--# -path=.:prelude:alltenses

concrete LexiconPes of Lexicon = CatPes ** 
--open ResPnb, Prelude in {
  open ParadigmsPes,MorphoPes, Prelude in {

  flags 
    optimize=values ;
    coding = utf8;

  lin

  airplane_N = mkN01 "hvApymA" inanimate ;
  answer_V2S = mkV2  (compoundV "jvAb" (mkV "dAdn" "dh")) "bh" False; 
  apartment_N = mkN01 "A:pArtmAn" inanimate;
  apple_N = mkN01 "syb" inanimate;
  art_N = mkN01 "hnr" inanimate;
  ask_V2Q = mkV2 (mkV_1 "prsydn") "Az" False;
  baby_N = mkN01 "bc^h" animate; -- has variant "kvdk"
  bad_A = mkA "bd" ;
  bank_N = mkN01 "bAnk" inanimate;
  beautiful_A = mkA "zybA" ;
  become_VA = mkV "Cdn" "Cv";
  beer_N = mkN01 "A:bjv" inanimate;
  beg_V2V =  mkV2V (compoundV "KvAhC" (mkV "krdn" "kn")) "Az" "" False;
  big_A = mkA "bzrg" ;
  bike_N = mkN01 "dvc^rKh" inanimate;
  bird_N = mkN02 "prndh" animate;
  black_A =  mkA "syAh" ;
  blue_A = mkA "A:by" ;
  boat_N = mkN01 "qAyq" inanimate;
  book_N = mkN01 "ktAb" inanimate;
  boot_N = mkN01 "c^kmh" inanimate; -- has variant "pvtyn"
  boss_N = mkN02 "kArfrmA" animate;
  boy_N = mkN02 "psr" animate;
  bread_N = mkN01 "nAn" inanimate;
  break_V2 = mkV2 (mkV "Ckstn" "Ckn") "rA";
  broad_A = mkA "vsyc" ;
  brother_N2 = (mkN01 "brAdr" animate) ** {c=""}; 
  brown_A = mkA ["qhvh Ay"] ; 
  butter_N = mkN01 "krh" inanimate;
  buy_V2 = mkV2 (mkV_1 "Krydn") "rA";
  camera_N = mkN01 "dvrbyn" inanimate;
  cap_N = mkCmpdNoun1 "klAh" (mkN01 "kp" animate); 
  car_N = mkN01 "mACyn" inanimate; -- has variant "Atvmbyl"
  carpet_N = mkN01 "frC" inanimate;
  cat_N = mkN01 "grbh" animate;
  ceiling_N = mkN01 "sqf" inanimate;
  chair_N = mkN01 "Sndly" inanimate;
  cheese_N = mkN01 "pnyr" inanimate;
  child_N = mkN02 "frznd"  animate; -- has variant "bc^h"
  church_N = mkN01 "klysA"  inanimate;
  city_N = mkN01 "Chr" inanimate;
  clean_A = mkA "tmyz" ;
  clever_A = mkA "bAhvC" ["bA hvCmndy"];  
  close_V2 =  mkV2 (mkV "bstn" "bnd") "rA"; 
  coat_N = mkN01 "kt" inanimate;
  cold_A = mkA "srd" ;
  come_V = mkV "A:mdn" "A:y" ;
  computer_N = mkN01 "kAmpyvtr" inanimate; -- also vaiant "rAyAnh"
  country_N = mkN01 "kCvr" inanimate;
  
-- Note: cousin inflects for gender and for being a mother's or a father's relatives in persian
-- The following is an example which is the daughter of your mom's brother
  cousin_N = mkCmpdNoun1 "dKtr" (mkN01 "dAyy" animate);  
  cow_N = mkN01 "gAv" animate;
  die_V = mkV "mrdn" "myr" ;
  dirty_A = mkA "kt-yf" ;
  distance_N3 = (mkN "fASlh" "fvASl" inanimate ) ** {c2="Az" ; c3 = "tA"};
  doctor_N = mkN01 "dktr" animate; -- has variant "pzCk", but only a doctor in medicine 
  dog_N = mkN01 "sg" animate;
  door_N = mkN01 "dr" inanimate;
  drink_V2 = mkV2 (mkV_1 "nvCydn") "rA";
--  easy_A2V = mkA "A:sAn" "" ;
  eat_V2 = mkV2 (mkV_2 "Kvrdn") "rA" ;
  empty_A = mkA "KAly" ;
  enemy_N = mkN02 "dCmn" animate;
  factory_N = mkN01 "kArKAnh" inanimate;
  father_N2 = (mkN02 "pdr" animate) ** {c=""};
  fear_VS = mkV_1 "trsydn"; 
  find_V2 = mkV2 (compoundV "pydA" (mkV "krdn" "kn") ) "rA";  
  fish_N = mkN01 "mAhy" animate;
  floor_N = mkN01 "zmyn" inanimate; -- Note: floor in persian can have 3 different translations
  forget_V2 = mkV2 (compoundV "frAmvC" (mkV "krdn" "kn")) "rA" ; 
  fridge_N = mkN01 "yKc^Al" inanimate;
  friend_N = mkN02 "dvst" animate;
  fruit_N = mkN01 "myvh" inanimate;
--  fun_AV = mkAV  "jAlb" ;
  garden_N = mkN01 "bAG" inanimate;
  girl_N = mkN02 "dKtr" animate;
  glove_N = mkN01 "dstkC" inanimate;
  gold_N = mkN01 "TlA" inanimate;
  good_A = mkA "Kvb" ;
  go_V = mkV "rftn" "rv";
  green_A = mkA "sbz" ;
  harbour_N = mkN "bndr" "bnAdr" inanimate;
--  hate_V2 = mkV2 (compoundV "mtnfr" (mkToBe "bvdn" "bAC" "hst")) "Az" False; -- needs from/ verb to be
  hat_N = mkN01 "klAh" inanimate;
  have_V2 = mkV2 haveVerb "rA" ; 
  hear_V2 = mkV2 (mkV "Cnydn" "Cnv") "rA" ;
  hill_N = mkN01 "tph" inanimate;
--  hope_VS = compoundV "AmydvAr" (mkToBe "bvdn" "bAC" "hst");
  horse_N = mkN01 "Asb" animate;
  hot_A = mkA "dAG" ["dAG dAG"] ;
  house_N = mkN01 "KAnh" inanimate;
  important_A = mkA "mhm" ["bA Ahmyt"];
  industry_N = mkN "Snct" "SnAyc" inanimate;
  iron_N = mkN01 "A:hn" inanimate;
  king_N = mkN "pAdCAh" "pAdCAhAn" animate;
  know_V2 = mkV2 (mkV "CnAKtn" "CnAs") "rA";
  know_VS = (mkV_1 "dAnstn");
  know_VQ = (mkV_1 "dAnstn") ;
  lake_N = mkN01 "dryAc^h" inanimate;
  lamp_N = mkN01 "c^rAG" inanimate; -- also "lAmp", but they have different usage
  learn_V2 = mkV2 (compoundV "yAd"(mkV "grftn" "gyr")) "rA";
  leather_N = mkN01 "c^rm" inanimate; -- is uncountable 
  leave_V2 = mkV2 (compoundV "trk"(mkV "krdn" "kn")) "rA";
  like_V2 = mkV2 (compoundV "dvst" haveVerb) "rA"; 
  listen_V2 = mkV2 (compoundV "gvC" (mkV "dAdn" "dh")) "bh" False; -- has a diferent preposition :"bh"
  live_V = compoundV "zndgy" (mkV "krdn" "kn");
  long_A = mkA "blnd" ;
  lose_V2 = mkV2 (compoundV "gm" (mkV "krdn" "kn")) "rA" ; 
  love_N = mkN01 "cCq" inanimate; 
  love_V2 = mkV2 (compoundV "dvst" haveVerb) "rA"; -- also possible: love_V2 = mkV2 (compoundV "cACq" (mkToBe "bvdn" "bAC" "hst"));
  man_N = mkN02 "mrd" animate; 
  married_A2 = mkA "mtA?hl" "";
  meat_N = mkN01 "gvCt" inanimate;
  milk_N = mkN01 "Cyr" inanimate;
  moon_N = mkN01 "mAh" inanimate; -- is this not a proper noun?
  mother_N2 = (mkN02 "mAdr" animate) ** {c=""};   
  mountain_N = mkN01 "kvh" inanimate;
  music_N = mkN "mvsyqy" "mvsyqy" animate; 
  narrow_A = mkA "bAryk" ;
  new_A = mkA "nv" "tAzh";
  newspaper_N = mkN01 "rvznAmh" inanimate;
  oil_N = mkN "nft" "nft" inanimate; -- also "rvGn"
  old_A = mkA "pyr" "pyrAnh";
  open_V2 = mkV2 (compoundV "bAz" (mkV "krdn" "kn")) "rA";
  paint_V2A = mkV2 (compoundV "rng" (mkV "krdn" "kn")) "rA" ;
  paper_N = mkN01 "kAGW" inanimate;
  paris_PN = mkPN "pArys" inanimate;  
  peace_N = mkN01 "SlH" inanimate; -- also "A:rAmC"  
  pen_N = mkN01 "qlm" inanimate; -- has  variant "KvdkAr"
  planet_N = mkN01 "syv2Arh" inanimate;
  plastic_N = mkN01 "plAstyk" inanimate; -- is uncountable 
  play_V2 = mkV2 (mkV "nvAKtn" "nvAz") "rA" ; 
  policeman_N = mkCmpdNoun2 (mkN02 "mA?mvr" animate) "plys"; 
  priest_N = mkN01 "kCyC" animate;
--  probable_AS = mkAS (regA "mHtml") ;
  queen_N = mkN01 "mlkh" animate;
  radio_N = mkN01 "rAdyv" inanimate;
  rain_V0 = compoundV "bArAn" (mkV "A:mdn" "A:y" ) ;
  read_V2 = mkV2 (mkV_2 "KvAndn") "rA";
  red_A = mkA "qrmz" ;
  religion_N = mkN "mWhb" "mWAhb" inanimate;
  restaurant_N = mkN01 "rstvrAn" inanimate;
  river_N = mkN01 "rvdKAnh" inanimate;
  rock_N = mkN01 "SKrh" inanimate;
  roof_N = mkN01 "bAm" inanimate; -- has  variant "sqf"
  rubber_N = mkN01 "pAkkn" inanimate; -- also "lAstyk" 
  run_V = mkV_1 "dvydn" ;
  say_VS = mkV "gftn" "gvy" ;
  school_N = mkN "mdrsh" "mdArs" inanimate;
  science_N = mkN "clm" "clvm" inanimate; -- also "dAnC"
  sea_N = mkN01 "dryA" inanimate;
  seek_V2 = mkV2 (compoundV "jstjv" (mkV "krdn" "kn")) "rA";
  see_V2 = mkV2 (mkV "dydn" "byn") "rA" ;
  sell_V3 = mkV3 (mkV "frvKtn" "frvC") "rA" "bh"; 
  send_V3 = mkV3 (mkV_1 "frstAdn") "rA" "brAy"; 
  sheep_N = mkN01 "gvsfnd" animate;
  ship_N = mkN01 "kCty" inanimate;
  shirt_N = mkN01 "pyrAhn" inanimate;
  shoe_N = mkN01 "kfC" inanimate;
  shop_N = mkN01 "frvCgAh" inanimate; -- has variant "mGAzh"
  short_A = mkA "kvtAh" ;
  silver_N = mkN "nqrh" ["nqrh jAt"] inanimate; -- add new function which applies + "jAt"
  sister_N = mkN02 "KvAhr" animate;
  sleep_V = mkV_1 "KvAbydn" ;
  small_A = mkA "kvc^k" ;
  snake_N = mkN01 "mAr" animate;
  sock_N = mkN01 "jvrAb" inanimate;
  speak_V2 = mkV2 (compoundV "SHbt" (mkV "krdn" "kn")) "" False; 
  star_N = mkN01 "stArh" animate;
  steel_N = mkN01 "fvlAd" inanimate; -- also "Astyl"
  stone_N = mkN01 "sng" inanimate;
  stove_N = mkN01 "AjAq" inanimate;
  student_N = mkCmpdNoun1 "dAnC" (mkN02 "A:mvz" animate); -- also "dAnCjv"
  stupid_A = mkA "Ablh" "AblhAnh" ;
  sun_N = mkN01 "KvrCyd" inanimate; -- is this not a proper noun?!!!
  switch8off_V2 = mkV2 (compoundV "KAmvC" (mkV "krdn" "kn")) "rA";
  switch8on_V2 = mkV2 (compoundV "rvCn" (mkV "krdn" "kn")) "rA";
  table_N = mkN01 "myz" inanimate;
  talk_V3 = mkV3 (compoundV "Hrf" (mkV "zdn" "zn")) "bA" [" drbArh y"];
  teacher_N = mkN02 "mclm" animate;
  teach_V2 = mkV2 (compoundV "A:mvzC" (mkV "dAdn" "dh")) "rA";
  television_N = mkN01 "tlvzyvn" inanimate;
  thick_A = mkA "klft" ;
  thin_A = mkA "nAzk" ;
  train_N = mkN01 "qTAr" inanimate;
  travel_V = compoundV "sfr" (mkV "krdn" "kn");
  tree_N = mkN02 "drKt" animate;
  trousers_N = mkN01 "ClvAr" inanimate;
  ugly_A = mkA "zCt" ;
  understand_V2 = mkV2 (mkV_1 "fhmydn") "rA";
  university_N = mkN01 "dAnCgAh" inanimate;
  village_N = mkN01 "rvstA" inanimate;
--  wait_V2 = mkV2 (compoundV "mntZr" (mkVToBe "bvdn" "bAC")); 
  walk_V = compoundV  "rAh"  (mkV "rftn" "rv");
  warm_A = mkA "grm" ;
  war_N = mkN01 "jng" inanimate;
--  watch_V2 = mkV2 (compoundV "mrAqb" (mkVToBe "bvdn" "bAC")); -- check harfe rabt!!!
  water_N = mkN01 "A:b" inanimate;
  white_A = mkA "sfyd" ;
  window_N = mkN01 "pnjrh" inanimate;
  wine_N = mkN01 "CrAb" inanimate;
  win_V2 = mkV2 (compoundV "brndh" (mkV "Cdn" "Cv")) "rA"; -- also possible with simple verb: mkV_2 "brdn"  
  woman_N = mkN02 "zn" animate;
--  wonder_VQ = compoundV "mtcjb" (mkVToBe "bvdn" "bAC") ;  
  wood_N = mkN01 "c^vb" inanimate;
  write_V2 = mkV2 (mkV "nvCtn" "nvys") "rA" ;
  yellow_A = mkA "zrd" ;
  young_A = mkA "jvAn""jvAnAnh" ;
  do_V2 = mkV2 (compoundV "AnjAm" (mkV "dAdn" "dh")) "rA";
  now_Adv = ss "HAlA" ;
  already_Adv = ss "qblAa." ;
  song_N = mkN01 "A:vAz" inanimate;
  add_V3 = mkV3 (compoundV "ADAfh" (mkV "krdn" "kn")) "rA" "bh" ;
  number_N = mkN01 "cdd" inanimate; -- also "tcdAd"
  put_V2 = mkV2 (mkV "gWACtn" "gWAr") "rA";
  stop_V = compoundV "tvqf" (mkV "krdn" "kn");
  jump_V = mkV_1 "prydn";
{-
  left_Ord = {s = "c^p" ; n = singular};
  right_Ord = {s= "rAst" ; n = singular};
-}  
  far_Adv = ss "dvr" ;
  correct_A = mkA "drst" ;
  dry_A = mkA "KCk" ["bh KCky"] ;
  dull_A = mkA ["mlAl A:vr"] ["bh Trzy mlAl A:vr"] ; 
  full_A = mkA "pr" ;
  heavy_A = mkA "sngyn" ;
  near_A = mkA "nzdyk" ;
  rotten_A = mkA "KrAb" ;
  round_A = mkA "grd" ;
  sharp_A = mkA "tyz" ;
  smooth_A = mkA "nrm" ;
  straight_A = mkA "mstqym" "mstqymAa.";
  wet_A = mkA "Kys" ; 
  wide_A = mkA "phn" ;
  animal_N = mkN "HyvAn" "HyvAnAt" animate;
  ashes_N = mkN01 "KAkstr" inanimate; 
  back_N = mkN01 "kmr" inanimate; 
  bark_N = mkN01 "cvcv" inanimate;
  belly_N = mkN01 "Ckm" inanimate;
  blood_N = mkN01 "Kvn" inanimate;
  bone_N = mkN01 "AstKvAn" inanimate;
  breast_N = mkN01 "synh" inanimate;
  cloud_N = mkN01 "Abr" inanimate;
  day_N = mkN01 "rvz" inanimate;
  dust_N = mkN01 "GbAr" inanimate;
  ear_N = mkN01 "gvC" inanimate;
  earth_N = mkN01 "zmyn" inanimate; -- also "KAk" 
  egg_N = mkCmpdNoun1 "tKm" (mkN01 "mrG" inanimate);  
  eye_N = mkN01 "c^Cm" inanimate ;
  fat_N = mkN01 "c^rby" inanimate;
  feather_N = mkN01 "pr" inanimate;
  fingernail_N = mkN01 "nAKn" inanimate;
  fire_N = mkN01 "A:tC" inanimate;
  flower_N = mkN01 "gl" inanimate;
  fog_N = mkN01 "mh" inanimate;
  foot_N = mkN01 "pA" inanimate;
  forest_N = mkN01 "jngl" inanimate;
  grass_N = mkN01 "c^mn" inanimate;
  guts_N = mkN01 "ChAmt" inanimate;
  hair_N = mkN01 "mv" inanimate;
  hand_N = mkN01 "dst" inanimate;
  head_N = mkN01 "sr" inanimate;
  heart_N = mkN01 "qlb" inanimate;
  horn_N = mkN01 "bvq" inanimate; -- also "CAK"
  husband_N = mkN02 "Cvhr" animate;
  ice_N = mkN01 "yK" inanimate;
  knee_N = mkN01 "zAnv" inanimate;
  leaf_N = mkN01 "brg" inanimate;
  leg_N = mkN01 "pA" inanimate;
  liver_N = mkN01 "rvdKAnh" inanimate;
  louse_N = mkN01 "CpC" inanimate;
  mouth_N = mkN01 "dhAn" inanimate;
  name_N = mkN01 "nAm" inanimate; -- has variant "Asm"
  neck_N = mkN01 "grdn" inanimate;
  night_N = mkN01 "Cb" inanimate;
  nose_N = mkN01 "byny" inanimate;
  person_N = mkN "CKS" "ACKAS" animate;
  rain_N = mkN01 "bArAn" inanimate; 
  road_N = mkN01 "jAdh" inanimate;
  root_N = mkN01 "ryCh" inanimate;
  rope_N = mkN01 "TnAb" inanimate;
  salt_N = mkN01 "nmk" inanimate;
  sand_N = mkN01 "mAsh" inanimate;
  seed_N = mkN01 "dAnh"  inanimate;
  skin_N = mkN01 "pvst" inanimate;
  sky_N = mkN01 "A:smAn" inanimate;
  smoke_N = mkN01 "dvd" inanimate;
  snow_N = mkN01 "brf" inanimate;
  stick_N = mkN01 "trkh" inanimate;
  tail_N = mkN01 "dm" inanimate;
  tongue_N = mkN01 "zbAn" inanimate;
  tooth_N = mkN01 "dndAn" inanimate;
  wife_N = mkN02 "hmsr" animate;
  wind_N = mkN01 "bAd" inanimate;
  wing_N = mkN01 "bAl" inanimate;
  worm_N = mkN01 "krm" inanimate;
  year_N = mkN01 "sAl" inanimate;
  blow_V = mkV_1 "dmydn" ;
  breathe_V = compoundV "nfs" (mkV_1 "kCydn");
  burn_V = mkV "svKtn" "svz" ;
  dig_V = mkV_2 "kndn" ;
  fall_V = mkV_1 "AftAdn" ;
--  float_V = compoundV "CnAvr" (mkToBe "bvdn" "bAC" "hst") ;
  flow_V = compoundV "jAry" (mkV "Cdn" "Cv") ;
  fly_V = compoundV "prvAz" (mkV "krdn" "kn") ;
  freeze_V = compoundV "yK" (mkV "zdn" "zn") ;
  give_V3 = mkV3 (mkV "dAdn" "dh") "rA" "bh";
  laugh_V = mkV_1 "Kndydn"  ;
  lie_N = mkN01 "drvG" inanimate;
  lie_V = compoundV "drvG" (mkV "gftn" "gv" );
  play_V = compoundV "bAzy" (mkV "krdn" "kn");
  sew_V = mkV "dvKtn" "dvz" ;
  sing_V = compoundV "A:vAz" (mkV_2 "KvAndn");
  sit_V = mkV "nCstn" "nCyn" ;
  smell_V = compoundV "bv" (mkV "dAdn" "dh");
  spit_V = compoundV "tf" (mkV "krdn" "kn");
  stand_V = mkV_1 "AystAdn";
  swell_V = compoundV "vrm" (mkV "krdn" "kn");
  swim_V = compoundV "CnA" (mkV "krdn" "kn");
  think_V = compoundV "fkr" (mkV "krdn" "kn");
  turn_V = mkV_1 "c^rKydn" ;
  vomit_V = compoundV "AstfrAG" (mkV "krdn" "kn");
  bite_V2 = mkV2 (compoundV "gAz" (mkV "grftn" "gyr")) "rA";
  count_V2 = mkV2 (mkV_2 "CmArdn") "rA";
  cut_V2 = mkV2 (mkV_1 "brydn") ;
  fear_V2 = mkV2 (mkV_1 "trsydn") "Az";
  fight_V2 = mkV2 (mkV_1 "jngydn") "bA" False;
  hit_V2 = mkV2 (compoundV "Drbh" (mkV "zdn" "zn")) "bh" False;
  hold_V2 = mkV2 (compoundV "ngh" haveVerb) "rA";
  hunt_V2 = mkV2 (compoundV "CkAr" (mkV "krdn" "kn")) "rA";
  kill_V2 = mkV2 ( mkV_2 "kCtn") "rA";
  pull_V2 = mkV2 (mkV_1 "kCydn") "rA";
  push_V2 = mkV2 (compoundV "hl" (mkV "dAdn" "dh")) "rA" ;
  rub_V2 = mkV2 (mkV_1 "mAlydn") "rA";
  scratch_V2 = mkV2 (mkV_1 "KrACydn") "rA" ;
  split_V2 = mkV2 (compoundV "tqsym" (mkV "krdn" "kn")) "rA";
  squeeze_V2 = mkV2 (compoundV "lh" (mkV "krdn" "kn")) "rA";
  stab_V2 = mkV2 (compoundV "c^Aqv" (mkV "zdn" "zn")) "bh" False; 
  suck_V2 = mkV2 (mkV_1 "mkydn") "rA" ;
  throw_V2 = mkV2 (compoundV "prtAb" (mkV "krdn" "kn")) "rA";
  tie_V2 = mkV2 (compoundV "grh" (mkV "zdn" "zn")) "rA";
  wash_V2 = mkV2 (mkV "Cstn" "Cvr") "rA" ; -- also "Cvy" which is the very formal form of the present root
  wipe_V2 = mkV2 (compoundV "pAk" (mkV "krdn" "kn")) "rA";

----  other_A = regA "dygr" ;

  grammar_N = mkCmpdNoun1 "dstvr" (mkN01 "zbAn" inanimate);  
  language_N = mkN01 "zbAn" inanimate;
  rule_N = mkN "qAnvn" "qvAnyn" inanimate;

---- added 4/6/2007
    john_PN = mkPN "jAn" inanimate; 
    question_N = mkN01 "sw?Al" inanimate; -- has variant "prsC"
    ready_A = mkA "A:mAdh" ["bA A:mAdgy"] ;
    reason_N = mkN "dlyl" "dlAyl" inanimate;
    today_Adv = ss "Amrvz" ;
    uncertain_A = mkA "nAmclvm" ["bA trdyd"];
     
}
