--# -path=.:../scandinavian:../common:../abstract:../../prelude

concrete LexiconSwe of Lexicon = CatSwe ** 
  open Prelude, ParadigmsSwe, IrregSwe in {

flags 
    coding=utf8 ;
  optimize=values ;

lin
  airplane_N = regGenN "flygplan" neutrum ;
  answer_V2S = mkV2S (regV "svarar") (mkPrep "till") ;
  apartment_N = mk2N "lägenhet" "lägenheter" ;
  apple_N = changeCompoundN ("äpple" | "äppel") (regGenN "äpple" neutrum) ;
  art_N = mk2N "konst" "konster" ;
  ask_V2Q = mkV2Q (regV "frågar") noPrep ;
  baby_N = regGenN "bebis" utrum ;
  bad_A = irregA "dålig" "sämre" "sämst";
  bank_N = mk2N "bank" "banker" ;
  beautiful_A = mk3A "vacker" "vackert" "vackra" ;
  become_VA = mkVA (mkV "bli" "blir" "bli" "blev" "blivit" "bliven" "blivande") ;
  beer_N = regGenN "öl" neutrum ;
  beg_V2V = mkV2V (mkV "be" "ber""be" "bad" "bett" "bedd") ;
  big_A = irregA "stor" "större" "störst";
  bike_N = mk2N "cykel" "cyklar" ;
  bird_N = mk2N "fågel" "fåglar" ;
  black_A = mk2A "svart" "svart" ;
  blue_A = mk2A "blå" "blått";
  boat_N = regGenN "båt" utrum ;
  book_N = mkN "bok" "boken" "böcker" "böckerna" ;
  boot_N = mk2N "stövel" "stövlar" ;
  boss_N = mk2N "chef" "chefer" ;
  boy_N = regGenN "pojke" utrum ;
  bread_N = regGenN "bröd" neutrum ;
  break_V2 = dirV2 (partV (mkV "slå" "slår" "slå" "slog" "slagit" "slagen") "sönder") ;
  broad_A = mk2A "bred" "brett" ;
  brother_N2 = mkN2 (mkN "bror" "brodern" "bröder" "bröderna") (mkPrep "till") ;
  brown_A = regA "brun" ;
  butter_N = regGenN "smör" neutrum ;
  buy_V2 = dirV2 (mk2V "köpa" "köpte") ;
  camera_N = regGenN "kamera" utrum ;
  cap_N = regGenN "mössa" utrum ;
  car_N = regGenN "bil" utrum ;
  carpet_N = regGenN "matta" utrum ;
  cat_N = mk2N "katt" "katter" ;
  ceiling_N = regGenN "tak" neutrum ;
  chair_N = regGenN "stol" utrum ;
  cheese_N = regGenN "ost" utrum ;
  child_N = regGenN "barn" neutrum ;
  church_N = regGenN "kyrka" utrum ;
  city_N = mkN "stad" "staden" "städer" "städerna" ;
  clean_A = regA "ren" ;
  clever_A = regA "klok" ;
  close_V2 = dirV2 (mk2V "stänga" "stängde") ;
  coat_N = regGenN "rock" utrum ;
  cold_A = regA "kall" ;
  come_V = komma_V ;
  computer_N = mk2N "dator" "datorer" ;
  country_N = mkN "land" "landet" "länder" "länderna" ;
  cousin_N = mk2N "kusin" "kusiner" ;
  cow_N = mk2N "ko" "kor" ;
  die_V = (mkV "dö" "dör" "dö" "dog" "dött" "dödd") ; ----
  distance_N3 = mkN3 (mk2N "avstånd" "avstånd") (mkPrep "från") (mkPrep "till") ;
  dirty_A = regA "smutsig" ;
  doctor_N = mk2N "läkare" "läkare" ;
  dog_N = regGenN "hund" utrum ;
  door_N = regGenN "dörr" utrum ;
  drink_V2 = dirV2 (irregV "dricka" "drack" "druckit") ;
  easy_A2V = mkA2V (mk2A "lätt" "lätt") (mkPrep "för") ;
  eat_V2 = dirV2 (irregV "äta" "åt" "ätit") ;
  empty_A = mkA "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ;
  enemy_N = regGenN "fiende" neutrum ;
  factory_N = mk2N "fabrik" "fabriker" ;
  father_N2 = mkN2 ((mkN "far" "fadern" "fäder" "fäderna")) (mkPrep "till") ;
  fear_VS = mkVS (regV "fruktar") ;
  find_V2 = dirV2 (irregV "finna" "fann" "funnit") ;
  fish_N = mk2N "fisk" "fiskar" ;
  floor_N = regGenN "golv" neutrum ;
  forget_V2 = dirV2 (mkV "glömma" "glömmer" "glöm" "glömde" "glömt" "glömd") ;
  fridge_N = regGenN "kylskåp" neutrum ;
  friend_N = mkN "vän" "vännen" "vänner" "vännerna" ;
  fruit_N = mk2N "frukt" "frukter" ;
  fun_AV = mkAV (regA "rolig") ;
  garden_N = regGenN "trädgård" utrum ;
  girl_N = regGenN "flicka" utrum ;
  glove_N = regGenN "handske" utrum ;
  gold_N = regGenN "guld" neutrum ;
  good_A = mkA "god" "gott" "goda" "goda" "bättre" "bäst" "bästa" ;
  go_V = (mkV "gå" "går" "gå" "gick" "gått" "gången") ;
  green_A = regA "grön" ;
  harbour_N = regGenN "hamn" utrum;
  hate_V2 = dirV2 (regV "hatar") ;
  hat_N = regGenN "hatt" utrum ;
  hear_V2 = dirV2 (mkV "höra" "hör" "hör" "hörde" "hört" "hörd") ;
  hill_N = regGenN "kulle" utrum ;
--  hope_VS = mkVS ((regV "önskar")) ;
  hope_VS = mkVS (depV (regV "hoppar")) ;
  horse_N = regGenN "häst" utrum ;
  hot_A = regA "het" ;
  house_N = regGenN "hus" neutrum ;
  important_A = regA "viktig" ;
  industry_N = mk2N "industri" "industrier" ; ---- "ien" ??
  iron_N = regGenN "järn" neutrum ;
  king_N = (regGenN "kung" utrum) ;
  know_V2 = mkV2 (mkV "känna" "kände" "känt") ;
  know_VQ = mkVQ (mkV "veta" "vet" "vet" "visste" "vetat" "visst") ;
  know_VS = mkVS (mkV "veta" "vet" "vet" "visste" "vetat" "visst") ;
  lake_N = mkN "sjö" "sjön" "sjöar" "sjöarna" ;
  lamp_N = regGenN "lampa" utrum;
  learn_V2 = dirV2 (reflV (mkV "lära" "lär" "lär" "lärde" "lärt" "lärd")) ;
  leather_N = mkN "läder" "lädret" "läder" "lädren" ;
  leave_V2 = dirV2 (regV "lämnar") ;
  like_V2 = mkV2 (mk2V "tycka" "tyckte") (mkPrep "om") ;
  listen_V2 = mkV2 (regV "lyssnar") (mkPrep "på") ;
  live_V = (irregV "leva" "levde" "levt") ; ---- ?
  long_A = irregA "lång" "längre" "längst" ;
  lose_V2 = dirV2 (regV "förlora") ;
  love_N = regGenN "kärlek" utrum ;
  love_V2 = dirV2 (regV "älska") ;
  man_N = (mkN "man" "mannen" "män" "männen") ;
  married_A2 = mkA2 (mk2A "gift" "gift") (mkPrep "med") ;
  meat_N = regGenN "kött" neutrum ;
  milk_N = regGenN "mjölk" utrum ; ---- -ar?
  moon_N = regGenN "måne" utrum ;
  mother_N2 = mkN2 (mkN "mor" "modern" "mödrar" "mödrarna") (mkPrep "till") ;
  mountain_N = regGenN "berg" neutrum ;
  music_N = mk2N "musik" "musiker" ; ---- er ?
  narrow_A = regA "smal" ;
  new_A = mkA "ny" "nytt" "nya" "nya" "nyare" "nyast" "nyaste" ;
  newspaper_N = regGenN "tidning" utrum ;
  oil_N = regGenN "olja" utrum ;
  old_A = mkA "gammal" "gammalt" "gamla" "gamla" "äldre" "äldst" "äldsta" ;
  open_V2 = dirV2 (regV "öppna") ;
  paint_V2A = mkV2A (regV "måla") noPrep ;
  paper_N = mkN "papper" "pappret" "papper" "pappren" ;
  paris_PN = regGenPN "Paris" neutrum ;
  peace_N = regGenN "fred" utrum ; ---- ar?
  pen_N = regGenN "penna" utrum ;
  planet_N = mk2N "planet" "planeter" ;
  plastic_N = mk2N "plast" "plaster" ;
  play_V2 = dirV2 (regV "spela") ;
  policeman_N = mk2N "polis" "poliser" ;
  priest_N = mk2N "präst" "präster" ;
  probable_AS = mkAS (regA "sannolik") ;
  queen_N = regGenN "drottning" utrum ;
  radio_N = mkN "radio" "radion" "radioapparater" "radioapparaterna" ; -- SAOL
  rain_V0 = mkV0 (regV "regna") ;
  read_V2 = dirV2 (mk2V "läsa" "läste") ;
  red_A = mk2A "röd" "rött" ;
  religion_N = mk2N "religion" "religioner" ;
  restaurant_N = mk2N "restaurang" "restauranger" ;
  river_N = mkN "å" "ån" "åar" "åarna" ;
  rock_N = mkN "sten" "stenen" "stenar" "stenarna" ;
  roof_N = regGenN "tak" neutrum ;
  rubber_N = mkN "gummi" "gummit" "gummin" "gummina" ;
  run_V = (irregV "springa" "sprang" "sprungit") ;
  say_VS = mkVS (mkV "säga" "säger" "säg" "sade" "sagt" "sagd") ;
  school_N = regGenN "skola" utrum;
  science_N = mk2N "vetenskap" "vetenskaper" ;
  sea_N = mkN "hav" "hav" ;
  seek_V2 = dirV2 (mk2V "söka" "sökte") ;
  see_V2 = dirV2 (mkV "se" "ser" "se" "såg" "sett" "sedd") ;
  sell_V3 = dirV3 (irregV "sälja" "sålde" "sålt") (mkPrep "till") ;
  send_V3 = dirV3 (regV "skicka") (mkPrep "till") ;
  sheep_N = mk2N "får" "får" ;
  ship_N = regGenN "skepp" neutrum ;
  shirt_N = regGenN "skjorta" utrum ;
  shoe_N = mk2N "sko" "skor" ;
  shop_N = mk2N "affär" "affärer" ;
  short_A = mkA "kort" "kort" ;
  silver_N = mkN "silver" "silvret" "silver" "silvren" ;
  sister_N = mk2N "syster" "systrar" ;
  sleep_V = (irregV "sova" "sov" "sovit") ;
  small_A = mkA "liten" "litet" "lilla" "små" "mindre" "minst" "minsta" ;
  snake_N = regGenN "orm" utrum ;
  sock_N = regGenN "strumpa" utrum ;
  speak_V2 = dirV2 (regV "tala") ;
  star_N = regGenN "stjärna" utrum ;
  steel_N = regGenN "stål" utrum ;
  stone_N = mkN "sten" "stenen" "stenar" "stenarna" ;
  stove_N = regGenN "spis" utrum ;
  student_N = mk2N "student" "studenter" ;
  stupid_A = mk3A "dum" "dumt" "dumma" ;
  sun_N = regGenN "sol" utrum ;
  switch8off_V2 = dirV2 (partV (irregV "stänga" "stängde" "stängt") "av") ;
  switch8on_V2 = dirV2 (partV (irregV "slå" "slog" "slagit") "på") ;
  table_N = regGenN "bord" neutrum ;
  talk_V3 = mkV3 (regV "prata") (mkPrep "till") (mkPrep "om") ;
  teacher_N = mk2N "lärare" "lärare" ;
  teach_V2 = dirV2 (regV "undervisa") ;
  television_N = mk2N "television" "televisioner" ;
  thick_A = regA "tjock" ;
  thin_A = mk2A "tunn" "tunt" ;
  train_N = regGenN "tåg" neutrum ;
  travel_V = mk2V "resa" "reste" ;
  tree_N = regGenN "träd" neutrum ;
  ----  trousers_N = regGenN "trousers" ; ---- pl t !
  ugly_A = regA "ful" ;
  understand_V2 = dirV2 (mkV "förstå" "förstår" "förstå" "förstod" "förstått" "förstådd") ;
  university_N = regGenN "universitet" neutrum ;
  village_N = mkN "by" "byn" "byar" "byarna" ;
  wait_V2 = mkV2 (regV "vänta") (mkPrep "på") ;
  walk_V = (mkV "gå" "går" "gå" "gick" "gått" "gången") ;
  warm_A = regA "varm" ;
  war_N = regGenN "krig" neutrum ;
  watch_V2 = mkV2 (regV "titta") (mkPrep "på") ;
  water_N = mkN "vatten" "vattnet" "vatten" "vattnen" ;
  white_A = regA "vit" ;
  window_N = mkN "fönster" "fönstret" "fönster" "fönstren" ;
  wine_N = mkN "vin" "vinet" "viner" "vinerna" ; ----
  win_V2 = dirV2 (irregV "vinna" "vann" "vunnit") ;
  woman_N = regGenN "kvinna" utrum ;
  wonder_VQ = mkVQ (regV "undra") ;
  wood_N = mkN "trä" "träet" "träen" "träena" ; ---- ?
  write_V2 = dirV2 (irregV "skriva" "skrev" "skrivit") ;
  yellow_A = regA "gul" ;
  young_A = irregA "ung" "yngre" "yngst" ;

  do_V2 = dirV2 göra_V ;
  now_Adv = mkAdv "nu" ;
  already_Adv = mkAdv "redan" ;
  song_N = mk2N "sång" "sånger" ;
  add_V3 = mkV3 (partV (irregV "lägga" "lade" "lagt") "till") noPrep (mkPrep "till") ;
  number_N = mkN "nummer" "numret" "numren" "numren" ;
  put_V2 = mkV2 (mkV "sätta" "sätter" "sätt" "satte" "satt" "satt") noPrep ;
  stop_V = regV "stanna" ;
  jump_V = regV "hoppa" ;

  left_Ord = {s = "vänstra" ; isDet = True} ;
  right_Ord = {s = "högra" ; isDet = True} ;
  far_Adv = mkAdv "långt" ;
  correct_A = regA "riktig" ;
  dry_A = regA "torr" ;
  dull_A = mk2A "slö" "slött";
  full_A = regA "full" ;
  heavy_A = irregA "tung" "tyngre" "tyngst" ;
  near_A = mkA "nära" "nära" "nära" "nära" "närmare" "närmast" "närmaste" ;
  rotten_A = mk3A "rutten" "ruttet" "ruttna" ;
  round_A = regA "rund" ;
  sharp_A = regA "vass" ;
  smooth_A = regA "slät" ;
  straight_A = regA "rak" ;
  wet_A = regA "våt" ;
  wide_A = mk2A "bred" "brett" ;
  animal_N = mk2N "djur" "djur" ;
  ashes_N = mk2N "aska" "askor" ;
  back_N = mk2N "rygg" "ryggar" ;
  bark_N = mk2N "bark" "barkar" ;
  belly_N = mk2N "mage" "magar" ;
  blood_N = mk2N "blod" "blod" ;
  bone_N = mk2N "ben" "ben" ;
  breast_N = mk2N "bröst" "bröst" ;
  cloud_N = mk2N "moln" "moln" ;
  day_N = mk2N "dag" "dagar" ;
  dust_N = mk2N "damm" "damm" ;
  ear_N = mkN "öra" "örat" "öron" "öronen" ;
  earth_N = mk2N "jord" "jordar" ;
  egg_N = mk2N "ägg" "ägg" ;
  eye_N = mkN "öga" "ögat" "ögon" "ögonen" ;
  fat_N = mk2N "fett" "fett" ;
  feather_N = mk2N "fjäder" "fjädrar" ;
  fingernail_N = mkN "nagel" "nageln" "naglar" "naglarna";
  fire_N = mk2N "eld" "eldar" ;
  flower_N = mk2N "blomma" "blommor" ;
  fog_N = mk2N "dimma" "dimmor" ;
  foot_N = mk2N "fot" "fötter" ;
  forest_N = mk2N "skog" "skogar" ;
  grass_N = mk2N "gräs" "gräs" ;
  guts_N = mk2N "inälva" "inälvor" ;
  hair_N = mk2N "hår" "hår" ;
  hand_N = mk2N "hand" "händer" ;
  head_N = mkN "huvud" "huvudet" "huvuden" "huvudena" ;
  heart_N = changeCompoundN "hjärt" (mkN "hjärta" "hjärtat" "hjärtan" "hjärtana") ;
  horn_N = mk2N "horn" "horn" ;
  husband_N = (mk2N "make" "makar") ;
  ice_N = mk2N "is" "isar" ;
  knee_N = mkN "knä" "knäet" "knän" "knäna" ;
  leaf_N = mk2N "löv" "löv" ;
  leg_N = mk2N "ben" "ben" ;
  liver_N = mkN "lever" "levern" "levrar" "levrarna";
  louse_N = mkN "lus" "lusen" "löss" "lössen" ;
  mouth_N = mkN "mun" "munnen" "munnar" "munnarna" ;
  name_N = mk2N "namn" "namn" ;
  neck_N = mk2N "nacke" "nackar" ;
  night_N = mk2N "natt" "nätter" ;
  nose_N = mk2N "näsa" "näsor" ;
  person_N = mk2N "person" "personer" ;
  rain_N = mk2N "regn" "regn" ;
  road_N = mk2N "väg" "vägar" ;
  root_N = mk2N "rot" "rötter" ;
  rope_N = mk2N "rep" "rep" ;
  salt_N = mkN "salt" "saltet" "salter" "salterna";
  sand_N = mk2N "sand" "sander" ;
  seed_N = mkN "frö" "fröet" "frön" "fröna" ;
  skin_N = mk2N "skinn" "skinn" ;
  sky_N = mk2N "himmel" "himlar" ;
  smoke_N = mk2N "rök" "rökar" ;
  snow_N = mkN "snö" "snön" "snöer" "snöerna" ;
  stick_N = mk2N "pinne" "pinnar" ;
  tail_N = mk2N "svans" "svansar" ;
  tongue_N = mk2N "tunga" "tungor" ;
  tooth_N = mk2N "tand" "tänder" ;
  wife_N = mk2N "fru" "fruar" ;
  wind_N = mk2N "vind" "vindar" ;
  wing_N = mk2N "vinge" "vingar" ;
  worm_N = mk2N "mask" "maskar" ;
  year_N = mk2N "år" "år" ;
  bite_V2 = dirV2 (bita_V) ;
  blow_V = mk2V "blåsa" "blåste" ;
  burn_V = brinna_V ; -- FIXME: bränna?
  count_V2 = dirV2 (regV "räkna") ;
  cut_V2 = dirV2 (skära_V) ;
  dig_V = mk2V "gräva" "grävde" ;
  fall_V = falla_V ;
  fear_V2 = dirV2 (regV "frukta") ;
  float_V = flyta_V ;
  flow_V = rinna_V ;
  fly_V = flyga_V ;
  freeze_V = frysa_V ;
  give_V3 = mkV3 (mkV "ge" "ger""ge" "gav" "givit" "given" "givande") (mkPrep []) (mkPrep []) ;
  hit_V2 = dirV2 (slå_V) ;
  hold_V2 = dirV2 (hålla_V) ;
  hunt_V2 = dirV2 (regV "jaga") ;
  kill_V2 = dirV2 (regV "döda") ;
  laugh_V = regV "skratta" ;
  lie_V = ligga_V ;
  play_V = mk2V "leka" "lekte" ;
  pull_V2 = dirV2 (draga_V) ;
  push_V2 = dirV2 (mk2V "trycka" "tryckte") ;
  rub_V2 = dirV2 (gnida_V) ;
  scratch_V2 = dirV2 (regV "klia") ;
  sew_V = sy_V ;
  sing_V = sjunga_V ;
  sit_V = sitta_V ;
  smell_V = regV "lukta" ;
  spit_V = regV "spotta" ;
  split_V2 = dirV2 (klyva_V) ;
  squeeze_V2 = dirV2 (klämma_V) ;
  stab_V2 = dirV2 (sticka_V) ;
  stand_V = stå_V ;
  suck_V2 = dirV2 (suga_V) ;
  swell_V = svälla_V ;
  swim_V = regV "simma" ;
  think_V = mk2V "tänka" "tänkte" ;
  throw_V2 = dirV2 (regV "kasta") ;
  tie_V2 = dirV2 (knyta_V) ;
  turn_V = vända_V ;
  vomit_V = mk2V "spy" "spydde" ;
  wash_V2 = dirV2 (regV "tvätta") ;
  wipe_V2 = dirV2 (regV "torka") ;

  breathe_V = depV (regV "anda") ;
  fight_V2 = 
    mkV2 (mkV "slåss" "slåss" "slåss" "slogs" "slagits" "slagen") (mkPrep "med") ;

  grammar_N = mk1N "grammatikerna" ;
  language_N = mk2N "språk" "språk" ;
  rule_N = mkN "regel" "regeln" "regler" "reglerna" ;

    john_PN = regPN "Johan" ;
    question_N = regN "fråga" ;
    ready_A = regA "färdig" ;
    reason_N = regN "anledning" ;
    today_Adv = mkAdv "idag" ;
    uncertain_A = mk3A "osäker" "osäkert" "osäkra" ;


} ;
