--# -path=.:../../translator

concrete LargeLibraryBrowserAPI of LargeLibraryBrowser = open Prelude in {

lincat 
  A, A2, AP, AdA, AdN, AdV, Adv, Ant, CAdv, CN, Card, Cl, ClSlash, Comp, Conj, Det, Dig, Digit, Digits, 
  IAdv, IComp, IDet, IP, IQuant, Imp, Interj, ListAP, ListAdv, 
  ListCN, ListIAdv, ListNP, ListRS, ListS, N, N2, N3, NP, Num, Numeral, 
  Ord, PConj, PN, Phr, Pol, Predet, Prep, Pron, QCl, QS, QVP, Quant, RCl, RP, RS, S, SC, SSlash, 
  Sub10, Sub100, Sub1000, Sub1000000, Subj, Temp, Tense, Text, Utt, V, V2, V2A, V2Q, V2S, V2V, V3, 
  VA, VP, VPSlash, VQ, VS, VV, Voc = Term ;

oper Term = {s : Str ; f,x,swap : Str ; par : Str * Str ; flat : Bool} ;

oper mkTerm = overload {
  mkTerm : Str -> Term = \f -> 
    {s = f ; f = f ; x,swap = [] ; par = noPar ; flat = False} ;
  mkTerm : Str -> Term -> Term = \f,x -> 
    appTerm f (fullTerm x) ;
  mkTerm : Str -> (_,_ : Term) -> Term = \f,x,y -> 
    appTerm f (concatTerm x y) ; 
  mkTerm : Str -> (_,_,_ : Term) -> Term = \f,x,y,z -> 
    appTerm f (fullTerm x ++ concatTerm y z) ; 
  mkTerm : Str -> (_,_,_,_ : Term) -> Term = \f,x,y,z,u -> 
    appTerm f (fullTerm x ++ fullTerm y ++ fullTerm z ++ fullTerm u) ;
  } ;

  noPar  = <[],[]> ;
  yesPar = <"(",")"> ;

  appTerm : Str -> Str -> Term = \f,x -> {s = f ++ x ; f = f ; x = x ; swap = [] ; par = yesPar ; flat = False} ;
  useTerm : Term -> Str = \t -> t.f ++ t.x ++ t.swap ;
  fullTerm : Term -> Str = \t -> t.par.p1 ++ t.f ++ t.x ++ t.swap ++ t.par.p2 ;
  flatTerm : Term -> Term = \t -> {s = t.x ; f = [] ; x = t.x ; swap = t.swap ; par = noPar ; flat = False} ;
  flatIfTerm : Term -> Term = \t -> case t.flat of {
    True  => flatTerm t ;
    False => t
    } ;
  mkFlat : Term -> Term = \t -> {s = t.s ; f = t.f ; x = t.x ; swap = t.swap ; par = t.par ; flat = True} ;
  mkSwap : Term -> Term = \t -> {s = t.s ; f = t.f ; x = [] ; swap = t.x ; par = t.par ; flat = False} ;
  mkSwapTerm : Str -> Term -> Term -> Term = \f,x,y -> 
    let xs = fullTerm x ; ys = fullTerm y in
    {s = f ++ xs ++ ys ; f = f ; x = xs ; swap = ys ; par = yesPar ; flat = False} ;
  concatTerm : Term -> Term -> Str = \t,u ->
    (t.par.p1 ++ t.f ++ t.x ++ t.par.p2 ++ fullTerm u ++ t.swap) ;

  hide : Str -> Str = \f -> [] ;
  hideOpt : Str -> Str = \f -> [] | f ;

lin AAnter = mkTerm "anteriorAnt" ;
lin ASimul = mkTerm (hideOpt "simultaneousAnt") ;
lin AdAP ada_1 ap_2 = mkTerm "mkAP" ada_1 (flatIfTerm ap_2) ;
lin AdAdv ada_1 adv_2 = mkTerm "mkAdv" ada_1 adv_2 ;
lin AdNum adn_1 card_2 = mkTerm "mkCard" adn_1 card_2 ;
lin AdVVP adv_1 vp_2 = mkTerm "mkVP" adv_1 vp_2 ;
lin AdVVPSlash adv_1 vpslash_2 = mkTerm "mkVPSlash" adv_1 vpslash_2 ;
--lin AddAdvQVP qvp_1 iadv_2 = mkTerm "mkQVP" qvp_1 iadv_2 ;
lin AdjCN ap_1 cn_2 = mkTerm "mkCN" ap_1 cn_2 ;
lin AdjOrd ord_1 = mkTerm "mkAP" ord_1 ;
lin AdnCAdv cadv_1 = mkTerm "mkAdN" cadv_1 ;
lin AdvAP ap_1 adv_2 = mkTerm "mkAP" ap_1 adv_2 ;
lin AdvCN cn_1 adv_2 = mkTerm "mkCN" cn_1 adv_2 ;
lin AdvIAdv iadv_1 adv_2 = mkTerm "mkIAdv" iadv_1 adv_2 ;
lin AdvIP ip_1 adv_2 = mkTerm "mkIP" ip_1 adv_2 ;
lin AdvNP np_1 adv_2 = mkTerm "mkNP" np_1 adv_2 ;
--lin AdvQVP vp_1 iadv_2 = mkTerm "mkQVP" vp_1 iadv_2 ;
lin AdvS adv_1 s_2 = mkTerm "mkS" adv_1 s_2 ;
lin AdvSlash clslash_1 adv_2 = mkTerm "mkClSlash" clslash_1 adv_2 ;
lin AdvVP vp_1 adv_2 = mkTerm "mkVP" vp_1 adv_2 ;
lin AdvVPSlash vpslash_1 adv_2 = mkTerm "mkVPSlash" vpslash_1 adv_2 ;
lin ApposCN cn_1 np_2 = mkTerm "mkCN" cn_1 np_2 ;
lin BaseAP ap_1 ap_2 = mkFlat (mkTerm "mkListAP" ap_1 ap_2) ;
lin BaseAdv adv_1 adv_2 = mkFlat (mkTerm "mkListAdv" adv_1 adv_2) ;
lin BaseCN cn_1 cn_2 = mkTerm "mkListCN" cn_1 cn_2 ;
--lin BaseIAdv iadv_1 iadv_2 = mkTerm "mkListIAdv" iadv_1 iadv_2 ;
lin BaseNP np_1 np_2 =mkFlat (mkTerm "mkListNP" np_1 np_2) ;
lin BaseRS rs_1 rs_2 = mkTerm "mkListRS" rs_1 rs_2 ;
lin BaseS s_1 s_2 = mkFlat (mkTerm "mkListS" s_1 s_2) ;
lin CAdvAP cadv_1 ap_2 np_3 = mkTerm "mkAP" cadv_1 ap_2 np_3 ;
lin CleftAdv adv_1 s_2 = mkTerm "mkCl" adv_1 s_2 ;
lin CleftNP np_1 rs_2 = mkTerm "mkCl" np_1 rs_2 ;
lin CompAP ap_1 = mkFlat (mkTerm "mkComp" (flatIfTerm ap_1)) ;
lin CompAdv adv_1 = mkFlat (mkTerm "mkComp" adv_1) ;
lin CompCN cn_1 = mkFlat (mkTerm "mkComp" (flatIfTerm cn_1)) ;
lin CompIAdv iadv_1 = mkTerm "mkIComp" iadv_1 ;
lin CompIP ip_1 = mkTerm "mkIComp" ip_1 ;
lin CompNP np_1 = mkFlat (mkTerm "mkComp" np_1) ;
lin ComparA a_1 np_2 = mkTerm "comparAP" a_1 np_2 ;
lin ComparAdvAdj cadv_1 a_2 np_3 = mkTerm "mkAdv" cadv_1 a_2 np_3 ;
lin ComparAdvAdjS cadv_1 a_2 s_3 = mkTerm "mkAdv" cadv_1 a_2 s_3 ;
lin ComplA2 a2_1 np_2 = mkTerm "mkAP" a2_1 np_2 ;
lin ComplN2 n2_1 np_2 = mkTerm "mkCN" (flatIfTerm n2_1) np_2 ;
lin ComplN3 n3_1 np_2 = mkFlat (mkTerm "mkN2" n3_1 np_2) ;
lin ComplSlash vpslash_1 np_2 = mkFlat (mkTerm "mkVP" (flatIfTerm vpslash_1) np_2) ;
--lin ComplSlashIP vpslash_1 ip_2 = mkTerm "mkQVP" vpslash_1 ip_2 ;
lin ComplVA va_1 ap_2 = mkFlat (mkTerm "mkVP" va_1 (flatIfTerm ap_2)) ;
lin ComplVQ vq_1 qs_2 = mkTerm "mkVP" vq_1 qs_2 ;
lin ComplVS vs_1 s_2 = mkTerm "mkVP" vs_1 s_2 ;
lin ComplVV vv_1 vp_2 = mkFlat (mkTerm "mkVP" vv_1 vp_2) ;
lin ConjAP conj_1 listap_2 = mkTerm "mkAP" conj_1 (flatIfTerm listap_2) ;
lin ConjAdv conj_1 listadv_2 = mkTerm "mkAdv" conj_1 (flatIfTerm listadv_2) ;
lin ConjCN conj_1 listcn_2 = mkTerm "mkCN" conj_1 listcn_2 ;
lin ConjIAdv conj_1 listiadv_2 = mkTerm "mkIAdv" conj_1 listiadv_2 ;
lin ConjNP conj_1 listnp_2 = mkTerm "mkNP" conj_1 (flatIfTerm listnp_2) ;
lin ConjRS conj_1 listrs_2 = mkTerm "mkRS" conj_1 listrs_2 ;
lin ConjS conj_1 lists_2 = mkTerm "mkS" conj_1 (flatIfTerm lists_2) ;
lin ConsAP ap_1 listap_2 = mkTerm "mkListAP" ap_1 listap_2 ;
lin ConsAdv adv_1 listadv_2 = mkTerm "mkListAdv" adv_1 listadv_2 ;
lin ConsCN cn_1 listcn_2 = mkTerm "mkListCN" cn_1 listcn_2 ;
--lin ConsIAdv iadv_1 listiadv_2 = mkTerm "mkListIAdv" iadv_1 listiadv_2 ;
lin ConsNP np_1 listnp_2 = mkTerm "mkListNP" np_1 listnp_2 ;
lin ConsRS rs_1 listrs_2 = mkTerm "mkListRS" rs_1 listrs_2 ;
lin ConsS s_1 lists_2 = mkTerm "mkListS" s_1 lists_2 ;
lin D_0 = mkTerm "n0_Dig" ;
lin D_1 = mkTerm "n1_Dig" ;
lin D_2 = mkTerm "n2_Dig" ;
lin D_3 = mkTerm "n3_Dig" ;
lin D_4 = mkTerm "n4_Dig" ;
lin D_5 = mkTerm "n5_Dig" ;
lin D_6 = mkTerm "n6_Dig" ;
lin D_7 = mkTerm "n7_Dig" ;
lin D_8 = mkTerm "n8_Dig" ;
lin D_9 = mkTerm "n9_Dig" ;
lin DefArt = mkTerm "the_Quant" ;
lin DetCN det_1 cn_2 = mkTerm "mkNP" (flatIfTerm det_1) (flatIfTerm cn_2) ;
lin DetNP det_1 = mkTerm "mkNP" det_1 ;
lin DetQuant quant_1 num_2 = mkFlat (mkTerm "mkDet" quant_1 num_2) ;
lin DetQuantOrd quant_1 num_2 ord_3 = mkTerm "mkDet" quant_1 num_2 ord_3 ;
lin EmbedQS qs_1 = mkTerm "mkSC" qs_1 ;
lin EmbedS s_1 = mkTerm "mkSC" s_1 ;
lin EmbedVP vp_1 = mkTerm "mkSC" vp_1 ;
lin ExistIP ip_1 = mkTerm "mkQCl" ip_1 ;
lin ExistNP np_1 = mkTerm "mkCl" np_1 ;
lin ExtAdvS adv_1 s_2 = mkTerm "mkS" adv_1 s_2 ;
lin FunRP prep_1 np_2 rp_3 = mkTerm "mkRP" prep_1 np_2 rp_3 ;
lin GenericCl vp_1 = mkTerm "genericCl" vp_1 ;
lin IDig dig_1 = mkTerm "mkDigits" (mkTerm "\"999999\"") ; -- mkTerm "mkDigits" dig_1 ;
lin IIDig dig_1 digits_2 = mkTerm "mkDigits" (mkTerm "\"999\"") ; -- mkTerm "mkDigits" dig_1 digits_2 ;
lin IdRP = mkTerm "which_RP" ;
lin IdetCN idet_1 cn_2 = mkTerm "mkIP" idet_1 cn_2 ;
lin IdetIP idet_1 = mkTerm "mkIP" idet_1 ;
lin IdetQuant iquant_1 num_2 = mkTerm "mkIDet" iquant_1 num_2 ;
--lin ImpP3 np_1 vp_2 = mkTerm "mkUtt" np_1 vp_2 ;
lin ImpPl1 vp_1 = mkTerm "lets_Utt" vp_1 ;
lin ImpVP vp_1 = mkTerm "mkImp" vp_1 ;
lin ImpersCl vp_1 = mkTerm "mkCl" vp_1 ;
lin IndefArt = mkTerm "a_Quant" ;
lin MassNP cn_1 = mkTerm "mkNP" cn_1 ;
lin NoPConj = mkTerm (hide "NoPConj") ;
lin NoVoc = mkTerm (hide "NoVoc") ;
lin NumCard card_1 = mkTerm "mkNum" card_1 ;
lin NumDigits digits_1 = mkTerm "mkCard" digits_1 ;
lin NumNumeral numeral_1 = mkTerm "mkCard" numeral_1 ;
lin NumPl = mkTerm "pluralNum" ;
lin NumSg = mkTerm (hideOpt "singularNum") ;
lin OrdDigits digits_1 = mkTerm "mkOrd" digits_1 ;
lin OrdNumeral numeral_1 = mkTerm "mkOrd" numeral_1 ;
lin OrdSuperl a_1 = mkTerm "mkOrd" a_1 ;
lin PConjConj conj_1 = mkTerm "mkPConj" conj_1 ;
lin PNeg = mkTerm "negativePol" ;
lin PPartNP np_1 v2_2 = mkTerm "mkNP" np_1 v2_2 ;
lin PPos = mkTerm (hideOpt "positivePol") ;
lin PassV2 v2_1 = mkTerm "passiveVP" v2_1 ;
lin PhrUtt pconj_1 utt_2 voc_3 = mkFlat (mkTerm "mkPhr" pconj_1 utt_2 voc_3) ;
lin PositA a_1 = mkFlat (mkTerm "mkAP" a_1) ;
lin PositAdAAdj a_1 = mkTerm "mkAdA" a_1 ;
lin PositAdvAdj a_1 = mkTerm "mkAdv" a_1 ;
lin PossPron pron_1 = mkTerm "mkQuant" pron_1 ;
lin PredSCVP sc_1 vp_2 = mkTerm "mkCl" sc_1 vp_2 ;
--lin PredVP np_1 vp_2 = mkTerm "mkCl" np_1 vp_2 ;
lin PredVP np_1 vp_2 = mkTerm "mkCl" np_1 (flatIfTerm vp_2) ;
lin PredetNP predet_1 np_2 = mkTerm "mkNP" predet_1 np_2 ;
lin PrepIP prep_1 ip_2 = mkTerm "mkIAdv" prep_1 ip_2 ;
lin PrepNP prep_1 np_2 = mkTerm "mkAdv" prep_1 np_2 ;
lin ProgrVP vp_1 = mkTerm "progressiveVP" vp_1 ;
lin QuestCl cl_1 = mkTerm "mkQCl" cl_1 ;
lin QuestIAdv iadv_1 cl_2 = mkTerm "mkQCl" iadv_1 cl_2 ;
lin QuestIComp icomp_1 np_2 = mkTerm "mkQCl" icomp_1 np_2 ;
lin QuestQVP ip_1 qvp_2 = mkTerm "mkQCl" ip_1 qvp_2 ;
lin QuestSlash ip_1 clslash_2 = mkTerm "mkQCl" ip_1 clslash_2 ;
lin QuestVP ip_1 vp_2 = mkTerm "mkQCl" ip_1 (flatIfTerm vp_2) ;
lin ReflA2 a2_1 = mkTerm "reflAP" a2_1 ;
lin ReflVP vpslash_1 = mkTerm "reflexiveVP" vpslash_1 ;
lin RelCN cn_1 rs_2 = mkTerm "mkCN" cn_1 rs_2 ;
lin RelCl cl_1 = mkTerm "mkRCl" cl_1 ;
lin RelNP np_1 rs_2 = mkTerm "mkNP" np_1 rs_2 ;
lin RelS s_1 rs_2 = mkTerm "mkS" s_1 rs_2 ;
lin RelSlash rp_1 clslash_2 = mkTerm "mkRCl" rp_1 clslash_2 ;
lin RelVP rp_1 vp_2 = mkTerm "mkRCl" rp_1 (flatIfTerm vp_2) ;
lin SSubjS s_1 subj_2 s_3 = mkTerm "mkS" s_1 subj_2 s_3 ;
lin SentAP ap_1 sc_2 = mkTerm "mkAP" ap_1 sc_2 ;
lin SentCN cn_1 sc_2 = mkTerm "mkCN" cn_1 sc_2 ;
lin Slash2V3 v3_1 np_2 = mkTerm "mkVPSlash" v3_1 np_2 ;
lin Slash3V3 v3_1 np_2 = mkFlat (mkSwapTerm "mkVPSlash" v3_1 np_2) ;
lin SlashPrep cl_1 prep_2 = mkTerm "mkClSlash" cl_1 prep_2 ;
lin SlashV2A v2a_1 ap_2 = mkFlat (mkSwapTerm "mkVPSlash" v2a_1 ap_2) ;
lin SlashV2Q v2q_1 qs_2 = mkFlat (mkSwapTerm "mkVPSlash" v2q_1 qs_2) ;
lin SlashV2S v2s_1 s_2 = mkFlat (mkSwapTerm "mkVPSlash" v2s_1 s_2) ;
lin SlashV2V v2v_1 vp_2 = mkFlat (mkSwapTerm "mkVPSlash" v2v_1 vp_2) ;
lin SlashV2VNP v2v_1 np_2 vpslash_3 = mkTerm "mkVPSlash" v2v_1 np_2 vpslash_3 ;
lin SlashV2a v2_1 = mkFlat (mkTerm "mkVPSlash" v2_1) ;
lin SlashVP np_1 vpslash_2 = mkTerm "mkClSlash" np_1 vpslash_2 ;
lin SlashVS np_1 vs_2 sslash_3 = mkTerm "mkClSlash" np_1 vs_2 sslash_3 ;
lin SlashVV vv_1 vpslash_2 = mkTerm "mkVPSlash" vv_1 vpslash_2 ;
lin SubjS subj_1 s_2 = mkTerm "mkAdv" subj_1 s_2 ;
lin TEmpty = mkTerm (hideOpt "emptyText") ;
lin TExclMark phr_1 text_2 = mkTerm "mkText" (flatIfTerm phr_1) (mkTerm "exclMarkPunct") text_2 ;
lin TFullStop phr_1 text_2 = mkTerm "mkText" (flatIfTerm phr_1) text_2 ;
lin TCond = mkTerm "conditionalTense" ;
lin TFut = mkTerm "futureTense" ;
lin TPast = mkTerm "pastTense" ;
lin TPres = mkTerm (hideOpt "presentTense") ;
lin TQuestMark phr_1 text_2 = mkTerm "mkText" (flatIfTerm phr_1) (mkTerm "questMarkPunct") text_2 ;
lin TTAnt tense_1 ant_2 = mkTerm "mkTense" tense_1 ant_2 ;
--lin Use2N3 n3_1 = mkTerm "mkN2" n3_1 ;
--lin Use3N3 n3_1 = mkTerm "mkN2" n3_1 ;
lin UseA2 a2_1 = mkTerm "mkAP" a2_1 ;
lin UseCl temp_1 pol_2 cl_3 = mkTerm "mkS" (flatTerm temp_1) pol_2 cl_3 ;
lin UseComp comp_1 = mkFlat (mkTerm "mkVP" (flatIfTerm comp_1)) ;
lin UseComparA a_1 = mkTerm "mkAP" a_1 ;
--lin UseCopula = mkTerm "UseCopula" ;
lin UseN n_1 = mkFlat (mkTerm "mkCN" n_1) ;
lin UseN2 n2_1 = mkTerm "mkCN" n2_1 ;
lin UsePN pn_1 = mkTerm "mkNP" pn_1 ;
lin UsePron pron_1 = mkTerm "mkNP" pron_1 ;
lin UseQCl temp_1 pol_2 qcl_3 = mkTerm "mkQS" (flatTerm temp_1) pol_2 qcl_3 ;
lin UseRCl temp_1 pol_2 rcl_3 = mkTerm "mkRS" (flatTerm temp_1) pol_2 rcl_3 ;
lin UseSlash temp_1 pol_2 clslash_3 = mkTerm "mkSSlash" temp_1 pol_2 clslash_3 ;
lin UseV v_1 = mkFlat (mkTerm "mkVP" v_1) ;
lin UttAP ap_1 = mkTerm "mkUtt" ap_1 ;
lin UttAdv adv_1 = mkTerm "mkUtt" adv_1 ;
lin UttCN cn_1 = mkTerm "mkUtt" cn_1 ;
lin UttCard card_1 = mkTerm "mkUtt" card_1 ;
lin UttIAdv iadv_1 = mkTerm "mkUtt" iadv_1 ;
lin UttIP ip_1 = mkTerm "mkUtt" ip_1 ;
lin UttImpPl pol_1 imp_2 = mkTerm "mkUtt" (mkTerm "pluralImpForm") pol_1 imp_2 ;
lin UttImpPol pol_1 imp_2 = mkTerm "mkUtt" (mkTerm "politeImpForm") pol_1 imp_2 ;
lin UttImpSg pol_1 imp_2 = mkTerm "mkUtt" pol_1 imp_2 ;
--lin UttInterj interj_1 = mkTerm "mkUtt" interj_1 ;
lin UttNP np_1 = mkTerm "mkUtt" np_1 ;
lin UttQS qs_1 = mkFlat (mkTerm "mkUtt" qs_1) ;
lin UttS s_1 = mkFlat (mkTerm "mkUtt" s_1) ;
lin UttVP vp_1 = mkTerm "mkUtt" vp_1 ;
lin VocNP np_1 = mkTerm "mkVoc" np_1 ;

  lin
    i_NP = mkTerm "i_NP" ;
    you_NP = mkTerm "you_NP" ;
    he_NP = mkTerm "he_NP" ;
    she_NP = mkTerm "she_NP" ;
    we_NP = mkTerm "we_NP" ;
    youPl_NP = mkTerm "youPl_NP" ;
    youPol_NP = mkTerm "youPol_NP" ;
    they_NP = mkTerm "they_NP" ;

    a_Det = mkTerm "a_Det" ;
    the_Det = mkTerm "the_Det" ;
    aPl_Det = mkTerm "aPl_Det" ;
    thePl_Det = mkTerm "thePl_Det" ;

lin above_Prep = mkTerm "above_Prep" ;
lin after_Prep = mkTerm "after_Prep" ;
lin all_Predet = mkTerm "all_Predet" ;
lin almost_AdA = mkTerm "almost_AdA" ;
lin almost_AdN = mkTerm "almost_AdN" ;
lin although_Subj = mkTerm "although_Subj" ;
lin always_AdV = mkTerm "always_AdV" ;
lin and_Conj = mkTerm "and_Conj" ;
lin as_CAdv = mkTerm "as_CAdv" ;
lin at_least_AdN = mkTerm "at_least_AdN" ;
lin at_most_AdN = mkTerm "at_most_AdN" ;
lin because_Subj = mkTerm "because_Subj" ;
lin before_Prep = mkTerm "before_Prep" ;
lin behind_Prep = mkTerm "behind_Prep" ;
lin between_Prep = mkTerm "between_Prep" ;
lin both7and_DConj = mkTerm "both7and_DConj" ;
lin but_PConj = mkTerm "but_PConj" ;
lin by8agent_Prep = mkTerm "by8agent_Prep" ;
lin by8means_Prep = mkTerm "by8means_Prep" ;
lin can8know_VV = mkTerm "can8know_VV" ;
lin can_VV = mkTerm "can_VV" ;
lin during_Prep = mkTerm "during_Prep" ;
lin either7or_DConj = mkTerm "either7or_DConj" ;
lin every_Det = mkTerm "every_Det" ;
lin everybody_NP = mkTerm "everybody_NP" ;
lin everything_NP = mkTerm "everything_NP" ;
lin everywhere_Adv = mkTerm "everywhere_Adv" ;
lin except_Prep = mkTerm "except_Prep" ;
lin few_Det = mkTerm "few_Det" ;
lin for_Prep = mkTerm "for_Prep" ;
lin from_Prep = mkTerm "from_Prep" ;
lin have_V2 = mkTerm "have_V2" ;
lin he_Pron = mkTerm "he_Pron" ;
lin here7from_Adv = mkTerm "here7from_Adv" ;
lin here7to_Adv = mkTerm "here7to_Adv" ;
lin here_Adv = mkTerm "here_Adv" ;
lin how8many_IDet = mkTerm "how8many_IDet" ;
lin how8much_IAdv = mkTerm "how8much_IAdv" ;
lin how_IAdv = mkTerm "how_IAdv" ;
lin i_Pron = mkTerm "i_Pron" ;
lin if_Subj = mkTerm "if_Subj" ;
lin if_then_Conj = mkTerm "if_then_Conj" ;
lin in8front_Prep = mkTerm "in8front_Prep" ;
lin in_Prep = mkTerm "in_Prep" ;
lin it_Pron = mkTerm "it_Pron" ;
lin language_title_Utt = mkTerm "language_title_Utt" ;
lin less_CAdv = mkTerm "less_CAdv" ;
lin many_Det = mkTerm "many_Det" ;
lin more_CAdv = mkTerm "more_CAdv" ;
lin most_Predet = mkTerm "most_Predet" ;
lin much_Det = mkTerm "much_Det" ;
lin must_VV = mkTerm "must_VV" ;
lin no_Quant = mkTerm "no_Quant" ;
lin no_Utt = mkTerm "no_Utt" ;
lin nobody_NP = mkTerm "nobody_NP" ;
lin not_Predet = mkTerm "not_Predet" ;
lin nothing_NP = mkTerm "nothing_NP" ;
lin on_Prep = mkTerm "on_Prep" ;
lin only_Predet = mkTerm "only_Predet" ;
lin or_Conj = mkTerm "or_Conj" ;
lin otherwise_PConj = mkTerm "otherwise_PConj" ;
lin part_Prep = mkTerm "part_Prep" ;
lin please_Voc = mkTerm "please_Voc" ;
lin possess_Prep = mkTerm "possess_Prep" ;
lin quite_Adv = mkTerm "quite_Adv" ;
lin she_Pron = mkTerm "she_Pron" ;
lin so_AdA = mkTerm "so_AdA" ;
lin somePl_Det = mkTerm "somePl_Det" ;
lin someSg_Det = mkTerm "someSg_Det" ;
lin somebody_NP = mkTerm "somebody_NP" ;
lin something_NP = mkTerm "something_NP" ;
lin somewhere_Adv = mkTerm "somewhere_Adv" ;
lin that_Quant = mkTerm "that_Quant" ;
lin that_Subj = mkTerm "that_Subj" ;
lin there7from_Adv = mkTerm "there7from_Adv" ;
lin there7to_Adv = mkTerm "there7to_Adv" ;
lin there_Adv = mkTerm "there_Adv" ;
lin therefore_PConj = mkTerm "therefore_PConj" ;
lin they_Pron = mkTerm "they_Pron" ;
lin this_Quant = mkTerm "this_Quant" ;
lin through_Prep = mkTerm "through_Prep" ;
lin to_Prep = mkTerm "to_Prep" ;
lin too_AdA = mkTerm "too_AdA" ;
lin under_Prep = mkTerm "under_Prep" ;
lin very_AdA = mkTerm "very_AdA" ;
lin want_VV = mkTerm "want_VV" ;
lin we_Pron = mkTerm "we_Pron" ;
lin whatPl_IP = mkTerm "whatPl_IP" ;
lin whatSg_IP = mkTerm "whatSg_IP" ;
lin when_IAdv = mkTerm "when_IAdv" ;
lin when_Subj = mkTerm "when_Subj" ;
lin where_IAdv = mkTerm "where_IAdv" ;
lin which_IQuant = mkTerm "which_IQuant" ;
lin whoPl_IP = mkTerm "whoPl_IP" ;
lin whoSg_IP = mkTerm "whoSg_IP" ;
lin why_IAdv = mkTerm "why_IAdv" ;
lin with_Prep = mkTerm "with_Prep" ;
lin without_Prep = mkTerm "without_Prep" ;
lin yes_Utt = mkTerm "yes_Utt" ;
lin youPl_Pron = mkTerm "youPl_Pron" ;
lin youPol_Pron = mkTerm "youPol_Pron" ;
lin youSg_Pron = mkTerm "youSg_Pron" ;
lin a_bomb_N = mkTerm "a_bomb_N" ;
lin a_fortiori_Adv = mkTerm "a_fortiori_Adv" ;
lin a_la_carte_Adv = mkTerm "a_la_carte_Adv" ;
lin a_la_mode_Adv = mkTerm "a_la_mode_Adv" ;
lin a_level_N = mkTerm "a_level_N" ;
lin a_posteriori_A = mkTerm "a_posteriori_A" ;
lin a_priori_A = mkTerm "a_priori_A" ;
lin aa_N = mkTerm "aa_N" ;
lin aachen_PN = mkTerm "aachen_PN" ;
lin aalii_N = mkTerm "aalii_N" ;
lin aardvark_N = mkTerm "aardvark_N" ;
lin aardwolf_N = mkTerm "aardwolf_N" ;
lin aarhus_PN = mkTerm "aarhus_PN" ;
lin ab_initio_Adv = mkTerm "ab_initio_Adv" ;
lin aba_N = mkTerm "aba_N" ;
lin abaca_N = mkTerm "abaca_N" ;
lin aback_Adv = mkTerm "aback_Adv" ;
lin abactinal_A = mkTerm "abactinal_A" ;
lin abacus_N = mkTerm "abacus_N" ;
lin abaft_Adv = mkTerm "abaft_Adv" ;
lin abaft_Prep = mkTerm "abaft_Prep" ;
lin abalone_N = mkTerm "abalone_N" ;
lin abampere_N = mkTerm "abampere_N" ;
lin abandon_N = mkTerm "abandon_N" ;
lin abandon_V2 = mkTerm "abandon_V2" ;
lin abandonment_N = mkTerm "abandonment_N" ;
lin abarticulation_N = mkTerm "abarticulation_N" ;
lin abase_V2 = mkTerm "abase_V2" ;
lin abasement_N = mkTerm "abasement_N" ;
lin abash_V2 = mkTerm "abash_V2" ;
lin abashment_N = mkTerm "abashment_N" ;
lin abasia_N = mkTerm "abasia_N" ;
lin abasic_A = mkTerm "abasic_A" ;
lin abatable_A = mkTerm "abatable_A" ;
lin abate_V = mkTerm "abate_V" ;
lin abate_V2 = mkTerm "abate_V2" ;
lin abatement_N = mkTerm "abatement_N" ;
lin abator_N = mkTerm "abator_N" ;
lin abattis_N = mkTerm "abattis_N" ;
lin abattoir_N = mkTerm "abattoir_N" ;
lin abaxial_A = mkTerm "abaxial_A" ;
lin abaya_N = mkTerm "abaya_N" ;
lin abbacy_N = mkTerm "abbacy_N" ;
lin abbatial_A = mkTerm "abbatial_A" ;
lin abbe_N = mkTerm "abbe_N" ;
lin abbess_N = mkTerm "abbess_N" ;
lin abbey_N = mkTerm "abbey_N" ;
lin abbot_N = mkTerm "abbot_N" ;
lin abbreviate_V2 = mkTerm "abbreviate_V2" ;
lin abbreviation_N = mkTerm "abbreviation_N" ;
lin abc_N = mkTerm "abc_N" ;
lin abcoulomb_N = mkTerm "abcoulomb_N" ;
lin abdicable_A = mkTerm "abdicable_A" ;
lin abdicate_V = mkTerm "abdicate_V" ;
lin abdicate_V2 = mkTerm "abdicate_V2" ;
lin abdication_N = mkTerm "abdication_N" ;
lin abdicator_N = mkTerm "abdicator_N" ;
lin abdomen_N = mkTerm "abdomen_N" ;
lin abdominal_A = mkTerm "abdominal_A" ;
lin abdominal_N = mkTerm "abdominal_N" ;
lin abdominocentesis_N = mkTerm "abdominocentesis_N" ;
lin abdominoplasty_N = mkTerm "abdominoplasty_N" ;
lin abdominous_A = mkTerm "abdominous_A" ;
lin abdominousness_N = mkTerm "abdominousness_N" ;
lin abdominovesical_A = mkTerm "abdominovesical_A" ;
lin abducent_A = mkTerm "abducent_A" ;
lin abducent_N = mkTerm "abducent_N" ;
lin abduct_V2 = mkTerm "abduct_V2" ;
lin abduction_N = mkTerm "abduction_N" ;
lin abductor_N = mkTerm "abductor_N" ;
lin abe_PN = mkTerm "abe_PN" ;
lin abeam_Adv = mkTerm "abeam_Adv" ;
lin abecedarian_A = mkTerm "abecedarian_A" ;
lin abecedarian_N = mkTerm "abecedarian_N" ;
lin abecedarius_N = mkTerm "abecedarius_N" ;
lin abed_Adv = mkTerm "abed_Adv" ;
lin abelia_N = mkTerm "abelia_N" ;
lin abelian_A = mkTerm "abelian_A" ;
lin abelmosk_N = mkTerm "abelmosk_N" ;
lin abercarn_PN = mkTerm "abercarn_PN" ;
lin aberdare_PN = mkTerm "aberdare_PN" ;
lin aberdeen_PN = mkTerm "aberdeen_PN" ;
lin abergavenny_PN = mkTerm "abergavenny_PN" ;
lin abergele_PN = mkTerm "abergele_PN" ;
lin aberrance_N = mkTerm "aberrance_N" ;
lin aberrant_A = mkTerm "aberrant_A" ;
lin aberrant_N = mkTerm "aberrant_N" ;
lin aberration_N = mkTerm "aberration_N" ;
lin abertillery_PN = mkTerm "abertillery_PN" ;
lin aberystwyth_PN = mkTerm "aberystwyth_PN" ;
lin abet_V = mkTerm "abet_V" ;
lin abet_V2 = mkTerm "abet_V2" ;
lin abetalipoproteinemia_N = mkTerm "abetalipoproteinemia_N" ;
lin abetment_N = mkTerm "abetment_N" ;
lin abettor_N = mkTerm "abettor_N" ;
lin abeyance_N = mkTerm "abeyance_N" ;
lin abeyant_A = mkTerm "abeyant_A" ;
lin abfarad_N = mkTerm "abfarad_N" ;
lin abhenry_N = mkTerm "abhenry_N" ;
lin abhor_V2 = mkTerm "abhor_V2" ;
lin abhorrence_N = mkTerm "abhorrence_N" ;
lin abhorrent_A = mkTerm "abhorrent_A" ;
lin abhorrer_N = mkTerm "abhorrer_N" ;
lin abidance_N = mkTerm "abidance_N" ;
lin abide_V = mkTerm "abide_V" ;
lin abide_V2 = mkTerm "abide_V2" ;
lin abide_by_V2 = mkTerm "abide_by_V2" ;
lin abience_N = mkTerm "abience_N" ;
lin abient_A = mkTerm "abient_A" ;
lin ability_N = mkTerm "ability_N" ;
lin abingdon_PN = mkTerm "abingdon_PN" ;
lin abiogenesis_N = mkTerm "abiogenesis_N" ;
lin abiogenetic_A = mkTerm "abiogenetic_A" ;
lin abiogenist_N = mkTerm "abiogenist_N" ;
lin abiotrophy_N = mkTerm "abiotrophy_N" ;
lin abject_A = mkTerm "abject_A" ;
lin abjection_N = mkTerm "abjection_N" ;
lin abjuration_N = mkTerm "abjuration_N" ;
lin abjure_V2 = mkTerm "abjure_V2" ;
lin abjurer_N = mkTerm "abjurer_N" ;
lin ablactation_N = mkTerm "ablactation_N" ;
lin ablated_A = mkTerm "ablated_A" ;
lin ablation_N = mkTerm "ablation_N" ;
lin ablative_A = mkTerm "ablative_A" ;
lin ablative_N = mkTerm "ablative_N" ;
lin ablaut_N = mkTerm "ablaut_N" ;
lin ablaze_A = mkTerm "ablaze_A" ;
lin able_A = mkTerm "able_A" ;
lin able_bodied_A = mkTerm "able_bodied_A" ;
lin ableism_N = mkTerm "ableism_N" ;
lin ablepharia_N = mkTerm "ablepharia_N" ;
lin abloom_A = mkTerm "abloom_A" ;
lin ablution_N = mkTerm "ablution_N" ;
lin ablutionary_A = mkTerm "ablutionary_A" ;
lin abnegation_N = mkTerm "abnegation_N" ;
lin abnegator_N = mkTerm "abnegator_N" ;
lin abnormal_A = mkTerm "abnormal_A" ;
lin abnormality_N = mkTerm "abnormality_N" ;
lin abo_N = mkTerm "abo_N" ;
lin aboard_Adv = mkTerm "aboard_Adv" ;
lin aboard_Prep = mkTerm "aboard_Prep" ;
lin abocclusion_N = mkTerm "abocclusion_N" ;
lin abode_N = mkTerm "abode_N" ;
lin abohm_N = mkTerm "abohm_N" ;
lin abolish_V2 = mkTerm "abolish_V2" ;
lin abolishable_A = mkTerm "abolishable_A" ;
lin abolition_N = mkTerm "abolition_N" ;
lin abolitionary_A = mkTerm "abolitionary_A" ;
lin abolitionism_N = mkTerm "abolitionism_N" ;
lin abolitionist_N = mkTerm "abolitionist_N" ;
lin abomasal_A = mkTerm "abomasal_A" ;
lin abomasum_N = mkTerm "abomasum_N" ;
lin abominable_A = mkTerm "abominable_A" ;
lin abominate_V2 = mkTerm "abominate_V2" ;
lin abomination_N = mkTerm "abomination_N" ;
lin abominator_N = mkTerm "abominator_N" ;
lin aborad_Adv = mkTerm "aborad_Adv" ;
lin aboral_A = mkTerm "aboral_A" ;
lin aboriginal_A = mkTerm "aboriginal_A" ;
lin aborigine_N = mkTerm "aborigine_N" ;
lin abort_N = mkTerm "abort_N" ;
lin abort_V = mkTerm "abort_V" ;
lin abort_V2 = mkTerm "abort_V2" ;
lin aborticide_N = mkTerm "aborticide_N" ;
lin abortifacient_A = mkTerm "abortifacient_A" ;
lin abortifacient_N = mkTerm "abortifacient_N" ;
lin abortion_N = mkTerm "abortion_N" ;
lin abortionistFem_N = mkTerm "abortionistFem_N" ;
lin abortionistMasc_N = mkTerm "abortionistMasc_N" ;
lin abortive_A = mkTerm "abortive_A" ;
lin abortus_N = mkTerm "abortus_N" ;
lin abound_V = mkTerm "abound_V" ;
lin about_AdN = mkTerm "about_AdN" ;
lin about_Adv = mkTerm "about_Adv" ;
lin about_Prep = mkTerm "about_Prep" ;
lin about_face_N = mkTerm "about_face_N" ;
lin about_face_V = mkTerm "about_face_V" ;
lin above_A = mkTerm "above_A" ;
lin above_Adv = mkTerm "above_Adv" ;
lin above_N = mkTerm "above_N" ;
lin above_board_A = mkTerm "above_board_A" ;
lin above_board_Adv = mkTerm "above_board_Adv" ;
lin above_mentioned_A = mkTerm "above_mentioned_A" ;
lin above_named_A = mkTerm "above_named_A" ;
lin aboveboard_A = mkTerm "aboveboard_A" ;
lin aboveground_A = mkTerm "aboveground_A" ;
lin abracadabra_N = mkTerm "abracadabra_N" ;
lin abrachia_N = mkTerm "abrachia_N" ;
lin abrade_V2 = mkTerm "abrade_V2" ;
lin abrader_N = mkTerm "abrader_N" ;
lin abraham_PN = mkTerm "abraham_PN" ;
lin abranchiate_A = mkTerm "abranchiate_A" ;
lin abrasion_N = mkTerm "abrasion_N" ;
lin abrasive_A = mkTerm "abrasive_A" ;
lin abrasive_N = mkTerm "abrasive_N" ;
lin abrasiveness_N = mkTerm "abrasiveness_N" ;
lin abreast_Adv = mkTerm "abreast_Adv" ;
lin abridge_V2 = mkTerm "abridge_V2" ;
lin abridgement_N = mkTerm "abridgement_N" ;
lin abridger_N = mkTerm "abridger_N" ;
lin abroach_A = mkTerm "abroach_A" ;
lin abroad_A = mkTerm "abroad_A" ;
lin abroad_Adv = mkTerm "abroad_Adv" ;
lin abrocome_N = mkTerm "abrocome_N" ;
lin abrogate_V2 = mkTerm "abrogate_V2" ;
lin abrogation_N = mkTerm "abrogation_N" ;
lin abrogator_N = mkTerm "abrogator_N" ;
lin abrupt_A = mkTerm "abrupt_A" ;
lin abruptness_N = mkTerm "abruptness_N" ;
lin abscess_N = mkTerm "abscess_N" ;
lin abscessed_A = mkTerm "abscessed_A" ;
lin abscissa_N = mkTerm "abscissa_N" ;
lin abscission_N = mkTerm "abscission_N" ;
lin abscond_V = mkTerm "abscond_V" ;
lin absconder_N = mkTerm "absconder_N" ;
lin abscondment_N = mkTerm "abscondment_N" ;
lin abseiler_N = mkTerm "abseiler_N" ;
lin absence_N = mkTerm "absence_N" ;
lin absent_A = mkTerm "absent_A" ;
lin absent_Prep = mkTerm "absent_Prep" ;
lin absent_V2 = mkTerm "absent_V2" ;
lin absent_minded_A = mkTerm "absent_minded_A" ;
lin absentee_N = mkTerm "absentee_N" ;
lin absenteeism_N = mkTerm "absenteeism_N" ;
lin absentmindedness_N = mkTerm "absentmindedness_N" ;
lin absinthe_N = mkTerm "absinthe_N" ;
lin absolute_A = mkTerm "absolute_A" ;
lin absolute_N = mkTerm "absolute_N" ;
lin absoluteness_N = mkTerm "absoluteness_N" ;
lin absolution_N = mkTerm "absolution_N" ;
lin absolutism_N = mkTerm "absolutism_N" ;
lin absolutist_A = mkTerm "absolutist_A" ;
lin absolutist_N = mkTerm "absolutist_N" ;
lin absolve_V2 = mkTerm "absolve_V2" ;
lin absolver_N = mkTerm "absolver_N" ;
lin absolvitory_A = mkTerm "absolvitory_A" ;
lin absorb_V2 = mkTerm "absorb_V2" ;
lin absorbable_A = mkTerm "absorbable_A" ;
lin absorbate_N = mkTerm "absorbate_N" ;
lin absorbefacient_A = mkTerm "absorbefacient_A" ;
lin absorbency_N = mkTerm "absorbency_N" ;
lin absorbent_A = mkTerm "absorbent_A" ;
lin absorbent_N = mkTerm "absorbent_N" ;
lin absorber_N = mkTerm "absorber_N" ;
lin absorbing_A = mkTerm "absorbing_A" ;
lin absorption_N = mkTerm "absorption_N" ;
lin absorptivity_N = mkTerm "absorptivity_N" ;
lin abstain_V = mkTerm "abstain_V" ;
lin abstainer_N = mkTerm "abstainer_N" ;
lin abstemious_A = mkTerm "abstemious_A" ;
lin abstemiousness_N = mkTerm "abstemiousness_N" ;
lin abstention_N = mkTerm "abstention_N" ;
lin abstinence_N = mkTerm "abstinence_N" ;
lin abstinent_A = mkTerm "abstinent_A" ;
lin abstract_A = mkTerm "abstract_A" ;
lin abstract_N = mkTerm "abstract_N" ;
lin abstract_V2 = mkTerm "abstract_V2" ;
lin abstractedness_N = mkTerm "abstractedness_N" ;
lin abstraction_N = mkTerm "abstraction_N" ;
lin abstractionism_N = mkTerm "abstractionism_N" ;
lin abstractionist_N = mkTerm "abstractionist_N" ;
lin abstractive_A = mkTerm "abstractive_A" ;
lin abstractness_N = mkTerm "abstractness_N" ;
lin abstractor_N = mkTerm "abstractor_N" ;
lin abstruse_A = mkTerm "abstruse_A" ;
lin abstruseness_N = mkTerm "abstruseness_N" ;
lin absurd_A = mkTerm "absurd_A" ;
lin absurd_N = mkTerm "absurd_N" ;
lin absurdity_N = mkTerm "absurdity_N" ;
lin abulia_N = mkTerm "abulia_N" ;
lin abulic_A = mkTerm "abulic_A" ;
lin abundance_N = mkTerm "abundance_N" ;
lin abundant_A = mkTerm "abundant_A" ;
lin abuse_N = mkTerm "abuse_N" ;
lin abuse_V2 = mkTerm "abuse_V2" ;
lin abuser_N = mkTerm "abuser_N" ;
lin abusive_A = mkTerm "abusive_A" ;
lin abut_V = mkTerm "abut_V" ;
lin abutment_N = mkTerm "abutment_N" ;
lin abutter_N = mkTerm "abutter_N" ;
lin abuzz_A = mkTerm "abuzz_A" ;
lin abvolt_N = mkTerm "abvolt_N" ;
lin abwatt_N = mkTerm "abwatt_N" ;
lin abysm_N = mkTerm "abysm_N" ;
lin abysmal_A = mkTerm "abysmal_A" ;
lin abyss_N = mkTerm "abyss_N" ;
lin abyssal_A = mkTerm "abyssal_A" ;
lin acacia_N = mkTerm "acacia_N" ;
lin academia_N = mkTerm "academia_N" ;
lin academic_A = mkTerm "academic_A" ;
lin academic_N = mkTerm "academic_N" ;
lin academicianFem_N = mkTerm "academicianFem_N" ;
lin academicianMasc_N = mkTerm "academicianMasc_N" ;
lin academicianship_N = mkTerm "academicianship_N" ;
lin academy_N = mkTerm "academy_N" ;
lin acanthion_N = mkTerm "acanthion_N" ;
lin acanthocephalan_N = mkTerm "acanthocephalan_N" ;
lin acanthocyte_N = mkTerm "acanthocyte_N" ;
lin acanthocytosis_N = mkTerm "acanthocytosis_N" ;
lin acanthoid_A = mkTerm "acanthoid_A" ;
lin acantholysis_N = mkTerm "acantholysis_N" ;
lin acanthoma_N = mkTerm "acanthoma_N" ;
lin acanthosis_N = mkTerm "acanthosis_N" ;
lin acanthotic_A = mkTerm "acanthotic_A" ;
lin acanthus_N = mkTerm "acanthus_N" ;
lin acapnic_A = mkTerm "acapnic_A" ;
lin acardia_N = mkTerm "acardia_N" ;
lin acariasis_N = mkTerm "acariasis_N" ;
lin acaricide_N = mkTerm "acaricide_N" ;
lin acarid_N = mkTerm "acarid_N" ;
lin acarine_N = mkTerm "acarine_N" ;
lin acarophobia_N = mkTerm "acarophobia_N" ;
lin acarpelous_A = mkTerm "acarpelous_A" ;
lin acarpous_A = mkTerm "acarpous_A" ;
lin acarus_N = mkTerm "acarus_N" ;
lin acatalectic_A = mkTerm "acatalectic_A" ;
lin acatalectic_N = mkTerm "acatalectic_N" ;
lin acataphasia_N = mkTerm "acataphasia_N" ;
lin acathexia_N = mkTerm "acathexia_N" ;
lin acathexis_N = mkTerm "acathexis_N" ;
lin acaudate_A = mkTerm "acaudate_A" ;
lin acaulescent_A = mkTerm "acaulescent_A" ;
lin accede_V = mkTerm "accede_V" ;
lin accelerando_A = mkTerm "accelerando_A" ;
lin accelerando_Adv = mkTerm "accelerando_Adv" ;
lin accelerando_N = mkTerm "accelerando_N" ;
lin accelerate_V = mkTerm "accelerate_V" ;
lin accelerate_V2 = mkTerm "accelerate_V2" ;
lin acceleration_N = mkTerm "acceleration_N" ;
lin accelerative_A = mkTerm "accelerative_A" ;
lin accelerator_N = mkTerm "accelerator_N" ;
lin accelerometer_N = mkTerm "accelerometer_N" ;
lin accent_N = mkTerm "accent_N" ;
lin accent_V2 = mkTerm "accent_V2" ;
lin accentor_N = mkTerm "accentor_N" ;
lin accentual_A = mkTerm "accentual_A" ;
lin accentuate_V2 = mkTerm "accentuate_V2" ;
lin accentuation_N = mkTerm "accentuation_N" ;
lin accept_V = mkTerm "accept_V" ;
lin accept_V2 = mkTerm "accept_V2" ;
lin accept_VS = mkTerm "accept_VS" ;
lin acceptability_N = mkTerm "acceptability_N" ;
lin acceptable_A = mkTerm "acceptable_A" ;
lin acceptance_N = mkTerm "acceptance_N" ;
lin acceptation_N = mkTerm "acceptation_N" ;
lin accepted_A = mkTerm "accepted_A" ;
lin acceptive_A = mkTerm "acceptive_A" ;
lin acceptor_N = mkTerm "acceptor_N" ;
lin access_N = mkTerm "access_N" ;
lin access_V2 = mkTerm "access_V2" ;
lin accessary_A = mkTerm "accessary_A" ;
lin accessary_N = mkTerm "accessary_N" ;
lin accessibility_N = mkTerm "accessibility_N" ;
lin accessible_A = mkTerm "accessible_A" ;
lin accession_N = mkTerm "accession_N" ;
lin accessional_A = mkTerm "accessional_A" ;
lin accessorial_A = mkTerm "accessorial_A" ;
lin accessory_A = mkTerm "accessory_A" ;
lin accessory_N = mkTerm "accessory_N" ;
lin accidence_N = mkTerm "accidence_N" ;
lin accident_N = mkTerm "accident_N" ;
lin accident_prone_A = mkTerm "accident_prone_A" ;
lin accidental_A = mkTerm "accidental_A" ;
lin accidental_N = mkTerm "accidental_N" ;
lin accipitrine_A = mkTerm "accipitrine_A" ;
lin acclaim_N = mkTerm "acclaim_N" ;
lin acclaim_V2 = mkTerm "acclaim_V2" ;
lin acclamation_N = mkTerm "acclamation_N" ;
lin acclimate_V = mkTerm "acclimate_V" ;
lin acclimate_V2 = mkTerm "acclimate_V2" ;
lin acclimation_N = mkTerm "acclimation_N" ;
lin acclimatization_N = mkTerm "acclimatization_N" ;
lin acclimatize_V = mkTerm "acclimatize_V" ;
lin acclimatize_V2 = mkTerm "acclimatize_V2" ;
lin acclivitous_A = mkTerm "acclivitous_A" ;
lin acclivity_N = mkTerm "acclivity_N" ;
lin accolade_N = mkTerm "accolade_N" ;
lin accommodate_V = mkTerm "accommodate_V" ;
lin accommodate_V2 = mkTerm "accommodate_V2" ;
lin accommodation_N = mkTerm "accommodation_N" ;
lin accommodational_A = mkTerm "accommodational_A" ;
lin accommodative_A = mkTerm "accommodative_A" ;
lin accompaniment_N = mkTerm "accompaniment_N" ;
lin accompanist_N = mkTerm "accompanist_N" ;
lin accompany_V2 = mkTerm "accompany_V2" ;
lin accomplice_N = mkTerm "accomplice_N" ;
lin accomplish_V2 = mkTerm "accomplish_V2" ;
lin accomplishable_A = mkTerm "accomplishable_A" ;
lin accomplished_A = mkTerm "accomplished_A" ;
lin accomplishment_N = mkTerm "accomplishment_N" ;
lin accord_N = mkTerm "accord_N" ;
lin accord_V = mkTerm "accord_V" ;
lin accordance_N = mkTerm "accordance_N" ;
lin accordant_A = mkTerm "accordant_A" ;
lin according_to_Prep = mkTerm "according_to_Prep" ;
lin accordingly_Adv = mkTerm "accordingly_Adv" ;
lin accordion_N = mkTerm "accordion_N" ;
lin accordionist_N = mkTerm "accordionist_N" ;
lin accost_V2 = mkTerm "accost_V2" ;
lin accouchement_N = mkTerm "accouchement_N" ;
lin account_N = mkTerm "account_N" ;
lin account_V = mkTerm "account_V" ;
lin account_V2 = mkTerm "account_V2" ;
lin account_for_V2 = mkTerm "account_for_V2" ;
lin accountability_N = mkTerm "accountability_N" ;
lin accountable_A = mkTerm "accountable_A" ;
lin accountancy_N = mkTerm "accountancy_N" ;
lin accountant_N = mkTerm "accountant_N" ;
lin accountantship_N = mkTerm "accountantship_N" ;
lin accounting_A = mkTerm "accounting_A" ;
lin accounting_N = mkTerm "accounting_N" ;
lin accoutered_A = mkTerm "accoutered_A" ;
lin accra_PN = mkTerm "accra_PN" ;
lin accredit_V2 = mkTerm "accredit_V2" ;
lin accreditation_N = mkTerm "accreditation_N" ;
lin accretion_N = mkTerm "accretion_N" ;
lin accretionary_A = mkTerm "accretionary_A" ;
lin accretive_A = mkTerm "accretive_A" ;
lin accrington_PN = mkTerm "accrington_PN" ;
lin accrue_V = mkTerm "accrue_V" ;
lin accrue_V2 = mkTerm "accrue_V2" ;
lin acculturation_N = mkTerm "acculturation_N" ;
lin acculturational_A = mkTerm "acculturational_A" ;
lin accumbent_A = mkTerm "accumbent_A" ;
lin accumulate_V = mkTerm "accumulate_V" ;
lin accumulate_V2 = mkTerm "accumulate_V2" ;
lin accumulation_N = mkTerm "accumulation_N" ;
lin accumulative_A = mkTerm "accumulative_A" ;
lin accumulator_N = mkTerm "accumulator_N" ;
lin accuracy_N = mkTerm "accuracy_N" ;
lin accurate_A = mkTerm "accurate_A" ;
lin accursed_A = mkTerm "accursed_A" ;
lin accurst_A = mkTerm "accurst_A" ;
lin accusation_N = mkTerm "accusation_N" ;
lin accusative_A = mkTerm "accusative_A" ;
lin accusative_N = mkTerm "accusative_N" ;
lin accusatorial_A = mkTerm "accusatorial_A" ;
lin accuse_V2 = mkTerm "accuse_V2" ;
lin accused_A = mkTerm "accused_A" ;
lin accused_N = mkTerm "accused_N" ;
lin accuserFem_N = mkTerm "accuserFem_N" ;
lin accuserMasc_N = mkTerm "accuserMasc_N" ;
lin accusingly_Adv = mkTerm "accusingly_Adv" ;
lin accustom_V2 = mkTerm "accustom_V2" ;
lin ace_A = mkTerm "ace_A" ;
lin ace_N = mkTerm "ace_N" ;
lin acebutolol_N = mkTerm "acebutolol_N" ;
lin acentric_A = mkTerm "acentric_A" ;
lin acephalia_N = mkTerm "acephalia_N" ;
lin acephalous_A = mkTerm "acephalous_A" ;
lin acerate_A = mkTerm "acerate_A" ;
lin acerb_A = mkTerm "acerb_A" ;
lin acerbity_N = mkTerm "acerbity_N" ;
lin acerola_N = mkTerm "acerola_N" ;
lin acervate_A = mkTerm "acervate_A" ;
lin acervulus_N = mkTerm "acervulus_N" ;
lin acetabular_A = mkTerm "acetabular_A" ;
lin acetabulum_N = mkTerm "acetabulum_N" ;
lin acetal_N = mkTerm "acetal_N" ;
lin acetaldehyde_N = mkTerm "acetaldehyde_N" ;
lin acetaldol_N = mkTerm "acetaldol_N" ;
lin acetamide_N = mkTerm "acetamide_N" ;
lin acetaminophen_N = mkTerm "acetaminophen_N" ;
lin acetanilide_N = mkTerm "acetanilide_N" ;
lin acetate_N = mkTerm "acetate_N" ;
lin acetic_A = mkTerm "acetic_A" ;
lin acetin_N = mkTerm "acetin_N" ;
lin acetone_N = mkTerm "acetone_N" ;
lin acetonic_A = mkTerm "acetonic_A" ;
lin acetophenetidin_N = mkTerm "acetophenetidin_N" ;
lin acetose_A = mkTerm "acetose_A" ;
lin acetum_N = mkTerm "acetum_N" ;
lin acetyl_N = mkTerm "acetyl_N" ;
lin acetylation_N = mkTerm "acetylation_N" ;
lin acetylcholine_N = mkTerm "acetylcholine_N" ;
lin acetylene_N = mkTerm "acetylene_N" ;
lin acetylenic_A = mkTerm "acetylenic_A" ;
lin acetylic_A = mkTerm "acetylic_A" ;
lin ache_N = mkTerm "ache_N" ;
lin ache_V = mkTerm "ache_V" ;
lin ache_for_V2 = mkTerm "ache_for_V2" ;
lin achene_N = mkTerm "achene_N" ;
lin achenial_A = mkTerm "achenial_A" ;
lin achievability_N = mkTerm "achievability_N" ;
lin achievable_A = mkTerm "achievable_A" ;
lin achieve_V2 = mkTerm "achieve_V2" ;
lin achievement_N = mkTerm "achievement_N" ;
lin achiever_N = mkTerm "achiever_N" ;
lin achillea_N = mkTerm "achillea_N" ;
lin achilles_PN = mkTerm "achilles_PN" ;
lin achimenes_N = mkTerm "achimenes_N" ;
lin achira_N = mkTerm "achira_N" ;
lin achlamydeous_A = mkTerm "achlamydeous_A" ;
lin achlorhydria_N = mkTerm "achlorhydria_N" ;
lin achlorhydric_A = mkTerm "achlorhydric_A" ;
lin acholia_N = mkTerm "acholia_N" ;
lin achondrite_N = mkTerm "achondrite_N" ;
lin achondritic_A = mkTerm "achondritic_A" ;
lin achondroplasia_N = mkTerm "achondroplasia_N" ;
lin achondroplastic_A = mkTerm "achondroplastic_A" ;
lin achromatic_A = mkTerm "achromatic_A" ;
lin achromatin_N = mkTerm "achromatin_N" ;
lin achromatinic_A = mkTerm "achromatinic_A" ;
lin achromatous_A = mkTerm "achromatous_A" ;
lin achromia_N = mkTerm "achromia_N" ;
lin achromic_A = mkTerm "achromic_A" ;
lin achylia_N = mkTerm "achylia_N" ;
lin acicula_N = mkTerm "acicula_N" ;
lin aciculate_A = mkTerm "aciculate_A" ;
lin acid_A = mkTerm "acid_A" ;
lin acid_N = mkTerm "acid_N" ;
lin acidemia_N = mkTerm "acidemia_N" ;
lin acidic_A = mkTerm "acidic_A" ;
lin acidification_N = mkTerm "acidification_N" ;
lin acidify_V = mkTerm "acidify_V" ;
lin acidify_V2 = mkTerm "acidify_V2" ;
lin acidimetric_A = mkTerm "acidimetric_A" ;
lin acidimetry_N = mkTerm "acidimetry_N" ;
lin acidity_N = mkTerm "acidity_N" ;
lin acidophil_N = mkTerm "acidophil_N" ;
lin acidophilic_A = mkTerm "acidophilic_A" ;
lin acidophilus_N = mkTerm "acidophilus_N" ;
lin acidosis_N = mkTerm "acidosis_N" ;
lin acidotic_A = mkTerm "acidotic_A" ;
lin acidulated_A = mkTerm "acidulated_A" ;
lin acidulous_A = mkTerm "acidulous_A" ;
lin acinar_A = mkTerm "acinar_A" ;
lin acinus_N = mkTerm "acinus_N" ;
lin ack_ack_N = mkTerm "ack_ack_N" ;
lin ackee_N = mkTerm "ackee_N" ;
lin acknowledge_V2 = mkTerm "acknowledge_V2" ;
lin acknowledge_VS = mkTerm "acknowledge_VS" ;
lin acknowledgeable_A = mkTerm "acknowledgeable_A" ;
lin acknowledgement_N = mkTerm "acknowledgement_N" ;
lin acme_N = mkTerm "acme_N" ;
lin acne_N = mkTerm "acne_N" ;
lin acned_A = mkTerm "acned_A" ;
lin acneiform_A = mkTerm "acneiform_A" ;
lin acold_A = mkTerm "acold_A" ;
lin acolyte_N = mkTerm "acolyte_N" ;
lin aconite_N = mkTerm "aconite_N" ;
lin acorea_N = mkTerm "acorea_N" ;
lin acorn_N = mkTerm "acorn_N" ;
lin acorn_cup_N = mkTerm "acorn_cup_N" ;
lin acoustic_A = mkTerm "acoustic_A" ;
lin acoustic_N = mkTerm "acoustic_N" ;
lin acoustician_N = mkTerm "acoustician_N" ;
lin acoustics_N = mkTerm "acoustics_N" ;
lin acquaint_V2 = mkTerm "acquaint_V2" ;
lin acquaintance_N = mkTerm "acquaintance_N" ;
lin acquaintanceship_N = mkTerm "acquaintanceship_N" ;
lin acquiesce_V = mkTerm "acquiesce_V" ;
lin acquiescence_N = mkTerm "acquiescence_N" ;
lin acquiescent_A = mkTerm "acquiescent_A" ;
lin acquirable_A = mkTerm "acquirable_A" ;
lin acquire_V2 = mkTerm "acquire_V2" ;
lin acquirement_N = mkTerm "acquirement_N" ;
lin acquirer_N = mkTerm "acquirer_N" ;
lin acquiring_N = mkTerm "acquiring_N" ;
lin acquisition_N = mkTerm "acquisition_N" ;
lin acquisitive_A = mkTerm "acquisitive_A" ;
lin acquisitiveness_N = mkTerm "acquisitiveness_N" ;
lin acquit_V2 = mkTerm "acquit_V2" ;
lin acquittal_N = mkTerm "acquittal_N" ;
lin acquittance_N = mkTerm "acquittance_N" ;
lin acre_N = mkTerm "acre_N" ;
lin acreage_N = mkTerm "acreage_N" ;
lin acrid_A = mkTerm "acrid_A" ;
lin acridity_N = mkTerm "acridity_N" ;
lin acrimonious_A = mkTerm "acrimonious_A" ;
lin acrimony_N = mkTerm "acrimony_N" ;
lin acritical_A = mkTerm "acritical_A" ;
lin acroanesthesia_N = mkTerm "acroanesthesia_N" ;
lin acrobatFem_N = mkTerm "acrobatFem_N" ;
lin acrobatMasc_N = mkTerm "acrobatMasc_N" ;
lin acrobatic_A = mkTerm "acrobatic_A" ;
lin acrobatics_N = mkTerm "acrobatics_N" ;
lin acrocarp_N = mkTerm "acrocarp_N" ;
lin acrocarpous_A = mkTerm "acrocarpous_A" ;
lin acrocentric_A = mkTerm "acrocentric_A" ;
lin acrocyanosis_N = mkTerm "acrocyanosis_N" ;
lin acrodont_N = mkTerm "acrodont_N" ;
lin acrogen_N = mkTerm "acrogen_N" ;
lin acrogenic_A = mkTerm "acrogenic_A" ;
lin acromegalic_A = mkTerm "acromegalic_A" ;
lin acromegaly_N = mkTerm "acromegaly_N" ;
lin acromicria_N = mkTerm "acromicria_N" ;
lin acromion_N = mkTerm "acromion_N" ;
lin acromphalus_N = mkTerm "acromphalus_N" ;
lin acromyotonia_N = mkTerm "acromyotonia_N" ;
lin acronym_N = mkTerm "acronym_N" ;
lin acronymic_A = mkTerm "acronymic_A" ;
lin acropetal_A = mkTerm "acropetal_A" ;
lin acrophobia_N = mkTerm "acrophobia_N" ;
lin acrophobic_A = mkTerm "acrophobic_A" ;
lin acrophony_N = mkTerm "acrophony_N" ;
lin acropolis_N = mkTerm "acropolis_N" ;
lin acroscopic_A = mkTerm "acroscopic_A" ;
lin acrosome_N = mkTerm "acrosome_N" ;
lin across_Adv = mkTerm "across_Adv" ;
lin across_Prep = mkTerm "across_Prep" ;
lin acrostic_N = mkTerm "acrostic_N" ;
lin acrylamide_N = mkTerm "acrylamide_N" ;
lin acrylic_N = mkTerm "acrylic_N" ;
lin act_N = mkTerm "act_N" ;
lin act_V = mkTerm "act_V" ;
lin act_V2 = mkTerm "act_V2" ;
lin act_on_V2 = mkTerm "act_on_V2" ;
lin act_out_V2 = mkTerm "act_out_V2" ;
lin act_up_V = mkTerm "act_up_V" ;
lin act_upon_V2 = mkTerm "act_upon_V2" ;
lin actable_A = mkTerm "actable_A" ;
lin actin_N = mkTerm "actin_N" ;
lin actinal_A = mkTerm "actinal_A" ;
lin acting_A = mkTerm "acting_A" ;
lin acting_N = mkTerm "acting_N" ;
lin actinia_N = mkTerm "actinia_N" ;
lin actinic_A = mkTerm "actinic_A" ;
lin actinism_N = mkTerm "actinism_N" ;
lin actinium_N = mkTerm "actinium_N" ;
lin actinoid_A = mkTerm "actinoid_A" ;
lin actinoid_N = mkTerm "actinoid_N" ;
lin actinolite_N = mkTerm "actinolite_N" ;
lin actinometer_N = mkTerm "actinometer_N" ;
lin actinometric_A = mkTerm "actinometric_A" ;
lin actinometry_N = mkTerm "actinometry_N" ;
lin actinomorphic_A = mkTerm "actinomorphic_A" ;
lin actinomyces_N = mkTerm "actinomyces_N" ;
lin actinomycetal_A = mkTerm "actinomycetal_A" ;
lin actinomycete_N = mkTerm "actinomycete_N" ;
lin actinomycin_N = mkTerm "actinomycin_N" ;
lin actinomycosis_N = mkTerm "actinomycosis_N" ;
lin actinomycotic_A = mkTerm "actinomycotic_A" ;
lin actinomyxidian_N = mkTerm "actinomyxidian_N" ;
lin actinopod_N = mkTerm "actinopod_N" ;
lin action_N = mkTerm "action_N" ;
lin actionable_A = mkTerm "actionable_A" ;
lin activate_V2 = mkTerm "activate_V2" ;
lin activation_N = mkTerm "activation_N" ;
lin activator_N = mkTerm "activator_N" ;
lin active_A = mkTerm "active_A" ;
lin active_N = mkTerm "active_N" ;
lin activeness_N = mkTerm "activeness_N" ;
lin activism_N = mkTerm "activism_N" ;
lin activistFem_N = mkTerm "activistFem_N" ;
lin activistMasc_N = mkTerm "activistMasc_N" ;
lin activist_A = mkTerm "activist_A" ;
lin activity_N = mkTerm "activity_N" ;
lin actomyosin_N = mkTerm "actomyosin_N" ;
lin actor_1_N = mkTerm "actor_1_N" ;
lin actor_2_N = mkTerm "actor_2_N" ;
lin actress_N = mkTerm "actress_N" ;
lin actual_A = mkTerm "actual_A" ;
lin actuality_N = mkTerm "actuality_N" ;
lin actually_Adv = mkTerm "actually_Adv" ;
lin actuarial_A = mkTerm "actuarial_A" ;
lin actuary_N = mkTerm "actuary_N" ;
lin actuate_V2 = mkTerm "actuate_V2" ;
lin actuator_N = mkTerm "actuator_N" ;
lin acuate_A = mkTerm "acuate_A" ;
lin acuity_N = mkTerm "acuity_N" ;
lin aculea_N = mkTerm "aculea_N" ;
lin aculeate_A = mkTerm "aculeate_A" ;
lin aculeus_N = mkTerm "aculeus_N" ;
lin acumen_N = mkTerm "acumen_N" ;
lin acuminate_A = mkTerm "acuminate_A" ;
lin acupressure_N = mkTerm "acupressure_N" ;
lin acupuncture_N = mkTerm "acupuncture_N" ;
lin acute_A = mkTerm "acute_A" ;
lin acuteness_N = mkTerm "acuteness_N" ;
lin acyclic_A = mkTerm "acyclic_A" ;
lin acyclovir_N = mkTerm "acyclovir_N" ;
lin acyl_N = mkTerm "acyl_N" ;
lin acylation_N = mkTerm "acylation_N" ;
lin ad_N = mkTerm "ad_N" ;
lin ad_PN = mkTerm "ad_PN" ;
lin ad_hoc_A = mkTerm "ad_hoc_A" ;
lin ad_hoc_Adv = mkTerm "ad_hoc_Adv" ;
lin ad_infinitum_Adv = mkTerm "ad_infinitum_Adv" ;
lin ad_interim_Adv = mkTerm "ad_interim_Adv" ;
lin ad_lib_A = mkTerm "ad_lib_A" ;
lin ad_lib_Adv = mkTerm "ad_lib_Adv" ;
lin ad_lib_V = mkTerm "ad_lib_V" ;
lin ad_libitum_Adv = mkTerm "ad_libitum_Adv" ;
lin ad_man_N = mkTerm "ad_man_N" ;
lin ad_nauseam_Adv = mkTerm "ad_nauseam_Adv" ;
lin ad_valorem_Adv = mkTerm "ad_valorem_Adv" ;
lin ada_PN = mkTerm "ada_PN" ;
lin adactylia_N = mkTerm "adactylia_N" ;
lin adactylous_A = mkTerm "adactylous_A" ;
lin adage_N = mkTerm "adage_N" ;
lin adagio_A = mkTerm "adagio_A" ;
lin adagio_Adv = mkTerm "adagio_Adv" ;
lin adagio_N = mkTerm "adagio_N" ;
lin adam_PN = mkTerm "adam_PN" ;
lin adamance_N = mkTerm "adamance_N" ;
lin adamant_A = mkTerm "adamant_A" ;
lin adamant_N = mkTerm "adamant_N" ;
lin adamantine_A = mkTerm "adamantine_A" ;
lin adapt_V = mkTerm "adapt_V" ;
lin adapt_V2 = mkTerm "adapt_V2" ;
lin adaptability_N = mkTerm "adaptability_N" ;
lin adaptable_A = mkTerm "adaptable_A" ;
lin adaptation_N = mkTerm "adaptation_N" ;
lin adaptational_A = mkTerm "adaptational_A" ;
lin adapter_N = mkTerm "adapter_N" ;
lin adaptive_A = mkTerm "adaptive_A" ;
lin adaptor_N = mkTerm "adaptor_N" ;
lin adaxial_A = mkTerm "adaxial_A" ;
lin add_V = mkTerm "add_V" ;
lin add_V2 = mkTerm "add_V2" ;
lin add_VS = mkTerm "add_VS" ;
lin add_in_V = mkTerm "add_in_V" ;
lin add_on_to_V2 = mkTerm "add_on_to_V2" ;
lin add_up_V = mkTerm "add_up_V" ;
lin add_up_V2 = mkTerm "add_up_V2" ;
lin add_up_to_V2 = mkTerm "add_up_to_V2" ;
lin addable_A = mkTerm "addable_A" ;
lin addax_N = mkTerm "addax_N" ;
lin added_A = mkTerm "added_A" ;
lin addend_N = mkTerm "addend_N" ;
lin addendum_N = mkTerm "addendum_N" ;
lin adder_N = mkTerm "adder_N" ;
lin addict_N = mkTerm "addict_N" ;
lin addict_V2 = mkTerm "addict_V2" ;
lin addiction_N = mkTerm "addiction_N" ;
lin addictive_A = mkTerm "addictive_A" ;
lin adding_machine_N = mkTerm "adding_machine_N" ;
lin addis_ababa_PN = mkTerm "addis_ababa_PN" ;
lin addition_N = mkTerm "addition_N" ;
lin additional_A = mkTerm "additional_A" ;
lin additionally_Adv = mkTerm "additionally_Adv" ;
lin additive_A = mkTerm "additive_A" ;
lin additive_N = mkTerm "additive_N" ;
lin addle_A = mkTerm "addle_A" ;
lin addle_V = mkTerm "addle_V" ;
lin addle_V2 = mkTerm "addle_V2" ;
lin addle_brained_A = mkTerm "addle_brained_A" ;
lin addle_head_N = mkTerm "addle_head_N" ;
lin addle_pated_A = mkTerm "addle_pated_A" ;
lin address_N = mkTerm "address_N" ;
lin address_V2 = mkTerm "address_V2" ;
lin addressable_A = mkTerm "addressable_A" ;
lin addressee_N = mkTerm "addressee_N" ;
lin addressograph_N = mkTerm "addressograph_N" ;
lin adduce_V2 = mkTerm "adduce_V2" ;
lin adducent_A = mkTerm "adducent_A" ;
lin adducer_N = mkTerm "adducer_N" ;
lin adducing_N = mkTerm "adducing_N" ;
lin adduct_N = mkTerm "adduct_N" ;
lin adduction_N = mkTerm "adduction_N" ;
lin adductor_N = mkTerm "adductor_N" ;
lin adelaide_PN = mkTerm "adelaide_PN" ;
lin adelgid_N = mkTerm "adelgid_N" ;
lin adenine_N = mkTerm "adenine_N" ;
lin adenitis_N = mkTerm "adenitis_N" ;
lin adenocarcinoma_N = mkTerm "adenocarcinoma_N" ;
lin adenocarcinomatous_A = mkTerm "adenocarcinomatous_A" ;
lin adenoid_A = mkTerm "adenoid_A" ;
lin adenoidal_A = mkTerm "adenoidal_A" ;
lin adenoidectomy_N = mkTerm "adenoidectomy_N" ;
lin adenoma_N = mkTerm "adenoma_N" ;
lin adenomegaly_N = mkTerm "adenomegaly_N" ;
lin adenopathy_N = mkTerm "adenopathy_N" ;
lin adenosine_N = mkTerm "adenosine_N" ;
lin adenovirus_N = mkTerm "adenovirus_N" ;
lin adept_A = mkTerm "adept_A" ;
lin adept_N = mkTerm "adept_N" ;
lin adeptness_N = mkTerm "adeptness_N" ;
lin adequacy_N = mkTerm "adequacy_N" ;
lin adequate_A = mkTerm "adequate_A" ;
lin adesite_N = mkTerm "adesite_N" ;
lin adhere_V = mkTerm "adhere_V" ;
lin adherence_N = mkTerm "adherence_N" ;
lin adherent_A = mkTerm "adherent_A" ;
lin adherent_N = mkTerm "adherent_N" ;
lin adhesion_N = mkTerm "adhesion_N" ;
lin adhesive_A = mkTerm "adhesive_A" ;
lin adhesive_N = mkTerm "adhesive_N" ;
lin adhesiveness_N = mkTerm "adhesiveness_N" ;
lin adhocracy_N = mkTerm "adhocracy_N" ;
lin adiabatic_A = mkTerm "adiabatic_A" ;
lin adience_N = mkTerm "adience_N" ;
lin adient_A = mkTerm "adient_A" ;
lin adieu_N = mkTerm "adieu_N" ;
lin adipose_A = mkTerm "adipose_A" ;
lin adiposity_N = mkTerm "adiposity_N" ;
lin adit_N = mkTerm "adit_N" ;
lin adjacency_N = mkTerm "adjacency_N" ;
lin adjacent_A = mkTerm "adjacent_A" ;
lin adjectival_A = mkTerm "adjectival_A" ;
lin adjective_A = mkTerm "adjective_A" ;
lin adjective_N = mkTerm "adjective_N" ;
lin adjoin_V = mkTerm "adjoin_V" ;
lin adjoin_V2 = mkTerm "adjoin_V2" ;
lin adjourn_V = mkTerm "adjourn_V" ;
lin adjourn_V2 = mkTerm "adjourn_V2" ;
lin adjournment_N = mkTerm "adjournment_N" ;
lin adjudge_V2 = mkTerm "adjudge_V2" ;
lin adjudicate_V = mkTerm "adjudicate_V" ;
lin adjudicate_V2 = mkTerm "adjudicate_V2" ;
lin adjudication_N = mkTerm "adjudication_N" ;
lin adjudicative_A = mkTerm "adjudicative_A" ;
lin adjudicator_N = mkTerm "adjudicator_N" ;
lin adjunct_A = mkTerm "adjunct_A" ;
lin adjunct_N = mkTerm "adjunct_N" ;
lin adjunctive_A = mkTerm "adjunctive_A" ;
lin adjuration_N = mkTerm "adjuration_N" ;
lin adjuratory_A = mkTerm "adjuratory_A" ;
lin adjure_V2 = mkTerm "adjure_V2" ;
lin adjust_V = mkTerm "adjust_V" ;
lin adjust_V2 = mkTerm "adjust_V2" ;
lin adjustable_A = mkTerm "adjustable_A" ;
lin adjuster_N = mkTerm "adjuster_N" ;
lin adjustive_A = mkTerm "adjustive_A" ;
lin adjustment_N = mkTerm "adjustment_N" ;
lin adjutant_N = mkTerm "adjutant_N" ;
lin adjuvant_A = mkTerm "adjuvant_A" ;
lin adjuvant_N = mkTerm "adjuvant_N" ;
lin admass_N = mkTerm "admass_N" ;
lin administer_V = mkTerm "administer_V" ;
lin administer_V2 = mkTerm "administer_V2" ;
lin administrable_A = mkTerm "administrable_A" ;
lin administration_N = mkTerm "administration_N" ;
lin administrative_A = mkTerm "administrative_A" ;
lin administratorFem_N = mkTerm "administratorFem_N" ;
lin administratorMasc_N = mkTerm "administratorMasc_N" ;
lin administrivia_N = mkTerm "administrivia_N" ;
lin admirability_N = mkTerm "admirability_N" ;
lin admirable_A = mkTerm "admirable_A" ;
lin admiral_N = mkTerm "admiral_N" ;
lin admiralty_N = mkTerm "admiralty_N" ;
lin admiration_N = mkTerm "admiration_N" ;
lin admire_V2 = mkTerm "admire_V2" ;
lin admirer_N = mkTerm "admirer_N" ;
lin admiringly_Adv = mkTerm "admiringly_Adv" ;
lin admissibility_N = mkTerm "admissibility_N" ;
lin admissible_A = mkTerm "admissible_A" ;
lin admission_N = mkTerm "admission_N" ;
lin admissive_A = mkTerm "admissive_A" ;
lin admit_V = mkTerm "admit_V" ;
lin admit_V2 = mkTerm "admit_V2" ;
lin admit_VS = mkTerm "admit_VS" ;
lin admittable_A = mkTerm "admittable_A" ;
lin admittance_N = mkTerm "admittance_N" ;
lin admittedly_Adv = mkTerm "admittedly_Adv" ;
lin admix_V = mkTerm "admix_V" ;
lin admix_V2 = mkTerm "admix_V2" ;
lin admixture_N = mkTerm "admixture_N" ;
lin admonish_V2 = mkTerm "admonish_V2" ;
lin admonisher_N = mkTerm "admonisher_N" ;
lin admonition_N = mkTerm "admonition_N" ;
lin admonitory_A = mkTerm "admonitory_A" ;
lin adnate_A = mkTerm "adnate_A" ;
lin adnexa_N = mkTerm "adnexa_N" ;
lin adnexal_A = mkTerm "adnexal_A" ;
lin adnoun_N = mkTerm "adnoun_N" ;
lin ado_N = mkTerm "ado_N" ;
lin adobe_N = mkTerm "adobe_N" ;
lin adobo_N = mkTerm "adobo_N" ;
lin adolescence_N = mkTerm "adolescence_N" ;
lin adolescent_A = mkTerm "adolescent_A" ;
lin adolescent_N = mkTerm "adolescent_N" ;
lin adonis_N = mkTerm "adonis_N" ;
lin adopt_V2 = mkTerm "adopt_V2" ;
lin adoptable_A = mkTerm "adoptable_A" ;
lin adoptee_N = mkTerm "adoptee_N" ;
lin adoption_N = mkTerm "adoption_N" ;
lin adoptive_A = mkTerm "adoptive_A" ;
lin adorability_N = mkTerm "adorability_N" ;
lin adorable_A = mkTerm "adorable_A" ;
lin adoration_N = mkTerm "adoration_N" ;
lin adore_V2 = mkTerm "adore_V2" ;
lin adorer_N = mkTerm "adorer_N" ;
lin adoring_A = mkTerm "adoring_A" ;
lin adorn_V2 = mkTerm "adorn_V2" ;
lin adornment_N = mkTerm "adornment_N" ;
lin adoxography_N = mkTerm "adoxography_N" ;
lin adrenal_A = mkTerm "adrenal_A" ;
lin adrenalectomy_N = mkTerm "adrenalectomy_N" ;
lin adrenalin_N = mkTerm "adrenalin_N" ;
lin adrenarche_N = mkTerm "adrenarche_N" ;
lin adrenergic_A = mkTerm "adrenergic_A" ;
lin adrenergic_N = mkTerm "adrenergic_N" ;
lin adrenocortical_A = mkTerm "adrenocortical_A" ;
lin adrenocorticotropic_A = mkTerm "adrenocorticotropic_A" ;
lin adrenosterone_N = mkTerm "adrenosterone_N" ;
lin adrian_PN = mkTerm "adrian_PN" ;
lin adrift_A = mkTerm "adrift_A" ;
lin adrift_Adv = mkTerm "adrift_Adv" ;
lin adroit_A = mkTerm "adroit_A" ;
lin adroitness_N = mkTerm "adroitness_N" ;
lin adscititious_A = mkTerm "adscititious_A" ;
lin adscript_A = mkTerm "adscript_A" ;
lin adsorbable_A = mkTerm "adsorbable_A" ;
lin adsorbate_N = mkTerm "adsorbate_N" ;
lin adsorbent_A = mkTerm "adsorbent_A" ;
lin adsorbent_N = mkTerm "adsorbent_N" ;
lin adsorption_N = mkTerm "adsorption_N" ;
lin adulation_N = mkTerm "adulation_N" ;
lin adulatory_A = mkTerm "adulatory_A" ;
lin adult_A = mkTerm "adult_A" ;
lin adult_N = mkTerm "adult_N" ;
lin adulterant_N = mkTerm "adulterant_N" ;
lin adulterate_A = mkTerm "adulterate_A" ;
lin adulterate_V2 = mkTerm "adulterate_V2" ;
lin adulterating_A = mkTerm "adulterating_A" ;
lin adulteration_N = mkTerm "adulteration_N" ;
lin adulterator_N = mkTerm "adulterator_N" ;
lin adulterer_N = mkTerm "adulterer_N" ;
lin adulteress_N = mkTerm "adulteress_N" ;
lin adulterine_A = mkTerm "adulterine_A" ;
lin adulterous_A = mkTerm "adulterous_A" ;
lin adultery_N = mkTerm "adultery_N" ;
lin adulthood_N = mkTerm "adulthood_N" ;
lin adumbrate_V2 = mkTerm "adumbrate_V2" ;
lin adumbration_N = mkTerm "adumbration_N" ;
lin adumbrative_A = mkTerm "adumbrative_A" ;
lin adust_A = mkTerm "adust_A" ;
lin advance_N = mkTerm "advance_N" ;
lin advance_V = mkTerm "advance_V" ;
lin advance_V2 = mkTerm "advance_V2" ;
lin advanced_A = mkTerm "advanced_A" ;
lin advancement_N = mkTerm "advancement_N" ;
lin advancer_N = mkTerm "advancer_N" ;
lin advantage_N = mkTerm "advantage_N" ;
lin advantage_V2 = mkTerm "advantage_V2" ;
lin advantageous_A = mkTerm "advantageous_A" ;
lin advection_N = mkTerm "advection_N" ;
lin advective_A = mkTerm "advective_A" ;
lin advent_N = mkTerm "advent_N" ;
lin adventistFem_N = mkTerm "adventistFem_N" ;
lin adventistMasc_N = mkTerm "adventistMasc_N" ;
lin adventitial_A = mkTerm "adventitial_A" ;
lin adventitious_A = mkTerm "adventitious_A" ;
lin adventive_A = mkTerm "adventive_A" ;
lin adventure_N = mkTerm "adventure_N" ;
lin adventure_V2 = mkTerm "adventure_V2" ;
lin adventurer_N = mkTerm "adventurer_N" ;
lin adventuresome_A = mkTerm "adventuresome_A" ;
lin adventuress_N = mkTerm "adventuress_N" ;
lin adventurism_N = mkTerm "adventurism_N" ;
lin adventuristic_A = mkTerm "adventuristic_A" ;
lin adventurous_A = mkTerm "adventurous_A" ;
lin adventurousness_N = mkTerm "adventurousness_N" ;
lin adverb_N = mkTerm "adverb_N" ;
lin adverbial_A = mkTerm "adverbial_A" ;
lin adverbial_N = mkTerm "adverbial_N" ;
lin adversary_N = mkTerm "adversary_N" ;
lin adversative_A = mkTerm "adversative_A" ;
lin adverse_A = mkTerm "adverse_A" ;
lin adversity_N = mkTerm "adversity_N" ;
lin advert_N = mkTerm "advert_N" ;
lin advert_V = mkTerm "advert_V" ;
lin advertence_N = mkTerm "advertence_N" ;
lin advertent_A = mkTerm "advertent_A" ;
lin advertise_V = mkTerm "advertise_V" ;
lin advertise_V2 = mkTerm "advertise_V2" ;
lin advertisement_N = mkTerm "advertisement_N" ;
lin advertiser_N = mkTerm "advertiser_N" ;
lin advertising_N = mkTerm "advertising_N" ;
lin advertorial_N = mkTerm "advertorial_N" ;
lin advice_N = mkTerm "advice_N" ;
lin advisability_N = mkTerm "advisability_N" ;
lin advisable_A = mkTerm "advisable_A" ;
lin advise_V = mkTerm "advise_V" ;
lin advise_V2 = mkTerm "advise_V2" ;
lin advise_VS = mkTerm "advise_VS" ;
lin advisee_N = mkTerm "advisee_N" ;
lin adviserFem_N = mkTerm "adviserFem_N" ;
lin adviserMasc_N = mkTerm "adviserMasc_N" ;
lin advisor_N = mkTerm "advisor_N" ;
lin advisory_A = mkTerm "advisory_A" ;
lin advisory_N = mkTerm "advisory_N" ;
lin advocacy_N = mkTerm "advocacy_N" ;
lin advocateFem_N = mkTerm "advocateFem_N" ;
lin advocateMasc_N = mkTerm "advocateMasc_N" ;
lin advocate_V2 = mkTerm "advocate_V2" ;
lin advocate_VS = mkTerm "advocate_VS" ;
lin advowson_N = mkTerm "advowson_N" ;
lin adynamia_N = mkTerm "adynamia_N" ;
lin adynamic_A = mkTerm "adynamic_A" ;
lin adz_N = mkTerm "adz_N" ;
lin adze_N = mkTerm "adze_N" ;
lin aecial_A = mkTerm "aecial_A" ;
lin aeciospore_N = mkTerm "aeciospore_N" ;
lin aecium_N = mkTerm "aecium_N" ;
lin aegis_N = mkTerm "aegis_N" ;
lin aeolotropic_A = mkTerm "aeolotropic_A" ;
lin aeon_N = mkTerm "aeon_N" ;
lin aerate_V2 = mkTerm "aerate_V2" ;
lin aeration_N = mkTerm "aeration_N" ;
lin aerator_N = mkTerm "aerator_N" ;
lin aerial_A = mkTerm "aerial_A" ;
lin aerial_N = mkTerm "aerial_N" ;
lin aerialist_N = mkTerm "aerialist_N" ;
lin aerides_N = mkTerm "aerides_N" ;
lin aerie_N = mkTerm "aerie_N" ;
lin aeriferous_A = mkTerm "aeriferous_A" ;
lin aeriform_A = mkTerm "aeriform_A" ;
lin aerobatics_N = mkTerm "aerobatics_N" ;
lin aerobe_N = mkTerm "aerobe_N" ;
lin aerobic_A = mkTerm "aerobic_A" ;
lin aerobics_N = mkTerm "aerobics_N" ;
lin aerobiosis_N = mkTerm "aerobiosis_N" ;
lin aerobiotic_A = mkTerm "aerobiotic_A" ;
lin aerodontalgia_N = mkTerm "aerodontalgia_N" ;
lin aerodrome_N = mkTerm "aerodrome_N" ;
lin aerodynamic_A = mkTerm "aerodynamic_A" ;
lin aerodynamics_N = mkTerm "aerodynamics_N" ;
lin aerolite_N = mkTerm "aerolite_N" ;
lin aerolitic_A = mkTerm "aerolitic_A" ;
lin aerological_A = mkTerm "aerological_A" ;
lin aerology_N = mkTerm "aerology_N" ;
lin aeromechanic_A = mkTerm "aeromechanic_A" ;
lin aeromechanics_N = mkTerm "aeromechanics_N" ;
lin aeromedical_A = mkTerm "aeromedical_A" ;
lin aeromedicine_N = mkTerm "aeromedicine_N" ;
lin aeronaut_N = mkTerm "aeronaut_N" ;
lin aeronautical_A = mkTerm "aeronautical_A" ;
lin aeronautics_N = mkTerm "aeronautics_N" ;
lin aerophagia_N = mkTerm "aerophagia_N" ;
lin aerophilatelic_A = mkTerm "aerophilatelic_A" ;
lin aerophilately_N = mkTerm "aerophilately_N" ;
lin aerophile_N = mkTerm "aerophile_N" ;
lin aeroplane_N = mkTerm "aeroplane_N" ;
lin aerosol_N = mkTerm "aerosol_N" ;
lin aerosolized_A = mkTerm "aerosolized_A" ;
lin aerospace_A = mkTerm "aerospace_A" ;
lin aerospace_N = mkTerm "aerospace_N" ;
lin aertex_N = mkTerm "aertex_N" ;
lin aery_N = mkTerm "aery_N" ;
lin aeschynanthus_N = mkTerm "aeschynanthus_N" ;
lin aesculapian_A = mkTerm "aesculapian_A" ;
lin aestheteFem_N = mkTerm "aestheteFem_N" ;
lin aestheteMasc_N = mkTerm "aestheteMasc_N" ;
lin aesthetic_A = mkTerm "aesthetic_A" ;
lin aesthetic_N = mkTerm "aesthetic_N" ;
lin aesthetical_A = mkTerm "aesthetical_A" ;
lin aesthetics_N = mkTerm "aesthetics_N" ;
lin aestival_A = mkTerm "aestival_A" ;
lin aether_N = mkTerm "aether_N" ;
lin aetiology_N = mkTerm "aetiology_N" ;
lin afar_Adv = mkTerm "afar_Adv" ;
lin afebrile_A = mkTerm "afebrile_A" ;
lin affability_N = mkTerm "affability_N" ;
lin affable_A = mkTerm "affable_A" ;
lin affair_N = mkTerm "affair_N" ;
lin affairs_N = mkTerm "affairs_N" ;
lin affect_N = mkTerm "affect_N" ;
lin affect_V2 = mkTerm "affect_V2" ;
lin affectation_N = mkTerm "affectation_N" ;
lin affected_A = mkTerm "affected_A" ;
lin affectedness_N = mkTerm "affectedness_N" ;
lin affecting_A = mkTerm "affecting_A" ;
lin affection_N = mkTerm "affection_N" ;
lin affectional_A = mkTerm "affectional_A" ;
lin affectionate_A = mkTerm "affectionate_A" ;
lin affectionateness_N = mkTerm "affectionateness_N" ;
lin affenpinscher_N = mkTerm "affenpinscher_N" ;
lin afferent_A = mkTerm "afferent_A" ;
lin affiance_V2 = mkTerm "affiance_V2" ;
lin affiant_N = mkTerm "affiant_N" ;
lin affidavit_N = mkTerm "affidavit_N" ;
lin affiliate_N = mkTerm "affiliate_N" ;
lin affiliate_V = mkTerm "affiliate_V" ;
lin affiliate_V2 = mkTerm "affiliate_V2" ;
lin affiliation_N = mkTerm "affiliation_N" ;
lin affinal_A = mkTerm "affinal_A" ;
lin affine_A = mkTerm "affine_A" ;
lin affine_N = mkTerm "affine_N" ;
lin affined_A = mkTerm "affined_A" ;
lin affinity_N = mkTerm "affinity_N" ;
lin affirm_V = mkTerm "affirm_V" ;
lin affirm_V2 = mkTerm "affirm_V2" ;
lin affirm_VS = mkTerm "affirm_VS" ;
lin affirmable_A = mkTerm "affirmable_A" ;
lin affirmation_N = mkTerm "affirmation_N" ;
lin affirmative_A = mkTerm "affirmative_A" ;
lin affirmative_N = mkTerm "affirmative_N" ;
lin affirmativeness_N = mkTerm "affirmativeness_N" ;
lin affix_N = mkTerm "affix_N" ;
lin affix_V2 = mkTerm "affix_V2" ;
lin affixal_A = mkTerm "affixal_A" ;
lin affixation_N = mkTerm "affixation_N" ;
lin afflatus_N = mkTerm "afflatus_N" ;
lin afflict_V2 = mkTerm "afflict_V2" ;
lin affliction_N = mkTerm "affliction_N" ;
lin afflictive_A = mkTerm "afflictive_A" ;
lin affluence_N = mkTerm "affluence_N" ;
lin affluent_A = mkTerm "affluent_A" ;
lin affluent_N = mkTerm "affluent_N" ;
lin afford_V2 = mkTerm "afford_V2" ;
lin afford_V2V = mkTerm "afford_V2V" ;
lin affordable_A = mkTerm "affordable_A" ;
lin afforest_V2 = mkTerm "afforest_V2" ;
lin afforestation_N = mkTerm "afforestation_N" ;
lin affranchise_V2 = mkTerm "affranchise_V2" ;
lin affray_N = mkTerm "affray_N" ;
lin affricate_N = mkTerm "affricate_N" ;
lin affrication_N = mkTerm "affrication_N" ;
lin affront_N = mkTerm "affront_N" ;
lin affront_V2 = mkTerm "affront_V2" ;
lin affusion_N = mkTerm "affusion_N" ;
lin afghanFem_N = mkTerm "afghanFem_N" ;
lin afghanMasc_N = mkTerm "afghanMasc_N" ;
lin afghan_A = mkTerm "afghan_A" ;
lin afghani_N = mkTerm "afghani_N" ;
lin afghanistan_PN = mkTerm "afghanistan_PN" ;
lin afghanistaniFem_N = mkTerm "afghanistaniFem_N" ;
lin afghanistaniMasc_N = mkTerm "afghanistaniMasc_N" ;
lin afghanistani_A = mkTerm "afghanistani_A" ;
lin afibrinogenemia_N = mkTerm "afibrinogenemia_N" ;
lin aficionado_N = mkTerm "aficionado_N" ;
lin afield_Adv = mkTerm "afield_Adv" ;
lin afire_A = mkTerm "afire_A" ;
lin aflame_A = mkTerm "aflame_A" ;
lin aflare_A = mkTerm "aflare_A" ;
lin aflatoxin_N = mkTerm "aflatoxin_N" ;
lin afloat_A = mkTerm "afloat_A" ;
lin aflutter_A = mkTerm "aflutter_A" ;
lin afoot_A = mkTerm "afoot_A" ;
lin afoot_Adv = mkTerm "afoot_Adv" ;
lin afore_Adv = mkTerm "afore_Adv" ;
lin afore_Prep = mkTerm "afore_Prep" ;
lin aforementioned_A = mkTerm "aforementioned_A" ;
lin aforesaid_A = mkTerm "aforesaid_A" ;
lin aforethought_Adv = mkTerm "aforethought_Adv" ;
lin afoul_Adv = mkTerm "afoul_Adv" ;
lin afraid_A = mkTerm "afraid_A" ;
lin afresh_Adv = mkTerm "afresh_Adv" ;
lin africa_PN = mkTerm "africa_PN" ;
lin africanFem_N = mkTerm "africanFem_N" ;
lin africanMasc_N = mkTerm "africanMasc_N" ;
lin african_A = mkTerm "african_A" ;
lin afrikanerFem_N = mkTerm "afrikanerFem_N" ;
lin afrikanerMasc_N = mkTerm "afrikanerMasc_N" ;
lin afrikaner_A = mkTerm "afrikaner_A" ;
lin afro_americanFem_N = mkTerm "afro_americanFem_N" ;
lin afro_americanMasc_N = mkTerm "afro_americanMasc_N" ;
lin afro_asian_A = mkTerm "afro_asian_A" ;
lin afro_wig_N = mkTerm "afro_wig_N" ;
lin afropavo_N = mkTerm "afropavo_N" ;
lin aft_A = mkTerm "aft_A" ;
lin aft_Adv = mkTerm "aft_Adv" ;
lin after_A = mkTerm "after_A" ;
lin after_Adv = mkTerm "after_Adv" ;
lin after_Subj = mkTerm "after_Subj" ;
lin afterbirth_N = mkTerm "afterbirth_N" ;
lin afterburner_N = mkTerm "afterburner_N" ;
lin aftercare_N = mkTerm "aftercare_N" ;
lin afterdamp_N = mkTerm "afterdamp_N" ;
lin afterdeck_N = mkTerm "afterdeck_N" ;
lin aftereffect_N = mkTerm "aftereffect_N" ;
lin afterglow_N = mkTerm "afterglow_N" ;
lin afterimage_N = mkTerm "afterimage_N" ;
lin afterlife_N = mkTerm "afterlife_N" ;
lin aftermath_N = mkTerm "aftermath_N" ;
lin aftermost_A = mkTerm "aftermost_A" ;
lin afternoon_N = mkTerm "afternoon_N" ;
lin afterpains_N = mkTerm "afterpains_N" ;
lin afterpiece_N = mkTerm "afterpiece_N" ;
lin aftershaft_N = mkTerm "aftershaft_N" ;
lin aftershafted_A = mkTerm "aftershafted_A" ;
lin aftershock_N = mkTerm "aftershock_N" ;
lin aftertaste_N = mkTerm "aftertaste_N" ;
lin afterthought_N = mkTerm "afterthought_N" ;
lin afterwards_Adv = mkTerm "afterwards_Adv" ;
lin afterworld_N = mkTerm "afterworld_N" ;
lin again_Adv = mkTerm "again_Adv" ;
lin against_Prep = mkTerm "against_Prep" ;
lin agal_N = mkTerm "agal_N" ;
lin agalactia_N = mkTerm "agalactia_N" ;
lin agama_N = mkTerm "agama_N" ;
lin agamete_N = mkTerm "agamete_N" ;
lin agamic_A = mkTerm "agamic_A" ;
lin agamid_N = mkTerm "agamid_N" ;
lin agammaglobulinemia_N = mkTerm "agammaglobulinemia_N" ;
lin agapanthus_N = mkTerm "agapanthus_N" ;
lin agape_A = mkTerm "agape_A" ;
lin agape_N = mkTerm "agape_N" ;
lin agar_N = mkTerm "agar_N" ;
lin agar_agar_N = mkTerm "agar_agar_N" ;
lin agaric_N = mkTerm "agaric_N" ;
lin agate_N = mkTerm "agate_N" ;
lin agateware_N = mkTerm "agateware_N" ;
lin agatha_PN = mkTerm "agatha_PN" ;
lin agave_N = mkTerm "agave_N" ;
lin agaze_A = mkTerm "agaze_A" ;
lin age_N = mkTerm "age_N" ;
lin age_V = mkTerm "age_V" ;
lin age_bracket_N = mkTerm "age_bracket_N" ;
lin age_group_N = mkTerm "age_group_N" ;
lin age_long_A = mkTerm "age_long_A" ;
lin age_old_A = mkTerm "age_old_A" ;
lin aged_N = mkTerm "aged_N" ;
lin aged_Prep = mkTerm "aged_Prep" ;
lin agedness_N = mkTerm "agedness_N" ;
lin ageing_N = mkTerm "ageing_N" ;
lin ageism_N = mkTerm "ageism_N" ;
lin ageless_A = mkTerm "ageless_A" ;
lin agelessness_N = mkTerm "agelessness_N" ;
lin agency_N = mkTerm "agency_N" ;
lin agenda_N = mkTerm "agenda_N" ;
lin agenesis_N = mkTerm "agenesis_N" ;
lin agentFem_N = mkTerm "agentFem_N" ;
lin agentMasc_N = mkTerm "agentMasc_N" ;
lin agent_provocateur_N = mkTerm "agent_provocateur_N" ;
lin agential_A = mkTerm "agential_A" ;
lin agerasia_N = mkTerm "agerasia_N" ;
lin ageratum_N = mkTerm "ageratum_N" ;
lin aggie_PN = mkTerm "aggie_PN" ;
lin agglomerate_A = mkTerm "agglomerate_A" ;
lin agglomerate_N = mkTerm "agglomerate_N" ;
lin agglomerate_V = mkTerm "agglomerate_V" ;
lin agglomerate_V2 = mkTerm "agglomerate_V2" ;
lin agglomeration_N = mkTerm "agglomeration_N" ;
lin agglomerator_N = mkTerm "agglomerator_N" ;
lin agglutinate_A = mkTerm "agglutinate_A" ;
lin agglutinate_V2 = mkTerm "agglutinate_V2" ;
lin agglutination_N = mkTerm "agglutination_N" ;
lin agglutinative_A = mkTerm "agglutinative_A" ;
lin agglutinin_N = mkTerm "agglutinin_N" ;
lin agglutinogen_N = mkTerm "agglutinogen_N" ;
lin aggrandize_V2 = mkTerm "aggrandize_V2" ;
lin aggrandizement_N = mkTerm "aggrandizement_N" ;
lin aggravate_V2 = mkTerm "aggravate_V2" ;
lin aggravating_A = mkTerm "aggravating_A" ;
lin aggravation_N = mkTerm "aggravation_N" ;
lin aggravator_N = mkTerm "aggravator_N" ;
lin aggregate_A = mkTerm "aggregate_A" ;
lin aggregate_N = mkTerm "aggregate_N" ;
lin aggregate_V = mkTerm "aggregate_V" ;
lin aggregate_V2 = mkTerm "aggregate_V2" ;
lin aggregation_N = mkTerm "aggregation_N" ;
lin aggression_N = mkTerm "aggression_N" ;
lin aggressive_A = mkTerm "aggressive_A" ;
lin aggressiveness_N = mkTerm "aggressiveness_N" ;
lin aggressorFem_N = mkTerm "aggressorFem_N" ;
lin aggressorMasc_N = mkTerm "aggressorMasc_N" ;
lin aggrieve_V2 = mkTerm "aggrieve_V2" ;
lin aggro_N = mkTerm "aggro_N" ;
lin aghast_A = mkTerm "aghast_A" ;
lin agile_A = mkTerm "agile_A" ;
lin agility_N = mkTerm "agility_N" ;
lin agin_Prep = mkTerm "agin_Prep" ;
lin aging_N = mkTerm "aging_N" ;
lin agio_N = mkTerm "agio_N" ;
lin agitate_V = mkTerm "agitate_V" ;
lin agitate_V2 = mkTerm "agitate_V2" ;
lin agitation_N = mkTerm "agitation_N" ;
lin agitative_A = mkTerm "agitative_A" ;
lin agitator_N = mkTerm "agitator_N" ;
lin agitprop_N = mkTerm "agitprop_N" ;
lin agleam_A = mkTerm "agleam_A" ;
lin aglet_N = mkTerm "aglet_N" ;
lin aglow_A = mkTerm "aglow_A" ;
lin agm_N = mkTerm "agm_N" ;
lin agnail_N = mkTerm "agnail_N" ;
lin agnate_A = mkTerm "agnate_A" ;
lin agnate_N = mkTerm "agnate_N" ;
lin agnes_PN = mkTerm "agnes_PN" ;
lin agnomen_N = mkTerm "agnomen_N" ;
lin agnosia_N = mkTerm "agnosia_N" ;
lin agnostic_A = mkTerm "agnostic_A" ;
lin agnostic_N = mkTerm "agnostic_N" ;
lin agnosticism_N = mkTerm "agnosticism_N" ;
lin ago_Adv = mkTerm "ago_Adv" ;
lin ago_Prep = mkTerm "ago_Prep" ;
lin agog_A = mkTerm "agog_A" ;
lin agon_N = mkTerm "agon_N" ;
lin agonadal_A = mkTerm "agonadal_A" ;
lin agonal_A = mkTerm "agonal_A" ;
lin agonist_N = mkTerm "agonist_N" ;
lin agonistic_A = mkTerm "agonistic_A" ;
lin agonize_V = mkTerm "agonize_V" ;
lin agonized_A = mkTerm "agonized_A" ;
lin agonizingly_Adv = mkTerm "agonizingly_Adv" ;
lin agony_N = mkTerm "agony_N" ;
lin agora_N = mkTerm "agora_N" ;
lin agoraphobia_N = mkTerm "agoraphobia_N" ;
lin agoraphobic_A = mkTerm "agoraphobic_A" ;
lin agouti_N = mkTerm "agouti_N" ;
lin agra_PN = mkTerm "agra_PN" ;
lin agranulocytic_A = mkTerm "agranulocytic_A" ;
lin agranulocytosis_N = mkTerm "agranulocytosis_N" ;
lin agrapha_N = mkTerm "agrapha_N" ;
lin agraphia_N = mkTerm "agraphia_N" ;
lin agraphic_A = mkTerm "agraphic_A" ;
lin agrarian_A = mkTerm "agrarian_A" ;
lin agree_V = mkTerm "agree_V" ;
lin agree_VS = mkTerm "agree_VS" ;
lin agree_VV = mkTerm "agree_VV" ;
lin agree_on_V = mkTerm "agree_on_V" ;
lin agree_with_V2 = mkTerm "agree_with_V2" ;
lin agreeable_A = mkTerm "agreeable_A" ;
lin agreeableness_N = mkTerm "agreeableness_N" ;
lin agreed_A = mkTerm "agreed_A" ;
lin agreement_N = mkTerm "agreement_N" ;
lin agrestic_A = mkTerm "agrestic_A" ;
lin agribusiness_N = mkTerm "agribusiness_N" ;
lin agricultural_A = mkTerm "agricultural_A" ;
lin agriculture_N = mkTerm "agriculture_N" ;
lin agriculturist_N = mkTerm "agriculturist_N" ;
lin agrimonia_N = mkTerm "agrimonia_N" ;
lin agrobiologic_A = mkTerm "agrobiologic_A" ;
lin agrobiology_N = mkTerm "agrobiology_N" ;
lin agrologic_A = mkTerm "agrologic_A" ;
lin agrology_N = mkTerm "agrology_N" ;
lin agromania_N = mkTerm "agromania_N" ;
lin agronomic_A = mkTerm "agronomic_A" ;
lin agronomist_N = mkTerm "agronomist_N" ;
lin agronomy_N = mkTerm "agronomy_N" ;
lin aground_A = mkTerm "aground_A" ;
lin aground_Adv = mkTerm "aground_Adv" ;
lin agrypnia_N = mkTerm "agrypnia_N" ;
lin agrypnotic_A = mkTerm "agrypnotic_A" ;
lin agua_N = mkTerm "agua_N" ;
lin ague_N = mkTerm "ague_N" ;
lin agueweed_N = mkTerm "agueweed_N" ;
lin aguish_A = mkTerm "aguish_A" ;
lin ah_Interj = mkTerm "ah_Interj" ;
lin ahead_Adv = mkTerm "ahead_Adv" ;
lin ahead_of_Prep = mkTerm "ahead_of_Prep" ;
lin ahimsa_N = mkTerm "ahimsa_N" ;
lin ahistorical_A = mkTerm "ahistorical_A" ;
lin ahmedabad_PN = mkTerm "ahmedabad_PN" ;
lin aid_N = mkTerm "aid_N" ;
lin aid_V = mkTerm "aid_V" ;
lin aid_V2 = mkTerm "aid_V2" ;
lin aide_N = mkTerm "aide_N" ;
lin aide_de_camp_N = mkTerm "aide_de_camp_N" ;
lin aide_memoire_N = mkTerm "aide_memoire_N" ;
lin aids_N = mkTerm "aids_N" ;
lin aigret_N = mkTerm "aigret_N" ;
lin aigrette_N = mkTerm "aigrette_N" ;
lin aikido_N = mkTerm "aikido_N" ;
lin ail_V = mkTerm "ail_V" ;
lin ail_V2 = mkTerm "ail_V2" ;
lin ailanthus_N = mkTerm "ailanthus_N" ;
lin aileron_N = mkTerm "aileron_N" ;
lin ailment_N = mkTerm "ailment_N" ;
lin ailurophobia_N = mkTerm "ailurophobia_N" ;
lin aim_N = mkTerm "aim_N" ;
lin aim_V = mkTerm "aim_V" ;
lin aim_V2 = mkTerm "aim_V2" ;
lin aim_VV = mkTerm "aim_VV" ;
lin aim_at_V2 = mkTerm "aim_at_V2" ;
lin aimless_A = mkTerm "aimless_A" ;
lin aioli_N = mkTerm "aioli_N" ;
lin air_N = mkTerm "air_N" ;
lin air_V = mkTerm "air_V" ;
lin air_V2 = mkTerm "air_V2" ;
lin air_bladder_N = mkTerm "air_bladder_N" ;
lin air_conditioned_A = mkTerm "air_conditioned_A" ;
lin air_conditioning_N = mkTerm "air_conditioning_N" ;
lin air_cooled_A = mkTerm "air_cooled_A" ;
lin air_minded_A = mkTerm "air_minded_A" ;
lin air_pump_N = mkTerm "air_pump_N" ;
lin air_raid_N = mkTerm "air_raid_N" ;
lin air_shaft_N = mkTerm "air_shaft_N" ;
lin air_sick_A = mkTerm "air_sick_A" ;
lin air_sickness_N = mkTerm "air_sickness_N" ;
lin air_to_air_A = mkTerm "air_to_air_A" ;
lin air_to_ground_A = mkTerm "air_to_ground_A" ;
lin airbed_N = mkTerm "airbed_N" ;
lin airborne_A = mkTerm "airborne_A" ;
lin airbrake_N = mkTerm "airbrake_N" ;
lin airbrush_N = mkTerm "airbrush_N" ;
lin airburst_N = mkTerm "airburst_N" ;
lin airbus_N = mkTerm "airbus_N" ;
lin aircraft_N = mkTerm "aircraft_N" ;
lin aircraftman_N = mkTerm "aircraftman_N" ;
lin aircraftsman_N = mkTerm "aircraftsman_N" ;
lin aircrew_N = mkTerm "aircrew_N" ;
lin aircrewman_N = mkTerm "aircrewman_N" ;
lin airdock_N = mkTerm "airdock_N" ;
lin airdrie_PN = mkTerm "airdrie_PN" ;
lin airdrop_N = mkTerm "airdrop_N" ;
lin aireborough_PN = mkTerm "aireborough_PN" ;
lin airedale_N = mkTerm "airedale_N" ;
lin airfare_N = mkTerm "airfare_N" ;
lin airfield_N = mkTerm "airfield_N" ;
lin airflow_N = mkTerm "airflow_N" ;
lin airfoil_N = mkTerm "airfoil_N" ;
lin airforce_N = mkTerm "airforce_N" ;
lin airframe_N = mkTerm "airframe_N" ;
lin airhead_N = mkTerm "airhead_N" ;
lin airheaded_A = mkTerm "airheaded_A" ;
lin airiness_N = mkTerm "airiness_N" ;
lin airing_N = mkTerm "airing_N" ;
lin airing_cupboard_N = mkTerm "airing_cupboard_N" ;
lin airless_A = mkTerm "airless_A" ;
lin airlift_N = mkTerm "airlift_N" ;
lin airline_N = mkTerm "airline_N" ;
lin airliner_N = mkTerm "airliner_N" ;
lin airlock_N = mkTerm "airlock_N" ;
lin airmail_N = mkTerm "airmail_N" ;
lin airmailer_N = mkTerm "airmailer_N" ;
lin airman_N = mkTerm "airman_N" ;
lin airplane_N = mkTerm "airplane_N" ;
lin airplay_N = mkTerm "airplay_N" ;
lin airport_N = mkTerm "airport_N" ;
lin airs_N = mkTerm "airs_N" ;
lin airscrew_N = mkTerm "airscrew_N" ;
lin airship_N = mkTerm "airship_N" ;
lin airspace_N = mkTerm "airspace_N" ;
lin airspeed_N = mkTerm "airspeed_N" ;
lin airstream_N = mkTerm "airstream_N" ;
lin airstrip_N = mkTerm "airstrip_N" ;
lin airtight_A = mkTerm "airtight_A" ;
lin airway_N = mkTerm "airway_N" ;
lin airwoman_N = mkTerm "airwoman_N" ;
lin airworthiness_N = mkTerm "airworthiness_N" ;
lin airworthy_A = mkTerm "airworthy_A" ;
lin airy_A = mkTerm "airy_A" ;
lin aisle_N = mkTerm "aisle_N" ;
lin aitch_N = mkTerm "aitch_N" ;
lin aitchbone_N = mkTerm "aitchbone_N" ;
lin ajar_A = mkTerm "ajar_A" ;
lin aka_Prep = mkTerm "aka_Prep" ;
lin akaa_PN = mkTerm "akaa_PN" ;
lin akaryocyte_N = mkTerm "akaryocyte_N" ;
lin akimbo_Adv = mkTerm "akimbo_Adv" ;
lin akin_A = mkTerm "akin_A" ;
lin akinesis_N = mkTerm "akinesis_N" ;
lin akron_PN = mkTerm "akron_PN" ;
lin al_PN = mkTerm "al_PN" ;
lin ala_N = mkTerm "ala_N" ;
lin alabama_PN = mkTerm "alabama_PN" ;
lin alabaster_A = mkTerm "alabaster_A" ;
lin alabaster_N = mkTerm "alabaster_N" ;
lin alacritous_A = mkTerm "alacritous_A" ;
lin alacrity_N = mkTerm "alacrity_N" ;
lin alahärmä_PN = mkTerm "alahärmä_PN" ;
lin alajärvi_PN = mkTerm "alajärvi_PN" ;
lin alalia_N = mkTerm "alalia_N" ;
lin alan_PN = mkTerm "alan_PN" ;
lin alanine_N = mkTerm "alanine_N" ;
lin alar_A = mkTerm "alar_A" ;
lin alarm_N = mkTerm "alarm_N" ;
lin alarm_V2 = mkTerm "alarm_V2" ;
lin alarm_clock_N = mkTerm "alarm_clock_N" ;
lin alarming_A = mkTerm "alarming_A" ;
lin alarmism_N = mkTerm "alarmism_N" ;
lin alarmist_N = mkTerm "alarmist_N" ;
lin alas_Interj = mkTerm "alas_Interj" ;
lin alaska_PN = mkTerm "alaska_PN" ;
lin alastaro_PN = mkTerm "alastaro_PN" ;
lin alastrim_N = mkTerm "alastrim_N" ;
lin alate_A = mkTerm "alate_A" ;
lin alavieska_PN = mkTerm "alavieska_PN" ;
lin alavus_PN = mkTerm "alavus_PN" ;
lin alb_N = mkTerm "alb_N" ;
lin albacore_N = mkTerm "albacore_N" ;
lin albania_PN = mkTerm "albania_PN" ;
lin albanian_A = mkTerm "albanian_A" ;
lin albanian_N = mkTerm "albanian_N" ;
lin albatross_N = mkTerm "albatross_N" ;
lin albedo_N = mkTerm "albedo_N" ;
lin albeit_Subj = mkTerm "albeit_Subj" ;
lin albert_PN = mkTerm "albert_PN" ;
lin alberta_PN = mkTerm "alberta_PN" ;
lin albescent_A = mkTerm "albescent_A" ;
lin albinal_A = mkTerm "albinal_A" ;
lin albinism_N = mkTerm "albinism_N" ;
lin albino_N = mkTerm "albino_N" ;
lin albite_N = mkTerm "albite_N" ;
lin albitic_A = mkTerm "albitic_A" ;
lin albizzia_N = mkTerm "albizzia_N" ;
lin albuca_N = mkTerm "albuca_N" ;
lin albuginea_N = mkTerm "albuginea_N" ;
lin album_N = mkTerm "album_N" ;
lin albumen_N = mkTerm "albumen_N" ;
lin albumin_N = mkTerm "albumin_N" ;
lin albuminous_A = mkTerm "albuminous_A" ;
lin albuminuria_N = mkTerm "albuminuria_N" ;
lin albuminuric_A = mkTerm "albuminuric_A" ;
lin albuterol_N = mkTerm "albuterol_N" ;
lin alcalde_N = mkTerm "alcalde_N" ;
lin alcazar_N = mkTerm "alcazar_N" ;
lin alchemic_A = mkTerm "alchemic_A" ;
lin alchemist_N = mkTerm "alchemist_N" ;
lin alchemistic_A = mkTerm "alchemistic_A" ;
lin alchemy_N = mkTerm "alchemy_N" ;
lin alcohol_N = mkTerm "alcohol_N" ;
lin alcoholic_A = mkTerm "alcoholic_A" ;
lin alcoholic_N = mkTerm "alcoholic_N" ;
lin alcoholism_N = mkTerm "alcoholism_N" ;
lin alcove_N = mkTerm "alcove_N" ;
lin aldehyde_N = mkTerm "aldehyde_N" ;
lin aldehydic_A = mkTerm "aldehydic_A" ;
lin alder_N = mkTerm "alder_N" ;
lin alderfly_N = mkTerm "alderfly_N" ;
lin alderman_N = mkTerm "alderman_N" ;
lin aldermanic_A = mkTerm "aldermanic_A" ;
lin aldershot_PN = mkTerm "aldershot_PN" ;
lin aldohexose_N = mkTerm "aldohexose_N" ;
lin aldol_N = mkTerm "aldol_N" ;
lin aldose_N = mkTerm "aldose_N" ;
lin aldosterone_N = mkTerm "aldosterone_N" ;
lin aldosteronism_N = mkTerm "aldosteronism_N" ;
lin ale_N = mkTerm "ale_N" ;
lin ale_house_N = mkTerm "ale_house_N" ;
lin aleatory_A = mkTerm "aleatory_A" ;
lin alee_A = mkTerm "alee_A" ;
lin alee_Adv = mkTerm "alee_Adv" ;
lin alembic_N = mkTerm "alembic_N" ;
lin alendronate_N = mkTerm "alendronate_N" ;
lin aleph_N = mkTerm "aleph_N" ;
lin aleppo_PN = mkTerm "aleppo_PN" ;
lin alert_A = mkTerm "alert_A" ;
lin alert_N = mkTerm "alert_N" ;
lin alert_V2 = mkTerm "alert_V2" ;
lin alertness_N = mkTerm "alertness_N" ;
lin alessandria_PN = mkTerm "alessandria_PN" ;
lin aleurone_N = mkTerm "aleurone_N" ;
lin aleuronic_A = mkTerm "aleuronic_A" ;
lin alewife_N = mkTerm "alewife_N" ;
lin alex_PN = mkTerm "alex_PN" ;
lin alexander_PN = mkTerm "alexander_PN" ;
lin alexandra_PN = mkTerm "alexandra_PN" ;
lin alexandria_PN = mkTerm "alexandria_PN" ;
lin alexandrine_N = mkTerm "alexandrine_N" ;
lin alexandrite_N = mkTerm "alexandrite_N" ;
lin alexia_N = mkTerm "alexia_N" ;
lin alexic_A = mkTerm "alexic_A" ;
lin alexic_N = mkTerm "alexic_N" ;
lin alf_PN = mkTerm "alf_PN" ;
lin alfalfa_N = mkTerm "alfalfa_N" ;
lin alfred_PN = mkTerm "alfred_PN" ;
lin alfresco_A = mkTerm "alfresco_A" ;
lin alfresco_Adv = mkTerm "alfresco_Adv" ;
lin alfreton_PN = mkTerm "alfreton_PN" ;
lin alga_N = mkTerm "alga_N" ;
lin algal_A = mkTerm "algal_A" ;
lin algarroba_N = mkTerm "algarroba_N" ;
lin algebra_N = mkTerm "algebra_N" ;
lin algebraic_A = mkTerm "algebraic_A" ;
lin algebraical_A = mkTerm "algebraical_A" ;
lin algebraist_N = mkTerm "algebraist_N" ;
lin alger_PN = mkTerm "alger_PN" ;
lin algeria_PN = mkTerm "algeria_PN" ;
lin algerian_A = mkTerm "algerian_A" ;
lin algerian_N = mkTerm "algerian_N" ;
lin algid_A = mkTerm "algid_A" ;
lin algidity_N = mkTerm "algidity_N" ;
lin algin_N = mkTerm "algin_N" ;
lin algoid_A = mkTerm "algoid_A" ;
lin algolagnia_N = mkTerm "algolagnia_N" ;
lin algolagnic_A = mkTerm "algolagnic_A" ;
lin algometer_N = mkTerm "algometer_N" ;
lin algometric_A = mkTerm "algometric_A" ;
lin algometry_N = mkTerm "algometry_N" ;
lin algophobia_N = mkTerm "algophobia_N" ;
lin algophobic_A = mkTerm "algophobic_A" ;
lin algorism_N = mkTerm "algorism_N" ;
lin algorithm_N = mkTerm "algorithm_N" ;
lin algorithmic_A = mkTerm "algorithmic_A" ;
lin ali_PN = mkTerm "ali_PN" ;
lin alias_Adv = mkTerm "alias_Adv" ;
lin alias_N = mkTerm "alias_N" ;
lin alibi_N = mkTerm "alibi_N" ;
lin alicante_PN = mkTerm "alicante_PN" ;
lin alice_PN = mkTerm "alice_PN" ;
lin alidade_N = mkTerm "alidade_N" ;
lin alienFem_N = mkTerm "alienFem_N" ;
lin alienMasc_N = mkTerm "alienMasc_N" ;
lin alien_A = mkTerm "alien_A" ;
lin alienable_A = mkTerm "alienable_A" ;
lin alienage_N = mkTerm "alienage_N" ;
lin alienate_V2 = mkTerm "alienate_V2" ;
lin alienating_A = mkTerm "alienating_A" ;
lin alienation_N = mkTerm "alienation_N" ;
lin alienator_N = mkTerm "alienator_N" ;
lin alienee_N = mkTerm "alienee_N" ;
lin alienism_N = mkTerm "alienism_N" ;
lin alienist_N = mkTerm "alienist_N" ;
lin alienor_N = mkTerm "alienor_N" ;
lin alight_A = mkTerm "alight_A" ;
lin alight_V = mkTerm "alight_V" ;
lin align_V = mkTerm "align_V" ;
lin align_V2 = mkTerm "align_V2" ;
lin alignment_N = mkTerm "alignment_N" ;
lin alike_A = mkTerm "alike_A" ;
lin alike_Adv = mkTerm "alike_Adv" ;
lin alimentary_A = mkTerm "alimentary_A" ;
lin alimentative_A = mkTerm "alimentative_A" ;
lin alimony_N = mkTerm "alimony_N" ;
lin aliphatic_A = mkTerm "aliphatic_A" ;
lin aliquant_N = mkTerm "aliquant_N" ;
lin aliquot_A = mkTerm "aliquot_A" ;
lin aliquot_N = mkTerm "aliquot_N" ;
lin alison_PN = mkTerm "alison_PN" ;
lin aliterate_N = mkTerm "aliterate_N" ;
lin alive_A = mkTerm "alive_A" ;
lin aliyah_N = mkTerm "aliyah_N" ;
lin alizarin_N = mkTerm "alizarin_N" ;
lin alkahest_N = mkTerm "alkahest_N" ;
lin alkahestic_A = mkTerm "alkahestic_A" ;
lin alkalemia_N = mkTerm "alkalemia_N" ;
lin alkalescent_A = mkTerm "alkalescent_A" ;
lin alkali_N = mkTerm "alkali_N" ;
lin alkalimetry_N = mkTerm "alkalimetry_N" ;
lin alkaline_A = mkTerm "alkaline_A" ;
lin alkalinity_N = mkTerm "alkalinity_N" ;
lin alkalinuria_N = mkTerm "alkalinuria_N" ;
lin alkaloid_N = mkTerm "alkaloid_N" ;
lin alkaloidal_A = mkTerm "alkaloidal_A" ;
lin alkalosis_N = mkTerm "alkalosis_N" ;
lin alkalotic_A = mkTerm "alkalotic_A" ;
lin alkapton_N = mkTerm "alkapton_N" ;
lin alkaptonuria_N = mkTerm "alkaptonuria_N" ;
lin alkene_N = mkTerm "alkene_N" ;
lin alkyd_N = mkTerm "alkyd_N" ;
lin alkyl_N = mkTerm "alkyl_N" ;
lin alkylbenzene_N = mkTerm "alkylbenzene_N" ;
lin alkylbenzenesulfonate_N = mkTerm "alkylbenzenesulfonate_N" ;
lin alkylic_A = mkTerm "alkylic_A" ;
lin all_A = mkTerm "all_A" ;
lin all_mains_A = mkTerm "all_mains_A" ;
lin all_round_A = mkTerm "all_round_A" ;
lin all_rounder_N = mkTerm "all_rounder_N" ;
lin allah_PN = mkTerm "allah_PN" ;
lin allahabad_PN = mkTerm "allahabad_PN" ;
lin allamanda_N = mkTerm "allamanda_N" ;
lin allan_PN = mkTerm "allan_PN" ;
lin allantoic_A = mkTerm "allantoic_A" ;
lin allantoid_A = mkTerm "allantoid_A" ;
lin allantois_N = mkTerm "allantois_N" ;
lin allargando_A = mkTerm "allargando_A" ;
lin allay_V2 = mkTerm "allay_V2" ;
lin allegation_N = mkTerm "allegation_N" ;
lin allege_V2 = mkTerm "allege_V2" ;
lin allege_VS = mkTerm "allege_VS" ;
lin alleged_A = mkTerm "alleged_A" ;
lin allegedly_AdA = mkTerm "allegedly_AdA" ;
lin allegedly_AdV = mkTerm "allegedly_AdV" ;
lin allegiance_N = mkTerm "allegiance_N" ;
lin allegiant_A = mkTerm "allegiant_A" ;
lin allegoric_A = mkTerm "allegoric_A" ;
lin allegorical_A = mkTerm "allegorical_A" ;
lin allegorizer_N = mkTerm "allegorizer_N" ;
lin allegory_N = mkTerm "allegory_N" ;
lin allegretto_A = mkTerm "allegretto_A" ;
lin allegretto_Adv = mkTerm "allegretto_Adv" ;
lin allegretto_N = mkTerm "allegretto_N" ;
lin allegro_A = mkTerm "allegro_A" ;
lin allegro_Adv = mkTerm "allegro_Adv" ;
lin allegro_N = mkTerm "allegro_N" ;
lin allele_N = mkTerm "allele_N" ;
lin allelic_A = mkTerm "allelic_A" ;
lin allemande_N = mkTerm "allemande_N" ;
lin allen_PN = mkTerm "allen_PN" ;
lin allergen_N = mkTerm "allergen_N" ;
lin allergenic_A = mkTerm "allergenic_A" ;
lin allergic_A = mkTerm "allergic_A" ;
lin allergist_N = mkTerm "allergist_N" ;
lin allergology_N = mkTerm "allergology_N" ;
lin allergy_N = mkTerm "allergy_N" ;
lin alleviate_V2 = mkTerm "alleviate_V2" ;
lin alleviation_N = mkTerm "alleviation_N" ;
lin alleviative_A = mkTerm "alleviative_A" ;
lin alleviator_N = mkTerm "alleviator_N" ;
lin alley_N = mkTerm "alley_N" ;
lin alleyway_N = mkTerm "alleyway_N" ;
lin alliaceous_A = mkTerm "alliaceous_A" ;
lin alliance_N = mkTerm "alliance_N" ;
lin allied_A = mkTerm "allied_A" ;
lin allies_N = mkTerm "allies_N" ;
lin alligator_N = mkTerm "alligator_N" ;
lin alligatored_A = mkTerm "alligatored_A" ;
lin alligatorfish_N = mkTerm "alligatorfish_N" ;
lin alliteration_N = mkTerm "alliteration_N" ;
lin alliterative_A = mkTerm "alliterative_A" ;
lin alliterator_N = mkTerm "alliterator_N" ;
lin alloa_PN = mkTerm "alloa_PN" ;
lin allocable_A = mkTerm "allocable_A" ;
lin allocate_V = mkTerm "allocate_V" ;
lin allocate_V2 = mkTerm "allocate_V2" ;
lin allocation_N = mkTerm "allocation_N" ;
lin allocator_N = mkTerm "allocator_N" ;
lin allochronic_A = mkTerm "allochronic_A" ;
lin allochthonous_A = mkTerm "allochthonous_A" ;
lin allocution_N = mkTerm "allocution_N" ;
lin allogamous_A = mkTerm "allogamous_A" ;
lin allogamy_N = mkTerm "allogamy_N" ;
lin allogeneic_A = mkTerm "allogeneic_A" ;
lin allograph_N = mkTerm "allograph_N" ;
lin allographic_A = mkTerm "allographic_A" ;
lin allomerism_N = mkTerm "allomerism_N" ;
lin allomerous_A = mkTerm "allomerous_A" ;
lin allometric_A = mkTerm "allometric_A" ;
lin allometry_N = mkTerm "allometry_N" ;
lin allomorph_N = mkTerm "allomorph_N" ;
lin allomorphic_A = mkTerm "allomorphic_A" ;
lin allopathic_A = mkTerm "allopathic_A" ;
lin allopathy_N = mkTerm "allopathy_N" ;
lin allopatric_A = mkTerm "allopatric_A" ;
lin allopatry_N = mkTerm "allopatry_N" ;
lin allophone_N = mkTerm "allophone_N" ;
lin allophonic_A = mkTerm "allophonic_A" ;
lin allopurinol_N = mkTerm "allopurinol_N" ;
lin allosaur_N = mkTerm "allosaur_N" ;
lin allot_V2 = mkTerm "allot_V2" ;
lin allotment_N = mkTerm "allotment_N" ;
lin allotrope_N = mkTerm "allotrope_N" ;
lin allotropic_A = mkTerm "allotropic_A" ;
lin allotropy_N = mkTerm "allotropy_N" ;
lin allover_A = mkTerm "allover_A" ;
lin allow_V2 = mkTerm "allow_V2" ;
lin allow_V2V = mkTerm "allow_V2V" ;
lin allow_for_V2 = mkTerm "allow_for_V2" ;
lin allow_of_V2 = mkTerm "allow_of_V2" ;
lin allowable_A = mkTerm "allowable_A" ;
lin allowance_N = mkTerm "allowance_N" ;
lin alloy_N = mkTerm "alloy_N" ;
lin alloy_V2 = mkTerm "alloy_V2" ;
lin allspice_N = mkTerm "allspice_N" ;
lin allude_V = mkTerm "allude_V" ;
lin allure_N = mkTerm "allure_N" ;
lin allure_V2 = mkTerm "allure_V2" ;
lin allurement_N = mkTerm "allurement_N" ;
lin alluring_A = mkTerm "alluring_A" ;
lin allusion_N = mkTerm "allusion_N" ;
lin allusive_A = mkTerm "allusive_A" ;
lin allusiveness_N = mkTerm "allusiveness_N" ;
lin alluvial_A = mkTerm "alluvial_A" ;
lin alluvion_N = mkTerm "alluvion_N" ;
lin ally_N = mkTerm "ally_N" ;
lin ally_V2 = mkTerm "ally_V2" ;
lin allyl_N = mkTerm "allyl_N" ;
lin allylic_A = mkTerm "allylic_A" ;
lin alma_ata_PN = mkTerm "alma_ata_PN" ;
lin alma_mater_N = mkTerm "alma_mater_N" ;
lin almanac_N = mkTerm "almanac_N" ;
lin almandine_N = mkTerm "almandine_N" ;
lin almandite_N = mkTerm "almandite_N" ;
lin almeria_PN = mkTerm "almeria_PN" ;
lin almighty_A = mkTerm "almighty_A" ;
lin almighty_N = mkTerm "almighty_N" ;
lin almond_N = mkTerm "almond_N" ;
lin almond_eyed_A = mkTerm "almond_eyed_A" ;
lin almoner_N = mkTerm "almoner_N" ;
lin almost_Adv = mkTerm "almost_Adv" ;
lin almost_Predet = mkTerm "almost_Predet" ;
lin alms_N = mkTerm "alms_N" ;
lin alms_box_N = mkTerm "alms_box_N" ;
lin alms_giving_N = mkTerm "alms_giving_N" ;
lin alms_house_N = mkTerm "alms_house_N" ;
lin almsgiver_N = mkTerm "almsgiver_N" ;
lin alnwick_PN = mkTerm "alnwick_PN" ;
lin alocasia_N = mkTerm "alocasia_N" ;
lin aloe_N = mkTerm "aloe_N" ;
lin aloft_Adv = mkTerm "aloft_Adv" ;
lin aloha_N = mkTerm "aloha_N" ;
lin alone_A = mkTerm "alone_A" ;
lin aloneness_N = mkTerm "aloneness_N" ;
lin along_Adv = mkTerm "along_Adv" ;
lin along_Prep = mkTerm "along_Prep" ;
lin alongside_Adv = mkTerm "alongside_Adv" ;
lin alongside_Prep = mkTerm "alongside_Prep" ;
lin aloof_A = mkTerm "aloof_A" ;
lin aloof_Adv = mkTerm "aloof_Adv" ;
lin aloofness_N = mkTerm "aloofness_N" ;
lin alopecia_N = mkTerm "alopecia_N" ;
lin alopecic_A = mkTerm "alopecic_A" ;
lin aloud_Adv = mkTerm "aloud_Adv" ;
lin alp_N = mkTerm "alp_N" ;
lin alpaca_N = mkTerm "alpaca_N" ;
lin alpenstock_N = mkTerm "alpenstock_N" ;
lin alpestrine_A = mkTerm "alpestrine_A" ;
lin alpha_A = mkTerm "alpha_A" ;
lin alpha_N = mkTerm "alpha_N" ;
lin alphabet_N = mkTerm "alphabet_N" ;
lin alphabetic_A = mkTerm "alphabetic_A" ;
lin alphabetical_A = mkTerm "alphabetical_A" ;
lin alphabetization_N = mkTerm "alphabetization_N" ;
lin alphabetized_A = mkTerm "alphabetized_A" ;
lin alphabetizer_N = mkTerm "alphabetizer_N" ;
lin alphanumeric_A = mkTerm "alphanumeric_A" ;
lin alphanumerics_N = mkTerm "alphanumerics_N" ;
lin alphavirus_N = mkTerm "alphavirus_N" ;
lin alpine_A = mkTerm "alpine_A" ;
lin alpinist_N = mkTerm "alpinist_N" ;
lin alprazolam_N = mkTerm "alprazolam_N" ;
lin already_AdV = mkTerm "already_AdV" ;
lin already_Adv = mkTerm "already_Adv" ;
lin alright_A = mkTerm "alright_A" ;
lin alright_Adv = mkTerm "alright_Adv" ;
lin alsatianFem_N = mkTerm "alsatianFem_N" ;
lin alsatianMasc_N = mkTerm "alsatianMasc_N" ;
lin also_AdV = mkTerm "also_AdV" ;
lin also_Adv = mkTerm "also_Adv" ;
lin also_ran_N = mkTerm "also_ran_N" ;
lin alstroemeria_N = mkTerm "alstroemeria_N" ;
lin altar_N = mkTerm "altar_N" ;
lin altar_piece_N = mkTerm "altar_piece_N" ;
lin altazimuth_N = mkTerm "altazimuth_N" ;
lin alter_V = mkTerm "alter_V" ;
lin alter_V2 = mkTerm "alter_V2" ;
lin alter_ego_N = mkTerm "alter_ego_N" ;
lin alterability_N = mkTerm "alterability_N" ;
lin alterable_A = mkTerm "alterable_A" ;
lin alteration_N = mkTerm "alteration_N" ;
lin altercation_N = mkTerm "altercation_N" ;
lin altered_A = mkTerm "altered_A" ;
lin alternate_A = mkTerm "alternate_A" ;
lin alternate_V = mkTerm "alternate_V" ;
lin alternate_V2 = mkTerm "alternate_V2" ;
lin alternation_N = mkTerm "alternation_N" ;
lin alternative_A = mkTerm "alternative_A" ;
lin alternative_N = mkTerm "alternative_N" ;
lin alternator_N = mkTerm "alternator_N" ;
lin althea_N = mkTerm "althea_N" ;
lin altimeter_N = mkTerm "altimeter_N" ;
lin altissimo_A = mkTerm "altissimo_A" ;
lin altitude_N = mkTerm "altitude_N" ;
lin altitudinal_A = mkTerm "altitudinal_A" ;
lin altitudinous_A = mkTerm "altitudinous_A" ;
lin alto_A = mkTerm "alto_A" ;
lin alto_N = mkTerm "alto_N" ;
lin altocumulus_N = mkTerm "altocumulus_N" ;
lin altogether_Adv = mkTerm "altogether_Adv" ;
lin alton_PN = mkTerm "alton_PN" ;
lin altostratus_N = mkTerm "altostratus_N" ;
lin altricial_A = mkTerm "altricial_A" ;
lin altrincham_PN = mkTerm "altrincham_PN" ;
lin altruism_N = mkTerm "altruism_N" ;
lin altruist_N = mkTerm "altruist_N" ;
lin altruistic_A = mkTerm "altruistic_A" ;
lin alula_N = mkTerm "alula_N" ;
lin alular_A = mkTerm "alular_A" ;
lin alum_N = mkTerm "alum_N" ;
lin alumina_N = mkTerm "alumina_N" ;
lin aluminate_N = mkTerm "aluminate_N" ;
lin aluminiferous_A = mkTerm "aluminiferous_A" ;
lin aluminium_N = mkTerm "aluminium_N" ;
lin aluminous_A = mkTerm "aluminous_A" ;
lin aluminum_N = mkTerm "aluminum_N" ;
lin alumna_N = mkTerm "alumna_N" ;
lin alumnus_N = mkTerm "alumnus_N" ;
lin alumroot_N = mkTerm "alumroot_N" ;
lin alundum_N = mkTerm "alundum_N" ;
lin alvechurch_PN = mkTerm "alvechurch_PN" ;
lin alveolar_A = mkTerm "alveolar_A" ;
lin alveolar_N = mkTerm "alveolar_N" ;
lin alveolate_A = mkTerm "alveolate_A" ;
lin alveolitis_N = mkTerm "alveolitis_N" ;
lin alveolus_N = mkTerm "alveolus_N" ;
lin alvine_A = mkTerm "alvine_A" ;
lin always_Adv = mkTerm "always_Adv" ;
lin alyssum_N = mkTerm "alyssum_N" ;
lin amah_N = mkTerm "amah_N" ;
lin amain_Adv = mkTerm "amain_Adv" ;
lin amalgam_N = mkTerm "amalgam_N" ;
lin amalgamate_A = mkTerm "amalgamate_A" ;
lin amalgamate_V = mkTerm "amalgamate_V" ;
lin amalgamate_V2 = mkTerm "amalgamate_V2" ;
lin amalgamation_N = mkTerm "amalgamation_N" ;
lin amalgamative_A = mkTerm "amalgamative_A" ;
lin amalgamator_N = mkTerm "amalgamator_N" ;
lin amanda_PN = mkTerm "amanda_PN" ;
lin amanuensis_N = mkTerm "amanuensis_N" ;
lin amaranth_N = mkTerm "amaranth_N" ;
lin amaranthine_A = mkTerm "amaranthine_A" ;
lin amarelle_N = mkTerm "amarelle_N" ;
lin amaretto_N = mkTerm "amaretto_N" ;
lin amaryllis_N = mkTerm "amaryllis_N" ;
lin amass_V2 = mkTerm "amass_V2" ;
lin amastia_N = mkTerm "amastia_N" ;
lin amateurFem_N = mkTerm "amateurFem_N" ;
lin amateurMasc_N = mkTerm "amateurMasc_N" ;
lin amateur_A = mkTerm "amateur_A" ;
lin amateurish_A = mkTerm "amateurish_A" ;
lin amateurishness_N = mkTerm "amateurishness_N" ;
lin amateurism_N = mkTerm "amateurism_N" ;
lin amative_A = mkTerm "amative_A" ;
lin amatory_A = mkTerm "amatory_A" ;
lin amaurosis_N = mkTerm "amaurosis_N" ;
lin amaurotic_A = mkTerm "amaurotic_A" ;
lin amaze_V2 = mkTerm "amaze_V2" ;
lin amaze_V2V = mkTerm "amaze_V2V" ;
lin amazement_N = mkTerm "amazement_N" ;
lin amazing_A = mkTerm "amazing_A" ;
lin amazon_N = mkTerm "amazon_N" ;
lin ambages_N = mkTerm "ambages_N" ;
lin ambassador_N = mkTerm "ambassador_N" ;
lin ambassadorial_A = mkTerm "ambassadorial_A" ;
lin ambassadorship_N = mkTerm "ambassadorship_N" ;
lin ambassadress_N = mkTerm "ambassadress_N" ;
lin amber_A = mkTerm "amber_A" ;
lin amber_N = mkTerm "amber_N" ;
lin ambergris_N = mkTerm "ambergris_N" ;
lin amberjack_N = mkTerm "amberjack_N" ;
lin ambidexterity_N = mkTerm "ambidexterity_N" ;
lin ambidextrous_A = mkTerm "ambidextrous_A" ;
lin ambience_N = mkTerm "ambience_N" ;
lin ambient_A = mkTerm "ambient_A" ;
lin ambiguity_N = mkTerm "ambiguity_N" ;
lin ambiguous_A = mkTerm "ambiguous_A" ;
lin ambit_N = mkTerm "ambit_N" ;
lin ambition_N = mkTerm "ambition_N" ;
lin ambitious_A = mkTerm "ambitious_A" ;
lin ambivalence_N = mkTerm "ambivalence_N" ;
lin ambivalent_A = mkTerm "ambivalent_A" ;
lin ambiversion_N = mkTerm "ambiversion_N" ;
lin ambiversive_A = mkTerm "ambiversive_A" ;
lin amble_N = mkTerm "amble_N" ;
lin amble_V = mkTerm "amble_V" ;
lin amblygonite_N = mkTerm "amblygonite_N" ;
lin amblyopia_N = mkTerm "amblyopia_N" ;
lin amblyopic_A = mkTerm "amblyopic_A" ;
lin amboyna_N = mkTerm "amboyna_N" ;
lin ambrosia_N = mkTerm "ambrosia_N" ;
lin ambrosial_A = mkTerm "ambrosial_A" ;
lin ambulacral_A = mkTerm "ambulacral_A" ;
lin ambulacrum_N = mkTerm "ambulacrum_N" ;
lin ambulance_N = mkTerm "ambulance_N" ;
lin ambulant_A = mkTerm "ambulant_A" ;
lin ambulation_N = mkTerm "ambulation_N" ;
lin ambulatory_A = mkTerm "ambulatory_A" ;
lin ambulatory_N = mkTerm "ambulatory_N" ;
lin ambuscade_N = mkTerm "ambuscade_N" ;
lin ambuscade_V2 = mkTerm "ambuscade_V2" ;
lin ambush_N = mkTerm "ambush_N" ;
lin ambush_V2 = mkTerm "ambush_V2" ;
lin ambusher_N = mkTerm "ambusher_N" ;
lin ambystomid_N = mkTerm "ambystomid_N" ;
lin amebiasis_N = mkTerm "amebiasis_N" ;
lin ameboid_A = mkTerm "ameboid_A" ;
lin ameer_N = mkTerm "ameer_N" ;
lin amelia_N = mkTerm "amelia_N" ;
lin ameliorate_V = mkTerm "ameliorate_V" ;
lin ameliorate_V2 = mkTerm "ameliorate_V2" ;
lin amelioration_N = mkTerm "amelioration_N" ;
lin ameloblast_N = mkTerm "ameloblast_N" ;
lin amelogenesis_N = mkTerm "amelogenesis_N" ;
lin amen_Interj = mkTerm "amen_Interj" ;
lin amenability_N = mkTerm "amenability_N" ;
lin amenable_A = mkTerm "amenable_A" ;
lin amend_V = mkTerm "amend_V" ;
lin amend_V2 = mkTerm "amend_V2" ;
lin amend_V2V = mkTerm "amend_V2V" ;
lin amendable_A = mkTerm "amendable_A" ;
lin amendatory_A = mkTerm "amendatory_A" ;
lin amendment_N = mkTerm "amendment_N" ;
lin amenity_N = mkTerm "amenity_N" ;
lin amenorrhea_N = mkTerm "amenorrhea_N" ;
lin amenorrheic_A = mkTerm "amenorrheic_A" ;
lin amentiferous_A = mkTerm "amentiferous_A" ;
lin amerciable_A = mkTerm "amerciable_A" ;
lin america_PN = mkTerm "america_PN" ;
lin americanFem_N = mkTerm "americanFem_N" ;
lin americanMasc_N = mkTerm "americanMasc_N" ;
lin american_A = mkTerm "american_A" ;
lin americanism_N = mkTerm "americanism_N" ;
lin americanize_V2 = mkTerm "americanize_V2" ;
lin americium_N = mkTerm "americium_N" ;
lin amesbury_PN = mkTerm "amesbury_PN" ;
lin ametabolic_A = mkTerm "ametabolic_A" ;
lin amethyst_A = mkTerm "amethyst_A" ;
lin amethyst_N = mkTerm "amethyst_N" ;
lin amethystine_A = mkTerm "amethystine_A" ;
lin ametria_N = mkTerm "ametria_N" ;
lin ametropia_N = mkTerm "ametropia_N" ;
lin ametropic_A = mkTerm "ametropic_A" ;
lin amiability_N = mkTerm "amiability_N" ;
lin amiable_A = mkTerm "amiable_A" ;
lin amicability_N = mkTerm "amicability_N" ;
lin amicable_A = mkTerm "amicable_A" ;
lin amid_Prep = mkTerm "amid_Prep" ;
lin amide_N = mkTerm "amide_N" ;
lin amidship_A = mkTerm "amidship_A" ;
lin amidship_Adv = mkTerm "amidship_Adv" ;
lin amidships_Adv = mkTerm "amidships_Adv" ;
lin amidst_Prep = mkTerm "amidst_Prep" ;
lin amiens_PN = mkTerm "amiens_PN" ;
lin amigo_N = mkTerm "amigo_N" ;
lin amine_N = mkTerm "amine_N" ;
lin amino_A = mkTerm "amino_A" ;
lin amino_N = mkTerm "amino_N" ;
lin aminoaciduria_N = mkTerm "aminoaciduria_N" ;
lin aminomethane_N = mkTerm "aminomethane_N" ;
lin aminophylline_N = mkTerm "aminophylline_N" ;
lin aminopyrine_N = mkTerm "aminopyrine_N" ;
lin amiodarone_N = mkTerm "amiodarone_N" ;
lin amir_N = mkTerm "amir_N" ;
lin amiss_A = mkTerm "amiss_A" ;
lin amiss_Adv = mkTerm "amiss_Adv" ;
lin amitosis_N = mkTerm "amitosis_N" ;
lin amitotic_A = mkTerm "amitotic_A" ;
lin amitriptyline_N = mkTerm "amitriptyline_N" ;
lin amity_N = mkTerm "amity_N" ;
lin ammanford_PN = mkTerm "ammanford_PN" ;
lin ammeter_N = mkTerm "ammeter_N" ;
lin ammine_N = mkTerm "ammine_N" ;
lin ammino_A = mkTerm "ammino_A" ;
lin ammobium_N = mkTerm "ammobium_N" ;
lin ammonia_N = mkTerm "ammonia_N" ;
lin ammoniac_A = mkTerm "ammoniac_A" ;
lin ammoniac_N = mkTerm "ammoniac_N" ;
lin ammoniated_A = mkTerm "ammoniated_A" ;
lin ammonification_N = mkTerm "ammonification_N" ;
lin ammonite_N = mkTerm "ammonite_N" ;
lin ammonitic_A = mkTerm "ammonitic_A" ;
lin ammonium_N = mkTerm "ammonium_N" ;
lin ammoniuria_N = mkTerm "ammoniuria_N" ;
lin ammunition_N = mkTerm "ammunition_N" ;
lin amnesia_N = mkTerm "amnesia_N" ;
lin amnesic_A = mkTerm "amnesic_A" ;
lin amnesic_N = mkTerm "amnesic_N" ;
lin amnestic_A = mkTerm "amnestic_A" ;
lin amnesty_N = mkTerm "amnesty_N" ;
lin amniocentesis_N = mkTerm "amniocentesis_N" ;
lin amnion_N = mkTerm "amnion_N" ;
lin amniote_N = mkTerm "amniote_N" ;
lin amniotic_A = mkTerm "amniotic_A" ;
lin amobarbital_N = mkTerm "amobarbital_N" ;
lin amoeba_N = mkTerm "amoeba_N" ;
lin amoebic_A = mkTerm "amoebic_A" ;
lin among_Prep = mkTerm "among_Prep" ;
lin amongst_Prep = mkTerm "amongst_Prep" ;
lin amora_N = mkTerm "amora_N" ;
lin amoral_A = mkTerm "amoral_A" ;
lin amoralism_N = mkTerm "amoralism_N" ;
lin amoralist_N = mkTerm "amoralist_N" ;
lin amorality_N = mkTerm "amorality_N" ;
lin amorist_N = mkTerm "amorist_N" ;
lin amoristic_A = mkTerm "amoristic_A" ;
lin amorous_A = mkTerm "amorous_A" ;
lin amorousness_N = mkTerm "amorousness_N" ;
lin amorpha_N = mkTerm "amorpha_N" ;
lin amorphophallus_N = mkTerm "amorphophallus_N" ;
lin amorphous_A = mkTerm "amorphous_A" ;
lin amort_A = mkTerm "amort_A" ;
lin amortization_N = mkTerm "amortization_N" ;
lin amortize_V2 = mkTerm "amortize_V2" ;
lin amount_N = mkTerm "amount_N" ;
lin amount_V = mkTerm "amount_V" ;
lin amour_N = mkTerm "amour_N" ;
lin amour_propre_N = mkTerm "amour_propre_N" ;
lin amoxicillin_N = mkTerm "amoxicillin_N" ;
lin amp_Conj = mkTerm "amp_Conj" ;
lin amp_N = mkTerm "amp_N" ;
lin amperage_N = mkTerm "amperage_N" ;
lin ampere_N = mkTerm "ampere_N" ;
lin ampersand_N = mkTerm "ampersand_N" ;
lin amphetamine_N = mkTerm "amphetamine_N" ;
lin amphibia_N = mkTerm "amphibia_N" ;
lin amphibian_N = mkTerm "amphibian_N" ;
lin amphibiotic_A = mkTerm "amphibiotic_A" ;
lin amphibious_A = mkTerm "amphibious_A" ;
lin amphibole_N = mkTerm "amphibole_N" ;
lin amphibolite_N = mkTerm "amphibolite_N" ;
lin amphibology_N = mkTerm "amphibology_N" ;
lin amphibrach_N = mkTerm "amphibrach_N" ;
lin amphictyony_N = mkTerm "amphictyony_N" ;
lin amphidiploid_N = mkTerm "amphidiploid_N" ;
lin amphidiploidy_N = mkTerm "amphidiploidy_N" ;
lin amphigory_N = mkTerm "amphigory_N" ;
lin amphimixis_N = mkTerm "amphimixis_N" ;
lin amphipod_N = mkTerm "amphipod_N" ;
lin amphiprostylar_A = mkTerm "amphiprostylar_A" ;
lin amphisbaena_N = mkTerm "amphisbaena_N" ;
lin amphistylar_A = mkTerm "amphistylar_A" ;
lin amphitheatre_N = mkTerm "amphitheatre_N" ;
lin amphitheatric_A = mkTerm "amphitheatric_A" ;
lin amphitropous_A = mkTerm "amphitropous_A" ;
lin amphiuma_N = mkTerm "amphiuma_N" ;
lin amphora_N = mkTerm "amphora_N" ;
lin amphoric_A = mkTerm "amphoric_A" ;
lin amphoteric_A = mkTerm "amphoteric_A" ;
lin amphotericin_N = mkTerm "amphotericin_N" ;
lin ampicillin_N = mkTerm "ampicillin_N" ;
lin ample_A = mkTerm "ample_A" ;
lin ampleness_N = mkTerm "ampleness_N" ;
lin amplification_N = mkTerm "amplification_N" ;
lin amplifier_N = mkTerm "amplifier_N" ;
lin amplify_V2 = mkTerm "amplify_V2" ;
lin amplitude_N = mkTerm "amplitude_N" ;
lin ampoule_N = mkTerm "ampoule_N" ;
lin ampulla_N = mkTerm "ampulla_N" ;
lin ampullar_A = mkTerm "ampullar_A" ;
lin amputate_V2 = mkTerm "amputate_V2" ;
lin amputation_N = mkTerm "amputation_N" ;
lin amputator_N = mkTerm "amputator_N" ;
lin amputee_N = mkTerm "amputee_N" ;
lin amrinone_N = mkTerm "amrinone_N" ;
lin amsterdam_PN = mkTerm "amsterdam_PN" ;
lin amuck_A = mkTerm "amuck_A" ;
lin amuck_Adv = mkTerm "amuck_Adv" ;
lin amulet_N = mkTerm "amulet_N" ;
lin amuse_V2 = mkTerm "amuse_V2" ;
lin amusement_N = mkTerm "amusement_N" ;
lin amusing_A = mkTerm "amusing_A" ;
lin amy_PN = mkTerm "amy_PN" ;
lin amygdala_N = mkTerm "amygdala_N" ;
lin amygdalin_N = mkTerm "amygdalin_N" ;
lin amygdaline_A = mkTerm "amygdaline_A" ;
lin amygdaloid_N = mkTerm "amygdaloid_N" ;
lin amygdalotomy_N = mkTerm "amygdalotomy_N" ;
lin amyl_N = mkTerm "amyl_N" ;
lin amylase_N = mkTerm "amylase_N" ;
lin amyloid_N = mkTerm "amyloid_N" ;
lin amyloidosis_N = mkTerm "amyloidosis_N" ;
lin amylolysis_N = mkTerm "amylolysis_N" ;
lin amylolytic_A = mkTerm "amylolytic_A" ;
lin amyotrophia_N = mkTerm "amyotrophia_N" ;
lin amyxia_N = mkTerm "amyxia_N" ;
lin ana_N = mkTerm "ana_N" ;
lin anabatic_A = mkTerm "anabatic_A" ;
lin anabiosis_N = mkTerm "anabiosis_N" ;
lin anabiotic_A = mkTerm "anabiotic_A" ;
lin anabolic_A = mkTerm "anabolic_A" ;
lin anabolism_N = mkTerm "anabolism_N" ;
lin anachronic_A = mkTerm "anachronic_A" ;
lin anachronism_N = mkTerm "anachronism_N" ;
lin anachronistic_A = mkTerm "anachronistic_A" ;
lin anachronistically_Adv = mkTerm "anachronistically_Adv" ;
lin anaclinal_A = mkTerm "anaclinal_A" ;
lin anaclisis_N = mkTerm "anaclisis_N" ;
lin anaclitic_A = mkTerm "anaclitic_A" ;
lin anacoluthia_N = mkTerm "anacoluthia_N" ;
lin anacoluthic_A = mkTerm "anacoluthic_A" ;
lin anaconda_N = mkTerm "anaconda_N" ;
lin anadiplosis_N = mkTerm "anadiplosis_N" ;
lin anadromous_A = mkTerm "anadromous_A" ;
lin anaemia_N = mkTerm "anaemia_N" ;
lin anaemic_A = mkTerm "anaemic_A" ;
lin anaerobe_N = mkTerm "anaerobe_N" ;
lin anaerobic_A = mkTerm "anaerobic_A" ;
lin anaesthesia_N = mkTerm "anaesthesia_N" ;
lin anaesthetic_A = mkTerm "anaesthetic_A" ;
lin anaesthetic_N = mkTerm "anaesthetic_N" ;
lin anaesthetist_N = mkTerm "anaesthetist_N" ;
lin anaglyph_N = mkTerm "anaglyph_N" ;
lin anaglyphic_A = mkTerm "anaglyphic_A" ;
lin anaglyphy_N = mkTerm "anaglyphy_N" ;
lin anagnost_N = mkTerm "anagnost_N" ;
lin anagoge_N = mkTerm "anagoge_N" ;
lin anagogic_A = mkTerm "anagogic_A" ;
lin anagram_N = mkTerm "anagram_N" ;
lin anagrammatic_A = mkTerm "anagrammatic_A" ;
lin anagrams_N = mkTerm "anagrams_N" ;
lin anal_A = mkTerm "anal_A" ;
lin analbuminemia_N = mkTerm "analbuminemia_N" ;
lin analects_N = mkTerm "analects_N" ;
lin analeptic_A = mkTerm "analeptic_A" ;
lin analeptic_N = mkTerm "analeptic_N" ;
lin analgesia_N = mkTerm "analgesia_N" ;
lin analgesic_A = mkTerm "analgesic_A" ;
lin analgesic_N = mkTerm "analgesic_N" ;
lin analog_N = mkTerm "analog_N" ;
lin analogical_A = mkTerm "analogical_A" ;
lin analogist_N = mkTerm "analogist_N" ;
lin analogous_A = mkTerm "analogous_A" ;
lin analogue_A = mkTerm "analogue_A" ;
lin analogue_N = mkTerm "analogue_N" ;
lin analogy_N = mkTerm "analogy_N" ;
lin analphabet_N = mkTerm "analphabet_N" ;
lin analphabetic_A = mkTerm "analphabetic_A" ;
lin analysand_N = mkTerm "analysand_N" ;
lin analysis_N = mkTerm "analysis_N" ;
lin analyst_N = mkTerm "analyst_N" ;
lin analytic_A = mkTerm "analytic_A" ;
lin analytical_A = mkTerm "analytical_A" ;
lin analyticity_N = mkTerm "analyticity_N" ;
lin analyzable_A = mkTerm "analyzable_A" ;
lin analyze_V2 = mkTerm "analyze_V2" ;
lin analyzer_N = mkTerm "analyzer_N" ;
lin anamnestic_A = mkTerm "anamnestic_A" ;
lin anamorphic_A = mkTerm "anamorphic_A" ;
lin anamorphism_N = mkTerm "anamorphism_N" ;
lin anamorphosis_N = mkTerm "anamorphosis_N" ;
lin anapaest_N = mkTerm "anapaest_N" ;
lin anapaestic_A = mkTerm "anapaestic_A" ;
lin anapest_N = mkTerm "anapest_N" ;
lin anapestic_A = mkTerm "anapestic_A" ;
lin anaphase_N = mkTerm "anaphase_N" ;
lin anaphasic_A = mkTerm "anaphasic_A" ;
lin anaphor_N = mkTerm "anaphor_N" ;
lin anaphora_N = mkTerm "anaphora_N" ;
lin anaphoric_A = mkTerm "anaphoric_A" ;
lin anaphrodisia_N = mkTerm "anaphrodisia_N" ;
lin anaphrodisiac_A = mkTerm "anaphrodisiac_A" ;
lin anaphylactic_A = mkTerm "anaphylactic_A" ;
lin anaphylaxis_N = mkTerm "anaphylaxis_N" ;
lin anaplasia_N = mkTerm "anaplasia_N" ;
lin anaplasmosis_N = mkTerm "anaplasmosis_N" ;
lin anaplastic_A = mkTerm "anaplastic_A" ;
lin anapsid_N = mkTerm "anapsid_N" ;
lin anarchic_A = mkTerm "anarchic_A" ;
lin anarchism_N = mkTerm "anarchism_N" ;
lin anarchistFem_N = mkTerm "anarchistFem_N" ;
lin anarchistMasc_N = mkTerm "anarchistMasc_N" ;
lin anarchistic_A = mkTerm "anarchistic_A" ;
lin anarchy_N = mkTerm "anarchy_N" ;
lin anarthria_N = mkTerm "anarthria_N" ;
lin anasarca_N = mkTerm "anasarca_N" ;
lin anasarcous_A = mkTerm "anasarcous_A" ;
lin anaspid_N = mkTerm "anaspid_N" ;
lin anastalsis_N = mkTerm "anastalsis_N" ;
lin anastigmat_N = mkTerm "anastigmat_N" ;
lin anastigmatic_A = mkTerm "anastigmatic_A" ;
lin anastomosis_N = mkTerm "anastomosis_N" ;
lin anastomotic_A = mkTerm "anastomotic_A" ;
lin anastrophe_N = mkTerm "anastrophe_N" ;
lin anastylosis_N = mkTerm "anastylosis_N" ;
lin anathema_N = mkTerm "anathema_N" ;
lin anathematization_N = mkTerm "anathematization_N" ;
lin anathematize_V = mkTerm "anathematize_V" ;
lin anathematize_V2 = mkTerm "anathematize_V2" ;
lin anatomic_A = mkTerm "anatomic_A" ;
lin anatomical_A = mkTerm "anatomical_A" ;
lin anatomist_N = mkTerm "anatomist_N" ;
lin anatomy_N = mkTerm "anatomy_N" ;
lin anatotitan_N = mkTerm "anatotitan_N" ;
lin anatoxin_N = mkTerm "anatoxin_N" ;
lin anatropous_A = mkTerm "anatropous_A" ;
lin ancestor_N = mkTerm "ancestor_N" ;
lin ancestral_A = mkTerm "ancestral_A" ;
lin ancestress_N = mkTerm "ancestress_N" ;
lin ancestry_N = mkTerm "ancestry_N" ;
lin anchor_N = mkTerm "anchor_N" ;
lin anchor_V = mkTerm "anchor_V" ;
lin anchor_V2 = mkTerm "anchor_V2" ;
lin anchorage_N = mkTerm "anchorage_N" ;
lin anchorite_N = mkTerm "anchorite_N" ;
lin anchoritic_A = mkTerm "anchoritic_A" ;
lin anchorman_N = mkTerm "anchorman_N" ;
lin anchovy_N = mkTerm "anchovy_N" ;
lin anchusa_N = mkTerm "anchusa_N" ;
lin ancient_A = mkTerm "ancient_A" ;
lin ancient_N = mkTerm "ancient_N" ;
lin ancientness_N = mkTerm "ancientness_N" ;
lin ancillary_A = mkTerm "ancillary_A" ;
lin ancona_PN = mkTerm "ancona_PN" ;
lin andante_A = mkTerm "andante_A" ;
lin andante_Adv = mkTerm "andante_Adv" ;
lin andante_N = mkTerm "andante_N" ;
lin andantino_A = mkTerm "andantino_A" ;
lin andesite_N = mkTerm "andesite_N" ;
lin andiron_N = mkTerm "andiron_N" ;
lin andorra_PN = mkTerm "andorra_PN" ;
lin andorran_A = mkTerm "andorran_A" ;
lin andorran_N = mkTerm "andorran_N" ;
lin andover_PN = mkTerm "andover_PN" ;
lin andradite_N = mkTerm "andradite_N" ;
lin andrena_N = mkTerm "andrena_N" ;
lin andrew_PN = mkTerm "andrew_PN" ;
lin androecium_N = mkTerm "androecium_N" ;
lin androgen_N = mkTerm "androgen_N" ;
lin androgenesis_N = mkTerm "androgenesis_N" ;
lin androgenetic_A = mkTerm "androgenetic_A" ;
lin androgenic_A = mkTerm "androgenic_A" ;
lin androglossia_N = mkTerm "androglossia_N" ;
lin androgynous_A = mkTerm "androgynous_A" ;
lin androgyny_N = mkTerm "androgyny_N" ;
lin android_N = mkTerm "android_N" ;
lin andromeda_N = mkTerm "andromeda_N" ;
lin androphobia_N = mkTerm "androphobia_N" ;
lin androsterone_N = mkTerm "androsterone_N" ;
lin andryala_N = mkTerm "andryala_N" ;
lin andy_PN = mkTerm "andy_PN" ;
lin anecdotal_A = mkTerm "anecdotal_A" ;
lin anecdote_N = mkTerm "anecdote_N" ;
lin anecdotic_A = mkTerm "anecdotic_A" ;
lin anecdotist_N = mkTerm "anecdotist_N" ;
lin anechoic_A = mkTerm "anechoic_A" ;
lin anemia_N = mkTerm "anemia_N" ;
lin anemic_A = mkTerm "anemic_A" ;
lin anemographic_A = mkTerm "anemographic_A" ;
lin anemography_N = mkTerm "anemography_N" ;
lin anemometer_N = mkTerm "anemometer_N" ;
lin anemometric_A = mkTerm "anemometric_A" ;
lin anemometry_N = mkTerm "anemometry_N" ;
lin anemone_N = mkTerm "anemone_N" ;
lin anemophilous_A = mkTerm "anemophilous_A" ;
lin anencephalic_A = mkTerm "anencephalic_A" ;
lin anencephaly_N = mkTerm "anencephaly_N" ;
lin anenst_Prep = mkTerm "anenst_Prep" ;
lin anent_Prep = mkTerm "anent_Prep" ;
lin anergy_N = mkTerm "anergy_N" ;
lin aneroid_A = mkTerm "aneroid_A" ;
lin aneroid_N = mkTerm "aneroid_N" ;
lin anesthesia_N = mkTerm "anesthesia_N" ;
lin anesthesiologist_N = mkTerm "anesthesiologist_N" ;
lin anesthesiology_N = mkTerm "anesthesiology_N" ;
lin anesthetic_A = mkTerm "anesthetic_A" ;
lin anesthetic_N = mkTerm "anesthetic_N" ;
lin anesthetist_N = mkTerm "anesthetist_N" ;
lin anesthetize_V2 = mkTerm "anesthetize_V2" ;
lin anesthyl_N = mkTerm "anesthyl_N" ;
lin anestrous_A = mkTerm "anestrous_A" ;
lin anestrus_N = mkTerm "anestrus_N" ;
lin aneuploid_A = mkTerm "aneuploid_A" ;
lin aneuploidy_N = mkTerm "aneuploidy_N" ;
lin aneurysm_N = mkTerm "aneurysm_N" ;
lin aneurysmal_A = mkTerm "aneurysmal_A" ;
lin anew_Adv = mkTerm "anew_Adv" ;
lin anfractuous_A = mkTerm "anfractuous_A" ;
lin angel_N = mkTerm "angel_N" ;
lin angela_PN = mkTerm "angela_PN" ;
lin angelfish_N = mkTerm "angelfish_N" ;
lin angelic_A = mkTerm "angelic_A" ;
lin angelica_N = mkTerm "angelica_N" ;
lin angelim_N = mkTerm "angelim_N" ;
lin angelology_N = mkTerm "angelology_N" ;
lin angelus_N = mkTerm "angelus_N" ;
lin anger_N = mkTerm "anger_N" ;
lin anger_V2 = mkTerm "anger_V2" ;
lin angers_PN = mkTerm "angers_PN" ;
lin angie_PN = mkTerm "angie_PN" ;
lin angiitis_N = mkTerm "angiitis_N" ;
lin angina_N = mkTerm "angina_N" ;
lin anginal_A = mkTerm "anginal_A" ;
lin angiocardiogram_N = mkTerm "angiocardiogram_N" ;
lin angiocarp_N = mkTerm "angiocarp_N" ;
lin angiocarpic_A = mkTerm "angiocarpic_A" ;
lin angioedema_N = mkTerm "angioedema_N" ;
lin angiogenesis_N = mkTerm "angiogenesis_N" ;
lin angiogram_N = mkTerm "angiogram_N" ;
lin angiography_N = mkTerm "angiography_N" ;
lin angiologist_N = mkTerm "angiologist_N" ;
lin angiology_N = mkTerm "angiology_N" ;
lin angioma_N = mkTerm "angioma_N" ;
lin angiomatous_A = mkTerm "angiomatous_A" ;
lin angiopathy_N = mkTerm "angiopathy_N" ;
lin angioplasty_N = mkTerm "angioplasty_N" ;
lin angiopteris_N = mkTerm "angiopteris_N" ;
lin angiosarcoma_N = mkTerm "angiosarcoma_N" ;
lin angioscope_N = mkTerm "angioscope_N" ;
lin angiosperm_N = mkTerm "angiosperm_N" ;
lin angiospermous_A = mkTerm "angiospermous_A" ;
lin angiotelectasia_N = mkTerm "angiotelectasia_N" ;
lin angiotensin_N = mkTerm "angiotensin_N" ;
lin angle_N = mkTerm "angle_N" ;
lin angle_V = mkTerm "angle_V" ;
lin angle_V2 = mkTerm "angle_V2" ;
lin angle_dozer_N = mkTerm "angle_dozer_N" ;
lin angle_for_V2 = mkTerm "angle_for_V2" ;
lin angle_iron_N = mkTerm "angle_iron_N" ;
lin angle_park_V = mkTerm "angle_park_V" ;
lin angle_park_V2 = mkTerm "angle_park_V2" ;
lin angler_N = mkTerm "angler_N" ;
lin anglewing_N = mkTerm "anglewing_N" ;
lin anglican_A = mkTerm "anglican_A" ;
lin anglican_N = mkTerm "anglican_N" ;
lin anglicism_N = mkTerm "anglicism_N" ;
lin anglicize_V2 = mkTerm "anglicize_V2" ;
lin angling_N = mkTerm "angling_N" ;
lin anglo_catholic_A = mkTerm "anglo_catholic_A" ;
lin anglo_catholic_N = mkTerm "anglo_catholic_N" ;
lin anglo_indian_A = mkTerm "anglo_indian_A" ;
lin anglo_indian_N = mkTerm "anglo_indian_N" ;
lin anglo_saxon_A = mkTerm "anglo_saxon_A" ;
lin anglo_saxon_N = mkTerm "anglo_saxon_N" ;
lin anglomania_N = mkTerm "anglomania_N" ;
lin anglophilFem_N = mkTerm "anglophilFem_N" ;
lin anglophilMasc_N = mkTerm "anglophilMasc_N" ;
lin anglophileFem_N = mkTerm "anglophileFem_N" ;
lin anglophileMasc_N = mkTerm "anglophileMasc_N" ;
lin anglophobe_N = mkTerm "anglophobe_N" ;
lin anglophobia_N = mkTerm "anglophobia_N" ;
lin angola_PN = mkTerm "angola_PN" ;
lin angolan_A = mkTerm "angolan_A" ;
lin angolan_N = mkTerm "angolan_N" ;
lin angora_N = mkTerm "angora_N" ;
lin angostura_N = mkTerm "angostura_N" ;
lin angrecum_N = mkTerm "angrecum_N" ;
lin angry_A = mkTerm "angry_A" ;
lin angst_N = mkTerm "angst_N" ;
lin angstrom_N = mkTerm "angstrom_N" ;
lin anguilla_PN = mkTerm "anguilla_PN" ;
lin anguillan_A = mkTerm "anguillan_A" ;
lin anguillan_N = mkTerm "anguillan_N" ;
lin anguine_A = mkTerm "anguine_A" ;
lin anguish_N = mkTerm "anguish_N" ;
lin anguished_A = mkTerm "anguished_A" ;
lin angular_A = mkTerm "angular_A" ;
lin angularity_N = mkTerm "angularity_N" ;
lin angulation_N = mkTerm "angulation_N" ;
lin angus_PN = mkTerm "angus_PN" ;
lin angwantibo_N = mkTerm "angwantibo_N" ;
lin anhedonia_N = mkTerm "anhedonia_N" ;
lin anhidrosis_N = mkTerm "anhidrosis_N" ;
lin anhydride_N = mkTerm "anhydride_N" ;
lin anhydrous_A = mkTerm "anhydrous_A" ;
lin ani_N = mkTerm "ani_N" ;
lin anicteric_A = mkTerm "anicteric_A" ;
lin anil_N = mkTerm "anil_N" ;
lin anile_A = mkTerm "anile_A" ;
lin aniline_N = mkTerm "aniline_N" ;
lin anima_N = mkTerm "anima_N" ;
lin animadversion_N = mkTerm "animadversion_N" ;
lin animadvert_V = mkTerm "animadvert_V" ;
lin animal_A = mkTerm "animal_A" ;
lin animal_N = mkTerm "animal_N" ;
lin animalcule_N = mkTerm "animalcule_N" ;
lin animalism_N = mkTerm "animalism_N" ;
lin animalistic_A = mkTerm "animalistic_A" ;
lin animality_N = mkTerm "animality_N" ;
lin animalization_N = mkTerm "animalization_N" ;
lin animate_A = mkTerm "animate_A" ;
lin animate_V2 = mkTerm "animate_V2" ;
lin animatedly_A = mkTerm "animatedly_A" ;
lin animatedly_Adv = mkTerm "animatedly_Adv" ;
lin animateness_N = mkTerm "animateness_N" ;
lin animating_A = mkTerm "animating_A" ;
lin animation_N = mkTerm "animation_N" ;
lin animatism_N = mkTerm "animatism_N" ;
lin animatistic_A = mkTerm "animatistic_A" ;
lin animator_N = mkTerm "animator_N" ;
lin animatronics_N = mkTerm "animatronics_N" ;
lin anime_N = mkTerm "anime_N" ;
lin animism_N = mkTerm "animism_N" ;
lin animist_A = mkTerm "animist_A" ;
lin animist_N = mkTerm "animist_N" ;
lin animosity_N = mkTerm "animosity_N" ;
lin animus_N = mkTerm "animus_N" ;
lin anion_N = mkTerm "anion_N" ;
lin anionic_A = mkTerm "anionic_A" ;
lin anise_N = mkTerm "anise_N" ;
lin aniseed_N = mkTerm "aniseed_N" ;
lin aniseikonia_N = mkTerm "aniseikonia_N" ;
lin aniseikonic_A = mkTerm "aniseikonic_A" ;
lin anisette_N = mkTerm "anisette_N" ;
lin anisogamete_N = mkTerm "anisogamete_N" ;
lin anisogametic_A = mkTerm "anisogametic_A" ;
lin anisogamic_A = mkTerm "anisogamic_A" ;
lin anisogamy_N = mkTerm "anisogamy_N" ;
lin anisometric_A = mkTerm "anisometric_A" ;
lin anisometropia_N = mkTerm "anisometropia_N" ;
lin anisometropic_A = mkTerm "anisometropic_A" ;
lin anisotropic_A = mkTerm "anisotropic_A" ;
lin anisotropy_N = mkTerm "anisotropy_N" ;
lin anita_PN = mkTerm "anita_PN" ;
lin anjala_PN = mkTerm "anjala_PN" ;
lin anjou_N = mkTerm "anjou_N" ;
lin ankara_PN = mkTerm "ankara_PN" ;
lin ankle_N = mkTerm "ankle_N" ;
lin anklebone_N = mkTerm "anklebone_N" ;
lin anklet_N = mkTerm "anklet_N" ;
lin ankus_N = mkTerm "ankus_N" ;
lin ankylosaur_N = mkTerm "ankylosaur_N" ;
lin ankylosis_N = mkTerm "ankylosis_N" ;
lin ankylotic_A = mkTerm "ankylotic_A" ;
lin ann_PN = mkTerm "ann_PN" ;
lin anna_N = mkTerm "anna_N" ;
lin anna_PN = mkTerm "anna_PN" ;
lin annabel_PN = mkTerm "annabel_PN" ;
lin annalist_N = mkTerm "annalist_N" ;
lin annalistic_A = mkTerm "annalistic_A" ;
lin annals_N = mkTerm "annals_N" ;
lin annan_PN = mkTerm "annan_PN" ;
lin anne_PN = mkTerm "anne_PN" ;
lin anneal_V2 = mkTerm "anneal_V2" ;
lin annealing_N = mkTerm "annealing_N" ;
lin annelid_A = mkTerm "annelid_A" ;
lin annelid_N = mkTerm "annelid_N" ;
lin annex_N = mkTerm "annex_N" ;
lin annex_V2 = mkTerm "annex_V2" ;
lin annexation_N = mkTerm "annexation_N" ;
lin annexational_A = mkTerm "annexational_A" ;
lin annexe_N = mkTerm "annexe_N" ;
lin annfield_PN = mkTerm "annfield_PN" ;
lin annfield_plain_PN = mkTerm "annfield_plain_PN" ;
lin annie_PN = mkTerm "annie_PN" ;
lin annihilate_V2 = mkTerm "annihilate_V2" ;
lin annihilating_A = mkTerm "annihilating_A" ;
lin annihilation_N = mkTerm "annihilation_N" ;
lin annihilative_A = mkTerm "annihilative_A" ;
lin annihilator_N = mkTerm "annihilator_N" ;
lin anniversary_N = mkTerm "anniversary_N" ;
lin annotate_V2 = mkTerm "annotate_V2" ;
lin annotation_N = mkTerm "annotation_N" ;
lin annotator_N = mkTerm "annotator_N" ;
lin announce_V2 = mkTerm "announce_V2" ;
lin announce_VS = mkTerm "announce_VS" ;
lin announcement_N = mkTerm "announcement_N" ;
lin announcer_N = mkTerm "announcer_N" ;
lin annoy_V2 = mkTerm "annoy_V2" ;
lin annoyance_N = mkTerm "annoyance_N" ;
lin annoying_A = mkTerm "annoying_A" ;
lin annual_A = mkTerm "annual_A" ;
lin annual_N = mkTerm "annual_N" ;
lin annuitant_N = mkTerm "annuitant_N" ;
lin annuity_N = mkTerm "annuity_N" ;
lin annul_V2 = mkTerm "annul_V2" ;
lin annular_A = mkTerm "annular_A" ;
lin annulet_N = mkTerm "annulet_N" ;
lin annulment_N = mkTerm "annulment_N" ;
lin annulus_N = mkTerm "annulus_N" ;
lin annum_N = mkTerm "annum_N" ;
lin annunciate_V2 = mkTerm "annunciate_V2" ;
lin annunciation_N = mkTerm "annunciation_N" ;
lin annunciator_N = mkTerm "annunciator_N" ;
lin annunciatory_A = mkTerm "annunciatory_A" ;
lin anoa_N = mkTerm "anoa_N" ;
lin anode_N = mkTerm "anode_N" ;
lin anodic_A = mkTerm "anodic_A" ;
lin anodyne_A = mkTerm "anodyne_A" ;
lin anodyne_N = mkTerm "anodyne_N" ;
lin anoint_V2 = mkTerm "anoint_V2" ;
lin anointer_N = mkTerm "anointer_N" ;
lin anointing_N = mkTerm "anointing_N" ;
lin anointment_N = mkTerm "anointment_N" ;
lin anomalist_N = mkTerm "anomalist_N" ;
lin anomalops_N = mkTerm "anomalops_N" ;
lin anomalopteryx_N = mkTerm "anomalopteryx_N" ;
lin anomalous_A = mkTerm "anomalous_A" ;
lin anomaly_N = mkTerm "anomaly_N" ;
lin anomie_N = mkTerm "anomie_N" ;
lin anon_Adv = mkTerm "anon_Adv" ;
lin anon_PN = mkTerm "anon_PN" ;
lin anonymity_N = mkTerm "anonymity_N" ;
lin anonymous_A = mkTerm "anonymous_A" ;
lin anoperineal_A = mkTerm "anoperineal_A" ;
lin anopheles_N = mkTerm "anopheles_N" ;
lin anopheline_A = mkTerm "anopheline_A" ;
lin anopheline_N = mkTerm "anopheline_N" ;
lin anopia_N = mkTerm "anopia_N" ;
lin anorak_N = mkTerm "anorak_N" ;
lin anorchism_N = mkTerm "anorchism_N" ;
lin anorectal_A = mkTerm "anorectal_A" ;
lin anorectic_A = mkTerm "anorectic_A" ;
lin anorexia_N = mkTerm "anorexia_N" ;
lin anorexic_A = mkTerm "anorexic_A" ;
lin anorexic_N = mkTerm "anorexic_N" ;
lin anorgasmia_N = mkTerm "anorgasmia_N" ;
lin anorthite_N = mkTerm "anorthite_N" ;
lin anorthitic_A = mkTerm "anorthitic_A" ;
lin anorthopia_N = mkTerm "anorthopia_N" ;
lin anosmia_N = mkTerm "anosmia_N" ;
lin anosmic_A = mkTerm "anosmic_A" ;
lin another_Det = mkTerm "another_Det" ;
lin another_Quant = mkTerm "another_Quant" ;
lin anovulation_N = mkTerm "anovulation_N" ;
lin anoxemia_N = mkTerm "anoxemia_N" ;
lin anoxemic_A = mkTerm "anoxemic_A" ;
lin anoxia_N = mkTerm "anoxia_N" ;
lin anoxic_A = mkTerm "anoxic_A" ;
lin anserine_A = mkTerm "anserine_A" ;
lin anshan_PN = mkTerm "anshan_PN" ;
lin answer_N = mkTerm "answer_N" ;
lin answer_V = mkTerm "answer_V" ;
lin answer_V2 = mkTerm "answer_V2" ;
lin answer_back_V2 = mkTerm "answer_back_V2" ;
lin answer_for_V2 = mkTerm "answer_for_V2" ;
lin answerable_A = mkTerm "answerable_A" ;
lin ant_N = mkTerm "ant_N" ;
lin ant_eater_N = mkTerm "ant_eater_N" ;
lin ant_hill_N = mkTerm "ant_hill_N" ;
lin antacid_A = mkTerm "antacid_A" ;
lin antacid_N = mkTerm "antacid_N" ;
lin antagonism_N = mkTerm "antagonism_N" ;
lin antagonist_N = mkTerm "antagonist_N" ;
lin antagonistic_A = mkTerm "antagonistic_A" ;
lin antagonize_V2 = mkTerm "antagonize_V2" ;
lin antapex_N = mkTerm "antapex_N" ;
lin antarctic_A = mkTerm "antarctic_A" ;
lin antbird_N = mkTerm "antbird_N" ;
lin ante_N = mkTerm "ante_N" ;
lin ante_meridiem_Adv = mkTerm "ante_meridiem_Adv" ;
lin antebellum_A = mkTerm "antebellum_A" ;
lin antecedence_N = mkTerm "antecedence_N" ;
lin antecedent_A = mkTerm "antecedent_A" ;
lin antecedent_N = mkTerm "antecedent_N" ;
lin antechamber_N = mkTerm "antechamber_N" ;
lin antecubital_A = mkTerm "antecubital_A" ;
lin antedate_V2 = mkTerm "antedate_V2" ;
lin antediluvian_A = mkTerm "antediluvian_A" ;
lin antediluvian_N = mkTerm "antediluvian_N" ;
lin antefix_N = mkTerm "antefix_N" ;
lin antelope_N = mkTerm "antelope_N" ;
lin antemeridian_A = mkTerm "antemeridian_A" ;
lin antemortem_A = mkTerm "antemortem_A" ;
lin antenatal_A = mkTerm "antenatal_A" ;
lin antenna_N = mkTerm "antenna_N" ;
lin antennal_A = mkTerm "antennal_A" ;
lin antenuptial_A = mkTerm "antenuptial_A" ;
lin antepenult_N = mkTerm "antepenult_N" ;
lin antepenultimate_A = mkTerm "antepenultimate_A" ;
lin anterior_A = mkTerm "anterior_A" ;
lin anteriority_N = mkTerm "anteriority_N" ;
lin anterograde_A = mkTerm "anterograde_A" ;
lin anteroom_N = mkTerm "anteroom_N" ;
lin anthea_PN = mkTerm "anthea_PN" ;
lin anthelmintic_A = mkTerm "anthelmintic_A" ;
lin anthem_N = mkTerm "anthem_N" ;
lin anther_N = mkTerm "anther_N" ;
lin antheral_A = mkTerm "antheral_A" ;
lin antheridial_A = mkTerm "antheridial_A" ;
lin antheridiophore_N = mkTerm "antheridiophore_N" ;
lin antheridium_N = mkTerm "antheridium_N" ;
lin antherozoid_N = mkTerm "antherozoid_N" ;
lin anthologist_N = mkTerm "anthologist_N" ;
lin anthology_N = mkTerm "anthology_N" ;
lin anthony_PN = mkTerm "anthony_PN" ;
lin anthophagous_A = mkTerm "anthophagous_A" ;
lin anthophyllite_N = mkTerm "anthophyllite_N" ;
lin anthozoan_N = mkTerm "anthozoan_N" ;
lin anthracite_N = mkTerm "anthracite_N" ;
lin anthracitic_A = mkTerm "anthracitic_A" ;
lin anthracosis_N = mkTerm "anthracosis_N" ;
lin anthrax_N = mkTerm "anthrax_N" ;
lin anthropic_A = mkTerm "anthropic_A" ;
lin anthropocentric_A = mkTerm "anthropocentric_A" ;
lin anthropocentrism_N = mkTerm "anthropocentrism_N" ;
lin anthropogenesis_N = mkTerm "anthropogenesis_N" ;
lin anthropogenetic_A = mkTerm "anthropogenetic_A" ;
lin anthropoid_A = mkTerm "anthropoid_A" ;
lin anthropoid_N = mkTerm "anthropoid_N" ;
lin anthropolatry_N = mkTerm "anthropolatry_N" ;
lin anthropological_A = mkTerm "anthropological_A" ;
lin anthropologistFem_N = mkTerm "anthropologistFem_N" ;
lin anthropologistMasc_N = mkTerm "anthropologistMasc_N" ;
lin anthropology_N = mkTerm "anthropology_N" ;
lin anthropometric_A = mkTerm "anthropometric_A" ;
lin anthropometry_N = mkTerm "anthropometry_N" ;
lin anthropomorphic_A = mkTerm "anthropomorphic_A" ;
lin anthropomorphism_N = mkTerm "anthropomorphism_N" ;
lin anthropophagous_A = mkTerm "anthropophagous_A" ;
lin anthropophagy_N = mkTerm "anthropophagy_N" ;
lin anthroposophy_N = mkTerm "anthroposophy_N" ;
lin anthurium_N = mkTerm "anthurium_N" ;
lin anti_A = mkTerm "anti_A" ;
lin anti_N = mkTerm "anti_N" ;
lin anti_Prep = mkTerm "anti_Prep" ;
lin anti_aircraft_A = mkTerm "anti_aircraft_A" ;
lin anti_aircraft_N = mkTerm "anti_aircraft_N" ;
lin anti_hero_N = mkTerm "anti_hero_N" ;
lin anti_personnel_A = mkTerm "anti_personnel_A" ;
lin anti_semite_A = mkTerm "anti_semite_A" ;
lin anti_semite_N = mkTerm "anti_semite_N" ;
lin anti_semitic_A = mkTerm "anti_semitic_A" ;
lin anti_semitism_N = mkTerm "anti_semitism_N" ;
lin antiadrenergic_A = mkTerm "antiadrenergic_A" ;
lin antialiasing_N = mkTerm "antialiasing_N" ;
lin antiapartheid_A = mkTerm "antiapartheid_A" ;
lin antiarrhythmic_N = mkTerm "antiarrhythmic_N" ;
lin antiauthoritarian_A = mkTerm "antiauthoritarian_A" ;
lin antibacterial_A = mkTerm "antibacterial_A" ;
lin antibacterial_N = mkTerm "antibacterial_N" ;
lin antibaryon_N = mkTerm "antibaryon_N" ;
lin antibiosis_N = mkTerm "antibiosis_N" ;
lin antibiotic_A = mkTerm "antibiotic_A" ;
lin antibiotic_N = mkTerm "antibiotic_N" ;
lin antibody_N = mkTerm "antibody_N" ;
lin antic_A = mkTerm "antic_A" ;
lin antic_N = mkTerm "antic_N" ;
lin anticancer_A = mkTerm "anticancer_A" ;
lin anticatalyst_N = mkTerm "anticatalyst_N" ;
lin anticholinergic_A = mkTerm "anticholinergic_A" ;
lin anticholinergic_N = mkTerm "anticholinergic_N" ;
lin anticholinesterase_N = mkTerm "anticholinesterase_N" ;
lin anticipant_A = mkTerm "anticipant_A" ;
lin anticipate_V = mkTerm "anticipate_V" ;
lin anticipate_V2 = mkTerm "anticipate_V2" ;
lin anticipate_VS = mkTerm "anticipate_VS" ;
lin anticipate_VV = mkTerm "anticipate_VV" ;
lin anticipation_N = mkTerm "anticipation_N" ;
lin anticipator_N = mkTerm "anticipator_N" ;
lin anticipatory_A = mkTerm "anticipatory_A" ;
lin anticlimactic_A = mkTerm "anticlimactic_A" ;
lin anticlimax_N = mkTerm "anticlimax_N" ;
lin anticlinal_A = mkTerm "anticlinal_A" ;
lin anticlockwise_Adv = mkTerm "anticlockwise_Adv" ;
lin anticoagulant_N = mkTerm "anticoagulant_N" ;
lin anticoagulation_N = mkTerm "anticoagulation_N" ;
lin anticoagulative_A = mkTerm "anticoagulative_A" ;
lin anticonvulsant_N = mkTerm "anticonvulsant_N" ;
lin antics_N = mkTerm "antics_N" ;
lin anticyclone_N = mkTerm "anticyclone_N" ;
lin anticyclonic_A = mkTerm "anticyclonic_A" ;
lin antidepressant_N = mkTerm "antidepressant_N" ;
lin antidiabetic_N = mkTerm "antidiabetic_N" ;
lin antidiarrheal_N = mkTerm "antidiarrheal_N" ;
lin antidiuretic_N = mkTerm "antidiuretic_N" ;
lin antidotal_A = mkTerm "antidotal_A" ;
lin antidote_N = mkTerm "antidote_N" ;
lin antidromic_A = mkTerm "antidromic_A" ;
lin antiemetic_N = mkTerm "antiemetic_N" ;
lin antiestablishmentarianism_N = mkTerm "antiestablishmentarianism_N" ;
lin antifeminist_N = mkTerm "antifeminist_N" ;
lin antiferromagnetic_A = mkTerm "antiferromagnetic_A" ;
lin antiferromagnetism_N = mkTerm "antiferromagnetism_N" ;
lin antiflatulent_N = mkTerm "antiflatulent_N" ;
lin antifreeze_N = mkTerm "antifreeze_N" ;
lin antifungal_N = mkTerm "antifungal_N" ;
lin antigen_N = mkTerm "antigen_N" ;
lin antigenic_A = mkTerm "antigenic_A" ;
lin antigram_N = mkTerm "antigram_N" ;
lin antigua_PN = mkTerm "antigua_PN" ;
lin antiguan_A = mkTerm "antiguan_A" ;
lin antiguan_N = mkTerm "antiguan_N" ;
lin antiheretical_A = mkTerm "antiheretical_A" ;
lin antihistamine_N = mkTerm "antihistamine_N" ;
lin antihypertensive_N = mkTerm "antihypertensive_N" ;
lin antiknock_A = mkTerm "antiknock_A" ;
lin antiknock_N = mkTerm "antiknock_N" ;
lin antilepton_N = mkTerm "antilepton_N" ;
lin antilogarithm_N = mkTerm "antilogarithm_N" ;
lin antimacassar_N = mkTerm "antimacassar_N" ;
lin antimagnetic_A = mkTerm "antimagnetic_A" ;
lin antimalarial_N = mkTerm "antimalarial_N" ;
lin antimatter_N = mkTerm "antimatter_N" ;
lin antimeson_N = mkTerm "antimeson_N" ;
lin antimetabolite_N = mkTerm "antimetabolite_N" ;
lin antimicrobial_A = mkTerm "antimicrobial_A" ;
lin antimonial_A = mkTerm "antimonial_A" ;
lin antimonic_A = mkTerm "antimonic_A" ;
lin antimonopoly_A = mkTerm "antimonopoly_A" ;
lin antimony_N = mkTerm "antimony_N" ;
lin antimuon_N = mkTerm "antimuon_N" ;
lin antimycin_N = mkTerm "antimycin_N" ;
lin antineoplastic_N = mkTerm "antineoplastic_N" ;
lin antineutrino_N = mkTerm "antineutrino_N" ;
lin antineutron_N = mkTerm "antineutron_N" ;
lin antinode_N = mkTerm "antinode_N" ;
lin antinomasia_N = mkTerm "antinomasia_N" ;
lin antinomian_A = mkTerm "antinomian_A" ;
lin antinomian_N = mkTerm "antinomian_N" ;
lin antinomianism_N = mkTerm "antinomianism_N" ;
lin antinomy_N = mkTerm "antinomy_N" ;
lin antioxidant_N = mkTerm "antioxidant_N" ;
lin antiparallel_A = mkTerm "antiparallel_A" ;
lin antiparticle_N = mkTerm "antiparticle_N" ;
lin antipasto_N = mkTerm "antipasto_N" ;
lin antipathetic_A = mkTerm "antipathetic_A" ;
lin antipathy_N = mkTerm "antipathy_N" ;
lin antiperspirant_N = mkTerm "antiperspirant_N" ;
lin antiphlogistic_A = mkTerm "antiphlogistic_A" ;
lin antiphon_N = mkTerm "antiphon_N" ;
lin antiphonary_A = mkTerm "antiphonary_A" ;
lin antiphonary_N = mkTerm "antiphonary_N" ;
lin antiphony_N = mkTerm "antiphony_N" ;
lin antiphrasis_N = mkTerm "antiphrasis_N" ;
lin antipodal_A = mkTerm "antipodal_A" ;
lin antipodal_N = mkTerm "antipodal_N" ;
lin antipode_N = mkTerm "antipode_N" ;
lin antipodes_N = mkTerm "antipodes_N" ;
lin antipollution_A = mkTerm "antipollution_A" ;
lin antipope_N = mkTerm "antipope_N" ;
lin antiproton_N = mkTerm "antiproton_N" ;
lin antiprotozoal_N = mkTerm "antiprotozoal_N" ;
lin antipruritic_N = mkTerm "antipruritic_N" ;
lin antipyresis_N = mkTerm "antipyresis_N" ;
lin antipyretic_A = mkTerm "antipyretic_A" ;
lin antipyretic_N = mkTerm "antipyretic_N" ;
lin antiquarian_A = mkTerm "antiquarian_A" ;
lin antiquarian_N = mkTerm "antiquarian_N" ;
lin antiquark_N = mkTerm "antiquark_N" ;
lin antiquary_N = mkTerm "antiquary_N" ;
lin antiquated_A = mkTerm "antiquated_A" ;
lin antique_A = mkTerm "antique_A" ;
lin antique_N = mkTerm "antique_N" ;
lin antiquity_N = mkTerm "antiquity_N" ;
lin antiredeposition_N = mkTerm "antiredeposition_N" ;
lin antirrhinum_N = mkTerm "antirrhinum_N" ;
lin antisatellite_A = mkTerm "antisatellite_A" ;
lin antisepsis_N = mkTerm "antisepsis_N" ;
lin antiseptic_A = mkTerm "antiseptic_A" ;
lin antiseptic_N = mkTerm "antiseptic_N" ;
lin antiserum_N = mkTerm "antiserum_N" ;
lin antisocial_A = mkTerm "antisocial_A" ;
lin antispasmodic_N = mkTerm "antispasmodic_N" ;
lin antistrophe_N = mkTerm "antistrophe_N" ;
lin antistrophic_A = mkTerm "antistrophic_A" ;
lin antisubmarine_A = mkTerm "antisubmarine_A" ;
lin antisyphilitic_N = mkTerm "antisyphilitic_N" ;
lin antitank_A = mkTerm "antitank_A" ;
lin antitauon_N = mkTerm "antitauon_N" ;
lin antithesis_N = mkTerm "antithesis_N" ;
lin antithetic_A = mkTerm "antithetic_A" ;
lin antithetical_A = mkTerm "antithetical_A" ;
lin antithyroid_A = mkTerm "antithyroid_A" ;
lin antitoxic_A = mkTerm "antitoxic_A" ;
lin antitoxin_N = mkTerm "antitoxin_N" ;
lin antitrade_A = mkTerm "antitrade_A" ;
lin antitrade_N = mkTerm "antitrade_N" ;
lin antitrades_N = mkTerm "antitrades_N" ;
lin antitussive_N = mkTerm "antitussive_N" ;
lin antitype_N = mkTerm "antitype_N" ;
lin antitypic_A = mkTerm "antitypic_A" ;
lin antivenin_N = mkTerm "antivenin_N" ;
lin antiviral_A = mkTerm "antiviral_A" ;
lin antiviral_N = mkTerm "antiviral_N" ;
lin antler_N = mkTerm "antler_N" ;
lin antlered_A = mkTerm "antlered_A" ;
lin antony_PN = mkTerm "antony_PN" ;
lin antonym_N = mkTerm "antonym_N" ;
lin antonymous_A = mkTerm "antonymous_A" ;
lin antonymy_N = mkTerm "antonymy_N" ;
lin antrim_PN = mkTerm "antrim_PN" ;
lin antrorse_A = mkTerm "antrorse_A" ;
lin antrum_N = mkTerm "antrum_N" ;
lin antsy_A = mkTerm "antsy_A" ;
lin antwerp_PN = mkTerm "antwerp_PN" ;
lin anuran_A = mkTerm "anuran_A" ;
lin anuresis_N = mkTerm "anuresis_N" ;
lin anuretic_A = mkTerm "anuretic_A" ;
lin anurous_A = mkTerm "anurous_A" ;
lin anus_N = mkTerm "anus_N" ;
lin anvil_N = mkTerm "anvil_N" ;
lin anxiety_N = mkTerm "anxiety_N" ;
lin anxiolytic_A = mkTerm "anxiolytic_A" ;
lin anxious_A = mkTerm "anxious_A" ;
lin anxiousness_N = mkTerm "anxiousness_N" ;
lin anyPl_Det = mkTerm "anyPl_Det" ;
lin anySg_Det = mkTerm "anySg_Det" ;
lin any_Adv = mkTerm "any_Adv" ;
lin anybody_NP = mkTerm "anybody_NP" ;
lin anyhow_Adv = mkTerm "anyhow_Adv" ;
lin anymore_Adv = mkTerm "anymore_Adv" ;
lin anyone_NP = mkTerm "anyone_NP" ;
lin anyplace_Adv = mkTerm "anyplace_Adv" ;
lin anything_NP = mkTerm "anything_NP" ;
lin anyway_Adv = mkTerm "anyway_Adv" ;
lin anywhere_Adv = mkTerm "anywhere_Adv" ;
lin aorist_N = mkTerm "aorist_N" ;
lin aoristic_A = mkTerm "aoristic_A" ;
lin aorta_N = mkTerm "aorta_N" ;
lin aortal_A = mkTerm "aortal_A" ;
lin aortitis_N = mkTerm "aortitis_N" ;
lin aoudad_N = mkTerm "aoudad_N" ;
lin apace_Adv = mkTerm "apace_Adv" ;
lin apache_N = mkTerm "apache_N" ;
lin apadana_N = mkTerm "apadana_N" ;
lin apar_N = mkTerm "apar_N" ;
lin apart_Adv = mkTerm "apart_Adv" ;
lin apart_from_Prep = mkTerm "apart_from_Prep" ;
lin apartheid_N = mkTerm "apartheid_N" ;
lin apartment_N = mkTerm "apartment_N" ;
lin apathetic_A = mkTerm "apathetic_A" ;
lin apathy_N = mkTerm "apathy_N" ;
lin apatite_N = mkTerm "apatite_N" ;
lin apatosaur_N = mkTerm "apatosaur_N" ;
lin ape_N = mkTerm "ape_N" ;
lin ape_V2 = mkTerm "ape_V2" ;
lin apeldoorn_PN = mkTerm "apeldoorn_PN" ;
lin apercu_N = mkTerm "apercu_N" ;
lin aperea_N = mkTerm "aperea_N" ;
lin aperient_A = mkTerm "aperient_A" ;
lin aperient_N = mkTerm "aperient_N" ;
lin aperiodic_A = mkTerm "aperiodic_A" ;
lin aperitif_N = mkTerm "aperitif_N" ;
lin aperture_N = mkTerm "aperture_N" ;
lin apery_N = mkTerm "apery_N" ;
lin apetalous_A = mkTerm "apetalous_A" ;
lin apex_N = mkTerm "apex_N" ;
lin aphaeresis_N = mkTerm "aphaeresis_N" ;
lin aphaeretic_A = mkTerm "aphaeretic_A" ;
lin aphagia_N = mkTerm "aphagia_N" ;
lin aphakia_N = mkTerm "aphakia_N" ;
lin aphakic_A = mkTerm "aphakic_A" ;
lin aphakic_N = mkTerm "aphakic_N" ;
lin aphanite_N = mkTerm "aphanite_N" ;
lin aphanitic_A = mkTerm "aphanitic_A" ;
lin aphasia_N = mkTerm "aphasia_N" ;
lin aphasic_A = mkTerm "aphasic_A" ;
lin aphasic_N = mkTerm "aphasic_N" ;
lin aphelion_N = mkTerm "aphelion_N" ;
lin apheresis_N = mkTerm "apheresis_N" ;
lin aphesis_N = mkTerm "aphesis_N" ;
lin aphetic_A = mkTerm "aphetic_A" ;
lin aphid_N = mkTerm "aphid_N" ;
lin aphis_N = mkTerm "aphis_N" ;
lin aphonia_N = mkTerm "aphonia_N" ;
lin aphonic_A = mkTerm "aphonic_A" ;
lin aphorism_N = mkTerm "aphorism_N" ;
lin aphorist_N = mkTerm "aphorist_N" ;
lin aphoristic_A = mkTerm "aphoristic_A" ;
lin aphotic_A = mkTerm "aphotic_A" ;
lin aphrodisia_N = mkTerm "aphrodisia_N" ;
lin aphrodisiac_A = mkTerm "aphrodisiac_A" ;
lin aphrodisiac_N = mkTerm "aphrodisiac_N" ;
lin aphyllous_A = mkTerm "aphyllous_A" ;
lin apian_A = mkTerm "apian_A" ;
lin apiarian_A = mkTerm "apiarian_A" ;
lin apiarist_N = mkTerm "apiarist_N" ;
lin apiary_N = mkTerm "apiary_N" ;
lin apical_A = mkTerm "apical_A" ;
lin apiculate_A = mkTerm "apiculate_A" ;
lin apicultural_A = mkTerm "apicultural_A" ;
lin apiculture_N = mkTerm "apiculture_N" ;
lin apiece_Adv = mkTerm "apiece_Adv" ;
lin apish_A = mkTerm "apish_A" ;
lin apishamore_N = mkTerm "apishamore_N" ;
lin apivorous_A = mkTerm "apivorous_A" ;
lin aplacental_A = mkTerm "aplacental_A" ;
lin aplanatic_A = mkTerm "aplanatic_A" ;
lin aplasia_N = mkTerm "aplasia_N" ;
lin aplite_N = mkTerm "aplite_N" ;
lin aplitic_A = mkTerm "aplitic_A" ;
lin aplomb_N = mkTerm "aplomb_N" ;
lin apnea_N = mkTerm "apnea_N" ;
lin apneic_A = mkTerm "apneic_A" ;
lin apoapsis_N = mkTerm "apoapsis_N" ;
lin apocalypse_N = mkTerm "apocalypse_N" ;
lin apocalyptic_A = mkTerm "apocalyptic_A" ;
lin apocarpous_A = mkTerm "apocarpous_A" ;
lin apochromatic_A = mkTerm "apochromatic_A" ;
lin apocope_N = mkTerm "apocope_N" ;
lin apocrine_A = mkTerm "apocrine_A" ;
lin apocrypha_N = mkTerm "apocrypha_N" ;
lin apocryphal_A = mkTerm "apocryphal_A" ;
lin apocynaceous_A = mkTerm "apocynaceous_A" ;
lin apodal_A = mkTerm "apodal_A" ;
lin apodeme_N = mkTerm "apodeme_N" ;
lin apodictic_A = mkTerm "apodictic_A" ;
lin apoenzyme_N = mkTerm "apoenzyme_N" ;
lin apogamic_A = mkTerm "apogamic_A" ;
lin apogamy_N = mkTerm "apogamy_N" ;
lin apogean_A = mkTerm "apogean_A" ;
lin apogee_N = mkTerm "apogee_N" ;
lin apojove_N = mkTerm "apojove_N" ;
lin apolemia_N = mkTerm "apolemia_N" ;
lin apolitical_A = mkTerm "apolitical_A" ;
lin apologetic_A = mkTerm "apologetic_A" ;
lin apologetics_N = mkTerm "apologetics_N" ;
lin apologist_N = mkTerm "apologist_N" ;
lin apologize_V = mkTerm "apologize_V" ;
lin apology_N = mkTerm "apology_N" ;
lin apomict_N = mkTerm "apomict_N" ;
lin apomictic_A = mkTerm "apomictic_A" ;
lin apomixis_N = mkTerm "apomixis_N" ;
lin apomorphine_N = mkTerm "apomorphine_N" ;
lin aponeurosis_N = mkTerm "aponeurosis_N" ;
lin aponeurotic_A = mkTerm "aponeurotic_A" ;
lin apopemptic_A = mkTerm "apopemptic_A" ;
lin apophasis_N = mkTerm "apophasis_N" ;
lin apophatic_A = mkTerm "apophatic_A" ;
lin apophatism_N = mkTerm "apophatism_N" ;
lin apophthegm_N = mkTerm "apophthegm_N" ;
lin apophyseal_A = mkTerm "apophyseal_A" ;
lin apophysis_N = mkTerm "apophysis_N" ;
lin apoplectic_A = mkTerm "apoplectic_A" ;
lin apoplectiform_A = mkTerm "apoplectiform_A" ;
lin apoplexy_N = mkTerm "apoplexy_N" ;
lin apoptosis_N = mkTerm "apoptosis_N" ;
lin aposelene_N = mkTerm "aposelene_N" ;
lin aposiopesis_N = mkTerm "aposiopesis_N" ;
lin aposiopetic_A = mkTerm "aposiopetic_A" ;
lin apostasy_N = mkTerm "apostasy_N" ;
lin apostate_A = mkTerm "apostate_A" ;
lin apostate_N = mkTerm "apostate_N" ;
lin apostle_N = mkTerm "apostle_N" ;
lin apostleship_N = mkTerm "apostleship_N" ;
lin apostolic_A = mkTerm "apostolic_A" ;
lin apostrophe_N = mkTerm "apostrophe_N" ;
lin apostrophic_A = mkTerm "apostrophic_A" ;
lin apostrophize_V2 = mkTerm "apostrophize_V2" ;
lin apothecary_N = mkTerm "apothecary_N" ;
lin apothecial_A = mkTerm "apothecial_A" ;
lin apothecium_N = mkTerm "apothecium_N" ;
lin apothegm_N = mkTerm "apothegm_N" ;
lin apothegmatic_A = mkTerm "apothegmatic_A" ;
lin apotheosis_N = mkTerm "apotheosis_N" ;
lin apotropaic_A = mkTerm "apotropaic_A" ;
lin appal_V2 = mkTerm "appal_V2" ;
lin appalling_A = mkTerm "appalling_A" ;
lin appalling_N = mkTerm "appalling_N" ;
lin appanage_N = mkTerm "appanage_N" ;
lin apparatchik_N = mkTerm "apparatchik_N" ;
lin apparatus_N = mkTerm "apparatus_N" ;
lin apparel_N = mkTerm "apparel_N" ;
lin apparel_V2 = mkTerm "apparel_V2" ;
lin appareled_A = mkTerm "appareled_A" ;
lin apparent_A = mkTerm "apparent_A" ;
lin apparentness_N = mkTerm "apparentness_N" ;
lin apparition_N = mkTerm "apparition_N" ;
lin apparitional_A = mkTerm "apparitional_A" ;
lin appeal_N = mkTerm "appeal_N" ;
lin appeal_V = mkTerm "appeal_V" ;
lin appeal_V2 = mkTerm "appeal_V2" ;
lin appealable_A = mkTerm "appealable_A" ;
lin appealing_A = mkTerm "appealing_A" ;
lin appear_V = mkTerm "appear_V" ;
lin appear_VA = mkTerm "appear_VA" ;
lin appear_VS = mkTerm "appear_VS" ;
lin appear_VV = mkTerm "appear_VV" ;
lin appearance_N = mkTerm "appearance_N" ;
lin appeasable_A = mkTerm "appeasable_A" ;
lin appease_V2 = mkTerm "appease_V2" ;
lin appeasement_N = mkTerm "appeasement_N" ;
lin appeaser_N = mkTerm "appeaser_N" ;
lin appellant_A = mkTerm "appellant_A" ;
lin appellant_N = mkTerm "appellant_N" ;
lin appellate_A = mkTerm "appellate_A" ;
lin appellation_N = mkTerm "appellation_N" ;
lin appellative_A = mkTerm "appellative_A" ;
lin append_V2 = mkTerm "append_V2" ;
lin appendage_N = mkTerm "appendage_N" ;
lin appendaged_A = mkTerm "appendaged_A" ;
lin appendant_A = mkTerm "appendant_A" ;
lin appendectomy_N = mkTerm "appendectomy_N" ;
lin appendicitis_N = mkTerm "appendicitis_N" ;
lin appendicle_N = mkTerm "appendicle_N" ;
lin appendicular_A = mkTerm "appendicular_A" ;
lin appendicularia_N = mkTerm "appendicularia_N" ;
lin appendix_N = mkTerm "appendix_N" ;
lin apperception_N = mkTerm "apperception_N" ;
lin apperceptive_A = mkTerm "apperceptive_A" ;
lin appertain_V = mkTerm "appertain_V" ;
lin appetent_A = mkTerm "appetent_A" ;
lin appetite_N = mkTerm "appetite_N" ;
lin appetitive_A = mkTerm "appetitive_A" ;
lin appetizer_N = mkTerm "appetizer_N" ;
lin appetizing_A = mkTerm "appetizing_A" ;
lin appetizingness_N = mkTerm "appetizingness_N" ;
lin applaud_V = mkTerm "applaud_V" ;
lin applaud_V2 = mkTerm "applaud_V2" ;
lin applaudable_A = mkTerm "applaudable_A" ;
lin applause_N = mkTerm "applause_N" ;
lin apple_N = mkTerm "apple_N" ;
lin applecart_N = mkTerm "applecart_N" ;
lin applejack_N = mkTerm "applejack_N" ;
lin applesauce_N = mkTerm "applesauce_N" ;
lin applet_N = mkTerm "applet_N" ;
lin applewood_N = mkTerm "applewood_N" ;
lin appliance_N = mkTerm "appliance_N" ;
lin applicability_N = mkTerm "applicability_N" ;
lin applicable_A = mkTerm "applicable_A" ;
lin applicant_N = mkTerm "applicant_N" ;
lin application_1_N = mkTerm "application_1_N" ;
lin application_2_N = mkTerm "application_2_N" ;
lin application_3_N = mkTerm "application_3_N" ;
lin applicative_A = mkTerm "applicative_A" ;
lin applicator_N = mkTerm "applicator_N" ;
lin applied_A = mkTerm "applied_A" ;
lin applique_N = mkTerm "applique_N" ;
lin applique_V2 = mkTerm "applique_V2" ;
lin apply_V = mkTerm "apply_V" ;
lin apply_V2 = mkTerm "apply_V2" ;
lin apply_V2V = mkTerm "apply_V2V" ;
lin apply_VV = mkTerm "apply_VV" ;
lin apply_for_V2 = mkTerm "apply_for_V2" ;
lin appoint_V2 = mkTerm "appoint_V2" ;
lin appoint_V2V = mkTerm "appoint_V2V" ;
lin appoint_V3 = mkTerm "appoint_V3" ;
lin appointed_A = mkTerm "appointed_A" ;
lin appointee_N = mkTerm "appointee_N" ;
lin appointive_A = mkTerm "appointive_A" ;
lin appointment_N = mkTerm "appointment_N" ;
lin apportion_V2 = mkTerm "apportion_V2" ;
lin apportionment_N = mkTerm "apportionment_N" ;
lin apposite_A = mkTerm "apposite_A" ;
lin apposition_N = mkTerm "apposition_N" ;
lin appositional_A = mkTerm "appositional_A" ;
lin appositively_Adv = mkTerm "appositively_Adv" ;
lin appraisal_N = mkTerm "appraisal_N" ;
lin appraise_V2 = mkTerm "appraise_V2" ;
lin appraiser_N = mkTerm "appraiser_N" ;
lin appreciable_A = mkTerm "appreciable_A" ;
lin appreciate_V = mkTerm "appreciate_V" ;
lin appreciate_V2 = mkTerm "appreciate_V2" ;
lin appreciation_N = mkTerm "appreciation_N" ;
lin appreciative_A = mkTerm "appreciative_A" ;
lin appreciator_N = mkTerm "appreciator_N" ;
lin apprehend_V2 = mkTerm "apprehend_V2" ;
lin apprehender_N = mkTerm "apprehender_N" ;
lin apprehensible_A = mkTerm "apprehensible_A" ;
lin apprehension_N = mkTerm "apprehension_N" ;
lin apprehensive_A = mkTerm "apprehensive_A" ;
lin apprentice_N = mkTerm "apprentice_N" ;
lin apprentice_V2 = mkTerm "apprentice_V2" ;
lin apprenticeship_N = mkTerm "apprenticeship_N" ;
lin appressed_A = mkTerm "appressed_A" ;
lin apprise_V2 = mkTerm "apprise_V2" ;
lin appro_N = mkTerm "appro_N" ;
lin approach_N = mkTerm "approach_N" ;
lin approach_V = mkTerm "approach_V" ;
lin approach_V2 = mkTerm "approach_V2" ;
lin approachability_N = mkTerm "approachability_N" ;
lin approachable_A = mkTerm "approachable_A" ;
lin approbation_N = mkTerm "approbation_N" ;
lin appropriable_A = mkTerm "appropriable_A" ;
lin appropriate_A = mkTerm "appropriate_A" ;
lin appropriate_V2 = mkTerm "appropriate_V2" ;
lin appropriateness_N = mkTerm "appropriateness_N" ;
lin appropriation_N = mkTerm "appropriation_N" ;
lin appropriative_A = mkTerm "appropriative_A" ;
lin appropriator_N = mkTerm "appropriator_N" ;
lin approval_N = mkTerm "approval_N" ;
lin approve_V = mkTerm "approve_V" ;
lin approve_V2 = mkTerm "approve_V2" ;
lin approved_A = mkTerm "approved_A" ;
lin approver_N = mkTerm "approver_N" ;
lin approvingly_Adv = mkTerm "approvingly_Adv" ;
lin approx_PN = mkTerm "approx_PN" ;
lin approximate_A = mkTerm "approximate_A" ;
lin approximate_V = mkTerm "approximate_V" ;
lin approximate_V2 = mkTerm "approximate_V2" ;
lin approximately_Adv = mkTerm "approximately_Adv" ;
lin approximation_N = mkTerm "approximation_N" ;
lin appurtenance_N = mkTerm "appurtenance_N" ;
lin apr_PN = mkTerm "apr_PN" ;
lin apractic_A = mkTerm "apractic_A" ;
lin apraxia_N = mkTerm "apraxia_N" ;
lin apres_ski_A = mkTerm "apres_ski_A" ;
lin apricot_N = mkTerm "apricot_N" ;
lin apron_N = mkTerm "apron_N" ;
lin apropos_A = mkTerm "apropos_A" ;
lin apropos_Adv = mkTerm "apropos_Adv" ;
lin apropos_Prep = mkTerm "apropos_Prep" ;
lin apse_N = mkTerm "apse_N" ;
lin apsidal_A = mkTerm "apsidal_A" ;
lin apt_A = mkTerm "apt_A" ;
lin apteral_A = mkTerm "apteral_A" ;
lin apterous_A = mkTerm "apterous_A" ;
lin aptitude_N = mkTerm "aptitude_N" ;
lin aptitudinal_A = mkTerm "aptitudinal_A" ;
lin aptness_N = mkTerm "aptness_N" ;
lin apud_Prep = mkTerm "apud_Prep" ;
lin aquaculture_N = mkTerm "aquaculture_N" ;
lin aqualung_N = mkTerm "aqualung_N" ;
lin aquamarine_N = mkTerm "aquamarine_N" ;
lin aquanaut_N = mkTerm "aquanaut_N" ;
lin aquaphobia_N = mkTerm "aquaphobia_N" ;
lin aquaplane_N = mkTerm "aquaplane_N" ;
lin aquaplane_V = mkTerm "aquaplane_V" ;
lin aquarium_N = mkTerm "aquarium_N" ;
lin aquarius_PN = mkTerm "aquarius_PN" ;
lin aquatic_A = mkTerm "aquatic_A" ;
lin aquatic_N = mkTerm "aquatic_N" ;
lin aquatint_N = mkTerm "aquatint_N" ;
lin aquavit_N = mkTerm "aquavit_N" ;
lin aqueduct_N = mkTerm "aqueduct_N" ;
lin aqueous_A = mkTerm "aqueous_A" ;
lin aquicultural_A = mkTerm "aquicultural_A" ;
lin aquifer_N = mkTerm "aquifer_N" ;
lin aquiferous_A = mkTerm "aquiferous_A" ;
lin aquiline_A = mkTerm "aquiline_A" ;
lin arab_A = mkTerm "arab_A" ;
lin arab_N = mkTerm "arab_N" ;
lin arabesque_N = mkTerm "arabesque_N" ;
lin arabianFem_N = mkTerm "arabianFem_N" ;
lin arabianMasc_N = mkTerm "arabianMasc_N" ;
lin arabian_A = mkTerm "arabian_A" ;
lin arabic_A = mkTerm "arabic_A" ;
lin arability_N = mkTerm "arability_N" ;
lin arabist_N = mkTerm "arabist_N" ;
lin arable_A = mkTerm "arable_A" ;
lin arachnid_N = mkTerm "arachnid_N" ;
lin arachnoid_A = mkTerm "arachnoid_A" ;
lin arachnoid_N = mkTerm "arachnoid_N" ;
lin arachnophobia_N = mkTerm "arachnophobia_N" ;
lin aragonite_N = mkTerm "aragonite_N" ;
lin aralia_N = mkTerm "aralia_N" ;
lin arame_N = mkTerm "arame_N" ;
lin araneidal_A = mkTerm "araneidal_A" ;
lin arariba_N = mkTerm "arariba_N" ;
lin araroba_N = mkTerm "araroba_N" ;
lin araucaria_N = mkTerm "araucaria_N" ;
lin arbiter_N = mkTerm "arbiter_N" ;
lin arbitrable_A = mkTerm "arbitrable_A" ;
lin arbitrage_N = mkTerm "arbitrage_N" ;
lin arbitrageur_N = mkTerm "arbitrageur_N" ;
lin arbitral_A = mkTerm "arbitral_A" ;
lin arbitrament_N = mkTerm "arbitrament_N" ;
lin arbitrary_A = mkTerm "arbitrary_A" ;
lin arbitrate_V = mkTerm "arbitrate_V" ;
lin arbitrate_V2 = mkTerm "arbitrate_V2" ;
lin arbitration_N = mkTerm "arbitration_N" ;
lin arbitrative_A = mkTerm "arbitrative_A" ;
lin arbitrator_N = mkTerm "arbitrator_N" ;
lin arbor_N = mkTerm "arbor_N" ;
lin arboraceous_A = mkTerm "arboraceous_A" ;
lin arboreal_A = mkTerm "arboreal_A" ;
lin arboretum_N = mkTerm "arboretum_N" ;
lin arborical_A = mkTerm "arborical_A" ;
lin arboriculture_N = mkTerm "arboriculture_N" ;
lin arborolatry_N = mkTerm "arborolatry_N" ;
lin arborvitae_N = mkTerm "arborvitae_N" ;
lin arbour_N = mkTerm "arbour_N" ;
lin arbovirus_N = mkTerm "arbovirus_N" ;
lin arbroath_PN = mkTerm "arbroath_PN" ;
lin arbutus_N = mkTerm "arbutus_N" ;
lin arc_N = mkTerm "arc_N" ;
lin arc_lamp_N = mkTerm "arc_lamp_N" ;
lin arc_light_N = mkTerm "arc_light_N" ;
lin arcade_N = mkTerm "arcade_N" ;
lin arcadian_A = mkTerm "arcadian_A" ;
lin arcadian_N = mkTerm "arcadian_N" ;
lin arcane_A = mkTerm "arcane_A" ;
lin arced_A = mkTerm "arced_A" ;
lin arcella_N = mkTerm "arcella_N" ;
lin arch_A = mkTerm "arch_A" ;
lin arch_N = mkTerm "arch_N" ;
lin arch_V = mkTerm "arch_V" ;
lin arch_V2 = mkTerm "arch_V2" ;
lin archaebacteria_N = mkTerm "archaebacteria_N" ;
lin archaeological_A = mkTerm "archaeological_A" ;
lin archaeologist_N = mkTerm "archaeologist_N" ;
lin archaeology_N = mkTerm "archaeology_N" ;
lin archaeopteryx_N = mkTerm "archaeopteryx_N" ;
lin archaeornis_N = mkTerm "archaeornis_N" ;
lin archaic_A = mkTerm "archaic_A" ;
lin archaism_N = mkTerm "archaism_N" ;
lin archaist_N = mkTerm "archaist_N" ;
lin archaistic_A = mkTerm "archaistic_A" ;
lin archangel_N = mkTerm "archangel_N" ;
lin archangelic_A = mkTerm "archangelic_A" ;
lin archbishop_N = mkTerm "archbishop_N" ;
lin archbishopric_N = mkTerm "archbishopric_N" ;
lin archdeacon_N = mkTerm "archdeacon_N" ;
lin archdeaconry_N = mkTerm "archdeaconry_N" ;
lin archdiocesan_A = mkTerm "archdiocesan_A" ;
lin archdiocese_N = mkTerm "archdiocese_N" ;
lin archducal_A = mkTerm "archducal_A" ;
lin archduchess_N = mkTerm "archduchess_N" ;
lin archduchy_N = mkTerm "archduchy_N" ;
lin archduke_N = mkTerm "archduke_N" ;
lin archean_A = mkTerm "archean_A" ;
lin archegonial_A = mkTerm "archegonial_A" ;
lin archegonium_N = mkTerm "archegonium_N" ;
lin archenteron_N = mkTerm "archenteron_N" ;
lin archeozoic_A = mkTerm "archeozoic_A" ;
lin archer_N = mkTerm "archer_N" ;
lin archerfish_N = mkTerm "archerfish_N" ;
lin archery_N = mkTerm "archery_N" ;
lin archespore_N = mkTerm "archespore_N" ;
lin archesporial_A = mkTerm "archesporial_A" ;
lin archetypal_A = mkTerm "archetypal_A" ;
lin archetype_N = mkTerm "archetype_N" ;
lin archiannelid_N = mkTerm "archiannelid_N" ;
lin archidiaconal_A = mkTerm "archidiaconal_A" ;
lin archidiaconate_N = mkTerm "archidiaconate_N" ;
lin archiepiscopal_A = mkTerm "archiepiscopal_A" ;
lin archil_N = mkTerm "archil_N" ;
lin archimandrite_N = mkTerm "archimandrite_N" ;
lin archine_N = mkTerm "archine_N" ;
lin archipallium_N = mkTerm "archipallium_N" ;
lin archipelagic_A = mkTerm "archipelagic_A" ;
lin archipelago_N = mkTerm "archipelago_N" ;
lin architectFem_N = mkTerm "architectFem_N" ;
lin architectMasc_N = mkTerm "architectMasc_N" ;
lin architectonics_N = mkTerm "architectonics_N" ;
lin architectural_A = mkTerm "architectural_A" ;
lin architecture_N = mkTerm "architecture_N" ;
lin architeuthis_N = mkTerm "architeuthis_N" ;
lin architrave_N = mkTerm "architrave_N" ;
lin archival_A = mkTerm "archival_A" ;
lin archive_N = mkTerm "archive_N" ;
lin archives_N = mkTerm "archives_N" ;
lin archivist_N = mkTerm "archivist_N" ;
lin archosaur_N = mkTerm "archosaur_N" ;
lin archosaurian_A = mkTerm "archosaurian_A" ;
lin archpriest_N = mkTerm "archpriest_N" ;
lin archway_N = mkTerm "archway_N" ;
lin arco_A = mkTerm "arco_A" ;
lin arctic_A = mkTerm "arctic_A" ;
lin arctic_N = mkTerm "arctic_N" ;
lin arctiid_N = mkTerm "arctiid_N" ;
lin arcus_N = mkTerm "arcus_N" ;
lin ardeb_N = mkTerm "ardeb_N" ;
lin ardent_A = mkTerm "ardent_A" ;
lin ardor_N = mkTerm "ardor_N" ;
lin ardour_N = mkTerm "ardour_N" ;
lin ardrossan_PN = mkTerm "ardrossan_PN" ;
lin arduous_A = mkTerm "arduous_A" ;
lin arduousness_N = mkTerm "arduousness_N" ;
lin are_N = mkTerm "are_N" ;
lin area_1_N = mkTerm "area_1_N" ;
lin area_2_N = mkTerm "area_2_N" ;
lin area_3_N = mkTerm "area_3_N" ;
lin area_4_N = mkTerm "area_4_N" ;
lin area_5_N = mkTerm "area_5_N" ;
lin area_6_N = mkTerm "area_6_N" ;
lin areal_A = mkTerm "areal_A" ;
lin areaway_N = mkTerm "areaway_N" ;
lin areca_N = mkTerm "areca_N" ;
lin areflexia_N = mkTerm "areflexia_N" ;
lin arena_N = mkTerm "arena_N" ;
lin arenaceous_A = mkTerm "arenaceous_A" ;
lin arenavirus_N = mkTerm "arenavirus_N" ;
lin arenicolous_A = mkTerm "arenicolous_A" ;
lin areola_N = mkTerm "areola_N" ;
lin areolar_A = mkTerm "areolar_A" ;
lin arete_N = mkTerm "arete_N" ;
lin arethusa_N = mkTerm "arethusa_N" ;
lin argali_N = mkTerm "argali_N" ;
lin argent_A = mkTerm "argent_A" ;
lin argent_N = mkTerm "argent_N" ;
lin argentic_A = mkTerm "argentic_A" ;
lin argentiferous_A = mkTerm "argentiferous_A" ;
lin argentina_PN = mkTerm "argentina_PN" ;
lin argentine_N = mkTerm "argentine_N" ;
lin argentine_PN = mkTerm "argentine_PN" ;
lin argentinian_A = mkTerm "argentinian_A" ;
lin argentinian_N = mkTerm "argentinian_N" ;
lin argentinosaur_N = mkTerm "argentinosaur_N" ;
lin argentite_N = mkTerm "argentite_N" ;
lin argentous_A = mkTerm "argentous_A" ;
lin argil_N = mkTerm "argil_N" ;
lin argillaceous_A = mkTerm "argillaceous_A" ;
lin argillite_N = mkTerm "argillite_N" ;
lin arginine_N = mkTerm "arginine_N" ;
lin argon_N = mkTerm "argon_N" ;
lin argonaut_N = mkTerm "argonaut_N" ;
lin argosy_N = mkTerm "argosy_N" ;
lin argot_N = mkTerm "argot_N" ;
lin arguable_A = mkTerm "arguable_A" ;
lin argue_V = mkTerm "argue_V" ;
lin argue_V2 = mkTerm "argue_V2" ;
lin argue_VS = mkTerm "argue_VS" ;
lin argue_down_V2 = mkTerm "argue_down_V2" ;
lin argue_out_V2 = mkTerm "argue_out_V2" ;
lin argument_N = mkTerm "argument_N" ;
lin argumentation_N = mkTerm "argumentation_N" ;
lin argumentative_A = mkTerm "argumentative_A" ;
lin argus_N = mkTerm "argus_N" ;
lin argus_eyed_A = mkTerm "argus_eyed_A" ;
lin argyle_N = mkTerm "argyle_N" ;
lin argyll_N = mkTerm "argyll_N" ;
lin argyrodite_N = mkTerm "argyrodite_N" ;
lin aria_N = mkTerm "aria_N" ;
lin arianist_N = mkTerm "arianist_N" ;
lin arid_A = mkTerm "arid_A" ;
lin aridity_N = mkTerm "aridity_N" ;
lin aries_PN = mkTerm "aries_PN" ;
lin arietta_N = mkTerm "arietta_N" ;
lin aright_Adv = mkTerm "aright_Adv" ;
lin aril_N = mkTerm "aril_N" ;
lin ariled_A = mkTerm "ariled_A" ;
lin ariose_A = mkTerm "ariose_A" ;
lin arioso_N = mkTerm "arioso_N" ;
lin arise_V = mkTerm "arise_V" ;
lin arista_N = mkTerm "arista_N" ;
lin aristocracy_N = mkTerm "aristocracy_N" ;
lin aristocrat_N = mkTerm "aristocrat_N" ;
lin aristocratic_A = mkTerm "aristocratic_A" ;
lin arithmancy_N = mkTerm "arithmancy_N" ;
lin arithmetic_N = mkTerm "arithmetic_N" ;
lin arithmetical_A = mkTerm "arithmetical_A" ;
lin arithmetician_N = mkTerm "arithmetician_N" ;
lin arity_N = mkTerm "arity_N" ;
lin arizona_PN = mkTerm "arizona_PN" ;
lin ark_N = mkTerm "ark_N" ;
lin arkansas_PN = mkTerm "arkansas_PN" ;
lin arm_1_N = mkTerm "arm_1_N" ;
lin arm_2_N = mkTerm "arm_2_N" ;
lin arm_V = mkTerm "arm_V" ;
lin arm_V2 = mkTerm "arm_V2" ;
lin arm_hole_N = mkTerm "arm_hole_N" ;
lin armada_N = mkTerm "armada_N" ;
lin armadale_PN = mkTerm "armadale_PN" ;
lin armadillo_N = mkTerm "armadillo_N" ;
lin armageddon_PN = mkTerm "armageddon_PN" ;
lin armagh_PN = mkTerm "armagh_PN" ;
lin armament_N = mkTerm "armament_N" ;
lin armamentarium_N = mkTerm "armamentarium_N" ;
lin armature_N = mkTerm "armature_N" ;
lin armband_N = mkTerm "armband_N" ;
lin armchair_N = mkTerm "armchair_N" ;
lin armed_A = mkTerm "armed_A" ;
lin armenian_N = mkTerm "armenian_N" ;
lin armet_N = mkTerm "armet_N" ;
lin armful_N = mkTerm "armful_N" ;
lin armiger_N = mkTerm "armiger_N" ;
lin armilla_N = mkTerm "armilla_N" ;
lin armillary_A = mkTerm "armillary_A" ;
lin arming_N = mkTerm "arming_N" ;
lin armistice_N = mkTerm "armistice_N" ;
lin armless_A = mkTerm "armless_A" ;
lin armlet_N = mkTerm "armlet_N" ;
lin armlike_A = mkTerm "armlike_A" ;
lin armoire_N = mkTerm "armoire_N" ;
lin armored_A = mkTerm "armored_A" ;
lin armorial_A = mkTerm "armorial_A" ;
lin armour_N = mkTerm "armour_N" ;
lin armour_plate_N = mkTerm "armour_plate_N" ;
lin armoured_A = mkTerm "armoured_A" ;
lin armourer_N = mkTerm "armourer_N" ;
lin armoury_N = mkTerm "armoury_N" ;
lin armpit_N = mkTerm "armpit_N" ;
lin armrest_N = mkTerm "armrest_N" ;
lin arms_race_N = mkTerm "arms_race_N" ;
lin arms_runner_N = mkTerm "arms_runner_N" ;
lin army_N = mkTerm "army_N" ;
lin armyworm_N = mkTerm "armyworm_N" ;
lin arnhem_PN = mkTerm "arnhem_PN" ;
lin arnica_N = mkTerm "arnica_N" ;
lin arnold_PN = mkTerm "arnold_PN" ;
lin aroid_A = mkTerm "aroid_A" ;
lin aroma_N = mkTerm "aroma_N" ;
lin aromatherapy_N = mkTerm "aromatherapy_N" ;
lin aromatic_A = mkTerm "aromatic_A" ;
lin arose_V2 = mkTerm "arose_V2" ;
lin around_AdN = mkTerm "around_AdN" ;
lin around_Adv = mkTerm "around_Adv" ;
lin around_Prep = mkTerm "around_Prep" ;
lin arousal_N = mkTerm "arousal_N" ;
lin arouse_V2 = mkTerm "arouse_V2" ;
lin arouse_V2V = mkTerm "arouse_V2V" ;
lin arpeggio_N = mkTerm "arpeggio_N" ;
lin arpent_N = mkTerm "arpent_N" ;
lin arquebus_N = mkTerm "arquebus_N" ;
lin arr_PN = mkTerm "arr_PN" ;
lin arrack_N = mkTerm "arrack_N" ;
lin arraign_V2 = mkTerm "arraign_V2" ;
lin arraignment_N = mkTerm "arraignment_N" ;
lin arrange_V = mkTerm "arrange_V" ;
lin arrange_V2 = mkTerm "arrange_V2" ;
lin arrangement_N = mkTerm "arrangement_N" ;
lin arranger_N = mkTerm "arranger_N" ;
lin arrant_A = mkTerm "arrant_A" ;
lin arras_N = mkTerm "arras_N" ;
lin array_N = mkTerm "array_N" ;
lin array_V2 = mkTerm "array_V2" ;
lin arrears_N = mkTerm "arrears_N" ;
lin arrest_N = mkTerm "arrest_N" ;
lin arrest_V2 = mkTerm "arrest_V2" ;
lin arrester_N = mkTerm "arrester_N" ;
lin arresting_A = mkTerm "arresting_A" ;
lin arrhythmic_A = mkTerm "arrhythmic_A" ;
lin arriere_pensee_N = mkTerm "arriere_pensee_N" ;
lin arrival_N = mkTerm "arrival_N" ;
lin arrive_V = mkTerm "arrive_V" ;
lin arroba_N = mkTerm "arroba_N" ;
lin arrogance_N = mkTerm "arrogance_N" ;
lin arrogant_A = mkTerm "arrogant_A" ;
lin arrogate_V2 = mkTerm "arrogate_V2" ;
lin arrogator_N = mkTerm "arrogator_N" ;
lin arrondissement_N = mkTerm "arrondissement_N" ;
lin arrow_N = mkTerm "arrow_N" ;
lin arrowhead_N = mkTerm "arrowhead_N" ;
lin arrowroot_N = mkTerm "arrowroot_N" ;
lin arrowsmith_N = mkTerm "arrowsmith_N" ;
lin arrowworm_N = mkTerm "arrowworm_N" ;
lin arroyo_N = mkTerm "arroyo_N" ;
lin arse_N = mkTerm "arse_N" ;
lin arsehole_N = mkTerm "arsehole_N" ;
lin arsenal_N = mkTerm "arsenal_N" ;
lin arsenate_N = mkTerm "arsenate_N" ;
lin arsenic_N = mkTerm "arsenic_N" ;
lin arsenical_A = mkTerm "arsenical_A" ;
lin arsenical_N = mkTerm "arsenical_N" ;
lin arsenide_N = mkTerm "arsenide_N" ;
lin arsenious_A = mkTerm "arsenious_A" ;
lin arsenopyrite_N = mkTerm "arsenopyrite_N" ;
lin arsine_N = mkTerm "arsine_N" ;
lin arson_N = mkTerm "arson_N" ;
lin arsonist_N = mkTerm "arsonist_N" ;
lin art_N = mkTerm "art_N" ;
lin art_PN = mkTerm "art_PN" ;
lin artefact_N = mkTerm "artefact_N" ;
lin artemisia_N = mkTerm "artemisia_N" ;
lin arterial_A = mkTerm "arterial_A" ;
lin arteriectasis_N = mkTerm "arteriectasis_N" ;
lin arteriogram_N = mkTerm "arteriogram_N" ;
lin arteriography_N = mkTerm "arteriography_N" ;
lin arteriolar_A = mkTerm "arteriolar_A" ;
lin arteriole_N = mkTerm "arteriole_N" ;
lin arteriolosclerosis_N = mkTerm "arteriolosclerosis_N" ;
lin arteriosclerosis_N = mkTerm "arteriosclerosis_N" ;
lin arteriosclerotic_A = mkTerm "arteriosclerotic_A" ;
lin arteriovenous_A = mkTerm "arteriovenous_A" ;
lin arteritis_N = mkTerm "arteritis_N" ;
lin artery_N = mkTerm "artery_N" ;
lin artesian_A = mkTerm "artesian_A" ;
lin artful_A = mkTerm "artful_A" ;
lin artfulness_N = mkTerm "artfulness_N" ;
lin arthralgia_N = mkTerm "arthralgia_N" ;
lin arthralgic_A = mkTerm "arthralgic_A" ;
lin arthritic_A = mkTerm "arthritic_A" ;
lin arthritic_N = mkTerm "arthritic_N" ;
lin arthritis_N = mkTerm "arthritis_N" ;
lin arthrocentesis_N = mkTerm "arthrocentesis_N" ;
lin arthrodesis_N = mkTerm "arthrodesis_N" ;
lin arthrogram_N = mkTerm "arthrogram_N" ;
lin arthrography_N = mkTerm "arthrography_N" ;
lin arthromere_N = mkTerm "arthromere_N" ;
lin arthromeric_A = mkTerm "arthromeric_A" ;
lin arthropathy_N = mkTerm "arthropathy_N" ;
lin arthroplasty_N = mkTerm "arthroplasty_N" ;
lin arthropod_N = mkTerm "arthropod_N" ;
lin arthropodal_A = mkTerm "arthropodal_A" ;
lin arthroscope_N = mkTerm "arthroscope_N" ;
lin arthroscopy_N = mkTerm "arthroscopy_N" ;
lin arthrospore_N = mkTerm "arthrospore_N" ;
lin arthrosporic_A = mkTerm "arthrosporic_A" ;
lin arthur_PN = mkTerm "arthur_PN" ;
lin artichoke_N = mkTerm "artichoke_N" ;
lin article_N = mkTerm "article_N" ;
lin article_V2 = mkTerm "article_V2" ;
lin articular_A = mkTerm "articular_A" ;
lin articulate_A = mkTerm "articulate_A" ;
lin articulate_V = mkTerm "articulate_V" ;
lin articulate_V2 = mkTerm "articulate_V2" ;
lin articulation_N = mkTerm "articulation_N" ;
lin articulator_N = mkTerm "articulator_N" ;
lin articulatory_A = mkTerm "articulatory_A" ;
lin artie_PN = mkTerm "artie_PN" ;
lin artifact_N = mkTerm "artifact_N" ;
lin artifactual_A = mkTerm "artifactual_A" ;
lin artifice_N = mkTerm "artifice_N" ;
lin artificer_N = mkTerm "artificer_N" ;
lin artificial_A = mkTerm "artificial_A" ;
lin artificiality_N = mkTerm "artificiality_N" ;
lin artillery_N = mkTerm "artillery_N" ;
lin artilleryman_N = mkTerm "artilleryman_N" ;
lin artiodactyl_A = mkTerm "artiodactyl_A" ;
lin artisan_N = mkTerm "artisan_N" ;
lin artist_N = mkTerm "artist_N" ;
lin artiste_N = mkTerm "artiste_N" ;
lin artistic_A = mkTerm "artistic_A" ;
lin artistry_N = mkTerm "artistry_N" ;
lin artjärvi_PN = mkTerm "artjärvi_PN" ;
lin artless_A = mkTerm "artless_A" ;
lin artlessness_N = mkTerm "artlessness_N" ;
lin artwork_N = mkTerm "artwork_N" ;
lin arty_A = mkTerm "arty_A" ;
lin arty_crafty_A = mkTerm "arty_crafty_A" ;
lin arum_N = mkTerm "arum_N" ;
lin arundinaceous_A = mkTerm "arundinaceous_A" ;
lin aryanFem_N = mkTerm "aryanFem_N" ;
lin aryanMasc_N = mkTerm "aryanMasc_N" ;
lin aryan_A = mkTerm "aryan_A" ;
lin arytenoid_N = mkTerm "arytenoid_N" ;
lin as_Prep = mkTerm "as_Prep" ;
lin as_Subj = mkTerm "as_Subj" ;
lin as_for_Prep = mkTerm "as_for_Prep" ;
lin as_long_as_Subj = mkTerm "as_long_as_Subj" ;
lin as_of_Prep = mkTerm "as_of_Prep" ;
lin as_opposed_to_Prep = mkTerm "as_opposed_to_Prep" ;
lin as_per_Prep = mkTerm "as_per_Prep" ;
lin as_regards_Prep = mkTerm "as_regards_Prep" ;
lin as_well_Adv = mkTerm "as_well_Adv" ;
lin as_well_as_Conj = mkTerm "as_well_as_Conj" ;
lin asafetida_N = mkTerm "asafetida_N" ;
lin asana_N = mkTerm "asana_N" ;
lin asap_PN = mkTerm "asap_PN" ;
lin asarabacca_N = mkTerm "asarabacca_N" ;
lin asbestos_N = mkTerm "asbestos_N" ;
lin asbestosis_N = mkTerm "asbestosis_N" ;
lin ascariasis_N = mkTerm "ascariasis_N" ;
lin ascend_V = mkTerm "ascend_V" ;
lin ascend_V2 = mkTerm "ascend_V2" ;
lin ascendable_A = mkTerm "ascendable_A" ;
lin ascendancy_N = mkTerm "ascendancy_N" ;
lin ascendant_A = mkTerm "ascendant_A" ;
lin ascendant_N = mkTerm "ascendant_N" ;
lin ascendency_N = mkTerm "ascendency_N" ;
lin ascendent_N = mkTerm "ascendent_N" ;
lin ascender_N = mkTerm "ascender_N" ;
lin ascension_N = mkTerm "ascension_N" ;
lin ascensional_A = mkTerm "ascensional_A" ;
lin ascent_N = mkTerm "ascent_N" ;
lin ascertain_V2 = mkTerm "ascertain_V2" ;
lin ascertainable_A = mkTerm "ascertainable_A" ;
lin ascetic_A = mkTerm "ascetic_A" ;
lin ascetic_N = mkTerm "ascetic_N" ;
lin asceticism_N = mkTerm "asceticism_N" ;
lin ascidian_N = mkTerm "ascidian_N" ;
lin ascites_N = mkTerm "ascites_N" ;
lin ascitic_A = mkTerm "ascitic_A" ;
lin asclepiad_N = mkTerm "asclepiad_N" ;
lin asclepiadaceous_A = mkTerm "asclepiadaceous_A" ;
lin ascocarp_N = mkTerm "ascocarp_N" ;
lin ascocarpous_A = mkTerm "ascocarpous_A" ;
lin ascolichen_N = mkTerm "ascolichen_N" ;
lin ascoma_N = mkTerm "ascoma_N" ;
lin ascomycete_N = mkTerm "ascomycete_N" ;
lin ascomycetous_A = mkTerm "ascomycetous_A" ;
lin ascorbic_A = mkTerm "ascorbic_A" ;
lin ascospore_N = mkTerm "ascospore_N" ;
lin ascosporic_A = mkTerm "ascosporic_A" ;
lin ascot_N = mkTerm "ascot_N" ;
lin ascot_PN = mkTerm "ascot_PN" ;
lin ascribable_A = mkTerm "ascribable_A" ;
lin ascribe_V2 = mkTerm "ascribe_V2" ;
lin ascription_N = mkTerm "ascription_N" ;
lin ascus_N = mkTerm "ascus_N" ;
lin asdic_N = mkTerm "asdic_N" ;
lin asepsis_N = mkTerm "asepsis_N" ;
lin aseptic_A = mkTerm "aseptic_A" ;
lin asexual_A = mkTerm "asexual_A" ;
lin asexuality_N = mkTerm "asexuality_N" ;
lin ash_N = mkTerm "ash_N" ;
lin ash_bin_N = mkTerm "ash_bin_N" ;
lin ash_can_N = mkTerm "ash_can_N" ;
lin ash_key_N = mkTerm "ash_key_N" ;
lin ash_pan_N = mkTerm "ash_pan_N" ;
lin ashamed_A = mkTerm "ashamed_A" ;
lin ashbourne_PN = mkTerm "ashbourne_PN" ;
lin ashby_PN = mkTerm "ashby_PN" ;
lin ashby_de_la_zouch_PN = mkTerm "ashby_de_la_zouch_PN" ;
lin ashby_woulds_PN = mkTerm "ashby_woulds_PN" ;
lin ashcake_N = mkTerm "ashcake_N" ;
lin ashen_A = mkTerm "ashen_A" ;
lin ashford_PN = mkTerm "ashford_PN" ;
lin ashington_PN = mkTerm "ashington_PN" ;
lin ashlar_N = mkTerm "ashlar_N" ;
lin ashore_Adv = mkTerm "ashore_Adv" ;
lin ashram_N = mkTerm "ashram_N" ;
lin ashton_in_makerfield_PN = mkTerm "ashton_in_makerfield_PN" ;
lin ashton_under_lyne_PN = mkTerm "ashton_under_lyne_PN" ;
lin ashtray_N = mkTerm "ashtray_N" ;
lin ashy_A = mkTerm "ashy_A" ;
lin asian_A = mkTerm "asian_A" ;
lin asian_N = mkTerm "asian_N" ;
lin asiatic_A = mkTerm "asiatic_A" ;
lin asiatic_N = mkTerm "asiatic_N" ;
lin aside_Adv = mkTerm "aside_Adv" ;
lin aside_N = mkTerm "aside_N" ;
lin aside_from_Prep = mkTerm "aside_from_Prep" ;
lin asikkala_PN = mkTerm "asikkala_PN" ;
lin asinine_A = mkTerm "asinine_A" ;
lin asininity_N = mkTerm "asininity_N" ;
lin ask_V = mkTerm "ask_V" ;
lin ask_V2 = mkTerm "ask_V2" ;
lin ask_V2V = mkTerm "ask_V2V" ;
lin ask_VQ = mkTerm "ask_VQ" ;
lin ask_about_V2 = mkTerm "ask_about_V2" ;
lin ask_after_V2 = mkTerm "ask_after_V2" ;
lin ask_around_V = mkTerm "ask_around_V" ;
lin ask_around_V2 = mkTerm "ask_around_V2" ;
lin ask_for_V2 = mkTerm "ask_for_V2" ;
lin ask_for_V3 = mkTerm "ask_for_V3" ;
lin ask_in_V2 = mkTerm "ask_in_V2" ;
lin ask_out_V2 = mkTerm "ask_out_V2" ;
lin ask_over_V2 = mkTerm "ask_over_V2" ;
lin ask_round_V2 = mkTerm "ask_round_V2" ;
lin askainen_PN = mkTerm "askainen_PN" ;
lin askance_A = mkTerm "askance_A" ;
lin askance_Adv = mkTerm "askance_Adv" ;
lin askern_PN = mkTerm "askern_PN" ;
lin askew_A = mkTerm "askew_A" ;
lin askew_Adv = mkTerm "askew_Adv" ;
lin asking_N = mkTerm "asking_N" ;
lin askola_PN = mkTerm "askola_PN" ;
lin aslant_A = mkTerm "aslant_A" ;
lin aslant_Adv = mkTerm "aslant_Adv" ;
lin asleep_A = mkTerm "asleep_A" ;
lin asleep_Adv = mkTerm "asleep_Adv" ;
lin asocial_A = mkTerm "asocial_A" ;
lin asp_N = mkTerm "asp_N" ;
lin asparaginase_N = mkTerm "asparaginase_N" ;
lin asparagine_N = mkTerm "asparagine_N" ;
lin asparagus_N = mkTerm "asparagus_N" ;
lin aspartame_N = mkTerm "aspartame_N" ;
lin aspect_N = mkTerm "aspect_N" ;
lin aspectual_A = mkTerm "aspectual_A" ;
lin aspen_N = mkTerm "aspen_N" ;
lin asper_N = mkTerm "asper_N" ;
lin aspergill_N = mkTerm "aspergill_N" ;
lin aspergillosis_N = mkTerm "aspergillosis_N" ;
lin asperity_N = mkTerm "asperity_N" ;
lin asperse_V2 = mkTerm "asperse_V2" ;
lin aspersion_N = mkTerm "aspersion_N" ;
lin aspersorium_N = mkTerm "aspersorium_N" ;
lin asphalt_N = mkTerm "asphalt_N" ;
lin asphalt_V2 = mkTerm "asphalt_V2" ;
lin asphaltic_A = mkTerm "asphaltic_A" ;
lin aspheric_A = mkTerm "aspheric_A" ;
lin asphodel_N = mkTerm "asphodel_N" ;
lin asphyxia_N = mkTerm "asphyxia_N" ;
lin asphyxiate_V2 = mkTerm "asphyxiate_V2" ;
lin asphyxiating_A = mkTerm "asphyxiating_A" ;
lin asphyxiation_N = mkTerm "asphyxiation_N" ;
lin aspic_N = mkTerm "aspic_N" ;
lin aspidistra_N = mkTerm "aspidistra_N" ;
lin aspirant_A = mkTerm "aspirant_A" ;
lin aspirant_N = mkTerm "aspirant_N" ;
lin aspirate_N = mkTerm "aspirate_N" ;
lin aspirate_V2 = mkTerm "aspirate_V2" ;
lin aspiration_N = mkTerm "aspiration_N" ;
lin aspirator_N = mkTerm "aspirator_N" ;
lin aspire_V = mkTerm "aspire_V" ;
lin aspire_VV = mkTerm "aspire_VV" ;
lin aspirin_N = mkTerm "aspirin_N" ;
lin aspull_PN = mkTerm "aspull_PN" ;
lin ass_N = mkTerm "ass_N" ;
lin assagai_N = mkTerm "assagai_N" ;
lin assail_V2 = mkTerm "assail_V2" ;
lin assailability_N = mkTerm "assailability_N" ;
lin assailable_A = mkTerm "assailable_A" ;
lin assailant_N = mkTerm "assailant_N" ;
lin assassin_N = mkTerm "assassin_N" ;
lin assassinate_V2 = mkTerm "assassinate_V2" ;
lin assassination_N = mkTerm "assassination_N" ;
lin assault_N = mkTerm "assault_N" ;
lin assault_V2 = mkTerm "assault_V2" ;
lin assaultive_A = mkTerm "assaultive_A" ;
lin assay_N = mkTerm "assay_N" ;
lin assay_V2 = mkTerm "assay_V2" ;
lin assayer_N = mkTerm "assayer_N" ;
lin assegai_N = mkTerm "assegai_N" ;
lin assemblage_N = mkTerm "assemblage_N" ;
lin assemble_V = mkTerm "assemble_V" ;
lin assemble_V2 = mkTerm "assemble_V2" ;
lin assembler_N = mkTerm "assembler_N" ;
lin assembly_N = mkTerm "assembly_N" ;
lin assemblyman_N = mkTerm "assemblyman_N" ;
lin assemblywoman_N = mkTerm "assemblywoman_N" ;
lin assent_N = mkTerm "assent_N" ;
lin assent_V = mkTerm "assent_V" ;
lin assenter_N = mkTerm "assenter_N" ;
lin assentient_A = mkTerm "assentient_A" ;
lin assert_V = mkTerm "assert_V" ;
lin assert_V2 = mkTerm "assert_V2" ;
lin assert_VS = mkTerm "assert_VS" ;
lin asserter_N = mkTerm "asserter_N" ;
lin assertion_N = mkTerm "assertion_N" ;
lin assertive_A = mkTerm "assertive_A" ;
lin assertiveness_N = mkTerm "assertiveness_N" ;
lin assess_V2 = mkTerm "assess_V2" ;
lin assessable_A = mkTerm "assessable_A" ;
lin assessee_N = mkTerm "assessee_N" ;
lin assessment_N = mkTerm "assessment_N" ;
lin assessor_N = mkTerm "assessor_N" ;
lin asset_N = mkTerm "asset_N" ;
lin assets_N = mkTerm "assets_N" ;
lin asseverate_V2 = mkTerm "asseverate_V2" ;
lin asseveration_N = mkTerm "asseveration_N" ;
lin asshole_N = mkTerm "asshole_N" ;
lin assibilation_N = mkTerm "assibilation_N" ;
lin assiduity_N = mkTerm "assiduity_N" ;
lin assiduous_A = mkTerm "assiduous_A" ;
lin assign_V2 = mkTerm "assign_V2" ;
lin assign_V2V = mkTerm "assign_V2V" ;
lin assignable_A = mkTerm "assignable_A" ;
lin assignation_N = mkTerm "assignation_N" ;
lin assignee_N = mkTerm "assignee_N" ;
lin assignment_N = mkTerm "assignment_N" ;
lin assignor_N = mkTerm "assignor_N" ;
lin assimilable_A = mkTerm "assimilable_A" ;
lin assimilate_V = mkTerm "assimilate_V" ;
lin assimilate_V2 = mkTerm "assimilate_V2" ;
lin assimilation_N = mkTerm "assimilation_N" ;
lin assimilative_A = mkTerm "assimilative_A" ;
lin assist_N = mkTerm "assist_N" ;
lin assist_V = mkTerm "assist_V" ;
lin assist_V2 = mkTerm "assist_V2" ;
lin assistance_N = mkTerm "assistance_N" ;
lin assistantFem_N = mkTerm "assistantFem_N" ;
lin assistantMasc_N = mkTerm "assistantMasc_N" ;
lin assistant_A = mkTerm "assistant_A" ;
lin assistive_A = mkTerm "assistive_A" ;
lin assize_N = mkTerm "assize_N" ;
lin assizes_N = mkTerm "assizes_N" ;
lin assoc_N = mkTerm "assoc_N" ;
lin associability_N = mkTerm "associability_N" ;
lin associable_A = mkTerm "associable_A" ;
lin associate_A = mkTerm "associate_A" ;
lin associate_N = mkTerm "associate_N" ;
lin associate_V = mkTerm "associate_V" ;
lin associate_V2 = mkTerm "associate_V2" ;
lin associated_A = mkTerm "associated_A" ;
lin associateship_N = mkTerm "associateship_N" ;
lin association_N = mkTerm "association_N" ;
lin associational_A = mkTerm "associational_A" ;
lin associationism_N = mkTerm "associationism_N" ;
lin associative_A = mkTerm "associative_A" ;
lin assonance_N = mkTerm "assonance_N" ;
lin assonant_A = mkTerm "assonant_A" ;
lin assorted_A = mkTerm "assorted_A" ;
lin assortment_N = mkTerm "assortment_N" ;
lin asst_N = mkTerm "asst_N" ;
lin assuage_V2 = mkTerm "assuage_V2" ;
lin assuasive_A = mkTerm "assuasive_A" ;
lin assume_V2 = mkTerm "assume_V2" ;
lin assume_VS = mkTerm "assume_VS" ;
lin assumption_N = mkTerm "assumption_N" ;
lin assumptive_A = mkTerm "assumptive_A" ;
lin assurance_N = mkTerm "assurance_N" ;
lin assure_V2 = mkTerm "assure_V2" ;
lin assure_V2S = mkTerm "assure_V2S" ;
lin assuredly_Adv = mkTerm "assuredly_Adv" ;
lin assuredness_N = mkTerm "assuredness_N" ;
lin assurgent_A = mkTerm "assurgent_A" ;
lin assuring_A = mkTerm "assuring_A" ;
lin astasia_N = mkTerm "astasia_N" ;
lin astatic_A = mkTerm "astatic_A" ;
lin astatine_N = mkTerm "astatine_N" ;
lin aster_N = mkTerm "aster_N" ;
lin astereognosis_N = mkTerm "astereognosis_N" ;
lin asteriated_A = mkTerm "asteriated_A" ;
lin asterion_N = mkTerm "asterion_N" ;
lin asterisk_N = mkTerm "asterisk_N" ;
lin asterisked_A = mkTerm "asterisked_A" ;
lin asterism_N = mkTerm "asterism_N" ;
lin asterismal_A = mkTerm "asterismal_A" ;
lin astern_Adv = mkTerm "astern_Adv" ;
lin asternal_A = mkTerm "asternal_A" ;
lin asteroid_A = mkTerm "asteroid_A" ;
lin asteroid_N = mkTerm "asteroid_N" ;
lin asteroidal_A = mkTerm "asteroidal_A" ;
lin asthenia_N = mkTerm "asthenia_N" ;
lin asthenic_A = mkTerm "asthenic_A" ;
lin asthenosphere_N = mkTerm "asthenosphere_N" ;
lin asthma_N = mkTerm "asthma_N" ;
lin asthmatic_A = mkTerm "asthmatic_A" ;
lin asthmatic_N = mkTerm "asthmatic_N" ;
lin astigmatic_A = mkTerm "astigmatic_A" ;
lin astigmatism_N = mkTerm "astigmatism_N" ;
lin astilbe_N = mkTerm "astilbe_N" ;
lin astir_A = mkTerm "astir_A" ;
lin astir_Adv = mkTerm "astir_Adv" ;
lin astomatal_A = mkTerm "astomatal_A" ;
lin astomatous_A = mkTerm "astomatous_A" ;
lin aston_PN = mkTerm "aston_PN" ;
lin astonish_V2 = mkTerm "astonish_V2" ;
lin astonishing_A = mkTerm "astonishing_A" ;
lin astonishment_N = mkTerm "astonishment_N" ;
lin astound_V2 = mkTerm "astound_V2" ;
lin astounding_A = mkTerm "astounding_A" ;
lin astragalar_A = mkTerm "astragalar_A" ;
lin astrakhan_N = mkTerm "astrakhan_N" ;
lin astral_A = mkTerm "astral_A" ;
lin astrantia_N = mkTerm "astrantia_N" ;
lin astraphobia_N = mkTerm "astraphobia_N" ;
lin astray_A = mkTerm "astray_A" ;
lin astray_Adv = mkTerm "astray_Adv" ;
lin astride_A = mkTerm "astride_A" ;
lin astride_Adv = mkTerm "astride_Adv" ;
lin astride_Prep = mkTerm "astride_Prep" ;
lin astringency_N = mkTerm "astringency_N" ;
lin astringent_A = mkTerm "astringent_A" ;
lin astringent_N = mkTerm "astringent_N" ;
lin astrocyte_N = mkTerm "astrocyte_N" ;
lin astrocytic_A = mkTerm "astrocytic_A" ;
lin astrodome_N = mkTerm "astrodome_N" ;
lin astrodynamics_N = mkTerm "astrodynamics_N" ;
lin astrogator_N = mkTerm "astrogator_N" ;
lin astroglia_N = mkTerm "astroglia_N" ;
lin astrolabe_N = mkTerm "astrolabe_N" ;
lin astrolatry_N = mkTerm "astrolatry_N" ;
lin astrologer_N = mkTerm "astrologer_N" ;
lin astrological_A = mkTerm "astrological_A" ;
lin astrology_N = mkTerm "astrology_N" ;
lin astrometry_N = mkTerm "astrometry_N" ;
lin astronaut_N = mkTerm "astronaut_N" ;
lin astronautic_A = mkTerm "astronautic_A" ;
lin astronautics_N = mkTerm "astronautics_N" ;
lin astronomer_N = mkTerm "astronomer_N" ;
lin astronomic_A = mkTerm "astronomic_A" ;
lin astronomical_A = mkTerm "astronomical_A" ;
lin astronomy_N = mkTerm "astronomy_N" ;
lin astrophysical_A = mkTerm "astrophysical_A" ;
lin astrophysicist_N = mkTerm "astrophysicist_N" ;
lin astrophysics_N = mkTerm "astrophysics_N" ;
lin astute_A = mkTerm "astute_A" ;
lin astuteness_N = mkTerm "astuteness_N" ;
lin astylar_A = mkTerm "astylar_A" ;
lin asunder_Adv = mkTerm "asunder_Adv" ;
lin asylum_N = mkTerm "asylum_N" ;
lin asymmetric_A = mkTerm "asymmetric_A" ;
lin asymmetrical_A = mkTerm "asymmetrical_A" ;
lin asymmetry_N = mkTerm "asymmetry_N" ;
lin asymptomatic_A = mkTerm "asymptomatic_A" ;
lin asymptote_N = mkTerm "asymptote_N" ;
lin asymptotic_A = mkTerm "asymptotic_A" ;
lin asynchronism_N = mkTerm "asynchronism_N" ;
lin asynchronous_A = mkTerm "asynchronous_A" ;
lin asynclitism_N = mkTerm "asynclitism_N" ;
lin asyndetic_A = mkTerm "asyndetic_A" ;
lin asyndeton_N = mkTerm "asyndeton_N" ;
lin asynergic_A = mkTerm "asynergic_A" ;
lin asynergy_N = mkTerm "asynergy_N" ;
lin asystole_N = mkTerm "asystole_N" ;
lin at_N = mkTerm "at_N" ;
lin at_Prep = mkTerm "at_Prep" ;
lin at_all_Adv = mkTerm "at_all_Adv" ;
lin at_home_Adv = mkTerm "at_home_Adv" ;
lin at_home_N = mkTerm "at_home_N" ;
lin at_last_Adv = mkTerm "at_last_Adv" ;
lin at_long_last_Adv = mkTerm "at_long_last_Adv" ;
lin at_the_behest_of_Prep = mkTerm "at_the_behest_of_Prep" ;
lin at_times_Adv = mkTerm "at_times_Adv" ;
lin atabrine_N = mkTerm "atabrine_N" ;
lin ataractic_A = mkTerm "ataractic_A" ;
lin ataraxia_N = mkTerm "ataraxia_N" ;
lin atavism_N = mkTerm "atavism_N" ;
lin atavist_N = mkTerm "atavist_N" ;
lin atavistic_A = mkTerm "atavistic_A" ;
lin ataxia_N = mkTerm "ataxia_N" ;
lin ataxic_A = mkTerm "ataxic_A" ;
lin atelectasis_N = mkTerm "atelectasis_N" ;
lin ateleiosis_N = mkTerm "ateleiosis_N" ;
lin ateleiotic_A = mkTerm "ateleiotic_A" ;
lin atelier_N = mkTerm "atelier_N" ;
lin atenolol_N = mkTerm "atenolol_N" ;
lin athanor_N = mkTerm "athanor_N" ;
lin atheism_N = mkTerm "atheism_N" ;
lin atheist_A = mkTerm "atheist_A" ;
lin atheist_N = mkTerm "atheist_N" ;
lin atheistic_A = mkTerm "atheistic_A" ;
lin athenaeum_N = mkTerm "athenaeum_N" ;
lin athenianFem_N = mkTerm "athenianFem_N" ;
lin athenianMasc_N = mkTerm "athenianMasc_N" ;
lin athenian_A = mkTerm "athenian_A" ;
lin athens_1_PN = mkTerm "athens_1_PN" ;
lin athens_2_PN = mkTerm "athens_2_PN" ;
lin atherogenesis_N = mkTerm "atherogenesis_N" ;
lin atheroma_N = mkTerm "atheroma_N" ;
lin atheromatous_A = mkTerm "atheromatous_A" ;
lin atherosclerosis_N = mkTerm "atherosclerosis_N" ;
lin atherosclerotic_A = mkTerm "atherosclerotic_A" ;
lin atherstone_PN = mkTerm "atherstone_PN" ;
lin athetosis_N = mkTerm "athetosis_N" ;
lin athirst_A = mkTerm "athirst_A" ;
lin athlete_N = mkTerm "athlete_N" ;
lin athletic_A = mkTerm "athletic_A" ;
lin athleticism_N = mkTerm "athleticism_N" ;
lin athletics_N = mkTerm "athletics_N" ;
lin athlone_PN = mkTerm "athlone_PN" ;
lin athwart_Adv = mkTerm "athwart_Adv" ;
lin athwart_Prep = mkTerm "athwart_Prep" ;
lin atilt_A = mkTerm "atilt_A" ;
lin atlanta_PN = mkTerm "atlanta_PN" ;
lin atlantic_A = mkTerm "atlantic_A" ;
lin atlantic_PN = mkTerm "atlantic_PN" ;
lin atlas_N = mkTerm "atlas_N" ;
lin atmometer_N = mkTerm "atmometer_N" ;
lin atmosphere_N = mkTerm "atmosphere_N" ;
lin atmospheric_A = mkTerm "atmospheric_A" ;
lin atmospherics_N = mkTerm "atmospherics_N" ;
lin atole_N = mkTerm "atole_N" ;
lin atoll_N = mkTerm "atoll_N" ;
lin atom_N = mkTerm "atom_N" ;
lin atomic_A = mkTerm "atomic_A" ;
lin atomism_N = mkTerm "atomism_N" ;
lin atomistic_A = mkTerm "atomistic_A" ;
lin atomization_N = mkTerm "atomization_N" ;
lin atomize_V2 = mkTerm "atomize_V2" ;
lin atomizer_N = mkTerm "atomizer_N" ;
lin atonal_A = mkTerm "atonal_A" ;
lin atonalistic_A = mkTerm "atonalistic_A" ;
lin atonality_N = mkTerm "atonality_N" ;
lin atone_V = mkTerm "atone_V" ;
lin atonement_N = mkTerm "atonement_N" ;
lin atonic_A = mkTerm "atonic_A" ;
lin atonicity_N = mkTerm "atonicity_N" ;
lin atop_Adv = mkTerm "atop_Adv" ;
lin atop_Prep = mkTerm "atop_Prep" ;
lin atopognosia_N = mkTerm "atopognosia_N" ;
lin atorvastatin_N = mkTerm "atorvastatin_N" ;
lin atrabilious_A = mkTerm "atrabilious_A" ;
lin atrazine_N = mkTerm "atrazine_N" ;
lin atresia_N = mkTerm "atresia_N" ;
lin atrial_A = mkTerm "atrial_A" ;
lin atrioventricular_A = mkTerm "atrioventricular_A" ;
lin atrium_N = mkTerm "atrium_N" ;
lin atrocious_A = mkTerm "atrocious_A" ;
lin atrocity_N = mkTerm "atrocity_N" ;
lin atrophic_A = mkTerm "atrophic_A" ;
lin atrophy_N = mkTerm "atrophy_N" ;
lin atrophy_V = mkTerm "atrophy_V" ;
lin atrophy_V2 = mkTerm "atrophy_V2" ;
lin atropine_N = mkTerm "atropine_N" ;
lin attach_V = mkTerm "attach_V" ;
lin attach_V2 = mkTerm "attach_V2" ;
lin attachable_A = mkTerm "attachable_A" ;
lin attache_N = mkTerm "attache_N" ;
lin attachment_N = mkTerm "attachment_N" ;
lin attack_N = mkTerm "attack_N" ;
lin attack_V2 = mkTerm "attack_V2" ;
lin attacker_N = mkTerm "attacker_N" ;
lin attain_V = mkTerm "attain_V" ;
lin attain_V2 = mkTerm "attain_V2" ;
lin attainable_A = mkTerm "attainable_A" ;
lin attainder_N = mkTerm "attainder_N" ;
lin attainment_N = mkTerm "attainment_N" ;
lin attar_N = mkTerm "attar_N" ;
lin attempt_1_N = mkTerm "attempt_1_N" ;
lin attempt_2_N = mkTerm "attempt_2_N" ;
lin attempt_V2 = mkTerm "attempt_V2" ;
lin attempt_VV = mkTerm "attempt_VV" ;
lin attempted_A = mkTerm "attempted_A" ;
lin attend_V = mkTerm "attend_V" ;
lin attend_V2 = mkTerm "attend_V2" ;
lin attendance_N = mkTerm "attendance_N" ;
lin attendant_A = mkTerm "attendant_A" ;
lin attendant_N = mkTerm "attendant_N" ;
lin attention_N = mkTerm "attention_N" ;
lin attentional_A = mkTerm "attentional_A" ;
lin attentive_A = mkTerm "attentive_A" ;
lin attentiveness_N = mkTerm "attentiveness_N" ;
lin attenuate_A = mkTerm "attenuate_A" ;
lin attenuate_V2 = mkTerm "attenuate_V2" ;
lin attenuation_N = mkTerm "attenuation_N" ;
lin attenuator_N = mkTerm "attenuator_N" ;
lin attest_V = mkTerm "attest_V" ;
lin attest_V2 = mkTerm "attest_V2" ;
lin attest_VS = mkTerm "attest_VS" ;
lin attestation_N = mkTerm "attestation_N" ;
lin attester_N = mkTerm "attester_N" ;
lin attic_A = mkTerm "attic_A" ;
lin attic_N = mkTerm "attic_N" ;
lin attire_N = mkTerm "attire_N" ;
lin attire_V2 = mkTerm "attire_V2" ;
lin attitude_N = mkTerm "attitude_N" ;
lin attitudinal_A = mkTerm "attitudinal_A" ;
lin attitudinize_V = mkTerm "attitudinize_V" ;
lin attorney_N = mkTerm "attorney_N" ;
lin attorneyship_N = mkTerm "attorneyship_N" ;
lin attosecond_N = mkTerm "attosecond_N" ;
lin attract_V2 = mkTerm "attract_V2" ;
lin attractable_A = mkTerm "attractable_A" ;
lin attraction_N = mkTerm "attraction_N" ;
lin attractive_A = mkTerm "attractive_A" ;
lin attractiveness_N = mkTerm "attractiveness_N" ;
lin attractor_N = mkTerm "attractor_N" ;
lin attributable_A = mkTerm "attributable_A" ;
lin attribute_N = mkTerm "attribute_N" ;
lin attribute_V2 = mkTerm "attribute_V2" ;
lin attribution_N = mkTerm "attribution_N" ;
lin attributive_A = mkTerm "attributive_A" ;
lin attrited_A = mkTerm "attrited_A" ;
lin attrition_N = mkTerm "attrition_N" ;
lin attritional_A = mkTerm "attritional_A" ;
lin attune_V2 = mkTerm "attune_V2" ;
lin atypical_A = mkTerm "atypical_A" ;
lin atypicality_N = mkTerm "atypicality_N" ;
lin au_fait_A = mkTerm "au_fait_A" ;
lin au_fond_Adv = mkTerm "au_fond_Adv" ;
lin au_pair_N = mkTerm "au_pair_N" ;
lin aubergine_N = mkTerm "aubergine_N" ;
lin aubrietia_N = mkTerm "aubrietia_N" ;
lin auburn_A = mkTerm "auburn_A" ;
lin auckland_PN = mkTerm "auckland_PN" ;
lin auction_N = mkTerm "auction_N" ;
lin auction_V2 = mkTerm "auction_V2" ;
lin auction_off_V2 = mkTerm "auction_off_V2" ;
lin auctioneer_N = mkTerm "auctioneer_N" ;
lin audacious_A = mkTerm "audacious_A" ;
lin audacity_N = mkTerm "audacity_N" ;
lin audibility_N = mkTerm "audibility_N" ;
lin audible_A = mkTerm "audible_A" ;
lin audible_N = mkTerm "audible_N" ;
lin audience_N = mkTerm "audience_N" ;
lin audile_N = mkTerm "audile_N" ;
lin audio_A = mkTerm "audio_A" ;
lin audio_N = mkTerm "audio_N" ;
lin audio_lingual_A = mkTerm "audio_lingual_A" ;
lin audiocassette_N = mkTerm "audiocassette_N" ;
lin audiogram_N = mkTerm "audiogram_N" ;
lin audiology_N = mkTerm "audiology_N" ;
lin audiometer_N = mkTerm "audiometer_N" ;
lin audiometric_A = mkTerm "audiometric_A" ;
lin audiometry_N = mkTerm "audiometry_N" ;
lin audiotape_N = mkTerm "audiotape_N" ;
lin audiovisual_A = mkTerm "audiovisual_A" ;
lin audiovisual_N = mkTerm "audiovisual_N" ;
lin audit_N = mkTerm "audit_N" ;
lin audit_V2 = mkTerm "audit_V2" ;
lin audition_N = mkTerm "audition_N" ;
lin audition_V = mkTerm "audition_V" ;
lin audition_V2 = mkTerm "audition_V2" ;
lin auditor_N = mkTerm "auditor_N" ;
lin auditorium_N = mkTerm "auditorium_N" ;
lin auditory_A = mkTerm "auditory_A" ;
lin audley_PN = mkTerm "audley_PN" ;
lin audrey_PN = mkTerm "audrey_PN" ;
lin aug_PN = mkTerm "aug_PN" ;
lin augend_N = mkTerm "augend_N" ;
lin auger_N = mkTerm "auger_N" ;
lin aught_N = mkTerm "aught_N" ;
lin augite_N = mkTerm "augite_N" ;
lin augitic_A = mkTerm "augitic_A" ;
lin augment_V = mkTerm "augment_V" ;
lin augment_V2 = mkTerm "augment_V2" ;
lin augmentation_N = mkTerm "augmentation_N" ;
lin augmentative_A = mkTerm "augmentative_A" ;
lin augsburg_PN = mkTerm "augsburg_PN" ;
lin augur_N = mkTerm "augur_N" ;
lin augur_V = mkTerm "augur_V" ;
lin augur_V2 = mkTerm "augur_V2" ;
lin augury_N = mkTerm "augury_N" ;
lin august_A = mkTerm "august_A" ;
lin augustan_A = mkTerm "augustan_A" ;
lin auk_N = mkTerm "auk_N" ;
lin auklet_N = mkTerm "auklet_N" ;
lin auld_A = mkTerm "auld_A" ;
lin auld_lang_syne_N = mkTerm "auld_lang_syne_N" ;
lin aunt_N = mkTerm "aunt_N" ;
lin auntie_N = mkTerm "auntie_N" ;
lin aunty_N = mkTerm "aunty_N" ;
lin aura_N = mkTerm "aura_N" ;
lin aura_PN = mkTerm "aura_PN" ;
lin aural_A = mkTerm "aural_A" ;
lin aureate_A = mkTerm "aureate_A" ;
lin aureole_N = mkTerm "aureole_N" ;
lin auricle_N = mkTerm "auricle_N" ;
lin auricula_N = mkTerm "auricula_N" ;
lin auricular_A = mkTerm "auricular_A" ;
lin auriculare_N = mkTerm "auriculare_N" ;
lin auriculate_A = mkTerm "auriculate_A" ;
lin auriferous_A = mkTerm "auriferous_A" ;
lin auriform_A = mkTerm "auriform_A" ;
lin aurochs_N = mkTerm "aurochs_N" ;
lin aurora_N = mkTerm "aurora_N" ;
lin auroral_A = mkTerm "auroral_A" ;
lin aurous_A = mkTerm "aurous_A" ;
lin auscultation_N = mkTerm "auscultation_N" ;
lin auscultatory_A = mkTerm "auscultatory_A" ;
lin auspice_N = mkTerm "auspice_N" ;
lin auspices_N = mkTerm "auspices_N" ;
lin auspicious_A = mkTerm "auspicious_A" ;
lin auspiciousness_N = mkTerm "auspiciousness_N" ;
lin aussie_N = mkTerm "aussie_N" ;
lin austenite_N = mkTerm "austenite_N" ;
lin austenitic_A = mkTerm "austenitic_A" ;
lin austere_A = mkTerm "austere_A" ;
lin austereness_N = mkTerm "austereness_N" ;
lin austerity_N = mkTerm "austerity_N" ;
lin austral_A = mkTerm "austral_A" ;
lin austral_N = mkTerm "austral_N" ;
lin australia_PN = mkTerm "australia_PN" ;
lin australianFem_N = mkTerm "australianFem_N" ;
lin australianMasc_N = mkTerm "australianMasc_N" ;
lin australian_A = mkTerm "australian_A" ;
lin australopithecine_A = mkTerm "australopithecine_A" ;
lin australopithecine_N = mkTerm "australopithecine_N" ;
lin austria_PN = mkTerm "austria_PN" ;
lin austrianFem_N = mkTerm "austrianFem_N" ;
lin austrianMasc_N = mkTerm "austrianMasc_N" ;
lin austrian_A = mkTerm "austrian_A" ;
lin autacoid_N = mkTerm "autacoid_N" ;
lin autacoidal_A = mkTerm "autacoidal_A" ;
lin autarchic_A = mkTerm "autarchic_A" ;
lin autarchy_N = mkTerm "autarchy_N" ;
lin autarkic_A = mkTerm "autarkic_A" ;
lin autarky_N = mkTerm "autarky_N" ;
lin auteur_N = mkTerm "auteur_N" ;
lin authentic_A = mkTerm "authentic_A" ;
lin authenticate_V2 = mkTerm "authenticate_V2" ;
lin authentication_N = mkTerm "authentication_N" ;
lin authenticity_N = mkTerm "authenticity_N" ;
lin author_N = mkTerm "author_N" ;
lin authore_V2 = mkTerm "authore_V2" ;
lin authoress_N = mkTerm "authoress_N" ;
lin authorial_A = mkTerm "authorial_A" ;
lin authoritarian_A = mkTerm "authoritarian_A" ;
lin authoritarian_N = mkTerm "authoritarian_N" ;
lin authoritarianism_N = mkTerm "authoritarianism_N" ;
lin authoritative_A = mkTerm "authoritative_A" ;
lin authority_1_N = mkTerm "authority_1_N" ;
lin authority_2_N = mkTerm "authority_2_N" ;
lin authorization_N = mkTerm "authorization_N" ;
lin authorize_V2 = mkTerm "authorize_V2" ;
lin authorize_V2V = mkTerm "authorize_V2V" ;
lin authorizer_N = mkTerm "authorizer_N" ;
lin authorship_N = mkTerm "authorship_N" ;
lin autism_N = mkTerm "autism_N" ;
lin autistic_A = mkTerm "autistic_A" ;
lin auto_N = mkTerm "auto_N" ;
lin auto_changer_N = mkTerm "auto_changer_N" ;
lin auto_da_fe_N = mkTerm "auto_da_fe_N" ;
lin autoantibody_N = mkTerm "autoantibody_N" ;
lin autobahn_N = mkTerm "autobahn_N" ;
lin autobiographer_N = mkTerm "autobiographer_N" ;
lin autobiographic_A = mkTerm "autobiographic_A" ;
lin autobiographical_A = mkTerm "autobiographical_A" ;
lin autobiography_N = mkTerm "autobiography_N" ;
lin autocatalysis_N = mkTerm "autocatalysis_N" ;
lin autocatalytic_A = mkTerm "autocatalytic_A" ;
lin autochthon_N = mkTerm "autochthon_N" ;
lin autochthonal_A = mkTerm "autochthonal_A" ;
lin autochthonous_A = mkTerm "autochthonous_A" ;
lin autoclave_N = mkTerm "autoclave_N" ;
lin autocracy_N = mkTerm "autocracy_N" ;
lin autocrat_N = mkTerm "autocrat_N" ;
lin autocratic_A = mkTerm "autocratic_A" ;
lin autodidact_N = mkTerm "autodidact_N" ;
lin autodidactic_A = mkTerm "autodidactic_A" ;
lin autoecious_A = mkTerm "autoecious_A" ;
lin autoerotic_A = mkTerm "autoerotic_A" ;
lin autoeroticism_N = mkTerm "autoeroticism_N" ;
lin autofluorescence_N = mkTerm "autofluorescence_N" ;
lin autofluorescent_A = mkTerm "autofluorescent_A" ;
lin autofocus_N = mkTerm "autofocus_N" ;
lin autogamous_A = mkTerm "autogamous_A" ;
lin autogamy_N = mkTerm "autogamy_N" ;
lin autogenetic_A = mkTerm "autogenetic_A" ;
lin autogenous_A = mkTerm "autogenous_A" ;
lin autogiro_N = mkTerm "autogiro_N" ;
lin autograft_N = mkTerm "autograft_N" ;
lin autograph_N = mkTerm "autograph_N" ;
lin autograph_V2 = mkTerm "autograph_V2" ;
lin autographic_A = mkTerm "autographic_A" ;
lin autogyro_N = mkTerm "autogyro_N" ;
lin autoicous_A = mkTerm "autoicous_A" ;
lin autoimmune_A = mkTerm "autoimmune_A" ;
lin autoimmunity_N = mkTerm "autoimmunity_N" ;
lin autoinjector_N = mkTerm "autoinjector_N" ;
lin autoloader_N = mkTerm "autoloader_N" ;
lin autologous_A = mkTerm "autologous_A" ;
lin autolysis_N = mkTerm "autolysis_N" ;
lin autolytic_A = mkTerm "autolytic_A" ;
lin automat_N = mkTerm "automat_N" ;
lin automate_V2 = mkTerm "automate_V2" ;
lin automated_A = mkTerm "automated_A" ;
lin automatic_A = mkTerm "automatic_A" ;
lin automatic_N = mkTerm "automatic_N" ;
lin automation_N = mkTerm "automation_N" ;
lin automatism_N = mkTerm "automatism_N" ;
lin automaton_N = mkTerm "automaton_N" ;
lin automobile_N = mkTerm "automobile_N" ;
lin automotive_A = mkTerm "automotive_A" ;
lin automysophobia_N = mkTerm "automysophobia_N" ;
lin autonomic_A = mkTerm "autonomic_A" ;
lin autonomous_A = mkTerm "autonomous_A" ;
lin autonomy_N = mkTerm "autonomy_N" ;
lin autophyte_N = mkTerm "autophyte_N" ;
lin autopilot_N = mkTerm "autopilot_N" ;
lin autoplastic_A = mkTerm "autoplastic_A" ;
lin autoplasty_N = mkTerm "autoplasty_N" ;
lin autopsy_N = mkTerm "autopsy_N" ;
lin autoradiograph_N = mkTerm "autoradiograph_N" ;
lin autoradiographic_A = mkTerm "autoradiographic_A" ;
lin autoradiography_N = mkTerm "autoradiography_N" ;
lin autoregulation_N = mkTerm "autoregulation_N" ;
lin autosemantic_A = mkTerm "autosemantic_A" ;
lin autosexing_N = mkTerm "autosexing_N" ;
lin autosomal_A = mkTerm "autosomal_A" ;
lin autosome_N = mkTerm "autosome_N" ;
lin autostrada_N = mkTerm "autostrada_N" ;
lin autosuggestion_N = mkTerm "autosuggestion_N" ;
lin autotelic_A = mkTerm "autotelic_A" ;
lin autotelism_N = mkTerm "autotelism_N" ;
lin autotomic_A = mkTerm "autotomic_A" ;
lin autotomy_N = mkTerm "autotomy_N" ;
lin autotrophic_A = mkTerm "autotrophic_A" ;
lin autotype_N = mkTerm "autotype_N" ;
lin autotypic_A = mkTerm "autotypic_A" ;
lin auttoinen_PN = mkTerm "auttoinen_PN" ;
lin autumn_N = mkTerm "autumn_N" ;
lin autumnal_A = mkTerm "autumnal_A" ;
lin auxesis_N = mkTerm "auxesis_N" ;
lin auxetic_A = mkTerm "auxetic_A" ;
lin auxiliary_A = mkTerm "auxiliary_A" ;
lin auxiliary_N = mkTerm "auxiliary_N" ;
lin auxin_N = mkTerm "auxin_N" ;
lin auxinic_A = mkTerm "auxinic_A" ;
lin avadavat_N = mkTerm "avadavat_N" ;
lin avail_N = mkTerm "avail_N" ;
lin avail_V = mkTerm "avail_V" ;
lin avail_V2 = mkTerm "avail_V2" ;
lin availability_N = mkTerm "availability_N" ;
lin available_A = mkTerm "available_A" ;
lin avalanche_N = mkTerm "avalanche_N" ;
lin avant_garde_N = mkTerm "avant_garde_N" ;
lin avaram_N = mkTerm "avaram_N" ;
lin avarice_N = mkTerm "avarice_N" ;
lin avaricious_A = mkTerm "avaricious_A" ;
lin avascular_A = mkTerm "avascular_A" ;
lin avatar_N = mkTerm "avatar_N" ;
lin ave_PN = mkTerm "ave_PN" ;
lin aveley_PN = mkTerm "aveley_PN" ;
lin avellan_A = mkTerm "avellan_A" ;
lin avenge_V2 = mkTerm "avenge_V2" ;
lin avenger_N = mkTerm "avenger_N" ;
lin avens_N = mkTerm "avens_N" ;
lin avenue_N = mkTerm "avenue_N" ;
lin aver_V2 = mkTerm "aver_V2" ;
lin average_A = mkTerm "average_A" ;
lin average_N = mkTerm "average_N" ;
lin average_V = mkTerm "average_V" ;
lin average_V2 = mkTerm "average_V2" ;
lin averageness_N = mkTerm "averageness_N" ;
lin averr_VS = mkTerm "averr_VS" ;
lin averse_A = mkTerm "averse_A" ;
lin aversion_N = mkTerm "aversion_N" ;
lin aversive_A = mkTerm "aversive_A" ;
lin avert_V2 = mkTerm "avert_V2" ;
lin averting_N = mkTerm "averting_N" ;
lin avian_A = mkTerm "avian_A" ;
lin aviary_N = mkTerm "aviary_N" ;
lin aviation_N = mkTerm "aviation_N" ;
lin aviatorFem_N = mkTerm "aviatorFem_N" ;
lin aviatorMasc_N = mkTerm "aviatorMasc_N" ;
lin aviatrix_N = mkTerm "aviatrix_N" ;
lin avid_A = mkTerm "avid_A" ;
lin avidity_N = mkTerm "avidity_N" ;
lin avifauna_N = mkTerm "avifauna_N" ;
lin avifaunal_A = mkTerm "avifaunal_A" ;
lin avignon_PN = mkTerm "avignon_PN" ;
lin avionic_A = mkTerm "avionic_A" ;
lin avionics_N = mkTerm "avionics_N" ;
lin avirulent_A = mkTerm "avirulent_A" ;
lin avitaminosis_N = mkTerm "avitaminosis_N" ;
lin avitaminotic_A = mkTerm "avitaminotic_A" ;
lin avo_N = mkTerm "avo_N" ;
lin avocado_A = mkTerm "avocado_A" ;
lin avocado_N = mkTerm "avocado_N" ;
lin avocation_N = mkTerm "avocation_N" ;
lin avocational_A = mkTerm "avocational_A" ;
lin avocet_N = mkTerm "avocet_N" ;
lin avoid_V2 = mkTerm "avoid_V2" ;
lin avoid_VV = mkTerm "avoid_VV" ;
lin avoidable_A = mkTerm "avoidable_A" ;
lin avoidance_N = mkTerm "avoidance_N" ;
lin avoirdupois_N = mkTerm "avoirdupois_N" ;
lin avon_PN = mkTerm "avon_PN" ;
lin avouch_V = mkTerm "avouch_V" ;
lin avouch_V2 = mkTerm "avouch_V2" ;
lin avow_V2 = mkTerm "avow_V2" ;
lin avowal_N = mkTerm "avowal_N" ;
lin avowedly_Adv = mkTerm "avowedly_Adv" ;
lin avower_N = mkTerm "avower_N" ;
lin avulsion_N = mkTerm "avulsion_N" ;
lin avuncular_A = mkTerm "avuncular_A" ;
lin await_V2 = mkTerm "await_V2" ;
lin awake_A = mkTerm "awake_A" ;
lin awake_V = mkTerm "awake_V" ;
lin awaken_V2 = mkTerm "awaken_V2" ;
lin awakening_N = mkTerm "awakening_N" ;
lin award_N = mkTerm "award_N" ;
lin award_V2 = mkTerm "award_V2" ;
lin award_V3 = mkTerm "award_V3" ;
lin aware_A = mkTerm "aware_A" ;
lin aware_of_A2 = mkTerm "aware_of_A2" ;
lin awareness_N = mkTerm "awareness_N" ;
lin awash_A = mkTerm "awash_A" ;
lin away_1_Adv = mkTerm "away_1_Adv" ;
lin away_2_Adv = mkTerm "away_2_Adv" ;
lin away_A = mkTerm "away_A" ;
lin awayness_N = mkTerm "awayness_N" ;
lin awe_N = mkTerm "awe_N" ;
lin awe_V2 = mkTerm "awe_V2" ;
lin awe_inspiring_A = mkTerm "awe_inspiring_A" ;
lin awe_stricken_A = mkTerm "awe_stricken_A" ;
lin awe_struck_A = mkTerm "awe_struck_A" ;
lin aweary_A = mkTerm "aweary_A" ;
lin aweigh_A = mkTerm "aweigh_A" ;
lin aweigh_Adv = mkTerm "aweigh_Adv" ;
lin aweless_A = mkTerm "aweless_A" ;
lin awesome_A = mkTerm "awesome_A" ;
lin awful_A = mkTerm "awful_A" ;
lin awfulness_N = mkTerm "awfulness_N" ;
lin awheel_A = mkTerm "awheel_A" ;
lin awhile_Adv = mkTerm "awhile_Adv" ;
lin awkward_A = mkTerm "awkward_A" ;
lin awkwardness_N = mkTerm "awkwardness_N" ;
lin awl_N = mkTerm "awl_N" ;
lin awlwort_N = mkTerm "awlwort_N" ;
lin awn_N = mkTerm "awn_N" ;
lin awned_A = mkTerm "awned_A" ;
lin awning_N = mkTerm "awning_N" ;
lin awninged_A = mkTerm "awninged_A" ;
lin awnless_A = mkTerm "awnless_A" ;
lin awol_PN = mkTerm "awol_PN" ;
lin awry_A = mkTerm "awry_A" ;
lin awry_Adv = mkTerm "awry_Adv" ;
lin ax_N = mkTerm "ax_N" ;
lin ax_V2 = mkTerm "ax_V2" ;
lin axe_N = mkTerm "axe_N" ;
lin axe_V2 = mkTerm "axe_V2" ;
lin axenic_A = mkTerm "axenic_A" ;
lin axial_A = mkTerm "axial_A" ;
lin axil_N = mkTerm "axil_N" ;
lin axile_A = mkTerm "axile_A" ;
lin axillary_A = mkTerm "axillary_A" ;
lin axiological_A = mkTerm "axiological_A" ;
lin axiology_N = mkTerm "axiology_N" ;
lin axiom_N = mkTerm "axiom_N" ;
lin axiomatic_A = mkTerm "axiomatic_A" ;
lin axis_N = mkTerm "axis_N" ;
lin axle_N = mkTerm "axle_N" ;
lin axletree_N = mkTerm "axletree_N" ;
lin axolemma_N = mkTerm "axolemma_N" ;
lin axolotl_N = mkTerm "axolotl_N" ;
lin axon_N = mkTerm "axon_N" ;
lin axonal_A = mkTerm "axonal_A" ;
lin axseed_N = mkTerm "axseed_N" ;
lin ay_Adv = mkTerm "ay_Adv" ;
lin ayah_N = mkTerm "ayah_N" ;
lin ayapana_N = mkTerm "ayapana_N" ;
lin ayatollah_N = mkTerm "ayatollah_N" ;
lin aycliffe_PN = mkTerm "aycliffe_PN" ;
lin aye_Adv = mkTerm "aye_Adv" ;
lin aye_Interj = mkTerm "aye_Interj" ;
lin ayin_N = mkTerm "ayin_N" ;
lin aylesbury_PN = mkTerm "aylesbury_PN" ;
lin aylesford_PN = mkTerm "aylesford_PN" ;
lin ayr_PN = mkTerm "ayr_PN" ;
lin ayran_N = mkTerm "ayran_N" ;
lin azadirachtin_N = mkTerm "azadirachtin_N" ;
lin azalea_N = mkTerm "azalea_N" ;
lin azathioprine_N = mkTerm "azathioprine_N" ;
lin azide_N = mkTerm "azide_N" ;
lin azido_A = mkTerm "azido_A" ;
lin azimuth_N = mkTerm "azimuth_N" ;
lin azimuthal_A = mkTerm "azimuthal_A" ;
lin azithromycin_N = mkTerm "azithromycin_N" ;
lin azo_A = mkTerm "azo_A" ;
lin azoic_A = mkTerm "azoic_A" ;
lin azonal_A = mkTerm "azonal_A" ;
lin azonic_A = mkTerm "azonic_A" ;
lin azote_N = mkTerm "azote_N" ;
lin azotemic_A = mkTerm "azotemic_A" ;
lin azotic_A = mkTerm "azotic_A" ;
lin azoturia_N = mkTerm "azoturia_N" ;
lin aztreonam_N = mkTerm "aztreonam_N" ;
lin azure_A = mkTerm "azure_A" ;
lin azure_N = mkTerm "azure_N" ;
lin azurite_N = mkTerm "azurite_N" ;
lin azygous_A = mkTerm "azygous_A" ;
lin azymia_N = mkTerm "azymia_N" ;
lin b_ed_N = mkTerm "b_ed_N" ;
lin ba_N = mkTerm "ba_N" ;
lin baa_N = mkTerm "baa_N" ;
lin baa_V = mkTerm "baa_V" ;
lin baa_lamb_N = mkTerm "baa_lamb_N" ;
lin baas_N = mkTerm "baas_N" ;
lin baba_N = mkTerm "baba_N" ;
lin babassu_N = mkTerm "babassu_N" ;
lin babbitting_N = mkTerm "babbitting_N" ;
lin babble_N = mkTerm "babble_N" ;
lin babble_V = mkTerm "babble_V" ;
lin babble_V2 = mkTerm "babble_V2" ;
lin babbler_N = mkTerm "babbler_N" ;
lin babe_N = mkTerm "babe_N" ;
lin babel_N = mkTerm "babel_N" ;
lin babelike_A = mkTerm "babelike_A" ;
lin babirusa_N = mkTerm "babirusa_N" ;
lin babka_N = mkTerm "babka_N" ;
lin baboo_N = mkTerm "baboo_N" ;
lin baboon_N = mkTerm "baboon_N" ;
lin baboonish_A = mkTerm "baboonish_A" ;
lin babs_PN = mkTerm "babs_PN" ;
lin babu_N = mkTerm "babu_N" ;
lin babushka_N = mkTerm "babushka_N" ;
lin baby_N = mkTerm "baby_N" ;
lin baby_V2 = mkTerm "baby_V2" ;
lin baby_faced_A = mkTerm "baby_faced_A" ;
lin baby_farmer_N = mkTerm "baby_farmer_N" ;
lin baby_minder_N = mkTerm "baby_minder_N" ;
lin baby_talk_N = mkTerm "baby_talk_N" ;
lin babyhood_N = mkTerm "babyhood_N" ;
lin babyish_A = mkTerm "babyish_A" ;
lin babysit_V = mkTerm "babysit_V" ;
lin babysitter_N = mkTerm "babysitter_N" ;
lin babysitting_N = mkTerm "babysitting_N" ;
lin baccalaureate_N = mkTerm "baccalaureate_N" ;
lin baccarat_N = mkTerm "baccarat_N" ;
lin baccate_A = mkTerm "baccate_A" ;
lin bacchanal_A = mkTerm "bacchanal_A" ;
lin bacchanal_N = mkTerm "bacchanal_N" ;
lin bacchanalian_A = mkTerm "bacchanalian_A" ;
lin bacchant_N = mkTerm "bacchant_N" ;
lin bacchante_N = mkTerm "bacchante_N" ;
lin bacchantic_A = mkTerm "bacchantic_A" ;
lin baccivorous_A = mkTerm "baccivorous_A" ;
lin baccy_N = mkTerm "baccy_N" ;
lin bachelor_N = mkTerm "bachelor_N" ;
lin bachelorhood_N = mkTerm "bachelorhood_N" ;
lin bacillar_A = mkTerm "bacillar_A" ;
lin bacillus_N = mkTerm "bacillus_N" ;
lin bacitracin_N = mkTerm "bacitracin_N" ;
lin back_A = mkTerm "back_A" ;
lin back_Adv = mkTerm "back_Adv" ;
lin back_N = mkTerm "back_N" ;
lin back_V = mkTerm "back_V" ;
lin back_away_V = mkTerm "back_away_V" ;
lin back_breaking_A = mkTerm "back_breaking_A" ;
lin back_down_N = mkTerm "back_down_N" ;
lin back_down_V = mkTerm "back_down_V" ;
lin back_formation_N = mkTerm "back_formation_N" ;
lin back_into_V3 = mkTerm "back_into_V3" ;
lin back_off_V = mkTerm "back_off_V" ;
lin back_out_V = mkTerm "back_out_V" ;
lin back_out_of_V2 = mkTerm "back_out_of_V2" ;
lin back_out_of_V3 = mkTerm "back_out_of_V3" ;
lin back_to_Prep = mkTerm "back_to_Prep" ;
lin back_up_1_V2 = mkTerm "back_up_1_V2" ;
lin back_up_2_V2 = mkTerm "back_up_2_V2" ;
lin back_up_N = mkTerm "back_up_N" ;
lin back_up_V = mkTerm "back_up_V" ;
lin backache_N = mkTerm "backache_N" ;
lin backband_N = mkTerm "backband_N" ;
lin backbeat_N = mkTerm "backbeat_N" ;
lin backbench_N = mkTerm "backbench_N" ;
lin backbencher_N = mkTerm "backbencher_N" ;
lin backbend_N = mkTerm "backbend_N" ;
lin backbite_V = mkTerm "backbite_V" ;
lin backbite_V2 = mkTerm "backbite_V2" ;
lin backbiter_N = mkTerm "backbiter_N" ;
lin backblast_N = mkTerm "backblast_N" ;
lin backboard_N = mkTerm "backboard_N" ;
lin backbone_N = mkTerm "backbone_N" ;
lin backchat_N = mkTerm "backchat_N" ;
lin backcloth_N = mkTerm "backcloth_N" ;
lin backdate_V2 = mkTerm "backdate_V2" ;
lin backdoor_N = mkTerm "backdoor_N" ;
lin backdrop_N = mkTerm "backdrop_N" ;
lin backerFem_N = mkTerm "backerFem_N" ;
lin backerMasc_N = mkTerm "backerMasc_N" ;
lin backfield_N = mkTerm "backfield_N" ;
lin backfire_N = mkTerm "backfire_N" ;
lin backfire_V = mkTerm "backfire_V" ;
lin backflow_N = mkTerm "backflow_N" ;
lin backgammon_N = mkTerm "backgammon_N" ;
lin background_N = mkTerm "background_N" ;
lin backgrounder_N = mkTerm "backgrounder_N" ;
lin backhand_A = mkTerm "backhand_A" ;
lin backhand_N = mkTerm "backhand_N" ;
lin backhanded_A = mkTerm "backhanded_A" ;
lin backhander_N = mkTerm "backhander_N" ;
lin backhoe_N = mkTerm "backhoe_N" ;
lin backing_N = mkTerm "backing_N" ;
lin backlash_N = mkTerm "backlash_N" ;
lin backless_A = mkTerm "backless_A" ;
lin backlighting_N = mkTerm "backlighting_N" ;
lin backlog_N = mkTerm "backlog_N" ;
lin backmost_A = mkTerm "backmost_A" ;
lin backpack_N = mkTerm "backpack_N" ;
lin backpacker_N = mkTerm "backpacker_N" ;
lin backpedal_V = mkTerm "backpedal_V" ;
lin backpedaling_V = mkTerm "backpedaling_V" ;
lin backplate_N = mkTerm "backplate_N" ;
lin backroom_N = mkTerm "backroom_N" ;
lin backsaw_N = mkTerm "backsaw_N" ;
lin backscratcher_N = mkTerm "backscratcher_N" ;
lin backseat_N = mkTerm "backseat_N" ;
lin backsheesh_N = mkTerm "backsheesh_N" ;
lin backside_N = mkTerm "backside_N" ;
lin backslapper_N = mkTerm "backslapper_N" ;
lin backslide_V = mkTerm "backslide_V" ;
lin backsliding_N = mkTerm "backsliding_N" ;
lin backspace_V = mkTerm "backspace_V" ;
lin backspin_N = mkTerm "backspin_N" ;
lin backstage_Adv = mkTerm "backstage_Adv" ;
lin backstair_A = mkTerm "backstair_A" ;
lin backstairs_N = mkTerm "backstairs_N" ;
lin backstay_N = mkTerm "backstay_N" ;
lin backstitch_N = mkTerm "backstitch_N" ;
lin backstop_N = mkTerm "backstop_N" ;
lin backstroke_N = mkTerm "backstroke_N" ;
lin backstroker_N = mkTerm "backstroker_N" ;
lin backswept_A = mkTerm "backswept_A" ;
lin backswimmer_N = mkTerm "backswimmer_N" ;
lin backsword_N = mkTerm "backsword_N" ;
lin backtalk_N = mkTerm "backtalk_N" ;
lin backward_A = mkTerm "backward_A" ;
lin backward_Adv = mkTerm "backward_Adv" ;
lin backwards_A = mkTerm "backwards_A" ;
lin backwards_Adv = mkTerm "backwards_Adv" ;
lin backwash_N = mkTerm "backwash_N" ;
lin backwater_N = mkTerm "backwater_N" ;
lin backwoods_N = mkTerm "backwoods_N" ;
lin backwoodsman_N = mkTerm "backwoodsman_N" ;
lin backworth_PN = mkTerm "backworth_PN" ;
lin backyard_N = mkTerm "backyard_N" ;
lin bacon_N = mkTerm "bacon_N" ;
lin bacteremia_N = mkTerm "bacteremia_N" ;
lin bacteremic_A = mkTerm "bacteremic_A" ;
lin bacteria_N = mkTerm "bacteria_N" ;
lin bacterial_A = mkTerm "bacterial_A" ;
lin bactericidal_A = mkTerm "bactericidal_A" ;
lin bactericide_N = mkTerm "bactericide_N" ;
lin bacteriochlorophyll_N = mkTerm "bacteriochlorophyll_N" ;
lin bacteriological_A = mkTerm "bacteriological_A" ;
lin bacteriologist_N = mkTerm "bacteriologist_N" ;
lin bacteriology_N = mkTerm "bacteriology_N" ;
lin bacteriolysis_N = mkTerm "bacteriolysis_N" ;
lin bacteriolytic_A = mkTerm "bacteriolytic_A" ;
lin bacteriophage_N = mkTerm "bacteriophage_N" ;
lin bacteriophagic_A = mkTerm "bacteriophagic_A" ;
lin bacteriostasis_N = mkTerm "bacteriostasis_N" ;
lin bacteriostat_N = mkTerm "bacteriostat_N" ;
lin bacteriostatic_A = mkTerm "bacteriostatic_A" ;
lin bacterium_N = mkTerm "bacterium_N" ;
lin bacteroid_N = mkTerm "bacteroid_N" ;
lin bacteroidal_A = mkTerm "bacteroidal_A" ;
lin bacup_PN = mkTerm "bacup_PN" ;
lin bad_A = mkTerm "bad_A" ;
lin bad_N = mkTerm "bad_N" ;
lin badajoz_PN = mkTerm "badajoz_PN" ;
lin badalona_PN = mkTerm "badalona_PN" ;
lin baddeleyite_N = mkTerm "baddeleyite_N" ;
lin badge_N = mkTerm "badge_N" ;
lin badger_N = mkTerm "badger_N" ;
lin badger_V2 = mkTerm "badger_V2" ;
lin badgering_N = mkTerm "badgering_N" ;
lin badinage_N = mkTerm "badinage_N" ;
lin badlands_N = mkTerm "badlands_N" ;
lin badly_behaved_A = mkTerm "badly_behaved_A" ;
lin badminton_N = mkTerm "badminton_N" ;
lin badness_N = mkTerm "badness_N" ;
lin baedeker_N = mkTerm "baedeker_N" ;
lin baffle_N = mkTerm "baffle_N" ;
lin baffle_V2 = mkTerm "baffle_V2" ;
lin baffled_N = mkTerm "baffled_N" ;
lin baffling_A = mkTerm "baffling_A" ;
lin bag_N = mkTerm "bag_N" ;
lin bag_V = mkTerm "bag_V" ;
lin bag_V2 = mkTerm "bag_V2" ;
lin bag_out_V2 = mkTerm "bag_out_V2" ;
lin bagasse_N = mkTerm "bagasse_N" ;
lin bagassosis_N = mkTerm "bagassosis_N" ;
lin bagatelle_N = mkTerm "bagatelle_N" ;
lin bagel_N = mkTerm "bagel_N" ;
lin baggage_N = mkTerm "baggage_N" ;
lin baggageman_N = mkTerm "baggageman_N" ;
lin bagger_N = mkTerm "bagger_N" ;
lin baggy_A = mkTerm "baggy_A" ;
lin baghdad_PN = mkTerm "baghdad_PN" ;
lin bagman_N = mkTerm "bagman_N" ;
lin bagnio_N = mkTerm "bagnio_N" ;
lin bagpipe_N = mkTerm "bagpipe_N" ;
lin baguet_N = mkTerm "baguet_N" ;
lin bahamas_PN = mkTerm "bahamas_PN" ;
lin bahamian_A = mkTerm "bahamian_A" ;
lin bahamian_N = mkTerm "bahamian_N" ;
lin bahasa_N = mkTerm "bahasa_N" ;
lin bahrain_PN = mkTerm "bahrain_PN" ;
lin bahraini_A = mkTerm "bahraini_A" ;
lin bahraini_N = mkTerm "bahraini_N" ;
lin baht_N = mkTerm "baht_N" ;
lin bail_N = mkTerm "bail_N" ;
lin bail_V = mkTerm "bail_V" ;
lin bail_V2 = mkTerm "bail_V2" ;
lin bail_out_V = mkTerm "bail_out_V" ;
lin bail_out_V2 = mkTerm "bail_out_V2" ;
lin bail_out_of_V3 = mkTerm "bail_out_of_V3" ;
lin bail_out_on_V2 = mkTerm "bail_out_on_V2" ;
lin bail_up_V = mkTerm "bail_up_V" ;
lin bailable_A = mkTerm "bailable_A" ;
lin bailee_N = mkTerm "bailee_N" ;
lin bailey_N = mkTerm "bailey_N" ;
lin bailey_PN = mkTerm "bailey_PN" ;
lin bailiff_N = mkTerm "bailiff_N" ;
lin bailiffship_N = mkTerm "bailiffship_N" ;
lin bailiwick_N = mkTerm "bailiwick_N" ;
lin bailment_N = mkTerm "bailment_N" ;
lin bailor_N = mkTerm "bailor_N" ;
lin bairn_N = mkTerm "bairn_N" ;
lin bait_N = mkTerm "bait_N" ;
lin bait_V = mkTerm "bait_V" ;
lin bait_V2 = mkTerm "bait_V2" ;
lin baiting_N = mkTerm "baiting_N" ;
lin baiza_N = mkTerm "baiza_N" ;
lin baize_N = mkTerm "baize_N" ;
lin bake_V = mkTerm "bake_V" ;
lin bake_V2 = mkTerm "bake_V2" ;
lin bakelite_N = mkTerm "bakelite_N" ;
lin baker_N = mkTerm "baker_N" ;
lin bakery_N = mkTerm "bakery_N" ;
lin baking_N = mkTerm "baking_N" ;
lin baking_hot_A = mkTerm "baking_hot_A" ;
lin baking_powder_N = mkTerm "baking_powder_N" ;
lin baklava_N = mkTerm "baklava_N" ;
lin baksheesh_N = mkTerm "baksheesh_N" ;
lin baku_PN = mkTerm "baku_PN" ;
lin balaclava_N = mkTerm "balaclava_N" ;
lin balagan_N = mkTerm "balagan_N" ;
lin balalaika_N = mkTerm "balalaika_N" ;
lin balance_N = mkTerm "balance_N" ;
lin balance_V = mkTerm "balance_V" ;
lin balance_V2 = mkTerm "balance_V2" ;
lin balance_sheet_N = mkTerm "balance_sheet_N" ;
lin balance_wheel_N = mkTerm "balance_wheel_N" ;
lin balanced_A = mkTerm "balanced_A" ;
lin balancer_N = mkTerm "balancer_N" ;
lin balanitis_N = mkTerm "balanitis_N" ;
lin balanoposthitis_N = mkTerm "balanoposthitis_N" ;
lin balas_N = mkTerm "balas_N" ;
lin balata_N = mkTerm "balata_N" ;
lin balboa_N = mkTerm "balboa_N" ;
lin balbriggan_N = mkTerm "balbriggan_N" ;
lin balconied_A = mkTerm "balconied_A" ;
lin balcony_N = mkTerm "balcony_N" ;
lin bald_A = mkTerm "bald_A" ;
lin bald_head_N = mkTerm "bald_head_N" ;
lin bald_pate_N = mkTerm "bald_pate_N" ;
lin baldachin_N = mkTerm "baldachin_N" ;
lin balderdash_N = mkTerm "balderdash_N" ;
lin balding_A = mkTerm "balding_A" ;
lin baldness_N = mkTerm "baldness_N" ;
lin baldock_PN = mkTerm "baldock_PN" ;
lin baldric_N = mkTerm "baldric_N" ;
lin bale_N = mkTerm "bale_N" ;
lin bale_V2 = mkTerm "bale_V2" ;
lin baleful_A = mkTerm "baleful_A" ;
lin balk_N = mkTerm "balk_N" ;
lin balk_V = mkTerm "balk_V" ;
lin balk_V2 = mkTerm "balk_V2" ;
lin balker_N = mkTerm "balker_N" ;
lin balkiness_N = mkTerm "balkiness_N" ;
lin balkline_N = mkTerm "balkline_N" ;
lin ball_N = mkTerm "ball_N" ;
lin ball_V = mkTerm "ball_V" ;
lin ball_V2 = mkTerm "ball_V2" ;
lin ball_cartridge_N = mkTerm "ball_cartridge_N" ;
lin ball_dress_N = mkTerm "ball_dress_N" ;
lin ball_up_V2 = mkTerm "ball_up_V2" ;
lin ballad_N = mkTerm "ballad_N" ;
lin ballade_N = mkTerm "ballade_N" ;
lin ballast_N = mkTerm "ballast_N" ;
lin ballast_V2 = mkTerm "ballast_V2" ;
lin ballbearing_N = mkTerm "ballbearing_N" ;
lin ballcock_N = mkTerm "ballcock_N" ;
lin ballerina_N = mkTerm "ballerina_N" ;
lin ballet_N = mkTerm "ballet_N" ;
lin ballet_dancer_N = mkTerm "ballet_dancer_N" ;
lin ballet_skirt_N = mkTerm "ballet_skirt_N" ;
lin balletic_A = mkTerm "balletic_A" ;
lin balletomane_N = mkTerm "balletomane_N" ;
lin balletomania_N = mkTerm "balletomania_N" ;
lin ballgame_N = mkTerm "ballgame_N" ;
lin ballistic_A = mkTerm "ballistic_A" ;
lin ballistics_N = mkTerm "ballistics_N" ;
lin ballistocardiogram_N = mkTerm "ballistocardiogram_N" ;
lin ballistocardiograph_N = mkTerm "ballistocardiograph_N" ;
lin ballock_N = mkTerm "ballock_N" ;
lin balloon_N = mkTerm "balloon_N" ;
lin balloon_V = mkTerm "balloon_V" ;
lin balloon_V2 = mkTerm "balloon_V2" ;
lin balloonfish_N = mkTerm "balloonfish_N" ;
lin ballooning_N = mkTerm "ballooning_N" ;
lin balloonist_N = mkTerm "balloonist_N" ;
lin ballot_N = mkTerm "ballot_N" ;
lin ballot_V = mkTerm "ballot_V" ;
lin ballot_box_N = mkTerm "ballot_box_N" ;
lin ballottement_N = mkTerm "ballottement_N" ;
lin ballpark_N = mkTerm "ballpark_N" ;
lin ballpen_N = mkTerm "ballpen_N" ;
lin ballplayer_N = mkTerm "ballplayer_N" ;
lin ballpoint_N = mkTerm "ballpoint_N" ;
lin ballpoint_pen_N = mkTerm "ballpoint_pen_N" ;
lin ballroom_N = mkTerm "ballroom_N" ;
lin balls_up_N = mkTerm "balls_up_N" ;
lin balls_up_V2 = mkTerm "balls_up_V2" ;
lin ballup_N = mkTerm "ballup_N" ;
lin bally_A = mkTerm "bally_A" ;
lin bally_Adv = mkTerm "bally_Adv" ;
lin ballyhoo_N = mkTerm "ballyhoo_N" ;
lin balm_N = mkTerm "balm_N" ;
lin balminess_N = mkTerm "balminess_N" ;
lin balmoral_N = mkTerm "balmoral_N" ;
lin balmy_A = mkTerm "balmy_A" ;
lin baloney_N = mkTerm "baloney_N" ;
lin balsa_N = mkTerm "balsa_N" ;
lin balsam_N = mkTerm "balsam_N" ;
lin balsamic_A = mkTerm "balsamic_A" ;
lin balsamroot_N = mkTerm "balsamroot_N" ;
lin baltic_sea_PN = mkTerm "baltic_sea_PN" ;
lin baltimore_PN = mkTerm "baltimore_PN" ;
lin baluster_N = mkTerm "baluster_N" ;
lin balustrade_N = mkTerm "balustrade_N" ;
lin bambino_N = mkTerm "bambino_N" ;
lin bamboo_N = mkTerm "bamboo_N" ;
lin bamboozle_V2 = mkTerm "bamboozle_V2" ;
lin ban_N = mkTerm "ban_N" ;
lin ban_V2 = mkTerm "ban_V2" ;
lin banal_A = mkTerm "banal_A" ;
lin banality_N = mkTerm "banality_N" ;
lin banana_N = mkTerm "banana_N" ;
lin banausic_A = mkTerm "banausic_A" ;
lin banbury_PN = mkTerm "banbury_PN" ;
lin band_N = mkTerm "band_N" ;
lin band_V = mkTerm "band_V" ;
lin band_V2 = mkTerm "band_V2" ;
lin band_saw_N = mkTerm "band_saw_N" ;
lin bandage_N = mkTerm "bandage_N" ;
lin bandage_V2 = mkTerm "bandage_V2" ;
lin bandanna_N = mkTerm "bandanna_N" ;
lin bandbox_N = mkTerm "bandbox_N" ;
lin bandeau_N = mkTerm "bandeau_N" ;
lin banderilla_N = mkTerm "banderilla_N" ;
lin banderillero_N = mkTerm "banderillero_N" ;
lin bandicoot_N = mkTerm "bandicoot_N" ;
lin bandit_N = mkTerm "bandit_N" ;
lin banditry_N = mkTerm "banditry_N" ;
lin bandleader_N = mkTerm "bandleader_N" ;
lin bandmaster_N = mkTerm "bandmaster_N" ;
lin bandoleer_N = mkTerm "bandoleer_N" ;
lin bandolier_N = mkTerm "bandolier_N" ;
lin bandoneon_N = mkTerm "bandoneon_N" ;
lin bandsman_N = mkTerm "bandsman_N" ;
lin bandstand_N = mkTerm "bandstand_N" ;
lin bandung_PN = mkTerm "bandung_PN" ;
lin bandwagon_N = mkTerm "bandwagon_N" ;
lin bandwidth_N = mkTerm "bandwidth_N" ;
lin bandy_A = mkTerm "bandy_A" ;
lin bandy_V2 = mkTerm "bandy_V2" ;
lin bandy_legged_A = mkTerm "bandy_legged_A" ;
lin bane_N = mkTerm "bane_N" ;
lin baneberry_N = mkTerm "baneberry_N" ;
lin baneful_A = mkTerm "baneful_A" ;
lin bang_Adv = mkTerm "bang_Adv" ;
lin bang_N = mkTerm "bang_N" ;
lin bang_V = mkTerm "bang_V" ;
lin bang_V2 = mkTerm "bang_V2" ;
lin bang_about_V = mkTerm "bang_about_V" ;
lin bang_around_V = mkTerm "bang_around_V" ;
lin bang_on_V = mkTerm "bang_on_V" ;
lin bang_on_about_V2 = mkTerm "bang_on_about_V2" ;
lin bang_out_V2 = mkTerm "bang_out_V2" ;
lin bang_up_V2 = mkTerm "bang_up_V2" ;
lin bangalore_PN = mkTerm "bangalore_PN" ;
lin banger_N = mkTerm "banger_N" ;
lin banging_N = mkTerm "banging_N" ;
lin bangkok_PN = mkTerm "bangkok_PN" ;
lin bangladesh_PN = mkTerm "bangladesh_PN" ;
lin bangladeshi_A = mkTerm "bangladeshi_A" ;
lin bangladeshi_N = mkTerm "bangladeshi_N" ;
lin bangle_N = mkTerm "bangle_N" ;
lin bangor_PN = mkTerm "bangor_PN" ;
lin banian_N = mkTerm "banian_N" ;
lin banian_tree_N = mkTerm "banian_tree_N" ;
lin banish_V2 = mkTerm "banish_V2" ;
lin banishment_N = mkTerm "banishment_N" ;
lin banister_N = mkTerm "banister_N" ;
lin banjo_N = mkTerm "banjo_N" ;
lin bank_1_N = mkTerm "bank_1_N" ;
lin bank_2_N = mkTerm "bank_2_N" ;
lin bank_V = mkTerm "bank_V" ;
lin bank_V2 = mkTerm "bank_V2" ;
lin bank_bill_N = mkTerm "bank_bill_N" ;
lin bank_book_N = mkTerm "bank_book_N" ;
lin bank_draft_N = mkTerm "bank_draft_N" ;
lin bank_on_V2 = mkTerm "bank_on_V2" ;
lin bank_rate_N = mkTerm "bank_rate_N" ;
lin bankable_A = mkTerm "bankable_A" ;
lin banker_N = mkTerm "banker_N" ;
lin banking_N = mkTerm "banking_N" ;
lin banknote_N = mkTerm "banknote_N" ;
lin bankroll_N = mkTerm "bankroll_N" ;
lin bankrupt_A = mkTerm "bankrupt_A" ;
lin bankrupt_N = mkTerm "bankrupt_N" ;
lin bankrupt_V2 = mkTerm "bankrupt_V2" ;
lin bankruptcy_N = mkTerm "bankruptcy_N" ;
lin banksia_N = mkTerm "banksia_N" ;
lin banner_A = mkTerm "banner_A" ;
lin banner_N = mkTerm "banner_N" ;
lin bannerlike_Adv = mkTerm "bannerlike_Adv" ;
lin banning_order_N = mkTerm "banning_order_N" ;
lin bannister_N = mkTerm "bannister_N" ;
lin bannock_N = mkTerm "bannock_N" ;
lin bannockburn_PN = mkTerm "bannockburn_PN" ;
lin banns_N = mkTerm "banns_N" ;
lin banquet_N = mkTerm "banquet_N" ;
lin banquet_V = mkTerm "banquet_V" ;
lin banquet_V2 = mkTerm "banquet_V2" ;
lin banquette_N = mkTerm "banquette_N" ;
lin banshee_N = mkTerm "banshee_N" ;
lin bant_V = mkTerm "bant_V" ;
lin bantam_A = mkTerm "bantam_A" ;
lin bantam_N = mkTerm "bantam_N" ;
lin bantamweight_N = mkTerm "bantamweight_N" ;
lin banteng_N = mkTerm "banteng_N" ;
lin banter_N = mkTerm "banter_N" ;
lin banter_V = mkTerm "banter_V" ;
lin banter_V2 = mkTerm "banter_V2" ;
lin banteringly_Adv = mkTerm "banteringly_Adv" ;
lin banting_N = mkTerm "banting_N" ;
lin bantry_PN = mkTerm "bantry_PN" ;
lin bantu_A = mkTerm "bantu_A" ;
lin bantu_N = mkTerm "bantu_N" ;
lin banyan_N = mkTerm "banyan_N" ;
lin banzai_N = mkTerm "banzai_N" ;
lin baobab_N = mkTerm "baobab_N" ;
lin bap_N = mkTerm "bap_N" ;
lin baptism_N = mkTerm "baptism_N" ;
lin baptismal_A = mkTerm "baptismal_A" ;
lin baptist_A = mkTerm "baptist_A" ;
lin baptist_N = mkTerm "baptist_N" ;
lin baptize_V2 = mkTerm "baptize_V2" ;
lin bar_1_N = mkTerm "bar_1_N" ;
lin bar_2_N = mkTerm "bar_2_N" ;
lin bar_Prep = mkTerm "bar_Prep" ;
lin bar_V2 = mkTerm "bar_V2" ;
lin baracaldo_PN = mkTerm "baracaldo_PN" ;
lin barb_N = mkTerm "barb_N" ;
lin barbadian_A = mkTerm "barbadian_A" ;
lin barbadian_N = mkTerm "barbadian_N" ;
lin barbados_PN = mkTerm "barbados_PN" ;
lin barbara_PN = mkTerm "barbara_PN" ;
lin barbarian_A = mkTerm "barbarian_A" ;
lin barbarian_N = mkTerm "barbarian_N" ;
lin barbaric_A = mkTerm "barbaric_A" ;
lin barbarism_N = mkTerm "barbarism_N" ;
lin barbarity_N = mkTerm "barbarity_N" ;
lin barbarization_N = mkTerm "barbarization_N" ;
lin barbarize_V2 = mkTerm "barbarize_V2" ;
lin barbarous_A = mkTerm "barbarous_A" ;
lin barbasco_N = mkTerm "barbasco_N" ;
lin barbecue_N = mkTerm "barbecue_N" ;
lin barbecue_V2 = mkTerm "barbecue_V2" ;
lin barbecuing_N = mkTerm "barbecuing_N" ;
lin barbed_A = mkTerm "barbed_A" ;
lin barbel_N = mkTerm "barbel_N" ;
lin barbell_N = mkTerm "barbell_N" ;
lin barber_N = mkTerm "barber_N" ;
lin barberry_N = mkTerm "barberry_N" ;
lin barbershop_N = mkTerm "barbershop_N" ;
lin barbet_N = mkTerm "barbet_N" ;
lin barbette_N = mkTerm "barbette_N" ;
lin barbican_N = mkTerm "barbican_N" ;
lin barbital_N = mkTerm "barbital_N" ;
lin barbitone_N = mkTerm "barbitone_N" ;
lin barbiturate_N = mkTerm "barbiturate_N" ;
lin barbu_N = mkTerm "barbu_N" ;
lin barcarole_N = mkTerm "barcarole_N" ;
lin barcarolle_N = mkTerm "barcarolle_N" ;
lin barcelona_PN = mkTerm "barcelona_PN" ;
lin bard_N = mkTerm "bard_N" ;
lin bardic_A = mkTerm "bardic_A" ;
lin bardolatry_N = mkTerm "bardolatry_N" ;
lin bare_A = mkTerm "bare_A" ;
lin bare_V2 = mkTerm "bare_V2" ;
lin bareback_A = mkTerm "bareback_A" ;
lin bareback_Adv = mkTerm "bareback_Adv" ;
lin barebacked_A = mkTerm "barebacked_A" ;
lin barebacked_Adv = mkTerm "barebacked_Adv" ;
lin bareboat_N = mkTerm "bareboat_N" ;
lin bareboating_N = mkTerm "bareboating_N" ;
lin barefaced_A = mkTerm "barefaced_A" ;
lin barefoot_A = mkTerm "barefoot_A" ;
lin barefoot_Adv = mkTerm "barefoot_Adv" ;
lin barefooted_A = mkTerm "barefooted_A" ;
lin barefooted_Adv = mkTerm "barefooted_Adv" ;
lin barehanded_A = mkTerm "barehanded_A" ;
lin bareheaded_A = mkTerm "bareheaded_A" ;
lin barelegged_A = mkTerm "barelegged_A" ;
lin barely_Adv = mkTerm "barely_Adv" ;
lin bareness_N = mkTerm "bareness_N" ;
lin bargain_N = mkTerm "bargain_N" ;
lin bargain_V = mkTerm "bargain_V" ;
lin bargain_V2 = mkTerm "bargain_V2" ;
lin bargain_down_V2 = mkTerm "bargain_down_V2" ;
lin bargain_for_V2 = mkTerm "bargain_for_V2" ;
lin bargain_on_V2 = mkTerm "bargain_on_V2" ;
lin bargainer_N = mkTerm "bargainer_N" ;
lin bargaining_N = mkTerm "bargaining_N" ;
lin barge_N = mkTerm "barge_N" ;
lin barge_V = mkTerm "barge_V" ;
lin barge_in_V = mkTerm "barge_in_V" ;
lin barge_into_V2 = mkTerm "barge_into_V2" ;
lin bargee_N = mkTerm "bargee_N" ;
lin bargello_N = mkTerm "bargello_N" ;
lin bargepole_N = mkTerm "bargepole_N" ;
lin bargoed_PN = mkTerm "bargoed_PN" ;
lin bari_PN = mkTerm "bari_PN" ;
lin baric_A = mkTerm "baric_A" ;
lin barilla_N = mkTerm "barilla_N" ;
lin baritone_A = mkTerm "baritone_A" ;
lin baritone_N = mkTerm "baritone_N" ;
lin barium_N = mkTerm "barium_N" ;
lin bark_N = mkTerm "bark_N" ;
lin bark_V = mkTerm "bark_V" ;
lin bark_V2 = mkTerm "bark_V2" ;
lin barker_N = mkTerm "barker_N" ;
lin barking_PN = mkTerm "barking_PN" ;
lin barky_A = mkTerm "barky_A" ;
lin barley_N = mkTerm "barley_N" ;
lin barley_sugar_N = mkTerm "barley_sugar_N" ;
lin barley_water_N = mkTerm "barley_water_N" ;
lin barleycorn_N = mkTerm "barleycorn_N" ;
lin barm_N = mkTerm "barm_N" ;
lin barmaid_N = mkTerm "barmaid_N" ;
lin barman_N = mkTerm "barman_N" ;
lin barmbrack_N = mkTerm "barmbrack_N" ;
lin barmy_A = mkTerm "barmy_A" ;
lin barn_N = mkTerm "barn_N" ;
lin barn_door_N = mkTerm "barn_door_N" ;
lin barnacle_N = mkTerm "barnacle_N" ;
lin barnard_castle_PN = mkTerm "barnard_castle_PN" ;
lin barnburner_N = mkTerm "barnburner_N" ;
lin barnet_PN = mkTerm "barnet_PN" ;
lin barnful_N = mkTerm "barnful_N" ;
lin barnoldswick_PN = mkTerm "barnoldswick_PN" ;
lin barnsley_PN = mkTerm "barnsley_PN" ;
lin barnstaple_PN = mkTerm "barnstaple_PN" ;
lin barnstorm_V = mkTerm "barnstorm_V" ;
lin barnstormer_N = mkTerm "barnstormer_N" ;
lin barnyard_N = mkTerm "barnyard_N" ;
lin barograph_N = mkTerm "barograph_N" ;
lin barographic_A = mkTerm "barographic_A" ;
lin barometer_N = mkTerm "barometer_N" ;
lin barometric_A = mkTerm "barometric_A" ;
lin baron_N = mkTerm "baron_N" ;
lin baronage_N = mkTerm "baronage_N" ;
lin baronduki_N = mkTerm "baronduki_N" ;
lin baroness_N = mkTerm "baroness_N" ;
lin baronet_N = mkTerm "baronet_N" ;
lin baronetage_N = mkTerm "baronetage_N" ;
lin baronetcy_N = mkTerm "baronetcy_N" ;
lin barong_N = mkTerm "barong_N" ;
lin baronial_A = mkTerm "baronial_A" ;
lin barony_N = mkTerm "barony_N" ;
lin baroque_A = mkTerm "baroque_A" ;
lin baroque_N = mkTerm "baroque_N" ;
lin baroreceptor_N = mkTerm "baroreceptor_N" ;
lin barosaur_N = mkTerm "barosaur_N" ;
lin barouche_N = mkTerm "barouche_N" ;
lin barque_N = mkTerm "barque_N" ;
lin barra_N = mkTerm "barra_N" ;
lin barrack_N = mkTerm "barrack_N" ;
lin barrack_V = mkTerm "barrack_V" ;
lin barrack_V2 = mkTerm "barrack_V2" ;
lin barracking_N = mkTerm "barracking_N" ;
lin barracks_N = mkTerm "barracks_N" ;
lin barracouta_N = mkTerm "barracouta_N" ;
lin barracuda_N = mkTerm "barracuda_N" ;
lin barrage_N = mkTerm "barrage_N" ;
lin barramundi_N = mkTerm "barramundi_N" ;
lin barranquilla_PN = mkTerm "barranquilla_PN" ;
lin barrator_N = mkTerm "barrator_N" ;
lin barratry_N = mkTerm "barratry_N" ;
lin barrel_N = mkTerm "barrel_N" ;
lin barrel_V2 = mkTerm "barrel_V2" ;
lin barreled_A = mkTerm "barreled_A" ;
lin barrelfish_N = mkTerm "barrelfish_N" ;
lin barrelhouse_N = mkTerm "barrelhouse_N" ;
lin barrels_N = mkTerm "barrels_N" ;
lin barren_A = mkTerm "barren_A" ;
lin barren_N = mkTerm "barren_N" ;
lin barrenness_N = mkTerm "barrenness_N" ;
lin barrenwort_N = mkTerm "barrenwort_N" ;
lin barrette_N = mkTerm "barrette_N" ;
lin barrhead_PN = mkTerm "barrhead_PN" ;
lin barricade_N = mkTerm "barricade_N" ;
lin barricade_V2 = mkTerm "barricade_V2" ;
lin barrier_N = mkTerm "barrier_N" ;
lin barring_N = mkTerm "barring_N" ;
lin barrio_N = mkTerm "barrio_N" ;
lin barrister_N = mkTerm "barrister_N" ;
lin barroom_N = mkTerm "barroom_N" ;
lin barrow_N = mkTerm "barrow_N" ;
lin barrow_boy_N = mkTerm "barrow_boy_N" ;
lin barrow_in_furness_PN = mkTerm "barrow_in_furness_PN" ;
lin barrow_man_N = mkTerm "barrow_man_N" ;
lin barry_PN = mkTerm "barry_PN" ;
lin bart_PN = mkTerm "bart_PN" ;
lin bartender_N = mkTerm "bartender_N" ;
lin barter_N = mkTerm "barter_N" ;
lin barter_V = mkTerm "barter_V" ;
lin barter_V2 = mkTerm "barter_V2" ;
lin barterer_N = mkTerm "barterer_N" ;
lin bartholomew_PN = mkTerm "bartholomew_PN" ;
lin bartlett_N = mkTerm "bartlett_N" ;
lin barton_upon_humber_PN = mkTerm "barton_upon_humber_PN" ;
lin bartonia_N = mkTerm "bartonia_N" ;
lin barycenter_N = mkTerm "barycenter_N" ;
lin barye_N = mkTerm "barye_N" ;
lin baryon_N = mkTerm "baryon_N" ;
lin baryta_N = mkTerm "baryta_N" ;
lin barytic_A = mkTerm "barytic_A" ;
lin bas_relief_N = mkTerm "bas_relief_N" ;
lin basal_A = mkTerm "basal_A" ;
lin basalt_N = mkTerm "basalt_N" ;
lin basaltic_A = mkTerm "basaltic_A" ;
lin bascule_N = mkTerm "bascule_N" ;
lin base_A = mkTerm "base_A" ;
lin base_N = mkTerm "base_N" ;
lin base_V = mkTerm "base_V" ;
lin base_V2 = mkTerm "base_V2" ;
lin baseball_N = mkTerm "baseball_N" ;
lin baseboard_N = mkTerm "baseboard_N" ;
lin basel_PN = mkTerm "basel_PN" ;
lin baseless_A = mkTerm "baseless_A" ;
lin baseline_N = mkTerm "baseline_N" ;
lin baseman_N = mkTerm "baseman_N" ;
lin basement_N = mkTerm "basement_N" ;
lin baseness_N = mkTerm "baseness_N" ;
lin basenji_N = mkTerm "basenji_N" ;
lin bash_N = mkTerm "bash_N" ;
lin bash_V2 = mkTerm "bash_V2" ;
lin bash_about_V2 = mkTerm "bash_about_V2" ;
lin bash_in_V2 = mkTerm "bash_in_V2" ;
lin bash_out_V2 = mkTerm "bash_out_V2" ;
lin bash_up_V2 = mkTerm "bash_up_V2" ;
lin bashful_A = mkTerm "bashful_A" ;
lin basic_A = mkTerm "basic_A" ;
lin basic_N = mkTerm "basic_N" ;
lin basically_Adv = mkTerm "basically_Adv" ;
lin basics_N = mkTerm "basics_N" ;
lin basidial_A = mkTerm "basidial_A" ;
lin basidiocarp_N = mkTerm "basidiocarp_N" ;
lin basidiolichen_N = mkTerm "basidiolichen_N" ;
lin basidiomycete_N = mkTerm "basidiomycete_N" ;
lin basidiomycetous_A = mkTerm "basidiomycetous_A" ;
lin basidiospore_N = mkTerm "basidiospore_N" ;
lin basidiosporous_A = mkTerm "basidiosporous_A" ;
lin basidium_N = mkTerm "basidium_N" ;
lin basifixed_A = mkTerm "basifixed_A" ;
lin basil_N = mkTerm "basil_N" ;
lin basil_PN = mkTerm "basil_PN" ;
lin basilar_A = mkTerm "basilar_A" ;
lin basildon_PN = mkTerm "basildon_PN" ;
lin basileus_N = mkTerm "basileus_N" ;
lin basilica_N = mkTerm "basilica_N" ;
lin basilican_A = mkTerm "basilican_A" ;
lin basilisk_N = mkTerm "basilisk_N" ;
lin basin_N = mkTerm "basin_N" ;
lin basinal_A = mkTerm "basinal_A" ;
lin basined_A = mkTerm "basined_A" ;
lin basinet_N = mkTerm "basinet_N" ;
lin basingstoke_PN = mkTerm "basingstoke_PN" ;
lin basipetal_A = mkTerm "basipetal_A" ;
lin basis_N = mkTerm "basis_N" ;
lin basiscopic_A = mkTerm "basiscopic_A" ;
lin bask_V = mkTerm "bask_V" ;
lin basket_N = mkTerm "basket_N" ;
lin basketball_N = mkTerm "basketball_N" ;
lin basketry_N = mkTerm "basketry_N" ;
lin basketweaver_N = mkTerm "basketweaver_N" ;
lin basophil_N = mkTerm "basophil_N" ;
lin basophilia_N = mkTerm "basophilia_N" ;
lin basophilic_A = mkTerm "basophilic_A" ;
lin basque_A = mkTerm "basque_A" ;
lin bass_A = mkTerm "bass_A" ;
lin bass_N = mkTerm "bass_N" ;
lin bassarisk_N = mkTerm "bassarisk_N" ;
lin basset_N = mkTerm "basset_N" ;
lin bassine_N = mkTerm "bassine_N" ;
lin bassinet_N = mkTerm "bassinet_N" ;
lin bassist_N = mkTerm "bassist_N" ;
lin bassoon_N = mkTerm "bassoon_N" ;
lin bassoonist_N = mkTerm "bassoonist_N" ;
lin basswood_N = mkTerm "basswood_N" ;
lin bast_N = mkTerm "bast_N" ;
lin bastard_N = mkTerm "bastard_N" ;
lin bastardization_N = mkTerm "bastardization_N" ;
lin bastardize_V2 = mkTerm "bastardize_V2" ;
lin bastardly_A = mkTerm "bastardly_A" ;
lin bastardy_N = mkTerm "bastardy_N" ;
lin baste_N = mkTerm "baste_N" ;
lin baste_V2 = mkTerm "baste_V2" ;
lin baster_N = mkTerm "baster_N" ;
lin bastille_N = mkTerm "bastille_N" ;
lin bastinado_N = mkTerm "bastinado_N" ;
lin bastinado_V2 = mkTerm "bastinado_V2" ;
lin basting_N = mkTerm "basting_N" ;
lin bastion_N = mkTerm "bastion_N" ;
lin bastioned_A = mkTerm "bastioned_A" ;
lin bastnasite_N = mkTerm "bastnasite_N" ;
lin basuco_N = mkTerm "basuco_N" ;
lin bat_N = mkTerm "bat_N" ;
lin bat_V = mkTerm "bat_V" ;
lin bat_V2 = mkTerm "bat_V2" ;
lin bat_in_V = mkTerm "bat_in_V" ;
lin batch_N = mkTerm "batch_N" ;
lin bate_V2 = mkTerm "bate_V2" ;
lin batfish_N = mkTerm "batfish_N" ;
lin bath_N = mkTerm "bath_N" ;
lin bath_PN = mkTerm "bath_PN" ;
lin bath_V = mkTerm "bath_V" ;
lin bath_V2 = mkTerm "bath_V2" ;
lin bath_chair_N = mkTerm "bath_chair_N" ;
lin bathe_N = mkTerm "bathe_N" ;
lin bathe_V = mkTerm "bathe_V" ;
lin bathe_V2 = mkTerm "bathe_V2" ;
lin bather_N = mkTerm "bather_N" ;
lin bathetic_A = mkTerm "bathetic_A" ;
lin bathgate_PN = mkTerm "bathgate_PN" ;
lin bathhouse_N = mkTerm "bathhouse_N" ;
lin bathing_N = mkTerm "bathing_N" ;
lin bathing_cap_N = mkTerm "bathing_cap_N" ;
lin bathing_costume_N = mkTerm "bathing_costume_N" ;
lin bathing_machine_N = mkTerm "bathing_machine_N" ;
lin bathing_suit_N = mkTerm "bathing_suit_N" ;
lin batholith_N = mkTerm "batholith_N" ;
lin batholithic_A = mkTerm "batholithic_A" ;
lin bathos_N = mkTerm "bathos_N" ;
lin bathrobe_N = mkTerm "bathrobe_N" ;
lin bathroom_N = mkTerm "bathroom_N" ;
lin bathtub_N = mkTerm "bathtub_N" ;
lin bathyal_A = mkTerm "bathyal_A" ;
lin bathymeter_N = mkTerm "bathymeter_N" ;
lin bathymetric_A = mkTerm "bathymetric_A" ;
lin bathymetry_N = mkTerm "bathymetry_N" ;
lin bathyscaphe_N = mkTerm "bathyscaphe_N" ;
lin bathysphere_N = mkTerm "bathysphere_N" ;
lin batik_N = mkTerm "batik_N" ;
lin batiste_N = mkTerm "batiste_N" ;
lin batley_PN = mkTerm "batley_PN" ;
lin batman_N = mkTerm "batman_N" ;
lin baton_N = mkTerm "baton_N" ;
lin batrachomyomachia_N = mkTerm "batrachomyomachia_N" ;
lin bats_A = mkTerm "bats_A" ;
lin batsman_N = mkTerm "batsman_N" ;
lin battalion_N = mkTerm "battalion_N" ;
lin batten_N = mkTerm "batten_N" ;
lin batten_V = mkTerm "batten_V" ;
lin batten_V2 = mkTerm "batten_V2" ;
lin batter_N = mkTerm "batter_N" ;
lin batter_V = mkTerm "batter_V" ;
lin batter_V2 = mkTerm "batter_V2" ;
lin battering_N = mkTerm "battering_N" ;
lin battery_1_N = mkTerm "battery_1_N" ;
lin battery_2_N = mkTerm "battery_2_N" ;
lin batting_N = mkTerm "batting_N" ;
lin battle_N = mkTerm "battle_N" ;
lin battle_V = mkTerm "battle_V" ;
lin battle_V2 = mkTerm "battle_V2" ;
lin battle_axe_N = mkTerm "battle_axe_N" ;
lin battle_cruiser_N = mkTerm "battle_cruiser_N" ;
lin battledore_N = mkTerm "battledore_N" ;
lin battledress_N = mkTerm "battledress_N" ;
lin battlefield_N = mkTerm "battlefield_N" ;
lin battlefront_N = mkTerm "battlefront_N" ;
lin battleful_A = mkTerm "battleful_A" ;
lin battleground_N = mkTerm "battleground_N" ;
lin battlement_N = mkTerm "battlement_N" ;
lin battlemented_A = mkTerm "battlemented_A" ;
lin battleship_N = mkTerm "battleship_N" ;
lin battue_N = mkTerm "battue_N" ;
lin batty_A = mkTerm "batty_A" ;
lin batwing_A = mkTerm "batwing_A" ;
lin batwing_N = mkTerm "batwing_N" ;
lin bauble_N = mkTerm "bauble_N" ;
lin baud_N = mkTerm "baud_N" ;
lin baulk_N = mkTerm "baulk_N" ;
lin baulk_V = mkTerm "baulk_V" ;
lin baulk_V2 = mkTerm "baulk_V2" ;
lin bauxite_N = mkTerm "bauxite_N" ;
lin bauxitic_A = mkTerm "bauxitic_A" ;
lin bawbee_N = mkTerm "bawbee_N" ;
lin bawd_N = mkTerm "bawd_N" ;
lin bawdry_N = mkTerm "bawdry_N" ;
lin bawdy_A = mkTerm "bawdy_A" ;
lin bawdy_N = mkTerm "bawdy_N" ;
lin bawl_V = mkTerm "bawl_V" ;
lin bawl_V2 = mkTerm "bawl_V2" ;
lin bawl_out_V2 = mkTerm "bawl_out_V2" ;
lin bawler_N = mkTerm "bawler_N" ;
lin bay_A = mkTerm "bay_A" ;
lin bay_N = mkTerm "bay_N" ;
lin bay_V = mkTerm "bay_V" ;
lin bay_wreath_N = mkTerm "bay_wreath_N" ;
lin baya_N = mkTerm "baya_N" ;
lin bayat_N = mkTerm "bayat_N" ;
lin bayberry_N = mkTerm "bayberry_N" ;
lin bayonet_N = mkTerm "bayonet_N" ;
lin bayonet_V2 = mkTerm "bayonet_V2" ;
lin bayou_N = mkTerm "bayou_N" ;
lin bazaar_N = mkTerm "bazaar_N" ;
lin bazooka_N = mkTerm "bazooka_N" ;
lin bbc_PN = mkTerm "bbc_PN" ;
lin bdellium_N = mkTerm "bdellium_N" ;
lin beach_N = mkTerm "beach_N" ;
lin beach_V2 = mkTerm "beach_V2" ;
lin beachcomber_N = mkTerm "beachcomber_N" ;
lin beachfront_N = mkTerm "beachfront_N" ;
lin beachhead_N = mkTerm "beachhead_N" ;
lin beachwear_N = mkTerm "beachwear_N" ;
lin beacon_N = mkTerm "beacon_N" ;
lin beacon_fire_N = mkTerm "beacon_fire_N" ;
lin beacon_light_N = mkTerm "beacon_light_N" ;
lin beaconsfield_PN = mkTerm "beaconsfield_PN" ;
lin bead_N = mkTerm "bead_N" ;
lin beaded_A = mkTerm "beaded_A" ;
lin beading_N = mkTerm "beading_N" ;
lin beadle_N = mkTerm "beadle_N" ;
lin beads_N = mkTerm "beads_N" ;
lin beadsman_N = mkTerm "beadsman_N" ;
lin beady_A = mkTerm "beady_A" ;
lin beagle_N = mkTerm "beagle_N" ;
lin beagling_N = mkTerm "beagling_N" ;
lin beak_N = mkTerm "beak_N" ;
lin beaked_A = mkTerm "beaked_A" ;
lin beaker_N = mkTerm "beaker_N" ;
lin beakless_A = mkTerm "beakless_A" ;
lin beaklike_A = mkTerm "beaklike_A" ;
lin beam_N = mkTerm "beam_N" ;
lin beam_V = mkTerm "beam_V" ;
lin beam_V2 = mkTerm "beam_V2" ;
lin beamish_A = mkTerm "beamish_A" ;
lin beamy_A = mkTerm "beamy_A" ;
lin bean_N = mkTerm "bean_N" ;
lin beanbag_N = mkTerm "beanbag_N" ;
lin beanball_N = mkTerm "beanball_N" ;
lin beanfeast_N = mkTerm "beanfeast_N" ;
lin beanie_N = mkTerm "beanie_N" ;
lin beano_N = mkTerm "beano_N" ;
lin beanstalk_N = mkTerm "beanstalk_N" ;
lin bear_N = mkTerm "bear_N" ;
lin bear_V = mkTerm "bear_V" ;
lin bear_V2 = mkTerm "bear_V2" ;
lin bear_down_on_V2 = mkTerm "bear_down_on_V2" ;
lin bear_on_V2 = mkTerm "bear_on_V2" ;
lin bear_out_V2 = mkTerm "bear_out_V2" ;
lin bear_up_V = mkTerm "bear_up_V" ;
lin bear_up_under_V2 = mkTerm "bear_up_under_V2" ;
lin bear_with_V2 = mkTerm "bear_with_V2" ;
lin bearable_A = mkTerm "bearable_A" ;
lin bearberry_N = mkTerm "bearberry_N" ;
lin beard_N = mkTerm "beard_N" ;
lin beard_V2 = mkTerm "beard_V2" ;
lin beardless_A = mkTerm "beardless_A" ;
lin bearer_N = mkTerm "bearer_N" ;
lin bearing_N = mkTerm "bearing_N" ;
lin bearish_A = mkTerm "bearish_A" ;
lin bearnaise_N = mkTerm "bearnaise_N" ;
lin bearsden_PN = mkTerm "bearsden_PN" ;
lin bearskin_N = mkTerm "bearskin_N" ;
lin beast_N = mkTerm "beast_N" ;
lin beastliness_N = mkTerm "beastliness_N" ;
lin beastly_A = mkTerm "beastly_A" ;
lin beastly_Adv = mkTerm "beastly_Adv" ;
lin beat_N = mkTerm "beat_N" ;
lin beat_V = mkTerm "beat_V" ;
lin beat_V2 = mkTerm "beat_V2" ;
lin beat_back_V = mkTerm "beat_back_V" ;
lin beat_down_V = mkTerm "beat_down_V" ;
lin beat_down_V2 = mkTerm "beat_down_V2" ;
lin beat_out_V2 = mkTerm "beat_out_V2" ;
lin beat_up_V2 = mkTerm "beat_up_V2" ;
lin beatable_A = mkTerm "beatable_A" ;
lin beaten_A = mkTerm "beaten_A" ;
lin beater_N = mkTerm "beater_N" ;
lin beatific_A = mkTerm "beatific_A" ;
lin beatification_N = mkTerm "beatification_N" ;
lin beatify_V2 = mkTerm "beatify_V2" ;
lin beating_N = mkTerm "beating_N" ;
lin beatitude_N = mkTerm "beatitude_N" ;
lin beatnik_N = mkTerm "beatnik_N" ;
lin beatrice_PN = mkTerm "beatrice_PN" ;
lin beau_N = mkTerm "beau_N" ;
lin beaugregory_N = mkTerm "beaugregory_N" ;
lin beaujolais_N = mkTerm "beaujolais_N" ;
lin beaumaris_PN = mkTerm "beaumaris_PN" ;
lin beauteous_A = mkTerm "beauteous_A" ;
lin beautician_N = mkTerm "beautician_N" ;
lin beautification_N = mkTerm "beautification_N" ;
lin beautiful_A = mkTerm "beautiful_A" ;
lin beautify_V2 = mkTerm "beautify_V2" ;
lin beauty_N = mkTerm "beauty_N" ;
lin beauty_parlour_N = mkTerm "beauty_parlour_N" ;
lin beauty_salon_N = mkTerm "beauty_salon_N" ;
lin beauty_sleep_N = mkTerm "beauty_sleep_N" ;
lin beauty_spot_N = mkTerm "beauty_spot_N" ;
lin beaver_N = mkTerm "beaver_N" ;
lin beaver_V = mkTerm "beaver_V" ;
lin beaver_away_V = mkTerm "beaver_away_V" ;
lin beaver_away_at_V2 = mkTerm "beaver_away_at_V2" ;
lin bebington_PN = mkTerm "bebington_PN" ;
lin becalmed_A = mkTerm "becalmed_A" ;
lin because_of_Prep = mkTerm "because_of_Prep" ;
lin beccles_PN = mkTerm "beccles_PN" ;
lin beck_N = mkTerm "beck_N" ;
lin becket_N = mkTerm "becket_N" ;
lin beckon_V = mkTerm "beckon_V" ;
lin beckon_V2 = mkTerm "beckon_V2" ;
lin become_V = mkTerm "become_V" ;
lin become_V2 = mkTerm "become_V2" ;
lin become_VA = mkTerm "become_VA" ;
lin becomingly_Adv = mkTerm "becomingly_Adv" ;
lin becomingness_N = mkTerm "becomingness_N" ;
lin bed_N = mkTerm "bed_N" ;
lin bed_V2 = mkTerm "bed_V2" ;
lin bed_down_V = mkTerm "bed_down_V" ;
lin bed_out_V2 = mkTerm "bed_out_V2" ;
lin bedaubed_A = mkTerm "bedaubed_A" ;
lin bedbug_N = mkTerm "bedbug_N" ;
lin bedclothes_N = mkTerm "bedclothes_N" ;
lin beddau_PN = mkTerm "beddau_PN" ;
lin bedder_N = mkTerm "bedder_N" ;
lin bedding_N = mkTerm "bedding_N" ;
lin bedecked_A = mkTerm "bedecked_A" ;
lin bedevil_V2 = mkTerm "bedevil_V2" ;
lin bedevilment_N = mkTerm "bedevilment_N" ;
lin bedewed_A = mkTerm "bedewed_A" ;
lin bedfast_A = mkTerm "bedfast_A" ;
lin bedfellow_N = mkTerm "bedfellow_N" ;
lin bedford_PN = mkTerm "bedford_PN" ;
lin bedfordshire_PN = mkTerm "bedfordshire_PN" ;
lin bedimmed_A = mkTerm "bedimmed_A" ;
lin bedlam_N = mkTerm "bedlam_N" ;
lin bedlamite_N = mkTerm "bedlamite_N" ;
lin bedless_A = mkTerm "bedless_A" ;
lin bedlington_PN = mkTerm "bedlington_PN" ;
lin bedouin_N = mkTerm "bedouin_N" ;
lin bedpan_N = mkTerm "bedpan_N" ;
lin bedpost_N = mkTerm "bedpost_N" ;
lin bedraggled_A = mkTerm "bedraggled_A" ;
lin bedrest_N = mkTerm "bedrest_N" ;
lin bedridden_A = mkTerm "bedridden_A" ;
lin bedrock_N = mkTerm "bedrock_N" ;
lin bedroll_N = mkTerm "bedroll_N" ;
lin bedroom_N = mkTerm "bedroom_N" ;
lin bedroomed_A = mkTerm "bedroomed_A" ;
lin bedside_N = mkTerm "bedside_N" ;
lin bedsit_N = mkTerm "bedsit_N" ;
lin bedsitter_N = mkTerm "bedsitter_N" ;
lin bedsitting_room_N = mkTerm "bedsitting_room_N" ;
lin bedsore_N = mkTerm "bedsore_N" ;
lin bedspread_N = mkTerm "bedspread_N" ;
lin bedspring_N = mkTerm "bedspring_N" ;
lin bedstead_N = mkTerm "bedstead_N" ;
lin bedstraw_N = mkTerm "bedstraw_N" ;
lin bedtime_N = mkTerm "bedtime_N" ;
lin bedwas_PN = mkTerm "bedwas_PN" ;
lin bedwetter_N = mkTerm "bedwetter_N" ;
lin bee_N = mkTerm "bee_N" ;
lin beebread_N = mkTerm "beebread_N" ;
lin beech_N = mkTerm "beech_N" ;
lin beechen_A = mkTerm "beechen_A" ;
lin beechnut_N = mkTerm "beechnut_N" ;
lin beef_1_N = mkTerm "beef_1_N" ;
lin beef_2_N = mkTerm "beef_2_N" ;
lin beef_3_N = mkTerm "beef_3_N" ;
lin beef_V = mkTerm "beef_V" ;
lin beef_up_V2 = mkTerm "beef_up_V2" ;
lin beefcake_N = mkTerm "beefcake_N" ;
lin beefeater_N = mkTerm "beefeater_N" ;
lin beefsteak_N = mkTerm "beefsteak_N" ;
lin beefwood_N = mkTerm "beefwood_N" ;
lin beefy_A = mkTerm "beefy_A" ;
lin beehive_N = mkTerm "beehive_N" ;
lin beekeeper_N = mkTerm "beekeeper_N" ;
lin beekeeping_N = mkTerm "beekeeping_N" ;
lin beeline_N = mkTerm "beeline_N" ;
lin beep_N = mkTerm "beep_N" ;
lin beeper_N = mkTerm "beeper_N" ;
lin beer_N = mkTerm "beer_N" ;
lin beery_A = mkTerm "beery_A" ;
lin beeswax_N = mkTerm "beeswax_N" ;
lin beeswax_V2 = mkTerm "beeswax_V2" ;
lin beet_N = mkTerm "beet_N" ;
lin beetle_A = mkTerm "beetle_A" ;
lin beetle_N = mkTerm "beetle_N" ;
lin beetle_V = mkTerm "beetle_V" ;
lin beetle_browed_A = mkTerm "beetle_browed_A" ;
lin beetroot_N = mkTerm "beetroot_N" ;
lin befall_V = mkTerm "befall_V" ;
lin befall_V2 = mkTerm "befall_V2" ;
lin befit_V2 = mkTerm "befit_V2" ;
lin befitting_A = mkTerm "befitting_A" ;
lin befogged_A = mkTerm "befogged_A" ;
lin before_Adv = mkTerm "before_Adv" ;
lin before_Subj = mkTerm "before_Subj" ;
lin beforehand_A = mkTerm "beforehand_A" ;
lin beforehand_Adv = mkTerm "beforehand_Adv" ;
lin befoul_V2 = mkTerm "befoul_V2" ;
lin befoulment_N = mkTerm "befoulment_N" ;
lin befriend_V2 = mkTerm "befriend_V2" ;
lin beg_V = mkTerm "beg_V" ;
lin beg_V2 = mkTerm "beg_V2" ;
lin beget_V2 = mkTerm "beget_V2" ;
lin begetter_N = mkTerm "begetter_N" ;
lin beggar_N = mkTerm "beggar_N" ;
lin beggar_V2 = mkTerm "beggar_V2" ;
lin beggarly_A = mkTerm "beggarly_A" ;
lin beggarman_N = mkTerm "beggarman_N" ;
lin beggarweed_N = mkTerm "beggarweed_N" ;
lin beggarwoman_N = mkTerm "beggarwoman_N" ;
lin beggary_N = mkTerm "beggary_N" ;
lin begin_V = mkTerm "begin_V" ;
lin begin_V2 = mkTerm "begin_V2" ;
lin begin_ing_VV = mkTerm "begin_ing_VV" ;
lin begin_to_VV = mkTerm "begin_to_VV" ;
lin begin_with_V = mkTerm "begin_with_V" ;
lin beginner_N = mkTerm "beginner_N" ;
lin beginning_N = mkTerm "beginning_N" ;
lin begonia_N = mkTerm "begonia_N" ;
lin begrimed_A = mkTerm "begrimed_A" ;
lin begrudge_V2 = mkTerm "begrudge_V2" ;
lin beguile_V2 = mkTerm "beguile_V2" ;
lin beguilement_N = mkTerm "beguilement_N" ;
lin beguiling_A = mkTerm "beguiling_A" ;
lin beguine_N = mkTerm "beguine_N" ;
lin begum_N = mkTerm "begum_N" ;
lin behalf_N = mkTerm "behalf_N" ;
lin behave_V = mkTerm "behave_V" ;
lin behaved_A = mkTerm "behaved_A" ;
lin behavior_N = mkTerm "behavior_N" ;
lin behavioral_A = mkTerm "behavioral_A" ;
lin behavioristic_A = mkTerm "behavioristic_A" ;
lin behaviour_N = mkTerm "behaviour_N" ;
lin behaviourism_N = mkTerm "behaviourism_N" ;
lin behaviourist_N = mkTerm "behaviourist_N" ;
lin behead_V2 = mkTerm "behead_V2" ;
lin behest_N = mkTerm "behest_N" ;
lin behind_Adv = mkTerm "behind_Adv" ;
lin behind_N = mkTerm "behind_N" ;
lin behindhand_A = mkTerm "behindhand_A" ;
lin behither_Prep = mkTerm "behither_Prep" ;
lin behold_V2 = mkTerm "behold_V2" ;
lin beholden_A = mkTerm "beholden_A" ;
lin beholder_N = mkTerm "beholder_N" ;
lin behove_V2 = mkTerm "behove_V2" ;
lin beige_A = mkTerm "beige_A" ;
lin beige_N = mkTerm "beige_N" ;
lin beijing_PN = mkTerm "beijing_PN" ;
lin being_A = mkTerm "being_A" ;
lin being_N = mkTerm "being_N" ;
lin beirut_PN = mkTerm "beirut_PN" ;
lin beith_PN = mkTerm "beith_PN" ;
lin bejewelled_A = mkTerm "bejewelled_A" ;
lin belabour_V2 = mkTerm "belabour_V2" ;
lin belated_A = mkTerm "belated_A" ;
lin belay_N = mkTerm "belay_N" ;
lin belay_V2 = mkTerm "belay_V2" ;
lin belaying_pin_N = mkTerm "belaying_pin_N" ;
lin belch_N = mkTerm "belch_N" ;
lin belch_V = mkTerm "belch_V" ;
lin belch_V2 = mkTerm "belch_V2" ;
lin belching_N = mkTerm "belching_N" ;
lin beldam_N = mkTerm "beldam_N" ;
lin beldame_N = mkTerm "beldame_N" ;
lin beleaguer_V2 = mkTerm "beleaguer_V2" ;
lin belem_PN = mkTerm "belem_PN" ;
lin belemnite_N = mkTerm "belemnite_N" ;
lin belemnitic_A = mkTerm "belemnitic_A" ;
lin belfast_PN = mkTerm "belfast_PN" ;
lin belfry_N = mkTerm "belfry_N" ;
lin belgian_A = mkTerm "belgian_A" ;
lin belgian_N = mkTerm "belgian_N" ;
lin belgium_PN = mkTerm "belgium_PN" ;
lin belgrade_PN = mkTerm "belgrade_PN" ;
lin belie_V2 = mkTerm "belie_V2" ;
lin belief_N = mkTerm "belief_N" ;
lin believable_A = mkTerm "believable_A" ;
lin believe_V = mkTerm "believe_V" ;
lin believe_V2 = mkTerm "believe_V2" ;
lin believe_VS = mkTerm "believe_VS" ;
lin believer_N = mkTerm "believer_N" ;
lin believing_N = mkTerm "believing_N" ;
lin belike_Adv = mkTerm "belike_Adv" ;
lin belinda_PN = mkTerm "belinda_PN" ;
lin belittle_V2 = mkTerm "belittle_V2" ;
lin belittling_A = mkTerm "belittling_A" ;
lin belittling_N = mkTerm "belittling_N" ;
lin bell_N = mkTerm "bell_N" ;
lin bell_V2 = mkTerm "bell_V2" ;
lin bell_bottomed_A = mkTerm "bell_bottomed_A" ;
lin bell_buoy_N = mkTerm "bell_buoy_N" ;
lin bell_flower_N = mkTerm "bell_flower_N" ;
lin bell_founder_N = mkTerm "bell_founder_N" ;
lin bell_foundry_N = mkTerm "bell_foundry_N" ;
lin bell_metal_N = mkTerm "bell_metal_N" ;
lin bell_push_N = mkTerm "bell_push_N" ;
lin bell_ringer_N = mkTerm "bell_ringer_N" ;
lin bell_tent_N = mkTerm "bell_tent_N" ;
lin bella_PN = mkTerm "bella_PN" ;
lin belladonna_N = mkTerm "belladonna_N" ;
lin bellarmine_N = mkTerm "bellarmine_N" ;
lin bellbird_N = mkTerm "bellbird_N" ;
lin bellboy_N = mkTerm "bellboy_N" ;
lin belle_N = mkTerm "belle_N" ;
lin belle_PN = mkTerm "belle_PN" ;
lin belletristic_A = mkTerm "belletristic_A" ;
lin bellhop_N = mkTerm "bellhop_N" ;
lin bellicose_A = mkTerm "bellicose_A" ;
lin bellicosity_N = mkTerm "bellicosity_N" ;
lin belligerence_N = mkTerm "belligerence_N" ;
lin belligerency_N = mkTerm "belligerency_N" ;
lin belligerent_A = mkTerm "belligerent_A" ;
lin belligerent_N = mkTerm "belligerent_N" ;
lin bellow_N = mkTerm "bellow_N" ;
lin bellow_V = mkTerm "bellow_V" ;
lin bellow_V2 = mkTerm "bellow_V2" ;
lin bellows_N = mkTerm "bellows_N" ;
lin bellpull_N = mkTerm "bellpull_N" ;
lin bellshill_PN = mkTerm "bellshill_PN" ;
lin bellwether_N = mkTerm "bellwether_N" ;
lin bellwort_N = mkTerm "bellwort_N" ;
lin belly_N = mkTerm "belly_N" ;
lin belly_V = mkTerm "belly_V" ;
lin belly_V2 = mkTerm "belly_V2" ;
lin bellyache_N = mkTerm "bellyache_N" ;
lin bellyache_V = mkTerm "bellyache_V" ;
lin bellyband_N = mkTerm "bellyband_N" ;
lin bellyflop_N = mkTerm "bellyflop_N" ;
lin bellyful_N = mkTerm "bellyful_N" ;
lin bellyland_V = mkTerm "bellyland_V" ;
lin bellylaugh_N = mkTerm "bellylaugh_N" ;
lin bellylaugh_V = mkTerm "bellylaugh_V" ;
lin bellyless_A = mkTerm "bellyless_A" ;
lin belo_horizonte_PN = mkTerm "belo_horizonte_PN" ;
lin belong_to_V2 = mkTerm "belong_to_V2" ;
lin belong_with_V2 = mkTerm "belong_with_V2" ;
lin belonging_N = mkTerm "belonging_N" ;
lin beloved_A = mkTerm "beloved_A" ;
lin beloved_N = mkTerm "beloved_N" ;
lin below_Adv = mkTerm "below_Adv" ;
lin below_Prep = mkTerm "below_Prep" ;
lin belowground_A = mkTerm "belowground_A" ;
lin belper_PN = mkTerm "belper_PN" ;
lin belt_N = mkTerm "belt_N" ;
lin belt_V2 = mkTerm "belt_V2" ;
lin belt_out_V2 = mkTerm "belt_out_V2" ;
lin belt_up_V = mkTerm "belt_up_V" ;
lin belting_N = mkTerm "belting_N" ;
lin beltlike_A = mkTerm "beltlike_A" ;
lin beltway_N = mkTerm "beltway_N" ;
lin beluga_N = mkTerm "beluga_N" ;
lin belvedere_N = mkTerm "belvedere_N" ;
lin bemoan_V2 = mkTerm "bemoan_V2" ;
lin bemused_A = mkTerm "bemused_A" ;
lin ben_N = mkTerm "ben_N" ;
lin ben_PN = mkTerm "ben_PN" ;
lin bench_N = mkTerm "bench_N" ;
lin benchmark_N = mkTerm "benchmark_N" ;
lin bend_N = mkTerm "bend_N" ;
lin bend_V = mkTerm "bend_V" ;
lin bend_V2 = mkTerm "bend_V2" ;
lin bend_down_V = mkTerm "bend_down_V" ;
lin bend_over_V = mkTerm "bend_over_V" ;
lin bend_over_backwards_V = mkTerm "bend_over_backwards_V" ;
lin bendability_N = mkTerm "bendability_N" ;
lin bendable_A = mkTerm "bendable_A" ;
lin bender_N = mkTerm "bender_N" ;
lin bending_N = mkTerm "bending_N" ;
lin beneath_Adv = mkTerm "beneath_Adv" ;
lin beneath_Prep = mkTerm "beneath_Prep" ;
lin benedick_N = mkTerm "benedick_N" ;
lin benedictine_A = mkTerm "benedictine_A" ;
lin benedictine_N = mkTerm "benedictine_N" ;
lin benediction_N = mkTerm "benediction_N" ;
lin benedictory_A = mkTerm "benedictory_A" ;
lin benefaction_N = mkTerm "benefaction_N" ;
lin benefactor_N = mkTerm "benefactor_N" ;
lin benefactress_N = mkTerm "benefactress_N" ;
lin benefic_A = mkTerm "benefic_A" ;
lin benefice_N = mkTerm "benefice_N" ;
lin beneficed_A = mkTerm "beneficed_A" ;
lin beneficence_N = mkTerm "beneficence_N" ;
lin beneficent_A = mkTerm "beneficent_A" ;
lin beneficial_A = mkTerm "beneficial_A" ;
lin beneficiary_A = mkTerm "beneficiary_A" ;
lin beneficiary_N = mkTerm "beneficiary_N" ;
lin benefit_N = mkTerm "benefit_N" ;
lin benefit_V = mkTerm "benefit_V" ;
lin benefit_V2 = mkTerm "benefit_V2" ;
lin benevolence_N = mkTerm "benevolence_N" ;
lin benevolent_A = mkTerm "benevolent_A" ;
lin bengali_A = mkTerm "bengali_A" ;
lin bengali_N = mkTerm "bengali_N" ;
lin benighted_A = mkTerm "benighted_A" ;
lin benign_A = mkTerm "benign_A" ;
lin benignant_A = mkTerm "benignant_A" ;
lin benignity_N = mkTerm "benignity_N" ;
lin benin_PN = mkTerm "benin_PN" ;
lin beninese_A = mkTerm "beninese_A" ;
lin beninese_N = mkTerm "beninese_N" ;
lin benison_N = mkTerm "benison_N" ;
lin benjamin_PN = mkTerm "benjamin_PN" ;
lin bennet_N = mkTerm "bennet_N" ;
lin benny_PN = mkTerm "benny_PN" ;
lin bennäs_PN = mkTerm "bennäs_PN" ;
lin bent_A = mkTerm "bent_A" ;
lin bent_N = mkTerm "bent_N" ;
lin benthic_A = mkTerm "benthic_A" ;
lin benthos_N = mkTerm "benthos_N" ;
lin bentonite_N = mkTerm "bentonite_N" ;
lin bentonitic_A = mkTerm "bentonitic_A" ;
lin bentwood_N = mkTerm "bentwood_N" ;
lin benumbed_A = mkTerm "benumbed_A" ;
lin benzedrine_N = mkTerm "benzedrine_N" ;
lin benzene_N = mkTerm "benzene_N" ;
lin benzenoid_A = mkTerm "benzenoid_A" ;
lin benzine_N = mkTerm "benzine_N" ;
lin benzoate_N = mkTerm "benzoate_N" ;
lin benzocaine_N = mkTerm "benzocaine_N" ;
lin benzodiazepine_N = mkTerm "benzodiazepine_N" ;
lin benzofuran_N = mkTerm "benzofuran_N" ;
lin benzoic_A = mkTerm "benzoic_A" ;
lin benzoin_N = mkTerm "benzoin_N" ;
lin benzol_N = mkTerm "benzol_N" ;
lin benzyl_N = mkTerm "benzyl_N" ;
lin benzylic_A = mkTerm "benzylic_A" ;
lin beograd_PN = mkTerm "beograd_PN" ;
lin bequeath_V2 = mkTerm "bequeath_V2" ;
lin bequest_N = mkTerm "bequest_N" ;
lin berate_V2 = mkTerm "berate_V2" ;
lin berating_N = mkTerm "berating_N" ;
lin bereave_V2 = mkTerm "bereave_V2" ;
lin bereaved_N = mkTerm "bereaved_N" ;
lin bereavement_N = mkTerm "bereavement_N" ;
lin bereft_A = mkTerm "bereft_A" ;
lin beret_N = mkTerm "beret_N" ;
lin berg_N = mkTerm "berg_N" ;
lin bergamo_PN = mkTerm "bergamo_PN" ;
lin bergamot_N = mkTerm "bergamot_N" ;
lin bergen_PN = mkTerm "bergen_PN" ;
lin bergenia_N = mkTerm "bergenia_N" ;
lin beri_beri_N = mkTerm "beri_beri_N" ;
lin berk_N = mkTerm "berk_N" ;
lin berkelium_N = mkTerm "berkelium_N" ;
lin berkhamsted_PN = mkTerm "berkhamsted_PN" ;
lin berkshire_PN = mkTerm "berkshire_PN" ;
lin berlin_N = mkTerm "berlin_N" ;
lin berlin_PN = mkTerm "berlin_PN" ;
lin berm_N = mkTerm "berm_N" ;
lin bermuda_PN = mkTerm "bermuda_PN" ;
lin bermudan_A = mkTerm "bermudan_A" ;
lin bermudan_N = mkTerm "bermudan_N" ;
lin bern_PN = mkTerm "bern_PN" ;
lin bernard_PN = mkTerm "bernard_PN" ;
lin bernie_PN = mkTerm "bernie_PN" ;
lin beroe_N = mkTerm "beroe_N" ;
lin berried_A = mkTerm "berried_A" ;
lin berry_N = mkTerm "berry_N" ;
lin berserk_A = mkTerm "berserk_A" ;
lin berserker_N = mkTerm "berserker_N" ;
lin bert_PN = mkTerm "bert_PN" ;
lin berth_N = mkTerm "berth_N" ;
lin berth_V = mkTerm "berth_V" ;
lin berth_V2 = mkTerm "berth_V2" ;
lin bertha_PN = mkTerm "bertha_PN" ;
lin bertie_PN = mkTerm "bertie_PN" ;
lin berwick_upon_tweed_PN = mkTerm "berwick_upon_tweed_PN" ;
lin beryl_N = mkTerm "beryl_N" ;
lin beryl_PN = mkTerm "beryl_PN" ;
lin beryllium_N = mkTerm "beryllium_N" ;
lin beseech_V2 = mkTerm "beseech_V2" ;
lin beseeching_A = mkTerm "beseeching_A" ;
lin beseem_V2 = mkTerm "beseem_V2" ;
lin beset_V2 = mkTerm "beset_V2" ;
lin beshrew_V2 = mkTerm "beshrew_V2" ;
lin beside_Prep = mkTerm "beside_Prep" ;
lin besides_Adv = mkTerm "besides_Adv" ;
lin besides_Prep = mkTerm "besides_Prep" ;
lin besiege_V2 = mkTerm "besiege_V2" ;
lin besieger_N = mkTerm "besieger_N" ;
lin besmear_V2 = mkTerm "besmear_V2" ;
lin besmirch_V2 = mkTerm "besmirch_V2" ;
lin besom_N = mkTerm "besom_N" ;
lin besotted_A = mkTerm "besotted_A" ;
lin bespangled_A = mkTerm "bespangled_A" ;
lin bespattered_A = mkTerm "bespattered_A" ;
lin bespeak_V2 = mkTerm "bespeak_V2" ;
lin bespectacled_A = mkTerm "bespectacled_A" ;
lin bespoke_A = mkTerm "bespoke_A" ;
lin besprent_A = mkTerm "besprent_A" ;
lin bess_PN = mkTerm "bess_PN" ;
lin bessie_PN = mkTerm "bessie_PN" ;
lin best_Adv = mkTerm "best_Adv" ;
lin best_N = mkTerm "best_N" ;
lin best_V2 = mkTerm "best_V2" ;
lin best_seller_N = mkTerm "best_seller_N" ;
lin bestial_A = mkTerm "bestial_A" ;
lin bestiality_N = mkTerm "bestiality_N" ;
lin bestiary_N = mkTerm "bestiary_N" ;
lin bestir_V2 = mkTerm "bestir_V2" ;
lin bestow_V2 = mkTerm "bestow_V2" ;
lin bestowal_N = mkTerm "bestowal_N" ;
lin bestrew_V2 = mkTerm "bestrew_V2" ;
lin bestride_V2 = mkTerm "bestride_V2" ;
lin bestselling_A = mkTerm "bestselling_A" ;
lin bestubbled_A = mkTerm "bestubbled_A" ;
lin bet_N = mkTerm "bet_N" ;
lin bet_V = mkTerm "bet_V" ;
lin bet_V2 = mkTerm "bet_V2" ;
lin bet_VS = mkTerm "bet_VS" ;
lin beta_A = mkTerm "beta_A" ;
lin beta_N = mkTerm "beta_N" ;
lin betaine_N = mkTerm "betaine_N" ;
lin betake_V2 = mkTerm "betake_V2" ;
lin betatron_N = mkTerm "betatron_N" ;
lin bete_noire_N = mkTerm "bete_noire_N" ;
lin betel_N = mkTerm "betel_N" ;
lin betel_nut_N = mkTerm "betel_nut_N" ;
lin beth_N = mkTerm "beth_N" ;
lin bethel_N = mkTerm "bethel_N" ;
lin bethink_V2 = mkTerm "bethink_V2" ;
lin bethune_PN = mkTerm "bethune_PN" ;
lin betide_V2 = mkTerm "betide_V2" ;
lin betimes_Adv = mkTerm "betimes_Adv" ;
lin betoken_V2 = mkTerm "betoken_V2" ;
lin betray_V2 = mkTerm "betray_V2" ;
lin betrayal_N = mkTerm "betrayal_N" ;
lin betrayer_N = mkTerm "betrayer_N" ;
lin betroth_V2 = mkTerm "betroth_V2" ;
lin betrothal_N = mkTerm "betrothal_N" ;
lin betrothedFem_N = mkTerm "betrothedFem_N" ;
lin betrothedMasc_N = mkTerm "betrothedMasc_N" ;
lin betsy_PN = mkTerm "betsy_PN" ;
lin better_A = mkTerm "better_A" ;
lin better_Adv = mkTerm "better_Adv" ;
lin better_N = mkTerm "better_N" ;
lin better_V2 = mkTerm "better_V2" ;
lin bettering_A = mkTerm "bettering_A" ;
lin betterment_N = mkTerm "betterment_N" ;
lin bettong_N = mkTerm "bettong_N" ;
lin bettor_N = mkTerm "bettor_N" ;
lin betty_PN = mkTerm "betty_PN" ;
lin betulaceous_A = mkTerm "betulaceous_A" ;
lin between_Adv = mkTerm "between_Adv" ;
lin betwixen_Prep = mkTerm "betwixen_Prep" ;
lin betwixt_Prep = mkTerm "betwixt_Prep" ;
lin bevatron_N = mkTerm "bevatron_N" ;
lin bevel_N = mkTerm "bevel_N" ;
lin bevel_V2 = mkTerm "bevel_V2" ;
lin beverage_N = mkTerm "beverage_N" ;
lin beverley_PN = mkTerm "beverley_PN" ;
lin bevy_N = mkTerm "bevy_N" ;
lin bewail_V2 = mkTerm "bewail_V2" ;
lin beware_V = mkTerm "beware_V" ;
lin beware_V2 = mkTerm "beware_V2" ;
lin bewdley_PN = mkTerm "bewdley_PN" ;
lin bewilder_V2 = mkTerm "bewilder_V2" ;
lin bewilderedly_Adv = mkTerm "bewilderedly_Adv" ;
lin bewildering_A = mkTerm "bewildering_A" ;
lin bewilderment_N = mkTerm "bewilderment_N" ;
lin bewitch_V2 = mkTerm "bewitch_V2" ;
lin bewitchery_N = mkTerm "bewitchery_N" ;
lin bewitching_A = mkTerm "bewitching_A" ;
lin bexhill_PN = mkTerm "bexhill_PN" ;
lin bexley_PN = mkTerm "bexley_PN" ;
lin bey_N = mkTerm "bey_N" ;
lin beyond_Adv = mkTerm "beyond_Adv" ;
lin beyond_Prep = mkTerm "beyond_Prep" ;
lin bezant_N = mkTerm "bezant_N" ;
lin bezel_N = mkTerm "bezel_N" ;
lin bezique_N = mkTerm "bezique_N" ;
lin bgcolor_N = mkTerm "bgcolor_N" ;
lin bhakti_N = mkTerm "bhakti_N" ;
lin bhang_N = mkTerm "bhang_N" ;
lin bhutan_PN = mkTerm "bhutan_PN" ;
lin bhutani_A = mkTerm "bhutani_A" ;
lin bhutani_N = mkTerm "bhutani_N" ;
lin bialy_N = mkTerm "bialy_N" ;
lin biannually_Adv = mkTerm "biannually_Adv" ;
lin bias_A = mkTerm "bias_A" ;
lin bias_N = mkTerm "bias_N" ;
lin bias_V2 = mkTerm "bias_V2" ;
lin biauricular_A = mkTerm "biauricular_A" ;
lin biaxial_A = mkTerm "biaxial_A" ;
lin bib_N = mkTerm "bib_N" ;
lin bib_V = mkTerm "bib_V" ;
lin bibbed_A = mkTerm "bibbed_A" ;
lin bible_N = mkTerm "bible_N" ;
lin bibless_A = mkTerm "bibless_A" ;
lin biblical_A = mkTerm "biblical_A" ;
lin bibliographer_N = mkTerm "bibliographer_N" ;
lin bibliographic_A = mkTerm "bibliographic_A" ;
lin bibliography_N = mkTerm "bibliography_N" ;
lin bibliolatrous_A = mkTerm "bibliolatrous_A" ;
lin bibliolatry_N = mkTerm "bibliolatry_N" ;
lin bibliomania_N = mkTerm "bibliomania_N" ;
lin bibliomaniacal_A = mkTerm "bibliomaniacal_A" ;
lin bibliophile_N = mkTerm "bibliophile_N" ;
lin bibliophilic_A = mkTerm "bibliophilic_A" ;
lin bibliopole_N = mkTerm "bibliopole_N" ;
lin bibliopolic_A = mkTerm "bibliopolic_A" ;
lin bibliotheca_N = mkTerm "bibliotheca_N" ;
lin bibliothecal_A = mkTerm "bibliothecal_A" ;
lin bibliotic_A = mkTerm "bibliotic_A" ;
lin bibliotics_N = mkTerm "bibliotics_N" ;
lin bibliotist_N = mkTerm "bibliotist_N" ;
lin bibulous_A = mkTerm "bibulous_A" ;
lin bicameral_A = mkTerm "bicameral_A" ;
lin bicapsular_A = mkTerm "bicapsular_A" ;
lin bicarbonate_N = mkTerm "bicarbonate_N" ;
lin bicentenary_N = mkTerm "bicentenary_N" ;
lin bicentennial_A = mkTerm "bicentennial_A" ;
lin bicentennial_N = mkTerm "bicentennial_N" ;
lin bicentric_A = mkTerm "bicentric_A" ;
lin bicephalous_A = mkTerm "bicephalous_A" ;
lin biceps_N = mkTerm "biceps_N" ;
lin bicester_PN = mkTerm "bicester_PN" ;
lin bichromate_N = mkTerm "bichromate_N" ;
lin bichromated_A = mkTerm "bichromated_A" ;
lin bicipital_A = mkTerm "bicipital_A" ;
lin bicker_N = mkTerm "bicker_N" ;
lin bicker_V = mkTerm "bicker_V" ;
lin bicolor_A = mkTerm "bicolor_A" ;
lin biconcave_A = mkTerm "biconcave_A" ;
lin biconvex_A = mkTerm "biconvex_A" ;
lin bicorn_A = mkTerm "bicorn_A" ;
lin bicorn_N = mkTerm "bicorn_N" ;
lin bicuspid_A = mkTerm "bicuspid_A" ;
lin bicycle_N = mkTerm "bicycle_N" ;
lin bicycle_V = mkTerm "bicycle_V" ;
lin bicyclic_A = mkTerm "bicyclic_A" ;
lin bicycling_N = mkTerm "bicycling_N" ;
lin bicylindrical_A = mkTerm "bicylindrical_A" ;
lin bid_N = mkTerm "bid_N" ;
lin bid_V = mkTerm "bid_V" ;
lin bid_V2 = mkTerm "bid_V2" ;
lin bid_up_V = mkTerm "bid_up_V" ;
lin biddable_A = mkTerm "biddable_A" ;
lin bidder_N = mkTerm "bidder_N" ;
lin bidding_N = mkTerm "bidding_N" ;
lin biddulph_PN = mkTerm "biddulph_PN" ;
lin bide_V2 = mkTerm "bide_V2" ;
lin bideford_PN = mkTerm "bideford_PN" ;
lin bidentate_A = mkTerm "bidentate_A" ;
lin bidet_N = mkTerm "bidet_N" ;
lin bidirectional_A = mkTerm "bidirectional_A" ;
lin bielefeld_PN = mkTerm "bielefeld_PN" ;
lin biennial_A = mkTerm "biennial_A" ;
lin biennial_N = mkTerm "biennial_N" ;
lin bier_N = mkTerm "bier_N" ;
lin biface_A = mkTerm "biface_A" ;
lin biff_N = mkTerm "biff_N" ;
lin biff_V2 = mkTerm "biff_V2" ;
lin bifid_A = mkTerm "bifid_A" ;
lin bifilar_A = mkTerm "bifilar_A" ;
lin biflagellate_A = mkTerm "biflagellate_A" ;
lin bifocal_A = mkTerm "bifocal_A" ;
lin bifocals_N = mkTerm "bifocals_N" ;
lin bifoliate_A = mkTerm "bifoliate_A" ;
lin biform_A = mkTerm "biform_A" ;
lin bifurcate_A = mkTerm "bifurcate_A" ;
lin bifurcate_V = mkTerm "bifurcate_V" ;
lin bifurcate_V2 = mkTerm "bifurcate_V2" ;
lin bifurcation_N = mkTerm "bifurcation_N" ;
lin big_A = mkTerm "big_A" ;
lin big_boned_A = mkTerm "big_boned_A" ;
lin big_up_V2 = mkTerm "big_up_V2" ;
lin bigamist_N = mkTerm "bigamist_N" ;
lin bigamous_A = mkTerm "bigamous_A" ;
lin bigamy_N = mkTerm "bigamy_N" ;
lin bigeminal_A = mkTerm "bigeminal_A" ;
lin bigeneric_A = mkTerm "bigeneric_A" ;
lin bigeye_N = mkTerm "bigeye_N" ;
lin biggin_N = mkTerm "biggin_N" ;
lin biggish_A = mkTerm "biggish_A" ;
lin biggleswade_PN = mkTerm "biggleswade_PN" ;
lin bighead_N = mkTerm "bighead_N" ;
lin bigheaded_A = mkTerm "bigheaded_A" ;
lin bigheartedness_N = mkTerm "bigheartedness_N" ;
lin bighorn_N = mkTerm "bighorn_N" ;
lin bight_N = mkTerm "bight_N" ;
lin bigmouthed_A = mkTerm "bigmouthed_A" ;
lin bignoniaceous_A = mkTerm "bignoniaceous_A" ;
lin bignoniad_N = mkTerm "bignoniad_N" ;
lin bigos_N = mkTerm "bigos_N" ;
lin bigot_N = mkTerm "bigot_N" ;
lin bigoted_A = mkTerm "bigoted_A" ;
lin bigotry_N = mkTerm "bigotry_N" ;
lin bigram_N = mkTerm "bigram_N" ;
lin bigwig_N = mkTerm "bigwig_N" ;
lin bijou_A = mkTerm "bijou_A" ;
lin bijou_N = mkTerm "bijou_N" ;
lin bike_N = mkTerm "bike_N" ;
lin bike_V = mkTerm "bike_V" ;
lin bikini_N = mkTerm "bikini_N" ;
lin bilabial_A = mkTerm "bilabial_A" ;
lin bilabial_N = mkTerm "bilabial_N" ;
lin bilabiate_A = mkTerm "bilabiate_A" ;
lin bilateral_A = mkTerm "bilateral_A" ;
lin bilateralism_N = mkTerm "bilateralism_N" ;
lin bilaterality_N = mkTerm "bilaterality_N" ;
lin bilbao_PN = mkTerm "bilbao_PN" ;
lin bilberry_N = mkTerm "bilberry_N" ;
lin bile_N = mkTerm "bile_N" ;
lin bile_duct_N = mkTerm "bile_duct_N" ;
lin bilge_N = mkTerm "bilge_N" ;
lin bilge_water_N = mkTerm "bilge_water_N" ;
lin bilgy_A = mkTerm "bilgy_A" ;
lin bilharzia_N = mkTerm "bilharzia_N" ;
lin biliary_A = mkTerm "biliary_A" ;
lin bilimbi_N = mkTerm "bilimbi_N" ;
lin bilinear_A = mkTerm "bilinear_A" ;
lin bilingual_A = mkTerm "bilingual_A" ;
lin bilingual_N = mkTerm "bilingual_N" ;
lin bilingualism_N = mkTerm "bilingualism_N" ;
lin bilious_A = mkTerm "bilious_A" ;
lin biliousness_N = mkTerm "biliousness_N" ;
lin bilirubin_N = mkTerm "bilirubin_N" ;
lin bilk_V2 = mkTerm "bilk_V2" ;
lin bill_N = mkTerm "bill_N" ;
lin bill_PN = mkTerm "bill_PN" ;
lin bill_V = mkTerm "bill_V" ;
lin bill_V2 = mkTerm "bill_V2" ;
lin bill_poster_N = mkTerm "bill_poster_N" ;
lin bill_sticker_N = mkTerm "bill_sticker_N" ;
lin billabong_N = mkTerm "billabong_N" ;
lin billboard_N = mkTerm "billboard_N" ;
lin billericay_PN = mkTerm "billericay_PN" ;
lin billet_N = mkTerm "billet_N" ;
lin billet_V2 = mkTerm "billet_V2" ;
lin billet_doux_N = mkTerm "billet_doux_N" ;
lin billfish_N = mkTerm "billfish_N" ;
lin billfold_N = mkTerm "billfold_N" ;
lin billhook_N = mkTerm "billhook_N" ;
lin billiard_A = mkTerm "billiard_A" ;
lin billiard_marker_N = mkTerm "billiard_marker_N" ;
lin billiard_player_N = mkTerm "billiard_player_N" ;
lin billiard_room_N = mkTerm "billiard_room_N" ;
lin billiard_table_N = mkTerm "billiard_table_N" ;
lin billiards_N = mkTerm "billiards_N" ;
lin billingsgate_N = mkTerm "billingsgate_N" ;
lin billington_PN = mkTerm "billington_PN" ;
lin billion_A = mkTerm "billion_A" ;
lin billion_N = mkTerm "billion_N" ;
lin billionaire_N = mkTerm "billionaire_N" ;
lin billionth_A = mkTerm "billionth_A" ;
lin billionth_N = mkTerm "billionth_N" ;
lin billow_N = mkTerm "billow_N" ;
lin billow_V = mkTerm "billow_V" ;
lin billowy_A = mkTerm "billowy_A" ;
lin billy_N = mkTerm "billy_N" ;
lin billy_PN = mkTerm "billy_PN" ;
lin billy_goat_N = mkTerm "billy_goat_N" ;
lin billy_ho_N = mkTerm "billy_ho_N" ;
lin billy_o_N = mkTerm "billy_o_N" ;
lin bilobate_A = mkTerm "bilobate_A" ;
lin bilocation_N = mkTerm "bilocation_N" ;
lin bilocular_A = mkTerm "bilocular_A" ;
lin biltong_N = mkTerm "biltong_N" ;
lin bimbo_N = mkTerm "bimbo_N" ;
lin bimester_N = mkTerm "bimester_N" ;
lin bimestrial_A = mkTerm "bimestrial_A" ;
lin bimetal_A = mkTerm "bimetal_A" ;
lin bimetal_N = mkTerm "bimetal_N" ;
lin bimetallic_A = mkTerm "bimetallic_A" ;
lin bimetallism_N = mkTerm "bimetallism_N" ;
lin bimetallist_N = mkTerm "bimetallist_N" ;
lin bimetallistic_A = mkTerm "bimetallistic_A" ;
lin bimillenial_A = mkTerm "bimillenial_A" ;
lin bimillennium_N = mkTerm "bimillennium_N" ;
lin bimodal_A = mkTerm "bimodal_A" ;
lin bimolecular_A = mkTerm "bimolecular_A" ;
lin bimonthly_A = mkTerm "bimonthly_A" ;
lin bimonthly_Adv = mkTerm "bimonthly_Adv" ;
lin bimonthly_N = mkTerm "bimonthly_N" ;
lin bimorphemic_A = mkTerm "bimorphemic_A" ;
lin bimotored_A = mkTerm "bimotored_A" ;
lin bin_N = mkTerm "bin_N" ;
lin binary_A = mkTerm "binary_A" ;
lin binary_N = mkTerm "binary_N" ;
lin binate_A = mkTerm "binate_A" ;
lin binaural_A = mkTerm "binaural_A" ;
lin bind_N = mkTerm "bind_N" ;
lin bind_V = mkTerm "bind_V" ;
lin bind_V2 = mkTerm "bind_V2" ;
lin bindable_A = mkTerm "bindable_A" ;
lin binder_N = mkTerm "binder_N" ;
lin bindery_N = mkTerm "bindery_N" ;
lin binding_A = mkTerm "binding_A" ;
lin binding_N = mkTerm "binding_N" ;
lin bindweed_N = mkTerm "bindweed_N" ;
lin bine_N = mkTerm "bine_N" ;
lin binge_N = mkTerm "binge_N" ;
lin bingley_PN = mkTerm "bingley_PN" ;
lin bingo_N = mkTerm "bingo_N" ;
lin binnacle_N = mkTerm "binnacle_N" ;
lin binocular_A = mkTerm "binocular_A" ;
lin binoculars_N = mkTerm "binoculars_N" ;
lin binomial_A = mkTerm "binomial_A" ;
lin binomial_N = mkTerm "binomial_N" ;
lin binturong_N = mkTerm "binturong_N" ;
lin binucleate_A = mkTerm "binucleate_A" ;
lin bio_N = mkTerm "bio_N" ;
lin bioassay_N = mkTerm "bioassay_N" ;
lin biocatalyst_N = mkTerm "biocatalyst_N" ;
lin biocatalytic_A = mkTerm "biocatalytic_A" ;
lin biochemical_A = mkTerm "biochemical_A" ;
lin biochemist_N = mkTerm "biochemist_N" ;
lin biochemistry_N = mkTerm "biochemistry_N" ;
lin biochip_N = mkTerm "biochip_N" ;
lin bioclimatic_A = mkTerm "bioclimatic_A" ;
lin bioclimatology_N = mkTerm "bioclimatology_N" ;
lin biodegradable_A = mkTerm "biodegradable_A" ;
lin biodiversity_N = mkTerm "biodiversity_N" ;
lin bioelectricity_N = mkTerm "bioelectricity_N" ;
lin bioethics_N = mkTerm "bioethics_N" ;
lin biofeedback_N = mkTerm "biofeedback_N" ;
lin biogenesis_N = mkTerm "biogenesis_N" ;
lin biogenetic_A = mkTerm "biogenetic_A" ;
lin biogenic_A = mkTerm "biogenic_A" ;
lin biogenous_A = mkTerm "biogenous_A" ;
lin biogeographic_A = mkTerm "biogeographic_A" ;
lin biogeography_N = mkTerm "biogeography_N" ;
lin biograph_N = mkTerm "biograph_N" ;
lin biographer_N = mkTerm "biographer_N" ;
lin biographic_A = mkTerm "biographic_A" ;
lin biographical_A = mkTerm "biographical_A" ;
lin biography_N = mkTerm "biography_N" ;
lin biohazard_N = mkTerm "biohazard_N" ;
lin biological_A = mkTerm "biological_A" ;
lin biologism_N = mkTerm "biologism_N" ;
lin biologist_N = mkTerm "biologist_N" ;
lin biologistic_A = mkTerm "biologistic_A" ;
lin biology_N = mkTerm "biology_N" ;
lin bioluminescence_N = mkTerm "bioluminescence_N" ;
lin bioluminescent_A = mkTerm "bioluminescent_A" ;
lin biomass_N = mkTerm "biomass_N" ;
lin biome_N = mkTerm "biome_N" ;
lin biomedical_A = mkTerm "biomedical_A" ;
lin biomedicine_N = mkTerm "biomedicine_N" ;
lin biometrics_N = mkTerm "biometrics_N" ;
lin bionic_A = mkTerm "bionic_A" ;
lin bionics_N = mkTerm "bionics_N" ;
lin biont_N = mkTerm "biont_N" ;
lin biophysicist_N = mkTerm "biophysicist_N" ;
lin biophysics_N = mkTerm "biophysics_N" ;
lin biopiracy_N = mkTerm "biopiracy_N" ;
lin biopsy_N = mkTerm "biopsy_N" ;
lin bioremediation_N = mkTerm "bioremediation_N" ;
lin biosafety_N = mkTerm "biosafety_N" ;
lin bioscope_N = mkTerm "bioscope_N" ;
lin biosphere_N = mkTerm "biosphere_N" ;
lin biosynthesis_N = mkTerm "biosynthesis_N" ;
lin biosynthetic_A = mkTerm "biosynthetic_A" ;
lin biosystematic_A = mkTerm "biosystematic_A" ;
lin biosystematics_N = mkTerm "biosystematics_N" ;
lin biota_N = mkTerm "biota_N" ;
lin biotechnology_N = mkTerm "biotechnology_N" ;
lin bioterrorism_N = mkTerm "bioterrorism_N" ;
lin biotic_A = mkTerm "biotic_A" ;
lin biotin_N = mkTerm "biotin_N" ;
lin biotite_N = mkTerm "biotite_N" ;
lin biotitic_A = mkTerm "biotitic_A" ;
lin biotype_N = mkTerm "biotype_N" ;
lin biotypic_A = mkTerm "biotypic_A" ;
lin bioweapon_N = mkTerm "bioweapon_N" ;
lin biparous_A = mkTerm "biparous_A" ;
lin bipartisan_A = mkTerm "bipartisan_A" ;
lin bipartite_A = mkTerm "bipartite_A" ;
lin biped_N = mkTerm "biped_N" ;
lin bipedal_A = mkTerm "bipedal_A" ;
lin bipedalism_N = mkTerm "bipedalism_N" ;
lin bipinnate_A = mkTerm "bipinnate_A" ;
lin bipinnatifid_A = mkTerm "bipinnatifid_A" ;
lin biplane_N = mkTerm "biplane_N" ;
lin bipolar_A = mkTerm "bipolar_A" ;
lin biprism_N = mkTerm "biprism_N" ;
lin biquadrate_N = mkTerm "biquadrate_N" ;
lin biquadratic_A = mkTerm "biquadratic_A" ;
lin biquadratic_N = mkTerm "biquadratic_N" ;
lin biracial_A = mkTerm "biracial_A" ;
lin biradial_A = mkTerm "biradial_A" ;
lin birch_A = mkTerm "birch_A" ;
lin birch_N = mkTerm "birch_N" ;
lin birch_V2 = mkTerm "birch_V2" ;
lin birch_rod_N = mkTerm "birch_rod_N" ;
lin bird's_eye_A = mkTerm "bird's_eye_A" ;
lin bird_N = mkTerm "bird_N" ;
lin bird_fancier_N = mkTerm "bird_fancier_N" ;
lin birdbath_N = mkTerm "birdbath_N" ;
lin birdcage_N = mkTerm "birdcage_N" ;
lin birdcall_N = mkTerm "birdcall_N" ;
lin birdhouse_N = mkTerm "birdhouse_N" ;
lin birdie_N = mkTerm "birdie_N" ;
lin birdlime_N = mkTerm "birdlime_N" ;
lin birdnesting_N = mkTerm "birdnesting_N" ;
lin birdwatcher_N = mkTerm "birdwatcher_N" ;
lin birefringent_A = mkTerm "birefringent_A" ;
lin biretta_N = mkTerm "biretta_N" ;
lin birkenhead_PN = mkTerm "birkenhead_PN" ;
lin birling_N = mkTerm "birling_N" ;
lin biro_N = mkTerm "biro_N" ;
lin birr_N = mkTerm "birr_N" ;
lin birstall_PN = mkTerm "birstall_PN" ;
lin birth_N = mkTerm "birth_N" ;
lin birth_control_N = mkTerm "birth_control_N" ;
lin birthday_N = mkTerm "birthday_N" ;
lin birthmark_N = mkTerm "birthmark_N" ;
lin birthplace_N = mkTerm "birthplace_N" ;
lin birthrate_N = mkTerm "birthrate_N" ;
lin birthright_N = mkTerm "birthright_N" ;
lin birthwort_N = mkTerm "birthwort_N" ;
lin birtley_PN = mkTerm "birtley_PN" ;
lin biryani_N = mkTerm "biryani_N" ;
lin biscuit_N = mkTerm "biscuit_N" ;
lin bise_N = mkTerm "bise_N" ;
lin bisect_V2 = mkTerm "bisect_V2" ;
lin bisection_N = mkTerm "bisection_N" ;
lin bisectional_A = mkTerm "bisectional_A" ;
lin biserrate_A = mkTerm "biserrate_A" ;
lin bisexual_A = mkTerm "bisexual_A" ;
lin bisexual_N = mkTerm "bisexual_N" ;
lin bisexuality_N = mkTerm "bisexuality_N" ;
lin bishop's_cleeve_PN = mkTerm "bishop's_cleeve_PN" ;
lin bishop's_stortford_PN = mkTerm "bishop's_stortford_PN" ;
lin bishop_N = mkTerm "bishop_N" ;
lin bishop_auckland_PN = mkTerm "bishop_auckland_PN" ;
lin bishopbriggs_PN = mkTerm "bishopbriggs_PN" ;
lin bishopric_N = mkTerm "bishopric_N" ;
lin bishopry_N = mkTerm "bishopry_N" ;
lin bismuth_N = mkTerm "bismuth_N" ;
lin bismuthal_A = mkTerm "bismuthal_A" ;
lin bismuthic_A = mkTerm "bismuthic_A" ;
lin bison_N = mkTerm "bison_N" ;
lin bisontine_A = mkTerm "bisontine_A" ;
lin bisque_N = mkTerm "bisque_N" ;
lin bister_N = mkTerm "bister_N" ;
lin bistered_A = mkTerm "bistered_A" ;
lin bistro_N = mkTerm "bistro_N" ;
lin bistroic_A = mkTerm "bistroic_A" ;
lin bit_N = mkTerm "bit_N" ;
lin bitartrate_N = mkTerm "bitartrate_N" ;
lin bitch_N = mkTerm "bitch_N" ;
lin bitch_V = mkTerm "bitch_V" ;
lin bitch_up_V2 = mkTerm "bitch_up_V2" ;
lin bitchery_N = mkTerm "bitchery_N" ;
lin bitchy_A = mkTerm "bitchy_A" ;
lin bite_N = mkTerm "bite_N" ;
lin bite_V = mkTerm "bite_V" ;
lin bite_V2 = mkTerm "bite_V2" ;
lin biter_N = mkTerm "biter_N" ;
lin bitewing_N = mkTerm "bitewing_N" ;
lin biting_A = mkTerm "biting_A" ;
lin bitmap_N = mkTerm "bitmap_N" ;
lin bitok_N = mkTerm "bitok_N" ;
lin bitter_A = mkTerm "bitter_A" ;
lin bitter_N = mkTerm "bitter_N" ;
lin bitter_sweet_A = mkTerm "bitter_sweet_A" ;
lin bittercress_N = mkTerm "bittercress_N" ;
lin bitterish_A = mkTerm "bitterish_A" ;
lin bittern_N = mkTerm "bittern_N" ;
lin bitterness_N = mkTerm "bitterness_N" ;
lin bitternut_N = mkTerm "bitternut_N" ;
lin bitterroot_N = mkTerm "bitterroot_N" ;
lin bitters_N = mkTerm "bitters_N" ;
lin bittersweet_N = mkTerm "bittersweet_N" ;
lin bitthead_N = mkTerm "bitthead_N" ;
lin bitty_A = mkTerm "bitty_A" ;
lin bitumastic_N = mkTerm "bitumastic_N" ;
lin bitumen_N = mkTerm "bitumen_N" ;
lin bituminoid_A = mkTerm "bituminoid_A" ;
lin bituminous_A = mkTerm "bituminous_A" ;
lin bivalent_A = mkTerm "bivalent_A" ;
lin bivalve_A = mkTerm "bivalve_A" ;
lin bivalve_N = mkTerm "bivalve_N" ;
lin bivariate_A = mkTerm "bivariate_A" ;
lin bivouac_N = mkTerm "bivouac_N" ;
lin bivouac_V = mkTerm "bivouac_V" ;
lin biweekly_N = mkTerm "biweekly_N" ;
lin biz_N = mkTerm "biz_N" ;
lin bizarre_A = mkTerm "bizarre_A" ;
lin bizonal_A = mkTerm "bizonal_A" ;
lin blab_V = mkTerm "blab_V" ;
lin blab_V2 = mkTerm "blab_V2" ;
lin blabber_V = mkTerm "blabber_V" ;
lin blabber_V2 = mkTerm "blabber_V2" ;
lin blabbermouth_N = mkTerm "blabbermouth_N" ;
lin blabbermouthed_A = mkTerm "blabbermouthed_A" ;
lin black_A = mkTerm "black_A" ;
lin black_N = mkTerm "black_N" ;
lin black_V2 = mkTerm "black_V2" ;
lin black_beetle_N = mkTerm "black_beetle_N" ;
lin black_lead_N = mkTerm "black_lead_N" ;
lin black_lead_V2 = mkTerm "black_lead_V2" ;
lin black_out_V = mkTerm "black_out_V" ;
lin blackamoor_N = mkTerm "blackamoor_N" ;
lin blackball_V2 = mkTerm "blackball_V2" ;
lin blackberry_N = mkTerm "blackberry_N" ;
lin blackbird_N = mkTerm "blackbird_N" ;
lin blackboard_N = mkTerm "blackboard_N" ;
lin blackbuck_N = mkTerm "blackbuck_N" ;
lin blackburn_PN = mkTerm "blackburn_PN" ;
lin blackcap_N = mkTerm "blackcap_N" ;
lin blackcock_N = mkTerm "blackcock_N" ;
lin blackcurrant_N = mkTerm "blackcurrant_N" ;
lin blacken_V = mkTerm "blacken_V" ;
lin blacken_V2 = mkTerm "blacken_V2" ;
lin blackening_N = mkTerm "blackening_N" ;
lin blackface_N = mkTerm "blackface_N" ;
lin blackfish_N = mkTerm "blackfish_N" ;
lin blackfly_N = mkTerm "blackfly_N" ;
lin blackguard_N = mkTerm "blackguard_N" ;
lin blackguard_V2 = mkTerm "blackguard_V2" ;
lin blackguardly_A = mkTerm "blackguardly_A" ;
lin blackhall_PN = mkTerm "blackhall_PN" ;
lin blackhead_N = mkTerm "blackhead_N" ;
lin blackheart_N = mkTerm "blackheart_N" ;
lin blacking_N = mkTerm "blacking_N" ;
lin blackish_A = mkTerm "blackish_A" ;
lin blackjack_N = mkTerm "blackjack_N" ;
lin blackleg_N = mkTerm "blackleg_N" ;
lin blackleg_V = mkTerm "blackleg_V" ;
lin blackleg_V2 = mkTerm "blackleg_V2" ;
lin blacklist_N = mkTerm "blacklist_N" ;
lin blacklist_V2 = mkTerm "blacklist_V2" ;
lin blackmail_N = mkTerm "blackmail_N" ;
lin blackmail_V2 = mkTerm "blackmail_V2" ;
lin blackmailer_N = mkTerm "blackmailer_N" ;
lin blackness_N = mkTerm "blackness_N" ;
lin blackout_N = mkTerm "blackout_N" ;
lin blackpoll_N = mkTerm "blackpoll_N" ;
lin blackpool_PN = mkTerm "blackpool_PN" ;
lin blackshirt_N = mkTerm "blackshirt_N" ;
lin blacksmith_N = mkTerm "blacksmith_N" ;
lin blacksnake_N = mkTerm "blacksnake_N" ;
lin blackthorn_N = mkTerm "blackthorn_N" ;
lin blacktop_N = mkTerm "blacktop_N" ;
lin blackwash_N = mkTerm "blackwash_N" ;
lin blackwater_A = mkTerm "blackwater_A" ;
lin blackwater_N = mkTerm "blackwater_N" ;
lin blackwood_N = mkTerm "blackwood_N" ;
lin blackwood_PN = mkTerm "blackwood_PN" ;
lin bladder_N = mkTerm "bladder_N" ;
lin bladderpod_N = mkTerm "bladderpod_N" ;
lin bladderwort_N = mkTerm "bladderwort_N" ;
lin bladderwrack_N = mkTerm "bladderwrack_N" ;
lin bladdery_A = mkTerm "bladdery_A" ;
lin blade_N = mkTerm "blade_N" ;
lin bladed_A = mkTerm "bladed_A" ;
lin blae_A = mkTerm "blae_A" ;
lin blaeberry_N = mkTerm "blaeberry_N" ;
lin blaenau_ffestiniog_PN = mkTerm "blaenau_ffestiniog_PN" ;
lin blaenavon_PN = mkTerm "blaenavon_PN" ;
lin blaengwrach_PN = mkTerm "blaengwrach_PN" ;
lin blah_N = mkTerm "blah_N" ;
lin blahs_N = mkTerm "blahs_N" ;
lin blain_N = mkTerm "blain_N" ;
lin blaina_PN = mkTerm "blaina_PN" ;
lin blairgowrie_PN = mkTerm "blairgowrie_PN" ;
lin blame_N = mkTerm "blame_N" ;
lin blame_V = mkTerm "blame_V" ;
lin blame_V2 = mkTerm "blame_V2" ;
lin blameless_A = mkTerm "blameless_A" ;
lin blamelessness_N = mkTerm "blamelessness_N" ;
lin blameworthiness_N = mkTerm "blameworthiness_N" ;
lin blameworthy_A = mkTerm "blameworthy_A" ;
lin blanc_N = mkTerm "blanc_N" ;
lin blanch_V = mkTerm "blanch_V" ;
lin blanch_V2 = mkTerm "blanch_V2" ;
lin blancmange_N = mkTerm "blancmange_N" ;
lin bland_A = mkTerm "bland_A" ;
lin blandishment_N = mkTerm "blandishment_N" ;
lin blandness_N = mkTerm "blandness_N" ;
lin blank_A = mkTerm "blank_A" ;
lin blank_N = mkTerm "blank_N" ;
lin blank_out_V = mkTerm "blank_out_V" ;
lin blank_out_V2 = mkTerm "blank_out_V2" ;
lin blanket_N = mkTerm "blanket_N" ;
lin blanket_V2 = mkTerm "blanket_V2" ;
lin blankness_N = mkTerm "blankness_N" ;
lin blanquillo_N = mkTerm "blanquillo_N" ;
lin blantyre_PN = mkTerm "blantyre_PN" ;
lin blare_N = mkTerm "blare_N" ;
lin blare_V = mkTerm "blare_V" ;
lin blare_V2 = mkTerm "blare_V2" ;
lin blare_out_V = mkTerm "blare_out_V" ;
lin blarney_N = mkTerm "blarney_N" ;
lin blase_A = mkTerm "blase_A" ;
lin blaspheme_V = mkTerm "blaspheme_V" ;
lin blaspheme_V2 = mkTerm "blaspheme_V2" ;
lin blasphemer_N = mkTerm "blasphemer_N" ;
lin blasphemous_A = mkTerm "blasphemous_A" ;
lin blasphemy_N = mkTerm "blasphemy_N" ;
lin blast_N = mkTerm "blast_N" ;
lin blast_V = mkTerm "blast_V" ;
lin blast_V2 = mkTerm "blast_V2" ;
lin blast_away_V = mkTerm "blast_away_V" ;
lin blast_furnace_N = mkTerm "blast_furnace_N" ;
lin blast_off_N = mkTerm "blast_off_N" ;
lin blast_off_V = mkTerm "blast_off_V" ;
lin blastema_N = mkTerm "blastema_N" ;
lin blastemal_A = mkTerm "blastemal_A" ;
lin blaster_N = mkTerm "blaster_N" ;
lin blastocoel_N = mkTerm "blastocoel_N" ;
lin blastocoelic_A = mkTerm "blastocoelic_A" ;
lin blastocyst_N = mkTerm "blastocyst_N" ;
lin blastocyte_N = mkTerm "blastocyte_N" ;
lin blastoderm_N = mkTerm "blastoderm_N" ;
lin blastodermatic_A = mkTerm "blastodermatic_A" ;
lin blastogenesis_N = mkTerm "blastogenesis_N" ;
lin blastogenetic_A = mkTerm "blastogenetic_A" ;
lin blastoma_N = mkTerm "blastoma_N" ;
lin blastomere_N = mkTerm "blastomere_N" ;
lin blastomeric_A = mkTerm "blastomeric_A" ;
lin blastomycete_N = mkTerm "blastomycete_N" ;
lin blastomycosis_N = mkTerm "blastomycosis_N" ;
lin blastomycotic_A = mkTerm "blastomycotic_A" ;
lin blastoporal_A = mkTerm "blastoporal_A" ;
lin blastopore_N = mkTerm "blastopore_N" ;
lin blastospheric_A = mkTerm "blastospheric_A" ;
lin blastula_N = mkTerm "blastula_N" ;
lin blatancy_N = mkTerm "blatancy_N" ;
lin blatant_A = mkTerm "blatant_A" ;
lin blather_N = mkTerm "blather_N" ;
lin blather_V = mkTerm "blather_V" ;
lin blaxploitation_N = mkTerm "blaxploitation_N" ;
lin blaze_N = mkTerm "blaze_N" ;
lin blaze_V = mkTerm "blaze_V" ;
lin blaze_V2 = mkTerm "blaze_V2" ;
lin blaze_away_V = mkTerm "blaze_away_V" ;
lin blazer_N = mkTerm "blazer_N" ;
lin blazon_N = mkTerm "blazon_N" ;
lin blazon_V2 = mkTerm "blazon_V2" ;
lin blazonry_N = mkTerm "blazonry_N" ;
lin bldg_PN = mkTerm "bldg_PN" ;
lin bldgs_PN = mkTerm "bldgs_PN" ;
lin bleach_N = mkTerm "bleach_N" ;
lin bleach_V = mkTerm "bleach_V" ;
lin bleach_V2 = mkTerm "bleach_V2" ;
lin bleacher_N = mkTerm "bleacher_N" ;
lin bleachers_N = mkTerm "bleachers_N" ;
lin bleaching_powder_N = mkTerm "bleaching_powder_N" ;
lin bleak_A = mkTerm "bleak_A" ;
lin bleakness_N = mkTerm "bleakness_N" ;
lin bleary_A = mkTerm "bleary_A" ;
lin bleary_eyed_A = mkTerm "bleary_eyed_A" ;
lin bleat_N = mkTerm "bleat_N" ;
lin bleat_V = mkTerm "bleat_V" ;
lin bleat_V2 = mkTerm "bleat_V2" ;
lin blebbed_A = mkTerm "blebbed_A" ;
lin blebby_A = mkTerm "blebby_A" ;
lin bleed_V = mkTerm "bleed_V" ;
lin bleed_V2 = mkTerm "bleed_V2" ;
lin bleed_VS = mkTerm "bleed_VS" ;
lin bleed_off_V = mkTerm "bleed_off_V" ;
lin bleeding_N = mkTerm "bleeding_N" ;
lin bleep_N = mkTerm "bleep_N" ;
lin bleep_V = mkTerm "bleep_V" ;
lin blemish_N = mkTerm "blemish_N" ;
lin blemish_V2 = mkTerm "blemish_V2" ;
lin blench_V = mkTerm "blench_V" ;
lin blend_N = mkTerm "blend_N" ;
lin blend_V = mkTerm "blend_V" ;
lin blend_V2 = mkTerm "blend_V2" ;
lin blender_N = mkTerm "blender_N" ;
lin blenny_N = mkTerm "blenny_N" ;
lin blepharism_N = mkTerm "blepharism_N" ;
lin blepharitis_N = mkTerm "blepharitis_N" ;
lin blepharospasm_N = mkTerm "blepharospasm_N" ;
lin bless_V2 = mkTerm "bless_V2" ;
lin blessedly_Adv = mkTerm "blessedly_Adv" ;
lin blessedness_N = mkTerm "blessedness_N" ;
lin blessing_N = mkTerm "blessing_N" ;
lin bletchley_PN = mkTerm "bletchley_PN" ;
lin blether_N = mkTerm "blether_N" ;
lin bletia_N = mkTerm "bletia_N" ;
lin bleu_N = mkTerm "bleu_N" ;
lin blewits_N = mkTerm "blewits_N" ;
lin blidworth_PN = mkTerm "blidworth_PN" ;
lin blight_N = mkTerm "blight_N" ;
lin blight_V2 = mkTerm "blight_V2" ;
lin blighter_N = mkTerm "blighter_N" ;
lin blighty_N = mkTerm "blighty_N" ;
lin blimp_N = mkTerm "blimp_N" ;
lin blimpish_A = mkTerm "blimpish_A" ;
lin blind_A = mkTerm "blind_A" ;
lin blind_N = mkTerm "blind_N" ;
lin blind_V2 = mkTerm "blind_V2" ;
lin blindfold_A = mkTerm "blindfold_A" ;
lin blindfold_N = mkTerm "blindfold_N" ;
lin blindfold_V2 = mkTerm "blindfold_V2" ;
lin blindman's_buff_N = mkTerm "blindman's_buff_N" ;
lin blindness_N = mkTerm "blindness_N" ;
lin blindworm_N = mkTerm "blindworm_N" ;
lin bling_N = mkTerm "bling_N" ;
lin blini_N = mkTerm "blini_N" ;
lin blink_N = mkTerm "blink_N" ;
lin blink_V = mkTerm "blink_V" ;
lin blink_V2 = mkTerm "blink_V2" ;
lin blinker_N = mkTerm "blinker_N" ;
lin blinks_N = mkTerm "blinks_N" ;
lin blintz_N = mkTerm "blintz_N" ;
lin blip_N = mkTerm "blip_N" ;
lin bliss_N = mkTerm "bliss_N" ;
lin bliss_out_V = mkTerm "bliss_out_V" ;
lin blissful_A = mkTerm "blissful_A" ;
lin blister_N = mkTerm "blister_N" ;
lin blister_V = mkTerm "blister_V" ;
lin blister_V2 = mkTerm "blister_V2" ;
lin blithe_A = mkTerm "blithe_A" ;
lin blithering_A = mkTerm "blithering_A" ;
lin blithesome_A = mkTerm "blithesome_A" ;
lin blitz_N = mkTerm "blitz_N" ;
lin blitz_V2 = mkTerm "blitz_V2" ;
lin blizzard_N = mkTerm "blizzard_N" ;
lin bloat_N = mkTerm "bloat_N" ;
lin bloated_A = mkTerm "bloated_A" ;
lin bloater_N = mkTerm "bloater_N" ;
lin blob_N = mkTerm "blob_N" ;
lin bloc_N = mkTerm "bloc_N" ;
lin block_N = mkTerm "block_N" ;
lin block_V2 = mkTerm "block_V2" ;
lin block_in_V2 = mkTerm "block_in_V2" ;
lin block_off_V2 = mkTerm "block_off_V2" ;
lin block_out_V2 = mkTerm "block_out_V2" ;
lin block_up_V2 = mkTerm "block_up_V2" ;
lin blockade_N = mkTerm "blockade_N" ;
lin blockade_V2 = mkTerm "blockade_V2" ;
lin blockade_runner_N = mkTerm "blockade_runner_N" ;
lin blockading_A = mkTerm "blockading_A" ;
lin blockage_N = mkTerm "blockage_N" ;
lin blockbuster_N = mkTerm "blockbuster_N" ;
lin blocker_N = mkTerm "blocker_N" ;
lin blockhead_N = mkTerm "blockhead_N" ;
lin blockheaded_A = mkTerm "blockheaded_A" ;
lin blockhouse_N = mkTerm "blockhouse_N" ;
lin blocking_N = mkTerm "blocking_N" ;
lin blockish_A = mkTerm "blockish_A" ;
lin blog_N = mkTerm "blog_N" ;
lin blogger_N = mkTerm "blogger_N" ;
lin bloke_N = mkTerm "bloke_N" ;
lin blolly_N = mkTerm "blolly_N" ;
lin blond_A = mkTerm "blond_A" ;
lin blonde_A = mkTerm "blonde_A" ;
lin blonde_N = mkTerm "blonde_N" ;
lin blood_N = mkTerm "blood_N" ;
lin blood_V2 = mkTerm "blood_V2" ;
lin blood_bath_N = mkTerm "blood_bath_N" ;
lin blood_donor_N = mkTerm "blood_donor_N" ;
lin blood_group_N = mkTerm "blood_group_N" ;
lin blood_heat_N = mkTerm "blood_heat_N" ;
lin blood_letting_N = mkTerm "blood_letting_N" ;
lin blood_money_N = mkTerm "blood_money_N" ;
lin blood_poisoning_N = mkTerm "blood_poisoning_N" ;
lin blood_pressure_N = mkTerm "blood_pressure_N" ;
lin blood_relation_N = mkTerm "blood_relation_N" ;
lin blood_transfusion_N = mkTerm "blood_transfusion_N" ;
lin blood_type_N = mkTerm "blood_type_N" ;
lin blood_vessel_N = mkTerm "blood_vessel_N" ;
lin bloodberry_N = mkTerm "bloodberry_N" ;
lin bloodcurdling_A = mkTerm "bloodcurdling_A" ;
lin bloodguilt_N = mkTerm "bloodguilt_N" ;
lin bloodguilty_A = mkTerm "bloodguilty_A" ;
lin bloodhound_N = mkTerm "bloodhound_N" ;
lin bloodiness_N = mkTerm "bloodiness_N" ;
lin bloodleaf_N = mkTerm "bloodleaf_N" ;
lin bloodless_A = mkTerm "bloodless_A" ;
lin bloodlust_N = mkTerm "bloodlust_N" ;
lin bloodmobile_N = mkTerm "bloodmobile_N" ;
lin bloodroot_N = mkTerm "bloodroot_N" ;
lin bloodshed_N = mkTerm "bloodshed_N" ;
lin bloodshot_A = mkTerm "bloodshot_A" ;
lin bloodstain_N = mkTerm "bloodstain_N" ;
lin bloodstained_A = mkTerm "bloodstained_A" ;
lin bloodstock_N = mkTerm "bloodstock_N" ;
lin bloodstone_N = mkTerm "bloodstone_N" ;
lin bloodstream_N = mkTerm "bloodstream_N" ;
lin bloodsucker_N = mkTerm "bloodsucker_N" ;
lin bloodsucking_A = mkTerm "bloodsucking_A" ;
lin bloodthirstiness_N = mkTerm "bloodthirstiness_N" ;
lin bloodthirsty_A = mkTerm "bloodthirsty_A" ;
lin bloodworm_N = mkTerm "bloodworm_N" ;
lin bloodwort_N = mkTerm "bloodwort_N" ;
lin bloody_A = mkTerm "bloody_A" ;
lin bloody_Adv = mkTerm "bloody_Adv" ;
lin bloody_minded_A = mkTerm "bloody_minded_A" ;
lin bloom_N = mkTerm "bloom_N" ;
lin bloom_V = mkTerm "bloom_V" ;
lin bloomer_N = mkTerm "bloomer_N" ;
lin bloomers_N = mkTerm "bloomers_N" ;
lin blooming_N = mkTerm "blooming_N" ;
lin blossom_N = mkTerm "blossom_N" ;
lin blossom_V = mkTerm "blossom_V" ;
lin blossoming_N = mkTerm "blossoming_N" ;
lin blot_N = mkTerm "blot_N" ;
lin blot_V2 = mkTerm "blot_V2" ;
lin blot_out_V = mkTerm "blot_out_V" ;
lin blotch_N = mkTerm "blotch_N" ;
lin blotched_A = mkTerm "blotched_A" ;
lin blotchy_A = mkTerm "blotchy_A" ;
lin blotter_N = mkTerm "blotter_N" ;
lin blotting_paper_N = mkTerm "blotting_paper_N" ;
lin blotto_A = mkTerm "blotto_A" ;
lin blouse_N = mkTerm "blouse_N" ;
lin blow_N = mkTerm "blow_N" ;
lin blow_V = mkTerm "blow_V" ;
lin blow_V2 = mkTerm "blow_V2" ;
lin blow_away_V = mkTerm "blow_away_V" ;
lin blow_away_V2 = mkTerm "blow_away_V2" ;
lin blow_down_V2 = mkTerm "blow_down_V2" ;
lin blow_dry_V2 = mkTerm "blow_dry_V2" ;
lin blow_in_V = mkTerm "blow_in_V" ;
lin blow_off_V = mkTerm "blow_off_V" ;
lin blow_off_V2 = mkTerm "blow_off_V2" ;
lin blow_out_V2 = mkTerm "blow_out_V2" ;
lin blow_over_V = mkTerm "blow_over_V" ;
lin blow_up_N = mkTerm "blow_up_N" ;
lin blow_up_V = mkTerm "blow_up_V" ;
lin blow_up_V2 = mkTerm "blow_up_V2" ;
lin blowback_N = mkTerm "blowback_N" ;
lin blower_N = mkTerm "blower_N" ;
lin blowfish_N = mkTerm "blowfish_N" ;
lin blowfly_N = mkTerm "blowfly_N" ;
lin blowgun_N = mkTerm "blowgun_N" ;
lin blowhole_N = mkTerm "blowhole_N" ;
lin blowing_N = mkTerm "blowing_N" ;
lin blowing_up_N = mkTerm "blowing_up_N" ;
lin blowlamp_N = mkTerm "blowlamp_N" ;
lin blowout_N = mkTerm "blowout_N" ;
lin blowpipe_N = mkTerm "blowpipe_N" ;
lin blowsy_A = mkTerm "blowsy_A" ;
lin blowtorch_N = mkTerm "blowtorch_N" ;
lin blowtube_N = mkTerm "blowtube_N" ;
lin blowy_A = mkTerm "blowy_A" ;
lin blowzy_A = mkTerm "blowzy_A" ;
lin blubber_N = mkTerm "blubber_N" ;
lin blubber_V = mkTerm "blubber_V" ;
lin blubber_V2 = mkTerm "blubber_V2" ;
lin blubberer_N = mkTerm "blubberer_N" ;
lin blubbery_A = mkTerm "blubbery_A" ;
lin blucher_N = mkTerm "blucher_N" ;
lin bludgeon_N = mkTerm "bludgeon_N" ;
lin bludgeon_V2 = mkTerm "bludgeon_V2" ;
lin bludgeoner_N = mkTerm "bludgeoner_N" ;
lin blue_A = mkTerm "blue_A" ;
lin blue_N = mkTerm "blue_N" ;
lin blue_V2 = mkTerm "blue_V2" ;
lin blue_collar_A = mkTerm "blue_collar_A" ;
lin blue_jacket_N = mkTerm "blue_jacket_N" ;
lin blue_pencil_V2 = mkTerm "blue_pencil_V2" ;
lin bluebell_N = mkTerm "bluebell_N" ;
lin blueberry_N = mkTerm "blueberry_N" ;
lin bluebird_N = mkTerm "bluebird_N" ;
lin bluebonnet_N = mkTerm "bluebonnet_N" ;
lin bluebottle_N = mkTerm "bluebottle_N" ;
lin bluecoat_N = mkTerm "bluecoat_N" ;
lin bluefin_N = mkTerm "bluefin_N" ;
lin bluefish_N = mkTerm "bluefish_N" ;
lin bluegill_N = mkTerm "bluegill_N" ;
lin bluegrass_N = mkTerm "bluegrass_N" ;
lin bluehead_N = mkTerm "bluehead_N" ;
lin bluepoint_N = mkTerm "bluepoint_N" ;
lin blueprint_N = mkTerm "blueprint_N" ;
lin blues_N = mkTerm "blues_N" ;
lin bluestem_N = mkTerm "bluestem_N" ;
lin bluestocking_N = mkTerm "bluestocking_N" ;
lin bluestone_N = mkTerm "bluestone_N" ;
lin bluethroat_N = mkTerm "bluethroat_N" ;
lin bluetick_N = mkTerm "bluetick_N" ;
lin bluetongue_N = mkTerm "bluetongue_N" ;
lin blueweed_N = mkTerm "blueweed_N" ;
lin bluewing_N = mkTerm "bluewing_N" ;
lin bluff_A = mkTerm "bluff_A" ;
lin bluff_N = mkTerm "bluff_N" ;
lin bluff_V = mkTerm "bluff_V" ;
lin bluff_V2 = mkTerm "bluff_V2" ;
lin bluffer_N = mkTerm "bluffer_N" ;
lin bluffness_N = mkTerm "bluffness_N" ;
lin bluing_N = mkTerm "bluing_N" ;
lin bluish_A = mkTerm "bluish_A" ;
lin blunder_N = mkTerm "blunder_N" ;
lin blunder_V = mkTerm "blunder_V" ;
lin blunder_V2 = mkTerm "blunder_V2" ;
lin blunderbuss_N = mkTerm "blunderbuss_N" ;
lin blunderer_N = mkTerm "blunderer_N" ;
lin blunt_A = mkTerm "blunt_A" ;
lin blunt_V2 = mkTerm "blunt_V2" ;
lin bluntness_N = mkTerm "bluntness_N" ;
lin blur_N = mkTerm "blur_N" ;
lin blur_V = mkTerm "blur_V" ;
lin blur_V2 = mkTerm "blur_V2" ;
lin blurb_N = mkTerm "blurb_N" ;
lin blurt_V2 = mkTerm "blurt_V2" ;
lin blurt_out_V2 = mkTerm "blurt_out_V2" ;
lin blush_N = mkTerm "blush_N" ;
lin blush_V = mkTerm "blush_V" ;
lin blushful_A = mkTerm "blushful_A" ;
lin bluster_N = mkTerm "bluster_N" ;
lin bluster_V = mkTerm "bluster_V" ;
lin bluster_V2 = mkTerm "bluster_V2" ;
lin blustery_A = mkTerm "blustery_A" ;
lin blvd_N = mkTerm "blvd_N" ;
lin blyth_PN = mkTerm "blyth_PN" ;
lin bma_N = mkTerm "bma_N" ;
lin bmus_N = mkTerm "bmus_N" ;
lin bo'ness_PN = mkTerm "bo'ness_PN" ;
lin bo'sn_N = mkTerm "bo'sn_N" ;
lin bo'sun_N = mkTerm "bo'sun_N" ;
lin boa_N = mkTerm "boa_N" ;
lin boa_constrictor_N = mkTerm "boa_constrictor_N" ;
lin boar_N = mkTerm "boar_N" ;
lin board_1_N = mkTerm "board_1_N" ;
lin board_2_N = mkTerm "board_2_N" ;
lin board_V2 = mkTerm "board_V2" ;
lin board_out_V2 = mkTerm "board_out_V2" ;
lin board_up_V2 = mkTerm "board_up_V2" ;
lin boarder_N = mkTerm "boarder_N" ;
lin boarding_N = mkTerm "boarding_N" ;
lin boarding_card_N = mkTerm "boarding_card_N" ;
lin boarding_house_N = mkTerm "boarding_house_N" ;
lin boarding_school_N = mkTerm "boarding_school_N" ;
lin boardroom_N = mkTerm "boardroom_N" ;
lin boards_N = mkTerm "boards_N" ;
lin boardwalk_N = mkTerm "boardwalk_N" ;
lin boarfish_N = mkTerm "boarfish_N" ;
lin boarhound_N = mkTerm "boarhound_N" ;
lin boast_N = mkTerm "boast_N" ;
lin boast_V = mkTerm "boast_V" ;
lin boast_V2 = mkTerm "boast_V2" ;
lin boast_VS = mkTerm "boast_VS" ;
lin boaster_N = mkTerm "boaster_N" ;
lin boastful_A = mkTerm "boastful_A" ;
lin boastfulness_N = mkTerm "boastfulness_N" ;
lin boat_N = mkTerm "boat_N" ;
lin boat_V = mkTerm "boat_V" ;
lin boat_hook_N = mkTerm "boat_hook_N" ;
lin boat_house_N = mkTerm "boat_house_N" ;
lin boat_race_N = mkTerm "boat_race_N" ;
lin boat_train_N = mkTerm "boat_train_N" ;
lin boatbill_N = mkTerm "boatbill_N" ;
lin boatbuilder_N = mkTerm "boatbuilder_N" ;
lin boater_N = mkTerm "boater_N" ;
lin boating_N = mkTerm "boating_N" ;
lin boatload_N = mkTerm "boatload_N" ;
lin boatman_N = mkTerm "boatman_N" ;
lin boatmanship_N = mkTerm "boatmanship_N" ;
lin boatswain_N = mkTerm "boatswain_N" ;
lin boatyard_N = mkTerm "boatyard_N" ;
lin bob_N = mkTerm "bob_N" ;
lin bob_PN = mkTerm "bob_PN" ;
lin bob_V = mkTerm "bob_V" ;
lin bob_V2 = mkTerm "bob_V2" ;
lin bobbin_N = mkTerm "bobbin_N" ;
lin bobble_N = mkTerm "bobble_N" ;
lin bobby_N = mkTerm "bobby_N" ;
lin bobby_PN = mkTerm "bobby_PN" ;
lin bobby_soxer_N = mkTerm "bobby_soxer_N" ;
lin bobcat_N = mkTerm "bobcat_N" ;
lin bobolink_N = mkTerm "bobolink_N" ;
lin bobsled_N = mkTerm "bobsled_N" ;
lin bobsledding_N = mkTerm "bobsledding_N" ;
lin bobsleigh_N = mkTerm "bobsleigh_N" ;
lin bobtail_A = mkTerm "bobtail_A" ;
lin bobtail_N = mkTerm "bobtail_N" ;
lin bobwhite_N = mkTerm "bobwhite_N" ;
lin bocce_N = mkTerm "bocce_N" ;
lin bocconia_N = mkTerm "bocconia_N" ;
lin boche_A = mkTerm "boche_A" ;
lin bochum_PN = mkTerm "bochum_PN" ;
lin bock_N = mkTerm "bock_N" ;
lin bodacious_A = mkTerm "bodacious_A" ;
lin bode_V = mkTerm "bode_V" ;
lin bode_V2 = mkTerm "bode_V2" ;
lin bodega_N = mkTerm "bodega_N" ;
lin bodice_N = mkTerm "bodice_N" ;
lin bodied_A = mkTerm "bodied_A" ;
lin bodiless_A = mkTerm "bodiless_A" ;
lin bodily_A = mkTerm "bodily_A" ;
lin bodily_Adv = mkTerm "bodily_Adv" ;
lin boding_N = mkTerm "boding_N" ;
lin bodkin_N = mkTerm "bodkin_N" ;
lin bodmin_PN = mkTerm "bodmin_PN" ;
lin body_N = mkTerm "body_N" ;
lin body_servant_N = mkTerm "body_servant_N" ;
lin body_snatcher_N = mkTerm "body_snatcher_N" ;
lin bodybuilder_N = mkTerm "bodybuilder_N" ;
lin bodybuilding_N = mkTerm "bodybuilding_N" ;
lin bodyguard_N = mkTerm "bodyguard_N" ;
lin bodywork_N = mkTerm "bodywork_N" ;
lin boer_A = mkTerm "boer_A" ;
lin boer_N = mkTerm "boer_N" ;
lin boffin_N = mkTerm "boffin_N" ;
lin boffo_A = mkTerm "boffo_A" ;
lin bog_N = mkTerm "bog_N" ;
lin bog_V = mkTerm "bog_V" ;
lin bog_V2 = mkTerm "bog_V2" ;
lin bog_down_V = mkTerm "bog_down_V" ;
lin bog_in_V = mkTerm "bog_in_V" ;
lin bog_into_V2 = mkTerm "bog_into_V2" ;
lin bog_off_V = mkTerm "bog_off_V" ;
lin bogey_N = mkTerm "bogey_N" ;
lin bogeyman_N = mkTerm "bogeyman_N" ;
lin boggle_V = mkTerm "boggle_V" ;
lin boggy_A = mkTerm "boggy_A" ;
lin bogie_N = mkTerm "bogie_N" ;
lin bognor_PN = mkTerm "bognor_PN" ;
lin bognor_regis_PN = mkTerm "bognor_regis_PN" ;
lin bogota_PN = mkTerm "bogota_PN" ;
lin bogus_A = mkTerm "bogus_A" ;
lin bogy_N = mkTerm "bogy_N" ;
lin bohemia_N = mkTerm "bohemia_N" ;
lin bohemian_A = mkTerm "bohemian_A" ;
lin bohemian_N = mkTerm "bohemian_N" ;
lin bohemianism_N = mkTerm "bohemianism_N" ;
lin bohrium_N = mkTerm "bohrium_N" ;
lin boil_N = mkTerm "boil_N" ;
lin boil_V = mkTerm "boil_V" ;
lin boil_V2 = mkTerm "boil_V2" ;
lin boil_down_V2 = mkTerm "boil_down_V2" ;
lin boil_down_to_V2 = mkTerm "boil_down_to_V2" ;
lin boil_over_V = mkTerm "boil_over_V" ;
lin boil_up_V = mkTerm "boil_up_V" ;
lin boil_up_V2 = mkTerm "boil_up_V2" ;
lin boiler_N = mkTerm "boiler_N" ;
lin boilerplate_N = mkTerm "boilerplate_N" ;
lin boilersuit_N = mkTerm "boilersuit_N" ;
lin boiling_Adv = mkTerm "boiling_Adv" ;
lin boiling_N = mkTerm "boiling_N" ;
lin boiling_point_N = mkTerm "boiling_point_N" ;
lin boisterous_A = mkTerm "boisterous_A" ;
lin boisterousness_N = mkTerm "boisterousness_N" ;
lin bola_N = mkTerm "bola_N" ;
lin bold_1_A = mkTerm "bold_1_A" ;
lin bold_2_A = mkTerm "bold_2_A" ;
lin boldface_N = mkTerm "boldface_N" ;
lin boldness_N = mkTerm "boldness_N" ;
lin boldon_PN = mkTerm "boldon_PN" ;
lin bole_N = mkTerm "bole_N" ;
lin bolero_N = mkTerm "bolero_N" ;
lin bolete_N = mkTerm "bolete_N" ;
lin bolide_N = mkTerm "bolide_N" ;
lin bolivar_N = mkTerm "bolivar_N" ;
lin bolivia_N = mkTerm "bolivia_N" ;
lin bolivia_PN = mkTerm "bolivia_PN" ;
lin bolivian_A = mkTerm "bolivian_A" ;
lin bolivian_N = mkTerm "bolivian_N" ;
lin boliviano_N = mkTerm "boliviano_N" ;
lin boll_N = mkTerm "boll_N" ;
lin bollard_N = mkTerm "bollard_N" ;
lin bollington_PN = mkTerm "bollington_PN" ;
lin bollock_N = mkTerm "bollock_N" ;
lin bollworm_N = mkTerm "bollworm_N" ;
lin bolo_N = mkTerm "bolo_N" ;
lin bologna_N = mkTerm "bologna_N" ;
lin bologna_PN = mkTerm "bologna_PN" ;
lin bologram_N = mkTerm "bologram_N" ;
lin bolographic_A = mkTerm "bolographic_A" ;
lin bolometer_N = mkTerm "bolometer_N" ;
lin bolometric_A = mkTerm "bolometric_A" ;
lin boloney_N = mkTerm "boloney_N" ;
lin bolshevik_N = mkTerm "bolshevik_N" ;
lin bolshy_A = mkTerm "bolshy_A" ;
lin bolsover_PN = mkTerm "bolsover_PN" ;
lin bolster_N = mkTerm "bolster_N" ;
lin bolster_V = mkTerm "bolster_V" ;
lin bolster_V2 = mkTerm "bolster_V2" ;
lin bolster_up_V2 = mkTerm "bolster_up_V2" ;
lin bolt_Adv = mkTerm "bolt_Adv" ;
lin bolt_N = mkTerm "bolt_N" ;
lin bolt_V = mkTerm "bolt_V" ;
lin bolt_V2 = mkTerm "bolt_V2" ;
lin bolt_hole_N = mkTerm "bolt_hole_N" ;
lin bolti_N = mkTerm "bolti_N" ;
lin bolton_PN = mkTerm "bolton_PN" ;
lin bolton_le_sands_PN = mkTerm "bolton_le_sands_PN" ;
lin bolus_N = mkTerm "bolus_N" ;
lin bolzano_PN = mkTerm "bolzano_PN" ;
lin bomb_N = mkTerm "bomb_N" ;
lin bomb_V = mkTerm "bomb_V" ;
lin bomb_V2 = mkTerm "bomb_V2" ;
lin bomb_proof_A = mkTerm "bomb_proof_A" ;
lin bomb_sight_N = mkTerm "bomb_sight_N" ;
lin bomb_site_N = mkTerm "bomb_site_N" ;
lin bombard_V2 = mkTerm "bombard_V2" ;
lin bombardier_N = mkTerm "bombardier_N" ;
lin bombardment_N = mkTerm "bombardment_N" ;
lin bombardon_N = mkTerm "bombardon_N" ;
lin bombast_N = mkTerm "bombast_N" ;
lin bombastic_A = mkTerm "bombastic_A" ;
lin bombay_PN = mkTerm "bombay_PN" ;
lin bombazine_N = mkTerm "bombazine_N" ;
lin bomber_N = mkTerm "bomber_N" ;
lin bombie_N = mkTerm "bombie_N" ;
lin bombing_N = mkTerm "bombing_N" ;
lin bomblet_N = mkTerm "bomblet_N" ;
lin bombshell_N = mkTerm "bombshell_N" ;
lin bombycid_N = mkTerm "bombycid_N" ;
lin bon_mot_N = mkTerm "bon_mot_N" ;
lin bona_fide_A = mkTerm "bona_fide_A" ;
lin bona_fide_Adv = mkTerm "bona_fide_Adv" ;
lin bonanza_N = mkTerm "bonanza_N" ;
lin bonbon_N = mkTerm "bonbon_N" ;
lin bond_N = mkTerm "bond_N" ;
lin bond_V2 = mkTerm "bond_V2" ;
lin bond_holder_N = mkTerm "bond_holder_N" ;
lin bondable_A = mkTerm "bondable_A" ;
lin bondage_N = mkTerm "bondage_N" ;
lin bonding_N = mkTerm "bonding_N" ;
lin bondman_N = mkTerm "bondman_N" ;
lin bondsman_N = mkTerm "bondsman_N" ;
lin bonduc_N = mkTerm "bonduc_N" ;
lin bondwoman_N = mkTerm "bondwoman_N" ;
lin bone_A = mkTerm "bone_A" ;
lin bone_N = mkTerm "bone_N" ;
lin bone_V2 = mkTerm "bone_V2" ;
lin bone_dry_A = mkTerm "bone_dry_A" ;
lin bone_head_N = mkTerm "bone_head_N" ;
lin bone_idle_A = mkTerm "bone_idle_A" ;
lin bone_lazy_A = mkTerm "bone_lazy_A" ;
lin bone_setter_N = mkTerm "bone_setter_N" ;
lin bone_up_V = mkTerm "bone_up_V" ;
lin bone_up_on_V2 = mkTerm "bone_up_on_V2" ;
lin bonefish_N = mkTerm "bonefish_N" ;
lin boneless_A = mkTerm "boneless_A" ;
lin bonelike_A = mkTerm "bonelike_A" ;
lin bonemeal_N = mkTerm "bonemeal_N" ;
lin boner_N = mkTerm "boner_N" ;
lin bones_N = mkTerm "bones_N" ;
lin boneset_N = mkTerm "boneset_N" ;
lin boneshaker_N = mkTerm "boneshaker_N" ;
lin bonfire_N = mkTerm "bonfire_N" ;
lin bong_N = mkTerm "bong_N" ;
lin bongo_N = mkTerm "bongo_N" ;
lin bonheur_N = mkTerm "bonheur_N" ;
lin bonhomie_N = mkTerm "bonhomie_N" ;
lin bonito_N = mkTerm "bonito_N" ;
lin bonkers_A = mkTerm "bonkers_A" ;
lin bonn_PN = mkTerm "bonn_PN" ;
lin bonnet_N = mkTerm "bonnet_N" ;
lin bonny_A = mkTerm "bonny_A" ;
lin bonnybridge_PN = mkTerm "bonnybridge_PN" ;
lin bonnyrigg_PN = mkTerm "bonnyrigg_PN" ;
lin bonsai_N = mkTerm "bonsai_N" ;
lin bonus_N = mkTerm "bonus_N" ;
lin bony_A = mkTerm "bony_A" ;
lin bonyness_N = mkTerm "bonyness_N" ;
lin bonzer_A = mkTerm "bonzer_A" ;
lin boo_N = mkTerm "boo_N" ;
lin boo_V = mkTerm "boo_V" ;
lin boo_V2 = mkTerm "boo_V2" ;
lin boob_N = mkTerm "boob_N" ;
lin boob_V = mkTerm "boob_V" ;
lin booboisie_N = mkTerm "booboisie_N" ;
lin booby_N = mkTerm "booby_N" ;
lin booby_trap_N = mkTerm "booby_trap_N" ;
lin boodle_N = mkTerm "boodle_N" ;
lin booger_N = mkTerm "booger_N" ;
lin boogie_N = mkTerm "boogie_N" ;
lin boogie_woogie_N = mkTerm "boogie_woogie_N" ;
lin book_N = mkTerm "book_N" ;
lin book_V2 = mkTerm "book_V2" ;
lin book_end_N = mkTerm "book_end_N" ;
lin book_in_V2 = mkTerm "book_in_V2" ;
lin book_into_V2 = mkTerm "book_into_V2" ;
lin book_keeper_N = mkTerm "book_keeper_N" ;
lin book_out_V = mkTerm "book_out_V" ;
lin book_up_V = mkTerm "book_up_V" ;
lin bookable_A = mkTerm "bookable_A" ;
lin bookbinder_N = mkTerm "bookbinder_N" ;
lin bookbindery_N = mkTerm "bookbindery_N" ;
lin bookbinding_N = mkTerm "bookbinding_N" ;
lin bookcase_N = mkTerm "bookcase_N" ;
lin bookclub_N = mkTerm "bookclub_N" ;
lin bookdealer_N = mkTerm "bookdealer_N" ;
lin booker_N = mkTerm "booker_N" ;
lin bookie_N = mkTerm "bookie_N" ;
lin booking_N = mkTerm "booking_N" ;
lin bookish_A = mkTerm "bookish_A" ;
lin bookishness_N = mkTerm "bookishness_N" ;
lin bookkeeping_N = mkTerm "bookkeeping_N" ;
lin booklet_N = mkTerm "booklet_N" ;
lin booklouse_N = mkTerm "booklouse_N" ;
lin bookmaker_N = mkTerm "bookmaker_N" ;
lin bookmark_N = mkTerm "bookmark_N" ;
lin bookmarker_N = mkTerm "bookmarker_N" ;
lin bookmobile_N = mkTerm "bookmobile_N" ;
lin bookplate_N = mkTerm "bookplate_N" ;
lin bookseller_N = mkTerm "bookseller_N" ;
lin bookshelf_N = mkTerm "bookshelf_N" ;
lin bookshop_N = mkTerm "bookshop_N" ;
lin bookstall_N = mkTerm "bookstall_N" ;
lin bookstore_N = mkTerm "bookstore_N" ;
lin bookworm_N = mkTerm "bookworm_N" ;
lin boom_N = mkTerm "boom_N" ;
lin boom_V = mkTerm "boom_V" ;
lin boom_V2 = mkTerm "boom_V2" ;
lin boomerang_N = mkTerm "boomerang_N" ;
lin boon_A = mkTerm "boon_A" ;
lin boon_N = mkTerm "boon_N" ;
lin boondoggle_N = mkTerm "boondoggle_N" ;
lin boor_N = mkTerm "boor_N" ;
lin boorish_A = mkTerm "boorish_A" ;
lin boorishness_N = mkTerm "boorishness_N" ;
lin boost_N = mkTerm "boost_N" ;
lin boost_V2 = mkTerm "boost_V2" ;
lin booster_N = mkTerm "booster_N" ;
lin boot_N = mkTerm "boot_N" ;
lin boot_V2 = mkTerm "boot_V2" ;
lin boot_up_V2 = mkTerm "boot_up_V2" ;
lin bootblack_N = mkTerm "bootblack_N" ;
lin bootee_N = mkTerm "bootee_N" ;
lin booth_N = mkTerm "booth_N" ;
lin boothose_N = mkTerm "boothose_N" ;
lin bootjack_N = mkTerm "bootjack_N" ;
lin bootlace_N = mkTerm "bootlace_N" ;
lin bootle_PN = mkTerm "bootle_PN" ;
lin bootleg_A = mkTerm "bootleg_A" ;
lin bootleg_N = mkTerm "bootleg_N" ;
lin bootleg_V2 = mkTerm "bootleg_V2" ;
lin bootlegger_N = mkTerm "bootlegger_N" ;
lin bootlegging_N = mkTerm "bootlegging_N" ;
lin bootless_A = mkTerm "bootless_A" ;
lin bootlicking_A = mkTerm "bootlicking_A" ;
lin bootmaker_N = mkTerm "bootmaker_N" ;
lin bootstrap_N = mkTerm "bootstrap_N" ;
lin booty_N = mkTerm "booty_N" ;
lin booze_N = mkTerm "booze_N" ;
lin booze_V = mkTerm "booze_V" ;
lin booze_up_N = mkTerm "booze_up_N" ;
lin boozer_N = mkTerm "boozer_N" ;
lin boozy_A = mkTerm "boozy_A" ;
lin bop_N = mkTerm "bop_N" ;
lin bopeep_N = mkTerm "bopeep_N" ;
lin boracic_A = mkTerm "boracic_A" ;
lin borage_N = mkTerm "borage_N" ;
lin borate_N = mkTerm "borate_N" ;
lin borated_A = mkTerm "borated_A" ;
lin borax_N = mkTerm "borax_N" ;
lin bordeaux_N = mkTerm "bordeaux_N" ;
lin bordeaux_PN = mkTerm "bordeaux_PN" ;
lin bordelaise_N = mkTerm "bordelaise_N" ;
lin border_N = mkTerm "border_N" ;
lin border_V = mkTerm "border_V" ;
lin border_V2 = mkTerm "border_V2" ;
lin border_on_V2 = mkTerm "border_on_V2" ;
lin borderer_N = mkTerm "borderer_N" ;
lin borderland_N = mkTerm "borderland_N" ;
lin borderline_A = mkTerm "borderline_A" ;
lin borderline_N = mkTerm "borderline_N" ;
lin borders_PN = mkTerm "borders_PN" ;
lin bordon_PN = mkTerm "bordon_PN" ;
lin bore_N = mkTerm "bore_N" ;
lin bore_V = mkTerm "bore_V" ;
lin bore_V2 = mkTerm "bore_V2" ;
lin bore_hole_N = mkTerm "bore_hole_N" ;
lin boreal_A = mkTerm "boreal_A" ;
lin bored_A = mkTerm "bored_A" ;
lin boredom_N = mkTerm "boredom_N" ;
lin borer_N = mkTerm "borer_N" ;
lin boric_A = mkTerm "boric_A" ;
lin boring_A = mkTerm "boring_A" ;
lin boring_N = mkTerm "boring_N" ;
lin boringness_N = mkTerm "boringness_N" ;
lin boris_PN = mkTerm "boris_PN" ;
lin bornite_N = mkTerm "bornite_N" ;
lin boron_N = mkTerm "boron_N" ;
lin boronic_A = mkTerm "boronic_A" ;
lin borosilicate_N = mkTerm "borosilicate_N" ;
lin borough_N = mkTerm "borough_N" ;
lin borrelia_N = mkTerm "borrelia_N" ;
lin borrow_V = mkTerm "borrow_V" ;
lin borrow_V2 = mkTerm "borrow_V2" ;
lin borrow_VV = mkTerm "borrow_VV" ;
lin borrower_N = mkTerm "borrower_N" ;
lin borrowing_N = mkTerm "borrowing_N" ;
lin borsch_N = mkTerm "borsch_N" ;
lin borstal_N = mkTerm "borstal_N" ;
lin borzoi_N = mkTerm "borzoi_N" ;
lin bosc_N = mkTerm "bosc_N" ;
lin bosh_N = mkTerm "bosh_N" ;
lin bosk_N = mkTerm "bosk_N" ;
lin boskopoid_A = mkTerm "boskopoid_A" ;
lin bosky_A = mkTerm "bosky_A" ;
lin bosom_N = mkTerm "bosom_N" ;
lin bosomed_A = mkTerm "bosomed_A" ;
lin bosomy_A = mkTerm "bosomy_A" ;
lin boson_N = mkTerm "boson_N" ;
lin boss_A = mkTerm "boss_A" ;
lin boss_N = mkTerm "boss_N" ;
lin boss_V2 = mkTerm "boss_V2" ;
lin boss_about_V2 = mkTerm "boss_about_V2" ;
lin boss_around_V2 = mkTerm "boss_around_V2" ;
lin boss_eyed_A = mkTerm "boss_eyed_A" ;
lin bossism_N = mkTerm "bossism_N" ;
lin bossy_A = mkTerm "bossy_A" ;
lin boston_PN = mkTerm "boston_PN" ;
lin bot_N = mkTerm "bot_N" ;
lin bota_N = mkTerm "bota_N" ;
lin botanic_A = mkTerm "botanic_A" ;
lin botanical_A = mkTerm "botanical_A" ;
lin botanical_N = mkTerm "botanical_N" ;
lin botanist_N = mkTerm "botanist_N" ;
lin botanize_V = mkTerm "botanize_V" ;
lin botany_N = mkTerm "botany_N" ;
lin botch_N = mkTerm "botch_N" ;
lin botch_V2 = mkTerm "botch_V2" ;
lin botch_up_V2 = mkTerm "botch_up_V2" ;
lin botcher_N = mkTerm "botcher_N" ;
lin botchy_A = mkTerm "botchy_A" ;
lin botfly_N = mkTerm "botfly_N" ;
lin both_Adv = mkTerm "both_Adv" ;
lin both_Det = mkTerm "both_Det" ;
lin bother_N = mkTerm "bother_N" ;
lin bother_V = mkTerm "bother_V" ;
lin bother_V2 = mkTerm "bother_V2" ;
lin bother_V2V = mkTerm "bother_V2V" ;
lin bother_VV = mkTerm "bother_VV" ;
lin bothersome_A = mkTerm "bothersome_A" ;
lin botonee_A = mkTerm "botonee_A" ;
lin botryoid_A = mkTerm "botryoid_A" ;
lin botswana_PN = mkTerm "botswana_PN" ;
lin bottle_N = mkTerm "bottle_N" ;
lin bottle_V2 = mkTerm "bottle_V2" ;
lin bottle_away_V = mkTerm "bottle_away_V" ;
lin bottle_fed_A = mkTerm "bottle_fed_A" ;
lin bottle_green_A = mkTerm "bottle_green_A" ;
lin bottle_out_V = mkTerm "bottle_out_V" ;
lin bottle_up_V2 = mkTerm "bottle_up_V2" ;
lin bottlebrush_N = mkTerm "bottlebrush_N" ;
lin bottlecap_N = mkTerm "bottlecap_N" ;
lin bottleneck_N = mkTerm "bottleneck_N" ;
lin bottler_N = mkTerm "bottler_N" ;
lin bottom_A = mkTerm "bottom_A" ;
lin bottom_N = mkTerm "bottom_N" ;
lin bottom_V = mkTerm "bottom_V" ;
lin bottom_out_V = mkTerm "bottom_out_V" ;
lin bottomed_A = mkTerm "bottomed_A" ;
lin bottomland_N = mkTerm "bottomland_N" ;
lin bottomless_A = mkTerm "bottomless_A" ;
lin bottomlessness_N = mkTerm "bottomlessness_N" ;
lin bottommost_A = mkTerm "bottommost_A" ;
lin bottrop_PN = mkTerm "bottrop_PN" ;
lin botuliform_A = mkTerm "botuliform_A" ;
lin botulin_N = mkTerm "botulin_N" ;
lin botulinal_A = mkTerm "botulinal_A" ;
lin botulinus_N = mkTerm "botulinus_N" ;
lin botulism_N = mkTerm "botulism_N" ;
lin boucle_N = mkTerm "boucle_N" ;
lin boudoir_N = mkTerm "boudoir_N" ;
lin bouffant_A = mkTerm "bouffant_A" ;
lin bouffant_N = mkTerm "bouffant_N" ;
lin bougainvillea_N = mkTerm "bougainvillea_N" ;
lin bough_N = mkTerm "bough_N" ;
lin boughed_A = mkTerm "boughed_A" ;
lin boughless_A = mkTerm "boughless_A" ;
lin boughten_A = mkTerm "boughten_A" ;
lin bouillabaisse_N = mkTerm "bouillabaisse_N" ;
lin bouillon_N = mkTerm "bouillon_N" ;
lin boulder_N = mkTerm "boulder_N" ;
lin boulevard_N = mkTerm "boulevard_N" ;
lin boulevardier_N = mkTerm "boulevardier_N" ;
lin boulle_N = mkTerm "boulle_N" ;
lin bounce_N = mkTerm "bounce_N" ;
lin bounce_V = mkTerm "bounce_V" ;
lin bounce_V2 = mkTerm "bounce_V2" ;
lin bounce_back_V = mkTerm "bounce_back_V" ;
lin bounce_into_V2 = mkTerm "bounce_into_V2" ;
lin bounce_off_V2 = mkTerm "bounce_off_V2" ;
lin bouncer_N = mkTerm "bouncer_N" ;
lin bouncy_A = mkTerm "bouncy_A" ;
lin bound_N = mkTerm "bound_N" ;
lin bound_V = mkTerm "bound_V" ;
lin bound_V2 = mkTerm "bound_V2" ;
lin bound_V2V = mkTerm "bound_V2V" ;
lin boundary_N = mkTerm "boundary_N" ;
lin bounden_A = mkTerm "bounden_A" ;
lin bounder_N = mkTerm "bounder_N" ;
lin boundless_A = mkTerm "boundless_A" ;
lin bounteous_A = mkTerm "bounteous_A" ;
lin bountied_A = mkTerm "bountied_A" ;
lin bountiful_A = mkTerm "bountiful_A" ;
lin bounty_N = mkTerm "bounty_N" ;
lin bouquet_N = mkTerm "bouquet_N" ;
lin bourbon_N = mkTerm "bourbon_N" ;
lin bourgeois_A = mkTerm "bourgeois_A" ;
lin bourgeois_N = mkTerm "bourgeois_N" ;
lin bourgeoisie_N = mkTerm "bourgeoisie_N" ;
lin bourguignon_N = mkTerm "bourguignon_N" ;
lin bourn_N = mkTerm "bourn_N" ;
lin bourne_N = mkTerm "bourne_N" ;
lin bourne_PN = mkTerm "bourne_PN" ;
lin bournemouth_PN = mkTerm "bournemouth_PN" ;
lin bourse_N = mkTerm "bourse_N" ;
lin bourtree_N = mkTerm "bourtree_N" ;
lin boustrophedon_N = mkTerm "boustrophedon_N" ;
lin boustrophedonic_A = mkTerm "boustrophedonic_A" ;
lin bout_N = mkTerm "bout_N" ;
lin boutique_N = mkTerm "boutique_N" ;
lin boutonniere_N = mkTerm "boutonniere_N" ;
lin bovid_N = mkTerm "bovid_N" ;
lin bovine_A = mkTerm "bovine_A" ;
lin bovine_N = mkTerm "bovine_N" ;
lin bovril_N = mkTerm "bovril_N" ;
lin bow_N = mkTerm "bow_N" ;
lin bow_V = mkTerm "bow_V" ;
lin bow_V2 = mkTerm "bow_V2" ;
lin bow_wow_N = mkTerm "bow_wow_N" ;
lin bowburn_PN = mkTerm "bowburn_PN" ;
lin bowdlerization_N = mkTerm "bowdlerization_N" ;
lin bowdlerize_V2 = mkTerm "bowdlerize_V2" ;
lin bowel_N = mkTerm "bowel_N" ;
lin bower_N = mkTerm "bower_N" ;
lin bowerbird_N = mkTerm "bowerbird_N" ;
lin bowery_A = mkTerm "bowery_A" ;
lin bowfin_N = mkTerm "bowfin_N" ;
lin bowfront_A = mkTerm "bowfront_A" ;
lin bowhead_N = mkTerm "bowhead_N" ;
lin bowie_N = mkTerm "bowie_N" ;
lin bowie_knife_N = mkTerm "bowie_knife_N" ;
lin bowing_N = mkTerm "bowing_N" ;
lin bowl_N = mkTerm "bowl_N" ;
lin bowl_V = mkTerm "bowl_V" ;
lin bowl_V2 = mkTerm "bowl_V2" ;
lin bowl_out_V2 = mkTerm "bowl_out_V2" ;
lin bowl_over_V2 = mkTerm "bowl_over_V2" ;
lin bowleg_N = mkTerm "bowleg_N" ;
lin bowler_N = mkTerm "bowler_N" ;
lin bowline_N = mkTerm "bowline_N" ;
lin bowling_N = mkTerm "bowling_N" ;
lin bowling_green_N = mkTerm "bowling_green_N" ;
lin bowls_N = mkTerm "bowls_N" ;
lin bowman_N = mkTerm "bowman_N" ;
lin bowsprit_N = mkTerm "bowsprit_N" ;
lin bowstring_N = mkTerm "bowstring_N" ;
lin box_N = mkTerm "box_N" ;
lin box_V = mkTerm "box_V" ;
lin box_V2 = mkTerm "box_V2" ;
lin box_in_V2 = mkTerm "box_in_V2" ;
lin box_kite_N = mkTerm "box_kite_N" ;
lin box_number_N = mkTerm "box_number_N" ;
lin box_office_N = mkTerm "box_office_N" ;
lin box_up_V2 = mkTerm "box_up_V2" ;
lin boxcar_N = mkTerm "boxcar_N" ;
lin boxcars_N = mkTerm "boxcars_N" ;
lin boxer_N = mkTerm "boxer_N" ;
lin boxfish_N = mkTerm "boxfish_N" ;
lin boxful_N = mkTerm "boxful_N" ;
lin boxing_N = mkTerm "boxing_N" ;
lin boxing_day_N = mkTerm "boxing_day_N" ;
lin boxing_day_PN = mkTerm "boxing_day_PN" ;
lin boxing_glove_N = mkTerm "boxing_glove_N" ;
lin boxing_match_N = mkTerm "boxing_match_N" ;
lin boxlike_A = mkTerm "boxlike_A" ;
lin boxwood_N = mkTerm "boxwood_N" ;
lin boy_N = mkTerm "boy_N" ;
lin boycott_N = mkTerm "boycott_N" ;
lin boycott_V2 = mkTerm "boycott_V2" ;
lin boyfriend_N = mkTerm "boyfriend_N" ;
lin boyhood_N = mkTerm "boyhood_N" ;
lin boyish_A = mkTerm "boyish_A" ;
lin boyishness_N = mkTerm "boyishness_N" ;
lin boysenberry_N = mkTerm "boysenberry_N" ;
lin boza_N = mkTerm "boza_N" ;
lin bra_N = mkTerm "bra_N" ;
lin brace_N = mkTerm "brace_N" ;
lin brace_V = mkTerm "brace_V" ;
lin brace_V2 = mkTerm "brace_V2" ;
lin brace_up_V = mkTerm "brace_up_V" ;
lin bracelet_N = mkTerm "bracelet_N" ;
lin bracer_N = mkTerm "bracer_N" ;
lin bracero_N = mkTerm "bracero_N" ;
lin brachial_A = mkTerm "brachial_A" ;
lin brachiate_A = mkTerm "brachiate_A" ;
lin brachiation_N = mkTerm "brachiation_N" ;
lin brachiopod_A = mkTerm "brachiopod_A" ;
lin brachiopod_N = mkTerm "brachiopod_N" ;
lin brachium_N = mkTerm "brachium_N" ;
lin brachycephalic_A = mkTerm "brachycephalic_A" ;
lin brachycephalic_N = mkTerm "brachycephalic_N" ;
lin brachycephaly_N = mkTerm "brachycephaly_N" ;
lin brachydactylic_A = mkTerm "brachydactylic_A" ;
lin brachydactyly_N = mkTerm "brachydactyly_N" ;
lin brachypterous_A = mkTerm "brachypterous_A" ;
lin brachyuran_N = mkTerm "brachyuran_N" ;
lin brachyurous_A = mkTerm "brachyurous_A" ;
lin bracken_N = mkTerm "bracken_N" ;
lin bracket_N = mkTerm "bracket_N" ;
lin bracket_V2 = mkTerm "bracket_V2" ;
lin brackish_A = mkTerm "brackish_A" ;
lin brackishness_N = mkTerm "brackishness_N" ;
lin bracknell_PN = mkTerm "bracknell_PN" ;
lin bract_N = mkTerm "bract_N" ;
lin bracteal_A = mkTerm "bracteal_A" ;
lin bracteate_A = mkTerm "bracteate_A" ;
lin bracteolate_A = mkTerm "bracteolate_A" ;
lin bracteole_N = mkTerm "bracteole_N" ;
lin brad_N = mkTerm "brad_N" ;
lin bradawl_N = mkTerm "bradawl_N" ;
lin bradford_PN = mkTerm "bradford_PN" ;
lin bradford_on_avon_PN = mkTerm "bradford_on_avon_PN" ;
lin bradycardia_N = mkTerm "bradycardia_N" ;
lin brae_N = mkTerm "brae_N" ;
lin brag_N = mkTerm "brag_N" ;
lin brag_V = mkTerm "brag_V" ;
lin braggadocio_N = mkTerm "braggadocio_N" ;
lin braggart_N = mkTerm "braggart_N" ;
lin bragger_N = mkTerm "bragger_N" ;
lin bragging_N = mkTerm "bragging_N" ;
lin brahman_N = mkTerm "brahman_N" ;
lin brahmin_N = mkTerm "brahmin_N" ;
lin brahminic_A = mkTerm "brahminic_A" ;
lin braid_N = mkTerm "braid_N" ;
lin braid_V2 = mkTerm "braid_V2" ;
lin brail_N = mkTerm "brail_N" ;
lin braille_N = mkTerm "braille_N" ;
lin brain_N = mkTerm "brain_N" ;
lin brain_V2 = mkTerm "brain_V2" ;
lin brain_fag_N = mkTerm "brain_fag_N" ;
lin brain_teaser_N = mkTerm "brain_teaser_N" ;
lin brainchild_N = mkTerm "brainchild_N" ;
lin brainless_A = mkTerm "brainless_A" ;
lin brainsick_A = mkTerm "brainsick_A" ;
lin brainstem_N = mkTerm "brainstem_N" ;
lin brainstorm_N = mkTerm "brainstorm_N" ;
lin brainstorming_N = mkTerm "brainstorming_N" ;
lin braintree_PN = mkTerm "braintree_PN" ;
lin brainwash_V2 = mkTerm "brainwash_V2" ;
lin brainwashing_N = mkTerm "brainwashing_N" ;
lin brainwave_N = mkTerm "brainwave_N" ;
lin brainworker_N = mkTerm "brainworker_N" ;
lin brainy_A = mkTerm "brainy_A" ;
lin braise_V2 = mkTerm "braise_V2" ;
lin braising_N = mkTerm "braising_N" ;
lin brake_N = mkTerm "brake_N" ;
lin brake_V = mkTerm "brake_V" ;
lin brake_V2 = mkTerm "brake_V2" ;
lin brakeman_N = mkTerm "brakeman_N" ;
lin braky_A = mkTerm "braky_A" ;
lin bramble_N = mkTerm "bramble_N" ;
lin brambling_N = mkTerm "brambling_N" ;
lin bran_N = mkTerm "bran_N" ;
lin bran_new_A = mkTerm "bran_new_A" ;
lin branch_N = mkTerm "branch_N" ;
lin branch_V = mkTerm "branch_V" ;
lin branch_out_V = mkTerm "branch_out_V" ;
lin branched_A = mkTerm "branched_A" ;
lin branchial_A = mkTerm "branchial_A" ;
lin branchiate_A = mkTerm "branchiate_A" ;
lin branching_N = mkTerm "branching_N" ;
lin branchiopod_A = mkTerm "branchiopod_A" ;
lin branchless_A = mkTerm "branchless_A" ;
lin branchlet_N = mkTerm "branchlet_N" ;
lin branchy_A = mkTerm "branchy_A" ;
lin brand_N = mkTerm "brand_N" ;
lin brand_V2 = mkTerm "brand_V2" ;
lin brand_new_A = mkTerm "brand_new_A" ;
lin branderburgh_PN = mkTerm "branderburgh_PN" ;
lin branding_iron_N = mkTerm "branding_iron_N" ;
lin brandish_V2 = mkTerm "brandish_V2" ;
lin brandy_N = mkTerm "brandy_N" ;
lin brandy_ball_N = mkTerm "brandy_ball_N" ;
lin brandy_snap_N = mkTerm "brandy_snap_N" ;
lin brant_N = mkTerm "brant_N" ;
lin brash_A = mkTerm "brash_A" ;
lin brashness_N = mkTerm "brashness_N" ;
lin brasilia_PN = mkTerm "brasilia_PN" ;
lin brass_N = mkTerm "brass_N" ;
lin brassard_N = mkTerm "brassard_N" ;
lin brassavola_N = mkTerm "brassavola_N" ;
lin brassbound_A = mkTerm "brassbound_A" ;
lin brasserie_N = mkTerm "brasserie_N" ;
lin brassie_N = mkTerm "brassie_N" ;
lin brassiere_N = mkTerm "brassiere_N" ;
lin brassy_A = mkTerm "brassy_A" ;
lin brat_N = mkTerm "brat_N" ;
lin bratislava_PN = mkTerm "bratislava_PN" ;
lin brattice_N = mkTerm "brattice_N" ;
lin bratty_A = mkTerm "bratty_A" ;
lin bratwurst_N = mkTerm "bratwurst_N" ;
lin braunschweig_PN = mkTerm "braunschweig_PN" ;
lin braunton_PN = mkTerm "braunton_PN" ;
lin bravado_N = mkTerm "bravado_N" ;
lin brave_A = mkTerm "brave_A" ;
lin brave_N = mkTerm "brave_N" ;
lin brave_V2 = mkTerm "brave_V2" ;
lin bravery_N = mkTerm "bravery_N" ;
lin bravo_N = mkTerm "bravo_N" ;
lin bravura_N = mkTerm "bravura_N" ;
lin brawl_N = mkTerm "brawl_N" ;
lin brawl_V = mkTerm "brawl_V" ;
lin brawler_N = mkTerm "brawler_N" ;
lin brawn_N = mkTerm "brawn_N" ;
lin brawny_A = mkTerm "brawny_A" ;
lin bray_N = mkTerm "bray_N" ;
lin bray_V2 = mkTerm "bray_V2" ;
lin braze_V2 = mkTerm "braze_V2" ;
lin brazen_A = mkTerm "brazen_A" ;
lin brazen_V2 = mkTerm "brazen_V2" ;
lin brazen_faced_A = mkTerm "brazen_faced_A" ;
lin brazier_N = mkTerm "brazier_N" ;
lin brazil_PN = mkTerm "brazil_PN" ;
lin brazilian_A = mkTerm "brazilian_A" ;
lin brazilian_N = mkTerm "brazilian_N" ;
lin brazilwood_N = mkTerm "brazilwood_N" ;
lin breach_N = mkTerm "breach_N" ;
lin breach_V2 = mkTerm "breach_V2" ;
lin bread_N = mkTerm "bread_N" ;
lin breadbasket_N = mkTerm "breadbasket_N" ;
lin breadboard_N = mkTerm "breadboard_N" ;
lin breadcrumb_N = mkTerm "breadcrumb_N" ;
lin breadfruit_N = mkTerm "breadfruit_N" ;
lin breadline_N = mkTerm "breadline_N" ;
lin breadroot_N = mkTerm "breadroot_N" ;
lin breadstick_N = mkTerm "breadstick_N" ;
lin breadstuff_N = mkTerm "breadstuff_N" ;
lin breadth_N = mkTerm "breadth_N" ;
lin breadthways_Adv = mkTerm "breadthways_Adv" ;
lin breadthwise_Adv = mkTerm "breadthwise_Adv" ;
lin breadwinner_N = mkTerm "breadwinner_N" ;
lin break_N = mkTerm "break_N" ;
lin break_V = mkTerm "break_V" ;
lin break_V2 = mkTerm "break_V2" ;
lin break_apart_V = mkTerm "break_apart_V" ;
lin break_away_V = mkTerm "break_away_V" ;
lin break_down_V = mkTerm "break_down_V" ;
lin break_down_V2 = mkTerm "break_down_V2" ;
lin break_in_N = mkTerm "break_in_N" ;
lin break_in_V = mkTerm "break_in_V" ;
lin break_in_V2 = mkTerm "break_in_V2" ;
lin break_in_on_V2 = mkTerm "break_in_on_V2" ;
lin break_into_V2 = mkTerm "break_into_V2" ;
lin break_off_V2 = mkTerm "break_off_V2" ;
lin break_out_V = mkTerm "break_out_V" ;
lin break_out_V2 = mkTerm "break_out_V2" ;
lin break_out_in_V2 = mkTerm "break_out_in_V2" ;
lin break_out_of_V2 = mkTerm "break_out_of_V2" ;
lin break_through_V2 = mkTerm "break_through_V2" ;
lin break_up_N = mkTerm "break_up_N" ;
lin break_up_V = mkTerm "break_up_V" ;
lin break_up_V2 = mkTerm "break_up_V2" ;
lin breakable_A = mkTerm "breakable_A" ;
lin breakable_N = mkTerm "breakable_N" ;
lin breakableness_N = mkTerm "breakableness_N" ;
lin breakage_N = mkTerm "breakage_N" ;
lin breakaway_A = mkTerm "breakaway_A" ;
lin breakaway_N = mkTerm "breakaway_N" ;
lin breakaways_N = mkTerm "breakaways_N" ;
lin breakax_N = mkTerm "breakax_N" ;
lin breakdown_N = mkTerm "breakdown_N" ;
lin breaker_N = mkTerm "breaker_N" ;
lin breakfast_N = mkTerm "breakfast_N" ;
lin breakfast_V = mkTerm "breakfast_V" ;
lin breakneck_A = mkTerm "breakneck_A" ;
lin breakout_N = mkTerm "breakout_N" ;
lin breakthrough_N = mkTerm "breakthrough_N" ;
lin breakwater_N = mkTerm "breakwater_N" ;
lin bream_N = mkTerm "bream_N" ;
lin breast_N = mkTerm "breast_N" ;
lin breast_V2 = mkTerm "breast_V2" ;
lin breast_deep_Adv = mkTerm "breast_deep_Adv" ;
lin breast_fed_A = mkTerm "breast_fed_A" ;
lin breast_high_Adv = mkTerm "breast_high_Adv" ;
lin breast_plate_N = mkTerm "breast_plate_N" ;
lin breastfeed_V = mkTerm "breastfeed_V" ;
lin breastfeed_V2 = mkTerm "breastfeed_V2" ;
lin breastless_A = mkTerm "breastless_A" ;
lin breaston_PN = mkTerm "breaston_PN" ;
lin breaststroke_N = mkTerm "breaststroke_N" ;
lin breaststroker_N = mkTerm "breaststroker_N" ;
lin breastwork_N = mkTerm "breastwork_N" ;
lin breath_N = mkTerm "breath_N" ;
lin breathalyser_N = mkTerm "breathalyser_N" ;
lin breathalyzer_N = mkTerm "breathalyzer_N" ;
lin breathe_V = mkTerm "breathe_V" ;
lin breathe_V2 = mkTerm "breathe_V2" ;
lin breather_N = mkTerm "breather_N" ;
lin breathing_N = mkTerm "breathing_N" ;
lin breathing_space_N = mkTerm "breathing_space_N" ;
lin breathless_A = mkTerm "breathless_A" ;
lin breathtaking_A = mkTerm "breathtaking_A" ;
lin breccia_N = mkTerm "breccia_N" ;
lin brecknock_PN = mkTerm "brecknock_PN" ;
lin breda_PN = mkTerm "breda_PN" ;
lin breech_N = mkTerm "breech_N" ;
lin breech_block_N = mkTerm "breech_block_N" ;
lin breechcloth_N = mkTerm "breechcloth_N" ;
lin breeched_A = mkTerm "breeched_A" ;
lin breeches_N = mkTerm "breeches_N" ;
lin breeches_buoy_N = mkTerm "breeches_buoy_N" ;
lin breechloader_N = mkTerm "breechloader_N" ;
lin breed_N = mkTerm "breed_N" ;
lin breed_V = mkTerm "breed_V" ;
lin breed_V2 = mkTerm "breed_V2" ;
lin breeder_N = mkTerm "breeder_N" ;
lin breeding_N = mkTerm "breeding_N" ;
lin breedsall_PN = mkTerm "breedsall_PN" ;
lin breeze_N = mkTerm "breeze_N" ;
lin breeze_V = mkTerm "breeze_V" ;
lin breeze_along_V = mkTerm "breeze_along_V" ;
lin breeze_in_V = mkTerm "breeze_in_V" ;
lin breeze_into_V2 = mkTerm "breeze_into_V2" ;
lin breeze_through_V2 = mkTerm "breeze_through_V2" ;
lin breeziness_N = mkTerm "breeziness_N" ;
lin breezy_A = mkTerm "breezy_A" ;
lin bregma_N = mkTerm "bregma_N" ;
lin bregmatic_A = mkTerm "bregmatic_A" ;
lin bremen_PN = mkTerm "bremen_PN" ;
lin bremerhaven_PN = mkTerm "bremerhaven_PN" ;
lin bren_N = mkTerm "bren_N" ;
lin bren_gun_N = mkTerm "bren_gun_N" ;
lin brenda_PN = mkTerm "brenda_PN" ;
lin brent_PN = mkTerm "brent_PN" ;
lin brentwood_PN = mkTerm "brentwood_PN" ;
lin brescia_PN = mkTerm "brescia_PN" ;
lin brest_PN = mkTerm "brest_PN" ;
lin brethren_N = mkTerm "brethren_N" ;
lin breve_N = mkTerm "breve_N" ;
lin brevet_N = mkTerm "brevet_N" ;
lin breviary_N = mkTerm "breviary_N" ;
lin brevity_N = mkTerm "brevity_N" ;
lin brew_N = mkTerm "brew_N" ;
lin brew_V = mkTerm "brew_V" ;
lin brew_V2 = mkTerm "brew_V2" ;
lin brewer_N = mkTerm "brewer_N" ;
lin brewery_N = mkTerm "brewery_N" ;
lin brewing_N = mkTerm "brewing_N" ;
lin brewpub_N = mkTerm "brewpub_N" ;
lin brian_PN = mkTerm "brian_PN" ;
lin briar_N = mkTerm "briar_N" ;
lin briard_N = mkTerm "briard_N" ;
lin briarroot_N = mkTerm "briarroot_N" ;
lin briarwood_N = mkTerm "briarwood_N" ;
lin bribable_A = mkTerm "bribable_A" ;
lin bribe_N = mkTerm "bribe_N" ;
lin bribe_V = mkTerm "bribe_V" ;
lin bribe_V2 = mkTerm "bribe_V2" ;
lin briber_N = mkTerm "briber_N" ;
lin bribery_N = mkTerm "bribery_N" ;
lin bric_a_brac_N = mkTerm "bric_a_brac_N" ;
lin brick_N = mkTerm "brick_N" ;
lin brick_V2 = mkTerm "brick_V2" ;
lin brick_field_N = mkTerm "brick_field_N" ;
lin brick_in_V2 = mkTerm "brick_in_V2" ;
lin brick_up_V2 = mkTerm "brick_up_V2" ;
lin brickbat_N = mkTerm "brickbat_N" ;
lin bricket_wood_PN = mkTerm "bricket_wood_PN" ;
lin brickkiln_N = mkTerm "brickkiln_N" ;
lin bricklayer_N = mkTerm "bricklayer_N" ;
lin bricklaying_N = mkTerm "bricklaying_N" ;
lin brickwork_N = mkTerm "brickwork_N" ;
lin brickyard_N = mkTerm "brickyard_N" ;
lin bridal_A = mkTerm "bridal_A" ;
lin bridal_N = mkTerm "bridal_N" ;
lin bride_N = mkTerm "bride_N" ;
lin bridecake_N = mkTerm "bridecake_N" ;
lin bridegroom_N = mkTerm "bridegroom_N" ;
lin bridesmaid_N = mkTerm "bridesmaid_N" ;
lin bridge_N = mkTerm "bridge_N" ;
lin bridge_V2 = mkTerm "bridge_V2" ;
lin bridgeable_A = mkTerm "bridgeable_A" ;
lin bridgehead_N = mkTerm "bridgehead_N" ;
lin bridgend_PN = mkTerm "bridgend_PN" ;
lin bridget_PN = mkTerm "bridget_PN" ;
lin bridgnorth_PN = mkTerm "bridgnorth_PN" ;
lin bridgwater_PN = mkTerm "bridgwater_PN" ;
lin bridle_N = mkTerm "bridle_N" ;
lin bridle_V = mkTerm "bridle_V" ;
lin bridle_V2 = mkTerm "bridle_V2" ;
lin bridle_path_N = mkTerm "bridle_path_N" ;
lin bridle_road_N = mkTerm "bridle_road_N" ;
lin bridlington_PN = mkTerm "bridlington_PN" ;
lin bridoon_N = mkTerm "bridoon_N" ;
lin bridport_PN = mkTerm "bridport_PN" ;
lin brief_A = mkTerm "brief_A" ;
lin brief_N = mkTerm "brief_N" ;
lin brief_V2 = mkTerm "brief_V2" ;
lin briefcase_N = mkTerm "briefcase_N" ;
lin briefing_N = mkTerm "briefing_N" ;
lin briefless_A = mkTerm "briefless_A" ;
lin briefness_N = mkTerm "briefness_N" ;
lin brier_N = mkTerm "brier_N" ;
lin brig_N = mkTerm "brig_N" ;
lin brig_PN = mkTerm "brig_PN" ;
lin brigade_N = mkTerm "brigade_N" ;
lin brigadier_N = mkTerm "brigadier_N" ;
lin brigand_N = mkTerm "brigand_N" ;
lin brigandine_N = mkTerm "brigandine_N" ;
lin brigantine_N = mkTerm "brigantine_N" ;
lin brighouse_PN = mkTerm "brighouse_PN" ;
lin bright_A = mkTerm "bright_A" ;
lin bright_Adv = mkTerm "bright_Adv" ;
lin brighten_V = mkTerm "brighten_V" ;
lin brighten_V2 = mkTerm "brighten_V2" ;
lin brighten_up_V = mkTerm "brighten_up_V" ;
lin brighten_up_V2 = mkTerm "brighten_up_V2" ;
lin brightlingsea_PN = mkTerm "brightlingsea_PN" ;
lin brightness_N = mkTerm "brightness_N" ;
lin brighton_PN = mkTerm "brighton_PN" ;
lin brill_N = mkTerm "brill_N" ;
lin brilliance_N = mkTerm "brilliance_N" ;
lin brilliancy_N = mkTerm "brilliancy_N" ;
lin brilliant_A = mkTerm "brilliant_A" ;
lin brilliantine_N = mkTerm "brilliantine_N" ;
lin brim_N = mkTerm "brim_N" ;
lin brim_V = mkTerm "brim_V" ;
lin brimful_A = mkTerm "brimful_A" ;
lin brimfull_A = mkTerm "brimfull_A" ;
lin brimless_A = mkTerm "brimless_A" ;
lin brimstone_N = mkTerm "brimstone_N" ;
lin brindled_A = mkTerm "brindled_A" ;
lin brine_N = mkTerm "brine_N" ;
lin bring_V2 = mkTerm "bring_V2" ;
lin bring_V3 = mkTerm "bring_V3" ;
lin bring_about_V2 = mkTerm "bring_about_V2" ;
lin bring_along_V2 = mkTerm "bring_along_V2" ;
lin bring_around_V2 = mkTerm "bring_around_V2" ;
lin bring_away_V2 = mkTerm "bring_away_V2" ;
lin bring_back_V2 = mkTerm "bring_back_V2" ;
lin bring_down_V2 = mkTerm "bring_down_V2" ;
lin bring_forth_V = mkTerm "bring_forth_V" ;
lin bring_forth_V2 = mkTerm "bring_forth_V2" ;
lin bring_forward_V2 = mkTerm "bring_forward_V2" ;
lin bring_in_V2 = mkTerm "bring_in_V2" ;
lin bring_off_V2 = mkTerm "bring_off_V2" ;
lin bring_on_V2 = mkTerm "bring_on_V2" ;
lin bring_out_V2 = mkTerm "bring_out_V2" ;
lin bring_out_in_V3 = mkTerm "bring_out_in_V3" ;
lin bring_over_V2 = mkTerm "bring_over_V2" ;
lin bring_round_V2 = mkTerm "bring_round_V2" ;
lin bring_to_V2 = mkTerm "bring_to_V2" ;
lin bring_up_V2 = mkTerm "bring_up_V2" ;
lin brininess_N = mkTerm "brininess_N" ;
lin brink_N = mkTerm "brink_N" ;
lin brinkmanship_N = mkTerm "brinkmanship_N" ;
lin briny_A = mkTerm "briny_A" ;
lin brioche_N = mkTerm "brioche_N" ;
lin briquet_N = mkTerm "briquet_N" ;
lin briquette_N = mkTerm "briquette_N" ;
lin brisance_N = mkTerm "brisance_N" ;
lin brisant_A = mkTerm "brisant_A" ;
lin brisbane_PN = mkTerm "brisbane_PN" ;
lin brisk_A = mkTerm "brisk_A" ;
lin brisket_N = mkTerm "brisket_N" ;
lin brisling_N = mkTerm "brisling_N" ;
lin bristle_N = mkTerm "bristle_N" ;
lin bristle_V = mkTerm "bristle_V" ;
lin bristlegrass_N = mkTerm "bristlegrass_N" ;
lin bristlelike_A = mkTerm "bristlelike_A" ;
lin bristletail_N = mkTerm "bristletail_N" ;
lin bristly_A = mkTerm "bristly_A" ;
lin bristol_PN = mkTerm "bristol_PN" ;
lin brit_N = mkTerm "brit_N" ;
lin britain_PN = mkTerm "britain_PN" ;
lin britannic_A = mkTerm "britannic_A" ;
lin britches_N = mkTerm "britches_N" ;
lin british_A = mkTerm "british_A" ;
lin britisher_N = mkTerm "britisher_N" ;
lin briton_A = mkTerm "briton_A" ;
lin briton_N = mkTerm "briton_N" ;
lin brittle_A = mkTerm "brittle_A" ;
lin brittle_N = mkTerm "brittle_N" ;
lin brittlebush_N = mkTerm "brittlebush_N" ;
lin brittleness_N = mkTerm "brittleness_N" ;
lin brixham_PN = mkTerm "brixham_PN" ;
lin brno_PN = mkTerm "brno_PN" ;
lin broach_V = mkTerm "broach_V" ;
lin broach_V2 = mkTerm "broach_V2" ;
lin broad_A = mkTerm "broad_A" ;
lin broad_N = mkTerm "broad_N" ;
lin broad_minded_A = mkTerm "broad_minded_A" ;
lin broad_mindedness_N = mkTerm "broad_mindedness_N" ;
lin broadax_N = mkTerm "broadax_N" ;
lin broadband_A = mkTerm "broadband_A" ;
lin broadbill_N = mkTerm "broadbill_N" ;
lin broadcast_Adv = mkTerm "broadcast_Adv" ;
lin broadcast_N = mkTerm "broadcast_N" ;
lin broadcast_V = mkTerm "broadcast_V" ;
lin broadcast_V2 = mkTerm "broadcast_V2" ;
lin broadcaster_N = mkTerm "broadcaster_N" ;
lin broadcasting_N = mkTerm "broadcasting_N" ;
lin broadcloth_N = mkTerm "broadcloth_N" ;
lin broaden_V = mkTerm "broaden_V" ;
lin broaden_V2 = mkTerm "broaden_V2" ;
lin broadening_N = mkTerm "broadening_N" ;
lin broadleaf_A = mkTerm "broadleaf_A" ;
lin broadloom_A = mkTerm "broadloom_A" ;
lin broadloom_N = mkTerm "broadloom_N" ;
lin broadly_speaking_Adv = mkTerm "broadly_speaking_Adv" ;
lin broadness_N = mkTerm "broadness_N" ;
lin broadsheet_N = mkTerm "broadsheet_N" ;
lin broadside_A = mkTerm "broadside_A" ;
lin broadside_Adv = mkTerm "broadside_Adv" ;
lin broadside_N = mkTerm "broadside_N" ;
lin broadsword_N = mkTerm "broadsword_N" ;
lin broadtail_N = mkTerm "broadtail_N" ;
lin broadways_Adv = mkTerm "broadways_Adv" ;
lin broadwise_Adv = mkTerm "broadwise_Adv" ;
lin broby_PN = mkTerm "broby_PN" ;
lin brocade_N = mkTerm "brocade_N" ;
lin brocade_V2 = mkTerm "brocade_V2" ;
lin broccoli_N = mkTerm "broccoli_N" ;
lin brochette_N = mkTerm "brochette_N" ;
lin brochure_N = mkTerm "brochure_N" ;
lin brocket_N = mkTerm "brocket_N" ;
lin brodiaea_N = mkTerm "brodiaea_N" ;
lin brogan_N = mkTerm "brogan_N" ;
lin brogue_N = mkTerm "brogue_N" ;
lin broil_N = mkTerm "broil_N" ;
lin broil_V = mkTerm "broil_V" ;
lin broil_V2 = mkTerm "broil_V2" ;
lin broiler_N = mkTerm "broiler_N" ;
lin broke_A = mkTerm "broke_A" ;
lin broken_A = mkTerm "broken_A" ;
lin broken_hearted_A = mkTerm "broken_hearted_A" ;
lin broker_N = mkTerm "broker_N" ;
lin brokerage_N = mkTerm "brokerage_N" ;
lin brolly_N = mkTerm "brolly_N" ;
lin brome_N = mkTerm "brome_N" ;
lin bromic_A = mkTerm "bromic_A" ;
lin bromide_N = mkTerm "bromide_N" ;
lin bromidic_A = mkTerm "bromidic_A" ;
lin bromine_N = mkTerm "bromine_N" ;
lin bromley_PN = mkTerm "bromley_PN" ;
lin bromoform_N = mkTerm "bromoform_N" ;
lin bromsgrove_PN = mkTerm "bromsgrove_PN" ;
lin bronchial_A = mkTerm "bronchial_A" ;
lin bronchiolar_A = mkTerm "bronchiolar_A" ;
lin bronchiole_N = mkTerm "bronchiole_N" ;
lin bronchiolitis_N = mkTerm "bronchiolitis_N" ;
lin bronchitic_A = mkTerm "bronchitic_A" ;
lin bronchitis_N = mkTerm "bronchitis_N" ;
lin bronchodilator_N = mkTerm "bronchodilator_N" ;
lin bronchopneumonia_N = mkTerm "bronchopneumonia_N" ;
lin bronchoscope_N = mkTerm "bronchoscope_N" ;
lin bronchoscopic_A = mkTerm "bronchoscopic_A" ;
lin bronchospasm_N = mkTerm "bronchospasm_N" ;
lin bronchus_N = mkTerm "bronchus_N" ;
lin bronco_N = mkTerm "bronco_N" ;
lin bronze_A = mkTerm "bronze_A" ;
lin bronze_N = mkTerm "bronze_N" ;
lin bronze_V = mkTerm "bronze_V" ;
lin bronze_V2 = mkTerm "bronze_V2" ;
lin brooch_N = mkTerm "brooch_N" ;
lin brood_N = mkTerm "brood_N" ;
lin brood_V = mkTerm "brood_V" ;
lin brood_hen_N = mkTerm "brood_hen_N" ;
lin brood_mare_N = mkTerm "brood_mare_N" ;
lin brooding_N = mkTerm "brooding_N" ;
lin broody_A = mkTerm "broody_A" ;
lin brook_N = mkTerm "brook_N" ;
lin brook_V2 = mkTerm "brook_V2" ;
lin brooklet_N = mkTerm "brooklet_N" ;
lin brooklime_N = mkTerm "brooklime_N" ;
lin brookweed_N = mkTerm "brookweed_N" ;
lin broom_N = mkTerm "broom_N" ;
lin broomcorn_N = mkTerm "broomcorn_N" ;
lin broomstick_N = mkTerm "broomstick_N" ;
lin broomweed_N = mkTerm "broomweed_N" ;
lin bros_PN = mkTerm "bros_PN" ;
lin broth_N = mkTerm "broth_N" ;
lin brothel_N = mkTerm "brothel_N" ;
lin brother_N = mkTerm "brother_N" ;
lin brother_in_law_N = mkTerm "brother_in_law_N" ;
lin brotherhood_N = mkTerm "brotherhood_N" ;
lin brotherly_A = mkTerm "brotherly_A" ;
lin brotherly_Adv = mkTerm "brotherly_Adv" ;
lin brotula_N = mkTerm "brotula_N" ;
lin brougham_N = mkTerm "brougham_N" ;
lin brought_V = mkTerm "brought_V" ;
lin broughton_PN = mkTerm "broughton_PN" ;
lin brouhaha_N = mkTerm "brouhaha_N" ;
lin brow_N = mkTerm "brow_N" ;
lin browbeat_V2 = mkTerm "browbeat_V2" ;
lin brown_A = mkTerm "brown_A" ;
lin brown_N = mkTerm "brown_N" ;
lin brown_V = mkTerm "brown_V" ;
lin brown_V2 = mkTerm "brown_V2" ;
lin brownie_N = mkTerm "brownie_N" ;
lin brownish_A = mkTerm "brownish_A" ;
lin brownstone_N = mkTerm "brownstone_N" ;
lin browntail_N = mkTerm "browntail_N" ;
lin browse_N = mkTerm "browse_N" ;
lin browse_V = mkTerm "browse_V" ;
lin browser_N = mkTerm "browser_N" ;
lin broxburn_PN = mkTerm "broxburn_PN" ;
lin bruce_PN = mkTerm "bruce_PN" ;
lin brucellosis_N = mkTerm "brucellosis_N" ;
lin brucine_N = mkTerm "brucine_N" ;
lin bruges_PN = mkTerm "bruges_PN" ;
lin bruin_N = mkTerm "bruin_N" ;
lin bruise_N = mkTerm "bruise_N" ;
lin bruise_V = mkTerm "bruise_V" ;
lin bruise_V2 = mkTerm "bruise_V2" ;
lin bruiser_N = mkTerm "bruiser_N" ;
lin bruit_V2 = mkTerm "bruit_V2" ;
lin brumal_A = mkTerm "brumal_A" ;
lin brumous_A = mkTerm "brumous_A" ;
lin brunch_N = mkTerm "brunch_N" ;
lin brunei_PN = mkTerm "brunei_PN" ;
lin bruneian_A = mkTerm "bruneian_A" ;
lin bruneian_N = mkTerm "bruneian_N" ;
lin brunet_A = mkTerm "brunet_A" ;
lin brunet_N = mkTerm "brunet_N" ;
lin brunetteFem_N = mkTerm "brunetteFem_N" ;
lin brunetteMasc_N = mkTerm "brunetteMasc_N" ;
lin brunswick_PN = mkTerm "brunswick_PN" ;
lin brunt_N = mkTerm "brunt_N" ;
lin brush_N = mkTerm "brush_N" ;
lin brush_V = mkTerm "brush_V" ;
lin brush_V2 = mkTerm "brush_V2" ;
lin brush_aside_V = mkTerm "brush_aside_V" ;
lin brush_off_N = mkTerm "brush_off_N" ;
lin brush_off_V2 = mkTerm "brush_off_V2" ;
lin brush_up_N = mkTerm "brush_up_N" ;
lin brush_up_V2 = mkTerm "brush_up_V2" ;
lin brushlike_A = mkTerm "brushlike_A" ;
lin brushwood_N = mkTerm "brushwood_N" ;
lin brushwork_N = mkTerm "brushwork_N" ;
lin brusque_A = mkTerm "brusque_A" ;
lin brusqueness_N = mkTerm "brusqueness_N" ;
lin brussels_PN = mkTerm "brussels_PN" ;
lin brut_A = mkTerm "brut_A" ;
lin brutal_A = mkTerm "brutal_A" ;
lin brutality_N = mkTerm "brutality_N" ;
lin brutalization_N = mkTerm "brutalization_N" ;
lin brutalize_V2 = mkTerm "brutalize_V2" ;
lin brute_N = mkTerm "brute_N" ;
lin brutish_A = mkTerm "brutish_A" ;
lin bruxism_N = mkTerm "bruxism_N" ;
lin bryan_PN = mkTerm "bryan_PN" ;
lin bryanthus_N = mkTerm "bryanthus_N" ;
lin bryony_N = mkTerm "bryony_N" ;
lin bryophyte_N = mkTerm "bryophyte_N" ;
lin bryophytic_A = mkTerm "bryophytic_A" ;
lin bryozoan_N = mkTerm "bryozoan_N" ;
lin bsc_N = mkTerm "bsc_N" ;
lin bst_PN = mkTerm "bst_PN" ;
lin bt_PN = mkTerm "bt_PN" ;
lin bubaline_A = mkTerm "bubaline_A" ;
lin bubble_N = mkTerm "bubble_N" ;
lin bubble_V = mkTerm "bubble_V" ;
lin bubble_over_V = mkTerm "bubble_over_V" ;
lin bubbler_N = mkTerm "bubbler_N" ;
lin bubbliness_N = mkTerm "bubbliness_N" ;
lin bubbly_A = mkTerm "bubbly_A" ;
lin bubbly_N = mkTerm "bubbly_N" ;
lin bubo_N = mkTerm "bubo_N" ;
lin bubonic_A = mkTerm "bubonic_A" ;
lin bucarest_PN = mkTerm "bucarest_PN" ;
lin buccal_A = mkTerm "buccal_A" ;
lin buccaneer_N = mkTerm "buccaneer_N" ;
lin buck_N = mkTerm "buck_N" ;
lin buck_V = mkTerm "buck_V" ;
lin buck_V2 = mkTerm "buck_V2" ;
lin buck_up_V2 = mkTerm "buck_up_V2" ;
lin buckboard_N = mkTerm "buckboard_N" ;
lin bucket_N = mkTerm "bucket_N" ;
lin bucket_V = mkTerm "bucket_V" ;
lin bucket_down_V = mkTerm "bucket_down_V" ;
lin bucketful_N = mkTerm "bucketful_N" ;
lin buckeye_N = mkTerm "buckeye_N" ;
lin buckhaven_PN = mkTerm "buckhaven_PN" ;
lin buckie_PN = mkTerm "buckie_PN" ;
lin buckingham_PN = mkTerm "buckingham_PN" ;
lin buckinghamshire_PN = mkTerm "buckinghamshire_PN" ;
lin buckle_N = mkTerm "buckle_N" ;
lin buckle_V = mkTerm "buckle_V" ;
lin buckle_V2 = mkTerm "buckle_V2" ;
lin buckle_down_V = mkTerm "buckle_down_V" ;
lin buckle_under_V = mkTerm "buckle_under_V" ;
lin buckle_up_V = mkTerm "buckle_up_V" ;
lin buckler_N = mkTerm "buckler_N" ;
lin buckley_PN = mkTerm "buckley_PN" ;
lin buckleya_N = mkTerm "buckleya_N" ;
lin buckminsterfullerene_N = mkTerm "buckminsterfullerene_N" ;
lin buckram_N = mkTerm "buckram_N" ;
lin bucksaw_N = mkTerm "bucksaw_N" ;
lin bucksburn_PN = mkTerm "bucksburn_PN" ;
lin buckshee_A = mkTerm "buckshee_A" ;
lin buckshot_N = mkTerm "buckshot_N" ;
lin buckskin_N = mkTerm "buckskin_N" ;
lin buckskins_N = mkTerm "buckskins_N" ;
lin buckthorn_N = mkTerm "buckthorn_N" ;
lin bucktooth_N = mkTerm "bucktooth_N" ;
lin buckwheat_N = mkTerm "buckwheat_N" ;
lin bucolic_A = mkTerm "bucolic_A" ;
lin bucolics_N = mkTerm "bucolics_N" ;
lin bud_N = mkTerm "bud_N" ;
lin bud_V = mkTerm "bud_V" ;
lin budapest_PN = mkTerm "budapest_PN" ;
lin buddhism_N = mkTerm "buddhism_N" ;
lin buddhistFem_N = mkTerm "buddhistFem_N" ;
lin buddhistMasc_N = mkTerm "buddhistMasc_N" ;
lin budding_N = mkTerm "budding_N" ;
lin buddy_N = mkTerm "buddy_N" ;
lin budge_V = mkTerm "budge_V" ;
lin budge_V2 = mkTerm "budge_V2" ;
lin budge_up_V = mkTerm "budge_up_V" ;
lin budgerigar_N = mkTerm "budgerigar_N" ;
lin budget_N = mkTerm "budget_N" ;
lin budget_V = mkTerm "budget_V" ;
lin budget_V2 = mkTerm "budget_V2" ;
lin budgetary_A = mkTerm "budgetary_A" ;
lin budgie_N = mkTerm "budgie_N" ;
lin buenos_aires_PN = mkTerm "buenos_aires_PN" ;
lin buff_A = mkTerm "buff_A" ;
lin buff_N = mkTerm "buff_N" ;
lin buff_V2 = mkTerm "buff_V2" ;
lin buff_up_V2 = mkTerm "buff_up_V2" ;
lin buff_up_on_V2 = mkTerm "buff_up_on_V2" ;
lin buffalo_N = mkTerm "buffalo_N" ;
lin buffalo_PN = mkTerm "buffalo_PN" ;
lin buffalofish_N = mkTerm "buffalofish_N" ;
lin buffer_N = mkTerm "buffer_N" ;
lin buffer_V2 = mkTerm "buffer_V2" ;
lin buffet_N = mkTerm "buffet_N" ;
lin buffet_V = mkTerm "buffet_V" ;
lin buffet_V2 = mkTerm "buffet_V2" ;
lin bufflehead_N = mkTerm "bufflehead_N" ;
lin buffoon_N = mkTerm "buffoon_N" ;
lin buffoonery_N = mkTerm "buffoonery_N" ;
lin buffoonish_A = mkTerm "buffoonish_A" ;
lin bufo_N = mkTerm "bufo_N" ;
lin bug_N = mkTerm "bug_N" ;
lin bug_V2 = mkTerm "bug_V2" ;
lin bug_hunter_N = mkTerm "bug_hunter_N" ;
lin bug_off_V = mkTerm "bug_off_V" ;
lin bug_out_V = mkTerm "bug_out_V" ;
lin bugaboo_N = mkTerm "bugaboo_N" ;
lin bugbane_N = mkTerm "bugbane_N" ;
lin bugbear_N = mkTerm "bugbear_N" ;
lin bugger_N = mkTerm "bugger_N" ;
lin bugger_V = mkTerm "bugger_V" ;
lin bugger_V2 = mkTerm "bugger_V2" ;
lin bugger_all_N = mkTerm "bugger_all_N" ;
lin buggery_N = mkTerm "buggery_N" ;
lin bugginess_N = mkTerm "bugginess_N" ;
lin buggy_A = mkTerm "buggy_A" ;
lin buggy_N = mkTerm "buggy_N" ;
lin bugle_N = mkTerm "bugle_N" ;
lin bugler_N = mkTerm "bugler_N" ;
lin bugleweed_N = mkTerm "bugleweed_N" ;
lin bugloss_N = mkTerm "bugloss_N" ;
lin buhl_N = mkTerm "buhl_N" ;
lin build_N = mkTerm "build_N" ;
lin build_V = mkTerm "build_V" ;
lin build_V2 = mkTerm "build_V2" ;
lin build_up_N = mkTerm "build_up_N" ;
lin build_up_V2 = mkTerm "build_up_V2" ;
lin builder_N = mkTerm "builder_N" ;
lin building_N = mkTerm "building_N" ;
lin building_society_N = mkTerm "building_society_N" ;
lin built_in_A = mkTerm "built_in_A" ;
lin built_up_A = mkTerm "built_up_A" ;
lin bulb_N = mkTerm "bulb_N" ;
lin bulbaceous_A = mkTerm "bulbaceous_A" ;
lin bulbar_A = mkTerm "bulbar_A" ;
lin bulbed_A = mkTerm "bulbed_A" ;
lin bulbil_N = mkTerm "bulbil_N" ;
lin bulblike_A = mkTerm "bulblike_A" ;
lin bulbous_A = mkTerm "bulbous_A" ;
lin bulbul_N = mkTerm "bulbul_N" ;
lin bulgaria_PN = mkTerm "bulgaria_PN" ;
lin bulgarianFem_N = mkTerm "bulgarianFem_N" ;
lin bulgarianMasc_N = mkTerm "bulgarianMasc_N" ;
lin bulgarian_A = mkTerm "bulgarian_A" ;
lin bulge_N = mkTerm "bulge_N" ;
lin bulge_V = mkTerm "bulge_V" ;
lin bulge_V2 = mkTerm "bulge_V2" ;
lin bulgur_N = mkTerm "bulgur_N" ;
lin bulimarexia_N = mkTerm "bulimarexia_N" ;
lin bulimia_N = mkTerm "bulimia_N" ;
lin bulimic_A = mkTerm "bulimic_A" ;
lin bulimic_N = mkTerm "bulimic_N" ;
lin bulk_N = mkTerm "bulk_N" ;
lin bulk_V = mkTerm "bulk_V" ;
lin bulk_out_V2 = mkTerm "bulk_out_V2" ;
lin bulk_up_V = mkTerm "bulk_up_V" ;
lin bulkhead_N = mkTerm "bulkhead_N" ;
lin bulkiness_N = mkTerm "bulkiness_N" ;
lin bulkington_PN = mkTerm "bulkington_PN" ;
lin bulky_A = mkTerm "bulky_A" ;
lin bull's_eye_N = mkTerm "bull's_eye_N" ;
lin bull_N = mkTerm "bull_N" ;
lin bull_headed_A = mkTerm "bull_headed_A" ;
lin bull_neck_N = mkTerm "bull_neck_N" ;
lin bull_terrier_N = mkTerm "bull_terrier_N" ;
lin bulla_N = mkTerm "bulla_N" ;
lin bullace_N = mkTerm "bullace_N" ;
lin bullate_A = mkTerm "bullate_A" ;
lin bullbrier_N = mkTerm "bullbrier_N" ;
lin bulldog_N = mkTerm "bulldog_N" ;
lin bulldoze_V2 = mkTerm "bulldoze_V2" ;
lin bulldozer_N = mkTerm "bulldozer_N" ;
lin bullet_N = mkTerm "bullet_N" ;
lin bullet_headed_A = mkTerm "bullet_headed_A" ;
lin bullethead_N = mkTerm "bullethead_N" ;
lin bulletin_N = mkTerm "bulletin_N" ;
lin bulletproof_A = mkTerm "bulletproof_A" ;
lin bullfight_N = mkTerm "bullfight_N" ;
lin bullfighter_N = mkTerm "bullfighter_N" ;
lin bullfighting_N = mkTerm "bullfighting_N" ;
lin bullfinch_N = mkTerm "bullfinch_N" ;
lin bullfrog_N = mkTerm "bullfrog_N" ;
lin bullhead_N = mkTerm "bullhead_N" ;
lin bullhorn_N = mkTerm "bullhorn_N" ;
lin bullion_N = mkTerm "bullion_N" ;
lin bullish_A = mkTerm "bullish_A" ;
lin bullnecked_A = mkTerm "bullnecked_A" ;
lin bullnose_N = mkTerm "bullnose_N" ;
lin bullock_N = mkTerm "bullock_N" ;
lin bullocky_A = mkTerm "bullocky_A" ;
lin bullpen_N = mkTerm "bullpen_N" ;
lin bullring_N = mkTerm "bullring_N" ;
lin bullshit_N = mkTerm "bullshit_N" ;
lin bullshit_V = mkTerm "bullshit_V" ;
lin bullshot_N = mkTerm "bullshot_N" ;
lin bully_A = mkTerm "bully_A" ;
lin bully_N = mkTerm "bully_N" ;
lin bully_V = mkTerm "bully_V" ;
lin bully_V2 = mkTerm "bully_V2" ;
lin bullyboy_N = mkTerm "bullyboy_N" ;
lin bullying_N = mkTerm "bullying_N" ;
lin bulrush_N = mkTerm "bulrush_N" ;
lin bulwark_N = mkTerm "bulwark_N" ;
lin bum_A = mkTerm "bum_A" ;
lin bum_N = mkTerm "bum_N" ;
lin bum_V = mkTerm "bum_V" ;
lin bum_V2 = mkTerm "bum_V2" ;
lin bumblebee_N = mkTerm "bumblebee_N" ;
lin bumbling_A = mkTerm "bumbling_A" ;
lin bumboat_N = mkTerm "bumboat_N" ;
lin bumf_N = mkTerm "bumf_N" ;
lin bummer_N = mkTerm "bummer_N" ;
lin bump_Adv = mkTerm "bump_Adv" ;
lin bump_N = mkTerm "bump_N" ;
lin bump_V = mkTerm "bump_V" ;
lin bump_V2 = mkTerm "bump_V2" ;
lin bump_into_V2 = mkTerm "bump_into_V2" ;
lin bump_off_V2 = mkTerm "bump_off_V2" ;
lin bump_up_V2 = mkTerm "bump_up_V2" ;
lin bumper_N = mkTerm "bumper_N" ;
lin bumpiness_N = mkTerm "bumpiness_N" ;
lin bumpkin_N = mkTerm "bumpkin_N" ;
lin bumpkinly_A = mkTerm "bumpkinly_A" ;
lin bumptious_A = mkTerm "bumptious_A" ;
lin bumptiousness_N = mkTerm "bumptiousness_N" ;
lin bumpy_A = mkTerm "bumpy_A" ;
lin bun_N = mkTerm "bun_N" ;
lin buna_N = mkTerm "buna_N" ;
lin bunch_N = mkTerm "bunch_N" ;
lin bunch_V = mkTerm "bunch_V" ;
lin bunch_V2 = mkTerm "bunch_V2" ;
lin bunchberry_N = mkTerm "bunchberry_N" ;
lin bunchgrass_N = mkTerm "bunchgrass_N" ;
lin bunchy_A = mkTerm "bunchy_A" ;
lin bunco_N = mkTerm "bunco_N" ;
lin bundle_N = mkTerm "bundle_N" ;
lin bundle_V = mkTerm "bundle_V" ;
lin bundle_V2 = mkTerm "bundle_V2" ;
lin bundle_off_V2 = mkTerm "bundle_off_V2" ;
lin bundle_out_V2 = mkTerm "bundle_out_V2" ;
lin bundle_up_V = mkTerm "bundle_up_V" ;
lin bundle_up_V2 = mkTerm "bundle_up_V2" ;
lin bundling_N = mkTerm "bundling_N" ;
lin bunfight_N = mkTerm "bunfight_N" ;
lin bung_N = mkTerm "bung_N" ;
lin bung_V2 = mkTerm "bung_V2" ;
lin bung_hole_N = mkTerm "bung_hole_N" ;
lin bungaloid_A = mkTerm "bungaloid_A" ;
lin bungalow_N = mkTerm "bungalow_N" ;
lin bungee_N = mkTerm "bungee_N" ;
lin bungle_N = mkTerm "bungle_N" ;
lin bungle_V = mkTerm "bungle_V" ;
lin bungle_V2 = mkTerm "bungle_V2" ;
lin bungler_N = mkTerm "bungler_N" ;
lin bunion_N = mkTerm "bunion_N" ;
lin bunk_N = mkTerm "bunk_N" ;
lin bunk_V = mkTerm "bunk_V" ;
lin bunk_off_V = mkTerm "bunk_off_V" ;
lin bunker_N = mkTerm "bunker_N" ;
lin bunker_V = mkTerm "bunker_V" ;
lin bunker_V2 = mkTerm "bunker_V2" ;
lin bunkmate_N = mkTerm "bunkmate_N" ;
lin bunkum_N = mkTerm "bunkum_N" ;
lin bunny_N = mkTerm "bunny_N" ;
lin bunsen_N = mkTerm "bunsen_N" ;
lin bunt_N = mkTerm "bunt_N" ;
lin buntal_N = mkTerm "buntal_N" ;
lin bunter_N = mkTerm "bunter_N" ;
lin bunting_N = mkTerm "bunting_N" ;
lin bunyavirus_N = mkTerm "bunyavirus_N" ;
lin buoy_N = mkTerm "buoy_N" ;
lin buoy_V = mkTerm "buoy_V" ;
lin buoy_V2 = mkTerm "buoy_V2" ;
lin buoy_up_V2 = mkTerm "buoy_up_V2" ;
lin buoyancy_N = mkTerm "buoyancy_N" ;
lin buoyant_A = mkTerm "buoyant_A" ;
lin bur_N = mkTerm "bur_N" ;
lin burberry_N = mkTerm "burberry_N" ;
lin burble_V = mkTerm "burble_V" ;
lin burble_VS = mkTerm "burble_VS" ;
lin burbot_N = mkTerm "burbot_N" ;
lin burden_N = mkTerm "burden_N" ;
lin burden_V2 = mkTerm "burden_V2" ;
lin burdenless_A = mkTerm "burdenless_A" ;
lin burdensome_A = mkTerm "burdensome_A" ;
lin burdensomeness_N = mkTerm "burdensomeness_N" ;
lin burdock_N = mkTerm "burdock_N" ;
lin bureau_N = mkTerm "bureau_N" ;
lin bureaucracy_N = mkTerm "bureaucracy_N" ;
lin bureaucrat_N = mkTerm "bureaucrat_N" ;
lin bureaucratic_A = mkTerm "bureaucratic_A" ;
lin burette_N = mkTerm "burette_N" ;
lin burg_N = mkTerm "burg_N" ;
lin burgeon_V = mkTerm "burgeon_V" ;
lin burgess_N = mkTerm "burgess_N" ;
lin burgess_PN = mkTerm "burgess_PN" ;
lin burgh_N = mkTerm "burgh_N" ;
lin burgher_N = mkTerm "burgher_N" ;
lin burglar_N = mkTerm "burglar_N" ;
lin burglar_alarm_N = mkTerm "burglar_alarm_N" ;
lin burglar_proof_A = mkTerm "burglar_proof_A" ;
lin burglarious_A = mkTerm "burglarious_A" ;
lin burglary_N = mkTerm "burglary_N" ;
lin burgle_V = mkTerm "burgle_V" ;
lin burgle_V2 = mkTerm "burgle_V2" ;
lin burgomaster_N = mkTerm "burgomaster_N" ;
lin burgoo_N = mkTerm "burgoo_N" ;
lin burgos_PN = mkTerm "burgos_PN" ;
lin burgrass_N = mkTerm "burgrass_N" ;
lin burgrave_N = mkTerm "burgrave_N" ;
lin burgundy_N = mkTerm "burgundy_N" ;
lin burial_N = mkTerm "burial_N" ;
lin burial_ground_N = mkTerm "burial_ground_N" ;
lin burin_N = mkTerm "burin_N" ;
lin burke_V2 = mkTerm "burke_V2" ;
lin burl_N = mkTerm "burl_N" ;
lin burlap_N = mkTerm "burlap_N" ;
lin burled_A = mkTerm "burled_A" ;
lin burlesque_A = mkTerm "burlesque_A" ;
lin burlesque_N = mkTerm "burlesque_N" ;
lin burlesque_V2 = mkTerm "burlesque_V2" ;
lin burley_PN = mkTerm "burley_PN" ;
lin burly_A = mkTerm "burly_A" ;
lin burma_PN = mkTerm "burma_PN" ;
lin burmese_A = mkTerm "burmese_A" ;
lin burmese_N = mkTerm "burmese_N" ;
lin burn_N = mkTerm "burn_N" ;
lin burn_V = mkTerm "burn_V" ;
lin burn_V2 = mkTerm "burn_V2" ;
lin burn_down_V = mkTerm "burn_down_V" ;
lin burn_down_V2 = mkTerm "burn_down_V2" ;
lin burn_off_V2 = mkTerm "burn_off_V2" ;
lin burn_out_V = mkTerm "burn_out_V" ;
lin burn_up_N = mkTerm "burn_up_N" ;
lin burn_up_V = mkTerm "burn_up_V" ;
lin burn_up_V2 = mkTerm "burn_up_V2" ;
lin burnable_A = mkTerm "burnable_A" ;
lin burner_N = mkTerm "burner_N" ;
lin burnham_on_sea_PN = mkTerm "burnham_on_sea_PN" ;
lin burning_A = mkTerm "burning_A" ;
lin burning_N = mkTerm "burning_N" ;
lin burnish_V = mkTerm "burnish_V" ;
lin burnish_V2 = mkTerm "burnish_V2" ;
lin burnley_PN = mkTerm "burnley_PN" ;
lin burnous_N = mkTerm "burnous_N" ;
lin burnouse_N = mkTerm "burnouse_N" ;
lin burntisland_PN = mkTerm "burntisland_PN" ;
lin burntwood_PN = mkTerm "burntwood_PN" ;
lin burp_N = mkTerm "burp_N" ;
lin burp_V = mkTerm "burp_V" ;
lin burp_V2 = mkTerm "burp_V2" ;
lin burqa_N = mkTerm "burqa_N" ;
lin burr_N = mkTerm "burr_N" ;
lin burr_drill_N = mkTerm "burr_drill_N" ;
lin burrawong_N = mkTerm "burrawong_N" ;
lin burrfish_N = mkTerm "burrfish_N" ;
lin burrito_N = mkTerm "burrito_N" ;
lin burrlike_A = mkTerm "burrlike_A" ;
lin burro_N = mkTerm "burro_N" ;
lin burrow_N = mkTerm "burrow_N" ;
lin burrow_V = mkTerm "burrow_V" ;
lin burrow_V2 = mkTerm "burrow_V2" ;
lin burry_port_PN = mkTerm "burry_port_PN" ;
lin bursa_N = mkTerm "bursa_N" ;
lin bursal_A = mkTerm "bursal_A" ;
lin bursar_N = mkTerm "bursar_N" ;
lin bursary_N = mkTerm "bursary_N" ;
lin burscough_PN = mkTerm "burscough_PN" ;
lin bursiform_A = mkTerm "bursiform_A" ;
lin bursitis_N = mkTerm "bursitis_N" ;
lin burst_N = mkTerm "burst_N" ;
lin burst_V = mkTerm "burst_V" ;
lin burst_V2 = mkTerm "burst_V2" ;
lin burst_into_V2 = mkTerm "burst_into_V2" ;
lin burthen_N = mkTerm "burthen_N" ;
lin burthen_V2 = mkTerm "burthen_V2" ;
lin burton_N = mkTerm "burton_N" ;
lin burton_upon_trent_PN = mkTerm "burton_upon_trent_PN" ;
lin burundi_PN = mkTerm "burundi_PN" ;
lin burundian_A = mkTerm "burundian_A" ;
lin burundian_N = mkTerm "burundian_N" ;
lin bury_PN = mkTerm "bury_PN" ;
lin bury_V = mkTerm "bury_V" ;
lin bury_V2 = mkTerm "bury_V2" ;
lin bury_st__edmunds_PN = mkTerm "bury_st__edmunds_PN" ;
lin burying_N = mkTerm "burying_N" ;
lin burying_ground_N = mkTerm "burying_ground_N" ;
lin bus_N = mkTerm "bus_N" ;
lin bus_V = mkTerm "bus_V" ;
lin bus_V2 = mkTerm "bus_V2" ;
lin busbar_N = mkTerm "busbar_N" ;
lin busboy_N = mkTerm "busboy_N" ;
lin busby_N = mkTerm "busby_N" ;
lin bush_N = mkTerm "bush_N" ;
lin bushbuck_N = mkTerm "bushbuck_N" ;
lin bushel_N = mkTerm "bushel_N" ;
lin bushing_N = mkTerm "bushing_N" ;
lin bushman_N = mkTerm "bushman_N" ;
lin bushtit_N = mkTerm "bushtit_N" ;
lin bushwhacker_N = mkTerm "bushwhacker_N" ;
lin bushwhacking_A = mkTerm "bushwhacking_A" ;
lin bushy_A = mkTerm "bushy_A" ;
lin business_N = mkTerm "business_N" ;
lin businesslike_A = mkTerm "businesslike_A" ;
lin businessman_N = mkTerm "businessman_N" ;
lin businessperson_N = mkTerm "businessperson_N" ;
lin businesswoman_N = mkTerm "businesswoman_N" ;
lin busker_N = mkTerm "busker_N" ;
lin buskin_N = mkTerm "buskin_N" ;
lin busload_N = mkTerm "busload_N" ;
lin busman_N = mkTerm "busman_N" ;
lin buspirone_N = mkTerm "buspirone_N" ;
lin bust_N = mkTerm "bust_N" ;
lin bust_V = mkTerm "bust_V" ;
lin bust_V2 = mkTerm "bust_V2" ;
lin bust_up_N = mkTerm "bust_up_N" ;
lin bust_up_V = mkTerm "bust_up_V" ;
lin bustard_N = mkTerm "bustard_N" ;
lin buster_N = mkTerm "buster_N" ;
lin bustier_N = mkTerm "bustier_N" ;
lin bustle_N = mkTerm "bustle_N" ;
lin bustle_V = mkTerm "bustle_V" ;
lin bustle_V2 = mkTerm "bustle_V2" ;
lin busy_A = mkTerm "busy_A" ;
lin busy_V2 = mkTerm "busy_V2" ;
lin busybody_N = mkTerm "busybody_N" ;
lin busyness_N = mkTerm "busyness_N" ;
lin busywork_N = mkTerm "busywork_N" ;
lin but_Adv = mkTerm "but_Adv" ;
lin but_Conj = mkTerm "but_Conj" ;
lin but_N = mkTerm "but_N" ;
lin but_Prep = mkTerm "but_Prep" ;
lin butacaine_N = mkTerm "butacaine_N" ;
lin butadiene_N = mkTerm "butadiene_N" ;
lin butane_N = mkTerm "butane_N" ;
lin butanone_N = mkTerm "butanone_N" ;
lin butch_A = mkTerm "butch_A" ;
lin butch_N = mkTerm "butch_N" ;
lin butcher_N = mkTerm "butcher_N" ;
lin butcher_V2 = mkTerm "butcher_V2" ;
lin butcherbird_N = mkTerm "butcherbird_N" ;
lin butchery_N = mkTerm "butchery_N" ;
lin buteonine_A = mkTerm "buteonine_A" ;
lin buteonine_N = mkTerm "buteonine_N" ;
lin butler_N = mkTerm "butler_N" ;
lin butt_N = mkTerm "butt_N" ;
lin butt_V = mkTerm "butt_V" ;
lin butt_V2 = mkTerm "butt_V2" ;
lin butt_in_V = mkTerm "butt_in_V" ;
lin butt_out_V = mkTerm "butt_out_V" ;
lin butte_N = mkTerm "butte_N" ;
lin butter_N = mkTerm "butter_N" ;
lin butter_V2 = mkTerm "butter_V2" ;
lin butter_up_V2 = mkTerm "butter_up_V2" ;
lin butterbean_N = mkTerm "butterbean_N" ;
lin butterbur_N = mkTerm "butterbur_N" ;
lin buttercrunch_N = mkTerm "buttercrunch_N" ;
lin buttercup_N = mkTerm "buttercup_N" ;
lin butterfat_N = mkTerm "butterfat_N" ;
lin butterfingers_N = mkTerm "butterfingers_N" ;
lin butterfish_N = mkTerm "butterfish_N" ;
lin butterfly_N = mkTerm "butterfly_N" ;
lin buttermilk_N = mkTerm "buttermilk_N" ;
lin butternut_N = mkTerm "butternut_N" ;
lin butterscotch_N = mkTerm "butterscotch_N" ;
lin butterweed_N = mkTerm "butterweed_N" ;
lin butterwort_N = mkTerm "butterwort_N" ;
lin buttery_A = mkTerm "buttery_A" ;
lin buttery_N = mkTerm "buttery_N" ;
lin buttinsky_N = mkTerm "buttinsky_N" ;
lin buttock_N = mkTerm "buttock_N" ;
lin buttocks_N = mkTerm "buttocks_N" ;
lin button_N = mkTerm "button_N" ;
lin button_V = mkTerm "button_V" ;
lin button_V2 = mkTerm "button_V2" ;
lin buttoned_up_A = mkTerm "buttoned_up_A" ;
lin buttonhole_N = mkTerm "buttonhole_N" ;
lin buttonhole_V2 = mkTerm "buttonhole_V2" ;
lin buttonhook_N = mkTerm "buttonhook_N" ;
lin buttonwood_N = mkTerm "buttonwood_N" ;
lin buttony_A = mkTerm "buttony_A" ;
lin buttress_N = mkTerm "buttress_N" ;
lin buttress_V2 = mkTerm "buttress_V2" ;
lin butty_N = mkTerm "butty_N" ;
lin butut_N = mkTerm "butut_N" ;
lin butyl_N = mkTerm "butyl_N" ;
lin butylene_N = mkTerm "butylene_N" ;
lin butyraceous_A = mkTerm "butyraceous_A" ;
lin butyric_A = mkTerm "butyric_A" ;
lin butyrin_N = mkTerm "butyrin_N" ;
lin buxom_A = mkTerm "buxom_A" ;
lin buxomness_N = mkTerm "buxomness_N" ;
lin buxton_PN = mkTerm "buxton_PN" ;
lin buy_N = mkTerm "buy_N" ;
lin buy_V = mkTerm "buy_V" ;
lin buy_V2 = mkTerm "buy_V2" ;
lin buy_back_V2 = mkTerm "buy_back_V2" ;
lin buy_in_V2 = mkTerm "buy_in_V2" ;
lin buy_into_V2 = mkTerm "buy_into_V2" ;
lin buy_off_V2 = mkTerm "buy_off_V2" ;
lin buy_out_V2 = mkTerm "buy_out_V2" ;
lin buy_up_V2 = mkTerm "buy_up_V2" ;
lin buyerFem_N = mkTerm "buyerFem_N" ;
lin buyerMasc_N = mkTerm "buyerMasc_N" ;
lin buying_N = mkTerm "buying_N" ;
lin buyout_N = mkTerm "buyout_N" ;
lin buzz_N = mkTerm "buzz_N" ;
lin buzz_V = mkTerm "buzz_V" ;
lin buzz_V2 = mkTerm "buzz_V2" ;
lin buzz_around_V2 = mkTerm "buzz_around_V2" ;
lin buzz_off_V = mkTerm "buzz_off_V" ;
lin buzzard_N = mkTerm "buzzard_N" ;
lin buzzer_N = mkTerm "buzzer_N" ;
lin buzzword_N = mkTerm "buzzword_N" ;
lin bvm_N = mkTerm "bvm_N" ;
lin by_Adv = mkTerm "by_Adv" ;
lin by_Prep = mkTerm "by_Prep" ;
lin by_and_large_Adv = mkTerm "by_and_large_Adv" ;
lin by_election_N = mkTerm "by_election_N" ;
lin by_means_of_Prep = mkTerm "by_means_of_Prep" ;
lin by_virtue_of_Prep = mkTerm "by_virtue_of_Prep" ;
lin bye_Interj = mkTerm "bye_Interj" ;
lin bye_N = mkTerm "bye_N" ;
lin bye_bye_Interj = mkTerm "bye_bye_Interj" ;
lin bye_law_N = mkTerm "bye_law_N" ;
lin bygone_A = mkTerm "bygone_A" ;
lin bygone_N = mkTerm "bygone_N" ;
lin bylaw_N = mkTerm "bylaw_N" ;
lin bypass_N = mkTerm "bypass_N" ;
lin bypass_V2 = mkTerm "bypass_V2" ;
lin bypath_N = mkTerm "bypath_N" ;
lin byplay_N = mkTerm "byplay_N" ;
lin byproduct_N = mkTerm "byproduct_N" ;
lin byroad_N = mkTerm "byroad_N" ;
lin byssus_N = mkTerm "byssus_N" ;
lin bystander_N = mkTerm "bystander_N" ;
lin byte_N = mkTerm "byte_N" ;
lin byway_N = mkTerm "byway_N" ;
lin byword_N = mkTerm "byword_N" ;
lin byzantine_A = mkTerm "byzantine_A" ;
lin c_in_c_PN = mkTerm "c_in_c_PN" ;
lin c_of_e_N = mkTerm "c_of_e_N" ;
lin ca'canny_N = mkTerm "ca'canny_N" ;
lin cab_N = mkTerm "cab_N" ;
lin cab_rank_N = mkTerm "cab_rank_N" ;
lin cabal_N = mkTerm "cabal_N" ;
lin cabala_N = mkTerm "cabala_N" ;
lin cabalist_N = mkTerm "cabalist_N" ;
lin cabalistic_A = mkTerm "cabalistic_A" ;
lin cabana_N = mkTerm "cabana_N" ;
lin cabaret_N = mkTerm "cabaret_N" ;
lin cabbage_N = mkTerm "cabbage_N" ;
lin cabbageworm_N = mkTerm "cabbageworm_N" ;
lin cabby_N = mkTerm "cabby_N" ;
lin caber_N = mkTerm "caber_N" ;
lin cabin_N = mkTerm "cabin_N" ;
lin cabinet_N = mkTerm "cabinet_N" ;
lin cabinet_maker_N = mkTerm "cabinet_maker_N" ;
lin cabinetmaking_N = mkTerm "cabinetmaking_N" ;
lin cabinetwork_N = mkTerm "cabinetwork_N" ;
lin cable's_length_N = mkTerm "cable's_length_N" ;
lin cable_N = mkTerm "cable_N" ;
lin cable_V = mkTerm "cable_V" ;
lin cable_V2 = mkTerm "cable_V2" ;
lin cable_car_N = mkTerm "cable_car_N" ;
lin cable_length_N = mkTerm "cable_length_N" ;
lin cable_railway_N = mkTerm "cable_railway_N" ;
lin cablegram_N = mkTerm "cablegram_N" ;
lin cabman_N = mkTerm "cabman_N" ;
lin cabochon_N = mkTerm "cabochon_N" ;
lin caboodle_N = mkTerm "caboodle_N" ;
lin caboose_N = mkTerm "caboose_N" ;
lin cabotage_N = mkTerm "cabotage_N" ;
lin cabstand_N = mkTerm "cabstand_N" ;
lin cacao_N = mkTerm "cacao_N" ;
lin cacao_bean_N = mkTerm "cacao_bean_N" ;
lin cacao_tree_N = mkTerm "cacao_tree_N" ;
lin cache_N = mkTerm "cache_N" ;
lin cache_V2 = mkTerm "cache_V2" ;
lin cachectic_A = mkTerm "cachectic_A" ;
lin cachet_N = mkTerm "cachet_N" ;
lin cachexia_N = mkTerm "cachexia_N" ;
lin cachinnation_N = mkTerm "cachinnation_N" ;
lin cachou_N = mkTerm "cachou_N" ;
lin cacique_N = mkTerm "cacique_N" ;
lin cackle_N = mkTerm "cackle_N" ;
lin cackle_V = mkTerm "cackle_V" ;
lin cackler_N = mkTerm "cackler_N" ;
lin cackly_A = mkTerm "cackly_A" ;
lin cacodemon_N = mkTerm "cacodemon_N" ;
lin cacodemonic_A = mkTerm "cacodemonic_A" ;
lin cacodyl_N = mkTerm "cacodyl_N" ;
lin cacodylic_A = mkTerm "cacodylic_A" ;
lin cacogenesis_N = mkTerm "cacogenesis_N" ;
lin cacophonous_A = mkTerm "cacophonous_A" ;
lin cacophony_N = mkTerm "cacophony_N" ;
lin cactus_N = mkTerm "cactus_N" ;
lin cacuminal_A = mkTerm "cacuminal_A" ;
lin cad_N = mkTerm "cad_N" ;
lin cadaster_N = mkTerm "cadaster_N" ;
lin cadastral_A = mkTerm "cadastral_A" ;
lin cadaver_N = mkTerm "cadaver_N" ;
lin cadaverine_N = mkTerm "cadaverine_N" ;
lin cadaverous_A = mkTerm "cadaverous_A" ;
lin caddie_N = mkTerm "caddie_N" ;
lin caddish_A = mkTerm "caddish_A" ;
lin caddisworm_N = mkTerm "caddisworm_N" ;
lin caddy_N = mkTerm "caddy_N" ;
lin cadence_N = mkTerm "cadence_N" ;
lin cadenced_A = mkTerm "cadenced_A" ;
lin cadenza_N = mkTerm "cadenza_N" ;
lin cadet_N = mkTerm "cadet_N" ;
lin cadetship_N = mkTerm "cadetship_N" ;
lin cadge_V = mkTerm "cadge_V" ;
lin cadge_V2 = mkTerm "cadge_V2" ;
lin cadger_N = mkTerm "cadger_N" ;
lin cadiz_PN = mkTerm "cadiz_PN" ;
lin cadmium_N = mkTerm "cadmium_N" ;
lin cadre_N = mkTerm "cadre_N" ;
lin caducean_A = mkTerm "caducean_A" ;
lin caduceus_N = mkTerm "caduceus_N" ;
lin caducous_A = mkTerm "caducous_A" ;
lin caecilian_A = mkTerm "caecilian_A" ;
lin caecilian_N = mkTerm "caecilian_N" ;
lin caen_PN = mkTerm "caen_PN" ;
lin caerleon_PN = mkTerm "caerleon_PN" ;
lin caernarfon_PN = mkTerm "caernarfon_PN" ;
lin caerphilly_PN = mkTerm "caerphilly_PN" ;
lin caesar_N = mkTerm "caesar_N" ;
lin caesarian_A = mkTerm "caesarian_A" ;
lin caespitose_A = mkTerm "caespitose_A" ;
lin caesura_N = mkTerm "caesura_N" ;
lin caesural_A = mkTerm "caesural_A" ;
lin cafe_N = mkTerm "cafe_N" ;
lin cafe_au_lait_N = mkTerm "cafe_au_lait_N" ;
lin cafeteria_N = mkTerm "cafeteria_N" ;
lin caff_N = mkTerm "caff_N" ;
lin caffeine_N = mkTerm "caffeine_N" ;
lin caffeinic_A = mkTerm "caffeinic_A" ;
lin caffeinism_N = mkTerm "caffeinism_N" ;
lin caftan_N = mkTerm "caftan_N" ;
lin cage_N = mkTerm "cage_N" ;
lin cage_V2 = mkTerm "cage_V2" ;
lin cagey_A = mkTerm "cagey_A" ;
lin cagily_Adv = mkTerm "cagily_Adv" ;
lin cagliari_PN = mkTerm "cagliari_PN" ;
lin cagoule_N = mkTerm "cagoule_N" ;
lin cahoot_N = mkTerm "cahoot_N" ;
lin caiman_N = mkTerm "caiman_N" ;
lin cairn_N = mkTerm "cairn_N" ;
lin cairned_A = mkTerm "cairned_A" ;
lin cairngorm_N = mkTerm "cairngorm_N" ;
lin cairo_PN = mkTerm "cairo_PN" ;
lin caisson_N = mkTerm "caisson_N" ;
lin caitiff_A = mkTerm "caitiff_A" ;
lin caitiff_N = mkTerm "caitiff_N" ;
lin cajole_V2 = mkTerm "cajole_V2" ;
lin cajolery_N = mkTerm "cajolery_N" ;
lin cake_N = mkTerm "cake_N" ;
lin cake_V = mkTerm "cake_V" ;
lin cake_V2 = mkTerm "cake_V2" ;
lin cakewalk_N = mkTerm "cakewalk_N" ;
lin calaba_N = mkTerm "calaba_N" ;
lin calabash_N = mkTerm "calabash_N" ;
lin caladenia_N = mkTerm "caladenia_N" ;
lin caladium_N = mkTerm "caladium_N" ;
lin calamint_N = mkTerm "calamint_N" ;
lin calamitous_A = mkTerm "calamitous_A" ;
lin calamity_N = mkTerm "calamity_N" ;
lin calamus_N = mkTerm "calamus_N" ;
lin calando_A = mkTerm "calando_A" ;
lin calanthe_N = mkTerm "calanthe_N" ;
lin calash_N = mkTerm "calash_N" ;
lin calcaneal_A = mkTerm "calcaneal_A" ;
lin calcareous_A = mkTerm "calcareous_A" ;
lin calced_A = mkTerm "calced_A" ;
lin calceolaria_N = mkTerm "calceolaria_N" ;
lin calceolate_A = mkTerm "calceolate_A" ;
lin calceus_N = mkTerm "calceus_N" ;
lin calcic_A = mkTerm "calcic_A" ;
lin calcicolous_A = mkTerm "calcicolous_A" ;
lin calciferous_A = mkTerm "calciferous_A" ;
lin calcific_A = mkTerm "calcific_A" ;
lin calcification_N = mkTerm "calcification_N" ;
lin calcifugous_A = mkTerm "calcifugous_A" ;
lin calcify_V = mkTerm "calcify_V" ;
lin calcify_V2 = mkTerm "calcify_V2" ;
lin calcimine_N = mkTerm "calcimine_N" ;
lin calcination_N = mkTerm "calcination_N" ;
lin calcine_V = mkTerm "calcine_V" ;
lin calcine_V2 = mkTerm "calcine_V2" ;
lin calcite_N = mkTerm "calcite_N" ;
lin calcitic_A = mkTerm "calcitic_A" ;
lin calcitonin_N = mkTerm "calcitonin_N" ;
lin calcium_N = mkTerm "calcium_N" ;
lin calculable_A = mkTerm "calculable_A" ;
lin calculate_V = mkTerm "calculate_V" ;
lin calculate_V2 = mkTerm "calculate_V2" ;
lin calculate_VS = mkTerm "calculate_VS" ;
lin calculatingly_Adv = mkTerm "calculatingly_Adv" ;
lin calculation_N = mkTerm "calculation_N" ;
lin calculator_N = mkTerm "calculator_N" ;
lin calculous_A = mkTerm "calculous_A" ;
lin calculus_N = mkTerm "calculus_N" ;
lin calcutta_PN = mkTerm "calcutta_PN" ;
lin caldera_N = mkTerm "caldera_N" ;
lin caldicot_PN = mkTerm "caldicot_PN" ;
lin caldron_N = mkTerm "caldron_N" ;
lin calefacient_A = mkTerm "calefacient_A" ;
lin calefaction_N = mkTerm "calefaction_N" ;
lin calefactory_A = mkTerm "calefactory_A" ;
lin calendar_N = mkTerm "calendar_N" ;
lin calender_N = mkTerm "calender_N" ;
lin calender_V2 = mkTerm "calender_V2" ;
lin calendric_A = mkTerm "calendric_A" ;
lin calendula_N = mkTerm "calendula_N" ;
lin calf_N = mkTerm "calf_N" ;
lin calf_love_N = mkTerm "calf_love_N" ;
lin cali_PN = mkTerm "cali_PN" ;
lin caliber_N = mkTerm "caliber_N" ;
lin calibrate_V2 = mkTerm "calibrate_V2" ;
lin calibration_N = mkTerm "calibration_N" ;
lin calibre_N = mkTerm "calibre_N" ;
lin caliche_N = mkTerm "caliche_N" ;
lin calico_A = mkTerm "calico_A" ;
lin calico_N = mkTerm "calico_N" ;
lin calif_N = mkTerm "calif_N" ;
lin california_PN = mkTerm "california_PN" ;
lin californian_A = mkTerm "californian_A" ;
lin californian_N = mkTerm "californian_N" ;
lin californium_N = mkTerm "californium_N" ;
lin caliginous_A = mkTerm "caliginous_A" ;
lin caliper_N = mkTerm "caliper_N" ;
lin caliph_N = mkTerm "caliph_N" ;
lin caliphate_N = mkTerm "caliphate_N" ;
lin calisaya_N = mkTerm "calisaya_N" ;
lin calisthenic_A = mkTerm "calisthenic_A" ;
lin calisthenics_N = mkTerm "calisthenics_N" ;
lin calk_N = mkTerm "calk_N" ;
lin calk_V2 = mkTerm "calk_V2" ;
lin call_N = mkTerm "call_N" ;
lin call_V = mkTerm "call_V" ;
lin call_V2 = mkTerm "call_V2" ;
lin call_after_V2 = mkTerm "call_after_V2" ;
lin call_around_V = mkTerm "call_around_V" ;
lin call_back_V2 = mkTerm "call_back_V2" ;
lin call_box_N = mkTerm "call_box_N" ;
lin call_for_V2V = mkTerm "call_for_V2V" ;
lin call_forth_V2 = mkTerm "call_forth_V2" ;
lin call_girl_N = mkTerm "call_girl_N" ;
lin call_in_V = mkTerm "call_in_V" ;
lin call_in_V2 = mkTerm "call_in_V2" ;
lin call_off_V2 = mkTerm "call_off_V2" ;
lin call_on_V = mkTerm "call_on_V" ;
lin call_on_V2 = mkTerm "call_on_V2" ;
lin call_out_V2 = mkTerm "call_out_V2" ;
lin call_over_N = mkTerm "call_over_N" ;
lin call_over_V = mkTerm "call_over_V" ;
lin call_round_V = mkTerm "call_round_V" ;
lin call_up_N = mkTerm "call_up_N" ;
lin call_up_V2 = mkTerm "call_up_V2" ;
lin callable_A = mkTerm "callable_A" ;
lin called_A = mkTerm "called_A" ;
lin caller_A = mkTerm "caller_A" ;
lin caller_N = mkTerm "caller_N" ;
lin calliandra_N = mkTerm "calliandra_N" ;
lin calligrapher_N = mkTerm "calligrapher_N" ;
lin calligraphic_A = mkTerm "calligraphic_A" ;
lin calligraphy_N = mkTerm "calligraphy_N" ;
lin calling_N = mkTerm "calling_N" ;
lin calliope_N = mkTerm "calliope_N" ;
lin calliopsis_N = mkTerm "calliopsis_N" ;
lin callipygian_A = mkTerm "callipygian_A" ;
lin callisthenics_N = mkTerm "callisthenics_N" ;
lin callithump_N = mkTerm "callithump_N" ;
lin callithumpian_A = mkTerm "callithumpian_A" ;
lin callosity_N = mkTerm "callosity_N" ;
lin callosotomy_N = mkTerm "callosotomy_N" ;
lin callous_A = mkTerm "callous_A" ;
lin calloused_A = mkTerm "calloused_A" ;
lin callousness_N = mkTerm "callousness_N" ;
lin callow_A = mkTerm "callow_A" ;
lin callowness_N = mkTerm "callowness_N" ;
lin callsign_N = mkTerm "callsign_N" ;
lin callus_N = mkTerm "callus_N" ;
lin calm_A = mkTerm "calm_A" ;
lin calm_N = mkTerm "calm_N" ;
lin calm_V = mkTerm "calm_V" ;
lin calm_V2 = mkTerm "calm_V2" ;
lin calm_down_V2 = mkTerm "calm_down_V2" ;
lin calme_down_V = mkTerm "calme_down_V" ;
lin calmness_N = mkTerm "calmness_N" ;
lin calne_PN = mkTerm "calne_PN" ;
lin calomel_N = mkTerm "calomel_N" ;
lin calor_PN = mkTerm "calor_PN" ;
lin caloric_A = mkTerm "caloric_A" ;
lin calorie_N = mkTerm "calorie_N" ;
lin calorifacient_A = mkTerm "calorifacient_A" ;
lin calorific_A = mkTerm "calorific_A" ;
lin calorimeter_N = mkTerm "calorimeter_N" ;
lin calorimetric_A = mkTerm "calorimetric_A" ;
lin calorimetry_N = mkTerm "calorimetry_N" ;
lin calosoma_N = mkTerm "calosoma_N" ;
lin calpac_N = mkTerm "calpac_N" ;
lin calque_N = mkTerm "calque_N" ;
lin caltrop_N = mkTerm "caltrop_N" ;
lin calumet_N = mkTerm "calumet_N" ;
lin calumniate_V2 = mkTerm "calumniate_V2" ;
lin calumniatory_A = mkTerm "calumniatory_A" ;
lin calumny_N = mkTerm "calumny_N" ;
lin calvaria_N = mkTerm "calvaria_N" ;
lin calvary_N = mkTerm "calvary_N" ;
lin calve_V = mkTerm "calve_V" ;
lin calverton_PN = mkTerm "calverton_PN" ;
lin calving_N = mkTerm "calving_N" ;
lin calvinism_N = mkTerm "calvinism_N" ;
lin calvinist_N = mkTerm "calvinist_N" ;
lin calyceal_A = mkTerm "calyceal_A" ;
lin calycular_A = mkTerm "calycular_A" ;
lin calyculate_A = mkTerm "calyculate_A" ;
lin calyculus_N = mkTerm "calyculus_N" ;
lin calypso_N = mkTerm "calypso_N" ;
lin calyptra_N = mkTerm "calyptra_N" ;
lin calyptrate_A = mkTerm "calyptrate_A" ;
lin calyx_N = mkTerm "calyx_N" ;
lin cam_N = mkTerm "cam_N" ;
lin camail_N = mkTerm "camail_N" ;
lin camaraderie_N = mkTerm "camaraderie_N" ;
lin camas_N = mkTerm "camas_N" ;
lin camber_N = mkTerm "camber_N" ;
lin camber_V = mkTerm "camber_V" ;
lin camber_V2 = mkTerm "camber_V2" ;
lin cambial_A = mkTerm "cambial_A" ;
lin cambium_N = mkTerm "cambium_N" ;
lin cambodia_PN = mkTerm "cambodia_PN" ;
lin cambodian_A = mkTerm "cambodian_A" ;
lin cambodian_N = mkTerm "cambodian_N" ;
lin cambourne_PN = mkTerm "cambourne_PN" ;
lin cambric_N = mkTerm "cambric_N" ;
lin cambridge_PN = mkTerm "cambridge_PN" ;
lin cambridgeshire_PN = mkTerm "cambridgeshire_PN" ;
lin cambuslang_PN = mkTerm "cambuslang_PN" ;
lin camcorder_N = mkTerm "camcorder_N" ;
lin camden_PN = mkTerm "camden_PN" ;
lin camel_N = mkTerm "camel_N" ;
lin camel_hair_N = mkTerm "camel_hair_N" ;
lin camellia_N = mkTerm "camellia_N" ;
lin camelpox_N = mkTerm "camelpox_N" ;
lin camembert_N = mkTerm "camembert_N" ;
lin cameo_N = mkTerm "cameo_N" ;
lin camera_N = mkTerm "camera_N" ;
lin cameraman_N = mkTerm "cameraman_N" ;
lin cameroon_PN = mkTerm "cameroon_PN" ;
lin cameroonian_A = mkTerm "cameroonian_A" ;
lin cameroonian_N = mkTerm "cameroonian_N" ;
lin camion_N = mkTerm "camion_N" ;
lin camise_N = mkTerm "camise_N" ;
lin camisole_N = mkTerm "camisole_N" ;
lin camlet_N = mkTerm "camlet_N" ;
lin camomile_N = mkTerm "camomile_N" ;
lin camouflage_N = mkTerm "camouflage_N" ;
lin camouflage_V2 = mkTerm "camouflage_V2" ;
lin camp_A = mkTerm "camp_A" ;
lin camp_N = mkTerm "camp_N" ;
lin camp_V = mkTerm "camp_V" ;
lin camp_V2 = mkTerm "camp_V2" ;
lin camp_bed_N = mkTerm "camp_bed_N" ;
lin camp_chair_N = mkTerm "camp_chair_N" ;
lin camp_fire_N = mkTerm "camp_fire_N" ;
lin camp_follower_N = mkTerm "camp_follower_N" ;
lin camp_out_V = mkTerm "camp_out_V" ;
lin camp_stool_N = mkTerm "camp_stool_N" ;
lin campaign_N = mkTerm "campaign_N" ;
lin campaign_V = mkTerm "campaign_V" ;
lin campaigner_N = mkTerm "campaigner_N" ;
lin campaigning_N = mkTerm "campaigning_N" ;
lin campanile_N = mkTerm "campanile_N" ;
lin campanula_N = mkTerm "campanula_N" ;
lin campanulate_A = mkTerm "campanulate_A" ;
lin campbeltown_PN = mkTerm "campbeltown_PN" ;
lin camper_N = mkTerm "camper_N" ;
lin campestral_A = mkTerm "campestral_A" ;
lin camphor_N = mkTerm "camphor_N" ;
lin camphoraceous_A = mkTerm "camphoraceous_A" ;
lin camphorated_A = mkTerm "camphorated_A" ;
lin camphoric_A = mkTerm "camphoric_A" ;
lin camping_N = mkTerm "camping_N" ;
lin campion_N = mkTerm "campion_N" ;
lin campmate_N = mkTerm "campmate_N" ;
lin campsite_N = mkTerm "campsite_N" ;
lin campus_N = mkTerm "campus_N" ;
lin campylotropous_A = mkTerm "campylotropous_A" ;
lin camshaft_N = mkTerm "camshaft_N" ;
lin camwood_N = mkTerm "camwood_N" ;
lin can_1_VV = mkTerm "can_1_VV" ;
lin can_2_VV = mkTerm "can_2_VV" ;
lin can_N = mkTerm "can_N" ;
lin can_V2 = mkTerm "can_V2" ;
lin canada_PN = mkTerm "canada_PN" ;
lin canadian_A = mkTerm "canadian_A" ;
lin canadian_N = mkTerm "canadian_N" ;
lin canal_N = mkTerm "canal_N" ;
lin canalicular_A = mkTerm "canalicular_A" ;
lin canaliculate_A = mkTerm "canaliculate_A" ;
lin canaliculus_N = mkTerm "canaliculus_N" ;
lin canalization_N = mkTerm "canalization_N" ;
lin canalize_V2 = mkTerm "canalize_V2" ;
lin canape_N = mkTerm "canape_N" ;
lin canard_N = mkTerm "canard_N" ;
lin canary_A = mkTerm "canary_A" ;
lin canary_N = mkTerm "canary_N" ;
lin canary_bird_N = mkTerm "canary_bird_N" ;
lin canary_wine_N = mkTerm "canary_wine_N" ;
lin canasta_N = mkTerm "canasta_N" ;
lin canavanine_N = mkTerm "canavanine_N" ;
lin canberra_PN = mkTerm "canberra_PN" ;
lin cancan_N = mkTerm "cancan_N" ;
lin cancel_V = mkTerm "cancel_V" ;
lin cancel_V2 = mkTerm "cancel_V2" ;
lin cancel_out_V2 = mkTerm "cancel_out_V2" ;
lin cancellate_A = mkTerm "cancellate_A" ;
lin cancellation_N = mkTerm "cancellation_N" ;
lin cancer_N = mkTerm "cancer_N" ;
lin cancer_PN = mkTerm "cancer_PN" ;
lin cancerous_A = mkTerm "cancerous_A" ;
lin cancerweed_N = mkTerm "cancerweed_N" ;
lin cancroid_A = mkTerm "cancroid_A" ;
lin cancroid_N = mkTerm "cancroid_N" ;
lin candelabrum_N = mkTerm "candelabrum_N" ;
lin candelilla_N = mkTerm "candelilla_N" ;
lin candescent_A = mkTerm "candescent_A" ;
lin candid_A = mkTerm "candid_A" ;
lin candida_N = mkTerm "candida_N" ;
lin candidacy_N = mkTerm "candidacy_N" ;
lin candidateFem_N = mkTerm "candidateFem_N" ;
lin candidateMasc_N = mkTerm "candidateMasc_N" ;
lin candidature_N = mkTerm "candidature_N" ;
lin candidiasis_N = mkTerm "candidiasis_N" ;
lin candle_N = mkTerm "candle_N" ;
lin candle_power_N = mkTerm "candle_power_N" ;
lin candlelight_N = mkTerm "candlelight_N" ;
lin candlemaker_N = mkTerm "candlemaker_N" ;
lin candlenut_N = mkTerm "candlenut_N" ;
lin candlepin_N = mkTerm "candlepin_N" ;
lin candlepins_N = mkTerm "candlepins_N" ;
lin candlesnuffer_N = mkTerm "candlesnuffer_N" ;
lin candlestick_N = mkTerm "candlestick_N" ;
lin candlewick_N = mkTerm "candlewick_N" ;
lin candlewood_N = mkTerm "candlewood_N" ;
lin candor_N = mkTerm "candor_N" ;
lin candour_N = mkTerm "candour_N" ;
lin candy_N = mkTerm "candy_N" ;
lin candy_V = mkTerm "candy_V" ;
lin candy_V2 = mkTerm "candy_V2" ;
lin candy_floss_N = mkTerm "candy_floss_N" ;
lin candytuft_N = mkTerm "candytuft_N" ;
lin cane_N = mkTerm "cane_N" ;
lin cane_V2 = mkTerm "cane_V2" ;
lin canebrake_N = mkTerm "canebrake_N" ;
lin canella_N = mkTerm "canella_N" ;
lin canescent_A = mkTerm "canescent_A" ;
lin canfield_N = mkTerm "canfield_N" ;
lin cangue_N = mkTerm "cangue_N" ;
lin canicular_A = mkTerm "canicular_A" ;
lin canine_A = mkTerm "canine_A" ;
lin canine_N = mkTerm "canine_N" ;
lin canistel_N = mkTerm "canistel_N" ;
lin canister_N = mkTerm "canister_N" ;
lin canker_N = mkTerm "canker_N" ;
lin canker_V2 = mkTerm "canker_V2" ;
lin cankerous_A = mkTerm "cankerous_A" ;
lin cankerworm_N = mkTerm "cankerworm_N" ;
lin canna_N = mkTerm "canna_N" ;
lin cannabin_N = mkTerm "cannabin_N" ;
lin cannabis_N = mkTerm "cannabis_N" ;
lin cannelloni_N = mkTerm "cannelloni_N" ;
lin cannery_N = mkTerm "cannery_N" ;
lin cannes_PN = mkTerm "cannes_PN" ;
lin cannibal_N = mkTerm "cannibal_N" ;
lin cannibalic_A = mkTerm "cannibalic_A" ;
lin cannibalism_N = mkTerm "cannibalism_N" ;
lin cannibalistic_A = mkTerm "cannibalistic_A" ;
lin cannibalize_V2 = mkTerm "cannibalize_V2" ;
lin cannikin_N = mkTerm "cannikin_N" ;
lin cannock_PN = mkTerm "cannock_PN" ;
lin cannon_1_N = mkTerm "cannon_1_N" ;
lin cannon_2_N = mkTerm "cannon_2_N" ;
lin cannon_fodder_N = mkTerm "cannon_fodder_N" ;
lin cannonade_N = mkTerm "cannonade_N" ;
lin cannonball_N = mkTerm "cannonball_N" ;
lin cannula_N = mkTerm "cannula_N" ;
lin cannulation_N = mkTerm "cannulation_N" ;
lin canny_A = mkTerm "canny_A" ;
lin canoe_N = mkTerm "canoe_N" ;
lin canoe_V2 = mkTerm "canoe_V2" ;
lin canoeist_N = mkTerm "canoeist_N" ;
lin canon_N = mkTerm "canon_N" ;
lin canonic_A = mkTerm "canonic_A" ;
lin canonical_A = mkTerm "canonical_A" ;
lin canonist_A = mkTerm "canonist_A" ;
lin canonist_N = mkTerm "canonist_N" ;
lin canonization_N = mkTerm "canonization_N" ;
lin canonize_V2 = mkTerm "canonize_V2" ;
lin canopied_A = mkTerm "canopied_A" ;
lin canopy_N = mkTerm "canopy_N" ;
lin canorous_A = mkTerm "canorous_A" ;
lin cant_N = mkTerm "cant_N" ;
lin cant_V = mkTerm "cant_V" ;
lin cant_V2 = mkTerm "cant_V2" ;
lin cantab_PN = mkTerm "cantab_PN" ;
lin cantabile_A = mkTerm "cantabile_A" ;
lin cantala_N = mkTerm "cantala_N" ;
lin cantaloupe_N = mkTerm "cantaloupe_N" ;
lin cantankerous_A = mkTerm "cantankerous_A" ;
lin cantata_N = mkTerm "cantata_N" ;
lin canteen_N = mkTerm "canteen_N" ;
lin canter_N = mkTerm "canter_N" ;
lin canter_V = mkTerm "canter_V" ;
lin canter_V2 = mkTerm "canter_V2" ;
lin canterbury_PN = mkTerm "canterbury_PN" ;
lin canthus_N = mkTerm "canthus_N" ;
lin canticle_N = mkTerm "canticle_N" ;
lin cantilever_N = mkTerm "cantilever_N" ;
lin cantillation_N = mkTerm "cantillation_N" ;
lin cantle_N = mkTerm "cantle_N" ;
lin canto_N = mkTerm "canto_N" ;
lin canton_N = mkTerm "canton_N" ;
lin canton_PN = mkTerm "canton_PN" ;
lin cantonal_A = mkTerm "cantonal_A" ;
lin cantonment_N = mkTerm "cantonment_N" ;
lin cantor_N = mkTerm "cantor_N" ;
lin canty_A = mkTerm "canty_A" ;
lin canuck_N = mkTerm "canuck_N" ;
lin canvas_N = mkTerm "canvas_N" ;
lin canvasback_N = mkTerm "canvasback_N" ;
lin canvass_N = mkTerm "canvass_N" ;
lin canvass_V = mkTerm "canvass_V" ;
lin canvass_V2 = mkTerm "canvass_V2" ;
lin canvasser_N = mkTerm "canvasser_N" ;
lin canvey_PN = mkTerm "canvey_PN" ;
lin canvey_island_PN = mkTerm "canvey_island_PN" ;
lin canyon_N = mkTerm "canyon_N" ;
lin canyonside_N = mkTerm "canyonside_N" ;
lin cap_1_N = mkTerm "cap_1_N" ;
lin cap_2_N = mkTerm "cap_2_N" ;
lin cap_V2 = mkTerm "cap_V2" ;
lin cap_a_pie_Adv = mkTerm "cap_a_pie_Adv" ;
lin cap_off_V2 = mkTerm "cap_off_V2" ;
lin capability_N = mkTerm "capability_N" ;
lin capable_of_A2 = mkTerm "capable_of_A2" ;
lin capacious_A = mkTerm "capacious_A" ;
lin capaciousness_N = mkTerm "capaciousness_N" ;
lin capacitance_N = mkTerm "capacitance_N" ;
lin capacitive_A = mkTerm "capacitive_A" ;
lin capacitor_N = mkTerm "capacitor_N" ;
lin capacity_N = mkTerm "capacity_N" ;
lin caparison_N = mkTerm "caparison_N" ;
lin caparison_V2 = mkTerm "caparison_V2" ;
lin cape_N = mkTerm "cape_N" ;
lin cape_town_PN = mkTerm "cape_town_PN" ;
lin capelin_N = mkTerm "capelin_N" ;
lin caper_N = mkTerm "caper_N" ;
lin caper_V = mkTerm "caper_V" ;
lin capercaillie_N = mkTerm "capercaillie_N" ;
lin capful_N = mkTerm "capful_N" ;
lin capillarity_N = mkTerm "capillarity_N" ;
lin capillary_A = mkTerm "capillary_A" ;
lin capillary_N = mkTerm "capillary_N" ;
lin capital_1_N = mkTerm "capital_1_N" ;
lin capital_2_N = mkTerm "capital_2_N" ;
lin capital_3_N = mkTerm "capital_3_N" ;
lin capital_A = mkTerm "capital_A" ;
lin capitalism_A = mkTerm "capitalism_A" ;
lin capitalism_N = mkTerm "capitalism_N" ;
lin capitalist_A = mkTerm "capitalist_A" ;
lin capitalist_N = mkTerm "capitalist_N" ;
lin capitalistic_A = mkTerm "capitalistic_A" ;
lin capitalization_N = mkTerm "capitalization_N" ;
lin capitalize_V = mkTerm "capitalize_V" ;
lin capitalize_V2 = mkTerm "capitalize_V2" ;
lin capitate_A = mkTerm "capitate_A" ;
lin capitate_N = mkTerm "capitate_N" ;
lin capitation_N = mkTerm "capitation_N" ;
lin capitol_N = mkTerm "capitol_N" ;
lin capitular_A = mkTerm "capitular_A" ;
lin capitulate_V = mkTerm "capitulate_V" ;
lin capitulate_V2 = mkTerm "capitulate_V2" ;
lin capitulation_N = mkTerm "capitulation_N" ;
lin capitulum_N = mkTerm "capitulum_N" ;
lin capo_N = mkTerm "capo_N" ;
lin capon_N = mkTerm "capon_N" ;
lin capote_N = mkTerm "capote_N" ;
lin cappella_N = mkTerm "cappella_N" ;
lin cappuccino_N = mkTerm "cappuccino_N" ;
lin capriccio_N = mkTerm "capriccio_N" ;
lin caprice_N = mkTerm "caprice_N" ;
lin capricious_A = mkTerm "capricious_A" ;
lin capriciousness_N = mkTerm "capriciousness_N" ;
lin capricorn_PN = mkTerm "capricorn_PN" ;
lin caprifig_N = mkTerm "caprifig_N" ;
lin caprine_A = mkTerm "caprine_A" ;
lin capriole_N = mkTerm "capriole_N" ;
lin capsaicin_N = mkTerm "capsaicin_N" ;
lin capsicum_N = mkTerm "capsicum_N" ;
lin capsid_N = mkTerm "capsid_N" ;
lin capsize_V = mkTerm "capsize_V" ;
lin capsize_V2 = mkTerm "capsize_V2" ;
lin capsizing_N = mkTerm "capsizing_N" ;
lin capstan_N = mkTerm "capstan_N" ;
lin capstone_N = mkTerm "capstone_N" ;
lin capsular_A = mkTerm "capsular_A" ;
lin capsulate_A = mkTerm "capsulate_A" ;
lin capsule_N = mkTerm "capsule_N" ;
lin capt_PN = mkTerm "capt_PN" ;
lin captain_N = mkTerm "captain_N" ;
lin captain_V2 = mkTerm "captain_V2" ;
lin captainship_N = mkTerm "captainship_N" ;
lin caption_N = mkTerm "caption_N" ;
lin captious_A = mkTerm "captious_A" ;
lin captivate_V2 = mkTerm "captivate_V2" ;
lin captivation_N = mkTerm "captivation_N" ;
lin captiveFem_N = mkTerm "captiveFem_N" ;
lin captiveMasc_N = mkTerm "captiveMasc_N" ;
lin captive_A = mkTerm "captive_A" ;
lin captivity_N = mkTerm "captivity_N" ;
lin captopril_N = mkTerm "captopril_N" ;
lin captor_N = mkTerm "captor_N" ;
lin capture_N = mkTerm "capture_N" ;
lin capture_V2 = mkTerm "capture_V2" ;
lin capuchin_N = mkTerm "capuchin_N" ;
lin capulin_N = mkTerm "capulin_N" ;
lin caput_N = mkTerm "caput_N" ;
lin capybara_N = mkTerm "capybara_N" ;
lin car_N = mkTerm "car_N" ;
lin car_V = mkTerm "car_V" ;
lin car_ferry_N = mkTerm "car_ferry_N" ;
lin carabao_N = mkTerm "carabao_N" ;
lin carabiner_N = mkTerm "carabiner_N" ;
lin caracal_N = mkTerm "caracal_N" ;
lin caracara_N = mkTerm "caracara_N" ;
lin caracas_PN = mkTerm "caracas_PN" ;
lin caracolito_N = mkTerm "caracolito_N" ;
lin carafe_N = mkTerm "carafe_N" ;
lin carambola_N = mkTerm "carambola_N" ;
lin caramel_A = mkTerm "caramel_A" ;
lin caramel_N = mkTerm "caramel_N" ;
lin carancha_N = mkTerm "carancha_N" ;
lin caranday_N = mkTerm "caranday_N" ;
lin carangid_A = mkTerm "carangid_A" ;
lin carapace_N = mkTerm "carapace_N" ;
lin carat_N = mkTerm "carat_N" ;
lin caravan_N = mkTerm "caravan_N" ;
lin caravanning_N = mkTerm "caravanning_N" ;
lin caravanserai_N = mkTerm "caravanserai_N" ;
lin caraway_N = mkTerm "caraway_N" ;
lin carbamate_N = mkTerm "carbamate_N" ;
lin carbide_N = mkTerm "carbide_N" ;
lin carbine_N = mkTerm "carbine_N" ;
lin carbineer_N = mkTerm "carbineer_N" ;
lin carbocyclic_A = mkTerm "carbocyclic_A" ;
lin carbohydrate_N = mkTerm "carbohydrate_N" ;
lin carbolated_A = mkTerm "carbolated_A" ;
lin carbolic_A = mkTerm "carbolic_A" ;
lin carbomycin_N = mkTerm "carbomycin_N" ;
lin carbon_N = mkTerm "carbon_N" ;
lin carbon_paper_N = mkTerm "carbon_paper_N" ;
lin carbonaceous_A = mkTerm "carbonaceous_A" ;
lin carbonado_N = mkTerm "carbonado_N" ;
lin carbonara_N = mkTerm "carbonara_N" ;
lin carbonate_N = mkTerm "carbonate_N" ;
lin carbonated_A = mkTerm "carbonated_A" ;
lin carbonation_N = mkTerm "carbonation_N" ;
lin carbonic_A = mkTerm "carbonic_A" ;
lin carboniferous_A = mkTerm "carboniferous_A" ;
lin carbonization_N = mkTerm "carbonization_N" ;
lin carbonize_V2 = mkTerm "carbonize_V2" ;
lin carbonyl_A = mkTerm "carbonyl_A" ;
lin carbonyl_N = mkTerm "carbonyl_N" ;
lin carborundum_N = mkTerm "carborundum_N" ;
lin carboxyl_A = mkTerm "carboxyl_A" ;
lin carboxyl_N = mkTerm "carboxyl_N" ;
lin carboy_N = mkTerm "carboy_N" ;
lin carbuncle_N = mkTerm "carbuncle_N" ;
lin carbuncled_A = mkTerm "carbuncled_A" ;
lin carburettor_N = mkTerm "carburettor_N" ;
lin carcase_N = mkTerm "carcase_N" ;
lin carcass_N = mkTerm "carcass_N" ;
lin carcinogen_N = mkTerm "carcinogen_N" ;
lin carcinogenic_A = mkTerm "carcinogenic_A" ;
lin carcinoid_N = mkTerm "carcinoid_N" ;
lin carcinoma_N = mkTerm "carcinoma_N" ;
lin carcinomatous_A = mkTerm "carcinomatous_A" ;
lin carcinosarcoma_N = mkTerm "carcinosarcoma_N" ;
lin card_1_N = mkTerm "card_1_N" ;
lin card_2_N = mkTerm "card_2_N" ;
lin card_V2 = mkTerm "card_V2" ;
lin card_sharper_N = mkTerm "card_sharper_N" ;
lin cardamom_N = mkTerm "cardamom_N" ;
lin cardboard_A = mkTerm "cardboard_A" ;
lin cardboard_N = mkTerm "cardboard_N" ;
lin cardcase_N = mkTerm "cardcase_N" ;
lin cardenden_PN = mkTerm "cardenden_PN" ;
lin cardholder_N = mkTerm "cardholder_N" ;
lin cardia_N = mkTerm "cardia_N" ;
lin cardiac_A = mkTerm "cardiac_A" ;
lin cardiff_PN = mkTerm "cardiff_PN" ;
lin cardigan_N = mkTerm "cardigan_N" ;
lin cardigan_PN = mkTerm "cardigan_PN" ;
lin cardinal_A = mkTerm "cardinal_A" ;
lin cardinal_N = mkTerm "cardinal_N" ;
lin cardinalate_N = mkTerm "cardinalate_N" ;
lin cardinalfish_N = mkTerm "cardinalfish_N" ;
lin cardinality_N = mkTerm "cardinality_N" ;
lin cardinalship_N = mkTerm "cardinalship_N" ;
lin cardiograph_N = mkTerm "cardiograph_N" ;
lin cardiographic_A = mkTerm "cardiographic_A" ;
lin cardiography_N = mkTerm "cardiography_N" ;
lin cardioid_N = mkTerm "cardioid_N" ;
lin cardiologic_A = mkTerm "cardiologic_A" ;
lin cardiologistFem_N = mkTerm "cardiologistFem_N" ;
lin cardiologistMasc_N = mkTerm "cardiologistMasc_N" ;
lin cardiology_N = mkTerm "cardiology_N" ;
lin cardiomegaly_N = mkTerm "cardiomegaly_N" ;
lin cardiomyopathy_N = mkTerm "cardiomyopathy_N" ;
lin cardiopulmonary_A = mkTerm "cardiopulmonary_A" ;
lin cardiospasm_N = mkTerm "cardiospasm_N" ;
lin cardiovascular_A = mkTerm "cardiovascular_A" ;
lin carditis_N = mkTerm "carditis_N" ;
lin cardoon_N = mkTerm "cardoon_N" ;
lin cardroom_N = mkTerm "cardroom_N" ;
lin cardsharp_N = mkTerm "cardsharp_N" ;
lin care_N = mkTerm "care_N" ;
lin care_V = mkTerm "care_V" ;
lin care_for_V2 = mkTerm "care_for_V2" ;
lin careen_V = mkTerm "careen_V" ;
lin careen_V2 = mkTerm "careen_V2" ;
lin career_N = mkTerm "career_N" ;
lin career_V = mkTerm "career_V" ;
lin careerism_N = mkTerm "careerism_N" ;
lin careerist_N = mkTerm "careerist_N" ;
lin carefree_A = mkTerm "carefree_A" ;
lin carefreeness_N = mkTerm "carefreeness_N" ;
lin careful_A = mkTerm "careful_A" ;
lin carefulness_N = mkTerm "carefulness_N" ;
lin caregiver_N = mkTerm "caregiver_N" ;
lin careladen_A = mkTerm "careladen_A" ;
lin careless_A = mkTerm "careless_A" ;
lin carelessness_N = mkTerm "carelessness_N" ;
lin carer_N = mkTerm "carer_N" ;
lin caress_N = mkTerm "caress_N" ;
lin caress_V2 = mkTerm "caress_V2" ;
lin caressing_A = mkTerm "caressing_A" ;
lin caressing_N = mkTerm "caressing_N" ;
lin caret_N = mkTerm "caret_N" ;
lin caretaker_N = mkTerm "caretaker_N" ;
lin careworn_A = mkTerm "careworn_A" ;
lin carful_N = mkTerm "carful_N" ;
lin cargo_N = mkTerm "cargo_N" ;
lin carhop_N = mkTerm "carhop_N" ;
lin caribou_N = mkTerm "caribou_N" ;
lin caricature_N = mkTerm "caricature_N" ;
lin caricature_V2 = mkTerm "caricature_V2" ;
lin caricaturist_N = mkTerm "caricaturist_N" ;
lin caries_N = mkTerm "caries_N" ;
lin carillon_N = mkTerm "carillon_N" ;
lin carillonneur_N = mkTerm "carillonneur_N" ;
lin carina_N = mkTerm "carina_N" ;
lin carinal_A = mkTerm "carinal_A" ;
lin carinate_N = mkTerm "carinate_N" ;
lin carioca_N = mkTerm "carioca_N" ;
lin carious_A = mkTerm "carious_A" ;
lin carissa_N = mkTerm "carissa_N" ;
lin carjacking_N = mkTerm "carjacking_N" ;
lin carl_PN = mkTerm "carl_PN" ;
lin carlisle_PN = mkTerm "carlisle_PN" ;
lin carload_N = mkTerm "carload_N" ;
lin carlow_PN = mkTerm "carlow_PN" ;
lin carluke_PN = mkTerm "carluke_PN" ;
lin carmarthen_PN = mkTerm "carmarthen_PN" ;
lin carmelite_A = mkTerm "carmelite_A" ;
lin carmelite_N = mkTerm "carmelite_N" ;
lin carminative_A = mkTerm "carminative_A" ;
lin carminative_N = mkTerm "carminative_N" ;
lin carmine_A = mkTerm "carmine_A" ;
lin carmine_N = mkTerm "carmine_N" ;
lin carnage_N = mkTerm "carnage_N" ;
lin carnal_A = mkTerm "carnal_A" ;
lin carnallite_N = mkTerm "carnallite_N" ;
lin carnassial_A = mkTerm "carnassial_A" ;
lin carnation_A = mkTerm "carnation_A" ;
lin carnation_N = mkTerm "carnation_N" ;
lin carnauba_N = mkTerm "carnauba_N" ;
lin carnelian_N = mkTerm "carnelian_N" ;
lin carnforth_PN = mkTerm "carnforth_PN" ;
lin carnival_N = mkTerm "carnival_N" ;
lin carnivore_N = mkTerm "carnivore_N" ;
lin carnivorous_A = mkTerm "carnivorous_A" ;
lin carnosaur_N = mkTerm "carnosaur_N" ;
lin carnotite_N = mkTerm "carnotite_N" ;
lin carnoustie_PN = mkTerm "carnoustie_PN" ;
lin carob_N = mkTerm "carob_N" ;
lin caroche_N = mkTerm "caroche_N" ;
lin carol_N = mkTerm "carol_N" ;
lin carol_PN = mkTerm "carol_PN" ;
lin carol_V2 = mkTerm "carol_V2" ;
lin carole_PN = mkTerm "carole_PN" ;
lin caroler_N = mkTerm "caroler_N" ;
lin carolina_PN = mkTerm "carolina_PN" ;
lin caroline_N = mkTerm "caroline_N" ;
lin caroline_PN = mkTerm "caroline_PN" ;
lin caroling_N = mkTerm "caroling_N" ;
lin caroller_N = mkTerm "caroller_N" ;
lin carolyn_PN = mkTerm "carolyn_PN" ;
lin carom_N = mkTerm "carom_N" ;
lin carotene_N = mkTerm "carotene_N" ;
lin carotenemia_N = mkTerm "carotenemia_N" ;
lin carotenoid_N = mkTerm "carotenoid_N" ;
lin carotid_A = mkTerm "carotid_A" ;
lin carousal_N = mkTerm "carousal_N" ;
lin carouse_N = mkTerm "carouse_N" ;
lin carouse_V2 = mkTerm "carouse_V2" ;
lin carousel_N = mkTerm "carousel_N" ;
lin carp_N = mkTerm "carp_N" ;
lin carp_V = mkTerm "carp_V" ;
lin carp_V2 = mkTerm "carp_V2" ;
lin carpal_A = mkTerm "carpal_A" ;
lin carpal_N = mkTerm "carpal_N" ;
lin carpel_N = mkTerm "carpel_N" ;
lin carpellary_A = mkTerm "carpellary_A" ;
lin carpellate_A = mkTerm "carpellate_A" ;
lin carpenter_N = mkTerm "carpenter_N" ;
lin carpenteria_N = mkTerm "carpenteria_N" ;
lin carpentry_N = mkTerm "carpentry_N" ;
lin carper_N = mkTerm "carper_N" ;
lin carpet_N = mkTerm "carpet_N" ;
lin carpet_V2 = mkTerm "carpet_V2" ;
lin carpet_beater_N = mkTerm "carpet_beater_N" ;
lin carpet_knight_N = mkTerm "carpet_knight_N" ;
lin carpet_sweeper_N = mkTerm "carpet_sweeper_N" ;
lin carpetbag_A = mkTerm "carpetbag_A" ;
lin carpetbag_N = mkTerm "carpetbag_N" ;
lin carpetbagger_N = mkTerm "carpetbagger_N" ;
lin carpetweed_N = mkTerm "carpetweed_N" ;
lin carpophagous_A = mkTerm "carpophagous_A" ;
lin carpophore_N = mkTerm "carpophore_N" ;
lin carport_N = mkTerm "carport_N" ;
lin carpospore_N = mkTerm "carpospore_N" ;
lin carposporic_A = mkTerm "carposporic_A" ;
lin carposporous_A = mkTerm "carposporous_A" ;
lin carrack_N = mkTerm "carrack_N" ;
lin carrageenin_N = mkTerm "carrageenin_N" ;
lin carrel_N = mkTerm "carrel_N" ;
lin carriage_N = mkTerm "carriage_N" ;
lin carriageway_N = mkTerm "carriageway_N" ;
lin carrie_PN = mkTerm "carrie_PN" ;
lin carried_away_V = mkTerm "carried_away_V" ;
lin carrier_N = mkTerm "carrier_N" ;
lin carrier_bag_N = mkTerm "carrier_bag_N" ;
lin carrier_pigeon_N = mkTerm "carrier_pigeon_N" ;
lin carrion_N = mkTerm "carrion_N" ;
lin carrion_crow_N = mkTerm "carrion_crow_N" ;
lin carron_PN = mkTerm "carron_PN" ;
lin carrot_N = mkTerm "carrot_N" ;
lin carroty_A = mkTerm "carroty_A" ;
lin carry_N = mkTerm "carry_N" ;
lin carry_V = mkTerm "carry_V" ;
lin carry_V2 = mkTerm "carry_V2" ;
lin carry_forward_V2 = mkTerm "carry_forward_V2" ;
lin carry_off_V2 = mkTerm "carry_off_V2" ;
lin carry_on_V = mkTerm "carry_on_V" ;
lin carry_on_V2 = mkTerm "carry_on_V2" ;
lin carry_on_about_V2 = mkTerm "carry_on_about_V2" ;
lin carry_on_with_V2 = mkTerm "carry_on_with_V2" ;
lin carry_out_V = mkTerm "carry_out_V" ;
lin carry_out_V2 = mkTerm "carry_out_V2" ;
lin carry_over_V2 = mkTerm "carry_over_V2" ;
lin carry_through_V2 = mkTerm "carry_through_V2" ;
lin carryall_N = mkTerm "carryall_N" ;
lin carrycot_N = mkTerm "carrycot_N" ;
lin carsick_A = mkTerm "carsick_A" ;
lin carsickness_N = mkTerm "carsickness_N" ;
lin cart_N = mkTerm "cart_N" ;
lin cart_V2 = mkTerm "cart_V2" ;
lin cart_off_V2 = mkTerm "cart_off_V2" ;
lin cart_out_V = mkTerm "cart_out_V" ;
lin cart_track_N = mkTerm "cart_track_N" ;
lin cartage_N = mkTerm "cartage_N" ;
lin cartagena_PN = mkTerm "cartagena_PN" ;
lin carte_blanche_N = mkTerm "carte_blanche_N" ;
lin cartel_N = mkTerm "cartel_N" ;
lin carter_N = mkTerm "carter_N" ;
lin carthorse_N = mkTerm "carthorse_N" ;
lin cartilage_N = mkTerm "cartilage_N" ;
lin cartilaginification_N = mkTerm "cartilaginification_N" ;
lin cartilaginous_A = mkTerm "cartilaginous_A" ;
lin cartload_N = mkTerm "cartload_N" ;
lin cartographer_N = mkTerm "cartographer_N" ;
lin cartographic_A = mkTerm "cartographic_A" ;
lin cartography_N = mkTerm "cartography_N" ;
lin carton_N = mkTerm "carton_N" ;
lin cartoon_N = mkTerm "cartoon_N" ;
lin cartoon_V2 = mkTerm "cartoon_V2" ;
lin cartoonistFem_N = mkTerm "cartoonistFem_N" ;
lin cartoonistMasc_N = mkTerm "cartoonistMasc_N" ;
lin cartouche_N = mkTerm "cartouche_N" ;
lin cartridge_N = mkTerm "cartridge_N" ;
lin cartridge_belt_N = mkTerm "cartridge_belt_N" ;
lin cartridge_paper_N = mkTerm "cartridge_paper_N" ;
lin cartroad_N = mkTerm "cartroad_N" ;
lin cartwheel_N = mkTerm "cartwheel_N" ;
lin cartwright_N = mkTerm "cartwright_N" ;
lin caruncle_N = mkTerm "caruncle_N" ;
lin caruncular_A = mkTerm "caruncular_A" ;
lin carunculate_A = mkTerm "carunculate_A" ;
lin carve_V = mkTerm "carve_V" ;
lin carve_V2 = mkTerm "carve_V2" ;
lin carve_out_V2 = mkTerm "carve_out_V2" ;
lin carve_up_V2 = mkTerm "carve_up_V2" ;
lin carvedilol_N = mkTerm "carvedilol_N" ;
lin carver_N = mkTerm "carver_N" ;
lin carving_N = mkTerm "carving_N" ;
lin carving_fork_N = mkTerm "carving_fork_N" ;
lin carving_knife_N = mkTerm "carving_knife_N" ;
lin caryatid_N = mkTerm "caryatid_N" ;
lin caryophyllaceous_A = mkTerm "caryophyllaceous_A" ;
lin casaba_N = mkTerm "casaba_N" ;
lin casablanca_PN = mkTerm "casablanca_PN" ;
lin cascade_N = mkTerm "cascade_N" ;
lin cascade_V = mkTerm "cascade_V" ;
lin cascara_N = mkTerm "cascara_N" ;
lin cascarilla_N = mkTerm "cascarilla_N" ;
lin case_N = mkTerm "case_N" ;
lin case_V2 = mkTerm "case_V2" ;
lin case_hardened_A = mkTerm "case_hardened_A" ;
lin case_history_N = mkTerm "case_history_N" ;
lin case_law_N = mkTerm "case_law_N" ;
lin casebook_A = mkTerm "casebook_A" ;
lin casebook_N = mkTerm "casebook_N" ;
lin casein_N = mkTerm "casein_N" ;
lin casement_N = mkTerm "casement_N" ;
lin caseous_A = mkTerm "caseous_A" ;
lin casern_N = mkTerm "casern_N" ;
lin casework_N = mkTerm "casework_N" ;
lin caseworm_N = mkTerm "caseworm_N" ;
lin cash_N = mkTerm "cash_N" ;
lin cash_V = mkTerm "cash_V" ;
lin cash_V2 = mkTerm "cash_V2" ;
lin cash_in_V2 = mkTerm "cash_in_V2" ;
lin cash_in_on_V2 = mkTerm "cash_in_on_V2" ;
lin cash_out_V2 = mkTerm "cash_out_V2" ;
lin cash_up_V = mkTerm "cash_up_V" ;
lin cashable_A = mkTerm "cashable_A" ;
lin cashbox_N = mkTerm "cashbox_N" ;
lin cashew_N = mkTerm "cashew_N" ;
lin cashier_N = mkTerm "cashier_N" ;
lin cashier_V2 = mkTerm "cashier_V2" ;
lin cashmere_N = mkTerm "cashmere_N" ;
lin casing_N = mkTerm "casing_N" ;
lin casino_N = mkTerm "casino_N" ;
lin cask_N = mkTerm "cask_N" ;
lin casket_N = mkTerm "casket_N" ;
lin caspase_N = mkTerm "caspase_N" ;
lin casque_N = mkTerm "casque_N" ;
lin casquet_N = mkTerm "casquet_N" ;
lin cassareep_N = mkTerm "cassareep_N" ;
lin cassava_N = mkTerm "cassava_N" ;
lin casserole_N = mkTerm "casserole_N" ;
lin cassette_N = mkTerm "cassette_N" ;
lin cassia_N = mkTerm "cassia_N" ;
lin cassiri_N = mkTerm "cassiri_N" ;
lin cassiterite_N = mkTerm "cassiterite_N" ;
lin cassock_N = mkTerm "cassock_N" ;
lin cassocked_A = mkTerm "cassocked_A" ;
lin cassowary_N = mkTerm "cassowary_N" ;
lin cast_N = mkTerm "cast_N" ;
lin cast_V = mkTerm "cast_V" ;
lin cast_V2 = mkTerm "cast_V2" ;
lin cast_about_for_V2 = mkTerm "cast_about_for_V2" ;
lin cast_around_V = mkTerm "cast_around_V" ;
lin cast_around_for_V2 = mkTerm "cast_around_for_V2" ;
lin cast_aside_V2 = mkTerm "cast_aside_V2" ;
lin cast_iron_A = mkTerm "cast_iron_A" ;
lin cast_off_A = mkTerm "cast_off_A" ;
lin cast_off_V = mkTerm "cast_off_V" ;
lin cast_off_V2 = mkTerm "cast_off_V2" ;
lin cast_out_V2 = mkTerm "cast_out_V2" ;
lin cast_round_for_V2 = mkTerm "cast_round_for_V2" ;
lin cast_up_V2 = mkTerm "cast_up_V2" ;
lin castaway_N = mkTerm "castaway_N" ;
lin caste_N = mkTerm "caste_N" ;
lin castellated_A = mkTerm "castellated_A" ;
lin caster_N = mkTerm "caster_N" ;
lin castigate_V2 = mkTerm "castigate_V2" ;
lin castigation_N = mkTerm "castigation_N" ;
lin casting_N = mkTerm "casting_N" ;
lin castle_N = mkTerm "castle_N" ;
lin castle_V = mkTerm "castle_V" ;
lin castleford_PN = mkTerm "castleford_PN" ;
lin castor_N = mkTerm "castor_N" ;
lin castor_oil_N = mkTerm "castor_oil_N" ;
lin castrate_V2 = mkTerm "castrate_V2" ;
lin castration_N = mkTerm "castration_N" ;
lin castrato_N = mkTerm "castrato_N" ;
lin casual_A = mkTerm "casual_A" ;
lin casualness_N = mkTerm "casualness_N" ;
lin casualty_N = mkTerm "casualty_N" ;
lin casuarina_N = mkTerm "casuarina_N" ;
lin casuist_N = mkTerm "casuist_N" ;
lin casuistic_A = mkTerm "casuistic_A" ;
lin casuistical_A = mkTerm "casuistical_A" ;
lin casuistry_N = mkTerm "casuistry_N" ;
lin casus_belli_N = mkTerm "casus_belli_N" ;
lin cat_N = mkTerm "cat_N" ;
lin cat_nap_N = mkTerm "cat_nap_N" ;
lin cat_o'_nine_tails_N = mkTerm "cat_o'_nine_tails_N" ;
lin cat_sleep_N = mkTerm "cat_sleep_N" ;
lin catabiosis_N = mkTerm "catabiosis_N" ;
lin catabolic_A = mkTerm "catabolic_A" ;
lin catabolism_N = mkTerm "catabolism_N" ;
lin catachresis_N = mkTerm "catachresis_N" ;
lin catachrestic_A = mkTerm "catachrestic_A" ;
lin cataclinal_A = mkTerm "cataclinal_A" ;
lin cataclysm_N = mkTerm "cataclysm_N" ;
lin cataclysmal_A = mkTerm "cataclysmal_A" ;
lin cataclysmic_A = mkTerm "cataclysmic_A" ;
lin catacomb_N = mkTerm "catacomb_N" ;
lin catacorner_A = mkTerm "catacorner_A" ;
lin catadromous_A = mkTerm "catadromous_A" ;
lin catafalque_N = mkTerm "catafalque_N" ;
lin catalanFem_N = mkTerm "catalanFem_N" ;
lin catalanMasc_N = mkTerm "catalanMasc_N" ;
lin catalan_A = mkTerm "catalan_A" ;
lin catalase_N = mkTerm "catalase_N" ;
lin catalatic_A = mkTerm "catalatic_A" ;
lin catalectic_A = mkTerm "catalectic_A" ;
lin catalectic_N = mkTerm "catalectic_N" ;
lin catalepsy_N = mkTerm "catalepsy_N" ;
lin cataleptic_A = mkTerm "cataleptic_A" ;
lin cataleptic_N = mkTerm "cataleptic_N" ;
lin catalexis_N = mkTerm "catalexis_N" ;
lin catalog_N = mkTerm "catalog_N" ;
lin catalog_V2 = mkTerm "catalog_V2" ;
lin cataloger_N = mkTerm "cataloger_N" ;
lin catalogue_N = mkTerm "catalogue_N" ;
lin catalogue_V2 = mkTerm "catalogue_V2" ;
lin catalpa_N = mkTerm "catalpa_N" ;
lin catalufa_N = mkTerm "catalufa_N" ;
lin catalysis_N = mkTerm "catalysis_N" ;
lin catalyst_N = mkTerm "catalyst_N" ;
lin catalytic_A = mkTerm "catalytic_A" ;
lin catamaran_N = mkTerm "catamaran_N" ;
lin catamite_N = mkTerm "catamite_N" ;
lin catananche_N = mkTerm "catananche_N" ;
lin catania_PN = mkTerm "catania_PN" ;
lin cataphasia_N = mkTerm "cataphasia_N" ;
lin cataphatic_A = mkTerm "cataphatic_A" ;
lin cataphatism_N = mkTerm "cataphatism_N" ;
lin cataphyll_N = mkTerm "cataphyll_N" ;
lin cataplasia_N = mkTerm "cataplasia_N" ;
lin cataplastic_A = mkTerm "cataplastic_A" ;
lin catapult_N = mkTerm "catapult_N" ;
lin catapult_V2 = mkTerm "catapult_V2" ;
lin catapultic_A = mkTerm "catapultic_A" ;
lin cataract_N = mkTerm "cataract_N" ;
lin catarrh_N = mkTerm "catarrh_N" ;
lin catarrhal_A = mkTerm "catarrhal_A" ;
lin catarrhine_A = mkTerm "catarrhine_A" ;
lin catastrophe_N = mkTerm "catastrophe_N" ;
lin catastrophic_A = mkTerm "catastrophic_A" ;
lin catatonia_N = mkTerm "catatonia_N" ;
lin catatonic_A = mkTerm "catatonic_A" ;
lin catbird_N = mkTerm "catbird_N" ;
lin catboat_N = mkTerm "catboat_N" ;
lin catcall_N = mkTerm "catcall_N" ;
lin catcall_V = mkTerm "catcall_V" ;
lin catch_N = mkTerm "catch_N" ;
lin catch_V2 = mkTerm "catch_V2" ;
lin catch_at_V2 = mkTerm "catch_at_V2" ;
lin catch_crop_N = mkTerm "catch_crop_N" ;
lin catch_on_V = mkTerm "catch_on_V" ;
lin catch_out_V2 = mkTerm "catch_out_V2" ;
lin catch_up_V = mkTerm "catch_up_V" ;
lin catch_up_V2 = mkTerm "catch_up_V2" ;
lin catch_up_in_V2 = mkTerm "catch_up_in_V2" ;
lin catch_up_on_V2 = mkTerm "catch_up_on_V2" ;
lin catch_up_with_V2 = mkTerm "catch_up_with_V2" ;
lin catchall_N = mkTerm "catchall_N" ;
lin catcher_N = mkTerm "catcher_N" ;
lin catching_N = mkTerm "catching_N" ;
lin catchment_N = mkTerm "catchment_N" ;
lin catchment_area_N = mkTerm "catchment_area_N" ;
lin catchment_basin_N = mkTerm "catchment_basin_N" ;
lin catchpenny_A = mkTerm "catchpenny_A" ;
lin catchphrase_N = mkTerm "catchphrase_N" ;
lin catchup_N = mkTerm "catchup_N" ;
lin catchword_N = mkTerm "catchword_N" ;
lin catchy_A = mkTerm "catchy_A" ;
lin catechesis_N = mkTerm "catechesis_N" ;
lin catechetical_A = mkTerm "catechetical_A" ;
lin catechin_N = mkTerm "catechin_N" ;
lin catechism_N = mkTerm "catechism_N" ;
lin catechismal_A = mkTerm "catechismal_A" ;
lin catechist_N = mkTerm "catechist_N" ;
lin catechistic_A = mkTerm "catechistic_A" ;
lin catechize_V2 = mkTerm "catechize_V2" ;
lin catecholamine_N = mkTerm "catecholamine_N" ;
lin catechu_N = mkTerm "catechu_N" ;
lin catechumen_N = mkTerm "catechumen_N" ;
lin categorem_N = mkTerm "categorem_N" ;
lin categorematic_A = mkTerm "categorematic_A" ;
lin categorial_A = mkTerm "categorial_A" ;
lin categoric_A = mkTerm "categoric_A" ;
lin categorical_A = mkTerm "categorical_A" ;
lin categorization_N = mkTerm "categorization_N" ;
lin categorize_V2 = mkTerm "categorize_V2" ;
lin category_N = mkTerm "category_N" ;
lin catena_N = mkTerm "catena_N" ;
lin catenary_N = mkTerm "catenary_N" ;
lin catenulate_A = mkTerm "catenulate_A" ;
lin cater_V = mkTerm "cater_V" ;
lin cater_for_V2 = mkTerm "cater_for_V2" ;
lin cater_to_V2 = mkTerm "cater_to_V2" ;
lin caterer_N = mkTerm "caterer_N" ;
lin catering_N = mkTerm "catering_N" ;
lin caterpillar_N = mkTerm "caterpillar_N" ;
lin caterwaul_N = mkTerm "caterwaul_N" ;
lin caterwaul_V = mkTerm "caterwaul_V" ;
lin catfish_N = mkTerm "catfish_N" ;
lin catgut_N = mkTerm "catgut_N" ;
lin cath_PN = mkTerm "cath_PN" ;
lin catharsis_N = mkTerm "catharsis_N" ;
lin cathartic_A = mkTerm "cathartic_A" ;
lin cathartic_N = mkTerm "cathartic_N" ;
lin cathectic_A = mkTerm "cathectic_A" ;
lin cathedra_N = mkTerm "cathedra_N" ;
lin cathedral_A = mkTerm "cathedral_A" ;
lin cathedral_N = mkTerm "cathedral_N" ;
lin catherine_PN = mkTerm "catherine_PN" ;
lin catheter_N = mkTerm "catheter_N" ;
lin catheterization_N = mkTerm "catheterization_N" ;
lin cathexis_N = mkTerm "cathexis_N" ;
lin cathode_N = mkTerm "cathode_N" ;
lin cathodic_A = mkTerm "cathodic_A" ;
lin catholicFem_N = mkTerm "catholicFem_N" ;
lin catholicMasc_N = mkTerm "catholicMasc_N" ;
lin catholic_A = mkTerm "catholic_A" ;
lin catholicism_N = mkTerm "catholicism_N" ;
lin catholicity_N = mkTerm "catholicity_N" ;
lin cathy_PN = mkTerm "cathy_PN" ;
lin cation_N = mkTerm "cation_N" ;
lin cationic_A = mkTerm "cationic_A" ;
lin catkin_N = mkTerm "catkin_N" ;
lin catkinate_A = mkTerm "catkinate_A" ;
lin catling_N = mkTerm "catling_N" ;
lin catmint_N = mkTerm "catmint_N" ;
lin catoptric_A = mkTerm "catoptric_A" ;
lin catoptrics_N = mkTerm "catoptrics_N" ;
lin catostomid_N = mkTerm "catostomid_N" ;
lin catsup_N = mkTerm "catsup_N" ;
lin cattail_N = mkTerm "cattail_N" ;
lin cattalo_N = mkTerm "cattalo_N" ;
lin cattiness_N = mkTerm "cattiness_N" ;
lin cattish_A = mkTerm "cattish_A" ;
lin cattle_N = mkTerm "cattle_N" ;
lin cattle_cake_N = mkTerm "cattle_cake_N" ;
lin cattleman_N = mkTerm "cattleman_N" ;
lin cattleship_N = mkTerm "cattleship_N" ;
lin cattleya_N = mkTerm "cattleya_N" ;
lin catty_A = mkTerm "catty_A" ;
lin catty_N = mkTerm "catty_N" ;
lin catwalk_N = mkTerm "catwalk_N" ;
lin caucasianFem_N = mkTerm "caucasianFem_N" ;
lin caucasianMasc_N = mkTerm "caucasianMasc_N" ;
lin caucasian_A = mkTerm "caucasian_A" ;
lin caucus_N = mkTerm "caucus_N" ;
lin cauda_N = mkTerm "cauda_N" ;
lin caudal_A = mkTerm "caudal_A" ;
lin caudate_A = mkTerm "caudate_A" ;
lin caudex_N = mkTerm "caudex_N" ;
lin caul_N = mkTerm "caul_N" ;
lin cauldron_N = mkTerm "cauldron_N" ;
lin caulescent_A = mkTerm "caulescent_A" ;
lin cauliflower_N = mkTerm "cauliflower_N" ;
lin cauline_A = mkTerm "cauline_A" ;
lin caulk_N = mkTerm "caulk_N" ;
lin caulk_V2 = mkTerm "caulk_V2" ;
lin causal_A = mkTerm "causal_A" ;
lin causalgia_N = mkTerm "causalgia_N" ;
lin causality_N = mkTerm "causality_N" ;
lin causation_N = mkTerm "causation_N" ;
lin causative_A = mkTerm "causative_A" ;
lin cause_N = mkTerm "cause_N" ;
lin cause_V2 = mkTerm "cause_V2" ;
lin cause_V2V = mkTerm "cause_V2V" ;
lin causeless_A = mkTerm "causeless_A" ;
lin causerie_N = mkTerm "causerie_N" ;
lin causeway_N = mkTerm "causeway_N" ;
lin causing_N = mkTerm "causing_N" ;
lin caustic_A = mkTerm "caustic_A" ;
lin caustic_N = mkTerm "caustic_N" ;
lin cauterize_V2 = mkTerm "cauterize_V2" ;
lin cautery_N = mkTerm "cautery_N" ;
lin caution_N = mkTerm "caution_N" ;
lin caution_V = mkTerm "caution_V" ;
lin caution_V2 = mkTerm "caution_V2" ;
lin caution_V2V = mkTerm "caution_V2V" ;
lin caution_VS = mkTerm "caution_VS" ;
lin cautionary_A = mkTerm "cautionary_A" ;
lin cautious_A = mkTerm "cautious_A" ;
lin cavalcade_N = mkTerm "cavalcade_N" ;
lin cavalier_A = mkTerm "cavalier_A" ;
lin cavalier_N = mkTerm "cavalier_N" ;
lin cavalry_N = mkTerm "cavalry_N" ;
lin cavalryman_N = mkTerm "cavalryman_N" ;
lin cavan_PN = mkTerm "cavan_PN" ;
lin cave_N = mkTerm "cave_N" ;
lin cave_V = mkTerm "cave_V" ;
lin cave_V2 = mkTerm "cave_V2" ;
lin cave_dweller_N = mkTerm "cave_dweller_N" ;
lin cave_in_N = mkTerm "cave_in_N" ;
lin cave_in_V = mkTerm "cave_in_V" ;
lin caveat_N = mkTerm "caveat_N" ;
lin caveman_N = mkTerm "caveman_N" ;
lin cavern_N = mkTerm "cavern_N" ;
lin cavernous_A = mkTerm "cavernous_A" ;
lin cavetto_N = mkTerm "cavetto_N" ;
lin caviar_N = mkTerm "caviar_N" ;
lin cavil_V = mkTerm "cavil_V" ;
lin cavity_N = mkTerm "cavity_N" ;
lin cavort_V = mkTerm "cavort_V" ;
lin cavy_N = mkTerm "cavy_N" ;
lin caw_N = mkTerm "caw_N" ;
lin caw_V = mkTerm "caw_V" ;
lin caw_V2 = mkTerm "caw_V2" ;
lin cayenne_N = mkTerm "cayenne_N" ;
lin cayenne_pepper_N = mkTerm "cayenne_pepper_N" ;
lin cayman_N = mkTerm "cayman_N" ;
lin cayuse_N = mkTerm "cayuse_N" ;
lin cbi_N = mkTerm "cbi_N" ;
lin cc_N = mkTerm "cc_N" ;
lin cd_N = mkTerm "cd_N" ;
lin cdr_PN = mkTerm "cdr_PN" ;
lin cdre_PN = mkTerm "cdre_PN" ;
lin cease_N = mkTerm "cease_N" ;
lin cease_V = mkTerm "cease_V" ;
lin cease_V2 = mkTerm "cease_V2" ;
lin cease_fire_N = mkTerm "cease_fire_N" ;
lin ceasefire_N = mkTerm "ceasefire_N" ;
lin ceaseless_A = mkTerm "ceaseless_A" ;
lin cecal_A = mkTerm "cecal_A" ;
lin cecil_PN = mkTerm "cecil_PN" ;
lin cecilia_PN = mkTerm "cecilia_PN" ;
lin cecily_PN = mkTerm "cecily_PN" ;
lin cecropia_N = mkTerm "cecropia_N" ;
lin cecum_N = mkTerm "cecum_N" ;
lin cedar_N = mkTerm "cedar_N" ;
lin cedarn_A = mkTerm "cedarn_A" ;
lin cede_V2 = mkTerm "cede_V2" ;
lin cedi_N = mkTerm "cedi_N" ;
lin cedilla_N = mkTerm "cedilla_N" ;
lin cedric_PN = mkTerm "cedric_PN" ;
lin cefadroxil_N = mkTerm "cefadroxil_N" ;
lin cefn_mawr_PN = mkTerm "cefn_mawr_PN" ;
lin cefoperazone_N = mkTerm "cefoperazone_N" ;
lin cefotaxime_N = mkTerm "cefotaxime_N" ;
lin ceftazidime_N = mkTerm "ceftazidime_N" ;
lin ceftriaxone_N = mkTerm "ceftriaxone_N" ;
lin cefuroxime_N = mkTerm "cefuroxime_N" ;
lin ceibo_N = mkTerm "ceibo_N" ;
lin ceilidh_N = mkTerm "ceilidh_N" ;
lin ceiling_N = mkTerm "ceiling_N" ;
lin ceilinged_A = mkTerm "ceilinged_A" ;
lin celandine_N = mkTerm "celandine_N" ;
lin celebrant_N = mkTerm "celebrant_N" ;
lin celebrate_V2 = mkTerm "celebrate_V2" ;
lin celebrated_A = mkTerm "celebrated_A" ;
lin celebration_N = mkTerm "celebration_N" ;
lin celebratory_A = mkTerm "celebratory_A" ;
lin celebrity_N = mkTerm "celebrity_N" ;
lin celecoxib_N = mkTerm "celecoxib_N" ;
lin celeriac_N = mkTerm "celeriac_N" ;
lin celerity_N = mkTerm "celerity_N" ;
lin celery_N = mkTerm "celery_N" ;
lin celesta_N = mkTerm "celesta_N" ;
lin celestial_A = mkTerm "celestial_A" ;
lin celestite_N = mkTerm "celestite_N" ;
lin celia_PN = mkTerm "celia_PN" ;
lin celiac_A = mkTerm "celiac_A" ;
lin celibacy_N = mkTerm "celibacy_N" ;
lin celibate_A = mkTerm "celibate_A" ;
lin celibate_N = mkTerm "celibate_N" ;
lin celiocentesis_N = mkTerm "celiocentesis_N" ;
lin celioma_N = mkTerm "celioma_N" ;
lin celioscopy_N = mkTerm "celioscopy_N" ;
lin cell_N = mkTerm "cell_N" ;
lin cellar_N = mkTerm "cellar_N" ;
lin cellarage_N = mkTerm "cellarage_N" ;
lin cellblock_N = mkTerm "cellblock_N" ;
lin cellistFem_N = mkTerm "cellistFem_N" ;
lin cellistMasc_N = mkTerm "cellistMasc_N" ;
lin cello_N = mkTerm "cello_N" ;
lin cellophane_N = mkTerm "cellophane_N" ;
lin cellular_A = mkTerm "cellular_A" ;
lin cellularity_N = mkTerm "cellularity_N" ;
lin cellulite_N = mkTerm "cellulite_N" ;
lin cellulitis_N = mkTerm "cellulitis_N" ;
lin celluloid_A = mkTerm "celluloid_A" ;
lin celluloid_N = mkTerm "celluloid_N" ;
lin cellulose_N = mkTerm "cellulose_N" ;
lin cellulosic_N = mkTerm "cellulosic_N" ;
lin cellulosid_A = mkTerm "cellulosid_A" ;
lin celom_N = mkTerm "celom_N" ;
lin celt_N = mkTerm "celt_N" ;
lin celtic_A = mkTerm "celtic_A" ;
lin celtic_N = mkTerm "celtic_N" ;
lin celtuce_N = mkTerm "celtuce_N" ;
lin cement_N = mkTerm "cement_N" ;
lin cement_V2 = mkTerm "cement_V2" ;
lin cement_mixer_N = mkTerm "cement_mixer_N" ;
lin cementite_N = mkTerm "cementite_N" ;
lin cementitious_A = mkTerm "cementitious_A" ;
lin cementum_N = mkTerm "cementum_N" ;
lin cemetery_N = mkTerm "cemetery_N" ;
lin cenobite_N = mkTerm "cenobite_N" ;
lin cenobitic_A = mkTerm "cenobitic_A" ;
lin cenogenesis_N = mkTerm "cenogenesis_N" ;
lin cenogenetic_A = mkTerm "cenogenetic_A" ;
lin cenotaph_N = mkTerm "cenotaph_N" ;
lin censer_N = mkTerm "censer_N" ;
lin censor_N = mkTerm "censor_N" ;
lin censor_V2 = mkTerm "censor_V2" ;
lin censorial_A = mkTerm "censorial_A" ;
lin censoring_N = mkTerm "censoring_N" ;
lin censorious_A = mkTerm "censorious_A" ;
lin censorship_N = mkTerm "censorship_N" ;
lin censure_N = mkTerm "censure_N" ;
lin censure_V2 = mkTerm "censure_V2" ;
lin census_N = mkTerm "census_N" ;
lin cent_N = mkTerm "cent_N" ;
lin centas_N = mkTerm "centas_N" ;
lin centaur_N = mkTerm "centaur_N" ;
lin centaury_N = mkTerm "centaury_N" ;
lin centavo_N = mkTerm "centavo_N" ;
lin centenarian_A = mkTerm "centenarian_A" ;
lin centenarian_N = mkTerm "centenarian_N" ;
lin centenary_A = mkTerm "centenary_A" ;
lin centenary_N = mkTerm "centenary_N" ;
lin centennial_A = mkTerm "centennial_A" ;
lin centennial_N = mkTerm "centennial_N" ;
lin center_A = mkTerm "center_A" ;
lin centered_A = mkTerm "centered_A" ;
lin centerfold_N = mkTerm "centerfold_N" ;
lin centering_N = mkTerm "centering_N" ;
lin centerline_N = mkTerm "centerline_N" ;
lin centesimal_A = mkTerm "centesimal_A" ;
lin centesimo_N = mkTerm "centesimo_N" ;
lin centesis_N = mkTerm "centesis_N" ;
lin centigrade_A = mkTerm "centigrade_A" ;
lin centiliter_N = mkTerm "centiliter_N" ;
lin centime_N = mkTerm "centime_N" ;
lin centimetre_N = mkTerm "centimetre_N" ;
lin centimo_N = mkTerm "centimo_N" ;
lin centipede_N = mkTerm "centipede_N" ;
lin centner_N = mkTerm "centner_N" ;
lin central_A = mkTerm "central_A" ;
lin central_N = mkTerm "central_N" ;
lin centralism_N = mkTerm "centralism_N" ;
lin centralist_A = mkTerm "centralist_A" ;
lin centrality_N = mkTerm "centrality_N" ;
lin centralization_N = mkTerm "centralization_N" ;
lin centralize_V = mkTerm "centralize_V" ;
lin centralize_V2 = mkTerm "centralize_V2" ;
lin centre_N = mkTerm "centre_N" ;
lin centre_V = mkTerm "centre_V" ;
lin centre_V2 = mkTerm "centre_V2" ;
lin centre_bit_N = mkTerm "centre_bit_N" ;
lin centre_board_N = mkTerm "centre_board_N" ;
lin centrepiece_N = mkTerm "centrepiece_N" ;
lin centrex_N = mkTerm "centrex_N" ;
lin centric_A = mkTerm "centric_A" ;
lin centrifugal_A = mkTerm "centrifugal_A" ;
lin centrifugation_N = mkTerm "centrifugation_N" ;
lin centrifuge_N = mkTerm "centrifuge_N" ;
lin centriole_N = mkTerm "centriole_N" ;
lin centripetal_A = mkTerm "centripetal_A" ;
lin centrism_N = mkTerm "centrism_N" ;
lin centrist_A = mkTerm "centrist_A" ;
lin centrist_N = mkTerm "centrist_N" ;
lin centroid_N = mkTerm "centroid_N" ;
lin centroidal_A = mkTerm "centroidal_A" ;
lin centromere_N = mkTerm "centromere_N" ;
lin centromeric_A = mkTerm "centromeric_A" ;
lin centrosome_N = mkTerm "centrosome_N" ;
lin centrosomic_A = mkTerm "centrosomic_A" ;
lin centrum_N = mkTerm "centrum_N" ;
lin centurion_N = mkTerm "centurion_N" ;
lin century_N = mkTerm "century_N" ;
lin cephalexin_N = mkTerm "cephalexin_N" ;
lin cephalhematoma_N = mkTerm "cephalhematoma_N" ;
lin cephalic_A = mkTerm "cephalic_A" ;
lin cephalochordate_N = mkTerm "cephalochordate_N" ;
lin cephaloglycin_N = mkTerm "cephaloglycin_N" ;
lin cephalometry_N = mkTerm "cephalometry_N" ;
lin cephalopod_A = mkTerm "cephalopod_A" ;
lin cephalopod_N = mkTerm "cephalopod_N" ;
lin cephaloridine_N = mkTerm "cephaloridine_N" ;
lin cephalosporin_N = mkTerm "cephalosporin_N" ;
lin cephalothin_N = mkTerm "cephalothin_N" ;
lin ceramic_A = mkTerm "ceramic_A" ;
lin ceramic_N = mkTerm "ceramic_N" ;
lin ceramics_N = mkTerm "ceramics_N" ;
lin ceras_N = mkTerm "ceras_N" ;
lin cerate_N = mkTerm "cerate_N" ;
lin ceratodus_N = mkTerm "ceratodus_N" ;
lin ceratopsian_N = mkTerm "ceratopsian_N" ;
lin ceratosaur_N = mkTerm "ceratosaur_N" ;
lin ceratozamia_N = mkTerm "ceratozamia_N" ;
lin cercaria_N = mkTerm "cercaria_N" ;
lin cercarial_A = mkTerm "cercarial_A" ;
lin cere_N = mkTerm "cere_N" ;
lin cereal_A = mkTerm "cereal_A" ;
lin cereal_N = mkTerm "cereal_N" ;
lin cerebellar_A = mkTerm "cerebellar_A" ;
lin cerebellum_N = mkTerm "cerebellum_N" ;
lin cerebral_A = mkTerm "cerebral_A" ;
lin cerebration_N = mkTerm "cerebration_N" ;
lin cerebrospinal_A = mkTerm "cerebrospinal_A" ;
lin cerebrovascular_A = mkTerm "cerebrovascular_A" ;
lin cerebrum_N = mkTerm "cerebrum_N" ;
lin cerecloth_N = mkTerm "cerecloth_N" ;
lin ceremonial_A = mkTerm "ceremonial_A" ;
lin ceremonial_N = mkTerm "ceremonial_N" ;
lin ceremonious_A = mkTerm "ceremonious_A" ;
lin ceremoniousness_N = mkTerm "ceremoniousness_N" ;
lin ceremony_N = mkTerm "ceremony_N" ;
lin ceresin_N = mkTerm "ceresin_N" ;
lin ceric_A = mkTerm "ceric_A" ;
lin ceriman_N = mkTerm "ceriman_N" ;
lin cerise_A = mkTerm "cerise_A" ;
lin cerise_N = mkTerm "cerise_N" ;
lin cerium_N = mkTerm "cerium_N" ;
lin cerivastatin_N = mkTerm "cerivastatin_N" ;
lin cernuous_A = mkTerm "cernuous_A" ;
lin cero_N = mkTerm "cero_N" ;
lin cerous_A = mkTerm "cerous_A" ;
lin cert_N = mkTerm "cert_N" ;
lin certain_1_A = mkTerm "certain_1_A" ;
lin certain_2_A = mkTerm "certain_2_A" ;
lin certainty_N = mkTerm "certainty_N" ;
lin certifiable_A = mkTerm "certifiable_A" ;
lin certificate_N = mkTerm "certificate_N" ;
lin certificate_V2 = mkTerm "certificate_V2" ;
lin certification_N = mkTerm "certification_N" ;
lin certificatory_A = mkTerm "certificatory_A" ;
lin certified_A = mkTerm "certified_A" ;
lin certify_V = mkTerm "certify_V" ;
lin certify_V2 = mkTerm "certify_V2" ;
lin certiorari_N = mkTerm "certiorari_N" ;
lin certitude_N = mkTerm "certitude_N" ;
lin cerulean_A = mkTerm "cerulean_A" ;
lin cerumen_N = mkTerm "cerumen_N" ;
lin ceruminous_A = mkTerm "ceruminous_A" ;
lin cerussite_N = mkTerm "cerussite_N" ;
lin cervical_A = mkTerm "cervical_A" ;
lin cervicitis_N = mkTerm "cervicitis_N" ;
lin cervine_A = mkTerm "cervine_A" ;
lin cervix_N = mkTerm "cervix_N" ;
lin cesarean_A = mkTerm "cesarean_A" ;
lin cesium_N = mkTerm "cesium_N" ;
lin cessation_N = mkTerm "cessation_N" ;
lin cession_N = mkTerm "cession_N" ;
lin cesspit_N = mkTerm "cesspit_N" ;
lin cesspool_N = mkTerm "cesspool_N" ;
lin cetacean_A = mkTerm "cetacean_A" ;
lin cetacean_N = mkTerm "cetacean_N" ;
lin cetrimide_N = mkTerm "cetrimide_N" ;
lin ceylon_PN = mkTerm "ceylon_PN" ;
lin cf_PN = mkTerm "cf_PN" ;
lin cf__Adv = mkTerm "cf__Adv" ;
lin cgs_N = mkTerm "cgs_N" ;
lin chabazite_N = mkTerm "chabazite_N" ;
lin chachalaca_N = mkTerm "chachalaca_N" ;
lin chachka_N = mkTerm "chachka_N" ;
lin chacma_N = mkTerm "chacma_N" ;
lin chad_N = mkTerm "chad_N" ;
lin chad_PN = mkTerm "chad_PN" ;
lin chadian_A = mkTerm "chadian_A" ;
lin chadian_N = mkTerm "chadian_N" ;
lin chador_N = mkTerm "chador_N" ;
lin chaenactis_N = mkTerm "chaenactis_N" ;
lin chaeta_N = mkTerm "chaeta_N" ;
lin chaetal_A = mkTerm "chaetal_A" ;
lin chaetodon_N = mkTerm "chaetodon_N" ;
lin chaetognathan_A = mkTerm "chaetognathan_A" ;
lin chafe_N = mkTerm "chafe_N" ;
lin chafe_V = mkTerm "chafe_V" ;
lin chafe_V2 = mkTerm "chafe_V2" ;
lin chafeweed_N = mkTerm "chafeweed_N" ;
lin chaff_N = mkTerm "chaff_N" ;
lin chaff_V2 = mkTerm "chaff_V2" ;
lin chaffinch_N = mkTerm "chaffinch_N" ;
lin chaffweed_N = mkTerm "chaffweed_N" ;
lin chaffy_A = mkTerm "chaffy_A" ;
lin chafing_N = mkTerm "chafing_N" ;
lin chafing_dish_N = mkTerm "chafing_dish_N" ;
lin chagrin_N = mkTerm "chagrin_N" ;
lin chagrin_V2 = mkTerm "chagrin_V2" ;
lin chain_N = mkTerm "chain_N" ;
lin chain_V2 = mkTerm "chain_V2" ;
lin chain_armour_N = mkTerm "chain_armour_N" ;
lin chain_gang_N = mkTerm "chain_gang_N" ;
lin chain_letter_N = mkTerm "chain_letter_N" ;
lin chain_mail_N = mkTerm "chain_mail_N" ;
lin chain_smoker_N = mkTerm "chain_smoker_N" ;
lin chain_stitch_N = mkTerm "chain_stitch_N" ;
lin chain_store_N = mkTerm "chain_store_N" ;
lin chair_N = mkTerm "chair_N" ;
lin chair_V2 = mkTerm "chair_V2" ;
lin chair_lift_N = mkTerm "chair_lift_N" ;
lin chairman_N = mkTerm "chairman_N" ;
lin chairmanship_N = mkTerm "chairmanship_N" ;
lin chaise_N = mkTerm "chaise_N" ;
lin chaise_longue_N = mkTerm "chaise_longue_N" ;
lin chaja_N = mkTerm "chaja_N" ;
lin chalaza_N = mkTerm "chalaza_N" ;
lin chalazion_N = mkTerm "chalazion_N" ;
lin chalcedony_N = mkTerm "chalcedony_N" ;
lin chalcocite_N = mkTerm "chalcocite_N" ;
lin chalcopyrite_N = mkTerm "chalcopyrite_N" ;
lin chaldron_N = mkTerm "chaldron_N" ;
lin chalet_N = mkTerm "chalet_N" ;
lin chalfont_PN = mkTerm "chalfont_PN" ;
lin chalfont_st_giles_PN = mkTerm "chalfont_st_giles_PN" ;
lin chalfont_st_peter_PN = mkTerm "chalfont_st_peter_PN" ;
lin chalice_N = mkTerm "chalice_N" ;
lin chalk_N = mkTerm "chalk_N" ;
lin chalk_V2 = mkTerm "chalk_V2" ;
lin chalk_out_V2 = mkTerm "chalk_out_V2" ;
lin chalk_up_V2 = mkTerm "chalk_up_V2" ;
lin chalk_up_to_V3 = mkTerm "chalk_up_to_V3" ;
lin chalkpit_N = mkTerm "chalkpit_N" ;
lin chalky_A = mkTerm "chalky_A" ;
lin challah_N = mkTerm "challah_N" ;
lin challenge_N = mkTerm "challenge_N" ;
lin challenge_V = mkTerm "challenge_V" ;
lin challenge_V2 = mkTerm "challenge_V2" ;
lin challengeable_A = mkTerm "challengeable_A" ;
lin challenger_N = mkTerm "challenger_N" ;
lin challis_N = mkTerm "challis_N" ;
lin chalybeate_A = mkTerm "chalybeate_A" ;
lin chamber_N = mkTerm "chamber_N" ;
lin chambered_A = mkTerm "chambered_A" ;
lin chamberlain_N = mkTerm "chamberlain_N" ;
lin chambermaid_N = mkTerm "chambermaid_N" ;
lin chamberpot_N = mkTerm "chamberpot_N" ;
lin chambray_N = mkTerm "chambray_N" ;
lin chameleon_N = mkTerm "chameleon_N" ;
lin chammy_leather_N = mkTerm "chammy_leather_N" ;
lin chamois_N = mkTerm "chamois_N" ;
lin chamois_leather_N = mkTerm "chamois_leather_N" ;
lin chamosite_N = mkTerm "chamosite_N" ;
lin champ_N = mkTerm "champ_N" ;
lin champ_V = mkTerm "champ_V" ;
lin champ_V2 = mkTerm "champ_V2" ;
lin champagne_N = mkTerm "champagne_N" ;
lin champerty_N = mkTerm "champerty_N" ;
lin champion_A = mkTerm "champion_A" ;
lin champion_Adv = mkTerm "champion_Adv" ;
lin champion_N = mkTerm "champion_N" ;
lin champion_V2 = mkTerm "champion_V2" ;
lin championship_N = mkTerm "championship_N" ;
lin champleve_A = mkTerm "champleve_A" ;
lin chanar_N = mkTerm "chanar_N" ;
lin chance_N = mkTerm "chance_N" ;
lin chance_V = mkTerm "chance_V" ;
lin chance_V2 = mkTerm "chance_V2" ;
lin chance_upon_V2 = mkTerm "chance_upon_V2" ;
lin chancel_N = mkTerm "chancel_N" ;
lin chancellery_N = mkTerm "chancellery_N" ;
lin chancellor_N = mkTerm "chancellor_N" ;
lin chancellorship_N = mkTerm "chancellorship_N" ;
lin chancery_N = mkTerm "chancery_N" ;
lin chancre_N = mkTerm "chancre_N" ;
lin chancroid_N = mkTerm "chancroid_N" ;
lin chancroidal_A = mkTerm "chancroidal_A" ;
lin chancrous_A = mkTerm "chancrous_A" ;
lin chancy_A = mkTerm "chancy_A" ;
lin chandelier_N = mkTerm "chandelier_N" ;
lin chandelle_N = mkTerm "chandelle_N" ;
lin chandler_N = mkTerm "chandler_N" ;
lin chandlery_N = mkTerm "chandlery_N" ;
lin chanfron_N = mkTerm "chanfron_N" ;
lin changchun_PN = mkTerm "changchun_PN" ;
lin change_N = mkTerm "change_N" ;
lin change_V = mkTerm "change_V" ;
lin change_V2 = mkTerm "change_V2" ;
lin change_over_V2 = mkTerm "change_over_V2" ;
lin changeable_A = mkTerm "changeable_A" ;
lin changeableness_N = mkTerm "changeableness_N" ;
lin changeful_A = mkTerm "changeful_A" ;
lin changeless_A = mkTerm "changeless_A" ;
lin changelessness_N = mkTerm "changelessness_N" ;
lin changeling_N = mkTerm "changeling_N" ;
lin changeover_N = mkTerm "changeover_N" ;
lin changer_N = mkTerm "changer_N" ;
lin changing_A = mkTerm "changing_A" ;
lin changsha_PN = mkTerm "changsha_PN" ;
lin channel_N = mkTerm "channel_N" ;
lin channel_V2 = mkTerm "channel_V2" ;
lin channelization_N = mkTerm "channelization_N" ;
lin channels_N = mkTerm "channels_N" ;
lin chant_N = mkTerm "chant_N" ;
lin chant_V = mkTerm "chant_V" ;
lin chant_V2 = mkTerm "chant_V2" ;
lin chanter_N = mkTerm "chanter_N" ;
lin chanterelle_N = mkTerm "chanterelle_N" ;
lin chantey_N = mkTerm "chantey_N" ;
lin chantlike_A = mkTerm "chantlike_A" ;
lin chantry_N = mkTerm "chantry_N" ;
lin chaos_N = mkTerm "chaos_N" ;
lin chaotic_A = mkTerm "chaotic_A" ;
lin chap_N = mkTerm "chap_N" ;
lin chap_V = mkTerm "chap_V" ;
lin chap_V2 = mkTerm "chap_V2" ;
lin chapatti_N = mkTerm "chapatti_N" ;
lin chapel_N = mkTerm "chapel_N" ;
lin chapelgoer_N = mkTerm "chapelgoer_N" ;
lin chaperon_N = mkTerm "chaperon_N" ;
lin chaperon_V2 = mkTerm "chaperon_V2" ;
lin chapfallen_A = mkTerm "chapfallen_A" ;
lin chaplain_N = mkTerm "chaplain_N" ;
lin chaplaincy_N = mkTerm "chaplaincy_N" ;
lin chaplet_N = mkTerm "chaplet_N" ;
lin chapleted_A = mkTerm "chapleted_A" ;
lin chapman_N = mkTerm "chapman_N" ;
lin chapter_N = mkTerm "chapter_N" ;
lin chapterhouse_N = mkTerm "chapterhouse_N" ;
lin char_N = mkTerm "char_N" ;
lin char_V = mkTerm "char_V" ;
lin char_V2 = mkTerm "char_V2" ;
lin charabanc_N = mkTerm "charabanc_N" ;
lin characin_N = mkTerm "characin_N" ;
lin character_1_N = mkTerm "character_1_N" ;
lin character_2_N = mkTerm "character_2_N" ;
lin characteristic_A = mkTerm "characteristic_A" ;
lin characteristic_N = mkTerm "characteristic_N" ;
lin characterization_N = mkTerm "characterization_N" ;
lin characterize_V2 = mkTerm "characterize_V2" ;
lin characterless_A = mkTerm "characterless_A" ;
lin charade_N = mkTerm "charade_N" ;
lin charades_N = mkTerm "charades_N" ;
lin charcoal_A = mkTerm "charcoal_A" ;
lin charcoal_N = mkTerm "charcoal_N" ;
lin charcoal_burner_N = mkTerm "charcoal_burner_N" ;
lin charcuterie_N = mkTerm "charcuterie_N" ;
lin chard_N = mkTerm "chard_N" ;
lin chard_PN = mkTerm "chard_PN" ;
lin charge_1_N = mkTerm "charge_1_N" ;
lin charge_2_N = mkTerm "charge_2_N" ;
lin charge_V = mkTerm "charge_V" ;
lin charge_V2 = mkTerm "charge_V2" ;
lin charge_account_N = mkTerm "charge_account_N" ;
lin charge_d'affaires_N = mkTerm "charge_d'affaires_N" ;
lin charge_off_V = mkTerm "charge_off_V" ;
lin charge_sheet_N = mkTerm "charge_sheet_N" ;
lin charge_up_V2 = mkTerm "charge_up_V2" ;
lin charge_with_V3 = mkTerm "charge_with_V3" ;
lin chargeable_A = mkTerm "chargeable_A" ;
lin charger_N = mkTerm "charger_N" ;
lin chariot_N = mkTerm "chariot_N" ;
lin charioteer_N = mkTerm "charioteer_N" ;
lin charisma_N = mkTerm "charisma_N" ;
lin charismatic_A = mkTerm "charismatic_A" ;
lin charitable_A = mkTerm "charitable_A" ;
lin charitableness_N = mkTerm "charitableness_N" ;
lin charity_N = mkTerm "charity_N" ;
lin charivari_N = mkTerm "charivari_N" ;
lin charlady_N = mkTerm "charlady_N" ;
lin charlatan_N = mkTerm "charlatan_N" ;
lin charlatanism_N = mkTerm "charlatanism_N" ;
lin charles_PN = mkTerm "charles_PN" ;
lin charleston_N = mkTerm "charleston_N" ;
lin charlie_PN = mkTerm "charlie_PN" ;
lin charlock_N = mkTerm "charlock_N" ;
lin charlotte_N = mkTerm "charlotte_N" ;
lin charlotte_PN = mkTerm "charlotte_PN" ;
lin charm_N = mkTerm "charm_N" ;
lin charm_V = mkTerm "charm_V" ;
lin charm_V2 = mkTerm "charm_V2" ;
lin charmer_N = mkTerm "charmer_N" ;
lin charming_A = mkTerm "charming_A" ;
lin charnel_A = mkTerm "charnel_A" ;
lin charnel_house_N = mkTerm "charnel_house_N" ;
lin chart_N = mkTerm "chart_N" ;
lin chart_V2 = mkTerm "chart_V2" ;
lin chartaceous_A = mkTerm "chartaceous_A" ;
lin charter_N = mkTerm "charter_N" ;
lin charter_V2 = mkTerm "charter_V2" ;
lin charter_party_N = mkTerm "charter_party_N" ;
lin charterhouse_N = mkTerm "charterhouse_N" ;
lin chartism_N = mkTerm "chartism_N" ;
lin chartist_N = mkTerm "chartist_N" ;
lin chartless_A = mkTerm "chartless_A" ;
lin chartreuse_A = mkTerm "chartreuse_A" ;
lin chartreuse_N = mkTerm "chartreuse_N" ;
lin charwoman_N = mkTerm "charwoman_N" ;
lin chary_A = mkTerm "chary_A" ;
lin charybdis_PN = mkTerm "charybdis_PN" ;
lin chas_PN = mkTerm "chas_PN" ;
lin chase_N = mkTerm "chase_N" ;
lin chase_V = mkTerm "chase_V" ;
lin chase_V2 = mkTerm "chase_V2" ;
lin chase_down_V2 = mkTerm "chase_down_V2" ;
lin chase_off_V2 = mkTerm "chase_off_V2" ;
lin chase_up_V2 = mkTerm "chase_up_V2" ;
lin chaser_N = mkTerm "chaser_N" ;
lin chasm_N = mkTerm "chasm_N" ;
lin chasse_N = mkTerm "chasse_N" ;
lin chassis_N = mkTerm "chassis_N" ;
lin chaste_A = mkTerm "chaste_A" ;
lin chasten_V2 = mkTerm "chasten_V2" ;
lin chasteness_N = mkTerm "chasteness_N" ;
lin chastise_V2 = mkTerm "chastise_V2" ;
lin chastisement_N = mkTerm "chastisement_N" ;
lin chastity_N = mkTerm "chastity_N" ;
lin chasuble_N = mkTerm "chasuble_N" ;
lin chat_N = mkTerm "chat_N" ;
lin chat_V = mkTerm "chat_V" ;
lin chat_up_V2 = mkTerm "chat_up_V2" ;
lin chateau_N = mkTerm "chateau_N" ;
lin chatelaine_N = mkTerm "chatelaine_N" ;
lin chatham_PN = mkTerm "chatham_PN" ;
lin chattel_N = mkTerm "chattel_N" ;
lin chatter_N = mkTerm "chatter_N" ;
lin chatter_V = mkTerm "chatter_V" ;
lin chatterbox_N = mkTerm "chatterbox_N" ;
lin chatterer_N = mkTerm "chatterer_N" ;
lin chatty_A = mkTerm "chatty_A" ;
lin chauffeur_N = mkTerm "chauffeur_N" ;
lin chauffeur_V2 = mkTerm "chauffeur_V2" ;
lin chauffeuse_N = mkTerm "chauffeuse_N" ;
lin chaulmoogra_N = mkTerm "chaulmoogra_N" ;
lin chauvinism_N = mkTerm "chauvinism_N" ;
lin chauvinist_N = mkTerm "chauvinist_N" ;
lin chauvinistic_A = mkTerm "chauvinistic_A" ;
lin chaw_N = mkTerm "chaw_N" ;
lin chaw_V2 = mkTerm "chaw_V2" ;
lin chaw_bacon_N = mkTerm "chaw_bacon_N" ;
lin cheadle_PN = mkTerm "cheadle_PN" ;
lin cheap_A = mkTerm "cheap_A" ;
lin cheapen_V = mkTerm "cheapen_V" ;
lin cheapen_V2 = mkTerm "cheapen_V2" ;
lin cheapjack_A = mkTerm "cheapjack_A" ;
lin cheapjack_N = mkTerm "cheapjack_N" ;
lin cheapness_N = mkTerm "cheapness_N" ;
lin cheapskate_N = mkTerm "cheapskate_N" ;
lin cheat_N = mkTerm "cheat_N" ;
lin cheat_V = mkTerm "cheat_V" ;
lin cheat_V2 = mkTerm "cheat_V2" ;
lin cheat_on_V2 = mkTerm "cheat_on_V2" ;
lin cheat_out_of_V3 = mkTerm "cheat_out_of_V3" ;
lin chebab_N = mkTerm "chebab_N" ;
lin check_N = mkTerm "check_N" ;
lin check_V = mkTerm "check_V" ;
lin check_V2 = mkTerm "check_V2" ;
lin check_back_V = mkTerm "check_back_V" ;
lin check_by_V2 = mkTerm "check_by_V2" ;
lin check_for_V2 = mkTerm "check_for_V2" ;
lin check_in_V = mkTerm "check_in_V" ;
lin check_in_V2 = mkTerm "check_in_V2" ;
lin check_into_V2 = mkTerm "check_into_V2" ;
lin check_off_V2 = mkTerm "check_off_V2" ;
lin check_on_V2 = mkTerm "check_on_V2" ;
lin check_out_V = mkTerm "check_out_V" ;
lin check_out_V2 = mkTerm "check_out_V2" ;
lin check_out_of_V2 = mkTerm "check_out_of_V2" ;
lin check_over_V2 = mkTerm "check_over_V2" ;
lin check_through_V2 = mkTerm "check_through_V2" ;
lin check_up_on_V2 = mkTerm "check_up_on_V2" ;
lin check_with_V2 = mkTerm "check_with_V2" ;
lin checkbook_N = mkTerm "checkbook_N" ;
lin checker_N = mkTerm "checker_N" ;
lin checker_V2 = mkTerm "checker_V2" ;
lin checkerbloom_N = mkTerm "checkerbloom_N" ;
lin checkerboard_N = mkTerm "checkerboard_N" ;
lin checkers_N = mkTerm "checkers_N" ;
lin checklist_N = mkTerm "checklist_N" ;
lin checkmate_N = mkTerm "checkmate_N" ;
lin checkmate_V2 = mkTerm "checkmate_V2" ;
lin checkout_N = mkTerm "checkout_N" ;
lin checkpoint_N = mkTerm "checkpoint_N" ;
lin checkroom_N = mkTerm "checkroom_N" ;
lin checksum_N = mkTerm "checksum_N" ;
lin checkup_N = mkTerm "checkup_N" ;
lin cheddar_N = mkTerm "cheddar_N" ;
lin cheek_N = mkTerm "cheek_N" ;
lin cheek_V2 = mkTerm "cheek_V2" ;
lin cheekbone_N = mkTerm "cheekbone_N" ;
lin cheekpiece_N = mkTerm "cheekpiece_N" ;
lin cheeky_A = mkTerm "cheeky_A" ;
lin cheep_N = mkTerm "cheep_N" ;
lin cheep_V = mkTerm "cheep_V" ;
lin cheer_N = mkTerm "cheer_N" ;
lin cheer_V = mkTerm "cheer_V" ;
lin cheer_V2 = mkTerm "cheer_V2" ;
lin cheer_on_V2 = mkTerm "cheer_on_V2" ;
lin cheer_up_V = mkTerm "cheer_up_V" ;
lin cheer_up_V2 = mkTerm "cheer_up_V2" ;
lin cheerer_N = mkTerm "cheerer_N" ;
lin cheerful_A = mkTerm "cheerful_A" ;
lin cheerfulness_N = mkTerm "cheerfulness_N" ;
lin cheering_N = mkTerm "cheering_N" ;
lin cheerleader_N = mkTerm "cheerleader_N" ;
lin cheerless_A = mkTerm "cheerless_A" ;
lin cheerlessness_N = mkTerm "cheerlessness_N" ;
lin cheers_Interj = mkTerm "cheers_Interj" ;
lin cheery_A = mkTerm "cheery_A" ;
lin cheese_N = mkTerm "cheese_N" ;
lin cheeseboard_N = mkTerm "cheeseboard_N" ;
lin cheeseburger_N = mkTerm "cheeseburger_N" ;
lin cheesecake_N = mkTerm "cheesecake_N" ;
lin cheesecloth_N = mkTerm "cheesecloth_N" ;
lin cheeselike_A = mkTerm "cheeselike_A" ;
lin cheesemonger_N = mkTerm "cheesemonger_N" ;
lin cheeseparing_A = mkTerm "cheeseparing_A" ;
lin cheetah_N = mkTerm "cheetah_N" ;
lin chef_N = mkTerm "chef_N" ;
lin chef_d'oeuvre_N = mkTerm "chef_d'oeuvre_N" ;
lin cheilitis_N = mkTerm "cheilitis_N" ;
lin cheilosis_N = mkTerm "cheilosis_N" ;
lin chela_N = mkTerm "chela_N" ;
lin chelate_A = mkTerm "chelate_A" ;
lin chelate_N = mkTerm "chelate_N" ;
lin chelation_N = mkTerm "chelation_N" ;
lin chelicera_N = mkTerm "chelicera_N" ;
lin cheliceral_A = mkTerm "cheliceral_A" ;
lin chelicerous_A = mkTerm "chelicerous_A" ;
lin cheliferous_A = mkTerm "cheliferous_A" ;
lin chelmsford_PN = mkTerm "chelmsford_PN" ;
lin chelonian_A = mkTerm "chelonian_A" ;
lin chelonian_N = mkTerm "chelonian_N" ;
lin chelsea_PN = mkTerm "chelsea_PN" ;
lin cheltenham_PN = mkTerm "cheltenham_PN" ;
lin chelyabinsk_PN = mkTerm "chelyabinsk_PN" ;
lin chemical_A = mkTerm "chemical_A" ;
lin chemical_N = mkTerm "chemical_N" ;
lin chemiluminescence_N = mkTerm "chemiluminescence_N" ;
lin chemiluminescent_A = mkTerm "chemiluminescent_A" ;
lin chemise_N = mkTerm "chemise_N" ;
lin chemisorption_N = mkTerm "chemisorption_N" ;
lin chemisorptive_A = mkTerm "chemisorptive_A" ;
lin chemistFem_N = mkTerm "chemistFem_N" ;
lin chemistMasc_N = mkTerm "chemistMasc_N" ;
lin chemistry_N = mkTerm "chemistry_N" ;
lin chemoreceptive_A = mkTerm "chemoreceptive_A" ;
lin chemoreceptor_N = mkTerm "chemoreceptor_N" ;
lin chemosis_N = mkTerm "chemosis_N" ;
lin chemosurgery_N = mkTerm "chemosurgery_N" ;
lin chemosynthesis_N = mkTerm "chemosynthesis_N" ;
lin chemotaxis_N = mkTerm "chemotaxis_N" ;
lin chemotherapeutic_A = mkTerm "chemotherapeutic_A" ;
lin chemotherapy_N = mkTerm "chemotherapy_N" ;
lin chengchow_PN = mkTerm "chengchow_PN" ;
lin chengtu_PN = mkTerm "chengtu_PN" ;
lin chenille_N = mkTerm "chenille_N" ;
lin chepstow_PN = mkTerm "chepstow_PN" ;
lin cheque_N = mkTerm "cheque_N" ;
lin chequebook_N = mkTerm "chequebook_N" ;
lin chequer_V2 = mkTerm "chequer_V2" ;
lin cherimoya_N = mkTerm "cherimoya_N" ;
lin cherish_V2 = mkTerm "cherish_V2" ;
lin cheroot_N = mkTerm "cheroot_N" ;
lin cherry_A = mkTerm "cherry_A" ;
lin cherry_N = mkTerm "cherry_N" ;
lin cherrystone_N = mkTerm "cherrystone_N" ;
lin chert_N = mkTerm "chert_N" ;
lin cherty_A = mkTerm "cherty_A" ;
lin cherub_N = mkTerm "cherub_N" ;
lin cherubic_A = mkTerm "cherubic_A" ;
lin chervil_N = mkTerm "chervil_N" ;
lin chesham_PN = mkTerm "chesham_PN" ;
lin cheshire_PN = mkTerm "cheshire_PN" ;
lin chess_N = mkTerm "chess_N" ;
lin chessboard_N = mkTerm "chessboard_N" ;
lin chessman_N = mkTerm "chessman_N" ;
lin chest_N = mkTerm "chest_N" ;
lin chester_PN = mkTerm "chester_PN" ;
lin chester_le_street_PN = mkTerm "chester_le_street_PN" ;
lin chesterfield_N = mkTerm "chesterfield_N" ;
lin chesterfield_PN = mkTerm "chesterfield_PN" ;
lin chestnut_A = mkTerm "chestnut_A" ;
lin chestnut_N = mkTerm "chestnut_N" ;
lin chetrum_N = mkTerm "chetrum_N" ;
lin cheval_glass_N = mkTerm "cheval_glass_N" ;
lin chevron_N = mkTerm "chevron_N" ;
lin chevrotain_N = mkTerm "chevrotain_N" ;
lin chew_N = mkTerm "chew_N" ;
lin chew_V = mkTerm "chew_V" ;
lin chew_V2 = mkTerm "chew_V2" ;
lin chew_off_V2 = mkTerm "chew_off_V2" ;
lin chew_on_V2 = mkTerm "chew_on_V2" ;
lin chew_out_V2 = mkTerm "chew_out_V2" ;
lin chew_over_V2 = mkTerm "chew_over_V2" ;
lin chew_up_V2 = mkTerm "chew_up_V2" ;
lin chewable_A = mkTerm "chewable_A" ;
lin chewer_N = mkTerm "chewer_N" ;
lin chewing_gum_N = mkTerm "chewing_gum_N" ;
lin chewink_N = mkTerm "chewink_N" ;
lin chewy_A = mkTerm "chewy_A" ;
lin chez_Prep = mkTerm "chez_Prep" ;
lin chi_N = mkTerm "chi_N" ;
lin chianti_N = mkTerm "chianti_N" ;
lin chiaroscuro_N = mkTerm "chiaroscuro_N" ;
lin chiasma_N = mkTerm "chiasma_N" ;
lin chiasmal_A = mkTerm "chiasmal_A" ;
lin chiasmus_N = mkTerm "chiasmus_N" ;
lin chic_A = mkTerm "chic_A" ;
lin chic_N = mkTerm "chic_N" ;
lin chicago_PN = mkTerm "chicago_PN" ;
lin chicane_N = mkTerm "chicane_N" ;
lin chicanery_N = mkTerm "chicanery_N" ;
lin chichester_PN = mkTerm "chichester_PN" ;
lin chichi_A = mkTerm "chichi_A" ;
lin chichi_N = mkTerm "chichi_N" ;
lin chichipe_N = mkTerm "chichipe_N" ;
lin chick_N = mkTerm "chick_N" ;
lin chickadee_N = mkTerm "chickadee_N" ;
lin chicken_A = mkTerm "chicken_A" ;
lin chicken_N = mkTerm "chicken_N" ;
lin chicken_hearted_A = mkTerm "chicken_hearted_A" ;
lin chicken_out_V = mkTerm "chicken_out_V" ;
lin chicken_run_N = mkTerm "chicken_run_N" ;
lin chickenfeed_N = mkTerm "chickenfeed_N" ;
lin chickenpox_N = mkTerm "chickenpox_N" ;
lin chickenshit_N = mkTerm "chickenshit_N" ;
lin chickeree_N = mkTerm "chickeree_N" ;
lin chickpea_N = mkTerm "chickpea_N" ;
lin chickweed_N = mkTerm "chickweed_N" ;
lin chicle_N = mkTerm "chicle_N" ;
lin chicory_N = mkTerm "chicory_N" ;
lin chide_V = mkTerm "chide_V" ;
lin chide_V2 = mkTerm "chide_V2" ;
lin chiding_N = mkTerm "chiding_N" ;
lin chief_A = mkTerm "chief_A" ;
lin chief_N = mkTerm "chief_N" ;
lin chieftainFem_N = mkTerm "chieftainFem_N" ;
lin chieftainMasc_N = mkTerm "chieftainMasc_N" ;
lin chieftaincy_N = mkTerm "chieftaincy_N" ;
lin chiffon_N = mkTerm "chiffon_N" ;
lin chiffonier_N = mkTerm "chiffonier_N" ;
lin chigetai_N = mkTerm "chigetai_N" ;
lin chignon_N = mkTerm "chignon_N" ;
lin chigoe_N = mkTerm "chigoe_N" ;
lin chilblain_N = mkTerm "chilblain_N" ;
lin chilblained_A = mkTerm "chilblained_A" ;
lin child's_play_N = mkTerm "child's_play_N" ;
lin child_N = mkTerm "child_N" ;
lin child_bearing_N = mkTerm "child_bearing_N" ;
lin childbearing_A = mkTerm "childbearing_A" ;
lin childbirth_N = mkTerm "childbirth_N" ;
lin childcare_N = mkTerm "childcare_N" ;
lin childhood_N = mkTerm "childhood_N" ;
lin childish_A = mkTerm "childish_A" ;
lin childishness_N = mkTerm "childishness_N" ;
lin childless_A = mkTerm "childless_A" ;
lin childlessness_N = mkTerm "childlessness_N" ;
lin childlike_A = mkTerm "childlike_A" ;
lin chile_PN = mkTerm "chile_PN" ;
lin chileanFem_N = mkTerm "chileanFem_N" ;
lin chileanMasc_N = mkTerm "chileanMasc_N" ;
lin chilean_A = mkTerm "chilean_A" ;
lin chili_N = mkTerm "chili_N" ;
lin chill_A = mkTerm "chill_A" ;
lin chill_N = mkTerm "chill_N" ;
lin chill_V = mkTerm "chill_V" ;
lin chill_V2 = mkTerm "chill_V2" ;
lin chill_out_V = mkTerm "chill_out_V" ;
lin chilliness_N = mkTerm "chilliness_N" ;
lin chilly_A = mkTerm "chilly_A" ;
lin chilly_N = mkTerm "chilly_N" ;
lin chimaera_N = mkTerm "chimaera_N" ;
lin chime_N = mkTerm "chime_N" ;
lin chime_V = mkTerm "chime_V" ;
lin chime_V2 = mkTerm "chime_V2" ;
lin chime_in_V = mkTerm "chime_in_V" ;
lin chimera_N = mkTerm "chimera_N" ;
lin chimeric_A = mkTerm "chimeric_A" ;
lin chimerical_A = mkTerm "chimerical_A" ;
lin chimney_N = mkTerm "chimney_N" ;
lin chimney_sweep_N = mkTerm "chimney_sweep_N" ;
lin chimneybreast_N = mkTerm "chimneybreast_N" ;
lin chimneypiece_N = mkTerm "chimneypiece_N" ;
lin chimneypot_N = mkTerm "chimneypot_N" ;
lin chimneystack_N = mkTerm "chimneystack_N" ;
lin chimneysweeper_N = mkTerm "chimneysweeper_N" ;
lin chimp_N = mkTerm "chimp_N" ;
lin chimpanzee_N = mkTerm "chimpanzee_N" ;
lin chin_N = mkTerm "chin_N" ;
lin chin_strap_N = mkTerm "chin_strap_N" ;
lin chin_wagging_N = mkTerm "chin_wagging_N" ;
lin china_N = mkTerm "china_N" ;
lin china_PN = mkTerm "china_PN" ;
lin china_closet_N = mkTerm "china_closet_N" ;
lin chinaberry_N = mkTerm "chinaberry_N" ;
lin chinaware_N = mkTerm "chinaware_N" ;
lin chincapin_N = mkTerm "chincapin_N" ;
lin chincherinchee_N = mkTerm "chincherinchee_N" ;
lin chinchilla_N = mkTerm "chinchilla_N" ;
lin chinchow_PN = mkTerm "chinchow_PN" ;
lin chine_N = mkTerm "chine_N" ;
lin chineseFem_N = mkTerm "chineseFem_N" ;
lin chineseMasc_N = mkTerm "chineseMasc_N" ;
lin chinese_A = mkTerm "chinese_A" ;
lin chink_N = mkTerm "chink_N" ;
lin chink_V = mkTerm "chink_V" ;
lin chink_V2 = mkTerm "chink_V2" ;
lin chinless_A = mkTerm "chinless_A" ;
lin chino_N = mkTerm "chino_N" ;
lin chinoiserie_N = mkTerm "chinoiserie_N" ;
lin chinook_N = mkTerm "chinook_N" ;
lin chintz_N = mkTerm "chintz_N" ;
lin chip_N = mkTerm "chip_N" ;
lin chip_V = mkTerm "chip_V" ;
lin chip_V2 = mkTerm "chip_V2" ;
lin chip_away_V = mkTerm "chip_away_V" ;
lin chip_away_at_V2 = mkTerm "chip_away_at_V2" ;
lin chip_in_V = mkTerm "chip_in_V" ;
lin chipboard_N = mkTerm "chipboard_N" ;
lin chipmunk_N = mkTerm "chipmunk_N" ;
lin chipolata_N = mkTerm "chipolata_N" ;
lin chipotle_N = mkTerm "chipotle_N" ;
lin chippendale_N = mkTerm "chippendale_N" ;
lin chippenham_PN = mkTerm "chippenham_PN" ;
lin chipper_A = mkTerm "chipper_A" ;
lin chips_N = mkTerm "chips_N" ;
lin chiralgia_N = mkTerm "chiralgia_N" ;
lin chiromantic_A = mkTerm "chiromantic_A" ;
lin chiropodist_N = mkTerm "chiropodist_N" ;
lin chiropody_N = mkTerm "chiropody_N" ;
lin chiropractic_N = mkTerm "chiropractic_N" ;
lin chiropractor_N = mkTerm "chiropractor_N" ;
lin chirp_N = mkTerm "chirp_N" ;
lin chirp_V = mkTerm "chirp_V" ;
lin chirp_V2 = mkTerm "chirp_V2" ;
lin chirpiness_N = mkTerm "chirpiness_N" ;
lin chirpy_A = mkTerm "chirpy_A" ;
lin chirrup_N = mkTerm "chirrup_N" ;
lin chirrup_V = mkTerm "chirrup_V" ;
lin chirrup_V2 = mkTerm "chirrup_V2" ;
lin chisel_N = mkTerm "chisel_N" ;
lin chisel_V2 = mkTerm "chisel_V2" ;
lin chiseled_A = mkTerm "chiseled_A" ;
lin chiseller_N = mkTerm "chiseller_N" ;
lin chit_N = mkTerm "chit_N" ;
lin chit_chat_N = mkTerm "chit_chat_N" ;
lin chitchat_N = mkTerm "chitchat_N" ;
lin chitin_N = mkTerm "chitin_N" ;
lin chitinous_A = mkTerm "chitinous_A" ;
lin chiton_N = mkTerm "chiton_N" ;
lin chitterlings_N = mkTerm "chitterlings_N" ;
lin chivalric_A = mkTerm "chivalric_A" ;
lin chivalrous_A = mkTerm "chivalrous_A" ;
lin chivalry_N = mkTerm "chivalry_N" ;
lin chive_N = mkTerm "chive_N" ;
lin chives_N = mkTerm "chives_N" ;
lin chivvy_V2 = mkTerm "chivvy_V2" ;
lin chlamydeous_A = mkTerm "chlamydeous_A" ;
lin chlamydia_N = mkTerm "chlamydia_N" ;
lin chlamydial_A = mkTerm "chlamydial_A" ;
lin chlamydospore_N = mkTerm "chlamydospore_N" ;
lin chlamys_N = mkTerm "chlamys_N" ;
lin chloasma_N = mkTerm "chloasma_N" ;
lin chloe_PN = mkTerm "chloe_PN" ;
lin chlorambucil_N = mkTerm "chlorambucil_N" ;
lin chloramine_N = mkTerm "chloramine_N" ;
lin chloramphenicol_N = mkTerm "chloramphenicol_N" ;
lin chlorate_N = mkTerm "chlorate_N" ;
lin chlordiazepoxide_N = mkTerm "chlordiazepoxide_N" ;
lin chlorella_N = mkTerm "chlorella_N" ;
lin chlorenchyma_N = mkTerm "chlorenchyma_N" ;
lin chlorhexidine_N = mkTerm "chlorhexidine_N" ;
lin chloride_N = mkTerm "chloride_N" ;
lin chlorinate_V2 = mkTerm "chlorinate_V2" ;
lin chlorination_N = mkTerm "chlorination_N" ;
lin chlorine_N = mkTerm "chlorine_N" ;
lin chlorinity_N = mkTerm "chlorinity_N" ;
lin chlorite_N = mkTerm "chlorite_N" ;
lin chloroacetophenone_N = mkTerm "chloroacetophenone_N" ;
lin chlorobenzene_N = mkTerm "chlorobenzene_N" ;
lin chlorobenzylidenemalononitrile_N = mkTerm "chlorobenzylidenemalononitrile_N" ;
lin chlorofluorocarbon_N = mkTerm "chlorofluorocarbon_N" ;
lin chloroform_N = mkTerm "chloroform_N" ;
lin chlorophyll_N = mkTerm "chlorophyll_N" ;
lin chlorophyllose_A = mkTerm "chlorophyllose_A" ;
lin chloropicrin_N = mkTerm "chloropicrin_N" ;
lin chloroplast_N = mkTerm "chloroplast_N" ;
lin chloroprene_N = mkTerm "chloroprene_N" ;
lin chloroquine_N = mkTerm "chloroquine_N" ;
lin chlorosis_N = mkTerm "chlorosis_N" ;
lin chlorothiazide_N = mkTerm "chlorothiazide_N" ;
lin chlorotic_A = mkTerm "chlorotic_A" ;
lin chlorpromazine_N = mkTerm "chlorpromazine_N" ;
lin chlorpyrifos_N = mkTerm "chlorpyrifos_N" ;
lin chlortetracycline_N = mkTerm "chlortetracycline_N" ;
lin chlorthalidone_N = mkTerm "chlorthalidone_N" ;
lin choanocyte_N = mkTerm "choanocyte_N" ;
lin choc_N = mkTerm "choc_N" ;
lin choc_ice_N = mkTerm "choc_ice_N" ;
lin chock_Adv = mkTerm "chock_Adv" ;
lin chock_N = mkTerm "chock_N" ;
lin chock_V2 = mkTerm "chock_V2" ;
lin chock_a_block_A = mkTerm "chock_a_block_A" ;
lin chock_a_block_Adv = mkTerm "chock_a_block_Adv" ;
lin chock_full_A = mkTerm "chock_full_A" ;
lin chocolate_A = mkTerm "chocolate_A" ;
lin chocolate_N = mkTerm "chocolate_N" ;
lin choice_A = mkTerm "choice_A" ;
lin choice_N = mkTerm "choice_N" ;
lin choir_N = mkTerm "choir_N" ;
lin choir_school_N = mkTerm "choir_school_N" ;
lin choirboy_N = mkTerm "choirboy_N" ;
lin choirmaster_N = mkTerm "choirmaster_N" ;
lin choke_N = mkTerm "choke_N" ;
lin choke_V = mkTerm "choke_V" ;
lin choke_V2 = mkTerm "choke_V2" ;
lin choke_damp_N = mkTerm "choke_damp_N" ;
lin choke_off_V2 = mkTerm "choke_off_V2" ;
lin choke_out_V2 = mkTerm "choke_out_V2" ;
lin choke_up_V = mkTerm "choke_up_V" ;
lin choke_up_V2 = mkTerm "choke_up_V2" ;
lin chokecherry_N = mkTerm "chokecherry_N" ;
lin chokehold_N = mkTerm "chokehold_N" ;
lin chokepoint_N = mkTerm "chokepoint_N" ;
lin choker_N = mkTerm "choker_N" ;
lin chokey_N = mkTerm "chokey_N" ;
lin choking_N = mkTerm "choking_N" ;
lin choky_A = mkTerm "choky_A" ;
lin choky_N = mkTerm "choky_N" ;
lin cholangiography_N = mkTerm "cholangiography_N" ;
lin cholangitis_N = mkTerm "cholangitis_N" ;
lin cholecystectomy_N = mkTerm "cholecystectomy_N" ;
lin cholecystitis_N = mkTerm "cholecystitis_N" ;
lin cholecystokinin_N = mkTerm "cholecystokinin_N" ;
lin cholelithiasis_N = mkTerm "cholelithiasis_N" ;
lin cholelithotomy_N = mkTerm "cholelithotomy_N" ;
lin choler_N = mkTerm "choler_N" ;
lin cholera_N = mkTerm "cholera_N" ;
lin choleraic_A = mkTerm "choleraic_A" ;
lin choleric_A = mkTerm "choleric_A" ;
lin cholesterol_N = mkTerm "cholesterol_N" ;
lin choline_N = mkTerm "choline_N" ;
lin cholinergic_A = mkTerm "cholinergic_A" ;
lin cholinesterase_N = mkTerm "cholinesterase_N" ;
lin cholla_N = mkTerm "cholla_N" ;
lin chomping_N = mkTerm "chomping_N" ;
lin chon_N = mkTerm "chon_N" ;
lin chondrin_N = mkTerm "chondrin_N" ;
lin chondrite_N = mkTerm "chondrite_N" ;
lin chondritic_A = mkTerm "chondritic_A" ;
lin chondroma_N = mkTerm "chondroma_N" ;
lin chondrosarcoma_N = mkTerm "chondrosarcoma_N" ;
lin chondrule_N = mkTerm "chondrule_N" ;
lin choose_V2 = mkTerm "choose_V2" ;
lin choose_VV = mkTerm "choose_VV" ;
lin choose_up_V = mkTerm "choose_up_V" ;
lin choose_up_V2 = mkTerm "choose_up_V2" ;
lin choosey_A = mkTerm "choosey_A" ;
lin choosy_A = mkTerm "choosy_A" ;
lin chop_N = mkTerm "chop_N" ;
lin chop_V = mkTerm "chop_V" ;
lin chop_V2 = mkTerm "chop_V2" ;
lin chop_chop_Adv = mkTerm "chop_chop_Adv" ;
lin chop_down_V2 = mkTerm "chop_down_V2" ;
lin chop_house_N = mkTerm "chop_house_N" ;
lin chop_off_V = mkTerm "chop_off_V" ;
lin chop_out_V = mkTerm "chop_out_V" ;
lin chop_suey_N = mkTerm "chop_suey_N" ;
lin chop_up_V2 = mkTerm "chop_up_V2" ;
lin chopine_N = mkTerm "chopine_N" ;
lin chopper_N = mkTerm "chopper_N" ;
lin choppiness_N = mkTerm "choppiness_N" ;
lin choppy_A = mkTerm "choppy_A" ;
lin chopstick_N = mkTerm "chopstick_N" ;
lin chopwell_PN = mkTerm "chopwell_PN" ;
lin choragic_A = mkTerm "choragic_A" ;
lin choragus_N = mkTerm "choragus_N" ;
lin choral_A = mkTerm "choral_A" ;
lin chorale_N = mkTerm "chorale_N" ;
lin chord_N = mkTerm "chord_N" ;
lin chordal_A = mkTerm "chordal_A" ;
lin chordamesoderm_N = mkTerm "chordamesoderm_N" ;
lin chordate_A = mkTerm "chordate_A" ;
lin chordate_N = mkTerm "chordate_N" ;
lin chorditis_N = mkTerm "chorditis_N" ;
lin chordophone_N = mkTerm "chordophone_N" ;
lin chore_N = mkTerm "chore_N" ;
lin chorea_N = mkTerm "chorea_N" ;
lin choreographer_N = mkTerm "choreographer_N" ;
lin choreographic_A = mkTerm "choreographic_A" ;
lin choreography_N = mkTerm "choreography_N" ;
lin choric_A = mkTerm "choric_A" ;
lin chorioallantois_N = mkTerm "chorioallantois_N" ;
lin choriomeningitis_N = mkTerm "choriomeningitis_N" ;
lin chorion_N = mkTerm "chorion_N" ;
lin chorionic_A = mkTerm "chorionic_A" ;
lin chorioretinitis_N = mkTerm "chorioretinitis_N" ;
lin chorister_N = mkTerm "chorister_N" ;
lin chorizo_N = mkTerm "chorizo_N" ;
lin chorley_PN = mkTerm "chorley_PN" ;
lin choroid_N = mkTerm "choroid_N" ;
lin chortle_N = mkTerm "chortle_N" ;
lin chortle_V = mkTerm "chortle_V" ;
lin chorus_N = mkTerm "chorus_N" ;
lin chorus_V2 = mkTerm "chorus_V2" ;
lin chorus_girl_N = mkTerm "chorus_girl_N" ;
lin chosen_A = mkTerm "chosen_A" ;
lin chosen_N = mkTerm "chosen_N" ;
lin chough_N = mkTerm "chough_N" ;
lin chow_N = mkTerm "chow_N" ;
lin chow_down_V = mkTerm "chow_down_V" ;
lin chow_down_on_V2 = mkTerm "chow_down_on_V2" ;
lin chowchow_N = mkTerm "chowchow_N" ;
lin chowder_N = mkTerm "chowder_N" ;
lin chrestomathy_N = mkTerm "chrestomathy_N" ;
lin chris_PN = mkTerm "chris_PN" ;
lin chrism_N = mkTerm "chrism_N" ;
lin chrissie_PN = mkTerm "chrissie_PN" ;
lin chrissy_PN = mkTerm "chrissy_PN" ;
lin christ_N = mkTerm "christ_N" ;
lin christ_PN = mkTerm "christ_PN" ;
lin christchurch_PN = mkTerm "christchurch_PN" ;
lin christella_N = mkTerm "christella_N" ;
lin christen_V2 = mkTerm "christen_V2" ;
lin christendom_N = mkTerm "christendom_N" ;
lin christening_N = mkTerm "christening_N" ;
lin christian_A = mkTerm "christian_A" ;
lin christian_N = mkTerm "christian_N" ;
lin christian_PN = mkTerm "christian_PN" ;
lin christianity_N = mkTerm "christianity_N" ;
lin christianly_A = mkTerm "christianly_A" ;
lin christina_PN = mkTerm "christina_PN" ;
lin christine_PN = mkTerm "christine_PN" ;
lin christless_A = mkTerm "christless_A" ;
lin christlike_A = mkTerm "christlike_A" ;
lin christmas_N = mkTerm "christmas_N" ;
lin christmas_PN = mkTerm "christmas_PN" ;
lin christmas_box_N = mkTerm "christmas_box_N" ;
lin christmas_tree_N = mkTerm "christmas_tree_N" ;
lin christmastide_N = mkTerm "christmastide_N" ;
lin christmastime_N = mkTerm "christmastime_N" ;
lin christopher_PN = mkTerm "christopher_PN" ;
lin chromate_N = mkTerm "chromate_N" ;
lin chromatic_A = mkTerm "chromatic_A" ;
lin chromatid_N = mkTerm "chromatid_N" ;
lin chromatin_N = mkTerm "chromatin_N" ;
lin chromatinic_A = mkTerm "chromatinic_A" ;
lin chromatism_N = mkTerm "chromatism_N" ;
lin chromatogram_N = mkTerm "chromatogram_N" ;
lin chromatographic_A = mkTerm "chromatographic_A" ;
lin chromatography_N = mkTerm "chromatography_N" ;
lin chrome_N = mkTerm "chrome_N" ;
lin chromesthesia_N = mkTerm "chromesthesia_N" ;
lin chromite_N = mkTerm "chromite_N" ;
lin chromium_N = mkTerm "chromium_N" ;
lin chromoblastomycosis_N = mkTerm "chromoblastomycosis_N" ;
lin chromogen_N = mkTerm "chromogen_N" ;
lin chromolithography_N = mkTerm "chromolithography_N" ;
lin chromophore_N = mkTerm "chromophore_N" ;
lin chromoplast_N = mkTerm "chromoplast_N" ;
lin chromosomal_A = mkTerm "chromosomal_A" ;
lin chromosome_N = mkTerm "chromosome_N" ;
lin chromosphere_N = mkTerm "chromosphere_N" ;
lin chronic_A = mkTerm "chronic_A" ;
lin chronicle_N = mkTerm "chronicle_N" ;
lin chronicle_V2 = mkTerm "chronicle_V2" ;
lin chronicler_N = mkTerm "chronicler_N" ;
lin chronograph_N = mkTerm "chronograph_N" ;
lin chronological_A = mkTerm "chronological_A" ;
lin chronology_N = mkTerm "chronology_N" ;
lin chronometer_N = mkTerm "chronometer_N" ;
lin chronoscope_N = mkTerm "chronoscope_N" ;
lin chrysalis_N = mkTerm "chrysalis_N" ;
lin chrysanthemum_N = mkTerm "chrysanthemum_N" ;
lin chrysoberyl_N = mkTerm "chrysoberyl_N" ;
lin chrysolite_N = mkTerm "chrysolite_N" ;
lin chrysoprase_N = mkTerm "chrysoprase_N" ;
lin chrysotherapy_N = mkTerm "chrysotherapy_N" ;
lin chrysotile_N = mkTerm "chrysotile_N" ;
lin chthonian_A = mkTerm "chthonian_A" ;
lin chub_N = mkTerm "chub_N" ;
lin chubbiness_N = mkTerm "chubbiness_N" ;
lin chubby_A = mkTerm "chubby_A" ;
lin chuck_N = mkTerm "chuck_N" ;
lin chuck_V2 = mkTerm "chuck_V2" ;
lin chuck_away_V2 = mkTerm "chuck_away_V2" ;
lin chuck_in_V2 = mkTerm "chuck_in_V2" ;
lin chuck_out_V2 = mkTerm "chuck_out_V2" ;
lin chuck_up_V = mkTerm "chuck_up_V" ;
lin chuck_up_V2 = mkTerm "chuck_up_V2" ;
lin chucker_out_N = mkTerm "chucker_out_N" ;
lin chuckle_N = mkTerm "chuckle_N" ;
lin chuckle_V = mkTerm "chuckle_V" ;
lin chuckle_VS = mkTerm "chuckle_VS" ;
lin chuckwalla_N = mkTerm "chuckwalla_N" ;
lin chufa_N = mkTerm "chufa_N" ;
lin chuffed_A = mkTerm "chuffed_A" ;
lin chug_N = mkTerm "chug_N" ;
lin chug_V = mkTerm "chug_V" ;
lin chukka_N = mkTerm "chukka_N" ;
lin chukker_N = mkTerm "chukker_N" ;
lin chum_N = mkTerm "chum_N" ;
lin chum_V = mkTerm "chum_V" ;
lin chumminess_N = mkTerm "chumminess_N" ;
lin chummy_A = mkTerm "chummy_A" ;
lin chump_N = mkTerm "chump_N" ;
lin chunga_N = mkTerm "chunga_N" ;
lin chungking_PN = mkTerm "chungking_PN" ;
lin chunk_N = mkTerm "chunk_N" ;
lin chunky_A = mkTerm "chunky_A" ;
lin chunnel_N = mkTerm "chunnel_N" ;
lin church_N = mkTerm "church_N" ;
lin churchgoer_N = mkTerm "churchgoer_N" ;
lin churchgoing_A = mkTerm "churchgoing_A" ;
lin churchly_A = mkTerm "churchly_A" ;
lin churchman_N = mkTerm "churchman_N" ;
lin churchwarden_N = mkTerm "churchwarden_N" ;
lin churchyard_N = mkTerm "churchyard_N" ;
lin churidars_N = mkTerm "churidars_N" ;
lin churl_N = mkTerm "churl_N" ;
lin churlish_A = mkTerm "churlish_A" ;
lin churn_N = mkTerm "churn_N" ;
lin churn_V = mkTerm "churn_V" ;
lin churn_V2 = mkTerm "churn_V2" ;
lin churn_out_V2 = mkTerm "churn_out_V2" ;
lin chute_N = mkTerm "chute_N" ;
lin chutney_N = mkTerm "chutney_N" ;
lin chutzpa_N = mkTerm "chutzpa_N" ;
lin chutzpanik_N = mkTerm "chutzpanik_N" ;
lin chylaceous_A = mkTerm "chylaceous_A" ;
lin chyle_N = mkTerm "chyle_N" ;
lin chyliferous_A = mkTerm "chyliferous_A" ;
lin chylific_A = mkTerm "chylific_A" ;
lin chylomicron_N = mkTerm "chylomicron_N" ;
lin chyme_N = mkTerm "chyme_N" ;
lin cia_N = mkTerm "cia_N" ;
lin cicada_N = mkTerm "cicada_N" ;
lin cicala_N = mkTerm "cicala_N" ;
lin cicatrice_N = mkTerm "cicatrice_N" ;
lin cicatrix_N = mkTerm "cicatrix_N" ;
lin cicero_N = mkTerm "cicero_N" ;
lin cicerone_N = mkTerm "cicerone_N" ;
lin cichlid_N = mkTerm "cichlid_N" ;
lin cid_N = mkTerm "cid_N" ;
lin cider_N = mkTerm "cider_N" ;
lin ciderpress_N = mkTerm "ciderpress_N" ;
lin cif_PN = mkTerm "cif_PN" ;
lin cigar_N = mkTerm "cigar_N" ;
lin cigar_shaped_A = mkTerm "cigar_shaped_A" ;
lin cigarette_N = mkTerm "cigarette_N" ;
lin cigarette_case_N = mkTerm "cigarette_case_N" ;
lin cigarette_holder_N = mkTerm "cigarette_holder_N" ;
lin cigarette_paper_N = mkTerm "cigarette_paper_N" ;
lin cigarillo_N = mkTerm "cigarillo_N" ;
lin ciliary_A = mkTerm "ciliary_A" ;
lin ciliate_A = mkTerm "ciliate_A" ;
lin ciliate_N = mkTerm "ciliate_N" ;
lin cilium_N = mkTerm "cilium_N" ;
lin cimetidine_N = mkTerm "cimetidine_N" ;
lin cinch_N = mkTerm "cinch_N" ;
lin cinch_V2 = mkTerm "cinch_V2" ;
lin cinchona_N = mkTerm "cinchona_N" ;
lin cinchonine_N = mkTerm "cinchonine_N" ;
lin cincinnati_PN = mkTerm "cincinnati_PN" ;
lin cincture_N = mkTerm "cincture_N" ;
lin cinder_N = mkTerm "cinder_N" ;
lin cinder_track_N = mkTerm "cinder_track_N" ;
lin cinderella_N = mkTerm "cinderella_N" ;
lin cinderford_PN = mkTerm "cinderford_PN" ;
lin cine_camera_N = mkTerm "cine_camera_N" ;
lin cine_film_N = mkTerm "cine_film_N" ;
lin cine_projector_N = mkTerm "cine_projector_N" ;
lin cinema_N = mkTerm "cinema_N" ;
lin cinematic_A = mkTerm "cinematic_A" ;
lin cinematographer_N = mkTerm "cinematographer_N" ;
lin cinematography_N = mkTerm "cinematography_N" ;
lin cineraria_N = mkTerm "cineraria_N" ;
lin cinerary_A = mkTerm "cinerary_A" ;
lin cingulum_N = mkTerm "cingulum_N" ;
lin cinnabar_N = mkTerm "cinnabar_N" ;
lin cinnamon_N = mkTerm "cinnamon_N" ;
lin cinquefoil_N = mkTerm "cinquefoil_N" ;
lin cipher_N = mkTerm "cipher_N" ;
lin cipher_V = mkTerm "cipher_V" ;
lin cipher_V2 = mkTerm "cipher_V2" ;
lin ciprofloxacin_N = mkTerm "ciprofloxacin_N" ;
lin circa_Prep = mkTerm "circa_Prep" ;
lin circadian_A = mkTerm "circadian_A" ;
lin circle_N = mkTerm "circle_N" ;
lin circle_V = mkTerm "circle_V" ;
lin circle_V2 = mkTerm "circle_V2" ;
lin circlet_N = mkTerm "circlet_N" ;
lin circuit_N = mkTerm "circuit_N" ;
lin circuitous_A = mkTerm "circuitous_A" ;
lin circuitry_N = mkTerm "circuitry_N" ;
lin circular_A = mkTerm "circular_A" ;
lin circular_N = mkTerm "circular_N" ;
lin circularity_N = mkTerm "circularity_N" ;
lin circularization_N = mkTerm "circularization_N" ;
lin circularize_V2 = mkTerm "circularize_V2" ;
lin circulate_V = mkTerm "circulate_V" ;
lin circulate_V2 = mkTerm "circulate_V2" ;
lin circulation_N = mkTerm "circulation_N" ;
lin circulative_A = mkTerm "circulative_A" ;
lin circulatory_A = mkTerm "circulatory_A" ;
lin circumcise_V2 = mkTerm "circumcise_V2" ;
lin circumcision_N = mkTerm "circumcision_N" ;
lin circumduction_N = mkTerm "circumduction_N" ;
lin circumference_N = mkTerm "circumference_N" ;
lin circumferential_A = mkTerm "circumferential_A" ;
lin circumflex_N = mkTerm "circumflex_N" ;
lin circumlocution_N = mkTerm "circumlocution_N" ;
lin circumlocutious_A = mkTerm "circumlocutious_A" ;
lin circumnavigate_V2 = mkTerm "circumnavigate_V2" ;
lin circumnavigation_N = mkTerm "circumnavigation_N" ;
lin circumpolar_A = mkTerm "circumpolar_A" ;
lin circumscribe_V2 = mkTerm "circumscribe_V2" ;
lin circumscription_N = mkTerm "circumscription_N" ;
lin circumspect_A = mkTerm "circumspect_A" ;
lin circumspection_N = mkTerm "circumspection_N" ;
lin circumstance_N = mkTerm "circumstance_N" ;
lin circumstances_N = mkTerm "circumstances_N" ;
lin circumstantial_A = mkTerm "circumstantial_A" ;
lin circumvent_V2 = mkTerm "circumvent_V2" ;
lin circumvention_N = mkTerm "circumvention_N" ;
lin circumvolution_N = mkTerm "circumvolution_N" ;
lin circus_N = mkTerm "circus_N" ;
lin cirencester_PN = mkTerm "cirencester_PN" ;
lin cirque_N = mkTerm "cirque_N" ;
lin cirrhosis_N = mkTerm "cirrhosis_N" ;
lin cirrocumulus_N = mkTerm "cirrocumulus_N" ;
lin cirrostratus_N = mkTerm "cirrostratus_N" ;
lin cirrus_N = mkTerm "cirrus_N" ;
lin cisalpine_A = mkTerm "cisalpine_A" ;
lin cisco_N = mkTerm "cisco_N" ;
lin cismontane_A = mkTerm "cismontane_A" ;
lin cissy_A = mkTerm "cissy_A" ;
lin cissy_N = mkTerm "cissy_N" ;
lin cistern_N = mkTerm "cistern_N" ;
lin cisterna_N = mkTerm "cisterna_N" ;
lin citadel_N = mkTerm "citadel_N" ;
lin citation_N = mkTerm "citation_N" ;
lin cite_V2 = mkTerm "cite_V2" ;
lin citified_A = mkTerm "citified_A" ;
lin citizenFem_N = mkTerm "citizenFem_N" ;
lin citizenMasc_N = mkTerm "citizenMasc_N" ;
lin citizenry_N = mkTerm "citizenry_N" ;
lin citizenship_N = mkTerm "citizenship_N" ;
lin citrange_N = mkTerm "citrange_N" ;
lin citrate_N = mkTerm "citrate_N" ;
lin citric_A = mkTerm "citric_A" ;
lin citrine_N = mkTerm "citrine_N" ;
lin citron_N = mkTerm "citron_N" ;
lin citronwood_N = mkTerm "citronwood_N" ;
lin citrous_A = mkTerm "citrous_A" ;
lin citrulline_N = mkTerm "citrulline_N" ;
lin citrus_N = mkTerm "citrus_N" ;
lin cittern_N = mkTerm "cittern_N" ;
lin city_N = mkTerm "city_N" ;
lin cityscape_N = mkTerm "cityscape_N" ;
lin citywide_A = mkTerm "citywide_A" ;
lin civet_N = mkTerm "civet_N" ;
lin civet_cat_N = mkTerm "civet_cat_N" ;
lin civic_A = mkTerm "civic_A" ;
lin civics_N = mkTerm "civics_N" ;
lin civies_N = mkTerm "civies_N" ;
lin civil_A = mkTerm "civil_A" ;
lin civilian_A = mkTerm "civilian_A" ;
lin civilian_N = mkTerm "civilian_N" ;
lin civilisation_N = mkTerm "civilisation_N" ;
lin civility_N = mkTerm "civility_N" ;
lin civilization_N = mkTerm "civilization_N" ;
lin civilize_V2 = mkTerm "civilize_V2" ;
lin civvy_street_PN = mkTerm "civvy_street_PN" ;
lin clabber_N = mkTerm "clabber_N" ;
lin clack_N = mkTerm "clack_N" ;
lin clack_V = mkTerm "clack_V" ;
lin clackmannon_PN = mkTerm "clackmannon_PN" ;
lin clacton_PN = mkTerm "clacton_PN" ;
lin clad_V = mkTerm "clad_V" ;
lin clad_V2 = mkTerm "clad_V2" ;
lin clade_N = mkTerm "clade_N" ;
lin cladistics_N = mkTerm "cladistics_N" ;
lin cladode_N = mkTerm "cladode_N" ;
lin cladogram_N = mkTerm "cladogram_N" ;
lin clag_up_V2 = mkTerm "clag_up_V2" ;
lin claim_N = mkTerm "claim_N" ;
lin claim_V = mkTerm "claim_V" ;
lin claim_V2 = mkTerm "claim_V2" ;
lin claim_VS = mkTerm "claim_VS" ;
lin claimant_N = mkTerm "claimant_N" ;
lin clairvoyance_N = mkTerm "clairvoyance_N" ;
lin clairvoyant_A = mkTerm "clairvoyant_A" ;
lin clairvoyant_N = mkTerm "clairvoyant_N" ;
lin clam_N = mkTerm "clam_N" ;
lin clam_V = mkTerm "clam_V" ;
lin clam_up_V = mkTerm "clam_up_V" ;
lin clamant_A = mkTerm "clamant_A" ;
lin clamatorial_A = mkTerm "clamatorial_A" ;
lin clambake_N = mkTerm "clambake_N" ;
lin clamber_N = mkTerm "clamber_N" ;
lin clamber_V = mkTerm "clamber_V" ;
lin clammy_A = mkTerm "clammy_A" ;
lin clammyweed_N = mkTerm "clammyweed_N" ;
lin clamor_N = mkTerm "clamor_N" ;
lin clamorous_A = mkTerm "clamorous_A" ;
lin clamour_N = mkTerm "clamour_N" ;
lin clamour_V = mkTerm "clamour_V" ;
lin clamour_V2 = mkTerm "clamour_V2" ;
lin clamp_N = mkTerm "clamp_N" ;
lin clamp_V = mkTerm "clamp_V" ;
lin clamp_V2 = mkTerm "clamp_V2" ;
lin clamp_down_N = mkTerm "clamp_down_N" ;
lin clamp_down_V = mkTerm "clamp_down_V" ;
lin clamp_down_on_V2 = mkTerm "clamp_down_on_V2" ;
lin clamshell_N = mkTerm "clamshell_N" ;
lin clan_N = mkTerm "clan_N" ;
lin clandestine_A = mkTerm "clandestine_A" ;
lin clang_N = mkTerm "clang_N" ;
lin clang_V = mkTerm "clang_V" ;
lin clang_V2 = mkTerm "clang_V2" ;
lin clanger_N = mkTerm "clanger_N" ;
lin clangorous_A = mkTerm "clangorous_A" ;
lin clangour_N = mkTerm "clangour_N" ;
lin clank_N = mkTerm "clank_N" ;
lin clank_V = mkTerm "clank_V" ;
lin clank_V2 = mkTerm "clank_V2" ;
lin clank_in_V = mkTerm "clank_in_V" ;
lin clannish_A = mkTerm "clannish_A" ;
lin clannishness_N = mkTerm "clannishness_N" ;
lin clansman_N = mkTerm "clansman_N" ;
lin clap_N = mkTerm "clap_N" ;
lin clap_V = mkTerm "clap_V" ;
lin clap_V2 = mkTerm "clap_V2" ;
lin clapboard_N = mkTerm "clapboard_N" ;
lin clapper_N = mkTerm "clapper_N" ;
lin clapperboard_N = mkTerm "clapperboard_N" ;
lin claptrap_N = mkTerm "claptrap_N" ;
lin claque_N = mkTerm "claque_N" ;
lin clare_PN = mkTerm "clare_PN" ;
lin clarence_N = mkTerm "clarence_N" ;
lin claret_N = mkTerm "claret_N" ;
lin clarification_N = mkTerm "clarification_N" ;
lin clarify_V = mkTerm "clarify_V" ;
lin clarify_V2 = mkTerm "clarify_V2" ;
lin clarinet_N = mkTerm "clarinet_N" ;
lin clarinetistFem_N = mkTerm "clarinetistFem_N" ;
lin clarinetistMasc_N = mkTerm "clarinetistMasc_N" ;
lin clarion_A = mkTerm "clarion_A" ;
lin clarion_N = mkTerm "clarion_N" ;
lin clarity_N = mkTerm "clarity_N" ;
lin clarkston_PN = mkTerm "clarkston_PN" ;
lin claro_N = mkTerm "claro_N" ;
lin clarrie_PN = mkTerm "clarrie_PN" ;
lin clary_N = mkTerm "clary_N" ;
lin clash_N = mkTerm "clash_N" ;
lin clash_V = mkTerm "clash_V" ;
lin clash_V2 = mkTerm "clash_V2" ;
lin clasp_N = mkTerm "clasp_N" ;
lin clasp_V = mkTerm "clasp_V" ;
lin clasp_V2 = mkTerm "clasp_V2" ;
lin clasp_knife_N = mkTerm "clasp_knife_N" ;
lin class_N = mkTerm "class_N" ;
lin class_V2 = mkTerm "class_V2" ;
lin class_conscious_A = mkTerm "class_conscious_A" ;
lin class_feeling_N = mkTerm "class_feeling_N" ;
lin class_fellow_N = mkTerm "class_fellow_N" ;
lin class_list_N = mkTerm "class_list_N" ;
lin class_warfare_N = mkTerm "class_warfare_N" ;
lin classic_A = mkTerm "classic_A" ;
lin classic_N = mkTerm "classic_N" ;
lin classical_A = mkTerm "classical_A" ;
lin classicism_N = mkTerm "classicism_N" ;
lin classicist_N = mkTerm "classicist_N" ;
lin classicistic_A = mkTerm "classicistic_A" ;
lin classics_N = mkTerm "classics_N" ;
lin classifiable_A = mkTerm "classifiable_A" ;
lin classification_N = mkTerm "classification_N" ;
lin classificatory_A = mkTerm "classificatory_A" ;
lin classified_A = mkTerm "classified_A" ;
lin classifier_N = mkTerm "classifier_N" ;
lin classify_V2 = mkTerm "classify_V2" ;
lin classless_A = mkTerm "classless_A" ;
lin classmate_N = mkTerm "classmate_N" ;
lin classroom_N = mkTerm "classroom_N" ;
lin classwork_N = mkTerm "classwork_N" ;
lin classy_A = mkTerm "classy_A" ;
lin clast_N = mkTerm "clast_N" ;
lin clastic_A = mkTerm "clastic_A" ;
lin clathrate_A = mkTerm "clathrate_A" ;
lin clatter_N = mkTerm "clatter_N" ;
lin clatter_V = mkTerm "clatter_V" ;
lin clatter_V2 = mkTerm "clatter_V2" ;
lin clattery_A = mkTerm "clattery_A" ;
lin claud_PN = mkTerm "claud_PN" ;
lin claude_PN = mkTerm "claude_PN" ;
lin clausal_A = mkTerm "clausal_A" ;
lin clause_N = mkTerm "clause_N" ;
lin claustrophobe_N = mkTerm "claustrophobe_N" ;
lin claustrophobia_N = mkTerm "claustrophobia_N" ;
lin claustrophobic_A = mkTerm "claustrophobic_A" ;
lin claustrum_N = mkTerm "claustrum_N" ;
lin clavichord_N = mkTerm "clavichord_N" ;
lin clavicle_N = mkTerm "clavicle_N" ;
lin clavier_N = mkTerm "clavier_N" ;
lin claw_N = mkTerm "claw_N" ;
lin claw_V2 = mkTerm "claw_V2" ;
lin claw_back_V2 = mkTerm "claw_back_V2" ;
lin clawback_N = mkTerm "clawback_N" ;
lin clawfoot_N = mkTerm "clawfoot_N" ;
lin clawhammer_N = mkTerm "clawhammer_N" ;
lin clawlike_A = mkTerm "clawlike_A" ;
lin clay_N = mkTerm "clay_N" ;
lin clay_cross_PN = mkTerm "clay_cross_PN" ;
lin clayey_A = mkTerm "clayey_A" ;
lin claymore_N = mkTerm "claymore_N" ;
lin claystone_N = mkTerm "claystone_N" ;
lin clean_A = mkTerm "clean_A" ;
lin clean_N = mkTerm "clean_N" ;
lin clean_V = mkTerm "clean_V" ;
lin clean_V2 = mkTerm "clean_V2" ;
lin clean_bowled_A = mkTerm "clean_bowled_A" ;
lin clean_cut_A = mkTerm "clean_cut_A" ;
lin clean_limbed_A = mkTerm "clean_limbed_A" ;
lin clean_living_A = mkTerm "clean_living_A" ;
lin clean_out_V = mkTerm "clean_out_V" ;
lin clean_out_V2 = mkTerm "clean_out_V2" ;
lin clean_shaven_A = mkTerm "clean_shaven_A" ;
lin clean_up_N = mkTerm "clean_up_N" ;
lin clean_up_V = mkTerm "clean_up_V" ;
lin clean_up_V2 = mkTerm "clean_up_V2" ;
lin cleanable_A = mkTerm "cleanable_A" ;
lin cleaner_N = mkTerm "cleaner_N" ;
lin cleaners_N = mkTerm "cleaners_N" ;
lin cleaning_N = mkTerm "cleaning_N" ;
lin cleanliness_N = mkTerm "cleanliness_N" ;
lin cleanly_A = mkTerm "cleanly_A" ;
lin cleanness_N = mkTerm "cleanness_N" ;
lin cleanse_V2 = mkTerm "cleanse_V2" ;
lin cleanser_N = mkTerm "cleanser_N" ;
lin cleansing_A = mkTerm "cleansing_A" ;
lin clear_A = mkTerm "clear_A" ;
lin clear_Adv = mkTerm "clear_Adv" ;
lin clear_N = mkTerm "clear_N" ;
lin clear_V = mkTerm "clear_V" ;
lin clear_V2 = mkTerm "clear_V2" ;
lin clear_away_V = mkTerm "clear_away_V" ;
lin clear_away_V2 = mkTerm "clear_away_V2" ;
lin clear_cut_Adv = mkTerm "clear_cut_Adv" ;
lin clear_headed_A = mkTerm "clear_headed_A" ;
lin clear_off_V = mkTerm "clear_off_V" ;
lin clear_out_V = mkTerm "clear_out_V" ;
lin clear_out_V2 = mkTerm "clear_out_V2" ;
lin clear_sighted_A = mkTerm "clear_sighted_A" ;
lin clear_up_V = mkTerm "clear_up_V" ;
lin clear_up_V2 = mkTerm "clear_up_V2" ;
lin clearance_N = mkTerm "clearance_N" ;
lin clearing_N = mkTerm "clearing_N" ;
lin clearing_house_N = mkTerm "clearing_house_N" ;
lin clearness_N = mkTerm "clearness_N" ;
lin clearway_N = mkTerm "clearway_N" ;
lin cleat_N = mkTerm "cleat_N" ;
lin cleator_moor_PN = mkTerm "cleator_moor_PN" ;
lin cleats_N = mkTerm "cleats_N" ;
lin cleavable_A = mkTerm "cleavable_A" ;
lin cleavage_N = mkTerm "cleavage_N" ;
lin cleave_V = mkTerm "cleave_V" ;
lin cleave_V2 = mkTerm "cleave_V2" ;
lin cleaver_N = mkTerm "cleaver_N" ;
lin cleavers_N = mkTerm "cleavers_N" ;
lin cleethorpes_PN = mkTerm "cleethorpes_PN" ;
lin clef_N = mkTerm "clef_N" ;
lin cleft_A = mkTerm "cleft_A" ;
lin cleft_N = mkTerm "cleft_N" ;
lin cleistogamous_A = mkTerm "cleistogamous_A" ;
lin cleistogamy_N = mkTerm "cleistogamy_N" ;
lin cleistothecium_N = mkTerm "cleistothecium_N" ;
lin clem_PN = mkTerm "clem_PN" ;
lin clematis_N = mkTerm "clematis_N" ;
lin clemency_N = mkTerm "clemency_N" ;
lin clement_A = mkTerm "clement_A" ;
lin clement_PN = mkTerm "clement_PN" ;
lin clementine_N = mkTerm "clementine_N" ;
lin clench_V2 = mkTerm "clench_V2" ;
lin clerestory_N = mkTerm "clerestory_N" ;
lin clergy_N = mkTerm "clergy_N" ;
lin clergyman_N = mkTerm "clergyman_N" ;
lin cleric_N = mkTerm "cleric_N" ;
lin clerical_A = mkTerm "clerical_A" ;
lin clericalism_N = mkTerm "clericalism_N" ;
lin clericalist_N = mkTerm "clericalist_N" ;
lin clerihew_N = mkTerm "clerihew_N" ;
lin clerk_N = mkTerm "clerk_N" ;
lin clerk_V = mkTerm "clerk_V" ;
lin clerkship_N = mkTerm "clerkship_N" ;
lin clermont_ferrand_PN = mkTerm "clermont_ferrand_PN" ;
lin clevedon_PN = mkTerm "clevedon_PN" ;
lin cleveland_PN = mkTerm "cleveland_PN" ;
lin clever_A = mkTerm "clever_A" ;
lin cleverness_N = mkTerm "cleverness_N" ;
lin clevis_N = mkTerm "clevis_N" ;
lin clew_N = mkTerm "clew_N" ;
lin clew_V2 = mkTerm "clew_V2" ;
lin clews_N = mkTerm "clews_N" ;
lin cliche_N = mkTerm "cliche_N" ;
lin cliched_A = mkTerm "cliched_A" ;
lin click_N = mkTerm "click_N" ;
lin click_V = mkTerm "click_V" ;
lin click_through_V2 = mkTerm "click_through_V2" ;
lin client_N = mkTerm "client_N" ;
lin clientage_N = mkTerm "clientage_N" ;
lin clientele_N = mkTerm "clientele_N" ;
lin cliff_N = mkTerm "cliff_N" ;
lin cliff_PN = mkTerm "cliff_PN" ;
lin cliff_hanger_N = mkTerm "cliff_hanger_N" ;
lin clifford_PN = mkTerm "clifford_PN" ;
lin climacteric_N = mkTerm "climacteric_N" ;
lin climactic_A = mkTerm "climactic_A" ;
lin climate_N = mkTerm "climate_N" ;
lin climatic_A = mkTerm "climatic_A" ;
lin climatologist_N = mkTerm "climatologist_N" ;
lin climatology_N = mkTerm "climatology_N" ;
lin climax_N = mkTerm "climax_N" ;
lin climax_V = mkTerm "climax_V" ;
lin climax_V2 = mkTerm "climax_V2" ;
lin climb_N = mkTerm "climb_N" ;
lin climb_V = mkTerm "climb_V" ;
lin climb_V2 = mkTerm "climb_V2" ;
lin climb_down_N = mkTerm "climb_down_N" ;
lin climb_down_V = mkTerm "climb_down_V" ;
lin climber_N = mkTerm "climber_N" ;
lin clime_N = mkTerm "clime_N" ;
lin clinch_N = mkTerm "clinch_N" ;
lin clinch_V = mkTerm "clinch_V" ;
lin clinch_V2 = mkTerm "clinch_V2" ;
lin clincher_N = mkTerm "clincher_N" ;
lin cling_N = mkTerm "cling_N" ;
lin cling_V = mkTerm "cling_V" ;
lin cling_on_V = mkTerm "cling_on_V" ;
lin cling_on_to_V2 = mkTerm "cling_on_to_V2" ;
lin cling_to_V2 = mkTerm "cling_to_V2" ;
lin clingfish_N = mkTerm "clingfish_N" ;
lin clinic_N = mkTerm "clinic_N" ;
lin clinical_A = mkTerm "clinical_A" ;
lin clinician_N = mkTerm "clinician_N" ;
lin clinid_N = mkTerm "clinid_N" ;
lin clink_N = mkTerm "clink_N" ;
lin clink_V = mkTerm "clink_V" ;
lin clink_V2 = mkTerm "clink_V2" ;
lin clinker_N = mkTerm "clinker_N" ;
lin clinker_built_A = mkTerm "clinker_built_A" ;
lin clinocephaly_N = mkTerm "clinocephaly_N" ;
lin clinodactyly_N = mkTerm "clinodactyly_N" ;
lin clinometer_N = mkTerm "clinometer_N" ;
lin clinquant_A = mkTerm "clinquant_A" ;
lin clintonia_N = mkTerm "clintonia_N" ;
lin clip_N = mkTerm "clip_N" ;
lin clip_V2 = mkTerm "clip_V2" ;
lin clip_joint_N = mkTerm "clip_joint_N" ;
lin clip_on_A = mkTerm "clip_on_A" ;
lin clipboard_N = mkTerm "clipboard_N" ;
lin clipper_N = mkTerm "clipper_N" ;
lin clipping_N = mkTerm "clipping_N" ;
lin clique_N = mkTerm "clique_N" ;
lin cliquish_A = mkTerm "cliquish_A" ;
lin clitheroe_PN = mkTerm "clitheroe_PN" ;
lin clitoral_A = mkTerm "clitoral_A" ;
lin clitoridectomy_N = mkTerm "clitoridectomy_N" ;
lin clitoris_N = mkTerm "clitoris_N" ;
lin clive_PN = mkTerm "clive_PN" ;
lin cloaca_N = mkTerm "cloaca_N" ;
lin cloak_N = mkTerm "cloak_N" ;
lin cloak_V2 = mkTerm "cloak_V2" ;
lin cloakmaker_N = mkTerm "cloakmaker_N" ;
lin cloakroom_N = mkTerm "cloakroom_N" ;
lin clobber_N = mkTerm "clobber_N" ;
lin clobber_V2 = mkTerm "clobber_V2" ;
lin cloche_N = mkTerm "cloche_N" ;
lin clock_N = mkTerm "clock_N" ;
lin clock_V = mkTerm "clock_V" ;
lin clock_V2 = mkTerm "clock_V2" ;
lin clock_dial_N = mkTerm "clock_dial_N" ;
lin clock_face_N = mkTerm "clock_face_N" ;
lin clock_golf_N = mkTerm "clock_golf_N" ;
lin clock_tower_N = mkTerm "clock_tower_N" ;
lin clock_watching_N = mkTerm "clock_watching_N" ;
lin clocking_N = mkTerm "clocking_N" ;
lin clocksmith_N = mkTerm "clocksmith_N" ;
lin clockwise_A = mkTerm "clockwise_A" ;
lin clockwise_Adv = mkTerm "clockwise_Adv" ;
lin clockwork_N = mkTerm "clockwork_N" ;
lin clod_N = mkTerm "clod_N" ;
lin cloddish_A = mkTerm "cloddish_A" ;
lin clodhopper_N = mkTerm "clodhopper_N" ;
lin clofibrate_N = mkTerm "clofibrate_N" ;
lin clog_N = mkTerm "clog_N" ;
lin clog_V = mkTerm "clog_V" ;
lin clog_V2 = mkTerm "clog_V2" ;
lin clog_dance_N = mkTerm "clog_dance_N" ;
lin clog_up_V2 = mkTerm "clog_up_V2" ;
lin cloggy_A = mkTerm "cloggy_A" ;
lin cloisonne_N = mkTerm "cloisonne_N" ;
lin cloister_N = mkTerm "cloister_N" ;
lin cloister_V2 = mkTerm "cloister_V2" ;
lin clomiphene_N = mkTerm "clomiphene_N" ;
lin clomipramine_N = mkTerm "clomipramine_N" ;
lin clonal_A = mkTerm "clonal_A" ;
lin clone_N = mkTerm "clone_N" ;
lin clone_V2 = mkTerm "clone_V2" ;
lin clonic_A = mkTerm "clonic_A" ;
lin clonidine_N = mkTerm "clonidine_N" ;
lin cloning_N = mkTerm "cloning_N" ;
lin clonus_N = mkTerm "clonus_N" ;
lin close_A = mkTerm "close_A" ;
lin close_Adv = mkTerm "close_Adv" ;
lin close_N = mkTerm "close_N" ;
lin close_V = mkTerm "close_V" ;
lin close_V2 = mkTerm "close_V2" ;
lin close_cropped_A = mkTerm "close_cropped_A" ;
lin close_cut_A = mkTerm "close_cut_A" ;
lin close_down_N = mkTerm "close_down_N" ;
lin close_down_V = mkTerm "close_down_V" ;
lin close_down_V2 = mkTerm "close_down_V2" ;
lin close_fisted_A = mkTerm "close_fisted_A" ;
lin close_fitting_A = mkTerm "close_fitting_A" ;
lin close_grained_A = mkTerm "close_grained_A" ;
lin close_hauled_A = mkTerm "close_hauled_A" ;
lin close_in_V = mkTerm "close_in_V" ;
lin close_in_on_V2 = mkTerm "close_in_on_V2" ;
lin close_in_upon_V2 = mkTerm "close_in_upon_V2" ;
lin close_off_V2 = mkTerm "close_off_V2" ;
lin close_on_V2 = mkTerm "close_on_V2" ;
lin close_out_V2 = mkTerm "close_out_V2" ;
lin close_set_A = mkTerm "close_set_A" ;
lin close_to_Prep = mkTerm "close_to_Prep" ;
lin close_up_N = mkTerm "close_up_N" ;
lin close_up_V = mkTerm "close_up_V" ;
lin close_up_V2 = mkTerm "close_up_V2" ;
lin closed_A = mkTerm "closed_A" ;
lin closeness_N = mkTerm "closeness_N" ;
lin closeout_N = mkTerm "closeout_N" ;
lin closer_N = mkTerm "closer_N" ;
lin closet_A = mkTerm "closet_A" ;
lin closet_N = mkTerm "closet_N" ;
lin closet_V2 = mkTerm "closet_V2" ;
lin closing_N = mkTerm "closing_N" ;
lin clostridium_N = mkTerm "clostridium_N" ;
lin closure_N = mkTerm "closure_N" ;
lin clot_N = mkTerm "clot_N" ;
lin clot_V = mkTerm "clot_V" ;
lin clot_V2 = mkTerm "clot_V2" ;
lin cloth_N = mkTerm "cloth_N" ;
lin clothe_V2 = mkTerm "clothe_V2" ;
lin clothes_N = mkTerm "clothes_N" ;
lin clothes_basket_N = mkTerm "clothes_basket_N" ;
lin clothes_hanger_N = mkTerm "clothes_hanger_N" ;
lin clothes_moth_N = mkTerm "clothes_moth_N" ;
lin clothes_peg_N = mkTerm "clothes_peg_N" ;
lin clothes_pin_N = mkTerm "clothes_pin_N" ;
lin clothesbrush_N = mkTerm "clothesbrush_N" ;
lin clotheshorse_N = mkTerm "clotheshorse_N" ;
lin clothesless_A = mkTerm "clothesless_A" ;
lin clothesline_N = mkTerm "clothesline_N" ;
lin clothier_N = mkTerm "clothier_N" ;
lin clothing_N = mkTerm "clothing_N" ;
lin cloud_N = mkTerm "cloud_N" ;
lin cloud_V = mkTerm "cloud_V" ;
lin cloud_V2 = mkTerm "cloud_V2" ;
lin cloud_bank_N = mkTerm "cloud_bank_N" ;
lin cloud_capped_A = mkTerm "cloud_capped_A" ;
lin cloud_cuckoo_land_N = mkTerm "cloud_cuckoo_land_N" ;
lin cloud_over_V = mkTerm "cloud_over_V" ;
lin cloudberry_N = mkTerm "cloudberry_N" ;
lin cloudburst_N = mkTerm "cloudburst_N" ;
lin cloudiness_N = mkTerm "cloudiness_N" ;
lin clouding_N = mkTerm "clouding_N" ;
lin cloudless_A = mkTerm "cloudless_A" ;
lin cloudlessness_N = mkTerm "cloudlessness_N" ;
lin cloudlike_A = mkTerm "cloudlike_A" ;
lin cloudy_A = mkTerm "cloudy_A" ;
lin clout_N = mkTerm "clout_N" ;
lin clout_V2 = mkTerm "clout_V2" ;
lin clove_N = mkTerm "clove_N" ;
lin clove_hitch_N = mkTerm "clove_hitch_N" ;
lin cloven_A = mkTerm "cloven_A" ;
lin clover_N = mkTerm "clover_N" ;
lin cloverleaf_N = mkTerm "cloverleaf_N" ;
lin clowder_N = mkTerm "clowder_N" ;
lin clown_N = mkTerm "clown_N" ;
lin clown_V = mkTerm "clown_V" ;
lin clown_about_V = mkTerm "clown_about_V" ;
lin clown_around_V = mkTerm "clown_around_V" ;
lin clowne_PN = mkTerm "clowne_PN" ;
lin clownish_A = mkTerm "clownish_A" ;
lin cloy_V = mkTerm "cloy_V" ;
lin cloy_V2 = mkTerm "cloy_V2" ;
lin cloyingly_Adv = mkTerm "cloyingly_Adv" ;
lin clozapine_N = mkTerm "clozapine_N" ;
lin cloze_A = mkTerm "cloze_A" ;
lin club_1_N = mkTerm "club_1_N" ;
lin club_2_N = mkTerm "club_2_N" ;
lin club_V = mkTerm "club_V" ;
lin club_V2 = mkTerm "club_V2" ;
lin club_footed_A = mkTerm "club_footed_A" ;
lin clubbable_A = mkTerm "clubbable_A" ;
lin clubbing_N = mkTerm "clubbing_N" ;
lin clubbish_A = mkTerm "clubbish_A" ;
lin clubfoot_N = mkTerm "clubfoot_N" ;
lin clubhouse_N = mkTerm "clubhouse_N" ;
lin clubroom_N = mkTerm "clubroom_N" ;
lin cluck_N = mkTerm "cluck_N" ;
lin cluck_V = mkTerm "cluck_V" ;
lin clue_N = mkTerm "clue_N" ;
lin clueless_A = mkTerm "clueless_A" ;
lin clumber_N = mkTerm "clumber_N" ;
lin clump_N = mkTerm "clump_N" ;
lin clump_V = mkTerm "clump_V" ;
lin clump_V2 = mkTerm "clump_V2" ;
lin clumsiness_N = mkTerm "clumsiness_N" ;
lin clumsy_A = mkTerm "clumsy_A" ;
lin clunch_N = mkTerm "clunch_N" ;
lin clunk_N = mkTerm "clunk_N" ;
lin clunk_V = mkTerm "clunk_V" ;
lin clunky_A = mkTerm "clunky_A" ;
lin clusia_N = mkTerm "clusia_N" ;
lin cluster_N = mkTerm "cluster_N" ;
lin cluster_V = mkTerm "cluster_V" ;
lin cluster_V2 = mkTerm "cluster_V2" ;
lin clutch_N = mkTerm "clutch_N" ;
lin clutch_V = mkTerm "clutch_V" ;
lin clutch_V2 = mkTerm "clutch_V2" ;
lin clutch_on_V = mkTerm "clutch_on_V" ;
lin clutter_N = mkTerm "clutter_N" ;
lin clutter_V2 = mkTerm "clutter_V2" ;
lin clwyd_PN = mkTerm "clwyd_PN" ;
lin clydach_PN = mkTerm "clydach_PN" ;
lin clydebank_PN = mkTerm "clydebank_PN" ;
lin clypeus_N = mkTerm "clypeus_N" ;
lin cm_N = mkTerm "cm_N" ;
lin co_N = mkTerm "co_N" ;
lin co_author_V2 = mkTerm "co_author_V2" ;
lin co_ed_N = mkTerm "co_ed_N" ;
lin co_edit_V2 = mkTerm "co_edit_V2" ;
lin co_exist_V = mkTerm "co_exist_V" ;
lin co_found_V2 = mkTerm "co_found_V2" ;
lin co_manage_V2 = mkTerm "co_manage_V2" ;
lin co_op_N = mkTerm "co_op_N" ;
lin co_opt_V2 = mkTerm "co_opt_V2" ;
lin co_respondent_N = mkTerm "co_respondent_N" ;
lin co_sponsor_V2 = mkTerm "co_sponsor_V2" ;
lin co_star_N = mkTerm "co_star_N" ;
lin co_star_V = mkTerm "co_star_V" ;
lin co_star_V2 = mkTerm "co_star_V2" ;
lin coach_1_N = mkTerm "coach_1_N" ;
lin coach_2_N = mkTerm "coach_2_N" ;
lin coach_3_N = mkTerm "coach_3_N" ;
lin coach_V = mkTerm "coach_V" ;
lin coach_V2 = mkTerm "coach_V2" ;
lin coach_builder_N = mkTerm "coach_builder_N" ;
lin coaching_N = mkTerm "coaching_N" ;
lin coachman_N = mkTerm "coachman_N" ;
lin coachwhip_N = mkTerm "coachwhip_N" ;
lin coadjutor_N = mkTerm "coadjutor_N" ;
lin coagulable_A = mkTerm "coagulable_A" ;
lin coagulant_N = mkTerm "coagulant_N" ;
lin coagulase_N = mkTerm "coagulase_N" ;
lin coagulate_A = mkTerm "coagulate_A" ;
lin coagulate_V = mkTerm "coagulate_V" ;
lin coagulate_V2 = mkTerm "coagulate_V2" ;
lin coagulation_N = mkTerm "coagulation_N" ;
lin coal_N = mkTerm "coal_N" ;
lin coal_V = mkTerm "coal_V" ;
lin coal_V2 = mkTerm "coal_V2" ;
lin coal_gas_N = mkTerm "coal_gas_N" ;
lin coal_hole_N = mkTerm "coal_hole_N" ;
lin coal_house_N = mkTerm "coal_house_N" ;
lin coal_scuttle_N = mkTerm "coal_scuttle_N" ;
lin coal_seam_N = mkTerm "coal_seam_N" ;
lin coal_tar_N = mkTerm "coal_tar_N" ;
lin coalbin_N = mkTerm "coalbin_N" ;
lin coalesce_V = mkTerm "coalesce_V" ;
lin coalescence_N = mkTerm "coalescence_N" ;
lin coalescent_A = mkTerm "coalescent_A" ;
lin coalface_N = mkTerm "coalface_N" ;
lin coalfield_N = mkTerm "coalfield_N" ;
lin coaling_station_N = mkTerm "coaling_station_N" ;
lin coalition_N = mkTerm "coalition_N" ;
lin coalman_N = mkTerm "coalman_N" ;
lin coalmine_N = mkTerm "coalmine_N" ;
lin coalpit_N = mkTerm "coalpit_N" ;
lin coalville_PN = mkTerm "coalville_PN" ;
lin coaming_N = mkTerm "coaming_N" ;
lin coarctate_A = mkTerm "coarctate_A" ;
lin coarctation_N = mkTerm "coarctation_N" ;
lin coarse_A = mkTerm "coarse_A" ;
lin coarsen_V = mkTerm "coarsen_V" ;
lin coarsen_V2 = mkTerm "coarsen_V2" ;
lin coarseness_N = mkTerm "coarseness_N" ;
lin coast_N = mkTerm "coast_N" ;
lin coast_V = mkTerm "coast_V" ;
lin coast_V2 = mkTerm "coast_V2" ;
lin coast_along_V = mkTerm "coast_along_V" ;
lin coastal_A = mkTerm "coastal_A" ;
lin coaster_N = mkTerm "coaster_N" ;
lin coastguard_N = mkTerm "coastguard_N" ;
lin coastguardsman_N = mkTerm "coastguardsman_N" ;
lin coastland_N = mkTerm "coastland_N" ;
lin coastline_N = mkTerm "coastline_N" ;
lin coastward_Adv = mkTerm "coastward_Adv" ;
lin coastwise_A = mkTerm "coastwise_A" ;
lin coastwise_Adv = mkTerm "coastwise_Adv" ;
lin coat_N = mkTerm "coat_N" ;
lin coat_V2 = mkTerm "coat_V2" ;
lin coat_hanger_N = mkTerm "coat_hanger_N" ;
lin coatbridge_PN = mkTerm "coatbridge_PN" ;
lin coatdress_N = mkTerm "coatdress_N" ;
lin coatee_N = mkTerm "coatee_N" ;
lin coati_N = mkTerm "coati_N" ;
lin coating_N = mkTerm "coating_N" ;
lin coatrack_N = mkTerm "coatrack_N" ;
lin coattail_N = mkTerm "coattail_N" ;
lin coauthorFem_N = mkTerm "coauthorFem_N" ;
lin coauthorMasc_N = mkTerm "coauthorMasc_N" ;
lin coax_V = mkTerm "coax_V" ;
lin coax_V2 = mkTerm "coax_V2" ;
lin coaxial_A = mkTerm "coaxial_A" ;
lin coaxing_N = mkTerm "coaxing_N" ;
lin coaxingly_Adv = mkTerm "coaxingly_Adv" ;
lin cob_N = mkTerm "cob_N" ;
lin cob_nut_N = mkTerm "cob_nut_N" ;
lin cobalt_N = mkTerm "cobalt_N" ;
lin cobaltite_N = mkTerm "cobaltite_N" ;
lin cobber_N = mkTerm "cobber_N" ;
lin cobble_N = mkTerm "cobble_N" ;
lin cobble_V2 = mkTerm "cobble_V2" ;
lin cobble_together_V2 = mkTerm "cobble_together_V2" ;
lin cobbler_N = mkTerm "cobbler_N" ;
lin cobblers_N = mkTerm "cobblers_N" ;
lin cobblestone_N = mkTerm "cobblestone_N" ;
lin cobham_PN = mkTerm "cobham_PN" ;
lin cobia_N = mkTerm "cobia_N" ;
lin cobra_N = mkTerm "cobra_N" ;
lin cobweb_N = mkTerm "cobweb_N" ;
lin cobwebby_A = mkTerm "cobwebby_A" ;
lin coca_N = mkTerm "coca_N" ;
lin coca_cola_N = mkTerm "coca_cola_N" ;
lin cocaine_N = mkTerm "cocaine_N" ;
lin cocarboxylase_N = mkTerm "cocarboxylase_N" ;
lin coccal_A = mkTerm "coccal_A" ;
lin coccidioidomycosis_N = mkTerm "coccidioidomycosis_N" ;
lin coccidiosis_N = mkTerm "coccidiosis_N" ;
lin coccidium_N = mkTerm "coccidium_N" ;
lin coccobacillus_N = mkTerm "coccobacillus_N" ;
lin coccoid_A = mkTerm "coccoid_A" ;
lin coccus_N = mkTerm "coccus_N" ;
lin coccygeal_A = mkTerm "coccygeal_A" ;
lin coccyx_N = mkTerm "coccyx_N" ;
lin cochin_N = mkTerm "cochin_N" ;
lin cochineal_N = mkTerm "cochineal_N" ;
lin cochlea_N = mkTerm "cochlea_N" ;
lin cochlear_A = mkTerm "cochlear_A" ;
lin cock_N = mkTerm "cock_N" ;
lin cock_V2 = mkTerm "cock_V2" ;
lin cock_a_doodle_doo_N = mkTerm "cock_a_doodle_doo_N" ;
lin cock_a_hoop_A = mkTerm "cock_a_hoop_A" ;
lin cock_a_hoop_Adv = mkTerm "cock_a_hoop_Adv" ;
lin cock_crow_N = mkTerm "cock_crow_N" ;
lin cock_up_V2 = mkTerm "cock_up_V2" ;
lin cockade_N = mkTerm "cockade_N" ;
lin cockamamie_A = mkTerm "cockamamie_A" ;
lin cockateel_N = mkTerm "cockateel_N" ;
lin cockatoo_N = mkTerm "cockatoo_N" ;
lin cockatrice_N = mkTerm "cockatrice_N" ;
lin cockchafer_N = mkTerm "cockchafer_N" ;
lin cocker_N = mkTerm "cocker_N" ;
lin cockerel_N = mkTerm "cockerel_N" ;
lin cockermouth_PN = mkTerm "cockermouth_PN" ;
lin cockeyed_A = mkTerm "cockeyed_A" ;
lin cockfight_N = mkTerm "cockfight_N" ;
lin cockfighting_N = mkTerm "cockfighting_N" ;
lin cockhorse_N = mkTerm "cockhorse_N" ;
lin cockle_N = mkTerm "cockle_N" ;
lin cocklebur_N = mkTerm "cocklebur_N" ;
lin cockleshell_N = mkTerm "cockleshell_N" ;
lin cockloft_N = mkTerm "cockloft_N" ;
lin cockney_A = mkTerm "cockney_A" ;
lin cockney_N = mkTerm "cockney_N" ;
lin cockpit_N = mkTerm "cockpit_N" ;
lin cockroach_N = mkTerm "cockroach_N" ;
lin cockscomb_N = mkTerm "cockscomb_N" ;
lin cockspur_N = mkTerm "cockspur_N" ;
lin cocksucker_N = mkTerm "cocksucker_N" ;
lin cocksure_A = mkTerm "cocksure_A" ;
lin cocktail_N = mkTerm "cocktail_N" ;
lin cockup_N = mkTerm "cockup_N" ;
lin cocky_A = mkTerm "cocky_A" ;
lin coco_N = mkTerm "coco_N" ;
lin cocoa_N = mkTerm "cocoa_N" ;
lin cocobolo_N = mkTerm "cocobolo_N" ;
lin coconut_N = mkTerm "coconut_N" ;
lin cocoon_N = mkTerm "cocoon_N" ;
lin cocoon_V2 = mkTerm "cocoon_V2" ;
lin cocooning_N = mkTerm "cocooning_N" ;
lin cocotte_N = mkTerm "cocotte_N" ;
lin cocozelle_N = mkTerm "cocozelle_N" ;
lin cocuswood_N = mkTerm "cocuswood_N" ;
lin cod_N = mkTerm "cod_N" ;
lin cod_PN = mkTerm "cod_PN" ;
lin cod_V = mkTerm "cod_V" ;
lin cod_V2 = mkTerm "cod_V2" ;
lin cod_liver_oil_N = mkTerm "cod_liver_oil_N" ;
lin coda_N = mkTerm "coda_N" ;
lin coddle_V2 = mkTerm "coddle_V2" ;
lin code_N = mkTerm "code_N" ;
lin code_V2 = mkTerm "code_V2" ;
lin codefendant_N = mkTerm "codefendant_N" ;
lin codeine_N = mkTerm "codeine_N" ;
lin codetalker_N = mkTerm "codetalker_N" ;
lin codex_N = mkTerm "codex_N" ;
lin codfish_N = mkTerm "codfish_N" ;
lin codger_N = mkTerm "codger_N" ;
lin codicil_N = mkTerm "codicil_N" ;
lin codification_N = mkTerm "codification_N" ;
lin codify_V2 = mkTerm "codify_V2" ;
lin codling_N = mkTerm "codling_N" ;
lin codon_N = mkTerm "codon_N" ;
lin codpiece_N = mkTerm "codpiece_N" ;
lin codsall_PN = mkTerm "codsall_PN" ;
lin coeducation_N = mkTerm "coeducation_N" ;
lin coeducational_A = mkTerm "coeducational_A" ;
lin coefficient_N = mkTerm "coefficient_N" ;
lin coelacanth_N = mkTerm "coelacanth_N" ;
lin coelenterate_N = mkTerm "coelenterate_N" ;
lin coelenteron_N = mkTerm "coelenteron_N" ;
lin coeliac_A = mkTerm "coeliac_A" ;
lin coelogyne_N = mkTerm "coelogyne_N" ;
lin coelophysis_N = mkTerm "coelophysis_N" ;
lin coelostat_N = mkTerm "coelostat_N" ;
lin coenzyme_N = mkTerm "coenzyme_N" ;
lin coequal_A = mkTerm "coequal_A" ;
lin coerce_V2 = mkTerm "coerce_V2" ;
lin coercion_N = mkTerm "coercion_N" ;
lin coercive_A = mkTerm "coercive_A" ;
lin coetaneous_A = mkTerm "coetaneous_A" ;
lin coeval_A = mkTerm "coeval_A" ;
lin coeval_N = mkTerm "coeval_N" ;
lin coexistence_N = mkTerm "coexistence_N" ;
lin coexistent_A = mkTerm "coexistent_A" ;
lin coextension_N = mkTerm "coextension_N" ;
lin coextensive_A = mkTerm "coextensive_A" ;
lin coextrude_V2 = mkTerm "coextrude_V2" ;
lin cofactor_N = mkTerm "cofactor_N" ;
lin coffee_N = mkTerm "coffee_N" ;
lin coffee_house_N = mkTerm "coffee_house_N" ;
lin coffee_mill_N = mkTerm "coffee_mill_N" ;
lin coffee_stall_N = mkTerm "coffee_stall_N" ;
lin coffeeberry_N = mkTerm "coffeeberry_N" ;
lin coffeecake_N = mkTerm "coffeecake_N" ;
lin coffeepot_N = mkTerm "coffeepot_N" ;
lin coffer_N = mkTerm "coffer_N" ;
lin coffer_dam_N = mkTerm "coffer_dam_N" ;
lin coffin_N = mkTerm "coffin_N" ;
lin cofounder_N = mkTerm "cofounder_N" ;
lin cog_N = mkTerm "cog_N" ;
lin cogency_N = mkTerm "cogency_N" ;
lin cogent_A = mkTerm "cogent_A" ;
lin cogged_A = mkTerm "cogged_A" ;
lin cogitable_A = mkTerm "cogitable_A" ;
lin cogitate_V = mkTerm "cogitate_V" ;
lin cogitate_V2 = mkTerm "cogitate_V2" ;
lin cogitation_N = mkTerm "cogitation_N" ;
lin cogitative_A = mkTerm "cogitative_A" ;
lin cognac_N = mkTerm "cognac_N" ;
lin cognate_A = mkTerm "cognate_A" ;
lin cognate_N = mkTerm "cognate_N" ;
lin cognition_N = mkTerm "cognition_N" ;
lin cognitive_A = mkTerm "cognitive_A" ;
lin cognizance_N = mkTerm "cognizance_N" ;
lin cognizant_A = mkTerm "cognizant_A" ;
lin cognomen_N = mkTerm "cognomen_N" ;
lin cogwheel_N = mkTerm "cogwheel_N" ;
lin cohabit_V = mkTerm "cohabit_V" ;
lin cohabitation_N = mkTerm "cohabitation_N" ;
lin cohere_V = mkTerm "cohere_V" ;
lin coherence_N = mkTerm "coherence_N" ;
lin coherency_N = mkTerm "coherency_N" ;
lin coherent_A = mkTerm "coherent_A" ;
lin cohesion_N = mkTerm "cohesion_N" ;
lin cohesive_A = mkTerm "cohesive_A" ;
lin cohesiveness_N = mkTerm "cohesiveness_N" ;
lin coho_N = mkTerm "coho_N" ;
lin cohomology_N = mkTerm "cohomology_N" ;
lin cohort_N = mkTerm "cohort_N" ;
lin coif_N = mkTerm "coif_N" ;
lin coiffeur_N = mkTerm "coiffeur_N" ;
lin coiffeuse_N = mkTerm "coiffeuse_N" ;
lin coiffure_N = mkTerm "coiffure_N" ;
lin coign_N = mkTerm "coign_N" ;
lin coil_N = mkTerm "coil_N" ;
lin coil_V = mkTerm "coil_V" ;
lin coil_V2 = mkTerm "coil_V2" ;
lin coimbatore_PN = mkTerm "coimbatore_PN" ;
lin coin_N = mkTerm "coin_N" ;
lin coin_V2 = mkTerm "coin_V2" ;
lin coinage_N = mkTerm "coinage_N" ;
lin coincide_V = mkTerm "coincide_V" ;
lin coincidence_N = mkTerm "coincidence_N" ;
lin coincident_A = mkTerm "coincident_A" ;
lin coincidental_A = mkTerm "coincidental_A" ;
lin coiner_N = mkTerm "coiner_N" ;
lin coinsurance_N = mkTerm "coinsurance_N" ;
lin coir_N = mkTerm "coir_N" ;
lin coital_A = mkTerm "coital_A" ;
lin coition_N = mkTerm "coition_N" ;
lin coitus_N = mkTerm "coitus_N" ;
lin coke_N = mkTerm "coke_N" ;
lin coke_V2 = mkTerm "coke_V2" ;
lin col_N = mkTerm "col_N" ;
lin col_PN = mkTerm "col_PN" ;
lin cola_N = mkTerm "cola_N" ;
lin colander_N = mkTerm "colander_N" ;
lin colchester_PN = mkTerm "colchester_PN" ;
lin colchicine_N = mkTerm "colchicine_N" ;
lin cold_A = mkTerm "cold_A" ;
lin cold_N = mkTerm "cold_N" ;
lin cold_blooded_A = mkTerm "cold_blooded_A" ;
lin cold_hearted_A = mkTerm "cold_hearted_A" ;
lin cold_shoulder_V2 = mkTerm "cold_shoulder_V2" ;
lin coldness_N = mkTerm "coldness_N" ;
lin coleshill_PN = mkTerm "coleshill_PN" ;
lin coleslaw_N = mkTerm "coleslaw_N" ;
lin coleus_N = mkTerm "coleus_N" ;
lin colic_N = mkTerm "colic_N" ;
lin colicky_A = mkTerm "colicky_A" ;
lin colicroot_N = mkTerm "colicroot_N" ;
lin colin_N = mkTerm "colin_N" ;
lin colin_PN = mkTerm "colin_PN" ;
lin coliphage_N = mkTerm "coliphage_N" ;
lin colitis_N = mkTerm "colitis_N" ;
lin coll_PN = mkTerm "coll_PN" ;
lin collaborate_V = mkTerm "collaborate_V" ;
lin collaboration_N = mkTerm "collaboration_N" ;
lin collaborationist_N = mkTerm "collaborationist_N" ;
lin collaborative_A = mkTerm "collaborative_A" ;
lin collaborator_N = mkTerm "collaborator_N" ;
lin collage_N = mkTerm "collage_N" ;
lin collagen_N = mkTerm "collagen_N" ;
lin collagenase_N = mkTerm "collagenase_N" ;
lin collagenous_A = mkTerm "collagenous_A" ;
lin collapsable_A = mkTerm "collapsable_A" ;
lin collapse_N = mkTerm "collapse_N" ;
lin collapse_V = mkTerm "collapse_V" ;
lin collapse_V2 = mkTerm "collapse_V2" ;
lin collapsible_A = mkTerm "collapsible_A" ;
lin collar_N = mkTerm "collar_N" ;
lin collar_V2 = mkTerm "collar_V2" ;
lin collarbone_N = mkTerm "collarbone_N" ;
lin collard_N = mkTerm "collard_N" ;
lin collards_N = mkTerm "collards_N" ;
lin collarless_A = mkTerm "collarless_A" ;
lin collate_V2 = mkTerm "collate_V2" ;
lin collateral_A = mkTerm "collateral_A" ;
lin collateral_N = mkTerm "collateral_N" ;
lin collation_N = mkTerm "collation_N" ;
lin colleague_N = mkTerm "colleague_N" ;
lin collect_A = mkTerm "collect_A" ;
lin collect_Adv = mkTerm "collect_Adv" ;
lin collect_N = mkTerm "collect_N" ;
lin collect_V = mkTerm "collect_V" ;
lin collect_V2 = mkTerm "collect_V2" ;
lin collectedly_Adv = mkTerm "collectedly_Adv" ;
lin collectible_A = mkTerm "collectible_A" ;
lin collectible_N = mkTerm "collectible_N" ;
lin collection_N = mkTerm "collection_N" ;
lin collective_A = mkTerm "collective_A" ;
lin collective_N = mkTerm "collective_N" ;
lin collectivism_N = mkTerm "collectivism_N" ;
lin collectivist_A = mkTerm "collectivist_A" ;
lin collectivist_N = mkTerm "collectivist_N" ;
lin collectivization_N = mkTerm "collectivization_N" ;
lin collectivize_V2 = mkTerm "collectivize_V2" ;
lin collector_N = mkTerm "collector_N" ;
lin colleen_N = mkTerm "colleen_N" ;
lin college_N = mkTerm "college_N" ;
lin collegial_A = mkTerm "collegial_A" ;
lin collegian_N = mkTerm "collegian_N" ;
lin collegiate_A = mkTerm "collegiate_A" ;
lin collembolan_N = mkTerm "collembolan_N" ;
lin collet_N = mkTerm "collet_N" ;
lin collide_V = mkTerm "collide_V" ;
lin collider_N = mkTerm "collider_N" ;
lin collie_N = mkTerm "collie_N" ;
lin collier_N = mkTerm "collier_N" ;
lin colliery_N = mkTerm "colliery_N" ;
lin colligation_N = mkTerm "colligation_N" ;
lin collimation_N = mkTerm "collimation_N" ;
lin collimator_N = mkTerm "collimator_N" ;
lin collinear_A = mkTerm "collinear_A" ;
lin collins_N = mkTerm "collins_N" ;
lin collision_N = mkTerm "collision_N" ;
lin collocate_V = mkTerm "collocate_V" ;
lin collocation_N = mkTerm "collocation_N" ;
lin collodion_N = mkTerm "collodion_N" ;
lin colloid_N = mkTerm "colloid_N" ;
lin colloidal_A = mkTerm "colloidal_A" ;
lin colloquial_A = mkTerm "colloquial_A" ;
lin colloquialism_N = mkTerm "colloquialism_N" ;
lin colloquium_N = mkTerm "colloquium_N" ;
lin colloquy_N = mkTerm "colloquy_N" ;
lin collotype_N = mkTerm "collotype_N" ;
lin collusion_N = mkTerm "collusion_N" ;
lin collusive_A = mkTerm "collusive_A" ;
lin colne_PN = mkTerm "colne_PN" ;
lin colobus_N = mkTerm "colobus_N" ;
lin cologne_N = mkTerm "cologne_N" ;
lin cologne_PN = mkTerm "cologne_PN" ;
lin colombia_PN = mkTerm "colombia_PN" ;
lin colombian_A = mkTerm "colombian_A" ;
lin colombian_N = mkTerm "colombian_N" ;
lin colombo_PN = mkTerm "colombo_PN" ;
lin colon_N = mkTerm "colon_N" ;
lin colonel_N = mkTerm "colonel_N" ;
lin colonial_A = mkTerm "colonial_A" ;
lin colonial_N = mkTerm "colonial_N" ;
lin colonialism_N = mkTerm "colonialism_N" ;
lin colonialist_N = mkTerm "colonialist_N" ;
lin colonic_A = mkTerm "colonic_A" ;
lin colonist_N = mkTerm "colonist_N" ;
lin colonization_N = mkTerm "colonization_N" ;
lin colonize_V2 = mkTerm "colonize_V2" ;
lin colonizer_N = mkTerm "colonizer_N" ;
lin colonnade_N = mkTerm "colonnade_N" ;
lin colonnaded_A = mkTerm "colonnaded_A" ;
lin colonoscope_N = mkTerm "colonoscope_N" ;
lin colonoscopy_N = mkTerm "colonoscopy_N" ;
lin colony_N = mkTerm "colony_N" ;
lin colophon_N = mkTerm "colophon_N" ;
lin colophony_N = mkTerm "colophony_N" ;
lin colorado_PN = mkTerm "colorado_PN" ;
lin coloration_N = mkTerm "coloration_N" ;
lin coloratura_N = mkTerm "coloratura_N" ;
lin colorcast_N = mkTerm "colorcast_N" ;
lin colorectal_A = mkTerm "colorectal_A" ;
lin colorfast_A = mkTerm "colorfast_A" ;
lin colorimeter_N = mkTerm "colorimeter_N" ;
lin colorimetric_A = mkTerm "colorimetric_A" ;
lin colorimetry_N = mkTerm "colorimetry_N" ;
lin colorist_N = mkTerm "colorist_N" ;
lin colorlessness_N = mkTerm "colorlessness_N" ;
lin colossal_A = mkTerm "colossal_A" ;
lin colossus_N = mkTerm "colossus_N" ;
lin colostomy_N = mkTerm "colostomy_N" ;
lin colostrum_N = mkTerm "colostrum_N" ;
lin colour_A = mkTerm "colour_A" ;
lin colour_N = mkTerm "colour_N" ;
lin colour_V = mkTerm "colour_V" ;
lin colour_V2 = mkTerm "colour_V2" ;
lin colour_V2A = mkTerm "colour_V2A" ;
lin colour_bar_N = mkTerm "colour_bar_N" ;
lin colour_blind_A = mkTerm "colour_blind_A" ;
lin colour_code_V2 = mkTerm "colour_code_V2" ;
lin colour_up_V = mkTerm "colour_up_V" ;
lin colour_wash_N = mkTerm "colour_wash_N" ;
lin coloured_A = mkTerm "coloured_A" ;
lin colourful_A = mkTerm "colourful_A" ;
lin colouring_N = mkTerm "colouring_N" ;
lin colourless_A = mkTerm "colourless_A" ;
lin colpitis_N = mkTerm "colpitis_N" ;
lin colpocele_N = mkTerm "colpocele_N" ;
lin colpocystitis_N = mkTerm "colpocystitis_N" ;
lin colpoxerosis_N = mkTerm "colpoxerosis_N" ;
lin colspan_N = mkTerm "colspan_N" ;
lin colt_N = mkTerm "colt_N" ;
lin colter_N = mkTerm "colter_N" ;
lin coltish_A = mkTerm "coltish_A" ;
lin coltsfoot_N = mkTerm "coltsfoot_N" ;
lin columbarium_N = mkTerm "columbarium_N" ;
lin columbia_PN = mkTerm "columbia_PN" ;
lin columbine_N = mkTerm "columbine_N" ;
lin columbium_N = mkTerm "columbium_N" ;
lin columbo_N = mkTerm "columbo_N" ;
lin columbus_PN = mkTerm "columbus_PN" ;
lin columella_N = mkTerm "columella_N" ;
lin column_N = mkTerm "column_N" ;
lin columnar_A = mkTerm "columnar_A" ;
lin columnea_N = mkTerm "columnea_N" ;
lin columned_A = mkTerm "columned_A" ;
lin columniation_N = mkTerm "columniation_N" ;
lin columniform_A = mkTerm "columniform_A" ;
lin columnistFem_N = mkTerm "columnistFem_N" ;
lin columnistMasc_N = mkTerm "columnistMasc_N" ;
lin colwyn_bay_PN = mkTerm "colwyn_bay_PN" ;
lin coma_N = mkTerm "coma_N" ;
lin comate_A = mkTerm "comate_A" ;
lin comatose_A = mkTerm "comatose_A" ;
lin comb_N = mkTerm "comb_N" ;
lin comb_V = mkTerm "comb_V" ;
lin comb_V2 = mkTerm "comb_V2" ;
lin comb_out_N = mkTerm "comb_out_N" ;
lin combat_N = mkTerm "combat_N" ;
lin combat_V = mkTerm "combat_V" ;
lin combat_V2 = mkTerm "combat_V2" ;
lin combatant_A = mkTerm "combatant_A" ;
lin combatant_N = mkTerm "combatant_N" ;
lin combative_A = mkTerm "combative_A" ;
lin combativeness_N = mkTerm "combativeness_N" ;
lin comber_N = mkTerm "comber_N" ;
lin combinable_A = mkTerm "combinable_A" ;
lin combination_N = mkTerm "combination_N" ;
lin combination_lock_N = mkTerm "combination_lock_N" ;
lin combinative_A = mkTerm "combinative_A" ;
lin combinatorial_A = mkTerm "combinatorial_A" ;
lin combine_N = mkTerm "combine_N" ;
lin combine_V = mkTerm "combine_V" ;
lin combine_V2 = mkTerm "combine_V2" ;
lin combine_VV = mkTerm "combine_VV" ;
lin combined_A = mkTerm "combined_A" ;
lin combining_N = mkTerm "combining_N" ;
lin combo_N = mkTerm "combo_N" ;
lin combretum_N = mkTerm "combretum_N" ;
lin comburent_A = mkTerm "comburent_A" ;
lin combustibility_N = mkTerm "combustibility_N" ;
lin combustible_A = mkTerm "combustible_A" ;
lin combustible_N = mkTerm "combustible_N" ;
lin combustion_N = mkTerm "combustion_N" ;
lin come_V = mkTerm "come_V" ;
lin come_about_V = mkTerm "come_about_V" ;
lin come_across_V = mkTerm "come_across_V" ;
lin come_across_V2 = mkTerm "come_across_V2" ;
lin come_along_V = mkTerm "come_along_V" ;
lin come_along_with_V2 = mkTerm "come_along_with_V2" ;
lin come_apart_V = mkTerm "come_apart_V" ;
lin come_around_V = mkTerm "come_around_V" ;
lin come_around_to_V2 = mkTerm "come_around_to_V2" ;
lin come_at_able_A = mkTerm "come_at_able_A" ;
lin come_away_V = mkTerm "come_away_V" ;
lin come_back_V = mkTerm "come_back_V" ;
lin come_before_V2 = mkTerm "come_before_V2" ;
lin come_by_V = mkTerm "come_by_V" ;
lin come_by_V2 = mkTerm "come_by_V2" ;
lin come_down_V = mkTerm "come_down_V" ;
lin come_down_on_V2 = mkTerm "come_down_on_V2" ;
lin come_down_upon_V2 = mkTerm "come_down_upon_V2" ;
lin come_down_with_V2 = mkTerm "come_down_with_V2" ;
lin come_forth_V = mkTerm "come_forth_V" ;
lin come_forth_with_V2 = mkTerm "come_forth_with_V2" ;
lin come_forward_V = mkTerm "come_forward_V" ;
lin come_from_V2 = mkTerm "come_from_V2" ;
lin come_in_V = mkTerm "come_in_V" ;
lin come_in_V2 = mkTerm "come_in_V2" ;
lin come_in_for_V2 = mkTerm "come_in_for_V2" ;
lin come_into_V2 = mkTerm "come_into_V2" ;
lin come_into_use_V = mkTerm "come_into_use_V" ;
lin come_off_V = mkTerm "come_off_V" ;
lin come_off_V2 = mkTerm "come_off_V2" ;
lin come_off_it_V = mkTerm "come_off_it_V" ;
lin come_on_N = mkTerm "come_on_N" ;
lin come_on_V = mkTerm "come_on_V" ;
lin come_out_V = mkTerm "come_out_V" ;
lin come_out_in_V2 = mkTerm "come_out_in_V2" ;
lin come_out_of_V2 = mkTerm "come_out_of_V2" ;
lin come_out_with_V2 = mkTerm "come_out_with_V2" ;
lin come_over_V = mkTerm "come_over_V" ;
lin come_over_V2 = mkTerm "come_over_V2" ;
lin come_round_V = mkTerm "come_round_V" ;
lin come_through_V = mkTerm "come_through_V" ;
lin come_through_with_V2 = mkTerm "come_through_with_V2" ;
lin come_to_V = mkTerm "come_to_V" ;
lin come_to_V2 = mkTerm "come_to_V2" ;
lin come_up_V = mkTerm "come_up_V" ;
lin come_up_against_V2 = mkTerm "come_up_against_V2" ;
lin come_up_to_V2 = mkTerm "come_up_to_V2" ;
lin come_up_with_V2 = mkTerm "come_up_with_V2" ;
lin come_upon_V2 = mkTerm "come_upon_V2" ;
lin come_with_V2 = mkTerm "come_with_V2" ;
lin comeback_N = mkTerm "comeback_N" ;
lin comedian_N = mkTerm "comedian_N" ;
lin comedic_A = mkTerm "comedic_A" ;
lin comedienne_N = mkTerm "comedienne_N" ;
lin comedown_N = mkTerm "comedown_N" ;
lin comedy_N = mkTerm "comedy_N" ;
lin comeliness_N = mkTerm "comeliness_N" ;
lin comely_A = mkTerm "comely_A" ;
lin comer_N = mkTerm "comer_N" ;
lin comestible_N = mkTerm "comestible_N" ;
lin comet_N = mkTerm "comet_N" ;
lin cometary_A = mkTerm "cometary_A" ;
lin comfit_N = mkTerm "comfit_N" ;
lin comfort_N = mkTerm "comfort_N" ;
lin comfort_V2 = mkTerm "comfort_V2" ;
lin comfortable_A = mkTerm "comfortable_A" ;
lin comfortableness_N = mkTerm "comfortableness_N" ;
lin comforter_N = mkTerm "comforter_N" ;
lin comforting_A = mkTerm "comforting_A" ;
lin comfortless_A = mkTerm "comfortless_A" ;
lin comfrey_N = mkTerm "comfrey_N" ;
lin comfy_A = mkTerm "comfy_A" ;
lin comic_A = mkTerm "comic_A" ;
lin comic_N = mkTerm "comic_N" ;
lin comical_A = mkTerm "comical_A" ;
lin comicality_N = mkTerm "comicality_N" ;
lin coming_A = mkTerm "coming_A" ;
lin coming_N = mkTerm "coming_N" ;
lin comity_N = mkTerm "comity_N" ;
lin comma_N = mkTerm "comma_N" ;
lin command_1_N = mkTerm "command_1_N" ;
lin command_2_N = mkTerm "command_2_N" ;
lin command_V = mkTerm "command_V" ;
lin command_V2 = mkTerm "command_V2" ;
lin commandant_N = mkTerm "commandant_N" ;
lin commandeer_V2 = mkTerm "commandeer_V2" ;
lin commander_N = mkTerm "commander_N" ;
lin commandership_N = mkTerm "commandership_N" ;
lin commandment_N = mkTerm "commandment_N" ;
lin commando_N = mkTerm "commando_N" ;
lin commelina_N = mkTerm "commelina_N" ;
lin commemorate_V2 = mkTerm "commemorate_V2" ;
lin commemoration_N = mkTerm "commemoration_N" ;
lin commemorative_A = mkTerm "commemorative_A" ;
lin commemorative_N = mkTerm "commemorative_N" ;
lin commence_V = mkTerm "commence_V" ;
lin commence_V2 = mkTerm "commence_V2" ;
lin commencement_N = mkTerm "commencement_N" ;
lin commend_V2 = mkTerm "commend_V2" ;
lin commendable_A = mkTerm "commendable_A" ;
lin commendation_N = mkTerm "commendation_N" ;
lin commensal_A = mkTerm "commensal_A" ;
lin commensal_N = mkTerm "commensal_N" ;
lin commensalism_N = mkTerm "commensalism_N" ;
lin commensurable_A = mkTerm "commensurable_A" ;
lin commensurate_A = mkTerm "commensurate_A" ;
lin commensurateness_N = mkTerm "commensurateness_N" ;
lin comment_N = mkTerm "comment_N" ;
lin comment_V = mkTerm "comment_V" ;
lin comment_V2 = mkTerm "comment_V2" ;
lin comment_VS = mkTerm "comment_VS" ;
lin commentary_N = mkTerm "commentary_N" ;
lin commentate_V = mkTerm "commentate_V" ;
lin commentator_N = mkTerm "commentator_N" ;
lin commerce_N = mkTerm "commerce_N" ;
lin commercial_A = mkTerm "commercial_A" ;
lin commercial_N = mkTerm "commercial_N" ;
lin commercialism_N = mkTerm "commercialism_N" ;
lin commercialization_N = mkTerm "commercialization_N" ;
lin commercialize_V2 = mkTerm "commercialize_V2" ;
lin commination_N = mkTerm "commination_N" ;
lin comminatory_A = mkTerm "comminatory_A" ;
lin commingle_V = mkTerm "commingle_V" ;
lin commingle_V2 = mkTerm "commingle_V2" ;
lin commiserate_V = mkTerm "commiserate_V" ;
lin commiseration_N = mkTerm "commiseration_N" ;
lin commiserative_A = mkTerm "commiserative_A" ;
lin commissar_N = mkTerm "commissar_N" ;
lin commissariat_N = mkTerm "commissariat_N" ;
lin commissary_N = mkTerm "commissary_N" ;
lin commission_N = mkTerm "commission_N" ;
lin commission_V2 = mkTerm "commission_V2" ;
lin commission_V2V = mkTerm "commission_V2V" ;
lin commissionaire_N = mkTerm "commissionaire_N" ;
lin commissioner_N = mkTerm "commissioner_N" ;
lin commissure_N = mkTerm "commissure_N" ;
lin commit_V2 = mkTerm "commit_V2" ;
lin commital_N = mkTerm "commital_N" ;
lin commitment_N = mkTerm "commitment_N" ;
lin committed_A = mkTerm "committed_A" ;
lin committedness_N = mkTerm "committedness_N" ;
lin committee_N = mkTerm "committee_N" ;
lin committeeman_N = mkTerm "committeeman_N" ;
lin committeewoman_N = mkTerm "committeewoman_N" ;
lin commode_1_N = mkTerm "commode_1_N" ;
lin commode_2_N = mkTerm "commode_2_N" ;
lin commodious_A = mkTerm "commodious_A" ;
lin commodity_N = mkTerm "commodity_N" ;
lin commodore_N = mkTerm "commodore_N" ;
lin common_1_A = mkTerm "common_1_A" ;
lin common_2_A = mkTerm "common_2_A" ;
lin common_N = mkTerm "common_N" ;
lin common_room_N = mkTerm "common_room_N" ;
lin commonage_N = mkTerm "commonage_N" ;
lin commonality_N = mkTerm "commonality_N" ;
lin commonalty_N = mkTerm "commonalty_N" ;
lin commoner_N = mkTerm "commoner_N" ;
lin commonness_N = mkTerm "commonness_N" ;
lin commonplace_A = mkTerm "commonplace_A" ;
lin commonplace_N = mkTerm "commonplace_N" ;
lin commons_N = mkTerm "commons_N" ;
lin commonsense_A = mkTerm "commonsense_A" ;
lin commonwealth_N = mkTerm "commonwealth_N" ;
lin commotion_N = mkTerm "commotion_N" ;
lin communal_A = mkTerm "communal_A" ;
lin communalism_N = mkTerm "communalism_N" ;
lin commune_N = mkTerm "commune_N" ;
lin commune_V = mkTerm "commune_V" ;
lin communicable_A = mkTerm "communicable_A" ;
lin communicant_N = mkTerm "communicant_N" ;
lin communicate_V = mkTerm "communicate_V" ;
lin communicate_V2 = mkTerm "communicate_V2" ;
lin communication_N = mkTerm "communication_N" ;
lin communicational_A = mkTerm "communicational_A" ;
lin communications_N = mkTerm "communications_N" ;
lin communicative_A = mkTerm "communicative_A" ;
lin communicativeness_N = mkTerm "communicativeness_N" ;
lin communicator_N = mkTerm "communicator_N" ;
lin communion_N = mkTerm "communion_N" ;
lin communique_N = mkTerm "communique_N" ;
lin communism_N = mkTerm "communism_N" ;
lin communist_A = mkTerm "communist_A" ;
lin communist_N = mkTerm "communist_N" ;
lin community_N = mkTerm "community_N" ;
lin communization_N = mkTerm "communization_N" ;
lin commutability_N = mkTerm "commutability_N" ;
lin commutable_A = mkTerm "commutable_A" ;
lin commutation_N = mkTerm "commutation_N" ;
lin commutative_A = mkTerm "commutative_A" ;
lin commutator_N = mkTerm "commutator_N" ;
lin commute_N = mkTerm "commute_N" ;
lin commute_V = mkTerm "commute_V" ;
lin commute_V2 = mkTerm "commute_V2" ;
lin commuter_N = mkTerm "commuter_N" ;
lin compact_A = mkTerm "compact_A" ;
lin compact_N = mkTerm "compact_N" ;
lin compact_V2 = mkTerm "compact_V2" ;
lin compaction_N = mkTerm "compaction_N" ;
lin compactness_N = mkTerm "compactness_N" ;
lin companion_N = mkTerm "companion_N" ;
lin companionability_N = mkTerm "companionability_N" ;
lin companionable_A = mkTerm "companionable_A" ;
lin companionate_A = mkTerm "companionate_A" ;
lin companionship_N = mkTerm "companionship_N" ;
lin companionway_N = mkTerm "companionway_N" ;
lin company_1_N = mkTerm "company_1_N" ;
lin company_2_N = mkTerm "company_2_N" ;
lin comparability_N = mkTerm "comparability_N" ;
lin comparable_A = mkTerm "comparable_A" ;
lin comparative_A = mkTerm "comparative_A" ;
lin comparative_N = mkTerm "comparative_N" ;
lin compare_N = mkTerm "compare_N" ;
lin compare_V = mkTerm "compare_V" ;
lin comparison_N = mkTerm "comparison_N" ;
lin compartment_N = mkTerm "compartment_N" ;
lin compartmental_A = mkTerm "compartmental_A" ;
lin compartmentalization_N = mkTerm "compartmentalization_N" ;
lin compartmentalize_V2 = mkTerm "compartmentalize_V2" ;
lin compartmented_A = mkTerm "compartmented_A" ;
lin compass_N = mkTerm "compass_N" ;
lin compass_V2 = mkTerm "compass_V2" ;
lin compassion_N = mkTerm "compassion_N" ;
lin compassionate_A = mkTerm "compassionate_A" ;
lin compatibility_N = mkTerm "compatibility_N" ;
lin compatible_A = mkTerm "compatible_A" ;
lin compatible_N = mkTerm "compatible_N" ;
lin compatriotFem_N = mkTerm "compatriotFem_N" ;
lin compatriotMasc_N = mkTerm "compatriotMasc_N" ;
lin compeer_N = mkTerm "compeer_N" ;
lin compel_V2 = mkTerm "compel_V2" ;
lin compel_V2V = mkTerm "compel_V2V" ;
lin compel_VV = mkTerm "compel_VV" ;
lin compelling_A = mkTerm "compelling_A" ;
lin compendious_A = mkTerm "compendious_A" ;
lin compendium_N = mkTerm "compendium_N" ;
lin compensable_A = mkTerm "compensable_A" ;
lin compensate_V = mkTerm "compensate_V" ;
lin compensate_V2 = mkTerm "compensate_V2" ;
lin compensation_N = mkTerm "compensation_N" ;
lin compensatory_A = mkTerm "compensatory_A" ;
lin compere_N = mkTerm "compere_N" ;
lin compere_V2 = mkTerm "compere_V2" ;
lin compete_V = mkTerm "compete_V" ;
lin competence_N = mkTerm "competence_N" ;
lin competent_A = mkTerm "competent_A" ;
lin competition_N = mkTerm "competition_N" ;
lin competitive_A = mkTerm "competitive_A" ;
lin competitiveness_N = mkTerm "competitiveness_N" ;
lin competitor_N = mkTerm "competitor_N" ;
lin compilation_N = mkTerm "compilation_N" ;
lin compile_V2 = mkTerm "compile_V2" ;
lin compiler_N = mkTerm "compiler_N" ;
lin complacence_N = mkTerm "complacence_N" ;
lin complacency_N = mkTerm "complacency_N" ;
lin complacent_A = mkTerm "complacent_A" ;
lin complain_V = mkTerm "complain_V" ;
lin complain_VS = mkTerm "complain_VS" ;
lin complainant_N = mkTerm "complainant_N" ;
lin complainingly_Adv = mkTerm "complainingly_Adv" ;
lin complaint_N = mkTerm "complaint_N" ;
lin complaisance_N = mkTerm "complaisance_N" ;
lin complaisant_A = mkTerm "complaisant_A" ;
lin complement_N = mkTerm "complement_N" ;
lin complement_V2 = mkTerm "complement_V2" ;
lin complemental_A = mkTerm "complemental_A" ;
lin complementarity_N = mkTerm "complementarity_N" ;
lin complementary_A = mkTerm "complementary_A" ;
lin complementation_N = mkTerm "complementation_N" ;
lin complete_A = mkTerm "complete_A" ;
lin complete_V = mkTerm "complete_V" ;
lin complete_V2 = mkTerm "complete_V2" ;
lin completeness_N = mkTerm "completeness_N" ;
lin completion_N = mkTerm "completion_N" ;
lin complex_A = mkTerm "complex_A" ;
lin complex_N = mkTerm "complex_N" ;
lin complexifier_N = mkTerm "complexifier_N" ;
lin complexion_N = mkTerm "complexion_N" ;
lin complexity_N = mkTerm "complexity_N" ;
lin compliance_N = mkTerm "compliance_N" ;
lin compliant_A = mkTerm "compliant_A" ;
lin complicate_V2 = mkTerm "complicate_V2" ;
lin complicated_A = mkTerm "complicated_A" ;
lin complicatedness_N = mkTerm "complicatedness_N" ;
lin complication_N = mkTerm "complication_N" ;
lin complicity_N = mkTerm "complicity_N" ;
lin compliment_N = mkTerm "compliment_N" ;
lin compliment_V2 = mkTerm "compliment_V2" ;
lin complimentary_A = mkTerm "complimentary_A" ;
lin complin_N = mkTerm "complin_N" ;
lin compline_N = mkTerm "compline_N" ;
lin comply_V = mkTerm "comply_V" ;
lin comply_V2 = mkTerm "comply_V2" ;
lin component_A = mkTerm "component_A" ;
lin component_N = mkTerm "component_N" ;
lin comport_V = mkTerm "comport_V" ;
lin comport_V2 = mkTerm "comport_V2" ;
lin comportment_N = mkTerm "comportment_N" ;
lin compos_mentis_A = mkTerm "compos_mentis_A" ;
lin compose_V = mkTerm "compose_V" ;
lin compose_V2 = mkTerm "compose_V2" ;
lin composer_N = mkTerm "composer_N" ;
lin composing_N = mkTerm "composing_N" ;
lin composite_A = mkTerm "composite_A" ;
lin composite_N = mkTerm "composite_N" ;
lin compositeness_N = mkTerm "compositeness_N" ;
lin composition_N = mkTerm "composition_N" ;
lin compositional_A = mkTerm "compositional_A" ;
lin compositor_N = mkTerm "compositor_N" ;
lin compost_N = mkTerm "compost_N" ;
lin compost_V2 = mkTerm "compost_V2" ;
lin composure_N = mkTerm "composure_N" ;
lin compote_N = mkTerm "compote_N" ;
lin compound_A = mkTerm "compound_A" ;
lin compound_N = mkTerm "compound_N" ;
lin compound_V = mkTerm "compound_V" ;
lin compound_V2 = mkTerm "compound_V2" ;
lin comprehend_V2 = mkTerm "comprehend_V2" ;
lin comprehensibility_N = mkTerm "comprehensibility_N" ;
lin comprehensible_A = mkTerm "comprehensible_A" ;
lin comprehension_N = mkTerm "comprehension_N" ;
lin comprehensive_A = mkTerm "comprehensive_A" ;
lin comprehensiveness_N = mkTerm "comprehensiveness_N" ;
lin compress_N = mkTerm "compress_N" ;
lin compress_V2 = mkTerm "compress_V2" ;
lin compressibility_N = mkTerm "compressibility_N" ;
lin compressible_A = mkTerm "compressible_A" ;
lin compression_N = mkTerm "compression_N" ;
lin compressor_N = mkTerm "compressor_N" ;
lin comprise_V2 = mkTerm "comprise_V2" ;
lin compromise_N = mkTerm "compromise_N" ;
lin compromise_V = mkTerm "compromise_V" ;
lin compromise_V2 = mkTerm "compromise_V2" ;
lin compromiser_N = mkTerm "compromiser_N" ;
lin compsognathus_N = mkTerm "compsognathus_N" ;
lin comptroller_N = mkTerm "comptroller_N" ;
lin comptrollership_N = mkTerm "comptrollership_N" ;
lin compulsion_N = mkTerm "compulsion_N" ;
lin compulsive_A = mkTerm "compulsive_A" ;
lin compulsive_N = mkTerm "compulsive_N" ;
lin compulsiveness_N = mkTerm "compulsiveness_N" ;
lin compulsory_A = mkTerm "compulsory_A" ;
lin compunction_N = mkTerm "compunction_N" ;
lin computable_A = mkTerm "computable_A" ;
lin computation_N = mkTerm "computation_N" ;
lin computational_A = mkTerm "computational_A" ;
lin compute_V = mkTerm "compute_V" ;
lin compute_V2 = mkTerm "compute_V2" ;
lin computer_N = mkTerm "computer_N" ;
lin computer_science_N = mkTerm "computer_science_N" ;
lin computerization_N = mkTerm "computerization_N" ;
lin computerize_V2 = mkTerm "computerize_V2" ;
lin computing_N = mkTerm "computing_N" ;
lin comrade_N = mkTerm "comrade_N" ;
lin comradely_A = mkTerm "comradely_A" ;
lin comradely_Adv = mkTerm "comradely_Adv" ;
lin comradeship_N = mkTerm "comradeship_N" ;
lin comune_A = mkTerm "comune_A" ;
lin con_Adv = mkTerm "con_Adv" ;
lin con_N = mkTerm "con_N" ;
lin con_V2 = mkTerm "con_V2" ;
lin con_man_N = mkTerm "con_man_N" ;
lin conacaste_N = mkTerm "conacaste_N" ;
lin concatenation_N = mkTerm "concatenation_N" ;
lin concave_A = mkTerm "concave_A" ;
lin concavity_N = mkTerm "concavity_N" ;
lin conceal_V2 = mkTerm "conceal_V2" ;
lin conceale_V = mkTerm "conceale_V" ;
lin concealment_N = mkTerm "concealment_N" ;
lin concede_V = mkTerm "concede_V" ;
lin concede_V2 = mkTerm "concede_V2" ;
lin concede_VS = mkTerm "concede_VS" ;
lin conceit_N = mkTerm "conceit_N" ;
lin conceited_A = mkTerm "conceited_A" ;
lin conceivable_A = mkTerm "conceivable_A" ;
lin conceivableness_N = mkTerm "conceivableness_N" ;
lin conceive_V = mkTerm "conceive_V" ;
lin conceive_V2 = mkTerm "conceive_V2" ;
lin concentrate_N = mkTerm "concentrate_N" ;
lin concentrate_V = mkTerm "concentrate_V" ;
lin concentrate_V2 = mkTerm "concentrate_V2" ;
lin concentrated_A = mkTerm "concentrated_A" ;
lin concentration_N = mkTerm "concentration_N" ;
lin concentric_A = mkTerm "concentric_A" ;
lin concentricity_N = mkTerm "concentricity_N" ;
lin concept_N = mkTerm "concept_N" ;
lin conception_N = mkTerm "conception_N" ;
lin conceptional_A = mkTerm "conceptional_A" ;
lin conceptive_A = mkTerm "conceptive_A" ;
lin conceptual_A = mkTerm "conceptual_A" ;
lin conceptualism_N = mkTerm "conceptualism_N" ;
lin conceptualistic_A = mkTerm "conceptualistic_A" ;
lin conceptualization_N = mkTerm "conceptualization_N" ;
lin concern_N = mkTerm "concern_N" ;
lin concern_V2 = mkTerm "concern_V2" ;
lin concerned_A = mkTerm "concerned_A" ;
lin concerning_Prep = mkTerm "concerning_Prep" ;
lin concert_N = mkTerm "concert_N" ;
lin concert_V2 = mkTerm "concert_V2" ;
lin concert_hall_N = mkTerm "concert_hall_N" ;
lin concertina_N = mkTerm "concertina_N" ;
lin concerto_N = mkTerm "concerto_N" ;
lin concession_N = mkTerm "concession_N" ;
lin concessionaire_N = mkTerm "concessionaire_N" ;
lin concessive_A = mkTerm "concessive_A" ;
lin conch_N = mkTerm "conch_N" ;
lin concha_N = mkTerm "concha_N" ;
lin conchfish_N = mkTerm "conchfish_N" ;
lin conchologist_N = mkTerm "conchologist_N" ;
lin conchology_N = mkTerm "conchology_N" ;
lin concierge_N = mkTerm "concierge_N" ;
lin conciliate_V2 = mkTerm "conciliate_V2" ;
lin conciliation_N = mkTerm "conciliation_N" ;
lin conciliator_N = mkTerm "conciliator_N" ;
lin conciliatory_A = mkTerm "conciliatory_A" ;
lin concise_A = mkTerm "concise_A" ;
lin conciseness_N = mkTerm "conciseness_N" ;
lin conclave_N = mkTerm "conclave_N" ;
lin conclude_V = mkTerm "conclude_V" ;
lin conclude_V2 = mkTerm "conclude_V2" ;
lin conclude_VS = mkTerm "conclude_VS" ;
lin conclusion_N = mkTerm "conclusion_N" ;
lin conclusive_A = mkTerm "conclusive_A" ;
lin concoct_V2 = mkTerm "concoct_V2" ;
lin concoction_N = mkTerm "concoction_N" ;
lin concomitance_N = mkTerm "concomitance_N" ;
lin concomitant_A = mkTerm "concomitant_A" ;
lin concomitant_N = mkTerm "concomitant_N" ;
lin concord_N = mkTerm "concord_N" ;
lin concordance_N = mkTerm "concordance_N" ;
lin concordant_A = mkTerm "concordant_A" ;
lin concordat_N = mkTerm "concordat_N" ;
lin concourse_N = mkTerm "concourse_N" ;
lin concrete_A = mkTerm "concrete_A" ;
lin concrete_N = mkTerm "concrete_N" ;
lin concrete_V = mkTerm "concrete_V" ;
lin concrete_V2 = mkTerm "concrete_V2" ;
lin concreteness_N = mkTerm "concreteness_N" ;
lin concretion_N = mkTerm "concretion_N" ;
lin concretism_N = mkTerm "concretism_N" ;
lin concretistic_A = mkTerm "concretistic_A" ;
lin concubinage_N = mkTerm "concubinage_N" ;
lin concubine_N = mkTerm "concubine_N" ;
lin concupiscence_N = mkTerm "concupiscence_N" ;
lin concur_V = mkTerm "concur_V" ;
lin concurrence_N = mkTerm "concurrence_N" ;
lin concurrent_A = mkTerm "concurrent_A" ;
lin concurrentness_N = mkTerm "concurrentness_N" ;
lin concuss_V2 = mkTerm "concuss_V2" ;
lin concussion_N = mkTerm "concussion_N" ;
lin condemn_V2 = mkTerm "condemn_V2" ;
lin condemnable_A = mkTerm "condemnable_A" ;
lin condemnation_N = mkTerm "condemnation_N" ;
lin condemnatory_A = mkTerm "condemnatory_A" ;
lin condensate_N = mkTerm "condensate_N" ;
lin condensation_N = mkTerm "condensation_N" ;
lin condense_V = mkTerm "condense_V" ;
lin condense_V2 = mkTerm "condense_V2" ;
lin condenser_N = mkTerm "condenser_N" ;
lin condensing_N = mkTerm "condensing_N" ;
lin condescend_V = mkTerm "condescend_V" ;
lin condescendingly_Adv = mkTerm "condescendingly_Adv" ;
lin condescension_N = mkTerm "condescension_N" ;
lin condign_A = mkTerm "condign_A" ;
lin condiment_N = mkTerm "condiment_N" ;
lin condition_1_N = mkTerm "condition_1_N" ;
lin condition_2_N = mkTerm "condition_2_N" ;
lin condition_V2 = mkTerm "condition_V2" ;
lin conditional_A = mkTerm "conditional_A" ;
lin conditionality_N = mkTerm "conditionality_N" ;
lin conditioner_N = mkTerm "conditioner_N" ;
lin conditioning_N = mkTerm "conditioning_N" ;
lin conditions_N = mkTerm "conditions_N" ;
lin condole_V = mkTerm "condole_V" ;
lin condolence_N = mkTerm "condolence_N" ;
lin condolent_A = mkTerm "condolent_A" ;
lin condom_N = mkTerm "condom_N" ;
lin condominium_N = mkTerm "condominium_N" ;
lin condonation_N = mkTerm "condonation_N" ;
lin condone_V2 = mkTerm "condone_V2" ;
lin condor_N = mkTerm "condor_N" ;
lin conduce_V = mkTerm "conduce_V" ;
lin conducive_A = mkTerm "conducive_A" ;
lin conduct_N = mkTerm "conduct_N" ;
lin conduct_V = mkTerm "conduct_V" ;
lin conduct_V2 = mkTerm "conduct_V2" ;
lin conductance_N = mkTerm "conductance_N" ;
lin conducting_N = mkTerm "conducting_N" ;
lin conduction_N = mkTerm "conduction_N" ;
lin conductive_A = mkTerm "conductive_A" ;
lin conductivity_N = mkTerm "conductivity_N" ;
lin conductor_N = mkTerm "conductor_N" ;
lin conductress_N = mkTerm "conductress_N" ;
lin conduit_N = mkTerm "conduit_N" ;
lin condylar_A = mkTerm "condylar_A" ;
lin condyle_N = mkTerm "condyle_N" ;
lin condylion_N = mkTerm "condylion_N" ;
lin cone_N = mkTerm "cone_N" ;
lin cone_V2 = mkTerm "cone_V2" ;
lin coneflower_N = mkTerm "coneflower_N" ;
lin conenose_N = mkTerm "conenose_N" ;
lin coney_N = mkTerm "coney_N" ;
lin confab_N = mkTerm "confab_N" ;
lin confab_V = mkTerm "confab_V" ;
lin confabulate_V = mkTerm "confabulate_V" ;
lin confabulation_N = mkTerm "confabulation_N" ;
lin confection_N = mkTerm "confection_N" ;
lin confectioner_N = mkTerm "confectioner_N" ;
lin confectionery_N = mkTerm "confectionery_N" ;
lin confederacy_N = mkTerm "confederacy_N" ;
lin confederate_A = mkTerm "confederate_A" ;
lin confederate_N = mkTerm "confederate_N" ;
lin confederate_V = mkTerm "confederate_V" ;
lin confederate_V2 = mkTerm "confederate_V2" ;
lin confederation_N = mkTerm "confederation_N" ;
lin confer_V = mkTerm "confer_V" ;
lin conferee_N = mkTerm "conferee_N" ;
lin conference_N = mkTerm "conference_N" ;
lin conferment_N = mkTerm "conferment_N" ;
lin conferrer_N = mkTerm "conferrer_N" ;
lin conferva_N = mkTerm "conferva_N" ;
lin confess_V = mkTerm "confess_V" ;
lin confess_V2 = mkTerm "confess_V2" ;
lin confess_VS = mkTerm "confess_VS" ;
lin confessedly_Adv = mkTerm "confessedly_Adv" ;
lin confession_N = mkTerm "confession_N" ;
lin confessional_N = mkTerm "confessional_N" ;
lin confessor_N = mkTerm "confessor_N" ;
lin confetti_N = mkTerm "confetti_N" ;
lin confidantFem_N = mkTerm "confidantFem_N" ;
lin confidantMasc_N = mkTerm "confidantMasc_N" ;
lin confidante_N = mkTerm "confidante_N" ;
lin confide_V = mkTerm "confide_V" ;
lin confide_V2 = mkTerm "confide_V2" ;
lin confide_VS = mkTerm "confide_VS" ;
lin confidence_N = mkTerm "confidence_N" ;
lin confident_A = mkTerm "confident_A" ;
lin confidential_A = mkTerm "confidential_A" ;
lin confidentiality_N = mkTerm "confidentiality_N" ;
lin configuration_N = mkTerm "configuration_N" ;
lin configurational_A = mkTerm "configurational_A" ;
lin configure_V2 = mkTerm "configure_V2" ;
lin confine_N = mkTerm "confine_N" ;
lin confine_V2 = mkTerm "confine_V2" ;
lin confinement_N = mkTerm "confinement_N" ;
lin confining_A = mkTerm "confining_A" ;
lin confirm_V2 = mkTerm "confirm_V2" ;
lin confirm_VS = mkTerm "confirm_VS" ;
lin confirmable_A = mkTerm "confirmable_A" ;
lin confirmation_N = mkTerm "confirmation_N" ;
lin confiscate_A = mkTerm "confiscate_A" ;
lin confiscate_V2 = mkTerm "confiscate_V2" ;
lin confiscation_N = mkTerm "confiscation_N" ;
lin confit_N = mkTerm "confit_N" ;
lin confiture_N = mkTerm "confiture_N" ;
lin conflagration_N = mkTerm "conflagration_N" ;
lin conflict_N = mkTerm "conflict_N" ;
lin conflict_V = mkTerm "conflict_V" ;
lin confluence_N = mkTerm "confluence_N" ;
lin confluent_A = mkTerm "confluent_A" ;
lin conform_V = mkTerm "conform_V" ;
lin conform_V2 = mkTerm "conform_V2" ;
lin conformable_A = mkTerm "conformable_A" ;
lin conformation_N = mkTerm "conformation_N" ;
lin conformist_A = mkTerm "conformist_A" ;
lin conformist_N = mkTerm "conformist_N" ;
lin conformity_N = mkTerm "conformity_N" ;
lin confound_V2 = mkTerm "confound_V2" ;
lin confounding_A = mkTerm "confounding_A" ;
lin confrere_N = mkTerm "confrere_N" ;
lin confront_V2 = mkTerm "confront_V2" ;
lin confrontation_N = mkTerm "confrontation_N" ;
lin confrontational_A = mkTerm "confrontational_A" ;
lin confucian_A = mkTerm "confucian_A" ;
lin confucian_N = mkTerm "confucian_N" ;
lin confusable_A = mkTerm "confusable_A" ;
lin confuse_V2 = mkTerm "confuse_V2" ;
lin confused_A = mkTerm "confused_A" ;
lin confusing_A = mkTerm "confusing_A" ;
lin confusion_N = mkTerm "confusion_N" ;
lin confutation_N = mkTerm "confutation_N" ;
lin confute_V2 = mkTerm "confute_V2" ;
lin conga_N = mkTerm "conga_N" ;
lin conge_N = mkTerm "conge_N" ;
lin congeal_V = mkTerm "congeal_V" ;
lin congeal_V2 = mkTerm "congeal_V2" ;
lin congealment_N = mkTerm "congealment_N" ;
lin congee_N = mkTerm "congee_N" ;
lin congener_N = mkTerm "congener_N" ;
lin congeneric_A = mkTerm "congeneric_A" ;
lin congenial_A = mkTerm "congenial_A" ;
lin congeniality_N = mkTerm "congeniality_N" ;
lin congenialness_N = mkTerm "congenialness_N" ;
lin congenital_A = mkTerm "congenital_A" ;
lin conger_N = mkTerm "conger_N" ;
lin conger_eel_N = mkTerm "conger_eel_N" ;
lin congested_A = mkTerm "congested_A" ;
lin congestion_N = mkTerm "congestion_N" ;
lin congestive_A = mkTerm "congestive_A" ;
lin congleton_PN = mkTerm "congleton_PN" ;
lin conglomerate_A = mkTerm "conglomerate_A" ;
lin conglomerate_N = mkTerm "conglomerate_N" ;
lin conglomerate_V = mkTerm "conglomerate_V" ;
lin conglomerate_V2 = mkTerm "conglomerate_V2" ;
lin conglomeration_N = mkTerm "conglomeration_N" ;
lin congo_PN = mkTerm "congo_PN" ;
lin congolese_A = mkTerm "congolese_A" ;
lin congolese_N = mkTerm "congolese_N" ;
lin congou_N = mkTerm "congou_N" ;
lin congratulate_V2 = mkTerm "congratulate_V2" ;
lin congratulation_N = mkTerm "congratulation_N" ;
lin congratulatory_A = mkTerm "congratulatory_A" ;
lin congregant_N = mkTerm "congregant_N" ;
lin congregate_V = mkTerm "congregate_V" ;
lin congregate_V2 = mkTerm "congregate_V2" ;
lin congregation_N = mkTerm "congregation_N" ;
lin congregational_A = mkTerm "congregational_A" ;
lin congress_N = mkTerm "congress_N" ;
lin congressional_A = mkTerm "congressional_A" ;
lin congressman_N = mkTerm "congressman_N" ;
lin congresswoman_N = mkTerm "congresswoman_N" ;
lin congruent_A = mkTerm "congruent_A" ;
lin congruity_N = mkTerm "congruity_N" ;
lin congruous_A = mkTerm "congruous_A" ;
lin conic_A = mkTerm "conic_A" ;
lin conical_A = mkTerm "conical_A" ;
lin conidiophore_N = mkTerm "conidiophore_N" ;
lin conidium_N = mkTerm "conidium_N" ;
lin conifer_N = mkTerm "conifer_N" ;
lin coniferous_A = mkTerm "coniferous_A" ;
lin conima_N = mkTerm "conima_N" ;
lin conjectural_A = mkTerm "conjectural_A" ;
lin conjecture_N = mkTerm "conjecture_N" ;
lin conjecture_V = mkTerm "conjecture_V" ;
lin conjecture_V2 = mkTerm "conjecture_V2" ;
lin conjoin_V = mkTerm "conjoin_V" ;
lin conjoin_V2 = mkTerm "conjoin_V2" ;
lin conjoint_A = mkTerm "conjoint_A" ;
lin conjugal_A = mkTerm "conjugal_A" ;
lin conjugate_A = mkTerm "conjugate_A" ;
lin conjugate_V = mkTerm "conjugate_V" ;
lin conjugate_V2 = mkTerm "conjugate_V2" ;
lin conjugation_N = mkTerm "conjugation_N" ;
lin conjunct_A = mkTerm "conjunct_A" ;
lin conjunction_N = mkTerm "conjunction_N" ;
lin conjunctiva_N = mkTerm "conjunctiva_N" ;
lin conjunctival_A = mkTerm "conjunctival_A" ;
lin conjunctive_A = mkTerm "conjunctive_A" ;
lin conjunctive_N = mkTerm "conjunctive_N" ;
lin conjunctivitis_N = mkTerm "conjunctivitis_N" ;
lin conjuncture_N = mkTerm "conjuncture_N" ;
lin conjuration_N = mkTerm "conjuration_N" ;
lin conjure_V = mkTerm "conjure_V" ;
lin conjure_V2 = mkTerm "conjure_V2" ;
lin conjure_up_V2 = mkTerm "conjure_up_V2" ;
lin conjurer_N = mkTerm "conjurer_N" ;
lin conjuring_N = mkTerm "conjuring_N" ;
lin conjuror_N = mkTerm "conjuror_N" ;
lin conk_N = mkTerm "conk_N" ;
lin conk_V = mkTerm "conk_V" ;
lin conk_out_V = mkTerm "conk_out_V" ;
lin conker_N = mkTerm "conker_N" ;
lin connah's_quay_PN = mkTerm "connah's_quay_PN" ;
lin connate_A = mkTerm "connate_A" ;
lin connatural_A = mkTerm "connatural_A" ;
lin connaught_PN = mkTerm "connaught_PN" ;
lin connect_V = mkTerm "connect_V" ;
lin connect_V2 = mkTerm "connect_V2" ;
lin connected_A = mkTerm "connected_A" ;
lin connecticut_PN = mkTerm "connecticut_PN" ;
lin connection_N = mkTerm "connection_N" ;
lin connective_A = mkTerm "connective_A" ;
lin connective_N = mkTerm "connective_N" ;
lin connectivity_N = mkTerm "connectivity_N" ;
lin connector_N = mkTerm "connector_N" ;
lin connexion_N = mkTerm "connexion_N" ;
lin connie_PN = mkTerm "connie_PN" ;
lin conning_A = mkTerm "conning_A" ;
lin connivance_N = mkTerm "connivance_N" ;
lin connive_V = mkTerm "connive_V" ;
lin connoisseur_N = mkTerm "connoisseur_N" ;
lin connotation_N = mkTerm "connotation_N" ;
lin connotational_A = mkTerm "connotational_A" ;
lin connotative_A = mkTerm "connotative_A" ;
lin connote_V2 = mkTerm "connote_V2" ;
lin connubial_A = mkTerm "connubial_A" ;
lin conodont_N = mkTerm "conodont_N" ;
lin conquer_V2 = mkTerm "conquer_V2" ;
lin conquerable_A = mkTerm "conquerable_A" ;
lin conqueror_N = mkTerm "conqueror_N" ;
lin conquest_N = mkTerm "conquest_N" ;
lin conquistador_N = mkTerm "conquistador_N" ;
lin cons_PN = mkTerm "cons_PN" ;
lin consanguinity_N = mkTerm "consanguinity_N" ;
lin conscience_N = mkTerm "conscience_N" ;
lin conscience_smitten_A = mkTerm "conscience_smitten_A" ;
lin conscienceless_A = mkTerm "conscienceless_A" ;
lin conscientious_A = mkTerm "conscientious_A" ;
lin conscientiousness_N = mkTerm "conscientiousness_N" ;
lin conscionable_A = mkTerm "conscionable_A" ;
lin conscious_A = mkTerm "conscious_A" ;
lin consciousness_N = mkTerm "consciousness_N" ;
lin conscript_N = mkTerm "conscript_N" ;
lin conscript_V2 = mkTerm "conscript_V2" ;
lin conscription_N = mkTerm "conscription_N" ;
lin consecrate_V2 = mkTerm "consecrate_V2" ;
lin consecration_N = mkTerm "consecration_N" ;
lin consecutive_A = mkTerm "consecutive_A" ;
lin consecutive_Adv = mkTerm "consecutive_Adv" ;
lin consensual_A = mkTerm "consensual_A" ;
lin consensus_N = mkTerm "consensus_N" ;
lin consent_N = mkTerm "consent_N" ;
lin consent_V = mkTerm "consent_V" ;
lin consent_V2V = mkTerm "consent_V2V" ;
lin consentaneous_A = mkTerm "consentaneous_A" ;
lin consequence_N = mkTerm "consequence_N" ;
lin consequent_A = mkTerm "consequent_A" ;
lin consequential_A = mkTerm "consequential_A" ;
lin conservancy_N = mkTerm "conservancy_N" ;
lin conservation_N = mkTerm "conservation_N" ;
lin conservatism_N = mkTerm "conservatism_N" ;
lin conservative_1_N = mkTerm "conservative_1_N" ;
lin conservative_2_N = mkTerm "conservative_2_N" ;
lin conservative_A = mkTerm "conservative_A" ;
lin conservatoire_N = mkTerm "conservatoire_N" ;
lin conservator_N = mkTerm "conservator_N" ;
lin conservatory_N = mkTerm "conservatory_N" ;
lin conserve_N = mkTerm "conserve_N" ;
lin conserve_V2 = mkTerm "conserve_V2" ;
lin consett_PN = mkTerm "consett_PN" ;
lin consider_V = mkTerm "consider_V" ;
lin consider_V2 = mkTerm "consider_V2" ;
lin consider_V2A = mkTerm "consider_V2A" ;
lin consider_V2V = mkTerm "consider_V2V" ;
lin consider_V3 = mkTerm "consider_V3" ;
lin consider_VS = mkTerm "consider_VS" ;
lin consider_VV = mkTerm "consider_VV" ;
lin considerable_A = mkTerm "considerable_A" ;
lin considerate_A = mkTerm "considerate_A" ;
lin considerateness_N = mkTerm "considerateness_N" ;
lin consideration_N = mkTerm "consideration_N" ;
lin considering_Prep = mkTerm "considering_Prep" ;
lin considering_Subj = mkTerm "considering_Subj" ;
lin consign_V2 = mkTerm "consign_V2" ;
lin consignee_N = mkTerm "consignee_N" ;
lin consigner_N = mkTerm "consigner_N" ;
lin consignment_N = mkTerm "consignment_N" ;
lin consignor_N = mkTerm "consignor_N" ;
lin consist_V = mkTerm "consist_V" ;
lin consistence_N = mkTerm "consistence_N" ;
lin consistency_N = mkTerm "consistency_N" ;
lin consistent_A = mkTerm "consistent_A" ;
lin consistory_N = mkTerm "consistory_N" ;
lin consolable_A = mkTerm "consolable_A" ;
lin consolation_N = mkTerm "consolation_N" ;
lin consolatory_A = mkTerm "consolatory_A" ;
lin console_N = mkTerm "console_N" ;
lin console_V2 = mkTerm "console_V2" ;
lin consolidate_V = mkTerm "consolidate_V" ;
lin consolidate_V2 = mkTerm "consolidate_V2" ;
lin consolidation_N = mkTerm "consolidation_N" ;
lin consolidative_A = mkTerm "consolidative_A" ;
lin consomme_N = mkTerm "consomme_N" ;
lin consonance_N = mkTerm "consonance_N" ;
lin consonant_A = mkTerm "consonant_A" ;
lin consonant_N = mkTerm "consonant_N" ;
lin consonantal_A = mkTerm "consonantal_A" ;
lin consort_N = mkTerm "consort_N" ;
lin consort_V = mkTerm "consort_V" ;
lin consortium_N = mkTerm "consortium_N" ;
lin conspecific_A = mkTerm "conspecific_A" ;
lin conspecific_N = mkTerm "conspecific_N" ;
lin conspectus_N = mkTerm "conspectus_N" ;
lin conspicuous_A = mkTerm "conspicuous_A" ;
lin conspicuousness_N = mkTerm "conspicuousness_N" ;
lin conspiracy_N = mkTerm "conspiracy_N" ;
lin conspirator_N = mkTerm "conspirator_N" ;
lin conspiratorial_A = mkTerm "conspiratorial_A" ;
lin conspire_V = mkTerm "conspire_V" ;
lin conspire_V2 = mkTerm "conspire_V2" ;
lin conspire_V2V = mkTerm "conspire_V2V" ;
lin constable_N = mkTerm "constable_N" ;
lin constabulary_N = mkTerm "constabulary_N" ;
lin constance_PN = mkTerm "constance_PN" ;
lin constancy_N = mkTerm "constancy_N" ;
lin constant_A = mkTerm "constant_A" ;
lin constant_N = mkTerm "constant_N" ;
lin constantan_N = mkTerm "constantan_N" ;
lin constellation_N = mkTerm "constellation_N" ;
lin consternation_N = mkTerm "consternation_N" ;
lin constipate_1_V2 = mkTerm "constipate_1_V2" ;
lin constipate_2_V2 = mkTerm "constipate_2_V2" ;
lin constipation_N = mkTerm "constipation_N" ;
lin constituency_N = mkTerm "constituency_N" ;
lin constituent_A = mkTerm "constituent_A" ;
lin constituent_N = mkTerm "constituent_N" ;
lin constitute_V2 = mkTerm "constitute_V2" ;
lin constitution_N = mkTerm "constitution_N" ;
lin constitutional_A = mkTerm "constitutional_A" ;
lin constitutional_N = mkTerm "constitutional_N" ;
lin constitutionalism_N = mkTerm "constitutionalism_N" ;
lin constitutionalist_N = mkTerm "constitutionalist_N" ;
lin constitutionalize_V2 = mkTerm "constitutionalize_V2" ;
lin constitutive_A = mkTerm "constitutive_A" ;
lin constrain_V2 = mkTerm "constrain_V2" ;
lin constrainedly_Adv = mkTerm "constrainedly_Adv" ;
lin constraint_N = mkTerm "constraint_N" ;
lin constrict_V2 = mkTerm "constrict_V2" ;
lin constricting_A = mkTerm "constricting_A" ;
lin constriction_N = mkTerm "constriction_N" ;
lin constrictor_N = mkTerm "constrictor_N" ;
lin construal_N = mkTerm "construal_N" ;
lin construct_V2 = mkTerm "construct_V2" ;
lin construction_N = mkTerm "construction_N" ;
lin constructional_A = mkTerm "constructional_A" ;
lin constructive_A = mkTerm "constructive_A" ;
lin constructiveness_N = mkTerm "constructiveness_N" ;
lin constructivism_N = mkTerm "constructivism_N" ;
lin constructivist_N = mkTerm "constructivist_N" ;
lin constructor_N = mkTerm "constructor_N" ;
lin construe_V = mkTerm "construe_V" ;
lin construe_V2 = mkTerm "construe_V2" ;
lin construe_V2V = mkTerm "construe_V2V" ;
lin consubstantial_A = mkTerm "consubstantial_A" ;
lin consubstantiation_N = mkTerm "consubstantiation_N" ;
lin consuetude_N = mkTerm "consuetude_N" ;
lin consuetudinary_N = mkTerm "consuetudinary_N" ;
lin consul_N = mkTerm "consul_N" ;
lin consular_A = mkTerm "consular_A" ;
lin consulate_N = mkTerm "consulate_N" ;
lin consulship_N = mkTerm "consulship_N" ;
lin consult_V = mkTerm "consult_V" ;
lin consult_V2 = mkTerm "consult_V2" ;
lin consultancy_N = mkTerm "consultancy_N" ;
lin consultant_N = mkTerm "consultant_N" ;
lin consultation_N = mkTerm "consultation_N" ;
lin consultative_A = mkTerm "consultative_A" ;
lin consumable_A = mkTerm "consumable_A" ;
lin consume_V = mkTerm "consume_V" ;
lin consume_V2 = mkTerm "consume_V2" ;
lin consumer_N = mkTerm "consumer_N" ;
lin consumerism_N = mkTerm "consumerism_N" ;
lin consummate_A = mkTerm "consummate_A" ;
lin consummate_V2 = mkTerm "consummate_V2" ;
lin consummation_N = mkTerm "consummation_N" ;
lin consumption_N = mkTerm "consumption_N" ;
lin consumptive_A = mkTerm "consumptive_A" ;
lin consumptive_N = mkTerm "consumptive_N" ;
lin cont_PN = mkTerm "cont_PN" ;
lin contact_N = mkTerm "contact_N" ;
lin contact_V2 = mkTerm "contact_V2" ;
lin contadino_N = mkTerm "contadino_N" ;
lin contagion_N = mkTerm "contagion_N" ;
lin contagious_A = mkTerm "contagious_A" ;
lin contain_V2 = mkTerm "contain_V2" ;
lin container_N = mkTerm "container_N" ;
lin containerful_N = mkTerm "containerful_N" ;
lin containment_N = mkTerm "containment_N" ;
lin contaminant_N = mkTerm "contaminant_N" ;
lin contaminate_V2 = mkTerm "contaminate_V2" ;
lin contamination_N = mkTerm "contamination_N" ;
lin contaminative_A = mkTerm "contaminative_A" ;
lin contemn_V2 = mkTerm "contemn_V2" ;
lin contemplate_V = mkTerm "contemplate_V" ;
lin contemplate_V2 = mkTerm "contemplate_V2" ;
lin contemplate_VS = mkTerm "contemplate_VS" ;
lin contemplation_N = mkTerm "contemplation_N" ;
lin contemplative_A = mkTerm "contemplative_A" ;
lin contemplative_N = mkTerm "contemplative_N" ;
lin contemporaneity_N = mkTerm "contemporaneity_N" ;
lin contemporaneous_A = mkTerm "contemporaneous_A" ;
lin contemporary_A = mkTerm "contemporary_A" ;
lin contemporary_N = mkTerm "contemporary_N" ;
lin contempt_N = mkTerm "contempt_N" ;
lin contemptible_A = mkTerm "contemptible_A" ;
lin contemptuous_of_A2 = mkTerm "contemptuous_of_A2" ;
lin contemptuousness_N = mkTerm "contemptuousness_N" ;
lin contend_V = mkTerm "contend_V" ;
lin contend_VS = mkTerm "contend_VS" ;
lin contender_N = mkTerm "contender_N" ;
lin content_A = mkTerm "content_A" ;
lin content_N = mkTerm "content_N" ;
lin content_V2 = mkTerm "content_V2" ;
lin contentedly_Adv = mkTerm "contentedly_Adv" ;
lin contentedness_N = mkTerm "contentedness_N" ;
lin contention_N = mkTerm "contention_N" ;
lin contentious_A = mkTerm "contentious_A" ;
lin contentment_N = mkTerm "contentment_N" ;
lin contents_N = mkTerm "contents_N" ;
lin conterminous_A = mkTerm "conterminous_A" ;
lin contest_N = mkTerm "contest_N" ;
lin contest_V = mkTerm "contest_V" ;
lin contest_V2 = mkTerm "contest_V2" ;
lin contestable_A = mkTerm "contestable_A" ;
lin contestant_N = mkTerm "contestant_N" ;
lin contestee_N = mkTerm "contestee_N" ;
lin contester_N = mkTerm "contester_N" ;
lin context_N = mkTerm "context_N" ;
lin contextual_A = mkTerm "contextual_A" ;
lin contextualism_N = mkTerm "contextualism_N" ;
lin contiguity_N = mkTerm "contiguity_N" ;
lin contiguous_A = mkTerm "contiguous_A" ;
lin continence_N = mkTerm "continence_N" ;
lin continent_A = mkTerm "continent_A" ;
lin continent_N = mkTerm "continent_N" ;
lin continental_A = mkTerm "continental_A" ;
lin contingency_N = mkTerm "contingency_N" ;
lin contingent_A = mkTerm "contingent_A" ;
lin contingent_N = mkTerm "contingent_N" ;
lin continual_A = mkTerm "continual_A" ;
lin continuance_N = mkTerm "continuance_N" ;
lin continuation_N = mkTerm "continuation_N" ;
lin continue_V = mkTerm "continue_V" ;
lin continue_V2 = mkTerm "continue_V2" ;
lin continue_VV = mkTerm "continue_VV" ;
lin continue_on_V = mkTerm "continue_on_V" ;
lin continued_A = mkTerm "continued_A" ;
lin continuing_A = mkTerm "continuing_A" ;
lin continuity_N = mkTerm "continuity_N" ;
lin continuous_A = mkTerm "continuous_A" ;
lin continuousness_N = mkTerm "continuousness_N" ;
lin continuum_N = mkTerm "continuum_N" ;
lin conto_N = mkTerm "conto_N" ;
lin contort_V2 = mkTerm "contort_V2" ;
lin contortion_N = mkTerm "contortion_N" ;
lin contortionist_N = mkTerm "contortionist_N" ;
lin contour_N = mkTerm "contour_N" ;
lin contour_V2 = mkTerm "contour_V2" ;
lin contra_Prep = mkTerm "contra_Prep" ;
lin contraband_N = mkTerm "contraband_N" ;
lin contrabass_A = mkTerm "contrabass_A" ;
lin contrabass_N = mkTerm "contrabass_N" ;
lin contrabassoon_N = mkTerm "contrabassoon_N" ;
lin contraception_N = mkTerm "contraception_N" ;
lin contraceptive_A = mkTerm "contraceptive_A" ;
lin contraceptive_N = mkTerm "contraceptive_N" ;
lin contract_N = mkTerm "contract_N" ;
lin contract_V = mkTerm "contract_V" ;
lin contract_V2 = mkTerm "contract_V2" ;
lin contract_V2V = mkTerm "contract_V2V" ;
lin contract_in_V = mkTerm "contract_in_V" ;
lin contract_out_V2 = mkTerm "contract_out_V2" ;
lin contract_out_of_V2 = mkTerm "contract_out_of_V2" ;
lin contractible_A = mkTerm "contractible_A" ;
lin contractile_A = mkTerm "contractile_A" ;
lin contractility_N = mkTerm "contractility_N" ;
lin contraction_N = mkTerm "contraction_N" ;
lin contractor_N = mkTerm "contractor_N" ;
lin contractual_A = mkTerm "contractual_A" ;
lin contracture_N = mkTerm "contracture_N" ;
lin contradict_V2 = mkTerm "contradict_V2" ;
lin contradiction_N = mkTerm "contradiction_N" ;
lin contradictoriness_N = mkTerm "contradictoriness_N" ;
lin contradictory_A = mkTerm "contradictory_A" ;
lin contradictory_N = mkTerm "contradictory_N" ;
lin contradistinction_N = mkTerm "contradistinction_N" ;
lin contradistinguish_V2 = mkTerm "contradistinguish_V2" ;
lin contrail_N = mkTerm "contrail_N" ;
lin contraindication_N = mkTerm "contraindication_N" ;
lin contralateral_A = mkTerm "contralateral_A" ;
lin contralto_N = mkTerm "contralto_N" ;
lin contraption_N = mkTerm "contraption_N" ;
lin contrapuntal_A = mkTerm "contrapuntal_A" ;
lin contrapuntist_N = mkTerm "contrapuntist_N" ;
lin contrarian_N = mkTerm "contrarian_N" ;
lin contrariety_N = mkTerm "contrariety_N" ;
lin contrariness_N = mkTerm "contrariness_N" ;
lin contrarious_A = mkTerm "contrarious_A" ;
lin contrariwise_Adv = mkTerm "contrariwise_Adv" ;
lin contrary_A = mkTerm "contrary_A" ;
lin contrary_N = mkTerm "contrary_N" ;
lin contrast_N = mkTerm "contrast_N" ;
lin contrast_V = mkTerm "contrast_V" ;
lin contrast_V2 = mkTerm "contrast_V2" ;
lin contrastingly_Adv = mkTerm "contrastingly_Adv" ;
lin contrastive_A = mkTerm "contrastive_A" ;
lin contrasty_A = mkTerm "contrasty_A" ;
lin contravene_V2 = mkTerm "contravene_V2" ;
lin contravention_N = mkTerm "contravention_N" ;
lin contretemps_N = mkTerm "contretemps_N" ;
lin contribute_V = mkTerm "contribute_V" ;
lin contribute_V2 = mkTerm "contribute_V2" ;
lin contribution_N = mkTerm "contribution_N" ;
lin contributor_N = mkTerm "contributor_N" ;
lin contributory_A = mkTerm "contributory_A" ;
lin contrite_A = mkTerm "contrite_A" ;
lin contrition_N = mkTerm "contrition_N" ;
lin contrivance_N = mkTerm "contrivance_N" ;
lin contrive_V = mkTerm "contrive_V" ;
lin contrive_V2 = mkTerm "contrive_V2" ;
lin contriver_N = mkTerm "contriver_N" ;
lin control_N = mkTerm "control_N" ;
lin control_V2 = mkTerm "control_V2" ;
lin controllable_A = mkTerm "controllable_A" ;
lin controlled_A = mkTerm "controlled_A" ;
lin controller_N = mkTerm "controller_N" ;
lin controllership_N = mkTerm "controllership_N" ;
lin controlling_A = mkTerm "controlling_A" ;
lin controversial_A = mkTerm "controversial_A" ;
lin controversialist_N = mkTerm "controversialist_N" ;
lin controversy_N = mkTerm "controversy_N" ;
lin controvert_V2 = mkTerm "controvert_V2" ;
lin contumacious_A = mkTerm "contumacious_A" ;
lin contumacy_N = mkTerm "contumacy_N" ;
lin contumelious_A = mkTerm "contumelious_A" ;
lin contumely_N = mkTerm "contumely_N" ;
lin contuse_V2 = mkTerm "contuse_V2" ;
lin contusion_N = mkTerm "contusion_N" ;
lin conundrum_N = mkTerm "conundrum_N" ;
lin conurbation_N = mkTerm "conurbation_N" ;
lin convalesce_V = mkTerm "convalesce_V" ;
lin convalescence_N = mkTerm "convalescence_N" ;
lin convalescent_A = mkTerm "convalescent_A" ;
lin convalescent_N = mkTerm "convalescent_N" ;
lin convection_N = mkTerm "convection_N" ;
lin convector_N = mkTerm "convector_N" ;
lin convene_V = mkTerm "convene_V" ;
lin convene_V2 = mkTerm "convene_V2" ;
lin convener_N = mkTerm "convener_N" ;
lin convenience_N = mkTerm "convenience_N" ;
lin convenient_A = mkTerm "convenient_A" ;
lin convent_N = mkTerm "convent_N" ;
lin conventicle_N = mkTerm "conventicle_N" ;
lin convention_N = mkTerm "convention_N" ;
lin conventional_A = mkTerm "conventional_A" ;
lin conventionality_N = mkTerm "conventionality_N" ;
lin conventionalization_N = mkTerm "conventionalization_N" ;
lin conventionalized_A = mkTerm "conventionalized_A" ;
lin conventioneer_N = mkTerm "conventioneer_N" ;
lin converge_V = mkTerm "converge_V" ;
lin convergence_N = mkTerm "convergence_N" ;
lin convergent_A = mkTerm "convergent_A" ;
lin conversant_A = mkTerm "conversant_A" ;
lin conversation_N = mkTerm "conversation_N" ;
lin conversational_A = mkTerm "conversational_A" ;
lin conversationalist_N = mkTerm "conversationalist_N" ;
lin converse_A = mkTerm "converse_A" ;
lin converse_N = mkTerm "converse_N" ;
lin converse_V = mkTerm "converse_V" ;
lin conversion_N = mkTerm "conversion_N" ;
lin convert_N = mkTerm "convert_N" ;
lin convert_V = mkTerm "convert_V" ;
lin convert_V2 = mkTerm "convert_V2" ;
lin converter_N = mkTerm "converter_N" ;
lin convertibility_N = mkTerm "convertibility_N" ;
lin convertible_A = mkTerm "convertible_A" ;
lin convertible_N = mkTerm "convertible_N" ;
lin convex_A = mkTerm "convex_A" ;
lin convexity_N = mkTerm "convexity_N" ;
lin convey_V2 = mkTerm "convey_V2" ;
lin conveyance_N = mkTerm "conveyance_N" ;
lin conveyancer_N = mkTerm "conveyancer_N" ;
lin conveyer_N = mkTerm "conveyer_N" ;
lin conveyer_belt_N = mkTerm "conveyer_belt_N" ;
lin conveyor_N = mkTerm "conveyor_N" ;
lin convict_N = mkTerm "convict_N" ;
lin convict_V2 = mkTerm "convict_V2" ;
lin conviction_N = mkTerm "conviction_N" ;
lin convince_V2 = mkTerm "convince_V2" ;
lin convince_V2V = mkTerm "convince_V2V" ;
lin convincible_A = mkTerm "convincible_A" ;
lin convincing_A = mkTerm "convincing_A" ;
lin convincingness_N = mkTerm "convincingness_N" ;
lin convivial_A = mkTerm "convivial_A" ;
lin conviviality_N = mkTerm "conviviality_N" ;
lin convocation_N = mkTerm "convocation_N" ;
lin convoke_V2 = mkTerm "convoke_V2" ;
lin convolute_A = mkTerm "convolute_A" ;
lin convoluted_A = mkTerm "convoluted_A" ;
lin convolution_N = mkTerm "convolution_N" ;
lin convolvulus_N = mkTerm "convolvulus_N" ;
lin convoy_N = mkTerm "convoy_N" ;
lin convoy_V2 = mkTerm "convoy_V2" ;
lin convulse_V2 = mkTerm "convulse_V2" ;
lin convulsion_N = mkTerm "convulsion_N" ;
lin convulsive_A = mkTerm "convulsive_A" ;
lin conwy_PN = mkTerm "conwy_PN" ;
lin cony_N = mkTerm "cony_N" ;
lin coo_N = mkTerm "coo_N" ;
lin coo_V = mkTerm "coo_V" ;
lin coo_V2 = mkTerm "coo_V2" ;
lin cook_N = mkTerm "cook_N" ;
lin cook_V = mkTerm "cook_V" ;
lin cook_V2 = mkTerm "cook_V2" ;
lin cookbook_N = mkTerm "cookbook_N" ;
lin cooker_N = mkTerm "cooker_N" ;
lin cookery_N = mkTerm "cookery_N" ;
lin cookery_book_N = mkTerm "cookery_book_N" ;
lin cookfire_N = mkTerm "cookfire_N" ;
lin cookham_PN = mkTerm "cookham_PN" ;
lin cookhouse_N = mkTerm "cookhouse_N" ;
lin cookie_N = mkTerm "cookie_N" ;
lin cooking_N = mkTerm "cooking_N" ;
lin cookout_N = mkTerm "cookout_N" ;
lin cookstove_N = mkTerm "cookstove_N" ;
lin cooky_N = mkTerm "cooky_N" ;
lin cool_A = mkTerm "cool_A" ;
lin cool_N = mkTerm "cool_N" ;
lin cool_V = mkTerm "cool_V" ;
lin cool_V2 = mkTerm "cool_V2" ;
lin cool_down_V = mkTerm "cool_down_V" ;
lin cool_down_V2 = mkTerm "cool_down_V2" ;
lin cool_headed_A = mkTerm "cool_headed_A" ;
lin cool_off_V = mkTerm "cool_off_V" ;
lin coolant_N = mkTerm "coolant_N" ;
lin cooler_N = mkTerm "cooler_N" ;
lin coolie_N = mkTerm "coolie_N" ;
lin cooling_N = mkTerm "cooling_N" ;
lin cooling_tower_N = mkTerm "cooling_tower_N" ;
lin coolness_N = mkTerm "coolness_N" ;
lin coon_N = mkTerm "coon_N" ;
lin coondog_N = mkTerm "coondog_N" ;
lin coonhound_N = mkTerm "coonhound_N" ;
lin coontie_N = mkTerm "coontie_N" ;
lin coop_N = mkTerm "coop_N" ;
lin coop_V2 = mkTerm "coop_V2" ;
lin coop_up_V2 = mkTerm "coop_up_V2" ;
lin cooper_N = mkTerm "cooper_N" ;
lin cooperate_V = mkTerm "cooperate_V" ;
lin cooperation_N = mkTerm "cooperation_N" ;
lin cooperative_A = mkTerm "cooperative_A" ;
lin cooperative_N = mkTerm "cooperative_N" ;
lin cooperator_N = mkTerm "cooperator_N" ;
lin coordinate_A = mkTerm "coordinate_A" ;
lin coordinate_N = mkTerm "coordinate_N" ;
lin coordinate_V = mkTerm "coordinate_V" ;
lin coordinate_V2 = mkTerm "coordinate_V2" ;
lin coordination_N = mkTerm "coordination_N" ;
lin coordinator_N = mkTerm "coordinator_N" ;
lin coot_N = mkTerm "coot_N" ;
lin cooter_N = mkTerm "cooter_N" ;
lin cop_N = mkTerm "cop_N" ;
lin cop_V2 = mkTerm "cop_V2" ;
lin cop_it_V = mkTerm "cop_it_V" ;
lin cop_off_V = mkTerm "cop_off_V" ;
lin cop_off_V2 = mkTerm "cop_off_V2" ;
lin cop_out_N = mkTerm "cop_out_N" ;
lin cop_out_V = mkTerm "cop_out_V" ;
lin copacetic_A = mkTerm "copacetic_A" ;
lin copaiba_N = mkTerm "copaiba_N" ;
lin copal_N = mkTerm "copal_N" ;
lin copalite_N = mkTerm "copalite_N" ;
lin copartner_N = mkTerm "copartner_N" ;
lin copartnership_N = mkTerm "copartnership_N" ;
lin cope_N = mkTerm "cope_N" ;
lin cope_V = mkTerm "cope_V" ;
lin copeck_N = mkTerm "copeck_N" ;
lin copenhagen_PN = mkTerm "copenhagen_PN" ;
lin copepod_N = mkTerm "copepod_N" ;
lin copernican_A = mkTerm "copernican_A" ;
lin copilot_N = mkTerm "copilot_N" ;
lin coping_N = mkTerm "coping_N" ;
lin coping_stone_N = mkTerm "coping_stone_N" ;
lin copious_A = mkTerm "copious_A" ;
lin coplanar_A = mkTerm "coplanar_A" ;
lin copolymer_N = mkTerm "copolymer_N" ;
lin copper_N = mkTerm "copper_N" ;
lin copper_V2 = mkTerm "copper_V2" ;
lin copper_bottom_V2 = mkTerm "copper_bottom_V2" ;
lin copper_bottomed_A = mkTerm "copper_bottomed_A" ;
lin copperhead_N = mkTerm "copperhead_N" ;
lin copperplate_N = mkTerm "copperplate_N" ;
lin coppersmith_N = mkTerm "coppersmith_N" ;
lin copperware_N = mkTerm "copperware_N" ;
lin coppery_A = mkTerm "coppery_A" ;
lin coppice_N = mkTerm "coppice_N" ;
lin coppull_PN = mkTerm "coppull_PN" ;
lin copra_N = mkTerm "copra_N" ;
lin coproduction_N = mkTerm "coproduction_N" ;
lin coprolalia_N = mkTerm "coprolalia_N" ;
lin coprolite_N = mkTerm "coprolite_N" ;
lin coprolith_N = mkTerm "coprolith_N" ;
lin coprophagy_N = mkTerm "coprophagy_N" ;
lin copse_N = mkTerm "copse_N" ;
lin copt_A = mkTerm "copt_A" ;
lin copt_N = mkTerm "copt_N" ;
lin coptic_N = mkTerm "coptic_N" ;
lin copula_N = mkTerm "copula_N" ;
lin copular_A = mkTerm "copular_A" ;
lin copulate_V = mkTerm "copulate_V" ;
lin copulation_N = mkTerm "copulation_N" ;
lin copulative_A = mkTerm "copulative_A" ;
lin copulative_N = mkTerm "copulative_N" ;
lin copy_N = mkTerm "copy_N" ;
lin copy_V = mkTerm "copy_V" ;
lin copy_V2 = mkTerm "copy_V2" ;
lin copybook_N = mkTerm "copybook_N" ;
lin copycat_N = mkTerm "copycat_N" ;
lin copyhold_N = mkTerm "copyhold_N" ;
lin copyholder_N = mkTerm "copyholder_N" ;
lin copying_N = mkTerm "copying_N" ;
lin copyist_N = mkTerm "copyist_N" ;
lin copyright_N = mkTerm "copyright_N" ;
lin copyright_V2 = mkTerm "copyright_V2" ;
lin copywriter_N = mkTerm "copywriter_N" ;
lin coquetry_N = mkTerm "coquetry_N" ;
lin coquette_N = mkTerm "coquette_N" ;
lin coquettish_A = mkTerm "coquettish_A" ;
lin coquille_N = mkTerm "coquille_N" ;
lin cor_anglais_N = mkTerm "cor_anglais_N" ;
lin coracle_N = mkTerm "coracle_N" ;
lin coral_A = mkTerm "coral_A" ;
lin coral_N = mkTerm "coral_N" ;
lin coral_reef_N = mkTerm "coral_reef_N" ;
lin coralbells_N = mkTerm "coralbells_N" ;
lin coralberry_N = mkTerm "coralberry_N" ;
lin coralwood_N = mkTerm "coralwood_N" ;
lin corbel_N = mkTerm "corbel_N" ;
lin corbelled_A = mkTerm "corbelled_A" ;
lin corbina_N = mkTerm "corbina_N" ;
lin corby_PN = mkTerm "corby_PN" ;
lin corchorus_N = mkTerm "corchorus_N" ;
lin cord_N = mkTerm "cord_N" ;
lin cord_V2 = mkTerm "cord_V2" ;
lin cordage_N = mkTerm "cordage_N" ;
lin cordate_A = mkTerm "cordate_A" ;
lin cordgrass_N = mkTerm "cordgrass_N" ;
lin cordial_A = mkTerm "cordial_A" ;
lin cordial_N = mkTerm "cordial_N" ;
lin cordiality_N = mkTerm "cordiality_N" ;
lin cordierite_N = mkTerm "cordierite_N" ;
lin cordite_N = mkTerm "cordite_N" ;
lin corditis_N = mkTerm "corditis_N" ;
lin cordless_A = mkTerm "cordless_A" ;
lin cordoba_N = mkTerm "cordoba_N" ;
lin cordoba_PN = mkTerm "cordoba_PN" ;
lin cordon_N = mkTerm "cordon_N" ;
lin cordon_V2 = mkTerm "cordon_V2" ;
lin cordon_bleu_A = mkTerm "cordon_bleu_A" ;
lin cordovan_N = mkTerm "cordovan_N" ;
lin cords_N = mkTerm "cords_N" ;
lin corduroy_N = mkTerm "corduroy_N" ;
lin cordwood_N = mkTerm "cordwood_N" ;
lin core_N = mkTerm "core_N" ;
lin core_V2 = mkTerm "core_V2" ;
lin coreference_N = mkTerm "coreference_N" ;
lin coreferent_A = mkTerm "coreferent_A" ;
lin coreferential_A = mkTerm "coreferential_A" ;
lin coreligionist_N = mkTerm "coreligionist_N" ;
lin coreopsis_N = mkTerm "coreopsis_N" ;
lin corer_N = mkTerm "corer_N" ;
lin corespondent_N = mkTerm "corespondent_N" ;
lin corgi_N = mkTerm "corgi_N" ;
lin coriaceous_A = mkTerm "coriaceous_A" ;
lin coriander_N = mkTerm "coriander_N" ;
lin corinthian_A = mkTerm "corinthian_A" ;
lin corinthian_N = mkTerm "corinthian_N" ;
lin cork_N = mkTerm "cork_N" ;
lin cork_PN = mkTerm "cork_PN" ;
lin cork_V2 = mkTerm "cork_V2" ;
lin corkage_N = mkTerm "corkage_N" ;
lin corkboard_N = mkTerm "corkboard_N" ;
lin corker_N = mkTerm "corker_N" ;
lin corkscrew_N = mkTerm "corkscrew_N" ;
lin corkwood_N = mkTerm "corkwood_N" ;
lin corm_N = mkTerm "corm_N" ;
lin cormorant_N = mkTerm "cormorant_N" ;
lin cormous_A = mkTerm "cormous_A" ;
lin corn_N = mkTerm "corn_N" ;
lin corn_V2 = mkTerm "corn_V2" ;
lin corn_exchange_N = mkTerm "corn_exchange_N" ;
lin cornbread_N = mkTerm "cornbread_N" ;
lin corncob_N = mkTerm "corncob_N" ;
lin corncrake_N = mkTerm "corncrake_N" ;
lin corncrib_N = mkTerm "corncrib_N" ;
lin cornea_N = mkTerm "cornea_N" ;
lin corneal_A = mkTerm "corneal_A" ;
lin cornelian_N = mkTerm "cornelian_N" ;
lin corneous_A = mkTerm "corneous_A" ;
lin corner_N = mkTerm "corner_N" ;
lin corner_V = mkTerm "corner_V" ;
lin corner_V2 = mkTerm "corner_V2" ;
lin corner_kick_N = mkTerm "corner_kick_N" ;
lin cornerback_N = mkTerm "cornerback_N" ;
lin cornerstone_N = mkTerm "cornerstone_N" ;
lin cornet_N = mkTerm "cornet_N" ;
lin cornetfish_N = mkTerm "cornetfish_N" ;
lin cornfield_N = mkTerm "cornfield_N" ;
lin cornflake_N = mkTerm "cornflake_N" ;
lin cornflour_N = mkTerm "cornflour_N" ;
lin cornflower_N = mkTerm "cornflower_N" ;
lin cornhusk_N = mkTerm "cornhusk_N" ;
lin cornhusker_N = mkTerm "cornhusker_N" ;
lin cornhusking_N = mkTerm "cornhusking_N" ;
lin cornice_N = mkTerm "cornice_N" ;
lin cornmeal_N = mkTerm "cornmeal_N" ;
lin cornpone_N = mkTerm "cornpone_N" ;
lin cornsilk_N = mkTerm "cornsilk_N" ;
lin cornsmut_N = mkTerm "cornsmut_N" ;
lin cornstalk_N = mkTerm "cornstalk_N" ;
lin cornstarch_N = mkTerm "cornstarch_N" ;
lin cornu_N = mkTerm "cornu_N" ;
lin cornucopia_N = mkTerm "cornucopia_N" ;
lin cornwall_PN = mkTerm "cornwall_PN" ;
lin corny_A = mkTerm "corny_A" ;
lin corolla_N = mkTerm "corolla_N" ;
lin corollary_N = mkTerm "corollary_N" ;
lin corona_N = mkTerm "corona_N" ;
lin coronary_A = mkTerm "coronary_A" ;
lin coronary_N = mkTerm "coronary_N" ;
lin coronation_N = mkTerm "coronation_N" ;
lin coroner_N = mkTerm "coroner_N" ;
lin coronet_N = mkTerm "coronet_N" ;
lin coroneted_A = mkTerm "coroneted_A" ;
lin coronilla_N = mkTerm "coronilla_N" ;
lin coronion_N = mkTerm "coronion_N" ;
lin corozo_N = mkTerm "corozo_N" ;
lin corp_PN = mkTerm "corp_PN" ;
lin corporal_A = mkTerm "corporal_A" ;
lin corporal_N = mkTerm "corporal_N" ;
lin corporate_A = mkTerm "corporate_A" ;
lin corporation_N = mkTerm "corporation_N" ;
lin corporatism_N = mkTerm "corporatism_N" ;
lin corporatist_A = mkTerm "corporatist_A" ;
lin corporatist_N = mkTerm "corporatist_N" ;
lin corporeal_A = mkTerm "corporeal_A" ;
lin corps_N = mkTerm "corps_N" ;
lin corps_de_ballet_N = mkTerm "corps_de_ballet_N" ;
lin corps_diplomatique_N = mkTerm "corps_diplomatique_N" ;
lin corpse_N = mkTerm "corpse_N" ;
lin corpulence_N = mkTerm "corpulence_N" ;
lin corpulent_A = mkTerm "corpulent_A" ;
lin corpus_N = mkTerm "corpus_N" ;
lin corpuscle_N = mkTerm "corpuscle_N" ;
lin corpuscular_A = mkTerm "corpuscular_A" ;
lin corral_N = mkTerm "corral_N" ;
lin corral_V2 = mkTerm "corral_V2" ;
lin correct_A = mkTerm "correct_A" ;
lin correct_V = mkTerm "correct_V" ;
lin correct_V2 = mkTerm "correct_V2" ;
lin correct_VS = mkTerm "correct_VS" ;
lin correctable_A = mkTerm "correctable_A" ;
lin correction_1_N = mkTerm "correction_1_N" ;
lin correction_2_N = mkTerm "correction_2_N" ;
lin correctional_A = mkTerm "correctional_A" ;
lin correctitude_N = mkTerm "correctitude_N" ;
lin corrective_A = mkTerm "corrective_A" ;
lin corrective_N = mkTerm "corrective_N" ;
lin correctness_N = mkTerm "correctness_N" ;
lin correlate_N = mkTerm "correlate_N" ;
lin correlate_V = mkTerm "correlate_V" ;
lin correlate_V2 = mkTerm "correlate_V2" ;
lin correlation_N = mkTerm "correlation_N" ;
lin correlational_A = mkTerm "correlational_A" ;
lin correlative_A = mkTerm "correlative_A" ;
lin correlative_N = mkTerm "correlative_N" ;
lin correspond_V = mkTerm "correspond_V" ;
lin correspond_V2 = mkTerm "correspond_V2" ;
lin correspondence_N = mkTerm "correspondence_N" ;
lin correspondent_N = mkTerm "correspondent_N" ;
lin corresponding_A = mkTerm "corresponding_A" ;
lin corridor_N = mkTerm "corridor_N" ;
lin corrie_N = mkTerm "corrie_N" ;
lin corrigenda_N = mkTerm "corrigenda_N" ;
lin corrigendum_N = mkTerm "corrigendum_N" ;
lin corrigible_A = mkTerm "corrigible_A" ;
lin corroborant_A = mkTerm "corroborant_A" ;
lin corroborate_V2 = mkTerm "corroborate_V2" ;
lin corroboration_N = mkTerm "corroboration_N" ;
lin corroborative_A = mkTerm "corroborative_A" ;
lin corrode_V = mkTerm "corrode_V" ;
lin corrode_V2 = mkTerm "corrode_V2" ;
lin corrosion_N = mkTerm "corrosion_N" ;
lin corrosive_A = mkTerm "corrosive_A" ;
lin corrosive_N = mkTerm "corrosive_N" ;
lin corrugate_V = mkTerm "corrugate_V" ;
lin corrugate_V2 = mkTerm "corrugate_V2" ;
lin corrugation_N = mkTerm "corrugation_N" ;
lin corrupt_A = mkTerm "corrupt_A" ;
lin corrupt_V = mkTerm "corrupt_V" ;
lin corrupt_V2 = mkTerm "corrupt_V2" ;
lin corruptibility_N = mkTerm "corruptibility_N" ;
lin corruptible_A = mkTerm "corruptible_A" ;
lin corruption_N = mkTerm "corruption_N" ;
lin corruptive_A = mkTerm "corruptive_A" ;
lin corruptness_N = mkTerm "corruptness_N" ;
lin corsage_N = mkTerm "corsage_N" ;
lin corsair_N = mkTerm "corsair_N" ;
lin corse_N = mkTerm "corse_N" ;
lin corselet_N = mkTerm "corselet_N" ;
lin corset_N = mkTerm "corset_N" ;
lin corsham_PN = mkTerm "corsham_PN" ;
lin corslet_N = mkTerm "corslet_N" ;
lin cortege_1_N = mkTerm "cortege_1_N" ;
lin cortege_2_N = mkTerm "cortege_2_N" ;
lin cortex_N = mkTerm "cortex_N" ;
lin cortical_A = mkTerm "cortical_A" ;
lin corticoafferent_A = mkTerm "corticoafferent_A" ;
lin corticoefferent_A = mkTerm "corticoefferent_A" ;
lin corticosteroid_N = mkTerm "corticosteroid_N" ;
lin corticosterone_N = mkTerm "corticosterone_N" ;
lin cortina_N = mkTerm "cortina_N" ;
lin cortisone_N = mkTerm "cortisone_N" ;
lin corundom_N = mkTerm "corundom_N" ;
lin corundum_N = mkTerm "corundum_N" ;
lin corunna_PN = mkTerm "corunna_PN" ;
lin coruscate_V = mkTerm "coruscate_V" ;
lin coruscation_N = mkTerm "coruscation_N" ;
lin corvee_N = mkTerm "corvee_N" ;
lin corvette_N = mkTerm "corvette_N" ;
lin corvine_A = mkTerm "corvine_A" ;
lin corydalis_N = mkTerm "corydalis_N" ;
lin corymb_N = mkTerm "corymb_N" ;
lin corymbose_A = mkTerm "corymbose_A" ;
lin corynebacterium_N = mkTerm "corynebacterium_N" ;
lin coryphantha_N = mkTerm "coryphantha_N" ;
lin corythosaur_N = mkTerm "corythosaur_N" ;
lin cos_N = mkTerm "cos_N" ;
lin coscoroba_N = mkTerm "coscoroba_N" ;
lin cosecant_N = mkTerm "cosecant_N" ;
lin coseismic_A = mkTerm "coseismic_A" ;
lin cosenza_PN = mkTerm "cosenza_PN" ;
lin cosh_N = mkTerm "cosh_N" ;
lin cosh_V2 = mkTerm "cosh_V2" ;
lin cosher_A = mkTerm "cosher_A" ;
lin cosignatory_A = mkTerm "cosignatory_A" ;
lin cosignatory_N = mkTerm "cosignatory_N" ;
lin cosigner_N = mkTerm "cosigner_N" ;
lin cosine_N = mkTerm "cosine_N" ;
lin cosiness_N = mkTerm "cosiness_N" ;
lin cosmetic_A = mkTerm "cosmetic_A" ;
lin cosmetic_N = mkTerm "cosmetic_N" ;
lin cosmetician_N = mkTerm "cosmetician_N" ;
lin cosmetologist_N = mkTerm "cosmetologist_N" ;
lin cosmetology_N = mkTerm "cosmetology_N" ;
lin cosmic_A = mkTerm "cosmic_A" ;
lin cosmid_N = mkTerm "cosmid_N" ;
lin cosmogony_N = mkTerm "cosmogony_N" ;
lin cosmographer_N = mkTerm "cosmographer_N" ;
lin cosmography_N = mkTerm "cosmography_N" ;
lin cosmolatry_N = mkTerm "cosmolatry_N" ;
lin cosmologic_A = mkTerm "cosmologic_A" ;
lin cosmologist_N = mkTerm "cosmologist_N" ;
lin cosmology_N = mkTerm "cosmology_N" ;
lin cosmonaut_N = mkTerm "cosmonaut_N" ;
lin cosmopolitan_A = mkTerm "cosmopolitan_A" ;
lin cosmopolitan_N = mkTerm "cosmopolitan_N" ;
lin cosmos_N = mkTerm "cosmos_N" ;
lin cosmotron_N = mkTerm "cosmotron_N" ;
lin cosset_V2 = mkTerm "cosset_V2" ;
lin cost_N = mkTerm "cost_N" ;
lin cost_V = mkTerm "cost_V" ;
lin cost_V2 = mkTerm "cost_V2" ;
lin cost_up_V2 = mkTerm "cost_up_V2" ;
lin costa_N = mkTerm "costa_N" ;
lin costa_rica_PN = mkTerm "costa_rica_PN" ;
lin costa_rican_A = mkTerm "costa_rican_A" ;
lin costa_rican_N = mkTerm "costa_rican_N" ;
lin costal_A = mkTerm "costal_A" ;
lin costate_A = mkTerm "costate_A" ;
lin costermonger_N = mkTerm "costermonger_N" ;
lin costia_N = mkTerm "costia_N" ;
lin costiasis_N = mkTerm "costiasis_N" ;
lin costing_N = mkTerm "costing_N" ;
lin costive_A = mkTerm "costive_A" ;
lin costliness_N = mkTerm "costliness_N" ;
lin costly_A = mkTerm "costly_A" ;
lin costmary_N = mkTerm "costmary_N" ;
lin costochondritis_N = mkTerm "costochondritis_N" ;
lin costs_N = mkTerm "costs_N" ;
lin costum_V2 = mkTerm "costum_V2" ;
lin costume_N = mkTerm "costume_N" ;
lin costumed_A = mkTerm "costumed_A" ;
lin costumier_N = mkTerm "costumier_N" ;
lin costusroot_N = mkTerm "costusroot_N" ;
lin cosy_A = mkTerm "cosy_A" ;
lin cosy_N = mkTerm "cosy_N" ;
lin cot_N = mkTerm "cot_N" ;
lin cotangent_N = mkTerm "cotangent_N" ;
lin cote_N = mkTerm "cote_N" ;
lin cotenant_N = mkTerm "cotenant_N" ;
lin coterie_N = mkTerm "coterie_N" ;
lin coterminous_A = mkTerm "coterminous_A" ;
lin cotilion_N = mkTerm "cotilion_N" ;
lin cotillion_N = mkTerm "cotillion_N" ;
lin cotinga_N = mkTerm "cotinga_N" ;
lin cotoneaster_N = mkTerm "cotoneaster_N" ;
lin cottage_N = mkTerm "cottage_N" ;
lin cottager_N = mkTerm "cottager_N" ;
lin cottar_N = mkTerm "cottar_N" ;
lin cotter_N = mkTerm "cotter_N" ;
lin cotton_N = mkTerm "cotton_N" ;
lin cotton_V = mkTerm "cotton_V" ;
lin cotton_cake_N = mkTerm "cotton_cake_N" ;
lin cotton_on_V = mkTerm "cotton_on_V" ;
lin cotton_plant_N = mkTerm "cotton_plant_N" ;
lin cotton_wool_N = mkTerm "cotton_wool_N" ;
lin cottonseed_N = mkTerm "cottonseed_N" ;
lin cottontail_N = mkTerm "cottontail_N" ;
lin cottonweed_N = mkTerm "cottonweed_N" ;
lin cottonwick_N = mkTerm "cottonwick_N" ;
lin cottonwood_N = mkTerm "cottonwood_N" ;
lin cottony_A = mkTerm "cottony_A" ;
lin cotyledon_N = mkTerm "cotyledon_N" ;
lin coucal_N = mkTerm "coucal_N" ;
lin couch_N = mkTerm "couch_N" ;
lin couch_V = mkTerm "couch_V" ;
lin couch_V2 = mkTerm "couch_V2" ;
lin couch_grass_N = mkTerm "couch_grass_N" ;
lin couchant_A = mkTerm "couchant_A" ;
lin couchette_N = mkTerm "couchette_N" ;
lin cougar_N = mkTerm "cougar_N" ;
lin cough_N = mkTerm "cough_N" ;
lin cough_V = mkTerm "cough_V" ;
lin cough_up_V2 = mkTerm "cough_up_V2" ;
lin coulisse_N = mkTerm "coulisse_N" ;
lin coulomb_N = mkTerm "coulomb_N" ;
lin coulter_N = mkTerm "coulter_N" ;
lin council_N = mkTerm "council_N" ;
lin council_board_N = mkTerm "council_board_N" ;
lin council_chamber_N = mkTerm "council_chamber_N" ;
lin councillor_N = mkTerm "councillor_N" ;
lin councillorship_N = mkTerm "councillorship_N" ;
lin councilman_N = mkTerm "councilman_N" ;
lin councilwoman_N = mkTerm "councilwoman_N" ;
lin counsel_N = mkTerm "counsel_N" ;
lin counsel_V2 = mkTerm "counsel_V2" ;
lin counselling_N = mkTerm "counselling_N" ;
lin counsellor_N = mkTerm "counsellor_N" ;
lin counselorship_N = mkTerm "counselorship_N" ;
lin count_1_N = mkTerm "count_1_N" ;
lin count_2_N = mkTerm "count_2_N" ;
lin count_V = mkTerm "count_V" ;
lin count_V2 = mkTerm "count_V2" ;
lin count_against_V2 = mkTerm "count_against_V2" ;
lin count_among_V2 = mkTerm "count_among_V2" ;
lin count_down_V2 = mkTerm "count_down_V2" ;
lin count_for_V2 = mkTerm "count_for_V2" ;
lin count_in_V2 = mkTerm "count_in_V2" ;
lin count_off_V2 = mkTerm "count_off_V2" ;
lin count_on_V2 = mkTerm "count_on_V2" ;
lin count_out_V2 = mkTerm "count_out_V2" ;
lin count_towards_V2 = mkTerm "count_towards_V2" ;
lin count_up_V2 = mkTerm "count_up_V2" ;
lin count_upon_V2 = mkTerm "count_upon_V2" ;
lin countable_A = mkTerm "countable_A" ;
lin countdown_N = mkTerm "countdown_N" ;
lin countenance_N = mkTerm "countenance_N" ;
lin countenance_V2 = mkTerm "countenance_V2" ;
lin counter_A = mkTerm "counter_A" ;
lin counter_Adv = mkTerm "counter_Adv" ;
lin counter_N = mkTerm "counter_N" ;
lin counter_V = mkTerm "counter_V" ;
lin counter_VS = mkTerm "counter_VS" ;
lin counter_example_N = mkTerm "counter_example_N" ;
lin counter_revolution_N = mkTerm "counter_revolution_N" ;
lin counter_revolutionary_A = mkTerm "counter_revolutionary_A" ;
lin counter_revolutionary_N = mkTerm "counter_revolutionary_N" ;
lin counteract_V2 = mkTerm "counteract_V2" ;
lin counteraction_N = mkTerm "counteraction_N" ;
lin counteractive_A = mkTerm "counteractive_A" ;
lin counterargument_N = mkTerm "counterargument_N" ;
lin counterattack_N = mkTerm "counterattack_N" ;
lin counterattack_V = mkTerm "counterattack_V" ;
lin counterattack_V2 = mkTerm "counterattack_V2" ;
lin counterattraction_N = mkTerm "counterattraction_N" ;
lin counterbalance_N = mkTerm "counterbalance_N" ;
lin counterbalance_V2 = mkTerm "counterbalance_V2" ;
lin counterblast_N = mkTerm "counterblast_N" ;
lin counterblow_N = mkTerm "counterblow_N" ;
lin counterbombardment_N = mkTerm "counterbombardment_N" ;
lin counterbore_N = mkTerm "counterbore_N" ;
lin countercharge_N = mkTerm "countercharge_N" ;
lin countercheck_N = mkTerm "countercheck_N" ;
lin counterclaim_N = mkTerm "counterclaim_N" ;
lin counterclockwise_A = mkTerm "counterclockwise_A" ;
lin counterclockwise_Adv = mkTerm "counterclockwise_Adv" ;
lin countercoup_N = mkTerm "countercoup_N" ;
lin counterculture_N = mkTerm "counterculture_N" ;
lin countercurrent_N = mkTerm "countercurrent_N" ;
lin counterdemonstration_N = mkTerm "counterdemonstration_N" ;
lin counterdemonstrator_N = mkTerm "counterdemonstrator_N" ;
lin counterespionage_N = mkTerm "counterespionage_N" ;
lin counterfactual_A = mkTerm "counterfactual_A" ;
lin counterfactuality_N = mkTerm "counterfactuality_N" ;
lin counterfeit_A = mkTerm "counterfeit_A" ;
lin counterfeit_N = mkTerm "counterfeit_N" ;
lin counterfeit_V2 = mkTerm "counterfeit_V2" ;
lin counterfeiter_N = mkTerm "counterfeiter_N" ;
lin counterfire_N = mkTerm "counterfire_N" ;
lin counterfoil_N = mkTerm "counterfoil_N" ;
lin counterglow_N = mkTerm "counterglow_N" ;
lin counterinsurgent_A = mkTerm "counterinsurgent_A" ;
lin counterintelligence_N = mkTerm "counterintelligence_N" ;
lin counterintuitive_A = mkTerm "counterintuitive_A" ;
lin counterirritant_N = mkTerm "counterirritant_N" ;
lin countermand_N = mkTerm "countermand_N" ;
lin countermand_V2 = mkTerm "countermand_V2" ;
lin countermarch_N = mkTerm "countermarch_N" ;
lin countermeasure_N = mkTerm "countermeasure_N" ;
lin countermine_N = mkTerm "countermine_N" ;
lin countermine_V = mkTerm "countermine_V" ;
lin countermine_V2 = mkTerm "countermine_V2" ;
lin counteroffensive_N = mkTerm "counteroffensive_N" ;
lin counteroffer_N = mkTerm "counteroffer_N" ;
lin counterpane_N = mkTerm "counterpane_N" ;
lin counterpart_N = mkTerm "counterpart_N" ;
lin counterperson_N = mkTerm "counterperson_N" ;
lin counterplea_N = mkTerm "counterplea_N" ;
lin counterplot_N = mkTerm "counterplot_N" ;
lin counterplot_V = mkTerm "counterplot_V" ;
lin counterplot_V2 = mkTerm "counterplot_V2" ;
lin counterpoint_N = mkTerm "counterpoint_N" ;
lin counterpoise_N = mkTerm "counterpoise_N" ;
lin counterpoise_V2 = mkTerm "counterpoise_V2" ;
lin counterproductive_A = mkTerm "counterproductive_A" ;
lin counterproposal_N = mkTerm "counterproposal_N" ;
lin counterpunch_N = mkTerm "counterpunch_N" ;
lin counterreformation_N = mkTerm "counterreformation_N" ;
lin counterrevolutionist_N = mkTerm "counterrevolutionist_N" ;
lin countershot_N = mkTerm "countershot_N" ;
lin countersign_N = mkTerm "countersign_N" ;
lin countersign_V2 = mkTerm "countersign_V2" ;
lin countersignature_N = mkTerm "countersignature_N" ;
lin countersink_N = mkTerm "countersink_N" ;
lin countersink_V2 = mkTerm "countersink_V2" ;
lin counterspy_N = mkTerm "counterspy_N" ;
lin counterstain_N = mkTerm "counterstain_N" ;
lin countersubversion_N = mkTerm "countersubversion_N" ;
lin countersuing_V2 = mkTerm "countersuing_V2" ;
lin countersuit_N = mkTerm "countersuit_N" ;
lin countertenor_A = mkTerm "countertenor_A" ;
lin countertenor_N = mkTerm "countertenor_N" ;
lin counterterror_A = mkTerm "counterterror_A" ;
lin counterterrorism_N = mkTerm "counterterrorism_N" ;
lin counterterrorist_N = mkTerm "counterterrorist_N" ;
lin countertop_N = mkTerm "countertop_N" ;
lin countertransference_N = mkTerm "countertransference_N" ;
lin countervail_V = mkTerm "countervail_V" ;
lin countervail_V2 = mkTerm "countervail_V2" ;
lin counterweight_N = mkTerm "counterweight_N" ;
lin countess_N = mkTerm "countess_N" ;
lin counting_house_N = mkTerm "counting_house_N" ;
lin countless_A = mkTerm "countless_A" ;
lin countrified_A = mkTerm "countrified_A" ;
lin country_N = mkTerm "country_N" ;
lin country_house_N = mkTerm "country_house_N" ;
lin country_seat_N = mkTerm "country_seat_N" ;
lin countryman_N = mkTerm "countryman_N" ;
lin countryside_N = mkTerm "countryside_N" ;
lin countrywide_A = mkTerm "countrywide_A" ;
lin countrywoman_N = mkTerm "countrywoman_N" ;
lin county_N = mkTerm "county_N" ;
lin countywide_A = mkTerm "countywide_A" ;
lin coup_N = mkTerm "coup_N" ;
lin coup_d'etat_N = mkTerm "coup_d'etat_N" ;
lin coup_de_grace_N = mkTerm "coup_de_grace_N" ;
lin coupe_N = mkTerm "coupe_N" ;
lin couple_N = mkTerm "couple_N" ;
lin couple_V = mkTerm "couple_V" ;
lin couple_V2 = mkTerm "couple_V2" ;
lin couplet_N = mkTerm "couplet_N" ;
lin coupling_N = mkTerm "coupling_N" ;
lin coupon_N = mkTerm "coupon_N" ;
lin courage_N = mkTerm "courage_N" ;
lin courageous_A = mkTerm "courageous_A" ;
lin courante_N = mkTerm "courante_N" ;
lin courbaril_N = mkTerm "courbaril_N" ;
lin courgette_N = mkTerm "courgette_N" ;
lin courier_N = mkTerm "courier_N" ;
lin courlan_N = mkTerm "courlan_N" ;
lin course_N = mkTerm "course_N" ;
lin course_V = mkTerm "course_V" ;
lin course_V2 = mkTerm "course_V2" ;
lin courser_N = mkTerm "courser_N" ;
lin coursework_N = mkTerm "coursework_N" ;
lin coursing_N = mkTerm "coursing_N" ;
lin court_1_N = mkTerm "court_1_N" ;
lin court_2_N = mkTerm "court_2_N" ;
lin court_V = mkTerm "court_V" ;
lin court_V2 = mkTerm "court_V2" ;
lin court_card_N = mkTerm "court_card_N" ;
lin court_martial_N = mkTerm "court_martial_N" ;
lin court_martial_V2 = mkTerm "court_martial_V2" ;
lin courteous_A = mkTerm "courteous_A" ;
lin courtesan_N = mkTerm "courtesan_N" ;
lin courtesy_N = mkTerm "courtesy_N" ;
lin courthouse_N = mkTerm "courthouse_N" ;
lin courtier_N = mkTerm "courtier_N" ;
lin courtliness_N = mkTerm "courtliness_N" ;
lin courtly_A = mkTerm "courtly_A" ;
lin courtroom_N = mkTerm "courtroom_N" ;
lin courtship_N = mkTerm "courtship_N" ;
lin courtyard_N = mkTerm "courtyard_N" ;
lin couscous_N = mkTerm "couscous_N" ;
lin cousin_N = mkTerm "cousin_N" ;
lin cousinly_A = mkTerm "cousinly_A" ;
lin couth_A = mkTerm "couth_A" ;
lin couthie_A = mkTerm "couthie_A" ;
lin couture_N = mkTerm "couture_N" ;
lin couturier_N = mkTerm "couturier_N" ;
lin couvade_N = mkTerm "couvade_N" ;
lin couverture_N = mkTerm "couverture_N" ;
lin covalence_N = mkTerm "covalence_N" ;
lin covalent_A = mkTerm "covalent_A" ;
lin covariance_N = mkTerm "covariance_N" ;
lin covariant_A = mkTerm "covariant_A" ;
lin covariation_N = mkTerm "covariation_N" ;
lin cove_N = mkTerm "cove_N" ;
lin coven_N = mkTerm "coven_N" ;
lin covenant_N = mkTerm "covenant_N" ;
lin covenant_V = mkTerm "covenant_V" ;
lin covenant_V2 = mkTerm "covenant_V2" ;
lin coventry_PN = mkTerm "coventry_PN" ;
lin cover_N = mkTerm "cover_N" ;
lin cover_V2 = mkTerm "cover_V2" ;
lin cover_for_V2 = mkTerm "cover_for_V2" ;
lin cover_up_N = mkTerm "cover_up_N" ;
lin cover_up_V2 = mkTerm "cover_up_V2" ;
lin coverage_N = mkTerm "coverage_N" ;
lin coverall_N = mkTerm "coverall_N" ;
lin covering_A = mkTerm "covering_A" ;
lin covering_N = mkTerm "covering_N" ;
lin coverlet_N = mkTerm "coverlet_N" ;
lin covert_A = mkTerm "covert_A" ;
lin covert_N = mkTerm "covert_N" ;
lin covet_V2 = mkTerm "covet_V2" ;
lin covetous_A = mkTerm "covetous_A" ;
lin covetousness_N = mkTerm "covetousness_N" ;
lin covey_N = mkTerm "covey_N" ;
lin cow_N = mkTerm "cow_N" ;
lin cow_V2 = mkTerm "cow_V2" ;
lin cowage_N = mkTerm "cowage_N" ;
lin coward_N = mkTerm "coward_N" ;
lin cowardice_N = mkTerm "cowardice_N" ;
lin cowardly_A = mkTerm "cowardly_A" ;
lin cowbarn_N = mkTerm "cowbarn_N" ;
lin cowbell_N = mkTerm "cowbell_N" ;
lin cowberry_N = mkTerm "cowberry_N" ;
lin cowbird_N = mkTerm "cowbird_N" ;
lin cowboy_N = mkTerm "cowboy_N" ;
lin cowcatcher_N = mkTerm "cowcatcher_N" ;
lin cowdenbeath_PN = mkTerm "cowdenbeath_PN" ;
lin cower_V = mkTerm "cower_V" ;
lin cowes_PN = mkTerm "cowes_PN" ;
lin cowfish_N = mkTerm "cowfish_N" ;
lin cowgirl_N = mkTerm "cowgirl_N" ;
lin cowhand_N = mkTerm "cowhand_N" ;
lin cowherb_N = mkTerm "cowherb_N" ;
lin cowherd_N = mkTerm "cowherd_N" ;
lin cowhide_N = mkTerm "cowhide_N" ;
lin cowhouse_N = mkTerm "cowhouse_N" ;
lin cowl_N = mkTerm "cowl_N" ;
lin cowled_A = mkTerm "cowled_A" ;
lin cowlick_N = mkTerm "cowlick_N" ;
lin cowling_N = mkTerm "cowling_N" ;
lin cowman_N = mkTerm "cowman_N" ;
lin coworker_N = mkTerm "coworker_N" ;
lin cowpea_N = mkTerm "cowpea_N" ;
lin cowpox_N = mkTerm "cowpox_N" ;
lin cowrie_N = mkTerm "cowrie_N" ;
lin cowshed_N = mkTerm "cowshed_N" ;
lin cowskin_N = mkTerm "cowskin_N" ;
lin cowslip_N = mkTerm "cowslip_N" ;
lin cox_N = mkTerm "cox_N" ;
lin cox_V = mkTerm "cox_V" ;
lin cox_V2 = mkTerm "cox_V2" ;
lin coxcomb_N = mkTerm "coxcomb_N" ;
lin coxsackievirus_N = mkTerm "coxsackievirus_N" ;
lin coxswain_N = mkTerm "coxswain_N" ;
lin coy_A = mkTerm "coy_A" ;
lin coydog_N = mkTerm "coydog_N" ;
lin coyness_N = mkTerm "coyness_N" ;
lin coyol_N = mkTerm "coyol_N" ;
lin coyote_N = mkTerm "coyote_N" ;
lin coypu_N = mkTerm "coypu_N" ;
lin cozen_V2 = mkTerm "cozen_V2" ;
lin coziness_N = mkTerm "coziness_N" ;
lin cozy_A = mkTerm "cozy_A" ;
lin cozy_up_V = mkTerm "cozy_up_V" ;
lin cozy_up_to_V2 = mkTerm "cozy_up_to_V2" ;
lin cp_PN = mkTerm "cp_PN" ;
lin cpl_PN = mkTerm "cpl_PN" ;
lin crab_N = mkTerm "crab_N" ;
lin crab_V = mkTerm "crab_V" ;
lin crab_V2 = mkTerm "crab_V2" ;
lin crab_apple_N = mkTerm "crab_apple_N" ;
lin crabbiness_N = mkTerm "crabbiness_N" ;
lin crabgrass_N = mkTerm "crabgrass_N" ;
lin crabwise_A = mkTerm "crabwise_A" ;
lin crack_N = mkTerm "crack_N" ;
lin crack_V2 = mkTerm "crack_V2" ;
lin crack_down_N = mkTerm "crack_down_N" ;
lin crack_down_V = mkTerm "crack_down_V" ;
lin crack_down_on_V2 = mkTerm "crack_down_on_V2" ;
lin crack_on_V = mkTerm "crack_on_V" ;
lin crack_up_N = mkTerm "crack_up_N" ;
lin crack_up_V = mkTerm "crack_up_V" ;
lin crack_up_V2 = mkTerm "crack_up_V2" ;
lin crack_up_at_V2 = mkTerm "crack_up_at_V2" ;
lin crackbrained_A = mkTerm "crackbrained_A" ;
lin cracker_N = mkTerm "cracker_N" ;
lin crackers_A = mkTerm "crackers_A" ;
lin cracking_N = mkTerm "cracking_N" ;
lin crackle_A = mkTerm "crackle_A" ;
lin crackle_N = mkTerm "crackle_N" ;
lin crackle_V = mkTerm "crackle_V" ;
lin crackle_china_N = mkTerm "crackle_china_N" ;
lin crackleware_N = mkTerm "crackleware_N" ;
lin crackling_N = mkTerm "crackling_N" ;
lin cracklings_N = mkTerm "cracklings_N" ;
lin crackpot_N = mkTerm "crackpot_N" ;
lin cracksman_N = mkTerm "cracksman_N" ;
lin cradle_N = mkTerm "cradle_N" ;
lin cradle_V2 = mkTerm "cradle_V2" ;
lin craft_N = mkTerm "craft_N" ;
lin craft_V2 = mkTerm "craft_V2" ;
lin craftiness_N = mkTerm "craftiness_N" ;
lin craftsman_N = mkTerm "craftsman_N" ;
lin craftsmanship_N = mkTerm "craftsmanship_N" ;
lin crafty_A = mkTerm "crafty_A" ;
lin crag_N = mkTerm "crag_N" ;
lin cragfast_A = mkTerm "cragfast_A" ;
lin cragged_A = mkTerm "cragged_A" ;
lin craggy_A = mkTerm "craggy_A" ;
lin cragsman_N = mkTerm "cragsman_N" ;
lin crake_N = mkTerm "crake_N" ;
lin cram_V = mkTerm "cram_V" ;
lin cram_V2 = mkTerm "cram_V2" ;
lin cram_full_A = mkTerm "cram_full_A" ;
lin cram_full_Adv = mkTerm "cram_full_Adv" ;
lin cram_in_V = mkTerm "cram_in_V" ;
lin cramlington_PN = mkTerm "cramlington_PN" ;
lin crammer_N = mkTerm "crammer_N" ;
lin cramp_N = mkTerm "cramp_N" ;
lin cramp_V2 = mkTerm "cramp_V2" ;
lin cramp_iron_N = mkTerm "cramp_iron_N" ;
lin crampon_N = mkTerm "crampon_N" ;
lin cran_N = mkTerm "cran_N" ;
lin cranberry_N = mkTerm "cranberry_N" ;
lin crane_N = mkTerm "crane_N" ;
lin crane_V = mkTerm "crane_V" ;
lin crane_V2 = mkTerm "crane_V2" ;
lin crane_fly_N = mkTerm "crane_fly_N" ;
lin cranesbill_N = mkTerm "cranesbill_N" ;
lin cranial_A = mkTerm "cranial_A" ;
lin craniology_N = mkTerm "craniology_N" ;
lin craniometer_N = mkTerm "craniometer_N" ;
lin craniometric_A = mkTerm "craniometric_A" ;
lin craniometry_N = mkTerm "craniometry_N" ;
lin craniotomy_N = mkTerm "craniotomy_N" ;
lin cranium_N = mkTerm "cranium_N" ;
lin crank_A = mkTerm "crank_A" ;
lin crank_N = mkTerm "crank_N" ;
lin crank_V2 = mkTerm "crank_V2" ;
lin crank_out_V = mkTerm "crank_out_V" ;
lin crank_up_V2 = mkTerm "crank_up_V2" ;
lin crankcase_N = mkTerm "crankcase_N" ;
lin crankiness_N = mkTerm "crankiness_N" ;
lin crankshaft_N = mkTerm "crankshaft_N" ;
lin cranky_A = mkTerm "cranky_A" ;
lin crannied_A = mkTerm "crannied_A" ;
lin cranny_N = mkTerm "cranny_N" ;
lin crap_N = mkTerm "crap_N" ;
lin crap_V = mkTerm "crap_V" ;
lin crap_shooting_N = mkTerm "crap_shooting_N" ;
lin crapaud_N = mkTerm "crapaud_N" ;
lin crape_N = mkTerm "crape_N" ;
lin crappie_N = mkTerm "crappie_N" ;
lin craps_N = mkTerm "craps_N" ;
lin crapshoot_N = mkTerm "crapshoot_N" ;
lin crapshooter_N = mkTerm "crapshooter_N" ;
lin crapulent_A = mkTerm "crapulent_A" ;
lin crapulous_A = mkTerm "crapulous_A" ;
lin crash_Adv = mkTerm "crash_Adv" ;
lin crash_N = mkTerm "crash_N" ;
lin crash_V = mkTerm "crash_V" ;
lin crash_dive_N = mkTerm "crash_dive_N" ;
lin crash_dive_V = mkTerm "crash_dive_V" ;
lin crash_helmet_N = mkTerm "crash_helmet_N" ;
lin crash_land_V = mkTerm "crash_land_V" ;
lin crash_land_V2 = mkTerm "crash_land_V2" ;
lin crash_landing_N = mkTerm "crash_landing_N" ;
lin crash_out_V = mkTerm "crash_out_V" ;
lin crass_A = mkTerm "crass_A" ;
lin crassness_N = mkTerm "crassness_N" ;
lin crate_N = mkTerm "crate_N" ;
lin crate_V2 = mkTerm "crate_V2" ;
lin crater_N = mkTerm "crater_N" ;
lin crater_V = mkTerm "crater_V" ;
lin craton_N = mkTerm "craton_N" ;
lin cravat_N = mkTerm "cravat_N" ;
lin crave_V = mkTerm "crave_V" ;
lin crave_V2 = mkTerm "crave_V2" ;
lin craven_A = mkTerm "craven_A" ;
lin craven_N = mkTerm "craven_N" ;
lin cravenness_N = mkTerm "cravenness_N" ;
lin craving_N = mkTerm "craving_N" ;
lin craw_N = mkTerm "craw_N" ;
lin crawfish_N = mkTerm "crawfish_N" ;
lin crawl_N = mkTerm "crawl_N" ;
lin crawl_V = mkTerm "crawl_V" ;
lin crawler_N = mkTerm "crawler_N" ;
lin crawley_PN = mkTerm "crawley_PN" ;
lin crawlspace_N = mkTerm "crawlspace_N" ;
lin crayfish_N = mkTerm "crayfish_N" ;
lin crayon_N = mkTerm "crayon_N" ;
lin crayon_V2 = mkTerm "crayon_V2" ;
lin craze_N = mkTerm "craze_N" ;
lin crazed_A = mkTerm "crazed_A" ;
lin craziness_N = mkTerm "craziness_N" ;
lin crazy_A = mkTerm "crazy_A" ;
lin crazy_N = mkTerm "crazy_N" ;
lin creak_N = mkTerm "creak_N" ;
lin creak_V = mkTerm "creak_V" ;
lin creaky_A = mkTerm "creaky_A" ;
lin cream_N = mkTerm "cream_N" ;
lin cream_V2 = mkTerm "cream_V2" ;
lin cream_off_V2 = mkTerm "cream_off_V2" ;
lin creamcups_N = mkTerm "creamcups_N" ;
lin creamery_N = mkTerm "creamery_N" ;
lin creaminess_N = mkTerm "creaminess_N" ;
lin creamy_A = mkTerm "creamy_A" ;
lin crease_N = mkTerm "crease_N" ;
lin crease_V = mkTerm "crease_V" ;
lin crease_V2 = mkTerm "crease_V2" ;
lin creaseless_A = mkTerm "creaseless_A" ;
lin creaseproof_A = mkTerm "creaseproof_A" ;
lin create_V = mkTerm "create_V" ;
lin create_V2 = mkTerm "create_V2" ;
lin creatine_N = mkTerm "creatine_N" ;
lin creation_N = mkTerm "creation_N" ;
lin creationism_N = mkTerm "creationism_N" ;
lin creative_A = mkTerm "creative_A" ;
lin creativeness_N = mkTerm "creativeness_N" ;
lin creativity_N = mkTerm "creativity_N" ;
lin creator_N = mkTerm "creator_N" ;
lin creature_N = mkTerm "creature_N" ;
lin creche_N = mkTerm "creche_N" ;
lin credence_N = mkTerm "credence_N" ;
lin credentialled_A = mkTerm "credentialled_A" ;
lin credenza_N = mkTerm "credenza_N" ;
lin credibility_N = mkTerm "credibility_N" ;
lin credible_A = mkTerm "credible_A" ;
lin credit_N = mkTerm "credit_N" ;
lin credit_V2 = mkTerm "credit_V2" ;
lin credit_side_N = mkTerm "credit_side_N" ;
lin credit_worthiness_N = mkTerm "credit_worthiness_N" ;
lin credit_worthy_A = mkTerm "credit_worthy_A" ;
lin creditable_A = mkTerm "creditable_A" ;
lin creditor_N = mkTerm "creditor_N" ;
lin credits_N = mkTerm "credits_N" ;
lin credo_N = mkTerm "credo_N" ;
lin credulity_N = mkTerm "credulity_N" ;
lin credulous_A = mkTerm "credulous_A" ;
lin credulousness_N = mkTerm "credulousness_N" ;
lin creed_N = mkTerm "creed_N" ;
lin creedal_A = mkTerm "creedal_A" ;
lin creek_N = mkTerm "creek_N" ;
lin creel_N = mkTerm "creel_N" ;
lin creep_N = mkTerm "creep_N" ;
lin creep_V = mkTerm "creep_V" ;
lin creep_in_V = mkTerm "creep_in_V" ;
lin creep_into_V2 = mkTerm "creep_into_V2" ;
lin creep_out_V2 = mkTerm "creep_out_V2" ;
lin creep_out_on_V2 = mkTerm "creep_out_on_V2" ;
lin creep_over_V2 = mkTerm "creep_over_V2" ;
lin creep_up_V = mkTerm "creep_up_V" ;
lin creep_up_on_V2 = mkTerm "creep_up_on_V2" ;
lin creeper_N = mkTerm "creeper_N" ;
lin creepiness_N = mkTerm "creepiness_N" ;
lin creeps_N = mkTerm "creeps_N" ;
lin creepy_A = mkTerm "creepy_A" ;
lin cremains_N = mkTerm "cremains_N" ;
lin cremate_V2 = mkTerm "cremate_V2" ;
lin cremation_N = mkTerm "cremation_N" ;
lin crematorium_N = mkTerm "crematorium_N" ;
lin crematory_N = mkTerm "crematory_N" ;
lin creme_de_menthe_N = mkTerm "creme_de_menthe_N" ;
lin crenate_A = mkTerm "crenate_A" ;
lin crenel_N = mkTerm "crenel_N" ;
lin crenelation_N = mkTerm "crenelation_N" ;
lin crenellated_A = mkTerm "crenellated_A" ;
lin crenulate_A = mkTerm "crenulate_A" ;
lin creole_A = mkTerm "creole_A" ;
lin creole_N = mkTerm "creole_N" ;
lin creosol_N = mkTerm "creosol_N" ;
lin creosote_N = mkTerm "creosote_N" ;
lin crepe_1_N = mkTerm "crepe_1_N" ;
lin crepe_2_N = mkTerm "crepe_2_N" ;
lin crepitate_V = mkTerm "crepitate_V" ;
lin crepitation_N = mkTerm "crepitation_N" ;
lin crepuscular_A = mkTerm "crepuscular_A" ;
lin cres_PN = mkTerm "cres_PN" ;
lin crescendo_A = mkTerm "crescendo_A" ;
lin crescendo_N = mkTerm "crescendo_N" ;
lin crescent_N = mkTerm "crescent_N" ;
lin cresol_N = mkTerm "cresol_N" ;
lin cress_N = mkTerm "cress_N" ;
lin crest_N = mkTerm "crest_N" ;
lin crest_V = mkTerm "crest_V" ;
lin crest_V2 = mkTerm "crest_V2" ;
lin crestfallen_A = mkTerm "crestfallen_A" ;
lin creswell_PN = mkTerm "creswell_PN" ;
lin cretaceous_A = mkTerm "cretaceous_A" ;
lin cretin_N = mkTerm "cretin_N" ;
lin cretinism_N = mkTerm "cretinism_N" ;
lin cretinous_A = mkTerm "cretinous_A" ;
lin cretonne_N = mkTerm "cretonne_N" ;
lin crevasse_N = mkTerm "crevasse_N" ;
lin crevice_N = mkTerm "crevice_N" ;
lin crew_N = mkTerm "crew_N" ;
lin crew_V = mkTerm "crew_V" ;
lin crew_cut_N = mkTerm "crew_cut_N" ;
lin crew_neck_N = mkTerm "crew_neck_N" ;
lin crewe_PN = mkTerm "crewe_PN" ;
lin crewelwork_N = mkTerm "crewelwork_N" ;
lin crewman_N = mkTerm "crewman_N" ;
lin crib_N = mkTerm "crib_N" ;
lin crib_V = mkTerm "crib_V" ;
lin crib_V2 = mkTerm "crib_V2" ;
lin cribbage_N = mkTerm "cribbage_N" ;
lin cribbage_board_N = mkTerm "cribbage_board_N" ;
lin crick_N = mkTerm "crick_N" ;
lin crick_V2 = mkTerm "crick_V2" ;
lin cricket_N = mkTerm "cricket_N" ;
lin cricketer_N = mkTerm "cricketer_N" ;
lin crieff_PN = mkTerm "crieff_PN" ;
lin crier_N = mkTerm "crier_N" ;
lin crime_N = mkTerm "crime_N" ;
lin crime_V2 = mkTerm "crime_V2" ;
lin criminal_A = mkTerm "criminal_A" ;
lin criminal_N = mkTerm "criminal_N" ;
lin criminalism_N = mkTerm "criminalism_N" ;
lin criminalization_N = mkTerm "criminalization_N" ;
lin criminalize_V2 = mkTerm "criminalize_V2" ;
lin criminative_A = mkTerm "criminative_A" ;
lin criminological_A = mkTerm "criminological_A" ;
lin criminologist_N = mkTerm "criminologist_N" ;
lin criminology_N = mkTerm "criminology_N" ;
lin crimp_N = mkTerm "crimp_N" ;
lin crimp_V2 = mkTerm "crimp_V2" ;
lin crimson_A = mkTerm "crimson_A" ;
lin crimson_N = mkTerm "crimson_N" ;
lin crimson_V = mkTerm "crimson_V" ;
lin crimson_V2 = mkTerm "crimson_V2" ;
lin cringe_V = mkTerm "cringe_V" ;
lin cringle_N = mkTerm "cringle_N" ;
lin crinkle_N = mkTerm "crinkle_N" ;
lin crinkle_V = mkTerm "crinkle_V" ;
lin crinkle_V2 = mkTerm "crinkle_V2" ;
lin crinkleroot_N = mkTerm "crinkleroot_N" ;
lin crinkly_A = mkTerm "crinkly_A" ;
lin crinoid_A = mkTerm "crinoid_A" ;
lin crinoid_N = mkTerm "crinoid_N" ;
lin crinoline_N = mkTerm "crinoline_N" ;
lin criollo_N = mkTerm "criollo_N" ;
lin cripple_N = mkTerm "cripple_N" ;
lin cripple_V2 = mkTerm "cripple_V2" ;
lin crippling_A = mkTerm "crippling_A" ;
lin crisis_N = mkTerm "crisis_N" ;
lin crisp_A = mkTerm "crisp_A" ;
lin crisp_N = mkTerm "crisp_N" ;
lin crisp_V = mkTerm "crisp_V" ;
lin crisp_V2 = mkTerm "crisp_V2" ;
lin crispate_A = mkTerm "crispate_A" ;
lin crispness_N = mkTerm "crispness_N" ;
lin criss_cross_V2 = mkTerm "criss_cross_V2" ;
lin crisscross_A = mkTerm "crisscross_A" ;
lin crisscross_Adv = mkTerm "crisscross_Adv" ;
lin crisscross_N = mkTerm "crisscross_N" ;
lin crisscross_V = mkTerm "crisscross_V" ;
lin cristobalite_N = mkTerm "cristobalite_N" ;
lin criterial_A = mkTerm "criterial_A" ;
lin criterion_N = mkTerm "criterion_N" ;
lin crith_N = mkTerm "crith_N" ;
lin critic_N = mkTerm "critic_N" ;
lin critical_1_A = mkTerm "critical_1_A" ;
lin critical_2_A = mkTerm "critical_2_A" ;
lin criticality_N = mkTerm "criticality_N" ;
lin criticism_N = mkTerm "criticism_N" ;
lin criticize_V = mkTerm "criticize_V" ;
lin criticize_V2 = mkTerm "criticize_V2" ;
lin critique_N = mkTerm "critique_N" ;
lin critter_N = mkTerm "critter_N" ;
lin croak_N = mkTerm "croak_N" ;
lin croak_V = mkTerm "croak_V" ;
lin croak_V2 = mkTerm "croak_V2" ;
lin croaker_N = mkTerm "croaker_N" ;
lin croaky_A = mkTerm "croaky_A" ;
lin crochet_N = mkTerm "crochet_N" ;
lin crochet_V = mkTerm "crochet_V" ;
lin crochet_V2 = mkTerm "crochet_V2" ;
lin crochet_hook_N = mkTerm "crochet_hook_N" ;
lin crocheting_N = mkTerm "crocheting_N" ;
lin crock_N = mkTerm "crock_N" ;
lin crock_V = mkTerm "crock_V" ;
lin crock_V2 = mkTerm "crock_V2" ;
lin crockery_N = mkTerm "crockery_N" ;
lin crocket_N = mkTerm "crocket_N" ;
lin crocketed_A = mkTerm "crocketed_A" ;
lin crocodile_N = mkTerm "crocodile_N" ;
lin crocolite_N = mkTerm "crocolite_N" ;
lin crocus_N = mkTerm "crocus_N" ;
lin croesus_PN = mkTerm "croesus_PN" ;
lin croft_N = mkTerm "croft_N" ;
lin crofter_N = mkTerm "crofter_N" ;
lin cromer_PN = mkTerm "cromer_PN" ;
lin cromlech_N = mkTerm "cromlech_N" ;
lin crone_N = mkTerm "crone_N" ;
lin crony_N = mkTerm "crony_N" ;
lin cronyism_N = mkTerm "cronyism_N" ;
lin crook_N = mkTerm "crook_N" ;
lin crook_PN = mkTerm "crook_PN" ;
lin crook_V = mkTerm "crook_V" ;
lin crook_V2 = mkTerm "crook_V2" ;
lin crook_back_A = mkTerm "crook_back_A" ;
lin crook_backed_A = mkTerm "crook_backed_A" ;
lin crooked_A = mkTerm "crooked_A" ;
lin crookedness_N = mkTerm "crookedness_N" ;
lin crookneck_N = mkTerm "crookneck_N" ;
lin croon_V = mkTerm "croon_V" ;
lin croon_V2 = mkTerm "croon_V2" ;
lin crooner_N = mkTerm "crooner_N" ;
lin crooning_N = mkTerm "crooning_N" ;
lin crop_N = mkTerm "crop_N" ;
lin crop_V = mkTerm "crop_V" ;
lin crop_V2 = mkTerm "crop_V2" ;
lin crop_dusting_N = mkTerm "crop_dusting_N" ;
lin crop_up_V = mkTerm "crop_up_V" ;
lin cropper_N = mkTerm "cropper_N" ;
lin croquet_N = mkTerm "croquet_N" ;
lin croquette_N = mkTerm "croquette_N" ;
lin crore_N = mkTerm "crore_N" ;
lin crosby_PN = mkTerm "crosby_PN" ;
lin crosier_N = mkTerm "crosier_N" ;
lin cross_A = mkTerm "cross_A" ;
lin cross_N = mkTerm "cross_N" ;
lin cross_V = mkTerm "cross_V" ;
lin cross_V2 = mkTerm "cross_V2" ;
lin cross_bench_N = mkTerm "cross_bench_N" ;
lin cross_bencher_N = mkTerm "cross_bencher_N" ;
lin cross_division_N = mkTerm "cross_division_N" ;
lin cross_examination_N = mkTerm "cross_examination_N" ;
lin cross_examine_V2 = mkTerm "cross_examine_V2" ;
lin cross_examiner_N = mkTerm "cross_examiner_N" ;
lin cross_fertilization_N = mkTerm "cross_fertilization_N" ;
lin cross_fertilize_V2 = mkTerm "cross_fertilize_V2" ;
lin cross_grained_A = mkTerm "cross_grained_A" ;
lin cross_heading_N = mkTerm "cross_heading_N" ;
lin cross_index_N = mkTerm "cross_index_N" ;
lin cross_index_V2 = mkTerm "cross_index_V2" ;
lin cross_legged_Adv = mkTerm "cross_legged_Adv" ;
lin cross_off_V2 = mkTerm "cross_off_V2" ;
lin cross_out_V2 = mkTerm "cross_out_V2" ;
lin cross_question_V2 = mkTerm "cross_question_V2" ;
lin cross_reference_N = mkTerm "cross_reference_N" ;
lin cross_section_N = mkTerm "cross_section_N" ;
lin cross_stitch_N = mkTerm "cross_stitch_N" ;
lin cross_up_V2 = mkTerm "cross_up_V2" ;
lin crossbar_N = mkTerm "crossbar_N" ;
lin crossbeam_N = mkTerm "crossbeam_N" ;
lin crossbill_N = mkTerm "crossbill_N" ;
lin crossbones_N = mkTerm "crossbones_N" ;
lin crossbow_N = mkTerm "crossbow_N" ;
lin crossbreed_N = mkTerm "crossbreed_N" ;
lin crossbreed_V2 = mkTerm "crossbreed_V2" ;
lin crosscheck_N = mkTerm "crosscheck_N" ;
lin crosscheck_V = mkTerm "crosscheck_V" ;
lin crosscheck_V2 = mkTerm "crosscheck_V2" ;
lin crosscountry_A = mkTerm "crosscountry_A" ;
lin crosscountry_Adv = mkTerm "crosscountry_Adv" ;
lin crosscurrent_N = mkTerm "crosscurrent_N" ;
lin crosscut_A = mkTerm "crosscut_A" ;
lin crosscut_N = mkTerm "crosscut_N" ;
lin crosse_N = mkTerm "crosse_N" ;
lin crosseyed_A = mkTerm "crosseyed_A" ;
lin crossfire_N = mkTerm "crossfire_N" ;
lin crosshairs_N = mkTerm "crosshairs_N" ;
lin crosshead_N = mkTerm "crosshead_N" ;
lin crossing_N = mkTerm "crossing_N" ;
lin crossjack_N = mkTerm "crossjack_N" ;
lin crossness_N = mkTerm "crossness_N" ;
lin crossopterygian_N = mkTerm "crossopterygian_N" ;
lin crossover_N = mkTerm "crossover_N" ;
lin crosspatch_N = mkTerm "crosspatch_N" ;
lin crosspiece_N = mkTerm "crosspiece_N" ;
lin crossroad_N = mkTerm "crossroad_N" ;
lin crossroads_N = mkTerm "crossroads_N" ;
lin crosstalk_N = mkTerm "crosstalk_N" ;
lin crosstown_A = mkTerm "crosstown_A" ;
lin crosstown_Adv = mkTerm "crosstown_Adv" ;
lin crosswalk_N = mkTerm "crosswalk_N" ;
lin crosswind_N = mkTerm "crosswind_N" ;
lin crosswise_A = mkTerm "crosswise_A" ;
lin crosswise_Adv = mkTerm "crosswise_Adv" ;
lin crossword_N = mkTerm "crossword_N" ;
lin crotalaria_N = mkTerm "crotalaria_N" ;
lin crotaphion_N = mkTerm "crotaphion_N" ;
lin crotch_N = mkTerm "crotch_N" ;
lin crotchet_N = mkTerm "crotchet_N" ;
lin crotchety_A = mkTerm "crotchety_A" ;
lin croton_N = mkTerm "croton_N" ;
lin crottle_N = mkTerm "crottle_N" ;
lin crouch_N = mkTerm "crouch_N" ;
lin crouch_V = mkTerm "crouch_V" ;
lin croup_N = mkTerm "croup_N" ;
lin croupier_N = mkTerm "croupier_N" ;
lin croupy_A = mkTerm "croupy_A" ;
lin crouton_N = mkTerm "crouton_N" ;
lin crow's_nest_N = mkTerm "crow's_nest_N" ;
lin crow_N = mkTerm "crow_N" ;
lin crow_V = mkTerm "crow_V" ;
lin crow_VS = mkTerm "crow_VS" ;
lin crowbait_N = mkTerm "crowbait_N" ;
lin crowbar_N = mkTerm "crowbar_N" ;
lin crowberry_N = mkTerm "crowberry_N" ;
lin crowborough_PN = mkTerm "crowborough_PN" ;
lin crowd_N = mkTerm "crowd_N" ;
lin crowd_V = mkTerm "crowd_V" ;
lin crowd_V2 = mkTerm "crowd_V2" ;
lin crowded_A = mkTerm "crowded_A" ;
lin crowding_N = mkTerm "crowding_N" ;
lin crown_N = mkTerm "crown_N" ;
lin crown_V2 = mkTerm "crown_V2" ;
lin crown_land_N = mkTerm "crown_land_N" ;
lin crownbeard_N = mkTerm "crownbeard_N" ;
lin crowning_A = mkTerm "crowning_A" ;
lin crowthorne_PN = mkTerm "crowthorne_PN" ;
lin croydon_PN = mkTerm "croydon_PN" ;
lin crozier_N = mkTerm "crozier_N" ;
lin crucial_A = mkTerm "crucial_A" ;
lin cruciate_A = mkTerm "cruciate_A" ;
lin crucible_N = mkTerm "crucible_N" ;
lin crucifer_N = mkTerm "crucifer_N" ;
lin cruciferous_A = mkTerm "cruciferous_A" ;
lin crucifix_N = mkTerm "crucifix_N" ;
lin crucifixion_N = mkTerm "crucifixion_N" ;
lin cruciform_A = mkTerm "cruciform_A" ;
lin crucify_V2 = mkTerm "crucify_V2" ;
lin crud_N = mkTerm "crud_N" ;
lin cruddy_A = mkTerm "cruddy_A" ;
lin crude_A = mkTerm "crude_A" ;
lin crudeness_N = mkTerm "crudeness_N" ;
lin crudites_N = mkTerm "crudites_N" ;
lin crudity_N = mkTerm "crudity_N" ;
lin cruel_A = mkTerm "cruel_A" ;
lin cruelty_N = mkTerm "cruelty_N" ;
lin cruet_N = mkTerm "cruet_N" ;
lin cruet_stand_N = mkTerm "cruet_stand_N" ;
lin cruise_N = mkTerm "cruise_N" ;
lin cruise_V = mkTerm "cruise_V" ;
lin cruise_through_V2 = mkTerm "cruise_through_V2" ;
lin cruiser_N = mkTerm "cruiser_N" ;
lin cruller_N = mkTerm "cruller_N" ;
lin crumb_N = mkTerm "crumb_N" ;
lin crumb_down_V = mkTerm "crumb_down_V" ;
lin crumble_V = mkTerm "crumble_V" ;
lin crumble_V2 = mkTerm "crumble_V2" ;
lin crumbliness_N = mkTerm "crumbliness_N" ;
lin crumbly_A = mkTerm "crumbly_A" ;
lin crumpet_N = mkTerm "crumpet_N" ;
lin crumple_V = mkTerm "crumple_V" ;
lin crumple_V2 = mkTerm "crumple_V2" ;
lin crunch_N = mkTerm "crunch_N" ;
lin crunch_V = mkTerm "crunch_V" ;
lin crunch_V2 = mkTerm "crunch_V2" ;
lin crupper_N = mkTerm "crupper_N" ;
lin crural_A = mkTerm "crural_A" ;
lin crus_N = mkTerm "crus_N" ;
lin crusade_N = mkTerm "crusade_N" ;
lin crusade_V = mkTerm "crusade_V" ;
lin crusader_N = mkTerm "crusader_N" ;
lin cruse_N = mkTerm "cruse_N" ;
lin crush_N = mkTerm "crush_N" ;
lin crush_V = mkTerm "crush_V" ;
lin crush_V2 = mkTerm "crush_V2" ;
lin crusher_N = mkTerm "crusher_N" ;
lin crushingly_Adv = mkTerm "crushingly_Adv" ;
lin crust_N = mkTerm "crust_N" ;
lin crust_V = mkTerm "crust_V" ;
lin crust_V2 = mkTerm "crust_V2" ;
lin crustacean_N = mkTerm "crustacean_N" ;
lin crustaceous_A = mkTerm "crustaceous_A" ;
lin crustal_A = mkTerm "crustal_A" ;
lin crustose_A = mkTerm "crustose_A" ;
lin crusty_A = mkTerm "crusty_A" ;
lin crutch_N = mkTerm "crutch_N" ;
lin crux_N = mkTerm "crux_N" ;
lin cruzeiro_N = mkTerm "cruzeiro_N" ;
lin cry_N = mkTerm "cry_N" ;
lin cry_V = mkTerm "cry_V" ;
lin cry_V2 = mkTerm "cry_V2" ;
lin cry_off_V2 = mkTerm "cry_off_V2" ;
lin cry_out_V = mkTerm "cry_out_V" ;
lin crybaby_N = mkTerm "crybaby_N" ;
lin cryesthesia_N = mkTerm "cryesthesia_N" ;
lin crying_N = mkTerm "crying_N" ;
lin cryoanesthesia_N = mkTerm "cryoanesthesia_N" ;
lin cryobiology_N = mkTerm "cryobiology_N" ;
lin cryocautery_N = mkTerm "cryocautery_N" ;
lin cryogen_N = mkTerm "cryogen_N" ;
lin cryogenic_A = mkTerm "cryogenic_A" ;
lin cryogenics_N = mkTerm "cryogenics_N" ;
lin cryolite_N = mkTerm "cryolite_N" ;
lin cryometer_N = mkTerm "cryometer_N" ;
lin cryonic_A = mkTerm "cryonic_A" ;
lin cryonics_N = mkTerm "cryonics_N" ;
lin cryophobia_N = mkTerm "cryophobia_N" ;
lin cryoscope_N = mkTerm "cryoscope_N" ;
lin cryostat_N = mkTerm "cryostat_N" ;
lin cryosurgery_N = mkTerm "cryosurgery_N" ;
lin crypt_N = mkTerm "crypt_N" ;
lin cryptanalysis_N = mkTerm "cryptanalysis_N" ;
lin cryptanalyst_N = mkTerm "cryptanalyst_N" ;
lin cryptanalytic_A = mkTerm "cryptanalytic_A" ;
lin cryptic_A = mkTerm "cryptic_A" ;
lin cryptobiosis_N = mkTerm "cryptobiosis_N" ;
lin cryptobiotic_A = mkTerm "cryptobiotic_A" ;
lin cryptococcosis_N = mkTerm "cryptococcosis_N" ;
lin cryptocoryne_N = mkTerm "cryptocoryne_N" ;
lin cryptogam_N = mkTerm "cryptogam_N" ;
lin cryptogamic_A = mkTerm "cryptogamic_A" ;
lin cryptogram_N = mkTerm "cryptogram_N" ;
lin cryptograph_N = mkTerm "cryptograph_N" ;
lin cryptographic_A = mkTerm "cryptographic_A" ;
lin cryptography_N = mkTerm "cryptography_N" ;
lin cryptomonad_N = mkTerm "cryptomonad_N" ;
lin cryptorchidy_N = mkTerm "cryptorchidy_N" ;
lin crystal_N = mkTerm "crystal_N" ;
lin crystal_gazing_N = mkTerm "crystal_gazing_N" ;
lin crystalline_A = mkTerm "crystalline_A" ;
lin crystallite_N = mkTerm "crystallite_N" ;
lin crystallization_N = mkTerm "crystallization_N" ;
lin crystallize_V = mkTerm "crystallize_V" ;
lin crystallize_V2 = mkTerm "crystallize_V2" ;
lin crystallographer_N = mkTerm "crystallographer_N" ;
lin crystallography_N = mkTerm "crystallography_N" ;
lin ctene_N = mkTerm "ctene_N" ;
lin ctenidium_N = mkTerm "ctenidium_N" ;
lin ctenoid_A = mkTerm "ctenoid_A" ;
lin ctenophore_N = mkTerm "ctenophore_N" ;
lin cub_N = mkTerm "cub_N" ;
lin cuba_PN = mkTerm "cuba_PN" ;
lin cuban_A = mkTerm "cuban_A" ;
lin cuban_N = mkTerm "cuban_N" ;
lin cubby_N = mkTerm "cubby_N" ;
lin cubbyhole_N = mkTerm "cubbyhole_N" ;
lin cube_N = mkTerm "cube_N" ;
lin cube_V2 = mkTerm "cube_V2" ;
lin cubeb_N = mkTerm "cubeb_N" ;
lin cubelike_A = mkTerm "cubelike_A" ;
lin cubic_A = mkTerm "cubic_A" ;
lin cubical_A = mkTerm "cubical_A" ;
lin cubicity_N = mkTerm "cubicity_N" ;
lin cubicle_N = mkTerm "cubicle_N" ;
lin cubism_N = mkTerm "cubism_N" ;
lin cubist_A = mkTerm "cubist_A" ;
lin cubist_N = mkTerm "cubist_N" ;
lin cubit_N = mkTerm "cubit_N" ;
lin cubital_A = mkTerm "cubital_A" ;
lin cubitiere_N = mkTerm "cubitiere_N" ;
lin cubitus_N = mkTerm "cubitus_N" ;
lin cuboid_N = mkTerm "cuboid_N" ;
lin cuckold_N = mkTerm "cuckold_N" ;
lin cuckold_V2 = mkTerm "cuckold_V2" ;
lin cuckoldom_N = mkTerm "cuckoldom_N" ;
lin cuckoldry_N = mkTerm "cuckoldry_N" ;
lin cuckoo_N = mkTerm "cuckoo_N" ;
lin cuckoo_clock_N = mkTerm "cuckoo_clock_N" ;
lin cuckoopint_N = mkTerm "cuckoopint_N" ;
lin cucumber_N = mkTerm "cucumber_N" ;
lin cucurbit_N = mkTerm "cucurbit_N" ;
lin cucurbitaceous_A = mkTerm "cucurbitaceous_A" ;
lin cud_N = mkTerm "cud_N" ;
lin cuddle_N = mkTerm "cuddle_N" ;
lin cuddle_V = mkTerm "cuddle_V" ;
lin cuddle_V2 = mkTerm "cuddle_V2" ;
lin cuddlesome_A = mkTerm "cuddlesome_A" ;
lin cuddly_A = mkTerm "cuddly_A" ;
lin cuddy_N = mkTerm "cuddy_N" ;
lin cudgel_N = mkTerm "cudgel_N" ;
lin cudgel_V2 = mkTerm "cudgel_V2" ;
lin cudweed_N = mkTerm "cudweed_N" ;
lin cudworth_PN = mkTerm "cudworth_PN" ;
lin cue_N = mkTerm "cue_N" ;
lin cuff_N = mkTerm "cuff_N" ;
lin cuff_V2 = mkTerm "cuff_V2" ;
lin cuffley_PN = mkTerm "cuffley_PN" ;
lin cufflink_N = mkTerm "cufflink_N" ;
lin cuirass_N = mkTerm "cuirass_N" ;
lin cuirassier_N = mkTerm "cuirassier_N" ;
lin cuisine_N = mkTerm "cuisine_N" ;
lin cuisse_N = mkTerm "cuisse_N" ;
lin cul_N = mkTerm "cul_N" ;
lin cul_de_sac_N = mkTerm "cul_de_sac_N" ;
lin culcheth_PN = mkTerm "culcheth_PN" ;
lin culdoscope_N = mkTerm "culdoscope_N" ;
lin culdoscopy_N = mkTerm "culdoscopy_N" ;
lin culinary_A = mkTerm "culinary_A" ;
lin cull_N = mkTerm "cull_N" ;
lin cull_V2 = mkTerm "cull_V2" ;
lin cullender_N = mkTerm "cullender_N" ;
lin cullis_N = mkTerm "cullis_N" ;
lin culm_N = mkTerm "culm_N" ;
lin culminate_V = mkTerm "culminate_V" ;
lin culminate_V2 = mkTerm "culminate_V2" ;
lin culmination_N = mkTerm "culmination_N" ;
lin culotte_N = mkTerm "culotte_N" ;
lin culpability_N = mkTerm "culpability_N" ;
lin culpable_A = mkTerm "culpable_A" ;
lin culprit_N = mkTerm "culprit_N" ;
lin cult_N = mkTerm "cult_N" ;
lin cultism_N = mkTerm "cultism_N" ;
lin cultist_N = mkTerm "cultist_N" ;
lin cultivable_A = mkTerm "cultivable_A" ;
lin cultivar_N = mkTerm "cultivar_N" ;
lin cultivate_V2 = mkTerm "cultivate_V2" ;
lin cultivation_N = mkTerm "cultivation_N" ;
lin cultivator_N = mkTerm "cultivator_N" ;
lin cultural_A = mkTerm "cultural_A" ;
lin culturati_N = mkTerm "culturati_N" ;
lin culture_N = mkTerm "culture_N" ;
lin cultured_A = mkTerm "cultured_A" ;
lin culverin_N = mkTerm "culverin_N" ;
lin culvert_N = mkTerm "culvert_N" ;
lin cum_N = mkTerm "cum_N" ;
lin cum_Prep = mkTerm "cum_Prep" ;
lin cumber_V2 = mkTerm "cumber_V2" ;
lin cumberland_PN = mkTerm "cumberland_PN" ;
lin cumbernauld_PN = mkTerm "cumbernauld_PN" ;
lin cumbersome_A = mkTerm "cumbersome_A" ;
lin cumbria_PN = mkTerm "cumbria_PN" ;
lin cumbrous_A = mkTerm "cumbrous_A" ;
lin cumin_N = mkTerm "cumin_N" ;
lin cummerbund_N = mkTerm "cummerbund_N" ;
lin cummings_N = mkTerm "cummings_N" ;
lin cumnock_PN = mkTerm "cumnock_PN" ;
lin cumulative_A = mkTerm "cumulative_A" ;
lin cumuliform_A = mkTerm "cumuliform_A" ;
lin cumulonimbus_N = mkTerm "cumulonimbus_N" ;
lin cumulous_A = mkTerm "cumulous_A" ;
lin cumulus_N = mkTerm "cumulus_N" ;
lin cuneate_A = mkTerm "cuneate_A" ;
lin cuneiform_A = mkTerm "cuneiform_A" ;
lin cuneiform_N = mkTerm "cuneiform_N" ;
lin cunner_N = mkTerm "cunner_N" ;
lin cunnilingus_N = mkTerm "cunnilingus_N" ;
lin cunning_A = mkTerm "cunning_A" ;
lin cunning_N = mkTerm "cunning_N" ;
lin cunt_N = mkTerm "cunt_N" ;
lin cup_N = mkTerm "cup_N" ;
lin cup_V2 = mkTerm "cup_V2" ;
lin cup_bearer_N = mkTerm "cup_bearer_N" ;
lin cup_final_N = mkTerm "cup_final_N" ;
lin cup_tie_N = mkTerm "cup_tie_N" ;
lin cupar_PN = mkTerm "cupar_PN" ;
lin cupboard_N = mkTerm "cupboard_N" ;
lin cupboard_love_N = mkTerm "cupboard_love_N" ;
lin cupcake_N = mkTerm "cupcake_N" ;
lin cupflower_N = mkTerm "cupflower_N" ;
lin cupful_N = mkTerm "cupful_N" ;
lin cupid_N = mkTerm "cupid_N" ;
lin cupid_PN = mkTerm "cupid_PN" ;
lin cupidity_N = mkTerm "cupidity_N" ;
lin cuplike_A = mkTerm "cuplike_A" ;
lin cupola_N = mkTerm "cupola_N" ;
lin cuppa_N = mkTerm "cuppa_N" ;
lin cupping_N = mkTerm "cupping_N" ;
lin cupric_A = mkTerm "cupric_A" ;
lin cuprite_N = mkTerm "cuprite_N" ;
lin cupro_nickel_N = mkTerm "cupro_nickel_N" ;
lin cupular_A = mkTerm "cupular_A" ;
lin cupule_N = mkTerm "cupule_N" ;
lin cur_N = mkTerm "cur_N" ;
lin curability_N = mkTerm "curability_N" ;
lin curable_A = mkTerm "curable_A" ;
lin curacao_N = mkTerm "curacao_N" ;
lin curacoa_N = mkTerm "curacoa_N" ;
lin curacy_N = mkTerm "curacy_N" ;
lin curandera_N = mkTerm "curandera_N" ;
lin curandero_N = mkTerm "curandero_N" ;
lin curassow_N = mkTerm "curassow_N" ;
lin curate_N = mkTerm "curate_N" ;
lin curative_A = mkTerm "curative_A" ;
lin curator_N = mkTerm "curator_N" ;
lin curatorial_A = mkTerm "curatorial_A" ;
lin curatorship_N = mkTerm "curatorship_N" ;
lin curb_N = mkTerm "curb_N" ;
lin curb_V2 = mkTerm "curb_V2" ;
lin curbside_N = mkTerm "curbside_N" ;
lin curbstone_N = mkTerm "curbstone_N" ;
lin curd_N = mkTerm "curd_N" ;
lin curdle_V = mkTerm "curdle_V" ;
lin curdle_V2 = mkTerm "curdle_V2" ;
lin curdling_N = mkTerm "curdling_N" ;
lin cure_N = mkTerm "cure_N" ;
lin cure_V = mkTerm "cure_V" ;
lin cure_V2 = mkTerm "cure_V2" ;
lin cure_all_N = mkTerm "cure_all_N" ;
lin curettage_N = mkTerm "curettage_N" ;
lin curette_N = mkTerm "curette_N" ;
lin curfew_N = mkTerm "curfew_N" ;
lin curie_N = mkTerm "curie_N" ;
lin curio_N = mkTerm "curio_N" ;
lin curiosa_N = mkTerm "curiosa_N" ;
lin curiosity_N = mkTerm "curiosity_N" ;
lin curious_A = mkTerm "curious_A" ;
lin curiousness_N = mkTerm "curiousness_N" ;
lin curitiba_PN = mkTerm "curitiba_PN" ;
lin curium_N = mkTerm "curium_N" ;
lin curl_N = mkTerm "curl_N" ;
lin curl_V = mkTerm "curl_V" ;
lin curl_up_V = mkTerm "curl_up_V" ;
lin curler_N = mkTerm "curler_N" ;
lin curlew_N = mkTerm "curlew_N" ;
lin curliness_N = mkTerm "curliness_N" ;
lin curling_N = mkTerm "curling_N" ;
lin curly_A = mkTerm "curly_A" ;
lin curmudgeon_N = mkTerm "curmudgeon_N" ;
lin currant_N = mkTerm "currant_N" ;
lin currawong_N = mkTerm "currawong_N" ;
lin currency_N = mkTerm "currency_N" ;
lin current_1_N = mkTerm "current_1_N" ;
lin current_2_N = mkTerm "current_2_N" ;
lin current_A = mkTerm "current_A" ;
lin currentness_N = mkTerm "currentness_N" ;
lin curricular_A = mkTerm "curricular_A" ;
lin curriculum_N = mkTerm "curriculum_N" ;
lin curriculum_vitae_N = mkTerm "curriculum_vitae_N" ;
lin currie_PN = mkTerm "currie_PN" ;
lin currier_N = mkTerm "currier_N" ;
lin currish_A = mkTerm "currish_A" ;
lin curry_N = mkTerm "curry_N" ;
lin curry_V2 = mkTerm "curry_V2" ;
lin curry_powder_N = mkTerm "curry_powder_N" ;
lin currycomb_N = mkTerm "currycomb_N" ;
lin curse_N = mkTerm "curse_N" ;
lin curse_V = mkTerm "curse_V" ;
lin curse_V2 = mkTerm "curse_V2" ;
lin cursive_A = mkTerm "cursive_A" ;
lin cursor_N = mkTerm "cursor_N" ;
lin cursorial_A = mkTerm "cursorial_A" ;
lin cursory_A = mkTerm "cursory_A" ;
lin curst_A = mkTerm "curst_A" ;
lin curt_A = mkTerm "curt_A" ;
lin curtail_V2 = mkTerm "curtail_V2" ;
lin curtailment_N = mkTerm "curtailment_N" ;
lin curtain_N = mkTerm "curtain_N" ;
lin curtain_V2 = mkTerm "curtain_V2" ;
lin curtain_call_N = mkTerm "curtain_call_N" ;
lin curtain_lecture_N = mkTerm "curtain_lecture_N" ;
lin curtain_raiser_N = mkTerm "curtain_raiser_N" ;
lin curtainless_A = mkTerm "curtainless_A" ;
lin curtal_A = mkTerm "curtal_A" ;
lin curtness_N = mkTerm "curtness_N" ;
lin curtsey_N = mkTerm "curtsey_N" ;
lin curtsey_V = mkTerm "curtsey_V" ;
lin curtsy_N = mkTerm "curtsy_N" ;
lin curtsy_V = mkTerm "curtsy_V" ;
lin curvaceously_Adv = mkTerm "curvaceously_Adv" ;
lin curvaceousness_N = mkTerm "curvaceousness_N" ;
lin curvature_N = mkTerm "curvature_N" ;
lin curve_N = mkTerm "curve_N" ;
lin curve_V = mkTerm "curve_V" ;
lin curve_V2 = mkTerm "curve_V2" ;
lin curvet_N = mkTerm "curvet_N" ;
lin curvilineal_A = mkTerm "curvilineal_A" ;
lin curvy_A = mkTerm "curvy_A" ;
lin cuscus_N = mkTerm "cuscus_N" ;
lin cushaw_N = mkTerm "cushaw_N" ;
lin cushion_N = mkTerm "cushion_N" ;
lin cushion_V2 = mkTerm "cushion_V2" ;
lin cushy_A = mkTerm "cushy_A" ;
lin cusk_N = mkTerm "cusk_N" ;
lin cusp_N = mkTerm "cusp_N" ;
lin cuspate_A = mkTerm "cuspate_A" ;
lin cuspidation_N = mkTerm "cuspidation_N" ;
lin cuspidor_N = mkTerm "cuspidor_N" ;
lin cuss_N = mkTerm "cuss_N" ;
lin cussed_A = mkTerm "cussed_A" ;
lin cussedness_N = mkTerm "cussedness_N" ;
lin custard_N = mkTerm "custard_N" ;
lin custodial_A = mkTerm "custodial_A" ;
lin custodian_N = mkTerm "custodian_N" ;
lin custodianship_N = mkTerm "custodianship_N" ;
lin custody_N = mkTerm "custody_N" ;
lin custom_N = mkTerm "custom_N" ;
lin custom_built_A = mkTerm "custom_built_A" ;
lin custom_made_A = mkTerm "custom_made_A" ;
lin customary_A = mkTerm "customary_A" ;
lin customerFem_N = mkTerm "customerFem_N" ;
lin customerMasc_N = mkTerm "customerMasc_N" ;
lin customhouse_N = mkTerm "customhouse_N" ;
lin customize_V2 = mkTerm "customize_V2" ;
lin customs_N = mkTerm "customs_N" ;
lin cut_N = mkTerm "cut_N" ;
lin cut_V = mkTerm "cut_V" ;
lin cut_V2 = mkTerm "cut_V2" ;
lin cut_across_V2 = mkTerm "cut_across_V2" ;
lin cut_back_V2 = mkTerm "cut_back_V2" ;
lin cut_back_on_V2 = mkTerm "cut_back_on_V2" ;
lin cut_down_V = mkTerm "cut_down_V" ;
lin cut_down_V2 = mkTerm "cut_down_V2" ;
lin cut_down_on_V2 = mkTerm "cut_down_on_V2" ;
lin cut_in_V = mkTerm "cut_in_V" ;
lin cut_in_V2 = mkTerm "cut_in_V2" ;
lin cut_in_on_V2 = mkTerm "cut_in_on_V2" ;
lin cut_it_out_V2 = mkTerm "cut_it_out_V2" ;
lin cut_off_V = mkTerm "cut_off_V" ;
lin cut_off_V2 = mkTerm "cut_off_V2" ;
lin cut_out_N = mkTerm "cut_out_N" ;
lin cut_out_V = mkTerm "cut_out_V" ;
lin cut_out_V2 = mkTerm "cut_out_V2" ;
lin cut_out_on_V2 = mkTerm "cut_out_on_V2" ;
lin cut_price_A = mkTerm "cut_price_A" ;
lin cut_rate_A = mkTerm "cut_rate_A" ;
lin cut_throat_A = mkTerm "cut_throat_A" ;
lin cut_throat_N = mkTerm "cut_throat_N" ;
lin cut_up_V = mkTerm "cut_up_V" ;
lin cut_up_V2 = mkTerm "cut_up_V2" ;
lin cutaneous_A = mkTerm "cutaneous_A" ;
lin cutaway_N = mkTerm "cutaway_N" ;
lin cutback_N = mkTerm "cutback_N" ;
lin cutch_N = mkTerm "cutch_N" ;
lin cute_A = mkTerm "cute_A" ;
lin cuteness_N = mkTerm "cuteness_N" ;
lin cuticle_N = mkTerm "cuticle_N" ;
lin cuticula_N = mkTerm "cuticula_N" ;
lin cuticular_A = mkTerm "cuticular_A" ;
lin cutin_N = mkTerm "cutin_N" ;
lin cutlas_N = mkTerm "cutlas_N" ;
lin cutlass_N = mkTerm "cutlass_N" ;
lin cutlassfish_N = mkTerm "cutlassfish_N" ;
lin cutler_N = mkTerm "cutler_N" ;
lin cutlery_N = mkTerm "cutlery_N" ;
lin cutlet_N = mkTerm "cutlet_N" ;
lin cutoff_N = mkTerm "cutoff_N" ;
lin cutpurse_N = mkTerm "cutpurse_N" ;
lin cutter_N = mkTerm "cutter_N" ;
lin cutting_N = mkTerm "cutting_N" ;
lin cutting_room_N = mkTerm "cutting_room_N" ;
lin cuttingly_Adv = mkTerm "cuttingly_Adv" ;
lin cuttlefish_N = mkTerm "cuttlefish_N" ;
lin cutwork_N = mkTerm "cutwork_N" ;
lin cutworm_N = mkTerm "cutworm_N" ;
lin cwmbran_PN = mkTerm "cwmbran_PN" ;
lin cwt_N = mkTerm "cwt_N" ;
lin cyan_N = mkTerm "cyan_N" ;
lin cyanamide_N = mkTerm "cyanamide_N" ;
lin cyanide_N = mkTerm "cyanide_N" ;
lin cyanobacteria_N = mkTerm "cyanobacteria_N" ;
lin cyanobacterial_A = mkTerm "cyanobacterial_A" ;
lin cyanogen_N = mkTerm "cyanogen_N" ;
lin cyanogenetic_A = mkTerm "cyanogenetic_A" ;
lin cyanohydrin_N = mkTerm "cyanohydrin_N" ;
lin cyanosis_N = mkTerm "cyanosis_N" ;
lin cyberart_N = mkTerm "cyberart_N" ;
lin cybercafe_N = mkTerm "cybercafe_N" ;
lin cybercrime_N = mkTerm "cybercrime_N" ;
lin cyberculture_N = mkTerm "cyberculture_N" ;
lin cybernaut_N = mkTerm "cybernaut_N" ;
lin cybernetic_A = mkTerm "cybernetic_A" ;
lin cybernetics_N = mkTerm "cybernetics_N" ;
lin cyberphobia_N = mkTerm "cyberphobia_N" ;
lin cyberpunk_N = mkTerm "cyberpunk_N" ;
lin cybersex_N = mkTerm "cybersex_N" ;
lin cyborg_N = mkTerm "cyborg_N" ;
lin cycad_N = mkTerm "cycad_N" ;
lin cyclamen_N = mkTerm "cyclamen_N" ;
lin cycle_N = mkTerm "cycle_N" ;
lin cycle_V = mkTerm "cycle_V" ;
lin cyclic_A = mkTerm "cyclic_A" ;
lin cyclical_A = mkTerm "cyclical_A" ;
lin cyclicity_N = mkTerm "cyclicity_N" ;
lin cycling_N = mkTerm "cycling_N" ;
lin cyclist_N = mkTerm "cyclist_N" ;
lin cyclobenzaprine_N = mkTerm "cyclobenzaprine_N" ;
lin cyclohexanol_N = mkTerm "cyclohexanol_N" ;
lin cycloid_A = mkTerm "cycloid_A" ;
lin cycloid_N = mkTerm "cycloid_N" ;
lin cyclone_N = mkTerm "cyclone_N" ;
lin cyclonic_A = mkTerm "cyclonic_A" ;
lin cyclooxygenase_N = mkTerm "cyclooxygenase_N" ;
lin cyclopaedia_N = mkTerm "cyclopaedia_N" ;
lin cyclopean_A = mkTerm "cyclopean_A" ;
lin cyclopia_N = mkTerm "cyclopia_N" ;
lin cyclopropane_N = mkTerm "cyclopropane_N" ;
lin cyclops_N = mkTerm "cyclops_N" ;
lin cycloserine_N = mkTerm "cycloserine_N" ;
lin cyclosis_N = mkTerm "cyclosis_N" ;
lin cyclostome_N = mkTerm "cyclostome_N" ;
lin cyclostyle_N = mkTerm "cyclostyle_N" ;
lin cyclostyle_V2 = mkTerm "cyclostyle_V2" ;
lin cyclothymia_N = mkTerm "cyclothymia_N" ;
lin cyclothymic_A = mkTerm "cyclothymic_A" ;
lin cyclotron_N = mkTerm "cyclotron_N" ;
lin cyder_N = mkTerm "cyder_N" ;
lin cygnet_N = mkTerm "cygnet_N" ;
lin cylinder_N = mkTerm "cylinder_N" ;
lin cylindrical_A = mkTerm "cylindrical_A" ;
lin cylindricality_N = mkTerm "cylindricality_N" ;
lin cyma_N = mkTerm "cyma_N" ;
lin cymbal_N = mkTerm "cymbal_N" ;
lin cymbalist_N = mkTerm "cymbalist_N" ;
lin cymbid_N = mkTerm "cymbid_N" ;
lin cyme_N = mkTerm "cyme_N" ;
lin cymene_N = mkTerm "cymene_N" ;
lin cymling_N = mkTerm "cymling_N" ;
lin cymose_A = mkTerm "cymose_A" ;
lin cymule_N = mkTerm "cymule_N" ;
lin cynancum_N = mkTerm "cynancum_N" ;
lin cynic_N = mkTerm "cynic_N" ;
lin cynical_A = mkTerm "cynical_A" ;
lin cynicism_N = mkTerm "cynicism_N" ;
lin cynodont_N = mkTerm "cynodont_N" ;
lin cynophobia_N = mkTerm "cynophobia_N" ;
lin cynosure_N = mkTerm "cynosure_N" ;
lin cynthia_PN = mkTerm "cynthia_PN" ;
lin cypher_N = mkTerm "cypher_N" ;
lin cypher_V = mkTerm "cypher_V" ;
lin cypher_V2 = mkTerm "cypher_V2" ;
lin cypress_N = mkTerm "cypress_N" ;
lin cyprian_A = mkTerm "cyprian_A" ;
lin cyprinid_A = mkTerm "cyprinid_A" ;
lin cyprinid_N = mkTerm "cyprinid_N" ;
lin cyprinodont_N = mkTerm "cyprinodont_N" ;
lin cypriot_A = mkTerm "cypriot_A" ;
lin cypriot_N = mkTerm "cypriot_N" ;
lin cypripedia_N = mkTerm "cypripedia_N" ;
lin cyproheptadine_N = mkTerm "cyproheptadine_N" ;
lin cyprus_PN = mkTerm "cyprus_PN" ;
lin cyril_PN = mkTerm "cyril_PN" ;
lin cyrilla_N = mkTerm "cyrilla_N" ;
lin cyrillic_A = mkTerm "cyrillic_A" ;
lin cyst_N = mkTerm "cyst_N" ;
lin cysteine_N = mkTerm "cysteine_N" ;
lin cystic_A = mkTerm "cystic_A" ;
lin cystine_N = mkTerm "cystine_N" ;
lin cystitis_N = mkTerm "cystitis_N" ;
lin cystocele_N = mkTerm "cystocele_N" ;
lin cystoplegia_N = mkTerm "cystoplegia_N" ;
lin cytoarchitectural_A = mkTerm "cytoarchitectural_A" ;
lin cytoarchitecture_N = mkTerm "cytoarchitecture_N" ;
lin cytochrome_N = mkTerm "cytochrome_N" ;
lin cytogenesis_N = mkTerm "cytogenesis_N" ;
lin cytogenetic_A = mkTerm "cytogenetic_A" ;
lin cytogeneticist_N = mkTerm "cytogeneticist_N" ;
lin cytogenetics_N = mkTerm "cytogenetics_N" ;
lin cytokine_N = mkTerm "cytokine_N" ;
lin cytokinesis_N = mkTerm "cytokinesis_N" ;
lin cytokinetic_A = mkTerm "cytokinetic_A" ;
lin cytological_A = mkTerm "cytological_A" ;
lin cytologist_N = mkTerm "cytologist_N" ;
lin cytology_N = mkTerm "cytology_N" ;
lin cytolysin_N = mkTerm "cytolysin_N" ;
lin cytolysis_N = mkTerm "cytolysis_N" ;
lin cytolytic_A = mkTerm "cytolytic_A" ;
lin cytomegalic_A = mkTerm "cytomegalic_A" ;
lin cytomegalovirus_N = mkTerm "cytomegalovirus_N" ;
lin cytopathogenic_A = mkTerm "cytopathogenic_A" ;
lin cytopenia_N = mkTerm "cytopenia_N" ;
lin cytophotometer_N = mkTerm "cytophotometer_N" ;
lin cytophotometric_A = mkTerm "cytophotometric_A" ;
lin cytophotometry_N = mkTerm "cytophotometry_N" ;
lin cytoplasm_N = mkTerm "cytoplasm_N" ;
lin cytoplasmic_A = mkTerm "cytoplasmic_A" ;
lin cytoplast_N = mkTerm "cytoplast_N" ;
lin cytoplastic_A = mkTerm "cytoplastic_A" ;
lin cytosine_N = mkTerm "cytosine_N" ;
lin cytoskeleton_N = mkTerm "cytoskeleton_N" ;
lin cytosol_N = mkTerm "cytosol_N" ;
lin cytostome_N = mkTerm "cytostome_N" ;
lin cytotoxic_A = mkTerm "cytotoxic_A" ;
lin cytotoxicity_N = mkTerm "cytotoxicity_N" ;
lin cytotoxin_N = mkTerm "cytotoxin_N" ;
lin czar_N = mkTerm "czar_N" ;
lin czarina_N = mkTerm "czarina_N" ;
lin czarist_A = mkTerm "czarist_A" ;
lin czech_A = mkTerm "czech_A" ;
lin czech_N = mkTerm "czech_N" ;
lin czechoslovak_A = mkTerm "czechoslovak_A" ;
lin czechoslovak_N = mkTerm "czechoslovak_N" ;
lin czechoslovakia_PN = mkTerm "czechoslovakia_PN" ;
lin czechoslovakian_A = mkTerm "czechoslovakian_A" ;
lin czechoslovakian_N = mkTerm "czechoslovakian_N" ;
lin d_day_PN = mkTerm "d_day_PN" ;
lin d_o_a__A = mkTerm "d_o_a__A" ;
lin dab_N = mkTerm "dab_N" ;
lin dab_V = mkTerm "dab_V" ;
lin dab_V2 = mkTerm "dab_V2" ;
lin dabble_V = mkTerm "dabble_V" ;
lin dabble_V2 = mkTerm "dabble_V2" ;
lin dabbler_N = mkTerm "dabbler_N" ;
lin dabchick_N = mkTerm "dabchick_N" ;
lin dacca_PN = mkTerm "dacca_PN" ;
lin dace_N = mkTerm "dace_N" ;
lin dacha_N = mkTerm "dacha_N" ;
lin dachshund_N = mkTerm "dachshund_N" ;
lin dacite_N = mkTerm "dacite_N" ;
lin dacitic_A = mkTerm "dacitic_A" ;
lin dacoit_N = mkTerm "dacoit_N" ;
lin dacoity_N = mkTerm "dacoity_N" ;
lin dacryocystitis_N = mkTerm "dacryocystitis_N" ;
lin dacryon_N = mkTerm "dacryon_N" ;
lin dactyl_N = mkTerm "dactyl_N" ;
lin dactylic_A = mkTerm "dactylic_A" ;
lin dactylomegaly_N = mkTerm "dactylomegaly_N" ;
lin dad_N = mkTerm "dad_N" ;
lin dada_N = mkTerm "dada_N" ;
lin daddy_N = mkTerm "daddy_N" ;
lin daddy_longlegs_N = mkTerm "daddy_longlegs_N" ;
lin dado_N = mkTerm "dado_N" ;
lin daedal_A = mkTerm "daedal_A" ;
lin daemon_N = mkTerm "daemon_N" ;
lin daffodil_N = mkTerm "daffodil_N" ;
lin daft_A = mkTerm "daft_A" ;
lin dagame_N = mkTerm "dagame_N" ;
lin dagga_N = mkTerm "dagga_N" ;
lin dagger_N = mkTerm "dagger_N" ;
lin daggerboard_N = mkTerm "daggerboard_N" ;
lin dago_N = mkTerm "dago_N" ;
lin daguerreotype_N = mkTerm "daguerreotype_N" ;
lin dahlia_N = mkTerm "dahlia_N" ;
lin dail_eireann_N = mkTerm "dail_eireann_N" ;
lin daily_A = mkTerm "daily_A" ;
lin daily_Adv = mkTerm "daily_Adv" ;
lin daily_N = mkTerm "daily_N" ;
lin daintiness_N = mkTerm "daintiness_N" ;
lin dainty_A = mkTerm "dainty_A" ;
lin dainty_N = mkTerm "dainty_N" ;
lin daiquiri_N = mkTerm "daiquiri_N" ;
lin dairy_N = mkTerm "dairy_N" ;
lin dairy_farm_N = mkTerm "dairy_farm_N" ;
lin dairy_farming_N = mkTerm "dairy_farming_N" ;
lin dairying_N = mkTerm "dairying_N" ;
lin dairymaid_N = mkTerm "dairymaid_N" ;
lin dairyman_N = mkTerm "dairyman_N" ;
lin dais_N = mkTerm "dais_N" ;
lin daisy_N = mkTerm "daisy_N" ;
lin daisy_PN = mkTerm "daisy_PN" ;
lin daisybush_N = mkTerm "daisybush_N" ;
lin daisylike_A = mkTerm "daisylike_A" ;
lin dakar_PN = mkTerm "dakar_PN" ;
lin dakota_PN = mkTerm "dakota_PN" ;
lin dalasi_N = mkTerm "dalasi_N" ;
lin dale_N = mkTerm "dale_N" ;
lin dalesman_N = mkTerm "dalesman_N" ;
lin daleth_N = mkTerm "daleth_N" ;
lin dalkeith_PN = mkTerm "dalkeith_PN" ;
lin dallas_PN = mkTerm "dallas_PN" ;
lin dalliance_N = mkTerm "dalliance_N" ;
lin dallier_N = mkTerm "dallier_N" ;
lin dallisgrass_N = mkTerm "dallisgrass_N" ;
lin dally_V = mkTerm "dally_V" ;
lin dalmatian_N = mkTerm "dalmatian_N" ;
lin dalry_PN = mkTerm "dalry_PN" ;
lin dalton_PN = mkTerm "dalton_PN" ;
lin dam_N = mkTerm "dam_N" ;
lin dam_V2 = mkTerm "dam_V2" ;
lin damage_N = mkTerm "damage_N" ;
lin damage_V2 = mkTerm "damage_V2" ;
lin damages_N = mkTerm "damages_N" ;
lin damaging_A = mkTerm "damaging_A" ;
lin damascene_A = mkTerm "damascene_A" ;
lin damascene_N = mkTerm "damascene_N" ;
lin damascene_V2 = mkTerm "damascene_V2" ;
lin damascus_PN = mkTerm "damascus_PN" ;
lin damask_A = mkTerm "damask_A" ;
lin damask_N = mkTerm "damask_N" ;
lin dame_N = mkTerm "dame_N" ;
lin dammar_N = mkTerm "dammar_N" ;
lin dammit_Interj = mkTerm "dammit_Interj" ;
lin damn_A = mkTerm "damn_A" ;
lin damn_Interj = mkTerm "damn_Interj" ;
lin damn_N = mkTerm "damn_N" ;
lin damn_V2 = mkTerm "damn_V2" ;
lin damnable_A = mkTerm "damnable_A" ;
lin damnation_N = mkTerm "damnation_N" ;
lin damnatory_A = mkTerm "damnatory_A" ;
lin damned_Adv = mkTerm "damned_Adv" ;
lin damned_N = mkTerm "damned_N" ;
lin damocles_PN = mkTerm "damocles_PN" ;
lin damourite_N = mkTerm "damourite_N" ;
lin damp_A = mkTerm "damp_A" ;
lin damp_N = mkTerm "damp_N" ;
lin damp_V = mkTerm "damp_V" ;
lin damp_V2 = mkTerm "damp_V2" ;
lin damp_down_V2 = mkTerm "damp_down_V2" ;
lin damp_off_V = mkTerm "damp_off_V" ;
lin dampen_V = mkTerm "dampen_V" ;
lin dampen_V2 = mkTerm "dampen_V2" ;
lin dampener_N = mkTerm "dampener_N" ;
lin damper_N = mkTerm "damper_N" ;
lin dampish_A = mkTerm "dampish_A" ;
lin dampness_N = mkTerm "dampness_N" ;
lin damsel_N = mkTerm "damsel_N" ;
lin damselfish_N = mkTerm "damselfish_N" ;
lin damselfly_N = mkTerm "damselfly_N" ;
lin damson_N = mkTerm "damson_N" ;
lin dan_PN = mkTerm "dan_PN" ;
lin danaid_N = mkTerm "danaid_N" ;
lin dance_N = mkTerm "dance_N" ;
lin dance_V = mkTerm "dance_V" ;
lin dance_V2 = mkTerm "dance_V2" ;
lin dance_band_N = mkTerm "dance_band_N" ;
lin dance_hall_N = mkTerm "dance_hall_N" ;
lin dance_orchestra_N = mkTerm "dance_orchestra_N" ;
lin danceable_A = mkTerm "danceable_A" ;
lin dancer_N = mkTerm "dancer_N" ;
lin dancing_N = mkTerm "dancing_N" ;
lin dandelion_N = mkTerm "dandelion_N" ;
lin dander_N = mkTerm "dander_N" ;
lin dandified_A = mkTerm "dandified_A" ;
lin dandle_V2 = mkTerm "dandle_V2" ;
lin dandruff_N = mkTerm "dandruff_N" ;
lin dandy_A = mkTerm "dandy_A" ;
lin dandy_N = mkTerm "dandy_N" ;
lin dane_N = mkTerm "dane_N" ;
lin danger_N = mkTerm "danger_N" ;
lin dangerous_A = mkTerm "dangerous_A" ;
lin dangerousness_N = mkTerm "dangerousness_N" ;
lin dangle_V = mkTerm "dangle_V" ;
lin dangle_V2 = mkTerm "dangle_V2" ;
lin dangleberry_N = mkTerm "dangleberry_N" ;
lin daniel_N = mkTerm "daniel_N" ;
lin daniel_PN = mkTerm "daniel_PN" ;
lin danishFem_N = mkTerm "danishFem_N" ;
lin danishMasc_N = mkTerm "danishMasc_N" ;
lin danish_A = mkTerm "danish_A" ;
lin dank_A = mkTerm "dank_A" ;
lin dankness_N = mkTerm "dankness_N" ;
lin danny_PN = mkTerm "danny_PN" ;
lin danse_macabre_N = mkTerm "danse_macabre_N" ;
lin danseur_N = mkTerm "danseur_N" ;
lin daphne_N = mkTerm "daphne_N" ;
lin daphne_PN = mkTerm "daphne_PN" ;
lin daphnia_N = mkTerm "daphnia_N" ;
lin dapper_A = mkTerm "dapper_A" ;
lin dapple_V2 = mkTerm "dapple_V2" ;
lin dapple_grey_A = mkTerm "dapple_grey_A" ;
lin dapple_grey_N = mkTerm "dapple_grey_N" ;
lin dapsone_N = mkTerm "dapsone_N" ;
lin daraf_N = mkTerm "daraf_N" ;
lin darby_PN = mkTerm "darby_PN" ;
lin dare_N = mkTerm "dare_N" ;
lin dare_V2 = mkTerm "dare_V2" ;
lin dare_VV = mkTerm "dare_VV" ;
lin daredevil_A = mkTerm "daredevil_A" ;
lin daredevil_N = mkTerm "daredevil_N" ;
lin daredevilry_N = mkTerm "daredevilry_N" ;
lin darenth_PN = mkTerm "darenth_PN" ;
lin darfield_PN = mkTerm "darfield_PN" ;
lin daring_N = mkTerm "daring_N" ;
lin daringly_Adv = mkTerm "daringly_Adv" ;
lin dark_A = mkTerm "dark_A" ;
lin dark_N = mkTerm "dark_N" ;
lin darken_V = mkTerm "darken_V" ;
lin darken_V2 = mkTerm "darken_V2" ;
lin darkey_N = mkTerm "darkey_N" ;
lin darkgrey_N = mkTerm "darkgrey_N" ;
lin darkie_N = mkTerm "darkie_N" ;
lin darkish_A = mkTerm "darkish_A" ;
lin darkling_A = mkTerm "darkling_A" ;
lin darkness_N = mkTerm "darkness_N" ;
lin darkroom_N = mkTerm "darkroom_N" ;
lin darky_N = mkTerm "darky_N" ;
lin darling_N = mkTerm "darling_N" ;
lin darlington_PN = mkTerm "darlington_PN" ;
lin darmstadt_PN = mkTerm "darmstadt_PN" ;
lin darmstadtium_N = mkTerm "darmstadtium_N" ;
lin darn_N = mkTerm "darn_N" ;
lin darn_V = mkTerm "darn_V" ;
lin darn_V2 = mkTerm "darn_V2" ;
lin darnel_N = mkTerm "darnel_N" ;
lin darner_N = mkTerm "darner_N" ;
lin darning_N = mkTerm "darning_N" ;
lin darning_needle_N = mkTerm "darning_needle_N" ;
lin dart_N = mkTerm "dart_N" ;
lin dart_V = mkTerm "dart_V" ;
lin dart_V2 = mkTerm "dart_V2" ;
lin dartboard_N = mkTerm "dartboard_N" ;
lin darter_N = mkTerm "darter_N" ;
lin dartford_PN = mkTerm "dartford_PN" ;
lin dartmouth_PN = mkTerm "dartmouth_PN" ;
lin darts_N = mkTerm "darts_N" ;
lin darwen_PN = mkTerm "darwen_PN" ;
lin dash_N = mkTerm "dash_N" ;
lin dash_V = mkTerm "dash_V" ;
lin dash_down_V2 = mkTerm "dash_down_V2" ;
lin dash_off_V = mkTerm "dash_off_V" ;
lin dash_off_V2 = mkTerm "dash_off_V2" ;
lin dashboard_N = mkTerm "dashboard_N" ;
lin dashiki_N = mkTerm "dashiki_N" ;
lin dashingly_Adv = mkTerm "dashingly_Adv" ;
lin dastard_N = mkTerm "dastard_N" ;
lin dastardliness_N = mkTerm "dastardliness_N" ;
lin dastardly_A = mkTerm "dastardly_A" ;
lin dasymeter_N = mkTerm "dasymeter_N" ;
lin dasyure_N = mkTerm "dasyure_N" ;
lin data_N = mkTerm "data_N" ;
lin database_N = mkTerm "database_N" ;
lin datable_A = mkTerm "datable_A" ;
lin date_1_N = mkTerm "date_1_N" ;
lin date_3_N = mkTerm "date_3_N" ;
lin date_7_N = mkTerm "date_7_N" ;
lin date_V = mkTerm "date_V" ;
lin date_V2 = mkTerm "date_V2" ;
lin dateless_A = mkTerm "dateless_A" ;
lin dateline_N = mkTerm "dateline_N" ;
lin dating_N = mkTerm "dating_N" ;
lin dative_A = mkTerm "dative_A" ;
lin dative_N = mkTerm "dative_N" ;
lin datum_N = mkTerm "datum_N" ;
lin daub_N = mkTerm "daub_N" ;
lin daub_V = mkTerm "daub_V" ;
lin daub_V2 = mkTerm "daub_V2" ;
lin dauber_N = mkTerm "dauber_N" ;
lin daughter_N = mkTerm "daughter_N" ;
lin daughter_in_law_N = mkTerm "daughter_in_law_N" ;
lin daughterly_A = mkTerm "daughterly_A" ;
lin daunt_V2 = mkTerm "daunt_V2" ;
lin daunting_A = mkTerm "daunting_A" ;
lin dauntless_A = mkTerm "dauntless_A" ;
lin dauntlessness_N = mkTerm "dauntlessness_N" ;
lin dauphin_N = mkTerm "dauphin_N" ;
lin davallia_N = mkTerm "davallia_N" ;
lin dave_PN = mkTerm "dave_PN" ;
lin davenport_N = mkTerm "davenport_N" ;
lin daventry_PN = mkTerm "daventry_PN" ;
lin davey_PN = mkTerm "davey_PN" ;
lin david_PN = mkTerm "david_PN" ;
lin davit_N = mkTerm "davit_N" ;
lin daw_N = mkTerm "daw_N" ;
lin dawah_N = mkTerm "dawah_N" ;
lin dawdle_V = mkTerm "dawdle_V" ;
lin dawdle_V2 = mkTerm "dawdle_V2" ;
lin dawdler_N = mkTerm "dawdler_N" ;
lin dawley_PN = mkTerm "dawley_PN" ;
lin dawlish_PN = mkTerm "dawlish_PN" ;
lin dawn_N = mkTerm "dawn_N" ;
lin dawn_PN = mkTerm "dawn_PN" ;
lin dawn_V = mkTerm "dawn_V" ;
lin dawn_on_V2 = mkTerm "dawn_on_V2" ;
lin day_N = mkTerm "day_N" ;
lin day_boarder_N = mkTerm "day_boarder_N" ;
lin day_labourer_N = mkTerm "day_labourer_N" ;
lin day_return_N = mkTerm "day_return_N" ;
lin day_school_N = mkTerm "day_school_N" ;
lin daybed_N = mkTerm "daybed_N" ;
lin daybook_N = mkTerm "daybook_N" ;
lin dayboy_N = mkTerm "dayboy_N" ;
lin daybreak_N = mkTerm "daybreak_N" ;
lin daycare_N = mkTerm "daycare_N" ;
lin daydream_N = mkTerm "daydream_N" ;
lin daydream_V = mkTerm "daydream_V" ;
lin daydreamer_N = mkTerm "daydreamer_N" ;
lin daygirl_N = mkTerm "daygirl_N" ;
lin daylight_N = mkTerm "daylight_N" ;
lin daylight_saving_A = mkTerm "daylight_saving_A" ;
lin daylight_saving_N = mkTerm "daylight_saving_N" ;
lin daylong_A = mkTerm "daylong_A" ;
lin daylong_Adv = mkTerm "daylong_Adv" ;
lin days_N = mkTerm "days_N" ;
lin dayspring_N = mkTerm "dayspring_N" ;
lin daytime_A = mkTerm "daytime_A" ;
lin daytime_N = mkTerm "daytime_N" ;
lin dayton_PN = mkTerm "dayton_PN" ;
lin daze_N = mkTerm "daze_N" ;
lin daze_V2 = mkTerm "daze_V2" ;
lin dazedly_Adv = mkTerm "dazedly_Adv" ;
lin dazzle_N = mkTerm "dazzle_N" ;
lin dazzle_V2 = mkTerm "dazzle_V2" ;
lin dazzling_A = mkTerm "dazzling_A" ;
lin ddt_N = mkTerm "ddt_N" ;
lin de_emphasize_V2 = mkTerm "de_emphasize_V2" ;
lin de_escalate_V2 = mkTerm "de_escalate_V2" ;
lin de_escalation_N = mkTerm "de_escalation_N" ;
lin de_facto_A = mkTerm "de_facto_A" ;
lin de_facto_Adv = mkTerm "de_facto_Adv" ;
lin de_ice_V2 = mkTerm "de_ice_V2" ;
lin de_jure_A = mkTerm "de_jure_A" ;
lin de_jure_Adv = mkTerm "de_jure_Adv" ;
lin de_luxe_A = mkTerm "de_luxe_A" ;
lin de_rigeur_A = mkTerm "de_rigeur_A" ;
lin de_trop_A = mkTerm "de_trop_A" ;
lin deacon_N = mkTerm "deacon_N" ;
lin deaconess_N = mkTerm "deaconess_N" ;
lin deactivate_V2 = mkTerm "deactivate_V2" ;
lin deactivation_N = mkTerm "deactivation_N" ;
lin dead_A = mkTerm "dead_A" ;
lin dead_Adv = mkTerm "dead_Adv" ;
lin dead_N = mkTerm "dead_N" ;
lin deaden_V2 = mkTerm "deaden_V2" ;
lin deadeye_N = mkTerm "deadeye_N" ;
lin deadhead_N = mkTerm "deadhead_N" ;
lin deadlight_N = mkTerm "deadlight_N" ;
lin deadline_N = mkTerm "deadline_N" ;
lin deadliness_N = mkTerm "deadliness_N" ;
lin deadlock_N = mkTerm "deadlock_N" ;
lin deadlock_V = mkTerm "deadlock_V" ;
lin deadlocked_A = mkTerm "deadlocked_A" ;
lin deadly_A = mkTerm "deadly_A" ;
lin deadness_N = mkTerm "deadness_N" ;
lin deadpan_A = mkTerm "deadpan_A" ;
lin deadpan_Adv = mkTerm "deadpan_Adv" ;
lin deadwood_N = mkTerm "deadwood_N" ;
lin deaf_A = mkTerm "deaf_A" ;
lin deaf_N = mkTerm "deaf_N" ;
lin deaf_aid_N = mkTerm "deaf_aid_N" ;
lin deaf_mute_N = mkTerm "deaf_mute_N" ;
lin deafen_V2 = mkTerm "deafen_V2" ;
lin deafening_A = mkTerm "deafening_A" ;
lin deafness_N = mkTerm "deafness_N" ;
lin deal_Adv = mkTerm "deal_Adv" ;
lin deal_N = mkTerm "deal_N" ;
lin deal_PN = mkTerm "deal_PN" ;
lin deal_V = mkTerm "deal_V" ;
lin deal_V2 = mkTerm "deal_V2" ;
lin dealer_N = mkTerm "dealer_N" ;
lin dealfish_N = mkTerm "dealfish_N" ;
lin dealignment_N = mkTerm "dealignment_N" ;
lin dealing_N = mkTerm "dealing_N" ;
lin dealings_N = mkTerm "dealings_N" ;
lin deamination_N = mkTerm "deamination_N" ;
lin dean_N = mkTerm "dean_N" ;
lin dean_PN = mkTerm "dean_PN" ;
lin deanery_N = mkTerm "deanery_N" ;
lin deanship_N = mkTerm "deanship_N" ;
lin dear_A = mkTerm "dear_A" ;
lin dear_Adv = mkTerm "dear_Adv" ;
lin dear_Interj = mkTerm "dear_Interj" ;
lin dear_N = mkTerm "dear_N" ;
lin dearest_N = mkTerm "dearest_N" ;
lin dearie_N = mkTerm "dearie_N" ;
lin dearness_N = mkTerm "dearness_N" ;
lin dearth_N = mkTerm "dearth_N" ;
lin deary_N = mkTerm "deary_N" ;
lin death_N = mkTerm "death_N" ;
lin death_mask_N = mkTerm "death_mask_N" ;
lin death_rate_N = mkTerm "death_rate_N" ;
lin death_roll_N = mkTerm "death_roll_N" ;
lin death_warrant_N = mkTerm "death_warrant_N" ;
lin deathbed_N = mkTerm "deathbed_N" ;
lin deathblow_N = mkTerm "deathblow_N" ;
lin deathless_A = mkTerm "deathless_A" ;
lin deathlike_A = mkTerm "deathlike_A" ;
lin deathly_A = mkTerm "deathly_A" ;
lin deathly_Adv = mkTerm "deathly_Adv" ;
lin deathtrap_N = mkTerm "deathtrap_N" ;
lin deb_N = mkTerm "deb_N" ;
lin debacle_N = mkTerm "debacle_N" ;
lin debag_V2 = mkTerm "debag_V2" ;
lin debar_V2 = mkTerm "debar_V2" ;
lin debark_V = mkTerm "debark_V" ;
lin debark_V2 = mkTerm "debark_V2" ;
lin debarkation_N = mkTerm "debarkation_N" ;
lin debarment_N = mkTerm "debarment_N" ;
lin debase_V2 = mkTerm "debase_V2" ;
lin debasement_N = mkTerm "debasement_N" ;
lin debaser_N = mkTerm "debaser_N" ;
lin debasing_A = mkTerm "debasing_A" ;
lin debatable_A = mkTerm "debatable_A" ;
lin debate_N = mkTerm "debate_N" ;
lin debate_V = mkTerm "debate_V" ;
lin debate_V2 = mkTerm "debate_V2" ;
lin debater_N = mkTerm "debater_N" ;
lin debauch_N = mkTerm "debauch_N" ;
lin debauch_V2 = mkTerm "debauch_V2" ;
lin debaucheeFem_N = mkTerm "debaucheeFem_N" ;
lin debaucheeMasc_N = mkTerm "debaucheeMasc_N" ;
lin debauchery_N = mkTerm "debauchery_N" ;
lin debbie_PN = mkTerm "debbie_PN" ;
lin debby_PN = mkTerm "debby_PN" ;
lin debenture_N = mkTerm "debenture_N" ;
lin debilitate_V2 = mkTerm "debilitate_V2" ;
lin debilitating_A = mkTerm "debilitating_A" ;
lin debilitation_N = mkTerm "debilitation_N" ;
lin debilitative_A = mkTerm "debilitative_A" ;
lin debility_N = mkTerm "debility_N" ;
lin debit_N = mkTerm "debit_N" ;
lin debit_V2 = mkTerm "debit_V2" ;
lin debit_side_N = mkTerm "debit_side_N" ;
lin debonair_A = mkTerm "debonair_A" ;
lin deborah_PN = mkTerm "deborah_PN" ;
lin debouch_V = mkTerm "debouch_V" ;
lin debouch_V2 = mkTerm "debouch_V2" ;
lin debridement_N = mkTerm "debridement_N" ;
lin debrief_V2 = mkTerm "debrief_V2" ;
lin debriefing_N = mkTerm "debriefing_N" ;
lin debris_N = mkTerm "debris_N" ;
lin debt_N = mkTerm "debt_N" ;
lin debtor_N = mkTerm "debtor_N" ;
lin debug_V2 = mkTerm "debug_V2" ;
lin debugger_N = mkTerm "debugger_N" ;
lin debunk_V2 = mkTerm "debunk_V2" ;
lin debut_1_N = mkTerm "debut_1_N" ;
lin debut_2_N = mkTerm "debut_2_N" ;
lin debut_V2 = mkTerm "debut_V2" ;
lin debutante_N = mkTerm "debutante_N" ;
lin dec_PN = mkTerm "dec_PN" ;
lin decade_N = mkTerm "decade_N" ;
lin decadence_N = mkTerm "decadence_N" ;
lin decadent_A = mkTerm "decadent_A" ;
lin decadent_N = mkTerm "decadent_N" ;
lin decagon_N = mkTerm "decagon_N" ;
lin decahedron_N = mkTerm "decahedron_N" ;
lin decal_N = mkTerm "decal_N" ;
lin decalcification_N = mkTerm "decalcification_N" ;
lin decalcomania_N = mkTerm "decalcomania_N" ;
lin decalescence_N = mkTerm "decalescence_N" ;
lin decalescent_A = mkTerm "decalescent_A" ;
lin decalogue_N = mkTerm "decalogue_N" ;
lin decameter_N = mkTerm "decameter_N" ;
lin decamp_V = mkTerm "decamp_V" ;
lin decampment_N = mkTerm "decampment_N" ;
lin decant_V2 = mkTerm "decant_V2" ;
lin decantation_N = mkTerm "decantation_N" ;
lin decanter_N = mkTerm "decanter_N" ;
lin decapitate_V2 = mkTerm "decapitate_V2" ;
lin decapitation_N = mkTerm "decapitation_N" ;
lin decapod_N = mkTerm "decapod_N" ;
lin decarbonize_V2 = mkTerm "decarbonize_V2" ;
lin decarboxylase_N = mkTerm "decarboxylase_N" ;
lin decarboxylation_N = mkTerm "decarboxylation_N" ;
lin decasyllabic_A = mkTerm "decasyllabic_A" ;
lin decasyllable_N = mkTerm "decasyllable_N" ;
lin decathlon_N = mkTerm "decathlon_N" ;
lin decay_N = mkTerm "decay_N" ;
lin decay_V = mkTerm "decay_V" ;
lin decayable_A = mkTerm "decayable_A" ;
lin decayed_A = mkTerm "decayed_A" ;
lin decease_N = mkTerm "decease_N" ;
lin decease_V = mkTerm "decease_V" ;
lin deceased_A = mkTerm "deceased_A" ;
lin deceit_N = mkTerm "deceit_N" ;
lin deceitful_A = mkTerm "deceitful_A" ;
lin deceitfulness_N = mkTerm "deceitfulness_N" ;
lin deceive_V2 = mkTerm "deceive_V2" ;
lin deceiver_N = mkTerm "deceiver_N" ;
lin deceivingly_Adv = mkTerm "deceivingly_Adv" ;
lin decelerate_V = mkTerm "decelerate_V" ;
lin decelerate_V2 = mkTerm "decelerate_V2" ;
lin deceleration_N = mkTerm "deceleration_N" ;
lin decency_N = mkTerm "decency_N" ;
lin decent_A = mkTerm "decent_A" ;
lin decentralization_N = mkTerm "decentralization_N" ;
lin decentralize_V2 = mkTerm "decentralize_V2" ;
lin deception_N = mkTerm "deception_N" ;
lin deceptive_A = mkTerm "deceptive_A" ;
lin deceptiveness_N = mkTerm "deceptiveness_N" ;
lin decibel_N = mkTerm "decibel_N" ;
lin decide_V = mkTerm "decide_V" ;
lin decide_V2 = mkTerm "decide_V2" ;
lin decide_VS = mkTerm "decide_VS" ;
lin decide_VV = mkTerm "decide_VV" ;
lin decide_on_V2 = mkTerm "decide_on_V2" ;
lin decide_upon_V2 = mkTerm "decide_upon_V2" ;
lin decided_A = mkTerm "decided_A" ;
lin decidua_N = mkTerm "decidua_N" ;
lin deciduous_A = mkTerm "deciduous_A" ;
lin decigram_N = mkTerm "decigram_N" ;
lin decile_N = mkTerm "decile_N" ;
lin deciliter_N = mkTerm "deciliter_N" ;
lin decimal_A = mkTerm "decimal_A" ;
lin decimal_N = mkTerm "decimal_N" ;
lin decimalization_N = mkTerm "decimalization_N" ;
lin decimalize_V2 = mkTerm "decimalize_V2" ;
lin decimate_V2 = mkTerm "decimate_V2" ;
lin decimation_N = mkTerm "decimation_N" ;
lin decimeter_N = mkTerm "decimeter_N" ;
lin decipher_V2 = mkTerm "decipher_V2" ;
lin decipherable_A = mkTerm "decipherable_A" ;
lin decipherer_N = mkTerm "decipherer_N" ;
lin decision_N = mkTerm "decision_N" ;
lin decision_making_N = mkTerm "decision_making_N" ;
lin decisive_A = mkTerm "decisive_A" ;
lin decisiveness_N = mkTerm "decisiveness_N" ;
lin deck_N = mkTerm "deck_N" ;
lin deck_V2 = mkTerm "deck_V2" ;
lin deck_out_V = mkTerm "deck_out_V" ;
lin decker_N = mkTerm "decker_N" ;
lin deckhand_N = mkTerm "deckhand_N" ;
lin deckle_N = mkTerm "deckle_N" ;
lin deckle_edged_A = mkTerm "deckle_edged_A" ;
lin deckled_A = mkTerm "deckled_A" ;
lin declaim_V = mkTerm "declaim_V" ;
lin declaim_V2 = mkTerm "declaim_V2" ;
lin declamation_N = mkTerm "declamation_N" ;
lin declamatory_A = mkTerm "declamatory_A" ;
lin declarable_A = mkTerm "declarable_A" ;
lin declaration_N = mkTerm "declaration_N" ;
lin declarative_A = mkTerm "declarative_A" ;
lin declare_V = mkTerm "declare_V" ;
lin declare_V2 = mkTerm "declare_V2" ;
lin declare_VS = mkTerm "declare_VS" ;
lin declassification_N = mkTerm "declassification_N" ;
lin declassify_V2 = mkTerm "declassify_V2" ;
lin declension_N = mkTerm "declension_N" ;
lin declination_N = mkTerm "declination_N" ;
lin decline_N = mkTerm "decline_N" ;
lin decline_V = mkTerm "decline_V" ;
lin decline_V2 = mkTerm "decline_V2" ;
lin decline_VV = mkTerm "decline_VV" ;
lin declinometer_N = mkTerm "declinometer_N" ;
lin declivitous_A = mkTerm "declivitous_A" ;
lin declivity_N = mkTerm "declivity_N" ;
lin declutch_V = mkTerm "declutch_V" ;
lin deco_N = mkTerm "deco_N" ;
lin decoction_N = mkTerm "decoction_N" ;
lin decode_V2 = mkTerm "decode_V2" ;
lin decoder_N = mkTerm "decoder_N" ;
lin decoding_N = mkTerm "decoding_N" ;
lin decoke_V2 = mkTerm "decoke_V2" ;
lin decolletage_N = mkTerm "decolletage_N" ;
lin decollete_A = mkTerm "decollete_A" ;
lin decolonization_N = mkTerm "decolonization_N" ;
lin decolonize_V2 = mkTerm "decolonize_V2" ;
lin decompose_V = mkTerm "decompose_V" ;
lin decompose_V2 = mkTerm "decompose_V2" ;
lin decomposition_N = mkTerm "decomposition_N" ;
lin decompositional_A = mkTerm "decompositional_A" ;
lin decompound_A = mkTerm "decompound_A" ;
lin decompress_V2 = mkTerm "decompress_V2" ;
lin decompression_N = mkTerm "decompression_N" ;
lin decongestant_N = mkTerm "decongestant_N" ;
lin deconsecrated_A = mkTerm "deconsecrated_A" ;
lin deconstruction_N = mkTerm "deconstruction_N" ;
lin deconstructionist_A = mkTerm "deconstructionist_A" ;
lin deconstructivism_N = mkTerm "deconstructivism_N" ;
lin decontaminate_V2 = mkTerm "decontaminate_V2" ;
lin decontamination_N = mkTerm "decontamination_N" ;
lin decontrol_V2 = mkTerm "decontrol_V2" ;
lin decor_N = mkTerm "decor_N" ;
lin decorate_V2 = mkTerm "decorate_V2" ;
lin decoration_N = mkTerm "decoration_N" ;
lin decorative_A = mkTerm "decorative_A" ;
lin decorativeness_N = mkTerm "decorativeness_N" ;
lin decorator_N = mkTerm "decorator_N" ;
lin decorous_A = mkTerm "decorous_A" ;
lin decortication_N = mkTerm "decortication_N" ;
lin decorum_N = mkTerm "decorum_N" ;
lin decoupage_N = mkTerm "decoupage_N" ;
lin decoy_N = mkTerm "decoy_N" ;
lin decoy_V2 = mkTerm "decoy_V2" ;
lin decrease_N = mkTerm "decrease_N" ;
lin decrease_V = mkTerm "decrease_V" ;
lin decrease_V2 = mkTerm "decrease_V2" ;
lin decree_N = mkTerm "decree_N" ;
lin decree_V2 = mkTerm "decree_V2" ;
lin decree_nisi_N = mkTerm "decree_nisi_N" ;
lin decrepit_A = mkTerm "decrepit_A" ;
lin decrepitation_N = mkTerm "decrepitation_N" ;
lin decrepitude_N = mkTerm "decrepitude_N" ;
lin decrescendo_A = mkTerm "decrescendo_A" ;
lin decrescendo_N = mkTerm "decrescendo_N" ;
lin decribe_V2 = mkTerm "decribe_V2" ;
lin decriminalization_N = mkTerm "decriminalization_N" ;
lin decry_V2 = mkTerm "decry_V2" ;
lin decubitus_N = mkTerm "decubitus_N" ;
lin decumary_N = mkTerm "decumary_N" ;
lin decurved_A = mkTerm "decurved_A" ;
lin decussate_A = mkTerm "decussate_A" ;
lin dedicate_V2 = mkTerm "dedicate_V2" ;
lin dedicated_A = mkTerm "dedicated_A" ;
lin dedication_N = mkTerm "dedication_N" ;
lin dedifferentiated_A = mkTerm "dedifferentiated_A" ;
lin dedifferentiation_N = mkTerm "dedifferentiation_N" ;
lin deduce_V2 = mkTerm "deduce_V2" ;
lin deducible_A = mkTerm "deducible_A" ;
lin deduct_V2 = mkTerm "deduct_V2" ;
lin deductible_A = mkTerm "deductible_A" ;
lin deductible_N = mkTerm "deductible_N" ;
lin deduction_N = mkTerm "deduction_N" ;
lin deductive_A = mkTerm "deductive_A" ;
lin deed_N = mkTerm "deed_N" ;
lin deed_box_N = mkTerm "deed_box_N" ;
lin deedpoll_N = mkTerm "deedpoll_N" ;
lin deem_V2 = mkTerm "deem_V2" ;
lin deem_V2A = mkTerm "deem_V2A" ;
lin deem_V2V = mkTerm "deem_V2V" ;
lin deep_A = mkTerm "deep_A" ;
lin deep_Adv = mkTerm "deep_Adv" ;
lin deep_N = mkTerm "deep_N" ;
lin deep_freeze_N = mkTerm "deep_freeze_N" ;
lin deep_freeze_V2 = mkTerm "deep_freeze_V2" ;
lin deep_laid_A = mkTerm "deep_laid_A" ;
lin deep_mined_A = mkTerm "deep_mined_A" ;
lin deep_rooted_A = mkTerm "deep_rooted_A" ;
lin deep_sea_A = mkTerm "deep_sea_A" ;
lin deep_seated_A = mkTerm "deep_seated_A" ;
lin deep_water_A = mkTerm "deep_water_A" ;
lin deepen_V = mkTerm "deepen_V" ;
lin deepen_V2 = mkTerm "deepen_V2" ;
lin deepening_N = mkTerm "deepening_N" ;
lin deepness_N = mkTerm "deepness_N" ;
lin deer_N = mkTerm "deer_N" ;
lin deerberry_N = mkTerm "deerberry_N" ;
lin deerskin_N = mkTerm "deerskin_N" ;
lin deerstalker_N = mkTerm "deerstalker_N" ;
lin deerstalking_N = mkTerm "deerstalking_N" ;
lin deface_V2 = mkTerm "deface_V2" ;
lin defacement_N = mkTerm "defacement_N" ;
lin defalcation_N = mkTerm "defalcation_N" ;
lin defamation_N = mkTerm "defamation_N" ;
lin defamatory_A = mkTerm "defamatory_A" ;
lin defame_V2 = mkTerm "defame_V2" ;
lin defamer_N = mkTerm "defamer_N" ;
lin default_N = mkTerm "default_N" ;
lin default_V = mkTerm "default_V" ;
lin defaulter_N = mkTerm "defaulter_N" ;
lin defeasible_A = mkTerm "defeasible_A" ;
lin defeat_N = mkTerm "defeat_N" ;
lin defeat_V2 = mkTerm "defeat_V2" ;
lin defeated_N = mkTerm "defeated_N" ;
lin defeatism_N = mkTerm "defeatism_N" ;
lin defeatist_N = mkTerm "defeatist_N" ;
lin defecate_V = mkTerm "defecate_V" ;
lin defecation_N = mkTerm "defecation_N" ;
lin defecator_N = mkTerm "defecator_N" ;
lin defect_N = mkTerm "defect_N" ;
lin defect_V = mkTerm "defect_V" ;
lin defection_N = mkTerm "defection_N" ;
lin defective_A = mkTerm "defective_A" ;
lin defectiveness_N = mkTerm "defectiveness_N" ;
lin defector_N = mkTerm "defector_N" ;
lin defence_N = mkTerm "defence_N" ;
lin defenceless_A = mkTerm "defenceless_A" ;
lin defencelessness_N = mkTerm "defencelessness_N" ;
lin defend_V2 = mkTerm "defend_V2" ;
lin defendable_A = mkTerm "defendable_A" ;
lin defendant_N = mkTerm "defendant_N" ;
lin defenderFem_N = mkTerm "defenderFem_N" ;
lin defenderMasc_N = mkTerm "defenderMasc_N" ;
lin defenestration_N = mkTerm "defenestration_N" ;
lin defense_N = mkTerm "defense_N" ;
lin defenseless_A = mkTerm "defenseless_A" ;
lin defenseless_Adv = mkTerm "defenseless_Adv" ;
lin defenselessness_N = mkTerm "defenselessness_N" ;
lin defensibility_N = mkTerm "defensibility_N" ;
lin defensible_A = mkTerm "defensible_A" ;
lin defensive_A = mkTerm "defensive_A" ;
lin defensive_N = mkTerm "defensive_N" ;
lin defensiveness_N = mkTerm "defensiveness_N" ;
lin defer_V = mkTerm "defer_V" ;
lin defer_V2 = mkTerm "defer_V2" ;
lin deference_N = mkTerm "deference_N" ;
lin deferent_A = mkTerm "deferent_A" ;
lin deferential_A = mkTerm "deferential_A" ;
lin deferment_N = mkTerm "deferment_N" ;
lin deferral_N = mkTerm "deferral_N" ;
lin defervescence_N = mkTerm "defervescence_N" ;
lin defervescent_A = mkTerm "defervescent_A" ;
lin defiance_N = mkTerm "defiance_N" ;
lin defiant_A = mkTerm "defiant_A" ;
lin defibrillation_N = mkTerm "defibrillation_N" ;
lin defibrillator_N = mkTerm "defibrillator_N" ;
lin deficiency_N = mkTerm "deficiency_N" ;
lin deficient_A = mkTerm "deficient_A" ;
lin deficit_N = mkTerm "deficit_N" ;
lin defilade_N = mkTerm "defilade_N" ;
lin defile_N = mkTerm "defile_N" ;
lin defile_V = mkTerm "defile_V" ;
lin defile_V2 = mkTerm "defile_V2" ;
lin defilement_N = mkTerm "defilement_N" ;
lin definable_A = mkTerm "definable_A" ;
lin define_V = mkTerm "define_V" ;
lin define_V2 = mkTerm "define_V2" ;
lin definite_A = mkTerm "definite_A" ;
lin definition_N = mkTerm "definition_N" ;
lin definitive_A = mkTerm "definitive_A" ;
lin deflagration_N = mkTerm "deflagration_N" ;
lin deflate_V2 = mkTerm "deflate_V2" ;
lin deflation_N = mkTerm "deflation_N" ;
lin deflationary_A = mkTerm "deflationary_A" ;
lin deflator_N = mkTerm "deflator_N" ;
lin deflect_V = mkTerm "deflect_V" ;
lin deflect_V2 = mkTerm "deflect_V2" ;
lin deflection_N = mkTerm "deflection_N" ;
lin deflective_A = mkTerm "deflective_A" ;
lin deflector_N = mkTerm "deflector_N" ;
lin defloration_N = mkTerm "defloration_N" ;
lin deflower_V2 = mkTerm "deflower_V2" ;
lin defoliant_N = mkTerm "defoliant_N" ;
lin defoliate_A = mkTerm "defoliate_A" ;
lin defoliate_V2 = mkTerm "defoliate_V2" ;
lin defoliation_N = mkTerm "defoliation_N" ;
lin defoliator_N = mkTerm "defoliator_N" ;
lin deforest_V2 = mkTerm "deforest_V2" ;
lin deforestation_N = mkTerm "deforestation_N" ;
lin deform_V2 = mkTerm "deform_V2" ;
lin deformation_N = mkTerm "deformation_N" ;
lin deformational_A = mkTerm "deformational_A" ;
lin deformity_N = mkTerm "deformity_N" ;
lin defraud_V2 = mkTerm "defraud_V2" ;
lin defray_V2 = mkTerm "defray_V2" ;
lin defrayal_N = mkTerm "defrayal_N" ;
lin defrayment_N = mkTerm "defrayment_N" ;
lin defrock_V2 = mkTerm "defrock_V2" ;
lin defrost_V2 = mkTerm "defrost_V2" ;
lin defroster_N = mkTerm "defroster_N" ;
lin deft_A = mkTerm "deft_A" ;
lin deftness_N = mkTerm "deftness_N" ;
lin defunct_A = mkTerm "defunct_A" ;
lin defuse_V2 = mkTerm "defuse_V2" ;
lin defy_V2 = mkTerm "defy_V2" ;
lin defy_V2V = mkTerm "defy_V2V" ;
lin degage_A = mkTerm "degage_A" ;
lin degauss_V2 = mkTerm "degauss_V2" ;
lin degaussing_N = mkTerm "degaussing_N" ;
lin degeneracy_N = mkTerm "degeneracy_N" ;
lin degenerate_A = mkTerm "degenerate_A" ;
lin degenerate_N = mkTerm "degenerate_N" ;
lin degenerate_V = mkTerm "degenerate_V" ;
lin degeneration_N = mkTerm "degeneration_N" ;
lin degenerative_A = mkTerm "degenerative_A" ;
lin degradation_N = mkTerm "degradation_N" ;
lin degrade_V2 = mkTerm "degrade_V2" ;
lin degree_1_N = mkTerm "degree_1_N" ;
lin degree_2_N = mkTerm "degree_2_N" ;
lin degree_3_N = mkTerm "degree_3_N" ;
lin degressive_A = mkTerm "degressive_A" ;
lin dehiscence_N = mkTerm "dehiscence_N" ;
lin dehiscent_A = mkTerm "dehiscent_A" ;
lin dehorn_V2 = mkTerm "dehorn_V2" ;
lin dehumanization_N = mkTerm "dehumanization_N" ;
lin dehumanize_V2 = mkTerm "dehumanize_V2" ;
lin dehydrate_V2 = mkTerm "dehydrate_V2" ;
lin dehydration_N = mkTerm "dehydration_N" ;
lin deictic_A = mkTerm "deictic_A" ;
lin deictic_N = mkTerm "deictic_N" ;
lin deific_A = mkTerm "deific_A" ;
lin deification_N = mkTerm "deification_N" ;
lin deify_V2 = mkTerm "deify_V2" ;
lin deign_V = mkTerm "deign_V" ;
lin deinocheirus_N = mkTerm "deinocheirus_N" ;
lin deinonychus_N = mkTerm "deinonychus_N" ;
lin deipnosophist_N = mkTerm "deipnosophist_N" ;
lin deirdre_PN = mkTerm "deirdre_PN" ;
lin deism_N = mkTerm "deism_N" ;
lin deist_A = mkTerm "deist_A" ;
lin deist_N = mkTerm "deist_N" ;
lin deity_N = mkTerm "deity_N" ;
lin deixis_N = mkTerm "deixis_N" ;
lin deject_V2 = mkTerm "deject_V2" ;
lin dejectedly_Adv = mkTerm "dejectedly_Adv" ;
lin dejection_N = mkTerm "dejection_N" ;
lin dekagram_N = mkTerm "dekagram_N" ;
lin dekaliter_N = mkTerm "dekaliter_N" ;
lin dekko_N = mkTerm "dekko_N" ;
lin delavirdine_N = mkTerm "delavirdine_N" ;
lin delaware_PN = mkTerm "delaware_PN" ;
lin delay_N = mkTerm "delay_N" ;
lin delay_V = mkTerm "delay_V" ;
lin delay_V2 = mkTerm "delay_V2" ;
lin delayed_action_A = mkTerm "delayed_action_A" ;
lin delayed_action_N = mkTerm "delayed_action_N" ;
lin delayer_N = mkTerm "delayer_N" ;
lin delectability_N = mkTerm "delectability_N" ;
lin delectable_A = mkTerm "delectable_A" ;
lin delectation_N = mkTerm "delectation_N" ;
lin delegacy_N = mkTerm "delegacy_N" ;
lin delegate_N = mkTerm "delegate_N" ;
lin delegate_V2 = mkTerm "delegate_V2" ;
lin delegating_N = mkTerm "delegating_N" ;
lin delegation_N = mkTerm "delegation_N" ;
lin delete_V2 = mkTerm "delete_V2" ;
lin deleterious_A = mkTerm "deleterious_A" ;
lin deletion_N = mkTerm "deletion_N" ;
lin delf_N = mkTerm "delf_N" ;
lin delft_N = mkTerm "delft_N" ;
lin delhi_PN = mkTerm "delhi_PN" ;
lin deliberate_A = mkTerm "deliberate_A" ;
lin deliberate_V = mkTerm "deliberate_V" ;
lin deliberate_V2 = mkTerm "deliberate_V2" ;
lin deliberation_N = mkTerm "deliberation_N" ;
lin deliberative_A = mkTerm "deliberative_A" ;
lin delible_A = mkTerm "delible_A" ;
lin delicacy_N = mkTerm "delicacy_N" ;
lin delicate_A = mkTerm "delicate_A" ;
lin delicatessen_N = mkTerm "delicatessen_N" ;
lin delicious_A = mkTerm "delicious_A" ;
lin delight_N = mkTerm "delight_N" ;
lin delight_V = mkTerm "delight_V" ;
lin delight_V2 = mkTerm "delight_V2" ;
lin delighted_A = mkTerm "delighted_A" ;
lin delightful_A = mkTerm "delightful_A" ;
lin delimit_V2 = mkTerm "delimit_V2" ;
lin delimitate_V2 = mkTerm "delimitate_V2" ;
lin delimitation_N = mkTerm "delimitation_N" ;
lin delineate_V2 = mkTerm "delineate_V2" ;
lin delineation_N = mkTerm "delineation_N" ;
lin delineative_A = mkTerm "delineative_A" ;
lin delinquency_N = mkTerm "delinquency_N" ;
lin delinquent_A = mkTerm "delinquent_A" ;
lin delinquent_N = mkTerm "delinquent_N" ;
lin deliquescent_A = mkTerm "deliquescent_A" ;
lin delirious_A = mkTerm "delirious_A" ;
lin delirium_N = mkTerm "delirium_N" ;
lin delirium_tremens_N = mkTerm "delirium_tremens_N" ;
lin deliver_V = mkTerm "deliver_V" ;
lin deliver_V2 = mkTerm "deliver_V2" ;
lin deliverable_A = mkTerm "deliverable_A" ;
lin deliverable_N = mkTerm "deliverable_N" ;
lin deliverance_N = mkTerm "deliverance_N" ;
lin deliverer_N = mkTerm "deliverer_N" ;
lin delivery_N = mkTerm "delivery_N" ;
lin deliveryman_N = mkTerm "deliveryman_N" ;
lin dell_N = mkTerm "dell_N" ;
lin delouse_V2 = mkTerm "delouse_V2" ;
lin delphic_A = mkTerm "delphic_A" ;
lin delphinium_N = mkTerm "delphinium_N" ;
lin delta_N = mkTerm "delta_N" ;
lin deltoid_A = mkTerm "deltoid_A" ;
lin deltoid_N = mkTerm "deltoid_N" ;
lin delude_V2 = mkTerm "delude_V2" ;
lin deluge_N = mkTerm "deluge_N" ;
lin deluge_V2 = mkTerm "deluge_V2" ;
lin delusion_N = mkTerm "delusion_N" ;
lin delusional_A = mkTerm "delusional_A" ;
lin delusive_A = mkTerm "delusive_A" ;
lin deluxe_A = mkTerm "deluxe_A" ;
lin delve_V = mkTerm "delve_V" ;
lin delve_V2 = mkTerm "delve_V2" ;
lin demagnetization_N = mkTerm "demagnetization_N" ;
lin demagnetize_V2 = mkTerm "demagnetize_V2" ;
lin demagogic_A = mkTerm "demagogic_A" ;
lin demagogue_N = mkTerm "demagogue_N" ;
lin demagoguery_N = mkTerm "demagoguery_N" ;
lin demagogy_N = mkTerm "demagogy_N" ;
lin demand_N = mkTerm "demand_N" ;
lin demand_V2 = mkTerm "demand_V2" ;
lin demand_VS = mkTerm "demand_VS" ;
lin demander_N = mkTerm "demander_N" ;
lin demanding_A = mkTerm "demanding_A" ;
lin demantoid_N = mkTerm "demantoid_N" ;
lin demarcate_V2 = mkTerm "demarcate_V2" ;
lin demarcation_N = mkTerm "demarcation_N" ;
lin demarche_N = mkTerm "demarche_N" ;
lin demean_V2 = mkTerm "demean_V2" ;
lin demeaning_A = mkTerm "demeaning_A" ;
lin demeanor_N = mkTerm "demeanor_N" ;
lin demeanour_N = mkTerm "demeanour_N" ;
lin demented_A = mkTerm "demented_A" ;
lin dementia_N = mkTerm "dementia_N" ;
lin demerara_N = mkTerm "demerara_N" ;
lin demerit_N = mkTerm "demerit_N" ;
lin demesne_N = mkTerm "demesne_N" ;
lin demiglace_N = mkTerm "demiglace_N" ;
lin demigod_N = mkTerm "demigod_N" ;
lin demijohn_N = mkTerm "demijohn_N" ;
lin demilitarization_N = mkTerm "demilitarization_N" ;
lin demilitarize_V2 = mkTerm "demilitarize_V2" ;
lin demimondaine_N = mkTerm "demimondaine_N" ;
lin demimonde_N = mkTerm "demimonde_N" ;
lin demineralization_N = mkTerm "demineralization_N" ;
lin demise_N = mkTerm "demise_N" ;
lin demist_V2 = mkTerm "demist_V2" ;
lin demister_N = mkTerm "demister_N" ;
lin demitasse_N = mkTerm "demitasse_N" ;
lin demiurge_N = mkTerm "demiurge_N" ;
lin demo_N = mkTerm "demo_N" ;
lin demob_V2 = mkTerm "demob_V2" ;
lin demobilization_N = mkTerm "demobilization_N" ;
lin demobilize_V2 = mkTerm "demobilize_V2" ;
lin democracy_N = mkTerm "democracy_N" ;
lin democrat_N = mkTerm "democrat_N" ;
lin democratic_A = mkTerm "democratic_A" ;
lin democratization_N = mkTerm "democratization_N" ;
lin democratize_V2 = mkTerm "democratize_V2" ;
lin demode_A = mkTerm "demode_A" ;
lin demodulation_N = mkTerm "demodulation_N" ;
lin demographer_N = mkTerm "demographer_N" ;
lin demographic_A = mkTerm "demographic_A" ;
lin demographic_N = mkTerm "demographic_N" ;
lin demography_N = mkTerm "demography_N" ;
lin demolish_V2 = mkTerm "demolish_V2" ;
lin demolition_N = mkTerm "demolition_N" ;
lin demon_N = mkTerm "demon_N" ;
lin demonetization_N = mkTerm "demonetization_N" ;
lin demonetize_V2 = mkTerm "demonetize_V2" ;
lin demoniac_A = mkTerm "demoniac_A" ;
lin demoniac_N = mkTerm "demoniac_N" ;
lin demoniacal_A = mkTerm "demoniacal_A" ;
lin demonic_A = mkTerm "demonic_A" ;
lin demonization_N = mkTerm "demonization_N" ;
lin demonize_V2 = mkTerm "demonize_V2" ;
lin demonstrability_N = mkTerm "demonstrability_N" ;
lin demonstrable_A = mkTerm "demonstrable_A" ;
lin demonstrate_V = mkTerm "demonstrate_V" ;
lin demonstrate_V2 = mkTerm "demonstrate_V2" ;
lin demonstrate_VS = mkTerm "demonstrate_VS" ;
lin demonstration_N = mkTerm "demonstration_N" ;
lin demonstrative_A = mkTerm "demonstrative_A" ;
lin demonstrativeness_N = mkTerm "demonstrativeness_N" ;
lin demonstrator_N = mkTerm "demonstrator_N" ;
lin demoralization_N = mkTerm "demoralization_N" ;
lin demoralize_V2 = mkTerm "demoralize_V2" ;
lin demoralizing_A = mkTerm "demoralizing_A" ;
lin demote_V2 = mkTerm "demote_V2" ;
lin demotic_A = mkTerm "demotic_A" ;
lin demotion_N = mkTerm "demotion_N" ;
lin demulcent_A = mkTerm "demulcent_A" ;
lin demulcent_N = mkTerm "demulcent_N" ;
lin demur_N = mkTerm "demur_N" ;
lin demur_V = mkTerm "demur_V" ;
lin demur_VS = mkTerm "demur_VS" ;
lin demure_A = mkTerm "demure_A" ;
lin demureness_N = mkTerm "demureness_N" ;
lin demurrage_N = mkTerm "demurrage_N" ;
lin demurrer_N = mkTerm "demurrer_N" ;
lin demyelination_N = mkTerm "demyelination_N" ;
lin demythologization_N = mkTerm "demythologization_N" ;
lin demythologized_A = mkTerm "demythologized_A" ;
lin den_N = mkTerm "den_N" ;
lin denain_PN = mkTerm "denain_PN" ;
lin denar_N = mkTerm "denar_N" ;
lin denary_A = mkTerm "denary_A" ;
lin denationalization_N = mkTerm "denationalization_N" ;
lin denationalize_V2 = mkTerm "denationalize_V2" ;
lin denaturant_N = mkTerm "denaturant_N" ;
lin denatured_A = mkTerm "denatured_A" ;
lin denazification_N = mkTerm "denazification_N" ;
lin denbigh_PN = mkTerm "denbigh_PN" ;
lin dendrite_N = mkTerm "dendrite_N" ;
lin dendritic_A = mkTerm "dendritic_A" ;
lin dendrobium_N = mkTerm "dendrobium_N" ;
lin dengue_N = mkTerm "dengue_N" ;
lin deniable_A = mkTerm "deniable_A" ;
lin denial_N = mkTerm "denial_N" ;
lin denier_N = mkTerm "denier_N" ;
lin denigrate_V2 = mkTerm "denigrate_V2" ;
lin denigration_N = mkTerm "denigration_N" ;
lin denim_N = mkTerm "denim_N" ;
lin denis_PN = mkTerm "denis_PN" ;
lin denise_PN = mkTerm "denise_PN" ;
lin denizen_N = mkTerm "denizen_N" ;
lin denmark_PN = mkTerm "denmark_PN" ;
lin dennis_PN = mkTerm "dennis_PN" ;
lin denny_PN = mkTerm "denny_PN" ;
lin denominate_V2 = mkTerm "denominate_V2" ;
lin denomination_N = mkTerm "denomination_N" ;
lin denominational_A = mkTerm "denominational_A" ;
lin denominationalism_N = mkTerm "denominationalism_N" ;
lin denominator_N = mkTerm "denominator_N" ;
lin denotative_A = mkTerm "denotative_A" ;
lin denotatum_N = mkTerm "denotatum_N" ;
lin denote_V2 = mkTerm "denote_V2" ;
lin denouement_N = mkTerm "denouement_N" ;
lin denounce_V2 = mkTerm "denounce_V2" ;
lin dense_A = mkTerm "dense_A" ;
lin denseness_N = mkTerm "denseness_N" ;
lin densimeter_N = mkTerm "densimeter_N" ;
lin densitometer_N = mkTerm "densitometer_N" ;
lin densitometry_N = mkTerm "densitometry_N" ;
lin density_N = mkTerm "density_N" ;
lin dent_N = mkTerm "dent_N" ;
lin dent_V = mkTerm "dent_V" ;
lin dent_V2 = mkTerm "dent_V2" ;
lin dental_A = mkTerm "dental_A" ;
lin dentate_A = mkTerm "dentate_A" ;
lin denticle_N = mkTerm "denticle_N" ;
lin denticulate_A = mkTerm "denticulate_A" ;
lin dentifrice_N = mkTerm "dentifrice_N" ;
lin dentine_N = mkTerm "dentine_N" ;
lin dentist_N = mkTerm "dentist_N" ;
lin dentistry_N = mkTerm "dentistry_N" ;
lin dentition_N = mkTerm "dentition_N" ;
lin denture_N = mkTerm "denture_N" ;
lin denudation_N = mkTerm "denudation_N" ;
lin denude_V2 = mkTerm "denude_V2" ;
lin denunciation_N = mkTerm "denunciation_N" ;
lin denver_PN = mkTerm "denver_PN" ;
lin deny_V2 = mkTerm "deny_V2" ;
lin deny_V3 = mkTerm "deny_V3" ;
lin deodar_N = mkTerm "deodar_N" ;
lin deodorant_N = mkTerm "deodorant_N" ;
lin deodorize_V2 = mkTerm "deodorize_V2" ;
lin deossification_N = mkTerm "deossification_N" ;
lin deoxyadenosine_N = mkTerm "deoxyadenosine_N" ;
lin deoxycytidine_N = mkTerm "deoxycytidine_N" ;
lin deoxyguanosine_N = mkTerm "deoxyguanosine_N" ;
lin deoxyribose_N = mkTerm "deoxyribose_N" ;
lin deoxythymidine_N = mkTerm "deoxythymidine_N" ;
lin dep_PN = mkTerm "dep_PN" ;
lin depart_V = mkTerm "depart_V" ;
lin departed_A = mkTerm "departed_A" ;
lin departed_N = mkTerm "departed_N" ;
lin departer_N = mkTerm "departer_N" ;
lin department_N = mkTerm "department_N" ;
lin departmental_A = mkTerm "departmental_A" ;
lin departure_N = mkTerm "departure_N" ;
lin depend_V = mkTerm "depend_V" ;
lin dependability_N = mkTerm "dependability_N" ;
lin dependable_A = mkTerm "dependable_A" ;
lin dependant_N = mkTerm "dependant_N" ;
lin dependence_N = mkTerm "dependence_N" ;
lin dependency_N = mkTerm "dependency_N" ;
lin dependent_A = mkTerm "dependent_A" ;
lin dependent_N = mkTerm "dependent_N" ;
lin depending_A = mkTerm "depending_A" ;
lin depersonalization_N = mkTerm "depersonalization_N" ;
lin depict_V2 = mkTerm "depict_V2" ;
lin depicting_N = mkTerm "depicting_N" ;
lin depiction_N = mkTerm "depiction_N" ;
lin depigmentation_N = mkTerm "depigmentation_N" ;
lin depilation_N = mkTerm "depilation_N" ;
lin depilatory_A = mkTerm "depilatory_A" ;
lin depilatory_N = mkTerm "depilatory_N" ;
lin depilous_A = mkTerm "depilous_A" ;
lin deplane_V = mkTerm "deplane_V" ;
lin depletable_A = mkTerm "depletable_A" ;
lin deplete_V2 = mkTerm "deplete_V2" ;
lin depletion_N = mkTerm "depletion_N" ;
lin deplorable_A = mkTerm "deplorable_A" ;
lin deplore_V2 = mkTerm "deplore_V2" ;
lin deploy_V = mkTerm "deploy_V" ;
lin deploy_V2 = mkTerm "deploy_V2" ;
lin deployment_N = mkTerm "deployment_N" ;
lin depolarization_N = mkTerm "depolarization_N" ;
lin deponent_N = mkTerm "deponent_N" ;
lin depopulate_V2 = mkTerm "depopulate_V2" ;
lin depopulation_N = mkTerm "depopulation_N" ;
lin deport_V2 = mkTerm "deport_V2" ;
lin deportation_N = mkTerm "deportation_N" ;
lin deportee_N = mkTerm "deportee_N" ;
lin deportment_N = mkTerm "deportment_N" ;
lin depose_V = mkTerm "depose_V" ;
lin depose_V2 = mkTerm "depose_V2" ;
lin deposit_N = mkTerm "deposit_N" ;
lin deposit_V2 = mkTerm "deposit_V2" ;
lin deposition_N = mkTerm "deposition_N" ;
lin depositor_N = mkTerm "depositor_N" ;
lin depository_N = mkTerm "depository_N" ;
lin depot_N = mkTerm "depot_N" ;
lin deprave_V2 = mkTerm "deprave_V2" ;
lin depravity_N = mkTerm "depravity_N" ;
lin deprecate_V2 = mkTerm "deprecate_V2" ;
lin deprecation_N = mkTerm "deprecation_N" ;
lin deprecative_A = mkTerm "deprecative_A" ;
lin depreciate_V = mkTerm "depreciate_V" ;
lin depreciate_V2 = mkTerm "depreciate_V2" ;
lin depreciation_N = mkTerm "depreciation_N" ;
lin depreciatory_A = mkTerm "depreciatory_A" ;
lin depredation_N = mkTerm "depredation_N" ;
lin depress_V2 = mkTerm "depress_V2" ;
lin depressant_A = mkTerm "depressant_A" ;
lin depressed_A = mkTerm "depressed_A" ;
lin depressing_A = mkTerm "depressing_A" ;
lin depression_N = mkTerm "depression_N" ;
lin depressive_A = mkTerm "depressive_A" ;
lin depressive_N = mkTerm "depressive_N" ;
lin depressor_N = mkTerm "depressor_N" ;
lin deprivation_N = mkTerm "deprivation_N" ;
lin deprive_V2 = mkTerm "deprive_V2" ;
lin dept_PN = mkTerm "dept_PN" ;
lin depth_N = mkTerm "depth_N" ;
lin depth_bomb_N = mkTerm "depth_bomb_N" ;
lin depth_charge_N = mkTerm "depth_charge_N" ;
lin depths_N = mkTerm "depths_N" ;
lin deputation_N = mkTerm "deputation_N" ;
lin depute_V2 = mkTerm "depute_V2" ;
lin deputize_V = mkTerm "deputize_V" ;
lin deputy_N = mkTerm "deputy_N" ;
lin derail_V2 = mkTerm "derail_V2" ;
lin derailment_N = mkTerm "derailment_N" ;
lin derange_V2 = mkTerm "derange_V2" ;
lin derangement_N = mkTerm "derangement_N" ;
lin derate_V2 = mkTerm "derate_V2" ;
lin derby_N = mkTerm "derby_N" ;
lin derby_PN = mkTerm "derby_PN" ;
lin derbyshire_PN = mkTerm "derbyshire_PN" ;
lin deregulate_V2 = mkTerm "deregulate_V2" ;
lin deregulation_N = mkTerm "deregulation_N" ;
lin dereham_PN = mkTerm "dereham_PN" ;
lin derek_PN = mkTerm "derek_PN" ;
lin derelict_A = mkTerm "derelict_A" ;
lin derelict_N = mkTerm "derelict_N" ;
lin dereliction_N = mkTerm "dereliction_N" ;
lin derequisition_V2 = mkTerm "derequisition_V2" ;
lin derestrict_V2 = mkTerm "derestrict_V2" ;
lin deride_V2 = mkTerm "deride_V2" ;
lin derision_N = mkTerm "derision_N" ;
lin derisive_A = mkTerm "derisive_A" ;
lin derisory_A = mkTerm "derisory_A" ;
lin derivable_A = mkTerm "derivable_A" ;
lin derivation_N = mkTerm "derivation_N" ;
lin derivational_A = mkTerm "derivational_A" ;
lin derivative_A = mkTerm "derivative_A" ;
lin derivative_N = mkTerm "derivative_N" ;
lin derive_V = mkTerm "derive_V" ;
lin derive_V2 = mkTerm "derive_V2" ;
lin deriving_N = mkTerm "deriving_N" ;
lin dermabrasion_N = mkTerm "dermabrasion_N" ;
lin dermal_A = mkTerm "dermal_A" ;
lin dermatitis_N = mkTerm "dermatitis_N" ;
lin dermatoglyphic_N = mkTerm "dermatoglyphic_N" ;
lin dermatoglyphics_N = mkTerm "dermatoglyphics_N" ;
lin dermatologic_A = mkTerm "dermatologic_A" ;
lin dermatologistFem_N = mkTerm "dermatologistFem_N" ;
lin dermatologistMasc_N = mkTerm "dermatologistMasc_N" ;
lin dermatology_N = mkTerm "dermatology_N" ;
lin dermatome_N = mkTerm "dermatome_N" ;
lin dermatomycosis_N = mkTerm "dermatomycosis_N" ;
lin dermatomyositis_N = mkTerm "dermatomyositis_N" ;
lin dermatosis_N = mkTerm "dermatosis_N" ;
lin dermis_N = mkTerm "dermis_N" ;
lin derogate_V = mkTerm "derogate_V" ;
lin derogation_N = mkTerm "derogation_N" ;
lin derogative_A = mkTerm "derogative_A" ;
lin derogatory_A = mkTerm "derogatory_A" ;
lin derrick_N = mkTerm "derrick_N" ;
lin derring_do_N = mkTerm "derring_do_N" ;
lin derringer_N = mkTerm "derringer_N" ;
lin derris_N = mkTerm "derris_N" ;
lin derv_N = mkTerm "derv_N" ;
lin dervish_N = mkTerm "dervish_N" ;
lin des_N = mkTerm "des_N" ;
lin des_PN = mkTerm "des_PN" ;
lin desalinate_V2 = mkTerm "desalinate_V2" ;
lin desalination_N = mkTerm "desalination_N" ;
lin desalinization_N = mkTerm "desalinization_N" ;
lin desalinize_V2 = mkTerm "desalinize_V2" ;
lin desalt_V2 = mkTerm "desalt_V2" ;
lin descale_V2 = mkTerm "descale_V2" ;
lin descant_N = mkTerm "descant_N" ;
lin descant_V = mkTerm "descant_V" ;
lin descend_V = mkTerm "descend_V" ;
lin descend_V2 = mkTerm "descend_V2" ;
lin descendant_A = mkTerm "descendant_A" ;
lin descendant_N = mkTerm "descendant_N" ;
lin descendants_N = mkTerm "descendants_N" ;
lin descender_N = mkTerm "descender_N" ;
lin descent_N = mkTerm "descent_N" ;
lin describable_A = mkTerm "describable_A" ;
lin describe_V2 = mkTerm "describe_V2" ;
lin describe_VS = mkTerm "describe_VS" ;
lin description_N = mkTerm "description_N" ;
lin descriptive_A = mkTerm "descriptive_A" ;
lin descriptivism_N = mkTerm "descriptivism_N" ;
lin descriptor_N = mkTerm "descriptor_N" ;
lin descry_V2 = mkTerm "descry_V2" ;
lin desecrate_V2 = mkTerm "desecrate_V2" ;
lin desecration_N = mkTerm "desecration_N" ;
lin desegrated_A = mkTerm "desegrated_A" ;
lin desegregate_V2 = mkTerm "desegregate_V2" ;
lin desegregation_N = mkTerm "desegregation_N" ;
lin desensitization_N = mkTerm "desensitization_N" ;
lin desensitize_V2 = mkTerm "desensitize_V2" ;
lin desensitizing_A = mkTerm "desensitizing_A" ;
lin desert_A = mkTerm "desert_A" ;
lin desert_N = mkTerm "desert_N" ;
lin desert_V = mkTerm "desert_V" ;
lin desert_V2 = mkTerm "desert_V2" ;
lin deserter_N = mkTerm "deserter_N" ;
lin desertification_N = mkTerm "desertification_N" ;
lin desertion_N = mkTerm "desertion_N" ;
lin deserts_N = mkTerm "deserts_N" ;
lin deserve_V = mkTerm "deserve_V" ;
lin deserve_V2 = mkTerm "deserve_V2" ;
lin deserve_VV = mkTerm "deserve_VV" ;
lin deservedly_Adv = mkTerm "deservedly_Adv" ;
lin deservingness_N = mkTerm "deservingness_N" ;
lin deshabille_N = mkTerm "deshabille_N" ;
lin desiccant_N = mkTerm "desiccant_N" ;
lin desiccate_V2 = mkTerm "desiccate_V2" ;
lin desideratum_N = mkTerm "desideratum_N" ;
lin design_N = mkTerm "design_N" ;
lin design_V = mkTerm "design_V" ;
lin design_V2 = mkTerm "design_V2" ;
lin designate_A = mkTerm "designate_A" ;
lin designate_V = mkTerm "designate_V" ;
lin designate_V2 = mkTerm "designate_V2" ;
lin designate_V2V = mkTerm "designate_V2V" ;
lin designate_VS = mkTerm "designate_VS" ;
lin designation_N = mkTerm "designation_N" ;
lin designative_A = mkTerm "designative_A" ;
lin designatum_N = mkTerm "designatum_N" ;
lin designedly_Adv = mkTerm "designedly_Adv" ;
lin designer_N = mkTerm "designer_N" ;
lin designing_N = mkTerm "designing_N" ;
lin desipramine_N = mkTerm "desipramine_N" ;
lin desirability_N = mkTerm "desirability_N" ;
lin desirable_A = mkTerm "desirable_A" ;
lin desire_N = mkTerm "desire_N" ;
lin desire_V2 = mkTerm "desire_V2" ;
lin desired_A = mkTerm "desired_A" ;
lin desirous_A = mkTerm "desirous_A" ;
lin desist_V = mkTerm "desist_V" ;
lin desk_N = mkTerm "desk_N" ;
lin desktop_A = mkTerm "desktop_A" ;
lin desktop_N = mkTerm "desktop_N" ;
lin desmid_N = mkTerm "desmid_N" ;
lin desmond_PN = mkTerm "desmond_PN" ;
lin desolate_A = mkTerm "desolate_A" ;
lin desolate_V2 = mkTerm "desolate_V2" ;
lin desolation_N = mkTerm "desolation_N" ;
lin desorption_N = mkTerm "desorption_N" ;
lin despair_N = mkTerm "despair_N" ;
lin despair_V = mkTerm "despair_V" ;
lin despairingly_Adv = mkTerm "despairingly_Adv" ;
lin despatch_N = mkTerm "despatch_N" ;
lin despatch_V2 = mkTerm "despatch_V2" ;
lin desperado_N = mkTerm "desperado_N" ;
lin desperate_A = mkTerm "desperate_A" ;
lin desperate_N = mkTerm "desperate_N" ;
lin desperation_N = mkTerm "desperation_N" ;
lin despicable_A = mkTerm "despicable_A" ;
lin despisal_N = mkTerm "despisal_N" ;
lin despise_V2 = mkTerm "despise_V2" ;
lin despite_N = mkTerm "despite_N" ;
lin despite_Prep = mkTerm "despite_Prep" ;
lin despiteful_A = mkTerm "despiteful_A" ;
lin despoil_V2 = mkTerm "despoil_V2" ;
lin despondency_N = mkTerm "despondency_N" ;
lin despondent_A = mkTerm "despondent_A" ;
lin despot_N = mkTerm "despot_N" ;
lin despotic_A = mkTerm "despotic_A" ;
lin despotism_N = mkTerm "despotism_N" ;
lin desquamation_N = mkTerm "desquamation_N" ;
lin dessau_PN = mkTerm "dessau_PN" ;
lin dessert_N = mkTerm "dessert_N" ;
lin dessertspoon_N = mkTerm "dessertspoon_N" ;
lin dessertspoonful_N = mkTerm "dessertspoonful_N" ;
lin dessiatine_N = mkTerm "dessiatine_N" ;
lin destabilization_N = mkTerm "destabilization_N" ;
lin destalinization_N = mkTerm "destalinization_N" ;
lin destination_N = mkTerm "destination_N" ;
lin destine_V2 = mkTerm "destine_V2" ;
lin destine_V2V = mkTerm "destine_V2V" ;
lin destiny_N = mkTerm "destiny_N" ;
lin destitute_A = mkTerm "destitute_A" ;
lin destitution_N = mkTerm "destitution_N" ;
lin destroy_V2 = mkTerm "destroy_V2" ;
lin destroyable_A = mkTerm "destroyable_A" ;
lin destroyer_N = mkTerm "destroyer_N" ;
lin destructibility_N = mkTerm "destructibility_N" ;
lin destructible_A = mkTerm "destructible_A" ;
lin destruction_N = mkTerm "destruction_N" ;
lin destructive_A = mkTerm "destructive_A" ;
lin destructiveness_N = mkTerm "destructiveness_N" ;
lin desuetude_N = mkTerm "desuetude_N" ;
lin desultory_A = mkTerm "desultory_A" ;
lin detach_V2 = mkTerm "detach_V2" ;
lin detachable_A = mkTerm "detachable_A" ;
lin detachment_N = mkTerm "detachment_N" ;
lin detail_N = mkTerm "detail_N" ;
lin detail_V2 = mkTerm "detail_V2" ;
lin detailed_A = mkTerm "detailed_A" ;
lin detain_V2 = mkTerm "detain_V2" ;
lin detainee_N = mkTerm "detainee_N" ;
lin detect_V2 = mkTerm "detect_V2" ;
lin detectable_A = mkTerm "detectable_A" ;
lin detection_N = mkTerm "detection_N" ;
lin detective_N = mkTerm "detective_N" ;
lin detector_N = mkTerm "detector_N" ;
lin detente_N = mkTerm "detente_N" ;
lin detention_N = mkTerm "detention_N" ;
lin deter_V2 = mkTerm "deter_V2" ;
lin detergency_N = mkTerm "detergency_N" ;
lin detergent_A = mkTerm "detergent_A" ;
lin detergent_N = mkTerm "detergent_N" ;
lin deteriorate_V = mkTerm "deteriorate_V" ;
lin deteriorate_V2 = mkTerm "deteriorate_V2" ;
lin deterioration_N = mkTerm "deterioration_N" ;
lin determent_N = mkTerm "determent_N" ;
lin determinable_A = mkTerm "determinable_A" ;
lin determinant_A = mkTerm "determinant_A" ;
lin determinant_N = mkTerm "determinant_N" ;
lin determinate_A = mkTerm "determinate_A" ;
lin determinateness_N = mkTerm "determinateness_N" ;
lin determination_N = mkTerm "determination_N" ;
lin determinative_A = mkTerm "determinative_A" ;
lin determinative_N = mkTerm "determinative_N" ;
lin determine_V = mkTerm "determine_V" ;
lin determine_V2 = mkTerm "determine_V2" ;
lin determine_V2V = mkTerm "determine_V2V" ;
lin determine_VS = mkTerm "determine_VS" ;
lin determine_VV = mkTerm "determine_VV" ;
lin determined_A = mkTerm "determined_A" ;
lin determiner_N = mkTerm "determiner_N" ;
lin determinism_N = mkTerm "determinism_N" ;
lin deterministic_A = mkTerm "deterministic_A" ;
lin deterrence_N = mkTerm "deterrence_N" ;
lin deterrent_A = mkTerm "deterrent_A" ;
lin deterrent_N = mkTerm "deterrent_N" ;
lin detest_V2 = mkTerm "detest_V2" ;
lin detestable_A = mkTerm "detestable_A" ;
lin detestation_N = mkTerm "detestation_N" ;
lin dethrone_V2 = mkTerm "dethrone_V2" ;
lin dethronement_N = mkTerm "dethronement_N" ;
lin detonate_V = mkTerm "detonate_V" ;
lin detonate_V2 = mkTerm "detonate_V2" ;
lin detonation_N = mkTerm "detonation_N" ;
lin detonative_A = mkTerm "detonative_A" ;
lin detonator_N = mkTerm "detonator_N" ;
lin detour_N = mkTerm "detour_N" ;
lin detour_V2 = mkTerm "detour_V2" ;
lin detox_N = mkTerm "detox_N" ;
lin detoxification_N = mkTerm "detoxification_N" ;
lin detract_V = mkTerm "detract_V" ;
lin detraction_N = mkTerm "detraction_N" ;
lin detractive_A = mkTerm "detractive_A" ;
lin detractor_N = mkTerm "detractor_N" ;
lin detrain_V = mkTerm "detrain_V" ;
lin detrain_V2 = mkTerm "detrain_V2" ;
lin detribalization_N = mkTerm "detribalization_N" ;
lin detribalize_V2 = mkTerm "detribalize_V2" ;
lin detriment_N = mkTerm "detriment_N" ;
lin detrimental_A = mkTerm "detrimental_A" ;
lin detritus_N = mkTerm "detritus_N" ;
lin detroit_PN = mkTerm "detroit_PN" ;
lin detumescence_N = mkTerm "detumescence_N" ;
lin deuce_N = mkTerm "deuce_N" ;
lin deuced_A = mkTerm "deuced_A" ;
lin deuteranopia_N = mkTerm "deuteranopia_N" ;
lin deuteranopic_A = mkTerm "deuteranopic_A" ;
lin deuterium_N = mkTerm "deuterium_N" ;
lin deuteron_N = mkTerm "deuteron_N" ;
lin deutschmark_N = mkTerm "deutschmark_N" ;
lin deutzia_N = mkTerm "deutzia_N" ;
lin devaluate_V2 = mkTerm "devaluate_V2" ;
lin devaluation_N = mkTerm "devaluation_N" ;
lin devalue_V2 = mkTerm "devalue_V2" ;
lin devastate_V2 = mkTerm "devastate_V2" ;
lin devastation_N = mkTerm "devastation_N" ;
lin develop_V = mkTerm "develop_V" ;
lin develop_V2 = mkTerm "develop_V2" ;
lin developed_A = mkTerm "developed_A" ;
lin developer_N = mkTerm "developer_N" ;
lin developing_A = mkTerm "developing_A" ;
lin development_N = mkTerm "development_N" ;
lin developmental_A = mkTerm "developmental_A" ;
lin deviant_A = mkTerm "deviant_A" ;
lin deviant_N = mkTerm "deviant_N" ;
lin deviate_V = mkTerm "deviate_V" ;
lin deviation_N = mkTerm "deviation_N" ;
lin deviationism_N = mkTerm "deviationism_N" ;
lin deviationist_N = mkTerm "deviationist_N" ;
lin device_N = mkTerm "device_N" ;
lin devil_N = mkTerm "devil_N" ;
lin devil_V = mkTerm "devil_V" ;
lin devil_V2 = mkTerm "devil_V2" ;
lin devil_may_care_A = mkTerm "devil_may_care_A" ;
lin devilish_A = mkTerm "devilish_A" ;
lin devilish_Adv = mkTerm "devilish_Adv" ;
lin devilment_N = mkTerm "devilment_N" ;
lin devilry_N = mkTerm "devilry_N" ;
lin deviltry_N = mkTerm "deviltry_N" ;
lin devilwood_N = mkTerm "devilwood_N" ;
lin devious_A = mkTerm "devious_A" ;
lin deviousness_N = mkTerm "deviousness_N" ;
lin devisal_N = mkTerm "devisal_N" ;
lin devise_N = mkTerm "devise_N" ;
lin devise_V2 = mkTerm "devise_V2" ;
lin devisee_N = mkTerm "devisee_N" ;
lin devising_N = mkTerm "devising_N" ;
lin devisor_N = mkTerm "devisor_N" ;
lin devitalization_N = mkTerm "devitalization_N" ;
lin devitalize_V2 = mkTerm "devitalize_V2" ;
lin devizes_PN = mkTerm "devizes_PN" ;
lin devoid_A = mkTerm "devoid_A" ;
lin devoir_N = mkTerm "devoir_N" ;
lin devolution_N = mkTerm "devolution_N" ;
lin devolve_V = mkTerm "devolve_V" ;
lin devolve_V2 = mkTerm "devolve_V2" ;
lin devon_PN = mkTerm "devon_PN" ;
lin devote_V2 = mkTerm "devote_V2" ;
lin devoted_A = mkTerm "devoted_A" ;
lin devotee_N = mkTerm "devotee_N" ;
lin devotion_N = mkTerm "devotion_N" ;
lin devotional_A = mkTerm "devotional_A" ;
lin devotional_N = mkTerm "devotional_N" ;
lin devour_V2 = mkTerm "devour_V2" ;
lin devourer_N = mkTerm "devourer_N" ;
lin devout_A = mkTerm "devout_A" ;
lin devoutness_N = mkTerm "devoutness_N" ;
lin devries_N = mkTerm "devries_N" ;
lin dew_N = mkTerm "dew_N" ;
lin dewberry_N = mkTerm "dewberry_N" ;
lin dewdrop_N = mkTerm "dewdrop_N" ;
lin dewlap_N = mkTerm "dewlap_N" ;
lin dewsbury_PN = mkTerm "dewsbury_PN" ;
lin dewy_A = mkTerm "dewy_A" ;
lin dexamethasone_N = mkTerm "dexamethasone_N" ;
lin dexter_A = mkTerm "dexter_A" ;
lin dexterity_N = mkTerm "dexterity_N" ;
lin dexterous_A = mkTerm "dexterous_A" ;
lin dextral_A = mkTerm "dextral_A" ;
lin dextrin_N = mkTerm "dextrin_N" ;
lin dextrocardia_N = mkTerm "dextrocardia_N" ;
lin dextrorotary_A = mkTerm "dextrorotary_A" ;
lin dextrorotation_N = mkTerm "dextrorotation_N" ;
lin dextrorse_A = mkTerm "dextrorse_A" ;
lin dextrose_N = mkTerm "dextrose_N" ;
lin dextrous_A = mkTerm "dextrous_A" ;
lin dg_PN = mkTerm "dg_PN" ;
lin dhak_N = mkTerm "dhak_N" ;
lin dhawa_N = mkTerm "dhawa_N" ;
lin dhole_N = mkTerm "dhole_N" ;
lin dhoti_N = mkTerm "dhoti_N" ;
lin dhow_N = mkTerm "dhow_N" ;
lin di_PN = mkTerm "di_PN" ;
lin diabatic_A = mkTerm "diabatic_A" ;
lin diabetes_N = mkTerm "diabetes_N" ;
lin diabetic_A = mkTerm "diabetic_A" ;
lin diabetic_N = mkTerm "diabetic_N" ;
lin diabolatry_N = mkTerm "diabolatry_N" ;
lin diabolic_A = mkTerm "diabolic_A" ;
lin diabolical_A = mkTerm "diabolical_A" ;
lin diabolism_N = mkTerm "diabolism_N" ;
lin diachronic_A = mkTerm "diachronic_A" ;
lin diacritic_A = mkTerm "diacritic_A" ;
lin diacritic_N = mkTerm "diacritic_N" ;
lin diacritical_A = mkTerm "diacritical_A" ;
lin diadem_N = mkTerm "diadem_N" ;
lin diadromous_A = mkTerm "diadromous_A" ;
lin diaeresis_N = mkTerm "diaeresis_N" ;
lin diagnosable_A = mkTerm "diagnosable_A" ;
lin diagnose_V2 = mkTerm "diagnose_V2" ;
lin diagnosis_N = mkTerm "diagnosis_N" ;
lin diagnostic_A = mkTerm "diagnostic_A" ;
lin diagnostician_N = mkTerm "diagnostician_N" ;
lin diagonal_A = mkTerm "diagonal_A" ;
lin diagonal_N = mkTerm "diagonal_N" ;
lin diagonalizable_A = mkTerm "diagonalizable_A" ;
lin diagonalization_N = mkTerm "diagonalization_N" ;
lin diagram_N = mkTerm "diagram_N" ;
lin diagrammatic_A = mkTerm "diagrammatic_A" ;
lin diagrammatical_A = mkTerm "diagrammatical_A" ;
lin diakinesis_N = mkTerm "diakinesis_N" ;
lin dial_N = mkTerm "dial_N" ;
lin dial_V2 = mkTerm "dial_V2" ;
lin dialect_N = mkTerm "dialect_N" ;
lin dialectal_A = mkTerm "dialectal_A" ;
lin dialectic_A = mkTerm "dialectic_A" ;
lin dialectic_N = mkTerm "dialectic_N" ;
lin dialectical_A = mkTerm "dialectical_A" ;
lin dialectician_N = mkTerm "dialectician_N" ;
lin dialectics_N = mkTerm "dialectics_N" ;
lin dialectology_N = mkTerm "dialectology_N" ;
lin dialog_N = mkTerm "dialog_N" ;
lin dialogue_N = mkTerm "dialogue_N" ;
lin dialysis_N = mkTerm "dialysis_N" ;
lin dialyzer_N = mkTerm "dialyzer_N" ;
lin diamagnet_N = mkTerm "diamagnet_N" ;
lin diamagnetic_A = mkTerm "diamagnetic_A" ;
lin diamagnetism_N = mkTerm "diamagnetism_N" ;
lin diamante_N = mkTerm "diamante_N" ;
lin diamantine_A = mkTerm "diamantine_A" ;
lin diameter_N = mkTerm "diameter_N" ;
lin diametral_A = mkTerm "diametral_A" ;
lin diametric_A = mkTerm "diametric_A" ;
lin diamine_N = mkTerm "diamine_N" ;
lin diamond_N = mkTerm "diamond_N" ;
lin diamondback_N = mkTerm "diamondback_N" ;
lin diana_PN = mkTerm "diana_PN" ;
lin diane_N = mkTerm "diane_N" ;
lin dianoetic_A = mkTerm "dianoetic_A" ;
lin diapason_N = mkTerm "diapason_N" ;
lin diapedesis_N = mkTerm "diapedesis_N" ;
lin diapensia_N = mkTerm "diapensia_N" ;
lin diaper_N = mkTerm "diaper_N" ;
lin diaphanous_A = mkTerm "diaphanous_A" ;
lin diapheromera_N = mkTerm "diapheromera_N" ;
lin diaphone_N = mkTerm "diaphone_N" ;
lin diaphoretic_A = mkTerm "diaphoretic_A" ;
lin diaphoretic_N = mkTerm "diaphoretic_N" ;
lin diaphragm_N = mkTerm "diaphragm_N" ;
lin diaphyseal_A = mkTerm "diaphyseal_A" ;
lin diaphysis_N = mkTerm "diaphysis_N" ;
lin diapir_N = mkTerm "diapir_N" ;
lin diapsid_N = mkTerm "diapsid_N" ;
lin diarchy_N = mkTerm "diarchy_N" ;
lin diarist_N = mkTerm "diarist_N" ;
lin diarrhea_N = mkTerm "diarrhea_N" ;
lin diarrheal_A = mkTerm "diarrheal_A" ;
lin diarrhoea_N = mkTerm "diarrhoea_N" ;
lin diary_N = mkTerm "diary_N" ;
lin diaspora_N = mkTerm "diaspora_N" ;
lin diastasis_N = mkTerm "diastasis_N" ;
lin diastema_N = mkTerm "diastema_N" ;
lin diastole_N = mkTerm "diastole_N" ;
lin diastolic_A = mkTerm "diastolic_A" ;
lin diastrophism_N = mkTerm "diastrophism_N" ;
lin diathermy_N = mkTerm "diathermy_N" ;
lin diathesis_N = mkTerm "diathesis_N" ;
lin diatom_N = mkTerm "diatom_N" ;
lin diatomic_A = mkTerm "diatomic_A" ;
lin diatonic_A = mkTerm "diatonic_A" ;
lin diatribe_N = mkTerm "diatribe_N" ;
lin diazepam_N = mkTerm "diazepam_N" ;
lin diazo_A = mkTerm "diazo_A" ;
lin diazonium_N = mkTerm "diazonium_N" ;
lin diazoxide_N = mkTerm "diazoxide_N" ;
lin dibber_N = mkTerm "dibber_N" ;
lin dibble_N = mkTerm "dibble_N" ;
lin dibble_V2 = mkTerm "dibble_V2" ;
lin dibranchiate_N = mkTerm "dibranchiate_N" ;
lin dibs_N = mkTerm "dibs_N" ;
lin dibucaine_N = mkTerm "dibucaine_N" ;
lin dicamptodon_N = mkTerm "dicamptodon_N" ;
lin dicarboxylic_A = mkTerm "dicarboxylic_A" ;
lin dice_N = mkTerm "dice_N" ;
lin dice_V = mkTerm "dice_V" ;
lin dice_V2 = mkTerm "dice_V2" ;
lin dice_box_N = mkTerm "dice_box_N" ;
lin dicer_N = mkTerm "dicer_N" ;
lin dicey_A = mkTerm "dicey_A" ;
lin dichloride_N = mkTerm "dichloride_N" ;
lin dichlorodiphenyltrichloroethane_N = mkTerm "dichlorodiphenyltrichloroethane_N" ;
lin dichondra_N = mkTerm "dichondra_N" ;
lin dichotomization_N = mkTerm "dichotomization_N" ;
lin dichotomous_A = mkTerm "dichotomous_A" ;
lin dichotomy_N = mkTerm "dichotomy_N" ;
lin dichroism_N = mkTerm "dichroism_N" ;
lin dichromacy_N = mkTerm "dichromacy_N" ;
lin dichromat_N = mkTerm "dichromat_N" ;
lin dichromatic_A = mkTerm "dichromatic_A" ;
lin dick_N = mkTerm "dick_N" ;
lin dick_PN = mkTerm "dick_PN" ;
lin dickens_N = mkTerm "dickens_N" ;
lin dicker_V = mkTerm "dicker_V" ;
lin dickey_N = mkTerm "dickey_N" ;
lin dickeybird_N = mkTerm "dickeybird_N" ;
lin dicky_A = mkTerm "dicky_A" ;
lin dicky_N = mkTerm "dicky_N" ;
lin dicky_PN = mkTerm "dicky_PN" ;
lin dicky_seat_N = mkTerm "dicky_seat_N" ;
lin dickybird_N = mkTerm "dickybird_N" ;
lin diclinous_A = mkTerm "diclinous_A" ;
lin dicloxacillin_N = mkTerm "dicloxacillin_N" ;
lin dicot_N = mkTerm "dicot_N" ;
lin dicotyledonous_A = mkTerm "dicotyledonous_A" ;
lin dictaphone_N = mkTerm "dictaphone_N" ;
lin dictate_N = mkTerm "dictate_N" ;
lin dictate_V = mkTerm "dictate_V" ;
lin dictate_V2 = mkTerm "dictate_V2" ;
lin dictate_VS = mkTerm "dictate_VS" ;
lin dictation_N = mkTerm "dictation_N" ;
lin dictator_N = mkTerm "dictator_N" ;
lin dictatorial_A = mkTerm "dictatorial_A" ;
lin dictatorship_N = mkTerm "dictatorship_N" ;
lin diction_N = mkTerm "diction_N" ;
lin dictionary_N = mkTerm "dictionary_N" ;
lin dictostylium_N = mkTerm "dictostylium_N" ;
lin dictum_N = mkTerm "dictum_N" ;
lin dictyopteran_A = mkTerm "dictyopteran_A" ;
lin dicumarol_N = mkTerm "dicumarol_N" ;
lin dicynodont_N = mkTerm "dicynodont_N" ;
lin didactic_A = mkTerm "didactic_A" ;
lin didacticism_N = mkTerm "didacticism_N" ;
lin didcot_PN = mkTerm "didcot_PN" ;
lin diddle_V2 = mkTerm "diddle_V2" ;
lin dideoxycytosine_N = mkTerm "dideoxycytosine_N" ;
lin dideoxyinosine_N = mkTerm "dideoxyinosine_N" ;
lin die_N = mkTerm "die_N" ;
lin die_V = mkTerm "die_V" ;
lin die_away_V = mkTerm "die_away_V" ;
lin die_back_V = mkTerm "die_back_V" ;
lin die_cast_A = mkTerm "die_cast_A" ;
lin die_down_V = mkTerm "die_down_V" ;
lin die_for_V2 = mkTerm "die_for_V2" ;
lin die_hard_N = mkTerm "die_hard_N" ;
lin die_off_V = mkTerm "die_off_V" ;
lin die_out_V = mkTerm "die_out_V" ;
lin dieback_N = mkTerm "dieback_N" ;
lin diemaker_N = mkTerm "diemaker_N" ;
lin diencephalon_N = mkTerm "diencephalon_N" ;
lin dieresis_N = mkTerm "dieresis_N" ;
lin diesel_N = mkTerm "diesel_N" ;
lin diestock_N = mkTerm "diestock_N" ;
lin diestrous_A = mkTerm "diestrous_A" ;
lin diestrus_N = mkTerm "diestrus_N" ;
lin diet_N = mkTerm "diet_N" ;
lin diet_V = mkTerm "diet_V" ;
lin diet_V2 = mkTerm "diet_V2" ;
lin dietary_A = mkTerm "dietary_A" ;
lin dietary_N = mkTerm "dietary_N" ;
lin dieter_N = mkTerm "dieter_N" ;
lin dietetics_N = mkTerm "dietetics_N" ;
lin diethylstilbesterol_N = mkTerm "diethylstilbesterol_N" ;
lin diethylstilbestrol_N = mkTerm "diethylstilbestrol_N" ;
lin dietician_N = mkTerm "dietician_N" ;
lin dietitian_N = mkTerm "dietitian_N" ;
lin differ_V = mkTerm "differ_V" ;
lin difference_N = mkTerm "difference_N" ;
lin different_A = mkTerm "different_A" ;
lin differentia_N = mkTerm "differentia_N" ;
lin differentiable_A = mkTerm "differentiable_A" ;
lin differential_A = mkTerm "differential_A" ;
lin differential_N = mkTerm "differential_N" ;
lin differentiate_V = mkTerm "differentiate_V" ;
lin differentiate_V2 = mkTerm "differentiate_V2" ;
lin differentiation_N = mkTerm "differentiation_N" ;
lin differentiator_N = mkTerm "differentiator_N" ;
lin difficult_A = mkTerm "difficult_A" ;
lin difficulty_N = mkTerm "difficulty_N" ;
lin diffidence_N = mkTerm "diffidence_N" ;
lin diffident_A = mkTerm "diffident_A" ;
lin difflugia_N = mkTerm "difflugia_N" ;
lin diffract_V2 = mkTerm "diffract_V2" ;
lin diffraction_N = mkTerm "diffraction_N" ;
lin diffuse_A = mkTerm "diffuse_A" ;
lin diffuse_V = mkTerm "diffuse_V" ;
lin diffuse_V2 = mkTerm "diffuse_V2" ;
lin diffuseness_N = mkTerm "diffuseness_N" ;
lin diffuser_N = mkTerm "diffuser_N" ;
lin diffusion_N = mkTerm "diffusion_N" ;
lin diflunisal_N = mkTerm "diflunisal_N" ;
lin dig_N = mkTerm "dig_N" ;
lin dig_V = mkTerm "dig_V" ;
lin dig_V2 = mkTerm "dig_V2" ;
lin dig_in_V = mkTerm "dig_in_V" ;
lin dig_into_V2 = mkTerm "dig_into_V2" ;
lin dig_out_V2 = mkTerm "dig_out_V2" ;
lin dig_up_V2 = mkTerm "dig_up_V2" ;
lin digest_N = mkTerm "digest_N" ;
lin digest_V = mkTerm "digest_V" ;
lin digest_V2 = mkTerm "digest_V2" ;
lin digester_N = mkTerm "digester_N" ;
lin digestibility_N = mkTerm "digestibility_N" ;
lin digestible_A = mkTerm "digestible_A" ;
lin digestion_N = mkTerm "digestion_N" ;
lin digestive_A = mkTerm "digestive_A" ;
lin digestive_N = mkTerm "digestive_N" ;
lin digger_N = mkTerm "digger_N" ;
lin digging_N = mkTerm "digging_N" ;
lin diggings_N = mkTerm "diggings_N" ;
lin dighted_A = mkTerm "dighted_A" ;
lin digit_N = mkTerm "digit_N" ;
lin digital_A = mkTerm "digital_A" ;
lin digitalis_N = mkTerm "digitalis_N" ;
lin digitalization_N = mkTerm "digitalization_N" ;
lin digitate_A = mkTerm "digitate_A" ;
lin digitigrade_A = mkTerm "digitigrade_A" ;
lin digitization_N = mkTerm "digitization_N" ;
lin digitizer_N = mkTerm "digitizer_N" ;
lin digitoxin_N = mkTerm "digitoxin_N" ;
lin diglyceride_N = mkTerm "diglyceride_N" ;
lin dignify_V2 = mkTerm "dignify_V2" ;
lin dignifying_A = mkTerm "dignifying_A" ;
lin dignitary_N = mkTerm "dignitary_N" ;
lin dignity_N = mkTerm "dignity_N" ;
lin digoxin_N = mkTerm "digoxin_N" ;
lin digraph_N = mkTerm "digraph_N" ;
lin digress_V = mkTerm "digress_V" ;
lin digression_N = mkTerm "digression_N" ;
lin digressive_A = mkTerm "digressive_A" ;
lin dihybrid_N = mkTerm "dihybrid_N" ;
lin dihydrostreptomycin_N = mkTerm "dihydrostreptomycin_N" ;
lin dijon_PN = mkTerm "dijon_PN" ;
lin dike_N = mkTerm "dike_N" ;
lin dike_V = mkTerm "dike_V" ;
lin dike_V2 = mkTerm "dike_V2" ;
lin dilapidated_A = mkTerm "dilapidated_A" ;
lin dilapidation_N = mkTerm "dilapidation_N" ;
lin dilatation_N = mkTerm "dilatation_N" ;
lin dilate_V = mkTerm "dilate_V" ;
lin dilate_V2 = mkTerm "dilate_V2" ;
lin dilation_N = mkTerm "dilation_N" ;
lin dilator_N = mkTerm "dilator_N" ;
lin dilatoriness_N = mkTerm "dilatoriness_N" ;
lin dilatory_A = mkTerm "dilatory_A" ;
lin dildo_N = mkTerm "dildo_N" ;
lin dilemma_N = mkTerm "dilemma_N" ;
lin dilettante_A = mkTerm "dilettante_A" ;
lin dilettante_N = mkTerm "dilettante_N" ;
lin diligence_N = mkTerm "diligence_N" ;
lin diligent_A = mkTerm "diligent_A" ;
lin dill_N = mkTerm "dill_N" ;
lin dillenia_N = mkTerm "dillenia_N" ;
lin dilly_dally_V = mkTerm "dilly_dally_V" ;
lin diltiazem_N = mkTerm "diltiazem_N" ;
lin dilutant_N = mkTerm "dilutant_N" ;
lin dilute_A = mkTerm "dilute_A" ;
lin dilute_V = mkTerm "dilute_V" ;
lin dilute_V2 = mkTerm "dilute_V2" ;
lin dilution_N = mkTerm "dilution_N" ;
lin diluvian_A = mkTerm "diluvian_A" ;
lin dim_A = mkTerm "dim_A" ;
lin dim_V = mkTerm "dim_V" ;
lin dim_V2 = mkTerm "dim_V2" ;
lin dime_N = mkTerm "dime_N" ;
lin dimenhydrinate_N = mkTerm "dimenhydrinate_N" ;
lin dimension_N = mkTerm "dimension_N" ;
lin dimensional_A = mkTerm "dimensional_A" ;
lin dimensionality_N = mkTerm "dimensionality_N" ;
lin dimensioning_A = mkTerm "dimensioning_A" ;
lin dimer_N = mkTerm "dimer_N" ;
lin dimethylglyoxime_N = mkTerm "dimethylglyoxime_N" ;
lin dimetrodon_N = mkTerm "dimetrodon_N" ;
lin diminish_V = mkTerm "diminish_V" ;
lin diminish_V2 = mkTerm "diminish_V2" ;
lin diminuendo_N = mkTerm "diminuendo_N" ;
lin diminution_N = mkTerm "diminution_N" ;
lin diminutive_A = mkTerm "diminutive_A" ;
lin diminutive_N = mkTerm "diminutive_N" ;
lin diminutiveness_N = mkTerm "diminutiveness_N" ;
lin dimity_N = mkTerm "dimity_N" ;
lin dimmer_N = mkTerm "dimmer_N" ;
lin dimness_N = mkTerm "dimness_N" ;
lin dimorphic_A = mkTerm "dimorphic_A" ;
lin dimorphism_N = mkTerm "dimorphism_N" ;
lin dimple_N = mkTerm "dimple_N" ;
lin dimple_V = mkTerm "dimple_V" ;
lin dimple_V2 = mkTerm "dimple_V2" ;
lin dimwit_N = mkTerm "dimwit_N" ;
lin din_N = mkTerm "din_N" ;
lin din_V = mkTerm "din_V" ;
lin din_V2 = mkTerm "din_V2" ;
lin dinar_N = mkTerm "dinar_N" ;
lin dine_V = mkTerm "dine_V" ;
lin dine_out_V = mkTerm "dine_out_V" ;
lin dine_out_on_V2 = mkTerm "dine_out_on_V2" ;
lin diner_N = mkTerm "diner_N" ;
lin dinette_N = mkTerm "dinette_N" ;
lin ding_N = mkTerm "ding_N" ;
lin ding_dong_Adv = mkTerm "ding_dong_Adv" ;
lin ding_dong_N = mkTerm "ding_dong_N" ;
lin dingbat_N = mkTerm "dingbat_N" ;
lin dingdong_Adv = mkTerm "dingdong_Adv" ;
lin dinghy_N = mkTerm "dinghy_N" ;
lin dinginess_N = mkTerm "dinginess_N" ;
lin dingle_N = mkTerm "dingle_N" ;
lin dingle_PN = mkTerm "dingle_PN" ;
lin dingo_N = mkTerm "dingo_N" ;
lin dingy_A = mkTerm "dingy_A" ;
lin dining_N = mkTerm "dining_N" ;
lin dining_car_N = mkTerm "dining_car_N" ;
lin dining_room_N = mkTerm "dining_room_N" ;
lin dining_table_N = mkTerm "dining_table_N" ;
lin dinky_A = mkTerm "dinky_A" ;
lin dinky_N = mkTerm "dinky_N" ;
lin dinner_N = mkTerm "dinner_N" ;
lin dinner_jacket_N = mkTerm "dinner_jacket_N" ;
lin dinner_party_N = mkTerm "dinner_party_N" ;
lin dinner_service_N = mkTerm "dinner_service_N" ;
lin dinner_set_N = mkTerm "dinner_set_N" ;
lin dinnertime_N = mkTerm "dinnertime_N" ;
lin dinnerware_N = mkTerm "dinnerware_N" ;
lin dinnington_PN = mkTerm "dinnington_PN" ;
lin dinoceras_N = mkTerm "dinoceras_N" ;
lin dinocerate_N = mkTerm "dinocerate_N" ;
lin dinoflagellate_N = mkTerm "dinoflagellate_N" ;
lin dinosaur_N = mkTerm "dinosaur_N" ;
lin dint_N = mkTerm "dint_N" ;
lin diocesan_A = mkTerm "diocesan_A" ;
lin diocesan_N = mkTerm "diocesan_N" ;
lin diocese_N = mkTerm "diocese_N" ;
lin diode_N = mkTerm "diode_N" ;
lin dioecious_A = mkTerm "dioecious_A" ;
lin diol_N = mkTerm "diol_N" ;
lin dioon_N = mkTerm "dioon_N" ;
lin diopter_N = mkTerm "diopter_N" ;
lin diorite_N = mkTerm "diorite_N" ;
lin dioxide_N = mkTerm "dioxide_N" ;
lin dioxin_N = mkTerm "dioxin_N" ;
lin dip_N = mkTerm "dip_N" ;
lin dip_V = mkTerm "dip_V" ;
lin dip_V2 = mkTerm "dip_V2" ;
lin dip_ed_N = mkTerm "dip_ed_N" ;
lin dip_in_V2 = mkTerm "dip_in_V2" ;
lin dip_into_V2 = mkTerm "dip_into_V2" ;
lin dip_out_V = mkTerm "dip_out_V" ;
lin diphenhydramine_N = mkTerm "diphenhydramine_N" ;
lin diphenylhydantoin_N = mkTerm "diphenylhydantoin_N" ;
lin diphtheria_N = mkTerm "diphtheria_N" ;
lin diphthong_N = mkTerm "diphthong_N" ;
lin diplegia_N = mkTerm "diplegia_N" ;
lin diplococcus_N = mkTerm "diplococcus_N" ;
lin diplodocus_N = mkTerm "diplodocus_N" ;
lin diploid_A = mkTerm "diploid_A" ;
lin diploid_N = mkTerm "diploid_N" ;
lin diploidy_N = mkTerm "diploidy_N" ;
lin diploma_N = mkTerm "diploma_N" ;
lin diplomacy_N = mkTerm "diplomacy_N" ;
lin diplomat_N = mkTerm "diplomat_N" ;
lin diplomate_N = mkTerm "diplomate_N" ;
lin diplomatic_A = mkTerm "diplomatic_A" ;
lin diplomatist_N = mkTerm "diplomatist_N" ;
lin diplopia_N = mkTerm "diplopia_N" ;
lin diplotene_N = mkTerm "diplotene_N" ;
lin dipolar_A = mkTerm "dipolar_A" ;
lin dipole_N = mkTerm "dipole_N" ;
lin dipper_N = mkTerm "dipper_N" ;
lin dipsomania_N = mkTerm "dipsomania_N" ;
lin dipsomaniac_N = mkTerm "dipsomaniac_N" ;
lin dipstick_N = mkTerm "dipstick_N" ;
lin dipterocarp_N = mkTerm "dipterocarp_N" ;
lin dipterous_A = mkTerm "dipterous_A" ;
lin diptych_N = mkTerm "diptych_N" ;
lin dir_N = mkTerm "dir_N" ;
lin dire_A = mkTerm "dire_A" ;
lin direct_A = mkTerm "direct_A" ;
lin direct_Adv = mkTerm "direct_Adv" ;
lin direct_V = mkTerm "direct_V" ;
lin direct_V2 = mkTerm "direct_V2" ;
lin direction_N = mkTerm "direction_N" ;
lin direction_finder_N = mkTerm "direction_finder_N" ;
lin directional_A = mkTerm "directional_A" ;
lin directionality_N = mkTerm "directionality_N" ;
lin directive_N = mkTerm "directive_N" ;
lin directivity_N = mkTerm "directivity_N" ;
lin directness_N = mkTerm "directness_N" ;
lin director_N = mkTerm "director_N" ;
lin directorate_N = mkTerm "directorate_N" ;
lin directorship_N = mkTerm "directorship_N" ;
lin directory_N = mkTerm "directory_N" ;
lin direful_A = mkTerm "direful_A" ;
lin dirge_N = mkTerm "dirge_N" ;
lin dirigible_N = mkTerm "dirigible_N" ;
lin dirk_N = mkTerm "dirk_N" ;
lin dirndl_N = mkTerm "dirndl_N" ;
lin dirt_A = mkTerm "dirt_A" ;
lin dirt_N = mkTerm "dirt_N" ;
lin dirt_cheap_A = mkTerm "dirt_cheap_A" ;
lin dirt_track_N = mkTerm "dirt_track_N" ;
lin dirtiness_N = mkTerm "dirtiness_N" ;
lin dirty_A = mkTerm "dirty_A" ;
lin dirty_V = mkTerm "dirty_V" ;
lin dirty_V2 = mkTerm "dirty_V2" ;
lin disa_N = mkTerm "disa_N" ;
lin disability_N = mkTerm "disability_N" ;
lin disable_V2 = mkTerm "disable_V2" ;
lin disabled_A = mkTerm "disabled_A" ;
lin disabled_N = mkTerm "disabled_N" ;
lin disablement_N = mkTerm "disablement_N" ;
lin disabling_A = mkTerm "disabling_A" ;
lin disabuse_V2 = mkTerm "disabuse_V2" ;
lin disaccharidase_N = mkTerm "disaccharidase_N" ;
lin disaccharide_N = mkTerm "disaccharide_N" ;
lin disadvantage_N = mkTerm "disadvantage_N" ;
lin disadvantageous_A = mkTerm "disadvantageous_A" ;
lin disaffected_A = mkTerm "disaffected_A" ;
lin disaffection_N = mkTerm "disaffection_N" ;
lin disafforest_V2 = mkTerm "disafforest_V2" ;
lin disagree_V = mkTerm "disagree_V" ;
lin disagree_V2 = mkTerm "disagree_V2" ;
lin disagree_VS = mkTerm "disagree_VS" ;
lin disagree_with_V2 = mkTerm "disagree_with_V2" ;
lin disagreeable_A = mkTerm "disagreeable_A" ;
lin disagreeableness_N = mkTerm "disagreeableness_N" ;
lin disagreement_N = mkTerm "disagreement_N" ;
lin disallow_V2 = mkTerm "disallow_V2" ;
lin disambiguation_N = mkTerm "disambiguation_N" ;
lin disambiguator_N = mkTerm "disambiguator_N" ;
lin disappear_V = mkTerm "disappear_V" ;
lin disappearance_N = mkTerm "disappearance_N" ;
lin disappoint_V2 = mkTerm "disappoint_V2" ;
lin disappointedly_Adv = mkTerm "disappointedly_Adv" ;
lin disappointing_A = mkTerm "disappointing_A" ;
lin disappointment_N = mkTerm "disappointment_N" ;
lin disapprobation_N = mkTerm "disapprobation_N" ;
lin disapproval_N = mkTerm "disapproval_N" ;
lin disapprove_V = mkTerm "disapprove_V" ;
lin disapprove_V2 = mkTerm "disapprove_V2" ;
lin disapprovingly_Adv = mkTerm "disapprovingly_Adv" ;
lin disarm_V = mkTerm "disarm_V" ;
lin disarm_V2 = mkTerm "disarm_V2" ;
lin disarmament_N = mkTerm "disarmament_N" ;
lin disarming_N = mkTerm "disarming_N" ;
lin disarrange_V2 = mkTerm "disarrange_V2" ;
lin disarrangement_N = mkTerm "disarrangement_N" ;
lin disarray_N = mkTerm "disarray_N" ;
lin disarray_V2 = mkTerm "disarray_V2" ;
lin disassociate_V2 = mkTerm "disassociate_V2" ;
lin disassociation_N = mkTerm "disassociation_N" ;
lin disaster_N = mkTerm "disaster_N" ;
lin disastrous_A = mkTerm "disastrous_A" ;
lin disavow_V2 = mkTerm "disavow_V2" ;
lin disavowable_A = mkTerm "disavowable_A" ;
lin disavowal_N = mkTerm "disavowal_N" ;
lin disband_V = mkTerm "disband_V" ;
lin disband_V2 = mkTerm "disband_V2" ;
lin disbandment_N = mkTerm "disbandment_N" ;
lin disbarment_N = mkTerm "disbarment_N" ;
lin disbelief_N = mkTerm "disbelief_N" ;
lin disbelieve_V = mkTerm "disbelieve_V" ;
lin disbelieve_V2 = mkTerm "disbelieve_V2" ;
lin disbeliever_N = mkTerm "disbeliever_N" ;
lin disbelievingly_Adv = mkTerm "disbelievingly_Adv" ;
lin disbud_V2 = mkTerm "disbud_V2" ;
lin disburden_V2 = mkTerm "disburden_V2" ;
lin disburse_V = mkTerm "disburse_V" ;
lin disburse_V2 = mkTerm "disburse_V2" ;
lin disbursement_N = mkTerm "disbursement_N" ;
lin disc_N = mkTerm "disc_N" ;
lin discalced_A = mkTerm "discalced_A" ;
lin discard_N = mkTerm "discard_N" ;
lin discard_V2 = mkTerm "discard_V2" ;
lin discern_V2 = mkTerm "discern_V2" ;
lin discernability_N = mkTerm "discernability_N" ;
lin discernible_A = mkTerm "discernible_A" ;
lin discerning_A = mkTerm "discerning_A" ;
lin discernment_N = mkTerm "discernment_N" ;
lin discharge_N = mkTerm "discharge_N" ;
lin discharge_V = mkTerm "discharge_V" ;
lin discharge_V2 = mkTerm "discharge_V2" ;
lin disciform_A = mkTerm "disciform_A" ;
lin discina_N = mkTerm "discina_N" ;
lin disciple_N = mkTerm "disciple_N" ;
lin discipleship_N = mkTerm "discipleship_N" ;
lin disciplinarian_N = mkTerm "disciplinarian_N" ;
lin disciplinary_A = mkTerm "disciplinary_A" ;
lin discipline_N = mkTerm "discipline_N" ;
lin discipline_V2 = mkTerm "discipline_V2" ;
lin disclaim_V2 = mkTerm "disclaim_V2" ;
lin disclaimer_N = mkTerm "disclaimer_N" ;
lin disclose_V = mkTerm "disclose_V" ;
lin disclose_V2 = mkTerm "disclose_V2" ;
lin disclose_VS = mkTerm "disclose_VS" ;
lin disclosure_N = mkTerm "disclosure_N" ;
lin disco_1_N = mkTerm "disco_1_N" ;
lin disco_2_N = mkTerm "disco_2_N" ;
lin discography_N = mkTerm "discography_N" ;
lin discoid_A = mkTerm "discoid_A" ;
lin discoloration_N = mkTerm "discoloration_N" ;
lin discolour_V = mkTerm "discolour_V" ;
lin discolour_V2 = mkTerm "discolour_V2" ;
lin discolouration_N = mkTerm "discolouration_N" ;
lin discombobulated_A = mkTerm "discombobulated_A" ;
lin discomfit_V2 = mkTerm "discomfit_V2" ;
lin discomfiture_N = mkTerm "discomfiture_N" ;
lin discomfort_N = mkTerm "discomfort_N" ;
lin discommode_V2 = mkTerm "discommode_V2" ;
lin discompose_V2 = mkTerm "discompose_V2" ;
lin discomposure_N = mkTerm "discomposure_N" ;
lin discomycete_N = mkTerm "discomycete_N" ;
lin discomycetous_A = mkTerm "discomycetous_A" ;
lin disconcert_V2 = mkTerm "disconcert_V2" ;
lin disconcerting_A = mkTerm "disconcerting_A" ;
lin disconfirming_A = mkTerm "disconfirming_A" ;
lin disconnect_V2 = mkTerm "disconnect_V2" ;
lin disconnection_N = mkTerm "disconnection_N" ;
lin disconsolate_A = mkTerm "disconsolate_A" ;
lin discontent_N = mkTerm "discontent_N" ;
lin discontent_V2 = mkTerm "discontent_V2" ;
lin discontentedly_Adv = mkTerm "discontentedly_Adv" ;
lin discontentment_N = mkTerm "discontentment_N" ;
lin discontinuance_N = mkTerm "discontinuance_N" ;
lin discontinue_V = mkTerm "discontinue_V" ;
lin discontinue_V2 = mkTerm "discontinue_V2" ;
lin discontinuity_N = mkTerm "discontinuity_N" ;
lin discontinuous_A = mkTerm "discontinuous_A" ;
lin discord_N = mkTerm "discord_N" ;
lin discordance_N = mkTerm "discordance_N" ;
lin discordant_A = mkTerm "discordant_A" ;
lin discorporate_A = mkTerm "discorporate_A" ;
lin discotheque_N = mkTerm "discotheque_N" ;
lin discount_N = mkTerm "discount_N" ;
lin discount_V = mkTerm "discount_V" ;
lin discount_V2 = mkTerm "discount_V2" ;
lin discountenance_V2 = mkTerm "discountenance_V2" ;
lin discourage_V2 = mkTerm "discourage_V2" ;
lin discouragement_N = mkTerm "discouragement_N" ;
lin discouraging_A = mkTerm "discouraging_A" ;
lin discourse_N = mkTerm "discourse_N" ;
lin discourse_V = mkTerm "discourse_V" ;
lin discourteous_A = mkTerm "discourteous_A" ;
lin discourtesy_N = mkTerm "discourtesy_N" ;
lin discover_V = mkTerm "discover_V" ;
lin discover_V2 = mkTerm "discover_V2" ;
lin discover_VS = mkTerm "discover_VS" ;
lin discovererFem_N = mkTerm "discovererFem_N" ;
lin discovererMasc_N = mkTerm "discovererMasc_N" ;
lin discovery_N = mkTerm "discovery_N" ;
lin discredit_N = mkTerm "discredit_N" ;
lin discredit_V2 = mkTerm "discredit_V2" ;
lin discreditable_A = mkTerm "discreditable_A" ;
lin discreet_A = mkTerm "discreet_A" ;
lin discrepancy_N = mkTerm "discrepancy_N" ;
lin discrepant_A = mkTerm "discrepant_A" ;
lin discrete_A = mkTerm "discrete_A" ;
lin discreteness_N = mkTerm "discreteness_N" ;
lin discretion_N = mkTerm "discretion_N" ;
lin discretionary_A = mkTerm "discretionary_A" ;
lin discriminable_A = mkTerm "discriminable_A" ;
lin discriminate_A = mkTerm "discriminate_A" ;
lin discriminate_V = mkTerm "discriminate_V" ;
lin discriminate_V2 = mkTerm "discriminate_V2" ;
lin discrimination_N = mkTerm "discrimination_N" ;
lin discriminative_A = mkTerm "discriminative_A" ;
lin discriminatory_A = mkTerm "discriminatory_A" ;
lin discursive_A = mkTerm "discursive_A" ;
lin discursiveness_N = mkTerm "discursiveness_N" ;
lin discus_N = mkTerm "discus_N" ;
lin discuss_V2 = mkTerm "discuss_V2" ;
lin discuss_VS = mkTerm "discuss_VS" ;
lin discussant_N = mkTerm "discussant_N" ;
lin discussion_N = mkTerm "discussion_N" ;
lin disdain_N = mkTerm "disdain_N" ;
lin disdain_V2 = mkTerm "disdain_V2" ;
lin disdainful_A = mkTerm "disdainful_A" ;
lin disease_N = mkTerm "disease_N" ;
lin diseased_A = mkTerm "diseased_A" ;
lin disembark_V = mkTerm "disembark_V" ;
lin disembark_V2 = mkTerm "disembark_V2" ;
lin disembarkation_N = mkTerm "disembarkation_N" ;
lin disembarrass_V2 = mkTerm "disembarrass_V2" ;
lin disembarrassment_N = mkTerm "disembarrassment_N" ;
lin disembody_V2 = mkTerm "disembody_V2" ;
lin disembowel_V2 = mkTerm "disembowel_V2" ;
lin disembowelment_N = mkTerm "disembowelment_N" ;
lin disenchant_V2 = mkTerm "disenchant_V2" ;
lin disenchanting_A = mkTerm "disenchanting_A" ;
lin disenchantment_N = mkTerm "disenchantment_N" ;
lin disencumber_V2 = mkTerm "disencumber_V2" ;
lin disenfranchise_V2 = mkTerm "disenfranchise_V2" ;
lin disenfranchisement_N = mkTerm "disenfranchisement_N" ;
lin disengage_V = mkTerm "disengage_V" ;
lin disengage_V2 = mkTerm "disengage_V2" ;
lin disengagement_N = mkTerm "disengagement_N" ;
lin disentangle_V = mkTerm "disentangle_V" ;
lin disentangle_V2 = mkTerm "disentangle_V2" ;
lin disentanglement_N = mkTerm "disentanglement_N" ;
lin disentangler_N = mkTerm "disentangler_N" ;
lin disequilibrium_N = mkTerm "disequilibrium_N" ;
lin disestablish_V2 = mkTerm "disestablish_V2" ;
lin disestablishment_N = mkTerm "disestablishment_N" ;
lin disesteem_N = mkTerm "disesteem_N" ;
lin disfavor_N = mkTerm "disfavor_N" ;
lin disfavour_N = mkTerm "disfavour_N" ;
lin disfavour_V2 = mkTerm "disfavour_V2" ;
lin disfigure_V2 = mkTerm "disfigure_V2" ;
lin disfigurement_N = mkTerm "disfigurement_N" ;
lin disfluency_N = mkTerm "disfluency_N" ;
lin disforest_V2 = mkTerm "disforest_V2" ;
lin disfranchise_V2 = mkTerm "disfranchise_V2" ;
lin disfranchisement_N = mkTerm "disfranchisement_N" ;
lin disgorge_V2 = mkTerm "disgorge_V2" ;
lin disgrace_N = mkTerm "disgrace_N" ;
lin disgrace_V2 = mkTerm "disgrace_V2" ;
lin disgraceful_A = mkTerm "disgraceful_A" ;
lin disgruntled_A = mkTerm "disgruntled_A" ;
lin disgruntlement_N = mkTerm "disgruntlement_N" ;
lin disguise_N = mkTerm "disguise_N" ;
lin disguise_V2 = mkTerm "disguise_V2" ;
lin disgust_N = mkTerm "disgust_N" ;
lin disgust_V2 = mkTerm "disgust_V2" ;
lin disgustedly_Adv = mkTerm "disgustedly_Adv" ;
lin disgusting_A = mkTerm "disgusting_A" ;
lin disgustingness_N = mkTerm "disgustingness_N" ;
lin dish_N = mkTerm "dish_N" ;
lin dish_V2 = mkTerm "dish_V2" ;
lin dish_out_V2 = mkTerm "dish_out_V2" ;
lin dish_up_V2 = mkTerm "dish_up_V2" ;
lin dishabille_N = mkTerm "dishabille_N" ;
lin disharmonious_A = mkTerm "disharmonious_A" ;
lin disharmony_N = mkTerm "disharmony_N" ;
lin dishcloth_N = mkTerm "dishcloth_N" ;
lin dishearten_V2 = mkTerm "dishearten_V2" ;
lin disheartenment_N = mkTerm "disheartenment_N" ;
lin disheveled_A = mkTerm "disheveled_A" ;
lin dishevelled_A = mkTerm "dishevelled_A" ;
lin dishful_N = mkTerm "dishful_N" ;
lin dishonest_A = mkTerm "dishonest_A" ;
lin dishonesty_N = mkTerm "dishonesty_N" ;
lin dishonorable_A = mkTerm "dishonorable_A" ;
lin dishonorableness_N = mkTerm "dishonorableness_N" ;
lin dishonour_N = mkTerm "dishonour_N" ;
lin dishonour_V2 = mkTerm "dishonour_V2" ;
lin dishonourable_A = mkTerm "dishonourable_A" ;
lin dishpan_N = mkTerm "dishpan_N" ;
lin dishrag_N = mkTerm "dishrag_N" ;
lin dishtowel_N = mkTerm "dishtowel_N" ;
lin dishwasher_N = mkTerm "dishwasher_N" ;
lin dishwashing_N = mkTerm "dishwashing_N" ;
lin dishwater_N = mkTerm "dishwater_N" ;
lin dishy_A = mkTerm "dishy_A" ;
lin disillusion_N = mkTerm "disillusion_N" ;
lin disillusion_V2 = mkTerm "disillusion_V2" ;
lin disillusionment_N = mkTerm "disillusionment_N" ;
lin disincentive_N = mkTerm "disincentive_N" ;
lin disinclination_N = mkTerm "disinclination_N" ;
lin disincline_V2 = mkTerm "disincline_V2" ;
lin disincline_V2V = mkTerm "disincline_V2V" ;
lin disinfect_V2 = mkTerm "disinfect_V2" ;
lin disinfectant_A = mkTerm "disinfectant_A" ;
lin disinfectant_N = mkTerm "disinfectant_N" ;
lin disinfection_N = mkTerm "disinfection_N" ;
lin disinfest_V2 = mkTerm "disinfest_V2" ;
lin disinfestation_N = mkTerm "disinfestation_N" ;
lin disinflation_N = mkTerm "disinflation_N" ;
lin disinformation_N = mkTerm "disinformation_N" ;
lin disingenuous_A = mkTerm "disingenuous_A" ;
lin disingenuousness_N = mkTerm "disingenuousness_N" ;
lin disinherit_V2 = mkTerm "disinherit_V2" ;
lin disinheritance_N = mkTerm "disinheritance_N" ;
lin disintegrate_V = mkTerm "disintegrate_V" ;
lin disintegrate_V2 = mkTerm "disintegrate_V2" ;
lin disintegration_N = mkTerm "disintegration_N" ;
lin disintegrative_A = mkTerm "disintegrative_A" ;
lin disinter_V2 = mkTerm "disinter_V2" ;
lin disinterest_N = mkTerm "disinterest_N" ;
lin disinterested_A = mkTerm "disinterested_A" ;
lin disinterestedness_N = mkTerm "disinterestedness_N" ;
lin disinterment_N = mkTerm "disinterment_N" ;
lin disinvestment_N = mkTerm "disinvestment_N" ;
lin disjoined_A = mkTerm "disjoined_A" ;
lin disjoint_A = mkTerm "disjoint_A" ;
lin disjoint_V2 = mkTerm "disjoint_V2" ;
lin disjointedly_Adv = mkTerm "disjointedly_Adv" ;
lin disjointedness_N = mkTerm "disjointedness_N" ;
lin disjunct_A = mkTerm "disjunct_A" ;
lin disjunction_N = mkTerm "disjunction_N" ;
lin disjunctive_A = mkTerm "disjunctive_A" ;
lin disk_N = mkTerm "disk_N" ;
lin diskette_N = mkTerm "diskette_N" ;
lin dislikable_A = mkTerm "dislikable_A" ;
lin dislike_N = mkTerm "dislike_N" ;
lin dislike_V2 = mkTerm "dislike_V2" ;
lin dislocate_V2 = mkTerm "dislocate_V2" ;
lin dislocation_N = mkTerm "dislocation_N" ;
lin dislodge_V2 = mkTerm "dislodge_V2" ;
lin dislodgement_N = mkTerm "dislodgement_N" ;
lin dislodgment_N = mkTerm "dislodgment_N" ;
lin disloyal_A = mkTerm "disloyal_A" ;
lin disloyalty_N = mkTerm "disloyalty_N" ;
lin dismal_A = mkTerm "dismal_A" ;
lin dismantle_V2 = mkTerm "dismantle_V2" ;
lin dismantlement_N = mkTerm "dismantlement_N" ;
lin dismantling_N = mkTerm "dismantling_N" ;
lin dismay_N = mkTerm "dismay_N" ;
lin dismay_V = mkTerm "dismay_V" ;
lin dismay_V2 = mkTerm "dismay_V2" ;
lin dismember_V2 = mkTerm "dismember_V2" ;
lin dismemberment_N = mkTerm "dismemberment_N" ;
lin dismiss_V2 = mkTerm "dismiss_V2" ;
lin dismissal_N = mkTerm "dismissal_N" ;
lin dismissible_A = mkTerm "dismissible_A" ;
lin dismissive_A = mkTerm "dismissive_A" ;
lin dismount_N = mkTerm "dismount_N" ;
lin dismount_V = mkTerm "dismount_V" ;
lin dismount_V2 = mkTerm "dismount_V2" ;
lin disobedience_N = mkTerm "disobedience_N" ;
lin disobedient_A = mkTerm "disobedient_A" ;
lin disobey_V2 = mkTerm "disobey_V2" ;
lin disoblige_V2 = mkTerm "disoblige_V2" ;
lin disobliging_A = mkTerm "disobliging_A" ;
lin disorder_N = mkTerm "disorder_N" ;
lin disorder_V2 = mkTerm "disorder_V2" ;
lin disorderliness_N = mkTerm "disorderliness_N" ;
lin disorderly_A = mkTerm "disorderly_A" ;
lin disorganization_N = mkTerm "disorganization_N" ;
lin disorganize_V2 = mkTerm "disorganize_V2" ;
lin disorient_V2 = mkTerm "disorient_V2" ;
lin disorientate_V2 = mkTerm "disorientate_V2" ;
lin disorientation_N = mkTerm "disorientation_N" ;
lin disorienting_A = mkTerm "disorienting_A" ;
lin disown_V2 = mkTerm "disown_V2" ;
lin disownment_N = mkTerm "disownment_N" ;
lin disparage_V2 = mkTerm "disparage_V2" ;
lin disparagement_N = mkTerm "disparagement_N" ;
lin disparagingly_Adv = mkTerm "disparagingly_Adv" ;
lin disparate_A = mkTerm "disparate_A" ;
lin disparateness_N = mkTerm "disparateness_N" ;
lin disparity_N = mkTerm "disparity_N" ;
lin dispassion_N = mkTerm "dispassion_N" ;
lin dispassionate_A = mkTerm "dispassionate_A" ;
lin dispassionateness_N = mkTerm "dispassionateness_N" ;
lin dispatch_N = mkTerm "dispatch_N" ;
lin dispatch_V2 = mkTerm "dispatch_V2" ;
lin dispatch_V2V = mkTerm "dispatch_V2V" ;
lin dispatch_box_N = mkTerm "dispatch_box_N" ;
lin dispatch_rider_N = mkTerm "dispatch_rider_N" ;
lin dispatcher_N = mkTerm "dispatcher_N" ;
lin dispel_V2 = mkTerm "dispel_V2" ;
lin dispensability_N = mkTerm "dispensability_N" ;
lin dispensable_A = mkTerm "dispensable_A" ;
lin dispensary_N = mkTerm "dispensary_N" ;
lin dispensation_N = mkTerm "dispensation_N" ;
lin dispense_V = mkTerm "dispense_V" ;
lin dispense_V2 = mkTerm "dispense_V2" ;
lin dispenser_N = mkTerm "dispenser_N" ;
lin dispersal_N = mkTerm "dispersal_N" ;
lin disperse_V = mkTerm "disperse_V" ;
lin disperse_V2 = mkTerm "disperse_V2" ;
lin dispersion_N = mkTerm "dispersion_N" ;
lin dispirit_V2 = mkTerm "dispirit_V2" ;
lin dispiritedly_Adv = mkTerm "dispiritedly_Adv" ;
lin displace_V2 = mkTerm "displace_V2" ;
lin displacement_N = mkTerm "displacement_N" ;
lin display_N = mkTerm "display_N" ;
lin display_V2 = mkTerm "display_V2" ;
lin display_VS = mkTerm "display_VS" ;
lin displease_V2 = mkTerm "displease_V2" ;
lin displeasing_A = mkTerm "displeasing_A" ;
lin displeasure_N = mkTerm "displeasure_N" ;
lin disport_V2 = mkTerm "disport_V2" ;
lin disposable_A = mkTerm "disposable_A" ;
lin disposable_N = mkTerm "disposable_N" ;
lin disposal_N = mkTerm "disposal_N" ;
lin dispose_V = mkTerm "dispose_V" ;
lin dispose_V2 = mkTerm "dispose_V2" ;
lin disposition_N = mkTerm "disposition_N" ;
lin dispossess_V2 = mkTerm "dispossess_V2" ;
lin dispossession_N = mkTerm "dispossession_N" ;
lin disproof_N = mkTerm "disproof_N" ;
lin disproportion_N = mkTerm "disproportion_N" ;
lin disproportionate_A = mkTerm "disproportionate_A" ;
lin disprove_V2 = mkTerm "disprove_V2" ;
lin disprove_VS = mkTerm "disprove_VS" ;
lin disputable_A = mkTerm "disputable_A" ;
lin disputant_N = mkTerm "disputant_N" ;
lin disputation_N = mkTerm "disputation_N" ;
lin disputatious_A = mkTerm "disputatious_A" ;
lin dispute_N = mkTerm "dispute_N" ;
lin dispute_V = mkTerm "dispute_V" ;
lin dispute_V2 = mkTerm "dispute_V2" ;
lin disqualification_N = mkTerm "disqualification_N" ;
lin disqualify_V2 = mkTerm "disqualify_V2" ;
lin disquiet_N = mkTerm "disquiet_N" ;
lin disquiet_V2 = mkTerm "disquiet_V2" ;
lin disquieting_A = mkTerm "disquieting_A" ;
lin disquietude_N = mkTerm "disquietude_N" ;
lin disquisition_N = mkTerm "disquisition_N" ;
lin disregard_N = mkTerm "disregard_N" ;
lin disregard_V2 = mkTerm "disregard_V2" ;
lin disrepair_N = mkTerm "disrepair_N" ;
lin disreputable_A = mkTerm "disreputable_A" ;
lin disrepute_N = mkTerm "disrepute_N" ;
lin disrespect_N = mkTerm "disrespect_N" ;
lin disrespectful_A = mkTerm "disrespectful_A" ;
lin disrobe_V = mkTerm "disrobe_V" ;
lin disrobe_V2 = mkTerm "disrobe_V2" ;
lin disrupt_V = mkTerm "disrupt_V" ;
lin disrupt_V2 = mkTerm "disrupt_V2" ;
lin disruption_N = mkTerm "disruption_N" ;
lin disruptive_A = mkTerm "disruptive_A" ;
lin dissatisfaction_N = mkTerm "dissatisfaction_N" ;
lin dissatisfy_V2 = mkTerm "dissatisfy_V2" ;
lin dissect_V2 = mkTerm "dissect_V2" ;
lin dissection_N = mkTerm "dissection_N" ;
lin dissemble_V = mkTerm "dissemble_V" ;
lin dissemble_V2 = mkTerm "dissemble_V2" ;
lin dissembler_N = mkTerm "dissembler_N" ;
lin disseminate_V = mkTerm "disseminate_V" ;
lin disseminate_V2 = mkTerm "disseminate_V2" ;
lin dissemination_N = mkTerm "dissemination_N" ;
lin dissension_N = mkTerm "dissension_N" ;
lin dissent_N = mkTerm "dissent_N" ;
lin dissent_V = mkTerm "dissent_V" ;
lin dissenter_N = mkTerm "dissenter_N" ;
lin dissentient_A = mkTerm "dissentient_A" ;
lin dissentious_A = mkTerm "dissentious_A" ;
lin dissertation_N = mkTerm "dissertation_N" ;
lin disservice_N = mkTerm "disservice_N" ;
lin dissever_V2 = mkTerm "dissever_V2" ;
lin dissidence_N = mkTerm "dissidence_N" ;
lin dissident_A = mkTerm "dissident_A" ;
lin dissident_N = mkTerm "dissident_N" ;
lin dissilience_N = mkTerm "dissilience_N" ;
lin dissilient_A = mkTerm "dissilient_A" ;
lin dissimilar_A = mkTerm "dissimilar_A" ;
lin dissimilarity_N = mkTerm "dissimilarity_N" ;
lin dissimilation_N = mkTerm "dissimilation_N" ;
lin dissimilitude_N = mkTerm "dissimilitude_N" ;
lin dissimulate_V = mkTerm "dissimulate_V" ;
lin dissimulate_V2 = mkTerm "dissimulate_V2" ;
lin dissimulation_N = mkTerm "dissimulation_N" ;
lin dissimulative_A = mkTerm "dissimulative_A" ;
lin dissipate_V = mkTerm "dissipate_V" ;
lin dissipate_V2 = mkTerm "dissipate_V2" ;
lin dissipation_N = mkTerm "dissipation_N" ;
lin dissociable_A = mkTerm "dissociable_A" ;
lin dissociate_V2 = mkTerm "dissociate_V2" ;
lin dissociation_N = mkTerm "dissociation_N" ;
lin dissociative_A = mkTerm "dissociative_A" ;
lin dissolubility_N = mkTerm "dissolubility_N" ;
lin dissoluble_A = mkTerm "dissoluble_A" ;
lin dissolute_A = mkTerm "dissolute_A" ;
lin dissoluteness_N = mkTerm "dissoluteness_N" ;
lin dissolution_N = mkTerm "dissolution_N" ;
lin dissolvable_A = mkTerm "dissolvable_A" ;
lin dissolve_N = mkTerm "dissolve_N" ;
lin dissolve_V = mkTerm "dissolve_V" ;
lin dissolve_V2 = mkTerm "dissolve_V2" ;
lin dissolving_N = mkTerm "dissolving_N" ;
lin dissonance_N = mkTerm "dissonance_N" ;
lin dissonant_A = mkTerm "dissonant_A" ;
lin dissuade_V2 = mkTerm "dissuade_V2" ;
lin dissuasion_N = mkTerm "dissuasion_N" ;
lin dissuasive_A = mkTerm "dissuasive_A" ;
lin dissyllable_N = mkTerm "dissyllable_N" ;
lin distaff_N = mkTerm "distaff_N" ;
lin distal_A = mkTerm "distal_A" ;
lin distance_N = mkTerm "distance_N" ;
lin distance_V2 = mkTerm "distance_V2" ;
lin distant_A = mkTerm "distant_A" ;
lin distaste_N = mkTerm "distaste_N" ;
lin distasteful_A = mkTerm "distasteful_A" ;
lin distastefulness_N = mkTerm "distastefulness_N" ;
lin distemper_N = mkTerm "distemper_N" ;
lin distemper_V2 = mkTerm "distemper_V2" ;
lin distend_V = mkTerm "distend_V" ;
lin distend_V2 = mkTerm "distend_V2" ;
lin distensible_A = mkTerm "distensible_A" ;
lin distension_N = mkTerm "distension_N" ;
lin distention_N = mkTerm "distention_N" ;
lin distil_V = mkTerm "distil_V" ;
lin distil_V2 = mkTerm "distil_V2" ;
lin distillate_N = mkTerm "distillate_N" ;
lin distillation_N = mkTerm "distillation_N" ;
lin distiller_N = mkTerm "distiller_N" ;
lin distillery_N = mkTerm "distillery_N" ;
lin distinct_A = mkTerm "distinct_A" ;
lin distinction_N = mkTerm "distinction_N" ;
lin distinctive_A = mkTerm "distinctive_A" ;
lin distinctiveness_N = mkTerm "distinctiveness_N" ;
lin distinctness_N = mkTerm "distinctness_N" ;
lin distinguish_V = mkTerm "distinguish_V" ;
lin distinguish_V2 = mkTerm "distinguish_V2" ;
lin distinguishable_A = mkTerm "distinguishable_A" ;
lin distinguished_A = mkTerm "distinguished_A" ;
lin distort_V2 = mkTerm "distort_V2" ;
lin distortable_A = mkTerm "distortable_A" ;
lin distortion_N = mkTerm "distortion_N" ;
lin distortionist_N = mkTerm "distortionist_N" ;
lin distract_V = mkTerm "distract_V" ;
lin distract_V2 = mkTerm "distract_V2" ;
lin distractedly_Adv = mkTerm "distractedly_Adv" ;
lin distraction_N = mkTerm "distraction_N" ;
lin distrain_V = mkTerm "distrain_V" ;
lin distraint_N = mkTerm "distraint_N" ;
lin distrait_A = mkTerm "distrait_A" ;
lin distraught_A = mkTerm "distraught_A" ;
lin distress_N = mkTerm "distress_N" ;
lin distress_V2 = mkTerm "distress_V2" ;
lin distressful_A = mkTerm "distressful_A" ;
lin distressing_A = mkTerm "distressing_A" ;
lin distributary_N = mkTerm "distributary_N" ;
lin distribute_V2 = mkTerm "distribute_V2" ;
lin distributed_A = mkTerm "distributed_A" ;
lin distribution_N = mkTerm "distribution_N" ;
lin distributional_A = mkTerm "distributional_A" ;
lin distributive_A = mkTerm "distributive_A" ;
lin distributor_N = mkTerm "distributor_N" ;
lin district_N = mkTerm "district_N" ;
lin distrust_N = mkTerm "distrust_N" ;
lin distrust_V2 = mkTerm "distrust_V2" ;
lin distrustful_A = mkTerm "distrustful_A" ;
lin distrustfulness_N = mkTerm "distrustfulness_N" ;
lin disturb_V2 = mkTerm "disturb_V2" ;
lin disturbance_N = mkTerm "disturbance_N" ;
lin disturber_N = mkTerm "disturber_N" ;
lin disturbing_A = mkTerm "disturbing_A" ;
lin disulfiram_N = mkTerm "disulfiram_N" ;
lin disunion_N = mkTerm "disunion_N" ;
lin disunite_V = mkTerm "disunite_V" ;
lin disunite_V2 = mkTerm "disunite_V2" ;
lin disunity_N = mkTerm "disunity_N" ;
lin disuse_N = mkTerm "disuse_N" ;
lin disused_A = mkTerm "disused_A" ;
lin disyllabic_A = mkTerm "disyllabic_A" ;
lin disyllable_N = mkTerm "disyllable_N" ;
lin dita_N = mkTerm "dita_N" ;
lin ditch_N = mkTerm "ditch_N" ;
lin ditch_V = mkTerm "ditch_V" ;
lin ditch_V2 = mkTerm "ditch_V2" ;
lin dither_N = mkTerm "dither_N" ;
lin dither_V = mkTerm "dither_V" ;
lin dithering_N = mkTerm "dithering_N" ;
lin dithyramb_N = mkTerm "dithyramb_N" ;
lin dithyrambic_A = mkTerm "dithyrambic_A" ;
lin ditto_N = mkTerm "ditto_N" ;
lin ditty_N = mkTerm "ditty_N" ;
lin diuresis_N = mkTerm "diuresis_N" ;
lin diurnal_A = mkTerm "diurnal_A" ;
lin diva_N = mkTerm "diva_N" ;
lin divagate_V = mkTerm "divagate_V" ;
lin divagation_N = mkTerm "divagation_N" ;
lin divan_N = mkTerm "divan_N" ;
lin divan_bed_N = mkTerm "divan_bed_N" ;
lin divarication_N = mkTerm "divarication_N" ;
lin dive_N = mkTerm "dive_N" ;
lin dive_V = mkTerm "dive_V" ;
lin dive_bomb_V = mkTerm "dive_bomb_V" ;
lin dive_bomb_V2 = mkTerm "dive_bomb_V2" ;
lin dive_bomber_N = mkTerm "dive_bomber_N" ;
lin dive_in_V = mkTerm "dive_in_V" ;
lin dive_into_V2 = mkTerm "dive_into_V2" ;
lin diver_N = mkTerm "diver_N" ;
lin diverge_V = mkTerm "diverge_V" ;
lin divergence_N = mkTerm "divergence_N" ;
lin divergency_N = mkTerm "divergency_N" ;
lin divergent_A = mkTerm "divergent_A" ;
lin divers_A = mkTerm "divers_A" ;
lin diverse_A = mkTerm "diverse_A" ;
lin diverseness_N = mkTerm "diverseness_N" ;
lin diversification_N = mkTerm "diversification_N" ;
lin diversify_V = mkTerm "diversify_V" ;
lin diversify_V2 = mkTerm "diversify_V2" ;
lin diversion_N = mkTerm "diversion_N" ;
lin diversionary_A = mkTerm "diversionary_A" ;
lin diversionist_N = mkTerm "diversionist_N" ;
lin diversity_N = mkTerm "diversity_N" ;
lin divert_V = mkTerm "divert_V" ;
lin diverticulitis_N = mkTerm "diverticulitis_N" ;
lin diverticulosis_N = mkTerm "diverticulosis_N" ;
lin diverticulum_N = mkTerm "diverticulum_N" ;
lin divertimento_N = mkTerm "divertimento_N" ;
lin dives_PN = mkTerm "dives_PN" ;
lin divest_V2 = mkTerm "divest_V2" ;
lin divestiture_N = mkTerm "divestiture_N" ;
lin dividable_A = mkTerm "dividable_A" ;
lin divide_N = mkTerm "divide_N" ;
lin divide_V = mkTerm "divide_V" ;
lin divide_V2 = mkTerm "divide_V2" ;
lin divide_up_V2 = mkTerm "divide_up_V2" ;
lin dividend_N = mkTerm "dividend_N" ;
lin dividend_warrant_N = mkTerm "dividend_warrant_N" ;
lin divider_N = mkTerm "divider_N" ;
lin divination_N = mkTerm "divination_N" ;
lin divinatory_A = mkTerm "divinatory_A" ;
lin divine_A = mkTerm "divine_A" ;
lin divine_N = mkTerm "divine_N" ;
lin divine_V = mkTerm "divine_V" ;
lin divine_V2 = mkTerm "divine_V2" ;
lin diviner_N = mkTerm "diviner_N" ;
lin diving_N = mkTerm "diving_N" ;
lin diving_bell_N = mkTerm "diving_bell_N" ;
lin diving_board_N = mkTerm "diving_board_N" ;
lin diving_dress_N = mkTerm "diving_dress_N" ;
lin diving_suit_N = mkTerm "diving_suit_N" ;
lin divinity_N = mkTerm "divinity_N" ;
lin divisibility_N = mkTerm "divisibility_N" ;
lin divisible_A = mkTerm "divisible_A" ;
lin division_1_N = mkTerm "division_1_N" ;
lin division_2_N = mkTerm "division_2_N" ;
lin division_3_N = mkTerm "division_3_N" ;
lin divisional_A = mkTerm "divisional_A" ;
lin divisor_N = mkTerm "divisor_N" ;
lin divorce_N = mkTerm "divorce_N" ;
lin divorce_V2 = mkTerm "divorce_V2" ;
lin divorcee_N = mkTerm "divorcee_N" ;
lin divot_N = mkTerm "divot_N" ;
lin divulge_V2 = mkTerm "divulge_V2" ;
lin divulgence_N = mkTerm "divulgence_N" ;
lin divvy_N = mkTerm "divvy_N" ;
lin divvy_out_V2 = mkTerm "divvy_out_V2" ;
lin divvy_up_V2 = mkTerm "divvy_up_V2" ;
lin dixie_N = mkTerm "dixie_N" ;
lin diy_N = mkTerm "diy_N" ;
lin dizygotic_A = mkTerm "dizygotic_A" ;
lin dizziness_N = mkTerm "dizziness_N" ;
lin dizzy_A = mkTerm "dizzy_A" ;
lin dizzy_V2 = mkTerm "dizzy_V2" ;
lin dj_N = mkTerm "dj_N" ;
lin djibouti_PN = mkTerm "djibouti_PN" ;
lin djiboutian_A = mkTerm "djiboutian_A" ;
lin djiboutian_N = mkTerm "djiboutian_N" ;
lin djinn_N = mkTerm "djinn_N" ;
lin djs_N = mkTerm "djs_N" ;
lin dlitt_N = mkTerm "dlitt_N" ;
lin dm_N = mkTerm "dm_N" ;
lin dna_N = mkTerm "dna_N" ;
lin dnepropetrovsk_PN = mkTerm "dnepropetrovsk_PN" ;
lin do_N = mkTerm "do_N" ;
lin do_V2 = mkTerm "do_V2" ;
lin do_gooder_N = mkTerm "do_gooder_N" ;
lin dob_in_V2 = mkTerm "dob_in_V2" ;
lin dobbin_N = mkTerm "dobbin_N" ;
lin dobra_N = mkTerm "dobra_N" ;
lin dobson_N = mkTerm "dobson_N" ;
lin docent_N = mkTerm "docent_N" ;
lin docile_A = mkTerm "docile_A" ;
lin docility_N = mkTerm "docility_N" ;
lin dock_N = mkTerm "dock_N" ;
lin dock_V = mkTerm "dock_V" ;
lin dock_V2 = mkTerm "dock_V2" ;
lin dockage_N = mkTerm "dockage_N" ;
lin docker_N = mkTerm "docker_N" ;
lin docket_N = mkTerm "docket_N" ;
lin docket_V2 = mkTerm "docket_V2" ;
lin docking_N = mkTerm "docking_N" ;
lin dockside_N = mkTerm "dockside_N" ;
lin dockyard_N = mkTerm "dockyard_N" ;
lin doctor_N = mkTerm "doctor_N" ;
lin doctor_V2 = mkTerm "doctor_V2" ;
lin doctoral_A = mkTerm "doctoral_A" ;
lin doctorate_N = mkTerm "doctorate_N" ;
lin doctorfish_N = mkTerm "doctorfish_N" ;
lin doctorspeak_N = mkTerm "doctorspeak_N" ;
lin doctrinaire_A = mkTerm "doctrinaire_A" ;
lin doctrinaire_N = mkTerm "doctrinaire_N" ;
lin doctrinal_A = mkTerm "doctrinal_A" ;
lin doctrine_N = mkTerm "doctrine_N" ;
lin document_N = mkTerm "document_N" ;
lin document_V2 = mkTerm "document_V2" ;
lin documentary_A = mkTerm "documentary_A" ;
lin documentary_N = mkTerm "documentary_N" ;
lin documentation_N = mkTerm "documentation_N" ;
lin dodder_N = mkTerm "dodder_N" ;
lin dodder_V = mkTerm "dodder_V" ;
lin dodderer_N = mkTerm "dodderer_N" ;
lin doddery_A = mkTerm "doddery_A" ;
lin doddle_N = mkTerm "doddle_N" ;
lin dodecagon_N = mkTerm "dodecagon_N" ;
lin dodecahedron_N = mkTerm "dodecahedron_N" ;
lin dodge_N = mkTerm "dodge_N" ;
lin dodge_V = mkTerm "dodge_V" ;
lin dodge_V2 = mkTerm "dodge_V2" ;
lin dodgem_N = mkTerm "dodgem_N" ;
lin dodger_N = mkTerm "dodger_N" ;
lin dodgy_A = mkTerm "dodgy_A" ;
lin dodo_N = mkTerm "dodo_N" ;
lin doe_N = mkTerm "doe_N" ;
lin doer_N = mkTerm "doer_N" ;
lin doeskin_N = mkTerm "doeskin_N" ;
lin doff_V2 = mkTerm "doff_V2" ;
lin dog's_tooth_N = mkTerm "dog's_tooth_N" ;
lin dog_N = mkTerm "dog_N" ;
lin dog_V2 = mkTerm "dog_V2" ;
lin dog_biscuit_N = mkTerm "dog_biscuit_N" ;
lin dog_cart_N = mkTerm "dog_cart_N" ;
lin dog_collar_N = mkTerm "dog_collar_N" ;
lin dog_eared_A = mkTerm "dog_eared_A" ;
lin dog_like_A = mkTerm "dog_like_A" ;
lin dogbane_N = mkTerm "dogbane_N" ;
lin doge_N = mkTerm "doge_N" ;
lin dogfight_N = mkTerm "dogfight_N" ;
lin dogfighter_N = mkTerm "dogfighter_N" ;
lin dogfish_N = mkTerm "dogfish_N" ;
lin doggedly_Adv = mkTerm "doggedly_Adv" ;
lin doggedness_N = mkTerm "doggedness_N" ;
lin doggerel_N = mkTerm "doggerel_N" ;
lin doggie_N = mkTerm "doggie_N" ;
lin dogging_A = mkTerm "dogging_A" ;
lin doggo_Adv = mkTerm "doggo_Adv" ;
lin doggy_N = mkTerm "doggy_N" ;
lin doghouse_N = mkTerm "doghouse_N" ;
lin dogie_N = mkTerm "dogie_N" ;
lin dogleg_N = mkTerm "dogleg_N" ;
lin dogma_N = mkTerm "dogma_N" ;
lin dogmatic_A = mkTerm "dogmatic_A" ;
lin dogmatism_N = mkTerm "dogmatism_N" ;
lin dogmatist_N = mkTerm "dogmatist_N" ;
lin dogmatize_V = mkTerm "dogmatize_V" ;
lin dogmatize_V2 = mkTerm "dogmatize_V2" ;
lin dogsbody_N = mkTerm "dogsbody_N" ;
lin dogsled_N = mkTerm "dogsled_N" ;
lin dogtooth_N = mkTerm "dogtooth_N" ;
lin dogtrot_N = mkTerm "dogtrot_N" ;
lin dogwatch_N = mkTerm "dogwatch_N" ;
lin dogwood_N = mkTerm "dogwood_N" ;
lin doh_N = mkTerm "doh_N" ;
lin doily_N = mkTerm "doily_N" ;
lin doing_N = mkTerm "doing_N" ;
lin dol_N = mkTerm "dol_N" ;
lin dolabriform_A = mkTerm "dolabriform_A" ;
lin dolce_Adv = mkTerm "dolce_Adv" ;
lin doldrums_N = mkTerm "doldrums_N" ;
lin dole_N = mkTerm "dole_N" ;
lin dole_V2 = mkTerm "dole_V2" ;
lin dole_out_V2 = mkTerm "dole_out_V2" ;
lin doleful_A = mkTerm "doleful_A" ;
lin dolefulness_N = mkTerm "dolefulness_N" ;
lin dolichocephalic_A = mkTerm "dolichocephalic_A" ;
lin dolichocephalic_N = mkTerm "dolichocephalic_N" ;
lin dolichocephaly_N = mkTerm "dolichocephaly_N" ;
lin doliolum_N = mkTerm "doliolum_N" ;
lin doll_N = mkTerm "doll_N" ;
lin doll_V = mkTerm "doll_V" ;
lin doll_V2 = mkTerm "doll_V2" ;
lin dollar_N = mkTerm "dollar_N" ;
lin dollarfish_N = mkTerm "dollarfish_N" ;
lin dollhouse_N = mkTerm "dollhouse_N" ;
lin dollop_N = mkTerm "dollop_N" ;
lin dolly_N = mkTerm "dolly_N" ;
lin dolly_PN = mkTerm "dolly_PN" ;
lin dolman_N = mkTerm "dolman_N" ;
lin dolmas_N = mkTerm "dolmas_N" ;
lin dolmen_N = mkTerm "dolmen_N" ;
lin dolomite_N = mkTerm "dolomite_N" ;
lin dolomitic_A = mkTerm "dolomitic_A" ;
lin dolor_N = mkTerm "dolor_N" ;
lin dolorous_A = mkTerm "dolorous_A" ;
lin dolour_N = mkTerm "dolour_N" ;
lin dolourous_A = mkTerm "dolourous_A" ;
lin dolphin_N = mkTerm "dolphin_N" ;
lin dolphinfish_N = mkTerm "dolphinfish_N" ;
lin dolt_N = mkTerm "dolt_N" ;
lin doltish_A = mkTerm "doltish_A" ;
lin domain_N = mkTerm "domain_N" ;
lin domatium_N = mkTerm "domatium_N" ;
lin dombeya_N = mkTerm "dombeya_N" ;
lin dome_N = mkTerm "dome_N" ;
lin domed_A = mkTerm "domed_A" ;
lin domesday_PN = mkTerm "domesday_PN" ;
lin domestic_A = mkTerm "domestic_A" ;
lin domestic_N = mkTerm "domestic_N" ;
lin domesticate_V2 = mkTerm "domesticate_V2" ;
lin domestication_N = mkTerm "domestication_N" ;
lin domesticity_N = mkTerm "domesticity_N" ;
lin domicile_N = mkTerm "domicile_N" ;
lin domiciliary_A = mkTerm "domiciliary_A" ;
lin dominance_N = mkTerm "dominance_N" ;
lin dominant_A = mkTerm "dominant_A" ;
lin dominant_N = mkTerm "dominant_N" ;
lin dominate_V = mkTerm "dominate_V" ;
lin dominate_V2 = mkTerm "dominate_V2" ;
lin domination_N = mkTerm "domination_N" ;
lin dominatrix_N = mkTerm "dominatrix_N" ;
lin domineer_V = mkTerm "domineer_V" ;
lin domineeringly_Adv = mkTerm "domineeringly_Adv" ;
lin dominic_PN = mkTerm "dominic_PN" ;
lin dominica_PN = mkTerm "dominica_PN" ;
lin dominical_A = mkTerm "dominical_A" ;
lin dominican_A = mkTerm "dominican_A" ;
lin dominican_N = mkTerm "dominican_N" ;
lin dominie_N = mkTerm "dominie_N" ;
lin dominion_N = mkTerm "dominion_N" ;
lin domino_N = mkTerm "domino_N" ;
lin dominoes_N = mkTerm "dominoes_N" ;
lin dominus_N = mkTerm "dominus_N" ;
lin don't_know_N = mkTerm "don't_know_N" ;
lin don_N = mkTerm "don_N" ;
lin don_PN = mkTerm "don_PN" ;
lin don_V2 = mkTerm "don_V2" ;
lin donald_PN = mkTerm "donald_PN" ;
lin donate_V = mkTerm "donate_V" ;
lin donate_V2 = mkTerm "donate_V2" ;
lin donation_N = mkTerm "donation_N" ;
lin doncaster_PN = mkTerm "doncaster_PN" ;
lin donegal_PN = mkTerm "donegal_PN" ;
lin donetsk_PN = mkTerm "donetsk_PN" ;
lin dong_N = mkTerm "dong_N" ;
lin dongle_N = mkTerm "dongle_N" ;
lin donjon_N = mkTerm "donjon_N" ;
lin donkey_N = mkTerm "donkey_N" ;
lin donkey_jacket_N = mkTerm "donkey_jacket_N" ;
lin donkey_work_N = mkTerm "donkey_work_N" ;
lin donna_N = mkTerm "donna_N" ;
lin donnish_A = mkTerm "donnish_A" ;
lin donor_N = mkTerm "donor_N" ;
lin doodad_N = mkTerm "doodad_N" ;
lin doodia_N = mkTerm "doodia_N" ;
lin doodle_V = mkTerm "doodle_V" ;
lin doodlebug_N = mkTerm "doodlebug_N" ;
lin doom_N = mkTerm "doom_N" ;
lin doom_V2 = mkTerm "doom_V2" ;
lin doomed_N = mkTerm "doomed_N" ;
lin doomsday_PN = mkTerm "doomsday_PN" ;
lin door_N = mkTerm "door_N" ;
lin door_to_door_A = mkTerm "door_to_door_A" ;
lin doorbell_N = mkTerm "doorbell_N" ;
lin doorcase_N = mkTerm "doorcase_N" ;
lin doorframe_N = mkTerm "doorframe_N" ;
lin doorhandle_N = mkTerm "doorhandle_N" ;
lin doorjamb_N = mkTerm "doorjamb_N" ;
lin doorkeeper_N = mkTerm "doorkeeper_N" ;
lin doorknob_N = mkTerm "doorknob_N" ;
lin doorknocker_N = mkTerm "doorknocker_N" ;
lin doorlock_N = mkTerm "doorlock_N" ;
lin doorman_N = mkTerm "doorman_N" ;
lin doormat_N = mkTerm "doormat_N" ;
lin doornail_N = mkTerm "doornail_N" ;
lin doorplate_N = mkTerm "doorplate_N" ;
lin doorpost_N = mkTerm "doorpost_N" ;
lin doorsill_N = mkTerm "doorsill_N" ;
lin doorstep_N = mkTerm "doorstep_N" ;
lin doorstop_N = mkTerm "doorstop_N" ;
lin doorstopper_N = mkTerm "doorstopper_N" ;
lin doorway_N = mkTerm "doorway_N" ;
lin dooryard_N = mkTerm "dooryard_N" ;
lin dopa_N = mkTerm "dopa_N" ;
lin dopamine_N = mkTerm "dopamine_N" ;
lin dope_N = mkTerm "dope_N" ;
lin dope_V2 = mkTerm "dope_V2" ;
lin dopey_A = mkTerm "dopey_A" ;
lin doppelganger_N = mkTerm "doppelganger_N" ;
lin dora_PN = mkTerm "dora_PN" ;
lin dorbeetle_N = mkTerm "dorbeetle_N" ;
lin dorchester_PN = mkTerm "dorchester_PN" ;
lin dordrecht_PN = mkTerm "dordrecht_PN" ;
lin doreen_PN = mkTerm "doreen_PN" ;
lin doric_A = mkTerm "doric_A" ;
lin doris_PN = mkTerm "doris_PN" ;
lin dorking_PN = mkTerm "dorking_PN" ;
lin dorm_N = mkTerm "dorm_N" ;
lin dormancy_N = mkTerm "dormancy_N" ;
lin dormant_A = mkTerm "dormant_A" ;
lin dormer_N = mkTerm "dormer_N" ;
lin dormer_window_N = mkTerm "dormer_window_N" ;
lin dormie_A = mkTerm "dormie_A" ;
lin dormitory_N = mkTerm "dormitory_N" ;
lin dormouse_N = mkTerm "dormouse_N" ;
lin dorothy_PN = mkTerm "dorothy_PN" ;
lin dorsal_A = mkTerm "dorsal_A" ;
lin dorset_PN = mkTerm "dorset_PN" ;
lin dorsiflexion_N = mkTerm "dorsiflexion_N" ;
lin dorsoventral_A = mkTerm "dorsoventral_A" ;
lin dorsum_N = mkTerm "dorsum_N" ;
lin dortmund_PN = mkTerm "dortmund_PN" ;
lin dory_N = mkTerm "dory_N" ;
lin dosage_N = mkTerm "dosage_N" ;
lin dose_N = mkTerm "dose_N" ;
lin dose_V2 = mkTerm "dose_V2" ;
lin dosemeter_N = mkTerm "dosemeter_N" ;
lin dosimetry_N = mkTerm "dosimetry_N" ;
lin doss_V = mkTerm "doss_V" ;
lin doss_about_V = mkTerm "doss_about_V" ;
lin doss_around_V = mkTerm "doss_around_V" ;
lin doss_down_V = mkTerm "doss_down_V" ;
lin doss_house_N = mkTerm "doss_house_N" ;
lin dossal_N = mkTerm "dossal_N" ;
lin dosser_N = mkTerm "dosser_N" ;
lin dossier_N = mkTerm "dossier_N" ;
lin dot_N = mkTerm "dot_N" ;
lin dot_V2 = mkTerm "dot_V2" ;
lin dotage_N = mkTerm "dotage_N" ;
lin dotard_N = mkTerm "dotard_N" ;
lin dote_V = mkTerm "dote_V" ;
lin dotterel_N = mkTerm "dotterel_N" ;
lin dottle_N = mkTerm "dottle_N" ;
lin dotty_A = mkTerm "dotty_A" ;
lin douai_PN = mkTerm "douai_PN" ;
lin double_A = mkTerm "double_A" ;
lin double_Adv = mkTerm "double_Adv" ;
lin double_N = mkTerm "double_N" ;
lin double_V = mkTerm "double_V" ;
lin double_V2 = mkTerm "double_V2" ;
lin double_as_V2 = mkTerm "double_as_V2" ;
lin double_back_V = mkTerm "double_back_V" ;
lin double_barrelled_A = mkTerm "double_barrelled_A" ;
lin double_bass_N = mkTerm "double_bass_N" ;
lin double_bedded_A = mkTerm "double_bedded_A" ;
lin double_breasted_A = mkTerm "double_breasted_A" ;
lin double_check_V2 = mkTerm "double_check_V2" ;
lin double_cross_N = mkTerm "double_cross_N" ;
lin double_cross_V2 = mkTerm "double_cross_V2" ;
lin double_dealer_N = mkTerm "double_dealer_N" ;
lin double_dealing_A = mkTerm "double_dealing_A" ;
lin double_dealing_N = mkTerm "double_dealing_N" ;
lin double_decker_N = mkTerm "double_decker_N" ;
lin double_dutch_N = mkTerm "double_dutch_N" ;
lin double_dyed_A = mkTerm "double_dyed_A" ;
lin double_edged_A = mkTerm "double_edged_A" ;
lin double_entry_N = mkTerm "double_entry_N" ;
lin double_faced_A = mkTerm "double_faced_A" ;
lin double_first_N = mkTerm "double_first_N" ;
lin double_jointed_A = mkTerm "double_jointed_A" ;
lin double_over_V = mkTerm "double_over_V" ;
lin double_park_V = mkTerm "double_park_V" ;
lin double_park_V2 = mkTerm "double_park_V2" ;
lin double_quick_A = mkTerm "double_quick_A" ;
lin double_quick_Adv = mkTerm "double_quick_Adv" ;
lin double_spacing_N = mkTerm "double_spacing_N" ;
lin double_talk_N = mkTerm "double_talk_N" ;
lin double_think_N = mkTerm "double_think_N" ;
lin double_up_V = mkTerm "double_up_V" ;
lin double_up_as_V2 = mkTerm "double_up_as_V2" ;
lin doubler_N = mkTerm "doubler_N" ;
lin doubles_N = mkTerm "doubles_N" ;
lin doublespeak_N = mkTerm "doublespeak_N" ;
lin doublet_N = mkTerm "doublet_N" ;
lin doubleton_N = mkTerm "doubleton_N" ;
lin doubletree_N = mkTerm "doubletree_N" ;
lin doubling_N = mkTerm "doubling_N" ;
lin doubloon_N = mkTerm "doubloon_N" ;
lin doubt_N = mkTerm "doubt_N" ;
lin doubt_V2 = mkTerm "doubt_V2" ;
lin doubt_VS = mkTerm "doubt_VS" ;
lin doubtful_A = mkTerm "doubtful_A" ;
lin doubting_A = mkTerm "doubting_A" ;
lin doubtless_Adv = mkTerm "doubtless_Adv" ;
lin douche_N = mkTerm "douche_N" ;
lin doug_PN = mkTerm "doug_PN" ;
lin dough_N = mkTerm "dough_N" ;
lin doughboy_N = mkTerm "doughboy_N" ;
lin doughnut_N = mkTerm "doughnut_N" ;
lin doughty_A = mkTerm "doughty_A" ;
lin doughy_A = mkTerm "doughy_A" ;
lin douglas_PN = mkTerm "douglas_PN" ;
lin dour_A = mkTerm "dour_A" ;
lin douroucouli_N = mkTerm "douroucouli_N" ;
lin douse_V2 = mkTerm "douse_V2" ;
lin dove_N = mkTerm "dove_N" ;
lin dovecote_N = mkTerm "dovecote_N" ;
lin dover_PN = mkTerm "dover_PN" ;
lin dovetail_N = mkTerm "dovetail_N" ;
lin dovetail_V = mkTerm "dovetail_V" ;
lin dovetail_V2 = mkTerm "dovetail_V2" ;
lin dovishness_N = mkTerm "dovishness_N" ;
lin dowager_N = mkTerm "dowager_N" ;
lin dowdiness_N = mkTerm "dowdiness_N" ;
lin dowdy_A = mkTerm "dowdy_A" ;
lin dowdy_N = mkTerm "dowdy_N" ;
lin dowel_N = mkTerm "dowel_N" ;
lin doweling_N = mkTerm "doweling_N" ;
lin dower_N = mkTerm "dower_N" ;
lin dower_V2 = mkTerm "dower_V2" ;
lin dowerless_A = mkTerm "dowerless_A" ;
lin dowitcher_N = mkTerm "dowitcher_N" ;
lin down_A = mkTerm "down_A" ;
lin down_Adv = mkTerm "down_Adv" ;
lin down_N = mkTerm "down_N" ;
lin down_PN = mkTerm "down_PN" ;
lin down_Prep = mkTerm "down_Prep" ;
lin down_V2 = mkTerm "down_V2" ;
lin down_and_out_N = mkTerm "down_and_out_N" ;
lin down_market_A = mkTerm "down_market_A" ;
lin down_to_earth_A = mkTerm "down_to_earth_A" ;
lin downbeat_N = mkTerm "downbeat_N" ;
lin downbound_A = mkTerm "downbound_A" ;
lin downcast_A = mkTerm "downcast_A" ;
lin downcast_N = mkTerm "downcast_N" ;
lin downdraft_N = mkTerm "downdraft_N" ;
lin downfall_N = mkTerm "downfall_N" ;
lin downfield_A = mkTerm "downfield_A" ;
lin downfield_Adv = mkTerm "downfield_Adv" ;
lin downgrade_N = mkTerm "downgrade_N" ;
lin downgrade_V2 = mkTerm "downgrade_V2" ;
lin downhearted_A = mkTerm "downhearted_A" ;
lin downheartedness_N = mkTerm "downheartedness_N" ;
lin downhill_Adv = mkTerm "downhill_Adv" ;
lin downhill_N = mkTerm "downhill_N" ;
lin downiness_N = mkTerm "downiness_N" ;
lin downing_street_PN = mkTerm "downing_street_PN" ;
lin download_N = mkTerm "download_N" ;
lin downloadable_A = mkTerm "downloadable_A" ;
lin downplay_V2 = mkTerm "downplay_V2" ;
lin downpour_N = mkTerm "downpour_N" ;
lin downright_A = mkTerm "downright_A" ;
lin downright_Adv = mkTerm "downright_Adv" ;
lin downrightness_N = mkTerm "downrightness_N" ;
lin downriver_Adv = mkTerm "downriver_Adv" ;
lin downscale_A = mkTerm "downscale_A" ;
lin downshift_N = mkTerm "downshift_N" ;
lin downside_N = mkTerm "downside_N" ;
lin downsize_V2 = mkTerm "downsize_V2" ;
lin downspin_N = mkTerm "downspin_N" ;
lin downstage_A = mkTerm "downstage_A" ;
lin downstage_Adv = mkTerm "downstage_Adv" ;
lin downstage_N = mkTerm "downstage_N" ;
lin downstair_A = mkTerm "downstair_A" ;
lin downstairs_A = mkTerm "downstairs_A" ;
lin downstairs_Adv = mkTerm "downstairs_Adv" ;
lin downstream_A = mkTerm "downstream_A" ;
lin downstream_Adv = mkTerm "downstream_Adv" ;
lin downstroke_N = mkTerm "downstroke_N" ;
lin downswing_N = mkTerm "downswing_N" ;
lin downtick_N = mkTerm "downtick_N" ;
lin downtime_N = mkTerm "downtime_N" ;
lin downtown_A = mkTerm "downtown_A" ;
lin downtown_Adv = mkTerm "downtown_Adv" ;
lin downtown_N = mkTerm "downtown_N" ;
lin downtrodden_A = mkTerm "downtrodden_A" ;
lin downturn_N = mkTerm "downturn_N" ;
lin downward_A = mkTerm "downward_A" ;
lin downward_Adv = mkTerm "downward_Adv" ;
lin downwards_Adv = mkTerm "downwards_Adv" ;
lin downwind_A = mkTerm "downwind_A" ;
lin downwind_Adv = mkTerm "downwind_Adv" ;
lin downy_A = mkTerm "downy_A" ;
lin dowry_N = mkTerm "dowry_N" ;
lin dowse_N = mkTerm "dowse_N" ;
lin dowse_V2 = mkTerm "dowse_V2" ;
lin dowser_N = mkTerm "dowser_N" ;
lin dowsing_N = mkTerm "dowsing_N" ;
lin doxazosin_N = mkTerm "doxazosin_N" ;
lin doxepin_N = mkTerm "doxepin_N" ;
lin doxology_N = mkTerm "doxology_N" ;
lin doxorubicin_N = mkTerm "doxorubicin_N" ;
lin doxycycline_N = mkTerm "doxycycline_N" ;
lin doyen_N = mkTerm "doyen_N" ;
lin doyenne_N = mkTerm "doyenne_N" ;
lin doyley_N = mkTerm "doyley_N" ;
lin doyly_N = mkTerm "doyly_N" ;
lin doz_N = mkTerm "doz_N" ;
lin doze_N = mkTerm "doze_N" ;
lin doze_V = mkTerm "doze_V" ;
lin doze_off_V = mkTerm "doze_off_V" ;
lin dozen_N = mkTerm "dozen_N" ;
lin dphil_N = mkTerm "dphil_N" ;
lin dr_PN = mkTerm "dr_PN" ;
lin drab_A = mkTerm "drab_A" ;
lin draba_N = mkTerm "draba_N" ;
lin drabness_N = mkTerm "drabness_N" ;
lin dracaena_N = mkTerm "dracaena_N" ;
lin drachma_N = mkTerm "drachma_N" ;
lin draconian_A = mkTerm "draconian_A" ;
lin dracontium_N = mkTerm "dracontium_N" ;
lin draft_N = mkTerm "draft_N" ;
lin draft_V2 = mkTerm "draft_V2" ;
lin draftee_N = mkTerm "draftee_N" ;
lin drafter_N = mkTerm "drafter_N" ;
lin drafting_N = mkTerm "drafting_N" ;
lin draftsman_N = mkTerm "draftsman_N" ;
lin drafty_A = mkTerm "drafty_A" ;
lin drag_N = mkTerm "drag_N" ;
lin drag_V = mkTerm "drag_V" ;
lin drag_V2 = mkTerm "drag_V2" ;
lin drag_down_V = mkTerm "drag_down_V" ;
lin drag_in_V = mkTerm "drag_in_V" ;
lin drag_on_V = mkTerm "drag_on_V" ;
lin dragee_N = mkTerm "dragee_N" ;
lin draggingly_Adv = mkTerm "draggingly_Adv" ;
lin draggled_A = mkTerm "draggled_A" ;
lin dragnet_N = mkTerm "dragnet_N" ;
lin dragoman_N = mkTerm "dragoman_N" ;
lin dragon_N = mkTerm "dragon_N" ;
lin dragonet_N = mkTerm "dragonet_N" ;
lin dragonfly_N = mkTerm "dragonfly_N" ;
lin dragonhead_N = mkTerm "dragonhead_N" ;
lin dragoon_N = mkTerm "dragoon_N" ;
lin dragoon_V2 = mkTerm "dragoon_V2" ;
lin dragsfjärd_PN = mkTerm "dragsfjärd_PN" ;
lin drain_N = mkTerm "drain_N" ;
lin drain_V = mkTerm "drain_V" ;
lin drain_V2 = mkTerm "drain_V2" ;
lin drainage_N = mkTerm "drainage_N" ;
lin drainage_basin_N = mkTerm "drainage_basin_N" ;
lin drainboard_N = mkTerm "drainboard_N" ;
lin draining_board_N = mkTerm "draining_board_N" ;
lin drainpipe_N = mkTerm "drainpipe_N" ;
lin drainplug_N = mkTerm "drainplug_N" ;
lin drake_N = mkTerm "drake_N" ;
lin dram_N = mkTerm "dram_N" ;
lin drama_N = mkTerm "drama_N" ;
lin dramatic_A = mkTerm "dramatic_A" ;
lin dramatics_N = mkTerm "dramatics_N" ;
lin dramatist_N = mkTerm "dramatist_N" ;
lin dramatization_N = mkTerm "dramatization_N" ;
lin dramatize_V2 = mkTerm "dramatize_V2" ;
lin dramaturgic_A = mkTerm "dramaturgic_A" ;
lin dramaturgy_N = mkTerm "dramaturgy_N" ;
lin drape_N = mkTerm "drape_N" ;
lin drape_V2 = mkTerm "drape_V2" ;
lin draper_N = mkTerm "draper_N" ;
lin drapery_N = mkTerm "drapery_N" ;
lin drastic_A = mkTerm "drastic_A" ;
lin drat_V2 = mkTerm "drat_V2" ;
lin draught_N = mkTerm "draught_N" ;
lin draught_V2 = mkTerm "draught_V2" ;
lin draught_horse_N = mkTerm "draught_horse_N" ;
lin draughts_N = mkTerm "draughts_N" ;
lin draughtsman_N = mkTerm "draughtsman_N" ;
lin draughty_A = mkTerm "draughty_A" ;
lin draw_1_V2 = mkTerm "draw_1_V2" ;
lin draw_2_V2 = mkTerm "draw_2_V2" ;
lin draw_N = mkTerm "draw_N" ;
lin draw_V = mkTerm "draw_V" ;
lin draw_back_V2 = mkTerm "draw_back_V2" ;
lin draw_down_V2 = mkTerm "draw_down_V2" ;
lin draw_even_V = mkTerm "draw_even_V" ;
lin draw_in_V = mkTerm "draw_in_V" ;
lin draw_into_V2 = mkTerm "draw_into_V2" ;
lin draw_off_V = mkTerm "draw_off_V" ;
lin draw_on_V = mkTerm "draw_on_V" ;
lin draw_on_V2 = mkTerm "draw_on_V2" ;
lin draw_out_V2 = mkTerm "draw_out_V2" ;
lin draw_up_V = mkTerm "draw_up_V" ;
lin draw_up_V2 = mkTerm "draw_up_V2" ;
lin drawback_N = mkTerm "drawback_N" ;
lin drawbar_N = mkTerm "drawbar_N" ;
lin drawbridge_N = mkTerm "drawbridge_N" ;
lin drawee_N = mkTerm "drawee_N" ;
lin drawer_N = mkTerm "drawer_N" ;
lin drawers_N = mkTerm "drawers_N" ;
lin drawing_N = mkTerm "drawing_N" ;
lin drawing_board_N = mkTerm "drawing_board_N" ;
lin drawing_pin_N = mkTerm "drawing_pin_N" ;
lin drawing_room_N = mkTerm "drawing_room_N" ;
lin drawknife_N = mkTerm "drawknife_N" ;
lin drawl_N = mkTerm "drawl_N" ;
lin drawl_V = mkTerm "drawl_V" ;
lin drawl_V2 = mkTerm "drawl_V2" ;
lin drawler_N = mkTerm "drawler_N" ;
lin drawnwork_N = mkTerm "drawnwork_N" ;
lin drawstring_N = mkTerm "drawstring_N" ;
lin dray_N = mkTerm "dray_N" ;
lin drayton_PN = mkTerm "drayton_PN" ;
lin dread_N = mkTerm "dread_N" ;
lin dread_V = mkTerm "dread_V" ;
lin dread_V2 = mkTerm "dread_V2" ;
lin dreadful_A = mkTerm "dreadful_A" ;
lin dreadfulness_N = mkTerm "dreadfulness_N" ;
lin dreadlock_N = mkTerm "dreadlock_N" ;
lin dreadnought_N = mkTerm "dreadnought_N" ;
lin dream_N = mkTerm "dream_N" ;
lin dream_V = mkTerm "dream_V" ;
lin dream_V2 = mkTerm "dream_V2" ;
lin dream_of_V2 = mkTerm "dream_of_V2" ;
lin dream_up_V2 = mkTerm "dream_up_V2" ;
lin dreamer_N = mkTerm "dreamer_N" ;
lin dreamland_N = mkTerm "dreamland_N" ;
lin dreamless_A = mkTerm "dreamless_A" ;
lin dreamlike_A = mkTerm "dreamlike_A" ;
lin dreamworld_N = mkTerm "dreamworld_N" ;
lin dreamy_A = mkTerm "dreamy_A" ;
lin drear_A = mkTerm "drear_A" ;
lin dreariness_N = mkTerm "dreariness_N" ;
lin dreary_A = mkTerm "dreary_A" ;
lin dredge_N = mkTerm "dredge_N" ;
lin dredge_V = mkTerm "dredge_V" ;
lin dredge_V2 = mkTerm "dredge_V2" ;
lin dredge_up_V2 = mkTerm "dredge_up_V2" ;
lin dredger_N = mkTerm "dredger_N" ;
lin dreg_N = mkTerm "dreg_N" ;
lin dregs_N = mkTerm "dregs_N" ;
lin drench_V2 = mkTerm "drench_V2" ;
lin drenching_N = mkTerm "drenching_N" ;
lin dresden_PN = mkTerm "dresden_PN" ;
lin dress_A = mkTerm "dress_A" ;
lin dress_N = mkTerm "dress_N" ;
lin dress_V = mkTerm "dress_V" ;
lin dress_V2 = mkTerm "dress_V2" ;
lin dress_down_V = mkTerm "dress_down_V" ;
lin dress_down_V2 = mkTerm "dress_down_V2" ;
lin dress_hanger_N = mkTerm "dress_hanger_N" ;
lin dress_up_V = mkTerm "dress_up_V" ;
lin dress_up_V2 = mkTerm "dress_up_V2" ;
lin dressage_N = mkTerm "dressage_N" ;
lin dresser_N = mkTerm "dresser_N" ;
lin dressing_N = mkTerm "dressing_N" ;
lin dressing_case_N = mkTerm "dressing_case_N" ;
lin dressing_down_N = mkTerm "dressing_down_N" ;
lin dressing_gown_N = mkTerm "dressing_gown_N" ;
lin dressing_table_N = mkTerm "dressing_table_N" ;
lin dressmaker_N = mkTerm "dressmaker_N" ;
lin dressmaking_N = mkTerm "dressmaking_N" ;
lin dressy_A = mkTerm "dressy_A" ;
lin drey_N = mkTerm "drey_N" ;
lin dribble_N = mkTerm "dribble_N" ;
lin dribble_V = mkTerm "dribble_V" ;
lin dribble_V2 = mkTerm "dribble_V2" ;
lin dribbler_N = mkTerm "dribbler_N" ;
lin driblet_N = mkTerm "driblet_N" ;
lin drier_N = mkTerm "drier_N" ;
lin driffield_PN = mkTerm "driffield_PN" ;
lin drift_N = mkTerm "drift_N" ;
lin drift_V = mkTerm "drift_V" ;
lin drift_V2 = mkTerm "drift_V2" ;
lin drift_apart_V = mkTerm "drift_apart_V" ;
lin drift_ice_N = mkTerm "drift_ice_N" ;
lin drift_net_N = mkTerm "drift_net_N" ;
lin drift_off_V = mkTerm "drift_off_V" ;
lin drift_wood_N = mkTerm "drift_wood_N" ;
lin driftage_N = mkTerm "driftage_N" ;
lin drifter_N = mkTerm "drifter_N" ;
lin driftfish_N = mkTerm "driftfish_N" ;
lin drifting_N = mkTerm "drifting_N" ;
lin drill_N = mkTerm "drill_N" ;
lin drill_V = mkTerm "drill_V" ;
lin drill_V2 = mkTerm "drill_V2" ;
lin drill_down_V = mkTerm "drill_down_V" ;
lin drill_down_through_V2 = mkTerm "drill_down_through_V2" ;
lin drill_into_V3 = mkTerm "drill_into_V3" ;
lin drilling_N = mkTerm "drilling_N" ;
lin drink_N = mkTerm "drink_N" ;
lin drink_V = mkTerm "drink_V" ;
lin drink_V2 = mkTerm "drink_V2" ;
lin drink_up_V2 = mkTerm "drink_up_V2" ;
lin drinkable_A = mkTerm "drinkable_A" ;
lin drinker_N = mkTerm "drinker_N" ;
lin drinking_N = mkTerm "drinking_N" ;
lin drinking_bout_N = mkTerm "drinking_bout_N" ;
lin drinking_fountain_N = mkTerm "drinking_fountain_N" ;
lin drinking_song_N = mkTerm "drinking_song_N" ;
lin drinking_water_N = mkTerm "drinking_water_N" ;
lin drip_N = mkTerm "drip_N" ;
lin drip_V = mkTerm "drip_V" ;
lin drip_V2 = mkTerm "drip_V2" ;
lin drip_dry_A = mkTerm "drip_dry_A" ;
lin drip_dry_V2 = mkTerm "drip_dry_V2" ;
lin dripless_A = mkTerm "dripless_A" ;
lin drippiness_N = mkTerm "drippiness_N" ;
lin dripping_N = mkTerm "dripping_N" ;
lin dripping_pan_N = mkTerm "dripping_pan_N" ;
lin drippings_N = mkTerm "drippings_N" ;
lin drippy_A = mkTerm "drippy_A" ;
lin dripstone_N = mkTerm "dripstone_N" ;
lin drive_N = mkTerm "drive_N" ;
lin drive_V = mkTerm "drive_V" ;
lin drive_V2 = mkTerm "drive_V2" ;
lin drive_V2V = mkTerm "drive_V2V" ;
lin drive_away_V2 = mkTerm "drive_away_V2" ;
lin drive_back_V2 = mkTerm "drive_back_V2" ;
lin drive_by_V = mkTerm "drive_by_V" ;
lin drive_down_V = mkTerm "drive_down_V" ;
lin drive_in_N = mkTerm "drive_in_N" ;
lin drive_off_V = mkTerm "drive_off_V" ;
lin drive_out_V2 = mkTerm "drive_out_V2" ;
lin drive_up_V = mkTerm "drive_up_V" ;
lin drive_up_V2 = mkTerm "drive_up_V2" ;
lin drivel_N = mkTerm "drivel_N" ;
lin drivel_V = mkTerm "drivel_V" ;
lin driveller_N = mkTerm "driveller_N" ;
lin driverFem_N = mkTerm "driverFem_N" ;
lin driverMasc_N = mkTerm "driverMasc_N" ;
lin driver_N = mkTerm "driver_N" ;
lin driveshaft_N = mkTerm "driveshaft_N" ;
lin driveway_N = mkTerm "driveway_N" ;
lin driving_A = mkTerm "driving_A" ;
lin driving_N = mkTerm "driving_N" ;
lin driving_belt_N = mkTerm "driving_belt_N" ;
lin driving_wheel_N = mkTerm "driving_wheel_N" ;
lin drizzle_N = mkTerm "drizzle_N" ;
lin drizzle_V = mkTerm "drizzle_V" ;
lin drizzly_A = mkTerm "drizzly_A" ;
lin drogheda_PN = mkTerm "drogheda_PN" ;
lin drogue_N = mkTerm "drogue_N" ;
lin droitwich_PN = mkTerm "droitwich_PN" ;
lin droll_A = mkTerm "droll_A" ;
lin drollery_N = mkTerm "drollery_N" ;
lin dromaeosaur_N = mkTerm "dromaeosaur_N" ;
lin dromedary_N = mkTerm "dromedary_N" ;
lin dronabinol_N = mkTerm "dronabinol_N" ;
lin drone_N = mkTerm "drone_N" ;
lin drone_V = mkTerm "drone_V" ;
lin drone_V2 = mkTerm "drone_V2" ;
lin drone_on_V = mkTerm "drone_on_V" ;
lin dronfield_PN = mkTerm "dronfield_PN" ;
lin drool_N = mkTerm "drool_N" ;
lin drool_V = mkTerm "drool_V" ;
lin droop_N = mkTerm "droop_N" ;
lin droop_V = mkTerm "droop_V" ;
lin droop_V2 = mkTerm "droop_V2" ;
lin droopingly_Adv = mkTerm "droopingly_Adv" ;
lin drop_N = mkTerm "drop_N" ;
lin drop_V = mkTerm "drop_V" ;
lin drop_V2 = mkTerm "drop_V2" ;
lin drop_around_V = mkTerm "drop_around_V" ;
lin drop_around_V2 = mkTerm "drop_around_V2" ;
lin drop_away_V = mkTerm "drop_away_V" ;
lin drop_back_V = mkTerm "drop_back_V" ;
lin drop_by_V = mkTerm "drop_by_V" ;
lin drop_curtain_N = mkTerm "drop_curtain_N" ;
lin drop_in_V = mkTerm "drop_in_V" ;
lin drop_in_on_V2 = mkTerm "drop_in_on_V2" ;
lin drop_kick_N = mkTerm "drop_kick_N" ;
lin drop_off_V = mkTerm "drop_off_V" ;
lin drop_off_V2 = mkTerm "drop_off_V2" ;
lin drop_out_V = mkTerm "drop_out_V" ;
lin drop_out_of_V2 = mkTerm "drop_out_of_V2" ;
lin drop_over_V = mkTerm "drop_over_V" ;
lin drop_round_V = mkTerm "drop_round_V" ;
lin drop_round_V2 = mkTerm "drop_round_V2" ;
lin drop_someone_in_it_V2 = mkTerm "drop_someone_in_it_V2" ;
lin drop_through_V = mkTerm "drop_through_V" ;
lin dropkick_N = mkTerm "dropkick_N" ;
lin dropkicker_N = mkTerm "dropkicker_N" ;
lin droplet_N = mkTerm "droplet_N" ;
lin dropline_N = mkTerm "dropline_N" ;
lin dropout_N = mkTerm "dropout_N" ;
lin dropper_N = mkTerm "dropper_N" ;
lin dropping_zone_N = mkTerm "dropping_zone_N" ;
lin droppings_N = mkTerm "droppings_N" ;
lin dropseed_N = mkTerm "dropseed_N" ;
lin dropsical_A = mkTerm "dropsical_A" ;
lin dropsy_N = mkTerm "dropsy_N" ;
lin droshky_N = mkTerm "droshky_N" ;
lin drosophila_N = mkTerm "drosophila_N" ;
lin dross_N = mkTerm "dross_N" ;
lin drought_N = mkTerm "drought_N" ;
lin drove_N = mkTerm "drove_N" ;
lin drover_N = mkTerm "drover_N" ;
lin drown_V = mkTerm "drown_V" ;
lin drown_V2 = mkTerm "drown_V2" ;
lin drown_in_V2 = mkTerm "drown_in_V2" ;
lin drown_out_V2 = mkTerm "drown_out_V2" ;
lin drowse_N = mkTerm "drowse_N" ;
lin drowse_V = mkTerm "drowse_V" ;
lin drowse_V2 = mkTerm "drowse_V2" ;
lin drowsiness_N = mkTerm "drowsiness_N" ;
lin drowsy_A = mkTerm "drowsy_A" ;
lin drub_V2 = mkTerm "drub_V2" ;
lin drubbing_N = mkTerm "drubbing_N" ;
lin drudge_N = mkTerm "drudge_N" ;
lin drudge_V = mkTerm "drudge_V" ;
lin drudgery_N = mkTerm "drudgery_N" ;
lin drug_N = mkTerm "drug_N" ;
lin drug_V2 = mkTerm "drug_V2" ;
lin drugget_N = mkTerm "drugget_N" ;
lin druggist_N = mkTerm "druggist_N" ;
lin drugless_A = mkTerm "drugless_A" ;
lin drugstore_N = mkTerm "drugstore_N" ;
lin druid_N = mkTerm "druid_N" ;
lin druidism_N = mkTerm "druidism_N" ;
lin drum_N = mkTerm "drum_N" ;
lin drum_V = mkTerm "drum_V" ;
lin drum_V2 = mkTerm "drum_V2" ;
lin drum_into_V2 = mkTerm "drum_into_V2" ;
lin drum_major_N = mkTerm "drum_major_N" ;
lin drum_majorette_N = mkTerm "drum_majorette_N" ;
lin drum_out_V2 = mkTerm "drum_out_V2" ;
lin drum_up_V2 = mkTerm "drum_up_V2" ;
lin drumbeat_N = mkTerm "drumbeat_N" ;
lin drumfire_N = mkTerm "drumfire_N" ;
lin drumhead_A = mkTerm "drumhead_A" ;
lin drumhead_N = mkTerm "drumhead_N" ;
lin drumlin_N = mkTerm "drumlin_N" ;
lin drummer_N = mkTerm "drummer_N" ;
lin drumming_N = mkTerm "drumming_N" ;
lin drumstick_N = mkTerm "drumstick_N" ;
lin drunk_A = mkTerm "drunk_A" ;
lin drunk_N = mkTerm "drunk_N" ;
lin drunkard_N = mkTerm "drunkard_N" ;
lin drunken_A = mkTerm "drunken_A" ;
lin drunkenness_N = mkTerm "drunkenness_N" ;
lin drupaceous_A = mkTerm "drupaceous_A" ;
lin drupe_N = mkTerm "drupe_N" ;
lin drupelet_N = mkTerm "drupelet_N" ;
lin drusen_N = mkTerm "drusen_N" ;
lin dry_A = mkTerm "dry_A" ;
lin dry_N = mkTerm "dry_N" ;
lin dry_V = mkTerm "dry_V" ;
lin dry_V2 = mkTerm "dry_V2" ;
lin dry_clean_V2 = mkTerm "dry_clean_V2" ;
lin dry_cleaner_N = mkTerm "dry_cleaner_N" ;
lin dry_cleaning_N = mkTerm "dry_cleaning_N" ;
lin dry_off_V2 = mkTerm "dry_off_V2" ;
lin dry_out_V = mkTerm "dry_out_V" ;
lin dry_out_V2 = mkTerm "dry_out_V2" ;
lin dry_shod_A = mkTerm "dry_shod_A" ;
lin dry_up_V = mkTerm "dry_up_V" ;
lin dry_up_V2 = mkTerm "dry_up_V2" ;
lin dry_walling_N = mkTerm "dry_walling_N" ;
lin dryad_N = mkTerm "dryad_N" ;
lin dryer_N = mkTerm "dryer_N" ;
lin drygoods_N = mkTerm "drygoods_N" ;
lin dryness_N = mkTerm "dryness_N" ;
lin dryopithecine_N = mkTerm "dryopithecine_N" ;
lin drypis_N = mkTerm "drypis_N" ;
lin dsc_N = mkTerm "dsc_N" ;
lin dscdna_N = mkTerm "dscdna_N" ;
lin dss_N = mkTerm "dss_N" ;
lin dti_N = mkTerm "dti_N" ;
lin dual_A = mkTerm "dual_A" ;
lin dualism_N = mkTerm "dualism_N" ;
lin dualist_N = mkTerm "dualist_N" ;
lin dualistic_A = mkTerm "dualistic_A" ;
lin duality_N = mkTerm "duality_N" ;
lin dub_N = mkTerm "dub_N" ;
lin dub_V2 = mkTerm "dub_V2" ;
lin dub_V3 = mkTerm "dub_V3" ;
lin dubbin_N = mkTerm "dubbin_N" ;
lin dubbing_N = mkTerm "dubbing_N" ;
lin dubiety_N = mkTerm "dubiety_N" ;
lin dubious_A = mkTerm "dubious_A" ;
lin dubiousness_N = mkTerm "dubiousness_N" ;
lin dublin_PN = mkTerm "dublin_PN" ;
lin dubliner_N = mkTerm "dubliner_N" ;
lin dubnium_N = mkTerm "dubnium_N" ;
lin ducal_A = mkTerm "ducal_A" ;
lin ducat_N = mkTerm "ducat_N" ;
lin duce_N = mkTerm "duce_N" ;
lin duchess_N = mkTerm "duchess_N" ;
lin duchy_A = mkTerm "duchy_A" ;
lin duchy_N = mkTerm "duchy_N" ;
lin duck_N = mkTerm "duck_N" ;
lin duck_V = mkTerm "duck_V" ;
lin duck_V2 = mkTerm "duck_V2" ;
lin duck_out_of_V2 = mkTerm "duck_out_of_V2" ;
lin duckbill_A = mkTerm "duckbill_A" ;
lin duckbilled_A = mkTerm "duckbilled_A" ;
lin duckboard_N = mkTerm "duckboard_N" ;
lin ducking_N = mkTerm "ducking_N" ;
lin ducking_stool_N = mkTerm "ducking_stool_N" ;
lin duckling_N = mkTerm "duckling_N" ;
lin duckpin_N = mkTerm "duckpin_N" ;
lin duckpins_N = mkTerm "duckpins_N" ;
lin duckweed_N = mkTerm "duckweed_N" ;
lin ducky_N = mkTerm "ducky_N" ;
lin duct_N = mkTerm "duct_N" ;
lin ductile_A = mkTerm "ductile_A" ;
lin ductility_N = mkTerm "ductility_N" ;
lin ductless_A = mkTerm "ductless_A" ;
lin ductule_N = mkTerm "ductule_N" ;
lin dud_A = mkTerm "dud_A" ;
lin dud_N = mkTerm "dud_N" ;
lin dude_N = mkTerm "dude_N" ;
lin dudeen_N = mkTerm "dudeen_N" ;
lin dudgeon_N = mkTerm "dudgeon_N" ;
lin dudley_PN = mkTerm "dudley_PN" ;
lin due_A = mkTerm "due_A" ;
lin due_Adv = mkTerm "due_Adv" ;
lin due_N = mkTerm "due_N" ;
lin due_to_Prep = mkTerm "due_to_Prep" ;
lin duel_N = mkTerm "duel_N" ;
lin duel_V = mkTerm "duel_V" ;
lin dueler_N = mkTerm "dueler_N" ;
lin duellist_N = mkTerm "duellist_N" ;
lin duenna_N = mkTerm "duenna_N" ;
lin duet_N = mkTerm "duet_N" ;
lin duff_N = mkTerm "duff_N" ;
lin duff_up_V2 = mkTerm "duff_up_V2" ;
lin duffel_N = mkTerm "duffel_N" ;
lin duffer_N = mkTerm "duffer_N" ;
lin duffle_N = mkTerm "duffle_N" ;
lin dug_N = mkTerm "dug_N" ;
lin dug_out_V = mkTerm "dug_out_V" ;
lin dugong_N = mkTerm "dugong_N" ;
lin dugout_N = mkTerm "dugout_N" ;
lin duisburg_PN = mkTerm "duisburg_PN" ;
lin duke_N = mkTerm "duke_N" ;
lin dukedom_N = mkTerm "dukedom_N" ;
lin dukinfield_PN = mkTerm "dukinfield_PN" ;
lin dulcet_A = mkTerm "dulcet_A" ;
lin dulciana_N = mkTerm "dulciana_N" ;
lin dulcimer_N = mkTerm "dulcimer_N" ;
lin dull_A = mkTerm "dull_A" ;
lin dull_V = mkTerm "dull_V" ;
lin dull_V2 = mkTerm "dull_V2" ;
lin dullard_N = mkTerm "dullard_N" ;
lin dullness_N = mkTerm "dullness_N" ;
lin dulse_N = mkTerm "dulse_N" ;
lin duly_AdV = mkTerm "duly_AdV" ;
lin duly_Adv = mkTerm "duly_Adv" ;
lin dumb_A = mkTerm "dumb_A" ;
lin dumb_down_V2 = mkTerm "dumb_down_V2" ;
lin dumbarton_PN = mkTerm "dumbarton_PN" ;
lin dumbbell_N = mkTerm "dumbbell_N" ;
lin dumbfound_V2 = mkTerm "dumbfound_V2" ;
lin dumbness_N = mkTerm "dumbness_N" ;
lin dumbwaiter_N = mkTerm "dumbwaiter_N" ;
lin dumdum_N = mkTerm "dumdum_N" ;
lin dumfries_PN = mkTerm "dumfries_PN" ;
lin dummy_A = mkTerm "dummy_A" ;
lin dummy_N = mkTerm "dummy_N" ;
lin dump_N = mkTerm "dump_N" ;
lin dump_V = mkTerm "dump_V" ;
lin dump_V2 = mkTerm "dump_V2" ;
lin dump_on_V2 = mkTerm "dump_on_V2" ;
lin dumpcart_N = mkTerm "dumpcart_N" ;
lin dumper_N = mkTerm "dumper_N" ;
lin dumpiness_N = mkTerm "dumpiness_N" ;
lin dumping_N = mkTerm "dumping_N" ;
lin dumpling_N = mkTerm "dumpling_N" ;
lin dumps_N = mkTerm "dumps_N" ;
lin dumpy_A = mkTerm "dumpy_A" ;
lin dun_A = mkTerm "dun_A" ;
lin dun_N = mkTerm "dun_N" ;
lin dun_V2 = mkTerm "dun_V2" ;
lin dun_laoghaire_PN = mkTerm "dun_laoghaire_PN" ;
lin duncan_PN = mkTerm "duncan_PN" ;
lin dunce_N = mkTerm "dunce_N" ;
lin dundalk_PN = mkTerm "dundalk_PN" ;
lin dundee_PN = mkTerm "dundee_PN" ;
lin dunderhead_N = mkTerm "dunderhead_N" ;
lin dune_N = mkTerm "dune_N" ;
lin dunfermline_PN = mkTerm "dunfermline_PN" ;
lin dung_N = mkTerm "dung_N" ;
lin dungeon_N = mkTerm "dungeon_N" ;
lin dunghill_N = mkTerm "dunghill_N" ;
lin dunk_N = mkTerm "dunk_N" ;
lin dunk_V2 = mkTerm "dunk_V2" ;
lin dunker_N = mkTerm "dunker_N" ;
lin dunkirk_PN = mkTerm "dunkirk_PN" ;
lin dunoon_PN = mkTerm "dunoon_PN" ;
lin dunstable_PN = mkTerm "dunstable_PN" ;
lin duo_N = mkTerm "duo_N" ;
lin duodecimal_A = mkTerm "duodecimal_A" ;
lin duodenal_A = mkTerm "duodenal_A" ;
lin duodenum_N = mkTerm "duodenum_N" ;
lin duologue_N = mkTerm "duologue_N" ;
lin dupe_N = mkTerm "dupe_N" ;
lin dupe_V2 = mkTerm "dupe_V2" ;
lin dupl_PN = mkTerm "dupl_PN" ;
lin duplex_A = mkTerm "duplex_A" ;
lin duplicable_A = mkTerm "duplicable_A" ;
lin duplicate_A = mkTerm "duplicate_A" ;
lin duplicate_N = mkTerm "duplicate_N" ;
lin duplicate_V2 = mkTerm "duplicate_V2" ;
lin duplication_N = mkTerm "duplication_N" ;
lin duplicator_N = mkTerm "duplicator_N" ;
lin duplicity_N = mkTerm "duplicity_N" ;
lin durability_N = mkTerm "durability_N" ;
lin durable_A = mkTerm "durable_A" ;
lin durable_N = mkTerm "durable_N" ;
lin durables_N = mkTerm "durables_N" ;
lin dural_A = mkTerm "dural_A" ;
lin durance_N = mkTerm "durance_N" ;
lin duration_N = mkTerm "duration_N" ;
lin durative_N = mkTerm "durative_N" ;
lin durban_PN = mkTerm "durban_PN" ;
lin durbar_N = mkTerm "durbar_N" ;
lin duress_N = mkTerm "duress_N" ;
lin durham_PN = mkTerm "durham_PN" ;
lin durian_N = mkTerm "durian_N" ;
lin durmast_N = mkTerm "durmast_N" ;
lin durra_N = mkTerm "durra_N" ;
lin durrington_PN = mkTerm "durrington_PN" ;
lin dursley_PN = mkTerm "dursley_PN" ;
lin durum_N = mkTerm "durum_N" ;
lin dusk_N = mkTerm "dusk_N" ;
lin dusky_A = mkTerm "dusky_A" ;
lin dusseldorf_PN = mkTerm "dusseldorf_PN" ;
lin dust_N = mkTerm "dust_N" ;
lin dust_V2 = mkTerm "dust_V2" ;
lin dust_bowl_N = mkTerm "dust_bowl_N" ;
lin dust_coat_N = mkTerm "dust_coat_N" ;
lin dust_jacket_N = mkTerm "dust_jacket_N" ;
lin dust_off_V = mkTerm "dust_off_V" ;
lin dust_sheet_N = mkTerm "dust_sheet_N" ;
lin dust_up_N = mkTerm "dust_up_N" ;
lin dust_wrapper_N = mkTerm "dust_wrapper_N" ;
lin dustbin_N = mkTerm "dustbin_N" ;
lin dustcart_N = mkTerm "dustcart_N" ;
lin dustcloth_N = mkTerm "dustcloth_N" ;
lin duster_N = mkTerm "duster_N" ;
lin dustiness_N = mkTerm "dustiness_N" ;
lin dustlike_A = mkTerm "dustlike_A" ;
lin dustman_N = mkTerm "dustman_N" ;
lin dustmop_N = mkTerm "dustmop_N" ;
lin dustpan_N = mkTerm "dustpan_N" ;
lin dusty_A = mkTerm "dusty_A" ;
lin dutchFem_N = mkTerm "dutchFem_N" ;
lin dutchMasc_N = mkTerm "dutchMasc_N" ;
lin dutch_A = mkTerm "dutch_A" ;
lin duteous_A = mkTerm "duteous_A" ;
lin dutiable_A = mkTerm "dutiable_A" ;
lin dutiful_A = mkTerm "dutiful_A" ;
lin dutifulness_N = mkTerm "dutifulness_N" ;
lin duty_N = mkTerm "duty_N" ;
lin duty_free_A = mkTerm "duty_free_A" ;
lin duvet_N = mkTerm "duvet_N" ;
lin dwarf_N = mkTerm "dwarf_N" ;
lin dwarf_V2 = mkTerm "dwarf_V2" ;
lin dwarfish_A = mkTerm "dwarfish_A" ;
lin dwarfishness_N = mkTerm "dwarfishness_N" ;
lin dwarfism_N = mkTerm "dwarfism_N" ;
lin dwell_V = mkTerm "dwell_V" ;
lin dwell_on_V2 = mkTerm "dwell_on_V2" ;
lin dwell_upon_V2 = mkTerm "dwell_upon_V2" ;
lin dweller_N = mkTerm "dweller_N" ;
lin dwelling_N = mkTerm "dwelling_N" ;
lin dwelling_house_N = mkTerm "dwelling_house_N" ;
lin dwindle_V = mkTerm "dwindle_V" ;
lin dwindling_N = mkTerm "dwindling_N" ;
lin dyadic_A = mkTerm "dyadic_A" ;
lin dyarchy_N = mkTerm "dyarchy_N" ;
lin dybbuk_N = mkTerm "dybbuk_N" ;
lin dye_N = mkTerm "dye_N" ;
lin dye_V = mkTerm "dye_V" ;
lin dye_V2 = mkTerm "dye_V2" ;
lin dye_works_N = mkTerm "dye_works_N" ;
lin dyed_in_the_wool_A = mkTerm "dyed_in_the_wool_A" ;
lin dyeing_N = mkTerm "dyeing_N" ;
lin dyer_N = mkTerm "dyer_N" ;
lin dyestuff_N = mkTerm "dyestuff_N" ;
lin dyewood_N = mkTerm "dyewood_N" ;
lin dyfed_PN = mkTerm "dyfed_PN" ;
lin dyke_N = mkTerm "dyke_N" ;
lin dyke_V = mkTerm "dyke_V" ;
lin dyke_V2 = mkTerm "dyke_V2" ;
lin dynamic_A = mkTerm "dynamic_A" ;
lin dynamic_N = mkTerm "dynamic_N" ;
lin dynamics_N = mkTerm "dynamics_N" ;
lin dynamism_N = mkTerm "dynamism_N" ;
lin dynamite_N = mkTerm "dynamite_N" ;
lin dynamite_V2 = mkTerm "dynamite_V2" ;
lin dynamiter_N = mkTerm "dynamiter_N" ;
lin dynamo_N = mkTerm "dynamo_N" ;
lin dynamometer_N = mkTerm "dynamometer_N" ;
lin dynast_N = mkTerm "dynast_N" ;
lin dynastic_A = mkTerm "dynastic_A" ;
lin dynasty_N = mkTerm "dynasty_N" ;
lin dyne_N = mkTerm "dyne_N" ;
lin dysaphia_N = mkTerm "dysaphia_N" ;
lin dysarthria_N = mkTerm "dysarthria_N" ;
lin dyscalculia_N = mkTerm "dyscalculia_N" ;
lin dyschezia_N = mkTerm "dyschezia_N" ;
lin dyscrasia_N = mkTerm "dyscrasia_N" ;
lin dysentery_N = mkTerm "dysentery_N" ;
lin dysfunction_N = mkTerm "dysfunction_N" ;
lin dysfunctional_A = mkTerm "dysfunctional_A" ;
lin dysgenesis_N = mkTerm "dysgenesis_N" ;
lin dysgenic_A = mkTerm "dysgenic_A" ;
lin dysgenics_N = mkTerm "dysgenics_N" ;
lin dysgraphia_N = mkTerm "dysgraphia_N" ;
lin dyskinesia_N = mkTerm "dyskinesia_N" ;
lin dyslectic_A = mkTerm "dyslectic_A" ;
lin dyslectic_N = mkTerm "dyslectic_N" ;
lin dyslexia_N = mkTerm "dyslexia_N" ;
lin dyslexic_A = mkTerm "dyslexic_A" ;
lin dyslogia_N = mkTerm "dyslogia_N" ;
lin dyslogistic_A = mkTerm "dyslogistic_A" ;
lin dysmenorrhea_N = mkTerm "dysmenorrhea_N" ;
lin dysomia_N = mkTerm "dysomia_N" ;
lin dysosmia_N = mkTerm "dysosmia_N" ;
lin dyspepsia_N = mkTerm "dyspepsia_N" ;
lin dyspeptic_A = mkTerm "dyspeptic_A" ;
lin dyspeptic_N = mkTerm "dyspeptic_N" ;
lin dysphagia_N = mkTerm "dysphagia_N" ;
lin dysphasia_N = mkTerm "dysphasia_N" ;
lin dysphemism_N = mkTerm "dysphemism_N" ;
lin dysphemistic_A = mkTerm "dysphemistic_A" ;
lin dysphonia_N = mkTerm "dysphonia_N" ;
lin dysphoria_N = mkTerm "dysphoria_N" ;
lin dysphoric_A = mkTerm "dysphoric_A" ;
lin dysplasia_N = mkTerm "dysplasia_N" ;
lin dysplastic_A = mkTerm "dysplastic_A" ;
lin dyspnea_N = mkTerm "dyspnea_N" ;
lin dysprosium_N = mkTerm "dysprosium_N" ;
lin dysthymia_N = mkTerm "dysthymia_N" ;
lin dystopia_N = mkTerm "dystopia_N" ;
lin dystopian_A = mkTerm "dystopian_A" ;
lin dystrophy_N = mkTerm "dystrophy_N" ;
lin dysuria_N = mkTerm "dysuria_N" ;
lin e'en_Adv = mkTerm "e'en_Adv" ;
lin e'er_Adv = mkTerm "e'er_Adv" ;
lin e_mail_N = mkTerm "e_mail_N" ;
lin each_Adv = mkTerm "each_Adv" ;
lin each_Det = mkTerm "each_Det" ;
lin eager_A = mkTerm "eager_A" ;
lin eagerness_N = mkTerm "eagerness_N" ;
lin eagle_N = mkTerm "eagle_N" ;
lin eagle_eyed_A = mkTerm "eagle_eyed_A" ;
lin eaglescliffe_PN = mkTerm "eaglescliffe_PN" ;
lin eaglet_N = mkTerm "eaglet_N" ;
lin ealing_PN = mkTerm "ealing_PN" ;
lin ear_N = mkTerm "ear_N" ;
lin ear_trumpet_N = mkTerm "ear_trumpet_N" ;
lin earache_N = mkTerm "earache_N" ;
lin eardrop_N = mkTerm "eardrop_N" ;
lin eardrum_N = mkTerm "eardrum_N" ;
lin eared_A = mkTerm "eared_A" ;
lin earflap_N = mkTerm "earflap_N" ;
lin earful_N = mkTerm "earful_N" ;
lin earl_N = mkTerm "earl_N" ;
lin earl_shilton_PN = mkTerm "earl_shilton_PN" ;
lin earldom_N = mkTerm "earldom_N" ;
lin earless_A = mkTerm "earless_A" ;
lin earlier_A = mkTerm "earlier_A" ;
lin earlier_Adv = mkTerm "earlier_Adv" ;
lin earliness_N = mkTerm "earliness_N" ;
lin earlobe_N = mkTerm "earlobe_N" ;
lin early_A = mkTerm "early_A" ;
lin early_Adv = mkTerm "early_Adv" ;
lin early_on_Adv = mkTerm "early_on_Adv" ;
lin early_warning_A = mkTerm "early_warning_A" ;
lin earlyish_A = mkTerm "earlyish_A" ;
lin earmark_N = mkTerm "earmark_N" ;
lin earmark_V2 = mkTerm "earmark_V2" ;
lin earmuff_N = mkTerm "earmuff_N" ;
lin earn_V = mkTerm "earn_V" ;
lin earn_V2 = mkTerm "earn_V2" ;
lin earner_N = mkTerm "earner_N" ;
lin earnest_A = mkTerm "earnest_A" ;
lin earnest_N = mkTerm "earnest_N" ;
lin earnest_money_N = mkTerm "earnest_money_N" ;
lin earnestness_N = mkTerm "earnestness_N" ;
lin earning_N = mkTerm "earning_N" ;
lin earnings_N = mkTerm "earnings_N" ;
lin earphone_N = mkTerm "earphone_N" ;
lin earpiece_N = mkTerm "earpiece_N" ;
lin earplug_N = mkTerm "earplug_N" ;
lin earring_N = mkTerm "earring_N" ;
lin earshot_N = mkTerm "earshot_N" ;
lin earth_N = mkTerm "earth_N" ;
lin earth_V2 = mkTerm "earth_V2" ;
lin earth_closet_N = mkTerm "earth_closet_N" ;
lin earthball_N = mkTerm "earthball_N" ;
lin earthborn_A = mkTerm "earthborn_A" ;
lin earthbound_A = mkTerm "earthbound_A" ;
lin earthen_A = mkTerm "earthen_A" ;
lin earthenware_N = mkTerm "earthenware_N" ;
lin earthlike_A = mkTerm "earthlike_A" ;
lin earthly_A = mkTerm "earthly_A" ;
lin earthnut_N = mkTerm "earthnut_N" ;
lin earthquake_N = mkTerm "earthquake_N" ;
lin earthshaking_A = mkTerm "earthshaking_A" ;
lin earthstar_N = mkTerm "earthstar_N" ;
lin earthtongue_N = mkTerm "earthtongue_N" ;
lin earthwork_N = mkTerm "earthwork_N" ;
lin earthworm_N = mkTerm "earthworm_N" ;
lin earthy_A = mkTerm "earthy_A" ;
lin earwax_N = mkTerm "earwax_N" ;
lin earwig_N = mkTerm "earwig_N" ;
lin ease_N = mkTerm "ease_N" ;
lin ease_V = mkTerm "ease_V" ;
lin ease_V2 = mkTerm "ease_V2" ;
lin ease_off_V2 = mkTerm "ease_off_V2" ;
lin ease_up_V = mkTerm "ease_up_V" ;
lin easel_N = mkTerm "easel_N" ;
lin easement_N = mkTerm "easement_N" ;
lin easiness_N = mkTerm "easiness_N" ;
lin easing_N = mkTerm "easing_N" ;
lin easington_PN = mkTerm "easington_PN" ;
lin east_A = mkTerm "east_A" ;
lin east_Adv = mkTerm "east_Adv" ;
lin east_N = mkTerm "east_N" ;
lin east_dereham_PN = mkTerm "east_dereham_PN" ;
lin east_grinstead_PN = mkTerm "east_grinstead_PN" ;
lin east_kilbride_PN = mkTerm "east_kilbride_PN" ;
lin east_retford_PN = mkTerm "east_retford_PN" ;
lin eastbound_A = mkTerm "eastbound_A" ;
lin eastbourne_PN = mkTerm "eastbourne_PN" ;
lin easter_N = mkTerm "easter_N" ;
lin easter_PN = mkTerm "easter_PN" ;
lin easterly_A = mkTerm "easterly_A" ;
lin easterly_Adv = mkTerm "easterly_Adv" ;
lin eastern_A = mkTerm "eastern_A" ;
lin easterner_N = mkTerm "easterner_N" ;
lin easternmost_A = mkTerm "easternmost_A" ;
lin eastleigh_PN = mkTerm "eastleigh_PN" ;
lin eastside_A = mkTerm "eastside_A" ;
lin eastward_A = mkTerm "eastward_A" ;
lin eastward_Adv = mkTerm "eastward_Adv" ;
lin eastwards_Adv = mkTerm "eastwards_Adv" ;
lin easy_A = mkTerm "easy_A" ;
lin easy_Adv = mkTerm "easy_Adv" ;
lin easy_V2V = mkTerm "easy_V2V" ;
lin easygoing_A = mkTerm "easygoing_A" ;
lin easygoingness_N = mkTerm "easygoingness_N" ;
lin eat_V = mkTerm "eat_V" ;
lin eat_V2 = mkTerm "eat_V2" ;
lin eat_away_V = mkTerm "eat_away_V" ;
lin eat_away_V2 = mkTerm "eat_away_V2" ;
lin eat_in_V = mkTerm "eat_in_V" ;
lin eat_into_V2 = mkTerm "eat_into_V2" ;
lin eat_out_V = mkTerm "eat_out_V" ;
lin eat_up_V2 = mkTerm "eat_up_V2" ;
lin eatable_A = mkTerm "eatable_A" ;
lin eatable_N = mkTerm "eatable_N" ;
lin eatage_N = mkTerm "eatage_N" ;
lin eater_N = mkTerm "eater_N" ;
lin eating_N = mkTerm "eating_N" ;
lin eating_apple_N = mkTerm "eating_apple_N" ;
lin eating_house_N = mkTerm "eating_house_N" ;
lin eau_de_cologne_N = mkTerm "eau_de_cologne_N" ;
lin eau_de_vie_N = mkTerm "eau_de_vie_N" ;
lin eaves_N = mkTerm "eaves_N" ;
lin eavesdrop_V = mkTerm "eavesdrop_V" ;
lin eavesdropper_N = mkTerm "eavesdropper_N" ;
lin ebay_N = mkTerm "ebay_N" ;
lin ebb_N = mkTerm "ebb_N" ;
lin ebb_V = mkTerm "ebb_V" ;
lin ebb_away_V = mkTerm "ebb_away_V" ;
lin ebbtide_N = mkTerm "ebbtide_N" ;
lin ebbw_vale_PN = mkTerm "ebbw_vale_PN" ;
lin eblis_N = mkTerm "eblis_N" ;
lin ebon_A = mkTerm "ebon_A" ;
lin ebonite_N = mkTerm "ebonite_N" ;
lin ebony_A = mkTerm "ebony_A" ;
lin ebony_N = mkTerm "ebony_N" ;
lin ebracteate_A = mkTerm "ebracteate_A" ;
lin ebullience_N = mkTerm "ebullience_N" ;
lin ebullient_A = mkTerm "ebullient_A" ;
lin eburnation_N = mkTerm "eburnation_N" ;
lin ec_N = mkTerm "ec_N" ;
lin ecarte_N = mkTerm "ecarte_N" ;
lin eccentric_A = mkTerm "eccentric_A" ;
lin eccentric_N = mkTerm "eccentric_N" ;
lin eccentricity_N = mkTerm "eccentricity_N" ;
lin ecchymosis_N = mkTerm "ecchymosis_N" ;
lin eccles_PN = mkTerm "eccles_PN" ;
lin ecclesiastic_N = mkTerm "ecclesiastic_N" ;
lin ecclesiastical_A = mkTerm "ecclesiastical_A" ;
lin ecclesiasticism_N = mkTerm "ecclesiasticism_N" ;
lin ecclesiology_N = mkTerm "ecclesiology_N" ;
lin eccrine_A = mkTerm "eccrine_A" ;
lin ecdemic_A = mkTerm "ecdemic_A" ;
lin echelon_N = mkTerm "echelon_N" ;
lin echidna_N = mkTerm "echidna_N" ;
lin echinocactus_N = mkTerm "echinocactus_N" ;
lin echinococcosis_N = mkTerm "echinococcosis_N" ;
lin echinococcus_N = mkTerm "echinococcus_N" ;
lin echinoderm_N = mkTerm "echinoderm_N" ;
lin echinus_N = mkTerm "echinus_N" ;
lin echo_N = mkTerm "echo_N" ;
lin echo_V = mkTerm "echo_V" ;
lin echo_V2 = mkTerm "echo_V2" ;
lin echo_sounder_N = mkTerm "echo_sounder_N" ;
lin echo_sounding_N = mkTerm "echo_sounding_N" ;
lin echocardiogram_N = mkTerm "echocardiogram_N" ;
lin echocardiograph_N = mkTerm "echocardiograph_N" ;
lin echocardiography_N = mkTerm "echocardiography_N" ;
lin echoencephalogram_N = mkTerm "echoencephalogram_N" ;
lin echoencephalograph_N = mkTerm "echoencephalograph_N" ;
lin echoencephalography_N = mkTerm "echoencephalography_N" ;
lin echoic_A = mkTerm "echoic_A" ;
lin echolalia_N = mkTerm "echolalia_N" ;
lin echoless_A = mkTerm "echoless_A" ;
lin echolocation_N = mkTerm "echolocation_N" ;
lin echovirus_N = mkTerm "echovirus_N" ;
lin eclair_N = mkTerm "eclair_N" ;
lin eclampsia_N = mkTerm "eclampsia_N" ;
lin eclat_N = mkTerm "eclat_N" ;
lin eclectic_A = mkTerm "eclectic_A" ;
lin eclectic_N = mkTerm "eclectic_N" ;
lin eclecticism_N = mkTerm "eclecticism_N" ;
lin eclipse_N = mkTerm "eclipse_N" ;
lin eclipse_V2 = mkTerm "eclipse_V2" ;
lin ecliptic_N = mkTerm "ecliptic_N" ;
lin eclogue_N = mkTerm "eclogue_N" ;
lin ecobabble_N = mkTerm "ecobabble_N" ;
lin ecological_A = mkTerm "ecological_A" ;
lin ecologist_N = mkTerm "ecologist_N" ;
lin ecology_N = mkTerm "ecology_N" ;
lin econometric_A = mkTerm "econometric_A" ;
lin econometrician_N = mkTerm "econometrician_N" ;
lin econometrics_N = mkTerm "econometrics_N" ;
lin economic_A = mkTerm "economic_A" ;
lin economical_A = mkTerm "economical_A" ;
lin economics_N = mkTerm "economics_N" ;
lin economist_N = mkTerm "economist_N" ;
lin economize_V = mkTerm "economize_V" ;
lin economize_V2 = mkTerm "economize_V2" ;
lin economizer_N = mkTerm "economizer_N" ;
lin economy_1_N = mkTerm "economy_1_N" ;
lin economy_2_N = mkTerm "economy_2_N" ;
lin ecosystem_N = mkTerm "ecosystem_N" ;
lin ecoterrorism_N = mkTerm "ecoterrorism_N" ;
lin ecotourism_N = mkTerm "ecotourism_N" ;
lin ecphonesis_N = mkTerm "ecphonesis_N" ;
lin ecstasy_N = mkTerm "ecstasy_N" ;
lin ecstatic_A = mkTerm "ecstatic_A" ;
lin ectasia_N = mkTerm "ectasia_N" ;
lin ectoderm_N = mkTerm "ectoderm_N" ;
lin ectodermal_A = mkTerm "ectodermal_A" ;
lin ectomorph_N = mkTerm "ectomorph_N" ;
lin ectomorphic_A = mkTerm "ectomorphic_A" ;
lin ectoparasite_N = mkTerm "ectoparasite_N" ;
lin ectopia_N = mkTerm "ectopia_N" ;
lin ectopic_A = mkTerm "ectopic_A" ;
lin ectoplasm_N = mkTerm "ectoplasm_N" ;
lin ectoproct_N = mkTerm "ectoproct_N" ;
lin ectrodactyly_N = mkTerm "ectrodactyly_N" ;
lin ecuador_PN = mkTerm "ecuador_PN" ;
lin ecuadorian_A = mkTerm "ecuadorian_A" ;
lin ecuadorian_N = mkTerm "ecuadorian_N" ;
lin ecumenic_A = mkTerm "ecumenic_A" ;
lin ecumenical_A = mkTerm "ecumenical_A" ;
lin ecumenism_N = mkTerm "ecumenism_N" ;
lin eczema_N = mkTerm "eczema_N" ;
lin ed_PN = mkTerm "ed_PN" ;
lin edacious_A = mkTerm "edacious_A" ;
lin edacity_N = mkTerm "edacity_N" ;
lin edaphosaurus_N = mkTerm "edaphosaurus_N" ;
lin eddie_PN = mkTerm "eddie_PN" ;
lin eddy_N = mkTerm "eddy_N" ;
lin eddy_PN = mkTerm "eddy_PN" ;
lin eddy_V = mkTerm "eddy_V" ;
lin edelweiss_N = mkTerm "edelweiss_N" ;
lin edema_N = mkTerm "edema_N" ;
lin edematous_A = mkTerm "edematous_A" ;
lin eden_PN = mkTerm "eden_PN" ;
lin edenbridge_PN = mkTerm "edenbridge_PN" ;
lin edental_A = mkTerm "edental_A" ;
lin edentate_N = mkTerm "edentate_N" ;
lin edentulous_A = mkTerm "edentulous_A" ;
lin edgar_PN = mkTerm "edgar_PN" ;
lin edge_N = mkTerm "edge_N" ;
lin edge_V = mkTerm "edge_V" ;
lin edge_V2 = mkTerm "edge_V2" ;
lin edge_out_V2 = mkTerm "edge_out_V2" ;
lin edge_up_V = mkTerm "edge_up_V" ;
lin edgeless_A = mkTerm "edgeless_A" ;
lin edger_N = mkTerm "edger_N" ;
lin edgeways_Adv = mkTerm "edgeways_Adv" ;
lin edgewise_Adv = mkTerm "edgewise_Adv" ;
lin edginess_N = mkTerm "edginess_N" ;
lin edging_N = mkTerm "edging_N" ;
lin edgy_A = mkTerm "edgy_A" ;
lin edibility_N = mkTerm "edibility_N" ;
lin edible_A = mkTerm "edible_A" ;
lin edible_N = mkTerm "edible_N" ;
lin edict_N = mkTerm "edict_N" ;
lin edification_N = mkTerm "edification_N" ;
lin edifice_N = mkTerm "edifice_N" ;
lin edify_V2 = mkTerm "edify_V2" ;
lin edifying_A = mkTerm "edifying_A" ;
lin edinburgh_PN = mkTerm "edinburgh_PN" ;
lin edit_V2 = mkTerm "edit_V2" ;
lin edith_PN = mkTerm "edith_PN" ;
lin editing_N = mkTerm "editing_N" ;
lin edition_N = mkTerm "edition_N" ;
lin editor_N = mkTerm "editor_N" ;
lin editorial_A = mkTerm "editorial_A" ;
lin editorial_N = mkTerm "editorial_N" ;
lin editorship_N = mkTerm "editorship_N" ;
lin edmontosaurus_N = mkTerm "edmontosaurus_N" ;
lin edmund_PN = mkTerm "edmund_PN" ;
lin edp_N = mkTerm "edp_N" ;
lin educate_V2 = mkTerm "educate_V2" ;
lin education_N = mkTerm "education_N" ;
lin educational_A = mkTerm "educational_A" ;
lin educationalist_N = mkTerm "educationalist_N" ;
lin educationist_N = mkTerm "educationist_N" ;
lin educative_A = mkTerm "educative_A" ;
lin educator_N = mkTerm "educator_N" ;
lin educe_V2 = mkTerm "educe_V2" ;
lin edutainment_N = mkTerm "edutainment_N" ;
lin edward_PN = mkTerm "edward_PN" ;
lin edwardian_A = mkTerm "edwardian_A" ;
lin edwardian_N = mkTerm "edwardian_N" ;
lin eec_N = mkTerm "eec_N" ;
lin eeg_N = mkTerm "eeg_N" ;
lin eel_N = mkTerm "eel_N" ;
lin eelblenny_N = mkTerm "eelblenny_N" ;
lin eelgrass_N = mkTerm "eelgrass_N" ;
lin eellike_A = mkTerm "eellike_A" ;
lin eelpout_N = mkTerm "eelpout_N" ;
lin eelworm_N = mkTerm "eelworm_N" ;
lin eerie_A = mkTerm "eerie_A" ;
lin eeriness_N = mkTerm "eeriness_N" ;
lin eery_A = mkTerm "eery_A" ;
lin eff_V = mkTerm "eff_V" ;
lin efface_V2 = mkTerm "efface_V2" ;
lin effaceable_A = mkTerm "effaceable_A" ;
lin effacement_N = mkTerm "effacement_N" ;
lin effect_N = mkTerm "effect_N" ;
lin effect_V2 = mkTerm "effect_V2" ;
lin effecter_N = mkTerm "effecter_N" ;
lin effective_A = mkTerm "effective_A" ;
lin effectiveness_N = mkTerm "effectiveness_N" ;
lin effector_N = mkTerm "effector_N" ;
lin effects_N = mkTerm "effects_N" ;
lin effectual_A = mkTerm "effectual_A" ;
lin effectuality_N = mkTerm "effectuality_N" ;
lin effectualness_N = mkTerm "effectualness_N" ;
lin effeminacy_N = mkTerm "effeminacy_N" ;
lin effeminate_A = mkTerm "effeminate_A" ;
lin effendi_N = mkTerm "effendi_N" ;
lin efferent_A = mkTerm "efferent_A" ;
lin effervesce_V = mkTerm "effervesce_V" ;
lin effervescence_N = mkTerm "effervescence_N" ;
lin effervescent_A = mkTerm "effervescent_A" ;
lin effete_A = mkTerm "effete_A" ;
lin effeteness_N = mkTerm "effeteness_N" ;
lin efficacious_A = mkTerm "efficacious_A" ;
lin efficacy_N = mkTerm "efficacy_N" ;
lin efficiency_N = mkTerm "efficiency_N" ;
lin efficient_A = mkTerm "efficient_A" ;
lin effigy_N = mkTerm "effigy_N" ;
lin effleurage_N = mkTerm "effleurage_N" ;
lin efflorescence_N = mkTerm "efflorescence_N" ;
lin efflorescent_A = mkTerm "efflorescent_A" ;
lin effluent_A = mkTerm "effluent_A" ;
lin effluent_N = mkTerm "effluent_N" ;
lin effluvium_N = mkTerm "effluvium_N" ;
lin efflux_N = mkTerm "efflux_N" ;
lin effort_N = mkTerm "effort_N" ;
lin effortful_A = mkTerm "effortful_A" ;
lin effortfulness_N = mkTerm "effortfulness_N" ;
lin effortless_A = mkTerm "effortless_A" ;
lin effortlessness_N = mkTerm "effortlessness_N" ;
lin effrontery_N = mkTerm "effrontery_N" ;
lin effulgence_N = mkTerm "effulgence_N" ;
lin effulgent_A = mkTerm "effulgent_A" ;
lin effusion_N = mkTerm "effusion_N" ;
lin effusive_A = mkTerm "effusive_A" ;
lin effusiveness_N = mkTerm "effusiveness_N" ;
lin eft_N = mkTerm "eft_N" ;
lin efta_N = mkTerm "efta_N" ;
lin eg_PN = mkTerm "eg_PN" ;
lin egad_Interj = mkTerm "egad_Interj" ;
lin egalitarian_A = mkTerm "egalitarian_A" ;
lin egalitarian_N = mkTerm "egalitarian_N" ;
lin egalitarianism_N = mkTerm "egalitarianism_N" ;
lin egality_N = mkTerm "egality_N" ;
lin egg_N = mkTerm "egg_N" ;
lin egg_V2 = mkTerm "egg_V2" ;
lin egg_beater_N = mkTerm "egg_beater_N" ;
lin egg_cup_N = mkTerm "egg_cup_N" ;
lin egg_on_V2 = mkTerm "egg_on_V2" ;
lin egg_whisk_N = mkTerm "egg_whisk_N" ;
lin eggar_N = mkTerm "eggar_N" ;
lin egghead_N = mkTerm "egghead_N" ;
lin eggnog_N = mkTerm "eggnog_N" ;
lin eggplant_N = mkTerm "eggplant_N" ;
lin eggshake_N = mkTerm "eggshake_N" ;
lin eggshell_N = mkTerm "eggshell_N" ;
lin eglantine_N = mkTerm "eglantine_N" ;
lin ego_N = mkTerm "ego_N" ;
lin egocentric_A = mkTerm "egocentric_A" ;
lin egocentric_N = mkTerm "egocentric_N" ;
lin egoism_N = mkTerm "egoism_N" ;
lin egoist_N = mkTerm "egoist_N" ;
lin egoistic_A = mkTerm "egoistic_A" ;
lin egoistical_A = mkTerm "egoistical_A" ;
lin egomania_N = mkTerm "egomania_N" ;
lin egomaniac_N = mkTerm "egomaniac_N" ;
lin egotism_N = mkTerm "egotism_N" ;
lin egotist_N = mkTerm "egotist_N" ;
lin egotistic_A = mkTerm "egotistic_A" ;
lin egotrip_N = mkTerm "egotrip_N" ;
lin egotrip_V = mkTerm "egotrip_V" ;
lin egregious_A = mkTerm "egregious_A" ;
lin egremont_PN = mkTerm "egremont_PN" ;
lin egress_N = mkTerm "egress_N" ;
lin egret_N = mkTerm "egret_N" ;
lin egypt_PN = mkTerm "egypt_PN" ;
lin egyptian_A = mkTerm "egyptian_A" ;
lin egyptian_N = mkTerm "egyptian_N" ;
lin eiche_PN = mkTerm "eiche_PN" ;
lin eider_N = mkTerm "eider_N" ;
lin eiderdown_N = mkTerm "eiderdown_N" ;
lin eidetic_A = mkTerm "eidetic_A" ;
lin eidos_N = mkTerm "eidos_N" ;
lin eigenvalue_N = mkTerm "eigenvalue_N" ;
lin eightpence_N = mkTerm "eightpence_N" ;
lin eightpenny_A = mkTerm "eightpenny_A" ;
lin eightsome_N = mkTerm "eightsome_N" ;
lin eileen_PN = mkTerm "eileen_PN" ;
lin eindhoven_PN = mkTerm "eindhoven_PN" ;
lin einsteinium_N = mkTerm "einsteinium_N" ;
lin eisegesis_N = mkTerm "eisegesis_N" ;
lin eisteddfod_N = mkTerm "eisteddfod_N" ;
lin either_Adv = mkTerm "either_Adv" ;
lin either_Det = mkTerm "either_Det" ;
lin ejaculate_V2 = mkTerm "ejaculate_V2" ;
lin ejaculation_N = mkTerm "ejaculation_N" ;
lin ejaculator_N = mkTerm "ejaculator_N" ;
lin eject_V = mkTerm "eject_V" ;
lin eject_V2 = mkTerm "eject_V2" ;
lin ejection_N = mkTerm "ejection_N" ;
lin ejector_N = mkTerm "ejector_N" ;
lin ejector_seat_N = mkTerm "ejector_seat_N" ;
lin eke_V2 = mkTerm "eke_V2" ;
lin eke_out_V2 = mkTerm "eke_out_V2" ;
lin ekenäs_PN = mkTerm "ekenäs_PN" ;
lin el_dorado_N = mkTerm "el_dorado_N" ;
lin el_salvador_PN = mkTerm "el_salvador_PN" ;
lin elaborate_A = mkTerm "elaborate_A" ;
lin elaborate_V = mkTerm "elaborate_V" ;
lin elaborate_V2 = mkTerm "elaborate_V2" ;
lin elaborateness_N = mkTerm "elaborateness_N" ;
lin elaboration_N = mkTerm "elaboration_N" ;
lin elaine_PN = mkTerm "elaine_PN" ;
lin elan_N = mkTerm "elan_N" ;
lin eland_N = mkTerm "eland_N" ;
lin elapid_N = mkTerm "elapid_N" ;
lin elapse_V = mkTerm "elapse_V" ;
lin elapsed_A = mkTerm "elapsed_A" ;
lin elasmobranch_N = mkTerm "elasmobranch_N" ;
lin elastance_N = mkTerm "elastance_N" ;
lin elastase_N = mkTerm "elastase_N" ;
lin elastic_A = mkTerm "elastic_A" ;
lin elastic_N = mkTerm "elastic_N" ;
lin elasticity_N = mkTerm "elasticity_N" ;
lin elasticized_A = mkTerm "elasticized_A" ;
lin elastin_N = mkTerm "elastin_N" ;
lin elastomer_N = mkTerm "elastomer_N" ;
lin elastoplast_N = mkTerm "elastoplast_N" ;
lin elastosis_N = mkTerm "elastosis_N" ;
lin elate_V2 = mkTerm "elate_V2" ;
lin elating_A = mkTerm "elating_A" ;
lin elation_N = mkTerm "elation_N" ;
lin elbow_N = mkTerm "elbow_N" ;
lin elbow_V2 = mkTerm "elbow_V2" ;
lin elbowing_N = mkTerm "elbowing_N" ;
lin elder_1_N = mkTerm "elder_1_N" ;
lin elder_2_N = mkTerm "elder_2_N" ;
lin elder_A = mkTerm "elder_A" ;
lin elderberry_N = mkTerm "elderberry_N" ;
lin elderly_A = mkTerm "elderly_A" ;
lin eldership_N = mkTerm "eldership_N" ;
lin elderslie_PN = mkTerm "elderslie_PN" ;
lin eldest_A = mkTerm "eldest_A" ;
lin eldritch_A = mkTerm "eldritch_A" ;
lin eleanor_PN = mkTerm "eleanor_PN" ;
lin elecampane_N = mkTerm "elecampane_N" ;
lin elect_A = mkTerm "elect_A" ;
lin elect_V = mkTerm "elect_V" ;
lin elect_V2 = mkTerm "elect_V2" ;
lin elect_V2V = mkTerm "elect_V2V" ;
lin elect_V3 = mkTerm "elect_V3" ;
lin elected_A = mkTerm "elected_A" ;
lin election_N = mkTerm "election_N" ;
lin electioneering_N = mkTerm "electioneering_N" ;
lin elective_A = mkTerm "elective_A" ;
lin elector_N = mkTerm "elector_N" ;
lin electoral_A = mkTerm "electoral_A" ;
lin electorate_N = mkTerm "electorate_N" ;
lin electric_A = mkTerm "electric_A" ;
lin electric_N = mkTerm "electric_N" ;
lin electrical_A = mkTerm "electrical_A" ;
lin electrician_N = mkTerm "electrician_N" ;
lin electricity_N = mkTerm "electricity_N" ;
lin electrification_N = mkTerm "electrification_N" ;
lin electrify_V2 = mkTerm "electrify_V2" ;
lin electrifying_A = mkTerm "electrifying_A" ;
lin electrocardiogram_N = mkTerm "electrocardiogram_N" ;
lin electrocardiograph_N = mkTerm "electrocardiograph_N" ;
lin electrocardiographic_A = mkTerm "electrocardiographic_A" ;
lin electrocautery_N = mkTerm "electrocautery_N" ;
lin electrochemical_A = mkTerm "electrochemical_A" ;
lin electrochemistry_N = mkTerm "electrochemistry_N" ;
lin electrocute_V2 = mkTerm "electrocute_V2" ;
lin electrocution_N = mkTerm "electrocution_N" ;
lin electrocutioner_N = mkTerm "electrocutioner_N" ;
lin electrode_N = mkTerm "electrode_N" ;
lin electrodeposition_N = mkTerm "electrodeposition_N" ;
lin electrodynamometer_N = mkTerm "electrodynamometer_N" ;
lin electroencephalogram_N = mkTerm "electroencephalogram_N" ;
lin electroencephalograph_N = mkTerm "electroencephalograph_N" ;
lin electroencephalographic_A = mkTerm "electroencephalographic_A" ;
lin electrograph_N = mkTerm "electrograph_N" ;
lin electrologist_N = mkTerm "electrologist_N" ;
lin electrolysis_N = mkTerm "electrolysis_N" ;
lin electrolyte_N = mkTerm "electrolyte_N" ;
lin electrolytic_A = mkTerm "electrolytic_A" ;
lin electrolytic_N = mkTerm "electrolytic_N" ;
lin electromagnet_N = mkTerm "electromagnet_N" ;
lin electromagnetic_A = mkTerm "electromagnetic_A" ;
lin electromagnetism_N = mkTerm "electromagnetism_N" ;
lin electromechanical_A = mkTerm "electromechanical_A" ;
lin electrometer_N = mkTerm "electrometer_N" ;
lin electromotive_A = mkTerm "electromotive_A" ;
lin electromyogram_N = mkTerm "electromyogram_N" ;
lin electromyograph_N = mkTerm "electromyograph_N" ;
lin electromyography_N = mkTerm "electromyography_N" ;
lin electron_N = mkTerm "electron_N" ;
lin electronegativity_N = mkTerm "electronegativity_N" ;
lin electronic_A = mkTerm "electronic_A" ;
lin electronics_N = mkTerm "electronics_N" ;
lin electrophoresis_N = mkTerm "electrophoresis_N" ;
lin electrophoretic_A = mkTerm "electrophoretic_A" ;
lin electrophorus_N = mkTerm "electrophorus_N" ;
lin electroplate_N = mkTerm "electroplate_N" ;
lin electroplate_V2 = mkTerm "electroplate_V2" ;
lin electroplater_N = mkTerm "electroplater_N" ;
lin electroretinogram_N = mkTerm "electroretinogram_N" ;
lin electroscope_N = mkTerm "electroscope_N" ;
lin electrosleep_N = mkTerm "electrosleep_N" ;
lin electrostatic_A = mkTerm "electrostatic_A" ;
lin electrostatics_N = mkTerm "electrostatics_N" ;
lin electrosurgery_N = mkTerm "electrosurgery_N" ;
lin electrotherapist_N = mkTerm "electrotherapist_N" ;
lin electrotherapy_N = mkTerm "electrotherapy_N" ;
lin electrum_N = mkTerm "electrum_N" ;
lin eleemosynary_A = mkTerm "eleemosynary_A" ;
lin elegance_N = mkTerm "elegance_N" ;
lin elegant_A = mkTerm "elegant_A" ;
lin elegiac_A = mkTerm "elegiac_A" ;
lin elegist_N = mkTerm "elegist_N" ;
lin elegy_N = mkTerm "elegy_N" ;
lin element_N = mkTerm "element_N" ;
lin elemental_A = mkTerm "elemental_A" ;
lin elementary_A = mkTerm "elementary_A" ;
lin elemi_N = mkTerm "elemi_N" ;
lin elephant_N = mkTerm "elephant_N" ;
lin elephantiasis_N = mkTerm "elephantiasis_N" ;
lin elephantine_A = mkTerm "elephantine_A" ;
lin elevate_V2 = mkTerm "elevate_V2" ;
lin elevation_N = mkTerm "elevation_N" ;
lin elevator_N = mkTerm "elevator_N" ;
lin elf_N = mkTerm "elf_N" ;
lin elfin_A = mkTerm "elfin_A" ;
lin elfish_A = mkTerm "elfish_A" ;
lin elgin_PN = mkTerm "elgin_PN" ;
lin elicit_V2 = mkTerm "elicit_V2" ;
lin elicitation_N = mkTerm "elicitation_N" ;
lin elide_V2 = mkTerm "elide_V2" ;
lin eligibility_N = mkTerm "eligibility_N" ;
lin eligible_A = mkTerm "eligible_A" ;
lin eliminate_V2 = mkTerm "eliminate_V2" ;
lin elimination_N = mkTerm "elimination_N" ;
lin eliminator_N = mkTerm "eliminator_N" ;
lin elimäki_PN = mkTerm "elimäki_PN" ;
lin elision_N = mkTerm "elision_N" ;
lin elite_A = mkTerm "elite_A" ;
lin elite_N = mkTerm "elite_N" ;
lin elitism_N = mkTerm "elitism_N" ;
lin elitistFem_N = mkTerm "elitistFem_N" ;
lin elitistMasc_N = mkTerm "elitistMasc_N" ;
lin elixir_N = mkTerm "elixir_N" ;
lin eliza_PN = mkTerm "eliza_PN" ;
lin elizabeth_PN = mkTerm "elizabeth_PN" ;
lin elizabethan_A = mkTerm "elizabethan_A" ;
lin elizabethan_N = mkTerm "elizabethan_N" ;
lin elk_N = mkTerm "elk_N" ;
lin ell_N = mkTerm "ell_N" ;
lin elland_PN = mkTerm "elland_PN" ;
lin ellen_PN = mkTerm "ellen_PN" ;
lin ellesmere_PN = mkTerm "ellesmere_PN" ;
lin ellesmere_port_PN = mkTerm "ellesmere_port_PN" ;
lin ellie_PN = mkTerm "ellie_PN" ;
lin ellipse_N = mkTerm "ellipse_N" ;
lin ellipsis_N = mkTerm "ellipsis_N" ;
lin ellipsoid_A = mkTerm "ellipsoid_A" ;
lin ellipsoid_N = mkTerm "ellipsoid_N" ;
lin elliptic_A = mkTerm "elliptic_A" ;
lin elliptical_A = mkTerm "elliptical_A" ;
lin elloughton_PN = mkTerm "elloughton_PN" ;
lin elm_N = mkTerm "elm_N" ;
lin elocution_N = mkTerm "elocution_N" ;
lin elocutionary_A = mkTerm "elocutionary_A" ;
lin elocutionistFem_N = mkTerm "elocutionistFem_N" ;
lin elocutionistMasc_N = mkTerm "elocutionistMasc_N" ;
lin elongate_A = mkTerm "elongate_A" ;
lin elongate_V = mkTerm "elongate_V" ;
lin elongate_V2 = mkTerm "elongate_V2" ;
lin elongation_N = mkTerm "elongation_N" ;
lin elope_V = mkTerm "elope_V" ;
lin elopement_N = mkTerm "elopement_N" ;
lin eloquence_N = mkTerm "eloquence_N" ;
lin eloquent_A = mkTerm "eloquent_A" ;
lin else_Adv = mkTerm "else_Adv" ;
lin elsewhere_Adv = mkTerm "elsewhere_Adv" ;
lin elsholtzia_N = mkTerm "elsholtzia_N" ;
lin elsie_PN = mkTerm "elsie_PN" ;
lin elstree_PN = mkTerm "elstree_PN" ;
lin eluate_N = mkTerm "eluate_N" ;
lin elucidate_V2 = mkTerm "elucidate_V2" ;
lin elucidation_N = mkTerm "elucidation_N" ;
lin elude_V2 = mkTerm "elude_V2" ;
lin elusive_A = mkTerm "elusive_A" ;
lin elusiveness_N = mkTerm "elusiveness_N" ;
lin elution_N = mkTerm "elution_N" ;
lin elver_N = mkTerm "elver_N" ;
lin elves_N = mkTerm "elves_N" ;
lin elvish_A = mkTerm "elvish_A" ;
lin ely_PN = mkTerm "ely_PN" ;
lin elysian_A = mkTerm "elysian_A" ;
lin elysium_PN = mkTerm "elysium_PN" ;
lin em_N = mkTerm "em_N" ;
lin emaciate_V2 = mkTerm "emaciate_V2" ;
lin emaciation_N = mkTerm "emaciation_N" ;
lin email_N = mkTerm "email_N" ;
lin emanate_V = mkTerm "emanate_V" ;
lin emanation_N = mkTerm "emanation_N" ;
lin emancipate_V2 = mkTerm "emancipate_V2" ;
lin emancipation_N = mkTerm "emancipation_N" ;
lin emancipative_A = mkTerm "emancipative_A" ;
lin emancipator_N = mkTerm "emancipator_N" ;
lin emarginate_A = mkTerm "emarginate_A" ;
lin emasculate_V2 = mkTerm "emasculate_V2" ;
lin emasculation_N = mkTerm "emasculation_N" ;
lin embalm_V2 = mkTerm "embalm_V2" ;
lin embalmer_N = mkTerm "embalmer_N" ;
lin embalmment_N = mkTerm "embalmment_N" ;
lin embankment_N = mkTerm "embankment_N" ;
lin embargo_N = mkTerm "embargo_N" ;
lin embargo_V2 = mkTerm "embargo_V2" ;
lin embark_V = mkTerm "embark_V" ;
lin embark_V2 = mkTerm "embark_V2" ;
lin embark_on_V2 = mkTerm "embark_on_V2" ;
lin embark_upon_V2 = mkTerm "embark_upon_V2" ;
lin embarkation_N = mkTerm "embarkation_N" ;
lin embarrass_V2 = mkTerm "embarrass_V2" ;
lin embarrassed_A = mkTerm "embarrassed_A" ;
lin embarrassing_A = mkTerm "embarrassing_A" ;
lin embarrassment_N = mkTerm "embarrassment_N" ;
lin embassy_N = mkTerm "embassy_N" ;
lin embattled_A = mkTerm "embattled_A" ;
lin embed_V2 = mkTerm "embed_V2" ;
lin embellish_V2 = mkTerm "embellish_V2" ;
lin embellishment_N = mkTerm "embellishment_N" ;
lin ember_N = mkTerm "ember_N" ;
lin embezzle_V2 = mkTerm "embezzle_V2" ;
lin embezzlement_N = mkTerm "embezzlement_N" ;
lin embezzler_N = mkTerm "embezzler_N" ;
lin embitter_V2 = mkTerm "embitter_V2" ;
lin embitterment_N = mkTerm "embitterment_N" ;
lin emblazon_V2 = mkTerm "emblazon_V2" ;
lin emblem_N = mkTerm "emblem_N" ;
lin emblematic_A = mkTerm "emblematic_A" ;
lin embodiment_N = mkTerm "embodiment_N" ;
lin embody_V2 = mkTerm "embody_V2" ;
lin embolden_V2 = mkTerm "embolden_V2" ;
lin embolectomy_N = mkTerm "embolectomy_N" ;
lin embolic_A = mkTerm "embolic_A" ;
lin embolism_N = mkTerm "embolism_N" ;
lin embolus_N = mkTerm "embolus_N" ;
lin embonpoint_A = mkTerm "embonpoint_A" ;
lin embonpoint_N = mkTerm "embonpoint_N" ;
lin emboss_V2 = mkTerm "emboss_V2" ;
lin embrace_N = mkTerm "embrace_N" ;
lin embrace_V = mkTerm "embrace_V" ;
lin embrace_V2 = mkTerm "embrace_V2" ;
lin embrasure_N = mkTerm "embrasure_N" ;
lin embrocation_N = mkTerm "embrocation_N" ;
lin embroider_V = mkTerm "embroider_V" ;
lin embroider_V2 = mkTerm "embroider_V2" ;
lin embroiderer_N = mkTerm "embroiderer_N" ;
lin embroideress_N = mkTerm "embroideress_N" ;
lin embroidery_N = mkTerm "embroidery_N" ;
lin embroil_V = mkTerm "embroil_V" ;
lin embroil_V2 = mkTerm "embroil_V2" ;
lin embryo_N = mkTerm "embryo_N" ;
lin embryologist_N = mkTerm "embryologist_N" ;
lin embryology_N = mkTerm "embryology_N" ;
lin embryonic_A = mkTerm "embryonic_A" ;
lin emeer_N = mkTerm "emeer_N" ;
lin emend_V2 = mkTerm "emend_V2" ;
lin emendation_N = mkTerm "emendation_N" ;
lin emerald_N = mkTerm "emerald_N" ;
lin emerge_V = mkTerm "emerge_V" ;
lin emergence_N = mkTerm "emergence_N" ;
lin emergency_N = mkTerm "emergency_N" ;
lin emergent_A = mkTerm "emergent_A" ;
lin emeritus_A = mkTerm "emeritus_A" ;
lin emeritus_N = mkTerm "emeritus_N" ;
lin emery_N = mkTerm "emery_N" ;
lin emetic_N = mkTerm "emetic_N" ;
lin emigrant_N = mkTerm "emigrant_N" ;
lin emigrate_V = mkTerm "emigrate_V" ;
lin emigrate_V2V = mkTerm "emigrate_V2V" ;
lin emigration_N = mkTerm "emigration_N" ;
lin emigre_N = mkTerm "emigre_N" ;
lin emily_PN = mkTerm "emily_PN" ;
lin eminence_N = mkTerm "eminence_N" ;
lin eminent_A = mkTerm "eminent_A" ;
lin emir_N = mkTerm "emir_N" ;
lin emirate_N = mkTerm "emirate_N" ;
lin emissary_N = mkTerm "emissary_N" ;
lin emission_N = mkTerm "emission_N" ;
lin emit_V2 = mkTerm "emit_V2" ;
lin emitter_N = mkTerm "emitter_N" ;
lin emma_PN = mkTerm "emma_PN" ;
lin emmenagogue_N = mkTerm "emmenagogue_N" ;
lin emmer_N = mkTerm "emmer_N" ;
lin emmetropia_N = mkTerm "emmetropia_N" ;
lin emmetropic_A = mkTerm "emmetropic_A" ;
lin emolument_N = mkTerm "emolument_N" ;
lin emoticon_N = mkTerm "emoticon_N" ;
lin emotion_N = mkTerm "emotion_N" ;
lin emotional_A = mkTerm "emotional_A" ;
lin emotionality_N = mkTerm "emotionality_N" ;
lin emotionless_A = mkTerm "emotionless_A" ;
lin emotionlessness_N = mkTerm "emotionlessness_N" ;
lin emotive_A = mkTerm "emotive_A" ;
lin empale_V2 = mkTerm "empale_V2" ;
lin empanel_V2 = mkTerm "empanel_V2" ;
lin empathic_A = mkTerm "empathic_A" ;
lin empathize_V = mkTerm "empathize_V" ;
lin empathy_N = mkTerm "empathy_N" ;
lin emperor_N = mkTerm "emperor_N" ;
lin emphasis_N = mkTerm "emphasis_N" ;
lin emphasize_V2 = mkTerm "emphasize_V2" ;
lin emphasize_VS = mkTerm "emphasize_VS" ;
lin emphasizing_N = mkTerm "emphasizing_N" ;
lin emphatic_A = mkTerm "emphatic_A" ;
lin emphysema_N = mkTerm "emphysema_N" ;
lin emphysematous_A = mkTerm "emphysematous_A" ;
lin empire_N = mkTerm "empire_N" ;
lin empiric_A = mkTerm "empiric_A" ;
lin empirical_A = mkTerm "empirical_A" ;
lin empiricism_N = mkTerm "empiricism_N" ;
lin empiricist_N = mkTerm "empiricist_N" ;
lin emplacement_N = mkTerm "emplacement_N" ;
lin emplane_V = mkTerm "emplane_V" ;
lin emplane_V2 = mkTerm "emplane_V2" ;
lin employ_N = mkTerm "employ_N" ;
lin employ_V2 = mkTerm "employ_V2" ;
lin employable_A = mkTerm "employable_A" ;
lin employable_N = mkTerm "employable_N" ;
lin employee_N = mkTerm "employee_N" ;
lin employer_N = mkTerm "employer_N" ;
lin employment_N = mkTerm "employment_N" ;
lin emporium_N = mkTerm "emporium_N" ;
lin empower_V2 = mkTerm "empower_V2" ;
lin empower_V2V = mkTerm "empower_V2V" ;
lin empress_N = mkTerm "empress_N" ;
lin emptiness_N = mkTerm "emptiness_N" ;
lin empty_A = mkTerm "empty_A" ;
lin empty_N = mkTerm "empty_N" ;
lin empty_V = mkTerm "empty_V" ;
lin empty_V2 = mkTerm "empty_V2" ;
lin empty_handed_A = mkTerm "empty_handed_A" ;
lin empty_headed_A = mkTerm "empty_headed_A" ;
lin empty_out_V2 = mkTerm "empty_out_V2" ;
lin emptying_N = mkTerm "emptying_N" ;
lin empurpled_A = mkTerm "empurpled_A" ;
lin empyema_N = mkTerm "empyema_N" ;
lin empyreal_A = mkTerm "empyreal_A" ;
lin empyrean_A = mkTerm "empyrean_A" ;
lin empyrean_N = mkTerm "empyrean_N" ;
lin emsworth_PN = mkTerm "emsworth_PN" ;
lin emu_N = mkTerm "emu_N" ;
lin emulate_V2 = mkTerm "emulate_V2" ;
lin emulation_N = mkTerm "emulation_N" ;
lin emulator_N = mkTerm "emulator_N" ;
lin emulous_A = mkTerm "emulous_A" ;
lin emulsifier_N = mkTerm "emulsifier_N" ;
lin emulsify_V2 = mkTerm "emulsify_V2" ;
lin emulsion_N = mkTerm "emulsion_N" ;
lin en_N = mkTerm "en_N" ;
lin en_clair_Adv = mkTerm "en_clair_Adv" ;
lin en_famille_Adv = mkTerm "en_famille_Adv" ;
lin en_masse_Adv = mkTerm "en_masse_Adv" ;
lin en_route_Adv = mkTerm "en_route_Adv" ;
lin enable_V2 = mkTerm "enable_V2" ;
lin enable_V2V = mkTerm "enable_V2V" ;
lin enable_VS = mkTerm "enable_VS" ;
lin enabling_A = mkTerm "enabling_A" ;
lin enact_V2 = mkTerm "enact_V2" ;
lin enact_V2V = mkTerm "enact_V2V" ;
lin enactment_N = mkTerm "enactment_N" ;
lin enalapril_N = mkTerm "enalapril_N" ;
lin enallage_N = mkTerm "enallage_N" ;
lin enamel_N = mkTerm "enamel_N" ;
lin enamel_V2 = mkTerm "enamel_V2" ;
lin enamelware_N = mkTerm "enamelware_N" ;
lin enamine_N = mkTerm "enamine_N" ;
lin enamored_A = mkTerm "enamored_A" ;
lin enamour_V2 = mkTerm "enamour_V2" ;
lin enanthem_N = mkTerm "enanthem_N" ;
lin enantiomorph_N = mkTerm "enantiomorph_N" ;
lin enantiomorphism_N = mkTerm "enantiomorphism_N" ;
lin enate_A = mkTerm "enate_A" ;
lin enate_N = mkTerm "enate_N" ;
lin enc_PN = mkTerm "enc_PN" ;
lin encainide_N = mkTerm "encainide_N" ;
lin encamp_V = mkTerm "encamp_V" ;
lin encamp_V2 = mkTerm "encamp_V2" ;
lin encampment_N = mkTerm "encampment_N" ;
lin encapsulation_N = mkTerm "encapsulation_N" ;
lin encase_V2 = mkTerm "encase_V2" ;
lin encasement_N = mkTerm "encasement_N" ;
lin encaustic_A = mkTerm "encaustic_A" ;
lin encaustic_N = mkTerm "encaustic_N" ;
lin encephalartos_N = mkTerm "encephalartos_N" ;
lin encephalitis_N = mkTerm "encephalitis_N" ;
lin encephalocele_N = mkTerm "encephalocele_N" ;
lin encephalogram_N = mkTerm "encephalogram_N" ;
lin encephalography_N = mkTerm "encephalography_N" ;
lin encephalomyelitis_N = mkTerm "encephalomyelitis_N" ;
lin enchain_V2 = mkTerm "enchain_V2" ;
lin enchant_V2 = mkTerm "enchant_V2" ;
lin enchanter_N = mkTerm "enchanter_N" ;
lin enchantingly_Adv = mkTerm "enchantingly_Adv" ;
lin enchantment_N = mkTerm "enchantment_N" ;
lin enchantress_N = mkTerm "enchantress_N" ;
lin enchilada_N = mkTerm "enchilada_N" ;
lin enchondroma_N = mkTerm "enchondroma_N" ;
lin encircle_V2 = mkTerm "encircle_V2" ;
lin encirclement_N = mkTerm "encirclement_N" ;
lin enclave_N = mkTerm "enclave_N" ;
lin enclose_V2 = mkTerm "enclose_V2" ;
lin enclosure_1_N = mkTerm "enclosure_1_N" ;
lin enclosure_2_N = mkTerm "enclosure_2_N" ;
lin enclosure_3_N = mkTerm "enclosure_3_N" ;
lin encode_V2 = mkTerm "encode_V2" ;
lin encoding_N = mkTerm "encoding_N" ;
lin encolure_N = mkTerm "encolure_N" ;
lin encomiastic_A = mkTerm "encomiastic_A" ;
lin encomium_N = mkTerm "encomium_N" ;
lin encompass_V2 = mkTerm "encompass_V2" ;
lin encompassment_N = mkTerm "encompassment_N" ;
lin encopresis_N = mkTerm "encopresis_N" ;
lin encore_N = mkTerm "encore_N" ;
lin encore_V2 = mkTerm "encore_V2" ;
lin encounter_N = mkTerm "encounter_N" ;
lin encounter_V2 = mkTerm "encounter_V2" ;
lin encourage_V2 = mkTerm "encourage_V2" ;
lin encourage_V2V = mkTerm "encourage_V2V" ;
lin encouragement_N = mkTerm "encouragement_N" ;
lin encouraging_A = mkTerm "encouraging_A" ;
lin encroach_V = mkTerm "encroach_V" ;
lin encroachment_N = mkTerm "encroachment_N" ;
lin encrust_V = mkTerm "encrust_V" ;
lin encrust_V2 = mkTerm "encrust_V2" ;
lin encrypt_V2 = mkTerm "encrypt_V2" ;
lin encryption_N = mkTerm "encryption_N" ;
lin encumber_V2 = mkTerm "encumber_V2" ;
lin encumbrance_N = mkTerm "encumbrance_N" ;
lin encyclical_A = mkTerm "encyclical_A" ;
lin encyclical_N = mkTerm "encyclical_N" ;
lin encyclopaedia_N = mkTerm "encyclopaedia_N" ;
lin encyclopaedic_A = mkTerm "encyclopaedic_A" ;
lin encyclopedia_N = mkTerm "encyclopedia_N" ;
lin encyclopedic_A = mkTerm "encyclopedic_A" ;
lin encyclopedist_N = mkTerm "encyclopedist_N" ;
lin encysted_A = mkTerm "encysted_A" ;
lin end_1_N = mkTerm "end_1_N" ;
lin end_2_N = mkTerm "end_2_N" ;
lin end_V = mkTerm "end_V" ;
lin end_V2 = mkTerm "end_V2" ;
lin end_all_N = mkTerm "end_all_N" ;
lin end_in_V2 = mkTerm "end_in_V2" ;
lin end_tail_V2 = mkTerm "end_tail_V2" ;
lin end_up_V2 = mkTerm "end_up_V2" ;
lin end_up_with_V2 = mkTerm "end_up_with_V2" ;
lin endameba_N = mkTerm "endameba_N" ;
lin endanger_V2 = mkTerm "endanger_V2" ;
lin endarterectomy_N = mkTerm "endarterectomy_N" ;
lin endarteritis_N = mkTerm "endarteritis_N" ;
lin endear_V2 = mkTerm "endear_V2" ;
lin endearingly_Adv = mkTerm "endearingly_Adv" ;
lin endearment_N = mkTerm "endearment_N" ;
lin endeavour_N = mkTerm "endeavour_N" ;
lin endeavour_V = mkTerm "endeavour_V" ;
lin endemic_A = mkTerm "endemic_A" ;
lin endemic_N = mkTerm "endemic_N" ;
lin endergonic_A = mkTerm "endergonic_A" ;
lin endermic_A = mkTerm "endermic_A" ;
lin endgame_N = mkTerm "endgame_N" ;
lin ending_N = mkTerm "ending_N" ;
lin endive_N = mkTerm "endive_N" ;
lin endless_A = mkTerm "endless_A" ;
lin endlessness_N = mkTerm "endlessness_N" ;
lin endocarditis_N = mkTerm "endocarditis_N" ;
lin endocardium_N = mkTerm "endocardium_N" ;
lin endocentric_A = mkTerm "endocentric_A" ;
lin endocervicitis_N = mkTerm "endocervicitis_N" ;
lin endocranium_N = mkTerm "endocranium_N" ;
lin endocrine_A = mkTerm "endocrine_A" ;
lin endocrinologist_N = mkTerm "endocrinologist_N" ;
lin endocrinology_N = mkTerm "endocrinology_N" ;
lin endoderm_N = mkTerm "endoderm_N" ;
lin endodontic_A = mkTerm "endodontic_A" ;
lin endodontics_N = mkTerm "endodontics_N" ;
lin endodontist_N = mkTerm "endodontist_N" ;
lin endoergic_A = mkTerm "endoergic_A" ;
lin endogamous_A = mkTerm "endogamous_A" ;
lin endogamy_N = mkTerm "endogamy_N" ;
lin endogenic_A = mkTerm "endogenic_A" ;
lin endogenous_A = mkTerm "endogenous_A" ;
lin endogeny_N = mkTerm "endogeny_N" ;
lin endolymph_N = mkTerm "endolymph_N" ;
lin endometrial_A = mkTerm "endometrial_A" ;
lin endometriosis_N = mkTerm "endometriosis_N" ;
lin endometrium_N = mkTerm "endometrium_N" ;
lin endomorph_N = mkTerm "endomorph_N" ;
lin endomorphic_A = mkTerm "endomorphic_A" ;
lin endomorphy_N = mkTerm "endomorphy_N" ;
lin endoneurium_N = mkTerm "endoneurium_N" ;
lin endonuclease_N = mkTerm "endonuclease_N" ;
lin endoparasite_N = mkTerm "endoparasite_N" ;
lin endoparasitic_A = mkTerm "endoparasitic_A" ;
lin endoplasm_N = mkTerm "endoplasm_N" ;
lin endorphin_N = mkTerm "endorphin_N" ;
lin endorse_V2 = mkTerm "endorse_V2" ;
lin endorsement_N = mkTerm "endorsement_N" ;
lin endorser_N = mkTerm "endorser_N" ;
lin endoscope_N = mkTerm "endoscope_N" ;
lin endoscopic_A = mkTerm "endoscopic_A" ;
lin endoscopy_N = mkTerm "endoscopy_N" ;
lin endoskeleton_N = mkTerm "endoskeleton_N" ;
lin endosperm_N = mkTerm "endosperm_N" ;
lin endospore_N = mkTerm "endospore_N" ;
lin endosteum_N = mkTerm "endosteum_N" ;
lin endothelial_A = mkTerm "endothelial_A" ;
lin endothelium_N = mkTerm "endothelium_N" ;
lin endothermic_A = mkTerm "endothermic_A" ;
lin endotoxin_N = mkTerm "endotoxin_N" ;
lin endow_V2 = mkTerm "endow_V2" ;
lin endowment_N = mkTerm "endowment_N" ;
lin endue_V2 = mkTerm "endue_V2" ;
lin endurable_A = mkTerm "endurable_A" ;
lin endurance_N = mkTerm "endurance_N" ;
lin endure_V = mkTerm "endure_V" ;
lin endure_V2 = mkTerm "endure_V2" ;
lin enduring_A = mkTerm "enduring_A" ;
lin endways_Adv = mkTerm "endways_Adv" ;
lin endwise_Adv = mkTerm "endwise_Adv" ;
lin enema_N = mkTerm "enema_N" ;
lin enemy_N = mkTerm "enemy_N" ;
lin energetic_A = mkTerm "energetic_A" ;
lin energid_N = mkTerm "energid_N" ;
lin energizer_N = mkTerm "energizer_N" ;
lin energizing_A = mkTerm "energizing_A" ;
lin energizing_N = mkTerm "energizing_N" ;
lin energy_N = mkTerm "energy_N" ;
lin enervate_V2 = mkTerm "enervate_V2" ;
lin enervation_N = mkTerm "enervation_N" ;
lin enfant_terrible_N = mkTerm "enfant_terrible_N" ;
lin enfeeble_V2 = mkTerm "enfeeble_V2" ;
lin enfeoffment_N = mkTerm "enfeoffment_N" ;
lin enfield_PN = mkTerm "enfield_PN" ;
lin enfilade_N = mkTerm "enfilade_N" ;
lin enflurane_N = mkTerm "enflurane_N" ;
lin enfold_V2 = mkTerm "enfold_V2" ;
lin enforce_V2 = mkTerm "enforce_V2" ;
lin enforceable_A = mkTerm "enforceable_A" ;
lin enforcement_N = mkTerm "enforcement_N" ;
lin enfranchise_V2 = mkTerm "enfranchise_V2" ;
lin enfranchisement_N = mkTerm "enfranchisement_N" ;
lin engage_V = mkTerm "engage_V" ;
lin engage_V2 = mkTerm "engage_V2" ;
lin engagement_N = mkTerm "engagement_N" ;
lin engelmannia_N = mkTerm "engelmannia_N" ;
lin engender_V2 = mkTerm "engender_V2" ;
lin engine_N = mkTerm "engine_N" ;
lin engine_driver_N = mkTerm "engine_driver_N" ;
lin engineer_N = mkTerm "engineer_N" ;
lin engineer_V = mkTerm "engineer_V" ;
lin engineer_V2 = mkTerm "engineer_V2" ;
lin engineering_N = mkTerm "engineering_N" ;
lin enginery_N = mkTerm "enginery_N" ;
lin england_PN = mkTerm "england_PN" ;
lin englishFem_N = mkTerm "englishFem_N" ;
lin englishMasc_N = mkTerm "englishMasc_N" ;
lin english_A = mkTerm "english_A" ;
lin engorgement_N = mkTerm "engorgement_N" ;
lin engraft_V2 = mkTerm "engraft_V2" ;
lin engram_N = mkTerm "engram_N" ;
lin engrave_V2 = mkTerm "engrave_V2" ;
lin engraver_N = mkTerm "engraver_N" ;
lin engraving_N = mkTerm "engraving_N" ;
lin engross_V2 = mkTerm "engross_V2" ;
lin engulf_V2 = mkTerm "engulf_V2" ;
lin enhance_V2 = mkTerm "enhance_V2" ;
lin enhanced_A = mkTerm "enhanced_A" ;
lin enhancement_N = mkTerm "enhancement_N" ;
lin enigma_N = mkTerm "enigma_N" ;
lin enigmatic_A = mkTerm "enigmatic_A" ;
lin enjambment_N = mkTerm "enjambment_N" ;
lin enjoin_V2 = mkTerm "enjoin_V2" ;
lin enjoy_V2 = mkTerm "enjoy_V2" ;
lin enjoy_VV = mkTerm "enjoy_VV" ;
lin enjoyable_A = mkTerm "enjoyable_A" ;
lin enjoyableness_N = mkTerm "enjoyableness_N" ;
lin enjoyer_N = mkTerm "enjoyer_N" ;
lin enjoyment_N = mkTerm "enjoyment_N" ;
lin enkephalin_N = mkTerm "enkephalin_N" ;
lin enkindle_V2 = mkTerm "enkindle_V2" ;
lin enlarge_V = mkTerm "enlarge_V" ;
lin enlarge_V2 = mkTerm "enlarge_V2" ;
lin enlargement_N = mkTerm "enlargement_N" ;
lin enlarger_N = mkTerm "enlarger_N" ;
lin enlighten_V2 = mkTerm "enlighten_V2" ;
lin enlightening_A = mkTerm "enlightening_A" ;
lin enlightenment_N = mkTerm "enlightenment_N" ;
lin enlist_V = mkTerm "enlist_V" ;
lin enlist_V2 = mkTerm "enlist_V2" ;
lin enlistment_N = mkTerm "enlistment_N" ;
lin enliven_V2 = mkTerm "enliven_V2" ;
lin enmesh_V2 = mkTerm "enmesh_V2" ;
lin enmity_N = mkTerm "enmity_N" ;
lin ennoble_V2 = mkTerm "ennoble_V2" ;
lin ennoblement_N = mkTerm "ennoblement_N" ;
lin ennobling_A = mkTerm "ennobling_A" ;
lin ennui_N = mkTerm "ennui_N" ;
lin ennumerate_V2 = mkTerm "ennumerate_V2" ;
lin eno_PN = mkTerm "eno_PN" ;
lin enoch_PN = mkTerm "enoch_PN" ;
lin enol_N = mkTerm "enol_N" ;
lin enolic_A = mkTerm "enolic_A" ;
lin enologist_N = mkTerm "enologist_N" ;
lin enology_N = mkTerm "enology_N" ;
lin enonkoski_PN = mkTerm "enonkoski_PN" ;
lin enontekiö_PN = mkTerm "enontekiö_PN" ;
lin enophile_N = mkTerm "enophile_N" ;
lin enormity_N = mkTerm "enormity_N" ;
lin enormous_A = mkTerm "enormous_A" ;
lin enormousness_N = mkTerm "enormousness_N" ;
lin enosis_N = mkTerm "enosis_N" ;
lin enough_A = mkTerm "enough_A" ;
lin enough_N = mkTerm "enough_N" ;
lin enough_Predet = mkTerm "enough_Predet" ;
lin enplane_V = mkTerm "enplane_V" ;
lin enplane_V2 = mkTerm "enplane_V2" ;
lin enquire_V = mkTerm "enquire_V" ;
lin enquire_V2 = mkTerm "enquire_V2" ;
lin enquirer_N = mkTerm "enquirer_N" ;
lin enquiringly_Adv = mkTerm "enquiringly_Adv" ;
lin enquiry_N = mkTerm "enquiry_N" ;
lin enrage_V2 = mkTerm "enrage_V2" ;
lin enrapture_V2 = mkTerm "enrapture_V2" ;
lin enrich_V2 = mkTerm "enrich_V2" ;
lin enrichment_N = mkTerm "enrichment_N" ;
lin enrol_V = mkTerm "enrol_V" ;
lin enrol_V2 = mkTerm "enrol_V2" ;
lin enroll_V = mkTerm "enroll_V" ;
lin enroll_V2 = mkTerm "enroll_V2" ;
lin enrollee_N = mkTerm "enrollee_N" ;
lin enrollment_N = mkTerm "enrollment_N" ;
lin enrolment_N = mkTerm "enrolment_N" ;
lin enschede_PN = mkTerm "enschede_PN" ;
lin ensconce_V2 = mkTerm "ensconce_V2" ;
lin ensemble_N = mkTerm "ensemble_N" ;
lin enshrine_V2 = mkTerm "enshrine_V2" ;
lin enshroud_V2 = mkTerm "enshroud_V2" ;
lin ensiform_A = mkTerm "ensiform_A" ;
lin ensign_N = mkTerm "ensign_N" ;
lin ensilage_N = mkTerm "ensilage_N" ;
lin enslave_V2 = mkTerm "enslave_V2" ;
lin enslavement_N = mkTerm "enslavement_N" ;
lin ensnare_V2 = mkTerm "ensnare_V2" ;
lin ensue_V = mkTerm "ensue_V" ;
lin ensure_V = mkTerm "ensure_V" ;
lin ensure_V2 = mkTerm "ensure_V2" ;
lin ensure_VS = mkTerm "ensure_VS" ;
lin entablature_N = mkTerm "entablature_N" ;
lin entail_N = mkTerm "entail_N" ;
lin entail_V2 = mkTerm "entail_V2" ;
lin entangle_V2 = mkTerm "entangle_V2" ;
lin entanglement_N = mkTerm "entanglement_N" ;
lin entasis_N = mkTerm "entasis_N" ;
lin entelechy_N = mkTerm "entelechy_N" ;
lin entellus_N = mkTerm "entellus_N" ;
lin entente_N = mkTerm "entente_N" ;
lin entente_cordiale_N = mkTerm "entente_cordiale_N" ;
lin enter_V = mkTerm "enter_V" ;
lin enter_V2 = mkTerm "enter_V2" ;
lin enter_for_V2 = mkTerm "enter_for_V2" ;
lin enter_into_V2 = mkTerm "enter_into_V2" ;
lin enteric_A = mkTerm "enteric_A" ;
lin enteritis_N = mkTerm "enteritis_N" ;
lin enterobiasis_N = mkTerm "enterobiasis_N" ;
lin enterokinase_N = mkTerm "enterokinase_N" ;
lin enterolith_N = mkTerm "enterolith_N" ;
lin enterolithiasis_N = mkTerm "enterolithiasis_N" ;
lin enteron_N = mkTerm "enteron_N" ;
lin enteropathy_N = mkTerm "enteropathy_N" ;
lin enteroptosis_N = mkTerm "enteroptosis_N" ;
lin enterostenosis_N = mkTerm "enterostenosis_N" ;
lin enterostomy_N = mkTerm "enterostomy_N" ;
lin enterotoxemia_N = mkTerm "enterotoxemia_N" ;
lin enterotoxin_N = mkTerm "enterotoxin_N" ;
lin enterovirus_N = mkTerm "enterovirus_N" ;
lin enterprise_N = mkTerm "enterprise_N" ;
lin enterprising_A = mkTerm "enterprising_A" ;
lin entertain_V2 = mkTerm "entertain_V2" ;
lin entertainer_N = mkTerm "entertainer_N" ;
lin entertaining_A = mkTerm "entertaining_A" ;
lin entertainment_N = mkTerm "entertainment_N" ;
lin enthral_V2 = mkTerm "enthral_V2" ;
lin enthrall_V2 = mkTerm "enthrall_V2" ;
lin enthrone_V2 = mkTerm "enthrone_V2" ;
lin enthronement_N = mkTerm "enthronement_N" ;
lin enthuse_V = mkTerm "enthuse_V" ;
lin enthusiasm_N = mkTerm "enthusiasm_N" ;
lin enthusiast_N = mkTerm "enthusiast_N" ;
lin enthusiastic_A = mkTerm "enthusiastic_A" ;
lin entice_V2 = mkTerm "entice_V2" ;
lin enticement_N = mkTerm "enticement_N" ;
lin entire_A = mkTerm "entire_A" ;
lin entirety_N = mkTerm "entirety_N" ;
lin entitle_V2V = mkTerm "entitle_V2V" ;
lin entitle_VS = mkTerm "entitle_VS" ;
lin entitlement_N = mkTerm "entitlement_N" ;
lin entity_N = mkTerm "entity_N" ;
lin entomb_V2 = mkTerm "entomb_V2" ;
lin entomion_N = mkTerm "entomion_N" ;
lin entomological_A = mkTerm "entomological_A" ;
lin entomologist_N = mkTerm "entomologist_N" ;
lin entomology_N = mkTerm "entomology_N" ;
lin entomophilous_A = mkTerm "entomophilous_A" ;
lin entomophobia_N = mkTerm "entomophobia_N" ;
lin entoproct_N = mkTerm "entoproct_N" ;
lin entourage_N = mkTerm "entourage_N" ;
lin entozoan_A = mkTerm "entozoan_A" ;
lin entozoic_A = mkTerm "entozoic_A" ;
lin entr'acte_N = mkTerm "entr'acte_N" ;
lin entrain_V = mkTerm "entrain_V" ;
lin entrain_V2 = mkTerm "entrain_V2" ;
lin entrance_N = mkTerm "entrance_N" ;
lin entrance_V2 = mkTerm "entrance_V2" ;
lin entrance_fee_N = mkTerm "entrance_fee_N" ;
lin entrance_money_N = mkTerm "entrance_money_N" ;
lin entrancement_N = mkTerm "entrancement_N" ;
lin entrant_N = mkTerm "entrant_N" ;
lin entrap_V2 = mkTerm "entrap_V2" ;
lin entrapment_N = mkTerm "entrapment_N" ;
lin entreat_V2 = mkTerm "entreat_V2" ;
lin entreatingly_Adv = mkTerm "entreatingly_Adv" ;
lin entreaty_N = mkTerm "entreaty_N" ;
lin entrecote_N = mkTerm "entrecote_N" ;
lin entree_N = mkTerm "entree_N" ;
lin entrench_V2 = mkTerm "entrench_V2" ;
lin entrenchment_N = mkTerm "entrenchment_N" ;
lin entrepot_N = mkTerm "entrepot_N" ;
lin entrepreneur_N = mkTerm "entrepreneur_N" ;
lin entrepreneurial_A = mkTerm "entrepreneurial_A" ;
lin entropy_N = mkTerm "entropy_N" ;
lin entrust_V2 = mkTerm "entrust_V2" ;
lin entry_1_N = mkTerm "entry_1_N" ;
lin entry_2_N = mkTerm "entry_2_N" ;
lin entwin_V = mkTerm "entwin_V" ;
lin entwine_V2 = mkTerm "entwine_V2" ;
lin enucleation_N = mkTerm "enucleation_N" ;
lin enumerate_V2 = mkTerm "enumerate_V2" ;
lin enumeration_N = mkTerm "enumeration_N" ;
lin enunciate_V = mkTerm "enunciate_V" ;
lin enunciate_V2 = mkTerm "enunciate_V2" ;
lin enunciation_N = mkTerm "enunciation_N" ;
lin enured_A = mkTerm "enured_A" ;
lin enuresis_N = mkTerm "enuresis_N" ;
lin envelop_V2 = mkTerm "envelop_V2" ;
lin envelope_N = mkTerm "envelope_N" ;
lin envelopment_N = mkTerm "envelopment_N" ;
lin envenom_V2 = mkTerm "envenom_V2" ;
lin enviable_A = mkTerm "enviable_A" ;
lin envious_A = mkTerm "envious_A" ;
lin environ_V2 = mkTerm "environ_V2" ;
lin environment_N = mkTerm "environment_N" ;
lin environmental_A = mkTerm "environmental_A" ;
lin environmentalism_N = mkTerm "environmentalism_N" ;
lin environmentalist_N = mkTerm "environmentalist_N" ;
lin environs_N = mkTerm "environs_N" ;
lin envisage_V2 = mkTerm "envisage_V2" ;
lin envision_V2 = mkTerm "envision_V2" ;
lin envision_VS = mkTerm "envision_VS" ;
lin envisioned_A = mkTerm "envisioned_A" ;
lin envoi_N = mkTerm "envoi_N" ;
lin envoy_N = mkTerm "envoy_N" ;
lin envy_N = mkTerm "envy_N" ;
lin envy_V2 = mkTerm "envy_V2" ;
lin enwrap_V2 = mkTerm "enwrap_V2" ;
lin enzootic_A = mkTerm "enzootic_A" ;
lin enzymatic_A = mkTerm "enzymatic_A" ;
lin enzyme_N = mkTerm "enzyme_N" ;
lin enzymologist_N = mkTerm "enzymologist_N" ;
lin enzymology_N = mkTerm "enzymology_N" ;
lin eohippus_N = mkTerm "eohippus_N" ;
lin eolith_N = mkTerm "eolith_N" ;
lin eolithic_A = mkTerm "eolithic_A" ;
lin eon_N = mkTerm "eon_N" ;
lin eonian_A = mkTerm "eonian_A" ;
lin eoraptor_N = mkTerm "eoraptor_N" ;
lin eosin_N = mkTerm "eosin_N" ;
lin eosinopenia_N = mkTerm "eosinopenia_N" ;
lin eosinophil_N = mkTerm "eosinophil_N" ;
lin eosinophilia_N = mkTerm "eosinophilia_N" ;
lin eosinophilic_A = mkTerm "eosinophilic_A" ;
lin epacris_N = mkTerm "epacris_N" ;
lin epanalepsis_N = mkTerm "epanalepsis_N" ;
lin epanaphora_N = mkTerm "epanaphora_N" ;
lin epanodos_N = mkTerm "epanodos_N" ;
lin epanorthosis_N = mkTerm "epanorthosis_N" ;
lin eparch_N = mkTerm "eparch_N" ;
lin eparchial_A = mkTerm "eparchial_A" ;
lin eparchy_N = mkTerm "eparchy_N" ;
lin epaulet_N = mkTerm "epaulet_N" ;
lin epaulette_N = mkTerm "epaulette_N" ;
lin epauliere_N = mkTerm "epauliere_N" ;
lin epee_N = mkTerm "epee_N" ;
lin ependyma_N = mkTerm "ependyma_N" ;
lin epenthesis_N = mkTerm "epenthesis_N" ;
lin epenthetic_A = mkTerm "epenthetic_A" ;
lin epergne_N = mkTerm "epergne_N" ;
lin ephah_N = mkTerm "ephah_N" ;
lin ephedra_N = mkTerm "ephedra_N" ;
lin ephedrine_N = mkTerm "ephedrine_N" ;
lin ephemera_N = mkTerm "ephemera_N" ;
lin ephemeral_A = mkTerm "ephemeral_A" ;
lin ephemerality_N = mkTerm "ephemerality_N" ;
lin ephemerid_N = mkTerm "ephemerid_N" ;
lin ephemeris_N = mkTerm "ephemeris_N" ;
lin ephemeron_N = mkTerm "ephemeron_N" ;
lin epic_A = mkTerm "epic_A" ;
lin epic_N = mkTerm "epic_N" ;
lin epicalyx_N = mkTerm "epicalyx_N" ;
lin epicanthus_N = mkTerm "epicanthus_N" ;
lin epicardia_N = mkTerm "epicardia_N" ;
lin epicardium_N = mkTerm "epicardium_N" ;
lin epicarp_N = mkTerm "epicarp_N" ;
lin epicarpal_A = mkTerm "epicarpal_A" ;
lin epicentre_N = mkTerm "epicentre_N" ;
lin epicondyle_N = mkTerm "epicondyle_N" ;
lin epicondylitis_N = mkTerm "epicondylitis_N" ;
lin epicranium_N = mkTerm "epicranium_N" ;
lin epicure_N = mkTerm "epicure_N" ;
lin epicurean_A = mkTerm "epicurean_A" ;
lin epicurean_N = mkTerm "epicurean_N" ;
lin epicureanism_N = mkTerm "epicureanism_N" ;
lin epicurism_N = mkTerm "epicurism_N" ;
lin epicycle_N = mkTerm "epicycle_N" ;
lin epicyclic_A = mkTerm "epicyclic_A" ;
lin epicycloid_N = mkTerm "epicycloid_N" ;
lin epideictic_A = mkTerm "epideictic_A" ;
lin epidemic_A = mkTerm "epidemic_A" ;
lin epidemic_N = mkTerm "epidemic_N" ;
lin epidemiologic_A = mkTerm "epidemiologic_A" ;
lin epidemiologist_N = mkTerm "epidemiologist_N" ;
lin epidemiology_N = mkTerm "epidemiology_N" ;
lin epidendron_N = mkTerm "epidendron_N" ;
lin epidermis_N = mkTerm "epidermis_N" ;
lin epidiascope_N = mkTerm "epidiascope_N" ;
lin epididymis_N = mkTerm "epididymis_N" ;
lin epididymitis_N = mkTerm "epididymitis_N" ;
lin epidural_A = mkTerm "epidural_A" ;
lin epigastric_A = mkTerm "epigastric_A" ;
lin epigastrium_N = mkTerm "epigastrium_N" ;
lin epigenesis_N = mkTerm "epigenesis_N" ;
lin epiglottis_N = mkTerm "epiglottis_N" ;
lin epiglottitis_N = mkTerm "epiglottitis_N" ;
lin epigone_N = mkTerm "epigone_N" ;
lin epigram_N = mkTerm "epigram_N" ;
lin epigrammatic_A = mkTerm "epigrammatic_A" ;
lin epigraph_N = mkTerm "epigraph_N" ;
lin epigraphy_N = mkTerm "epigraphy_N" ;
lin epikeratophakia_N = mkTerm "epikeratophakia_N" ;
lin epilation_N = mkTerm "epilation_N" ;
lin epilepsy_N = mkTerm "epilepsy_N" ;
lin epilepticFem_N = mkTerm "epilepticFem_N" ;
lin epilepticMasc_N = mkTerm "epilepticMasc_N" ;
lin epileptic_A = mkTerm "epileptic_A" ;
lin epilithic_A = mkTerm "epilithic_A" ;
lin epilogue_N = mkTerm "epilogue_N" ;
lin epimorphic_A = mkTerm "epimorphic_A" ;
lin epinephrine_N = mkTerm "epinephrine_N" ;
lin epiphany_N = mkTerm "epiphany_N" ;
lin epiphany_PN = mkTerm "epiphany_PN" ;
lin epiphenomenon_N = mkTerm "epiphenomenon_N" ;
lin epiphora_N = mkTerm "epiphora_N" ;
lin epiphyllum_N = mkTerm "epiphyllum_N" ;
lin epiphyseal_A = mkTerm "epiphyseal_A" ;
lin epiphysis_N = mkTerm "epiphysis_N" ;
lin epiphytic_A = mkTerm "epiphytic_A" ;
lin epiphytotic_A = mkTerm "epiphytotic_A" ;
lin epiplexis_N = mkTerm "epiplexis_N" ;
lin episcia_N = mkTerm "episcia_N" ;
lin episcleritis_N = mkTerm "episcleritis_N" ;
lin episcopacy_N = mkTerm "episcopacy_N" ;
lin episcopal_A = mkTerm "episcopal_A" ;
lin episcopalian_A = mkTerm "episcopalian_A" ;
lin episcopalian_N = mkTerm "episcopalian_N" ;
lin episcopate_N = mkTerm "episcopate_N" ;
lin episiotomy_N = mkTerm "episiotomy_N" ;
lin episode_N = mkTerm "episode_N" ;
lin episodic_A = mkTerm "episodic_A" ;
lin episome_N = mkTerm "episome_N" ;
lin epispadias_N = mkTerm "epispadias_N" ;
lin episteme_N = mkTerm "episteme_N" ;
lin epistemic_A = mkTerm "epistemic_A" ;
lin epistemologist_N = mkTerm "epistemologist_N" ;
lin epistemology_N = mkTerm "epistemology_N" ;
lin epistle_N = mkTerm "epistle_N" ;
lin epistolary_A = mkTerm "epistolary_A" ;
lin epitaph_N = mkTerm "epitaph_N" ;
lin epitaxy_N = mkTerm "epitaxy_N" ;
lin epithalamium_N = mkTerm "epithalamium_N" ;
lin epithelial_A = mkTerm "epithelial_A" ;
lin epitheliod_A = mkTerm "epitheliod_A" ;
lin epithelioma_N = mkTerm "epithelioma_N" ;
lin epithelium_N = mkTerm "epithelium_N" ;
lin epithet_N = mkTerm "epithet_N" ;
lin epitome_N = mkTerm "epitome_N" ;
lin epitomize_V2 = mkTerm "epitomize_V2" ;
lin epizoan_A = mkTerm "epizoan_A" ;
lin epizoic_A = mkTerm "epizoic_A" ;
lin epizootic_A = mkTerm "epizootic_A" ;
lin epoch_N = mkTerm "epoch_N" ;
lin epoch_making_A = mkTerm "epoch_making_A" ;
lin epochal_A = mkTerm "epochal_A" ;
lin eponym_N = mkTerm "eponym_N" ;
lin eponymous_A = mkTerm "eponymous_A" ;
lin eponymy_N = mkTerm "eponymy_N" ;
lin epos_N = mkTerm "epos_N" ;
lin epoxy_N = mkTerm "epoxy_N" ;
lin epping_PN = mkTerm "epping_PN" ;
lin epsilon_N = mkTerm "epsilon_N" ;
lin epsom_PN = mkTerm "epsom_PN" ;
lin eptatretus_N = mkTerm "eptatretus_N" ;
lin equable_A = mkTerm "equable_A" ;
lin equal_A = mkTerm "equal_A" ;
lin equal_N = mkTerm "equal_N" ;
lin equal_V2 = mkTerm "equal_V2" ;
lin equal_to_A2 = mkTerm "equal_to_A2" ;
lin equalitarian_N = mkTerm "equalitarian_N" ;
lin equality_N = mkTerm "equality_N" ;
lin equalization_N = mkTerm "equalization_N" ;
lin equalize_V2 = mkTerm "equalize_V2" ;
lin equalizer_N = mkTerm "equalizer_N" ;
lin equanimity_N = mkTerm "equanimity_N" ;
lin equatability_N = mkTerm "equatability_N" ;
lin equate_V2 = mkTerm "equate_V2" ;
lin equation_N = mkTerm "equation_N" ;
lin equator_N = mkTerm "equator_N" ;
lin equatorial_A = mkTerm "equatorial_A" ;
lin equatorial_N = mkTerm "equatorial_N" ;
lin equerry_N = mkTerm "equerry_N" ;
lin equestrian_A = mkTerm "equestrian_A" ;
lin equestrian_N = mkTerm "equestrian_N" ;
lin equiangular_A = mkTerm "equiangular_A" ;
lin equidistant_A = mkTerm "equidistant_A" ;
lin equidistribution_N = mkTerm "equidistribution_N" ;
lin equilateral_A = mkTerm "equilateral_A" ;
lin equilateral_N = mkTerm "equilateral_N" ;
lin equilibration_N = mkTerm "equilibration_N" ;
lin equilibrium_N = mkTerm "equilibrium_N" ;
lin equine_A = mkTerm "equine_A" ;
lin equine_N = mkTerm "equine_N" ;
lin equinoctial_A = mkTerm "equinoctial_A" ;
lin equinox_N = mkTerm "equinox_N" ;
lin equip_V2 = mkTerm "equip_V2" ;
lin equipage_N = mkTerm "equipage_N" ;
lin equipment_N = mkTerm "equipment_N" ;
lin equipoise_N = mkTerm "equipoise_N" ;
lin equipoised_A = mkTerm "equipoised_A" ;
lin equipotent_A = mkTerm "equipotent_A" ;
lin equiprobable_A = mkTerm "equiprobable_A" ;
lin equitable_A = mkTerm "equitable_A" ;
lin equity_N = mkTerm "equity_N" ;
lin equivalence_N = mkTerm "equivalence_N" ;
lin equivalent_A = mkTerm "equivalent_A" ;
lin equivalent_N = mkTerm "equivalent_N" ;
lin equivocal_A = mkTerm "equivocal_A" ;
lin equivocation_N = mkTerm "equivocation_N" ;
lin er_Interj = mkTerm "er_Interj" ;
lin era_N = mkTerm "era_N" ;
lin eradicable_A = mkTerm "eradicable_A" ;
lin eradicate_V2 = mkTerm "eradicate_V2" ;
lin eradication_N = mkTerm "eradication_N" ;
lin erase_V2 = mkTerm "erase_V2" ;
lin eraser_N = mkTerm "eraser_N" ;
lin erasure_N = mkTerm "erasure_N" ;
lin erbium_N = mkTerm "erbium_N" ;
lin ere_Adv = mkTerm "ere_Adv" ;
lin ere_Prep = mkTerm "ere_Prep" ;
lin erect_A = mkTerm "erect_A" ;
lin erect_V2 = mkTerm "erect_V2" ;
lin erectile_A = mkTerm "erectile_A" ;
lin erecting_N = mkTerm "erecting_N" ;
lin erection_N = mkTerm "erection_N" ;
lin erectness_N = mkTerm "erectness_N" ;
lin eremite_N = mkTerm "eremite_N" ;
lin eremitic_A = mkTerm "eremitic_A" ;
lin eremitism_N = mkTerm "eremitism_N" ;
lin erethism_N = mkTerm "erethism_N" ;
lin erfurt_PN = mkTerm "erfurt_PN" ;
lin erg_N = mkTerm "erg_N" ;
lin ergo_Adv = mkTerm "ergo_Adv" ;
lin ergodic_A = mkTerm "ergodic_A" ;
lin ergodicity_N = mkTerm "ergodicity_N" ;
lin ergonomic_A = mkTerm "ergonomic_A" ;
lin ergonomics_N = mkTerm "ergonomics_N" ;
lin ergonovine_N = mkTerm "ergonovine_N" ;
lin ergosterol_N = mkTerm "ergosterol_N" ;
lin ergot_N = mkTerm "ergot_N" ;
lin ergotamine_N = mkTerm "ergotamine_N" ;
lin ergotic_A = mkTerm "ergotic_A" ;
lin ergotism_N = mkTerm "ergotism_N" ;
lin ergotropic_A = mkTerm "ergotropic_A" ;
lin ergotropism_N = mkTerm "ergotropism_N" ;
lin eric_PN = mkTerm "eric_PN" ;
lin erica_N = mkTerm "erica_N" ;
lin erica_PN = mkTerm "erica_PN" ;
lin erin_PN = mkTerm "erin_PN" ;
lin eriogonum_N = mkTerm "eriogonum_N" ;
lin eristic_A = mkTerm "eristic_A" ;
lin eristic_N = mkTerm "eristic_N" ;
lin eritrea_PN = mkTerm "eritrea_PN" ;
lin eritrean_A = mkTerm "eritrean_A" ;
lin eritrean_N = mkTerm "eritrean_N" ;
lin erlangen_PN = mkTerm "erlangen_PN" ;
lin ermine_N = mkTerm "ermine_N" ;
lin ern_N = mkTerm "ern_N" ;
lin ernest_PN = mkTerm "ernest_PN" ;
lin ernie_PN = mkTerm "ernie_PN" ;
lin erode_V = mkTerm "erode_V" ;
lin erode_V2 = mkTerm "erode_V2" ;
lin erogenous_A = mkTerm "erogenous_A" ;
lin erose_A = mkTerm "erose_A" ;
lin erosion_N = mkTerm "erosion_N" ;
lin erosive_A = mkTerm "erosive_A" ;
lin erotic_A = mkTerm "erotic_A" ;
lin erotic_N = mkTerm "erotic_N" ;
lin eroticism_N = mkTerm "eroticism_N" ;
lin err_V = mkTerm "err_V" ;
lin errancy_N = mkTerm "errancy_N" ;
lin errand_N = mkTerm "errand_N" ;
lin errant_A = mkTerm "errant_A" ;
lin erratic_A = mkTerm "erratic_A" ;
lin erratum_N = mkTerm "erratum_N" ;
lin errhine_A = mkTerm "errhine_A" ;
lin erroneous_A = mkTerm "erroneous_A" ;
lin erroneousness_N = mkTerm "erroneousness_N" ;
lin error_N = mkTerm "error_N" ;
lin errorless_A = mkTerm "errorless_A" ;
lin ersatz_A = mkTerm "ersatz_A" ;
lin ersatz_N = mkTerm "ersatz_N" ;
lin erse_N = mkTerm "erse_N" ;
lin erstwhile_A = mkTerm "erstwhile_A" ;
lin eructation_N = mkTerm "eructation_N" ;
lin erudite_A = mkTerm "erudite_A" ;
lin eruditeness_N = mkTerm "eruditeness_N" ;
lin erudition_N = mkTerm "erudition_N" ;
lin erupt_V = mkTerm "erupt_V" ;
lin eruption_N = mkTerm "eruption_N" ;
lin eruptive_A = mkTerm "eruptive_A" ;
lin erwinia_N = mkTerm "erwinia_N" ;
lin eryngo_N = mkTerm "eryngo_N" ;
lin erysipelas_N = mkTerm "erysipelas_N" ;
lin erythema_N = mkTerm "erythema_N" ;
lin erythematous_A = mkTerm "erythematous_A" ;
lin erythrite_N = mkTerm "erythrite_N" ;
lin erythroblast_N = mkTerm "erythroblast_N" ;
lin erythroblastosis_N = mkTerm "erythroblastosis_N" ;
lin erythroderma_N = mkTerm "erythroderma_N" ;
lin erythroid_A = mkTerm "erythroid_A" ;
lin erythromycin_N = mkTerm "erythromycin_N" ;
lin erythropoiesis_N = mkTerm "erythropoiesis_N" ;
lin erythropoietic_A = mkTerm "erythropoietic_A" ;
lin erythropoietin_N = mkTerm "erythropoietin_N" ;
lin escadrille_N = mkTerm "escadrille_N" ;
lin escalade_N = mkTerm "escalade_N" ;
lin escalader_N = mkTerm "escalader_N" ;
lin escalate_V = mkTerm "escalate_V" ;
lin escalate_V2 = mkTerm "escalate_V2" ;
lin escalation_N = mkTerm "escalation_N" ;
lin escalator_N = mkTerm "escalator_N" ;
lin escalope_N = mkTerm "escalope_N" ;
lin escapade_N = mkTerm "escapade_N" ;
lin escape_N = mkTerm "escape_N" ;
lin escape_V = mkTerm "escape_V" ;
lin escape_V2 = mkTerm "escape_V2" ;
lin escape_VS = mkTerm "escape_VS" ;
lin escapee_N = mkTerm "escapee_N" ;
lin escapement_N = mkTerm "escapement_N" ;
lin escapism_N = mkTerm "escapism_N" ;
lin escapist_N = mkTerm "escapist_N" ;
lin escapologist_N = mkTerm "escapologist_N" ;
lin escapology_N = mkTerm "escapology_N" ;
lin escargot_N = mkTerm "escargot_N" ;
lin escarpment_N = mkTerm "escarpment_N" ;
lin eschar_N = mkTerm "eschar_N" ;
lin eschatological_A = mkTerm "eschatological_A" ;
lin eschatologist_N = mkTerm "eschatologist_N" ;
lin eschatology_N = mkTerm "eschatology_N" ;
lin escheat_N = mkTerm "escheat_N" ;
lin escherichia_N = mkTerm "escherichia_N" ;
lin eschew_V2 = mkTerm "eschew_V2" ;
lin escolar_N = mkTerm "escolar_N" ;
lin escort_N = mkTerm "escort_N" ;
lin escort_V2 = mkTerm "escort_V2" ;
lin escritoire_N = mkTerm "escritoire_N" ;
lin escrow_N = mkTerm "escrow_N" ;
lin escudo_N = mkTerm "escudo_N" ;
lin escutcheon_N = mkTerm "escutcheon_N" ;
lin esfahan_PN = mkTerm "esfahan_PN" ;
lin esker_N = mkTerm "esker_N" ;
lin eskimo_N = mkTerm "eskimo_N" ;
lin esmolol_N = mkTerm "esmolol_N" ;
lin esophageal_A = mkTerm "esophageal_A" ;
lin esophagitis_N = mkTerm "esophagitis_N" ;
lin esophagoscope_N = mkTerm "esophagoscope_N" ;
lin esophagus_N = mkTerm "esophagus_N" ;
lin esoteric_A = mkTerm "esoteric_A" ;
lin esoterica_N = mkTerm "esoterica_N" ;
lin esp_N = mkTerm "esp_N" ;
lin espadrille_N = mkTerm "espadrille_N" ;
lin espalier_N = mkTerm "espalier_N" ;
lin especial_A = mkTerm "especial_A" ;
lin esperanto_N = mkTerm "esperanto_N" ;
lin espionage_N = mkTerm "espionage_N" ;
lin esplanade_N = mkTerm "esplanade_N" ;
lin espoo_PN = mkTerm "espoo_PN" ;
lin espousal_N = mkTerm "espousal_N" ;
lin espouse_V2 = mkTerm "espouse_V2" ;
lin espresso_N = mkTerm "espresso_N" ;
lin esprit_N = mkTerm "esprit_N" ;
lin esprit_de_corps_N = mkTerm "esprit_de_corps_N" ;
lin espy_V2 = mkTerm "espy_V2" ;
lin esq_PN = mkTerm "esq_PN" ;
lin esquire_N = mkTerm "esquire_N" ;
lin essay_N = mkTerm "essay_N" ;
lin essay_V = mkTerm "essay_V" ;
lin essay_V2 = mkTerm "essay_V2" ;
lin essayist_N = mkTerm "essayist_N" ;
lin essen_PN = mkTerm "essen_PN" ;
lin essence_N = mkTerm "essence_N" ;
lin essential_A = mkTerm "essential_A" ;
lin essential_N = mkTerm "essential_N" ;
lin essentiality_N = mkTerm "essentiality_N" ;
lin essex_PN = mkTerm "essex_PN" ;
lin establish_V2 = mkTerm "establish_V2" ;
lin established_A = mkTerm "established_A" ;
lin establishment_N = mkTerm "establishment_N" ;
lin establishmentarianism_N = mkTerm "establishmentarianism_N" ;
lin estaminet_N = mkTerm "estaminet_N" ;
lin estate_N = mkTerm "estate_N" ;
lin estazolam_N = mkTerm "estazolam_N" ;
lin esteem_N = mkTerm "esteem_N" ;
lin esteem_V2 = mkTerm "esteem_V2" ;
lin ester_N = mkTerm "ester_N" ;
lin esther_PN = mkTerm "esther_PN" ;
lin esthete_N = mkTerm "esthete_N" ;
lin esthetic_A = mkTerm "esthetic_A" ;
lin esthetic_N = mkTerm "esthetic_N" ;
lin esthetical_A = mkTerm "esthetical_A" ;
lin esthetician_N = mkTerm "esthetician_N" ;
lin esthetics_N = mkTerm "esthetics_N" ;
lin estimable_A = mkTerm "estimable_A" ;
lin estimate_N = mkTerm "estimate_N" ;
lin estimate_V = mkTerm "estimate_V" ;
lin estimate_V2 = mkTerm "estimate_V2" ;
lin estimate_V2V = mkTerm "estimate_V2V" ;
lin estimate_VS = mkTerm "estimate_VS" ;
lin estimated_A = mkTerm "estimated_A" ;
lin estimation_N = mkTerm "estimation_N" ;
lin estivation_N = mkTerm "estivation_N" ;
lin estoppel_N = mkTerm "estoppel_N" ;
lin estradiol_N = mkTerm "estradiol_N" ;
lin estrange_V2 = mkTerm "estrange_V2" ;
lin estrangement_N = mkTerm "estrangement_N" ;
lin estranging_A = mkTerm "estranging_A" ;
lin estriol_N = mkTerm "estriol_N" ;
lin estrogen_N = mkTerm "estrogen_N" ;
lin estrogenic_A = mkTerm "estrogenic_A" ;
lin estrone_N = mkTerm "estrone_N" ;
lin estrous_A = mkTerm "estrous_A" ;
lin estrus_N = mkTerm "estrus_N" ;
lin estuarine_A = mkTerm "estuarine_A" ;
lin estuary_N = mkTerm "estuary_N" ;
lin et_al_PN = mkTerm "et_al_PN" ;
lin et_seq_PN = mkTerm "et_seq_PN" ;
lin eta_N = mkTerm "eta_N" ;
lin etagere_N = mkTerm "etagere_N" ;
lin etamine_N = mkTerm "etamine_N" ;
lin etanercept_N = mkTerm "etanercept_N" ;
lin etc_PN = mkTerm "etc_PN" ;
lin etcetera_N = mkTerm "etcetera_N" ;
lin etch_V = mkTerm "etch_V" ;
lin etch_V2 = mkTerm "etch_V2" ;
lin etcher_N = mkTerm "etcher_N" ;
lin etching_N = mkTerm "etching_N" ;
lin etd_N = mkTerm "etd_N" ;
lin eternal_A = mkTerm "eternal_A" ;
lin eternity_N = mkTerm "eternity_N" ;
lin ethane_N = mkTerm "ethane_N" ;
lin ethanol_N = mkTerm "ethanol_N" ;
lin ethchlorvynol_N = mkTerm "ethchlorvynol_N" ;
lin ethel_PN = mkTerm "ethel_PN" ;
lin ether_N = mkTerm "ether_N" ;
lin ethereal_A = mkTerm "ethereal_A" ;
lin ethernet_N = mkTerm "ethernet_N" ;
lin ethic_N = mkTerm "ethic_N" ;
lin ethical_A = mkTerm "ethical_A" ;
lin ethicism_N = mkTerm "ethicism_N" ;
lin ethicist_N = mkTerm "ethicist_N" ;
lin ethics_N = mkTerm "ethics_N" ;
lin ethiopia_PN = mkTerm "ethiopia_PN" ;
lin ethiopian_A = mkTerm "ethiopian_A" ;
lin ethiopian_N = mkTerm "ethiopian_N" ;
lin ethmoid_N = mkTerm "ethmoid_N" ;
lin ethnarch_N = mkTerm "ethnarch_N" ;
lin ethnic_A = mkTerm "ethnic_A" ;
lin ethnic_N = mkTerm "ethnic_N" ;
lin ethnicity_N = mkTerm "ethnicity_N" ;
lin ethnocentric_A = mkTerm "ethnocentric_A" ;
lin ethnocentrism_N = mkTerm "ethnocentrism_N" ;
lin ethnographer_N = mkTerm "ethnographer_N" ;
lin ethnographic_A = mkTerm "ethnographic_A" ;
lin ethnography_N = mkTerm "ethnography_N" ;
lin ethnological_A = mkTerm "ethnological_A" ;
lin ethnologist_N = mkTerm "ethnologist_N" ;
lin ethnology_N = mkTerm "ethnology_N" ;
lin ethologist_N = mkTerm "ethologist_N" ;
lin ethology_N = mkTerm "ethology_N" ;
lin ethos_N = mkTerm "ethos_N" ;
lin ethosuximide_N = mkTerm "ethosuximide_N" ;
lin ethyl_N = mkTerm "ethyl_N" ;
lin ethylene_N = mkTerm "ethylene_N" ;
lin etiolate_A = mkTerm "etiolate_A" ;
lin etiolation_N = mkTerm "etiolation_N" ;
lin etiological_A = mkTerm "etiological_A" ;
lin etiologist_N = mkTerm "etiologist_N" ;
lin etiology_N = mkTerm "etiology_N" ;
lin etiquette_N = mkTerm "etiquette_N" ;
lin etodolac_N = mkTerm "etodolac_N" ;
lin etude_N = mkTerm "etude_N" ;
lin etui_N = mkTerm "etui_N" ;
lin etymological_A = mkTerm "etymological_A" ;
lin etymologist_N = mkTerm "etymologist_N" ;
lin etymology_N = mkTerm "etymology_N" ;
lin etymon_N = mkTerm "etymon_N" ;
lin eubacteria_N = mkTerm "eubacteria_N" ;
lin eucalyptus_N = mkTerm "eucalyptus_N" ;
lin eucharist_N = mkTerm "eucharist_N" ;
lin euchre_N = mkTerm "euchre_N" ;
lin euclidean_A = mkTerm "euclidean_A" ;
lin eudemon_N = mkTerm "eudemon_N" ;
lin eudemonic_A = mkTerm "eudemonic_A" ;
lin eudemonism_N = mkTerm "eudemonism_N" ;
lin eudiometer_N = mkTerm "eudiometer_N" ;
lin eugene_PN = mkTerm "eugene_PN" ;
lin eugenic_A = mkTerm "eugenic_A" ;
lin eugenics_N = mkTerm "eugenics_N" ;
lin euglena_N = mkTerm "euglena_N" ;
lin euglenoid_N = mkTerm "euglenoid_N" ;
lin eukaryote_N = mkTerm "eukaryote_N" ;
lin eukaryotic_A = mkTerm "eukaryotic_A" ;
lin eulogist_N = mkTerm "eulogist_N" ;
lin eulogistic_A = mkTerm "eulogistic_A" ;
lin eulogize_V2 = mkTerm "eulogize_V2" ;
lin eulogy_N = mkTerm "eulogy_N" ;
lin eunice_PN = mkTerm "eunice_PN" ;
lin eunuch_N = mkTerm "eunuch_N" ;
lin euphemism_N = mkTerm "euphemism_N" ;
lin euphemistic_A = mkTerm "euphemistic_A" ;
lin euphonic_A = mkTerm "euphonic_A" ;
lin euphonious_A = mkTerm "euphonious_A" ;
lin euphonium_N = mkTerm "euphonium_N" ;
lin euphony_N = mkTerm "euphony_N" ;
lin euphorbium_N = mkTerm "euphorbium_N" ;
lin euphoria_N = mkTerm "euphoria_N" ;
lin euphoriant_A = mkTerm "euphoriant_A" ;
lin euphoriant_N = mkTerm "euphoriant_N" ;
lin euphoric_A = mkTerm "euphoric_A" ;
lin euphuism_N = mkTerm "euphuism_N" ;
lin eupnea_N = mkTerm "eupnea_N" ;
lin eura_PN = mkTerm "eura_PN" ;
lin eurajoki_PN = mkTerm "eurajoki_PN" ;
lin eurasia_PN = mkTerm "eurasia_PN" ;
lin eurasian_A = mkTerm "eurasian_A" ;
lin eurasian_N = mkTerm "eurasian_N" ;
lin eurhythmics_N = mkTerm "eurhythmics_N" ;
lin euro_N = mkTerm "euro_N" ;
lin eurodollar_N = mkTerm "eurodollar_N" ;
lin europe_PN = mkTerm "europe_PN" ;
lin european_A = mkTerm "european_A" ;
lin european_N = mkTerm "european_N" ;
lin european_union_NP = mkTerm "european_union_NP" ;
lin europium_N = mkTerm "europium_N" ;
lin eurovision_PN = mkTerm "eurovision_PN" ;
lin eurypterid_N = mkTerm "eurypterid_N" ;
lin eurythmics_N = mkTerm "eurythmics_N" ;
lin eurythmy_N = mkTerm "eurythmy_N" ;
lin eusporangiate_A = mkTerm "eusporangiate_A" ;
lin eusporangium_N = mkTerm "eusporangium_N" ;
lin eustachian_A = mkTerm "eustachian_A" ;
lin eutectic_N = mkTerm "eutectic_N" ;
lin euthanasia_N = mkTerm "euthanasia_N" ;
lin euthenics_N = mkTerm "euthenics_N" ;
lin eutherian_A = mkTerm "eutherian_A" ;
lin eutrophic_A = mkTerm "eutrophic_A" ;
lin eutrophication_N = mkTerm "eutrophication_N" ;
lin eva_PN = mkTerm "eva_PN" ;
lin evacuate_V2 = mkTerm "evacuate_V2" ;
lin evacuation_N = mkTerm "evacuation_N" ;
lin evacuee_N = mkTerm "evacuee_N" ;
lin evade_V2 = mkTerm "evade_V2" ;
lin evaluate_V = mkTerm "evaluate_V" ;
lin evaluate_V2 = mkTerm "evaluate_V2" ;
lin evaluation_N = mkTerm "evaluation_N" ;
lin evaluative_A = mkTerm "evaluative_A" ;
lin evaluator_N = mkTerm "evaluator_N" ;
lin evanescence_N = mkTerm "evanescence_N" ;
lin evanescent_A = mkTerm "evanescent_A" ;
lin evangelical_A = mkTerm "evangelical_A" ;
lin evangelicalism_N = mkTerm "evangelicalism_N" ;
lin evangelism_N = mkTerm "evangelism_N" ;
lin evangelist_N = mkTerm "evangelist_N" ;
lin evangelistic_A = mkTerm "evangelistic_A" ;
lin evaporable_A = mkTerm "evaporable_A" ;
lin evaporate_V = mkTerm "evaporate_V" ;
lin evaporate_V2 = mkTerm "evaporate_V2" ;
lin evaporate_VS = mkTerm "evaporate_VS" ;
lin evaporation_N = mkTerm "evaporation_N" ;
lin evaporative_A = mkTerm "evaporative_A" ;
lin evaporite_N = mkTerm "evaporite_N" ;
lin evasion_N = mkTerm "evasion_N" ;
lin evasive_A = mkTerm "evasive_A" ;
lin evasiveness_N = mkTerm "evasiveness_N" ;
lin eve_N = mkTerm "eve_N" ;
lin eve_PN = mkTerm "eve_PN" ;
lin evelyn_PN = mkTerm "evelyn_PN" ;
lin even_1_A = mkTerm "even_1_A" ;
lin even_2_A = mkTerm "even_2_A" ;
lin even_AdA = mkTerm "even_AdA" ;
lin even_AdV = mkTerm "even_AdV" ;
lin even_Adv = mkTerm "even_Adv" ;
lin even_N = mkTerm "even_N" ;
lin even_V2 = mkTerm "even_V2" ;
lin even_handed_A = mkTerm "even_handed_A" ;
lin even_out_V = mkTerm "even_out_V" ;
lin even_though_Subj = mkTerm "even_though_Subj" ;
lin evening_N = mkTerm "evening_N" ;
lin evenness_N = mkTerm "evenness_N" ;
lin evensong_N = mkTerm "evensong_N" ;
lin event_N = mkTerm "event_N" ;
lin eventful_A = mkTerm "eventful_A" ;
lin eventide_N = mkTerm "eventide_N" ;
lin eventration_N = mkTerm "eventration_N" ;
lin eventual_A = mkTerm "eventual_A" ;
lin eventuality_N = mkTerm "eventuality_N" ;
lin ever_AdV = mkTerm "ever_AdV" ;
lin ever_Adv = mkTerm "ever_Adv" ;
lin evergreen_A = mkTerm "evergreen_A" ;
lin evergreen_N = mkTerm "evergreen_N" ;
lin everlasting_A = mkTerm "everlasting_A" ;
lin everlasting_N = mkTerm "everlasting_N" ;
lin everlastingness_N = mkTerm "everlastingness_N" ;
lin evermore_Adv = mkTerm "evermore_Adv" ;
lin eversion_N = mkTerm "eversion_N" ;
lin every_bit_Adv = mkTerm "every_bit_Adv" ;
lin everyday_A = mkTerm "everyday_A" ;
lin everyman_N = mkTerm "everyman_N" ;
lin everyone_NP = mkTerm "everyone_NP" ;
lin everyplace_Adv = mkTerm "everyplace_Adv" ;
lin evesham_PN = mkTerm "evesham_PN" ;
lin evict_V2 = mkTerm "evict_V2" ;
lin eviction_N = mkTerm "eviction_N" ;
lin evidence_1_N = mkTerm "evidence_1_N" ;
lin evidence_2_N = mkTerm "evidence_2_N" ;
lin evidence_V2 = mkTerm "evidence_V2" ;
lin evident_A = mkTerm "evident_A" ;
lin evidential_A = mkTerm "evidential_A" ;
lin evidentiary_A = mkTerm "evidentiary_A" ;
lin evijärvi_PN = mkTerm "evijärvi_PN" ;
lin evil_A = mkTerm "evil_A" ;
lin evil_N = mkTerm "evil_N" ;
lin evil_doer_N = mkTerm "evil_doer_N" ;
lin evil_minded_A = mkTerm "evil_minded_A" ;
lin evince_V2 = mkTerm "evince_V2" ;
lin eviscerate_A = mkTerm "eviscerate_A" ;
lin eviscerate_V2 = mkTerm "eviscerate_V2" ;
lin evisceration_N = mkTerm "evisceration_N" ;
lin evitable_A = mkTerm "evitable_A" ;
lin evocation_N = mkTerm "evocation_N" ;
lin evocative_A = mkTerm "evocative_A" ;
lin evoke_V2 = mkTerm "evoke_V2" ;
lin evolution_N = mkTerm "evolution_N" ;
lin evolutionary_A = mkTerm "evolutionary_A" ;
lin evolutionistFem_N = mkTerm "evolutionistFem_N" ;
lin evolutionistMasc_N = mkTerm "evolutionistMasc_N" ;
lin evolve_V = mkTerm "evolve_V" ;
lin evolve_V2 = mkTerm "evolve_V2" ;
lin ewe_N = mkTerm "ewe_N" ;
lin ewell_PN = mkTerm "ewell_PN" ;
lin ewer_N = mkTerm "ewer_N" ;
lin ex_A = mkTerm "ex_A" ;
lin ex_directory_A = mkTerm "ex_directory_A" ;
lin ex_gratia_A = mkTerm "ex_gratia_A" ;
lin ex_officio_A = mkTerm "ex_officio_A" ;
lin ex_officio_Adv = mkTerm "ex_officio_Adv" ;
lin ex_service_A = mkTerm "ex_service_A" ;
lin ex_serviceman_N = mkTerm "ex_serviceman_N" ;
lin exabit_N = mkTerm "exabit_N" ;
lin exabyte_N = mkTerm "exabyte_N" ;
lin exacerbate_V2 = mkTerm "exacerbate_V2" ;
lin exacerbation_N = mkTerm "exacerbation_N" ;
lin exact_A = mkTerm "exact_A" ;
lin exact_V2 = mkTerm "exact_V2" ;
lin exacta_N = mkTerm "exacta_N" ;
lin exacting_A = mkTerm "exacting_A" ;
lin exaction_N = mkTerm "exaction_N" ;
lin exactitude_N = mkTerm "exactitude_N" ;
lin exactness_N = mkTerm "exactness_N" ;
lin exaggerate_V = mkTerm "exaggerate_V" ;
lin exaggerate_V2 = mkTerm "exaggerate_V2" ;
lin exaggeration_N = mkTerm "exaggeration_N" ;
lin exalt_V2 = mkTerm "exalt_V2" ;
lin exaltation_N = mkTerm "exaltation_N" ;
lin exam_N = mkTerm "exam_N" ;
lin examen_N = mkTerm "examen_N" ;
lin examination_N = mkTerm "examination_N" ;
lin examine_V2 = mkTerm "examine_V2" ;
lin examiner_N = mkTerm "examiner_N" ;
lin example_N = mkTerm "example_N" ;
lin exanthem_N = mkTerm "exanthem_N" ;
lin exarch_N = mkTerm "exarch_N" ;
lin exasperate_V2 = mkTerm "exasperate_V2" ;
lin exasperating_A = mkTerm "exasperating_A" ;
lin exasperation_N = mkTerm "exasperation_N" ;
lin exaugural_A = mkTerm "exaugural_A" ;
lin exbibit_N = mkTerm "exbibit_N" ;
lin excavate_V = mkTerm "excavate_V" ;
lin excavate_V2 = mkTerm "excavate_V2" ;
lin excavation_N = mkTerm "excavation_N" ;
lin excavator_N = mkTerm "excavator_N" ;
lin exceed_V2 = mkTerm "exceed_V2" ;
lin exceedance_N = mkTerm "exceedance_N" ;
lin exceeding_A = mkTerm "exceeding_A" ;
lin excel_V = mkTerm "excel_V" ;
lin excel_V2 = mkTerm "excel_V2" ;
lin excellence_N = mkTerm "excellence_N" ;
lin excellency_N = mkTerm "excellency_N" ;
lin excellent_A = mkTerm "excellent_A" ;
lin excelsior_N = mkTerm "excelsior_N" ;
lin except_Conj = mkTerm "except_Conj" ;
lin except_V2 = mkTerm "except_V2" ;
lin except_for_Prep = mkTerm "except_for_Prep" ;
lin exception_N = mkTerm "exception_N" ;
lin exceptionable_A = mkTerm "exceptionable_A" ;
lin exceptional_A = mkTerm "exceptional_A" ;
lin excerpt_N = mkTerm "excerpt_N" ;
lin excess_A = mkTerm "excess_A" ;
lin excess_N = mkTerm "excess_N" ;
lin excessive_A = mkTerm "excessive_A" ;
lin exchange_N = mkTerm "exchange_N" ;
lin exchange_V2 = mkTerm "exchange_V2" ;
lin exchangeability_N = mkTerm "exchangeability_N" ;
lin exchangeable_A = mkTerm "exchangeable_A" ;
lin exchanger_N = mkTerm "exchanger_N" ;
lin exchequer_N = mkTerm "exchequer_N" ;
lin excise_N = mkTerm "excise_N" ;
lin excise_V2 = mkTerm "excise_V2" ;
lin exciseman_N = mkTerm "exciseman_N" ;
lin excision_N = mkTerm "excision_N" ;
lin excitability_N = mkTerm "excitability_N" ;
lin excitable_A = mkTerm "excitable_A" ;
lin excitant_A = mkTerm "excitant_A" ;
lin excitation_N = mkTerm "excitation_N" ;
lin excite_V2 = mkTerm "excite_V2" ;
lin excited_A = mkTerm "excited_A" ;
lin excitement_N = mkTerm "excitement_N" ;
lin exciting_A = mkTerm "exciting_A" ;
lin excl_PN = mkTerm "excl_PN" ;
lin exclaim_V2 = mkTerm "exclaim_V2" ;
lin exclamation_N = mkTerm "exclamation_N" ;
lin exclamatory_A = mkTerm "exclamatory_A" ;
lin exclude_V2 = mkTerm "exclude_V2" ;
lin exclusion_N = mkTerm "exclusion_N" ;
lin exclusive_A = mkTerm "exclusive_A" ;
lin exclusive_N = mkTerm "exclusive_N" ;
lin excogitate_V2 = mkTerm "excogitate_V2" ;
lin excogitation_N = mkTerm "excogitation_N" ;
lin excogitative_A = mkTerm "excogitative_A" ;
lin excogitator_N = mkTerm "excogitator_N" ;
lin excommunicate_V2 = mkTerm "excommunicate_V2" ;
lin excommunication_N = mkTerm "excommunication_N" ;
lin excoriate_V2 = mkTerm "excoriate_V2" ;
lin excoriation_N = mkTerm "excoriation_N" ;
lin excrement_N = mkTerm "excrement_N" ;
lin excrescence_N = mkTerm "excrescence_N" ;
lin excrescent_A = mkTerm "excrescent_A" ;
lin excrete_V2 = mkTerm "excrete_V2" ;
lin excretion_N = mkTerm "excretion_N" ;
lin excretory_A = mkTerm "excretory_A" ;
lin excruciating_A = mkTerm "excruciating_A" ;
lin exculpate_V2 = mkTerm "exculpate_V2" ;
lin exculpation_N = mkTerm "exculpation_N" ;
lin exculpatory_A = mkTerm "exculpatory_A" ;
lin excursion_N = mkTerm "excursion_N" ;
lin excursionist_N = mkTerm "excursionist_N" ;
lin excusable_A = mkTerm "excusable_A" ;
lin excuse_N = mkTerm "excuse_N" ;
lin excuse_V2 = mkTerm "excuse_V2" ;
lin excuse_me_Interj = mkTerm "excuse_me_Interj" ;
lin execrable_A = mkTerm "execrable_A" ;
lin execrate_V2 = mkTerm "execrate_V2" ;
lin execration_N = mkTerm "execration_N" ;
lin executability_N = mkTerm "executability_N" ;
lin executant_N = mkTerm "executant_N" ;
lin execute_V2 = mkTerm "execute_V2" ;
lin execution_N = mkTerm "execution_N" ;
lin executioner_N = mkTerm "executioner_N" ;
lin executive_A = mkTerm "executive_A" ;
lin executive_N = mkTerm "executive_N" ;
lin executor_N = mkTerm "executor_N" ;
lin executrix_N = mkTerm "executrix_N" ;
lin exegesis_N = mkTerm "exegesis_N" ;
lin exegete_N = mkTerm "exegete_N" ;
lin exegetic_A = mkTerm "exegetic_A" ;
lin exemplar_N = mkTerm "exemplar_N" ;
lin exemplary_A = mkTerm "exemplary_A" ;
lin exemplification_N = mkTerm "exemplification_N" ;
lin exemplify_V2 = mkTerm "exemplify_V2" ;
lin exemplifying_A = mkTerm "exemplifying_A" ;
lin exempt_A = mkTerm "exempt_A" ;
lin exempt_V2 = mkTerm "exempt_V2" ;
lin exempt_V2V = mkTerm "exempt_V2V" ;
lin exemption_N = mkTerm "exemption_N" ;
lin exenteration_N = mkTerm "exenteration_N" ;
lin exercise_N = mkTerm "exercise_N" ;
lin exercise_V = mkTerm "exercise_V" ;
lin exercise_V2 = mkTerm "exercise_V2" ;
lin exercise_VV = mkTerm "exercise_VV" ;
lin exergonic_A = mkTerm "exergonic_A" ;
lin exert_V2 = mkTerm "exert_V2" ;
lin exertion_N = mkTerm "exertion_N" ;
lin exeter_PN = mkTerm "exeter_PN" ;
lin exfoliation_N = mkTerm "exfoliation_N" ;
lin exhalation_N = mkTerm "exhalation_N" ;
lin exhale_V = mkTerm "exhale_V" ;
lin exhale_V2 = mkTerm "exhale_V2" ;
lin exhaust_N = mkTerm "exhaust_N" ;
lin exhaust_V2 = mkTerm "exhaust_V2" ;
lin exhaust_pipe_N = mkTerm "exhaust_pipe_N" ;
lin exhaustible_A = mkTerm "exhaustible_A" ;
lin exhausting_A = mkTerm "exhausting_A" ;
lin exhaustion_N = mkTerm "exhaustion_N" ;
lin exhaustive_A = mkTerm "exhaustive_A" ;
lin exhibit_N = mkTerm "exhibit_N" ;
lin exhibit_V2 = mkTerm "exhibit_V2" ;
lin exhibition_N = mkTerm "exhibition_N" ;
lin exhibitioner_N = mkTerm "exhibitioner_N" ;
lin exhibitionism_N = mkTerm "exhibitionism_N" ;
lin exhibitionist_N = mkTerm "exhibitionist_N" ;
lin exhibitionistic_A = mkTerm "exhibitionistic_A" ;
lin exhibitor_N = mkTerm "exhibitor_N" ;
lin exhilarate_V2 = mkTerm "exhilarate_V2" ;
lin exhilarating_A = mkTerm "exhilarating_A" ;
lin exhilaration_N = mkTerm "exhilaration_N" ;
lin exhort_V2 = mkTerm "exhort_V2" ;
lin exhortation_N = mkTerm "exhortation_N" ;
lin exhortative_A = mkTerm "exhortative_A" ;
lin exhumation_N = mkTerm "exhumation_N" ;
lin exhume_V2 = mkTerm "exhume_V2" ;
lin exigency_N = mkTerm "exigency_N" ;
lin exigent_A = mkTerm "exigent_A" ;
lin exiguous_A = mkTerm "exiguous_A" ;
lin exile_N = mkTerm "exile_N" ;
lin exile_V2 = mkTerm "exile_V2" ;
lin exilic_A = mkTerm "exilic_A" ;
lin exist_V = mkTerm "exist_V" ;
lin existence_N = mkTerm "existence_N" ;
lin existent_A = mkTerm "existent_A" ;
lin existential_A = mkTerm "existential_A" ;
lin existentialism_N = mkTerm "existentialism_N" ;
lin existentialist_A = mkTerm "existentialist_A" ;
lin existentialist_N = mkTerm "existentialist_N" ;
lin existing_A = mkTerm "existing_A" ;
lin exit_N = mkTerm "exit_N" ;
lin exit_V = mkTerm "exit_V" ;
lin exmouth_PN = mkTerm "exmouth_PN" ;
lin exobiology_N = mkTerm "exobiology_N" ;
lin exocentric_A = mkTerm "exocentric_A" ;
lin exocrine_A = mkTerm "exocrine_A" ;
lin exode_N = mkTerm "exode_N" ;
lin exodontic_A = mkTerm "exodontic_A" ;
lin exodontics_N = mkTerm "exodontics_N" ;
lin exodontist_N = mkTerm "exodontist_N" ;
lin exodus_N = mkTerm "exodus_N" ;
lin exoergic_A = mkTerm "exoergic_A" ;
lin exogamous_A = mkTerm "exogamous_A" ;
lin exogamy_N = mkTerm "exogamy_N" ;
lin exogenous_A = mkTerm "exogenous_A" ;
lin exomphalos_N = mkTerm "exomphalos_N" ;
lin exon_N = mkTerm "exon_N" ;
lin exonerate_V2 = mkTerm "exonerate_V2" ;
lin exoneration_N = mkTerm "exoneration_N" ;
lin exonuclease_N = mkTerm "exonuclease_N" ;
lin exophthalmos_N = mkTerm "exophthalmos_N" ;
lin exorbitance_N = mkTerm "exorbitance_N" ;
lin exorbitant_A = mkTerm "exorbitant_A" ;
lin exorcism_N = mkTerm "exorcism_N" ;
lin exorcist_N = mkTerm "exorcist_N" ;
lin exorcize_V2 = mkTerm "exorcize_V2" ;
lin exordium_N = mkTerm "exordium_N" ;
lin exoskeleton_N = mkTerm "exoskeleton_N" ;
lin exosphere_N = mkTerm "exosphere_N" ;
lin exostosis_N = mkTerm "exostosis_N" ;
lin exoteric_A = mkTerm "exoteric_A" ;
lin exotherm_N = mkTerm "exotherm_N" ;
lin exothermic_A = mkTerm "exothermic_A" ;
lin exotic_A = mkTerm "exotic_A" ;
lin exoticism_N = mkTerm "exoticism_N" ;
lin exotoxin_N = mkTerm "exotoxin_N" ;
lin expand_V = mkTerm "expand_V" ;
lin expand_V2 = mkTerm "expand_V2" ;
lin expandable_A = mkTerm "expandable_A" ;
lin expanse_N = mkTerm "expanse_N" ;
lin expansion_N = mkTerm "expansion_N" ;
lin expansionism_N = mkTerm "expansionism_N" ;
lin expansionist_A = mkTerm "expansionist_A" ;
lin expansive_A = mkTerm "expansive_A" ;
lin expansiveness_N = mkTerm "expansiveness_N" ;
lin expatiate_V = mkTerm "expatiate_V" ;
lin expatiation_N = mkTerm "expatiation_N" ;
lin expatriate_N = mkTerm "expatriate_N" ;
lin expatriate_V2 = mkTerm "expatriate_V2" ;
lin expect_V = mkTerm "expect_V" ;
lin expect_V2 = mkTerm "expect_V2" ;
lin expect_V2V = mkTerm "expect_V2V" ;
lin expect_VS = mkTerm "expect_VS" ;
lin expect_VV = mkTerm "expect_VV" ;
lin expectable_A = mkTerm "expectable_A" ;
lin expectancy_N = mkTerm "expectancy_N" ;
lin expectant_A = mkTerm "expectant_A" ;
lin expectation_N = mkTerm "expectation_N" ;
lin expected_A = mkTerm "expected_A" ;
lin expectedness_N = mkTerm "expectedness_N" ;
lin expectorant_N = mkTerm "expectorant_N" ;
lin expectorate_V = mkTerm "expectorate_V" ;
lin expectorate_V2 = mkTerm "expectorate_V2" ;
lin expectoration_N = mkTerm "expectoration_N" ;
lin expedience_N = mkTerm "expedience_N" ;
lin expediency_N = mkTerm "expediency_N" ;
lin expedient_A = mkTerm "expedient_A" ;
lin expedient_N = mkTerm "expedient_N" ;
lin expedite_V2 = mkTerm "expedite_V2" ;
lin expedition_N = mkTerm "expedition_N" ;
lin expeditionary_A = mkTerm "expeditionary_A" ;
lin expeditious_A = mkTerm "expeditious_A" ;
lin expel_V2 = mkTerm "expel_V2" ;
lin expend_V2 = mkTerm "expend_V2" ;
lin expendable_A = mkTerm "expendable_A" ;
lin expending_N = mkTerm "expending_N" ;
lin expenditure_N = mkTerm "expenditure_N" ;
lin expense_N = mkTerm "expense_N" ;
lin expensive_A = mkTerm "expensive_A" ;
lin expensiveness_N = mkTerm "expensiveness_N" ;
lin experience_N = mkTerm "experience_N" ;
lin experience_V2 = mkTerm "experience_V2" ;
lin experienced_A = mkTerm "experienced_A" ;
lin experiential_A = mkTerm "experiential_A" ;
lin experiment_N = mkTerm "experiment_N" ;
lin experiment_V = mkTerm "experiment_V" ;
lin experiment_V2 = mkTerm "experiment_V2" ;
lin experimental_A = mkTerm "experimental_A" ;
lin experimentalism_N = mkTerm "experimentalism_N" ;
lin experimentation_N = mkTerm "experimentation_N" ;
lin experimenterFem_N = mkTerm "experimenterFem_N" ;
lin experimenterMasc_N = mkTerm "experimenterMasc_N" ;
lin expert_A = mkTerm "expert_A" ;
lin expert_N = mkTerm "expert_N" ;
lin expertise_N = mkTerm "expertise_N" ;
lin expertness_N = mkTerm "expertness_N" ;
lin expiable_A = mkTerm "expiable_A" ;
lin expiate_V2 = mkTerm "expiate_V2" ;
lin expiation_N = mkTerm "expiation_N" ;
lin expiatory_A = mkTerm "expiatory_A" ;
lin expiration_N = mkTerm "expiration_N" ;
lin expiratory_A = mkTerm "expiratory_A" ;
lin expire_V = mkTerm "expire_V" ;
lin expire_V2 = mkTerm "expire_V2" ;
lin expire_VS = mkTerm "expire_VS" ;
lin expiry_N = mkTerm "expiry_N" ;
lin explain_V2 = mkTerm "explain_V2" ;
lin explain_VS = mkTerm "explain_VS" ;
lin explain_away_V = mkTerm "explain_away_V" ;
lin explainable_A = mkTerm "explainable_A" ;
lin explanans_N = mkTerm "explanans_N" ;
lin explanation_N = mkTerm "explanation_N" ;
lin explanatory_A = mkTerm "explanatory_A" ;
lin expletive_N = mkTerm "expletive_N" ;
lin explicable_A = mkTerm "explicable_A" ;
lin explicandum_N = mkTerm "explicandum_N" ;
lin explicate_V2 = mkTerm "explicate_V2" ;
lin explication_N = mkTerm "explication_N" ;
lin explicit_A = mkTerm "explicit_A" ;
lin explicitness_N = mkTerm "explicitness_N" ;
lin explode_V = mkTerm "explode_V" ;
lin exploit_N = mkTerm "exploit_N" ;
lin exploit_V2 = mkTerm "exploit_V2" ;
lin exploitation_N = mkTerm "exploitation_N" ;
lin exploitative_A = mkTerm "exploitative_A" ;
lin exploiter_N = mkTerm "exploiter_N" ;
lin exploration_N = mkTerm "exploration_N" ;
lin exploratory_A = mkTerm "exploratory_A" ;
lin explore_V2 = mkTerm "explore_V2" ;
lin explore_VS = mkTerm "explore_VS" ;
lin explorerFem_N = mkTerm "explorerFem_N" ;
lin explorerMasc_N = mkTerm "explorerMasc_N" ;
lin explosion_N = mkTerm "explosion_N" ;
lin explosive_A = mkTerm "explosive_A" ;
lin explosive_N = mkTerm "explosive_N" ;
lin expo_N = mkTerm "expo_N" ;
lin exponent_1_N = mkTerm "exponent_1_N" ;
lin exponent_2_N = mkTerm "exponent_2_N" ;
lin exponential_A = mkTerm "exponential_A" ;
lin exponential_N = mkTerm "exponential_N" ;
lin exponentiation_N = mkTerm "exponentiation_N" ;
lin export_N = mkTerm "export_N" ;
lin export_V = mkTerm "export_V" ;
lin export_V2 = mkTerm "export_V2" ;
lin exportable_A = mkTerm "exportable_A" ;
lin exportation_N = mkTerm "exportation_N" ;
lin exporterFem_N = mkTerm "exporterFem_N" ;
lin exporterMasc_N = mkTerm "exporterMasc_N" ;
lin exporting_N = mkTerm "exporting_N" ;
lin expose_N = mkTerm "expose_N" ;
lin expose_V = mkTerm "expose_V" ;
lin expose_V2 = mkTerm "expose_V2" ;
lin exposition_N = mkTerm "exposition_N" ;
lin expositor_N = mkTerm "expositor_N" ;
lin expository_A = mkTerm "expository_A" ;
lin expostulate_V = mkTerm "expostulate_V" ;
lin expostulation_N = mkTerm "expostulation_N" ;
lin exposure_N = mkTerm "exposure_N" ;
lin expound_V2 = mkTerm "expound_V2" ;
lin expound_VS = mkTerm "expound_VS" ;
lin express_A = mkTerm "express_A" ;
lin express_Adv = mkTerm "express_Adv" ;
lin express_N = mkTerm "express_N" ;
lin express_V2 = mkTerm "express_V2" ;
lin expressible_A = mkTerm "expressible_A" ;
lin expression_N = mkTerm "expression_N" ;
lin expressionism_N = mkTerm "expressionism_N" ;
lin expressionistFem_N = mkTerm "expressionistFem_N" ;
lin expressionistMasc_N = mkTerm "expressionistMasc_N" ;
lin expressionist_A = mkTerm "expressionist_A" ;
lin expressionless_A = mkTerm "expressionless_A" ;
lin expressive_A = mkTerm "expressive_A" ;
lin expressiveness_N = mkTerm "expressiveness_N" ;
lin expressway_N = mkTerm "expressway_N" ;
lin expropriate_V2 = mkTerm "expropriate_V2" ;
lin expropriation_N = mkTerm "expropriation_N" ;
lin expulsion_N = mkTerm "expulsion_N" ;
lin expunction_N = mkTerm "expunction_N" ;
lin expunge_V2 = mkTerm "expunge_V2" ;
lin expurgate_V2 = mkTerm "expurgate_V2" ;
lin expurgation_N = mkTerm "expurgation_N" ;
lin expurgator_N = mkTerm "expurgator_N" ;
lin exquisite_A = mkTerm "exquisite_A" ;
lin exquisiteness_N = mkTerm "exquisiteness_N" ;
lin extant_A = mkTerm "extant_A" ;
lin extemporaneous_A = mkTerm "extemporaneous_A" ;
lin extemporary_A = mkTerm "extemporary_A" ;
lin extempore_A = mkTerm "extempore_A" ;
lin extempore_Adv = mkTerm "extempore_Adv" ;
lin extemporization_N = mkTerm "extemporization_N" ;
lin extemporize_V = mkTerm "extemporize_V" ;
lin extemporize_V2 = mkTerm "extemporize_V2" ;
lin extend_V = mkTerm "extend_V" ;
lin extend_V2 = mkTerm "extend_V2" ;
lin extended_A = mkTerm "extended_A" ;
lin extendible_A = mkTerm "extendible_A" ;
lin extensile_A = mkTerm "extensile_A" ;
lin extension_N = mkTerm "extension_N" ;
lin extensional_A = mkTerm "extensional_A" ;
lin extensive_A = mkTerm "extensive_A" ;
lin extent_N = mkTerm "extent_N" ;
lin extenuate_V2 = mkTerm "extenuate_V2" ;
lin extenuating_A = mkTerm "extenuating_A" ;
lin extenuation_N = mkTerm "extenuation_N" ;
lin exterior_A = mkTerm "exterior_A" ;
lin exterior_N = mkTerm "exterior_N" ;
lin exteriorize_V2 = mkTerm "exteriorize_V2" ;
lin exterminable_A = mkTerm "exterminable_A" ;
lin exterminate_V2 = mkTerm "exterminate_V2" ;
lin extermination_N = mkTerm "extermination_N" ;
lin exterminator_N = mkTerm "exterminator_N" ;
lin extern_N = mkTerm "extern_N" ;
lin external_A = mkTerm "external_A" ;
lin external_N = mkTerm "external_N" ;
lin externalization_N = mkTerm "externalization_N" ;
lin externalize_V2 = mkTerm "externalize_V2" ;
lin exteroception_N = mkTerm "exteroception_N" ;
lin exteroceptive_A = mkTerm "exteroceptive_A" ;
lin exteroceptor_N = mkTerm "exteroceptor_N" ;
lin exterritorial_A = mkTerm "exterritorial_A" ;
lin extinct_A = mkTerm "extinct_A" ;
lin extinction_N = mkTerm "extinction_N" ;
lin extinguish_V2 = mkTerm "extinguish_V2" ;
lin extinguishable_A = mkTerm "extinguishable_A" ;
lin extinguisher_N = mkTerm "extinguisher_N" ;
lin extirpate_V2 = mkTerm "extirpate_V2" ;
lin extirpation_N = mkTerm "extirpation_N" ;
lin extol_V2 = mkTerm "extol_V2" ;
lin extort_V = mkTerm "extort_V" ;
lin extort_V2 = mkTerm "extort_V2" ;
lin extortion_N = mkTerm "extortion_N" ;
lin extortionate_A = mkTerm "extortionate_A" ;
lin extra_A = mkTerm "extra_A" ;
lin extra_Adv = mkTerm "extra_Adv" ;
lin extra_N = mkTerm "extra_N" ;
lin extracellular_A = mkTerm "extracellular_A" ;
lin extract_N = mkTerm "extract_N" ;
lin extract_V2 = mkTerm "extract_V2" ;
lin extractable_A = mkTerm "extractable_A" ;
lin extraction_N = mkTerm "extraction_N" ;
lin extractor_N = mkTerm "extractor_N" ;
lin extracurricular_A = mkTerm "extracurricular_A" ;
lin extradite_V2 = mkTerm "extradite_V2" ;
lin extradition_N = mkTerm "extradition_N" ;
lin extrados_N = mkTerm "extrados_N" ;
lin extragalactic_A = mkTerm "extragalactic_A" ;
lin extrajudicial_A = mkTerm "extrajudicial_A" ;
lin extralegal_A = mkTerm "extralegal_A" ;
lin extralinguistic_A = mkTerm "extralinguistic_A" ;
lin extramarital_A = mkTerm "extramarital_A" ;
lin extramural_A = mkTerm "extramural_A" ;
lin extraneous_A = mkTerm "extraneous_A" ;
lin extraneousness_N = mkTerm "extraneousness_N" ;
lin extraordinariness_N = mkTerm "extraordinariness_N" ;
lin extraordinary_A = mkTerm "extraordinary_A" ;
lin extrapolate_V = mkTerm "extrapolate_V" ;
lin extrapolate_V2 = mkTerm "extrapolate_V2" ;
lin extrapolation_N = mkTerm "extrapolation_N" ;
lin extrasensory_A = mkTerm "extrasensory_A" ;
lin extrasystole_N = mkTerm "extrasystole_N" ;
lin extrasystolic_A = mkTerm "extrasystolic_A" ;
lin extraterrestrial_A = mkTerm "extraterrestrial_A" ;
lin extraterritorial_A = mkTerm "extraterritorial_A" ;
lin extratropical_A = mkTerm "extratropical_A" ;
lin extravagance_N = mkTerm "extravagance_N" ;
lin extravagant_A = mkTerm "extravagant_A" ;
lin extravaganza_N = mkTerm "extravaganza_N" ;
lin extravasation_N = mkTerm "extravasation_N" ;
lin extraversion_N = mkTerm "extraversion_N" ;
lin extreme_A = mkTerm "extreme_A" ;
lin extreme_N = mkTerm "extreme_N" ;
lin extremeness_N = mkTerm "extremeness_N" ;
lin extremism_N = mkTerm "extremism_N" ;
lin extremist_A = mkTerm "extremist_A" ;
lin extremist_N = mkTerm "extremist_N" ;
lin extremity_N = mkTerm "extremity_N" ;
lin extremum_N = mkTerm "extremum_N" ;
lin extricable_A = mkTerm "extricable_A" ;
lin extricate_V2 = mkTerm "extricate_V2" ;
lin extrication_N = mkTerm "extrication_N" ;
lin extrinsic_A = mkTerm "extrinsic_A" ;
lin extropic_A = mkTerm "extropic_A" ;
lin extropy_N = mkTerm "extropy_N" ;
lin extrospective_A = mkTerm "extrospective_A" ;
lin extroversion_N = mkTerm "extroversion_N" ;
lin extroversive_A = mkTerm "extroversive_A" ;
lin extrovert_A = mkTerm "extrovert_A" ;
lin extrovert_N = mkTerm "extrovert_N" ;
lin extroverted_A = mkTerm "extroverted_A" ;
lin extrovertish_A = mkTerm "extrovertish_A" ;
lin extrude_V2 = mkTerm "extrude_V2" ;
lin extrusion_N = mkTerm "extrusion_N" ;
lin extrusive_A = mkTerm "extrusive_A" ;
lin exuberance_N = mkTerm "exuberance_N" ;
lin exuberant_A = mkTerm "exuberant_A" ;
lin exudate_N = mkTerm "exudate_N" ;
lin exudation_N = mkTerm "exudation_N" ;
lin exude_V = mkTerm "exude_V" ;
lin exude_V2 = mkTerm "exude_V2" ;
lin exult_V = mkTerm "exult_V" ;
lin exultant_A = mkTerm "exultant_A" ;
lin exultation_N = mkTerm "exultation_N" ;
lin exurbia_N = mkTerm "exurbia_N" ;
lin exuviae_N = mkTerm "exuviae_N" ;
lin exuvial_A = mkTerm "exuvial_A" ;
lin eyas_N = mkTerm "eyas_N" ;
lin eye_N = mkTerm "eye_N" ;
lin eye_V2 = mkTerm "eye_V2" ;
lin eye_catching_A = mkTerm "eye_catching_A" ;
lin eye_opener_N = mkTerm "eye_opener_N" ;
lin eye_shadow_N = mkTerm "eye_shadow_N" ;
lin eye_up_V2 = mkTerm "eye_up_V2" ;
lin eyeball_N = mkTerm "eyeball_N" ;
lin eyeball_V2 = mkTerm "eyeball_V2" ;
lin eyebath_N = mkTerm "eyebath_N" ;
lin eyebrow_N = mkTerm "eyebrow_N" ;
lin eyecatching_A = mkTerm "eyecatching_A" ;
lin eyecup_N = mkTerm "eyecup_N" ;
lin eyedness_N = mkTerm "eyedness_N" ;
lin eyedrop_N = mkTerm "eyedrop_N" ;
lin eyeful_N = mkTerm "eyeful_N" ;
lin eyeglass_N = mkTerm "eyeglass_N" ;
lin eyelash_N = mkTerm "eyelash_N" ;
lin eyeless_A = mkTerm "eyeless_A" ;
lin eyelessness_N = mkTerm "eyelessness_N" ;
lin eyelet_N = mkTerm "eyelet_N" ;
lin eyelid_N = mkTerm "eyelid_N" ;
lin eyelike_A = mkTerm "eyelike_A" ;
lin eyeliner_N = mkTerm "eyeliner_N" ;
lin eyepatch_N = mkTerm "eyepatch_N" ;
lin eyepiece_N = mkTerm "eyepiece_N" ;
lin eyes_N = mkTerm "eyes_N" ;
lin eyeshot_N = mkTerm "eyeshot_N" ;
lin eyesight_N = mkTerm "eyesight_N" ;
lin eyesore_N = mkTerm "eyesore_N" ;
lin eyespot_N = mkTerm "eyespot_N" ;
lin eyestrain_N = mkTerm "eyestrain_N" ;
lin eyetooth_N = mkTerm "eyetooth_N" ;
lin eyewash_N = mkTerm "eyewash_N" ;
lin eyewitness_N = mkTerm "eyewitness_N" ;
lin eyrie_N = mkTerm "eyrie_N" ;
lin eyrir_N = mkTerm "eyrir_N" ;
lin eyry_N = mkTerm "eyry_N" ;
lin fa_N = mkTerm "fa_N" ;
lin fab_A = mkTerm "fab_A" ;
lin fabian_A = mkTerm "fabian_A" ;
lin fabian_N = mkTerm "fabian_N" ;
lin fable_N = mkTerm "fable_N" ;
lin fabled_A = mkTerm "fabled_A" ;
lin fabric_N = mkTerm "fabric_N" ;
lin fabricate_V2 = mkTerm "fabricate_V2" ;
lin fabrication_N = mkTerm "fabrication_N" ;
lin fabulist_N = mkTerm "fabulist_N" ;
lin fabulous_A = mkTerm "fabulous_A" ;
lin facade_N = mkTerm "facade_N" ;
lin face_N = mkTerm "face_N" ;
lin face_V = mkTerm "face_V" ;
lin face_V2 = mkTerm "face_V2" ;
lin face_ache_N = mkTerm "face_ache_N" ;
lin face_card_N = mkTerm "face_card_N" ;
lin face_cloth_N = mkTerm "face_cloth_N" ;
lin face_cream_N = mkTerm "face_cream_N" ;
lin face_lift_N = mkTerm "face_lift_N" ;
lin face_lifting_N = mkTerm "face_lifting_N" ;
lin face_off_V2 = mkTerm "face_off_V2" ;
lin face_pack_N = mkTerm "face_pack_N" ;
lin face_powder_N = mkTerm "face_powder_N" ;
lin face_saver_N = mkTerm "face_saver_N" ;
lin face_saving_A = mkTerm "face_saving_A" ;
lin face_saving_N = mkTerm "face_saving_N" ;
lin face_up_to_V2 = mkTerm "face_up_to_V2" ;
lin faceless_A = mkTerm "faceless_A" ;
lin faceplate_N = mkTerm "faceplate_N" ;
lin facer_N = mkTerm "facer_N" ;
lin facet_N = mkTerm "facet_N" ;
lin faceted_A = mkTerm "faceted_A" ;
lin facetious_A = mkTerm "facetious_A" ;
lin facetiousness_N = mkTerm "facetiousness_N" ;
lin facia_N = mkTerm "facia_N" ;
lin facial_A = mkTerm "facial_A" ;
lin facial_N = mkTerm "facial_N" ;
lin facile_A = mkTerm "facile_A" ;
lin facilitate_V2 = mkTerm "facilitate_V2" ;
lin facilitation_N = mkTerm "facilitation_N" ;
lin facilitative_A = mkTerm "facilitative_A" ;
lin facilitator_N = mkTerm "facilitator_N" ;
lin facilitatory_A = mkTerm "facilitatory_A" ;
lin facility_N = mkTerm "facility_N" ;
lin facing_N = mkTerm "facing_N" ;
lin facsimile_N = mkTerm "facsimile_N" ;
lin fact_N = mkTerm "fact_N" ;
lin fact_finding_A = mkTerm "fact_finding_A" ;
lin faction_N = mkTerm "faction_N" ;
lin factious_A = mkTerm "factious_A" ;
lin factitious_A = mkTerm "factitious_A" ;
lin factoid_N = mkTerm "factoid_N" ;
lin factor_N = mkTerm "factor_N" ;
lin factor_in_V = mkTerm "factor_in_V" ;
lin factorial_A = mkTerm "factorial_A" ;
lin factorial_N = mkTerm "factorial_N" ;
lin factorization_N = mkTerm "factorization_N" ;
lin factorize_V2 = mkTerm "factorize_V2" ;
lin factory_N = mkTerm "factory_N" ;
lin factotum_N = mkTerm "factotum_N" ;
lin factual_A = mkTerm "factual_A" ;
lin factuality_N = mkTerm "factuality_N" ;
lin facula_N = mkTerm "facula_N" ;
lin facultative_A = mkTerm "facultative_A" ;
lin faculty_N = mkTerm "faculty_N" ;
lin fad_N = mkTerm "fad_N" ;
lin faddish_A = mkTerm "faddish_A" ;
lin faddist_N = mkTerm "faddist_N" ;
lin faddy_A = mkTerm "faddy_A" ;
lin fade_N = mkTerm "fade_N" ;
lin fade_V = mkTerm "fade_V" ;
lin fade_V2 = mkTerm "fade_V2" ;
lin fadeout_N = mkTerm "fadeout_N" ;
lin fado_N = mkTerm "fado_N" ;
lin faecal_A = mkTerm "faecal_A" ;
lin faerie_N = mkTerm "faerie_N" ;
lin faery_N = mkTerm "faery_N" ;
lin faff_about_V = mkTerm "faff_about_V" ;
lin faff_around_V = mkTerm "faff_around_V" ;
lin fag_N = mkTerm "fag_N" ;
lin fag_V = mkTerm "fag_V" ;
lin fag_V2 = mkTerm "fag_V2" ;
lin fag_end_N = mkTerm "fag_end_N" ;
lin faggot_N = mkTerm "faggot_N" ;
lin fagot_N = mkTerm "fagot_N" ;
lin fagoting_N = mkTerm "fagoting_N" ;
lin faience_N = mkTerm "faience_N" ;
lin fail_N = mkTerm "fail_N" ;
lin fail_V = mkTerm "fail_V" ;
lin fail_V2 = mkTerm "fail_V2" ;
lin fail_VV = mkTerm "fail_VV" ;
lin fail_safe_A = mkTerm "fail_safe_A" ;
lin failing_N = mkTerm "failing_N" ;
lin faille_N = mkTerm "faille_N" ;
lin failure_N = mkTerm "failure_N" ;
lin fain_Adv = mkTerm "fain_Adv" ;
lin faineance_N = mkTerm "faineance_N" ;
lin faineant_A = mkTerm "faineant_A" ;
lin faint_A = mkTerm "faint_A" ;
lin faint_N = mkTerm "faint_N" ;
lin faint_V = mkTerm "faint_V" ;
lin faint_hearted_A = mkTerm "faint_hearted_A" ;
lin faintheartedness_N = mkTerm "faintheartedness_N" ;
lin faintness_N = mkTerm "faintness_N" ;
lin fair_A = mkTerm "fair_A" ;
lin fair_N = mkTerm "fair_N" ;
lin fair_minded_A = mkTerm "fair_minded_A" ;
lin fairground_N = mkTerm "fairground_N" ;
lin fairish_A = mkTerm "fairish_A" ;
lin fairlead_N = mkTerm "fairlead_N" ;
lin fairly_Adv = mkTerm "fairly_Adv" ;
lin fairness_N = mkTerm "fairness_N" ;
lin fairway_N = mkTerm "fairway_N" ;
lin fairy_N = mkTerm "fairy_N" ;
lin fairyland_N = mkTerm "fairyland_N" ;
lin fairytale_N = mkTerm "fairytale_N" ;
lin fait_accompli_N = mkTerm "fait_accompli_N" ;
lin faith_N = mkTerm "faith_N" ;
lin faith_healing_N = mkTerm "faith_healing_N" ;
lin faithful_A = mkTerm "faithful_A" ;
lin faithful_N = mkTerm "faithful_N" ;
lin faithfulness_N = mkTerm "faithfulness_N" ;
lin faithless_A = mkTerm "faithless_A" ;
lin faithlessness_N = mkTerm "faithlessness_N" ;
lin fake_A = mkTerm "fake_A" ;
lin fake_N = mkTerm "fake_N" ;
lin fake_V2 = mkTerm "fake_V2" ;
lin fakery_N = mkTerm "fakery_N" ;
lin fakir_N = mkTerm "fakir_N" ;
lin falafel_N = mkTerm "falafel_N" ;
lin falangist_N = mkTerm "falangist_N" ;
lin falcate_A = mkTerm "falcate_A" ;
lin falchion_N = mkTerm "falchion_N" ;
lin falcon_N = mkTerm "falcon_N" ;
lin falconer_N = mkTerm "falconer_N" ;
lin falconine_A = mkTerm "falconine_A" ;
lin falconry_N = mkTerm "falconry_N" ;
lin falkirk_PN = mkTerm "falkirk_PN" ;
lin fall_1_N = mkTerm "fall_1_N" ;
lin fall_2_N = mkTerm "fall_2_N" ;
lin fall_V = mkTerm "fall_V" ;
lin fall_about_V = mkTerm "fall_about_V" ;
lin fall_apart_V = mkTerm "fall_apart_V" ;
lin fall_back_V = mkTerm "fall_back_V" ;
lin fall_back_on_V2 = mkTerm "fall_back_on_V2" ;
lin fall_behind_V = mkTerm "fall_behind_V" ;
lin fall_behind_in_V2 = mkTerm "fall_behind_in_V2" ;
lin fall_down_V = mkTerm "fall_down_V" ;
lin fall_for_V2 = mkTerm "fall_for_V2" ;
lin fall_in_V = mkTerm "fall_in_V" ;
lin fall_into_V2 = mkTerm "fall_into_V2" ;
lin fall_off_V = mkTerm "fall_off_V" ;
lin fall_out_V = mkTerm "fall_out_V" ;
lin fall_out_with_V2 = mkTerm "fall_out_with_V2" ;
lin fall_over_V = mkTerm "fall_over_V" ;
lin fall_through_V = mkTerm "fall_through_V" ;
lin fall_under_V2 = mkTerm "fall_under_V2" ;
lin fallacious_A = mkTerm "fallacious_A" ;
lin fallaciousness_N = mkTerm "fallaciousness_N" ;
lin fallacy_N = mkTerm "fallacy_N" ;
lin fallboard_N = mkTerm "fallboard_N" ;
lin faller_N = mkTerm "faller_N" ;
lin fallibility_N = mkTerm "fallibility_N" ;
lin fallible_A = mkTerm "fallible_A" ;
lin fallopian_A = mkTerm "fallopian_A" ;
lin fallout_N = mkTerm "fallout_N" ;
lin fallow_A = mkTerm "fallow_A" ;
lin fallow_N = mkTerm "fallow_N" ;
lin fallow_deer_N = mkTerm "fallow_deer_N" ;
lin falls_N = mkTerm "falls_N" ;
lin falmouth_PN = mkTerm "falmouth_PN" ;
lin false_A = mkTerm "false_A" ;
lin false_Adv = mkTerm "false_Adv" ;
lin falsehood_N = mkTerm "falsehood_N" ;
lin falseness_N = mkTerm "falseness_N" ;
lin falsetto_A = mkTerm "falsetto_A" ;
lin falsetto_N = mkTerm "falsetto_N" ;
lin falsie_N = mkTerm "falsie_N" ;
lin falsification_N = mkTerm "falsification_N" ;
lin falsifier_N = mkTerm "falsifier_N" ;
lin falsify_V2 = mkTerm "falsify_V2" ;
lin falsity_N = mkTerm "falsity_N" ;
lin falter_V = mkTerm "falter_V" ;
lin falter_V2 = mkTerm "falter_V2" ;
lin falteringly_Adv = mkTerm "falteringly_Adv" ;
lin fame_N = mkTerm "fame_N" ;
lin fame_V2 = mkTerm "fame_V2" ;
lin familial_A = mkTerm "familial_A" ;
lin familiar_A = mkTerm "familiar_A" ;
lin familiar_N = mkTerm "familiar_N" ;
lin familiar_with_A2 = mkTerm "familiar_with_A2" ;
lin familiarity_N = mkTerm "familiarity_N" ;
lin familiarization_N = mkTerm "familiarization_N" ;
lin familiarize_V2 = mkTerm "familiarize_V2" ;
lin familiarizing_A = mkTerm "familiarizing_A" ;
lin family_N = mkTerm "family_N" ;
lin famine_N = mkTerm "famine_N" ;
lin famish_V = mkTerm "famish_V" ;
lin famish_V2 = mkTerm "famish_V2" ;
lin famotidine_N = mkTerm "famotidine_N" ;
lin famous_A = mkTerm "famous_A" ;
lin famulus_N = mkTerm "famulus_N" ;
lin fan_1_N = mkTerm "fan_1_N" ;
lin fan_2_N = mkTerm "fan_2_N" ;
lin fan_3_N = mkTerm "fan_3_N" ;
lin fan_V = mkTerm "fan_V" ;
lin fan_V2 = mkTerm "fan_V2" ;
lin fan_belt_N = mkTerm "fan_belt_N" ;
lin fanaloka_N = mkTerm "fanaloka_N" ;
lin fanaticFem_N = mkTerm "fanaticFem_N" ;
lin fanaticMasc_N = mkTerm "fanaticMasc_N" ;
lin fanatic_A = mkTerm "fanatic_A" ;
lin fanatical_A = mkTerm "fanatical_A" ;
lin fanaticism_N = mkTerm "fanaticism_N" ;
lin fanbase_N = mkTerm "fanbase_N" ;
lin fancier_N = mkTerm "fancier_N" ;
lin fanciful_A = mkTerm "fanciful_A" ;
lin fancy_A = mkTerm "fancy_A" ;
lin fancy_N = mkTerm "fancy_N" ;
lin fancy_V2 = mkTerm "fancy_V2" ;
lin fancy_free_A = mkTerm "fancy_free_A" ;
lin fandango_N = mkTerm "fandango_N" ;
lin fandom_A = mkTerm "fandom_A" ;
lin fandom_N = mkTerm "fandom_N" ;
lin fanfare_N = mkTerm "fanfare_N" ;
lin fang_N = mkTerm "fang_N" ;
lin fanged_A = mkTerm "fanged_A" ;
lin fanion_N = mkTerm "fanion_N" ;
lin fanjet_N = mkTerm "fanjet_N" ;
lin fanlight_N = mkTerm "fanlight_N" ;
lin fanlike_A = mkTerm "fanlike_A" ;
lin fanny_N = mkTerm "fanny_N" ;
lin fanny_PN = mkTerm "fanny_PN" ;
lin fansite_N = mkTerm "fansite_N" ;
lin fantail_N = mkTerm "fantail_N" ;
lin fantan_N = mkTerm "fantan_N" ;
lin fantasia_N = mkTerm "fantasia_N" ;
lin fantasist_N = mkTerm "fantasist_N" ;
lin fantasize_V = mkTerm "fantasize_V" ;
lin fantast_N = mkTerm "fantast_N" ;
lin fantastic_A = mkTerm "fantastic_A" ;
lin fantastically_Adv = mkTerm "fantastically_Adv" ;
lin fantasy_N = mkTerm "fantasy_N" ;
lin fantods_N = mkTerm "fantods_N" ;
lin fao_N = mkTerm "fao_N" ;
lin far_A = mkTerm "far_A" ;
lin far_AdA = mkTerm "far_AdA" ;
lin far_V2 = mkTerm "far_V2" ;
lin far_famed_A = mkTerm "far_famed_A" ;
lin far_fetched_A = mkTerm "far_fetched_A" ;
lin far_flung_A = mkTerm "far_flung_A" ;
lin far_from_Prep = mkTerm "far_from_Prep" ;
lin far_off_A = mkTerm "far_off_A" ;
lin far_reaching_A = mkTerm "far_reaching_A" ;
lin far_seeing_A = mkTerm "far_seeing_A" ;
lin far_sighted_A = mkTerm "far_sighted_A" ;
lin farad_N = mkTerm "farad_N" ;
lin farandole_N = mkTerm "farandole_N" ;
lin faraway_A = mkTerm "faraway_A" ;
lin farce_N = mkTerm "farce_N" ;
lin farcical_A = mkTerm "farcical_A" ;
lin fardel_N = mkTerm "fardel_N" ;
lin fare_N = mkTerm "fare_N" ;
lin fare_V = mkTerm "fare_V" ;
lin fare_stage_N = mkTerm "fare_stage_N" ;
lin farewell_N = mkTerm "farewell_N" ;
lin farfalle_N = mkTerm "farfalle_N" ;
lin farina_N = mkTerm "farina_N" ;
lin farinaceous_A = mkTerm "farinaceous_A" ;
lin farkleberry_N = mkTerm "farkleberry_N" ;
lin farm_N = mkTerm "farm_N" ;
lin farm_V = mkTerm "farm_V" ;
lin farm_V2 = mkTerm "farm_V2" ;
lin farm_out_V2 = mkTerm "farm_out_V2" ;
lin farmer_N = mkTerm "farmer_N" ;
lin farmerette_N = mkTerm "farmerette_N" ;
lin farmhand_N = mkTerm "farmhand_N" ;
lin farmhouse_N = mkTerm "farmhouse_N" ;
lin farming_N = mkTerm "farming_N" ;
lin farmland_N = mkTerm "farmland_N" ;
lin farmplace_N = mkTerm "farmplace_N" ;
lin farmstead_N = mkTerm "farmstead_N" ;
lin farmyard_N = mkTerm "farmyard_N" ;
lin farness_N = mkTerm "farness_N" ;
lin farnham_PN = mkTerm "farnham_PN" ;
lin farnworth_PN = mkTerm "farnworth_PN" ;
lin faro_N = mkTerm "faro_N" ;
lin farrago_N = mkTerm "farrago_N" ;
lin farrier_N = mkTerm "farrier_N" ;
lin farrow_N = mkTerm "farrow_N" ;
lin farrow_V = mkTerm "farrow_V" ;
lin farsi_N = mkTerm "farsi_N" ;
lin fart_N = mkTerm "fart_N" ;
lin fart_V = mkTerm "fart_V" ;
lin fart_about_V = mkTerm "fart_about_V" ;
lin fart_around_V = mkTerm "fart_around_V" ;
lin farther_A = mkTerm "farther_A" ;
lin farther_Adv = mkTerm "farther_Adv" ;
lin farthermost_A = mkTerm "farthermost_A" ;
lin farthest_Adv = mkTerm "farthest_Adv" ;
lin farthing_N = mkTerm "farthing_N" ;
lin farthingale_N = mkTerm "farthingale_N" ;
lin fartlek_N = mkTerm "fartlek_N" ;
lin fasces_N = mkTerm "fasces_N" ;
lin fascia_N = mkTerm "fascia_N" ;
lin fascicle_N = mkTerm "fascicle_N" ;
lin fasciculation_N = mkTerm "fasciculation_N" ;
lin fascinate_V2 = mkTerm "fascinate_V2" ;
lin fascinating_A = mkTerm "fascinating_A" ;
lin fascination_N = mkTerm "fascination_N" ;
lin fascioliasis_N = mkTerm "fascioliasis_N" ;
lin fasciolopsiasis_N = mkTerm "fasciolopsiasis_N" ;
lin fascism_N = mkTerm "fascism_N" ;
lin fascist_A = mkTerm "fascist_A" ;
lin fascist_N = mkTerm "fascist_N" ;
lin fascista_N = mkTerm "fascista_N" ;
lin fashion_N = mkTerm "fashion_N" ;
lin fashion_V2 = mkTerm "fashion_V2" ;
lin fashionable_A = mkTerm "fashionable_A" ;
lin fast_A = mkTerm "fast_A" ;
lin fast_N = mkTerm "fast_N" ;
lin fast_V = mkTerm "fast_V" ;
lin fastball_N = mkTerm "fastball_N" ;
lin fasten_V = mkTerm "fasten_V" ;
lin fasten_V2 = mkTerm "fasten_V2" ;
lin fasten_down_V2 = mkTerm "fasten_down_V2" ;
lin fasten_on_V2 = mkTerm "fasten_on_V2" ;
lin fasten_onto_V2 = mkTerm "fasten_onto_V2" ;
lin fasten_up_V2 = mkTerm "fasten_up_V2" ;
lin fastener_N = mkTerm "fastener_N" ;
lin fastening_N = mkTerm "fastening_N" ;
lin fastidious_A = mkTerm "fastidious_A" ;
lin fastidiousness_N = mkTerm "fastidiousness_N" ;
lin fastigiate_A = mkTerm "fastigiate_A" ;
lin fastnacht_N = mkTerm "fastnacht_N" ;
lin fastness_N = mkTerm "fastness_N" ;
lin fat_A = mkTerm "fat_A" ;
lin fat_N = mkTerm "fat_N" ;
lin fat_V2 = mkTerm "fat_V2" ;
lin fatal_A = mkTerm "fatal_A" ;
lin fatalism_N = mkTerm "fatalism_N" ;
lin fatalistFem_N = mkTerm "fatalistFem_N" ;
lin fatalistMasc_N = mkTerm "fatalistMasc_N" ;
lin fatalist_A = mkTerm "fatalist_A" ;
lin fatalistic_A = mkTerm "fatalistic_A" ;
lin fatality_N = mkTerm "fatality_N" ;
lin fatback_N = mkTerm "fatback_N" ;
lin fate_N = mkTerm "fate_N" ;
lin fate_V2 = mkTerm "fate_V2" ;
lin fateful_A = mkTerm "fateful_A" ;
lin fathead_N = mkTerm "fathead_N" ;
lin father_N = mkTerm "father_N" ;
lin father_V2 = mkTerm "father_V2" ;
lin father_in_law_N = mkTerm "father_in_law_N" ;
lin fatherhood_N = mkTerm "fatherhood_N" ;
lin fatherland_N = mkTerm "fatherland_N" ;
lin fatherless_A = mkTerm "fatherless_A" ;
lin fatherliness_N = mkTerm "fatherliness_N" ;
lin fatherly_A = mkTerm "fatherly_A" ;
lin fathom_N = mkTerm "fathom_N" ;
lin fathom_V2 = mkTerm "fathom_V2" ;
lin fathom_out_V2 = mkTerm "fathom_out_V2" ;
lin fathomable_A = mkTerm "fathomable_A" ;
lin fathomless_A = mkTerm "fathomless_A" ;
lin fatigability_N = mkTerm "fatigability_N" ;
lin fatigue_N = mkTerm "fatigue_N" ;
lin fatigue_V2 = mkTerm "fatigue_V2" ;
lin fatigue_party_N = mkTerm "fatigue_party_N" ;
lin fatigues_N = mkTerm "fatigues_N" ;
lin fatless_A = mkTerm "fatless_A" ;
lin fatness_N = mkTerm "fatness_N" ;
lin fatso_N = mkTerm "fatso_N" ;
lin fatten_V = mkTerm "fatten_V" ;
lin fatten_V2 = mkTerm "fatten_V2" ;
lin fatten_up_V2 = mkTerm "fatten_up_V2" ;
lin fattish_A = mkTerm "fattish_A" ;
lin fattism_N = mkTerm "fattism_N" ;
lin fatty_A = mkTerm "fatty_A" ;
lin fatuity_N = mkTerm "fatuity_N" ;
lin fatuous_A = mkTerm "fatuous_A" ;
lin fatuousness_N = mkTerm "fatuousness_N" ;
lin fatwa_N = mkTerm "fatwa_N" ;
lin fatwah_N = mkTerm "fatwah_N" ;
lin faubourg_N = mkTerm "faubourg_N" ;
lin faucal_A = mkTerm "faucal_A" ;
lin fauces_N = mkTerm "fauces_N" ;
lin faucet_N = mkTerm "faucet_N" ;
lin fauld_N = mkTerm "fauld_N" ;
lin fauldhouse_PN = mkTerm "fauldhouse_PN" ;
lin fault_N = mkTerm "fault_N" ;
lin fault_V2 = mkTerm "fault_V2" ;
lin fault_finder_N = mkTerm "fault_finder_N" ;
lin fault_finding_N = mkTerm "fault_finding_N" ;
lin faultless_A = mkTerm "faultless_A" ;
lin faultlessness_N = mkTerm "faultlessness_N" ;
lin faulty_A = mkTerm "faulty_A" ;
lin faun_N = mkTerm "faun_N" ;
lin fauna_N = mkTerm "fauna_N" ;
lin fauteuil_N = mkTerm "fauteuil_N" ;
lin fauvism_N = mkTerm "fauvism_N" ;
lin faux_pas_N = mkTerm "faux_pas_N" ;
lin faversham_PN = mkTerm "faversham_PN" ;
lin favism_N = mkTerm "favism_N" ;
lin favour_N = mkTerm "favour_N" ;
lin favour_V = mkTerm "favour_V" ;
lin favour_V2 = mkTerm "favour_V2" ;
lin favour_VS = mkTerm "favour_VS" ;
lin favourable_A = mkTerm "favourable_A" ;
lin favourableness_N = mkTerm "favourableness_N" ;
lin favoured_A = mkTerm "favoured_A" ;
lin favouriteFem_N = mkTerm "favouriteFem_N" ;
lin favouriteMasc_N = mkTerm "favouriteMasc_N" ;
lin favourite_A = mkTerm "favourite_A" ;
lin favouritism_N = mkTerm "favouritism_N" ;
lin favus_N = mkTerm "favus_N" ;
lin fawley_PN = mkTerm "fawley_PN" ;
lin fawn_N = mkTerm "fawn_N" ;
lin fawn_V = mkTerm "fawn_V" ;
lin fawn_on_V2 = mkTerm "fawn_on_V2" ;
lin fawn_over_V2 = mkTerm "fawn_over_V2" ;
lin fax_N = mkTerm "fax_N" ;
lin fbi_PN = mkTerm "fbi_PN" ;
lin fealty_N = mkTerm "fealty_N" ;
lin fear_N = mkTerm "fear_N" ;
lin fear_V = mkTerm "fear_V" ;
lin fear_V2 = mkTerm "fear_V2" ;
lin fear_VS = mkTerm "fear_VS" ;
lin fearful_A = mkTerm "fearful_A" ;
lin fearfulness_N = mkTerm "fearfulness_N" ;
lin fearless_A = mkTerm "fearless_A" ;
lin fearlessness_N = mkTerm "fearlessness_N" ;
lin fearsome_A = mkTerm "fearsome_A" ;
lin feasibility_N = mkTerm "feasibility_N" ;
lin feasible_A = mkTerm "feasible_A" ;
lin feast_N = mkTerm "feast_N" ;
lin feast_V = mkTerm "feast_V" ;
lin feast_V2 = mkTerm "feast_V2" ;
lin feast_day_N = mkTerm "feast_day_N" ;
lin feasting_N = mkTerm "feasting_N" ;
lin feat_N = mkTerm "feat_N" ;
lin feather_N = mkTerm "feather_N" ;
lin feather_V2 = mkTerm "feather_V2" ;
lin feather_boa_N = mkTerm "feather_boa_N" ;
lin featherbed_N = mkTerm "featherbed_N" ;
lin featherbed_V2 = mkTerm "featherbed_V2" ;
lin featherbedding_N = mkTerm "featherbedding_N" ;
lin featherbrained_A = mkTerm "featherbrained_A" ;
lin featheredge_N = mkTerm "featheredge_N" ;
lin featherfoil_N = mkTerm "featherfoil_N" ;
lin featherlike_A = mkTerm "featherlike_A" ;
lin featherstone_PN = mkTerm "featherstone_PN" ;
lin feathertop_N = mkTerm "feathertop_N" ;
lin featherweight_N = mkTerm "featherweight_N" ;
lin feathery_A = mkTerm "feathery_A" ;
lin feature_N = mkTerm "feature_N" ;
lin feature_V2 = mkTerm "feature_V2" ;
lin featureless_A = mkTerm "featureless_A" ;
lin feb_PN = mkTerm "feb_PN" ;
lin febrile_A = mkTerm "febrile_A" ;
lin feckless_A = mkTerm "feckless_A" ;
lin fecklessness_N = mkTerm "fecklessness_N" ;
lin fecula_N = mkTerm "fecula_N" ;
lin feculence_N = mkTerm "feculence_N" ;
lin feculent_A = mkTerm "feculent_A" ;
lin fecund_A = mkTerm "fecund_A" ;
lin fecundity_N = mkTerm "fecundity_N" ;
lin fed_N = mkTerm "fed_N" ;
lin fed_up_V = mkTerm "fed_up_V" ;
lin fedayeen_N = mkTerm "fedayeen_N" ;
lin fedelline_N = mkTerm "fedelline_N" ;
lin federal_A = mkTerm "federal_A" ;
lin federalism_N = mkTerm "federalism_N" ;
lin federalist_N = mkTerm "federalist_N" ;
lin federalization_N = mkTerm "federalization_N" ;
lin federate_A = mkTerm "federate_A" ;
lin federate_V = mkTerm "federate_V" ;
lin federate_V2 = mkTerm "federate_V2" ;
lin federation_N = mkTerm "federation_N" ;
lin fedora_N = mkTerm "fedora_N" ;
lin fee_N = mkTerm "fee_N" ;
lin fee_V2 = mkTerm "fee_V2" ;
lin feeble_A = mkTerm "feeble_A" ;
lin feeble_minded_A = mkTerm "feeble_minded_A" ;
lin feeblemindedness_N = mkTerm "feeblemindedness_N" ;
lin feebleness_N = mkTerm "feebleness_N" ;
lin feed_N = mkTerm "feed_N" ;
lin feed_V = mkTerm "feed_V" ;
lin feed_V2 = mkTerm "feed_V2" ;
lin feed_off_V2 = mkTerm "feed_off_V2" ;
lin feed_on_V2 = mkTerm "feed_on_V2" ;
lin feed_up_V2 = mkTerm "feed_up_V2" ;
lin feedback_N = mkTerm "feedback_N" ;
lin feeder_N = mkTerm "feeder_N" ;
lin feeding_N = mkTerm "feeding_N" ;
lin feeding_bottle_N = mkTerm "feeding_bottle_N" ;
lin feedlot_N = mkTerm "feedlot_N" ;
lin feedstock_N = mkTerm "feedstock_N" ;
lin feel_N = mkTerm "feel_N" ;
lin feel_V = mkTerm "feel_V" ;
lin feel_V2 = mkTerm "feel_V2" ;
lin feel_VA = mkTerm "feel_VA" ;
lin feel_VS = mkTerm "feel_VS" ;
lin feel_out_V = mkTerm "feel_out_V" ;
lin feel_up_V2 = mkTerm "feel_up_V2" ;
lin feel_up_to_V2 = mkTerm "feel_up_to_V2" ;
lin feeler_N = mkTerm "feeler_N" ;
lin feeling_N = mkTerm "feeling_N" ;
lin feelingly_Adv = mkTerm "feelingly_Adv" ;
lin feelings_N = mkTerm "feelings_N" ;
lin feetfirst_Adv = mkTerm "feetfirst_Adv" ;
lin feign_V2 = mkTerm "feign_V2" ;
lin feijoa_N = mkTerm "feijoa_N" ;
lin feint_N = mkTerm "feint_N" ;
lin feint_V = mkTerm "feint_V" ;
lin feist_N = mkTerm "feist_N" ;
lin feisty_A = mkTerm "feisty_A" ;
lin feldspar_N = mkTerm "feldspar_N" ;
lin felicitate_V2 = mkTerm "felicitate_V2" ;
lin felicitation_N = mkTerm "felicitation_N" ;
lin felicitous_A = mkTerm "felicitous_A" ;
lin felicity_N = mkTerm "felicity_N" ;
lin felicity_PN = mkTerm "felicity_PN" ;
lin feline_A = mkTerm "feline_A" ;
lin feline_N = mkTerm "feline_N" ;
lin felix_PN = mkTerm "felix_PN" ;
lin felixstowe_PN = mkTerm "felixstowe_PN" ;
lin fell_A = mkTerm "fell_A" ;
lin fell_N = mkTerm "fell_N" ;
lin fell_V2 = mkTerm "fell_V2" ;
lin fell_apart_V = mkTerm "fell_apart_V" ;
lin fell_off_V = mkTerm "fell_off_V" ;
lin fell_through_V = mkTerm "fell_through_V" ;
lin fellah_N = mkTerm "fellah_N" ;
lin fellatio_N = mkTerm "fellatio_N" ;
lin felloe_N = mkTerm "felloe_N" ;
lin fellow_A = mkTerm "fellow_A" ;
lin fellow_N = mkTerm "fellow_N" ;
lin fellow_feeling_N = mkTerm "fellow_feeling_N" ;
lin fellow_traveller_N = mkTerm "fellow_traveller_N" ;
lin fellowship_N = mkTerm "fellowship_N" ;
lin felon_N = mkTerm "felon_N" ;
lin felonious_A = mkTerm "felonious_A" ;
lin felony_N = mkTerm "felony_N" ;
lin felspar_N = mkTerm "felspar_N" ;
lin felt_N = mkTerm "felt_N" ;
lin felted_A = mkTerm "felted_A" ;
lin felucca_N = mkTerm "felucca_N" ;
lin felwort_N = mkTerm "felwort_N" ;
lin fem_PN = mkTerm "fem_PN" ;
lin female_A = mkTerm "female_A" ;
lin female_N = mkTerm "female_N" ;
lin femaleness_N = mkTerm "femaleness_N" ;
lin feminine_A = mkTerm "feminine_A" ;
lin feminine_N = mkTerm "feminine_N" ;
lin femininity_N = mkTerm "femininity_N" ;
lin feminism_N = mkTerm "feminism_N" ;
lin feministFem_N = mkTerm "feministFem_N" ;
lin feministMasc_N = mkTerm "feministMasc_N" ;
lin feminist_A = mkTerm "feminist_A" ;
lin feminization_N = mkTerm "feminization_N" ;
lin femoral_A = mkTerm "femoral_A" ;
lin femtochemistry_N = mkTerm "femtochemistry_N" ;
lin femtometer_N = mkTerm "femtometer_N" ;
lin femtosecond_N = mkTerm "femtosecond_N" ;
lin femtovolt_N = mkTerm "femtovolt_N" ;
lin femur_N = mkTerm "femur_N" ;
lin fen_N = mkTerm "fen_N" ;
lin fence_N = mkTerm "fence_N" ;
lin fence_V2 = mkTerm "fence_V2" ;
lin fence_in_V2 = mkTerm "fence_in_V2" ;
lin fence_off_V2 = mkTerm "fence_off_V2" ;
lin fencelike_A = mkTerm "fencelike_A" ;
lin fencer_N = mkTerm "fencer_N" ;
lin fencing_N = mkTerm "fencing_N" ;
lin fend_V = mkTerm "fend_V" ;
lin fend_V2 = mkTerm "fend_V2" ;
lin fend_for_V2 = mkTerm "fend_for_V2" ;
lin fend_off_V2 = mkTerm "fend_off_V2" ;
lin fender_N = mkTerm "fender_N" ;
lin fenestra_N = mkTerm "fenestra_N" ;
lin fenestral_A = mkTerm "fenestral_A" ;
lin fenestration_N = mkTerm "fenestration_N" ;
lin fennel_N = mkTerm "fennel_N" ;
lin fenoprofen_N = mkTerm "fenoprofen_N" ;
lin fenugreek_N = mkTerm "fenugreek_N" ;
lin feoff_N = mkTerm "feoff_N" ;
lin feral_A = mkTerm "feral_A" ;
lin fergusonite_N = mkTerm "fergusonite_N" ;
lin feria_N = mkTerm "feria_N" ;
lin ferial_A = mkTerm "ferial_A" ;
lin fermanagh_PN = mkTerm "fermanagh_PN" ;
lin fermata_N = mkTerm "fermata_N" ;
lin ferment_N = mkTerm "ferment_N" ;
lin ferment_V = mkTerm "ferment_V" ;
lin ferment_V2 = mkTerm "ferment_V2" ;
lin fermentable_A = mkTerm "fermentable_A" ;
lin fermentation_N = mkTerm "fermentation_N" ;
lin fermion_N = mkTerm "fermion_N" ;
lin fermium_N = mkTerm "fermium_N" ;
lin fern_N = mkTerm "fern_N" ;
lin ferned_A = mkTerm "ferned_A" ;
lin fernless_A = mkTerm "fernless_A" ;
lin fernlike_A = mkTerm "fernlike_A" ;
lin ferny_A = mkTerm "ferny_A" ;
lin ferocious_A = mkTerm "ferocious_A" ;
lin ferociousness_N = mkTerm "ferociousness_N" ;
lin ferocity_N = mkTerm "ferocity_N" ;
lin ferrara_PN = mkTerm "ferrara_PN" ;
lin ferret_N = mkTerm "ferret_N" ;
lin ferret_V = mkTerm "ferret_V" ;
lin ferret_V2 = mkTerm "ferret_V2" ;
lin ferret_out_V2 = mkTerm "ferret_out_V2" ;
lin ferric_A = mkTerm "ferric_A" ;
lin ferricyanide_N = mkTerm "ferricyanide_N" ;
lin ferrimagnetism_N = mkTerm "ferrimagnetism_N" ;
lin ferris_wheel_N = mkTerm "ferris_wheel_N" ;
lin ferrite_N = mkTerm "ferrite_N" ;
lin ferritin_N = mkTerm "ferritin_N" ;
lin ferrocerium_N = mkTerm "ferrocerium_N" ;
lin ferroconcrete_N = mkTerm "ferroconcrete_N" ;
lin ferrocyanide_N = mkTerm "ferrocyanide_N" ;
lin ferromagnetic_A = mkTerm "ferromagnetic_A" ;
lin ferromagnetism_N = mkTerm "ferromagnetism_N" ;
lin ferrous_A = mkTerm "ferrous_A" ;
lin ferrule_N = mkTerm "ferrule_N" ;
lin ferry_N = mkTerm "ferry_N" ;
lin ferry_V = mkTerm "ferry_V" ;
lin ferry_V2 = mkTerm "ferry_V2" ;
lin ferryboat_N = mkTerm "ferryboat_N" ;
lin ferryhill_PN = mkTerm "ferryhill_PN" ;
lin ferryman_N = mkTerm "ferryman_N" ;
lin fertile_A = mkTerm "fertile_A" ;
lin fertility_N = mkTerm "fertility_N" ;
lin fertilizable_A = mkTerm "fertilizable_A" ;
lin fertilization_N = mkTerm "fertilization_N" ;
lin fertilize_V2 = mkTerm "fertilize_V2" ;
lin fertilizer_N = mkTerm "fertilizer_N" ;
lin ferule_N = mkTerm "ferule_N" ;
lin fervency_N = mkTerm "fervency_N" ;
lin fervent_A = mkTerm "fervent_A" ;
lin fervid_A = mkTerm "fervid_A" ;
lin fervour_N = mkTerm "fervour_N" ;
lin fescue_N = mkTerm "fescue_N" ;
lin fess_up_V = mkTerm "fess_up_V" ;
lin fess_up_V2 = mkTerm "fess_up_V2" ;
lin fess_up_to_V2 = mkTerm "fess_up_to_V2" ;
lin fesse_N = mkTerm "fesse_N" ;
lin festal_A = mkTerm "festal_A" ;
lin fester_N = mkTerm "fester_N" ;
lin fester_V = mkTerm "fester_V" ;
lin festering_N = mkTerm "festering_N" ;
lin festination_N = mkTerm "festination_N" ;
lin festival_N = mkTerm "festival_N" ;
lin festive_A = mkTerm "festive_A" ;
lin festivity_N = mkTerm "festivity_N" ;
lin festoon_N = mkTerm "festoon_N" ;
lin festoon_V2 = mkTerm "festoon_V2" ;
lin festschrift_N = mkTerm "festschrift_N" ;
lin fetal_A = mkTerm "fetal_A" ;
lin fetch_N = mkTerm "fetch_N" ;
lin fetch_V2 = mkTerm "fetch_V2" ;
lin fetching_A = mkTerm "fetching_A" ;
lin fete_N = mkTerm "fete_N" ;
lin fete_V2 = mkTerm "fete_V2" ;
lin fete_day_N = mkTerm "fete_day_N" ;
lin feterita_N = mkTerm "feterita_N" ;
lin fetid_A = mkTerm "fetid_A" ;
lin fetish_N = mkTerm "fetish_N" ;
lin fetishism_N = mkTerm "fetishism_N" ;
lin fetishist_N = mkTerm "fetishist_N" ;
lin fetlock_N = mkTerm "fetlock_N" ;
lin fetology_N = mkTerm "fetology_N" ;
lin fetometry_N = mkTerm "fetometry_N" ;
lin fetoprotein_N = mkTerm "fetoprotein_N" ;
lin fetoscope_N = mkTerm "fetoscope_N" ;
lin fetoscopy_N = mkTerm "fetoscopy_N" ;
lin fetter_N = mkTerm "fetter_N" ;
lin fetter_V2 = mkTerm "fetter_V2" ;
lin fetterbush_N = mkTerm "fetterbush_N" ;
lin fettle_N = mkTerm "fettle_N" ;
lin fettuccine_N = mkTerm "fettuccine_N" ;
lin fetus_N = mkTerm "fetus_N" ;
lin feud_N = mkTerm "feud_N" ;
lin feudal_A = mkTerm "feudal_A" ;
lin feudalism_N = mkTerm "feudalism_N" ;
lin feudatory_A = mkTerm "feudatory_A" ;
lin feudatory_N = mkTerm "feudatory_N" ;
lin feude_V = mkTerm "feude_V" ;
lin fever_N = mkTerm "fever_N" ;
lin fevered_A = mkTerm "fevered_A" ;
lin feverfew_N = mkTerm "feverfew_N" ;
lin feverish_A = mkTerm "feverish_A" ;
lin feverroot_N = mkTerm "feverroot_N" ;
lin few_A = mkTerm "few_A" ;
lin few_N = mkTerm "few_N" ;
lin few_Num = mkTerm "few_Num" ;
lin fewer_A = mkTerm "fewer_A" ;
lin fewer_Det = mkTerm "fewer_Det" ;
lin fewer_than_AdN = mkTerm "fewer_than_AdN" ;
lin fewness_N = mkTerm "fewness_N" ;
lin fey_A = mkTerm "fey_A" ;
lin fez_N = mkTerm "fez_N" ;
lin fiance_N = mkTerm "fiance_N" ;
lin fiancee_N = mkTerm "fiancee_N" ;
lin fiasco_N = mkTerm "fiasco_N" ;
lin fiat_N = mkTerm "fiat_N" ;
lin fib_N = mkTerm "fib_N" ;
lin fib_V = mkTerm "fib_V" ;
lin fibber_N = mkTerm "fibber_N" ;
lin fibbing_N = mkTerm "fibbing_N" ;
lin fiber_N = mkTerm "fiber_N" ;
lin fiberboard_N = mkTerm "fiberboard_N" ;
lin fiberglass_N = mkTerm "fiberglass_N" ;
lin fiberscope_N = mkTerm "fiberscope_N" ;
lin fibre_N = mkTerm "fibre_N" ;
lin fibreboard_N = mkTerm "fibreboard_N" ;
lin fibreglass_N = mkTerm "fibreglass_N" ;
lin fibril_N = mkTerm "fibril_N" ;
lin fibrillation_N = mkTerm "fibrillation_N" ;
lin fibrillose_A = mkTerm "fibrillose_A" ;
lin fibrin_N = mkTerm "fibrin_N" ;
lin fibrinase_N = mkTerm "fibrinase_N" ;
lin fibrinogen_N = mkTerm "fibrinogen_N" ;
lin fibrinolysis_N = mkTerm "fibrinolysis_N" ;
lin fibrinopeptide_N = mkTerm "fibrinopeptide_N" ;
lin fibrinous_A = mkTerm "fibrinous_A" ;
lin fibroadenoma_N = mkTerm "fibroadenoma_N" ;
lin fibroblast_N = mkTerm "fibroblast_N" ;
lin fibrocalcific_A = mkTerm "fibrocalcific_A" ;
lin fibrocartilage_N = mkTerm "fibrocartilage_N" ;
lin fibrocartilaginous_A = mkTerm "fibrocartilaginous_A" ;
lin fibroma_N = mkTerm "fibroma_N" ;
lin fibromyositis_N = mkTerm "fibromyositis_N" ;
lin fibrosis_N = mkTerm "fibrosis_N" ;
lin fibrositis_N = mkTerm "fibrositis_N" ;
lin fibrosity_N = mkTerm "fibrosity_N" ;
lin fibrous_A = mkTerm "fibrous_A" ;
lin fibula_N = mkTerm "fibula_N" ;
lin fichu_N = mkTerm "fichu_N" ;
lin fickle_A = mkTerm "fickle_A" ;
lin fickleness_N = mkTerm "fickleness_N" ;
lin fictile_A = mkTerm "fictile_A" ;
lin fiction_N = mkTerm "fiction_N" ;
lin fictional_A = mkTerm "fictional_A" ;
lin fictionalization_N = mkTerm "fictionalization_N" ;
lin fictitious_A = mkTerm "fictitious_A" ;
lin fictive_A = mkTerm "fictive_A" ;
lin fiddle_N = mkTerm "fiddle_N" ;
lin fiddle_V2 = mkTerm "fiddle_V2" ;
lin fiddle_about_V = mkTerm "fiddle_about_V" ;
lin fiddle_around_V = mkTerm "fiddle_around_V" ;
lin fiddle_away_V2 = mkTerm "fiddle_away_V2" ;
lin fiddleneck_N = mkTerm "fiddleneck_N" ;
lin fiddler_N = mkTerm "fiddler_N" ;
lin fiddlestick_N = mkTerm "fiddlestick_N" ;
lin fidelity_N = mkTerm "fidelity_N" ;
lin fidget_N = mkTerm "fidget_N" ;
lin fidget_V = mkTerm "fidget_V" ;
lin fidget_V2 = mkTerm "fidget_V2" ;
lin fidgety_A = mkTerm "fidgety_A" ;
lin fiducial_A = mkTerm "fiducial_A" ;
lin fiduciary_A = mkTerm "fiduciary_A" ;
lin fiduciary_N = mkTerm "fiduciary_N" ;
lin fief_N = mkTerm "fief_N" ;
lin fiefdom_N = mkTerm "fiefdom_N" ;
lin field_1_N = mkTerm "field_1_N" ;
lin field_2_N = mkTerm "field_2_N" ;
lin field_3_N = mkTerm "field_3_N" ;
lin field_4_N = mkTerm "field_4_N" ;
lin field_V = mkTerm "field_V" ;
lin field_V2 = mkTerm "field_V2" ;
lin field_hospital_N = mkTerm "field_hospital_N" ;
lin field_officer_N = mkTerm "field_officer_N" ;
lin fielder_N = mkTerm "fielder_N" ;
lin fieldfare_N = mkTerm "fieldfare_N" ;
lin fielding_N = mkTerm "fielding_N" ;
lin fieldsman_N = mkTerm "fieldsman_N" ;
lin fieldstone_N = mkTerm "fieldstone_N" ;
lin fieldwork_N = mkTerm "fieldwork_N" ;
lin fieldworker_N = mkTerm "fieldworker_N" ;
lin fiend_N = mkTerm "fiend_N" ;
lin fiendish_A = mkTerm "fiendish_A" ;
lin fierce_A = mkTerm "fierce_A" ;
lin fierceness_N = mkTerm "fierceness_N" ;
lin fieriness_N = mkTerm "fieriness_N" ;
lin fiery_A = mkTerm "fiery_A" ;
lin fiesta_N = mkTerm "fiesta_N" ;
lin fife_N = mkTerm "fife_N" ;
lin fife_PN = mkTerm "fife_PN" ;
lin fig_N = mkTerm "fig_N" ;
lin fig_leaf_N = mkTerm "fig_leaf_N" ;
lin fight_N = mkTerm "fight_N" ;
lin fight_V = mkTerm "fight_V" ;
lin fight_V2 = mkTerm "fight_V2" ;
lin fight_back_V = mkTerm "fight_back_V" ;
lin fight_back_V2 = mkTerm "fight_back_V2" ;
lin fight_it_out_V2 = mkTerm "fight_it_out_V2" ;
lin fight_off_V2 = mkTerm "fight_off_V2" ;
lin fighter_N = mkTerm "fighter_N" ;
lin fighting_N = mkTerm "fighting_N" ;
lin figment_N = mkTerm "figment_N" ;
lin figural_A = mkTerm "figural_A" ;
lin figuration_N = mkTerm "figuration_N" ;
lin figurative_A = mkTerm "figurative_A" ;
lin figure_1_N = mkTerm "figure_1_N" ;
lin figure_2_N = mkTerm "figure_2_N" ;
lin figure_V = mkTerm "figure_V" ;
lin figure_VS = mkTerm "figure_VS" ;
lin figure_on_V2 = mkTerm "figure_on_V2" ;
lin figure_out_V2 = mkTerm "figure_out_V2" ;
lin figure_up_V2 = mkTerm "figure_up_V2" ;
lin figurehead_N = mkTerm "figurehead_N" ;
lin figurine_N = mkTerm "figurine_N" ;
lin figwort_N = mkTerm "figwort_N" ;
lin fiji_PN = mkTerm "fiji_PN" ;
lin fijian_A = mkTerm "fijian_A" ;
lin fijian_N = mkTerm "fijian_N" ;
lin filaggrin_N = mkTerm "filaggrin_N" ;
lin filament_N = mkTerm "filament_N" ;
lin filamentous_A = mkTerm "filamentous_A" ;
lin filar_A = mkTerm "filar_A" ;
lin filaria_N = mkTerm "filaria_N" ;
lin filarial_A = mkTerm "filarial_A" ;
lin filariasis_N = mkTerm "filariasis_N" ;
lin filariid_A = mkTerm "filariid_A" ;
lin filature_N = mkTerm "filature_N" ;
lin filbert_N = mkTerm "filbert_N" ;
lin filch_V2 = mkTerm "filch_V2" ;
lin file_N = mkTerm "file_N" ;
lin file_V = mkTerm "file_V" ;
lin file_V2 = mkTerm "file_V2" ;
lin file_away_V2 = mkTerm "file_away_V2" ;
lin file_for_V2 = mkTerm "file_for_V2" ;
lin filefish_N = mkTerm "filefish_N" ;
lin filename_N = mkTerm "filename_N" ;
lin filer_N = mkTerm "filer_N" ;
lin filet_N = mkTerm "filet_N" ;
lin filial_A = mkTerm "filial_A" ;
lin filibuster_N = mkTerm "filibuster_N" ;
lin filibuster_V = mkTerm "filibuster_V" ;
lin filicide_N = mkTerm "filicide_N" ;
lin filigree_N = mkTerm "filigree_N" ;
lin filing_N = mkTerm "filing_N" ;
lin filipino_A = mkTerm "filipino_A" ;
lin filipino_N = mkTerm "filipino_N" ;
lin fill_N = mkTerm "fill_N" ;
lin fill_V = mkTerm "fill_V" ;
lin fill_V2 = mkTerm "fill_V2" ;
lin fill_in_V = mkTerm "fill_in_V" ;
lin fill_in_V2 = mkTerm "fill_in_V2" ;
lin fill_in_for_V2 = mkTerm "fill_in_for_V2" ;
lin fill_in_on_V3 = mkTerm "fill_in_on_V3" ;
lin fill_out_V = mkTerm "fill_out_V" ;
lin fill_out_V2 = mkTerm "fill_out_V2" ;
lin fill_up_V2 = mkTerm "fill_up_V2" ;
lin filler_N = mkTerm "filler_N" ;
lin fillet_N = mkTerm "fillet_N" ;
lin fillet_V2 = mkTerm "fillet_V2" ;
lin filling_N = mkTerm "filling_N" ;
lin fillip_N = mkTerm "fillip_N" ;
lin filly_N = mkTerm "filly_N" ;
lin film_1_N = mkTerm "film_1_N" ;
lin film_2_N = mkTerm "film_2_N" ;
lin film_V = mkTerm "film_V" ;
lin film_V2 = mkTerm "film_V2" ;
lin film_star_N = mkTerm "film_star_N" ;
lin filmable_A = mkTerm "filmable_A" ;
lin filmdom_N = mkTerm "filmdom_N" ;
lin filming_N = mkTerm "filming_N" ;
lin filmmaker_N = mkTerm "filmmaker_N" ;
lin filmmaking_N = mkTerm "filmmaking_N" ;
lin filmography_N = mkTerm "filmography_N" ;
lin filmy_A = mkTerm "filmy_A" ;
lin filovirus_N = mkTerm "filovirus_N" ;
lin fils_N = mkTerm "fils_N" ;
lin filter_N = mkTerm "filter_N" ;
lin filter_V = mkTerm "filter_V" ;
lin filter_V2 = mkTerm "filter_V2" ;
lin filter_in_V = mkTerm "filter_in_V" ;
lin filter_out_V2 = mkTerm "filter_out_V2" ;
lin filtertipped_A = mkTerm "filtertipped_A" ;
lin filth_N = mkTerm "filth_N" ;
lin filthiness_N = mkTerm "filthiness_N" ;
lin filthy_A = mkTerm "filthy_A" ;
lin filtrate_N = mkTerm "filtrate_N" ;
lin filtrate_V = mkTerm "filtrate_V" ;
lin filtrate_V2 = mkTerm "filtrate_V2" ;
lin filtration_N = mkTerm "filtration_N" ;
lin fimbria_N = mkTerm "fimbria_N" ;
lin fimbriate_A = mkTerm "fimbriate_A" ;
lin fin_N = mkTerm "fin_N" ;
lin finable_A = mkTerm "finable_A" ;
lin finagle_V2 = mkTerm "finagle_V2" ;
lin finagler_N = mkTerm "finagler_N" ;
lin final_A = mkTerm "final_A" ;
lin final_N = mkTerm "final_N" ;
lin finale_N = mkTerm "finale_N" ;
lin finalist_N = mkTerm "finalist_N" ;
lin finality_N = mkTerm "finality_N" ;
lin finalization_N = mkTerm "finalization_N" ;
lin finalize_V2 = mkTerm "finalize_V2" ;
lin finally_Adv = mkTerm "finally_Adv" ;
lin finance_N = mkTerm "finance_N" ;
lin finance_V2 = mkTerm "finance_V2" ;
lin financial_A = mkTerm "financial_A" ;
lin financier_N = mkTerm "financier_N" ;
lin financing_N = mkTerm "financing_N" ;
lin finback_N = mkTerm "finback_N" ;
lin finch_N = mkTerm "finch_N" ;
lin find_N = mkTerm "find_N" ;
lin find_V = mkTerm "find_V" ;
lin find_V2 = mkTerm "find_V2" ;
lin find_V2A = mkTerm "find_V2A" ;
lin find_VS = mkTerm "find_VS" ;
lin find_out_V = mkTerm "find_out_V" ;
lin find_out_V2 = mkTerm "find_out_V2" ;
lin finder_N = mkTerm "finder_N" ;
lin finding_N = mkTerm "finding_N" ;
lin findings_N = mkTerm "findings_N" ;
lin fine_A = mkTerm "fine_A" ;
lin fine_Adv = mkTerm "fine_Adv" ;
lin fine_N = mkTerm "fine_N" ;
lin fine_V2 = mkTerm "fine_V2" ;
lin fine_tooth_A = mkTerm "fine_tooth_A" ;
lin fineable_A = mkTerm "fineable_A" ;
lin fineness_N = mkTerm "fineness_N" ;
lin finer_A = mkTerm "finer_A" ;
lin finery_N = mkTerm "finery_N" ;
lin finespun_A = mkTerm "finespun_A" ;
lin finesse_N = mkTerm "finesse_N" ;
lin finesse_V2 = mkTerm "finesse_V2" ;
lin finger_N = mkTerm "finger_N" ;
lin finger_V2 = mkTerm "finger_V2" ;
lin finger_alphabet_N = mkTerm "finger_alphabet_N" ;
lin finger_bowl_N = mkTerm "finger_bowl_N" ;
lin finger_plate_N = mkTerm "finger_plate_N" ;
lin finger_post_N = mkTerm "finger_post_N" ;
lin fingerboard_N = mkTerm "fingerboard_N" ;
lin fingering_N = mkTerm "fingering_N" ;
lin fingerless_A = mkTerm "fingerless_A" ;
lin fingerling_N = mkTerm "fingerling_N" ;
lin fingermark_N = mkTerm "fingermark_N" ;
lin fingernail_N = mkTerm "fingernail_N" ;
lin fingerprint_N = mkTerm "fingerprint_N" ;
lin fingerprinting_N = mkTerm "fingerprinting_N" ;
lin fingerstall_N = mkTerm "fingerstall_N" ;
lin fingertip_N = mkTerm "fingertip_N" ;
lin finial_N = mkTerm "finial_N" ;
lin finical_A = mkTerm "finical_A" ;
lin finicky_A = mkTerm "finicky_A" ;
lin finis_N = mkTerm "finis_N" ;
lin finish_N = mkTerm "finish_N" ;
lin finish_V = mkTerm "finish_V" ;
lin finish_V2 = mkTerm "finish_V2" ;
lin finish_off_V2 = mkTerm "finish_off_V2" ;
lin finish_up_V = mkTerm "finish_up_V" ;
lin finish_up_with_V2 = mkTerm "finish_up_with_V2" ;
lin finish_with_V2 = mkTerm "finish_with_V2" ;
lin finished_A = mkTerm "finished_A" ;
lin finisher_N = mkTerm "finisher_N" ;
lin finite_A = mkTerm "finite_A" ;
lin finiteness_N = mkTerm "finiteness_N" ;
lin fink_N = mkTerm "fink_N" ;
lin fink_on_V2 = mkTerm "fink_on_V2" ;
lin fink_out_V = mkTerm "fink_out_V" ;
lin finland_PN = mkTerm "finland_PN" ;
lin finnan_N = mkTerm "finnan_N" ;
lin finnan_haddie_N = mkTerm "finnan_haddie_N" ;
lin finnan_haddock_N = mkTerm "finnan_haddock_N" ;
lin finnishFem_N = mkTerm "finnishFem_N" ;
lin finnishMasc_N = mkTerm "finnishMasc_N" ;
lin finnish_A = mkTerm "finnish_A" ;
lin fiona_PN = mkTerm "fiona_PN" ;
lin fiord_N = mkTerm "fiord_N" ;
lin fipple_N = mkTerm "fipple_N" ;
lin fir_N = mkTerm "fir_N" ;
lin fir_cone_N = mkTerm "fir_cone_N" ;
lin fire_1_N = mkTerm "fire_1_N" ;
lin fire_2_N = mkTerm "fire_2_N" ;
lin fire_V = mkTerm "fire_V" ;
lin fire_V2 = mkTerm "fire_V2" ;
lin fire_alarm_N = mkTerm "fire_alarm_N" ;
lin fire_away_V = mkTerm "fire_away_V" ;
lin fire_back_V = mkTerm "fire_back_V" ;
lin fire_brigade_N = mkTerm "fire_brigade_N" ;
lin fire_control_N = mkTerm "fire_control_N" ;
lin fire_eater_N = mkTerm "fire_eater_N" ;
lin fire_engine_N = mkTerm "fire_engine_N" ;
lin fire_escape_N = mkTerm "fire_escape_N" ;
lin fire_extinguisher_N = mkTerm "fire_extinguisher_N" ;
lin fire_fighter_N = mkTerm "fire_fighter_N" ;
lin fire_hose_N = mkTerm "fire_hose_N" ;
lin fire_off_V2 = mkTerm "fire_off_V2" ;
lin fire_power_N = mkTerm "fire_power_N" ;
lin fire_raising_N = mkTerm "fire_raising_N" ;
lin fire_up_V = mkTerm "fire_up_V" ;
lin fire_up_V2 = mkTerm "fire_up_V2" ;
lin fire_walker_N = mkTerm "fire_walker_N" ;
lin fire_walking_N = mkTerm "fire_walking_N" ;
lin fire_watcher_N = mkTerm "fire_watcher_N" ;
lin fire_watching_N = mkTerm "fire_watching_N" ;
lin firearm_N = mkTerm "firearm_N" ;
lin fireball_N = mkTerm "fireball_N" ;
lin firebase_N = mkTerm "firebase_N" ;
lin firebird_N = mkTerm "firebird_N" ;
lin fireboat_N = mkTerm "fireboat_N" ;
lin firebomb_N = mkTerm "firebomb_N" ;
lin firebox_N = mkTerm "firebox_N" ;
lin firebrand_N = mkTerm "firebrand_N" ;
lin firebrat_N = mkTerm "firebrat_N" ;
lin firebreak_N = mkTerm "firebreak_N" ;
lin firebrick_N = mkTerm "firebrick_N" ;
lin firebug_N = mkTerm "firebug_N" ;
lin fireclay_N = mkTerm "fireclay_N" ;
lin firecracker_N = mkTerm "firecracker_N" ;
lin firedamp_N = mkTerm "firedamp_N" ;
lin firedog_N = mkTerm "firedog_N" ;
lin firefly_N = mkTerm "firefly_N" ;
lin fireguard_N = mkTerm "fireguard_N" ;
lin firelight_N = mkTerm "firelight_N" ;
lin firelighter_N = mkTerm "firelighter_N" ;
lin fireman_N = mkTerm "fireman_N" ;
lin firenze_PN = mkTerm "firenze_PN" ;
lin fireplace_N = mkTerm "fireplace_N" ;
lin fireplug_N = mkTerm "fireplug_N" ;
lin fireproof_A = mkTerm "fireproof_A" ;
lin fireside_N = mkTerm "fireside_N" ;
lin firestone_N = mkTerm "firestone_N" ;
lin firestorm_N = mkTerm "firestorm_N" ;
lin firetrap_N = mkTerm "firetrap_N" ;
lin firewall_N = mkTerm "firewall_N" ;
lin firewater_N = mkTerm "firewater_N" ;
lin fireweed_N = mkTerm "fireweed_N" ;
lin firewood_N = mkTerm "firewood_N" ;
lin firework_N = mkTerm "firework_N" ;
lin fireworks_N = mkTerm "fireworks_N" ;
lin firing_N = mkTerm "firing_N" ;
lin firing_line_N = mkTerm "firing_line_N" ;
lin firing_party_N = mkTerm "firing_party_N" ;
lin firing_squad_N = mkTerm "firing_squad_N" ;
lin firkin_N = mkTerm "firkin_N" ;
lin firm_A = mkTerm "firm_A" ;
lin firm_Adv = mkTerm "firm_Adv" ;
lin firm_N = mkTerm "firm_N" ;
lin firm_V = mkTerm "firm_V" ;
lin firm_V2 = mkTerm "firm_V2" ;
lin firm_up_V2 = mkTerm "firm_up_V2" ;
lin firmament_N = mkTerm "firmament_N" ;
lin firmamental_A = mkTerm "firmamental_A" ;
lin firmness_N = mkTerm "firmness_N" ;
lin firmware_N = mkTerm "firmware_N" ;
lin first_Adv = mkTerm "first_Adv" ;
lin first_class_A = mkTerm "first_class_A" ;
lin first_class_Adv = mkTerm "first_class_Adv" ;
lin first_hand_A = mkTerm "first_hand_A" ;
lin first_nighter_N = mkTerm "first_nighter_N" ;
lin first_rate_A = mkTerm "first_rate_A" ;
lin firstborn_A = mkTerm "firstborn_A" ;
lin firstborn_N = mkTerm "firstborn_N" ;
lin firstly_Adv = mkTerm "firstly_Adv" ;
lin firth_N = mkTerm "firth_N" ;
lin fisc_N = mkTerm "fisc_N" ;
lin fiscal_A = mkTerm "fiscal_A" ;
lin fish_N = mkTerm "fish_N" ;
lin fish_V = mkTerm "fish_V" ;
lin fish_V2 = mkTerm "fish_V2" ;
lin fish_for_V2 = mkTerm "fish_for_V2" ;
lin fish_hook_N = mkTerm "fish_hook_N" ;
lin fish_knife_N = mkTerm "fish_knife_N" ;
lin fish_out_V2 = mkTerm "fish_out_V2" ;
lin fish_slice_N = mkTerm "fish_slice_N" ;
lin fishball_N = mkTerm "fishball_N" ;
lin fishbone_N = mkTerm "fishbone_N" ;
lin fishbowl_N = mkTerm "fishbowl_N" ;
lin fishcake_N = mkTerm "fishcake_N" ;
lin fisher_N = mkTerm "fisher_N" ;
lin fisherman_N = mkTerm "fisherman_N" ;
lin fishery_N = mkTerm "fishery_N" ;
lin fisheye_A = mkTerm "fisheye_A" ;
lin fishing_N = mkTerm "fishing_N" ;
lin fishing_line_N = mkTerm "fishing_line_N" ;
lin fishing_rod_N = mkTerm "fishing_rod_N" ;
lin fishing_tackle_N = mkTerm "fishing_tackle_N" ;
lin fishmonger_N = mkTerm "fishmonger_N" ;
lin fishnet_N = mkTerm "fishnet_N" ;
lin fishpaste_N = mkTerm "fishpaste_N" ;
lin fishplate_N = mkTerm "fishplate_N" ;
lin fishpond_N = mkTerm "fishpond_N" ;
lin fishwife_N = mkTerm "fishwife_N" ;
lin fishy_A = mkTerm "fishy_A" ;
lin fissile_A = mkTerm "fissile_A" ;
lin fission_N = mkTerm "fission_N" ;
lin fissionable_A = mkTerm "fissionable_A" ;
lin fissiparity_N = mkTerm "fissiparity_N" ;
lin fissiparous_A = mkTerm "fissiparous_A" ;
lin fissure_N = mkTerm "fissure_N" ;
lin fist_N = mkTerm "fist_N" ;
lin fistfight_N = mkTerm "fistfight_N" ;
lin fistmele_N = mkTerm "fistmele_N" ;
lin fistula_N = mkTerm "fistula_N" ;
lin fistular_A = mkTerm "fistular_A" ;
lin fistulous_A = mkTerm "fistulous_A" ;
lin fit_A = mkTerm "fit_A" ;
lin fit_N = mkTerm "fit_N" ;
lin fit_V = mkTerm "fit_V" ;
lin fit_V2 = mkTerm "fit_V2" ;
lin fit_in_V = mkTerm "fit_in_V" ;
lin fit_in_V2 = mkTerm "fit_in_V2" ;
lin fit_in_with_V2 = mkTerm "fit_in_with_V2" ;
lin fit_into_V2 = mkTerm "fit_into_V2" ;
lin fit_out_V2 = mkTerm "fit_out_V2" ;
lin fit_out_with_V2 = mkTerm "fit_out_with_V2" ;
lin fit_up_V2 = mkTerm "fit_up_V2" ;
lin fitful_A = mkTerm "fitful_A" ;
lin fitfulness_N = mkTerm "fitfulness_N" ;
lin fitment_N = mkTerm "fitment_N" ;
lin fitness_N = mkTerm "fitness_N" ;
lin fitter_A = mkTerm "fitter_A" ;
lin fitter_N = mkTerm "fitter_N" ;
lin fitting_A = mkTerm "fitting_A" ;
lin fitting_N = mkTerm "fitting_N" ;
lin fivefold_A = mkTerm "fivefold_A" ;
lin fivepence_N = mkTerm "fivepence_N" ;
lin fivepenny_A = mkTerm "fivepenny_A" ;
lin fiver_N = mkTerm "fiver_N" ;
lin fives_N = mkTerm "fives_N" ;
lin fix_N = mkTerm "fix_N" ;
lin fix_V = mkTerm "fix_V" ;
lin fix_V2 = mkTerm "fix_V2" ;
lin fix_up_V2 = mkTerm "fix_up_V2" ;
lin fixate_V2 = mkTerm "fixate_V2" ;
lin fixation_N = mkTerm "fixation_N" ;
lin fixative_N = mkTerm "fixative_N" ;
lin fixed_A = mkTerm "fixed_A" ;
lin fixedness_N = mkTerm "fixedness_N" ;
lin fixer_N = mkTerm "fixer_N" ;
lin fixings_N = mkTerm "fixings_N" ;
lin fixture_N = mkTerm "fixture_N" ;
lin fizgig_N = mkTerm "fizgig_N" ;
lin fizz_N = mkTerm "fizz_N" ;
lin fizz_V = mkTerm "fizz_V" ;
lin fizzle_V = mkTerm "fizzle_V" ;
lin fizzle_out_V = mkTerm "fizzle_out_V" ;
lin fizzy_A = mkTerm "fizzy_A" ;
lin fjord_N = mkTerm "fjord_N" ;
lin flab_N = mkTerm "flab_N" ;
lin flabbergast_V2 = mkTerm "flabbergast_V2" ;
lin flabbiness_N = mkTerm "flabbiness_N" ;
lin flabby_A = mkTerm "flabby_A" ;
lin flaccid_A = mkTerm "flaccid_A" ;
lin flaccidity_N = mkTerm "flaccidity_N" ;
lin flag_N = mkTerm "flag_N" ;
lin flag_V = mkTerm "flag_V" ;
lin flag_V2 = mkTerm "flag_V2" ;
lin flag_captain_N = mkTerm "flag_captain_N" ;
lin flag_day_N = mkTerm "flag_day_N" ;
lin flag_down_V2 = mkTerm "flag_down_V2" ;
lin flag_up_V2 = mkTerm "flag_up_V2" ;
lin flagellant_N = mkTerm "flagellant_N" ;
lin flagellate_A = mkTerm "flagellate_A" ;
lin flagellate_N = mkTerm "flagellate_N" ;
lin flagellate_V2 = mkTerm "flagellate_V2" ;
lin flagellation_N = mkTerm "flagellation_N" ;
lin flagellum_N = mkTerm "flagellum_N" ;
lin flageolet_N = mkTerm "flageolet_N" ;
lin flagfish_N = mkTerm "flagfish_N" ;
lin flagging_N = mkTerm "flagging_N" ;
lin flagitious_A = mkTerm "flagitious_A" ;
lin flagon_N = mkTerm "flagon_N" ;
lin flagpole_N = mkTerm "flagpole_N" ;
lin flagrant_A = mkTerm "flagrant_A" ;
lin flagship_N = mkTerm "flagship_N" ;
lin flagstaff_N = mkTerm "flagstaff_N" ;
lin flagstone_N = mkTerm "flagstone_N" ;
lin flail_N = mkTerm "flail_N" ;
lin flail_V2 = mkTerm "flail_V2" ;
lin flair_N = mkTerm "flair_N" ;
lin flak_N = mkTerm "flak_N" ;
lin flake_N = mkTerm "flake_N" ;
lin flake_V = mkTerm "flake_V" ;
lin flake_out_V = mkTerm "flake_out_V" ;
lin flakiness_N = mkTerm "flakiness_N" ;
lin flaky_A = mkTerm "flaky_A" ;
lin flambeau_N = mkTerm "flambeau_N" ;
lin flamboyance_N = mkTerm "flamboyance_N" ;
lin flamboyant_A = mkTerm "flamboyant_A" ;
lin flame_N = mkTerm "flame_N" ;
lin flame_V = mkTerm "flame_V" ;
lin flame_out_V = mkTerm "flame_out_V" ;
lin flame_up_V = mkTerm "flame_up_V" ;
lin flamen_N = mkTerm "flamen_N" ;
lin flamenco_N = mkTerm "flamenco_N" ;
lin flameproof_A = mkTerm "flameproof_A" ;
lin flamethrower_N = mkTerm "flamethrower_N" ;
lin flamingo_N = mkTerm "flamingo_N" ;
lin flammability_N = mkTerm "flammability_N" ;
lin flammable_A = mkTerm "flammable_A" ;
lin flan_N = mkTerm "flan_N" ;
lin flange_N = mkTerm "flange_N" ;
lin flank_N = mkTerm "flank_N" ;
lin flank_V = mkTerm "flank_V" ;
lin flank_V2 = mkTerm "flank_V2" ;
lin flanker_N = mkTerm "flanker_N" ;
lin flannel_N = mkTerm "flannel_N" ;
lin flannelbush_N = mkTerm "flannelbush_N" ;
lin flannelette_N = mkTerm "flannelette_N" ;
lin flap_N = mkTerm "flap_N" ;
lin flap_V = mkTerm "flap_V" ;
lin flap_V2 = mkTerm "flap_V2" ;
lin flapjack_N = mkTerm "flapjack_N" ;
lin flapper_N = mkTerm "flapper_N" ;
lin flare_N = mkTerm "flare_N" ;
lin flare_V = mkTerm "flare_V" ;
lin flare_V2 = mkTerm "flare_V2" ;
lin flare_out_V = mkTerm "flare_out_V" ;
lin flare_path_N = mkTerm "flare_path_N" ;
lin flare_up_N = mkTerm "flare_up_N" ;
lin flare_up_V = mkTerm "flare_up_V" ;
lin flash_N = mkTerm "flash_N" ;
lin flash_V = mkTerm "flash_V" ;
lin flashback_N = mkTerm "flashback_N" ;
lin flashboard_N = mkTerm "flashboard_N" ;
lin flashbulb_N = mkTerm "flashbulb_N" ;
lin flasher_N = mkTerm "flasher_N" ;
lin flashgun_N = mkTerm "flashgun_N" ;
lin flashiness_N = mkTerm "flashiness_N" ;
lin flashing_N = mkTerm "flashing_N" ;
lin flashlight_N = mkTerm "flashlight_N" ;
lin flashover_N = mkTerm "flashover_N" ;
lin flashpoint_N = mkTerm "flashpoint_N" ;
lin flashy_A = mkTerm "flashy_A" ;
lin flask_N = mkTerm "flask_N" ;
lin flat_A = mkTerm "flat_A" ;
lin flat_Adv = mkTerm "flat_Adv" ;
lin flat_N = mkTerm "flat_N" ;
lin flat_bottomed_A = mkTerm "flat_bottomed_A" ;
lin flat_car_N = mkTerm "flat_car_N" ;
lin flat_footed_A = mkTerm "flat_footed_A" ;
lin flat_iron_N = mkTerm "flat_iron_N" ;
lin flatbed_N = mkTerm "flatbed_N" ;
lin flatbottom_A = mkTerm "flatbottom_A" ;
lin flatbread_N = mkTerm "flatbread_N" ;
lin flatbrod_N = mkTerm "flatbrod_N" ;
lin flatfish_N = mkTerm "flatfish_N" ;
lin flatfoot_N = mkTerm "flatfoot_N" ;
lin flathead_N = mkTerm "flathead_N" ;
lin flatlet_N = mkTerm "flatlet_N" ;
lin flatmate_N = mkTerm "flatmate_N" ;
lin flatness_N = mkTerm "flatness_N" ;
lin flats_N = mkTerm "flats_N" ;
lin flatten_V = mkTerm "flatten_V" ;
lin flatten_V2 = mkTerm "flatten_V2" ;
lin flatter_V2 = mkTerm "flatter_V2" ;
lin flatterer_N = mkTerm "flatterer_N" ;
lin flattering_A = mkTerm "flattering_A" ;
lin flattery_N = mkTerm "flattery_N" ;
lin flattop_N = mkTerm "flattop_N" ;
lin flatulence_N = mkTerm "flatulence_N" ;
lin flatulent_A = mkTerm "flatulent_A" ;
lin flatware_N = mkTerm "flatware_N" ;
lin flatwork_N = mkTerm "flatwork_N" ;
lin flatworm_N = mkTerm "flatworm_N" ;
lin flaunt_N = mkTerm "flaunt_N" ;
lin flaunt_V = mkTerm "flaunt_V" ;
lin flaunt_V2 = mkTerm "flaunt_V2" ;
lin flaunty_A = mkTerm "flaunty_A" ;
lin flautist_N = mkTerm "flautist_N" ;
lin flavin_N = mkTerm "flavin_N" ;
lin flavivirus_N = mkTerm "flavivirus_N" ;
lin flavone_N = mkTerm "flavone_N" ;
lin flavonoid_N = mkTerm "flavonoid_N" ;
lin flavorful_A = mkTerm "flavorful_A" ;
lin flavorlessness_N = mkTerm "flavorlessness_N" ;
lin flavorsomeness_N = mkTerm "flavorsomeness_N" ;
lin flavour_N = mkTerm "flavour_N" ;
lin flavour_V2 = mkTerm "flavour_V2" ;
lin flavourer_N = mkTerm "flavourer_N" ;
lin flavouring_N = mkTerm "flavouring_N" ;
lin flavourless_A = mkTerm "flavourless_A" ;
lin flaw_N = mkTerm "flaw_N" ;
lin flaw_V2 = mkTerm "flaw_V2" ;
lin flawless_A = mkTerm "flawless_A" ;
lin flax_N = mkTerm "flax_N" ;
lin flaxen_A = mkTerm "flaxen_A" ;
lin flay_V2 = mkTerm "flay_V2" ;
lin flea_N = mkTerm "flea_N" ;
lin flea_bite_N = mkTerm "flea_bite_N" ;
lin flea_bitten_A = mkTerm "flea_bitten_A" ;
lin fleabag_N = mkTerm "fleabag_N" ;
lin fleabane_N = mkTerm "fleabane_N" ;
lin fleapit_N = mkTerm "fleapit_N" ;
lin fleawort_N = mkTerm "fleawort_N" ;
lin flecainide_N = mkTerm "flecainide_N" ;
lin fleck_N = mkTerm "fleck_N" ;
lin fleck_V2 = mkTerm "fleck_V2" ;
lin fledged_A = mkTerm "fledged_A" ;
lin fledgeling_N = mkTerm "fledgeling_N" ;
lin fledgling_A = mkTerm "fledgling_A" ;
lin fledgling_N = mkTerm "fledgling_N" ;
lin flee_V = mkTerm "flee_V" ;
lin flee_V2 = mkTerm "flee_V2" ;
lin fleece_N = mkTerm "fleece_N" ;
lin fleece_V2 = mkTerm "fleece_V2" ;
lin fleeceable_A = mkTerm "fleeceable_A" ;
lin fleecy_A = mkTerm "fleecy_A" ;
lin fleer_N = mkTerm "fleer_N" ;
lin fleet_A = mkTerm "fleet_A" ;
lin fleet_N = mkTerm "fleet_N" ;
lin fleet_PN = mkTerm "fleet_PN" ;
lin fleet_street_PN = mkTerm "fleet_street_PN" ;
lin fleeting_A = mkTerm "fleeting_A" ;
lin fleetness_N = mkTerm "fleetness_N" ;
lin fleetwood_PN = mkTerm "fleetwood_PN" ;
lin flemish_A = mkTerm "flemish_A" ;
lin flemish_N = mkTerm "flemish_N" ;
lin flesh_N = mkTerm "flesh_N" ;
lin flesh_out_V2 = mkTerm "flesh_out_V2" ;
lin flesh_wound_N = mkTerm "flesh_wound_N" ;
lin fleshiness_N = mkTerm "fleshiness_N" ;
lin fleshly_A = mkTerm "fleshly_A" ;
lin fleshy_A = mkTerm "fleshy_A" ;
lin fleur_de_lis_N = mkTerm "fleur_de_lis_N" ;
lin flex_N = mkTerm "flex_N" ;
lin flex_V2 = mkTerm "flex_V2" ;
lin flexibility_N = mkTerm "flexibility_N" ;
lin flexible_A = mkTerm "flexible_A" ;
lin flexion_N = mkTerm "flexion_N" ;
lin flexuous_A = mkTerm "flexuous_A" ;
lin flexure_N = mkTerm "flexure_N" ;
lin flibbertigibbet_N = mkTerm "flibbertigibbet_N" ;
lin flick_N = mkTerm "flick_N" ;
lin flick_V2 = mkTerm "flick_V2" ;
lin flick_knife_N = mkTerm "flick_knife_N" ;
lin flick_over_V = mkTerm "flick_over_V" ;
lin flick_through_V2 = mkTerm "flick_through_V2" ;
lin flicker_N = mkTerm "flicker_N" ;
lin flicker_V = mkTerm "flicker_V" ;
lin flickertail_N = mkTerm "flickertail_N" ;
lin flier_N = mkTerm "flier_N" ;
lin flies_N = mkTerm "flies_N" ;
lin flight_N = mkTerm "flight_N" ;
lin flight_V2 = mkTerm "flight_V2" ;
lin flightiness_N = mkTerm "flightiness_N" ;
lin flightless_A = mkTerm "flightless_A" ;
lin flighty_A = mkTerm "flighty_A" ;
lin flimsiness_N = mkTerm "flimsiness_N" ;
lin flimsy_A = mkTerm "flimsy_A" ;
lin flimsy_N = mkTerm "flimsy_N" ;
lin flinch_V = mkTerm "flinch_V" ;
lin flinders_N = mkTerm "flinders_N" ;
lin fling_N = mkTerm "fling_N" ;
lin fling_V = mkTerm "fling_V" ;
lin fling_V2 = mkTerm "fling_V2" ;
lin flint_N = mkTerm "flint_N" ;
lin flint_PN = mkTerm "flint_PN" ;
lin flintlock_N = mkTerm "flintlock_N" ;
lin flintstone_N = mkTerm "flintstone_N" ;
lin flinty_A = mkTerm "flinty_A" ;
lin flip_A = mkTerm "flip_A" ;
lin flip_N = mkTerm "flip_N" ;
lin flip_V = mkTerm "flip_V" ;
lin flip_V2 = mkTerm "flip_V2" ;
lin flip_off_V2 = mkTerm "flip_off_V2" ;
lin flip_out_V = mkTerm "flip_out_V" ;
lin flip_through_V2 = mkTerm "flip_through_V2" ;
lin flippancy_N = mkTerm "flippancy_N" ;
lin flippant_A = mkTerm "flippant_A" ;
lin flipper_N = mkTerm "flipper_N" ;
lin flirt_N = mkTerm "flirt_N" ;
lin flirt_V = mkTerm "flirt_V" ;
lin flirtation_N = mkTerm "flirtation_N" ;
lin flirtatious_A = mkTerm "flirtatious_A" ;
lin flit_N = mkTerm "flit_N" ;
lin flit_V = mkTerm "flit_V" ;
lin flitch_N = mkTerm "flitch_N" ;
lin float_N = mkTerm "float_N" ;
lin float_V = mkTerm "float_V" ;
lin floatation_N = mkTerm "floatation_N" ;
lin floater_N = mkTerm "floater_N" ;
lin floating_N = mkTerm "floating_N" ;
lin floatplane_N = mkTerm "floatplane_N" ;
lin floccose_A = mkTerm "floccose_A" ;
lin flocculation_N = mkTerm "flocculation_N" ;
lin floccule_N = mkTerm "floccule_N" ;
lin flocculent_A = mkTerm "flocculent_A" ;
lin flock_N = mkTerm "flock_N" ;
lin flock_V = mkTerm "flock_V" ;
lin flock_V2V = mkTerm "flock_V2V" ;
lin floe_N = mkTerm "floe_N" ;
lin flog_V2 = mkTerm "flog_V2" ;
lin flog_off_V2 = mkTerm "flog_off_V2" ;
lin flogger_N = mkTerm "flogger_N" ;
lin flogging_N = mkTerm "flogging_N" ;
lin flood_N = mkTerm "flood_N" ;
lin flood_V = mkTerm "flood_V" ;
lin flood_V2 = mkTerm "flood_V2" ;
lin flood_tide_N = mkTerm "flood_tide_N" ;
lin floodgate_N = mkTerm "floodgate_N" ;
lin floodhead_N = mkTerm "floodhead_N" ;
lin flooding_N = mkTerm "flooding_N" ;
lin floodlight_V2 = mkTerm "floodlight_V2" ;
lin floodlit_A = mkTerm "floodlit_A" ;
lin floodplain_N = mkTerm "floodplain_N" ;
lin floor_N = mkTerm "floor_N" ;
lin floor_V2 = mkTerm "floor_V2" ;
lin floor_it_V = mkTerm "floor_it_V" ;
lin floor_walker_N = mkTerm "floor_walker_N" ;
lin floorboard_N = mkTerm "floorboard_N" ;
lin flooring_N = mkTerm "flooring_N" ;
lin floozie_N = mkTerm "floozie_N" ;
lin floozy_N = mkTerm "floozy_N" ;
lin flop_Adv = mkTerm "flop_Adv" ;
lin flop_N = mkTerm "flop_N" ;
lin flop_V = mkTerm "flop_V" ;
lin flop_V2 = mkTerm "flop_V2" ;
lin flophouse_N = mkTerm "flophouse_N" ;
lin floppy_A = mkTerm "floppy_A" ;
lin flora_N = mkTerm "flora_N" ;
lin flora_PN = mkTerm "flora_PN" ;
lin floral_A = mkTerm "floral_A" ;
lin florence_1_PN = mkTerm "florence_1_PN" ;
lin florence_2_PN = mkTerm "florence_2_PN" ;
lin floret_N = mkTerm "floret_N" ;
lin floricultural_A = mkTerm "floricultural_A" ;
lin floriculture_N = mkTerm "floriculture_N" ;
lin florid_A = mkTerm "florid_A" ;
lin florida_PN = mkTerm "florida_PN" ;
lin florilegium_N = mkTerm "florilegium_N" ;
lin florin_N = mkTerm "florin_N" ;
lin florist_N = mkTerm "florist_N" ;
lin florrie_PN = mkTerm "florrie_PN" ;
lin floss_N = mkTerm "floss_N" ;
lin flotation_N = mkTerm "flotation_N" ;
lin flotilla_N = mkTerm "flotilla_N" ;
lin flotsam_N = mkTerm "flotsam_N" ;
lin flounce_N = mkTerm "flounce_N" ;
lin flounce_V = mkTerm "flounce_V" ;
lin flounce_V2 = mkTerm "flounce_V2" ;
lin flounce_off_V = mkTerm "flounce_off_V" ;
lin flounce_out_V = mkTerm "flounce_out_V" ;
lin flounder_N = mkTerm "flounder_N" ;
lin flounder_V = mkTerm "flounder_V" ;
lin flour_N = mkTerm "flour_N" ;
lin flour_V2 = mkTerm "flour_V2" ;
lin flourish_N = mkTerm "flourish_N" ;
lin flourish_V = mkTerm "flourish_V" ;
lin floury_A = mkTerm "floury_A" ;
lin flout_V2 = mkTerm "flout_V2" ;
lin flow_N = mkTerm "flow_N" ;
lin flow_V = mkTerm "flow_V" ;
lin flowage_N = mkTerm "flowage_N" ;
lin flower_N = mkTerm "flower_N" ;
lin flower_V = mkTerm "flower_V" ;
lin flower_girl_N = mkTerm "flower_girl_N" ;
lin flowerbed_N = mkTerm "flowerbed_N" ;
lin flowered_A = mkTerm "flowered_A" ;
lin flowering_A = mkTerm "flowering_A" ;
lin flowerless_A = mkTerm "flowerless_A" ;
lin flowerpot_N = mkTerm "flowerpot_N" ;
lin flowery_A = mkTerm "flowery_A" ;
lin floxuridine_N = mkTerm "floxuridine_N" ;
lin flu_N = mkTerm "flu_N" ;
lin fluctuate_V = mkTerm "fluctuate_V" ;
lin fluctuation_N = mkTerm "fluctuation_N" ;
lin flue_N = mkTerm "flue_N" ;
lin fluency_N = mkTerm "fluency_N" ;
lin fluent_A = mkTerm "fluent_A" ;
lin fluff_N = mkTerm "fluff_N" ;
lin fluff_V2 = mkTerm "fluff_V2" ;
lin fluff_out_V2 = mkTerm "fluff_out_V2" ;
lin fluff_up_V2 = mkTerm "fluff_up_V2" ;
lin fluffy_A = mkTerm "fluffy_A" ;
lin flugelhorn_N = mkTerm "flugelhorn_N" ;
lin fluid_A = mkTerm "fluid_A" ;
lin fluid_N = mkTerm "fluid_N" ;
lin fluidity_N = mkTerm "fluidity_N" ;
lin fluidounce_N = mkTerm "fluidounce_N" ;
lin fluidram_N = mkTerm "fluidram_N" ;
lin fluke_N = mkTerm "fluke_N" ;
lin flume_N = mkTerm "flume_N" ;
lin flummery_N = mkTerm "flummery_N" ;
lin flummox_V2 = mkTerm "flummox_V2" ;
lin flunitrazepan_N = mkTerm "flunitrazepan_N" ;
lin flunk_V = mkTerm "flunk_V" ;
lin flunk_V2 = mkTerm "flunk_V2" ;
lin flunkey_N = mkTerm "flunkey_N" ;
lin flunky_N = mkTerm "flunky_N" ;
lin fluorapatite_N = mkTerm "fluorapatite_N" ;
lin fluorescein_N = mkTerm "fluorescein_N" ;
lin fluorescence_N = mkTerm "fluorescence_N" ;
lin fluorescent_A = mkTerm "fluorescent_A" ;
lin fluorescent_N = mkTerm "fluorescent_N" ;
lin fluoridate_V2 = mkTerm "fluoridate_V2" ;
lin fluoridation_N = mkTerm "fluoridation_N" ;
lin fluoride_N = mkTerm "fluoride_N" ;
lin fluoridization_N = mkTerm "fluoridization_N" ;
lin fluoridize_V2 = mkTerm "fluoridize_V2" ;
lin fluorine_N = mkTerm "fluorine_N" ;
lin fluorite_N = mkTerm "fluorite_N" ;
lin fluoroboride_N = mkTerm "fluoroboride_N" ;
lin fluorocarbon_N = mkTerm "fluorocarbon_N" ;
lin fluorochrome_N = mkTerm "fluorochrome_N" ;
lin fluoroform_N = mkTerm "fluoroform_N" ;
lin fluoroscope_N = mkTerm "fluoroscope_N" ;
lin fluoroscopy_N = mkTerm "fluoroscopy_N" ;
lin fluorosis_N = mkTerm "fluorosis_N" ;
lin fluorouracil_N = mkTerm "fluorouracil_N" ;
lin fluosilicate_N = mkTerm "fluosilicate_N" ;
lin fluoxetine_N = mkTerm "fluoxetine_N" ;
lin fluphenazine_N = mkTerm "fluphenazine_N" ;
lin flurazepam_N = mkTerm "flurazepam_N" ;
lin flurbiprofen_N = mkTerm "flurbiprofen_N" ;
lin flurry_N = mkTerm "flurry_N" ;
lin flurry_V2 = mkTerm "flurry_V2" ;
lin flush_A = mkTerm "flush_A" ;
lin flush_Adv = mkTerm "flush_Adv" ;
lin flush_N = mkTerm "flush_N" ;
lin flush_V = mkTerm "flush_V" ;
lin flush_V2 = mkTerm "flush_V2" ;
lin flush_out_V = mkTerm "flush_out_V" ;
lin fluster_N = mkTerm "fluster_N" ;
lin fluster_V2 = mkTerm "fluster_V2" ;
lin flute_N = mkTerm "flute_N" ;
lin flute_V = mkTerm "flute_V" ;
lin flute_V2 = mkTerm "flute_V2" ;
lin fluting_N = mkTerm "fluting_N" ;
lin flutist_N = mkTerm "flutist_N" ;
lin flutter_N = mkTerm "flutter_N" ;
lin flutter_V = mkTerm "flutter_V" ;
lin flutter_V2 = mkTerm "flutter_V2" ;
lin fluvastatin_N = mkTerm "fluvastatin_N" ;
lin fluvial_A = mkTerm "fluvial_A" ;
lin flux_N = mkTerm "flux_N" ;
lin fluxmeter_N = mkTerm "fluxmeter_N" ;
lin fly_A = mkTerm "fly_A" ;
lin fly_N = mkTerm "fly_N" ;
lin fly_V = mkTerm "fly_V" ;
lin fly_V2 = mkTerm "fly_V2" ;
lin fly_about_V = mkTerm "fly_about_V" ;
lin fly_around_V = mkTerm "fly_around_V" ;
lin fly_at_V2 = mkTerm "fly_at_V2" ;
lin fly_by_V = mkTerm "fly_by_V" ;
lin fly_fish_V = mkTerm "fly_fish_V" ;
lin fly_fishing_N = mkTerm "fly_fishing_N" ;
lin fly_into_V2 = mkTerm "fly_into_V2" ;
lin fly_out_V = mkTerm "fly_out_V" ;
lin fly_swat_N = mkTerm "fly_swat_N" ;
lin fly_swatter_N = mkTerm "fly_swatter_N" ;
lin flyaway_A = mkTerm "flyaway_A" ;
lin flyblown_A = mkTerm "flyblown_A" ;
lin flycatcher_N = mkTerm "flycatcher_N" ;
lin flyer_N = mkTerm "flyer_N" ;
lin flying_bomb_N = mkTerm "flying_bomb_N" ;
lin flying_fish_N = mkTerm "flying_fish_N" ;
lin flying_fox_N = mkTerm "flying_fox_N" ;
lin flying_squad_N = mkTerm "flying_squad_N" ;
lin flyleaf_N = mkTerm "flyleaf_N" ;
lin flyover_N = mkTerm "flyover_N" ;
lin flypaper_N = mkTerm "flypaper_N" ;
lin flypast_N = mkTerm "flypast_N" ;
lin flyspeck_N = mkTerm "flyspeck_N" ;
lin flytrap_N = mkTerm "flytrap_N" ;
lin flyweight_N = mkTerm "flyweight_N" ;
lin flywheel_N = mkTerm "flywheel_N" ;
lin fm_N = mkTerm "fm_N" ;
lin fo'c'sle_N = mkTerm "fo'c'sle_N" ;
lin fo_N = mkTerm "fo_N" ;
lin foal_N = mkTerm "foal_N" ;
lin foal_V = mkTerm "foal_V" ;
lin foam_N = mkTerm "foam_N" ;
lin foam_V = mkTerm "foam_V" ;
lin foam_rubber_N = mkTerm "foam_rubber_N" ;
lin foamflower_N = mkTerm "foamflower_N" ;
lin foaminess_N = mkTerm "foaminess_N" ;
lin foamy_A = mkTerm "foamy_A" ;
lin fob_N = mkTerm "fob_N" ;
lin fob_V2 = mkTerm "fob_V2" ;
lin fob_off_V2 = mkTerm "fob_off_V2" ;
lin fob_off_on_V3 = mkTerm "fob_off_on_V3" ;
lin fob_off_onto_V3 = mkTerm "fob_off_onto_V3" ;
lin fob_off_with_V3 = mkTerm "fob_off_with_V3" ;
lin focal_A = mkTerm "focal_A" ;
lin focalization_N = mkTerm "focalization_N" ;
lin focus_N = mkTerm "focus_N" ;
lin focus_V = mkTerm "focus_V" ;
lin focus_V2 = mkTerm "focus_V2" ;
lin focus_on_V2 = mkTerm "focus_on_V2" ;
lin fodder_N = mkTerm "fodder_N" ;
lin foe_N = mkTerm "foe_N" ;
lin foetal_A = mkTerm "foetal_A" ;
lin foetus_N = mkTerm "foetus_N" ;
lin fog_N = mkTerm "fog_N" ;
lin fog_V2 = mkTerm "fog_V2" ;
lin fogbank_N = mkTerm "fogbank_N" ;
lin fogbound_A = mkTerm "fogbound_A" ;
lin fogey_N = mkTerm "fogey_N" ;
lin foggia_PN = mkTerm "foggia_PN" ;
lin foggy_A = mkTerm "foggy_A" ;
lin foghorn_N = mkTerm "foghorn_N" ;
lin foglamp_N = mkTerm "foglamp_N" ;
lin fogsignal_N = mkTerm "fogsignal_N" ;
lin fogyish_A = mkTerm "fogyish_A" ;
lin fohn_N = mkTerm "fohn_N" ;
lin foible_N = mkTerm "foible_N" ;
lin foil_N = mkTerm "foil_N" ;
lin foil_V2 = mkTerm "foil_V2" ;
lin foist_V2 = mkTerm "foist_V2" ;
lin fold_N = mkTerm "fold_N" ;
lin fold_V = mkTerm "fold_V" ;
lin fold_V2 = mkTerm "fold_V2" ;
lin fold_up_V2 = mkTerm "fold_up_V2" ;
lin foldable_A = mkTerm "foldable_A" ;
lin folder_N = mkTerm "folder_N" ;
lin folderal_N = mkTerm "folderal_N" ;
lin folderol_N = mkTerm "folderol_N" ;
lin foldout_N = mkTerm "foldout_N" ;
lin foliaceous_A = mkTerm "foliaceous_A" ;
lin foliage_N = mkTerm "foliage_N" ;
lin foliate_A = mkTerm "foliate_A" ;
lin foliation_N = mkTerm "foliation_N" ;
lin folio_N = mkTerm "folio_N" ;
lin foliolate_A = mkTerm "foliolate_A" ;
lin folium_N = mkTerm "folium_N" ;
lin folk_N = mkTerm "folk_N" ;
lin folk_dance_N = mkTerm "folk_dance_N" ;
lin folkestone_PN = mkTerm "folkestone_PN" ;
lin folklore_N = mkTerm "folklore_N" ;
lin folks_N = mkTerm "folks_N" ;
lin folksong_N = mkTerm "folksong_N" ;
lin folksy_A = mkTerm "folksy_A" ;
lin folktale_N = mkTerm "folktale_N" ;
lin follicle_N = mkTerm "follicle_N" ;
lin follicular_A = mkTerm "follicular_A" ;
lin folliculitis_N = mkTerm "folliculitis_N" ;
lin follies_N = mkTerm "follies_N" ;
lin follow_V = mkTerm "follow_V" ;
lin follow_V2 = mkTerm "follow_V2" ;
lin follow_VS = mkTerm "follow_VS" ;
lin follow_on_N = mkTerm "follow_on_N" ;
lin follow_on_V = mkTerm "follow_on_V" ;
lin follow_on_from_V2 = mkTerm "follow_on_from_V2" ;
lin follow_through_N = mkTerm "follow_through_N" ;
lin follow_through_V = mkTerm "follow_through_V" ;
lin follow_up_N = mkTerm "follow_up_N" ;
lin follow_up_V2 = mkTerm "follow_up_V2" ;
lin follower_N = mkTerm "follower_N" ;
lin following_A = mkTerm "following_A" ;
lin following_N = mkTerm "following_N" ;
lin following_Prep = mkTerm "following_Prep" ;
lin folly_N = mkTerm "folly_N" ;
lin foment_V2 = mkTerm "foment_V2" ;
lin fomentation_N = mkTerm "fomentation_N" ;
lin fomite_N = mkTerm "fomite_N" ;
lin fond_A = mkTerm "fond_A" ;
lin fondant_N = mkTerm "fondant_N" ;
lin fondle_V2 = mkTerm "fondle_V2" ;
lin fondler_N = mkTerm "fondler_N" ;
lin fondness_N = mkTerm "fondness_N" ;
lin fondue_N = mkTerm "fondue_N" ;
lin font_N = mkTerm "font_N" ;
lin fontanelle_N = mkTerm "fontanelle_N" ;
lin fontsize_N = mkTerm "fontsize_N" ;
lin foochow_PN = mkTerm "foochow_PN" ;
lin food_N = mkTerm "food_N" ;
lin foodless_A = mkTerm "foodless_A" ;
lin foodstuff_N = mkTerm "foodstuff_N" ;
lin fool_N = mkTerm "fool_N" ;
lin fool_V2 = mkTerm "fool_V2" ;
lin fool_about_V = mkTerm "fool_about_V" ;
lin fool_around_V = mkTerm "fool_around_V" ;
lin fool_with_V2 = mkTerm "fool_with_V2" ;
lin foolery_N = mkTerm "foolery_N" ;
lin foolhardiness_N = mkTerm "foolhardiness_N" ;
lin foolhardy_A = mkTerm "foolhardy_A" ;
lin foolish_A = mkTerm "foolish_A" ;
lin foolishness_N = mkTerm "foolishness_N" ;
lin foolproof_A = mkTerm "foolproof_A" ;
lin foolscap_N = mkTerm "foolscap_N" ;
lin foot_N = mkTerm "foot_N" ;
lin foot_V = mkTerm "foot_V" ;
lin foot_V2 = mkTerm "foot_V2" ;
lin foot_and_mouth_A = mkTerm "foot_and_mouth_A" ;
lin foot_and_mouth_N = mkTerm "foot_and_mouth_N" ;
lin foot_bath_N = mkTerm "foot_bath_N" ;
lin foot_pound_N = mkTerm "foot_pound_N" ;
lin foot_race_N = mkTerm "foot_race_N" ;
lin foot_rot_N = mkTerm "foot_rot_N" ;
lin footage_N = mkTerm "footage_N" ;
lin football_N = mkTerm "football_N" ;
lin footballer_N = mkTerm "footballer_N" ;
lin footboard_N = mkTerm "footboard_N" ;
lin footbridge_N = mkTerm "footbridge_N" ;
lin footcandle_N = mkTerm "footcandle_N" ;
lin footedness_N = mkTerm "footedness_N" ;
lin footer_N = mkTerm "footer_N" ;
lin footfall_N = mkTerm "footfall_N" ;
lin footfault_N = mkTerm "footfault_N" ;
lin foothill_N = mkTerm "foothill_N" ;
lin foothold_N = mkTerm "foothold_N" ;
lin footing_N = mkTerm "footing_N" ;
lin footle_V = mkTerm "footle_V" ;
lin footle_V2 = mkTerm "footle_V2" ;
lin footless_A = mkTerm "footless_A" ;
lin footlights_N = mkTerm "footlights_N" ;
lin footlocker_N = mkTerm "footlocker_N" ;
lin footloose_A = mkTerm "footloose_A" ;
lin footman_N = mkTerm "footman_N" ;
lin footmark_N = mkTerm "footmark_N" ;
lin footnote_N = mkTerm "footnote_N" ;
lin footpad_N = mkTerm "footpad_N" ;
lin footpath_N = mkTerm "footpath_N" ;
lin footplate_N = mkTerm "footplate_N" ;
lin footprint_N = mkTerm "footprint_N" ;
lin footslog_V = mkTerm "footslog_V" ;
lin footslogger_N = mkTerm "footslogger_N" ;
lin footsore_A = mkTerm "footsore_A" ;
lin footstep_N = mkTerm "footstep_N" ;
lin footstool_N = mkTerm "footstool_N" ;
lin footsure_A = mkTerm "footsure_A" ;
lin footwall_N = mkTerm "footwall_N" ;
lin footwear_N = mkTerm "footwear_N" ;
lin footwork_N = mkTerm "footwork_N" ;
lin fop_N = mkTerm "fop_N" ;
lin foppish_A = mkTerm "foppish_A" ;
lin foppishness_N = mkTerm "foppishness_N" ;
lin for_Adv = mkTerm "for_Adv" ;
lin for_PConj = mkTerm "for_PConj" ;
lin for_example_Adv = mkTerm "for_example_Adv" ;
lin for_instance_Adv = mkTerm "for_instance_Adv" ;
lin for_starters_Adv = mkTerm "for_starters_Adv" ;
lin for_sure_Adv = mkTerm "for_sure_Adv" ;
lin for_the_sake_of_Prep = mkTerm "for_the_sake_of_Prep" ;
lin forage_N = mkTerm "forage_N" ;
lin forage_V = mkTerm "forage_V" ;
lin forager_N = mkTerm "forager_N" ;
lin foraging_N = mkTerm "foraging_N" ;
lin foram_N = mkTerm "foram_N" ;
lin foramen_N = mkTerm "foramen_N" ;
lin foray_N = mkTerm "foray_N" ;
lin foray_V = mkTerm "foray_V" ;
lin forbear_N = mkTerm "forbear_N" ;
lin forbear_V = mkTerm "forbear_V" ;
lin forbear_V2 = mkTerm "forbear_V2" ;
lin forbearance_N = mkTerm "forbearance_N" ;
lin forbid_V2 = mkTerm "forbid_V2" ;
lin forbidding_A = mkTerm "forbidding_A" ;
lin forby_Prep = mkTerm "forby_Prep" ;
lin force_N = mkTerm "force_N" ;
lin force_V = mkTerm "force_V" ;
lin force_V2 = mkTerm "force_V2" ;
lin force_V2V = mkTerm "force_V2V" ;
lin force_VS = mkTerm "force_VS" ;
lin force_feed_V2 = mkTerm "force_feed_V2" ;
lin force_land_V = mkTerm "force_land_V" ;
lin force_land_V2 = mkTerm "force_land_V2" ;
lin force_majeure_N = mkTerm "force_majeure_N" ;
lin force_out_V = mkTerm "force_out_V" ;
lin forceful_A = mkTerm "forceful_A" ;
lin forcefulness_N = mkTerm "forcefulness_N" ;
lin forceless_A = mkTerm "forceless_A" ;
lin forcemeat_N = mkTerm "forcemeat_N" ;
lin forceps_N = mkTerm "forceps_N" ;
lin forcible_A = mkTerm "forcible_A" ;
lin forcipate_A = mkTerm "forcipate_A" ;
lin ford_N = mkTerm "ford_N" ;
lin ford_V2 = mkTerm "ford_V2" ;
lin fordable_A = mkTerm "fordable_A" ;
lin fore_A = mkTerm "fore_A" ;
lin fore_Adv = mkTerm "fore_Adv" ;
lin fore_N = mkTerm "fore_N" ;
lin forearm_N = mkTerm "forearm_N" ;
lin forearm_V2 = mkTerm "forearm_V2" ;
lin forebear_N = mkTerm "forebear_N" ;
lin forebode_V2 = mkTerm "forebode_V2" ;
lin foreboding_N = mkTerm "foreboding_N" ;
lin forebrain_N = mkTerm "forebrain_N" ;
lin forecast_N = mkTerm "forecast_N" ;
lin forecast_V = mkTerm "forecast_V" ;
lin forecast_V2 = mkTerm "forecast_V2" ;
lin forecast_VS = mkTerm "forecast_VS" ;
lin forecaster_N = mkTerm "forecaster_N" ;
lin forecastle_N = mkTerm "forecastle_N" ;
lin foreclose_V = mkTerm "foreclose_V" ;
lin foreclose_V2 = mkTerm "foreclose_V2" ;
lin foreclosure_N = mkTerm "foreclosure_N" ;
lin forecourt_N = mkTerm "forecourt_N" ;
lin foredeck_N = mkTerm "foredeck_N" ;
lin foredoom_V2 = mkTerm "foredoom_V2" ;
lin forefather_N = mkTerm "forefather_N" ;
lin forefinger_N = mkTerm "forefinger_N" ;
lin forefoot_N = mkTerm "forefoot_N" ;
lin forefront_N = mkTerm "forefront_N" ;
lin foregather_V = mkTerm "foregather_V" ;
lin forego_V = mkTerm "forego_V" ;
lin forego_V2 = mkTerm "forego_V2" ;
lin foreground_N = mkTerm "foreground_N" ;
lin forehand_A = mkTerm "forehand_A" ;
lin forehand_N = mkTerm "forehand_N" ;
lin forehanded_A = mkTerm "forehanded_A" ;
lin forehead_N = mkTerm "forehead_N" ;
lin foreign_1_A = mkTerm "foreign_1_A" ;
lin foreign_2_A = mkTerm "foreign_2_A" ;
lin foreigner_N = mkTerm "foreigner_N" ;
lin foreignness_N = mkTerm "foreignness_N" ;
lin foreknow_V = mkTerm "foreknow_V" ;
lin foreknow_V2 = mkTerm "foreknow_V2" ;
lin foreknowledge_N = mkTerm "foreknowledge_N" ;
lin foreland_N = mkTerm "foreland_N" ;
lin foreleg_N = mkTerm "foreleg_N" ;
lin forelimb_N = mkTerm "forelimb_N" ;
lin forelock_N = mkTerm "forelock_N" ;
lin foreman_N = mkTerm "foreman_N" ;
lin foremanship_N = mkTerm "foremanship_N" ;
lin foremast_N = mkTerm "foremast_N" ;
lin foremost_A = mkTerm "foremost_A" ;
lin foremost_Adv = mkTerm "foremost_Adv" ;
lin foremother_N = mkTerm "foremother_N" ;
lin forename_N = mkTerm "forename_N" ;
lin forenenst_Prep = mkTerm "forenenst_Prep" ;
lin forenoon_N = mkTerm "forenoon_N" ;
lin forensic_A = mkTerm "forensic_A" ;
lin forensics_N = mkTerm "forensics_N" ;
lin foreordain_V2 = mkTerm "foreordain_V2" ;
lin forepaw_N = mkTerm "forepaw_N" ;
lin foreperson_N = mkTerm "foreperson_N" ;
lin foreplay_N = mkTerm "foreplay_N" ;
lin forequarter_N = mkTerm "forequarter_N" ;
lin forerunner_N = mkTerm "forerunner_N" ;
lin foresail_N = mkTerm "foresail_N" ;
lin foresee_V2 = mkTerm "foresee_V2" ;
lin foreseeable_A = mkTerm "foreseeable_A" ;
lin foreshadow_V2 = mkTerm "foreshadow_V2" ;
lin foreshank_N = mkTerm "foreshank_N" ;
lin foreshock_N = mkTerm "foreshock_N" ;
lin foreshore_N = mkTerm "foreshore_N" ;
lin foreshorten_V2 = mkTerm "foreshorten_V2" ;
lin foresight_N = mkTerm "foresight_N" ;
lin foreskin_N = mkTerm "foreskin_N" ;
lin forest_N = mkTerm "forest_N" ;
lin forestall_V2 = mkTerm "forestall_V2" ;
lin forestay_N = mkTerm "forestay_N" ;
lin forested_A = mkTerm "forested_A" ;
lin forester_N = mkTerm "forester_N" ;
lin forestiera_N = mkTerm "forestiera_N" ;
lin forestry_N = mkTerm "forestry_N" ;
lin foreswear_V2 = mkTerm "foreswear_V2" ;
lin foretaste_N = mkTerm "foretaste_N" ;
lin foretell_V2 = mkTerm "foretell_V2" ;
lin forethought_N = mkTerm "forethought_N" ;
lin forethoughtful_A = mkTerm "forethoughtful_A" ;
lin foretop_N = mkTerm "foretop_N" ;
lin forever_Adv = mkTerm "forever_Adv" ;
lin forewarn_V2 = mkTerm "forewarn_V2" ;
lin forewarning_N = mkTerm "forewarning_N" ;
lin forewing_N = mkTerm "forewing_N" ;
lin forewoman_N = mkTerm "forewoman_N" ;
lin foreword_N = mkTerm "foreword_N" ;
lin forfar_PN = mkTerm "forfar_PN" ;
lin forfeit_N = mkTerm "forfeit_N" ;
lin forfeit_V2 = mkTerm "forfeit_V2" ;
lin forfeiture_N = mkTerm "forfeiture_N" ;
lin forgather_V = mkTerm "forgather_V" ;
lin forge_N = mkTerm "forge_N" ;
lin forge_V = mkTerm "forge_V" ;
lin forge_V2 = mkTerm "forge_V2" ;
lin forge_ahead_V = mkTerm "forge_ahead_V" ;
lin forger_N = mkTerm "forger_N" ;
lin forgery_N = mkTerm "forgery_N" ;
lin forget_V = mkTerm "forget_V" ;
lin forget_V2 = mkTerm "forget_V2" ;
lin forget_VS = mkTerm "forget_VS" ;
lin forget_me_not_N = mkTerm "forget_me_not_N" ;
lin forgetful_A = mkTerm "forgetful_A" ;
lin forgetfulness_N = mkTerm "forgetfulness_N" ;
lin forgettable_A = mkTerm "forgettable_A" ;
lin forging_N = mkTerm "forging_N" ;
lin forgivable_A = mkTerm "forgivable_A" ;
lin forgive_V = mkTerm "forgive_V" ;
lin forgive_V2 = mkTerm "forgive_V2" ;
lin forgiveness_N = mkTerm "forgiveness_N" ;
lin forgivingly_Adv = mkTerm "forgivingly_Adv" ;
lin forgivingness_N = mkTerm "forgivingness_N" ;
lin forgo_V2 = mkTerm "forgo_V2" ;
lin forint_N = mkTerm "forint_N" ;
lin fork_1_N = mkTerm "fork_1_N" ;
lin fork_3_N = mkTerm "fork_3_N" ;
lin fork_4_N = mkTerm "fork_4_N" ;
lin fork_V = mkTerm "fork_V" ;
lin fork_V2 = mkTerm "fork_V2" ;
lin fork_out_V = mkTerm "fork_out_V" ;
lin fork_over_V = mkTerm "fork_over_V" ;
lin forklift_N = mkTerm "forklift_N" ;
lin forli_PN = mkTerm "forli_PN" ;
lin forlorn_A = mkTerm "forlorn_A" ;
lin forlornness_N = mkTerm "forlornness_N" ;
lin form_N = mkTerm "form_N" ;
lin form_V = mkTerm "form_V" ;
lin form_V2 = mkTerm "form_V2" ;
lin formal_A = mkTerm "formal_A" ;
lin formaldehyde_N = mkTerm "formaldehyde_N" ;
lin formalin_N = mkTerm "formalin_N" ;
lin formalism_N = mkTerm "formalism_N" ;
lin formalistic_A = mkTerm "formalistic_A" ;
lin formality_N = mkTerm "formality_N" ;
lin formalization_N = mkTerm "formalization_N" ;
lin formalize_V2 = mkTerm "formalize_V2" ;
lin formalwear_N = mkTerm "formalwear_N" ;
lin format_N = mkTerm "format_N" ;
lin formation_N = mkTerm "formation_N" ;
lin formative_A = mkTerm "formative_A" ;
lin formative_N = mkTerm "formative_N" ;
lin formby_PN = mkTerm "formby_PN" ;
lin former_A = mkTerm "former_A" ;
lin former_N = mkTerm "former_N" ;
lin formic_A = mkTerm "formic_A" ;
lin formica_N = mkTerm "formica_N" ;
lin formication_N = mkTerm "formication_N" ;
lin formidability_N = mkTerm "formidability_N" ;
lin formidable_A = mkTerm "formidable_A" ;
lin formless_A = mkTerm "formless_A" ;
lin formosa_PN = mkTerm "formosa_PN" ;
lin formula_N = mkTerm "formula_N" ;
lin formulaic_A = mkTerm "formulaic_A" ;
lin formulary_A = mkTerm "formulary_A" ;
lin formulary_N = mkTerm "formulary_N" ;
lin formulate_V2 = mkTerm "formulate_V2" ;
lin formulation_N = mkTerm "formulation_N" ;
lin fornenst_Prep = mkTerm "fornenst_Prep" ;
lin fornent_Prep = mkTerm "fornent_Prep" ;
lin fornicate_V = mkTerm "fornicate_V" ;
lin fornication_N = mkTerm "fornication_N" ;
lin fornix_N = mkTerm "fornix_N" ;
lin forrader_Adv = mkTerm "forrader_Adv" ;
lin forsake_V2 = mkTerm "forsake_V2" ;
lin forsaking_N = mkTerm "forsaking_N" ;
lin forsooth_Adv = mkTerm "forsooth_Adv" ;
lin forssa_PN = mkTerm "forssa_PN" ;
lin forswear_V2 = mkTerm "forswear_V2" ;
lin forsythia_N = mkTerm "forsythia_N" ;
lin fort_N = mkTerm "fort_N" ;
lin fort_lauderdale_PN = mkTerm "fort_lauderdale_PN" ;
lin fort_william_PN = mkTerm "fort_william_PN" ;
lin fort_worth_PN = mkTerm "fort_worth_PN" ;
lin fortaleza_PN = mkTerm "fortaleza_PN" ;
lin forte_A = mkTerm "forte_A" ;
lin forte_Adv = mkTerm "forte_Adv" ;
lin forte_N = mkTerm "forte_N" ;
lin fortemente_A = mkTerm "fortemente_A" ;
lin forth_Adv = mkTerm "forth_Adv" ;
lin forthcoming_A = mkTerm "forthcoming_A" ;
lin forthright_A = mkTerm "forthright_A" ;
lin forthwith_Adv = mkTerm "forthwith_Adv" ;
lin fortification_N = mkTerm "fortification_N" ;
lin fortify_V2 = mkTerm "fortify_V2" ;
lin fortissimo_A = mkTerm "fortissimo_A" ;
lin fortissimo_Adv = mkTerm "fortissimo_Adv" ;
lin fortitude_N = mkTerm "fortitude_N" ;
lin fortnight_N = mkTerm "fortnight_N" ;
lin fortnightly_A = mkTerm "fortnightly_A" ;
lin fortnightly_Adv = mkTerm "fortnightly_Adv" ;
lin fortress_N = mkTerm "fortress_N" ;
lin fortuitous_A = mkTerm "fortuitous_A" ;
lin fortuitousness_N = mkTerm "fortuitousness_N" ;
lin fortunate_A = mkTerm "fortunate_A" ;
lin fortunately_Adv = mkTerm "fortunately_Adv" ;
lin fortune_N = mkTerm "fortune_N" ;
lin fortuneteller_N = mkTerm "fortuneteller_N" ;
lin fortunetelling_N = mkTerm "fortunetelling_N" ;
lin forty_N = mkTerm "forty_N" ;
lin fortyish_A = mkTerm "fortyish_A" ;
lin forum_N = mkTerm "forum_N" ;
lin forward_A = mkTerm "forward_A" ;
lin forward_Adv = mkTerm "forward_Adv" ;
lin forward_N = mkTerm "forward_N" ;
lin forward_V2 = mkTerm "forward_V2" ;
lin forwarding_N = mkTerm "forwarding_N" ;
lin forwardness_N = mkTerm "forwardness_N" ;
lin forwards_Adv = mkTerm "forwards_Adv" ;
lin foryml_N = mkTerm "foryml_N" ;
lin fossa_N = mkTerm "fossa_N" ;
lin fosse_N = mkTerm "fosse_N" ;
lin fossil_A = mkTerm "fossil_A" ;
lin fossil_N = mkTerm "fossil_N" ;
lin fossiliferous_A = mkTerm "fossiliferous_A" ;
lin fossilization_N = mkTerm "fossilization_N" ;
lin fossilize_V = mkTerm "fossilize_V" ;
lin fossilize_V2 = mkTerm "fossilize_V2" ;
lin fossorial_A = mkTerm "fossorial_A" ;
lin foster_A = mkTerm "foster_A" ;
lin foster_V2 = mkTerm "foster_V2" ;
lin foster_brother_N = mkTerm "foster_brother_N" ;
lin foster_child_N = mkTerm "foster_child_N" ;
lin foster_father_N = mkTerm "foster_father_N" ;
lin foster_mother_N = mkTerm "foster_mother_N" ;
lin foster_parent_N = mkTerm "foster_parent_N" ;
lin foster_sister_N = mkTerm "foster_sister_N" ;
lin fostering_N = mkTerm "fostering_N" ;
lin fothergilla_N = mkTerm "fothergilla_N" ;
lin foul_A = mkTerm "foul_A" ;
lin foul_N = mkTerm "foul_N" ;
lin foul_V = mkTerm "foul_V" ;
lin foul_V2 = mkTerm "foul_V2" ;
lin foul_mouthed_A = mkTerm "foul_mouthed_A" ;
lin foul_spoken_A = mkTerm "foul_spoken_A" ;
lin foulard_N = mkTerm "foulard_N" ;
lin foulness_N = mkTerm "foulness_N" ;
lin found_N = mkTerm "found_N" ;
lin found_V2 = mkTerm "found_V2" ;
lin foundation_N = mkTerm "foundation_N" ;
lin foundation_stone_N = mkTerm "foundation_stone_N" ;
lin founder_N = mkTerm "founder_N" ;
lin founder_V = mkTerm "founder_V" ;
lin founder_V2 = mkTerm "founder_V2" ;
lin foundering_N = mkTerm "foundering_N" ;
lin foundling_N = mkTerm "foundling_N" ;
lin foundress_N = mkTerm "foundress_N" ;
lin foundry_N = mkTerm "foundry_N" ;
lin fount_N = mkTerm "fount_N" ;
lin fountain_N = mkTerm "fountain_N" ;
lin fountain_head_N = mkTerm "fountain_head_N" ;
lin fountain_pen_N = mkTerm "fountain_pen_N" ;
lin four_in_hand_N = mkTerm "four_in_hand_N" ;
lin four_part_A = mkTerm "four_part_A" ;
lin four_ply_A = mkTerm "four_ply_A" ;
lin four_poster_N = mkTerm "four_poster_N" ;
lin four_pounder_N = mkTerm "four_pounder_N" ;
lin four_wheeler_N = mkTerm "four_wheeler_N" ;
lin fourfold_A = mkTerm "fourfold_A" ;
lin fourfold_Adv = mkTerm "fourfold_Adv" ;
lin fourhanded_A = mkTerm "fourhanded_A" ;
lin fourpence_N = mkTerm "fourpence_N" ;
lin fourpenny_A = mkTerm "fourpenny_A" ;
lin fourscore_A = mkTerm "fourscore_A" ;
lin fourscore_N = mkTerm "fourscore_N" ;
lin foursome_N = mkTerm "foursome_N" ;
lin foursquare_A = mkTerm "foursquare_A" ;
lin foursquare_Adv = mkTerm "foursquare_Adv" ;
lin fovea_N = mkTerm "fovea_N" ;
lin fowey_PN = mkTerm "fowey_PN" ;
lin fowl_N = mkTerm "fowl_N" ;
lin fowl_V = mkTerm "fowl_V" ;
lin fowl_run_N = mkTerm "fowl_run_N" ;
lin fowler_N = mkTerm "fowler_N" ;
lin fowlingpiece_N = mkTerm "fowlingpiece_N" ;
lin fowlpest_N = mkTerm "fowlpest_N" ;
lin fox_N = mkTerm "fox_N" ;
lin fox_V2 = mkTerm "fox_V2" ;
lin fox_terrier_N = mkTerm "fox_terrier_N" ;
lin foxglove_N = mkTerm "foxglove_N" ;
lin foxhole_N = mkTerm "foxhole_N" ;
lin foxhound_N = mkTerm "foxhound_N" ;
lin foxhunt_N = mkTerm "foxhunt_N" ;
lin foxhunt_V = mkTerm "foxhunt_V" ;
lin foxhunter_N = mkTerm "foxhunter_N" ;
lin foxtail_N = mkTerm "foxtail_N" ;
lin foxtrot_N = mkTerm "foxtrot_N" ;
lin foxy_A = mkTerm "foxy_A" ;
lin foyer_N = mkTerm "foyer_N" ;
lin fr_PN = mkTerm "fr_PN" ;
lin fracas_N = mkTerm "fracas_N" ;
lin fractal_N = mkTerm "fractal_N" ;
lin fraction_N = mkTerm "fraction_N" ;
lin fractional_A = mkTerm "fractional_A" ;
lin fractionation_N = mkTerm "fractionation_N" ;
lin fractious_A = mkTerm "fractious_A" ;
lin fractiousness_N = mkTerm "fractiousness_N" ;
lin fracture_N = mkTerm "fracture_N" ;
lin fracture_V = mkTerm "fracture_V" ;
lin fracture_V2 = mkTerm "fracture_V2" ;
lin fragile_A = mkTerm "fragile_A" ;
lin fragility_N = mkTerm "fragility_N" ;
lin fragment_N = mkTerm "fragment_N" ;
lin fragment_V = mkTerm "fragment_V" ;
lin fragment_V2 = mkTerm "fragment_V2" ;
lin fragmental_A = mkTerm "fragmental_A" ;
lin fragmentary_A = mkTerm "fragmentary_A" ;
lin fragmentation_N = mkTerm "fragmentation_N" ;
lin fragrance_N = mkTerm "fragrance_N" ;
lin fragrant_A = mkTerm "fragrant_A" ;
lin frail_A = mkTerm "frail_A" ;
lin frail_N = mkTerm "frail_N" ;
lin frailty_N = mkTerm "frailty_N" ;
lin fraise_N = mkTerm "fraise_N" ;
lin frame_N = mkTerm "frame_N" ;
lin frame_V = mkTerm "frame_V" ;
lin frame_V2 = mkTerm "frame_V2" ;
lin frame_up_N = mkTerm "frame_up_N" ;
lin framer_N = mkTerm "framer_N" ;
lin framework_N = mkTerm "framework_N" ;
lin framing_N = mkTerm "framing_N" ;
lin frampton_cotterell_PN = mkTerm "frampton_cotterell_PN" ;
lin fran_PN = mkTerm "fran_PN" ;
lin franc_N = mkTerm "franc_N" ;
lin france_PN = mkTerm "france_PN" ;
lin frances_PN = mkTerm "frances_PN" ;
lin franchise_N = mkTerm "franchise_N" ;
lin francis_PN = mkTerm "francis_PN" ;
lin franciscan_A = mkTerm "franciscan_A" ;
lin franciscan_N = mkTerm "franciscan_N" ;
lin francium_N = mkTerm "francium_N" ;
lin frangible_A = mkTerm "frangible_A" ;
lin frangipane_N = mkTerm "frangipane_N" ;
lin frangipani_N = mkTerm "frangipani_N" ;
lin frank_A = mkTerm "frank_A" ;
lin frank_N = mkTerm "frank_N" ;
lin frank_PN = mkTerm "frank_PN" ;
lin frank_V2 = mkTerm "frank_V2" ;
lin frankfurt_PN = mkTerm "frankfurt_PN" ;
lin frankfurter_N = mkTerm "frankfurter_N" ;
lin frankie_PN = mkTerm "frankie_PN" ;
lin frankincense_N = mkTerm "frankincense_N" ;
lin franking_machine_N = mkTerm "franking_machine_N" ;
lin franklin_N = mkTerm "franklin_N" ;
lin frankly_Adv = mkTerm "frankly_Adv" ;
lin frankness_N = mkTerm "frankness_N" ;
lin frantic_A = mkTerm "frantic_A" ;
lin frappe_N = mkTerm "frappe_N" ;
lin fraserburgh_PN = mkTerm "fraserburgh_PN" ;
lin fraternal_A = mkTerm "fraternal_A" ;
lin fraternity_N = mkTerm "fraternity_N" ;
lin fraternization_N = mkTerm "fraternization_N" ;
lin fraternize_V = mkTerm "fraternize_V" ;
lin fratricide_N = mkTerm "fratricide_N" ;
lin frau_N = mkTerm "frau_N" ;
lin fraud_N = mkTerm "fraud_N" ;
lin fraudulence_N = mkTerm "fraudulence_N" ;
lin fraudulent_A = mkTerm "fraudulent_A" ;
lin fraught_A = mkTerm "fraught_A" ;
lin fraulein_N = mkTerm "fraulein_N" ;
lin fraxinella_N = mkTerm "fraxinella_N" ;
lin fray_N = mkTerm "fray_N" ;
lin fray_V = mkTerm "fray_V" ;
lin fray_V2 = mkTerm "fray_V2" ;
lin frazzle_N = mkTerm "frazzle_N" ;
lin freak_N = mkTerm "freak_N" ;
lin freak_V = mkTerm "freak_V" ;
lin freak_V2 = mkTerm "freak_V2" ;
lin freak_out_N = mkTerm "freak_out_N" ;
lin freak_out_V2 = mkTerm "freak_out_V2" ;
lin freakish_A = mkTerm "freakish_A" ;
lin freakishness_N = mkTerm "freakishness_N" ;
lin freaky_A = mkTerm "freaky_A" ;
lin freckle_N = mkTerm "freckle_N" ;
lin freckle_V = mkTerm "freckle_V" ;
lin freckle_V2 = mkTerm "freckle_V2" ;
lin freckleton_PN = mkTerm "freckleton_PN" ;
lin fred_PN = mkTerm "fred_PN" ;
lin freda_PN = mkTerm "freda_PN" ;
lin freddie_PN = mkTerm "freddie_PN" ;
lin freddy_PN = mkTerm "freddy_PN" ;
lin frederick_PN = mkTerm "frederick_PN" ;
lin frederiksberg_PN = mkTerm "frederiksberg_PN" ;
lin free_1_A = mkTerm "free_1_A" ;
lin free_2_A = mkTerm "free_2_A" ;
lin free_3_A = mkTerm "free_3_A" ;
lin free_N = mkTerm "free_N" ;
lin free_V2 = mkTerm "free_V2" ;
lin free_V2V = mkTerm "free_V2V" ;
lin free_and_easy_A = mkTerm "free_and_easy_A" ;
lin free_for_all_N = mkTerm "free_for_all_N" ;
lin free_handed_A = mkTerm "free_handed_A" ;
lin free_list_N = mkTerm "free_list_N" ;
lin free_liver_N = mkTerm "free_liver_N" ;
lin free_living_N = mkTerm "free_living_N" ;
lin free_of_A2 = mkTerm "free_of_A2" ;
lin free_range_A = mkTerm "free_range_A" ;
lin free_spoken_A = mkTerm "free_spoken_A" ;
lin free_standing_A = mkTerm "free_standing_A" ;
lin free_thinker_N = mkTerm "free_thinker_N" ;
lin free_thinking_A = mkTerm "free_thinking_A" ;
lin free_thought_N = mkTerm "free_thought_N" ;
lin free_trader_N = mkTerm "free_trader_N" ;
lin free_up_V2 = mkTerm "free_up_V2" ;
lin freebie_N = mkTerm "freebie_N" ;
lin freebooter_N = mkTerm "freebooter_N" ;
lin freeborn_A = mkTerm "freeborn_A" ;
lin freedman_N = mkTerm "freedman_N" ;
lin freedom_N = mkTerm "freedom_N" ;
lin freehand_A = mkTerm "freehand_A" ;
lin freehold_N = mkTerm "freehold_N" ;
lin freeholder_N = mkTerm "freeholder_N" ;
lin freelance_A = mkTerm "freelance_A" ;
lin freelance_N = mkTerm "freelance_N" ;
lin freelance_V = mkTerm "freelance_V" ;
lin freelancer_N = mkTerm "freelancer_N" ;
lin freeloader_N = mkTerm "freeloader_N" ;
lin freemail_N = mkTerm "freemail_N" ;
lin freeman_N = mkTerm "freeman_N" ;
lin freemason_N = mkTerm "freemason_N" ;
lin freemasonry_N = mkTerm "freemasonry_N" ;
lin freesia_N = mkTerm "freesia_N" ;
lin freestone_N = mkTerm "freestone_N" ;
lin freestyle_N = mkTerm "freestyle_N" ;
lin freetail_N = mkTerm "freetail_N" ;
lin freeware_N = mkTerm "freeware_N" ;
lin freeway_N = mkTerm "freeway_N" ;
lin freewheel_N = mkTerm "freewheel_N" ;
lin freewheel_V = mkTerm "freewheel_V" ;
lin freewill_A = mkTerm "freewill_A" ;
lin freeze_N = mkTerm "freeze_N" ;
lin freeze_V = mkTerm "freeze_V" ;
lin freeze_V2 = mkTerm "freeze_V2" ;
lin freeze_out_V2 = mkTerm "freeze_out_V2" ;
lin freeze_over_V = mkTerm "freeze_over_V" ;
lin freeze_up_V = mkTerm "freeze_up_V" ;
lin freezer_N = mkTerm "freezer_N" ;
lin freezing_mixture_N = mkTerm "freezing_mixture_N" ;
lin freezing_point_N = mkTerm "freezing_point_N" ;
lin freiburg_PN = mkTerm "freiburg_PN" ;
lin freight_N = mkTerm "freight_N" ;
lin freight_V2 = mkTerm "freight_V2" ;
lin freight_train_N = mkTerm "freight_train_N" ;
lin freighter_N = mkTerm "freighter_N" ;
lin freightliner_N = mkTerm "freightliner_N" ;
lin frenchFem_N = mkTerm "frenchFem_N" ;
lin frenchMasc_N = mkTerm "frenchMasc_N" ;
lin french_A = mkTerm "french_A" ;
lin frenetic_A = mkTerm "frenetic_A" ;
lin frenzied_A = mkTerm "frenzied_A" ;
lin frenzy_N = mkTerm "frenzy_N" ;
lin frequency_N = mkTerm "frequency_N" ;
lin frequent_A = mkTerm "frequent_A" ;
lin frequent_V2 = mkTerm "frequent_V2" ;
lin frequentative_N = mkTerm "frequentative_N" ;
lin fresco_N = mkTerm "fresco_N" ;
lin fresco_V2 = mkTerm "fresco_V2" ;
lin fresh_A = mkTerm "fresh_A" ;
lin fresh_Adv = mkTerm "fresh_Adv" ;
lin freshen_V = mkTerm "freshen_V" ;
lin freshen_V2 = mkTerm "freshen_V2" ;
lin freshen_up_V = mkTerm "freshen_up_V" ;
lin freshen_up_V2 = mkTerm "freshen_up_V2" ;
lin freshener_N = mkTerm "freshener_N" ;
lin fresher_N = mkTerm "fresher_N" ;
lin freshet_N = mkTerm "freshet_N" ;
lin freshman_A = mkTerm "freshman_A" ;
lin freshman_N = mkTerm "freshman_N" ;
lin freshness_N = mkTerm "freshness_N" ;
lin freshwater_A = mkTerm "freshwater_A" ;
lin freshwater_N = mkTerm "freshwater_N" ;
lin freshwater_PN = mkTerm "freshwater_PN" ;
lin fret_N = mkTerm "fret_N" ;
lin fret_V = mkTerm "fret_V" ;
lin fret_V2 = mkTerm "fret_V2" ;
lin fret_VS = mkTerm "fret_VS" ;
lin fretful_A = mkTerm "fretful_A" ;
lin fretsaw_N = mkTerm "fretsaw_N" ;
lin fretwork_N = mkTerm "fretwork_N" ;
lin freudian_A = mkTerm "freudian_A" ;
lin fri_PN = mkTerm "fri_PN" ;
lin friability_N = mkTerm "friability_N" ;
lin friable_A = mkTerm "friable_A" ;
lin friar_N = mkTerm "friar_N" ;
lin friary_N = mkTerm "friary_N" ;
lin fricandeau_N = mkTerm "fricandeau_N" ;
lin fricassee_N = mkTerm "fricassee_N" ;
lin fricassee_V2 = mkTerm "fricassee_V2" ;
lin fricative_A = mkTerm "fricative_A" ;
lin fricative_N = mkTerm "fricative_N" ;
lin friction_N = mkTerm "friction_N" ;
lin frictional_A = mkTerm "frictional_A" ;
lin frictionless_A = mkTerm "frictionless_A" ;
lin fridge_N = mkTerm "fridge_N" ;
lin friedcake_N = mkTerm "friedcake_N" ;
lin friend_N = mkTerm "friend_N" ;
lin friendless_A = mkTerm "friendless_A" ;
lin friendlessness_N = mkTerm "friendlessness_N" ;
lin friendliness_N = mkTerm "friendliness_N" ;
lin friendly_A = mkTerm "friendly_A" ;
lin friendly_N = mkTerm "friendly_N" ;
lin friendship_N = mkTerm "friendship_N" ;
lin frier_N = mkTerm "frier_N" ;
lin frieze_N = mkTerm "frieze_N" ;
lin frigate_N = mkTerm "frigate_N" ;
lin fright_N = mkTerm "fright_N" ;
lin fright_V2 = mkTerm "fright_V2" ;
lin frighten_V2 = mkTerm "frighten_V2" ;
lin frighten_away_V2 = mkTerm "frighten_away_V2" ;
lin frighten_off_V2 = mkTerm "frighten_off_V2" ;
lin frightened_A = mkTerm "frightened_A" ;
lin frightening_A = mkTerm "frightening_A" ;
lin frightful_A = mkTerm "frightful_A" ;
lin frightfulness_N = mkTerm "frightfulness_N" ;
lin frigid_A = mkTerm "frigid_A" ;
lin frigidity_N = mkTerm "frigidity_N" ;
lin frigorific_A = mkTerm "frigorific_A" ;
lin frijole_N = mkTerm "frijole_N" ;
lin frill_N = mkTerm "frill_N" ;
lin frilled_A = mkTerm "frilled_A" ;
lin frilly_A = mkTerm "frilly_A" ;
lin fringe_N = mkTerm "fringe_N" ;
lin fringe_V2 = mkTerm "fringe_V2" ;
lin fringepod_N = mkTerm "fringepod_N" ;
lin fringy_A = mkTerm "fringy_A" ;
lin frinton_PN = mkTerm "frinton_PN" ;
lin frippery_N = mkTerm "frippery_N" ;
lin frisk_N = mkTerm "frisk_N" ;
lin frisk_V = mkTerm "frisk_V" ;
lin frisk_V2 = mkTerm "frisk_V2" ;
lin friskiness_N = mkTerm "friskiness_N" ;
lin frisky_A = mkTerm "frisky_A" ;
lin frisson_N = mkTerm "frisson_N" ;
lin fritillary_N = mkTerm "fritillary_N" ;
lin frittata_N = mkTerm "frittata_N" ;
lin fritter_N = mkTerm "fritter_N" ;
lin fritter_V2 = mkTerm "fritter_V2" ;
lin fritter_away_V = mkTerm "fritter_away_V" ;
lin frivol_V = mkTerm "frivol_V" ;
lin frivol_V2 = mkTerm "frivol_V2" ;
lin frivolity_N = mkTerm "frivolity_N" ;
lin frivolous_A = mkTerm "frivolous_A" ;
lin frizz_N = mkTerm "frizz_N" ;
lin frizz_V2 = mkTerm "frizz_V2" ;
lin frizzle_V = mkTerm "frizzle_V" ;
lin frizzle_V2 = mkTerm "frizzle_V2" ;
lin frizzy_A = mkTerm "frizzy_A" ;
lin fro_Adv = mkTerm "fro_Adv" ;
lin frock_N = mkTerm "frock_N" ;
lin frock_coat_N = mkTerm "frock_coat_N" ;
lin frodsham_PN = mkTerm "frodsham_PN" ;
lin frog_N = mkTerm "frog_N" ;
lin frogbit_N = mkTerm "frogbit_N" ;
lin frogfish_N = mkTerm "frogfish_N" ;
lin froghopper_N = mkTerm "froghopper_N" ;
lin frogman_N = mkTerm "frogman_N" ;
lin frogmarch_V2 = mkTerm "frogmarch_V2" ;
lin frogmouth_N = mkTerm "frogmouth_N" ;
lin frolic_N = mkTerm "frolic_N" ;
lin frolic_V = mkTerm "frolic_V" ;
lin frolicsome_A = mkTerm "frolicsome_A" ;
lin from_home_Adv = mkTerm "from_home_Adv" ;
lin from_time_to_time_Adv = mkTerm "from_time_to_time_Adv" ;
lin frome_PN = mkTerm "frome_PN" ;
lin frond_N = mkTerm "frond_N" ;
lin front_A = mkTerm "front_A" ;
lin front_N = mkTerm "front_N" ;
lin front_V = mkTerm "front_V" ;
lin front_V2 = mkTerm "front_V2" ;
lin front_bench_N = mkTerm "front_bench_N" ;
lin front_bencher_N = mkTerm "front_bencher_N" ;
lin front_for_V2 = mkTerm "front_for_V2" ;
lin front_off_V2 = mkTerm "front_off_V2" ;
lin front_onto_V2 = mkTerm "front_onto_V2" ;
lin front_out_V2 = mkTerm "front_out_V2" ;
lin front_up_V = mkTerm "front_up_V" ;
lin front_up_V2 = mkTerm "front_up_V2" ;
lin frontage_N = mkTerm "frontage_N" ;
lin frontal_A = mkTerm "frontal_A" ;
lin frontal_N = mkTerm "frontal_N" ;
lin frontier_N = mkTerm "frontier_N" ;
lin frontiersman_N = mkTerm "frontiersman_N" ;
lin frontierswoman_N = mkTerm "frontierswoman_N" ;
lin frontispiece_N = mkTerm "frontispiece_N" ;
lin frontlet_N = mkTerm "frontlet_N" ;
lin frontman_N = mkTerm "frontman_N" ;
lin frore_A = mkTerm "frore_A" ;
lin frost_N = mkTerm "frost_N" ;
lin frost_V = mkTerm "frost_V" ;
lin frost_V2 = mkTerm "frost_V2" ;
lin frost_bound_A = mkTerm "frost_bound_A" ;
lin frostbite_N = mkTerm "frostbite_N" ;
lin frostbitten_A = mkTerm "frostbitten_A" ;
lin frostiness_N = mkTerm "frostiness_N" ;
lin frosting_N = mkTerm "frosting_N" ;
lin frostweed_N = mkTerm "frostweed_N" ;
lin frosty_A = mkTerm "frosty_A" ;
lin froth_N = mkTerm "froth_N" ;
lin froth_V = mkTerm "froth_V" ;
lin frothiness_N = mkTerm "frothiness_N" ;
lin frothy_A = mkTerm "frothy_A" ;
lin frottage_N = mkTerm "frottage_N" ;
lin frotteur_N = mkTerm "frotteur_N" ;
lin froward_A = mkTerm "froward_A" ;
lin froward_Prep = mkTerm "froward_Prep" ;
lin frown_N = mkTerm "frown_N" ;
lin frown_V = mkTerm "frown_V" ;
lin frown_on_V2 = mkTerm "frown_on_V2" ;
lin frowningly_Adv = mkTerm "frowningly_Adv" ;
lin frowsty_A = mkTerm "frowsty_A" ;
lin frowsy_A = mkTerm "frowsy_A" ;
lin frowzy_A = mkTerm "frowzy_A" ;
lin frozen_A = mkTerm "frozen_A" ;
lin frs_N = mkTerm "frs_N" ;
lin fructification_N = mkTerm "fructification_N" ;
lin fructify_V = mkTerm "fructify_V" ;
lin fructify_V2 = mkTerm "fructify_V2" ;
lin fructose_N = mkTerm "fructose_N" ;
lin fructosuria_N = mkTerm "fructosuria_N" ;
lin frugal_A = mkTerm "frugal_A" ;
lin frugality_N = mkTerm "frugality_N" ;
lin fruit_N = mkTerm "fruit_N" ;
lin fruit_V = mkTerm "fruit_V" ;
lin fruit_fly_N = mkTerm "fruit_fly_N" ;
lin fruitage_N = mkTerm "fruitage_N" ;
lin fruitcake_N = mkTerm "fruitcake_N" ;
lin fruiterer_N = mkTerm "fruiterer_N" ;
lin fruitful_A = mkTerm "fruitful_A" ;
lin fruitfulness_N = mkTerm "fruitfulness_N" ;
lin fruition_N = mkTerm "fruition_N" ;
lin fruitless_A = mkTerm "fruitless_A" ;
lin fruitlessness_N = mkTerm "fruitlessness_N" ;
lin fruitlet_N = mkTerm "fruitlet_N" ;
lin fruitwood_N = mkTerm "fruitwood_N" ;
lin fruity_A = mkTerm "fruity_A" ;
lin frumenty_N = mkTerm "frumenty_N" ;
lin frump_N = mkTerm "frump_N" ;
lin frumpish_A = mkTerm "frumpish_A" ;
lin frumpy_A = mkTerm "frumpy_A" ;
lin frustrate_V2 = mkTerm "frustrate_V2" ;
lin frustrating_A = mkTerm "frustrating_A" ;
lin frustration_N = mkTerm "frustration_N" ;
lin frustum_N = mkTerm "frustum_N" ;
lin fry_N = mkTerm "fry_N" ;
lin fry_V = mkTerm "fry_V" ;
lin fry_V2 = mkTerm "fry_V2" ;
lin fry_pan_N = mkTerm "fry_pan_N" ;
lin fryer_N = mkTerm "fryer_N" ;
lin frying_N = mkTerm "frying_N" ;
lin frying_pan_N = mkTerm "frying_pan_N" ;
lin ft_PN = mkTerm "ft_PN" ;
lin fuchsia_N = mkTerm "fuchsia_N" ;
lin fuck_N = mkTerm "fuck_N" ;
lin fuck_V = mkTerm "fuck_V" ;
lin fuck_V2 = mkTerm "fuck_V2" ;
lin fuck_all_N = mkTerm "fuck_all_N" ;
lin fucker_N = mkTerm "fucker_N" ;
lin fucking_A = mkTerm "fucking_A" ;
lin fucking_Adv = mkTerm "fucking_Adv" ;
lin fucking_N = mkTerm "fucking_N" ;
lin fucoid_N = mkTerm "fucoid_N" ;
lin fucus_N = mkTerm "fucus_N" ;
lin fuddle_V2 = mkTerm "fuddle_V2" ;
lin fuddy_duddy_N = mkTerm "fuddy_duddy_N" ;
lin fudge_N = mkTerm "fudge_N" ;
lin fudge_over_V = mkTerm "fudge_over_V" ;
lin fuel_N = mkTerm "fuel_N" ;
lin fuel_V = mkTerm "fuel_V" ;
lin fuel_V2 = mkTerm "fuel_V2" ;
lin fuel_up_V = mkTerm "fuel_up_V" ;
lin fueling_N = mkTerm "fueling_N" ;
lin fug_N = mkTerm "fug_N" ;
lin fugacity_N = mkTerm "fugacity_N" ;
lin fugal_A = mkTerm "fugal_A" ;
lin fuggy_A = mkTerm "fuggy_A" ;
lin fugitive_A = mkTerm "fugitive_A" ;
lin fugitive_N = mkTerm "fugitive_N" ;
lin fugleman_N = mkTerm "fugleman_N" ;
lin fugly_A = mkTerm "fugly_A" ;
lin fugu_N = mkTerm "fugu_N" ;
lin fugue_N = mkTerm "fugue_N" ;
lin fuhrer_N = mkTerm "fuhrer_N" ;
lin fuji_N = mkTerm "fuji_N" ;
lin fulcrum_N = mkTerm "fulcrum_N" ;
lin fulfil_V2 = mkTerm "fulfil_V2" ;
lin fulfill_V2 = mkTerm "fulfill_V2" ;
lin fulfillment_N = mkTerm "fulfillment_N" ;
lin fulfilment_N = mkTerm "fulfilment_N" ;
lin fulgurating_A = mkTerm "fulgurating_A" ;
lin full_A = mkTerm "full_A" ;
lin full_blooded_A = mkTerm "full_blooded_A" ;
lin full_blown_A = mkTerm "full_blown_A" ;
lin full_dress_A = mkTerm "full_dress_A" ;
lin full_fashioned_A = mkTerm "full_fashioned_A" ;
lin full_fledged_A = mkTerm "full_fledged_A" ;
lin full_grown_A = mkTerm "full_grown_A" ;
lin full_length_A = mkTerm "full_length_A" ;
lin full_page_A = mkTerm "full_page_A" ;
lin full_scale_A = mkTerm "full_scale_A" ;
lin full_time_A = mkTerm "full_time_A" ;
lin full_time_Adv = mkTerm "full_time_Adv" ;
lin fullback_N = mkTerm "fullback_N" ;
lin fuller_N = mkTerm "fuller_N" ;
lin fullerene_N = mkTerm "fullerene_N" ;
lin fullness_N = mkTerm "fullness_N" ;
lin fully_Adv = mkTerm "fully_Adv" ;
lin fully_fashioned_A = mkTerm "fully_fashioned_A" ;
lin fully_fledged_A = mkTerm "fully_fledged_A" ;
lin fully_grown_A = mkTerm "fully_grown_A" ;
lin fulmar_N = mkTerm "fulmar_N" ;
lin fulminant_A = mkTerm "fulminant_A" ;
lin fulminate_N = mkTerm "fulminate_N" ;
lin fulminate_V = mkTerm "fulminate_V" ;
lin fulmination_N = mkTerm "fulmination_N" ;
lin fulsome_A = mkTerm "fulsome_A" ;
lin fulsomeness_N = mkTerm "fulsomeness_N" ;
lin fumble_N = mkTerm "fumble_N" ;
lin fumble_V = mkTerm "fumble_V" ;
lin fumble_V2 = mkTerm "fumble_V2" ;
lin fumbler_N = mkTerm "fumbler_N" ;
lin fume_N = mkTerm "fume_N" ;
lin fume_V = mkTerm "fume_V" ;
lin fume_V2 = mkTerm "fume_V2" ;
lin fume_VS = mkTerm "fume_VS" ;
lin fumewort_N = mkTerm "fumewort_N" ;
lin fumigant_N = mkTerm "fumigant_N" ;
lin fumigate_V2 = mkTerm "fumigate_V2" ;
lin fumigation_N = mkTerm "fumigation_N" ;
lin fumigator_N = mkTerm "fumigator_N" ;
lin fumitory_N = mkTerm "fumitory_N" ;
lin fun_A = mkTerm "fun_A" ;
lin fun_N = mkTerm "fun_N" ;
lin funambulism_N = mkTerm "funambulism_N" ;
lin funambulistFem_N = mkTerm "funambulistFem_N" ;
lin funambulistMasc_N = mkTerm "funambulistMasc_N" ;
lin function_N = mkTerm "function_N" ;
lin function_V = mkTerm "function_V" ;
lin functional_A = mkTerm "functional_A" ;
lin functionalism_N = mkTerm "functionalism_N" ;
lin functionalist_N = mkTerm "functionalist_N" ;
lin functionality_N = mkTerm "functionality_N" ;
lin functionary_N = mkTerm "functionary_N" ;
lin functor_N = mkTerm "functor_N" ;
lin fund_N = mkTerm "fund_N" ;
lin fund_V2 = mkTerm "fund_V2" ;
lin fundamental_A = mkTerm "fundamental_A" ;
lin fundamental_N = mkTerm "fundamental_N" ;
lin fundamentalism_N = mkTerm "fundamentalism_N" ;
lin fundamentalist_A = mkTerm "fundamentalist_A" ;
lin fundamentalist_N = mkTerm "fundamentalist_N" ;
lin fundamentals_N = mkTerm "fundamentals_N" ;
lin funding_N = mkTerm "funding_N" ;
lin fundraiser_N = mkTerm "fundraiser_N" ;
lin fundraising_N = mkTerm "fundraising_N" ;
lin funds_N = mkTerm "funds_N" ;
lin fundus_N = mkTerm "fundus_N" ;
lin funeral_N = mkTerm "funeral_N" ;
lin funerary_A = mkTerm "funerary_A" ;
lin funereal_A = mkTerm "funereal_A" ;
lin funfair_N = mkTerm "funfair_N" ;
lin fungal_A = mkTerm "fungal_A" ;
lin fungible_A = mkTerm "fungible_A" ;
lin fungible_N = mkTerm "fungible_N" ;
lin fungicidal_A = mkTerm "fungicidal_A" ;
lin fungicide_N = mkTerm "fungicide_N" ;
lin fungoid_A = mkTerm "fungoid_A" ;
lin fungous_A = mkTerm "fungous_A" ;
lin fungus_N = mkTerm "fungus_N" ;
lin funicle_N = mkTerm "funicle_N" ;
lin funicular_A = mkTerm "funicular_A" ;
lin funicular_N = mkTerm "funicular_N" ;
lin funiculitis_N = mkTerm "funiculitis_N" ;
lin funiculus_N = mkTerm "funiculus_N" ;
lin funk_N = mkTerm "funk_N" ;
lin funk_V = mkTerm "funk_V" ;
lin funk_V2 = mkTerm "funk_V2" ;
lin funky_A = mkTerm "funky_A" ;
lin funnel_N = mkTerm "funnel_N" ;
lin funnel_V = mkTerm "funnel_V" ;
lin funnel_V2 = mkTerm "funnel_V2" ;
lin funniness_N = mkTerm "funniness_N" ;
lin funny_A = mkTerm "funny_A" ;
lin funny_bone_N = mkTerm "funny_bone_N" ;
lin funrun_N = mkTerm "funrun_N" ;
lin fur_N = mkTerm "fur_N" ;
lin furan_N = mkTerm "furan_N" ;
lin furbelow_N = mkTerm "furbelow_N" ;
lin furbish_V2 = mkTerm "furbish_V2" ;
lin furcation_N = mkTerm "furcation_N" ;
lin furcula_N = mkTerm "furcula_N" ;
lin furfural_N = mkTerm "furfural_N" ;
lin furious_A = mkTerm "furious_A" ;
lin furl_V = mkTerm "furl_V" ;
lin furl_V2 = mkTerm "furl_V2" ;
lin furlike_A = mkTerm "furlike_A" ;
lin furlong_N = mkTerm "furlong_N" ;
lin furlough_N = mkTerm "furlough_N" ;
lin furnace_N = mkTerm "furnace_N" ;
lin furnish_V2 = mkTerm "furnish_V2" ;
lin furnishing_N = mkTerm "furnishing_N" ;
lin furniture_N = mkTerm "furniture_N" ;
lin furore_N = mkTerm "furore_N" ;
lin furosemide_N = mkTerm "furosemide_N" ;
lin furred_A = mkTerm "furred_A" ;
lin furrier_N = mkTerm "furrier_N" ;
lin furring_N = mkTerm "furring_N" ;
lin furrow_N = mkTerm "furrow_N" ;
lin furrow_V = mkTerm "furrow_V" ;
lin furrow_V2 = mkTerm "furrow_V2" ;
lin furry_A = mkTerm "furry_A" ;
lin furth_PN = mkTerm "furth_PN" ;
lin further_A = mkTerm "further_A" ;
lin further_AdV = mkTerm "further_AdV" ;
lin further_Adv = mkTerm "further_Adv" ;
lin further_V2 = mkTerm "further_V2" ;
lin furtherance_N = mkTerm "furtherance_N" ;
lin furthermore_Adv = mkTerm "furthermore_Adv" ;
lin furthermost_A = mkTerm "furthermost_A" ;
lin furthest_A = mkTerm "furthest_A" ;
lin furthest_Adv = mkTerm "furthest_Adv" ;
lin furtive_A = mkTerm "furtive_A" ;
lin furtiveness_N = mkTerm "furtiveness_N" ;
lin furunculosis_N = mkTerm "furunculosis_N" ;
lin fury_N = mkTerm "fury_N" ;
lin furze_N = mkTerm "furze_N" ;
lin fuschia_N = mkTerm "fuschia_N" ;
lin fuscous_A = mkTerm "fuscous_A" ;
lin fuse_N = mkTerm "fuse_N" ;
lin fuse_V = mkTerm "fuse_V" ;
lin fuse_V2 = mkTerm "fuse_V2" ;
lin fusee_N = mkTerm "fusee_N" ;
lin fuselage_N = mkTerm "fuselage_N" ;
lin fushun_PN = mkTerm "fushun_PN" ;
lin fusible_A = mkTerm "fusible_A" ;
lin fusiform_A = mkTerm "fusiform_A" ;
lin fusil_N = mkTerm "fusil_N" ;
lin fusilier_N = mkTerm "fusilier_N" ;
lin fusillade_N = mkTerm "fusillade_N" ;
lin fusion_N = mkTerm "fusion_N" ;
lin fuss_N = mkTerm "fuss_N" ;
lin fuss_V = mkTerm "fuss_V" ;
lin fuss_V2 = mkTerm "fuss_V2" ;
lin fussiness_N = mkTerm "fussiness_N" ;
lin fusspot_N = mkTerm "fusspot_N" ;
lin fussy_A = mkTerm "fussy_A" ;
lin fustian_N = mkTerm "fustian_N" ;
lin fusty_A = mkTerm "fusty_A" ;
lin futile_A = mkTerm "futile_A" ;
lin futility_N = mkTerm "futility_N" ;
lin futon_N = mkTerm "futon_N" ;
lin future_1_N = mkTerm "future_1_N" ;
lin future_3_N = mkTerm "future_3_N" ;
lin future_A = mkTerm "future_A" ;
lin futureless_A = mkTerm "futureless_A" ;
lin futurism_N = mkTerm "futurism_N" ;
lin futuristFem_N = mkTerm "futuristFem_N" ;
lin futuristMasc_N = mkTerm "futuristMasc_N" ;
lin futuristic_A = mkTerm "futuristic_A" ;
lin futurity_N = mkTerm "futurity_N" ;
lin futurology_N = mkTerm "futurology_N" ;
lin fuze_N = mkTerm "fuze_N" ;
lin fuzz_N = mkTerm "fuzz_N" ;
lin fuzzed_A = mkTerm "fuzzed_A" ;
lin fuzzy_A = mkTerm "fuzzy_A" ;
lin fwd_PN = mkTerm "fwd_PN" ;
lin g_N = mkTerm "g_N" ;
lin g_man_N = mkTerm "g_man_N" ;
lin gab_N = mkTerm "gab_N" ;
lin gabapentin_N = mkTerm "gabapentin_N" ;
lin gabardine_N = mkTerm "gabardine_N" ;
lin gabble_N = mkTerm "gabble_N" ;
lin gabble_V = mkTerm "gabble_V" ;
lin gabble_V2 = mkTerm "gabble_V2" ;
lin gabbro_N = mkTerm "gabbro_N" ;
lin gaberdine_N = mkTerm "gaberdine_N" ;
lin gable_N = mkTerm "gable_N" ;
lin gabled_A = mkTerm "gabled_A" ;
lin gabon_PN = mkTerm "gabon_PN" ;
lin gabonese_A = mkTerm "gabonese_A" ;
lin gabonese_N = mkTerm "gabonese_N" ;
lin gad_V = mkTerm "gad_V" ;
lin gad_about_V = mkTerm "gad_about_V" ;
lin gad_around_V = mkTerm "gad_around_V" ;
lin gadabout_N = mkTerm "gadabout_N" ;
lin gaddi_N = mkTerm "gaddi_N" ;
lin gadfly_N = mkTerm "gadfly_N" ;
lin gadget_N = mkTerm "gadget_N" ;
lin gadgeteer_N = mkTerm "gadgeteer_N" ;
lin gadgetry_N = mkTerm "gadgetry_N" ;
lin gadoid_N = mkTerm "gadoid_N" ;
lin gadolinite_N = mkTerm "gadolinite_N" ;
lin gadolinium_N = mkTerm "gadolinium_N" ;
lin gael_N = mkTerm "gael_N" ;
lin gaelic_A = mkTerm "gaelic_A" ;
lin gaelic_N = mkTerm "gaelic_N" ;
lin gaff_N = mkTerm "gaff_N" ;
lin gaffe_N = mkTerm "gaffe_N" ;
lin gaffer_N = mkTerm "gaffer_N" ;
lin gaffsail_N = mkTerm "gaffsail_N" ;
lin gag_N = mkTerm "gag_N" ;
lin gag_V = mkTerm "gag_V" ;
lin gag_V2 = mkTerm "gag_V2" ;
lin gag_for_V2 = mkTerm "gag_for_V2" ;
lin gaga_A = mkTerm "gaga_A" ;
lin gage_N = mkTerm "gage_N" ;
lin gage_V2 = mkTerm "gage_V2" ;
lin gaggle_N = mkTerm "gaggle_N" ;
lin gagman_N = mkTerm "gagman_N" ;
lin gaiety_N = mkTerm "gaiety_N" ;
lin gaillardia_N = mkTerm "gaillardia_N" ;
lin gain_N = mkTerm "gain_N" ;
lin gain_V = mkTerm "gain_V" ;
lin gain_V2 = mkTerm "gain_V2" ;
lin gain_back_V = mkTerm "gain_back_V" ;
lin gainer_N = mkTerm "gainer_N" ;
lin gainful_A = mkTerm "gainful_A" ;
lin gainly_A = mkTerm "gainly_A" ;
lin gainsay_V2 = mkTerm "gainsay_V2" ;
lin gainsborough_N = mkTerm "gainsborough_N" ;
lin gainsborough_PN = mkTerm "gainsborough_PN" ;
lin gait_N = mkTerm "gait_N" ;
lin gaiter_N = mkTerm "gaiter_N" ;
lin gal_N = mkTerm "gal_N" ;
lin gala_N = mkTerm "gala_N" ;
lin galactagogue_N = mkTerm "galactagogue_N" ;
lin galactic_A = mkTerm "galactic_A" ;
lin galactocele_N = mkTerm "galactocele_N" ;
lin galactose_N = mkTerm "galactose_N" ;
lin galactosemia_N = mkTerm "galactosemia_N" ;
lin galactosis_N = mkTerm "galactosis_N" ;
lin galago_N = mkTerm "galago_N" ;
lin galangal_N = mkTerm "galangal_N" ;
lin galantine_N = mkTerm "galantine_N" ;
lin galashiels_PN = mkTerm "galashiels_PN" ;
lin galax_N = mkTerm "galax_N" ;
lin galaxy_N = mkTerm "galaxy_N" ;
lin galbanum_N = mkTerm "galbanum_N" ;
lin galbulus_N = mkTerm "galbulus_N" ;
lin gale_N = mkTerm "gale_N" ;
lin galea_N = mkTerm "galea_N" ;
lin galena_N = mkTerm "galena_N" ;
lin galere_N = mkTerm "galere_N" ;
lin galingale_N = mkTerm "galingale_N" ;
lin gall_N = mkTerm "gall_N" ;
lin gall_V2 = mkTerm "gall_V2" ;
lin gallamine_N = mkTerm "gallamine_N" ;
lin gallant_A = mkTerm "gallant_A" ;
lin gallant_N = mkTerm "gallant_N" ;
lin gallantry_N = mkTerm "gallantry_N" ;
lin gallbladder_N = mkTerm "gallbladder_N" ;
lin galleon_N = mkTerm "galleon_N" ;
lin gallery_N = mkTerm "gallery_N" ;
lin galley_N = mkTerm "galley_N" ;
lin galley_proof_N = mkTerm "galley_proof_N" ;
lin galley_slave_N = mkTerm "galley_slave_N" ;
lin gallfly_N = mkTerm "gallfly_N" ;
lin gallic_A = mkTerm "gallic_A" ;
lin gallicism_N = mkTerm "gallicism_N" ;
lin gallinaceous_A = mkTerm "gallinaceous_A" ;
lin gallinule_N = mkTerm "gallinule_N" ;
lin gallium_N = mkTerm "gallium_N" ;
lin gallivant_V = mkTerm "gallivant_V" ;
lin gallon_N = mkTerm "gallon_N" ;
lin gallop_N = mkTerm "gallop_N" ;
lin gallop_V = mkTerm "gallop_V" ;
lin gallop_V2 = mkTerm "gallop_V2" ;
lin galloway_PN = mkTerm "galloway_PN" ;
lin gallows_N = mkTerm "gallows_N" ;
lin gallows_bird_N = mkTerm "gallows_bird_N" ;
lin gallstone_N = mkTerm "gallstone_N" ;
lin gallup_PN = mkTerm "gallup_PN" ;
lin galoot_N = mkTerm "galoot_N" ;
lin galore_Adv = mkTerm "galore_Adv" ;
lin galosh_N = mkTerm "galosh_N" ;
lin galumph_V = mkTerm "galumph_V" ;
lin galvanic_A = mkTerm "galvanic_A" ;
lin galvanism_N = mkTerm "galvanism_N" ;
lin galvanization_N = mkTerm "galvanization_N" ;
lin galvanize_V2 = mkTerm "galvanize_V2" ;
lin galvanize_VS = mkTerm "galvanize_VS" ;
lin galvanizer_N = mkTerm "galvanizer_N" ;
lin galvanometer_N = mkTerm "galvanometer_N" ;
lin galway_PN = mkTerm "galway_PN" ;
lin gam_N = mkTerm "gam_N" ;
lin gambia_PN = mkTerm "gambia_PN" ;
lin gambian_A = mkTerm "gambian_A" ;
lin gambian_N = mkTerm "gambian_N" ;
lin gambist_N = mkTerm "gambist_N" ;
lin gambit_N = mkTerm "gambit_N" ;
lin gamble_N = mkTerm "gamble_N" ;
lin gamble_V = mkTerm "gamble_V" ;
lin gamble_V2 = mkTerm "gamble_V2" ;
lin gambler_N = mkTerm "gambler_N" ;
lin gambling_N = mkTerm "gambling_N" ;
lin gambling_den_N = mkTerm "gambling_den_N" ;
lin gamboge_N = mkTerm "gamboge_N" ;
lin gambol_N = mkTerm "gambol_N" ;
lin gambol_V = mkTerm "gambol_V" ;
lin gambrel_N = mkTerm "gambrel_N" ;
lin game_1_N = mkTerm "game_1_N" ;
lin game_2_N = mkTerm "game_2_N" ;
lin game_3_N = mkTerm "game_3_N" ;
lin game_A = mkTerm "game_A" ;
lin game_V = mkTerm "game_V" ;
lin game_V2 = mkTerm "game_V2" ;
lin game_bag_N = mkTerm "game_bag_N" ;
lin game_bird_N = mkTerm "game_bird_N" ;
lin game_licence_N = mkTerm "game_licence_N" ;
lin gamecock_N = mkTerm "gamecock_N" ;
lin gamekeeper_N = mkTerm "gamekeeper_N" ;
lin gamelan_N = mkTerm "gamelan_N" ;
lin gameplay_N = mkTerm "gameplay_N" ;
lin games_master_N = mkTerm "games_master_N" ;
lin games_mistress_N = mkTerm "games_mistress_N" ;
lin gamesmanship_N = mkTerm "gamesmanship_N" ;
lin gametangium_N = mkTerm "gametangium_N" ;
lin gamete_N = mkTerm "gamete_N" ;
lin gametocyte_N = mkTerm "gametocyte_N" ;
lin gametoecium_N = mkTerm "gametoecium_N" ;
lin gametogenesis_N = mkTerm "gametogenesis_N" ;
lin gametophore_N = mkTerm "gametophore_N" ;
lin gametophyte_N = mkTerm "gametophyte_N" ;
lin gamey_A = mkTerm "gamey_A" ;
lin gamine_N = mkTerm "gamine_N" ;
lin gaminess_N = mkTerm "gaminess_N" ;
lin gaming_N = mkTerm "gaming_N" ;
lin gaming_house_N = mkTerm "gaming_house_N" ;
lin gaming_table_N = mkTerm "gaming_table_N" ;
lin gamma_N = mkTerm "gamma_N" ;
lin gammon_N = mkTerm "gammon_N" ;
lin gammopathy_N = mkTerm "gammopathy_N" ;
lin gammy_A = mkTerm "gammy_A" ;
lin gamopetalous_A = mkTerm "gamopetalous_A" ;
lin gamp_N = mkTerm "gamp_N" ;
lin gamut_N = mkTerm "gamut_N" ;
lin gamy_A = mkTerm "gamy_A" ;
lin gander_N = mkTerm "gander_N" ;
lin gang_N = mkTerm "gang_N" ;
lin gang_V = mkTerm "gang_V" ;
lin gang_up_V = mkTerm "gang_up_V" ;
lin gang_up_against_V2 = mkTerm "gang_up_against_V2" ;
lin gang_up_on_V2 = mkTerm "gang_up_on_V2" ;
lin ganger_N = mkTerm "ganger_N" ;
lin gangling_A = mkTerm "gangling_A" ;
lin ganglion_N = mkTerm "ganglion_N" ;
lin gangplank_N = mkTerm "gangplank_N" ;
lin gangrene_N = mkTerm "gangrene_N" ;
lin gangrene_V = mkTerm "gangrene_V" ;
lin gangrene_V2 = mkTerm "gangrene_V2" ;
lin gangrenous_A = mkTerm "gangrenous_A" ;
lin gangsaw_N = mkTerm "gangsaw_N" ;
lin gangsta_N = mkTerm "gangsta_N" ;
lin gangster_N = mkTerm "gangster_N" ;
lin gangway_N = mkTerm "gangway_N" ;
lin gannet_N = mkTerm "gannet_N" ;
lin ganoid_N = mkTerm "ganoid_N" ;
lin ganoin_N = mkTerm "ganoin_N" ;
lin gantlet_N = mkTerm "gantlet_N" ;
lin gantry_N = mkTerm "gantry_N" ;
lin gaol_N = mkTerm "gaol_N" ;
lin gaol_V2 = mkTerm "gaol_V2" ;
lin gaolbird_N = mkTerm "gaolbird_N" ;
lin gaolbreak_N = mkTerm "gaolbreak_N" ;
lin gaoler_N = mkTerm "gaoler_N" ;
lin gap_N = mkTerm "gap_N" ;
lin gap_toothed_A = mkTerm "gap_toothed_A" ;
lin gape_N = mkTerm "gape_N" ;
lin gape_V = mkTerm "gape_V" ;
lin gar_N = mkTerm "gar_N" ;
lin garage_N = mkTerm "garage_N" ;
lin garage_V2 = mkTerm "garage_V2" ;
lin garambulla_N = mkTerm "garambulla_N" ;
lin garb_N = mkTerm "garb_N" ;
lin garb_V2 = mkTerm "garb_V2" ;
lin garbage_N = mkTerm "garbage_N" ;
lin garbage_can_N = mkTerm "garbage_can_N" ;
lin garble_V2 = mkTerm "garble_V2" ;
lin garboard_N = mkTerm "garboard_N" ;
lin garbology_N = mkTerm "garbology_N" ;
lin garden_N = mkTerm "garden_N" ;
lin garden_V = mkTerm "garden_V" ;
lin garden_truck_N = mkTerm "garden_truck_N" ;
lin gardenerFem_N = mkTerm "gardenerFem_N" ;
lin gardenerMasc_N = mkTerm "gardenerMasc_N" ;
lin gardenia_N = mkTerm "gardenia_N" ;
lin gardening_N = mkTerm "gardening_N" ;
lin gareth_PN = mkTerm "gareth_PN" ;
lin garforth_PN = mkTerm "garforth_PN" ;
lin garganey_N = mkTerm "garganey_N" ;
lin gargantuan_A = mkTerm "gargantuan_A" ;
lin gargle_N = mkTerm "gargle_N" ;
lin gargle_V = mkTerm "gargle_V" ;
lin gargle_V2 = mkTerm "gargle_V2" ;
lin gargoyle_N = mkTerm "gargoyle_N" ;
lin garibaldi_N = mkTerm "garibaldi_N" ;
lin garish_A = mkTerm "garish_A" ;
lin garishness_N = mkTerm "garishness_N" ;
lin garland_N = mkTerm "garland_N" ;
lin garland_V2 = mkTerm "garland_V2" ;
lin garlic_N = mkTerm "garlic_N" ;
lin garlicky_A = mkTerm "garlicky_A" ;
lin garment_N = mkTerm "garment_N" ;
lin garmentmaker_N = mkTerm "garmentmaker_N" ;
lin garner_N = mkTerm "garner_N" ;
lin garner_V2 = mkTerm "garner_V2" ;
lin garnet_N = mkTerm "garnet_N" ;
lin garnierite_N = mkTerm "garnierite_N" ;
lin garnish_N = mkTerm "garnish_N" ;
lin garnish_V2 = mkTerm "garnish_V2" ;
lin garnishee_N = mkTerm "garnishee_N" ;
lin garnishment_N = mkTerm "garnishment_N" ;
lin garotte_N = mkTerm "garotte_N" ;
lin garret_N = mkTerm "garret_N" ;
lin garrison_N = mkTerm "garrison_N" ;
lin garrison_V2 = mkTerm "garrison_V2" ;
lin garrote_N = mkTerm "garrote_N" ;
lin garroter_N = mkTerm "garroter_N" ;
lin garrotte_N = mkTerm "garrotte_N" ;
lin garrotte_V2 = mkTerm "garrotte_V2" ;
lin garrowhill_PN = mkTerm "garrowhill_PN" ;
lin garrulity_N = mkTerm "garrulity_N" ;
lin garrulous_A = mkTerm "garrulous_A" ;
lin garter_N = mkTerm "garter_N" ;
lin gary_PN = mkTerm "gary_PN" ;
lin gas_N = mkTerm "gas_N" ;
lin gas_V = mkTerm "gas_V" ;
lin gas_V2 = mkTerm "gas_V2" ;
lin gas_bracket_N = mkTerm "gas_bracket_N" ;
lin gas_cooker_N = mkTerm "gas_cooker_N" ;
lin gas_engine_N = mkTerm "gas_engine_N" ;
lin gas_fitter_N = mkTerm "gas_fitter_N" ;
lin gas_helmet_N = mkTerm "gas_helmet_N" ;
lin gas_holder_N = mkTerm "gas_holder_N" ;
lin gas_mask_N = mkTerm "gas_mask_N" ;
lin gas_meter_N = mkTerm "gas_meter_N" ;
lin gas_oven_N = mkTerm "gas_oven_N" ;
lin gas_ring_N = mkTerm "gas_ring_N" ;
lin gas_station_N = mkTerm "gas_station_N" ;
lin gas_stove_N = mkTerm "gas_stove_N" ;
lin gasbag_N = mkTerm "gasbag_N" ;
lin gaseous_A = mkTerm "gaseous_A" ;
lin gaseousness_N = mkTerm "gaseousness_N" ;
lin gasfield_N = mkTerm "gasfield_N" ;
lin gash_N = mkTerm "gash_N" ;
lin gash_V2 = mkTerm "gash_V2" ;
lin gasification_N = mkTerm "gasification_N" ;
lin gasify_V = mkTerm "gasify_V" ;
lin gasify_V2 = mkTerm "gasify_V2" ;
lin gasket_N = mkTerm "gasket_N" ;
lin gaskin_N = mkTerm "gaskin_N" ;
lin gaslight_N = mkTerm "gaslight_N" ;
lin gasman_N = mkTerm "gasman_N" ;
lin gasohol_N = mkTerm "gasohol_N" ;
lin gasolene_N = mkTerm "gasolene_N" ;
lin gasoline_N = mkTerm "gasoline_N" ;
lin gasometer_N = mkTerm "gasometer_N" ;
lin gasp_N = mkTerm "gasp_N" ;
lin gasp_V = mkTerm "gasp_V" ;
lin gasp_V2 = mkTerm "gasp_V2" ;
lin gassing_N = mkTerm "gassing_N" ;
lin gassy_A = mkTerm "gassy_A" ;
lin gasteromycete_N = mkTerm "gasteromycete_N" ;
lin gastrectomy_N = mkTerm "gastrectomy_N" ;
lin gastric_A = mkTerm "gastric_A" ;
lin gastrin_N = mkTerm "gastrin_N" ;
lin gastritis_N = mkTerm "gastritis_N" ;
lin gastrocnemius_N = mkTerm "gastrocnemius_N" ;
lin gastroduodenal_A = mkTerm "gastroduodenal_A" ;
lin gastroenteritis_N = mkTerm "gastroenteritis_N" ;
lin gastroenterologistFem_N = mkTerm "gastroenterologistFem_N" ;
lin gastroenterologistMasc_N = mkTerm "gastroenterologistMasc_N" ;
lin gastroenterology_N = mkTerm "gastroenterology_N" ;
lin gastroenterostomy_N = mkTerm "gastroenterostomy_N" ;
lin gastroesophageal_A = mkTerm "gastroesophageal_A" ;
lin gastrogavage_N = mkTerm "gastrogavage_N" ;
lin gastrointestinal_A = mkTerm "gastrointestinal_A" ;
lin gastromy_N = mkTerm "gastromy_N" ;
lin gastronomic_A = mkTerm "gastronomic_A" ;
lin gastronomy_N = mkTerm "gastronomy_N" ;
lin gastropod_N = mkTerm "gastropod_N" ;
lin gastroscope_N = mkTerm "gastroscope_N" ;
lin gastroscopy_N = mkTerm "gastroscopy_N" ;
lin gastrostomy_N = mkTerm "gastrostomy_N" ;
lin gastrula_N = mkTerm "gastrula_N" ;
lin gastrulation_N = mkTerm "gastrulation_N" ;
lin gasworks_N = mkTerm "gasworks_N" ;
lin gat_N = mkTerm "gat_N" ;
lin gate_N = mkTerm "gate_N" ;
lin gate_V2 = mkTerm "gate_V2" ;
lin gateau_N = mkTerm "gateau_N" ;
lin gatecrash_V2 = mkTerm "gatecrash_V2" ;
lin gatecrasher_N = mkTerm "gatecrasher_N" ;
lin gatehouse_N = mkTerm "gatehouse_N" ;
lin gatekeeper_N = mkTerm "gatekeeper_N" ;
lin gatepost_N = mkTerm "gatepost_N" ;
lin gateshead_PN = mkTerm "gateshead_PN" ;
lin gateway_N = mkTerm "gateway_N" ;
lin gather_N = mkTerm "gather_N" ;
lin gather_V = mkTerm "gather_V" ;
lin gather_V2 = mkTerm "gather_V2" ;
lin gatherer_N = mkTerm "gatherer_N" ;
lin gathering_N = mkTerm "gathering_N" ;
lin gatt_N = mkTerm "gatt_N" ;
lin gauche_A = mkTerm "gauche_A" ;
lin gaucherie_N = mkTerm "gaucherie_N" ;
lin gaucho_N = mkTerm "gaucho_N" ;
lin gaud_N = mkTerm "gaud_N" ;
lin gaudery_N = mkTerm "gaudery_N" ;
lin gaudy_A = mkTerm "gaudy_A" ;
lin gaudy_N = mkTerm "gaudy_N" ;
lin gauge_N = mkTerm "gauge_N" ;
lin gauge_V2 = mkTerm "gauge_V2" ;
lin gaul_N = mkTerm "gaul_N" ;
lin gaumless_A = mkTerm "gaumless_A" ;
lin gaunt_A = mkTerm "gaunt_A" ;
lin gauntlet_N = mkTerm "gauntlet_N" ;
lin gauntleted_A = mkTerm "gauntleted_A" ;
lin gauntness_N = mkTerm "gauntness_N" ;
lin gaur_N = mkTerm "gaur_N" ;
lin gauss_N = mkTerm "gauss_N" ;
lin gauze_N = mkTerm "gauze_N" ;
lin gauzy_A = mkTerm "gauzy_A" ;
lin gavel_N = mkTerm "gavel_N" ;
lin gavial_N = mkTerm "gavial_N" ;
lin gavin_PN = mkTerm "gavin_PN" ;
lin gavotte_N = mkTerm "gavotte_N" ;
lin gawk_N = mkTerm "gawk_N" ;
lin gawker_N = mkTerm "gawker_N" ;
lin gawkiness_N = mkTerm "gawkiness_N" ;
lin gawky_A = mkTerm "gawky_A" ;
lin gawp_V = mkTerm "gawp_V" ;
lin gay_A = mkTerm "gay_A" ;
lin gay_N = mkTerm "gay_N" ;
lin gayal_N = mkTerm "gayal_N" ;
lin gayness_N = mkTerm "gayness_N" ;
lin gazania_N = mkTerm "gazania_N" ;
lin gaze_N = mkTerm "gaze_N" ;
lin gaze_V = mkTerm "gaze_V" ;
lin gazebo_N = mkTerm "gazebo_N" ;
lin gazelle_N = mkTerm "gazelle_N" ;
lin gazette_N = mkTerm "gazette_N" ;
lin gazette_V2 = mkTerm "gazette_V2" ;
lin gazetteer_N = mkTerm "gazetteer_N" ;
lin gazpacho_N = mkTerm "gazpacho_N" ;
lin gazump_V = mkTerm "gazump_V" ;
lin gazump_V2 = mkTerm "gazump_V2" ;
lin gb_PN = mkTerm "gb_PN" ;
lin gcse_N = mkTerm "gcse_N" ;
lin gcses_N = mkTerm "gcses_N" ;
lin gdansk_PN = mkTerm "gdansk_PN" ;
lin gdn_PN = mkTerm "gdn_PN" ;
lin gdns_PN = mkTerm "gdns_PN" ;
lin gean_N = mkTerm "gean_N" ;
lin gear_N = mkTerm "gear_N" ;
lin gear_V = mkTerm "gear_V" ;
lin gear_V2 = mkTerm "gear_V2" ;
lin gear_case_N = mkTerm "gear_case_N" ;
lin gear_to_V2 = mkTerm "gear_to_V2" ;
lin gear_towards_V2 = mkTerm "gear_towards_V2" ;
lin gear_up_V = mkTerm "gear_up_V" ;
lin gearbox_N = mkTerm "gearbox_N" ;
lin gearing_N = mkTerm "gearing_N" ;
lin gearset_N = mkTerm "gearset_N" ;
lin gearshift_N = mkTerm "gearshift_N" ;
lin gecko_N = mkTerm "gecko_N" ;
lin gee_gee_N = mkTerm "gee_gee_N" ;
lin geebung_N = mkTerm "geebung_N" ;
lin geek_N = mkTerm "geek_N" ;
lin geek_out_V = mkTerm "geek_out_V" ;
lin geezer_N = mkTerm "geezer_N" ;
lin geiger_N = mkTerm "geiger_N" ;
lin geisha_N = mkTerm "geisha_N" ;
lin gel_N = mkTerm "gel_N" ;
lin gel_V = mkTerm "gel_V" ;
lin gelatin_N = mkTerm "gelatin_N" ;
lin gelatine_N = mkTerm "gelatine_N" ;
lin gelatinous_A = mkTerm "gelatinous_A" ;
lin gelatinousness_N = mkTerm "gelatinousness_N" ;
lin geld_V2 = mkTerm "geld_V2" ;
lin gelding_N = mkTerm "gelding_N" ;
lin gelechiid_N = mkTerm "gelechiid_N" ;
lin gelignite_N = mkTerm "gelignite_N" ;
lin gelligaer_PN = mkTerm "gelligaer_PN" ;
lin gelsenkirchen_PN = mkTerm "gelsenkirchen_PN" ;
lin gem_N = mkTerm "gem_N" ;
lin gemfibrozil_N = mkTerm "gemfibrozil_N" ;
lin geminate_N = mkTerm "geminate_N" ;
lin gemination_N = mkTerm "gemination_N" ;
lin gemini_PN = mkTerm "gemini_PN" ;
lin gemma_N = mkTerm "gemma_N" ;
lin gemmed_A = mkTerm "gemmed_A" ;
lin gemmiferous_A = mkTerm "gemmiferous_A" ;
lin gemmule_N = mkTerm "gemmule_N" ;
lin gempylid_N = mkTerm "gempylid_N" ;
lin gemsbok_N = mkTerm "gemsbok_N" ;
lin gen_N = mkTerm "gen_N" ;
lin gen_PN = mkTerm "gen_PN" ;
lin gen_V2 = mkTerm "gen_V2" ;
lin gendarme_N = mkTerm "gendarme_N" ;
lin gendarmerie_N = mkTerm "gendarmerie_N" ;
lin gender_1_N = mkTerm "gender_1_N" ;
lin gender_2_N = mkTerm "gender_2_N" ;
lin gene_N = mkTerm "gene_N" ;
lin gene_PN = mkTerm "gene_PN" ;
lin genealogic_A = mkTerm "genealogic_A" ;
lin genealogical_A = mkTerm "genealogical_A" ;
lin genealogist_N = mkTerm "genealogist_N" ;
lin genealogy_N = mkTerm "genealogy_N" ;
lin general_A = mkTerm "general_A" ;
lin general_N = mkTerm "general_N" ;
lin generalissimo_N = mkTerm "generalissimo_N" ;
lin generality_N = mkTerm "generality_N" ;
lin generalization_N = mkTerm "generalization_N" ;
lin generalize_V = mkTerm "generalize_V" ;
lin generalize_V2 = mkTerm "generalize_V2" ;
lin generally_Adv = mkTerm "generally_Adv" ;
lin generalship_N = mkTerm "generalship_N" ;
lin generate_V2 = mkTerm "generate_V2" ;
lin generation_N = mkTerm "generation_N" ;
lin generational_A = mkTerm "generational_A" ;
lin generative_A = mkTerm "generative_A" ;
lin generator_N = mkTerm "generator_N" ;
lin generic_A = mkTerm "generic_A" ;
lin generic_N = mkTerm "generic_N" ;
lin generosity_N = mkTerm "generosity_N" ;
lin generous_A = mkTerm "generous_A" ;
lin genesis_N = mkTerm "genesis_N" ;
lin genet_N = mkTerm "genet_N" ;
lin genetic_A = mkTerm "genetic_A" ;
lin geneticism_N = mkTerm "geneticism_N" ;
lin geneticist_N = mkTerm "geneticist_N" ;
lin genetics_N = mkTerm "genetics_N" ;
lin geneva_N = mkTerm "geneva_N" ;
lin geneva_PN = mkTerm "geneva_PN" ;
lin genial_A = mkTerm "genial_A" ;
lin geniality_N = mkTerm "geniality_N" ;
lin genic_A = mkTerm "genic_A" ;
lin geniculate_A = mkTerm "geniculate_A" ;
lin genie_N = mkTerm "genie_N" ;
lin genip_N = mkTerm "genip_N" ;
lin genipa_N = mkTerm "genipa_N" ;
lin genipap_N = mkTerm "genipap_N" ;
lin genital_A = mkTerm "genital_A" ;
lin genitalia_N = mkTerm "genitalia_N" ;
lin genitive_A = mkTerm "genitive_A" ;
lin genitive_N = mkTerm "genitive_N" ;
lin genitor_N = mkTerm "genitor_N" ;
lin genitourinary_A = mkTerm "genitourinary_A" ;
lin genius_N = mkTerm "genius_N" ;
lin genius_loci_N = mkTerm "genius_loci_N" ;
lin genlisea_N = mkTerm "genlisea_N" ;
lin genoa_PN = mkTerm "genoa_PN" ;
lin genocide_N = mkTerm "genocide_N" ;
lin genoise_N = mkTerm "genoise_N" ;
lin genome_N = mkTerm "genome_N" ;
lin genomics_N = mkTerm "genomics_N" ;
lin genotype_N = mkTerm "genotype_N" ;
lin genotypical_A = mkTerm "genotypical_A" ;
lin genova_PN = mkTerm "genova_PN" ;
lin genre_N = mkTerm "genre_N" ;
lin genre_painting_N = mkTerm "genre_painting_N" ;
lin gent_N = mkTerm "gent_N" ;
lin gentamicin_N = mkTerm "gentamicin_N" ;
lin genteel_A = mkTerm "genteel_A" ;
lin gentian_N = mkTerm "gentian_N" ;
lin gentianella_N = mkTerm "gentianella_N" ;
lin gentile_A = mkTerm "gentile_A" ;
lin gentile_N = mkTerm "gentile_N" ;
lin gentility_N = mkTerm "gentility_N" ;
lin gentle_A = mkTerm "gentle_A" ;
lin gentlefolk_N = mkTerm "gentlefolk_N" ;
lin gentleman_N = mkTerm "gentleman_N" ;
lin gentleman_at_arms_N = mkTerm "gentleman_at_arms_N" ;
lin gentlemanlike_A = mkTerm "gentlemanlike_A" ;
lin gentlemanly_A = mkTerm "gentlemanly_A" ;
lin gentleness_N = mkTerm "gentleness_N" ;
lin gentlewoman_N = mkTerm "gentlewoman_N" ;
lin gentrification_N = mkTerm "gentrification_N" ;
lin gentry_N = mkTerm "gentry_N" ;
lin genuflect_V = mkTerm "genuflect_V" ;
lin genuflection_N = mkTerm "genuflection_N" ;
lin genuflexion_N = mkTerm "genuflexion_N" ;
lin genuine_A = mkTerm "genuine_A" ;
lin genuineness_N = mkTerm "genuineness_N" ;
lin genus_N = mkTerm "genus_N" ;
lin geocentric_A = mkTerm "geocentric_A" ;
lin geochemistry_N = mkTerm "geochemistry_N" ;
lin geode_N = mkTerm "geode_N" ;
lin geodesic_N = mkTerm "geodesic_N" ;
lin geodesy_N = mkTerm "geodesy_N" ;
lin geodetic_A = mkTerm "geodetic_A" ;
lin geoduck_N = mkTerm "geoduck_N" ;
lin geoff_PN = mkTerm "geoff_PN" ;
lin geoffrey_PN = mkTerm "geoffrey_PN" ;
lin geographer_N = mkTerm "geographer_N" ;
lin geographic_A = mkTerm "geographic_A" ;
lin geographical_A = mkTerm "geographical_A" ;
lin geography_N = mkTerm "geography_N" ;
lin geologic_A = mkTerm "geologic_A" ;
lin geological_A = mkTerm "geological_A" ;
lin geologistFem_N = mkTerm "geologistFem_N" ;
lin geologistMasc_N = mkTerm "geologistMasc_N" ;
lin geology_N = mkTerm "geology_N" ;
lin geomancer_N = mkTerm "geomancer_N" ;
lin geomancy_N = mkTerm "geomancy_N" ;
lin geometer_N = mkTerm "geometer_N" ;
lin geometric_A = mkTerm "geometric_A" ;
lin geometrical_A = mkTerm "geometrical_A" ;
lin geometrid_N = mkTerm "geometrid_N" ;
lin geometry_N = mkTerm "geometry_N" ;
lin geomorphologic_A = mkTerm "geomorphologic_A" ;
lin geophagy_N = mkTerm "geophagy_N" ;
lin geophysical_A = mkTerm "geophysical_A" ;
lin geophysicist_N = mkTerm "geophysicist_N" ;
lin geophysics_N = mkTerm "geophysics_N" ;
lin geophyte_N = mkTerm "geophyte_N" ;
lin geophytic_A = mkTerm "geophytic_A" ;
lin geopolitical_A = mkTerm "geopolitical_A" ;
lin geopolitics_N = mkTerm "geopolitics_N" ;
lin geordie_N = mkTerm "geordie_N" ;
lin george_PN = mkTerm "george_PN" ;
lin georgette_N = mkTerm "georgette_N" ;
lin georgia_PN = mkTerm "georgia_PN" ;
lin georgian_A = mkTerm "georgian_A" ;
lin georgian_N = mkTerm "georgian_N" ;
lin georgie_PN = mkTerm "georgie_PN" ;
lin geostationary_A = mkTerm "geostationary_A" ;
lin geostrategic_A = mkTerm "geostrategic_A" ;
lin geostrategy_N = mkTerm "geostrategy_N" ;
lin geosynchronous_A = mkTerm "geosynchronous_A" ;
lin geothermal_A = mkTerm "geothermal_A" ;
lin geotropism_N = mkTerm "geotropism_N" ;
lin gerald_PN = mkTerm "gerald_PN" ;
lin geraldine_PN = mkTerm "geraldine_PN" ;
lin geranium_N = mkTerm "geranium_N" ;
lin gerard_PN = mkTerm "gerard_PN" ;
lin gerardia_N = mkTerm "gerardia_N" ;
lin gerbil_N = mkTerm "gerbil_N" ;
lin gerenuk_N = mkTerm "gerenuk_N" ;
lin geriatric_A = mkTerm "geriatric_A" ;
lin geriatrician_N = mkTerm "geriatrician_N" ;
lin geriatrics_N = mkTerm "geriatrics_N" ;
lin germ_N = mkTerm "germ_N" ;
lin germanFem_N = mkTerm "germanFem_N" ;
lin germanMasc_N = mkTerm "germanMasc_N" ;
lin german_A = mkTerm "german_A" ;
lin germander_N = mkTerm "germander_N" ;
lin germane_A = mkTerm "germane_A" ;
lin germaneness_N = mkTerm "germaneness_N" ;
lin germanic_A = mkTerm "germanic_A" ;
lin germanite_N = mkTerm "germanite_N" ;
lin germanium_N = mkTerm "germanium_N" ;
lin germany_PN = mkTerm "germany_PN" ;
lin germfree_A = mkTerm "germfree_A" ;
lin germicide_N = mkTerm "germicide_N" ;
lin germinal_A = mkTerm "germinal_A" ;
lin germinate_V = mkTerm "germinate_V" ;
lin germinate_V2 = mkTerm "germinate_V2" ;
lin germination_N = mkTerm "germination_N" ;
lin germy_A = mkTerm "germy_A" ;
lin gerontocracy_N = mkTerm "gerontocracy_N" ;
lin gerontologist_N = mkTerm "gerontologist_N" ;
lin gerontology_N = mkTerm "gerontology_N" ;
lin gerry_PN = mkTerm "gerry_PN" ;
lin gerrymander_N = mkTerm "gerrymander_N" ;
lin gerrymander_V2 = mkTerm "gerrymander_V2" ;
lin gertie_PN = mkTerm "gertie_PN" ;
lin gertrude_PN = mkTerm "gertrude_PN" ;
lin gerund_N = mkTerm "gerund_N" ;
lin gerundial_A = mkTerm "gerundial_A" ;
lin gesneria_N = mkTerm "gesneria_N" ;
lin gesneriad_N = mkTerm "gesneriad_N" ;
lin gesso_N = mkTerm "gesso_N" ;
lin gestalt_N = mkTerm "gestalt_N" ;
lin gestapo_N = mkTerm "gestapo_N" ;
lin gestation_N = mkTerm "gestation_N" ;
lin gestational_A = mkTerm "gestational_A" ;
lin gesticulate_V = mkTerm "gesticulate_V" ;
lin gesticulation_N = mkTerm "gesticulation_N" ;
lin gestural_A = mkTerm "gestural_A" ;
lin gesture_N = mkTerm "gesture_N" ;
lin gesture_V = mkTerm "gesture_V" ;
lin get_N = mkTerm "get_N" ;
lin get_V2 = mkTerm "get_V2" ;
lin get_V2V = mkTerm "get_V2V" ;
lin get_VV = mkTerm "get_VV" ;
lin get_about_V = mkTerm "get_about_V" ;
lin get_above_V2 = mkTerm "get_above_V2" ;
lin get_across_V = mkTerm "get_across_V" ;
lin get_across_V2 = mkTerm "get_across_V2" ;
lin get_across_to_V2 = mkTerm "get_across_to_V2" ;
lin get_after_V2 = mkTerm "get_after_V2" ;
lin get_ahead_V = mkTerm "get_ahead_V" ;
lin get_ahead_of_V2 = mkTerm "get_ahead_of_V2" ;
lin get_along_V = mkTerm "get_along_V" ;
lin get_along_in_V2 = mkTerm "get_along_in_V2" ;
lin get_along_with_V2 = mkTerm "get_along_with_V2" ;
lin get_around_V = mkTerm "get_around_V" ;
lin get_around_V2 = mkTerm "get_around_V2" ;
lin get_around_to_V2 = mkTerm "get_around_to_V2" ;
lin get_at_V2 = mkTerm "get_at_V2" ;
lin get_at_able_A = mkTerm "get_at_able_A" ;
lin get_away_V = mkTerm "get_away_V" ;
lin get_away_from_V2 = mkTerm "get_away_from_V2" ;
lin get_away_with_V2 = mkTerm "get_away_with_V2" ;
lin get_back_V = mkTerm "get_back_V" ;
lin get_back_V2 = mkTerm "get_back_V2" ;
lin get_back_at_V2 = mkTerm "get_back_at_V2" ;
lin get_back_into_V2 = mkTerm "get_back_into_V2" ;
lin get_back_to_V2 = mkTerm "get_back_to_V2" ;
lin get_back_together_V = mkTerm "get_back_together_V" ;
lin get_behind_V2 = mkTerm "get_behind_V2" ;
lin get_behind_with_V2 = mkTerm "get_behind_with_V2" ;
lin get_by_V = mkTerm "get_by_V" ;
lin get_by_V2 = mkTerm "get_by_V2" ;
lin get_by_on_V2 = mkTerm "get_by_on_V2" ;
lin get_by_with_V2 = mkTerm "get_by_with_V2" ;
lin get_down_V = mkTerm "get_down_V" ;
lin get_down_V2 = mkTerm "get_down_V2" ;
lin get_down_on_V2 = mkTerm "get_down_on_V2" ;
lin get_down_to_V2 = mkTerm "get_down_to_V2" ;
lin get_even_V = mkTerm "get_even_V" ;
lin get_in_V = mkTerm "get_in_V" ;
lin get_in_V2 = mkTerm "get_in_V2" ;
lin get_in_on_V2 = mkTerm "get_in_on_V2" ;
lin get_in_with_V2 = mkTerm "get_in_with_V2" ;
lin get_into_V2 = mkTerm "get_into_V2" ;
lin get_it_V = mkTerm "get_it_V" ;
lin get_it_off_V = mkTerm "get_it_off_V" ;
lin get_it_off_with_V2 = mkTerm "get_it_off_with_V2" ;
lin get_it_on_V = mkTerm "get_it_on_V" ;
lin get_it_on_with_V2 = mkTerm "get_it_on_with_V2" ;
lin get_it_together_V = mkTerm "get_it_together_V" ;
lin get_it_up_V = mkTerm "get_it_up_V" ;
lin get_off_V = mkTerm "get_off_V" ;
lin get_off_V2 = mkTerm "get_off_V2" ;
lin get_off_it_V2 = mkTerm "get_off_it_V2" ;
lin get_off_on_V2 = mkTerm "get_off_on_V2" ;
lin get_off_with_V2 = mkTerm "get_off_with_V2" ;
lin get_on_1_V2 = mkTerm "get_on_1_V2" ;
lin get_on_2_V2 = mkTerm "get_on_2_V2" ;
lin get_on_V = mkTerm "get_on_V" ;
lin get_on_at_V2 = mkTerm "get_on_at_V2" ;
lin get_on_for_V2 = mkTerm "get_on_for_V2" ;
lin get_on_to_V2 = mkTerm "get_on_to_V2" ;
lin get_on_with_V2 = mkTerm "get_on_with_V2" ;
lin get_onto_V2 = mkTerm "get_onto_V2" ;
lin get_out_V = mkTerm "get_out_V" ;
lin get_out_V2 = mkTerm "get_out_V2" ;
lin get_out_of_V2 = mkTerm "get_out_of_V2" ;
lin get_over_V = mkTerm "get_over_V" ;
lin get_over_V2 = mkTerm "get_over_V2" ;
lin get_over_with_V2 = mkTerm "get_over_with_V2" ;
lin get_round_V = mkTerm "get_round_V" ;
lin get_round_V2 = mkTerm "get_round_V2" ;
lin get_round_to_V2 = mkTerm "get_round_to_V2" ;
lin get_through_V = mkTerm "get_through_V" ;
lin get_through_V2 = mkTerm "get_through_V2" ;
lin get_through_V3 = mkTerm "get_through_V3" ;
lin get_through_to_V2 = mkTerm "get_through_to_V2" ;
lin get_to_V2 = mkTerm "get_to_V2" ;
lin get_together_N = mkTerm "get_together_N" ;
lin get_together_V = mkTerm "get_together_V" ;
lin get_up_N = mkTerm "get_up_N" ;
lin get_up_V = mkTerm "get_up_V" ;
lin get_up_V2 = mkTerm "get_up_V2" ;
lin get_up_to_V2 = mkTerm "get_up_to_V2" ;
lin getaway_N = mkTerm "getaway_N" ;
lin gettable_A = mkTerm "gettable_A" ;
lin geum_N = mkTerm "geum_N" ;
lin geyser_N = mkTerm "geyser_N" ;
lin ghana_PN = mkTerm "ghana_PN" ;
lin ghanaian_A = mkTerm "ghanaian_A" ;
lin ghanaian_N = mkTerm "ghanaian_N" ;
lin gharry_N = mkTerm "gharry_N" ;
lin ghastliness_N = mkTerm "ghastliness_N" ;
lin ghastly_A = mkTerm "ghastly_A" ;
lin ghat_N = mkTerm "ghat_N" ;
lin ghatti_N = mkTerm "ghatti_N" ;
lin ghee_N = mkTerm "ghee_N" ;
lin ghent_PN = mkTerm "ghent_PN" ;
lin gherkin_N = mkTerm "gherkin_N" ;
lin ghetto_N = mkTerm "ghetto_N" ;
lin ghillie_N = mkTerm "ghillie_N" ;
lin ghost_N = mkTerm "ghost_N" ;
lin ghost_V = mkTerm "ghost_V" ;
lin ghost_V2 = mkTerm "ghost_V2" ;
lin ghost_away_V2 = mkTerm "ghost_away_V2" ;
lin ghost_writer_N = mkTerm "ghost_writer_N" ;
lin ghostliness_N = mkTerm "ghostliness_N" ;
lin ghostly_A = mkTerm "ghostly_A" ;
lin ghoul_N = mkTerm "ghoul_N" ;
lin ghoulish_A = mkTerm "ghoulish_A" ;
lin ghq_PN = mkTerm "ghq_PN" ;
lin ghrelin_N = mkTerm "ghrelin_N" ;
lin gi_N = mkTerm "gi_N" ;
lin giant_A = mkTerm "giant_A" ;
lin giant_N = mkTerm "giant_N" ;
lin giantess_N = mkTerm "giantess_N" ;
lin giantism_N = mkTerm "giantism_N" ;
lin giardia_N = mkTerm "giardia_N" ;
lin giardiasis_N = mkTerm "giardiasis_N" ;
lin gib_N = mkTerm "gib_N" ;
lin gibber_V = mkTerm "gibber_V" ;
lin gibberellin_N = mkTerm "gibberellin_N" ;
lin gibberish_N = mkTerm "gibberish_N" ;
lin gibbet_N = mkTerm "gibbet_N" ;
lin gibbet_V2 = mkTerm "gibbet_V2" ;
lin gibbon_N = mkTerm "gibbon_N" ;
lin gibbous_A = mkTerm "gibbous_A" ;
lin gibbsite_N = mkTerm "gibbsite_N" ;
lin gibe_N = mkTerm "gibe_N" ;
lin gibe_V = mkTerm "gibe_V" ;
lin gibibit_N = mkTerm "gibibit_N" ;
lin gibingly_Adv = mkTerm "gibingly_Adv" ;
lin giblet_N = mkTerm "giblet_N" ;
lin gibraltar_PN = mkTerm "gibraltar_PN" ;
lin gibraltarian_A = mkTerm "gibraltarian_A" ;
lin gibraltarian_N = mkTerm "gibraltarian_N" ;
lin giddiness_N = mkTerm "giddiness_N" ;
lin giddy_A = mkTerm "giddy_A" ;
lin gidgee_N = mkTerm "gidgee_N" ;
lin giffnock_PN = mkTerm "giffnock_PN" ;
lin gift_N = mkTerm "gift_N" ;
lin gift_V2 = mkTerm "gift_V2" ;
lin gifted_A = mkTerm "gifted_A" ;
lin gig_N = mkTerm "gig_N" ;
lin gigabit_N = mkTerm "gigabit_N" ;
lin gigabyte_N = mkTerm "gigabyte_N" ;
lin gigahertz_N = mkTerm "gigahertz_N" ;
lin gigantic_A = mkTerm "gigantic_A" ;
lin gigantism_N = mkTerm "gigantism_N" ;
lin giggle_N = mkTerm "giggle_N" ;
lin giggle_V = mkTerm "giggle_V" ;
lin gigolo_N = mkTerm "gigolo_N" ;
lin gilbert_N = mkTerm "gilbert_N" ;
lin gilbert_PN = mkTerm "gilbert_PN" ;
lin gilbertian_A = mkTerm "gilbertian_A" ;
lin gild_N = mkTerm "gild_N" ;
lin gild_V2 = mkTerm "gild_V2" ;
lin gilder_N = mkTerm "gilder_N" ;
lin gildhall_N = mkTerm "gildhall_N" ;
lin gilding_N = mkTerm "gilding_N" ;
lin giles_PN = mkTerm "giles_PN" ;
lin gilfach_goch_PN = mkTerm "gilfach_goch_PN" ;
lin gill_N = mkTerm "gill_N" ;
lin gill_PN = mkTerm "gill_PN" ;
lin gillian_PN = mkTerm "gillian_PN" ;
lin gillie_N = mkTerm "gillie_N" ;
lin gillingham_PN = mkTerm "gillingham_PN" ;
lin gilt_N = mkTerm "gilt_N" ;
lin gilt_edged_A = mkTerm "gilt_edged_A" ;
lin gimbal_N = mkTerm "gimbal_N" ;
lin gimbaled_A = mkTerm "gimbaled_A" ;
lin gimcrack_A = mkTerm "gimcrack_A" ;
lin gimel_N = mkTerm "gimel_N" ;
lin gimlet_N = mkTerm "gimlet_N" ;
lin gimmick_N = mkTerm "gimmick_N" ;
lin gimmickry_N = mkTerm "gimmickry_N" ;
lin gin_N = mkTerm "gin_N" ;
lin gin_V2 = mkTerm "gin_V2" ;
lin gin_up_V2 = mkTerm "gin_up_V2" ;
lin gina_PN = mkTerm "gina_PN" ;
lin ginger_A = mkTerm "ginger_A" ;
lin ginger_N = mkTerm "ginger_N" ;
lin ginger_V2 = mkTerm "ginger_V2" ;
lin ginger_up_V2 = mkTerm "ginger_up_V2" ;
lin gingerbread_N = mkTerm "gingerbread_N" ;
lin gingerly_A = mkTerm "gingerly_A" ;
lin gingerol_N = mkTerm "gingerol_N" ;
lin gingersnap_N = mkTerm "gingersnap_N" ;
lin gingery_A = mkTerm "gingery_A" ;
lin gingham_N = mkTerm "gingham_N" ;
lin gingiva_N = mkTerm "gingiva_N" ;
lin gingival_A = mkTerm "gingival_A" ;
lin gingivitis_N = mkTerm "gingivitis_N" ;
lin gingko_N = mkTerm "gingko_N" ;
lin ginkgo_N = mkTerm "ginkgo_N" ;
lin ginseng_N = mkTerm "ginseng_N" ;
lin gipsyFem_N = mkTerm "gipsyFem_N" ;
lin gipsyMasc_N = mkTerm "gipsyMasc_N" ;
lin gipsywort_N = mkTerm "gipsywort_N" ;
lin giraffe_N = mkTerm "giraffe_N" ;
lin girandole_N = mkTerm "girandole_N" ;
lin gird_V = mkTerm "gird_V" ;
lin gird_V2 = mkTerm "gird_V2" ;
lin girder_N = mkTerm "girder_N" ;
lin girdle_N = mkTerm "girdle_N" ;
lin girdle_V2 = mkTerm "girdle_V2" ;
lin girl_N = mkTerm "girl_N" ;
lin girlfriend_N = mkTerm "girlfriend_N" ;
lin girlhood_N = mkTerm "girlhood_N" ;
lin girlish_A = mkTerm "girlish_A" ;
lin girlishness_N = mkTerm "girlishness_N" ;
lin giro_N = mkTerm "giro_N" ;
lin girth_N = mkTerm "girth_N" ;
lin girvan_PN = mkTerm "girvan_PN" ;
lin gist_N = mkTerm "gist_N" ;
lin gitana_N = mkTerm "gitana_N" ;
lin gitano_N = mkTerm "gitano_N" ;
lin give_N = mkTerm "give_N" ;
lin give_V = mkTerm "give_V" ;
lin give_V2 = mkTerm "give_V2" ;
lin give_V3 = mkTerm "give_V3" ;
lin give_away_V = mkTerm "give_away_V" ;
lin give_away_V2 = mkTerm "give_away_V2" ;
lin give_back_V2 = mkTerm "give_back_V2" ;
lin give_in_V = mkTerm "give_in_V" ;
lin give_in_V2 = mkTerm "give_in_V2" ;
lin give_in_to_V2 = mkTerm "give_in_to_V2" ;
lin give_it_to_V2 = mkTerm "give_it_to_V2" ;
lin give_it_up_for_V2 = mkTerm "give_it_up_for_V2" ;
lin give_it_up_to_V2 = mkTerm "give_it_up_to_V2" ;
lin give_of_V2 = mkTerm "give_of_V2" ;
lin give_off_V = mkTerm "give_off_V" ;
lin give_off_V2 = mkTerm "give_off_V2" ;
lin give_onto_V2 = mkTerm "give_onto_V2" ;
lin give_out_V = mkTerm "give_out_V" ;
lin give_out_V2 = mkTerm "give_out_V2" ;
lin give_over_V = mkTerm "give_over_V" ;
lin give_over_V2 = mkTerm "give_over_V2" ;
lin give_over_to_V3 = mkTerm "give_over_to_V3" ;
lin give_up_V = mkTerm "give_up_V" ;
lin give_up_V2 = mkTerm "give_up_V2" ;
lin give_up_on_V2 = mkTerm "give_up_on_V2" ;
lin give_up_to_V2 = mkTerm "give_up_to_V2" ;
lin give_way_V = mkTerm "give_way_V" ;
lin give_way_to_V2 = mkTerm "give_way_to_V2" ;
lin give_yourself_up_V = mkTerm "give_yourself_up_V" ;
lin give_yourself_up_to_V2 = mkTerm "give_yourself_up_to_V2" ;
lin giveaway_N = mkTerm "giveaway_N" ;
lin given_A = mkTerm "given_A" ;
lin given_N = mkTerm "given_N" ;
lin givenness_N = mkTerm "givenness_N" ;
lin giver_N = mkTerm "giver_N" ;
lin giveth_V2 = mkTerm "giveth_V2" ;
lin giving_N = mkTerm "giving_N" ;
lin gizzard_N = mkTerm "gizzard_N" ;
lin glabella_N = mkTerm "glabella_N" ;
lin glabellar_A = mkTerm "glabellar_A" ;
lin glabrescent_A = mkTerm "glabrescent_A" ;
lin glabrous_A = mkTerm "glabrous_A" ;
lin glace_A = mkTerm "glace_A" ;
lin glacial_A = mkTerm "glacial_A" ;
lin glaciated_A = mkTerm "glaciated_A" ;
lin glaciation_N = mkTerm "glaciation_N" ;
lin glacier_N = mkTerm "glacier_N" ;
lin glad_A = mkTerm "glad_A" ;
lin gladden_V2 = mkTerm "gladden_V2" ;
lin glade_N = mkTerm "glade_N" ;
lin gladiator_N = mkTerm "gladiator_N" ;
lin gladiatorial_A = mkTerm "gladiatorial_A" ;
lin gladiolus_N = mkTerm "gladiolus_N" ;
lin gladness_N = mkTerm "gladness_N" ;
lin gladsome_A = mkTerm "gladsome_A" ;
lin gladys_PN = mkTerm "gladys_PN" ;
lin glam_N = mkTerm "glam_N" ;
lin glamor_N = mkTerm "glamor_N" ;
lin glamorgan_PN = mkTerm "glamorgan_PN" ;
lin glamorization_N = mkTerm "glamorization_N" ;
lin glamorize_V2 = mkTerm "glamorize_V2" ;
lin glamorous_A = mkTerm "glamorous_A" ;
lin glamour_N = mkTerm "glamour_N" ;
lin glance_N = mkTerm "glance_N" ;
lin glance_V = mkTerm "glance_V" ;
lin glance_V2 = mkTerm "glance_V2" ;
lin gland_N = mkTerm "gland_N" ;
lin glanders_N = mkTerm "glanders_N" ;
lin glandular_A = mkTerm "glandular_A" ;
lin glans_N = mkTerm "glans_N" ;
lin glare_N = mkTerm "glare_N" ;
lin glare_V = mkTerm "glare_V" ;
lin glare_V2 = mkTerm "glare_V2" ;
lin glaring_A = mkTerm "glaring_A" ;
lin glasgow_PN = mkTerm "glasgow_PN" ;
lin glasnost_N = mkTerm "glasnost_N" ;
lin glass_1_N = mkTerm "glass_1_N" ;
lin glass_2_N = mkTerm "glass_2_N" ;
lin glass_V2 = mkTerm "glass_V2" ;
lin glass_blower_N = mkTerm "glass_blower_N" ;
lin glass_cutter_N = mkTerm "glass_cutter_N" ;
lin glass_wool_N = mkTerm "glass_wool_N" ;
lin glassful_N = mkTerm "glassful_N" ;
lin glasshouse_N = mkTerm "glasshouse_N" ;
lin glassmaker_N = mkTerm "glassmaker_N" ;
lin glassware_N = mkTerm "glassware_N" ;
lin glassworks_N = mkTerm "glassworks_N" ;
lin glasswort_N = mkTerm "glasswort_N" ;
lin glassy_A = mkTerm "glassy_A" ;
lin glastonbury_PN = mkTerm "glastonbury_PN" ;
lin glaswegian_A = mkTerm "glaswegian_A" ;
lin glaswegian_N = mkTerm "glaswegian_N" ;
lin glaucoma_N = mkTerm "glaucoma_N" ;
lin glauconite_N = mkTerm "glauconite_N" ;
lin glaucous_A = mkTerm "glaucous_A" ;
lin glaze_N = mkTerm "glaze_N" ;
lin glaze_V = mkTerm "glaze_V" ;
lin glaze_V2 = mkTerm "glaze_V2" ;
lin glazier_N = mkTerm "glazier_N" ;
lin gleam_N = mkTerm "gleam_N" ;
lin gleam_V = mkTerm "gleam_V" ;
lin glean_V = mkTerm "glean_V" ;
lin glean_V2 = mkTerm "glean_V2" ;
lin gleaner_N = mkTerm "gleaner_N" ;
lin gleba_N = mkTerm "gleba_N" ;
lin glebe_N = mkTerm "glebe_N" ;
lin glee_N = mkTerm "glee_N" ;
lin gleeful_A = mkTerm "gleeful_A" ;
lin gleet_N = mkTerm "gleet_N" ;
lin glen_N = mkTerm "glen_N" ;
lin glen_PN = mkTerm "glen_PN" ;
lin glengarry_N = mkTerm "glengarry_N" ;
lin glenrothes_PN = mkTerm "glenrothes_PN" ;
lin glial_A = mkTerm "glial_A" ;
lin glib_A = mkTerm "glib_A" ;
lin glibness_N = mkTerm "glibness_N" ;
lin glide_N = mkTerm "glide_N" ;
lin glide_V = mkTerm "glide_V" ;
lin glider_N = mkTerm "glider_N" ;
lin gliding_N = mkTerm "gliding_N" ;
lin glimmer_N = mkTerm "glimmer_N" ;
lin glimmer_V = mkTerm "glimmer_V" ;
lin glimmery_A = mkTerm "glimmery_A" ;
lin glimpse_N = mkTerm "glimpse_N" ;
lin glimpse_V2 = mkTerm "glimpse_V2" ;
lin glint_N = mkTerm "glint_N" ;
lin glint_V = mkTerm "glint_V" ;
lin glioblastoma_N = mkTerm "glioblastoma_N" ;
lin glioma_N = mkTerm "glioma_N" ;
lin glipizide_N = mkTerm "glipizide_N" ;
lin gliricidia_N = mkTerm "gliricidia_N" ;
lin glissade_N = mkTerm "glissade_N" ;
lin glissade_V = mkTerm "glissade_V" ;
lin glissando_A = mkTerm "glissando_A" ;
lin glissando_Adv = mkTerm "glissando_Adv" ;
lin glissando_N = mkTerm "glissando_N" ;
lin glisten_V = mkTerm "glisten_V" ;
lin glister_N = mkTerm "glister_N" ;
lin glister_V = mkTerm "glister_V" ;
lin glitter_N = mkTerm "glitter_N" ;
lin glitter_V = mkTerm "glitter_V" ;
lin gloaming_N = mkTerm "gloaming_N" ;
lin gloat_N = mkTerm "gloat_N" ;
lin gloat_V = mkTerm "gloat_V" ;
lin gloat_VS = mkTerm "gloat_VS" ;
lin gloatingly_Adv = mkTerm "gloatingly_Adv" ;
lin global_A = mkTerm "global_A" ;
lin globalization_N = mkTerm "globalization_N" ;
lin globe_N = mkTerm "globe_N" ;
lin globeflower_N = mkTerm "globeflower_N" ;
lin globetrot_V = mkTerm "globetrot_V" ;
lin globetrotter_N = mkTerm "globetrotter_N" ;
lin globigerina_N = mkTerm "globigerina_N" ;
lin globin_N = mkTerm "globin_N" ;
lin globular_A = mkTerm "globular_A" ;
lin globule_N = mkTerm "globule_N" ;
lin globulin_N = mkTerm "globulin_N" ;
lin glochidium_N = mkTerm "glochidium_N" ;
lin glockenspiel_N = mkTerm "glockenspiel_N" ;
lin glogg_N = mkTerm "glogg_N" ;
lin glomerular_A = mkTerm "glomerular_A" ;
lin glomerule_N = mkTerm "glomerule_N" ;
lin glomerulonephritis_N = mkTerm "glomerulonephritis_N" ;
lin glomerulus_N = mkTerm "glomerulus_N" ;
lin gloom_N = mkTerm "gloom_N" ;
lin gloominess_N = mkTerm "gloominess_N" ;
lin glooming_A = mkTerm "glooming_A" ;
lin gloomy_A = mkTerm "gloomy_A" ;
lin glop_N = mkTerm "glop_N" ;
lin gloria_PN = mkTerm "gloria_PN" ;
lin glorification_N = mkTerm "glorification_N" ;
lin glorify_V2 = mkTerm "glorify_V2" ;
lin gloriosa_N = mkTerm "gloriosa_N" ;
lin glorious_A = mkTerm "glorious_A" ;
lin glory_N = mkTerm "glory_N" ;
lin glory_V = mkTerm "glory_V" ;
lin glory_hole_N = mkTerm "glory_hole_N" ;
lin gloss_N = mkTerm "gloss_N" ;
lin gloss_V2 = mkTerm "gloss_V2" ;
lin gloss_over_V2 = mkTerm "gloss_over_V2" ;
lin glossalgia_N = mkTerm "glossalgia_N" ;
lin glossarist_N = mkTerm "glossarist_N" ;
lin glossary_N = mkTerm "glossary_N" ;
lin glossiness_N = mkTerm "glossiness_N" ;
lin glossitis_N = mkTerm "glossitis_N" ;
lin glossolalia_N = mkTerm "glossolalia_N" ;
lin glossop_PN = mkTerm "glossop_PN" ;
lin glossopharyngeal_A = mkTerm "glossopharyngeal_A" ;
lin glossoptosis_N = mkTerm "glossoptosis_N" ;
lin glossy_A = mkTerm "glossy_A" ;
lin glossy_N = mkTerm "glossy_N" ;
lin glottal_A = mkTerm "glottal_A" ;
lin glottis_N = mkTerm "glottis_N" ;
lin glottochronological_A = mkTerm "glottochronological_A" ;
lin glottochronology_N = mkTerm "glottochronology_N" ;
lin gloucester_PN = mkTerm "gloucester_PN" ;
lin gloucestershire_PN = mkTerm "gloucestershire_PN" ;
lin glove_N = mkTerm "glove_N" ;
lin glove_compartment_N = mkTerm "glove_compartment_N" ;
lin gloved_A = mkTerm "gloved_A" ;
lin gloveless_A = mkTerm "gloveless_A" ;
lin glow_N = mkTerm "glow_N" ;
lin glow_V = mkTerm "glow_V" ;
lin glow_worm_N = mkTerm "glow_worm_N" ;
lin glower_V = mkTerm "glower_V" ;
lin gloweringly_Adv = mkTerm "gloweringly_Adv" ;
lin glowingly_Adv = mkTerm "glowingly_Adv" ;
lin gloxinia_N = mkTerm "gloxinia_N" ;
lin glucagon_N = mkTerm "glucagon_N" ;
lin glucocorticoid_N = mkTerm "glucocorticoid_N" ;
lin glucosamine_N = mkTerm "glucosamine_N" ;
lin glucose_N = mkTerm "glucose_N" ;
lin glucoside_N = mkTerm "glucoside_N" ;
lin glucosuria_N = mkTerm "glucosuria_N" ;
lin glue_N = mkTerm "glue_N" ;
lin glue_V2 = mkTerm "glue_V2" ;
lin glue_down_V = mkTerm "glue_down_V" ;
lin glued_A = mkTerm "glued_A" ;
lin gluey_A = mkTerm "gluey_A" ;
lin glum_A = mkTerm "glum_A" ;
lin glume_N = mkTerm "glume_N" ;
lin glumness_N = mkTerm "glumness_N" ;
lin gluon_N = mkTerm "gluon_N" ;
lin glusburn_PN = mkTerm "glusburn_PN" ;
lin glut_N = mkTerm "glut_N" ;
lin glut_V2 = mkTerm "glut_V2" ;
lin glutamate_N = mkTerm "glutamate_N" ;
lin glutamine_N = mkTerm "glutamine_N" ;
lin gluteal_A = mkTerm "gluteal_A" ;
lin glutelin_N = mkTerm "glutelin_N" ;
lin gluten_N = mkTerm "gluten_N" ;
lin glutethimide_N = mkTerm "glutethimide_N" ;
lin gluteus_N = mkTerm "gluteus_N" ;
lin glutinous_A = mkTerm "glutinous_A" ;
lin glutton_N = mkTerm "glutton_N" ;
lin gluttonous_A = mkTerm "gluttonous_A" ;
lin gluttony_N = mkTerm "gluttony_N" ;
lin glyburide_N = mkTerm "glyburide_N" ;
lin glyceraldehyde_N = mkTerm "glyceraldehyde_N" ;
lin glyceride_N = mkTerm "glyceride_N" ;
lin glycerine_N = mkTerm "glycerine_N" ;
lin glycerite_N = mkTerm "glycerite_N" ;
lin glycerogelatin_N = mkTerm "glycerogelatin_N" ;
lin glycerol_N = mkTerm "glycerol_N" ;
lin glyceryl_N = mkTerm "glyceryl_N" ;
lin glycine_N = mkTerm "glycine_N" ;
lin glycogen_N = mkTerm "glycogen_N" ;
lin glycogenesis_N = mkTerm "glycogenesis_N" ;
lin glycogenic_A = mkTerm "glycogenic_A" ;
lin glycolysis_N = mkTerm "glycolysis_N" ;
lin glycoprotein_N = mkTerm "glycoprotein_N" ;
lin glycoside_N = mkTerm "glycoside_N" ;
lin glycosuria_N = mkTerm "glycosuria_N" ;
lin glyph_N = mkTerm "glyph_N" ;
lin glyptics_N = mkTerm "glyptics_N" ;
lin glyptography_N = mkTerm "glyptography_N" ;
lin gmt_PN = mkTerm "gmt_PN" ;
lin gnarled_A = mkTerm "gnarled_A" ;
lin gnash_V = mkTerm "gnash_V" ;
lin gnash_V2 = mkTerm "gnash_V2" ;
lin gnat_N = mkTerm "gnat_N" ;
lin gnatcatcher_N = mkTerm "gnatcatcher_N" ;
lin gnathion_N = mkTerm "gnathion_N" ;
lin gnathostome_N = mkTerm "gnathostome_N" ;
lin gnaw_V = mkTerm "gnaw_V" ;
lin gnaw_V2 = mkTerm "gnaw_V2" ;
lin gnaw_at_V2 = mkTerm "gnaw_at_V2" ;
lin gnaw_away_at_V2 = mkTerm "gnaw_away_at_V2" ;
lin gneiss_N = mkTerm "gneiss_N" ;
lin gnetum_N = mkTerm "gnetum_N" ;
lin gnocchi_N = mkTerm "gnocchi_N" ;
lin gnome_N = mkTerm "gnome_N" ;
lin gnomic_A = mkTerm "gnomic_A" ;
lin gnomish_A = mkTerm "gnomish_A" ;
lin gnomon_N = mkTerm "gnomon_N" ;
lin gnosis_N = mkTerm "gnosis_N" ;
lin gnostic_A = mkTerm "gnostic_A" ;
lin gnp_N = mkTerm "gnp_N" ;
lin gnu_N = mkTerm "gnu_N" ;
lin go_A = mkTerm "go_A" ;
lin go_N = mkTerm "go_N" ;
lin go_V = mkTerm "go_V" ;
lin go_VA = mkTerm "go_VA" ;
lin go_VV = mkTerm "go_VV" ;
lin go_about_V = mkTerm "go_about_V" ;
lin go_about_V2 = mkTerm "go_about_V2" ;
lin go_across_V = mkTerm "go_across_V" ;
lin go_after_V2 = mkTerm "go_after_V2" ;
lin go_against_V2 = mkTerm "go_against_V2" ;
lin go_ahead_N = mkTerm "go_ahead_N" ;
lin go_ahead_V = mkTerm "go_ahead_V" ;
lin go_ahead_with_V2 = mkTerm "go_ahead_with_V2" ;
lin go_along_V = mkTerm "go_along_V" ;
lin go_along_with_V2 = mkTerm "go_along_with_V2" ;
lin go_around_V = mkTerm "go_around_V" ;
lin go_as_you_please_A = mkTerm "go_as_you_please_A" ;
lin go_at_V2 = mkTerm "go_at_V2" ;
lin go_away_V = mkTerm "go_away_V" ;
lin go_back_V = mkTerm "go_back_V" ;
lin go_back_V2 = mkTerm "go_back_V2" ;
lin go_back_on_V2 = mkTerm "go_back_on_V2" ;
lin go_before_V = mkTerm "go_before_V" ;
lin go_below_V = mkTerm "go_below_V" ;
lin go_between_N = mkTerm "go_between_N" ;
lin go_by_N = mkTerm "go_by_N" ;
lin go_by_V = mkTerm "go_by_V" ;
lin go_by_V2 = mkTerm "go_by_V2" ;
lin go_cart_N = mkTerm "go_cart_N" ;
lin go_down_V = mkTerm "go_down_V" ;
lin go_down_on_V2 = mkTerm "go_down_on_V2" ;
lin go_down_to_V2 = mkTerm "go_down_to_V2" ;
lin go_down_with_V2 = mkTerm "go_down_with_V2" ;
lin go_for_V = mkTerm "go_for_V" ;
lin go_for_V2 = mkTerm "go_for_V2" ;
lin go_for_it_V = mkTerm "go_for_it_V" ;
lin go_forth_V = mkTerm "go_forth_V" ;
lin go_forward_V = mkTerm "go_forward_V" ;
lin go_getter_N = mkTerm "go_getter_N" ;
lin go_in_V = mkTerm "go_in_V" ;
lin go_in_for_V2 = mkTerm "go_in_for_V2" ;
lin go_in_with_V2 = mkTerm "go_in_with_V2" ;
lin go_into_V2 = mkTerm "go_into_V2" ;
lin go_it_V = mkTerm "go_it_V" ;
lin go_it_alone_V = mkTerm "go_it_alone_V" ;
lin go_kart_N = mkTerm "go_kart_N" ;
lin go_off_V = mkTerm "go_off_V" ;
lin go_off_V2 = mkTerm "go_off_V2" ;
lin go_off_with_V2 = mkTerm "go_off_with_V2" ;
lin go_on_V = mkTerm "go_on_V" ;
lin go_on_V2 = mkTerm "go_on_V2" ;
lin go_on_about_V2 = mkTerm "go_on_about_V2" ;
lin go_on_at_V2 = mkTerm "go_on_at_V2" ;
lin go_on_to_V2 = mkTerm "go_on_to_V2" ;
lin go_on_with_V2 = mkTerm "go_on_with_V2" ;
lin go_one_V = mkTerm "go_one_V" ;
lin go_out_V = mkTerm "go_out_V" ;
lin go_out_for_V2 = mkTerm "go_out_for_V2" ;
lin go_out_to_V2 = mkTerm "go_out_to_V2" ;
lin go_out_with_V2 = mkTerm "go_out_with_V2" ;
lin go_over_V = mkTerm "go_over_V" ;
lin go_over_V2 = mkTerm "go_over_V2" ;
lin go_over_to_V2 = mkTerm "go_over_to_V2" ;
lin go_past_V2 = mkTerm "go_past_V2" ;
lin go_round_V = mkTerm "go_round_V" ;
lin go_slow_N = mkTerm "go_slow_N" ;
lin go_through_V = mkTerm "go_through_V" ;
lin go_through_V2 = mkTerm "go_through_V2" ;
lin go_through_with_V2 = mkTerm "go_through_with_V2" ;
lin go_to_V2 = mkTerm "go_to_V2" ;
lin go_to_meeting_A = mkTerm "go_to_meeting_A" ;
lin go_together_V = mkTerm "go_together_V" ;
lin go_towards_V2 = mkTerm "go_towards_V2" ;
lin go_under_V = mkTerm "go_under_V" ;
lin go_up_V = mkTerm "go_up_V" ;
lin go_up_to_V2 = mkTerm "go_up_to_V2" ;
lin go_with_V2 = mkTerm "go_with_V2" ;
lin go_without_V2 = mkTerm "go_without_V2" ;
lin goad_N = mkTerm "goad_N" ;
lin goad_V2 = mkTerm "goad_V2" ;
lin goal_1_N = mkTerm "goal_1_N" ;
lin goal_2_N = mkTerm "goal_2_N" ;
lin goal_kick_N = mkTerm "goal_kick_N" ;
lin goal_line_N = mkTerm "goal_line_N" ;
lin goalie_N = mkTerm "goalie_N" ;
lin goalkeeper_N = mkTerm "goalkeeper_N" ;
lin goalless_A = mkTerm "goalless_A" ;
lin goalmouth_N = mkTerm "goalmouth_N" ;
lin goalpost_N = mkTerm "goalpost_N" ;
lin goaltender_N = mkTerm "goaltender_N" ;
lin goat_N = mkTerm "goat_N" ;
lin goatee_N = mkTerm "goatee_N" ;
lin goateed_A = mkTerm "goateed_A" ;
lin goatfish_N = mkTerm "goatfish_N" ;
lin goatherd_N = mkTerm "goatherd_N" ;
lin goatsfoot_N = mkTerm "goatsfoot_N" ;
lin goatskin_N = mkTerm "goatskin_N" ;
lin goatsucker_N = mkTerm "goatsucker_N" ;
lin gob_N = mkTerm "gob_N" ;
lin gobbet_N = mkTerm "gobbet_N" ;
lin gobble_N = mkTerm "gobble_N" ;
lin gobble_V = mkTerm "gobble_V" ;
lin gobble_V2 = mkTerm "gobble_V2" ;
lin gobbledygook_N = mkTerm "gobbledygook_N" ;
lin gobbler_N = mkTerm "gobbler_N" ;
lin goblet_N = mkTerm "goblet_N" ;
lin goblin_N = mkTerm "goblin_N" ;
lin gobsmacked_A = mkTerm "gobsmacked_A" ;
lin god_N = mkTerm "god_N" ;
lin god_PN = mkTerm "god_PN" ;
lin god_damn_A = mkTerm "god_damn_A" ;
lin god_damned_A = mkTerm "god_damned_A" ;
lin godalming_PN = mkTerm "godalming_PN" ;
lin godchild_N = mkTerm "godchild_N" ;
lin goddam_A = mkTerm "goddam_A" ;
lin goddam_Adv = mkTerm "goddam_Adv" ;
lin goddaughter_N = mkTerm "goddaughter_N" ;
lin goddess_N = mkTerm "goddess_N" ;
lin godfather_N = mkTerm "godfather_N" ;
lin godfearing_A = mkTerm "godfearing_A" ;
lin godforsaken_A = mkTerm "godforsaken_A" ;
lin godfrey_PN = mkTerm "godfrey_PN" ;
lin godhead_N = mkTerm "godhead_N" ;
lin godless_A = mkTerm "godless_A" ;
lin godlessness_N = mkTerm "godlessness_N" ;
lin godlike_A = mkTerm "godlike_A" ;
lin godliness_N = mkTerm "godliness_N" ;
lin godly_A = mkTerm "godly_A" ;
lin godmanchester_PN = mkTerm "godmanchester_PN" ;
lin godmother_N = mkTerm "godmother_N" ;
lin godown_N = mkTerm "godown_N" ;
lin godparent_N = mkTerm "godparent_N" ;
lin godsend_N = mkTerm "godsend_N" ;
lin godson_N = mkTerm "godson_N" ;
lin godspeed_N = mkTerm "godspeed_N" ;
lin godwit_N = mkTerm "godwit_N" ;
lin goethite_N = mkTerm "goethite_N" ;
lin gofer_N = mkTerm "gofer_N" ;
lin goffer_N = mkTerm "goffer_N" ;
lin goffs_oak_PN = mkTerm "goffs_oak_PN" ;
lin goggle_V = mkTerm "goggle_V" ;
lin goggle_box_N = mkTerm "goggle_box_N" ;
lin goggle_eyed_A = mkTerm "goggle_eyed_A" ;
lin goggles_N = mkTerm "goggles_N" ;
lin going_N = mkTerm "going_N" ;
lin going_over_N = mkTerm "going_over_N" ;
lin goiter_N = mkTerm "goiter_N" ;
lin goitre_N = mkTerm "goitre_N" ;
lin goitrogen_N = mkTerm "goitrogen_N" ;
lin golbourne_PN = mkTerm "golbourne_PN" ;
lin gold_A = mkTerm "gold_A" ;
lin gold_N = mkTerm "gold_N" ;
lin gold_beater_N = mkTerm "gold_beater_N" ;
lin gold_digger_N = mkTerm "gold_digger_N" ;
lin gold_dust_N = mkTerm "gold_dust_N" ;
lin gold_foil_N = mkTerm "gold_foil_N" ;
lin gold_leaf_N = mkTerm "gold_leaf_N" ;
lin gold_plate_N = mkTerm "gold_plate_N" ;
lin gold_rush_N = mkTerm "gold_rush_N" ;
lin goldbeater_N = mkTerm "goldbeater_N" ;
lin goldbrick_N = mkTerm "goldbrick_N" ;
lin goldcrest_N = mkTerm "goldcrest_N" ;
lin golden_A = mkTerm "golden_A" ;
lin goldenbush_N = mkTerm "goldenbush_N" ;
lin goldeneye_N = mkTerm "goldeneye_N" ;
lin goldenrod_N = mkTerm "goldenrod_N" ;
lin goldenseal_N = mkTerm "goldenseal_N" ;
lin goldfield_N = mkTerm "goldfield_N" ;
lin goldfields_N = mkTerm "goldfields_N" ;
lin goldfinch_N = mkTerm "goldfinch_N" ;
lin goldfish_N = mkTerm "goldfish_N" ;
lin goldilocks_N = mkTerm "goldilocks_N" ;
lin goldmine_N = mkTerm "goldmine_N" ;
lin goldsmith_N = mkTerm "goldsmith_N" ;
lin goldstone_N = mkTerm "goldstone_N" ;
lin goldthread_N = mkTerm "goldthread_N" ;
lin golem_N = mkTerm "golem_N" ;
lin golf_N = mkTerm "golf_N" ;
lin golf_V = mkTerm "golf_V" ;
lin golf_ball_N = mkTerm "golf_ball_N" ;
lin golf_club_N = mkTerm "golf_club_N" ;
lin golf_course_N = mkTerm "golf_course_N" ;
lin golf_links_N = mkTerm "golf_links_N" ;
lin golfcart_N = mkTerm "golfcart_N" ;
lin golfer_N = mkTerm "golfer_N" ;
lin golfing_N = mkTerm "golfing_N" ;
lin goliard_N = mkTerm "goliard_N" ;
lin goliath_N = mkTerm "goliath_N" ;
lin golliwog_N = mkTerm "golliwog_N" ;
lin golly_Interj = mkTerm "golly_Interj" ;
lin golosh_N = mkTerm "golosh_N" ;
lin gomphothere_N = mkTerm "gomphothere_N" ;
lin gonad_N = mkTerm "gonad_N" ;
lin gonadal_A = mkTerm "gonadal_A" ;
lin gonadotropic_A = mkTerm "gonadotropic_A" ;
lin gonadotropin_N = mkTerm "gonadotropin_N" ;
lin gondola_N = mkTerm "gondola_N" ;
lin gondolier_N = mkTerm "gondolier_N" ;
lin goner_N = mkTerm "goner_N" ;
lin gong_N = mkTerm "gong_N" ;
lin gong_V2 = mkTerm "gong_V2" ;
lin gonif_N = mkTerm "gonif_N" ;
lin goniometer_N = mkTerm "goniometer_N" ;
lin gonion_N = mkTerm "gonion_N" ;
lin gonioscopy_N = mkTerm "gonioscopy_N" ;
lin gonococcus_N = mkTerm "gonococcus_N" ;
lin gonorrhea_N = mkTerm "gonorrhea_N" ;
lin gonorrhoea_N = mkTerm "gonorrhoea_N" ;
lin goo_N = mkTerm "goo_N" ;
lin good_A = mkTerm "good_A" ;
lin good_N = mkTerm "good_N" ;
lin good_afternoon_Interj = mkTerm "good_afternoon_Interj" ;
lin good_evening_Interj = mkTerm "good_evening_Interj" ;
lin good_fellowship_N = mkTerm "good_fellowship_N" ;
lin good_for_naught_A = mkTerm "good_for_naught_A" ;
lin good_for_naught_N = mkTerm "good_for_naught_N" ;
lin good_for_nothing_A = mkTerm "good_for_nothing_A" ;
lin good_for_nothing_N = mkTerm "good_for_nothing_N" ;
lin good_humoured_A = mkTerm "good_humoured_A" ;
lin good_looking_A = mkTerm "good_looking_A" ;
lin good_luck_Interj = mkTerm "good_luck_Interj" ;
lin good_morning_Interj = mkTerm "good_morning_Interj" ;
lin good_natured_A = mkTerm "good_natured_A" ;
lin good_neighbourliness_N = mkTerm "good_neighbourliness_N" ;
lin good_night_Interj = mkTerm "good_night_Interj" ;
lin good_tempered_A = mkTerm "good_tempered_A" ;
lin good_time_A = mkTerm "good_time_A" ;
lin goodbye_Interj = mkTerm "goodbye_Interj" ;
lin goodish_A = mkTerm "goodish_A" ;
lin goodly_A = mkTerm "goodly_A" ;
lin goodness_N = mkTerm "goodness_N" ;
lin goods_N = mkTerm "goods_N" ;
lin goodwill_N = mkTerm "goodwill_N" ;
lin goody_N = mkTerm "goody_N" ;
lin goody_goody_A = mkTerm "goody_goody_A" ;
lin goody_goody_N = mkTerm "goody_goody_N" ;
lin gooey_A = mkTerm "gooey_A" ;
lin goof_N = mkTerm "goof_N" ;
lin goof_V = mkTerm "goof_V" ;
lin goof_V2 = mkTerm "goof_V2" ;
lin goof_around_V = mkTerm "goof_around_V" ;
lin goof_off_V = mkTerm "goof_off_V" ;
lin goof_up_V2 = mkTerm "goof_up_V2" ;
lin goofy_A = mkTerm "goofy_A" ;
lin googly_N = mkTerm "googly_N" ;
lin googol_N = mkTerm "googol_N" ;
lin googolplex_N = mkTerm "googolplex_N" ;
lin gook_N = mkTerm "gook_N" ;
lin goole_PN = mkTerm "goole_PN" ;
lin goon_N = mkTerm "goon_N" ;
lin goosander_N = mkTerm "goosander_N" ;
lin goose_N = mkTerm "goose_N" ;
lin goose_flesh_N = mkTerm "goose_flesh_N" ;
lin goose_step_N = mkTerm "goose_step_N" ;
lin gooseberry_N = mkTerm "gooseberry_N" ;
lin goosefish_N = mkTerm "goosefish_N" ;
lin goosefoot_N = mkTerm "goosefoot_N" ;
lin gooseneck_N = mkTerm "gooseneck_N" ;
lin gopher_N = mkTerm "gopher_N" ;
lin goral_N = mkTerm "goral_N" ;
lin gordian_A = mkTerm "gordian_A" ;
lin gordon_PN = mkTerm "gordon_PN" ;
lin gore_N = mkTerm "gore_N" ;
lin gore_V2 = mkTerm "gore_V2" ;
lin gorge_N = mkTerm "gorge_N" ;
lin gorge_V = mkTerm "gorge_V" ;
lin gorge_V2 = mkTerm "gorge_V2" ;
lin gorgeous_A = mkTerm "gorgeous_A" ;
lin gorgerin_N = mkTerm "gorgerin_N" ;
lin gorget_N = mkTerm "gorget_N" ;
lin gorgon_N = mkTerm "gorgon_N" ;
lin gorgonian_N = mkTerm "gorgonian_N" ;
lin gorgonzola_N = mkTerm "gorgonzola_N" ;
lin gorilla_N = mkTerm "gorilla_N" ;
lin gorky_PN = mkTerm "gorky_PN" ;
lin gormandize_V = mkTerm "gormandize_V" ;
lin gormless_A = mkTerm "gormless_A" ;
lin gorse_N = mkTerm "gorse_N" ;
lin gorseinon_PN = mkTerm "gorseinon_PN" ;
lin gory_A = mkTerm "gory_A" ;
lin goshawk_N = mkTerm "goshawk_N" ;
lin gosling_N = mkTerm "gosling_N" ;
lin gospel_N = mkTerm "gospel_N" ;
lin gosport_PN = mkTerm "gosport_PN" ;
lin gossamer_N = mkTerm "gossamer_N" ;
lin gossip_N = mkTerm "gossip_N" ;
lin gossip_V = mkTerm "gossip_V" ;
lin gossiping_N = mkTerm "gossiping_N" ;
lin goth_N = mkTerm "goth_N" ;
lin gothenburg_PN = mkTerm "gothenburg_PN" ;
lin gothic_A = mkTerm "gothic_A" ;
lin gothic_N = mkTerm "gothic_N" ;
lin gottingen_PN = mkTerm "gottingen_PN" ;
lin gouache_N = mkTerm "gouache_N" ;
lin gouge_N = mkTerm "gouge_N" ;
lin gouge_V2 = mkTerm "gouge_V2" ;
lin gouger_N = mkTerm "gouger_N" ;
lin goulash_N = mkTerm "goulash_N" ;
lin gourd_N = mkTerm "gourd_N" ;
lin gourde_N = mkTerm "gourde_N" ;
lin gourmand_N = mkTerm "gourmand_N" ;
lin gourmandism_N = mkTerm "gourmandism_N" ;
lin gourmet_N = mkTerm "gourmet_N" ;
lin gourock_PN = mkTerm "gourock_PN" ;
lin gout_N = mkTerm "gout_N" ;
lin gouty_A = mkTerm "gouty_A" ;
lin gov_PN = mkTerm "gov_PN" ;
lin govern_V = mkTerm "govern_V" ;
lin govern_V2 = mkTerm "govern_V2" ;
lin governance_N = mkTerm "governance_N" ;
lin governed_N = mkTerm "governed_N" ;
lin governess_N = mkTerm "governess_N" ;
lin government_N = mkTerm "government_N" ;
lin governmental_A = mkTerm "governmental_A" ;
lin governor_N = mkTerm "governor_N" ;
lin governor_general_N = mkTerm "governor_general_N" ;
lin governorship_N = mkTerm "governorship_N" ;
lin govt_N = mkTerm "govt_N" ;
lin gown_N = mkTerm "gown_N" ;
lin gown_V2 = mkTerm "gown_V2" ;
lin gp_N = mkTerm "gp_N" ;
lin grab_N = mkTerm "grab_N" ;
lin grab_V = mkTerm "grab_V" ;
lin grab_V2 = mkTerm "grab_V2" ;
lin grabber_N = mkTerm "grabber_N" ;
lin grace_N = mkTerm "grace_N" ;
lin grace_V2 = mkTerm "grace_V2" ;
lin graceful_A = mkTerm "graceful_A" ;
lin gracefulness_N = mkTerm "gracefulness_N" ;
lin graceless_A = mkTerm "graceless_A" ;
lin gracelessness_N = mkTerm "gracelessness_N" ;
lin gracilariid_N = mkTerm "gracilariid_N" ;
lin gracile_A = mkTerm "gracile_A" ;
lin gracious_A = mkTerm "gracious_A" ;
lin graciousness_N = mkTerm "graciousness_N" ;
lin grackle_N = mkTerm "grackle_N" ;
lin grad_N = mkTerm "grad_N" ;
lin gradable_A = mkTerm "gradable_A" ;
lin gradation_N = mkTerm "gradation_N" ;
lin gradational_A = mkTerm "gradational_A" ;
lin grade_N = mkTerm "grade_N" ;
lin grade_V2 = mkTerm "grade_V2" ;
lin grader_N = mkTerm "grader_N" ;
lin gradient_N = mkTerm "gradient_N" ;
lin grading_N = mkTerm "grading_N" ;
lin gradual_A = mkTerm "gradual_A" ;
lin gradual_N = mkTerm "gradual_N" ;
lin graduality_N = mkTerm "graduality_N" ;
lin gradualness_N = mkTerm "gradualness_N" ;
lin graduate_N = mkTerm "graduate_N" ;
lin graduate_V = mkTerm "graduate_V" ;
lin graduate_V2 = mkTerm "graduate_V2" ;
lin graduation_N = mkTerm "graduation_N" ;
lin graffito_N = mkTerm "graffito_N" ;
lin graft_N = mkTerm "graft_N" ;
lin graft_V = mkTerm "graft_V" ;
lin graft_V2 = mkTerm "graft_V2" ;
lin grail_N = mkTerm "grail_N" ;
lin grain_N = mkTerm "grain_N" ;
lin grained_A = mkTerm "grained_A" ;
lin grainfield_N = mkTerm "grainfield_N" ;
lin graining_N = mkTerm "graining_N" ;
lin gram_N = mkTerm "gram_N" ;
lin grama_N = mkTerm "grama_N" ;
lin gramicidin_N = mkTerm "gramicidin_N" ;
lin grammar_N = mkTerm "grammar_N" ;
lin grammarian_N = mkTerm "grammarian_N" ;
lin grammatical_A = mkTerm "grammatical_A" ;
lin gramme_N = mkTerm "gramme_N" ;
lin gramophone_N = mkTerm "gramophone_N" ;
lin grampian_PN = mkTerm "grampian_PN" ;
lin grampus_N = mkTerm "grampus_N" ;
lin granada_PN = mkTerm "granada_PN" ;
lin granadilla_N = mkTerm "granadilla_N" ;
lin granary_N = mkTerm "granary_N" ;
lin grand_A = mkTerm "grand_A" ;
lin grand_prix_N = mkTerm "grand_prix_N" ;
lin grandad_N = mkTerm "grandad_N" ;
lin grandaunt_N = mkTerm "grandaunt_N" ;
lin grandchild_N = mkTerm "grandchild_N" ;
lin granddad_N = mkTerm "granddad_N" ;
lin granddaughter_N = mkTerm "granddaughter_N" ;
lin grandee_N = mkTerm "grandee_N" ;
lin grandeur_N = mkTerm "grandeur_N" ;
lin grandfather_N = mkTerm "grandfather_N" ;
lin grandiloquence_N = mkTerm "grandiloquence_N" ;
lin grandiloquent_A = mkTerm "grandiloquent_A" ;
lin grandiose_A = mkTerm "grandiose_A" ;
lin grandiosity_N = mkTerm "grandiosity_N" ;
lin grandma_N = mkTerm "grandma_N" ;
lin grandmaster_N = mkTerm "grandmaster_N" ;
lin grandmother_N = mkTerm "grandmother_N" ;
lin grandnephew_N = mkTerm "grandnephew_N" ;
lin grandniece_N = mkTerm "grandniece_N" ;
lin grandpa_N = mkTerm "grandpa_N" ;
lin grandparent_N = mkTerm "grandparent_N" ;
lin grandson_N = mkTerm "grandson_N" ;
lin grandstand_N = mkTerm "grandstand_N" ;
lin grandstander_N = mkTerm "grandstander_N" ;
lin granduncle_N = mkTerm "granduncle_N" ;
lin grange_N = mkTerm "grange_N" ;
lin grangemouth_PN = mkTerm "grangemouth_PN" ;
lin granite_N = mkTerm "granite_N" ;
lin graniteware_N = mkTerm "graniteware_N" ;
lin granitic_A = mkTerm "granitic_A" ;
lin grannie_N = mkTerm "grannie_N" ;
lin granny_N = mkTerm "granny_N" ;
lin granola_N = mkTerm "granola_N" ;
lin grant_N = mkTerm "grant_N" ;
lin grant_V2 = mkTerm "grant_V2" ;
lin grant_V3 = mkTerm "grant_V3" ;
lin grantee_N = mkTerm "grantee_N" ;
lin granter_N = mkTerm "granter_N" ;
lin grantham_PN = mkTerm "grantham_PN" ;
lin grantor_N = mkTerm "grantor_N" ;
lin granular_A = mkTerm "granular_A" ;
lin granularity_N = mkTerm "granularity_N" ;
lin granulate_V = mkTerm "granulate_V" ;
lin granulate_V2 = mkTerm "granulate_V2" ;
lin granulation_N = mkTerm "granulation_N" ;
lin granule_N = mkTerm "granule_N" ;
lin granuliferous_A = mkTerm "granuliferous_A" ;
lin granulocyte_N = mkTerm "granulocyte_N" ;
lin granulocytic_A = mkTerm "granulocytic_A" ;
lin granuloma_N = mkTerm "granuloma_N" ;
lin granulomatous_A = mkTerm "granulomatous_A" ;
lin grape_N = mkTerm "grape_N" ;
lin grape_sugar_N = mkTerm "grape_sugar_N" ;
lin grapefruit_N = mkTerm "grapefruit_N" ;
lin grapelike_A = mkTerm "grapelike_A" ;
lin grapeshot_N = mkTerm "grapeshot_N" ;
lin grapevine_N = mkTerm "grapevine_N" ;
lin grapey_A = mkTerm "grapey_A" ;
lin graph_N = mkTerm "graph_N" ;
lin graphic_A = mkTerm "graphic_A" ;
lin graphic_N = mkTerm "graphic_N" ;
lin graphical_A = mkTerm "graphical_A" ;
lin graphics_N = mkTerm "graphics_N" ;
lin graphite_N = mkTerm "graphite_N" ;
lin graphologist_N = mkTerm "graphologist_N" ;
lin graphology_N = mkTerm "graphology_N" ;
lin grapnel_N = mkTerm "grapnel_N" ;
lin grappa_N = mkTerm "grappa_N" ;
lin grapple_V = mkTerm "grapple_V" ;
lin grappling_iron_N = mkTerm "grappling_iron_N" ;
lin grasp_N = mkTerm "grasp_N" ;
lin grasp_V = mkTerm "grasp_V" ;
lin grasp_V2 = mkTerm "grasp_V2" ;
lin grasp_at_V2 = mkTerm "grasp_at_V2" ;
lin grasping_N = mkTerm "grasping_N" ;
lin grass_N = mkTerm "grass_N" ;
lin grass_V = mkTerm "grass_V" ;
lin grass_V2 = mkTerm "grass_V2" ;
lin grass_on_V2 = mkTerm "grass_on_V2" ;
lin grass_up_V2 = mkTerm "grass_up_V2" ;
lin grassfinch_N = mkTerm "grassfinch_N" ;
lin grassfire_N = mkTerm "grassfire_N" ;
lin grasshopper_N = mkTerm "grasshopper_N" ;
lin grassland_N = mkTerm "grassland_N" ;
lin grassless_A = mkTerm "grassless_A" ;
lin grasslike_A = mkTerm "grasslike_A" ;
lin grassroots_A = mkTerm "grassroots_A" ;
lin grassy_A = mkTerm "grassy_A" ;
lin grate_N = mkTerm "grate_N" ;
lin grate_V = mkTerm "grate_V" ;
lin grate_V2 = mkTerm "grate_V2" ;
lin grateful_A = mkTerm "grateful_A" ;
lin gratefulness_N = mkTerm "gratefulness_N" ;
lin grater_N = mkTerm "grater_N" ;
lin gratification_N = mkTerm "gratification_N" ;
lin gratify_V2 = mkTerm "gratify_V2" ;
lin gratifying_A = mkTerm "gratifying_A" ;
lin grating_N = mkTerm "grating_N" ;
lin gratingly_Adv = mkTerm "gratingly_Adv" ;
lin gratis_A = mkTerm "gratis_A" ;
lin gratis_Adv = mkTerm "gratis_Adv" ;
lin gratitude_N = mkTerm "gratitude_N" ;
lin gratuitous_A = mkTerm "gratuitous_A" ;
lin gratuity_N = mkTerm "gratuity_N" ;
lin grave_A = mkTerm "grave_A" ;
lin grave_N = mkTerm "grave_N" ;
lin grave_V2 = mkTerm "grave_V2" ;
lin gravedigger_N = mkTerm "gravedigger_N" ;
lin gravel_N = mkTerm "gravel_N" ;
lin gravel_V2 = mkTerm "gravel_V2" ;
lin gravelly_A = mkTerm "gravelly_A" ;
lin gravelweed_N = mkTerm "gravelweed_N" ;
lin graven_A = mkTerm "graven_A" ;
lin graveness_N = mkTerm "graveness_N" ;
lin gravenhage_PN = mkTerm "gravenhage_PN" ;
lin graver_N = mkTerm "graver_N" ;
lin graverobber_N = mkTerm "graverobber_N" ;
lin gravesend_PN = mkTerm "gravesend_PN" ;
lin gravestone_N = mkTerm "gravestone_N" ;
lin graveyard_N = mkTerm "graveyard_N" ;
lin gravida_N = mkTerm "gravida_N" ;
lin gravidity_N = mkTerm "gravidity_N" ;
lin gravimeter_N = mkTerm "gravimeter_N" ;
lin graving_dock_N = mkTerm "graving_dock_N" ;
lin gravitate_V = mkTerm "gravitate_V" ;
lin gravitation_N = mkTerm "gravitation_N" ;
lin gravitational_A = mkTerm "gravitational_A" ;
lin graviton_N = mkTerm "graviton_N" ;
lin gravity_N = mkTerm "gravity_N" ;
lin gravure_N = mkTerm "gravure_N" ;
lin gravy_N = mkTerm "gravy_N" ;
lin gravy_boat_N = mkTerm "gravy_boat_N" ;
lin graz_PN = mkTerm "graz_PN" ;
lin graze_N = mkTerm "graze_N" ;
lin graze_V = mkTerm "graze_V" ;
lin graze_V2 = mkTerm "graze_V2" ;
lin grazier_N = mkTerm "grazier_N" ;
lin grazing_N = mkTerm "grazing_N" ;
lin grazing_land_N = mkTerm "grazing_land_N" ;
lin grease_N = mkTerm "grease_N" ;
lin grease_V2 = mkTerm "grease_V2" ;
lin grease_gun_N = mkTerm "grease_gun_N" ;
lin greasepaint_N = mkTerm "greasepaint_N" ;
lin greaseproof_A = mkTerm "greaseproof_A" ;
lin greaser_N = mkTerm "greaser_N" ;
lin greasewood_N = mkTerm "greasewood_N" ;
lin greasiness_N = mkTerm "greasiness_N" ;
lin greasy_A = mkTerm "greasy_A" ;
lin great_A = mkTerm "great_A" ;
lin great_N = mkTerm "great_N" ;
lin great_harwood_PN = mkTerm "great_harwood_PN" ;
lin great_malvern_PN = mkTerm "great_malvern_PN" ;
lin great_shelford_PN = mkTerm "great_shelford_PN" ;
lin great_yarmouth_PN = mkTerm "great_yarmouth_PN" ;
lin greatcoat_N = mkTerm "greatcoat_N" ;
lin greater_A = mkTerm "greater_A" ;
lin greatest_A = mkTerm "greatest_A" ;
lin greathearted_A = mkTerm "greathearted_A" ;
lin greatly_Adv = mkTerm "greatly_Adv" ;
lin greatness_N = mkTerm "greatness_N" ;
lin greave_N = mkTerm "greave_N" ;
lin greaves_N = mkTerm "greaves_N" ;
lin grebe_N = mkTerm "grebe_N" ;
lin grecian_A = mkTerm "grecian_A" ;
lin greece_PN = mkTerm "greece_PN" ;
lin greed_N = mkTerm "greed_N" ;
lin greediness_N = mkTerm "greediness_N" ;
lin greedy_A = mkTerm "greedy_A" ;
lin greekFem_N = mkTerm "greekFem_N" ;
lin greekMasc_N = mkTerm "greekMasc_N" ;
lin greek_A = mkTerm "greek_A" ;
lin green_A = mkTerm "green_A" ;
lin green_N = mkTerm "green_N" ;
lin greenback_N = mkTerm "greenback_N" ;
lin greenbelt_N = mkTerm "greenbelt_N" ;
lin greenbottle_N = mkTerm "greenbottle_N" ;
lin greenery_N = mkTerm "greenery_N" ;
lin greeneye_N = mkTerm "greeneye_N" ;
lin greeneyed_A = mkTerm "greeneyed_A" ;
lin greenfly_N = mkTerm "greenfly_N" ;
lin greengage_N = mkTerm "greengage_N" ;
lin greengrocer_N = mkTerm "greengrocer_N" ;
lin greengrocery_N = mkTerm "greengrocery_N" ;
lin greenhorn_N = mkTerm "greenhorn_N" ;
lin greenhouse_A = mkTerm "greenhouse_A" ;
lin greenhouse_N = mkTerm "greenhouse_N" ;
lin greenish_A = mkTerm "greenish_A" ;
lin greenishness_N = mkTerm "greenishness_N" ;
lin greenling_N = mkTerm "greenling_N" ;
lin greenmail_N = mkTerm "greenmail_N" ;
lin greenness_N = mkTerm "greenness_N" ;
lin greenock_PN = mkTerm "greenock_PN" ;
lin greenockite_N = mkTerm "greenockite_N" ;
lin greenroom_N = mkTerm "greenroom_N" ;
lin greens_N = mkTerm "greens_N" ;
lin greensand_N = mkTerm "greensand_N" ;
lin greenshank_N = mkTerm "greenshank_N" ;
lin greenside_A = mkTerm "greenside_A" ;
lin greenskeeper_N = mkTerm "greenskeeper_N" ;
lin greensward_N = mkTerm "greensward_N" ;
lin greenwich_PN = mkTerm "greenwich_PN" ;
lin greenwing_N = mkTerm "greenwing_N" ;
lin greenwood_N = mkTerm "greenwood_N" ;
lin greet_V2 = mkTerm "greet_V2" ;
lin greeter_N = mkTerm "greeter_N" ;
lin greeting_N = mkTerm "greeting_N" ;
lin greg_PN = mkTerm "greg_PN" ;
lin gregarine_N = mkTerm "gregarine_N" ;
lin gregarious_A = mkTerm "gregarious_A" ;
lin gregariousness_N = mkTerm "gregariousness_N" ;
lin gregorian_A = mkTerm "gregorian_A" ;
lin gregory_PN = mkTerm "gregory_PN" ;
lin greisen_N = mkTerm "greisen_N" ;
lin gremlin_N = mkTerm "gremlin_N" ;
lin grenada_PN = mkTerm "grenada_PN" ;
lin grenade_N = mkTerm "grenade_N" ;
lin grenadian_A = mkTerm "grenadian_A" ;
lin grenadian_N = mkTerm "grenadian_N" ;
lin grenadier_N = mkTerm "grenadier_N" ;
lin grenadine_N = mkTerm "grenadine_N" ;
lin grevillea_N = mkTerm "grevillea_N" ;
lin grey_A = mkTerm "grey_A" ;
lin grey_N = mkTerm "grey_N" ;
lin grey_V = mkTerm "grey_V" ;
lin grey_V2 = mkTerm "grey_V2" ;
lin grey_headed_A = mkTerm "grey_headed_A" ;
lin grey_out_V2 = mkTerm "grey_out_V2" ;
lin greyback_N = mkTerm "greyback_N" ;
lin greybeard_N = mkTerm "greybeard_N" ;
lin greyhen_N = mkTerm "greyhen_N" ;
lin greyhound_N = mkTerm "greyhound_N" ;
lin greyish_A = mkTerm "greyish_A" ;
lin greylag_N = mkTerm "greylag_N" ;
lin grid_N = mkTerm "grid_N" ;
lin gridcolor_N = mkTerm "gridcolor_N" ;
lin griddle_N = mkTerm "griddle_N" ;
lin gridiron_N = mkTerm "gridiron_N" ;
lin gridlock_N = mkTerm "gridlock_N" ;
lin grief_N = mkTerm "grief_N" ;
lin grievance_N = mkTerm "grievance_N" ;
lin grieve_V = mkTerm "grieve_V" ;
lin grieve_V2 = mkTerm "grieve_V2" ;
lin grievous_A = mkTerm "grievous_A" ;
lin griffin_N = mkTerm "griffin_N" ;
lin griffon_N = mkTerm "griffon_N" ;
lin grigri_N = mkTerm "grigri_N" ;
lin grill_N = mkTerm "grill_N" ;
lin grill_V = mkTerm "grill_V" ;
lin grill_V2 = mkTerm "grill_V2" ;
lin grille_N = mkTerm "grille_N" ;
lin grillroom_N = mkTerm "grillroom_N" ;
lin grim_A = mkTerm "grim_A" ;
lin grimace_N = mkTerm "grimace_N" ;
lin grimace_V = mkTerm "grimace_V" ;
lin grime_N = mkTerm "grime_N" ;
lin grime_V2 = mkTerm "grime_V2" ;
lin grimethorpe_PN = mkTerm "grimethorpe_PN" ;
lin griminess_N = mkTerm "griminess_N" ;
lin grimness_N = mkTerm "grimness_N" ;
lin grimoire_N = mkTerm "grimoire_N" ;
lin grimsby_PN = mkTerm "grimsby_PN" ;
lin grimy_A = mkTerm "grimy_A" ;
lin grin_N = mkTerm "grin_N" ;
lin grin_V = mkTerm "grin_V" ;
lin grind_N = mkTerm "grind_N" ;
lin grind_V = mkTerm "grind_V" ;
lin grind_V2 = mkTerm "grind_V2" ;
lin grind_away_V = mkTerm "grind_away_V" ;
lin grind_down_V2 = mkTerm "grind_down_V2" ;
lin grind_into_V2 = mkTerm "grind_into_V2" ;
lin grind_on_V = mkTerm "grind_on_V" ;
lin grind_out_V2 = mkTerm "grind_out_V2" ;
lin grind_up_V2 = mkTerm "grind_up_V2" ;
lin grinder_N = mkTerm "grinder_N" ;
lin grinding_N = mkTerm "grinding_N" ;
lin grindstone_N = mkTerm "grindstone_N" ;
lin gringo_N = mkTerm "gringo_N" ;
lin grinner_N = mkTerm "grinner_N" ;
lin grinstead_PN = mkTerm "grinstead_PN" ;
lin griot_N = mkTerm "griot_N" ;
lin grip_N = mkTerm "grip_N" ;
lin grip_V2 = mkTerm "grip_V2" ;
lin gripe_N = mkTerm "gripe_N" ;
lin gripe_VS = mkTerm "gripe_VS" ;
lin grippe_N = mkTerm "grippe_N" ;
lin gripsack_N = mkTerm "gripsack_N" ;
lin grisaille_N = mkTerm "grisaille_N" ;
lin griseofulvin_N = mkTerm "griseofulvin_N" ;
lin grisly_A = mkTerm "grisly_A" ;
lin grison_N = mkTerm "grison_N" ;
lin grissino_N = mkTerm "grissino_N" ;
lin grist_N = mkTerm "grist_N" ;
lin gristle_N = mkTerm "gristle_N" ;
lin gristmill_N = mkTerm "gristmill_N" ;
lin grit_N = mkTerm "grit_N" ;
lin grit_V2 = mkTerm "grit_V2" ;
lin grits_N = mkTerm "grits_N" ;
lin gritty_A = mkTerm "gritty_A" ;
lin grivet_N = mkTerm "grivet_N" ;
lin grizzle_N = mkTerm "grizzle_N" ;
lin grizzle_V = mkTerm "grizzle_V" ;
lin grizzled_A = mkTerm "grizzled_A" ;
lin grizzly_N = mkTerm "grizzly_N" ;
lin groan_N = mkTerm "groan_N" ;
lin groan_V = mkTerm "groan_V" ;
lin groan_V2 = mkTerm "groan_V2" ;
lin groaner_N = mkTerm "groaner_N" ;
lin groat_N = mkTerm "groat_N" ;
lin groats_N = mkTerm "groats_N" ;
lin grocer_N = mkTerm "grocer_N" ;
lin grocery_N = mkTerm "grocery_N" ;
lin groenendael_N = mkTerm "groenendael_N" ;
lin grog_N = mkTerm "grog_N" ;
lin grogginess_N = mkTerm "grogginess_N" ;
lin groggy_A = mkTerm "groggy_A" ;
lin grogram_N = mkTerm "grogram_N" ;
lin groin_N = mkTerm "groin_N" ;
lin groin_V2 = mkTerm "groin_V2" ;
lin gromwell_N = mkTerm "gromwell_N" ;
lin groningen_PN = mkTerm "groningen_PN" ;
lin groom_N = mkTerm "groom_N" ;
lin groom_V2 = mkTerm "groom_V2" ;
lin groomsman_N = mkTerm "groomsman_N" ;
lin groove_N = mkTerm "groove_N" ;
lin groove_V2 = mkTerm "groove_V2" ;
lin groover_N = mkTerm "groover_N" ;
lin grooving_N = mkTerm "grooving_N" ;
lin groovy_A = mkTerm "groovy_A" ;
lin grope_N = mkTerm "grope_N" ;
lin grope_V = mkTerm "grope_V" ;
lin grope_V2 = mkTerm "grope_V2" ;
lin gropingly_Adv = mkTerm "gropingly_Adv" ;
lin grosbeak_N = mkTerm "grosbeak_N" ;
lin groschen_N = mkTerm "groschen_N" ;
lin grosgrain_N = mkTerm "grosgrain_N" ;
lin gross_A = mkTerm "gross_A" ;
lin gross_N = mkTerm "gross_N" ;
lin gross_V2 = mkTerm "gross_V2" ;
lin grossness_N = mkTerm "grossness_N" ;
lin grosz_N = mkTerm "grosz_N" ;
lin grot_N = mkTerm "grot_N" ;
lin grotesque_A = mkTerm "grotesque_A" ;
lin grotesque_N = mkTerm "grotesque_N" ;
lin grotesqueness_N = mkTerm "grotesqueness_N" ;
lin grotto_N = mkTerm "grotto_N" ;
lin grotty_A = mkTerm "grotty_A" ;
lin grouch_N = mkTerm "grouch_N" ;
lin grouch_V = mkTerm "grouch_V" ;
lin grouchy_A = mkTerm "grouchy_A" ;
lin ground_1_N = mkTerm "ground_1_N" ;
lin ground_2_N = mkTerm "ground_2_N" ;
lin ground_V = mkTerm "ground_V" ;
lin ground_V2 = mkTerm "ground_V2" ;
lin ground_bait_N = mkTerm "ground_bait_N" ;
lin ground_fish_N = mkTerm "ground_fish_N" ;
lin ground_plan_N = mkTerm "ground_plan_N" ;
lin ground_rent_N = mkTerm "ground_rent_N" ;
lin groundbreaking_A = mkTerm "groundbreaking_A" ;
lin groundbreaking_N = mkTerm "groundbreaking_N" ;
lin groundcover_N = mkTerm "groundcover_N" ;
lin grounder_N = mkTerm "grounder_N" ;
lin groundhog_N = mkTerm "groundhog_N" ;
lin grounding_N = mkTerm "grounding_N" ;
lin groundless_A = mkTerm "groundless_A" ;
lin groundlessness_N = mkTerm "groundlessness_N" ;
lin groundling_N = mkTerm "groundling_N" ;
lin groundmass_N = mkTerm "groundmass_N" ;
lin groundnut_N = mkTerm "groundnut_N" ;
lin grounds_N = mkTerm "grounds_N" ;
lin groundsel_N = mkTerm "groundsel_N" ;
lin groundsheet_N = mkTerm "groundsheet_N" ;
lin groundsman_N = mkTerm "groundsman_N" ;
lin groundspeed_N = mkTerm "groundspeed_N" ;
lin groundwater_N = mkTerm "groundwater_N" ;
lin groundwork_N = mkTerm "groundwork_N" ;
lin group_N = mkTerm "group_N" ;
lin group_V = mkTerm "group_V" ;
lin group_V2 = mkTerm "group_V2" ;
lin grouper_N = mkTerm "grouper_N" ;
lin groupie_N = mkTerm "groupie_N" ;
lin grouping_N = mkTerm "grouping_N" ;
lin groupthink_N = mkTerm "groupthink_N" ;
lin groupware_N = mkTerm "groupware_N" ;
lin grouse_N = mkTerm "grouse_N" ;
lin grouse_V = mkTerm "grouse_V" ;
lin grouse_VS = mkTerm "grouse_VS" ;
lin grouseberry_N = mkTerm "grouseberry_N" ;
lin grout_N = mkTerm "grout_N" ;
lin grove_N = mkTerm "grove_N" ;
lin grovel_V = mkTerm "grovel_V" ;
lin groveller_N = mkTerm "groveller_N" ;
lin grow_V = mkTerm "grow_V" ;
lin grow_V2 = mkTerm "grow_V2" ;
lin grow_VA = mkTerm "grow_VA" ;
lin grow_apart_V = mkTerm "grow_apart_V" ;
lin grow_away_from_V2 = mkTerm "grow_away_from_V2" ;
lin grow_back_V = mkTerm "grow_back_V" ;
lin grow_from_V2 = mkTerm "grow_from_V2" ;
lin grow_into_V2 = mkTerm "grow_into_V2" ;
lin grow_on_V2 = mkTerm "grow_on_V2" ;
lin grow_out_V = mkTerm "grow_out_V" ;
lin grow_out_of_V2 = mkTerm "grow_out_of_V2" ;
lin grow_to_V = mkTerm "grow_to_V" ;
lin grow_together_V = mkTerm "grow_together_V" ;
lin grow_under_V = mkTerm "grow_under_V" ;
lin grow_up_V = mkTerm "grow_up_V" ;
lin grow_up_on_V2 = mkTerm "grow_up_on_V2" ;
lin grow_upon_V2 = mkTerm "grow_upon_V2" ;
lin grower_N = mkTerm "grower_N" ;
lin growing_A = mkTerm "growing_A" ;
lin growing_N = mkTerm "growing_N" ;
lin growl_N = mkTerm "growl_N" ;
lin growl_V = mkTerm "growl_V" ;
lin growl_V2 = mkTerm "growl_V2" ;
lin growler_N = mkTerm "growler_N" ;
lin growling_N = mkTerm "growling_N" ;
lin growlingly_Adv = mkTerm "growlingly_Adv" ;
lin grown_up_A = mkTerm "grown_up_A" ;
lin grown_up_N = mkTerm "grown_up_N" ;
lin growth_N = mkTerm "growth_N" ;
lin groyne_N = mkTerm "groyne_N" ;
lin grub_N = mkTerm "grub_N" ;
lin grub_V = mkTerm "grub_V" ;
lin grub_V2 = mkTerm "grub_V2" ;
lin grubbiness_N = mkTerm "grubbiness_N" ;
lin grubby_A = mkTerm "grubby_A" ;
lin grubby_N = mkTerm "grubby_N" ;
lin grubstake_N = mkTerm "grubstake_N" ;
lin grudge_N = mkTerm "grudge_N" ;
lin grudge_V2 = mkTerm "grudge_V2" ;
lin grudging_A = mkTerm "grudging_A" ;
lin gruel_N = mkTerm "gruel_N" ;
lin gruelling_A = mkTerm "gruelling_A" ;
lin gruesome_A = mkTerm "gruesome_A" ;
lin gruesomeness_N = mkTerm "gruesomeness_N" ;
lin gruff_A = mkTerm "gruff_A" ;
lin gruffness_N = mkTerm "gruffness_N" ;
lin grugru_N = mkTerm "grugru_N" ;
lin grumble_N = mkTerm "grumble_N" ;
lin grumble_V = mkTerm "grumble_V" ;
lin grumble_V2 = mkTerm "grumble_V2" ;
lin grumble_VS = mkTerm "grumble_VS" ;
lin grumbler_N = mkTerm "grumbler_N" ;
lin grume_N = mkTerm "grume_N" ;
lin grumpiness_N = mkTerm "grumpiness_N" ;
lin grumpy_A = mkTerm "grumpy_A" ;
lin grundyism_N = mkTerm "grundyism_N" ;
lin grunge_N = mkTerm "grunge_N" ;
lin grunt_N = mkTerm "grunt_N" ;
lin grunt_V = mkTerm "grunt_V" ;
lin grunt_V2 = mkTerm "grunt_V2" ;
lin grunter_N = mkTerm "grunter_N" ;
lin gryphon_N = mkTerm "gryphon_N" ;
lin guacamole_N = mkTerm "guacamole_N" ;
lin guadalajara_PN = mkTerm "guadalajara_PN" ;
lin guaiacum_N = mkTerm "guaiacum_N" ;
lin guama_N = mkTerm "guama_N" ;
lin guan_N = mkTerm "guan_N" ;
lin guanabenz_N = mkTerm "guanabenz_N" ;
lin guanaco_N = mkTerm "guanaco_N" ;
lin guanine_N = mkTerm "guanine_N" ;
lin guano_N = mkTerm "guano_N" ;
lin guar_N = mkTerm "guar_N" ;
lin guarani_N = mkTerm "guarani_N" ;
lin guarantee_N = mkTerm "guarantee_N" ;
lin guarantee_V = mkTerm "guarantee_V" ;
lin guarantee_V2 = mkTerm "guarantee_V2" ;
lin guarantee_VS = mkTerm "guarantee_VS" ;
lin guarantor_N = mkTerm "guarantor_N" ;
lin guaranty_N = mkTerm "guaranty_N" ;
lin guard_N = mkTerm "guard_N" ;
lin guard_V = mkTerm "guard_V" ;
lin guard_V2 = mkTerm "guard_V2" ;
lin guard_boat_N = mkTerm "guard_boat_N" ;
lin guardhouse_N = mkTerm "guardhouse_N" ;
lin guardian_N = mkTerm "guardian_N" ;
lin guardianship_N = mkTerm "guardianship_N" ;
lin guardrail_N = mkTerm "guardrail_N" ;
lin guardroom_N = mkTerm "guardroom_N" ;
lin guardship_N = mkTerm "guardship_N" ;
lin guardsman_N = mkTerm "guardsman_N" ;
lin guatemala_PN = mkTerm "guatemala_PN" ;
lin guatemala_city_PN = mkTerm "guatemala_city_PN" ;
lin guatemalan_A = mkTerm "guatemalan_A" ;
lin guatemalan_N = mkTerm "guatemalan_N" ;
lin guava_N = mkTerm "guava_N" ;
lin guayaquil_PN = mkTerm "guayaquil_PN" ;
lin guayule_N = mkTerm "guayule_N" ;
lin gubernatorial_A = mkTerm "gubernatorial_A" ;
lin gudgeon_N = mkTerm "gudgeon_N" ;
lin guelder_rose_N = mkTerm "guelder_rose_N" ;
lin guenon_N = mkTerm "guenon_N" ;
lin guerdon_N = mkTerm "guerdon_N" ;
lin guereza_N = mkTerm "guereza_N" ;
lin gueridon_N = mkTerm "gueridon_N" ;
lin guerilla_N = mkTerm "guerilla_N" ;
lin guerrilla_N = mkTerm "guerrilla_N" ;
lin guess_N = mkTerm "guess_N" ;
lin guess_V = mkTerm "guess_V" ;
lin guess_V2 = mkTerm "guess_V2" ;
lin guess_VS = mkTerm "guess_VS" ;
lin guesser_N = mkTerm "guesser_N" ;
lin guesstimate_N = mkTerm "guesstimate_N" ;
lin guesswork_N = mkTerm "guesswork_N" ;
lin guest_N = mkTerm "guest_N" ;
lin guest_night_N = mkTerm "guest_night_N" ;
lin guesthouse_N = mkTerm "guesthouse_N" ;
lin guestroom_N = mkTerm "guestroom_N" ;
lin guffaw_N = mkTerm "guffaw_N" ;
lin guffaw_V = mkTerm "guffaw_V" ;
lin guidance_N = mkTerm "guidance_N" ;
lin guide_N = mkTerm "guide_N" ;
lin guide_V2 = mkTerm "guide_V2" ;
lin guidebook_N = mkTerm "guidebook_N" ;
lin guideline_N = mkTerm "guideline_N" ;
lin guidelines_N = mkTerm "guidelines_N" ;
lin guidepost_N = mkTerm "guidepost_N" ;
lin guiding_A = mkTerm "guiding_A" ;
lin guild_N = mkTerm "guild_N" ;
lin guild_hall_N = mkTerm "guild_hall_N" ;
lin guilder_N = mkTerm "guilder_N" ;
lin guildford_PN = mkTerm "guildford_PN" ;
lin guile_N = mkTerm "guile_N" ;
lin guileful_A = mkTerm "guileful_A" ;
lin guileless_A = mkTerm "guileless_A" ;
lin guillemot_N = mkTerm "guillemot_N" ;
lin guilloche_N = mkTerm "guilloche_N" ;
lin guillotine_N = mkTerm "guillotine_N" ;
lin guillotine_V2 = mkTerm "guillotine_V2" ;
lin guilt_N = mkTerm "guilt_N" ;
lin guiltiness_N = mkTerm "guiltiness_N" ;
lin guiltless_A = mkTerm "guiltless_A" ;
lin guilty_A = mkTerm "guilty_A" ;
lin guimpe_N = mkTerm "guimpe_N" ;
lin guinea_N = mkTerm "guinea_N" ;
lin guinea_PN = mkTerm "guinea_PN" ;
lin guinea_fowl_N = mkTerm "guinea_fowl_N" ;
lin guinea_pig_N = mkTerm "guinea_pig_N" ;
lin guinean_A = mkTerm "guinean_A" ;
lin guinean_N = mkTerm "guinean_N" ;
lin guinness_N = mkTerm "guinness_N" ;
lin guisborough_PN = mkTerm "guisborough_PN" ;
lin guise_N = mkTerm "guise_N" ;
lin guitar_N = mkTerm "guitar_N" ;
lin guitarfish_N = mkTerm "guitarfish_N" ;
lin guitarist_N = mkTerm "guitarist_N" ;
lin gulag_N = mkTerm "gulag_N" ;
lin gulch_N = mkTerm "gulch_N" ;
lin gulden_N = mkTerm "gulden_N" ;
lin gulf_N = mkTerm "gulf_N" ;
lin gulfweed_N = mkTerm "gulfweed_N" ;
lin gull_1_N = mkTerm "gull_1_N" ;
lin gull_2_N = mkTerm "gull_2_N" ;
lin gull_V2 = mkTerm "gull_V2" ;
lin gullet_N = mkTerm "gullet_N" ;
lin gullibility_N = mkTerm "gullibility_N" ;
lin gullible_A = mkTerm "gullible_A" ;
lin gully_N = mkTerm "gully_N" ;
lin gulp_N = mkTerm "gulp_N" ;
lin gulp_V = mkTerm "gulp_V" ;
lin gulp_V2 = mkTerm "gulp_V2" ;
lin gulper_N = mkTerm "gulper_N" ;
lin gulping_N = mkTerm "gulping_N" ;
lin gum_N = mkTerm "gum_N" ;
lin gum_V2 = mkTerm "gum_V2" ;
lin gumbo_N = mkTerm "gumbo_N" ;
lin gumboil_N = mkTerm "gumboil_N" ;
lin gumboot_N = mkTerm "gumboot_N" ;
lin gumdrop_N = mkTerm "gumdrop_N" ;
lin gumma_N = mkTerm "gumma_N" ;
lin gummite_N = mkTerm "gummite_N" ;
lin gummosis_N = mkTerm "gummosis_N" ;
lin gummy_A = mkTerm "gummy_A" ;
lin gumption_N = mkTerm "gumption_N" ;
lin gumshoe_N = mkTerm "gumshoe_N" ;
lin gumweed_N = mkTerm "gumweed_N" ;
lin gumwood_N = mkTerm "gumwood_N" ;
lin gun_N = mkTerm "gun_N" ;
lin gun_V2 = mkTerm "gun_V2" ;
lin gun_carriage_N = mkTerm "gun_carriage_N" ;
lin gun_for_V2 = mkTerm "gun_for_V2" ;
lin gunboat_N = mkTerm "gunboat_N" ;
lin guncotton_N = mkTerm "guncotton_N" ;
lin gundog_N = mkTerm "gundog_N" ;
lin gunfight_N = mkTerm "gunfight_N" ;
lin gunfire_N = mkTerm "gunfire_N" ;
lin gunflint_N = mkTerm "gunflint_N" ;
lin gunite_N = mkTerm "gunite_N" ;
lin gunlock_N = mkTerm "gunlock_N" ;
lin gunman_N = mkTerm "gunman_N" ;
lin gunmetal_N = mkTerm "gunmetal_N" ;
lin gunnel_N = mkTerm "gunnel_N" ;
lin gunner_N = mkTerm "gunner_N" ;
lin gunnery_N = mkTerm "gunnery_N" ;
lin gunny_N = mkTerm "gunny_N" ;
lin gunnysack_N = mkTerm "gunnysack_N" ;
lin gunplay_N = mkTerm "gunplay_N" ;
lin gunpoint_N = mkTerm "gunpoint_N" ;
lin gunpowder_N = mkTerm "gunpowder_N" ;
lin gunroom_N = mkTerm "gunroom_N" ;
lin gunrunner_N = mkTerm "gunrunner_N" ;
lin gunrunning_N = mkTerm "gunrunning_N" ;
lin gunshot_N = mkTerm "gunshot_N" ;
lin gunsight_N = mkTerm "gunsight_N" ;
lin gunsmith_N = mkTerm "gunsmith_N" ;
lin gunwale_N = mkTerm "gunwale_N" ;
lin guppy_N = mkTerm "guppy_N" ;
lin gurgle_N = mkTerm "gurgle_N" ;
lin gurgle_V = mkTerm "gurgle_V" ;
lin gurkha_N = mkTerm "gurkha_N" ;
lin gurnard_N = mkTerm "gurnard_N" ;
lin gurney_N = mkTerm "gurney_N" ;
lin guru_N = mkTerm "guru_N" ;
lin gush_N = mkTerm "gush_N" ;
lin gush_V = mkTerm "gush_V" ;
lin gusher_N = mkTerm "gusher_N" ;
lin gushingly_Adv = mkTerm "gushingly_Adv" ;
lin gusset_N = mkTerm "gusset_N" ;
lin gusseted_A = mkTerm "gusseted_A" ;
lin gussy_up_V2 = mkTerm "gussy_up_V2" ;
lin gust_N = mkTerm "gust_N" ;
lin gustation_N = mkTerm "gustation_N" ;
lin gustatory_A = mkTerm "gustatory_A" ;
lin gusto_N = mkTerm "gusto_N" ;
lin gusty_A = mkTerm "gusty_A" ;
lin gut_N = mkTerm "gut_N" ;
lin gut_V2 = mkTerm "gut_V2" ;
lin gutless_A = mkTerm "gutless_A" ;
lin gutlessness_N = mkTerm "gutlessness_N" ;
lin gutsiness_N = mkTerm "gutsiness_N" ;
lin gutsy_A = mkTerm "gutsy_A" ;
lin gutta_percha_N = mkTerm "gutta_percha_N" ;
lin gutter_N = mkTerm "gutter_N" ;
lin gutter_V = mkTerm "gutter_V" ;
lin guttersnipe_N = mkTerm "guttersnipe_N" ;
lin guttural_A = mkTerm "guttural_A" ;
lin guttural_N = mkTerm "guttural_N" ;
lin guvnor_N = mkTerm "guvnor_N" ;
lin guy's_PN = mkTerm "guy's_PN" ;
lin guy_N = mkTerm "guy_N" ;
lin guy_PN = mkTerm "guy_PN" ;
lin guy_V2 = mkTerm "guy_V2" ;
lin guyana_PN = mkTerm "guyana_PN" ;
lin guyanese_A = mkTerm "guyanese_A" ;
lin guyanese_N = mkTerm "guyanese_N" ;
lin guyot_N = mkTerm "guyot_N" ;
lin guzzle_V = mkTerm "guzzle_V" ;
lin guzzle_V2 = mkTerm "guzzle_V2" ;
lin guzzler_N = mkTerm "guzzler_N" ;
lin gwen_PN = mkTerm "gwen_PN" ;
lin gwendoline_PN = mkTerm "gwendoline_PN" ;
lin gwent_PN = mkTerm "gwent_PN" ;
lin gwersyllt_PN = mkTerm "gwersyllt_PN" ;
lin gwynedd_PN = mkTerm "gwynedd_PN" ;
lin gybe_V = mkTerm "gybe_V" ;
lin gybe_V2 = mkTerm "gybe_V2" ;
lin gym_N = mkTerm "gym_N" ;
lin gymkhana_N = mkTerm "gymkhana_N" ;
lin gymnasium_N = mkTerm "gymnasium_N" ;
lin gymnast_N = mkTerm "gymnast_N" ;
lin gymnastic_A = mkTerm "gymnastic_A" ;
lin gymnastics_N = mkTerm "gymnastics_N" ;
lin gymnosophical_A = mkTerm "gymnosophical_A" ;
lin gymnosophist_N = mkTerm "gymnosophist_N" ;
lin gymnosophy_N = mkTerm "gymnosophy_N" ;
lin gymnosperm_N = mkTerm "gymnosperm_N" ;
lin gymnospermous_A = mkTerm "gymnospermous_A" ;
lin gymslip_N = mkTerm "gymslip_N" ;
lin gynaecological_A = mkTerm "gynaecological_A" ;
lin gynaecologist_N = mkTerm "gynaecologist_N" ;
lin gynaecology_N = mkTerm "gynaecology_N" ;
lin gynandromorphic_A = mkTerm "gynandromorphic_A" ;
lin gynecocracy_N = mkTerm "gynecocracy_N" ;
lin gynecological_A = mkTerm "gynecological_A" ;
lin gynecologistFem_N = mkTerm "gynecologistFem_N" ;
lin gynecologistMasc_N = mkTerm "gynecologistMasc_N" ;
lin gynecology_N = mkTerm "gynecology_N" ;
lin gynecomastia_N = mkTerm "gynecomastia_N" ;
lin gyneolatry_N = mkTerm "gyneolatry_N" ;
lin gynobase_N = mkTerm "gynobase_N" ;
lin gynoecium_N = mkTerm "gynoecium_N" ;
lin gynogenesis_N = mkTerm "gynogenesis_N" ;
lin gynophobia_N = mkTerm "gynophobia_N" ;
lin gynophore_N = mkTerm "gynophore_N" ;
lin gynostegium_N = mkTerm "gynostegium_N" ;
lin gyp_N = mkTerm "gyp_N" ;
lin gyp_V2 = mkTerm "gyp_V2" ;
lin gypsum_N = mkTerm "gypsum_N" ;
lin gypsy_N = mkTerm "gypsy_N" ;
lin gyral_A = mkTerm "gyral_A" ;
lin gyrate_V = mkTerm "gyrate_V" ;
lin gyration_N = mkTerm "gyration_N" ;
lin gyrfalcon_N = mkTerm "gyrfalcon_N" ;
lin gyro_N = mkTerm "gyro_N" ;
lin gyrocompass_N = mkTerm "gyrocompass_N" ;
lin gyromitra_N = mkTerm "gyromitra_N" ;
lin gyroscope_N = mkTerm "gyroscope_N" ;
lin gyroscopic_A = mkTerm "gyroscopic_A" ;
lin gyrostabilizer_N = mkTerm "gyrostabilizer_N" ;
lin gyrus_N = mkTerm "gyrus_N" ;
lin h'm_V = mkTerm "h'm_V" ;
lin h_bomb_N = mkTerm "h_bomb_N" ;
lin ha'p'orth_N = mkTerm "ha'p'orth_N" ;
lin ha'penny_N = mkTerm "ha'penny_N" ;
lin ha_Interj = mkTerm "ha_Interj" ;
lin haapajärvi_PN = mkTerm "haapajärvi_PN" ;
lin haapavesi_PN = mkTerm "haapavesi_PN" ;
lin haarlem_PN = mkTerm "haarlem_PN" ;
lin habanera_N = mkTerm "habanera_N" ;
lin habeas_corpus_N = mkTerm "habeas_corpus_N" ;
lin haberdasher_N = mkTerm "haberdasher_N" ;
lin haberdashery_N = mkTerm "haberdashery_N" ;
lin habergeon_N = mkTerm "habergeon_N" ;
lin habit_N = mkTerm "habit_N" ;
lin habitability_N = mkTerm "habitability_N" ;
lin habitable_A = mkTerm "habitable_A" ;
lin habitat_N = mkTerm "habitat_N" ;
lin habitation_N = mkTerm "habitation_N" ;
lin habited_A = mkTerm "habited_A" ;
lin habitual_A = mkTerm "habitual_A" ;
lin habituate_V2 = mkTerm "habituate_V2" ;
lin habituation_N = mkTerm "habituation_N" ;
lin habitude_N = mkTerm "habitude_N" ;
lin habitue_N = mkTerm "habitue_N" ;
lin habitus_N = mkTerm "habitus_N" ;
lin hacek_N = mkTerm "hacek_N" ;
lin hacienda_N = mkTerm "hacienda_N" ;
lin hack_N = mkTerm "hack_N" ;
lin hack_V = mkTerm "hack_V" ;
lin hack_V2 = mkTerm "hack_V2" ;
lin hack_around_V = mkTerm "hack_around_V" ;
lin hack_away_V = mkTerm "hack_away_V" ;
lin hack_into_V2 = mkTerm "hack_into_V2" ;
lin hack_off_V2 = mkTerm "hack_off_V2" ;
lin hack_up_V2 = mkTerm "hack_up_V2" ;
lin hackberry_N = mkTerm "hackberry_N" ;
lin hacker_N = mkTerm "hacker_N" ;
lin hackle_N = mkTerm "hackle_N" ;
lin hackney_N = mkTerm "hackney_N" ;
lin hackney_PN = mkTerm "hackney_PN" ;
lin hackneyed_A = mkTerm "hackneyed_A" ;
lin hacksaw_N = mkTerm "hacksaw_N" ;
lin hackwork_N = mkTerm "hackwork_N" ;
lin hadal_A = mkTerm "hadal_A" ;
lin haddington_PN = mkTerm "haddington_PN" ;
lin haddock_N = mkTerm "haddock_N" ;
lin hades_PN = mkTerm "hades_PN" ;
lin hadith_N = mkTerm "hadith_N" ;
lin hadji_N = mkTerm "hadji_N" ;
lin hadron_N = mkTerm "hadron_N" ;
lin hadrosaur_N = mkTerm "hadrosaur_N" ;
lin haematite_N = mkTerm "haematite_N" ;
lin haemoglobin_N = mkTerm "haemoglobin_N" ;
lin haemophilia_N = mkTerm "haemophilia_N" ;
lin haemophiliac_N = mkTerm "haemophiliac_N" ;
lin haemophilic_A = mkTerm "haemophilic_A" ;
lin haemoproteid_N = mkTerm "haemoproteid_N" ;
lin haemorrhage_N = mkTerm "haemorrhage_N" ;
lin haemosporidian_N = mkTerm "haemosporidian_N" ;
lin hafnium_N = mkTerm "hafnium_N" ;
lin haft_N = mkTerm "haft_N" ;
lin hag_N = mkTerm "hag_N" ;
lin hag_ridden_A = mkTerm "hag_ridden_A" ;
lin hagberry_N = mkTerm "hagberry_N" ;
lin hagen_PN = mkTerm "hagen_PN" ;
lin hagfish_N = mkTerm "hagfish_N" ;
lin haggard_A = mkTerm "haggard_A" ;
lin haggis_N = mkTerm "haggis_N" ;
lin haggle_N = mkTerm "haggle_N" ;
lin haggle_V = mkTerm "haggle_V" ;
lin haggler_N = mkTerm "haggler_N" ;
lin hagiographer_N = mkTerm "hagiographer_N" ;
lin hagiography_N = mkTerm "hagiography_N" ;
lin hagiolatry_N = mkTerm "hagiolatry_N" ;
lin hagiology_N = mkTerm "hagiology_N" ;
lin hagley_PN = mkTerm "hagley_PN" ;
lin haha_N = mkTerm "haha_N" ;
lin haik_N = mkTerm "haik_N" ;
lin haiku_N = mkTerm "haiku_N" ;
lin hail_N = mkTerm "hail_N" ;
lin hail_V = mkTerm "hail_V" ;
lin hail_V2 = mkTerm "hail_V2" ;
lin hailsham_PN = mkTerm "hailsham_PN" ;
lin hailstone_N = mkTerm "hailstone_N" ;
lin hailstorm_N = mkTerm "hailstorm_N" ;
lin hailuoto_PN = mkTerm "hailuoto_PN" ;
lin haiphong_PN = mkTerm "haiphong_PN" ;
lin hair's_breadth_N = mkTerm "hair's_breadth_N" ;
lin hair_N = mkTerm "hair_N" ;
lin hair_breadth_N = mkTerm "hair_breadth_N" ;
lin hair_dye_N = mkTerm "hair_dye_N" ;
lin hair_oil_N = mkTerm "hair_oil_N" ;
lin hair_raising_A = mkTerm "hair_raising_A" ;
lin hair_shirt_N = mkTerm "hair_shirt_N" ;
lin hair_slide_N = mkTerm "hair_slide_N" ;
lin hair_trigger_N = mkTerm "hair_trigger_N" ;
lin hairball_N = mkTerm "hairball_N" ;
lin hairbrush_N = mkTerm "hairbrush_N" ;
lin haircloth_N = mkTerm "haircloth_N" ;
lin haircut_N = mkTerm "haircut_N" ;
lin hairdo_N = mkTerm "hairdo_N" ;
lin hairdresser_N = mkTerm "hairdresser_N" ;
lin hairdressing_N = mkTerm "hairdressing_N" ;
lin hairiness_N = mkTerm "hairiness_N" ;
lin hairless_A = mkTerm "hairless_A" ;
lin hairlessness_N = mkTerm "hairlessness_N" ;
lin hairlike_A = mkTerm "hairlike_A" ;
lin hairline_N = mkTerm "hairline_N" ;
lin hairnet_N = mkTerm "hairnet_N" ;
lin hairpiece_N = mkTerm "hairpiece_N" ;
lin hairpin_N = mkTerm "hairpin_N" ;
lin hairsplitter_N = mkTerm "hairsplitter_N" ;
lin hairsplitting_A = mkTerm "hairsplitting_A" ;
lin hairsplitting_N = mkTerm "hairsplitting_N" ;
lin hairspring_N = mkTerm "hairspring_N" ;
lin hairstreak_N = mkTerm "hairstreak_N" ;
lin hairstyle_N = mkTerm "hairstyle_N" ;
lin hairstylist_N = mkTerm "hairstylist_N" ;
lin hairweaving_N = mkTerm "hairweaving_N" ;
lin hairy_A = mkTerm "hairy_A" ;
lin haiti_PN = mkTerm "haiti_PN" ;
lin haitian_A = mkTerm "haitian_A" ;
lin haitian_N = mkTerm "haitian_N" ;
lin hajj_N = mkTerm "hajj_N" ;
lin hajji_N = mkTerm "hajji_N" ;
lin hake_N = mkTerm "hake_N" ;
lin hakim_N = mkTerm "hakim_N" ;
lin hal_PN = mkTerm "hal_PN" ;
lin halal_A = mkTerm "halal_A" ;
lin halal_N = mkTerm "halal_N" ;
lin halberd_N = mkTerm "halberd_N" ;
lin halberdier_N = mkTerm "halberdier_N" ;
lin halcyon_A = mkTerm "halcyon_A" ;
lin halcyon_N = mkTerm "halcyon_N" ;
lin hale_A = mkTerm "hale_A" ;
lin haler_N = mkTerm "haler_N" ;
lin halesowen_PN = mkTerm "halesowen_PN" ;
lin half_A = mkTerm "half_A" ;
lin half_Adv = mkTerm "half_Adv" ;
lin half_N = mkTerm "half_N" ;
lin half_Predet = mkTerm "half_Predet" ;
lin half_baked_A = mkTerm "half_baked_A" ;
lin half_blood_N = mkTerm "half_blood_N" ;
lin half_breed_N = mkTerm "half_breed_N" ;
lin half_brother_N = mkTerm "half_brother_N" ;
lin half_caste_N = mkTerm "half_caste_N" ;
lin half_crazed_A = mkTerm "half_crazed_A" ;
lin half_crown_N = mkTerm "half_crown_N" ;
lin half_hardy_A = mkTerm "half_hardy_A" ;
lin half_hearted_A = mkTerm "half_hearted_A" ;
lin half_holiday_N = mkTerm "half_holiday_N" ;
lin half_hour_N = mkTerm "half_hour_N" ;
lin half_hourly_A = mkTerm "half_hourly_A" ;
lin half_hourly_Adv = mkTerm "half_hourly_Adv" ;
lin half_length_A = mkTerm "half_length_A" ;
lin half_pay_N = mkTerm "half_pay_N" ;
lin half_price_Adv = mkTerm "half_price_Adv" ;
lin half_seas_over_A = mkTerm "half_seas_over_A" ;
lin half_sister_N = mkTerm "half_sister_N" ;
lin half_size_A = mkTerm "half_size_A" ;
lin half_timbered_A = mkTerm "half_timbered_A" ;
lin half_time_N = mkTerm "half_time_N" ;
lin half_track_N = mkTerm "half_track_N" ;
lin half_tracked_A = mkTerm "half_tracked_A" ;
lin half_truth_N = mkTerm "half_truth_N" ;
lin half_volley_N = mkTerm "half_volley_N" ;
lin half_yearly_A = mkTerm "half_yearly_A" ;
lin half_yearly_Adv = mkTerm "half_yearly_Adv" ;
lin halfback_N = mkTerm "halfback_N" ;
lin halfbeak_N = mkTerm "halfbeak_N" ;
lin halfhearted_A = mkTerm "halfhearted_A" ;
lin halfpenny_N = mkTerm "halfpenny_N" ;
lin halfpennyworth_N = mkTerm "halfpennyworth_N" ;
lin halftime_N = mkTerm "halftime_N" ;
lin halftone_N = mkTerm "halftone_N" ;
lin halfway_A = mkTerm "halfway_A" ;
lin halfway_Adv = mkTerm "halfway_Adv" ;
lin halfwit_N = mkTerm "halfwit_N" ;
lin halfwitted_A = mkTerm "halfwitted_A" ;
lin halibut_N = mkTerm "halibut_N" ;
lin halide_N = mkTerm "halide_N" ;
lin halifax_PN = mkTerm "halifax_PN" ;
lin halikko_PN = mkTerm "halikko_PN" ;
lin halite_N = mkTerm "halite_N" ;
lin halitosis_N = mkTerm "halitosis_N" ;
lin halitus_N = mkTerm "halitus_N" ;
lin hall_N = mkTerm "hall_N" ;
lin hall_stand_N = mkTerm "hall_stand_N" ;
lin halle_PN = mkTerm "halle_PN" ;
lin hallelujah_N = mkTerm "hallelujah_N" ;
lin halliard_N = mkTerm "halliard_N" ;
lin hallmark_N = mkTerm "hallmark_N" ;
lin halloo_N = mkTerm "halloo_N" ;
lin halloo_V = mkTerm "halloo_V" ;
lin hallow_N = mkTerm "hallow_N" ;
lin hallow_V2 = mkTerm "hallow_V2" ;
lin hallowe'en_N = mkTerm "hallowe'en_N" ;
lin hallowe'en_PN = mkTerm "hallowe'en_PN" ;
lin hallucination_N = mkTerm "hallucination_N" ;
lin hallucinatory_A = mkTerm "hallucinatory_A" ;
lin hallucinogen_N = mkTerm "hallucinogen_N" ;
lin hallucinogenic_A = mkTerm "hallucinogenic_A" ;
lin hallucinosis_N = mkTerm "hallucinosis_N" ;
lin hallway_N = mkTerm "hallway_N" ;
lin halma_N = mkTerm "halma_N" ;
lin halo_N = mkTerm "halo_N" ;
lin halobacteria_N = mkTerm "halobacteria_N" ;
lin halocarbon_N = mkTerm "halocarbon_N" ;
lin haloform_N = mkTerm "haloform_N" ;
lin halogen_N = mkTerm "halogen_N" ;
lin halogeton_N = mkTerm "halogeton_N" ;
lin halon_N = mkTerm "halon_N" ;
lin haloperidol_N = mkTerm "haloperidol_N" ;
lin halophile_N = mkTerm "halophile_N" ;
lin halophyte_N = mkTerm "halophyte_N" ;
lin halothane_N = mkTerm "halothane_N" ;
lin halstead_PN = mkTerm "halstead_PN" ;
lin halsua_PN = mkTerm "halsua_PN" ;
lin halt_A = mkTerm "halt_A" ;
lin halt_N = mkTerm "halt_N" ;
lin halt_V = mkTerm "halt_V" ;
lin halt_V2 = mkTerm "halt_V2" ;
lin halter_N = mkTerm "halter_N" ;
lin haltingly_Adv = mkTerm "haltingly_Adv" ;
lin halve_V2 = mkTerm "halve_V2" ;
lin halyard_N = mkTerm "halyard_N" ;
lin ham_N = mkTerm "ham_N" ;
lin ham_V = mkTerm "ham_V" ;
lin ham_V2 = mkTerm "ham_V2" ;
lin ham_fisted_A = mkTerm "ham_fisted_A" ;
lin ham_handed_A = mkTerm "ham_handed_A" ;
lin ham_up_V2 = mkTerm "ham_up_V2" ;
lin hamadryad_N = mkTerm "hamadryad_N" ;
lin hamartoma_N = mkTerm "hamartoma_N" ;
lin hamate_N = mkTerm "hamate_N" ;
lin hamburg_PN = mkTerm "hamburg_PN" ;
lin hamburger_N = mkTerm "hamburger_N" ;
lin hame_N = mkTerm "hame_N" ;
lin hamelia_N = mkTerm "hamelia_N" ;
lin hamhung_PN = mkTerm "hamhung_PN" ;
lin hamilton_PN = mkTerm "hamilton_PN" ;
lin hamina_PN = mkTerm "hamina_PN" ;
lin hamlet_N = mkTerm "hamlet_N" ;
lin hammer_N = mkTerm "hammer_N" ;
lin hammer_V = mkTerm "hammer_V" ;
lin hammer_V2 = mkTerm "hammer_V2" ;
lin hammer_away_at_V2 = mkTerm "hammer_away_at_V2" ;
lin hammer_into_V2 = mkTerm "hammer_into_V2" ;
lin hammer_out_V2 = mkTerm "hammer_out_V2" ;
lin hammerhead_N = mkTerm "hammerhead_N" ;
lin hammerlock_N = mkTerm "hammerlock_N" ;
lin hammersmith_PN = mkTerm "hammersmith_PN" ;
lin hammertoe_N = mkTerm "hammertoe_N" ;
lin hamming_N = mkTerm "hamming_N" ;
lin hammock_N = mkTerm "hammock_N" ;
lin hammy_A = mkTerm "hammy_A" ;
lin hamper_N = mkTerm "hamper_N" ;
lin hamper_V2 = mkTerm "hamper_V2" ;
lin hampreston_PN = mkTerm "hampreston_PN" ;
lin hampshire_PN = mkTerm "hampshire_PN" ;
lin hamster_N = mkTerm "hamster_N" ;
lin hamstring_N = mkTerm "hamstring_N" ;
lin hamstring_V2 = mkTerm "hamstring_V2" ;
lin hand_N = mkTerm "hand_N" ;
lin hand_V2 = mkTerm "hand_V2" ;
lin hand_back_V2 = mkTerm "hand_back_V2" ;
lin hand_barrow_N = mkTerm "hand_barrow_N" ;
lin hand_carry_V2 = mkTerm "hand_carry_V2" ;
lin hand_down_V2 = mkTerm "hand_down_V2" ;
lin hand_grenade_N = mkTerm "hand_grenade_N" ;
lin hand_in_V2 = mkTerm "hand_in_V2" ;
lin hand_luggage_N = mkTerm "hand_luggage_N" ;
lin hand_me_down_N = mkTerm "hand_me_down_N" ;
lin hand_on_V2 = mkTerm "hand_on_V2" ;
lin hand_organ_N = mkTerm "hand_organ_N" ;
lin hand_out_N = mkTerm "hand_out_N" ;
lin hand_out_V2 = mkTerm "hand_out_V2" ;
lin hand_over_V2 = mkTerm "hand_over_V2" ;
lin hand_picked_A = mkTerm "hand_picked_A" ;
lin handbag_N = mkTerm "handbag_N" ;
lin handball_N = mkTerm "handball_N" ;
lin handbell_N = mkTerm "handbell_N" ;
lin handbill_N = mkTerm "handbill_N" ;
lin handbook_N = mkTerm "handbook_N" ;
lin handbow_N = mkTerm "handbow_N" ;
lin handbrake_N = mkTerm "handbrake_N" ;
lin handbreadth_N = mkTerm "handbreadth_N" ;
lin handcar_N = mkTerm "handcar_N" ;
lin handcart_N = mkTerm "handcart_N" ;
lin handclap_N = mkTerm "handclap_N" ;
lin handcuff_N = mkTerm "handcuff_N" ;
lin handcuff_V2 = mkTerm "handcuff_V2" ;
lin handedness_N = mkTerm "handedness_N" ;
lin handful_N = mkTerm "handful_N" ;
lin handgun_N = mkTerm "handgun_N" ;
lin handheld_N = mkTerm "handheld_N" ;
lin handhold_N = mkTerm "handhold_N" ;
lin handicap_N = mkTerm "handicap_N" ;
lin handicap_V2 = mkTerm "handicap_V2" ;
lin handicapped_A = mkTerm "handicapped_A" ;
lin handicraft_N = mkTerm "handicraft_N" ;
lin handiness_N = mkTerm "handiness_N" ;
lin handiwork_N = mkTerm "handiwork_N" ;
lin handkerchief_N = mkTerm "handkerchief_N" ;
lin handle_N = mkTerm "handle_N" ;
lin handle_V = mkTerm "handle_V" ;
lin handle_V2 = mkTerm "handle_V2" ;
lin handlebar_N = mkTerm "handlebar_N" ;
lin handleless_A = mkTerm "handleless_A" ;
lin handler_N = mkTerm "handler_N" ;
lin handless_A = mkTerm "handless_A" ;
lin handline_N = mkTerm "handline_N" ;
lin handling_N = mkTerm "handling_N" ;
lin handloom_N = mkTerm "handloom_N" ;
lin handmade_A = mkTerm "handmade_A" ;
lin handmaid_N = mkTerm "handmaid_N" ;
lin handoff_N = mkTerm "handoff_N" ;
lin handover_N = mkTerm "handover_N" ;
lin handrail_N = mkTerm "handrail_N" ;
lin handrest_N = mkTerm "handrest_N" ;
lin hands_N = mkTerm "hands_N" ;
lin handsaw_N = mkTerm "handsaw_N" ;
lin handset_N = mkTerm "handset_N" ;
lin handsewn_A = mkTerm "handsewn_A" ;
lin handshake_N = mkTerm "handshake_N" ;
lin handshaking_N = mkTerm "handshaking_N" ;
lin handsome_A = mkTerm "handsome_A" ;
lin handsomeness_N = mkTerm "handsomeness_N" ;
lin handspike_N = mkTerm "handspike_N" ;
lin handspring_N = mkTerm "handspring_N" ;
lin handstamp_N = mkTerm "handstamp_N" ;
lin handstand_N = mkTerm "handstand_N" ;
lin handwear_N = mkTerm "handwear_N" ;
lin handwheel_N = mkTerm "handwheel_N" ;
lin handwork_N = mkTerm "handwork_N" ;
lin handwriting_N = mkTerm "handwriting_N" ;
lin handwritten_A = mkTerm "handwritten_A" ;
lin handy_A = mkTerm "handy_A" ;
lin handyman_N = mkTerm "handyman_N" ;
lin hang_N = mkTerm "hang_N" ;
lin hang_V = mkTerm "hang_V" ;
lin hang_V2 = mkTerm "hang_V2" ;
lin hang_about_V = mkTerm "hang_about_V" ;
lin hang_around_V = mkTerm "hang_around_V" ;
lin hang_around_V2 = mkTerm "hang_around_V2" ;
lin hang_back_V = mkTerm "hang_back_V" ;
lin hang_back_from_V2 = mkTerm "hang_back_from_V2" ;
lin hang_in_there_V = mkTerm "hang_in_there_V" ;
lin hang_it_up_V = mkTerm "hang_it_up_V" ;
lin hang_on_V = mkTerm "hang_on_V" ;
lin hang_onto_V2 = mkTerm "hang_onto_V2" ;
lin hang_out_V = mkTerm "hang_out_V" ;
lin hang_out_V2 = mkTerm "hang_out_V2" ;
lin hang_out_for_V2 = mkTerm "hang_out_for_V2" ;
lin hang_over_V2 = mkTerm "hang_over_V2" ;
lin hang_together_V = mkTerm "hang_together_V" ;
lin hang_up_N = mkTerm "hang_up_N" ;
lin hang_up_V = mkTerm "hang_up_V" ;
lin hang_up_V2 = mkTerm "hang_up_V2" ;
lin hang_up_on_V2 = mkTerm "hang_up_on_V2" ;
lin hang_with_V2 = mkTerm "hang_with_V2" ;
lin hangar_N = mkTerm "hangar_N" ;
lin hangchon_PN = mkTerm "hangchon_PN" ;
lin hangdog_A = mkTerm "hangdog_A" ;
lin hanger_N = mkTerm "hanger_N" ;
lin hanger_on_N = mkTerm "hanger_on_N" ;
lin hanging_N = mkTerm "hanging_N" ;
lin hangman_N = mkTerm "hangman_N" ;
lin hangnail_N = mkTerm "hangnail_N" ;
lin hangover_N = mkTerm "hangover_N" ;
lin hank_N = mkTerm "hank_N" ;
lin hankasalmi_PN = mkTerm "hankasalmi_PN" ;
lin hanker_V = mkTerm "hanker_V" ;
lin hanker_after_V2 = mkTerm "hanker_after_V2" ;
lin hanker_for_V2 = mkTerm "hanker_for_V2" ;
lin hankering_N = mkTerm "hankering_N" ;
lin hanko_PN = mkTerm "hanko_PN" ;
lin hanky_N = mkTerm "hanky_N" ;
lin hanky_panky_N = mkTerm "hanky_panky_N" ;
lin hanoi_PN = mkTerm "hanoi_PN" ;
lin hanover_PN = mkTerm "hanover_PN" ;
lin hansard_N = mkTerm "hansard_N" ;
lin hansom_N = mkTerm "hansom_N" ;
lin hao_N = mkTerm "hao_N" ;
lin hap_N = mkTerm "hap_N" ;
lin hap_V = mkTerm "hap_V" ;
lin haphazard_A = mkTerm "haphazard_A" ;
lin haphazard_Adv = mkTerm "haphazard_Adv" ;
lin hapless_A = mkTerm "hapless_A" ;
lin haploid_A = mkTerm "haploid_A" ;
lin haploid_N = mkTerm "haploid_N" ;
lin haploidy_N = mkTerm "haploidy_N" ;
lin haplosporidian_N = mkTerm "haplosporidian_N" ;
lin haplotype_N = mkTerm "haplotype_N" ;
lin haply_Adv = mkTerm "haply_Adv" ;
lin happen_V = mkTerm "happen_V" ;
lin happen_VV = mkTerm "happen_VV" ;
lin happening_N = mkTerm "happening_N" ;
lin happiness_N = mkTerm "happiness_N" ;
lin happy_A = mkTerm "happy_A" ;
lin happy_go_lucky_A = mkTerm "happy_go_lucky_A" ;
lin haptic_A = mkTerm "haptic_A" ;
lin haptoglobin_N = mkTerm "haptoglobin_N" ;
lin harakiri_N = mkTerm "harakiri_N" ;
lin harangue_N = mkTerm "harangue_N" ;
lin harangue_V = mkTerm "harangue_V" ;
lin harangue_V2 = mkTerm "harangue_V2" ;
lin haranguer_N = mkTerm "haranguer_N" ;
lin harass_V2 = mkTerm "harass_V2" ;
lin harasser_N = mkTerm "harasser_N" ;
lin harassment_N = mkTerm "harassment_N" ;
lin harbin_PN = mkTerm "harbin_PN" ;
lin harbinger_N = mkTerm "harbinger_N" ;
lin harbour_N = mkTerm "harbour_N" ;
lin harbour_V = mkTerm "harbour_V" ;
lin harbour_V2 = mkTerm "harbour_V2" ;
lin harbourage_N = mkTerm "harbourage_N" ;
lin hard_1_A = mkTerm "hard_1_A" ;
lin hard_2_A = mkTerm "hard_2_A" ;
lin hard_baked_A = mkTerm "hard_baked_A" ;
lin hard_bitten_A = mkTerm "hard_bitten_A" ;
lin hard_boiled_A = mkTerm "hard_boiled_A" ;
lin hard_headed_A = mkTerm "hard_headed_A" ;
lin hardback_N = mkTerm "hardback_N" ;
lin hardbacked_A = mkTerm "hardbacked_A" ;
lin hardbake_N = mkTerm "hardbake_N" ;
lin hardball_N = mkTerm "hardball_N" ;
lin hardboard_N = mkTerm "hardboard_N" ;
lin hardbound_A = mkTerm "hardbound_A" ;
lin hardcore_A = mkTerm "hardcore_A" ;
lin hardcover_N = mkTerm "hardcover_N" ;
lin hardcovered_A = mkTerm "hardcovered_A" ;
lin harden_V = mkTerm "harden_V" ;
lin harden_V2 = mkTerm "harden_V2" ;
lin hardening_N = mkTerm "hardening_N" ;
lin hardhearted_A = mkTerm "hardhearted_A" ;
lin hardhitting_A = mkTerm "hardhitting_A" ;
lin hardihood_N = mkTerm "hardihood_N" ;
lin hardiness_N = mkTerm "hardiness_N" ;
lin hardinggrass_N = mkTerm "hardinggrass_N" ;
lin hardliner_N = mkTerm "hardliner_N" ;
lin hardly_AdV = mkTerm "hardly_AdV" ;
lin hardness_N = mkTerm "hardness_N" ;
lin hardscrabble_A = mkTerm "hardscrabble_A" ;
lin hardship_N = mkTerm "hardship_N" ;
lin hardtack_N = mkTerm "hardtack_N" ;
lin hardtop_N = mkTerm "hardtop_N" ;
lin hardware_N = mkTerm "hardware_N" ;
lin hardwood_N = mkTerm "hardwood_N" ;
lin hardworking_A = mkTerm "hardworking_A" ;
lin hardy_A = mkTerm "hardy_A" ;
lin hare_N = mkTerm "hare_N" ;
lin hare_V = mkTerm "hare_V" ;
lin harebell_N = mkTerm "harebell_N" ;
lin harebrained_A = mkTerm "harebrained_A" ;
lin harelip_N = mkTerm "harelip_N" ;
lin harem_N = mkTerm "harem_N" ;
lin haricot_N = mkTerm "haricot_N" ;
lin haringey_PN = mkTerm "haringey_PN" ;
lin harjavalta_PN = mkTerm "harjavalta_PN" ;
lin hark_V = mkTerm "hark_V" ;
lin harlequin_N = mkTerm "harlequin_N" ;
lin harlequinade_N = mkTerm "harlequinade_N" ;
lin harley_street_PN = mkTerm "harley_street_PN" ;
lin harlot_N = mkTerm "harlot_N" ;
lin harlow_PN = mkTerm "harlow_PN" ;
lin harm_N = mkTerm "harm_N" ;
lin harm_V2 = mkTerm "harm_V2" ;
lin harmattan_N = mkTerm "harmattan_N" ;
lin harmful_A = mkTerm "harmful_A" ;
lin harmfulness_N = mkTerm "harmfulness_N" ;
lin harmless_A = mkTerm "harmless_A" ;
lin harmonic_A = mkTerm "harmonic_A" ;
lin harmonic_N = mkTerm "harmonic_N" ;
lin harmonica_N = mkTerm "harmonica_N" ;
lin harmonics_N = mkTerm "harmonics_N" ;
lin harmonious_A = mkTerm "harmonious_A" ;
lin harmonium_N = mkTerm "harmonium_N" ;
lin harmonizable_A = mkTerm "harmonizable_A" ;
lin harmonization_N = mkTerm "harmonization_N" ;
lin harmonize_V = mkTerm "harmonize_V" ;
lin harmonize_V2 = mkTerm "harmonize_V2" ;
lin harmonizer_N = mkTerm "harmonizer_N" ;
lin harmony_N = mkTerm "harmony_N" ;
lin harness_N = mkTerm "harness_N" ;
lin harness_V2 = mkTerm "harness_V2" ;
lin harold_PN = mkTerm "harold_PN" ;
lin harp_N = mkTerm "harp_N" ;
lin harp_V = mkTerm "harp_V" ;
lin harp_on_V = mkTerm "harp_on_V" ;
lin harpenden_PN = mkTerm "harpenden_PN" ;
lin harper_N = mkTerm "harper_N" ;
lin harpist_N = mkTerm "harpist_N" ;
lin harpoon_N = mkTerm "harpoon_N" ;
lin harpoon_V2 = mkTerm "harpoon_V2" ;
lin harpooner_N = mkTerm "harpooner_N" ;
lin harpsichord_N = mkTerm "harpsichord_N" ;
lin harpsichordist_N = mkTerm "harpsichordist_N" ;
lin harpulla_N = mkTerm "harpulla_N" ;
lin harpullia_N = mkTerm "harpullia_N" ;
lin harpy_N = mkTerm "harpy_N" ;
lin harridan_N = mkTerm "harridan_N" ;
lin harrier_N = mkTerm "harrier_N" ;
lin harriet_PN = mkTerm "harriet_PN" ;
lin harrogate_PN = mkTerm "harrogate_PN" ;
lin harrow_N = mkTerm "harrow_N" ;
lin harrow_PN = mkTerm "harrow_PN" ;
lin harrow_V2 = mkTerm "harrow_V2" ;
lin harry_PN = mkTerm "harry_PN" ;
lin harry_V2 = mkTerm "harry_V2" ;
lin harsh_A = mkTerm "harsh_A" ;
lin harshness_N = mkTerm "harshness_N" ;
lin hart_N = mkTerm "hart_N" ;
lin hartebeest_N = mkTerm "hartebeest_N" ;
lin hartlepool_PN = mkTerm "hartlepool_PN" ;
lin hartley_PN = mkTerm "hartley_PN" ;
lin hartola_PN = mkTerm "hartola_PN" ;
lin harum_scarum_A = mkTerm "harum_scarum_A" ;
lin harum_scarum_N = mkTerm "harum_scarum_N" ;
lin harvest_N = mkTerm "harvest_N" ;
lin harvest_V2 = mkTerm "harvest_V2" ;
lin harvester_N = mkTerm "harvester_N" ;
lin harvestfish_N = mkTerm "harvestfish_N" ;
lin harvestman_N = mkTerm "harvestman_N" ;
lin harvey_PN = mkTerm "harvey_PN" ;
lin harwich_PN = mkTerm "harwich_PN" ;
lin harwood_PN = mkTerm "harwood_PN" ;
lin harworth_PN = mkTerm "harworth_PN" ;
lin has_been_N = mkTerm "has_been_N" ;
lin hash_N = mkTerm "hash_N" ;
lin hash_V2 = mkTerm "hash_V2" ;
lin hash_out_V = mkTerm "hash_out_V" ;
lin hashish_N = mkTerm "hashish_N" ;
lin haslemere_PN = mkTerm "haslemere_PN" ;
lin haslet_N = mkTerm "haslet_N" ;
lin haslingden_PN = mkTerm "haslingden_PN" ;
lin hasp_N = mkTerm "hasp_N" ;
lin hassium_N = mkTerm "hassium_N" ;
lin hassle_N = mkTerm "hassle_N" ;
lin hassle_V = mkTerm "hassle_V" ;
lin hassle_V2 = mkTerm "hassle_V2" ;
lin hassock_N = mkTerm "hassock_N" ;
lin hastate_A = mkTerm "hastate_A" ;
lin haste_N = mkTerm "haste_N" ;
lin hasten_V = mkTerm "hasten_V" ;
lin hasten_V2 = mkTerm "hasten_V2" ;
lin hastiness_N = mkTerm "hastiness_N" ;
lin hastings_PN = mkTerm "hastings_PN" ;
lin hasty_A = mkTerm "hasty_A" ;
lin hat_N = mkTerm "hat_N" ;
lin hatband_N = mkTerm "hatband_N" ;
lin hatbox_N = mkTerm "hatbox_N" ;
lin hatch_N = mkTerm "hatch_N" ;
lin hatch_V = mkTerm "hatch_V" ;
lin hatch_V2 = mkTerm "hatch_V2" ;
lin hatchback_N = mkTerm "hatchback_N" ;
lin hatchel_N = mkTerm "hatchel_N" ;
lin hatchery_N = mkTerm "hatchery_N" ;
lin hatchet_N = mkTerm "hatchet_N" ;
lin hatching_N = mkTerm "hatching_N" ;
lin hatchling_N = mkTerm "hatchling_N" ;
lin hatchway_N = mkTerm "hatchway_N" ;
lin hate_N = mkTerm "hate_N" ;
lin hate_V2 = mkTerm "hate_V2" ;
lin hate_VV = mkTerm "hate_VV" ;
lin hate_on_V2 = mkTerm "hate_on_V2" ;
lin hateful_A = mkTerm "hateful_A" ;
lin hatefulness_N = mkTerm "hatefulness_N" ;
lin hatemonger_N = mkTerm "hatemonger_N" ;
lin hater_N = mkTerm "hater_N" ;
lin hatfield_PN = mkTerm "hatfield_PN" ;
lin hatful_N = mkTerm "hatful_N" ;
lin hatless_A = mkTerm "hatless_A" ;
lin hatmaker_N = mkTerm "hatmaker_N" ;
lin hatpin_N = mkTerm "hatpin_N" ;
lin hatred_N = mkTerm "hatred_N" ;
lin hatted_A = mkTerm "hatted_A" ;
lin hatter_N = mkTerm "hatter_N" ;
lin hauberk_N = mkTerm "hauberk_N" ;
lin haughtiness_N = mkTerm "haughtiness_N" ;
lin haughty_A = mkTerm "haughty_A" ;
lin hauho_PN = mkTerm "hauho_PN" ;
lin haukipudas_PN = mkTerm "haukipudas_PN" ;
lin haukivuori_PN = mkTerm "haukivuori_PN" ;
lin haul_N = mkTerm "haul_N" ;
lin haul_V = mkTerm "haul_V" ;
lin haul_V2 = mkTerm "haul_V2" ;
lin haul_out_V2 = mkTerm "haul_out_V2" ;
lin haulage_N = mkTerm "haulage_N" ;
lin hauler_N = mkTerm "hauler_N" ;
lin haulier_N = mkTerm "haulier_N" ;
lin hauling_N = mkTerm "hauling_N" ;
lin haulm_N = mkTerm "haulm_N" ;
lin haunch_N = mkTerm "haunch_N" ;
lin haunt_N = mkTerm "haunt_N" ;
lin haunt_V2 = mkTerm "haunt_V2" ;
lin haunting_A = mkTerm "haunting_A" ;
lin hausjärvi_PN = mkTerm "hausjärvi_PN" ;
lin hausmannite_N = mkTerm "hausmannite_N" ;
lin haustorium_N = mkTerm "haustorium_N" ;
lin hautboy_N = mkTerm "hautboy_N" ;
lin hauteur_N = mkTerm "hauteur_N" ;
lin havana_N = mkTerm "havana_N" ;
lin havana_PN = mkTerm "havana_PN" ;
lin have_V = mkTerm "have_V" ;
lin have_VV = mkTerm "have_VV" ;
lin have_against_V2 = mkTerm "have_against_V2" ;
lin have_around_V2 = mkTerm "have_around_V2" ;
lin have_down_as_V3 = mkTerm "have_down_as_V3" ;
lin have_in_V2 = mkTerm "have_in_V2" ;
lin have_it_away_V = mkTerm "have_it_away_V" ;
lin have_it_in_for_V2 = mkTerm "have_it_in_for_V2" ;
lin have_it_off_V = mkTerm "have_it_off_V" ;
lin have_it_out_with_V2 = mkTerm "have_it_out_with_V2" ;
lin have_off_V2 = mkTerm "have_off_V2" ;
lin have_on_V = mkTerm "have_on_V" ;
lin have_on_V2 = mkTerm "have_on_V2" ;
lin have_over_V2 = mkTerm "have_over_V2" ;
lin have_round_V2 = mkTerm "have_round_V2" ;
lin have_up_V2 = mkTerm "have_up_V2" ;
lin havelock_N = mkTerm "havelock_N" ;
lin haven_N = mkTerm "haven_N" ;
lin haverfordwest_PN = mkTerm "haverfordwest_PN" ;
lin haverhill_PN = mkTerm "haverhill_PN" ;
lin havering_PN = mkTerm "havering_PN" ;
lin haversack_N = mkTerm "haversack_N" ;
lin havoc_N = mkTerm "havoc_N" ;
lin haw_N = mkTerm "haw_N" ;
lin haw_V = mkTerm "haw_V" ;
lin haw_haw_N = mkTerm "haw_haw_N" ;
lin hawaii_PN = mkTerm "hawaii_PN" ;
lin hawala_N = mkTerm "hawala_N" ;
lin hawfinch_N = mkTerm "hawfinch_N" ;
lin hawick_PN = mkTerm "hawick_PN" ;
lin hawk_N = mkTerm "hawk_N" ;
lin hawk_V2 = mkTerm "hawk_V2" ;
lin hawk_eyed_A = mkTerm "hawk_eyed_A" ;
lin hawkbit_N = mkTerm "hawkbit_N" ;
lin hawke's_bay_PN = mkTerm "hawke's_bay_PN" ;
lin hawker_N = mkTerm "hawker_N" ;
lin hawkishness_N = mkTerm "hawkishness_N" ;
lin hawkmoth_N = mkTerm "hawkmoth_N" ;
lin hawkweed_N = mkTerm "hawkweed_N" ;
lin hawse_N = mkTerm "hawse_N" ;
lin hawser_N = mkTerm "hawser_N" ;
lin hawthorn_N = mkTerm "hawthorn_N" ;
lin hay_N = mkTerm "hay_N" ;
lin haycock_N = mkTerm "haycock_N" ;
lin hayfield_N = mkTerm "hayfield_N" ;
lin hayfork_N = mkTerm "hayfork_N" ;
lin haying_N = mkTerm "haying_N" ;
lin hayling_PN = mkTerm "hayling_PN" ;
lin hayloft_N = mkTerm "hayloft_N" ;
lin haymaker_N = mkTerm "haymaker_N" ;
lin haymaking_N = mkTerm "haymaking_N" ;
lin haymow_N = mkTerm "haymow_N" ;
lin hayrack_N = mkTerm "hayrack_N" ;
lin hayrick_N = mkTerm "hayrick_N" ;
lin haystack_N = mkTerm "haystack_N" ;
lin haywards_heath_PN = mkTerm "haywards_heath_PN" ;
lin haywire_A = mkTerm "haywire_A" ;
lin haywire_N = mkTerm "haywire_N" ;
lin hazard_N = mkTerm "hazard_N" ;
lin hazard_V2 = mkTerm "hazard_V2" ;
lin hazardous_A = mkTerm "hazardous_A" ;
lin hazardousness_N = mkTerm "hazardousness_N" ;
lin haze_N = mkTerm "haze_N" ;
lin haze_V2 = mkTerm "haze_V2" ;
lin hazel_A = mkTerm "hazel_A" ;
lin hazel_N = mkTerm "hazel_N" ;
lin hazel_PN = mkTerm "hazel_PN" ;
lin hazelnut_N = mkTerm "hazelnut_N" ;
lin haziness_N = mkTerm "haziness_N" ;
lin hazy_A = mkTerm "hazy_A" ;
lin he_goat_N = mkTerm "he_goat_N" ;
lin he_man_N = mkTerm "he_man_N" ;
lin head_A = mkTerm "head_A" ;
lin head_N = mkTerm "head_N" ;
lin head_V = mkTerm "head_V" ;
lin head_V2 = mkTerm "head_V2" ;
lin head_for_V2 = mkTerm "head_for_V2" ;
lin head_hunter_N = mkTerm "head_hunter_N" ;
lin head_off_V = mkTerm "head_off_V" ;
lin head_off_V2 = mkTerm "head_off_V2" ;
lin head_on_A = mkTerm "head_on_A" ;
lin head_on_Adv = mkTerm "head_on_Adv" ;
lin head_out_V = mkTerm "head_out_V" ;
lin head_up_V2 = mkTerm "head_up_V2" ;
lin headache_N = mkTerm "headache_N" ;
lin headband_N = mkTerm "headband_N" ;
lin headboard_N = mkTerm "headboard_N" ;
lin headcheese_N = mkTerm "headcheese_N" ;
lin headdress_N = mkTerm "headdress_N" ;
lin header_N = mkTerm "header_N" ;
lin headfast_N = mkTerm "headfast_N" ;
lin headfirst_A = mkTerm "headfirst_A" ;
lin headful_N = mkTerm "headful_N" ;
lin headgear_N = mkTerm "headgear_N" ;
lin heading_N = mkTerm "heading_N" ;
lin headlamp_N = mkTerm "headlamp_N" ;
lin headland_N = mkTerm "headland_N" ;
lin headless_A = mkTerm "headless_A" ;
lin headlight_N = mkTerm "headlight_N" ;
lin headlike_A = mkTerm "headlike_A" ;
lin headline_N = mkTerm "headline_N" ;
lin headliner_N = mkTerm "headliner_N" ;
lin headlinese_N = mkTerm "headlinese_N" ;
lin headlock_N = mkTerm "headlock_N" ;
lin headlong_A = mkTerm "headlong_A" ;
lin headlong_Adv = mkTerm "headlong_Adv" ;
lin headman_N = mkTerm "headman_N" ;
lin headmaster_N = mkTerm "headmaster_N" ;
lin headmastership_N = mkTerm "headmastership_N" ;
lin headmistress_N = mkTerm "headmistress_N" ;
lin headmistressship_N = mkTerm "headmistressship_N" ;
lin headpiece_N = mkTerm "headpiece_N" ;
lin headpin_N = mkTerm "headpin_N" ;
lin headquarter_N = mkTerm "headquarter_N" ;
lin headquarters_N = mkTerm "headquarters_N" ;
lin headrace_N = mkTerm "headrace_N" ;
lin headrest_N = mkTerm "headrest_N" ;
lin headroom_N = mkTerm "headroom_N" ;
lin headsail_N = mkTerm "headsail_N" ;
lin headscarf_N = mkTerm "headscarf_N" ;
lin headset_N = mkTerm "headset_N" ;
lin headshake_N = mkTerm "headshake_N" ;
lin headship_N = mkTerm "headship_N" ;
lin headshot_N = mkTerm "headshot_N" ;
lin headsman_N = mkTerm "headsman_N" ;
lin headspace_N = mkTerm "headspace_N" ;
lin headstall_N = mkTerm "headstall_N" ;
lin headstand_N = mkTerm "headstand_N" ;
lin headstock_N = mkTerm "headstock_N" ;
lin headstone_N = mkTerm "headstone_N" ;
lin headstream_N = mkTerm "headstream_N" ;
lin headstrong_A = mkTerm "headstrong_A" ;
lin headwater_N = mkTerm "headwater_N" ;
lin headway_N = mkTerm "headway_N" ;
lin headwind_N = mkTerm "headwind_N" ;
lin headword_N = mkTerm "headword_N" ;
lin heady_A = mkTerm "heady_A" ;
lin heal_V = mkTerm "heal_V" ;
lin heal_V2 = mkTerm "heal_V2" ;
lin healer_N = mkTerm "healer_N" ;
lin healing_N = mkTerm "healing_N" ;
lin health_N = mkTerm "health_N" ;
lin healthcare_N = mkTerm "healthcare_N" ;
lin healthful_A = mkTerm "healthful_A" ;
lin healthfulness_N = mkTerm "healthfulness_N" ;
lin healthy_A = mkTerm "healthy_A" ;
lin heanor_PN = mkTerm "heanor_PN" ;
lin heap_N = mkTerm "heap_N" ;
lin heap_V2 = mkTerm "heap_V2" ;
lin heaps_Adv = mkTerm "heaps_Adv" ;
lin hear_V = mkTerm "hear_V" ;
lin hear_V2 = mkTerm "hear_V2" ;
lin hear_V2V = mkTerm "hear_V2V" ;
lin hear_VS = mkTerm "hear_VS" ;
lin hear_about_V2 = mkTerm "hear_about_V2" ;
lin hear_from_V2 = mkTerm "hear_from_V2" ;
lin hear_of_V2 = mkTerm "hear_of_V2" ;
lin hear_of_V3 = mkTerm "hear_of_V3" ;
lin hear_out_V2 = mkTerm "hear_out_V2" ;
lin hearer_N = mkTerm "hearer_N" ;
lin hearing_N = mkTerm "hearing_N" ;
lin hearing_aid_N = mkTerm "hearing_aid_N" ;
lin hearken_V = mkTerm "hearken_V" ;
lin hearsay_A = mkTerm "hearsay_A" ;
lin hearsay_N = mkTerm "hearsay_N" ;
lin hearse_N = mkTerm "hearse_N" ;
lin heart's_ease_N = mkTerm "heart's_ease_N" ;
lin heart_N = mkTerm "heart_N" ;
lin heart_disease_N = mkTerm "heart_disease_N" ;
lin heart_failure_N = mkTerm "heart_failure_N" ;
lin heart_rending_A = mkTerm "heart_rending_A" ;
lin heartache_N = mkTerm "heartache_N" ;
lin heartbeat_N = mkTerm "heartbeat_N" ;
lin heartbreak_N = mkTerm "heartbreak_N" ;
lin heartbreaker_N = mkTerm "heartbreaker_N" ;
lin heartbreaking_A = mkTerm "heartbreaking_A" ;
lin heartbroken_A = mkTerm "heartbroken_A" ;
lin heartburn_N = mkTerm "heartburn_N" ;
lin heartburning_N = mkTerm "heartburning_N" ;
lin hearted_A = mkTerm "hearted_A" ;
lin hearten_V2 = mkTerm "hearten_V2" ;
lin heartening_A = mkTerm "heartening_A" ;
lin heartfelt_A = mkTerm "heartfelt_A" ;
lin hearth_N = mkTerm "hearth_N" ;
lin hearthrug_N = mkTerm "hearthrug_N" ;
lin hearthstone_N = mkTerm "hearthstone_N" ;
lin heartiness_N = mkTerm "heartiness_N" ;
lin heartland_N = mkTerm "heartland_N" ;
lin heartleaf_N = mkTerm "heartleaf_N" ;
lin heartless_A = mkTerm "heartless_A" ;
lin heartlessness_N = mkTerm "heartlessness_N" ;
lin heartrot_N = mkTerm "heartrot_N" ;
lin hearts_N = mkTerm "hearts_N" ;
lin heartseed_N = mkTerm "heartseed_N" ;
lin heartsick_A = mkTerm "heartsick_A" ;
lin heartstrings_N = mkTerm "heartstrings_N" ;
lin heartthrob_N = mkTerm "heartthrob_N" ;
lin heartwarming_A = mkTerm "heartwarming_A" ;
lin heartwood_N = mkTerm "heartwood_N" ;
lin hearty_A = mkTerm "hearty_A" ;
lin heat_N = mkTerm "heat_N" ;
lin heat_V = mkTerm "heat_V" ;
lin heat_V2 = mkTerm "heat_V2" ;
lin heat_flash_N = mkTerm "heat_flash_N" ;
lin heat_up_V2 = mkTerm "heat_up_V2" ;
lin heatable_A = mkTerm "heatable_A" ;
lin heated_A = mkTerm "heated_A" ;
lin heater_N = mkTerm "heater_N" ;
lin heath_N = mkTerm "heath_N" ;
lin heathen_A = mkTerm "heathen_A" ;
lin heathen_N = mkTerm "heathen_N" ;
lin heathenish_A = mkTerm "heathenish_A" ;
lin heather_N = mkTerm "heather_N" ;
lin heather_PN = mkTerm "heather_PN" ;
lin heather_mixture_N = mkTerm "heather_mixture_N" ;
lin heathlike_A = mkTerm "heathlike_A" ;
lin heating_N = mkTerm "heating_N" ;
lin heatless_A = mkTerm "heatless_A" ;
lin heatspot_N = mkTerm "heatspot_N" ;
lin heatstroke_N = mkTerm "heatstroke_N" ;
lin heatwave_N = mkTerm "heatwave_N" ;
lin heaume_N = mkTerm "heaume_N" ;
lin heave_N = mkTerm "heave_N" ;
lin heave_V = mkTerm "heave_V" ;
lin heave_V2 = mkTerm "heave_V2" ;
lin heave_out_V = mkTerm "heave_out_V" ;
lin heaven_N = mkTerm "heaven_N" ;
lin heavenly_A = mkTerm "heavenly_A" ;
lin heavensent_A = mkTerm "heavensent_A" ;
lin heavenward_A = mkTerm "heavenward_A" ;
lin heavenward_Adv = mkTerm "heavenward_Adv" ;
lin heavenwards_A = mkTerm "heavenwards_A" ;
lin heavenwards_Adv = mkTerm "heavenwards_Adv" ;
lin heaver_N = mkTerm "heaver_N" ;
lin heaves_N = mkTerm "heaves_N" ;
lin heavily_Adv = mkTerm "heavily_Adv" ;
lin heaviness_N = mkTerm "heaviness_N" ;
lin heaviside_PN = mkTerm "heaviside_PN" ;
lin heavy_A = mkTerm "heavy_A" ;
lin heavy_Adv = mkTerm "heavy_Adv" ;
lin heavy_N = mkTerm "heavy_N" ;
lin heavy_handed_A = mkTerm "heavy_handed_A" ;
lin heavy_hearted_A = mkTerm "heavy_hearted_A" ;
lin heavy_laden_A = mkTerm "heavy_laden_A" ;
lin heavyheartedness_N = mkTerm "heavyheartedness_N" ;
lin heavyweight_N = mkTerm "heavyweight_N" ;
lin hebden_royal_PN = mkTerm "hebden_royal_PN" ;
lin hebdomadal_A = mkTerm "hebdomadal_A" ;
lin hebephrenia_N = mkTerm "hebephrenia_N" ;
lin hebephrenic_A = mkTerm "hebephrenic_A" ;
lin hebetude_N = mkTerm "hebetude_N" ;
lin hebraic_A = mkTerm "hebraic_A" ;
lin hebrew_A = mkTerm "hebrew_A" ;
lin hecatomb_N = mkTerm "hecatomb_N" ;
lin heck_N = mkTerm "heck_N" ;
lin heckelphone_N = mkTerm "heckelphone_N" ;
lin heckle_V2 = mkTerm "heckle_V2" ;
lin heckler_N = mkTerm "heckler_N" ;
lin heckling_N = mkTerm "heckling_N" ;
lin hectare_N = mkTerm "hectare_N" ;
lin hectic_A = mkTerm "hectic_A" ;
lin hectogram_N = mkTerm "hectogram_N" ;
lin hectograph_N = mkTerm "hectograph_N" ;
lin hectoliter_N = mkTerm "hectoliter_N" ;
lin hectometer_N = mkTerm "hectometer_N" ;
lin hector_V = mkTerm "hector_V" ;
lin hector_V2 = mkTerm "hector_V2" ;
lin hedge_N = mkTerm "hedge_N" ;
lin hedge_V = mkTerm "hedge_V" ;
lin hedge_V2 = mkTerm "hedge_V2" ;
lin hedge_end_PN = mkTerm "hedge_end_PN" ;
lin hedge_sparrow_N = mkTerm "hedge_sparrow_N" ;
lin hedgehog_N = mkTerm "hedgehog_N" ;
lin hedgehop_V = mkTerm "hedgehop_V" ;
lin hedger_N = mkTerm "hedger_N" ;
lin hedgerow_N = mkTerm "hedgerow_N" ;
lin hedonic_A = mkTerm "hedonic_A" ;
lin hedonism_N = mkTerm "hedonism_N" ;
lin hedonist_N = mkTerm "hedonist_N" ;
lin hedonistic_A = mkTerm "hedonistic_A" ;
lin heed_N = mkTerm "heed_N" ;
lin heed_V2 = mkTerm "heed_V2" ;
lin heedful_A = mkTerm "heedful_A" ;
lin heedless_A = mkTerm "heedless_A" ;
lin heedlessness_N = mkTerm "heedlessness_N" ;
lin heehaw_N = mkTerm "heehaw_N" ;
lin heel_N = mkTerm "heel_N" ;
lin heel_V = mkTerm "heel_V" ;
lin heel_V2 = mkTerm "heel_V2" ;
lin heelbone_N = mkTerm "heelbone_N" ;
lin heft_N = mkTerm "heft_N" ;
lin hefty_A = mkTerm "hefty_A" ;
lin hegari_N = mkTerm "hegari_N" ;
lin hegemon_N = mkTerm "hegemon_N" ;
lin hegemony_N = mkTerm "hegemony_N" ;
lin hegira_N = mkTerm "hegira_N" ;
lin heidelburg_PN = mkTerm "heidelburg_PN" ;
lin heifer_N = mkTerm "heifer_N" ;
lin height_N = mkTerm "height_N" ;
lin heighten_V = mkTerm "heighten_V" ;
lin heighten_V2 = mkTerm "heighten_V2" ;
lin heinola_PN = mkTerm "heinola_PN" ;
lin heinous_A = mkTerm "heinous_A" ;
lin heinousness_N = mkTerm "heinousness_N" ;
lin heinävesi_PN = mkTerm "heinävesi_PN" ;
lin heir_N = mkTerm "heir_N" ;
lin heiress_N = mkTerm "heiress_N" ;
lin heirloom_N = mkTerm "heirloom_N" ;
lin heist_N = mkTerm "heist_N" ;
lin hejira_N = mkTerm "hejira_N" ;
lin held_A = mkTerm "held_A" ;
lin helen_PN = mkTerm "helen_PN" ;
lin helensburgh_PN = mkTerm "helensburgh_PN" ;
lin heliacal_A = mkTerm "heliacal_A" ;
lin helianthemum_N = mkTerm "helianthemum_N" ;
lin helicon_N = mkTerm "helicon_N" ;
lin helicopter_N = mkTerm "helicopter_N" ;
lin heliocentric_A = mkTerm "heliocentric_A" ;
lin heliogram_N = mkTerm "heliogram_N" ;
lin heliograph_N = mkTerm "heliograph_N" ;
lin heliograph_V2 = mkTerm "heliograph_V2" ;
lin heliolatry_N = mkTerm "heliolatry_N" ;
lin heliometer_N = mkTerm "heliometer_N" ;
lin heliopause_N = mkTerm "heliopause_N" ;
lin heliophila_N = mkTerm "heliophila_N" ;
lin heliopsis_N = mkTerm "heliopsis_N" ;
lin heliosphere_N = mkTerm "heliosphere_N" ;
lin heliotherapy_N = mkTerm "heliotherapy_N" ;
lin heliotrope_N = mkTerm "heliotrope_N" ;
lin heliotropism_N = mkTerm "heliotropism_N" ;
lin heliozoan_N = mkTerm "heliozoan_N" ;
lin heliport_N = mkTerm "heliport_N" ;
lin helium_N = mkTerm "helium_N" ;
lin helix_N = mkTerm "helix_N" ;
lin hell_Interj = mkTerm "hell_Interj" ;
lin hell_N = mkTerm "hell_N" ;
lin hellbender_N = mkTerm "hellbender_N" ;
lin hellcat_N = mkTerm "hellcat_N" ;
lin hellebore_N = mkTerm "hellebore_N" ;
lin helleborine_N = mkTerm "helleborine_N" ;
lin hellene_N = mkTerm "hellene_N" ;
lin hellenic_A = mkTerm "hellenic_A" ;
lin hellfire_N = mkTerm "hellfire_N" ;
lin hellgrammiate_N = mkTerm "hellgrammiate_N" ;
lin hellhound_N = mkTerm "hellhound_N" ;
lin hellion_N = mkTerm "hellion_N" ;
lin hellish_A = mkTerm "hellish_A" ;
lin hello_Interj = mkTerm "hello_Interj" ;
lin helm_N = mkTerm "helm_N" ;
lin helmet_N = mkTerm "helmet_N" ;
lin helmeted_A = mkTerm "helmeted_A" ;
lin helmetflower_N = mkTerm "helmetflower_N" ;
lin helminth_N = mkTerm "helminth_N" ;
lin helminthiasis_N = mkTerm "helminthiasis_N" ;
lin helmsman_N = mkTerm "helmsman_N" ;
lin helot_N = mkTerm "helot_N" ;
lin help_N = mkTerm "help_N" ;
lin help_V = mkTerm "help_V" ;
lin help_V2 = mkTerm "help_V2" ;
lin help_V2V = mkTerm "help_V2V" ;
lin help_out_V2 = mkTerm "help_out_V2" ;
lin help_to_VV = mkTerm "help_to_VV" ;
lin helperFem_N = mkTerm "helperFem_N" ;
lin helperMasc_N = mkTerm "helperMasc_N" ;
lin helpful_A = mkTerm "helpful_A" ;
lin helpfulness_N = mkTerm "helpfulness_N" ;
lin helping_N = mkTerm "helping_N" ;
lin helpless_A = mkTerm "helpless_A" ;
lin helplessness_N = mkTerm "helplessness_N" ;
lin helpmate_N = mkTerm "helpmate_N" ;
lin helpmeet_N = mkTerm "helpmeet_N" ;
lin helsinki_PN = mkTerm "helsinki_PN" ;
lin helston_PN = mkTerm "helston_PN" ;
lin helter_skelter_Adv = mkTerm "helter_skelter_Adv" ;
lin helter_skelter_N = mkTerm "helter_skelter_N" ;
lin helve_N = mkTerm "helve_N" ;
lin helvella_N = mkTerm "helvella_N" ;
lin hem_N = mkTerm "hem_N" ;
lin hem_V = mkTerm "hem_V" ;
lin hem_V2 = mkTerm "hem_V2" ;
lin hemagglutination_N = mkTerm "hemagglutination_N" ;
lin hemal_A = mkTerm "hemal_A" ;
lin hemangioma_N = mkTerm "hemangioma_N" ;
lin hematemesis_N = mkTerm "hematemesis_N" ;
lin hematinic_N = mkTerm "hematinic_N" ;
lin hematite_N = mkTerm "hematite_N" ;
lin hematocele_N = mkTerm "hematocele_N" ;
lin hematochezia_N = mkTerm "hematochezia_N" ;
lin hematochrome_N = mkTerm "hematochrome_N" ;
lin hematocolpometra_N = mkTerm "hematocolpometra_N" ;
lin hematocolpos_N = mkTerm "hematocolpos_N" ;
lin hematocrit_N = mkTerm "hematocrit_N" ;
lin hematocytopenia_N = mkTerm "hematocytopenia_N" ;
lin hematocyturia_N = mkTerm "hematocyturia_N" ;
lin hematologic_A = mkTerm "hematologic_A" ;
lin hematologist_N = mkTerm "hematologist_N" ;
lin hematology_N = mkTerm "hematology_N" ;
lin hematoma_N = mkTerm "hematoma_N" ;
lin hematopoiesis_N = mkTerm "hematopoiesis_N" ;
lin hematopoietic_A = mkTerm "hematopoietic_A" ;
lin hematuria_N = mkTerm "hematuria_N" ;
lin heme_N = mkTerm "heme_N" ;
lin hemel_hempstead_PN = mkTerm "hemel_hempstead_PN" ;
lin hemeralopia_N = mkTerm "hemeralopia_N" ;
lin hemiacetal_N = mkTerm "hemiacetal_N" ;
lin hemianopia_N = mkTerm "hemianopia_N" ;
lin hemic_A = mkTerm "hemic_A" ;
lin hemiepiphyte_N = mkTerm "hemiepiphyte_N" ;
lin hemimetabolous_A = mkTerm "hemimetabolous_A" ;
lin hemimetamorphosis_N = mkTerm "hemimetamorphosis_N" ;
lin hemimorphite_N = mkTerm "hemimorphite_N" ;
lin hemin_N = mkTerm "hemin_N" ;
lin hemiparasite_N = mkTerm "hemiparasite_N" ;
lin hemiparasitic_A = mkTerm "hemiparasitic_A" ;
lin hemiplegia_N = mkTerm "hemiplegia_N" ;
lin hemiplegic_N = mkTerm "hemiplegic_N" ;
lin hemisphere_N = mkTerm "hemisphere_N" ;
lin hemispheric_A = mkTerm "hemispheric_A" ;
lin hemispherical_A = mkTerm "hemispherical_A" ;
lin hemline_N = mkTerm "hemline_N" ;
lin hemlock_N = mkTerm "hemlock_N" ;
lin hemming_stitch_N = mkTerm "hemming_stitch_N" ;
lin hemochromatosis_N = mkTerm "hemochromatosis_N" ;
lin hemodialysis_N = mkTerm "hemodialysis_N" ;
lin hemodynamic_A = mkTerm "hemodynamic_A" ;
lin hemodynamics_N = mkTerm "hemodynamics_N" ;
lin hemoglobin_N = mkTerm "hemoglobin_N" ;
lin hemoglobinemia_N = mkTerm "hemoglobinemia_N" ;
lin hemoglobinopathy_N = mkTerm "hemoglobinopathy_N" ;
lin hemoglobinuria_N = mkTerm "hemoglobinuria_N" ;
lin hemolysin_N = mkTerm "hemolysin_N" ;
lin hemolysis_N = mkTerm "hemolysis_N" ;
lin hemolytic_A = mkTerm "hemolytic_A" ;
lin hemophilia_N = mkTerm "hemophilia_N" ;
lin hemophiliac_N = mkTerm "hemophiliac_N" ;
lin hemoprotein_N = mkTerm "hemoprotein_N" ;
lin hemoptysis_N = mkTerm "hemoptysis_N" ;
lin hemorrhage_N = mkTerm "hemorrhage_N" ;
lin hemorrhage_V = mkTerm "hemorrhage_V" ;
lin hemorrhage_V2 = mkTerm "hemorrhage_V2" ;
lin hemorrhagic_A = mkTerm "hemorrhagic_A" ;
lin hemorrhoid_N = mkTerm "hemorrhoid_N" ;
lin hemorrhoidectomy_N = mkTerm "hemorrhoidectomy_N" ;
lin hemosiderin_N = mkTerm "hemosiderin_N" ;
lin hemosiderosis_N = mkTerm "hemosiderosis_N" ;
lin hemostasis_N = mkTerm "hemostasis_N" ;
lin hemostat_N = mkTerm "hemostat_N" ;
lin hemothorax_N = mkTerm "hemothorax_N" ;
lin hemp_N = mkTerm "hemp_N" ;
lin hempen_A = mkTerm "hempen_A" ;
lin hemstitch_N = mkTerm "hemstitch_N" ;
lin hemstitch_V2 = mkTerm "hemstitch_V2" ;
lin hemsworth_PN = mkTerm "hemsworth_PN" ;
lin hen_N = mkTerm "hen_N" ;
lin hen_party_N = mkTerm "hen_party_N" ;
lin henbane_N = mkTerm "henbane_N" ;
lin henbit_N = mkTerm "henbit_N" ;
lin hence_Adv = mkTerm "hence_Adv" ;
lin henceforth_Adv = mkTerm "henceforth_Adv" ;
lin henceforward_Adv = mkTerm "henceforward_Adv" ;
lin henchman_N = mkTerm "henchman_N" ;
lin hencoop_N = mkTerm "hencoop_N" ;
lin hendiadys_N = mkTerm "hendiadys_N" ;
lin henhouse_N = mkTerm "henhouse_N" ;
lin henley_on_thames_PN = mkTerm "henley_on_thames_PN" ;
lin henna_N = mkTerm "henna_N" ;
lin hennaed_A = mkTerm "hennaed_A" ;
lin henpecked_A = mkTerm "henpecked_A" ;
lin henroost_N = mkTerm "henroost_N" ;
lin henry_N = mkTerm "henry_N" ;
lin henry_PN = mkTerm "henry_PN" ;
lin hep_A = mkTerm "hep_A" ;
lin hepadnavirus_N = mkTerm "hepadnavirus_N" ;
lin heparin_N = mkTerm "heparin_N" ;
lin hepatic_A = mkTerm "hepatic_A" ;
lin hepatica_N = mkTerm "hepatica_N" ;
lin hepatitis_N = mkTerm "hepatitis_N" ;
lin hepatoma_N = mkTerm "hepatoma_N" ;
lin hepatomegaly_N = mkTerm "hepatomegaly_N" ;
lin hepatotoxic_A = mkTerm "hepatotoxic_A" ;
lin hepatotoxin_N = mkTerm "hepatotoxin_N" ;
lin heptagon_N = mkTerm "heptagon_N" ;
lin heptane_N = mkTerm "heptane_N" ;
lin herald_N = mkTerm "herald_N" ;
lin herald_V2 = mkTerm "herald_V2" ;
lin heraldic_A = mkTerm "heraldic_A" ;
lin heraldry_N = mkTerm "heraldry_N" ;
lin herb_N = mkTerm "herb_N" ;
lin herb_PN = mkTerm "herb_PN" ;
lin herbaceous_A = mkTerm "herbaceous_A" ;
lin herbage_N = mkTerm "herbage_N" ;
lin herbal_A = mkTerm "herbal_A" ;
lin herbalist_N = mkTerm "herbalist_N" ;
lin herbarium_N = mkTerm "herbarium_N" ;
lin herbert_PN = mkTerm "herbert_PN" ;
lin herbicide_N = mkTerm "herbicide_N" ;
lin herbivore_N = mkTerm "herbivore_N" ;
lin herbivorous_A = mkTerm "herbivorous_A" ;
lin herculean_A = mkTerm "herculean_A" ;
lin herd_N = mkTerm "herd_N" ;
lin herd_V = mkTerm "herd_V" ;
lin herd_V2 = mkTerm "herd_V2" ;
lin herder_N = mkTerm "herder_N" ;
lin herdsman_N = mkTerm "herdsman_N" ;
lin hereabout_Adv = mkTerm "hereabout_Adv" ;
lin hereabouts_Adv = mkTerm "hereabouts_Adv" ;
lin hereafter_Adv = mkTerm "hereafter_Adv" ;
lin hereafter_N = mkTerm "hereafter_N" ;
lin hereby_Adv = mkTerm "hereby_Adv" ;
lin hereditament_N = mkTerm "hereditament_N" ;
lin hereditarianism_N = mkTerm "hereditarianism_N" ;
lin hereditary_A = mkTerm "hereditary_A" ;
lin heredity_N = mkTerm "heredity_N" ;
lin hereford_PN = mkTerm "hereford_PN" ;
lin herein_Adv = mkTerm "herein_Adv" ;
lin hereinafter_Adv = mkTerm "hereinafter_Adv" ;
lin hereinbefore_Adv = mkTerm "hereinbefore_Adv" ;
lin hereness_N = mkTerm "hereness_N" ;
lin hereof_Adv = mkTerm "hereof_Adv" ;
lin heresy_N = mkTerm "heresy_N" ;
lin heretic_N = mkTerm "heretic_N" ;
lin heretical_A = mkTerm "heretical_A" ;
lin hereto_Adv = mkTerm "hereto_Adv" ;
lin heretofore_Adv = mkTerm "heretofore_Adv" ;
lin hereunder_Adv = mkTerm "hereunder_Adv" ;
lin hereupon_Adv = mkTerm "hereupon_Adv" ;
lin herewith_Adv = mkTerm "herewith_Adv" ;
lin heritable_A = mkTerm "heritable_A" ;
lin heritage_N = mkTerm "heritage_N" ;
lin herm_N = mkTerm "herm_N" ;
lin hermaphrodite_N = mkTerm "hermaphrodite_N" ;
lin hermaphroditic_A = mkTerm "hermaphroditic_A" ;
lin hermaphroditism_N = mkTerm "hermaphroditism_N" ;
lin hermeneutic_A = mkTerm "hermeneutic_A" ;
lin hermeneutics_N = mkTerm "hermeneutics_N" ;
lin hermetic_A = mkTerm "hermetic_A" ;
lin hermit_N = mkTerm "hermit_N" ;
lin hermitage_N = mkTerm "hermitage_N" ;
lin herne_PN = mkTerm "herne_PN" ;
lin herne_bay_PN = mkTerm "herne_bay_PN" ;
lin hernia_N = mkTerm "hernia_N" ;
lin hero_N = mkTerm "hero_N" ;
lin heroic_A = mkTerm "heroic_A" ;
lin heroics_N = mkTerm "heroics_N" ;
lin heroin_N = mkTerm "heroin_N" ;
lin heroine_N = mkTerm "heroine_N" ;
lin heroism_N = mkTerm "heroism_N" ;
lin heron_N = mkTerm "heron_N" ;
lin heronry_N = mkTerm "heronry_N" ;
lin herpangia_N = mkTerm "herpangia_N" ;
lin herpes_N = mkTerm "herpes_N" ;
lin herpetologist_N = mkTerm "herpetologist_N" ;
lin herpetology_N = mkTerm "herpetology_N" ;
lin herr_N = mkTerm "herr_N" ;
lin herrerasaur_N = mkTerm "herrerasaur_N" ;
lin herring_N = mkTerm "herring_N" ;
lin herringbone_N = mkTerm "herringbone_N" ;
lin hertford_PN = mkTerm "hertford_PN" ;
lin hertfordshire_PN = mkTerm "hertfordshire_PN" ;
lin hertz_N = mkTerm "hertz_N" ;
lin hertzian_A = mkTerm "hertzian_A" ;
lin hesitance_N = mkTerm "hesitance_N" ;
lin hesitancy_N = mkTerm "hesitancy_N" ;
lin hesitant_A = mkTerm "hesitant_A" ;
lin hesitate_V = mkTerm "hesitate_V" ;
lin hesitate_VV = mkTerm "hesitate_VV" ;
lin hesitatingly_Adv = mkTerm "hesitatingly_Adv" ;
lin hesitation_N = mkTerm "hesitation_N" ;
lin hessian_N = mkTerm "hessian_N" ;
lin het_up_A = mkTerm "het_up_A" ;
lin heterocercal_A = mkTerm "heterocercal_A" ;
lin heterocyclic_A = mkTerm "heterocyclic_A" ;
lin heterodactyl_A = mkTerm "heterodactyl_A" ;
lin heterodox_A = mkTerm "heterodox_A" ;
lin heterodoxy_N = mkTerm "heterodoxy_N" ;
lin heterodyne_A = mkTerm "heterodyne_A" ;
lin heteroecious_A = mkTerm "heteroecious_A" ;
lin heterogeneity_N = mkTerm "heterogeneity_N" ;
lin heterogeneous_A = mkTerm "heterogeneous_A" ;
lin heterogenous_A = mkTerm "heterogenous_A" ;
lin heterograft_N = mkTerm "heterograft_N" ;
lin heteroicous_A = mkTerm "heteroicous_A" ;
lin heterologous_A = mkTerm "heterologous_A" ;
lin heterology_N = mkTerm "heterology_N" ;
lin heterometabolism_N = mkTerm "heterometabolism_N" ;
lin heterometabolous_A = mkTerm "heterometabolous_A" ;
lin heteronym_N = mkTerm "heteronym_N" ;
lin heteroploid_N = mkTerm "heteroploid_N" ;
lin heteroploidy_N = mkTerm "heteroploidy_N" ;
lin heterosexism_N = mkTerm "heterosexism_N" ;
lin heterosexual_A = mkTerm "heterosexual_A" ;
lin heterosexual_N = mkTerm "heterosexual_N" ;
lin heterosexuality_N = mkTerm "heterosexuality_N" ;
lin heterosis_N = mkTerm "heterosis_N" ;
lin heterosporous_A = mkTerm "heterosporous_A" ;
lin heterospory_N = mkTerm "heterospory_N" ;
lin heterostracan_N = mkTerm "heterostracan_N" ;
lin heterotroph_N = mkTerm "heterotroph_N" ;
lin heterotrophic_A = mkTerm "heterotrophic_A" ;
lin heterozygosity_N = mkTerm "heterozygosity_N" ;
lin heterozygote_N = mkTerm "heterozygote_N" ;
lin heterozygous_A = mkTerm "heterozygous_A" ;
lin heth_N = mkTerm "heth_N" ;
lin hetton_PN = mkTerm "hetton_PN" ;
lin heulandite_N = mkTerm "heulandite_N" ;
lin heuristic_A = mkTerm "heuristic_A" ;
lin heuristic_N = mkTerm "heuristic_N" ;
lin heuristics_N = mkTerm "heuristics_N" ;
lin hew_V = mkTerm "hew_V" ;
lin hew_V2 = mkTerm "hew_V2" ;
lin hewer_N = mkTerm "hewer_N" ;
lin hewn_A = mkTerm "hewn_A" ;
lin hex_N = mkTerm "hex_N" ;
lin hexachlorophene_N = mkTerm "hexachlorophene_N" ;
lin hexadecimal_A = mkTerm "hexadecimal_A" ;
lin hexagon_N = mkTerm "hexagon_N" ;
lin hexagonal_A = mkTerm "hexagonal_A" ;
lin hexagram_N = mkTerm "hexagram_N" ;
lin hexahedron_N = mkTerm "hexahedron_N" ;
lin hexameter_N = mkTerm "hexameter_N" ;
lin hexane_N = mkTerm "hexane_N" ;
lin hexangular_A = mkTerm "hexangular_A" ;
lin hexapod_N = mkTerm "hexapod_N" ;
lin hexed_A = mkTerm "hexed_A" ;
lin hexestrol_N = mkTerm "hexestrol_N" ;
lin hexham_PN = mkTerm "hexham_PN" ;
lin hexose_N = mkTerm "hexose_N" ;
lin hey_Interj = mkTerm "hey_Interj" ;
lin heyday_N = mkTerm "heyday_N" ;
lin heysham_PN = mkTerm "heysham_PN" ;
lin heywood_PN = mkTerm "heywood_PN" ;
lin hi_Interj = mkTerm "hi_Interj" ;
lin hi_fi_A = mkTerm "hi_fi_A" ;
lin hi_fi_N = mkTerm "hi_fi_N" ;
lin hiatus_N = mkTerm "hiatus_N" ;
lin hibachi_N = mkTerm "hibachi_N" ;
lin hibernate_V = mkTerm "hibernate_V" ;
lin hibernation_N = mkTerm "hibernation_N" ;
lin hibiscus_N = mkTerm "hibiscus_N" ;
lin hiccough_N = mkTerm "hiccough_N" ;
lin hiccough_V = mkTerm "hiccough_V" ;
lin hiccup_N = mkTerm "hiccup_N" ;
lin hiccup_V = mkTerm "hiccup_V" ;
lin hick_A = mkTerm "hick_A" ;
lin hick_N = mkTerm "hick_N" ;
lin hickey_N = mkTerm "hickey_N" ;
lin hickory_N = mkTerm "hickory_N" ;
lin hidden_A = mkTerm "hidden_A" ;
lin hiddenite_N = mkTerm "hiddenite_N" ;
lin hiddenness_N = mkTerm "hiddenness_N" ;
lin hide_N = mkTerm "hide_N" ;
lin hide_V = mkTerm "hide_V" ;
lin hide_V2 = mkTerm "hide_V2" ;
lin hide_and_seek_N = mkTerm "hide_and_seek_N" ;
lin hide_away_V = mkTerm "hide_away_V" ;
lin hide_away_V2 = mkTerm "hide_away_V2" ;
lin hide_out_N = mkTerm "hide_out_N" ;
lin hide_out_V = mkTerm "hide_out_V" ;
lin hideaway_N = mkTerm "hideaway_N" ;
lin hidebound_A = mkTerm "hidebound_A" ;
lin hideous_A = mkTerm "hideous_A" ;
lin hideousness_N = mkTerm "hideousness_N" ;
lin hiding_N = mkTerm "hiding_N" ;
lin hiding_place_N = mkTerm "hiding_place_N" ;
lin hidrotic_A = mkTerm "hidrotic_A" ;
lin hie_V = mkTerm "hie_V" ;
lin hierarch_N = mkTerm "hierarch_N" ;
lin hierarchic_A = mkTerm "hierarchic_A" ;
lin hierarchical_A = mkTerm "hierarchical_A" ;
lin hierarchy_N = mkTerm "hierarchy_N" ;
lin hieratic_A = mkTerm "hieratic_A" ;
lin hieratic_N = mkTerm "hieratic_N" ;
lin hierocracy_N = mkTerm "hierocracy_N" ;
lin hieroglyph_N = mkTerm "hieroglyph_N" ;
lin hieroglyphic_A = mkTerm "hieroglyphic_A" ;
lin hieroglyphics_N = mkTerm "hieroglyphics_N" ;
lin higgledy_piggledy_A = mkTerm "higgledy_piggledy_A" ;
lin higgledy_piggledy_Adv = mkTerm "higgledy_piggledy_Adv" ;
lin high_A = mkTerm "high_A" ;
lin high_Adv = mkTerm "high_Adv" ;
lin high_N = mkTerm "high_N" ;
lin high_class_A = mkTerm "high_class_A" ;
lin high_falutin_A = mkTerm "high_falutin_A" ;
lin high_fidelity_A = mkTerm "high_fidelity_A" ;
lin high_fidelity_N = mkTerm "high_fidelity_N" ;
lin high_frequency_N = mkTerm "high_frequency_N" ;
lin high_grade_A = mkTerm "high_grade_A" ;
lin high_handed_A = mkTerm "high_handed_A" ;
lin high_keyed_A = mkTerm "high_keyed_A" ;
lin high_level_A = mkTerm "high_level_A" ;
lin high_minded_A = mkTerm "high_minded_A" ;
lin high_mindedness_N = mkTerm "high_mindedness_N" ;
lin high_necked_A = mkTerm "high_necked_A" ;
lin high_octane_A = mkTerm "high_octane_A" ;
lin high_pitched_A = mkTerm "high_pitched_A" ;
lin high_powered_A = mkTerm "high_powered_A" ;
lin high_pressure_N = mkTerm "high_pressure_N" ;
lin high_priced_A = mkTerm "high_priced_A" ;
lin high_principled_A = mkTerm "high_principled_A" ;
lin high_ranking_A = mkTerm "high_ranking_A" ;
lin high_rise_A = mkTerm "high_rise_A" ;
lin high_sounding_A = mkTerm "high_sounding_A" ;
lin high_speed_A = mkTerm "high_speed_A" ;
lin high_spen_PN = mkTerm "high_spen_PN" ;
lin high_spirited_A = mkTerm "high_spirited_A" ;
lin high_tension_A = mkTerm "high_tension_A" ;
lin high_toned_A = mkTerm "high_toned_A" ;
lin high_up_N = mkTerm "high_up_N" ;
lin high_wycombe_PN = mkTerm "high_wycombe_PN" ;
lin highball_N = mkTerm "highball_N" ;
lin highbinder_N = mkTerm "highbinder_N" ;
lin highboard_N = mkTerm "highboard_N" ;
lin highborn_A = mkTerm "highborn_A" ;
lin highboy_N = mkTerm "highboy_N" ;
lin highbrow_A = mkTerm "highbrow_A" ;
lin highbrow_N = mkTerm "highbrow_N" ;
lin highchair_N = mkTerm "highchair_N" ;
lin highflier_N = mkTerm "highflier_N" ;
lin highflown_A = mkTerm "highflown_A" ;
lin highflyer_N = mkTerm "highflyer_N" ;
lin highflying_A = mkTerm "highflying_A" ;
lin highjack_N = mkTerm "highjack_N" ;
lin highjack_V2 = mkTerm "highjack_V2" ;
lin highjacker_N = mkTerm "highjacker_N" ;
lin highjacking_N = mkTerm "highjacking_N" ;
lin highland_N = mkTerm "highland_N" ;
lin highland_PN = mkTerm "highland_PN" ;
lin highlander_N = mkTerm "highlander_N" ;
lin highlight_N = mkTerm "highlight_N" ;
lin highlight_V2 = mkTerm "highlight_V2" ;
lin highlighter_N = mkTerm "highlighter_N" ;
lin highly_Adv = mkTerm "highly_Adv" ;
lin highness_N = mkTerm "highness_N" ;
lin highroad_N = mkTerm "highroad_N" ;
lin highway_N = mkTerm "highway_N" ;
lin highwayman_N = mkTerm "highwayman_N" ;
lin hijab_N = mkTerm "hijab_N" ;
lin hijack_N = mkTerm "hijack_N" ;
lin hijack_V2 = mkTerm "hijack_V2" ;
lin hijacker_N = mkTerm "hijacker_N" ;
lin hike_N = mkTerm "hike_N" ;
lin hike_V = mkTerm "hike_V" ;
lin hiker_N = mkTerm "hiker_N" ;
lin hilar_A = mkTerm "hilar_A" ;
lin hilarious_A = mkTerm "hilarious_A" ;
lin hilarity_N = mkTerm "hilarity_N" ;
lin hilary_PN = mkTerm "hilary_PN" ;
lin hilda_PN = mkTerm "hilda_PN" ;
lin hill_N = mkTerm "hill_N" ;
lin hill_billy_N = mkTerm "hill_billy_N" ;
lin hilliness_N = mkTerm "hilliness_N" ;
lin hillingdon_PN = mkTerm "hillingdon_PN" ;
lin hillock_N = mkTerm "hillock_N" ;
lin hillside_N = mkTerm "hillside_N" ;
lin hilltop_N = mkTerm "hilltop_N" ;
lin hilly_A = mkTerm "hilly_A" ;
lin hilt_N = mkTerm "hilt_N" ;
lin hilum_N = mkTerm "hilum_N" ;
lin hilus_N = mkTerm "hilus_N" ;
lin himanka_PN = mkTerm "himanka_PN" ;
lin hin_N = mkTerm "hin_N" ;
lin hinckley_PN = mkTerm "hinckley_PN" ;
lin hind_A = mkTerm "hind_A" ;
lin hind_N = mkTerm "hind_N" ;
lin hindbrain_N = mkTerm "hindbrain_N" ;
lin hinder_V2 = mkTerm "hinder_V2" ;
lin hindfoot_N = mkTerm "hindfoot_N" ;
lin hindgut_N = mkTerm "hindgut_N" ;
lin hindi_A = mkTerm "hindi_A" ;
lin hindmost_A = mkTerm "hindmost_A" ;
lin hindquarter_N = mkTerm "hindquarter_N" ;
lin hindquarters_N = mkTerm "hindquarters_N" ;
lin hindrance_N = mkTerm "hindrance_N" ;
lin hindshank_N = mkTerm "hindshank_N" ;
lin hindsight_N = mkTerm "hindsight_N" ;
lin hindu_A = mkTerm "hindu_A" ;
lin hindu_N = mkTerm "hindu_N" ;
lin hinduism_N = mkTerm "hinduism_N" ;
lin hindustani_A = mkTerm "hindustani_A" ;
lin hindustani_N = mkTerm "hindustani_N" ;
lin hinge_N = mkTerm "hinge_N" ;
lin hinge_V = mkTerm "hinge_V" ;
lin hinge_V2 = mkTerm "hinge_V2" ;
lin hinge_on_V2 = mkTerm "hinge_on_V2" ;
lin hinge_upon_V2 = mkTerm "hinge_upon_V2" ;
lin hinny_N = mkTerm "hinny_N" ;
lin hint_N = mkTerm "hint_N" ;
lin hint_V = mkTerm "hint_V" ;
lin hint_V2 = mkTerm "hint_V2" ;
lin hint_VS = mkTerm "hint_VS" ;
lin hinterland_N = mkTerm "hinterland_N" ;
lin hip_A = mkTerm "hip_A" ;
lin hip_N = mkTerm "hip_N" ;
lin hip_bath_N = mkTerm "hip_bath_N" ;
lin hip_flask_N = mkTerm "hip_flask_N" ;
lin hip_pocket_N = mkTerm "hip_pocket_N" ;
lin hipbone_N = mkTerm "hipbone_N" ;
lin hiplength_A = mkTerm "hiplength_A" ;
lin hipless_A = mkTerm "hipless_A" ;
lin hipline_N = mkTerm "hipline_N" ;
lin hippeastrum_N = mkTerm "hippeastrum_N" ;
lin hipped_A = mkTerm "hipped_A" ;
lin hippie_N = mkTerm "hippie_N" ;
lin hippo_N = mkTerm "hippo_N" ;
lin hippocampus_N = mkTerm "hippocampus_N" ;
lin hippocratic_A = mkTerm "hippocratic_A" ;
lin hippodrome_N = mkTerm "hippodrome_N" ;
lin hippopotamus_N = mkTerm "hippopotamus_N" ;
lin hippy_N = mkTerm "hippy_N" ;
lin hircine_A = mkTerm "hircine_A" ;
lin hire_N = mkTerm "hire_N" ;
lin hire_V2 = mkTerm "hire_V2" ;
lin hire_V2V = mkTerm "hire_V2V" ;
lin hireling_N = mkTerm "hireling_N" ;
lin hiroshima_PN = mkTerm "hiroshima_PN" ;
lin hirsute_A = mkTerm "hirsute_A" ;
lin hirsuteness_N = mkTerm "hirsuteness_N" ;
lin hirvensalmi_PN = mkTerm "hirvensalmi_PN" ;
lin hispanic_A = mkTerm "hispanic_A" ;
lin hispid_A = mkTerm "hispid_A" ;
lin hiss_N = mkTerm "hiss_N" ;
lin hiss_V = mkTerm "hiss_V" ;
lin hiss_V2 = mkTerm "hiss_V2" ;
lin hiss_VQ = mkTerm "hiss_VQ" ;
lin hisser_N = mkTerm "hisser_N" ;
lin histaminase_N = mkTerm "histaminase_N" ;
lin histamine_N = mkTerm "histamine_N" ;
lin histidine_N = mkTerm "histidine_N" ;
lin histiocyte_N = mkTerm "histiocyte_N" ;
lin histiocytosis_N = mkTerm "histiocytosis_N" ;
lin histocompatibility_N = mkTerm "histocompatibility_N" ;
lin histogram_N = mkTerm "histogram_N" ;
lin histoincompatibility_N = mkTerm "histoincompatibility_N" ;
lin histological_A = mkTerm "histological_A" ;
lin histologist_N = mkTerm "histologist_N" ;
lin histology_N = mkTerm "histology_N" ;
lin histone_N = mkTerm "histone_N" ;
lin historian_N = mkTerm "historian_N" ;
lin historic_A = mkTerm "historic_A" ;
lin historical_A = mkTerm "historical_A" ;
lin historicalness_N = mkTerm "historicalness_N" ;
lin historicism_N = mkTerm "historicism_N" ;
lin historicize_V2 = mkTerm "historicize_V2" ;
lin historiography_N = mkTerm "historiography_N" ;
lin history_N = mkTerm "history_N" ;
lin histrionic_A = mkTerm "histrionic_A" ;
lin histrionics_N = mkTerm "histrionics_N" ;
lin hit_N = mkTerm "hit_N" ;
lin hit_V = mkTerm "hit_V" ;
lin hit_V2 = mkTerm "hit_V2" ;
lin hit_and_run_A = mkTerm "hit_and_run_A" ;
lin hit_back_V2 = mkTerm "hit_back_V2" ;
lin hit_for_V3 = mkTerm "hit_for_V3" ;
lin hit_it_off_V = mkTerm "hit_it_off_V" ;
lin hit_it_off_with_V2 = mkTerm "hit_it_off_with_V2" ;
lin hit_on_V2 = mkTerm "hit_on_V2" ;
lin hit_out_at_V2 = mkTerm "hit_out_at_V2" ;
lin hit_up_V = mkTerm "hit_up_V" ;
lin hit_up_V2 = mkTerm "hit_up_V2" ;
lin hit_up_on_V2 = mkTerm "hit_up_on_V2" ;
lin hit_upon_V2 = mkTerm "hit_upon_V2" ;
lin hit_with_V3 = mkTerm "hit_with_V3" ;
lin hitch_N = mkTerm "hitch_N" ;
lin hitch_V = mkTerm "hitch_V" ;
lin hitch_V2 = mkTerm "hitch_V2" ;
lin hitchhike_V = mkTerm "hitchhike_V" ;
lin hitchhiker_N = mkTerm "hitchhiker_N" ;
lin hitchin_PN = mkTerm "hitchin_PN" ;
lin hitchrack_N = mkTerm "hitchrack_N" ;
lin hither_Adv = mkTerm "hither_Adv" ;
lin hitherto_Adv = mkTerm "hitherto_Adv" ;
lin hitless_A = mkTerm "hitless_A" ;
lin hitter_N = mkTerm "hitter_N" ;
lin hive_N = mkTerm "hive_N" ;
lin hive_V = mkTerm "hive_V" ;
lin hive_V2 = mkTerm "hive_V2" ;
lin hive_off_V2 = mkTerm "hive_off_V2" ;
lin hm_PN = mkTerm "hm_PN" ;
lin hmso_PN = mkTerm "hmso_PN" ;
lin hoar_A = mkTerm "hoar_A" ;
lin hoard_N = mkTerm "hoard_N" ;
lin hoard_V = mkTerm "hoard_V" ;
lin hoard_V2 = mkTerm "hoard_V2" ;
lin hoarder_N = mkTerm "hoarder_N" ;
lin hoarding_N = mkTerm "hoarding_N" ;
lin hoarfrost_N = mkTerm "hoarfrost_N" ;
lin hoariness_N = mkTerm "hoariness_N" ;
lin hoarse_A = mkTerm "hoarse_A" ;
lin hoarseness_N = mkTerm "hoarseness_N" ;
lin hoary_A = mkTerm "hoary_A" ;
lin hoatzin_N = mkTerm "hoatzin_N" ;
lin hoax_N = mkTerm "hoax_N" ;
lin hoax_V2 = mkTerm "hoax_V2" ;
lin hoaxer_N = mkTerm "hoaxer_N" ;
lin hob_N = mkTerm "hob_N" ;
lin hobbit_N = mkTerm "hobbit_N" ;
lin hobble_N = mkTerm "hobble_N" ;
lin hobble_V = mkTerm "hobble_V" ;
lin hobble_V2 = mkTerm "hobble_V2" ;
lin hobble_skirt_N = mkTerm "hobble_skirt_N" ;
lin hobbledehoy_N = mkTerm "hobbledehoy_N" ;
lin hobbler_N = mkTerm "hobbler_N" ;
lin hobby_N = mkTerm "hobby_N" ;
lin hobbyhorse_N = mkTerm "hobbyhorse_N" ;
lin hobbyism_N = mkTerm "hobbyism_N" ;
lin hobbyist_N = mkTerm "hobbyist_N" ;
lin hobgoblin_N = mkTerm "hobgoblin_N" ;
lin hobnail_N = mkTerm "hobnail_N" ;
lin hobnailed_A = mkTerm "hobnailed_A" ;
lin hobnob_V = mkTerm "hobnob_V" ;
lin hobo_N = mkTerm "hobo_N" ;
lin hobson_PN = mkTerm "hobson_PN" ;
lin hock_N = mkTerm "hock_N" ;
lin hock_V2 = mkTerm "hock_V2" ;
lin hockey_N = mkTerm "hockey_N" ;
lin hockley_PN = mkTerm "hockley_PN" ;
lin hocus_pocus_N = mkTerm "hocus_pocus_N" ;
lin hod_N = mkTerm "hod_N" ;
lin hoddesdon_PN = mkTerm "hoddesdon_PN" ;
lin hodgepodge_N = mkTerm "hodgepodge_N" ;
lin hodoscope_N = mkTerm "hodoscope_N" ;
lin hoe_N = mkTerm "hoe_N" ;
lin hoe_V = mkTerm "hoe_V" ;
lin hoe_V2 = mkTerm "hoe_V2" ;
lin hoecake_N = mkTerm "hoecake_N" ;
lin hofei_PN = mkTerm "hofei_PN" ;
lin hog_N = mkTerm "hog_N" ;
lin hog_V2 = mkTerm "hog_V2" ;
lin hogan_N = mkTerm "hogan_N" ;
lin hogback_N = mkTerm "hogback_N" ;
lin hogchoker_N = mkTerm "hogchoker_N" ;
lin hogfish_N = mkTerm "hogfish_N" ;
lin hoggish_A = mkTerm "hoggish_A" ;
lin hogmanay_N = mkTerm "hogmanay_N" ;
lin hogmanay_PN = mkTerm "hogmanay_PN" ;
lin hogshead_N = mkTerm "hogshead_N" ;
lin hogwash_N = mkTerm "hogwash_N" ;
lin hoist_N = mkTerm "hoist_N" ;
lin hoist_V2 = mkTerm "hoist_V2" ;
lin hoister_N = mkTerm "hoister_N" ;
lin hoity_toity_A = mkTerm "hoity_toity_A" ;
lin hold_N = mkTerm "hold_N" ;
lin hold_V = mkTerm "hold_V" ;
lin hold_V2 = mkTerm "hold_V2" ;
lin hold_VS = mkTerm "hold_VS" ;
lin hold_against_V3 = mkTerm "hold_against_V3" ;
lin hold_back_V = mkTerm "hold_back_V" ;
lin hold_back_V2 = mkTerm "hold_back_V2" ;
lin hold_back_from_V2 = mkTerm "hold_back_from_V2" ;
lin hold_down_V2 = mkTerm "hold_down_V2" ;
lin hold_forth_V = mkTerm "hold_forth_V" ;
lin hold_off_V = mkTerm "hold_off_V" ;
lin hold_off_V2 = mkTerm "hold_off_V2" ;
lin hold_off_on_V2 = mkTerm "hold_off_on_V2" ;
lin hold_on_V = mkTerm "hold_on_V" ;
lin hold_on_to_V2 = mkTerm "hold_on_to_V2" ;
lin hold_onto_V = mkTerm "hold_onto_V" ;
lin hold_onto_V2 = mkTerm "hold_onto_V2" ;
lin hold_out_V = mkTerm "hold_out_V" ;
lin hold_out_V2 = mkTerm "hold_out_V2" ;
lin hold_out_against_V2 = mkTerm "hold_out_against_V2" ;
lin hold_out_for_V2 = mkTerm "hold_out_for_V2" ;
lin hold_out_on_V2 = mkTerm "hold_out_on_V2" ;
lin hold_over_V2 = mkTerm "hold_over_V2" ;
lin hold_together_V = mkTerm "hold_together_V" ;
lin hold_up_N = mkTerm "hold_up_N" ;
lin hold_up_V2 = mkTerm "hold_up_V2" ;
lin hold_with_V2 = mkTerm "hold_with_V2" ;
lin holdall_N = mkTerm "holdall_N" ;
lin holder_N = mkTerm "holder_N" ;
lin holding_N = mkTerm "holding_N" ;
lin holdout_N = mkTerm "holdout_N" ;
lin holdover_N = mkTerm "holdover_N" ;
lin hole_N = mkTerm "hole_N" ;
lin hole_V = mkTerm "hole_V" ;
lin hole_V2 = mkTerm "hole_V2" ;
lin hole_and_corner_A = mkTerm "hole_and_corner_A" ;
lin hole_up_V = mkTerm "hole_up_V" ;
lin holey_A = mkTerm "holey_A" ;
lin holiday_N = mkTerm "holiday_N" ;
lin holiday_V = mkTerm "holiday_V" ;
lin holiday_maker_N = mkTerm "holiday_maker_N" ;
lin holiness_N = mkTerm "holiness_N" ;
lin holism_N = mkTerm "holism_N" ;
lin holistic_A = mkTerm "holistic_A" ;
lin holland_PN = mkTerm "holland_PN" ;
lin hollandaise_N = mkTerm "hollandaise_N" ;
lin hollander_A = mkTerm "hollander_A" ;
lin hollander_N = mkTerm "hollander_N" ;
lin holler_V = mkTerm "holler_V" ;
lin holler_V2 = mkTerm "holler_V2" ;
lin holloa_N = mkTerm "holloa_N" ;
lin hollola_PN = mkTerm "hollola_PN" ;
lin hollow_A = mkTerm "hollow_A" ;
lin hollow_N = mkTerm "hollow_N" ;
lin hollow_V2 = mkTerm "hollow_V2" ;
lin hollowness_N = mkTerm "hollowness_N" ;
lin hollowware_N = mkTerm "hollowware_N" ;
lin holly_N = mkTerm "holly_N" ;
lin hollyhock_N = mkTerm "hollyhock_N" ;
lin hollywood_PN = mkTerm "hollywood_PN" ;
lin holm_oak_N = mkTerm "holm_oak_N" ;
lin holmfirth_PN = mkTerm "holmfirth_PN" ;
lin holmium_N = mkTerm "holmium_N" ;
lin holocaust_N = mkTerm "holocaust_N" ;
lin holocephalan_N = mkTerm "holocephalan_N" ;
lin hologram_N = mkTerm "hologram_N" ;
lin holograph_N = mkTerm "holograph_N" ;
lin holographic_A = mkTerm "holographic_A" ;
lin holography_N = mkTerm "holography_N" ;
lin holometabola_N = mkTerm "holometabola_N" ;
lin holometabolic_A = mkTerm "holometabolic_A" ;
lin holometabolism_N = mkTerm "holometabolism_N" ;
lin holonym_N = mkTerm "holonym_N" ;
lin holonymy_N = mkTerm "holonymy_N" ;
lin holophyte_N = mkTerm "holophyte_N" ;
lin holophytic_A = mkTerm "holophytic_A" ;
lin holozoic_A = mkTerm "holozoic_A" ;
lin holster_N = mkTerm "holster_N" ;
lin holy_A = mkTerm "holy_A" ;
lin holy_N = mkTerm "holy_N" ;
lin holyhead_PN = mkTerm "holyhead_PN" ;
lin holystone_N = mkTerm "holystone_N" ;
lin holystone_V2 = mkTerm "holystone_V2" ;
lin homage_N = mkTerm "homage_N" ;
lin home_A = mkTerm "home_A" ;
lin home_Adv = mkTerm "home_Adv" ;
lin home_N = mkTerm "home_N" ;
lin home_baked_A = mkTerm "home_baked_A" ;
lin home_brewed_A = mkTerm "home_brewed_A" ;
lin home_cured_A = mkTerm "home_cured_A" ;
lin home_farm_N = mkTerm "home_farm_N" ;
lin home_grown_A = mkTerm "home_grown_A" ;
lin home_in_on_V2 = mkTerm "home_in_on_V2" ;
lin home_made_A = mkTerm "home_made_A" ;
lin homebound_A = mkTerm "homebound_A" ;
lin homebound_N = mkTerm "homebound_N" ;
lin homeboy_N = mkTerm "homeboy_N" ;
lin homebuilder_N = mkTerm "homebuilder_N" ;
lin homecoming_N = mkTerm "homecoming_N" ;
lin homefolk_N = mkTerm "homefolk_N" ;
lin homegirl_N = mkTerm "homegirl_N" ;
lin homeland_N = mkTerm "homeland_N" ;
lin homeless_A = mkTerm "homeless_A" ;
lin homeless_N = mkTerm "homeless_N" ;
lin homelessness_N = mkTerm "homelessness_N" ;
lin homelike_A = mkTerm "homelike_A" ;
lin homeliness_N = mkTerm "homeliness_N" ;
lin homely_A = mkTerm "homely_A" ;
lin homemaking_N = mkTerm "homemaking_N" ;
lin homeobox_N = mkTerm "homeobox_N" ;
lin homeopath_N = mkTerm "homeopath_N" ;
lin homeopathic_A = mkTerm "homeopathic_A" ;
lin homeopathy_N = mkTerm "homeopathy_N" ;
lin homeostasis_N = mkTerm "homeostasis_N" ;
lin homeostatic_A = mkTerm "homeostatic_A" ;
lin homeotherm_N = mkTerm "homeotherm_N" ;
lin homeowner_N = mkTerm "homeowner_N" ;
lin homepage_N = mkTerm "homepage_N" ;
lin homer_N = mkTerm "homer_N" ;
lin homer_V = mkTerm "homer_V" ;
lin homeric_A = mkTerm "homeric_A" ;
lin homesick_A = mkTerm "homesick_A" ;
lin homesickness_N = mkTerm "homesickness_N" ;
lin homespun_A = mkTerm "homespun_A" ;
lin homespun_N = mkTerm "homespun_N" ;
lin homestead_N = mkTerm "homestead_N" ;
lin homestretch_N = mkTerm "homestretch_N" ;
lin hometown_N = mkTerm "hometown_N" ;
lin homeward_A = mkTerm "homeward_A" ;
lin homeward_Adv = mkTerm "homeward_Adv" ;
lin homewards_Adv = mkTerm "homewards_Adv" ;
lin homework_N = mkTerm "homework_N" ;
lin homeworld_N = mkTerm "homeworld_N" ;
lin homey_A = mkTerm "homey_A" ;
lin homicidal_A = mkTerm "homicidal_A" ;
lin homicide_N = mkTerm "homicide_N" ;
lin homiletic_A = mkTerm "homiletic_A" ;
lin homiletics_N = mkTerm "homiletics_N" ;
lin homily_N = mkTerm "homily_N" ;
lin hominal_A = mkTerm "hominal_A" ;
lin homing_A = mkTerm "homing_A" ;
lin hominian_A = mkTerm "hominian_A" ;
lin hominid_N = mkTerm "hominid_N" ;
lin hominine_A = mkTerm "hominine_A" ;
lin hominoid_N = mkTerm "hominoid_N" ;
lin hominy_N = mkTerm "hominy_N" ;
lin homo_N = mkTerm "homo_N" ;
lin homo_sapiens_N = mkTerm "homo_sapiens_N" ;
lin homocercal_A = mkTerm "homocercal_A" ;
lin homocyclic_A = mkTerm "homocyclic_A" ;
lin homoeopath_N = mkTerm "homoeopath_N" ;
lin homoeopathy_N = mkTerm "homoeopathy_N" ;
lin homoerotic_A = mkTerm "homoerotic_A" ;
lin homogenate_N = mkTerm "homogenate_N" ;
lin homogeneity_N = mkTerm "homogeneity_N" ;
lin homogeneous_A = mkTerm "homogeneous_A" ;
lin homogenization_N = mkTerm "homogenization_N" ;
lin homogenize_V2 = mkTerm "homogenize_V2" ;
lin homogeny_N = mkTerm "homogeny_N" ;
lin homograft_N = mkTerm "homograft_N" ;
lin homograph_N = mkTerm "homograph_N" ;
lin homoiothermic_A = mkTerm "homoiothermic_A" ;
lin homologic_A = mkTerm "homologic_A" ;
lin homologous_A = mkTerm "homologous_A" ;
lin homology_N = mkTerm "homology_N" ;
lin homomorphism_N = mkTerm "homomorphism_N" ;
lin homonym_N = mkTerm "homonym_N" ;
lin homonymic_A = mkTerm "homonymic_A" ;
lin homonymy_N = mkTerm "homonymy_N" ;
lin homophobe_N = mkTerm "homophobe_N" ;
lin homophobia_N = mkTerm "homophobia_N" ;
lin homophobic_A = mkTerm "homophobic_A" ;
lin homophone_N = mkTerm "homophone_N" ;
lin homophonic_A = mkTerm "homophonic_A" ;
lin homophonous_A = mkTerm "homophonous_A" ;
lin homophony_N = mkTerm "homophony_N" ;
lin homosexual_A = mkTerm "homosexual_A" ;
lin homosexual_N = mkTerm "homosexual_N" ;
lin homosexuality_N = mkTerm "homosexuality_N" ;
lin homosporous_A = mkTerm "homosporous_A" ;
lin homospory_N = mkTerm "homospory_N" ;
lin homostylous_A = mkTerm "homostylous_A" ;
lin homozygosity_N = mkTerm "homozygosity_N" ;
lin homozygote_N = mkTerm "homozygote_N" ;
lin homozygous_A = mkTerm "homozygous_A" ;
lin homunculus_N = mkTerm "homunculus_N" ;
lin hon_PN = mkTerm "hon_PN" ;
lin honduran_A = mkTerm "honduran_A" ;
lin honduran_N = mkTerm "honduran_N" ;
lin honduras_PN = mkTerm "honduras_PN" ;
lin hone_N = mkTerm "hone_N" ;
lin hone_V2 = mkTerm "hone_V2" ;
lin hone_in_on_V2 = mkTerm "hone_in_on_V2" ;
lin honest_A = mkTerm "honest_A" ;
lin honesty_N = mkTerm "honesty_N" ;
lin honey_A = mkTerm "honey_A" ;
lin honey_N = mkTerm "honey_N" ;
lin honeybee_N = mkTerm "honeybee_N" ;
lin honeycomb_N = mkTerm "honeycomb_N" ;
lin honeycomb_V2 = mkTerm "honeycomb_V2" ;
lin honeycreeper_N = mkTerm "honeycreeper_N" ;
lin honeydew_N = mkTerm "honeydew_N" ;
lin honeyed_A = mkTerm "honeyed_A" ;
lin honeyflower_N = mkTerm "honeyflower_N" ;
lin honeylike_A = mkTerm "honeylike_A" ;
lin honeymoon_N = mkTerm "honeymoon_N" ;
lin honeymoon_V = mkTerm "honeymoon_V" ;
lin honeypot_N = mkTerm "honeypot_N" ;
lin honeysuckle_N = mkTerm "honeysuckle_N" ;
lin hong_kong_PN = mkTerm "hong_kong_PN" ;
lin honiton_PN = mkTerm "honiton_PN" ;
lin honk_N = mkTerm "honk_N" ;
lin honk_V = mkTerm "honk_V" ;
lin honkajoki_PN = mkTerm "honkajoki_PN" ;
lin honker_N = mkTerm "honker_N" ;
lin honkytonk_N = mkTerm "honkytonk_N" ;
lin honor_N = mkTerm "honor_N" ;
lin honorable_A = mkTerm "honorable_A" ;
lin honorarium_N = mkTerm "honorarium_N" ;
lin honorary_A = mkTerm "honorary_A" ;
lin honoree_N = mkTerm "honoree_N" ;
lin honorific_A = mkTerm "honorific_A" ;
lin honorific_N = mkTerm "honorific_N" ;
lin honoring_N = mkTerm "honoring_N" ;
lin honour_N = mkTerm "honour_N" ;
lin honour_V2 = mkTerm "honour_V2" ;
lin honourable_A = mkTerm "honourable_A" ;
lin honourableness_N = mkTerm "honourableness_N" ;
lin hoo_PN = mkTerm "hoo_PN" ;
lin hooch_N = mkTerm "hooch_N" ;
lin hood_N = mkTerm "hood_N" ;
lin hood_V2 = mkTerm "hood_V2" ;
lin hoodlum_N = mkTerm "hoodlum_N" ;
lin hoodoo_N = mkTerm "hoodoo_N" ;
lin hoodoo_V2 = mkTerm "hoodoo_V2" ;
lin hoodwink_V2 = mkTerm "hoodwink_V2" ;
lin hooey_N = mkTerm "hooey_N" ;
lin hoof_N = mkTerm "hoof_N" ;
lin hoofer_N = mkTerm "hoofer_N" ;
lin hooflike_A = mkTerm "hooflike_A" ;
lin hoofprint_N = mkTerm "hoofprint_N" ;
lin hook_N = mkTerm "hook_N" ;
lin hook_V = mkTerm "hook_V" ;
lin hook_V2 = mkTerm "hook_V2" ;
lin hook_into_V2 = mkTerm "hook_into_V2" ;
lin hook_nosed_A = mkTerm "hook_nosed_A" ;
lin hook_up_N = mkTerm "hook_up_N" ;
lin hook_up_V = mkTerm "hook_up_V" ;
lin hook_up_V2 = mkTerm "hook_up_V2" ;
lin hook_up_to_V2 = mkTerm "hook_up_to_V2" ;
lin hookah_N = mkTerm "hookah_N" ;
lin hooker_N = mkTerm "hooker_N" ;
lin hooklike_A = mkTerm "hooklike_A" ;
lin hookworm_N = mkTerm "hookworm_N" ;
lin hooky_N = mkTerm "hooky_N" ;
lin hooligan_N = mkTerm "hooligan_N" ;
lin hooliganism_N = mkTerm "hooliganism_N" ;
lin hoon_around_V = mkTerm "hoon_around_V" ;
lin hoop_N = mkTerm "hoop_N" ;
lin hoop_V2 = mkTerm "hoop_V2" ;
lin hoop_la_N = mkTerm "hoop_la_N" ;
lin hoopoe_N = mkTerm "hoopoe_N" ;
lin hoopskirt_N = mkTerm "hoopskirt_N" ;
lin hoosegow_N = mkTerm "hoosegow_N" ;
lin hoot_N = mkTerm "hoot_N" ;
lin hoot_V = mkTerm "hoot_V" ;
lin hoot_V2 = mkTerm "hoot_V2" ;
lin hooter_N = mkTerm "hooter_N" ;
lin hoover_N = mkTerm "hoover_N" ;
lin hoover_V2 = mkTerm "hoover_V2" ;
lin hop_N = mkTerm "hop_N" ;
lin hop_V = mkTerm "hop_V" ;
lin hop_V2 = mkTerm "hop_V2" ;
lin hop_field_N = mkTerm "hop_field_N" ;
lin hop_garden_N = mkTerm "hop_garden_N" ;
lin hop_picker_N = mkTerm "hop_picker_N" ;
lin hop_pole_N = mkTerm "hop_pole_N" ;
lin hope_N = mkTerm "hope_N" ;
lin hope_PN = mkTerm "hope_PN" ;
lin hope_V = mkTerm "hope_V" ;
lin hope_VS = mkTerm "hope_VS" ;
lin hope_VV = mkTerm "hope_VV" ;
lin hopeful_A = mkTerm "hopeful_A" ;
lin hopefulness_N = mkTerm "hopefulness_N" ;
lin hopeless_A = mkTerm "hopeless_A" ;
lin hopelessness_N = mkTerm "hopelessness_N" ;
lin hoper_N = mkTerm "hoper_N" ;
lin hopped_up_A = mkTerm "hopped_up_A" ;
lin hopper_N = mkTerm "hopper_N" ;
lin hopsacking_N = mkTerm "hopsacking_N" ;
lin hopscotch_N = mkTerm "hopscotch_N" ;
lin hopscotch_V = mkTerm "hopscotch_V" ;
lin horace_PN = mkTerm "horace_PN" ;
lin horary_A = mkTerm "horary_A" ;
lin horde_N = mkTerm "horde_N" ;
lin horehound_N = mkTerm "horehound_N" ;
lin horizon_N = mkTerm "horizon_N" ;
lin horizontal_A = mkTerm "horizontal_A" ;
lin horizontal_N = mkTerm "horizontal_N" ;
lin horizontality_N = mkTerm "horizontality_N" ;
lin horley_PN = mkTerm "horley_PN" ;
lin hormonal_A = mkTerm "hormonal_A" ;
lin hormone_N = mkTerm "hormone_N" ;
lin horn_N = mkTerm "horn_N" ;
lin horn_V = mkTerm "horn_V" ;
lin horn_rimmed_A = mkTerm "horn_rimmed_A" ;
lin hornbeam_N = mkTerm "hornbeam_N" ;
lin hornbill_N = mkTerm "hornbill_N" ;
lin hornblende_N = mkTerm "hornblende_N" ;
lin hornbook_N = mkTerm "hornbook_N" ;
lin horned_A = mkTerm "horned_A" ;
lin hornet_N = mkTerm "hornet_N" ;
lin hornfels_N = mkTerm "hornfels_N" ;
lin horniness_N = mkTerm "horniness_N" ;
lin hornist_N = mkTerm "hornist_N" ;
lin hornless_A = mkTerm "hornless_A" ;
lin hornlike_A = mkTerm "hornlike_A" ;
lin hornpipe_N = mkTerm "hornpipe_N" ;
lin hornsea_PN = mkTerm "hornsea_PN" ;
lin hornwort_N = mkTerm "hornwort_N" ;
lin horny_A = mkTerm "horny_A" ;
lin horology_N = mkTerm "horology_N" ;
lin horoscope_N = mkTerm "horoscope_N" ;
lin horoscopy_N = mkTerm "horoscopy_N" ;
lin horrible_A = mkTerm "horrible_A" ;
lin horrid_A = mkTerm "horrid_A" ;
lin horridness_N = mkTerm "horridness_N" ;
lin horrific_A = mkTerm "horrific_A" ;
lin horrify_V2 = mkTerm "horrify_V2" ;
lin horrifyingly_Adv = mkTerm "horrifyingly_Adv" ;
lin horror_N = mkTerm "horror_N" ;
lin horror_stricken_A = mkTerm "horror_stricken_A" ;
lin horror_struck_A = mkTerm "horror_struck_A" ;
lin hors_de_combat_A = mkTerm "hors_de_combat_A" ;
lin horse_N = mkTerm "horse_N" ;
lin horse_around_V = mkTerm "horse_around_V" ;
lin horse_chestnut_N = mkTerm "horse_chestnut_N" ;
lin horse_laugh_N = mkTerm "horse_laugh_N" ;
lin horse_pond_N = mkTerm "horse_pond_N" ;
lin horse_sense_N = mkTerm "horse_sense_N" ;
lin horseback_Adv = mkTerm "horseback_Adv" ;
lin horseback_N = mkTerm "horseback_N" ;
lin horsebox_N = mkTerm "horsebox_N" ;
lin horsecar_N = mkTerm "horsecar_N" ;
lin horsecloth_N = mkTerm "horsecloth_N" ;
lin horseflesh_N = mkTerm "horseflesh_N" ;
lin horsefly_N = mkTerm "horsefly_N" ;
lin horsehair_N = mkTerm "horsehair_N" ;
lin horsehide_N = mkTerm "horsehide_N" ;
lin horseleech_N = mkTerm "horseleech_N" ;
lin horseman_N = mkTerm "horseman_N" ;
lin horsemanship_N = mkTerm "horsemanship_N" ;
lin horsemeat_N = mkTerm "horsemeat_N" ;
lin horsemint_N = mkTerm "horsemint_N" ;
lin horseplay_N = mkTerm "horseplay_N" ;
lin horsepower_N = mkTerm "horsepower_N" ;
lin horserace_N = mkTerm "horserace_N" ;
lin horseracing_N = mkTerm "horseracing_N" ;
lin horseradish_N = mkTerm "horseradish_N" ;
lin horseshoe_N = mkTerm "horseshoe_N" ;
lin horseshow_N = mkTerm "horseshow_N" ;
lin horsetail_N = mkTerm "horsetail_N" ;
lin horseweed_N = mkTerm "horseweed_N" ;
lin horsewhip_N = mkTerm "horsewhip_N" ;
lin horsewhip_V2 = mkTerm "horsewhip_V2" ;
lin horsewhipping_N = mkTerm "horsewhipping_N" ;
lin horsewoman_N = mkTerm "horsewoman_N" ;
lin horsham_PN = mkTerm "horsham_PN" ;
lin horsley_PN = mkTerm "horsley_PN" ;
lin horst_N = mkTerm "horst_N" ;
lin horsy_A = mkTerm "horsy_A" ;
lin hortative_A = mkTerm "hortative_A" ;
lin hortensia_N = mkTerm "hortensia_N" ;
lin horticultural_A = mkTerm "horticultural_A" ;
lin horticulture_N = mkTerm "horticulture_N" ;
lin horticulturist_N = mkTerm "horticulturist_N" ;
lin horwich_PN = mkTerm "horwich_PN" ;
lin hosanna_N = mkTerm "hosanna_N" ;
lin hose_N = mkTerm "hose_N" ;
lin hose_V2 = mkTerm "hose_V2" ;
lin hose_down_V2 = mkTerm "hose_down_V2" ;
lin hosepipe_N = mkTerm "hosepipe_N" ;
lin hosier_N = mkTerm "hosier_N" ;
lin hosiery_N = mkTerm "hosiery_N" ;
lin hosp_PN = mkTerm "hosp_PN" ;
lin hospice_N = mkTerm "hospice_N" ;
lin hospitable_A = mkTerm "hospitable_A" ;
lin hospitableness_N = mkTerm "hospitableness_N" ;
lin hospital_N = mkTerm "hospital_N" ;
lin hospitality_N = mkTerm "hospitality_N" ;
lin hospitalization_N = mkTerm "hospitalization_N" ;
lin hospitalize_V2 = mkTerm "hospitalize_V2" ;
lin host_N = mkTerm "host_N" ;
lin host_V2 = mkTerm "host_V2" ;
lin hostage_N = mkTerm "hostage_N" ;
lin hostel_N = mkTerm "hostel_N" ;
lin hosteller_N = mkTerm "hosteller_N" ;
lin hostelry_N = mkTerm "hostelry_N" ;
lin hostess_N = mkTerm "hostess_N" ;
lin hostile_A = mkTerm "hostile_A" ;
lin hostile_N = mkTerm "hostile_N" ;
lin hostilities_N = mkTerm "hostilities_N" ;
lin hostility_N = mkTerm "hostility_N" ;
lin hot_A = mkTerm "hot_A" ;
lin hot_V = mkTerm "hot_V" ;
lin hot_V2 = mkTerm "hot_V2" ;
lin hot_blooded_A = mkTerm "hot_blooded_A" ;
lin hot_headed_A = mkTerm "hot_headed_A" ;
lin hot_tempered_A = mkTerm "hot_tempered_A" ;
lin hot_water_bottle_N = mkTerm "hot_water_bottle_N" ;
lin hotbed_N = mkTerm "hotbed_N" ;
lin hotbox_N = mkTerm "hotbox_N" ;
lin hotchpotch_N = mkTerm "hotchpotch_N" ;
lin hotdog_N = mkTerm "hotdog_N" ;
lin hotel_N = mkTerm "hotel_N" ;
lin hotelier_N = mkTerm "hotelier_N" ;
lin hotfoot_Adv = mkTerm "hotfoot_Adv" ;
lin hotfoot_N = mkTerm "hotfoot_N" ;
lin hotfoot_V = mkTerm "hotfoot_V" ;
lin hothead_N = mkTerm "hothead_N" ;
lin hothouse_N = mkTerm "hothouse_N" ;
lin hotness_N = mkTerm "hotness_N" ;
lin hotplate_N = mkTerm "hotplate_N" ;
lin hotspur_N = mkTerm "hotspur_N" ;
lin hottish_A = mkTerm "hottish_A" ;
lin houghton_PN = mkTerm "houghton_PN" ;
lin hound_N = mkTerm "hound_N" ;
lin hound_V2 = mkTerm "hound_V2" ;
lin hound_out_V2 = mkTerm "hound_out_V2" ;
lin hounslow_PN = mkTerm "hounslow_PN" ;
lin hour_N = mkTerm "hour_N" ;
lin hourglass_N = mkTerm "hourglass_N" ;
lin houri_N = mkTerm "houri_N" ;
lin hourlong_A = mkTerm "hourlong_A" ;
lin hourly_A = mkTerm "hourly_A" ;
lin hourly_Adv = mkTerm "hourly_Adv" ;
lin hours_N = mkTerm "hours_N" ;
lin house_N = mkTerm "house_N" ;
lin house_V2 = mkTerm "house_V2" ;
lin house_party_N = mkTerm "house_party_N" ;
lin house_warming_N = mkTerm "house_warming_N" ;
lin houseboat_N = mkTerm "houseboat_N" ;
lin housebound_A = mkTerm "housebound_A" ;
lin housebreaker_N = mkTerm "housebreaker_N" ;
lin housebreaking_N = mkTerm "housebreaking_N" ;
lin housebroken_A = mkTerm "housebroken_A" ;
lin housecleaning_N = mkTerm "housecleaning_N" ;
lin housecoat_N = mkTerm "housecoat_N" ;
lin housecraft_N = mkTerm "housecraft_N" ;
lin housedog_N = mkTerm "housedog_N" ;
lin housefather_N = mkTerm "housefather_N" ;
lin housefly_N = mkTerm "housefly_N" ;
lin houseful_N = mkTerm "houseful_N" ;
lin household_N = mkTerm "household_N" ;
lin householder_N = mkTerm "householder_N" ;
lin housekeeper_N = mkTerm "housekeeper_N" ;
lin houselights_N = mkTerm "houselights_N" ;
lin housemaid_N = mkTerm "housemaid_N" ;
lin houseman_N = mkTerm "houseman_N" ;
lin housemaster_N = mkTerm "housemaster_N" ;
lin housemate_N = mkTerm "housemate_N" ;
lin housemother_N = mkTerm "housemother_N" ;
lin houseplant_N = mkTerm "houseplant_N" ;
lin houseproud_A = mkTerm "houseproud_A" ;
lin houseroom_N = mkTerm "houseroom_N" ;
lin housetop_N = mkTerm "housetop_N" ;
lin housetrained_A = mkTerm "housetrained_A" ;
lin housewife_N = mkTerm "housewife_N" ;
lin housewifely_A = mkTerm "housewifely_A" ;
lin housewifery_N = mkTerm "housewifery_N" ;
lin housework_N = mkTerm "housework_N" ;
lin housewrecker_N = mkTerm "housewrecker_N" ;
lin housing_N = mkTerm "housing_N" ;
lin houston_PN = mkTerm "houston_PN" ;
lin houtskär_PN = mkTerm "houtskär_PN" ;
lin hove_PN = mkTerm "hove_PN" ;
lin hovea_N = mkTerm "hovea_N" ;
lin hovel_N = mkTerm "hovel_N" ;
lin hover_V = mkTerm "hover_V" ;
lin hover_around_V = mkTerm "hover_around_V" ;
lin hovercraft_N = mkTerm "hovercraft_N" ;
lin how8much_IDet = mkTerm "how8much_IDet" ;
lin how_d'ye_do_N = mkTerm "how_d'ye_do_N" ;
lin howard_PN = mkTerm "howard_PN" ;
lin howdah_N = mkTerm "howdah_N" ;
lin however_Adv = mkTerm "however_Adv" ;
lin howitzer_N = mkTerm "howitzer_N" ;
lin howl_N = mkTerm "howl_N" ;
lin howl_V = mkTerm "howl_V" ;
lin howl_V2 = mkTerm "howl_V2" ;
lin howler_N = mkTerm "howler_N" ;
lin hoya_N = mkTerm "hoya_N" ;
lin hoyden_N = mkTerm "hoyden_N" ;
lin hoydenish_A = mkTerm "hoydenish_A" ;
lin hoydenism_N = mkTerm "hoydenism_N" ;
lin hoylake_PN = mkTerm "hoylake_PN" ;
lin hoyland_nether_PN = mkTerm "hoyland_nether_PN" ;
lin hp_N = mkTerm "hp_N" ;
lin hq_PN = mkTerm "hq_PN" ;
lin hrh_PN = mkTerm "hrh_PN" ;
lin hryvnia_N = mkTerm "hryvnia_N" ;
lin huarache_N = mkTerm "huarache_N" ;
lin hub_N = mkTerm "hub_N" ;
lin hubble_bubble_N = mkTerm "hubble_bubble_N" ;
lin hubbub_N = mkTerm "hubbub_N" ;
lin hubby_N = mkTerm "hubby_N" ;
lin hubcap_N = mkTerm "hubcap_N" ;
lin hubert_PN = mkTerm "hubert_PN" ;
lin hubris_N = mkTerm "hubris_N" ;
lin huck_N = mkTerm "huck_N" ;
lin huckaback_N = mkTerm "huckaback_N" ;
lin huckleberry_N = mkTerm "huckleberry_N" ;
lin hucknall_PN = mkTerm "hucknall_PN" ;
lin huckster_N = mkTerm "huckster_N" ;
lin huddersfield_PN = mkTerm "huddersfield_PN" ;
lin huddle_N = mkTerm "huddle_N" ;
lin huddle_V = mkTerm "huddle_V" ;
lin huddle_V2 = mkTerm "huddle_V2" ;
lin huddler_N = mkTerm "huddler_N" ;
lin hudud_N = mkTerm "hudud_N" ;
lin hue_N = mkTerm "hue_N" ;
lin hued_A = mkTerm "hued_A" ;
lin hueless_A = mkTerm "hueless_A" ;
lin huff_N = mkTerm "huff_N" ;
lin huff_V = mkTerm "huff_V" ;
lin huffiness_N = mkTerm "huffiness_N" ;
lin huffish_A = mkTerm "huffish_A" ;
lin huffy_A = mkTerm "huffy_A" ;
lin hug_N = mkTerm "hug_N" ;
lin hug_V2 = mkTerm "hug_V2" ;
lin huge_A = mkTerm "huge_A" ;
lin hugely_Adv = mkTerm "hugely_Adv" ;
lin hugger_N = mkTerm "hugger_N" ;
lin hugger_mugger_A = mkTerm "hugger_mugger_A" ;
lin hugger_mugger_Adv = mkTerm "hugger_mugger_Adv" ;
lin hugger_mugger_N = mkTerm "hugger_mugger_N" ;
lin hugh_PN = mkTerm "hugh_PN" ;
lin hughie_PN = mkTerm "hughie_PN" ;
lin huguenot_N = mkTerm "huguenot_N" ;
lin huhehot_PN = mkTerm "huhehot_PN" ;
lin huisache_N = mkTerm "huisache_N" ;
lin huitre_N = mkTerm "huitre_N" ;
lin huittinen_PN = mkTerm "huittinen_PN" ;
lin hula_N = mkTerm "hula_N" ;
lin hulk_N = mkTerm "hulk_N" ;
lin hulking_A = mkTerm "hulking_A" ;
lin hull_N = mkTerm "hull_N" ;
lin hull_V2 = mkTerm "hull_V2" ;
lin hullabaloo_N = mkTerm "hullabaloo_N" ;
lin hum_N = mkTerm "hum_N" ;
lin hum_V = mkTerm "hum_V" ;
lin hum_V2 = mkTerm "hum_V2" ;
lin human_A = mkTerm "human_A" ;
lin human_N = mkTerm "human_N" ;
lin humane_A = mkTerm "humane_A" ;
lin humaneness_N = mkTerm "humaneness_N" ;
lin humanism_N = mkTerm "humanism_N" ;
lin humanist_A = mkTerm "humanist_A" ;
lin humanist_N = mkTerm "humanist_N" ;
lin humanistic_A = mkTerm "humanistic_A" ;
lin humanitarian_A = mkTerm "humanitarian_A" ;
lin humanitarian_N = mkTerm "humanitarian_N" ;
lin humanitarianism_N = mkTerm "humanitarianism_N" ;
lin humanities_N = mkTerm "humanities_N" ;
lin humanity_N = mkTerm "humanity_N" ;
lin humanization_N = mkTerm "humanization_N" ;
lin humanize_V = mkTerm "humanize_V" ;
lin humanize_V2 = mkTerm "humanize_V2" ;
lin humankind_N = mkTerm "humankind_N" ;
lin humanness_N = mkTerm "humanness_N" ;
lin humanoid_A = mkTerm "humanoid_A" ;
lin humate_N = mkTerm "humate_N" ;
lin humberside_PN = mkTerm "humberside_PN" ;
lin humberston_PN = mkTerm "humberston_PN" ;
lin humble_A = mkTerm "humble_A" ;
lin humble_V2 = mkTerm "humble_V2" ;
lin humbleness_N = mkTerm "humbleness_N" ;
lin humbug_N = mkTerm "humbug_N" ;
lin humbug_V2 = mkTerm "humbug_V2" ;
lin humdinger_N = mkTerm "humdinger_N" ;
lin humdrum_A = mkTerm "humdrum_A" ;
lin humectant_N = mkTerm "humectant_N" ;
lin humerus_N = mkTerm "humerus_N" ;
lin humic_A = mkTerm "humic_A" ;
lin humid_A = mkTerm "humid_A" ;
lin humidify_V2 = mkTerm "humidify_V2" ;
lin humidity_N = mkTerm "humidity_N" ;
lin humification_N = mkTerm "humification_N" ;
lin humified_A = mkTerm "humified_A" ;
lin humiliate_V2 = mkTerm "humiliate_V2" ;
lin humiliatingly_Adv = mkTerm "humiliatingly_Adv" ;
lin humiliation_N = mkTerm "humiliation_N" ;
lin humility_N = mkTerm "humility_N" ;
lin humin_N = mkTerm "humin_N" ;
lin hummer_N = mkTerm "hummer_N" ;
lin humming_N = mkTerm "humming_N" ;
lin humming_top_N = mkTerm "humming_top_N" ;
lin hummingbird_N = mkTerm "hummingbird_N" ;
lin hummock_N = mkTerm "hummock_N" ;
lin hummus_N = mkTerm "hummus_N" ;
lin humongous_A = mkTerm "humongous_A" ;
lin humor_N = mkTerm "humor_N" ;
lin humoral_A = mkTerm "humoral_A" ;
lin humorist_N = mkTerm "humorist_N" ;
lin humorless_A = mkTerm "humorless_A" ;
lin humorous_A = mkTerm "humorous_A" ;
lin humour_N = mkTerm "humour_N" ;
lin humour_V2 = mkTerm "humour_V2" ;
lin humourist_N = mkTerm "humourist_N" ;
lin humourless_A = mkTerm "humourless_A" ;
lin hump_N = mkTerm "hump_N" ;
lin hump_V2 = mkTerm "hump_V2" ;
lin humpback_N = mkTerm "humpback_N" ;
lin humpbacked_A = mkTerm "humpbacked_A" ;
lin humphrey_PN = mkTerm "humphrey_PN" ;
lin humppila_PN = mkTerm "humppila_PN" ;
lin humus_N = mkTerm "humus_N" ;
lin hun_N = mkTerm "hun_N" ;
lin hunch_N = mkTerm "hunch_N" ;
lin hunch_V2 = mkTerm "hunch_V2" ;
lin hunchback_A = mkTerm "hunchback_A" ;
lin hunchback_N = mkTerm "hunchback_N" ;
lin hunchbacked_A = mkTerm "hunchbacked_A" ;
lin hundredfold_Adv = mkTerm "hundredfold_Adv" ;
lin hundredweight_N = mkTerm "hundredweight_N" ;
lin hung_on_V = mkTerm "hung_on_V" ;
lin hung_out_V = mkTerm "hung_out_V" ;
lin hungarian_A = mkTerm "hungarian_A" ;
lin hungarian_N = mkTerm "hungarian_N" ;
lin hungary_PN = mkTerm "hungary_PN" ;
lin hunger_N = mkTerm "hunger_N" ;
lin hunger_V = mkTerm "hunger_V" ;
lin hunger_march_N = mkTerm "hunger_march_N" ;
lin hunger_marcher_N = mkTerm "hunger_marcher_N" ;
lin hungry_A = mkTerm "hungry_A" ;
lin hunk_N = mkTerm "hunk_N" ;
lin hunker_down_V = mkTerm "hunker_down_V" ;
lin hunt_N = mkTerm "hunt_N" ;
lin hunt_V = mkTerm "hunt_V" ;
lin hunt_V2 = mkTerm "hunt_V2" ;
lin hunt_down_V2 = mkTerm "hunt_down_V2" ;
lin hunt_out_V2 = mkTerm "hunt_out_V2" ;
lin hunt_up_V2 = mkTerm "hunt_up_V2" ;
lin hunter_N = mkTerm "hunter_N" ;
lin hunting_N = mkTerm "hunting_N" ;
lin hunting_crop_N = mkTerm "hunting_crop_N" ;
lin huntingdon_PN = mkTerm "huntingdon_PN" ;
lin huntress_N = mkTerm "huntress_N" ;
lin huntsman_N = mkTerm "huntsman_N" ;
lin hurdle_N = mkTerm "hurdle_N" ;
lin hurdle_V = mkTerm "hurdle_V" ;
lin hurdle_V2 = mkTerm "hurdle_V2" ;
lin hurdler_N = mkTerm "hurdler_N" ;
lin hurdles_N = mkTerm "hurdles_N" ;
lin hurdy_gurdy_N = mkTerm "hurdy_gurdy_N" ;
lin hurl_N = mkTerm "hurl_N" ;
lin hurl_V2 = mkTerm "hurl_V2" ;
lin hurling_N = mkTerm "hurling_N" ;
lin hurly_burly_N = mkTerm "hurly_burly_N" ;
lin hurrah_N = mkTerm "hurrah_N" ;
lin hurrah_V = mkTerm "hurrah_V" ;
lin hurricane_N = mkTerm "hurricane_N" ;
lin hurried_A = mkTerm "hurried_A" ;
lin hurry_N = mkTerm "hurry_N" ;
lin hurry_V = mkTerm "hurry_V" ;
lin hurstpierpoint_PN = mkTerm "hurstpierpoint_PN" ;
lin hurt_N = mkTerm "hurt_N" ;
lin hurt_V = mkTerm "hurt_V" ;
lin hurt_V2 = mkTerm "hurt_V2" ;
lin hurtful_A = mkTerm "hurtful_A" ;
lin hurtle_V = mkTerm "hurtle_V" ;
lin husband_N = mkTerm "husband_N" ;
lin husband_V2 = mkTerm "husband_V2" ;
lin husbandly_A = mkTerm "husbandly_A" ;
lin husbandman_N = mkTerm "husbandman_N" ;
lin husbandry_N = mkTerm "husbandry_N" ;
lin hush_N = mkTerm "hush_N" ;
lin hush_V = mkTerm "hush_V" ;
lin hush_V2 = mkTerm "hush_V2" ;
lin hush_hush_A = mkTerm "hush_hush_A" ;
lin hush_money_N = mkTerm "hush_money_N" ;
lin hush_up_V2 = mkTerm "hush_up_V2" ;
lin husk_N = mkTerm "husk_N" ;
lin husk_V2 = mkTerm "husk_V2" ;
lin huskiness_N = mkTerm "huskiness_N" ;
lin husky_A = mkTerm "husky_A" ;
lin husky_N = mkTerm "husky_N" ;
lin hussar_N = mkTerm "hussar_N" ;
lin hussy_N = mkTerm "hussy_N" ;
lin hustings_N = mkTerm "hustings_N" ;
lin hustle_N = mkTerm "hustle_N" ;
lin hustle_V = mkTerm "hustle_V" ;
lin hustle_V2 = mkTerm "hustle_V2" ;
lin hustler_N = mkTerm "hustler_N" ;
lin hut_N = mkTerm "hut_N" ;
lin hutch_N = mkTerm "hutch_N" ;
lin hutment_N = mkTerm "hutment_N" ;
lin hutted_A = mkTerm "hutted_A" ;
lin hwainan_PN = mkTerm "hwainan_PN" ;
lin hyacinth_N = mkTerm "hyacinth_N" ;
lin hyaena_N = mkTerm "hyaena_N" ;
lin hyaline_A = mkTerm "hyaline_A" ;
lin hyaline_N = mkTerm "hyaline_N" ;
lin hyalinization_N = mkTerm "hyalinization_N" ;
lin hyaloplasm_N = mkTerm "hyaloplasm_N" ;
lin hyaloplasmic_A = mkTerm "hyaloplasmic_A" ;
lin hyaluronidase_N = mkTerm "hyaluronidase_N" ;
lin hybrid_A = mkTerm "hybrid_A" ;
lin hybrid_N = mkTerm "hybrid_N" ;
lin hybridization_N = mkTerm "hybridization_N" ;
lin hybridize_V = mkTerm "hybridize_V" ;
lin hybridize_V2 = mkTerm "hybridize_V2" ;
lin hybridoma_N = mkTerm "hybridoma_N" ;
lin hydantoin_N = mkTerm "hydantoin_N" ;
lin hydathode_N = mkTerm "hydathode_N" ;
lin hydatid_N = mkTerm "hydatid_N" ;
lin hyde_PN = mkTerm "hyde_PN" ;
lin hyderabad_PN = mkTerm "hyderabad_PN" ;
lin hydra_N = mkTerm "hydra_N" ;
lin hydralazine_N = mkTerm "hydralazine_N" ;
lin hydramnios_N = mkTerm "hydramnios_N" ;
lin hydrangea_N = mkTerm "hydrangea_N" ;
lin hydrant_N = mkTerm "hydrant_N" ;
lin hydrarthrosis_N = mkTerm "hydrarthrosis_N" ;
lin hydrate_N = mkTerm "hydrate_N" ;
lin hydrate_V = mkTerm "hydrate_V" ;
lin hydrate_V2 = mkTerm "hydrate_V2" ;
lin hydration_N = mkTerm "hydration_N" ;
lin hydraulic_A = mkTerm "hydraulic_A" ;
lin hydraulics_N = mkTerm "hydraulics_N" ;
lin hydrazine_N = mkTerm "hydrazine_N" ;
lin hydrazoite_N = mkTerm "hydrazoite_N" ;
lin hydremia_N = mkTerm "hydremia_N" ;
lin hydric_A = mkTerm "hydric_A" ;
lin hydride_N = mkTerm "hydride_N" ;
lin hydrilla_N = mkTerm "hydrilla_N" ;
lin hydrocarbon_N = mkTerm "hydrocarbon_N" ;
lin hydrocele_N = mkTerm "hydrocele_N" ;
lin hydrocephalic_A = mkTerm "hydrocephalic_A" ;
lin hydrocephalus_N = mkTerm "hydrocephalus_N" ;
lin hydrochloric_A = mkTerm "hydrochloric_A" ;
lin hydrochloride_N = mkTerm "hydrochloride_N" ;
lin hydrochlorofluorocarbon_N = mkTerm "hydrochlorofluorocarbon_N" ;
lin hydrochlorothiazide_N = mkTerm "hydrochlorothiazide_N" ;
lin hydrocolloid_N = mkTerm "hydrocolloid_N" ;
lin hydrocortisone_N = mkTerm "hydrocortisone_N" ;
lin hydrocracking_N = mkTerm "hydrocracking_N" ;
lin hydrodynamic_A = mkTerm "hydrodynamic_A" ;
lin hydrodynamics_N = mkTerm "hydrodynamics_N" ;
lin hydroelectric_A = mkTerm "hydroelectric_A" ;
lin hydroelectricity_N = mkTerm "hydroelectricity_N" ;
lin hydroflumethiazide_N = mkTerm "hydroflumethiazide_N" ;
lin hydrofluorocarbon_N = mkTerm "hydrofluorocarbon_N" ;
lin hydrofoil_N = mkTerm "hydrofoil_N" ;
lin hydrogel_N = mkTerm "hydrogel_N" ;
lin hydrogen_N = mkTerm "hydrogen_N" ;
lin hydrogenation_N = mkTerm "hydrogenation_N" ;
lin hydrographic_A = mkTerm "hydrographic_A" ;
lin hydrography_N = mkTerm "hydrography_N" ;
lin hydrokinetic_A = mkTerm "hydrokinetic_A" ;
lin hydrologist_N = mkTerm "hydrologist_N" ;
lin hydrology_N = mkTerm "hydrology_N" ;
lin hydrolysate_N = mkTerm "hydrolysate_N" ;
lin hydrolysis_N = mkTerm "hydrolysis_N" ;
lin hydrolyzable_A = mkTerm "hydrolyzable_A" ;
lin hydromancer_N = mkTerm "hydromancer_N" ;
lin hydromancy_N = mkTerm "hydromancy_N" ;
lin hydromel_N = mkTerm "hydromel_N" ;
lin hydrometer_N = mkTerm "hydrometer_N" ;
lin hydrometric_A = mkTerm "hydrometric_A" ;
lin hydrometry_N = mkTerm "hydrometry_N" ;
lin hydronephrosis_N = mkTerm "hydronephrosis_N" ;
lin hydropathic_A = mkTerm "hydropathic_A" ;
lin hydropathy_N = mkTerm "hydropathy_N" ;
lin hydrophilic_A = mkTerm "hydrophilic_A" ;
lin hydrophobia_N = mkTerm "hydrophobia_N" ;
lin hydrophobic_A = mkTerm "hydrophobic_A" ;
lin hydrophobicity_N = mkTerm "hydrophobicity_N" ;
lin hydrophytic_A = mkTerm "hydrophytic_A" ;
lin hydroplane_N = mkTerm "hydroplane_N" ;
lin hydroponics_N = mkTerm "hydroponics_N" ;
lin hydrosphere_N = mkTerm "hydrosphere_N" ;
lin hydrostatic_A = mkTerm "hydrostatic_A" ;
lin hydrostatics_N = mkTerm "hydrostatics_N" ;
lin hydrothorax_N = mkTerm "hydrothorax_N" ;
lin hydrous_A = mkTerm "hydrous_A" ;
lin hydroxide_N = mkTerm "hydroxide_N" ;
lin hydroxy_A = mkTerm "hydroxy_A" ;
lin hydroxychloroquine_N = mkTerm "hydroxychloroquine_N" ;
lin hydroxyl_N = mkTerm "hydroxyl_N" ;
lin hydroxymethyl_N = mkTerm "hydroxymethyl_N" ;
lin hydroxyproline_N = mkTerm "hydroxyproline_N" ;
lin hydrozoan_N = mkTerm "hydrozoan_N" ;
lin hyena_N = mkTerm "hyena_N" ;
lin hygiene_N = mkTerm "hygiene_N" ;
lin hygienic_A = mkTerm "hygienic_A" ;
lin hygienist_N = mkTerm "hygienist_N" ;
lin hygrodeik_N = mkTerm "hygrodeik_N" ;
lin hygrometer_N = mkTerm "hygrometer_N" ;
lin hygrophyte_N = mkTerm "hygrophyte_N" ;
lin hygrophytic_A = mkTerm "hygrophytic_A" ;
lin hygroscope_N = mkTerm "hygroscope_N" ;
lin hygroscopic_A = mkTerm "hygroscopic_A" ;
lin hymen_N = mkTerm "hymen_N" ;
lin hymenal_A = mkTerm "hymenal_A" ;
lin hymeneal_A = mkTerm "hymeneal_A" ;
lin hymeneal_N = mkTerm "hymeneal_N" ;
lin hymenium_N = mkTerm "hymenium_N" ;
lin hymenopterous_A = mkTerm "hymenopterous_A" ;
lin hymn_N = mkTerm "hymn_N" ;
lin hymn_V2 = mkTerm "hymn_V2" ;
lin hymnal_N = mkTerm "hymnal_N" ;
lin hyoid_A = mkTerm "hyoid_A" ;
lin hyoid_N = mkTerm "hyoid_N" ;
lin hyoscyamine_N = mkTerm "hyoscyamine_N" ;
lin hypaethral_A = mkTerm "hypaethral_A" ;
lin hypallage_N = mkTerm "hypallage_N" ;
lin hypanthium_N = mkTerm "hypanthium_N" ;
lin hype_V2 = mkTerm "hype_V2" ;
lin hyperacidity_N = mkTerm "hyperacidity_N" ;
lin hyperactive_A = mkTerm "hyperactive_A" ;
lin hyperactivity_N = mkTerm "hyperactivity_N" ;
lin hyperacusis_N = mkTerm "hyperacusis_N" ;
lin hyperbaton_N = mkTerm "hyperbaton_N" ;
lin hyperbetalipoproteinemia_N = mkTerm "hyperbetalipoproteinemia_N" ;
lin hyperbilirubinemia_N = mkTerm "hyperbilirubinemia_N" ;
lin hyperbola_N = mkTerm "hyperbola_N" ;
lin hyperbole_N = mkTerm "hyperbole_N" ;
lin hyperbolic_A = mkTerm "hyperbolic_A" ;
lin hyperboloid_N = mkTerm "hyperboloid_N" ;
lin hyperboloidal_A = mkTerm "hyperboloidal_A" ;
lin hypercalcemia_N = mkTerm "hypercalcemia_N" ;
lin hypercalciuria_N = mkTerm "hypercalciuria_N" ;
lin hypercapnia_N = mkTerm "hypercapnia_N" ;
lin hypercatalectic_A = mkTerm "hypercatalectic_A" ;
lin hypercatalectic_N = mkTerm "hypercatalectic_N" ;
lin hypercellularity_N = mkTerm "hypercellularity_N" ;
lin hypercholesterolemia_N = mkTerm "hypercholesterolemia_N" ;
lin hypercoaster_N = mkTerm "hypercoaster_N" ;
lin hypercritical_A = mkTerm "hypercritical_A" ;
lin hyperemesis_N = mkTerm "hyperemesis_N" ;
lin hyperemia_N = mkTerm "hyperemia_N" ;
lin hyperemic_A = mkTerm "hyperemic_A" ;
lin hyperextension_N = mkTerm "hyperextension_N" ;
lin hyperfine_A = mkTerm "hyperfine_A" ;
lin hyperglycemia_N = mkTerm "hyperglycemia_N" ;
lin hyperhidrosis_N = mkTerm "hyperhidrosis_N" ;
lin hypericism_N = mkTerm "hypericism_N" ;
lin hyperinflation_N = mkTerm "hyperinflation_N" ;
lin hyperkalemia_N = mkTerm "hyperkalemia_N" ;
lin hyperlink_N = mkTerm "hyperlink_N" ;
lin hyperlipoproteinemia_N = mkTerm "hyperlipoproteinemia_N" ;
lin hypermarket_N = mkTerm "hypermarket_N" ;
lin hypermastigote_N = mkTerm "hypermastigote_N" ;
lin hypermedia_N = mkTerm "hypermedia_N" ;
lin hypermotility_N = mkTerm "hypermotility_N" ;
lin hypernatremia_N = mkTerm "hypernatremia_N" ;
lin hypernym_N = mkTerm "hypernym_N" ;
lin hypernymy_N = mkTerm "hypernymy_N" ;
lin hyperon_N = mkTerm "hyperon_N" ;
lin hyperope_N = mkTerm "hyperope_N" ;
lin hyperopia_N = mkTerm "hyperopia_N" ;
lin hyperopic_A = mkTerm "hyperopic_A" ;
lin hyperparathyroidism_N = mkTerm "hyperparathyroidism_N" ;
lin hyperpigmentation_N = mkTerm "hyperpigmentation_N" ;
lin hyperpituitarism_N = mkTerm "hyperpituitarism_N" ;
lin hyperplasia_N = mkTerm "hyperplasia_N" ;
lin hyperpnea_N = mkTerm "hyperpnea_N" ;
lin hyperpyrexia_N = mkTerm "hyperpyrexia_N" ;
lin hypersecretion_N = mkTerm "hypersecretion_N" ;
lin hypersensitive_A = mkTerm "hypersensitive_A" ;
lin hypersensitivity_N = mkTerm "hypersensitivity_N" ;
lin hypersomnia_N = mkTerm "hypersomnia_N" ;
lin hypersplenism_N = mkTerm "hypersplenism_N" ;
lin hypertension_N = mkTerm "hypertension_N" ;
lin hypertensive_A = mkTerm "hypertensive_A" ;
lin hypertensive_N = mkTerm "hypertensive_N" ;
lin hypertext_N = mkTerm "hypertext_N" ;
lin hyperthermal_A = mkTerm "hyperthermal_A" ;
lin hyperthermia_N = mkTerm "hyperthermia_N" ;
lin hyperthyroidism_N = mkTerm "hyperthyroidism_N" ;
lin hypertonia_N = mkTerm "hypertonia_N" ;
lin hypertonic_A = mkTerm "hypertonic_A" ;
lin hypertonicity_N = mkTerm "hypertonicity_N" ;
lin hypertrophied_A = mkTerm "hypertrophied_A" ;
lin hypertrophy_N = mkTerm "hypertrophy_N" ;
lin hypervelocity_N = mkTerm "hypervelocity_N" ;
lin hyperventilation_N = mkTerm "hyperventilation_N" ;
lin hypervitaminosis_N = mkTerm "hypervitaminosis_N" ;
lin hypervolemia_N = mkTerm "hypervolemia_N" ;
lin hypha_N = mkTerm "hypha_N" ;
lin hyphema_N = mkTerm "hyphema_N" ;
lin hyphen_N = mkTerm "hyphen_N" ;
lin hyphen_V2 = mkTerm "hyphen_V2" ;
lin hyphenate_V2 = mkTerm "hyphenate_V2" ;
lin hyphenation_N = mkTerm "hyphenation_N" ;
lin hypnagogue_N = mkTerm "hypnagogue_N" ;
lin hypnoanalysis_N = mkTerm "hypnoanalysis_N" ;
lin hypnogenesis_N = mkTerm "hypnogenesis_N" ;
lin hypnoid_A = mkTerm "hypnoid_A" ;
lin hypnophobia_N = mkTerm "hypnophobia_N" ;
lin hypnosis_N = mkTerm "hypnosis_N" ;
lin hypnotherapy_N = mkTerm "hypnotherapy_N" ;
lin hypnotic_A = mkTerm "hypnotic_A" ;
lin hypnotism_N = mkTerm "hypnotism_N" ;
lin hypnotist_N = mkTerm "hypnotist_N" ;
lin hypnotize_V2 = mkTerm "hypnotize_V2" ;
lin hypo_N = mkTerm "hypo_N" ;
lin hypoactive_A = mkTerm "hypoactive_A" ;
lin hypobasidium_N = mkTerm "hypobasidium_N" ;
lin hypobetalipoproteinemia_N = mkTerm "hypobetalipoproteinemia_N" ;
lin hypocalcemia_N = mkTerm "hypocalcemia_N" ;
lin hypocapnia_N = mkTerm "hypocapnia_N" ;
lin hypocellularity_N = mkTerm "hypocellularity_N" ;
lin hypochlorite_N = mkTerm "hypochlorite_N" ;
lin hypochondria_N = mkTerm "hypochondria_N" ;
lin hypochondriac_A = mkTerm "hypochondriac_A" ;
lin hypochondriac_N = mkTerm "hypochondriac_N" ;
lin hypochondriacal_A = mkTerm "hypochondriacal_A" ;
lin hypochondrium_N = mkTerm "hypochondrium_N" ;
lin hypocrisy_N = mkTerm "hypocrisy_N" ;
lin hypocrite_N = mkTerm "hypocrite_N" ;
lin hypocritical_A = mkTerm "hypocritical_A" ;
lin hypocycloid_N = mkTerm "hypocycloid_N" ;
lin hypodermal_A = mkTerm "hypodermal_A" ;
lin hypodermic_A = mkTerm "hypodermic_A" ;
lin hypodermic_N = mkTerm "hypodermic_N" ;
lin hypodermis_N = mkTerm "hypodermis_N" ;
lin hypoesthesia_N = mkTerm "hypoesthesia_N" ;
lin hypogammaglobulinemia_N = mkTerm "hypogammaglobulinemia_N" ;
lin hypoglossal_N = mkTerm "hypoglossal_N" ;
lin hypoglycemia_N = mkTerm "hypoglycemia_N" ;
lin hypoglycemic_A = mkTerm "hypoglycemic_A" ;
lin hypogonadism_N = mkTerm "hypogonadism_N" ;
lin hypokalemia_N = mkTerm "hypokalemia_N" ;
lin hypolipoproteinemia_N = mkTerm "hypolipoproteinemia_N" ;
lin hyponatremia_N = mkTerm "hyponatremia_N" ;
lin hyponym_N = mkTerm "hyponym_N" ;
lin hyponymy_N = mkTerm "hyponymy_N" ;
lin hypoparathyroidism_N = mkTerm "hypoparathyroidism_N" ;
lin hypophyseal_A = mkTerm "hypophyseal_A" ;
lin hypophysectomized_A = mkTerm "hypophysectomized_A" ;
lin hypophysectomy_N = mkTerm "hypophysectomy_N" ;
lin hypopigmentation_N = mkTerm "hypopigmentation_N" ;
lin hypoplasia_N = mkTerm "hypoplasia_N" ;
lin hypopnea_N = mkTerm "hypopnea_N" ;
lin hypoproteinemia_N = mkTerm "hypoproteinemia_N" ;
lin hyposmia_N = mkTerm "hyposmia_N" ;
lin hypospadias_N = mkTerm "hypospadias_N" ;
lin hypostasis_N = mkTerm "hypostasis_N" ;
lin hypostatization_N = mkTerm "hypostatization_N" ;
lin hypotension_N = mkTerm "hypotension_N" ;
lin hypotensive_A = mkTerm "hypotensive_A" ;
lin hypotensive_N = mkTerm "hypotensive_N" ;
lin hypotenuse_N = mkTerm "hypotenuse_N" ;
lin hypothalamic_A = mkTerm "hypothalamic_A" ;
lin hypothalamus_N = mkTerm "hypothalamus_N" ;
lin hypothecate_V2 = mkTerm "hypothecate_V2" ;
lin hypothermia_N = mkTerm "hypothermia_N" ;
lin hypothermic_A = mkTerm "hypothermic_A" ;
lin hypothesis_N = mkTerm "hypothesis_N" ;
lin hypothesize_V2 = mkTerm "hypothesize_V2" ;
lin hypothetical_A = mkTerm "hypothetical_A" ;
lin hypothetical_N = mkTerm "hypothetical_N" ;
lin hypothrombinemia_N = mkTerm "hypothrombinemia_N" ;
lin hypothyroidism_N = mkTerm "hypothyroidism_N" ;
lin hypotonia_N = mkTerm "hypotonia_N" ;
lin hypotonic_A = mkTerm "hypotonic_A" ;
lin hypotonicity_N = mkTerm "hypotonicity_N" ;
lin hypovolemia_N = mkTerm "hypovolemia_N" ;
lin hypovolemic_A = mkTerm "hypovolemic_A" ;
lin hypoxia_N = mkTerm "hypoxia_N" ;
lin hypozeugma_N = mkTerm "hypozeugma_N" ;
lin hypozeuxis_N = mkTerm "hypozeuxis_N" ;
lin hypsography_N = mkTerm "hypsography_N" ;
lin hypsometer_N = mkTerm "hypsometer_N" ;
lin hypsometry_N = mkTerm "hypsometry_N" ;
lin hyrax_N = mkTerm "hyrax_N" ;
lin hyrynsalmi_PN = mkTerm "hyrynsalmi_PN" ;
lin hyson_N = mkTerm "hyson_N" ;
lin hyssop_N = mkTerm "hyssop_N" ;
lin hysterectomy_N = mkTerm "hysterectomy_N" ;
lin hysteresis_N = mkTerm "hysteresis_N" ;
lin hysteria_N = mkTerm "hysteria_N" ;
lin hysteric_A = mkTerm "hysteric_A" ;
lin hysteric_N = mkTerm "hysteric_N" ;
lin hysterical_A = mkTerm "hysterical_A" ;
lin hysterics_N = mkTerm "hysterics_N" ;
lin hysterocatalepsy_N = mkTerm "hysterocatalepsy_N" ;
lin hysterosalpingogram_N = mkTerm "hysterosalpingogram_N" ;
lin hysteroscopy_N = mkTerm "hysteroscopy_N" ;
lin hysterotomy_N = mkTerm "hysterotomy_N" ;
lin hythe_PN = mkTerm "hythe_PN" ;
lin hyvinge_PN = mkTerm "hyvinge_PN" ;
lin hämeenkoski_PN = mkTerm "hämeenkoski_PN" ;
lin hämeenkyrö_PN = mkTerm "hämeenkyrö_PN" ;
lin hämeenlinna_PN = mkTerm "hämeenlinna_PN" ;
lin iFem_Pron = mkTerm "iFem_Pron" ;
lin i_e__Adv = mkTerm "i_e__Adv" ;
lin iamb_N = mkTerm "iamb_N" ;
lin iambic_A = mkTerm "iambic_A" ;
lin iambic_N = mkTerm "iambic_N" ;
lin iambics_N = mkTerm "iambics_N" ;
lin iambus_N = mkTerm "iambus_N" ;
lin ian_PN = mkTerm "ian_PN" ;
lin iatrogenic_A = mkTerm "iatrogenic_A" ;
lin iba_N = mkTerm "iba_N" ;
lin ibadan_PN = mkTerm "ibadan_PN" ;
lin ibex_N = mkTerm "ibex_N" ;
lin ibid_PN = mkTerm "ibid_PN" ;
lin ibid__Adv = mkTerm "ibid__Adv" ;
lin ibidem_Adv = mkTerm "ibidem_Adv" ;
lin ibis_N = mkTerm "ibis_N" ;
lin ibuprofen_N = mkTerm "ibuprofen_N" ;
lin icbm_N = mkTerm "icbm_N" ;
lin ice_N = mkTerm "ice_N" ;
lin ice_V = mkTerm "ice_V" ;
lin ice_V2 = mkTerm "ice_V2" ;
lin ice_axe_N = mkTerm "ice_axe_N" ;
lin ice_cream_N = mkTerm "ice_cream_N" ;
lin ice_lolly_N = mkTerm "ice_lolly_N" ;
lin ice_show_N = mkTerm "ice_show_N" ;
lin ice_skate_N = mkTerm "ice_skate_N" ;
lin ice_skate_V = mkTerm "ice_skate_V" ;
lin ice_skating_N = mkTerm "ice_skating_N" ;
lin ice_tray_N = mkTerm "ice_tray_N" ;
lin iceberg_N = mkTerm "iceberg_N" ;
lin iceboat_N = mkTerm "iceboat_N" ;
lin icebound_A = mkTerm "icebound_A" ;
lin icebox_N = mkTerm "icebox_N" ;
lin icebreaker_N = mkTerm "icebreaker_N" ;
lin icecap_N = mkTerm "icecap_N" ;
lin icecube_N = mkTerm "icecube_N" ;
lin icefall_N = mkTerm "icefall_N" ;
lin icefield_N = mkTerm "icefield_N" ;
lin icefloe_N = mkTerm "icefloe_N" ;
lin icefree_A = mkTerm "icefree_A" ;
lin icehouse_N = mkTerm "icehouse_N" ;
lin iceland_PN = mkTerm "iceland_PN" ;
lin icelander_A = mkTerm "icelander_A" ;
lin icelander_N = mkTerm "icelander_N" ;
lin icelandic_A = mkTerm "icelandic_A" ;
lin icelandic_N = mkTerm "icelandic_N" ;
lin iceman_N = mkTerm "iceman_N" ;
lin icepack_N = mkTerm "icepack_N" ;
lin icepick_N = mkTerm "icepick_N" ;
lin icerink_N = mkTerm "icerink_N" ;
lin ichneumon_N = mkTerm "ichneumon_N" ;
lin ichneumon_fly_N = mkTerm "ichneumon_fly_N" ;
lin ichor_N = mkTerm "ichor_N" ;
lin ichorous_A = mkTerm "ichorous_A" ;
lin ichthyolatry_N = mkTerm "ichthyolatry_N" ;
lin ichthyologist_N = mkTerm "ichthyologist_N" ;
lin ichthyology_N = mkTerm "ichthyology_N" ;
lin ichthyosaur_N = mkTerm "ichthyosaur_N" ;
lin ichthyosaurus_N = mkTerm "ichthyosaurus_N" ;
lin ichthyosis_N = mkTerm "ichthyosis_N" ;
lin icicle_N = mkTerm "icicle_N" ;
lin icing_N = mkTerm "icing_N" ;
lin icky_A = mkTerm "icky_A" ;
lin icon_N = mkTerm "icon_N" ;
lin iconic_A = mkTerm "iconic_A" ;
lin iconoclasm_N = mkTerm "iconoclasm_N" ;
lin iconoclast_N = mkTerm "iconoclast_N" ;
lin iconoclastic_A = mkTerm "iconoclastic_A" ;
lin iconography_N = mkTerm "iconography_N" ;
lin iconolatry_N = mkTerm "iconolatry_N" ;
lin iconology_N = mkTerm "iconology_N" ;
lin iconoscope_N = mkTerm "iconoscope_N" ;
lin icosahedral_A = mkTerm "icosahedral_A" ;
lin icosahedron_N = mkTerm "icosahedron_N" ;
lin ictal_A = mkTerm "ictal_A" ;
lin icterogenic_A = mkTerm "icterogenic_A" ;
lin ictodosaur_N = mkTerm "ictodosaur_N" ;
lin icy_A = mkTerm "icy_A" ;
lin id_N = mkTerm "id_N" ;
lin ida_PN = mkTerm "ida_PN" ;
lin idaho_PN = mkTerm "idaho_PN" ;
lin idea_N = mkTerm "idea_N" ;
lin idea_of_N2 = mkTerm "idea_of_N2" ;
lin ideal_A = mkTerm "ideal_A" ;
lin ideal_N = mkTerm "ideal_N" ;
lin idealism_N = mkTerm "idealism_N" ;
lin idealist_N = mkTerm "idealist_N" ;
lin idealistic_A = mkTerm "idealistic_A" ;
lin ideality_N = mkTerm "ideality_N" ;
lin idealization_N = mkTerm "idealization_N" ;
lin idealize_V2 = mkTerm "idealize_V2" ;
lin ideally_Adv = mkTerm "ideally_Adv" ;
lin ideation_N = mkTerm "ideation_N" ;
lin idem_PN = mkTerm "idem_PN" ;
lin idempotent_A = mkTerm "idempotent_A" ;
lin identical_A = mkTerm "identical_A" ;
lin identifiable_A = mkTerm "identifiable_A" ;
lin identification_N = mkTerm "identification_N" ;
lin identifier_N = mkTerm "identifier_N" ;
lin identify_V = mkTerm "identify_V" ;
lin identify_V2 = mkTerm "identify_V2" ;
lin identikit_N = mkTerm "identikit_N" ;
lin identity_N = mkTerm "identity_N" ;
lin ideogram_N = mkTerm "ideogram_N" ;
lin ideograph_N = mkTerm "ideograph_N" ;
lin ideographic_A = mkTerm "ideographic_A" ;
lin ideography_N = mkTerm "ideography_N" ;
lin ideological_A = mkTerm "ideological_A" ;
lin ideologist_N = mkTerm "ideologist_N" ;
lin ideology_N = mkTerm "ideology_N" ;
lin ides_N = mkTerm "ides_N" ;
lin idesia_N = mkTerm "idesia_N" ;
lin idiocy_N = mkTerm "idiocy_N" ;
lin idiographic_A = mkTerm "idiographic_A" ;
lin idiolatry_N = mkTerm "idiolatry_N" ;
lin idiolect_N = mkTerm "idiolect_N" ;
lin idiom_N = mkTerm "idiom_N" ;
lin idiomatic_A = mkTerm "idiomatic_A" ;
lin idiopathic_A = mkTerm "idiopathic_A" ;
lin idiosyncrasy_N = mkTerm "idiosyncrasy_N" ;
lin idiosyncratic_A = mkTerm "idiosyncratic_A" ;
lin idiot_N = mkTerm "idiot_N" ;
lin idiotic_A = mkTerm "idiotic_A" ;
lin idle_A = mkTerm "idle_A" ;
lin idle_N = mkTerm "idle_N" ;
lin idle_V = mkTerm "idle_V" ;
lin idle_V2 = mkTerm "idle_V2" ;
lin idleness_N = mkTerm "idleness_N" ;
lin idler_N = mkTerm "idler_N" ;
lin idol_N = mkTerm "idol_N" ;
lin idolater_N = mkTerm "idolater_N" ;
lin idolatress_N = mkTerm "idolatress_N" ;
lin idolatrous_A = mkTerm "idolatrous_A" ;
lin idolatry_N = mkTerm "idolatry_N" ;
lin idolization_N = mkTerm "idolization_N" ;
lin idolize_V2 = mkTerm "idolize_V2" ;
lin idolizer_N = mkTerm "idolizer_N" ;
lin idyll_N = mkTerm "idyll_N" ;
lin idyllic_A = mkTerm "idyllic_A" ;
lin ie_PN = mkTerm "ie_PN" ;
lin igloo_N = mkTerm "igloo_N" ;
lin igneous_A = mkTerm "igneous_A" ;
lin ignescent_A = mkTerm "ignescent_A" ;
lin ignis_fatuus_N = mkTerm "ignis_fatuus_N" ;
lin ignite_V = mkTerm "ignite_V" ;
lin ignite_V2 = mkTerm "ignite_V2" ;
lin igniter_N = mkTerm "igniter_N" ;
lin ignition_N = mkTerm "ignition_N" ;
lin ignoble_A = mkTerm "ignoble_A" ;
lin ignobleness_N = mkTerm "ignobleness_N" ;
lin ignominious_A = mkTerm "ignominious_A" ;
lin ignominy_N = mkTerm "ignominy_N" ;
lin ignoramus_N = mkTerm "ignoramus_N" ;
lin ignorance_N = mkTerm "ignorance_N" ;
lin ignorant_A = mkTerm "ignorant_A" ;
lin ignorantness_N = mkTerm "ignorantness_N" ;
lin ignore_V = mkTerm "ignore_V" ;
lin ignore_V2 = mkTerm "ignore_V2" ;
lin iguana_N = mkTerm "iguana_N" ;
lin iguanid_N = mkTerm "iguanid_N" ;
lin iguanodon_N = mkTerm "iguanodon_N" ;
lin ii_PN = mkTerm "ii_PN" ;
lin iisalmi_PN = mkTerm "iisalmi_PN" ;
lin iitti_PN = mkTerm "iitti_PN" ;
lin ijtihad_N = mkTerm "ijtihad_N" ;
lin ikaalinen_PN = mkTerm "ikaalinen_PN" ;
lin ikon_N = mkTerm "ikon_N" ;
lin ilama_N = mkTerm "ilama_N" ;
lin ileitis_N = mkTerm "ileitis_N" ;
lin ileostomy_N = mkTerm "ileostomy_N" ;
lin ileum_N = mkTerm "ileum_N" ;
lin ilex_N = mkTerm "ilex_N" ;
lin ilfracombe_PN = mkTerm "ilfracombe_PN" ;
lin iliac_A = mkTerm "iliac_A" ;
lin ilium_N = mkTerm "ilium_N" ;
lin ilk_N = mkTerm "ilk_N" ;
lin ilkeston_PN = mkTerm "ilkeston_PN" ;
lin ilkley_PN = mkTerm "ilkley_PN" ;
lin ill_1_A = mkTerm "ill_1_A" ;
lin ill_2_A = mkTerm "ill_2_A" ;
lin ill_AdV = mkTerm "ill_AdV" ;
lin ill_N = mkTerm "ill_N" ;
lin ill_advised_A = mkTerm "ill_advised_A" ;
lin ill_affected_A = mkTerm "ill_affected_A" ;
lin ill_bred_A = mkTerm "ill_bred_A" ;
lin ill_breeding_N = mkTerm "ill_breeding_N" ;
lin ill_disposed_A = mkTerm "ill_disposed_A" ;
lin ill_fated_A = mkTerm "ill_fated_A" ;
lin ill_favoured_A = mkTerm "ill_favoured_A" ;
lin ill_gotten_A = mkTerm "ill_gotten_A" ;
lin ill_judged_A = mkTerm "ill_judged_A" ;
lin ill_mannered_A = mkTerm "ill_mannered_A" ;
lin ill_natured_A = mkTerm "ill_natured_A" ;
lin ill_omened_A = mkTerm "ill_omened_A" ;
lin ill_starred_A = mkTerm "ill_starred_A" ;
lin ill_timed_A = mkTerm "ill_timed_A" ;
lin ill_treat_V2 = mkTerm "ill_treat_V2" ;
lin ill_treatment_N = mkTerm "ill_treatment_N" ;
lin ill_usage_N = mkTerm "ill_usage_N" ;
lin ill_use_V2 = mkTerm "ill_use_V2" ;
lin illative_A = mkTerm "illative_A" ;
lin illegal_A = mkTerm "illegal_A" ;
lin illegal_N = mkTerm "illegal_N" ;
lin illegality_N = mkTerm "illegality_N" ;
lin illegibility_N = mkTerm "illegibility_N" ;
lin illegible_A = mkTerm "illegible_A" ;
lin illegitimacy_N = mkTerm "illegitimacy_N" ;
lin illegitimate_A = mkTerm "illegitimate_A" ;
lin illegitimate_N = mkTerm "illegitimate_N" ;
lin illiberal_A = mkTerm "illiberal_A" ;
lin illiberality_N = mkTerm "illiberality_N" ;
lin illicit_A = mkTerm "illicit_A" ;
lin illicitness_N = mkTerm "illicitness_N" ;
lin illimitable_A = mkTerm "illimitable_A" ;
lin illinois_PN = mkTerm "illinois_PN" ;
lin illiteracy_N = mkTerm "illiteracy_N" ;
lin illiterate_A = mkTerm "illiterate_A" ;
lin illiterate_N = mkTerm "illiterate_N" ;
lin illness_N = mkTerm "illness_N" ;
lin illogical_A = mkTerm "illogical_A" ;
lin illogicality_N = mkTerm "illogicality_N" ;
lin illogicalness_N = mkTerm "illogicalness_N" ;
lin illume_V2 = mkTerm "illume_V2" ;
lin illuminance_N = mkTerm "illuminance_N" ;
lin illuminant_N = mkTerm "illuminant_N" ;
lin illuminate_V2 = mkTerm "illuminate_V2" ;
lin illumination_N = mkTerm "illumination_N" ;
lin illumine_V2 = mkTerm "illumine_V2" ;
lin illusion_N = mkTerm "illusion_N" ;
lin illusional_A = mkTerm "illusional_A" ;
lin illusionist_N = mkTerm "illusionist_N" ;
lin illusive_A = mkTerm "illusive_A" ;
lin illusory_A = mkTerm "illusory_A" ;
lin illustrate_V = mkTerm "illustrate_V" ;
lin illustrate_V2 = mkTerm "illustrate_V2" ;
lin illustrate_VS = mkTerm "illustrate_VS" ;
lin illustration_N = mkTerm "illustration_N" ;
lin illustrative_A = mkTerm "illustrative_A" ;
lin illustrator_N = mkTerm "illustrator_N" ;
lin illustrious_A = mkTerm "illustrious_A" ;
lin ilmajoki_PN = mkTerm "ilmajoki_PN" ;
lin ilmenite_N = mkTerm "ilmenite_N" ;
lin ilo_N = mkTerm "ilo_N" ;
lin ilomantsi_PN = mkTerm "ilomantsi_PN" ;
lin image_N = mkTerm "image_N" ;
lin image_V2 = mkTerm "image_V2" ;
lin imagery_N = mkTerm "imagery_N" ;
lin imaginable_A = mkTerm "imaginable_A" ;
lin imaginary_A = mkTerm "imaginary_A" ;
lin imagination_N = mkTerm "imagination_N" ;
lin imaginative_A = mkTerm "imaginative_A" ;
lin imagine_V = mkTerm "imagine_V" ;
lin imagine_V2 = mkTerm "imagine_V2" ;
lin imagine_VS = mkTerm "imagine_VS" ;
lin imaging_N = mkTerm "imaging_N" ;
lin imagism_N = mkTerm "imagism_N" ;
lin imago_N = mkTerm "imago_N" ;
lin imam_N = mkTerm "imam_N" ;
lin imaret_N = mkTerm "imaret_N" ;
lin imatra_PN = mkTerm "imatra_PN" ;
lin imbalance_N = mkTerm "imbalance_N" ;
lin imbecile_A = mkTerm "imbecile_A" ;
lin imbecile_N = mkTerm "imbecile_N" ;
lin imbecility_N = mkTerm "imbecility_N" ;
lin imbed_V2 = mkTerm "imbed_V2" ;
lin imbibe_V2 = mkTerm "imbibe_V2" ;
lin imbibition_N = mkTerm "imbibition_N" ;
lin imbricate_A = mkTerm "imbricate_A" ;
lin imbrication_N = mkTerm "imbrication_N" ;
lin imbroglio_N = mkTerm "imbroglio_N" ;
lin imbue_V2 = mkTerm "imbue_V2" ;
lin imf_N = mkTerm "imf_N" ;
lin imidazole_N = mkTerm "imidazole_N" ;
lin imide_N = mkTerm "imide_N" ;
lin imipramine_N = mkTerm "imipramine_N" ;
lin imitate_V2 = mkTerm "imitate_V2" ;
lin imitation_N = mkTerm "imitation_N" ;
lin imitative_A = mkTerm "imitative_A" ;
lin imitator_N = mkTerm "imitator_N" ;
lin immaculate_A = mkTerm "immaculate_A" ;
lin immanence_N = mkTerm "immanence_N" ;
lin immanent_A = mkTerm "immanent_A" ;
lin immaterial_A = mkTerm "immaterial_A" ;
lin immateriality_N = mkTerm "immateriality_N" ;
lin immature_A = mkTerm "immature_A" ;
lin immaturity_N = mkTerm "immaturity_N" ;
lin immeasurable_A = mkTerm "immeasurable_A" ;
lin immediacy_N = mkTerm "immediacy_N" ;
lin immediate_A = mkTerm "immediate_A" ;
lin immemorial_A = mkTerm "immemorial_A" ;
lin immense_A = mkTerm "immense_A" ;
lin immensity_N = mkTerm "immensity_N" ;
lin immerse_V2 = mkTerm "immerse_V2" ;
lin immersion_N = mkTerm "immersion_N" ;
lin immigrant_N = mkTerm "immigrant_N" ;
lin immigrate_V = mkTerm "immigrate_V" ;
lin immigration_N = mkTerm "immigration_N" ;
lin imminence_N = mkTerm "imminence_N" ;
lin imminent_A = mkTerm "imminent_A" ;
lin immingham_PN = mkTerm "immingham_PN" ;
lin immiscible_A = mkTerm "immiscible_A" ;
lin immobile_A = mkTerm "immobile_A" ;
lin immobility_N = mkTerm "immobility_N" ;
lin immobilization_N = mkTerm "immobilization_N" ;
lin immobilize_V2 = mkTerm "immobilize_V2" ;
lin immoderate_A = mkTerm "immoderate_A" ;
lin immoderation_N = mkTerm "immoderation_N" ;
lin immodest_A = mkTerm "immodest_A" ;
lin immodesty_N = mkTerm "immodesty_N" ;
lin immolate_V2 = mkTerm "immolate_V2" ;
lin immolation_N = mkTerm "immolation_N" ;
lin immoral_A = mkTerm "immoral_A" ;
lin immorality_N = mkTerm "immorality_N" ;
lin immortal_A = mkTerm "immortal_A" ;
lin immortal_N = mkTerm "immortal_N" ;
lin immortality_N = mkTerm "immortality_N" ;
lin immortalize_V2 = mkTerm "immortalize_V2" ;
lin immortelle_N = mkTerm "immortelle_N" ;
lin immotility_N = mkTerm "immotility_N" ;
lin immovability_N = mkTerm "immovability_N" ;
lin immovable_A = mkTerm "immovable_A" ;
lin immune_A = mkTerm "immune_A" ;
lin immune_N = mkTerm "immune_N" ;
lin immunity_N = mkTerm "immunity_N" ;
lin immunization_N = mkTerm "immunization_N" ;
lin immunize_V2 = mkTerm "immunize_V2" ;
lin immunoassay_N = mkTerm "immunoassay_N" ;
lin immunochemical_A = mkTerm "immunochemical_A" ;
lin immunochemistry_N = mkTerm "immunochemistry_N" ;
lin immunocompetence_N = mkTerm "immunocompetence_N" ;
lin immunocompetent_A = mkTerm "immunocompetent_A" ;
lin immunocompromised_A = mkTerm "immunocompromised_A" ;
lin immunodeficiency_N = mkTerm "immunodeficiency_N" ;
lin immunodeficient_A = mkTerm "immunodeficient_A" ;
lin immunoelectrophoresis_N = mkTerm "immunoelectrophoresis_N" ;
lin immunofluorescence_N = mkTerm "immunofluorescence_N" ;
lin immunogen_N = mkTerm "immunogen_N" ;
lin immunogenic_A = mkTerm "immunogenic_A" ;
lin immunogenicity_N = mkTerm "immunogenicity_N" ;
lin immunoglobulin_N = mkTerm "immunoglobulin_N" ;
lin immunohistochemistry_N = mkTerm "immunohistochemistry_N" ;
lin immunological_A = mkTerm "immunological_A" ;
lin immunologist_N = mkTerm "immunologist_N" ;
lin immunology_N = mkTerm "immunology_N" ;
lin immunopathology_N = mkTerm "immunopathology_N" ;
lin immunosuppressant_N = mkTerm "immunosuppressant_N" ;
lin immunosuppressed_A = mkTerm "immunosuppressed_A" ;
lin immunosuppression_N = mkTerm "immunosuppression_N" ;
lin immunosuppressive_A = mkTerm "immunosuppressive_A" ;
lin immunotherapeutic_A = mkTerm "immunotherapeutic_A" ;
lin immunotherapy_N = mkTerm "immunotherapy_N" ;
lin immure_V2 = mkTerm "immure_V2" ;
lin immutability_N = mkTerm "immutability_N" ;
lin immutable_A = mkTerm "immutable_A" ;
lin imp_N = mkTerm "imp_N" ;
lin impact_N = mkTerm "impact_N" ;
lin impact_V2 = mkTerm "impact_V2" ;
lin impaction_N = mkTerm "impaction_N" ;
lin impair_V2 = mkTerm "impair_V2" ;
lin impairer_N = mkTerm "impairer_N" ;
lin impairment_N = mkTerm "impairment_N" ;
lin impala_N = mkTerm "impala_N" ;
lin impale_V2 = mkTerm "impale_V2" ;
lin impalement_N = mkTerm "impalement_N" ;
lin impalpable_A = mkTerm "impalpable_A" ;
lin impanel_V2 = mkTerm "impanel_V2" ;
lin impart_V2 = mkTerm "impart_V2" ;
lin impartial_A = mkTerm "impartial_A" ;
lin impartiality_N = mkTerm "impartiality_N" ;
lin impassable_A = mkTerm "impassable_A" ;
lin impasse_N = mkTerm "impasse_N" ;
lin impassioned_A = mkTerm "impassioned_A" ;
lin impassive_A = mkTerm "impassive_A" ;
lin impassiveness_N = mkTerm "impassiveness_N" ;
lin impassivity_N = mkTerm "impassivity_N" ;
lin impasto_N = mkTerm "impasto_N" ;
lin impatience_N = mkTerm "impatience_N" ;
lin impatient_A = mkTerm "impatient_A" ;
lin impeach_V2 = mkTerm "impeach_V2" ;
lin impeachability_N = mkTerm "impeachability_N" ;
lin impeachment_N = mkTerm "impeachment_N" ;
lin impeccability_N = mkTerm "impeccability_N" ;
lin impeccable_A = mkTerm "impeccable_A" ;
lin impeccant_A = mkTerm "impeccant_A" ;
lin impecunious_A = mkTerm "impecunious_A" ;
lin impecuniousness_N = mkTerm "impecuniousness_N" ;
lin impedance_N = mkTerm "impedance_N" ;
lin impede_V2 = mkTerm "impede_V2" ;
lin impediment_N = mkTerm "impediment_N" ;
lin impedimenta_N = mkTerm "impedimenta_N" ;
lin impel_V2 = mkTerm "impel_V2" ;
lin impellent_A = mkTerm "impellent_A" ;
lin impeller_N = mkTerm "impeller_N" ;
lin impelling_A = mkTerm "impelling_A" ;
lin impend_V = mkTerm "impend_V" ;
lin impending_A = mkTerm "impending_A" ;
lin impenetrability_N = mkTerm "impenetrability_N" ;
lin impenetrable_A = mkTerm "impenetrable_A" ;
lin impenitence_N = mkTerm "impenitence_N" ;
lin impenitent_A = mkTerm "impenitent_A" ;
lin imperative_A = mkTerm "imperative_A" ;
lin imperative_N = mkTerm "imperative_N" ;
lin imperativeness_N = mkTerm "imperativeness_N" ;
lin imperceptibility_N = mkTerm "imperceptibility_N" ;
lin imperceptible_A = mkTerm "imperceptible_A" ;
lin imperfect_A = mkTerm "imperfect_A" ;
lin imperfect_N = mkTerm "imperfect_N" ;
lin imperfectibility_N = mkTerm "imperfectibility_N" ;
lin imperfectible_A = mkTerm "imperfectible_A" ;
lin imperfection_N = mkTerm "imperfection_N" ;
lin imperfective_N = mkTerm "imperfective_N" ;
lin imperforate_A = mkTerm "imperforate_A" ;
lin imperial_A = mkTerm "imperial_A" ;
lin imperial_N = mkTerm "imperial_N" ;
lin imperialism_N = mkTerm "imperialism_N" ;
lin imperialist_N = mkTerm "imperialist_N" ;
lin imperialistic_A = mkTerm "imperialistic_A" ;
lin imperil_V2 = mkTerm "imperil_V2" ;
lin imperile_V2 = mkTerm "imperile_V2" ;
lin imperious_A = mkTerm "imperious_A" ;
lin imperiousness_N = mkTerm "imperiousness_N" ;
lin imperishability_N = mkTerm "imperishability_N" ;
lin imperishable_A = mkTerm "imperishable_A" ;
lin imperium_N = mkTerm "imperium_N" ;
lin impermanence_N = mkTerm "impermanence_N" ;
lin impermanent_A = mkTerm "impermanent_A" ;
lin impermeability_N = mkTerm "impermeability_N" ;
lin impermeable_A = mkTerm "impermeable_A" ;
lin impermissibility_N = mkTerm "impermissibility_N" ;
lin impermissible_A = mkTerm "impermissible_A" ;
lin impersonal_A = mkTerm "impersonal_A" ;
lin impersonate_V2 = mkTerm "impersonate_V2" ;
lin impersonation_N = mkTerm "impersonation_N" ;
lin impersonator_N = mkTerm "impersonator_N" ;
lin impertinence_N = mkTerm "impertinence_N" ;
lin impertinent_A = mkTerm "impertinent_A" ;
lin imperturbability_N = mkTerm "imperturbability_N" ;
lin imperturbable_A = mkTerm "imperturbable_A" ;
lin impervious_A = mkTerm "impervious_A" ;
lin impetiginous_A = mkTerm "impetiginous_A" ;
lin impetigo_N = mkTerm "impetigo_N" ;
lin impetuosity_N = mkTerm "impetuosity_N" ;
lin impetuous_A = mkTerm "impetuous_A" ;
lin impetuousness_N = mkTerm "impetuousness_N" ;
lin impetus_N = mkTerm "impetus_N" ;
lin impiety_N = mkTerm "impiety_N" ;
lin impinge_V = mkTerm "impinge_V" ;
lin impingement_N = mkTerm "impingement_N" ;
lin impious_A = mkTerm "impious_A" ;
lin impish_A = mkTerm "impish_A" ;
lin impishness_N = mkTerm "impishness_N" ;
lin implacable_A = mkTerm "implacable_A" ;
lin implant_N = mkTerm "implant_N" ;
lin implant_V2 = mkTerm "implant_V2" ;
lin implantation_N = mkTerm "implantation_N" ;
lin implausibility_N = mkTerm "implausibility_N" ;
lin implausible_A = mkTerm "implausible_A" ;
lin implement_N = mkTerm "implement_N" ;
lin implement_V2 = mkTerm "implement_V2" ;
lin implemental_A = mkTerm "implemental_A" ;
lin implementation_N = mkTerm "implementation_N" ;
lin implicate_V2 = mkTerm "implicate_V2" ;
lin implication_N = mkTerm "implication_N" ;
lin implicational_A = mkTerm "implicational_A" ;
lin implicative_A = mkTerm "implicative_A" ;
lin implicit_A = mkTerm "implicit_A" ;
lin implicitness_N = mkTerm "implicitness_N" ;
lin implore_V2 = mkTerm "implore_V2" ;
lin implore_VS = mkTerm "implore_VS" ;
lin imploringly_Adv = mkTerm "imploringly_Adv" ;
lin implosion_N = mkTerm "implosion_N" ;
lin imply_V = mkTerm "imply_V" ;
lin imply_V2 = mkTerm "imply_V2" ;
lin imply_VS = mkTerm "imply_VS" ;
lin impolite_A = mkTerm "impolite_A" ;
lin impoliteness_N = mkTerm "impoliteness_N" ;
lin impolitic_A = mkTerm "impolitic_A" ;
lin imponderable_A = mkTerm "imponderable_A" ;
lin imponderable_N = mkTerm "imponderable_N" ;
lin import_N = mkTerm "import_N" ;
lin import_V2 = mkTerm "import_V2" ;
lin importance_N = mkTerm "importance_N" ;
lin important_A = mkTerm "important_A" ;
lin importation_N = mkTerm "importation_N" ;
lin importerFem_N = mkTerm "importerFem_N" ;
lin importerMasc_N = mkTerm "importerMasc_N" ;
lin importing_N = mkTerm "importing_N" ;
lin importunate_A = mkTerm "importunate_A" ;
lin importune_V2 = mkTerm "importune_V2" ;
lin importunity_N = mkTerm "importunity_N" ;
lin impose_V = mkTerm "impose_V" ;
lin impose_V2 = mkTerm "impose_V2" ;
lin imposing_A = mkTerm "imposing_A" ;
lin imposition_N = mkTerm "imposition_N" ;
lin impossibility_N = mkTerm "impossibility_N" ;
lin impossible_A = mkTerm "impossible_A" ;
lin impossible_N = mkTerm "impossible_N" ;
lin imposter_N = mkTerm "imposter_N" ;
lin impostor_N = mkTerm "impostor_N" ;
lin imposture_N = mkTerm "imposture_N" ;
lin impotence_N = mkTerm "impotence_N" ;
lin impotent_A = mkTerm "impotent_A" ;
lin impound_V2 = mkTerm "impound_V2" ;
lin impoundment_N = mkTerm "impoundment_N" ;
lin impoverish_V2 = mkTerm "impoverish_V2" ;
lin impoverishment_N = mkTerm "impoverishment_N" ;
lin impracticability_N = mkTerm "impracticability_N" ;
lin impracticable_A = mkTerm "impracticable_A" ;
lin impracticableness_N = mkTerm "impracticableness_N" ;
lin impractical_A = mkTerm "impractical_A" ;
lin impracticality_N = mkTerm "impracticality_N" ;
lin imprecate_V2 = mkTerm "imprecate_V2" ;
lin imprecation_N = mkTerm "imprecation_N" ;
lin imprecise_A = mkTerm "imprecise_A" ;
lin impreciseness_N = mkTerm "impreciseness_N" ;
lin imprecision_N = mkTerm "imprecision_N" ;
lin impregnability_N = mkTerm "impregnability_N" ;
lin impregnable_A = mkTerm "impregnable_A" ;
lin impregnate_V2 = mkTerm "impregnate_V2" ;
lin impregnation_N = mkTerm "impregnation_N" ;
lin impresario_N = mkTerm "impresario_N" ;
lin impress_N = mkTerm "impress_N" ;
lin impress_V = mkTerm "impress_V" ;
lin impress_V2 = mkTerm "impress_V2" ;
lin impression_N = mkTerm "impression_N" ;
lin impressionable_A = mkTerm "impressionable_A" ;
lin impressionism_N = mkTerm "impressionism_N" ;
lin impressionist_A = mkTerm "impressionist_A" ;
lin impressionist_N = mkTerm "impressionist_N" ;
lin impressionistic_A = mkTerm "impressionistic_A" ;
lin impressive_A = mkTerm "impressive_A" ;
lin impressiveness_N = mkTerm "impressiveness_N" ;
lin imprimatur_N = mkTerm "imprimatur_N" ;
lin imprint_N = mkTerm "imprint_N" ;
lin imprint_V2 = mkTerm "imprint_V2" ;
lin imprinting_N = mkTerm "imprinting_N" ;
lin imprison_V2 = mkTerm "imprison_V2" ;
lin imprisonment_N = mkTerm "imprisonment_N" ;
lin improbability_N = mkTerm "improbability_N" ;
lin improbable_A = mkTerm "improbable_A" ;
lin impromptu_A = mkTerm "impromptu_A" ;
lin impromptu_Adv = mkTerm "impromptu_Adv" ;
lin impromptu_N = mkTerm "impromptu_N" ;
lin improper_A = mkTerm "improper_A" ;
lin impropriety_N = mkTerm "impropriety_N" ;
lin improvable_A = mkTerm "improvable_A" ;
lin improve_V = mkTerm "improve_V" ;
lin improve_V2 = mkTerm "improve_V2" ;
lin improved_A = mkTerm "improved_A" ;
lin improvement_N = mkTerm "improvement_N" ;
lin improver_N = mkTerm "improver_N" ;
lin improvidence_N = mkTerm "improvidence_N" ;
lin improvident_A = mkTerm "improvident_A" ;
lin improvisation_N = mkTerm "improvisation_N" ;
lin improvisational_A = mkTerm "improvisational_A" ;
lin improvise_V = mkTerm "improvise_V" ;
lin improvise_V2 = mkTerm "improvise_V2" ;
lin imprudence_N = mkTerm "imprudence_N" ;
lin imprudent_A = mkTerm "imprudent_A" ;
lin impudence_N = mkTerm "impudence_N" ;
lin impudent_A = mkTerm "impudent_A" ;
lin impugn_V2 = mkTerm "impugn_V2" ;
lin impugnable_A = mkTerm "impugnable_A" ;
lin impuissant_A = mkTerm "impuissant_A" ;
lin impulse_N = mkTerm "impulse_N" ;
lin impulse_buy_V = mkTerm "impulse_buy_V" ;
lin impulse_buy_V2 = mkTerm "impulse_buy_V2" ;
lin impulsion_N = mkTerm "impulsion_N" ;
lin impulsive_A = mkTerm "impulsive_A" ;
lin impulsiveness_N = mkTerm "impulsiveness_N" ;
lin impunity_N = mkTerm "impunity_N" ;
lin impure_A = mkTerm "impure_A" ;
lin impurity_N = mkTerm "impurity_N" ;
lin imputation_N = mkTerm "imputation_N" ;
lin impute_V2 = mkTerm "impute_V2" ;
lin imputrescible_A = mkTerm "imputrescible_A" ;
lin in_1_Adv = mkTerm "in_1_Adv" ;
lin in_2_Adv = mkTerm "in_2_Adv" ;
lin in_A = mkTerm "in_A" ;
lin in_N = mkTerm "in_N" ;
lin in_accordance_with_Prep = mkTerm "in_accordance_with_Prep" ;
lin in_addition_Adv = mkTerm "in_addition_Adv" ;
lin in_addition_to_Prep = mkTerm "in_addition_to_Prep" ;
lin in_case_of_Prep = mkTerm "in_case_of_Prep" ;
lin in_chief_A = mkTerm "in_chief_A" ;
lin in_fighting_N = mkTerm "in_fighting_N" ;
lin in_front_of_Prep = mkTerm "in_front_of_Prep" ;
lin in_general_Adv = mkTerm "in_general_Adv" ;
lin in_lieu_of_Prep = mkTerm "in_lieu_of_Prep" ;
lin in_loco_parentis_Adv = mkTerm "in_loco_parentis_Adv" ;
lin in_order_to_Prep = mkTerm "in_order_to_Prep" ;
lin in_particular_Adv = mkTerm "in_particular_Adv" ;
lin in_patient_N = mkTerm "in_patient_N" ;
lin in_person_Adv = mkTerm "in_person_Adv" ;
lin in_place_of_Prep = mkTerm "in_place_of_Prep" ;
lin in_point_of_Prep = mkTerm "in_point_of_Prep" ;
lin in_reality_Adv = mkTerm "in_reality_Adv" ;
lin in_service_A = mkTerm "in_service_A" ;
lin in_situ_Adv = mkTerm "in_situ_Adv" ;
lin in_spite_of_Prep = mkTerm "in_spite_of_Prep" ;
lin in_the_end_1_Adv = mkTerm "in_the_end_1_Adv" ;
lin in_the_end_2_Adv = mkTerm "in_the_end_2_Adv" ;
lin in_the_main_1_Adv = mkTerm "in_the_main_1_Adv" ;
lin in_the_main_2_Adv = mkTerm "in_the_main_2_Adv" ;
lin in_toto_Adv = mkTerm "in_toto_Adv" ;
lin in_tray_N = mkTerm "in_tray_N" ;
lin in_truth_Adv = mkTerm "in_truth_Adv" ;
lin inability_N = mkTerm "inability_N" ;
lin inaccessibility_N = mkTerm "inaccessibility_N" ;
lin inaccessible_A = mkTerm "inaccessible_A" ;
lin inaccuracy_N = mkTerm "inaccuracy_N" ;
lin inaccurate_A = mkTerm "inaccurate_A" ;
lin inaction_N = mkTerm "inaction_N" ;
lin inactivate_V2 = mkTerm "inactivate_V2" ;
lin inactivation_N = mkTerm "inactivation_N" ;
lin inactive_A = mkTerm "inactive_A" ;
lin inactiveness_N = mkTerm "inactiveness_N" ;
lin inactivity_N = mkTerm "inactivity_N" ;
lin inadequacy_N = mkTerm "inadequacy_N" ;
lin inadequate_A = mkTerm "inadequate_A" ;
lin inadmissibility_N = mkTerm "inadmissibility_N" ;
lin inadmissible_A = mkTerm "inadmissible_A" ;
lin inadvertence_N = mkTerm "inadvertence_N" ;
lin inadvertent_A = mkTerm "inadvertent_A" ;
lin inadvisability_N = mkTerm "inadvisability_N" ;
lin inadvisable_A = mkTerm "inadvisable_A" ;
lin inaesthetic_A = mkTerm "inaesthetic_A" ;
lin inalienable_A = mkTerm "inalienable_A" ;
lin inamorata_N = mkTerm "inamorata_N" ;
lin inamorato_N = mkTerm "inamorato_N" ;
lin inane_A = mkTerm "inane_A" ;
lin inanimate_A = mkTerm "inanimate_A" ;
lin inanimateness_N = mkTerm "inanimateness_N" ;
lin inanition_N = mkTerm "inanition_N" ;
lin inanity_N = mkTerm "inanity_N" ;
lin inapplicability_N = mkTerm "inapplicability_N" ;
lin inapplicable_A = mkTerm "inapplicable_A" ;
lin inapposite_A = mkTerm "inapposite_A" ;
lin inappreciable_A = mkTerm "inappreciable_A" ;
lin inappropriate_A = mkTerm "inappropriate_A" ;
lin inappropriateness_N = mkTerm "inappropriateness_N" ;
lin inapt_A = mkTerm "inapt_A" ;
lin inaptitude_N = mkTerm "inaptitude_N" ;
lin inaptness_N = mkTerm "inaptness_N" ;
lin inarguable_A = mkTerm "inarguable_A" ;
lin inari_PN = mkTerm "inari_PN" ;
lin inarticulate_A = mkTerm "inarticulate_A" ;
lin inartistic_A = mkTerm "inartistic_A" ;
lin inasmuch_as_Adv = mkTerm "inasmuch_as_Adv" ;
lin inattention_N = mkTerm "inattention_N" ;
lin inattentive_A = mkTerm "inattentive_A" ;
lin inattentiveness_N = mkTerm "inattentiveness_N" ;
lin inaudibility_N = mkTerm "inaudibility_N" ;
lin inaudible_A = mkTerm "inaudible_A" ;
lin inaugural_A = mkTerm "inaugural_A" ;
lin inaugural_N = mkTerm "inaugural_N" ;
lin inaugurate_V2 = mkTerm "inaugurate_V2" ;
lin inauguration_N = mkTerm "inauguration_N" ;
lin inauspicious_A = mkTerm "inauspicious_A" ;
lin inauspiciousness_N = mkTerm "inauspiciousness_N" ;
lin inauthentic_A = mkTerm "inauthentic_A" ;
lin inboard_A = mkTerm "inboard_A" ;
lin inborn_A = mkTerm "inborn_A" ;
lin inbound_A = mkTerm "inbound_A" ;
lin inbred_A = mkTerm "inbred_A" ;
lin inbreeding_N = mkTerm "inbreeding_N" ;
lin inbuilt_A = mkTerm "inbuilt_A" ;
lin inc_PN = mkTerm "inc_PN" ;
lin incalculable_A = mkTerm "incalculable_A" ;
lin incandescence_N = mkTerm "incandescence_N" ;
lin incandescent_A = mkTerm "incandescent_A" ;
lin incantation_N = mkTerm "incantation_N" ;
lin incapability_N = mkTerm "incapability_N" ;
lin incapable_A = mkTerm "incapable_A" ;
lin incapacitate_V2 = mkTerm "incapacitate_V2" ;
lin incapacity_N = mkTerm "incapacity_N" ;
lin incarcerate_V2 = mkTerm "incarcerate_V2" ;
lin incarceration_N = mkTerm "incarceration_N" ;
lin incarnate_A = mkTerm "incarnate_A" ;
lin incarnate_V2 = mkTerm "incarnate_V2" ;
lin incarnation_N = mkTerm "incarnation_N" ;
lin incaution_N = mkTerm "incaution_N" ;
lin incautious_A = mkTerm "incautious_A" ;
lin incendiarism_N = mkTerm "incendiarism_N" ;
lin incendiary_A = mkTerm "incendiary_A" ;
lin incendiary_N = mkTerm "incendiary_N" ;
lin incense_N = mkTerm "incense_N" ;
lin incense_V2 = mkTerm "incense_V2" ;
lin incentive_N = mkTerm "incentive_N" ;
lin inception_N = mkTerm "inception_N" ;
lin incertitude_N = mkTerm "incertitude_N" ;
lin incessant_A = mkTerm "incessant_A" ;
lin incest_N = mkTerm "incest_N" ;
lin incestuous_A = mkTerm "incestuous_A" ;
lin inch_N = mkTerm "inch_N" ;
lin inch_V = mkTerm "inch_V" ;
lin inch_V2 = mkTerm "inch_V2" ;
lin inch_up_V = mkTerm "inch_up_V" ;
lin inchoate_A = mkTerm "inchoate_A" ;
lin inchoative_A = mkTerm "inchoative_A" ;
lin inchoative_N = mkTerm "inchoative_N" ;
lin inchon_PN = mkTerm "inchon_PN" ;
lin incidence_N = mkTerm "incidence_N" ;
lin incident_A = mkTerm "incident_A" ;
lin incident_N = mkTerm "incident_N" ;
lin incidental_A = mkTerm "incidental_A" ;
lin incidental_N = mkTerm "incidental_N" ;
lin incinerate_V2 = mkTerm "incinerate_V2" ;
lin incineration_N = mkTerm "incineration_N" ;
lin incinerator_N = mkTerm "incinerator_N" ;
lin incipiency_N = mkTerm "incipiency_N" ;
lin incipient_A = mkTerm "incipient_A" ;
lin incise_V2 = mkTerm "incise_V2" ;
lin incision_N = mkTerm "incision_N" ;
lin incisive_A = mkTerm "incisive_A" ;
lin incisiveness_N = mkTerm "incisiveness_N" ;
lin incisor_N = mkTerm "incisor_N" ;
lin incisure_N = mkTerm "incisure_N" ;
lin incitation_N = mkTerm "incitation_N" ;
lin incite_V2 = mkTerm "incite_V2" ;
lin incitement_N = mkTerm "incitement_N" ;
lin incivility_N = mkTerm "incivility_N" ;
lin incl_PN = mkTerm "incl_PN" ;
lin inclemency_N = mkTerm "inclemency_N" ;
lin inclement_A = mkTerm "inclement_A" ;
lin inclination_N = mkTerm "inclination_N" ;
lin incline_N = mkTerm "incline_N" ;
lin incline_V = mkTerm "incline_V" ;
lin incline_V2 = mkTerm "incline_V2" ;
lin incline_V2V = mkTerm "incline_V2V" ;
lin inclined_A = mkTerm "inclined_A" ;
lin inclinometer_N = mkTerm "inclinometer_N" ;
lin inclose_V2 = mkTerm "inclose_V2" ;
lin inclosure_N = mkTerm "inclosure_N" ;
lin include_V = mkTerm "include_V" ;
lin include_V2 = mkTerm "include_V2" ;
lin including_N = mkTerm "including_N" ;
lin including_Prep = mkTerm "including_Prep" ;
lin inclusion_N = mkTerm "inclusion_N" ;
lin inclusive_A = mkTerm "inclusive_A" ;
lin incognito_A = mkTerm "incognito_A" ;
lin incognito_Adv = mkTerm "incognito_Adv" ;
lin incognizable_A = mkTerm "incognizable_A" ;
lin incognizance_N = mkTerm "incognizance_N" ;
lin incoherence_N = mkTerm "incoherence_N" ;
lin incoherent_A = mkTerm "incoherent_A" ;
lin incombustible_A = mkTerm "incombustible_A" ;
lin income_N = mkTerm "income_N" ;
lin income_tax_N = mkTerm "income_tax_N" ;
lin incoming_A = mkTerm "incoming_A" ;
lin incommensurable_A = mkTerm "incommensurable_A" ;
lin incommensurate_A = mkTerm "incommensurate_A" ;
lin incommode_V2 = mkTerm "incommode_V2" ;
lin incommodious_A = mkTerm "incommodious_A" ;
lin incommunicado_A = mkTerm "incommunicado_A" ;
lin incommutability_N = mkTerm "incommutability_N" ;
lin incommutable_A = mkTerm "incommutable_A" ;
lin incomparable_A = mkTerm "incomparable_A" ;
lin incompatibility_N = mkTerm "incompatibility_N" ;
lin incompatible_A = mkTerm "incompatible_A" ;
lin incompetence_N = mkTerm "incompetence_N" ;
lin incompetency_N = mkTerm "incompetency_N" ;
lin incompetent_A = mkTerm "incompetent_A" ;
lin incompetent_N = mkTerm "incompetent_N" ;
lin incomplete_A = mkTerm "incomplete_A" ;
lin incompleteness_N = mkTerm "incompleteness_N" ;
lin incomprehensibility_N = mkTerm "incomprehensibility_N" ;
lin incomprehensible_A = mkTerm "incomprehensible_A" ;
lin incomprehension_N = mkTerm "incomprehension_N" ;
lin incompressibility_N = mkTerm "incompressibility_N" ;
lin incompressible_A = mkTerm "incompressible_A" ;
lin incomputable_A = mkTerm "incomputable_A" ;
lin inconceivability_N = mkTerm "inconceivability_N" ;
lin inconceivable_A = mkTerm "inconceivable_A" ;
lin inconclusive_A = mkTerm "inconclusive_A" ;
lin inconclusiveness_N = mkTerm "inconclusiveness_N" ;
lin incongruent_A = mkTerm "incongruent_A" ;
lin incongruity_N = mkTerm "incongruity_N" ;
lin incongruous_A = mkTerm "incongruous_A" ;
lin inconsequence_N = mkTerm "inconsequence_N" ;
lin inconsequent_A = mkTerm "inconsequent_A" ;
lin inconsequential_A = mkTerm "inconsequential_A" ;
lin inconsiderable_A = mkTerm "inconsiderable_A" ;
lin inconsiderate_A = mkTerm "inconsiderate_A" ;
lin inconsideration_N = mkTerm "inconsideration_N" ;
lin inconsistency_N = mkTerm "inconsistency_N" ;
lin inconsistent_A = mkTerm "inconsistent_A" ;
lin inconsolable_A = mkTerm "inconsolable_A" ;
lin inconspicuous_A = mkTerm "inconspicuous_A" ;
lin inconspicuousness_N = mkTerm "inconspicuousness_N" ;
lin inconstancy_N = mkTerm "inconstancy_N" ;
lin inconstant_A = mkTerm "inconstant_A" ;
lin incontestable_A = mkTerm "incontestable_A" ;
lin incontinence_N = mkTerm "incontinence_N" ;
lin incontinent_A = mkTerm "incontinent_A" ;
lin incontrovertibility_N = mkTerm "incontrovertibility_N" ;
lin incontrovertible_A = mkTerm "incontrovertible_A" ;
lin inconvenience_N = mkTerm "inconvenience_N" ;
lin inconvenience_V2 = mkTerm "inconvenience_V2" ;
lin inconvenient_A = mkTerm "inconvenient_A" ;
lin inconvertibility_N = mkTerm "inconvertibility_N" ;
lin inconvertible_A = mkTerm "inconvertible_A" ;
lin incoordination_N = mkTerm "incoordination_N" ;
lin incorporate_A = mkTerm "incorporate_A" ;
lin incorporate_V2 = mkTerm "incorporate_V2" ;
lin incorporated_A = mkTerm "incorporated_A" ;
lin incorporation_N = mkTerm "incorporation_N" ;
lin incorporative_A = mkTerm "incorporative_A" ;
lin incorporeal_A = mkTerm "incorporeal_A" ;
lin incorrect_A = mkTerm "incorrect_A" ;
lin incorrectness_N = mkTerm "incorrectness_N" ;
lin incorrigible_A = mkTerm "incorrigible_A" ;
lin incorrupt_A = mkTerm "incorrupt_A" ;
lin incorruptibility_N = mkTerm "incorruptibility_N" ;
lin incorruptible_A = mkTerm "incorruptible_A" ;
lin incorruptness_N = mkTerm "incorruptness_N" ;
lin increase_N = mkTerm "increase_N" ;
lin increase_V = mkTerm "increase_V" ;
lin increase_V2 = mkTerm "increase_V2" ;
lin increased_A = mkTerm "increased_A" ;
lin increasing_A = mkTerm "increasing_A" ;
lin increasingly_AdA = mkTerm "increasingly_AdA" ;
lin increasingly_AdV = mkTerm "increasingly_AdV" ;
lin increasingly_Adv = mkTerm "increasingly_Adv" ;
lin incredibility_N = mkTerm "incredibility_N" ;
lin incredible_A = mkTerm "incredible_A" ;
lin incredulity_N = mkTerm "incredulity_N" ;
lin incredulous_A = mkTerm "incredulous_A" ;
lin increment_N = mkTerm "increment_N" ;
lin incremental_A = mkTerm "incremental_A" ;
lin incriminate_V2 = mkTerm "incriminate_V2" ;
lin incriminatingly_Adv = mkTerm "incriminatingly_Adv" ;
lin incrimination_N = mkTerm "incrimination_N" ;
lin incrustation_N = mkTerm "incrustation_N" ;
lin incubate_V = mkTerm "incubate_V" ;
lin incubate_V2 = mkTerm "incubate_V2" ;
lin incubation_N = mkTerm "incubation_N" ;
lin incubator_N = mkTerm "incubator_N" ;
lin incubus_N = mkTerm "incubus_N" ;
lin inculcate_V2 = mkTerm "inculcate_V2" ;
lin inculcation_N = mkTerm "inculcation_N" ;
lin inculpate_V2 = mkTerm "inculpate_V2" ;
lin inculpatory_A = mkTerm "inculpatory_A" ;
lin incumbency_N = mkTerm "incumbency_N" ;
lin incumbent_A = mkTerm "incumbent_A" ;
lin incumbent_N = mkTerm "incumbent_N" ;
lin incur_V2 = mkTerm "incur_V2" ;
lin incurability_N = mkTerm "incurability_N" ;
lin incurable_A = mkTerm "incurable_A" ;
lin incurable_N = mkTerm "incurable_N" ;
lin incurious_A = mkTerm "incurious_A" ;
lin incurrence_N = mkTerm "incurrence_N" ;
lin incurring_N = mkTerm "incurring_N" ;
lin incursion_N = mkTerm "incursion_N" ;
lin incursive_A = mkTerm "incursive_A" ;
lin incurvate_A = mkTerm "incurvate_A" ;
lin incurvation_N = mkTerm "incurvation_N" ;
lin incurved_A = mkTerm "incurved_A" ;
lin incus_N = mkTerm "incus_N" ;
lin indaba_N = mkTerm "indaba_N" ;
lin indapamide_N = mkTerm "indapamide_N" ;
lin indebted_A = mkTerm "indebted_A" ;
lin indebtedness_N = mkTerm "indebtedness_N" ;
lin indecency_N = mkTerm "indecency_N" ;
lin indecent_A = mkTerm "indecent_A" ;
lin indecipherable_A = mkTerm "indecipherable_A" ;
lin indecision_N = mkTerm "indecision_N" ;
lin indecisive_A = mkTerm "indecisive_A" ;
lin indecisiveness_N = mkTerm "indecisiveness_N" ;
lin indecorous_A = mkTerm "indecorous_A" ;
lin indecorum_N = mkTerm "indecorum_N" ;
lin indeed_AdV = mkTerm "indeed_AdV" ;
lin indeed_Adv = mkTerm "indeed_Adv" ;
lin indefatigability_N = mkTerm "indefatigability_N" ;
lin indefatigable_A = mkTerm "indefatigable_A" ;
lin indefeasible_A = mkTerm "indefeasible_A" ;
lin indefensible_A = mkTerm "indefensible_A" ;
lin indefinable_A = mkTerm "indefinable_A" ;
lin indefinite_A = mkTerm "indefinite_A" ;
lin indefiniteness_N = mkTerm "indefiniteness_N" ;
lin indehiscent_A = mkTerm "indehiscent_A" ;
lin indelible_A = mkTerm "indelible_A" ;
lin indelicacy_N = mkTerm "indelicacy_N" ;
lin indelicate_A = mkTerm "indelicate_A" ;
lin indemnification_N = mkTerm "indemnification_N" ;
lin indemnify_V2 = mkTerm "indemnify_V2" ;
lin indemnity_N = mkTerm "indemnity_N" ;
lin indene_N = mkTerm "indene_N" ;
lin indent_N = mkTerm "indent_N" ;
lin indent_V = mkTerm "indent_V" ;
lin indent_V2 = mkTerm "indent_V2" ;
lin indentation_N = mkTerm "indentation_N" ;
lin indenture_N = mkTerm "indenture_N" ;
lin indenture_V2 = mkTerm "indenture_V2" ;
lin independence_N = mkTerm "independence_N" ;
lin independent_1_A = mkTerm "independent_1_A" ;
lin independent_2_A = mkTerm "independent_2_A" ;
lin independent_N = mkTerm "independent_N" ;
lin indescribable_A = mkTerm "indescribable_A" ;
lin indestructibility_N = mkTerm "indestructibility_N" ;
lin indestructible_A = mkTerm "indestructible_A" ;
lin indeterminable_A = mkTerm "indeterminable_A" ;
lin indeterminacy_N = mkTerm "indeterminacy_N" ;
lin indeterminate_A = mkTerm "indeterminate_A" ;
lin index_N = mkTerm "index_N" ;
lin index_V2 = mkTerm "index_V2" ;
lin indexation_N = mkTerm "indexation_N" ;
lin indexer_N = mkTerm "indexer_N" ;
lin indexical_A = mkTerm "indexical_A" ;
lin indexing_N = mkTerm "indexing_N" ;
lin indexless_A = mkTerm "indexless_A" ;
lin india_PN = mkTerm "india_PN" ;
lin india_rubber_N = mkTerm "india_rubber_N" ;
lin indiaman_N = mkTerm "indiaman_N" ;
lin indianFem_1_N = mkTerm "indianFem_1_N" ;
lin indianFem_2_N = mkTerm "indianFem_2_N" ;
lin indianMasc_1_N = mkTerm "indianMasc_1_N" ;
lin indianMasc_2_N = mkTerm "indianMasc_2_N" ;
lin indian_A = mkTerm "indian_A" ;
lin indiana_PN = mkTerm "indiana_PN" ;
lin indianapolis_PN = mkTerm "indianapolis_PN" ;
lin indicate_V2 = mkTerm "indicate_V2" ;
lin indicate_VS = mkTerm "indicate_VS" ;
lin indication_N = mkTerm "indication_N" ;
lin indicative_A = mkTerm "indicative_A" ;
lin indicator_N = mkTerm "indicator_N" ;
lin indict_V = mkTerm "indict_V" ;
lin indict_V2 = mkTerm "indict_V2" ;
lin indictable_A = mkTerm "indictable_A" ;
lin indiction_N = mkTerm "indiction_N" ;
lin indictment_N = mkTerm "indictment_N" ;
lin indie_A = mkTerm "indie_A" ;
lin indie_N = mkTerm "indie_N" ;
lin indies_PN = mkTerm "indies_PN" ;
lin indifference_N = mkTerm "indifference_N" ;
lin indifferent_A = mkTerm "indifferent_A" ;
lin indigence_N = mkTerm "indigence_N" ;
lin indigenous_A = mkTerm "indigenous_A" ;
lin indigenousness_N = mkTerm "indigenousness_N" ;
lin indigent_A = mkTerm "indigent_A" ;
lin indigestibility_N = mkTerm "indigestibility_N" ;
lin indigestible_A = mkTerm "indigestible_A" ;
lin indigestion_N = mkTerm "indigestion_N" ;
lin indignant_A = mkTerm "indignant_A" ;
lin indignation_N = mkTerm "indignation_N" ;
lin indignity_N = mkTerm "indignity_N" ;
lin indigo_A = mkTerm "indigo_A" ;
lin indigo_N = mkTerm "indigo_N" ;
lin indinavir_N = mkTerm "indinavir_N" ;
lin indirect_A = mkTerm "indirect_A" ;
lin indirection_N = mkTerm "indirection_N" ;
lin indirectness_N = mkTerm "indirectness_N" ;
lin indiscernible_A = mkTerm "indiscernible_A" ;
lin indiscipline_N = mkTerm "indiscipline_N" ;
lin indiscreet_A = mkTerm "indiscreet_A" ;
lin indiscrete_A = mkTerm "indiscrete_A" ;
lin indiscretion_N = mkTerm "indiscretion_N" ;
lin indiscriminate_A = mkTerm "indiscriminate_A" ;
lin indispensability_N = mkTerm "indispensability_N" ;
lin indispensable_A = mkTerm "indispensable_A" ;
lin indisposed_A = mkTerm "indisposed_A" ;
lin indisposition_N = mkTerm "indisposition_N" ;
lin indisputability_N = mkTerm "indisputability_N" ;
lin indisputable_A = mkTerm "indisputable_A" ;
lin indissoluble_A = mkTerm "indissoluble_A" ;
lin indistinct_A = mkTerm "indistinct_A" ;
lin indistinctness_N = mkTerm "indistinctness_N" ;
lin indistinguishable_A = mkTerm "indistinguishable_A" ;
lin indite_V2 = mkTerm "indite_V2" ;
lin indium_N = mkTerm "indium_N" ;
lin individual_A = mkTerm "individual_A" ;
lin individual_N = mkTerm "individual_N" ;
lin individualism_N = mkTerm "individualism_N" ;
lin individualist_A = mkTerm "individualist_A" ;
lin individualist_N = mkTerm "individualist_N" ;
lin individualistic_A = mkTerm "individualistic_A" ;
lin individuality_N = mkTerm "individuality_N" ;
lin individualization_N = mkTerm "individualization_N" ;
lin individualize_V2 = mkTerm "individualize_V2" ;
lin indivisible_A = mkTerm "indivisible_A" ;
lin indo_european_A = mkTerm "indo_european_A" ;
lin indocile_A = mkTerm "indocile_A" ;
lin indoctrinate_V2 = mkTerm "indoctrinate_V2" ;
lin indoctrination_N = mkTerm "indoctrination_N" ;
lin indolence_N = mkTerm "indolence_N" ;
lin indolent_A = mkTerm "indolent_A" ;
lin indomethacin_N = mkTerm "indomethacin_N" ;
lin indomitability_N = mkTerm "indomitability_N" ;
lin indomitable_A = mkTerm "indomitable_A" ;
lin indonesia_PN = mkTerm "indonesia_PN" ;
lin indonesian_A = mkTerm "indonesian_A" ;
lin indonesian_N = mkTerm "indonesian_N" ;
lin indoor_A = mkTerm "indoor_A" ;
lin indoors_Adv = mkTerm "indoors_Adv" ;
lin indore_PN = mkTerm "indore_PN" ;
lin indorse_V2 = mkTerm "indorse_V2" ;
lin indrawn_A = mkTerm "indrawn_A" ;
lin indri_N = mkTerm "indri_N" ;
lin indubitable_A = mkTerm "indubitable_A" ;
lin induce_V2 = mkTerm "induce_V2" ;
lin inducement_N = mkTerm "inducement_N" ;
lin inducer_N = mkTerm "inducer_N" ;
lin induct_V2 = mkTerm "induct_V2" ;
lin inductee_N = mkTerm "inductee_N" ;
lin induction_N = mkTerm "induction_N" ;
lin inductive_A = mkTerm "inductive_A" ;
lin inductor_N = mkTerm "inductor_N" ;
lin indue_V2 = mkTerm "indue_V2" ;
lin indulge_V = mkTerm "indulge_V" ;
lin indulge_V2 = mkTerm "indulge_V2" ;
lin indulgence_N = mkTerm "indulgence_N" ;
lin indulgent_A = mkTerm "indulgent_A" ;
lin indumentum_N = mkTerm "indumentum_N" ;
lin indusial_A = mkTerm "indusial_A" ;
lin indusium_N = mkTerm "indusium_N" ;
lin industrial_A = mkTerm "industrial_A" ;
lin industrialism_N = mkTerm "industrialism_N" ;
lin industrialist_N = mkTerm "industrialist_N" ;
lin industrialization_N = mkTerm "industrialization_N" ;
lin industrialize_V2 = mkTerm "industrialize_V2" ;
lin industrious_A = mkTerm "industrious_A" ;
lin industry_N = mkTerm "industry_N" ;
lin indweller_N = mkTerm "indweller_N" ;
lin indwelling_A = mkTerm "indwelling_A" ;
lin inebriate_A = mkTerm "inebriate_A" ;
lin inebriate_N = mkTerm "inebriate_N" ;
lin inebriate_V2 = mkTerm "inebriate_V2" ;
lin inebriation_N = mkTerm "inebriation_N" ;
lin inebriety_N = mkTerm "inebriety_N" ;
lin inedible_A = mkTerm "inedible_A" ;
lin ineffable_A = mkTerm "ineffable_A" ;
lin ineffective_A = mkTerm "ineffective_A" ;
lin ineffectiveness_N = mkTerm "ineffectiveness_N" ;
lin ineffectual_A = mkTerm "ineffectual_A" ;
lin ineffectuality_N = mkTerm "ineffectuality_N" ;
lin inefficacious_A = mkTerm "inefficacious_A" ;
lin inefficacy_N = mkTerm "inefficacy_N" ;
lin inefficiency_N = mkTerm "inefficiency_N" ;
lin inefficient_A = mkTerm "inefficient_A" ;
lin inelaborate_A = mkTerm "inelaborate_A" ;
lin inelastic_A = mkTerm "inelastic_A" ;
lin inelasticity_N = mkTerm "inelasticity_N" ;
lin inelegance_N = mkTerm "inelegance_N" ;
lin inelegant_A = mkTerm "inelegant_A" ;
lin ineligibility_N = mkTerm "ineligibility_N" ;
lin ineligible_A = mkTerm "ineligible_A" ;
lin ineloquently_Adv = mkTerm "ineloquently_Adv" ;
lin ineluctability_N = mkTerm "ineluctability_N" ;
lin ineluctable_A = mkTerm "ineluctable_A" ;
lin inept_A = mkTerm "inept_A" ;
lin ineptitude_N = mkTerm "ineptitude_N" ;
lin inequality_N = mkTerm "inequality_N" ;
lin inequitable_A = mkTerm "inequitable_A" ;
lin inequity_N = mkTerm "inequity_N" ;
lin ineradicable_A = mkTerm "ineradicable_A" ;
lin inerrable_A = mkTerm "inerrable_A" ;
lin inerrancy_N = mkTerm "inerrancy_N" ;
lin inert_A = mkTerm "inert_A" ;
lin inertia_N = mkTerm "inertia_N" ;
lin inertial_A = mkTerm "inertial_A" ;
lin inertness_N = mkTerm "inertness_N" ;
lin inescapable_A = mkTerm "inescapable_A" ;
lin inessential_A = mkTerm "inessential_A" ;
lin inessential_N = mkTerm "inessential_N" ;
lin inessentiality_N = mkTerm "inessentiality_N" ;
lin inestimable_A = mkTerm "inestimable_A" ;
lin inevitability_N = mkTerm "inevitability_N" ;
lin inevitable_A = mkTerm "inevitable_A" ;
lin inevitable_N = mkTerm "inevitable_N" ;
lin inexact_A = mkTerm "inexact_A" ;
lin inexactitude_N = mkTerm "inexactitude_N" ;
lin inexactness_N = mkTerm "inexactness_N" ;
lin inexcusable_A = mkTerm "inexcusable_A" ;
lin inexhaustible_A = mkTerm "inexhaustible_A" ;
lin inexorable_A = mkTerm "inexorable_A" ;
lin inexpedience_N = mkTerm "inexpedience_N" ;
lin inexpediency_N = mkTerm "inexpediency_N" ;
lin inexpedient_A = mkTerm "inexpedient_A" ;
lin inexpensive_A = mkTerm "inexpensive_A" ;
lin inexpensiveness_N = mkTerm "inexpensiveness_N" ;
lin inexperience_N = mkTerm "inexperience_N" ;
lin inexperienced_A = mkTerm "inexperienced_A" ;
lin inexpert_A = mkTerm "inexpert_A" ;
lin inexpiable_A = mkTerm "inexpiable_A" ;
lin inexplicable_A = mkTerm "inexplicable_A" ;
lin inexplicitness_N = mkTerm "inexplicitness_N" ;
lin inexpressible_A = mkTerm "inexpressible_A" ;
lin inexpressive_A = mkTerm "inexpressive_A" ;
lin inexpungible_A = mkTerm "inexpungible_A" ;
lin inexterminable_A = mkTerm "inexterminable_A" ;
lin inextinguishable_A = mkTerm "inextinguishable_A" ;
lin inextricable_A = mkTerm "inextricable_A" ;
lin infallibility_N = mkTerm "infallibility_N" ;
lin infallible_A = mkTerm "infallible_A" ;
lin infamous_A = mkTerm "infamous_A" ;
lin infamy_N = mkTerm "infamy_N" ;
lin infancy_N = mkTerm "infancy_N" ;
lin infant_N = mkTerm "infant_N" ;
lin infanticide_N = mkTerm "infanticide_N" ;
lin infantile_A = mkTerm "infantile_A" ;
lin infantilism_N = mkTerm "infantilism_N" ;
lin infantry_N = mkTerm "infantry_N" ;
lin infantryman_N = mkTerm "infantryman_N" ;
lin infarct_N = mkTerm "infarct_N" ;
lin infatuate_V2 = mkTerm "infatuate_V2" ;
lin infatuation_N = mkTerm "infatuation_N" ;
lin infeasibility_N = mkTerm "infeasibility_N" ;
lin infect_V = mkTerm "infect_V" ;
lin infect_V2 = mkTerm "infect_V2" ;
lin infected_A = mkTerm "infected_A" ;
lin infection_N = mkTerm "infection_N" ;
lin infectious_A = mkTerm "infectious_A" ;
lin infective_A = mkTerm "infective_A" ;
lin infelicitous_A = mkTerm "infelicitous_A" ;
lin infelicity_N = mkTerm "infelicity_N" ;
lin infer_V2 = mkTerm "infer_V2" ;
lin inference_N = mkTerm "inference_N" ;
lin inferential_A = mkTerm "inferential_A" ;
lin inferior_A = mkTerm "inferior_A" ;
lin inferior_N = mkTerm "inferior_N" ;
lin inferiority_N = mkTerm "inferiority_N" ;
lin infernal_A = mkTerm "infernal_A" ;
lin infernal_N = mkTerm "infernal_N" ;
lin inferno_N = mkTerm "inferno_N" ;
lin infertile_A = mkTerm "infertile_A" ;
lin infertility_N = mkTerm "infertility_N" ;
lin infest_V2 = mkTerm "infest_V2" ;
lin infestation_N = mkTerm "infestation_N" ;
lin infidel_N = mkTerm "infidel_N" ;
lin infidelity_N = mkTerm "infidelity_N" ;
lin infield_N = mkTerm "infield_N" ;
lin infielder_N = mkTerm "infielder_N" ;
lin infiltrate_V = mkTerm "infiltrate_V" ;
lin infiltrate_V2 = mkTerm "infiltrate_V2" ;
lin infiltration_N = mkTerm "infiltration_N" ;
lin infiltrator_N = mkTerm "infiltrator_N" ;
lin infinite_A = mkTerm "infinite_A" ;
lin infiniteness_N = mkTerm "infiniteness_N" ;
lin infinitesimal_A = mkTerm "infinitesimal_A" ;
lin infinitesimal_N = mkTerm "infinitesimal_N" ;
lin infinitival_A = mkTerm "infinitival_A" ;
lin infinitive_A = mkTerm "infinitive_A" ;
lin infinitive_N = mkTerm "infinitive_N" ;
lin infinitude_N = mkTerm "infinitude_N" ;
lin infinity_N = mkTerm "infinity_N" ;
lin infirm_A = mkTerm "infirm_A" ;
lin infirmary_N = mkTerm "infirmary_N" ;
lin infirmity_N = mkTerm "infirmity_N" ;
lin infix_N = mkTerm "infix_N" ;
lin inflame_V = mkTerm "inflame_V" ;
lin inflame_V2 = mkTerm "inflame_V2" ;
lin inflammable_A = mkTerm "inflammable_A" ;
lin inflammation_N = mkTerm "inflammation_N" ;
lin inflammatory_A = mkTerm "inflammatory_A" ;
lin inflatable_A = mkTerm "inflatable_A" ;
lin inflate_V = mkTerm "inflate_V" ;
lin inflate_V2 = mkTerm "inflate_V2" ;
lin inflater_N = mkTerm "inflater_N" ;
lin inflation_N = mkTerm "inflation_N" ;
lin inflationary_A = mkTerm "inflationary_A" ;
lin inflect_V2 = mkTerm "inflect_V2" ;
lin inflection_N = mkTerm "inflection_N" ;
lin inflectional_A = mkTerm "inflectional_A" ;
lin inflexibility_N = mkTerm "inflexibility_N" ;
lin inflexible_A = mkTerm "inflexible_A" ;
lin inflexion_N = mkTerm "inflexion_N" ;
lin inflict_V2 = mkTerm "inflict_V2" ;
lin infliction_N = mkTerm "infliction_N" ;
lin infliximab_N = mkTerm "infliximab_N" ;
lin inflorescence_N = mkTerm "inflorescence_N" ;
lin inflow_N = mkTerm "inflow_N" ;
lin inflowing_A = mkTerm "inflowing_A" ;
lin influence_N = mkTerm "influence_N" ;
lin influence_V2 = mkTerm "influence_V2" ;
lin influential_A = mkTerm "influential_A" ;
lin influenza_N = mkTerm "influenza_N" ;
lin influx_N = mkTerm "influx_N" ;
lin info_Adv = mkTerm "info_Adv" ;
lin info_N = mkTerm "info_N" ;
lin infomercial_N = mkTerm "infomercial_N" ;
lin inform_V = mkTerm "inform_V" ;
lin inform_V2 = mkTerm "inform_V2" ;
lin informal_A = mkTerm "informal_A" ;
lin informality_N = mkTerm "informality_N" ;
lin informant_N = mkTerm "informant_N" ;
lin information_N = mkTerm "information_N" ;
lin informational_A = mkTerm "informational_A" ;
lin informative_A = mkTerm "informative_A" ;
lin informer_N = mkTerm "informer_N" ;
lin informing_N = mkTerm "informing_N" ;
lin infra_Adv = mkTerm "infra_Adv" ;
lin infra_dig_A = mkTerm "infra_dig_A" ;
lin infra_red_A = mkTerm "infra_red_A" ;
lin infraction_N = mkTerm "infraction_N" ;
lin infrahuman_A = mkTerm "infrahuman_A" ;
lin infrangible_A = mkTerm "infrangible_A" ;
lin infrared_N = mkTerm "infrared_N" ;
lin infrasonic_A = mkTerm "infrasonic_A" ;
lin infrastructure_N = mkTerm "infrastructure_N" ;
lin infrequency_N = mkTerm "infrequency_N" ;
lin infrequent_A = mkTerm "infrequent_A" ;
lin infringe_V = mkTerm "infringe_V" ;
lin infringe_V2 = mkTerm "infringe_V2" ;
lin infringement_N = mkTerm "infringement_N" ;
lin infructescence_N = mkTerm "infructescence_N" ;
lin infundibulum_N = mkTerm "infundibulum_N" ;
lin infuriate_V2 = mkTerm "infuriate_V2" ;
lin infuriation_N = mkTerm "infuriation_N" ;
lin infuse_V = mkTerm "infuse_V" ;
lin infuse_V2 = mkTerm "infuse_V2" ;
lin infusion_N = mkTerm "infusion_N" ;
lin infusorian_N = mkTerm "infusorian_N" ;
lin inga_N = mkTerm "inga_N" ;
lin ingatestone_PN = mkTerm "ingatestone_PN" ;
lin ingathering_N = mkTerm "ingathering_N" ;
lin ingenious_A = mkTerm "ingenious_A" ;
lin ingenue_N = mkTerm "ingenue_N" ;
lin ingenuity_N = mkTerm "ingenuity_N" ;
lin ingenuous_A = mkTerm "ingenuous_A" ;
lin ingenuousness_N = mkTerm "ingenuousness_N" ;
lin ingest_V2 = mkTerm "ingest_V2" ;
lin ingesta_N = mkTerm "ingesta_N" ;
lin ingle_nook_N = mkTerm "ingle_nook_N" ;
lin inglorious_A = mkTerm "inglorious_A" ;
lin ingoing_A = mkTerm "ingoing_A" ;
lin ingot_N = mkTerm "ingot_N" ;
lin ingraft_V2 = mkTerm "ingraft_V2" ;
lin ingrained_A = mkTerm "ingrained_A" ;
lin ingrate_N = mkTerm "ingrate_N" ;
lin ingratiate_V2 = mkTerm "ingratiate_V2" ;
lin ingratiating_A = mkTerm "ingratiating_A" ;
lin ingratiation_N = mkTerm "ingratiation_N" ;
lin ingratitude_N = mkTerm "ingratitude_N" ;
lin ingredient_N = mkTerm "ingredient_N" ;
lin ingress_N = mkTerm "ingress_N" ;
lin ingrid_PN = mkTerm "ingrid_PN" ;
lin ingrowing_A = mkTerm "ingrowing_A" ;
lin ingrowth_N = mkTerm "ingrowth_N" ;
lin inguinal_A = mkTerm "inguinal_A" ;
lin ingå_PN = mkTerm "ingå_PN" ;
lin inhabit_V2 = mkTerm "inhabit_V2" ;
lin inhabitable_A = mkTerm "inhabitable_A" ;
lin inhabitancy_N = mkTerm "inhabitancy_N" ;
lin inhabitant_N = mkTerm "inhabitant_N" ;
lin inhalant_A = mkTerm "inhalant_A" ;
lin inhalant_N = mkTerm "inhalant_N" ;
lin inhalation_N = mkTerm "inhalation_N" ;
lin inhale_V = mkTerm "inhale_V" ;
lin inhale_V2 = mkTerm "inhale_V2" ;
lin inhaler_N = mkTerm "inhaler_N" ;
lin inharmonious_A = mkTerm "inharmonious_A" ;
lin inherence_N = mkTerm "inherence_N" ;
lin inherent_A = mkTerm "inherent_A" ;
lin inherit_V = mkTerm "inherit_V" ;
lin inherit_V2 = mkTerm "inherit_V2" ;
lin inheritable_A = mkTerm "inheritable_A" ;
lin inheritance_N = mkTerm "inheritance_N" ;
lin inheritorFem_N = mkTerm "inheritorFem_N" ;
lin inheritorMasc_N = mkTerm "inheritorMasc_N" ;
lin inhibit_V2 = mkTerm "inhibit_V2" ;
lin inhibition_N = mkTerm "inhibition_N" ;
lin inhibitor_N = mkTerm "inhibitor_N" ;
lin inhibitory_A = mkTerm "inhibitory_A" ;
lin inhomogeneity_N = mkTerm "inhomogeneity_N" ;
lin inhomogeneous_A = mkTerm "inhomogeneous_A" ;
lin inhospitable_A = mkTerm "inhospitable_A" ;
lin inhospitableness_N = mkTerm "inhospitableness_N" ;
lin inhospitality_N = mkTerm "inhospitality_N" ;
lin inhuman_A = mkTerm "inhuman_A" ;
lin inhumane_A = mkTerm "inhumane_A" ;
lin inhumaneness_N = mkTerm "inhumaneness_N" ;
lin inhumanity_N = mkTerm "inhumanity_N" ;
lin inimical_A = mkTerm "inimical_A" ;
lin inimitable_A = mkTerm "inimitable_A" ;
lin inion_N = mkTerm "inion_N" ;
lin iniquitous_A = mkTerm "iniquitous_A" ;
lin iniquity_N = mkTerm "iniquity_N" ;
lin initial_A = mkTerm "initial_A" ;
lin initial_N = mkTerm "initial_N" ;
lin initial_V2 = mkTerm "initial_V2" ;
lin initiate_A = mkTerm "initiate_A" ;
lin initiate_N = mkTerm "initiate_N" ;
lin initiate_V2 = mkTerm "initiate_V2" ;
lin initiation_N = mkTerm "initiation_N" ;
lin initiative_N = mkTerm "initiative_N" ;
lin iniö_PN = mkTerm "iniö_PN" ;
lin inject_V2 = mkTerm "inject_V2" ;
lin injectable_A = mkTerm "injectable_A" ;
lin injection_N = mkTerm "injection_N" ;
lin injector_N = mkTerm "injector_N" ;
lin injudicious_A = mkTerm "injudicious_A" ;
lin injudiciousness_N = mkTerm "injudiciousness_N" ;
lin injunction_N = mkTerm "injunction_N" ;
lin injure_V2 = mkTerm "injure_V2" ;
lin injured_A = mkTerm "injured_A" ;
lin injurious_A = mkTerm "injurious_A" ;
lin injury_N = mkTerm "injury_N" ;
lin injustice_N = mkTerm "injustice_N" ;
lin ink_N = mkTerm "ink_N" ;
lin ink_V2 = mkTerm "ink_V2" ;
lin ink_bottle_N = mkTerm "ink_bottle_N" ;
lin ink_pad_N = mkTerm "ink_pad_N" ;
lin ink_pot_N = mkTerm "ink_pot_N" ;
lin inkberry_N = mkTerm "inkberry_N" ;
lin inkblot_N = mkTerm "inkblot_N" ;
lin inkle_N = mkTerm "inkle_N" ;
lin inkling_N = mkTerm "inkling_N" ;
lin inkstand_N = mkTerm "inkstand_N" ;
lin inkwell_N = mkTerm "inkwell_N" ;
lin inky_A = mkTerm "inky_A" ;
lin inland_A = mkTerm "inland_A" ;
lin inland_Adv = mkTerm "inland_Adv" ;
lin inlay_N = mkTerm "inlay_N" ;
lin inlay_V2 = mkTerm "inlay_V2" ;
lin inlet_N = mkTerm "inlet_N" ;
lin inline_A = mkTerm "inline_A" ;
lin inmate_N = mkTerm "inmate_N" ;
lin inmost_A = mkTerm "inmost_A" ;
lin inn_N = mkTerm "inn_N" ;
lin innate_A = mkTerm "innate_A" ;
lin innateness_N = mkTerm "innateness_N" ;
lin inner_A = mkTerm "inner_A" ;
lin innermost_A = mkTerm "innermost_A" ;
lin innervation_N = mkTerm "innervation_N" ;
lin inning_N = mkTerm "inning_N" ;
lin innings_N = mkTerm "innings_N" ;
lin innkeeper_N = mkTerm "innkeeper_N" ;
lin innocence_N = mkTerm "innocence_N" ;
lin innocency_N = mkTerm "innocency_N" ;
lin innocent_A = mkTerm "innocent_A" ;
lin innocent_N = mkTerm "innocent_N" ;
lin innocuous_A = mkTerm "innocuous_A" ;
lin innovate_V = mkTerm "innovate_V" ;
lin innovate_V2 = mkTerm "innovate_V2" ;
lin innovation_N = mkTerm "innovation_N" ;
lin innovative_A = mkTerm "innovative_A" ;
lin innovativeness_N = mkTerm "innovativeness_N" ;
lin innovator_N = mkTerm "innovator_N" ;
lin innoxious_A = mkTerm "innoxious_A" ;
lin innsbruck_PN = mkTerm "innsbruck_PN" ;
lin innuendo_N = mkTerm "innuendo_N" ;
lin innumerable_A = mkTerm "innumerable_A" ;
lin innumerableness_N = mkTerm "innumerableness_N" ;
lin innumerate_A = mkTerm "innumerate_A" ;
lin inoculant_N = mkTerm "inoculant_N" ;
lin inoculate_V2 = mkTerm "inoculate_V2" ;
lin inoculating_N = mkTerm "inoculating_N" ;
lin inoculation_N = mkTerm "inoculation_N" ;
lin inoculator_N = mkTerm "inoculator_N" ;
lin inoffensive_A = mkTerm "inoffensive_A" ;
lin inoperable_A = mkTerm "inoperable_A" ;
lin inoperative_A = mkTerm "inoperative_A" ;
lin inopportune_A = mkTerm "inopportune_A" ;
lin inopportuneness_N = mkTerm "inopportuneness_N" ;
lin inordinate_A = mkTerm "inordinate_A" ;
lin inorganic_A = mkTerm "inorganic_A" ;
lin inosine_N = mkTerm "inosine_N" ;
lin inositol_N = mkTerm "inositol_N" ;
lin inpouring_A = mkTerm "inpouring_A" ;
lin inpouring_N = mkTerm "inpouring_N" ;
lin input_N = mkTerm "input_N" ;
lin inquest_N = mkTerm "inquest_N" ;
lin inquietude_N = mkTerm "inquietude_N" ;
lin inquire_V = mkTerm "inquire_V" ;
lin inquire_V2 = mkTerm "inquire_V2" ;
lin inquirer_N = mkTerm "inquirer_N" ;
lin inquiringly_Adv = mkTerm "inquiringly_Adv" ;
lin inquiry_N = mkTerm "inquiry_N" ;
lin inquisition_N = mkTerm "inquisition_N" ;
lin inquisitive_A = mkTerm "inquisitive_A" ;
lin inquisitiveness_N = mkTerm "inquisitiveness_N" ;
lin inquisitor_N = mkTerm "inquisitor_N" ;
lin inquisitorial_A = mkTerm "inquisitorial_A" ;
lin inquisitory_A = mkTerm "inquisitory_A" ;
lin inroad_N = mkTerm "inroad_N" ;
lin inrush_N = mkTerm "inrush_N" ;
lin insalubrious_A = mkTerm "insalubrious_A" ;
lin insalubrity_N = mkTerm "insalubrity_N" ;
lin insane_A = mkTerm "insane_A" ;
lin insanitary_A = mkTerm "insanitary_A" ;
lin insanity_N = mkTerm "insanity_N" ;
lin insatiable_A = mkTerm "insatiable_A" ;
lin insatiate_A = mkTerm "insatiate_A" ;
lin inscribe_V2 = mkTerm "inscribe_V2" ;
lin inscription_N = mkTerm "inscription_N" ;
lin inscriptive_A = mkTerm "inscriptive_A" ;
lin inscrutability_N = mkTerm "inscrutability_N" ;
lin inscrutable_A = mkTerm "inscrutable_A" ;
lin insect_N = mkTerm "insect_N" ;
lin insect_powder_N = mkTerm "insect_powder_N" ;
lin insectan_A = mkTerm "insectan_A" ;
lin insecticidal_A = mkTerm "insecticidal_A" ;
lin insecticide_N = mkTerm "insecticide_N" ;
lin insectifuge_N = mkTerm "insectifuge_N" ;
lin insectivore_N = mkTerm "insectivore_N" ;
lin insectivorous_A = mkTerm "insectivorous_A" ;
lin insecure_A = mkTerm "insecure_A" ;
lin insecureness_N = mkTerm "insecureness_N" ;
lin insecurity_N = mkTerm "insecurity_N" ;
lin inseminate_V2 = mkTerm "inseminate_V2" ;
lin insemination_N = mkTerm "insemination_N" ;
lin insensate_A = mkTerm "insensate_A" ;
lin insensibility_N = mkTerm "insensibility_N" ;
lin insensible_A = mkTerm "insensible_A" ;
lin insensitive_A = mkTerm "insensitive_A" ;
lin insensitivity_N = mkTerm "insensitivity_N" ;
lin insentience_N = mkTerm "insentience_N" ;
lin insentient_A = mkTerm "insentient_A" ;
lin inseparable_A = mkTerm "inseparable_A" ;
lin insert_N = mkTerm "insert_N" ;
lin insert_V2 = mkTerm "insert_V2" ;
lin insertion_N = mkTerm "insertion_N" ;
lin inset_N = mkTerm "inset_N" ;
lin inset_V2 = mkTerm "inset_V2" ;
lin inshore_A = mkTerm "inshore_A" ;
lin inshore_Adv = mkTerm "inshore_Adv" ;
lin inside_A = mkTerm "inside_A" ;
lin inside_Adv = mkTerm "inside_Adv" ;
lin inside_N = mkTerm "inside_N" ;
lin inside_Prep = mkTerm "inside_Prep" ;
lin inside_of_Prep = mkTerm "inside_of_Prep" ;
lin insider_N = mkTerm "insider_N" ;
lin insidious_A = mkTerm "insidious_A" ;
lin insidiousness_N = mkTerm "insidiousness_N" ;
lin insight_N = mkTerm "insight_N" ;
lin insightful_A = mkTerm "insightful_A" ;
lin insightfulness_N = mkTerm "insightfulness_N" ;
lin insigne_N = mkTerm "insigne_N" ;
lin insignia_N = mkTerm "insignia_N" ;
lin insignificance_N = mkTerm "insignificance_N" ;
lin insignificant_A = mkTerm "insignificant_A" ;
lin insincere_A = mkTerm "insincere_A" ;
lin insincerity_N = mkTerm "insincerity_N" ;
lin insinuate_V2 = mkTerm "insinuate_V2" ;
lin insinuatingly_Adv = mkTerm "insinuatingly_Adv" ;
lin insinuation_N = mkTerm "insinuation_N" ;
lin insipid_A = mkTerm "insipid_A" ;
lin insipidity_N = mkTerm "insipidity_N" ;
lin insipidness_N = mkTerm "insipidness_N" ;
lin insist_V = mkTerm "insist_V" ;
lin insist_V2 = mkTerm "insist_V2" ;
lin insist_VS = mkTerm "insist_VS" ;
lin insistence_N = mkTerm "insistence_N" ;
lin insistent_A = mkTerm "insistent_A" ;
lin insofar_Adv = mkTerm "insofar_Adv" ;
lin insolation_N = mkTerm "insolation_N" ;
lin insole_N = mkTerm "insole_N" ;
lin insolence_N = mkTerm "insolence_N" ;
lin insolent_A = mkTerm "insolent_A" ;
lin insolubility_N = mkTerm "insolubility_N" ;
lin insoluble_A = mkTerm "insoluble_A" ;
lin insolvable_A = mkTerm "insolvable_A" ;
lin insolvency_N = mkTerm "insolvency_N" ;
lin insolvent_A = mkTerm "insolvent_A" ;
lin insolvent_N = mkTerm "insolvent_N" ;
lin insomnia_N = mkTerm "insomnia_N" ;
lin insomniac_A = mkTerm "insomniac_A" ;
lin insomniac_N = mkTerm "insomniac_N" ;
lin insomuch_Adv = mkTerm "insomuch_Adv" ;
lin insouciance_N = mkTerm "insouciance_N" ;
lin insouciant_A = mkTerm "insouciant_A" ;
lin inspan_V2 = mkTerm "inspan_V2" ;
lin inspect_V2 = mkTerm "inspect_V2" ;
lin inspection_N = mkTerm "inspection_N" ;
lin inspector_N = mkTerm "inspector_N" ;
lin inspectorate_N = mkTerm "inspectorate_N" ;
lin inspectorship_N = mkTerm "inspectorship_N" ;
lin inspiration_N = mkTerm "inspiration_N" ;
lin inspirational_A = mkTerm "inspirational_A" ;
lin inspiratory_A = mkTerm "inspiratory_A" ;
lin inspire_V2 = mkTerm "inspire_V2" ;
lin inspire_V2V = mkTerm "inspire_V2V" ;
lin inspiring_A = mkTerm "inspiring_A" ;
lin inspissation_N = mkTerm "inspissation_N" ;
lin inst_PN = mkTerm "inst_PN" ;
lin instability_N = mkTerm "instability_N" ;
lin instal_V = mkTerm "instal_V" ;
lin install_V = mkTerm "install_V" ;
lin install_V2 = mkTerm "install_V2" ;
lin installation_N = mkTerm "installation_N" ;
lin installment_N = mkTerm "installment_N" ;
lin instalment_N = mkTerm "instalment_N" ;
lin instance_N = mkTerm "instance_N" ;
lin instance_V2 = mkTerm "instance_V2" ;
lin instant_A = mkTerm "instant_A" ;
lin instant_N = mkTerm "instant_N" ;
lin instantaneous_A = mkTerm "instantaneous_A" ;
lin instantiation_N = mkTerm "instantiation_N" ;
lin instar_N = mkTerm "instar_N" ;
lin instead_Adv = mkTerm "instead_Adv" ;
lin instead_of_Prep = mkTerm "instead_of_Prep" ;
lin instep_N = mkTerm "instep_N" ;
lin instigate_V2 = mkTerm "instigate_V2" ;
lin instigation_N = mkTerm "instigation_N" ;
lin instigator_N = mkTerm "instigator_N" ;
lin instil_V2 = mkTerm "instil_V2" ;
lin instillation_N = mkTerm "instillation_N" ;
lin instillator_N = mkTerm "instillator_N" ;
lin instinct_A = mkTerm "instinct_A" ;
lin instinct_N = mkTerm "instinct_N" ;
lin instinctive_A = mkTerm "instinctive_A" ;
lin institute_N = mkTerm "institute_N" ;
lin institute_V2 = mkTerm "institute_V2" ;
lin institution_N = mkTerm "institution_N" ;
lin institutional_A = mkTerm "institutional_A" ;
lin institutionalization_N = mkTerm "institutionalization_N" ;
lin institutionalize_V2 = mkTerm "institutionalize_V2" ;
lin instroke_N = mkTerm "instroke_N" ;
lin instruct_V2 = mkTerm "instruct_V2" ;
lin instruction_N = mkTerm "instruction_N" ;
lin instructional_A = mkTerm "instructional_A" ;
lin instructive_A = mkTerm "instructive_A" ;
lin instructor_N = mkTerm "instructor_N" ;
lin instructorship_N = mkTerm "instructorship_N" ;
lin instructress_N = mkTerm "instructress_N" ;
lin instrument_N = mkTerm "instrument_N" ;
lin instrumental_A = mkTerm "instrumental_A" ;
lin instrumentalism_N = mkTerm "instrumentalism_N" ;
lin instrumentalist_N = mkTerm "instrumentalist_N" ;
lin instrumentality_N = mkTerm "instrumentality_N" ;
lin instrumentation_N = mkTerm "instrumentation_N" ;
lin insubordinate_A = mkTerm "insubordinate_A" ;
lin insubordination_N = mkTerm "insubordination_N" ;
lin insubstantial_A = mkTerm "insubstantial_A" ;
lin insubstantiality_N = mkTerm "insubstantiality_N" ;
lin insufferable_A = mkTerm "insufferable_A" ;
lin insufficiency_N = mkTerm "insufficiency_N" ;
lin insufficient_A = mkTerm "insufficient_A" ;
lin insufflation_N = mkTerm "insufflation_N" ;
lin insular_A = mkTerm "insular_A" ;
lin insularism_N = mkTerm "insularism_N" ;
lin insularity_N = mkTerm "insularity_N" ;
lin insulate_V2 = mkTerm "insulate_V2" ;
lin insulation_N = mkTerm "insulation_N" ;
lin insulator_N = mkTerm "insulator_N" ;
lin insulin_N = mkTerm "insulin_N" ;
lin insult_N = mkTerm "insult_N" ;
lin insult_V2 = mkTerm "insult_V2" ;
lin insulting_A = mkTerm "insulting_A" ;
lin insuperable_A = mkTerm "insuperable_A" ;
lin insupportable_A = mkTerm "insupportable_A" ;
lin insurability_N = mkTerm "insurability_N" ;
lin insurable_A = mkTerm "insurable_A" ;
lin insurance_N = mkTerm "insurance_N" ;
lin insure_V = mkTerm "insure_V" ;
lin insure_V2 = mkTerm "insure_V2" ;
lin insure_VS = mkTerm "insure_VS" ;
lin insured_N = mkTerm "insured_N" ;
lin insurgency_N = mkTerm "insurgency_N" ;
lin insurgent_A = mkTerm "insurgent_A" ;
lin insurgent_N = mkTerm "insurgent_N" ;
lin insurmountable_A = mkTerm "insurmountable_A" ;
lin insurrection_N = mkTerm "insurrection_N" ;
lin insurrectional_A = mkTerm "insurrectional_A" ;
lin insurrectionism_N = mkTerm "insurrectionism_N" ;
lin intact_A = mkTerm "intact_A" ;
lin intactness_N = mkTerm "intactness_N" ;
lin intaglio_N = mkTerm "intaglio_N" ;
lin intake_N = mkTerm "intake_N" ;
lin intangibility_N = mkTerm "intangibility_N" ;
lin intangible_A = mkTerm "intangible_A" ;
lin intangible_N = mkTerm "intangible_N" ;
lin intangibles_N = mkTerm "intangibles_N" ;
lin integer_N = mkTerm "integer_N" ;
lin integral_A = mkTerm "integral_A" ;
lin integral_N = mkTerm "integral_N" ;
lin integrate_V = mkTerm "integrate_V" ;
lin integrate_V2 = mkTerm "integrate_V2" ;
lin integrated_A = mkTerm "integrated_A" ;
lin integration_N = mkTerm "integration_N" ;
lin integrative_A = mkTerm "integrative_A" ;
lin integrator_N = mkTerm "integrator_N" ;
lin integrity_N = mkTerm "integrity_N" ;
lin integument_N = mkTerm "integument_N" ;
lin integumentary_A = mkTerm "integumentary_A" ;
lin intellect_N = mkTerm "intellect_N" ;
lin intellectual_A = mkTerm "intellectual_A" ;
lin intellectual_N = mkTerm "intellectual_N" ;
lin intellectualization_N = mkTerm "intellectualization_N" ;
lin intelligence_1_N = mkTerm "intelligence_1_N" ;
lin intelligence_2_N = mkTerm "intelligence_2_N" ;
lin intelligent_A = mkTerm "intelligent_A" ;
lin intelligentsia_N = mkTerm "intelligentsia_N" ;
lin intelligibility_N = mkTerm "intelligibility_N" ;
lin intelligible_A = mkTerm "intelligible_A" ;
lin intemperance_N = mkTerm "intemperance_N" ;
lin intemperate_A = mkTerm "intemperate_A" ;
lin intend_VV = mkTerm "intend_VV" ;
lin intended_A = mkTerm "intended_A" ;
lin intense_A = mkTerm "intense_A" ;
lin intensification_N = mkTerm "intensification_N" ;
lin intensifier_N = mkTerm "intensifier_N" ;
lin intensify_V = mkTerm "intensify_V" ;
lin intensify_V2 = mkTerm "intensify_V2" ;
lin intension_N = mkTerm "intension_N" ;
lin intensional_A = mkTerm "intensional_A" ;
lin intensity_N = mkTerm "intensity_N" ;
lin intensive_A = mkTerm "intensive_A" ;
lin intent_A = mkTerm "intent_A" ;
lin intent_N = mkTerm "intent_N" ;
lin intention_N = mkTerm "intention_N" ;
lin intentional_A = mkTerm "intentional_A" ;
lin intentionality_N = mkTerm "intentionality_N" ;
lin intentness_N = mkTerm "intentness_N" ;
lin inter_V2 = mkTerm "inter_V2" ;
lin inter_alia_Adv = mkTerm "inter_alia_Adv" ;
lin interact_V = mkTerm "interact_V" ;
lin interaction_N = mkTerm "interaction_N" ;
lin interactional_A = mkTerm "interactional_A" ;
lin interactive_A = mkTerm "interactive_A" ;
lin interbreed_V = mkTerm "interbreed_V" ;
lin interbreed_V2 = mkTerm "interbreed_V2" ;
lin intercalary_A = mkTerm "intercalary_A" ;
lin intercede_V = mkTerm "intercede_V" ;
lin intercellular_A = mkTerm "intercellular_A" ;
lin intercept_N = mkTerm "intercept_N" ;
lin intercept_V2 = mkTerm "intercept_V2" ;
lin interception_N = mkTerm "interception_N" ;
lin interceptor_N = mkTerm "interceptor_N" ;
lin intercession_N = mkTerm "intercession_N" ;
lin interchange_N = mkTerm "interchange_N" ;
lin interchange_V2 = mkTerm "interchange_V2" ;
lin interchangeable_A = mkTerm "interchangeable_A" ;
lin interchurch_A = mkTerm "interchurch_A" ;
lin intercollegiate_A = mkTerm "intercollegiate_A" ;
lin intercom_N = mkTerm "intercom_N" ;
lin intercommunicate_V = mkTerm "intercommunicate_V" ;
lin intercommunication_N = mkTerm "intercommunication_N" ;
lin intercommunion_N = mkTerm "intercommunion_N" ;
lin interconnect_V = mkTerm "interconnect_V" ;
lin interconnect_V2 = mkTerm "interconnect_V2" ;
lin interconnectedness_N = mkTerm "interconnectedness_N" ;
lin interconnection_N = mkTerm "interconnection_N" ;
lin intercontinental_A = mkTerm "intercontinental_A" ;
lin intercostal_A = mkTerm "intercostal_A" ;
lin intercostal_N = mkTerm "intercostal_N" ;
lin intercourse_N = mkTerm "intercourse_N" ;
lin interdenominational_A = mkTerm "interdenominational_A" ;
lin interdepartmental_A = mkTerm "interdepartmental_A" ;
lin interdepartmental_Adv = mkTerm "interdepartmental_Adv" ;
lin interdependence_N = mkTerm "interdependence_N" ;
lin interdependent_A = mkTerm "interdependent_A" ;
lin interdict_N = mkTerm "interdict_N" ;
lin interdict_V2 = mkTerm "interdict_V2" ;
lin interdiction_N = mkTerm "interdiction_N" ;
lin interdisciplinary_A = mkTerm "interdisciplinary_A" ;
lin interest_1_N = mkTerm "interest_1_N" ;
lin interest_2_N = mkTerm "interest_2_N" ;
lin interest_V = mkTerm "interest_V" ;
lin interest_V2 = mkTerm "interest_V2" ;
lin interested_A = mkTerm "interested_A" ;
lin interestedness_N = mkTerm "interestedness_N" ;
lin interesting_A = mkTerm "interesting_A" ;
lin interface_N = mkTerm "interface_N" ;
lin interfacial_A = mkTerm "interfacial_A" ;
lin interfaith_A = mkTerm "interfaith_A" ;
lin interfere_V = mkTerm "interfere_V" ;
lin interference_N = mkTerm "interference_N" ;
lin interferometer_N = mkTerm "interferometer_N" ;
lin interferon_N = mkTerm "interferon_N" ;
lin intergalactic_A = mkTerm "intergalactic_A" ;
lin interim_A = mkTerm "interim_A" ;
lin interim_N = mkTerm "interim_N" ;
lin interior_A = mkTerm "interior_A" ;
lin interior_N = mkTerm "interior_N" ;
lin interject_V2 = mkTerm "interject_V2" ;
lin interjection_N = mkTerm "interjection_N" ;
lin interlace_V = mkTerm "interlace_V" ;
lin interlace_V2 = mkTerm "interlace_V2" ;
lin interlard_V2 = mkTerm "interlard_V2" ;
lin interlayer_N = mkTerm "interlayer_N" ;
lin interleaf_N = mkTerm "interleaf_N" ;
lin interleave_V2 = mkTerm "interleave_V2" ;
lin interleukin_N = mkTerm "interleukin_N" ;
lin interlinear_A = mkTerm "interlinear_A" ;
lin interlink_V = mkTerm "interlink_V" ;
lin interlink_V2 = mkTerm "interlink_V2" ;
lin interlobular_A = mkTerm "interlobular_A" ;
lin interlock_N = mkTerm "interlock_N" ;
lin interlock_V = mkTerm "interlock_V" ;
lin interlock_V2 = mkTerm "interlock_V2" ;
lin interlocutor_N = mkTerm "interlocutor_N" ;
lin interlocutory_A = mkTerm "interlocutory_A" ;
lin interloper_N = mkTerm "interloper_N" ;
lin interlude_N = mkTerm "interlude_N" ;
lin intermarriage_N = mkTerm "intermarriage_N" ;
lin intermarry_V = mkTerm "intermarry_V" ;
lin intermediary_N = mkTerm "intermediary_N" ;
lin intermediate_A = mkTerm "intermediate_A" ;
lin intermediate_N = mkTerm "intermediate_N" ;
lin interment_N = mkTerm "interment_N" ;
lin intermezzo_N = mkTerm "intermezzo_N" ;
lin interminable_A = mkTerm "interminable_A" ;
lin intermingle_V = mkTerm "intermingle_V" ;
lin intermingle_V2 = mkTerm "intermingle_V2" ;
lin intermission_N = mkTerm "intermission_N" ;
lin intermittence_N = mkTerm "intermittence_N" ;
lin intermittent_A = mkTerm "intermittent_A" ;
lin intermix_V = mkTerm "intermix_V" ;
lin intermix_V2 = mkTerm "intermix_V2" ;
lin intermixture_N = mkTerm "intermixture_N" ;
lin intermolecular_A = mkTerm "intermolecular_A" ;
lin intermural_A = mkTerm "intermural_A" ;
lin intern_N = mkTerm "intern_N" ;
lin intern_V2 = mkTerm "intern_V2" ;
lin internal_A = mkTerm "internal_A" ;
lin internal_N = mkTerm "internal_N" ;
lin internalization_N = mkTerm "internalization_N" ;
lin internalize_V2 = mkTerm "internalize_V2" ;
lin international_A = mkTerm "international_A" ;
lin international_N = mkTerm "international_N" ;
lin internationale_N = mkTerm "internationale_N" ;
lin internationalism_N = mkTerm "internationalism_N" ;
lin internationalist_A = mkTerm "internationalist_A" ;
lin internationalist_N = mkTerm "internationalist_N" ;
lin internationality_N = mkTerm "internationality_N" ;
lin internationalization_N = mkTerm "internationalization_N" ;
lin internationalize_V2 = mkTerm "internationalize_V2" ;
lin interne_N = mkTerm "interne_N" ;
lin internecine_A = mkTerm "internecine_A" ;
lin internee_N = mkTerm "internee_N" ;
lin internet_N = mkTerm "internet_N" ;
lin internist_N = mkTerm "internist_N" ;
lin internment_N = mkTerm "internment_N" ;
lin internode_N = mkTerm "internode_N" ;
lin internship_N = mkTerm "internship_N" ;
lin internuncio_N = mkTerm "internuncio_N" ;
lin interoception_N = mkTerm "interoception_N" ;
lin interoceptive_A = mkTerm "interoceptive_A" ;
lin interoceptor_N = mkTerm "interoceptor_N" ;
lin interoperability_N = mkTerm "interoperability_N" ;
lin interoperable_A = mkTerm "interoperable_A" ;
lin interpellate_V2 = mkTerm "interpellate_V2" ;
lin interpellation_N = mkTerm "interpellation_N" ;
lin interpenetration_N = mkTerm "interpenetration_N" ;
lin interpersonal_A = mkTerm "interpersonal_A" ;
lin interphone_N = mkTerm "interphone_N" ;
lin interplanetary_A = mkTerm "interplanetary_A" ;
lin interplay_N = mkTerm "interplay_N" ;
lin interpol_PN = mkTerm "interpol_PN" ;
lin interpolate_V2 = mkTerm "interpolate_V2" ;
lin interpolation_N = mkTerm "interpolation_N" ;
lin interpose_V = mkTerm "interpose_V" ;
lin interpose_V2 = mkTerm "interpose_V2" ;
lin interposition_N = mkTerm "interposition_N" ;
lin interpret_V = mkTerm "interpret_V" ;
lin interpret_V2 = mkTerm "interpret_V2" ;
lin interpretation_N = mkTerm "interpretation_N" ;
lin interpretative_A = mkTerm "interpretative_A" ;
lin interpreter_N = mkTerm "interpreter_N" ;
lin interracial_A = mkTerm "interracial_A" ;
lin interreflection_N = mkTerm "interreflection_N" ;
lin interregnum_N = mkTerm "interregnum_N" ;
lin interrelate_V = mkTerm "interrelate_V" ;
lin interrelate_V2 = mkTerm "interrelate_V2" ;
lin interrelation_N = mkTerm "interrelation_N" ;
lin interrelationship_N = mkTerm "interrelationship_N" ;
lin interrogate_V2 = mkTerm "interrogate_V2" ;
lin interrogation_N = mkTerm "interrogation_N" ;
lin interrogative_A = mkTerm "interrogative_A" ;
lin interrogative_N = mkTerm "interrogative_N" ;
lin interrogator_N = mkTerm "interrogator_N" ;
lin interrogatory_A = mkTerm "interrogatory_A" ;
lin interrupt_N = mkTerm "interrupt_N" ;
lin interrupt_V = mkTerm "interrupt_V" ;
lin interrupt_V2 = mkTerm "interrupt_V2" ;
lin interrupter_N = mkTerm "interrupter_N" ;
lin interruption_N = mkTerm "interruption_N" ;
lin interscholastic_A = mkTerm "interscholastic_A" ;
lin intersect_V = mkTerm "intersect_V" ;
lin intersect_V2 = mkTerm "intersect_V2" ;
lin intersection_N = mkTerm "intersection_N" ;
lin intersexual_A = mkTerm "intersexual_A" ;
lin interspecies_A = mkTerm "interspecies_A" ;
lin intersperse_V2 = mkTerm "intersperse_V2" ;
lin interspersion_N = mkTerm "interspersion_N" ;
lin interstate_A = mkTerm "interstate_A" ;
lin interstate_N = mkTerm "interstate_N" ;
lin interstellar_A = mkTerm "interstellar_A" ;
lin interstice_N = mkTerm "interstice_N" ;
lin interstitial_A = mkTerm "interstitial_A" ;
lin intertidal_A = mkTerm "intertidal_A" ;
lin intertribal_A = mkTerm "intertribal_A" ;
lin intertrigo_N = mkTerm "intertrigo_N" ;
lin intertwine_V = mkTerm "intertwine_V" ;
lin intertwine_V2 = mkTerm "intertwine_V2" ;
lin interval_N = mkTerm "interval_N" ;
lin intervene_V = mkTerm "intervene_V" ;
lin intervene_V2V = mkTerm "intervene_V2V" ;
lin intervenor_N = mkTerm "intervenor_N" ;
lin intervention_N = mkTerm "intervention_N" ;
lin intervertebral_A = mkTerm "intervertebral_A" ;
lin interview_N = mkTerm "interview_N" ;
lin interview_V2 = mkTerm "interview_V2" ;
lin interviewee_N = mkTerm "interviewee_N" ;
lin interviewer_N = mkTerm "interviewer_N" ;
lin interweave_V2 = mkTerm "interweave_V2" ;
lin intestacy_N = mkTerm "intestacy_N" ;
lin intestate_A = mkTerm "intestate_A" ;
lin intestinal_A = mkTerm "intestinal_A" ;
lin intestine_N = mkTerm "intestine_N" ;
lin inti_N = mkTerm "inti_N" ;
lin intifada_N = mkTerm "intifada_N" ;
lin intima_N = mkTerm "intima_N" ;
lin intimacy_N = mkTerm "intimacy_N" ;
lin intimal_A = mkTerm "intimal_A" ;
lin intimate_A = mkTerm "intimate_A" ;
lin intimate_N = mkTerm "intimate_N" ;
lin intimate_V2 = mkTerm "intimate_V2" ;
lin intimation_N = mkTerm "intimation_N" ;
lin intimidate_V2 = mkTerm "intimidate_V2" ;
lin intimidation_N = mkTerm "intimidation_N" ;
lin into_Prep = mkTerm "into_Prep" ;
lin intolerable_A = mkTerm "intolerable_A" ;
lin intolerance_N = mkTerm "intolerance_N" ;
lin intolerant_A = mkTerm "intolerant_A" ;
lin intonation_N = mkTerm "intonation_N" ;
lin intone_V = mkTerm "intone_V" ;
lin intone_V2 = mkTerm "intone_V2" ;
lin intoxicant_A = mkTerm "intoxicant_A" ;
lin intoxicant_N = mkTerm "intoxicant_N" ;
lin intoxicate_V2 = mkTerm "intoxicate_V2" ;
lin intoxication_N = mkTerm "intoxication_N" ;
lin intra_uterine_A = mkTerm "intra_uterine_A" ;
lin intracellular_A = mkTerm "intracellular_A" ;
lin intracerebral_A = mkTerm "intracerebral_A" ;
lin intracranial_A = mkTerm "intracranial_A" ;
lin intractability_N = mkTerm "intractability_N" ;
lin intractable_A = mkTerm "intractable_A" ;
lin intradepartmental_A = mkTerm "intradepartmental_A" ;
lin intradermal_A = mkTerm "intradermal_A" ;
lin intrados_N = mkTerm "intrados_N" ;
lin intralinguistic_A = mkTerm "intralinguistic_A" ;
lin intralobular_A = mkTerm "intralobular_A" ;
lin intramolecular_A = mkTerm "intramolecular_A" ;
lin intramural_A = mkTerm "intramural_A" ;
lin intramuscular_A = mkTerm "intramuscular_A" ;
lin intranet_N = mkTerm "intranet_N" ;
lin intransigence_N = mkTerm "intransigence_N" ;
lin intransigency_N = mkTerm "intransigency_N" ;
lin intransigent_A = mkTerm "intransigent_A" ;
lin intransitive_A = mkTerm "intransitive_A" ;
lin intransitivity_N = mkTerm "intransitivity_N" ;
lin intrapulmonary_A = mkTerm "intrapulmonary_A" ;
lin intrasentential_A = mkTerm "intrasentential_A" ;
lin intraspecies_A = mkTerm "intraspecies_A" ;
lin intrastate_A = mkTerm "intrastate_A" ;
lin intravasation_N = mkTerm "intravasation_N" ;
lin intravenous_A = mkTerm "intravenous_A" ;
lin intraventricular_A = mkTerm "intraventricular_A" ;
lin intrench_V2 = mkTerm "intrench_V2" ;
lin intrepid_A = mkTerm "intrepid_A" ;
lin intrepidity_N = mkTerm "intrepidity_N" ;
lin intricacy_N = mkTerm "intricacy_N" ;
lin intricate_A = mkTerm "intricate_A" ;
lin intrigue_N = mkTerm "intrigue_N" ;
lin intrigue_V = mkTerm "intrigue_V" ;
lin intrigue_V2 = mkTerm "intrigue_V2" ;
lin intrinsic_A = mkTerm "intrinsic_A" ;
lin intro_N = mkTerm "intro_N" ;
lin introduce_V2 = mkTerm "introduce_V2" ;
lin introduction_N = mkTerm "introduction_N" ;
lin introductory_A = mkTerm "introductory_A" ;
lin introit_N = mkTerm "introit_N" ;
lin introitus_N = mkTerm "introitus_N" ;
lin introject_N = mkTerm "introject_N" ;
lin introjected_A = mkTerm "introjected_A" ;
lin introjection_N = mkTerm "introjection_N" ;
lin intron_N = mkTerm "intron_N" ;
lin introspect_V = mkTerm "introspect_V" ;
lin introspection_N = mkTerm "introspection_N" ;
lin introspective_A = mkTerm "introspective_A" ;
lin introspectiveness_N = mkTerm "introspectiveness_N" ;
lin introuvable_A = mkTerm "introuvable_A" ;
lin introversion_N = mkTerm "introversion_N" ;
lin introversive_A = mkTerm "introversive_A" ;
lin introvert_N = mkTerm "introvert_N" ;
lin introvert_V2 = mkTerm "introvert_V2" ;
lin introvertish_A = mkTerm "introvertish_A" ;
lin intrude_V = mkTerm "intrude_V" ;
lin intrude_V2 = mkTerm "intrude_V2" ;
lin intruder_N = mkTerm "intruder_N" ;
lin intrusion_N = mkTerm "intrusion_N" ;
lin intrusive_A = mkTerm "intrusive_A" ;
lin intrusiveness_N = mkTerm "intrusiveness_N" ;
lin intrust_V2 = mkTerm "intrust_V2" ;
lin intuit_V = mkTerm "intuit_V" ;
lin intuit_V2 = mkTerm "intuit_V2" ;
lin intuition_N = mkTerm "intuition_N" ;
lin intuitionism_N = mkTerm "intuitionism_N" ;
lin intuitionist_A = mkTerm "intuitionist_A" ;
lin intuitive_A = mkTerm "intuitive_A" ;
lin intumescence_N = mkTerm "intumescence_N" ;
lin intussusception_N = mkTerm "intussusception_N" ;
lin inula_N = mkTerm "inula_N" ;
lin inulin_N = mkTerm "inulin_N" ;
lin inundate_V2 = mkTerm "inundate_V2" ;
lin inundation_N = mkTerm "inundation_N" ;
lin inure_V2 = mkTerm "inure_V2" ;
lin inutile_A = mkTerm "inutile_A" ;
lin inutility_N = mkTerm "inutility_N" ;
lin invade_V2 = mkTerm "invade_V2" ;
lin invader_N = mkTerm "invader_N" ;
lin invagination_N = mkTerm "invagination_N" ;
lin invalid_A = mkTerm "invalid_A" ;
lin invalid_N = mkTerm "invalid_N" ;
lin invalid_V2 = mkTerm "invalid_V2" ;
lin invalidate_V2 = mkTerm "invalidate_V2" ;
lin invalidation_N = mkTerm "invalidation_N" ;
lin invalidator_N = mkTerm "invalidator_N" ;
lin invalidism_N = mkTerm "invalidism_N" ;
lin invalidity_N = mkTerm "invalidity_N" ;
lin invaluable_A = mkTerm "invaluable_A" ;
lin invaluableness_N = mkTerm "invaluableness_N" ;
lin invariability_N = mkTerm "invariability_N" ;
lin invariable_A = mkTerm "invariable_A" ;
lin invariance_N = mkTerm "invariance_N" ;
lin invariant_A = mkTerm "invariant_A" ;
lin invariant_N = mkTerm "invariant_N" ;
lin invasion_N = mkTerm "invasion_N" ;
lin invasive_A = mkTerm "invasive_A" ;
lin invective_N = mkTerm "invective_N" ;
lin inveigh_V = mkTerm "inveigh_V" ;
lin inveigle_V2 = mkTerm "inveigle_V2" ;
lin invent_V = mkTerm "invent_V" ;
lin invent_V2 = mkTerm "invent_V2" ;
lin invention_N = mkTerm "invention_N" ;
lin inventive_A = mkTerm "inventive_A" ;
lin inventiveness_N = mkTerm "inventiveness_N" ;
lin inventor_N = mkTerm "inventor_N" ;
lin inventory_N = mkTerm "inventory_N" ;
lin inverkeithing_PN = mkTerm "inverkeithing_PN" ;
lin inverness_PN = mkTerm "inverness_PN" ;
lin inverse_A = mkTerm "inverse_A" ;
lin inverse_N = mkTerm "inverse_N" ;
lin inversion_N = mkTerm "inversion_N" ;
lin invert_V2 = mkTerm "invert_V2" ;
lin invertase_N = mkTerm "invertase_N" ;
lin invertebrate_A = mkTerm "invertebrate_A" ;
lin invertebrate_N = mkTerm "invertebrate_N" ;
lin inverter_N = mkTerm "inverter_N" ;
lin invertible_A = mkTerm "invertible_A" ;
lin inverurie_PN = mkTerm "inverurie_PN" ;
lin invest_V = mkTerm "invest_V" ;
lin invest_V2 = mkTerm "invest_V2" ;
lin investigate_V = mkTerm "investigate_V" ;
lin investigate_V2 = mkTerm "investigate_V2" ;
lin investigation_N = mkTerm "investigation_N" ;
lin investigative_A = mkTerm "investigative_A" ;
lin investigator_N = mkTerm "investigator_N" ;
lin investing_N = mkTerm "investing_N" ;
lin investiture_N = mkTerm "investiture_N" ;
lin investment_N = mkTerm "investment_N" ;
lin investor_N = mkTerm "investor_N" ;
lin inveterate_A = mkTerm "inveterate_A" ;
lin invidious_A = mkTerm "invidious_A" ;
lin invigilate_V = mkTerm "invigilate_V" ;
lin invigilation_N = mkTerm "invigilation_N" ;
lin invigilator_N = mkTerm "invigilator_N" ;
lin invigorate_V2 = mkTerm "invigorate_V2" ;
lin invigorating_A = mkTerm "invigorating_A" ;
lin invincibility_N = mkTerm "invincibility_N" ;
lin invincible_A = mkTerm "invincible_A" ;
lin inviolable_A = mkTerm "inviolable_A" ;
lin inviolate_A = mkTerm "inviolate_A" ;
lin invisibility_N = mkTerm "invisibility_N" ;
lin invisible_A = mkTerm "invisible_A" ;
lin invitation_N = mkTerm "invitation_N" ;
lin invitational_A = mkTerm "invitational_A" ;
lin invitatory_A = mkTerm "invitatory_A" ;
lin invite_N = mkTerm "invite_N" ;
lin invite_V2 = mkTerm "invite_V2" ;
lin invite_V2V = mkTerm "invite_V2V" ;
lin invite_in_V = mkTerm "invite_in_V" ;
lin invocation_N = mkTerm "invocation_N" ;
lin invoice_N = mkTerm "invoice_N" ;
lin invoice_V2 = mkTerm "invoice_V2" ;
lin invoke_V2 = mkTerm "invoke_V2" ;
lin involucrate_A = mkTerm "involucrate_A" ;
lin involucre_N = mkTerm "involucre_N" ;
lin involuntary_A = mkTerm "involuntary_A" ;
lin involute_A = mkTerm "involute_A" ;
lin involution_N = mkTerm "involution_N" ;
lin involve_V = mkTerm "involve_V" ;
lin involve_V2 = mkTerm "involve_V2" ;
lin involve_VS = mkTerm "involve_VS" ;
lin involved_A = mkTerm "involved_A" ;
lin involvement_N = mkTerm "involvement_N" ;
lin invulnerability_N = mkTerm "invulnerability_N" ;
lin invulnerable_A = mkTerm "invulnerable_A" ;
lin inward_A = mkTerm "inward_A" ;
lin inward_Adv = mkTerm "inward_Adv" ;
lin inwardness_N = mkTerm "inwardness_N" ;
lin inwards_Adv = mkTerm "inwards_Adv" ;
lin inwrought_A = mkTerm "inwrought_A" ;
lin iodide_N = mkTerm "iodide_N" ;
lin iodinated_A = mkTerm "iodinated_A" ;
lin iodinating_A = mkTerm "iodinating_A" ;
lin iodination_N = mkTerm "iodination_N" ;
lin iodine_N = mkTerm "iodine_N" ;
lin iodochlorhydroxyquin_N = mkTerm "iodochlorhydroxyquin_N" ;
lin iodocompound_N = mkTerm "iodocompound_N" ;
lin iodoform_N = mkTerm "iodoform_N" ;
lin iodoprotein_N = mkTerm "iodoprotein_N" ;
lin iodopsin_N = mkTerm "iodopsin_N" ;
lin iodothyronine_N = mkTerm "iodothyronine_N" ;
lin iodotyrosine_N = mkTerm "iodotyrosine_N" ;
lin ion_N = mkTerm "ion_N" ;
lin ionic_A = mkTerm "ionic_A" ;
lin ionization_N = mkTerm "ionization_N" ;
lin ionize_V = mkTerm "ionize_V" ;
lin ionize_V2 = mkTerm "ionize_V2" ;
lin ionosphere_N = mkTerm "ionosphere_N" ;
lin iontophoresis_N = mkTerm "iontophoresis_N" ;
lin iota_N = mkTerm "iota_N" ;
lin iou_N = mkTerm "iou_N" ;
lin iowa_PN = mkTerm "iowa_PN" ;
lin ipecac_N = mkTerm "ipecac_N" ;
lin ipod_N = mkTerm "ipod_N" ;
lin iproclozide_N = mkTerm "iproclozide_N" ;
lin ipse_dixit_N = mkTerm "ipse_dixit_N" ;
lin ipsilateral_A = mkTerm "ipsilateral_A" ;
lin ipso_facto_Adv = mkTerm "ipso_facto_Adv" ;
lin ipswich_PN = mkTerm "ipswich_PN" ;
lin iq_N = mkTerm "iq_N" ;
lin ira_N = mkTerm "ira_N" ;
lin iran_PN = mkTerm "iran_PN" ;
lin iranianFem_N = mkTerm "iranianFem_N" ;
lin iranianMasc_N = mkTerm "iranianMasc_N" ;
lin iranian_A = mkTerm "iranian_A" ;
lin iraq_PN = mkTerm "iraq_PN" ;
lin iraqi_A = mkTerm "iraqi_A" ;
lin iraqi_N = mkTerm "iraqi_N" ;
lin irascibility_N = mkTerm "irascibility_N" ;
lin irascible_A = mkTerm "irascible_A" ;
lin irate_A = mkTerm "irate_A" ;
lin ire_N = mkTerm "ire_N" ;
lin ireful_A = mkTerm "ireful_A" ;
lin ireland_PN = mkTerm "ireland_PN" ;
lin irene_PN = mkTerm "irene_PN" ;
lin irenic_A = mkTerm "irenic_A" ;
lin iridaceous_A = mkTerm "iridaceous_A" ;
lin iridectomy_N = mkTerm "iridectomy_N" ;
lin iridescence_N = mkTerm "iridescence_N" ;
lin iridescent_A = mkTerm "iridescent_A" ;
lin iridic_A = mkTerm "iridic_A" ;
lin iridium_N = mkTerm "iridium_N" ;
lin iridocyclitis_N = mkTerm "iridocyclitis_N" ;
lin iridokeratitis_N = mkTerm "iridokeratitis_N" ;
lin iridoncus_N = mkTerm "iridoncus_N" ;
lin iridotomy_N = mkTerm "iridotomy_N" ;
lin iris_N = mkTerm "iris_N" ;
lin iris_PN = mkTerm "iris_PN" ;
lin irishFem_N = mkTerm "irishFem_N" ;
lin irishMasc_N = mkTerm "irishMasc_N" ;
lin irish_A = mkTerm "irish_A" ;
lin irishman_N = mkTerm "irishman_N" ;
lin irishwoman_N = mkTerm "irishwoman_N" ;
lin iritic_A = mkTerm "iritic_A" ;
lin iritis_N = mkTerm "iritis_N" ;
lin irk_V2 = mkTerm "irk_V2" ;
lin irksome_A = mkTerm "irksome_A" ;
lin iron_N = mkTerm "iron_N" ;
lin iron_V = mkTerm "iron_V" ;
lin iron_V2 = mkTerm "iron_V2" ;
lin iron_foundry_N = mkTerm "iron_foundry_N" ;
lin iron_grey_A = mkTerm "iron_grey_A" ;
lin iron_grey_N = mkTerm "iron_grey_N" ;
lin iron_out_V = mkTerm "iron_out_V" ;
lin iron_out_V2 = mkTerm "iron_out_V2" ;
lin ironclad_A = mkTerm "ironclad_A" ;
lin ironclad_N = mkTerm "ironclad_N" ;
lin ironic_A = mkTerm "ironic_A" ;
lin ironical_A = mkTerm "ironical_A" ;
lin ironing_N = mkTerm "ironing_N" ;
lin ironing_board_N = mkTerm "ironing_board_N" ;
lin ironlike_A = mkTerm "ironlike_A" ;
lin ironmonger_N = mkTerm "ironmonger_N" ;
lin ironmongery_N = mkTerm "ironmongery_N" ;
lin ironmould_N = mkTerm "ironmould_N" ;
lin irons_N = mkTerm "irons_N" ;
lin ironshod_A = mkTerm "ironshod_A" ;
lin ironside_N = mkTerm "ironside_N" ;
lin ironware_N = mkTerm "ironware_N" ;
lin ironweed_N = mkTerm "ironweed_N" ;
lin ironwood_N = mkTerm "ironwood_N" ;
lin ironwork_N = mkTerm "ironwork_N" ;
lin ironworker_N = mkTerm "ironworker_N" ;
lin ironworks_N = mkTerm "ironworks_N" ;
lin irony_N = mkTerm "irony_N" ;
lin irradiate_V2 = mkTerm "irradiate_V2" ;
lin irradiation_N = mkTerm "irradiation_N" ;
lin irrational_A = mkTerm "irrational_A" ;
lin irrationality_N = mkTerm "irrationality_N" ;
lin irreclaimable_A = mkTerm "irreclaimable_A" ;
lin irreconcilable_A = mkTerm "irreconcilable_A" ;
lin irrecoverable_A = mkTerm "irrecoverable_A" ;
lin irredeemable_A = mkTerm "irredeemable_A" ;
lin irredenta_N = mkTerm "irredenta_N" ;
lin irredentism_N = mkTerm "irredentism_N" ;
lin irredentist_N = mkTerm "irredentist_N" ;
lin irreducible_A = mkTerm "irreducible_A" ;
lin irrefutable_A = mkTerm "irrefutable_A" ;
lin irregardless_Adv = mkTerm "irregardless_Adv" ;
lin irregular_A = mkTerm "irregular_A" ;
lin irregular_N = mkTerm "irregular_N" ;
lin irregularity_N = mkTerm "irregularity_N" ;
lin irrelevance_N = mkTerm "irrelevance_N" ;
lin irrelevancy_N = mkTerm "irrelevancy_N" ;
lin irrelevant_A = mkTerm "irrelevant_A" ;
lin irreligionist_N = mkTerm "irreligionist_N" ;
lin irreligious_A = mkTerm "irreligious_A" ;
lin irreligiousness_N = mkTerm "irreligiousness_N" ;
lin irremediable_A = mkTerm "irremediable_A" ;
lin irremovable_A = mkTerm "irremovable_A" ;
lin irreparable_A = mkTerm "irreparable_A" ;
lin irreplaceable_A = mkTerm "irreplaceable_A" ;
lin irreplaceableness_N = mkTerm "irreplaceableness_N" ;
lin irrepressibility_N = mkTerm "irrepressibility_N" ;
lin irrepressible_A = mkTerm "irrepressible_A" ;
lin irreproachable_A = mkTerm "irreproachable_A" ;
lin irreproducibility_N = mkTerm "irreproducibility_N" ;
lin irresistibility_N = mkTerm "irresistibility_N" ;
lin irresistible_A = mkTerm "irresistible_A" ;
lin irresolute_A = mkTerm "irresolute_A" ;
lin irresoluteness_N = mkTerm "irresoluteness_N" ;
lin irresolution_N = mkTerm "irresolution_N" ;
lin irrespective_A = mkTerm "irrespective_A" ;
lin irresponsibility_N = mkTerm "irresponsibility_N" ;
lin irresponsible_A = mkTerm "irresponsible_A" ;
lin irretrievable_A = mkTerm "irretrievable_A" ;
lin irreverence_N = mkTerm "irreverence_N" ;
lin irreverent_A = mkTerm "irreverent_A" ;
lin irreversibility_N = mkTerm "irreversibility_N" ;
lin irreversible_A = mkTerm "irreversible_A" ;
lin irrevocable_A = mkTerm "irrevocable_A" ;
lin irridentism_N = mkTerm "irridentism_N" ;
lin irrigate_V2 = mkTerm "irrigate_V2" ;
lin irrigation_N = mkTerm "irrigation_N" ;
lin irritability_N = mkTerm "irritability_N" ;
lin irritable_A = mkTerm "irritable_A" ;
lin irritant_A = mkTerm "irritant_A" ;
lin irritant_N = mkTerm "irritant_N" ;
lin irritate_V2 = mkTerm "irritate_V2" ;
lin irritating_A = mkTerm "irritating_A" ;
lin irritation_N = mkTerm "irritation_N" ;
lin irruption_N = mkTerm "irruption_N" ;
lin irruptive_A = mkTerm "irruptive_A" ;
lin irthlingborough_PN = mkTerm "irthlingborough_PN" ;
lin irvine_PN = mkTerm "irvine_PN" ;
lin isaac_PN = mkTerm "isaac_PN" ;
lin isabel_PN = mkTerm "isabel_PN" ;
lin isabella_PN = mkTerm "isabella_PN" ;
lin ischemia_N = mkTerm "ischemia_N" ;
lin ischemic_A = mkTerm "ischemic_A" ;
lin ischium_N = mkTerm "ischium_N" ;
lin isentropic_A = mkTerm "isentropic_A" ;
lin isinglass_N = mkTerm "isinglass_N" ;
lin islam_N = mkTerm "islam_N" ;
lin islamic_A = mkTerm "islamic_A" ;
lin island_N = mkTerm "island_N" ;
lin islander_N = mkTerm "islander_N" ;
lin isle_N = mkTerm "isle_N" ;
lin islet_N = mkTerm "islet_N" ;
lin islington_PN = mkTerm "islington_PN" ;
lin ism_N = mkTerm "ism_N" ;
lin isoagglutination_N = mkTerm "isoagglutination_N" ;
lin isoagglutinin_N = mkTerm "isoagglutinin_N" ;
lin isoagglutinogen_N = mkTerm "isoagglutinogen_N" ;
lin isoantibody_N = mkTerm "isoantibody_N" ;
lin isobar_N = mkTerm "isobar_N" ;
lin isobel_PN = mkTerm "isobel_PN" ;
lin isobutylene_N = mkTerm "isobutylene_N" ;
lin isocarboxazid_N = mkTerm "isocarboxazid_N" ;
lin isochronal_A = mkTerm "isochronal_A" ;
lin isochrone_N = mkTerm "isochrone_N" ;
lin isoclinal_A = mkTerm "isoclinal_A" ;
lin isocyanate_N = mkTerm "isocyanate_N" ;
lin isoflurane_N = mkTerm "isoflurane_N" ;
lin isogamete_N = mkTerm "isogamete_N" ;
lin isogamy_N = mkTerm "isogamy_N" ;
lin isogon_N = mkTerm "isogon_N" ;
lin isogonic_A = mkTerm "isogonic_A" ;
lin isogram_N = mkTerm "isogram_N" ;
lin isohel_N = mkTerm "isohel_N" ;
lin isojoki_PN = mkTerm "isojoki_PN" ;
lin isokyrö_PN = mkTerm "isokyrö_PN" ;
lin isolable_A = mkTerm "isolable_A" ;
lin isolate_V2 = mkTerm "isolate_V2" ;
lin isolated_A = mkTerm "isolated_A" ;
lin isolation_N = mkTerm "isolation_N" ;
lin isolationism_N = mkTerm "isolationism_N" ;
lin isolationist_A = mkTerm "isolationist_A" ;
lin isolationist_N = mkTerm "isolationist_N" ;
lin isoleucine_N = mkTerm "isoleucine_N" ;
lin isomer_N = mkTerm "isomer_N" ;
lin isomerase_N = mkTerm "isomerase_N" ;
lin isomeric_A = mkTerm "isomeric_A" ;
lin isomerism_N = mkTerm "isomerism_N" ;
lin isomerization_N = mkTerm "isomerization_N" ;
lin isometric_A = mkTerm "isometric_A" ;
lin isometrics_N = mkTerm "isometrics_N" ;
lin isometropia_N = mkTerm "isometropia_N" ;
lin isometry_N = mkTerm "isometry_N" ;
lin isomorphic_A = mkTerm "isomorphic_A" ;
lin isomorphism_N = mkTerm "isomorphism_N" ;
lin isomorphous_A = mkTerm "isomorphous_A" ;
lin isoniazid_N = mkTerm "isoniazid_N" ;
lin isopod_N = mkTerm "isopod_N" ;
lin isoproterenol_N = mkTerm "isoproterenol_N" ;
lin isopteran_A = mkTerm "isopteran_A" ;
lin isosceles_A = mkTerm "isosceles_A" ;
lin isosorbide_N = mkTerm "isosorbide_N" ;
lin isostasy_N = mkTerm "isostasy_N" ;
lin isotherm_N = mkTerm "isotherm_N" ;
lin isothermal_A = mkTerm "isothermal_A" ;
lin isothermic_A = mkTerm "isothermic_A" ;
lin isothiocyanate_N = mkTerm "isothiocyanate_N" ;
lin isotonic_A = mkTerm "isotonic_A" ;
lin isotope_N = mkTerm "isotope_N" ;
lin isotopic_A = mkTerm "isotopic_A" ;
lin isotropic_A = mkTerm "isotropic_A" ;
lin isotropy_N = mkTerm "isotropy_N" ;
lin israel_PN = mkTerm "israel_PN" ;
lin israeli_A = mkTerm "israeli_A" ;
lin israeli_N = mkTerm "israeli_N" ;
lin issue_1_N = mkTerm "issue_1_N" ;
lin issue_2_N = mkTerm "issue_2_N" ;
lin issue_V = mkTerm "issue_V" ;
lin issue_V2 = mkTerm "issue_V2" ;
lin issue_forth_V = mkTerm "issue_forth_V" ;
lin issuer_N = mkTerm "issuer_N" ;
lin istanbul_PN = mkTerm "istanbul_PN" ;
lin isthmian_A = mkTerm "isthmian_A" ;
lin isthmus_N = mkTerm "isthmus_N" ;
lin italianFem_N = mkTerm "italianFem_N" ;
lin italianMasc_N = mkTerm "italianMasc_N" ;
lin italian_A = mkTerm "italian_A" ;
lin italic_A = mkTerm "italic_A" ;
lin italic_N = mkTerm "italic_N" ;
lin italicize_V2 = mkTerm "italicize_V2" ;
lin italy_PN = mkTerm "italy_PN" ;
lin itch_N = mkTerm "itch_N" ;
lin itch_V = mkTerm "itch_V" ;
lin itchy_A = mkTerm "itchy_A" ;
lin item_Adv = mkTerm "item_Adv" ;
lin item_N = mkTerm "item_N" ;
lin itemize_V2 = mkTerm "itemize_V2" ;
lin iterate_V2 = mkTerm "iterate_V2" ;
lin iteration_N = mkTerm "iteration_N" ;
lin iterative_A = mkTerm "iterative_A" ;
lin iterative_N = mkTerm "iterative_N" ;
lin itinerant_A = mkTerm "itinerant_A" ;
lin itinerant_N = mkTerm "itinerant_N" ;
lin itinerary_N = mkTerm "itinerary_N" ;
lin itineration_N = mkTerm "itineration_N" ;
lin itraconazole_N = mkTerm "itraconazole_N" ;
lin itv_N = mkTerm "itv_N" ;
lin iud_N = mkTerm "iud_N" ;
lin ivalo_PN = mkTerm "ivalo_PN" ;
lin ivan_PN = mkTerm "ivan_PN" ;
lin iver_PN = mkTerm "iver_PN" ;
lin ivied_A = mkTerm "ivied_A" ;
lin ivor_PN = mkTerm "ivor_PN" ;
lin ivory_N = mkTerm "ivory_N" ;
lin ivorybill_N = mkTerm "ivorybill_N" ;
lin ivy_N = mkTerm "ivy_N" ;
lin ivy_PN = mkTerm "ivy_PN" ;
lin izar_N = mkTerm "izar_N" ;
lin izmir_PN = mkTerm "izmir_PN" ;
lin jaala_PN = mkTerm "jaala_PN" ;
lin jab_N = mkTerm "jab_N" ;
lin jab_V = mkTerm "jab_V" ;
lin jab_V2 = mkTerm "jab_V2" ;
lin jabalpur_PN = mkTerm "jabalpur_PN" ;
lin jabber_N = mkTerm "jabber_N" ;
lin jabber_V = mkTerm "jabber_V" ;
lin jabber_V2 = mkTerm "jabber_V2" ;
lin jabber_away_V = mkTerm "jabber_away_V" ;
lin jabberer_N = mkTerm "jabberer_N" ;
lin jabberwocky_N = mkTerm "jabberwocky_N" ;
lin jabiru_N = mkTerm "jabiru_N" ;
lin jabot_N = mkTerm "jabot_N" ;
lin jaboticaba_N = mkTerm "jaboticaba_N" ;
lin jacamar_N = mkTerm "jacamar_N" ;
lin jack_N = mkTerm "jack_N" ;
lin jack_PN = mkTerm "jack_PN" ;
lin jack_V2 = mkTerm "jack_V2" ;
lin jack_around_V2 = mkTerm "jack_around_V2" ;
lin jack_in_V2 = mkTerm "jack_in_V2" ;
lin jack_in_the_box_N = mkTerm "jack_in_the_box_N" ;
lin jack_knife_N = mkTerm "jack_knife_N" ;
lin jack_knife_V = mkTerm "jack_knife_V" ;
lin jack_o'_lantern_N = mkTerm "jack_o'_lantern_N" ;
lin jack_plane_N = mkTerm "jack_plane_N" ;
lin jack_up_V = mkTerm "jack_up_V" ;
lin jack_up_V2 = mkTerm "jack_up_V2" ;
lin jackal_N = mkTerm "jackal_N" ;
lin jackanapes_N = mkTerm "jackanapes_N" ;
lin jackass_N = mkTerm "jackass_N" ;
lin jackboot_N = mkTerm "jackboot_N" ;
lin jackdaw_N = mkTerm "jackdaw_N" ;
lin jacket_N = mkTerm "jacket_N" ;
lin jackfruit_N = mkTerm "jackfruit_N" ;
lin jackie_PN = mkTerm "jackie_PN" ;
lin jacklight_N = mkTerm "jacklight_N" ;
lin jackpot_N = mkTerm "jackpot_N" ;
lin jackrabbit_N = mkTerm "jackrabbit_N" ;
lin jacks_N = mkTerm "jacks_N" ;
lin jackscrew_N = mkTerm "jackscrew_N" ;
lin jacksmelt_N = mkTerm "jacksmelt_N" ;
lin jacksnipe_N = mkTerm "jacksnipe_N" ;
lin jacksonville_PN = mkTerm "jacksonville_PN" ;
lin jackstraw_N = mkTerm "jackstraw_N" ;
lin jackstraws_N = mkTerm "jackstraws_N" ;
lin jacob_PN = mkTerm "jacob_PN" ;
lin jacobean_A = mkTerm "jacobean_A" ;
lin jacobin_A = mkTerm "jacobin_A" ;
lin jacobin_N = mkTerm "jacobin_N" ;
lin jacobinism_N = mkTerm "jacobinism_N" ;
lin jacobite_N = mkTerm "jacobite_N" ;
lin jaconet_N = mkTerm "jaconet_N" ;
lin jacquard_N = mkTerm "jacquard_N" ;
lin jacqueline_PN = mkTerm "jacqueline_PN" ;
lin jactitation_N = mkTerm "jactitation_N" ;
lin jade_A = mkTerm "jade_A" ;
lin jade_N = mkTerm "jade_N" ;
lin jaded_A = mkTerm "jaded_A" ;
lin jadeite_N = mkTerm "jadeite_N" ;
lin jaeger_N = mkTerm "jaeger_N" ;
lin jag_N = mkTerm "jag_N" ;
lin jag_V2 = mkTerm "jag_V2" ;
lin jaggedness_N = mkTerm "jaggedness_N" ;
lin jaggery_N = mkTerm "jaggery_N" ;
lin jaggy_A = mkTerm "jaggy_A" ;
lin jaguar_N = mkTerm "jaguar_N" ;
lin jaguarundi_N = mkTerm "jaguarundi_N" ;
lin jail_N = mkTerm "jail_N" ;
lin jail_V2 = mkTerm "jail_V2" ;
lin jailer_N = mkTerm "jailer_N" ;
lin jailor_N = mkTerm "jailor_N" ;
lin jaipur_PN = mkTerm "jaipur_PN" ;
lin jakarta_PN = mkTerm "jakarta_PN" ;
lin jake_N = mkTerm "jake_N" ;
lin jake_PN = mkTerm "jake_PN" ;
lin jakes_N = mkTerm "jakes_N" ;
lin jakobstad_PN = mkTerm "jakobstad_PN" ;
lin jalapeno_N = mkTerm "jalapeno_N" ;
lin jalasjärvi_PN = mkTerm "jalasjärvi_PN" ;
lin jalopy_N = mkTerm "jalopy_N" ;
lin jalousie_N = mkTerm "jalousie_N" ;
lin jam_N = mkTerm "jam_N" ;
lin jam_V = mkTerm "jam_V" ;
lin jam_V2 = mkTerm "jam_V2" ;
lin jam_VS = mkTerm "jam_VS" ;
lin jam_on_V2 = mkTerm "jam_on_V2" ;
lin jamaica_PN = mkTerm "jamaica_PN" ;
lin jamaican_A = mkTerm "jamaican_A" ;
lin jamaican_N = mkTerm "jamaican_N" ;
lin jamb_N = mkTerm "jamb_N" ;
lin jambalaya_N = mkTerm "jambalaya_N" ;
lin jamboree_N = mkTerm "jamboree_N" ;
lin james_PN = mkTerm "james_PN" ;
lin jamjar_N = mkTerm "jamjar_N" ;
lin jammer_N = mkTerm "jammer_N" ;
lin jamming_N = mkTerm "jamming_N" ;
lin jampack_V2 = mkTerm "jampack_V2" ;
lin jampan_N = mkTerm "jampan_N" ;
lin jampot_N = mkTerm "jampot_N" ;
lin jan_PN = mkTerm "jan_PN" ;
lin janakkala_PN = mkTerm "janakkala_PN" ;
lin jane_PN = mkTerm "jane_PN" ;
lin janet_PN = mkTerm "janet_PN" ;
lin jangle_N = mkTerm "jangle_N" ;
lin jangle_V = mkTerm "jangle_V" ;
lin jangle_V2 = mkTerm "jangle_V2" ;
lin janice_PN = mkTerm "janice_PN" ;
lin janie_PN = mkTerm "janie_PN" ;
lin janissary_N = mkTerm "janissary_N" ;
lin janitor_N = mkTerm "janitor_N" ;
lin janus_PN = mkTerm "janus_PN" ;
lin japan_N = mkTerm "japan_N" ;
lin japan_PN = mkTerm "japan_PN" ;
lin japan_V2 = mkTerm "japan_V2" ;
lin japaneseFem_N = mkTerm "japaneseFem_N" ;
lin japaneseMasc_N = mkTerm "japaneseMasc_N" ;
lin japanese_A = mkTerm "japanese_A" ;
lin jape_N = mkTerm "jape_N" ;
lin japonica_N = mkTerm "japonica_N" ;
lin jar_N = mkTerm "jar_N" ;
lin jar_V = mkTerm "jar_V" ;
lin jar_V2 = mkTerm "jar_V2" ;
lin jarful_N = mkTerm "jarful_N" ;
lin jargon_N = mkTerm "jargon_N" ;
lin jargoon_N = mkTerm "jargoon_N" ;
lin jarringly_Adv = mkTerm "jarringly_Adv" ;
lin jarrow_PN = mkTerm "jarrow_PN" ;
lin jasmine_N = mkTerm "jasmine_N" ;
lin jason_PN = mkTerm "jason_PN" ;
lin jasper_N = mkTerm "jasper_N" ;
lin jassid_N = mkTerm "jassid_N" ;
lin jati_N = mkTerm "jati_N" ;
lin jaundice_N = mkTerm "jaundice_N" ;
lin jaundice_V2 = mkTerm "jaundice_V2" ;
lin jaunt_N = mkTerm "jaunt_N" ;
lin jaunt_V = mkTerm "jaunt_V" ;
lin jauntiness_N = mkTerm "jauntiness_N" ;
lin jaunting_car_N = mkTerm "jaunting_car_N" ;
lin jaunty_A = mkTerm "jaunty_A" ;
lin java_N = mkTerm "java_N" ;
lin java_PN = mkTerm "java_PN" ;
lin javanese_A = mkTerm "javanese_A" ;
lin javanese_N = mkTerm "javanese_N" ;
lin javelin_N = mkTerm "javelin_N" ;
lin jaw_N = mkTerm "jaw_N" ;
lin jaw_V = mkTerm "jaw_V" ;
lin jaw_away_V = mkTerm "jaw_away_V" ;
lin jawan_N = mkTerm "jawan_N" ;
lin jawbone_N = mkTerm "jawbone_N" ;
lin jawbreaker_N = mkTerm "jawbreaker_N" ;
lin jawed_A = mkTerm "jawed_A" ;
lin jawfish_N = mkTerm "jawfish_N" ;
lin jawless_A = mkTerm "jawless_A" ;
lin jay_N = mkTerm "jay_N" ;
lin jaywalk_V = mkTerm "jaywalk_V" ;
lin jaywalker_N = mkTerm "jaywalker_N" ;
lin jazz_N = mkTerm "jazz_N" ;
lin jazz_V2 = mkTerm "jazz_V2" ;
lin jazz_up_V2 = mkTerm "jazz_up_V2" ;
lin jazzy_A = mkTerm "jazzy_A" ;
lin jc_PN = mkTerm "jc_PN" ;
lin jealous_A = mkTerm "jealous_A" ;
lin jealousy_N = mkTerm "jealousy_N" ;
lin jean_N = mkTerm "jean_N" ;
lin jean_PN = mkTerm "jean_PN" ;
lin jeanie_PN = mkTerm "jeanie_PN" ;
lin jeans_N = mkTerm "jeans_N" ;
lin jedburgh_PN = mkTerm "jedburgh_PN" ;
lin jeep_N = mkTerm "jeep_N" ;
lin jeer_N = mkTerm "jeer_N" ;
lin jeer_V = mkTerm "jeer_V" ;
lin jeer_V2 = mkTerm "jeer_V2" ;
lin jeeringly_Adv = mkTerm "jeeringly_Adv" ;
lin jeff_PN = mkTerm "jeff_PN" ;
lin jeffrey_PN = mkTerm "jeffrey_PN" ;
lin jehovah_PN = mkTerm "jehovah_PN" ;
lin jejune_A = mkTerm "jejune_A" ;
lin jejuneness_N = mkTerm "jejuneness_N" ;
lin jejunitis_N = mkTerm "jejunitis_N" ;
lin jejunity_N = mkTerm "jejunity_N" ;
lin jejunoileitis_N = mkTerm "jejunoileitis_N" ;
lin jejunostomy_N = mkTerm "jejunostomy_N" ;
lin jejunum_N = mkTerm "jejunum_N" ;
lin jekyll_and_hyde_PN = mkTerm "jekyll_and_hyde_PN" ;
lin jell_V = mkTerm "jell_V" ;
lin jell_V2 = mkTerm "jell_V2" ;
lin jellaba_N = mkTerm "jellaba_N" ;
lin jello_N = mkTerm "jello_N" ;
lin jelly_N = mkTerm "jelly_N" ;
lin jelly_V = mkTerm "jelly_V" ;
lin jelly_V2 = mkTerm "jelly_V2" ;
lin jellyfish_N = mkTerm "jellyfish_N" ;
lin jellyroll_N = mkTerm "jellyroll_N" ;
lin jemmy_N = mkTerm "jemmy_N" ;
lin jennet_N = mkTerm "jennet_N" ;
lin jennifer_PN = mkTerm "jennifer_PN" ;
lin jenny_N = mkTerm "jenny_N" ;
lin jenny_PN = mkTerm "jenny_PN" ;
lin jeopardize_V2 = mkTerm "jeopardize_V2" ;
lin jeopardy_N = mkTerm "jeopardy_N" ;
lin jerboa_N = mkTerm "jerboa_N" ;
lin jeremiad_N = mkTerm "jeremiad_N" ;
lin jeremy_PN = mkTerm "jeremy_PN" ;
lin jerk_N = mkTerm "jerk_N" ;
lin jerk_V = mkTerm "jerk_V" ;
lin jerk_V2 = mkTerm "jerk_V2" ;
lin jerk_around_V = mkTerm "jerk_around_V" ;
lin jerk_around_V2 = mkTerm "jerk_around_V2" ;
lin jerk_off_V = mkTerm "jerk_off_V" ;
lin jerkin_N = mkTerm "jerkin_N" ;
lin jerkiness_N = mkTerm "jerkiness_N" ;
lin jerkwater_A = mkTerm "jerkwater_A" ;
lin jerky_A = mkTerm "jerky_A" ;
lin jerky_N = mkTerm "jerky_N" ;
lin jeroboam_N = mkTerm "jeroboam_N" ;
lin jerome_PN = mkTerm "jerome_PN" ;
lin jerry_N = mkTerm "jerry_N" ;
lin jerry_PN = mkTerm "jerry_PN" ;
lin jerry_builder_N = mkTerm "jerry_builder_N" ;
lin jerry_building_N = mkTerm "jerry_building_N" ;
lin jerry_built_A = mkTerm "jerry_built_A" ;
lin jersey_N = mkTerm "jersey_N" ;
lin jersey_PN = mkTerm "jersey_PN" ;
lin jess_PN = mkTerm "jess_PN" ;
lin jessica_PN = mkTerm "jessica_PN" ;
lin jessie_PN = mkTerm "jessie_PN" ;
lin jest_N = mkTerm "jest_N" ;
lin jest_V = mkTerm "jest_V" ;
lin jester_N = mkTerm "jester_N" ;
lin jesuit_N = mkTerm "jesuit_N" ;
lin jesuitical_A = mkTerm "jesuitical_A" ;
lin jesus_PN = mkTerm "jesus_PN" ;
lin jet_N = mkTerm "jet_N" ;
lin jet_V = mkTerm "jet_V" ;
lin jet_V2 = mkTerm "jet_V2" ;
lin jet_black_A = mkTerm "jet_black_A" ;
lin jet_off_V = mkTerm "jet_off_V" ;
lin jet_propelled_A = mkTerm "jet_propelled_A" ;
lin jetliner_N = mkTerm "jetliner_N" ;
lin jetsam_N = mkTerm "jetsam_N" ;
lin jettison_V2 = mkTerm "jettison_V2" ;
lin jetty_N = mkTerm "jetty_N" ;
lin jew_N = mkTerm "jew_N" ;
lin jewel_N = mkTerm "jewel_N" ;
lin jewel_V2 = mkTerm "jewel_V2" ;
lin jeweller_N = mkTerm "jeweller_N" ;
lin jewellery_N = mkTerm "jewellery_N" ;
lin jewelry_N = mkTerm "jewelry_N" ;
lin jewelweed_N = mkTerm "jewelweed_N" ;
lin jewess_N = mkTerm "jewess_N" ;
lin jewfish_N = mkTerm "jewfish_N" ;
lin jewish_A = mkTerm "jewish_A" ;
lin jezebel_N = mkTerm "jezebel_N" ;
lin jiao_N = mkTerm "jiao_N" ;
lin jib_N = mkTerm "jib_N" ;
lin jib_V = mkTerm "jib_V" ;
lin jib_boom_N = mkTerm "jib_boom_N" ;
lin jibe_N = mkTerm "jibe_N" ;
lin jibe_V = mkTerm "jibe_V" ;
lin jiffy_N = mkTerm "jiffy_N" ;
lin jig_N = mkTerm "jig_N" ;
lin jig_V = mkTerm "jig_V" ;
lin jig_V2 = mkTerm "jig_V2" ;
lin jigger_N = mkTerm "jigger_N" ;
lin jiggered_A = mkTerm "jiggered_A" ;
lin jiggermast_N = mkTerm "jiggermast_N" ;
lin jiggery_pokery_N = mkTerm "jiggery_pokery_N" ;
lin jiggle_N = mkTerm "jiggle_N" ;
lin jiggle_V = mkTerm "jiggle_V" ;
lin jiggle_V2 = mkTerm "jiggle_V2" ;
lin jigsaw_N = mkTerm "jigsaw_N" ;
lin jihad_N = mkTerm "jihad_N" ;
lin jihadi_A = mkTerm "jihadi_A" ;
lin jill_PN = mkTerm "jill_PN" ;
lin jilt_N = mkTerm "jilt_N" ;
lin jilt_V2 = mkTerm "jilt_V2" ;
lin jim_PN = mkTerm "jim_PN" ;
lin jim_crow_N = mkTerm "jim_crow_N" ;
lin jimdandy_N = mkTerm "jimdandy_N" ;
lin jimmies_N = mkTerm "jimmies_N" ;
lin jimmy_N = mkTerm "jimmy_N" ;
lin jimmy_PN = mkTerm "jimmy_PN" ;
lin jimsonweed_N = mkTerm "jimsonweed_N" ;
lin jingle_N = mkTerm "jingle_N" ;
lin jingle_V = mkTerm "jingle_V" ;
lin jingle_V2 = mkTerm "jingle_V2" ;
lin jingo_N = mkTerm "jingo_N" ;
lin jingoism_N = mkTerm "jingoism_N" ;
lin jingoist_N = mkTerm "jingoist_N" ;
lin jingoistic_A = mkTerm "jingoistic_A" ;
lin jinks_N = mkTerm "jinks_N" ;
lin jinn_N = mkTerm "jinn_N" ;
lin jinrikisha_N = mkTerm "jinrikisha_N" ;
lin jinx_N = mkTerm "jinx_N" ;
lin jiqui_N = mkTerm "jiqui_N" ;
lin jird_N = mkTerm "jird_N" ;
lin jitney_N = mkTerm "jitney_N" ;
lin jitter_N = mkTerm "jitter_N" ;
lin jitterbug_N = mkTerm "jitterbug_N" ;
lin jitteriness_N = mkTerm "jitteriness_N" ;
lin jittering_A = mkTerm "jittering_A" ;
lin jitters_N = mkTerm "jitters_N" ;
lin jittery_A = mkTerm "jittery_A" ;
lin jive_N = mkTerm "jive_N" ;
lin jive_V = mkTerm "jive_V" ;
lin jnr_PN = mkTerm "jnr_PN" ;
lin jo_PN = mkTerm "jo_PN" ;
lin joan_PN = mkTerm "joan_PN" ;
lin joanie_PN = mkTerm "joanie_PN" ;
lin joann_PN = mkTerm "joann_PN" ;
lin joanna_PN = mkTerm "joanna_PN" ;
lin joanne_PN = mkTerm "joanne_PN" ;
lin job_N = mkTerm "job_N" ;
lin job_PN = mkTerm "job_PN" ;
lin job_V = mkTerm "job_V" ;
lin job_V2 = mkTerm "job_V2" ;
lin jobber_N = mkTerm "jobber_N" ;
lin jobbery_N = mkTerm "jobbery_N" ;
lin jobcentre_N = mkTerm "jobcentre_N" ;
lin jobholder_N = mkTerm "jobholder_N" ;
lin jocelyn_PN = mkTerm "jocelyn_PN" ;
lin jockey_N = mkTerm "jockey_N" ;
lin jockey_V = mkTerm "jockey_V" ;
lin jockey_V2 = mkTerm "jockey_V2" ;
lin jocose_A = mkTerm "jocose_A" ;
lin jocoseness_N = mkTerm "jocoseness_N" ;
lin jocosity_N = mkTerm "jocosity_N" ;
lin jocular_A = mkTerm "jocular_A" ;
lin jocularity_N = mkTerm "jocularity_N" ;
lin jocund_A = mkTerm "jocund_A" ;
lin jocundity_N = mkTerm "jocundity_N" ;
lin jodhpur_N = mkTerm "jodhpur_N" ;
lin jodhpurs_N = mkTerm "jodhpurs_N" ;
lin joe_PN = mkTerm "joe_PN" ;
lin joensuu_PN = mkTerm "joensuu_PN" ;
lin joey_PN = mkTerm "joey_PN" ;
lin jog_N = mkTerm "jog_N" ;
lin jog_V = mkTerm "jog_V" ;
lin jog_V2 = mkTerm "jog_V2" ;
lin jog_trot_N = mkTerm "jog_trot_N" ;
lin jogger_N = mkTerm "jogger_N" ;
lin jogging_N = mkTerm "jogging_N" ;
lin joggle_N = mkTerm "joggle_N" ;
lin joggle_V = mkTerm "joggle_V" ;
lin joggle_V2 = mkTerm "joggle_V2" ;
lin johannesburg_PN = mkTerm "johannesburg_PN" ;
lin john_PN = mkTerm "john_PN" ;
lin john_bull_N = mkTerm "john_bull_N" ;
lin johnny_PN = mkTerm "johnny_PN" ;
lin johnnycake_N = mkTerm "johnnycake_N" ;
lin johnstone_PN = mkTerm "johnstone_PN" ;
lin joie_de_vivre_N = mkTerm "joie_de_vivre_N" ;
lin join_N = mkTerm "join_N" ;
lin join_V = mkTerm "join_V" ;
lin join_V2 = mkTerm "join_V2" ;
lin join_up_V = mkTerm "join_up_V" ;
lin joiner_N = mkTerm "joiner_N" ;
lin joinery_N = mkTerm "joinery_N" ;
lin joining_N = mkTerm "joining_N" ;
lin joint_A = mkTerm "joint_A" ;
lin joint_N = mkTerm "joint_N" ;
lin joint_V2 = mkTerm "joint_V2" ;
lin jointer_N = mkTerm "jointer_N" ;
lin jointure_N = mkTerm "jointure_N" ;
lin joist_N = mkTerm "joist_N" ;
lin joke_N = mkTerm "joke_N" ;
lin joke_V = mkTerm "joke_V" ;
lin joke_around_V = mkTerm "joke_around_V" ;
lin joker_N = mkTerm "joker_N" ;
lin jokingly_Adv = mkTerm "jokingly_Adv" ;
lin jokioinen_PN = mkTerm "jokioinen_PN" ;
lin jollification_N = mkTerm "jollification_N" ;
lin jollity_N = mkTerm "jollity_N" ;
lin jolly_A = mkTerm "jolly_A" ;
lin jolly_Adv = mkTerm "jolly_Adv" ;
lin jolly_N = mkTerm "jolly_N" ;
lin jolly_V2 = mkTerm "jolly_V2" ;
lin jollyboat_N = mkTerm "jollyboat_N" ;
lin jolt_N = mkTerm "jolt_N" ;
lin jolt_V = mkTerm "jolt_V" ;
lin jolt_V2 = mkTerm "jolt_V2" ;
lin jolty_A = mkTerm "jolty_A" ;
lin jonah_N = mkTerm "jonah_N" ;
lin jonah_PN = mkTerm "jonah_PN" ;
lin jonathan_PN = mkTerm "jonathan_PN" ;
lin jonquil_N = mkTerm "jonquil_N" ;
lin jordan_PN = mkTerm "jordan_PN" ;
lin jordanian_A = mkTerm "jordanian_A" ;
lin jordanian_N = mkTerm "jordanian_N" ;
lin joroinen_PN = mkTerm "joroinen_PN" ;
lin jorum_N = mkTerm "jorum_N" ;
lin joseph_PN = mkTerm "joseph_PN" ;
lin josephine_PN = mkTerm "josephine_PN" ;
lin josh_PN = mkTerm "josh_PN" ;
lin joshua_PN = mkTerm "joshua_PN" ;
lin joss_N = mkTerm "joss_N" ;
lin joss_house_N = mkTerm "joss_house_N" ;
lin joss_stick_N = mkTerm "joss_stick_N" ;
lin jostle_N = mkTerm "jostle_N" ;
lin jostle_V = mkTerm "jostle_V" ;
lin jostle_V2 = mkTerm "jostle_V2" ;
lin jot_N = mkTerm "jot_N" ;
lin jot_V2 = mkTerm "jot_V2" ;
lin jot_down_V2 = mkTerm "jot_down_V2" ;
lin jotter_N = mkTerm "jotter_N" ;
lin jotting_N = mkTerm "jotting_N" ;
lin joule_N = mkTerm "joule_N" ;
lin journal_N = mkTerm "journal_N" ;
lin journalese_N = mkTerm "journalese_N" ;
lin journalism_N = mkTerm "journalism_N" ;
lin journalist_N = mkTerm "journalist_N" ;
lin journalistic_A = mkTerm "journalistic_A" ;
lin journey_N = mkTerm "journey_N" ;
lin journey_V = mkTerm "journey_V" ;
lin journeyman_N = mkTerm "journeyman_N" ;
lin joust_N = mkTerm "joust_N" ;
lin joust_V = mkTerm "joust_V" ;
lin joutsa_PN = mkTerm "joutsa_PN" ;
lin joutseno_PN = mkTerm "joutseno_PN" ;
lin jove_PN = mkTerm "jove_PN" ;
lin jovial_A = mkTerm "jovial_A" ;
lin joviality_N = mkTerm "joviality_N" ;
lin jowl_N = mkTerm "jowl_N" ;
lin jowly_A = mkTerm "jowly_A" ;
lin joy_N = mkTerm "joy_N" ;
lin joy_PN = mkTerm "joy_PN" ;
lin joy_V = mkTerm "joy_V" ;
lin joy_ride_N = mkTerm "joy_ride_N" ;
lin joy_stick_N = mkTerm "joy_stick_N" ;
lin joyce_PN = mkTerm "joyce_PN" ;
lin joyful_A = mkTerm "joyful_A" ;
lin joyfulness_N = mkTerm "joyfulness_N" ;
lin joyless_A = mkTerm "joyless_A" ;
lin joylessness_N = mkTerm "joylessness_N" ;
lin joyous_A = mkTerm "joyous_A" ;
lin joyousness_N = mkTerm "joyousness_N" ;
lin jp_N = mkTerm "jp_N" ;
lin jpg_N = mkTerm "jpg_N" ;
lin ju_jitsu_N = mkTerm "ju_jitsu_N" ;
lin juankoski_PN = mkTerm "juankoski_PN" ;
lin jubilant_A = mkTerm "jubilant_A" ;
lin jubilation_N = mkTerm "jubilation_N" ;
lin jubilee_N = mkTerm "jubilee_N" ;
lin judaic_A = mkTerm "judaic_A" ;
lin judaism_N = mkTerm "judaism_N" ;
lin judas_N = mkTerm "judas_N" ;
lin judas_PN = mkTerm "judas_PN" ;
lin judder_V = mkTerm "judder_V" ;
lin judge_N = mkTerm "judge_N" ;
lin judge_V = mkTerm "judge_V" ;
lin judge_V2 = mkTerm "judge_V2" ;
lin judge_VS = mkTerm "judge_VS" ;
lin judgement_N = mkTerm "judgement_N" ;
lin judgeship_N = mkTerm "judgeship_N" ;
lin judgment_N = mkTerm "judgment_N" ;
lin judgmental_A = mkTerm "judgmental_A" ;
lin judicable_A = mkTerm "judicable_A" ;
lin judicature_N = mkTerm "judicature_N" ;
lin judicial_A = mkTerm "judicial_A" ;
lin judiciary_N = mkTerm "judiciary_N" ;
lin judicious_A = mkTerm "judicious_A" ;
lin judiciousness_N = mkTerm "judiciousness_N" ;
lin judith_PN = mkTerm "judith_PN" ;
lin judo_N = mkTerm "judo_N" ;
lin judy_PN = mkTerm "judy_PN" ;
lin jug_N = mkTerm "jug_N" ;
lin jug_V2 = mkTerm "jug_V2" ;
lin jugale_N = mkTerm "jugale_N" ;
lin jugful_N = mkTerm "jugful_N" ;
lin juggernaut_N = mkTerm "juggernaut_N" ;
lin juggle_N = mkTerm "juggle_N" ;
lin juggle_V = mkTerm "juggle_V" ;
lin juggle_V2 = mkTerm "juggle_V2" ;
lin jugglerFem_N = mkTerm "jugglerFem_N" ;
lin jugglerMasc_N = mkTerm "jugglerMasc_N" ;
lin jugglery_N = mkTerm "jugglery_N" ;
lin jugular_A = mkTerm "jugular_A" ;
lin jugular_N = mkTerm "jugular_N" ;
lin juice_1_N = mkTerm "juice_1_N" ;
lin juice_2_N = mkTerm "juice_2_N" ;
lin juice_up_V2 = mkTerm "juice_up_V2" ;
lin juiceless_A = mkTerm "juiceless_A" ;
lin juiciness_N = mkTerm "juiciness_N" ;
lin juicy_A = mkTerm "juicy_A" ;
lin juju_N = mkTerm "juju_N" ;
lin jujube_N = mkTerm "jujube_N" ;
lin jujutsu_N = mkTerm "jujutsu_N" ;
lin juke_N = mkTerm "juke_N" ;
lin jukebox_N = mkTerm "jukebox_N" ;
lin jul_PN = mkTerm "jul_PN" ;
lin julep_N = mkTerm "julep_N" ;
lin julia_N = mkTerm "julia_N" ;
lin julia_PN = mkTerm "julia_PN" ;
lin julian_A = mkTerm "julian_A" ;
lin julian_PN = mkTerm "julian_PN" ;
lin julie_PN = mkTerm "julie_PN" ;
lin julienne_N = mkTerm "julienne_N" ;
lin juliet_PN = mkTerm "juliet_PN" ;
lin jumble_N = mkTerm "jumble_N" ;
lin jumble_V = mkTerm "jumble_V" ;
lin jumble_V2 = mkTerm "jumble_V2" ;
lin jumble_sale_N = mkTerm "jumble_sale_N" ;
lin jumbo_A = mkTerm "jumbo_A" ;
lin jumbojet_N = mkTerm "jumbojet_N" ;
lin jumentous_A = mkTerm "jumentous_A" ;
lin jump_N = mkTerm "jump_N" ;
lin jump_V = mkTerm "jump_V" ;
lin jump_V2 = mkTerm "jump_V2" ;
lin jump_at_V2 = mkTerm "jump_at_V2" ;
lin jump_in_V = mkTerm "jump_in_V" ;
lin jump_on_V2 = mkTerm "jump_on_V2" ;
lin jump_to_V2 = mkTerm "jump_to_V2" ;
lin jumped_up_A = mkTerm "jumped_up_A" ;
lin jumper_N = mkTerm "jumper_N" ;
lin jumpiness_N = mkTerm "jumpiness_N" ;
lin jumping_N = mkTerm "jumping_N" ;
lin jumpstart_N = mkTerm "jumpstart_N" ;
lin jumpy_A = mkTerm "jumpy_A" ;
lin jun_PN = mkTerm "jun_PN" ;
lin junco_N = mkTerm "junco_N" ;
lin junction_N = mkTerm "junction_N" ;
lin juncture_N = mkTerm "juncture_N" ;
lin jungle_N = mkTerm "jungle_N" ;
lin jungly_A = mkTerm "jungly_A" ;
lin junior_A = mkTerm "junior_A" ;
lin junior_N = mkTerm "junior_N" ;
lin juniper_N = mkTerm "juniper_N" ;
lin junk_N = mkTerm "junk_N" ;
lin junk_V2 = mkTerm "junk_V2" ;
lin junk_shop_N = mkTerm "junk_shop_N" ;
lin junket_N = mkTerm "junket_N" ;
lin junket_V = mkTerm "junket_V" ;
lin junketing_N = mkTerm "junketing_N" ;
lin junkie_N = mkTerm "junkie_N" ;
lin junky_N = mkTerm "junky_N" ;
lin junkyard_N = mkTerm "junkyard_N" ;
lin junoesque_A = mkTerm "junoesque_A" ;
lin junta_N = mkTerm "junta_N" ;
lin jupati_N = mkTerm "jupati_N" ;
lin jupiter_PN = mkTerm "jupiter_PN" ;
lin jural_A = mkTerm "jural_A" ;
lin juridical_A = mkTerm "juridical_A" ;
lin jurisdiction_N = mkTerm "jurisdiction_N" ;
lin jurisdictional_A = mkTerm "jurisdictional_A" ;
lin jurisprudence_N = mkTerm "jurisprudence_N" ;
lin jurisprudential_A = mkTerm "jurisprudential_A" ;
lin jurist_N = mkTerm "jurist_N" ;
lin juror_N = mkTerm "juror_N" ;
lin jurva_PN = mkTerm "jurva_PN" ;
lin jury_N = mkTerm "jury_N" ;
lin jury_box_N = mkTerm "jury_box_N" ;
lin jury_mast_N = mkTerm "jury_mast_N" ;
lin jury_rigge_V2 = mkTerm "jury_rigge_V2" ;
lin juryman_N = mkTerm "juryman_N" ;
lin just_A = mkTerm "just_A" ;
lin just_AdV = mkTerm "just_AdV" ;
lin just_Adv = mkTerm "just_Adv" ;
lin just_Predet = mkTerm "just_Predet" ;
lin just_because_Subj = mkTerm "just_because_Subj" ;
lin justice_N = mkTerm "justice_N" ;
lin justiciar_N = mkTerm "justiciar_N" ;
lin justiciary_N = mkTerm "justiciary_N" ;
lin justifiable_A = mkTerm "justifiable_A" ;
lin justification_N = mkTerm "justification_N" ;
lin justificative_A = mkTerm "justificative_A" ;
lin justified_A = mkTerm "justified_A" ;
lin justify_V2 = mkTerm "justify_V2" ;
lin justify_VV = mkTerm "justify_VV" ;
lin justin_PN = mkTerm "justin_PN" ;
lin justness_N = mkTerm "justness_N" ;
lin jut_V = mkTerm "jut_V" ;
lin jute_N = mkTerm "jute_N" ;
lin juuka_PN = mkTerm "juuka_PN" ;
lin juupajoki_PN = mkTerm "juupajoki_PN" ;
lin juva_PN = mkTerm "juva_PN" ;
lin juvenescence_N = mkTerm "juvenescence_N" ;
lin juvenile_A = mkTerm "juvenile_A" ;
lin juvenile_N = mkTerm "juvenile_N" ;
lin juxtapose_V2 = mkTerm "juxtapose_V2" ;
lin juxtaposition_N = mkTerm "juxtaposition_N" ;
lin jyväskylä_PN = mkTerm "jyväskylä_PN" ;
lin jämijärvi_PN = mkTerm "jämijärvi_PN" ;
lin jämsä_PN = mkTerm "jämsä_PN" ;
lin jämsänkoski_PN = mkTerm "jämsänkoski_PN" ;
lin jäppilä_PN = mkTerm "jäppilä_PN" ;
lin järvelä_PN = mkTerm "järvelä_PN" ;
lin järvenpää_PN = mkTerm "järvenpää_PN" ;
lin kaarina_PN = mkTerm "kaarina_PN" ;
lin kaavi_PN = mkTerm "kaavi_PN" ;
lin kabbalism_N = mkTerm "kabbalism_N" ;
lin kabob_N = mkTerm "kabob_N" ;
lin kachina_N = mkTerm "kachina_N" ;
lin kaffir_N = mkTerm "kaffir_N" ;
lin kaffiyeh_N = mkTerm "kaffiyeh_N" ;
lin kafkaesque_A = mkTerm "kafkaesque_A" ;
lin kahikatea_N = mkTerm "kahikatea_N" ;
lin kail_N = mkTerm "kail_N" ;
lin kainite_N = mkTerm "kainite_N" ;
lin kaiser_N = mkTerm "kaiser_N" ;
lin kajaani_PN = mkTerm "kajaani_PN" ;
lin kakemono_N = mkTerm "kakemono_N" ;
lin kaki_N = mkTerm "kaki_N" ;
lin kalajoki_PN = mkTerm "kalajoki_PN" ;
lin kalansuwa_N = mkTerm "kalansuwa_N" ;
lin kale_N = mkTerm "kale_N" ;
lin kaleidoscope_N = mkTerm "kaleidoscope_N" ;
lin kaleidoscopic_A = mkTerm "kaleidoscopic_A" ;
lin kalemia_N = mkTerm "kalemia_N" ;
lin kalgan_PN = mkTerm "kalgan_PN" ;
lin kaliuresis_N = mkTerm "kaliuresis_N" ;
lin kalmia_N = mkTerm "kalmia_N" ;
lin kalumpang_N = mkTerm "kalumpang_N" ;
lin kalvola_PN = mkTerm "kalvola_PN" ;
lin kameez_N = mkTerm "kameez_N" ;
lin kamikaze_N = mkTerm "kamikaze_N" ;
lin kampong_N = mkTerm "kampong_N" ;
lin kampuchea_PN = mkTerm "kampuchea_PN" ;
lin kampuchean_A = mkTerm "kampuchean_A" ;
lin kampuchean_N = mkTerm "kampuchean_N" ;
lin kanamycin_N = mkTerm "kanamycin_N" ;
lin kanchil_N = mkTerm "kanchil_N" ;
lin kangaroo_N = mkTerm "kangaroo_N" ;
lin kangasala_PN = mkTerm "kangasala_PN" ;
lin kangaslampi_PN = mkTerm "kangaslampi_PN" ;
lin kangasniemi_PN = mkTerm "kangasniemi_PN" ;
lin kankaanpää_PN = mkTerm "kankaanpää_PN" ;
lin kannonkoski_PN = mkTerm "kannonkoski_PN" ;
lin kannus_PN = mkTerm "kannus_PN" ;
lin kanpur_PN = mkTerm "kanpur_PN" ;
lin kansas_PN = mkTerm "kansas_PN" ;
lin kansas_city_PN = mkTerm "kansas_city_PN" ;
lin kanzu_N = mkTerm "kanzu_N" ;
lin kaohsiung_PN = mkTerm "kaohsiung_PN" ;
lin kaoliang_N = mkTerm "kaoliang_N" ;
lin kaolin_N = mkTerm "kaolin_N" ;
lin kaolinite_N = mkTerm "kaolinite_N" ;
lin kaon_N = mkTerm "kaon_N" ;
lin kapeika_N = mkTerm "kapeika_N" ;
lin kaph_N = mkTerm "kaph_N" ;
lin kapok_N = mkTerm "kapok_N" ;
lin kappa_N = mkTerm "kappa_N" ;
lin kapuka_N = mkTerm "kapuka_N" ;
lin kaput_A = mkTerm "kaput_A" ;
lin karachi_PN = mkTerm "karachi_PN" ;
lin karaganda_PN = mkTerm "karaganda_PN" ;
lin karaoke_N = mkTerm "karaoke_N" ;
lin karat_N = mkTerm "karat_N" ;
lin karate_N = mkTerm "karate_N" ;
lin karen_PN = mkTerm "karen_PN" ;
lin karhula_PN = mkTerm "karhula_PN" ;
lin karijoki_PN = mkTerm "karijoki_PN" ;
lin karinainen_PN = mkTerm "karinainen_PN" ;
lin karis_PN = mkTerm "karis_PN" ;
lin karjalohja_PN = mkTerm "karjalohja_PN" ;
lin karkkila_PN = mkTerm "karkkila_PN" ;
lin karlsruhe_PN = mkTerm "karlsruhe_PN" ;
lin karma_N = mkTerm "karma_N" ;
lin karstula_PN = mkTerm "karstula_PN" ;
lin karttula_PN = mkTerm "karttula_PN" ;
lin karvia_PN = mkTerm "karvia_PN" ;
lin karyokinesis_N = mkTerm "karyokinesis_N" ;
lin karyokinetic_A = mkTerm "karyokinetic_A" ;
lin karyolymph_N = mkTerm "karyolymph_N" ;
lin karyolysis_N = mkTerm "karyolysis_N" ;
lin karyotype_N = mkTerm "karyotype_N" ;
lin kasbah_N = mkTerm "kasbah_N" ;
lin kasha_N = mkTerm "kasha_N" ;
lin kashmir_PN = mkTerm "kashmir_PN" ;
lin kashmiri_A = mkTerm "kashmiri_A" ;
lin kashmiri_N = mkTerm "kashmiri_N" ;
lin kaskinen_PN = mkTerm "kaskinen_PN" ;
lin kassel_PN = mkTerm "kassel_PN" ;
lin kat_N = mkTerm "kat_N" ;
lin katabatic_A = mkTerm "katabatic_A" ;
lin katamorphism_N = mkTerm "katamorphism_N" ;
lin kate_PN = mkTerm "kate_PN" ;
lin kath_PN = mkTerm "kath_PN" ;
lin katharobe_N = mkTerm "katharobe_N" ;
lin katharobic_A = mkTerm "katharobic_A" ;
lin katharometer_N = mkTerm "katharometer_N" ;
lin katherine_PN = mkTerm "katherine_PN" ;
lin kathy_PN = mkTerm "kathy_PN" ;
lin katie_PN = mkTerm "katie_PN" ;
lin katowice_PN = mkTerm "katowice_PN" ;
lin katydid_N = mkTerm "katydid_N" ;
lin kauhajoki_PN = mkTerm "kauhajoki_PN" ;
lin kauhava_PN = mkTerm "kauhava_PN" ;
lin kauniainen_PN = mkTerm "kauniainen_PN" ;
lin kauri_N = mkTerm "kauri_N" ;
lin kaustinen_PN = mkTerm "kaustinen_PN" ;
lin kava_N = mkTerm "kava_N" ;
lin kawaka_N = mkTerm "kawaka_N" ;
lin kay_PN = mkTerm "kay_PN" ;
lin kayak_N = mkTerm "kayak_N" ;
lin kazan_PN = mkTerm "kazan_PN" ;
lin kazoo_N = mkTerm "kazoo_N" ;
lin kea_N = mkTerm "kea_N" ;
lin kebab_N = mkTerm "kebab_N" ;
lin kedgeree_N = mkTerm "kedgeree_N" ;
lin keel_N = mkTerm "keel_N" ;
lin keel_V = mkTerm "keel_V" ;
lin keel_V2 = mkTerm "keel_V2" ;
lin keel_over_V = mkTerm "keel_over_V" ;
lin keelboat_N = mkTerm "keelboat_N" ;
lin keelson_N = mkTerm "keelson_N" ;
lin keen_A = mkTerm "keen_A" ;
lin keen_N = mkTerm "keen_N" ;
lin keen_V = mkTerm "keen_V" ;
lin keen_V2 = mkTerm "keen_V2" ;
lin keenness_N = mkTerm "keenness_N" ;
lin keep_N = mkTerm "keep_N" ;
lin keep_V = mkTerm "keep_V" ;
lin keep_V2 = mkTerm "keep_V2" ;
lin keep_V2A = mkTerm "keep_V2A" ;
lin keep_VV = mkTerm "keep_VV" ;
lin keep_around_V2 = mkTerm "keep_around_V2" ;
lin keep_at_V2 = mkTerm "keep_at_V2" ;
lin keep_away_V2 = mkTerm "keep_away_V2" ;
lin keep_back_V = mkTerm "keep_back_V" ;
lin keep_back_V2 = mkTerm "keep_back_V2" ;
lin keep_down_V2 = mkTerm "keep_down_V2" ;
lin keep_from_V2 = mkTerm "keep_from_V2" ;
lin keep_in_V2 = mkTerm "keep_in_V2" ;
lin keep_ing_V2V = mkTerm "keep_ing_V2V" ;
lin keep_off_V2 = mkTerm "keep_off_V2" ;
lin keep_on_V = mkTerm "keep_on_V" ;
lin keep_on_V2 = mkTerm "keep_on_V2" ;
lin keep_out_V = mkTerm "keep_out_V" ;
lin keep_out_V2 = mkTerm "keep_out_V2" ;
lin keep_over_V2 = mkTerm "keep_over_V2" ;
lin keep_to_V2 = mkTerm "keep_to_V2" ;
lin keep_to_V2V = mkTerm "keep_to_V2V" ;
lin keep_up_V = mkTerm "keep_up_V" ;
lin keep_up_V2 = mkTerm "keep_up_V2" ;
lin keep_up_at_V2 = mkTerm "keep_up_at_V2" ;
lin keep_up_with_V2 = mkTerm "keep_up_with_V2" ;
lin keeper_N = mkTerm "keeper_N" ;
lin keeping_N = mkTerm "keeping_N" ;
lin keepsake_N = mkTerm "keepsake_N" ;
lin keeshond_N = mkTerm "keeshond_N" ;
lin keg_N = mkTerm "keg_N" ;
lin keighley_PN = mkTerm "keighley_PN" ;
lin keitele_PN = mkTerm "keitele_PN" ;
lin keith_PN = mkTerm "keith_PN" ;
lin keloid_N = mkTerm "keloid_N" ;
lin kelp_N = mkTerm "kelp_N" ;
lin kelpie_N = mkTerm "kelpie_N" ;
lin kelpy_N = mkTerm "kelpy_N" ;
lin kelso_PN = mkTerm "kelso_PN" ;
lin kelt_N = mkTerm "kelt_N" ;
lin kelty_PN = mkTerm "kelty_PN" ;
lin kelvin_N = mkTerm "kelvin_N" ;
lin kemi_PN = mkTerm "kemi_PN" ;
lin kemijärvi_PN = mkTerm "kemijärvi_PN" ;
lin keminmaa_PN = mkTerm "keminmaa_PN" ;
lin kempele_PN = mkTerm "kempele_PN" ;
lin kempt_A = mkTerm "kempt_A" ;
lin kemsing_PN = mkTerm "kemsing_PN" ;
lin ken_N = mkTerm "ken_N" ;
lin ken_PN = mkTerm "ken_PN" ;
lin ken_V2 = mkTerm "ken_V2" ;
lin kenaf_N = mkTerm "kenaf_N" ;
lin kendal_PN = mkTerm "kendal_PN" ;
lin kenilworth_PN = mkTerm "kenilworth_PN" ;
lin kennel_N = mkTerm "kennel_N" ;
lin kennel_V = mkTerm "kennel_V" ;
lin kennel_V2 = mkTerm "kennel_V2" ;
lin kenneth_PN = mkTerm "kenneth_PN" ;
lin kenning_N = mkTerm "kenning_N" ;
lin kenny_PN = mkTerm "kenny_PN" ;
lin kensington_PN = mkTerm "kensington_PN" ;
lin kent_PN = mkTerm "kent_PN" ;
lin kentucky_PN = mkTerm "kentucky_PN" ;
lin kenya_PN = mkTerm "kenya_PN" ;
lin kenyan_A = mkTerm "kenyan_A" ;
lin kenyan_N = mkTerm "kenyan_N" ;
lin kepi_N = mkTerm "kepi_N" ;
lin keratalgia_N = mkTerm "keratalgia_N" ;
lin keratectasia_N = mkTerm "keratectasia_N" ;
lin keratin_N = mkTerm "keratin_N" ;
lin keratinization_N = mkTerm "keratinization_N" ;
lin keratitis_N = mkTerm "keratitis_N" ;
lin keratoacanthoma_N = mkTerm "keratoacanthoma_N" ;
lin keratocele_N = mkTerm "keratocele_N" ;
lin keratoconjunctivitis_N = mkTerm "keratoconjunctivitis_N" ;
lin keratoconus_N = mkTerm "keratoconus_N" ;
lin keratoderma_N = mkTerm "keratoderma_N" ;
lin keratohyalin_N = mkTerm "keratohyalin_N" ;
lin keratoiritis_N = mkTerm "keratoiritis_N" ;
lin keratomalacia_N = mkTerm "keratomalacia_N" ;
lin keratomycosis_N = mkTerm "keratomycosis_N" ;
lin keratonosis_N = mkTerm "keratonosis_N" ;
lin keratonosus_N = mkTerm "keratonosus_N" ;
lin keratoplasty_N = mkTerm "keratoplasty_N" ;
lin keratoscleritis_N = mkTerm "keratoscleritis_N" ;
lin keratoscope_N = mkTerm "keratoscope_N" ;
lin keratoscopy_N = mkTerm "keratoscopy_N" ;
lin keratosis_N = mkTerm "keratosis_N" ;
lin keratotomy_N = mkTerm "keratotomy_N" ;
lin kerava_PN = mkTerm "kerava_PN" ;
lin kerb_N = mkTerm "kerb_N" ;
lin kerbstone_N = mkTerm "kerbstone_N" ;
lin kerchief_N = mkTerm "kerchief_N" ;
lin kerimäki_PN = mkTerm "kerimäki_PN" ;
lin kerion_N = mkTerm "kerion_N" ;
lin kern_N = mkTerm "kern_N" ;
lin kernel_N = mkTerm "kernel_N" ;
lin kernicterus_N = mkTerm "kernicterus_N" ;
lin kernite_N = mkTerm "kernite_N" ;
lin kerosene_N = mkTerm "kerosene_N" ;
lin kerry_PN = mkTerm "kerry_PN" ;
lin kerygma_N = mkTerm "kerygma_N" ;
lin kestilä_PN = mkTerm "kestilä_PN" ;
lin kestrel_N = mkTerm "kestrel_N" ;
lin kesälahti_PN = mkTerm "kesälahti_PN" ;
lin ketamine_N = mkTerm "ketamine_N" ;
lin ketch_N = mkTerm "ketch_N" ;
lin ketchup_N = mkTerm "ketchup_N" ;
lin keteleeria_N = mkTerm "keteleeria_N" ;
lin ketembilla_N = mkTerm "ketembilla_N" ;
lin ketoacidosis_N = mkTerm "ketoacidosis_N" ;
lin ketohexose_N = mkTerm "ketohexose_N" ;
lin ketone_N = mkTerm "ketone_N" ;
lin ketonemia_N = mkTerm "ketonemia_N" ;
lin ketonuria_N = mkTerm "ketonuria_N" ;
lin ketoprofen_N = mkTerm "ketoprofen_N" ;
lin ketorolac_N = mkTerm "ketorolac_N" ;
lin ketose_N = mkTerm "ketose_N" ;
lin ketosteroid_N = mkTerm "ketosteroid_N" ;
lin kettering_PN = mkTerm "kettering_PN" ;
lin kettle_N = mkTerm "kettle_N" ;
lin kettledrum_N = mkTerm "kettledrum_N" ;
lin keurboom_N = mkTerm "keurboom_N" ;
lin keuruu_PN = mkTerm "keuruu_PN" ;
lin kevin_PN = mkTerm "kevin_PN" ;
lin key_1_N = mkTerm "key_1_N" ;
lin key_2_N = mkTerm "key_2_N" ;
lin key_3_N = mkTerm "key_3_N" ;
lin key_A = mkTerm "key_A" ;
lin key_V2 = mkTerm "key_V2" ;
lin key_down_V = mkTerm "key_down_V" ;
lin key_in_V2 = mkTerm "key_in_V2" ;
lin key_in_on_V2 = mkTerm "key_in_on_V2" ;
lin key_on_V2 = mkTerm "key_on_V2" ;
lin key_to_V2 = mkTerm "key_to_V2" ;
lin key_up_V2 = mkTerm "key_up_V2" ;
lin keyboard_N = mkTerm "keyboard_N" ;
lin keyboardist_N = mkTerm "keyboardist_N" ;
lin keycard_N = mkTerm "keycard_N" ;
lin keyhole_N = mkTerm "keyhole_N" ;
lin keyless_A = mkTerm "keyless_A" ;
lin keynote_N = mkTerm "keynote_N" ;
lin keynsham_PN = mkTerm "keynsham_PN" ;
lin keyring_N = mkTerm "keyring_N" ;
lin keystone_N = mkTerm "keystone_N" ;
lin keystroke_N = mkTerm "keystroke_N" ;
lin keyword_N = mkTerm "keyword_N" ;
lin keyworth_PN = mkTerm "keyworth_PN" ;
lin kg_N = mkTerm "kg_N" ;
lin kgb_N = mkTerm "kgb_N" ;
lin khadi_N = mkTerm "khadi_N" ;
lin khaki_A = mkTerm "khaki_A" ;
lin khaki_N = mkTerm "khaki_N" ;
lin khakis_N = mkTerm "khakis_N" ;
lin khalka_N = mkTerm "khalka_N" ;
lin khamsin_N = mkTerm "khamsin_N" ;
lin khan_N = mkTerm "khan_N" ;
lin khanate_N = mkTerm "khanate_N" ;
lin kharkov_PN = mkTerm "kharkov_PN" ;
lin khartoum_PN = mkTerm "khartoum_PN" ;
lin khimar_N = mkTerm "khimar_N" ;
lin khmer_N = mkTerm "khmer_N" ;
lin khoum_N = mkTerm "khoum_N" ;
lin khukuri_N = mkTerm "khukuri_N" ;
lin khz_N = mkTerm "khz_N" ;
lin kiang_N = mkTerm "kiang_N" ;
lin kibble_N = mkTerm "kibble_N" ;
lin kibbutz_N = mkTerm "kibbutz_N" ;
lin kibbutznik_N = mkTerm "kibbutznik_N" ;
lin kibe_N = mkTerm "kibe_N" ;
lin kibibit_N = mkTerm "kibibit_N" ;
lin kibitzer_N = mkTerm "kibitzer_N" ;
lin kick_N = mkTerm "kick_N" ;
lin kick_V = mkTerm "kick_V" ;
lin kick_V2 = mkTerm "kick_V2" ;
lin kick_about_V2 = mkTerm "kick_about_V2" ;
lin kick_around_V2 = mkTerm "kick_around_V2" ;
lin kick_around_with_V2 = mkTerm "kick_around_with_V2" ;
lin kick_back_V = mkTerm "kick_back_V" ;
lin kick_back_V2 = mkTerm "kick_back_V2" ;
lin kick_down_V2 = mkTerm "kick_down_V2" ;
lin kick_in_V = mkTerm "kick_in_V" ;
lin kick_in_V2 = mkTerm "kick_in_V2" ;
lin kick_off_V = mkTerm "kick_off_V" ;
lin kick_off_V2 = mkTerm "kick_off_V2" ;
lin kick_out_V2 = mkTerm "kick_out_V2" ;
lin kick_start_N = mkTerm "kick_start_N" ;
lin kick_starter_N = mkTerm "kick_starter_N" ;
lin kick_through_V = mkTerm "kick_through_V" ;
lin kick_up_V = mkTerm "kick_up_V" ;
lin kickback_N = mkTerm "kickback_N" ;
lin kicker_N = mkTerm "kicker_N" ;
lin kickoff_N = mkTerm "kickoff_N" ;
lin kicksorter_N = mkTerm "kicksorter_N" ;
lin kickstand_N = mkTerm "kickstand_N" ;
lin kid_N = mkTerm "kid_N" ;
lin kid_V = mkTerm "kid_V" ;
lin kid_V2 = mkTerm "kid_V2" ;
lin kidderminster_PN = mkTerm "kidderminster_PN" ;
lin kiddy_N = mkTerm "kiddy_N" ;
lin kidlington_PN = mkTerm "kidlington_PN" ;
lin kidnap_V2 = mkTerm "kidnap_V2" ;
lin kidnapper_N = mkTerm "kidnapper_N" ;
lin kidnapping_N = mkTerm "kidnapping_N" ;
lin kidney_N = mkTerm "kidney_N" ;
lin kidney_bean_N = mkTerm "kidney_bean_N" ;
lin kidsgrove_PN = mkTerm "kidsgrove_PN" ;
lin kieserite_N = mkTerm "kieserite_N" ;
lin kiev_PN = mkTerm "kiev_PN" ;
lin kihniö_PN = mkTerm "kihniö_PN" ;
lin kiihtelysvaara_PN = mkTerm "kiihtelysvaara_PN" ;
lin kiikala_PN = mkTerm "kiikala_PN" ;
lin kiikoinen_PN = mkTerm "kiikoinen_PN" ;
lin kiiminki_PN = mkTerm "kiiminki_PN" ;
lin kike_N = mkTerm "kike_N" ;
lin kilbirnie_PN = mkTerm "kilbirnie_PN" ;
lin kildare_PN = mkTerm "kildare_PN" ;
lin kilderkin_N = mkTerm "kilderkin_N" ;
lin kilkenny_PN = mkTerm "kilkenny_PN" ;
lin kill_N = mkTerm "kill_N" ;
lin kill_V = mkTerm "kill_V" ;
lin kill_V2 = mkTerm "kill_V2" ;
lin kill_off_V2 = mkTerm "kill_off_V2" ;
lin killable_A = mkTerm "killable_A" ;
lin killarney_PN = mkTerm "killarney_PN" ;
lin killdeer_N = mkTerm "killdeer_N" ;
lin killer_N = mkTerm "killer_N" ;
lin killifish_N = mkTerm "killifish_N" ;
lin killing_N = mkTerm "killing_N" ;
lin killingly_Adv = mkTerm "killingly_Adv" ;
lin killjoy_N = mkTerm "killjoy_N" ;
lin kilmarnock_PN = mkTerm "kilmarnock_PN" ;
lin kiln_N = mkTerm "kiln_N" ;
lin kilo_N = mkTerm "kilo_N" ;
lin kilo_PN = mkTerm "kilo_PN" ;
lin kilobit_N = mkTerm "kilobit_N" ;
lin kilobyte_N = mkTerm "kilobyte_N" ;
lin kilocycle_N = mkTerm "kilocycle_N" ;
lin kilogram_N = mkTerm "kilogram_N" ;
lin kilohertz_N = mkTerm "kilohertz_N" ;
lin kilolitre_N = mkTerm "kilolitre_N" ;
lin kilometre_N = mkTerm "kilometre_N" ;
lin kiloton_N = mkTerm "kiloton_N" ;
lin kilovolt_N = mkTerm "kilovolt_N" ;
lin kilowatt_N = mkTerm "kilowatt_N" ;
lin kilsyth_PN = mkTerm "kilsyth_PN" ;
lin kilt_N = mkTerm "kilt_N" ;
lin kilter_N = mkTerm "kilter_N" ;
lin kilwinning_PN = mkTerm "kilwinning_PN" ;
lin kimberley_PN = mkTerm "kimberley_PN" ;
lin kimberlite_N = mkTerm "kimberlite_N" ;
lin kimito_PN = mkTerm "kimito_PN" ;
lin kimono_N = mkTerm "kimono_N" ;
lin kin_N = mkTerm "kin_N" ;
lin kina_N = mkTerm "kina_N" ;
lin kinanesthesia_N = mkTerm "kinanesthesia_N" ;
lin kinase_N = mkTerm "kinase_N" ;
lin kind_A = mkTerm "kind_A" ;
lin kind_N = mkTerm "kind_N" ;
lin kind_hearted_A = mkTerm "kind_hearted_A" ;
lin kinda_Adv = mkTerm "kinda_Adv" ;
lin kindergarten_N = mkTerm "kindergarten_N" ;
lin kindhearted_A = mkTerm "kindhearted_A" ;
lin kindheartedness_N = mkTerm "kindheartedness_N" ;
lin kindle_V = mkTerm "kindle_V" ;
lin kindle_V2 = mkTerm "kindle_V2" ;
lin kindliness_N = mkTerm "kindliness_N" ;
lin kindling_N = mkTerm "kindling_N" ;
lin kindly_A = mkTerm "kindly_A" ;
lin kindness_N = mkTerm "kindness_N" ;
lin kindred_A = mkTerm "kindred_A" ;
lin kindred_N = mkTerm "kindred_N" ;
lin kinematics_N = mkTerm "kinematics_N" ;
lin kinescope_N = mkTerm "kinescope_N" ;
lin kinesiology_N = mkTerm "kinesiology_N" ;
lin kinesis_N = mkTerm "kinesis_N" ;
lin kinesthesia_N = mkTerm "kinesthesia_N" ;
lin kinesthesis_N = mkTerm "kinesthesis_N" ;
lin kinesthetic_A = mkTerm "kinesthetic_A" ;
lin kinetic_A = mkTerm "kinetic_A" ;
lin kinetics_N = mkTerm "kinetics_N" ;
lin king's_lynn_PN = mkTerm "king's_lynn_PN" ;
lin king_N = mkTerm "king_N" ;
lin king_size_A = mkTerm "king_size_A" ;
lin king_sized_A = mkTerm "king_sized_A" ;
lin kingbird_N = mkTerm "kingbird_N" ;
lin kingbolt_N = mkTerm "kingbolt_N" ;
lin kingcup_N = mkTerm "kingcup_N" ;
lin kingdom_N = mkTerm "kingdom_N" ;
lin kingfish_N = mkTerm "kingfish_N" ;
lin kingfisher_N = mkTerm "kingfisher_N" ;
lin kinglet_N = mkTerm "kinglet_N" ;
lin kinglike_A = mkTerm "kinglike_A" ;
lin kingly_A = mkTerm "kingly_A" ;
lin kingmaker_N = mkTerm "kingmaker_N" ;
lin kingpin_N = mkTerm "kingpin_N" ;
lin kingsbury_PN = mkTerm "kingsbury_PN" ;
lin kingship_N = mkTerm "kingship_N" ;
lin kingsteignton_PN = mkTerm "kingsteignton_PN" ;
lin kingston_PN = mkTerm "kingston_PN" ;
lin kingston_upon_hull_PN = mkTerm "kingston_upon_hull_PN" ;
lin kingston_upon_thames_PN = mkTerm "kingston_upon_thames_PN" ;
lin kingwood_N = mkTerm "kingwood_N" ;
lin kinin_N = mkTerm "kinin_N" ;
lin kink_N = mkTerm "kink_N" ;
lin kink_V = mkTerm "kink_V" ;
lin kink_V2 = mkTerm "kink_V2" ;
lin kinkajou_N = mkTerm "kinkajou_N" ;
lin kinky_A = mkTerm "kinky_A" ;
lin kinnula_PN = mkTerm "kinnula_PN" ;
lin kino_N = mkTerm "kino_N" ;
lin kinshasa_PN = mkTerm "kinshasa_PN" ;
lin kinship_N = mkTerm "kinship_N" ;
lin kinsman_N = mkTerm "kinsman_N" ;
lin kinswoman_N = mkTerm "kinswoman_N" ;
lin kiosk_N = mkTerm "kiosk_N" ;
lin kip_1_N = mkTerm "kip_1_N" ;
lin kip_2_N = mkTerm "kip_2_N" ;
lin kip_V = mkTerm "kip_V" ;
lin kip_down_V = mkTerm "kip_down_V" ;
lin kip_down_on_V2 = mkTerm "kip_down_on_V2" ;
lin kippax_PN = mkTerm "kippax_PN" ;
lin kipper_N = mkTerm "kipper_N" ;
lin kirin_PN = mkTerm "kirin_PN" ;
lin kirk_N = mkTerm "kirk_N" ;
lin kirkby_PN = mkTerm "kirkby_PN" ;
lin kirkby_in_ashfield_PN = mkTerm "kirkby_in_ashfield_PN" ;
lin kirkcaldy_PN = mkTerm "kirkcaldy_PN" ;
lin kirkham_PN = mkTerm "kirkham_PN" ;
lin kirkintilloch_PN = mkTerm "kirkintilloch_PN" ;
lin kirkkonummi_PN = mkTerm "kirkkonummi_PN" ;
lin kirkwall_PN = mkTerm "kirkwall_PN" ;
lin kirpan_N = mkTerm "kirpan_N" ;
lin kirsch_N = mkTerm "kirsch_N" ;
lin kirtle_N = mkTerm "kirtle_N" ;
lin kishke_N = mkTerm "kishke_N" ;
lin kisko_PN = mkTerm "kisko_PN" ;
lin kismet_N = mkTerm "kismet_N" ;
lin kiss_N = mkTerm "kiss_N" ;
lin kiss_V2 = mkTerm "kiss_V2" ;
lin kiss_off_V = mkTerm "kiss_off_V" ;
lin kiss_off_V2 = mkTerm "kiss_off_V2" ;
lin kiss_up_to_V2 = mkTerm "kiss_up_to_V2" ;
lin kisser_N = mkTerm "kisser_N" ;
lin kit_N = mkTerm "kit_N" ;
lin kit_V2 = mkTerm "kit_V2" ;
lin kitakyushu_PN = mkTerm "kitakyushu_PN" ;
lin kitbag_N = mkTerm "kitbag_N" ;
lin kitchen_N = mkTerm "kitchen_N" ;
lin kitchenette_N = mkTerm "kitchenette_N" ;
lin kitchenware_N = mkTerm "kitchenware_N" ;
lin kite_N = mkTerm "kite_N" ;
lin kite_balloon_N = mkTerm "kite_balloon_N" ;
lin kitee_PN = mkTerm "kitee_PN" ;
lin kith_N = mkTerm "kith_N" ;
lin kitsch_A = mkTerm "kitsch_A" ;
lin kitsch_N = mkTerm "kitsch_N" ;
lin kittee_N = mkTerm "kittee_N" ;
lin kitten_N = mkTerm "kitten_N" ;
lin kittenish_A = mkTerm "kittenish_A" ;
lin kittilä_PN = mkTerm "kittilä_PN" ;
lin kittiwake_N = mkTerm "kittiwake_N" ;
lin kitty_N = mkTerm "kitty_N" ;
lin kitty_PN = mkTerm "kitty_PN" ;
lin kiukainen_PN = mkTerm "kiukainen_PN" ;
lin kiuruvesi_PN = mkTerm "kiuruvesi_PN" ;
lin kivijärvi_PN = mkTerm "kivijärvi_PN" ;
lin kiwi_N = mkTerm "kiwi_N" ;
lin klavern_N = mkTerm "klavern_N" ;
lin klaxon_N = mkTerm "klaxon_N" ;
lin klebsiella_N = mkTerm "klebsiella_N" ;
lin kleenex_N = mkTerm "kleenex_N" ;
lin kleptomania_N = mkTerm "kleptomania_N" ;
lin kleptomaniac_N = mkTerm "kleptomaniac_N" ;
lin klondike_N = mkTerm "klondike_N" ;
lin kludge_N = mkTerm "kludge_N" ;
lin klutz_N = mkTerm "klutz_N" ;
lin klystron_N = mkTerm "klystron_N" ;
lin km_N = mkTerm "km_N" ;
lin knack_N = mkTerm "knack_N" ;
lin knacker_N = mkTerm "knacker_N" ;
lin knackered_A = mkTerm "knackered_A" ;
lin knackwurst_N = mkTerm "knackwurst_N" ;
lin knap_V2 = mkTerm "knap_V2" ;
lin knapsack_N = mkTerm "knapsack_N" ;
lin knapweed_N = mkTerm "knapweed_N" ;
lin knaresborough_PN = mkTerm "knaresborough_PN" ;
lin knave_N = mkTerm "knave_N" ;
lin knavery_N = mkTerm "knavery_N" ;
lin knavish_A = mkTerm "knavish_A" ;
lin knawel_N = mkTerm "knawel_N" ;
lin knead_V = mkTerm "knead_V" ;
lin knead_V2 = mkTerm "knead_V2" ;
lin knee_N = mkTerm "knee_N" ;
lin knee_deep_A = mkTerm "knee_deep_A" ;
lin knee_deep_Adv = mkTerm "knee_deep_Adv" ;
lin knee_high_A = mkTerm "knee_high_A" ;
lin knee_high_Adv = mkTerm "knee_high_Adv" ;
lin kneecap_N = mkTerm "kneecap_N" ;
lin kneel_N = mkTerm "kneel_N" ;
lin kneel_V = mkTerm "kneel_V" ;
lin kneeler_N = mkTerm "kneeler_N" ;
lin knell_N = mkTerm "knell_N" ;
lin knesset_N = mkTerm "knesset_N" ;
lin knick_knack_N = mkTerm "knick_knack_N" ;
lin knife_N = mkTerm "knife_N" ;
lin knife_V2 = mkTerm "knife_V2" ;
lin knife_edge_N = mkTerm "knife_edge_N" ;
lin knifelike_A = mkTerm "knifelike_A" ;
lin knight_N = mkTerm "knight_N" ;
lin knight_V2 = mkTerm "knight_V2" ;
lin knight_errant_N = mkTerm "knight_errant_N" ;
lin knighthood_N = mkTerm "knighthood_N" ;
lin knightly_A = mkTerm "knightly_A" ;
lin kniphofia_N = mkTerm "kniphofia_N" ;
lin knish_N = mkTerm "knish_N" ;
lin knit_N = mkTerm "knit_N" ;
lin knit_V = mkTerm "knit_V" ;
lin knit_V2 = mkTerm "knit_V2" ;
lin knitter_N = mkTerm "knitter_N" ;
lin knitting_N = mkTerm "knitting_N" ;
lin knitting_machine_N = mkTerm "knitting_machine_N" ;
lin knitting_needle_N = mkTerm "knitting_needle_N" ;
lin knitwear_N = mkTerm "knitwear_N" ;
lin knob_N = mkTerm "knob_N" ;
lin knobble_N = mkTerm "knobble_N" ;
lin knobbly_A = mkTerm "knobbly_A" ;
lin knobby_A = mkTerm "knobby_A" ;
lin knobkerrie_N = mkTerm "knobkerrie_N" ;
lin knock_N = mkTerm "knock_N" ;
lin knock_V = mkTerm "knock_V" ;
lin knock_V2 = mkTerm "knock_V2" ;
lin knock_about_V2 = mkTerm "knock_about_V2" ;
lin knock_around_V2 = mkTerm "knock_around_V2" ;
lin knock_back_V2 = mkTerm "knock_back_V2" ;
lin knock_down_V2 = mkTerm "knock_down_V2" ;
lin knock_it_off_V2 = mkTerm "knock_it_off_V2" ;
lin knock_kneed_A = mkTerm "knock_kneed_A" ;
lin knock_off_V = mkTerm "knock_off_V" ;
lin knock_off_V2 = mkTerm "knock_off_V2" ;
lin knock_on_N = mkTerm "knock_on_N" ;
lin knock_out_V = mkTerm "knock_out_V" ;
lin knock_out_V2 = mkTerm "knock_out_V2" ;
lin knock_over_V = mkTerm "knock_over_V" ;
lin knock_together_V2 = mkTerm "knock_together_V2" ;
lin knock_up_V = mkTerm "knock_up_V" ;
lin knock_up_V2 = mkTerm "knock_up_V2" ;
lin knockabout_A = mkTerm "knockabout_A" ;
lin knockabout_N = mkTerm "knockabout_N" ;
lin knockdown_A = mkTerm "knockdown_A" ;
lin knockdown_N = mkTerm "knockdown_N" ;
lin knocker_N = mkTerm "knocker_N" ;
lin knockoff_N = mkTerm "knockoff_N" ;
lin knockout_A = mkTerm "knockout_A" ;
lin knockout_N = mkTerm "knockout_N" ;
lin knoll_N = mkTerm "knoll_N" ;
lin knot_N = mkTerm "knot_N" ;
lin knot_V = mkTerm "knot_V" ;
lin knot_V2 = mkTerm "knot_V2" ;
lin knotgrass_N = mkTerm "knotgrass_N" ;
lin knothole_N = mkTerm "knothole_N" ;
lin knottingley_PN = mkTerm "knottingley_PN" ;
lin knotty_A = mkTerm "knotty_A" ;
lin knout_N = mkTerm "knout_N" ;
lin know_N = mkTerm "know_N" ;
lin know_V = mkTerm "know_V" ;
lin know_V2 = mkTerm "know_V2" ;
lin know_VQ = mkTerm "know_VQ" ;
lin know_VS = mkTerm "know_VS" ;
lin know_all_N = mkTerm "know_all_N" ;
lin know_how_N = mkTerm "know_how_N" ;
lin knowable_A = mkTerm "knowable_A" ;
lin knower_N = mkTerm "knower_N" ;
lin knowing_N = mkTerm "knowing_N" ;
lin knowingness_N = mkTerm "knowingness_N" ;
lin knowledge_N = mkTerm "knowledge_N" ;
lin knowledgeability_N = mkTerm "knowledgeability_N" ;
lin knowledgeable_A = mkTerm "knowledgeable_A" ;
lin known_A = mkTerm "known_A" ;
lin knuckle_N = mkTerm "knuckle_N" ;
lin knuckle_V = mkTerm "knuckle_V" ;
lin knuckle_down_V = mkTerm "knuckle_down_V" ;
lin knuckle_under_V = mkTerm "knuckle_under_V" ;
lin knuckleball_N = mkTerm "knuckleball_N" ;
lin knutsford_PN = mkTerm "knutsford_PN" ;
lin ko_N = mkTerm "ko_N" ;
lin koala_N = mkTerm "koala_N" ;
lin koan_N = mkTerm "koan_N" ;
lin kob_N = mkTerm "kob_N" ;
lin kobe_PN = mkTerm "kobe_PN" ;
lin koblenz_PN = mkTerm "koblenz_PN" ;
lin kobo_N = mkTerm "kobo_N" ;
lin kohl_N = mkTerm "kohl_N" ;
lin kohleria_N = mkTerm "kohleria_N" ;
lin kohlrabi_N = mkTerm "kohlrabi_N" ;
lin koinonia_N = mkTerm "koinonia_N" ;
lin kokemäki_PN = mkTerm "kokemäki_PN" ;
lin kokkola_PN = mkTerm "kokkola_PN" ;
lin kola_N = mkTerm "kola_N" ;
lin kola_nut_N = mkTerm "kola_nut_N" ;
lin kolari_PN = mkTerm "kolari_PN" ;
lin kolkhoz_N = mkTerm "kolkhoz_N" ;
lin kolkhoznik_N = mkTerm "kolkhoznik_N" ;
lin koln_PN = mkTerm "koln_PN" ;
lin komondor_N = mkTerm "komondor_N" ;
lin konini_N = mkTerm "konini_N" ;
lin konnevesi_PN = mkTerm "konnevesi_PN" ;
lin kontiolahti_PN = mkTerm "kontiolahti_PN" ;
lin kook_N = mkTerm "kook_N" ;
lin kookaburra_N = mkTerm "kookaburra_N" ;
lin kopeck_N = mkTerm "kopeck_N" ;
lin kopek_N = mkTerm "kopek_N" ;
lin kopiyka_N = mkTerm "kopiyka_N" ;
lin kopje_N = mkTerm "kopje_N" ;
lin koppie_N = mkTerm "koppie_N" ;
lin koran_N = mkTerm "koran_N" ;
lin koranic_A = mkTerm "koranic_A" ;
lin korea_PN = mkTerm "korea_PN" ;
lin korean_A = mkTerm "korean_A" ;
lin korean_N = mkTerm "korean_N" ;
lin korpilahti_PN = mkTerm "korpilahti_PN" ;
lin korsholm_PN = mkTerm "korsholm_PN" ;
lin korsnäs_PN = mkTerm "korsnäs_PN" ;
lin kortesjärvi_PN = mkTerm "kortesjärvi_PN" ;
lin koruna_N = mkTerm "koruna_N" ;
lin kos_N = mkTerm "kos_N" ;
lin kosher_A = mkTerm "kosher_A" ;
lin kosher_N = mkTerm "kosher_N" ;
lin koski_PN = mkTerm "koski_PN" ;
lin kotka_PN = mkTerm "kotka_PN" ;
lin koto_N = mkTerm "koto_N" ;
lin kotow_N = mkTerm "kotow_N" ;
lin kotow_V = mkTerm "kotow_V" ;
lin koukkuniemi_PN = mkTerm "koukkuniemi_PN" ;
lin koumiss_N = mkTerm "koumiss_N" ;
lin kouvola_PN = mkTerm "kouvola_PN" ;
lin kowhai_N = mkTerm "kowhai_N" ;
lin kowtow_N = mkTerm "kowtow_N" ;
lin kowtow_V = mkTerm "kowtow_V" ;
lin kraal_N = mkTerm "kraal_N" ;
lin kraft_N = mkTerm "kraft_N" ;
lin krait_N = mkTerm "krait_N" ;
lin krakow_PN = mkTerm "krakow_PN" ;
lin krasnoyarsk_PN = mkTerm "krasnoyarsk_PN" ;
lin kraurosis_N = mkTerm "kraurosis_N" ;
lin krefeld_PN = mkTerm "krefeld_PN" ;
lin kremlin_N = mkTerm "kremlin_N" ;
lin krigia_N = mkTerm "krigia_N" ;
lin krill_N = mkTerm "krill_N" ;
lin kris_N = mkTerm "kris_N" ;
lin kristinestad_PN = mkTerm "kristinestad_PN" ;
lin krivoi_rog_PN = mkTerm "krivoi_rog_PN" ;
lin krona_N = mkTerm "krona_N" ;
lin krone_N = mkTerm "krone_N" ;
lin kronoby_PN = mkTerm "kronoby_PN" ;
lin kroon_N = mkTerm "kroon_N" ;
lin krubi_N = mkTerm "krubi_N" ;
lin krummhorn_N = mkTerm "krummhorn_N" ;
lin krypton_N = mkTerm "krypton_N" ;
lin kudos_N = mkTerm "kudos_N" ;
lin kudu_N = mkTerm "kudu_N" ;
lin kudzu_N = mkTerm "kudzu_N" ;
lin kuhmalahti_PN = mkTerm "kuhmalahti_PN" ;
lin kuhmo_PN = mkTerm "kuhmo_PN" ;
lin kuhmoinen_PN = mkTerm "kuhmoinen_PN" ;
lin kuivaniemi_PN = mkTerm "kuivaniemi_PN" ;
lin kullaa_PN = mkTerm "kullaa_PN" ;
lin kummel_N = mkTerm "kummel_N" ;
lin kumquat_N = mkTerm "kumquat_N" ;
lin kung_fu_N = mkTerm "kung_fu_N" ;
lin kunming_PN = mkTerm "kunming_PN" ;
lin kunzite_N = mkTerm "kunzite_N" ;
lin kuopio_PN = mkTerm "kuopio_PN" ;
lin kuortane_PN = mkTerm "kuortane_PN" ;
lin kurd_N = mkTerm "kurd_N" ;
lin kurikka_PN = mkTerm "kurikka_PN" ;
lin kurrajong_N = mkTerm "kurrajong_N" ;
lin kurta_N = mkTerm "kurta_N" ;
lin kuru_N = mkTerm "kuru_N" ;
lin kuru_PN = mkTerm "kuru_PN" ;
lin kurus_N = mkTerm "kurus_N" ;
lin kustavi_PN = mkTerm "kustavi_PN" ;
lin kuusamo_PN = mkTerm "kuusamo_PN" ;
lin kuusjoki_PN = mkTerm "kuusjoki_PN" ;
lin kuvasz_N = mkTerm "kuvasz_N" ;
lin kuwait_PN = mkTerm "kuwait_PN" ;
lin kuwait_city_PN = mkTerm "kuwait_city_PN" ;
lin kuwaiti_A = mkTerm "kuwaiti_A" ;
lin kuwaiti_N = mkTerm "kuwaiti_N" ;
lin kuybyshev_PN = mkTerm "kuybyshev_PN" ;
lin kvass_N = mkTerm "kvass_N" ;
lin kvetch_N = mkTerm "kvetch_N" ;
lin kw_N = mkTerm "kw_N" ;
lin kwacha_N = mkTerm "kwacha_N" ;
lin kwanza_N = mkTerm "kwanza_N" ;
lin kwashiorkor_N = mkTerm "kwashiorkor_N" ;
lin kweiyang_PN = mkTerm "kweiyang_PN" ;
lin kwela_N = mkTerm "kwela_N" ;
lin kyanite_N = mkTerm "kyanite_N" ;
lin kyat_N = mkTerm "kyat_N" ;
lin kylie_N = mkTerm "kylie_N" ;
lin kylix_N = mkTerm "kylix_N" ;
lin kylmäkoski_PN = mkTerm "kylmäkoski_PN" ;
lin kymograph_N = mkTerm "kymograph_N" ;
lin kyoto_PN = mkTerm "kyoto_PN" ;
lin kyphosis_N = mkTerm "kyphosis_N" ;
lin kyrö_PN = mkTerm "kyrö_PN" ;
lin kyyjärvi_PN = mkTerm "kyyjärvi_PN" ;
lin kälviä_PN = mkTerm "kälviä_PN" ;
lin kärkölä_PN = mkTerm "kärkölä_PN" ;
lin kärsämäki_PN = mkTerm "kärsämäki_PN" ;
lin köyliö_PN = mkTerm "köyliö_PN" ;
lin l_plate_N = mkTerm "l_plate_N" ;
lin la_N = mkTerm "la_N" ;
lin la_PN = mkTerm "la_PN" ;
lin la_di_da_A = mkTerm "la_di_da_A" ;
lin la_habana_PN = mkTerm "la_habana_PN" ;
lin la_paz_PN = mkTerm "la_paz_PN" ;
lin la_plata_PN = mkTerm "la_plata_PN" ;
lin la_spezia_PN = mkTerm "la_spezia_PN" ;
lin laager_N = mkTerm "laager_N" ;
lin lab_N = mkTerm "lab_N" ;
lin lab_PN = mkTerm "lab_PN" ;
lin labdanum_N = mkTerm "labdanum_N" ;
lin label_N = mkTerm "label_N" ;
lin label_V = mkTerm "label_V" ;
lin label_V2 = mkTerm "label_V2" ;
lin label_V3 = mkTerm "label_V3" ;
lin labeled_A = mkTerm "labeled_A" ;
lin labetalol_N = mkTerm "labetalol_N" ;
lin labial_A = mkTerm "labial_A" ;
lin labiate_A = mkTerm "labiate_A" ;
lin labile_A = mkTerm "labile_A" ;
lin labium_N = mkTerm "labium_N" ;
lin labor_N = mkTerm "labor_N" ;
lin laboratory_N = mkTerm "laboratory_N" ;
lin labored_A = mkTerm "labored_A" ;
lin laborer_N = mkTerm "laborer_N" ;
lin laborious_A = mkTerm "laborious_A" ;
lin laboriousness_N = mkTerm "laboriousness_N" ;
lin laborsaving_A = mkTerm "laborsaving_A" ;
lin labour_N = mkTerm "labour_N" ;
lin labour_V = mkTerm "labour_V" ;
lin labour_V2 = mkTerm "labour_V2" ;
lin labour_saving_A = mkTerm "labour_saving_A" ;
lin labourer_N = mkTerm "labourer_N" ;
lin labourite_N = mkTerm "labourite_N" ;
lin labrador_PN = mkTerm "labrador_PN" ;
lin laburnum_N = mkTerm "laburnum_N" ;
lin labyrinth_N = mkTerm "labyrinth_N" ;
lin labyrinthine_A = mkTerm "labyrinthine_A" ;
lin labyrinthitis_N = mkTerm "labyrinthitis_N" ;
lin labyrinthodont_N = mkTerm "labyrinthodont_N" ;
lin lac_N = mkTerm "lac_N" ;
lin lace_N = mkTerm "lace_N" ;
lin lace_V = mkTerm "lace_V" ;
lin lace_V2 = mkTerm "lace_V2" ;
lin lacebark_N = mkTerm "lacebark_N" ;
lin lacer_N = mkTerm "lacer_N" ;
lin lacerate_A = mkTerm "lacerate_A" ;
lin lacerate_V2 = mkTerm "lacerate_V2" ;
lin laceration_N = mkTerm "laceration_N" ;
lin lacewing_N = mkTerm "lacewing_N" ;
lin lacework_N = mkTerm "lacework_N" ;
lin lachrymal_A = mkTerm "lachrymal_A" ;
lin lachrymose_A = mkTerm "lachrymose_A" ;
lin lacing_N = mkTerm "lacing_N" ;
lin lack_N = mkTerm "lack_N" ;
lin lack_V = mkTerm "lack_V" ;
lin lack_V2 = mkTerm "lack_V2" ;
lin lack_lustre_A = mkTerm "lack_lustre_A" ;
lin lackadaisical_A = mkTerm "lackadaisical_A" ;
lin lackey_N = mkTerm "lackey_N" ;
lin lacking_A = mkTerm "lacking_A" ;
lin lackluster_A = mkTerm "lackluster_A" ;
lin laconic_A = mkTerm "laconic_A" ;
lin laconicism_N = mkTerm "laconicism_N" ;
lin laconism_N = mkTerm "laconism_N" ;
lin lacquer_N = mkTerm "lacquer_N" ;
lin lacquer_V2 = mkTerm "lacquer_V2" ;
lin lacquerware_N = mkTerm "lacquerware_N" ;
lin lacrimal_A = mkTerm "lacrimal_A" ;
lin lacrimation_N = mkTerm "lacrimation_N" ;
lin lacrimatory_A = mkTerm "lacrimatory_A" ;
lin lacrosse_N = mkTerm "lacrosse_N" ;
lin lactalbumin_N = mkTerm "lactalbumin_N" ;
lin lactase_N = mkTerm "lactase_N" ;
lin lactate_N = mkTerm "lactate_N" ;
lin lactation_N = mkTerm "lactation_N" ;
lin lacteal_A = mkTerm "lacteal_A" ;
lin lacteal_N = mkTerm "lacteal_N" ;
lin lactic_A = mkTerm "lactic_A" ;
lin lactifuge_N = mkTerm "lactifuge_N" ;
lin lactobacillus_N = mkTerm "lactobacillus_N" ;
lin lactogen_N = mkTerm "lactogen_N" ;
lin lactogenic_A = mkTerm "lactogenic_A" ;
lin lactose_N = mkTerm "lactose_N" ;
lin lactosuria_N = mkTerm "lactosuria_N" ;
lin lacuna_N = mkTerm "lacuna_N" ;
lin lacustrine_A = mkTerm "lacustrine_A" ;
lin lacy_A = mkTerm "lacy_A" ;
lin lad_N = mkTerm "lad_N" ;
lin ladder_N = mkTerm "ladder_N" ;
lin ladder_V = mkTerm "ladder_V" ;
lin ladder_proof_A = mkTerm "ladder_proof_A" ;
lin laddie_N = mkTerm "laddie_N" ;
lin lade_V2 = mkTerm "lade_V2" ;
lin laden_A = mkTerm "laden_A" ;
lin lading_N = mkTerm "lading_N" ;
lin ladle_N = mkTerm "ladle_N" ;
lin ladle_V2 = mkTerm "ladle_V2" ;
lin lady's_maid_N = mkTerm "lady's_maid_N" ;
lin lady_N = mkTerm "lady_N" ;
lin lady_chapel_N = mkTerm "lady_chapel_N" ;
lin lady_in_waiting_N = mkTerm "lady_in_waiting_N" ;
lin lady_killer_N = mkTerm "lady_killer_N" ;
lin ladybird_N = mkTerm "ladybird_N" ;
lin ladybug_N = mkTerm "ladybug_N" ;
lin ladyfinger_N = mkTerm "ladyfinger_N" ;
lin ladyfish_N = mkTerm "ladyfish_N" ;
lin ladylike_A = mkTerm "ladylike_A" ;
lin ladylikeness_N = mkTerm "ladylikeness_N" ;
lin ladylove_N = mkTerm "ladylove_N" ;
lin ladyship_N = mkTerm "ladyship_N" ;
lin laelia_N = mkTerm "laelia_N" ;
lin laetrile_N = mkTerm "laetrile_N" ;
lin lag_N = mkTerm "lag_N" ;
lin lag_V = mkTerm "lag_V" ;
lin lag_V2 = mkTerm "lag_V2" ;
lin lagan_N = mkTerm "lagan_N" ;
lin lager_1_N = mkTerm "lager_1_N" ;
lin lager_2_N = mkTerm "lager_2_N" ;
lin lagerphone_N = mkTerm "lagerphone_N" ;
lin laggard_N = mkTerm "laggard_N" ;
lin lagging_N = mkTerm "lagging_N" ;
lin lagniappe_N = mkTerm "lagniappe_N" ;
lin lagomorph_N = mkTerm "lagomorph_N" ;
lin lagoon_N = mkTerm "lagoon_N" ;
lin lagophthalmos_N = mkTerm "lagophthalmos_N" ;
lin lagos_PN = mkTerm "lagos_PN" ;
lin lahar_N = mkTerm "lahar_N" ;
lin lahore_PN = mkTerm "lahore_PN" ;
lin lahti_PN = mkTerm "lahti_PN" ;
lin laic_A = mkTerm "laic_A" ;
lin laicize_V2 = mkTerm "laicize_V2" ;
lin laihia_PN = mkTerm "laihia_PN" ;
lin lair_N = mkTerm "lair_N" ;
lin laird_N = mkTerm "laird_N" ;
lin laissez_faire_N = mkTerm "laissez_faire_N" ;
lin laitila_PN = mkTerm "laitila_PN" ;
lin laity_N = mkTerm "laity_N" ;
lin lake_N = mkTerm "lake_N" ;
lin lakefront_N = mkTerm "lakefront_N" ;
lin lakenheath_PN = mkTerm "lakenheath_PN" ;
lin lakeside_N = mkTerm "lakeside_N" ;
lin lakh_N = mkTerm "lakh_N" ;
lin lallation_N = mkTerm "lallation_N" ;
lin lally_N = mkTerm "lally_N" ;
lin lam_V = mkTerm "lam_V" ;
lin lam_V2 = mkTerm "lam_V2" ;
lin lama_N = mkTerm "lama_N" ;
lin lamasery_N = mkTerm "lamasery_N" ;
lin lamb_N = mkTerm "lamb_N" ;
lin lamb_V = mkTerm "lamb_V" ;
lin lambaste_V2 = mkTerm "lambaste_V2" ;
lin lambda_N = mkTerm "lambda_N" ;
lin lambdacism_N = mkTerm "lambdacism_N" ;
lin lambency_N = mkTerm "lambency_N" ;
lin lambent_A = mkTerm "lambent_A" ;
lin lambert_N = mkTerm "lambert_N" ;
lin lambeth_PN = mkTerm "lambeth_PN" ;
lin lambkin_N = mkTerm "lambkin_N" ;
lin lamblike_A = mkTerm "lamblike_A" ;
lin lambrequin_N = mkTerm "lambrequin_N" ;
lin lambskin_N = mkTerm "lambskin_N" ;
lin lame_A = mkTerm "lame_A" ;
lin lame_N = mkTerm "lame_N" ;
lin lame_V2 = mkTerm "lame_V2" ;
lin lamedh_N = mkTerm "lamedh_N" ;
lin lamella_N = mkTerm "lamella_N" ;
lin lamellibranch_A = mkTerm "lamellibranch_A" ;
lin lameness_N = mkTerm "lameness_N" ;
lin lament_N = mkTerm "lament_N" ;
lin lament_V = mkTerm "lament_V" ;
lin lament_V2 = mkTerm "lament_V2" ;
lin lament_VS = mkTerm "lament_VS" ;
lin lamentable_A = mkTerm "lamentable_A" ;
lin lamentation_N = mkTerm "lamentation_N" ;
lin lamina_N = mkTerm "lamina_N" ;
lin laminar_A = mkTerm "laminar_A" ;
lin laminate_N = mkTerm "laminate_N" ;
lin laminate_V = mkTerm "laminate_V" ;
lin laminate_V2 = mkTerm "laminate_V2" ;
lin lamination_N = mkTerm "lamination_N" ;
lin laminator_N = mkTerm "laminator_N" ;
lin laminectomy_N = mkTerm "laminectomy_N" ;
lin laminitis_N = mkTerm "laminitis_N" ;
lin lamivudine_N = mkTerm "lamivudine_N" ;
lin lammas_N = mkTerm "lammas_N" ;
lin lammas_PN = mkTerm "lammas_PN" ;
lin lammi_PN = mkTerm "lammi_PN" ;
lin lamp_N = mkTerm "lamp_N" ;
lin lamp_black_N = mkTerm "lamp_black_N" ;
lin lamplight_N = mkTerm "lamplight_N" ;
lin lamplighter_N = mkTerm "lamplighter_N" ;
lin lamplit_A = mkTerm "lamplit_A" ;
lin lampoon_N = mkTerm "lampoon_N" ;
lin lampoon_V2 = mkTerm "lampoon_V2" ;
lin lamppost_N = mkTerm "lamppost_N" ;
lin lamprey_N = mkTerm "lamprey_N" ;
lin lampshade_N = mkTerm "lampshade_N" ;
lin lanai_N = mkTerm "lanai_N" ;
lin lanark_PN = mkTerm "lanark_PN" ;
lin lanate_A = mkTerm "lanate_A" ;
lin lancashire_PN = mkTerm "lancashire_PN" ;
lin lancaster_PN = mkTerm "lancaster_PN" ;
lin lancastrian_A = mkTerm "lancastrian_A" ;
lin lancastrian_N = mkTerm "lancastrian_N" ;
lin lance_N = mkTerm "lance_N" ;
lin lance_V2 = mkTerm "lance_V2" ;
lin lance_corporal_N = mkTerm "lance_corporal_N" ;
lin lancelet_N = mkTerm "lancelet_N" ;
lin lanceolate_A = mkTerm "lanceolate_A" ;
lin lancer_N = mkTerm "lancer_N" ;
lin lancet_N = mkTerm "lancet_N" ;
lin lancetfish_N = mkTerm "lancetfish_N" ;
lin lancewood_N = mkTerm "lancewood_N" ;
lin lanchow_PN = mkTerm "lanchow_PN" ;
lin lancing_PN = mkTerm "lancing_PN" ;
lin land_N = mkTerm "land_N" ;
lin land_V = mkTerm "land_V" ;
lin land_V2 = mkTerm "land_V2" ;
lin land_agent_N = mkTerm "land_agent_N" ;
lin land_in_V2 = mkTerm "land_in_V2" ;
lin land_up_in_V2 = mkTerm "land_up_in_V2" ;
lin land_with_V3 = mkTerm "land_with_V3" ;
lin landau_N = mkTerm "landau_N" ;
lin lander_N = mkTerm "lander_N" ;
lin landfall_N = mkTerm "landfall_N" ;
lin landfill_N = mkTerm "landfill_N" ;
lin landgrave_N = mkTerm "landgrave_N" ;
lin landholder_N = mkTerm "landholder_N" ;
lin landholding_N = mkTerm "landholding_N" ;
lin landing_N = mkTerm "landing_N" ;
lin landing_craft_N = mkTerm "landing_craft_N" ;
lin landing_field_N = mkTerm "landing_field_N" ;
lin landing_gear_N = mkTerm "landing_gear_N" ;
lin landing_net_N = mkTerm "landing_net_N" ;
lin landing_party_N = mkTerm "landing_party_N" ;
lin landing_place_N = mkTerm "landing_place_N" ;
lin landing_stage_N = mkTerm "landing_stage_N" ;
lin landing_strip_N = mkTerm "landing_strip_N" ;
lin landlady_N = mkTerm "landlady_N" ;
lin landler_N = mkTerm "landler_N" ;
lin landless_A = mkTerm "landless_A" ;
lin landlocked_A = mkTerm "landlocked_A" ;
lin landlord_N = mkTerm "landlord_N" ;
lin landlubber_N = mkTerm "landlubber_N" ;
lin landmark_N = mkTerm "landmark_N" ;
lin landmass_N = mkTerm "landmass_N" ;
lin landmine_N = mkTerm "landmine_N" ;
lin landowner_N = mkTerm "landowner_N" ;
lin landrover_N = mkTerm "landrover_N" ;
lin landscape_N = mkTerm "landscape_N" ;
lin landscape_V2 = mkTerm "landscape_V2" ;
lin landscaping_N = mkTerm "landscaping_N" ;
lin landscapist_N = mkTerm "landscapist_N" ;
lin landside_N = mkTerm "landside_N" ;
lin landslide_N = mkTerm "landslide_N" ;
lin landslip_N = mkTerm "landslip_N" ;
lin landsman_N = mkTerm "landsman_N" ;
lin landward_Adv = mkTerm "landward_Adv" ;
lin lane_N = mkTerm "lane_N" ;
lin langbeinite_N = mkTerm "langbeinite_N" ;
lin langlaufer_N = mkTerm "langlaufer_N" ;
lin langley_N = mkTerm "langley_N" ;
lin langsyne_Adv = mkTerm "langsyne_Adv" ;
lin langsyne_N = mkTerm "langsyne_N" ;
lin language_N = mkTerm "language_N" ;
lin languid_A = mkTerm "languid_A" ;
lin languish_V = mkTerm "languish_V" ;
lin languisher_N = mkTerm "languisher_N" ;
lin languor_N = mkTerm "languor_N" ;
lin languorous_A = mkTerm "languorous_A" ;
lin langur_N = mkTerm "langur_N" ;
lin lank_A = mkTerm "lank_A" ;
lin lankiness_N = mkTerm "lankiness_N" ;
lin lanky_A = mkTerm "lanky_A" ;
lin lanolin_N = mkTerm "lanolin_N" ;
lin lanseh_N = mkTerm "lanseh_N" ;
lin lansoprazole_N = mkTerm "lansoprazole_N" ;
lin lantana_N = mkTerm "lantana_N" ;
lin lantern_N = mkTerm "lantern_N" ;
lin lantern_jawed_A = mkTerm "lantern_jawed_A" ;
lin lanternfish_N = mkTerm "lanternfish_N" ;
lin lanthanum_N = mkTerm "lanthanum_N" ;
lin lanugo_N = mkTerm "lanugo_N" ;
lin lanyard_N = mkTerm "lanyard_N" ;
lin lao_N = mkTerm "lao_N" ;
lin laos_PN = mkTerm "laos_PN" ;
lin laotian_A = mkTerm "laotian_A" ;
lin laotian_N = mkTerm "laotian_N" ;
lin lap_N = mkTerm "lap_N" ;
lin lap_V = mkTerm "lap_V" ;
lin lap_V2 = mkTerm "lap_V2" ;
lin lap_dog_N = mkTerm "lap_dog_N" ;
lin lap_up_V2 = mkTerm "lap_up_V2" ;
lin laparocele_N = mkTerm "laparocele_N" ;
lin laparoscope_N = mkTerm "laparoscope_N" ;
lin laparoscopy_N = mkTerm "laparoscopy_N" ;
lin laparotomy_N = mkTerm "laparotomy_N" ;
lin lapboard_N = mkTerm "lapboard_N" ;
lin lapel_N = mkTerm "lapel_N" ;
lin lapful_N = mkTerm "lapful_N" ;
lin lapidarian_A = mkTerm "lapidarian_A" ;
lin lapidary_A = mkTerm "lapidary_A" ;
lin lapidary_N = mkTerm "lapidary_N" ;
lin lapin_N = mkTerm "lapin_N" ;
lin lapinjärvi_PN = mkTerm "lapinjärvi_PN" ;
lin lapinlahti_PN = mkTerm "lapinlahti_PN" ;
lin lapis_lazuli_N = mkTerm "lapis_lazuli_N" ;
lin lapland_PN = mkTerm "lapland_PN" ;
lin lappajärvi_PN = mkTerm "lappajärvi_PN" ;
lin lappeenranta_PN = mkTerm "lappeenranta_PN" ;
lin lappet_N = mkTerm "lappet_N" ;
lin lappi_PN = mkTerm "lappi_PN" ;
lin lapse_N = mkTerm "lapse_N" ;
lin lapse_V = mkTerm "lapse_V" ;
lin lapsed_A = mkTerm "lapsed_A" ;
lin laptop_N = mkTerm "laptop_N" ;
lin lapua_PN = mkTerm "lapua_PN" ;
lin lapwing_N = mkTerm "lapwing_N" ;
lin larboard_A = mkTerm "larboard_A" ;
lin larboard_N = mkTerm "larboard_N" ;
lin larcenist_N = mkTerm "larcenist_N" ;
lin larceny_N = mkTerm "larceny_N" ;
lin larch_N = mkTerm "larch_N" ;
lin lard_N = mkTerm "lard_N" ;
lin lard_V2 = mkTerm "lard_V2" ;
lin larder_N = mkTerm "larder_N" ;
lin large_A = mkTerm "large_A" ;
lin large_Adv = mkTerm "large_Adv" ;
lin large_N = mkTerm "large_N" ;
lin large_it_up_V2 = mkTerm "large_it_up_V2" ;
lin large_scale_A = mkTerm "large_scale_A" ;
lin largemouth_N = mkTerm "largemouth_N" ;
lin largeness_N = mkTerm "largeness_N" ;
lin largess_N = mkTerm "largess_N" ;
lin largesse_N = mkTerm "largesse_N" ;
lin larghetto_A = mkTerm "larghetto_A" ;
lin larghetto_N = mkTerm "larghetto_N" ;
lin larghissimo_A = mkTerm "larghissimo_A" ;
lin largish_A = mkTerm "largish_A" ;
lin largo_A = mkTerm "largo_A" ;
lin largo_Adv = mkTerm "largo_Adv" ;
lin largo_N = mkTerm "largo_N" ;
lin largs_PN = mkTerm "largs_PN" ;
lin lari_N = mkTerm "lari_N" ;
lin lariat_N = mkTerm "lariat_N" ;
lin larid_N = mkTerm "larid_N" ;
lin lark_N = mkTerm "lark_N" ;
lin lark_V = mkTerm "lark_V" ;
lin lark_about_V = mkTerm "lark_about_V" ;
lin lark_around_V = mkTerm "lark_around_V" ;
lin lark_it_up_V = mkTerm "lark_it_up_V" ;
lin larkhall_PN = mkTerm "larkhall_PN" ;
lin larkspur_N = mkTerm "larkspur_N" ;
lin larn_V = mkTerm "larn_V" ;
lin larn_V2 = mkTerm "larn_V2" ;
lin larne_PN = mkTerm "larne_PN" ;
lin larry_PN = mkTerm "larry_PN" ;
lin larsmo_PN = mkTerm "larsmo_PN" ;
lin larva_N = mkTerm "larva_N" ;
lin larvacean_N = mkTerm "larvacean_N" ;
lin larvacide_N = mkTerm "larvacide_N" ;
lin larval_A = mkTerm "larval_A" ;
lin larvicide_N = mkTerm "larvicide_N" ;
lin laryngeal_A = mkTerm "laryngeal_A" ;
lin laryngectomy_N = mkTerm "laryngectomy_N" ;
lin laryngismus_N = mkTerm "laryngismus_N" ;
lin laryngitis_N = mkTerm "laryngitis_N" ;
lin laryngopharyngeal_A = mkTerm "laryngopharyngeal_A" ;
lin laryngopharyngitis_N = mkTerm "laryngopharyngitis_N" ;
lin laryngopharynx_N = mkTerm "laryngopharynx_N" ;
lin laryngoscope_N = mkTerm "laryngoscope_N" ;
lin laryngospasm_N = mkTerm "laryngospasm_N" ;
lin laryngostenosis_N = mkTerm "laryngostenosis_N" ;
lin laryngotracheobronchitis_N = mkTerm "laryngotracheobronchitis_N" ;
lin larynx_N = mkTerm "larynx_N" ;
lin las_palmas_PN = mkTerm "las_palmas_PN" ;
lin lasagna_N = mkTerm "lasagna_N" ;
lin lascar_N = mkTerm "lascar_N" ;
lin lascivious_A = mkTerm "lascivious_A" ;
lin lasciviousness_N = mkTerm "lasciviousness_N" ;
lin laser_N = mkTerm "laser_N" ;
lin lash_N = mkTerm "lash_N" ;
lin lash_V = mkTerm "lash_V" ;
lin lash_V2 = mkTerm "lash_V2" ;
lin lash_down_V = mkTerm "lash_down_V" ;
lin lash_down_V2 = mkTerm "lash_down_V2" ;
lin lash_into_V2 = mkTerm "lash_into_V2" ;
lin lash_out_V = mkTerm "lash_out_V" ;
lin lash_out_against_V2 = mkTerm "lash_out_against_V2" ;
lin lash_out_at_V2 = mkTerm "lash_out_at_V2" ;
lin lash_out_on_V2 = mkTerm "lash_out_on_V2" ;
lin lash_up_N = mkTerm "lash_up_N" ;
lin lasher_N = mkTerm "lasher_N" ;
lin lashing_N = mkTerm "lashing_N" ;
lin lasiocampid_N = mkTerm "lasiocampid_N" ;
lin lass_N = mkTerm "lass_N" ;
lin lassie_N = mkTerm "lassie_N" ;
lin lassitude_N = mkTerm "lassitude_N" ;
lin lasso_N = mkTerm "lasso_N" ;
lin lasso_V2 = mkTerm "lasso_V2" ;
lin last_1_A = mkTerm "last_1_A" ;
lin last_2_A = mkTerm "last_2_A" ;
lin last_N = mkTerm "last_N" ;
lin last_V = mkTerm "last_V" ;
lin lasting_A = mkTerm "lasting_A" ;
lin lastingness_N = mkTerm "lastingness_N" ;
lin lastly_Adv = mkTerm "lastly_Adv" ;
lin lat_N = mkTerm "lat_N" ;
lin latakia_N = mkTerm "latakia_N" ;
lin latanier_N = mkTerm "latanier_N" ;
lin latch_N = mkTerm "latch_N" ;
lin latch_V = mkTerm "latch_V" ;
lin latch_V2 = mkTerm "latch_V2" ;
lin latch_on_V = mkTerm "latch_on_V" ;
lin latch_on_to_V2 = mkTerm "latch_on_to_V2" ;
lin latch_onto_V2 = mkTerm "latch_onto_V2" ;
lin latchet_N = mkTerm "latchet_N" ;
lin latchkey_N = mkTerm "latchkey_N" ;
lin latchstring_N = mkTerm "latchstring_N" ;
lin late_A = mkTerm "late_A" ;
lin late_Adv = mkTerm "late_Adv" ;
lin latecomer_N = mkTerm "latecomer_N" ;
lin lateen_A = mkTerm "lateen_A" ;
lin lateen_N = mkTerm "lateen_N" ;
lin lately_Adv = mkTerm "lately_Adv" ;
lin latency_N = mkTerm "latency_N" ;
lin lateness_N = mkTerm "lateness_N" ;
lin latent_A = mkTerm "latent_A" ;
lin later_Adv = mkTerm "later_Adv" ;
lin lateral_A = mkTerm "lateral_A" ;
lin laterality_N = mkTerm "laterality_N" ;
lin lateralization_N = mkTerm "lateralization_N" ;
lin laterite_N = mkTerm "laterite_N" ;
lin latest_A = mkTerm "latest_A" ;
lin latest_N = mkTerm "latest_N" ;
lin latex_N = mkTerm "latex_N" ;
lin lath_N = mkTerm "lath_N" ;
lin lathe_N = mkTerm "lathe_N" ;
lin lather_N = mkTerm "lather_N" ;
lin lather_V = mkTerm "lather_V" ;
lin lather_V2 = mkTerm "lather_V2" ;
lin lathery_A = mkTerm "lathery_A" ;
lin lathi_N = mkTerm "lathi_N" ;
lin laticifer_N = mkTerm "laticifer_N" ;
lin latin_A = mkTerm "latin_A" ;
lin latinate_A = mkTerm "latinate_A" ;
lin latinist_N = mkTerm "latinist_N" ;
lin latinize_V2 = mkTerm "latinize_V2" ;
lin latish_A = mkTerm "latish_A" ;
lin latitude_N = mkTerm "latitude_N" ;
lin latitudes_N = mkTerm "latitudes_N" ;
lin latitudinal_A = mkTerm "latitudinal_A" ;
lin latitudinarian_A = mkTerm "latitudinarian_A" ;
lin latitudinarian_N = mkTerm "latitudinarian_N" ;
lin latrine_N = mkTerm "latrine_N" ;
lin lats_N = mkTerm "lats_N" ;
lin latten_N = mkTerm "latten_N" ;
lin latter_A = mkTerm "latter_A" ;
lin latter_N = mkTerm "latter_N" ;
lin latter_day_A = mkTerm "latter_day_A" ;
lin lattice_N = mkTerm "lattice_N" ;
lin latticed_A = mkTerm "latticed_A" ;
lin laud_V2 = mkTerm "laud_V2" ;
lin laudable_A = mkTerm "laudable_A" ;
lin laudanum_N = mkTerm "laudanum_N" ;
lin laudator_N = mkTerm "laudator_N" ;
lin laudatory_A = mkTerm "laudatory_A" ;
lin laugh_N = mkTerm "laugh_N" ;
lin laugh_V = mkTerm "laugh_V" ;
lin laugh_V2 = mkTerm "laugh_V2" ;
lin laugh_VS = mkTerm "laugh_VS" ;
lin laugh_at_V2 = mkTerm "laugh_at_V2" ;
lin laugh_off_V2 = mkTerm "laugh_off_V2" ;
lin laughable_A = mkTerm "laughable_A" ;
lin laugher_N = mkTerm "laugher_N" ;
lin laughing_A = mkTerm "laughing_A" ;
lin laughing_gas_N = mkTerm "laughing_gas_N" ;
lin laughing_stock_N = mkTerm "laughing_stock_N" ;
lin laughter_N = mkTerm "laughter_N" ;
lin laukaa_PN = mkTerm "laukaa_PN" ;
lin launch_N = mkTerm "launch_N" ;
lin launch_V = mkTerm "launch_V" ;
lin launch_V2 = mkTerm "launch_V2" ;
lin launcher_N = mkTerm "launcher_N" ;
lin launching_N = mkTerm "launching_N" ;
lin launching_pad_N = mkTerm "launching_pad_N" ;
lin launching_site_N = mkTerm "launching_site_N" ;
lin launder_V = mkTerm "launder_V" ;
lin launder_V2 = mkTerm "launder_V2" ;
lin launderette_N = mkTerm "launderette_N" ;
lin laundering_N = mkTerm "laundering_N" ;
lin laundress_N = mkTerm "laundress_N" ;
lin laundry_N = mkTerm "laundry_N" ;
lin laundryman_N = mkTerm "laundryman_N" ;
lin laundrywoman_N = mkTerm "laundrywoman_N" ;
lin laura_N = mkTerm "laura_N" ;
lin laura_PN = mkTerm "laura_PN" ;
lin laureateFem_N = mkTerm "laureateFem_N" ;
lin laureateMasc_N = mkTerm "laureateMasc_N" ;
lin laureate_A = mkTerm "laureate_A" ;
lin laurel_N = mkTerm "laurel_N" ;
lin laureled_A = mkTerm "laureled_A" ;
lin laurelled_A = mkTerm "laurelled_A" ;
lin laurelwood_N = mkTerm "laurelwood_N" ;
lin laurence_PN = mkTerm "laurence_PN" ;
lin lausanne_PN = mkTerm "lausanne_PN" ;
lin lav_N = mkTerm "lav_N" ;
lin lava_N = mkTerm "lava_N" ;
lin lavage_N = mkTerm "lavage_N" ;
lin lavalava_N = mkTerm "lavalava_N" ;
lin lavaliere_N = mkTerm "lavaliere_N" ;
lin lavatory_N = mkTerm "lavatory_N" ;
lin lave_V2 = mkTerm "lave_V2" ;
lin lavender_A = mkTerm "lavender_A" ;
lin lavender_N = mkTerm "lavender_N" ;
lin laver_N = mkTerm "laver_N" ;
lin lavia_PN = mkTerm "lavia_PN" ;
lin lavish_A = mkTerm "lavish_A" ;
lin lavish_V2 = mkTerm "lavish_V2" ;
lin lavishness_N = mkTerm "lavishness_N" ;
lin law_1_N = mkTerm "law_1_N" ;
lin law_2_N = mkTerm "law_2_N" ;
lin law_abiding_A = mkTerm "law_abiding_A" ;
lin law_officer_N = mkTerm "law_officer_N" ;
lin lawbreaker_N = mkTerm "lawbreaker_N" ;
lin lawful_A = mkTerm "lawful_A" ;
lin lawfulness_N = mkTerm "lawfulness_N" ;
lin lawgiver_N = mkTerm "lawgiver_N" ;
lin lawless_A = mkTerm "lawless_A" ;
lin lawlessness_N = mkTerm "lawlessness_N" ;
lin lawmaker_N = mkTerm "lawmaker_N" ;
lin lawmaking_N = mkTerm "lawmaking_N" ;
lin lawman_N = mkTerm "lawman_N" ;
lin lawn_N = mkTerm "lawn_N" ;
lin lawn_mower_N = mkTerm "lawn_mower_N" ;
lin lawrence_PN = mkTerm "lawrence_PN" ;
lin lawrencium_N = mkTerm "lawrencium_N" ;
lin lawsuit_N = mkTerm "lawsuit_N" ;
lin lawyer_N = mkTerm "lawyer_N" ;
lin lawyerbush_N = mkTerm "lawyerbush_N" ;
lin lax_A = mkTerm "lax_A" ;
lin laxative_A = mkTerm "laxative_A" ;
lin laxative_N = mkTerm "laxative_N" ;
lin laxity_N = mkTerm "laxity_N" ;
lin laxness_N = mkTerm "laxness_N" ;
lin lay_A = mkTerm "lay_A" ;
lin lay_N = mkTerm "lay_N" ;
lin lay_V = mkTerm "lay_V" ;
lin lay_V2 = mkTerm "lay_V2" ;
lin lay_away_V2 = mkTerm "lay_away_V2" ;
lin lay_down_V = mkTerm "lay_down_V" ;
lin lay_down_V2 = mkTerm "lay_down_V2" ;
lin lay_figure_N = mkTerm "lay_figure_N" ;
lin lay_in_on_V2 = mkTerm "lay_in_on_V2" ;
lin lay_into_V2 = mkTerm "lay_into_V2" ;
lin lay_off_N = mkTerm "lay_off_N" ;
lin lay_off_V2 = mkTerm "lay_off_V2" ;
lin lay_on_V2 = mkTerm "lay_on_V2" ;
lin lay_out_N = mkTerm "lay_out_N" ;
lin lay_out_V2 = mkTerm "lay_out_V2" ;
lin layabout_N = mkTerm "layabout_N" ;
lin layby_N = mkTerm "layby_N" ;
lin layer_N = mkTerm "layer_N" ;
lin layer_V2 = mkTerm "layer_V2" ;
lin layer_cake_N = mkTerm "layer_cake_N" ;
lin layette_N = mkTerm "layette_N" ;
lin laying_N = mkTerm "laying_N" ;
lin layman_N = mkTerm "layman_N" ;
lin layover_N = mkTerm "layover_N" ;
lin lazar_N = mkTerm "lazar_N" ;
lin lazaret_N = mkTerm "lazaret_N" ;
lin lazarette_N = mkTerm "lazarette_N" ;
lin lazaretto_N = mkTerm "lazaretto_N" ;
lin lazarus_N = mkTerm "lazarus_N" ;
lin lazarus_PN = mkTerm "lazarus_PN" ;
lin laze_V = mkTerm "laze_V" ;
lin laze_V2 = mkTerm "laze_V2" ;
lin laziness_N = mkTerm "laziness_N" ;
lin lazy_A = mkTerm "lazy_A" ;
lin lazybones_N = mkTerm "lazybones_N" ;
lin lb_N = mkTerm "lb_N" ;
lin lbw_PN = mkTerm "lbw_PN" ;
lin le_havre_PN = mkTerm "le_havre_PN" ;
lin le_mans_PN = mkTerm "le_mans_PN" ;
lin lea_N = mkTerm "lea_N" ;
lin leach_N = mkTerm "leach_N" ;
lin leach_V2 = mkTerm "leach_V2" ;
lin lead_N = mkTerm "lead_N" ;
lin lead_V = mkTerm "lead_V" ;
lin lead_V2 = mkTerm "lead_V2" ;
lin lead_V2V = mkTerm "lead_V2V" ;
lin lead_in_N = mkTerm "lead_in_N" ;
lin lead_on_V2 = mkTerm "lead_on_V2" ;
lin lead_ore_N = mkTerm "lead_ore_N" ;
lin lead_to_V2 = mkTerm "lead_to_V2" ;
lin lead_up_V = mkTerm "lead_up_V" ;
lin leaded_A = mkTerm "leaded_A" ;
lin leaden_A = mkTerm "leaden_A" ;
lin leader_N = mkTerm "leader_N" ;
lin leaderless_A = mkTerm "leaderless_A" ;
lin leadership_N = mkTerm "leadership_N" ;
lin leading_A = mkTerm "leading_A" ;
lin leading_N = mkTerm "leading_N" ;
lin leading_rein_N = mkTerm "leading_rein_N" ;
lin leadplant_N = mkTerm "leadplant_N" ;
lin leadwort_N = mkTerm "leadwort_N" ;
lin leaf_N = mkTerm "leaf_N" ;
lin leaf_V = mkTerm "leaf_V" ;
lin leaf_bud_N = mkTerm "leaf_bud_N" ;
lin leaf_mould_N = mkTerm "leaf_mould_N" ;
lin leafed_A = mkTerm "leafed_A" ;
lin leafhopper_N = mkTerm "leafhopper_N" ;
lin leafless_A = mkTerm "leafless_A" ;
lin leaflet_N = mkTerm "leaflet_N" ;
lin leaflike_A = mkTerm "leaflike_A" ;
lin leafy_A = mkTerm "leafy_A" ;
lin league_1_N = mkTerm "league_1_N" ;
lin league_2_N = mkTerm "league_2_N" ;
lin league_V = mkTerm "league_V" ;
lin league_V2 = mkTerm "league_V2" ;
lin leak_N = mkTerm "leak_N" ;
lin leak_V = mkTerm "leak_V" ;
lin leak_V2 = mkTerm "leak_V2" ;
lin leak_out_V2 = mkTerm "leak_out_V2" ;
lin leakage_N = mkTerm "leakage_N" ;
lin leaker_N = mkTerm "leaker_N" ;
lin leakiness_N = mkTerm "leakiness_N" ;
lin leakproof_A = mkTerm "leakproof_A" ;
lin leaky_A = mkTerm "leaky_A" ;
lin leal_A = mkTerm "leal_A" ;
lin leamington_spa_PN = mkTerm "leamington_spa_PN" ;
lin lean_A = mkTerm "lean_A" ;
lin lean_N = mkTerm "lean_N" ;
lin lean_V = mkTerm "lean_V" ;
lin lean_V2 = mkTerm "lean_V2" ;
lin lean_on_V2 = mkTerm "lean_on_V2" ;
lin lean_to_N = mkTerm "lean_to_N" ;
lin leaner_N = mkTerm "leaner_N" ;
lin leaning_N = mkTerm "leaning_N" ;
lin leanness_N = mkTerm "leanness_N" ;
lin leap_N = mkTerm "leap_N" ;
lin leap_V = mkTerm "leap_V" ;
lin leap_V2 = mkTerm "leap_V2" ;
lin leap_at_V2 = mkTerm "leap_at_V2" ;
lin leap_on_V2 = mkTerm "leap_on_V2" ;
lin leap_out_V = mkTerm "leap_out_V" ;
lin leap_out_at_V2 = mkTerm "leap_out_at_V2" ;
lin leap_upon_V2 = mkTerm "leap_upon_V2" ;
lin leap_year_N = mkTerm "leap_year_N" ;
lin leapfrog_N = mkTerm "leapfrog_N" ;
lin leapfrog_V2 = mkTerm "leapfrog_V2" ;
lin learn_V = mkTerm "learn_V" ;
lin learn_V2 = mkTerm "learn_V2" ;
lin learn_VS = mkTerm "learn_VS" ;
lin learn_VV = mkTerm "learn_VV" ;
lin learner_N = mkTerm "learner_N" ;
lin learning_N = mkTerm "learning_N" ;
lin lease_N = mkTerm "lease_N" ;
lin lease_V2 = mkTerm "lease_V2" ;
lin lease_lend_N = mkTerm "lease_lend_N" ;
lin leasehold_A = mkTerm "leasehold_A" ;
lin leasehold_N = mkTerm "leasehold_N" ;
lin leaseholder_N = mkTerm "leaseholder_N" ;
lin leash_N = mkTerm "leash_N" ;
lin least_Adv = mkTerm "least_Adv" ;
lin least_N = mkTerm "least_N" ;
lin leastways_Adv = mkTerm "leastways_Adv" ;
lin leastwise_Adv = mkTerm "leastwise_Adv" ;
lin leather_N = mkTerm "leather_N" ;
lin leather_jacket_N = mkTerm "leather_jacket_N" ;
lin leatherette_N = mkTerm "leatherette_N" ;
lin leatherhead_PN = mkTerm "leatherhead_PN" ;
lin leatherleaf_N = mkTerm "leatherleaf_N" ;
lin leatherneck_N = mkTerm "leatherneck_N" ;
lin leatherwood_N = mkTerm "leatherwood_N" ;
lin leatherwork_N = mkTerm "leatherwork_N" ;
lin leathery_A = mkTerm "leathery_A" ;
lin leave_N = mkTerm "leave_N" ;
lin leave_V = mkTerm "leave_V" ;
lin leave_V2 = mkTerm "leave_V2" ;
lin leave_V2V = mkTerm "leave_V2V" ;
lin leave_behind_V = mkTerm "leave_behind_V" ;
lin leave_off_V = mkTerm "leave_off_V" ;
lin leave_on_V2 = mkTerm "leave_on_V2" ;
lin leave_open_V = mkTerm "leave_open_V" ;
lin leave_out_V2 = mkTerm "leave_out_V2" ;
lin leave_over_V = mkTerm "leave_over_V" ;
lin leave_taking_N = mkTerm "leave_taking_N" ;
lin leaven_N = mkTerm "leaven_N" ;
lin leaven_V2 = mkTerm "leaven_V2" ;
lin lebaneseFem_N = mkTerm "lebaneseFem_N" ;
lin lebaneseMasc_N = mkTerm "lebaneseMasc_N" ;
lin lebanese_A = mkTerm "lebanese_A" ;
lin lebanon_PN = mkTerm "lebanon_PN" ;
lin lecanopteris_N = mkTerm "lecanopteris_N" ;
lin lecanora_N = mkTerm "lecanora_N" ;
lin lecher_N = mkTerm "lecher_N" ;
lin lecherous_A = mkTerm "lecherous_A" ;
lin lecherousness_N = mkTerm "lecherousness_N" ;
lin lechery_N = mkTerm "lechery_N" ;
lin lechwe_N = mkTerm "lechwe_N" ;
lin lecithin_N = mkTerm "lecithin_N" ;
lin lectern_N = mkTerm "lectern_N" ;
lin lectin_N = mkTerm "lectin_N" ;
lin lector_N = mkTerm "lector_N" ;
lin lecture_N = mkTerm "lecture_N" ;
lin lecture_V = mkTerm "lecture_V" ;
lin lecture_V2 = mkTerm "lecture_V2" ;
lin lecturer_N = mkTerm "lecturer_N" ;
lin lectureship_N = mkTerm "lectureship_N" ;
lin lederhosen_N = mkTerm "lederhosen_N" ;
lin ledge_N = mkTerm "ledge_N" ;
lin ledger_N = mkTerm "ledger_N" ;
lin lee_N = mkTerm "lee_N" ;
lin leech_N = mkTerm "leech_N" ;
lin leeds_PN = mkTerm "leeds_PN" ;
lin leek_N = mkTerm "leek_N" ;
lin leek_PN = mkTerm "leek_PN" ;
lin leer_N = mkTerm "leer_N" ;
lin leer_V = mkTerm "leer_V" ;
lin leery_A = mkTerm "leery_A" ;
lin lees_N = mkTerm "lees_N" ;
lin leeward_A = mkTerm "leeward_A" ;
lin leeward_Adv = mkTerm "leeward_Adv" ;
lin leeward_N = mkTerm "leeward_N" ;
lin leeway_N = mkTerm "leeway_N" ;
lin leflunomide_N = mkTerm "leflunomide_N" ;
lin left_A = mkTerm "left_A" ;
lin left_N = mkTerm "left_N" ;
lin left_hand_A = mkTerm "left_hand_A" ;
lin left_handed_A = mkTerm "left_handed_A" ;
lin left_of_Prep = mkTerm "left_of_Prep" ;
lin left_wing_N = mkTerm "left_wing_N" ;
lin left_winger_N = mkTerm "left_winger_N" ;
lin leftish_A = mkTerm "leftish_A" ;
lin leftism_N = mkTerm "leftism_N" ;
lin leftist_A = mkTerm "leftist_A" ;
lin leftist_N = mkTerm "leftist_N" ;
lin leftmost_A = mkTerm "leftmost_A" ;
lin leftover_A = mkTerm "leftover_A" ;
lin leftover_N = mkTerm "leftover_N" ;
lin leg_N = mkTerm "leg_N" ;
lin leg_pull_N = mkTerm "leg_pull_N" ;
lin leg_pulling_N = mkTerm "leg_pulling_N" ;
lin legacy_N = mkTerm "legacy_N" ;
lin legal_A = mkTerm "legal_A" ;
lin legalese_N = mkTerm "legalese_N" ;
lin legalism_N = mkTerm "legalism_N" ;
lin legalistic_A = mkTerm "legalistic_A" ;
lin legality_N = mkTerm "legality_N" ;
lin legalization_N = mkTerm "legalization_N" ;
lin legalize_V2 = mkTerm "legalize_V2" ;
lin legate_N = mkTerm "legate_N" ;
lin legatee_N = mkTerm "legatee_N" ;
lin legation_N = mkTerm "legation_N" ;
lin legato_A = mkTerm "legato_A" ;
lin legato_Adv = mkTerm "legato_Adv" ;
lin legend_N = mkTerm "legend_N" ;
lin legendary_A = mkTerm "legendary_A" ;
lin leger_line_N = mkTerm "leger_line_N" ;
lin legerdemain_N = mkTerm "legerdemain_N" ;
lin legged_A = mkTerm "legged_A" ;
lin legging_N = mkTerm "legging_N" ;
lin leggy_A = mkTerm "leggy_A" ;
lin leghorn_N = mkTerm "leghorn_N" ;
lin legibility_N = mkTerm "legibility_N" ;
lin legible_A = mkTerm "legible_A" ;
lin legion_N = mkTerm "legion_N" ;
lin legionary_N = mkTerm "legionary_N" ;
lin legionnaire_N = mkTerm "legionnaire_N" ;
lin legislate_V = mkTerm "legislate_V" ;
lin legislate_V2 = mkTerm "legislate_V2" ;
lin legislation_N = mkTerm "legislation_N" ;
lin legislative_A = mkTerm "legislative_A" ;
lin legislator_N = mkTerm "legislator_N" ;
lin legislatorship_N = mkTerm "legislatorship_N" ;
lin legislature_N = mkTerm "legislature_N" ;
lin legitimacy_N = mkTerm "legitimacy_N" ;
lin legitimate_A = mkTerm "legitimate_A" ;
lin legitimation_N = mkTerm "legitimation_N" ;
lin legitimatize_V2 = mkTerm "legitimatize_V2" ;
lin legitimize_V2 = mkTerm "legitimize_V2" ;
lin legitimize_V2V = mkTerm "legitimize_V2V" ;
lin legless_A = mkTerm "legless_A" ;
lin leglike_A = mkTerm "leglike_A" ;
lin legume_N = mkTerm "legume_N" ;
lin leguminous_A = mkTerm "leguminous_A" ;
lin lehtimäki_PN = mkTerm "lehtimäki_PN" ;
lin lei_N = mkTerm "lei_N" ;
lin leicester_PN = mkTerm "leicester_PN" ;
lin leicestershire_PN = mkTerm "leicestershire_PN" ;
lin leiden_PN = mkTerm "leiden_PN" ;
lin leigh_PN = mkTerm "leigh_PN" ;
lin leighton_linslade_PN = mkTerm "leighton_linslade_PN" ;
lin leinster_PN = mkTerm "leinster_PN" ;
lin leiomyoma_N = mkTerm "leiomyoma_N" ;
lin leiomyosarcoma_N = mkTerm "leiomyosarcoma_N" ;
lin leipzig_PN = mkTerm "leipzig_PN" ;
lin leishmaniasis_N = mkTerm "leishmaniasis_N" ;
lin leister_N = mkTerm "leister_N" ;
lin leisure_N = mkTerm "leisure_N" ;
lin leisured_A = mkTerm "leisured_A" ;
lin leisureliness_N = mkTerm "leisureliness_N" ;
lin leisurely_A = mkTerm "leisurely_A" ;
lin leisurely_Adv = mkTerm "leisurely_Adv" ;
lin leitmotiv_N = mkTerm "leitmotiv_N" ;
lin leitrim_PN = mkTerm "leitrim_PN" ;
lin leivonmäki_PN = mkTerm "leivonmäki_PN" ;
lin leix_PN = mkTerm "leix_PN" ;
lin lek_N = mkTerm "lek_N" ;
lin lekvar_N = mkTerm "lekvar_N" ;
lin lemi_PN = mkTerm "lemi_PN" ;
lin lemma_N = mkTerm "lemma_N" ;
lin lemming_N = mkTerm "lemming_N" ;
lin lemniscus_N = mkTerm "lemniscus_N" ;
lin lemon_N = mkTerm "lemon_N" ;
lin lemonade_N = mkTerm "lemonade_N" ;
lin lemongrass_N = mkTerm "lemongrass_N" ;
lin lemonwood_N = mkTerm "lemonwood_N" ;
lin lemony_A = mkTerm "lemony_A" ;
lin lempira_N = mkTerm "lempira_N" ;
lin lempäälä_PN = mkTerm "lempäälä_PN" ;
lin lemu_PN = mkTerm "lemu_PN" ;
lin lemur_N = mkTerm "lemur_N" ;
lin len_PN = mkTerm "len_PN" ;
lin lend_V = mkTerm "lend_V" ;
lin lend_V2 = mkTerm "lend_V2" ;
lin lendable_A = mkTerm "lendable_A" ;
lin lender_N = mkTerm "lender_N" ;
lin lending_N = mkTerm "lending_N" ;
lin lending_library_N = mkTerm "lending_library_N" ;
lin length_N = mkTerm "length_N" ;
lin lengthen_V = mkTerm "lengthen_V" ;
lin lengthen_V2 = mkTerm "lengthen_V2" ;
lin lengthiness_N = mkTerm "lengthiness_N" ;
lin lengthways_A = mkTerm "lengthways_A" ;
lin lengthways_Adv = mkTerm "lengthways_Adv" ;
lin lengthwise_A = mkTerm "lengthwise_A" ;
lin lengthwise_Adv = mkTerm "lengthwise_Adv" ;
lin lengthy_A = mkTerm "lengthy_A" ;
lin lenience_N = mkTerm "lenience_N" ;
lin leniency_N = mkTerm "leniency_N" ;
lin lenient_A = mkTerm "lenient_A" ;
lin leningrad_PN = mkTerm "leningrad_PN" ;
lin lenitive_N = mkTerm "lenitive_N" ;
lin lenity_N = mkTerm "lenity_N" ;
lin lenny_PN = mkTerm "lenny_PN" ;
lin lens_N = mkTerm "lens_N" ;
lin lens_PN = mkTerm "lens_PN" ;
lin lent_N = mkTerm "lent_N" ;
lin lent_PN = mkTerm "lent_PN" ;
lin lenten_A = mkTerm "lenten_A" ;
lin lentic_A = mkTerm "lentic_A" ;
lin lenticel_N = mkTerm "lenticel_N" ;
lin lentil_N = mkTerm "lentil_N" ;
lin lentissimo_A = mkTerm "lentissimo_A" ;
lin lento_A = mkTerm "lento_A" ;
lin lento_Adv = mkTerm "lento_Adv" ;
lin leo_PN = mkTerm "leo_PN" ;
lin leominster_PN = mkTerm "leominster_PN" ;
lin leon_PN = mkTerm "leon_PN" ;
lin leonard_PN = mkTerm "leonard_PN" ;
lin leone_N = mkTerm "leone_N" ;
lin leonine_A = mkTerm "leonine_A" ;
lin leopard_N = mkTerm "leopard_N" ;
lin leopardess_N = mkTerm "leopardess_N" ;
lin leotard_N = mkTerm "leotard_N" ;
lin leper_N = mkTerm "leper_N" ;
lin lepidobotrys_N = mkTerm "lepidobotrys_N" ;
lin lepidocrocite_N = mkTerm "lepidocrocite_N" ;
lin lepidolite_N = mkTerm "lepidolite_N" ;
lin lepidomelane_N = mkTerm "lepidomelane_N" ;
lin lepidophobia_N = mkTerm "lepidophobia_N" ;
lin lepidopterist_N = mkTerm "lepidopterist_N" ;
lin lepidopterology_N = mkTerm "lepidopterology_N" ;
lin lepidote_A = mkTerm "lepidote_A" ;
lin lepiota_N = mkTerm "lepiota_N" ;
lin leporid_N = mkTerm "leporid_N" ;
lin leppävirta_PN = mkTerm "leppävirta_PN" ;
lin leprechaun_N = mkTerm "leprechaun_N" ;
lin leprosy_N = mkTerm "leprosy_N" ;
lin leprous_A = mkTerm "leprous_A" ;
lin leptocephalus_N = mkTerm "leptocephalus_N" ;
lin leptomeninges_N = mkTerm "leptomeninges_N" ;
lin leptomeningitis_N = mkTerm "leptomeningitis_N" ;
lin lepton_1_N = mkTerm "lepton_1_N" ;
lin lepton_2_N = mkTerm "lepton_2_N" ;
lin leptorrhine_A = mkTerm "leptorrhine_A" ;
lin leptospira_N = mkTerm "leptospira_N" ;
lin leptosporangiate_A = mkTerm "leptosporangiate_A" ;
lin leptosporangium_N = mkTerm "leptosporangium_N" ;
lin leptotene_N = mkTerm "leptotene_N" ;
lin leresis_N = mkTerm "leresis_N" ;
lin lerot_N = mkTerm "lerot_N" ;
lin lerwick_PN = mkTerm "lerwick_PN" ;
lin les_PN = mkTerm "les_PN" ;
lin lesbian_A = mkTerm "lesbian_A" ;
lin lesbian_N = mkTerm "lesbian_N" ;
lin lesbianism_N = mkTerm "lesbianism_N" ;
lin lese_majesty_N = mkTerm "lese_majesty_N" ;
lin lesion_N = mkTerm "lesion_N" ;
lin lesley_PN = mkTerm "lesley_PN" ;
lin leslie_PN = mkTerm "leslie_PN" ;
lin lesotho_PN = mkTerm "lesotho_PN" ;
lin less_A = mkTerm "less_A" ;
lin less_AdA = mkTerm "less_AdA" ;
lin less_Adv = mkTerm "less_Adv" ;
lin less_Det = mkTerm "less_Det" ;
lin less_than_AdN = mkTerm "less_than_AdN" ;
lin lessee_N = mkTerm "lessee_N" ;
lin lessen_V = mkTerm "lessen_V" ;
lin lessen_V2 = mkTerm "lessen_V2" ;
lin lesser_A = mkTerm "lesser_A" ;
lin lesson_N = mkTerm "lesson_N" ;
lin lessor_N = mkTerm "lessor_N" ;
lin lest_Prep = mkTerm "lest_Prep" ;
lin lestijärvi_PN = mkTerm "lestijärvi_PN" ;
lin let_N = mkTerm "let_N" ;
lin let_V2V = mkTerm "let_V2V" ;
lin let_down_N = mkTerm "let_down_N" ;
lin let_down_V2 = mkTerm "let_down_V2" ;
lin let_in_V2 = mkTerm "let_in_V2" ;
lin let_off_V2 = mkTerm "let_off_V2" ;
lin let_on_V = mkTerm "let_on_V" ;
lin let_out_V2 = mkTerm "let_out_V2" ;
lin let_up_N = mkTerm "let_up_N" ;
lin let_up_V = mkTerm "let_up_V" ;
lin letchworth_PN = mkTerm "letchworth_PN" ;
lin lethal_A = mkTerm "lethal_A" ;
lin lethargic_A = mkTerm "lethargic_A" ;
lin lethargy_N = mkTerm "lethargy_N" ;
lin lethe_PN = mkTerm "lethe_PN" ;
lin letter_1_N = mkTerm "letter_1_N" ;
lin letter_2_N = mkTerm "letter_2_N" ;
lin letter_box_N = mkTerm "letter_box_N" ;
lin letter_card_N = mkTerm "letter_card_N" ;
lin letter_case_N = mkTerm "letter_case_N" ;
lin lettered_A = mkTerm "lettered_A" ;
lin letterer_N = mkTerm "letterer_N" ;
lin letterhead_N = mkTerm "letterhead_N" ;
lin lettering_N = mkTerm "lettering_N" ;
lin letterman_N = mkTerm "letterman_N" ;
lin letterpress_N = mkTerm "letterpress_N" ;
lin letters_N = mkTerm "letters_N" ;
lin letting_N = mkTerm "letting_N" ;
lin lettuce_N = mkTerm "lettuce_N" ;
lin leu_N = mkTerm "leu_N" ;
lin leucine_N = mkTerm "leucine_N" ;
lin leucocyte_N = mkTerm "leucocyte_N" ;
lin leucocytozoan_N = mkTerm "leucocytozoan_N" ;
lin leucothoe_N = mkTerm "leucothoe_N" ;
lin leukaemia_N = mkTerm "leukaemia_N" ;
lin leukocyte_N = mkTerm "leukocyte_N" ;
lin leukocytosis_N = mkTerm "leukocytosis_N" ;
lin leukoderma_N = mkTerm "leukoderma_N" ;
lin leukoencephalitis_N = mkTerm "leukoencephalitis_N" ;
lin leukoma_N = mkTerm "leukoma_N" ;
lin leukopenia_N = mkTerm "leukopenia_N" ;
lin leukorrhea_N = mkTerm "leukorrhea_N" ;
lin lev_N = mkTerm "lev_N" ;
lin levallorphan_N = mkTerm "levallorphan_N" ;
lin levant_PN = mkTerm "levant_PN" ;
lin levant_V = mkTerm "levant_V" ;
lin levanter_N = mkTerm "levanter_N" ;
lin levantine_A = mkTerm "levantine_A" ;
lin levantine_N = mkTerm "levantine_N" ;
lin levator_N = mkTerm "levator_N" ;
lin levee_N = mkTerm "levee_N" ;
lin level_1_N = mkTerm "level_1_N" ;
lin level_2_N = mkTerm "level_2_N" ;
lin level_A = mkTerm "level_A" ;
lin level_V = mkTerm "level_V" ;
lin level_V2 = mkTerm "level_V2" ;
lin level_headed_A = mkTerm "level_headed_A" ;
lin level_off_V = mkTerm "level_off_V" ;
lin level_out_V = mkTerm "level_out_V" ;
lin leveler_N = mkTerm "leveler_N" ;
lin leveller_N = mkTerm "leveller_N" ;
lin leven_PN = mkTerm "leven_PN" ;
lin lever_N = mkTerm "lever_N" ;
lin lever_V2 = mkTerm "lever_V2" ;
lin leverage_N = mkTerm "leverage_N" ;
lin leveret_N = mkTerm "leveret_N" ;
lin leverkusen_PN = mkTerm "leverkusen_PN" ;
lin leviathan_N = mkTerm "leviathan_N" ;
lin levirate_N = mkTerm "levirate_N" ;
lin levitate_V = mkTerm "levitate_V" ;
lin levitate_V2 = mkTerm "levitate_V2" ;
lin levitation_N = mkTerm "levitation_N" ;
lin levity_N = mkTerm "levity_N" ;
lin levorotary_A = mkTerm "levorotary_A" ;
lin levorotation_N = mkTerm "levorotation_N" ;
lin levy_N = mkTerm "levy_N" ;
lin levy_V = mkTerm "levy_V" ;
lin levy_V2 = mkTerm "levy_V2" ;
lin lewd_A = mkTerm "lewd_A" ;
lin lewdness_N = mkTerm "lewdness_N" ;
lin lewes_PN = mkTerm "lewes_PN" ;
lin lewis_PN = mkTerm "lewis_PN" ;
lin lewisham_PN = mkTerm "lewisham_PN" ;
lin lexeme_N = mkTerm "lexeme_N" ;
lin lexical_A = mkTerm "lexical_A" ;
lin lexicalization_N = mkTerm "lexicalization_N" ;
lin lexicalized_A = mkTerm "lexicalized_A" ;
lin lexicographerFem_N = mkTerm "lexicographerFem_N" ;
lin lexicographerMasc_N = mkTerm "lexicographerMasc_N" ;
lin lexicographic_A = mkTerm "lexicographic_A" ;
lin lexicography_N = mkTerm "lexicography_N" ;
lin lexicology_N = mkTerm "lexicology_N" ;
lin lexicon_N = mkTerm "lexicon_N" ;
lin lexicostatistic_A = mkTerm "lexicostatistic_A" ;
lin lexicostatistics_N = mkTerm "lexicostatistics_N" ;
lin lexis_N = mkTerm "lexis_N" ;
lin ley_N = mkTerm "ley_N" ;
lin leyland_PN = mkTerm "leyland_PN" ;
lin li_N = mkTerm "li_N" ;
lin liabilities_N = mkTerm "liabilities_N" ;
lin liability_N = mkTerm "liability_N" ;
lin liable_A = mkTerm "liable_A" ;
lin liaise_V = mkTerm "liaise_V" ;
lin liaison_N = mkTerm "liaison_N" ;
lin liana_N = mkTerm "liana_N" ;
lin liar_N = mkTerm "liar_N" ;
lin lib_N = mkTerm "lib_N" ;
lin lib_PN = mkTerm "lib_PN" ;
lin libation_N = mkTerm "libation_N" ;
lin libel_N = mkTerm "libel_N" ;
lin libel_V2 = mkTerm "libel_V2" ;
lin libellous_A = mkTerm "libellous_A" ;
lin liberal_A = mkTerm "liberal_A" ;
lin liberal_N = mkTerm "liberal_N" ;
lin liberalism_N = mkTerm "liberalism_N" ;
lin liberalistic_A = mkTerm "liberalistic_A" ;
lin liberality_N = mkTerm "liberality_N" ;
lin liberalization_N = mkTerm "liberalization_N" ;
lin liberalize_V2 = mkTerm "liberalize_V2" ;
lin liberate_V2 = mkTerm "liberate_V2" ;
lin liberation_N = mkTerm "liberation_N" ;
lin liberator_N = mkTerm "liberator_N" ;
lin liberia_PN = mkTerm "liberia_PN" ;
lin liberian_A = mkTerm "liberian_A" ;
lin liberian_N = mkTerm "liberian_N" ;
lin libertarian_A = mkTerm "libertarian_A" ;
lin libertarian_N = mkTerm "libertarian_N" ;
lin libertarianism_N = mkTerm "libertarianism_N" ;
lin libertine_N = mkTerm "libertine_N" ;
lin liberty_N = mkTerm "liberty_N" ;
lin libidinal_A = mkTerm "libidinal_A" ;
lin libidinous_A = mkTerm "libidinous_A" ;
lin libido_N = mkTerm "libido_N" ;
lin libra_PN = mkTerm "libra_PN" ;
lin librarian_N = mkTerm "librarian_N" ;
lin librarianship_N = mkTerm "librarianship_N" ;
lin library_N = mkTerm "library_N" ;
lin libration_N = mkTerm "libration_N" ;
lin librettist_N = mkTerm "librettist_N" ;
lin libretto_N = mkTerm "libretto_N" ;
lin libya_PN = mkTerm "libya_PN" ;
lin libyan_A = mkTerm "libyan_A" ;
lin libyan_N = mkTerm "libyan_N" ;
lin licence_N = mkTerm "licence_N" ;
lin licence_V2 = mkTerm "licence_V2" ;
lin license_N = mkTerm "license_N" ;
lin license_V2 = mkTerm "license_V2" ;
lin licensed_A = mkTerm "licensed_A" ;
lin licensee_N = mkTerm "licensee_N" ;
lin licenser_N = mkTerm "licenser_N" ;
lin licentiate_N = mkTerm "licentiate_N" ;
lin licentious_A = mkTerm "licentious_A" ;
lin licentiousness_N = mkTerm "licentiousness_N" ;
lin lichen_N = mkTerm "lichen_N" ;
lin lichfield_PN = mkTerm "lichfield_PN" ;
lin lichgate_N = mkTerm "lichgate_N" ;
lin licit_A = mkTerm "licit_A" ;
lin licitness_N = mkTerm "licitness_N" ;
lin lick_N = mkTerm "lick_N" ;
lin lick_V2 = mkTerm "lick_V2" ;
lin licking_N = mkTerm "licking_N" ;
lin lid_N = mkTerm "lid_N" ;
lin lidar_N = mkTerm "lidar_N" ;
lin lidded_A = mkTerm "lidded_A" ;
lin lidless_A = mkTerm "lidless_A" ;
lin lido_N = mkTerm "lido_N" ;
lin lie_1_V = mkTerm "lie_1_V" ;
lin lie_2_V = mkTerm "lie_2_V" ;
lin lie_N = mkTerm "lie_N" ;
lin lie_VS = mkTerm "lie_VS" ;
lin lie_abed_N = mkTerm "lie_abed_N" ;
lin lie_around_V = mkTerm "lie_around_V" ;
lin lie_back_V = mkTerm "lie_back_V" ;
lin lie_detector_N = mkTerm "lie_detector_N" ;
lin lie_down_V = mkTerm "lie_down_V" ;
lin lie_down_on_V2 = mkTerm "lie_down_on_V2" ;
lin lie_in_N = mkTerm "lie_in_N" ;
lin lie_with_V2 = mkTerm "lie_with_V2" ;
lin liebfraumilch_N = mkTerm "liebfraumilch_N" ;
lin liechtenstein_PN = mkTerm "liechtenstein_PN" ;
lin liechtensteiner_A = mkTerm "liechtensteiner_A" ;
lin liechtensteiner_N = mkTerm "liechtensteiner_N" ;
lin lied_N = mkTerm "lied_N" ;
lin lieder_singer_N = mkTerm "lieder_singer_N" ;
lin lief_Adv = mkTerm "lief_Adv" ;
lin liege_A = mkTerm "liege_A" ;
lin liege_N = mkTerm "liege_N" ;
lin liege_PN = mkTerm "liege_PN" ;
lin liegeman_N = mkTerm "liegeman_N" ;
lin lieksa_PN = mkTerm "lieksa_PN" ;
lin lien_N = mkTerm "lien_N" ;
lin lieto_PN = mkTerm "lieto_PN" ;
lin lieu_N = mkTerm "lieu_N" ;
lin lieutenancy_N = mkTerm "lieutenancy_N" ;
lin lieutenant_N = mkTerm "lieutenant_N" ;
lin life_N = mkTerm "life_N" ;
lin life_buoy_N = mkTerm "life_buoy_N" ;
lin life_giving_A = mkTerm "life_giving_A" ;
lin life_jacket_N = mkTerm "life_jacket_N" ;
lin life_office_N = mkTerm "life_office_N" ;
lin life_preserver_N = mkTerm "life_preserver_N" ;
lin life_raft_N = mkTerm "life_raft_N" ;
lin life_saver_N = mkTerm "life_saver_N" ;
lin life_size_A = mkTerm "life_size_A" ;
lin life_sized_A = mkTerm "life_sized_A" ;
lin life_span_N = mkTerm "life_span_N" ;
lin life_work_N = mkTerm "life_work_N" ;
lin lifebelt_N = mkTerm "lifebelt_N" ;
lin lifeblood_N = mkTerm "lifeblood_N" ;
lin lifeboat_N = mkTerm "lifeboat_N" ;
lin lifebuoy_N = mkTerm "lifebuoy_N" ;
lin lifeguard_N = mkTerm "lifeguard_N" ;
lin lifeless_A = mkTerm "lifeless_A" ;
lin lifelike_A = mkTerm "lifelike_A" ;
lin lifeline_N = mkTerm "lifeline_N" ;
lin lifelong_A = mkTerm "lifelong_A" ;
lin lifer_N = mkTerm "lifer_N" ;
lin lifesaving_N = mkTerm "lifesaving_N" ;
lin lifestyle_N = mkTerm "lifestyle_N" ;
lin lifetime_N = mkTerm "lifetime_N" ;
lin lift_N = mkTerm "lift_N" ;
lin lift_V = mkTerm "lift_V" ;
lin lift_V2 = mkTerm "lift_V2" ;
lin lift_off_N = mkTerm "lift_off_N" ;
lin lift_off_V = mkTerm "lift_off_V" ;
lin liftman_N = mkTerm "liftman_N" ;
lin ligament_N = mkTerm "ligament_N" ;
lin ligand_N = mkTerm "ligand_N" ;
lin ligation_N = mkTerm "ligation_N" ;
lin ligature_N = mkTerm "ligature_N" ;
lin liger_N = mkTerm "liger_N" ;
lin light_1_A = mkTerm "light_1_A" ;
lin light_2_A = mkTerm "light_2_A" ;
lin light_Adv = mkTerm "light_Adv" ;
lin light_N = mkTerm "light_N" ;
lin light_V = mkTerm "light_V" ;
lin light_V2 = mkTerm "light_V2" ;
lin light_armed_A = mkTerm "light_armed_A" ;
lin light_coloured_A = mkTerm "light_coloured_A" ;
lin light_fingered_A = mkTerm "light_fingered_A" ;
lin light_handed_A = mkTerm "light_handed_A" ;
lin light_headed_A = mkTerm "light_headed_A" ;
lin light_headedness_N = mkTerm "light_headedness_N" ;
lin light_hearted_A = mkTerm "light_hearted_A" ;
lin light_heartedness_N = mkTerm "light_heartedness_N" ;
lin light_heavyweight_N = mkTerm "light_heavyweight_N" ;
lin light_minded_A = mkTerm "light_minded_A" ;
lin light_mindedness_N = mkTerm "light_mindedness_N" ;
lin light_o'_love_N = mkTerm "light_o'_love_N" ;
lin light_out_V = mkTerm "light_out_V" ;
lin light_up_V = mkTerm "light_up_V" ;
lin light_up_V2 = mkTerm "light_up_V2" ;
lin lighten_V = mkTerm "lighten_V" ;
lin lighten_V2 = mkTerm "lighten_V2" ;
lin lighten_up_V2 = mkTerm "lighten_up_V2" ;
lin lightening_N = mkTerm "lightening_N" ;
lin lighter_N = mkTerm "lighter_N" ;
lin lighter_V2 = mkTerm "lighter_V2" ;
lin lighterage_N = mkTerm "lighterage_N" ;
lin lighterman_N = mkTerm "lighterman_N" ;
lin lightgrey_N = mkTerm "lightgrey_N" ;
lin lighthouse_N = mkTerm "lighthouse_N" ;
lin lighting_N = mkTerm "lighting_N" ;
lin lighting_up_A = mkTerm "lighting_up_A" ;
lin lightless_A = mkTerm "lightless_A" ;
lin lightness_N = mkTerm "lightness_N" ;
lin lightning_N = mkTerm "lightning_N" ;
lin lightning_conductor_N = mkTerm "lightning_conductor_N" ;
lin lightning_rod_N = mkTerm "lightning_rod_N" ;
lin lightproof_A = mkTerm "lightproof_A" ;
lin lightsaber_N = mkTerm "lightsaber_N" ;
lin lightship_N = mkTerm "lightship_N" ;
lin lightsome_A = mkTerm "lightsome_A" ;
lin lightsomeness_N = mkTerm "lightsomeness_N" ;
lin lightweight_A = mkTerm "lightweight_A" ;
lin lightweight_N = mkTerm "lightweight_N" ;
lin lightwood_N = mkTerm "lightwood_N" ;
lin ligne_N = mkTerm "ligne_N" ;
lin ligneous_A = mkTerm "ligneous_A" ;
lin lignin_N = mkTerm "lignin_N" ;
lin lignite_N = mkTerm "lignite_N" ;
lin lignosae_N = mkTerm "lignosae_N" ;
lin lignum_N = mkTerm "lignum_N" ;
lin ligule_N = mkTerm "ligule_N" ;
lin likable_A = mkTerm "likable_A" ;
lin like_A = mkTerm "like_A" ;
lin like_N = mkTerm "like_N" ;
lin like_Prep = mkTerm "like_Prep" ;
lin like_Subj = mkTerm "like_Subj" ;
lin like_V2 = mkTerm "like_V2" ;
lin like_VS = mkTerm "like_VS" ;
lin like_VV = mkTerm "like_VV" ;
lin like_minded_A = mkTerm "like_minded_A" ;
lin likeable_A = mkTerm "likeable_A" ;
lin likelihood_N = mkTerm "likelihood_N" ;
lin likely_A = mkTerm "likely_A" ;
lin liken_V2 = mkTerm "liken_V2" ;
lin likeness_N = mkTerm "likeness_N" ;
lin likening_N = mkTerm "likening_N" ;
lin likewise_Adv = mkTerm "likewise_Adv" ;
lin liking_N = mkTerm "liking_N" ;
lin likuta_N = mkTerm "likuta_N" ;
lin lilac_N = mkTerm "lilac_N" ;
lin lilangeni_N = mkTerm "lilangeni_N" ;
lin liliaceous_A = mkTerm "liliaceous_A" ;
lin lilian_PN = mkTerm "lilian_PN" ;
lin liljendal_PN = mkTerm "liljendal_PN" ;
lin lille_PN = mkTerm "lille_PN" ;
lin lilliputian_A = mkTerm "lilliputian_A" ;
lin lilliputian_N = mkTerm "lilliputian_N" ;
lin lilt_N = mkTerm "lilt_N" ;
lin lilt_V = mkTerm "lilt_V" ;
lin lilt_V2 = mkTerm "lilt_V2" ;
lin lily_N = mkTerm "lily_N" ;
lin lily_PN = mkTerm "lily_PN" ;
lin lily_livered_A = mkTerm "lily_livered_A" ;
lin lily_white_A = mkTerm "lily_white_A" ;
lin lilyturf_N = mkTerm "lilyturf_N" ;
lin lima_PN = mkTerm "lima_PN" ;
lin limacine_A = mkTerm "limacine_A" ;
lin liman_N = mkTerm "liman_N" ;
lin limb_N = mkTerm "limb_N" ;
lin limbed_A = mkTerm "limbed_A" ;
lin limber_A = mkTerm "limber_A" ;
lin limber_N = mkTerm "limber_N" ;
lin limber_V = mkTerm "limber_V" ;
lin limber_V2 = mkTerm "limber_V2" ;
lin limber_up_V = mkTerm "limber_up_V" ;
lin limber_up_for_V2 = mkTerm "limber_up_for_V2" ;
lin limbers_N = mkTerm "limbers_N" ;
lin limbic_A = mkTerm "limbic_A" ;
lin limbless_A = mkTerm "limbless_A" ;
lin limbo_N = mkTerm "limbo_N" ;
lin limbus_N = mkTerm "limbus_N" ;
lin lime_1_N = mkTerm "lime_1_N" ;
lin lime_2_N = mkTerm "lime_2_N" ;
lin lime_V2 = mkTerm "lime_V2" ;
lin lime_tree_N = mkTerm "lime_tree_N" ;
lin limeade_N = mkTerm "limeade_N" ;
lin limejuice_N = mkTerm "limejuice_N" ;
lin limekiln_N = mkTerm "limekiln_N" ;
lin limelight_N = mkTerm "limelight_N" ;
lin limerick_N = mkTerm "limerick_N" ;
lin limerick_PN = mkTerm "limerick_PN" ;
lin limestone_N = mkTerm "limestone_N" ;
lin limewater_N = mkTerm "limewater_N" ;
lin limey_N = mkTerm "limey_N" ;
lin liminka_PN = mkTerm "liminka_PN" ;
lin limit_N = mkTerm "limit_N" ;
lin limit_V2 = mkTerm "limit_V2" ;
lin limit_V2V = mkTerm "limit_V2V" ;
lin limitation_N = mkTerm "limitation_N" ;
lin limited_A = mkTerm "limited_A" ;
lin limiter_N = mkTerm "limiter_N" ;
lin limiting_A = mkTerm "limiting_A" ;
lin limitless_A = mkTerm "limitless_A" ;
lin limn_V2 = mkTerm "limn_V2" ;
lin limnological_A = mkTerm "limnological_A" ;
lin limnologist_N = mkTerm "limnologist_N" ;
lin limnology_N = mkTerm "limnology_N" ;
lin limoges_PN = mkTerm "limoges_PN" ;
lin limonene_N = mkTerm "limonene_N" ;
lin limonite_N = mkTerm "limonite_N" ;
lin limousine_N = mkTerm "limousine_N" ;
lin limp_A = mkTerm "limp_A" ;
lin limp_N = mkTerm "limp_N" ;
lin limp_V = mkTerm "limp_V" ;
lin limpa_N = mkTerm "limpa_N" ;
lin limpet_N = mkTerm "limpet_N" ;
lin limpid_A = mkTerm "limpid_A" ;
lin limpidity_N = mkTerm "limpidity_N" ;
lin limpkin_N = mkTerm "limpkin_N" ;
lin limpness_N = mkTerm "limpness_N" ;
lin linage_N = mkTerm "linage_N" ;
lin linalool_N = mkTerm "linalool_N" ;
lin linchpin_N = mkTerm "linchpin_N" ;
lin lincoln_PN = mkTerm "lincoln_PN" ;
lin lincolnshire_PN = mkTerm "lincolnshire_PN" ;
lin lincomycin_N = mkTerm "lincomycin_N" ;
lin linda_PN = mkTerm "linda_PN" ;
lin lindane_N = mkTerm "lindane_N" ;
lin linden_N = mkTerm "linden_N" ;
lin linden_tree_N = mkTerm "linden_tree_N" ;
lin lindy_N = mkTerm "lindy_N" ;
lin line_N = mkTerm "line_N" ;
lin line_V = mkTerm "line_V" ;
lin line_V2 = mkTerm "line_V2" ;
lin line_shooter_N = mkTerm "line_shooter_N" ;
lin line_shooting_N = mkTerm "line_shooting_N" ;
lin line_up_N = mkTerm "line_up_N" ;
lin line_up_V = mkTerm "line_up_V" ;
lin line_up_V2 = mkTerm "line_up_V2" ;
lin lineage_N = mkTerm "lineage_N" ;
lin lineal_A = mkTerm "lineal_A" ;
lin lineament_N = mkTerm "lineament_N" ;
lin linear_A = mkTerm "linear_A" ;
lin lineation_N = mkTerm "lineation_N" ;
lin linebacker_N = mkTerm "linebacker_N" ;
lin linecut_N = mkTerm "linecut_N" ;
lin linelike_A = mkTerm "linelike_A" ;
lin lineman_N = mkTerm "lineman_N" ;
lin linen_N = mkTerm "linen_N" ;
lin linen_draper_N = mkTerm "linen_draper_N" ;
lin liner_N = mkTerm "liner_N" ;
lin liner_train_N = mkTerm "liner_train_N" ;
lin linesman_N = mkTerm "linesman_N" ;
lin ling_N = mkTerm "ling_N" ;
lin lingam_N = mkTerm "lingam_N" ;
lin lingcod_N = mkTerm "lingcod_N" ;
lin linger_V = mkTerm "linger_V" ;
lin lingerer_N = mkTerm "lingerer_N" ;
lin lingerie_N = mkTerm "lingerie_N" ;
lin lingeringly_Adv = mkTerm "lingeringly_Adv" ;
lin lingo_N = mkTerm "lingo_N" ;
lin lingonberry_N = mkTerm "lingonberry_N" ;
lin lingua_franca_N = mkTerm "lingua_franca_N" ;
lin lingual_A = mkTerm "lingual_A" ;
lin lingual_N = mkTerm "lingual_N" ;
lin linguica_N = mkTerm "linguica_N" ;
lin linguine_N = mkTerm "linguine_N" ;
lin linguist_N = mkTerm "linguist_N" ;
lin linguistic_A = mkTerm "linguistic_A" ;
lin linguistics_N = mkTerm "linguistics_N" ;
lin lingulate_A = mkTerm "lingulate_A" ;
lin liniment_N = mkTerm "liniment_N" ;
lin linin_N = mkTerm "linin_N" ;
lin lining_N = mkTerm "lining_N" ;
lin link_N = mkTerm "link_N" ;
lin link_V = mkTerm "link_V" ;
lin link_V2 = mkTerm "link_V2" ;
lin link_up_N = mkTerm "link_up_N" ;
lin link_up_V2 = mkTerm "link_up_V2" ;
lin link_up_with_V2 = mkTerm "link_up_with_V2" ;
lin linkage_N = mkTerm "linkage_N" ;
lin linkboy_N = mkTerm "linkboy_N" ;
lin linkman_N = mkTerm "linkman_N" ;
lin links_N = mkTerm "links_N" ;
lin linlithgow_PN = mkTerm "linlithgow_PN" ;
lin linnet_N = mkTerm "linnet_N" ;
lin lino_N = mkTerm "lino_N" ;
lin linocut_N = mkTerm "linocut_N" ;
lin linoleum_N = mkTerm "linoleum_N" ;
lin linotype_N = mkTerm "linotype_N" ;
lin linseed_N = mkTerm "linseed_N" ;
lin linsey_woolsey_N = mkTerm "linsey_woolsey_N" ;
lin linstock_N = mkTerm "linstock_N" ;
lin lint_N = mkTerm "lint_N" ;
lin lintel_N = mkTerm "lintel_N" ;
lin linuron_N = mkTerm "linuron_N" ;
lin linwood_PN = mkTerm "linwood_PN" ;
lin linz_PN = mkTerm "linz_PN" ;
lin lion_N = mkTerm "lion_N" ;
lin lion_hearted_A = mkTerm "lion_hearted_A" ;
lin lion_hunter_N = mkTerm "lion_hunter_N" ;
lin lionel_PN = mkTerm "lionel_PN" ;
lin lioness_N = mkTerm "lioness_N" ;
lin lionet_N = mkTerm "lionet_N" ;
lin lionfish_N = mkTerm "lionfish_N" ;
lin lionize_V2 = mkTerm "lionize_V2" ;
lin lip_N = mkTerm "lip_N" ;
lin lip_read_V2 = mkTerm "lip_read_V2" ;
lin lip_reading_N = mkTerm "lip_reading_N" ;
lin liparis_N = mkTerm "liparis_N" ;
lin lipase_N = mkTerm "lipase_N" ;
lin lipectomy_N = mkTerm "lipectomy_N" ;
lin lipemia_N = mkTerm "lipemia_N" ;
lin liperi_PN = mkTerm "liperi_PN" ;
lin lipid_N = mkTerm "lipid_N" ;
lin lipidosis_N = mkTerm "lipidosis_N" ;
lin lipless_A = mkTerm "lipless_A" ;
lin lipogram_N = mkTerm "lipogram_N" ;
lin lipoma_N = mkTerm "lipoma_N" ;
lin lipomatosis_N = mkTerm "lipomatosis_N" ;
lin lipophilic_A = mkTerm "lipophilic_A" ;
lin lipoprotein_N = mkTerm "lipoprotein_N" ;
lin liposarcoma_N = mkTerm "liposarcoma_N" ;
lin liposome_N = mkTerm "liposome_N" ;
lin liposuction_N = mkTerm "liposuction_N" ;
lin lipped_A = mkTerm "lipped_A" ;
lin lipstick_N = mkTerm "lipstick_N" ;
lin liquefaction_N = mkTerm "liquefaction_N" ;
lin liquefiable_A = mkTerm "liquefiable_A" ;
lin liquefy_V = mkTerm "liquefy_V" ;
lin liquefy_V2 = mkTerm "liquefy_V2" ;
lin liquescent_A = mkTerm "liquescent_A" ;
lin liqueur_N = mkTerm "liqueur_N" ;
lin liquid_A = mkTerm "liquid_A" ;
lin liquid_N = mkTerm "liquid_N" ;
lin liquidambar_N = mkTerm "liquidambar_N" ;
lin liquidate_V = mkTerm "liquidate_V" ;
lin liquidate_V2 = mkTerm "liquidate_V2" ;
lin liquidation_N = mkTerm "liquidation_N" ;
lin liquidator_N = mkTerm "liquidator_N" ;
lin liquidity_N = mkTerm "liquidity_N" ;
lin liquidize_V2 = mkTerm "liquidize_V2" ;
lin liquidizer_N = mkTerm "liquidizer_N" ;
lin liquor_N = mkTerm "liquor_N" ;
lin liquorice_N = mkTerm "liquorice_N" ;
lin lira_N = mkTerm "lira_N" ;
lin lisa_N = mkTerm "lisa_N" ;
lin lisa_PN = mkTerm "lisa_PN" ;
lin lisbon_PN = mkTerm "lisbon_PN" ;
lin lisinopril_N = mkTerm "lisinopril_N" ;
lin liskeard_PN = mkTerm "liskeard_PN" ;
lin lisle_N = mkTerm "lisle_N" ;
lin lisp_N = mkTerm "lisp_N" ;
lin lisp_V = mkTerm "lisp_V" ;
lin lisp_V2 = mkTerm "lisp_V2" ;
lin lisper_N = mkTerm "lisper_N" ;
lin lispingly_Adv = mkTerm "lispingly_Adv" ;
lin lissom_A = mkTerm "lissom_A" ;
lin lissome_A = mkTerm "lissome_A" ;
lin lissomeness_N = mkTerm "lissomeness_N" ;
lin lissomness_N = mkTerm "lissomness_N" ;
lin list_N = mkTerm "list_N" ;
lin list_V = mkTerm "list_V" ;
lin list_V2 = mkTerm "list_V2" ;
lin list_V2V = mkTerm "list_V2V" ;
lin list_of_N2 = mkTerm "list_of_N2" ;
lin list_price_N = mkTerm "list_price_N" ;
lin listen_V = mkTerm "listen_V" ;
lin listen_in_V = mkTerm "listen_in_V" ;
lin listen_out_for_V2 = mkTerm "listen_out_for_V2" ;
lin listen_up_V = mkTerm "listen_up_V" ;
lin listenerFem_N = mkTerm "listenerFem_N" ;
lin listenerMasc_N = mkTerm "listenerMasc_N" ;
lin listening_N = mkTerm "listening_N" ;
lin lister_N = mkTerm "lister_N" ;
lin listeria_N = mkTerm "listeria_N" ;
lin listeriosis_N = mkTerm "listeriosis_N" ;
lin listing_N = mkTerm "listing_N" ;
lin listless_A = mkTerm "listless_A" ;
lin listlessness_N = mkTerm "listlessness_N" ;
lin lit_V2 = mkTerm "lit_V2" ;
lin litany_N = mkTerm "litany_N" ;
lin litas_N = mkTerm "litas_N" ;
lin literacy_N = mkTerm "literacy_N" ;
lin literal_A = mkTerm "literal_A" ;
lin literal_N = mkTerm "literal_N" ;
lin literalism_N = mkTerm "literalism_N" ;
lin literalness_N = mkTerm "literalness_N" ;
lin literary_A = mkTerm "literary_A" ;
lin literate_A = mkTerm "literate_A" ;
lin literate_N = mkTerm "literate_N" ;
lin literati_N = mkTerm "literati_N" ;
lin literatim_Adv = mkTerm "literatim_Adv" ;
lin literature_N = mkTerm "literature_N" ;
lin lithe_A = mkTerm "lithe_A" ;
lin lithiasis_N = mkTerm "lithiasis_N" ;
lin lithic_A = mkTerm "lithic_A" ;
lin lithium_N = mkTerm "lithium_N" ;
lin lithograph_N = mkTerm "lithograph_N" ;
lin lithograph_V = mkTerm "lithograph_V" ;
lin lithograph_V2 = mkTerm "lithograph_V2" ;
lin lithographer_N = mkTerm "lithographer_N" ;
lin lithographic_A = mkTerm "lithographic_A" ;
lin lithography_N = mkTerm "lithography_N" ;
lin lithomancer_N = mkTerm "lithomancer_N" ;
lin lithomancy_N = mkTerm "lithomancy_N" ;
lin lithomantic_A = mkTerm "lithomantic_A" ;
lin lithophyte_N = mkTerm "lithophyte_N" ;
lin lithophytic_A = mkTerm "lithophytic_A" ;
lin lithops_N = mkTerm "lithops_N" ;
lin lithosphere_N = mkTerm "lithosphere_N" ;
lin lithotomy_N = mkTerm "lithotomy_N" ;
lin lithuresis_N = mkTerm "lithuresis_N" ;
lin litigant_N = mkTerm "litigant_N" ;
lin litigate_V = mkTerm "litigate_V" ;
lin litigate_V2 = mkTerm "litigate_V2" ;
lin litigation_N = mkTerm "litigation_N" ;
lin litigious_A = mkTerm "litigious_A" ;
lin litigiousness_N = mkTerm "litigiousness_N" ;
lin litmus_N = mkTerm "litmus_N" ;
lin litmus_paper_N = mkTerm "litmus_paper_N" ;
lin litotes_N = mkTerm "litotes_N" ;
lin litre_N = mkTerm "litre_N" ;
lin litter_N = mkTerm "litter_N" ;
lin litter_V = mkTerm "litter_V" ;
lin litter_V2 = mkTerm "litter_V2" ;
lin litter_basket_N = mkTerm "litter_basket_N" ;
lin litter_lout_N = mkTerm "litter_lout_N" ;
lin litterbin_N = mkTerm "litterbin_N" ;
lin litterer_N = mkTerm "litterer_N" ;
lin little_A = mkTerm "little_A" ;
lin little_Det = mkTerm "little_Det" ;
lin little_N = mkTerm "little_N" ;
lin littlehampton_PN = mkTerm "littlehampton_PN" ;
lin littleneck_N = mkTerm "littleneck_N" ;
lin littleness_N = mkTerm "littleness_N" ;
lin littoral_A = mkTerm "littoral_A" ;
lin littoral_N = mkTerm "littoral_N" ;
lin liturgical_A = mkTerm "liturgical_A" ;
lin liturgics_N = mkTerm "liturgics_N" ;
lin liturgist_N = mkTerm "liturgist_N" ;
lin liturgy_N = mkTerm "liturgy_N" ;
lin livable_A = mkTerm "livable_A" ;
lin live_A = mkTerm "live_A" ;
lin live_Adv = mkTerm "live_Adv" ;
lin live_V = mkTerm "live_V" ;
lin live_birth_N = mkTerm "live_birth_N" ;
lin live_by_V2 = mkTerm "live_by_V2" ;
lin live_down_V2 = mkTerm "live_down_V2" ;
lin live_for_V2 = mkTerm "live_for_V2" ;
lin live_in_V = mkTerm "live_in_V" ;
lin live_it_up_V2 = mkTerm "live_it_up_V2" ;
lin live_off_V2 = mkTerm "live_off_V2" ;
lin live_on_V = mkTerm "live_on_V" ;
lin live_on_V2 = mkTerm "live_on_V2" ;
lin live_out_V = mkTerm "live_out_V" ;
lin live_out_V2 = mkTerm "live_out_V2" ;
lin live_through_V2 = mkTerm "live_through_V2" ;
lin live_together_V = mkTerm "live_together_V" ;
lin live_up_V = mkTerm "live_up_V" ;
lin live_up_to_V2 = mkTerm "live_up_to_V2" ;
lin live_with_V2 = mkTerm "live_with_V2" ;
lin liveable_A = mkTerm "liveable_A" ;
lin liveborn_A = mkTerm "liveborn_A" ;
lin livedo_N = mkTerm "livedo_N" ;
lin livelihood_N = mkTerm "livelihood_N" ;
lin liveliness_N = mkTerm "liveliness_N" ;
lin livelong_A = mkTerm "livelong_A" ;
lin lively_A = mkTerm "lively_A" ;
lin liven_V = mkTerm "liven_V" ;
lin liven_V2 = mkTerm "liven_V2" ;
lin liver_N = mkTerm "liver_N" ;
lin liveried_A = mkTerm "liveried_A" ;
lin liverish_A = mkTerm "liverish_A" ;
lin liverpool_PN = mkTerm "liverpool_PN" ;
lin liverpudlian_A = mkTerm "liverpudlian_A" ;
lin liverpudlian_N = mkTerm "liverpudlian_N" ;
lin liverwort_N = mkTerm "liverwort_N" ;
lin liverwurst_N = mkTerm "liverwurst_N" ;
lin livery_A = mkTerm "livery_A" ;
lin livery_N = mkTerm "livery_N" ;
lin liveryman_N = mkTerm "liveryman_N" ;
lin livestock_N = mkTerm "livestock_N" ;
lin livid_A = mkTerm "livid_A" ;
lin lividity_N = mkTerm "lividity_N" ;
lin lividness_N = mkTerm "lividness_N" ;
lin living_A = mkTerm "living_A" ;
lin living_N = mkTerm "living_N" ;
lin living_room_N = mkTerm "living_room_N" ;
lin living_space_N = mkTerm "living_space_N" ;
lin livingston_PN = mkTerm "livingston_PN" ;
lin livorno_PN = mkTerm "livorno_PN" ;
lin liz_PN = mkTerm "liz_PN" ;
lin liza_N = mkTerm "liza_N" ;
lin liza_PN = mkTerm "liza_PN" ;
lin lizard_N = mkTerm "lizard_N" ;
lin lizardfish_N = mkTerm "lizardfish_N" ;
lin lizzy_PN = mkTerm "lizzy_PN" ;
lin ljubljana_PN = mkTerm "ljubljana_PN" ;
lin llama_N = mkTerm "llama_N" ;
lin llandudno_PN = mkTerm "llandudno_PN" ;
lin llanelli_PN = mkTerm "llanelli_PN" ;
lin llangollen_PN = mkTerm "llangollen_PN" ;
lin llano_N = mkTerm "llano_N" ;
lin llantrisant_PN = mkTerm "llantrisant_PN" ;
lin llantwit_major_PN = mkTerm "llantwit_major_PN" ;
lin llb_N = mkTerm "llb_N" ;
lin lloyd's_PN = mkTerm "lloyd's_PN" ;
lin loach_N = mkTerm "loach_N" ;
lin load_N = mkTerm "load_N" ;
lin load_V = mkTerm "load_V" ;
lin load_V2 = mkTerm "load_V2" ;
lin load_down_V = mkTerm "load_down_V" ;
lin load_line_N = mkTerm "load_line_N" ;
lin load_shedding_N = mkTerm "load_shedding_N" ;
lin load_up_V = mkTerm "load_up_V" ;
lin load_up_V2 = mkTerm "load_up_V2" ;
lin load_up_on_V2 = mkTerm "load_up_on_V2" ;
lin loader_N = mkTerm "loader_N" ;
lin loading_N = mkTerm "loading_N" ;
lin loadstar_N = mkTerm "loadstar_N" ;
lin loadstone_N = mkTerm "loadstone_N" ;
lin loaf_N = mkTerm "loaf_N" ;
lin loaf_V = mkTerm "loaf_V" ;
lin loaf_V2 = mkTerm "loaf_V2" ;
lin loaf_sugar_N = mkTerm "loaf_sugar_N" ;
lin loafer_N = mkTerm "loafer_N" ;
lin loam_N = mkTerm "loam_N" ;
lin loamless_A = mkTerm "loamless_A" ;
lin loamy_A = mkTerm "loamy_A" ;
lin loan_N = mkTerm "loan_N" ;
lin loan_V2 = mkTerm "loan_V2" ;
lin loan_collection_N = mkTerm "loan_collection_N" ;
lin loan_office_N = mkTerm "loan_office_N" ;
lin loan_out_V = mkTerm "loan_out_V" ;
lin loanblend_N = mkTerm "loanblend_N" ;
lin loaner_N = mkTerm "loaner_N" ;
lin loanhead_PN = mkTerm "loanhead_PN" ;
lin loanword_N = mkTerm "loanword_N" ;
lin loasa_N = mkTerm "loasa_N" ;
lin loath_A = mkTerm "loath_A" ;
lin loathe_V2 = mkTerm "loathe_V2" ;
lin loathing_N = mkTerm "loathing_N" ;
lin loathly_A = mkTerm "loathly_A" ;
lin loathsome_A = mkTerm "loathsome_A" ;
lin loathsomeness_N = mkTerm "loathsomeness_N" ;
lin lob_N = mkTerm "lob_N" ;
lin lob_V = mkTerm "lob_V" ;
lin lob_V2 = mkTerm "lob_V2" ;
lin lobar_A = mkTerm "lobar_A" ;
lin lobate_A = mkTerm "lobate_A" ;
lin lobby_N = mkTerm "lobby_N" ;
lin lobby_V = mkTerm "lobby_V" ;
lin lobby_V2 = mkTerm "lobby_V2" ;
lin lobby_V2V = mkTerm "lobby_V2V" ;
lin lobbyism_N = mkTerm "lobbyism_N" ;
lin lobbyist_N = mkTerm "lobbyist_N" ;
lin lobe_N = mkTerm "lobe_N" ;
lin lobectomy_N = mkTerm "lobectomy_N" ;
lin lobed_A = mkTerm "lobed_A" ;
lin lobelia_N = mkTerm "lobelia_N" ;
lin lobeliaceous_A = mkTerm "lobeliaceous_A" ;
lin loblolly_N = mkTerm "loblolly_N" ;
lin lobotomy_N = mkTerm "lobotomy_N" ;
lin lobscouse_N = mkTerm "lobscouse_N" ;
lin lobster_N = mkTerm "lobster_N" ;
lin lobster_pot_N = mkTerm "lobster_pot_N" ;
lin lobsterman_N = mkTerm "lobsterman_N" ;
lin lobular_A = mkTerm "lobular_A" ;
lin lobularity_N = mkTerm "lobularity_N" ;
lin lobule_N = mkTerm "lobule_N" ;
lin loc_cit_PN = mkTerm "loc_cit_PN" ;
lin local_A = mkTerm "local_A" ;
lin local_N = mkTerm "local_N" ;
lin locale_N = mkTerm "locale_N" ;
lin localism_N = mkTerm "localism_N" ;
lin locality_N = mkTerm "locality_N" ;
lin localization_N = mkTerm "localization_N" ;
lin localize_V2 = mkTerm "localize_V2" ;
lin locate_V = mkTerm "locate_V" ;
lin locate_V2 = mkTerm "locate_V2" ;
lin location_N = mkTerm "location_N" ;
lin locator_N = mkTerm "locator_N" ;
lin loch_N = mkTerm "loch_N" ;
lin lochgelly_PN = mkTerm "lochgelly_PN" ;
lin lochia_N = mkTerm "lochia_N" ;
lin lock_N = mkTerm "lock_N" ;
lin lock_V = mkTerm "lock_V" ;
lin lock_V2 = mkTerm "lock_V2" ;
lin lock_away_V2 = mkTerm "lock_away_V2" ;
lin lock_down_V2 = mkTerm "lock_down_V2" ;
lin lock_gate_N = mkTerm "lock_gate_N" ;
lin lock_in_V2 = mkTerm "lock_in_V2" ;
lin lock_keeper_N = mkTerm "lock_keeper_N" ;
lin lock_onto_V2 = mkTerm "lock_onto_V2" ;
lin lock_out_V2 = mkTerm "lock_out_V2" ;
lin lock_up_V2 = mkTerm "lock_up_V2" ;
lin lock_yourself_away_V = mkTerm "lock_yourself_away_V" ;
lin lockage_N = mkTerm "lockage_N" ;
lin lockdown_N = mkTerm "lockdown_N" ;
lin locker_N = mkTerm "locker_N" ;
lin locket_N = mkTerm "locket_N" ;
lin locking_N = mkTerm "locking_N" ;
lin lockjaw_N = mkTerm "lockjaw_N" ;
lin lockmaster_N = mkTerm "lockmaster_N" ;
lin locknut_N = mkTerm "locknut_N" ;
lin lockout_N = mkTerm "lockout_N" ;
lin lockring_N = mkTerm "lockring_N" ;
lin locksmith_N = mkTerm "locksmith_N" ;
lin lockstep_N = mkTerm "lockstep_N" ;
lin lockstitch_N = mkTerm "lockstitch_N" ;
lin lockup_A = mkTerm "lockup_A" ;
lin lockup_N = mkTerm "lockup_N" ;
lin loco_A = mkTerm "loco_A" ;
lin locomotion_N = mkTerm "locomotion_N" ;
lin locomotive_A = mkTerm "locomotive_A" ;
lin locomotive_N = mkTerm "locomotive_N" ;
lin locoweed_N = mkTerm "locoweed_N" ;
lin locule_N = mkTerm "locule_N" ;
lin locum_N = mkTerm "locum_N" ;
lin locum_tenens_N = mkTerm "locum_tenens_N" ;
lin locus_N = mkTerm "locus_N" ;
lin locus_classicus_N = mkTerm "locus_classicus_N" ;
lin locust_N = mkTerm "locust_N" ;
lin locust_tree_N = mkTerm "locust_tree_N" ;
lin locution_N = mkTerm "locution_N" ;
lin lode_N = mkTerm "lode_N" ;
lin lodestar_N = mkTerm "lodestar_N" ;
lin lodestone_N = mkTerm "lodestone_N" ;
lin lodge_N = mkTerm "lodge_N" ;
lin lodge_V = mkTerm "lodge_V" ;
lin lodge_V2 = mkTerm "lodge_V2" ;
lin lodgement_N = mkTerm "lodgement_N" ;
lin lodger_N = mkTerm "lodger_N" ;
lin lodging_N = mkTerm "lodging_N" ;
lin lodging_house_N = mkTerm "lodging_house_N" ;
lin lodgment_N = mkTerm "lodgment_N" ;
lin lodz_PN = mkTerm "lodz_PN" ;
lin loess_N = mkTerm "loess_N" ;
lin loft_N = mkTerm "loft_N" ;
lin loft_V2 = mkTerm "loft_V2" ;
lin loftiness_N = mkTerm "loftiness_N" ;
lin loftus_PN = mkTerm "loftus_PN" ;
lin lofty_A = mkTerm "lofty_A" ;
lin log_N = mkTerm "log_N" ;
lin log_V2 = mkTerm "log_V2" ;
lin log_cabin_N = mkTerm "log_cabin_N" ;
lin log_in_V = mkTerm "log_in_V" ;
lin log_into_V2 = mkTerm "log_into_V2" ;
lin log_jam_N = mkTerm "log_jam_N" ;
lin log_off_V2 = mkTerm "log_off_V2" ;
lin log_on_V2 = mkTerm "log_on_V2" ;
lin log_out_V = mkTerm "log_out_V" ;
lin log_rolling_N = mkTerm "log_rolling_N" ;
lin loganberry_N = mkTerm "loganberry_N" ;
lin logarithm_N = mkTerm "logarithm_N" ;
lin logarithmic_A = mkTerm "logarithmic_A" ;
lin logbook_N = mkTerm "logbook_N" ;
lin loge_N = mkTerm "loge_N" ;
lin loggerhead_N = mkTerm "loggerhead_N" ;
lin loggerheads_N = mkTerm "loggerheads_N" ;
lin loggia_N = mkTerm "loggia_N" ;
lin logging_N = mkTerm "logging_N" ;
lin logic_N = mkTerm "logic_N" ;
lin logical_A = mkTerm "logical_A" ;
lin logicality_N = mkTerm "logicality_N" ;
lin logician_N = mkTerm "logician_N" ;
lin logicism_N = mkTerm "logicism_N" ;
lin loginess_N = mkTerm "loginess_N" ;
lin logion_N = mkTerm "logion_N" ;
lin logistic_A = mkTerm "logistic_A" ;
lin logistical_A = mkTerm "logistical_A" ;
lin logistics_N = mkTerm "logistics_N" ;
lin logo_N = mkTerm "logo_N" ;
lin logogram_N = mkTerm "logogram_N" ;
lin logogrammatic_A = mkTerm "logogrammatic_A" ;
lin logomach_N = mkTerm "logomach_N" ;
lin logomachy_N = mkTerm "logomachy_N" ;
lin logorrhea_N = mkTerm "logorrhea_N" ;
lin logwood_N = mkTerm "logwood_N" ;
lin lohja_PN = mkTerm "lohja_PN" ;
lin lohtaja_PN = mkTerm "lohtaja_PN" ;
lin loimaa_PN = mkTerm "loimaa_PN" ;
lin loin_N = mkTerm "loin_N" ;
lin loincloth_N = mkTerm "loincloth_N" ;
lin loins_N = mkTerm "loins_N" ;
lin loir_N = mkTerm "loir_N" ;
lin lois_PN = mkTerm "lois_PN" ;
lin loiter_V = mkTerm "loiter_V" ;
lin loiter_V2 = mkTerm "loiter_V2" ;
lin loiterer_N = mkTerm "loiterer_N" ;
lin loligo_N = mkTerm "loligo_N" ;
lin loll_V = mkTerm "loll_V" ;
lin loll_V2 = mkTerm "loll_V2" ;
lin lollipop_N = mkTerm "lollipop_N" ;
lin lolly_N = mkTerm "lolly_N" ;
lin lomatia_N = mkTerm "lomatia_N" ;
lin loment_N = mkTerm "loment_N" ;
lin lomustine_N = mkTerm "lomustine_N" ;
lin london_PN = mkTerm "london_PN" ;
lin londonderry_PN = mkTerm "londonderry_PN" ;
lin londoner_N = mkTerm "londoner_N" ;
lin lone_A = mkTerm "lone_A" ;
lin loneliness_N = mkTerm "loneliness_N" ;
lin lonely_A = mkTerm "lonely_A" ;
lin loner_N = mkTerm "loner_N" ;
lin lonesome_A = mkTerm "lonesome_A" ;
lin long_A = mkTerm "long_A" ;
lin long_N = mkTerm "long_N" ;
lin long_V = mkTerm "long_V" ;
lin long_distance_A = mkTerm "long_distance_A" ;
lin long_drawn_out_A = mkTerm "long_drawn_out_A" ;
lin long_eaton_PN = mkTerm "long_eaton_PN" ;
lin long_haired_A = mkTerm "long_haired_A" ;
lin long_headed_A = mkTerm "long_headed_A" ;
lin long_lived_A = mkTerm "long_lived_A" ;
lin long_play_A = mkTerm "long_play_A" ;
lin long_playing_A = mkTerm "long_playing_A" ;
lin long_range_A = mkTerm "long_range_A" ;
lin long_sighted_A = mkTerm "long_sighted_A" ;
lin long_standing_A = mkTerm "long_standing_A" ;
lin long_suffering_A = mkTerm "long_suffering_A" ;
lin long_term_A = mkTerm "long_term_A" ;
lin long_time_A = mkTerm "long_time_A" ;
lin long_winded_A = mkTerm "long_winded_A" ;
lin long_windedness_N = mkTerm "long_windedness_N" ;
lin longan_N = mkTerm "longan_N" ;
lin longanberry_N = mkTerm "longanberry_N" ;
lin longboat_N = mkTerm "longboat_N" ;
lin longbow_N = mkTerm "longbow_N" ;
lin longbowman_N = mkTerm "longbowman_N" ;
lin longer_Adv = mkTerm "longer_Adv" ;
lin longer_N = mkTerm "longer_N" ;
lin longest_Adv = mkTerm "longest_Adv" ;
lin longevity_N = mkTerm "longevity_N" ;
lin longhand_A = mkTerm "longhand_A" ;
lin longhand_N = mkTerm "longhand_N" ;
lin longhorn_N = mkTerm "longhorn_N" ;
lin longing_N = mkTerm "longing_N" ;
lin longingly_Adv = mkTerm "longingly_Adv" ;
lin longish_A = mkTerm "longish_A" ;
lin longitude_N = mkTerm "longitude_N" ;
lin longitudinal_A = mkTerm "longitudinal_A" ;
lin longness_N = mkTerm "longness_N" ;
lin longridge_PN = mkTerm "longridge_PN" ;
lin longshoreman_N = mkTerm "longshoreman_N" ;
lin longshot_N = mkTerm "longshot_N" ;
lin longton_PN = mkTerm "longton_PN" ;
lin longueur_N = mkTerm "longueur_N" ;
lin longways_Adv = mkTerm "longways_Adv" ;
lin longways_N = mkTerm "longways_N" ;
lin longwise_Adv = mkTerm "longwise_Adv" ;
lin longwool_N = mkTerm "longwool_N" ;
lin loo_N = mkTerm "loo_N" ;
lin loofa_N = mkTerm "loofa_N" ;
lin loofah_N = mkTerm "loofah_N" ;
lin look_N = mkTerm "look_N" ;
lin look_V = mkTerm "look_V" ;
lin look_V2 = mkTerm "look_V2" ;
lin look_VA = mkTerm "look_VA" ;
lin look_after_V2 = mkTerm "look_after_V2" ;
lin look_ahead_to_V2 = mkTerm "look_ahead_to_V2" ;
lin look_around_V = mkTerm "look_around_V" ;
lin look_around_at_V2 = mkTerm "look_around_at_V2" ;
lin look_at_V2 = mkTerm "look_at_V2" ;
lin look_back_V = mkTerm "look_back_V" ;
lin look_back_on_V2 = mkTerm "look_back_on_V2" ;
lin look_down_V = mkTerm "look_down_V" ;
lin look_down_on_V2 = mkTerm "look_down_on_V2" ;
lin look_for_V2 = mkTerm "look_for_V2" ;
lin look_forward_V = mkTerm "look_forward_V" ;
lin look_forward_to_V2 = mkTerm "look_forward_to_V2" ;
lin look_in_V2 = mkTerm "look_in_V2" ;
lin look_in_on_V2 = mkTerm "look_in_on_V2" ;
lin look_into_V2 = mkTerm "look_into_V2" ;
lin look_on_V = mkTerm "look_on_V" ;
lin look_on_as_V3 = mkTerm "look_on_as_V3" ;
lin look_out_V = mkTerm "look_out_V" ;
lin look_out_for_V2 = mkTerm "look_out_for_V2" ;
lin look_over_N = mkTerm "look_over_N" ;
lin look_over_V2 = mkTerm "look_over_V2" ;
lin look_round_V2 = mkTerm "look_round_V2" ;
lin look_through_V2 = mkTerm "look_through_V2" ;
lin look_to_V2 = mkTerm "look_to_V2" ;
lin look_toward_V2 = mkTerm "look_toward_V2" ;
lin look_up_V = mkTerm "look_up_V" ;
lin look_up_V2 = mkTerm "look_up_V2" ;
lin look_up_to_V2 = mkTerm "look_up_to_V2" ;
lin look_upon_as_V3 = mkTerm "look_upon_as_V3" ;
lin lookdown_N = mkTerm "lookdown_N" ;
lin looker_N = mkTerm "looker_N" ;
lin looker_on_N = mkTerm "looker_on_N" ;
lin looking_N = mkTerm "looking_N" ;
lin looking_glass_N = mkTerm "looking_glass_N" ;
lin lookout_N = mkTerm "lookout_N" ;
lin loom_N = mkTerm "loom_N" ;
lin loom_V = mkTerm "loom_V" ;
lin loon_N = mkTerm "loon_N" ;
lin loony_A = mkTerm "loony_A" ;
lin loony_N = mkTerm "loony_N" ;
lin loonybin_N = mkTerm "loonybin_N" ;
lin loop_1_N = mkTerm "loop_1_N" ;
lin loop_2_N = mkTerm "loop_2_N" ;
lin loop_V = mkTerm "loop_V" ;
lin loop_V2 = mkTerm "loop_V2" ;
lin loop_line_N = mkTerm "loop_line_N" ;
lin loophole_N = mkTerm "loophole_N" ;
lin loopy_A = mkTerm "loopy_A" ;
lin loose_A = mkTerm "loose_A" ;
lin loose_Adv = mkTerm "loose_Adv" ;
lin loose_V2 = mkTerm "loose_V2" ;
lin loose_leaf_A = mkTerm "loose_leaf_A" ;
lin loosely_Adv = mkTerm "loosely_Adv" ;
lin loosen_V = mkTerm "loosen_V" ;
lin loosen_V2 = mkTerm "loosen_V2" ;
lin loosen_up_V = mkTerm "loosen_up_V" ;
lin looseness_N = mkTerm "looseness_N" ;
lin loosening_N = mkTerm "loosening_N" ;
lin loosestrife_N = mkTerm "loosestrife_N" ;
lin loot_N = mkTerm "loot_N" ;
lin loot_V = mkTerm "loot_V" ;
lin loot_V2 = mkTerm "loot_V2" ;
lin looter_N = mkTerm "looter_N" ;
lin looting_N = mkTerm "looting_N" ;
lin lop_V = mkTerm "lop_V" ;
lin lop_V2 = mkTerm "lop_V2" ;
lin lop_eared_A = mkTerm "lop_eared_A" ;
lin lope_N = mkTerm "lope_N" ;
lin lope_V = mkTerm "lope_V" ;
lin loppi_PN = mkTerm "loppi_PN" ;
lin lopsided_A = mkTerm "lopsided_A" ;
lin lopsidedness_N = mkTerm "lopsidedness_N" ;
lin loquacious_A = mkTerm "loquacious_A" ;
lin loquaciousness_N = mkTerm "loquaciousness_N" ;
lin loquacity_N = mkTerm "loquacity_N" ;
lin loquat_N = mkTerm "loquat_N" ;
lin lorazepam_N = mkTerm "lorazepam_N" ;
lin lorchel_N = mkTerm "lorchel_N" ;
lin lord_N = mkTerm "lord_N" ;
lin lord_V2 = mkTerm "lord_V2" ;
lin lord_it_over_V2 = mkTerm "lord_it_over_V2" ;
lin lordless_A = mkTerm "lordless_A" ;
lin lordliness_N = mkTerm "lordliness_N" ;
lin lordly_A = mkTerm "lordly_A" ;
lin lordolatry_N = mkTerm "lordolatry_N" ;
lin lordosis_N = mkTerm "lordosis_N" ;
lin lordship_N = mkTerm "lordship_N" ;
lin lore_N = mkTerm "lore_N" ;
lin lorgnette_N = mkTerm "lorgnette_N" ;
lin lorica_N = mkTerm "lorica_N" ;
lin lorikeet_N = mkTerm "lorikeet_N" ;
lin lorn_A = mkTerm "lorn_A" ;
lin lorna_PN = mkTerm "lorna_PN" ;
lin lorry_N = mkTerm "lorry_N" ;
lin lory_N = mkTerm "lory_N" ;
lin los_angeles_PN = mkTerm "los_angeles_PN" ;
lin lose_V = mkTerm "lose_V" ;
lin lose_V2 = mkTerm "lose_V2" ;
lin lose_out_V = mkTerm "lose_out_V" ;
lin lose_out_on_V2 = mkTerm "lose_out_on_V2" ;
lin lose_out_to_V2 = mkTerm "lose_out_to_V2" ;
lin lose_up_V = mkTerm "lose_up_V" ;
lin loser_N = mkTerm "loser_N" ;
lin losings_N = mkTerm "losings_N" ;
lin loss_N = mkTerm "loss_N" ;
lin loss_leader_N = mkTerm "loss_leader_N" ;
lin lossiemouth_PN = mkTerm "lossiemouth_PN" ;
lin lossless_A = mkTerm "lossless_A" ;
lin lossy_A = mkTerm "lossy_A" ;
lin lost_A = mkTerm "lost_A" ;
lin lot_1_N = mkTerm "lot_1_N" ;
lin lot_2_N = mkTerm "lot_2_N" ;
lin lot_3_N = mkTerm "lot_3_N" ;
lin lota_N = mkTerm "lota_N" ;
lin loth_A = mkTerm "loth_A" ;
lin lothian_PN = mkTerm "lothian_PN" ;
lin loti_N = mkTerm "loti_N" ;
lin lotic_A = mkTerm "lotic_A" ;
lin lotion_N = mkTerm "lotion_N" ;
lin lottery_N = mkTerm "lottery_N" ;
lin lotto_N = mkTerm "lotto_N" ;
lin lotus_N = mkTerm "lotus_N" ;
lin lotus_eater_N = mkTerm "lotus_eater_N" ;
lin lotusland_N = mkTerm "lotusland_N" ;
lin louche_A = mkTerm "louche_A" ;
lin loud_A = mkTerm "loud_A" ;
lin loud_Adv = mkTerm "loud_Adv" ;
lin loud_hailer_N = mkTerm "loud_hailer_N" ;
lin loudmouth_N = mkTerm "loudmouth_N" ;
lin loudness_N = mkTerm "loudness_N" ;
lin loudspeaker_N = mkTerm "loudspeaker_N" ;
lin lough_N = mkTerm "lough_N" ;
lin loughborough_PN = mkTerm "loughborough_PN" ;
lin louis_PN = mkTerm "louis_PN" ;
lin louise_PN = mkTerm "louise_PN" ;
lin louisiana_PN = mkTerm "louisiana_PN" ;
lin louisville_PN = mkTerm "louisville_PN" ;
lin lounge_N = mkTerm "lounge_N" ;
lin lounge_V = mkTerm "lounge_V" ;
lin lounge_chair_N = mkTerm "lounge_chair_N" ;
lin lounge_lizard_N = mkTerm "lounge_lizard_N" ;
lin lounge_suit_N = mkTerm "lounge_suit_N" ;
lin lounger_N = mkTerm "lounger_N" ;
lin loungewear_N = mkTerm "loungewear_N" ;
lin loupe_N = mkTerm "loupe_N" ;
lin lour_V = mkTerm "lour_V" ;
lin louringly_Adv = mkTerm "louringly_Adv" ;
lin louse_N = mkTerm "louse_N" ;
lin lousy_A = mkTerm "lousy_A" ;
lin lout_N = mkTerm "lout_N" ;
lin louth_PN = mkTerm "louth_PN" ;
lin loutish_A = mkTerm "loutish_A" ;
lin louvar_N = mkTerm "louvar_N" ;
lin louver_N = mkTerm "louver_N" ;
lin louvered_A = mkTerm "louvered_A" ;
lin louvre_N = mkTerm "louvre_N" ;
lin lovable_A = mkTerm "lovable_A" ;
lin lovage_N = mkTerm "lovage_N" ;
lin lovastatin_N = mkTerm "lovastatin_N" ;
lin love_N = mkTerm "love_N" ;
lin love_V2 = mkTerm "love_V2" ;
lin love_VV = mkTerm "love_VV" ;
lin love_affair_N = mkTerm "love_affair_N" ;
lin love_child_N = mkTerm "love_child_N" ;
lin love_feast_N = mkTerm "love_feast_N" ;
lin love_knot_N = mkTerm "love_knot_N" ;
lin love_letter_N = mkTerm "love_letter_N" ;
lin love_match_N = mkTerm "love_match_N" ;
lin love_philtre_N = mkTerm "love_philtre_N" ;
lin love_potion_N = mkTerm "love_potion_N" ;
lin love_seat_N = mkTerm "love_seat_N" ;
lin love_song_N = mkTerm "love_song_N" ;
lin love_story_N = mkTerm "love_story_N" ;
lin love_token_N = mkTerm "love_token_N" ;
lin lovebird_N = mkTerm "lovebird_N" ;
lin loveless_A = mkTerm "loveless_A" ;
lin loveliness_N = mkTerm "loveliness_N" ;
lin lovelorn_A = mkTerm "lovelorn_A" ;
lin lovely_A = mkTerm "lovely_A" ;
lin lovemaking_N = mkTerm "lovemaking_N" ;
lin lover_N = mkTerm "lover_N" ;
lin loverlike_A = mkTerm "loverlike_A" ;
lin lovesick_A = mkTerm "lovesick_A" ;
lin lovesickness_N = mkTerm "lovesickness_N" ;
lin loving_A = mkTerm "loving_A" ;
lin loving_cup_N = mkTerm "loving_cup_N" ;
lin loving_kindness_N = mkTerm "loving_kindness_N" ;
lin lovingness_N = mkTerm "lovingness_N" ;
lin lovisa_PN = mkTerm "lovisa_PN" ;
lin low_A = mkTerm "low_A" ;
lin low_Adv = mkTerm "low_Adv" ;
lin low_N = mkTerm "low_N" ;
lin low_V = mkTerm "low_V" ;
lin low_down_A = mkTerm "low_down_A" ;
lin low_keyed_A = mkTerm "low_keyed_A" ;
lin low_pitched_A = mkTerm "low_pitched_A" ;
lin low_relief_N = mkTerm "low_relief_N" ;
lin low_spirited_A = mkTerm "low_spirited_A" ;
lin lowborn_A = mkTerm "lowborn_A" ;
lin lowboy_N = mkTerm "lowboy_N" ;
lin lowbred_A = mkTerm "lowbred_A" ;
lin lowbrow_A = mkTerm "lowbrow_A" ;
lin lowbrow_N = mkTerm "lowbrow_N" ;
lin lower_Adv = mkTerm "lower_Adv" ;
lin lower_V = mkTerm "lower_V" ;
lin lower_V2 = mkTerm "lower_V2" ;
lin lowercase_A = mkTerm "lowercase_A" ;
lin lowerclassman_N = mkTerm "lowerclassman_N" ;
lin lowering_N = mkTerm "lowering_N" ;
lin loweringly_Adv = mkTerm "loweringly_Adv" ;
lin lowermost_A = mkTerm "lowermost_A" ;
lin lowest_Adv = mkTerm "lowest_Adv" ;
lin lowestoft_PN = mkTerm "lowestoft_PN" ;
lin lowland_A = mkTerm "lowland_A" ;
lin lowland_N = mkTerm "lowland_N" ;
lin lowlander_N = mkTerm "lowlander_N" ;
lin lowliness_N = mkTerm "lowliness_N" ;
lin lowly_A = mkTerm "lowly_A" ;
lin lowness_N = mkTerm "lowness_N" ;
lin lowset_A = mkTerm "lowset_A" ;
lin lox_N = mkTerm "lox_N" ;
lin loxapine_N = mkTerm "loxapine_N" ;
lin loyal_A = mkTerm "loyal_A" ;
lin loyalist_N = mkTerm "loyalist_N" ;
lin loyalty_N = mkTerm "loyalty_N" ;
lin loyang_PN = mkTerm "loyang_PN" ;
lin lozenge_N = mkTerm "lozenge_N" ;
lin lp_N = mkTerm "lp_N" ;
lin lsd_N = mkTerm "lsd_N" ;
lin lt_PN = mkTerm "lt_PN" ;
lin ltd_PN = mkTerm "ltd_PN" ;
lin luau_N = mkTerm "luau_N" ;
lin lubber_N = mkTerm "lubber_N" ;
lin lubberly_A = mkTerm "lubberly_A" ;
lin lubeck_PN = mkTerm "lubeck_PN" ;
lin lubricant_N = mkTerm "lubricant_N" ;
lin lubricate_V2 = mkTerm "lubricate_V2" ;
lin lubrication_N = mkTerm "lubrication_N" ;
lin lubricious_A = mkTerm "lubricious_A" ;
lin lucent_A = mkTerm "lucent_A" ;
lin lucerne_N = mkTerm "lucerne_N" ;
lin lucid_A = mkTerm "lucid_A" ;
lin lucidity_N = mkTerm "lucidity_N" ;
lin lucifer_N = mkTerm "lucifer_N" ;
lin luciferin_N = mkTerm "luciferin_N" ;
lin lucifugous_A = mkTerm "lucifugous_A" ;
lin luck_N = mkTerm "luck_N" ;
lin luck_into_V2 = mkTerm "luck_into_V2" ;
lin luck_out_V = mkTerm "luck_out_V" ;
lin luckily_Adv = mkTerm "luckily_Adv" ;
lin luckless_A = mkTerm "luckless_A" ;
lin lucknow_PN = mkTerm "lucknow_PN" ;
lin lucky_A = mkTerm "lucky_A" ;
lin lucrative_A = mkTerm "lucrative_A" ;
lin lucre_N = mkTerm "lucre_N" ;
lin lucubration_N = mkTerm "lucubration_N" ;
lin lucy_PN = mkTerm "lucy_PN" ;
lin luddite_N = mkTerm "luddite_N" ;
lin ludicrous_A = mkTerm "ludicrous_A" ;
lin ludlow_PN = mkTerm "ludlow_PN" ;
lin ludo_N = mkTerm "ludo_N" ;
lin ludwigshafen_PN = mkTerm "ludwigshafen_PN" ;
lin luff_N = mkTerm "luff_N" ;
lin luff_V = mkTerm "luff_V" ;
lin luff_V2 = mkTerm "luff_V2" ;
lin luffa_N = mkTerm "luffa_N" ;
lin lug_N = mkTerm "lug_N" ;
lin lug_V2 = mkTerm "lug_V2" ;
lin lug_around_V = mkTerm "lug_around_V" ;
lin luge_N = mkTerm "luge_N" ;
lin luger_N = mkTerm "luger_N" ;
lin luggage_N = mkTerm "luggage_N" ;
lin luggage_carrier_N = mkTerm "luggage_carrier_N" ;
lin luggage_rack_N = mkTerm "luggage_rack_N" ;
lin luggage_van_N = mkTerm "luggage_van_N" ;
lin lugger_N = mkTerm "lugger_N" ;
lin luging_N = mkTerm "luging_N" ;
lin lugsail_N = mkTerm "lugsail_N" ;
lin lugubrious_A = mkTerm "lugubrious_A" ;
lin lugubriousness_N = mkTerm "lugubriousness_N" ;
lin lugworm_N = mkTerm "lugworm_N" ;
lin luhanka_PN = mkTerm "luhanka_PN" ;
lin luke_PN = mkTerm "luke_PN" ;
lin lukewarm_A = mkTerm "lukewarm_A" ;
lin lukewarmness_N = mkTerm "lukewarmness_N" ;
lin lull_N = mkTerm "lull_N" ;
lin lull_V = mkTerm "lull_V" ;
lin lull_V2 = mkTerm "lull_V2" ;
lin lullaby_N = mkTerm "lullaby_N" ;
lin lumbago_N = mkTerm "lumbago_N" ;
lin lumbar_A = mkTerm "lumbar_A" ;
lin lumber_N = mkTerm "lumber_N" ;
lin lumber_V = mkTerm "lumber_V" ;
lin lumber_V2 = mkTerm "lumber_V2" ;
lin lumber_mill_N = mkTerm "lumber_mill_N" ;
lin lumbering_N = mkTerm "lumbering_N" ;
lin lumberjack_N = mkTerm "lumberjack_N" ;
lin lumberman_N = mkTerm "lumberman_N" ;
lin lumberroom_N = mkTerm "lumberroom_N" ;
lin lumberyard_N = mkTerm "lumberyard_N" ;
lin lumbosacral_A = mkTerm "lumbosacral_A" ;
lin lumen_N = mkTerm "lumen_N" ;
lin lumijoki_PN = mkTerm "lumijoki_PN" ;
lin luminary_N = mkTerm "luminary_N" ;
lin luminescence_N = mkTerm "luminescence_N" ;
lin luminescent_A = mkTerm "luminescent_A" ;
lin luminism_N = mkTerm "luminism_N" ;
lin luminosity_N = mkTerm "luminosity_N" ;
lin luminous_A = mkTerm "luminous_A" ;
lin lumma_N = mkTerm "lumma_N" ;
lin lump_N = mkTerm "lump_N" ;
lin lump_V2 = mkTerm "lump_V2" ;
lin lumpectomy_N = mkTerm "lumpectomy_N" ;
lin lumpenproletariat_N = mkTerm "lumpenproletariat_N" ;
lin lumper_N = mkTerm "lumper_N" ;
lin lumpfish_N = mkTerm "lumpfish_N" ;
lin lumpish_A = mkTerm "lumpish_A" ;
lin lumpsucker_N = mkTerm "lumpsucker_N" ;
lin lumpy_A = mkTerm "lumpy_A" ;
lin lunacy_N = mkTerm "lunacy_N" ;
lin lunar_A = mkTerm "lunar_A" ;
lin lunatic_A = mkTerm "lunatic_A" ;
lin lunatic_N = mkTerm "lunatic_N" ;
lin lunch_N = mkTerm "lunch_N" ;
lin lunch_V = mkTerm "lunch_V" ;
lin lunch_V2 = mkTerm "lunch_V2" ;
lin luncheon_N = mkTerm "luncheon_N" ;
lin luncher_N = mkTerm "luncher_N" ;
lin lunching_N = mkTerm "lunching_N" ;
lin lunchroom_N = mkTerm "lunchroom_N" ;
lin lunchtime_N = mkTerm "lunchtime_N" ;
lin lunette_N = mkTerm "lunette_N" ;
lin lung_N = mkTerm "lung_N" ;
lin lung_power_N = mkTerm "lung_power_N" ;
lin lunge_N = mkTerm "lunge_N" ;
lin lunge_V = mkTerm "lunge_V" ;
lin lunger_N = mkTerm "lunger_N" ;
lin lungfish_N = mkTerm "lungfish_N" ;
lin lungi_N = mkTerm "lungi_N" ;
lin lunisolar_A = mkTerm "lunisolar_A" ;
lin lunula_N = mkTerm "lunula_N" ;
lin luopioinen_PN = mkTerm "luopioinen_PN" ;
lin lupin_N = mkTerm "lupin_N" ;
lin lupine_A = mkTerm "lupine_A" ;
lin lupine_N = mkTerm "lupine_N" ;
lin lupus_N = mkTerm "lupus_N" ;
lin lurch_N = mkTerm "lurch_N" ;
lin lurch_V = mkTerm "lurch_V" ;
lin lurcher_N = mkTerm "lurcher_N" ;
lin lure_N = mkTerm "lure_N" ;
lin lure_V2 = mkTerm "lure_V2" ;
lin lure_away_V = mkTerm "lure_away_V" ;
lin lurid_A = mkTerm "lurid_A" ;
lin luridness_N = mkTerm "luridness_N" ;
lin lurk_V = mkTerm "lurk_V" ;
lin lurker_N = mkTerm "lurker_N" ;
lin lurking_place_N = mkTerm "lurking_place_N" ;
lin luscious_A = mkTerm "luscious_A" ;
lin lusciousness_N = mkTerm "lusciousness_N" ;
lin lush_A = mkTerm "lush_A" ;
lin lush_N = mkTerm "lush_N" ;
lin lust_N = mkTerm "lust_N" ;
lin lust_V = mkTerm "lust_V" ;
lin lust_after_V2 = mkTerm "lust_after_V2" ;
lin luster_N = mkTerm "luster_N" ;
lin lusterware_N = mkTerm "lusterware_N" ;
lin lustful_A = mkTerm "lustful_A" ;
lin lustre_N = mkTerm "lustre_N" ;
lin lustrous_A = mkTerm "lustrous_A" ;
lin lustrum_N = mkTerm "lustrum_N" ;
lin lusty_A = mkTerm "lusty_A" ;
lin luta_PN = mkTerm "luta_PN" ;
lin lutanist_N = mkTerm "lutanist_N" ;
lin lute_N = mkTerm "lute_N" ;
lin luteal_A = mkTerm "luteal_A" ;
lin lutefisk_N = mkTerm "lutefisk_N" ;
lin lutenist_N = mkTerm "lutenist_N" ;
lin lutetium_N = mkTerm "lutetium_N" ;
lin lutheran_A = mkTerm "lutheran_A" ;
lin lutheran_N = mkTerm "lutheran_N" ;
lin luthier_N = mkTerm "luthier_N" ;
lin lutist_N = mkTerm "lutist_N" ;
lin luton_PN = mkTerm "luton_PN" ;
lin luumäki_PN = mkTerm "luumäki_PN" ;
lin luvia_PN = mkTerm "luvia_PN" ;
lin lux_N = mkTerm "lux_N" ;
lin luxation_N = mkTerm "luxation_N" ;
lin luxe_A = mkTerm "luxe_A" ;
lin luxembourg_PN = mkTerm "luxembourg_PN" ;
lin luxemburger_A = mkTerm "luxemburger_A" ;
lin luxemburger_N = mkTerm "luxemburger_N" ;
lin luxuriance_N = mkTerm "luxuriance_N" ;
lin luxuriant_A = mkTerm "luxuriant_A" ;
lin luxuriate_V = mkTerm "luxuriate_V" ;
lin luxuriation_N = mkTerm "luxuriation_N" ;
lin luxurious_A = mkTerm "luxurious_A" ;
lin luxury_A = mkTerm "luxury_A" ;
lin luxury_N = mkTerm "luxury_N" ;
lin lvov_PN = mkTerm "lvov_PN" ;
lin lwei_N = mkTerm "lwei_N" ;
lin lyallpur_PN = mkTerm "lyallpur_PN" ;
lin lycaenid_N = mkTerm "lycaenid_N" ;
lin lycanthropy_N = mkTerm "lycanthropy_N" ;
lin lycee_N = mkTerm "lycee_N" ;
lin lyceum_N = mkTerm "lyceum_N" ;
lin lychee_N = mkTerm "lychee_N" ;
lin lychgate_N = mkTerm "lychgate_N" ;
lin lychnis_N = mkTerm "lychnis_N" ;
lin lycopene_N = mkTerm "lycopene_N" ;
lin lydia_PN = mkTerm "lydia_PN" ;
lin lydney_PN = mkTerm "lydney_PN" ;
lin lye_N = mkTerm "lye_N" ;
lin lygaeid_N = mkTerm "lygaeid_N" ;
lin lying_N = mkTerm "lying_N" ;
lin lying_in_A = mkTerm "lying_in_A" ;
lin lymantriid_N = mkTerm "lymantriid_N" ;
lin lymington_PN = mkTerm "lymington_PN" ;
lin lymm_PN = mkTerm "lymm_PN" ;
lin lymph_N = mkTerm "lymph_N" ;
lin lymphadenitis_N = mkTerm "lymphadenitis_N" ;
lin lymphadenoma_N = mkTerm "lymphadenoma_N" ;
lin lymphadenopathy_N = mkTerm "lymphadenopathy_N" ;
lin lymphangiectasia_N = mkTerm "lymphangiectasia_N" ;
lin lymphangiogram_N = mkTerm "lymphangiogram_N" ;
lin lymphangiography_N = mkTerm "lymphangiography_N" ;
lin lymphangioma_N = mkTerm "lymphangioma_N" ;
lin lymphangitis_N = mkTerm "lymphangitis_N" ;
lin lymphatic_A = mkTerm "lymphatic_A" ;
lin lymphedema_N = mkTerm "lymphedema_N" ;
lin lymphoblast_N = mkTerm "lymphoblast_N" ;
lin lymphocyte_N = mkTerm "lymphocyte_N" ;
lin lymphocytic_A = mkTerm "lymphocytic_A" ;
lin lymphocytopenia_N = mkTerm "lymphocytopenia_N" ;
lin lymphocytosis_N = mkTerm "lymphocytosis_N" ;
lin lymphogranuloma_N = mkTerm "lymphogranuloma_N" ;
lin lymphoid_A = mkTerm "lymphoid_A" ;
lin lymphokine_N = mkTerm "lymphokine_N" ;
lin lymphoma_N = mkTerm "lymphoma_N" ;
lin lymphopoiesis_N = mkTerm "lymphopoiesis_N" ;
lin lymphuria_N = mkTerm "lymphuria_N" ;
lin lynch_N = mkTerm "lynch_N" ;
lin lynch_V2 = mkTerm "lynch_V2" ;
lin lynching_N = mkTerm "lynching_N" ;
lin lynchpin_N = mkTerm "lynchpin_N" ;
lin lynn_PN = mkTerm "lynn_PN" ;
lin lynne_PN = mkTerm "lynne_PN" ;
lin lynx_N = mkTerm "lynx_N" ;
lin lynx_eyed_A = mkTerm "lynx_eyed_A" ;
lin lyonnaise_A = mkTerm "lyonnaise_A" ;
lin lyons_PN = mkTerm "lyons_PN" ;
lin lyophilized_A = mkTerm "lyophilized_A" ;
lin lypressin_N = mkTerm "lypressin_N" ;
lin lyrate_A = mkTerm "lyrate_A" ;
lin lyre_N = mkTerm "lyre_N" ;
lin lyre_bird_N = mkTerm "lyre_bird_N" ;
lin lyric_A = mkTerm "lyric_A" ;
lin lyric_N = mkTerm "lyric_N" ;
lin lyrical_A = mkTerm "lyrical_A" ;
lin lyricality_N = mkTerm "lyricality_N" ;
lin lyricism_N = mkTerm "lyricism_N" ;
lin lyricist_N = mkTerm "lyricist_N" ;
lin lysin_N = mkTerm "lysin_N" ;
lin lysine_N = mkTerm "lysine_N" ;
lin lysinemia_N = mkTerm "lysinemia_N" ;
lin lysis_N = mkTerm "lysis_N" ;
lin lysogenic_A = mkTerm "lysogenic_A" ;
lin lysogenization_N = mkTerm "lysogenization_N" ;
lin lysogeny_N = mkTerm "lysogeny_N" ;
lin lysol_N = mkTerm "lysol_N" ;
lin lysosome_N = mkTerm "lysosome_N" ;
lin lysozyme_N = mkTerm "lysozyme_N" ;
lin lyssavirus_N = mkTerm "lyssavirus_N" ;
lin lytham_PN = mkTerm "lytham_PN" ;
lin lytham_st_annes_PN = mkTerm "lytham_st_annes_PN" ;
lin längelmäki_PN = mkTerm "längelmäki_PN" ;
lin länsi_turunmaa_PN = mkTerm "länsi_turunmaa_PN" ;
lin ma'am_N = mkTerm "ma'am_N" ;
lin ma_N = mkTerm "ma_N" ;
lin maaninka_PN = mkTerm "maaninka_PN" ;
lin maar_N = mkTerm "maar_N" ;
lin maastricht_PN = mkTerm "maastricht_PN" ;
lin mabel_PN = mkTerm "mabel_PN" ;
lin mac_N = mkTerm "mac_N" ;
lin macabre_A = mkTerm "macabre_A" ;
lin macadam_N = mkTerm "macadam_N" ;
lin macadamia_N = mkTerm "macadamia_N" ;
lin macadamize_V2 = mkTerm "macadamize_V2" ;
lin macaque_N = mkTerm "macaque_N" ;
lin macaroni_N = mkTerm "macaroni_N" ;
lin macaronic_A = mkTerm "macaronic_A" ;
lin macaroon_N = mkTerm "macaroon_N" ;
lin macaw_N = mkTerm "macaw_N" ;
lin macclesfield_PN = mkTerm "macclesfield_PN" ;
lin mace_N = mkTerm "mace_N" ;
lin mace_bearer_N = mkTerm "mace_bearer_N" ;
lin macedoine_N = mkTerm "macedoine_N" ;
lin macedonian_A = mkTerm "macedonian_A" ;
lin macedonian_N = mkTerm "macedonian_N" ;
lin macerate_V = mkTerm "macerate_V" ;
lin macerate_V2 = mkTerm "macerate_V2" ;
lin maceration_N = mkTerm "maceration_N" ;
lin macerative_A = mkTerm "macerative_A" ;
lin mach_PN = mkTerm "mach_PN" ;
lin machete_N = mkTerm "machete_N" ;
lin machiavellian_A = mkTerm "machiavellian_A" ;
lin machicolation_N = mkTerm "machicolation_N" ;
lin machination_N = mkTerm "machination_N" ;
lin machine_N = mkTerm "machine_N" ;
lin machine_V2 = mkTerm "machine_V2" ;
lin machine_gun_N = mkTerm "machine_gun_N" ;
lin machine_made_A = mkTerm "machine_made_A" ;
lin machinery_N = mkTerm "machinery_N" ;
lin machinist_N = mkTerm "machinist_N" ;
lin machismo_N = mkTerm "machismo_N" ;
lin machmeter_N = mkTerm "machmeter_N" ;
lin macho_N = mkTerm "macho_N" ;
lin mackerel_N = mkTerm "mackerel_N" ;
lin mackinaw_N = mkTerm "mackinaw_N" ;
lin mackintosh_N = mkTerm "mackintosh_N" ;
lin mackle_N = mkTerm "mackle_N" ;
lin macon_N = mkTerm "macon_N" ;
lin macrame_N = mkTerm "macrame_N" ;
lin macrencephalic_A = mkTerm "macrencephalic_A" ;
lin macrencephaly_N = mkTerm "macrencephaly_N" ;
lin macro_A = mkTerm "macro_A" ;
lin macro_N = mkTerm "macro_N" ;
lin macrobiotic_A = mkTerm "macrobiotic_A" ;
lin macrobiotics_N = mkTerm "macrobiotics_N" ;
lin macrocephalic_A = mkTerm "macrocephalic_A" ;
lin macrocephaly_N = mkTerm "macrocephaly_N" ;
lin macrocosm_N = mkTerm "macrocosm_N" ;
lin macrocosmic_A = mkTerm "macrocosmic_A" ;
lin macrocytosis_N = mkTerm "macrocytosis_N" ;
lin macroeconomic_A = mkTerm "macroeconomic_A" ;
lin macroeconomics_N = mkTerm "macroeconomics_N" ;
lin macroeconomist_N = mkTerm "macroeconomist_N" ;
lin macroevolution_N = mkTerm "macroevolution_N" ;
lin macroglossia_N = mkTerm "macroglossia_N" ;
lin macromolecular_A = mkTerm "macromolecular_A" ;
lin macromolecule_N = mkTerm "macromolecule_N" ;
lin macron_N = mkTerm "macron_N" ;
lin macrophage_N = mkTerm "macrophage_N" ;
lin macroscopic_A = mkTerm "macroscopic_A" ;
lin macroscopically_Adv = mkTerm "macroscopically_Adv" ;
lin macrotus_N = mkTerm "macrotus_N" ;
lin macrozamia_N = mkTerm "macrozamia_N" ;
lin macula_N = mkTerm "macula_N" ;
lin maculate_A = mkTerm "maculate_A" ;
lin macule_N = mkTerm "macule_N" ;
lin macumba_N = mkTerm "macumba_N" ;
lin macushla_N = mkTerm "macushla_N" ;
lin mad_A = mkTerm "mad_A" ;
lin madagascan_A = mkTerm "madagascan_A" ;
lin madagascan_N = mkTerm "madagascan_N" ;
lin madagascar_PN = mkTerm "madagascar_PN" ;
lin madam_N = mkTerm "madam_N" ;
lin madame_N = mkTerm "madame_N" ;
lin madcap_N = mkTerm "madcap_N" ;
lin madden_V2 = mkTerm "madden_V2" ;
lin madder_N = mkTerm "madder_N" ;
lin madderwort_N = mkTerm "madderwort_N" ;
lin maddy_PN = mkTerm "maddy_PN" ;
lin madeira_N = mkTerm "madeira_N" ;
lin madeleine_PN = mkTerm "madeleine_PN" ;
lin mademoiselle_N = mkTerm "mademoiselle_N" ;
lin madge_PN = mkTerm "madge_PN" ;
lin madhouse_N = mkTerm "madhouse_N" ;
lin madman_N = mkTerm "madman_N" ;
lin madness_N = mkTerm "madness_N" ;
lin madonna_N = mkTerm "madonna_N" ;
lin madras_N = mkTerm "madras_N" ;
lin madras_PN = mkTerm "madras_PN" ;
lin madrasa_N = mkTerm "madrasa_N" ;
lin madrid_PN = mkTerm "madrid_PN" ;
lin madrigal_N = mkTerm "madrigal_N" ;
lin madrigalist_N = mkTerm "madrigalist_N" ;
lin madrilene_N = mkTerm "madrilene_N" ;
lin madrona_N = mkTerm "madrona_N" ;
lin madurai_PN = mkTerm "madurai_PN" ;
lin madwoman_N = mkTerm "madwoman_N" ;
lin maecenas_PN = mkTerm "maecenas_PN" ;
lin maelstrom_N = mkTerm "maelstrom_N" ;
lin maenad_N = mkTerm "maenad_N" ;
lin maesteg_PN = mkTerm "maesteg_PN" ;
lin maestro_N = mkTerm "maestro_N" ;
lin maffick_V = mkTerm "maffick_V" ;
lin mafia_N = mkTerm "mafia_N" ;
lin mafioso_N = mkTerm "mafioso_N" ;
lin mag_N = mkTerm "mag_N" ;
lin magazine_N = mkTerm "magazine_N" ;
lin magdalen_N = mkTerm "magdalen_N" ;
lin magdeburg_PN = mkTerm "magdeburg_PN" ;
lin mage_N = mkTerm "mage_N" ;
lin magenta_A = mkTerm "magenta_A" ;
lin magenta_N = mkTerm "magenta_N" ;
lin maggie_PN = mkTerm "maggie_PN" ;
lin maggot_N = mkTerm "maggot_N" ;
lin maggoty_A = mkTerm "maggoty_A" ;
lin maghull_PN = mkTerm "maghull_PN" ;
lin magic_A = mkTerm "magic_A" ;
lin magic_N = mkTerm "magic_N" ;
lin magic_away_V2 = mkTerm "magic_away_V2" ;
lin magical_A = mkTerm "magical_A" ;
lin magician_N = mkTerm "magician_N" ;
lin magisterial_A = mkTerm "magisterial_A" ;
lin magistracy_N = mkTerm "magistracy_N" ;
lin magistrate_N = mkTerm "magistrate_N" ;
lin magma_N = mkTerm "magma_N" ;
lin magnanimity_N = mkTerm "magnanimity_N" ;
lin magnanimous_A = mkTerm "magnanimous_A" ;
lin magnate_N = mkTerm "magnate_N" ;
lin magnesia_N = mkTerm "magnesia_N" ;
lin magnesite_N = mkTerm "magnesite_N" ;
lin magnesium_N = mkTerm "magnesium_N" ;
lin magnet_N = mkTerm "magnet_N" ;
lin magnetic_A = mkTerm "magnetic_A" ;
lin magnetism_N = mkTerm "magnetism_N" ;
lin magnetite_N = mkTerm "magnetite_N" ;
lin magnetization_N = mkTerm "magnetization_N" ;
lin magnetize_V2 = mkTerm "magnetize_V2" ;
lin magneto_N = mkTerm "magneto_N" ;
lin magnetograph_N = mkTerm "magnetograph_N" ;
lin magnetohydrodynamics_N = mkTerm "magnetohydrodynamics_N" ;
lin magnetometer_N = mkTerm "magnetometer_N" ;
lin magneton_N = mkTerm "magneton_N" ;
lin magnetosphere_N = mkTerm "magnetosphere_N" ;
lin magnetron_N = mkTerm "magnetron_N" ;
lin magnificat_N = mkTerm "magnificat_N" ;
lin magnification_N = mkTerm "magnification_N" ;
lin magnificence_N = mkTerm "magnificence_N" ;
lin magnificent_A = mkTerm "magnificent_A" ;
lin magnifico_N = mkTerm "magnifico_N" ;
lin magnifier_N = mkTerm "magnifier_N" ;
lin magnify_V2 = mkTerm "magnify_V2" ;
lin magniloquence_N = mkTerm "magniloquence_N" ;
lin magniloquent_A = mkTerm "magniloquent_A" ;
lin magnitude_N = mkTerm "magnitude_N" ;
lin magnolia_N = mkTerm "magnolia_N" ;
lin magnum_N = mkTerm "magnum_N" ;
lin magnum_opus_N = mkTerm "magnum_opus_N" ;
lin magpie_N = mkTerm "magpie_N" ;
lin maguey_N = mkTerm "maguey_N" ;
lin magus_N = mkTerm "magus_N" ;
lin magyarFem_N = mkTerm "magyarFem_N" ;
lin magyarMasc_N = mkTerm "magyarMasc_N" ;
lin magyar_A = mkTerm "magyar_A" ;
lin maharaja_N = mkTerm "maharaja_N" ;
lin maharanee_N = mkTerm "maharanee_N" ;
lin maharani_N = mkTerm "maharani_N" ;
lin mahatma_N = mkTerm "mahatma_N" ;
lin mahjong_N = mkTerm "mahjong_N" ;
lin mahoe_N = mkTerm "mahoe_N" ;
lin mahogany_N = mkTerm "mahogany_N" ;
lin mahout_N = mkTerm "mahout_N" ;
lin mahuang_N = mkTerm "mahuang_N" ;
lin maid_N = mkTerm "maid_N" ;
lin maiden_A = mkTerm "maiden_A" ;
lin maiden_N = mkTerm "maiden_N" ;
lin maidenhair_N = mkTerm "maidenhair_N" ;
lin maidenhead_N = mkTerm "maidenhead_N" ;
lin maidenhead_PN = mkTerm "maidenhead_PN" ;
lin maidenhood_N = mkTerm "maidenhood_N" ;
lin maidenlike_A = mkTerm "maidenlike_A" ;
lin maidenliness_N = mkTerm "maidenliness_N" ;
lin maidenly_A = mkTerm "maidenly_A" ;
lin maidservant_N = mkTerm "maidservant_N" ;
lin maidstone_PN = mkTerm "maidstone_PN" ;
lin maigre_N = mkTerm "maigre_N" ;
lin mail_N = mkTerm "mail_N" ;
lin mail_V2 = mkTerm "mail_V2" ;
lin mail_train_N = mkTerm "mail_train_N" ;
lin mailbag_N = mkTerm "mailbag_N" ;
lin mailboat_N = mkTerm "mailboat_N" ;
lin mailbox_N = mkTerm "mailbox_N" ;
lin maildrop_N = mkTerm "maildrop_N" ;
lin mailer_N = mkTerm "mailer_N" ;
lin mailing_N = mkTerm "mailing_N" ;
lin mailing_card_N = mkTerm "mailing_card_N" ;
lin mailing_list_N = mkTerm "mailing_list_N" ;
lin maillot_N = mkTerm "maillot_N" ;
lin mailman_N = mkTerm "mailman_N" ;
lin mailsorter_N = mkTerm "mailsorter_N" ;
lin maim_V2 = mkTerm "maim_V2" ;
lin main_A = mkTerm "main_A" ;
lin main_N = mkTerm "main_N" ;
lin maine_PN = mkTerm "maine_PN" ;
lin mainframe_N = mkTerm "mainframe_N" ;
lin mainland_N = mkTerm "mainland_N" ;
lin mainline_A = mkTerm "mainline_A" ;
lin mainly_Adv = mkTerm "mainly_Adv" ;
lin mainmast_N = mkTerm "mainmast_N" ;
lin mains_N = mkTerm "mains_N" ;
lin mainsail_N = mkTerm "mainsail_N" ;
lin mainspring_N = mkTerm "mainspring_N" ;
lin mainstay_N = mkTerm "mainstay_N" ;
lin mainstream_A = mkTerm "mainstream_A" ;
lin mainstream_N = mkTerm "mainstream_N" ;
lin mainstreamed_A = mkTerm "mainstreamed_A" ;
lin maintain_V = mkTerm "maintain_V" ;
lin maintain_V2 = mkTerm "maintain_V2" ;
lin maintain_VS = mkTerm "maintain_VS" ;
lin maintainable_A = mkTerm "maintainable_A" ;
lin maintenance_N = mkTerm "maintenance_N" ;
lin mainz_PN = mkTerm "mainz_PN" ;
lin maisonette_N = mkTerm "maisonette_N" ;
lin maisonnette_N = mkTerm "maisonnette_N" ;
lin maize_N = mkTerm "maize_N" ;
lin maj_PN = mkTerm "maj_PN" ;
lin majestic_A = mkTerm "majestic_A" ;
lin majesty_N = mkTerm "majesty_N" ;
lin majolica_N = mkTerm "majolica_N" ;
lin major_A = mkTerm "major_A" ;
lin major_N = mkTerm "major_N" ;
lin major_V = mkTerm "major_V" ;
lin major_domo_N = mkTerm "major_domo_N" ;
lin major_general_N = mkTerm "major_general_N" ;
lin majority_N = mkTerm "majority_N" ;
lin majuscular_A = mkTerm "majuscular_A" ;
lin majuscule_A = mkTerm "majuscule_A" ;
lin make_N = mkTerm "make_N" ;
lin make_V = mkTerm "make_V" ;
lin make_V2 = mkTerm "make_V2" ;
lin make_V2A = mkTerm "make_V2A" ;
lin make_V2V = mkTerm "make_V2V" ;
lin make_after_V = mkTerm "make_after_V" ;
lin make_away_with_V2 = mkTerm "make_away_with_V2" ;
lin make_believe_N = mkTerm "make_believe_N" ;
lin make_do_with_V2 = mkTerm "make_do_with_V2" ;
lin make_for_V2 = mkTerm "make_for_V2" ;
lin make_into_V2 = mkTerm "make_into_V2" ;
lin make_it_V = mkTerm "make_it_V" ;
lin make_it_up_to_V2 = mkTerm "make_it_up_to_V2" ;
lin make_of_V3 = mkTerm "make_of_V3" ;
lin make_off_V = mkTerm "make_off_V" ;
lin make_off_with_V2 = mkTerm "make_off_with_V2" ;
lin make_out_V = mkTerm "make_out_V" ;
lin make_out_V2 = mkTerm "make_out_V2" ;
lin make_out_with_V2 = mkTerm "make_out_with_V2" ;
lin make_over_V2 = mkTerm "make_over_V2" ;
lin make_towards_V2 = mkTerm "make_towards_V2" ;
lin make_up_N = mkTerm "make_up_N" ;
lin make_up_V = mkTerm "make_up_V" ;
lin make_up_V2 = mkTerm "make_up_V2" ;
lin make_up_for_V2 = mkTerm "make_up_for_V2" ;
lin make_up_to_V2 = mkTerm "make_up_to_V2" ;
lin make_with_V2 = mkTerm "make_with_V2" ;
lin makeover_N = mkTerm "makeover_N" ;
lin maker_N = mkTerm "maker_N" ;
lin makeready_N = mkTerm "makeready_N" ;
lin makeshift_A = mkTerm "makeshift_A" ;
lin makeshift_N = mkTerm "makeshift_N" ;
lin makeup_N = mkTerm "makeup_N" ;
lin makeweight_N = mkTerm "makeweight_N" ;
lin making_N = mkTerm "making_N" ;
lin mako_N = mkTerm "mako_N" ;
lin makomako_N = mkTerm "makomako_N" ;
lin malabsorption_N = mkTerm "malabsorption_N" ;
lin malacca_N = mkTerm "malacca_N" ;
lin malachite_N = mkTerm "malachite_N" ;
lin malacia_N = mkTerm "malacia_N" ;
lin malacologist_N = mkTerm "malacologist_N" ;
lin malacology_N = mkTerm "malacology_N" ;
lin maladaptive_A = mkTerm "maladaptive_A" ;
lin maladjusted_A = mkTerm "maladjusted_A" ;
lin maladjustive_A = mkTerm "maladjustive_A" ;
lin maladjustment_N = mkTerm "maladjustment_N" ;
lin maladroit_A = mkTerm "maladroit_A" ;
lin maladroitness_N = mkTerm "maladroitness_N" ;
lin malady_N = mkTerm "malady_N" ;
lin malaga_PN = mkTerm "malaga_PN" ;
lin malahini_N = mkTerm "malahini_N" ;
lin malaise_N = mkTerm "malaise_N" ;
lin malamute_N = mkTerm "malamute_N" ;
lin malapropism_N = mkTerm "malapropism_N" ;
lin malapropos_A = mkTerm "malapropos_A" ;
lin malapropos_Adv = mkTerm "malapropos_Adv" ;
lin malaria_N = mkTerm "malaria_N" ;
lin malarial_A = mkTerm "malarial_A" ;
lin malawi_PN = mkTerm "malawi_PN" ;
lin malawian_A = mkTerm "malawian_A" ;
lin malawian_N = mkTerm "malawian_N" ;
lin malax_PN = mkTerm "malax_PN" ;
lin malay_A = mkTerm "malay_A" ;
lin malay_N = mkTerm "malay_N" ;
lin malaya_PN = mkTerm "malaya_PN" ;
lin malayan_A = mkTerm "malayan_A" ;
lin malayan_N = mkTerm "malayan_N" ;
lin malaysia_PN = mkTerm "malaysia_PN" ;
lin malaysian_A = mkTerm "malaysian_A" ;
lin malaysian_N = mkTerm "malaysian_N" ;
lin malcolm_PN = mkTerm "malcolm_PN" ;
lin malcontent_A = mkTerm "malcontent_A" ;
lin malcontent_N = mkTerm "malcontent_N" ;
lin maldon_PN = mkTerm "maldon_PN" ;
lin male_A = mkTerm "male_A" ;
lin male_N = mkTerm "male_N" ;
lin maleate_N = mkTerm "maleate_N" ;
lin maleberry_N = mkTerm "maleberry_N" ;
lin malediction_N = mkTerm "malediction_N" ;
lin malefactor_N = mkTerm "malefactor_N" ;
lin malefic_A = mkTerm "malefic_A" ;
lin maleficence_N = mkTerm "maleficence_N" ;
lin maleficent_A = mkTerm "maleficent_A" ;
lin maleness_N = mkTerm "maleness_N" ;
lin maleo_N = mkTerm "maleo_N" ;
lin malevolence_N = mkTerm "malevolence_N" ;
lin malevolent_A = mkTerm "malevolent_A" ;
lin malfeasance_N = mkTerm "malfeasance_N" ;
lin malfeasant_N = mkTerm "malfeasant_N" ;
lin malformation_N = mkTerm "malformation_N" ;
lin malformed_A = mkTerm "malformed_A" ;
lin malfunction_N = mkTerm "malfunction_N" ;
lin malfunction_V = mkTerm "malfunction_V" ;
lin mali_PN = mkTerm "mali_PN" ;
lin malian_A = mkTerm "malian_A" ;
lin malian_N = mkTerm "malian_N" ;
lin malice_N = mkTerm "malice_N" ;
lin malicious_A = mkTerm "malicious_A" ;
lin malign_A = mkTerm "malign_A" ;
lin malign_V2 = mkTerm "malign_V2" ;
lin malignancy_N = mkTerm "malignancy_N" ;
lin malignant_A = mkTerm "malignant_A" ;
lin malignity_N = mkTerm "malignity_N" ;
lin malik_N = mkTerm "malik_N" ;
lin malinger_V = mkTerm "malinger_V" ;
lin malingerer_N = mkTerm "malingerer_N" ;
lin malingering_N = mkTerm "malingering_N" ;
lin malinois_N = mkTerm "malinois_N" ;
lin mall_N = mkTerm "mall_N" ;
lin mallard_N = mkTerm "mallard_N" ;
lin malleability_N = mkTerm "malleability_N" ;
lin malleable_A = mkTerm "malleable_A" ;
lin mallee_N = mkTerm "mallee_N" ;
lin mallet_N = mkTerm "mallet_N" ;
lin malleus_N = mkTerm "malleus_N" ;
lin mallow_N = mkTerm "mallow_N" ;
lin mallow_PN = mkTerm "mallow_PN" ;
lin malmo_PN = mkTerm "malmo_PN" ;
lin malmsey_N = mkTerm "malmsey_N" ;
lin malnourished_A = mkTerm "malnourished_A" ;
lin malnutrition_N = mkTerm "malnutrition_N" ;
lin malocclusion_N = mkTerm "malocclusion_N" ;
lin malodor_N = mkTerm "malodor_N" ;
lin malodorous_A = mkTerm "malodorous_A" ;
lin malodorousness_N = mkTerm "malodorousness_N" ;
lin malope_N = mkTerm "malope_N" ;
lin malposed_A = mkTerm "malposed_A" ;
lin malposition_N = mkTerm "malposition_N" ;
lin malpractice_N = mkTerm "malpractice_N" ;
lin malt_N = mkTerm "malt_N" ;
lin malt_V = mkTerm "malt_V" ;
lin malt_V2 = mkTerm "malt_V2" ;
lin malta_PN = mkTerm "malta_PN" ;
lin maltby_PN = mkTerm "maltby_PN" ;
lin malted_N = mkTerm "malted_N" ;
lin malteseFem_N = mkTerm "malteseFem_N" ;
lin malteseMasc_N = mkTerm "malteseMasc_N" ;
lin maltese_A = mkTerm "maltese_A" ;
lin maltha_N = mkTerm "maltha_N" ;
lin malthusian_A = mkTerm "malthusian_A" ;
lin maltose_N = mkTerm "maltose_N" ;
lin maltreat_V2 = mkTerm "maltreat_V2" ;
lin maltreatment_N = mkTerm "maltreatment_N" ;
lin maltster_N = mkTerm "maltster_N" ;
lin malvasia_N = mkTerm "malvasia_N" ;
lin malvern_PN = mkTerm "malvern_PN" ;
lin malversation_N = mkTerm "malversation_N" ;
lin mama_N = mkTerm "mama_N" ;
lin mamba_N = mkTerm "mamba_N" ;
lin mambo_N = mkTerm "mambo_N" ;
lin mamey_N = mkTerm "mamey_N" ;
lin mamie_PN = mkTerm "mamie_PN" ;
lin mamma_N = mkTerm "mamma_N" ;
lin mammal_N = mkTerm "mammal_N" ;
lin mammalian_A = mkTerm "mammalian_A" ;
lin mammalogist_N = mkTerm "mammalogist_N" ;
lin mammalogy_N = mkTerm "mammalogy_N" ;
lin mammary_A = mkTerm "mammary_A" ;
lin mammillaria_N = mkTerm "mammillaria_N" ;
lin mammogram_N = mkTerm "mammogram_N" ;
lin mammography_N = mkTerm "mammography_N" ;
lin mammon_N = mkTerm "mammon_N" ;
lin mammoth_N = mkTerm "mammoth_N" ;
lin mammothermography_N = mkTerm "mammothermography_N" ;
lin mammy_N = mkTerm "mammy_N" ;
lin mamo_N = mkTerm "mamo_N" ;
lin man_N = mkTerm "man_N" ;
lin man_V2 = mkTerm "man_V2" ;
lin man_at_arms_N = mkTerm "man_at_arms_N" ;
lin man_down_V = mkTerm "man_down_V" ;
lin man_eater_N = mkTerm "man_eater_N" ;
lin man_hour_N = mkTerm "man_hour_N" ;
lin man_of_war_N = mkTerm "man_of_war_N" ;
lin man_sized_A = mkTerm "man_sized_A" ;
lin man_up_V = mkTerm "man_up_V" ;
lin manacle_N = mkTerm "manacle_N" ;
lin manacle_V2 = mkTerm "manacle_V2" ;
lin manage_V = mkTerm "manage_V" ;
lin manage_V2 = mkTerm "manage_V2" ;
lin manage_VV = mkTerm "manage_VV" ;
lin manageability_N = mkTerm "manageability_N" ;
lin manageable_A = mkTerm "manageable_A" ;
lin management_N = mkTerm "management_N" ;
lin manager_N = mkTerm "manager_N" ;
lin manageress_N = mkTerm "manageress_N" ;
lin managerial_A = mkTerm "managerial_A" ;
lin managership_N = mkTerm "managership_N" ;
lin managing_A = mkTerm "managing_A" ;
lin manakin_N = mkTerm "manakin_N" ;
lin manana_N = mkTerm "manana_N" ;
lin manat_N = mkTerm "manat_N" ;
lin manatee_N = mkTerm "manatee_N" ;
lin manchester_PN = mkTerm "manchester_PN" ;
lin mancunian_A = mkTerm "mancunian_A" ;
lin mancunian_N = mkTerm "mancunian_N" ;
lin mandala_N = mkTerm "mandala_N" ;
lin mandamus_N = mkTerm "mandamus_N" ;
lin mandarin_N = mkTerm "mandarin_N" ;
lin mandatary_N = mkTerm "mandatary_N" ;
lin mandate_N = mkTerm "mandate_N" ;
lin mandate_V2 = mkTerm "mandate_V2" ;
lin mandate_VS = mkTerm "mandate_VS" ;
lin mandator_N = mkTerm "mandator_N" ;
lin mandatory_A = mkTerm "mandatory_A" ;
lin mandatory_N = mkTerm "mandatory_N" ;
lin mandible_N = mkTerm "mandible_N" ;
lin mandibular_A = mkTerm "mandibular_A" ;
lin mandibulate_A = mkTerm "mandibulate_A" ;
lin mandibulofacial_A = mkTerm "mandibulofacial_A" ;
lin mandola_N = mkTerm "mandola_N" ;
lin mandolin_N = mkTerm "mandolin_N" ;
lin mandragora_N = mkTerm "mandragora_N" ;
lin mandrake_N = mkTerm "mandrake_N" ;
lin mandrill_N = mkTerm "mandrill_N" ;
lin mandy_PN = mkTerm "mandy_PN" ;
lin mane_N = mkTerm "mane_N" ;
lin maneuver_N = mkTerm "maneuver_N" ;
lin maneuverability_N = mkTerm "maneuverability_N" ;
lin maneuverable_A = mkTerm "maneuverable_A" ;
lin maneuverer_N = mkTerm "maneuverer_N" ;
lin manful_A = mkTerm "manful_A" ;
lin manfulness_N = mkTerm "manfulness_N" ;
lin manga_N = mkTerm "manga_N" ;
lin mangabey_N = mkTerm "mangabey_N" ;
lin manganate_N = mkTerm "manganate_N" ;
lin manganese_N = mkTerm "manganese_N" ;
lin manganite_N = mkTerm "manganite_N" ;
lin mange_N = mkTerm "mange_N" ;
lin mangel_wurzel_N = mkTerm "mangel_wurzel_N" ;
lin manger_N = mkTerm "manger_N" ;
lin mangle_N = mkTerm "mangle_N" ;
lin mangle_V2 = mkTerm "mangle_V2" ;
lin manglietia_N = mkTerm "manglietia_N" ;
lin mango_N = mkTerm "mango_N" ;
lin mangosteen_N = mkTerm "mangosteen_N" ;
lin mangrove_N = mkTerm "mangrove_N" ;
lin mangy_A = mkTerm "mangy_A" ;
lin manhandle_V2 = mkTerm "manhandle_V2" ;
lin manhattan_PN = mkTerm "manhattan_PN" ;
lin manhole_N = mkTerm "manhole_N" ;
lin manhood_N = mkTerm "manhood_N" ;
lin manhunt_N = mkTerm "manhunt_N" ;
lin mania_N = mkTerm "mania_N" ;
lin maniac_N = mkTerm "maniac_N" ;
lin maniacal_A = mkTerm "maniacal_A" ;
lin manic_depressive_A = mkTerm "manic_depressive_A" ;
lin manic_depressive_N = mkTerm "manic_depressive_N" ;
lin maniclike_A = mkTerm "maniclike_A" ;
lin manicotti_N = mkTerm "manicotti_N" ;
lin manicure_N = mkTerm "manicure_N" ;
lin manicure_V2 = mkTerm "manicure_V2" ;
lin manicurist_N = mkTerm "manicurist_N" ;
lin manifest_A = mkTerm "manifest_A" ;
lin manifest_N = mkTerm "manifest_N" ;
lin manifest_V2 = mkTerm "manifest_V2" ;
lin manifestation_N = mkTerm "manifestation_N" ;
lin manifesto_N = mkTerm "manifesto_N" ;
lin manifold_A = mkTerm "manifold_A" ;
lin manifold_N = mkTerm "manifold_N" ;
lin manifold_V2 = mkTerm "manifold_V2" ;
lin manikin_N = mkTerm "manikin_N" ;
lin manila_N = mkTerm "manila_N" ;
lin manila_PN = mkTerm "manila_PN" ;
lin manilla_N = mkTerm "manilla_N" ;
lin manipulability_N = mkTerm "manipulability_N" ;
lin manipulate_V2 = mkTerm "manipulate_V2" ;
lin manipulation_N = mkTerm "manipulation_N" ;
lin manipulative_A = mkTerm "manipulative_A" ;
lin manipulator_N = mkTerm "manipulator_N" ;
lin maniraptor_N = mkTerm "maniraptor_N" ;
lin manitoba_PN = mkTerm "manitoba_PN" ;
lin mankind_N = mkTerm "mankind_N" ;
lin manky_A = mkTerm "manky_A" ;
lin manlike_A = mkTerm "manlike_A" ;
lin manliness_N = mkTerm "manliness_N" ;
lin manly_A = mkTerm "manly_A" ;
lin manna_N = mkTerm "manna_N" ;
lin mannequin_N = mkTerm "mannequin_N" ;
lin manner_N = mkTerm "manner_N" ;
lin mannered_A = mkTerm "mannered_A" ;
lin mannerism_N = mkTerm "mannerism_N" ;
lin mannerly_A = mkTerm "mannerly_A" ;
lin manners_N = mkTerm "manners_N" ;
lin mannheim_PN = mkTerm "mannheim_PN" ;
lin mannish_A = mkTerm "mannish_A" ;
lin mannitol_N = mkTerm "mannitol_N" ;
lin manoeuvrability_N = mkTerm "manoeuvrability_N" ;
lin manoeuvrable_A = mkTerm "manoeuvrable_A" ;
lin manoeuvre_N = mkTerm "manoeuvre_N" ;
lin manoeuvre_V = mkTerm "manoeuvre_V" ;
lin manoeuvre_V2 = mkTerm "manoeuvre_V2" ;
lin manoeuvrer_N = mkTerm "manoeuvrer_N" ;
lin manometer_N = mkTerm "manometer_N" ;
lin manor_N = mkTerm "manor_N" ;
lin manor_house_N = mkTerm "manor_house_N" ;
lin manorial_A = mkTerm "manorial_A" ;
lin manpower_N = mkTerm "manpower_N" ;
lin manque_A = mkTerm "manque_A" ;
lin mansard_A = mkTerm "mansard_A" ;
lin mansard_N = mkTerm "mansard_N" ;
lin manse_N = mkTerm "manse_N" ;
lin manservant_N = mkTerm "manservant_N" ;
lin mansfield_PN = mkTerm "mansfield_PN" ;
lin mansion_N = mkTerm "mansion_N" ;
lin manslaughter_N = mkTerm "manslaughter_N" ;
lin manta_N = mkTerm "manta_N" ;
lin mantel_N = mkTerm "mantel_N" ;
lin mantelet_N = mkTerm "mantelet_N" ;
lin mantelpiece_N = mkTerm "mantelpiece_N" ;
lin manticore_N = mkTerm "manticore_N" ;
lin mantilla_N = mkTerm "mantilla_N" ;
lin mantis_N = mkTerm "mantis_N" ;
lin mantispid_N = mkTerm "mantispid_N" ;
lin mantissa_N = mkTerm "mantissa_N" ;
lin mantle_N = mkTerm "mantle_N" ;
lin mantle_V = mkTerm "mantle_V" ;
lin mantle_V2 = mkTerm "mantle_V2" ;
lin mantra_N = mkTerm "mantra_N" ;
lin mantrap_N = mkTerm "mantrap_N" ;
lin mantua_N = mkTerm "mantua_N" ;
lin manual_A = mkTerm "manual_A" ;
lin manual_N = mkTerm "manual_N" ;
lin manubrium_N = mkTerm "manubrium_N" ;
lin manufacture_N = mkTerm "manufacture_N" ;
lin manufacture_V2 = mkTerm "manufacture_V2" ;
lin manufacturer_N = mkTerm "manufacturer_N" ;
lin manufacturing_A = mkTerm "manufacturing_A" ;
lin manufacturing_N = mkTerm "manufacturing_N" ;
lin manul_N = mkTerm "manul_N" ;
lin manumission_N = mkTerm "manumission_N" ;
lin manumit_V2 = mkTerm "manumit_V2" ;
lin manure_N = mkTerm "manure_N" ;
lin manure_V2 = mkTerm "manure_V2" ;
lin manuscript_N = mkTerm "manuscript_N" ;
lin manx_A = mkTerm "manx_A" ;
lin manx_N = mkTerm "manx_N" ;
lin many_sided_A = mkTerm "many_sided_A" ;
lin manzanita_N = mkTerm "manzanita_N" ;
lin maoism_N = mkTerm "maoism_N" ;
lin maoist_N = mkTerm "maoist_N" ;
lin maori_N = mkTerm "maori_N" ;
lin map_N = mkTerm "map_N" ;
lin map_V2 = mkTerm "map_V2" ;
lin map_out_V = mkTerm "map_out_V" ;
lin map_reader_N = mkTerm "map_reader_N" ;
lin mapinguari_N = mkTerm "mapinguari_N" ;
lin maple_N = mkTerm "maple_N" ;
lin maple_leaf_N = mkTerm "maple_leaf_N" ;
lin maplelike_A = mkTerm "maplelike_A" ;
lin mapmaking_N = mkTerm "mapmaking_N" ;
lin mapping_N = mkTerm "mapping_N" ;
lin maquiladora_N = mkTerm "maquiladora_N" ;
lin maquis_N = mkTerm "maquis_N" ;
lin mar_PN = mkTerm "mar_PN" ;
lin mar_V2 = mkTerm "mar_V2" ;
lin mara_N = mkTerm "mara_N" ;
lin marabou_N = mkTerm "marabou_N" ;
lin maraca_N = mkTerm "maraca_N" ;
lin maracaibo_PN = mkTerm "maracaibo_PN" ;
lin marang_N = mkTerm "marang_N" ;
lin maranta_N = mkTerm "maranta_N" ;
lin marasca_N = mkTerm "marasca_N" ;
lin maraschino_N = mkTerm "maraschino_N" ;
lin marasmus_N = mkTerm "marasmus_N" ;
lin marathon_N = mkTerm "marathon_N" ;
lin marathoner_N = mkTerm "marathoner_N" ;
lin maraud_V = mkTerm "maraud_V" ;
lin marauder_N = mkTerm "marauder_N" ;
lin marble_N = mkTerm "marble_N" ;
lin marbled_A = mkTerm "marbled_A" ;
lin marbleization_N = mkTerm "marbleization_N" ;
lin marbles_N = mkTerm "marbles_N" ;
lin marblewood_N = mkTerm "marblewood_N" ;
lin marbling_N = mkTerm "marbling_N" ;
lin marc_N = mkTerm "marc_N" ;
lin marcel_N = mkTerm "marcel_N" ;
lin march_V = mkTerm "march_V" ;
lin march_V2 = mkTerm "march_V2" ;
lin marcher_N = mkTerm "marcher_N" ;
lin marchioness_N = mkTerm "marchioness_N" ;
lin mardi_gras_N = mkTerm "mardi_gras_N" ;
lin mare_N = mkTerm "mare_N" ;
lin margaret_PN = mkTerm "margaret_PN" ;
lin margarin_N = mkTerm "margarin_N" ;
lin margarine_N = mkTerm "margarine_N" ;
lin margarita_N = mkTerm "margarita_N" ;
lin margate_N = mkTerm "margate_N" ;
lin margate_PN = mkTerm "margate_PN" ;
lin margay_N = mkTerm "margay_N" ;
lin marge_N = mkTerm "marge_N" ;
lin marge_PN = mkTerm "marge_PN" ;
lin margery_PN = mkTerm "margery_PN" ;
lin margie_PN = mkTerm "margie_PN" ;
lin margin_N = mkTerm "margin_N" ;
lin marginal_A = mkTerm "marginal_A" ;
lin marginalia_N = mkTerm "marginalia_N" ;
lin marginality_N = mkTerm "marginality_N" ;
lin marginalization_N = mkTerm "marginalization_N" ;
lin marginalize_V2 = mkTerm "marginalize_V2" ;
lin margrave_N = mkTerm "margrave_N" ;
lin marguerite_N = mkTerm "marguerite_N" ;
lin maria_PN = mkTerm "maria_PN" ;
lin mariachi_N = mkTerm "mariachi_N" ;
lin marian_PN = mkTerm "marian_PN" ;
lin marie_PN = mkTerm "marie_PN" ;
lin marigold_N = mkTerm "marigold_N" ;
lin marihuana_N = mkTerm "marihuana_N" ;
lin marilyn_PN = mkTerm "marilyn_PN" ;
lin marimba_N = mkTerm "marimba_N" ;
lin marina_N = mkTerm "marina_N" ;
lin marinade_N = mkTerm "marinade_N" ;
lin marinade_V2 = mkTerm "marinade_V2" ;
lin marinara_N = mkTerm "marinara_N" ;
lin marinate_V2 = mkTerm "marinate_V2" ;
lin marine_A = mkTerm "marine_A" ;
lin marine_N = mkTerm "marine_N" ;
lin mariner_N = mkTerm "mariner_N" ;
lin marion_PN = mkTerm "marion_PN" ;
lin marionette_N = mkTerm "marionette_N" ;
lin mariposa_N = mkTerm "mariposa_N" ;
lin marital_A = mkTerm "marital_A" ;
lin mariticide_N = mkTerm "mariticide_N" ;
lin maritime_A = mkTerm "maritime_A" ;
lin marjoram_N = mkTerm "marjoram_N" ;
lin marjorie_PN = mkTerm "marjorie_PN" ;
lin mark_N = mkTerm "mark_N" ;
lin mark_PN = mkTerm "mark_PN" ;
lin mark_V2 = mkTerm "mark_V2" ;
lin mark_V3 = mkTerm "mark_V3" ;
lin mark_down_V2 = mkTerm "mark_down_V2" ;
lin mark_down_as_V3 = mkTerm "mark_down_as_V3" ;
lin mark_off_V2 = mkTerm "mark_off_V2" ;
lin mark_out_V2 = mkTerm "mark_out_V2" ;
lin mark_out_for_V3 = mkTerm "mark_out_for_V3" ;
lin mark_out_from_V3 = mkTerm "mark_out_from_V3" ;
lin mark_up_N = mkTerm "mark_up_N" ;
lin mark_up_V2 = mkTerm "mark_up_V2" ;
lin marke_VS = mkTerm "marke_VS" ;
lin marke_up_V = mkTerm "marke_up_V" ;
lin marked_A = mkTerm "marked_A" ;
lin marker_N = mkTerm "marker_N" ;
lin market_1_N = mkTerm "market_1_N" ;
lin market_2_N = mkTerm "market_2_N" ;
lin market_V = mkTerm "market_V" ;
lin market_V2 = mkTerm "market_V2" ;
lin market_cross_N = mkTerm "market_cross_N" ;
lin market_day_N = mkTerm "market_day_N" ;
lin market_drayton_PN = mkTerm "market_drayton_PN" ;
lin market_garden_N = mkTerm "market_garden_N" ;
lin market_gardening_N = mkTerm "market_gardening_N" ;
lin market_harborough_PN = mkTerm "market_harborough_PN" ;
lin market_square_N = mkTerm "market_square_N" ;
lin market_town_N = mkTerm "market_town_N" ;
lin marketable_A = mkTerm "marketable_A" ;
lin marketing_N = mkTerm "marketing_N" ;
lin marketplace_N = mkTerm "marketplace_N" ;
lin markhor_N = mkTerm "markhor_N" ;
lin marking_N = mkTerm "marking_N" ;
lin marking_ink_N = mkTerm "marking_ink_N" ;
lin marking_inks_N = mkTerm "marking_inks_N" ;
lin markka_N = mkTerm "markka_N" ;
lin marksman_N = mkTerm "marksman_N" ;
lin marksmanship_N = mkTerm "marksmanship_N" ;
lin marl_N = mkTerm "marl_N" ;
lin marlberry_N = mkTerm "marlberry_N" ;
lin marlborough_PN = mkTerm "marlborough_PN" ;
lin marlene_PN = mkTerm "marlene_PN" ;
lin marlin_N = mkTerm "marlin_N" ;
lin marline_N = mkTerm "marline_N" ;
lin marlinespike_N = mkTerm "marlinespike_N" ;
lin marlite_N = mkTerm "marlite_N" ;
lin marlow_PN = mkTerm "marlow_PN" ;
lin marly_A = mkTerm "marly_A" ;
lin marmalade_N = mkTerm "marmalade_N" ;
lin marmite_N = mkTerm "marmite_N" ;
lin marmoreal_A = mkTerm "marmoreal_A" ;
lin marmorean_A = mkTerm "marmorean_A" ;
lin marmoset_N = mkTerm "marmoset_N" ;
lin marmot_N = mkTerm "marmot_N" ;
lin marocain_N = mkTerm "marocain_N" ;
lin maroon_A = mkTerm "maroon_A" ;
lin maroon_N = mkTerm "maroon_N" ;
lin maroon_V2 = mkTerm "maroon_V2" ;
lin marple_PN = mkTerm "marple_PN" ;
lin marque_N = mkTerm "marque_N" ;
lin marquee_N = mkTerm "marquee_N" ;
lin marquess_N = mkTerm "marquess_N" ;
lin marquetry_N = mkTerm "marquetry_N" ;
lin marquis_N = mkTerm "marquis_N" ;
lin marriage_N = mkTerm "marriage_N" ;
lin marriageability_N = mkTerm "marriageability_N" ;
lin marriageable_A = mkTerm "marriageable_A" ;
lin married_A = mkTerm "married_A" ;
lin married_N = mkTerm "married_N" ;
lin marrow_1_N = mkTerm "marrow_1_N" ;
lin marrow_2_N = mkTerm "marrow_2_N" ;
lin marrowbone_N = mkTerm "marrowbone_N" ;
lin marry_V = mkTerm "marry_V" ;
lin marry_V2 = mkTerm "marry_V2" ;
lin marry_in_V = mkTerm "marry_in_V" ;
lin marry_out_V = mkTerm "marry_out_V" ;
lin mars_PN = mkTerm "mars_PN" ;
lin marsala_N = mkTerm "marsala_N" ;
lin marseillaise_N = mkTerm "marseillaise_N" ;
lin marseille_N = mkTerm "marseille_N" ;
lin marseilles_PN = mkTerm "marseilles_PN" ;
lin marsh_N = mkTerm "marsh_N" ;
lin marshal_N = mkTerm "marshal_N" ;
lin marshal_V2 = mkTerm "marshal_V2" ;
lin marshalling_yard_N = mkTerm "marshalling_yard_N" ;
lin marshalship_N = mkTerm "marshalship_N" ;
lin marshmallow_N = mkTerm "marshmallow_N" ;
lin marshy_A = mkTerm "marshy_A" ;
lin marske_PN = mkTerm "marske_PN" ;
lin marsupial_A = mkTerm "marsupial_A" ;
lin marsupial_N = mkTerm "marsupial_N" ;
lin marsupium_N = mkTerm "marsupium_N" ;
lin mart_N = mkTerm "mart_N" ;
lin marten_N = mkTerm "marten_N" ;
lin martensite_N = mkTerm "martensite_N" ;
lin martha_PN = mkTerm "martha_PN" ;
lin martial_A = mkTerm "martial_A" ;
lin martian_A = mkTerm "martian_A" ;
lin martian_N = mkTerm "martian_N" ;
lin martin_N = mkTerm "martin_N" ;
lin martin_PN = mkTerm "martin_PN" ;
lin martinet_N = mkTerm "martinet_N" ;
lin martingale_N = mkTerm "martingale_N" ;
lin martini_N = mkTerm "martini_N" ;
lin marttila_PN = mkTerm "marttila_PN" ;
lin martynia_N = mkTerm "martynia_N" ;
lin martyr_N = mkTerm "martyr_N" ;
lin martyr_V2 = mkTerm "martyr_V2" ;
lin martyrdom_N = mkTerm "martyrdom_N" ;
lin marumi_N = mkTerm "marumi_N" ;
lin marupa_N = mkTerm "marupa_N" ;
lin marvel_N = mkTerm "marvel_N" ;
lin marvel_V = mkTerm "marvel_V" ;
lin marvellous_A = mkTerm "marvellous_A" ;
lin marxism_N = mkTerm "marxism_N" ;
lin marxistFem_N = mkTerm "marxistFem_N" ;
lin marxistMasc_N = mkTerm "marxistMasc_N" ;
lin mary_PN = mkTerm "mary_PN" ;
lin maryland_PN = mkTerm "maryland_PN" ;
lin maryport_PN = mkTerm "maryport_PN" ;
lin marzipan_N = mkTerm "marzipan_N" ;
lin masc_PN = mkTerm "masc_PN" ;
lin mascara_N = mkTerm "mascara_N" ;
lin mascarpone_N = mkTerm "mascarpone_N" ;
lin mascot_N = mkTerm "mascot_N" ;
lin masculine_A = mkTerm "masculine_A" ;
lin masculine_N = mkTerm "masculine_N" ;
lin masculinity_N = mkTerm "masculinity_N" ;
lin masculinization_N = mkTerm "masculinization_N" ;
lin masdevallia_N = mkTerm "masdevallia_N" ;
lin maser_N = mkTerm "maser_N" ;
lin mash_N = mkTerm "mash_N" ;
lin mash_V2 = mkTerm "mash_V2" ;
lin mash_up_V2 = mkTerm "mash_up_V2" ;
lin masher_N = mkTerm "masher_N" ;
lin mashie_N = mkTerm "mashie_N" ;
lin masjid_N = mkTerm "masjid_N" ;
lin mask_N = mkTerm "mask_N" ;
lin mask_V2 = mkTerm "mask_V2" ;
lin masking_N = mkTerm "masking_N" ;
lin masku_PN = mkTerm "masku_PN" ;
lin masochism_N = mkTerm "masochism_N" ;
lin masochist_N = mkTerm "masochist_N" ;
lin masochistic_A = mkTerm "masochistic_A" ;
lin mason_N = mkTerm "mason_N" ;
lin mason_dixon_PN = mkTerm "mason_dixon_PN" ;
lin masonic_A = mkTerm "masonic_A" ;
lin masonry_N = mkTerm "masonry_N" ;
lin masque_N = mkTerm "masque_N" ;
lin masquerade_N = mkTerm "masquerade_N" ;
lin masquerade_V = mkTerm "masquerade_V" ;
lin masquerader_N = mkTerm "masquerader_N" ;
lin mass_1_N = mkTerm "mass_1_N" ;
lin mass_2_N = mkTerm "mass_2_N" ;
lin mass_3_N = mkTerm "mass_3_N" ;
lin mass_A = mkTerm "mass_A" ;
lin mass_V = mkTerm "mass_V" ;
lin mass_V2 = mkTerm "mass_V2" ;
lin mass_produce_V2 = mkTerm "mass_produce_V2" ;
lin massachusetts_PN = mkTerm "massachusetts_PN" ;
lin massacre_N = mkTerm "massacre_N" ;
lin massacre_V2 = mkTerm "massacre_V2" ;
lin massage_N = mkTerm "massage_N" ;
lin massage_V2 = mkTerm "massage_V2" ;
lin massager_N = mkTerm "massager_N" ;
lin massasauga_N = mkTerm "massasauga_N" ;
lin masse_N = mkTerm "masse_N" ;
lin masseter_N = mkTerm "masseter_N" ;
lin masseur_N = mkTerm "masseur_N" ;
lin masseuse_N = mkTerm "masseuse_N" ;
lin massicot_N = mkTerm "massicot_N" ;
lin massif_N = mkTerm "massif_N" ;
lin massive_A = mkTerm "massive_A" ;
lin massiveness_N = mkTerm "massiveness_N" ;
lin massy_A = mkTerm "massy_A" ;
lin mast_N = mkTerm "mast_N" ;
lin mastaba_N = mkTerm "mastaba_N" ;
lin mastalgia_N = mkTerm "mastalgia_N" ;
lin mastectomy_N = mkTerm "mastectomy_N" ;
lin masted_A = mkTerm "masted_A" ;
lin master_1_N = mkTerm "master_1_N" ;
lin master_2_N = mkTerm "master_2_N" ;
lin master_V2 = mkTerm "master_V2" ;
lin master_at_arms_N = mkTerm "master_at_arms_N" ;
lin master_key_N = mkTerm "master_key_N" ;
lin masterful_A = mkTerm "masterful_A" ;
lin mastering_N = mkTerm "mastering_N" ;
lin masterless_A = mkTerm "masterless_A" ;
lin masterly_A = mkTerm "masterly_A" ;
lin mastermind_N = mkTerm "mastermind_N" ;
lin mastermind_V2 = mkTerm "mastermind_V2" ;
lin masterpiece_N = mkTerm "masterpiece_N" ;
lin mastership_N = mkTerm "mastership_N" ;
lin masterstroke_N = mkTerm "masterstroke_N" ;
lin mastery_N = mkTerm "mastery_N" ;
lin masthead_N = mkTerm "masthead_N" ;
lin mastic_N = mkTerm "mastic_N" ;
lin masticate_V2 = mkTerm "masticate_V2" ;
lin mastication_N = mkTerm "mastication_N" ;
lin mastiff_N = mkTerm "mastiff_N" ;
lin mastitis_N = mkTerm "mastitis_N" ;
lin mastodon_N = mkTerm "mastodon_N" ;
lin mastoid_A = mkTerm "mastoid_A" ;
lin mastoid_N = mkTerm "mastoid_N" ;
lin mastoidale_N = mkTerm "mastoidale_N" ;
lin mastoidectomy_N = mkTerm "mastoidectomy_N" ;
lin mastoiditis_N = mkTerm "mastoiditis_N" ;
lin mastopathy_N = mkTerm "mastopathy_N" ;
lin mastopexy_N = mkTerm "mastopexy_N" ;
lin masturbate_V = mkTerm "masturbate_V" ;
lin masturbate_V2 = mkTerm "masturbate_V2" ;
lin masturbation_N = mkTerm "masturbation_N" ;
lin masturbator_N = mkTerm "masturbator_N" ;
lin mat_A = mkTerm "mat_A" ;
lin mat_N = mkTerm "mat_N" ;
lin mat_V = mkTerm "mat_V" ;
lin mat_V2 = mkTerm "mat_V2" ;
lin matador_N = mkTerm "matador_N" ;
lin matai_N = mkTerm "matai_N" ;
lin match_1_N = mkTerm "match_1_N" ;
lin match_2_N = mkTerm "match_2_N" ;
lin match_3_N = mkTerm "match_3_N" ;
lin match_V2 = mkTerm "match_V2" ;
lin match_point_N = mkTerm "match_point_N" ;
lin match_up_V = mkTerm "match_up_V" ;
lin matchboard_N = mkTerm "matchboard_N" ;
lin matchbook_N = mkTerm "matchbook_N" ;
lin matchbox_N = mkTerm "matchbox_N" ;
lin matchet_N = mkTerm "matchet_N" ;
lin matchless_A = mkTerm "matchless_A" ;
lin matchlock_N = mkTerm "matchlock_N" ;
lin matchmaker_N = mkTerm "matchmaker_N" ;
lin matchmaking_N = mkTerm "matchmaking_N" ;
lin matchstick_N = mkTerm "matchstick_N" ;
lin matchweed_N = mkTerm "matchweed_N" ;
lin matchwood_N = mkTerm "matchwood_N" ;
lin mateFem_1_N = mkTerm "mateFem_1_N" ;
lin mateFem_2_N = mkTerm "mateFem_2_N" ;
lin mateMasc_1_N = mkTerm "mateMasc_1_N" ;
lin mateMasc_2_N = mkTerm "mateMasc_2_N" ;
lin mate_N = mkTerm "mate_N" ;
lin mate_V = mkTerm "mate_V" ;
lin mate_V2 = mkTerm "mate_V2" ;
lin mateless_A = mkTerm "mateless_A" ;
lin matelote_N = mkTerm "matelote_N" ;
lin mater_N = mkTerm "mater_N" ;
lin material_A = mkTerm "material_A" ;
lin material_N = mkTerm "material_N" ;
lin materialism_N = mkTerm "materialism_N" ;
lin materialist_N = mkTerm "materialist_N" ;
lin materialistic_A = mkTerm "materialistic_A" ;
lin materiality_N = mkTerm "materiality_N" ;
lin materialization_N = mkTerm "materialization_N" ;
lin materialize_V = mkTerm "materialize_V" ;
lin materialize_V2V = mkTerm "materialize_V2V" ;
lin materiel_N = mkTerm "materiel_N" ;
lin maternal_A = mkTerm "maternal_A" ;
lin maternalism_N = mkTerm "maternalism_N" ;
lin maternalistic_A = mkTerm "maternalistic_A" ;
lin maternity_N = mkTerm "maternity_N" ;
lin matey_A = mkTerm "matey_A" ;
lin math_N = mkTerm "math_N" ;
lin mathematical_A = mkTerm "mathematical_A" ;
lin mathematicianFem_N = mkTerm "mathematicianFem_N" ;
lin mathematicianMasc_N = mkTerm "mathematicianMasc_N" ;
lin mathematics_N = mkTerm "mathematics_N" ;
lin maths_N = mkTerm "maths_N" ;
lin matinee_N = mkTerm "matinee_N" ;
lin matins_N = mkTerm "matins_N" ;
lin matlock_PN = mkTerm "matlock_PN" ;
lin matriarch_N = mkTerm "matriarch_N" ;
lin matriarchal_A = mkTerm "matriarchal_A" ;
lin matriarchic_A = mkTerm "matriarchic_A" ;
lin matriarchy_N = mkTerm "matriarchy_N" ;
lin matric_N = mkTerm "matric_N" ;
lin matricentric_A = mkTerm "matricentric_A" ;
lin matricide_N = mkTerm "matricide_N" ;
lin matriculate_N = mkTerm "matriculate_N" ;
lin matriculate_V = mkTerm "matriculate_V" ;
lin matriculate_V2 = mkTerm "matriculate_V2" ;
lin matriculation_N = mkTerm "matriculation_N" ;
lin matrilineage_N = mkTerm "matrilineage_N" ;
lin matrilineal_A = mkTerm "matrilineal_A" ;
lin matrimonial_A = mkTerm "matrimonial_A" ;
lin matrimony_N = mkTerm "matrimony_N" ;
lin matrix_N = mkTerm "matrix_N" ;
lin matron_N = mkTerm "matron_N" ;
lin matronly_A = mkTerm "matronly_A" ;
lin matronymic_N = mkTerm "matronymic_N" ;
lin matsyendra_N = mkTerm "matsyendra_N" ;
lin matt_A = mkTerm "matt_A" ;
lin matt_PN = mkTerm "matt_PN" ;
lin matte_N = mkTerm "matte_N" ;
lin matter_1_N = mkTerm "matter_1_N" ;
lin matter_2_N = mkTerm "matter_2_N" ;
lin matter_V = mkTerm "matter_V" ;
lin matter_of_course_A = mkTerm "matter_of_course_A" ;
lin matter_of_fact_A = mkTerm "matter_of_fact_A" ;
lin matthew_PN = mkTerm "matthew_PN" ;
lin matting_N = mkTerm "matting_N" ;
lin mattock_N = mkTerm "mattock_N" ;
lin mattress_N = mkTerm "mattress_N" ;
lin maturate_V = mkTerm "maturate_V" ;
lin maturation_N = mkTerm "maturation_N" ;
lin maturational_A = mkTerm "maturational_A" ;
lin mature_A = mkTerm "mature_A" ;
lin mature_V = mkTerm "mature_V" ;
lin mature_V2 = mkTerm "mature_V2" ;
lin maturity_1_N = mkTerm "maturity_1_N" ;
lin maturity_2_N = mkTerm "maturity_2_N" ;
lin maturity_3_N = mkTerm "maturity_3_N" ;
lin matutinal_A = mkTerm "matutinal_A" ;
lin matzo_N = mkTerm "matzo_N" ;
lin maud_PN = mkTerm "maud_PN" ;
lin maudie_PN = mkTerm "maudie_PN" ;
lin maudlin_A = mkTerm "maudlin_A" ;
lin maul_N = mkTerm "maul_N" ;
lin maul_V2 = mkTerm "maul_V2" ;
lin mauler_N = mkTerm "mauler_N" ;
lin maulstick_N = mkTerm "maulstick_N" ;
lin maund_N = mkTerm "maund_N" ;
lin maunder_V = mkTerm "maunder_V" ;
lin maundy_thursday_N = mkTerm "maundy_thursday_N" ;
lin maundy_thursday_PN = mkTerm "maundy_thursday_PN" ;
lin maureen_PN = mkTerm "maureen_PN" ;
lin maurice_PN = mkTerm "maurice_PN" ;
lin mauritania_PN = mkTerm "mauritania_PN" ;
lin mauritanian_A = mkTerm "mauritanian_A" ;
lin mauritanian_N = mkTerm "mauritanian_N" ;
lin mauritian_A = mkTerm "mauritian_A" ;
lin mauritian_N = mkTerm "mauritian_N" ;
lin mauritius_PN = mkTerm "mauritius_PN" ;
lin mausoleum_N = mkTerm "mausoleum_N" ;
lin mauve_A = mkTerm "mauve_A" ;
lin mauve_N = mkTerm "mauve_N" ;
lin maverick_N = mkTerm "maverick_N" ;
lin mavis_N = mkTerm "mavis_N" ;
lin mavis_PN = mkTerm "mavis_PN" ;
lin maw_N = mkTerm "maw_N" ;
lin mawkish_A = mkTerm "mawkish_A" ;
lin mawkishness_N = mkTerm "mawkishness_N" ;
lin max_N = mkTerm "max_N" ;
lin max_PN = mkTerm "max_PN" ;
lin max_out_V2 = mkTerm "max_out_V2" ;
lin maxi_A = mkTerm "maxi_A" ;
lin maxi_N = mkTerm "maxi_N" ;
lin maxillaria_N = mkTerm "maxillaria_N" ;
lin maxillary_A = mkTerm "maxillary_A" ;
lin maxillodental_A = mkTerm "maxillodental_A" ;
lin maxillofacial_A = mkTerm "maxillofacial_A" ;
lin maxillomandibular_A = mkTerm "maxillomandibular_A" ;
lin maxim_N = mkTerm "maxim_N" ;
lin maximal_A = mkTerm "maximal_A" ;
lin maximization_N = mkTerm "maximization_N" ;
lin maximize_V2 = mkTerm "maximize_V2" ;
lin maximizing_A = mkTerm "maximizing_A" ;
lin maximum_A = mkTerm "maximum_A" ;
lin maximum_N = mkTerm "maximum_N" ;
lin maxine_PN = mkTerm "maxine_PN" ;
lin maxwell_N = mkTerm "maxwell_N" ;
lin may_1_VV = mkTerm "may_1_VV" ;
lin may_2_VV = mkTerm "may_2_VV" ;
lin may_beetle_N = mkTerm "may_beetle_N" ;
lin may_bug_N = mkTerm "may_bug_N" ;
lin mayapple_N = mkTerm "mayapple_N" ;
lin maybe_Adv = mkTerm "maybe_Adv" ;
lin mayday_N = mkTerm "mayday_N" ;
lin mayeng_N = mkTerm "mayeng_N" ;
lin mayfair_PN = mkTerm "mayfair_PN" ;
lin mayfield_PN = mkTerm "mayfield_PN" ;
lin mayfly_N = mkTerm "mayfly_N" ;
lin mayhaw_N = mkTerm "mayhaw_N" ;
lin mayhem_N = mkTerm "mayhem_N" ;
lin mayo_PN = mkTerm "mayo_PN" ;
lin mayonnaise_N = mkTerm "mayonnaise_N" ;
lin mayor_N = mkTerm "mayor_N" ;
lin mayoral_A = mkTerm "mayoral_A" ;
lin mayoralty_N = mkTerm "mayoralty_N" ;
lin mayoress_N = mkTerm "mayoress_N" ;
lin maypole_N = mkTerm "maypole_N" ;
lin maypop_N = mkTerm "maypop_N" ;
lin mayweed_N = mkTerm "mayweed_N" ;
lin maze_N = mkTerm "maze_N" ;
lin mazed_A = mkTerm "mazed_A" ;
lin mazer_N = mkTerm "mazer_N" ;
lin mazurka_N = mkTerm "mazurka_N" ;
lin mb_N = mkTerm "mb_N" ;
lin mc_N = mkTerm "mc_N" ;
lin mcc_N = mkTerm "mcc_N" ;
lin mccarthyism_N = mkTerm "mccarthyism_N" ;
lin md_N = mkTerm "md_N" ;
lin mead_N = mkTerm "mead_N" ;
lin meadow_N = mkTerm "meadow_N" ;
lin meadowgrass_N = mkTerm "meadowgrass_N" ;
lin meadowlark_N = mkTerm "meadowlark_N" ;
lin meager_A = mkTerm "meager_A" ;
lin meagerness_N = mkTerm "meagerness_N" ;
lin meagre_A = mkTerm "meagre_A" ;
lin meagreness_N = mkTerm "meagreness_N" ;
lin meal_N = mkTerm "meal_N" ;
lin mealie_N = mkTerm "mealie_N" ;
lin mealtime_N = mkTerm "mealtime_N" ;
lin mealworm_N = mkTerm "mealworm_N" ;
lin mealy_A = mkTerm "mealy_A" ;
lin mealy_bug_N = mkTerm "mealy_bug_N" ;
lin mealy_mouthed_A = mkTerm "mealy_mouthed_A" ;
lin mealymouthed_A = mkTerm "mealymouthed_A" ;
lin mean_A = mkTerm "mean_A" ;
lin mean_N = mkTerm "mean_N" ;
lin mean_V2 = mkTerm "mean_V2" ;
lin mean_V2V = mkTerm "mean_V2V" ;
lin mean_VS = mkTerm "mean_VS" ;
lin mean_VV = mkTerm "mean_VV" ;
lin meander_N = mkTerm "meander_N" ;
lin meander_V = mkTerm "meander_V" ;
lin meanderingly_Adv = mkTerm "meanderingly_Adv" ;
lin meanie_N = mkTerm "meanie_N" ;
lin meaning_N = mkTerm "meaning_N" ;
lin meaningful_A = mkTerm "meaningful_A" ;
lin meaningfulness_N = mkTerm "meaningfulness_N" ;
lin meaningless_A = mkTerm "meaningless_A" ;
lin meaninglessness_N = mkTerm "meaninglessness_N" ;
lin meanness_N = mkTerm "meanness_N" ;
lin means_N = mkTerm "means_N" ;
lin meanspiritedly_Adv = mkTerm "meanspiritedly_Adv" ;
lin meantime_Adv = mkTerm "meantime_Adv" ;
lin meantime_N = mkTerm "meantime_N" ;
lin meanwhile_Adv = mkTerm "meanwhile_Adv" ;
lin meany_N = mkTerm "meany_N" ;
lin measles_N = mkTerm "measles_N" ;
lin measly_A = mkTerm "measly_A" ;
lin measurable_A = mkTerm "measurable_A" ;
lin measure_N = mkTerm "measure_N" ;
lin measure_V = mkTerm "measure_V" ;
lin measure_V2 = mkTerm "measure_V2" ;
lin measure_against_V3 = mkTerm "measure_against_V3" ;
lin measure_off_V2 = mkTerm "measure_off_V2" ;
lin measure_out_V2 = mkTerm "measure_out_V2" ;
lin measure_up_V = mkTerm "measure_up_V" ;
lin measure_up_V2 = mkTerm "measure_up_V2" ;
lin measure_up_to_V2 = mkTerm "measure_up_to_V2" ;
lin measuredly_Adv = mkTerm "measuredly_Adv" ;
lin measureless_A = mkTerm "measureless_A" ;
lin measurement_N = mkTerm "measurement_N" ;
lin measurer_N = mkTerm "measurer_N" ;
lin meat_N = mkTerm "meat_N" ;
lin meat_safe_N = mkTerm "meat_safe_N" ;
lin meatball_N = mkTerm "meatball_N" ;
lin meath_PN = mkTerm "meath_PN" ;
lin meatless_A = mkTerm "meatless_A" ;
lin meatpacking_N = mkTerm "meatpacking_N" ;
lin meatus_N = mkTerm "meatus_N" ;
lin meaty_A = mkTerm "meaty_A" ;
lin mebendazole_N = mkTerm "mebendazole_N" ;
lin mebibit_N = mkTerm "mebibit_N" ;
lin mecca_N = mkTerm "mecca_N" ;
lin mecca_PN = mkTerm "mecca_PN" ;
lin mechanic_A = mkTerm "mechanic_A" ;
lin mechanic_N = mkTerm "mechanic_N" ;
lin mechanical_A = mkTerm "mechanical_A" ;
lin mechanics_N = mkTerm "mechanics_N" ;
lin mechanism_N = mkTerm "mechanism_N" ;
lin mechanist_N = mkTerm "mechanist_N" ;
lin mechanistic_A = mkTerm "mechanistic_A" ;
lin mechanistically_Adv = mkTerm "mechanistically_Adv" ;
lin mechanization_N = mkTerm "mechanization_N" ;
lin mechanize_V2 = mkTerm "mechanize_V2" ;
lin meclizine_N = mkTerm "meclizine_N" ;
lin meclofenamate_N = mkTerm "meclofenamate_N" ;
lin meconium_N = mkTerm "meconium_N" ;
lin mecopteran_N = mkTerm "mecopteran_N" ;
lin mecopterous_A = mkTerm "mecopterous_A" ;
lin med_N = mkTerm "med_N" ;
lin medal_N = mkTerm "medal_N" ;
lin medalist_N = mkTerm "medalist_N" ;
lin medallion_N = mkTerm "medallion_N" ;
lin medallist_N = mkTerm "medallist_N" ;
lin medan_PN = mkTerm "medan_PN" ;
lin meddle_V = mkTerm "meddle_V" ;
lin meddler_N = mkTerm "meddler_N" ;
lin meddlesome_A = mkTerm "meddlesome_A" ;
lin meddling_N = mkTerm "meddling_N" ;
lin medellin_PN = mkTerm "medellin_PN" ;
lin media_N = mkTerm "media_N" ;
lin mediacy_N = mkTerm "mediacy_N" ;
lin mediaeval_A = mkTerm "mediaeval_A" ;
lin medial_A = mkTerm "medial_A" ;
lin median_A = mkTerm "median_A" ;
lin median_N = mkTerm "median_N" ;
lin mediant_N = mkTerm "mediant_N" ;
lin mediastinum_N = mkTerm "mediastinum_N" ;
lin mediate_A = mkTerm "mediate_A" ;
lin mediate_V = mkTerm "mediate_V" ;
lin mediate_V2 = mkTerm "mediate_V2" ;
lin mediation_N = mkTerm "mediation_N" ;
lin mediator_N = mkTerm "mediator_N" ;
lin mediatorial_A = mkTerm "mediatorial_A" ;
lin mediatory_A = mkTerm "mediatory_A" ;
lin mediatrix_N = mkTerm "mediatrix_N" ;
lin medic_N = mkTerm "medic_N" ;
lin medical_A = mkTerm "medical_A" ;
lin medical_N = mkTerm "medical_N" ;
lin medicament_N = mkTerm "medicament_N" ;
lin medicare_N = mkTerm "medicare_N" ;
lin medicate_V2 = mkTerm "medicate_V2" ;
lin medication_N = mkTerm "medication_N" ;
lin medicative_A = mkTerm "medicative_A" ;
lin medicinal_A = mkTerm "medicinal_A" ;
lin medicine_N = mkTerm "medicine_N" ;
lin medicine_ball_N = mkTerm "medicine_ball_N" ;
lin medicine_chest_N = mkTerm "medicine_chest_N" ;
lin medicine_man_N = mkTerm "medicine_man_N" ;
lin medico_N = mkTerm "medico_N" ;
lin medicolegal_A = mkTerm "medicolegal_A" ;
lin medieval_A = mkTerm "medieval_A" ;
lin medina_N = mkTerm "medina_N" ;
lin mediocre_A = mkTerm "mediocre_A" ;
lin mediocrity_N = mkTerm "mediocrity_N" ;
lin meditate_V = mkTerm "meditate_V" ;
lin meditate_V2 = mkTerm "meditate_V2" ;
lin meditation_N = mkTerm "meditation_N" ;
lin meditative_A = mkTerm "meditative_A" ;
lin mediterranean_A = mkTerm "mediterranean_A" ;
lin medium_A = mkTerm "medium_A" ;
lin medium_N = mkTerm "medium_N" ;
lin medium_grade_A = mkTerm "medium_grade_A" ;
lin medlar_N = mkTerm "medlar_N" ;
lin medley_N = mkTerm "medley_N" ;
lin medroxyprogesterone_N = mkTerm "medroxyprogesterone_N" ;
lin medulla_N = mkTerm "medulla_N" ;
lin medullary_A = mkTerm "medullary_A" ;
lin medusa_N = mkTerm "medusa_N" ;
lin medusoid_A = mkTerm "medusoid_A" ;
lin meed_N = mkTerm "meed_N" ;
lin meek_A = mkTerm "meek_A" ;
lin meekness_N = mkTerm "meekness_N" ;
lin meerkat_N = mkTerm "meerkat_N" ;
lin meerschaum_N = mkTerm "meerschaum_N" ;
lin meet_A = mkTerm "meet_A" ;
lin meet_N = mkTerm "meet_N" ;
lin meet_V = mkTerm "meet_V" ;
lin meet_V2 = mkTerm "meet_V2" ;
lin meet_up_V = mkTerm "meet_up_V" ;
lin meet_with_V2 = mkTerm "meet_with_V2" ;
lin meeting_N = mkTerm "meeting_N" ;
lin meeting_house_N = mkTerm "meeting_house_N" ;
lin meeting_place_N = mkTerm "meeting_place_N" ;
lin mefloquine_N = mkTerm "mefloquine_N" ;
lin meg_PN = mkTerm "meg_PN" ;
lin megabit_N = mkTerm "megabit_N" ;
lin megabyte_N = mkTerm "megabyte_N" ;
lin megacolon_N = mkTerm "megacolon_N" ;
lin megacycle_N = mkTerm "megacycle_N" ;
lin megadeath_N = mkTerm "megadeath_N" ;
lin megaflop_N = mkTerm "megaflop_N" ;
lin megagametophyte_N = mkTerm "megagametophyte_N" ;
lin megahertz_N = mkTerm "megahertz_N" ;
lin megakaryocyte_N = mkTerm "megakaryocyte_N" ;
lin megakaryocytic_A = mkTerm "megakaryocytic_A" ;
lin megalith_N = mkTerm "megalith_N" ;
lin megalithic_A = mkTerm "megalithic_A" ;
lin megaloblast_N = mkTerm "megaloblast_N" ;
lin megaloblastic_A = mkTerm "megaloblastic_A" ;
lin megalocyte_N = mkTerm "megalocyte_N" ;
lin megalomania_N = mkTerm "megalomania_N" ;
lin megalomaniac_N = mkTerm "megalomaniac_N" ;
lin megalomaniacal_A = mkTerm "megalomaniacal_A" ;
lin megalopolis_N = mkTerm "megalopolis_N" ;
lin megalosaur_N = mkTerm "megalosaur_N" ;
lin megaphone_N = mkTerm "megaphone_N" ;
lin megapode_N = mkTerm "megapode_N" ;
lin megascopic_A = mkTerm "megascopic_A" ;
lin megasporangium_N = mkTerm "megasporangium_N" ;
lin megaspore_N = mkTerm "megaspore_N" ;
lin megasporophyll_N = mkTerm "megasporophyll_N" ;
lin megatherian_N = mkTerm "megatherian_N" ;
lin megaton_N = mkTerm "megaton_N" ;
lin megawatt_N = mkTerm "megawatt_N" ;
lin megestrol_N = mkTerm "megestrol_N" ;
lin megillah_N = mkTerm "megillah_N" ;
lin megilp_N = mkTerm "megilp_N" ;
lin megohm_N = mkTerm "megohm_N" ;
lin megrim_N = mkTerm "megrim_N" ;
lin meiosis_N = mkTerm "meiosis_N" ;
lin meiotic_A = mkTerm "meiotic_A" ;
lin meitnerium_N = mkTerm "meitnerium_N" ;
lin melagra_N = mkTerm "melagra_N" ;
lin melamine_N = mkTerm "melamine_N" ;
lin melancholia_N = mkTerm "melancholia_N" ;
lin melancholic_A = mkTerm "melancholic_A" ;
lin melancholic_N = mkTerm "melancholic_N" ;
lin melancholy_A = mkTerm "melancholy_A" ;
lin melancholy_N = mkTerm "melancholy_N" ;
lin melange_N = mkTerm "melange_N" ;
lin melanin_N = mkTerm "melanin_N" ;
lin melanoblast_N = mkTerm "melanoblast_N" ;
lin melanocyte_N = mkTerm "melanocyte_N" ;
lin melanoderma_N = mkTerm "melanoderma_N" ;
lin melanoma_N = mkTerm "melanoma_N" ;
lin melanosis_N = mkTerm "melanosis_N" ;
lin melatonin_N = mkTerm "melatonin_N" ;
lin melbourne_PN = mkTerm "melbourne_PN" ;
lin melcombe_PN = mkTerm "melcombe_PN" ;
lin melcombe_regis_PN = mkTerm "melcombe_regis_PN" ;
lin meld_V2 = mkTerm "meld_V2" ;
lin melee_N = mkTerm "melee_N" ;
lin melena_N = mkTerm "melena_N" ;
lin melilotus_N = mkTerm "melilotus_N" ;
lin meliorate_V = mkTerm "meliorate_V" ;
lin meliorate_V2 = mkTerm "meliorate_V2" ;
lin melioration_N = mkTerm "melioration_N" ;
lin meliorism_N = mkTerm "meliorism_N" ;
lin melksham_PN = mkTerm "melksham_PN" ;
lin mellifluous_A = mkTerm "mellifluous_A" ;
lin mellilä_PN = mkTerm "mellilä_PN" ;
lin mellow_A = mkTerm "mellow_A" ;
lin mellow_V = mkTerm "mellow_V" ;
lin mellow_V2 = mkTerm "mellow_V2" ;
lin mellowing_N = mkTerm "mellowing_N" ;
lin mellowingly_Adv = mkTerm "mellowingly_Adv" ;
lin mellowness_N = mkTerm "mellowness_N" ;
lin melodic_A = mkTerm "melodic_A" ;
lin melodious_A = mkTerm "melodious_A" ;
lin melodiousness_N = mkTerm "melodiousness_N" ;
lin melodrama_N = mkTerm "melodrama_N" ;
lin melodramatic_A = mkTerm "melodramatic_A" ;
lin melody_N = mkTerm "melody_N" ;
lin melon_N = mkTerm "melon_N" ;
lin melosa_N = mkTerm "melosa_N" ;
lin melphalan_N = mkTerm "melphalan_N" ;
lin melt_V = mkTerm "melt_V" ;
lin melt_V2 = mkTerm "melt_V2" ;
lin melt_down_V2 = mkTerm "melt_down_V2" ;
lin meltable_A = mkTerm "meltable_A" ;
lin meltdown_N = mkTerm "meltdown_N" ;
lin melter_N = mkTerm "melter_N" ;
lin meltham_PN = mkTerm "meltham_PN" ;
lin melting_point_N = mkTerm "melting_point_N" ;
lin melting_pot_N = mkTerm "melting_pot_N" ;
lin melton_mowbray_PN = mkTerm "melton_mowbray_PN" ;
lin meltwater_N = mkTerm "meltwater_N" ;
lin mem_N = mkTerm "mem_N" ;
lin member_N = mkTerm "member_N" ;
lin membered_A = mkTerm "membered_A" ;
lin memberless_A = mkTerm "memberless_A" ;
lin membership_N = mkTerm "membership_N" ;
lin membrane_N = mkTerm "membrane_N" ;
lin membranous_A = mkTerm "membranous_A" ;
lin meme_N = mkTerm "meme_N" ;
lin memento_N = mkTerm "memento_N" ;
lin memo_N = mkTerm "memo_N" ;
lin memoir_N = mkTerm "memoir_N" ;
lin memorabilia_N = mkTerm "memorabilia_N" ;
lin memorability_N = mkTerm "memorability_N" ;
lin memorable_A = mkTerm "memorable_A" ;
lin memorandum_N = mkTerm "memorandum_N" ;
lin memorial_N = mkTerm "memorial_N" ;
lin memorialize_V2 = mkTerm "memorialize_V2" ;
lin memorization_N = mkTerm "memorization_N" ;
lin memorize_V2 = mkTerm "memorize_V2" ;
lin memorizer_N = mkTerm "memorizer_N" ;
lin memory_N = mkTerm "memory_N" ;
lin memphis_PN = mkTerm "memphis_PN" ;
lin memsahib_N = mkTerm "memsahib_N" ;
lin menace_N = mkTerm "menace_N" ;
lin menace_V2 = mkTerm "menace_V2" ;
lin menacingly_Adv = mkTerm "menacingly_Adv" ;
lin menage_N = mkTerm "menage_N" ;
lin menagerie_N = mkTerm "menagerie_N" ;
lin menarche_N = mkTerm "menarche_N" ;
lin mend_N = mkTerm "mend_N" ;
lin mend_V = mkTerm "mend_V" ;
lin mend_V2 = mkTerm "mend_V2" ;
lin mendacious_A = mkTerm "mendacious_A" ;
lin mendacity_N = mkTerm "mendacity_N" ;
lin mendelevium_N = mkTerm "mendelevium_N" ;
lin mendelian_A = mkTerm "mendelian_A" ;
lin mender_N = mkTerm "mender_N" ;
lin mendicant_A = mkTerm "mendicant_A" ;
lin mendicant_N = mkTerm "mendicant_N" ;
lin mending_N = mkTerm "mending_N" ;
lin menhaden_N = mkTerm "menhaden_N" ;
lin menhir_N = mkTerm "menhir_N" ;
lin menial_A = mkTerm "menial_A" ;
lin menial_N = mkTerm "menial_N" ;
lin meningeal_A = mkTerm "meningeal_A" ;
lin meningioma_N = mkTerm "meningioma_N" ;
lin meningism_N = mkTerm "meningism_N" ;
lin meningitis_N = mkTerm "meningitis_N" ;
lin meningocele_N = mkTerm "meningocele_N" ;
lin meningoencephalitis_N = mkTerm "meningoencephalitis_N" ;
lin meninx_N = mkTerm "meninx_N" ;
lin meniscectomy_N = mkTerm "meniscectomy_N" ;
lin meniscus_N = mkTerm "meniscus_N" ;
lin menopausal_A = mkTerm "menopausal_A" ;
lin menopause_N = mkTerm "menopause_N" ;
lin menorah_N = mkTerm "menorah_N" ;
lin menorrhagia_N = mkTerm "menorrhagia_N" ;
lin menorrhea_N = mkTerm "menorrhea_N" ;
lin mensal_A = mkTerm "mensal_A" ;
lin mensch_N = mkTerm "mensch_N" ;
lin menstrual_A = mkTerm "menstrual_A" ;
lin menstruate_V = mkTerm "menstruate_V" ;
lin menstruation_N = mkTerm "menstruation_N" ;
lin menstruum_N = mkTerm "menstruum_N" ;
lin mensurable_A = mkTerm "mensurable_A" ;
lin mensural_A = mkTerm "mensural_A" ;
lin mensuration_N = mkTerm "mensuration_N" ;
lin mental_A = mkTerm "mental_A" ;
lin mentalism_N = mkTerm "mentalism_N" ;
lin mentality_N = mkTerm "mentality_N" ;
lin menthol_N = mkTerm "menthol_N" ;
lin mentholated_A = mkTerm "mentholated_A" ;
lin mention_N = mkTerm "mention_N" ;
lin mention_V = mkTerm "mention_V" ;
lin mention_V2 = mkTerm "mention_V2" ;
lin mention_VS = mkTerm "mention_VS" ;
lin mentioner_N = mkTerm "mentioner_N" ;
lin mentor_N = mkTerm "mentor_N" ;
lin mentum_N = mkTerm "mentum_N" ;
lin menu_N = mkTerm "menu_N" ;
lin meopham_PN = mkTerm "meopham_PN" ;
lin meow_N = mkTerm "meow_N" ;
lin meperidine_N = mkTerm "meperidine_N" ;
lin mephenytoin_N = mkTerm "mephenytoin_N" ;
lin mephistophelian_A = mkTerm "mephistophelian_A" ;
lin mephitis_N = mkTerm "mephitis_N" ;
lin mephobarbital_N = mkTerm "mephobarbital_N" ;
lin meprobamate_N = mkTerm "meprobamate_N" ;
lin meralgia_N = mkTerm "meralgia_N" ;
lin merbromine_N = mkTerm "merbromine_N" ;
lin mercantile_A = mkTerm "mercantile_A" ;
lin mercantilism_N = mkTerm "mercantilism_N" ;
lin mercaptopurine_N = mkTerm "mercaptopurine_N" ;
lin mercator_PN = mkTerm "mercator_PN" ;
lin mercenary_A = mkTerm "mercenary_A" ;
lin mercenary_N = mkTerm "mercenary_N" ;
lin mercer_N = mkTerm "mercer_N" ;
lin mercerize_V2 = mkTerm "mercerize_V2" ;
lin merchandise_N = mkTerm "merchandise_N" ;
lin merchant_N = mkTerm "merchant_N" ;
lin merchantability_N = mkTerm "merchantability_N" ;
lin merchantman_N = mkTerm "merchantman_N" ;
lin merciful_A = mkTerm "merciful_A" ;
lin mercifulness_N = mkTerm "mercifulness_N" ;
lin merciless_A = mkTerm "merciless_A" ;
lin mercilessness_N = mkTerm "mercilessness_N" ;
lin mercurial_A = mkTerm "mercurial_A" ;
lin mercuric_A = mkTerm "mercuric_A" ;
lin mercury_N = mkTerm "mercury_N" ;
lin mercury_PN = mkTerm "mercury_PN" ;
lin mercy_N = mkTerm "mercy_N" ;
lin mere_A = mkTerm "mere_A" ;
lin mere_N = mkTerm "mere_N" ;
lin merestone_N = mkTerm "merestone_N" ;
lin meretricious_A = mkTerm "meretricious_A" ;
lin meretriciousness_N = mkTerm "meretriciousness_N" ;
lin merganser_N = mkTerm "merganser_N" ;
lin merge_V = mkTerm "merge_V" ;
lin merge_V2 = mkTerm "merge_V2" ;
lin merger_N = mkTerm "merger_N" ;
lin merging_N = mkTerm "merging_N" ;
lin mericarp_N = mkTerm "mericarp_N" ;
lin meridian_A = mkTerm "meridian_A" ;
lin meridian_N = mkTerm "meridian_N" ;
lin meridional_A = mkTerm "meridional_A" ;
lin merijärvi_PN = mkTerm "merijärvi_PN" ;
lin merikarvia_PN = mkTerm "merikarvia_PN" ;
lin merimasku_PN = mkTerm "merimasku_PN" ;
lin meringue_N = mkTerm "meringue_N" ;
lin merino_N = mkTerm "merino_N" ;
lin merino_sheep_N = mkTerm "merino_sheep_N" ;
lin meristem_N = mkTerm "meristem_N" ;
lin merit_N = mkTerm "merit_N" ;
lin merit_V2 = mkTerm "merit_V2" ;
lin meritocracy_N = mkTerm "meritocracy_N" ;
lin meritocratic_A = mkTerm "meritocratic_A" ;
lin meritorious_A = mkTerm "meritorious_A" ;
lin merlon_N = mkTerm "merlon_N" ;
lin mermaid_N = mkTerm "mermaid_N" ;
lin merman_N = mkTerm "merman_N" ;
lin meromelia_N = mkTerm "meromelia_N" ;
lin meronym_N = mkTerm "meronym_N" ;
lin meronymy_N = mkTerm "meronymy_N" ;
lin merozoite_N = mkTerm "merozoite_N" ;
lin merriment_N = mkTerm "merriment_N" ;
lin merry_A = mkTerm "merry_A" ;
lin merry_christmas_Interj = mkTerm "merry_christmas_Interj" ;
lin merry_go_round_N = mkTerm "merry_go_round_N" ;
lin merrymaker_N = mkTerm "merrymaker_N" ;
lin merrymaking_N = mkTerm "merrymaking_N" ;
lin merthyr_tydfil_PN = mkTerm "merthyr_tydfil_PN" ;
lin merton_PN = mkTerm "merton_PN" ;
lin mesa_N = mkTerm "mesa_N" ;
lin mesalliance_N = mkTerm "mesalliance_N" ;
lin mescal_N = mkTerm "mescal_N" ;
lin mescaline_N = mkTerm "mescaline_N" ;
lin meseems_Adv = mkTerm "meseems_Adv" ;
lin mesenchyme_N = mkTerm "mesenchyme_N" ;
lin mesenteric_A = mkTerm "mesenteric_A" ;
lin mesentery_N = mkTerm "mesentery_N" ;
lin mesh_N = mkTerm "mesh_N" ;
lin mesh_V = mkTerm "mesh_V" ;
lin mesh_V2 = mkTerm "mesh_V2" ;
lin meshugaas_N = mkTerm "meshugaas_N" ;
lin meshugge_A = mkTerm "meshugge_A" ;
lin meshuggeneh_N = mkTerm "meshuggeneh_N" ;
lin mesial_A = mkTerm "mesial_A" ;
lin mesic_A = mkTerm "mesic_A" ;
lin mesmeric_A = mkTerm "mesmeric_A" ;
lin mesmerism_N = mkTerm "mesmerism_N" ;
lin mesmerist_N = mkTerm "mesmerist_N" ;
lin mesmerize_V2 = mkTerm "mesmerize_V2" ;
lin mesoblastic_A = mkTerm "mesoblastic_A" ;
lin mesocarp_N = mkTerm "mesocarp_N" ;
lin mesocolon_N = mkTerm "mesocolon_N" ;
lin mesoderm_N = mkTerm "mesoderm_N" ;
lin mesohippus_N = mkTerm "mesohippus_N" ;
lin mesolithic_A = mkTerm "mesolithic_A" ;
lin mesomorph_N = mkTerm "mesomorph_N" ;
lin mesomorphic_A = mkTerm "mesomorphic_A" ;
lin meson_N = mkTerm "meson_N" ;
lin mesonic_A = mkTerm "mesonic_A" ;
lin mesophyte_N = mkTerm "mesophyte_N" ;
lin mesophytic_A = mkTerm "mesophytic_A" ;
lin mesosphere_N = mkTerm "mesosphere_N" ;
lin mesothelioma_N = mkTerm "mesothelioma_N" ;
lin mesothelium_N = mkTerm "mesothelium_N" ;
lin mesquite_N = mkTerm "mesquite_N" ;
lin mess_N = mkTerm "mess_N" ;
lin mess_V = mkTerm "mess_V" ;
lin mess_V2 = mkTerm "mess_V2" ;
lin mess_about_V = mkTerm "mess_about_V" ;
lin mess_about_V2 = mkTerm "mess_about_V2" ;
lin mess_about_with_V2 = mkTerm "mess_about_with_V2" ;
lin mess_around_V = mkTerm "mess_around_V" ;
lin mess_around_V2 = mkTerm "mess_around_V2" ;
lin mess_around_with_V2 = mkTerm "mess_around_with_V2" ;
lin mess_jacket_N = mkTerm "mess_jacket_N" ;
lin mess_over_V2 = mkTerm "mess_over_V2" ;
lin mess_up_N = mkTerm "mess_up_N" ;
lin mess_up_V2 = mkTerm "mess_up_V2" ;
lin mess_with_V2 = mkTerm "mess_with_V2" ;
lin message_N = mkTerm "message_N" ;
lin messaging_N = mkTerm "messaging_N" ;
lin messenger_N = mkTerm "messenger_N" ;
lin messiah_N = mkTerm "messiah_N" ;
lin messiahship_N = mkTerm "messiahship_N" ;
lin messianic_A = mkTerm "messianic_A" ;
lin messina_PN = mkTerm "messina_PN" ;
lin messiness_N = mkTerm "messiness_N" ;
lin messmate_N = mkTerm "messmate_N" ;
lin messuage_N = mkTerm "messuage_N" ;
lin messy_A = mkTerm "messy_A" ;
lin mestiza_N = mkTerm "mestiza_N" ;
lin mestizo_N = mkTerm "mestizo_N" ;
lin mestranol_N = mkTerm "mestranol_N" ;
lin met_PN = mkTerm "met_PN" ;
lin met_out_V = mkTerm "met_out_V" ;
lin metabolic_A = mkTerm "metabolic_A" ;
lin metabolism_N = mkTerm "metabolism_N" ;
lin metabolite_N = mkTerm "metabolite_N" ;
lin metabolize_V2 = mkTerm "metabolize_V2" ;
lin metacarpal_A = mkTerm "metacarpal_A" ;
lin metacarpal_N = mkTerm "metacarpal_N" ;
lin metacarpus_N = mkTerm "metacarpus_N" ;
lin metacenter_N = mkTerm "metacenter_N" ;
lin metacentric_A = mkTerm "metacentric_A" ;
lin metadata_N = mkTerm "metadata_N" ;
lin metagenesis_N = mkTerm "metagenesis_N" ;
lin metagrobolized_A = mkTerm "metagrobolized_A" ;
lin metaknowledge_N = mkTerm "metaknowledge_N" ;
lin metal_N = mkTerm "metal_N" ;
lin metal_V2 = mkTerm "metal_V2" ;
lin metalanguage_N = mkTerm "metalanguage_N" ;
lin metalepsis_N = mkTerm "metalepsis_N" ;
lin metalhead_N = mkTerm "metalhead_N" ;
lin metallic_A = mkTerm "metallic_A" ;
lin metallic_N = mkTerm "metallic_N" ;
lin metallike_A = mkTerm "metallike_A" ;
lin metalloid_A = mkTerm "metalloid_A" ;
lin metallurgical_A = mkTerm "metallurgical_A" ;
lin metallurgist_N = mkTerm "metallurgist_N" ;
lin metallurgy_N = mkTerm "metallurgy_N" ;
lin metalware_N = mkTerm "metalware_N" ;
lin metalwork_N = mkTerm "metalwork_N" ;
lin metalworker_N = mkTerm "metalworker_N" ;
lin metalworking_N = mkTerm "metalworking_N" ;
lin metamathematics_N = mkTerm "metamathematics_N" ;
lin metamere_N = mkTerm "metamere_N" ;
lin metameric_A = mkTerm "metameric_A" ;
lin metamorphic_A = mkTerm "metamorphic_A" ;
lin metamorphism_N = mkTerm "metamorphism_N" ;
lin metamorphopsia_N = mkTerm "metamorphopsia_N" ;
lin metamorphose_V = mkTerm "metamorphose_V" ;
lin metamorphose_V2 = mkTerm "metamorphose_V2" ;
lin metamorphosis_N = mkTerm "metamorphosis_N" ;
lin metamorphous_A = mkTerm "metamorphous_A" ;
lin metaphase_N = mkTerm "metaphase_N" ;
lin metaphor_N = mkTerm "metaphor_N" ;
lin metaphorical_A = mkTerm "metaphorical_A" ;
lin metaphysical_A = mkTerm "metaphysical_A" ;
lin metaphysics_N = mkTerm "metaphysics_N" ;
lin metaphysis_N = mkTerm "metaphysis_N" ;
lin metaproterenol_N = mkTerm "metaproterenol_N" ;
lin metarule_N = mkTerm "metarule_N" ;
lin metasequoia_N = mkTerm "metasequoia_N" ;
lin metastability_N = mkTerm "metastability_N" ;
lin metastable_A = mkTerm "metastable_A" ;
lin metastasis_N = mkTerm "metastasis_N" ;
lin metastatic_A = mkTerm "metastatic_A" ;
lin metatarsal_A = mkTerm "metatarsal_A" ;
lin metatarsal_N = mkTerm "metatarsal_N" ;
lin metatarsus_N = mkTerm "metatarsus_N" ;
lin metatherian_N = mkTerm "metatherian_N" ;
lin metathesis_N = mkTerm "metathesis_N" ;
lin metazoan_N = mkTerm "metazoan_N" ;
lin mete_V2 = mkTerm "mete_V2" ;
lin mete_out_V2 = mkTerm "mete_out_V2" ;
lin metempsychosis_N = mkTerm "metempsychosis_N" ;
lin metencephalon_N = mkTerm "metencephalon_N" ;
lin meteor_N = mkTerm "meteor_N" ;
lin meteoric_A = mkTerm "meteoric_A" ;
lin meteorite_N = mkTerm "meteorite_N" ;
lin meteoritic_A = mkTerm "meteoritic_A" ;
lin meteoroid_N = mkTerm "meteoroid_N" ;
lin meteorologic_A = mkTerm "meteorologic_A" ;
lin meteorological_A = mkTerm "meteorological_A" ;
lin meteorologist_N = mkTerm "meteorologist_N" ;
lin meteorology_N = mkTerm "meteorology_N" ;
lin meteortropism_N = mkTerm "meteortropism_N" ;
lin meter_N = mkTerm "meter_N" ;
lin meterstick_N = mkTerm "meterstick_N" ;
lin metformin_N = mkTerm "metformin_N" ;
lin methacholine_N = mkTerm "methacholine_N" ;
lin methadone_N = mkTerm "methadone_N" ;
lin methamphetamine_N = mkTerm "methamphetamine_N" ;
lin methane_N = mkTerm "methane_N" ;
lin methanogen_N = mkTerm "methanogen_N" ;
lin methanol_N = mkTerm "methanol_N" ;
lin methapyrilene_N = mkTerm "methapyrilene_N" ;
lin methaqualone_N = mkTerm "methaqualone_N" ;
lin metharbital_N = mkTerm "metharbital_N" ;
lin metheglin_N = mkTerm "metheglin_N" ;
lin methenamine_N = mkTerm "methenamine_N" ;
lin methicillin_N = mkTerm "methicillin_N" ;
lin methinks_Adv = mkTerm "methinks_Adv" ;
lin methionine_N = mkTerm "methionine_N" ;
lin methocarbamol_N = mkTerm "methocarbamol_N" ;
lin method_N = mkTerm "method_N" ;
lin methodical_A = mkTerm "methodical_A" ;
lin methodism_N = mkTerm "methodism_N" ;
lin methodist_A = mkTerm "methodist_A" ;
lin methodist_N = mkTerm "methodist_N" ;
lin methodological_A = mkTerm "methodological_A" ;
lin methodology_N = mkTerm "methodology_N" ;
lin methotrexate_N = mkTerm "methotrexate_N" ;
lin methought_Adv = mkTerm "methought_Adv" ;
lin methuselah_PN = mkTerm "methuselah_PN" ;
lin methyl_N = mkTerm "methyl_N" ;
lin methylated_A = mkTerm "methylated_A" ;
lin methyldopa_N = mkTerm "methyldopa_N" ;
lin methylenedioxymethamphetamine_N = mkTerm "methylenedioxymethamphetamine_N" ;
lin methylphenidate_N = mkTerm "methylphenidate_N" ;
lin methyltestosterone_N = mkTerm "methyltestosterone_N" ;
lin metic_N = mkTerm "metic_N" ;
lin metical_N = mkTerm "metical_N" ;
lin meticulous_A = mkTerm "meticulous_A" ;
lin meticulousness_N = mkTerm "meticulousness_N" ;
lin metier_N = mkTerm "metier_N" ;
lin metonym_N = mkTerm "metonym_N" ;
lin metonymic_A = mkTerm "metonymic_A" ;
lin metonymy_N = mkTerm "metonymy_N" ;
lin metopion_N = mkTerm "metopion_N" ;
lin metoprolol_N = mkTerm "metoprolol_N" ;
lin metralgia_N = mkTerm "metralgia_N" ;
lin metre_N = mkTerm "metre_N" ;
lin metric_A = mkTerm "metric_A" ;
lin metrical_A = mkTerm "metrical_A" ;
lin metrication_N = mkTerm "metrication_N" ;
lin metricize_V2 = mkTerm "metricize_V2" ;
lin metrification_N = mkTerm "metrification_N" ;
lin metritis_N = mkTerm "metritis_N" ;
lin metro_N = mkTerm "metro_N" ;
lin metrological_A = mkTerm "metrological_A" ;
lin metrology_N = mkTerm "metrology_N" ;
lin metronidazole_N = mkTerm "metronidazole_N" ;
lin metronome_N = mkTerm "metronome_N" ;
lin metropolis_N = mkTerm "metropolis_N" ;
lin metropolitan_A = mkTerm "metropolitan_A" ;
lin metropolitan_N = mkTerm "metropolitan_N" ;
lin metroptosis_N = mkTerm "metroptosis_N" ;
lin metrorrhagia_N = mkTerm "metrorrhagia_N" ;
lin mettle_N = mkTerm "mettle_N" ;
lin mettlesome_A = mkTerm "mettlesome_A" ;
lin mettlesomeness_N = mkTerm "mettlesomeness_N" ;
lin metz_PN = mkTerm "metz_PN" ;
lin mew_N = mkTerm "mew_N" ;
lin mew_V = mkTerm "mew_V" ;
lin mews_N = mkTerm "mews_N" ;
lin mexican_A = mkTerm "mexican_A" ;
lin mexican_N = mkTerm "mexican_N" ;
lin mexico_PN = mkTerm "mexico_PN" ;
lin mexico_city_PN = mkTerm "mexico_city_PN" ;
lin mexiletine_N = mkTerm "mexiletine_N" ;
lin mezereon_N = mkTerm "mezereon_N" ;
lin mezereum_N = mkTerm "mezereum_N" ;
lin mezuzah_N = mkTerm "mezuzah_N" ;
lin mezzanine_A = mkTerm "mezzanine_A" ;
lin mezzanine_N = mkTerm "mezzanine_N" ;
lin mezzo_Adv = mkTerm "mezzo_Adv" ;
lin mezzo_soprano_N = mkTerm "mezzo_soprano_N" ;
lin mezzotint_N = mkTerm "mezzotint_N" ;
lin mg_N = mkTerm "mg_N" ;
lin mgr_PN = mkTerm "mgr_PN" ;
lin mho_N = mkTerm "mho_N" ;
lin mi5_PN = mkTerm "mi5_PN" ;
lin mi6_PN = mkTerm "mi6_PN" ;
lin mi_N = mkTerm "mi_N" ;
lin miami_PN = mkTerm "miami_PN" ;
lin miasma_N = mkTerm "miasma_N" ;
lin miasmal_A = mkTerm "miasmal_A" ;
lin miasmic_A = mkTerm "miasmic_A" ;
lin mica_N = mkTerm "mica_N" ;
lin micaceous_A = mkTerm "micaceous_A" ;
lin micelle_N = mkTerm "micelle_N" ;
lin michael_PN = mkTerm "michael_PN" ;
lin michaelmas_N = mkTerm "michaelmas_N" ;
lin michaelmas_PN = mkTerm "michaelmas_PN" ;
lin michelle_PN = mkTerm "michelle_PN" ;
lin michigan_PN = mkTerm "michigan_PN" ;
lin mick_PN = mkTerm "mick_PN" ;
lin mickey_N = mkTerm "mickey_N" ;
lin mickey_PN = mkTerm "mickey_PN" ;
lin mickle_N = mkTerm "mickle_N" ;
lin miconazole_N = mkTerm "miconazole_N" ;
lin micro_A = mkTerm "micro_A" ;
lin micro_N = mkTerm "micro_N" ;
lin microbalance_N = mkTerm "microbalance_N" ;
lin microbe_N = mkTerm "microbe_N" ;
lin microbial_A = mkTerm "microbial_A" ;
lin microbiologist_N = mkTerm "microbiologist_N" ;
lin microbiology_N = mkTerm "microbiology_N" ;
lin microbrachia_N = mkTerm "microbrachia_N" ;
lin microbrewery_N = mkTerm "microbrewery_N" ;
lin microcephalic_A = mkTerm "microcephalic_A" ;
lin microcephaly_N = mkTerm "microcephaly_N" ;
lin microcosm_N = mkTerm "microcosm_N" ;
lin microcosmic_A = mkTerm "microcosmic_A" ;
lin microcrystalline_A = mkTerm "microcrystalline_A" ;
lin microcyte_N = mkTerm "microcyte_N" ;
lin microcytosis_N = mkTerm "microcytosis_N" ;
lin microdot_N = mkTerm "microdot_N" ;
lin microeconomic_A = mkTerm "microeconomic_A" ;
lin microeconomics_N = mkTerm "microeconomics_N" ;
lin microeconomist_N = mkTerm "microeconomist_N" ;
lin microelectronic_A = mkTerm "microelectronic_A" ;
lin microelectronics_N = mkTerm "microelectronics_N" ;
lin microevolution_N = mkTerm "microevolution_N" ;
lin microfarad_N = mkTerm "microfarad_N" ;
lin microfiche_N = mkTerm "microfiche_N" ;
lin microfilm_N = mkTerm "microfilm_N" ;
lin microfilm_V2 = mkTerm "microfilm_V2" ;
lin microflora_N = mkTerm "microflora_N" ;
lin microfossil_N = mkTerm "microfossil_N" ;
lin microgametophyte_N = mkTerm "microgametophyte_N" ;
lin microgauss_N = mkTerm "microgauss_N" ;
lin microglia_N = mkTerm "microglia_N" ;
lin microgliacyte_N = mkTerm "microgliacyte_N" ;
lin microgram_N = mkTerm "microgram_N" ;
lin micrometeoric_A = mkTerm "micrometeoric_A" ;
lin micrometeorite_N = mkTerm "micrometeorite_N" ;
lin micrometeoritic_A = mkTerm "micrometeoritic_A" ;
lin micrometer_N = mkTerm "micrometer_N" ;
lin micrometry_N = mkTerm "micrometry_N" ;
lin micron_N = mkTerm "micron_N" ;
lin micronutrient_N = mkTerm "micronutrient_N" ;
lin microorganism_N = mkTerm "microorganism_N" ;
lin micropaleontology_N = mkTerm "micropaleontology_N" ;
lin micropenis_N = mkTerm "micropenis_N" ;
lin microphage_N = mkTerm "microphage_N" ;
lin microphone_N = mkTerm "microphone_N" ;
lin microphoning_N = mkTerm "microphoning_N" ;
lin microphotometer_N = mkTerm "microphotometer_N" ;
lin microprocessor_N = mkTerm "microprocessor_N" ;
lin micropylar_A = mkTerm "micropylar_A" ;
lin micropyle_N = mkTerm "micropyle_N" ;
lin microradian_N = mkTerm "microradian_N" ;
lin microscope_N = mkTerm "microscope_N" ;
lin microscopic_A = mkTerm "microscopic_A" ;
lin microscopical_A = mkTerm "microscopical_A" ;
lin microscopist_N = mkTerm "microscopist_N" ;
lin microscopy_N = mkTerm "microscopy_N" ;
lin microsecond_N = mkTerm "microsecond_N" ;
lin microsomal_A = mkTerm "microsomal_A" ;
lin microsome_N = mkTerm "microsome_N" ;
lin microsporangium_N = mkTerm "microsporangium_N" ;
lin microspore_N = mkTerm "microspore_N" ;
lin microsporidian_N = mkTerm "microsporidian_N" ;
lin microsporophyll_N = mkTerm "microsporophyll_N" ;
lin microsurgery_N = mkTerm "microsurgery_N" ;
lin microtome_N = mkTerm "microtome_N" ;
lin microtubule_N = mkTerm "microtubule_N" ;
lin microvolt_N = mkTerm "microvolt_N" ;
lin microwave_N = mkTerm "microwave_N" ;
lin micturition_N = mkTerm "micturition_N" ;
lin mid_A = mkTerm "mid_A" ;
lin mid_Prep = mkTerm "mid_Prep" ;
lin mid_off_N = mkTerm "mid_off_N" ;
lin mid_on_N = mkTerm "mid_on_N" ;
lin midafternoon_N = mkTerm "midafternoon_N" ;
lin midair_N = mkTerm "midair_N" ;
lin midazolam_N = mkTerm "midazolam_N" ;
lin midbrain_N = mkTerm "midbrain_N" ;
lin midday_N = mkTerm "midday_N" ;
lin midden_N = mkTerm "midden_N" ;
lin middle_A = mkTerm "middle_A" ;
lin middle_N = mkTerm "middle_N" ;
lin middle_aged_A = mkTerm "middle_aged_A" ;
lin middle_class_A = mkTerm "middle_class_A" ;
lin middle_distance_A = mkTerm "middle_distance_A" ;
lin middle_of_the_road_A = mkTerm "middle_of_the_road_A" ;
lin middlebrow_N = mkTerm "middlebrow_N" ;
lin middlemanFem_N = mkTerm "middlemanFem_N" ;
lin middlemanMasc_N = mkTerm "middlemanMasc_N" ;
lin middlemost_A = mkTerm "middlemost_A" ;
lin middlesex_PN = mkTerm "middlesex_PN" ;
lin middleton_PN = mkTerm "middleton_PN" ;
lin middleweight_A = mkTerm "middleweight_A" ;
lin middleweight_N = mkTerm "middleweight_N" ;
lin middlewich_PN = mkTerm "middlewich_PN" ;
lin middling_A = mkTerm "middling_A" ;
lin middling_Adv = mkTerm "middling_Adv" ;
lin middling_N = mkTerm "middling_N" ;
lin middy_N = mkTerm "middy_N" ;
lin midfield_N = mkTerm "midfield_N" ;
lin midfielder_N = mkTerm "midfielder_N" ;
lin midge_N = mkTerm "midge_N" ;
lin midget_N = mkTerm "midget_N" ;
lin midgrass_N = mkTerm "midgrass_N" ;
lin midi_A = mkTerm "midi_A" ;
lin midinette_N = mkTerm "midinette_N" ;
lin midiron_N = mkTerm "midiron_N" ;
lin midland_N = mkTerm "midland_N" ;
lin midlands_PN = mkTerm "midlands_PN" ;
lin midmost_A = mkTerm "midmost_A" ;
lin midmost_Adv = mkTerm "midmost_Adv" ;
lin midnight_N = mkTerm "midnight_N" ;
lin midplane_N = mkTerm "midplane_N" ;
lin midrib_N = mkTerm "midrib_N" ;
lin midriff_N = mkTerm "midriff_N" ;
lin midshipman_N = mkTerm "midshipman_N" ;
lin midships_Adv = mkTerm "midships_Adv" ;
lin midst_N = mkTerm "midst_N" ;
lin midst_Prep = mkTerm "midst_Prep" ;
lin midstream_N = mkTerm "midstream_N" ;
lin midsummer_N = mkTerm "midsummer_N" ;
lin midterm_N = mkTerm "midterm_N" ;
lin midway_A = mkTerm "midway_A" ;
lin midway_Adv = mkTerm "midway_Adv" ;
lin midway_N = mkTerm "midway_N" ;
lin midweek_A = mkTerm "midweek_A" ;
lin midweek_Adv = mkTerm "midweek_Adv" ;
lin midweek_N = mkTerm "midweek_N" ;
lin midweekly_A = mkTerm "midweekly_A" ;
lin midwest_PN = mkTerm "midwest_PN" ;
lin midwestern_A = mkTerm "midwestern_A" ;
lin midwife_N = mkTerm "midwife_N" ;
lin midwifery_N = mkTerm "midwifery_N" ;
lin midwinter_N = mkTerm "midwinter_N" ;
lin miehikkälä_PN = mkTerm "miehikkälä_PN" ;
lin mien_N = mkTerm "mien_N" ;
lin mietoinen_PN = mkTerm "mietoinen_PN" ;
lin miff_V2 = mkTerm "miff_V2" ;
lin might_N = mkTerm "might_N" ;
lin might_have_been_N = mkTerm "might_have_been_N" ;
lin mighty_A = mkTerm "mighty_A" ;
lin mighty_Adv = mkTerm "mighty_Adv" ;
lin mignonette_N = mkTerm "mignonette_N" ;
lin migraine_N = mkTerm "migraine_N" ;
lin migrant_A = mkTerm "migrant_A" ;
lin migrant_N = mkTerm "migrant_N" ;
lin migrate_V = mkTerm "migrate_V" ;
lin migration_N = mkTerm "migration_N" ;
lin migrational_A = mkTerm "migrational_A" ;
lin migrator_N = mkTerm "migrator_N" ;
lin migratory_A = mkTerm "migratory_A" ;
lin mihrab_N = mkTerm "mihrab_N" ;
lin mikado_N = mkTerm "mikado_N" ;
lin mike_N = mkTerm "mike_N" ;
lin mike_PN = mkTerm "mike_PN" ;
lin mikkeli_PN = mkTerm "mikkeli_PN" ;
lin mikvah_N = mkTerm "mikvah_N" ;
lin mil_N = mkTerm "mil_N" ;
lin milady_N = mkTerm "milady_N" ;
lin milage_N = mkTerm "milage_N" ;
lin milan_PN = mkTerm "milan_PN" ;
lin milano_PN = mkTerm "milano_PN" ;
lin milch_A = mkTerm "milch_A" ;
lin mild_A = mkTerm "mild_A" ;
lin mildenhall_PN = mkTerm "mildenhall_PN" ;
lin mildew_N = mkTerm "mildew_N" ;
lin mildew_V = mkTerm "mildew_V" ;
lin mildew_V2 = mkTerm "mildew_V2" ;
lin mildness_N = mkTerm "mildness_N" ;
lin mildred_PN = mkTerm "mildred_PN" ;
lin mile_N = mkTerm "mile_N" ;
lin mileage_N = mkTerm "mileage_N" ;
lin mileometer_N = mkTerm "mileometer_N" ;
lin miler_N = mkTerm "miler_N" ;
lin miles_PN = mkTerm "miles_PN" ;
lin milestone_N = mkTerm "milestone_N" ;
lin milford_PN = mkTerm "milford_PN" ;
lin milford_haven_PN = mkTerm "milford_haven_PN" ;
lin milieu_N = mkTerm "milieu_N" ;
lin militainment_N = mkTerm "militainment_N" ;
lin militancy_N = mkTerm "militancy_N" ;
lin militant_A = mkTerm "militant_A" ;
lin militant_N = mkTerm "militant_N" ;
lin militarism_N = mkTerm "militarism_N" ;
lin militarist_N = mkTerm "militarist_N" ;
lin militaristic_A = mkTerm "militaristic_A" ;
lin militarized_A = mkTerm "militarized_A" ;
lin military_A = mkTerm "military_A" ;
lin military_N = mkTerm "military_N" ;
lin militate_V = mkTerm "militate_V" ;
lin militia_N = mkTerm "militia_N" ;
lin militiaman_N = mkTerm "militiaman_N" ;
lin milk_N = mkTerm "milk_N" ;
lin milk_V = mkTerm "milk_V" ;
lin milk_V2 = mkTerm "milk_V2" ;
lin milk_churn_N = mkTerm "milk_churn_N" ;
lin milk_powder_N = mkTerm "milk_powder_N" ;
lin milk_shake_N = mkTerm "milk_shake_N" ;
lin milk_tooth_N = mkTerm "milk_tooth_N" ;
lin milk_white_A = mkTerm "milk_white_A" ;
lin milkbar_N = mkTerm "milkbar_N" ;
lin milkcap_N = mkTerm "milkcap_N" ;
lin milking_machine_N = mkTerm "milking_machine_N" ;
lin milkless_A = mkTerm "milkless_A" ;
lin milkmaid_N = mkTerm "milkmaid_N" ;
lin milkman_N = mkTerm "milkman_N" ;
lin milksop_N = mkTerm "milksop_N" ;
lin milkweed_N = mkTerm "milkweed_N" ;
lin milkwort_N = mkTerm "milkwort_N" ;
lin milky_A = mkTerm "milky_A" ;
lin mill_N = mkTerm "mill_N" ;
lin mill_V = mkTerm "mill_V" ;
lin mill_V2 = mkTerm "mill_V2" ;
lin mill_around_V = mkTerm "mill_around_V" ;
lin mill_dam_N = mkTerm "mill_dam_N" ;
lin mill_girl_N = mkTerm "mill_girl_N" ;
lin mill_hand_N = mkTerm "mill_hand_N" ;
lin millboard_N = mkTerm "millboard_N" ;
lin millenarian_A = mkTerm "millenarian_A" ;
lin millenarian_N = mkTerm "millenarian_N" ;
lin millenarianism_N = mkTerm "millenarianism_N" ;
lin millenary_A = mkTerm "millenary_A" ;
lin millenary_N = mkTerm "millenary_N" ;
lin millennial_A = mkTerm "millennial_A" ;
lin millennium_N = mkTerm "millennium_N" ;
lin miller_N = mkTerm "miller_N" ;
lin millerite_N = mkTerm "millerite_N" ;
lin millet_N = mkTerm "millet_N" ;
lin millettia_N = mkTerm "millettia_N" ;
lin milliammeter_N = mkTerm "milliammeter_N" ;
lin milliampere_N = mkTerm "milliampere_N" ;
lin milliard_N = mkTerm "milliard_N" ;
lin millibar_N = mkTerm "millibar_N" ;
lin millicent_PN = mkTerm "millicent_PN" ;
lin millicurie_N = mkTerm "millicurie_N" ;
lin millidegree_N = mkTerm "millidegree_N" ;
lin millie_PN = mkTerm "millie_PN" ;
lin milliequivalent_N = mkTerm "milliequivalent_N" ;
lin millifarad_N = mkTerm "millifarad_N" ;
lin milligram_N = mkTerm "milligram_N" ;
lin millihenry_N = mkTerm "millihenry_N" ;
lin milliliter_N = mkTerm "milliliter_N" ;
lin millime_N = mkTerm "millime_N" ;
lin millimetre_N = mkTerm "millimetre_N" ;
lin milline_N = mkTerm "milline_N" ;
lin milliner_N = mkTerm "milliner_N" ;
lin millinery_N = mkTerm "millinery_N" ;
lin milling_N = mkTerm "milling_N" ;
lin million_A = mkTerm "million_A" ;
lin million_N = mkTerm "million_N" ;
lin millionaire_N = mkTerm "millionaire_N" ;
lin millionairess_N = mkTerm "millionairess_N" ;
lin millionfold_Adv = mkTerm "millionfold_Adv" ;
lin millions_N = mkTerm "millions_N" ;
lin millionth_A = mkTerm "millionth_A" ;
lin millionth_N = mkTerm "millionth_N" ;
lin millipede_N = mkTerm "millipede_N" ;
lin milliradian_N = mkTerm "milliradian_N" ;
lin millisecond_N = mkTerm "millisecond_N" ;
lin millivolt_N = mkTerm "millivolt_N" ;
lin millivoltmeter_N = mkTerm "millivoltmeter_N" ;
lin milliwatt_N = mkTerm "milliwatt_N" ;
lin millom_PN = mkTerm "millom_PN" ;
lin millpond_N = mkTerm "millpond_N" ;
lin millrace_N = mkTerm "millrace_N" ;
lin millstone_N = mkTerm "millstone_N" ;
lin millwheel_N = mkTerm "millwheel_N" ;
lin millwork_N = mkTerm "millwork_N" ;
lin millwright_N = mkTerm "millwright_N" ;
lin milly_PN = mkTerm "milly_PN" ;
lin milngavie_PN = mkTerm "milngavie_PN" ;
lin milnrow_PN = mkTerm "milnrow_PN" ;
lin milo_N = mkTerm "milo_N" ;
lin milometer_N = mkTerm "milometer_N" ;
lin milord_N = mkTerm "milord_N" ;
lin milt_N = mkTerm "milt_N" ;
lin milton_keynes_PN = mkTerm "milton_keynes_PN" ;
lin milwaukee_PN = mkTerm "milwaukee_PN" ;
lin mime_N = mkTerm "mime_N" ;
lin mime_V = mkTerm "mime_V" ;
lin mime_V2 = mkTerm "mime_V2" ;
lin mimeograph_N = mkTerm "mimeograph_N" ;
lin mimeograph_V2 = mkTerm "mimeograph_V2" ;
lin mimesis_N = mkTerm "mimesis_N" ;
lin mimetic_A = mkTerm "mimetic_A" ;
lin mimic_A = mkTerm "mimic_A" ;
lin mimic_N = mkTerm "mimic_N" ;
lin mimic_V2 = mkTerm "mimic_V2" ;
lin mimicry_N = mkTerm "mimicry_N" ;
lin mimosa_N = mkTerm "mimosa_N" ;
lin min_N = mkTerm "min_N" ;
lin minaret_N = mkTerm "minaret_N" ;
lin minatory_A = mkTerm "minatory_A" ;
lin mince_N = mkTerm "mince_N" ;
lin mince_V = mkTerm "mince_V" ;
lin mince_V2 = mkTerm "mince_V2" ;
lin mince_pie_N = mkTerm "mince_pie_N" ;
lin mincemeat_N = mkTerm "mincemeat_N" ;
lin mincer_N = mkTerm "mincer_N" ;
lin mincingly_Adv = mkTerm "mincingly_Adv" ;
lin mind_N = mkTerm "mind_N" ;
lin mind_V = mkTerm "mind_V" ;
lin mind_V2 = mkTerm "mind_V2" ;
lin mind_VS = mkTerm "mind_VS" ;
lin mind_bending_A = mkTerm "mind_bending_A" ;
lin mind_blowing_A = mkTerm "mind_blowing_A" ;
lin mind_boggling_A = mkTerm "mind_boggling_A" ;
lin mind_reader_N = mkTerm "mind_reader_N" ;
lin minder_N = mkTerm "minder_N" ;
lin mindful_A = mkTerm "mindful_A" ;
lin mindfulness_N = mkTerm "mindfulness_N" ;
lin mindless_A = mkTerm "mindless_A" ;
lin mindlessness_N = mkTerm "mindlessness_N" ;
lin mine_A = mkTerm "mine_A" ;
lin mine_N = mkTerm "mine_N" ;
lin mine_V = mkTerm "mine_V" ;
lin mine_V2 = mkTerm "mine_V2" ;
lin mine_detector_N = mkTerm "mine_detector_N" ;
lin mine_disposal_N = mkTerm "mine_disposal_N" ;
lin minefield_N = mkTerm "minefield_N" ;
lin minehead_PN = mkTerm "minehead_PN" ;
lin minelayer_N = mkTerm "minelayer_N" ;
lin minelaying_N = mkTerm "minelaying_N" ;
lin miner_N = mkTerm "miner_N" ;
lin mineral_A = mkTerm "mineral_A" ;
lin mineral_N = mkTerm "mineral_N" ;
lin mineralocorticoid_N = mkTerm "mineralocorticoid_N" ;
lin mineralogist_N = mkTerm "mineralogist_N" ;
lin mineralogy_N = mkTerm "mineralogy_N" ;
lin mineshaft_N = mkTerm "mineshaft_N" ;
lin minestrone_N = mkTerm "minestrone_N" ;
lin minesweeper_N = mkTerm "minesweeper_N" ;
lin minesweeping_N = mkTerm "minesweeping_N" ;
lin mineworker_N = mkTerm "mineworker_N" ;
lin minge_N = mkTerm "minge_N" ;
lin mingle_V = mkTerm "mingle_V" ;
lin mingle_V2 = mkTerm "mingle_V2" ;
lin mingling_N = mkTerm "mingling_N" ;
lin mingy_A = mkTerm "mingy_A" ;
lin mini_A = mkTerm "mini_A" ;
lin miniature_A = mkTerm "miniature_A" ;
lin miniature_N = mkTerm "miniature_N" ;
lin miniaturist_N = mkTerm "miniaturist_N" ;
lin miniaturization_N = mkTerm "miniaturization_N" ;
lin miniaturize_V2 = mkTerm "miniaturize_V2" ;
lin minibar_N = mkTerm "minibar_N" ;
lin minibike_N = mkTerm "minibike_N" ;
lin minibus_N = mkTerm "minibus_N" ;
lin minicab_N = mkTerm "minicab_N" ;
lin minicar_N = mkTerm "minicar_N" ;
lin minicomputer_N = mkTerm "minicomputer_N" ;
lin minim_N = mkTerm "minim_N" ;
lin minimal_A = mkTerm "minimal_A" ;
lin minimalism_N = mkTerm "minimalism_N" ;
lin minimalist_A = mkTerm "minimalist_A" ;
lin minimalist_N = mkTerm "minimalist_N" ;
lin minimization_N = mkTerm "minimization_N" ;
lin minimize_V2 = mkTerm "minimize_V2" ;
lin minimum_A = mkTerm "minimum_A" ;
lin minimum_N = mkTerm "minimum_N" ;
lin minimus_N = mkTerm "minimus_N" ;
lin mining_N = mkTerm "mining_N" ;
lin minion_N = mkTerm "minion_N" ;
lin miniseries_N = mkTerm "miniseries_N" ;
lin miniskirt_N = mkTerm "miniskirt_N" ;
lin minister_1_N = mkTerm "minister_1_N" ;
lin minister_2_N = mkTerm "minister_2_N" ;
lin minister_V = mkTerm "minister_V" ;
lin ministerial_A = mkTerm "ministerial_A" ;
lin ministrant_A = mkTerm "ministrant_A" ;
lin ministrant_N = mkTerm "ministrant_N" ;
lin ministration_N = mkTerm "ministration_N" ;
lin ministry_N = mkTerm "ministry_N" ;
lin minisub_N = mkTerm "minisub_N" ;
lin minivan_N = mkTerm "minivan_N" ;
lin miniver_N = mkTerm "miniver_N" ;
lin mink_N = mkTerm "mink_N" ;
lin minneapolis_PN = mkTerm "minneapolis_PN" ;
lin minnesota_PN = mkTerm "minnesota_PN" ;
lin minniebush_N = mkTerm "minniebush_N" ;
lin minnow_N = mkTerm "minnow_N" ;
lin minocycline_N = mkTerm "minocycline_N" ;
lin minor_A = mkTerm "minor_A" ;
lin minor_N = mkTerm "minor_N" ;
lin minority_N = mkTerm "minority_N" ;
lin minotaur_N = mkTerm "minotaur_N" ;
lin minoxidil_N = mkTerm "minoxidil_N" ;
lin minsk_PN = mkTerm "minsk_PN" ;
lin minster_N = mkTerm "minster_N" ;
lin minster_in_sheppey_PN = mkTerm "minster_in_sheppey_PN" ;
lin minstrel_N = mkTerm "minstrel_N" ;
lin minstrelsy_N = mkTerm "minstrelsy_N" ;
lin mint_N = mkTerm "mint_N" ;
lin mint_V2 = mkTerm "mint_V2" ;
lin mintage_N = mkTerm "mintage_N" ;
lin mintmark_N = mkTerm "mintmark_N" ;
lin minty_A = mkTerm "minty_A" ;
lin minuend_N = mkTerm "minuend_N" ;
lin minuet_N = mkTerm "minuet_N" ;
lin minus_A = mkTerm "minus_A" ;
lin minus_N = mkTerm "minus_N" ;
lin minus_Prep = mkTerm "minus_Prep" ;
lin minuscule_A = mkTerm "minuscule_A" ;
lin minuscule_N = mkTerm "minuscule_N" ;
lin minute_A = mkTerm "minute_A" ;
lin minute_N = mkTerm "minute_N" ;
lin minute_V2 = mkTerm "minute_V2" ;
lin minute_book_N = mkTerm "minute_book_N" ;
lin minute_gun_N = mkTerm "minute_gun_N" ;
lin minute_hand_N = mkTerm "minute_hand_N" ;
lin minuteman_N = mkTerm "minuteman_N" ;
lin minuteness_N = mkTerm "minuteness_N" ;
lin minutes_N = mkTerm "minutes_N" ;
lin minutia_N = mkTerm "minutia_N" ;
lin minx_N = mkTerm "minx_N" ;
lin minyan_N = mkTerm "minyan_N" ;
lin miotic_A = mkTerm "miotic_A" ;
lin miracle_N = mkTerm "miracle_N" ;
lin miraculous_A = mkTerm "miraculous_A" ;
lin mirage_N = mkTerm "mirage_N" ;
lin miranda_PN = mkTerm "miranda_PN" ;
lin mire_N = mkTerm "mire_N" ;
lin mire_V = mkTerm "mire_V" ;
lin mire_V2 = mkTerm "mire_V2" ;
lin miriam_PN = mkTerm "miriam_PN" ;
lin miro_N = mkTerm "miro_N" ;
lin mirror_N = mkTerm "mirror_N" ;
lin mirror_V2 = mkTerm "mirror_V2" ;
lin mirrorlike_A = mkTerm "mirrorlike_A" ;
lin mirth_N = mkTerm "mirth_N" ;
lin mirthful_A = mkTerm "mirthful_A" ;
lin mirthless_A = mkTerm "mirthless_A" ;
lin miry_A = mkTerm "miry_A" ;
lin misadventure_N = mkTerm "misadventure_N" ;
lin misadvise_V2 = mkTerm "misadvise_V2" ;
lin misalignment_N = mkTerm "misalignment_N" ;
lin misalliance_N = mkTerm "misalliance_N" ;
lin misanthrope_N = mkTerm "misanthrope_N" ;
lin misanthropic_A = mkTerm "misanthropic_A" ;
lin misanthropy_N = mkTerm "misanthropy_N" ;
lin misapplication_N = mkTerm "misapplication_N" ;
lin misapply_V2 = mkTerm "misapply_V2" ;
lin misapprehend_V2 = mkTerm "misapprehend_V2" ;
lin misapprehension_N = mkTerm "misapprehension_N" ;
lin misappropriate_V2 = mkTerm "misappropriate_V2" ;
lin misappropriation_N = mkTerm "misappropriation_N" ;
lin misbegotten_A = mkTerm "misbegotten_A" ;
lin misbehave_V = mkTerm "misbehave_V" ;
lin misbehave_V2 = mkTerm "misbehave_V2" ;
lin misbehavior_N = mkTerm "misbehavior_N" ;
lin misbehaviour_N = mkTerm "misbehaviour_N" ;
lin misbranded_A = mkTerm "misbranded_A" ;
lin misc_PN = mkTerm "misc_PN" ;
lin miscalculate_V = mkTerm "miscalculate_V" ;
lin miscalculate_V2 = mkTerm "miscalculate_V2" ;
lin miscalculation_N = mkTerm "miscalculation_N" ;
lin miscall_V2 = mkTerm "miscall_V2" ;
lin miscarriage_N = mkTerm "miscarriage_N" ;
lin miscarry_V2 = mkTerm "miscarry_V2" ;
lin miscast_V2 = mkTerm "miscast_V2" ;
lin miscegenation_N = mkTerm "miscegenation_N" ;
lin miscellaneous_A = mkTerm "miscellaneous_A" ;
lin miscellany_N = mkTerm "miscellany_N" ;
lin mischance_N = mkTerm "mischance_N" ;
lin mischief_N = mkTerm "mischief_N" ;
lin mischief_maker_N = mkTerm "mischief_maker_N" ;
lin mischief_making_N = mkTerm "mischief_making_N" ;
lin mischievous_A = mkTerm "mischievous_A" ;
lin mischievousness_N = mkTerm "mischievousness_N" ;
lin miscible_A = mkTerm "miscible_A" ;
lin misconceive_V = mkTerm "misconceive_V" ;
lin misconceive_V2 = mkTerm "misconceive_V2" ;
lin misconception_N = mkTerm "misconception_N" ;
lin misconduct_N = mkTerm "misconduct_N" ;
lin misconduct_V2 = mkTerm "misconduct_V2" ;
lin misconstrual_N = mkTerm "misconstrual_N" ;
lin misconstruction_N = mkTerm "misconstruction_N" ;
lin misconstrue_V2 = mkTerm "misconstrue_V2" ;
lin miscount_N = mkTerm "miscount_N" ;
lin miscount_V = mkTerm "miscount_V" ;
lin miscount_V2 = mkTerm "miscount_V2" ;
lin miscreant_N = mkTerm "miscreant_N" ;
lin miscue_N = mkTerm "miscue_N" ;
lin misdate_V2 = mkTerm "misdate_V2" ;
lin misdeal_N = mkTerm "misdeal_N" ;
lin misdeal_V = mkTerm "misdeal_V" ;
lin misdeal_V2 = mkTerm "misdeal_V2" ;
lin misdeed_N = mkTerm "misdeed_N" ;
lin misdemeanor_N = mkTerm "misdemeanor_N" ;
lin misdemeanour_N = mkTerm "misdemeanour_N" ;
lin misdirect_V2 = mkTerm "misdirect_V2" ;
lin misdirection_N = mkTerm "misdirection_N" ;
lin misdoing_N = mkTerm "misdoing_N" ;
lin mise_en_scene_N = mkTerm "mise_en_scene_N" ;
lin miser_N = mkTerm "miser_N" ;
lin miserable_A = mkTerm "miserable_A" ;
lin miserliness_N = mkTerm "miserliness_N" ;
lin miserly_A = mkTerm "miserly_A" ;
lin misery_N = mkTerm "misery_N" ;
lin misfeasance_N = mkTerm "misfeasance_N" ;
lin misfire_N = mkTerm "misfire_N" ;
lin misfire_V = mkTerm "misfire_V" ;
lin misfit_N = mkTerm "misfit_N" ;
lin misfortune_N = mkTerm "misfortune_N" ;
lin misgive_V2 = mkTerm "misgive_V2" ;
lin misgiving_N = mkTerm "misgiving_N" ;
lin misgovern_V2 = mkTerm "misgovern_V2" ;
lin misgovernment_N = mkTerm "misgovernment_N" ;
lin misguide_V2 = mkTerm "misguide_V2" ;
lin mishandle_V2 = mkTerm "mishandle_V2" ;
lin mishap_N = mkTerm "mishap_N" ;
lin mishmash_N = mkTerm "mishmash_N" ;
lin mishpocha_N = mkTerm "mishpocha_N" ;
lin misinform_V2 = mkTerm "misinform_V2" ;
lin misinformation_N = mkTerm "misinformation_N" ;
lin misinterpret_V2 = mkTerm "misinterpret_V2" ;
lin misinterpretation_N = mkTerm "misinterpretation_N" ;
lin misjudge_V = mkTerm "misjudge_V" ;
lin misjudge_V2 = mkTerm "misjudge_V2" ;
lin mislaid_A = mkTerm "mislaid_A" ;
lin mislay_V2 = mkTerm "mislay_V2" ;
lin mislead_V2 = mkTerm "mislead_V2" ;
lin misleader_N = mkTerm "misleader_N" ;
lin misleading_A = mkTerm "misleading_A" ;
lin mismanage_V2 = mkTerm "mismanage_V2" ;
lin mismanagement_N = mkTerm "mismanagement_N" ;
lin mismatch_N = mkTerm "mismatch_N" ;
lin mismatched_A = mkTerm "mismatched_A" ;
lin misname_V2 = mkTerm "misname_V2" ;
lin misnomer_N = mkTerm "misnomer_N" ;
lin miso_N = mkTerm "miso_N" ;
lin misocainea_N = mkTerm "misocainea_N" ;
lin misogamist_N = mkTerm "misogamist_N" ;
lin misogamy_N = mkTerm "misogamy_N" ;
lin misogynic_A = mkTerm "misogynic_A" ;
lin misogynist_N = mkTerm "misogynist_N" ;
lin misogynous_A = mkTerm "misogynous_A" ;
lin misogyny_N = mkTerm "misogyny_N" ;
lin misology_N = mkTerm "misology_N" ;
lin misoneism_N = mkTerm "misoneism_N" ;
lin misopedia_N = mkTerm "misopedia_N" ;
lin misplace_V2 = mkTerm "misplace_V2" ;
lin misprint_N = mkTerm "misprint_N" ;
lin misprint_V2 = mkTerm "misprint_V2" ;
lin mispronounce_V2 = mkTerm "mispronounce_V2" ;
lin mispronunciation_N = mkTerm "mispronunciation_N" ;
lin misquotation_N = mkTerm "misquotation_N" ;
lin misquote_V2 = mkTerm "misquote_V2" ;
lin misread_V2 = mkTerm "misread_V2" ;
lin misreading_N = mkTerm "misreading_N" ;
lin misrelated_A = mkTerm "misrelated_A" ;
lin misrepresent_V2 = mkTerm "misrepresent_V2" ;
lin misrepresentation_N = mkTerm "misrepresentation_N" ;
lin misrule_N = mkTerm "misrule_N" ;
lin miss_N = mkTerm "miss_N" ;
lin miss_V = mkTerm "miss_V" ;
lin miss_V2 = mkTerm "miss_V2" ;
lin miss_out_V = mkTerm "miss_out_V" ;
lin miss_out_V2 = mkTerm "miss_out_V2" ;
lin miss_out_on_V2 = mkTerm "miss_out_on_V2" ;
lin missal_N = mkTerm "missal_N" ;
lin misshapen_A = mkTerm "misshapen_A" ;
lin missile_N = mkTerm "missile_N" ;
lin missing_A = mkTerm "missing_A" ;
lin mission_N = mkTerm "mission_N" ;
lin missionary_A = mkTerm "missionary_A" ;
lin missionary_N = mkTerm "missionary_N" ;
lin missis_N = mkTerm "missis_N" ;
lin mississippi_PN = mkTerm "mississippi_PN" ;
lin missive_N = mkTerm "missive_N" ;
lin missouri_PN = mkTerm "missouri_PN" ;
lin misspell_V2 = mkTerm "misspell_V2" ;
lin misspelling_N = mkTerm "misspelling_N" ;
lin misspend_V2 = mkTerm "misspend_V2" ;
lin misstate_V2 = mkTerm "misstate_V2" ;
lin misstatement_N = mkTerm "misstatement_N" ;
lin missus_N = mkTerm "missus_N" ;
lin missy_N = mkTerm "missy_N" ;
lin mist_N = mkTerm "mist_N" ;
lin mist_V = mkTerm "mist_V" ;
lin mist_V2 = mkTerm "mist_V2" ;
lin mistake_N = mkTerm "mistake_N" ;
lin mistake_V = mkTerm "mistake_V" ;
lin mistake_V2 = mkTerm "mistake_V2" ;
lin mistaken_A = mkTerm "mistaken_A" ;
lin mister_N = mkTerm "mister_N" ;
lin mistflower_N = mkTerm "mistflower_N" ;
lin mistime_V2 = mkTerm "mistime_V2" ;
lin mistiness_N = mkTerm "mistiness_N" ;
lin mistletoe_N = mkTerm "mistletoe_N" ;
lin mistral_N = mkTerm "mistral_N" ;
lin mistranslate_V2 = mkTerm "mistranslate_V2" ;
lin mistranslation_N = mkTerm "mistranslation_N" ;
lin mistreat_V2 = mkTerm "mistreat_V2" ;
lin mistreatment_N = mkTerm "mistreatment_N" ;
lin mistress_N = mkTerm "mistress_N" ;
lin mistrial_N = mkTerm "mistrial_N" ;
lin mistrust_N = mkTerm "mistrust_N" ;
lin mistrust_V2 = mkTerm "mistrust_V2" ;
lin mistrustful_A = mkTerm "mistrustful_A" ;
lin misty_A = mkTerm "misty_A" ;
lin misunderstand_V2 = mkTerm "misunderstand_V2" ;
lin misunderstanding_N = mkTerm "misunderstanding_N" ;
lin misuse_N = mkTerm "misuse_N" ;
lin misuse_V2 = mkTerm "misuse_V2" ;
lin mite_N = mkTerm "mite_N" ;
lin miter_N = mkTerm "miter_N" ;
lin miterwort_N = mkTerm "miterwort_N" ;
lin mithraic_A = mkTerm "mithraic_A" ;
lin mithramycin_N = mkTerm "mithramycin_N" ;
lin mitigable_A = mkTerm "mitigable_A" ;
lin mitigate_V2 = mkTerm "mitigate_V2" ;
lin mitigation_N = mkTerm "mitigation_N" ;
lin mitochondrial_A = mkTerm "mitochondrial_A" ;
lin mitochondrion_N = mkTerm "mitochondrion_N" ;
lin mitogen_N = mkTerm "mitogen_N" ;
lin mitomycin_N = mkTerm "mitomycin_N" ;
lin mitosis_N = mkTerm "mitosis_N" ;
lin mitotic_A = mkTerm "mitotic_A" ;
lin mitral_A = mkTerm "mitral_A" ;
lin mitre_N = mkTerm "mitre_N" ;
lin mitre_joint_N = mkTerm "mitre_joint_N" ;
lin mitt_N = mkTerm "mitt_N" ;
lin mittelschmerz_N = mkTerm "mittelschmerz_N" ;
lin mitten_N = mkTerm "mitten_N" ;
lin mitzvah_N = mkTerm "mitzvah_N" ;
lin mix_N = mkTerm "mix_N" ;
lin mix_V = mkTerm "mix_V" ;
lin mix_V2 = mkTerm "mix_V2" ;
lin mix_up_N = mkTerm "mix_up_N" ;
lin mix_up_V2 = mkTerm "mix_up_V2" ;
lin mixed_A = mkTerm "mixed_A" ;
lin mixed_up_A = mkTerm "mixed_up_A" ;
lin mixer_N = mkTerm "mixer_N" ;
lin mixology_N = mkTerm "mixology_N" ;
lin mixture_N = mkTerm "mixture_N" ;
lin mizen_N = mkTerm "mizen_N" ;
lin mizzen_N = mkTerm "mizzen_N" ;
lin mizzen_mast_N = mkTerm "mizzen_mast_N" ;
lin mizzle_V = mkTerm "mizzle_V" ;
lin ml_N = mkTerm "ml_N" ;
lin mlle_PN = mkTerm "mlle_PN" ;
lin mm_N = mkTerm "mm_N" ;
lin mme_PN = mkTerm "mme_PN" ;
lin mnemonic_A = mkTerm "mnemonic_A" ;
lin mnemonic_N = mkTerm "mnemonic_N" ;
lin mnemonics_N = mkTerm "mnemonics_N" ;
lin mnemonist_N = mkTerm "mnemonist_N" ;
lin mo_N = mkTerm "mo_N" ;
lin mo_PN = mkTerm "mo_PN" ;
lin moa_N = mkTerm "moa_N" ;
lin moan_N = mkTerm "moan_N" ;
lin moan_V = mkTerm "moan_V" ;
lin moan_VS = mkTerm "moan_VS" ;
lin moat_N = mkTerm "moat_N" ;
lin moated_A = mkTerm "moated_A" ;
lin mob_N = mkTerm "mob_N" ;
lin mob_V2 = mkTerm "mob_V2" ;
lin mobbish_A = mkTerm "mobbish_A" ;
lin mobcap_N = mkTerm "mobcap_N" ;
lin mobile_A = mkTerm "mobile_A" ;
lin mobile_N = mkTerm "mobile_N" ;
lin mobility_N = mkTerm "mobility_N" ;
lin mobilization_N = mkTerm "mobilization_N" ;
lin mobilize_V = mkTerm "mobilize_V" ;
lin mobilize_V2 = mkTerm "mobilize_V2" ;
lin mobocracy_N = mkTerm "mobocracy_N" ;
lin mobster_N = mkTerm "mobster_N" ;
lin moccasin_N = mkTerm "moccasin_N" ;
lin mocha_N = mkTerm "mocha_N" ;
lin mock_A = mkTerm "mock_A" ;
lin mock_N = mkTerm "mock_N" ;
lin mock_V = mkTerm "mock_V" ;
lin mock_V2 = mkTerm "mock_V2" ;
lin mock_up_N = mkTerm "mock_up_N" ;
lin mock_up_V2 = mkTerm "mock_up_V2" ;
lin mocker_N = mkTerm "mocker_N" ;
lin mockernut_N = mkTerm "mockernut_N" ;
lin mockery_N = mkTerm "mockery_N" ;
lin mockingbird_N = mkTerm "mockingbird_N" ;
lin mockingly_Adv = mkTerm "mockingly_Adv" ;
lin mod_A = mkTerm "mod_A" ;
lin mod_N = mkTerm "mod_N" ;
lin mod_cons_N = mkTerm "mod_cons_N" ;
lin modal_A = mkTerm "modal_A" ;
lin modality_N = mkTerm "modality_N" ;
lin mode_N = mkTerm "mode_N" ;
lin model_N = mkTerm "model_N" ;
lin model_V = mkTerm "model_V" ;
lin model_V2 = mkTerm "model_V2" ;
lin modeler_N = mkTerm "modeler_N" ;
lin modeling_N = mkTerm "modeling_N" ;
lin modeller_N = mkTerm "modeller_N" ;
lin modelling_N = mkTerm "modelling_N" ;
lin modem_N = mkTerm "modem_N" ;
lin modena_PN = mkTerm "modena_PN" ;
lin moderate_A = mkTerm "moderate_A" ;
lin moderate_N = mkTerm "moderate_N" ;
lin moderate_V = mkTerm "moderate_V" ;
lin moderate_V2 = mkTerm "moderate_V2" ;
lin moderation_N = mkTerm "moderation_N" ;
lin moderationism_N = mkTerm "moderationism_N" ;
lin moderationist_N = mkTerm "moderationist_N" ;
lin moderato_A = mkTerm "moderato_A" ;
lin moderator_N = mkTerm "moderator_N" ;
lin moderatorship_N = mkTerm "moderatorship_N" ;
lin modern_A = mkTerm "modern_A" ;
lin modern_N = mkTerm "modern_N" ;
lin moderne_A = mkTerm "moderne_A" ;
lin modernism_N = mkTerm "modernism_N" ;
lin modernist_N = mkTerm "modernist_N" ;
lin modernistic_A = mkTerm "modernistic_A" ;
lin modernity_N = mkTerm "modernity_N" ;
lin modernization_N = mkTerm "modernization_N" ;
lin modernize_V2 = mkTerm "modernize_V2" ;
lin modest_A = mkTerm "modest_A" ;
lin modesty_N = mkTerm "modesty_N" ;
lin modicum_N = mkTerm "modicum_N" ;
lin modifiable_A = mkTerm "modifiable_A" ;
lin modification_N = mkTerm "modification_N" ;
lin modifier_N = mkTerm "modifier_N" ;
lin modify_V2 = mkTerm "modify_V2" ;
lin modillion_N = mkTerm "modillion_N" ;
lin modiolus_N = mkTerm "modiolus_N" ;
lin modish_A = mkTerm "modish_A" ;
lin modiste_N = mkTerm "modiste_N" ;
lin mods_N = mkTerm "mods_N" ;
lin modular_A = mkTerm "modular_A" ;
lin modulate_V = mkTerm "modulate_V" ;
lin modulate_V2 = mkTerm "modulate_V2" ;
lin modulation_N = mkTerm "modulation_N" ;
lin module_N = mkTerm "module_N" ;
lin modulo_Prep = mkTerm "modulo_Prep" ;
lin modulus_N = mkTerm "modulus_N" ;
lin modus_operandi_N = mkTerm "modus_operandi_N" ;
lin modus_vivendi_N = mkTerm "modus_vivendi_N" ;
lin moggy_off_V = mkTerm "moggy_off_V" ;
lin mogul_N = mkTerm "mogul_N" ;
lin mohair_N = mkTerm "mohair_N" ;
lin mohammedan_N = mkTerm "mohammedan_N" ;
lin mohawk_N = mkTerm "mohawk_N" ;
lin moiety_N = mkTerm "moiety_N" ;
lin moil_V = mkTerm "moil_V" ;
lin moira_PN = mkTerm "moira_PN" ;
lin moire_A = mkTerm "moire_A" ;
lin moire_N = mkTerm "moire_N" ;
lin moist_A = mkTerm "moist_A" ;
lin moisten_V = mkTerm "moisten_V" ;
lin moisten_V2 = mkTerm "moisten_V2" ;
lin moistening_N = mkTerm "moistening_N" ;
lin moisture_N = mkTerm "moisture_N" ;
lin mojarra_N = mkTerm "mojarra_N" ;
lin mojo_N = mkTerm "mojo_N" ;
lin moke_N = mkTerm "moke_N" ;
lin moksa_N = mkTerm "moksa_N" ;
lin molal_A = mkTerm "molal_A" ;
lin molality_N = mkTerm "molality_N" ;
lin molar_A = mkTerm "molar_A" ;
lin molar_N = mkTerm "molar_N" ;
lin molarity_N = mkTerm "molarity_N" ;
lin molasses_N = mkTerm "molasses_N" ;
lin mold_PN = mkTerm "mold_PN" ;
lin mold_V = mkTerm "mold_V" ;
lin mold_V2 = mkTerm "mold_V2" ;
lin moldboard_N = mkTerm "moldboard_N" ;
lin molding_N = mkTerm "molding_N" ;
lin moldy_A = mkTerm "moldy_A" ;
lin mole_N = mkTerm "mole_N" ;
lin molecular_A = mkTerm "molecular_A" ;
lin molecule_N = mkTerm "molecule_N" ;
lin molehill_N = mkTerm "molehill_N" ;
lin moleskin_N = mkTerm "moleskin_N" ;
lin molest_V2 = mkTerm "molest_V2" ;
lin molestation_N = mkTerm "molestation_N" ;
lin molester_N = mkTerm "molester_N" ;
lin molindone_N = mkTerm "molindone_N" ;
lin moll_N = mkTerm "moll_N" ;
lin mollie_N = mkTerm "mollie_N" ;
lin mollification_N = mkTerm "mollification_N" ;
lin mollify_V2 = mkTerm "mollify_V2" ;
lin mollusc_N = mkTerm "mollusc_N" ;
lin molluscum_N = mkTerm "molluscum_N" ;
lin mollusk_N = mkTerm "mollusk_N" ;
lin molly_N = mkTerm "molly_N" ;
lin molly_PN = mkTerm "molly_PN" ;
lin mollycoddle_N = mkTerm "mollycoddle_N" ;
lin mollycoddle_V2 = mkTerm "mollycoddle_V2" ;
lin moloch_N = mkTerm "moloch_N" ;
lin moloch_PN = mkTerm "moloch_PN" ;
lin molt_N = mkTerm "molt_N" ;
lin molten_A = mkTerm "molten_A" ;
lin molter_N = mkTerm "molter_N" ;
lin molto_Adv = mkTerm "molto_Adv" ;
lin molybdenite_N = mkTerm "molybdenite_N" ;
lin molybdenum_N = mkTerm "molybdenum_N" ;
lin mom_N = mkTerm "mom_N" ;
lin mombin_N = mkTerm "mombin_N" ;
lin moment_N = mkTerm "moment_N" ;
lin momentary_A = mkTerm "momentary_A" ;
lin momentous_A = mkTerm "momentous_A" ;
lin momentousness_N = mkTerm "momentousness_N" ;
lin momentum_N = mkTerm "momentum_N" ;
lin momism_N = mkTerm "momism_N" ;
lin mon_PN = mkTerm "mon_PN" ;
lin monaco_PN = mkTerm "monaco_PN" ;
lin monad_N = mkTerm "monad_N" ;
lin monaghan_PN = mkTerm "monaghan_PN" ;
lin monal_N = mkTerm "monal_N" ;
lin monandrous_A = mkTerm "monandrous_A" ;
lin monandry_N = mkTerm "monandry_N" ;
lin monarch_N = mkTerm "monarch_N" ;
lin monarchal_A = mkTerm "monarchal_A" ;
lin monarchic_A = mkTerm "monarchic_A" ;
lin monarchism_N = mkTerm "monarchism_N" ;
lin monarchist_N = mkTerm "monarchist_N" ;
lin monarchy_N = mkTerm "monarchy_N" ;
lin monarda_N = mkTerm "monarda_N" ;
lin monastery_N = mkTerm "monastery_N" ;
lin monastic_A = mkTerm "monastic_A" ;
lin monasticism_N = mkTerm "monasticism_N" ;
lin monatomic_A = mkTerm "monatomic_A" ;
lin monaural_A = mkTerm "monaural_A" ;
lin monazite_N = mkTerm "monazite_N" ;
lin monchengladbach_PN = mkTerm "monchengladbach_PN" ;
lin monegasque_A = mkTerm "monegasque_A" ;
lin monegasque_N = mkTerm "monegasque_N" ;
lin moneran_A = mkTerm "moneran_A" ;
lin moneran_N = mkTerm "moneran_N" ;
lin monestrous_A = mkTerm "monestrous_A" ;
lin monetarism_N = mkTerm "monetarism_N" ;
lin monetarist_N = mkTerm "monetarist_N" ;
lin monetary_A = mkTerm "monetary_A" ;
lin monetization_N = mkTerm "monetization_N" ;
lin monetize_V2 = mkTerm "monetize_V2" ;
lin money_N = mkTerm "money_N" ;
lin money_grubber_N = mkTerm "money_grubber_N" ;
lin money_order_N = mkTerm "money_order_N" ;
lin money_spinner_N = mkTerm "money_spinner_N" ;
lin moneybag_N = mkTerm "moneybag_N" ;
lin moneybox_N = mkTerm "moneybox_N" ;
lin moneychanger_N = mkTerm "moneychanger_N" ;
lin moneyed_A = mkTerm "moneyed_A" ;
lin moneylender_N = mkTerm "moneylender_N" ;
lin moneyless_A = mkTerm "moneyless_A" ;
lin moneymaker_N = mkTerm "moneymaker_N" ;
lin moneymaking_N = mkTerm "moneymaking_N" ;
lin moneywort_N = mkTerm "moneywort_N" ;
lin monger_N = mkTerm "monger_N" ;
lin mongo_N = mkTerm "mongo_N" ;
lin mongol_A = mkTerm "mongol_A" ;
lin mongol_N = mkTerm "mongol_N" ;
lin mongolia_PN = mkTerm "mongolia_PN" ;
lin mongolian_A = mkTerm "mongolian_A" ;
lin mongolian_N = mkTerm "mongolian_N" ;
lin mongolism_N = mkTerm "mongolism_N" ;
lin mongoloid_A = mkTerm "mongoloid_A" ;
lin mongoloid_N = mkTerm "mongoloid_N" ;
lin mongoose_N = mkTerm "mongoose_N" ;
lin mongrel_A = mkTerm "mongrel_A" ;
lin mongrel_N = mkTerm "mongrel_N" ;
lin monica_PN = mkTerm "monica_PN" ;
lin monifieth_PN = mkTerm "monifieth_PN" ;
lin moniker_N = mkTerm "moniker_N" ;
lin monilia_N = mkTerm "monilia_N" ;
lin monism_N = mkTerm "monism_N" ;
lin monistic_A = mkTerm "monistic_A" ;
lin monition_N = mkTerm "monition_N" ;
lin monitor_N = mkTerm "monitor_N" ;
lin monitor_V = mkTerm "monitor_V" ;
lin monitor_V2 = mkTerm "monitor_V2" ;
lin monitoring_N = mkTerm "monitoring_N" ;
lin monk_N = mkTerm "monk_N" ;
lin monkey_N = mkTerm "monkey_N" ;
lin monkey_V = mkTerm "monkey_V" ;
lin monkey_around_V = mkTerm "monkey_around_V" ;
lin monkey_jacket_N = mkTerm "monkey_jacket_N" ;
lin monkey_nut_N = mkTerm "monkey_nut_N" ;
lin monkey_puzzle_N = mkTerm "monkey_puzzle_N" ;
lin monkey_wrench_N = mkTerm "monkey_wrench_N" ;
lin monkfish_N = mkTerm "monkfish_N" ;
lin monkish_A = mkTerm "monkish_A" ;
lin monkshood_N = mkTerm "monkshood_N" ;
lin monmouth_PN = mkTerm "monmouth_PN" ;
lin mono_A = mkTerm "mono_A" ;
lin monoamine_N = mkTerm "monoamine_N" ;
lin monoblast_N = mkTerm "monoblast_N" ;
lin monocarboxylic_A = mkTerm "monocarboxylic_A" ;
lin monocarp_N = mkTerm "monocarp_N" ;
lin monocarpic_A = mkTerm "monocarpic_A" ;
lin monochromacy_N = mkTerm "monochromacy_N" ;
lin monochromat_N = mkTerm "monochromat_N" ;
lin monochromatic_A = mkTerm "monochromatic_A" ;
lin monochrome_A = mkTerm "monochrome_A" ;
lin monochrome_N = mkTerm "monochrome_N" ;
lin monocle_N = mkTerm "monocle_N" ;
lin monocled_A = mkTerm "monocled_A" ;
lin monoclinal_A = mkTerm "monoclinal_A" ;
lin monocline_N = mkTerm "monocline_N" ;
lin monoclinic_A = mkTerm "monoclinic_A" ;
lin monoclinous_A = mkTerm "monoclinous_A" ;
lin monoclonal_A = mkTerm "monoclonal_A" ;
lin monocot_N = mkTerm "monocot_N" ;
lin monocotyledonous_A = mkTerm "monocotyledonous_A" ;
lin monoculture_N = mkTerm "monoculture_N" ;
lin monocyte_N = mkTerm "monocyte_N" ;
lin monocytosis_N = mkTerm "monocytosis_N" ;
lin monodic_A = mkTerm "monodic_A" ;
lin monoecious_A = mkTerm "monoecious_A" ;
lin monogamist_N = mkTerm "monogamist_N" ;
lin monogamous_A = mkTerm "monogamous_A" ;
lin monogamy_N = mkTerm "monogamy_N" ;
lin monogenesis_N = mkTerm "monogenesis_N" ;
lin monogenic_A = mkTerm "monogenic_A" ;
lin monogram_N = mkTerm "monogram_N" ;
lin monograph_N = mkTerm "monograph_N" ;
lin monogynous_A = mkTerm "monogynous_A" ;
lin monogyny_N = mkTerm "monogyny_N" ;
lin monohybrid_N = mkTerm "monohybrid_N" ;
lin monohydrate_N = mkTerm "monohydrate_N" ;
lin monolatry_N = mkTerm "monolatry_N" ;
lin monolingual_A = mkTerm "monolingual_A" ;
lin monolingual_N = mkTerm "monolingual_N" ;
lin monolith_N = mkTerm "monolith_N" ;
lin monolithic_A = mkTerm "monolithic_A" ;
lin monologist_N = mkTerm "monologist_N" ;
lin monologue_N = mkTerm "monologue_N" ;
lin monomania_N = mkTerm "monomania_N" ;
lin monomaniac_N = mkTerm "monomaniac_N" ;
lin monomaniacal_A = mkTerm "monomaniacal_A" ;
lin monomer_N = mkTerm "monomer_N" ;
lin monometallic_A = mkTerm "monometallic_A" ;
lin monomorphemic_A = mkTerm "monomorphemic_A" ;
lin mononeuropathy_N = mkTerm "mononeuropathy_N" ;
lin mononuclear_A = mkTerm "mononuclear_A" ;
lin monophonic_A = mkTerm "monophonic_A" ;
lin monophony_N = mkTerm "monophony_N" ;
lin monoplane_N = mkTerm "monoplane_N" ;
lin monoplegia_N = mkTerm "monoplegia_N" ;
lin monopolist_N = mkTerm "monopolist_N" ;
lin monopolistic_A = mkTerm "monopolistic_A" ;
lin monopolization_N = mkTerm "monopolization_N" ;
lin monopolize_V2 = mkTerm "monopolize_V2" ;
lin monopoly_N = mkTerm "monopoly_N" ;
lin monopsony_N = mkTerm "monopsony_N" ;
lin monopteral_A = mkTerm "monopteral_A" ;
lin monorail_N = mkTerm "monorail_N" ;
lin monorchism_N = mkTerm "monorchism_N" ;
lin monosaccharide_N = mkTerm "monosaccharide_N" ;
lin monosemous_A = mkTerm "monosemous_A" ;
lin monosemy_N = mkTerm "monosemy_N" ;
lin monosomy_N = mkTerm "monosomy_N" ;
lin monosyllabic_A = mkTerm "monosyllabic_A" ;
lin monosyllable_N = mkTerm "monosyllable_N" ;
lin monotheism_N = mkTerm "monotheism_N" ;
lin monotheist_N = mkTerm "monotheist_N" ;
lin monotheistic_A = mkTerm "monotheistic_A" ;
lin monotone_N = mkTerm "monotone_N" ;
lin monotonic_A = mkTerm "monotonic_A" ;
lin monotonous_A = mkTerm "monotonous_A" ;
lin monotony_N = mkTerm "monotony_N" ;
lin monotreme_N = mkTerm "monotreme_N" ;
lin monotype_N = mkTerm "monotype_N" ;
lin monotypic_A = mkTerm "monotypic_A" ;
lin monounsaturated_A = mkTerm "monounsaturated_A" ;
lin monovalent_A = mkTerm "monovalent_A" ;
lin monoxide_N = mkTerm "monoxide_N" ;
lin monozygotic_A = mkTerm "monozygotic_A" ;
lin mons_N = mkTerm "mons_N" ;
lin monsieur_N = mkTerm "monsieur_N" ;
lin monsignor_N = mkTerm "monsignor_N" ;
lin monsoon_N = mkTerm "monsoon_N" ;
lin monster_N = mkTerm "monster_N" ;
lin monstera_N = mkTerm "monstera_N" ;
lin monstrance_N = mkTerm "monstrance_N" ;
lin monstrosity_N = mkTerm "monstrosity_N" ;
lin monstrous_A = mkTerm "monstrous_A" ;
lin montage_N = mkTerm "montage_N" ;
lin montana_PN = mkTerm "montana_PN" ;
lin montane_A = mkTerm "montane_A" ;
lin monte_N = mkTerm "monte_N" ;
lin monterrey_PN = mkTerm "monterrey_PN" ;
lin montevideo_PN = mkTerm "montevideo_PN" ;
lin month_N = mkTerm "month_N" ;
lin monthlong_A = mkTerm "monthlong_A" ;
lin monthly_A = mkTerm "monthly_A" ;
lin monthly_Adv = mkTerm "monthly_Adv" ;
lin monthly_N = mkTerm "monthly_N" ;
lin montreal_PN = mkTerm "montreal_PN" ;
lin montrose_PN = mkTerm "montrose_PN" ;
lin montserrat_PN = mkTerm "montserrat_PN" ;
lin montserratian_A = mkTerm "montserratian_A" ;
lin montserratian_N = mkTerm "montserratian_N" ;
lin monument_N = mkTerm "monument_N" ;
lin monumental_A = mkTerm "monumental_A" ;
lin monza_PN = mkTerm "monza_PN" ;
lin moo_N = mkTerm "moo_N" ;
lin moo_V = mkTerm "moo_V" ;
lin moo_cow_N = mkTerm "moo_cow_N" ;
lin mooch_V = mkTerm "mooch_V" ;
lin mooch_about_V = mkTerm "mooch_about_V" ;
lin mooch_around_V = mkTerm "mooch_around_V" ;
lin moocher_N = mkTerm "moocher_N" ;
lin mood_N = mkTerm "mood_N" ;
lin moodiness_N = mkTerm "moodiness_N" ;
lin moody_A = mkTerm "moody_A" ;
lin moon_N = mkTerm "moon_N" ;
lin moon_V = mkTerm "moon_V" ;
lin moon_V2 = mkTerm "moon_V2" ;
lin moonbeam_N = mkTerm "moonbeam_N" ;
lin moonfish_N = mkTerm "moonfish_N" ;
lin moonflower_N = mkTerm "moonflower_N" ;
lin moonless_A = mkTerm "moonless_A" ;
lin moonlight_N = mkTerm "moonlight_N" ;
lin moonlighter_N = mkTerm "moonlighter_N" ;
lin moonlike_A = mkTerm "moonlike_A" ;
lin moonlit_A = mkTerm "moonlit_A" ;
lin moonseed_N = mkTerm "moonseed_N" ;
lin moonshine_N = mkTerm "moonshine_N" ;
lin moonstone_N = mkTerm "moonstone_N" ;
lin moonstruck_A = mkTerm "moonstruck_A" ;
lin moonwalk_N = mkTerm "moonwalk_N" ;
lin moonwort_N = mkTerm "moonwort_N" ;
lin moony_A = mkTerm "moony_A" ;
lin moor_N = mkTerm "moor_N" ;
lin moor_V2 = mkTerm "moor_V2" ;
lin moorage_N = mkTerm "moorage_N" ;
lin moorcock_N = mkTerm "moorcock_N" ;
lin moorfowl_N = mkTerm "moorfowl_N" ;
lin moorgame_N = mkTerm "moorgame_N" ;
lin moorhen_N = mkTerm "moorhen_N" ;
lin mooring_N = mkTerm "mooring_N" ;
lin mooring_mast_N = mkTerm "mooring_mast_N" ;
lin moorish_A = mkTerm "moorish_A" ;
lin moorland_N = mkTerm "moorland_N" ;
lin moose_N = mkTerm "moose_N" ;
lin moosewood_N = mkTerm "moosewood_N" ;
lin moot_A = mkTerm "moot_A" ;
lin moot_N = mkTerm "moot_N" ;
lin moot_V2 = mkTerm "moot_V2" ;
lin mop_N = mkTerm "mop_N" ;
lin mop_V = mkTerm "mop_V" ;
lin mop_V2 = mkTerm "mop_V2" ;
lin mop_up_V2 = mkTerm "mop_up_V2" ;
lin mope_N = mkTerm "mope_N" ;
lin mope_V = mkTerm "mope_V" ;
lin mope_about_V = mkTerm "mope_about_V" ;
lin mope_around_V = mkTerm "mope_around_V" ;
lin moped_N = mkTerm "moped_N" ;
lin mopper_N = mkTerm "mopper_N" ;
lin moppet_N = mkTerm "moppet_N" ;
lin moquette_N = mkTerm "moquette_N" ;
lin moraceous_A = mkTerm "moraceous_A" ;
lin moraine_N = mkTerm "moraine_N" ;
lin moral_A = mkTerm "moral_A" ;
lin moral_N = mkTerm "moral_N" ;
lin morale_N = mkTerm "morale_N" ;
lin moralism_N = mkTerm "moralism_N" ;
lin moralist_N = mkTerm "moralist_N" ;
lin moralistic_A = mkTerm "moralistic_A" ;
lin morality_N = mkTerm "morality_N" ;
lin moralization_N = mkTerm "moralization_N" ;
lin moralize_V = mkTerm "moralize_V" ;
lin moralize_V2 = mkTerm "moralize_V2" ;
lin moralizing_N = mkTerm "moralizing_N" ;
lin morass_N = mkTerm "morass_N" ;
lin moratorium_N = mkTerm "moratorium_N" ;
lin moray_N = mkTerm "moray_N" ;
lin morbid_A = mkTerm "morbid_A" ;
lin morbidity_N = mkTerm "morbidity_N" ;
lin morbidness_N = mkTerm "morbidness_N" ;
lin morbilliform_A = mkTerm "morbilliform_A" ;
lin morceau_N = mkTerm "morceau_N" ;
lin mordacious_A = mkTerm "mordacious_A" ;
lin mordacity_N = mkTerm "mordacity_N" ;
lin mordant_A = mkTerm "mordant_A" ;
lin mordant_N = mkTerm "mordant_N" ;
lin more_Adv = mkTerm "more_Adv" ;
lin more_N = mkTerm "more_N" ;
lin more_Quant = mkTerm "more_Quant" ;
lin more_often_than_not_Adv = mkTerm "more_often_than_not_Adv" ;
lin more_than_AdN = mkTerm "more_than_AdN" ;
lin more_than_Predet = mkTerm "more_than_Predet" ;
lin morecambe_PN = mkTerm "morecambe_PN" ;
lin moreen_N = mkTerm "moreen_N" ;
lin morel_N = mkTerm "morel_N" ;
lin morello_N = mkTerm "morello_N" ;
lin moreover_Adv = mkTerm "moreover_Adv" ;
lin mores_N = mkTerm "mores_N" ;
lin moresque_A = mkTerm "moresque_A" ;
lin morgan_N = mkTerm "morgan_N" ;
lin morganatic_A = mkTerm "morganatic_A" ;
lin morganite_N = mkTerm "morganite_N" ;
lin morgen_N = mkTerm "morgen_N" ;
lin morgue_N = mkTerm "morgue_N" ;
lin moribund_A = mkTerm "moribund_A" ;
lin morion_N = mkTerm "morion_N" ;
lin morley_PN = mkTerm "morley_PN" ;
lin mormon_A = mkTerm "mormon_A" ;
lin mormon_N = mkTerm "mormon_N" ;
lin mormonism_N = mkTerm "mormonism_N" ;
lin morn_N = mkTerm "morn_N" ;
lin morning_N = mkTerm "morning_N" ;
lin morning_glory_N = mkTerm "morning_glory_N" ;
lin morning_room_N = mkTerm "morning_room_N" ;
lin moroccan_A = mkTerm "moroccan_A" ;
lin moroccan_N = mkTerm "moroccan_N" ;
lin morocco_N = mkTerm "morocco_N" ;
lin morocco_PN = mkTerm "morocco_PN" ;
lin moron_N = mkTerm "moron_N" ;
lin moronic_A = mkTerm "moronic_A" ;
lin moronity_N = mkTerm "moronity_N" ;
lin morose_A = mkTerm "morose_A" ;
lin moroseness_N = mkTerm "moroseness_N" ;
lin morosoph_N = mkTerm "morosoph_N" ;
lin morpeth_PN = mkTerm "morpeth_PN" ;
lin morphallaxis_N = mkTerm "morphallaxis_N" ;
lin morphea_N = mkTerm "morphea_N" ;
lin morpheme_N = mkTerm "morpheme_N" ;
lin morphemic_A = mkTerm "morphemic_A" ;
lin morpheus_PN = mkTerm "morpheus_PN" ;
lin morphia_N = mkTerm "morphia_N" ;
lin morphine_N = mkTerm "morphine_N" ;
lin morphogenesis_N = mkTerm "morphogenesis_N" ;
lin morphologic_A = mkTerm "morphologic_A" ;
lin morphological_A = mkTerm "morphological_A" ;
lin morphology_N = mkTerm "morphology_N" ;
lin morphophoneme_N = mkTerm "morphophoneme_N" ;
lin morphophonemic_A = mkTerm "morphophonemic_A" ;
lin morphophonemics_N = mkTerm "morphophonemics_N" ;
lin morris_dance_N = mkTerm "morris_dance_N" ;
lin morrow_N = mkTerm "morrow_N" ;
lin morse_N = mkTerm "morse_N" ;
lin morsel_N = mkTerm "morsel_N" ;
lin mortal_A = mkTerm "mortal_A" ;
lin mortal_N = mkTerm "mortal_N" ;
lin mortality_N = mkTerm "mortality_N" ;
lin mortar_N = mkTerm "mortar_N" ;
lin mortar_V2 = mkTerm "mortar_V2" ;
lin mortarboard_N = mkTerm "mortarboard_N" ;
lin mortgage_N = mkTerm "mortgage_N" ;
lin mortgage_V2 = mkTerm "mortgage_V2" ;
lin mortgagee_N = mkTerm "mortgagee_N" ;
lin mortgagor_N = mkTerm "mortgagor_N" ;
lin mortice_N = mkTerm "mortice_N" ;
lin mortice_V2 = mkTerm "mortice_V2" ;
lin mortician_N = mkTerm "mortician_N" ;
lin mortification_N = mkTerm "mortification_N" ;
lin mortify_V = mkTerm "mortify_V" ;
lin mortify_V2 = mkTerm "mortify_V2" ;
lin mortise_N = mkTerm "mortise_N" ;
lin mortise_V2 = mkTerm "mortise_V2" ;
lin mortmain_N = mkTerm "mortmain_N" ;
lin mortuary_A = mkTerm "mortuary_A" ;
lin mortuary_N = mkTerm "mortuary_N" ;
lin morula_N = mkTerm "morula_N" ;
lin mosaic_A = mkTerm "mosaic_A" ;
lin mosaic_N = mkTerm "mosaic_N" ;
lin mosaicism_N = mkTerm "mosaicism_N" ;
lin moscow_1_PN = mkTerm "moscow_1_PN" ;
lin moscow_2_PN = mkTerm "moscow_2_PN" ;
lin moselle_N = mkTerm "moselle_N" ;
lin mosey_V = mkTerm "mosey_V" ;
lin moshav_N = mkTerm "moshav_N" ;
lin moslem_A = mkTerm "moslem_A" ;
lin moslem_N = mkTerm "moslem_N" ;
lin mosque_N = mkTerm "mosque_N" ;
lin mosquito_N = mkTerm "mosquito_N" ;
lin mosquito_craft_N = mkTerm "mosquito_craft_N" ;
lin mosquito_net_N = mkTerm "mosquito_net_N" ;
lin mosquitofish_N = mkTerm "mosquitofish_N" ;
lin moss_N = mkTerm "moss_N" ;
lin moss_grown_A = mkTerm "moss_grown_A" ;
lin mossback_N = mkTerm "mossback_N" ;
lin mossley_PN = mkTerm "mossley_PN" ;
lin mossy_A = mkTerm "mossy_A" ;
lin most_Adv = mkTerm "most_Adv" ;
lin most_Det = mkTerm "most_Det" ;
lin mostaccioli_N = mkTerm "mostaccioli_N" ;
lin mostly_Adv = mkTerm "mostly_Adv" ;
lin mote_N = mkTerm "mote_N" ;
lin motel_N = mkTerm "motel_N" ;
lin motet_N = mkTerm "motet_N" ;
lin moth_N = mkTerm "moth_N" ;
lin moth_eaten_A = mkTerm "moth_eaten_A" ;
lin mothball_N = mkTerm "mothball_N" ;
lin mother_N = mkTerm "mother_N" ;
lin mother_V2 = mkTerm "mother_V2" ;
lin mother_in_law_N = mkTerm "mother_in_law_N" ;
lin mother_of_pearl_N = mkTerm "mother_of_pearl_N" ;
lin motherhood_N = mkTerm "motherhood_N" ;
lin motherland_N = mkTerm "motherland_N" ;
lin motherless_A = mkTerm "motherless_A" ;
lin motherlike_A = mkTerm "motherlike_A" ;
lin motherliness_N = mkTerm "motherliness_N" ;
lin motherly_A = mkTerm "motherly_A" ;
lin motherwell_PN = mkTerm "motherwell_PN" ;
lin motherwort_N = mkTerm "motherwort_N" ;
lin mothproof_A = mkTerm "mothproof_A" ;
lin mothproof_V2 = mkTerm "mothproof_V2" ;
lin mothy_A = mkTerm "mothy_A" ;
lin motif_N = mkTerm "motif_N" ;
lin motile_A = mkTerm "motile_A" ;
lin motile_N = mkTerm "motile_N" ;
lin motilin_N = mkTerm "motilin_N" ;
lin motility_N = mkTerm "motility_N" ;
lin motion_N = mkTerm "motion_N" ;
lin motion_V = mkTerm "motion_V" ;
lin motion_V2 = mkTerm "motion_V2" ;
lin motional_A = mkTerm "motional_A" ;
lin motionless_A = mkTerm "motionless_A" ;
lin motionlessness_N = mkTerm "motionlessness_N" ;
lin motivate_V2 = mkTerm "motivate_V2" ;
lin motivate_V2V = mkTerm "motivate_V2V" ;
lin motivation_N = mkTerm "motivation_N" ;
lin motivational_A = mkTerm "motivational_A" ;
lin motive_A = mkTerm "motive_A" ;
lin motive_N = mkTerm "motive_N" ;
lin motiveless_A = mkTerm "motiveless_A" ;
lin motley_A = mkTerm "motley_A" ;
lin motley_N = mkTerm "motley_N" ;
lin motmot_N = mkTerm "motmot_N" ;
lin motor_N = mkTerm "motor_N" ;
lin motor_V = mkTerm "motor_V" ;
lin motor_assisted_A = mkTerm "motor_assisted_A" ;
lin motorbike_N = mkTerm "motorbike_N" ;
lin motorboat_N = mkTerm "motorboat_N" ;
lin motorcade_N = mkTerm "motorcade_N" ;
lin motorcar_N = mkTerm "motorcar_N" ;
lin motorcoach_N = mkTerm "motorcoach_N" ;
lin motorcycle_N = mkTerm "motorcycle_N" ;
lin motorcycling_N = mkTerm "motorcycling_N" ;
lin motorcyclist_N = mkTerm "motorcyclist_N" ;
lin motoring_N = mkTerm "motoring_N" ;
lin motorist_N = mkTerm "motorist_N" ;
lin motorization_N = mkTerm "motorization_N" ;
lin motorize_V2 = mkTerm "motorize_V2" ;
lin motorman_N = mkTerm "motorman_N" ;
lin motormouth_N = mkTerm "motormouth_N" ;
lin motorway_N = mkTerm "motorway_N" ;
lin mottle_N = mkTerm "mottle_N" ;
lin mottle_V2 = mkTerm "mottle_V2" ;
lin mottling_N = mkTerm "mottling_N" ;
lin motto_N = mkTerm "motto_N" ;
lin mouflon_N = mkTerm "mouflon_N" ;
lin mouhijärvi_PN = mkTerm "mouhijärvi_PN" ;
lin moujik_N = mkTerm "moujik_N" ;
lin mould_1_N = mkTerm "mould_1_N" ;
lin mould_2_N = mkTerm "mould_2_N" ;
lin mould_3_N = mkTerm "mould_3_N" ;
lin mould_V = mkTerm "mould_V" ;
lin mould_V2 = mkTerm "mould_V2" ;
lin moulder_V = mkTerm "moulder_V" ;
lin moulding_N = mkTerm "moulding_N" ;
lin mouldy_A = mkTerm "mouldy_A" ;
lin moult_N = mkTerm "moult_N" ;
lin moult_V = mkTerm "moult_V" ;
lin moult_V2 = mkTerm "moult_V2" ;
lin mound_N = mkTerm "mound_N" ;
lin mount_N = mkTerm "mount_N" ;
lin mount_V = mkTerm "mount_V" ;
lin mount_V2 = mkTerm "mount_V2" ;
lin mount_up_V = mkTerm "mount_up_V" ;
lin mountain_N = mkTerm "mountain_N" ;
lin mountain_ash_PN = mkTerm "mountain_ash_PN" ;
lin mountaineer_N = mkTerm "mountaineer_N" ;
lin mountaineering_N = mkTerm "mountaineering_N" ;
lin mountainous_A = mkTerm "mountainous_A" ;
lin mountainside_N = mkTerm "mountainside_N" ;
lin mountebank_N = mkTerm "mountebank_N" ;
lin mounter_N = mkTerm "mounter_N" ;
lin mountie_N = mkTerm "mountie_N" ;
lin mounting_N = mkTerm "mounting_N" ;
lin mourn_V = mkTerm "mourn_V" ;
lin mourn_V2 = mkTerm "mourn_V2" ;
lin mourner_N = mkTerm "mourner_N" ;
lin mournful_A = mkTerm "mournful_A" ;
lin mournfulness_N = mkTerm "mournfulness_N" ;
lin mourning_N = mkTerm "mourning_N" ;
lin mourning_band_N = mkTerm "mourning_band_N" ;
lin mourning_ring_N = mkTerm "mourning_ring_N" ;
lin mouse_N = mkTerm "mouse_N" ;
lin mouse_V = mkTerm "mouse_V" ;
lin mousepad_N = mkTerm "mousepad_N" ;
lin mouser_N = mkTerm "mouser_N" ;
lin mousetrap_N = mkTerm "mousetrap_N" ;
lin moussaka_N = mkTerm "moussaka_N" ;
lin mousse_N = mkTerm "mousse_N" ;
lin moustache_N = mkTerm "moustache_N" ;
lin mousy_A = mkTerm "mousy_A" ;
lin mouth_N = mkTerm "mouth_N" ;
lin mouth_V = mkTerm "mouth_V" ;
lin mouth_V2 = mkTerm "mouth_V2" ;
lin mouth_off_V = mkTerm "mouth_off_V" ;
lin mouth_organ_N = mkTerm "mouth_organ_N" ;
lin mouth_watering_A = mkTerm "mouth_watering_A" ;
lin mouthbreeder_N = mkTerm "mouthbreeder_N" ;
lin mouthful_N = mkTerm "mouthful_N" ;
lin mouthlike_A = mkTerm "mouthlike_A" ;
lin mouthpart_N = mkTerm "mouthpart_N" ;
lin mouthpiece_N = mkTerm "mouthpiece_N" ;
lin mouton_N = mkTerm "mouton_N" ;
lin movability_N = mkTerm "movability_N" ;
lin movable_A = mkTerm "movable_A" ;
lin move_1_V = mkTerm "move_1_V" ;
lin move_2_V = mkTerm "move_2_V" ;
lin move_N = mkTerm "move_N" ;
lin move_V2 = mkTerm "move_V2" ;
lin move_ahead_V = mkTerm "move_ahead_V" ;
lin move_along_V = mkTerm "move_along_V" ;
lin move_away_V = mkTerm "move_away_V" ;
lin move_away_from_V2 = mkTerm "move_away_from_V2" ;
lin move_down_V2 = mkTerm "move_down_V2" ;
lin move_in_V = mkTerm "move_in_V" ;
lin move_in_on_V2 = mkTerm "move_in_on_V2" ;
lin move_into_V2 = mkTerm "move_into_V2" ;
lin move_on_V = mkTerm "move_on_V" ;
lin move_on_V2 = mkTerm "move_on_V2" ;
lin move_out_V = mkTerm "move_out_V" ;
lin move_out_V2 = mkTerm "move_out_V2" ;
lin move_towards_V2 = mkTerm "move_towards_V2" ;
lin move_up_V = mkTerm "move_up_V" ;
lin move_up_V2 = mkTerm "move_up_V2" ;
lin movement_N = mkTerm "movement_N" ;
lin mover_N = mkTerm "mover_N" ;
lin movie_N = mkTerm "movie_N" ;
lin moviegoer_N = mkTerm "moviegoer_N" ;
lin moviemaking_N = mkTerm "moviemaking_N" ;
lin moving_A = mkTerm "moving_A" ;
lin mow_N = mkTerm "mow_N" ;
lin mow_V = mkTerm "mow_V" ;
lin mow_V2 = mkTerm "mow_V2" ;
lin mower_N = mkTerm "mower_N" ;
lin mown_A = mkTerm "mown_A" ;
lin mozambican_A = mkTerm "mozambican_A" ;
lin mozambican_N = mkTerm "mozambican_N" ;
lin mozambique_PN = mkTerm "mozambique_PN" ;
lin mozzarella_N = mkTerm "mozzarella_N" ;
lin mp_N = mkTerm "mp_N" ;
lin mpg_N = mkTerm "mpg_N" ;
lin mph_N = mkTerm "mph_N" ;
lin mr_PN = mkTerm "mr_PN" ;
lin mrs_PN = mkTerm "mrs_PN" ;
lin ms_N = mkTerm "ms_N" ;
lin ms_PN = mkTerm "ms_PN" ;
lin msasa_N = mkTerm "msasa_N" ;
lin msc_N = mkTerm "msc_N" ;
lin mt_PN = mkTerm "mt_PN" ;
lin mu_N = mkTerm "mu_N" ;
lin much_AdA = mkTerm "much_AdA" ;
lin much_Adv = mkTerm "much_Adv" ;
lin much_N = mkTerm "much_N" ;
lin muchness_N = mkTerm "muchness_N" ;
lin muciferous_A = mkTerm "muciferous_A" ;
lin mucilage_N = mkTerm "mucilage_N" ;
lin mucin_N = mkTerm "mucin_N" ;
lin mucinoid_A = mkTerm "mucinoid_A" ;
lin mucinous_A = mkTerm "mucinous_A" ;
lin muck_N = mkTerm "muck_N" ;
lin muck_V = mkTerm "muck_V" ;
lin muck_V2 = mkTerm "muck_V2" ;
lin muck_heap_N = mkTerm "muck_heap_N" ;
lin muckle_N = mkTerm "muckle_N" ;
lin muckraker_N = mkTerm "muckraker_N" ;
lin muckraking_N = mkTerm "muckraking_N" ;
lin mucky_A = mkTerm "mucky_A" ;
lin mucocutaneous_A = mkTerm "mucocutaneous_A" ;
lin mucoid_A = mkTerm "mucoid_A" ;
lin mucoid_N = mkTerm "mucoid_N" ;
lin mucopolysaccharide_N = mkTerm "mucopolysaccharide_N" ;
lin mucopolysaccharidosis_N = mkTerm "mucopolysaccharidosis_N" ;
lin mucopurulent_A = mkTerm "mucopurulent_A" ;
lin mucor_N = mkTerm "mucor_N" ;
lin mucosal_A = mkTerm "mucosal_A" ;
lin mucous_A = mkTerm "mucous_A" ;
lin mucuna_N = mkTerm "mucuna_N" ;
lin mucus_N = mkTerm "mucus_N" ;
lin mud_N = mkTerm "mud_N" ;
lin mud_V2 = mkTerm "mud_V2" ;
lin mud_bath_N = mkTerm "mud_bath_N" ;
lin mudder_N = mkTerm "mudder_N" ;
lin muddle_N = mkTerm "muddle_N" ;
lin muddle_V = mkTerm "muddle_V" ;
lin muddle_V2 = mkTerm "muddle_V2" ;
lin muddle_along_V = mkTerm "muddle_along_V" ;
lin muddle_headed_A = mkTerm "muddle_headed_A" ;
lin muddle_through_V = mkTerm "muddle_through_V" ;
lin muddle_up_V2 = mkTerm "muddle_up_V2" ;
lin muddy_A = mkTerm "muddy_A" ;
lin muddy_V2 = mkTerm "muddy_V2" ;
lin mudguard_N = mkTerm "mudguard_N" ;
lin mudhif_N = mkTerm "mudhif_N" ;
lin mudra_N = mkTerm "mudra_N" ;
lin mudskipper_N = mkTerm "mudskipper_N" ;
lin mudslide_N = mkTerm "mudslide_N" ;
lin mudslinger_N = mkTerm "mudslinger_N" ;
lin muesli_N = mkTerm "muesli_N" ;
lin muezzin_N = mkTerm "muezzin_N" ;
lin muff_N = mkTerm "muff_N" ;
lin muff_V2 = mkTerm "muff_V2" ;
lin muffin_N = mkTerm "muffin_N" ;
lin muffin_man_N = mkTerm "muffin_man_N" ;
lin muffle_N = mkTerm "muffle_N" ;
lin muffle_V2 = mkTerm "muffle_V2" ;
lin muffler_N = mkTerm "muffler_N" ;
lin mufti_N = mkTerm "mufti_N" ;
lin mug_N = mkTerm "mug_N" ;
lin mug_V2 = mkTerm "mug_V2" ;
lin mug_up_V = mkTerm "mug_up_V" ;
lin mug_up_on_V2 = mkTerm "mug_up_on_V2" ;
lin muggee_N = mkTerm "muggee_N" ;
lin mugger_N = mkTerm "mugger_N" ;
lin mugginess_N = mkTerm "mugginess_N" ;
lin mugging_N = mkTerm "mugging_N" ;
lin muggins_N = mkTerm "muggins_N" ;
lin muggy_A = mkTerm "muggy_A" ;
lin mugwort_N = mkTerm "mugwort_N" ;
lin mugwump_N = mkTerm "mugwump_N" ;
lin muhammad_PN = mkTerm "muhammad_PN" ;
lin muhammadan_A = mkTerm "muhammadan_A" ;
lin muhammadan_N = mkTerm "muhammadan_N" ;
lin muhammadanism_N = mkTerm "muhammadanism_N" ;
lin muhos_PN = mkTerm "muhos_PN" ;
lin muishond_N = mkTerm "muishond_N" ;
lin mujahid_N = mkTerm "mujahid_N" ;
lin mujahidin_N = mkTerm "mujahidin_N" ;
lin mujtihad_N = mkTerm "mujtihad_N" ;
lin mukataa_N = mkTerm "mukataa_N" ;
lin mukden_PN = mkTerm "mukden_PN" ;
lin mulatto_N = mkTerm "mulatto_N" ;
lin mulberry_N = mkTerm "mulberry_N" ;
lin mulch_N = mkTerm "mulch_N" ;
lin mulch_V2 = mkTerm "mulch_V2" ;
lin mulct_V2 = mkTerm "mulct_V2" ;
lin mule_N = mkTerm "mule_N" ;
lin mule_over_V2 = mkTerm "mule_over_V2" ;
lin muleteer_N = mkTerm "muleteer_N" ;
lin mulheim_PN = mkTerm "mulheim_PN" ;
lin mulhouse_PN = mkTerm "mulhouse_PN" ;
lin mulish_A = mkTerm "mulish_A" ;
lin mulishness_N = mkTerm "mulishness_N" ;
lin mull_N = mkTerm "mull_N" ;
lin mull_V2 = mkTerm "mull_V2" ;
lin mull_over_V2 = mkTerm "mull_over_V2" ;
lin mullah_N = mkTerm "mullah_N" ;
lin mullein_N = mkTerm "mullein_N" ;
lin muller_N = mkTerm "muller_N" ;
lin mullet_N = mkTerm "mullet_N" ;
lin mulligatawny_N = mkTerm "mulligatawny_N" ;
lin mullion_N = mkTerm "mullion_N" ;
lin mullioned_A = mkTerm "mullioned_A" ;
lin mulloway_N = mkTerm "mulloway_N" ;
lin multan_PN = mkTerm "multan_PN" ;
lin multi_ethnicity_N = mkTerm "multi_ethnicity_N" ;
lin multi_lingual_A = mkTerm "multi_lingual_A" ;
lin multia_PN = mkTerm "multia_PN" ;
lin multicellular_A = mkTerm "multicellular_A" ;
lin multicollinearity_N = mkTerm "multicollinearity_N" ;
lin multicultural_A = mkTerm "multicultural_A" ;
lin multiculturalism_N = mkTerm "multiculturalism_N" ;
lin multidimensional_A = mkTerm "multidimensional_A" ;
lin multiethnic_A = mkTerm "multiethnic_A" ;
lin multifactorial_A = mkTerm "multifactorial_A" ;
lin multifarious_A = mkTerm "multifarious_A" ;
lin multiflora_N = mkTerm "multiflora_N" ;
lin multiform_A = mkTerm "multiform_A" ;
lin multilane_A = mkTerm "multilane_A" ;
lin multilateral_A = mkTerm "multilateral_A" ;
lin multilevel_A = mkTerm "multilevel_A" ;
lin multimedia_N = mkTerm "multimedia_N" ;
lin multinational_A = mkTerm "multinational_A" ;
lin multinucleate_A = mkTerm "multinucleate_A" ;
lin multiparous_A = mkTerm "multiparous_A" ;
lin multipartite_A = mkTerm "multipartite_A" ;
lin multiphase_A = mkTerm "multiphase_A" ;
lin multiplayer_N = mkTerm "multiplayer_N" ;
lin multiple_A = mkTerm "multiple_A" ;
lin multiple_N = mkTerm "multiple_N" ;
lin multiplex_A = mkTerm "multiplex_A" ;
lin multiplex_N = mkTerm "multiplex_N" ;
lin multiplexer_N = mkTerm "multiplexer_N" ;
lin multiplicand_N = mkTerm "multiplicand_N" ;
lin multiplication_N = mkTerm "multiplication_N" ;
lin multiplicative_A = mkTerm "multiplicative_A" ;
lin multiplicity_N = mkTerm "multiplicity_N" ;
lin multiplier_N = mkTerm "multiplier_N" ;
lin multiply_V = mkTerm "multiply_V" ;
lin multiply_V2 = mkTerm "multiply_V2" ;
lin multipotent_A = mkTerm "multipotent_A" ;
lin multiprocessing_N = mkTerm "multiprocessing_N" ;
lin multiprocessor_N = mkTerm "multiprocessor_N" ;
lin multiprogramming_N = mkTerm "multiprogramming_N" ;
lin multipurpose_A = mkTerm "multipurpose_A" ;
lin multiracial_A = mkTerm "multiracial_A" ;
lin multistage_N = mkTerm "multistage_N" ;
lin multistory_A = mkTerm "multistory_A" ;
lin multitude_N = mkTerm "multitude_N" ;
lin multitudinous_A = mkTerm "multitudinous_A" ;
lin multitudinousness_N = mkTerm "multitudinousness_N" ;
lin multivalent_A = mkTerm "multivalent_A" ;
lin multivariate_A = mkTerm "multivariate_A" ;
lin multiversity_N = mkTerm "multiversity_N" ;
lin multivitamin_N = mkTerm "multivitamin_N" ;
lin multum_in_parvo_N = mkTerm "multum_in_parvo_N" ;
lin mum_A = mkTerm "mum_A" ;
lin mum_N = mkTerm "mum_N" ;
lin mumble_N = mkTerm "mumble_N" ;
lin mumble_V = mkTerm "mumble_V" ;
lin mumble_V2 = mkTerm "mumble_V2" ;
lin mumbling_N = mkTerm "mumbling_N" ;
lin mumbo_jumbo_N = mkTerm "mumbo_jumbo_N" ;
lin mummer_N = mkTerm "mummer_N" ;
lin mummery_N = mkTerm "mummery_N" ;
lin mummichog_N = mkTerm "mummichog_N" ;
lin mummification_N = mkTerm "mummification_N" ;
lin mummify_V2 = mkTerm "mummify_V2" ;
lin mummy_N = mkTerm "mummy_N" ;
lin mumps_N = mkTerm "mumps_N" ;
lin mumpsimus_N = mkTerm "mumpsimus_N" ;
lin munch_N = mkTerm "munch_N" ;
lin munch_V = mkTerm "munch_V" ;
lin munch_V2 = mkTerm "munch_V2" ;
lin muncher_N = mkTerm "muncher_N" ;
lin mundane_A = mkTerm "mundane_A" ;
lin mung_N = mkTerm "mung_N" ;
lin munich_PN = mkTerm "munich_PN" ;
lin municipal_A = mkTerm "municipal_A" ;
lin municipality_N = mkTerm "municipality_N" ;
lin munificence_N = mkTerm "munificence_N" ;
lin munificent_A = mkTerm "munificent_A" ;
lin muniments_N = mkTerm "muniments_N" ;
lin munition_N = mkTerm "munition_N" ;
lin munition_V2 = mkTerm "munition_V2" ;
lin munj_N = mkTerm "munj_N" ;
lin munster_PN = mkTerm "munster_PN" ;
lin muntjac_N = mkTerm "muntjac_N" ;
lin muon_N = mkTerm "muon_N" ;
lin muonio_PN = mkTerm "muonio_PN" ;
lin mural_A = mkTerm "mural_A" ;
lin mural_N = mkTerm "mural_N" ;
lin muralist_N = mkTerm "muralist_N" ;
lin murder_N = mkTerm "murder_N" ;
lin murder_V2 = mkTerm "murder_V2" ;
lin murderee_N = mkTerm "murderee_N" ;
lin murderer_N = mkTerm "murderer_N" ;
lin murderess_N = mkTerm "murderess_N" ;
lin murderous_A = mkTerm "murderous_A" ;
lin murderousness_N = mkTerm "murderousness_N" ;
lin muriel_PN = mkTerm "muriel_PN" ;
lin murine_A = mkTerm "murine_A" ;
lin murine_N = mkTerm "murine_N" ;
lin murk_N = mkTerm "murk_N" ;
lin murky_A = mkTerm "murky_A" ;
lin murmur_N = mkTerm "murmur_N" ;
lin murmur_V = mkTerm "murmur_V" ;
lin murmur_V2 = mkTerm "murmur_V2" ;
lin murmurous_A = mkTerm "murmurous_A" ;
lin murphy_N = mkTerm "murphy_N" ;
lin murrain_N = mkTerm "murrain_N" ;
lin murre_N = mkTerm "murre_N" ;
lin murton_PN = mkTerm "murton_PN" ;
lin muscadine_N = mkTerm "muscadine_N" ;
lin muscat_N = mkTerm "muscat_N" ;
lin muscatel_N = mkTerm "muscatel_N" ;
lin muscle_N = mkTerm "muscle_N" ;
lin muscle_V = mkTerm "muscle_V" ;
lin muscle_V2 = mkTerm "muscle_V2" ;
lin muscle_bound_A = mkTerm "muscle_bound_A" ;
lin muscle_in_V = mkTerm "muscle_in_V" ;
lin muscle_in_on_V2 = mkTerm "muscle_in_on_V2" ;
lin muscle_into_V2 = mkTerm "muscle_into_V2" ;
lin muscle_out_V2 = mkTerm "muscle_out_V2" ;
lin muscleman_N = mkTerm "muscleman_N" ;
lin muscovite_A = mkTerm "muscovite_A" ;
lin muscovite_N = mkTerm "muscovite_N" ;
lin muscovy_N = mkTerm "muscovy_N" ;
lin muscular_A = mkTerm "muscular_A" ;
lin muscularity_N = mkTerm "muscularity_N" ;
lin musculoskeletal_A = mkTerm "musculoskeletal_A" ;
lin muse_N = mkTerm "muse_N" ;
lin muse_V = mkTerm "muse_V" ;
lin muse_VS = mkTerm "muse_VS" ;
lin muser_N = mkTerm "muser_N" ;
lin musette_N = mkTerm "musette_N" ;
lin museum_N = mkTerm "museum_N" ;
lin mush_N = mkTerm "mush_N" ;
lin musher_N = mkTerm "musher_N" ;
lin mushiness_N = mkTerm "mushiness_N" ;
lin mushroom_N = mkTerm "mushroom_N" ;
lin mushroom_V = mkTerm "mushroom_V" ;
lin mushy_A = mkTerm "mushy_A" ;
lin music_N = mkTerm "music_N" ;
lin music_box_N = mkTerm "music_box_N" ;
lin music_hall_N = mkTerm "music_hall_N" ;
lin music_stand_N = mkTerm "music_stand_N" ;
lin music_stool_N = mkTerm "music_stool_N" ;
lin musical_A = mkTerm "musical_A" ;
lin musical_N = mkTerm "musical_N" ;
lin musical_box_N = mkTerm "musical_box_N" ;
lin musicality_N = mkTerm "musicality_N" ;
lin musicianFem_N = mkTerm "musicianFem_N" ;
lin musicianMasc_N = mkTerm "musicianMasc_N" ;
lin musicianship_N = mkTerm "musicianship_N" ;
lin musicological_A = mkTerm "musicological_A" ;
lin musicologist_N = mkTerm "musicologist_N" ;
lin musicology_N = mkTerm "musicology_N" ;
lin musingly_Adv = mkTerm "musingly_Adv" ;
lin musk_N = mkTerm "musk_N" ;
lin musk_deer_N = mkTerm "musk_deer_N" ;
lin musk_rose_N = mkTerm "musk_rose_N" ;
lin muskellunge_N = mkTerm "muskellunge_N" ;
lin musket_N = mkTerm "musket_N" ;
lin musketeer_N = mkTerm "musketeer_N" ;
lin musketry_N = mkTerm "musketry_N" ;
lin muskiness_N = mkTerm "muskiness_N" ;
lin muskmelon_N = mkTerm "muskmelon_N" ;
lin muskrat_N = mkTerm "muskrat_N" ;
lin muskwood_N = mkTerm "muskwood_N" ;
lin musky_A = mkTerm "musky_A" ;
lin muslim_A = mkTerm "muslim_A" ;
lin muslim_N = mkTerm "muslim_N" ;
lin muslin_N = mkTerm "muslin_N" ;
lin musnud_N = mkTerm "musnud_N" ;
lin musophobia_N = mkTerm "musophobia_N" ;
lin musquash_N = mkTerm "musquash_N" ;
lin muss_N = mkTerm "muss_N" ;
lin muss_V2 = mkTerm "muss_V2" ;
lin mussel_N = mkTerm "mussel_N" ;
lin musselburgh_PN = mkTerm "musselburgh_PN" ;
lin must_N = mkTerm "must_N" ;
lin mustache_N = mkTerm "mustache_N" ;
lin mustachio_N = mkTerm "mustachio_N" ;
lin mustachioed_A = mkTerm "mustachioed_A" ;
lin mustang_N = mkTerm "mustang_N" ;
lin mustard_N = mkTerm "mustard_N" ;
lin muster_N = mkTerm "muster_N" ;
lin muster_V = mkTerm "muster_V" ;
lin muster_V2 = mkTerm "muster_V2" ;
lin musth_N = mkTerm "musth_N" ;
lin mustiness_N = mkTerm "mustiness_N" ;
lin musty_A = mkTerm "musty_A" ;
lin mutability_N = mkTerm "mutability_N" ;
lin mutable_A = mkTerm "mutable_A" ;
lin mutafacient_A = mkTerm "mutafacient_A" ;
lin mutagen_N = mkTerm "mutagen_N" ;
lin mutagenesis_N = mkTerm "mutagenesis_N" ;
lin mutagenic_A = mkTerm "mutagenic_A" ;
lin mutant_A = mkTerm "mutant_A" ;
lin mutant_N = mkTerm "mutant_N" ;
lin mutation_N = mkTerm "mutation_N" ;
lin mutational_A = mkTerm "mutational_A" ;
lin mutatis_mutandis_Adv = mkTerm "mutatis_mutandis_Adv" ;
lin mutative_A = mkTerm "mutative_A" ;
lin mutchkin_N = mkTerm "mutchkin_N" ;
lin mute_A = mkTerm "mute_A" ;
lin mute_N = mkTerm "mute_N" ;
lin mute_V2 = mkTerm "mute_V2" ;
lin muteness_N = mkTerm "muteness_N" ;
lin mutilate_V = mkTerm "mutilate_V" ;
lin mutilate_V2 = mkTerm "mutilate_V2" ;
lin mutilation_N = mkTerm "mutilation_N" ;
lin mutilator_N = mkTerm "mutilator_N" ;
lin mutineer_N = mkTerm "mutineer_N" ;
lin mutinous_A = mkTerm "mutinous_A" ;
lin mutiny_N = mkTerm "mutiny_N" ;
lin mutiny_V = mkTerm "mutiny_V" ;
lin mutisia_N = mkTerm "mutisia_N" ;
lin mutism_N = mkTerm "mutism_N" ;
lin muton_N = mkTerm "muton_N" ;
lin mutt_N = mkTerm "mutt_N" ;
lin mutter_N = mkTerm "mutter_N" ;
lin mutter_V = mkTerm "mutter_V" ;
lin mutter_V2 = mkTerm "mutter_V2" ;
lin mutterer_N = mkTerm "mutterer_N" ;
lin mutton_N = mkTerm "mutton_N" ;
lin mutton_head_N = mkTerm "mutton_head_N" ;
lin mutual_A = mkTerm "mutual_A" ;
lin mutuality_N = mkTerm "mutuality_N" ;
lin muurame_PN = mkTerm "muurame_PN" ;
lin muurla_PN = mkTerm "muurla_PN" ;
lin muzzle_N = mkTerm "muzzle_N" ;
lin muzzle_V2 = mkTerm "muzzle_V2" ;
lin muzzle_velocity_N = mkTerm "muzzle_velocity_N" ;
lin muzzler_N = mkTerm "muzzler_N" ;
lin muzzy_A = mkTerm "muzzy_A" ;
lin myalgia_N = mkTerm "myalgia_N" ;
lin myalgic_A = mkTerm "myalgic_A" ;
lin myasthenia_N = mkTerm "myasthenia_N" ;
lin mycelium_N = mkTerm "mycelium_N" ;
lin mycobacteria_N = mkTerm "mycobacteria_N" ;
lin mycologist_N = mkTerm "mycologist_N" ;
lin mycology_N = mkTerm "mycology_N" ;
lin mycomycin_N = mkTerm "mycomycin_N" ;
lin mycophagist_N = mkTerm "mycophagist_N" ;
lin mycophagy_N = mkTerm "mycophagy_N" ;
lin mycoplasma_N = mkTerm "mycoplasma_N" ;
lin mycotoxin_N = mkTerm "mycotoxin_N" ;
lin mydriasis_N = mkTerm "mydriasis_N" ;
lin mydriatic_N = mkTerm "mydriatic_N" ;
lin myelatelia_N = mkTerm "myelatelia_N" ;
lin myelencephalon_N = mkTerm "myelencephalon_N" ;
lin myelic_A = mkTerm "myelic_A" ;
lin myelin_N = mkTerm "myelin_N" ;
lin myelinated_A = mkTerm "myelinated_A" ;
lin myelinic_A = mkTerm "myelinic_A" ;
lin myelinization_N = mkTerm "myelinization_N" ;
lin myelitis_N = mkTerm "myelitis_N" ;
lin myeloblast_N = mkTerm "myeloblast_N" ;
lin myelocyte_N = mkTerm "myelocyte_N" ;
lin myelofibrosis_N = mkTerm "myelofibrosis_N" ;
lin myelogram_N = mkTerm "myelogram_N" ;
lin myelography_N = mkTerm "myelography_N" ;
lin myeloid_A = mkTerm "myeloid_A" ;
lin myeloma_N = mkTerm "myeloma_N" ;
lin myelomeningocele_N = mkTerm "myelomeningocele_N" ;
lin myiasis_N = mkTerm "myiasis_N" ;
lin mylodon_N = mkTerm "mylodon_N" ;
lin mylodontid_N = mkTerm "mylodontid_N" ;
lin myna_N = mkTerm "myna_N" ;
lin mynämäki_PN = mkTerm "mynämäki_PN" ;
lin myocardial_A = mkTerm "myocardial_A" ;
lin myocardium_N = mkTerm "myocardium_N" ;
lin myoclonus_N = mkTerm "myoclonus_N" ;
lin myofibril_N = mkTerm "myofibril_N" ;
lin myoglobin_N = mkTerm "myoglobin_N" ;
lin myoglobinuria_N = mkTerm "myoglobinuria_N" ;
lin myogram_N = mkTerm "myogram_N" ;
lin myoid_A = mkTerm "myoid_A" ;
lin myology_N = mkTerm "myology_N" ;
lin myoma_N = mkTerm "myoma_N" ;
lin myometritis_N = mkTerm "myometritis_N" ;
lin myometrium_N = mkTerm "myometrium_N" ;
lin myonecrosis_N = mkTerm "myonecrosis_N" ;
lin myopathic_A = mkTerm "myopathic_A" ;
lin myopathy_N = mkTerm "myopathy_N" ;
lin myope_N = mkTerm "myope_N" ;
lin myopia_N = mkTerm "myopia_N" ;
lin myopic_A = mkTerm "myopic_A" ;
lin myosarcoma_N = mkTerm "myosarcoma_N" ;
lin myosin_N = mkTerm "myosin_N" ;
lin myositis_N = mkTerm "myositis_N" ;
lin myotomy_N = mkTerm "myotomy_N" ;
lin myotonia_N = mkTerm "myotonia_N" ;
lin myotonic_A = mkTerm "myotonic_A" ;
lin myra_PN = mkTerm "myra_PN" ;
lin myriad_A = mkTerm "myriad_A" ;
lin myriad_N = mkTerm "myriad_N" ;
lin myriagram_N = mkTerm "myriagram_N" ;
lin myriameter_N = mkTerm "myriameter_N" ;
lin myriapod_N = mkTerm "myriapod_N" ;
lin myringectomy_N = mkTerm "myringectomy_N" ;
lin myringoplasty_N = mkTerm "myringoplasty_N" ;
lin myringotomy_N = mkTerm "myringotomy_N" ;
lin myrmecophagous_A = mkTerm "myrmecophagous_A" ;
lin myrmecophile_N = mkTerm "myrmecophile_N" ;
lin myrmecophilous_A = mkTerm "myrmecophilous_A" ;
lin myrmecophyte_N = mkTerm "myrmecophyte_N" ;
lin myrmecophytic_A = mkTerm "myrmecophytic_A" ;
lin myrmidon_N = mkTerm "myrmidon_N" ;
lin myrrh_N = mkTerm "myrrh_N" ;
lin myrskylä_PN = mkTerm "myrskylä_PN" ;
lin myrtle_N = mkTerm "myrtle_N" ;
lin mysophilia_N = mkTerm "mysophilia_N" ;
lin mysophobia_N = mkTerm "mysophobia_N" ;
lin mysophobic_A = mkTerm "mysophobic_A" ;
lin myspace_N = mkTerm "myspace_N" ;
lin mysterious_A = mkTerm "mysterious_A" ;
lin mystery_N = mkTerm "mystery_N" ;
lin mysticFem_N = mkTerm "mysticFem_N" ;
lin mysticMasc_N = mkTerm "mysticMasc_N" ;
lin mystic_A = mkTerm "mystic_A" ;
lin mystical_A = mkTerm "mystical_A" ;
lin mysticism_N = mkTerm "mysticism_N" ;
lin mystification_N = mkTerm "mystification_N" ;
lin mystify_V2 = mkTerm "mystify_V2" ;
lin mystique_N = mkTerm "mystique_N" ;
lin myth_N = mkTerm "myth_N" ;
lin mythic_A = mkTerm "mythic_A" ;
lin mythical_A = mkTerm "mythical_A" ;
lin mythological_A = mkTerm "mythological_A" ;
lin mythologist_N = mkTerm "mythologist_N" ;
lin mythologization_N = mkTerm "mythologization_N" ;
lin mythology_N = mkTerm "mythology_N" ;
lin myxedema_N = mkTerm "myxedema_N" ;
lin myxobacteria_N = mkTerm "myxobacteria_N" ;
lin myxoma_N = mkTerm "myxoma_N" ;
lin myxomatosis_N = mkTerm "myxomatosis_N" ;
lin myxosporidian_N = mkTerm "myxosporidian_N" ;
lin myxovirus_N = mkTerm "myxovirus_N" ;
lin mäntsälä_PN = mkTerm "mäntsälä_PN" ;
lin mänttä_PN = mkTerm "mänttä_PN" ;
lin mäntyharju_PN = mkTerm "mäntyharju_PN" ;
lin naafi_N = mkTerm "naafi_N" ;
lin naantali_PN = mkTerm "naantali_PN" ;
lin nab_V2 = mkTerm "nab_V2" ;
lin nabob_N = mkTerm "nabob_N" ;
lin naboom_N = mkTerm "naboom_N" ;
lin nabumetone_N = mkTerm "nabumetone_N" ;
lin nacelle_N = mkTerm "nacelle_N" ;
lin nacho_N = mkTerm "nacho_N" ;
lin nacre_N = mkTerm "nacre_N" ;
lin nacreous_A = mkTerm "nacreous_A" ;
lin nadir_N = mkTerm "nadir_N" ;
lin nadolol_N = mkTerm "nadolol_N" ;
lin nae_Interj = mkTerm "nae_Interj" ;
lin nafcillin_N = mkTerm "nafcillin_N" ;
lin naff_off_V = mkTerm "naff_off_V" ;
lin nag_N = mkTerm "nag_N" ;
lin nag_V = mkTerm "nag_V" ;
lin nag_V2 = mkTerm "nag_V2" ;
lin nag_at_V2 = mkTerm "nag_at_V2" ;
lin nagami_N = mkTerm "nagami_N" ;
lin nagger_N = mkTerm "nagger_N" ;
lin nagi_N = mkTerm "nagi_N" ;
lin nagoya_PN = mkTerm "nagoya_PN" ;
lin nagpur_PN = mkTerm "nagpur_PN" ;
lin nagu_PN = mkTerm "nagu_PN" ;
lin naiad_N = mkTerm "naiad_N" ;
lin naiant_A = mkTerm "naiant_A" ;
lin naif_N = mkTerm "naif_N" ;
lin nail_N = mkTerm "nail_N" ;
lin nail_V2 = mkTerm "nail_V2" ;
lin nail_down_V2 = mkTerm "nail_down_V2" ;
lin nail_polish_N = mkTerm "nail_polish_N" ;
lin nail_varnish_N = mkTerm "nail_varnish_N" ;
lin nailbrush_N = mkTerm "nailbrush_N" ;
lin nailer_N = mkTerm "nailer_N" ;
lin nailfile_N = mkTerm "nailfile_N" ;
lin nailhead_N = mkTerm "nailhead_N" ;
lin nailsea_PN = mkTerm "nailsea_PN" ;
lin nainsook_N = mkTerm "nainsook_N" ;
lin naira_N = mkTerm "naira_N" ;
lin nairn_PN = mkTerm "nairn_PN" ;
lin nairobi_PN = mkTerm "nairobi_PN" ;
lin naive_A = mkTerm "naive_A" ;
lin naivete_N = mkTerm "naivete_N" ;
lin naivety_N = mkTerm "naivety_N" ;
lin naked_A = mkTerm "naked_A" ;
lin nakedness_N = mkTerm "nakedness_N" ;
lin nakedwood_N = mkTerm "nakedwood_N" ;
lin nakkila_PN = mkTerm "nakkila_PN" ;
lin nalorphine_N = mkTerm "nalorphine_N" ;
lin naloxone_N = mkTerm "naloxone_N" ;
lin naltrexone_N = mkTerm "naltrexone_N" ;
lin namby_pamby_A = mkTerm "namby_pamby_A" ;
lin namby_pamby_N = mkTerm "namby_pamby_N" ;
lin name_N = mkTerm "name_N" ;
lin name_V2 = mkTerm "name_V2" ;
lin name_V3 = mkTerm "name_V3" ;
lin name_after_V3 = mkTerm "name_after_V3" ;
lin name_day_N = mkTerm "name_day_N" ;
lin name_drop_V = mkTerm "name_drop_V" ;
lin name_dropping_N = mkTerm "name_dropping_N" ;
lin name_part_N = mkTerm "name_part_N" ;
lin nameko_N = mkTerm "nameko_N" ;
lin nameless_A = mkTerm "nameless_A" ;
lin namely_Adv = mkTerm "namely_Adv" ;
lin nameplate_N = mkTerm "nameplate_N" ;
lin namer_N = mkTerm "namer_N" ;
lin namesake_N = mkTerm "namesake_N" ;
lin namibia_PN = mkTerm "namibia_PN" ;
lin namibianFem_N = mkTerm "namibianFem_N" ;
lin namibianMasc_N = mkTerm "namibianMasc_N" ;
lin namibian_A = mkTerm "namibian_A" ;
lin naming_N = mkTerm "naming_N" ;
lin nan_N = mkTerm "nan_N" ;
lin nanchang_PN = mkTerm "nanchang_PN" ;
lin nancy_PN = mkTerm "nancy_PN" ;
lin nandrolone_N = mkTerm "nandrolone_N" ;
lin nankeen_N = mkTerm "nankeen_N" ;
lin nanking_PN = mkTerm "nanking_PN" ;
lin nanning_PN = mkTerm "nanning_PN" ;
lin nanny_N = mkTerm "nanny_N" ;
lin nanny_goat_N = mkTerm "nanny_goat_N" ;
lin nanogram_N = mkTerm "nanogram_N" ;
lin nanometer_N = mkTerm "nanometer_N" ;
lin nanomia_N = mkTerm "nanomia_N" ;
lin nanophthalmos_N = mkTerm "nanophthalmos_N" ;
lin nanosecond_N = mkTerm "nanosecond_N" ;
lin nanotechnology_N = mkTerm "nanotechnology_N" ;
lin nanovolt_N = mkTerm "nanovolt_N" ;
lin nantwich_PN = mkTerm "nantwich_PN" ;
lin naomi_PN = mkTerm "naomi_PN" ;
lin nap_N = mkTerm "nap_N" ;
lin nap_V = mkTerm "nap_V" ;
lin napalm_N = mkTerm "napalm_N" ;
lin nape_N = mkTerm "nape_N" ;
lin napery_N = mkTerm "napery_N" ;
lin naphazoline_N = mkTerm "naphazoline_N" ;
lin naphtha_N = mkTerm "naphtha_N" ;
lin naphthalene_N = mkTerm "naphthalene_N" ;
lin naphthol_N = mkTerm "naphthol_N" ;
lin napkin_N = mkTerm "napkin_N" ;
lin napkin_ring_N = mkTerm "napkin_ring_N" ;
lin naples_PN = mkTerm "naples_PN" ;
lin napoleon_N = mkTerm "napoleon_N" ;
lin napoleonic_A = mkTerm "napoleonic_A" ;
lin napoli_PN = mkTerm "napoli_PN" ;
lin nappy_N = mkTerm "nappy_N" ;
lin naprapath_N = mkTerm "naprapath_N" ;
lin naprapathy_N = mkTerm "naprapathy_N" ;
lin naproxen_N = mkTerm "naproxen_N" ;
lin napu_N = mkTerm "napu_N" ;
lin naranjilla_N = mkTerm "naranjilla_N" ;
lin narborough_PN = mkTerm "narborough_PN" ;
lin narc_N = mkTerm "narc_N" ;
lin narcissism_N = mkTerm "narcissism_N" ;
lin narcissist_N = mkTerm "narcissist_N" ;
lin narcissus_N = mkTerm "narcissus_N" ;
lin narcolepsy_N = mkTerm "narcolepsy_N" ;
lin narcoleptic_A = mkTerm "narcoleptic_A" ;
lin narcoleptic_N = mkTerm "narcoleptic_N" ;
lin narcosis_N = mkTerm "narcosis_N" ;
lin narcoterrorism_N = mkTerm "narcoterrorism_N" ;
lin narcotic_A = mkTerm "narcotic_A" ;
lin narcotic_N = mkTerm "narcotic_N" ;
lin nard_N = mkTerm "nard_N" ;
lin nardoo_N = mkTerm "nardoo_N" ;
lin narial_A = mkTerm "narial_A" ;
lin naris_N = mkTerm "naris_N" ;
lin nark_N = mkTerm "nark_N" ;
lin nark_V2 = mkTerm "nark_V2" ;
lin narrate_V2 = mkTerm "narrate_V2" ;
lin narration_N = mkTerm "narration_N" ;
lin narrative_A = mkTerm "narrative_A" ;
lin narrative_N = mkTerm "narrative_N" ;
lin narrator_N = mkTerm "narrator_N" ;
lin narrow_A = mkTerm "narrow_A" ;
lin narrow_N = mkTerm "narrow_N" ;
lin narrow_V = mkTerm "narrow_V" ;
lin narrow_V2 = mkTerm "narrow_V2" ;
lin narrow_down_V2 = mkTerm "narrow_down_V2" ;
lin narrow_minded_A = mkTerm "narrow_minded_A" ;
lin narrow_mindedness_N = mkTerm "narrow_mindedness_N" ;
lin narrowing_N = mkTerm "narrowing_N" ;
lin narrowness_N = mkTerm "narrowness_N" ;
lin narthex_N = mkTerm "narthex_N" ;
lin narwhal_N = mkTerm "narwhal_N" ;
lin nary_Predet = mkTerm "nary_Predet" ;
lin nasa_PN = mkTerm "nasa_PN" ;
lin nasal_A = mkTerm "nasal_A" ;
lin nasal_N = mkTerm "nasal_N" ;
lin nasality_N = mkTerm "nasality_N" ;
lin nasalization_N = mkTerm "nasalization_N" ;
lin nasalize_V2 = mkTerm "nasalize_V2" ;
lin nascent_A = mkTerm "nascent_A" ;
lin nasion_N = mkTerm "nasion_N" ;
lin nasopharyngeal_A = mkTerm "nasopharyngeal_A" ;
lin nasopharynx_N = mkTerm "nasopharynx_N" ;
lin nastiness_N = mkTerm "nastiness_N" ;
lin nastola_PN = mkTerm "nastola_PN" ;
lin nasturtium_N = mkTerm "nasturtium_N" ;
lin nasty_A = mkTerm "nasty_A" ;
lin nat_PN = mkTerm "nat_PN" ;
lin natal_A = mkTerm "natal_A" ;
lin natalie_PN = mkTerm "natalie_PN" ;
lin nathaniel_PN = mkTerm "nathaniel_PN" ;
lin nation_N = mkTerm "nation_N" ;
lin national_A = mkTerm "national_A" ;
lin national_N = mkTerm "national_N" ;
lin nationalism_N = mkTerm "nationalism_N" ;
lin nationalist_A = mkTerm "nationalist_A" ;
lin nationalist_N = mkTerm "nationalist_N" ;
lin nationalistic_A = mkTerm "nationalistic_A" ;
lin nationality_N = mkTerm "nationality_N" ;
lin nationalization_N = mkTerm "nationalization_N" ;
lin nationalize_V2 = mkTerm "nationalize_V2" ;
lin nationhood_N = mkTerm "nationhood_N" ;
lin nationwide_A = mkTerm "nationwide_A" ;
lin nationwide_Adv = mkTerm "nationwide_Adv" ;
lin native_A = mkTerm "native_A" ;
lin native_N = mkTerm "native_N" ;
lin nativeness_N = mkTerm "nativeness_N" ;
lin nativism_N = mkTerm "nativism_N" ;
lin nativist_A = mkTerm "nativist_A" ;
lin nativist_N = mkTerm "nativist_N" ;
lin nativity_N = mkTerm "nativity_N" ;
lin nato_PN = mkTerm "nato_PN" ;
lin natriuresis_N = mkTerm "natriuresis_N" ;
lin natriuretic_A = mkTerm "natriuretic_A" ;
lin natrolite_N = mkTerm "natrolite_N" ;
lin natter_V = mkTerm "natter_V" ;
lin natterjack_N = mkTerm "natterjack_N" ;
lin natty_A = mkTerm "natty_A" ;
lin natural_A = mkTerm "natural_A" ;
lin natural_N = mkTerm "natural_N" ;
lin naturalism_N = mkTerm "naturalism_N" ;
lin naturalist_N = mkTerm "naturalist_N" ;
lin naturalistic_A = mkTerm "naturalistic_A" ;
lin naturalization_N = mkTerm "naturalization_N" ;
lin naturalize_V = mkTerm "naturalize_V" ;
lin naturalize_V2 = mkTerm "naturalize_V2" ;
lin naturalness_N = mkTerm "naturalness_N" ;
lin nature_N = mkTerm "nature_N" ;
lin naturism_N = mkTerm "naturism_N" ;
lin naturist_N = mkTerm "naturist_N" ;
lin naturistic_A = mkTerm "naturistic_A" ;
lin naturopath_N = mkTerm "naturopath_N" ;
lin naturopathy_N = mkTerm "naturopathy_N" ;
lin naught_N = mkTerm "naught_N" ;
lin naughtiness_N = mkTerm "naughtiness_N" ;
lin naughty_A = mkTerm "naughty_A" ;
lin naumachy_N = mkTerm "naumachy_N" ;
lin nauru_PN = mkTerm "nauru_PN" ;
lin nauruan_A = mkTerm "nauruan_A" ;
lin nauruan_N = mkTerm "nauruan_N" ;
lin nausea_N = mkTerm "nausea_N" ;
lin nauseate_V2 = mkTerm "nauseate_V2" ;
lin nauseating_A = mkTerm "nauseating_A" ;
lin nauseous_A = mkTerm "nauseous_A" ;
lin nautch_N = mkTerm "nautch_N" ;
lin nautch_girl_N = mkTerm "nautch_girl_N" ;
lin nautical_A = mkTerm "nautical_A" ;
lin nautilus_N = mkTerm "nautilus_N" ;
lin naval_A = mkTerm "naval_A" ;
lin nave_N = mkTerm "nave_N" ;
lin navel_N = mkTerm "navel_N" ;
lin navicular_A = mkTerm "navicular_A" ;
lin navigability_N = mkTerm "navigability_N" ;
lin navigable_A = mkTerm "navigable_A" ;
lin navigate_V = mkTerm "navigate_V" ;
lin navigate_V2 = mkTerm "navigate_V2" ;
lin navigation_N = mkTerm "navigation_N" ;
lin navigational_A = mkTerm "navigational_A" ;
lin navigator_N = mkTerm "navigator_N" ;
lin navvy_N = mkTerm "navvy_N" ;
lin navy_N = mkTerm "navy_N" ;
lin nawab_N = mkTerm "nawab_N" ;
lin nay_Adv = mkTerm "nay_Adv" ;
lin nay_N = mkTerm "nay_N" ;
lin naysay_V2 = mkTerm "naysay_V2" ;
lin naysayer_N = mkTerm "naysayer_N" ;
lin naysaying_N = mkTerm "naysaying_N" ;
lin nazi_A = mkTerm "nazi_A" ;
lin nazi_N = mkTerm "nazi_N" ;
lin nazism_N = mkTerm "nazism_N" ;
lin nb_PN = mkTerm "nb_PN" ;
lin nco_N = mkTerm "nco_N" ;
lin ne'er_Adv = mkTerm "ne'er_Adv" ;
lin ne'er_do_well_N = mkTerm "ne'er_do_well_N" ;
lin ne_plus_ultra_N = mkTerm "ne_plus_ultra_N" ;
lin neanderthal_A = mkTerm "neanderthal_A" ;
lin neap_N = mkTerm "neap_N" ;
lin neap_tide_N = mkTerm "neap_tide_N" ;
lin neapolitan_A = mkTerm "neapolitan_A" ;
lin neapolitan_N = mkTerm "neapolitan_N" ;
lin near_A = mkTerm "near_A" ;
lin near_Adv = mkTerm "near_Adv" ;
lin near_Prep = mkTerm "near_Prep" ;
lin near_V = mkTerm "near_V" ;
lin near_V2 = mkTerm "near_V2" ;
lin near_sighted_A = mkTerm "near_sighted_A" ;
lin near_to_Prep = mkTerm "near_to_Prep" ;
lin nearby_A = mkTerm "nearby_A" ;
lin nearby_Adv = mkTerm "nearby_Adv" ;
lin nearer_Adv = mkTerm "nearer_Adv" ;
lin nearer_Prep = mkTerm "nearer_Prep" ;
lin nearest_Adv = mkTerm "nearest_Adv" ;
lin nearest_Prep = mkTerm "nearest_Prep" ;
lin nearly_Adv = mkTerm "nearly_Adv" ;
lin nearness_N = mkTerm "nearness_N" ;
lin nearside_N = mkTerm "nearside_N" ;
lin neat_A = mkTerm "neat_A" ;
lin neath_PN = mkTerm "neath_PN" ;
lin neatness_N = mkTerm "neatness_N" ;
lin nebbish_N = mkTerm "nebbish_N" ;
lin nebraska_PN = mkTerm "nebraska_PN" ;
lin nebuchadnezzar_N = mkTerm "nebuchadnezzar_N" ;
lin nebula_N = mkTerm "nebula_N" ;
lin nebular_A = mkTerm "nebular_A" ;
lin nebule_N = mkTerm "nebule_N" ;
lin nebulous_A = mkTerm "nebulous_A" ;
lin necessary_A = mkTerm "necessary_A" ;
lin necessary_N = mkTerm "necessary_N" ;
lin necessitarian_N = mkTerm "necessitarian_N" ;
lin necessitate_V2 = mkTerm "necessitate_V2" ;
lin necessitous_A = mkTerm "necessitous_A" ;
lin necessity_N = mkTerm "necessity_N" ;
lin neck_N = mkTerm "neck_N" ;
lin neck_V = mkTerm "neck_V" ;
lin neckband_N = mkTerm "neckband_N" ;
lin neckcloth_N = mkTerm "neckcloth_N" ;
lin necked_A = mkTerm "necked_A" ;
lin necker_N = mkTerm "necker_N" ;
lin neckerchief_N = mkTerm "neckerchief_N" ;
lin necklace_N = mkTerm "necklace_N" ;
lin neckless_A = mkTerm "neckless_A" ;
lin necklet_N = mkTerm "necklet_N" ;
lin necklike_A = mkTerm "necklike_A" ;
lin neckline_N = mkTerm "neckline_N" ;
lin neckpiece_N = mkTerm "neckpiece_N" ;
lin necktie_N = mkTerm "necktie_N" ;
lin neckwear_N = mkTerm "neckwear_N" ;
lin necrobiosis_N = mkTerm "necrobiosis_N" ;
lin necrology_N = mkTerm "necrology_N" ;
lin necrolysis_N = mkTerm "necrolysis_N" ;
lin necromancer_N = mkTerm "necromancer_N" ;
lin necromancy_N = mkTerm "necromancy_N" ;
lin necromantic_A = mkTerm "necromantic_A" ;
lin necrophagia_N = mkTerm "necrophagia_N" ;
lin necrophilia_N = mkTerm "necrophilia_N" ;
lin necropolis_N = mkTerm "necropolis_N" ;
lin necrosis_N = mkTerm "necrosis_N" ;
lin necrotic_A = mkTerm "necrotic_A" ;
lin nectar_N = mkTerm "nectar_N" ;
lin nectariferous_A = mkTerm "nectariferous_A" ;
lin nectarine_N = mkTerm "nectarine_N" ;
lin nectary_N = mkTerm "nectary_N" ;
lin ned_PN = mkTerm "ned_PN" ;
lin neddy_PN = mkTerm "neddy_PN" ;
lin nee_A = mkTerm "nee_A" ;
lin need_N = mkTerm "need_N" ;
lin need_V = mkTerm "need_V" ;
lin need_V2 = mkTerm "need_V2" ;
lin need_VV = mkTerm "need_VV" ;
lin needful_A = mkTerm "needful_A" ;
lin neediness_N = mkTerm "neediness_N" ;
lin needle_N = mkTerm "needle_N" ;
lin needle_V2 = mkTerm "needle_V2" ;
lin needlebush_N = mkTerm "needlebush_N" ;
lin needlecraft_N = mkTerm "needlecraft_N" ;
lin needlefish_N = mkTerm "needlefish_N" ;
lin needlepoint_N = mkTerm "needlepoint_N" ;
lin needless_A = mkTerm "needless_A" ;
lin needlewoman_N = mkTerm "needlewoman_N" ;
lin needlewood_N = mkTerm "needlewood_N" ;
lin needlework_N = mkTerm "needlework_N" ;
lin needleworker_N = mkTerm "needleworker_N" ;
lin needs_Adv = mkTerm "needs_Adv" ;
lin needy_A = mkTerm "needy_A" ;
lin needy_N = mkTerm "needy_N" ;
lin neem_N = mkTerm "neem_N" ;
lin neencephalon_N = mkTerm "neencephalon_N" ;
lin nefarious_A = mkTerm "nefarious_A" ;
lin nefariousness_N = mkTerm "nefariousness_N" ;
lin nefazodone_N = mkTerm "nefazodone_N" ;
lin negate_V2 = mkTerm "negate_V2" ;
lin negation_N = mkTerm "negation_N" ;
lin negative_A = mkTerm "negative_A" ;
lin negative_N = mkTerm "negative_N" ;
lin negative_V2 = mkTerm "negative_V2" ;
lin negativist_N = mkTerm "negativist_N" ;
lin negativity_N = mkTerm "negativity_N" ;
lin neglect_N = mkTerm "neglect_N" ;
lin neglect_V2 = mkTerm "neglect_V2" ;
lin neglecter_N = mkTerm "neglecter_N" ;
lin neglectful_A = mkTerm "neglectful_A" ;
lin neglectfulness_N = mkTerm "neglectfulness_N" ;
lin neglige_N = mkTerm "neglige_N" ;
lin negligee_N = mkTerm "negligee_N" ;
lin negligence_N = mkTerm "negligence_N" ;
lin negligent_A = mkTerm "negligent_A" ;
lin negligible_A = mkTerm "negligible_A" ;
lin negotiable_A = mkTerm "negotiable_A" ;
lin negotiate_V = mkTerm "negotiate_V" ;
lin negotiate_V2 = mkTerm "negotiate_V2" ;
lin negotiate_VV = mkTerm "negotiate_VV" ;
lin negotiation_N = mkTerm "negotiation_N" ;
lin negotiator_N = mkTerm "negotiator_N" ;
lin negotiatress_N = mkTerm "negotiatress_N" ;
lin negress_N = mkTerm "negress_N" ;
lin negro_A = mkTerm "negro_A" ;
lin negro_N = mkTerm "negro_N" ;
lin negroid_A = mkTerm "negroid_A" ;
lin negroid_N = mkTerm "negroid_N" ;
lin negus_N = mkTerm "negus_N" ;
lin neigh_N = mkTerm "neigh_N" ;
lin neigh_V = mkTerm "neigh_V" ;
lin neighbor_N = mkTerm "neighbor_N" ;
lin neighborhood_N = mkTerm "neighborhood_N" ;
lin neighbour_N = mkTerm "neighbour_N" ;
lin neighbour_V = mkTerm "neighbour_V" ;
lin neighbour_V2 = mkTerm "neighbour_V2" ;
lin neighbourhood_N = mkTerm "neighbourhood_N" ;
lin neighbouring_A = mkTerm "neighbouring_A" ;
lin neighbourliness_N = mkTerm "neighbourliness_N" ;
lin neighbourly_A = mkTerm "neighbourly_A" ;
lin neil_PN = mkTerm "neil_PN" ;
lin neither7nor_DConj = mkTerm "neither7nor_DConj" ;
lin neither_A = mkTerm "neither_A" ;
lin neither_Adv = mkTerm "neither_Adv" ;
lin neither_Det = mkTerm "neither_Det" ;
lin neither_Prep = mkTerm "neither_Prep" ;
lin nekton_N = mkTerm "nekton_N" ;
lin nelfinavir_N = mkTerm "nelfinavir_N" ;
lin nell_PN = mkTerm "nell_PN" ;
lin nelly_N = mkTerm "nelly_N" ;
lin nelly_PN = mkTerm "nelly_PN" ;
lin nelson_N = mkTerm "nelson_N" ;
lin nelson_PN = mkTerm "nelson_PN" ;
lin nem_con_Adv = mkTerm "nem_con_Adv" ;
lin nematode_N = mkTerm "nematode_N" ;
lin nemesis_N = mkTerm "nemesis_N" ;
lin nemophila_N = mkTerm "nemophila_N" ;
lin neo_A = mkTerm "neo_A" ;
lin neoclassic_A = mkTerm "neoclassic_A" ;
lin neoclassical_A = mkTerm "neoclassical_A" ;
lin neoclassicism_N = mkTerm "neoclassicism_N" ;
lin neoclassicist_A = mkTerm "neoclassicist_A" ;
lin neoclassicist_N = mkTerm "neoclassicist_N" ;
lin neocolonialism_N = mkTerm "neocolonialism_N" ;
lin neoconservatism_N = mkTerm "neoconservatism_N" ;
lin neoconservative_N = mkTerm "neoconservative_N" ;
lin neocortical_A = mkTerm "neocortical_A" ;
lin neodymium_N = mkTerm "neodymium_N" ;
lin neoexpressionism_N = mkTerm "neoexpressionism_N" ;
lin neoliberal_A = mkTerm "neoliberal_A" ;
lin neoliberal_N = mkTerm "neoliberal_N" ;
lin neoliberalism_N = mkTerm "neoliberalism_N" ;
lin neolith_N = mkTerm "neolith_N" ;
lin neolithic_A = mkTerm "neolithic_A" ;
lin neologism_N = mkTerm "neologism_N" ;
lin neologist_N = mkTerm "neologist_N" ;
lin neomycin_N = mkTerm "neomycin_N" ;
lin neon_N = mkTerm "neon_N" ;
lin neonatal_A = mkTerm "neonatal_A" ;
lin neonate_N = mkTerm "neonate_N" ;
lin neonatology_N = mkTerm "neonatology_N" ;
lin neopallium_N = mkTerm "neopallium_N" ;
lin neophobia_N = mkTerm "neophobia_N" ;
lin neophyte_N = mkTerm "neophyte_N" ;
lin neoplasia_N = mkTerm "neoplasia_N" ;
lin neoplasm_N = mkTerm "neoplasm_N" ;
lin neoplastic_A = mkTerm "neoplastic_A" ;
lin neoprene_N = mkTerm "neoprene_N" ;
lin neoromanticism_N = mkTerm "neoromanticism_N" ;
lin neostigmine_N = mkTerm "neostigmine_N" ;
lin neotenic_A = mkTerm "neotenic_A" ;
lin neoteny_N = mkTerm "neoteny_N" ;
lin neotony_N = mkTerm "neotony_N" ;
lin nepal_PN = mkTerm "nepal_PN" ;
lin nepalese_A = mkTerm "nepalese_A" ;
lin nepalese_N = mkTerm "nepalese_N" ;
lin nepaliFem_N = mkTerm "nepaliFem_N" ;
lin nepaliMasc_N = mkTerm "nepaliMasc_N" ;
lin nepali_A = mkTerm "nepali_A" ;
lin nepheline_N = mkTerm "nepheline_N" ;
lin nephelinite_N = mkTerm "nephelinite_N" ;
lin nephew_N = mkTerm "nephew_N" ;
lin nephology_N = mkTerm "nephology_N" ;
lin nephoscope_N = mkTerm "nephoscope_N" ;
lin nephralgia_N = mkTerm "nephralgia_N" ;
lin nephrectomy_N = mkTerm "nephrectomy_N" ;
lin nephrite_N = mkTerm "nephrite_N" ;
lin nephritic_A = mkTerm "nephritic_A" ;
lin nephritis_N = mkTerm "nephritis_N" ;
lin nephrocalcinosis_N = mkTerm "nephrocalcinosis_N" ;
lin nephrolithiasis_N = mkTerm "nephrolithiasis_N" ;
lin nephrology_N = mkTerm "nephrology_N" ;
lin nephron_N = mkTerm "nephron_N" ;
lin nephroptosis_N = mkTerm "nephroptosis_N" ;
lin nephrosclerosis_N = mkTerm "nephrosclerosis_N" ;
lin nephrotomy_N = mkTerm "nephrotomy_N" ;
lin nephrotoxic_A = mkTerm "nephrotoxic_A" ;
lin nephrotoxin_N = mkTerm "nephrotoxin_N" ;
lin nephthytis_N = mkTerm "nephthytis_N" ;
lin nepotism_N = mkTerm "nepotism_N" ;
lin nepotist_N = mkTerm "nepotist_N" ;
lin neptune_PN = mkTerm "neptune_PN" ;
lin neptunium_N = mkTerm "neptunium_N" ;
lin nerd_N = mkTerm "nerd_N" ;
lin nerd_out_V = mkTerm "nerd_out_V" ;
lin nereid_N = mkTerm "nereid_N" ;
lin nerita_N = mkTerm "nerita_N" ;
lin neritic_A = mkTerm "neritic_A" ;
lin neritid_N = mkTerm "neritid_N" ;
lin neritina_N = mkTerm "neritina_N" ;
lin nerve_N = mkTerm "nerve_N" ;
lin nerve_V2 = mkTerm "nerve_V2" ;
lin nerve_cell_N = mkTerm "nerve_cell_N" ;
lin nerve_centre_N = mkTerm "nerve_centre_N" ;
lin nerve_racking_A = mkTerm "nerve_racking_A" ;
lin nerveless_A = mkTerm "nerveless_A" ;
lin nerves_N = mkTerm "nerves_N" ;
lin nervous_A = mkTerm "nervous_A" ;
lin nervousness_N = mkTerm "nervousness_N" ;
lin nervy_A = mkTerm "nervy_A" ;
lin nescience_N = mkTerm "nescience_N" ;
lin nescient_A = mkTerm "nescient_A" ;
lin ness_N = mkTerm "ness_N" ;
lin nest_N = mkTerm "nest_N" ;
lin nest_V = mkTerm "nest_V" ;
lin nest_egg_N = mkTerm "nest_egg_N" ;
lin nester_N = mkTerm "nester_N" ;
lin nestle_V = mkTerm "nestle_V" ;
lin nestle_V2 = mkTerm "nestle_V2" ;
lin nestling_N = mkTerm "nestling_N" ;
lin neston_PN = mkTerm "neston_PN" ;
lin nestor_PN = mkTerm "nestor_PN" ;
lin net_A = mkTerm "net_A" ;
lin net_N = mkTerm "net_N" ;
lin net_V2 = mkTerm "net_V2" ;
lin net_out_V = mkTerm "net_out_V" ;
lin netball_N = mkTerm "netball_N" ;
lin nether_A = mkTerm "nether_A" ;
lin netherlander_N = mkTerm "netherlander_N" ;
lin netherlands_PN = mkTerm "netherlands_PN" ;
lin nethermost_A = mkTerm "nethermost_A" ;
lin netley_PN = mkTerm "netley_PN" ;
lin nett_A = mkTerm "nett_A" ;
lin nett_V2 = mkTerm "nett_V2" ;
lin netting_N = mkTerm "netting_N" ;
lin nettle_N = mkTerm "nettle_N" ;
lin nettle_V2 = mkTerm "nettle_V2" ;
lin nettlerash_N = mkTerm "nettlerash_N" ;
lin network_N = mkTerm "network_N" ;
lin networklike_A = mkTerm "networklike_A" ;
lin neural_A = mkTerm "neural_A" ;
lin neuralgia_N = mkTerm "neuralgia_N" ;
lin neuralgic_A = mkTerm "neuralgic_A" ;
lin neurasthenia_N = mkTerm "neurasthenia_N" ;
lin neurasthenic_A = mkTerm "neurasthenic_A" ;
lin neurasthenic_N = mkTerm "neurasthenic_N" ;
lin neurectomy_N = mkTerm "neurectomy_N" ;
lin neurinoma_N = mkTerm "neurinoma_N" ;
lin neuritis_N = mkTerm "neuritis_N" ;
lin neuroanatomic_A = mkTerm "neuroanatomic_A" ;
lin neuroanatomy_N = mkTerm "neuroanatomy_N" ;
lin neurobiological_A = mkTerm "neurobiological_A" ;
lin neurobiological_Adv = mkTerm "neurobiological_Adv" ;
lin neurobiologist_N = mkTerm "neurobiologist_N" ;
lin neurobiology_N = mkTerm "neurobiology_N" ;
lin neuroblast_N = mkTerm "neuroblast_N" ;
lin neuroblastoma_N = mkTerm "neuroblastoma_N" ;
lin neurochemical_N = mkTerm "neurochemical_N" ;
lin neurodermatitis_N = mkTerm "neurodermatitis_N" ;
lin neuroendocrine_A = mkTerm "neuroendocrine_A" ;
lin neuroepithelioma_N = mkTerm "neuroepithelioma_N" ;
lin neuroepithelium_N = mkTerm "neuroepithelium_N" ;
lin neuroethics_N = mkTerm "neuroethics_N" ;
lin neurofibroma_N = mkTerm "neurofibroma_N" ;
lin neurofibromatosis_N = mkTerm "neurofibromatosis_N" ;
lin neurogenesis_N = mkTerm "neurogenesis_N" ;
lin neurogenic_A = mkTerm "neurogenic_A" ;
lin neuroglia_N = mkTerm "neuroglia_N" ;
lin neurogliacyte_N = mkTerm "neurogliacyte_N" ;
lin neuroglial_A = mkTerm "neuroglial_A" ;
lin neurohormone_N = mkTerm "neurohormone_N" ;
lin neurolemma_N = mkTerm "neurolemma_N" ;
lin neurolinguist_N = mkTerm "neurolinguist_N" ;
lin neurolinguistics_N = mkTerm "neurolinguistics_N" ;
lin neurological_A = mkTerm "neurological_A" ;
lin neurologistFem_N = mkTerm "neurologistFem_N" ;
lin neurologistMasc_N = mkTerm "neurologistMasc_N" ;
lin neurology_N = mkTerm "neurology_N" ;
lin neuroma_N = mkTerm "neuroma_N" ;
lin neuromatous_A = mkTerm "neuromatous_A" ;
lin neuromotor_A = mkTerm "neuromotor_A" ;
lin neuromuscular_A = mkTerm "neuromuscular_A" ;
lin neuropathy_N = mkTerm "neuropathy_N" ;
lin neurophysiological_A = mkTerm "neurophysiological_A" ;
lin neurophysiology_N = mkTerm "neurophysiology_N" ;
lin neuropil_N = mkTerm "neuropil_N" ;
lin neuroplasty_N = mkTerm "neuroplasty_N" ;
lin neuropsychiatric_A = mkTerm "neuropsychiatric_A" ;
lin neuropsychiatry_N = mkTerm "neuropsychiatry_N" ;
lin neuropsychological_A = mkTerm "neuropsychological_A" ;
lin neuropteron_N = mkTerm "neuropteron_N" ;
lin neurosarcoma_N = mkTerm "neurosarcoma_N" ;
lin neuroscience_N = mkTerm "neuroscience_N" ;
lin neuroscientist_N = mkTerm "neuroscientist_N" ;
lin neurosis_N = mkTerm "neurosis_N" ;
lin neurosurgeon_N = mkTerm "neurosurgeon_N" ;
lin neurosurgery_N = mkTerm "neurosurgery_N" ;
lin neurosyphilis_N = mkTerm "neurosyphilis_N" ;
lin neurotic_A = mkTerm "neurotic_A" ;
lin neurotic_N = mkTerm "neurotic_N" ;
lin neurotoxic_A = mkTerm "neurotoxic_A" ;
lin neurotoxin_N = mkTerm "neurotoxin_N" ;
lin neurotransmitter_N = mkTerm "neurotransmitter_N" ;
lin neurotropic_A = mkTerm "neurotropic_A" ;
lin neurotropism_N = mkTerm "neurotropism_N" ;
lin neuss_PN = mkTerm "neuss_PN" ;
lin neuter_A = mkTerm "neuter_A" ;
lin neuter_N = mkTerm "neuter_N" ;
lin neuter_V2 = mkTerm "neuter_V2" ;
lin neutering_N = mkTerm "neutering_N" ;
lin neutral_A = mkTerm "neutral_A" ;
lin neutral_N = mkTerm "neutral_N" ;
lin neutralism_N = mkTerm "neutralism_N" ;
lin neutralist_N = mkTerm "neutralist_N" ;
lin neutrality_N = mkTerm "neutrality_N" ;
lin neutralization_N = mkTerm "neutralization_N" ;
lin neutralize_V2 = mkTerm "neutralize_V2" ;
lin neutrino_N = mkTerm "neutrino_N" ;
lin neutron_N = mkTerm "neutron_N" ;
lin neutropenia_N = mkTerm "neutropenia_N" ;
lin neutrophil_N = mkTerm "neutrophil_N" ;
lin nevada_PN = mkTerm "nevada_PN" ;
lin neve_N = mkTerm "neve_N" ;
lin never_AdV = mkTerm "never_AdV" ;
lin never_Adv = mkTerm "never_Adv" ;
lin nevermore_Adv = mkTerm "nevermore_Adv" ;
lin nevertheless_Adv = mkTerm "nevertheless_Adv" ;
lin neville_PN = mkTerm "neville_PN" ;
lin nevirapine_N = mkTerm "nevirapine_N" ;
lin new_A = mkTerm "new_A" ;
lin new_Adv = mkTerm "new_Adv" ;
lin new_cumnock_PN = mkTerm "new_cumnock_PN" ;
lin new_mills_PN = mkTerm "new_mills_PN" ;
lin new_orleans_PN = mkTerm "new_orleans_PN" ;
lin new_tredegar_PN = mkTerm "new_tredegar_PN" ;
lin new_windsor_PN = mkTerm "new_windsor_PN" ;
lin new_york_PN = mkTerm "new_york_PN" ;
lin newark_PN = mkTerm "newark_PN" ;
lin newarthill_PN = mkTerm "newarthill_PN" ;
lin newbiggin_PN = mkTerm "newbiggin_PN" ;
lin newborn_A = mkTerm "newborn_A" ;
lin newbury_PN = mkTerm "newbury_PN" ;
lin newcastle_PN = mkTerm "newcastle_PN" ;
lin newcastle_under_lyme_PN = mkTerm "newcastle_under_lyme_PN" ;
lin newcastle_upon_tyne_PN = mkTerm "newcastle_upon_tyne_PN" ;
lin newcomer_N = mkTerm "newcomer_N" ;
lin newel_N = mkTerm "newel_N" ;
lin newfangled_A = mkTerm "newfangled_A" ;
lin newfound_A = mkTerm "newfound_A" ;
lin newfoundland_PN = mkTerm "newfoundland_PN" ;
lin newham_PN = mkTerm "newham_PN" ;
lin newhaven_PN = mkTerm "newhaven_PN" ;
lin newlywed_N = mkTerm "newlywed_N" ;
lin newmains_PN = mkTerm "newmains_PN" ;
lin newmarket_N = mkTerm "newmarket_N" ;
lin newmarket_PN = mkTerm "newmarket_PN" ;
lin newness_N = mkTerm "newness_N" ;
lin newport_PN = mkTerm "newport_PN" ;
lin newport_pagnell_PN = mkTerm "newport_pagnell_PN" ;
lin newquay_PN = mkTerm "newquay_PN" ;
lin newry_PN = mkTerm "newry_PN" ;
lin news_N = mkTerm "news_N" ;
lin newsagent_N = mkTerm "newsagent_N" ;
lin newsboy_N = mkTerm "newsboy_N" ;
lin newscast_N = mkTerm "newscast_N" ;
lin newscaster_N = mkTerm "newscaster_N" ;
lin newsdealer_N = mkTerm "newsdealer_N" ;
lin newsflash_N = mkTerm "newsflash_N" ;
lin newsless_A = mkTerm "newsless_A" ;
lin newsletter_N = mkTerm "newsletter_N" ;
lin newsmonger_N = mkTerm "newsmonger_N" ;
lin newspaper_N = mkTerm "newspaper_N" ;
lin newspapering_N = mkTerm "newspapering_N" ;
lin newspaperman_N = mkTerm "newspaperman_N" ;
lin newspeak_N = mkTerm "newspeak_N" ;
lin newsprint_N = mkTerm "newsprint_N" ;
lin newsreader_N = mkTerm "newsreader_N" ;
lin newsreel_N = mkTerm "newsreel_N" ;
lin newsroom_N = mkTerm "newsroom_N" ;
lin newssheet_N = mkTerm "newssheet_N" ;
lin newsstand_N = mkTerm "newsstand_N" ;
lin newsvendor_N = mkTerm "newsvendor_N" ;
lin newswoman_N = mkTerm "newswoman_N" ;
lin newsworthiness_N = mkTerm "newsworthiness_N" ;
lin newsworthy_A = mkTerm "newsworthy_A" ;
lin newsy_A = mkTerm "newsy_A" ;
lin newt_N = mkTerm "newt_N" ;
lin newton_N = mkTerm "newton_N" ;
lin newton_abbot_PN = mkTerm "newton_abbot_PN" ;
lin newton_aycliffe_PN = mkTerm "newton_aycliffe_PN" ;
lin newton_le_willows_PN = mkTerm "newton_le_willows_PN" ;
lin newton_mearns_PN = mkTerm "newton_mearns_PN" ;
lin newtonian_A = mkTerm "newtonian_A" ;
lin newtonian_N = mkTerm "newtonian_N" ;
lin newtown_PN = mkTerm "newtown_PN" ;
lin next_A = mkTerm "next_A" ;
lin next_Prep = mkTerm "next_Prep" ;
lin next_to_Prep = mkTerm "next_to_Prep" ;
lin nexus_N = mkTerm "nexus_N" ;
lin ngultrum_N = mkTerm "ngultrum_N" ;
lin ngwee_N = mkTerm "ngwee_N" ;
lin nhs_N = mkTerm "nhs_N" ;
lin niacin_N = mkTerm "niacin_N" ;
lin nib_N = mkTerm "nib_N" ;
lin nibbed_A = mkTerm "nibbed_A" ;
lin nibble_N = mkTerm "nibble_N" ;
lin nibble_V = mkTerm "nibble_V" ;
lin nibble_V2 = mkTerm "nibble_V2" ;
lin nibbler_N = mkTerm "nibbler_N" ;
lin niblick_N = mkTerm "niblick_N" ;
lin nicad_N = mkTerm "nicad_N" ;
lin nicaragua_PN = mkTerm "nicaragua_PN" ;
lin nicaraguan_A = mkTerm "nicaraguan_A" ;
lin nicaraguan_N = mkTerm "nicaraguan_N" ;
lin nice_A = mkTerm "nice_A" ;
lin nice_PN = mkTerm "nice_PN" ;
lin niceness_N = mkTerm "niceness_N" ;
lin nicety_N = mkTerm "nicety_N" ;
lin niche_N = mkTerm "niche_N" ;
lin nicholas_PN = mkTerm "nicholas_PN" ;
lin nick_N = mkTerm "nick_N" ;
lin nick_PN = mkTerm "nick_PN" ;
lin nick_V2 = mkTerm "nick_V2" ;
lin nickby_PN = mkTerm "nickby_PN" ;
lin nickel_N = mkTerm "nickel_N" ;
lin nickel_V2 = mkTerm "nickel_V2" ;
lin nicknack_N = mkTerm "nicknack_N" ;
lin nickname_N = mkTerm "nickname_N" ;
lin nickname_V2 = mkTerm "nickname_V2" ;
lin nickname_V3 = mkTerm "nickname_V3" ;
lin nicola_PN = mkTerm "nicola_PN" ;
lin nicole_PN = mkTerm "nicole_PN" ;
lin nicotine_N = mkTerm "nicotine_N" ;
lin nidicolous_A = mkTerm "nidicolous_A" ;
lin nidifugous_A = mkTerm "nidifugous_A" ;
lin nidus_N = mkTerm "nidus_N" ;
lin niece_N = mkTerm "niece_N" ;
lin nifedipine_N = mkTerm "nifedipine_N" ;
lin niff_N = mkTerm "niff_N" ;
lin niffy_A = mkTerm "niffy_A" ;
lin nifty_A = mkTerm "nifty_A" ;
lin nigel_PN = mkTerm "nigel_PN" ;
lin nigella_N = mkTerm "nigella_N" ;
lin niger_PN = mkTerm "niger_PN" ;
lin nigeria_PN = mkTerm "nigeria_PN" ;
lin nigerian_A = mkTerm "nigerian_A" ;
lin nigerian_N = mkTerm "nigerian_N" ;
lin nigerien_A = mkTerm "nigerien_A" ;
lin nigerien_N = mkTerm "nigerien_N" ;
lin niggard_N = mkTerm "niggard_N" ;
lin niggardliness_N = mkTerm "niggardliness_N" ;
lin niggardly_A = mkTerm "niggardly_A" ;
lin nigger_N = mkTerm "nigger_N" ;
lin niggle_V = mkTerm "niggle_V" ;
lin nigh_Adv = mkTerm "nigh_Adv" ;
lin nigher_Adv = mkTerm "nigher_Adv" ;
lin nighest_Adv = mkTerm "nighest_Adv" ;
lin night_N = mkTerm "night_N" ;
lin night_bell_N = mkTerm "night_bell_N" ;
lin night_bird_N = mkTerm "night_bird_N" ;
lin night_light_N = mkTerm "night_light_N" ;
lin night_line_N = mkTerm "night_line_N" ;
lin night_porter_N = mkTerm "night_porter_N" ;
lin night_soil_N = mkTerm "night_soil_N" ;
lin night_stop_N = mkTerm "night_stop_N" ;
lin night_time_N = mkTerm "night_time_N" ;
lin night_watch_N = mkTerm "night_watch_N" ;
lin night_watchman_N = mkTerm "night_watchman_N" ;
lin nightcap_N = mkTerm "nightcap_N" ;
lin nightclub_N = mkTerm "nightclub_N" ;
lin nightdress_N = mkTerm "nightdress_N" ;
lin nightfall_N = mkTerm "nightfall_N" ;
lin nightgown_N = mkTerm "nightgown_N" ;
lin nighthawk_N = mkTerm "nighthawk_N" ;
lin nightie_N = mkTerm "nightie_N" ;
lin nightingale_N = mkTerm "nightingale_N" ;
lin nightjar_N = mkTerm "nightjar_N" ;
lin nightlife_N = mkTerm "nightlife_N" ;
lin nightlong_A = mkTerm "nightlong_A" ;
lin nightly_A = mkTerm "nightly_A" ;
lin nightly_Adv = mkTerm "nightly_Adv" ;
lin nightmare_N = mkTerm "nightmare_N" ;
lin nightmarish_A = mkTerm "nightmarish_A" ;
lin nightshade_N = mkTerm "nightshade_N" ;
lin nightshirt_N = mkTerm "nightshirt_N" ;
lin nightwear_N = mkTerm "nightwear_N" ;
lin nightwork_N = mkTerm "nightwork_N" ;
lin nihil_N = mkTerm "nihil_N" ;
lin nihilism_N = mkTerm "nihilism_N" ;
lin nihilist_N = mkTerm "nihilist_N" ;
lin nihilistic_A = mkTerm "nihilistic_A" ;
lin nijmegen_PN = mkTerm "nijmegen_PN" ;
lin nil_N = mkTerm "nil_N" ;
lin nilgai_N = mkTerm "nilgai_N" ;
lin nilotic_A = mkTerm "nilotic_A" ;
lin nilpotent_A = mkTerm "nilpotent_A" ;
lin nilsiä_PN = mkTerm "nilsiä_PN" ;
lin nim_N = mkTerm "nim_N" ;
lin nimble_A = mkTerm "nimble_A" ;
lin nimbleness_N = mkTerm "nimbleness_N" ;
lin nimblewill_N = mkTerm "nimblewill_N" ;
lin nimbus_N = mkTerm "nimbus_N" ;
lin niminy_piminy_A = mkTerm "niminy_piminy_A" ;
lin nimrod_PN = mkTerm "nimrod_PN" ;
lin nincompoop_N = mkTerm "nincompoop_N" ;
lin ninefold_A = mkTerm "ninefold_A" ;
lin ninefold_Adv = mkTerm "ninefold_Adv" ;
lin ninepence_N = mkTerm "ninepence_N" ;
lin ninepenny_A = mkTerm "ninepenny_A" ;
lin ninepin_N = mkTerm "ninepin_N" ;
lin ninepins_N = mkTerm "ninepins_N" ;
lin ninja_N = mkTerm "ninja_N" ;
lin ninjutsu_N = mkTerm "ninjutsu_N" ;
lin ninny_N = mkTerm "ninny_N" ;
lin ninon_N = mkTerm "ninon_N" ;
lin ninth_N = mkTerm "ninth_N" ;
lin niobe_PN = mkTerm "niobe_PN" ;
lin niobite_N = mkTerm "niobite_N" ;
lin niobium_N = mkTerm "niobium_N" ;
lin nip_N = mkTerm "nip_N" ;
lin nip_V = mkTerm "nip_V" ;
lin nip_V2 = mkTerm "nip_V2" ;
lin nip_off_V = mkTerm "nip_off_V" ;
lin nip_out_V = mkTerm "nip_out_V" ;
lin nipa_N = mkTerm "nipa_N" ;
lin nipper_N = mkTerm "nipper_N" ;
lin nipple_N = mkTerm "nipple_N" ;
lin nipponese_A = mkTerm "nipponese_A" ;
lin nippy_A = mkTerm "nippy_A" ;
lin niqaabi_N = mkTerm "niqaabi_N" ;
lin niqab_N = mkTerm "niqab_N" ;
lin nirvana_N = mkTerm "nirvana_N" ;
lin nisi_A = mkTerm "nisi_A" ;
lin nissen_PN = mkTerm "nissen_PN" ;
lin nit_N = mkTerm "nit_N" ;
lin nitpicker_N = mkTerm "nitpicker_N" ;
lin nitrate_N = mkTerm "nitrate_N" ;
lin nitrazepam_N = mkTerm "nitrazepam_N" ;
lin nitre_N = mkTerm "nitre_N" ;
lin nitric_A = mkTerm "nitric_A" ;
lin nitride_N = mkTerm "nitride_N" ;
lin nitrification_N = mkTerm "nitrification_N" ;
lin nitrile_N = mkTerm "nitrile_N" ;
lin nitrite_N = mkTerm "nitrite_N" ;
lin nitrobacterium_N = mkTerm "nitrobacterium_N" ;
lin nitrobenzene_N = mkTerm "nitrobenzene_N" ;
lin nitrocalcite_N = mkTerm "nitrocalcite_N" ;
lin nitrochalk_N = mkTerm "nitrochalk_N" ;
lin nitrochloromethane_N = mkTerm "nitrochloromethane_N" ;
lin nitrofuran_N = mkTerm "nitrofuran_N" ;
lin nitrofurantoin_N = mkTerm "nitrofurantoin_N" ;
lin nitrogen_N = mkTerm "nitrogen_N" ;
lin nitrogenase_N = mkTerm "nitrogenase_N" ;
lin nitrogenous_A = mkTerm "nitrogenous_A" ;
lin nitroglycerin_N = mkTerm "nitroglycerin_N" ;
lin nitroglycerine_N = mkTerm "nitroglycerine_N" ;
lin nitrosobacteria_N = mkTerm "nitrosobacteria_N" ;
lin nitrous_A = mkTerm "nitrous_A" ;
lin nitty_gritty_N = mkTerm "nitty_gritty_N" ;
lin nitwit_N = mkTerm "nitwit_N" ;
lin nitwitted_A = mkTerm "nitwitted_A" ;
lin nivala_PN = mkTerm "nivala_PN" ;
lin nix_N = mkTerm "nix_N" ;
lin nix_V2 = mkTerm "nix_V2" ;
lin no_Interj = mkTerm "no_Interj" ;
lin no_ball_N = mkTerm "no_ball_N" ;
lin no_fewer_than_AdN = mkTerm "no_fewer_than_AdN" ;
lin no_go_A = mkTerm "no_go_A" ;
lin no_longer_AdV = mkTerm "no_longer_AdV" ;
lin no_man's_land_N = mkTerm "no_man's_land_N" ;
lin no_more_than_AdN = mkTerm "no_more_than_AdN" ;
lin no_one_NP = mkTerm "no_one_NP" ;
lin noah_PN = mkTerm "noah_PN" ;
lin nob_N = mkTerm "nob_N" ;
lin nobble_V2 = mkTerm "nobble_V2" ;
lin nobel_PN = mkTerm "nobel_PN" ;
lin nobelium_N = mkTerm "nobelium_N" ;
lin nobility_N = mkTerm "nobility_N" ;
lin nobleFem_N = mkTerm "nobleFem_N" ;
lin nobleMasc_N = mkTerm "nobleMasc_N" ;
lin noble_A = mkTerm "noble_A" ;
lin noble_mindedness_N = mkTerm "noble_mindedness_N" ;
lin nobleman_N = mkTerm "nobleman_N" ;
lin noblesse_N = mkTerm "noblesse_N" ;
lin noblesse_oblige_N = mkTerm "noblesse_oblige_N" ;
lin nocent_A = mkTerm "nocent_A" ;
lin nociceptive_A = mkTerm "nociceptive_A" ;
lin noctambulist_N = mkTerm "noctambulist_N" ;
lin noctiluca_N = mkTerm "noctiluca_N" ;
lin noctilucent_A = mkTerm "noctilucent_A" ;
lin nocturia_N = mkTerm "nocturia_N" ;
lin nocturnal_A = mkTerm "nocturnal_A" ;
lin nocturne_N = mkTerm "nocturne_N" ;
lin nod_N = mkTerm "nod_N" ;
lin nod_V = mkTerm "nod_V" ;
lin nod_off_V = mkTerm "nod_off_V" ;
lin nod_through_V2 = mkTerm "nod_through_V2" ;
lin noddle_N = mkTerm "noddle_N" ;
lin node_N = mkTerm "node_N" ;
lin nodular_A = mkTerm "nodular_A" ;
lin nodulated_A = mkTerm "nodulated_A" ;
lin nodule_N = mkTerm "nodule_N" ;
lin nodulose_A = mkTerm "nodulose_A" ;
lin noel_N = mkTerm "noel_N" ;
lin noel_PN = mkTerm "noel_PN" ;
lin nog_N = mkTerm "nog_N" ;
lin noggin_N = mkTerm "noggin_N" ;
lin nogging_N = mkTerm "nogging_N" ;
lin nohow_Adv = mkTerm "nohow_Adv" ;
lin noise_N = mkTerm "noise_N" ;
lin noise_V2 = mkTerm "noise_V2" ;
lin noiseless_A = mkTerm "noiseless_A" ;
lin noiselessness_N = mkTerm "noiselessness_N" ;
lin noisemaker_N = mkTerm "noisemaker_N" ;
lin noisiness_N = mkTerm "noisiness_N" ;
lin noisome_A = mkTerm "noisome_A" ;
lin noisy_A = mkTerm "noisy_A" ;
lin nokia_PN = mkTerm "nokia_PN" ;
lin nom_de_plume_N = mkTerm "nom_de_plume_N" ;
lin noma_N = mkTerm "noma_N" ;
lin nomad_N = mkTerm "nomad_N" ;
lin nomadic_A = mkTerm "nomadic_A" ;
lin nombril_N = mkTerm "nombril_N" ;
lin nomenclature_N = mkTerm "nomenclature_N" ;
lin nomenklatura_N = mkTerm "nomenklatura_N" ;
lin nomia_N = mkTerm "nomia_N" ;
lin nominal_A = mkTerm "nominal_A" ;
lin nominalism_N = mkTerm "nominalism_N" ;
lin nominalist_N = mkTerm "nominalist_N" ;
lin nominalistic_A = mkTerm "nominalistic_A" ;
lin nominate_V2 = mkTerm "nominate_V2" ;
lin nomination_N = mkTerm "nomination_N" ;
lin nominative_A = mkTerm "nominative_A" ;
lin nominative_N = mkTerm "nominative_N" ;
lin nominator_N = mkTerm "nominator_N" ;
lin nominee_N = mkTerm "nominee_N" ;
lin nomogram_N = mkTerm "nomogram_N" ;
lin nomothetic_A = mkTerm "nomothetic_A" ;
lin non_compliance_N = mkTerm "non_compliance_N" ;
lin non_compos_mentis_A = mkTerm "non_compos_mentis_A" ;
lin non_contentious_A = mkTerm "non_contentious_A" ;
lin non_interference_N = mkTerm "non_interference_N" ;
lin non_sequitur_N = mkTerm "non_sequitur_N" ;
lin non_skid_A = mkTerm "non_skid_A" ;
lin non_u_A = mkTerm "non_u_A" ;
lin nonabsorbency_N = mkTerm "nonabsorbency_N" ;
lin nonabsorbent_A = mkTerm "nonabsorbent_A" ;
lin nonacceptance_N = mkTerm "nonacceptance_N" ;
lin nonaccomplishment_N = mkTerm "nonaccomplishment_N" ;
lin nonaddictive_A = mkTerm "nonaddictive_A" ;
lin nonadhesive_A = mkTerm "nonadhesive_A" ;
lin nonadjacent_A = mkTerm "nonadjacent_A" ;
lin nonadsorbent_A = mkTerm "nonadsorbent_A" ;
lin nonage_N = mkTerm "nonage_N" ;
lin nonagenarian_A = mkTerm "nonagenarian_A" ;
lin nonagenarian_N = mkTerm "nonagenarian_N" ;
lin nonaggression_N = mkTerm "nonaggression_N" ;
lin nonagon_N = mkTerm "nonagon_N" ;
lin nonalcoholic_A = mkTerm "nonalcoholic_A" ;
lin nonaligned_A = mkTerm "nonaligned_A" ;
lin nonalignment_N = mkTerm "nonalignment_N" ;
lin nonallele_N = mkTerm "nonallele_N" ;
lin nonappearance_N = mkTerm "nonappearance_N" ;
lin nonappointive_A = mkTerm "nonappointive_A" ;
lin nonarbitrable_A = mkTerm "nonarbitrable_A" ;
lin nonarbitrary_A = mkTerm "nonarbitrary_A" ;
lin nonarboreal_A = mkTerm "nonarboreal_A" ;
lin nonassertive_A = mkTerm "nonassertive_A" ;
lin nonassociative_A = mkTerm "nonassociative_A" ;
lin nonastringent_A = mkTerm "nonastringent_A" ;
lin nonattendance_N = mkTerm "nonattendance_N" ;
lin nonautonomous_A = mkTerm "nonautonomous_A" ;
lin nonbearing_A = mkTerm "nonbearing_A" ;
lin nonbeing_N = mkTerm "nonbeing_N" ;
lin nonbelligerent_A = mkTerm "nonbelligerent_A" ;
lin noncaloric_A = mkTerm "noncaloric_A" ;
lin noncandidate_N = mkTerm "noncandidate_N" ;
lin noncarbonated_A = mkTerm "noncarbonated_A" ;
lin noncausative_A = mkTerm "noncausative_A" ;
lin nonce_N = mkTerm "nonce_N" ;
lin nonce_word_N = mkTerm "nonce_word_N" ;
lin noncellular_A = mkTerm "noncellular_A" ;
lin nonchalance_N = mkTerm "nonchalance_N" ;
lin nonchalant_A = mkTerm "nonchalant_A" ;
lin noncivilized_A = mkTerm "noncivilized_A" ;
lin nonclassical_A = mkTerm "nonclassical_A" ;
lin noncollapsible_A = mkTerm "noncollapsible_A" ;
lin noncolumned_A = mkTerm "noncolumned_A" ;
lin noncombatant_A = mkTerm "noncombatant_A" ;
lin noncombatant_N = mkTerm "noncombatant_N" ;
lin noncombinative_A = mkTerm "noncombinative_A" ;
lin noncombining_A = mkTerm "noncombining_A" ;
lin noncombustible_A = mkTerm "noncombustible_A" ;
lin noncommercial_A = mkTerm "noncommercial_A" ;
lin noncommissioned_A = mkTerm "noncommissioned_A" ;
lin noncommittal_A = mkTerm "noncommittal_A" ;
lin noncommunicable_A = mkTerm "noncommunicable_A" ;
lin noncompetitive_A = mkTerm "noncompetitive_A" ;
lin noncomprehensive_A = mkTerm "noncomprehensive_A" ;
lin nonconductive_A = mkTerm "nonconductive_A" ;
lin nonconductor_N = mkTerm "nonconductor_N" ;
lin nonconforming_A = mkTerm "nonconforming_A" ;
lin nonconformism_N = mkTerm "nonconformism_N" ;
lin nonconformist_A = mkTerm "nonconformist_A" ;
lin nonconformist_N = mkTerm "nonconformist_N" ;
lin nonconformity_N = mkTerm "nonconformity_N" ;
lin nonconscious_A = mkTerm "nonconscious_A" ;
lin nonconvergent_A = mkTerm "nonconvergent_A" ;
lin noncritical_A = mkTerm "noncritical_A" ;
lin noncrucial_A = mkTerm "noncrucial_A" ;
lin noncrystalline_A = mkTerm "noncrystalline_A" ;
lin noncurrent_A = mkTerm "noncurrent_A" ;
lin noncyclic_A = mkTerm "noncyclic_A" ;
lin nondeductible_A = mkTerm "nondeductible_A" ;
lin nondenominational_A = mkTerm "nondenominational_A" ;
lin nondescript_A = mkTerm "nondescript_A" ;
lin nondescript_N = mkTerm "nondescript_N" ;
lin nondevelopment_N = mkTerm "nondevelopment_N" ;
lin nondigestible_A = mkTerm "nondigestible_A" ;
lin nondisjunction_N = mkTerm "nondisjunction_N" ;
lin nondisposable_A = mkTerm "nondisposable_A" ;
lin nondriver_N = mkTerm "nondriver_N" ;
lin none_A = mkTerm "none_A" ;
lin none_Adv = mkTerm "none_Adv" ;
lin none_NP = mkTerm "none_NP" ;
lin nonechoic_A = mkTerm "nonechoic_A" ;
lin noneffervescent_A = mkTerm "noneffervescent_A" ;
lin nonelective_A = mkTerm "nonelective_A" ;
lin nonentity_N = mkTerm "nonentity_N" ;
lin nonenzymatic_A = mkTerm "nonenzymatic_A" ;
lin nonequivalence_N = mkTerm "nonequivalence_N" ;
lin nonequivalent_A = mkTerm "nonequivalent_A" ;
lin nones_N = mkTerm "nones_N" ;
lin nonesuch_N = mkTerm "nonesuch_N" ;
lin nonetheless_Adv = mkTerm "nonetheless_Adv" ;
lin nonevent_N = mkTerm "nonevent_N" ;
lin nonexempt_A = mkTerm "nonexempt_A" ;
lin nonexistence_N = mkTerm "nonexistence_N" ;
lin nonexistent_A = mkTerm "nonexistent_A" ;
lin nonexploratory_A = mkTerm "nonexploratory_A" ;
lin nonexplosive_A = mkTerm "nonexplosive_A" ;
lin nonextant_A = mkTerm "nonextant_A" ;
lin nonextensile_A = mkTerm "nonextensile_A" ;
lin nonfat_A = mkTerm "nonfat_A" ;
lin nonfatal_A = mkTerm "nonfatal_A" ;
lin nonfeasance_N = mkTerm "nonfeasance_N" ;
lin nonfiction_N = mkTerm "nonfiction_N" ;
lin nonfictional_A = mkTerm "nonfictional_A" ;
lin nonfinancial_A = mkTerm "nonfinancial_A" ;
lin nonfissile_A = mkTerm "nonfissile_A" ;
lin nonfissionable_A = mkTerm "nonfissionable_A" ;
lin nonflammable_A = mkTerm "nonflammable_A" ;
lin nonfunctional_A = mkTerm "nonfunctional_A" ;
lin nonglutinous_A = mkTerm "nonglutinous_A" ;
lin nongranular_A = mkTerm "nongranular_A" ;
lin nongregarious_A = mkTerm "nongregarious_A" ;
lin nonhairy_A = mkTerm "nonhairy_A" ;
lin nonharmonic_A = mkTerm "nonharmonic_A" ;
lin nonhereditary_A = mkTerm "nonhereditary_A" ;
lin nonhierarchical_A = mkTerm "nonhierarchical_A" ;
lin nonhuman_A = mkTerm "nonhuman_A" ;
lin nonimitative_A = mkTerm "nonimitative_A" ;
lin nonindulgent_A = mkTerm "nonindulgent_A" ;
lin nonindustrial_A = mkTerm "nonindustrial_A" ;
lin noninfectious_A = mkTerm "noninfectious_A" ;
lin noninflammatory_A = mkTerm "noninflammatory_A" ;
lin noninheritable_A = mkTerm "noninheritable_A" ;
lin noninstitutional_A = mkTerm "noninstitutional_A" ;
lin noninstitutionalized_A = mkTerm "noninstitutionalized_A" ;
lin nonintegrated_A = mkTerm "nonintegrated_A" ;
lin nonintellectual_A = mkTerm "nonintellectual_A" ;
lin noninterchangeable_A = mkTerm "noninterchangeable_A" ;
lin nonintervention_N = mkTerm "nonintervention_N" ;
lin noninvasive_A = mkTerm "noninvasive_A" ;
lin nonionic_A = mkTerm "nonionic_A" ;
lin nonionized_A = mkTerm "nonionized_A" ;
lin nonjudgmental_A = mkTerm "nonjudgmental_A" ;
lin nonkosher_A = mkTerm "nonkosher_A" ;
lin nonlethal_A = mkTerm "nonlethal_A" ;
lin nonlexical_A = mkTerm "nonlexical_A" ;
lin nonlinear_A = mkTerm "nonlinear_A" ;
lin nonlinguistic_A = mkTerm "nonlinguistic_A" ;
lin nonmagnetic_A = mkTerm "nonmagnetic_A" ;
lin nonmandatory_A = mkTerm "nonmandatory_A" ;
lin nonmechanical_A = mkTerm "nonmechanical_A" ;
lin nonmechanistic_A = mkTerm "nonmechanistic_A" ;
lin nonmember_N = mkTerm "nonmember_N" ;
lin nonmetal_N = mkTerm "nonmetal_N" ;
lin nonmetallic_A = mkTerm "nonmetallic_A" ;
lin nonmetamorphic_A = mkTerm "nonmetamorphic_A" ;
lin nonmigratory_A = mkTerm "nonmigratory_A" ;
lin nonmodern_A = mkTerm "nonmodern_A" ;
lin nonmonotonic_A = mkTerm "nonmonotonic_A" ;
lin nonmoral_A = mkTerm "nonmoral_A" ;
lin nonmotile_A = mkTerm "nonmotile_A" ;
lin nonmoving_A = mkTerm "nonmoving_A" ;
lin nonnative_A = mkTerm "nonnative_A" ;
lin nonnatural_A = mkTerm "nonnatural_A" ;
lin nonnegative_A = mkTerm "nonnegative_A" ;
lin nonnomadic_A = mkTerm "nonnomadic_A" ;
lin nonnormative_A = mkTerm "nonnormative_A" ;
lin nonobservance_N = mkTerm "nonobservance_N" ;
lin nonobservant_A = mkTerm "nonobservant_A" ;
lin nonoccurrence_N = mkTerm "nonoccurrence_N" ;
lin nonopening_A = mkTerm "nonopening_A" ;
lin nonoperational_A = mkTerm "nonoperational_A" ;
lin nonoscillatory_A = mkTerm "nonoscillatory_A" ;
lin nonparallel_A = mkTerm "nonparallel_A" ;
lin nonparametric_A = mkTerm "nonparametric_A" ;
lin nonpareil_A = mkTerm "nonpareil_A" ;
lin nonpareil_N = mkTerm "nonpareil_N" ;
lin nonparticipant_N = mkTerm "nonparticipant_N" ;
lin nonparticulate_A = mkTerm "nonparticulate_A" ;
lin nonpartisan_A = mkTerm "nonpartisan_A" ;
lin nonpartisan_N = mkTerm "nonpartisan_N" ;
lin nonpasserine_A = mkTerm "nonpasserine_A" ;
lin nonpayment_N = mkTerm "nonpayment_N" ;
lin nonperson_N = mkTerm "nonperson_N" ;
lin nonpersonal_A = mkTerm "nonpersonal_A" ;
lin nonphotosynthetic_A = mkTerm "nonphotosynthetic_A" ;
lin nonplus_V2 = mkTerm "nonplus_V2" ;
lin nonpoisonous_A = mkTerm "nonpoisonous_A" ;
lin nonpolitical_A = mkTerm "nonpolitical_A" ;
lin nonporous_A = mkTerm "nonporous_A" ;
lin nonpregnant_A = mkTerm "nonpregnant_A" ;
lin nonprehensile_A = mkTerm "nonprehensile_A" ;
lin nonproductive_A = mkTerm "nonproductive_A" ;
lin nonprofessional_A = mkTerm "nonprofessional_A" ;
lin nonprofit_A = mkTerm "nonprofit_A" ;
lin nonprognosticative_A = mkTerm "nonprognosticative_A" ;
lin nonproliferation_N = mkTerm "nonproliferation_N" ;
lin nonproprietary_A = mkTerm "nonproprietary_A" ;
lin nonpsychoactive_A = mkTerm "nonpsychoactive_A" ;
lin nonpublic_A = mkTerm "nonpublic_A" ;
lin nonpurulent_A = mkTerm "nonpurulent_A" ;
lin nonracial_A = mkTerm "nonracial_A" ;
lin nonradioactive_A = mkTerm "nonradioactive_A" ;
lin nonrandom_A = mkTerm "nonrandom_A" ;
lin nonrational_A = mkTerm "nonrational_A" ;
lin nonreader_N = mkTerm "nonreader_N" ;
lin nonreciprocal_A = mkTerm "nonreciprocal_A" ;
lin nonreciprocating_A = mkTerm "nonreciprocating_A" ;
lin nonrecreational_A = mkTerm "nonrecreational_A" ;
lin nonreflective_A = mkTerm "nonreflective_A" ;
lin nonrepetitive_A = mkTerm "nonrepetitive_A" ;
lin nonrepresentational_A = mkTerm "nonrepresentational_A" ;
lin nonrepresentative_A = mkTerm "nonrepresentative_A" ;
lin nonresident_A = mkTerm "nonresident_A" ;
lin nonresident_N = mkTerm "nonresident_N" ;
lin nonresidential_A = mkTerm "nonresidential_A" ;
lin nonresilient_A = mkTerm "nonresilient_A" ;
lin nonresinous_A = mkTerm "nonresinous_A" ;
lin nonresistance_N = mkTerm "nonresistance_N" ;
lin nonresistant_A = mkTerm "nonresistant_A" ;
lin nonrestrictive_A = mkTerm "nonrestrictive_A" ;
lin nonreticulate_A = mkTerm "nonreticulate_A" ;
lin nonretractile_A = mkTerm "nonretractile_A" ;
lin nonreturnable_A = mkTerm "nonreturnable_A" ;
lin nonreversible_A = mkTerm "nonreversible_A" ;
lin nonrhythmic_A = mkTerm "nonrhythmic_A" ;
lin nonrigid_A = mkTerm "nonrigid_A" ;
lin nonruminant_A = mkTerm "nonruminant_A" ;
lin nonsectarian_A = mkTerm "nonsectarian_A" ;
lin nonsense_N = mkTerm "nonsense_N" ;
lin nonsensical_A = mkTerm "nonsensical_A" ;
lin nonsensitive_A = mkTerm "nonsensitive_A" ;
lin nonsignificant_A = mkTerm "nonsignificant_A" ;
lin nonslip_A = mkTerm "nonslip_A" ;
lin nonslippery_A = mkTerm "nonslippery_A" ;
lin nonsmoker_N = mkTerm "nonsmoker_N" ;
lin nonspatial_A = mkTerm "nonspatial_A" ;
lin nonspeaking_A = mkTerm "nonspeaking_A" ;
lin nonspecific_A = mkTerm "nonspecific_A" ;
lin nonspherical_A = mkTerm "nonspherical_A" ;
lin nonstandard_A = mkTerm "nonstandard_A" ;
lin nonstarter_N = mkTerm "nonstarter_N" ;
lin nonsteroid_N = mkTerm "nonsteroid_N" ;
lin nonsteroidal_A = mkTerm "nonsteroidal_A" ;
lin nonstick_A = mkTerm "nonstick_A" ;
lin nonstop_A = mkTerm "nonstop_A" ;
lin nonstop_Adv = mkTerm "nonstop_Adv" ;
lin nonstructural_A = mkTerm "nonstructural_A" ;
lin nonsubmersible_A = mkTerm "nonsubmersible_A" ;
lin nonsuch_N = mkTerm "nonsuch_N" ;
lin nonsuppurative_A = mkTerm "nonsuppurative_A" ;
lin nonsurgical_A = mkTerm "nonsurgical_A" ;
lin nonsyllabic_A = mkTerm "nonsyllabic_A" ;
lin nonsynchronous_A = mkTerm "nonsynchronous_A" ;
lin nonsynthetic_A = mkTerm "nonsynthetic_A" ;
lin nontaxable_A = mkTerm "nontaxable_A" ;
lin nontechnical_A = mkTerm "nontechnical_A" ;
lin nontelescopic_A = mkTerm "nontelescopic_A" ;
lin nonterritorial_A = mkTerm "nonterritorial_A" ;
lin nonthermal_A = mkTerm "nonthermal_A" ;
lin nontoxic_A = mkTerm "nontoxic_A" ;
lin nontraditional_A = mkTerm "nontraditional_A" ;
lin nontransferable_A = mkTerm "nontransferable_A" ;
lin nontranslational_A = mkTerm "nontranslational_A" ;
lin nontricyclic_N = mkTerm "nontricyclic_N" ;
lin nonturbulent_A = mkTerm "nonturbulent_A" ;
lin nonuniformity_N = mkTerm "nonuniformity_N" ;
lin nonunion_A = mkTerm "nonunion_A" ;
lin nonuple_A = mkTerm "nonuple_A" ;
lin nonvenomous_A = mkTerm "nonvenomous_A" ;
lin nonverbal_A = mkTerm "nonverbal_A" ;
lin nonviable_A = mkTerm "nonviable_A" ;
lin nonviolence_N = mkTerm "nonviolence_N" ;
lin nonviolent_A = mkTerm "nonviolent_A" ;
lin nonvisual_A = mkTerm "nonvisual_A" ;
lin nonvolatile_A = mkTerm "nonvolatile_A" ;
lin nonwashable_A = mkTerm "nonwashable_A" ;
lin nonwoody_A = mkTerm "nonwoody_A" ;
lin nonworker_N = mkTerm "nonworker_N" ;
lin noodle_N = mkTerm "noodle_N" ;
lin nook_N = mkTerm "nook_N" ;
lin noon_N = mkTerm "noon_N" ;
lin noonday_A = mkTerm "noonday_A" ;
lin noontide_N = mkTerm "noontide_N" ;
lin noormarkku_PN = mkTerm "noormarkku_PN" ;
lin noose_N = mkTerm "noose_N" ;
lin noose_V2 = mkTerm "noose_V2" ;
lin nopal_N = mkTerm "nopal_N" ;
lin nope_Interj = mkTerm "nope_Interj" ;
lin nor'_east_N = mkTerm "nor'_east_N" ;
lin nor'_nor'_east_Adv = mkTerm "nor'_nor'_east_Adv" ;
lin nor'_nor'_east_N = mkTerm "nor'_nor'_east_N" ;
lin nor'_nor'_west_Adv = mkTerm "nor'_nor'_west_Adv" ;
lin nor'_nor'_west_N = mkTerm "nor'_nor'_west_N" ;
lin nor'_west_N = mkTerm "nor'_west_N" ;
lin nor_Conj = mkTerm "nor_Conj" ;
lin nora_PN = mkTerm "nora_PN" ;
lin noradrenaline_N = mkTerm "noradrenaline_N" ;
lin nordic_A = mkTerm "nordic_A" ;
lin nordic_N = mkTerm "nordic_N" ;
lin norethindrone_N = mkTerm "norethindrone_N" ;
lin norethynodrel_N = mkTerm "norethynodrel_N" ;
lin norfolk_PN = mkTerm "norfolk_PN" ;
lin norgestrel_N = mkTerm "norgestrel_N" ;
lin noria_N = mkTerm "noria_N" ;
lin norm_N = mkTerm "norm_N" ;
lin normal_A = mkTerm "normal_A" ;
lin normal_N = mkTerm "normal_N" ;
lin normalcy_N = mkTerm "normalcy_N" ;
lin normality_N = mkTerm "normality_N" ;
lin normalization_N = mkTerm "normalization_N" ;
lin normalize_V2 = mkTerm "normalize_V2" ;
lin normalizer_N = mkTerm "normalizer_N" ;
lin normally_Adv = mkTerm "normally_Adv" ;
lin norman_A = mkTerm "norman_A" ;
lin norman_N = mkTerm "norman_N" ;
lin norman_PN = mkTerm "norman_PN" ;
lin normanton_PN = mkTerm "normanton_PN" ;
lin normantown_PN = mkTerm "normantown_PN" ;
lin normative_A = mkTerm "normative_A" ;
lin normotensive_A = mkTerm "normotensive_A" ;
lin normothermia_N = mkTerm "normothermia_N" ;
lin norse_A = mkTerm "norse_A" ;
lin norse_N = mkTerm "norse_N" ;
lin north_A = mkTerm "north_A" ;
lin north_Adv = mkTerm "north_Adv" ;
lin north_N = mkTerm "north_N" ;
lin north_korea_PN = mkTerm "north_korea_PN" ;
lin north_northeast_Adv = mkTerm "north_northeast_Adv" ;
lin north_northeast_N = mkTerm "north_northeast_N" ;
lin north_northwest_Adv = mkTerm "north_northwest_Adv" ;
lin north_northwest_N = mkTerm "north_northwest_N" ;
lin north_walsham_PN = mkTerm "north_walsham_PN" ;
lin northallerton_PN = mkTerm "northallerton_PN" ;
lin northam_PN = mkTerm "northam_PN" ;
lin northampton_PN = mkTerm "northampton_PN" ;
lin northamptonshire_PN = mkTerm "northamptonshire_PN" ;
lin northbound_A = mkTerm "northbound_A" ;
lin northeast_Adv = mkTerm "northeast_Adv" ;
lin northeast_N = mkTerm "northeast_N" ;
lin northeaster_N = mkTerm "northeaster_N" ;
lin northeasterly_A = mkTerm "northeasterly_A" ;
lin northeastern_A = mkTerm "northeastern_A" ;
lin northeastward_A = mkTerm "northeastward_A" ;
lin northeastward_Adv = mkTerm "northeastward_Adv" ;
lin northerly_A = mkTerm "northerly_A" ;
lin northerly_Adv = mkTerm "northerly_Adv" ;
lin northern_A = mkTerm "northern_A" ;
lin northerner_N = mkTerm "northerner_N" ;
lin northernmost_A = mkTerm "northernmost_A" ;
lin northernness_N = mkTerm "northernness_N" ;
lin northland_N = mkTerm "northland_N" ;
lin northman_N = mkTerm "northman_N" ;
lin northumberland_PN = mkTerm "northumberland_PN" ;
lin northward_Adv = mkTerm "northward_Adv" ;
lin northwards_Adv = mkTerm "northwards_Adv" ;
lin northwest_Adv = mkTerm "northwest_Adv" ;
lin northwest_N = mkTerm "northwest_N" ;
lin northwester_N = mkTerm "northwester_N" ;
lin northwesterly_A = mkTerm "northwesterly_A" ;
lin northwestern_A = mkTerm "northwestern_A" ;
lin northwestward_A = mkTerm "northwestward_A" ;
lin northwestward_Adv = mkTerm "northwestward_Adv" ;
lin northwich_PN = mkTerm "northwich_PN" ;
lin norton_PN = mkTerm "norton_PN" ;
lin nortriptyline_N = mkTerm "nortriptyline_N" ;
lin norway_PN = mkTerm "norway_PN" ;
lin norwegianFem_N = mkTerm "norwegianFem_N" ;
lin norwegianMasc_N = mkTerm "norwegianMasc_N" ;
lin norwegian_A = mkTerm "norwegian_A" ;
lin norwich_PN = mkTerm "norwich_PN" ;
lin nose_N = mkTerm "nose_N" ;
lin nose_V = mkTerm "nose_V" ;
lin nose_V2 = mkTerm "nose_V2" ;
lin nose_about_V = mkTerm "nose_about_V" ;
lin nose_around_V = mkTerm "nose_around_V" ;
lin nose_around_V2 = mkTerm "nose_around_V2" ;
lin nose_flute_N = mkTerm "nose_flute_N" ;
lin nose_out_V2 = mkTerm "nose_out_V2" ;
lin nose_wheel_N = mkTerm "nose_wheel_N" ;
lin nosebag_N = mkTerm "nosebag_N" ;
lin noseband_N = mkTerm "noseband_N" ;
lin nosebleed_N = mkTerm "nosebleed_N" ;
lin nosecone_N = mkTerm "nosecone_N" ;
lin nosedive_N = mkTerm "nosedive_N" ;
lin nosedive_V = mkTerm "nosedive_V" ;
lin nosegay_N = mkTerm "nosegay_N" ;
lin noseless_A = mkTerm "noseless_A" ;
lin nosepiece_N = mkTerm "nosepiece_N" ;
lin nosering_N = mkTerm "nosering_N" ;
lin nosey_A = mkTerm "nosey_A" ;
lin nosh_N = mkTerm "nosh_N" ;
lin nosh_V = mkTerm "nosh_V" ;
lin nosh_up_N = mkTerm "nosh_up_N" ;
lin nosher_N = mkTerm "nosher_N" ;
lin nosiness_N = mkTerm "nosiness_N" ;
lin nosocomial_A = mkTerm "nosocomial_A" ;
lin nosohusial_A = mkTerm "nosohusial_A" ;
lin nosology_N = mkTerm "nosology_N" ;
lin nostalgia_N = mkTerm "nostalgia_N" ;
lin nostalgic_A = mkTerm "nostalgic_A" ;
lin nostalgically_Adv = mkTerm "nostalgically_Adv" ;
lin nostoc_N = mkTerm "nostoc_N" ;
lin nostril_N = mkTerm "nostril_N" ;
lin nostrum_N = mkTerm "nostrum_N" ;
lin nosy_A = mkTerm "nosy_A" ;
lin notability_N = mkTerm "notability_N" ;
lin notable_A = mkTerm "notable_A" ;
lin notable_N = mkTerm "notable_N" ;
lin notary_N = mkTerm "notary_N" ;
lin notation_N = mkTerm "notation_N" ;
lin notch_N = mkTerm "notch_N" ;
lin notch_V2 = mkTerm "notch_V2" ;
lin note_1_N = mkTerm "note_1_N" ;
lin note_2_N = mkTerm "note_2_N" ;
lin note_3_N = mkTerm "note_3_N" ;
lin note_V = mkTerm "note_V" ;
lin note_V2 = mkTerm "note_V2" ;
lin note_VS = mkTerm "note_VS" ;
lin note_down_V2 = mkTerm "note_down_V2" ;
lin notebook_N = mkTerm "notebook_N" ;
lin notecase_N = mkTerm "notecase_N" ;
lin noted_A = mkTerm "noted_A" ;
lin notepad_N = mkTerm "notepad_N" ;
lin notepaper_N = mkTerm "notepaper_N" ;
lin noteworthy_A = mkTerm "noteworthy_A" ;
lin nothing_Adv = mkTerm "nothing_Adv" ;
lin nothing_N = mkTerm "nothing_N" ;
lin nothingness_N = mkTerm "nothingness_N" ;
lin nothings_N = mkTerm "nothings_N" ;
lin nothosaur_N = mkTerm "nothosaur_N" ;
lin notice_N = mkTerm "notice_N" ;
lin notice_V2 = mkTerm "notice_V2" ;
lin notice_VS = mkTerm "notice_VS" ;
lin notice_board_N = mkTerm "notice_board_N" ;
lin noticeable_A = mkTerm "noticeable_A" ;
lin noticer_N = mkTerm "noticer_N" ;
lin notifiable_A = mkTerm "notifiable_A" ;
lin notification_N = mkTerm "notification_N" ;
lin notify_V2 = mkTerm "notify_V2" ;
lin notion_N = mkTerm "notion_N" ;
lin notional_A = mkTerm "notional_A" ;
lin notochord_N = mkTerm "notochord_N" ;
lin notoriety_N = mkTerm "notoriety_N" ;
lin notorious_A = mkTerm "notorious_A" ;
lin notornis_N = mkTerm "notornis_N" ;
lin nottingham_PN = mkTerm "nottingham_PN" ;
lin nottinghamshire_PN = mkTerm "nottinghamshire_PN" ;
lin notwithstanding_Adv = mkTerm "notwithstanding_Adv" ;
lin notwithstanding_Prep = mkTerm "notwithstanding_Prep" ;
lin nougat_N = mkTerm "nougat_N" ;
lin nought_N = mkTerm "nought_N" ;
lin noumenon_N = mkTerm "noumenon_N" ;
lin noun_N = mkTerm "noun_N" ;
lin nourish_V2 = mkTerm "nourish_V2" ;
lin nourishment_N = mkTerm "nourishment_N" ;
lin nous_N = mkTerm "nous_N" ;
lin nousiainen_PN = mkTerm "nousiainen_PN" ;
lin nouveau_riche_N = mkTerm "nouveau_riche_N" ;
lin nov_PN = mkTerm "nov_PN" ;
lin nova_N = mkTerm "nova_N" ;
lin nova_scotia_PN = mkTerm "nova_scotia_PN" ;
lin novara_PN = mkTerm "novara_PN" ;
lin novation_N = mkTerm "novation_N" ;
lin novel_A = mkTerm "novel_A" ;
lin novel_N = mkTerm "novel_N" ;
lin novelette_N = mkTerm "novelette_N" ;
lin novelist_N = mkTerm "novelist_N" ;
lin novelization_N = mkTerm "novelization_N" ;
lin novella_N = mkTerm "novella_N" ;
lin novelty_N = mkTerm "novelty_N" ;
lin novena_N = mkTerm "novena_N" ;
lin novice_N = mkTerm "novice_N" ;
lin noviciate_N = mkTerm "noviciate_N" ;
lin novillada_N = mkTerm "novillada_N" ;
lin novillero_N = mkTerm "novillero_N" ;
lin novitiate_N = mkTerm "novitiate_N" ;
lin novobiocin_N = mkTerm "novobiocin_N" ;
lin novokuznetsk_PN = mkTerm "novokuznetsk_PN" ;
lin novosibirsk_PN = mkTerm "novosibirsk_PN" ;
lin now_AdV = mkTerm "now_AdV" ;
lin now_Adv = mkTerm "now_Adv" ;
lin now_N = mkTerm "now_N" ;
lin now_and_again_Adv = mkTerm "now_and_again_Adv" ;
lin now_and_then_Adv = mkTerm "now_and_then_Adv" ;
lin nowadays_Adv = mkTerm "nowadays_Adv" ;
lin nowhere_Adv = mkTerm "nowhere_Adv" ;
lin nowhere_N = mkTerm "nowhere_N" ;
lin nowise_Adv = mkTerm "nowise_Adv" ;
lin noxious_A = mkTerm "noxious_A" ;
lin noxiousness_N = mkTerm "noxiousness_N" ;
lin nozzle_N = mkTerm "nozzle_N" ;
lin nr_PN = mkTerm "nr_PN" ;
lin nspcc_N = mkTerm "nspcc_N" ;
lin nt_N = mkTerm "nt_N" ;
lin nth_A = mkTerm "nth_A" ;
lin nu_N = mkTerm "nu_N" ;
lin nuance_N = mkTerm "nuance_N" ;
lin nub_N = mkTerm "nub_N" ;
lin nubbin_N = mkTerm "nubbin_N" ;
lin nubile_A = mkTerm "nubile_A" ;
lin nucellus_N = mkTerm "nucellus_N" ;
lin nuclear_A = mkTerm "nuclear_A" ;
lin nuclease_N = mkTerm "nuclease_N" ;
lin nucleated_A = mkTerm "nucleated_A" ;
lin nucleic_A = mkTerm "nucleic_A" ;
lin nucleolus_N = mkTerm "nucleolus_N" ;
lin nucleon_N = mkTerm "nucleon_N" ;
lin nucleoplasm_N = mkTerm "nucleoplasm_N" ;
lin nucleoprotein_N = mkTerm "nucleoprotein_N" ;
lin nucleoside_N = mkTerm "nucleoside_N" ;
lin nucleosynthesis_N = mkTerm "nucleosynthesis_N" ;
lin nucleotide_N = mkTerm "nucleotide_N" ;
lin nucleus_N = mkTerm "nucleus_N" ;
lin nude_A = mkTerm "nude_A" ;
lin nude_N = mkTerm "nude_N" ;
lin nudge_N = mkTerm "nudge_N" ;
lin nudge_V2 = mkTerm "nudge_V2" ;
lin nudger_N = mkTerm "nudger_N" ;
lin nudism_N = mkTerm "nudism_N" ;
lin nudist_N = mkTerm "nudist_N" ;
lin nudity_N = mkTerm "nudity_N" ;
lin nudnik_N = mkTerm "nudnik_N" ;
lin nugatory_A = mkTerm "nugatory_A" ;
lin nugget_N = mkTerm "nugget_N" ;
lin nuijamaa_PN = mkTerm "nuijamaa_PN" ;
lin nuisance_N = mkTerm "nuisance_N" ;
lin null_A = mkTerm "null_A" ;
lin nullah_N = mkTerm "nullah_N" ;
lin nullification_N = mkTerm "nullification_N" ;
lin nullifier_N = mkTerm "nullifier_N" ;
lin nullify_V2 = mkTerm "nullify_V2" ;
lin nullipara_N = mkTerm "nullipara_N" ;
lin nullity_N = mkTerm "nullity_N" ;
lin numb_A = mkTerm "numb_A" ;
lin numb_V2 = mkTerm "numb_V2" ;
lin numbat_N = mkTerm "numbat_N" ;
lin number_1_N = mkTerm "number_1_N" ;
lin number_2_N = mkTerm "number_2_N" ;
lin number_3_N = mkTerm "number_3_N" ;
lin number_V2 = mkTerm "number_V2" ;
lin numberless_A = mkTerm "numberless_A" ;
lin numberplate_N = mkTerm "numberplate_N" ;
lin numbing_A = mkTerm "numbing_A" ;
lin numbness_N = mkTerm "numbness_N" ;
lin numdah_N = mkTerm "numdah_N" ;
lin numen_N = mkTerm "numen_N" ;
lin numerable_A = mkTerm "numerable_A" ;
lin numeracy_N = mkTerm "numeracy_N" ;
lin numeral_A = mkTerm "numeral_A" ;
lin numeral_N = mkTerm "numeral_N" ;
lin numerate_A = mkTerm "numerate_A" ;
lin numeration_N = mkTerm "numeration_N" ;
lin numerator_N = mkTerm "numerator_N" ;
lin numeric_A = mkTerm "numeric_A" ;
lin numerical_A = mkTerm "numerical_A" ;
lin numerological_A = mkTerm "numerological_A" ;
lin numerologistFem_N = mkTerm "numerologistFem_N" ;
lin numerologistMasc_N = mkTerm "numerologistMasc_N" ;
lin numerology_N = mkTerm "numerology_N" ;
lin numerous_A = mkTerm "numerous_A" ;
lin numerousness_N = mkTerm "numerousness_N" ;
lin numinous_A = mkTerm "numinous_A" ;
lin numismatics_N = mkTerm "numismatics_N" ;
lin numismatist_N = mkTerm "numismatist_N" ;
lin nummulite_N = mkTerm "nummulite_N" ;
lin numskull_N = mkTerm "numskull_N" ;
lin nun_N = mkTerm "nun_N" ;
lin nuncio_N = mkTerm "nuncio_N" ;
lin nuneaton_PN = mkTerm "nuneaton_PN" ;
lin nunnery_N = mkTerm "nunnery_N" ;
lin nuptial_A = mkTerm "nuptial_A" ;
lin nurenburg_PN = mkTerm "nurenburg_PN" ;
lin nurmes_PN = mkTerm "nurmes_PN" ;
lin nurmijärvi_PN = mkTerm "nurmijärvi_PN" ;
lin nurmo_PN = mkTerm "nurmo_PN" ;
lin nurse_N = mkTerm "nurse_N" ;
lin nurse_V2 = mkTerm "nurse_V2" ;
lin nurseling_N = mkTerm "nurseling_N" ;
lin nursemaid_N = mkTerm "nursemaid_N" ;
lin nurser_N = mkTerm "nurser_N" ;
lin nursery_N = mkTerm "nursery_N" ;
lin nurseryman_N = mkTerm "nurseryman_N" ;
lin nursing_A = mkTerm "nursing_A" ;
lin nursing_N = mkTerm "nursing_N" ;
lin nursing_home_N = mkTerm "nursing_home_N" ;
lin nursling_N = mkTerm "nursling_N" ;
lin nurtural_A = mkTerm "nurtural_A" ;
lin nurturance_N = mkTerm "nurturance_N" ;
lin nurturant_A = mkTerm "nurturant_A" ;
lin nurture_N = mkTerm "nurture_N" ;
lin nurture_V2 = mkTerm "nurture_V2" ;
lin nut_N = mkTerm "nut_N" ;
lin nut_V = mkTerm "nut_V" ;
lin nut_brown_A = mkTerm "nut_brown_A" ;
lin nut_butter_N = mkTerm "nut_butter_N" ;
lin nut_out_V2 = mkTerm "nut_out_V2" ;
lin nutation_N = mkTerm "nutation_N" ;
lin nutcracker_N = mkTerm "nutcracker_N" ;
lin nutgrass_N = mkTerm "nutgrass_N" ;
lin nuthatch_N = mkTerm "nuthatch_N" ;
lin nuthouse_N = mkTerm "nuthouse_N" ;
lin nutlet_N = mkTerm "nutlet_N" ;
lin nutlike_A = mkTerm "nutlike_A" ;
lin nutmeg_N = mkTerm "nutmeg_N" ;
lin nutria_N = mkTerm "nutria_N" ;
lin nutrient_A = mkTerm "nutrient_A" ;
lin nutrient_N = mkTerm "nutrient_N" ;
lin nutriment_N = mkTerm "nutriment_N" ;
lin nutrition_N = mkTerm "nutrition_N" ;
lin nutritional_A = mkTerm "nutritional_A" ;
lin nutritious_A = mkTerm "nutritious_A" ;
lin nutritiousness_N = mkTerm "nutritiousness_N" ;
lin nutritive_A = mkTerm "nutritive_A" ;
lin nuts_A = mkTerm "nuts_A" ;
lin nutshell_N = mkTerm "nutshell_N" ;
lin nutter_N = mkTerm "nutter_N" ;
lin nutty_A = mkTerm "nutty_A" ;
lin nuzzle_V = mkTerm "nuzzle_V" ;
lin nuzzle_V2 = mkTerm "nuzzle_V2" ;
lin nyala_N = mkTerm "nyala_N" ;
lin nybble_N = mkTerm "nybble_N" ;
lin nyctalopia_N = mkTerm "nyctalopia_N" ;
lin nyctophobia_N = mkTerm "nyctophobia_N" ;
lin nykarleby_PN = mkTerm "nykarleby_PN" ;
lin nylon_N = mkTerm "nylon_N" ;
lin nylons_N = mkTerm "nylons_N" ;
lin nymph_N = mkTerm "nymph_N" ;
lin nymphalid_N = mkTerm "nymphalid_N" ;
lin nymphet_N = mkTerm "nymphet_N" ;
lin nympho_N = mkTerm "nympho_N" ;
lin nympholepsy_N = mkTerm "nympholepsy_N" ;
lin nympholept_N = mkTerm "nympholept_N" ;
lin nymphomania_N = mkTerm "nymphomania_N" ;
lin nymphomaniac_A = mkTerm "nymphomaniac_A" ;
lin nymphomaniac_N = mkTerm "nymphomaniac_N" ;
lin nymphomaniacal_A = mkTerm "nymphomaniacal_A" ;
lin nystagmus_N = mkTerm "nystagmus_N" ;
lin nystatin_N = mkTerm "nystatin_N" ;
lin närpes_PN = mkTerm "närpes_PN" ;
lin o'er_Adv = mkTerm "o'er_Adv" ;
lin o_level_N = mkTerm "o_level_N" ;
lin oaf_N = mkTerm "oaf_N" ;
lin oafish_A = mkTerm "oafish_A" ;
lin oak_N = mkTerm "oak_N" ;
lin oak_apple_N = mkTerm "oak_apple_N" ;
lin oaken_A = mkTerm "oaken_A" ;
lin oakengates_PN = mkTerm "oakengates_PN" ;
lin oakum_N = mkTerm "oakum_N" ;
lin oap_N = mkTerm "oap_N" ;
lin oar_N = mkTerm "oar_N" ;
lin oarfish_N = mkTerm "oarfish_N" ;
lin oarsman_N = mkTerm "oarsman_N" ;
lin oarsmanship_N = mkTerm "oarsmanship_N" ;
lin oarswoman_N = mkTerm "oarswoman_N" ;
lin oasis_N = mkTerm "oasis_N" ;
lin oast_N = mkTerm "oast_N" ;
lin oasthouse_N = mkTerm "oasthouse_N" ;
lin oat_N = mkTerm "oat_N" ;
lin oatcake_N = mkTerm "oatcake_N" ;
lin oaten_A = mkTerm "oaten_A" ;
lin oath_N = mkTerm "oath_N" ;
lin oatmeal_N = mkTerm "oatmeal_N" ;
lin oau_N = mkTerm "oau_N" ;
lin ob_PN = mkTerm "ob_PN" ;
lin oban_PN = mkTerm "oban_PN" ;
lin obbligato_N = mkTerm "obbligato_N" ;
lin obduracy_N = mkTerm "obduracy_N" ;
lin obdurate_A = mkTerm "obdurate_A" ;
lin obeah_N = mkTerm "obeah_N" ;
lin obeche_N = mkTerm "obeche_N" ;
lin obedience_N = mkTerm "obedience_N" ;
lin obedient_A = mkTerm "obedient_A" ;
lin obeisance_N = mkTerm "obeisance_N" ;
lin obelion_N = mkTerm "obelion_N" ;
lin obelisk_N = mkTerm "obelisk_N" ;
lin oberhausen_PN = mkTerm "oberhausen_PN" ;
lin obese_A = mkTerm "obese_A" ;
lin obesity_N = mkTerm "obesity_N" ;
lin obey_V = mkTerm "obey_V" ;
lin obey_V2 = mkTerm "obey_V2" ;
lin obfuscate_V2 = mkTerm "obfuscate_V2" ;
lin obfuscation_N = mkTerm "obfuscation_N" ;
lin obi_N = mkTerm "obi_N" ;
lin obiism_N = mkTerm "obiism_N" ;
lin obiter_dictum_N = mkTerm "obiter_dictum_N" ;
lin obituary_N = mkTerm "obituary_N" ;
lin object_N = mkTerm "object_N" ;
lin object_V = mkTerm "object_V" ;
lin object_V2 = mkTerm "object_V2" ;
lin objectification_N = mkTerm "objectification_N" ;
lin objection_N = mkTerm "objection_N" ;
lin objectionable_A = mkTerm "objectionable_A" ;
lin objective_A = mkTerm "objective_A" ;
lin objective_N = mkTerm "objective_N" ;
lin objectivity_N = mkTerm "objectivity_N" ;
lin objector_N = mkTerm "objector_N" ;
lin objurgate_V2 = mkTerm "objurgate_V2" ;
lin objurgation_N = mkTerm "objurgation_N" ;
lin oblanceolate_A = mkTerm "oblanceolate_A" ;
lin oblate_A = mkTerm "oblate_A" ;
lin oblate_N = mkTerm "oblate_N" ;
lin oblateness_N = mkTerm "oblateness_N" ;
lin oblation_N = mkTerm "oblation_N" ;
lin obligate_A = mkTerm "obligate_A" ;
lin obligate_V2 = mkTerm "obligate_V2" ;
lin obligate_V2V = mkTerm "obligate_V2V" ;
lin obligation_N = mkTerm "obligation_N" ;
lin obligational_A = mkTerm "obligational_A" ;
lin obligatory_A = mkTerm "obligatory_A" ;
lin oblige_V2 = mkTerm "oblige_V2" ;
lin oblige_V2V = mkTerm "oblige_V2V" ;
lin obliger_N = mkTerm "obliger_N" ;
lin obliging_A = mkTerm "obliging_A" ;
lin oblique_A = mkTerm "oblique_A" ;
lin oblique_N = mkTerm "oblique_N" ;
lin obliqueness_N = mkTerm "obliqueness_N" ;
lin obliquity_N = mkTerm "obliquity_N" ;
lin obliterable_A = mkTerm "obliterable_A" ;
lin obliterate_V2 = mkTerm "obliterate_V2" ;
lin obliteration_N = mkTerm "obliteration_N" ;
lin obliterator_N = mkTerm "obliterator_N" ;
lin oblivion_N = mkTerm "oblivion_N" ;
lin oblivious_A = mkTerm "oblivious_A" ;
lin obliviousness_N = mkTerm "obliviousness_N" ;
lin oblong_A = mkTerm "oblong_A" ;
lin oblong_N = mkTerm "oblong_N" ;
lin obloquy_N = mkTerm "obloquy_N" ;
lin obnoxious_A = mkTerm "obnoxious_A" ;
lin obnoxiousness_N = mkTerm "obnoxiousness_N" ;
lin oboe_N = mkTerm "oboe_N" ;
lin oboist_N = mkTerm "oboist_N" ;
lin obolus_N = mkTerm "obolus_N" ;
lin obovate_A = mkTerm "obovate_A" ;
lin obscene_A = mkTerm "obscene_A" ;
lin obscenity_N = mkTerm "obscenity_N" ;
lin obscurantism_N = mkTerm "obscurantism_N" ;
lin obscurantist_N = mkTerm "obscurantist_N" ;
lin obscure_A = mkTerm "obscure_A" ;
lin obscure_V2 = mkTerm "obscure_V2" ;
lin obscureness_N = mkTerm "obscureness_N" ;
lin obscurity_N = mkTerm "obscurity_N" ;
lin obsequious_A = mkTerm "obsequious_A" ;
lin obsequiousness_N = mkTerm "obsequiousness_N" ;
lin observable_A = mkTerm "observable_A" ;
lin observance_N = mkTerm "observance_N" ;
lin observant_A = mkTerm "observant_A" ;
lin observation_N = mkTerm "observation_N" ;
lin observatory_N = mkTerm "observatory_N" ;
lin observe_V2 = mkTerm "observe_V2" ;
lin observe_VS = mkTerm "observe_VS" ;
lin observer_N = mkTerm "observer_N" ;
lin obsess_V2 = mkTerm "obsess_V2" ;
lin obsession_N = mkTerm "obsession_N" ;
lin obsessional_A = mkTerm "obsessional_A" ;
lin obsessive_A = mkTerm "obsessive_A" ;
lin obsessive_N = mkTerm "obsessive_N" ;
lin obsessiveness_N = mkTerm "obsessiveness_N" ;
lin obsidian_N = mkTerm "obsidian_N" ;
lin obsolescence_N = mkTerm "obsolescence_N" ;
lin obsolescent_A = mkTerm "obsolescent_A" ;
lin obsolete_A = mkTerm "obsolete_A" ;
lin obsoleteness_N = mkTerm "obsoleteness_N" ;
lin obstacle_N = mkTerm "obstacle_N" ;
lin obstetric_A = mkTerm "obstetric_A" ;
lin obstetrical_A = mkTerm "obstetrical_A" ;
lin obstetrician_N = mkTerm "obstetrician_N" ;
lin obstetrics_N = mkTerm "obstetrics_N" ;
lin obstinacy_N = mkTerm "obstinacy_N" ;
lin obstinate_A = mkTerm "obstinate_A" ;
lin obstipation_N = mkTerm "obstipation_N" ;
lin obstreperous_A = mkTerm "obstreperous_A" ;
lin obstreperousness_N = mkTerm "obstreperousness_N" ;
lin obstruct_V2 = mkTerm "obstruct_V2" ;
lin obstruction_N = mkTerm "obstruction_N" ;
lin obstructionism_N = mkTerm "obstructionism_N" ;
lin obstructionist_N = mkTerm "obstructionist_N" ;
lin obstructive_A = mkTerm "obstructive_A" ;
lin obstruent_N = mkTerm "obstruent_N" ;
lin obtain_V = mkTerm "obtain_V" ;
lin obtain_V2 = mkTerm "obtain_V2" ;
lin obtainable_A = mkTerm "obtainable_A" ;
lin obtainment_N = mkTerm "obtainment_N" ;
lin obtrude_V = mkTerm "obtrude_V" ;
lin obtrude_V2 = mkTerm "obtrude_V2" ;
lin obtrusive_A = mkTerm "obtrusive_A" ;
lin obtrusiveness_N = mkTerm "obtrusiveness_N" ;
lin obturator_N = mkTerm "obturator_N" ;
lin obtuse_A = mkTerm "obtuse_A" ;
lin obtuseness_N = mkTerm "obtuseness_N" ;
lin obverse_N = mkTerm "obverse_N" ;
lin obviate_V2 = mkTerm "obviate_V2" ;
lin obviation_N = mkTerm "obviation_N" ;
lin obvious_A = mkTerm "obvious_A" ;
lin obviousness_N = mkTerm "obviousness_N" ;
lin oca_N = mkTerm "oca_N" ;
lin ocarina_N = mkTerm "ocarina_N" ;
lin occasion_N = mkTerm "occasion_N" ;
lin occasion_V2 = mkTerm "occasion_V2" ;
lin occasional_A = mkTerm "occasional_A" ;
lin occasions_N = mkTerm "occasions_N" ;
lin occident_PN = mkTerm "occident_PN" ;
lin occidental_A = mkTerm "occidental_A" ;
lin occidental_N = mkTerm "occidental_N" ;
lin occidentalism_N = mkTerm "occidentalism_N" ;
lin occipital_A = mkTerm "occipital_A" ;
lin occiput_N = mkTerm "occiput_N" ;
lin occluded_A = mkTerm "occluded_A" ;
lin occlusion_N = mkTerm "occlusion_N" ;
lin occlusive_A = mkTerm "occlusive_A" ;
lin occult_A = mkTerm "occult_A" ;
lin occult_N = mkTerm "occult_N" ;
lin occultism_N = mkTerm "occultism_N" ;
lin occultist_N = mkTerm "occultist_N" ;
lin occupancy_N = mkTerm "occupancy_N" ;
lin occupant_N = mkTerm "occupant_N" ;
lin occupation_N = mkTerm "occupation_N" ;
lin occupational_A = mkTerm "occupational_A" ;
lin occupier_N = mkTerm "occupier_N" ;
lin occupy_V = mkTerm "occupy_V" ;
lin occupy_V2 = mkTerm "occupy_V2" ;
lin occur_V = mkTerm "occur_V" ;
lin occur_to_V2 = mkTerm "occur_to_V2" ;
lin occurr_V2 = mkTerm "occurr_V2" ;
lin occurrence_N = mkTerm "occurrence_N" ;
lin occurrent_A = mkTerm "occurrent_A" ;
lin ocean_N = mkTerm "ocean_N" ;
lin oceanfront_N = mkTerm "oceanfront_N" ;
lin oceangoing_A = mkTerm "oceangoing_A" ;
lin oceanic_A = mkTerm "oceanic_A" ;
lin oceanographer_N = mkTerm "oceanographer_N" ;
lin oceanography_N = mkTerm "oceanography_N" ;
lin ocellated_A = mkTerm "ocellated_A" ;
lin ocelot_N = mkTerm "ocelot_N" ;
lin ocher_A = mkTerm "ocher_A" ;
lin ocher_N = mkTerm "ocher_N" ;
lin ochre_N = mkTerm "ochre_N" ;
lin ochronosis_N = mkTerm "ochronosis_N" ;
lin ockbrook_PN = mkTerm "ockbrook_PN" ;
lin ockendon_PN = mkTerm "ockendon_PN" ;
lin oclock_Adv = mkTerm "oclock_Adv" ;
lin ocotillo_N = mkTerm "ocotillo_N" ;
lin oct_PN = mkTerm "oct_PN" ;
lin octagon_N = mkTerm "octagon_N" ;
lin octagonal_A = mkTerm "octagonal_A" ;
lin octahedron_N = mkTerm "octahedron_N" ;
lin octal_A = mkTerm "octal_A" ;
lin octameter_N = mkTerm "octameter_N" ;
lin octane_N = mkTerm "octane_N" ;
lin octangular_A = mkTerm "octangular_A" ;
lin octant_N = mkTerm "octant_N" ;
lin octave_N = mkTerm "octave_N" ;
lin octavo_N = mkTerm "octavo_N" ;
lin octet_N = mkTerm "octet_N" ;
lin octette_N = mkTerm "octette_N" ;
lin octillion_N = mkTerm "octillion_N" ;
lin octogenarian_A = mkTerm "octogenarian_A" ;
lin octogenarian_N = mkTerm "octogenarian_N" ;
lin octopod_N = mkTerm "octopod_N" ;
lin octopus_N = mkTerm "octopus_N" ;
lin octoroon_N = mkTerm "octoroon_N" ;
lin octosyllabic_A = mkTerm "octosyllabic_A" ;
lin octosyllable_N = mkTerm "octosyllable_N" ;
lin octroi_N = mkTerm "octroi_N" ;
lin octuple_A = mkTerm "octuple_A" ;
lin ocular_A = mkTerm "ocular_A" ;
lin oculism_N = mkTerm "oculism_N" ;
lin oculist_N = mkTerm "oculist_N" ;
lin oculomotor_N = mkTerm "oculomotor_N" ;
lin odalisque_N = mkTerm "odalisque_N" ;
lin odd_1_A = mkTerm "odd_1_A" ;
lin odd_2_A = mkTerm "odd_2_A" ;
lin odd_job_A = mkTerm "odd_job_A" ;
lin oddish_A = mkTerm "oddish_A" ;
lin oddity_N = mkTerm "oddity_N" ;
lin oddment_N = mkTerm "oddment_N" ;
lin oddness_N = mkTerm "oddness_N" ;
lin odds_N = mkTerm "odds_N" ;
lin odds_on_A = mkTerm "odds_on_A" ;
lin odds_on_Adv = mkTerm "odds_on_Adv" ;
lin ode_N = mkTerm "ode_N" ;
lin odessa_PN = mkTerm "odessa_PN" ;
lin odious_A = mkTerm "odious_A" ;
lin odist_N = mkTerm "odist_N" ;
lin odium_N = mkTerm "odium_N" ;
lin odometer_N = mkTerm "odometer_N" ;
lin odonate_N = mkTerm "odonate_N" ;
lin odontoglossum_N = mkTerm "odontoglossum_N" ;
lin odor_N = mkTerm "odor_N" ;
lin odoriferous_A = mkTerm "odoriferous_A" ;
lin odorless_A = mkTerm "odorless_A" ;
lin odorous_A = mkTerm "odorous_A" ;
lin odour_N = mkTerm "odour_N" ;
lin odourless_A = mkTerm "odourless_A" ;
lin odynophagia_N = mkTerm "odynophagia_N" ;
lin odyssey_N = mkTerm "odyssey_N" ;
lin oecd_N = mkTerm "oecd_N" ;
lin oecumenical_A = mkTerm "oecumenical_A" ;
lin oed_N = mkTerm "oed_N" ;
lin oedipus_PN = mkTerm "oedipus_PN" ;
lin oenomel_N = mkTerm "oenomel_N" ;
lin oersted_N = mkTerm "oersted_N" ;
lin oesophagus_N = mkTerm "oesophagus_N" ;
lin oeuvre_N = mkTerm "oeuvre_N" ;
lin of_Prep = mkTerm "of_Prep" ;
lin of_course_Adv = mkTerm "of_course_Adv" ;
lin off_A = mkTerm "off_A" ;
lin off_Adv = mkTerm "off_Adv" ;
lin off_Prep = mkTerm "off_Prep" ;
lin off_day_N = mkTerm "off_day_N" ;
lin off_licence_N = mkTerm "off_licence_N" ;
lin off_peak_A = mkTerm "off_peak_A" ;
lin off_putting_A = mkTerm "off_putting_A" ;
lin off_street_A = mkTerm "off_street_A" ;
lin off_white_A = mkTerm "off_white_A" ;
lin offal_N = mkTerm "offal_N" ;
lin offaly_PN = mkTerm "offaly_PN" ;
lin offbeat_A = mkTerm "offbeat_A" ;
lin offenbach_PN = mkTerm "offenbach_PN" ;
lin offence_N = mkTerm "offence_N" ;
lin offenceless_A = mkTerm "offenceless_A" ;
lin offend_V = mkTerm "offend_V" ;
lin offend_V2 = mkTerm "offend_V2" ;
lin offenderFem_N = mkTerm "offenderFem_N" ;
lin offenderMasc_N = mkTerm "offenderMasc_N" ;
lin offensive_A = mkTerm "offensive_A" ;
lin offensive_N = mkTerm "offensive_N" ;
lin offensiveness_N = mkTerm "offensiveness_N" ;
lin offer_N = mkTerm "offer_N" ;
lin offer_V2 = mkTerm "offer_V2" ;
lin offer_VV = mkTerm "offer_VV" ;
lin offer_up_V = mkTerm "offer_up_V" ;
lin offerer_N = mkTerm "offerer_N" ;
lin offering_N = mkTerm "offering_N" ;
lin offertory_N = mkTerm "offertory_N" ;
lin offhand_A = mkTerm "offhand_A" ;
lin offhand_Adv = mkTerm "offhand_Adv" ;
lin offhanded_A = mkTerm "offhanded_A" ;
lin offhanded_Adv = mkTerm "offhanded_Adv" ;
lin offhandedly_A = mkTerm "offhandedly_A" ;
lin office_N = mkTerm "office_N" ;
lin office_bearer_N = mkTerm "office_bearer_N" ;
lin office_block_N = mkTerm "office_block_N" ;
lin office_boy_N = mkTerm "office_boy_N" ;
lin office_holder_N = mkTerm "office_holder_N" ;
lin officer_1_N = mkTerm "officer_1_N" ;
lin officer_2_N = mkTerm "officer_2_N" ;
lin officer_3_N = mkTerm "officer_3_N" ;
lin officialFem_N = mkTerm "officialFem_N" ;
lin officialMasc_N = mkTerm "officialMasc_N" ;
lin official_A = mkTerm "official_A" ;
lin officialdom_N = mkTerm "officialdom_N" ;
lin officialese_N = mkTerm "officialese_N" ;
lin officiant_N = mkTerm "officiant_N" ;
lin officiate_V = mkTerm "officiate_V" ;
lin officiation_N = mkTerm "officiation_N" ;
lin officious_A = mkTerm "officious_A" ;
lin officiousness_N = mkTerm "officiousness_N" ;
lin offing_N = mkTerm "offing_N" ;
lin offish_A = mkTerm "offish_A" ;
lin offline_A = mkTerm "offline_A" ;
lin offprint_N = mkTerm "offprint_N" ;
lin offset_N = mkTerm "offset_N" ;
lin offset_V2 = mkTerm "offset_V2" ;
lin offshoot_N = mkTerm "offshoot_N" ;
lin offshore_A = mkTerm "offshore_A" ;
lin offshore_Adv = mkTerm "offshore_Adv" ;
lin offside_A = mkTerm "offside_A" ;
lin offside_Adv = mkTerm "offside_Adv" ;
lin offside_N = mkTerm "offside_N" ;
lin offspring_N = mkTerm "offspring_N" ;
lin offstage_A = mkTerm "offstage_A" ;
lin offstage_Adv = mkTerm "offstage_Adv" ;
lin oft_Adv = mkTerm "oft_Adv" ;
lin oft_times_Adv = mkTerm "oft_times_Adv" ;
lin often_AdA = mkTerm "often_AdA" ;
lin often_AdV = mkTerm "often_AdV" ;
lin often_Adv = mkTerm "often_Adv" ;
lin oftener_Adv = mkTerm "oftener_Adv" ;
lin ogee_N = mkTerm "ogee_N" ;
lin ogle_V = mkTerm "ogle_V" ;
lin ogle_V2 = mkTerm "ogle_V2" ;
lin ogler_N = mkTerm "ogler_N" ;
lin ogmore_valley_PN = mkTerm "ogmore_valley_PN" ;
lin ogre_N = mkTerm "ogre_N" ;
lin ogreish_A = mkTerm "ogreish_A" ;
lin ogress_N = mkTerm "ogress_N" ;
lin oh_Interj = mkTerm "oh_Interj" ;
lin ohio_PN = mkTerm "ohio_PN" ;
lin ohm_N = mkTerm "ohm_N" ;
lin ohmage_N = mkTerm "ohmage_N" ;
lin ohmic_A = mkTerm "ohmic_A" ;
lin ohmmeter_N = mkTerm "ohmmeter_N" ;
lin oil_N = mkTerm "oil_N" ;
lin oil_V2 = mkTerm "oil_V2" ;
lin oil_bearing_A = mkTerm "oil_bearing_A" ;
lin oil_burner_N = mkTerm "oil_burner_N" ;
lin oil_cake_N = mkTerm "oil_cake_N" ;
lin oil_painting_N = mkTerm "oil_painting_N" ;
lin oil_palm_N = mkTerm "oil_palm_N" ;
lin oil_paper_N = mkTerm "oil_paper_N" ;
lin oil_rig_N = mkTerm "oil_rig_N" ;
lin oil_silk_N = mkTerm "oil_silk_N" ;
lin oil_slick_N = mkTerm "oil_slick_N" ;
lin oil_tanker_N = mkTerm "oil_tanker_N" ;
lin oil_well_N = mkTerm "oil_well_N" ;
lin oilbird_N = mkTerm "oilbird_N" ;
lin oilcan_N = mkTerm "oilcan_N" ;
lin oilcloth_N = mkTerm "oilcloth_N" ;
lin oiler_N = mkTerm "oiler_N" ;
lin oilfield_N = mkTerm "oilfield_N" ;
lin oilfired_A = mkTerm "oilfired_A" ;
lin oilfish_N = mkTerm "oilfish_N" ;
lin oiliness_N = mkTerm "oiliness_N" ;
lin oilman_N = mkTerm "oilman_N" ;
lin oilseed_N = mkTerm "oilseed_N" ;
lin oilskin_N = mkTerm "oilskin_N" ;
lin oilstone_N = mkTerm "oilstone_N" ;
lin oily_A = mkTerm "oily_A" ;
lin ointment_N = mkTerm "ointment_N" ;
lin oitti_PN = mkTerm "oitti_PN" ;
lin ok_Interj = mkTerm "ok_Interj" ;
lin oka_N = mkTerm "oka_N" ;
lin okapi_N = mkTerm "okapi_N" ;
lin okay_A = mkTerm "okay_A" ;
lin okay_Adv = mkTerm "okay_Adv" ;
lin okay_Interj = mkTerm "okay_Interj" ;
lin okay_V2 = mkTerm "okay_V2" ;
lin oklahoma_PN = mkTerm "oklahoma_PN" ;
lin oklahoma_city_PN = mkTerm "oklahoma_city_PN" ;
lin okra_N = mkTerm "okra_N" ;
lin ola_N = mkTerm "ola_N" ;
lin old_A = mkTerm "old_A" ;
lin old_N = mkTerm "old_N" ;
lin old_fashioned_A = mkTerm "old_fashioned_A" ;
lin old_maidish_A = mkTerm "old_maidish_A" ;
lin old_time_A = mkTerm "old_time_A" ;
lin old_timer_N = mkTerm "old_timer_N" ;
lin old_windsor_PN = mkTerm "old_windsor_PN" ;
lin old_womanish_A = mkTerm "old_womanish_A" ;
lin old_world_A = mkTerm "old_world_A" ;
lin olden_A = mkTerm "olden_A" ;
lin oldenburg_PN = mkTerm "oldenburg_PN" ;
lin oldham_PN = mkTerm "oldham_PN" ;
lin oldie_N = mkTerm "oldie_N" ;
lin oldish_A = mkTerm "oldish_A" ;
lin oldland_PN = mkTerm "oldland_PN" ;
lin oldline_A = mkTerm "oldline_A" ;
lin oldness_N = mkTerm "oldness_N" ;
lin oldster_N = mkTerm "oldster_N" ;
lin oleaceous_A = mkTerm "oleaceous_A" ;
lin oleaginous_A = mkTerm "oleaginous_A" ;
lin oleander_N = mkTerm "oleander_N" ;
lin oleaster_N = mkTerm "oleaster_N" ;
lin olecranon_N = mkTerm "olecranon_N" ;
lin oleophilic_A = mkTerm "oleophilic_A" ;
lin oleophobic_A = mkTerm "oleophobic_A" ;
lin oleoresin_N = mkTerm "oleoresin_N" ;
lin olfactory_A = mkTerm "olfactory_A" ;
lin oligarch_N = mkTerm "oligarch_N" ;
lin oligarchic_A = mkTerm "oligarchic_A" ;
lin oligarchy_N = mkTerm "oligarchy_N" ;
lin oligochaete_N = mkTerm "oligochaete_N" ;
lin oligodactyly_N = mkTerm "oligodactyly_N" ;
lin oligodendrocyte_N = mkTerm "oligodendrocyte_N" ;
lin oligodendroglia_N = mkTerm "oligodendroglia_N" ;
lin oligodontia_N = mkTerm "oligodontia_N" ;
lin oligomenorrhea_N = mkTerm "oligomenorrhea_N" ;
lin oligopoly_N = mkTerm "oligopoly_N" ;
lin oligosaccharide_N = mkTerm "oligosaccharide_N" ;
lin oligospermia_N = mkTerm "oligospermia_N" ;
lin oliguria_N = mkTerm "oliguria_N" ;
lin olive_A = mkTerm "olive_A" ;
lin olive_N = mkTerm "olive_N" ;
lin olive_PN = mkTerm "olive_PN" ;
lin olive_tree_N = mkTerm "olive_tree_N" ;
lin olivelike_A = mkTerm "olivelike_A" ;
lin olivenite_N = mkTerm "olivenite_N" ;
lin oliver_PN = mkTerm "oliver_PN" ;
lin olivia_PN = mkTerm "olivia_PN" ;
lin olivine_N = mkTerm "olivine_N" ;
lin ollerton_PN = mkTerm "ollerton_PN" ;
lin ollie_PN = mkTerm "ollie_PN" ;
lin olm_N = mkTerm "olm_N" ;
lin ology_N = mkTerm "ology_N" ;
lin olympiad_N = mkTerm "olympiad_N" ;
lin olympian_A = mkTerm "olympian_A" ;
lin olympian_N = mkTerm "olympian_N" ;
lin olympic_A = mkTerm "olympic_A" ;
lin olympics_PN = mkTerm "olympics_PN" ;
lin oman_PN = mkTerm "oman_PN" ;
lin omani_A = mkTerm "omani_A" ;
lin omani_N = mkTerm "omani_N" ;
lin ombu_N = mkTerm "ombu_N" ;
lin ombudsman_N = mkTerm "ombudsman_N" ;
lin omega_N = mkTerm "omega_N" ;
lin omelet_N = mkTerm "omelet_N" ;
lin omelette_N = mkTerm "omelette_N" ;
lin omen_N = mkTerm "omen_N" ;
lin omen_V2 = mkTerm "omen_V2" ;
lin omentum_N = mkTerm "omentum_N" ;
lin omeprazole_N = mkTerm "omeprazole_N" ;
lin omerta_N = mkTerm "omerta_N" ;
lin omicron_N = mkTerm "omicron_N" ;
lin ominous_A = mkTerm "ominous_A" ;
lin omissible_A = mkTerm "omissible_A" ;
lin omission_N = mkTerm "omission_N" ;
lin omissive_A = mkTerm "omissive_A" ;
lin omit_V2 = mkTerm "omit_V2" ;
lin ommastrephes_N = mkTerm "ommastrephes_N" ;
lin ommatidium_N = mkTerm "ommatidium_N" ;
lin omnibus_N = mkTerm "omnibus_N" ;
lin omnidirectional_A = mkTerm "omnidirectional_A" ;
lin omnifarious_A = mkTerm "omnifarious_A" ;
lin omnipotence_N = mkTerm "omnipotence_N" ;
lin omnipotent_A = mkTerm "omnipotent_A" ;
lin omnipresent_A = mkTerm "omnipresent_A" ;
lin omnirange_N = mkTerm "omnirange_N" ;
lin omniscience_N = mkTerm "omniscience_N" ;
lin omniscient_A = mkTerm "omniscient_A" ;
lin omnivore_N = mkTerm "omnivore_N" ;
lin omnivorous_A = mkTerm "omnivorous_A" ;
lin omophagia_N = mkTerm "omophagia_N" ;
lin omphaloskepsis_N = mkTerm "omphaloskepsis_N" ;
lin omsk_PN = mkTerm "omsk_PN" ;
lin on_Adv = mkTerm "on_Adv" ;
lin on_account_of_Prep = mkTerm "on_account_of_Prep" ;
lin on_behalf_of_Prep = mkTerm "on_behalf_of_Prep" ;
lin on_licence_N = mkTerm "on_licence_N" ;
lin on_occasion_Adv = mkTerm "on_occasion_Adv" ;
lin on_top_of_Prep = mkTerm "on_top_of_Prep" ;
lin onager_N = mkTerm "onager_N" ;
lin onboard_A = mkTerm "onboard_A" ;
lin once_AdV = mkTerm "once_AdV" ;
lin once_Adv = mkTerm "once_Adv" ;
lin once_Prep = mkTerm "once_Prep" ;
lin once_Subj = mkTerm "once_Subj" ;
lin once_in_a_while_Adv = mkTerm "once_in_a_while_Adv" ;
lin onchocerciasis_N = mkTerm "onchocerciasis_N" ;
lin oncidium_N = mkTerm "oncidium_N" ;
lin oncogene_N = mkTerm "oncogene_N" ;
lin oncological_A = mkTerm "oncological_A" ;
lin oncologist_N = mkTerm "oncologist_N" ;
lin oncology_N = mkTerm "oncology_N" ;
lin oncoming_A = mkTerm "oncoming_A" ;
lin oncoming_N = mkTerm "oncoming_N" ;
lin one_armed_A = mkTerm "one_armed_A" ;
lin one_eyed_A = mkTerm "one_eyed_A" ;
lin one_horse_A = mkTerm "one_horse_A" ;
lin one_idea'd_A = mkTerm "one_idea'd_A" ;
lin one_sided_A = mkTerm "one_sided_A" ;
lin one_step_N = mkTerm "one_step_N" ;
lin one_time_A = mkTerm "one_time_A" ;
lin one_upmanship_N = mkTerm "one_upmanship_N" ;
lin oneiric_A = mkTerm "oneiric_A" ;
lin oneiromancer_N = mkTerm "oneiromancer_N" ;
lin oneiromancy_N = mkTerm "oneiromancy_N" ;
lin oneness_N = mkTerm "oneness_N" ;
lin onerous_A = mkTerm "onerous_A" ;
lin ongar_PN = mkTerm "ongar_PN" ;
lin ongoing_A = mkTerm "ongoing_A" ;
lin onion_N = mkTerm "onion_N" ;
lin onionskin_N = mkTerm "onionskin_N" ;
lin online_A = mkTerm "online_A" ;
lin onlooker_N = mkTerm "onlooker_N" ;
lin only_Adv = mkTerm "only_Adv" ;
lin onomancer_N = mkTerm "onomancer_N" ;
lin onomancy_N = mkTerm "onomancy_N" ;
lin onomastic_A = mkTerm "onomastic_A" ;
lin onomasticon_N = mkTerm "onomasticon_N" ;
lin onomastics_N = mkTerm "onomastics_N" ;
lin onomatomania_N = mkTerm "onomatomania_N" ;
lin onomatopoeia_N = mkTerm "onomatopoeia_N" ;
lin onomatopoeic_A = mkTerm "onomatopoeic_A" ;
lin onrush_N = mkTerm "onrush_N" ;
lin onset_N = mkTerm "onset_N" ;
lin onshore_A = mkTerm "onshore_A" ;
lin onshore_Adv = mkTerm "onshore_Adv" ;
lin onside_A = mkTerm "onside_A" ;
lin onslaught_N = mkTerm "onslaught_N" ;
lin onstage_A = mkTerm "onstage_A" ;
lin onstage_Adv = mkTerm "onstage_Adv" ;
lin ontario_PN = mkTerm "ontario_PN" ;
lin onto_Prep = mkTerm "onto_Prep" ;
lin ontogenetic_A = mkTerm "ontogenetic_A" ;
lin ontological_A = mkTerm "ontological_A" ;
lin ontology_N = mkTerm "ontology_N" ;
lin onus_N = mkTerm "onus_N" ;
lin onward_A = mkTerm "onward_A" ;
lin onward_Adv = mkTerm "onward_Adv" ;
lin onwards_Adv = mkTerm "onwards_Adv" ;
lin onycholysis_N = mkTerm "onycholysis_N" ;
lin onychophoran_N = mkTerm "onychophoran_N" ;
lin onychosis_N = mkTerm "onychosis_N" ;
lin onymous_A = mkTerm "onymous_A" ;
lin onyx_N = mkTerm "onyx_N" ;
lin oocyte_N = mkTerm "oocyte_N" ;
lin oogenesis_N = mkTerm "oogenesis_N" ;
lin oology_N = mkTerm "oology_N" ;
lin oolong_N = mkTerm "oolong_N" ;
lin oomph_N = mkTerm "oomph_N" ;
lin oophorectomy_N = mkTerm "oophorectomy_N" ;
lin oophoritis_N = mkTerm "oophoritis_N" ;
lin oophorosalpingectomy_N = mkTerm "oophorosalpingectomy_N" ;
lin oosphere_N = mkTerm "oosphere_N" ;
lin oospore_N = mkTerm "oospore_N" ;
lin ootid_N = mkTerm "ootid_N" ;
lin ooze_N = mkTerm "ooze_N" ;
lin ooze_V = mkTerm "ooze_V" ;
lin ooze_V2 = mkTerm "ooze_V2" ;
lin oozy_A = mkTerm "oozy_A" ;
lin op_PN = mkTerm "op_PN" ;
lin op_art_N = mkTerm "op_art_N" ;
lin op_cit_PN = mkTerm "op_cit_PN" ;
lin opacification_N = mkTerm "opacification_N" ;
lin opacity_N = mkTerm "opacity_N" ;
lin opah_N = mkTerm "opah_N" ;
lin opal_N = mkTerm "opal_N" ;
lin opalescence_N = mkTerm "opalescence_N" ;
lin opalescent_A = mkTerm "opalescent_A" ;
lin opaque_A = mkTerm "opaque_A" ;
lin opaqueness_N = mkTerm "opaqueness_N" ;
lin opec_PN = mkTerm "opec_PN" ;
lin open_A = mkTerm "open_A" ;
lin open_Adv = mkTerm "open_Adv" ;
lin open_N = mkTerm "open_N" ;
lin open_V = mkTerm "open_V" ;
lin open_V2 = mkTerm "open_V2" ;
lin open_air_A = mkTerm "open_air_A" ;
lin open_ended_A = mkTerm "open_ended_A" ;
lin open_eyed_A = mkTerm "open_eyed_A" ;
lin open_handed_A = mkTerm "open_handed_A" ;
lin open_hearted_A = mkTerm "open_hearted_A" ;
lin open_minded_A = mkTerm "open_minded_A" ;
lin open_mouthed_A = mkTerm "open_mouthed_A" ;
lin open_up_V = mkTerm "open_up_V" ;
lin open_up_V2 = mkTerm "open_up_V2" ;
lin openbill_N = mkTerm "openbill_N" ;
lin opencast_A = mkTerm "opencast_A" ;
lin opener_N = mkTerm "opener_N" ;
lin opening_A = mkTerm "opening_A" ;
lin opening_N = mkTerm "opening_N" ;
lin openness_N = mkTerm "openness_N" ;
lin openwork_N = mkTerm "openwork_N" ;
lin opepe_N = mkTerm "opepe_N" ;
lin opera_N = mkTerm "opera_N" ;
lin opera_cloak_N = mkTerm "opera_cloak_N" ;
lin opera_hat_N = mkTerm "opera_hat_N" ;
lin opera_house_N = mkTerm "opera_house_N" ;
lin operable_A = mkTerm "operable_A" ;
lin operagoer_N = mkTerm "operagoer_N" ;
lin operand_N = mkTerm "operand_N" ;
lin operant_A = mkTerm "operant_A" ;
lin operate_V = mkTerm "operate_V" ;
lin operate_V2 = mkTerm "operate_V2" ;
lin operate_on_V2 = mkTerm "operate_on_V2" ;
lin operatic_A = mkTerm "operatic_A" ;
lin operating_N = mkTerm "operating_N" ;
lin operating_table_N = mkTerm "operating_table_N" ;
lin operating_theatre_N = mkTerm "operating_theatre_N" ;
lin operation_N = mkTerm "operation_N" ;
lin operational_A = mkTerm "operational_A" ;
lin operationalism_N = mkTerm "operationalism_N" ;
lin operationalist_A = mkTerm "operationalist_A" ;
lin operations_N = mkTerm "operations_N" ;
lin operative_A = mkTerm "operative_A" ;
lin operative_N = mkTerm "operative_N" ;
lin operator_N = mkTerm "operator_N" ;
lin operculate_A = mkTerm "operculate_A" ;
lin operculum_N = mkTerm "operculum_N" ;
lin operetta_N = mkTerm "operetta_N" ;
lin operon_N = mkTerm "operon_N" ;
lin ophidism_N = mkTerm "ophidism_N" ;
lin ophiolatry_N = mkTerm "ophiolatry_N" ;
lin ophryon_N = mkTerm "ophryon_N" ;
lin ophthalmectomy_N = mkTerm "ophthalmectomy_N" ;
lin ophthalmia_N = mkTerm "ophthalmia_N" ;
lin ophthalmic_A = mkTerm "ophthalmic_A" ;
lin ophthalmologist_N = mkTerm "ophthalmologist_N" ;
lin ophthalmology_N = mkTerm "ophthalmology_N" ;
lin ophthalmoplegia_N = mkTerm "ophthalmoplegia_N" ;
lin ophthalmoscope_N = mkTerm "ophthalmoscope_N" ;
lin ophthalmoscopy_N = mkTerm "ophthalmoscopy_N" ;
lin opiate_N = mkTerm "opiate_N" ;
lin opine_V2 = mkTerm "opine_V2" ;
lin opine_VS = mkTerm "opine_VS" ;
lin opinion_N = mkTerm "opinion_N" ;
lin opinionated_A = mkTerm "opinionated_A" ;
lin opinionative_A = mkTerm "opinionative_A" ;
lin opisthognathous_A = mkTerm "opisthognathous_A" ;
lin opisthorchiasis_N = mkTerm "opisthorchiasis_N" ;
lin opisthotonos_N = mkTerm "opisthotonos_N" ;
lin opium_N = mkTerm "opium_N" ;
lin opium_den_N = mkTerm "opium_den_N" ;
lin opopanax_N = mkTerm "opopanax_N" ;
lin opossum_N = mkTerm "opossum_N" ;
lin opp_PN = mkTerm "opp_PN" ;
lin opponentFem_N = mkTerm "opponentFem_N" ;
lin opponentMasc_N = mkTerm "opponentMasc_N" ;
lin opponent_A = mkTerm "opponent_A" ;
lin opportune_A = mkTerm "opportune_A" ;
lin opportuneness_N = mkTerm "opportuneness_N" ;
lin opportunism_N = mkTerm "opportunism_N" ;
lin opportunistFem_N = mkTerm "opportunistFem_N" ;
lin opportunistMasc_N = mkTerm "opportunistMasc_N" ;
lin opportunist_A = mkTerm "opportunist_A" ;
lin opportunity_N = mkTerm "opportunity_N" ;
lin opposable_A = mkTerm "opposable_A" ;
lin oppose_V = mkTerm "oppose_V" ;
lin oppose_V2 = mkTerm "oppose_V2" ;
lin opposed_A = mkTerm "opposed_A" ;
lin opposite_A = mkTerm "opposite_A" ;
lin opposite_Adv = mkTerm "opposite_Adv" ;
lin opposite_N = mkTerm "opposite_N" ;
lin opposite_Prep = mkTerm "opposite_Prep" ;
lin opposition_N = mkTerm "opposition_N" ;
lin oppress_V2 = mkTerm "oppress_V2" ;
lin oppression_N = mkTerm "oppression_N" ;
lin oppressive_A = mkTerm "oppressive_A" ;
lin oppressor_N = mkTerm "oppressor_N" ;
lin opprobrious_A = mkTerm "opprobrious_A" ;
lin opprobrium_N = mkTerm "opprobrium_N" ;
lin oppugn_V2 = mkTerm "oppugn_V2" ;
lin opsin_N = mkTerm "opsin_N" ;
lin opsonin_N = mkTerm "opsonin_N" ;
lin opsonization_N = mkTerm "opsonization_N" ;
lin opt_V = mkTerm "opt_V" ;
lin opt_VV = mkTerm "opt_VV" ;
lin opt_for_V2 = mkTerm "opt_for_V2" ;
lin opt_in_V = mkTerm "opt_in_V" ;
lin opt_into_V2 = mkTerm "opt_into_V2" ;
lin opt_out_V2 = mkTerm "opt_out_V2" ;
lin optative_A = mkTerm "optative_A" ;
lin optative_N = mkTerm "optative_N" ;
lin optic_A = mkTerm "optic_A" ;
lin optic_N = mkTerm "optic_N" ;
lin optical_A = mkTerm "optical_A" ;
lin optician_N = mkTerm "optician_N" ;
lin optics_N = mkTerm "optics_N" ;
lin optimal_A = mkTerm "optimal_A" ;
lin optimism_N = mkTerm "optimism_N" ;
lin optimistFem_N = mkTerm "optimistFem_N" ;
lin optimistMasc_N = mkTerm "optimistMasc_N" ;
lin optimistic_A = mkTerm "optimistic_A" ;
lin optimization_N = mkTerm "optimization_N" ;
lin optimum_A = mkTerm "optimum_A" ;
lin optimum_N = mkTerm "optimum_N" ;
lin option_N = mkTerm "option_N" ;
lin optional_A = mkTerm "optional_A" ;
lin optometrist_N = mkTerm "optometrist_N" ;
lin optometry_N = mkTerm "optometry_N" ;
lin opulence_N = mkTerm "opulence_N" ;
lin opulent_A = mkTerm "opulent_A" ;
lin opus_N = mkTerm "opus_N" ;
lin orach_N = mkTerm "orach_N" ;
lin oracle_N = mkTerm "oracle_N" ;
lin oracular_A = mkTerm "oracular_A" ;
lin orad_Adv = mkTerm "orad_Adv" ;
lin oral_A = mkTerm "oral_A" ;
lin oral_N = mkTerm "oral_N" ;
lin orange_1_N = mkTerm "orange_1_N" ;
lin orange_2_N = mkTerm "orange_2_N" ;
lin orange_A = mkTerm "orange_A" ;
lin orangeade_N = mkTerm "orangeade_N" ;
lin orangeman_N = mkTerm "orangeman_N" ;
lin orangery_N = mkTerm "orangery_N" ;
lin orangewood_N = mkTerm "orangewood_N" ;
lin orangutan_N = mkTerm "orangutan_N" ;
lin orate_V = mkTerm "orate_V" ;
lin oration_N = mkTerm "oration_N" ;
lin oratorFem_N = mkTerm "oratorFem_N" ;
lin oratorMasc_N = mkTerm "oratorMasc_N" ;
lin oratorical_A = mkTerm "oratorical_A" ;
lin oratorio_N = mkTerm "oratorio_N" ;
lin oratory_N = mkTerm "oratory_N" ;
lin oravais_PN = mkTerm "oravais_PN" ;
lin orb_N = mkTerm "orb_N" ;
lin orbiculate_A = mkTerm "orbiculate_A" ;
lin orbit_N = mkTerm "orbit_N" ;
lin orbit_V = mkTerm "orbit_V" ;
lin orbit_V2 = mkTerm "orbit_V2" ;
lin orbital_A = mkTerm "orbital_A" ;
lin orbitale_N = mkTerm "orbitale_N" ;
lin orchard_N = mkTerm "orchard_N" ;
lin orchestra_N = mkTerm "orchestra_N" ;
lin orchestral_A = mkTerm "orchestral_A" ;
lin orchestrate_V2 = mkTerm "orchestrate_V2" ;
lin orchestration_N = mkTerm "orchestration_N" ;
lin orchestrator_N = mkTerm "orchestrator_N" ;
lin orchid_N = mkTerm "orchid_N" ;
lin orchidalgia_N = mkTerm "orchidalgia_N" ;
lin orchidectomy_N = mkTerm "orchidectomy_N" ;
lin orchil_N = mkTerm "orchil_N" ;
lin orchiopexy_N = mkTerm "orchiopexy_N" ;
lin orchis_N = mkTerm "orchis_N" ;
lin orchitis_N = mkTerm "orchitis_N" ;
lin orchotomy_N = mkTerm "orchotomy_N" ;
lin ordain_V2 = mkTerm "ordain_V2" ;
lin ordain_VS = mkTerm "ordain_VS" ;
lin ordainer_N = mkTerm "ordainer_N" ;
lin ordeal_N = mkTerm "ordeal_N" ;
lin order_N = mkTerm "order_N" ;
lin order_V = mkTerm "order_V" ;
lin order_V2 = mkTerm "order_V2" ;
lin order_V2V = mkTerm "order_V2V" ;
lin order_VS = mkTerm "order_VS" ;
lin order_book_N = mkTerm "order_book_N" ;
lin order_form_N = mkTerm "order_form_N" ;
lin order_paper_N = mkTerm "order_paper_N" ;
lin orderer_N = mkTerm "orderer_N" ;
lin ordering_N = mkTerm "ordering_N" ;
lin orderliness_N = mkTerm "orderliness_N" ;
lin orderly_A = mkTerm "orderly_A" ;
lin orderly_N = mkTerm "orderly_N" ;
lin ordinal_A = mkTerm "ordinal_A" ;
lin ordinal_N = mkTerm "ordinal_N" ;
lin ordinance_N = mkTerm "ordinance_N" ;
lin ordinand_N = mkTerm "ordinand_N" ;
lin ordinariness_N = mkTerm "ordinariness_N" ;
lin ordinary_A = mkTerm "ordinary_A" ;
lin ordinary_N = mkTerm "ordinary_N" ;
lin ordinate_N = mkTerm "ordinate_N" ;
lin ordination_N = mkTerm "ordination_N" ;
lin ordnance_N = mkTerm "ordnance_N" ;
lin ordure_N = mkTerm "ordure_N" ;
lin ore_N = mkTerm "ore_N" ;
lin oregano_N = mkTerm "oregano_N" ;
lin oregon_PN = mkTerm "oregon_PN" ;
lin oreo_N = mkTerm "oreo_N" ;
lin organ_N = mkTerm "organ_N" ;
lin organ_blower_N = mkTerm "organ_blower_N" ;
lin organ_grinder_N = mkTerm "organ_grinder_N" ;
lin organ_loft_N = mkTerm "organ_loft_N" ;
lin organdie_N = mkTerm "organdie_N" ;
lin organdy_N = mkTerm "organdy_N" ;
lin organelle_N = mkTerm "organelle_N" ;
lin organic_A = mkTerm "organic_A" ;
lin organic_N = mkTerm "organic_N" ;
lin organicism_N = mkTerm "organicism_N" ;
lin organicistic_A = mkTerm "organicistic_A" ;
lin organification_N = mkTerm "organification_N" ;
lin organisation_N = mkTerm "organisation_N" ;
lin organism_N = mkTerm "organism_N" ;
lin organismal_A = mkTerm "organismal_A" ;
lin organist_N = mkTerm "organist_N" ;
lin organization_N = mkTerm "organization_N" ;
lin organizational_A = mkTerm "organizational_A" ;
lin organize_V2 = mkTerm "organize_V2" ;
lin organize_V2V = mkTerm "organize_V2V" ;
lin organizer_N = mkTerm "organizer_N" ;
lin organon_N = mkTerm "organon_N" ;
lin organophosphate_N = mkTerm "organophosphate_N" ;
lin organza_N = mkTerm "organza_N" ;
lin orgasm_N = mkTerm "orgasm_N" ;
lin orgiastic_A = mkTerm "orgiastic_A" ;
lin orgy_N = mkTerm "orgy_N" ;
lin oriel_N = mkTerm "oriel_N" ;
lin orient_A = mkTerm "orient_A" ;
lin orient_N = mkTerm "orient_N" ;
lin orient_V2 = mkTerm "orient_V2" ;
lin oriental_A = mkTerm "oriental_A" ;
lin oriental_N = mkTerm "oriental_N" ;
lin orientalism_N = mkTerm "orientalism_N" ;
lin orientalistFem_N = mkTerm "orientalistFem_N" ;
lin orientalistMasc_N = mkTerm "orientalistMasc_N" ;
lin orientate_V2 = mkTerm "orientate_V2" ;
lin orientation_N = mkTerm "orientation_N" ;
lin oriented_A = mkTerm "oriented_A" ;
lin orienting_A = mkTerm "orienting_A" ;
lin orifice_N = mkTerm "orifice_N" ;
lin oriflamme_N = mkTerm "oriflamme_N" ;
lin origami_N = mkTerm "origami_N" ;
lin origanum_N = mkTerm "origanum_N" ;
lin origin_N = mkTerm "origin_N" ;
lin original_A = mkTerm "original_A" ;
lin original_N = mkTerm "original_N" ;
lin originalism_N = mkTerm "originalism_N" ;
lin originality_N = mkTerm "originality_N" ;
lin originate_V = mkTerm "originate_V" ;
lin originate_V2 = mkTerm "originate_V2" ;
lin originatorFem_N = mkTerm "originatorFem_N" ;
lin originatorMasc_N = mkTerm "originatorMasc_N" ;
lin orimattila_PN = mkTerm "orimattila_PN" ;
lin oriole_N = mkTerm "oriole_N" ;
lin oripää_PN = mkTerm "oripää_PN" ;
lin orison_N = mkTerm "orison_N" ;
lin orivesi_PN = mkTerm "orivesi_PN" ;
lin orkney_PN = mkTerm "orkney_PN" ;
lin orleans_PN = mkTerm "orleans_PN" ;
lin orlop_N = mkTerm "orlop_N" ;
lin ormer_N = mkTerm "ormer_N" ;
lin ormolu_N = mkTerm "ormolu_N" ;
lin ormskirk_PN = mkTerm "ormskirk_PN" ;
lin ornament_N = mkTerm "ornament_N" ;
lin ornament_V2 = mkTerm "ornament_V2" ;
lin ornamental_A = mkTerm "ornamental_A" ;
lin ornamental_N = mkTerm "ornamental_N" ;
lin ornamentalism_N = mkTerm "ornamentalism_N" ;
lin ornamentation_N = mkTerm "ornamentation_N" ;
lin ornate_A = mkTerm "ornate_A" ;
lin ornateness_N = mkTerm "ornateness_N" ;
lin ornery_A = mkTerm "ornery_A" ;
lin ornithine_N = mkTerm "ornithine_N" ;
lin ornithischian_N = mkTerm "ornithischian_N" ;
lin ornithological_A = mkTerm "ornithological_A" ;
lin ornithologistFem_N = mkTerm "ornithologistFem_N" ;
lin ornithologistMasc_N = mkTerm "ornithologistMasc_N" ;
lin ornithology_N = mkTerm "ornithology_N" ;
lin ornithomimid_N = mkTerm "ornithomimid_N" ;
lin ornithopod_N = mkTerm "ornithopod_N" ;
lin orogeny_N = mkTerm "orogeny_N" ;
lin oroide_N = mkTerm "oroide_N" ;
lin orologistFem_N = mkTerm "orologistFem_N" ;
lin orologistMasc_N = mkTerm "orologistMasc_N" ;
lin orology_N = mkTerm "orology_N" ;
lin oropharyngeal_A = mkTerm "oropharyngeal_A" ;
lin oropharynx_N = mkTerm "oropharynx_N" ;
lin orotund_A = mkTerm "orotund_A" ;
lin orphan_N = mkTerm "orphan_N" ;
lin orphan_V2 = mkTerm "orphan_V2" ;
lin orphanage_N = mkTerm "orphanage_N" ;
lin orphenadrine_N = mkTerm "orphenadrine_N" ;
lin orphrey_N = mkTerm "orphrey_N" ;
lin orpiment_N = mkTerm "orpiment_N" ;
lin orpine_N = mkTerm "orpine_N" ;
lin orrery_N = mkTerm "orrery_N" ;
lin orrisroot_N = mkTerm "orrisroot_N" ;
lin orthicon_N = mkTerm "orthicon_N" ;
lin orthochorea_N = mkTerm "orthochorea_N" ;
lin orthoclase_N = mkTerm "orthoclase_N" ;
lin orthodontic_A = mkTerm "orthodontic_A" ;
lin orthodontics_N = mkTerm "orthodontics_N" ;
lin orthodontist_N = mkTerm "orthodontist_N" ;
lin orthodox_A = mkTerm "orthodox_A" ;
lin orthodoxy_N = mkTerm "orthodoxy_N" ;
lin orthoepist_N = mkTerm "orthoepist_N" ;
lin orthoepy_N = mkTerm "orthoepy_N" ;
lin orthogonal_A = mkTerm "orthogonal_A" ;
lin orthogonality_N = mkTerm "orthogonality_N" ;
lin orthographic_A = mkTerm "orthographic_A" ;
lin orthography_N = mkTerm "orthography_N" ;
lin orthomolecular_A = mkTerm "orthomolecular_A" ;
lin orthomyxovirus_N = mkTerm "orthomyxovirus_N" ;
lin orthopaedic_A = mkTerm "orthopaedic_A" ;
lin orthopaedics_N = mkTerm "orthopaedics_N" ;
lin orthopedist_N = mkTerm "orthopedist_N" ;
lin orthopnea_N = mkTerm "orthopnea_N" ;
lin orthopter_N = mkTerm "orthopter_N" ;
lin orthoptic_A = mkTerm "orthoptic_A" ;
lin orthoptics_N = mkTerm "orthoptics_N" ;
lin orthoptist_N = mkTerm "orthoptist_N" ;
lin orthoscope_N = mkTerm "orthoscope_N" ;
lin orthostatic_A = mkTerm "orthostatic_A" ;
lin orthotropous_A = mkTerm "orthotropous_A" ;
lin ortolan_N = mkTerm "ortolan_N" ;
lin ortygan_N = mkTerm "ortygan_N" ;
lin oryx_N = mkTerm "oryx_N" ;
lin orzo_N = mkTerm "orzo_N" ;
lin os_N = mkTerm "os_N" ;
lin osaka_PN = mkTerm "osaka_PN" ;
lin oscar_N = mkTerm "oscar_N" ;
lin oscar_PN = mkTerm "oscar_PN" ;
lin oscheocele_N = mkTerm "oscheocele_N" ;
lin oscillate_V = mkTerm "oscillate_V" ;
lin oscillate_V2 = mkTerm "oscillate_V2" ;
lin oscillation_N = mkTerm "oscillation_N" ;
lin oscillator_N = mkTerm "oscillator_N" ;
lin oscillatory_A = mkTerm "oscillatory_A" ;
lin oscillogram_N = mkTerm "oscillogram_N" ;
lin oscillograph_N = mkTerm "oscillograph_N" ;
lin oscilloscope_N = mkTerm "oscilloscope_N" ;
lin oscine_A = mkTerm "oscine_A" ;
lin oscine_N = mkTerm "oscine_N" ;
lin oscitancy_N = mkTerm "oscitancy_N" ;
lin osculation_N = mkTerm "osculation_N" ;
lin osier_N = mkTerm "osier_N" ;
lin oslo_PN = mkTerm "oslo_PN" ;
lin osmiridium_N = mkTerm "osmiridium_N" ;
lin osmium_N = mkTerm "osmium_N" ;
lin osmoreceptor_N = mkTerm "osmoreceptor_N" ;
lin osmosis_N = mkTerm "osmosis_N" ;
lin osmotic_A = mkTerm "osmotic_A" ;
lin osnabruck_PN = mkTerm "osnabruck_PN" ;
lin osprey_N = mkTerm "osprey_N" ;
lin osseous_A = mkTerm "osseous_A" ;
lin ossett_PN = mkTerm "ossett_PN" ;
lin ossicle_N = mkTerm "ossicle_N" ;
lin ossicular_A = mkTerm "ossicular_A" ;
lin ossiferous_A = mkTerm "ossiferous_A" ;
lin ossification_N = mkTerm "ossification_N" ;
lin ossify_V = mkTerm "ossify_V" ;
lin ossify_V2 = mkTerm "ossify_V2" ;
lin ossuary_N = mkTerm "ossuary_N" ;
lin osteal_A = mkTerm "osteal_A" ;
lin osteitis_N = mkTerm "osteitis_N" ;
lin ostensible_A = mkTerm "ostensible_A" ;
lin ostensive_A = mkTerm "ostensive_A" ;
lin ostentation_N = mkTerm "ostentation_N" ;
lin ostentatious_A = mkTerm "ostentatious_A" ;
lin osteoarthritis_N = mkTerm "osteoarthritis_N" ;
lin osteoblast_N = mkTerm "osteoblast_N" ;
lin osteoblastoma_N = mkTerm "osteoblastoma_N" ;
lin osteochondroma_N = mkTerm "osteochondroma_N" ;
lin osteoclasis_N = mkTerm "osteoclasis_N" ;
lin osteoclast_N = mkTerm "osteoclast_N" ;
lin osteocyte_N = mkTerm "osteocyte_N" ;
lin osteodystrophy_N = mkTerm "osteodystrophy_N" ;
lin osteologist_N = mkTerm "osteologist_N" ;
lin osteology_N = mkTerm "osteology_N" ;
lin osteolysis_N = mkTerm "osteolysis_N" ;
lin osteoma_N = mkTerm "osteoma_N" ;
lin osteomalacia_N = mkTerm "osteomalacia_N" ;
lin osteomyelitis_N = mkTerm "osteomyelitis_N" ;
lin osteopath_N = mkTerm "osteopath_N" ;
lin osteopathy_N = mkTerm "osteopathy_N" ;
lin osteopetrosis_N = mkTerm "osteopetrosis_N" ;
lin osteophyte_N = mkTerm "osteophyte_N" ;
lin osteoporosis_N = mkTerm "osteoporosis_N" ;
lin osteosarcoma_N = mkTerm "osteosarcoma_N" ;
lin osteosclerosis_N = mkTerm "osteosclerosis_N" ;
lin osteostracan_N = mkTerm "osteostracan_N" ;
lin osteotomy_N = mkTerm "osteotomy_N" ;
lin ostinato_N = mkTerm "ostinato_N" ;
lin ostiole_N = mkTerm "ostiole_N" ;
lin ostler_N = mkTerm "ostler_N" ;
lin ostomy_N = mkTerm "ostomy_N" ;
lin ostracism_N = mkTerm "ostracism_N" ;
lin ostracize_V2 = mkTerm "ostracize_V2" ;
lin ostracoderm_N = mkTerm "ostracoderm_N" ;
lin ostrich_N = mkTerm "ostrich_N" ;
lin oswald_PN = mkTerm "oswald_PN" ;
lin oswestry_PN = mkTerm "oswestry_PN" ;
lin ot_N = mkTerm "ot_N" ;
lin otago_PN = mkTerm "otago_PN" ;
lin otaniemi_PN = mkTerm "otaniemi_PN" ;
lin other_A = mkTerm "other_A" ;
lin other_Adv = mkTerm "other_Adv" ;
lin other_N = mkTerm "other_N" ;
lin otherness_N = mkTerm "otherness_N" ;
lin otherwise_A = mkTerm "otherwise_A" ;
lin otherwise_Adv = mkTerm "otherwise_Adv" ;
lin otherworld_N = mkTerm "otherworld_N" ;
lin otherworldly_A = mkTerm "otherworldly_A" ;
lin othonna_N = mkTerm "othonna_N" ;
lin otic_A = mkTerm "otic_A" ;
lin otiose_A = mkTerm "otiose_A" ;
lin otitis_N = mkTerm "otitis_N" ;
lin otley_PN = mkTerm "otley_PN" ;
lin otology_N = mkTerm "otology_N" ;
lin otoplasty_N = mkTerm "otoplasty_N" ;
lin otorrhea_N = mkTerm "otorrhea_N" ;
lin otosclerosis_N = mkTerm "otosclerosis_N" ;
lin otoscope_N = mkTerm "otoscope_N" ;
lin ototoxic_A = mkTerm "ototoxic_A" ;
lin ottawa_PN = mkTerm "ottawa_PN" ;
lin otter_N = mkTerm "otter_N" ;
lin otterhound_N = mkTerm "otterhound_N" ;
lin ottomanFem_N = mkTerm "ottomanFem_N" ;
lin ottomanMasc_N = mkTerm "ottomanMasc_N" ;
lin oubliette_N = mkTerm "oubliette_N" ;
lin ought_VV = mkTerm "ought_VV" ;
lin ouguiya_N = mkTerm "ouguiya_N" ;
lin ouija_N = mkTerm "ouija_N" ;
lin ouija_board_N = mkTerm "ouija_board_N" ;
lin oulainen_PN = mkTerm "oulainen_PN" ;
lin oulu_PN = mkTerm "oulu_PN" ;
lin oulunsalo_PN = mkTerm "oulunsalo_PN" ;
lin ounce_N = mkTerm "ounce_N" ;
lin oust_V = mkTerm "oust_V" ;
lin oust_V2 = mkTerm "oust_V2" ;
lin ouster_N = mkTerm "ouster_N" ;
lin out_A = mkTerm "out_A" ;
lin out_Adv = mkTerm "out_Adv" ;
lin out_N = mkTerm "out_N" ;
lin out_Prep = mkTerm "out_Prep" ;
lin out_V2 = mkTerm "out_V2" ;
lin out_from_Prep = mkTerm "out_from_Prep" ;
lin out_herod_V2 = mkTerm "out_herod_V2" ;
lin out_of_Prep = mkTerm "out_of_Prep" ;
lin out_of_date_A = mkTerm "out_of_date_A" ;
lin out_of_door_A = mkTerm "out_of_door_A" ;
lin out_of_doors_Adv = mkTerm "out_of_doors_Adv" ;
lin out_of_the_way_A = mkTerm "out_of_the_way_A" ;
lin out_of_the_way_Adv = mkTerm "out_of_the_way_Adv" ;
lin out_of_work_A = mkTerm "out_of_work_A" ;
lin out_trade_V2 = mkTerm "out_trade_V2" ;
lin out_tray_N = mkTerm "out_tray_N" ;
lin outage_N = mkTerm "outage_N" ;
lin outback_A = mkTerm "outback_A" ;
lin outback_N = mkTerm "outback_N" ;
lin outbalance_V2 = mkTerm "outbalance_V2" ;
lin outbid_V2 = mkTerm "outbid_V2" ;
lin outboard_A = mkTerm "outboard_A" ;
lin outbound_A = mkTerm "outbound_A" ;
lin outbrave_V2 = mkTerm "outbrave_V2" ;
lin outbreak_N = mkTerm "outbreak_N" ;
lin outbred_A = mkTerm "outbred_A" ;
lin outbuilding_N = mkTerm "outbuilding_N" ;
lin outburst_N = mkTerm "outburst_N" ;
lin outcast_A = mkTerm "outcast_A" ;
lin outcast_N = mkTerm "outcast_N" ;
lin outcaste_A = mkTerm "outcaste_A" ;
lin outcaste_N = mkTerm "outcaste_N" ;
lin outclass_V2 = mkTerm "outclass_V2" ;
lin outcome_N = mkTerm "outcome_N" ;
lin outcrop_N = mkTerm "outcrop_N" ;
lin outcry_N = mkTerm "outcry_N" ;
lin outdated_A = mkTerm "outdated_A" ;
lin outdistance_V2 = mkTerm "outdistance_V2" ;
lin outdo_V2 = mkTerm "outdo_V2" ;
lin outdoor_A = mkTerm "outdoor_A" ;
lin outdoors_Adv = mkTerm "outdoors_Adv" ;
lin outdoors_N = mkTerm "outdoors_N" ;
lin outdoorsman_N = mkTerm "outdoorsman_N" ;
lin outdoorswoman_N = mkTerm "outdoorswoman_N" ;
lin outdoorsy_A = mkTerm "outdoorsy_A" ;
lin outer_A = mkTerm "outer_A" ;
lin outercourse_N = mkTerm "outercourse_N" ;
lin outermost_A = mkTerm "outermost_A" ;
lin outerwear_N = mkTerm "outerwear_N" ;
lin outface_V2 = mkTerm "outface_V2" ;
lin outfall_N = mkTerm "outfall_N" ;
lin outfield_N = mkTerm "outfield_N" ;
lin outfielder_N = mkTerm "outfielder_N" ;
lin outfight_V2 = mkTerm "outfight_V2" ;
lin outfit_N = mkTerm "outfit_N" ;
lin outfit_V2 = mkTerm "outfit_V2" ;
lin outfitter_N = mkTerm "outfitter_N" ;
lin outfitting_N = mkTerm "outfitting_N" ;
lin outflank_V2 = mkTerm "outflank_V2" ;
lin outflow_N = mkTerm "outflow_N" ;
lin outfly_V2 = mkTerm "outfly_V2" ;
lin outfox_V2 = mkTerm "outfox_V2" ;
lin outgain_V2 = mkTerm "outgain_V2" ;
lin outgo_N = mkTerm "outgo_N" ;
lin outgo_V = mkTerm "outgo_V" ;
lin outgoing_A = mkTerm "outgoing_A" ;
lin outgrow_V2 = mkTerm "outgrow_V2" ;
lin outgrowth_N = mkTerm "outgrowth_N" ;
lin outhouse_N = mkTerm "outhouse_N" ;
lin outing_N = mkTerm "outing_N" ;
lin outlandish_A = mkTerm "outlandish_A" ;
lin outlandishness_N = mkTerm "outlandishness_N" ;
lin outlast_V2 = mkTerm "outlast_V2" ;
lin outlaw_N = mkTerm "outlaw_N" ;
lin outlaw_V2 = mkTerm "outlaw_V2" ;
lin outlawry_N = mkTerm "outlawry_N" ;
lin outlay_N = mkTerm "outlay_N" ;
lin outleap_V2 = mkTerm "outleap_V2" ;
lin outlet_N = mkTerm "outlet_N" ;
lin outlier_N = mkTerm "outlier_N" ;
lin outline_N = mkTerm "outline_N" ;
lin outline_V2 = mkTerm "outline_V2" ;
lin outlive_V2 = mkTerm "outlive_V2" ;
lin outlook_N = mkTerm "outlook_N" ;
lin outlying_A = mkTerm "outlying_A" ;
lin outmanoeuvre_V2 = mkTerm "outmanoeuvre_V2" ;
lin outmarch_V2 = mkTerm "outmarch_V2" ;
lin outmatch_V2 = mkTerm "outmatch_V2" ;
lin outmoded_A = mkTerm "outmoded_A" ;
lin outmost_A = mkTerm "outmost_A" ;
lin outnumber_V2 = mkTerm "outnumber_V2" ;
lin outokumpu_PN = mkTerm "outokumpu_PN" ;
lin outpace_V2 = mkTerm "outpace_V2" ;
lin outpatient_N = mkTerm "outpatient_N" ;
lin outperform_V2 = mkTerm "outperform_V2" ;
lin outplay_V2 = mkTerm "outplay_V2" ;
lin outpoint_V2 = mkTerm "outpoint_V2" ;
lin outport_N = mkTerm "outport_N" ;
lin outpost_N = mkTerm "outpost_N" ;
lin outpouring_N = mkTerm "outpouring_N" ;
lin output_N = mkTerm "output_N" ;
lin outrage_N = mkTerm "outrage_N" ;
lin outrage_V2 = mkTerm "outrage_V2" ;
lin outrageous_A = mkTerm "outrageous_A" ;
lin outrageousness_N = mkTerm "outrageousness_N" ;
lin outrange_V2 = mkTerm "outrange_V2" ;
lin outrank_V2 = mkTerm "outrank_V2" ;
lin outre_A = mkTerm "outre_A" ;
lin outreach_N = mkTerm "outreach_N" ;
lin outride_V2 = mkTerm "outride_V2" ;
lin outrider_N = mkTerm "outrider_N" ;
lin outrigged_A = mkTerm "outrigged_A" ;
lin outrigger_N = mkTerm "outrigger_N" ;
lin outright_A = mkTerm "outright_A" ;
lin outright_Adv = mkTerm "outright_Adv" ;
lin outrival_V2 = mkTerm "outrival_V2" ;
lin outrun_V2 = mkTerm "outrun_V2" ;
lin outsail_V2 = mkTerm "outsail_V2" ;
lin outsell_V2 = mkTerm "outsell_V2" ;
lin outset_N = mkTerm "outset_N" ;
lin outshine_V2 = mkTerm "outshine_V2" ;
lin outside_A = mkTerm "outside_A" ;
lin outside_Adv = mkTerm "outside_Adv" ;
lin outside_N = mkTerm "outside_N" ;
lin outside_Prep = mkTerm "outside_Prep" ;
lin outside_of_Prep = mkTerm "outside_of_Prep" ;
lin outsider_N = mkTerm "outsider_N" ;
lin outsize_A = mkTerm "outsize_A" ;
lin outsize_N = mkTerm "outsize_N" ;
lin outskirt_N = mkTerm "outskirt_N" ;
lin outskirts_N = mkTerm "outskirts_N" ;
lin outsmart_V2 = mkTerm "outsmart_V2" ;
lin outsole_N = mkTerm "outsole_N" ;
lin outspan_V = mkTerm "outspan_V" ;
lin outspan_V2 = mkTerm "outspan_V2" ;
lin outspoken_A = mkTerm "outspoken_A" ;
lin outspokenness_N = mkTerm "outspokenness_N" ;
lin outspread_A = mkTerm "outspread_A" ;
lin outstanding_A = mkTerm "outstanding_A" ;
lin outstation_N = mkTerm "outstation_N" ;
lin outstay_V2 = mkTerm "outstay_V2" ;
lin outstretched_A = mkTerm "outstretched_A" ;
lin outstrip_V2 = mkTerm "outstrip_V2" ;
lin outstroke_N = mkTerm "outstroke_N" ;
lin outtake_N = mkTerm "outtake_N" ;
lin outthrust_N = mkTerm "outthrust_N" ;
lin outvie_V2 = mkTerm "outvie_V2" ;
lin outvote_V2 = mkTerm "outvote_V2" ;
lin outward_A = mkTerm "outward_A" ;
lin outward_Adv = mkTerm "outward_Adv" ;
lin outwardness_N = mkTerm "outwardness_N" ;
lin outwards_Adv = mkTerm "outwards_Adv" ;
lin outwear_V2 = mkTerm "outwear_V2" ;
lin outweigh_V2 = mkTerm "outweigh_V2" ;
lin outwit_V2 = mkTerm "outwit_V2" ;
lin outwith_Prep = mkTerm "outwith_Prep" ;
lin outwork_N = mkTerm "outwork_N" ;
lin ouzel_N = mkTerm "ouzel_N" ;
lin ouzo_N = mkTerm "ouzo_N" ;
lin oval_A = mkTerm "oval_A" ;
lin oval_N = mkTerm "oval_N" ;
lin ovarian_A = mkTerm "ovarian_A" ;
lin ovaritis_N = mkTerm "ovaritis_N" ;
lin ovary_N = mkTerm "ovary_N" ;
lin ovate_A = mkTerm "ovate_A" ;
lin ovation_N = mkTerm "ovation_N" ;
lin oven_N = mkTerm "oven_N" ;
lin ovenbird_N = mkTerm "ovenbird_N" ;
lin ovenware_N = mkTerm "ovenware_N" ;
lin over_Adv = mkTerm "over_Adv" ;
lin over_N = mkTerm "over_N" ;
lin over_Prep = mkTerm "over_Prep" ;
lin over_abundance_N = mkTerm "over_abundance_N" ;
lin over_magazine_V2 = mkTerm "over_magazine_V2" ;
lin over_ripe_A = mkTerm "over_ripe_A" ;
lin overabundant_A = mkTerm "overabundant_A" ;
lin overachievement_N = mkTerm "overachievement_N" ;
lin overachiever_N = mkTerm "overachiever_N" ;
lin overact_V = mkTerm "overact_V" ;
lin overact_V2 = mkTerm "overact_V2" ;
lin overactive_A = mkTerm "overactive_A" ;
lin overactivity_N = mkTerm "overactivity_N" ;
lin overage_A = mkTerm "overage_A" ;
lin overage_N = mkTerm "overage_N" ;
lin overall_A = mkTerm "overall_A" ;
lin overall_Adv = mkTerm "overall_Adv" ;
lin overall_N = mkTerm "overall_N" ;
lin overambitious_A = mkTerm "overambitious_A" ;
lin overanxiety_N = mkTerm "overanxiety_N" ;
lin overanxious_A = mkTerm "overanxious_A" ;
lin overarch_V = mkTerm "overarch_V" ;
lin overarch_V2 = mkTerm "overarch_V2" ;
lin overarm_A = mkTerm "overarm_A" ;
lin overarm_Adv = mkTerm "overarm_Adv" ;
lin overawe_V2 = mkTerm "overawe_V2" ;
lin overbalance_V = mkTerm "overbalance_V" ;
lin overbalance_V2 = mkTerm "overbalance_V2" ;
lin overbear_V2 = mkTerm "overbear_V2" ;
lin overbearing_A = mkTerm "overbearing_A" ;
lin overbid_N = mkTerm "overbid_N" ;
lin overbid_V = mkTerm "overbid_V" ;
lin overbid_V2 = mkTerm "overbid_V2" ;
lin overbite_N = mkTerm "overbite_N" ;
lin overblown_A = mkTerm "overblown_A" ;
lin overboard_Adv = mkTerm "overboard_Adv" ;
lin overbold_A = mkTerm "overbold_A" ;
lin overburden_N = mkTerm "overburden_N" ;
lin overburden_V2 = mkTerm "overburden_V2" ;
lin overbusy_A = mkTerm "overbusy_A" ;
lin overcall_V = mkTerm "overcall_V" ;
lin overcall_V2 = mkTerm "overcall_V2" ;
lin overcapitalization_N = mkTerm "overcapitalization_N" ;
lin overcapitalize_V2 = mkTerm "overcapitalize_V2" ;
lin overcareful_A = mkTerm "overcareful_A" ;
lin overcast_A = mkTerm "overcast_A" ;
lin overcast_N = mkTerm "overcast_N" ;
lin overcautious_A = mkTerm "overcautious_A" ;
lin overcharge_N = mkTerm "overcharge_N" ;
lin overcharge_V = mkTerm "overcharge_V" ;
lin overcharge_V2 = mkTerm "overcharge_V2" ;
lin overclothe_V2 = mkTerm "overclothe_V2" ;
lin overcloud_V = mkTerm "overcloud_V" ;
lin overcloud_V2 = mkTerm "overcloud_V2" ;
lin overcoat_N = mkTerm "overcoat_N" ;
lin overcome_V = mkTerm "overcome_V" ;
lin overcome_V2 = mkTerm "overcome_V2" ;
lin overcommit_V2 = mkTerm "overcommit_V2" ;
lin overcompensation_N = mkTerm "overcompensation_N" ;
lin overconfidence_N = mkTerm "overconfidence_N" ;
lin overconfident_A = mkTerm "overconfident_A" ;
lin overcook_V2 = mkTerm "overcook_V2" ;
lin overcredulity_N = mkTerm "overcredulity_N" ;
lin overcredulous_A = mkTerm "overcredulous_A" ;
lin overcritical_A = mkTerm "overcritical_A" ;
lin overcrop_V2 = mkTerm "overcrop_V2" ;
lin overcrowd_V2 = mkTerm "overcrowd_V2" ;
lin overcurious_A = mkTerm "overcurious_A" ;
lin overdelicate_A = mkTerm "overdelicate_A" ;
lin overdo_V2 = mkTerm "overdo_V2" ;
lin overdose_N = mkTerm "overdose_N" ;
lin overdose_V = mkTerm "overdose_V" ;
lin overdraft_N = mkTerm "overdraft_N" ;
lin overdraw_V = mkTerm "overdraw_V" ;
lin overdraw_V2 = mkTerm "overdraw_V2" ;
lin overdress_V = mkTerm "overdress_V" ;
lin overdress_V2 = mkTerm "overdress_V2" ;
lin overdrive_N = mkTerm "overdrive_N" ;
lin overdue_A = mkTerm "overdue_A" ;
lin overeager_A = mkTerm "overeager_A" ;
lin overeat_V = mkTerm "overeat_V" ;
lin overemotional_A = mkTerm "overemotional_A" ;
lin overemphasis_N = mkTerm "overemphasis_N" ;
lin overemphasize_V = mkTerm "overemphasize_V" ;
lin overemphasize_V2 = mkTerm "overemphasize_V2" ;
lin overenthusiastic_A = mkTerm "overenthusiastic_A" ;
lin overestimate_N = mkTerm "overestimate_N" ;
lin overestimate_V2 = mkTerm "overestimate_V2" ;
lin overexcited_A = mkTerm "overexcited_A" ;
lin overexert_V2 = mkTerm "overexert_V2" ;
lin overexertion_N = mkTerm "overexertion_N" ;
lin overexploitation_N = mkTerm "overexploitation_N" ;
lin overexpose_V2 = mkTerm "overexpose_V2" ;
lin overexposure_N = mkTerm "overexposure_N" ;
lin overfamiliar_A = mkTerm "overfamiliar_A" ;
lin overfed_A = mkTerm "overfed_A" ;
lin overfeed_V = mkTerm "overfeed_V" ;
lin overfeed_V2 = mkTerm "overfeed_V2" ;
lin overfeeding_N = mkTerm "overfeeding_N" ;
lin overflight_N = mkTerm "overflight_N" ;
lin overflow_N = mkTerm "overflow_N" ;
lin overflow_V = mkTerm "overflow_V" ;
lin overflow_V2 = mkTerm "overflow_V2" ;
lin overfly_V2 = mkTerm "overfly_V2" ;
lin overfond_A = mkTerm "overfond_A" ;
lin overfull_A = mkTerm "overfull_A" ;
lin overgarment_N = mkTerm "overgarment_N" ;
lin overgenerous_A = mkTerm "overgenerous_A" ;
lin overgreedy_A = mkTerm "overgreedy_A" ;
lin overgrown_A = mkTerm "overgrown_A" ;
lin overgrowth_N = mkTerm "overgrowth_N" ;
lin overhand_A = mkTerm "overhand_A" ;
lin overhang_N = mkTerm "overhang_N" ;
lin overhang_V = mkTerm "overhang_V" ;
lin overhang_V2 = mkTerm "overhang_V2" ;
lin overhasty_A = mkTerm "overhasty_A" ;
lin overhaul_N = mkTerm "overhaul_N" ;
lin overhaul_V2 = mkTerm "overhaul_V2" ;
lin overhead_A = mkTerm "overhead_A" ;
lin overhead_Adv = mkTerm "overhead_Adv" ;
lin overhead_N = mkTerm "overhead_N" ;
lin overhear_V2 = mkTerm "overhear_V2" ;
lin overheat_V2 = mkTerm "overheat_V2" ;
lin overheating_N = mkTerm "overheating_N" ;
lin overindulge_V = mkTerm "overindulge_V" ;
lin overindulge_V2 = mkTerm "overindulge_V2" ;
lin overindulgence_N = mkTerm "overindulgence_N" ;
lin overindulgent_A = mkTerm "overindulgent_A" ;
lin overjealous_A = mkTerm "overjealous_A" ;
lin overjoyed_A = mkTerm "overjoyed_A" ;
lin overkill_N = mkTerm "overkill_N" ;
lin overladen_A = mkTerm "overladen_A" ;
lin overland_A = mkTerm "overland_A" ;
lin overlap_N = mkTerm "overlap_N" ;
lin overlap_V = mkTerm "overlap_V" ;
lin overlap_V2 = mkTerm "overlap_V2" ;
lin overlarge_A = mkTerm "overlarge_A" ;
lin overlay_N = mkTerm "overlay_N" ;
lin overlay_V2 = mkTerm "overlay_V2" ;
lin overleaf_Adv = mkTerm "overleaf_Adv" ;
lin overleap_V2 = mkTerm "overleap_V2" ;
lin overlie_V = mkTerm "overlie_V" ;
lin overlip_N = mkTerm "overlip_N" ;
lin overload_N = mkTerm "overload_N" ;
lin overload_V2 = mkTerm "overload_V2" ;
lin overlook_N = mkTerm "overlook_N" ;
lin overlook_V2 = mkTerm "overlook_V2" ;
lin overlord_N = mkTerm "overlord_N" ;
lin overlordship_N = mkTerm "overlordship_N" ;
lin overly_Adv = mkTerm "overly_Adv" ;
lin overmantel_N = mkTerm "overmantel_N" ;
lin overmaster_V2 = mkTerm "overmaster_V2" ;
lin overmodest_A = mkTerm "overmodest_A" ;
lin overmuch_A = mkTerm "overmuch_A" ;
lin overmuch_Adv = mkTerm "overmuch_Adv" ;
lin overnervous_A = mkTerm "overnervous_A" ;
lin overnight_A = mkTerm "overnight_A" ;
lin overnight_Adv = mkTerm "overnight_Adv" ;
lin overnighter_N = mkTerm "overnighter_N" ;
lin overpass_N = mkTerm "overpass_N" ;
lin overpay_V = mkTerm "overpay_V" ;
lin overpay_V2 = mkTerm "overpay_V2" ;
lin overpayment_N = mkTerm "overpayment_N" ;
lin overplant_V2 = mkTerm "overplant_V2" ;
lin overplay_V2 = mkTerm "overplay_V2" ;
lin overplus_N = mkTerm "overplus_N" ;
lin overpopulation_N = mkTerm "overpopulation_N" ;
lin overpower_V2 = mkTerm "overpower_V2" ;
lin overpowering_A = mkTerm "overpowering_A" ;
lin overpraise_V2 = mkTerm "overpraise_V2" ;
lin overpressure_N = mkTerm "overpressure_N" ;
lin overprice_V2 = mkTerm "overprice_V2" ;
lin overprint_N = mkTerm "overprint_N" ;
lin overprint_V2 = mkTerm "overprint_V2" ;
lin overproduce_V = mkTerm "overproduce_V" ;
lin overproduce_V2 = mkTerm "overproduce_V2" ;
lin overproduction_N = mkTerm "overproduction_N" ;
lin overprotective_A = mkTerm "overprotective_A" ;
lin overproud_A = mkTerm "overproud_A" ;
lin overrate_V2 = mkTerm "overrate_V2" ;
lin overreach_V2 = mkTerm "overreach_V2" ;
lin overreaching_A = mkTerm "overreaching_A" ;
lin overreact_V = mkTerm "overreact_V" ;
lin overreaction_N = mkTerm "overreaction_N" ;
lin overrefined_A = mkTerm "overrefined_A" ;
lin override_N = mkTerm "override_N" ;
lin override_V2 = mkTerm "override_V2" ;
lin overriding_A = mkTerm "overriding_A" ;
lin overrule_V2 = mkTerm "overrule_V2" ;
lin overrun_V2 = mkTerm "overrun_V2" ;
lin oversea_A = mkTerm "oversea_A" ;
lin oversea_Adv = mkTerm "oversea_Adv" ;
lin overseas_A = mkTerm "overseas_A" ;
lin overseas_Adv = mkTerm "overseas_Adv" ;
lin oversee_V2 = mkTerm "oversee_V2" ;
lin overseer_N = mkTerm "overseer_N" ;
lin oversell_V2 = mkTerm "oversell_V2" ;
lin oversensitive_A = mkTerm "oversensitive_A" ;
lin oversensitiveness_N = mkTerm "oversensitiveness_N" ;
lin overserious_A = mkTerm "overserious_A" ;
lin oversew_V2 = mkTerm "oversew_V2" ;
lin oversewn_A = mkTerm "oversewn_A" ;
lin oversexed_A = mkTerm "oversexed_A" ;
lin overshadow_V2 = mkTerm "overshadow_V2" ;
lin overshoe_N = mkTerm "overshoe_N" ;
lin overshoot_N = mkTerm "overshoot_N" ;
lin overshoot_V2 = mkTerm "overshoot_V2" ;
lin overside_Adv = mkTerm "overside_Adv" ;
lin oversight_N = mkTerm "oversight_N" ;
lin oversimplification_N = mkTerm "oversimplification_N" ;
lin oversimplify_V = mkTerm "oversimplify_V" ;
lin oversimplify_V2 = mkTerm "oversimplify_V2" ;
lin oversize_A = mkTerm "oversize_A" ;
lin oversized_A = mkTerm "oversized_A" ;
lin overskirt_N = mkTerm "overskirt_N" ;
lin oversleep_V = mkTerm "oversleep_V" ;
lin oversolicitous_A = mkTerm "oversolicitous_A" ;
lin overspend_V = mkTerm "overspend_V" ;
lin overspend_V2 = mkTerm "overspend_V2" ;
lin overspill_N = mkTerm "overspill_N" ;
lin overstate_V2 = mkTerm "overstate_V2" ;
lin overstatement_N = mkTerm "overstatement_N" ;
lin overstay_V2 = mkTerm "overstay_V2" ;
lin overstep_V2 = mkTerm "overstep_V2" ;
lin overstock_V2 = mkTerm "overstock_V2" ;
lin overstrain_N = mkTerm "overstrain_N" ;
lin overstrain_V2 = mkTerm "overstrain_V2" ;
lin overstrung_A = mkTerm "overstrung_A" ;
lin overstuffed_A = mkTerm "overstuffed_A" ;
lin oversubscribe_V2 = mkTerm "oversubscribe_V2" ;
lin oversuspicious_A = mkTerm "oversuspicious_A" ;
lin overt_A = mkTerm "overt_A" ;
lin overtake_V2 = mkTerm "overtake_V2" ;
lin overtax_V2 = mkTerm "overtax_V2" ;
lin overthrow_N = mkTerm "overthrow_N" ;
lin overthrow_V2 = mkTerm "overthrow_V2" ;
lin overthwart_Prep = mkTerm "overthwart_Prep" ;
lin overtime_Adv = mkTerm "overtime_Adv" ;
lin overtime_N = mkTerm "overtime_N" ;
lin overtolerance_N = mkTerm "overtolerance_N" ;
lin overtone_N = mkTerm "overtone_N" ;
lin overtop_V2 = mkTerm "overtop_V2" ;
lin overtrump_V2 = mkTerm "overtrump_V2" ;
lin overture_N = mkTerm "overture_N" ;
lin overturn_N = mkTerm "overturn_N" ;
lin overturn_V = mkTerm "overturn_V" ;
lin overturn_V2 = mkTerm "overturn_V2" ;
lin overvaliant_A = mkTerm "overvaliant_A" ;
lin overvaluation_N = mkTerm "overvaluation_N" ;
lin overvalue_V2 = mkTerm "overvalue_V2" ;
lin overview_N = mkTerm "overview_N" ;
lin overweening_A = mkTerm "overweening_A" ;
lin overweight_A = mkTerm "overweight_A" ;
lin overweight_N = mkTerm "overweight_N" ;
lin overweighted_A = mkTerm "overweighted_A" ;
lin overwhelm_V2 = mkTerm "overwhelm_V2" ;
lin overwhelming_A = mkTerm "overwhelming_A" ;
lin overwork_N = mkTerm "overwork_N" ;
lin overwork_V = mkTerm "overwork_V" ;
lin overwork_V2 = mkTerm "overwork_V2" ;
lin overwrought_A = mkTerm "overwrought_A" ;
lin overzealous_A = mkTerm "overzealous_A" ;
lin oviduct_N = mkTerm "oviduct_N" ;
lin oviedo_PN = mkTerm "oviedo_PN" ;
lin ovine_A = mkTerm "ovine_A" ;
lin oviparous_A = mkTerm "oviparous_A" ;
lin ovipositor_N = mkTerm "ovipositor_N" ;
lin oviraptorid_N = mkTerm "oviraptorid_N" ;
lin ovoid_A = mkTerm "ovoid_A" ;
lin ovoid_N = mkTerm "ovoid_N" ;
lin ovolo_N = mkTerm "ovolo_N" ;
lin ovotestis_N = mkTerm "ovotestis_N" ;
lin ovoviviparous_A = mkTerm "ovoviviparous_A" ;
lin ovular_A = mkTerm "ovular_A" ;
lin ovulation_N = mkTerm "ovulation_N" ;
lin ovule_N = mkTerm "ovule_N" ;
lin ovum_N = mkTerm "ovum_N" ;
lin owe_V = mkTerm "owe_V" ;
lin owe_V2 = mkTerm "owe_V2" ;
lin owe_to_V3 = mkTerm "owe_to_V3" ;
lin owing_to_Prep = mkTerm "owing_to_Prep" ;
lin owl_N = mkTerm "owl_N" ;
lin owlet_N = mkTerm "owlet_N" ;
lin owlish_A = mkTerm "owlish_A" ;
lin own_A = mkTerm "own_A" ;
lin own_V2 = mkTerm "own_V2" ;
lin own_up_V = mkTerm "own_up_V" ;
lin owner_N = mkTerm "owner_N" ;
lin owner_driven_A = mkTerm "owner_driven_A" ;
lin owner_driver_N = mkTerm "owner_driver_N" ;
lin owner_occupied_A = mkTerm "owner_occupied_A" ;
lin owner_occupier_N = mkTerm "owner_occupier_N" ;
lin ownerless_A = mkTerm "ownerless_A" ;
lin ownership_N = mkTerm "ownership_N" ;
lin ox_N = mkTerm "ox_N" ;
lin oxacillin_N = mkTerm "oxacillin_N" ;
lin oxalacetate_N = mkTerm "oxalacetate_N" ;
lin oxalate_N = mkTerm "oxalate_N" ;
lin oxalis_N = mkTerm "oxalis_N" ;
lin oxaprozin_N = mkTerm "oxaprozin_N" ;
lin oxazepam_N = mkTerm "oxazepam_N" ;
lin oxbow_N = mkTerm "oxbow_N" ;
lin oxbridge_PN = mkTerm "oxbridge_PN" ;
lin oxcart_N = mkTerm "oxcart_N" ;
lin oxeye_N = mkTerm "oxeye_N" ;
lin oxeyed_A = mkTerm "oxeyed_A" ;
lin oxford_N = mkTerm "oxford_N" ;
lin oxford_PN = mkTerm "oxford_PN" ;
lin oxfordshire_PN = mkTerm "oxfordshire_PN" ;
lin oxidant_N = mkTerm "oxidant_N" ;
lin oxidase_N = mkTerm "oxidase_N" ;
lin oxidation_N = mkTerm "oxidation_N" ;
lin oxidative_A = mkTerm "oxidative_A" ;
lin oxide_N = mkTerm "oxide_N" ;
lin oxidizable_A = mkTerm "oxidizable_A" ;
lin oxidization_N = mkTerm "oxidization_N" ;
lin oxidize_V = mkTerm "oxidize_V" ;
lin oxidize_V2 = mkTerm "oxidize_V2" ;
lin oxidoreductase_N = mkTerm "oxidoreductase_N" ;
lin oxime_N = mkTerm "oxime_N" ;
lin oximeter_N = mkTerm "oximeter_N" ;
lin oxlip_N = mkTerm "oxlip_N" ;
lin oxon_PN = mkTerm "oxon_PN" ;
lin oxonian_A = mkTerm "oxonian_A" ;
lin oxonian_N = mkTerm "oxonian_N" ;
lin oxtail_N = mkTerm "oxtail_N" ;
lin oxtant_N = mkTerm "oxtant_N" ;
lin oxted_PN = mkTerm "oxted_PN" ;
lin oxtongue_N = mkTerm "oxtongue_N" ;
lin oxyacetylene_A = mkTerm "oxyacetylene_A" ;
lin oxyacetylene_N = mkTerm "oxyacetylene_N" ;
lin oxyacid_N = mkTerm "oxyacid_N" ;
lin oxycephaly_N = mkTerm "oxycephaly_N" ;
lin oxygen_N = mkTerm "oxygen_N" ;
lin oxygenase_N = mkTerm "oxygenase_N" ;
lin oxygenate_V2 = mkTerm "oxygenate_V2" ;
lin oxygenation_N = mkTerm "oxygenation_N" ;
lin oxygenize_V2 = mkTerm "oxygenize_V2" ;
lin oxyhemoglobin_N = mkTerm "oxyhemoglobin_N" ;
lin oxymoron_N = mkTerm "oxymoron_N" ;
lin oxyopia_N = mkTerm "oxyopia_N" ;
lin oxyphenbutazone_N = mkTerm "oxyphenbutazone_N" ;
lin oxyphencyclimine_N = mkTerm "oxyphencyclimine_N" ;
lin oxytetracycline_N = mkTerm "oxytetracycline_N" ;
lin oxytocic_N = mkTerm "oxytocic_N" ;
lin oxytocin_N = mkTerm "oxytocin_N" ;
lin oxytone_N = mkTerm "oxytone_N" ;
lin oyabun_N = mkTerm "oyabun_N" ;
lin oyster_N = mkTerm "oyster_N" ;
lin oyster_bank_N = mkTerm "oyster_bank_N" ;
lin oyster_bar_N = mkTerm "oyster_bar_N" ;
lin oyster_bed_N = mkTerm "oyster_bed_N" ;
lin oyster_catcher_N = mkTerm "oyster_catcher_N" ;
lin oz_N = mkTerm "oz_N" ;
lin ozena_N = mkTerm "ozena_N" ;
lin ozone_N = mkTerm "ozone_N" ;
lin ozonide_N = mkTerm "ozonide_N" ;
lin ozzie_PN = mkTerm "ozzie_PN" ;
lin pa_N = mkTerm "pa_N" ;
lin paanga_N = mkTerm "paanga_N" ;
lin pabulum_N = mkTerm "pabulum_N" ;
lin paca_N = mkTerm "paca_N" ;
lin pace_N = mkTerm "pace_N" ;
lin pace_Prep = mkTerm "pace_Prep" ;
lin pace_V = mkTerm "pace_V" ;
lin pace_V2 = mkTerm "pace_V2" ;
lin pacemaker_N = mkTerm "pacemaker_N" ;
lin pacer_N = mkTerm "pacer_N" ;
lin pacesetter_N = mkTerm "pacesetter_N" ;
lin pachinko_N = mkTerm "pachinko_N" ;
lin pachisi_N = mkTerm "pachisi_N" ;
lin pachuco_N = mkTerm "pachuco_N" ;
lin pachycephalosaur_N = mkTerm "pachycephalosaur_N" ;
lin pachycheilia_N = mkTerm "pachycheilia_N" ;
lin pachyderm_N = mkTerm "pachyderm_N" ;
lin pachydermatous_A = mkTerm "pachydermatous_A" ;
lin pachysandra_N = mkTerm "pachysandra_N" ;
lin pachytene_N = mkTerm "pachytene_N" ;
lin pacific_A = mkTerm "pacific_A" ;
lin pacific_PN = mkTerm "pacific_PN" ;
lin pacification_N = mkTerm "pacification_N" ;
lin pacifier_N = mkTerm "pacifier_N" ;
lin pacifism_N = mkTerm "pacifism_N" ;
lin pacifistFem_N = mkTerm "pacifistFem_N" ;
lin pacifistMasc_N = mkTerm "pacifistMasc_N" ;
lin pacifistically_Adv = mkTerm "pacifistically_Adv" ;
lin pacify_V2 = mkTerm "pacify_V2" ;
lin pacing_N = mkTerm "pacing_N" ;
lin pack_N = mkTerm "pack_N" ;
lin pack_V = mkTerm "pack_V" ;
lin pack_V2 = mkTerm "pack_V2" ;
lin pack_animal_N = mkTerm "pack_animal_N" ;
lin pack_away_V2 = mkTerm "pack_away_V2" ;
lin pack_in_V = mkTerm "pack_in_V" ;
lin pack_in_V2 = mkTerm "pack_in_V2" ;
lin pack_it_in_V = mkTerm "pack_it_in_V" ;
lin pack_off_V2 = mkTerm "pack_off_V2" ;
lin pack_out_V2 = mkTerm "pack_out_V2" ;
lin pack_saddle_N = mkTerm "pack_saddle_N" ;
lin pack_thread_N = mkTerm "pack_thread_N" ;
lin pack_up_V = mkTerm "pack_up_V" ;
lin pack_up_V2 = mkTerm "pack_up_V2" ;
lin packable_A = mkTerm "packable_A" ;
lin package_N = mkTerm "package_N" ;
lin package_V2 = mkTerm "package_V2" ;
lin packaging_N = mkTerm "packaging_N" ;
lin packer_N = mkTerm "packer_N" ;
lin packet_N = mkTerm "packet_N" ;
lin packet_boat_N = mkTerm "packet_boat_N" ;
lin packhorse_N = mkTerm "packhorse_N" ;
lin packing_N = mkTerm "packing_N" ;
lin packing_case_N = mkTerm "packing_case_N" ;
lin packing_needle_N = mkTerm "packing_needle_N" ;
lin packinghouse_N = mkTerm "packinghouse_N" ;
lin packrat_N = mkTerm "packrat_N" ;
lin pact_N = mkTerm "pact_N" ;
lin pad_N = mkTerm "pad_N" ;
lin pad_V = mkTerm "pad_V" ;
lin pad_V2 = mkTerm "pad_V2" ;
lin pad_down_V = mkTerm "pad_down_V" ;
lin pad_out_V2 = mkTerm "pad_out_V2" ;
lin padasjoki_PN = mkTerm "padasjoki_PN" ;
lin padauk_N = mkTerm "padauk_N" ;
lin padding_N = mkTerm "padding_N" ;
lin paddle_N = mkTerm "paddle_N" ;
lin paddle_V = mkTerm "paddle_V" ;
lin paddle_V2 = mkTerm "paddle_V2" ;
lin paddle_box_N = mkTerm "paddle_box_N" ;
lin paddle_steamer_N = mkTerm "paddle_steamer_N" ;
lin paddle_wheel_N = mkTerm "paddle_wheel_N" ;
lin paddlefish_N = mkTerm "paddlefish_N" ;
lin paddock_N = mkTerm "paddock_N" ;
lin paddy_N = mkTerm "paddy_N" ;
lin paddy_PN = mkTerm "paddy_PN" ;
lin paddy_field_N = mkTerm "paddy_field_N" ;
lin paddy_wagon_N = mkTerm "paddy_wagon_N" ;
lin pademelon_N = mkTerm "pademelon_N" ;
lin padlock_N = mkTerm "padlock_N" ;
lin padlock_V2 = mkTerm "padlock_V2" ;
lin padova_PN = mkTerm "padova_PN" ;
lin padre_N = mkTerm "padre_N" ;
lin padrone_N = mkTerm "padrone_N" ;
lin padua_PN = mkTerm "padua_PN" ;
lin paean_N = mkTerm "paean_N" ;
lin paederasty_N = mkTerm "paederasty_N" ;
lin paediatrics_N = mkTerm "paediatrics_N" ;
lin paella_N = mkTerm "paella_N" ;
lin paeony_N = mkTerm "paeony_N" ;
lin pagan_A = mkTerm "pagan_A" ;
lin pagan_N = mkTerm "pagan_N" ;
lin paganism_N = mkTerm "paganism_N" ;
lin page_N = mkTerm "page_N" ;
lin page_V2 = mkTerm "page_V2" ;
lin pageant_N = mkTerm "pageant_N" ;
lin pageantry_N = mkTerm "pageantry_N" ;
lin pageboy_N = mkTerm "pageboy_N" ;
lin pagination_N = mkTerm "pagination_N" ;
lin paging_N = mkTerm "paging_N" ;
lin pagoda_N = mkTerm "pagoda_N" ;
lin pahautea_N = mkTerm "pahautea_N" ;
lin pahoehoe_N = mkTerm "pahoehoe_N" ;
lin paid_A = mkTerm "paid_A" ;
lin pail_N = mkTerm "pail_N" ;
lin pailful_N = mkTerm "pailful_N" ;
lin paillasse_N = mkTerm "paillasse_N" ;
lin pailliasse_N = mkTerm "pailliasse_N" ;
lin paimio_PN = mkTerm "paimio_PN" ;
lin pain_N = mkTerm "pain_N" ;
lin pain_V2 = mkTerm "pain_V2" ;
lin painful_A = mkTerm "painful_A" ;
lin painfulness_N = mkTerm "painfulness_N" ;
lin painkiller_N = mkTerm "painkiller_N" ;
lin painless_A = mkTerm "painless_A" ;
lin painstaking_A = mkTerm "painstaking_A" ;
lin paint_N = mkTerm "paint_N" ;
lin paint_V = mkTerm "paint_V" ;
lin paint_V2 = mkTerm "paint_V2" ;
lin paintable_A = mkTerm "paintable_A" ;
lin paintball_N = mkTerm "paintball_N" ;
lin paintbox_N = mkTerm "paintbox_N" ;
lin paintbrush_N = mkTerm "paintbrush_N" ;
lin painter_N = mkTerm "painter_N" ;
lin painterly_A = mkTerm "painterly_A" ;
lin painting_N = mkTerm "painting_N" ;
lin pair_N = mkTerm "pair_N" ;
lin pair_V = mkTerm "pair_V" ;
lin pair_V2 = mkTerm "pair_V2" ;
lin pair_off_V = mkTerm "pair_off_V" ;
lin pair_off_V2 = mkTerm "pair_off_V2" ;
lin pair_off_with_V2 = mkTerm "pair_off_with_V2" ;
lin pair_up_V = mkTerm "pair_up_V" ;
lin pairing_N = mkTerm "pairing_N" ;
lin paisa_N = mkTerm "paisa_N" ;
lin paisley_N = mkTerm "paisley_N" ;
lin paisley_PN = mkTerm "paisley_PN" ;
lin pajama_N = mkTerm "pajama_N" ;
lin pakistan_PN = mkTerm "pakistan_PN" ;
lin pakistaniFem_N = mkTerm "pakistaniFem_N" ;
lin pakistaniMasc_N = mkTerm "pakistaniMasc_N" ;
lin pakistani_A = mkTerm "pakistani_A" ;
lin pal_N = mkTerm "pal_N" ;
lin pal_V = mkTerm "pal_V" ;
lin pal_about_V = mkTerm "pal_about_V" ;
lin pal_around_V = mkTerm "pal_around_V" ;
lin pal_up_V = mkTerm "pal_up_V" ;
lin palace_N = mkTerm "palace_N" ;
lin paladin_N = mkTerm "paladin_N" ;
lin palaeolithic_A = mkTerm "palaeolithic_A" ;
lin palaeontologist_N = mkTerm "palaeontologist_N" ;
lin palaeontology_N = mkTerm "palaeontology_N" ;
lin palankeen_N = mkTerm "palankeen_N" ;
lin palanquin_N = mkTerm "palanquin_N" ;
lin palatability_N = mkTerm "palatability_N" ;
lin palatable_A = mkTerm "palatable_A" ;
lin palatal_A = mkTerm "palatal_A" ;
lin palatal_N = mkTerm "palatal_N" ;
lin palate_N = mkTerm "palate_N" ;
lin palatial_A = mkTerm "palatial_A" ;
lin palatinate_N = mkTerm "palatinate_N" ;
lin palatine_A = mkTerm "palatine_A" ;
lin palatine_N = mkTerm "palatine_N" ;
lin palatoglossal_A = mkTerm "palatoglossal_A" ;
lin palatopharyngoplasty_N = mkTerm "palatopharyngoplasty_N" ;
lin palaver_N = mkTerm "palaver_N" ;
lin palaver_V = mkTerm "palaver_V" ;
lin pale_A = mkTerm "pale_A" ;
lin pale_N = mkTerm "pale_N" ;
lin pale_V = mkTerm "pale_V" ;
lin paleencephalon_N = mkTerm "paleencephalon_N" ;
lin paleface_N = mkTerm "paleface_N" ;
lin palembang_PN = mkTerm "palembang_PN" ;
lin paleness_N = mkTerm "paleness_N" ;
lin paleoanthropological_A = mkTerm "paleoanthropological_A" ;
lin paleoanthropology_N = mkTerm "paleoanthropology_N" ;
lin paleobiology_N = mkTerm "paleobiology_N" ;
lin paleobotany_N = mkTerm "paleobotany_N" ;
lin paleocerebellum_N = mkTerm "paleocerebellum_N" ;
lin paleoclimatology_N = mkTerm "paleoclimatology_N" ;
lin paleocortical_A = mkTerm "paleocortical_A" ;
lin paleodendrology_N = mkTerm "paleodendrology_N" ;
lin paleoecology_N = mkTerm "paleoecology_N" ;
lin paleoethnography_N = mkTerm "paleoethnography_N" ;
lin paleogeography_N = mkTerm "paleogeography_N" ;
lin paleogeology_N = mkTerm "paleogeology_N" ;
lin paleographer_N = mkTerm "paleographer_N" ;
lin paleography_N = mkTerm "paleography_N" ;
lin paleolith_N = mkTerm "paleolith_N" ;
lin paleolithic_A = mkTerm "paleolithic_A" ;
lin paleology_N = mkTerm "paleology_N" ;
lin paleomammalogy_N = mkTerm "paleomammalogy_N" ;
lin paleontological_A = mkTerm "paleontological_A" ;
lin paleontologist_N = mkTerm "paleontologist_N" ;
lin paleontology_N = mkTerm "paleontology_N" ;
lin paleopathology_N = mkTerm "paleopathology_N" ;
lin paleornithology_N = mkTerm "paleornithology_N" ;
lin paleozoology_N = mkTerm "paleozoology_N" ;
lin palermo_PN = mkTerm "palermo_PN" ;
lin palestine_PN = mkTerm "palestine_PN" ;
lin palestinian_A = mkTerm "palestinian_A" ;
lin palestinian_N = mkTerm "palestinian_N" ;
lin palestra_N = mkTerm "palestra_N" ;
lin paletiology_N = mkTerm "paletiology_N" ;
lin palette_N = mkTerm "palette_N" ;
lin palette_knife_N = mkTerm "palette_knife_N" ;
lin palfrey_N = mkTerm "palfrey_N" ;
lin palilalia_N = mkTerm "palilalia_N" ;
lin palimony_N = mkTerm "palimony_N" ;
lin palimpsest_N = mkTerm "palimpsest_N" ;
lin palindrome_N = mkTerm "palindrome_N" ;
lin paling_N = mkTerm "paling_N" ;
lin palingenesis_N = mkTerm "palingenesis_N" ;
lin palingenetic_A = mkTerm "palingenetic_A" ;
lin palisade_N = mkTerm "palisade_N" ;
lin palisade_V2 = mkTerm "palisade_V2" ;
lin palish_A = mkTerm "palish_A" ;
lin pall_N = mkTerm "pall_N" ;
lin pall_V = mkTerm "pall_V" ;
lin palladium_N = mkTerm "palladium_N" ;
lin pallasite_N = mkTerm "pallasite_N" ;
lin pallbearer_N = mkTerm "pallbearer_N" ;
lin pallet_N = mkTerm "pallet_N" ;
lin pallette_N = mkTerm "pallette_N" ;
lin palliasse_N = mkTerm "palliasse_N" ;
lin palliate_V2 = mkTerm "palliate_V2" ;
lin palliation_N = mkTerm "palliation_N" ;
lin palliative_A = mkTerm "palliative_A" ;
lin palliative_N = mkTerm "palliative_N" ;
lin pallid_A = mkTerm "pallid_A" ;
lin pallidness_N = mkTerm "pallidness_N" ;
lin pallidum_N = mkTerm "pallidum_N" ;
lin pallium_N = mkTerm "pallium_N" ;
lin pallone_N = mkTerm "pallone_N" ;
lin pallor_N = mkTerm "pallor_N" ;
lin pally_A = mkTerm "pally_A" ;
lin palm_1_N = mkTerm "palm_1_N" ;
lin palm_2_N = mkTerm "palm_2_N" ;
lin palm_3_N = mkTerm "palm_3_N" ;
lin palm_V2 = mkTerm "palm_V2" ;
lin palm_off_V = mkTerm "palm_off_V" ;
lin palm_off_V2 = mkTerm "palm_off_V2" ;
lin palm_oil_N = mkTerm "palm_oil_N" ;
lin palmar_A = mkTerm "palmar_A" ;
lin palmate_A = mkTerm "palmate_A" ;
lin palmatifid_A = mkTerm "palmatifid_A" ;
lin palmature_N = mkTerm "palmature_N" ;
lin palmer_N = mkTerm "palmer_N" ;
lin palmetto_N = mkTerm "palmetto_N" ;
lin palmist_N = mkTerm "palmist_N" ;
lin palmistry_N = mkTerm "palmistry_N" ;
lin palmitin_N = mkTerm "palmitin_N" ;
lin palmlike_A = mkTerm "palmlike_A" ;
lin palmy_A = mkTerm "palmy_A" ;
lin palmyra_N = mkTerm "palmyra_N" ;
lin palometa_N = mkTerm "palometa_N" ;
lin palomino_N = mkTerm "palomino_N" ;
lin paloverde_N = mkTerm "paloverde_N" ;
lin palpable_A = mkTerm "palpable_A" ;
lin palpation_N = mkTerm "palpation_N" ;
lin palpatory_A = mkTerm "palpatory_A" ;
lin palpebrate_A = mkTerm "palpebrate_A" ;
lin palpebration_N = mkTerm "palpebration_N" ;
lin palpitant_A = mkTerm "palpitant_A" ;
lin palpitate_V = mkTerm "palpitate_V" ;
lin palpitation_N = mkTerm "palpitation_N" ;
lin palsy_N = mkTerm "palsy_N" ;
lin palsy_V2 = mkTerm "palsy_V2" ;
lin paltamo_PN = mkTerm "paltamo_PN" ;
lin palter_V = mkTerm "palter_V" ;
lin paltriness_N = mkTerm "paltriness_N" ;
lin paltry_A = mkTerm "paltry_A" ;
lin pam_PN = mkTerm "pam_PN" ;
lin pamela_PN = mkTerm "pamela_PN" ;
lin pampas_N = mkTerm "pampas_N" ;
lin pampas_grass_N = mkTerm "pampas_grass_N" ;
lin pamper_V2 = mkTerm "pamper_V2" ;
lin pamperer_N = mkTerm "pamperer_N" ;
lin pamphlet_N = mkTerm "pamphlet_N" ;
lin pamphleteerFem_N = mkTerm "pamphleteerFem_N" ;
lin pamphleteerMasc_N = mkTerm "pamphleteerMasc_N" ;
lin pamplona_PN = mkTerm "pamplona_PN" ;
lin pan_N = mkTerm "pan_N" ;
lin pan_V = mkTerm "pan_V" ;
lin pan_V2 = mkTerm "pan_V2" ;
lin pan_out_V = mkTerm "pan_out_V" ;
lin panacea_N = mkTerm "panacea_N" ;
lin panache_N = mkTerm "panache_N" ;
lin panama_N = mkTerm "panama_N" ;
lin panama_PN = mkTerm "panama_PN" ;
lin panamanian_A = mkTerm "panamanian_A" ;
lin panamanian_N = mkTerm "panamanian_N" ;
lin panatela_N = mkTerm "panatela_N" ;
lin panatella_N = mkTerm "panatella_N" ;
lin pancake_N = mkTerm "pancake_N" ;
lin pancarditis_N = mkTerm "pancarditis_N" ;
lin panchayat_N = mkTerm "panchayat_N" ;
lin panchromatic_A = mkTerm "panchromatic_A" ;
lin pancreas_N = mkTerm "pancreas_N" ;
lin pancreatectomy_N = mkTerm "pancreatectomy_N" ;
lin pancreatic_A = mkTerm "pancreatic_A" ;
lin pancreatin_N = mkTerm "pancreatin_N" ;
lin pancreatitis_N = mkTerm "pancreatitis_N" ;
lin pancytopenia_N = mkTerm "pancytopenia_N" ;
lin panda_N = mkTerm "panda_N" ;
lin pandanus_N = mkTerm "pandanus_N" ;
lin pandemic_A = mkTerm "pandemic_A" ;
lin pandemic_N = mkTerm "pandemic_N" ;
lin pandemonium_N = mkTerm "pandemonium_N" ;
lin pander_N = mkTerm "pander_N" ;
lin pander_V = mkTerm "pander_V" ;
lin panderer_N = mkTerm "panderer_N" ;
lin pandiculation_N = mkTerm "pandiculation_N" ;
lin pandurate_A = mkTerm "pandurate_A" ;
lin pane_N = mkTerm "pane_N" ;
lin panegyric_N = mkTerm "panegyric_N" ;
lin panel_N = mkTerm "panel_N" ;
lin panel_V2 = mkTerm "panel_V2" ;
lin paneled_A = mkTerm "paneled_A" ;
lin paneling_N = mkTerm "paneling_N" ;
lin panelist_N = mkTerm "panelist_N" ;
lin panelling_N = mkTerm "panelling_N" ;
lin panencephalitis_N = mkTerm "panencephalitis_N" ;
lin panfish_N = mkTerm "panfish_N" ;
lin pang_N = mkTerm "pang_N" ;
lin panga_N = mkTerm "panga_N" ;
lin pangolin_N = mkTerm "pangolin_N" ;
lin panhandle_N = mkTerm "panhandle_N" ;
lin panhandle_V = mkTerm "panhandle_V" ;
lin panhandler_N = mkTerm "panhandler_N" ;
lin panic_N = mkTerm "panic_N" ;
lin panic_V = mkTerm "panic_V" ;
lin panic_V2 = mkTerm "panic_V2" ;
lin panic_stricken_A = mkTerm "panic_stricken_A" ;
lin panicky_A = mkTerm "panicky_A" ;
lin panicle_N = mkTerm "panicle_N" ;
lin panicled_A = mkTerm "panicled_A" ;
lin paniculate_A = mkTerm "paniculate_A" ;
lin panjandrum_N = mkTerm "panjandrum_N" ;
lin pannier_N = mkTerm "pannier_N" ;
lin pannikin_N = mkTerm "pannikin_N" ;
lin panoplied_A = mkTerm "panoplied_A" ;
lin panoply_N = mkTerm "panoply_N" ;
lin panoptic_A = mkTerm "panoptic_A" ;
lin panopticon_N = mkTerm "panopticon_N" ;
lin panorama_N = mkTerm "panorama_N" ;
lin panoramic_A = mkTerm "panoramic_A" ;
lin panpipe_N = mkTerm "panpipe_N" ;
lin pansexual_N = mkTerm "pansexual_N" ;
lin pansinusitis_N = mkTerm "pansinusitis_N" ;
lin pansy_N = mkTerm "pansy_N" ;
lin pant_N = mkTerm "pant_N" ;
lin pant_V = mkTerm "pant_V" ;
lin pant_V2 = mkTerm "pant_V2" ;
lin pantaloon_N = mkTerm "pantaloon_N" ;
lin pantechnicon_N = mkTerm "pantechnicon_N" ;
lin pantheism_N = mkTerm "pantheism_N" ;
lin pantheist_A = mkTerm "pantheist_A" ;
lin pantheist_N = mkTerm "pantheist_N" ;
lin pantheistic_A = mkTerm "pantheistic_A" ;
lin pantheon_N = mkTerm "pantheon_N" ;
lin panther_N = mkTerm "panther_N" ;
lin pantie_N = mkTerm "pantie_N" ;
lin pantile_N = mkTerm "pantile_N" ;
lin panting_N = mkTerm "panting_N" ;
lin pantingly_Adv = mkTerm "pantingly_Adv" ;
lin panto_N = mkTerm "panto_N" ;
lin pantograph_N = mkTerm "pantograph_N" ;
lin pantomime_N = mkTerm "pantomime_N" ;
lin pantropical_A = mkTerm "pantropical_A" ;
lin pantry_N = mkTerm "pantry_N" ;
lin pantryman_N = mkTerm "pantryman_N" ;
lin pantyhose_N = mkTerm "pantyhose_N" ;
lin panzer_A = mkTerm "panzer_A" ;
lin panzer_N = mkTerm "panzer_N" ;
lin paotow_PN = mkTerm "paotow_PN" ;
lin pap_N = mkTerm "pap_N" ;
lin papa_N = mkTerm "papa_N" ;
lin papacy_N = mkTerm "papacy_N" ;
lin papain_N = mkTerm "papain_N" ;
lin papal_A = mkTerm "papal_A" ;
lin paparazzo_N = mkTerm "paparazzo_N" ;
lin papaverine_N = mkTerm "papaverine_N" ;
lin papaw_N = mkTerm "papaw_N" ;
lin papaya_N = mkTerm "papaya_N" ;
lin paper_N = mkTerm "paper_N" ;
lin paper_V2 = mkTerm "paper_V2" ;
lin paper_chase_N = mkTerm "paper_chase_N" ;
lin paper_over_V2 = mkTerm "paper_over_V2" ;
lin paperback_A = mkTerm "paperback_A" ;
lin paperback_N = mkTerm "paperback_N" ;
lin paperbacked_A = mkTerm "paperbacked_A" ;
lin paperboard_N = mkTerm "paperboard_N" ;
lin paperboy_N = mkTerm "paperboy_N" ;
lin paperclip_N = mkTerm "paperclip_N" ;
lin paperhanger_N = mkTerm "paperhanger_N" ;
lin papering_N = mkTerm "papering_N" ;
lin paperknife_N = mkTerm "paperknife_N" ;
lin paperless_A = mkTerm "paperless_A" ;
lin papermaking_N = mkTerm "papermaking_N" ;
lin papermill_N = mkTerm "papermill_N" ;
lin paperweight_N = mkTerm "paperweight_N" ;
lin paperwork_N = mkTerm "paperwork_N" ;
lin papery_A = mkTerm "papery_A" ;
lin papier_mache_N = mkTerm "papier_mache_N" ;
lin papilla_N = mkTerm "papilla_N" ;
lin papillary_A = mkTerm "papillary_A" ;
lin papillate_A = mkTerm "papillate_A" ;
lin papilledema_N = mkTerm "papilledema_N" ;
lin papilliform_A = mkTerm "papilliform_A" ;
lin papilloma_N = mkTerm "papilloma_N" ;
lin papillon_N = mkTerm "papillon_N" ;
lin papist_A = mkTerm "papist_A" ;
lin papist_N = mkTerm "papist_N" ;
lin papoose_N = mkTerm "papoose_N" ;
lin papovavirus_N = mkTerm "papovavirus_N" ;
lin pappose_A = mkTerm "pappose_A" ;
lin pappus_N = mkTerm "pappus_N" ;
lin paprika_N = mkTerm "paprika_N" ;
lin papua_PN = mkTerm "papua_PN" ;
lin papuan_A = mkTerm "papuan_A" ;
lin papuan_N = mkTerm "papuan_N" ;
lin papule_N = mkTerm "papule_N" ;
lin papulovesicle_N = mkTerm "papulovesicle_N" ;
lin papyrus_N = mkTerm "papyrus_N" ;
lin par_N = mkTerm "par_N" ;
lin par_down_V = mkTerm "par_down_V" ;
lin par_excellence_Adv = mkTerm "par_excellence_Adv" ;
lin para_N = mkTerm "para_N" ;
lin parable_N = mkTerm "parable_N" ;
lin parabola_N = mkTerm "parabola_N" ;
lin parabolic_A = mkTerm "parabolic_A" ;
lin parabolical_A = mkTerm "parabolical_A" ;
lin paraboloid_N = mkTerm "paraboloid_N" ;
lin paraboloidal_A = mkTerm "paraboloidal_A" ;
lin parachute_N = mkTerm "parachute_N" ;
lin parachute_V = mkTerm "parachute_V" ;
lin parachute_V2 = mkTerm "parachute_V2" ;
lin parachutist_N = mkTerm "parachutist_N" ;
lin paracosm_N = mkTerm "paracosm_N" ;
lin parade_N = mkTerm "parade_N" ;
lin parade_V = mkTerm "parade_V" ;
lin parade_V2 = mkTerm "parade_V2" ;
lin parade_ground_N = mkTerm "parade_ground_N" ;
lin paradiddle_N = mkTerm "paradiddle_N" ;
lin paradigm_N = mkTerm "paradigm_N" ;
lin paradigmatic_A = mkTerm "paradigmatic_A" ;
lin paradise_N = mkTerm "paradise_N" ;
lin paradisiac_A = mkTerm "paradisiac_A" ;
lin paradisiacal_A = mkTerm "paradisiacal_A" ;
lin paradox_N = mkTerm "paradox_N" ;
lin paradoxical_A = mkTerm "paradoxical_A" ;
lin paraffin_N = mkTerm "paraffin_N" ;
lin parafovea_N = mkTerm "parafovea_N" ;
lin paragon_N = mkTerm "paragon_N" ;
lin paragonite_N = mkTerm "paragonite_N" ;
lin paragraph_N = mkTerm "paragraph_N" ;
lin paragraph_V2 = mkTerm "paragraph_V2" ;
lin paragrapher_N = mkTerm "paragrapher_N" ;
lin paraguay_PN = mkTerm "paraguay_PN" ;
lin paraguayan_A = mkTerm "paraguayan_A" ;
lin paraguayan_N = mkTerm "paraguayan_N" ;
lin parakeet_N = mkTerm "parakeet_N" ;
lin paralanguage_N = mkTerm "paralanguage_N" ;
lin paraldehyde_N = mkTerm "paraldehyde_N" ;
lin paralegal_N = mkTerm "paralegal_N" ;
lin paralepsis_N = mkTerm "paralepsis_N" ;
lin parallax_N = mkTerm "parallax_N" ;
lin parallel_A = mkTerm "parallel_A" ;
lin parallel_N = mkTerm "parallel_N" ;
lin parallel_V2 = mkTerm "parallel_V2" ;
lin parallelepiped_N = mkTerm "parallelepiped_N" ;
lin parallelism_N = mkTerm "parallelism_N" ;
lin parallelogram_N = mkTerm "parallelogram_N" ;
lin paralogism_N = mkTerm "paralogism_N" ;
lin paralyse_V2 = mkTerm "paralyse_V2" ;
lin paralysis_N = mkTerm "paralysis_N" ;
lin paralytic_A = mkTerm "paralytic_A" ;
lin paralytic_N = mkTerm "paralytic_N" ;
lin paralyze_V2 = mkTerm "paralyze_V2" ;
lin paramagnet_N = mkTerm "paramagnet_N" ;
lin paramagnetic_A = mkTerm "paramagnetic_A" ;
lin paramagnetism_N = mkTerm "paramagnetism_N" ;
lin paramecium_N = mkTerm "paramecium_N" ;
lin paramedic_N = mkTerm "paramedic_N" ;
lin paramedical_A = mkTerm "paramedical_A" ;
lin parameter_N = mkTerm "parameter_N" ;
lin parametric_A = mkTerm "parametric_A" ;
lin parametritis_N = mkTerm "parametritis_N" ;
lin paramilitary_A = mkTerm "paramilitary_A" ;
lin paramilitary_N = mkTerm "paramilitary_N" ;
lin paramnesia_N = mkTerm "paramnesia_N" ;
lin paramount_A = mkTerm "paramount_A" ;
lin paramountcy_N = mkTerm "paramountcy_N" ;
lin paramour_N = mkTerm "paramour_N" ;
lin paramyxovirus_N = mkTerm "paramyxovirus_N" ;
lin paranasal_A = mkTerm "paranasal_A" ;
lin parang_N = mkTerm "parang_N" ;
lin paranoia_N = mkTerm "paranoia_N" ;
lin paranoiac_N = mkTerm "paranoiac_N" ;
lin paranoid_A = mkTerm "paranoid_A" ;
lin paranoid_N = mkTerm "paranoid_N" ;
lin paranormal_A = mkTerm "paranormal_A" ;
lin paraparesis_N = mkTerm "paraparesis_N" ;
lin parapet_N = mkTerm "parapet_N" ;
lin paraph_N = mkTerm "paraph_N" ;
lin paraphernalia_N = mkTerm "paraphernalia_N" ;
lin paraphilia_N = mkTerm "paraphilia_N" ;
lin paraphrase_N = mkTerm "paraphrase_N" ;
lin paraphrase_V2 = mkTerm "paraphrase_V2" ;
lin paraphrastic_A = mkTerm "paraphrastic_A" ;
lin paraphysis_N = mkTerm "paraphysis_N" ;
lin paraplegia_N = mkTerm "paraplegia_N" ;
lin paraplegic_A = mkTerm "paraplegic_A" ;
lin paraplegic_N = mkTerm "paraplegic_N" ;
lin parapodium_N = mkTerm "parapodium_N" ;
lin paraprofessional_N = mkTerm "paraprofessional_N" ;
lin parapsychological_A = mkTerm "parapsychological_A" ;
lin parapsychologist_N = mkTerm "parapsychologist_N" ;
lin paraquat_N = mkTerm "paraquat_N" ;
lin parasail_N = mkTerm "parasail_N" ;
lin parasailing_N = mkTerm "parasailing_N" ;
lin parasite_N = mkTerm "parasite_N" ;
lin parasitemia_N = mkTerm "parasitemia_N" ;
lin parasitic_A = mkTerm "parasitic_A" ;
lin parasitical_A = mkTerm "parasitical_A" ;
lin parasitism_N = mkTerm "parasitism_N" ;
lin parasol_N = mkTerm "parasol_N" ;
lin parasympathetic_A = mkTerm "parasympathetic_A" ;
lin parasympathomimetic_A = mkTerm "parasympathomimetic_A" ;
lin parathion_N = mkTerm "parathion_N" ;
lin paratrooper_N = mkTerm "paratrooper_N" ;
lin paratroops_N = mkTerm "paratroops_N" ;
lin paratyphoid_N = mkTerm "paratyphoid_N" ;
lin parboil_V2 = mkTerm "parboil_V2" ;
lin parcel_N = mkTerm "parcel_N" ;
lin parcel_V2 = mkTerm "parcel_V2" ;
lin parcel_out_V = mkTerm "parcel_out_V" ;
lin parcellation_N = mkTerm "parcellation_N" ;
lin parch_V2 = mkTerm "parch_V2" ;
lin parchment_N = mkTerm "parchment_N" ;
lin pardon_N = mkTerm "pardon_N" ;
lin pardon_V2 = mkTerm "pardon_V2" ;
lin pardonable_A = mkTerm "pardonable_A" ;
lin pardoner_N = mkTerm "pardoner_N" ;
lin pare_V2 = mkTerm "pare_V2" ;
lin pare_back_V2 = mkTerm "pare_back_V2" ;
lin pare_down_V2 = mkTerm "pare_down_V2" ;
lin paregmenon_N = mkTerm "paregmenon_N" ;
lin paregoric_N = mkTerm "paregoric_N" ;
lin parenchyma_N = mkTerm "parenchyma_N" ;
lin parent_N = mkTerm "parent_N" ;
lin parentage_N = mkTerm "parentage_N" ;
lin parental_A = mkTerm "parental_A" ;
lin parented_A = mkTerm "parented_A" ;
lin parenteral_A = mkTerm "parenteral_A" ;
lin parenthesis_N = mkTerm "parenthesis_N" ;
lin parenthetic_A = mkTerm "parenthetic_A" ;
lin parenthetical_A = mkTerm "parenthetical_A" ;
lin parenthood_N = mkTerm "parenthood_N" ;
lin parer_N = mkTerm "parer_N" ;
lin paresis_N = mkTerm "paresis_N" ;
lin paresthesia_N = mkTerm "paresthesia_N" ;
lin paretic_N = mkTerm "paretic_N" ;
lin pareve_A = mkTerm "pareve_A" ;
lin parfait_N = mkTerm "parfait_N" ;
lin pargas_PN = mkTerm "pargas_PN" ;
lin parget_N = mkTerm "parget_N" ;
lin pargeting_N = mkTerm "pargeting_N" ;
lin parhelic_A = mkTerm "parhelic_A" ;
lin parhelion_N = mkTerm "parhelion_N" ;
lin pari_mutuel_N = mkTerm "pari_mutuel_N" ;
lin pari_passu_Adv = mkTerm "pari_passu_Adv" ;
lin pariah_N = mkTerm "pariah_N" ;
lin pariah_dog_N = mkTerm "pariah_dog_N" ;
lin parietal_A = mkTerm "parietal_A" ;
lin parikkala_PN = mkTerm "parikkala_PN" ;
lin paring_N = mkTerm "paring_N" ;
lin paris_1_PN = mkTerm "paris_1_PN" ;
lin paris_2_PN = mkTerm "paris_2_PN" ;
lin parish_N = mkTerm "parish_N" ;
lin parishioner_N = mkTerm "parishioner_N" ;
lin parisian_A = mkTerm "parisian_A" ;
lin parisian_N = mkTerm "parisian_N" ;
lin parisology_N = mkTerm "parisology_N" ;
lin parity_N = mkTerm "parity_N" ;
lin park_N = mkTerm "park_N" ;
lin park_V = mkTerm "park_V" ;
lin park_V2 = mkTerm "park_V2" ;
lin parka_N = mkTerm "parka_N" ;
lin parkano_PN = mkTerm "parkano_PN" ;
lin parking_N = mkTerm "parking_N" ;
lin parkinson's_A = mkTerm "parkinson's_A" ;
lin parky_A = mkTerm "parky_A" ;
lin parlance_N = mkTerm "parlance_N" ;
lin parlay_N = mkTerm "parlay_N" ;
lin parley_N = mkTerm "parley_N" ;
lin parley_V = mkTerm "parley_V" ;
lin parliament_N = mkTerm "parliament_N" ;
lin parliamentarian_N = mkTerm "parliamentarian_N" ;
lin parliamentary_A = mkTerm "parliamentary_A" ;
lin parlor_N = mkTerm "parlor_N" ;
lin parlormaid_N = mkTerm "parlormaid_N" ;
lin parlour_N = mkTerm "parlour_N" ;
lin parlour_car_N = mkTerm "parlour_car_N" ;
lin parlous_A = mkTerm "parlous_A" ;
lin parma_PN = mkTerm "parma_PN" ;
lin parmesan_N = mkTerm "parmesan_N" ;
lin parnassia_N = mkTerm "parnassia_N" ;
lin parochial_A = mkTerm "parochial_A" ;
lin parochialism_N = mkTerm "parochialism_N" ;
lin parodist_N = mkTerm "parodist_N" ;
lin parody_N = mkTerm "parody_N" ;
lin parody_V2 = mkTerm "parody_V2" ;
lin paroicous_A = mkTerm "paroicous_A" ;
lin parola_PN = mkTerm "parola_PN" ;
lin parole_N = mkTerm "parole_N" ;
lin parole_V2 = mkTerm "parole_V2" ;
lin paronychia_N = mkTerm "paronychia_N" ;
lin paroquet_N = mkTerm "paroquet_N" ;
lin parotid_A = mkTerm "parotid_A" ;
lin parotitis_N = mkTerm "parotitis_N" ;
lin parous_A = mkTerm "parous_A" ;
lin paroxetime_N = mkTerm "paroxetime_N" ;
lin paroxysm_N = mkTerm "paroxysm_N" ;
lin paroxysmal_A = mkTerm "paroxysmal_A" ;
lin paroxytone_N = mkTerm "paroxytone_N" ;
lin parquet_N = mkTerm "parquet_N" ;
lin parquetry_N = mkTerm "parquetry_N" ;
lin parr_N = mkTerm "parr_N" ;
lin parricide_N = mkTerm "parricide_N" ;
lin parrot_N = mkTerm "parrot_N" ;
lin parrotfish_N = mkTerm "parrotfish_N" ;
lin parrotlike_A = mkTerm "parrotlike_A" ;
lin parry_N = mkTerm "parry_N" ;
lin parry_V2 = mkTerm "parry_V2" ;
lin parse_V2 = mkTerm "parse_V2" ;
lin parsec_N = mkTerm "parsec_N" ;
lin parsee_N = mkTerm "parsee_N" ;
lin parser_N = mkTerm "parser_N" ;
lin parsimonious_A = mkTerm "parsimonious_A" ;
lin parsimony_N = mkTerm "parsimony_N" ;
lin parsley_N = mkTerm "parsley_N" ;
lin parsnip_N = mkTerm "parsnip_N" ;
lin parson_N = mkTerm "parson_N" ;
lin parsonage_N = mkTerm "parsonage_N" ;
lin part_Adv = mkTerm "part_Adv" ;
lin part_N = mkTerm "part_N" ;
lin part_V = mkTerm "part_V" ;
lin part_V2 = mkTerm "part_V2" ;
lin part_of_N2 = mkTerm "part_of_N2" ;
lin part_owner_N = mkTerm "part_owner_N" ;
lin part_singing_N = mkTerm "part_singing_N" ;
lin part_song_N = mkTerm "part_song_N" ;
lin part_time_A = mkTerm "part_time_A" ;
lin part_time_Adv = mkTerm "part_time_Adv" ;
lin part_timer_N = mkTerm "part_timer_N" ;
lin part_with_V2 = mkTerm "part_with_V2" ;
lin partake_V = mkTerm "partake_V" ;
lin partake_V2 = mkTerm "partake_V2" ;
lin partaker_N = mkTerm "partaker_N" ;
lin parterre_N = mkTerm "parterre_N" ;
lin parthenocarpy_N = mkTerm "parthenocarpy_N" ;
lin parthenogenesis_N = mkTerm "parthenogenesis_N" ;
lin parthenote_N = mkTerm "parthenote_N" ;
lin parthian_A = mkTerm "parthian_A" ;
lin parti_coloured_A = mkTerm "parti_coloured_A" ;
lin partial_A = mkTerm "partial_A" ;
lin partial_N = mkTerm "partial_N" ;
lin partiality_N = mkTerm "partiality_N" ;
lin partialness_N = mkTerm "partialness_N" ;
lin partible_A = mkTerm "partible_A" ;
lin participant_N = mkTerm "participant_N" ;
lin participate_V = mkTerm "participate_V" ;
lin participate_V2 = mkTerm "participate_V2" ;
lin participation_N = mkTerm "participation_N" ;
lin participatory_A = mkTerm "participatory_A" ;
lin participial_A = mkTerm "participial_A" ;
lin participle_N = mkTerm "participle_N" ;
lin particle_N = mkTerm "particle_N" ;
lin particular_A = mkTerm "particular_A" ;
lin particular_N = mkTerm "particular_N" ;
lin particularism_N = mkTerm "particularism_N" ;
lin particularistic_A = mkTerm "particularistic_A" ;
lin particularity_N = mkTerm "particularity_N" ;
lin particularization_N = mkTerm "particularization_N" ;
lin particularize_V = mkTerm "particularize_V" ;
lin particularize_V2 = mkTerm "particularize_V2" ;
lin particulate_A = mkTerm "particulate_A" ;
lin particulate_N = mkTerm "particulate_N" ;
lin parting_N = mkTerm "parting_N" ;
lin partisan_A = mkTerm "partisan_A" ;
lin partisan_N = mkTerm "partisan_N" ;
lin partisanship_N = mkTerm "partisanship_N" ;
lin partita_N = mkTerm "partita_N" ;
lin partition_N = mkTerm "partition_N" ;
lin partition_V2 = mkTerm "partition_V2" ;
lin partitionist_N = mkTerm "partitionist_N" ;
lin partitive_A = mkTerm "partitive_A" ;
lin partitive_N = mkTerm "partitive_N" ;
lin partly_Adv = mkTerm "partly_Adv" ;
lin partner_N = mkTerm "partner_N" ;
lin partner_V2 = mkTerm "partner_V2" ;
lin partnership_N = mkTerm "partnership_N" ;
lin partridge_N = mkTerm "partridge_N" ;
lin partridgeberry_N = mkTerm "partridgeberry_N" ;
lin parts_N = mkTerm "parts_N" ;
lin parturiency_N = mkTerm "parturiency_N" ;
lin parturient_A = mkTerm "parturient_A" ;
lin parturition_N = mkTerm "parturition_N" ;
lin party_1_N = mkTerm "party_1_N" ;
lin party_2_N = mkTerm "party_2_N" ;
lin party_spirit_N = mkTerm "party_spirit_N" ;
lin party_spirited_A = mkTerm "party_spirited_A" ;
lin party_wall_N = mkTerm "party_wall_N" ;
lin partygoer_N = mkTerm "partygoer_N" ;
lin parvenu_A = mkTerm "parvenu_A" ;
lin parvenu_N = mkTerm "parvenu_N" ;
lin parvis_N = mkTerm "parvis_N" ;
lin parvovirus_N = mkTerm "parvovirus_N" ;
lin pas_N = mkTerm "pas_N" ;
lin pascal_N = mkTerm "pascal_N" ;
lin paschal_A = mkTerm "paschal_A" ;
lin pasha_N = mkTerm "pasha_N" ;
lin pashto_N = mkTerm "pashto_N" ;
lin pasqueflower_N = mkTerm "pasqueflower_N" ;
lin pass_N = mkTerm "pass_N" ;
lin pass_V = mkTerm "pass_V" ;
lin pass_around_V2 = mkTerm "pass_around_V2" ;
lin pass_as_V2 = mkTerm "pass_as_V2" ;
lin pass_away_V = mkTerm "pass_away_V" ;
lin pass_back_V2 = mkTerm "pass_back_V2" ;
lin pass_by_V = mkTerm "pass_by_V" ;
lin pass_by_V2 = mkTerm "pass_by_V2" ;
lin pass_down_V2 = mkTerm "pass_down_V2" ;
lin pass_for_V2 = mkTerm "pass_for_V2" ;
lin pass_off_V = mkTerm "pass_off_V" ;
lin pass_off_V2 = mkTerm "pass_off_V2" ;
lin pass_on_V = mkTerm "pass_on_V" ;
lin pass_on_V2 = mkTerm "pass_on_V2" ;
lin pass_on_to_V2 = mkTerm "pass_on_to_V2" ;
lin pass_out_V = mkTerm "pass_out_V" ;
lin pass_out_V2 = mkTerm "pass_out_V2" ;
lin pass_over_V = mkTerm "pass_over_V" ;
lin pass_over_V2 = mkTerm "pass_over_V2" ;
lin pass_round_V2 = mkTerm "pass_round_V2" ;
lin pass_through_V2 = mkTerm "pass_through_V2" ;
lin pass_to_V2 = mkTerm "pass_to_V2" ;
lin pass_up_V2 = mkTerm "pass_up_V2" ;
lin passable_A = mkTerm "passable_A" ;
lin passage_N = mkTerm "passage_N" ;
lin passageway_N = mkTerm "passageway_N" ;
lin passbook_N = mkTerm "passbook_N" ;
lin passe_A = mkTerm "passe_A" ;
lin passee_A = mkTerm "passee_A" ;
lin passenger_N = mkTerm "passenger_N" ;
lin passepartout_N = mkTerm "passepartout_N" ;
lin passer_N = mkTerm "passer_N" ;
lin passerine_A = mkTerm "passerine_A" ;
lin passerine_N = mkTerm "passerine_N" ;
lin passim_Adv = mkTerm "passim_Adv" ;
lin passing_Adv = mkTerm "passing_Adv" ;
lin passing_N = mkTerm "passing_N" ;
lin passing_out_A = mkTerm "passing_out_A" ;
lin passion_N = mkTerm "passion_N" ;
lin passion_flower_N = mkTerm "passion_flower_N" ;
lin passionate_A = mkTerm "passionate_A" ;
lin passionless_A = mkTerm "passionless_A" ;
lin passive_A = mkTerm "passive_A" ;
lin passive_N = mkTerm "passive_N" ;
lin passiveness_N = mkTerm "passiveness_N" ;
lin passivity_N = mkTerm "passivity_N" ;
lin passkey_N = mkTerm "passkey_N" ;
lin passover_N = mkTerm "passover_N" ;
lin passport_N = mkTerm "passport_N" ;
lin password_N = mkTerm "password_N" ;
lin past_A = mkTerm "past_A" ;
lin past_Adv = mkTerm "past_Adv" ;
lin past_N = mkTerm "past_N" ;
lin past_Prep = mkTerm "past_Prep" ;
lin pasta_N = mkTerm "pasta_N" ;
lin paste_N = mkTerm "paste_N" ;
lin paste_V2 = mkTerm "paste_V2" ;
lin paste_up_N = mkTerm "paste_up_N" ;
lin pasteboard_N = mkTerm "pasteboard_N" ;
lin pastel_A = mkTerm "pastel_A" ;
lin pastel_N = mkTerm "pastel_N" ;
lin paster_N = mkTerm "paster_N" ;
lin pastern_N = mkTerm "pastern_N" ;
lin pasteurization_N = mkTerm "pasteurization_N" ;
lin pasteurize_V2 = mkTerm "pasteurize_V2" ;
lin pastiche_N = mkTerm "pastiche_N" ;
lin pastille_N = mkTerm "pastille_N" ;
lin pastime_N = mkTerm "pastime_N" ;
lin pasting_N = mkTerm "pasting_N" ;
lin pastis_N = mkTerm "pastis_N" ;
lin pastness_N = mkTerm "pastness_N" ;
lin pastor_N = mkTerm "pastor_N" ;
lin pastoral_A = mkTerm "pastoral_A" ;
lin pastoral_N = mkTerm "pastoral_N" ;
lin pastorale_N = mkTerm "pastorale_N" ;
lin pastorate_N = mkTerm "pastorate_N" ;
lin pastorship_N = mkTerm "pastorship_N" ;
lin pastrami_N = mkTerm "pastrami_N" ;
lin pastry_N = mkTerm "pastry_N" ;
lin pastry_cook_N = mkTerm "pastry_cook_N" ;
lin pasturage_N = mkTerm "pasturage_N" ;
lin pasture_N = mkTerm "pasture_N" ;
lin pasture_V = mkTerm "pasture_V" ;
lin pasture_V2 = mkTerm "pasture_V2" ;
lin pasty_A = mkTerm "pasty_A" ;
lin pasty_N = mkTerm "pasty_N" ;
lin pat_A = mkTerm "pat_A" ;
lin pat_Adv = mkTerm "pat_Adv" ;
lin pat_N = mkTerm "pat_N" ;
lin pat_PN = mkTerm "pat_PN" ;
lin pat_V = mkTerm "pat_V" ;
lin pat_V2 = mkTerm "pat_V2" ;
lin pat_down_V2 = mkTerm "pat_down_V2" ;
lin pataca_N = mkTerm "pataca_N" ;
lin patas_N = mkTerm "patas_N" ;
lin patch_N = mkTerm "patch_N" ;
lin patch_V2 = mkTerm "patch_V2" ;
lin patch_pocket_N = mkTerm "patch_pocket_N" ;
lin patch_together_V2 = mkTerm "patch_together_V2" ;
lin patch_up_V2 = mkTerm "patch_up_V2" ;
lin patchcord_N = mkTerm "patchcord_N" ;
lin patchiness_N = mkTerm "patchiness_N" ;
lin patching_N = mkTerm "patching_N" ;
lin patchouli_N = mkTerm "patchouli_N" ;
lin patchwork_N = mkTerm "patchwork_N" ;
lin patchy_A = mkTerm "patchy_A" ;
lin pate_1_N = mkTerm "pate_1_N" ;
lin pate_2_N = mkTerm "pate_2_N" ;
lin pate_de_foie_gras_N = mkTerm "pate_de_foie_gras_N" ;
lin patella_N = mkTerm "patella_N" ;
lin patellar_A = mkTerm "patellar_A" ;
lin patency_N = mkTerm "patency_N" ;
lin patent_A = mkTerm "patent_A" ;
lin patent_N = mkTerm "patent_N" ;
lin patent_V2 = mkTerm "patent_V2" ;
lin patentee_N = mkTerm "patentee_N" ;
lin pater_N = mkTerm "pater_N" ;
lin paterfamilias_N = mkTerm "paterfamilias_N" ;
lin paternal_A = mkTerm "paternal_A" ;
lin paternalism_N = mkTerm "paternalism_N" ;
lin paternalistic_A = mkTerm "paternalistic_A" ;
lin paternity_N = mkTerm "paternity_N" ;
lin paternoster_N = mkTerm "paternoster_N" ;
lin path_N = mkTerm "path_N" ;
lin path_finder_N = mkTerm "path_finder_N" ;
lin pathetic_A = mkTerm "pathetic_A" ;
lin pathless_A = mkTerm "pathless_A" ;
lin pathogen_N = mkTerm "pathogen_N" ;
lin pathogenesis_N = mkTerm "pathogenesis_N" ;
lin pathogenically_Adv = mkTerm "pathogenically_Adv" ;
lin pathological_A = mkTerm "pathological_A" ;
lin pathologist_N = mkTerm "pathologist_N" ;
lin pathology_N = mkTerm "pathology_N" ;
lin pathos_N = mkTerm "pathos_N" ;
lin pathway_N = mkTerm "pathway_N" ;
lin patience_N = mkTerm "patience_N" ;
lin patience_PN = mkTerm "patience_PN" ;
lin patient_A = mkTerm "patient_A" ;
lin patient_N = mkTerm "patient_N" ;
lin patina_N = mkTerm "patina_N" ;
lin patio_N = mkTerm "patio_N" ;
lin patisserie_N = mkTerm "patisserie_N" ;
lin patka_N = mkTerm "patka_N" ;
lin patois_N = mkTerm "patois_N" ;
lin patrai_PN = mkTerm "patrai_PN" ;
lin patrial_N = mkTerm "patrial_N" ;
lin patriarch_N = mkTerm "patriarch_N" ;
lin patriarchal_A = mkTerm "patriarchal_A" ;
lin patriarchate_N = mkTerm "patriarchate_N" ;
lin patriarchic_A = mkTerm "patriarchic_A" ;
lin patriarchy_N = mkTerm "patriarchy_N" ;
lin patricentric_A = mkTerm "patricentric_A" ;
lin patricia_PN = mkTerm "patricia_PN" ;
lin patrician_A = mkTerm "patrician_A" ;
lin patrician_N = mkTerm "patrician_N" ;
lin patricide_N = mkTerm "patricide_N" ;
lin patrick_PN = mkTerm "patrick_PN" ;
lin patrilineage_N = mkTerm "patrilineage_N" ;
lin patrilineal_A = mkTerm "patrilineal_A" ;
lin patrimonial_A = mkTerm "patrimonial_A" ;
lin patrimony_N = mkTerm "patrimony_N" ;
lin patriot_N = mkTerm "patriot_N" ;
lin patriotic_A = mkTerm "patriotic_A" ;
lin patriotism_N = mkTerm "patriotism_N" ;
lin patristic_A = mkTerm "patristic_A" ;
lin patristics_N = mkTerm "patristics_N" ;
lin patrol_N = mkTerm "patrol_N" ;
lin patrol_V = mkTerm "patrol_V" ;
lin patrol_V2 = mkTerm "patrol_V2" ;
lin patroller_N = mkTerm "patroller_N" ;
lin patrolman_N = mkTerm "patrolman_N" ;
lin patron_N = mkTerm "patron_N" ;
lin patronage_N = mkTerm "patronage_N" ;
lin patroness_N = mkTerm "patroness_N" ;
lin patronize_V2 = mkTerm "patronize_V2" ;
lin patronizing_A = mkTerm "patronizing_A" ;
lin patronymic_A = mkTerm "patronymic_A" ;
lin patronymic_N = mkTerm "patronymic_N" ;
lin patten_N = mkTerm "patten_N" ;
lin patter_N = mkTerm "patter_N" ;
lin patter_V = mkTerm "patter_V" ;
lin patter_V2 = mkTerm "patter_V2" ;
lin pattern_N = mkTerm "pattern_N" ;
lin pattern_V2 = mkTerm "pattern_V2" ;
lin patternmaker_N = mkTerm "patternmaker_N" ;
lin patty_N = mkTerm "patty_N" ;
lin patty_PN = mkTerm "patty_PN" ;
lin patty_pan_N = mkTerm "patty_pan_N" ;
lin patzer_N = mkTerm "patzer_N" ;
lin paucity_N = mkTerm "paucity_N" ;
lin paul_PN = mkTerm "paul_PN" ;
lin paula_PN = mkTerm "paula_PN" ;
lin pauline_PN = mkTerm "pauline_PN" ;
lin paunch_N = mkTerm "paunch_N" ;
lin paunchiness_N = mkTerm "paunchiness_N" ;
lin paunchy_A = mkTerm "paunchy_A" ;
lin pauper_N = mkTerm "pauper_N" ;
lin pauperism_N = mkTerm "pauperism_N" ;
lin pauperization_N = mkTerm "pauperization_N" ;
lin pauperize_V2 = mkTerm "pauperize_V2" ;
lin pause_N = mkTerm "pause_N" ;
lin pause_V = mkTerm "pause_V" ;
lin pause_V2V = mkTerm "pause_V2V" ;
lin pause_VS = mkTerm "pause_VS" ;
lin pavage_N = mkTerm "pavage_N" ;
lin pavane_N = mkTerm "pavane_N" ;
lin pave_N = mkTerm "pave_N" ;
lin pave_V2 = mkTerm "pave_V2" ;
lin paved_A = mkTerm "paved_A" ;
lin pavement_N = mkTerm "pavement_N" ;
lin pavilion_N = mkTerm "pavilion_N" ;
lin paving_N = mkTerm "paving_N" ;
lin paving_stone_N = mkTerm "paving_stone_N" ;
lin pavior_N = mkTerm "pavior_N" ;
lin pavis_N = mkTerm "pavis_N" ;
lin pavlova_N = mkTerm "pavlova_N" ;
lin pavonia_N = mkTerm "pavonia_N" ;
lin paw_N = mkTerm "paw_N" ;
lin paw_V = mkTerm "paw_V" ;
lin paw_V2 = mkTerm "paw_V2" ;
lin pawer_N = mkTerm "pawer_N" ;
lin pawky_A = mkTerm "pawky_A" ;
lin pawl_N = mkTerm "pawl_N" ;
lin pawn_N = mkTerm "pawn_N" ;
lin pawn_V2 = mkTerm "pawn_V2" ;
lin pawn_ticket_N = mkTerm "pawn_ticket_N" ;
lin pawnbroker_N = mkTerm "pawnbroker_N" ;
lin pawnshop_N = mkTerm "pawnshop_N" ;
lin pawpaw_N = mkTerm "pawpaw_N" ;
lin pax_N = mkTerm "pax_N" ;
lin pax_romana_N = mkTerm "pax_romana_N" ;
lin pay_N = mkTerm "pay_N" ;
lin pay_V = mkTerm "pay_V" ;
lin pay_V2 = mkTerm "pay_V2" ;
lin pay_V2V = mkTerm "pay_V2V" ;
lin pay_V3 = mkTerm "pay_V3" ;
lin pay_as_you_earn_N = mkTerm "pay_as_you_earn_N" ;
lin pay_back_V = mkTerm "pay_back_V" ;
lin pay_back_V2 = mkTerm "pay_back_V2" ;
lin pay_claim_N = mkTerm "pay_claim_N" ;
lin pay_down_V2 = mkTerm "pay_down_V2" ;
lin pay_for_V3 = mkTerm "pay_for_V3" ;
lin pay_into_V3 = mkTerm "pay_into_V3" ;
lin pay_off_V = mkTerm "pay_off_V" ;
lin pay_off_V2 = mkTerm "pay_off_V2" ;
lin pay_out_V = mkTerm "pay_out_V" ;
lin pay_packet_N = mkTerm "pay_packet_N" ;
lin pay_station_N = mkTerm "pay_station_N" ;
lin pay_up_V = mkTerm "pay_up_V" ;
lin payable_A = mkTerm "payable_A" ;
lin payable_N = mkTerm "payable_N" ;
lin payback_N = mkTerm "payback_N" ;
lin paycheck_N = mkTerm "paycheck_N" ;
lin payday_N = mkTerm "payday_N" ;
lin paydirt_N = mkTerm "paydirt_N" ;
lin paye_PN = mkTerm "paye_PN" ;
lin payee_N = mkTerm "payee_N" ;
lin payer_N = mkTerm "payer_N" ;
lin payload_N = mkTerm "payload_N" ;
lin paymaster_N = mkTerm "paymaster_N" ;
lin payment_N = mkTerm "payment_N" ;
lin paynim_N = mkTerm "paynim_N" ;
lin payoff_N = mkTerm "payoff_N" ;
lin payola_N = mkTerm "payola_N" ;
lin payphone_N = mkTerm "payphone_N" ;
lin payroll_N = mkTerm "payroll_N" ;
lin paysheet_N = mkTerm "paysheet_N" ;
lin payslip_N = mkTerm "payslip_N" ;
lin pc_PN = mkTerm "pc_PN" ;
lin pdf_N = mkTerm "pdf_N" ;
lin pdsa_N = mkTerm "pdsa_N" ;
lin pe_N = mkTerm "pe_N" ;
lin pea_N = mkTerm "pea_N" ;
lin pea_chick_N = mkTerm "pea_chick_N" ;
lin pea_flour_N = mkTerm "pea_flour_N" ;
lin pea_green_A = mkTerm "pea_green_A" ;
lin pea_green_N = mkTerm "pea_green_N" ;
lin pea_jacket_N = mkTerm "pea_jacket_N" ;
lin pea_soup_N = mkTerm "pea_soup_N" ;
lin peace_N = mkTerm "peace_N" ;
lin peace_offering_N = mkTerm "peace_offering_N" ;
lin peaceable_A = mkTerm "peaceable_A" ;
lin peaceableness_N = mkTerm "peaceableness_N" ;
lin peaceful_A = mkTerm "peaceful_A" ;
lin peacefulness_N = mkTerm "peacefulness_N" ;
lin peacehaven_PN = mkTerm "peacehaven_PN" ;
lin peacekeeper_N = mkTerm "peacekeeper_N" ;
lin peacekeeping_A = mkTerm "peacekeeping_A" ;
lin peacekeeping_N = mkTerm "peacekeeping_N" ;
lin peacemaker_N = mkTerm "peacemaker_N" ;
lin peacetime_N = mkTerm "peacetime_N" ;
lin peach_N = mkTerm "peach_N" ;
lin peach_V = mkTerm "peach_V" ;
lin peach_V2 = mkTerm "peach_V2" ;
lin peachick_N = mkTerm "peachick_N" ;
lin peachy_A = mkTerm "peachy_A" ;
lin peacock_N = mkTerm "peacock_N" ;
lin peacock_blue_A = mkTerm "peacock_blue_A" ;
lin peacock_blue_N = mkTerm "peacock_blue_N" ;
lin peafowl_N = mkTerm "peafowl_N" ;
lin peahen_N = mkTerm "peahen_N" ;
lin peak_N = mkTerm "peak_N" ;
lin peak_V = mkTerm "peak_V" ;
lin peak_V2 = mkTerm "peak_V2" ;
lin peaky_A = mkTerm "peaky_A" ;
lin peal_N = mkTerm "peal_N" ;
lin peal_V = mkTerm "peal_V" ;
lin peal_V2 = mkTerm "peal_V2" ;
lin peanut_N = mkTerm "peanut_N" ;
lin peanuts_N = mkTerm "peanuts_N" ;
lin pear_N = mkTerm "pear_N" ;
lin pearl_N = mkTerm "pearl_N" ;
lin pearl_PN = mkTerm "pearl_PN" ;
lin pearl_V = mkTerm "pearl_V" ;
lin pearl_barley_N = mkTerm "pearl_barley_N" ;
lin pearl_diver_N = mkTerm "pearl_diver_N" ;
lin pearl_fishery_N = mkTerm "pearl_fishery_N" ;
lin pearl_oyster_N = mkTerm "pearl_oyster_N" ;
lin pearl_sago_N = mkTerm "pearl_sago_N" ;
lin pearlfish_N = mkTerm "pearlfish_N" ;
lin pearlite_N = mkTerm "pearlite_N" ;
lin pearlwort_N = mkTerm "pearlwort_N" ;
lin pearly_A = mkTerm "pearly_A" ;
lin pearmain_N = mkTerm "pearmain_N" ;
lin peasantFem_N = mkTerm "peasantFem_N" ;
lin peasantMasc_N = mkTerm "peasantMasc_N" ;
lin peasanthood_N = mkTerm "peasanthood_N" ;
lin peasantry_N = mkTerm "peasantry_N" ;
lin pease_N = mkTerm "pease_N" ;
lin pease_pudding_N = mkTerm "pease_pudding_N" ;
lin peashooter_N = mkTerm "peashooter_N" ;
lin peasouper_N = mkTerm "peasouper_N" ;
lin peat_N = mkTerm "peat_N" ;
lin peaty_A = mkTerm "peaty_A" ;
lin peavey_N = mkTerm "peavey_N" ;
lin peba_N = mkTerm "peba_N" ;
lin pebble_N = mkTerm "pebble_N" ;
lin pebbly_A = mkTerm "pebbly_A" ;
lin pebibit_N = mkTerm "pebibit_N" ;
lin pecan_N = mkTerm "pecan_N" ;
lin peccable_A = mkTerm "peccable_A" ;
lin peccadillo_N = mkTerm "peccadillo_N" ;
lin peccary_N = mkTerm "peccary_N" ;
lin peck_N = mkTerm "peck_N" ;
lin peck_V = mkTerm "peck_V" ;
lin peck_V2 = mkTerm "peck_V2" ;
lin peck_at_V2 = mkTerm "peck_at_V2" ;
lin pecker_N = mkTerm "pecker_N" ;
lin peckish_A = mkTerm "peckish_A" ;
lin pecopteris_N = mkTerm "pecopteris_N" ;
lin pectic_A = mkTerm "pectic_A" ;
lin pectin_N = mkTerm "pectin_N" ;
lin pectinate_A = mkTerm "pectinate_A" ;
lin pectineal_A = mkTerm "pectineal_A" ;
lin pectoral_A = mkTerm "pectoral_A" ;
lin pectoral_N = mkTerm "pectoral_N" ;
lin peculate_V = mkTerm "peculate_V" ;
lin peculate_V2 = mkTerm "peculate_V2" ;
lin peculation_N = mkTerm "peculation_N" ;
lin peculiar_A = mkTerm "peculiar_A" ;
lin peculiarity_N = mkTerm "peculiarity_N" ;
lin pecuniary_A = mkTerm "pecuniary_A" ;
lin pedagogic_A = mkTerm "pedagogic_A" ;
lin pedagogical_A = mkTerm "pedagogical_A" ;
lin pedagogueFem_N = mkTerm "pedagogueFem_N" ;
lin pedagogueMasc_N = mkTerm "pedagogueMasc_N" ;
lin pedagogy_N = mkTerm "pedagogy_N" ;
lin pedal_A = mkTerm "pedal_A" ;
lin pedal_N = mkTerm "pedal_N" ;
lin pedal_V = mkTerm "pedal_V" ;
lin pedal_V2 = mkTerm "pedal_V2" ;
lin pedaler_N = mkTerm "pedaler_N" ;
lin pedant_N = mkTerm "pedant_N" ;
lin pedantic_A = mkTerm "pedantic_A" ;
lin pedantry_N = mkTerm "pedantry_N" ;
lin pedate_A = mkTerm "pedate_A" ;
lin peddle_V = mkTerm "peddle_V" ;
lin peddle_V2 = mkTerm "peddle_V2" ;
lin peddler_N = mkTerm "peddler_N" ;
lin pederast_N = mkTerm "pederast_N" ;
lin pederastic_A = mkTerm "pederastic_A" ;
lin pederasty_N = mkTerm "pederasty_N" ;
lin pedersöre_PN = mkTerm "pedersöre_PN" ;
lin pedestal_N = mkTerm "pedestal_N" ;
lin pedestrian_A = mkTerm "pedestrian_A" ;
lin pedestrian_N = mkTerm "pedestrian_N" ;
lin pediatric_A = mkTerm "pediatric_A" ;
lin pediatrician_N = mkTerm "pediatrician_N" ;
lin pediatrics_N = mkTerm "pediatrics_N" ;
lin pedicab_N = mkTerm "pedicab_N" ;
lin pedicel_N = mkTerm "pedicel_N" ;
lin pediculicide_N = mkTerm "pediculicide_N" ;
lin pediculosis_N = mkTerm "pediculosis_N" ;
lin pedicure_N = mkTerm "pedicure_N" ;
lin pedigree_N = mkTerm "pedigree_N" ;
lin pediment_N = mkTerm "pediment_N" ;
lin pedlar_N = mkTerm "pedlar_N" ;
lin pedodontist_N = mkTerm "pedodontist_N" ;
lin pedometer_N = mkTerm "pedometer_N" ;
lin pedophile_N = mkTerm "pedophile_N" ;
lin pedophilia_N = mkTerm "pedophilia_N" ;
lin peduncle_N = mkTerm "peduncle_N" ;
lin pedunculate_A = mkTerm "pedunculate_A" ;
lin pee_N = mkTerm "pee_N" ;
lin pee_V = mkTerm "pee_V" ;
lin peebles_PN = mkTerm "peebles_PN" ;
lin peeing_N = mkTerm "peeing_N" ;
lin peek_N = mkTerm "peek_N" ;
lin peek_V = mkTerm "peek_V" ;
lin peek_a_boo_N = mkTerm "peek_a_boo_N" ;
lin peekaboo_N = mkTerm "peekaboo_N" ;
lin peel_N = mkTerm "peel_N" ;
lin peel_V = mkTerm "peel_V" ;
lin peel_V2 = mkTerm "peel_V2" ;
lin peel_away_V = mkTerm "peel_away_V" ;
lin peel_away_from_V2 = mkTerm "peel_away_from_V2" ;
lin peel_off_V = mkTerm "peel_off_V" ;
lin peel_off_from_V2 = mkTerm "peel_off_from_V2" ;
lin peel_out_V = mkTerm "peel_out_V" ;
lin peeler_N = mkTerm "peeler_N" ;
lin peen_N = mkTerm "peen_N" ;
lin peep_N = mkTerm "peep_N" ;
lin peep_V = mkTerm "peep_V" ;
lin peeper_N = mkTerm "peeper_N" ;
lin peephole_N = mkTerm "peephole_N" ;
lin peepshow_N = mkTerm "peepshow_N" ;
lin peepul_N = mkTerm "peepul_N" ;
lin peer_N = mkTerm "peer_N" ;
lin peer_V = mkTerm "peer_V" ;
lin peerage_N = mkTerm "peerage_N" ;
lin peeress_N = mkTerm "peeress_N" ;
lin peerless_A = mkTerm "peerless_A" ;
lin peeve_N = mkTerm "peeve_N" ;
lin peeve_V2 = mkTerm "peeve_V2" ;
lin peevish_A = mkTerm "peevish_A" ;
lin peevishness_N = mkTerm "peevishness_N" ;
lin peewit_N = mkTerm "peewit_N" ;
lin peg_N = mkTerm "peg_N" ;
lin peg_PN = mkTerm "peg_PN" ;
lin peg_V = mkTerm "peg_V" ;
lin peg_V2 = mkTerm "peg_V2" ;
lin peg_away_V = mkTerm "peg_away_V" ;
lin peg_down_V2 = mkTerm "peg_down_V2" ;
lin peg_it_V = mkTerm "peg_it_V" ;
lin peg_out_V = mkTerm "peg_out_V" ;
lin peg_out_V2 = mkTerm "peg_out_V2" ;
lin pegboard_N = mkTerm "pegboard_N" ;
lin peggy_PN = mkTerm "peggy_PN" ;
lin pegmatite_N = mkTerm "pegmatite_N" ;
lin peignoir_N = mkTerm "peignoir_N" ;
lin pejorative_A = mkTerm "pejorative_A" ;
lin peke_N = mkTerm "peke_N" ;
lin pekinese_N = mkTerm "pekinese_N" ;
lin peking_PN = mkTerm "peking_PN" ;
lin pekoe_N = mkTerm "pekoe_N" ;
lin pelf_N = mkTerm "pelf_N" ;
lin pelican_N = mkTerm "pelican_N" ;
lin pelisse_N = mkTerm "pelisse_N" ;
lin pelkosenniemi_PN = mkTerm "pelkosenniemi_PN" ;
lin pell_mell_Adv = mkTerm "pell_mell_Adv" ;
lin pellagra_N = mkTerm "pellagra_N" ;
lin pellet_N = mkTerm "pellet_N" ;
lin pellicle_N = mkTerm "pellicle_N" ;
lin pellitory_N = mkTerm "pellitory_N" ;
lin pello_PN = mkTerm "pello_PN" ;
lin pellucid_A = mkTerm "pellucid_A" ;
lin pellucidness_N = mkTerm "pellucidness_N" ;
lin pelmet_N = mkTerm "pelmet_N" ;
lin pelota_N = mkTerm "pelota_N" ;
lin pelt_N = mkTerm "pelt_N" ;
lin pelt_V = mkTerm "pelt_V" ;
lin pelt_V2 = mkTerm "pelt_V2" ;
lin peltate_A = mkTerm "peltate_A" ;
lin pelter_N = mkTerm "pelter_N" ;
lin pelton_PN = mkTerm "pelton_PN" ;
lin peludo_N = mkTerm "peludo_N" ;
lin pelvic_A = mkTerm "pelvic_A" ;
lin pelvimeter_N = mkTerm "pelvimeter_N" ;
lin pelvimetry_N = mkTerm "pelvimetry_N" ;
lin pelvis_N = mkTerm "pelvis_N" ;
lin pelycosaur_N = mkTerm "pelycosaur_N" ;
lin pembroke_PN = mkTerm "pembroke_PN" ;
lin pemmican_N = mkTerm "pemmican_N" ;
lin pemphigous_A = mkTerm "pemphigous_A" ;
lin pemphigus_N = mkTerm "pemphigus_N" ;
lin pen_1_N = mkTerm "pen_1_N" ;
lin pen_2_N = mkTerm "pen_2_N" ;
lin pen_V2 = mkTerm "pen_V2" ;
lin pen_and_ink_N = mkTerm "pen_and_ink_N" ;
lin pen_friend_N = mkTerm "pen_friend_N" ;
lin pen_name_N = mkTerm "pen_name_N" ;
lin pen_pusher_N = mkTerm "pen_pusher_N" ;
lin penal_A = mkTerm "penal_A" ;
lin penalization_N = mkTerm "penalization_N" ;
lin penalize_V2 = mkTerm "penalize_V2" ;
lin penalty_N = mkTerm "penalty_N" ;
lin penance_N = mkTerm "penance_N" ;
lin penarth_PN = mkTerm "penarth_PN" ;
lin penchant_N = mkTerm "penchant_N" ;
lin pencil_N = mkTerm "pencil_N" ;
lin pencil_V2 = mkTerm "pencil_V2" ;
lin pencil_in_V2 = mkTerm "pencil_in_V2" ;
lin pend_V = mkTerm "pend_V" ;
lin pend_V2 = mkTerm "pend_V2" ;
lin pendant_N = mkTerm "pendant_N" ;
lin pendent_A = mkTerm "pendent_A" ;
lin pending_Prep = mkTerm "pending_Prep" ;
lin pendlebury_PN = mkTerm "pendlebury_PN" ;
lin pendragon_N = mkTerm "pendragon_N" ;
lin pendulous_A = mkTerm "pendulous_A" ;
lin pendulum_N = mkTerm "pendulum_N" ;
lin penelope_PN = mkTerm "penelope_PN" ;
lin peneplain_N = mkTerm "peneplain_N" ;
lin penetrability_N = mkTerm "penetrability_N" ;
lin penetrable_A = mkTerm "penetrable_A" ;
lin penetralia_N = mkTerm "penetralia_N" ;
lin penetrate_V = mkTerm "penetrate_V" ;
lin penetrate_V2 = mkTerm "penetrate_V2" ;
lin penetratingly_Adv = mkTerm "penetratingly_Adv" ;
lin penetration_N = mkTerm "penetration_N" ;
lin penetrative_A = mkTerm "penetrative_A" ;
lin penetrator_N = mkTerm "penetrator_N" ;
lin pengo_N = mkTerm "pengo_N" ;
lin penguin_N = mkTerm "penguin_N" ;
lin penicillamine_N = mkTerm "penicillamine_N" ;
lin penicillin_N = mkTerm "penicillin_N" ;
lin penicillinase_N = mkTerm "penicillinase_N" ;
lin penicuik_PN = mkTerm "penicuik_PN" ;
lin penile_A = mkTerm "penile_A" ;
lin peninsula_N = mkTerm "peninsula_N" ;
lin peninsular_A = mkTerm "peninsular_A" ;
lin penis_N = mkTerm "penis_N" ;
lin penitence_N = mkTerm "penitence_N" ;
lin penitent_A = mkTerm "penitent_A" ;
lin penitent_N = mkTerm "penitent_N" ;
lin penitential_A = mkTerm "penitential_A" ;
lin penitentiary_A = mkTerm "penitentiary_A" ;
lin penitentiary_N = mkTerm "penitentiary_N" ;
lin penki_PN = mkTerm "penki_PN" ;
lin penknife_N = mkTerm "penknife_N" ;
lin penlight_N = mkTerm "penlight_N" ;
lin penmanship_N = mkTerm "penmanship_N" ;
lin penn'orth_N = mkTerm "penn'orth_N" ;
lin pennant_N = mkTerm "pennant_N" ;
lin pennate_A = mkTerm "pennate_A" ;
lin penne_N = mkTerm "penne_N" ;
lin penni_N = mkTerm "penni_N" ;
lin penniless_A = mkTerm "penniless_A" ;
lin pennon_N = mkTerm "pennon_N" ;
lin pennoncel_N = mkTerm "pennoncel_N" ;
lin pennsylvania_PN = mkTerm "pennsylvania_PN" ;
lin penny_N = mkTerm "penny_N" ;
lin penny_PN = mkTerm "penny_PN" ;
lin pennycress_N = mkTerm "pennycress_N" ;
lin pennyroyal_N = mkTerm "pennyroyal_N" ;
lin pennyweight_N = mkTerm "pennyweight_N" ;
lin pennywhistle_N = mkTerm "pennywhistle_N" ;
lin pennyworth_N = mkTerm "pennyworth_N" ;
lin penologist_N = mkTerm "penologist_N" ;
lin penology_N = mkTerm "penology_N" ;
lin penrhyn_PN = mkTerm "penrhyn_PN" ;
lin penrith_PN = mkTerm "penrith_PN" ;
lin penryn_PN = mkTerm "penryn_PN" ;
lin pension_N = mkTerm "pension_N" ;
lin pension_V2 = mkTerm "pension_V2" ;
lin pensionable_A = mkTerm "pensionable_A" ;
lin pensioner_N = mkTerm "pensioner_N" ;
lin pensive_A = mkTerm "pensive_A" ;
lin pensiveness_N = mkTerm "pensiveness_N" ;
lin penstock_N = mkTerm "penstock_N" ;
lin pent_A = mkTerm "pent_A" ;
lin pent_up_A = mkTerm "pent_up_A" ;
lin pentacle_N = mkTerm "pentacle_N" ;
lin pentaerythritol_N = mkTerm "pentaerythritol_N" ;
lin pentagon_N = mkTerm "pentagon_N" ;
lin pentagonal_A = mkTerm "pentagonal_A" ;
lin pentahedron_N = mkTerm "pentahedron_N" ;
lin pentail_N = mkTerm "pentail_N" ;
lin pentamerous_A = mkTerm "pentamerous_A" ;
lin pentameter_N = mkTerm "pentameter_N" ;
lin pentasyllabic_A = mkTerm "pentasyllabic_A" ;
lin pentateuch_N = mkTerm "pentateuch_N" ;
lin pentathlete_N = mkTerm "pentathlete_N" ;
lin pentathlon_N = mkTerm "pentathlon_N" ;
lin pentatonic_A = mkTerm "pentatonic_A" ;
lin pentavalent_A = mkTerm "pentavalent_A" ;
lin pentazocine_N = mkTerm "pentazocine_N" ;
lin pentecost_N = mkTerm "pentecost_N" ;
lin pentecostal_A = mkTerm "pentecostal_A" ;
lin pentecostalism_N = mkTerm "pentecostalism_N" ;
lin penthouse_N = mkTerm "penthouse_N" ;
lin pentimento_N = mkTerm "pentimento_N" ;
lin pentlandite_N = mkTerm "pentlandite_N" ;
lin pentode_N = mkTerm "pentode_N" ;
lin pentose_N = mkTerm "pentose_N" ;
lin pentoxide_N = mkTerm "pentoxide_N" ;
lin pentoxifylline_N = mkTerm "pentoxifylline_N" ;
lin pentylenetetrazol_N = mkTerm "pentylenetetrazol_N" ;
lin penuche_N = mkTerm "penuche_N" ;
lin penult_N = mkTerm "penult_N" ;
lin penultimate_A = mkTerm "penultimate_A" ;
lin penultimate_N = mkTerm "penultimate_N" ;
lin penumbra_N = mkTerm "penumbra_N" ;
lin penumbral_A = mkTerm "penumbral_A" ;
lin penurious_A = mkTerm "penurious_A" ;
lin penuriousness_N = mkTerm "penuriousness_N" ;
lin penury_N = mkTerm "penury_N" ;
lin penzance_PN = mkTerm "penzance_PN" ;
lin peon_N = mkTerm "peon_N" ;
lin peonage_N = mkTerm "peonage_N" ;
lin peony_N = mkTerm "peony_N" ;
lin people_N = mkTerm "people_N" ;
lin people_V2 = mkTerm "people_V2" ;
lin peoples_N = mkTerm "peoples_N" ;
lin pep_N = mkTerm "pep_N" ;
lin pep_V2 = mkTerm "pep_V2" ;
lin pep_up_V2 = mkTerm "pep_up_V2" ;
lin peperomia_N = mkTerm "peperomia_N" ;
lin peplos_N = mkTerm "peplos_N" ;
lin peplum_N = mkTerm "peplum_N" ;
lin pepper_N = mkTerm "pepper_N" ;
lin pepper_V2 = mkTerm "pepper_V2" ;
lin pepper_and_salt_N = mkTerm "pepper_and_salt_N" ;
lin pepper_mill_N = mkTerm "pepper_mill_N" ;
lin pepper_pot_N = mkTerm "pepper_pot_N" ;
lin peppercorn_N = mkTerm "peppercorn_N" ;
lin peppermint_N = mkTerm "peppermint_N" ;
lin pepperoni_N = mkTerm "pepperoni_N" ;
lin peppery_A = mkTerm "peppery_A" ;
lin pepsin_N = mkTerm "pepsin_N" ;
lin pepsinogen_N = mkTerm "pepsinogen_N" ;
lin peptic_A = mkTerm "peptic_A" ;
lin peptide_N = mkTerm "peptide_N" ;
lin peptization_N = mkTerm "peptization_N" ;
lin peptone_N = mkTerm "peptone_N" ;
lin per_Prep = mkTerm "per_Prep" ;
lin peradventure_Adv = mkTerm "peradventure_Adv" ;
lin peradventure_N = mkTerm "peradventure_N" ;
lin perambulate_V = mkTerm "perambulate_V" ;
lin perambulate_V2 = mkTerm "perambulate_V2" ;
lin perambulation_N = mkTerm "perambulation_N" ;
lin perambulator_N = mkTerm "perambulator_N" ;
lin percale_N = mkTerm "percale_N" ;
lin perceivable_A = mkTerm "perceivable_A" ;
lin perceive_V2 = mkTerm "perceive_V2" ;
lin perceive_V2V = mkTerm "perceive_V2V" ;
lin perceive_VS = mkTerm "perceive_VS" ;
lin perceived_A = mkTerm "perceived_A" ;
lin perceiver_N = mkTerm "perceiver_N" ;
lin percent_N = mkTerm "percent_N" ;
lin percentage_N = mkTerm "percentage_N" ;
lin percentile_N = mkTerm "percentile_N" ;
lin percept_N = mkTerm "percept_N" ;
lin perceptibility_N = mkTerm "perceptibility_N" ;
lin perceptible_A = mkTerm "perceptible_A" ;
lin perception_N = mkTerm "perception_N" ;
lin perceptive_A = mkTerm "perceptive_A" ;
lin perceptiveness_N = mkTerm "perceptiveness_N" ;
lin perceptual_A = mkTerm "perceptual_A" ;
lin perch_N = mkTerm "perch_N" ;
lin perch_V = mkTerm "perch_V" ;
lin perch_V2 = mkTerm "perch_V2" ;
lin perchance_Adv = mkTerm "perchance_Adv" ;
lin percher_N = mkTerm "percher_N" ;
lin perchlorate_N = mkTerm "perchlorate_N" ;
lin perchloride_N = mkTerm "perchloride_N" ;
lin percipient_A = mkTerm "percipient_A" ;
lin percolate_N = mkTerm "percolate_N" ;
lin percolate_V = mkTerm "percolate_V" ;
lin percolate_V2 = mkTerm "percolate_V2" ;
lin percolation_N = mkTerm "percolation_N" ;
lin percolator_N = mkTerm "percolator_N" ;
lin percussion_N = mkTerm "percussion_N" ;
lin percussionist_N = mkTerm "percussionist_N" ;
lin percussive_A = mkTerm "percussive_A" ;
lin percy_PN = mkTerm "percy_PN" ;
lin perdition_N = mkTerm "perdition_N" ;
lin perdurability_N = mkTerm "perdurability_N" ;
lin peregrination_N = mkTerm "peregrination_N" ;
lin peregrine_N = mkTerm "peregrine_N" ;
lin peremptory_A = mkTerm "peremptory_A" ;
lin perennation_N = mkTerm "perennation_N" ;
lin perennial_A = mkTerm "perennial_A" ;
lin perennial_N = mkTerm "perennial_N" ;
lin perestroika_N = mkTerm "perestroika_N" ;
lin perfect_A = mkTerm "perfect_A" ;
lin perfect_V2 = mkTerm "perfect_V2" ;
lin perfecter_N = mkTerm "perfecter_N" ;
lin perfectibility_N = mkTerm "perfectibility_N" ;
lin perfectible_A = mkTerm "perfectible_A" ;
lin perfection_N = mkTerm "perfection_N" ;
lin perfectionism_N = mkTerm "perfectionism_N" ;
lin perfectionist_N = mkTerm "perfectionist_N" ;
lin perfective_N = mkTerm "perfective_N" ;
lin perfervid_A = mkTerm "perfervid_A" ;
lin perfidious_A = mkTerm "perfidious_A" ;
lin perfidiousness_N = mkTerm "perfidiousness_N" ;
lin perfidy_N = mkTerm "perfidy_N" ;
lin perfluorocarbon_N = mkTerm "perfluorocarbon_N" ;
lin perfoliate_A = mkTerm "perfoliate_A" ;
lin perforate_V2 = mkTerm "perforate_V2" ;
lin perforation_N = mkTerm "perforation_N" ;
lin perforce_Adv = mkTerm "perforce_Adv" ;
lin perform_V = mkTerm "perform_V" ;
lin perform_V2 = mkTerm "perform_V2" ;
lin performance_1_N = mkTerm "performance_1_N" ;
lin performance_2_N = mkTerm "performance_2_N" ;
lin performer_N = mkTerm "performer_N" ;
lin perfume_N = mkTerm "perfume_N" ;
lin perfume_V2 = mkTerm "perfume_V2" ;
lin perfumerFem_N = mkTerm "perfumerFem_N" ;
lin perfumerMasc_N = mkTerm "perfumerMasc_N" ;
lin perfumery_N = mkTerm "perfumery_N" ;
lin perfunctory_A = mkTerm "perfunctory_A" ;
lin perfusion_N = mkTerm "perfusion_N" ;
lin pergola_N = mkTerm "pergola_N" ;
lin perhaps_Adv = mkTerm "perhaps_Adv" ;
lin perho_PN = mkTerm "perho_PN" ;
lin peri_N = mkTerm "peri_N" ;
lin perianal_A = mkTerm "perianal_A" ;
lin perianth_N = mkTerm "perianth_N" ;
lin periapsis_N = mkTerm "periapsis_N" ;
lin periarteritis_N = mkTerm "periarteritis_N" ;
lin pericardial_A = mkTerm "pericardial_A" ;
lin pericarditis_N = mkTerm "pericarditis_N" ;
lin pericardium_N = mkTerm "pericardium_N" ;
lin pericarp_N = mkTerm "pericarp_N" ;
lin pericementoclasia_N = mkTerm "pericementoclasia_N" ;
lin periclase_N = mkTerm "periclase_N" ;
lin peridinian_N = mkTerm "peridinian_N" ;
lin peridium_N = mkTerm "peridium_N" ;
lin peridot_N = mkTerm "peridot_N" ;
lin peridotite_N = mkTerm "peridotite_N" ;
lin perigee_N = mkTerm "perigee_N" ;
lin perigon_N = mkTerm "perigon_N" ;
lin perigonal_A = mkTerm "perigonal_A" ;
lin perihelion_N = mkTerm "perihelion_N" ;
lin perijove_N = mkTerm "perijove_N" ;
lin peril_N = mkTerm "peril_N" ;
lin peril_V2 = mkTerm "peril_V2" ;
lin perilous_A = mkTerm "perilous_A" ;
lin perilymph_N = mkTerm "perilymph_N" ;
lin perimeter_N = mkTerm "perimeter_N" ;
lin perimysium_N = mkTerm "perimysium_N" ;
lin perinasal_A = mkTerm "perinasal_A" ;
lin perinatal_A = mkTerm "perinatal_A" ;
lin perinatologist_N = mkTerm "perinatologist_N" ;
lin perinatology_N = mkTerm "perinatology_N" ;
lin perineal_A = mkTerm "perineal_A" ;
lin perineotomy_N = mkTerm "perineotomy_N" ;
lin perineum_N = mkTerm "perineum_N" ;
lin perineurium_N = mkTerm "perineurium_N" ;
lin period_1_N = mkTerm "period_1_N" ;
lin period_2_N = mkTerm "period_2_N" ;
lin period_3_N = mkTerm "period_3_N" ;
lin periodic_A = mkTerm "periodic_A" ;
lin periodical_A = mkTerm "periodical_A" ;
lin periodical_N = mkTerm "periodical_N" ;
lin periodontic_A = mkTerm "periodontic_A" ;
lin periodontics_N = mkTerm "periodontics_N" ;
lin periodontist_N = mkTerm "periodontist_N" ;
lin periosteum_N = mkTerm "periosteum_N" ;
lin peripatetic_A = mkTerm "peripatetic_A" ;
lin peripatetic_N = mkTerm "peripatetic_N" ;
lin peripeteia_N = mkTerm "peripeteia_N" ;
lin peripheral_A = mkTerm "peripheral_A" ;
lin peripheral_N = mkTerm "peripheral_N" ;
lin periphery_N = mkTerm "periphery_N" ;
lin periphrasis_N = mkTerm "periphrasis_N" ;
lin periphrastic_A = mkTerm "periphrastic_A" ;
lin peripteral_A = mkTerm "peripteral_A" ;
lin periscope_N = mkTerm "periscope_N" ;
lin periselene_N = mkTerm "periselene_N" ;
lin perish_V = mkTerm "perish_V" ;
lin perish_V2 = mkTerm "perish_V2" ;
lin perishability_N = mkTerm "perishability_N" ;
lin perishable_A = mkTerm "perishable_A" ;
lin perishable_N = mkTerm "perishable_N" ;
lin perisher_N = mkTerm "perisher_N" ;
lin perisperm_N = mkTerm "perisperm_N" ;
lin peristalsis_N = mkTerm "peristalsis_N" ;
lin peristome_N = mkTerm "peristome_N" ;
lin peristylar_A = mkTerm "peristylar_A" ;
lin peristyle_N = mkTerm "peristyle_N" ;
lin perithecium_N = mkTerm "perithecium_N" ;
lin perithelial_A = mkTerm "perithelial_A" ;
lin perithelium_N = mkTerm "perithelium_N" ;
lin peritoneal_A = mkTerm "peritoneal_A" ;
lin peritoneum_N = mkTerm "peritoneum_N" ;
lin peritonitis_N = mkTerm "peritonitis_N" ;
lin peritrichous_A = mkTerm "peritrichous_A" ;
lin periwig_N = mkTerm "periwig_N" ;
lin periwinkle_N = mkTerm "periwinkle_N" ;
lin perjure_V2 = mkTerm "perjure_V2" ;
lin perjurer_N = mkTerm "perjurer_N" ;
lin perjury_N = mkTerm "perjury_N" ;
lin perk_N = mkTerm "perk_N" ;
lin perk_V = mkTerm "perk_V" ;
lin perk_V2 = mkTerm "perk_V2" ;
lin perk_up_V2 = mkTerm "perk_up_V2" ;
lin perkiness_N = mkTerm "perkiness_N" ;
lin perky_A = mkTerm "perky_A" ;
lin perm_N = mkTerm "perm_N" ;
lin perm_PN = mkTerm "perm_PN" ;
lin perm_V2 = mkTerm "perm_V2" ;
lin permafrost_N = mkTerm "permafrost_N" ;
lin permanence_N = mkTerm "permanence_N" ;
lin permanency_N = mkTerm "permanency_N" ;
lin permanent_A = mkTerm "permanent_A" ;
lin permanganate_N = mkTerm "permanganate_N" ;
lin permeability_N = mkTerm "permeability_N" ;
lin permeable_A = mkTerm "permeable_A" ;
lin permeant_A = mkTerm "permeant_A" ;
lin permeate_V = mkTerm "permeate_V" ;
lin permeate_V2 = mkTerm "permeate_V2" ;
lin permeation_N = mkTerm "permeation_N" ;
lin permissibility_N = mkTerm "permissibility_N" ;
lin permissible_A = mkTerm "permissible_A" ;
lin permission_N = mkTerm "permission_N" ;
lin permissive_A = mkTerm "permissive_A" ;
lin permissiveness_N = mkTerm "permissiveness_N" ;
lin permit_N = mkTerm "permit_N" ;
lin permit_V = mkTerm "permit_V" ;
lin permit_V2 = mkTerm "permit_V2" ;
lin permit_V2V = mkTerm "permit_V2V" ;
lin permutability_N = mkTerm "permutability_N" ;
lin permutation_N = mkTerm "permutation_N" ;
lin permute_V2 = mkTerm "permute_V2" ;
lin pernicious_A = mkTerm "pernicious_A" ;
lin perniciousness_N = mkTerm "perniciousness_N" ;
lin pernickety_A = mkTerm "pernickety_A" ;
lin perniö_PN = mkTerm "perniö_PN" ;
lin pernå_PN = mkTerm "pernå_PN" ;
lin peroneal_A = mkTerm "peroneal_A" ;
lin peroneus_N = mkTerm "peroneus_N" ;
lin peroration_N = mkTerm "peroration_N" ;
lin peroxidase_N = mkTerm "peroxidase_N" ;
lin peroxide_N = mkTerm "peroxide_N" ;
lin perpendicular_A = mkTerm "perpendicular_A" ;
lin perpendicular_N = mkTerm "perpendicular_N" ;
lin perpendicularity_N = mkTerm "perpendicularity_N" ;
lin perpetrate_V2 = mkTerm "perpetrate_V2" ;
lin perpetration_N = mkTerm "perpetration_N" ;
lin perpetrator_N = mkTerm "perpetrator_N" ;
lin perpetual_A = mkTerm "perpetual_A" ;
lin perpetuate_V2 = mkTerm "perpetuate_V2" ;
lin perpetuation_N = mkTerm "perpetuation_N" ;
lin perpetuity_N = mkTerm "perpetuity_N" ;
lin perphenazine_N = mkTerm "perphenazine_N" ;
lin perplex_V2 = mkTerm "perplex_V2" ;
lin perplexedly_Adv = mkTerm "perplexedly_Adv" ;
lin perplexity_N = mkTerm "perplexity_N" ;
lin perquisite_N = mkTerm "perquisite_N" ;
lin perry_N = mkTerm "perry_N" ;
lin persecute_V2 = mkTerm "persecute_V2" ;
lin persecution_N = mkTerm "persecution_N" ;
lin persecutor_N = mkTerm "persecutor_N" ;
lin perseverance_N = mkTerm "perseverance_N" ;
lin perseveration_N = mkTerm "perseveration_N" ;
lin persevere_V = mkTerm "persevere_V" ;
lin perseveringly_Adv = mkTerm "perseveringly_Adv" ;
lin pershore_PN = mkTerm "pershore_PN" ;
lin persia_PN = mkTerm "persia_PN" ;
lin persianFem_N = mkTerm "persianFem_N" ;
lin persianMasc_N = mkTerm "persianMasc_N" ;
lin persian_A = mkTerm "persian_A" ;
lin persiflage_N = mkTerm "persiflage_N" ;
lin persimmon_N = mkTerm "persimmon_N" ;
lin persist_V = mkTerm "persist_V" ;
lin persistence_N = mkTerm "persistence_N" ;
lin persistent_A = mkTerm "persistent_A" ;
lin person_N = mkTerm "person_N" ;
lin persona_N = mkTerm "persona_N" ;
lin persona_grata_N = mkTerm "persona_grata_N" ;
lin persona_non_grata_N = mkTerm "persona_non_grata_N" ;
lin personable_A = mkTerm "personable_A" ;
lin personableness_N = mkTerm "personableness_N" ;
lin personage_N = mkTerm "personage_N" ;
lin personal_A = mkTerm "personal_A" ;
lin personal_N = mkTerm "personal_N" ;
lin personality_N = mkTerm "personality_N" ;
lin personalize_V2 = mkTerm "personalize_V2" ;
lin personally_1_Adv = mkTerm "personally_1_Adv" ;
lin personally_2_Adv = mkTerm "personally_2_Adv" ;
lin personalty_N = mkTerm "personalty_N" ;
lin personate_V2 = mkTerm "personate_V2" ;
lin personation_N = mkTerm "personation_N" ;
lin personhood_N = mkTerm "personhood_N" ;
lin personification_N = mkTerm "personification_N" ;
lin personify_V2 = mkTerm "personify_V2" ;
lin personnel_N = mkTerm "personnel_N" ;
lin perspective_N = mkTerm "perspective_N" ;
lin perspex_N = mkTerm "perspex_N" ;
lin perspicacious_A = mkTerm "perspicacious_A" ;
lin perspicacity_N = mkTerm "perspicacity_N" ;
lin perspicuity_N = mkTerm "perspicuity_N" ;
lin perspicuous_A = mkTerm "perspicuous_A" ;
lin perspicuousness_N = mkTerm "perspicuousness_N" ;
lin perspiration_N = mkTerm "perspiration_N" ;
lin perspire_V = mkTerm "perspire_V" ;
lin perspirer_N = mkTerm "perspirer_N" ;
lin persuadable_A = mkTerm "persuadable_A" ;
lin persuade_V2 = mkTerm "persuade_V2" ;
lin persuade_V2V = mkTerm "persuade_V2V" ;
lin persuader_N = mkTerm "persuader_N" ;
lin persuasion_N = mkTerm "persuasion_N" ;
lin persuasive_A = mkTerm "persuasive_A" ;
lin persuasiveness_N = mkTerm "persuasiveness_N" ;
lin pert_A = mkTerm "pert_A" ;
lin pertain_V = mkTerm "pertain_V" ;
lin pertainym_N = mkTerm "pertainym_N" ;
lin perth_PN = mkTerm "perth_PN" ;
lin pertinacious_A = mkTerm "pertinacious_A" ;
lin pertinacity_N = mkTerm "pertinacity_N" ;
lin pertinence_N = mkTerm "pertinence_N" ;
lin pertinent_A = mkTerm "pertinent_A" ;
lin pertness_N = mkTerm "pertness_N" ;
lin pertteli_PN = mkTerm "pertteli_PN" ;
lin pertunmaa_PN = mkTerm "pertunmaa_PN" ;
lin perturb_V2 = mkTerm "perturb_V2" ;
lin perturbation_N = mkTerm "perturbation_N" ;
lin peru_PN = mkTerm "peru_PN" ;
lin perugia_PN = mkTerm "perugia_PN" ;
lin peruke_N = mkTerm "peruke_N" ;
lin peruked_A = mkTerm "peruked_A" ;
lin perusal_N = mkTerm "perusal_N" ;
lin peruse_V2 = mkTerm "peruse_V2" ;
lin peruvian_A = mkTerm "peruvian_A" ;
lin peruvian_N = mkTerm "peruvian_N" ;
lin pervade_V2 = mkTerm "pervade_V2" ;
lin pervaporation_N = mkTerm "pervaporation_N" ;
lin pervasion_N = mkTerm "pervasion_N" ;
lin pervasive_A = mkTerm "pervasive_A" ;
lin pervasiveness_N = mkTerm "pervasiveness_N" ;
lin perverse_A = mkTerm "perverse_A" ;
lin perverseness_N = mkTerm "perverseness_N" ;
lin perversion_N = mkTerm "perversion_N" ;
lin perversity_N = mkTerm "perversity_N" ;
lin pervert_N = mkTerm "pervert_N" ;
lin pervert_V2 = mkTerm "pervert_V2" ;
lin pervious_A = mkTerm "pervious_A" ;
lin pesantran_N = mkTerm "pesantran_N" ;
lin pescara_PN = mkTerm "pescara_PN" ;
lin peseta_N = mkTerm "peseta_N" ;
lin pesewa_N = mkTerm "pesewa_N" ;
lin peshmerga_N = mkTerm "peshmerga_N" ;
lin pesky_A = mkTerm "pesky_A" ;
lin peso_N = mkTerm "peso_N" ;
lin pessary_N = mkTerm "pessary_N" ;
lin pessimal_A = mkTerm "pessimal_A" ;
lin pessimism_N = mkTerm "pessimism_N" ;
lin pessimistFem_N = mkTerm "pessimistFem_N" ;
lin pessimistMasc_N = mkTerm "pessimistMasc_N" ;
lin pessimistic_A = mkTerm "pessimistic_A" ;
lin pest_N = mkTerm "pest_N" ;
lin pester_V2 = mkTerm "pester_V2" ;
lin pesthole_N = mkTerm "pesthole_N" ;
lin pesticide_N = mkTerm "pesticide_N" ;
lin pestiferous_A = mkTerm "pestiferous_A" ;
lin pestilence_N = mkTerm "pestilence_N" ;
lin pestilent_A = mkTerm "pestilent_A" ;
lin pestilential_A = mkTerm "pestilential_A" ;
lin pestle_N = mkTerm "pestle_N" ;
lin pestle_V2 = mkTerm "pestle_V2" ;
lin pesto_N = mkTerm "pesto_N" ;
lin pet_N = mkTerm "pet_N" ;
lin pet_V2 = mkTerm "pet_V2" ;
lin petabit_N = mkTerm "petabit_N" ;
lin petabyte_N = mkTerm "petabyte_N" ;
lin petal_N = mkTerm "petal_N" ;
lin petaled_A = mkTerm "petaled_A" ;
lin petalled_A = mkTerm "petalled_A" ;
lin petallike_A = mkTerm "petallike_A" ;
lin petaloid_A = mkTerm "petaloid_A" ;
lin petalous_A = mkTerm "petalous_A" ;
lin petard_N = mkTerm "petard_N" ;
lin petcock_N = mkTerm "petcock_N" ;
lin pete_PN = mkTerm "pete_PN" ;
lin petechia_N = mkTerm "petechia_N" ;
lin peter_PN = mkTerm "peter_PN" ;
lin peter_V = mkTerm "peter_V" ;
lin peter_out_V = mkTerm "peter_out_V" ;
lin peterborough_PN = mkTerm "peterborough_PN" ;
lin peterhead_PN = mkTerm "peterhead_PN" ;
lin peterlee_PN = mkTerm "peterlee_PN" ;
lin petersfield_PN = mkTerm "petersfield_PN" ;
lin petfood_N = mkTerm "petfood_N" ;
lin petiole_N = mkTerm "petiole_N" ;
lin petiolule_N = mkTerm "petiolule_N" ;
lin petit_bourgeois_N = mkTerm "petit_bourgeois_N" ;
lin petite_A = mkTerm "petite_A" ;
lin petite_N = mkTerm "petite_N" ;
lin petition_N = mkTerm "petition_N" ;
lin petition_V = mkTerm "petition_V" ;
lin petition_V2 = mkTerm "petition_V2" ;
lin petitionary_A = mkTerm "petitionary_A" ;
lin petitioner_N = mkTerm "petitioner_N" ;
lin petrel_N = mkTerm "petrel_N" ;
lin petrifaction_N = mkTerm "petrifaction_N" ;
lin petrify_V = mkTerm "petrify_V" ;
lin petrify_V2 = mkTerm "petrify_V2" ;
lin petrissage_N = mkTerm "petrissage_N" ;
lin petrochemical_N = mkTerm "petrochemical_N" ;
lin petroglyph_N = mkTerm "petroglyph_N" ;
lin petrol_N = mkTerm "petrol_N" ;
lin petrolatum_N = mkTerm "petrolatum_N" ;
lin petroleum_N = mkTerm "petroleum_N" ;
lin petrology_N = mkTerm "petrology_N" ;
lin petrous_A = mkTerm "petrous_A" ;
lin petter_N = mkTerm "petter_N" ;
lin petticoat_N = mkTerm "petticoat_N" ;
lin petticoated_A = mkTerm "petticoated_A" ;
lin pettifogging_A = mkTerm "pettifogging_A" ;
lin pettiness_N = mkTerm "pettiness_N" ;
lin pettish_A = mkTerm "pettish_A" ;
lin pettishness_N = mkTerm "pettishness_N" ;
lin petty_A = mkTerm "petty_A" ;
lin petulance_N = mkTerm "petulance_N" ;
lin petulant_A = mkTerm "petulant_A" ;
lin petunia_N = mkTerm "petunia_N" ;
lin petäjävesi_PN = mkTerm "petäjävesi_PN" ;
lin pew_N = mkTerm "pew_N" ;
lin pew_opener_N = mkTerm "pew_opener_N" ;
lin pewee_N = mkTerm "pewee_N" ;
lin pewit_N = mkTerm "pewit_N" ;
lin pewter_N = mkTerm "pewter_N" ;
lin peyote_N = mkTerm "peyote_N" ;
lin pfannkuchen_N = mkTerm "pfannkuchen_N" ;
lin pfennig_N = mkTerm "pfennig_N" ;
lin ph_N = mkTerm "ph_N" ;
lin phacoemulsification_N = mkTerm "phacoemulsification_N" ;
lin phaeton_N = mkTerm "phaeton_N" ;
lin phagocyte_N = mkTerm "phagocyte_N" ;
lin phagocytic_A = mkTerm "phagocytic_A" ;
lin phagocytosis_N = mkTerm "phagocytosis_N" ;
lin phaius_N = mkTerm "phaius_N" ;
lin phalangeal_A = mkTerm "phalangeal_A" ;
lin phalanger_N = mkTerm "phalanger_N" ;
lin phalangitis_N = mkTerm "phalangitis_N" ;
lin phalanx_N = mkTerm "phalanx_N" ;
lin phalarope_N = mkTerm "phalarope_N" ;
lin phallic_A = mkTerm "phallic_A" ;
lin phalloplasty_N = mkTerm "phalloplasty_N" ;
lin phallus_N = mkTerm "phallus_N" ;
lin phalsa_N = mkTerm "phalsa_N" ;
lin phaneromania_N = mkTerm "phaneromania_N" ;
lin phantasm_N = mkTerm "phantasm_N" ;
lin phantasmagoria_N = mkTerm "phantasmagoria_N" ;
lin phantasmagoric_A = mkTerm "phantasmagoric_A" ;
lin phantasmal_A = mkTerm "phantasmal_A" ;
lin phantasy_N = mkTerm "phantasy_N" ;
lin phantom_A = mkTerm "phantom_A" ;
lin phantom_N = mkTerm "phantom_N" ;
lin pharaoh_N = mkTerm "pharaoh_N" ;
lin pharisaic_A = mkTerm "pharisaic_A" ;
lin pharisaical_A = mkTerm "pharisaical_A" ;
lin pharisee_N = mkTerm "pharisee_N" ;
lin pharmaceutical_A = mkTerm "pharmaceutical_A" ;
lin pharmaceutical_N = mkTerm "pharmaceutical_N" ;
lin pharmacist_N = mkTerm "pharmacist_N" ;
lin pharmacogenetics_N = mkTerm "pharmacogenetics_N" ;
lin pharmacokinetics_N = mkTerm "pharmacokinetics_N" ;
lin pharmacological_A = mkTerm "pharmacological_A" ;
lin pharmacologist_N = mkTerm "pharmacologist_N" ;
lin pharmacology_N = mkTerm "pharmacology_N" ;
lin pharmacopoeia_N = mkTerm "pharmacopoeia_N" ;
lin pharmacy_1_N = mkTerm "pharmacy_1_N" ;
lin pharmacy_2_N = mkTerm "pharmacy_2_N" ;
lin pharos_N = mkTerm "pharos_N" ;
lin pharyngeal_A = mkTerm "pharyngeal_A" ;
lin pharyngitis_N = mkTerm "pharyngitis_N" ;
lin pharynx_N = mkTerm "pharynx_N" ;
lin phase_N = mkTerm "phase_N" ;
lin phase_V2 = mkTerm "phase_V2" ;
lin phase_in_V2 = mkTerm "phase_in_V2" ;
lin phase_out_V2 = mkTerm "phase_out_V2" ;
lin phasianid_N = mkTerm "phasianid_N" ;
lin phasmid_N = mkTerm "phasmid_N" ;
lin phd_N = mkTerm "phd_N" ;
lin pheasant_N = mkTerm "pheasant_N" ;
lin phellem_N = mkTerm "phellem_N" ;
lin phenacomys_N = mkTerm "phenacomys_N" ;
lin phenazopyridine_N = mkTerm "phenazopyridine_N" ;
lin phencyclidine_N = mkTerm "phencyclidine_N" ;
lin phenelzine_N = mkTerm "phenelzine_N" ;
lin pheniramine_N = mkTerm "pheniramine_N" ;
lin phenobarbitone_N = mkTerm "phenobarbitone_N" ;
lin phenol_N = mkTerm "phenol_N" ;
lin phenolphthalein_N = mkTerm "phenolphthalein_N" ;
lin phenomenal_A = mkTerm "phenomenal_A" ;
lin phenomenology_N = mkTerm "phenomenology_N" ;
lin phenomenon_N = mkTerm "phenomenon_N" ;
lin phenothiazine_N = mkTerm "phenothiazine_N" ;
lin phenotype_N = mkTerm "phenotype_N" ;
lin phenotypical_A = mkTerm "phenotypical_A" ;
lin phensuximide_N = mkTerm "phensuximide_N" ;
lin phentolamine_N = mkTerm "phentolamine_N" ;
lin phenylalanine_N = mkTerm "phenylalanine_N" ;
lin phenylbutazone_N = mkTerm "phenylbutazone_N" ;
lin phenylephrine_N = mkTerm "phenylephrine_N" ;
lin phenylketonuria_N = mkTerm "phenylketonuria_N" ;
lin phenylpropanolamine_N = mkTerm "phenylpropanolamine_N" ;
lin phenyltoloxamine_N = mkTerm "phenyltoloxamine_N" ;
lin pheochromocytoma_N = mkTerm "pheochromocytoma_N" ;
lin pheromone_N = mkTerm "pheromone_N" ;
lin phi_N = mkTerm "phi_N" ;
lin phial_N = mkTerm "phial_N" ;
lin phil_PN = mkTerm "phil_PN" ;
lin philadelphia_PN = mkTerm "philadelphia_PN" ;
lin philadelphus_N = mkTerm "philadelphus_N" ;
lin philander_V = mkTerm "philander_V" ;
lin philanderer_N = mkTerm "philanderer_N" ;
lin philanthropic_A = mkTerm "philanthropic_A" ;
lin philanthropist_N = mkTerm "philanthropist_N" ;
lin philanthropy_N = mkTerm "philanthropy_N" ;
lin philatelic_A = mkTerm "philatelic_A" ;
lin philatelist_N = mkTerm "philatelist_N" ;
lin philately_N = mkTerm "philately_N" ;
lin philharmonic_A = mkTerm "philharmonic_A" ;
lin philhellene_A = mkTerm "philhellene_A" ;
lin philhellene_N = mkTerm "philhellene_N" ;
lin philhellenic_A = mkTerm "philhellenic_A" ;
lin philhellenism_N = mkTerm "philhellenism_N" ;
lin philip_PN = mkTerm "philip_PN" ;
lin philippa_PN = mkTerm "philippa_PN" ;
lin philippine_A = mkTerm "philippine_A" ;
lin philippine_N = mkTerm "philippine_N" ;
lin philippines_PN = mkTerm "philippines_PN" ;
lin philistine_N = mkTerm "philistine_N" ;
lin philistinism_N = mkTerm "philistinism_N" ;
lin phillipsite_N = mkTerm "phillipsite_N" ;
lin philodendron_N = mkTerm "philodendron_N" ;
lin philogyny_N = mkTerm "philogyny_N" ;
lin philological_A = mkTerm "philological_A" ;
lin philologist_N = mkTerm "philologist_N" ;
lin philology_N = mkTerm "philology_N" ;
lin philomath_N = mkTerm "philomath_N" ;
lin philosopher_N = mkTerm "philosopher_N" ;
lin philosophic_A = mkTerm "philosophic_A" ;
lin philosophical_A = mkTerm "philosophical_A" ;
lin philosophize_V = mkTerm "philosophize_V" ;
lin philosophizer_N = mkTerm "philosophizer_N" ;
lin philosophizing_N = mkTerm "philosophizing_N" ;
lin philosophy_N = mkTerm "philosophy_N" ;
lin philtre_N = mkTerm "philtre_N" ;
lin phimosis_N = mkTerm "phimosis_N" ;
lin phlebectomy_N = mkTerm "phlebectomy_N" ;
lin phlebitis_N = mkTerm "phlebitis_N" ;
lin phlebothrombosis_N = mkTerm "phlebothrombosis_N" ;
lin phlebotomist_N = mkTerm "phlebotomist_N" ;
lin phlegm_N = mkTerm "phlegm_N" ;
lin phlegmatic_A = mkTerm "phlegmatic_A" ;
lin phlegmy_A = mkTerm "phlegmy_A" ;
lin phloem_N = mkTerm "phloem_N" ;
lin phlogiston_N = mkTerm "phlogiston_N" ;
lin phlogopite_N = mkTerm "phlogopite_N" ;
lin phlomis_N = mkTerm "phlomis_N" ;
lin phlox_N = mkTerm "phlox_N" ;
lin phnom_penh_PN = mkTerm "phnom_penh_PN" ;
lin phobia_N = mkTerm "phobia_N" ;
lin phobic_A = mkTerm "phobic_A" ;
lin phobophobia_N = mkTerm "phobophobia_N" ;
lin phocine_A = mkTerm "phocine_A" ;
lin phocomelia_N = mkTerm "phocomelia_N" ;
lin phoebe_N = mkTerm "phoebe_N" ;
lin phoebe_PN = mkTerm "phoebe_PN" ;
lin phoenicophorium_N = mkTerm "phoenicophorium_N" ;
lin phoenix_N = mkTerm "phoenix_N" ;
lin phoenix_PN = mkTerm "phoenix_PN" ;
lin phon_N = mkTerm "phon_N" ;
lin phone_N = mkTerm "phone_N" ;
lin phone_V = mkTerm "phone_V" ;
lin phone_V2 = mkTerm "phone_V2" ;
lin phone_in_N = mkTerm "phone_in_N" ;
lin phonebook_N = mkTerm "phonebook_N" ;
lin phonebooth_N = mkTerm "phonebooth_N" ;
lin phonecall_N = mkTerm "phonecall_N" ;
lin phoneme_N = mkTerm "phoneme_N" ;
lin phonemic_A = mkTerm "phonemic_A" ;
lin phonemic_Adv = mkTerm "phonemic_Adv" ;
lin phonemics_N = mkTerm "phonemics_N" ;
lin phonetic_A = mkTerm "phonetic_A" ;
lin phonetic_N = mkTerm "phonetic_N" ;
lin phonetician_N = mkTerm "phonetician_N" ;
lin phonetics_N = mkTerm "phonetics_N" ;
lin phoney_A = mkTerm "phoney_A" ;
lin phoney_N = mkTerm "phoney_N" ;
lin phonic_A = mkTerm "phonic_A" ;
lin phonics_N = mkTerm "phonics_N" ;
lin phonogram_N = mkTerm "phonogram_N" ;
lin phonogramic_A = mkTerm "phonogramic_A" ;
lin phonograph_N = mkTerm "phonograph_N" ;
lin phonological_A = mkTerm "phonological_A" ;
lin phonologist_N = mkTerm "phonologist_N" ;
lin phonology_N = mkTerm "phonology_N" ;
lin phonophobia_N = mkTerm "phonophobia_N" ;
lin phony_A = mkTerm "phony_A" ;
lin phony_N = mkTerm "phony_N" ;
lin phoronid_N = mkTerm "phoronid_N" ;
lin phosgene_N = mkTerm "phosgene_N" ;
lin phosphatase_N = mkTerm "phosphatase_N" ;
lin phosphate_N = mkTerm "phosphate_N" ;
lin phosphine_N = mkTerm "phosphine_N" ;
lin phosphocreatine_N = mkTerm "phosphocreatine_N" ;
lin phospholipid_N = mkTerm "phospholipid_N" ;
lin phosphoprotein_N = mkTerm "phosphoprotein_N" ;
lin phosphor_N = mkTerm "phosphor_N" ;
lin phosphorescence_N = mkTerm "phosphorescence_N" ;
lin phosphorescent_A = mkTerm "phosphorescent_A" ;
lin phosphoric_A = mkTerm "phosphoric_A" ;
lin phosphorous_A = mkTerm "phosphorous_A" ;
lin phosphorus_N = mkTerm "phosphorus_N" ;
lin phot_N = mkTerm "phot_N" ;
lin photalgia_N = mkTerm "photalgia_N" ;
lin photic_A = mkTerm "photic_A" ;
lin photo_N = mkTerm "photo_N" ;
lin photocathode_N = mkTerm "photocathode_N" ;
lin photochemical_A = mkTerm "photochemical_A" ;
lin photochemistry_N = mkTerm "photochemistry_N" ;
lin photocoagulation_N = mkTerm "photocoagulation_N" ;
lin photocoagulator_N = mkTerm "photocoagulator_N" ;
lin photoconductive_A = mkTerm "photoconductive_A" ;
lin photoconductivity_N = mkTerm "photoconductivity_N" ;
lin photocopier_N = mkTerm "photocopier_N" ;
lin photocopy_N = mkTerm "photocopy_N" ;
lin photocopy_V2 = mkTerm "photocopy_V2" ;
lin photoelectric_A = mkTerm "photoelectric_A" ;
lin photoelectricity_N = mkTerm "photoelectricity_N" ;
lin photoelectron_N = mkTerm "photoelectron_N" ;
lin photoemission_N = mkTerm "photoemission_N" ;
lin photoemissive_A = mkTerm "photoemissive_A" ;
lin photoflash_N = mkTerm "photoflash_N" ;
lin photogenic_A = mkTerm "photogenic_A" ;
lin photograph_N = mkTerm "photograph_N" ;
lin photograph_V2 = mkTerm "photograph_V2" ;
lin photographer_N = mkTerm "photographer_N" ;
lin photographic_A = mkTerm "photographic_A" ;
lin photography_N = mkTerm "photography_N" ;
lin photogravure_N = mkTerm "photogravure_N" ;
lin photojournalism_N = mkTerm "photojournalism_N" ;
lin photojournalist_N = mkTerm "photojournalist_N" ;
lin photolithograph_N = mkTerm "photolithograph_N" ;
lin photolithography_N = mkTerm "photolithography_N" ;
lin photomechanical_A = mkTerm "photomechanical_A" ;
lin photomechanics_N = mkTerm "photomechanics_N" ;
lin photometer_N = mkTerm "photometer_N" ;
lin photometric_A = mkTerm "photometric_A" ;
lin photometrist_N = mkTerm "photometrist_N" ;
lin photometry_N = mkTerm "photometry_N" ;
lin photomicrograph_N = mkTerm "photomicrograph_N" ;
lin photomontage_N = mkTerm "photomontage_N" ;
lin photon_N = mkTerm "photon_N" ;
lin photophobia_N = mkTerm "photophobia_N" ;
lin photopigment_N = mkTerm "photopigment_N" ;
lin photoretinitis_N = mkTerm "photoretinitis_N" ;
lin photosensitivity_N = mkTerm "photosensitivity_N" ;
lin photosensitize_V2 = mkTerm "photosensitize_V2" ;
lin photosphere_N = mkTerm "photosphere_N" ;
lin photostat_N = mkTerm "photostat_N" ;
lin photostat_V2 = mkTerm "photostat_V2" ;
lin photosynthesis_N = mkTerm "photosynthesis_N" ;
lin photosynthetic_A = mkTerm "photosynthetic_A" ;
lin phototherapy_N = mkTerm "phototherapy_N" ;
lin phototropism_N = mkTerm "phototropism_N" ;
lin photovoltaic_A = mkTerm "photovoltaic_A" ;
lin phragmocone_N = mkTerm "phragmocone_N" ;
lin phrasal_A = mkTerm "phrasal_A" ;
lin phrase_N = mkTerm "phrase_N" ;
lin phrase_V2 = mkTerm "phrase_V2" ;
lin phrase_book_N = mkTerm "phrase_book_N" ;
lin phraseology_N = mkTerm "phraseology_N" ;
lin phrasing_N = mkTerm "phrasing_N" ;
lin phreatic_A = mkTerm "phreatic_A" ;
lin phrenetic_A = mkTerm "phrenetic_A" ;
lin phrenic_A = mkTerm "phrenic_A" ;
lin phrenological_A = mkTerm "phrenological_A" ;
lin phrenologist_N = mkTerm "phrenologist_N" ;
lin phrenology_N = mkTerm "phrenology_N" ;
lin phrontistery_N = mkTerm "phrontistery_N" ;
lin phthisis_N = mkTerm "phthisis_N" ;
lin phut_Adv = mkTerm "phut_Adv" ;
lin phycobilin_N = mkTerm "phycobilin_N" ;
lin phycocyanin_N = mkTerm "phycocyanin_N" ;
lin phycoerythrin_N = mkTerm "phycoerythrin_N" ;
lin phycology_N = mkTerm "phycology_N" ;
lin phycomycosis_N = mkTerm "phycomycosis_N" ;
lin phylactery_N = mkTerm "phylactery_N" ;
lin phyle_N = mkTerm "phyle_N" ;
lin phylliform_A = mkTerm "phylliform_A" ;
lin phyllis_PN = mkTerm "phyllis_PN" ;
lin phyllo_N = mkTerm "phyllo_N" ;
lin phyllode_N = mkTerm "phyllode_N" ;
lin phyllodial_A = mkTerm "phyllodial_A" ;
lin phylogenetic_A = mkTerm "phylogenetic_A" ;
lin phylum_N = mkTerm "phylum_N" ;
lin physa_N = mkTerm "physa_N" ;
lin physic_N = mkTerm "physic_N" ;
lin physical_A = mkTerm "physical_A" ;
lin physician_N = mkTerm "physician_N" ;
lin physicist_N = mkTerm "physicist_N" ;
lin physicochemical_A = mkTerm "physicochemical_A" ;
lin physics_N = mkTerm "physics_N" ;
lin physiognomy_N = mkTerm "physiognomy_N" ;
lin physiologic_A = mkTerm "physiologic_A" ;
lin physiological_A = mkTerm "physiological_A" ;
lin physiologist_N = mkTerm "physiologist_N" ;
lin physiology_N = mkTerm "physiology_N" ;
lin physiotherapeutic_A = mkTerm "physiotherapeutic_A" ;
lin physiotherapist_N = mkTerm "physiotherapist_N" ;
lin physiotherapy_N = mkTerm "physiotherapy_N" ;
lin physique_N = mkTerm "physique_N" ;
lin physostegia_N = mkTerm "physostegia_N" ;
lin physostigmine_N = mkTerm "physostigmine_N" ;
lin phytelephas_N = mkTerm "phytelephas_N" ;
lin phytochemical_N = mkTerm "phytochemical_N" ;
lin phytochemist_N = mkTerm "phytochemist_N" ;
lin phytochemistry_N = mkTerm "phytochemistry_N" ;
lin phytohormone_N = mkTerm "phytohormone_N" ;
lin phytoplankton_N = mkTerm "phytoplankton_N" ;
lin phytotherapy_N = mkTerm "phytotherapy_N" ;
lin pi_N = mkTerm "pi_N" ;
lin pia_N = mkTerm "pia_N" ;
lin piacenza_PN = mkTerm "piacenza_PN" ;
lin piaffe_N = mkTerm "piaffe_N" ;
lin pianism_N = mkTerm "pianism_N" ;
lin pianissimo_A = mkTerm "pianissimo_A" ;
lin pianissimo_Adv = mkTerm "pianissimo_Adv" ;
lin pianistFem_N = mkTerm "pianistFem_N" ;
lin pianistMasc_N = mkTerm "pianistMasc_N" ;
lin pianistic_A = mkTerm "pianistic_A" ;
lin piano_A = mkTerm "piano_A" ;
lin piano_Adv = mkTerm "piano_Adv" ;
lin piano_N = mkTerm "piano_N" ;
lin pianoforte_N = mkTerm "pianoforte_N" ;
lin pianola_N = mkTerm "pianola_N" ;
lin piastre_N = mkTerm "piastre_N" ;
lin piazza_N = mkTerm "piazza_N" ;
lin pibroch_N = mkTerm "pibroch_N" ;
lin pica_N = mkTerm "pica_N" ;
lin picador_N = mkTerm "picador_N" ;
lin picaresque_A = mkTerm "picaresque_A" ;
lin piccalilli_N = mkTerm "piccalilli_N" ;
lin piccaninny_N = mkTerm "piccaninny_N" ;
lin piccolo_N = mkTerm "piccolo_N" ;
lin pichi_N = mkTerm "pichi_N" ;
lin pichiciago_N = mkTerm "pichiciago_N" ;
lin pick_N = mkTerm "pick_N" ;
lin pick_V = mkTerm "pick_V" ;
lin pick_V2 = mkTerm "pick_V2" ;
lin pick_at_V2 = mkTerm "pick_at_V2" ;
lin pick_away_V = mkTerm "pick_away_V" ;
lin pick_me_up_N = mkTerm "pick_me_up_N" ;
lin pick_off_V2 = mkTerm "pick_off_V2" ;
lin pick_on_V2 = mkTerm "pick_on_V2" ;
lin pick_out_V2 = mkTerm "pick_out_V2" ;
lin pick_through_V2 = mkTerm "pick_through_V2" ;
lin pick_up_N = mkTerm "pick_up_N" ;
lin pick_up_V = mkTerm "pick_up_V" ;
lin pick_up_V2 = mkTerm "pick_up_V2" ;
lin pick_up_after_V2 = mkTerm "pick_up_after_V2" ;
lin pick_up_on_V2 = mkTerm "pick_up_on_V2" ;
lin pick_yourself_up_V = mkTerm "pick_yourself_up_V" ;
lin pickaback_Adv = mkTerm "pickaback_Adv" ;
lin pickaxe_N = mkTerm "pickaxe_N" ;
lin pickelhaube_N = mkTerm "pickelhaube_N" ;
lin picker_N = mkTerm "picker_N" ;
lin pickerel_N = mkTerm "pickerel_N" ;
lin pickerelweed_N = mkTerm "pickerelweed_N" ;
lin picket_N = mkTerm "picket_N" ;
lin picket_V = mkTerm "picket_V" ;
lin picket_V2 = mkTerm "picket_V2" ;
lin picking_N = mkTerm "picking_N" ;
lin pickings_N = mkTerm "pickings_N" ;
lin pickle_N = mkTerm "pickle_N" ;
lin pickle_V2 = mkTerm "pickle_V2" ;
lin pickpocket_N = mkTerm "pickpocket_N" ;
lin picnic_N = mkTerm "picnic_N" ;
lin picnic_V = mkTerm "picnic_V" ;
lin picnicker_N = mkTerm "picnicker_N" ;
lin picofarad_N = mkTerm "picofarad_N" ;
lin picometer_N = mkTerm "picometer_N" ;
lin picornavirus_N = mkTerm "picornavirus_N" ;
lin picosecond_N = mkTerm "picosecond_N" ;
lin picot_N = mkTerm "picot_N" ;
lin picovolt_N = mkTerm "picovolt_N" ;
lin picric_A = mkTerm "picric_A" ;
lin pictograph_N = mkTerm "pictograph_N" ;
lin pictographic_A = mkTerm "pictographic_A" ;
lin pictorial_A = mkTerm "pictorial_A" ;
lin pictorial_N = mkTerm "pictorial_N" ;
lin picture_N = mkTerm "picture_N" ;
lin picture_V2 = mkTerm "picture_V2" ;
lin picture_book_N = mkTerm "picture_book_N" ;
lin picture_card_N = mkTerm "picture_card_N" ;
lin picture_gallery_N = mkTerm "picture_gallery_N" ;
lin picturesque_A = mkTerm "picturesque_A" ;
lin picturesqueness_N = mkTerm "picturesqueness_N" ;
lin picturing_N = mkTerm "picturing_N" ;
lin picul_N = mkTerm "picul_N" ;
lin piculet_N = mkTerm "piculet_N" ;
lin piddle_N = mkTerm "piddle_N" ;
lin piddle_V = mkTerm "piddle_V" ;
lin piddock_N = mkTerm "piddock_N" ;
lin pidgin_N = mkTerm "pidgin_N" ;
lin pie_N = mkTerm "pie_N" ;
lin pie_crust_N = mkTerm "pie_crust_N" ;
lin piebald_A = mkTerm "piebald_A" ;
lin piece_N = mkTerm "piece_N" ;
lin piece_V2 = mkTerm "piece_V2" ;
lin piecemeal_A = mkTerm "piecemeal_A" ;
lin piecemeal_Adv = mkTerm "piecemeal_Adv" ;
lin piecework_N = mkTerm "piecework_N" ;
lin pied_A = mkTerm "pied_A" ;
lin pied_a_terre_N = mkTerm "pied_a_terre_N" ;
lin piedmont_N = mkTerm "piedmont_N" ;
lin pieksämäki_PN = mkTerm "pieksämäki_PN" ;
lin pielavesi_PN = mkTerm "pielavesi_PN" ;
lin pieplant_N = mkTerm "pieplant_N" ;
lin pier_N = mkTerm "pier_N" ;
lin pier_glass_N = mkTerm "pier_glass_N" ;
lin pierce_V = mkTerm "pierce_V" ;
lin pierce_V2 = mkTerm "pierce_V2" ;
lin piercingly_Adv = mkTerm "piercingly_Adv" ;
lin pierid_N = mkTerm "pierid_N" ;
lin pierrot_N = mkTerm "pierrot_N" ;
lin pieta_N = mkTerm "pieta_N" ;
lin pietistic_A = mkTerm "pietistic_A" ;
lin piety_N = mkTerm "piety_N" ;
lin piezoelectric_A = mkTerm "piezoelectric_A" ;
lin piezoelectricity_N = mkTerm "piezoelectricity_N" ;
lin piezometer_N = mkTerm "piezometer_N" ;
lin piffle_N = mkTerm "piffle_N" ;
lin piffle_V = mkTerm "piffle_V" ;
lin pig_N = mkTerm "pig_N" ;
lin pig_V = mkTerm "pig_V" ;
lin pig_headed_A = mkTerm "pig_headed_A" ;
lin pig_headedness_N = mkTerm "pig_headedness_N" ;
lin pig_iron_N = mkTerm "pig_iron_N" ;
lin pig_off_V = mkTerm "pig_off_V" ;
lin pig_out_V = mkTerm "pig_out_V" ;
lin pig_sticking_N = mkTerm "pig_sticking_N" ;
lin pigboat_N = mkTerm "pigboat_N" ;
lin pigeon_N = mkTerm "pigeon_N" ;
lin pigeon_breasted_A = mkTerm "pigeon_breasted_A" ;
lin pigeon_toed_A = mkTerm "pigeon_toed_A" ;
lin pigeonhole_N = mkTerm "pigeonhole_N" ;
lin pigeonhole_V2 = mkTerm "pigeonhole_V2" ;
lin pigfish_N = mkTerm "pigfish_N" ;
lin piggery_N = mkTerm "piggery_N" ;
lin piggish_A = mkTerm "piggish_A" ;
lin piggishness_N = mkTerm "piggishness_N" ;
lin piggy_A = mkTerm "piggy_A" ;
lin piggy_N = mkTerm "piggy_N" ;
lin piggyback_Adv = mkTerm "piggyback_Adv" ;
lin piggyback_N = mkTerm "piggyback_N" ;
lin piggyback_V = mkTerm "piggyback_V" ;
lin piglet_N = mkTerm "piglet_N" ;
lin pigment_N = mkTerm "pigment_N" ;
lin pigmentation_N = mkTerm "pigmentation_N" ;
lin pigmy_N = mkTerm "pigmy_N" ;
lin pignut_N = mkTerm "pignut_N" ;
lin pigskin_N = mkTerm "pigskin_N" ;
lin pigsty_N = mkTerm "pigsty_N" ;
lin pigswill_N = mkTerm "pigswill_N" ;
lin pigtail_N = mkTerm "pigtail_N" ;
lin pigwash_N = mkTerm "pigwash_N" ;
lin pigweed_N = mkTerm "pigweed_N" ;
lin pihtipudas_PN = mkTerm "pihtipudas_PN" ;
lin piikkiö_PN = mkTerm "piikkiö_PN" ;
lin piippola_PN = mkTerm "piippola_PN" ;
lin pika_N = mkTerm "pika_N" ;
lin pike_N = mkTerm "pike_N" ;
lin pikeblenny_N = mkTerm "pikeblenny_N" ;
lin pikestaff_N = mkTerm "pikestaff_N" ;
lin pilaff_N = mkTerm "pilaff_N" ;
lin pilar_A = mkTerm "pilar_A" ;
lin pilaster_N = mkTerm "pilaster_N" ;
lin pilchard_N = mkTerm "pilchard_N" ;
lin pile_N = mkTerm "pile_N" ;
lin pile_V = mkTerm "pile_V" ;
lin pile_V2 = mkTerm "pile_V2" ;
lin pile_driver_N = mkTerm "pile_driver_N" ;
lin pile_dwelling_N = mkTerm "pile_dwelling_N" ;
lin pile_in_V = mkTerm "pile_in_V" ;
lin pile_into_V2 = mkTerm "pile_into_V2" ;
lin pile_on_V2 = mkTerm "pile_on_V2" ;
lin pile_out_V = mkTerm "pile_out_V" ;
lin pile_up_N = mkTerm "pile_up_N" ;
lin pile_up_V = mkTerm "pile_up_V" ;
lin pile_up_V2 = mkTerm "pile_up_V2" ;
lin piles_N = mkTerm "piles_N" ;
lin pilfer_V = mkTerm "pilfer_V" ;
lin pilfer_V2 = mkTerm "pilfer_V2" ;
lin pilferage_N = mkTerm "pilferage_N" ;
lin pilferer_N = mkTerm "pilferer_N" ;
lin pilgrim_N = mkTerm "pilgrim_N" ;
lin pilgrimage_N = mkTerm "pilgrimage_N" ;
lin pill_N = mkTerm "pill_N" ;
lin pill_PN = mkTerm "pill_PN" ;
lin pillage_N = mkTerm "pillage_N" ;
lin pillage_V2 = mkTerm "pillage_V2" ;
lin pillager_N = mkTerm "pillager_N" ;
lin pillar_N = mkTerm "pillar_N" ;
lin pillar_box_N = mkTerm "pillar_box_N" ;
lin pillared_A = mkTerm "pillared_A" ;
lin pillbox_N = mkTerm "pillbox_N" ;
lin pillion_N = mkTerm "pillion_N" ;
lin pillory_N = mkTerm "pillory_N" ;
lin pillory_V2 = mkTerm "pillory_V2" ;
lin pillow_N = mkTerm "pillow_N" ;
lin pillow_V2 = mkTerm "pillow_V2" ;
lin pillow_fight_N = mkTerm "pillow_fight_N" ;
lin pillowcase_N = mkTerm "pillowcase_N" ;
lin pillowslip_N = mkTerm "pillowslip_N" ;
lin pillwort_N = mkTerm "pillwort_N" ;
lin pilocarpine_N = mkTerm "pilocarpine_N" ;
lin pilosebaceous_A = mkTerm "pilosebaceous_A" ;
lin pilot_N = mkTerm "pilot_N" ;
lin pilot_V2 = mkTerm "pilot_V2" ;
lin pilot_boat_N = mkTerm "pilot_boat_N" ;
lin pilot_burner_N = mkTerm "pilot_burner_N" ;
lin pilot_cloth_N = mkTerm "pilot_cloth_N" ;
lin pilot_engine_N = mkTerm "pilot_engine_N" ;
lin pilot_fish_N = mkTerm "pilot_fish_N" ;
lin pilot_light_N = mkTerm "pilot_light_N" ;
lin pilothouse_N = mkTerm "pilothouse_N" ;
lin piloting_N = mkTerm "piloting_N" ;
lin pilotless_A = mkTerm "pilotless_A" ;
lin pilous_A = mkTerm "pilous_A" ;
lin pilus_N = mkTerm "pilus_N" ;
lin pimento_N = mkTerm "pimento_N" ;
lin pimozide_N = mkTerm "pimozide_N" ;
lin pimp_N = mkTerm "pimp_N" ;
lin pimp_V = mkTerm "pimp_V" ;
lin pimpernel_N = mkTerm "pimpernel_N" ;
lin pimple_N = mkTerm "pimple_N" ;
lin pimpled_A = mkTerm "pimpled_A" ;
lin pimply_A = mkTerm "pimply_A" ;
lin pin_N = mkTerm "pin_N" ;
lin pin_V2 = mkTerm "pin_V2" ;
lin pin_down_V2 = mkTerm "pin_down_V2" ;
lin pin_money_N = mkTerm "pin_money_N" ;
lin pin_on_V3 = mkTerm "pin_on_V3" ;
lin pin_point_V2 = mkTerm "pin_point_V2" ;
lin pin_table_N = mkTerm "pin_table_N" ;
lin pin_up_N = mkTerm "pin_up_N" ;
lin pin_up_V2 = mkTerm "pin_up_V2" ;
lin pinafore_N = mkTerm "pinafore_N" ;
lin pinata_N = mkTerm "pinata_N" ;
lin pinball_N = mkTerm "pinball_N" ;
lin pince_nez_N = mkTerm "pince_nez_N" ;
lin pincer_N = mkTerm "pincer_N" ;
lin pinch_N = mkTerm "pinch_N" ;
lin pinch_V = mkTerm "pinch_V" ;
lin pinch_V2 = mkTerm "pinch_V2" ;
lin pinchbeck_A = mkTerm "pinchbeck_A" ;
lin pinchbeck_N = mkTerm "pinchbeck_N" ;
lin pinche_N = mkTerm "pinche_N" ;
lin pinchgut_N = mkTerm "pinchgut_N" ;
lin pincushion_N = mkTerm "pincushion_N" ;
lin pindolol_N = mkTerm "pindolol_N" ;
lin pine_N = mkTerm "pine_N" ;
lin pine_V = mkTerm "pine_V" ;
lin pine_away_V = mkTerm "pine_away_V" ;
lin pineal_A = mkTerm "pineal_A" ;
lin pinealoma_N = mkTerm "pinealoma_N" ;
lin pineapple_N = mkTerm "pineapple_N" ;
lin pinecone_N = mkTerm "pinecone_N" ;
lin pinesap_N = mkTerm "pinesap_N" ;
lin pinetum_N = mkTerm "pinetum_N" ;
lin pinfish_N = mkTerm "pinfish_N" ;
lin pinfold_N = mkTerm "pinfold_N" ;
lin ping_N = mkTerm "ping_N" ;
lin ping_V = mkTerm "ping_V" ;
lin pinger_N = mkTerm "pinger_N" ;
lin pingpong_N = mkTerm "pingpong_N" ;
lin pinguecula_N = mkTerm "pinguecula_N" ;
lin pinhead_N = mkTerm "pinhead_N" ;
lin pinhole_N = mkTerm "pinhole_N" ;
lin pining_N = mkTerm "pining_N" ;
lin pinion_N = mkTerm "pinion_N" ;
lin pinion_V2 = mkTerm "pinion_V2" ;
lin pinite_N = mkTerm "pinite_N" ;
lin pink_A = mkTerm "pink_A" ;
lin pink_N = mkTerm "pink_N" ;
lin pink_V = mkTerm "pink_V" ;
lin pink_V2 = mkTerm "pink_V2" ;
lin pinkish_A = mkTerm "pinkish_A" ;
lin pinkness_N = mkTerm "pinkness_N" ;
lin pinko_N = mkTerm "pinko_N" ;
lin pinkroot_N = mkTerm "pinkroot_N" ;
lin pinna_N = mkTerm "pinna_N" ;
lin pinnace_N = mkTerm "pinnace_N" ;
lin pinnacle_N = mkTerm "pinnacle_N" ;
lin pinnacle_V2 = mkTerm "pinnacle_V2" ;
lin pinnate_A = mkTerm "pinnate_A" ;
lin pinnatifid_A = mkTerm "pinnatifid_A" ;
lin pinnatisect_A = mkTerm "pinnatisect_A" ;
lin pinner_N = mkTerm "pinner_N" ;
lin pinning_N = mkTerm "pinning_N" ;
lin pinny_N = mkTerm "pinny_N" ;
lin pinochle_N = mkTerm "pinochle_N" ;
lin pinocytosis_N = mkTerm "pinocytosis_N" ;
lin pinole_N = mkTerm "pinole_N" ;
lin pinon_N = mkTerm "pinon_N" ;
lin pinpoint_N = mkTerm "pinpoint_N" ;
lin pinprick_N = mkTerm "pinprick_N" ;
lin pinscher_N = mkTerm "pinscher_N" ;
lin pinstripe_A = mkTerm "pinstripe_A" ;
lin pinstripe_N = mkTerm "pinstripe_N" ;
lin pinstriped_A = mkTerm "pinstriped_A" ;
lin pint_N = mkTerm "pint_N" ;
lin pintail_N = mkTerm "pintail_N" ;
lin pintle_N = mkTerm "pintle_N" ;
lin pinto_N = mkTerm "pinto_N" ;
lin pinwheel_N = mkTerm "pinwheel_N" ;
lin pinworm_N = mkTerm "pinworm_N" ;
lin pinyin_N = mkTerm "pinyin_N" ;
lin pion_N = mkTerm "pion_N" ;
lin pioneer_N = mkTerm "pioneer_N" ;
lin pioneer_V = mkTerm "pioneer_V" ;
lin pioneer_V2 = mkTerm "pioneer_V2" ;
lin pious_A = mkTerm "pious_A" ;
lin pip_N = mkTerm "pip_N" ;
lin pip_V2 = mkTerm "pip_V2" ;
lin pipage_N = mkTerm "pipage_N" ;
lin pipe_1_N = mkTerm "pipe_1_N" ;
lin pipe_2_N = mkTerm "pipe_2_N" ;
lin pipe_V = mkTerm "pipe_V" ;
lin pipe_V2 = mkTerm "pipe_V2" ;
lin pipe_down_V = mkTerm "pipe_down_V" ;
lin pipe_in_V = mkTerm "pipe_in_V" ;
lin pipe_organ_N = mkTerm "pipe_organ_N" ;
lin pipe_rack_N = mkTerm "pipe_rack_N" ;
lin pipe_up_V = mkTerm "pipe_up_V" ;
lin pipeclay_N = mkTerm "pipeclay_N" ;
lin pipedream_N = mkTerm "pipedream_N" ;
lin pipefish_N = mkTerm "pipefish_N" ;
lin pipefitting_N = mkTerm "pipefitting_N" ;
lin pipeful_N = mkTerm "pipeful_N" ;
lin pipeline_N = mkTerm "pipeline_N" ;
lin piper_N = mkTerm "piper_N" ;
lin piperacillin_N = mkTerm "piperacillin_N" ;
lin piperazine_N = mkTerm "piperazine_N" ;
lin piperin_N = mkTerm "piperin_N" ;
lin piperocaine_N = mkTerm "piperocaine_N" ;
lin pipet_N = mkTerm "pipet_N" ;
lin pipette_N = mkTerm "pipette_N" ;
lin pipework_N = mkTerm "pipework_N" ;
lin pipewort_N = mkTerm "pipewort_N" ;
lin piping_Adv = mkTerm "piping_Adv" ;
lin piping_N = mkTerm "piping_N" ;
lin pipistrelle_N = mkTerm "pipistrelle_N" ;
lin pipit_N = mkTerm "pipit_N" ;
lin pippin_N = mkTerm "pippin_N" ;
lin pipsissewa_N = mkTerm "pipsissewa_N" ;
lin pipsqueak_N = mkTerm "pipsqueak_N" ;
lin piquancy_N = mkTerm "piquancy_N" ;
lin piquant_A = mkTerm "piquant_A" ;
lin pique_N = mkTerm "pique_N" ;
lin pique_V2 = mkTerm "pique_V2" ;
lin piquet_N = mkTerm "piquet_N" ;
lin piracy_N = mkTerm "piracy_N" ;
lin piraeus_PN = mkTerm "piraeus_PN" ;
lin piranha_N = mkTerm "piranha_N" ;
lin pirate_N = mkTerm "pirate_N" ;
lin pirate_V2 = mkTerm "pirate_V2" ;
lin piratical_A = mkTerm "piratical_A" ;
lin pirkkala_PN = mkTerm "pirkkala_PN" ;
lin pirogi_N = mkTerm "pirogi_N" ;
lin piroplasm_N = mkTerm "piroplasm_N" ;
lin pirouette_N = mkTerm "pirouette_N" ;
lin pirouette_V = mkTerm "pirouette_V" ;
lin piroxicam_N = mkTerm "piroxicam_N" ;
lin pis_aller_N = mkTerm "pis_aller_N" ;
lin pisa_PN = mkTerm "pisa_PN" ;
lin pisanosaur_N = mkTerm "pisanosaur_N" ;
lin piscatorial_A = mkTerm "piscatorial_A" ;
lin pisces_PN = mkTerm "pisces_PN" ;
lin piscine_A = mkTerm "piscine_A" ;
lin piscivorous_A = mkTerm "piscivorous_A" ;
lin pisiform_N = mkTerm "pisiform_N" ;
lin piss_N = mkTerm "piss_N" ;
lin piss_V = mkTerm "piss_V" ;
lin piss_V2 = mkTerm "piss_V2" ;
lin pisser_N = mkTerm "pisser_N" ;
lin pistachio_N = mkTerm "pistachio_N" ;
lin piste_N = mkTerm "piste_N" ;
lin pistia_N = mkTerm "pistia_N" ;
lin pistil_N = mkTerm "pistil_N" ;
lin pistillate_A = mkTerm "pistillate_A" ;
lin pistillode_N = mkTerm "pistillode_N" ;
lin pistol_N = mkTerm "pistol_N" ;
lin pistoleer_N = mkTerm "pistoleer_N" ;
lin piston_N = mkTerm "piston_N" ;
lin pit_N = mkTerm "pit_N" ;
lin pit_V2 = mkTerm "pit_V2" ;
lin pit_a_pat_Adv = mkTerm "pit_a_pat_Adv" ;
lin pit_against_V3 = mkTerm "pit_against_V3" ;
lin pit_out_V = mkTerm "pit_out_V" ;
lin pit_prop_N = mkTerm "pit_prop_N" ;
lin pita_N = mkTerm "pita_N" ;
lin pitahaya_N = mkTerm "pitahaya_N" ;
lin pitch_N = mkTerm "pitch_N" ;
lin pitch_V = mkTerm "pitch_V" ;
lin pitch_V2 = mkTerm "pitch_V2" ;
lin pitch_black_A = mkTerm "pitch_black_A" ;
lin pitch_dark_A = mkTerm "pitch_dark_A" ;
lin pitch_for_V2 = mkTerm "pitch_for_V2" ;
lin pitch_in_V = mkTerm "pitch_in_V" ;
lin pitch_into_V2 = mkTerm "pitch_into_V2" ;
lin pitchblende_N = mkTerm "pitchblende_N" ;
lin pitcher_N = mkTerm "pitcher_N" ;
lin pitchfork_N = mkTerm "pitchfork_N" ;
lin pitchfork_V2 = mkTerm "pitchfork_V2" ;
lin pitching_N = mkTerm "pitching_N" ;
lin pitchman_N = mkTerm "pitchman_N" ;
lin pitchstone_N = mkTerm "pitchstone_N" ;
lin pitchy_A = mkTerm "pitchy_A" ;
lin piteous_A = mkTerm "piteous_A" ;
lin pitfall_N = mkTerm "pitfall_N" ;
lin pith_N = mkTerm "pith_N" ;
lin pithead_N = mkTerm "pithead_N" ;
lin pithy_A = mkTerm "pithy_A" ;
lin pitiable_A = mkTerm "pitiable_A" ;
lin pitiful_A = mkTerm "pitiful_A" ;
lin pitiless_A = mkTerm "pitiless_A" ;
lin pitilessness_N = mkTerm "pitilessness_N" ;
lin pitman_N = mkTerm "pitman_N" ;
lin piton_N = mkTerm "piton_N" ;
lin pitsaw_N = mkTerm "pitsaw_N" ;
lin pitta_N = mkTerm "pitta_N" ;
lin pittance_N = mkTerm "pittance_N" ;
lin pitter_patter_N = mkTerm "pitter_patter_N" ;
lin pitting_N = mkTerm "pitting_N" ;
lin pittsburgh_PN = mkTerm "pittsburgh_PN" ;
lin pituitary_A = mkTerm "pituitary_A" ;
lin pituitary_N = mkTerm "pituitary_N" ;
lin pity_N = mkTerm "pity_N" ;
lin pity_V2 = mkTerm "pity_V2" ;
lin pitying_A = mkTerm "pitying_A" ;
lin pityriasis_N = mkTerm "pityriasis_N" ;
lin pivot_N = mkTerm "pivot_N" ;
lin pivot_V = mkTerm "pivot_V" ;
lin pivot_V2 = mkTerm "pivot_V2" ;
lin pivotal_A = mkTerm "pivotal_A" ;
lin pixel_N = mkTerm "pixel_N" ;
lin pixie_N = mkTerm "pixie_N" ;
lin pixilated_A = mkTerm "pixilated_A" ;
lin pixy_N = mkTerm "pixy_N" ;
lin pizza_N = mkTerm "pizza_N" ;
lin pizzeria_N = mkTerm "pizzeria_N" ;
lin pizzicato_A = mkTerm "pizzicato_A" ;
lin pizzicato_Adv = mkTerm "pizzicato_Adv" ;
lin pizzicato_N = mkTerm "pizzicato_N" ;
lin placable_A = mkTerm "placable_A" ;
lin placard_N = mkTerm "placard_N" ;
lin placard_V2 = mkTerm "placard_V2" ;
lin placate_V2 = mkTerm "placate_V2" ;
lin placatingly_Adv = mkTerm "placatingly_Adv" ;
lin placation_N = mkTerm "placation_N" ;
lin place_N = mkTerm "place_N" ;
lin place_V2 = mkTerm "place_V2" ;
lin place_bet_N = mkTerm "place_bet_N" ;
lin place_name_N = mkTerm "place_name_N" ;
lin placebo_N = mkTerm "placebo_N" ;
lin placeholder_N = mkTerm "placeholder_N" ;
lin placeman_N = mkTerm "placeman_N" ;
lin placement_N = mkTerm "placement_N" ;
lin placenta_N = mkTerm "placenta_N" ;
lin placental_A = mkTerm "placental_A" ;
lin placental_N = mkTerm "placental_N" ;
lin placentation_N = mkTerm "placentation_N" ;
lin placer_N = mkTerm "placer_N" ;
lin placeseeker_N = mkTerm "placeseeker_N" ;
lin placid_A = mkTerm "placid_A" ;
lin placidity_N = mkTerm "placidity_N" ;
lin placing_N = mkTerm "placing_N" ;
lin placket_N = mkTerm "placket_N" ;
lin placoderm_N = mkTerm "placoderm_N" ;
lin placoid_A = mkTerm "placoid_A" ;
lin plage_N = mkTerm "plage_N" ;
lin plagiarism_N = mkTerm "plagiarism_N" ;
lin plagiarist_N = mkTerm "plagiarist_N" ;
lin plagiaristic_A = mkTerm "plagiaristic_A" ;
lin plagiarize_V2 = mkTerm "plagiarize_V2" ;
lin plagiocephaly_N = mkTerm "plagiocephaly_N" ;
lin plagioclase_N = mkTerm "plagioclase_N" ;
lin plagioclastic_A = mkTerm "plagioclastic_A" ;
lin plague_N = mkTerm "plague_N" ;
lin plague_V2 = mkTerm "plague_V2" ;
lin plague_spot_N = mkTerm "plague_spot_N" ;
lin plaguey_Adv = mkTerm "plaguey_Adv" ;
lin plaguy_A = mkTerm "plaguy_A" ;
lin plaice_N = mkTerm "plaice_N" ;
lin plaid_N = mkTerm "plaid_N" ;
lin plain_A = mkTerm "plain_A" ;
lin plain_Adv = mkTerm "plain_Adv" ;
lin plain_N = mkTerm "plain_N" ;
lin plain_V = mkTerm "plain_V" ;
lin plain_V2 = mkTerm "plain_V2" ;
lin plain_spoken_A = mkTerm "plain_spoken_A" ;
lin plainclothesman_N = mkTerm "plainclothesman_N" ;
lin plainness_N = mkTerm "plainness_N" ;
lin plainsman_N = mkTerm "plainsman_N" ;
lin plainsong_N = mkTerm "plainsong_N" ;
lin plaint_N = mkTerm "plaint_N" ;
lin plaintiff_N = mkTerm "plaintiff_N" ;
lin plaintive_A = mkTerm "plaintive_A" ;
lin plaintiveness_N = mkTerm "plaintiveness_N" ;
lin plait_N = mkTerm "plait_N" ;
lin plait_V2 = mkTerm "plait_V2" ;
lin plaiter_N = mkTerm "plaiter_N" ;
lin plan_N = mkTerm "plan_N" ;
lin plan_V = mkTerm "plan_V" ;
lin plan_V2 = mkTerm "plan_V2" ;
lin plan_V2V = mkTerm "plan_V2V" ;
lin plan_VS = mkTerm "plan_VS" ;
lin plan_VV = mkTerm "plan_VV" ;
lin planar_A = mkTerm "planar_A" ;
lin planarian_N = mkTerm "planarian_N" ;
lin planate_A = mkTerm "planate_A" ;
lin planation_N = mkTerm "planation_N" ;
lin planchet_N = mkTerm "planchet_N" ;
lin planchette_N = mkTerm "planchette_N" ;
lin plane_N = mkTerm "plane_N" ;
lin plane_V = mkTerm "plane_V" ;
lin plane_V2 = mkTerm "plane_V2" ;
lin plane_tree_N = mkTerm "plane_tree_N" ;
lin planet_N = mkTerm "planet_N" ;
lin planetal_A = mkTerm "planetal_A" ;
lin planetarium_N = mkTerm "planetarium_N" ;
lin planetary_A = mkTerm "planetary_A" ;
lin planetesimal_N = mkTerm "planetesimal_N" ;
lin plangency_N = mkTerm "plangency_N" ;
lin plangent_A = mkTerm "plangent_A" ;
lin plank_N = mkTerm "plank_N" ;
lin plank_V2 = mkTerm "plank_V2" ;
lin plank_bed_N = mkTerm "plank_bed_N" ;
lin planking_N = mkTerm "planking_N" ;
lin plankton_N = mkTerm "plankton_N" ;
lin planktonic_A = mkTerm "planktonic_A" ;
lin planless_A = mkTerm "planless_A" ;
lin planned_A = mkTerm "planned_A" ;
lin planner_N = mkTerm "planner_N" ;
lin planning_N = mkTerm "planning_N" ;
lin planoconcave_A = mkTerm "planoconcave_A" ;
lin planoconvex_A = mkTerm "planoconvex_A" ;
lin planographic_A = mkTerm "planographic_A" ;
lin plant_1_N = mkTerm "plant_1_N" ;
lin plant_2_N = mkTerm "plant_2_N" ;
lin plant_V2 = mkTerm "plant_V2" ;
lin plant_louse_N = mkTerm "plant_louse_N" ;
lin plant_out_V2 = mkTerm "plant_out_V2" ;
lin plantain_N = mkTerm "plantain_N" ;
lin plantal_A = mkTerm "plantal_A" ;
lin plantar_A = mkTerm "plantar_A" ;
lin plantation_N = mkTerm "plantation_N" ;
lin planter_N = mkTerm "planter_N" ;
lin plantigrade_A = mkTerm "plantigrade_A" ;
lin planting_N = mkTerm "planting_N" ;
lin plantlet_N = mkTerm "plantlet_N" ;
lin planula_N = mkTerm "planula_N" ;
lin plaque_N = mkTerm "plaque_N" ;
lin plash_N = mkTerm "plash_N" ;
lin plash_V = mkTerm "plash_V" ;
lin plash_V2 = mkTerm "plash_V2" ;
lin plasm_N = mkTerm "plasm_N" ;
lin plasma_N = mkTerm "plasma_N" ;
lin plasmablast_N = mkTerm "plasmablast_N" ;
lin plasmacytoma_N = mkTerm "plasmacytoma_N" ;
lin plasmapheresis_N = mkTerm "plasmapheresis_N" ;
lin plasmid_N = mkTerm "plasmid_N" ;
lin plasmin_N = mkTerm "plasmin_N" ;
lin plasminogen_N = mkTerm "plasminogen_N" ;
lin plasmodium_N = mkTerm "plasmodium_N" ;
lin plaster_N = mkTerm "plaster_N" ;
lin plaster_V2 = mkTerm "plaster_V2" ;
lin plasterboard_N = mkTerm "plasterboard_N" ;
lin plasterer_N = mkTerm "plasterer_N" ;
lin plastering_N = mkTerm "plastering_N" ;
lin plastic_A = mkTerm "plastic_A" ;
lin plastic_N = mkTerm "plastic_N" ;
lin plastic_bomb_N = mkTerm "plastic_bomb_N" ;
lin plasticine_N = mkTerm "plasticine_N" ;
lin plasticity_N = mkTerm "plasticity_N" ;
lin plasticizer_N = mkTerm "plasticizer_N" ;
lin plastics_N = mkTerm "plastics_N" ;
lin plastid_N = mkTerm "plastid_N" ;
lin plastination_N = mkTerm "plastination_N" ;
lin plastron_N = mkTerm "plastron_N" ;
lin plat_N = mkTerm "plat_N" ;
lin plate_N = mkTerm "plate_N" ;
lin plate_V2 = mkTerm "plate_V2" ;
lin plate_glass_N = mkTerm "plate_glass_N" ;
lin plate_powder_N = mkTerm "plate_powder_N" ;
lin plate_rack_N = mkTerm "plate_rack_N" ;
lin plate_up_V = mkTerm "plate_up_V" ;
lin plateau_N = mkTerm "plateau_N" ;
lin plateful_N = mkTerm "plateful_N" ;
lin platelayer_N = mkTerm "platelayer_N" ;
lin platelet_N = mkTerm "platelet_N" ;
lin plateletpheresis_N = mkTerm "plateletpheresis_N" ;
lin platen_N = mkTerm "platen_N" ;
lin plater_N = mkTerm "plater_N" ;
lin platform_N = mkTerm "platform_N" ;
lin plating_N = mkTerm "plating_N" ;
lin platinum_N = mkTerm "platinum_N" ;
lin platitude_N = mkTerm "platitude_N" ;
lin platitudinarian_N = mkTerm "platitudinarian_N" ;
lin platitudinous_A = mkTerm "platitudinous_A" ;
lin platonic_A = mkTerm "platonic_A" ;
lin platoon_N = mkTerm "platoon_N" ;
lin platter_N = mkTerm "platter_N" ;
lin platy_N = mkTerm "platy_N" ;
lin platyctenean_N = mkTerm "platyctenean_N" ;
lin platypus_N = mkTerm "platypus_N" ;
lin platyrrhine_A = mkTerm "platyrrhine_A" ;
lin platysma_N = mkTerm "platysma_N" ;
lin plaudit_N = mkTerm "plaudit_N" ;
lin plausibility_N = mkTerm "plausibility_N" ;
lin plausible_A = mkTerm "plausible_A" ;
lin play_1_V = mkTerm "play_1_V" ;
lin play_1_V2 = mkTerm "play_1_V2" ;
lin play_2_V = mkTerm "play_2_V" ;
lin play_2_V2 = mkTerm "play_2_V2" ;
lin play_3_V = mkTerm "play_3_V" ;
lin play_3_V2 = mkTerm "play_3_V2" ;
lin play_N = mkTerm "play_N" ;
lin play_acting_N = mkTerm "play_acting_N" ;
lin play_actor_N = mkTerm "play_actor_N" ;
lin play_along_V = mkTerm "play_along_V" ;
lin play_around_V = mkTerm "play_around_V" ;
lin play_at_V2 = mkTerm "play_at_V2" ;
lin play_away_V = mkTerm "play_away_V" ;
lin play_back_V2 = mkTerm "play_back_V2" ;
lin play_box_N = mkTerm "play_box_N" ;
lin play_down_V2 = mkTerm "play_down_V2" ;
lin play_off_N = mkTerm "play_off_N" ;
lin play_off_V = mkTerm "play_off_V" ;
lin play_off_V2 = mkTerm "play_off_V2" ;
lin play_on_V = mkTerm "play_on_V" ;
lin play_on_V2 = mkTerm "play_on_V2" ;
lin play_out_V = mkTerm "play_out_V" ;
lin play_out_V2 = mkTerm "play_out_V2" ;
lin play_reading_N = mkTerm "play_reading_N" ;
lin play_up_V = mkTerm "play_up_V" ;
lin play_up_V2 = mkTerm "play_up_V2" ;
lin play_up_to_V2 = mkTerm "play_up_to_V2" ;
lin play_upon_V2 = mkTerm "play_upon_V2" ;
lin play_with_V2 = mkTerm "play_with_V2" ;
lin playable_A = mkTerm "playable_A" ;
lin playback_N = mkTerm "playback_N" ;
lin playbill_N = mkTerm "playbill_N" ;
lin playbook_N = mkTerm "playbook_N" ;
lin playbox_N = mkTerm "playbox_N" ;
lin playboy_N = mkTerm "playboy_N" ;
lin player_N = mkTerm "player_N" ;
lin player_piano_N = mkTerm "player_piano_N" ;
lin playfellow_N = mkTerm "playfellow_N" ;
lin playful_A = mkTerm "playful_A" ;
lin playfulness_N = mkTerm "playfulness_N" ;
lin playgoer_N = mkTerm "playgoer_N" ;
lin playground_N = mkTerm "playground_N" ;
lin playgroup_N = mkTerm "playgroup_N" ;
lin playhouse_N = mkTerm "playhouse_N" ;
lin playing_N = mkTerm "playing_N" ;
lin playing_card_N = mkTerm "playing_card_N" ;
lin playing_field_N = mkTerm "playing_field_N" ;
lin playlet_N = mkTerm "playlet_N" ;
lin playlist_N = mkTerm "playlist_N" ;
lin playmaker_N = mkTerm "playmaker_N" ;
lin playmate_N = mkTerm "playmate_N" ;
lin playpen_N = mkTerm "playpen_N" ;
lin playroom_N = mkTerm "playroom_N" ;
lin playschool_N = mkTerm "playschool_N" ;
lin playsuit_N = mkTerm "playsuit_N" ;
lin plaything_N = mkTerm "plaything_N" ;
lin playtime_N = mkTerm "playtime_N" ;
lin playwright_N = mkTerm "playwright_N" ;
lin plaza_N = mkTerm "plaza_N" ;
lin plc_PN = mkTerm "plc_PN" ;
lin plea_N = mkTerm "plea_N" ;
lin pleach_V2 = mkTerm "pleach_V2" ;
lin plead_V = mkTerm "plead_V" ;
lin plead_V2 = mkTerm "plead_V2" ;
lin plead_VS = mkTerm "plead_VS" ;
lin plead_out_V = mkTerm "plead_out_V" ;
lin pleading_N = mkTerm "pleading_N" ;
lin pleadingly_Adv = mkTerm "pleadingly_Adv" ;
lin pleasance_N = mkTerm "pleasance_N" ;
lin pleasant_A = mkTerm "pleasant_A" ;
lin pleasantness_N = mkTerm "pleasantness_N" ;
lin pleasantry_N = mkTerm "pleasantry_N" ;
lin please_Adv = mkTerm "please_Adv" ;
lin please_V = mkTerm "please_V" ;
lin please_V2 = mkTerm "please_V2" ;
lin please_V2V = mkTerm "please_V2V" ;
lin please_VV = mkTerm "please_VV" ;
lin pleased_A = mkTerm "pleased_A" ;
lin pleaser_N = mkTerm "pleaser_N" ;
lin pleasing_N = mkTerm "pleasing_N" ;
lin pleasingly_Adv = mkTerm "pleasingly_Adv" ;
lin pleasingness_N = mkTerm "pleasingness_N" ;
lin pleasurable_A = mkTerm "pleasurable_A" ;
lin pleasure_N = mkTerm "pleasure_N" ;
lin pleasure_boat_N = mkTerm "pleasure_boat_N" ;
lin pleasure_craft_N = mkTerm "pleasure_craft_N" ;
lin pleasure_ground_N = mkTerm "pleasure_ground_N" ;
lin pleat_N = mkTerm "pleat_N" ;
lin pleat_V2 = mkTerm "pleat_V2" ;
lin pleb_N = mkTerm "pleb_N" ;
lin plebeian_A = mkTerm "plebeian_A" ;
lin plebeian_N = mkTerm "plebeian_N" ;
lin plebiscite_N = mkTerm "plebiscite_N" ;
lin plectognath_N = mkTerm "plectognath_N" ;
lin plectranthus_N = mkTerm "plectranthus_N" ;
lin plectrum_N = mkTerm "plectrum_N" ;
lin pledge_N = mkTerm "pledge_N" ;
lin pledge_V2 = mkTerm "pledge_V2" ;
lin pledge_V2V = mkTerm "pledge_V2V" ;
lin pledge_VS = mkTerm "pledge_VS" ;
lin pledgee_N = mkTerm "pledgee_N" ;
lin pledger_N = mkTerm "pledger_N" ;
lin plenary_A = mkTerm "plenary_A" ;
lin plenipotentiary_N = mkTerm "plenipotentiary_N" ;
lin plenitude_N = mkTerm "plenitude_N" ;
lin plenteous_A = mkTerm "plenteous_A" ;
lin plentiful_A = mkTerm "plentiful_A" ;
lin plenty_Adv = mkTerm "plenty_Adv" ;
lin plenty_N = mkTerm "plenty_N" ;
lin plenty_NP = mkTerm "plenty_NP" ;
lin plenum_N = mkTerm "plenum_N" ;
lin pleochroic_A = mkTerm "pleochroic_A" ;
lin pleochroism_N = mkTerm "pleochroism_N" ;
lin pleomorphic_A = mkTerm "pleomorphic_A" ;
lin pleomorphism_N = mkTerm "pleomorphism_N" ;
lin pleonasm_N = mkTerm "pleonasm_N" ;
lin pleonastic_A = mkTerm "pleonastic_A" ;
lin plesiosaur_N = mkTerm "plesiosaur_N" ;
lin plethora_N = mkTerm "plethora_N" ;
lin plethysmograph_N = mkTerm "plethysmograph_N" ;
lin pleura_N = mkTerm "pleura_N" ;
lin pleural_A = mkTerm "pleural_A" ;
lin pleurisy_N = mkTerm "pleurisy_N" ;
lin pleurocarp_N = mkTerm "pleurocarp_N" ;
lin pleurocarpous_A = mkTerm "pleurocarpous_A" ;
lin pleurodont_N = mkTerm "pleurodont_N" ;
lin pleurodynia_N = mkTerm "pleurodynia_N" ;
lin pleuropneumonia_N = mkTerm "pleuropneumonia_N" ;
lin pleurothallis_N = mkTerm "pleurothallis_N" ;
lin pleximeter_N = mkTerm "pleximeter_N" ;
lin plexor_N = mkTerm "plexor_N" ;
lin plexus_N = mkTerm "plexus_N" ;
lin pliability_N = mkTerm "pliability_N" ;
lin pliable_A = mkTerm "pliable_A" ;
lin pliancy_N = mkTerm "pliancy_N" ;
lin pliant_A = mkTerm "pliant_A" ;
lin plication_N = mkTerm "plication_N" ;
lin plier_N = mkTerm "plier_N" ;
lin pliers_N = mkTerm "pliers_N" ;
lin plight_N = mkTerm "plight_N" ;
lin plight_V2 = mkTerm "plight_V2" ;
lin plimsoll_N = mkTerm "plimsoll_N" ;
lin plinth_N = mkTerm "plinth_N" ;
lin ploce_N = mkTerm "ploce_N" ;
lin plod_V = mkTerm "plod_V" ;
lin plod_V2 = mkTerm "plod_V2" ;
lin plodder_N = mkTerm "plodder_N" ;
lin plodding_N = mkTerm "plodding_N" ;
lin ploddingly_Adv = mkTerm "ploddingly_Adv" ;
lin plonk_Adv = mkTerm "plonk_Adv" ;
lin plonk_N = mkTerm "plonk_N" ;
lin plonk_V = mkTerm "plonk_V" ;
lin plop_Adv = mkTerm "plop_Adv" ;
lin plop_N = mkTerm "plop_N" ;
lin plop_V = mkTerm "plop_V" ;
lin plosion_N = mkTerm "plosion_N" ;
lin plosive_A = mkTerm "plosive_A" ;
lin plosive_N = mkTerm "plosive_N" ;
lin plot_N = mkTerm "plot_N" ;
lin plot_V = mkTerm "plot_V" ;
lin plot_V2 = mkTerm "plot_V2" ;
lin plot_out_V = mkTerm "plot_out_V" ;
lin plotter_N = mkTerm "plotter_N" ;
lin plough_N = mkTerm "plough_N" ;
lin plough_V = mkTerm "plough_V" ;
lin plough_V2 = mkTerm "plough_V2" ;
lin plough_back_V2 = mkTerm "plough_back_V2" ;
lin plough_into_V2 = mkTerm "plough_into_V2" ;
lin plough_on_V = mkTerm "plough_on_V" ;
lin plough_through_V2 = mkTerm "plough_through_V2" ;
lin plough_up_V2 = mkTerm "plough_up_V2" ;
lin ploughboy_N = mkTerm "ploughboy_N" ;
lin ploughman_N = mkTerm "ploughman_N" ;
lin ploughshare_N = mkTerm "ploughshare_N" ;
lin plover_N = mkTerm "plover_N" ;
lin plow_N = mkTerm "plow_N" ;
lin plow_V = mkTerm "plow_V" ;
lin plow_V2 = mkTerm "plow_V2" ;
lin plow_back_V2 = mkTerm "plow_back_V2" ;
lin plow_into_V2 = mkTerm "plow_into_V2" ;
lin plow_on_V = mkTerm "plow_on_V" ;
lin plow_through_V2 = mkTerm "plow_through_V2" ;
lin plow_up_V2 = mkTerm "plow_up_V2" ;
lin plowboy_N = mkTerm "plowboy_N" ;
lin plowing_N = mkTerm "plowing_N" ;
lin plowman_N = mkTerm "plowman_N" ;
lin plowshare_N = mkTerm "plowshare_N" ;
lin plowwright_N = mkTerm "plowwright_N" ;
lin ploy_N = mkTerm "ploy_N" ;
lin pluck_N = mkTerm "pluck_N" ;
lin pluck_V = mkTerm "pluck_V" ;
lin pluck_V2 = mkTerm "pluck_V2" ;
lin pluck_at_V2 = mkTerm "pluck_at_V2" ;
lin pluck_up_V2 = mkTerm "pluck_up_V2" ;
lin plucky_A = mkTerm "plucky_A" ;
lin plug_N = mkTerm "plug_N" ;
lin plug_V = mkTerm "plug_V" ;
lin plug_V2 = mkTerm "plug_V2" ;
lin plug_in_V2 = mkTerm "plug_in_V2" ;
lin plughole_N = mkTerm "plughole_N" ;
lin plum_N = mkTerm "plum_N" ;
lin plum_pudding_N = mkTerm "plum_pudding_N" ;
lin plumage_N = mkTerm "plumage_N" ;
lin plumaged_A = mkTerm "plumaged_A" ;
lin plumate_A = mkTerm "plumate_A" ;
lin plumb_A = mkTerm "plumb_A" ;
lin plumb_Adv = mkTerm "plumb_Adv" ;
lin plumb_N = mkTerm "plumb_N" ;
lin plumb_V2 = mkTerm "plumb_V2" ;
lin plumbaginaceous_A = mkTerm "plumbaginaceous_A" ;
lin plumbago_N = mkTerm "plumbago_N" ;
lin plumber_N = mkTerm "plumber_N" ;
lin plumbic_A = mkTerm "plumbic_A" ;
lin plumbing_N = mkTerm "plumbing_N" ;
lin plumcot_N = mkTerm "plumcot_N" ;
lin plume_N = mkTerm "plume_N" ;
lin plume_V2 = mkTerm "plume_V2" ;
lin plumelike_A = mkTerm "plumelike_A" ;
lin plumlike_A = mkTerm "plumlike_A" ;
lin plummet_N = mkTerm "plummet_N" ;
lin plummet_V = mkTerm "plummet_V" ;
lin plummet_V2 = mkTerm "plummet_V2" ;
lin plummy_A = mkTerm "plummy_A" ;
lin plump_A = mkTerm "plump_A" ;
lin plump_Adv = mkTerm "plump_Adv" ;
lin plump_N = mkTerm "plump_N" ;
lin plump_V = mkTerm "plump_V" ;
lin plump_V2 = mkTerm "plump_V2" ;
lin plump_down_V = mkTerm "plump_down_V" ;
lin plump_for_V2 = mkTerm "plump_for_V2" ;
lin plump_up_V2 = mkTerm "plump_up_V2" ;
lin plump_yourself_down_V = mkTerm "plump_yourself_down_V" ;
lin plumpness_N = mkTerm "plumpness_N" ;
lin plumule_N = mkTerm "plumule_N" ;
lin plunder_N = mkTerm "plunder_N" ;
lin plunder_V = mkTerm "plunder_V" ;
lin plunder_V2 = mkTerm "plunder_V2" ;
lin plunderage_N = mkTerm "plunderage_N" ;
lin plunderer_N = mkTerm "plunderer_N" ;
lin plundering_N = mkTerm "plundering_N" ;
lin plunge_N = mkTerm "plunge_N" ;
lin plunge_V = mkTerm "plunge_V" ;
lin plunge_V2 = mkTerm "plunge_V2" ;
lin plunge_in_V = mkTerm "plunge_in_V" ;
lin plunger_N = mkTerm "plunger_N" ;
lin plunk_N = mkTerm "plunk_N" ;
lin pluperfect_A = mkTerm "pluperfect_A" ;
lin pluperfect_N = mkTerm "pluperfect_N" ;
lin plural_A = mkTerm "plural_A" ;
lin plural_N = mkTerm "plural_N" ;
lin pluralism_N = mkTerm "pluralism_N" ;
lin pluralist_N = mkTerm "pluralist_N" ;
lin pluralistic_A = mkTerm "pluralistic_A" ;
lin plurality_N = mkTerm "plurality_N" ;
lin pluralization_N = mkTerm "pluralization_N" ;
lin plus_A = mkTerm "plus_A" ;
lin plus_Conj = mkTerm "plus_Conj" ;
lin plus_N = mkTerm "plus_N" ;
lin plus_Prep = mkTerm "plus_Prep" ;
lin plush_A = mkTerm "plush_A" ;
lin plush_N = mkTerm "plush_N" ;
lin plushy_A = mkTerm "plushy_A" ;
lin pluto_PN = mkTerm "pluto_PN" ;
lin plutocracy_N = mkTerm "plutocracy_N" ;
lin plutocrat_N = mkTerm "plutocrat_N" ;
lin plutocratic_A = mkTerm "plutocratic_A" ;
lin plutonium_N = mkTerm "plutonium_N" ;
lin ply_N = mkTerm "ply_N" ;
lin ply_V = mkTerm "ply_V" ;
lin ply_V2 = mkTerm "ply_V2" ;
lin ply_V2A = mkTerm "ply_V2A" ;
lin plymouth_PN = mkTerm "plymouth_PN" ;
lin plywood_N = mkTerm "plywood_N" ;
lin pneumatic_A = mkTerm "pneumatic_A" ;
lin pneumatics_N = mkTerm "pneumatics_N" ;
lin pneumatophore_N = mkTerm "pneumatophore_N" ;
lin pneumococcal_A = mkTerm "pneumococcal_A" ;
lin pneumococcus_N = mkTerm "pneumococcus_N" ;
lin pneumoconiosis_N = mkTerm "pneumoconiosis_N" ;
lin pneumocytosis_N = mkTerm "pneumocytosis_N" ;
lin pneumogastric_A = mkTerm "pneumogastric_A" ;
lin pneumonectomy_N = mkTerm "pneumonectomy_N" ;
lin pneumonia_N = mkTerm "pneumonia_N" ;
lin pneumonic_A = mkTerm "pneumonic_A" ;
lin pneumonitis_N = mkTerm "pneumonitis_N" ;
lin pneumothorax_N = mkTerm "pneumothorax_N" ;
lin png_N = mkTerm "png_N" ;
lin po_N = mkTerm "po_N" ;
lin poach_V = mkTerm "poach_V" ;
lin poach_V2 = mkTerm "poach_V2" ;
lin poacher_N = mkTerm "poacher_N" ;
lin poaching_N = mkTerm "poaching_N" ;
lin pochard_N = mkTerm "pochard_N" ;
lin pock_N = mkTerm "pock_N" ;
lin pocked_A = mkTerm "pocked_A" ;
lin pocket_N = mkTerm "pocket_N" ;
lin pocket_V2 = mkTerm "pocket_V2" ;
lin pocket_book_N = mkTerm "pocket_book_N" ;
lin pocket_handkerchief_N = mkTerm "pocket_handkerchief_N" ;
lin pocket_knife_N = mkTerm "pocket_knife_N" ;
lin pocket_money_N = mkTerm "pocket_money_N" ;
lin pocketcomb_N = mkTerm "pocketcomb_N" ;
lin pocketful_N = mkTerm "pocketful_N" ;
lin pockmark_N = mkTerm "pockmark_N" ;
lin pockmarked_A = mkTerm "pockmarked_A" ;
lin pod_N = mkTerm "pod_N" ;
lin pod_V = mkTerm "pod_V" ;
lin pod_V2 = mkTerm "pod_V2" ;
lin podalgia_N = mkTerm "podalgia_N" ;
lin podcast_N = mkTerm "podcast_N" ;
lin podetium_N = mkTerm "podetium_N" ;
lin podgy_A = mkTerm "podgy_A" ;
lin podiatry_N = mkTerm "podiatry_N" ;
lin podium_N = mkTerm "podium_N" ;
lin podlike_A = mkTerm "podlike_A" ;
lin podocarp_N = mkTerm "podocarp_N" ;
lin podzol_N = mkTerm "podzol_N" ;
lin poem_N = mkTerm "poem_N" ;
lin poesy_N = mkTerm "poesy_N" ;
lin poet_N = mkTerm "poet_N" ;
lin poetess_N = mkTerm "poetess_N" ;
lin poetic_A = mkTerm "poetic_A" ;
lin poetical_A = mkTerm "poetical_A" ;
lin poetics_N = mkTerm "poetics_N" ;
lin poetry_N = mkTerm "poetry_N" ;
lin pogge_N = mkTerm "pogge_N" ;
lin pogonia_N = mkTerm "pogonia_N" ;
lin pogonion_N = mkTerm "pogonion_N" ;
lin pogrom_N = mkTerm "pogrom_N" ;
lin pohja_PN = mkTerm "pohja_PN" ;
lin poi_N = mkTerm "poi_N" ;
lin poignance_N = mkTerm "poignance_N" ;
lin poignancy_N = mkTerm "poignancy_N" ;
lin poignant_A = mkTerm "poignant_A" ;
lin poikilotherm_N = mkTerm "poikilotherm_N" ;
lin poikilothermic_A = mkTerm "poikilothermic_A" ;
lin poilu_N = mkTerm "poilu_N" ;
lin poinsettia_N = mkTerm "poinsettia_N" ;
lin point_1_N = mkTerm "point_1_N" ;
lin point_2_N = mkTerm "point_2_N" ;
lin point_V = mkTerm "point_V" ;
lin point_V2 = mkTerm "point_V2" ;
lin point_blank_A = mkTerm "point_blank_A" ;
lin point_blank_Adv = mkTerm "point_blank_Adv" ;
lin point_duty_N = mkTerm "point_duty_N" ;
lin point_out_V2 = mkTerm "point_out_V2" ;
lin point_out_VS = mkTerm "point_out_VS" ;
lin point_up_V = mkTerm "point_up_V" ;
lin pointed_A = mkTerm "pointed_A" ;
lin pointedly_AdV = mkTerm "pointedly_AdV" ;
lin pointedness_N = mkTerm "pointedness_N" ;
lin pointer_N = mkTerm "pointer_N" ;
lin pointillism_N = mkTerm "pointillism_N" ;
lin pointillist_A = mkTerm "pointillist_A" ;
lin pointillist_N = mkTerm "pointillist_N" ;
lin pointless_A = mkTerm "pointless_A" ;
lin pointsman_N = mkTerm "pointsman_N" ;
lin poise_N = mkTerm "poise_N" ;
lin poise_V = mkTerm "poise_V" ;
lin poise_V2 = mkTerm "poise_V2" ;
lin poison_N = mkTerm "poison_N" ;
lin poison_V2 = mkTerm "poison_V2" ;
lin poison_gas_N = mkTerm "poison_gas_N" ;
lin poison_ivy_N = mkTerm "poison_ivy_N" ;
lin poisoner_N = mkTerm "poisoner_N" ;
lin poisoning_N = mkTerm "poisoning_N" ;
lin poisonous_A = mkTerm "poisonous_A" ;
lin poke_N = mkTerm "poke_N" ;
lin poke_V = mkTerm "poke_V" ;
lin poke_V2 = mkTerm "poke_V2" ;
lin poke_about_V = mkTerm "poke_about_V" ;
lin poke_around_V = mkTerm "poke_around_V" ;
lin poke_bonnet_N = mkTerm "poke_bonnet_N" ;
lin poker_N = mkTerm "poker_N" ;
lin poker_face_N = mkTerm "poker_face_N" ;
lin pokeweed_N = mkTerm "pokeweed_N" ;
lin poky_A = mkTerm "poky_A" ;
lin polack_N = mkTerm "polack_N" ;
lin poland_PN = mkTerm "poland_PN" ;
lin polar_A = mkTerm "polar_A" ;
lin polarimeter_N = mkTerm "polarimeter_N" ;
lin polaris_N = mkTerm "polaris_N" ;
lin polarity_N = mkTerm "polarity_N" ;
lin polarization_N = mkTerm "polarization_N" ;
lin polarize_V2 = mkTerm "polarize_V2" ;
lin polarographic_A = mkTerm "polarographic_A" ;
lin polarography_N = mkTerm "polarography_N" ;
lin polaroid_N = mkTerm "polaroid_N" ;
lin polder_N = mkTerm "polder_N" ;
lin pole_N = mkTerm "pole_N" ;
lin pole_jumping_N = mkTerm "pole_jumping_N" ;
lin pole_star_N = mkTerm "pole_star_N" ;
lin pole_vault_N = mkTerm "pole_vault_N" ;
lin poleax_N = mkTerm "poleax_N" ;
lin poleax_V2 = mkTerm "poleax_V2" ;
lin poleaxe_N = mkTerm "poleaxe_N" ;
lin poleaxe_V2 = mkTerm "poleaxe_V2" ;
lin polecat_N = mkTerm "polecat_N" ;
lin polemic_A = mkTerm "polemic_A" ;
lin polemic_N = mkTerm "polemic_N" ;
lin polemicist_N = mkTerm "polemicist_N" ;
lin polemics_N = mkTerm "polemics_N" ;
lin polemoniaceous_A = mkTerm "polemoniaceous_A" ;
lin polemonium_N = mkTerm "polemonium_N" ;
lin polenta_N = mkTerm "polenta_N" ;
lin police_N = mkTerm "police_N" ;
lin police_V2 = mkTerm "police_V2" ;
lin police_office_N = mkTerm "police_office_N" ;
lin police_officer_N = mkTerm "police_officer_N" ;
lin police_station_N = mkTerm "police_station_N" ;
lin policeman_N = mkTerm "policeman_N" ;
lin policewoman_N = mkTerm "policewoman_N" ;
lin policy_N = mkTerm "policy_N" ;
lin policyholder_N = mkTerm "policyholder_N" ;
lin polio_N = mkTerm "polio_N" ;
lin poliomyelitis_N = mkTerm "poliomyelitis_N" ;
lin poliosis_N = mkTerm "poliosis_N" ;
lin poliovirus_N = mkTerm "poliovirus_N" ;
lin polishFem_N = mkTerm "polishFem_N" ;
lin polishMasc_N = mkTerm "polishMasc_N" ;
lin polish_A = mkTerm "polish_A" ;
lin polish_N = mkTerm "polish_N" ;
lin polish_V = mkTerm "polish_V" ;
lin polish_V2 = mkTerm "polish_V2" ;
lin polish_off_V2 = mkTerm "polish_off_V2" ;
lin polish_up_V2 = mkTerm "polish_up_V2" ;
lin polished_A = mkTerm "polished_A" ;
lin polisher_N = mkTerm "polisher_N" ;
lin politburo_N = mkTerm "politburo_N" ;
lin polite_A = mkTerm "polite_A" ;
lin politeness_N = mkTerm "politeness_N" ;
lin politic_A = mkTerm "politic_A" ;
lin political_A = mkTerm "political_A" ;
lin politician_N = mkTerm "politician_N" ;
lin politicize_V = mkTerm "politicize_V" ;
lin politicize_V2 = mkTerm "politicize_V2" ;
lin politick_V = mkTerm "politick_V" ;
lin politics_N = mkTerm "politics_N" ;
lin polity_N = mkTerm "polity_N" ;
lin polka_N = mkTerm "polka_N" ;
lin poll_N = mkTerm "poll_N" ;
lin poll_V = mkTerm "poll_V" ;
lin poll_V2 = mkTerm "poll_V2" ;
lin poll_tax_N = mkTerm "poll_tax_N" ;
lin pollack_N = mkTerm "pollack_N" ;
lin pollard_N = mkTerm "pollard_N" ;
lin pollard_V2 = mkTerm "pollard_V2" ;
lin pollen_N = mkTerm "pollen_N" ;
lin pollinate_V2 = mkTerm "pollinate_V2" ;
lin pollination_N = mkTerm "pollination_N" ;
lin pollinator_N = mkTerm "pollinator_N" ;
lin polling_booth_N = mkTerm "polling_booth_N" ;
lin polling_day_N = mkTerm "polling_day_N" ;
lin polling_station_N = mkTerm "polling_station_N" ;
lin pollinium_N = mkTerm "pollinium_N" ;
lin pollster_N = mkTerm "pollster_N" ;
lin pollucite_N = mkTerm "pollucite_N" ;
lin pollutant_N = mkTerm "pollutant_N" ;
lin pollute_V2 = mkTerm "pollute_V2" ;
lin polluter_N = mkTerm "polluter_N" ;
lin pollution_N = mkTerm "pollution_N" ;
lin polly_PN = mkTerm "polly_PN" ;
lin polo_N = mkTerm "polo_N" ;
lin polo_neck_A = mkTerm "polo_neck_A" ;
lin polonaise_N = mkTerm "polonaise_N" ;
lin polonium_N = mkTerm "polonium_N" ;
lin polony_N = mkTerm "polony_N" ;
lin poltergeist_N = mkTerm "poltergeist_N" ;
lin poltroon_A = mkTerm "poltroon_A" ;
lin poltroon_N = mkTerm "poltroon_N" ;
lin poltroonery_N = mkTerm "poltroonery_N" ;
lin polvijärvi_PN = mkTerm "polvijärvi_PN" ;
lin poly_N = mkTerm "poly_N" ;
lin polyamide_N = mkTerm "polyamide_N" ;
lin polyandrist_N = mkTerm "polyandrist_N" ;
lin polyandrous_A = mkTerm "polyandrous_A" ;
lin polyandry_N = mkTerm "polyandry_N" ;
lin polyanthus_N = mkTerm "polyanthus_N" ;
lin polyarteritis_N = mkTerm "polyarteritis_N" ;
lin polyatomic_A = mkTerm "polyatomic_A" ;
lin polybutylene_N = mkTerm "polybutylene_N" ;
lin polychaete_N = mkTerm "polychaete_N" ;
lin polychromatic_A = mkTerm "polychromatic_A" ;
lin polychrome_N = mkTerm "polychrome_N" ;
lin polycrystalline_A = mkTerm "polycrystalline_A" ;
lin polycythemia_N = mkTerm "polycythemia_N" ;
lin polydactyl_A = mkTerm "polydactyl_A" ;
lin polydactyly_N = mkTerm "polydactyly_N" ;
lin polydipsia_N = mkTerm "polydipsia_N" ;
lin polyelectrolyte_N = mkTerm "polyelectrolyte_N" ;
lin polyester_N = mkTerm "polyester_N" ;
lin polyestrous_A = mkTerm "polyestrous_A" ;
lin polyethylene_N = mkTerm "polyethylene_N" ;
lin polyfoam_N = mkTerm "polyfoam_N" ;
lin polygamist_N = mkTerm "polygamist_N" ;
lin polygamous_A = mkTerm "polygamous_A" ;
lin polygamy_N = mkTerm "polygamy_N" ;
lin polygene_N = mkTerm "polygene_N" ;
lin polygenic_A = mkTerm "polygenic_A" ;
lin polyglotFem_N = mkTerm "polyglotFem_N" ;
lin polyglotMasc_N = mkTerm "polyglotMasc_N" ;
lin polyglot_A = mkTerm "polyglot_A" ;
lin polygon_N = mkTerm "polygon_N" ;
lin polygonal_A = mkTerm "polygonal_A" ;
lin polygraph_N = mkTerm "polygraph_N" ;
lin polygynist_N = mkTerm "polygynist_N" ;
lin polygynous_A = mkTerm "polygynous_A" ;
lin polygyny_N = mkTerm "polygyny_N" ;
lin polyhedral_A = mkTerm "polyhedral_A" ;
lin polyhedron_N = mkTerm "polyhedron_N" ;
lin polymastigote_N = mkTerm "polymastigote_N" ;
lin polymath_N = mkTerm "polymath_N" ;
lin polymer_N = mkTerm "polymer_N" ;
lin polymerase_N = mkTerm "polymerase_N" ;
lin polymeric_A = mkTerm "polymeric_A" ;
lin polymerization_N = mkTerm "polymerization_N" ;
lin polymorph_N = mkTerm "polymorph_N" ;
lin polymorphemic_A = mkTerm "polymorphemic_A" ;
lin polymorphic_A = mkTerm "polymorphic_A" ;
lin polymorphism_N = mkTerm "polymorphism_N" ;
lin polymorphous_A = mkTerm "polymorphous_A" ;
lin polymyositis_N = mkTerm "polymyositis_N" ;
lin polymyxin_N = mkTerm "polymyxin_N" ;
lin polyneuritis_N = mkTerm "polyneuritis_N" ;
lin polynomial_A = mkTerm "polynomial_A" ;
lin polynomial_N = mkTerm "polynomial_N" ;
lin polynya_N = mkTerm "polynya_N" ;
lin polyoma_N = mkTerm "polyoma_N" ;
lin polyp_N = mkTerm "polyp_N" ;
lin polypectomy_N = mkTerm "polypectomy_N" ;
lin polypeptide_N = mkTerm "polypeptide_N" ;
lin polypetalous_A = mkTerm "polypetalous_A" ;
lin polyphone_N = mkTerm "polyphone_N" ;
lin polyphonic_A = mkTerm "polyphonic_A" ;
lin polyphony_N = mkTerm "polyphony_N" ;
lin polyphosphate_N = mkTerm "polyphosphate_N" ;
lin polyploid_A = mkTerm "polyploid_A" ;
lin polyploid_N = mkTerm "polyploid_N" ;
lin polyploidy_N = mkTerm "polyploidy_N" ;
lin polypody_N = mkTerm "polypody_N" ;
lin polypore_N = mkTerm "polypore_N" ;
lin polypropenonitrile_N = mkTerm "polypropenonitrile_N" ;
lin polypropylene_N = mkTerm "polypropylene_N" ;
lin polyptoton_N = mkTerm "polyptoton_N" ;
lin polypus_N = mkTerm "polypus_N" ;
lin polysaccharide_N = mkTerm "polysaccharide_N" ;
lin polysemant_N = mkTerm "polysemant_N" ;
lin polysemous_A = mkTerm "polysemous_A" ;
lin polysemy_N = mkTerm "polysemy_N" ;
lin polysomy_N = mkTerm "polysomy_N" ;
lin polystyrene_N = mkTerm "polystyrene_N" ;
lin polysyllabic_A = mkTerm "polysyllabic_A" ;
lin polysyllable_N = mkTerm "polysyllable_N" ;
lin polysyndeton_N = mkTerm "polysyndeton_N" ;
lin polytechnic_N = mkTerm "polytechnic_N" ;
lin polytheism_N = mkTerm "polytheism_N" ;
lin polytheist_N = mkTerm "polytheist_N" ;
lin polytheistic_A = mkTerm "polytheistic_A" ;
lin polythene_N = mkTerm "polythene_N" ;
lin polytonal_A = mkTerm "polytonal_A" ;
lin polytonality_N = mkTerm "polytonality_N" ;
lin polyunsaturated_A = mkTerm "polyunsaturated_A" ;
lin polyurethane_N = mkTerm "polyurethane_N" ;
lin polyuria_N = mkTerm "polyuria_N" ;
lin polyvalence_N = mkTerm "polyvalence_N" ;
lin polyvalent_A = mkTerm "polyvalent_A" ;
lin pom_N = mkTerm "pom_N" ;
lin pomade_N = mkTerm "pomade_N" ;
lin pomade_V2 = mkTerm "pomade_V2" ;
lin pomarkku_PN = mkTerm "pomarkku_PN" ;
lin pome_N = mkTerm "pome_N" ;
lin pomegranate_N = mkTerm "pomegranate_N" ;
lin pomelo_N = mkTerm "pomelo_N" ;
lin pomfret_N = mkTerm "pomfret_N" ;
lin pommel_N = mkTerm "pommel_N" ;
lin pommel_V2 = mkTerm "pommel_V2" ;
lin pommy_N = mkTerm "pommy_N" ;
lin pomologist_N = mkTerm "pomologist_N" ;
lin pomology_N = mkTerm "pomology_N" ;
lin pomp_N = mkTerm "pomp_N" ;
lin pompadour_N = mkTerm "pompadour_N" ;
lin pompano_N = mkTerm "pompano_N" ;
lin pompon_N = mkTerm "pompon_N" ;
lin pomposity_N = mkTerm "pomposity_N" ;
lin pompous_A = mkTerm "pompous_A" ;
lin ponce_N = mkTerm "ponce_N" ;
lin poncho_N = mkTerm "poncho_N" ;
lin pond_N = mkTerm "pond_N" ;
lin ponder_V = mkTerm "ponder_V" ;
lin ponder_V2 = mkTerm "ponder_V2" ;
lin ponderable_A = mkTerm "ponderable_A" ;
lin ponderosa_N = mkTerm "ponderosa_N" ;
lin ponderous_A = mkTerm "ponderous_A" ;
lin ponderousness_N = mkTerm "ponderousness_N" ;
lin pondweed_N = mkTerm "pondweed_N" ;
lin pone_N = mkTerm "pone_N" ;
lin pongee_N = mkTerm "pongee_N" ;
lin poniard_N = mkTerm "poniard_N" ;
lin poniard_V2 = mkTerm "poniard_V2" ;
lin pons_N = mkTerm "pons_N" ;
lin pont_llan_fraith_PN = mkTerm "pont_llan_fraith_PN" ;
lin pontardawe_PN = mkTerm "pontardawe_PN" ;
lin pontardulais_PN = mkTerm "pontardulais_PN" ;
lin pontefract_PN = mkTerm "pontefract_PN" ;
lin pontifex_N = mkTerm "pontifex_N" ;
lin pontiff_N = mkTerm "pontiff_N" ;
lin pontifical_A = mkTerm "pontifical_A" ;
lin pontifical_N = mkTerm "pontifical_N" ;
lin pontificate_N = mkTerm "pontificate_N" ;
lin pontificate_V = mkTerm "pontificate_V" ;
lin pontoon_N = mkTerm "pontoon_N" ;
lin pontycymmer_PN = mkTerm "pontycymmer_PN" ;
lin pontypool_PN = mkTerm "pontypool_PN" ;
lin pony_N = mkTerm "pony_N" ;
lin pony_trekking_N = mkTerm "pony_trekking_N" ;
lin pony_up_V2 = mkTerm "pony_up_V2" ;
lin ponytail_N = mkTerm "ponytail_N" ;
lin pooch_N = mkTerm "pooch_N" ;
lin pood_N = mkTerm "pood_N" ;
lin poodle_N = mkTerm "poodle_N" ;
lin poof_N = mkTerm "poof_N" ;
lin pooh_pooh_V2 = mkTerm "pooh_pooh_V2" ;
lin pool_N = mkTerm "pool_N" ;
lin pool_V2 = mkTerm "pool_V2" ;
lin poole_PN = mkTerm "poole_PN" ;
lin pooler_N = mkTerm "pooler_N" ;
lin poolroom_N = mkTerm "poolroom_N" ;
lin poon_N = mkTerm "poon_N" ;
lin poona_PN = mkTerm "poona_PN" ;
lin poop_N = mkTerm "poop_N" ;
lin poop_out_V = mkTerm "poop_out_V" ;
lin poop_out_on_V2 = mkTerm "poop_out_on_V2" ;
lin poor_1_A = mkTerm "poor_1_A" ;
lin poor_2_A = mkTerm "poor_2_A" ;
lin poor_3_A = mkTerm "poor_3_A" ;
lin poor_box_N = mkTerm "poor_box_N" ;
lin poor_rate_N = mkTerm "poor_rate_N" ;
lin poor_spirited_A = mkTerm "poor_spirited_A" ;
lin poorhouse_N = mkTerm "poorhouse_N" ;
lin poorly_A = mkTerm "poorly_A" ;
lin poorness_N = mkTerm "poorness_N" ;
lin poorwill_N = mkTerm "poorwill_N" ;
lin pootle_along_V = mkTerm "pootle_along_V" ;
lin pop_A = mkTerm "pop_A" ;
lin pop_Adv = mkTerm "pop_Adv" ;
lin pop_N = mkTerm "pop_N" ;
lin pop_V2 = mkTerm "pop_V2" ;
lin pop_in_V = mkTerm "pop_in_V" ;
lin pop_off_V = mkTerm "pop_off_V" ;
lin pop_out_V = mkTerm "pop_out_V" ;
lin pop_up_V = mkTerm "pop_up_V" ;
lin popcorn_N = mkTerm "popcorn_N" ;
lin pope_N = mkTerm "pope_N" ;
lin popery_N = mkTerm "popery_N" ;
lin popeyed_A = mkTerm "popeyed_A" ;
lin popgun_N = mkTerm "popgun_N" ;
lin popinjay_N = mkTerm "popinjay_N" ;
lin popish_A = mkTerm "popish_A" ;
lin poplar_N = mkTerm "poplar_N" ;
lin poplin_N = mkTerm "poplin_N" ;
lin popliteal_A = mkTerm "popliteal_A" ;
lin popover_N = mkTerm "popover_N" ;
lin poppa_N = mkTerm "poppa_N" ;
lin popper_N = mkTerm "popper_N" ;
lin poppet_N = mkTerm "poppet_N" ;
lin poppy_N = mkTerm "poppy_N" ;
lin poppycock_N = mkTerm "poppycock_N" ;
lin populace_N = mkTerm "populace_N" ;
lin popular_A = mkTerm "popular_A" ;
lin popularism_N = mkTerm "popularism_N" ;
lin popularity_N = mkTerm "popularity_N" ;
lin popularization_N = mkTerm "popularization_N" ;
lin popularize_V2 = mkTerm "popularize_V2" ;
lin popularizer_N = mkTerm "popularizer_N" ;
lin populate_V2 = mkTerm "populate_V2" ;
lin population_N = mkTerm "population_N" ;
lin populism_N = mkTerm "populism_N" ;
lin populist_N = mkTerm "populist_N" ;
lin populous_A = mkTerm "populous_A" ;
lin porbeagle_N = mkTerm "porbeagle_N" ;
lin porcelain_N = mkTerm "porcelain_N" ;
lin porch_N = mkTerm "porch_N" ;
lin porcine_A = mkTerm "porcine_A" ;
lin porcupine_N = mkTerm "porcupine_N" ;
lin porcupinefish_N = mkTerm "porcupinefish_N" ;
lin pore_N = mkTerm "pore_N" ;
lin pore_V = mkTerm "pore_V" ;
lin pore_over_V2 = mkTerm "pore_over_V2" ;
lin porgy_N = mkTerm "porgy_N" ;
lin pori_PN = mkTerm "pori_PN" ;
lin pork_N = mkTerm "pork_N" ;
lin pork_barrel_N = mkTerm "pork_barrel_N" ;
lin pork_butcher_N = mkTerm "pork_butcher_N" ;
lin porkchop_N = mkTerm "porkchop_N" ;
lin porker_N = mkTerm "porker_N" ;
lin porkfish_N = mkTerm "porkfish_N" ;
lin porkholt_N = mkTerm "porkholt_N" ;
lin porkpie_N = mkTerm "porkpie_N" ;
lin porn_N = mkTerm "porn_N" ;
lin pornainen_PN = mkTerm "pornainen_PN" ;
lin pornographer_N = mkTerm "pornographer_N" ;
lin pornographic_A = mkTerm "pornographic_A" ;
lin pornography_N = mkTerm "pornography_N" ;
lin porose_A = mkTerm "porose_A" ;
lin porosity_N = mkTerm "porosity_N" ;
lin porous_A = mkTerm "porous_A" ;
lin porousness_N = mkTerm "porousness_N" ;
lin porphyria_N = mkTerm "porphyria_N" ;
lin porphyrin_N = mkTerm "porphyrin_N" ;
lin porphyritic_A = mkTerm "porphyritic_A" ;
lin porphyry_N = mkTerm "porphyry_N" ;
lin porpoise_N = mkTerm "porpoise_N" ;
lin porridge_N = mkTerm "porridge_N" ;
lin porringer_N = mkTerm "porringer_N" ;
lin port_A = mkTerm "port_A" ;
lin port_N = mkTerm "port_N" ;
lin port_V2 = mkTerm "port_V2" ;
lin port_glasgow_PN = mkTerm "port_glasgow_PN" ;
lin port_talbot_PN = mkTerm "port_talbot_PN" ;
lin portability_N = mkTerm "portability_N" ;
lin portable_A = mkTerm "portable_A" ;
lin portable_N = mkTerm "portable_N" ;
lin portage_N = mkTerm "portage_N" ;
lin portal_N = mkTerm "portal_N" ;
lin portcullis_N = mkTerm "portcullis_N" ;
lin porte_cochere_N = mkTerm "porte_cochere_N" ;
lin portend_V2 = mkTerm "portend_V2" ;
lin portent_N = mkTerm "portent_N" ;
lin portentous_A = mkTerm "portentous_A" ;
lin porter_N = mkTerm "porter_N" ;
lin porterage_N = mkTerm "porterage_N" ;
lin porterhouse_N = mkTerm "porterhouse_N" ;
lin portfolio_N = mkTerm "portfolio_N" ;
lin porthcawl_PN = mkTerm "porthcawl_PN" ;
lin porthmadog_PN = mkTerm "porthmadog_PN" ;
lin porthole_N = mkTerm "porthole_N" ;
lin portico_N = mkTerm "portico_N" ;
lin portiere_N = mkTerm "portiere_N" ;
lin portion_N = mkTerm "portion_N" ;
lin portion_V2 = mkTerm "portion_V2" ;
lin portishead_PN = mkTerm "portishead_PN" ;
lin portland_PN = mkTerm "portland_PN" ;
lin portly_A = mkTerm "portly_A" ;
lin portmanteau_N = mkTerm "portmanteau_N" ;
lin porto_alegre_PN = mkTerm "porto_alegre_PN" ;
lin portrait_N = mkTerm "portrait_N" ;
lin portraitist_N = mkTerm "portraitist_N" ;
lin portraiture_N = mkTerm "portraiture_N" ;
lin portray_V2 = mkTerm "portray_V2" ;
lin portrayal_N = mkTerm "portrayal_N" ;
lin portsmouth_PN = mkTerm "portsmouth_PN" ;
lin portugal_PN = mkTerm "portugal_PN" ;
lin portuguese_A = mkTerm "portuguese_A" ;
lin portuguese_N = mkTerm "portuguese_N" ;
lin portulaca_N = mkTerm "portulaca_N" ;
lin portwatcher_N = mkTerm "portwatcher_N" ;
lin porvoo_PN = mkTerm "porvoo_PN" ;
lin pose_N = mkTerm "pose_N" ;
lin pose_V = mkTerm "pose_V" ;
lin pose_V2 = mkTerm "pose_V2" ;
lin poser_N = mkTerm "poser_N" ;
lin poseur_N = mkTerm "poseur_N" ;
lin poseuse_N = mkTerm "poseuse_N" ;
lin posh_A = mkTerm "posh_A" ;
lin posh_V2 = mkTerm "posh_V2" ;
lin posio_PN = mkTerm "posio_PN" ;
lin posit_V2 = mkTerm "posit_V2" ;
lin position_N = mkTerm "position_N" ;
lin position_V2 = mkTerm "position_V2" ;
lin positionable_A = mkTerm "positionable_A" ;
lin positional_A = mkTerm "positional_A" ;
lin positive_A = mkTerm "positive_A" ;
lin positive_N = mkTerm "positive_N" ;
lin positiveness_N = mkTerm "positiveness_N" ;
lin positivism_N = mkTerm "positivism_N" ;
lin positivist_A = mkTerm "positivist_A" ;
lin positivist_N = mkTerm "positivist_N" ;
lin positivity_N = mkTerm "positivity_N" ;
lin positron_N = mkTerm "positron_N" ;
lin posology_N = mkTerm "posology_N" ;
lin posse_N = mkTerm "posse_N" ;
lin posseman_N = mkTerm "posseman_N" ;
lin possess_V2 = mkTerm "possess_V2" ;
lin possession_N = mkTerm "possession_N" ;
lin possessive_A = mkTerm "possessive_A" ;
lin possessiveness_N = mkTerm "possessiveness_N" ;
lin possessor_N = mkTerm "possessor_N" ;
lin posset_N = mkTerm "posset_N" ;
lin possibility_N = mkTerm "possibility_N" ;
lin possible_A = mkTerm "possible_A" ;
lin possible_N = mkTerm "possible_N" ;
lin possum_N = mkTerm "possum_N" ;
lin post_N = mkTerm "post_N" ;
lin post_Prep = mkTerm "post_Prep" ;
lin post_V = mkTerm "post_V" ;
lin post_V2 = mkTerm "post_V2" ;
lin post_chaise_N = mkTerm "post_chaise_N" ;
lin post_free_A = mkTerm "post_free_A" ;
lin post_free_Adv = mkTerm "post_free_Adv" ;
lin post_haste_Adv = mkTerm "post_haste_Adv" ;
lin post_horse_N = mkTerm "post_horse_N" ;
lin post_meridiem_Adv = mkTerm "post_meridiem_Adv" ;
lin post_mortem_A = mkTerm "post_mortem_A" ;
lin post_mortem_N = mkTerm "post_mortem_N" ;
lin post_paid_A = mkTerm "post_paid_A" ;
lin post_paid_Adv = mkTerm "post_paid_Adv" ;
lin post_war_A = mkTerm "post_war_A" ;
lin postage_N = mkTerm "postage_N" ;
lin postage_stamp_N = mkTerm "postage_stamp_N" ;
lin postal_A = mkTerm "postal_A" ;
lin postbag_N = mkTerm "postbag_N" ;
lin postbiblical_A = mkTerm "postbiblical_A" ;
lin postbox_N = mkTerm "postbox_N" ;
lin postcard_N = mkTerm "postcard_N" ;
lin postcode_N = mkTerm "postcode_N" ;
lin postdate_V2 = mkTerm "postdate_V2" ;
lin postdiluvian_A = mkTerm "postdiluvian_A" ;
lin postdiluvian_N = mkTerm "postdiluvian_N" ;
lin postdoc_N = mkTerm "postdoc_N" ;
lin postdoctoral_A = mkTerm "postdoctoral_A" ;
lin postdoctoral_N = mkTerm "postdoctoral_N" ;
lin poste_restante_N = mkTerm "poste_restante_N" ;
lin poster_N = mkTerm "poster_N" ;
lin posterior_A = mkTerm "posterior_A" ;
lin posterior_N = mkTerm "posterior_N" ;
lin posteriority_N = mkTerm "posteriority_N" ;
lin posterity_N = mkTerm "posterity_N" ;
lin postern_N = mkTerm "postern_N" ;
lin postexilic_A = mkTerm "postexilic_A" ;
lin postganglionic_A = mkTerm "postganglionic_A" ;
lin postglacial_A = mkTerm "postglacial_A" ;
lin postgraduate_A = mkTerm "postgraduate_A" ;
lin postgraduate_N = mkTerm "postgraduate_N" ;
lin posthitis_N = mkTerm "posthitis_N" ;
lin posthole_N = mkTerm "posthole_N" ;
lin posthouse_N = mkTerm "posthouse_N" ;
lin posthumous_A = mkTerm "posthumous_A" ;
lin postictal_A = mkTerm "postictal_A" ;
lin postilion_N = mkTerm "postilion_N" ;
lin postillion_N = mkTerm "postillion_N" ;
lin postindustrial_A = mkTerm "postindustrial_A" ;
lin posting_N = mkTerm "posting_N" ;
lin postlude_N = mkTerm "postlude_N" ;
lin postman_N = mkTerm "postman_N" ;
lin postmark_N = mkTerm "postmark_N" ;
lin postmark_V2 = mkTerm "postmark_V2" ;
lin postmaster_N = mkTerm "postmaster_N" ;
lin postmenopausal_A = mkTerm "postmenopausal_A" ;
lin postmeridian_A = mkTerm "postmeridian_A" ;
lin postmillennial_A = mkTerm "postmillennial_A" ;
lin postmistress_N = mkTerm "postmistress_N" ;
lin postmodernism_N = mkTerm "postmodernism_N" ;
lin postmodernist_A = mkTerm "postmodernist_A" ;
lin postmortem_A = mkTerm "postmortem_A" ;
lin postmortem_N = mkTerm "postmortem_N" ;
lin postnatal_A = mkTerm "postnatal_A" ;
lin postnuptial_A = mkTerm "postnuptial_A" ;
lin postoperative_A = mkTerm "postoperative_A" ;
lin postpaid_A = mkTerm "postpaid_A" ;
lin postpone_V2 = mkTerm "postpone_V2" ;
lin postponement_N = mkTerm "postponement_N" ;
lin postposition_N = mkTerm "postposition_N" ;
lin postpositive_A = mkTerm "postpositive_A" ;
lin postprandial_A = mkTerm "postprandial_A" ;
lin postscript_N = mkTerm "postscript_N" ;
lin postseason_N = mkTerm "postseason_N" ;
lin postulant_N = mkTerm "postulant_N" ;
lin postulate_N = mkTerm "postulate_N" ;
lin postulate_V2 = mkTerm "postulate_V2" ;
lin postulation_N = mkTerm "postulation_N" ;
lin postulator_N = mkTerm "postulator_N" ;
lin postural_A = mkTerm "postural_A" ;
lin posture_N = mkTerm "posture_N" ;
lin posture_V = mkTerm "posture_V" ;
lin posture_V2 = mkTerm "posture_V2" ;
lin posturer_N = mkTerm "posturer_N" ;
lin posturing_N = mkTerm "posturing_N" ;
lin posy_N = mkTerm "posy_N" ;
lin pot_N = mkTerm "pot_N" ;
lin pot_V = mkTerm "pot_V" ;
lin pot_V2 = mkTerm "pot_V2" ;
lin pot_shot_N = mkTerm "pot_shot_N" ;
lin pot_trained_A = mkTerm "pot_trained_A" ;
lin potable_A = mkTerm "potable_A" ;
lin potage_N = mkTerm "potage_N" ;
lin potash_N = mkTerm "potash_N" ;
lin potassium_N = mkTerm "potassium_N" ;
lin potation_N = mkTerm "potation_N" ;
lin potato_N = mkTerm "potato_N" ;
lin potbellied_A = mkTerm "potbellied_A" ;
lin potbelly_N = mkTerm "potbelly_N" ;
lin potboiler_N = mkTerm "potboiler_N" ;
lin potbound_A = mkTerm "potbound_A" ;
lin potboy_N = mkTerm "potboy_N" ;
lin poteen_N = mkTerm "poteen_N" ;
lin potency_N = mkTerm "potency_N" ;
lin potent_A = mkTerm "potent_A" ;
lin potentate_N = mkTerm "potentate_N" ;
lin potential_A = mkTerm "potential_A" ;
lin potential_N = mkTerm "potential_N" ;
lin potentiality_N = mkTerm "potentiality_N" ;
lin potentiation_N = mkTerm "potentiation_N" ;
lin potentiometer_N = mkTerm "potentiometer_N" ;
lin pothead_N = mkTerm "pothead_N" ;
lin pother_N = mkTerm "pother_N" ;
lin potherb_N = mkTerm "potherb_N" ;
lin potholder_N = mkTerm "potholder_N" ;
lin pothole_N = mkTerm "pothole_N" ;
lin potholer_N = mkTerm "potholer_N" ;
lin pothook_N = mkTerm "pothook_N" ;
lin pothos_N = mkTerm "pothos_N" ;
lin pothouse_N = mkTerm "pothouse_N" ;
lin pothunter_N = mkTerm "pothunter_N" ;
lin potion_N = mkTerm "potion_N" ;
lin potlatch_N = mkTerm "potlatch_N" ;
lin potluck_N = mkTerm "potluck_N" ;
lin potman_N = mkTerm "potman_N" ;
lin potoroo_N = mkTerm "potoroo_N" ;
lin potpie_N = mkTerm "potpie_N" ;
lin potpourri_N = mkTerm "potpourri_N" ;
lin potsdam_PN = mkTerm "potsdam_PN" ;
lin potsherd_N = mkTerm "potsherd_N" ;
lin pottage_N = mkTerm "pottage_N" ;
lin potter_N = mkTerm "potter_N" ;
lin potter_V = mkTerm "potter_V" ;
lin potter_about_V = mkTerm "potter_about_V" ;
lin potter_around_V = mkTerm "potter_around_V" ;
lin potterer_N = mkTerm "potterer_N" ;
lin potters_bar_PN = mkTerm "potters_bar_PN" ;
lin pottery_N = mkTerm "pottery_N" ;
lin pottle_N = mkTerm "pottle_N" ;
lin potto_N = mkTerm "potto_N" ;
lin potty_A = mkTerm "potty_A" ;
lin potty_N = mkTerm "potty_N" ;
lin pouch_N = mkTerm "pouch_N" ;
lin pouch_V2 = mkTerm "pouch_V2" ;
lin pouf_N = mkTerm "pouf_N" ;
lin pouffe_N = mkTerm "pouffe_N" ;
lin poulette_N = mkTerm "poulette_N" ;
lin poulterer_N = mkTerm "poulterer_N" ;
lin poultice_N = mkTerm "poultice_N" ;
lin poultice_V2 = mkTerm "poultice_V2" ;
lin poultry_N = mkTerm "poultry_N" ;
lin poultryman_N = mkTerm "poultryman_N" ;
lin pounce_N = mkTerm "pounce_N" ;
lin pounce_V = mkTerm "pounce_V" ;
lin pound_1_N = mkTerm "pound_1_N" ;
lin pound_2_N = mkTerm "pound_2_N" ;
lin pound_V = mkTerm "pound_V" ;
lin pound_V2 = mkTerm "pound_V2" ;
lin poundage_N = mkTerm "poundage_N" ;
lin poundal_N = mkTerm "poundal_N" ;
lin pounder_N = mkTerm "pounder_N" ;
lin pounding_N = mkTerm "pounding_N" ;
lin pour_V = mkTerm "pour_V" ;
lin pour_V2 = mkTerm "pour_V2" ;
lin pour_down_V = mkTerm "pour_down_V" ;
lin pour_forth_V = mkTerm "pour_forth_V" ;
lin pour_in_V2 = mkTerm "pour_in_V2" ;
lin pour_out_V = mkTerm "pour_out_V" ;
lin pout_N = mkTerm "pout_N" ;
lin pout_V = mkTerm "pout_V" ;
lin pout_V2 = mkTerm "pout_V2" ;
lin poutingly_Adv = mkTerm "poutingly_Adv" ;
lin poverty_N = mkTerm "poverty_N" ;
lin poverty_stricken_A = mkTerm "poverty_stricken_A" ;
lin pow_N = mkTerm "pow_N" ;
lin powder_N = mkTerm "powder_N" ;
lin powder_V = mkTerm "powder_V" ;
lin powder_V2 = mkTerm "powder_V2" ;
lin powder_flask_N = mkTerm "powder_flask_N" ;
lin powder_horn_N = mkTerm "powder_horn_N" ;
lin powder_magazine_N = mkTerm "powder_magazine_N" ;
lin powder_puff_N = mkTerm "powder_puff_N" ;
lin powder_room_N = mkTerm "powder_room_N" ;
lin powderer_N = mkTerm "powderer_N" ;
lin powderpuff_N = mkTerm "powderpuff_N" ;
lin powdery_A = mkTerm "powdery_A" ;
lin power_N = mkTerm "power_N" ;
lin power_V2 = mkTerm "power_V2" ;
lin power_dive_N = mkTerm "power_dive_N" ;
lin power_dive_V2 = mkTerm "power_dive_V2" ;
lin power_down_V2 = mkTerm "power_down_V2" ;
lin power_off_V2 = mkTerm "power_off_V2" ;
lin power_point_N = mkTerm "power_point_N" ;
lin power_station_N = mkTerm "power_station_N" ;
lin power_up_V2 = mkTerm "power_up_V2" ;
lin powerboat_N = mkTerm "powerboat_N" ;
lin powerful_A = mkTerm "powerful_A" ;
lin powerhouse_N = mkTerm "powerhouse_N" ;
lin powerless_A = mkTerm "powerless_A" ;
lin powerlessness_N = mkTerm "powerlessness_N" ;
lin powwow_N = mkTerm "powwow_N" ;
lin powwow_V = mkTerm "powwow_V" ;
lin powys_PN = mkTerm "powys_PN" ;
lin pox_N = mkTerm "pox_N" ;
lin poxvirus_N = mkTerm "poxvirus_N" ;
lin poynton_PN = mkTerm "poynton_PN" ;
lin poznan_PN = mkTerm "poznan_PN" ;
lin pp_N = mkTerm "pp_N" ;
lin pr_N = mkTerm "pr_N" ;
lin practicability_N = mkTerm "practicability_N" ;
lin practicable_A = mkTerm "practicable_A" ;
lin practical_A = mkTerm "practical_A" ;
lin practical_N = mkTerm "practical_N" ;
lin practicality_N = mkTerm "practicality_N" ;
lin practice_N = mkTerm "practice_N" ;
lin practice_V = mkTerm "practice_V" ;
lin practice_V2 = mkTerm "practice_V2" ;
lin practician_N = mkTerm "practician_N" ;
lin practise_V = mkTerm "practise_V" ;
lin practise_V2 = mkTerm "practise_V2" ;
lin practitionerFem_N = mkTerm "practitionerFem_N" ;
lin practitionerMasc_N = mkTerm "practitionerMasc_N" ;
lin praenomen_N = mkTerm "praenomen_N" ;
lin praesidium_N = mkTerm "praesidium_N" ;
lin praetor_N = mkTerm "praetor_N" ;
lin praetorian_A = mkTerm "praetorian_A" ;
lin praetorium_N = mkTerm "praetorium_N" ;
lin praetorship_N = mkTerm "praetorship_N" ;
lin pragmatic_A = mkTerm "pragmatic_A" ;
lin pragmatics_N = mkTerm "pragmatics_N" ;
lin pragmatism_N = mkTerm "pragmatism_N" ;
lin pragmatist_N = mkTerm "pragmatist_N" ;
lin prague_PN = mkTerm "prague_PN" ;
lin prairie_N = mkTerm "prairie_N" ;
lin praise_N = mkTerm "praise_N" ;
lin praise_V2 = mkTerm "praise_V2" ;
lin praiseworthiness_N = mkTerm "praiseworthiness_N" ;
lin praiseworthy_A = mkTerm "praiseworthy_A" ;
lin praisworthiness_N = mkTerm "praisworthiness_N" ;
lin praline_N = mkTerm "praline_N" ;
lin pram_N = mkTerm "pram_N" ;
lin prance_N = mkTerm "prance_N" ;
lin prance_V = mkTerm "prance_V" ;
lin prancer_N = mkTerm "prancer_N" ;
lin prandial_A = mkTerm "prandial_A" ;
lin prang_N = mkTerm "prang_N" ;
lin prank_N = mkTerm "prank_N" ;
lin prankishness_N = mkTerm "prankishness_N" ;
lin prankster_N = mkTerm "prankster_N" ;
lin praseodymium_N = mkTerm "praseodymium_N" ;
lin prate_N = mkTerm "prate_N" ;
lin prate_V = mkTerm "prate_V" ;
lin pratfall_N = mkTerm "pratfall_N" ;
lin pratincole_N = mkTerm "pratincole_N" ;
lin prato_PN = mkTerm "prato_PN" ;
lin prattle_N = mkTerm "prattle_N" ;
lin prattle_V = mkTerm "prattle_V" ;
lin prattle_on_V = mkTerm "prattle_on_V" ;
lin prattler_N = mkTerm "prattler_N" ;
lin pravastatin_N = mkTerm "pravastatin_N" ;
lin prawn_N = mkTerm "prawn_N" ;
lin prawn_V = mkTerm "prawn_V" ;
lin pray_V = mkTerm "pray_V" ;
lin pray_V2 = mkTerm "pray_V2" ;
lin praya_N = mkTerm "praya_N" ;
lin prayer_N = mkTerm "prayer_N" ;
lin prayer_book_N = mkTerm "prayer_book_N" ;
lin prayer_mat_N = mkTerm "prayer_mat_N" ;
lin prayer_meeting_N = mkTerm "prayer_meeting_N" ;
lin prayer_rug_N = mkTerm "prayer_rug_N" ;
lin prayer_wheel_N = mkTerm "prayer_wheel_N" ;
lin prayerful_A = mkTerm "prayerful_A" ;
lin prazosin_N = mkTerm "prazosin_N" ;
lin pre_approve_V2 = mkTerm "pre_approve_V2" ;
lin pre_eminence_N = mkTerm "pre_eminence_N" ;
lin pre_eminent_A = mkTerm "pre_eminent_A" ;
lin pre_empt_V2 = mkTerm "pre_empt_V2" ;
lin pre_emption_N = mkTerm "pre_emption_N" ;
lin pre_emptive_A = mkTerm "pre_emptive_A" ;
lin pre_exist_V = mkTerm "pre_exist_V" ;
lin pre_existence_N = mkTerm "pre_existence_N" ;
lin pre_existent_A = mkTerm "pre_existent_A" ;
lin pre_packaged_A = mkTerm "pre_packaged_A" ;
lin pre_raphaelite_A = mkTerm "pre_raphaelite_A" ;
lin pre_raphaelite_N = mkTerm "pre_raphaelite_N" ;
lin pre_register_V2 = mkTerm "pre_register_V2" ;
lin pre_sign_V2 = mkTerm "pre_sign_V2" ;
lin pre_test_V2 = mkTerm "pre_test_V2" ;
lin preach_V = mkTerm "preach_V" ;
lin preach_V2 = mkTerm "preach_V2" ;
lin preacher_N = mkTerm "preacher_N" ;
lin preachification_N = mkTerm "preachification_N" ;
lin preachify_V = mkTerm "preachify_V" ;
lin preachy_A = mkTerm "preachy_A" ;
lin preamble_N = mkTerm "preamble_N" ;
lin preanal_A = mkTerm "preanal_A" ;
lin prearrange_V2 = mkTerm "prearrange_V2" ;
lin prearrangement_N = mkTerm "prearrangement_N" ;
lin prebend_N = mkTerm "prebend_N" ;
lin prebendary_N = mkTerm "prebendary_N" ;
lin precancerous_A = mkTerm "precancerous_A" ;
lin precarious_A = mkTerm "precarious_A" ;
lin precariousness_N = mkTerm "precariousness_N" ;
lin precast_A = mkTerm "precast_A" ;
lin precatory_A = mkTerm "precatory_A" ;
lin precaution_N = mkTerm "precaution_N" ;
lin precautionary_A = mkTerm "precautionary_A" ;
lin precede_V2 = mkTerm "precede_V2" ;
lin precedence_N = mkTerm "precedence_N" ;
lin precedent_A = mkTerm "precedent_A" ;
lin precedent_N = mkTerm "precedent_N" ;
lin precedented_A = mkTerm "precedented_A" ;
lin precedential_A = mkTerm "precedential_A" ;
lin preceding_A = mkTerm "preceding_A" ;
lin precentor_N = mkTerm "precentor_N" ;
lin precentorship_N = mkTerm "precentorship_N" ;
lin precept_N = mkTerm "precept_N" ;
lin preceptor_N = mkTerm "preceptor_N" ;
lin preceptorship_N = mkTerm "preceptorship_N" ;
lin precession_N = mkTerm "precession_N" ;
lin prechlorination_N = mkTerm "prechlorination_N" ;
lin precinct_N = mkTerm "precinct_N" ;
lin preciosity_N = mkTerm "preciosity_N" ;
lin precious_A = mkTerm "precious_A" ;
lin precious_Adv = mkTerm "precious_Adv" ;
lin preciousness_N = mkTerm "preciousness_N" ;
lin precipice_N = mkTerm "precipice_N" ;
lin precipitant_N = mkTerm "precipitant_N" ;
lin precipitate_A = mkTerm "precipitate_A" ;
lin precipitate_N = mkTerm "precipitate_N" ;
lin precipitate_V2 = mkTerm "precipitate_V2" ;
lin precipitation_N = mkTerm "precipitation_N" ;
lin precipitator_N = mkTerm "precipitator_N" ;
lin precipitin_N = mkTerm "precipitin_N" ;
lin precipitous_A = mkTerm "precipitous_A" ;
lin precis_N = mkTerm "precis_N" ;
lin precis_V2 = mkTerm "precis_V2" ;
lin precise_A = mkTerm "precise_A" ;
lin preciseness_N = mkTerm "preciseness_N" ;
lin precision_N = mkTerm "precision_N" ;
lin preclinical_A = mkTerm "preclinical_A" ;
lin preclude_V2 = mkTerm "preclude_V2" ;
lin preclusion_N = mkTerm "preclusion_N" ;
lin preclusive_A = mkTerm "preclusive_A" ;
lin precocial_A = mkTerm "precocial_A" ;
lin precocious_A = mkTerm "precocious_A" ;
lin precociousness_N = mkTerm "precociousness_N" ;
lin precocity_N = mkTerm "precocity_N" ;
lin precognition_N = mkTerm "precognition_N" ;
lin preconceive_V2 = mkTerm "preconceive_V2" ;
lin preconception_N = mkTerm "preconception_N" ;
lin preconcerted_A = mkTerm "preconcerted_A" ;
lin precondition_N = mkTerm "precondition_N" ;
lin preconditioned_A = mkTerm "preconditioned_A" ;
lin precooked_A = mkTerm "precooked_A" ;
lin precooled_A = mkTerm "precooled_A" ;
lin precordial_A = mkTerm "precordial_A" ;
lin precordium_N = mkTerm "precordium_N" ;
lin precursor_N = mkTerm "precursor_N" ;
lin precursory_A = mkTerm "precursory_A" ;
lin predaceous_A = mkTerm "predaceous_A" ;
lin predacious_A = mkTerm "predacious_A" ;
lin predate_V2 = mkTerm "predate_V2" ;
lin predation_N = mkTerm "predation_N" ;
lin predator_N = mkTerm "predator_N" ;
lin predatory_A = mkTerm "predatory_A" ;
lin predecease_V2 = mkTerm "predecease_V2" ;
lin predecessor_N = mkTerm "predecessor_N" ;
lin predestinarian_A = mkTerm "predestinarian_A" ;
lin predestinarianism_N = mkTerm "predestinarianism_N" ;
lin predestinate_A = mkTerm "predestinate_A" ;
lin predestinate_V2 = mkTerm "predestinate_V2" ;
lin predestination_N = mkTerm "predestination_N" ;
lin predestine_V2 = mkTerm "predestine_V2" ;
lin predetermination_N = mkTerm "predetermination_N" ;
lin predetermine_V2 = mkTerm "predetermine_V2" ;
lin predicament_N = mkTerm "predicament_N" ;
lin predicate_N = mkTerm "predicate_N" ;
lin predicate_V2 = mkTerm "predicate_V2" ;
lin predicative_A = mkTerm "predicative_A" ;
lin predicator_N = mkTerm "predicator_N" ;
lin predict_V2 = mkTerm "predict_V2" ;
lin predict_VS = mkTerm "predict_VS" ;
lin predictability_N = mkTerm "predictability_N" ;
lin predictable_A = mkTerm "predictable_A" ;
lin prediction_N = mkTerm "prediction_N" ;
lin predictive_A = mkTerm "predictive_A" ;
lin predictor_N = mkTerm "predictor_N" ;
lin predigest_V2 = mkTerm "predigest_V2" ;
lin predilection_N = mkTerm "predilection_N" ;
lin predispose_V2 = mkTerm "predispose_V2" ;
lin predisposition_N = mkTerm "predisposition_N" ;
lin prednisolone_N = mkTerm "prednisolone_N" ;
lin prednisone_N = mkTerm "prednisone_N" ;
lin predominance_N = mkTerm "predominance_N" ;
lin predominant_A = mkTerm "predominant_A" ;
lin predominate_V = mkTerm "predominate_V" ;
lin predomination_N = mkTerm "predomination_N" ;
lin preeclampsia_N = mkTerm "preeclampsia_N" ;
lin preemption_N = mkTerm "preemption_N" ;
lin preemptive_A = mkTerm "preemptive_A" ;
lin preemptor_N = mkTerm "preemptor_N" ;
lin preen_V2 = mkTerm "preen_V2" ;
lin preexistent_A = mkTerm "preexistent_A" ;
lin prefab_A = mkTerm "prefab_A" ;
lin prefab_N = mkTerm "prefab_N" ;
lin prefabricate_V2 = mkTerm "prefabricate_V2" ;
lin prefabrication_N = mkTerm "prefabrication_N" ;
lin preface_N = mkTerm "preface_N" ;
lin preface_V2 = mkTerm "preface_V2" ;
lin prefaded_A = mkTerm "prefaded_A" ;
lin prefatory_A = mkTerm "prefatory_A" ;
lin prefect_N = mkTerm "prefect_N" ;
lin prefectural_A = mkTerm "prefectural_A" ;
lin prefecture_N = mkTerm "prefecture_N" ;
lin prefer_V2 = mkTerm "prefer_V2" ;
lin prefer_VV = mkTerm "prefer_VV" ;
lin preferable_A = mkTerm "preferable_A" ;
lin preference_N = mkTerm "preference_N" ;
lin preferential_A = mkTerm "preferential_A" ;
lin preferment_N = mkTerm "preferment_N" ;
lin preferred_A = mkTerm "preferred_A" ;
lin prefiguration_N = mkTerm "prefiguration_N" ;
lin prefigure_V2 = mkTerm "prefigure_V2" ;
lin prefix_N = mkTerm "prefix_N" ;
lin prefix_V2 = mkTerm "prefix_V2" ;
lin prefixation_N = mkTerm "prefixation_N" ;
lin preformation_N = mkTerm "preformation_N" ;
lin prefrontal_A = mkTerm "prefrontal_A" ;
lin pregnancy_N = mkTerm "pregnancy_N" ;
lin pregnanediol_N = mkTerm "pregnanediol_N" ;
lin pregnant_A = mkTerm "pregnant_A" ;
lin preheat_V2 = mkTerm "preheat_V2" ;
lin prehensile_A = mkTerm "prehensile_A" ;
lin prehensor_N = mkTerm "prehensor_N" ;
lin prehistoric_A = mkTerm "prehistoric_A" ;
lin prehistorical_A = mkTerm "prehistorical_A" ;
lin prehistory_N = mkTerm "prehistory_N" ;
lin prejudge_V2 = mkTerm "prejudge_V2" ;
lin prejudgement_N = mkTerm "prejudgement_N" ;
lin prejudgment_N = mkTerm "prejudgment_N" ;
lin prejudice_N = mkTerm "prejudice_N" ;
lin prejudice_V2 = mkTerm "prejudice_V2" ;
lin prejudicial_A = mkTerm "prejudicial_A" ;
lin prelacy_N = mkTerm "prelacy_N" ;
lin prelapsarian_A = mkTerm "prelapsarian_A" ;
lin prelate_N = mkTerm "prelate_N" ;
lin prelim_N = mkTerm "prelim_N" ;
lin preliminary_A = mkTerm "preliminary_A" ;
lin preliminary_N = mkTerm "preliminary_N" ;
lin preliterate_A = mkTerm "preliterate_A" ;
lin prelude_N = mkTerm "prelude_N" ;
lin prelude_V2 = mkTerm "prelude_V2" ;
lin premarital_A = mkTerm "premarital_A" ;
lin premature_A = mkTerm "premature_A" ;
lin prematureness_N = mkTerm "prematureness_N" ;
lin premedical_A = mkTerm "premedical_A" ;
lin premeditate_V2 = mkTerm "premeditate_V2" ;
lin premeditation_N = mkTerm "premeditation_N" ;
lin premenopausal_A = mkTerm "premenopausal_A" ;
lin premenstrual_A = mkTerm "premenstrual_A" ;
lin premier_A = mkTerm "premier_A" ;
lin premier_N = mkTerm "premier_N" ;
lin premiere_N = mkTerm "premiere_N" ;
lin premiere_V = mkTerm "premiere_V" ;
lin premiere_V2 = mkTerm "premiere_V2" ;
lin premiership_N = mkTerm "premiership_N" ;
lin premise_N = mkTerm "premise_N" ;
lin premise_V2 = mkTerm "premise_V2" ;
lin premises_N = mkTerm "premises_N" ;
lin premiss_N = mkTerm "premiss_N" ;
lin premiss_V2 = mkTerm "premiss_V2" ;
lin premium_A = mkTerm "premium_A" ;
lin premium_N = mkTerm "premium_N" ;
lin premolar_N = mkTerm "premolar_N" ;
lin premonition_N = mkTerm "premonition_N" ;
lin premonitory_A = mkTerm "premonitory_A" ;
lin prenatal_A = mkTerm "prenatal_A" ;
lin prentice_N = mkTerm "prentice_N" ;
lin prenuptial_A = mkTerm "prenuptial_A" ;
lin preoccupancy_N = mkTerm "preoccupancy_N" ;
lin preoccupation_N = mkTerm "preoccupation_N" ;
lin preoccupy_V2 = mkTerm "preoccupy_V2" ;
lin preoperative_A = mkTerm "preoperative_A" ;
lin preordain_V2 = mkTerm "preordain_V2" ;
lin prep_N = mkTerm "prep_N" ;
lin prepacked_A = mkTerm "prepacked_A" ;
lin preparation_N = mkTerm "preparation_N" ;
lin preparatory_A = mkTerm "preparatory_A" ;
lin prepare_V = mkTerm "prepare_V" ;
lin prepare_V2 = mkTerm "prepare_V2" ;
lin prepare_V2V = mkTerm "prepare_V2V" ;
lin prepare_VV = mkTerm "prepare_VV" ;
lin prepared_A = mkTerm "prepared_A" ;
lin preparedness_N = mkTerm "preparedness_N" ;
lin prepay_V2 = mkTerm "prepay_V2" ;
lin prepayment_N = mkTerm "prepayment_N" ;
lin preponderance_N = mkTerm "preponderance_N" ;
lin preponderant_A = mkTerm "preponderant_A" ;
lin preponderate_V = mkTerm "preponderate_V" ;
lin preposition_N = mkTerm "preposition_N" ;
lin prepositional_A = mkTerm "prepositional_A" ;
lin prepossess_V2 = mkTerm "prepossess_V2" ;
lin prepossessing_A = mkTerm "prepossessing_A" ;
lin prepossession_N = mkTerm "prepossession_N" ;
lin preposterous_A = mkTerm "preposterous_A" ;
lin preprandial_A = mkTerm "preprandial_A" ;
lin prepuberty_N = mkTerm "prepuberty_N" ;
lin prepubescent_A = mkTerm "prepubescent_A" ;
lin prepuce_N = mkTerm "prepuce_N" ;
lin prepupal_A = mkTerm "prepupal_A" ;
lin prequel_N = mkTerm "prequel_N" ;
lin prerecord_V2 = mkTerm "prerecord_V2" ;
lin prerequisite_A = mkTerm "prerequisite_A" ;
lin prerequisite_N = mkTerm "prerequisite_N" ;
lin prerogative_N = mkTerm "prerogative_N" ;
lin pres_N = mkTerm "pres_N" ;
lin presage_N = mkTerm "presage_N" ;
lin presage_V2 = mkTerm "presage_V2" ;
lin presbyope_N = mkTerm "presbyope_N" ;
lin presbyopia_N = mkTerm "presbyopia_N" ;
lin presbyter_N = mkTerm "presbyter_N" ;
lin presbyterian_A = mkTerm "presbyterian_A" ;
lin presbyterian_N = mkTerm "presbyterian_N" ;
lin presbyterianism_N = mkTerm "presbyterianism_N" ;
lin presbytery_N = mkTerm "presbytery_N" ;
lin preschool_N = mkTerm "preschool_N" ;
lin preschooler_N = mkTerm "preschooler_N" ;
lin prescience_N = mkTerm "prescience_N" ;
lin prescient_A = mkTerm "prescient_A" ;
lin prescot_PN = mkTerm "prescot_PN" ;
lin prescribe_V = mkTerm "prescribe_V" ;
lin prescribe_V2 = mkTerm "prescribe_V2" ;
lin prescript_N = mkTerm "prescript_N" ;
lin prescription_N = mkTerm "prescription_N" ;
lin prescriptive_A = mkTerm "prescriptive_A" ;
lin prescriptivism_N = mkTerm "prescriptivism_N" ;
lin preseason_N = mkTerm "preseason_N" ;
lin presence_N = mkTerm "presence_N" ;
lin present_A = mkTerm "present_A" ;
lin present_N = mkTerm "present_N" ;
lin present_V2 = mkTerm "present_V2" ;
lin present_day_A = mkTerm "present_day_A" ;
lin presentable_A = mkTerm "presentable_A" ;
lin presentation_N = mkTerm "presentation_N" ;
lin presentational_A = mkTerm "presentational_A" ;
lin presenter_N = mkTerm "presenter_N" ;
lin presentiment_N = mkTerm "presentiment_N" ;
lin presentism_N = mkTerm "presentism_N" ;
lin presentist_N = mkTerm "presentist_N" ;
lin presentment_N = mkTerm "presentment_N" ;
lin presentness_N = mkTerm "presentness_N" ;
lin preservable_A = mkTerm "preservable_A" ;
lin preservation_N = mkTerm "preservation_N" ;
lin preservationist_N = mkTerm "preservationist_N" ;
lin preservative_A = mkTerm "preservative_A" ;
lin preservative_N = mkTerm "preservative_N" ;
lin preserve_N = mkTerm "preserve_N" ;
lin preserve_V2 = mkTerm "preserve_V2" ;
lin preserver_N = mkTerm "preserver_N" ;
lin preset_A = mkTerm "preset_A" ;
lin preside_V = mkTerm "preside_V" ;
lin presidency_N = mkTerm "presidency_N" ;
lin presidentFem_N = mkTerm "presidentFem_N" ;
lin presidentMasc_N = mkTerm "presidentMasc_N" ;
lin presidential_A = mkTerm "presidential_A" ;
lin presidio_N = mkTerm "presidio_N" ;
lin presidium_N = mkTerm "presidium_N" ;
lin presocratic_A = mkTerm "presocratic_A" ;
lin press_N = mkTerm "press_N" ;
lin press_V = mkTerm "press_V" ;
lin press_V2 = mkTerm "press_V2" ;
lin press_V2V = mkTerm "press_V2V" ;
lin press_agency_N = mkTerm "press_agency_N" ;
lin press_agent_N = mkTerm "press_agent_N" ;
lin press_ahead_V = mkTerm "press_ahead_V" ;
lin press_box_N = mkTerm "press_box_N" ;
lin press_clipping_N = mkTerm "press_clipping_N" ;
lin press_cutting_N = mkTerm "press_cutting_N" ;
lin press_for_V2 = mkTerm "press_for_V2" ;
lin press_forward_with_V2 = mkTerm "press_forward_with_V2" ;
lin press_gallery_N = mkTerm "press_gallery_N" ;
lin press_gang_N = mkTerm "press_gang_N" ;
lin press_into_V2 = mkTerm "press_into_V2" ;
lin press_lord_N = mkTerm "press_lord_N" ;
lin press_on_V = mkTerm "press_on_V" ;
lin press_photographer_N = mkTerm "press_photographer_N" ;
lin press_stud_N = mkTerm "press_stud_N" ;
lin press_up_N = mkTerm "press_up_N" ;
lin press_upon_V2 = mkTerm "press_upon_V2" ;
lin pressing_A = mkTerm "pressing_A" ;
lin pressing_N = mkTerm "pressing_N" ;
lin pressman_N = mkTerm "pressman_N" ;
lin pressmark_N = mkTerm "pressmark_N" ;
lin pressor_A = mkTerm "pressor_A" ;
lin pressure_N = mkTerm "pressure_N" ;
lin pressure_V2 = mkTerm "pressure_V2" ;
lin pressure_V2V = mkTerm "pressure_V2V" ;
lin pressure_cooker_N = mkTerm "pressure_cooker_N" ;
lin pressure_gauge_N = mkTerm "pressure_gauge_N" ;
lin pressurized_A = mkTerm "pressurized_A" ;
lin prestatyn_PN = mkTerm "prestatyn_PN" ;
lin prestidigitation_N = mkTerm "prestidigitation_N" ;
lin prestidigitator_N = mkTerm "prestidigitator_N" ;
lin prestige_N = mkTerm "prestige_N" ;
lin prestigious_A = mkTerm "prestigious_A" ;
lin prestissimo_A = mkTerm "prestissimo_A" ;
lin prestissimo_Adv = mkTerm "prestissimo_Adv" ;
lin presto_A = mkTerm "presto_A" ;
lin presto_Adv = mkTerm "presto_Adv" ;
lin preston_PN = mkTerm "preston_PN" ;
lin prestonpans_PN = mkTerm "prestonpans_PN" ;
lin prestressed_A = mkTerm "prestressed_A" ;
lin prestwich_PN = mkTerm "prestwich_PN" ;
lin prestwick_PN = mkTerm "prestwick_PN" ;
lin presumable_A = mkTerm "presumable_A" ;
lin presumably_Adv = mkTerm "presumably_Adv" ;
lin presume_V = mkTerm "presume_V" ;
lin presume_V2 = mkTerm "presume_V2" ;
lin presume_VS = mkTerm "presume_VS" ;
lin presumption_N = mkTerm "presumption_N" ;
lin presumptive_A = mkTerm "presumptive_A" ;
lin presumptuous_A = mkTerm "presumptuous_A" ;
lin presuppose_V2 = mkTerm "presuppose_V2" ;
lin presupposition_N = mkTerm "presupposition_N" ;
lin preteen_A = mkTerm "preteen_A" ;
lin preteen_N = mkTerm "preteen_N" ;
lin pretence_N = mkTerm "pretence_N" ;
lin pretend_V = mkTerm "pretend_V" ;
lin pretend_V2 = mkTerm "pretend_V2" ;
lin pretend_VS = mkTerm "pretend_VS" ;
lin pretendedly_Adv = mkTerm "pretendedly_Adv" ;
lin pretender_N = mkTerm "pretender_N" ;
lin pretense_N = mkTerm "pretense_N" ;
lin pretension_N = mkTerm "pretension_N" ;
lin pretentious_A = mkTerm "pretentious_A" ;
lin pretentiousness_N = mkTerm "pretentiousness_N" ;
lin preterist_N = mkTerm "preterist_N" ;
lin preterit_A = mkTerm "preterit_A" ;
lin preterit_N = mkTerm "preterit_N" ;
lin preterite_A = mkTerm "preterite_A" ;
lin preterite_N = mkTerm "preterite_N" ;
lin pretermission_N = mkTerm "pretermission_N" ;
lin preternatural_A = mkTerm "preternatural_A" ;
lin pretext_N = mkTerm "pretext_N" ;
lin pretor_N = mkTerm "pretor_N" ;
lin pretoria_PN = mkTerm "pretoria_PN" ;
lin pretrial_N = mkTerm "pretrial_N" ;
lin prettify_V2 = mkTerm "prettify_V2" ;
lin prettily_Adv = mkTerm "prettily_Adv" ;
lin prettiness_N = mkTerm "prettiness_N" ;
lin pretty_A = mkTerm "pretty_A" ;
lin pretty_AdA = mkTerm "pretty_AdA" ;
lin pretty_N = mkTerm "pretty_N" ;
lin pretty_pretty_A = mkTerm "pretty_pretty_A" ;
lin pretzel_N = mkTerm "pretzel_N" ;
lin prevail_V = mkTerm "prevail_V" ;
lin prevailing_A = mkTerm "prevailing_A" ;
lin prevalence_N = mkTerm "prevalence_N" ;
lin prevalent_A = mkTerm "prevalent_A" ;
lin prevaricate_V = mkTerm "prevaricate_V" ;
lin prevarication_N = mkTerm "prevarication_N" ;
lin prevent_V2 = mkTerm "prevent_V2" ;
lin preventable_A = mkTerm "preventable_A" ;
lin preventative_N = mkTerm "preventative_N" ;
lin prevention_N = mkTerm "prevention_N" ;
lin preventive_A = mkTerm "preventive_A" ;
lin preventive_N = mkTerm "preventive_N" ;
lin preview_N = mkTerm "preview_N" ;
lin preview_V2 = mkTerm "preview_V2" ;
lin previous_A = mkTerm "previous_A" ;
lin prevision_N = mkTerm "prevision_N" ;
lin prewar_A = mkTerm "prewar_A" ;
lin prey_N = mkTerm "prey_N" ;
lin prey_V = mkTerm "prey_V" ;
lin prey_on_V2 = mkTerm "prey_on_V2" ;
lin prey_upon_V2 = mkTerm "prey_upon_V2" ;
lin priapic_A = mkTerm "priapic_A" ;
lin priapism_N = mkTerm "priapism_N" ;
lin price_N = mkTerm "price_N" ;
lin price_V = mkTerm "price_V" ;
lin price_V2 = mkTerm "price_V2" ;
lin price_V2V = mkTerm "price_V2V" ;
lin price_control_N = mkTerm "price_control_N" ;
lin price_controlled_A = mkTerm "price_controlled_A" ;
lin price_in_V2 = mkTerm "price_in_V2" ;
lin price_up_V2 = mkTerm "price_up_V2" ;
lin priceless_A = mkTerm "priceless_A" ;
lin pricelist_N = mkTerm "pricelist_N" ;
lin pricey_A = mkTerm "pricey_A" ;
lin pricing_N = mkTerm "pricing_N" ;
lin prick_N = mkTerm "prick_N" ;
lin prick_V = mkTerm "prick_V" ;
lin prick_V2 = mkTerm "prick_V2" ;
lin pricker_N = mkTerm "pricker_N" ;
lin pricket_N = mkTerm "pricket_N" ;
lin pricking_N = mkTerm "pricking_N" ;
lin prickle_N = mkTerm "prickle_N" ;
lin prickle_V = mkTerm "prickle_V" ;
lin prickle_V2 = mkTerm "prickle_V2" ;
lin prickleback_N = mkTerm "prickleback_N" ;
lin prickliness_N = mkTerm "prickliness_N" ;
lin prickling_N = mkTerm "prickling_N" ;
lin prickly_A = mkTerm "prickly_A" ;
lin pride_N = mkTerm "pride_N" ;
lin pride_V2 = mkTerm "pride_V2" ;
lin prie_dieu_N = mkTerm "prie_dieu_N" ;
lin priest_N = mkTerm "priest_N" ;
lin priest_ridden_A = mkTerm "priest_ridden_A" ;
lin priestcraft_N = mkTerm "priestcraft_N" ;
lin priestess_N = mkTerm "priestess_N" ;
lin priesthood_N = mkTerm "priesthood_N" ;
lin priestlike_A = mkTerm "priestlike_A" ;
lin priestly_A = mkTerm "priestly_A" ;
lin prig_N = mkTerm "prig_N" ;
lin priggish_A = mkTerm "priggish_A" ;
lin priggishness_N = mkTerm "priggishness_N" ;
lin prim_A = mkTerm "prim_A" ;
lin prim_V2 = mkTerm "prim_V2" ;
lin prima_A = mkTerm "prima_A" ;
lin prima_ballerina_N = mkTerm "prima_ballerina_N" ;
lin prima_donna_N = mkTerm "prima_donna_N" ;
lin prima_facie_A = mkTerm "prima_facie_A" ;
lin prima_facie_Adv = mkTerm "prima_facie_Adv" ;
lin primacy_N = mkTerm "primacy_N" ;
lin primaeval_A = mkTerm "primaeval_A" ;
lin primal_A = mkTerm "primal_A" ;
lin primality_N = mkTerm "primality_N" ;
lin primaquine_N = mkTerm "primaquine_N" ;
lin primary_A = mkTerm "primary_A" ;
lin primary_N = mkTerm "primary_N" ;
lin primate_N = mkTerm "primate_N" ;
lin primateship_N = mkTerm "primateship_N" ;
lin primatology_N = mkTerm "primatology_N" ;
lin prime_A = mkTerm "prime_A" ;
lin prime_N = mkTerm "prime_N" ;
lin prime_V2 = mkTerm "prime_V2" ;
lin primer_N = mkTerm "primer_N" ;
lin primeval_A = mkTerm "primeval_A" ;
lin primidone_N = mkTerm "primidone_N" ;
lin primigravida_N = mkTerm "primigravida_N" ;
lin priming_N = mkTerm "priming_N" ;
lin primipara_N = mkTerm "primipara_N" ;
lin primiparous_A = mkTerm "primiparous_A" ;
lin primitive_A = mkTerm "primitive_A" ;
lin primitive_N = mkTerm "primitive_N" ;
lin primitiveness_N = mkTerm "primitiveness_N" ;
lin primitivism_N = mkTerm "primitivism_N" ;
lin primness_N = mkTerm "primness_N" ;
lin primo_A = mkTerm "primo_A" ;
lin primo_N = mkTerm "primo_N" ;
lin primogeniture_N = mkTerm "primogeniture_N" ;
lin primordial_A = mkTerm "primordial_A" ;
lin primordium_N = mkTerm "primordium_N" ;
lin primp_V2 = mkTerm "primp_V2" ;
lin primping_N = mkTerm "primping_N" ;
lin primrose_N = mkTerm "primrose_N" ;
lin primula_N = mkTerm "primula_N" ;
lin primus_N = mkTerm "primus_N" ;
lin prince_N = mkTerm "prince_N" ;
lin princedom_N = mkTerm "princedom_N" ;
lin princeling_N = mkTerm "princeling_N" ;
lin princely_A = mkTerm "princely_A" ;
lin princes_risborough_PN = mkTerm "princes_risborough_PN" ;
lin princess_N = mkTerm "princess_N" ;
lin princewood_N = mkTerm "princewood_N" ;
lin principal_A = mkTerm "principal_A" ;
lin principal_N = mkTerm "principal_N" ;
lin principality_N = mkTerm "principality_N" ;
lin principalship_N = mkTerm "principalship_N" ;
lin principle_N = mkTerm "principle_N" ;
lin principled_A = mkTerm "principled_A" ;
lin principles_N = mkTerm "principles_N" ;
lin prink_V2 = mkTerm "prink_V2" ;
lin print_N = mkTerm "print_N" ;
lin print_V = mkTerm "print_V" ;
lin print_V2 = mkTerm "print_V2" ;
lin print_out_V2 = mkTerm "print_out_V2" ;
lin print_seller_N = mkTerm "print_seller_N" ;
lin print_shop_N = mkTerm "print_shop_N" ;
lin printable_A = mkTerm "printable_A" ;
lin printed_A = mkTerm "printed_A" ;
lin printer_N = mkTerm "printer_N" ;
lin printing_N = mkTerm "printing_N" ;
lin printing_ink_N = mkTerm "printing_ink_N" ;
lin printing_press_N = mkTerm "printing_press_N" ;
lin printmaker_N = mkTerm "printmaker_N" ;
lin printmaking_N = mkTerm "printmaking_N" ;
lin printout_N = mkTerm "printout_N" ;
lin prion_N = mkTerm "prion_N" ;
lin prior_A = mkTerm "prior_A" ;
lin prior_N = mkTerm "prior_N" ;
lin prior_to_Prep = mkTerm "prior_to_Prep" ;
lin prioress_N = mkTerm "prioress_N" ;
lin priority_N = mkTerm "priority_N" ;
lin priorship_N = mkTerm "priorship_N" ;
lin priory_N = mkTerm "priory_N" ;
lin priscilla_PN = mkTerm "priscilla_PN" ;
lin prise_V2 = mkTerm "prise_V2" ;
lin prism_N = mkTerm "prism_N" ;
lin prismatic_A = mkTerm "prismatic_A" ;
lin prismatoid_N = mkTerm "prismatoid_N" ;
lin prismoid_N = mkTerm "prismoid_N" ;
lin prison_N = mkTerm "prison_N" ;
lin prison_breaking_N = mkTerm "prison_breaking_N" ;
lin prisoner_N = mkTerm "prisoner_N" ;
lin prisonlike_A = mkTerm "prisonlike_A" ;
lin pristine_A = mkTerm "pristine_A" ;
lin privacy_N = mkTerm "privacy_N" ;
lin private_A = mkTerm "private_A" ;
lin private_N = mkTerm "private_N" ;
lin privateer_N = mkTerm "privateer_N" ;
lin privation_N = mkTerm "privation_N" ;
lin privatisation_N = mkTerm "privatisation_N" ;
lin privatization_N = mkTerm "privatization_N" ;
lin privatize_V2 = mkTerm "privatize_V2" ;
lin privet_N = mkTerm "privet_N" ;
lin privilege_N = mkTerm "privilege_N" ;
lin privileged_A = mkTerm "privileged_A" ;
lin privy_A = mkTerm "privy_A" ;
lin privy_N = mkTerm "privy_N" ;
lin prize_N = mkTerm "prize_N" ;
lin prize_V2 = mkTerm "prize_V2" ;
lin prize_fight_N = mkTerm "prize_fight_N" ;
lin prize_money_N = mkTerm "prize_money_N" ;
lin prize_ring_N = mkTerm "prize_ring_N" ;
lin prizefighter_N = mkTerm "prizefighter_N" ;
lin pro_A = mkTerm "pro_A" ;
lin pro_Adv = mkTerm "pro_Adv" ;
lin pro_N = mkTerm "pro_N" ;
lin pro_Prep = mkTerm "pro_Prep" ;
lin pro_forma_A = mkTerm "pro_forma_A" ;
lin pro_forma_Adv = mkTerm "pro_forma_Adv" ;
lin pro_rata_Adv = mkTerm "pro_rata_Adv" ;
lin pro_tem_Adv = mkTerm "pro_tem_Adv" ;
lin pro_tempore_Adv = mkTerm "pro_tempore_Adv" ;
lin proaccelerin_N = mkTerm "proaccelerin_N" ;
lin proactive_A = mkTerm "proactive_A" ;
lin probabilism_N = mkTerm "probabilism_N" ;
lin probabilistic_A = mkTerm "probabilistic_A" ;
lin probability_N = mkTerm "probability_N" ;
lin probable_A = mkTerm "probable_A" ;
lin probable_N = mkTerm "probable_N" ;
lin probate_N = mkTerm "probate_N" ;
lin probate_V2 = mkTerm "probate_V2" ;
lin probation_N = mkTerm "probation_N" ;
lin probationary_A = mkTerm "probationary_A" ;
lin probationer_N = mkTerm "probationer_N" ;
lin probative_A = mkTerm "probative_A" ;
lin probe_N = mkTerm "probe_N" ;
lin probe_V = mkTerm "probe_V" ;
lin probe_V2 = mkTerm "probe_V2" ;
lin probenecid_N = mkTerm "probenecid_N" ;
lin probiotic_N = mkTerm "probiotic_N" ;
lin probity_N = mkTerm "probity_N" ;
lin problem_N = mkTerm "problem_N" ;
lin problematic_A = mkTerm "problematic_A" ;
lin proboscidean_N = mkTerm "proboscidean_N" ;
lin proboscis_N = mkTerm "proboscis_N" ;
lin procaine_N = mkTerm "procaine_N" ;
lin procarbazine_N = mkTerm "procarbazine_N" ;
lin procedural_A = mkTerm "procedural_A" ;
lin procedure_N = mkTerm "procedure_N" ;
lin proceed_N = mkTerm "proceed_N" ;
lin proceed_V = mkTerm "proceed_V" ;
lin proceeding_N = mkTerm "proceeding_N" ;
lin proceedings_N = mkTerm "proceedings_N" ;
lin process_N = mkTerm "process_N" ;
lin process_V = mkTerm "process_V" ;
lin process_V2 = mkTerm "process_V2" ;
lin process_server_N = mkTerm "process_server_N" ;
lin processing_N = mkTerm "processing_N" ;
lin procession_N = mkTerm "procession_N" ;
lin processional_A = mkTerm "processional_A" ;
lin processional_N = mkTerm "processional_N" ;
lin processor_N = mkTerm "processor_N" ;
lin prochlorperazine_N = mkTerm "prochlorperazine_N" ;
lin proclaim_V2 = mkTerm "proclaim_V2" ;
lin proclaim_VS = mkTerm "proclaim_VS" ;
lin proclamation_N = mkTerm "proclamation_N" ;
lin proclivity_N = mkTerm "proclivity_N" ;
lin proconsul_N = mkTerm "proconsul_N" ;
lin proconsular_A = mkTerm "proconsular_A" ;
lin proconsulate_N = mkTerm "proconsulate_N" ;
lin proconsulship_N = mkTerm "proconsulship_N" ;
lin proconvertin_N = mkTerm "proconvertin_N" ;
lin procrastinate_V = mkTerm "procrastinate_V" ;
lin procrastination_N = mkTerm "procrastination_N" ;
lin procrastinator_N = mkTerm "procrastinator_N" ;
lin procreate_V2 = mkTerm "procreate_V2" ;
lin procreation_N = mkTerm "procreation_N" ;
lin proctalgia_N = mkTerm "proctalgia_N" ;
lin proctitis_N = mkTerm "proctitis_N" ;
lin proctologist_N = mkTerm "proctologist_N" ;
lin proctology_N = mkTerm "proctology_N" ;
lin proctoplasty_N = mkTerm "proctoplasty_N" ;
lin proctor_N = mkTerm "proctor_N" ;
lin proctorship_N = mkTerm "proctorship_N" ;
lin proctoscope_N = mkTerm "proctoscope_N" ;
lin proctoscopy_N = mkTerm "proctoscopy_N" ;
lin procumbent_A = mkTerm "procumbent_A" ;
lin procurable_A = mkTerm "procurable_A" ;
lin procurator_N = mkTerm "procurator_N" ;
lin procure_V2 = mkTerm "procure_V2" ;
lin procurement_N = mkTerm "procurement_N" ;
lin procurer_N = mkTerm "procurer_N" ;
lin procuress_N = mkTerm "procuress_N" ;
lin procyclidine_N = mkTerm "procyclidine_N" ;
lin procyonid_N = mkTerm "procyonid_N" ;
lin prod_N = mkTerm "prod_N" ;
lin prod_V = mkTerm "prod_V" ;
lin prod_V2 = mkTerm "prod_V2" ;
lin prod_V2V = mkTerm "prod_V2V" ;
lin prodigal_A = mkTerm "prodigal_A" ;
lin prodigal_N = mkTerm "prodigal_N" ;
lin prodigality_N = mkTerm "prodigality_N" ;
lin prodigious_A = mkTerm "prodigious_A" ;
lin prodigy_N = mkTerm "prodigy_N" ;
lin prodromal_A = mkTerm "prodromal_A" ;
lin prodrome_N = mkTerm "prodrome_N" ;
lin produce_N = mkTerm "produce_N" ;
lin produce_V = mkTerm "produce_V" ;
lin produce_V2 = mkTerm "produce_V2" ;
lin producer_N = mkTerm "producer_N" ;
lin product_N = mkTerm "product_N" ;
lin production_N = mkTerm "production_N" ;
lin productive_A = mkTerm "productive_A" ;
lin productiveness_N = mkTerm "productiveness_N" ;
lin productivity_N = mkTerm "productivity_N" ;
lin proenzyme_N = mkTerm "proenzyme_N" ;
lin prof_N = mkTerm "prof_N" ;
lin prof_PN = mkTerm "prof_PN" ;
lin profanation_N = mkTerm "profanation_N" ;
lin profanatory_A = mkTerm "profanatory_A" ;
lin profane_A = mkTerm "profane_A" ;
lin profane_V2 = mkTerm "profane_V2" ;
lin profaneness_N = mkTerm "profaneness_N" ;
lin profanity_N = mkTerm "profanity_N" ;
lin profess_V = mkTerm "profess_V" ;
lin profess_V2 = mkTerm "profess_V2" ;
lin profess_V2V = mkTerm "profess_V2V" ;
lin professedly_Adv = mkTerm "professedly_Adv" ;
lin profession_N = mkTerm "profession_N" ;
lin professional_A = mkTerm "professional_A" ;
lin professional_N = mkTerm "professional_N" ;
lin professionalism_N = mkTerm "professionalism_N" ;
lin professionalization_N = mkTerm "professionalization_N" ;
lin professor_N = mkTerm "professor_N" ;
lin professorial_A = mkTerm "professorial_A" ;
lin professorship_N = mkTerm "professorship_N" ;
lin proffer_N = mkTerm "proffer_N" ;
lin proffer_V2 = mkTerm "proffer_V2" ;
lin proficiency_N = mkTerm "proficiency_N" ;
lin proficient_A = mkTerm "proficient_A" ;
lin profile_N = mkTerm "profile_N" ;
lin profile_V2 = mkTerm "profile_V2" ;
lin profiling_N = mkTerm "profiling_N" ;
lin profit_N = mkTerm "profit_N" ;
lin profit_V = mkTerm "profit_V" ;
lin profit_V2 = mkTerm "profit_V2" ;
lin profit_margin_N = mkTerm "profit_margin_N" ;
lin profit_sharing_N = mkTerm "profit_sharing_N" ;
lin profitability_N = mkTerm "profitability_N" ;
lin profitable_A = mkTerm "profitable_A" ;
lin profitableness_N = mkTerm "profitableness_N" ;
lin profiteer_N = mkTerm "profiteer_N" ;
lin profiteer_V = mkTerm "profiteer_V" ;
lin profiterole_N = mkTerm "profiterole_N" ;
lin profitless_A = mkTerm "profitless_A" ;
lin profligacy_N = mkTerm "profligacy_N" ;
lin profligate_A = mkTerm "profligate_A" ;
lin profligate_N = mkTerm "profligate_N" ;
lin profound_A = mkTerm "profound_A" ;
lin profoundness_N = mkTerm "profoundness_N" ;
lin profundity_N = mkTerm "profundity_N" ;
lin profuse_A = mkTerm "profuse_A" ;
lin profuseness_N = mkTerm "profuseness_N" ;
lin profusion_N = mkTerm "profusion_N" ;
lin progenitor_N = mkTerm "progenitor_N" ;
lin progeria_N = mkTerm "progeria_N" ;
lin progestational_A = mkTerm "progestational_A" ;
lin progesterone_N = mkTerm "progesterone_N" ;
lin progestin_N = mkTerm "progestin_N" ;
lin prognathism_N = mkTerm "prognathism_N" ;
lin prognathous_A = mkTerm "prognathous_A" ;
lin prognosis_N = mkTerm "prognosis_N" ;
lin prognostic_A = mkTerm "prognostic_A" ;
lin prognostic_N = mkTerm "prognostic_N" ;
lin prognosticate_V2 = mkTerm "prognosticate_V2" ;
lin prognostication_N = mkTerm "prognostication_N" ;
lin program_N = mkTerm "program_N" ;
lin program_V2 = mkTerm "program_V2" ;
lin program_V2V = mkTerm "program_V2V" ;
lin programma_N = mkTerm "programma_N" ;
lin programmable_A = mkTerm "programmable_A" ;
lin programme_N = mkTerm "programme_N" ;
lin programme_V2 = mkTerm "programme_V2" ;
lin programmerFem_N = mkTerm "programmerFem_N" ;
lin programmerMasc_N = mkTerm "programmerMasc_N" ;
lin programming_N = mkTerm "programming_N" ;
lin progress_N = mkTerm "progress_N" ;
lin progress_V = mkTerm "progress_V" ;
lin progress_V2 = mkTerm "progress_V2" ;
lin progression_N = mkTerm "progression_N" ;
lin progressive_A = mkTerm "progressive_A" ;
lin progressive_N = mkTerm "progressive_N" ;
lin progressiveness_N = mkTerm "progressiveness_N" ;
lin progressivism_N = mkTerm "progressivism_N" ;
lin progymnosperm_N = mkTerm "progymnosperm_N" ;
lin prohibit_V = mkTerm "prohibit_V" ;
lin prohibit_V2 = mkTerm "prohibit_V2" ;
lin prohibition_N = mkTerm "prohibition_N" ;
lin prohibitionist_N = mkTerm "prohibitionist_N" ;
lin prohibitive_A = mkTerm "prohibitive_A" ;
lin prohibitory_A = mkTerm "prohibitory_A" ;
lin proinflammatory_A = mkTerm "proinflammatory_A" ;
lin project_N = mkTerm "project_N" ;
lin project_V = mkTerm "project_V" ;
lin project_V2 = mkTerm "project_V2" ;
lin project_V2V = mkTerm "project_V2V" ;
lin project_VS = mkTerm "project_VS" ;
lin projectile_A = mkTerm "projectile_A" ;
lin projectile_N = mkTerm "projectile_N" ;
lin projection_N = mkTerm "projection_N" ;
lin projectionist_N = mkTerm "projectionist_N" ;
lin projective_A = mkTerm "projective_A" ;
lin projector_N = mkTerm "projector_N" ;
lin prokaryote_N = mkTerm "prokaryote_N" ;
lin prokaryotic_A = mkTerm "prokaryotic_A" ;
lin prolactin_N = mkTerm "prolactin_N" ;
lin prolamine_N = mkTerm "prolamine_N" ;
lin prolapse_N = mkTerm "prolapse_N" ;
lin prolapse_V = mkTerm "prolapse_V" ;
lin prolate_A = mkTerm "prolate_A" ;
lin prole_N = mkTerm "prole_N" ;
lin prolegomenon_N = mkTerm "prolegomenon_N" ;
lin prolepsis_N = mkTerm "prolepsis_N" ;
lin proletarian_A = mkTerm "proletarian_A" ;
lin proletarian_N = mkTerm "proletarian_N" ;
lin proletariat_N = mkTerm "proletariat_N" ;
lin proliferate_V = mkTerm "proliferate_V" ;
lin proliferate_V2 = mkTerm "proliferate_V2" ;
lin proliferation_N = mkTerm "proliferation_N" ;
lin prolific_A = mkTerm "prolific_A" ;
lin proline_N = mkTerm "proline_N" ;
lin prolix_A = mkTerm "prolix_A" ;
lin prolixity_N = mkTerm "prolixity_N" ;
lin prologue_N = mkTerm "prologue_N" ;
lin prolong_V2 = mkTerm "prolong_V2" ;
lin prolongation_N = mkTerm "prolongation_N" ;
lin prolonge_N = mkTerm "prolonge_N" ;
lin prolonged_A = mkTerm "prolonged_A" ;
lin prolusory_A = mkTerm "prolusory_A" ;
lin prom_N = mkTerm "prom_N" ;
lin promenade_N = mkTerm "promenade_N" ;
lin promenade_V = mkTerm "promenade_V" ;
lin promenade_V2 = mkTerm "promenade_V2" ;
lin promethazine_N = mkTerm "promethazine_N" ;
lin promethium_N = mkTerm "promethium_N" ;
lin prominence_N = mkTerm "prominence_N" ;
lin prominent_A = mkTerm "prominent_A" ;
lin promiscuity_N = mkTerm "promiscuity_N" ;
lin promiscuous_A = mkTerm "promiscuous_A" ;
lin promise_N = mkTerm "promise_N" ;
lin promise_V = mkTerm "promise_V" ;
lin promise_V2 = mkTerm "promise_V2" ;
lin promise_VS = mkTerm "promise_VS" ;
lin promise_VV = mkTerm "promise_VV" ;
lin promisee_N = mkTerm "promisee_N" ;
lin promiser_N = mkTerm "promiser_N" ;
lin promisingly_Adv = mkTerm "promisingly_Adv" ;
lin promissory_A = mkTerm "promissory_A" ;
lin promo_N = mkTerm "promo_N" ;
lin promontory_N = mkTerm "promontory_N" ;
lin promote_V = mkTerm "promote_V" ;
lin promote_V2 = mkTerm "promote_V2" ;
lin promoter_N = mkTerm "promoter_N" ;
lin promotion_N = mkTerm "promotion_N" ;
lin promotional_A = mkTerm "promotional_A" ;
lin promotive_A = mkTerm "promotive_A" ;
lin prompt_A = mkTerm "prompt_A" ;
lin prompt_N = mkTerm "prompt_N" ;
lin prompt_V2 = mkTerm "prompt_V2" ;
lin prompt_V2V = mkTerm "prompt_V2V" ;
lin prompt_box_N = mkTerm "prompt_box_N" ;
lin prompt_copy_N = mkTerm "prompt_copy_N" ;
lin promptbook_N = mkTerm "promptbook_N" ;
lin prompter_N = mkTerm "prompter_N" ;
lin prompting_N = mkTerm "prompting_N" ;
lin promptitude_N = mkTerm "promptitude_N" ;
lin promptness_N = mkTerm "promptness_N" ;
lin promulgate_V2 = mkTerm "promulgate_V2" ;
lin promulgation_N = mkTerm "promulgation_N" ;
lin promulgator_N = mkTerm "promulgator_N" ;
lin promycelium_N = mkTerm "promycelium_N" ;
lin pronation_N = mkTerm "pronation_N" ;
lin pronator_N = mkTerm "pronator_N" ;
lin prone_A = mkTerm "prone_A" ;
lin proneness_N = mkTerm "proneness_N" ;
lin prong_N = mkTerm "prong_N" ;
lin pronged_A = mkTerm "pronged_A" ;
lin pronghorn_N = mkTerm "pronghorn_N" ;
lin pronominal_A = mkTerm "pronominal_A" ;
lin pronoun_N = mkTerm "pronoun_N" ;
lin pronounce_V = mkTerm "pronounce_V" ;
lin pronounce_V2 = mkTerm "pronounce_V2" ;
lin pronounceable_A = mkTerm "pronounceable_A" ;
lin pronounced_A = mkTerm "pronounced_A" ;
lin pronouncement_N = mkTerm "pronouncement_N" ;
lin pronto_Adv = mkTerm "pronto_Adv" ;
lin pronucleus_N = mkTerm "pronucleus_N" ;
lin pronunciamento_N = mkTerm "pronunciamento_N" ;
lin pronunciation_N = mkTerm "pronunciation_N" ;
lin proof_A = mkTerm "proof_A" ;
lin proof_N = mkTerm "proof_N" ;
lin proof_V2 = mkTerm "proof_V2" ;
lin proofread_V = mkTerm "proofread_V" ;
lin proofread_V2 = mkTerm "proofread_V2" ;
lin proofreader_N = mkTerm "proofreader_N" ;
lin prop_N = mkTerm "prop_N" ;
lin prop_V2 = mkTerm "prop_V2" ;
lin prop_up_V2 = mkTerm "prop_up_V2" ;
lin propaedeutic_N = mkTerm "propaedeutic_N" ;
lin propaganda_N = mkTerm "propaganda_N" ;
lin propagandist_A = mkTerm "propagandist_A" ;
lin propagandist_N = mkTerm "propagandist_N" ;
lin propagandize_V = mkTerm "propagandize_V" ;
lin propagandize_V2 = mkTerm "propagandize_V2" ;
lin propagate_V = mkTerm "propagate_V" ;
lin propagate_V2 = mkTerm "propagate_V2" ;
lin propagation_N = mkTerm "propagation_N" ;
lin propagative_A = mkTerm "propagative_A" ;
lin propagator_N = mkTerm "propagator_N" ;
lin propanal_N = mkTerm "propanal_N" ;
lin propane_N = mkTerm "propane_N" ;
lin propanol_N = mkTerm "propanol_N" ;
lin propanolol_N = mkTerm "propanolol_N" ;
lin proparoxytone_N = mkTerm "proparoxytone_N" ;
lin propel_V2 = mkTerm "propel_V2" ;
lin propellant_A = mkTerm "propellant_A" ;
lin propellant_N = mkTerm "propellant_N" ;
lin propellent_A = mkTerm "propellent_A" ;
lin propellent_N = mkTerm "propellent_N" ;
lin propeller_N = mkTerm "propeller_N" ;
lin propenal_N = mkTerm "propenal_N" ;
lin propenoate_N = mkTerm "propenoate_N" ;
lin propenonitrile_N = mkTerm "propenonitrile_N" ;
lin propensity_N = mkTerm "propensity_N" ;
lin proper_A = mkTerm "proper_A" ;
lin propertied_A = mkTerm "propertied_A" ;
lin property_1_N = mkTerm "property_1_N" ;
lin property_2_N = mkTerm "property_2_N" ;
lin property_man_N = mkTerm "property_man_N" ;
lin property_master_N = mkTerm "property_master_N" ;
lin propertyless_A = mkTerm "propertyless_A" ;
lin prophase_N = mkTerm "prophase_N" ;
lin prophecy_N = mkTerm "prophecy_N" ;
lin prophesy_V = mkTerm "prophesy_V" ;
lin prophesy_V2 = mkTerm "prophesy_V2" ;
lin prophet_N = mkTerm "prophet_N" ;
lin prophetess_N = mkTerm "prophetess_N" ;
lin prophetic_A = mkTerm "prophetic_A" ;
lin prophetical_A = mkTerm "prophetical_A" ;
lin prophylactic_A = mkTerm "prophylactic_A" ;
lin prophylactic_N = mkTerm "prophylactic_N" ;
lin prophylaxis_N = mkTerm "prophylaxis_N" ;
lin prophyll_N = mkTerm "prophyll_N" ;
lin propinquity_N = mkTerm "propinquity_N" ;
lin propitiate_V2 = mkTerm "propitiate_V2" ;
lin propitiation_N = mkTerm "propitiation_N" ;
lin propitiative_A = mkTerm "propitiative_A" ;
lin propitiatory_A = mkTerm "propitiatory_A" ;
lin propitious_A = mkTerm "propitious_A" ;
lin propjet_N = mkTerm "propjet_N" ;
lin proponent_N = mkTerm "proponent_N" ;
lin proportion_N = mkTerm "proportion_N" ;
lin proportion_V2 = mkTerm "proportion_V2" ;
lin proportionable_A = mkTerm "proportionable_A" ;
lin proportional_A = mkTerm "proportional_A" ;
lin proportional_N = mkTerm "proportional_N" ;
lin proportionality_N = mkTerm "proportionality_N" ;
lin proportionate_A = mkTerm "proportionate_A" ;
lin proposal_N = mkTerm "proposal_N" ;
lin propose_V = mkTerm "propose_V" ;
lin propose_V2 = mkTerm "propose_V2" ;
lin propose_VS = mkTerm "propose_VS" ;
lin propose_VV = mkTerm "propose_VV" ;
lin proposed_A = mkTerm "proposed_A" ;
lin proposer_N = mkTerm "proposer_N" ;
lin proposition_N = mkTerm "proposition_N" ;
lin proposition_V2 = mkTerm "proposition_V2" ;
lin propositus_N = mkTerm "propositus_N" ;
lin propound_V2 = mkTerm "propound_V2" ;
lin propoxyphene_N = mkTerm "propoxyphene_N" ;
lin proprietary_A = mkTerm "proprietary_A" ;
lin proprietor_N = mkTerm "proprietor_N" ;
lin proprietorship_N = mkTerm "proprietorship_N" ;
lin proprietress_N = mkTerm "proprietress_N" ;
lin propriety_N = mkTerm "propriety_N" ;
lin proprioception_N = mkTerm "proprioception_N" ;
lin proprioceptive_A = mkTerm "proprioceptive_A" ;
lin proprioceptor_N = mkTerm "proprioceptor_N" ;
lin proprionamide_N = mkTerm "proprionamide_N" ;
lin props_N = mkTerm "props_N" ;
lin propulsion_N = mkTerm "propulsion_N" ;
lin propulsive_A = mkTerm "propulsive_A" ;
lin propyl_N = mkTerm "propyl_N" ;
lin propylene_N = mkTerm "propylene_N" ;
lin propylthiouracil_N = mkTerm "propylthiouracil_N" ;
lin proration_N = mkTerm "proration_N" ;
lin prorogation_N = mkTerm "prorogation_N" ;
lin prorogue_V2 = mkTerm "prorogue_V2" ;
lin prosaic_A = mkTerm "prosaic_A" ;
lin proscenium_N = mkTerm "proscenium_N" ;
lin prosciutto_N = mkTerm "prosciutto_N" ;
lin proscribe_V2 = mkTerm "proscribe_V2" ;
lin proscription_N = mkTerm "proscription_N" ;
lin prose_N = mkTerm "prose_N" ;
lin prosecute_V2 = mkTerm "prosecute_V2" ;
lin prosecution_N = mkTerm "prosecution_N" ;
lin prosecutorFem_N = mkTerm "prosecutorFem_N" ;
lin prosecutorMasc_N = mkTerm "prosecutorMasc_N" ;
lin proselyte_N = mkTerm "proselyte_N" ;
lin proselytism_N = mkTerm "proselytism_N" ;
lin proselytize_V = mkTerm "proselytize_V" ;
lin proselytize_V2 = mkTerm "proselytize_V2" ;
lin prosimian_N = mkTerm "prosimian_N" ;
lin prosiness_N = mkTerm "prosiness_N" ;
lin prosodic_A = mkTerm "prosodic_A" ;
lin prosody_N = mkTerm "prosody_N" ;
lin prospect_N = mkTerm "prospect_N" ;
lin prospect_V = mkTerm "prospect_V" ;
lin prospective_A = mkTerm "prospective_A" ;
lin prospector_N = mkTerm "prospector_N" ;
lin prospectus_N = mkTerm "prospectus_N" ;
lin prosper_V = mkTerm "prosper_V" ;
lin prosper_V2 = mkTerm "prosper_V2" ;
lin prosperity_N = mkTerm "prosperity_N" ;
lin prosperous_A = mkTerm "prosperous_A" ;
lin prostaglandin_N = mkTerm "prostaglandin_N" ;
lin prostate_A = mkTerm "prostate_A" ;
lin prostate_N = mkTerm "prostate_N" ;
lin prostatectomy_N = mkTerm "prostatectomy_N" ;
lin prostatitis_N = mkTerm "prostatitis_N" ;
lin prosthesis_N = mkTerm "prosthesis_N" ;
lin prosthetic_A = mkTerm "prosthetic_A" ;
lin prosthetics_N = mkTerm "prosthetics_N" ;
lin prosthetist_N = mkTerm "prosthetist_N" ;
lin prosthion_N = mkTerm "prosthion_N" ;
lin prosthodontic_A = mkTerm "prosthodontic_A" ;
lin prosthodontics_N = mkTerm "prosthodontics_N" ;
lin prosthodontist_N = mkTerm "prosthodontist_N" ;
lin prostitute_N = mkTerm "prostitute_N" ;
lin prostitute_V2 = mkTerm "prostitute_V2" ;
lin prostitution_N = mkTerm "prostitution_N" ;
lin prostrate_A = mkTerm "prostrate_A" ;
lin prostrate_V2 = mkTerm "prostrate_V2" ;
lin prostration_N = mkTerm "prostration_N" ;
lin prostyle_A = mkTerm "prostyle_A" ;
lin prosy_A = mkTerm "prosy_A" ;
lin protactinium_N = mkTerm "protactinium_N" ;
lin protagonist_N = mkTerm "protagonist_N" ;
lin protamine_N = mkTerm "protamine_N" ;
lin protanopia_N = mkTerm "protanopia_N" ;
lin protanopic_A = mkTerm "protanopic_A" ;
lin protea_N = mkTerm "protea_N" ;
lin protean_A = mkTerm "protean_A" ;
lin protease_N = mkTerm "protease_N" ;
lin protect_V = mkTerm "protect_V" ;
lin protect_V2 = mkTerm "protect_V2" ;
lin protected_A = mkTerm "protected_A" ;
lin protection_N = mkTerm "protection_N" ;
lin protectionism_N = mkTerm "protectionism_N" ;
lin protectionistFem_N = mkTerm "protectionistFem_N" ;
lin protectionistMasc_N = mkTerm "protectionistMasc_N" ;
lin protective_A = mkTerm "protective_A" ;
lin protectiveness_N = mkTerm "protectiveness_N" ;
lin protector_N = mkTerm "protector_N" ;
lin protectorate_N = mkTerm "protectorate_N" ;
lin protectorship_N = mkTerm "protectorship_N" ;
lin protege_N = mkTerm "protege_N" ;
lin protegee_N = mkTerm "protegee_N" ;
lin protein_N = mkTerm "protein_N" ;
lin proteinaceous_A = mkTerm "proteinaceous_A" ;
lin proteolysis_N = mkTerm "proteolysis_N" ;
lin proteolytic_A = mkTerm "proteolytic_A" ;
lin proteome_N = mkTerm "proteome_N" ;
lin proteomics_N = mkTerm "proteomics_N" ;
lin proterozoic_A = mkTerm "proterozoic_A" ;
lin protest_N = mkTerm "protest_N" ;
lin protest_V = mkTerm "protest_V" ;
lin protest_V2 = mkTerm "protest_V2" ;
lin protestant_A = mkTerm "protestant_A" ;
lin protestant_N = mkTerm "protestant_N" ;
lin protestantism_N = mkTerm "protestantism_N" ;
lin protestation_N = mkTerm "protestation_N" ;
lin protester_N = mkTerm "protester_N" ;
lin protestingly_Adv = mkTerm "protestingly_Adv" ;
lin prothalamion_N = mkTerm "prothalamion_N" ;
lin prothorax_N = mkTerm "prothorax_N" ;
lin prothrombin_N = mkTerm "prothrombin_N" ;
lin prothrombinase_N = mkTerm "prothrombinase_N" ;
lin protist_N = mkTerm "protist_N" ;
lin protoarcheology_N = mkTerm "protoarcheology_N" ;
lin protoavis_N = mkTerm "protoavis_N" ;
lin protoceratops_N = mkTerm "protoceratops_N" ;
lin protocol_N = mkTerm "protocol_N" ;
lin protoctist_N = mkTerm "protoctist_N" ;
lin protogeometric_A = mkTerm "protogeometric_A" ;
lin protohippus_N = mkTerm "protohippus_N" ;
lin protohistory_N = mkTerm "protohistory_N" ;
lin protology_N = mkTerm "protology_N" ;
lin proton_N = mkTerm "proton_N" ;
lin protoplasm_N = mkTerm "protoplasm_N" ;
lin prototherian_N = mkTerm "prototherian_N" ;
lin prototype_N = mkTerm "prototype_N" ;
lin protozoal_A = mkTerm "protozoal_A" ;
lin protozoan_N = mkTerm "protozoan_N" ;
lin protozoological_A = mkTerm "protozoological_A" ;
lin protozoologist_N = mkTerm "protozoologist_N" ;
lin protozoology_N = mkTerm "protozoology_N" ;
lin protract_V2 = mkTerm "protract_V2" ;
lin protractile_A = mkTerm "protractile_A" ;
lin protraction_N = mkTerm "protraction_N" ;
lin protractor_N = mkTerm "protractor_N" ;
lin protriptyline_N = mkTerm "protriptyline_N" ;
lin protrude_V = mkTerm "protrude_V" ;
lin protrude_V2 = mkTerm "protrude_V2" ;
lin protrusile_A = mkTerm "protrusile_A" ;
lin protrusion_N = mkTerm "protrusion_N" ;
lin protrusive_A = mkTerm "protrusive_A" ;
lin protuberance_N = mkTerm "protuberance_N" ;
lin protuberant_A = mkTerm "protuberant_A" ;
lin proturan_N = mkTerm "proturan_N" ;
lin proud_A = mkTerm "proud_A" ;
lin provable_A = mkTerm "provable_A" ;
lin prove_V = mkTerm "prove_V" ;
lin prove_V2 = mkTerm "prove_V2" ;
lin prove_VA = mkTerm "prove_VA" ;
lin prove_VS = mkTerm "prove_VS" ;
lin provenance_N = mkTerm "provenance_N" ;
lin provencal_A = mkTerm "provencal_A" ;
lin provender_N = mkTerm "provender_N" ;
lin proverb_N = mkTerm "proverb_N" ;
lin proverbial_A = mkTerm "proverbial_A" ;
lin provide_V = mkTerm "provide_V" ;
lin provide_V2 = mkTerm "provide_V2" ;
lin provided_Subj = mkTerm "provided_Subj" ;
lin providence_N = mkTerm "providence_N" ;
lin providence_PN = mkTerm "providence_PN" ;
lin provident_A = mkTerm "provident_A" ;
lin providential_A = mkTerm "providential_A" ;
lin provider_N = mkTerm "provider_N" ;
lin providing_Subj = mkTerm "providing_Subj" ;
lin province_N = mkTerm "province_N" ;
lin provincial_A = mkTerm "provincial_A" ;
lin provincial_N = mkTerm "provincial_N" ;
lin provincialism_N = mkTerm "provincialism_N" ;
lin provirus_N = mkTerm "provirus_N" ;
lin provision_N = mkTerm "provision_N" ;
lin provision_V2 = mkTerm "provision_V2" ;
lin provisional_A = mkTerm "provisional_A" ;
lin proviso_N = mkTerm "proviso_N" ;
lin provisory_A = mkTerm "provisory_A" ;
lin provitamin_N = mkTerm "provitamin_N" ;
lin provocation_N = mkTerm "provocation_N" ;
lin provocative_A = mkTerm "provocative_A" ;
lin provoke_V2 = mkTerm "provoke_V2" ;
lin provoking_A = mkTerm "provoking_A" ;
lin provost_N = mkTerm "provost_N" ;
lin prow_N = mkTerm "prow_N" ;
lin prowess_N = mkTerm "prowess_N" ;
lin prowl_N = mkTerm "prowl_N" ;
lin prowl_V = mkTerm "prowl_V" ;
lin prowl_V2 = mkTerm "prowl_V2" ;
lin prowler_N = mkTerm "prowler_N" ;
lin prox_Adv = mkTerm "prox_Adv" ;
lin proxemics_N = mkTerm "proxemics_N" ;
lin proximal_A = mkTerm "proximal_A" ;
lin proximate_A = mkTerm "proximate_A" ;
lin proximity_N = mkTerm "proximity_N" ;
lin proximo_A = mkTerm "proximo_A" ;
lin proxy_N = mkTerm "proxy_N" ;
lin pru_PN = mkTerm "pru_PN" ;
lin prude_N = mkTerm "prude_N" ;
lin prudence_N = mkTerm "prudence_N" ;
lin prudence_PN = mkTerm "prudence_PN" ;
lin prudent_A = mkTerm "prudent_A" ;
lin prudential_A = mkTerm "prudential_A" ;
lin prudery_N = mkTerm "prudery_N" ;
lin prudhoe_PN = mkTerm "prudhoe_PN" ;
lin prudish_A = mkTerm "prudish_A" ;
lin prune_N = mkTerm "prune_N" ;
lin prune_V2 = mkTerm "prune_V2" ;
lin pruner_N = mkTerm "pruner_N" ;
lin pruning_N = mkTerm "pruning_N" ;
lin pruning_hook_N = mkTerm "pruning_hook_N" ;
lin pruning_knife_N = mkTerm "pruning_knife_N" ;
lin pruning_saw_N = mkTerm "pruning_saw_N" ;
lin pruno_N = mkTerm "pruno_N" ;
lin prurience_N = mkTerm "prurience_N" ;
lin pruriency_N = mkTerm "pruriency_N" ;
lin prurient_A = mkTerm "prurient_A" ;
lin prurigo_N = mkTerm "prurigo_N" ;
lin pruritus_N = mkTerm "pruritus_N" ;
lin prussian_A = mkTerm "prussian_A" ;
lin prussian_N = mkTerm "prussian_N" ;
lin prussic_A = mkTerm "prussic_A" ;
lin pry_V = mkTerm "pry_V" ;
lin pry_V2 = mkTerm "pry_V2" ;
lin pryingly_Adv = mkTerm "pryingly_Adv" ;
lin psalm_N = mkTerm "psalm_N" ;
lin psalmist_N = mkTerm "psalmist_N" ;
lin psalmody_N = mkTerm "psalmody_N" ;
lin psalter_N = mkTerm "psalter_N" ;
lin psalterium_N = mkTerm "psalterium_N" ;
lin psaltery_N = mkTerm "psaltery_N" ;
lin psammoma_N = mkTerm "psammoma_N" ;
lin psephologist_N = mkTerm "psephologist_N" ;
lin psephology_N = mkTerm "psephology_N" ;
lin pseud_N = mkTerm "pseud_N" ;
lin pseudo_A = mkTerm "pseudo_A" ;
lin pseudo_N = mkTerm "pseudo_N" ;
lin pseudobulb_N = mkTerm "pseudobulb_N" ;
lin pseudoephedrine_N = mkTerm "pseudoephedrine_N" ;
lin pseudohallucination_N = mkTerm "pseudohallucination_N" ;
lin pseudohermaphrodite_N = mkTerm "pseudohermaphrodite_N" ;
lin pseudohermaphroditic_A = mkTerm "pseudohermaphroditic_A" ;
lin pseudohermaphroditism_N = mkTerm "pseudohermaphroditism_N" ;
lin pseudomonad_N = mkTerm "pseudomonad_N" ;
lin pseudonym_N = mkTerm "pseudonym_N" ;
lin pseudonymous_A = mkTerm "pseudonymous_A" ;
lin pseudophloem_N = mkTerm "pseudophloem_N" ;
lin pseudopod_N = mkTerm "pseudopod_N" ;
lin pseudoscience_N = mkTerm "pseudoscience_N" ;
lin pseudoscientific_A = mkTerm "pseudoscientific_A" ;
lin psi_N = mkTerm "psi_N" ;
lin psilocybin_N = mkTerm "psilocybin_N" ;
lin psilomelane_N = mkTerm "psilomelane_N" ;
lin psilophyte_N = mkTerm "psilophyte_N" ;
lin psilophyton_N = mkTerm "psilophyton_N" ;
lin psilosis_N = mkTerm "psilosis_N" ;
lin psittacosaur_N = mkTerm "psittacosaur_N" ;
lin psittacosis_N = mkTerm "psittacosis_N" ;
lin psoas_N = mkTerm "psoas_N" ;
lin psocid_N = mkTerm "psocid_N" ;
lin psoriasis_N = mkTerm "psoriasis_N" ;
lin psych_out_V2 = mkTerm "psych_out_V2" ;
lin psych_up_V2 = mkTerm "psych_up_V2" ;
lin psyche_N = mkTerm "psyche_N" ;
lin psychedelia_N = mkTerm "psychedelia_N" ;
lin psychedelic_A = mkTerm "psychedelic_A" ;
lin psychiatric_A = mkTerm "psychiatric_A" ;
lin psychiatrist_N = mkTerm "psychiatrist_N" ;
lin psychiatry_N = mkTerm "psychiatry_N" ;
lin psychic_A = mkTerm "psychic_A" ;
lin psychic_N = mkTerm "psychic_N" ;
lin psychical_A = mkTerm "psychical_A" ;
lin psychoactive_A = mkTerm "psychoactive_A" ;
lin psychoanalyse_V2 = mkTerm "psychoanalyse_V2" ;
lin psychoanalysis_N = mkTerm "psychoanalysis_N" ;
lin psychoanalyst_N = mkTerm "psychoanalyst_N" ;
lin psychoanalytic_A = mkTerm "psychoanalytic_A" ;
lin psychoanalytical_A = mkTerm "psychoanalytical_A" ;
lin psychoanalyze_V2 = mkTerm "psychoanalyze_V2" ;
lin psychobabble_N = mkTerm "psychobabble_N" ;
lin psychodid_N = mkTerm "psychodid_N" ;
lin psychodynamics_N = mkTerm "psychodynamics_N" ;
lin psychogenesis_N = mkTerm "psychogenesis_N" ;
lin psychogenetic_A = mkTerm "psychogenetic_A" ;
lin psychogenic_A = mkTerm "psychogenic_A" ;
lin psychokinetic_A = mkTerm "psychokinetic_A" ;
lin psycholinguist_N = mkTerm "psycholinguist_N" ;
lin psycholinguistic_A = mkTerm "psycholinguistic_A" ;
lin psycholinguistics_N = mkTerm "psycholinguistics_N" ;
lin psychological_A = mkTerm "psychological_A" ;
lin psychologist_N = mkTerm "psychologist_N" ;
lin psychology_N = mkTerm "psychology_N" ;
lin psychometric_A = mkTerm "psychometric_A" ;
lin psychometry_N = mkTerm "psychometry_N" ;
lin psychomotor_A = mkTerm "psychomotor_A" ;
lin psychopath_N = mkTerm "psychopath_N" ;
lin psychopathic_A = mkTerm "psychopathic_A" ;
lin psychopharmacological_A = mkTerm "psychopharmacological_A" ;
lin psychopharmacology_N = mkTerm "psychopharmacology_N" ;
lin psychophysicist_N = mkTerm "psychophysicist_N" ;
lin psychophysics_N = mkTerm "psychophysics_N" ;
lin psychopomp_N = mkTerm "psychopomp_N" ;
lin psychosexual_A = mkTerm "psychosexual_A" ;
lin psychosexuality_N = mkTerm "psychosexuality_N" ;
lin psychosis_N = mkTerm "psychosis_N" ;
lin psychosomatic_A = mkTerm "psychosomatic_A" ;
lin psychosurgery_N = mkTerm "psychosurgery_N" ;
lin psychotherapeutic_A = mkTerm "psychotherapeutic_A" ;
lin psychotherapist_N = mkTerm "psychotherapist_N" ;
lin psychotherapy_N = mkTerm "psychotherapy_N" ;
lin psychotic_A = mkTerm "psychotic_A" ;
lin psychotic_N = mkTerm "psychotic_N" ;
lin psychrometer_N = mkTerm "psychrometer_N" ;
lin pt_N = mkTerm "pt_N" ;
lin pta_N = mkTerm "pta_N" ;
lin ptarmigan_N = mkTerm "ptarmigan_N" ;
lin pte_PN = mkTerm "pte_PN" ;
lin pteridological_A = mkTerm "pteridological_A" ;
lin pteridologist_N = mkTerm "pteridologist_N" ;
lin pteridology_N = mkTerm "pteridology_N" ;
lin pteridophyte_N = mkTerm "pteridophyte_N" ;
lin pterion_N = mkTerm "pterion_N" ;
lin pterodactyl_N = mkTerm "pterodactyl_N" ;
lin pteropogon_N = mkTerm "pteropogon_N" ;
lin pterosaur_N = mkTerm "pterosaur_N" ;
lin pterygium_N = mkTerm "pterygium_N" ;
lin pto_PN = mkTerm "pto_PN" ;
lin ptomaine_N = mkTerm "ptomaine_N" ;
lin ptosis_N = mkTerm "ptosis_N" ;
lin pty_PN = mkTerm "pty_PN" ;
lin ptyalin_N = mkTerm "ptyalin_N" ;
lin ptyalism_N = mkTerm "ptyalism_N" ;
lin ptyalith_N = mkTerm "ptyalith_N" ;
lin pub_N = mkTerm "pub_N" ;
lin pub_crawl_N = mkTerm "pub_crawl_N" ;
lin pub_crawl_V = mkTerm "pub_crawl_V" ;
lin pubertal_A = mkTerm "pubertal_A" ;
lin puberty_N = mkTerm "puberty_N" ;
lin pubes_N = mkTerm "pubes_N" ;
lin pubescent_A = mkTerm "pubescent_A" ;
lin pubic_A = mkTerm "pubic_A" ;
lin pubis_N = mkTerm "pubis_N" ;
lin public_A = mkTerm "public_A" ;
lin public_N = mkTerm "public_N" ;
lin public_spirited_A = mkTerm "public_spirited_A" ;
lin publican_N = mkTerm "publican_N" ;
lin publication_N = mkTerm "publication_N" ;
lin publicist_N = mkTerm "publicist_N" ;
lin publicity_N = mkTerm "publicity_N" ;
lin publicize_V2 = mkTerm "publicize_V2" ;
lin publish_V = mkTerm "publish_V" ;
lin publish_V2 = mkTerm "publish_V2" ;
lin publishable_A = mkTerm "publishable_A" ;
lin publisher_N = mkTerm "publisher_N" ;
lin publishing_A = mkTerm "publishing_A" ;
lin publishing_N = mkTerm "publishing_N" ;
lin puccoon_N = mkTerm "puccoon_N" ;
lin puce_N = mkTerm "puce_N" ;
lin puck_N = mkTerm "puck_N" ;
lin pucker_N = mkTerm "pucker_N" ;
lin pucker_V = mkTerm "pucker_V" ;
lin pucker_V2 = mkTerm "pucker_V2" ;
lin pucker_up_V = mkTerm "pucker_up_V" ;
lin pucker_up_V2 = mkTerm "pucker_up_V2" ;
lin puckish_A = mkTerm "puckish_A" ;
lin pud_N = mkTerm "pud_N" ;
lin pudasjärvi_PN = mkTerm "pudasjärvi_PN" ;
lin pudden_N = mkTerm "pudden_N" ;
lin pudden_head_N = mkTerm "pudden_head_N" ;
lin pudding_N = mkTerm "pudding_N" ;
lin pudding_face_N = mkTerm "pudding_face_N" ;
lin puddingwife_N = mkTerm "puddingwife_N" ;
lin puddle_N = mkTerm "puddle_N" ;
lin puddle_V2 = mkTerm "puddle_V2" ;
lin puddler_N = mkTerm "puddler_N" ;
lin pudendal_A = mkTerm "pudendal_A" ;
lin pudendum_N = mkTerm "pudendum_N" ;
lin pudge_N = mkTerm "pudge_N" ;
lin pudgy_A = mkTerm "pudgy_A" ;
lin pudsey_PN = mkTerm "pudsey_PN" ;
lin pueblo_N = mkTerm "pueblo_N" ;
lin puerile_A = mkTerm "puerile_A" ;
lin puerility_N = mkTerm "puerility_N" ;
lin puerpera_N = mkTerm "puerpera_N" ;
lin puerperal_A = mkTerm "puerperal_A" ;
lin puerperium_N = mkTerm "puerperium_N" ;
lin puff_A = mkTerm "puff_A" ;
lin puff_N = mkTerm "puff_N" ;
lin puff_V = mkTerm "puff_V" ;
lin puff_V2 = mkTerm "puff_V2" ;
lin puffball_N = mkTerm "puffball_N" ;
lin puffbird_N = mkTerm "puffbird_N" ;
lin puffer_N = mkTerm "puffer_N" ;
lin puffery_N = mkTerm "puffery_N" ;
lin puffin_N = mkTerm "puffin_N" ;
lin puffiness_N = mkTerm "puffiness_N" ;
lin puffing_N = mkTerm "puffing_N" ;
lin puffy_A = mkTerm "puffy_A" ;
lin pug_N = mkTerm "pug_N" ;
lin pug_dog_N = mkTerm "pug_dog_N" ;
lin pug_nose_A = mkTerm "pug_nose_A" ;
lin pug_nose_N = mkTerm "pug_nose_N" ;
lin pug_nosed_A = mkTerm "pug_nosed_A" ;
lin pugilism_N = mkTerm "pugilism_N" ;
lin pugilist_N = mkTerm "pugilist_N" ;
lin pugilistic_A = mkTerm "pugilistic_A" ;
lin pugnacious_A = mkTerm "pugnacious_A" ;
lin pugnacity_N = mkTerm "pugnacity_N" ;
lin puissance_N = mkTerm "puissance_N" ;
lin puissant_A = mkTerm "puissant_A" ;
lin puka_N = mkTerm "puka_N" ;
lin puke_N = mkTerm "puke_N" ;
lin puke_V = mkTerm "puke_V" ;
lin puke_V2 = mkTerm "puke_V2" ;
lin pukka_A = mkTerm "pukka_A" ;
lin pukkila_PN = mkTerm "pukkila_PN" ;
lin puku_N = mkTerm "puku_N" ;
lin pul_N = mkTerm "pul_N" ;
lin pula_N = mkTerm "pula_N" ;
lin pulasan_N = mkTerm "pulasan_N" ;
lin pulchritude_N = mkTerm "pulchritude_N" ;
lin pulchritudinous_A = mkTerm "pulchritudinous_A" ;
lin pule_V = mkTerm "pule_V" ;
lin pulkkila_PN = mkTerm "pulkkila_PN" ;
lin pull_N = mkTerm "pull_N" ;
lin pull_V = mkTerm "pull_V" ;
lin pull_V2 = mkTerm "pull_V2" ;
lin pull_ahead_V = mkTerm "pull_ahead_V" ;
lin pull_apart_V2 = mkTerm "pull_apart_V2" ;
lin pull_away_V = mkTerm "pull_away_V" ;
lin pull_back_V = mkTerm "pull_back_V" ;
lin pull_back_V2 = mkTerm "pull_back_V2" ;
lin pull_down_V = mkTerm "pull_down_V" ;
lin pull_down_V2 = mkTerm "pull_down_V2" ;
lin pull_for_V2 = mkTerm "pull_for_V2" ;
lin pull_in_N = mkTerm "pull_in_N" ;
lin pull_in_V = mkTerm "pull_in_V" ;
lin pull_in_V2 = mkTerm "pull_in_V2" ;
lin pull_off_N = mkTerm "pull_off_N" ;
lin pull_off_V = mkTerm "pull_off_V" ;
lin pull_off_V2 = mkTerm "pull_off_V2" ;
lin pull_on_V2 = mkTerm "pull_on_V2" ;
lin pull_out_N = mkTerm "pull_out_N" ;
lin pull_out_V = mkTerm "pull_out_V" ;
lin pull_out_V2 = mkTerm "pull_out_V2" ;
lin pull_over_V2 = mkTerm "pull_over_V2" ;
lin pull_through_N = mkTerm "pull_through_N" ;
lin pull_through_V = mkTerm "pull_through_V" ;
lin pull_to_V2 = mkTerm "pull_to_V2" ;
lin pull_together_V = mkTerm "pull_together_V" ;
lin pull_up_N = mkTerm "pull_up_N" ;
lin pull_up_V = mkTerm "pull_up_V" ;
lin pull_up_V2 = mkTerm "pull_up_V2" ;
lin pull_yourself_together_V = mkTerm "pull_yourself_together_V" ;
lin pullback_N = mkTerm "pullback_N" ;
lin puller_N = mkTerm "puller_N" ;
lin pullet_N = mkTerm "pullet_N" ;
lin pulley_N = mkTerm "pulley_N" ;
lin pulley_block_N = mkTerm "pulley_block_N" ;
lin pullman_N = mkTerm "pullman_N" ;
lin pullover_N = mkTerm "pullover_N" ;
lin pullulate_V = mkTerm "pullulate_V" ;
lin pullulation_N = mkTerm "pullulation_N" ;
lin pulmonary_A = mkTerm "pulmonary_A" ;
lin pulp_N = mkTerm "pulp_N" ;
lin pulp_V = mkTerm "pulp_V" ;
lin pulp_V2 = mkTerm "pulp_V2" ;
lin pulpit_N = mkTerm "pulpit_N" ;
lin pulpwood_N = mkTerm "pulpwood_N" ;
lin pulpy_A = mkTerm "pulpy_A" ;
lin pulque_N = mkTerm "pulque_N" ;
lin pulsar_N = mkTerm "pulsar_N" ;
lin pulsate_V = mkTerm "pulsate_V" ;
lin pulsate_V2 = mkTerm "pulsate_V2" ;
lin pulsation_N = mkTerm "pulsation_N" ;
lin pulse_N = mkTerm "pulse_N" ;
lin pulse_V = mkTerm "pulse_V" ;
lin pulverization_N = mkTerm "pulverization_N" ;
lin pulverize_V = mkTerm "pulverize_V" ;
lin pulverize_V2 = mkTerm "pulverize_V2" ;
lin puma_N = mkTerm "puma_N" ;
lin pumice_N = mkTerm "pumice_N" ;
lin pumice_stone_N = mkTerm "pumice_stone_N" ;
lin pummel_V2 = mkTerm "pummel_V2" ;
lin pump_N = mkTerm "pump_N" ;
lin pump_V = mkTerm "pump_V" ;
lin pump_V2 = mkTerm "pump_V2" ;
lin pump_in_V = mkTerm "pump_in_V" ;
lin pump_out_V = mkTerm "pump_out_V" ;
lin pump_room_N = mkTerm "pump_room_N" ;
lin pump_up_V = mkTerm "pump_up_V" ;
lin pumpernickel_N = mkTerm "pumpernickel_N" ;
lin pumpkin_N = mkTerm "pumpkin_N" ;
lin pumpkinseed_N = mkTerm "pumpkinseed_N" ;
lin pun_N = mkTerm "pun_N" ;
lin pun_V = mkTerm "pun_V" ;
lin punch_N = mkTerm "punch_N" ;
lin punch_V2 = mkTerm "punch_V2" ;
lin punch_drunk_A = mkTerm "punch_drunk_A" ;
lin punch_up_N = mkTerm "punch_up_N" ;
lin punchball_N = mkTerm "punchball_N" ;
lin punchboard_N = mkTerm "punchboard_N" ;
lin punchbowl_N = mkTerm "punchbowl_N" ;
lin puncher_N = mkTerm "puncher_N" ;
lin punching_ball_N = mkTerm "punching_ball_N" ;
lin punctilio_N = mkTerm "punctilio_N" ;
lin punctilious_A = mkTerm "punctilious_A" ;
lin punctiliousness_N = mkTerm "punctiliousness_N" ;
lin punctual_A = mkTerm "punctual_A" ;
lin punctuality_N = mkTerm "punctuality_N" ;
lin punctuate_V2 = mkTerm "punctuate_V2" ;
lin punctuation_N = mkTerm "punctuation_N" ;
lin punctum_N = mkTerm "punctum_N" ;
lin puncturable_A = mkTerm "puncturable_A" ;
lin puncture_N = mkTerm "puncture_N" ;
lin puncture_V = mkTerm "puncture_V" ;
lin puncture_V2 = mkTerm "puncture_V2" ;
lin punctureless_A = mkTerm "punctureless_A" ;
lin pundit_N = mkTerm "pundit_N" ;
lin pung_N = mkTerm "pung_N" ;
lin pungapung_N = mkTerm "pungapung_N" ;
lin pungency_N = mkTerm "pungency_N" ;
lin pungent_A = mkTerm "pungent_A" ;
lin punic_A = mkTerm "punic_A" ;
lin puniness_N = mkTerm "puniness_N" ;
lin punish_V2 = mkTerm "punish_V2" ;
lin punishable_A = mkTerm "punishable_A" ;
lin punishing_A = mkTerm "punishing_A" ;
lin punishment_N = mkTerm "punishment_N" ;
lin punitive_A = mkTerm "punitive_A" ;
lin punk_N = mkTerm "punk_N" ;
lin punkah_N = mkTerm "punkah_N" ;
lin punkaharju_PN = mkTerm "punkaharju_PN" ;
lin punkalaidun_PN = mkTerm "punkalaidun_PN" ;
lin punkie_N = mkTerm "punkie_N" ;
lin punks_N = mkTerm "punks_N" ;
lin punnet_N = mkTerm "punnet_N" ;
lin punster_N = mkTerm "punster_N" ;
lin punt_N = mkTerm "punt_N" ;
lin punt_V = mkTerm "punt_V" ;
lin punt_V2 = mkTerm "punt_V2" ;
lin punter_N = mkTerm "punter_N" ;
lin puny_A = mkTerm "puny_A" ;
lin puolanka_PN = mkTerm "puolanka_PN" ;
lin pup_N = mkTerm "pup_N" ;
lin pupa_N = mkTerm "pupa_N" ;
lin pupal_A = mkTerm "pupal_A" ;
lin pupil_N = mkTerm "pupil_N" ;
lin pupillary_A = mkTerm "pupillary_A" ;
lin puppet_N = mkTerm "puppet_N" ;
lin puppeteer_N = mkTerm "puppeteer_N" ;
lin puppetry_N = mkTerm "puppetry_N" ;
lin puppy_N = mkTerm "puppy_N" ;
lin puppyish_A = mkTerm "puppyish_A" ;
lin purblind_A = mkTerm "purblind_A" ;
lin purchasable_A = mkTerm "purchasable_A" ;
lin purchase_N = mkTerm "purchase_N" ;
lin purchase_V2 = mkTerm "purchase_V2" ;
lin purchaser_N = mkTerm "purchaser_N" ;
lin purdah_N = mkTerm "purdah_N" ;
lin pure_A = mkTerm "pure_A" ;
lin purebred_A = mkTerm "purebred_A" ;
lin puree_N = mkTerm "puree_N" ;
lin pureness_N = mkTerm "pureness_N" ;
lin purgation_N = mkTerm "purgation_N" ;
lin purgative_A = mkTerm "purgative_A" ;
lin purgative_N = mkTerm "purgative_N" ;
lin purgatorial_A = mkTerm "purgatorial_A" ;
lin purgatory_N = mkTerm "purgatory_N" ;
lin purge_N = mkTerm "purge_N" ;
lin purge_V2 = mkTerm "purge_V2" ;
lin purification_N = mkTerm "purification_N" ;
lin purifier_N = mkTerm "purifier_N" ;
lin purify_V2 = mkTerm "purify_V2" ;
lin purifying_A = mkTerm "purifying_A" ;
lin purine_N = mkTerm "purine_N" ;
lin purism_N = mkTerm "purism_N" ;
lin purist_N = mkTerm "purist_N" ;
lin puritan_A = mkTerm "puritan_A" ;
lin puritan_N = mkTerm "puritan_N" ;
lin puritanical_A = mkTerm "puritanical_A" ;
lin puritanism_N = mkTerm "puritanism_N" ;
lin purity_N = mkTerm "purity_N" ;
lin purl_N = mkTerm "purl_N" ;
lin purl_V = mkTerm "purl_V" ;
lin purl_V2 = mkTerm "purl_V2" ;
lin purloin_V2 = mkTerm "purloin_V2" ;
lin purloo_N = mkTerm "purloo_N" ;
lin purple_A = mkTerm "purple_A" ;
lin purple_N = mkTerm "purple_N" ;
lin purplish_A = mkTerm "purplish_A" ;
lin purport_N = mkTerm "purport_N" ;
lin purport_V2 = mkTerm "purport_V2" ;
lin purport_V2V = mkTerm "purport_V2V" ;
lin purportedly_Adv = mkTerm "purportedly_Adv" ;
lin purpose_N = mkTerm "purpose_N" ;
lin purpose_V2 = mkTerm "purpose_V2" ;
lin purpose_built_A = mkTerm "purpose_built_A" ;
lin purposeful_A = mkTerm "purposeful_A" ;
lin purposefulness_N = mkTerm "purposefulness_N" ;
lin purposeless_A = mkTerm "purposeless_A" ;
lin purposelessness_N = mkTerm "purposelessness_N" ;
lin purposely_Adv = mkTerm "purposely_Adv" ;
lin purposive_A = mkTerm "purposive_A" ;
lin purpura_N = mkTerm "purpura_N" ;
lin purr_N = mkTerm "purr_N" ;
lin purr_V = mkTerm "purr_V" ;
lin purr_V2 = mkTerm "purr_V2" ;
lin purr_VS = mkTerm "purr_VS" ;
lin purse_N = mkTerm "purse_N" ;
lin purse_V2 = mkTerm "purse_V2" ;
lin purse_proud_A = mkTerm "purse_proud_A" ;
lin purser_N = mkTerm "purser_N" ;
lin purslane_N = mkTerm "purslane_N" ;
lin pursuance_N = mkTerm "pursuance_N" ;
lin pursuant_A = mkTerm "pursuant_A" ;
lin pursuant_to_Prep = mkTerm "pursuant_to_Prep" ;
lin pursue_V = mkTerm "pursue_V" ;
lin pursue_V2 = mkTerm "pursue_V2" ;
lin pursued_N = mkTerm "pursued_N" ;
lin pursuer_N = mkTerm "pursuer_N" ;
lin pursuit_N = mkTerm "pursuit_N" ;
lin pursy_A = mkTerm "pursy_A" ;
lin purulence_N = mkTerm "purulence_N" ;
lin purulent_A = mkTerm "purulent_A" ;
lin purvey_V = mkTerm "purvey_V" ;
lin purvey_V2 = mkTerm "purvey_V2" ;
lin purveyance_N = mkTerm "purveyance_N" ;
lin purveyor_N = mkTerm "purveyor_N" ;
lin purview_N = mkTerm "purview_N" ;
lin pus_N = mkTerm "pus_N" ;
lin pusan_PN = mkTerm "pusan_PN" ;
lin push_N = mkTerm "push_N" ;
lin push_V = mkTerm "push_V" ;
lin push_V2 = mkTerm "push_V2" ;
lin push_V2V = mkTerm "push_V2V" ;
lin push_VS = mkTerm "push_VS" ;
lin push_ahead_V = mkTerm "push_ahead_V" ;
lin push_around_V = mkTerm "push_around_V" ;
lin push_back_V = mkTerm "push_back_V" ;
lin push_bike_N = mkTerm "push_bike_N" ;
lin push_in_V2 = mkTerm "push_in_V2" ;
lin push_through_V = mkTerm "push_through_V" ;
lin push_up_V2 = mkTerm "push_up_V2" ;
lin pushball_N = mkTerm "pushball_N" ;
lin pushcart_N = mkTerm "pushcart_N" ;
lin pushchair_N = mkTerm "pushchair_N" ;
lin pusher_N = mkTerm "pusher_N" ;
lin pushful_A = mkTerm "pushful_A" ;
lin pushover_N = mkTerm "pushover_N" ;
lin pushup_N = mkTerm "pushup_N" ;
lin pusillanimity_N = mkTerm "pusillanimity_N" ;
lin pusillanimous_A = mkTerm "pusillanimous_A" ;
lin puss_N = mkTerm "puss_N" ;
lin pussy_N = mkTerm "pussy_N" ;
lin pussycat_N = mkTerm "pussycat_N" ;
lin pussyfoot_V = mkTerm "pussyfoot_V" ;
lin pustule_N = mkTerm "pustule_N" ;
lin put_N = mkTerm "put_N" ;
lin put_V2 = mkTerm "put_V2" ;
lin put_across_V = mkTerm "put_across_V" ;
lin put_across_V2 = mkTerm "put_across_V2" ;
lin put_aside_V = mkTerm "put_aside_V" ;
lin put_away_V = mkTerm "put_away_V" ;
lin put_away_V2 = mkTerm "put_away_V2" ;
lin put_back_V2 = mkTerm "put_back_V2" ;
lin put_by_V2 = mkTerm "put_by_V2" ;
lin put_down_N = mkTerm "put_down_N" ;
lin put_down_V = mkTerm "put_down_V" ;
lin put_down_V2 = mkTerm "put_down_V2" ;
lin put_down_for_V3 = mkTerm "put_down_for_V3" ;
lin put_down_to_V3 = mkTerm "put_down_to_V3" ;
lin put_forth_V = mkTerm "put_forth_V" ;
lin put_in_V = mkTerm "put_in_V" ;
lin put_in_V2 = mkTerm "put_in_V2" ;
lin put_in_for_V2 = mkTerm "put_in_for_V2" ;
lin put_off_V = mkTerm "put_off_V" ;
lin put_off_V2 = mkTerm "put_off_V2" ;
lin put_on_N = mkTerm "put_on_N" ;
lin put_on_V = mkTerm "put_on_V" ;
lin put_on_V2 = mkTerm "put_on_V2" ;
lin put_out_V = mkTerm "put_out_V" ;
lin put_out_V2 = mkTerm "put_out_V2" ;
lin put_over_V2 = mkTerm "put_over_V2" ;
lin put_through_V2 = mkTerm "put_through_V2" ;
lin put_together_V2 = mkTerm "put_together_V2" ;
lin put_towards_V2 = mkTerm "put_towards_V2" ;
lin put_up_V = mkTerm "put_up_V" ;
lin put_up_V2 = mkTerm "put_up_V2" ;
lin put_up_V2V = mkTerm "put_up_V2V" ;
lin put_up_with_V2 = mkTerm "put_up_with_V2" ;
lin put_upon_V = mkTerm "put_upon_V" ;
lin putamen_N = mkTerm "putamen_N" ;
lin putative_A = mkTerm "putative_A" ;
lin putdownable_A = mkTerm "putdownable_A" ;
lin putoff_N = mkTerm "putoff_N" ;
lin putout_N = mkTerm "putout_N" ;
lin putrefaction_N = mkTerm "putrefaction_N" ;
lin putrefactive_A = mkTerm "putrefactive_A" ;
lin putrefy_V = mkTerm "putrefy_V" ;
lin putrefy_V2 = mkTerm "putrefy_V2" ;
lin putrescence_N = mkTerm "putrescence_N" ;
lin putrescent_A = mkTerm "putrescent_A" ;
lin putrescine_N = mkTerm "putrescine_N" ;
lin putrid_A = mkTerm "putrid_A" ;
lin putridity_N = mkTerm "putridity_N" ;
lin putsch_N = mkTerm "putsch_N" ;
lin putt_N = mkTerm "putt_N" ;
lin putt_V = mkTerm "putt_V" ;
lin putt_V2 = mkTerm "putt_V2" ;
lin puttee_N = mkTerm "puttee_N" ;
lin putter_N = mkTerm "putter_N" ;
lin putter_V = mkTerm "putter_V" ;
lin putter_V2 = mkTerm "putter_V2" ;
lin putterer_N = mkTerm "putterer_N" ;
lin putting_green_N = mkTerm "putting_green_N" ;
lin putting_iron_N = mkTerm "putting_iron_N" ;
lin putty_N = mkTerm "putty_N" ;
lin putty_V2 = mkTerm "putty_V2" ;
lin puttyroot_N = mkTerm "puttyroot_N" ;
lin putz_N = mkTerm "putz_N" ;
lin puumala_PN = mkTerm "puumala_PN" ;
lin puzzle_N = mkTerm "puzzle_N" ;
lin puzzle_V2 = mkTerm "puzzle_V2" ;
lin puzzlement_N = mkTerm "puzzlement_N" ;
lin puzzler_N = mkTerm "puzzler_N" ;
lin pwllheli_PN = mkTerm "pwllheli_PN" ;
lin pya_N = mkTerm "pya_N" ;
lin pycnidium_N = mkTerm "pycnidium_N" ;
lin pycnodysostosis_N = mkTerm "pycnodysostosis_N" ;
lin pycnosis_N = mkTerm "pycnosis_N" ;
lin pyelitis_N = mkTerm "pyelitis_N" ;
lin pyelogram_N = mkTerm "pyelogram_N" ;
lin pyelography_N = mkTerm "pyelography_N" ;
lin pyelonephritis_N = mkTerm "pyelonephritis_N" ;
lin pyemia_N = mkTerm "pyemia_N" ;
lin pyemic_A = mkTerm "pyemic_A" ;
lin pygmy_N = mkTerm "pygmy_N" ;
lin pyhtää_PN = mkTerm "pyhtää_PN" ;
lin pyhäjoki_PN = mkTerm "pyhäjoki_PN" ;
lin pyhäjärvi_PN = mkTerm "pyhäjärvi_PN" ;
lin pyhäntä_PN = mkTerm "pyhäntä_PN" ;
lin pyhäranta_PN = mkTerm "pyhäranta_PN" ;
lin pyhäsalmi_PN = mkTerm "pyhäsalmi_PN" ;
lin pyhäselkä_PN = mkTerm "pyhäselkä_PN" ;
lin pyinma_N = mkTerm "pyinma_N" ;
lin pyjama_A = mkTerm "pyjama_A" ;
lin pyknotic_A = mkTerm "pyknotic_A" ;
lin pyle_PN = mkTerm "pyle_PN" ;
lin pylkönmäki_PN = mkTerm "pylkönmäki_PN" ;
lin pylon_N = mkTerm "pylon_N" ;
lin pyloric_A = mkTerm "pyloric_A" ;
lin pylorus_N = mkTerm "pylorus_N" ;
lin pyocyanase_N = mkTerm "pyocyanase_N" ;
lin pyocyanin_N = mkTerm "pyocyanin_N" ;
lin pyogenic_A = mkTerm "pyogenic_A" ;
lin pyongyang_PN = mkTerm "pyongyang_PN" ;
lin pyorrhea_N = mkTerm "pyorrhea_N" ;
lin pyorrhoea_N = mkTerm "pyorrhoea_N" ;
lin pyralid_N = mkTerm "pyralid_N" ;
lin pyramid_N = mkTerm "pyramid_N" ;
lin pyramidal_A = mkTerm "pyramidal_A" ;
lin pyramidically_Adv = mkTerm "pyramidically_Adv" ;
lin pyramiding_N = mkTerm "pyramiding_N" ;
lin pyre_N = mkTerm "pyre_N" ;
lin pyrectic_A = mkTerm "pyrectic_A" ;
lin pyrene_N = mkTerm "pyrene_N" ;
lin pyrethrum_N = mkTerm "pyrethrum_N" ;
lin pyretic_A = mkTerm "pyretic_A" ;
lin pyridine_N = mkTerm "pyridine_N" ;
lin pyrilamine_N = mkTerm "pyrilamine_N" ;
lin pyrimidine_N = mkTerm "pyrimidine_N" ;
lin pyrite_N = mkTerm "pyrite_N" ;
lin pyrites_N = mkTerm "pyrites_N" ;
lin pyrocellulose_N = mkTerm "pyrocellulose_N" ;
lin pyrochemical_A = mkTerm "pyrochemical_A" ;
lin pyroelectric_A = mkTerm "pyroelectric_A" ;
lin pyroelectricity_N = mkTerm "pyroelectricity_N" ;
lin pyrogallic_A = mkTerm "pyrogallic_A" ;
lin pyrogallol_N = mkTerm "pyrogallol_N" ;
lin pyrogen_N = mkTerm "pyrogen_N" ;
lin pyrogenic_A = mkTerm "pyrogenic_A" ;
lin pyrograph_N = mkTerm "pyrograph_N" ;
lin pyrographer_N = mkTerm "pyrographer_N" ;
lin pyrographic_A = mkTerm "pyrographic_A" ;
lin pyrography_N = mkTerm "pyrography_N" ;
lin pyrolatry_N = mkTerm "pyrolatry_N" ;
lin pyroligneous_A = mkTerm "pyroligneous_A" ;
lin pyrolusite_N = mkTerm "pyrolusite_N" ;
lin pyrolysis_N = mkTerm "pyrolysis_N" ;
lin pyrolytic_A = mkTerm "pyrolytic_A" ;
lin pyromancer_N = mkTerm "pyromancer_N" ;
lin pyromancy_N = mkTerm "pyromancy_N" ;
lin pyromania_N = mkTerm "pyromania_N" ;
lin pyromaniac_N = mkTerm "pyromaniac_N" ;
lin pyrometer_N = mkTerm "pyrometer_N" ;
lin pyromorphite_N = mkTerm "pyromorphite_N" ;
lin pyrope_N = mkTerm "pyrope_N" ;
lin pyrophobia_N = mkTerm "pyrophobia_N" ;
lin pyrophosphate_N = mkTerm "pyrophosphate_N" ;
lin pyrophyllite_N = mkTerm "pyrophyllite_N" ;
lin pyrostat_N = mkTerm "pyrostat_N" ;
lin pyrotechnic_A = mkTerm "pyrotechnic_A" ;
lin pyrotechnics_N = mkTerm "pyrotechnics_N" ;
lin pyroxene_N = mkTerm "pyroxene_N" ;
lin pyroxylin_N = mkTerm "pyroxylin_N" ;
lin pyrrhic_A = mkTerm "pyrrhic_A" ;
lin pyrrhic_N = mkTerm "pyrrhic_N" ;
lin pyrrhotite_N = mkTerm "pyrrhotite_N" ;
lin pyrrhuloxia_N = mkTerm "pyrrhuloxia_N" ;
lin pythium_N = mkTerm "pythium_N" ;
lin python_N = mkTerm "python_N" ;
lin pythoness_N = mkTerm "pythoness_N" ;
lin pyuria_N = mkTerm "pyuria_N" ;
lin pyx_N = mkTerm "pyx_N" ;
lin pyxidium_N = mkTerm "pyxidium_N" ;
lin pyxie_N = mkTerm "pyxie_N" ;
lin pyxis_N = mkTerm "pyxis_N" ;
lin pälkäne_PN = mkTerm "pälkäne_PN" ;
lin pöytyä_PN = mkTerm "pöytyä_PN" ;
lin qadi_N = mkTerm "qadi_N" ;
lin qatar_PN = mkTerm "qatar_PN" ;
lin qatari_A = mkTerm "qatari_A" ;
lin qatari_N = mkTerm "qatari_N" ;
lin qc_N = mkTerm "qc_N" ;
lin qed_PN = mkTerm "qed_PN" ;
lin qepiq_N = mkTerm "qepiq_N" ;
lin qi_N = mkTerm "qi_N" ;
lin qibla_N = mkTerm "qibla_N" ;
lin qindarka_N = mkTerm "qindarka_N" ;
lin qoph_N = mkTerm "qoph_N" ;
lin qt_N = mkTerm "qt_N" ;
lin qua_Prep = mkTerm "qua_Prep" ;
lin quack_Interj = mkTerm "quack_Interj" ;
lin quack_N = mkTerm "quack_N" ;
lin quack_V = mkTerm "quack_V" ;
lin quack_quack_N = mkTerm "quack_quack_N" ;
lin quackery_N = mkTerm "quackery_N" ;
lin quad_N = mkTerm "quad_N" ;
lin quadrangle_N = mkTerm "quadrangle_N" ;
lin quadrangular_A = mkTerm "quadrangular_A" ;
lin quadrant_N = mkTerm "quadrant_N" ;
lin quadrantanopia_N = mkTerm "quadrantanopia_N" ;
lin quadraphonic_A = mkTerm "quadraphonic_A" ;
lin quadraphony_N = mkTerm "quadraphony_N" ;
lin quadrate_A = mkTerm "quadrate_A" ;
lin quadrate_N = mkTerm "quadrate_N" ;
lin quadratic_A = mkTerm "quadratic_A" ;
lin quadratic_N = mkTerm "quadratic_N" ;
lin quadratics_N = mkTerm "quadratics_N" ;
lin quadrature_N = mkTerm "quadrature_N" ;
lin quadrennium_N = mkTerm "quadrennium_N" ;
lin quadric_N = mkTerm "quadric_N" ;
lin quadriceps_N = mkTerm "quadriceps_N" ;
lin quadrilateral_A = mkTerm "quadrilateral_A" ;
lin quadrilateral_N = mkTerm "quadrilateral_N" ;
lin quadrille_N = mkTerm "quadrille_N" ;
lin quadrillion_N = mkTerm "quadrillion_N" ;
lin quadrillionth_A = mkTerm "quadrillionth_A" ;
lin quadripara_N = mkTerm "quadripara_N" ;
lin quadripartite_A = mkTerm "quadripartite_A" ;
lin quadriplegia_N = mkTerm "quadriplegia_N" ;
lin quadriplegic_N = mkTerm "quadriplegic_N" ;
lin quadrivium_N = mkTerm "quadrivium_N" ;
lin quadroon_N = mkTerm "quadroon_N" ;
lin quadrophonic_A = mkTerm "quadrophonic_A" ;
lin quadrophony_N = mkTerm "quadrophony_N" ;
lin quadrumvirate_N = mkTerm "quadrumvirate_N" ;
lin quadruped_N = mkTerm "quadruped_N" ;
lin quadrupedal_A = mkTerm "quadrupedal_A" ;
lin quadruple_A = mkTerm "quadruple_A" ;
lin quadruple_N = mkTerm "quadruple_N" ;
lin quadruple_V = mkTerm "quadruple_V" ;
lin quadruple_V2 = mkTerm "quadruple_V2" ;
lin quadruplet_N = mkTerm "quadruplet_N" ;
lin quadruplicate_A = mkTerm "quadruplicate_A" ;
lin quadruplicate_N = mkTerm "quadruplicate_N" ;
lin quadruplicate_V2 = mkTerm "quadruplicate_V2" ;
lin quadrupling_N = mkTerm "quadrupling_N" ;
lin quaestor_N = mkTerm "quaestor_N" ;
lin quaff_N = mkTerm "quaff_N" ;
lin quaff_V = mkTerm "quaff_V" ;
lin quaff_V2 = mkTerm "quaff_V2" ;
lin quaffer_N = mkTerm "quaffer_N" ;
lin quagga_N = mkTerm "quagga_N" ;
lin quagmire_N = mkTerm "quagmire_N" ;
lin quahaug_N = mkTerm "quahaug_N" ;
lin quai_d'orsay_N = mkTerm "quai_d'orsay_N" ;
lin quail_N = mkTerm "quail_N" ;
lin quail_V = mkTerm "quail_V" ;
lin quaint_A = mkTerm "quaint_A" ;
lin quaintness_N = mkTerm "quaintness_N" ;
lin quake_N = mkTerm "quake_N" ;
lin quake_V = mkTerm "quake_V" ;
lin quaker_N = mkTerm "quaker_N" ;
lin qualification_N = mkTerm "qualification_N" ;
lin qualifications_N = mkTerm "qualifications_N" ;
lin qualified_A = mkTerm "qualified_A" ;
lin qualifier_N = mkTerm "qualifier_N" ;
lin qualify_V = mkTerm "qualify_V" ;
lin qualify_V2 = mkTerm "qualify_V2" ;
lin qualitative_A = mkTerm "qualitative_A" ;
lin quality_A = mkTerm "quality_A" ;
lin quality_N = mkTerm "quality_N" ;
lin qualm_N = mkTerm "qualm_N" ;
lin quandary_N = mkTerm "quandary_N" ;
lin quandong_N = mkTerm "quandong_N" ;
lin quango_N = mkTerm "quango_N" ;
lin quantal_A = mkTerm "quantal_A" ;
lin quantic_N = mkTerm "quantic_N" ;
lin quantifiability_N = mkTerm "quantifiability_N" ;
lin quantifiable_A = mkTerm "quantifiable_A" ;
lin quantification_N = mkTerm "quantification_N" ;
lin quantifier_N = mkTerm "quantifier_N" ;
lin quantify_V2 = mkTerm "quantify_V2" ;
lin quantitative_A = mkTerm "quantitative_A" ;
lin quantity_N = mkTerm "quantity_N" ;
lin quantization_N = mkTerm "quantization_N" ;
lin quantum_N = mkTerm "quantum_N" ;
lin quarantine_N = mkTerm "quarantine_N" ;
lin quarantine_V2 = mkTerm "quarantine_V2" ;
lin quark_N = mkTerm "quark_N" ;
lin quarrel_N = mkTerm "quarrel_N" ;
lin quarrel_V = mkTerm "quarrel_V" ;
lin quarrel_out_V = mkTerm "quarrel_out_V" ;
lin quarrel_with_V2 = mkTerm "quarrel_with_V2" ;
lin quarreler_N = mkTerm "quarreler_N" ;
lin quarrelsome_A = mkTerm "quarrelsome_A" ;
lin quarrelsomeness_N = mkTerm "quarrelsomeness_N" ;
lin quarry_N = mkTerm "quarry_N" ;
lin quarry_V = mkTerm "quarry_V" ;
lin quarry_V2 = mkTerm "quarry_V2" ;
lin quarrying_N = mkTerm "quarrying_N" ;
lin quarryman_N = mkTerm "quarryman_N" ;
lin quart_N = mkTerm "quart_N" ;
lin quartan_A = mkTerm "quartan_A" ;
lin quartan_N = mkTerm "quartan_N" ;
lin quarter_N = mkTerm "quarter_N" ;
lin quarter_V2 = mkTerm "quarter_V2" ;
lin quarter_day_N = mkTerm "quarter_day_N" ;
lin quarter_deck_N = mkTerm "quarter_deck_N" ;
lin quarter_plate_N = mkTerm "quarter_plate_N" ;
lin quarterback_N = mkTerm "quarterback_N" ;
lin quarterfinal_N = mkTerm "quarterfinal_N" ;
lin quartering_N = mkTerm "quartering_N" ;
lin quarterlight_N = mkTerm "quarterlight_N" ;
lin quarterly_A = mkTerm "quarterly_A" ;
lin quarterly_Adv = mkTerm "quarterly_Adv" ;
lin quarterly_N = mkTerm "quarterly_N" ;
lin quartermaster_N = mkTerm "quartermaster_N" ;
lin quartermaster_general_N = mkTerm "quartermaster_general_N" ;
lin quarterstaff_N = mkTerm "quarterstaff_N" ;
lin quartet_N = mkTerm "quartet_N" ;
lin quartile_N = mkTerm "quartile_N" ;
lin quarto_N = mkTerm "quarto_N" ;
lin quartz_N = mkTerm "quartz_N" ;
lin quartzite_N = mkTerm "quartzite_N" ;
lin quartzose_A = mkTerm "quartzose_A" ;
lin quasar_N = mkTerm "quasar_N" ;
lin quash_V2 = mkTerm "quash_V2" ;
lin quasiparticle_N = mkTerm "quasiparticle_N" ;
lin quassia_N = mkTerm "quassia_N" ;
lin quatercentenary_N = mkTerm "quatercentenary_N" ;
lin quatercentennial_N = mkTerm "quatercentennial_N" ;
lin quaternate_A = mkTerm "quaternate_A" ;
lin quatrain_N = mkTerm "quatrain_N" ;
lin quattrocento_N = mkTerm "quattrocento_N" ;
lin quaver_N = mkTerm "quaver_N" ;
lin quaver_V = mkTerm "quaver_V" ;
lin quaver_V2 = mkTerm "quaver_V2" ;
lin quaveringly_Adv = mkTerm "quaveringly_Adv" ;
lin quay_N = mkTerm "quay_N" ;
lin queasiness_N = mkTerm "queasiness_N" ;
lin queasy_A = mkTerm "queasy_A" ;
lin quebec_PN = mkTerm "quebec_PN" ;
lin queen_N = mkTerm "queen_N" ;
lin queen_V2 = mkTerm "queen_V2" ;
lin queenborough_in_sheppey_PN = mkTerm "queenborough_in_sheppey_PN" ;
lin queenly_A = mkTerm "queenly_A" ;
lin queensbury_PN = mkTerm "queensbury_PN" ;
lin queensferry_PN = mkTerm "queensferry_PN" ;
lin queensland_PN = mkTerm "queensland_PN" ;
lin queer_A = mkTerm "queer_A" ;
lin queer_N = mkTerm "queer_N" ;
lin queer_V2 = mkTerm "queer_V2" ;
lin queer_up_V2 = mkTerm "queer_up_V2" ;
lin queerness_N = mkTerm "queerness_N" ;
lin quell_V2 = mkTerm "quell_V2" ;
lin quellung_N = mkTerm "quellung_N" ;
lin quench_V2 = mkTerm "quench_V2" ;
lin quenchless_A = mkTerm "quenchless_A" ;
lin quentin_PN = mkTerm "quentin_PN" ;
lin quercitron_N = mkTerm "quercitron_N" ;
lin quern_N = mkTerm "quern_N" ;
lin querulous_A = mkTerm "querulous_A" ;
lin querulousness_N = mkTerm "querulousness_N" ;
lin query_N = mkTerm "query_N" ;
lin query_V = mkTerm "query_V" ;
lin query_V2 = mkTerm "query_V2" ;
lin quesadilla_N = mkTerm "quesadilla_N" ;
lin quest_N = mkTerm "quest_N" ;
lin quest_V = mkTerm "quest_V" ;
lin question_N = mkTerm "question_N" ;
lin question_V2 = mkTerm "question_V2" ;
lin question_mark_N = mkTerm "question_mark_N" ;
lin question_master_N = mkTerm "question_master_N" ;
lin questionable_A = mkTerm "questionable_A" ;
lin questioner_N = mkTerm "questioner_N" ;
lin questioning_A = mkTerm "questioning_A" ;
lin questioning_N = mkTerm "questioning_N" ;
lin questionnaire_N = mkTerm "questionnaire_N" ;
lin quetzal_N = mkTerm "quetzal_N" ;
lin queue_N = mkTerm "queue_N" ;
lin queue_V = mkTerm "queue_V" ;
lin qui_vive_N = mkTerm "qui_vive_N" ;
lin quibble_N = mkTerm "quibble_N" ;
lin quibble_V = mkTerm "quibble_V" ;
lin quibbler_N = mkTerm "quibbler_N" ;
lin quiche_N = mkTerm "quiche_N" ;
lin quick_A = mkTerm "quick_A" ;
lin quick_Adv = mkTerm "quick_Adv" ;
lin quick_N = mkTerm "quick_N" ;
lin quick_change_A = mkTerm "quick_change_A" ;
lin quick_eared_A = mkTerm "quick_eared_A" ;
lin quick_eyed_A = mkTerm "quick_eyed_A" ;
lin quick_freeze_V2 = mkTerm "quick_freeze_V2" ;
lin quick_sighted_A = mkTerm "quick_sighted_A" ;
lin quick_tempered_A = mkTerm "quick_tempered_A" ;
lin quick_witted_A = mkTerm "quick_witted_A" ;
lin quicken_V = mkTerm "quicken_V" ;
lin quicken_V2 = mkTerm "quicken_V2" ;
lin quickener_N = mkTerm "quickener_N" ;
lin quickening_N = mkTerm "quickening_N" ;
lin quicker_Adv = mkTerm "quicker_Adv" ;
lin quickest_Adv = mkTerm "quickest_Adv" ;
lin quickie_N = mkTerm "quickie_N" ;
lin quicklime_N = mkTerm "quicklime_N" ;
lin quickness_N = mkTerm "quickness_N" ;
lin quicksand_N = mkTerm "quicksand_N" ;
lin quickset_A = mkTerm "quickset_A" ;
lin quickset_N = mkTerm "quickset_N" ;
lin quicksilver_N = mkTerm "quicksilver_N" ;
lin quickstep_N = mkTerm "quickstep_N" ;
lin quid_N = mkTerm "quid_N" ;
lin quid_pro_quo_N = mkTerm "quid_pro_quo_N" ;
lin quiddity_N = mkTerm "quiddity_N" ;
lin quiescence_N = mkTerm "quiescence_N" ;
lin quiescent_A = mkTerm "quiescent_A" ;
lin quiet_A = mkTerm "quiet_A" ;
lin quiet_N = mkTerm "quiet_N" ;
lin quiet_V = mkTerm "quiet_V" ;
lin quiet_V2 = mkTerm "quiet_V2" ;
lin quiet_down_V2 = mkTerm "quiet_down_V2" ;
lin quieten_V = mkTerm "quieten_V" ;
lin quieten_V2 = mkTerm "quieten_V2" ;
lin quieten_down_V2 = mkTerm "quieten_down_V2" ;
lin quietism_N = mkTerm "quietism_N" ;
lin quietist_N = mkTerm "quietist_N" ;
lin quietly_Adv = mkTerm "quietly_Adv" ;
lin quietness_N = mkTerm "quietness_N" ;
lin quietude_N = mkTerm "quietude_N" ;
lin quietus_N = mkTerm "quietus_N" ;
lin quiff_N = mkTerm "quiff_N" ;
lin quill_N = mkTerm "quill_N" ;
lin quill_feather_N = mkTerm "quill_feather_N" ;
lin quillwort_N = mkTerm "quillwort_N" ;
lin quilt_N = mkTerm "quilt_N" ;
lin quilt_V2 = mkTerm "quilt_V2" ;
lin quilting_N = mkTerm "quilting_N" ;
lin quin_N = mkTerm "quin_N" ;
lin quinacrine_N = mkTerm "quinacrine_N" ;
lin quince_N = mkTerm "quince_N" ;
lin quincentenary_A = mkTerm "quincentenary_A" ;
lin quincentenary_N = mkTerm "quincentenary_N" ;
lin quincentennial_A = mkTerm "quincentennial_A" ;
lin quincentennial_N = mkTerm "quincentennial_N" ;
lin quinidine_N = mkTerm "quinidine_N" ;
lin quinine_N = mkTerm "quinine_N" ;
lin quinone_N = mkTerm "quinone_N" ;
lin quinquagesima_N = mkTerm "quinquagesima_N" ;
lin quinquagesima_PN = mkTerm "quinquagesima_PN" ;
lin quinquefoliate_A = mkTerm "quinquefoliate_A" ;
lin quinquennium_N = mkTerm "quinquennium_N" ;
lin quinsy_N = mkTerm "quinsy_N" ;
lin quintal_N = mkTerm "quintal_N" ;
lin quintessence_N = mkTerm "quintessence_N" ;
lin quintessential_A = mkTerm "quintessential_A" ;
lin quintet_N = mkTerm "quintet_N" ;
lin quintillion_N = mkTerm "quintillion_N" ;
lin quintillionth_A = mkTerm "quintillionth_A" ;
lin quintipara_N = mkTerm "quintipara_N" ;
lin quintuple_A = mkTerm "quintuple_A" ;
lin quintuplet_N = mkTerm "quintuplet_N" ;
lin quintupling_N = mkTerm "quintupling_N" ;
lin quip_N = mkTerm "quip_N" ;
lin quip_V = mkTerm "quip_V" ;
lin quip_VS = mkTerm "quip_VS" ;
lin quipu_N = mkTerm "quipu_N" ;
lin quira_N = mkTerm "quira_N" ;
lin quire_N = mkTerm "quire_N" ;
lin quirk_N = mkTerm "quirk_N" ;
lin quirky_A = mkTerm "quirky_A" ;
lin quirt_N = mkTerm "quirt_N" ;
lin quisling_N = mkTerm "quisling_N" ;
lin quit_V = mkTerm "quit_V" ;
lin quit_V2 = mkTerm "quit_V2" ;
lin quit_on_V2 = mkTerm "quit_on_V2" ;
lin quitclaim_N = mkTerm "quitclaim_N" ;
lin quite_AdA = mkTerm "quite_AdA" ;
lin quite_Predet = mkTerm "quite_Predet" ;
lin quito_PN = mkTerm "quito_PN" ;
lin quits_A = mkTerm "quits_A" ;
lin quittance_N = mkTerm "quittance_N" ;
lin quitter_N = mkTerm "quitter_N" ;
lin quiver_N = mkTerm "quiver_N" ;
lin quiver_V = mkTerm "quiver_V" ;
lin quiver_V2 = mkTerm "quiver_V2" ;
lin quixotic_A = mkTerm "quixotic_A" ;
lin quiz_N = mkTerm "quiz_N" ;
lin quiz_V2 = mkTerm "quiz_V2" ;
lin quizmaster_N = mkTerm "quizmaster_N" ;
lin quizzical_A = mkTerm "quizzical_A" ;
lin quodlibet_N = mkTerm "quodlibet_N" ;
lin quoin_N = mkTerm "quoin_N" ;
lin quoit_N = mkTerm "quoit_N" ;
lin quoits_N = mkTerm "quoits_N" ;
lin quonset_N = mkTerm "quonset_N" ;
lin quorum_N = mkTerm "quorum_N" ;
lin quot_V = mkTerm "quot_V" ;
lin quota_N = mkTerm "quota_N" ;
lin quotability_N = mkTerm "quotability_N" ;
lin quotable_A = mkTerm "quotable_A" ;
lin quotation_N = mkTerm "quotation_N" ;
lin quote_N = mkTerm "quote_N" ;
lin quote_V = mkTerm "quote_V" ;
lin quote_V2 = mkTerm "quote_V2" ;
lin quoter_N = mkTerm "quoter_N" ;
lin quotidian_A = mkTerm "quotidian_A" ;
lin quotient_N = mkTerm "quotient_N" ;
lin qurush_N = mkTerm "qurush_N" ;
lin qv_PN = mkTerm "qv_PN" ;
lin ra_N = mkTerm "ra_N" ;
lin raahe_PN = mkTerm "raahe_PN" ;
lin rabato_N = mkTerm "rabato_N" ;
lin rabbet_N = mkTerm "rabbet_N" ;
lin rabbi_N = mkTerm "rabbi_N" ;
lin rabbinate_N = mkTerm "rabbinate_N" ;
lin rabbinical_A = mkTerm "rabbinical_A" ;
lin rabbit_N = mkTerm "rabbit_N" ;
lin rabbit_V = mkTerm "rabbit_V" ;
lin rabbit_burrow_N = mkTerm "rabbit_burrow_N" ;
lin rabbit_hole_N = mkTerm "rabbit_hole_N" ;
lin rabbit_hutch_N = mkTerm "rabbit_hutch_N" ;
lin rabbit_punch_N = mkTerm "rabbit_punch_N" ;
lin rabbit_warren_N = mkTerm "rabbit_warren_N" ;
lin rabbitfish_N = mkTerm "rabbitfish_N" ;
lin rabbitweed_N = mkTerm "rabbitweed_N" ;
lin rabbitwood_N = mkTerm "rabbitwood_N" ;
lin rabble_N = mkTerm "rabble_N" ;
lin rabble_rousing_A = mkTerm "rabble_rousing_A" ;
lin rabelaisian_A = mkTerm "rabelaisian_A" ;
lin rabid_A = mkTerm "rabid_A" ;
lin rabies_N = mkTerm "rabies_N" ;
lin raccoon_N = mkTerm "raccoon_N" ;
lin race_1_N = mkTerm "race_1_N" ;
lin race_2_N = mkTerm "race_2_N" ;
lin race_V = mkTerm "race_V" ;
lin race_V2 = mkTerm "race_V2" ;
lin race_V2V = mkTerm "race_V2V" ;
lin race_VV = mkTerm "race_VV" ;
lin race_meeting_N = mkTerm "race_meeting_N" ;
lin race_off_V = mkTerm "race_off_V" ;
lin raceabout_N = mkTerm "raceabout_N" ;
lin racecard_N = mkTerm "racecard_N" ;
lin racecourse_N = mkTerm "racecourse_N" ;
lin racehorse_N = mkTerm "racehorse_N" ;
lin raceme_N = mkTerm "raceme_N" ;
lin racemose_A = mkTerm "racemose_A" ;
lin racer_N = mkTerm "racer_N" ;
lin racerunner_N = mkTerm "racerunner_N" ;
lin racetrack_N = mkTerm "racetrack_N" ;
lin raceway_N = mkTerm "raceway_N" ;
lin rachel_PN = mkTerm "rachel_PN" ;
lin rachis_N = mkTerm "rachis_N" ;
lin rachitis_N = mkTerm "rachitis_N" ;
lin racial_A = mkTerm "racial_A" ;
lin racialism_N = mkTerm "racialism_N" ;
lin racialist_N = mkTerm "racialist_N" ;
lin raciness_N = mkTerm "raciness_N" ;
lin racing_N = mkTerm "racing_N" ;
lin racism_N = mkTerm "racism_N" ;
lin racistFem_N = mkTerm "racistFem_N" ;
lin racistMasc_N = mkTerm "racistMasc_N" ;
lin racist_A = mkTerm "racist_A" ;
lin rack_N = mkTerm "rack_N" ;
lin rack_V2 = mkTerm "rack_V2" ;
lin rack_in_V = mkTerm "rack_in_V" ;
lin rack_off_V = mkTerm "rack_off_V" ;
lin rack_out_V = mkTerm "rack_out_V" ;
lin rack_railway_N = mkTerm "rack_railway_N" ;
lin rack_rent_N = mkTerm "rack_rent_N" ;
lin rack_up_V2 = mkTerm "rack_up_V2" ;
lin racker_N = mkTerm "racker_N" ;
lin racket_N = mkTerm "racket_N" ;
lin racket_V = mkTerm "racket_V" ;
lin racketeer_N = mkTerm "racketeer_N" ;
lin racketeering_N = mkTerm "racketeering_N" ;
lin rackety_A = mkTerm "rackety_A" ;
lin raconteur_N = mkTerm "raconteur_N" ;
lin racoon_N = mkTerm "racoon_N" ;
lin racquet_N = mkTerm "racquet_N" ;
lin racquetball_N = mkTerm "racquetball_N" ;
lin racy_A = mkTerm "racy_A" ;
lin rad_N = mkTerm "rad_N" ;
lin rada_PN = mkTerm "rada_PN" ;
lin radar_N = mkTerm "radar_N" ;
lin radcliffe_PN = mkTerm "radcliffe_PN" ;
lin radcliffe_on_trent_PN = mkTerm "radcliffe_on_trent_PN" ;
lin raddled_A = mkTerm "raddled_A" ;
lin radial_A = mkTerm "radial_A" ;
lin radial_N = mkTerm "radial_N" ;
lin radian_N = mkTerm "radian_N" ;
lin radiance_N = mkTerm "radiance_N" ;
lin radiant_A = mkTerm "radiant_A" ;
lin radiate_A = mkTerm "radiate_A" ;
lin radiate_V = mkTerm "radiate_V" ;
lin radiate_V2 = mkTerm "radiate_V2" ;
lin radiation_N = mkTerm "radiation_N" ;
lin radiator_N = mkTerm "radiator_N" ;
lin radical_A = mkTerm "radical_A" ;
lin radical_N = mkTerm "radical_N" ;
lin radicalism_N = mkTerm "radicalism_N" ;
lin radicchio_N = mkTerm "radicchio_N" ;
lin radicle_N = mkTerm "radicle_N" ;
lin radiculitis_N = mkTerm "radiculitis_N" ;
lin radio_A = mkTerm "radio_A" ;
lin radio_N = mkTerm "radio_N" ;
lin radio_V2 = mkTerm "radio_V2" ;
lin radio_gramophone_N = mkTerm "radio_gramophone_N" ;
lin radio_location_N = mkTerm "radio_location_N" ;
lin radio_set_N = mkTerm "radio_set_N" ;
lin radio_telescope_N = mkTerm "radio_telescope_N" ;
lin radioactive_A = mkTerm "radioactive_A" ;
lin radioactivity_N = mkTerm "radioactivity_N" ;
lin radiobiologist_N = mkTerm "radiobiologist_N" ;
lin radiobiology_N = mkTerm "radiobiology_N" ;
lin radiocarbon_N = mkTerm "radiocarbon_N" ;
lin radiochemistry_N = mkTerm "radiochemistry_N" ;
lin radiochlorine_N = mkTerm "radiochlorine_N" ;
lin radiogram_N = mkTerm "radiogram_N" ;
lin radiograph_N = mkTerm "radiograph_N" ;
lin radiographer_N = mkTerm "radiographer_N" ;
lin radiographic_A = mkTerm "radiographic_A" ;
lin radiography_N = mkTerm "radiography_N" ;
lin radioimmunoassay_N = mkTerm "radioimmunoassay_N" ;
lin radioisotope_N = mkTerm "radioisotope_N" ;
lin radiolarian_N = mkTerm "radiolarian_N" ;
lin radiological_A = mkTerm "radiological_A" ;
lin radiologist_N = mkTerm "radiologist_N" ;
lin radiology_N = mkTerm "radiology_N" ;
lin radiolucent_A = mkTerm "radiolucent_A" ;
lin radiolysis_N = mkTerm "radiolysis_N" ;
lin radiometer_N = mkTerm "radiometer_N" ;
lin radiomicrometer_N = mkTerm "radiomicrometer_N" ;
lin radiopacity_N = mkTerm "radiopacity_N" ;
lin radiopaque_A = mkTerm "radiopaque_A" ;
lin radiopharmaceutical_N = mkTerm "radiopharmaceutical_N" ;
lin radiophotograph_N = mkTerm "radiophotograph_N" ;
lin radiophotography_N = mkTerm "radiophotography_N" ;
lin radioprotection_N = mkTerm "radioprotection_N" ;
lin radioscopy_N = mkTerm "radioscopy_N" ;
lin radiosensitive_A = mkTerm "radiosensitive_A" ;
lin radiotelegraph_N = mkTerm "radiotelegraph_N" ;
lin radiotelephone_N = mkTerm "radiotelephone_N" ;
lin radiotelephonic_A = mkTerm "radiotelephonic_A" ;
lin radiotherapist_N = mkTerm "radiotherapist_N" ;
lin radiotherapy_N = mkTerm "radiotherapy_N" ;
lin radish_N = mkTerm "radish_N" ;
lin radium_N = mkTerm "radium_N" ;
lin radius_N = mkTerm "radius_N" ;
lin radlett_PN = mkTerm "radlett_PN" ;
lin radome_N = mkTerm "radome_N" ;
lin radon_N = mkTerm "radon_N" ;
lin radstock_PN = mkTerm "radstock_PN" ;
lin raf_N = mkTerm "raf_N" ;
lin raffia_N = mkTerm "raffia_N" ;
lin raffinose_N = mkTerm "raffinose_N" ;
lin raffish_A = mkTerm "raffish_A" ;
lin raffle_N = mkTerm "raffle_N" ;
lin raffle_V2 = mkTerm "raffle_V2" ;
lin raft_N = mkTerm "raft_N" ;
lin raft_V = mkTerm "raft_V" ;
lin raft_V2 = mkTerm "raft_V2" ;
lin rafter_N = mkTerm "rafter_N" ;
lin raftered_A = mkTerm "raftered_A" ;
lin raftsman_N = mkTerm "raftsman_N" ;
lin rag_N = mkTerm "rag_N" ;
lin rag_V2 = mkTerm "rag_V2" ;
lin rag_day_N = mkTerm "rag_day_N" ;
lin ragamuffin_N = mkTerm "ragamuffin_N" ;
lin ragbag_N = mkTerm "ragbag_N" ;
lin rage_N = mkTerm "rage_N" ;
lin rage_V = mkTerm "rage_V" ;
lin raggedly_Adv = mkTerm "raggedly_Adv" ;
lin raggedness_N = mkTerm "raggedness_N" ;
lin raglan_N = mkTerm "raglan_N" ;
lin ragout_N = mkTerm "ragout_N" ;
lin ragpicker_N = mkTerm "ragpicker_N" ;
lin ragsorter_N = mkTerm "ragsorter_N" ;
lin ragtag_N = mkTerm "ragtag_N" ;
lin ragtime_N = mkTerm "ragtime_N" ;
lin ragweed_N = mkTerm "ragweed_N" ;
lin ragwort_N = mkTerm "ragwort_N" ;
lin raid_N = mkTerm "raid_N" ;
lin raid_V = mkTerm "raid_V" ;
lin raid_V2 = mkTerm "raid_V2" ;
lin raider_N = mkTerm "raider_N" ;
lin rail_N = mkTerm "rail_N" ;
lin rail_V = mkTerm "rail_V" ;
lin rail_V2 = mkTerm "rail_V2" ;
lin railbird_N = mkTerm "railbird_N" ;
lin railcar_N = mkTerm "railcar_N" ;
lin railhead_N = mkTerm "railhead_N" ;
lin railing_N = mkTerm "railing_N" ;
lin raillery_N = mkTerm "raillery_N" ;
lin railroad_N = mkTerm "railroad_N" ;
lin railroad_V2 = mkTerm "railroad_V2" ;
lin railway_N = mkTerm "railway_N" ;
lin railwayman_N = mkTerm "railwayman_N" ;
lin raiment_N = mkTerm "raiment_N" ;
lin rain_N = mkTerm "rain_N" ;
lin rain_V = mkTerm "rain_V" ;
lin rain_V2 = mkTerm "rain_V2" ;
lin rain_down_on_V2 = mkTerm "rain_down_on_V2" ;
lin rain_gauge_N = mkTerm "rain_gauge_N" ;
lin rain_off_V = mkTerm "rain_off_V" ;
lin rain_out_V = mkTerm "rain_out_V" ;
lin rainbow_N = mkTerm "rainbow_N" ;
lin raincoat_N = mkTerm "raincoat_N" ;
lin raindrop_N = mkTerm "raindrop_N" ;
lin rainfall_N = mkTerm "rainfall_N" ;
lin rainford_PN = mkTerm "rainford_PN" ;
lin rainforest_N = mkTerm "rainforest_N" ;
lin rainless_A = mkTerm "rainless_A" ;
lin rainmaker_N = mkTerm "rainmaker_N" ;
lin rainmaking_N = mkTerm "rainmaking_N" ;
lin rainproof_A = mkTerm "rainproof_A" ;
lin rainstorm_N = mkTerm "rainstorm_N" ;
lin rainwater_N = mkTerm "rainwater_N" ;
lin rainy_A = mkTerm "rainy_A" ;
lin raisable_A = mkTerm "raisable_A" ;
lin raise_N = mkTerm "raise_N" ;
lin raise_V2 = mkTerm "raise_V2" ;
lin raised_A = mkTerm "raised_A" ;
lin raiser_N = mkTerm "raiser_N" ;
lin raisin_N = mkTerm "raisin_N" ;
lin raising_A = mkTerm "raising_A" ;
lin raising_N = mkTerm "raising_N" ;
lin raisio_PN = mkTerm "raisio_PN" ;
lin raison_d'etre_N = mkTerm "raison_d'etre_N" ;
lin raita_N = mkTerm "raita_N" ;
lin raj_N = mkTerm "raj_N" ;
lin raja_N = mkTerm "raja_N" ;
lin rajah_N = mkTerm "rajah_N" ;
lin rajanya_N = mkTerm "rajanya_N" ;
lin rake_N = mkTerm "rake_N" ;
lin rake_V = mkTerm "rake_V" ;
lin rake_V2 = mkTerm "rake_V2" ;
lin rake_in_V2 = mkTerm "rake_in_V2" ;
lin rake_it_in_V2 = mkTerm "rake_it_in_V2" ;
lin rake_off_N = mkTerm "rake_off_N" ;
lin rake_off_V2 = mkTerm "rake_off_V2" ;
lin rake_over_V2 = mkTerm "rake_over_V2" ;
lin rake_up_V2 = mkTerm "rake_up_V2" ;
lin rakish_A = mkTerm "rakish_A" ;
lin rakishness_N = mkTerm "rakishness_N" ;
lin rallentando_A = mkTerm "rallentando_A" ;
lin rallentando_Adv = mkTerm "rallentando_Adv" ;
lin rally_N = mkTerm "rally_N" ;
lin rally_V = mkTerm "rally_V" ;
lin rally_V2 = mkTerm "rally_V2" ;
lin rally_V2V = mkTerm "rally_V2V" ;
lin rallying_N = mkTerm "rallying_N" ;
lin ralph_PN = mkTerm "ralph_PN" ;
lin ram_N = mkTerm "ram_N" ;
lin ram_V2 = mkTerm "ram_V2" ;
lin ramadan_N = mkTerm "ramadan_N" ;
lin ramadan_PN = mkTerm "ramadan_PN" ;
lin ramble_N = mkTerm "ramble_N" ;
lin ramble_V = mkTerm "ramble_V" ;
lin ramble_on_V = mkTerm "ramble_on_V" ;
lin rambler_N = mkTerm "rambler_N" ;
lin rambunctious_A = mkTerm "rambunctious_A" ;
lin rambutan_N = mkTerm "rambutan_N" ;
lin ramekin_N = mkTerm "ramekin_N" ;
lin ramie_N = mkTerm "ramie_N" ;
lin ramification_N = mkTerm "ramification_N" ;
lin ramify_V = mkTerm "ramify_V" ;
lin ramify_V2 = mkTerm "ramify_V2" ;
lin ramipril_N = mkTerm "ramipril_N" ;
lin ramjet_N = mkTerm "ramjet_N" ;
lin rammer_N = mkTerm "rammer_N" ;
lin ramp_N = mkTerm "ramp_N" ;
lin ramp_V2 = mkTerm "ramp_V2" ;
lin ramp_up_V2 = mkTerm "ramp_up_V2" ;
lin rampage_N = mkTerm "rampage_N" ;
lin rampage_V = mkTerm "rampage_V" ;
lin rampageous_A = mkTerm "rampageous_A" ;
lin rampant_A = mkTerm "rampant_A" ;
lin rampart_N = mkTerm "rampart_N" ;
lin rampion_N = mkTerm "rampion_N" ;
lin ramrod_N = mkTerm "ramrod_N" ;
lin ramsbottom_PN = mkTerm "ramsbottom_PN" ;
lin ramsgate_PN = mkTerm "ramsgate_PN" ;
lin ramshackle_A = mkTerm "ramshackle_A" ;
lin ramus_N = mkTerm "ramus_N" ;
lin ranch_N = mkTerm "ranch_N" ;
lin rancher_N = mkTerm "rancher_N" ;
lin ranching_N = mkTerm "ranching_N" ;
lin rancid_A = mkTerm "rancid_A" ;
lin rancidity_N = mkTerm "rancidity_N" ;
lin rancidness_N = mkTerm "rancidness_N" ;
lin rancorous_A = mkTerm "rancorous_A" ;
lin rancour_N = mkTerm "rancour_N" ;
lin rand_N = mkTerm "rand_N" ;
lin randolph_PN = mkTerm "randolph_PN" ;
lin random_A = mkTerm "random_A" ;
lin random_N = mkTerm "random_N" ;
lin randomization_N = mkTerm "randomization_N" ;
lin randomized_A = mkTerm "randomized_A" ;
lin randomness_N = mkTerm "randomness_N" ;
lin randy_A = mkTerm "randy_A" ;
lin ranee_N = mkTerm "ranee_N" ;
lin rang_up_V = mkTerm "rang_up_V" ;
lin range_N = mkTerm "range_N" ;
lin range_V = mkTerm "range_V" ;
lin rangefinder_N = mkTerm "rangefinder_N" ;
lin rangeland_N = mkTerm "rangeland_N" ;
lin ranger_N = mkTerm "ranger_N" ;
lin rangoon_PN = mkTerm "rangoon_PN" ;
lin rangpur_N = mkTerm "rangpur_N" ;
lin rangy_A = mkTerm "rangy_A" ;
lin rani_N = mkTerm "rani_N" ;
lin ranitidine_N = mkTerm "ranitidine_N" ;
lin rank_A = mkTerm "rank_A" ;
lin rank_N = mkTerm "rank_N" ;
lin rank_V = mkTerm "rank_V" ;
lin rank_V2 = mkTerm "rank_V2" ;
lin ranker_N = mkTerm "ranker_N" ;
lin ranking_N = mkTerm "ranking_N" ;
lin rankle_V = mkTerm "rankle_V" ;
lin rankness_N = mkTerm "rankness_N" ;
lin ransack_V2 = mkTerm "ransack_V2" ;
lin ransacking_N = mkTerm "ransacking_N" ;
lin ransom_N = mkTerm "ransom_N" ;
lin ransom_V2 = mkTerm "ransom_V2" ;
lin rant_N = mkTerm "rant_N" ;
lin rant_V = mkTerm "rant_V" ;
lin rant_V2 = mkTerm "rant_V2" ;
lin rantasalmi_PN = mkTerm "rantasalmi_PN" ;
lin ranter_N = mkTerm "ranter_N" ;
lin rantsila_PN = mkTerm "rantsila_PN" ;
lin ranua_PN = mkTerm "ranua_PN" ;
lin ranula_N = mkTerm "ranula_N" ;
lin rap_N = mkTerm "rap_N" ;
lin rap_V = mkTerm "rap_V" ;
lin rap_V2 = mkTerm "rap_V2" ;
lin rap_out_V2 = mkTerm "rap_out_V2" ;
lin rapacious_A = mkTerm "rapacious_A" ;
lin rapacity_N = mkTerm "rapacity_N" ;
lin rape_N = mkTerm "rape_N" ;
lin rape_V2 = mkTerm "rape_V2" ;
lin raper_N = mkTerm "raper_N" ;
lin rapeseed_N = mkTerm "rapeseed_N" ;
lin raphe_N = mkTerm "raphe_N" ;
lin rapid_A = mkTerm "rapid_A" ;
lin rapid_N = mkTerm "rapid_N" ;
lin rapidity_N = mkTerm "rapidity_N" ;
lin rapier_N = mkTerm "rapier_N" ;
lin rapier_thrust_N = mkTerm "rapier_thrust_N" ;
lin rapine_N = mkTerm "rapine_N" ;
lin rapist_N = mkTerm "rapist_N" ;
lin rappee_N = mkTerm "rappee_N" ;
lin rappel_N = mkTerm "rappel_N" ;
lin rapper_N = mkTerm "rapper_N" ;
lin rapport_N = mkTerm "rapport_N" ;
lin rapporteur_N = mkTerm "rapporteur_N" ;
lin rapprochement_N = mkTerm "rapprochement_N" ;
lin rapscallion_N = mkTerm "rapscallion_N" ;
lin rapt_A = mkTerm "rapt_A" ;
lin raptorial_A = mkTerm "raptorial_A" ;
lin rapture_N = mkTerm "rapture_N" ;
lin rapturous_A = mkTerm "rapturous_A" ;
lin rare_A = mkTerm "rare_A" ;
lin rarebit_N = mkTerm "rarebit_N" ;
lin rarefaction_N = mkTerm "rarefaction_N" ;
lin rarefy_V = mkTerm "rarefy_V" ;
lin rarefy_V2 = mkTerm "rarefy_V2" ;
lin rareness_N = mkTerm "rareness_N" ;
lin raring_A = mkTerm "raring_A" ;
lin rariora_N = mkTerm "rariora_N" ;
lin rarity_N = mkTerm "rarity_N" ;
lin rascal_N = mkTerm "rascal_N" ;
lin rascality_N = mkTerm "rascality_N" ;
lin rascally_A = mkTerm "rascally_A" ;
lin rase_V2 = mkTerm "rase_V2" ;
lin rash_A = mkTerm "rash_A" ;
lin rash_N = mkTerm "rash_N" ;
lin rasher_N = mkTerm "rasher_N" ;
lin rashness_N = mkTerm "rashness_N" ;
lin rasp_N = mkTerm "rasp_N" ;
lin rasp_V = mkTerm "rasp_V" ;
lin rasp_V2 = mkTerm "rasp_V2" ;
lin raspberry_N = mkTerm "raspberry_N" ;
lin raspingly_Adv = mkTerm "raspingly_Adv" ;
lin raster_N = mkTerm "raster_N" ;
lin rat_N = mkTerm "rat_N" ;
lin rat_V = mkTerm "rat_V" ;
lin rat_V2 = mkTerm "rat_V2" ;
lin rat_a_tat_tat_N = mkTerm "rat_a_tat_tat_N" ;
lin rat_on_V2 = mkTerm "rat_on_V2" ;
lin rat_out_V2 = mkTerm "rat_out_V2" ;
lin rat_tat_N = mkTerm "rat_tat_N" ;
lin rat_through_V2 = mkTerm "rat_through_V2" ;
lin ratability_N = mkTerm "ratability_N" ;
lin ratable_A = mkTerm "ratable_A" ;
lin ratables_N = mkTerm "ratables_N" ;
lin ratafia_N = mkTerm "ratafia_N" ;
lin ratan_N = mkTerm "ratan_N" ;
lin ratatouille_N = mkTerm "ratatouille_N" ;
lin ratch_N = mkTerm "ratch_N" ;
lin ratchet_N = mkTerm "ratchet_N" ;
lin ratchet_up_V2 = mkTerm "ratchet_up_V2" ;
lin rate_N = mkTerm "rate_N" ;
lin rate_V = mkTerm "rate_V" ;
lin rate_V2 = mkTerm "rate_V2" ;
lin rateability_N = mkTerm "rateability_N" ;
lin rateable_A = mkTerm "rateable_A" ;
lin ratel_N = mkTerm "ratel_N" ;
lin ratepayer_N = mkTerm "ratepayer_N" ;
lin rates_N = mkTerm "rates_N" ;
lin rather_Adv = mkTerm "rather_Adv" ;
lin rather_than_Conj = mkTerm "rather_than_Conj" ;
lin rather_than_Prep = mkTerm "rather_than_Prep" ;
lin rathole_N = mkTerm "rathole_N" ;
lin rathskeller_N = mkTerm "rathskeller_N" ;
lin ratification_N = mkTerm "ratification_N" ;
lin ratify_V2 = mkTerm "ratify_V2" ;
lin rating_N = mkTerm "rating_N" ;
lin ratio_N = mkTerm "ratio_N" ;
lin ratiocination_N = mkTerm "ratiocination_N" ;
lin ratiocinative_A = mkTerm "ratiocinative_A" ;
lin ration_N = mkTerm "ration_N" ;
lin ration_V2 = mkTerm "ration_V2" ;
lin rational_A = mkTerm "rational_A" ;
lin rationale_N = mkTerm "rationale_N" ;
lin rationalism_N = mkTerm "rationalism_N" ;
lin rationalistFem_N = mkTerm "rationalistFem_N" ;
lin rationalistMasc_N = mkTerm "rationalistMasc_N" ;
lin rationalist_A = mkTerm "rationalist_A" ;
lin rationalistic_A = mkTerm "rationalistic_A" ;
lin rationality_N = mkTerm "rationality_N" ;
lin rationalization_N = mkTerm "rationalization_N" ;
lin rationalize_V2 = mkTerm "rationalize_V2" ;
lin rationing_N = mkTerm "rationing_N" ;
lin ratite_N = mkTerm "ratite_N" ;
lin ratlike_A = mkTerm "ratlike_A" ;
lin ratlin_N = mkTerm "ratlin_N" ;
lin ratline_N = mkTerm "ratline_N" ;
lin rattan_N = mkTerm "rattan_N" ;
lin ratter_N = mkTerm "ratter_N" ;
lin rattle_N = mkTerm "rattle_N" ;
lin rattle_V = mkTerm "rattle_V" ;
lin rattle_V2 = mkTerm "rattle_V2" ;
lin rattle_off_V2 = mkTerm "rattle_off_V2" ;
lin rattlebrained_A = mkTerm "rattlebrained_A" ;
lin rattlepated_A = mkTerm "rattlepated_A" ;
lin rattler_N = mkTerm "rattler_N" ;
lin rattlesnake_N = mkTerm "rattlesnake_N" ;
lin rattling_Adv = mkTerm "rattling_Adv" ;
lin rattrap_N = mkTerm "rattrap_N" ;
lin ratty_A = mkTerm "ratty_A" ;
lin raucous_A = mkTerm "raucous_A" ;
lin rauma_PN = mkTerm "rauma_PN" ;
lin raunchy_A = mkTerm "raunchy_A" ;
lin rautalampi_PN = mkTerm "rautalampi_PN" ;
lin rautavaara_PN = mkTerm "rautavaara_PN" ;
lin rautjärvi_PN = mkTerm "rautjärvi_PN" ;
lin rauwolfia_N = mkTerm "rauwolfia_N" ;
lin ravage_N = mkTerm "ravage_N" ;
lin ravage_V = mkTerm "ravage_V" ;
lin ravage_V2 = mkTerm "ravage_V2" ;
lin ravaging_N = mkTerm "ravaging_N" ;
lin rave_N = mkTerm "rave_N" ;
lin rave_V = mkTerm "rave_V" ;
lin rave_V2 = mkTerm "rave_V2" ;
lin rave_up_N = mkTerm "rave_up_N" ;
lin ravehook_N = mkTerm "ravehook_N" ;
lin ravel_V = mkTerm "ravel_V" ;
lin ravel_V2 = mkTerm "ravel_V2" ;
lin raveling_N = mkTerm "raveling_N" ;
lin raven_N = mkTerm "raven_N" ;
lin ravening_A = mkTerm "ravening_A" ;
lin ravenna_PN = mkTerm "ravenna_PN" ;
lin ravenous_A = mkTerm "ravenous_A" ;
lin raver_N = mkTerm "raver_N" ;
lin ravigote_N = mkTerm "ravigote_N" ;
lin ravine_N = mkTerm "ravine_N" ;
lin raving_Adv = mkTerm "raving_Adv" ;
lin raving_N = mkTerm "raving_N" ;
lin ravioli_N = mkTerm "ravioli_N" ;
lin ravish_V2 = mkTerm "ravish_V2" ;
lin ravishing_A = mkTerm "ravishing_A" ;
lin ravishment_N = mkTerm "ravishment_N" ;
lin raw_A = mkTerm "raw_A" ;
lin raw_N = mkTerm "raw_N" ;
lin rawboned_A = mkTerm "rawboned_A" ;
lin rawhide_A = mkTerm "rawhide_A" ;
lin rawhide_N = mkTerm "rawhide_N" ;
lin rawness_N = mkTerm "rawness_N" ;
lin rawtenstall_PN = mkTerm "rawtenstall_PN" ;
lin ray_N = mkTerm "ray_N" ;
lin ray_PN = mkTerm "ray_PN" ;
lin ray_V = mkTerm "ray_V" ;
lin ray_V2 = mkTerm "ray_V2" ;
lin rayless_A = mkTerm "rayless_A" ;
lin raymond_PN = mkTerm "raymond_PN" ;
lin rayon_N = mkTerm "rayon_N" ;
lin razbliuto_N = mkTerm "razbliuto_N" ;
lin raze_V2 = mkTerm "raze_V2" ;
lin razing_N = mkTerm "razing_N" ;
lin razor_N = mkTerm "razor_N" ;
lin razor_V2 = mkTerm "razor_V2" ;
lin razor_edge_N = mkTerm "razor_edge_N" ;
lin razorback_A = mkTerm "razorback_A" ;
lin razorback_N = mkTerm "razorback_N" ;
lin razorbacked_A = mkTerm "razorbacked_A" ;
lin razorbill_N = mkTerm "razorbill_N" ;
lin razorblade_N = mkTerm "razorblade_N" ;
lin razzle_N = mkTerm "razzle_N" ;
lin razzle_dazzle_N = mkTerm "razzle_dazzle_N" ;
lin rc_PN = mkTerm "rc_PN" ;
lin rd_PN = mkTerm "rd_PN" ;
lin re_N = mkTerm "re_N" ;
lin re_Prep = mkTerm "re_Prep" ;
lin re_address_V2 = mkTerm "re_address_V2" ;
lin re_afforest_V2 = mkTerm "re_afforest_V2" ;
lin re_afforestation_N = mkTerm "re_afforestation_N" ;
lin re_count_N = mkTerm "re_count_N" ;
lin re_count_V2 = mkTerm "re_count_V2" ;
lin re_cover_V2 = mkTerm "re_cover_V2" ;
lin re_create_V2 = mkTerm "re_create_V2" ;
lin re_echo_N = mkTerm "re_echo_N" ;
lin re_echo_V = mkTerm "re_echo_V" ;
lin re_elect_V2 = mkTerm "re_elect_V2" ;
lin re_emerge_V = mkTerm "re_emerge_V" ;
lin re_emphasize_V2 = mkTerm "re_emphasize_V2" ;
lin re_enter_V = mkTerm "re_enter_V" ;
lin re_enter_V2 = mkTerm "re_enter_V2" ;
lin re_entry_N = mkTerm "re_entry_N" ;
lin re_establish_V2 = mkTerm "re_establish_V2" ;
lin re_evaluate_V2 = mkTerm "re_evaluate_V2" ;
lin re_examine_V2 = mkTerm "re_examine_V2" ;
lin re_form_V = mkTerm "re_form_V" ;
lin re_form_V2 = mkTerm "re_form_V2" ;
lin re_formation_N = mkTerm "re_formation_N" ;
lin re_join_V2 = mkTerm "re_join_V2" ;
lin re_supply_V2 = mkTerm "re_supply_V2" ;
lin reach_N = mkTerm "reach_N" ;
lin reach_V = mkTerm "reach_V" ;
lin reach_V2 = mkTerm "reach_V2" ;
lin reach_out_V = mkTerm "reach_out_V" ;
lin reach_out_for_V2 = mkTerm "reach_out_for_V2" ;
lin reach_out_to_V2 = mkTerm "reach_out_to_V2" ;
lin react_V = mkTerm "react_V" ;
lin reactance_N = mkTerm "reactance_N" ;
lin reactant_N = mkTerm "reactant_N" ;
lin reaction_N = mkTerm "reaction_N" ;
lin reactionary_A = mkTerm "reactionary_A" ;
lin reactionary_N = mkTerm "reactionary_N" ;
lin reactionism_N = mkTerm "reactionism_N" ;
lin reactivate_V2 = mkTerm "reactivate_V2" ;
lin reactive_A = mkTerm "reactive_A" ;
lin reactivity_N = mkTerm "reactivity_N" ;
lin reactor_N = mkTerm "reactor_N" ;
lin read_N = mkTerm "read_N" ;
lin read_V = mkTerm "read_V" ;
lin read_V2 = mkTerm "read_V2" ;
lin read_VS = mkTerm "read_VS" ;
lin read_off_V2 = mkTerm "read_off_V2" ;
lin read_out_V2 = mkTerm "read_out_V2" ;
lin read_up_on_V2 = mkTerm "read_up_on_V2" ;
lin readability_N = mkTerm "readability_N" ;
lin readable_A = mkTerm "readable_A" ;
lin reader_N = mkTerm "reader_N" ;
lin readership_N = mkTerm "readership_N" ;
lin readiness_N = mkTerm "readiness_N" ;
lin reading_N = mkTerm "reading_N" ;
lin reading_PN = mkTerm "reading_PN" ;
lin reading_lamp_N = mkTerm "reading_lamp_N" ;
lin reading_room_N = mkTerm "reading_room_N" ;
lin readjust_V2 = mkTerm "readjust_V2" ;
lin readjustment_N = mkTerm "readjustment_N" ;
lin readmission_N = mkTerm "readmission_N" ;
lin readmit_V2 = mkTerm "readmit_V2" ;
lin readout_N = mkTerm "readout_N" ;
lin ready_A = mkTerm "ready_A" ;
lin ready_N = mkTerm "ready_N" ;
lin ready_V2 = mkTerm "ready_V2" ;
lin ready_made_A = mkTerm "ready_made_A" ;
lin reaffiliation_N = mkTerm "reaffiliation_N" ;
lin reaffirm_V2 = mkTerm "reaffirm_V2" ;
lin reagent_N = mkTerm "reagent_N" ;
lin reagin_N = mkTerm "reagin_N" ;
lin real_1_N = mkTerm "real_1_N" ;
lin real_2_N = mkTerm "real_2_N" ;
lin real_A = mkTerm "real_A" ;
lin realgar_N = mkTerm "realgar_N" ;
lin realign_V2 = mkTerm "realign_V2" ;
lin realism_N = mkTerm "realism_N" ;
lin realist_N = mkTerm "realist_N" ;
lin realistic_A = mkTerm "realistic_A" ;
lin reality_N = mkTerm "reality_N" ;
lin realizable_A = mkTerm "realizable_A" ;
lin realization_N = mkTerm "realization_N" ;
lin realize_V2 = mkTerm "realize_V2" ;
lin realize_VS = mkTerm "realize_VS" ;
lin reallocation_N = mkTerm "reallocation_N" ;
lin reallotment_N = mkTerm "reallotment_N" ;
lin really_AdA = mkTerm "really_AdA" ;
lin really_Adv = mkTerm "really_Adv" ;
lin realm_N = mkTerm "realm_N" ;
lin realpolitik_N = mkTerm "realpolitik_N" ;
lin realtor_N = mkTerm "realtor_N" ;
lin realty_N = mkTerm "realty_N" ;
lin ream_N = mkTerm "ream_N" ;
lin reamer_N = mkTerm "reamer_N" ;
lin reanimate_V2 = mkTerm "reanimate_V2" ;
lin reap_V = mkTerm "reap_V" ;
lin reap_V2 = mkTerm "reap_V2" ;
lin reaper_N = mkTerm "reaper_N" ;
lin reaping_hook_N = mkTerm "reaping_hook_N" ;
lin reappear_V = mkTerm "reappear_V" ;
lin reappearance_N = mkTerm "reappearance_N" ;
lin reappoint_V = mkTerm "reappoint_V" ;
lin reappoint_V2 = mkTerm "reappoint_V2" ;
lin reappraisal_N = mkTerm "reappraisal_N" ;
lin reappraise_V2 = mkTerm "reappraise_V2" ;
lin rear_A = mkTerm "rear_A" ;
lin rear_N = mkTerm "rear_N" ;
lin rear_V = mkTerm "rear_V" ;
lin rear_V2 = mkTerm "rear_V2" ;
lin rear_admiral_N = mkTerm "rear_admiral_N" ;
lin rearguard_N = mkTerm "rearguard_N" ;
lin rearm_V = mkTerm "rearm_V" ;
lin rearm_V2 = mkTerm "rearm_V2" ;
lin rearmament_N = mkTerm "rearmament_N" ;
lin rearmost_A = mkTerm "rearmost_A" ;
lin rearrange_V2 = mkTerm "rearrange_V2" ;
lin rearrangement_N = mkTerm "rearrangement_N" ;
lin rearward_A = mkTerm "rearward_A" ;
lin rearward_N = mkTerm "rearward_N" ;
lin rearwards_Adv = mkTerm "rearwards_Adv" ;
lin reason_N = mkTerm "reason_N" ;
lin reason_V = mkTerm "reason_V" ;
lin reason_V2 = mkTerm "reason_V2" ;
lin reason_VS = mkTerm "reason_VS" ;
lin reason_out_V2 = mkTerm "reason_out_V2" ;
lin reasonable_A = mkTerm "reasonable_A" ;
lin reasonableness_N = mkTerm "reasonableness_N" ;
lin reasoner_N = mkTerm "reasoner_N" ;
lin reasoning_N = mkTerm "reasoning_N" ;
lin reasonless_A = mkTerm "reasonless_A" ;
lin reassemble_V = mkTerm "reassemble_V" ;
lin reassemble_V2 = mkTerm "reassemble_V2" ;
lin reassembly_N = mkTerm "reassembly_N" ;
lin reassert_V2 = mkTerm "reassert_V2" ;
lin reassertion_N = mkTerm "reassertion_N" ;
lin reassess_V2 = mkTerm "reassess_V2" ;
lin reassessment_N = mkTerm "reassessment_N" ;
lin reassign_V2 = mkTerm "reassign_V2" ;
lin reassignment_N = mkTerm "reassignment_N" ;
lin reassume_V2 = mkTerm "reassume_V2" ;
lin reassurance_N = mkTerm "reassurance_N" ;
lin reassure_V2 = mkTerm "reassure_V2" ;
lin reassure_V2S = mkTerm "reassure_V2S" ;
lin reassuring_A = mkTerm "reassuring_A" ;
lin reattribute_V2 = mkTerm "reattribute_V2" ;
lin rebarbative_A = mkTerm "rebarbative_A" ;
lin rebate_N = mkTerm "rebate_N" ;
lin rebecca_PN = mkTerm "rebecca_PN" ;
lin rebel_N = mkTerm "rebel_N" ;
lin rebel_V = mkTerm "rebel_V" ;
lin rebellion_N = mkTerm "rebellion_N" ;
lin rebellious_A = mkTerm "rebellious_A" ;
lin rebelliousness_N = mkTerm "rebelliousness_N" ;
lin rebind_V2 = mkTerm "rebind_V2" ;
lin rebirth_N = mkTerm "rebirth_N" ;
lin reborn_A = mkTerm "reborn_A" ;
lin rebound_N = mkTerm "rebound_N" ;
lin rebound_V = mkTerm "rebound_V" ;
lin rebound_V2 = mkTerm "rebound_V2" ;
lin rebound_V2V = mkTerm "rebound_V2V" ;
lin reboxetine_N = mkTerm "reboxetine_N" ;
lin rebozo_N = mkTerm "rebozo_N" ;
lin rebranded_A = mkTerm "rebranded_A" ;
lin rebroadcast_N = mkTerm "rebroadcast_N" ;
lin rebuff_N = mkTerm "rebuff_N" ;
lin rebuff_V = mkTerm "rebuff_V" ;
lin rebuff_V2 = mkTerm "rebuff_V2" ;
lin rebuild_V2 = mkTerm "rebuild_V2" ;
lin rebuilding_N = mkTerm "rebuilding_N" ;
lin rebuke_N = mkTerm "rebuke_N" ;
lin rebuke_V2 = mkTerm "rebuke_V2" ;
lin rebukingly_Adv = mkTerm "rebukingly_Adv" ;
lin reburying_N = mkTerm "reburying_N" ;
lin rebus_N = mkTerm "rebus_N" ;
lin rebut_V2 = mkTerm "rebut_V2" ;
lin rebuttal_N = mkTerm "rebuttal_N" ;
lin rebutter_N = mkTerm "rebutter_N" ;
lin rec_PN = mkTerm "rec_PN" ;
lin recalcitrance_N = mkTerm "recalcitrance_N" ;
lin recalcitrancy_N = mkTerm "recalcitrancy_N" ;
lin recalcitrant_A = mkTerm "recalcitrant_A" ;
lin recalculate_V2 = mkTerm "recalculate_V2" ;
lin recalculation_N = mkTerm "recalculation_N" ;
lin recall_N = mkTerm "recall_N" ;
lin recall_V2 = mkTerm "recall_V2" ;
lin recall_VS = mkTerm "recall_VS" ;
lin recant_V = mkTerm "recant_V" ;
lin recant_V2 = mkTerm "recant_V2" ;
lin recantation_N = mkTerm "recantation_N" ;
lin recap_N = mkTerm "recap_N" ;
lin recap_V = mkTerm "recap_V" ;
lin recap_V2 = mkTerm "recap_V2" ;
lin recapitulate_V = mkTerm "recapitulate_V" ;
lin recapitulate_V2 = mkTerm "recapitulate_V2" ;
lin recapitulation_N = mkTerm "recapitulation_N" ;
lin recapture_N = mkTerm "recapture_N" ;
lin recapture_V2 = mkTerm "recapture_V2" ;
lin recast_V2 = mkTerm "recast_V2" ;
lin recce_N = mkTerm "recce_N" ;
lin recd_PN = mkTerm "recd_PN" ;
lin recede_V = mkTerm "recede_V" ;
lin receding_N = mkTerm "receding_N" ;
lin receipt_N = mkTerm "receipt_N" ;
lin receipt_V2 = mkTerm "receipt_V2" ;
lin receivable_A = mkTerm "receivable_A" ;
lin receivable_N = mkTerm "receivable_N" ;
lin receive_V = mkTerm "receive_V" ;
lin receive_V2 = mkTerm "receive_V2" ;
lin receiver_N = mkTerm "receiver_N" ;
lin receivership_N = mkTerm "receivership_N" ;
lin receiving_set_N = mkTerm "receiving_set_N" ;
lin recency_N = mkTerm "recency_N" ;
lin recent_A = mkTerm "recent_A" ;
lin recentralize_V2 = mkTerm "recentralize_V2" ;
lin receptacle_N = mkTerm "receptacle_N" ;
lin reception_N = mkTerm "reception_N" ;
lin reception_desk_N = mkTerm "reception_desk_N" ;
lin receptionist_N = mkTerm "receptionist_N" ;
lin receptive_A = mkTerm "receptive_A" ;
lin receptiveness_N = mkTerm "receptiveness_N" ;
lin receptivity_N = mkTerm "receptivity_N" ;
lin receptor_N = mkTerm "receptor_N" ;
lin recess_N = mkTerm "recess_N" ;
lin recess_V2 = mkTerm "recess_V2" ;
lin recession_N = mkTerm "recession_N" ;
lin recessional_A = mkTerm "recessional_A" ;
lin recessional_N = mkTerm "recessional_N" ;
lin recessionary_A = mkTerm "recessionary_A" ;
lin recessive_A = mkTerm "recessive_A" ;
lin rechargeable_A = mkTerm "rechargeable_A" ;
lin rechauffe_N = mkTerm "rechauffe_N" ;
lin recherche_A = mkTerm "recherche_A" ;
lin recidivism_N = mkTerm "recidivism_N" ;
lin recidivist_N = mkTerm "recidivist_N" ;
lin recife_PN = mkTerm "recife_PN" ;
lin recipe_N = mkTerm "recipe_N" ;
lin recipient_N = mkTerm "recipient_N" ;
lin reciprocal_A = mkTerm "reciprocal_A" ;
lin reciprocal_N = mkTerm "reciprocal_N" ;
lin reciprocality_N = mkTerm "reciprocality_N" ;
lin reciprocate_V = mkTerm "reciprocate_V" ;
lin reciprocate_V2 = mkTerm "reciprocate_V2" ;
lin reciprocation_N = mkTerm "reciprocation_N" ;
lin reciprocative_A = mkTerm "reciprocative_A" ;
lin reciprocity_N = mkTerm "reciprocity_N" ;
lin recirculation_N = mkTerm "recirculation_N" ;
lin recission_N = mkTerm "recission_N" ;
lin recital_N = mkTerm "recital_N" ;
lin recitalist_N = mkTerm "recitalist_N" ;
lin recitation_N = mkTerm "recitation_N" ;
lin recitative_N = mkTerm "recitative_N" ;
lin recite_V = mkTerm "recite_V" ;
lin recite_V2 = mkTerm "recite_V2" ;
lin reciter_N = mkTerm "reciter_N" ;
lin reckless_A = mkTerm "reckless_A" ;
lin recklessness_N = mkTerm "recklessness_N" ;
lin recklinghausen_PN = mkTerm "recklinghausen_PN" ;
lin reckon_VS = mkTerm "reckon_VS" ;
lin reckon_on_V2 = mkTerm "reckon_on_V2" ;
lin reckoner_N = mkTerm "reckoner_N" ;
lin reckoning_N = mkTerm "reckoning_N" ;
lin reclaim_V2 = mkTerm "reclaim_V2" ;
lin reclaimable_A = mkTerm "reclaimable_A" ;
lin reclamation_N = mkTerm "reclamation_N" ;
lin reclassification_N = mkTerm "reclassification_N" ;
lin reclassify_V2 = mkTerm "reclassify_V2" ;
lin recline_V = mkTerm "recline_V" ;
lin recline_V2 = mkTerm "recline_V2" ;
lin recliner_N = mkTerm "recliner_N" ;
lin reclining_N = mkTerm "reclining_N" ;
lin recluse_A = mkTerm "recluse_A" ;
lin recluse_N = mkTerm "recluse_N" ;
lin reclusiveness_N = mkTerm "reclusiveness_N" ;
lin recoding_N = mkTerm "recoding_N" ;
lin recognition_N = mkTerm "recognition_N" ;
lin recognizable_A = mkTerm "recognizable_A" ;
lin recognizance_N = mkTerm "recognizance_N" ;
lin recognize_1_V2 = mkTerm "recognize_1_V2" ;
lin recognize_4_V2 = mkTerm "recognize_4_V2" ;
lin recognize_VS = mkTerm "recognize_VS" ;
lin recoil_N = mkTerm "recoil_N" ;
lin recoil_V = mkTerm "recoil_V" ;
lin recoilless_A = mkTerm "recoilless_A" ;
lin recollect_V = mkTerm "recollect_V" ;
lin recollect_V2 = mkTerm "recollect_V2" ;
lin recollection_N = mkTerm "recollection_N" ;
lin recombinant_A = mkTerm "recombinant_A" ;
lin recombinant_N = mkTerm "recombinant_N" ;
lin recombination_N = mkTerm "recombination_N" ;
lin recommend_V2 = mkTerm "recommend_V2" ;
lin recommend_V2V = mkTerm "recommend_V2V" ;
lin recommendation_N = mkTerm "recommendation_N" ;
lin recommit_V2 = mkTerm "recommit_V2" ;
lin recompense_N = mkTerm "recompense_N" ;
lin recompense_V2 = mkTerm "recompense_V2" ;
lin reconcilable_A = mkTerm "reconcilable_A" ;
lin reconcile_V2 = mkTerm "reconcile_V2" ;
lin reconciliation_N = mkTerm "reconciliation_N" ;
lin recondite_A = mkTerm "recondite_A" ;
lin reconditeness_N = mkTerm "reconditeness_N" ;
lin recondition_V2 = mkTerm "recondition_V2" ;
lin reconfiguration_N = mkTerm "reconfiguration_N" ;
lin reconnaissance_N = mkTerm "reconnaissance_N" ;
lin reconnoitre_V = mkTerm "reconnoitre_V" ;
lin reconnoitre_V2 = mkTerm "reconnoitre_V2" ;
lin reconsecrate_V2 = mkTerm "reconsecrate_V2" ;
lin reconsider_V2 = mkTerm "reconsider_V2" ;
lin reconsider_VS = mkTerm "reconsider_VS" ;
lin reconsideration_N = mkTerm "reconsideration_N" ;
lin reconstruct_V2 = mkTerm "reconstruct_V2" ;
lin reconstruction_N = mkTerm "reconstruction_N" ;
lin reconstructive_A = mkTerm "reconstructive_A" ;
lin reconvict_V2 = mkTerm "reconvict_V2" ;
lin record_1_N = mkTerm "record_1_N" ;
lin record_2_N = mkTerm "record_2_N" ;
lin record_3_N = mkTerm "record_3_N" ;
lin record_A = mkTerm "record_A" ;
lin record_V2 = mkTerm "record_V2" ;
lin record_breaking_A = mkTerm "record_breaking_A" ;
lin record_player_N = mkTerm "record_player_N" ;
lin recorder_N = mkTerm "recorder_N" ;
lin recording_N = mkTerm "recording_N" ;
lin recount_VS = mkTerm "recount_VS" ;
lin recoup_V2 = mkTerm "recoup_V2" ;
lin recourse_N = mkTerm "recourse_N" ;
lin recover_V = mkTerm "recover_V" ;
lin recoverable_A = mkTerm "recoverable_A" ;
lin recovery_N = mkTerm "recovery_N" ;
lin recreant_A = mkTerm "recreant_A" ;
lin recreant_N = mkTerm "recreant_N" ;
lin recreate_V2 = mkTerm "recreate_V2" ;
lin recreation_N = mkTerm "recreation_N" ;
lin recreational_A = mkTerm "recreational_A" ;
lin recriminate_V = mkTerm "recriminate_V" ;
lin recrimination_N = mkTerm "recrimination_N" ;
lin recriminative_A = mkTerm "recriminative_A" ;
lin recriminatory_A = mkTerm "recriminatory_A" ;
lin recrudescence_N = mkTerm "recrudescence_N" ;
lin recrudescent_A = mkTerm "recrudescent_A" ;
lin recruit_N = mkTerm "recruit_N" ;
lin recruit_V = mkTerm "recruit_V" ;
lin recruit_V2 = mkTerm "recruit_V2" ;
lin recruiter_N = mkTerm "recruiter_N" ;
lin recruitment_N = mkTerm "recruitment_N" ;
lin rectal_A = mkTerm "rectal_A" ;
lin rectangle_N = mkTerm "rectangle_N" ;
lin rectangular_A = mkTerm "rectangular_A" ;
lin rectangularity_N = mkTerm "rectangularity_N" ;
lin rectification_N = mkTerm "rectification_N" ;
lin rectifier_N = mkTerm "rectifier_N" ;
lin rectify_V2 = mkTerm "rectify_V2" ;
lin rectilinear_A = mkTerm "rectilinear_A" ;
lin rectitude_N = mkTerm "rectitude_N" ;
lin recto_N = mkTerm "recto_N" ;
lin rectocele_N = mkTerm "rectocele_N" ;
lin rector_N = mkTerm "rector_N" ;
lin rectorship_N = mkTerm "rectorship_N" ;
lin rectory_N = mkTerm "rectory_N" ;
lin rectosigmoid_A = mkTerm "rectosigmoid_A" ;
lin rectum_N = mkTerm "rectum_N" ;
lin rectus_N = mkTerm "rectus_N" ;
lin recumbent_A = mkTerm "recumbent_A" ;
lin recuperate_V = mkTerm "recuperate_V" ;
lin recuperate_V2 = mkTerm "recuperate_V2" ;
lin recuperation_N = mkTerm "recuperation_N" ;
lin recuperative_A = mkTerm "recuperative_A" ;
lin recur_V = mkTerm "recur_V" ;
lin recurrence_N = mkTerm "recurrence_N" ;
lin recurrent_A = mkTerm "recurrent_A" ;
lin recursion_N = mkTerm "recursion_N" ;
lin recursive_A = mkTerm "recursive_A" ;
lin recurve_V = mkTerm "recurve_V" ;
lin recurve_V2 = mkTerm "recurve_V2" ;
lin recusancy_N = mkTerm "recusancy_N" ;
lin recusant_A = mkTerm "recusant_A" ;
lin recusant_N = mkTerm "recusant_N" ;
lin recusation_N = mkTerm "recusation_N" ;
lin recycle_V2 = mkTerm "recycle_V2" ;
lin recycling_N = mkTerm "recycling_N" ;
lin red_A = mkTerm "red_A" ;
lin red_N = mkTerm "red_N" ;
lin red_hot_A = mkTerm "red_hot_A" ;
lin red_rimmed_A = mkTerm "red_rimmed_A" ;
lin redact_N = mkTerm "redact_N" ;
lin redact_V2 = mkTerm "redact_V2" ;
lin redaction_N = mkTerm "redaction_N" ;
lin redberry_N = mkTerm "redberry_N" ;
lin redbone_N = mkTerm "redbone_N" ;
lin redbreast_N = mkTerm "redbreast_N" ;
lin redbrick_A = mkTerm "redbrick_A" ;
lin redbridge_PN = mkTerm "redbridge_PN" ;
lin redbud_N = mkTerm "redbud_N" ;
lin redcap_N = mkTerm "redcap_N" ;
lin redcoat_N = mkTerm "redcoat_N" ;
lin redden_V = mkTerm "redden_V" ;
lin redden_V2 = mkTerm "redden_V2" ;
lin reddish_A = mkTerm "reddish_A" ;
lin redditch_PN = mkTerm "redditch_PN" ;
lin redecorate_V2 = mkTerm "redecorate_V2" ;
lin rededication_N = mkTerm "rededication_N" ;
lin redeem_V2 = mkTerm "redeem_V2" ;
lin redeemable_A = mkTerm "redeemable_A" ;
lin redeemer_N = mkTerm "redeemer_N" ;
lin redefine_V2 = mkTerm "redefine_V2" ;
lin redefinition_N = mkTerm "redefinition_N" ;
lin redemption_N = mkTerm "redemption_N" ;
lin redemptive_A = mkTerm "redemptive_A" ;
lin redeploy_V2 = mkTerm "redeploy_V2" ;
lin redeployment_N = mkTerm "redeployment_N" ;
lin redeposition_N = mkTerm "redeposition_N" ;
lin redesign_N = mkTerm "redesign_N" ;
lin redesign_V2 = mkTerm "redesign_V2" ;
lin redetermination_N = mkTerm "redetermination_N" ;
lin redevelop_V2 = mkTerm "redevelop_V2" ;
lin redevelopment_N = mkTerm "redevelopment_N" ;
lin redeye_N = mkTerm "redeye_N" ;
lin redfish_N = mkTerm "redfish_N" ;
lin redhead_N = mkTerm "redhead_N" ;
lin redheaded_A = mkTerm "redheaded_A" ;
lin redhorse_N = mkTerm "redhorse_N" ;
lin rediffusion_N = mkTerm "rediffusion_N" ;
lin rediscover_V2 = mkTerm "rediscover_V2" ;
lin rediscovery_N = mkTerm "rediscovery_N" ;
lin redisposition_N = mkTerm "redisposition_N" ;
lin redistribute_V2 = mkTerm "redistribute_V2" ;
lin redistribution_N = mkTerm "redistribution_N" ;
lin redline_V2 = mkTerm "redline_V2" ;
lin redneck_N = mkTerm "redneck_N" ;
lin redness_N = mkTerm "redness_N" ;
lin redo_V2 = mkTerm "redo_V2" ;
lin redolence_N = mkTerm "redolence_N" ;
lin redolent_A = mkTerm "redolent_A" ;
lin redouble_V = mkTerm "redouble_V" ;
lin redouble_V2 = mkTerm "redouble_V2" ;
lin redoubt_N = mkTerm "redoubt_N" ;
lin redoubtable_A = mkTerm "redoubtable_A" ;
lin redound_V = mkTerm "redound_V" ;
lin redpoll_N = mkTerm "redpoll_N" ;
lin redraft_N = mkTerm "redraft_N" ;
lin redraw_V2 = mkTerm "redraw_V2" ;
lin redress_N = mkTerm "redress_N" ;
lin redress_V2 = mkTerm "redress_V2" ;
lin redruth_PN = mkTerm "redruth_PN" ;
lin redshank_N = mkTerm "redshank_N" ;
lin redskin_N = mkTerm "redskin_N" ;
lin redstart_N = mkTerm "redstart_N" ;
lin redtail_N = mkTerm "redtail_N" ;
lin reduce_V = mkTerm "reduce_V" ;
lin reduce_V2 = mkTerm "reduce_V2" ;
lin reduced_A = mkTerm "reduced_A" ;
lin reducer_N = mkTerm "reducer_N" ;
lin reducible_A = mkTerm "reducible_A" ;
lin reducing_N = mkTerm "reducing_N" ;
lin reductase_N = mkTerm "reductase_N" ;
lin reductio_ad_absurdum_N = mkTerm "reductio_ad_absurdum_N" ;
lin reduction_N = mkTerm "reduction_N" ;
lin reductionism_N = mkTerm "reductionism_N" ;
lin reductionist_A = mkTerm "reductionist_A" ;
lin reductive_A = mkTerm "reductive_A" ;
lin redundance_N = mkTerm "redundance_N" ;
lin redundancy_N = mkTerm "redundancy_N" ;
lin redundant_A = mkTerm "redundant_A" ;
lin reduplicate_V2 = mkTerm "reduplicate_V2" ;
lin reduplication_N = mkTerm "reduplication_N" ;
lin redwing_N = mkTerm "redwing_N" ;
lin redwood_N = mkTerm "redwood_N" ;
lin reed_N = mkTerm "reed_N" ;
lin reedy_A = mkTerm "reedy_A" ;
lin reef_N = mkTerm "reef_N" ;
lin reef_V2 = mkTerm "reef_V2" ;
lin reef_knot_N = mkTerm "reef_knot_N" ;
lin reefer_N = mkTerm "reefer_N" ;
lin reefy_A = mkTerm "reefy_A" ;
lin reek_N = mkTerm "reek_N" ;
lin reek_V = mkTerm "reek_V" ;
lin reel_N = mkTerm "reel_N" ;
lin reel_V = mkTerm "reel_V" ;
lin reel_V2 = mkTerm "reel_V2" ;
lin reel_in_V2 = mkTerm "reel_in_V2" ;
lin reel_off_V2 = mkTerm "reel_off_V2" ;
lin reel_out_V2 = mkTerm "reel_out_V2" ;
lin reelection_N = mkTerm "reelection_N" ;
lin reeler_N = mkTerm "reeler_N" ;
lin reenactment_N = mkTerm "reenactment_N" ;
lin reenactor_N = mkTerm "reenactor_N" ;
lin reenlistment_N = mkTerm "reenlistment_N" ;
lin reevaluation_N = mkTerm "reevaluation_N" ;
lin reeve_N = mkTerm "reeve_N" ;
lin reexamine_V = mkTerm "reexamine_V" ;
lin ref_N = mkTerm "ref_N" ;
lin reface_V2 = mkTerm "reface_V2" ;
lin refashion_N = mkTerm "refashion_N" ;
lin refashion_V2 = mkTerm "refashion_V2" ;
lin refection_N = mkTerm "refection_N" ;
lin refectory_N = mkTerm "refectory_N" ;
lin refer_V = mkTerm "refer_V" ;
lin refer_V2 = mkTerm "refer_V2" ;
lin referable_A = mkTerm "referable_A" ;
lin referee_N = mkTerm "referee_N" ;
lin referee_V = mkTerm "referee_V" ;
lin referee_V2 = mkTerm "referee_V2" ;
lin reference_N = mkTerm "reference_N" ;
lin referenced_A = mkTerm "referenced_A" ;
lin referendum_N = mkTerm "referendum_N" ;
lin referent_A = mkTerm "referent_A" ;
lin referent_N = mkTerm "referent_N" ;
lin referential_A = mkTerm "referential_A" ;
lin referral_N = mkTerm "referral_N" ;
lin refile_V2 = mkTerm "refile_V2" ;
lin refill_N = mkTerm "refill_N" ;
lin refill_V2 = mkTerm "refill_V2" ;
lin refilling_N = mkTerm "refilling_N" ;
lin refinance_V = mkTerm "refinance_V" ;
lin refinance_V2 = mkTerm "refinance_V2" ;
lin refine_V = mkTerm "refine_V" ;
lin refine_V2 = mkTerm "refine_V2" ;
lin refined_A = mkTerm "refined_A" ;
lin refinement_N = mkTerm "refinement_N" ;
lin refiner_N = mkTerm "refiner_N" ;
lin refinery_N = mkTerm "refinery_N" ;
lin refining_N = mkTerm "refining_N" ;
lin refinisher_N = mkTerm "refinisher_N" ;
lin refit_N = mkTerm "refit_N" ;
lin refit_V = mkTerm "refit_V" ;
lin refit_V2 = mkTerm "refit_V2" ;
lin reflate_V2 = mkTerm "reflate_V2" ;
lin reflation_N = mkTerm "reflation_N" ;
lin reflect_V = mkTerm "reflect_V" ;
lin reflect_V2 = mkTerm "reflect_V2" ;
lin reflection_N = mkTerm "reflection_N" ;
lin reflective_A = mkTerm "reflective_A" ;
lin reflectiveness_N = mkTerm "reflectiveness_N" ;
lin reflectometer_N = mkTerm "reflectometer_N" ;
lin reflector_N = mkTerm "reflector_N" ;
lin reflex_A = mkTerm "reflex_A" ;
lin reflex_N = mkTerm "reflex_N" ;
lin reflexed_A = mkTerm "reflexed_A" ;
lin reflexion_N = mkTerm "reflexion_N" ;
lin reflexive_A = mkTerm "reflexive_A" ;
lin reflexive_N = mkTerm "reflexive_N" ;
lin reflexivity_N = mkTerm "reflexivity_N" ;
lin reflexology_N = mkTerm "reflexology_N" ;
lin refloat_V = mkTerm "refloat_V" ;
lin refloat_V2 = mkTerm "refloat_V2" ;
lin reflux_N = mkTerm "reflux_N" ;
lin refocus_V = mkTerm "refocus_V" ;
lin refocus_V2 = mkTerm "refocus_V2" ;
lin refocus_V2V = mkTerm "refocus_V2V" ;
lin refocusing_N = mkTerm "refocusing_N" ;
lin reforest_V2 = mkTerm "reforest_V2" ;
lin reforestation_N = mkTerm "reforestation_N" ;
lin reform_N = mkTerm "reform_N" ;
lin reformation_N = mkTerm "reformation_N" ;
lin reformative_A = mkTerm "reformative_A" ;
lin reformatory_A = mkTerm "reformatory_A" ;
lin reformatory_N = mkTerm "reformatory_N" ;
lin reformer_N = mkTerm "reformer_N" ;
lin reformism_N = mkTerm "reformism_N" ;
lin reformist_N = mkTerm "reformist_N" ;
lin reformulate_V2 = mkTerm "reformulate_V2" ;
lin refract_V2 = mkTerm "refract_V2" ;
lin refraction_N = mkTerm "refraction_N" ;
lin refractive_A = mkTerm "refractive_A" ;
lin refractivity_N = mkTerm "refractivity_N" ;
lin refractometer_N = mkTerm "refractometer_N" ;
lin refractoriness_N = mkTerm "refractoriness_N" ;
lin refractory_A = mkTerm "refractory_A" ;
lin refrain_N = mkTerm "refrain_N" ;
lin refrain_V = mkTerm "refrain_V" ;
lin refresh_V2 = mkTerm "refresh_V2" ;
lin refresher_N = mkTerm "refresher_N" ;
lin refreshing_A = mkTerm "refreshing_A" ;
lin refreshment_N = mkTerm "refreshment_N" ;
lin refrigerant_A = mkTerm "refrigerant_A" ;
lin refrigerant_N = mkTerm "refrigerant_N" ;
lin refrigerate_V2 = mkTerm "refrigerate_V2" ;
lin refrigeration_N = mkTerm "refrigeration_N" ;
lin refrigerator_N = mkTerm "refrigerator_N" ;
lin refuel_V = mkTerm "refuel_V" ;
lin refuel_V2 = mkTerm "refuel_V2" ;
lin refuge_N = mkTerm "refuge_N" ;
lin refugee_N = mkTerm "refugee_N" ;
lin refulgence_N = mkTerm "refulgence_N" ;
lin refulgent_A = mkTerm "refulgent_A" ;
lin refund_N = mkTerm "refund_N" ;
lin refund_V2 = mkTerm "refund_V2" ;
lin refurbish_V2 = mkTerm "refurbish_V2" ;
lin refurbishment_N = mkTerm "refurbishment_N" ;
lin refurnish_V2 = mkTerm "refurnish_V2" ;
lin refusal_N = mkTerm "refusal_N" ;
lin refuse_N = mkTerm "refuse_N" ;
lin refuse_V = mkTerm "refuse_V" ;
lin refuse_V2 = mkTerm "refuse_V2" ;
lin refuse_VV = mkTerm "refuse_VV" ;
lin refuse_collector_N = mkTerm "refuse_collector_N" ;
lin refutable_A = mkTerm "refutable_A" ;
lin refutation_N = mkTerm "refutation_N" ;
lin refute_V2 = mkTerm "refute_V2" ;
lin reg_PN = mkTerm "reg_PN" ;
lin regain_V2 = mkTerm "regain_V2" ;
lin regal_A = mkTerm "regal_A" ;
lin regale_V2 = mkTerm "regale_V2" ;
lin regalia_N = mkTerm "regalia_N" ;
lin regard_N = mkTerm "regard_N" ;
lin regard_V = mkTerm "regard_V" ;
lin regard_V2 = mkTerm "regard_V2" ;
lin regardful_A = mkTerm "regardful_A" ;
lin regarding_Prep = mkTerm "regarding_Prep" ;
lin regardless_A = mkTerm "regardless_A" ;
lin regardless_Adv = mkTerm "regardless_Adv" ;
lin regardless_of_Prep = mkTerm "regardless_of_Prep" ;
lin regatta_N = mkTerm "regatta_N" ;
lin regency_N = mkTerm "regency_N" ;
lin regenerate_A = mkTerm "regenerate_A" ;
lin regenerate_V = mkTerm "regenerate_V" ;
lin regenerate_V2 = mkTerm "regenerate_V2" ;
lin regeneration_N = mkTerm "regeneration_N" ;
lin regensburg_PN = mkTerm "regensburg_PN" ;
lin regent_A = mkTerm "regent_A" ;
lin regent_N = mkTerm "regent_N" ;
lin reggae_N = mkTerm "reggae_N" ;
lin regicide_N = mkTerm "regicide_N" ;
lin regime_1_N = mkTerm "regime_1_N" ;
lin regime_2_N = mkTerm "regime_2_N" ;
lin regimen_N = mkTerm "regimen_N" ;
lin regiment_N = mkTerm "regiment_N" ;
lin regiment_V2 = mkTerm "regiment_V2" ;
lin regimental_A = mkTerm "regimental_A" ;
lin regimentals_N = mkTerm "regimentals_N" ;
lin regimentation_N = mkTerm "regimentation_N" ;
lin regina_PN = mkTerm "regina_PN" ;
lin reginald_PN = mkTerm "reginald_PN" ;
lin region_N = mkTerm "region_N" ;
lin regional_A = mkTerm "regional_A" ;
lin regional_N = mkTerm "regional_N" ;
lin regionalism_N = mkTerm "regionalism_N" ;
lin register_N = mkTerm "register_N" ;
lin register_V = mkTerm "register_V" ;
lin register_V2 = mkTerm "register_V2" ;
lin registered_A = mkTerm "registered_A" ;
lin registrant_N = mkTerm "registrant_N" ;
lin registrar_N = mkTerm "registrar_N" ;
lin registration_N = mkTerm "registration_N" ;
lin registry_N = mkTerm "registry_N" ;
lin regnant_A = mkTerm "regnant_A" ;
lin regnellidium_N = mkTerm "regnellidium_N" ;
lin regosol_N = mkTerm "regosol_N" ;
lin regress_N = mkTerm "regress_N" ;
lin regress_V = mkTerm "regress_V" ;
lin regression_N = mkTerm "regression_N" ;
lin regressive_A = mkTerm "regressive_A" ;
lin regret_N = mkTerm "regret_N" ;
lin regret_V2 = mkTerm "regret_V2" ;
lin regret_VS = mkTerm "regret_VS" ;
lin regretful_A = mkTerm "regretful_A" ;
lin regrettable_A = mkTerm "regrettable_A" ;
lin regroup_V = mkTerm "regroup_V" ;
lin regroup_V2 = mkTerm "regroup_V2" ;
lin regular_A = mkTerm "regular_A" ;
lin regular_N = mkTerm "regular_N" ;
lin regularity_N = mkTerm "regularity_N" ;
lin regularization_N = mkTerm "regularization_N" ;
lin regularize_V2 = mkTerm "regularize_V2" ;
lin regulate_V2 = mkTerm "regulate_V2" ;
lin regulation_A = mkTerm "regulation_A" ;
lin regulation_N = mkTerm "regulation_N" ;
lin regulative_A = mkTerm "regulative_A" ;
lin regulator_N = mkTerm "regulator_N" ;
lin regulatory_A = mkTerm "regulatory_A" ;
lin regum_V2 = mkTerm "regum_V2" ;
lin regur_N = mkTerm "regur_N" ;
lin regurgitate_V = mkTerm "regurgitate_V" ;
lin regurgitate_V2 = mkTerm "regurgitate_V2" ;
lin regurgitation_N = mkTerm "regurgitation_N" ;
lin rehabilitate_V2 = mkTerm "rehabilitate_V2" ;
lin rehabilitation_N = mkTerm "rehabilitation_N" ;
lin rehabilitative_A = mkTerm "rehabilitative_A" ;
lin reharmonization_N = mkTerm "reharmonization_N" ;
lin rehash_N = mkTerm "rehash_N" ;
lin rehash_V2 = mkTerm "rehash_V2" ;
lin rehear_V2 = mkTerm "rehear_V2" ;
lin rehearing_N = mkTerm "rehearing_N" ;
lin rehearsal_N = mkTerm "rehearsal_N" ;
lin rehearse_V = mkTerm "rehearse_V" ;
lin rehearse_V2 = mkTerm "rehearse_V2" ;
lin rehouse_V2 = mkTerm "rehouse_V2" ;
lin reich_N = mkTerm "reich_N" ;
lin reigate_PN = mkTerm "reigate_PN" ;
lin reign_N = mkTerm "reign_N" ;
lin reign_V = mkTerm "reign_V" ;
lin reignite_V2 = mkTerm "reignite_V2" ;
lin reimburse_V2 = mkTerm "reimburse_V2" ;
lin reimbursement_N = mkTerm "reimbursement_N" ;
lin reimpose_V2 = mkTerm "reimpose_V2" ;
lin reimposition_N = mkTerm "reimposition_N" ;
lin rein_N = mkTerm "rein_N" ;
lin rein_V2 = mkTerm "rein_V2" ;
lin rein_in_V2 = mkTerm "rein_in_V2" ;
lin reincarnate_A = mkTerm "reincarnate_A" ;
lin reincarnate_V2 = mkTerm "reincarnate_V2" ;
lin reincarnation_N = mkTerm "reincarnation_N" ;
lin reincarnationism_N = mkTerm "reincarnationism_N" ;
lin reindeer_N = mkTerm "reindeer_N" ;
lin reindict_V2 = mkTerm "reindict_V2" ;
lin reinforce_V2 = mkTerm "reinforce_V2" ;
lin reinforcement_N = mkTerm "reinforcement_N" ;
lin reinstall_V2 = mkTerm "reinstall_V2" ;
lin reinstate_V2 = mkTerm "reinstate_V2" ;
lin reinstatement_N = mkTerm "reinstatement_N" ;
lin reinstitute_V2 = mkTerm "reinstitute_V2" ;
lin reinsurance_N = mkTerm "reinsurance_N" ;
lin reinsure_V2 = mkTerm "reinsure_V2" ;
lin reintegrate_V2 = mkTerm "reintegrate_V2" ;
lin reintegration_N = mkTerm "reintegration_N" ;
lin reinterpret_V2 = mkTerm "reinterpret_V2" ;
lin reinterpretation_N = mkTerm "reinterpretation_N" ;
lin reintroduce_V2 = mkTerm "reintroduce_V2" ;
lin reintroduction_N = mkTerm "reintroduction_N" ;
lin reinvent_V2 = mkTerm "reinvent_V2" ;
lin reinvest_V2 = mkTerm "reinvest_V2" ;
lin reinvigorate_V2 = mkTerm "reinvigorate_V2" ;
lin reisjärvi_PN = mkTerm "reisjärvi_PN" ;
lin reissue_N = mkTerm "reissue_N" ;
lin reissue_V2 = mkTerm "reissue_V2" ;
lin reiterate_V2 = mkTerm "reiterate_V2" ;
lin reiterate_VS = mkTerm "reiterate_VS" ;
lin reiteration_N = mkTerm "reiteration_N" ;
lin reject_N = mkTerm "reject_N" ;
lin reject_V2 = mkTerm "reject_V2" ;
lin rejection_N = mkTerm "rejection_N" ;
lin rejective_A = mkTerm "rejective_A" ;
lin rejig_V2 = mkTerm "rejig_V2" ;
lin rejoice_V = mkTerm "rejoice_V" ;
lin rejoice_V2 = mkTerm "rejoice_V2" ;
lin rejoicing_N = mkTerm "rejoicing_N" ;
lin rejoin_V = mkTerm "rejoin_V" ;
lin rejoinder_N = mkTerm "rejoinder_N" ;
lin rejuvenate_V = mkTerm "rejuvenate_V" ;
lin rejuvenate_V2 = mkTerm "rejuvenate_V2" ;
lin rejuvenation_N = mkTerm "rejuvenation_N" ;
lin rekindle_V = mkTerm "rekindle_V" ;
lin rekindle_V2 = mkTerm "rekindle_V2" ;
lin relapse_N = mkTerm "relapse_N" ;
lin relapse_V = mkTerm "relapse_V" ;
lin relate_N = mkTerm "relate_N" ;
lin relate_V = mkTerm "relate_V" ;
lin relate_V2 = mkTerm "relate_V2" ;
lin related_A = mkTerm "related_A" ;
lin relatedness_N = mkTerm "relatedness_N" ;
lin relation_N = mkTerm "relation_N" ;
lin relational_A = mkTerm "relational_A" ;
lin relationship_N = mkTerm "relationship_N" ;
lin relative_A = mkTerm "relative_A" ;
lin relative_N = mkTerm "relative_N" ;
lin relativism_N = mkTerm "relativism_N" ;
lin relativistic_A = mkTerm "relativistic_A" ;
lin relativity_N = mkTerm "relativity_N" ;
lin relatum_N = mkTerm "relatum_N" ;
lin relax_V = mkTerm "relax_V" ;
lin relax_V2 = mkTerm "relax_V2" ;
lin relaxant_A = mkTerm "relaxant_A" ;
lin relaxant_N = mkTerm "relaxant_N" ;
lin relaxation_N = mkTerm "relaxation_N" ;
lin relaxer_N = mkTerm "relaxer_N" ;
lin relaxin_N = mkTerm "relaxin_N" ;
lin relay_N = mkTerm "relay_N" ;
lin relay_V2 = mkTerm "relay_V2" ;
lin release_N = mkTerm "release_N" ;
lin release_V2 = mkTerm "release_V2" ;
lin relegate_V2 = mkTerm "relegate_V2" ;
lin relegation_N = mkTerm "relegation_N" ;
lin relent_V = mkTerm "relent_V" ;
lin relentless_A = mkTerm "relentless_A" ;
lin relentlessness_N = mkTerm "relentlessness_N" ;
lin relevance_N = mkTerm "relevance_N" ;
lin relevancy_N = mkTerm "relevancy_N" ;
lin relevant_A = mkTerm "relevant_A" ;
lin reliability_N = mkTerm "reliability_N" ;
lin reliable_A = mkTerm "reliable_A" ;
lin reliance_N = mkTerm "reliance_N" ;
lin reliant_A = mkTerm "reliant_A" ;
lin relic_N = mkTerm "relic_N" ;
lin relict_N = mkTerm "relict_N" ;
lin relief_N = mkTerm "relief_N" ;
lin relieve_V2 = mkTerm "relieve_V2" ;
lin reliever_N = mkTerm "reliever_N" ;
lin religion_N = mkTerm "religion_N" ;
lin religionism_N = mkTerm "religionism_N" ;
lin religionist_N = mkTerm "religionist_N" ;
lin religiosity_N = mkTerm "religiosity_N" ;
lin religious_A = mkTerm "religious_A" ;
lin religious_N = mkTerm "religious_N" ;
lin religiousness_N = mkTerm "religiousness_N" ;
lin reline_V2 = mkTerm "reline_V2" ;
lin relinquish_V2 = mkTerm "relinquish_V2" ;
lin relinquishment_N = mkTerm "relinquishment_N" ;
lin reliquary_N = mkTerm "reliquary_N" ;
lin relish_N = mkTerm "relish_N" ;
lin relish_V2 = mkTerm "relish_V2" ;
lin relistening_N = mkTerm "relistening_N" ;
lin relive_V2 = mkTerm "relive_V2" ;
lin reliving_N = mkTerm "reliving_N" ;
lin relocate_V = mkTerm "relocate_V" ;
lin relocate_V2 = mkTerm "relocate_V2" ;
lin relocation_N = mkTerm "relocation_N" ;
lin reluctance_N = mkTerm "reluctance_N" ;
lin reluctant_A = mkTerm "reluctant_A" ;
lin reluctivity_N = mkTerm "reluctivity_N" ;
lin rely_V = mkTerm "rely_V" ;
lin rely_V2 = mkTerm "rely_V2" ;
lin rely_on_V = mkTerm "rely_on_V" ;
lin rely_on_V2V = mkTerm "rely_on_V2V" ;
lin remain_N = mkTerm "remain_N" ;
lin remain_V = mkTerm "remain_V" ;
lin remain_V2 = mkTerm "remain_V2" ;
lin remain_VA = mkTerm "remain_VA" ;
lin remain_VV = mkTerm "remain_VV" ;
lin remainder_N = mkTerm "remainder_N" ;
lin remaining_A = mkTerm "remaining_A" ;
lin remains_N = mkTerm "remains_N" ;
lin remake_N = mkTerm "remake_N" ;
lin remake_V2 = mkTerm "remake_V2" ;
lin remand_N = mkTerm "remand_N" ;
lin remand_V2 = mkTerm "remand_V2" ;
lin remark_N = mkTerm "remark_N" ;
lin remark_V = mkTerm "remark_V" ;
lin remark_VS = mkTerm "remark_VS" ;
lin remarkable_A = mkTerm "remarkable_A" ;
lin remarriage_N = mkTerm "remarriage_N" ;
lin remarry_V = mkTerm "remarry_V" ;
lin remarry_V2 = mkTerm "remarry_V2" ;
lin rematch_N = mkTerm "rematch_N" ;
lin remediable_A = mkTerm "remediable_A" ;
lin remedial_A = mkTerm "remedial_A" ;
lin remedy_N = mkTerm "remedy_N" ;
lin remedy_V2 = mkTerm "remedy_V2" ;
lin remember_V = mkTerm "remember_V" ;
lin remember_V2 = mkTerm "remember_V2" ;
lin remember_VS = mkTerm "remember_VS" ;
lin remembrance_N = mkTerm "remembrance_N" ;
lin remilitarization_N = mkTerm "remilitarization_N" ;
lin remilitarize_V2 = mkTerm "remilitarize_V2" ;
lin remind_V2 = mkTerm "remind_V2" ;
lin reminder_N = mkTerm "reminder_N" ;
lin reminisce_V = mkTerm "reminisce_V" ;
lin reminiscence_N = mkTerm "reminiscence_N" ;
lin reminiscent_A = mkTerm "reminiscent_A" ;
lin remise_N = mkTerm "remise_N" ;
lin remiss_A = mkTerm "remiss_A" ;
lin remission_N = mkTerm "remission_N" ;
lin remissness_N = mkTerm "remissness_N" ;
lin remit_N = mkTerm "remit_N" ;
lin remit_V = mkTerm "remit_V" ;
lin remit_V2 = mkTerm "remit_V2" ;
lin remittance_N = mkTerm "remittance_N" ;
lin remittent_A = mkTerm "remittent_A" ;
lin remix_N = mkTerm "remix_N" ;
lin remnant_N = mkTerm "remnant_N" ;
lin remodel_V = mkTerm "remodel_V" ;
lin remodel_V2 = mkTerm "remodel_V2" ;
lin remonstrance_N = mkTerm "remonstrance_N" ;
lin remonstrate_V = mkTerm "remonstrate_V" ;
lin remora_N = mkTerm "remora_N" ;
lin remorse_N = mkTerm "remorse_N" ;
lin remorseful_A = mkTerm "remorseful_A" ;
lin remorseless_A = mkTerm "remorseless_A" ;
lin remote_A = mkTerm "remote_A" ;
lin remoteness_N = mkTerm "remoteness_N" ;
lin remould_V2 = mkTerm "remould_V2" ;
lin remount_N = mkTerm "remount_N" ;
lin remount_V = mkTerm "remount_V" ;
lin remount_V2 = mkTerm "remount_V2" ;
lin removable_A = mkTerm "removable_A" ;
lin removal_N = mkTerm "removal_N" ;
lin remove_N = mkTerm "remove_N" ;
lin remove_V = mkTerm "remove_V" ;
lin remove_V2 = mkTerm "remove_V2" ;
lin remover_N = mkTerm "remover_N" ;
lin remscheid_PN = mkTerm "remscheid_PN" ;
lin remuda_N = mkTerm "remuda_N" ;
lin remunerate_V2 = mkTerm "remunerate_V2" ;
lin remuneration_N = mkTerm "remuneration_N" ;
lin remunerative_A = mkTerm "remunerative_A" ;
lin renaissance_N = mkTerm "renaissance_N" ;
lin renal_A = mkTerm "renal_A" ;
lin rename_V2 = mkTerm "rename_V2" ;
lin rename_V3 = mkTerm "rename_V3" ;
lin renascence_N = mkTerm "renascence_N" ;
lin renascent_A = mkTerm "renascent_A" ;
lin rend_V2 = mkTerm "rend_V2" ;
lin render_N = mkTerm "render_N" ;
lin render_V2 = mkTerm "render_V2" ;
lin rendering_N = mkTerm "rendering_N" ;
lin rendezvous_N = mkTerm "rendezvous_N" ;
lin rendezvous_V = mkTerm "rendezvous_V" ;
lin rendezvouse_V = mkTerm "rendezvouse_V" ;
lin rending_A = mkTerm "rending_A" ;
lin rendition_N = mkTerm "rendition_N" ;
lin renegadeFem_N = mkTerm "renegadeFem_N" ;
lin renegadeMasc_N = mkTerm "renegadeMasc_N" ;
lin renegade_V = mkTerm "renegade_V" ;
lin renege_V = mkTerm "renege_V" ;
lin renegotiate_V2 = mkTerm "renegotiate_V2" ;
lin renegue_V = mkTerm "renegue_V" ;
lin renew_V2 = mkTerm "renew_V2" ;
lin renewable_A = mkTerm "renewable_A" ;
lin renewal_N = mkTerm "renewal_N" ;
lin renewed_A = mkTerm "renewed_A" ;
lin renewing_A = mkTerm "renewing_A" ;
lin renfrew_PN = mkTerm "renfrew_PN" ;
lin reniform_A = mkTerm "reniform_A" ;
lin renin_N = mkTerm "renin_N" ;
lin renko_PN = mkTerm "renko_PN" ;
lin rennes_PN = mkTerm "rennes_PN" ;
lin rennet_N = mkTerm "rennet_N" ;
lin rennin_N = mkTerm "rennin_N" ;
lin renounce_V2 = mkTerm "renounce_V2" ;
lin renovate_V2 = mkTerm "renovate_V2" ;
lin renovation_N = mkTerm "renovation_N" ;
lin renovator_N = mkTerm "renovator_N" ;
lin renown_N = mkTerm "renown_N" ;
lin renowned_A = mkTerm "renowned_A" ;
lin rensselaerite_N = mkTerm "rensselaerite_N" ;
lin rent_N = mkTerm "rent_N" ;
lin rent_V = mkTerm "rent_V" ;
lin rent_V2 = mkTerm "rent_V2" ;
lin rent_collector_N = mkTerm "rent_collector_N" ;
lin rent_free_A = mkTerm "rent_free_A" ;
lin rent_free_Adv = mkTerm "rent_free_Adv" ;
lin rent_out_V2 = mkTerm "rent_out_V2" ;
lin rent_rebate_N = mkTerm "rent_rebate_N" ;
lin rent_roll_N = mkTerm "rent_roll_N" ;
lin rentable_A = mkTerm "rentable_A" ;
lin rental_A = mkTerm "rental_A" ;
lin rental_N = mkTerm "rental_N" ;
lin renter_N = mkTerm "renter_N" ;
lin rentier_N = mkTerm "rentier_N" ;
lin renunciant_A = mkTerm "renunciant_A" ;
lin renunciation_N = mkTerm "renunciation_N" ;
lin reoffer_V2 = mkTerm "reoffer_V2" ;
lin reopen_V = mkTerm "reopen_V" ;
lin reopen_V2 = mkTerm "reopen_V2" ;
lin reorder_N = mkTerm "reorder_N" ;
lin reordering_N = mkTerm "reordering_N" ;
lin reorganization_N = mkTerm "reorganization_N" ;
lin reorganize_V = mkTerm "reorganize_V" ;
lin reorganize_V2 = mkTerm "reorganize_V2" ;
lin reorient_V = mkTerm "reorient_V" ;
lin reorient_V2 = mkTerm "reorient_V2" ;
lin reorientate_V = mkTerm "reorientate_V" ;
lin reorientate_V2 = mkTerm "reorientate_V2" ;
lin reorientation_N = mkTerm "reorientation_N" ;
lin reovirus_N = mkTerm "reovirus_N" ;
lin rep_N = mkTerm "rep_N" ;
lin repackage_V2 = mkTerm "repackage_V2" ;
lin repaint_V2 = mkTerm "repaint_V2" ;
lin repair_N = mkTerm "repair_N" ;
lin repair_V = mkTerm "repair_V" ;
lin repair_V2 = mkTerm "repair_V2" ;
lin repairable_A = mkTerm "repairable_A" ;
lin repairer_N = mkTerm "repairer_N" ;
lin repairman_N = mkTerm "repairman_N" ;
lin repand_A = mkTerm "repand_A" ;
lin reparable_A = mkTerm "reparable_A" ;
lin reparation_N = mkTerm "reparation_N" ;
lin repartee_N = mkTerm "repartee_N" ;
lin repass_V2 = mkTerm "repass_V2" ;
lin repast_N = mkTerm "repast_N" ;
lin repatriate_N = mkTerm "repatriate_N" ;
lin repatriate_V2 = mkTerm "repatriate_V2" ;
lin repatriation_N = mkTerm "repatriation_N" ;
lin repay_V = mkTerm "repay_V" ;
lin repay_V2 = mkTerm "repay_V2" ;
lin repayable_A = mkTerm "repayable_A" ;
lin repayment_N = mkTerm "repayment_N" ;
lin repeal_N = mkTerm "repeal_N" ;
lin repeal_V2 = mkTerm "repeal_V2" ;
lin repeat_N = mkTerm "repeat_N" ;
lin repeat_V = mkTerm "repeat_V" ;
lin repeat_V2 = mkTerm "repeat_V2" ;
lin repeat_VS = mkTerm "repeat_VS" ;
lin repeatable_A = mkTerm "repeatable_A" ;
lin repeated_A = mkTerm "repeated_A" ;
lin repeater_N = mkTerm "repeater_N" ;
lin repechage_N = mkTerm "repechage_N" ;
lin repel_V2 = mkTerm "repel_V2" ;
lin repellent_A = mkTerm "repellent_A" ;
lin repellent_N = mkTerm "repellent_N" ;
lin repent_V = mkTerm "repent_V" ;
lin repent_V2 = mkTerm "repent_V2" ;
lin repentance_N = mkTerm "repentance_N" ;
lin repentant_A = mkTerm "repentant_A" ;
lin repercussion_N = mkTerm "repercussion_N" ;
lin repertoire_N = mkTerm "repertoire_N" ;
lin repertory_N = mkTerm "repertory_N" ;
lin repetition_N = mkTerm "repetition_N" ;
lin repetitious_A = mkTerm "repetitious_A" ;
lin repetitive_A = mkTerm "repetitive_A" ;
lin repetitiveness_N = mkTerm "repetitiveness_N" ;
lin repine_V = mkTerm "repine_V" ;
lin replace_V2 = mkTerm "replace_V2" ;
lin replaceability_N = mkTerm "replaceability_N" ;
lin replaceable_A = mkTerm "replaceable_A" ;
lin replacement_N = mkTerm "replacement_N" ;
lin replant_V2 = mkTerm "replant_V2" ;
lin replaster_V2 = mkTerm "replaster_V2" ;
lin replay_N = mkTerm "replay_N" ;
lin replay_V2 = mkTerm "replay_V2" ;
lin replenish_V2 = mkTerm "replenish_V2" ;
lin replenishment_N = mkTerm "replenishment_N" ;
lin replete_A = mkTerm "replete_A" ;
lin repletion_N = mkTerm "repletion_N" ;
lin replica_N = mkTerm "replica_N" ;
lin replicate_V2 = mkTerm "replicate_V2" ;
lin replication_N = mkTerm "replication_N" ;
lin replot_PN = mkTerm "replot_PN" ;
lin reply_N = mkTerm "reply_N" ;
lin reply_V = mkTerm "reply_V" ;
lin reply_VS = mkTerm "reply_VS" ;
lin reply_paid_A = mkTerm "reply_paid_A" ;
lin repoint_V2 = mkTerm "repoint_V2" ;
lin repond_V = mkTerm "repond_V" ;
lin report_N = mkTerm "report_N" ;
lin report_V = mkTerm "report_V" ;
lin report_V2 = mkTerm "report_V2" ;
lin report_VS = mkTerm "report_VS" ;
lin report_in_V = mkTerm "report_in_V" ;
lin reportable_A = mkTerm "reportable_A" ;
lin reportage_N = mkTerm "reportage_N" ;
lin reportedly_Adv = mkTerm "reportedly_Adv" ;
lin reporterFem_N = mkTerm "reporterFem_N" ;
lin reporterMasc_N = mkTerm "reporterMasc_N" ;
lin reporting_N = mkTerm "reporting_N" ;
lin repose_N = mkTerm "repose_N" ;
lin repose_V = mkTerm "repose_V" ;
lin repose_V2 = mkTerm "repose_V2" ;
lin reposeful_A = mkTerm "reposeful_A" ;
lin repositing_N = mkTerm "repositing_N" ;
lin reposition_V2 = mkTerm "reposition_V2" ;
lin repositioning_N = mkTerm "repositioning_N" ;
lin repository_N = mkTerm "repository_N" ;
lin repossess_V2 = mkTerm "repossess_V2" ;
lin repossession_N = mkTerm "repossession_N" ;
lin repot_V2 = mkTerm "repot_V2" ;
lin repp_N = mkTerm "repp_N" ;
lin reprehend_V2 = mkTerm "reprehend_V2" ;
lin reprehensibility_N = mkTerm "reprehensibility_N" ;
lin reprehensible_A = mkTerm "reprehensible_A" ;
lin represent_V = mkTerm "represent_V" ;
lin represent_V2 = mkTerm "represent_V2" ;
lin representable_A = mkTerm "representable_A" ;
lin representation_N = mkTerm "representation_N" ;
lin representational_A = mkTerm "representational_A" ;
lin representations_N = mkTerm "representations_N" ;
lin representativeFem_N = mkTerm "representativeFem_N" ;
lin representativeMasc_N = mkTerm "representativeMasc_N" ;
lin representative_A = mkTerm "representative_A" ;
lin repress_V2 = mkTerm "repress_V2" ;
lin repression_N = mkTerm "repression_N" ;
lin repressive_A = mkTerm "repressive_A" ;
lin repressor_N = mkTerm "repressor_N" ;
lin reprieve_N = mkTerm "reprieve_N" ;
lin reprieve_V2 = mkTerm "reprieve_V2" ;
lin reprimand_N = mkTerm "reprimand_N" ;
lin reprimand_V2 = mkTerm "reprimand_V2" ;
lin reprint_N = mkTerm "reprint_N" ;
lin reprint_V2 = mkTerm "reprint_V2" ;
lin reprisal_N = mkTerm "reprisal_N" ;
lin reprise_N = mkTerm "reprise_N" ;
lin reproach_N = mkTerm "reproach_N" ;
lin reproach_V2 = mkTerm "reproach_V2" ;
lin reproachful_A = mkTerm "reproachful_A" ;
lin reprobate_N = mkTerm "reprobate_N" ;
lin reprobate_V2 = mkTerm "reprobate_V2" ;
lin reprobation_N = mkTerm "reprobation_N" ;
lin reproduce_V = mkTerm "reproduce_V" ;
lin reproduce_V2 = mkTerm "reproduce_V2" ;
lin reproducer_N = mkTerm "reproducer_N" ;
lin reproducibility_N = mkTerm "reproducibility_N" ;
lin reproducible_A = mkTerm "reproducible_A" ;
lin reproduction_N = mkTerm "reproduction_N" ;
lin reproductive_A = mkTerm "reproductive_A" ;
lin reproof_N = mkTerm "reproof_N" ;
lin reproof_V2 = mkTerm "reproof_V2" ;
lin reprove_V2 = mkTerm "reprove_V2" ;
lin reprovingly_Adv = mkTerm "reprovingly_Adv" ;
lin reps_N = mkTerm "reps_N" ;
lin reptile_N = mkTerm "reptile_N" ;
lin reptilian_A = mkTerm "reptilian_A" ;
lin reptilian_N = mkTerm "reptilian_N" ;
lin republic_N = mkTerm "republic_N" ;
lin republican_A = mkTerm "republican_A" ;
lin republican_N = mkTerm "republican_N" ;
lin republicanism_N = mkTerm "republicanism_N" ;
lin republication_N = mkTerm "republication_N" ;
lin repudiate_V2 = mkTerm "repudiate_V2" ;
lin repudiation_N = mkTerm "repudiation_N" ;
lin repudiative_A = mkTerm "repudiative_A" ;
lin repugnance_N = mkTerm "repugnance_N" ;
lin repugnant_A = mkTerm "repugnant_A" ;
lin repulse_N = mkTerm "repulse_N" ;
lin repulse_V2 = mkTerm "repulse_V2" ;
lin repulsion_N = mkTerm "repulsion_N" ;
lin repulsive_A = mkTerm "repulsive_A" ;
lin repurchase_V2 = mkTerm "repurchase_V2" ;
lin reputable_A = mkTerm "reputable_A" ;
lin reputation_N = mkTerm "reputation_N" ;
lin repute_N = mkTerm "repute_N" ;
lin repute_V2 = mkTerm "repute_V2" ;
lin repute_V2V = mkTerm "repute_V2V" ;
lin reputed_A = mkTerm "reputed_A" ;
lin request_N = mkTerm "request_N" ;
lin request_V2 = mkTerm "request_V2" ;
lin request_VS = mkTerm "request_VS" ;
lin requiem_N = mkTerm "requiem_N" ;
lin requiescat_N = mkTerm "requiescat_N" ;
lin require_V = mkTerm "require_V" ;
lin require_V2 = mkTerm "require_V2" ;
lin require_V2V = mkTerm "require_V2V" ;
lin require_VS = mkTerm "require_VS" ;
lin required_A = mkTerm "required_A" ;
lin requirement_N = mkTerm "requirement_N" ;
lin requisite_A = mkTerm "requisite_A" ;
lin requisite_N = mkTerm "requisite_N" ;
lin requisiteness_N = mkTerm "requisiteness_N" ;
lin requisition_N = mkTerm "requisition_N" ;
lin requisition_V2 = mkTerm "requisition_V2" ;
lin requital_N = mkTerm "requital_N" ;
lin requite_V2 = mkTerm "requite_V2" ;
lin reread_V2 = mkTerm "reread_V2" ;
lin rerebrace_N = mkTerm "rerebrace_N" ;
lin reredos_N = mkTerm "reredos_N" ;
lin reroute_V2 = mkTerm "reroute_V2" ;
lin rerun_N = mkTerm "rerun_N" ;
lin rerun_V2 = mkTerm "rerun_V2" ;
lin res_N = mkTerm "res_N" ;
lin resale_N = mkTerm "resale_N" ;
lin reschedule_V2 = mkTerm "reschedule_V2" ;
lin rescind_V2 = mkTerm "rescind_V2" ;
lin rescindable_A = mkTerm "rescindable_A" ;
lin rescript_N = mkTerm "rescript_N" ;
lin rescue_N = mkTerm "rescue_N" ;
lin rescue_V2 = mkTerm "rescue_V2" ;
lin rescuerFem_N = mkTerm "rescuerFem_N" ;
lin rescuerMasc_N = mkTerm "rescuerMasc_N" ;
lin research_N = mkTerm "research_N" ;
lin research_V = mkTerm "research_V" ;
lin research_V2 = mkTerm "research_V2" ;
lin researcherFem_N = mkTerm "researcherFem_N" ;
lin researcherMasc_N = mkTerm "researcherMasc_N" ;
lin reseat_V2 = mkTerm "reseat_V2" ;
lin reseau_N = mkTerm "reseau_N" ;
lin resection_N = mkTerm "resection_N" ;
lin reseda_N = mkTerm "reseda_N" ;
lin reseed_V2 = mkTerm "reseed_V2" ;
lin resell_V2 = mkTerm "resell_V2" ;
lin resemblance_N = mkTerm "resemblance_N" ;
lin resemble_V2 = mkTerm "resemble_V2" ;
lin resent_V2 = mkTerm "resent_V2" ;
lin resent_VS = mkTerm "resent_VS" ;
lin resentful_A = mkTerm "resentful_A" ;
lin resentment_N = mkTerm "resentment_N" ;
lin reserpine_N = mkTerm "reserpine_N" ;
lin reservation_N = mkTerm "reservation_N" ;
lin reserve_N = mkTerm "reserve_N" ;
lin reserve_V = mkTerm "reserve_V" ;
lin reserve_V2 = mkTerm "reserve_V2" ;
lin reservedly_Adv = mkTerm "reservedly_Adv" ;
lin reservist_N = mkTerm "reservist_N" ;
lin reservoir_N = mkTerm "reservoir_N" ;
lin reset_N = mkTerm "reset_N" ;
lin reset_V = mkTerm "reset_V" ;
lin reset_V2 = mkTerm "reset_V2" ;
lin resettle_V = mkTerm "resettle_V" ;
lin resettle_V2 = mkTerm "resettle_V2" ;
lin resettlement_N = mkTerm "resettlement_N" ;
lin resh_N = mkTerm "resh_N" ;
lin reshape_V2 = mkTerm "reshape_V2" ;
lin reshipment_N = mkTerm "reshipment_N" ;
lin reshuffle_N = mkTerm "reshuffle_N" ;
lin reshuffle_V2 = mkTerm "reshuffle_V2" ;
lin reside_V = mkTerm "reside_V" ;
lin residence_N = mkTerm "residence_N" ;
lin residency_N = mkTerm "residency_N" ;
lin resident_A = mkTerm "resident_A" ;
lin resident_N = mkTerm "resident_N" ;
lin residential_A = mkTerm "residential_A" ;
lin residual_A = mkTerm "residual_A" ;
lin residual_N = mkTerm "residual_N" ;
lin residuary_A = mkTerm "residuary_A" ;
lin residue_N = mkTerm "residue_N" ;
lin resign_V = mkTerm "resign_V" ;
lin resign_V2 = mkTerm "resign_V2" ;
lin resignation_N = mkTerm "resignation_N" ;
lin resignedly_Adv = mkTerm "resignedly_Adv" ;
lin resilience_N = mkTerm "resilience_N" ;
lin resiliency_N = mkTerm "resiliency_N" ;
lin resilient_A = mkTerm "resilient_A" ;
lin resin_N = mkTerm "resin_N" ;
lin resinated_A = mkTerm "resinated_A" ;
lin resinlike_A = mkTerm "resinlike_A" ;
lin resinoid_N = mkTerm "resinoid_N" ;
lin resinous_A = mkTerm "resinous_A" ;
lin resist_V = mkTerm "resist_V" ;
lin resist_V2 = mkTerm "resist_V2" ;
lin resist_VV = mkTerm "resist_VV" ;
lin resistance_N = mkTerm "resistance_N" ;
lin resistant_A = mkTerm "resistant_A" ;
lin resister_N = mkTerm "resister_N" ;
lin resistible_A = mkTerm "resistible_A" ;
lin resistive_A = mkTerm "resistive_A" ;
lin resistivity_N = mkTerm "resistivity_N" ;
lin resistless_A = mkTerm "resistless_A" ;
lin resistor_N = mkTerm "resistor_N" ;
lin resold_V2 = mkTerm "resold_V2" ;
lin resole_V2 = mkTerm "resole_V2" ;
lin resolute_A = mkTerm "resolute_A" ;
lin resoluteness_N = mkTerm "resoluteness_N" ;
lin resolution_N = mkTerm "resolution_N" ;
lin resolvable_A = mkTerm "resolvable_A" ;
lin resolve_N = mkTerm "resolve_N" ;
lin resolve_V = mkTerm "resolve_V" ;
lin resolve_V2 = mkTerm "resolve_V2" ;
lin resonance_N = mkTerm "resonance_N" ;
lin resonant_A = mkTerm "resonant_A" ;
lin resonate_V = mkTerm "resonate_V" ;
lin resonate_V2 = mkTerm "resonate_V2" ;
lin resonator_N = mkTerm "resonator_N" ;
lin resorcinol_N = mkTerm "resorcinol_N" ;
lin resorption_N = mkTerm "resorption_N" ;
lin resort_N = mkTerm "resort_N" ;
lin resort_V = mkTerm "resort_V" ;
lin resound_V = mkTerm "resound_V" ;
lin resound_V2 = mkTerm "resound_V2" ;
lin resoundingly_Adv = mkTerm "resoundingly_Adv" ;
lin resource_N = mkTerm "resource_N" ;
lin resourceful_A = mkTerm "resourceful_A" ;
lin resourcefulness_N = mkTerm "resourcefulness_N" ;
lin resourceless_A = mkTerm "resourceless_A" ;
lin respect_N = mkTerm "respect_N" ;
lin respect_V2 = mkTerm "respect_V2" ;
lin respectability_N = mkTerm "respectability_N" ;
lin respectable_A = mkTerm "respectable_A" ;
lin respecter_N = mkTerm "respecter_N" ;
lin respectful_A = mkTerm "respectful_A" ;
lin respective_A = mkTerm "respective_A" ;
lin respects_N = mkTerm "respects_N" ;
lin respiration_N = mkTerm "respiration_N" ;
lin respirator_N = mkTerm "respirator_N" ;
lin respiratory_A = mkTerm "respiratory_A" ;
lin respire_V = mkTerm "respire_V" ;
lin respite_N = mkTerm "respite_N" ;
lin respite_V2 = mkTerm "respite_V2" ;
lin resplendence_N = mkTerm "resplendence_N" ;
lin resplendency_N = mkTerm "resplendency_N" ;
lin resplendent_A = mkTerm "resplendent_A" ;
lin respond_V = mkTerm "respond_V" ;
lin respond_VS = mkTerm "respond_VS" ;
lin respondent_N = mkTerm "respondent_N" ;
lin response_N = mkTerm "response_N" ;
lin responsibility_N = mkTerm "responsibility_N" ;
lin responsible_A = mkTerm "responsible_A" ;
lin responsive_A = mkTerm "responsive_A" ;
lin responsiveness_N = mkTerm "responsiveness_N" ;
lin rest_N = mkTerm "rest_N" ;
lin rest_V2 = mkTerm "rest_V2" ;
lin rest_cure_N = mkTerm "rest_cure_N" ;
lin rest_day_N = mkTerm "rest_day_N" ;
lin rest_home_N = mkTerm "rest_home_N" ;
lin rest_house_N = mkTerm "rest_house_N" ;
lin restart_V = mkTerm "restart_V" ;
lin restart_V2 = mkTerm "restart_V2" ;
lin restate_V2 = mkTerm "restate_V2" ;
lin restate_V2V = mkTerm "restate_V2V" ;
lin restatement_N = mkTerm "restatement_N" ;
lin restaurant_N = mkTerm "restaurant_N" ;
lin restauranteur_N = mkTerm "restauranteur_N" ;
lin restaurateur_N = mkTerm "restaurateur_N" ;
lin rester_N = mkTerm "rester_N" ;
lin restful_A = mkTerm "restful_A" ;
lin restfulness_N = mkTerm "restfulness_N" ;
lin restharrow_N = mkTerm "restharrow_N" ;
lin restitution_N = mkTerm "restitution_N" ;
lin restive_A = mkTerm "restive_A" ;
lin restiveness_N = mkTerm "restiveness_N" ;
lin restless_A = mkTerm "restless_A" ;
lin restlessness_N = mkTerm "restlessness_N" ;
lin restock_V2 = mkTerm "restock_V2" ;
lin restoration_N = mkTerm "restoration_N" ;
lin restorative_A = mkTerm "restorative_A" ;
lin restorative_N = mkTerm "restorative_N" ;
lin restore_V2 = mkTerm "restore_V2" ;
lin restorer_N = mkTerm "restorer_N" ;
lin restrain_V2 = mkTerm "restrain_V2" ;
lin restrainer_N = mkTerm "restrainer_N" ;
lin restraint_N = mkTerm "restraint_N" ;
lin restrict_V = mkTerm "restrict_V" ;
lin restrict_V2 = mkTerm "restrict_V2" ;
lin restricted_A = mkTerm "restricted_A" ;
lin restriction_N = mkTerm "restriction_N" ;
lin restrictive_A = mkTerm "restrictive_A" ;
lin restrictiveness_N = mkTerm "restrictiveness_N" ;
lin restructure_V = mkTerm "restructure_V" ;
lin restructure_V2 = mkTerm "restructure_V2" ;
lin restructure_V2V = mkTerm "restructure_V2V" ;
lin result_N = mkTerm "result_N" ;
lin result_V = mkTerm "result_V" ;
lin resultant_A = mkTerm "resultant_A" ;
lin resultant_N = mkTerm "resultant_N" ;
lin resulting_A = mkTerm "resulting_A" ;
lin resume_N = mkTerm "resume_N" ;
lin resume_V = mkTerm "resume_V" ;
lin resume_V2 = mkTerm "resume_V2" ;
lin resumption_N = mkTerm "resumption_N" ;
lin resurface_V = mkTerm "resurface_V" ;
lin resurface_V2 = mkTerm "resurface_V2" ;
lin resurgence_N = mkTerm "resurgence_N" ;
lin resurgent_A = mkTerm "resurgent_A" ;
lin resurrect_V = mkTerm "resurrect_V" ;
lin resurrect_V2 = mkTerm "resurrect_V2" ;
lin resurrection_N = mkTerm "resurrection_N" ;
lin resurvey_N = mkTerm "resurvey_N" ;
lin resuscitate_V = mkTerm "resuscitate_V" ;
lin resuscitate_V2 = mkTerm "resuscitate_V2" ;
lin resuscitation_N = mkTerm "resuscitation_N" ;
lin resuscitator_N = mkTerm "resuscitator_N" ;
lin resuspension_N = mkTerm "resuspension_N" ;
lin ret_PN = mkTerm "ret_PN" ;
lin ret_V2 = mkTerm "ret_V2" ;
lin retail_A = mkTerm "retail_A" ;
lin retail_Adv = mkTerm "retail_Adv" ;
lin retail_N = mkTerm "retail_N" ;
lin retail_V = mkTerm "retail_V" ;
lin retail_V2 = mkTerm "retail_V2" ;
lin retailer_N = mkTerm "retailer_N" ;
lin retailing_N = mkTerm "retailing_N" ;
lin retain_V2 = mkTerm "retain_V2" ;
lin retainer_N = mkTerm "retainer_N" ;
lin retake_N = mkTerm "retake_N" ;
lin retake_V2 = mkTerm "retake_V2" ;
lin retaliate_V = mkTerm "retaliate_V" ;
lin retaliation_N = mkTerm "retaliation_N" ;
lin retaliative_A = mkTerm "retaliative_A" ;
lin retaliatory_A = mkTerm "retaliatory_A" ;
lin retard_V2 = mkTerm "retard_V2" ;
lin retardant_N = mkTerm "retardant_N" ;
lin retardation_N = mkTerm "retardation_N" ;
lin retch_V = mkTerm "retch_V" ;
lin retd_PN = mkTerm "retd_PN" ;
lin retell_V2 = mkTerm "retell_V2" ;
lin retem_N = mkTerm "retem_N" ;
lin retention_N = mkTerm "retention_N" ;
lin retentive_A = mkTerm "retentive_A" ;
lin retentiveness_N = mkTerm "retentiveness_N" ;
lin retford_PN = mkTerm "retford_PN" ;
lin rethink_N = mkTerm "rethink_N" ;
lin rethink_V = mkTerm "rethink_V" ;
lin rethink_V2 = mkTerm "rethink_V2" ;
lin reticence_N = mkTerm "reticence_N" ;
lin reticent_A = mkTerm "reticent_A" ;
lin reticle_N = mkTerm "reticle_N" ;
lin reticulate_A = mkTerm "reticulate_A" ;
lin reticulate_V = mkTerm "reticulate_V" ;
lin reticulate_V2 = mkTerm "reticulate_V2" ;
lin reticulation_N = mkTerm "reticulation_N" ;
lin reticule_N = mkTerm "reticule_N" ;
lin reticulocyte_N = mkTerm "reticulocyte_N" ;
lin reticulum_N = mkTerm "reticulum_N" ;
lin retina_N = mkTerm "retina_N" ;
lin retinal_A = mkTerm "retinal_A" ;
lin retinene_N = mkTerm "retinene_N" ;
lin retinitis_N = mkTerm "retinitis_N" ;
lin retinoblastoma_N = mkTerm "retinoblastoma_N" ;
lin retinopathy_N = mkTerm "retinopathy_N" ;
lin retinue_N = mkTerm "retinue_N" ;
lin retire_N = mkTerm "retire_N" ;
lin retire_V = mkTerm "retire_V" ;
lin retire_V2 = mkTerm "retire_V2" ;
lin retired_A = mkTerm "retired_A" ;
lin retiree_N = mkTerm "retiree_N" ;
lin retirement_N = mkTerm "retirement_N" ;
lin retool_V2 = mkTerm "retool_V2" ;
lin retort_N = mkTerm "retort_N" ;
lin retort_V2 = mkTerm "retort_V2" ;
lin retort_VS = mkTerm "retort_VS" ;
lin retouch_V2 = mkTerm "retouch_V2" ;
lin retrace_V2 = mkTerm "retrace_V2" ;
lin retract_V = mkTerm "retract_V" ;
lin retract_V2 = mkTerm "retract_V2" ;
lin retractable_A = mkTerm "retractable_A" ;
lin retractile_A = mkTerm "retractile_A" ;
lin retraction_N = mkTerm "retraction_N" ;
lin retractor_N = mkTerm "retractor_N" ;
lin retraining_N = mkTerm "retraining_N" ;
lin retral_A = mkTerm "retral_A" ;
lin retransmit_V2 = mkTerm "retransmit_V2" ;
lin retread_N = mkTerm "retread_N" ;
lin retread_V2 = mkTerm "retread_V2" ;
lin retreat_N = mkTerm "retreat_N" ;
lin retreat_V = mkTerm "retreat_V" ;
lin retreatant_N = mkTerm "retreatant_N" ;
lin retreated_N = mkTerm "retreated_N" ;
lin retrench_V = mkTerm "retrench_V" ;
lin retrench_V2 = mkTerm "retrench_V2" ;
lin retrenchment_N = mkTerm "retrenchment_N" ;
lin retrial_N = mkTerm "retrial_N" ;
lin retribution_N = mkTerm "retribution_N" ;
lin retributive_A = mkTerm "retributive_A" ;
lin retrievable_A = mkTerm "retrievable_A" ;
lin retrieval_N = mkTerm "retrieval_N" ;
lin retrieve_V = mkTerm "retrieve_V" ;
lin retrieve_V2 = mkTerm "retrieve_V2" ;
lin retriever_N = mkTerm "retriever_N" ;
lin retro_N = mkTerm "retro_N" ;
lin retroactive_A = mkTerm "retroactive_A" ;
lin retrofit_N = mkTerm "retrofit_N" ;
lin retrofit_V2 = mkTerm "retrofit_V2" ;
lin retroflection_N = mkTerm "retroflection_N" ;
lin retroflex_A = mkTerm "retroflex_A" ;
lin retrograde_A = mkTerm "retrograde_A" ;
lin retrograde_V = mkTerm "retrograde_V" ;
lin retrogress_V = mkTerm "retrogress_V" ;
lin retrogression_N = mkTerm "retrogression_N" ;
lin retrogressive_A = mkTerm "retrogressive_A" ;
lin retronym_N = mkTerm "retronym_N" ;
lin retrorocket_N = mkTerm "retrorocket_N" ;
lin retrorse_A = mkTerm "retrorse_A" ;
lin retrospect_N = mkTerm "retrospect_N" ;
lin retrospection_N = mkTerm "retrospection_N" ;
lin retrospective_A = mkTerm "retrospective_A" ;
lin retrospective_N = mkTerm "retrospective_N" ;
lin retrousse_A = mkTerm "retrousse_A" ;
lin retroversion_N = mkTerm "retroversion_N" ;
lin retrovirus_N = mkTerm "retrovirus_N" ;
lin retrovision_N = mkTerm "retrovision_N" ;
lin retsina_N = mkTerm "retsina_N" ;
lin return_N = mkTerm "return_N" ;
lin return_V = mkTerm "return_V" ;
lin return_V2 = mkTerm "return_V2" ;
lin returnable_A = mkTerm "returnable_A" ;
lin reunification_N = mkTerm "reunification_N" ;
lin reunion_N = mkTerm "reunion_N" ;
lin reunite_V = mkTerm "reunite_V" ;
lin reunite_V2 = mkTerm "reunite_V2" ;
lin reuptake_N = mkTerm "reuptake_N" ;
lin rev_N = mkTerm "rev_N" ;
lin rev_PN = mkTerm "rev_PN" ;
lin rev_V = mkTerm "rev_V" ;
lin rev_V2 = mkTerm "rev_V2" ;
lin revaluation_N = mkTerm "revaluation_N" ;
lin revalue_V2 = mkTerm "revalue_V2" ;
lin revamp_V2 = mkTerm "revamp_V2" ;
lin revd_PN = mkTerm "revd_PN" ;
lin reveal_V2 = mkTerm "reveal_V2" ;
lin reveal_VS = mkTerm "reveal_VS" ;
lin revealing_A = mkTerm "revealing_A" ;
lin reveille_N = mkTerm "reveille_N" ;
lin revel_N = mkTerm "revel_N" ;
lin revel_V = mkTerm "revel_V" ;
lin revelation_N = mkTerm "revelation_N" ;
lin reveler_N = mkTerm "reveler_N" ;
lin reveller_N = mkTerm "reveller_N" ;
lin revelry_N = mkTerm "revelry_N" ;
lin revenant_A = mkTerm "revenant_A" ;
lin revenant_N = mkTerm "revenant_N" ;
lin revenge_N = mkTerm "revenge_N" ;
lin revenge_V2 = mkTerm "revenge_V2" ;
lin revengeful_A = mkTerm "revengeful_A" ;
lin revenue_N = mkTerm "revenue_N" ;
lin revenuer_N = mkTerm "revenuer_N" ;
lin reverberant_A = mkTerm "reverberant_A" ;
lin reverberate_V = mkTerm "reverberate_V" ;
lin reverberate_V2 = mkTerm "reverberate_V2" ;
lin reverberation_N = mkTerm "reverberation_N" ;
lin revere_V2 = mkTerm "revere_V2" ;
lin reverence_N = mkTerm "reverence_N" ;
lin reverence_V2 = mkTerm "reverence_V2" ;
lin reverend_A = mkTerm "reverend_A" ;
lin reverend_N = mkTerm "reverend_N" ;
lin reverent_A = mkTerm "reverent_A" ;
lin reverential_A = mkTerm "reverential_A" ;
lin reverie_N = mkTerm "reverie_N" ;
lin revers_N = mkTerm "revers_N" ;
lin reversal_N = mkTerm "reversal_N" ;
lin reverse_A = mkTerm "reverse_A" ;
lin reverse_N = mkTerm "reverse_N" ;
lin reverse_V = mkTerm "reverse_V" ;
lin reverse_V2 = mkTerm "reverse_V2" ;
lin reversibility_N = mkTerm "reversibility_N" ;
lin reversible_A = mkTerm "reversible_A" ;
lin reversible_N = mkTerm "reversible_N" ;
lin reversion_N = mkTerm "reversion_N" ;
lin reversionary_A = mkTerm "reversionary_A" ;
lin reversioner_N = mkTerm "reversioner_N" ;
lin revert_V = mkTerm "revert_V" ;
lin revertible_A = mkTerm "revertible_A" ;
lin revetment_N = mkTerm "revetment_N" ;
lin review_N = mkTerm "review_N" ;
lin review_V = mkTerm "review_V" ;
lin review_V2 = mkTerm "review_V2" ;
lin reviewer_N = mkTerm "reviewer_N" ;
lin revile_V = mkTerm "revile_V" ;
lin revile_V2 = mkTerm "revile_V2" ;
lin revise_N = mkTerm "revise_N" ;
lin revise_V = mkTerm "revise_V" ;
lin revise_V2 = mkTerm "revise_V2" ;
lin revised_A = mkTerm "revised_A" ;
lin reviser_N = mkTerm "reviser_N" ;
lin revision_N = mkTerm "revision_N" ;
lin revisionism_N = mkTerm "revisionism_N" ;
lin revisionistFem_N = mkTerm "revisionistFem_N" ;
lin revisionistMasc_N = mkTerm "revisionistMasc_N" ;
lin revisit_V2 = mkTerm "revisit_V2" ;
lin revitalization_N = mkTerm "revitalization_N" ;
lin revitalize_V2 = mkTerm "revitalize_V2" ;
lin revival_N = mkTerm "revival_N" ;
lin revivalism_N = mkTerm "revivalism_N" ;
lin revivalist_N = mkTerm "revivalist_N" ;
lin revivalistic_A = mkTerm "revivalistic_A" ;
lin revive_V = mkTerm "revive_V" ;
lin revive_V2 = mkTerm "revive_V2" ;
lin revivify_V2 = mkTerm "revivify_V2" ;
lin revocable_A = mkTerm "revocable_A" ;
lin revocation_N = mkTerm "revocation_N" ;
lin revoke_N = mkTerm "revoke_N" ;
lin revoke_V = mkTerm "revoke_V" ;
lin revoke_V2 = mkTerm "revoke_V2" ;
lin revolt_N = mkTerm "revolt_N" ;
lin revolt_V = mkTerm "revolt_V" ;
lin revolt_V2 = mkTerm "revolt_V2" ;
lin revolution_N = mkTerm "revolution_N" ;
lin revolutionary_A = mkTerm "revolutionary_A" ;
lin revolutionary_N = mkTerm "revolutionary_N" ;
lin revolutionism_N = mkTerm "revolutionism_N" ;
lin revolutionist_N = mkTerm "revolutionist_N" ;
lin revolutionize_V2 = mkTerm "revolutionize_V2" ;
lin revolve_V = mkTerm "revolve_V" ;
lin revolve_V2 = mkTerm "revolve_V2" ;
lin revolver_N = mkTerm "revolver_N" ;
lin revue_N = mkTerm "revue_N" ;
lin revulsion_N = mkTerm "revulsion_N" ;
lin reward_N = mkTerm "reward_N" ;
lin reward_V2 = mkTerm "reward_V2" ;
lin rewardful_A = mkTerm "rewardful_A" ;
lin rewarding_A = mkTerm "rewarding_A" ;
lin rewire_V2 = mkTerm "rewire_V2" ;
lin reword_V2 = mkTerm "reword_V2" ;
lin rewording_N = mkTerm "rewording_N" ;
lin rework_V2 = mkTerm "rework_V2" ;
lin rewrite_N = mkTerm "rewrite_N" ;
lin rewrite_V2 = mkTerm "rewrite_V2" ;
lin rewriting_N = mkTerm "rewriting_N" ;
lin rex_PN = mkTerm "rex_PN" ;
lin reykjavik_PN = mkTerm "reykjavik_PN" ;
lin rgb_N = mkTerm "rgb_N" ;
lin rhabdomyoma_N = mkTerm "rhabdomyoma_N" ;
lin rhabdomyosarcoma_N = mkTerm "rhabdomyosarcoma_N" ;
lin rhabdovirus_N = mkTerm "rhabdovirus_N" ;
lin rhagades_N = mkTerm "rhagades_N" ;
lin rhapsodize_V = mkTerm "rhapsodize_V" ;
lin rhapsody_N = mkTerm "rhapsody_N" ;
lin rhea_N = mkTerm "rhea_N" ;
lin rheims_PN = mkTerm "rheims_PN" ;
lin rhenish_A = mkTerm "rhenish_A" ;
lin rhenium_N = mkTerm "rhenium_N" ;
lin rheologic_A = mkTerm "rheologic_A" ;
lin rheology_N = mkTerm "rheology_N" ;
lin rheometer_N = mkTerm "rheometer_N" ;
lin rheostat_N = mkTerm "rheostat_N" ;
lin rhesus_N = mkTerm "rhesus_N" ;
lin rhetoric_N = mkTerm "rhetoric_N" ;
lin rhetorical_A = mkTerm "rhetorical_A" ;
lin rhetorician_N = mkTerm "rhetorician_N" ;
lin rheum_N = mkTerm "rheum_N" ;
lin rheumatic_A = mkTerm "rheumatic_A" ;
lin rheumatic_N = mkTerm "rheumatic_N" ;
lin rheumatism_N = mkTerm "rheumatism_N" ;
lin rheumatoid_A = mkTerm "rheumatoid_A" ;
lin rheumatologist_N = mkTerm "rheumatologist_N" ;
lin rheumatology_N = mkTerm "rheumatology_N" ;
lin rheumy_A = mkTerm "rheumy_A" ;
lin rheydt_PN = mkTerm "rheydt_PN" ;
lin rhinal_A = mkTerm "rhinal_A" ;
lin rhine_PN = mkTerm "rhine_PN" ;
lin rhinencephalon_N = mkTerm "rhinencephalon_N" ;
lin rhinestone_N = mkTerm "rhinestone_N" ;
lin rhinion_N = mkTerm "rhinion_N" ;
lin rhinitis_N = mkTerm "rhinitis_N" ;
lin rhino_N = mkTerm "rhino_N" ;
lin rhinoceros_N = mkTerm "rhinoceros_N" ;
lin rhinolaryngology_N = mkTerm "rhinolaryngology_N" ;
lin rhinopathy_N = mkTerm "rhinopathy_N" ;
lin rhinophyma_N = mkTerm "rhinophyma_N" ;
lin rhinorrhea_N = mkTerm "rhinorrhea_N" ;
lin rhinoscope_N = mkTerm "rhinoscope_N" ;
lin rhinoscopy_N = mkTerm "rhinoscopy_N" ;
lin rhinosporidiosis_N = mkTerm "rhinosporidiosis_N" ;
lin rhinostenosis_N = mkTerm "rhinostenosis_N" ;
lin rhinotomy_N = mkTerm "rhinotomy_N" ;
lin rhinotracheitis_N = mkTerm "rhinotracheitis_N" ;
lin rhinovirus_N = mkTerm "rhinovirus_N" ;
lin rhizoctinia_N = mkTerm "rhizoctinia_N" ;
lin rhizoid_N = mkTerm "rhizoid_N" ;
lin rhizoidal_A = mkTerm "rhizoidal_A" ;
lin rhizomatous_A = mkTerm "rhizomatous_A" ;
lin rhizome_N = mkTerm "rhizome_N" ;
lin rhizomorph_N = mkTerm "rhizomorph_N" ;
lin rhizopod_N = mkTerm "rhizopod_N" ;
lin rhizopus_N = mkTerm "rhizopus_N" ;
lin rhizotomy_N = mkTerm "rhizotomy_N" ;
lin rho_N = mkTerm "rho_N" ;
lin rhode_PN = mkTerm "rhode_PN" ;
lin rhodium_N = mkTerm "rhodium_N" ;
lin rhodochrosite_N = mkTerm "rhodochrosite_N" ;
lin rhododendron_N = mkTerm "rhododendron_N" ;
lin rhodolite_N = mkTerm "rhodolite_N" ;
lin rhodonite_N = mkTerm "rhodonite_N" ;
lin rhomb_N = mkTerm "rhomb_N" ;
lin rhombic_A = mkTerm "rhombic_A" ;
lin rhombohedral_A = mkTerm "rhombohedral_A" ;
lin rhombohedron_N = mkTerm "rhombohedron_N" ;
lin rhomboid_A = mkTerm "rhomboid_A" ;
lin rhomboid_N = mkTerm "rhomboid_N" ;
lin rhombus_N = mkTerm "rhombus_N" ;
lin rhonchus_N = mkTerm "rhonchus_N" ;
lin rhondda_PN = mkTerm "rhondda_PN" ;
lin rhosllanerchrugog_PN = mkTerm "rhosllanerchrugog_PN" ;
lin rhubarb_N = mkTerm "rhubarb_N" ;
lin rhyl_PN = mkTerm "rhyl_PN" ;
lin rhyme_N = mkTerm "rhyme_N" ;
lin rhyme_V = mkTerm "rhyme_V" ;
lin rhyme_V2 = mkTerm "rhyme_V2" ;
lin rhymer_N = mkTerm "rhymer_N" ;
lin rhymester_N = mkTerm "rhymester_N" ;
lin rhymney_PN = mkTerm "rhymney_PN" ;
lin rhyolite_N = mkTerm "rhyolite_N" ;
lin rhythm_N = mkTerm "rhythm_N" ;
lin rhythmic_A = mkTerm "rhythmic_A" ;
lin rhythmical_A = mkTerm "rhythmical_A" ;
lin rhythmicity_N = mkTerm "rhythmicity_N" ;
lin rib_N = mkTerm "rib_N" ;
lin rib_V2 = mkTerm "rib_V2" ;
lin ribald_A = mkTerm "ribald_A" ;
lin ribald_N = mkTerm "ribald_N" ;
lin ribaldry_N = mkTerm "ribaldry_N" ;
lin riband_N = mkTerm "riband_N" ;
lin ribavirin_N = mkTerm "ribavirin_N" ;
lin ribbing_N = mkTerm "ribbing_N" ;
lin ribbon_N = mkTerm "ribbon_N" ;
lin ribbonfish_N = mkTerm "ribbonfish_N" ;
lin ribbonlike_A = mkTerm "ribbonlike_A" ;
lin ribier_N = mkTerm "ribier_N" ;
lin ribless_A = mkTerm "ribless_A" ;
lin riblike_A = mkTerm "riblike_A" ;
lin riboflavin_N = mkTerm "riboflavin_N" ;
lin ribonuclease_N = mkTerm "ribonuclease_N" ;
lin ribose_N = mkTerm "ribose_N" ;
lin ribosome_N = mkTerm "ribosome_N" ;
lin rice_N = mkTerm "rice_N" ;
lin rice_paper_N = mkTerm "rice_paper_N" ;
lin ricegrass_N = mkTerm "ricegrass_N" ;
lin ricer_N = mkTerm "ricer_N" ;
lin rich_A = mkTerm "rich_A" ;
lin richard_PN = mkTerm "richard_PN" ;
lin richmond_PN = mkTerm "richmond_PN" ;
lin richmond_upon_thames_PN = mkTerm "richmond_upon_thames_PN" ;
lin richness_N = mkTerm "richness_N" ;
lin richweed_N = mkTerm "richweed_N" ;
lin ricin_N = mkTerm "ricin_N" ;
lin rick_N = mkTerm "rick_N" ;
lin rick_PN = mkTerm "rick_PN" ;
lin rick_V2 = mkTerm "rick_V2" ;
lin rickets_N = mkTerm "rickets_N" ;
lin rickettsia_N = mkTerm "rickettsia_N" ;
lin rickettsial_A = mkTerm "rickettsial_A" ;
lin rickettsialpox_N = mkTerm "rickettsialpox_N" ;
lin rickety_A = mkTerm "rickety_A" ;
lin rickey_N = mkTerm "rickey_N" ;
lin rickmansworth_PN = mkTerm "rickmansworth_PN" ;
lin rickrack_N = mkTerm "rickrack_N" ;
lin rickshaw_N = mkTerm "rickshaw_N" ;
lin ricky_PN = mkTerm "ricky_PN" ;
lin ricochet_N = mkTerm "ricochet_N" ;
lin ricochet_V = mkTerm "ricochet_V" ;
lin ricochet_V2 = mkTerm "ricochet_V2" ;
lin ricotta_N = mkTerm "ricotta_N" ;
lin rictus_N = mkTerm "rictus_N" ;
lin rid_V2 = mkTerm "rid_V2" ;
lin riddance_N = mkTerm "riddance_N" ;
lin riddle_N = mkTerm "riddle_N" ;
lin riddle_V2 = mkTerm "riddle_V2" ;
lin ride_N = mkTerm "ride_N" ;
lin ride_V = mkTerm "ride_V" ;
lin ride_V2 = mkTerm "ride_V2" ;
lin ride_off_V = mkTerm "ride_off_V" ;
lin ride_on_V2 = mkTerm "ride_on_V2" ;
lin ride_out_V2 = mkTerm "ride_out_V2" ;
lin ride_up_V = mkTerm "ride_up_V" ;
lin riderFem_N = mkTerm "riderFem_N" ;
lin riderMasc_N = mkTerm "riderMasc_N" ;
lin riderless_A = mkTerm "riderless_A" ;
lin ridge_N = mkTerm "ridge_N" ;
lin ridge_V2 = mkTerm "ridge_V2" ;
lin ridge_tile_N = mkTerm "ridge_tile_N" ;
lin ridgeling_N = mkTerm "ridgeling_N" ;
lin ridgepole_N = mkTerm "ridgepole_N" ;
lin ridicule_N = mkTerm "ridicule_N" ;
lin ridicule_V2 = mkTerm "ridicule_V2" ;
lin ridiculous_A = mkTerm "ridiculous_A" ;
lin riding_N = mkTerm "riding_N" ;
lin riding_habit_N = mkTerm "riding_habit_N" ;
lin riding_lamp_N = mkTerm "riding_lamp_N" ;
lin riding_light_N = mkTerm "riding_light_N" ;
lin riding_master_N = mkTerm "riding_master_N" ;
lin riding_school_N = mkTerm "riding_school_N" ;
lin ridley_N = mkTerm "ridley_N" ;
lin riel_N = mkTerm "riel_N" ;
lin riesling_N = mkTerm "riesling_N" ;
lin rifampin_N = mkTerm "rifampin_N" ;
lin rife_A = mkTerm "rife_A" ;
lin riff_N = mkTerm "riff_N" ;
lin riff_raff_N = mkTerm "riff_raff_N" ;
lin riffle_N = mkTerm "riffle_N" ;
lin riffle_V = mkTerm "riffle_V" ;
lin riffle_V2 = mkTerm "riffle_V2" ;
lin rifle_N = mkTerm "rifle_N" ;
lin rifle_V2 = mkTerm "rifle_V2" ;
lin rifle_range_N = mkTerm "rifle_range_N" ;
lin rifle_shot_N = mkTerm "rifle_shot_N" ;
lin riflebird_N = mkTerm "riflebird_N" ;
lin rifleman_N = mkTerm "rifleman_N" ;
lin rift_N = mkTerm "rift_N" ;
lin rift_valley_N = mkTerm "rift_valley_N" ;
lin rig_N = mkTerm "rig_N" ;
lin rig_V = mkTerm "rig_V" ;
lin rig_V2 = mkTerm "rig_V2" ;
lin riga_PN = mkTerm "riga_PN" ;
lin rigatoni_N = mkTerm "rigatoni_N" ;
lin rigg_up_V = mkTerm "rigg_up_V" ;
lin rigger_N = mkTerm "rigger_N" ;
lin rigging_N = mkTerm "rigging_N" ;
lin right_1_A = mkTerm "right_1_A" ;
lin right_1_Adv = mkTerm "right_1_Adv" ;
lin right_2_A = mkTerm "right_2_A" ;
lin right_2_Adv = mkTerm "right_2_Adv" ;
lin right_3_A = mkTerm "right_3_A" ;
lin right_Interj = mkTerm "right_Interj" ;
lin right_N = mkTerm "right_N" ;
lin right_V2 = mkTerm "right_V2" ;
lin right_angled_A = mkTerm "right_angled_A" ;
lin right_down_A = mkTerm "right_down_A" ;
lin right_down_Adv = mkTerm "right_down_Adv" ;
lin right_hand_A = mkTerm "right_hand_A" ;
lin right_handed_A = mkTerm "right_handed_A" ;
lin right_hander_N = mkTerm "right_hander_N" ;
lin right_minded_A = mkTerm "right_minded_A" ;
lin right_of_Prep = mkTerm "right_of_Prep" ;
lin right_turn_N = mkTerm "right_turn_N" ;
lin right_wing_N = mkTerm "right_wing_N" ;
lin right_winger_N = mkTerm "right_winger_N" ;
lin righteous_A = mkTerm "righteous_A" ;
lin righteousness_N = mkTerm "righteousness_N" ;
lin rightful_A = mkTerm "rightful_A" ;
lin rightfulness_N = mkTerm "rightfulness_N" ;
lin rightish_A = mkTerm "rightish_A" ;
lin rightism_N = mkTerm "rightism_N" ;
lin rightist_A = mkTerm "rightist_A" ;
lin rightist_N = mkTerm "rightist_N" ;
lin rightmost_A = mkTerm "rightmost_A" ;
lin rightness_N = mkTerm "rightness_N" ;
lin rigid_A = mkTerm "rigid_A" ;
lin rigidity_N = mkTerm "rigidity_N" ;
lin rigmarole_N = mkTerm "rigmarole_N" ;
lin rigor_mortis_N = mkTerm "rigor_mortis_N" ;
lin rigorous_A = mkTerm "rigorous_A" ;
lin rigour_N = mkTerm "rigour_N" ;
lin rigout_N = mkTerm "rigout_N" ;
lin riihimäki_PN = mkTerm "riihimäki_PN" ;
lin rijeka_PN = mkTerm "rijeka_PN" ;
lin rijsttaffel_N = mkTerm "rijsttaffel_N" ;
lin rile_V2 = mkTerm "rile_V2" ;
lin rill_N = mkTerm "rill_N" ;
lin rim_N = mkTerm "rim_N" ;
lin rim_V2 = mkTerm "rim_V2" ;
lin rima_N = mkTerm "rima_N" ;
lin rime_N = mkTerm "rime_N" ;
lin rime_V2 = mkTerm "rime_V2" ;
lin rimini_PN = mkTerm "rimini_PN" ;
lin rimless_A = mkTerm "rimless_A" ;
lin rimose_A = mkTerm "rimose_A" ;
lin rimu_N = mkTerm "rimu_N" ;
lin rind_N = mkTerm "rind_N" ;
lin rinderpest_N = mkTerm "rinderpest_N" ;
lin ring_4_V2 = mkTerm "ring_4_V2" ;
lin ring_6_V2 = mkTerm "ring_6_V2" ;
lin ring_N = mkTerm "ring_N" ;
lin ring_V = mkTerm "ring_V" ;
lin ring_armour_N = mkTerm "ring_armour_N" ;
lin ring_back_V2 = mkTerm "ring_back_V2" ;
lin ring_finger_N = mkTerm "ring_finger_N" ;
lin ring_in_V = mkTerm "ring_in_V" ;
lin ring_mail_N = mkTerm "ring_mail_N" ;
lin ring_off_V = mkTerm "ring_off_V" ;
lin ring_out_V = mkTerm "ring_out_V" ;
lin ring_road_N = mkTerm "ring_road_N" ;
lin ring_round_V = mkTerm "ring_round_V" ;
lin ring_up_V = mkTerm "ring_up_V" ;
lin ring_up_V2 = mkTerm "ring_up_V2" ;
lin ring_with_V2 = mkTerm "ring_with_V2" ;
lin ringdove_N = mkTerm "ringdove_N" ;
lin ringer_N = mkTerm "ringer_N" ;
lin ringgit_N = mkTerm "ringgit_N" ;
lin ringhals_N = mkTerm "ringhals_N" ;
lin ringing_N = mkTerm "ringing_N" ;
lin ringleader_N = mkTerm "ringleader_N" ;
lin ringlet_N = mkTerm "ringlet_N" ;
lin ringleted_A = mkTerm "ringleted_A" ;
lin ringlike_A = mkTerm "ringlike_A" ;
lin ringmaster_N = mkTerm "ringmaster_N" ;
lin rings_N = mkTerm "rings_N" ;
lin ringside_N = mkTerm "ringside_N" ;
lin ringtail_N = mkTerm "ringtail_N" ;
lin ringwood_PN = mkTerm "ringwood_PN" ;
lin ringworm_N = mkTerm "ringworm_N" ;
lin rink_N = mkTerm "rink_N" ;
lin rinse_N = mkTerm "rinse_N" ;
lin rinse_V2 = mkTerm "rinse_V2" ;
lin rio_de_janeiro_PN = mkTerm "rio_de_janeiro_PN" ;
lin riot_N = mkTerm "riot_N" ;
lin riot_V = mkTerm "riot_V" ;
lin rioter_N = mkTerm "rioter_N" ;
lin rioting_N = mkTerm "rioting_N" ;
lin riotous_A = mkTerm "riotous_A" ;
lin rip_N = mkTerm "rip_N" ;
lin rip_PN = mkTerm "rip_PN" ;
lin rip_V = mkTerm "rip_V" ;
lin rip_V2 = mkTerm "rip_V2" ;
lin rip_off_N = mkTerm "rip_off_N" ;
lin rip_off_V2 = mkTerm "rip_off_V2" ;
lin rip_out_V = mkTerm "rip_out_V" ;
lin rip_roaring_A = mkTerm "rip_roaring_A" ;
lin riparian_A = mkTerm "riparian_A" ;
lin ripcord_N = mkTerm "ripcord_N" ;
lin ripe_A = mkTerm "ripe_A" ;
lin ripen_V = mkTerm "ripen_V" ;
lin ripen_V2 = mkTerm "ripen_V2" ;
lin ripeness_N = mkTerm "ripeness_N" ;
lin ripening_N = mkTerm "ripening_N" ;
lin ripley_PN = mkTerm "ripley_PN" ;
lin ripon_PN = mkTerm "ripon_PN" ;
lin riposte_N = mkTerm "riposte_N" ;
lin riposte_V = mkTerm "riposte_V" ;
lin ripper_N = mkTerm "ripper_N" ;
lin ripple_N = mkTerm "ripple_N" ;
lin ripple_V = mkTerm "ripple_V" ;
lin ripple_V2 = mkTerm "ripple_V2" ;
lin ripsaw_N = mkTerm "ripsaw_N" ;
lin riptide_N = mkTerm "riptide_N" ;
lin risborough_PN = mkTerm "risborough_PN" ;
lin risca_PN = mkTerm "risca_PN" ;
lin rise_N = mkTerm "rise_N" ;
lin rise_V = mkTerm "rise_V" ;
lin rise_V2 = mkTerm "rise_V2" ;
lin riser_N = mkTerm "riser_N" ;
lin rishton_PN = mkTerm "rishton_PN" ;
lin risibility_N = mkTerm "risibility_N" ;
lin risible_A = mkTerm "risible_A" ;
lin rising_A = mkTerm "rising_A" ;
lin rising_N = mkTerm "rising_N" ;
lin risk_N = mkTerm "risk_N" ;
lin risk_V2 = mkTerm "risk_V2" ;
lin risk_VV = mkTerm "risk_VV" ;
lin riskiness_N = mkTerm "riskiness_N" ;
lin risklessness_N = mkTerm "risklessness_N" ;
lin risky_A = mkTerm "risky_A" ;
lin risotto_N = mkTerm "risotto_N" ;
lin risque_A = mkTerm "risque_A" ;
lin rissole_N = mkTerm "rissole_N" ;
lin ristiina_PN = mkTerm "ristiina_PN" ;
lin ristijärvi_PN = mkTerm "ristijärvi_PN" ;
lin ristinummi_PN = mkTerm "ristinummi_PN" ;
lin rita_PN = mkTerm "rita_PN" ;
lin rite_N = mkTerm "rite_N" ;
lin ritonavir_N = mkTerm "ritonavir_N" ;
lin ritual_A = mkTerm "ritual_A" ;
lin ritual_N = mkTerm "ritual_N" ;
lin ritualism_N = mkTerm "ritualism_N" ;
lin ritualist_N = mkTerm "ritualist_N" ;
lin ritualistic_A = mkTerm "ritualistic_A" ;
lin ritz_N = mkTerm "ritz_N" ;
lin ritzy_A = mkTerm "ritzy_A" ;
lin rival_A = mkTerm "rival_A" ;
lin rival_N = mkTerm "rival_N" ;
lin rival_V2 = mkTerm "rival_V2" ;
lin rivalry_N = mkTerm "rivalry_N" ;
lin rive_V = mkTerm "rive_V" ;
lin rive_V2 = mkTerm "rive_V2" ;
lin river_N = mkTerm "river_N" ;
lin river_basin_N = mkTerm "river_basin_N" ;
lin river_bed_N = mkTerm "river_bed_N" ;
lin riverbank_N = mkTerm "riverbank_N" ;
lin riverside_N = mkTerm "riverside_N" ;
lin rivet_N = mkTerm "rivet_N" ;
lin rivet_V = mkTerm "rivet_V" ;
lin rivet_V2 = mkTerm "rivet_V2" ;
lin riveter_N = mkTerm "riveter_N" ;
lin riviera_PN = mkTerm "riviera_PN" ;
lin rivulet_N = mkTerm "rivulet_N" ;
lin rivulus_N = mkTerm "rivulus_N" ;
lin rly_N = mkTerm "rly_N" ;
lin rm_N = mkTerm "rm_N" ;
lin rn_N = mkTerm "rn_N" ;
lin roach_N = mkTerm "roach_N" ;
lin road_N = mkTerm "road_N" ;
lin road_book_N = mkTerm "road_book_N" ;
lin road_hog_N = mkTerm "road_hog_N" ;
lin road_metal_N = mkTerm "road_metal_N" ;
lin road_sense_N = mkTerm "road_sense_N" ;
lin roadbed_N = mkTerm "roadbed_N" ;
lin roadblock_N = mkTerm "roadblock_N" ;
lin roadhouse_N = mkTerm "roadhouse_N" ;
lin roadkill_N = mkTerm "roadkill_N" ;
lin roadless_A = mkTerm "roadless_A" ;
lin roadman_N = mkTerm "roadman_N" ;
lin roadmender_N = mkTerm "roadmender_N" ;
lin roadrunner_N = mkTerm "roadrunner_N" ;
lin roads_N = mkTerm "roads_N" ;
lin roadside_N = mkTerm "roadside_N" ;
lin roadstead_N = mkTerm "roadstead_N" ;
lin roadster_N = mkTerm "roadster_N" ;
lin roadway_N = mkTerm "roadway_N" ;
lin roadworthiness_N = mkTerm "roadworthiness_N" ;
lin roadworthy_A = mkTerm "roadworthy_A" ;
lin roam_V = mkTerm "roam_V" ;
lin roam_V2 = mkTerm "roam_V2" ;
lin roan_A = mkTerm "roan_A" ;
lin roan_N = mkTerm "roan_N" ;
lin roar_N = mkTerm "roar_N" ;
lin roar_V = mkTerm "roar_V" ;
lin roar_V2 = mkTerm "roar_V2" ;
lin roarer_N = mkTerm "roarer_N" ;
lin roaring_Adv = mkTerm "roaring_Adv" ;
lin roast_A = mkTerm "roast_A" ;
lin roast_N = mkTerm "roast_N" ;
lin roast_V = mkTerm "roast_V" ;
lin roast_V2 = mkTerm "roast_V2" ;
lin roaster_N = mkTerm "roaster_N" ;
lin roasting_N = mkTerm "roasting_N" ;
lin rob_PN = mkTerm "rob_PN" ;
lin rob_V2 = mkTerm "rob_V2" ;
lin robalo_N = mkTerm "robalo_N" ;
lin robber_N = mkTerm "robber_N" ;
lin robbery_N = mkTerm "robbery_N" ;
lin robe_N = mkTerm "robe_N" ;
lin robe_V = mkTerm "robe_V" ;
lin robe_V2 = mkTerm "robe_V2" ;
lin robert_PN = mkTerm "robert_PN" ;
lin robin_N = mkTerm "robin_N" ;
lin robin_PN = mkTerm "robin_PN" ;
lin roble_N = mkTerm "roble_N" ;
lin robot_N = mkTerm "robot_N" ;
lin robotic_A = mkTerm "robotic_A" ;
lin robotics_N = mkTerm "robotics_N" ;
lin robust_A = mkTerm "robust_A" ;
lin robustness_N = mkTerm "robustness_N" ;
lin roc_N = mkTerm "roc_N" ;
lin roccella_N = mkTerm "roccella_N" ;
lin rochdale_PN = mkTerm "rochdale_PN" ;
lin rochester_PN = mkTerm "rochester_PN" ;
lin rock_'n_roll_N = mkTerm "rock_'n_roll_N" ;
lin rock_1_N = mkTerm "rock_1_N" ;
lin rock_2_N = mkTerm "rock_2_N" ;
lin rock_V = mkTerm "rock_V" ;
lin rock_V2 = mkTerm "rock_V2" ;
lin rock_bottom_N = mkTerm "rock_bottom_N" ;
lin rock_cake_N = mkTerm "rock_cake_N" ;
lin rock_climbing_N = mkTerm "rock_climbing_N" ;
lin rock_crystal_N = mkTerm "rock_crystal_N" ;
lin rock_garden_N = mkTerm "rock_garden_N" ;
lin rock_plant_N = mkTerm "rock_plant_N" ;
lin rock_salmon_N = mkTerm "rock_salmon_N" ;
lin rock_salt_N = mkTerm "rock_salt_N" ;
lin rockabilly_N = mkTerm "rockabilly_N" ;
lin rocker_N = mkTerm "rocker_N" ;
lin rockery_N = mkTerm "rockery_N" ;
lin rocket_1_N = mkTerm "rocket_1_N" ;
lin rocket_2_N = mkTerm "rocket_2_N" ;
lin rocket_V = mkTerm "rocket_V" ;
lin rocket_base_N = mkTerm "rocket_base_N" ;
lin rocket_range_N = mkTerm "rocket_range_N" ;
lin rocketry_N = mkTerm "rocketry_N" ;
lin rockfish_N = mkTerm "rockfish_N" ;
lin rockiness_N = mkTerm "rockiness_N" ;
lin rocking_chair_N = mkTerm "rocking_chair_N" ;
lin rocking_horse_N = mkTerm "rocking_horse_N" ;
lin rockrose_N = mkTerm "rockrose_N" ;
lin rockslide_N = mkTerm "rockslide_N" ;
lin rockweed_N = mkTerm "rockweed_N" ;
lin rocky_A = mkTerm "rocky_A" ;
lin rococo_A = mkTerm "rococo_A" ;
lin rococo_N = mkTerm "rococo_N" ;
lin rod_N = mkTerm "rod_N" ;
lin rod_PN = mkTerm "rod_PN" ;
lin rodent_N = mkTerm "rodent_N" ;
lin rodeo_N = mkTerm "rodeo_N" ;
lin rodney_PN = mkTerm "rodney_PN" ;
lin rodomontade_N = mkTerm "rodomontade_N" ;
lin roe_N = mkTerm "roe_N" ;
lin roebuck_N = mkTerm "roebuck_N" ;
lin roentgen_N = mkTerm "roentgen_N" ;
lin roentgenium_N = mkTerm "roentgenium_N" ;
lin roentgenogram_N = mkTerm "roentgenogram_N" ;
lin roentgenographic_A = mkTerm "roentgenographic_A" ;
lin roentgenography_N = mkTerm "roentgenography_N" ;
lin rofecoxib_N = mkTerm "rofecoxib_N" ;
lin rogation_N = mkTerm "rogation_N" ;
lin roger_PN = mkTerm "roger_PN" ;
lin rogue_N = mkTerm "rogue_N" ;
lin rogue_elephant_N = mkTerm "rogue_elephant_N" ;
lin roguery_N = mkTerm "roguery_N" ;
lin roguish_A = mkTerm "roguish_A" ;
lin roguishness_N = mkTerm "roguishness_N" ;
lin roil_V2 = mkTerm "roil_V2" ;
lin roisterer_N = mkTerm "roisterer_N" ;
lin role_N = mkTerm "role_N" ;
lin roleplaying_N = mkTerm "roleplaying_N" ;
lin roll_N = mkTerm "roll_N" ;
lin roll_V = mkTerm "roll_V" ;
lin roll_V2 = mkTerm "roll_V2" ;
lin roll_back_V = mkTerm "roll_back_V" ;
lin roll_back_V2 = mkTerm "roll_back_V2" ;
lin roll_by_V = mkTerm "roll_by_V" ;
lin roll_call_N = mkTerm "roll_call_N" ;
lin roll_down_V = mkTerm "roll_down_V" ;
lin roll_in_V = mkTerm "roll_in_V" ;
lin roll_on_N = mkTerm "roll_on_N" ;
lin roll_on_V = mkTerm "roll_on_V" ;
lin roll_on_V2 = mkTerm "roll_on_V2" ;
lin roll_out_V2 = mkTerm "roll_out_V2" ;
lin roll_over_V = mkTerm "roll_over_V" ;
lin roll_up_V = mkTerm "roll_up_V" ;
lin rollback_N = mkTerm "rollback_N" ;
lin roller_N = mkTerm "roller_N" ;
lin roller_skate_N = mkTerm "roller_skate_N" ;
lin rollerblader_N = mkTerm "rollerblader_N" ;
lin rollerblading_N = mkTerm "rollerblading_N" ;
lin rollicking_A = mkTerm "rollicking_A" ;
lin rolling_N = mkTerm "rolling_N" ;
lin rolling_mill_N = mkTerm "rolling_mill_N" ;
lin rolling_pin_N = mkTerm "rolling_pin_N" ;
lin rolling_stock_N = mkTerm "rolling_stock_N" ;
lin rollmops_N = mkTerm "rollmops_N" ;
lin rollover_N = mkTerm "rollover_N" ;
lin roly_poly_N = mkTerm "roly_poly_N" ;
lin romaic_A = mkTerm "romaic_A" ;
lin romaic_N = mkTerm "romaic_N" ;
lin roman_A = mkTerm "roman_A" ;
lin roman_N = mkTerm "roman_N" ;
lin romance_A = mkTerm "romance_A" ;
lin romance_N = mkTerm "romance_N" ;
lin romance_V = mkTerm "romance_V" ;
lin romance_V2 = mkTerm "romance_V2" ;
lin romanesque_N = mkTerm "romanesque_N" ;
lin romania_PN = mkTerm "romania_PN" ;
lin romanianFem_N = mkTerm "romanianFem_N" ;
lin romanianMasc_N = mkTerm "romanianMasc_N" ;
lin romanian_A = mkTerm "romanian_A" ;
lin romantic_A = mkTerm "romantic_A" ;
lin romantic_N = mkTerm "romantic_N" ;
lin romanticism_N = mkTerm "romanticism_N" ;
lin romanticist_N = mkTerm "romanticist_N" ;
lin romanticize_V = mkTerm "romanticize_V" ;
lin romanticize_V2 = mkTerm "romanticize_V2" ;
lin romany_A = mkTerm "romany_A" ;
lin romany_N = mkTerm "romany_N" ;
lin rome_PN = mkTerm "rome_PN" ;
lin romish_A = mkTerm "romish_A" ;
lin romp_N = mkTerm "romp_N" ;
lin romp_V = mkTerm "romp_V" ;
lin romp_in_V = mkTerm "romp_in_V" ;
lin romp_through_V2 = mkTerm "romp_through_V2" ;
lin romper_N = mkTerm "romper_N" ;
lin romsey_PN = mkTerm "romsey_PN" ;
lin ron_PN = mkTerm "ron_PN" ;
lin ronald_PN = mkTerm "ronald_PN" ;
lin rondeau_N = mkTerm "rondeau_N" ;
lin rondel_N = mkTerm "rondel_N" ;
lin rondelet_N = mkTerm "rondelet_N" ;
lin rondo_N = mkTerm "rondo_N" ;
lin roneo_N = mkTerm "roneo_N" ;
lin roneo_V2 = mkTerm "roneo_V2" ;
lin ronnie_PN = mkTerm "ronnie_PN" ;
lin rontgen_N = mkTerm "rontgen_N" ;
lin rood_N = mkTerm "rood_N" ;
lin rood_tree_N = mkTerm "rood_tree_N" ;
lin roof_N = mkTerm "roof_N" ;
lin roof_V2 = mkTerm "roof_V2" ;
lin roof_garden_N = mkTerm "roof_garden_N" ;
lin roof_tree_N = mkTerm "roof_tree_N" ;
lin roofer_N = mkTerm "roofer_N" ;
lin roofing_N = mkTerm "roofing_N" ;
lin roofless_A = mkTerm "roofless_A" ;
lin rooftop_N = mkTerm "rooftop_N" ;
lin rooibos_N = mkTerm "rooibos_N" ;
lin rook_N = mkTerm "rook_N" ;
lin rook_V2 = mkTerm "rook_V2" ;
lin rookery_N = mkTerm "rookery_N" ;
lin rookie_N = mkTerm "rookie_N" ;
lin room_1_N = mkTerm "room_1_N" ;
lin room_2_N = mkTerm "room_2_N" ;
lin room_V = mkTerm "room_V" ;
lin room_in_V2 = mkTerm "room_in_V2" ;
lin room_mate_N = mkTerm "room_mate_N" ;
lin roomer_N = mkTerm "roomer_N" ;
lin roomette_N = mkTerm "roomette_N" ;
lin roomful_N = mkTerm "roomful_N" ;
lin roomy_A = mkTerm "roomy_A" ;
lin roost_N = mkTerm "roost_N" ;
lin roost_V = mkTerm "roost_V" ;
lin rooster_N = mkTerm "rooster_N" ;
lin root_N = mkTerm "root_N" ;
lin root_V = mkTerm "root_V" ;
lin root_V2 = mkTerm "root_V2" ;
lin root_about_V = mkTerm "root_about_V" ;
lin root_around_V2 = mkTerm "root_around_V2" ;
lin root_for_V2 = mkTerm "root_for_V2" ;
lin root_out_V2 = mkTerm "root_out_V2" ;
lin root_up_V2 = mkTerm "root_up_V2" ;
lin rootage_N = mkTerm "rootage_N" ;
lin rootbound_A = mkTerm "rootbound_A" ;
lin rooting_N = mkTerm "rooting_N" ;
lin rootle_V = mkTerm "rootle_V" ;
lin rootless_A = mkTerm "rootless_A" ;
lin rootlet_N = mkTerm "rootlet_N" ;
lin roots_N = mkTerm "roots_N" ;
lin rootstock_N = mkTerm "rootstock_N" ;
lin rope_N = mkTerm "rope_N" ;
lin rope_V2 = mkTerm "rope_V2" ;
lin rope_dancer_N = mkTerm "rope_dancer_N" ;
lin rope_in_V2 = mkTerm "rope_in_V2" ;
lin rope_into_V2 = mkTerm "rope_into_V2" ;
lin rope_ladder_N = mkTerm "rope_ladder_N" ;
lin rope_off_V2 = mkTerm "rope_off_V2" ;
lin rope_yard_N = mkTerm "rope_yard_N" ;
lin rope_yarn_N = mkTerm "rope_yarn_N" ;
lin ropemaker_N = mkTerm "ropemaker_N" ;
lin roper_N = mkTerm "roper_N" ;
lin ropewalk_N = mkTerm "ropewalk_N" ;
lin ropewalker_N = mkTerm "ropewalker_N" ;
lin ropeway_N = mkTerm "ropeway_N" ;
lin ropey_A = mkTerm "ropey_A" ;
lin roping_N = mkTerm "roping_N" ;
lin ropy_A = mkTerm "ropy_A" ;
lin roquefort_N = mkTerm "roquefort_N" ;
lin roridula_N = mkTerm "roridula_N" ;
lin rorqual_N = mkTerm "rorqual_N" ;
lin rosaceous_A = mkTerm "rosaceous_A" ;
lin rosalie_PN = mkTerm "rosalie_PN" ;
lin rosalind_PN = mkTerm "rosalind_PN" ;
lin rosamund_PN = mkTerm "rosamund_PN" ;
lin rosario_PN = mkTerm "rosario_PN" ;
lin rosary_N = mkTerm "rosary_N" ;
lin roscommon_PN = mkTerm "roscommon_PN" ;
lin rose_A = mkTerm "rose_A" ;
lin rose_N = mkTerm "rose_N" ;
lin rose_PN = mkTerm "rose_PN" ;
lin rose_V = mkTerm "rose_V" ;
lin rose_V2 = mkTerm "rose_V2" ;
lin rose_bed_N = mkTerm "rose_bed_N" ;
lin rose_leaf_N = mkTerm "rose_leaf_N" ;
lin rose_red_A = mkTerm "rose_red_A" ;
lin rose_water_N = mkTerm "rose_water_N" ;
lin roseate_A = mkTerm "roseate_A" ;
lin rosebay_N = mkTerm "rosebay_N" ;
lin rosebud_N = mkTerm "rosebud_N" ;
lin rosefish_N = mkTerm "rosefish_N" ;
lin roselle_N = mkTerm "roselle_N" ;
lin rosemaling_N = mkTerm "rosemaling_N" ;
lin rosemary_N = mkTerm "rosemary_N" ;
lin rosemary_PN = mkTerm "rosemary_PN" ;
lin rosette_N = mkTerm "rosette_N" ;
lin rosewood_N = mkTerm "rosewood_N" ;
lin rosie_PN = mkTerm "rosie_PN" ;
lin rosilla_N = mkTerm "rosilla_N" ;
lin rosin_N = mkTerm "rosin_N" ;
lin rosin_V2 = mkTerm "rosin_V2" ;
lin rosinweed_N = mkTerm "rosinweed_N" ;
lin rosita_N = mkTerm "rosita_N" ;
lin roslyn_PN = mkTerm "roslyn_PN" ;
lin ross_on_wye_PN = mkTerm "ross_on_wye_PN" ;
lin rossington_PN = mkTerm "rossington_PN" ;
lin rosslare_PN = mkTerm "rosslare_PN" ;
lin roster_N = mkTerm "roster_N" ;
lin rostock_PN = mkTerm "rostock_PN" ;
lin rostov_na_donu_PN = mkTerm "rostov_na_donu_PN" ;
lin rostrate_A = mkTerm "rostrate_A" ;
lin rostrum_N = mkTerm "rostrum_N" ;
lin rosy_A = mkTerm "rosy_A" ;
lin rot_N = mkTerm "rot_N" ;
lin rot_V = mkTerm "rot_V" ;
lin rot_V2 = mkTerm "rot_V2" ;
lin rota_N = mkTerm "rota_N" ;
lin rotarian_N = mkTerm "rotarian_N" ;
lin rotary_A = mkTerm "rotary_A" ;
lin rotary_N = mkTerm "rotary_N" ;
lin rotatable_A = mkTerm "rotatable_A" ;
lin rotate_V = mkTerm "rotate_V" ;
lin rotate_V2 = mkTerm "rotate_V2" ;
lin rotation_N = mkTerm "rotation_N" ;
lin rotational_A = mkTerm "rotational_A" ;
lin rotatory_A = mkTerm "rotatory_A" ;
lin rotavirus_N = mkTerm "rotavirus_N" ;
lin rote_N = mkTerm "rote_N" ;
lin rotenone_N = mkTerm "rotenone_N" ;
lin rotgut_N = mkTerm "rotgut_N" ;
lin rotherham_PN = mkTerm "rotherham_PN" ;
lin rothesay_PN = mkTerm "rothesay_PN" ;
lin rothwell_PN = mkTerm "rothwell_PN" ;
lin rotifer_N = mkTerm "rotifer_N" ;
lin rotisserie_N = mkTerm "rotisserie_N" ;
lin rotl_N = mkTerm "rotl_N" ;
lin rotogravure_N = mkTerm "rotogravure_N" ;
lin rotor_N = mkTerm "rotor_N" ;
lin rotten_A = mkTerm "rotten_A" ;
lin rottenness_N = mkTerm "rottenness_N" ;
lin rottenstone_N = mkTerm "rottenstone_N" ;
lin rotter_N = mkTerm "rotter_N" ;
lin rotterdam_PN = mkTerm "rotterdam_PN" ;
lin rotund_A = mkTerm "rotund_A" ;
lin rotunda_N = mkTerm "rotunda_N" ;
lin rotundity_N = mkTerm "rotundity_N" ;
lin roubaix_PN = mkTerm "roubaix_PN" ;
lin rouble_N = mkTerm "rouble_N" ;
lin roue_N = mkTerm "roue_N" ;
lin rouen_PN = mkTerm "rouen_PN" ;
lin rouge_N = mkTerm "rouge_N" ;
lin rouge_V = mkTerm "rouge_V" ;
lin rouge_V2 = mkTerm "rouge_V2" ;
lin rough_A = mkTerm "rough_A" ;
lin rough_Adv = mkTerm "rough_Adv" ;
lin rough_N = mkTerm "rough_N" ;
lin rough_V2 = mkTerm "rough_V2" ;
lin rough_and_tumble_A = mkTerm "rough_and_tumble_A" ;
lin rough_and_tumble_N = mkTerm "rough_and_tumble_N" ;
lin rough_dry_V2 = mkTerm "rough_dry_V2" ;
lin rough_hewn_A = mkTerm "rough_hewn_A" ;
lin rough_house_V = mkTerm "rough_house_V" ;
lin rough_house_V2 = mkTerm "rough_house_V2" ;
lin rough_spoken_A = mkTerm "rough_spoken_A" ;
lin rough_up_V2 = mkTerm "rough_up_V2" ;
lin roughage_N = mkTerm "roughage_N" ;
lin roughcast_N = mkTerm "roughcast_N" ;
lin roughcast_V2 = mkTerm "roughcast_V2" ;
lin roughdried_A = mkTerm "roughdried_A" ;
lin roughen_V = mkTerm "roughen_V" ;
lin roughen_V2 = mkTerm "roughen_V2" ;
lin roughish_A = mkTerm "roughish_A" ;
lin roughly_AdV = mkTerm "roughly_AdV" ;
lin roughneck_N = mkTerm "roughneck_N" ;
lin roughness_N = mkTerm "roughness_N" ;
lin roughrider_N = mkTerm "roughrider_N" ;
lin roughshod_A = mkTerm "roughshod_A" ;
lin roulade_N = mkTerm "roulade_N" ;
lin rouleau_N = mkTerm "rouleau_N" ;
lin roulette_N = mkTerm "roulette_N" ;
lin round_A = mkTerm "round_A" ;
lin round_Adv = mkTerm "round_Adv" ;
lin round_N = mkTerm "round_N" ;
lin round_Prep = mkTerm "round_Prep" ;
lin round_V = mkTerm "round_V" ;
lin round_V2 = mkTerm "round_V2" ;
lin round_arm_A = mkTerm "round_arm_A" ;
lin round_arm_Adv = mkTerm "round_arm_Adv" ;
lin round_backed_A = mkTerm "round_backed_A" ;
lin round_eyed_A = mkTerm "round_eyed_A" ;
lin round_hand_N = mkTerm "round_hand_N" ;
lin round_off_V2 = mkTerm "round_off_V2" ;
lin round_out_V = mkTerm "round_out_V" ;
lin round_shot_N = mkTerm "round_shot_N" ;
lin round_shouldered_A = mkTerm "round_shouldered_A" ;
lin round_the_clock_A = mkTerm "round_the_clock_A" ;
lin round_the_clock_Adv = mkTerm "round_the_clock_Adv" ;
lin round_up_V = mkTerm "round_up_V" ;
lin roundabout_A = mkTerm "roundabout_A" ;
lin roundabout_N = mkTerm "roundabout_N" ;
lin rounded_A = mkTerm "rounded_A" ;
lin roundedness_N = mkTerm "roundedness_N" ;
lin roundel_N = mkTerm "roundel_N" ;
lin roundelay_N = mkTerm "roundelay_N" ;
lin rounder_N = mkTerm "rounder_N" ;
lin rounders_N = mkTerm "rounders_N" ;
lin roundhead_N = mkTerm "roundhead_N" ;
lin roundhouse_N = mkTerm "roundhouse_N" ;
lin rounding_N = mkTerm "rounding_N" ;
lin roundish_A = mkTerm "roundish_A" ;
lin roundness_N = mkTerm "roundness_N" ;
lin roundsman_N = mkTerm "roundsman_N" ;
lin roundup_N = mkTerm "roundup_N" ;
lin rouse_V = mkTerm "rouse_V" ;
lin rouse_V2 = mkTerm "rouse_V2" ;
lin rout_N = mkTerm "rout_N" ;
lin rout_V2 = mkTerm "rout_V2" ;
lin route_N = mkTerm "route_N" ;
lin route_V2 = mkTerm "route_V2" ;
lin routemarch_N = mkTerm "routemarch_N" ;
lin router_N = mkTerm "router_N" ;
lin routine_A = mkTerm "routine_A" ;
lin routine_N = mkTerm "routine_N" ;
lin roux_N = mkTerm "roux_N" ;
lin rovaniemi_PN = mkTerm "rovaniemi_PN" ;
lin rove_V = mkTerm "rove_V" ;
lin rove_V2 = mkTerm "rove_V2" ;
lin rover_N = mkTerm "rover_N" ;
lin row_N = mkTerm "row_N" ;
lin row_V = mkTerm "row_V" ;
lin row_V2 = mkTerm "row_V2" ;
lin row_back_V = mkTerm "row_back_V" ;
lin rowan_N = mkTerm "rowan_N" ;
lin rowan_berry_N = mkTerm "rowan_berry_N" ;
lin rowan_tree_N = mkTerm "rowan_tree_N" ;
lin rowboat_N = mkTerm "rowboat_N" ;
lin rowdiness_N = mkTerm "rowdiness_N" ;
lin rowdy_A = mkTerm "rowdy_A" ;
lin rowdy_N = mkTerm "rowdy_N" ;
lin rowdyism_N = mkTerm "rowdyism_N" ;
lin rowel_N = mkTerm "rowel_N" ;
lin rower_N = mkTerm "rower_N" ;
lin rowing_N = mkTerm "rowing_N" ;
lin rowing_boat_N = mkTerm "rowing_boat_N" ;
lin rowing_club_N = mkTerm "rowing_club_N" ;
lin rowlands_gill_PN = mkTerm "rowlands_gill_PN" ;
lin rowlock_N = mkTerm "rowlock_N" ;
lin rowspan_N = mkTerm "rowspan_N" ;
lin roy_PN = mkTerm "roy_PN" ;
lin royal_A = mkTerm "royal_A" ;
lin royal_N = mkTerm "royal_N" ;
lin royalism_N = mkTerm "royalism_N" ;
lin royalist_N = mkTerm "royalist_N" ;
lin royalty_N = mkTerm "royalty_N" ;
lin royston_PN = mkTerm "royston_PN" ;
lin rpm_N = mkTerm "rpm_N" ;
lin rspca_N = mkTerm "rspca_N" ;
lin rsvp_PN = mkTerm "rsvp_PN" ;
lin rt_hon_PN = mkTerm "rt_hon_PN" ;
lin rub_N = mkTerm "rub_N" ;
lin rub_V = mkTerm "rub_V" ;
lin rub_V2 = mkTerm "rub_V2" ;
lin rub_a_dub_N = mkTerm "rub_a_dub_N" ;
lin rub_along_V = mkTerm "rub_along_V" ;
lin rub_down_N = mkTerm "rub_down_N" ;
lin rub_down_V2 = mkTerm "rub_down_V2" ;
lin rub_in_V2 = mkTerm "rub_in_V2" ;
lin rub_it_in_V2 = mkTerm "rub_it_in_V2" ;
lin rub_off_on_V2 = mkTerm "rub_off_on_V2" ;
lin rub_out_V2 = mkTerm "rub_out_V2" ;
lin rub_up_N = mkTerm "rub_up_N" ;
lin rub_up_against_V2 = mkTerm "rub_up_against_V2" ;
lin rub_up_on_V2 = mkTerm "rub_up_on_V2" ;
lin rubato_N = mkTerm "rubato_N" ;
lin rubber_A = mkTerm "rubber_A" ;
lin rubber_N = mkTerm "rubber_N" ;
lin rubber_V2 = mkTerm "rubber_V2" ;
lin rubber_necking_V = mkTerm "rubber_necking_V" ;
lin rubber_stamp_V2 = mkTerm "rubber_stamp_V2" ;
lin rubberize_V2 = mkTerm "rubberize_V2" ;
lin rubberneck_N = mkTerm "rubberneck_N" ;
lin rubberneck_V = mkTerm "rubberneck_V" ;
lin rubbery_A = mkTerm "rubbery_A" ;
lin rubbing_N = mkTerm "rubbing_N" ;
lin rubbish_N = mkTerm "rubbish_N" ;
lin rubbish_V2 = mkTerm "rubbish_V2" ;
lin rubbishing_N = mkTerm "rubbishing_N" ;
lin rubbishy_A = mkTerm "rubbishy_A" ;
lin rubble_N = mkTerm "rubble_N" ;
lin rubefacient_N = mkTerm "rubefacient_N" ;
lin rubel_N = mkTerm "rubel_N" ;
lin rubicelle_N = mkTerm "rubicelle_N" ;
lin rubicon_N = mkTerm "rubicon_N" ;
lin rubicund_A = mkTerm "rubicund_A" ;
lin rubidium_N = mkTerm "rubidium_N" ;
lin ruble_N = mkTerm "ruble_N" ;
lin rubric_N = mkTerm "rubric_N" ;
lin ruby_A = mkTerm "ruby_A" ;
lin ruby_N = mkTerm "ruby_N" ;
lin ruck_N = mkTerm "ruck_N" ;
lin ruck_V = mkTerm "ruck_V" ;
lin ruck_V2 = mkTerm "ruck_V2" ;
lin rucksack_N = mkTerm "rucksack_N" ;
lin ruckus_N = mkTerm "ruckus_N" ;
lin rudapithecus_N = mkTerm "rudapithecus_N" ;
lin rudd_N = mkTerm "rudd_N" ;
lin rudder_N = mkTerm "rudder_N" ;
lin rudderfish_N = mkTerm "rudderfish_N" ;
lin rudderless_A = mkTerm "rudderless_A" ;
lin rudderpost_N = mkTerm "rudderpost_N" ;
lin ruddiness_N = mkTerm "ruddiness_N" ;
lin ruddington_PN = mkTerm "ruddington_PN" ;
lin ruddle_N = mkTerm "ruddle_N" ;
lin ruddle_V2 = mkTerm "ruddle_V2" ;
lin ruddy_A = mkTerm "ruddy_A" ;
lin rude_A = mkTerm "rude_A" ;
lin rudeness_N = mkTerm "rudeness_N" ;
lin rudiment_N = mkTerm "rudiment_N" ;
lin rudimentary_A = mkTerm "rudimentary_A" ;
lin rudolf_PN = mkTerm "rudolf_PN" ;
lin rudy_PN = mkTerm "rudy_PN" ;
lin rue_N = mkTerm "rue_N" ;
lin rue_V2 = mkTerm "rue_V2" ;
lin rueful_A = mkTerm "rueful_A" ;
lin ruff_N = mkTerm "ruff_N" ;
lin ruff_V = mkTerm "ruff_V" ;
lin ruff_V2 = mkTerm "ruff_V2" ;
lin ruffian_N = mkTerm "ruffian_N" ;
lin ruffianism_N = mkTerm "ruffianism_N" ;
lin ruffianly_A = mkTerm "ruffianly_A" ;
lin ruffle_N = mkTerm "ruffle_N" ;
lin ruffle_V = mkTerm "ruffle_V" ;
lin ruffle_V2 = mkTerm "ruffle_V2" ;
lin rug_N = mkTerm "rug_N" ;
lin ruga_N = mkTerm "ruga_N" ;
lin rugby_N = mkTerm "rugby_N" ;
lin rugby_PN = mkTerm "rugby_PN" ;
lin rugeley_PN = mkTerm "rugeley_PN" ;
lin rugged_A = mkTerm "rugged_A" ;
lin ruggedization_N = mkTerm "ruggedization_N" ;
lin ruggedness_N = mkTerm "ruggedness_N" ;
lin rugger_N = mkTerm "rugger_N" ;
lin rugose_A = mkTerm "rugose_A" ;
lin rugulah_N = mkTerm "rugulah_N" ;
lin ruin_N = mkTerm "ruin_N" ;
lin ruin_V2 = mkTerm "ruin_V2" ;
lin ruination_N = mkTerm "ruination_N" ;
lin ruinous_A = mkTerm "ruinous_A" ;
lin rule_N = mkTerm "rule_N" ;
lin rule_V = mkTerm "rule_V" ;
lin rule_V2 = mkTerm "rule_V2" ;
lin rule_VS = mkTerm "rule_VS" ;
lin rule_out_V2 = mkTerm "rule_out_V2" ;
lin ruler_N = mkTerm "ruler_N" ;
lin rulership_N = mkTerm "rulership_N" ;
lin ruling_A = mkTerm "ruling_A" ;
lin ruling_N = mkTerm "ruling_N" ;
lin ruly_A = mkTerm "ruly_A" ;
lin rum_N = mkTerm "rum_N" ;
lin rum_runner_N = mkTerm "rum_runner_N" ;
lin rumba_N = mkTerm "rumba_N" ;
lin rumble_N = mkTerm "rumble_N" ;
lin rumble_V = mkTerm "rumble_V" ;
lin rumble_V2 = mkTerm "rumble_V2" ;
lin rumbling_N = mkTerm "rumbling_N" ;
lin rumbustious_A = mkTerm "rumbustious_A" ;
lin rumen_N = mkTerm "rumen_N" ;
lin ruminant_A = mkTerm "ruminant_A" ;
lin ruminant_N = mkTerm "ruminant_N" ;
lin ruminate_V = mkTerm "ruminate_V" ;
lin rumination_N = mkTerm "rumination_N" ;
lin ruminative_A = mkTerm "ruminative_A" ;
lin rummage_N = mkTerm "rummage_N" ;
lin rummage_V = mkTerm "rummage_V" ;
lin rummage_V2 = mkTerm "rummage_V2" ;
lin rummer_N = mkTerm "rummer_N" ;
lin rummy_A = mkTerm "rummy_A" ;
lin rummy_N = mkTerm "rummy_N" ;
lin rumour_N = mkTerm "rumour_N" ;
lin rumour_V2 = mkTerm "rumour_V2" ;
lin rumour_V3 = mkTerm "rumour_V3" ;
lin rumour_monger_N = mkTerm "rumour_monger_N" ;
lin rump_N = mkTerm "rump_N" ;
lin rump_steak_N = mkTerm "rump_steak_N" ;
lin rumple_V2 = mkTerm "rumple_V2" ;
lin rumpus_N = mkTerm "rumpus_N" ;
lin run_N = mkTerm "run_N" ;
lin run_V = mkTerm "run_V" ;
lin run_V2 = mkTerm "run_V2" ;
lin run_across_V2 = mkTerm "run_across_V2" ;
lin run_after_V2 = mkTerm "run_after_V2" ;
lin run_against_V2 = mkTerm "run_against_V2" ;
lin run_along_V = mkTerm "run_along_V" ;
lin run_around_V = mkTerm "run_around_V" ;
lin run_away_V = mkTerm "run_away_V" ;
lin run_away_from_V2 = mkTerm "run_away_from_V2" ;
lin run_down_V = mkTerm "run_down_V" ;
lin run_down_V2 = mkTerm "run_down_V2" ;
lin run_for_V2 = mkTerm "run_for_V2" ;
lin run_in_V = mkTerm "run_in_V" ;
lin run_in_V2 = mkTerm "run_in_V2" ;
lin run_into_V2 = mkTerm "run_into_V2" ;
lin run_of_the_mill_A = mkTerm "run_of_the_mill_A" ;
lin run_off_N = mkTerm "run_off_N" ;
lin run_off_V = mkTerm "run_off_V" ;
lin run_off_V2 = mkTerm "run_off_V2" ;
lin run_on_V2 = mkTerm "run_on_V2" ;
lin run_out_V = mkTerm "run_out_V" ;
lin run_out_of_V2 = mkTerm "run_out_of_V2" ;
lin run_over_V = mkTerm "run_over_V" ;
lin run_over_V2 = mkTerm "run_over_V2" ;
lin run_through_N = mkTerm "run_through_N" ;
lin run_through_V2 = mkTerm "run_through_V2" ;
lin run_to_V2 = mkTerm "run_to_V2" ;
lin run_up_N = mkTerm "run_up_N" ;
lin run_up_V = mkTerm "run_up_V" ;
lin run_up_V2 = mkTerm "run_up_V2" ;
lin run_up_against_V2 = mkTerm "run_up_against_V2" ;
lin run_up_on_V2 = mkTerm "run_up_on_V2" ;
lin run_with_V2 = mkTerm "run_with_V2" ;
lin runaway_A = mkTerm "runaway_A" ;
lin runaway_N = mkTerm "runaway_N" ;
lin runcinate_A = mkTerm "runcinate_A" ;
lin runcorn_PN = mkTerm "runcorn_PN" ;
lin rundle_N = mkTerm "rundle_N" ;
lin rundown_A = mkTerm "rundown_A" ;
lin rundown_N = mkTerm "rundown_N" ;
lin rune_N = mkTerm "rune_N" ;
lin rung_N = mkTerm "rung_N" ;
lin rung_V2V = mkTerm "rung_V2V" ;
lin runic_A = mkTerm "runic_A" ;
lin runnel_N = mkTerm "runnel_N" ;
lin runner_N = mkTerm "runner_N" ;
lin runner_up_N = mkTerm "runner_up_N" ;
lin running_A = mkTerm "running_A" ;
lin running_N = mkTerm "running_N" ;
lin running_board_N = mkTerm "running_board_N" ;
lin runny_A = mkTerm "runny_A" ;
lin runproof_A = mkTerm "runproof_A" ;
lin runt_N = mkTerm "runt_N" ;
lin runtime_N = mkTerm "runtime_N" ;
lin runup_N = mkTerm "runup_N" ;
lin runway_N = mkTerm "runway_N" ;
lin ruokolahti_PN = mkTerm "ruokolahti_PN" ;
lin ruotsinpyhtää_PN = mkTerm "ruotsinpyhtää_PN" ;
lin ruovesi_PN = mkTerm "ruovesi_PN" ;
lin rupee_N = mkTerm "rupee_N" ;
lin rupert_PN = mkTerm "rupert_PN" ;
lin rupestral_A = mkTerm "rupestral_A" ;
lin rupiah_N = mkTerm "rupiah_N" ;
lin rupture_N = mkTerm "rupture_N" ;
lin rupture_V = mkTerm "rupture_V" ;
lin rupture_V2 = mkTerm "rupture_V2" ;
lin rupturewort_N = mkTerm "rupturewort_N" ;
lin rural_A = mkTerm "rural_A" ;
lin ruralism_N = mkTerm "ruralism_N" ;
lin ruralist_N = mkTerm "ruralist_N" ;
lin rurality_N = mkTerm "rurality_N" ;
lin ruritanian_A = mkTerm "ruritanian_A" ;
lin ruse_N = mkTerm "ruse_N" ;
lin rush_N = mkTerm "rush_N" ;
lin rush_V = mkTerm "rush_V" ;
lin rush_V2 = mkTerm "rush_V2" ;
lin rush_VV = mkTerm "rush_VV" ;
lin rush_away_V = mkTerm "rush_away_V" ;
lin rush_into_V2 = mkTerm "rush_into_V2" ;
lin rush_off_V = mkTerm "rush_off_V" ;
lin rush_out_V2 = mkTerm "rush_out_V2" ;
lin rusher_N = mkTerm "rusher_N" ;
lin rushlight_N = mkTerm "rushlight_N" ;
lin rushlike_A = mkTerm "rushlike_A" ;
lin rushy_A = mkTerm "rushy_A" ;
lin rusk_N = mkTerm "rusk_N" ;
lin rusko_PN = mkTerm "rusko_PN" ;
lin russet_A = mkTerm "russet_A" ;
lin russet_N = mkTerm "russet_N" ;
lin russia_PN = mkTerm "russia_PN" ;
lin russianFem_N = mkTerm "russianFem_N" ;
lin russianMasc_N = mkTerm "russianMasc_N" ;
lin russian_A = mkTerm "russian_A" ;
lin rust_A = mkTerm "rust_A" ;
lin rust_N = mkTerm "rust_N" ;
lin rust_V = mkTerm "rust_V" ;
lin rust_V2 = mkTerm "rust_V2" ;
lin rustic_A = mkTerm "rustic_A" ;
lin rustic_N = mkTerm "rustic_N" ;
lin rusticate_V = mkTerm "rusticate_V" ;
lin rusticate_V2 = mkTerm "rusticate_V2" ;
lin rustication_N = mkTerm "rustication_N" ;
lin rusticity_N = mkTerm "rusticity_N" ;
lin rustiness_N = mkTerm "rustiness_N" ;
lin rustle_N = mkTerm "rustle_N" ;
lin rustle_V = mkTerm "rustle_V" ;
lin rustle_V2 = mkTerm "rustle_V2" ;
lin rustle_up_V2 = mkTerm "rustle_up_V2" ;
lin rustler_N = mkTerm "rustler_N" ;
lin rustless_A = mkTerm "rustless_A" ;
lin rustling_N = mkTerm "rustling_N" ;
lin rustproof_A = mkTerm "rustproof_A" ;
lin rusty_A = mkTerm "rusty_A" ;
lin rut_N = mkTerm "rut_N" ;
lin rut_V2 = mkTerm "rut_V2" ;
lin rutabaga_N = mkTerm "rutabaga_N" ;
lin ruth_PN = mkTerm "ruth_PN" ;
lin ruthenium_N = mkTerm "ruthenium_N" ;
lin rutherford_N = mkTerm "rutherford_N" ;
lin rutherfordium_N = mkTerm "rutherfordium_N" ;
lin rutherglen_PN = mkTerm "rutherglen_PN" ;
lin ruthless_A = mkTerm "ruthless_A" ;
lin ruthlessness_N = mkTerm "ruthlessness_N" ;
lin rutile_N = mkTerm "rutile_N" ;
lin rutland_PN = mkTerm "rutland_PN" ;
lin ruukki_PN = mkTerm "ruukki_PN" ;
lin rwanda_PN = mkTerm "rwanda_PN" ;
lin rwandan_A = mkTerm "rwandan_A" ;
lin rwandan_N = mkTerm "rwandan_N" ;
lin rya_N = mkTerm "rya_N" ;
lin rydberg_N = mkTerm "rydberg_N" ;
lin ryde_PN = mkTerm "ryde_PN" ;
lin rye_N = mkTerm "rye_N" ;
lin rye_bread_N = mkTerm "rye_bread_N" ;
lin ryehill_PN = mkTerm "ryehill_PN" ;
lin rymättylä_PN = mkTerm "rymättylä_PN" ;
lin rääkkylä_PN = mkTerm "rääkkylä_PN" ;
lin saarbrucken_PN = mkTerm "saarbrucken_PN" ;
lin saari_PN = mkTerm "saari_PN" ;
lin saarijärvi_PN = mkTerm "saarijärvi_PN" ;
lin sabadeli_PN = mkTerm "sabadeli_PN" ;
lin sabah_PN = mkTerm "sabah_PN" ;
lin sabahan_A = mkTerm "sabahan_A" ;
lin sabahan_N = mkTerm "sabahan_N" ;
lin sabbat_N = mkTerm "sabbat_N" ;
lin sabbatarian_A = mkTerm "sabbatarian_A" ;
lin sabbatarian_N = mkTerm "sabbatarian_N" ;
lin sabbath_N = mkTerm "sabbath_N" ;
lin sabbatia_N = mkTerm "sabbatia_N" ;
lin sabbatical_A = mkTerm "sabbatical_A" ;
lin sabbatical_N = mkTerm "sabbatical_N" ;
lin saber_N = mkTerm "saber_N" ;
lin sabicu_N = mkTerm "sabicu_N" ;
lin sabin_N = mkTerm "sabin_N" ;
lin sable_A = mkTerm "sable_A" ;
lin sable_N = mkTerm "sable_N" ;
lin sabot_N = mkTerm "sabot_N" ;
lin sabotage_N = mkTerm "sabotage_N" ;
lin sabotage_V2 = mkTerm "sabotage_V2" ;
lin saboteurFem_N = mkTerm "saboteurFem_N" ;
lin saboteurMasc_N = mkTerm "saboteurMasc_N" ;
lin sabra_N = mkTerm "sabra_N" ;
lin sabre_N = mkTerm "sabre_N" ;
lin sabre_V2 = mkTerm "sabre_V2" ;
lin sabre_rattling_N = mkTerm "sabre_rattling_N" ;
lin sabre_toothed_A = mkTerm "sabre_toothed_A" ;
lin sac_N = mkTerm "sac_N" ;
lin saccade_N = mkTerm "saccade_N" ;
lin saccadic_A = mkTerm "saccadic_A" ;
lin saccharin_N = mkTerm "saccharin_N" ;
lin saccharine_A = mkTerm "saccharine_A" ;
lin saccharinity_N = mkTerm "saccharinity_N" ;
lin sacculated_A = mkTerm "sacculated_A" ;
lin saccule_N = mkTerm "saccule_N" ;
lin sacerdotal_A = mkTerm "sacerdotal_A" ;
lin sacerdotalism_N = mkTerm "sacerdotalism_N" ;
lin sachem_N = mkTerm "sachem_N" ;
lin sachet_N = mkTerm "sachet_N" ;
lin sack_N = mkTerm "sack_N" ;
lin sack_V2 = mkTerm "sack_V2" ;
lin sack_race_N = mkTerm "sack_race_N" ;
lin sackbut_N = mkTerm "sackbut_N" ;
lin sackcloth_N = mkTerm "sackcloth_N" ;
lin sacking_N = mkTerm "sacking_N" ;
lin sacral_A = mkTerm "sacral_A" ;
lin sacrament_N = mkTerm "sacrament_N" ;
lin sacramental_A = mkTerm "sacramental_A" ;
lin sacramento_PN = mkTerm "sacramento_PN" ;
lin sacred_A = mkTerm "sacred_A" ;
lin sacredness_N = mkTerm "sacredness_N" ;
lin sacrifice_N = mkTerm "sacrifice_N" ;
lin sacrifice_V = mkTerm "sacrifice_V" ;
lin sacrifice_V2 = mkTerm "sacrifice_V2" ;
lin sacrificeable_A = mkTerm "sacrificeable_A" ;
lin sacrificer_N = mkTerm "sacrificer_N" ;
lin sacrificial_A = mkTerm "sacrificial_A" ;
lin sacrilege_N = mkTerm "sacrilege_N" ;
lin sacrilegious_A = mkTerm "sacrilegious_A" ;
lin sacrilegiousness_N = mkTerm "sacrilegiousness_N" ;
lin sacristan_N = mkTerm "sacristan_N" ;
lin sacristy_N = mkTerm "sacristy_N" ;
lin sacrosanct_A = mkTerm "sacrosanct_A" ;
lin sacrum_N = mkTerm "sacrum_N" ;
lin sad_A = mkTerm "sad_A" ;
lin sadden_V = mkTerm "sadden_V" ;
lin sadden_V2 = mkTerm "sadden_V2" ;
lin saddle_N = mkTerm "saddle_N" ;
lin saddle_V = mkTerm "saddle_V" ;
lin saddle_V2 = mkTerm "saddle_V2" ;
lin saddle_sore_A = mkTerm "saddle_sore_A" ;
lin saddle_up_V2 = mkTerm "saddle_up_V2" ;
lin saddle_with_V3 = mkTerm "saddle_with_V3" ;
lin saddleback_N = mkTerm "saddleback_N" ;
lin saddlebag_N = mkTerm "saddlebag_N" ;
lin saddlebill_N = mkTerm "saddlebill_N" ;
lin saddler_N = mkTerm "saddler_N" ;
lin saddlery_N = mkTerm "saddlery_N" ;
lin sadhe_N = mkTerm "sadhe_N" ;
lin sadhu_N = mkTerm "sadhu_N" ;
lin sadism_N = mkTerm "sadism_N" ;
lin sadist_N = mkTerm "sadist_N" ;
lin sadistic_A = mkTerm "sadistic_A" ;
lin sadness_N = mkTerm "sadness_N" ;
lin sadomasochism_N = mkTerm "sadomasochism_N" ;
lin sadomasochistFem_N = mkTerm "sadomasochistFem_N" ;
lin sadomasochistMasc_N = mkTerm "sadomasochistMasc_N" ;
lin sadomasochistic_A = mkTerm "sadomasochistic_A" ;
lin sae_N = mkTerm "sae_N" ;
lin safari_N = mkTerm "safari_N" ;
lin safe_A = mkTerm "safe_A" ;
lin safe_N = mkTerm "safe_N" ;
lin safe_conduct_N = mkTerm "safe_conduct_N" ;
lin safe_deposit_A = mkTerm "safe_deposit_A" ;
lin safe_deposit_N = mkTerm "safe_deposit_N" ;
lin safebreaker_N = mkTerm "safebreaker_N" ;
lin safecracker_N = mkTerm "safecracker_N" ;
lin safeguard_N = mkTerm "safeguard_N" ;
lin safeguard_V2 = mkTerm "safeguard_V2" ;
lin safehold_N = mkTerm "safehold_N" ;
lin safekeeping_N = mkTerm "safekeeping_N" ;
lin safeness_N = mkTerm "safeness_N" ;
lin safety_N = mkTerm "safety_N" ;
lin safety_belt_N = mkTerm "safety_belt_N" ;
lin safety_bolt_N = mkTerm "safety_bolt_N" ;
lin safety_catch_N = mkTerm "safety_catch_N" ;
lin safety_curtain_N = mkTerm "safety_curtain_N" ;
lin safety_factor_N = mkTerm "safety_factor_N" ;
lin safety_lamp_N = mkTerm "safety_lamp_N" ;
lin safety_lock_N = mkTerm "safety_lock_N" ;
lin safety_match_N = mkTerm "safety_match_N" ;
lin safety_pin_N = mkTerm "safety_pin_N" ;
lin safety_razor_N = mkTerm "safety_razor_N" ;
lin safety_valve_N = mkTerm "safety_valve_N" ;
lin safflower_N = mkTerm "safflower_N" ;
lin saffron_N = mkTerm "saffron_N" ;
lin saffron_walden_PN = mkTerm "saffron_walden_PN" ;
lin safranine_N = mkTerm "safranine_N" ;
lin sag_N = mkTerm "sag_N" ;
lin sag_V = mkTerm "sag_V" ;
lin sag_off_V2 = mkTerm "sag_off_V2" ;
lin saga_N = mkTerm "saga_N" ;
lin sagacious_A = mkTerm "sagacious_A" ;
lin sagacity_N = mkTerm "sagacity_N" ;
lin sage_A = mkTerm "sage_A" ;
lin sage_N = mkTerm "sage_N" ;
lin sage_green_A = mkTerm "sage_green_A" ;
lin sage_green_N = mkTerm "sage_green_N" ;
lin sagebrush_N = mkTerm "sagebrush_N" ;
lin sagitta_N = mkTerm "sagitta_N" ;
lin sagittal_A = mkTerm "sagittal_A" ;
lin sagittarius_PN = mkTerm "sagittarius_PN" ;
lin sagittate_A = mkTerm "sagittate_A" ;
lin sago_N = mkTerm "sago_N" ;
lin saguaro_N = mkTerm "saguaro_N" ;
lin sahalahti_PN = mkTerm "sahalahti_PN" ;
lin sahib_N = mkTerm "sahib_N" ;
lin said_Quant = mkTerm "said_Quant" ;
lin saiga_N = mkTerm "saiga_N" ;
lin saigon_PN = mkTerm "saigon_PN" ;
lin sail_N = mkTerm "sail_N" ;
lin sail_V = mkTerm "sail_V" ;
lin sail_into_V2 = mkTerm "sail_into_V2" ;
lin sail_through_V2 = mkTerm "sail_through_V2" ;
lin sailboat_N = mkTerm "sailboat_N" ;
lin sailcloth_N = mkTerm "sailcloth_N" ;
lin sailfish_N = mkTerm "sailfish_N" ;
lin sailing_N = mkTerm "sailing_N" ;
lin sailing_boat_N = mkTerm "sailing_boat_N" ;
lin sailing_master_N = mkTerm "sailing_master_N" ;
lin sailing_ship_N = mkTerm "sailing_ship_N" ;
lin sailing_vessel_N = mkTerm "sailing_vessel_N" ;
lin sailmaker_N = mkTerm "sailmaker_N" ;
lin sailor_N = mkTerm "sailor_N" ;
lin sainfoin_N = mkTerm "sainfoin_N" ;
lin saint's_day_N = mkTerm "saint's_day_N" ;
lin saint_N = mkTerm "saint_N" ;
lin sainted_A = mkTerm "sainted_A" ;
lin sainthood_N = mkTerm "sainthood_N" ;
lin saintlike_A = mkTerm "saintlike_A" ;
lin saintliness_N = mkTerm "saintliness_N" ;
lin saintly_A = mkTerm "saintly_A" ;
lin sake_1_N = mkTerm "sake_1_N" ;
lin sake_2_N = mkTerm "sake_2_N" ;
lin saki_N = mkTerm "saki_N" ;
lin sal_volatile_N = mkTerm "sal_volatile_N" ;
lin salaam_N = mkTerm "salaam_N" ;
lin salaam_V = mkTerm "salaam_V" ;
lin salability_N = mkTerm "salability_N" ;
lin salable_A = mkTerm "salable_A" ;
lin salacious_A = mkTerm "salacious_A" ;
lin salaciousness_N = mkTerm "salaciousness_N" ;
lin salacity_N = mkTerm "salacity_N" ;
lin salad_N = mkTerm "salad_N" ;
lin salad_dressing_N = mkTerm "salad_dressing_N" ;
lin salad_oil_N = mkTerm "salad_oil_N" ;
lin salai_N = mkTerm "salai_N" ;
lin salal_N = mkTerm "salal_N" ;
lin salamanca_PN = mkTerm "salamanca_PN" ;
lin salamander_N = mkTerm "salamander_N" ;
lin salamandriform_A = mkTerm "salamandriform_A" ;
lin salami_N = mkTerm "salami_N" ;
lin salaried_A = mkTerm "salaried_A" ;
lin salary_N = mkTerm "salary_N" ;
lin salat_N = mkTerm "salat_N" ;
lin sale_N = mkTerm "sale_N" ;
lin sale_PN = mkTerm "sale_PN" ;
lin saleable_A = mkTerm "saleable_A" ;
lin salerno_PN = mkTerm "salerno_PN" ;
lin saleroom_N = mkTerm "saleroom_N" ;
lin salesclerk_N = mkTerm "salesclerk_N" ;
lin salesgirl_N = mkTerm "salesgirl_N" ;
lin salesman_N = mkTerm "salesman_N" ;
lin salesmanship_N = mkTerm "salesmanship_N" ;
lin salesperson_N = mkTerm "salesperson_N" ;
lin saleswoman_N = mkTerm "saleswoman_N" ;
lin salford_PN = mkTerm "salford_PN" ;
lin salicylate_N = mkTerm "salicylate_N" ;
lin salience_N = mkTerm "salience_N" ;
lin salient_A = mkTerm "salient_A" ;
lin salient_N = mkTerm "salient_N" ;
lin saliferous_A = mkTerm "saliferous_A" ;
lin saline_A = mkTerm "saline_A" ;
lin saline_N = mkTerm "saline_N" ;
lin salinity_N = mkTerm "salinity_N" ;
lin salinometer_N = mkTerm "salinometer_N" ;
lin salisbury_PN = mkTerm "salisbury_PN" ;
lin saliva_N = mkTerm "saliva_N" ;
lin salivary_A = mkTerm "salivary_A" ;
lin salivate_V = mkTerm "salivate_V" ;
lin salivation_N = mkTerm "salivation_N" ;
lin salla_PN = mkTerm "salla_PN" ;
lin sallet_N = mkTerm "sallet_N" ;
lin sallow_A = mkTerm "sallow_A" ;
lin sallow_N = mkTerm "sallow_N" ;
lin sallow_V = mkTerm "sallow_V" ;
lin sallow_V2 = mkTerm "sallow_V2" ;
lin sallowness_N = mkTerm "sallowness_N" ;
lin sally_N = mkTerm "sally_N" ;
lin sally_PN = mkTerm "sally_PN" ;
lin sally_V = mkTerm "sally_V" ;
lin sally_forth_V = mkTerm "sally_forth_V" ;
lin sally_out_V = mkTerm "sally_out_V" ;
lin salmagundi_N = mkTerm "salmagundi_N" ;
lin salmi_N = mkTerm "salmi_N" ;
lin salmon_N = mkTerm "salmon_N" ;
lin salmonberry_N = mkTerm "salmonberry_N" ;
lin salmonella_N = mkTerm "salmonella_N" ;
lin salmonellosis_N = mkTerm "salmonellosis_N" ;
lin salmonid_N = mkTerm "salmonid_N" ;
lin salo_PN = mkTerm "salo_PN" ;
lin salol_N = mkTerm "salol_N" ;
lin salon_N = mkTerm "salon_N" ;
lin saloon_N = mkTerm "saloon_N" ;
lin salp_N = mkTerm "salp_N" ;
lin salpiglossis_N = mkTerm "salpiglossis_N" ;
lin salpingectomy_N = mkTerm "salpingectomy_N" ;
lin salpingitis_N = mkTerm "salpingitis_N" ;
lin salpinx_N = mkTerm "salpinx_N" ;
lin salsa_N = mkTerm "salsa_N" ;
lin salsify_N = mkTerm "salsify_N" ;
lin salsilla_N = mkTerm "salsilla_N" ;
lin salt_A = mkTerm "salt_A" ;
lin salt_N = mkTerm "salt_N" ;
lin salt_PN = mkTerm "salt_PN" ;
lin salt_V2 = mkTerm "salt_V2" ;
lin salt_away_V2 = mkTerm "salt_away_V2" ;
lin salt_cellar_N = mkTerm "salt_cellar_N" ;
lin salt_lick_N = mkTerm "salt_lick_N" ;
lin saltash_PN = mkTerm "saltash_PN" ;
lin saltation_N = mkTerm "saltation_N" ;
lin saltbox_N = mkTerm "saltbox_N" ;
lin saltburn_PN = mkTerm "saltburn_PN" ;
lin saltbush_N = mkTerm "saltbush_N" ;
lin saltcoats_PN = mkTerm "saltcoats_PN" ;
lin salter_N = mkTerm "salter_N" ;
lin saltine_N = mkTerm "saltine_N" ;
lin saltiness_N = mkTerm "saltiness_N" ;
lin salting_N = mkTerm "salting_N" ;
lin saltish_A = mkTerm "saltish_A" ;
lin saltlike_A = mkTerm "saltlike_A" ;
lin saltpan_N = mkTerm "saltpan_N" ;
lin saltpetre_N = mkTerm "saltpetre_N" ;
lin saltshaker_N = mkTerm "saltshaker_N" ;
lin saltwater_N = mkTerm "saltwater_N" ;
lin saltworks_N = mkTerm "saltworks_N" ;
lin saltwort_N = mkTerm "saltwort_N" ;
lin salty_A = mkTerm "salty_A" ;
lin salubrious_A = mkTerm "salubrious_A" ;
lin salubrity_N = mkTerm "salubrity_N" ;
lin salutary_A = mkTerm "salutary_A" ;
lin salutation_N = mkTerm "salutation_N" ;
lin salutatorian_N = mkTerm "salutatorian_N" ;
lin salute_N = mkTerm "salute_N" ;
lin salute_V = mkTerm "salute_V" ;
lin salute_V2 = mkTerm "salute_V2" ;
lin salvador_PN = mkTerm "salvador_PN" ;
lin salvadorean_A = mkTerm "salvadorean_A" ;
lin salvadorean_N = mkTerm "salvadorean_N" ;
lin salvage_N = mkTerm "salvage_N" ;
lin salvage_V2 = mkTerm "salvage_V2" ;
lin salvageable_A = mkTerm "salvageable_A" ;
lin salvager_N = mkTerm "salvager_N" ;
lin salvation_N = mkTerm "salvation_N" ;
lin salve_N = mkTerm "salve_N" ;
lin salve_V2 = mkTerm "salve_V2" ;
lin salver_N = mkTerm "salver_N" ;
lin salverform_A = mkTerm "salverform_A" ;
lin salvia_N = mkTerm "salvia_N" ;
lin salvific_A = mkTerm "salvific_A" ;
lin salvinorin_N = mkTerm "salvinorin_N" ;
lin salvo_N = mkTerm "salvo_N" ;
lin salwar_N = mkTerm "salwar_N" ;
lin salzburg_PN = mkTerm "salzburg_PN" ;
lin sam_PN = mkTerm "sam_PN" ;
lin samantha_PN = mkTerm "samantha_PN" ;
lin samara_N = mkTerm "samara_N" ;
lin samaritan_N = mkTerm "samaritan_N" ;
lin samarium_N = mkTerm "samarium_N" ;
lin samarskite_N = mkTerm "samarskite_N" ;
lin samba_N = mkTerm "samba_N" ;
lin sambar_N = mkTerm "sambar_N" ;
lin sambuca_N = mkTerm "sambuca_N" ;
lin same_A = mkTerm "same_A" ;
lin same_Adv = mkTerm "same_Adv" ;
lin samekh_N = mkTerm "samekh_N" ;
lin sameness_N = mkTerm "sameness_N" ;
lin samisen_N = mkTerm "samisen_N" ;
lin samite_N = mkTerm "samite_N" ;
lin samizdat_N = mkTerm "samizdat_N" ;
lin sammatti_PN = mkTerm "sammatti_PN" ;
lin sammy_PN = mkTerm "sammy_PN" ;
lin samoa_PN = mkTerm "samoa_PN" ;
lin samoan_A = mkTerm "samoan_A" ;
lin samoan_N = mkTerm "samoan_N" ;
lin samosa_N = mkTerm "samosa_N" ;
lin samovar_N = mkTerm "samovar_N" ;
lin sampan_N = mkTerm "sampan_N" ;
lin sample_N = mkTerm "sample_N" ;
lin sample_V2 = mkTerm "sample_V2" ;
lin sampler_N = mkTerm "sampler_N" ;
lin sampling_N = mkTerm "sampling_N" ;
lin samsara_N = mkTerm "samsara_N" ;
lin samuel_PN = mkTerm "samuel_PN" ;
lin samurai_N = mkTerm "samurai_N" ;
lin san_antonio_PN = mkTerm "san_antonio_PN" ;
lin san_bernardino_PN = mkTerm "san_bernardino_PN" ;
lin san_diego_PN = mkTerm "san_diego_PN" ;
lin san_francisco_PN = mkTerm "san_francisco_PN" ;
lin san_jose_PN = mkTerm "san_jose_PN" ;
lin san_juan_PN = mkTerm "san_juan_PN" ;
lin san_marinese_A = mkTerm "san_marinese_A" ;
lin san_marinese_N = mkTerm "san_marinese_N" ;
lin san_marino_PN = mkTerm "san_marino_PN" ;
lin san_sebastian_PN = mkTerm "san_sebastian_PN" ;
lin sanatorium_N = mkTerm "sanatorium_N" ;
lin sanctification_N = mkTerm "sanctification_N" ;
lin sanctify_V2 = mkTerm "sanctify_V2" ;
lin sanctimonious_A = mkTerm "sanctimonious_A" ;
lin sanctimoniousness_N = mkTerm "sanctimoniousness_N" ;
lin sanction_N = mkTerm "sanction_N" ;
lin sanction_V2 = mkTerm "sanction_V2" ;
lin sanctionative_A = mkTerm "sanctionative_A" ;
lin sanctity_N = mkTerm "sanctity_N" ;
lin sanctuary_N = mkTerm "sanctuary_N" ;
lin sanctum_N = mkTerm "sanctum_N" ;
lin sand_N = mkTerm "sand_N" ;
lin sand_V2 = mkTerm "sand_V2" ;
lin sand_bar_N = mkTerm "sand_bar_N" ;
lin sandal_N = mkTerm "sandal_N" ;
lin sandaled_A = mkTerm "sandaled_A" ;
lin sandalled_A = mkTerm "sandalled_A" ;
lin sandalwood_N = mkTerm "sandalwood_N" ;
lin sandarac_N = mkTerm "sandarac_N" ;
lin sandbach_PN = mkTerm "sandbach_PN" ;
lin sandbag_N = mkTerm "sandbag_N" ;
lin sandbagger_N = mkTerm "sandbagger_N" ;
lin sandbank_N = mkTerm "sandbank_N" ;
lin sandblast_N = mkTerm "sandblast_N" ;
lin sandblast_V2 = mkTerm "sandblast_V2" ;
lin sandblaster_N = mkTerm "sandblaster_N" ;
lin sandbox_N = mkTerm "sandbox_N" ;
lin sandboy_N = mkTerm "sandboy_N" ;
lin sandbur_N = mkTerm "sandbur_N" ;
lin sanderling_N = mkTerm "sanderling_N" ;
lin sandfish_N = mkTerm "sandfish_N" ;
lin sandfly_N = mkTerm "sandfly_N" ;
lin sandglass_N = mkTerm "sandglass_N" ;
lin sandgrouse_N = mkTerm "sandgrouse_N" ;
lin sandhi_N = mkTerm "sandhi_N" ;
lin sandiness_N = mkTerm "sandiness_N" ;
lin sandlot_N = mkTerm "sandlot_N" ;
lin sandman_N = mkTerm "sandman_N" ;
lin sandown_PN = mkTerm "sandown_PN" ;
lin sandpaper_N = mkTerm "sandpaper_N" ;
lin sandpaper_V2 = mkTerm "sandpaper_V2" ;
lin sandpapery_A = mkTerm "sandpapery_A" ;
lin sandpiper_N = mkTerm "sandpiper_N" ;
lin sandpit_N = mkTerm "sandpit_N" ;
lin sandra_PN = mkTerm "sandra_PN" ;
lin sandstone_N = mkTerm "sandstone_N" ;
lin sandstorm_N = mkTerm "sandstorm_N" ;
lin sandwich_N = mkTerm "sandwich_N" ;
lin sandwich_V = mkTerm "sandwich_V" ;
lin sandwich_V2 = mkTerm "sandwich_V2" ;
lin sandwich_board_N = mkTerm "sandwich_board_N" ;
lin sandwichman_N = mkTerm "sandwichman_N" ;
lin sandwort_N = mkTerm "sandwort_N" ;
lin sandy_A = mkTerm "sandy_A" ;
lin sandy_PN = mkTerm "sandy_PN" ;
lin sane_A = mkTerm "sane_A" ;
lin sang_froid_N = mkTerm "sang_froid_N" ;
lin sangapenum_N = mkTerm "sangapenum_N" ;
lin sangaree_N = mkTerm "sangaree_N" ;
lin sango_N = mkTerm "sango_N" ;
lin sangoma_N = mkTerm "sangoma_N" ;
lin sanguinary_A = mkTerm "sanguinary_A" ;
lin sanguine_A = mkTerm "sanguine_A" ;
lin sanguine_N = mkTerm "sanguine_N" ;
lin sanguinity_N = mkTerm "sanguinity_N" ;
lin sanicle_N = mkTerm "sanicle_N" ;
lin sanitariness_N = mkTerm "sanitariness_N" ;
lin sanitary_A = mkTerm "sanitary_A" ;
lin sanitation_N = mkTerm "sanitation_N" ;
lin sanitize_V2 = mkTerm "sanitize_V2" ;
lin sanity_N = mkTerm "sanity_N" ;
lin sannup_N = mkTerm "sannup_N" ;
lin sannyasi_N = mkTerm "sannyasi_N" ;
lin sans_Prep = mkTerm "sans_Prep" ;
lin sansevieria_N = mkTerm "sansevieria_N" ;
lin sanskrit_N = mkTerm "sanskrit_N" ;
lin santa_claus_N = mkTerm "santa_claus_N" ;
lin santa_claus_PN = mkTerm "santa_claus_PN" ;
lin santander_PN = mkTerm "santander_PN" ;
lin santiago_PN = mkTerm "santiago_PN" ;
lin santims_N = mkTerm "santims_N" ;
lin santo_domingo_PN = mkTerm "santo_domingo_PN" ;
lin santos_PN = mkTerm "santos_PN" ;
lin sao_paolo_PN = mkTerm "sao_paolo_PN" ;
lin sap_N = mkTerm "sap_N" ;
lin sap_V = mkTerm "sap_V" ;
lin sap_V2 = mkTerm "sap_V2" ;
lin saphead_N = mkTerm "saphead_N" ;
lin sapidity_N = mkTerm "sapidity_N" ;
lin sapience_N = mkTerm "sapience_N" ;
lin sapiens_A = mkTerm "sapiens_A" ;
lin sapient_A = mkTerm "sapient_A" ;
lin sapiential_A = mkTerm "sapiential_A" ;
lin sapless_A = mkTerm "sapless_A" ;
lin sapling_N = mkTerm "sapling_N" ;
lin sapodilla_N = mkTerm "sapodilla_N" ;
lin saponaceous_A = mkTerm "saponaceous_A" ;
lin saponification_N = mkTerm "saponification_N" ;
lin saponified_A = mkTerm "saponified_A" ;
lin saponin_N = mkTerm "saponin_N" ;
lin sapote_N = mkTerm "sapote_N" ;
lin sapper_N = mkTerm "sapper_N" ;
lin sapphic_A = mkTerm "sapphic_A" ;
lin sapphire_A = mkTerm "sapphire_A" ;
lin sapphire_N = mkTerm "sapphire_N" ;
lin sapphirine_A = mkTerm "sapphirine_A" ;
lin sapphirine_N = mkTerm "sapphirine_N" ;
lin sapporo_PN = mkTerm "sapporo_PN" ;
lin sappy_A = mkTerm "sappy_A" ;
lin sapremia_N = mkTerm "sapremia_N" ;
lin saprobe_N = mkTerm "saprobe_N" ;
lin saprobic_A = mkTerm "saprobic_A" ;
lin saprolite_N = mkTerm "saprolite_N" ;
lin sapropel_N = mkTerm "sapropel_N" ;
lin saprophagous_A = mkTerm "saprophagous_A" ;
lin saprophyte_N = mkTerm "saprophyte_N" ;
lin saprophytic_A = mkTerm "saprophytic_A" ;
lin sapsago_N = mkTerm "sapsago_N" ;
lin sapsucker_N = mkTerm "sapsucker_N" ;
lin sapwood_N = mkTerm "sapwood_N" ;
lin saquinavir_N = mkTerm "saquinavir_N" ;
lin sara_PN = mkTerm "sara_PN" ;
lin saraband_N = mkTerm "saraband_N" ;
lin saracen_N = mkTerm "saracen_N" ;
lin sarah_PN = mkTerm "sarah_PN" ;
lin sarajevo_PN = mkTerm "sarajevo_PN" ;
lin saran_N = mkTerm "saran_N" ;
lin saratov_PN = mkTerm "saratov_PN" ;
lin sarawak_PN = mkTerm "sarawak_PN" ;
lin sarawakian_A = mkTerm "sarawakian_A" ;
lin sarawakian_N = mkTerm "sarawakian_N" ;
lin sarcasm_N = mkTerm "sarcasm_N" ;
lin sarcastic_A = mkTerm "sarcastic_A" ;
lin sarcenet_N = mkTerm "sarcenet_N" ;
lin sarcodinian_N = mkTerm "sarcodinian_N" ;
lin sarcoidosis_N = mkTerm "sarcoidosis_N" ;
lin sarcolemma_N = mkTerm "sarcolemma_N" ;
lin sarcolemmal_A = mkTerm "sarcolemmal_A" ;
lin sarcolemmic_A = mkTerm "sarcolemmic_A" ;
lin sarcoma_N = mkTerm "sarcoma_N" ;
lin sarcomere_N = mkTerm "sarcomere_N" ;
lin sarcophagus_N = mkTerm "sarcophagus_N" ;
lin sarcoplasm_N = mkTerm "sarcoplasm_N" ;
lin sarcosine_N = mkTerm "sarcosine_N" ;
lin sarcosomal_A = mkTerm "sarcosomal_A" ;
lin sarcosome_N = mkTerm "sarcosome_N" ;
lin sarcosporidian_N = mkTerm "sarcosporidian_N" ;
lin sard_N = mkTerm "sard_N" ;
lin sardine_N = mkTerm "sardine_N" ;
lin sardonic_A = mkTerm "sardonic_A" ;
lin sardonyx_N = mkTerm "sardonyx_N" ;
lin sari_N = mkTerm "sari_N" ;
lin sarin_N = mkTerm "sarin_N" ;
lin sarisbury_PN = mkTerm "sarisbury_PN" ;
lin sarong_N = mkTerm "sarong_N" ;
lin sarsaparilla_N = mkTerm "sarsaparilla_N" ;
lin sartorial_A = mkTerm "sartorial_A" ;
lin sartorius_N = mkTerm "sartorius_N" ;
lin sash_N = mkTerm "sash_N" ;
lin sash_cord_N = mkTerm "sash_cord_N" ;
lin sash_line_N = mkTerm "sash_line_N" ;
lin sashay_N = mkTerm "sashay_N" ;
lin sashimi_N = mkTerm "sashimi_N" ;
lin saskatchewan_PN = mkTerm "saskatchewan_PN" ;
lin saskatoon_N = mkTerm "saskatoon_N" ;
lin sass_N = mkTerm "sass_N" ;
lin sassaby_N = mkTerm "sassaby_N" ;
lin sassafras_N = mkTerm "sassafras_N" ;
lin sassari_PN = mkTerm "sassari_PN" ;
lin sassenach_N = mkTerm "sassenach_N" ;
lin sat_PN = mkTerm "sat_PN" ;
lin sat_down_V = mkTerm "sat_down_V" ;
lin sat_in_V = mkTerm "sat_in_V" ;
lin satan_N = mkTerm "satan_N" ;
lin satang_N = mkTerm "satang_N" ;
lin satanic_A = mkTerm "satanic_A" ;
lin satanophobia_N = mkTerm "satanophobia_N" ;
lin satchel_N = mkTerm "satchel_N" ;
lin sate_V2 = mkTerm "sate_V2" ;
lin sateen_N = mkTerm "sateen_N" ;
lin satellite_A = mkTerm "satellite_A" ;
lin satellite_N = mkTerm "satellite_N" ;
lin satiable_A = mkTerm "satiable_A" ;
lin satiate_A = mkTerm "satiate_A" ;
lin satiate_V2 = mkTerm "satiate_V2" ;
lin satiation_N = mkTerm "satiation_N" ;
lin satiety_N = mkTerm "satiety_N" ;
lin satin_A = mkTerm "satin_A" ;
lin satin_N = mkTerm "satin_N" ;
lin satinet_N = mkTerm "satinet_N" ;
lin satinleaf_N = mkTerm "satinleaf_N" ;
lin satinwood_N = mkTerm "satinwood_N" ;
lin satiny_A = mkTerm "satiny_A" ;
lin satire_N = mkTerm "satire_N" ;
lin satirical_A = mkTerm "satirical_A" ;
lin satirist_N = mkTerm "satirist_N" ;
lin satirize_V2 = mkTerm "satirize_V2" ;
lin satisfaction_N = mkTerm "satisfaction_N" ;
lin satisfactoriness_N = mkTerm "satisfactoriness_N" ;
lin satisfactory_A = mkTerm "satisfactory_A" ;
lin satisfied_A = mkTerm "satisfied_A" ;
lin satisfier_N = mkTerm "satisfier_N" ;
lin satisfy_V2 = mkTerm "satisfy_V2" ;
lin satori_N = mkTerm "satori_N" ;
lin satrap_N = mkTerm "satrap_N" ;
lin satsuma_N = mkTerm "satsuma_N" ;
lin saturate_V2 = mkTerm "saturate_V2" ;
lin saturation_N = mkTerm "saturation_N" ;
lin saturn_PN = mkTerm "saturn_PN" ;
lin saturnalia_N = mkTerm "saturnalia_N" ;
lin saturniid_N = mkTerm "saturniid_N" ;
lin saturnine_A = mkTerm "saturnine_A" ;
lin satyr_N = mkTerm "satyr_N" ;
lin satyriasis_N = mkTerm "satyriasis_N" ;
lin satyric_A = mkTerm "satyric_A" ;
lin sauce_N = mkTerm "sauce_N" ;
lin sauce_V2 = mkTerm "sauce_V2" ;
lin sauce_boat_N = mkTerm "sauce_boat_N" ;
lin saucepan_N = mkTerm "saucepan_N" ;
lin saucepot_N = mkTerm "saucepot_N" ;
lin saucer_N = mkTerm "saucer_N" ;
lin saucer_eyed_A = mkTerm "saucer_eyed_A" ;
lin sauchie_PN = mkTerm "sauchie_PN" ;
lin sauciness_N = mkTerm "sauciness_N" ;
lin saucy_A = mkTerm "saucy_A" ;
lin saudi_arabia_PN = mkTerm "saudi_arabia_PN" ;
lin saudi_arabian_A = mkTerm "saudi_arabian_A" ;
lin saudi_arabian_N = mkTerm "saudi_arabian_N" ;
lin sauerbraten_N = mkTerm "sauerbraten_N" ;
lin sauerkraut_N = mkTerm "sauerkraut_N" ;
lin saukkola_PN = mkTerm "saukkola_PN" ;
lin sauna_N = mkTerm "sauna_N" ;
lin saunter_N = mkTerm "saunter_N" ;
lin saunter_V = mkTerm "saunter_V" ;
lin saunterer_N = mkTerm "saunterer_N" ;
lin saurian_A = mkTerm "saurian_A" ;
lin saurian_N = mkTerm "saurian_N" ;
lin saurischian_N = mkTerm "saurischian_N" ;
lin sauropod_N = mkTerm "sauropod_N" ;
lin saury_N = mkTerm "saury_N" ;
lin sausage_N = mkTerm "sausage_N" ;
lin sausage_dog_N = mkTerm "sausage_dog_N" ;
lin sausage_meat_N = mkTerm "sausage_meat_N" ;
lin sausage_roll_N = mkTerm "sausage_roll_N" ;
lin saute_A = mkTerm "saute_A" ;
lin saute_N = mkTerm "saute_N" ;
lin saute_V2 = mkTerm "saute_V2" ;
lin sauvo_PN = mkTerm "sauvo_PN" ;
lin savage_A = mkTerm "savage_A" ;
lin savage_N = mkTerm "savage_N" ;
lin savage_V2 = mkTerm "savage_V2" ;
lin savageness_N = mkTerm "savageness_N" ;
lin savagery_N = mkTerm "savagery_N" ;
lin savanna_N = mkTerm "savanna_N" ;
lin savannah_N = mkTerm "savannah_N" ;
lin savant_N = mkTerm "savant_N" ;
lin savarin_N = mkTerm "savarin_N" ;
lin save_N = mkTerm "save_N" ;
lin save_V = mkTerm "save_V" ;
lin save_V2 = mkTerm "save_V2" ;
lin save_on_V2 = mkTerm "save_on_V2" ;
lin save_up_V2 = mkTerm "save_up_V2" ;
lin saveloy_N = mkTerm "saveloy_N" ;
lin saver_N = mkTerm "saver_N" ;
lin saving_N = mkTerm "saving_N" ;
lin savings_N = mkTerm "savings_N" ;
lin savings_bank_N = mkTerm "savings_bank_N" ;
lin savior_N = mkTerm "savior_N" ;
lin saviour_N = mkTerm "saviour_N" ;
lin savitaipale_PN = mkTerm "savitaipale_PN" ;
lin savoir_faire_N = mkTerm "savoir_faire_N" ;
lin savonlinna_PN = mkTerm "savonlinna_PN" ;
lin savonranta_PN = mkTerm "savonranta_PN" ;
lin savore_V2 = mkTerm "savore_V2" ;
lin savour_N = mkTerm "savour_N" ;
lin savour_V = mkTerm "savour_V" ;
lin savour_V2 = mkTerm "savour_V2" ;
lin savoury_A = mkTerm "savoury_A" ;
lin savoury_N = mkTerm "savoury_N" ;
lin savoy_N = mkTerm "savoy_N" ;
lin savukoski_PN = mkTerm "savukoski_PN" ;
lin savvy_N = mkTerm "savvy_N" ;
lin savvy_V = mkTerm "savvy_V" ;
lin saw_N = mkTerm "saw_N" ;
lin saw_V = mkTerm "saw_V" ;
lin saw_V2 = mkTerm "saw_V2" ;
lin saw_off_V2 = mkTerm "saw_off_V2" ;
lin saw_pit_N = mkTerm "saw_pit_N" ;
lin saw_up_V2 = mkTerm "saw_up_V2" ;
lin sawbridgeworth_PN = mkTerm "sawbridgeworth_PN" ;
lin sawdust_N = mkTerm "sawdust_N" ;
lin sawfish_N = mkTerm "sawfish_N" ;
lin sawfly_N = mkTerm "sawfly_N" ;
lin sawhorse_N = mkTerm "sawhorse_N" ;
lin sawm_N = mkTerm "sawm_N" ;
lin sawmill_N = mkTerm "sawmill_N" ;
lin sawtooth_N = mkTerm "sawtooth_N" ;
lin sawwort_N = mkTerm "sawwort_N" ;
lin sawyer_N = mkTerm "sawyer_N" ;
lin sax_N = mkTerm "sax_N" ;
lin saxhorn_N = mkTerm "saxhorn_N" ;
lin saxicolous_A = mkTerm "saxicolous_A" ;
lin saxifrage_N = mkTerm "saxifrage_N" ;
lin saxitoxin_N = mkTerm "saxitoxin_N" ;
lin saxon_A = mkTerm "saxon_A" ;
lin saxon_N = mkTerm "saxon_N" ;
lin saxophone_N = mkTerm "saxophone_N" ;
lin saxophonist_N = mkTerm "saxophonist_N" ;
lin say_N = mkTerm "say_N" ;
lin say_V = mkTerm "say_V" ;
lin say_V2 = mkTerm "say_V2" ;
lin say_VS = mkTerm "say_VS" ;
lin saying_N = mkTerm "saying_N" ;
lin scab_N = mkTerm "scab_N" ;
lin scabbard_N = mkTerm "scabbard_N" ;
lin scabby_A = mkTerm "scabby_A" ;
lin scabicide_N = mkTerm "scabicide_N" ;
lin scabies_N = mkTerm "scabies_N" ;
lin scabious_N = mkTerm "scabious_N" ;
lin scablands_N = mkTerm "scablands_N" ;
lin scabrous_A = mkTerm "scabrous_A" ;
lin scad_N = mkTerm "scad_N" ;
lin scaffold_N = mkTerm "scaffold_N" ;
lin scaffolding_N = mkTerm "scaffolding_N" ;
lin scalability_N = mkTerm "scalability_N" ;
lin scalable_A = mkTerm "scalable_A" ;
lin scalage_N = mkTerm "scalage_N" ;
lin scalar_A = mkTerm "scalar_A" ;
lin scalar_N = mkTerm "scalar_N" ;
lin scalawag_N = mkTerm "scalawag_N" ;
lin scald_N = mkTerm "scald_N" ;
lin scald_V2 = mkTerm "scald_V2" ;
lin scale_N = mkTerm "scale_N" ;
lin scale_V = mkTerm "scale_V" ;
lin scale_V2 = mkTerm "scale_V2" ;
lin scale_back_V2 = mkTerm "scale_back_V2" ;
lin scale_down_V2 = mkTerm "scale_down_V2" ;
lin scale_up_V2 = mkTerm "scale_up_V2" ;
lin scaleless_A = mkTerm "scaleless_A" ;
lin scalelike_A = mkTerm "scalelike_A" ;
lin scalene_A = mkTerm "scalene_A" ;
lin scalenus_N = mkTerm "scalenus_N" ;
lin scaler_N = mkTerm "scaler_N" ;
lin scalic_A = mkTerm "scalic_A" ;
lin scaliness_N = mkTerm "scaliness_N" ;
lin scaling_N = mkTerm "scaling_N" ;
lin scaling_ladder_N = mkTerm "scaling_ladder_N" ;
lin scallop_N = mkTerm "scallop_N" ;
lin scallop_V2 = mkTerm "scallop_V2" ;
lin scallop_shell_N = mkTerm "scallop_shell_N" ;
lin scallopine_N = mkTerm "scallopine_N" ;
lin scallywag_N = mkTerm "scallywag_N" ;
lin scalp_N = mkTerm "scalp_N" ;
lin scalp_V2 = mkTerm "scalp_V2" ;
lin scalpel_N = mkTerm "scalpel_N" ;
lin scalper_N = mkTerm "scalper_N" ;
lin scaly_A = mkTerm "scaly_A" ;
lin scam_N = mkTerm "scam_N" ;
lin scam_V2 = mkTerm "scam_V2" ;
lin scammony_N = mkTerm "scammony_N" ;
lin scamp_N = mkTerm "scamp_N" ;
lin scamp_V2 = mkTerm "scamp_V2" ;
lin scamper_N = mkTerm "scamper_N" ;
lin scamper_V = mkTerm "scamper_V" ;
lin scampi_N = mkTerm "scampi_N" ;
lin scan_N = mkTerm "scan_N" ;
lin scan_V = mkTerm "scan_V" ;
lin scan_V2 = mkTerm "scan_V2" ;
lin scandal_N = mkTerm "scandal_N" ;
lin scandalization_N = mkTerm "scandalization_N" ;
lin scandalize_V2 = mkTerm "scandalize_V2" ;
lin scandalmonger_N = mkTerm "scandalmonger_N" ;
lin scandalmongering_A = mkTerm "scandalmongering_A" ;
lin scandalmongering_N = mkTerm "scandalmongering_N" ;
lin scandalous_A = mkTerm "scandalous_A" ;
lin scandalousness_N = mkTerm "scandalousness_N" ;
lin scandent_A = mkTerm "scandent_A" ;
lin scandinavian_A = mkTerm "scandinavian_A" ;
lin scandinavian_N = mkTerm "scandinavian_N" ;
lin scandium_N = mkTerm "scandium_N" ;
lin scanner_N = mkTerm "scanner_N" ;
lin scanning_N = mkTerm "scanning_N" ;
lin scansion_N = mkTerm "scansion_N" ;
lin scant_A = mkTerm "scant_A" ;
lin scant_V2 = mkTerm "scant_V2" ;
lin scantiness_N = mkTerm "scantiness_N" ;
lin scantling_N = mkTerm "scantling_N" ;
lin scanty_A = mkTerm "scanty_A" ;
lin scape_N = mkTerm "scape_N" ;
lin scapegoat_N = mkTerm "scapegoat_N" ;
lin scapegrace_N = mkTerm "scapegrace_N" ;
lin scaphocephaly_N = mkTerm "scaphocephaly_N" ;
lin scaphopod_N = mkTerm "scaphopod_N" ;
lin scapose_A = mkTerm "scapose_A" ;
lin scapula_N = mkTerm "scapula_N" ;
lin scapular_A = mkTerm "scapular_A" ;
lin scapular_N = mkTerm "scapular_N" ;
lin scapulohumeral_A = mkTerm "scapulohumeral_A" ;
lin scar_N = mkTerm "scar_N" ;
lin scar_V = mkTerm "scar_V" ;
lin scar_V2 = mkTerm "scar_V2" ;
lin scarab_N = mkTerm "scarab_N" ;
lin scarborough_PN = mkTerm "scarborough_PN" ;
lin scarce_A = mkTerm "scarce_A" ;
lin scarcity_N = mkTerm "scarcity_N" ;
lin scare_N = mkTerm "scare_N" ;
lin scare_V = mkTerm "scare_V" ;
lin scare_V2 = mkTerm "scare_V2" ;
lin scare_away_V2 = mkTerm "scare_away_V2" ;
lin scare_off_V2 = mkTerm "scare_off_V2" ;
lin scarecrow_N = mkTerm "scarecrow_N" ;
lin scarecrowish_A = mkTerm "scarecrowish_A" ;
lin scared_A = mkTerm "scared_A" ;
lin scaremonger_N = mkTerm "scaremonger_N" ;
lin scarf_N = mkTerm "scarf_N" ;
lin scarf_pin_N = mkTerm "scarf_pin_N" ;
lin scarf_up_V = mkTerm "scarf_up_V" ;
lin scarify_V2 = mkTerm "scarify_V2" ;
lin scarlet_A = mkTerm "scarlet_A" ;
lin scarlet_N = mkTerm "scarlet_N" ;
lin scarp_N = mkTerm "scarp_N" ;
lin scarper_V = mkTerm "scarper_V" ;
lin scary_A = mkTerm "scary_A" ;
lin scat_N = mkTerm "scat_N" ;
lin scathing_A = mkTerm "scathing_A" ;
lin scatological_A = mkTerm "scatological_A" ;
lin scatology_N = mkTerm "scatology_N" ;
lin scatophagy_N = mkTerm "scatophagy_N" ;
lin scatter_N = mkTerm "scatter_N" ;
lin scatter_V = mkTerm "scatter_V" ;
lin scatter_V2 = mkTerm "scatter_V2" ;
lin scatterbrain_N = mkTerm "scatterbrain_N" ;
lin scatterbrained_A = mkTerm "scatterbrained_A" ;
lin scattered_A = mkTerm "scattered_A" ;
lin scattering_N = mkTerm "scattering_N" ;
lin scattershot_A = mkTerm "scattershot_A" ;
lin scatty_A = mkTerm "scatty_A" ;
lin scaup_N = mkTerm "scaup_N" ;
lin scauper_N = mkTerm "scauper_N" ;
lin scavenge_V = mkTerm "scavenge_V" ;
lin scavenger_N = mkTerm "scavenger_N" ;
lin scenario_N = mkTerm "scenario_N" ;
lin scenarist_N = mkTerm "scenarist_N" ;
lin scene_N = mkTerm "scene_N" ;
lin scene_painter_N = mkTerm "scene_painter_N" ;
lin scene_shifter_N = mkTerm "scene_shifter_N" ;
lin scenery_N = mkTerm "scenery_N" ;
lin scenic_A = mkTerm "scenic_A" ;
lin scent_N = mkTerm "scent_N" ;
lin scent_V2 = mkTerm "scent_V2" ;
lin scentless_A = mkTerm "scentless_A" ;
lin scepter_N = mkTerm "scepter_N" ;
lin sceptered_A = mkTerm "sceptered_A" ;
lin sceptic_N = mkTerm "sceptic_N" ;
lin sceptical_A = mkTerm "sceptical_A" ;
lin scepticism_N = mkTerm "scepticism_N" ;
lin sceptre_N = mkTerm "sceptre_N" ;
lin sceptred_A = mkTerm "sceptred_A" ;
lin schedule_N = mkTerm "schedule_N" ;
lin schedule_V = mkTerm "schedule_V" ;
lin schedule_V2 = mkTerm "schedule_V2" ;
lin schedule_V2V = mkTerm "schedule_V2V" ;
lin scheduler_N = mkTerm "scheduler_N" ;
lin scheduling_N = mkTerm "scheduling_N" ;
lin scheelite_N = mkTerm "scheelite_N" ;
lin schema_N = mkTerm "schema_N" ;
lin schematic_A = mkTerm "schematic_A" ;
lin schematic_N = mkTerm "schematic_N" ;
lin schematization_N = mkTerm "schematization_N" ;
lin scheme_N = mkTerm "scheme_N" ;
lin scheme_V = mkTerm "scheme_V" ;
lin scheme_V2 = mkTerm "scheme_V2" ;
lin schemer_N = mkTerm "schemer_N" ;
lin schemozzle_N = mkTerm "schemozzle_N" ;
lin scherzo_N = mkTerm "scherzo_N" ;
lin schilling_N = mkTerm "schilling_N" ;
lin schipperke_N = mkTerm "schipperke_N" ;
lin schism_N = mkTerm "schism_N" ;
lin schismatic_A = mkTerm "schismatic_A" ;
lin schist_N = mkTerm "schist_N" ;
lin schistosome_N = mkTerm "schistosome_N" ;
lin schistosomiasis_N = mkTerm "schistosomiasis_N" ;
lin schizocarp_N = mkTerm "schizocarp_N" ;
lin schizogony_N = mkTerm "schizogony_N" ;
lin schizoid_A = mkTerm "schizoid_A" ;
lin schizopetalon_N = mkTerm "schizopetalon_N" ;
lin schizophrenia_N = mkTerm "schizophrenia_N" ;
lin schizophrenic_A = mkTerm "schizophrenic_A" ;
lin schizophrenic_N = mkTerm "schizophrenic_N" ;
lin schizothymia_N = mkTerm "schizothymia_N" ;
lin schlemiel_N = mkTerm "schlemiel_N" ;
lin schlep_N = mkTerm "schlep_N" ;
lin schlepper_N = mkTerm "schlepper_N" ;
lin schlimazel_N = mkTerm "schlimazel_N" ;
lin schlock_N = mkTerm "schlock_N" ;
lin schlockmeister_N = mkTerm "schlockmeister_N" ;
lin schmaltz_N = mkTerm "schmaltz_N" ;
lin schmaltzy_A = mkTerm "schmaltzy_A" ;
lin schmalzy_A = mkTerm "schmalzy_A" ;
lin schmeer_N = mkTerm "schmeer_N" ;
lin schmuck_N = mkTerm "schmuck_N" ;
lin schnapps_N = mkTerm "schnapps_N" ;
lin schnauzer_N = mkTerm "schnauzer_N" ;
lin schnitzel_N = mkTerm "schnitzel_N" ;
lin schnook_N = mkTerm "schnook_N" ;
lin schnorkel_N = mkTerm "schnorkel_N" ;
lin schnorrer_N = mkTerm "schnorrer_N" ;
lin scholar_N = mkTerm "scholar_N" ;
lin scholarly_A = mkTerm "scholarly_A" ;
lin scholarship_N = mkTerm "scholarship_N" ;
lin scholastic_A = mkTerm "scholastic_A" ;
lin scholasticism_N = mkTerm "scholasticism_N" ;
lin scholiast_N = mkTerm "scholiast_N" ;
lin scholium_N = mkTerm "scholium_N" ;
lin school_1_N = mkTerm "school_1_N" ;
lin school_2_N = mkTerm "school_2_N" ;
lin school_V2 = mkTerm "school_V2" ;
lin school_board_N = mkTerm "school_board_N" ;
lin schoolbag_N = mkTerm "schoolbag_N" ;
lin schoolbook_N = mkTerm "schoolbook_N" ;
lin schoolboy_N = mkTerm "schoolboy_N" ;
lin schoolchild_N = mkTerm "schoolchild_N" ;
lin schooldays_N = mkTerm "schooldays_N" ;
lin schoolfellow_N = mkTerm "schoolfellow_N" ;
lin schoolfriend_N = mkTerm "schoolfriend_N" ;
lin schoolgirl_N = mkTerm "schoolgirl_N" ;
lin schoolhouse_N = mkTerm "schoolhouse_N" ;
lin schooling_N = mkTerm "schooling_N" ;
lin schoolman_N = mkTerm "schoolman_N" ;
lin schoolmarm_N = mkTerm "schoolmarm_N" ;
lin schoolmaster_N = mkTerm "schoolmaster_N" ;
lin schoolmate_N = mkTerm "schoolmate_N" ;
lin schoolmistress_N = mkTerm "schoolmistress_N" ;
lin schoolroom_N = mkTerm "schoolroom_N" ;
lin schoolteacher_N = mkTerm "schoolteacher_N" ;
lin schooltime_N = mkTerm "schooltime_N" ;
lin schoolwide_A = mkTerm "schoolwide_A" ;
lin schoolyard_N = mkTerm "schoolyard_N" ;
lin schooner_N = mkTerm "schooner_N" ;
lin schorl_N = mkTerm "schorl_N" ;
lin schottische_N = mkTerm "schottische_N" ;
lin schrod_N = mkTerm "schrod_N" ;
lin schwa_N = mkTerm "schwa_N" ;
lin schwerin_PN = mkTerm "schwerin_PN" ;
lin sci_fi_N = mkTerm "sci_fi_N" ;
lin sciatic_A = mkTerm "sciatic_A" ;
lin sciatica_N = mkTerm "sciatica_N" ;
lin science_N = mkTerm "science_N" ;
lin scienter_Adv = mkTerm "scienter_Adv" ;
lin scientific_A = mkTerm "scientific_A" ;
lin scientist_N = mkTerm "scientist_N" ;
lin scilla_N = mkTerm "scilla_N" ;
lin scimitar_N = mkTerm "scimitar_N" ;
lin scintilla_N = mkTerm "scintilla_N" ;
lin scintillate_V = mkTerm "scintillate_V" ;
lin scintillation_N = mkTerm "scintillation_N" ;
lin sciolism_N = mkTerm "sciolism_N" ;
lin scion_N = mkTerm "scion_N" ;
lin scission_N = mkTerm "scission_N" ;
lin scissors_N = mkTerm "scissors_N" ;
lin scissortail_N = mkTerm "scissortail_N" ;
lin sclaff_N = mkTerm "sclaff_N" ;
lin sclera_N = mkTerm "sclera_N" ;
lin scleredema_N = mkTerm "scleredema_N" ;
lin sclerite_N = mkTerm "sclerite_N" ;
lin scleritis_N = mkTerm "scleritis_N" ;
lin scleroderma_N = mkTerm "scleroderma_N" ;
lin sclerometer_N = mkTerm "sclerometer_N" ;
lin scleroprotein_N = mkTerm "scleroprotein_N" ;
lin sclerosis_N = mkTerm "sclerosis_N" ;
lin sclerotic_A = mkTerm "sclerotic_A" ;
lin sclerotinia_N = mkTerm "sclerotinia_N" ;
lin sclerotium_N = mkTerm "sclerotium_N" ;
lin sclerotomy_N = mkTerm "sclerotomy_N" ;
lin scoff_N = mkTerm "scoff_N" ;
lin scoff_V = mkTerm "scoff_V" ;
lin scoff_V2 = mkTerm "scoff_V2" ;
lin scoffer_N = mkTerm "scoffer_N" ;
lin scoffingly_Adv = mkTerm "scoffingly_Adv" ;
lin scofflaw_N = mkTerm "scofflaw_N" ;
lin scold_N = mkTerm "scold_N" ;
lin scold_V = mkTerm "scold_V" ;
lin scold_V2 = mkTerm "scold_V2" ;
lin scolding_N = mkTerm "scolding_N" ;
lin scolion_N = mkTerm "scolion_N" ;
lin scoliosis_N = mkTerm "scoliosis_N" ;
lin scollop_V2 = mkTerm "scollop_V2" ;
lin scolopendrium_N = mkTerm "scolopendrium_N" ;
lin scombroid_N = mkTerm "scombroid_N" ;
lin sconce_N = mkTerm "sconce_N" ;
lin scone_N = mkTerm "scone_N" ;
lin scoop_N = mkTerm "scoop_N" ;
lin scoop_V = mkTerm "scoop_V" ;
lin scoop_V2 = mkTerm "scoop_V2" ;
lin scoop_up_V = mkTerm "scoop_up_V" ;
lin scoopful_N = mkTerm "scoopful_N" ;
lin scoot_V = mkTerm "scoot_V" ;
lin scoot_V2 = mkTerm "scoot_V2" ;
lin scooter_N = mkTerm "scooter_N" ;
lin scopal_A = mkTerm "scopal_A" ;
lin scope_N = mkTerm "scope_N" ;
lin scopolamine_N = mkTerm "scopolamine_N" ;
lin scorbutic_A = mkTerm "scorbutic_A" ;
lin scorch_N = mkTerm "scorch_N" ;
lin scorch_V = mkTerm "scorch_V" ;
lin scorch_V2 = mkTerm "scorch_V2" ;
lin scorcher_N = mkTerm "scorcher_N" ;
lin scorching_Adv = mkTerm "scorching_Adv" ;
lin score_N = mkTerm "score_N" ;
lin score_V = mkTerm "score_V" ;
lin score_V2 = mkTerm "score_V2" ;
lin scoreboard_N = mkTerm "scoreboard_N" ;
lin scorebook_N = mkTerm "scorebook_N" ;
lin scorecard_N = mkTerm "scorecard_N" ;
lin scorekeeper_N = mkTerm "scorekeeper_N" ;
lin scoreless_A = mkTerm "scoreless_A" ;
lin scorer_N = mkTerm "scorer_N" ;
lin scorn_N = mkTerm "scorn_N" ;
lin scorn_V2 = mkTerm "scorn_V2" ;
lin scornful_A = mkTerm "scornful_A" ;
lin scorpaenid_N = mkTerm "scorpaenid_N" ;
lin scorpaenoid_N = mkTerm "scorpaenoid_N" ;
lin scorpio_PN = mkTerm "scorpio_PN" ;
lin scorpion_N = mkTerm "scorpion_N" ;
lin scorpionfish_N = mkTerm "scorpionfish_N" ;
lin scorpionweed_N = mkTerm "scorpionweed_N" ;
lin scorzonera_N = mkTerm "scorzonera_N" ;
lin scot_N = mkTerm "scot_N" ;
lin scot_free_Adv = mkTerm "scot_free_Adv" ;
lin scotch_A = mkTerm "scotch_A" ;
lin scotch_N = mkTerm "scotch_N" ;
lin scotch_V2 = mkTerm "scotch_V2" ;
lin scotchman_N = mkTerm "scotchman_N" ;
lin scotchwoman_N = mkTerm "scotchwoman_N" ;
lin scoter_N = mkTerm "scoter_N" ;
lin scotland_PN = mkTerm "scotland_PN" ;
lin scotland_yard_PN = mkTerm "scotland_yard_PN" ;
lin scotoma_N = mkTerm "scotoma_N" ;
lin scotomatous_A = mkTerm "scotomatous_A" ;
lin scots_A = mkTerm "scots_A" ;
lin scotsman_N = mkTerm "scotsman_N" ;
lin scotswoman_N = mkTerm "scotswoman_N" ;
lin scottish_A = mkTerm "scottish_A" ;
lin scoundrel_N = mkTerm "scoundrel_N" ;
lin scoundrelly_A = mkTerm "scoundrelly_A" ;
lin scour_N = mkTerm "scour_N" ;
lin scour_V = mkTerm "scour_V" ;
lin scour_V2 = mkTerm "scour_V2" ;
lin scourer_N = mkTerm "scourer_N" ;
lin scourge_N = mkTerm "scourge_N" ;
lin scourge_V2 = mkTerm "scourge_V2" ;
lin scouring_N = mkTerm "scouring_N" ;
lin scours_N = mkTerm "scours_N" ;
lin scout_N = mkTerm "scout_N" ;
lin scout_V = mkTerm "scout_V" ;
lin scout_V2 = mkTerm "scout_V2" ;
lin scout_about_V = mkTerm "scout_about_V" ;
lin scout_around_V = mkTerm "scout_around_V" ;
lin scout_out_V2 = mkTerm "scout_out_V2" ;
lin scout_round_V = mkTerm "scout_round_V" ;
lin scout_up_V2 = mkTerm "scout_up_V2" ;
lin scouting_N = mkTerm "scouting_N" ;
lin scoutmaster_N = mkTerm "scoutmaster_N" ;
lin scow_N = mkTerm "scow_N" ;
lin scowl_N = mkTerm "scowl_N" ;
lin scowl_V = mkTerm "scowl_V" ;
lin scrabble_N = mkTerm "scrabble_N" ;
lin scrabble_V = mkTerm "scrabble_V" ;
lin scrabbly_A = mkTerm "scrabbly_A" ;
lin scrag_N = mkTerm "scrag_N" ;
lin scrag_V2 = mkTerm "scrag_V2" ;
lin scrag_end_N = mkTerm "scrag_end_N" ;
lin scraggly_A = mkTerm "scraggly_A" ;
lin scraggy_A = mkTerm "scraggy_A" ;
lin scram_V = mkTerm "scram_V" ;
lin scramble_N = mkTerm "scramble_N" ;
lin scramble_V = mkTerm "scramble_V" ;
lin scramble_V2 = mkTerm "scramble_V2" ;
lin scrambler_N = mkTerm "scrambler_N" ;
lin scrap_N = mkTerm "scrap_N" ;
lin scrap_V = mkTerm "scrap_V" ;
lin scrap_V2 = mkTerm "scrap_V2" ;
lin scrap_iron_N = mkTerm "scrap_iron_N" ;
lin scrapbook_N = mkTerm "scrapbook_N" ;
lin scrape_N = mkTerm "scrape_N" ;
lin scrape_V = mkTerm "scrape_V" ;
lin scrape_V2 = mkTerm "scrape_V2" ;
lin scrape_along_V = mkTerm "scrape_along_V" ;
lin scrape_by_V = mkTerm "scrape_by_V" ;
lin scrape_in_V = mkTerm "scrape_in_V" ;
lin scrape_into_V2 = mkTerm "scrape_into_V2" ;
lin scrape_through_V2 = mkTerm "scrape_through_V2" ;
lin scrape_together_V2 = mkTerm "scrape_together_V2" ;
lin scrape_up_V2 = mkTerm "scrape_up_V2" ;
lin scraper_N = mkTerm "scraper_N" ;
lin scrapheap_N = mkTerm "scrapheap_N" ;
lin scrapie_N = mkTerm "scrapie_N" ;
lin scraping_N = mkTerm "scraping_N" ;
lin scrappiness_N = mkTerm "scrappiness_N" ;
lin scrapple_N = mkTerm "scrapple_N" ;
lin scrappy_A = mkTerm "scrappy_A" ;
lin scratch_N = mkTerm "scratch_N" ;
lin scratch_V = mkTerm "scratch_V" ;
lin scratch_V2 = mkTerm "scratch_V2" ;
lin scratch_out_V = mkTerm "scratch_out_V" ;
lin scratch_pad_N = mkTerm "scratch_pad_N" ;
lin scratch_race_N = mkTerm "scratch_race_N" ;
lin scratcher_N = mkTerm "scratcher_N" ;
lin scratchy_A = mkTerm "scratchy_A" ;
lin scrawl_N = mkTerm "scrawl_N" ;
lin scrawl_V = mkTerm "scrawl_V" ;
lin scrawl_V2 = mkTerm "scrawl_V2" ;
lin scrawler_N = mkTerm "scrawler_N" ;
lin scrawniness_N = mkTerm "scrawniness_N" ;
lin scrawny_A = mkTerm "scrawny_A" ;
lin screaky_A = mkTerm "screaky_A" ;
lin scream_N = mkTerm "scream_N" ;
lin scream_V = mkTerm "scream_V" ;
lin scream_V2 = mkTerm "scream_V2" ;
lin scream_VS = mkTerm "scream_VS" ;
lin screamer_N = mkTerm "screamer_N" ;
lin screamingly_Adv = mkTerm "screamingly_Adv" ;
lin scree_N = mkTerm "scree_N" ;
lin screech_N = mkTerm "screech_N" ;
lin screech_V = mkTerm "screech_V" ;
lin screech_V2 = mkTerm "screech_V2" ;
lin screech_owl_N = mkTerm "screech_owl_N" ;
lin screed_N = mkTerm "screed_N" ;
lin screen_N = mkTerm "screen_N" ;
lin screen_V = mkTerm "screen_V" ;
lin screen_V2 = mkTerm "screen_V2" ;
lin screen_off_V2 = mkTerm "screen_off_V2" ;
lin screen_out_V2 = mkTerm "screen_out_V2" ;
lin screener_N = mkTerm "screener_N" ;
lin screening_N = mkTerm "screening_N" ;
lin screenplay_N = mkTerm "screenplay_N" ;
lin screenwriter_N = mkTerm "screenwriter_N" ;
lin screw_N = mkTerm "screw_N" ;
lin screw_V = mkTerm "screw_V" ;
lin screw_V2 = mkTerm "screw_V2" ;
lin screw_around_V = mkTerm "screw_around_V" ;
lin screw_over_V2 = mkTerm "screw_over_V2" ;
lin screw_topped_A = mkTerm "screw_topped_A" ;
lin screw_up_V2 = mkTerm "screw_up_V2" ;
lin screwball_A = mkTerm "screwball_A" ;
lin screwball_N = mkTerm "screwball_N" ;
lin screwballer_N = mkTerm "screwballer_N" ;
lin screwdriver_N = mkTerm "screwdriver_N" ;
lin screwtop_N = mkTerm "screwtop_N" ;
lin screwup_N = mkTerm "screwup_N" ;
lin screwy_A = mkTerm "screwy_A" ;
lin scribble_N = mkTerm "scribble_N" ;
lin scribble_V = mkTerm "scribble_V" ;
lin scribble_V2 = mkTerm "scribble_V2" ;
lin scribbler_N = mkTerm "scribbler_N" ;
lin scribbling_block_N = mkTerm "scribbling_block_N" ;
lin scribe_N = mkTerm "scribe_N" ;
lin scriber_N = mkTerm "scriber_N" ;
lin scrim_N = mkTerm "scrim_N" ;
lin scrimmage_N = mkTerm "scrimmage_N" ;
lin scrimmage_V = mkTerm "scrimmage_V" ;
lin scrimmage_V2 = mkTerm "scrimmage_V2" ;
lin scrimp_V = mkTerm "scrimp_V" ;
lin scrimp_V2 = mkTerm "scrimp_V2" ;
lin scrimshank_V = mkTerm "scrimshank_V" ;
lin scrimshanker_N = mkTerm "scrimshanker_N" ;
lin scrimshaw_N = mkTerm "scrimshaw_N" ;
lin scrimy_A = mkTerm "scrimy_A" ;
lin scrip_N = mkTerm "scrip_N" ;
lin script_1_N = mkTerm "script_1_N" ;
lin script_2_N = mkTerm "script_2_N" ;
lin script_3_N = mkTerm "script_3_N" ;
lin scripted_A = mkTerm "scripted_A" ;
lin scriptorium_N = mkTerm "scriptorium_N" ;
lin scriptural_A = mkTerm "scriptural_A" ;
lin scripture_N = mkTerm "scripture_N" ;
lin scriptwriter_N = mkTerm "scriptwriter_N" ;
lin scrivened_A = mkTerm "scrivened_A" ;
lin scrivener_N = mkTerm "scrivener_N" ;
lin scrod_N = mkTerm "scrod_N" ;
lin scrofula_N = mkTerm "scrofula_N" ;
lin scrofulous_A = mkTerm "scrofulous_A" ;
lin scroll_N = mkTerm "scroll_N" ;
lin scrooge_N = mkTerm "scrooge_N" ;
lin scrotal_A = mkTerm "scrotal_A" ;
lin scrotum_N = mkTerm "scrotum_N" ;
lin scrounge_V = mkTerm "scrounge_V" ;
lin scrounge_V2 = mkTerm "scrounge_V2" ;
lin scrounger_N = mkTerm "scrounger_N" ;
lin scrub_A = mkTerm "scrub_A" ;
lin scrub_N = mkTerm "scrub_N" ;
lin scrub_V = mkTerm "scrub_V" ;
lin scrub_V2 = mkTerm "scrub_V2" ;
lin scrubber_N = mkTerm "scrubber_N" ;
lin scrubbing_brush_N = mkTerm "scrubbing_brush_N" ;
lin scrubbird_N = mkTerm "scrubbird_N" ;
lin scrubby_A = mkTerm "scrubby_A" ;
lin scrubland_N = mkTerm "scrubland_N" ;
lin scruff_N = mkTerm "scruff_N" ;
lin scruffy_A = mkTerm "scruffy_A" ;
lin scrum_N = mkTerm "scrum_N" ;
lin scrummage_N = mkTerm "scrummage_N" ;
lin scrumptious_A = mkTerm "scrumptious_A" ;
lin scrumpy_N = mkTerm "scrumpy_N" ;
lin scrunch_N = mkTerm "scrunch_N" ;
lin scrunch_V2 = mkTerm "scrunch_V2" ;
lin scruple_N = mkTerm "scruple_N" ;
lin scruple_V = mkTerm "scruple_V" ;
lin scrupulous_A = mkTerm "scrupulous_A" ;
lin scrupulousness_N = mkTerm "scrupulousness_N" ;
lin scrutineer_N = mkTerm "scrutineer_N" ;
lin scrutinize_V2 = mkTerm "scrutinize_V2" ;
lin scrutinizer_N = mkTerm "scrutinizer_N" ;
lin scrutiny_N = mkTerm "scrutiny_N" ;
lin scud_N = mkTerm "scud_N" ;
lin scud_V = mkTerm "scud_V" ;
lin scuff_1_N = mkTerm "scuff_1_N" ;
lin scuff_2_N = mkTerm "scuff_2_N" ;
lin scuff_V = mkTerm "scuff_V" ;
lin scuff_V2 = mkTerm "scuff_V2" ;
lin scuffer_N = mkTerm "scuffer_N" ;
lin scuffle_N = mkTerm "scuffle_N" ;
lin scuffle_V = mkTerm "scuffle_V" ;
lin scull_N = mkTerm "scull_N" ;
lin scull_V = mkTerm "scull_V" ;
lin scull_V2 = mkTerm "scull_V2" ;
lin sculler_N = mkTerm "sculler_N" ;
lin scullery_N = mkTerm "scullery_N" ;
lin sculling_N = mkTerm "sculling_N" ;
lin scullion_N = mkTerm "scullion_N" ;
lin sculpin_N = mkTerm "sculpin_N" ;
lin sculpt_V = mkTerm "sculpt_V" ;
lin sculpt_V2 = mkTerm "sculpt_V2" ;
lin sculptor_N = mkTerm "sculptor_N" ;
lin sculptress_N = mkTerm "sculptress_N" ;
lin sculptural_A = mkTerm "sculptural_A" ;
lin sculpture_N = mkTerm "sculpture_N" ;
lin sculpture_V = mkTerm "sculpture_V" ;
lin sculpture_V2 = mkTerm "sculpture_V2" ;
lin scum_N = mkTerm "scum_N" ;
lin scumble_N = mkTerm "scumble_N" ;
lin scummy_A = mkTerm "scummy_A" ;
lin scunner_N = mkTerm "scunner_N" ;
lin scunthorpe_PN = mkTerm "scunthorpe_PN" ;
lin scup_N = mkTerm "scup_N" ;
lin scupper_N = mkTerm "scupper_N" ;
lin scupper_V2 = mkTerm "scupper_V2" ;
lin scuppernong_N = mkTerm "scuppernong_N" ;
lin scurf_N = mkTerm "scurf_N" ;
lin scurfy_A = mkTerm "scurfy_A" ;
lin scurrility_N = mkTerm "scurrility_N" ;
lin scurrilous_A = mkTerm "scurrilous_A" ;
lin scurry_N = mkTerm "scurry_N" ;
lin scurry_V = mkTerm "scurry_V" ;
lin scurvy_A = mkTerm "scurvy_A" ;
lin scurvy_N = mkTerm "scurvy_N" ;
lin scut_N = mkTerm "scut_N" ;
lin scutcheon_N = mkTerm "scutcheon_N" ;
lin scute_N = mkTerm "scute_N" ;
lin scuttle_N = mkTerm "scuttle_N" ;
lin scuttle_V = mkTerm "scuttle_V" ;
lin scuttle_V2 = mkTerm "scuttle_V2" ;
lin scylla_N = mkTerm "scylla_N" ;
lin scyphozoan_N = mkTerm "scyphozoan_N" ;
lin scyphus_N = mkTerm "scyphus_N" ;
lin scythe_N = mkTerm "scythe_N" ;
lin scythe_V2 = mkTerm "scythe_V2" ;
lin sea_N = mkTerm "sea_N" ;
lin sea_anemone_N = mkTerm "sea_anemone_N" ;
lin sea_animal_N = mkTerm "sea_animal_N" ;
lin sea_bathing_N = mkTerm "sea_bathing_N" ;
lin sea_boat_N = mkTerm "sea_boat_N" ;
lin sea_bream_N = mkTerm "sea_bream_N" ;
lin sea_breeze_N = mkTerm "sea_breeze_N" ;
lin sea_coal_N = mkTerm "sea_coal_N" ;
lin sea_cow_N = mkTerm "sea_cow_N" ;
lin sea_dog_N = mkTerm "sea_dog_N" ;
lin sea_fish_N = mkTerm "sea_fish_N" ;
lin sea_girt_A = mkTerm "sea_girt_A" ;
lin sea_god_N = mkTerm "sea_god_N" ;
lin sea_green_A = mkTerm "sea_green_A" ;
lin sea_green_N = mkTerm "sea_green_N" ;
lin sea_horse_N = mkTerm "sea_horse_N" ;
lin sea_level_N = mkTerm "sea_level_N" ;
lin sea_lion_N = mkTerm "sea_lion_N" ;
lin sea_power_N = mkTerm "sea_power_N" ;
lin sea_rover_N = mkTerm "sea_rover_N" ;
lin sea_snake_N = mkTerm "sea_snake_N" ;
lin sea_urchin_N = mkTerm "sea_urchin_N" ;
lin sea_wall_N = mkTerm "sea_wall_N" ;
lin sea_water_N = mkTerm "sea_water_N" ;
lin seabag_N = mkTerm "seabag_N" ;
lin seabed_N = mkTerm "seabed_N" ;
lin seabird_N = mkTerm "seabird_N" ;
lin seaboard_N = mkTerm "seaboard_N" ;
lin seaborgium_N = mkTerm "seaborgium_N" ;
lin seaborne_A = mkTerm "seaborne_A" ;
lin seafarer_N = mkTerm "seafarer_N" ;
lin seafaring_A = mkTerm "seafaring_A" ;
lin seafaring_N = mkTerm "seafaring_N" ;
lin seafood_N = mkTerm "seafood_N" ;
lin seaford_PN = mkTerm "seaford_PN" ;
lin seafront_N = mkTerm "seafront_N" ;
lin seagoing_A = mkTerm "seagoing_A" ;
lin seagrass_N = mkTerm "seagrass_N" ;
lin seagull_N = mkTerm "seagull_N" ;
lin seaham_PN = mkTerm "seaham_PN" ;
lin seakale_N = mkTerm "seakale_N" ;
lin seal_N = mkTerm "seal_N" ;
lin seal_V = mkTerm "seal_V" ;
lin seal_V2 = mkTerm "seal_V2" ;
lin seal_ring_N = mkTerm "seal_ring_N" ;
lin sealant_N = mkTerm "sealant_N" ;
lin sealer_N = mkTerm "sealer_N" ;
lin sealing_wax_N = mkTerm "sealing_wax_N" ;
lin sealskin_N = mkTerm "sealskin_N" ;
lin sealyham_N = mkTerm "sealyham_N" ;
lin seam_N = mkTerm "seam_N" ;
lin seam_V2 = mkTerm "seam_V2" ;
lin seaman_N = mkTerm "seaman_N" ;
lin seamanlike_A = mkTerm "seamanlike_A" ;
lin seamanship_N = mkTerm "seamanship_N" ;
lin seamless_A = mkTerm "seamless_A" ;
lin seamount_N = mkTerm "seamount_N" ;
lin seamstress_N = mkTerm "seamstress_N" ;
lin seamus_PN = mkTerm "seamus_PN" ;
lin seamy_A = mkTerm "seamy_A" ;
lin sean_PN = mkTerm "sean_PN" ;
lin seance_N = mkTerm "seance_N" ;
lin seaplane_N = mkTerm "seaplane_N" ;
lin seaport_N = mkTerm "seaport_N" ;
lin seaquake_N = mkTerm "seaquake_N" ;
lin sear_A = mkTerm "sear_A" ;
lin sear_V2 = mkTerm "sear_V2" ;
lin search_N = mkTerm "search_N" ;
lin search_V = mkTerm "search_V" ;
lin search_V2 = mkTerm "search_V2" ;
lin search_party_N = mkTerm "search_party_N" ;
lin search_warrant_N = mkTerm "search_warrant_N" ;
lin searcher_N = mkTerm "searcher_N" ;
lin searchingly_Adv = mkTerm "searchingly_Adv" ;
lin searchlight_N = mkTerm "searchlight_N" ;
lin searing_A = mkTerm "searing_A" ;
lin searing_iron_N = mkTerm "searing_iron_N" ;
lin seascape_N = mkTerm "seascape_N" ;
lin seashell_N = mkTerm "seashell_N" ;
lin seashore_N = mkTerm "seashore_N" ;
lin seasick_A = mkTerm "seasick_A" ;
lin seasickness_N = mkTerm "seasickness_N" ;
lin seaside_N = mkTerm "seaside_N" ;
lin seasnail_N = mkTerm "seasnail_N" ;
lin season_N = mkTerm "season_N" ;
lin season_V = mkTerm "season_V" ;
lin season_V2 = mkTerm "season_V2" ;
lin season_ticket_N = mkTerm "season_ticket_N" ;
lin seasonable_A = mkTerm "seasonable_A" ;
lin seasonableness_N = mkTerm "seasonableness_N" ;
lin seasonal_A = mkTerm "seasonal_A" ;
lin seasoner_N = mkTerm "seasoner_N" ;
lin seasoning_N = mkTerm "seasoning_N" ;
lin seat_N = mkTerm "seat_N" ;
lin seat_belt_N = mkTerm "seat_belt_N" ;
lin seating_N = mkTerm "seating_N" ;
lin seating_room_N = mkTerm "seating_room_N" ;
lin seaton_burn_PN = mkTerm "seaton_burn_PN" ;
lin seaton_delaval_PN = mkTerm "seaton_delaval_PN" ;
lin seattle_PN = mkTerm "seattle_PN" ;
lin seaward_A = mkTerm "seaward_A" ;
lin seaward_Adv = mkTerm "seaward_Adv" ;
lin seaward_N = mkTerm "seaward_N" ;
lin seawards_Adv = mkTerm "seawards_Adv" ;
lin seaway_N = mkTerm "seaway_N" ;
lin seaweed_N = mkTerm "seaweed_N" ;
lin seaworthiness_N = mkTerm "seaworthiness_N" ;
lin seaworthy_A = mkTerm "seaworthy_A" ;
lin seborrhea_N = mkTerm "seborrhea_N" ;
lin sebum_N = mkTerm "sebum_N" ;
lin sec_A = mkTerm "sec_A" ;
lin sec_N = mkTerm "sec_N" ;
lin secant_N = mkTerm "secant_N" ;
lin secateurs_N = mkTerm "secateurs_N" ;
lin secede_V = mkTerm "secede_V" ;
lin secession_N = mkTerm "secession_N" ;
lin secessionism_N = mkTerm "secessionism_N" ;
lin secessionist_N = mkTerm "secessionist_N" ;
lin seckel_N = mkTerm "seckel_N" ;
lin seclude_V2 = mkTerm "seclude_V2" ;
lin seclusion_N = mkTerm "seclusion_N" ;
lin second_N = mkTerm "second_N" ;
lin second_V2 = mkTerm "second_V2" ;
lin second_best_A = mkTerm "second_best_A" ;
lin second_best_Adv = mkTerm "second_best_Adv" ;
lin second_best_N = mkTerm "second_best_N" ;
lin second_class_A = mkTerm "second_class_A" ;
lin second_class_Adv = mkTerm "second_class_Adv" ;
lin second_class_N = mkTerm "second_class_N" ;
lin second_guess_V2 = mkTerm "second_guess_V2" ;
lin second_hand_A = mkTerm "second_hand_A" ;
lin second_hand_N = mkTerm "second_hand_N" ;
lin second_rate_A = mkTerm "second_rate_A" ;
lin second_rater_N = mkTerm "second_rater_N" ;
lin second_sighted_A = mkTerm "second_sighted_A" ;
lin secondary_A = mkTerm "secondary_A" ;
lin secondary_N = mkTerm "secondary_N" ;
lin seconder_N = mkTerm "seconder_N" ;
lin secondly_Adv = mkTerm "secondly_Adv" ;
lin secondment_N = mkTerm "secondment_N" ;
lin secondo_N = mkTerm "secondo_N" ;
lin secrecy_N = mkTerm "secrecy_N" ;
lin secret_A = mkTerm "secret_A" ;
lin secret_N = mkTerm "secret_N" ;
lin secretarial_A = mkTerm "secretarial_A" ;
lin secretariat_N = mkTerm "secretariat_N" ;
lin secretary_N = mkTerm "secretary_N" ;
lin secretary_general_N = mkTerm "secretary_general_N" ;
lin secretaryship_N = mkTerm "secretaryship_N" ;
lin secretase_N = mkTerm "secretase_N" ;
lin secrete_V2 = mkTerm "secrete_V2" ;
lin secretin_N = mkTerm "secretin_N" ;
lin secretion_N = mkTerm "secretion_N" ;
lin secretive_A = mkTerm "secretive_A" ;
lin secretiveness_N = mkTerm "secretiveness_N" ;
lin secretory_A = mkTerm "secretory_A" ;
lin sect_N = mkTerm "sect_N" ;
lin sectarian_A = mkTerm "sectarian_A" ;
lin sectarian_N = mkTerm "sectarian_N" ;
lin sectarianism_N = mkTerm "sectarianism_N" ;
lin section_N = mkTerm "section_N" ;
lin sectional_A = mkTerm "sectional_A" ;
lin sectional_N = mkTerm "sectional_N" ;
lin sectionalism_N = mkTerm "sectionalism_N" ;
lin sector_N = mkTerm "sector_N" ;
lin sectorial_A = mkTerm "sectorial_A" ;
lin secular_A = mkTerm "secular_A" ;
lin secularism_N = mkTerm "secularism_N" ;
lin secularist_N = mkTerm "secularist_N" ;
lin secularization_N = mkTerm "secularization_N" ;
lin secularize_V2 = mkTerm "secularize_V2" ;
lin secundigravida_N = mkTerm "secundigravida_N" ;
lin secure_A = mkTerm "secure_A" ;
lin secure_V2 = mkTerm "secure_V2" ;
lin secureness_N = mkTerm "secureness_N" ;
lin securicor_PN = mkTerm "securicor_PN" ;
lin security_N = mkTerm "security_N" ;
lin sedan_N = mkTerm "sedan_N" ;
lin sedan_chair_N = mkTerm "sedan_chair_N" ;
lin sedate_A = mkTerm "sedate_A" ;
lin sedate_V2 = mkTerm "sedate_V2" ;
lin sedateness_N = mkTerm "sedateness_N" ;
lin sedation_N = mkTerm "sedation_N" ;
lin sedative_A = mkTerm "sedative_A" ;
lin sedative_N = mkTerm "sedative_N" ;
lin sedentary_A = mkTerm "sedentary_A" ;
lin sedge_N = mkTerm "sedge_N" ;
lin sedgy_A = mkTerm "sedgy_A" ;
lin sediment_N = mkTerm "sediment_N" ;
lin sedimentary_A = mkTerm "sedimentary_A" ;
lin sedition_N = mkTerm "sedition_N" ;
lin seditious_A = mkTerm "seditious_A" ;
lin seduce_V2 = mkTerm "seduce_V2" ;
lin seducer_N = mkTerm "seducer_N" ;
lin seduction_N = mkTerm "seduction_N" ;
lin seductive_A = mkTerm "seductive_A" ;
lin seductress_N = mkTerm "seductress_N" ;
lin sedulity_N = mkTerm "sedulity_N" ;
lin sedulous_A = mkTerm "sedulous_A" ;
lin sedum_N = mkTerm "sedum_N" ;
lin see_N = mkTerm "see_N" ;
lin see_V = mkTerm "see_V" ;
lin see_V2 = mkTerm "see_V2" ;
lin see_V2V = mkTerm "see_V2V" ;
lin see_VQ = mkTerm "see_VQ" ;
lin see_VS = mkTerm "see_VS" ;
lin see_about_V2 = mkTerm "see_about_V2" ;
lin see_into_V3 = mkTerm "see_into_V3" ;
lin see_off_V2 = mkTerm "see_off_V2" ;
lin see_out_V2 = mkTerm "see_out_V2" ;
lin see_through_A = mkTerm "see_through_A" ;
lin see_through_V2 = mkTerm "see_through_V2" ;
lin see_to_V2 = mkTerm "see_to_V2" ;
lin seed_N = mkTerm "seed_N" ;
lin seed_V = mkTerm "seed_V" ;
lin seed_V2 = mkTerm "seed_V2" ;
lin seed_corn_N = mkTerm "seed_corn_N" ;
lin seedbed_N = mkTerm "seedbed_N" ;
lin seedcake_N = mkTerm "seedcake_N" ;
lin seeder_N = mkTerm "seeder_N" ;
lin seediness_N = mkTerm "seediness_N" ;
lin seedless_A = mkTerm "seedless_A" ;
lin seedling_N = mkTerm "seedling_N" ;
lin seedsman_N = mkTerm "seedsman_N" ;
lin seedtime_N = mkTerm "seedtime_N" ;
lin seedy_A = mkTerm "seedy_A" ;
lin seek_N = mkTerm "seek_N" ;
lin seek_V2 = mkTerm "seek_V2" ;
lin seek_VV = mkTerm "seek_VV" ;
lin seek_out_V2 = mkTerm "seek_out_V2" ;
lin seeker_N = mkTerm "seeker_N" ;
lin seeking_N = mkTerm "seeking_N" ;
lin seem_VA = mkTerm "seem_VA" ;
lin seem_VS = mkTerm "seem_VS" ;
lin seem_VV = mkTerm "seem_VV" ;
lin seeming_A = mkTerm "seeming_A" ;
lin seemliness_N = mkTerm "seemliness_N" ;
lin seemly_A = mkTerm "seemly_A" ;
lin seep_V = mkTerm "seep_V" ;
lin seepage_N = mkTerm "seepage_N" ;
lin seer_N = mkTerm "seer_N" ;
lin seersucker_N = mkTerm "seersucker_N" ;
lin seesaw_N = mkTerm "seesaw_N" ;
lin seesaw_V = mkTerm "seesaw_V" ;
lin seethe_V = mkTerm "seethe_V" ;
lin seethe_V2 = mkTerm "seethe_V2" ;
lin segment_N = mkTerm "segment_N" ;
lin segment_V = mkTerm "segment_V" ;
lin segment_V2 = mkTerm "segment_V2" ;
lin segmental_A = mkTerm "segmental_A" ;
lin segmentation_N = mkTerm "segmentation_N" ;
lin segno_N = mkTerm "segno_N" ;
lin segregate_N = mkTerm "segregate_N" ;
lin segregate_V2 = mkTerm "segregate_V2" ;
lin segregation_N = mkTerm "segregation_N" ;
lin segregationism_N = mkTerm "segregationism_N" ;
lin segregator_N = mkTerm "segregator_N" ;
lin segue_N = mkTerm "segue_N" ;
lin seiche_N = mkTerm "seiche_N" ;
lin seidel_N = mkTerm "seidel_N" ;
lin seigneury_N = mkTerm "seigneury_N" ;
lin seignior_N = mkTerm "seignior_N" ;
lin seigniorage_N = mkTerm "seigniorage_N" ;
lin seigniory_N = mkTerm "seigniory_N" ;
lin seine_N = mkTerm "seine_N" ;
lin seine_V = mkTerm "seine_V" ;
lin seine_V2 = mkTerm "seine_V2" ;
lin seinäjoki_PN = mkTerm "seinäjoki_PN" ;
lin seismic_A = mkTerm "seismic_A" ;
lin seismogram_N = mkTerm "seismogram_N" ;
lin seismograph_N = mkTerm "seismograph_N" ;
lin seismography_N = mkTerm "seismography_N" ;
lin seismological_A = mkTerm "seismological_A" ;
lin seismologist_N = mkTerm "seismologist_N" ;
lin seismology_N = mkTerm "seismology_N" ;
lin seize_V = mkTerm "seize_V" ;
lin seize_V2 = mkTerm "seize_V2" ;
lin seize_up_V = mkTerm "seize_up_V" ;
lin seizing_N = mkTerm "seizing_N" ;
lin seizure_N = mkTerm "seizure_N" ;
lin selby_PN = mkTerm "selby_PN" ;
lin seldom_Adv = mkTerm "seldom_Adv" ;
lin select_A = mkTerm "select_A" ;
lin select_V = mkTerm "select_V" ;
lin select_V2 = mkTerm "select_V2" ;
lin select_V2V = mkTerm "select_V2V" ;
lin select_VV = mkTerm "select_VV" ;
lin selected_A = mkTerm "selected_A" ;
lin selection_N = mkTerm "selection_N" ;
lin selective_A = mkTerm "selective_A" ;
lin selectivity_N = mkTerm "selectivity_N" ;
lin selectman_N = mkTerm "selectman_N" ;
lin selector_N = mkTerm "selector_N" ;
lin selectwoman_N = mkTerm "selectwoman_N" ;
lin selenium_N = mkTerm "selenium_N" ;
lin selenology_N = mkTerm "selenology_N" ;
lin self_A = mkTerm "self_A" ;
lin self_N = mkTerm "self_N" ;
lin self_abasement_N = mkTerm "self_abasement_N" ;
lin self_abnegation_N = mkTerm "self_abnegation_N" ;
lin self_absorbed_A = mkTerm "self_absorbed_A" ;
lin self_acting_A = mkTerm "self_acting_A" ;
lin self_activating_A = mkTerm "self_activating_A" ;
lin self_addressed_A = mkTerm "self_addressed_A" ;
lin self_appointed_A = mkTerm "self_appointed_A" ;
lin self_assertion_N = mkTerm "self_assertion_N" ;
lin self_assertive_A = mkTerm "self_assertive_A" ;
lin self_assurance_N = mkTerm "self_assurance_N" ;
lin self_assured_A = mkTerm "self_assured_A" ;
lin self_centred_A = mkTerm "self_centred_A" ;
lin self_collected_A = mkTerm "self_collected_A" ;
lin self_coloured_A = mkTerm "self_coloured_A" ;
lin self_command_N = mkTerm "self_command_N" ;
lin self_communion_N = mkTerm "self_communion_N" ;
lin self_complacency_N = mkTerm "self_complacency_N" ;
lin self_confessed_A = mkTerm "self_confessed_A" ;
lin self_confidence_N = mkTerm "self_confidence_N" ;
lin self_confident_A = mkTerm "self_confident_A" ;
lin self_conscious_A = mkTerm "self_conscious_A" ;
lin self_consciousness_N = mkTerm "self_consciousness_N" ;
lin self_contained_A = mkTerm "self_contained_A" ;
lin self_control_N = mkTerm "self_control_N" ;
lin self_defence_N = mkTerm "self_defence_N" ;
lin self_denial_N = mkTerm "self_denial_N" ;
lin self_denying_A = mkTerm "self_denying_A" ;
lin self_destruct_V = mkTerm "self_destruct_V" ;
lin self_determination_N = mkTerm "self_determination_N" ;
lin self_educated_A = mkTerm "self_educated_A" ;
lin self_effacing_A = mkTerm "self_effacing_A" ;
lin self_employed_A = mkTerm "self_employed_A" ;
lin self_esteem_N = mkTerm "self_esteem_N" ;
lin self_evident_A = mkTerm "self_evident_A" ;
lin self_examination_N = mkTerm "self_examination_N" ;
lin self_explanatory_A = mkTerm "self_explanatory_A" ;
lin self_help_N = mkTerm "self_help_N" ;
lin self_importance_N = mkTerm "self_importance_N" ;
lin self_important_A = mkTerm "self_important_A" ;
lin self_imposed_A = mkTerm "self_imposed_A" ;
lin self_indulgence_N = mkTerm "self_indulgence_N" ;
lin self_indulgent_A = mkTerm "self_indulgent_A" ;
lin self_insure_V = mkTerm "self_insure_V" ;
lin self_interest_N = mkTerm "self_interest_N" ;
lin self_locking_A = mkTerm "self_locking_A" ;
lin self_made_A = mkTerm "self_made_A" ;
lin self_opinionated_A = mkTerm "self_opinionated_A" ;
lin self_pity_N = mkTerm "self_pity_N" ;
lin self_possessed_A = mkTerm "self_possessed_A" ;
lin self_possession_N = mkTerm "self_possession_N" ;
lin self_preservation_N = mkTerm "self_preservation_N" ;
lin self_raising_A = mkTerm "self_raising_A" ;
lin self_reliance_N = mkTerm "self_reliance_N" ;
lin self_reliant_A = mkTerm "self_reliant_A" ;
lin self_respect_N = mkTerm "self_respect_N" ;
lin self_respecting_A = mkTerm "self_respecting_A" ;
lin self_righteous_A = mkTerm "self_righteous_A" ;
lin self_rule_N = mkTerm "self_rule_N" ;
lin self_sacrifice_N = mkTerm "self_sacrifice_N" ;
lin self_sacrificing_A = mkTerm "self_sacrificing_A" ;
lin self_same_A = mkTerm "self_same_A" ;
lin self_sealing_A = mkTerm "self_sealing_A" ;
lin self_seeker_N = mkTerm "self_seeker_N" ;
lin self_seeking_A = mkTerm "self_seeking_A" ;
lin self_seeking_N = mkTerm "self_seeking_N" ;
lin self_service_N = mkTerm "self_service_N" ;
lin self_sown_A = mkTerm "self_sown_A" ;
lin self_starter_N = mkTerm "self_starter_N" ;
lin self_styled_A = mkTerm "self_styled_A" ;
lin self_sufficiency_N = mkTerm "self_sufficiency_N" ;
lin self_sufficient_A = mkTerm "self_sufficient_A" ;
lin self_sufficing_A = mkTerm "self_sufficing_A" ;
lin self_supporting_A = mkTerm "self_supporting_A" ;
lin self_will_N = mkTerm "self_will_N" ;
lin self_willed_A = mkTerm "self_willed_A" ;
lin self_winding_A = mkTerm "self_winding_A" ;
lin selfconsciously_Adv = mkTerm "selfconsciously_Adv" ;
lin selfish_A = mkTerm "selfish_A" ;
lin selfishness_N = mkTerm "selfishness_N" ;
lin selflessness_N = mkTerm "selflessness_N" ;
lin selfsameness_N = mkTerm "selfsameness_N" ;
lin selkirk_PN = mkTerm "selkirk_PN" ;
lin sell_N = mkTerm "sell_N" ;
lin sell_V = mkTerm "sell_V" ;
lin sell_V2 = mkTerm "sell_V2" ;
lin sell_back_V = mkTerm "sell_back_V" ;
lin sell_off_V2 = mkTerm "sell_off_V2" ;
lin sell_on_V2 = mkTerm "sell_on_V2" ;
lin sell_out_V = mkTerm "sell_out_V" ;
lin sell_out_V2 = mkTerm "sell_out_V2" ;
lin sell_up_V2 = mkTerm "sell_up_V2" ;
lin sellerFem_N = mkTerm "sellerFem_N" ;
lin sellerMasc_N = mkTerm "sellerMasc_N" ;
lin selling_N = mkTerm "selling_N" ;
lin selloff_N = mkTerm "selloff_N" ;
lin sellout_N = mkTerm "sellout_N" ;
lin selsey_PN = mkTerm "selsey_PN" ;
lin selston_PN = mkTerm "selston_PN" ;
lin selsyn_N = mkTerm "selsyn_N" ;
lin seltzer_N = mkTerm "seltzer_N" ;
lin selvage_N = mkTerm "selvage_N" ;
lin selvedge_N = mkTerm "selvedge_N" ;
lin semantic_A = mkTerm "semantic_A" ;
lin semanticist_N = mkTerm "semanticist_N" ;
lin semantics_N = mkTerm "semantics_N" ;
lin semaphore_N = mkTerm "semaphore_N" ;
lin semaphore_V = mkTerm "semaphore_V" ;
lin semaphore_V2 = mkTerm "semaphore_V2" ;
lin semarang_PN = mkTerm "semarang_PN" ;
lin semblance_N = mkTerm "semblance_N" ;
lin semen_N = mkTerm "semen_N" ;
lin semester_N = mkTerm "semester_N" ;
lin semestral_A = mkTerm "semestral_A" ;
lin semi_final_N = mkTerm "semi_final_N" ;
lin semiabstract_A = mkTerm "semiabstract_A" ;
lin semiannual_A = mkTerm "semiannual_A" ;
lin semiaquatic_A = mkTerm "semiaquatic_A" ;
lin semiarid_A = mkTerm "semiarid_A" ;
lin semiautobiographical_A = mkTerm "semiautobiographical_A" ;
lin semiautomatic_A = mkTerm "semiautomatic_A" ;
lin semibreve_N = mkTerm "semibreve_N" ;
lin semicentennial_A = mkTerm "semicentennial_A" ;
lin semicentennial_N = mkTerm "semicentennial_N" ;
lin semicircle_N = mkTerm "semicircle_N" ;
lin semicircular_A = mkTerm "semicircular_A" ;
lin semicolon_N = mkTerm "semicolon_N" ;
lin semicoma_N = mkTerm "semicoma_N" ;
lin semicomatose_A = mkTerm "semicomatose_A" ;
lin semiconducting_A = mkTerm "semiconducting_A" ;
lin semiconductor_N = mkTerm "semiconductor_N" ;
lin semiconscious_A = mkTerm "semiconscious_A" ;
lin semidark_A = mkTerm "semidark_A" ;
lin semidarkness_N = mkTerm "semidarkness_N" ;
lin semidesert_N = mkTerm "semidesert_N" ;
lin semidetached_A = mkTerm "semidetached_A" ;
lin semidiameter_N = mkTerm "semidiameter_N" ;
lin semiempirical_A = mkTerm "semiempirical_A" ;
lin semifinalist_N = mkTerm "semifinalist_N" ;
lin semifluidity_N = mkTerm "semifluidity_N" ;
lin semiformal_A = mkTerm "semiformal_A" ;
lin semigloss_N = mkTerm "semigloss_N" ;
lin semihard_A = mkTerm "semihard_A" ;
lin semiliquid_A = mkTerm "semiliquid_A" ;
lin semiliterate_A = mkTerm "semiliterate_A" ;
lin semimonthly_A = mkTerm "semimonthly_A" ;
lin semimonthly_Adv = mkTerm "semimonthly_Adv" ;
lin semimonthly_N = mkTerm "semimonthly_N" ;
lin seminal_A = mkTerm "seminal_A" ;
lin seminar_N = mkTerm "seminar_N" ;
lin seminarian_N = mkTerm "seminarian_N" ;
lin seminarist_N = mkTerm "seminarist_N" ;
lin seminary_N = mkTerm "seminary_N" ;
lin seminiferous_A = mkTerm "seminiferous_A" ;
lin seminoma_N = mkTerm "seminoma_N" ;
lin seminude_A = mkTerm "seminude_A" ;
lin semiofficial_A = mkTerm "semiofficial_A" ;
lin semiopaque_A = mkTerm "semiopaque_A" ;
lin semiotic_A = mkTerm "semiotic_A" ;
lin semiotics_N = mkTerm "semiotics_N" ;
lin semiparasitic_A = mkTerm "semiparasitic_A" ;
lin semipermeable_A = mkTerm "semipermeable_A" ;
lin semipolitical_A = mkTerm "semipolitical_A" ;
lin semiprecious_A = mkTerm "semiprecious_A" ;
lin semiprivate_A = mkTerm "semiprivate_A" ;
lin semiprofessional_N = mkTerm "semiprofessional_N" ;
lin semipublic_A = mkTerm "semipublic_A" ;
lin semiquaver_N = mkTerm "semiquaver_N" ;
lin semirigid_A = mkTerm "semirigid_A" ;
lin semisolid_A = mkTerm "semisolid_A" ;
lin semite_A = mkTerm "semite_A" ;
lin semite_N = mkTerm "semite_N" ;
lin semiterrestrial_A = mkTerm "semiterrestrial_A" ;
lin semitic_A = mkTerm "semitic_A" ;
lin semitone_N = mkTerm "semitone_N" ;
lin semitrailer_N = mkTerm "semitrailer_N" ;
lin semitrance_N = mkTerm "semitrance_N" ;
lin semitropical_A = mkTerm "semitropical_A" ;
lin semivowel_N = mkTerm "semivowel_N" ;
lin semiweekly_A = mkTerm "semiweekly_A" ;
lin semiweekly_Adv = mkTerm "semiweekly_Adv" ;
lin semiweekly_N = mkTerm "semiweekly_N" ;
lin semolina_N = mkTerm "semolina_N" ;
lin sempstress_N = mkTerm "sempstress_N" ;
lin sen_N = mkTerm "sen_N" ;
lin senate_N = mkTerm "senate_N" ;
lin senator_N = mkTerm "senator_N" ;
lin senatorial_A = mkTerm "senatorial_A" ;
lin senatorship_N = mkTerm "senatorship_N" ;
lin send_V = mkTerm "send_V" ;
lin send_V2 = mkTerm "send_V2" ;
lin send_V2V = mkTerm "send_V2V" ;
lin send_back_V2 = mkTerm "send_back_V2" ;
lin send_for_V2 = mkTerm "send_for_V2" ;
lin send_in_V = mkTerm "send_in_V" ;
lin send_in_V2 = mkTerm "send_in_V2" ;
lin send_off_V2 = mkTerm "send_off_V2" ;
lin send_off_for_V2 = mkTerm "send_off_for_V2" ;
lin send_out_V2 = mkTerm "send_out_V2" ;
lin send_out_for_V2 = mkTerm "send_out_for_V2" ;
lin send_up_N = mkTerm "send_up_N" ;
lin send_up_V2 = mkTerm "send_up_V2" ;
lin sendee_N = mkTerm "sendee_N" ;
lin sender_N = mkTerm "sender_N" ;
lin sending_N = mkTerm "sending_N" ;
lin sendoff_N = mkTerm "sendoff_N" ;
lin sene_N = mkTerm "sene_N" ;
lin senega_N = mkTerm "senega_N" ;
lin senegal_PN = mkTerm "senegal_PN" ;
lin senegalese_A = mkTerm "senegalese_A" ;
lin senegalese_N = mkTerm "senegalese_N" ;
lin senescence_N = mkTerm "senescence_N" ;
lin senescent_A = mkTerm "senescent_A" ;
lin seneschal_N = mkTerm "seneschal_N" ;
lin senile_A = mkTerm "senile_A" ;
lin senility_N = mkTerm "senility_N" ;
lin senior_A = mkTerm "senior_A" ;
lin senior_N = mkTerm "senior_N" ;
lin seniority_N = mkTerm "seniority_N" ;
lin seniti_N = mkTerm "seniti_N" ;
lin senna_N = mkTerm "senna_N" ;
lin sennit_N = mkTerm "sennit_N" ;
lin senor_N = mkTerm "senor_N" ;
lin senora_N = mkTerm "senora_N" ;
lin senorita_N = mkTerm "senorita_N" ;
lin sensate_A = mkTerm "sensate_A" ;
lin sensation_N = mkTerm "sensation_N" ;
lin sensational_A = mkTerm "sensational_A" ;
lin sensationalism_N = mkTerm "sensationalism_N" ;
lin sensationalist_N = mkTerm "sensationalist_N" ;
lin sense_N = mkTerm "sense_N" ;
lin sense_V2 = mkTerm "sense_V2" ;
lin sense_VS = mkTerm "sense_VS" ;
lin sense_organ_N = mkTerm "sense_organ_N" ;
lin senseless_A = mkTerm "senseless_A" ;
lin senselessness_N = mkTerm "senselessness_N" ;
lin sensibility_N = mkTerm "sensibility_N" ;
lin sensible_A = mkTerm "sensible_A" ;
lin sensibleness_N = mkTerm "sensibleness_N" ;
lin sensing_N = mkTerm "sensing_N" ;
lin sensitive_A = mkTerm "sensitive_A" ;
lin sensitivity_N = mkTerm "sensitivity_N" ;
lin sensitization_N = mkTerm "sensitization_N" ;
lin sensitize_V2 = mkTerm "sensitize_V2" ;
lin sensitizer_N = mkTerm "sensitizer_N" ;
lin sensitizing_A = mkTerm "sensitizing_A" ;
lin sensitizing_N = mkTerm "sensitizing_N" ;
lin sensitometer_N = mkTerm "sensitometer_N" ;
lin sensor_N = mkTerm "sensor_N" ;
lin sensorimotor_A = mkTerm "sensorimotor_A" ;
lin sensorineural_A = mkTerm "sensorineural_A" ;
lin sensorium_N = mkTerm "sensorium_N" ;
lin sensory_A = mkTerm "sensory_A" ;
lin sensual_A = mkTerm "sensual_A" ;
lin sensualism_N = mkTerm "sensualism_N" ;
lin sensualist_N = mkTerm "sensualist_N" ;
lin sensuality_N = mkTerm "sensuality_N" ;
lin sensuous_A = mkTerm "sensuous_A" ;
lin sensuousness_N = mkTerm "sensuousness_N" ;
lin sent_N = mkTerm "sent_N" ;
lin sente_N = mkTerm "sente_N" ;
lin sentence_N = mkTerm "sentence_N" ;
lin sentence_V = mkTerm "sentence_V" ;
lin sentence_V2 = mkTerm "sentence_V2" ;
lin sentential_A = mkTerm "sentential_A" ;
lin sententious_A = mkTerm "sententious_A" ;
lin sentience_N = mkTerm "sentience_N" ;
lin sentient_A = mkTerm "sentient_A" ;
lin sentiment_N = mkTerm "sentiment_N" ;
lin sentimental_A = mkTerm "sentimental_A" ;
lin sentimentalism_N = mkTerm "sentimentalism_N" ;
lin sentimentalist_N = mkTerm "sentimentalist_N" ;
lin sentimentality_N = mkTerm "sentimentality_N" ;
lin sentimentalization_N = mkTerm "sentimentalization_N" ;
lin sentimentalize_V = mkTerm "sentimentalize_V" ;
lin sentimentalize_V2 = mkTerm "sentimentalize_V2" ;
lin sentinel_N = mkTerm "sentinel_N" ;
lin sentry_N = mkTerm "sentry_N" ;
lin sentry_box_N = mkTerm "sentry_box_N" ;
lin sentry_go_N = mkTerm "sentry_go_N" ;
lin seoul_PN = mkTerm "seoul_PN" ;
lin sepal_N = mkTerm "sepal_N" ;
lin sepaloid_A = mkTerm "sepaloid_A" ;
lin separability_N = mkTerm "separability_N" ;
lin separable_A = mkTerm "separable_A" ;
lin separate_A = mkTerm "separate_A" ;
lin separate_N = mkTerm "separate_N" ;
lin separate_V = mkTerm "separate_V" ;
lin separate_V2 = mkTerm "separate_V2" ;
lin separateness_N = mkTerm "separateness_N" ;
lin separation_N = mkTerm "separation_N" ;
lin separatism_N = mkTerm "separatism_N" ;
lin separatist_N = mkTerm "separatist_N" ;
lin separative_A = mkTerm "separative_A" ;
lin separator_N = mkTerm "separator_N" ;
lin sepia_N = mkTerm "sepia_N" ;
lin sepsis_N = mkTerm "sepsis_N" ;
lin sept_PN = mkTerm "sept_PN" ;
lin septal_A = mkTerm "septal_A" ;
lin septation_N = mkTerm "septation_N" ;
lin septectomy_N = mkTerm "septectomy_N" ;
lin septet_N = mkTerm "septet_N" ;
lin septic_A = mkTerm "septic_A" ;
lin septicaemia_N = mkTerm "septicaemia_N" ;
lin septicemia_N = mkTerm "septicemia_N" ;
lin septicemic_A = mkTerm "septicemic_A" ;
lin septillion_N = mkTerm "septillion_N" ;
lin septrional_A = mkTerm "septrional_A" ;
lin septuagenarian_N = mkTerm "septuagenarian_N" ;
lin septuagint_N = mkTerm "septuagint_N" ;
lin septum_N = mkTerm "septum_N" ;
lin septuple_A = mkTerm "septuple_A" ;
lin sepulchral_A = mkTerm "sepulchral_A" ;
lin sepulchre_N = mkTerm "sepulchre_N" ;
lin sepulture_N = mkTerm "sepulture_N" ;
lin sequel_N = mkTerm "sequel_N" ;
lin sequela_N = mkTerm "sequela_N" ;
lin sequella_N = mkTerm "sequella_N" ;
lin sequence_N = mkTerm "sequence_N" ;
lin sequencer_N = mkTerm "sequencer_N" ;
lin sequent_A = mkTerm "sequent_A" ;
lin sequential_A = mkTerm "sequential_A" ;
lin sequester_V2 = mkTerm "sequester_V2" ;
lin sequestrate_V2 = mkTerm "sequestrate_V2" ;
lin sequestration_N = mkTerm "sequestration_N" ;
lin sequin_N = mkTerm "sequin_N" ;
lin sequoia_N = mkTerm "sequoia_N" ;
lin seraglio_N = mkTerm "seraglio_N" ;
lin serape_N = mkTerm "serape_N" ;
lin seraph_N = mkTerm "seraph_N" ;
lin seraphic_A = mkTerm "seraphic_A" ;
lin serbian_A = mkTerm "serbian_A" ;
lin serbo_croat_N = mkTerm "serbo_croat_N" ;
lin sere_A = mkTerm "sere_A" ;
lin serenade_N = mkTerm "serenade_N" ;
lin serenade_V2 = mkTerm "serenade_V2" ;
lin serendipitous_A = mkTerm "serendipitous_A" ;
lin serendipity_N = mkTerm "serendipity_N" ;
lin serene_A = mkTerm "serene_A" ;
lin sereness_N = mkTerm "sereness_N" ;
lin serenity_N = mkTerm "serenity_N" ;
lin serf_N = mkTerm "serf_N" ;
lin serfdom_N = mkTerm "serfdom_N" ;
lin serflike_A = mkTerm "serflike_A" ;
lin serge_N = mkTerm "serge_N" ;
lin sergeant_N = mkTerm "sergeant_N" ;
lin sergeant_major_N = mkTerm "sergeant_major_N" ;
lin serger_N = mkTerm "serger_N" ;
lin serial_A = mkTerm "serial_A" ;
lin serial_N = mkTerm "serial_N" ;
lin serialism_N = mkTerm "serialism_N" ;
lin serialization_N = mkTerm "serialization_N" ;
lin serialize_V2 = mkTerm "serialize_V2" ;
lin seriatim_Adv = mkTerm "seriatim_Adv" ;
lin sericultural_A = mkTerm "sericultural_A" ;
lin sericulture_N = mkTerm "sericulture_N" ;
lin sericulturist_N = mkTerm "sericulturist_N" ;
lin series_N = mkTerm "series_N" ;
lin serif_N = mkTerm "serif_N" ;
lin serigraphy_N = mkTerm "serigraphy_N" ;
lin serin_N = mkTerm "serin_N" ;
lin serine_N = mkTerm "serine_N" ;
lin seriocomedy_N = mkTerm "seriocomedy_N" ;
lin seriocomic_A = mkTerm "seriocomic_A" ;
lin serious_A = mkTerm "serious_A" ;
lin seriousness_N = mkTerm "seriousness_N" ;
lin serjeant_N = mkTerm "serjeant_N" ;
lin serjeant_at_arms_N = mkTerm "serjeant_at_arms_N" ;
lin sermon_N = mkTerm "sermon_N" ;
lin sermonize_V = mkTerm "sermonize_V" ;
lin sermonize_V2 = mkTerm "sermonize_V2" ;
lin serologic_A = mkTerm "serologic_A" ;
lin serologist_N = mkTerm "serologist_N" ;
lin serology_N = mkTerm "serology_N" ;
lin serotine_N = mkTerm "serotine_N" ;
lin serotonin_N = mkTerm "serotonin_N" ;
lin serous_A = mkTerm "serous_A" ;
lin serow_N = mkTerm "serow_N" ;
lin serpent_N = mkTerm "serpent_N" ;
lin serpentine_A = mkTerm "serpentine_A" ;
lin serrate_A = mkTerm "serrate_A" ;
lin serrated_A = mkTerm "serrated_A" ;
lin serration_N = mkTerm "serration_N" ;
lin serratus_N = mkTerm "serratus_N" ;
lin serried_A = mkTerm "serried_A" ;
lin serrulate_A = mkTerm "serrulate_A" ;
lin sertraline_N = mkTerm "sertraline_N" ;
lin sertularian_N = mkTerm "sertularian_N" ;
lin serum_N = mkTerm "serum_N" ;
lin serval_N = mkTerm "serval_N" ;
lin servantFem_N = mkTerm "servantFem_N" ;
lin servantMasc_N = mkTerm "servantMasc_N" ;
lin serve_N = mkTerm "serve_N" ;
lin serve_V = mkTerm "serve_V" ;
lin serve_V2 = mkTerm "serve_V2" ;
lin server_N = mkTerm "server_N" ;
lin service_N = mkTerm "service_N" ;
lin service_V2 = mkTerm "service_V2" ;
lin serviceability_N = mkTerm "serviceability_N" ;
lin serviceable_A = mkTerm "serviceable_A" ;
lin serviceman_N = mkTerm "serviceman_N" ;
lin servicing_N = mkTerm "servicing_N" ;
lin serviette_N = mkTerm "serviette_N" ;
lin servile_A = mkTerm "servile_A" ;
lin servility_N = mkTerm "servility_N" ;
lin serving_N = mkTerm "serving_N" ;
lin servitor_N = mkTerm "servitor_N" ;
lin servitude_N = mkTerm "servitude_N" ;
lin servo_N = mkTerm "servo_N" ;
lin servomechanical_A = mkTerm "servomechanical_A" ;
lin sesame_N = mkTerm "sesame_N" ;
lin sesbania_N = mkTerm "sesbania_N" ;
lin sesotho_N = mkTerm "sesotho_N" ;
lin sesquicentennial_N = mkTerm "sesquicentennial_N" ;
lin sesquipedalian_A = mkTerm "sesquipedalian_A" ;
lin sesquipedalian_N = mkTerm "sesquipedalian_N" ;
lin sesquipedality_N = mkTerm "sesquipedality_N" ;
lin sessile_A = mkTerm "sessile_A" ;
lin session_N = mkTerm "session_N" ;
lin sestet_N = mkTerm "sestet_N" ;
lin set_1_N = mkTerm "set_1_N" ;
lin set_2_N = mkTerm "set_2_N" ;
lin set_V2 = mkTerm "set_V2" ;
lin set_about_V2 = mkTerm "set_about_V2" ;
lin set_apart_V2 = mkTerm "set_apart_V2" ;
lin set_aside_V2 = mkTerm "set_aside_V2" ;
lin set_back_V = mkTerm "set_back_V" ;
lin set_back_V2 = mkTerm "set_back_V2" ;
lin set_forth_V = mkTerm "set_forth_V" ;
lin set_forth_V2 = mkTerm "set_forth_V2" ;
lin set_in_V = mkTerm "set_in_V" ;
lin set_off_V = mkTerm "set_off_V" ;
lin set_off_V2 = mkTerm "set_off_V2" ;
lin set_on_V2 = mkTerm "set_on_V2" ;
lin set_out_V = mkTerm "set_out_V" ;
lin set_out_V2 = mkTerm "set_out_V2" ;
lin set_square_N = mkTerm "set_square_N" ;
lin set_to_N = mkTerm "set_to_N" ;
lin set_to_V = mkTerm "set_to_V" ;
lin set_up_N = mkTerm "set_up_N" ;
lin set_up_V = mkTerm "set_up_V" ;
lin set_up_V2 = mkTerm "set_up_V2" ;
lin set_upon_V2 = mkTerm "set_upon_V2" ;
lin seta_N = mkTerm "seta_N" ;
lin setback_N = mkTerm "setback_N" ;
lin setscrew_N = mkTerm "setscrew_N" ;
lin setswana_N = mkTerm "setswana_N" ;
lin sett_N = mkTerm "sett_N" ;
lin settee_N = mkTerm "settee_N" ;
lin setter_N = mkTerm "setter_N" ;
lin setting_N = mkTerm "setting_N" ;
lin settle_N = mkTerm "settle_N" ;
lin settle_V = mkTerm "settle_V" ;
lin settle_V2 = mkTerm "settle_V2" ;
lin settle_back_V = mkTerm "settle_back_V" ;
lin settle_down_V = mkTerm "settle_down_V" ;
lin settle_for_V2 = mkTerm "settle_for_V2" ;
lin settle_in_V = mkTerm "settle_in_V" ;
lin settle_on_V2 = mkTerm "settle_on_V2" ;
lin settle_up_V = mkTerm "settle_up_V" ;
lin settlement_N = mkTerm "settlement_N" ;
lin settler_N = mkTerm "settler_N" ;
lin settling_N = mkTerm "settling_N" ;
lin settlor_N = mkTerm "settlor_N" ;
lin seven_sisters_PN = mkTerm "seven_sisters_PN" ;
lin sevenfold_A = mkTerm "sevenfold_A" ;
lin sevenfold_Adv = mkTerm "sevenfold_Adv" ;
lin sevenoaks_PN = mkTerm "sevenoaks_PN" ;
lin sever_V = mkTerm "sever_V" ;
lin sever_V2 = mkTerm "sever_V2" ;
lin several_Det = mkTerm "several_Det" ;
lin several_Num = mkTerm "several_Num" ;
lin severally_Adv = mkTerm "severally_Adv" ;
lin severalty_N = mkTerm "severalty_N" ;
lin severance_N = mkTerm "severance_N" ;
lin severe_A = mkTerm "severe_A" ;
lin severity_N = mkTerm "severity_N" ;
lin sevilla_PN = mkTerm "sevilla_PN" ;
lin seville_PN = mkTerm "seville_PN" ;
lin sew_V = mkTerm "sew_V" ;
lin sew_V2 = mkTerm "sew_V2" ;
lin sewage_N = mkTerm "sewage_N" ;
lin sewage_farm_N = mkTerm "sewage_farm_N" ;
lin sewage_works_N = mkTerm "sewage_works_N" ;
lin sewer_N = mkTerm "sewer_N" ;
lin sewer_gas_N = mkTerm "sewer_gas_N" ;
lin sewer_rat_N = mkTerm "sewer_rat_N" ;
lin sewerage_N = mkTerm "sewerage_N" ;
lin sewing_N = mkTerm "sewing_N" ;
lin sewing_machine_N = mkTerm "sewing_machine_N" ;
lin sex_1_N = mkTerm "sex_1_N" ;
lin sex_2_N = mkTerm "sex_2_N" ;
lin sex_V2 = mkTerm "sex_V2" ;
lin sex_starved_A = mkTerm "sex_starved_A" ;
lin sex_up_V2 = mkTerm "sex_up_V2" ;
lin sexagenarian_A = mkTerm "sexagenarian_A" ;
lin sexagenarian_N = mkTerm "sexagenarian_N" ;
lin sexagesimal_A = mkTerm "sexagesimal_A" ;
lin sexcapade_N = mkTerm "sexcapade_N" ;
lin sexism_N = mkTerm "sexism_N" ;
lin sexist_A = mkTerm "sexist_A" ;
lin sexist_N = mkTerm "sexist_N" ;
lin sexless_A = mkTerm "sexless_A" ;
lin sexploitation_N = mkTerm "sexploitation_N" ;
lin sext_N = mkTerm "sext_N" ;
lin sextant_N = mkTerm "sextant_N" ;
lin sextet_N = mkTerm "sextet_N" ;
lin sextette_N = mkTerm "sextette_N" ;
lin sextillion_N = mkTerm "sextillion_N" ;
lin sexton_N = mkTerm "sexton_N" ;
lin sextuple_A = mkTerm "sextuple_A" ;
lin sexual_A = mkTerm "sexual_A" ;
lin sexuality_N = mkTerm "sexuality_N" ;
lin sexy_A = mkTerm "sexy_A" ;
lin seychelles_PN = mkTerm "seychelles_PN" ;
lin seychellois_A = mkTerm "seychellois_A" ;
lin seychellois_N = mkTerm "seychellois_N" ;
lin sforzando_N = mkTerm "sforzando_N" ;
lin sgd_PN = mkTerm "sgd_PN" ;
lin sgraffito_N = mkTerm "sgraffito_N" ;
lin sgt_PN = mkTerm "sgt_PN" ;
lin shabbiness_N = mkTerm "shabbiness_N" ;
lin shabby_A = mkTerm "shabby_A" ;
lin shabby_genteel_A = mkTerm "shabby_genteel_A" ;
lin shack_N = mkTerm "shack_N" ;
lin shack_V = mkTerm "shack_V" ;
lin shack_up_V = mkTerm "shack_up_V" ;
lin shackle_N = mkTerm "shackle_N" ;
lin shackle_V2 = mkTerm "shackle_V2" ;
lin shad_N = mkTerm "shad_N" ;
lin shaddock_N = mkTerm "shaddock_N" ;
lin shade_N = mkTerm "shade_N" ;
lin shade_V = mkTerm "shade_V" ;
lin shade_V2 = mkTerm "shade_V2" ;
lin shade_in_V2 = mkTerm "shade_in_V2" ;
lin shade_tree_N = mkTerm "shade_tree_N" ;
lin shadiness_N = mkTerm "shadiness_N" ;
lin shading_N = mkTerm "shading_N" ;
lin shadow_N = mkTerm "shadow_N" ;
lin shadow_V2 = mkTerm "shadow_V2" ;
lin shadow_boxing_N = mkTerm "shadow_boxing_N" ;
lin shadowing_N = mkTerm "shadowing_N" ;
lin shadowy_A = mkTerm "shadowy_A" ;
lin shady_A = mkTerm "shady_A" ;
lin shaft_N = mkTerm "shaft_N" ;
lin shag_N = mkTerm "shag_N" ;
lin shag_V = mkTerm "shag_V" ;
lin shag_V2 = mkTerm "shag_V2" ;
lin shagbark_N = mkTerm "shagbark_N" ;
lin shagginess_N = mkTerm "shagginess_N" ;
lin shagging_N = mkTerm "shagging_N" ;
lin shaggy_A = mkTerm "shaggy_A" ;
lin shaggymane_N = mkTerm "shaggymane_N" ;
lin shah_N = mkTerm "shah_N" ;
lin shahadah_N = mkTerm "shahadah_N" ;
lin shaheed_N = mkTerm "shaheed_N" ;
lin shaitan_N = mkTerm "shaitan_N" ;
lin shakable_A = mkTerm "shakable_A" ;
lin shake_N = mkTerm "shake_N" ;
lin shake_V = mkTerm "shake_V" ;
lin shake_V2 = mkTerm "shake_V2" ;
lin shake_down_V2 = mkTerm "shake_down_V2" ;
lin shake_off_V2 = mkTerm "shake_off_V2" ;
lin shake_out_V2 = mkTerm "shake_out_V2" ;
lin shake_up_N = mkTerm "shake_up_N" ;
lin shake_up_V2 = mkTerm "shake_up_V2" ;
lin shakedown_A = mkTerm "shakedown_A" ;
lin shakedown_N = mkTerm "shakedown_N" ;
lin shakeout_N = mkTerm "shakeout_N" ;
lin shaker_N = mkTerm "shaker_N" ;
lin shakespearian_A = mkTerm "shakespearian_A" ;
lin shakiness_N = mkTerm "shakiness_N" ;
lin shaking_N = mkTerm "shaking_N" ;
lin shaky_A = mkTerm "shaky_A" ;
lin shale_N = mkTerm "shale_N" ;
lin shale_oil_N = mkTerm "shale_oil_N" ;
lin shall_VV = mkTerm "shall_VV" ;
lin shallot_N = mkTerm "shallot_N" ;
lin shallow_A = mkTerm "shallow_A" ;
lin shallow_N = mkTerm "shallow_N" ;
lin shallow_V = mkTerm "shallow_V" ;
lin shallowness_N = mkTerm "shallowness_N" ;
lin shallu_N = mkTerm "shallu_N" ;
lin sham_A = mkTerm "sham_A" ;
lin sham_N = mkTerm "sham_N" ;
lin sham_V = mkTerm "sham_V" ;
lin sham_V2 = mkTerm "sham_V2" ;
lin shaman_N = mkTerm "shaman_N" ;
lin shamanism_N = mkTerm "shamanism_N" ;
lin shamanist_A = mkTerm "shamanist_A" ;
lin shamble_N = mkTerm "shamble_N" ;
lin shamble_V = mkTerm "shamble_V" ;
lin shambles_N = mkTerm "shambles_N" ;
lin shambolic_A = mkTerm "shambolic_A" ;
lin shame_N = mkTerm "shame_N" ;
lin shame_V2 = mkTerm "shame_V2" ;
lin shame_making_A = mkTerm "shame_making_A" ;
lin shamefaced_A = mkTerm "shamefaced_A" ;
lin shamefacedness_N = mkTerm "shamefacedness_N" ;
lin shameful_A = mkTerm "shameful_A" ;
lin shamefulness_N = mkTerm "shamefulness_N" ;
lin shameless_A = mkTerm "shameless_A" ;
lin shamelessness_N = mkTerm "shamelessness_N" ;
lin shammy_N = mkTerm "shammy_N" ;
lin shampoo_N = mkTerm "shampoo_N" ;
lin shampoo_V2 = mkTerm "shampoo_V2" ;
lin shamrock_N = mkTerm "shamrock_N" ;
lin shandy_N = mkTerm "shandy_N" ;
lin shandygaff_N = mkTerm "shandygaff_N" ;
lin shanghai_PN = mkTerm "shanghai_PN" ;
lin shanghai_V2 = mkTerm "shanghai_V2" ;
lin shanghaier_N = mkTerm "shanghaier_N" ;
lin shank_N = mkTerm "shank_N" ;
lin shanklin_PN = mkTerm "shanklin_PN" ;
lin shanny_N = mkTerm "shanny_N" ;
lin shantung_N = mkTerm "shantung_N" ;
lin shanty_N = mkTerm "shanty_N" ;
lin shantytown_N = mkTerm "shantytown_N" ;
lin shape_N = mkTerm "shape_N" ;
lin shape_V = mkTerm "shape_V" ;
lin shape_V2 = mkTerm "shape_V2" ;
lin shape_VV = mkTerm "shape_VV" ;
lin shape_up_V = mkTerm "shape_up_V" ;
lin shapeless_A = mkTerm "shapeless_A" ;
lin shapelessness_N = mkTerm "shapelessness_N" ;
lin shapely_A = mkTerm "shapely_A" ;
lin shaper_N = mkTerm "shaper_N" ;
lin shaping_N = mkTerm "shaping_N" ;
lin shard_N = mkTerm "shard_N" ;
lin share_N = mkTerm "share_N" ;
lin share_V = mkTerm "share_V" ;
lin share_V2 = mkTerm "share_V2" ;
lin share_out_N = mkTerm "share_out_N" ;
lin share_out_V = mkTerm "share_out_V" ;
lin sharecropper_N = mkTerm "sharecropper_N" ;
lin shared_A = mkTerm "shared_A" ;
lin shareholder_N = mkTerm "shareholder_N" ;
lin shareholding_N = mkTerm "shareholding_N" ;
lin shareware_N = mkTerm "shareware_N" ;
lin shariah_N = mkTerm "shariah_N" ;
lin sharing_N = mkTerm "sharing_N" ;
lin shark_N = mkTerm "shark_N" ;
lin sharkskin_N = mkTerm "sharkskin_N" ;
lin sharksucker_N = mkTerm "sharksucker_N" ;
lin sharon_PN = mkTerm "sharon_PN" ;
lin sharp_A = mkTerm "sharp_A" ;
lin sharp_Adv = mkTerm "sharp_Adv" ;
lin sharp_N = mkTerm "sharp_N" ;
lin sharp_eyed_A = mkTerm "sharp_eyed_A" ;
lin sharp_set_A = mkTerm "sharp_set_A" ;
lin sharp_sighted_A = mkTerm "sharp_sighted_A" ;
lin sharp_witted_A = mkTerm "sharp_witted_A" ;
lin sharpen_V = mkTerm "sharpen_V" ;
lin sharpen_V2 = mkTerm "sharpen_V2" ;
lin sharpener_N = mkTerm "sharpener_N" ;
lin sharper_N = mkTerm "sharper_N" ;
lin sharpie_N = mkTerm "sharpie_N" ;
lin sharpness_N = mkTerm "sharpness_N" ;
lin sharpshooter_N = mkTerm "sharpshooter_N" ;
lin shatter_V = mkTerm "shatter_V" ;
lin shatter_V2 = mkTerm "shatter_V2" ;
lin shatterproof_A = mkTerm "shatterproof_A" ;
lin shave_N = mkTerm "shave_N" ;
lin shave_V = mkTerm "shave_V" ;
lin shave_V2 = mkTerm "shave_V2" ;
lin shave_away_V = mkTerm "shave_away_V" ;
lin shave_off_V2 = mkTerm "shave_off_V2" ;
lin shaven_A = mkTerm "shaven_A" ;
lin shaver_N = mkTerm "shaver_N" ;
lin shavian_A = mkTerm "shavian_A" ;
lin shavian_N = mkTerm "shavian_N" ;
lin shaving_brush_N = mkTerm "shaving_brush_N" ;
lin shawl_N = mkTerm "shawl_N" ;
lin shawm_N = mkTerm "shawm_N" ;
lin she_goat_N = mkTerm "she_goat_N" ;
lin sheaf_N = mkTerm "sheaf_N" ;
lin shear_N = mkTerm "shear_N" ;
lin shear_V2 = mkTerm "shear_V2" ;
lin shearer_N = mkTerm "shearer_N" ;
lin shearing_N = mkTerm "shearing_N" ;
lin shears_N = mkTerm "shears_N" ;
lin shearwater_N = mkTerm "shearwater_N" ;
lin sheath_N = mkTerm "sheath_N" ;
lin sheath_knife_N = mkTerm "sheath_knife_N" ;
lin sheathe_V2 = mkTerm "sheathe_V2" ;
lin sheathing_N = mkTerm "sheathing_N" ;
lin shebang_N = mkTerm "shebang_N" ;
lin shebeen_N = mkTerm "shebeen_N" ;
lin shed_N = mkTerm "shed_N" ;
lin shed_V2 = mkTerm "shed_V2" ;
lin shedder_N = mkTerm "shedder_N" ;
lin shedding_N = mkTerm "shedding_N" ;
lin sheen_N = mkTerm "sheen_N" ;
lin sheep_N = mkTerm "sheep_N" ;
lin sheepdog_N = mkTerm "sheepdog_N" ;
lin sheepfold_N = mkTerm "sheepfold_N" ;
lin sheepherder_N = mkTerm "sheepherder_N" ;
lin sheepish_A = mkTerm "sheepish_A" ;
lin sheepishness_N = mkTerm "sheepishness_N" ;
lin sheeplike_A = mkTerm "sheeplike_A" ;
lin sheepman_N = mkTerm "sheepman_N" ;
lin sheeprun_N = mkTerm "sheeprun_N" ;
lin sheepshank_N = mkTerm "sheepshank_N" ;
lin sheepshead_N = mkTerm "sheepshead_N" ;
lin sheepshearing_N = mkTerm "sheepshearing_N" ;
lin sheepskin_N = mkTerm "sheepskin_N" ;
lin sheepwalk_N = mkTerm "sheepwalk_N" ;
lin sheer_A = mkTerm "sheer_A" ;
lin sheer_Adv = mkTerm "sheer_Adv" ;
lin sheer_V = mkTerm "sheer_V" ;
lin sheerness_PN = mkTerm "sheerness_PN" ;
lin sheet_N = mkTerm "sheet_N" ;
lin sheet_anchor_N = mkTerm "sheet_anchor_N" ;
lin sheet_lightning_N = mkTerm "sheet_lightning_N" ;
lin sheeting_N = mkTerm "sheeting_N" ;
lin sheetlike_A = mkTerm "sheetlike_A" ;
lin sheffield_PN = mkTerm "sheffield_PN" ;
lin shegetz_N = mkTerm "shegetz_N" ;
lin sheik_N = mkTerm "sheik_N" ;
lin sheika_N = mkTerm "sheika_N" ;
lin sheikdom_N = mkTerm "sheikdom_N" ;
lin sheikh_N = mkTerm "sheikh_N" ;
lin sheikhdom_N = mkTerm "sheikhdom_N" ;
lin sheila_PN = mkTerm "sheila_PN" ;
lin shekel_N = mkTerm "shekel_N" ;
lin sheldrake_N = mkTerm "sheldrake_N" ;
lin shelduck_N = mkTerm "shelduck_N" ;
lin shelf_N = mkTerm "shelf_N" ;
lin shelfful_N = mkTerm "shelfful_N" ;
lin shelflike_A = mkTerm "shelflike_A" ;
lin shelford_PN = mkTerm "shelford_PN" ;
lin shell_N = mkTerm "shell_N" ;
lin shell_V = mkTerm "shell_V" ;
lin shell_V2 = mkTerm "shell_V2" ;
lin shell_out_V2 = mkTerm "shell_out_V2" ;
lin shell_shock_N = mkTerm "shell_shock_N" ;
lin shellac_N = mkTerm "shellac_N" ;
lin shellac_V2 = mkTerm "shellac_V2" ;
lin sheller_N = mkTerm "sheller_N" ;
lin shellfire_N = mkTerm "shellfire_N" ;
lin shellfish_N = mkTerm "shellfish_N" ;
lin shellflower_N = mkTerm "shellflower_N" ;
lin shellproof_A = mkTerm "shellproof_A" ;
lin shelter_N = mkTerm "shelter_N" ;
lin shelter_V = mkTerm "shelter_V" ;
lin shelter_V2 = mkTerm "shelter_V2" ;
lin shelve_V = mkTerm "shelve_V" ;
lin shelve_V2 = mkTerm "shelve_V2" ;
lin shelver_N = mkTerm "shelver_N" ;
lin shepherd_N = mkTerm "shepherd_N" ;
lin shepherd_V2 = mkTerm "shepherd_V2" ;
lin shepherdess_N = mkTerm "shepherdess_N" ;
lin shepshed_PN = mkTerm "shepshed_PN" ;
lin shepton_mallet_PN = mkTerm "shepton_mallet_PN" ;
lin sheraton_N = mkTerm "sheraton_N" ;
lin sherbert_N = mkTerm "sherbert_N" ;
lin sherbet_N = mkTerm "sherbet_N" ;
lin sherbourne_PN = mkTerm "sherbourne_PN" ;
lin sheriff_N = mkTerm "sheriff_N" ;
lin sheringham_PN = mkTerm "sheringham_PN" ;
lin sherry_N = mkTerm "sherry_N" ;
lin shetland_PN = mkTerm "shetland_PN" ;
lin shevington_PN = mkTerm "shevington_PN" ;
lin shew_V = mkTerm "shew_V" ;
lin shew_V2 = mkTerm "shew_V2" ;
lin shibboleth_N = mkTerm "shibboleth_N" ;
lin shield_N = mkTerm "shield_N" ;
lin shield_V2 = mkTerm "shield_V2" ;
lin shielding_N = mkTerm "shielding_N" ;
lin shift_N = mkTerm "shift_N" ;
lin shift_V = mkTerm "shift_V" ;
lin shift_V2 = mkTerm "shift_V2" ;
lin shiftiness_N = mkTerm "shiftiness_N" ;
lin shiftless_A = mkTerm "shiftless_A" ;
lin shiftlessness_N = mkTerm "shiftlessness_N" ;
lin shifty_A = mkTerm "shifty_A" ;
lin shigella_N = mkTerm "shigella_N" ;
lin shigellosis_N = mkTerm "shigellosis_N" ;
lin shihkiachwang_PN = mkTerm "shihkiachwang_PN" ;
lin shiitake_N = mkTerm "shiitake_N" ;
lin shiksa_N = mkTerm "shiksa_N" ;
lin shildon_PN = mkTerm "shildon_PN" ;
lin shill_N = mkTerm "shill_N" ;
lin shillelagh_N = mkTerm "shillelagh_N" ;
lin shilling_N = mkTerm "shilling_N" ;
lin shillyshally_N = mkTerm "shillyshally_N" ;
lin shillyshally_V = mkTerm "shillyshally_V" ;
lin shim_N = mkTerm "shim_N" ;
lin shimmer_N = mkTerm "shimmer_N" ;
lin shimmer_V = mkTerm "shimmer_V" ;
lin shimmery_A = mkTerm "shimmery_A" ;
lin shimmy_N = mkTerm "shimmy_N" ;
lin shin_N = mkTerm "shin_N" ;
lin shin_V = mkTerm "shin_V" ;
lin shinbone_N = mkTerm "shinbone_N" ;
lin shindig_N = mkTerm "shindig_N" ;
lin shindy_N = mkTerm "shindy_N" ;
lin shine_N = mkTerm "shine_N" ;
lin shine_V = mkTerm "shine_V" ;
lin shine_V2 = mkTerm "shine_V2" ;
lin shiner_N = mkTerm "shiner_N" ;
lin shingle_N = mkTerm "shingle_N" ;
lin shingle_V2 = mkTerm "shingle_V2" ;
lin shingler_N = mkTerm "shingler_N" ;
lin shingles_N = mkTerm "shingles_N" ;
lin shingling_N = mkTerm "shingling_N" ;
lin shingly_A = mkTerm "shingly_A" ;
lin shinguard_N = mkTerm "shinguard_N" ;
lin shininess_N = mkTerm "shininess_N" ;
lin shining_N = mkTerm "shining_N" ;
lin shinny_N = mkTerm "shinny_N" ;
lin shinplaster_N = mkTerm "shinplaster_N" ;
lin shiny_A = mkTerm "shiny_A" ;
lin ship's_chandler_N = mkTerm "ship's_chandler_N" ;
lin ship_N = mkTerm "ship_N" ;
lin ship_V = mkTerm "ship_V" ;
lin ship_V2 = mkTerm "ship_V2" ;
lin ship_breaker_N = mkTerm "ship_breaker_N" ;
lin ship_canal_N = mkTerm "ship_canal_N" ;
lin ship_in_V = mkTerm "ship_in_V" ;
lin ship_off_V2 = mkTerm "ship_off_V2" ;
lin ship_out_V = mkTerm "ship_out_V" ;
lin ship_out_V2 = mkTerm "ship_out_V2" ;
lin shipboard_A = mkTerm "shipboard_A" ;
lin shipbroker_N = mkTerm "shipbroker_N" ;
lin shipbuilder_N = mkTerm "shipbuilder_N" ;
lin shipbuilding_N = mkTerm "shipbuilding_N" ;
lin shipload_N = mkTerm "shipload_N" ;
lin shipmate_N = mkTerm "shipmate_N" ;
lin shipment_N = mkTerm "shipment_N" ;
lin shipowner_N = mkTerm "shipowner_N" ;
lin shipper_N = mkTerm "shipper_N" ;
lin shipping_N = mkTerm "shipping_N" ;
lin shipping_agent_N = mkTerm "shipping_agent_N" ;
lin shipping_office_N = mkTerm "shipping_office_N" ;
lin shipshape_A = mkTerm "shipshape_A" ;
lin shipshape_Adv = mkTerm "shipshape_Adv" ;
lin shipside_N = mkTerm "shipside_N" ;
lin shipway_N = mkTerm "shipway_N" ;
lin shipworm_N = mkTerm "shipworm_N" ;
lin shipwreck_N = mkTerm "shipwreck_N" ;
lin shipwreck_V = mkTerm "shipwreck_V" ;
lin shipwright_N = mkTerm "shipwright_N" ;
lin shipyard_N = mkTerm "shipyard_N" ;
lin shire_N = mkTerm "shire_N" ;
lin shirebrook_PN = mkTerm "shirebrook_PN" ;
lin shiremoor_PN = mkTerm "shiremoor_PN" ;
lin shirk_V = mkTerm "shirk_V" ;
lin shirk_V2 = mkTerm "shirk_V2" ;
lin shirker_N = mkTerm "shirker_N" ;
lin shirking_N = mkTerm "shirking_N" ;
lin shirley_PN = mkTerm "shirley_PN" ;
lin shirring_N = mkTerm "shirring_N" ;
lin shirt_N = mkTerm "shirt_N" ;
lin shirt_front_N = mkTerm "shirt_front_N" ;
lin shirtdress_N = mkTerm "shirtdress_N" ;
lin shirting_N = mkTerm "shirting_N" ;
lin shirtmaker_N = mkTerm "shirtmaker_N" ;
lin shirtsleeve_N = mkTerm "shirtsleeve_N" ;
lin shirtsleeves_N = mkTerm "shirtsleeves_N" ;
lin shirttail_N = mkTerm "shirttail_N" ;
lin shirtwaist_N = mkTerm "shirtwaist_N" ;
lin shirtwaister_N = mkTerm "shirtwaister_N" ;
lin shirty_A = mkTerm "shirty_A" ;
lin shish_kebab_N = mkTerm "shish_kebab_N" ;
lin shit_N = mkTerm "shit_N" ;
lin shit_V = mkTerm "shit_V" ;
lin shitless_A = mkTerm "shitless_A" ;
lin shittah_N = mkTerm "shittah_N" ;
lin shittimwood_N = mkTerm "shittimwood_N" ;
lin shiv_N = mkTerm "shiv_N" ;
lin shiva_N = mkTerm "shiva_N" ;
lin shivaree_N = mkTerm "shivaree_N" ;
lin shiver_N = mkTerm "shiver_N" ;
lin shiver_V = mkTerm "shiver_V" ;
lin shivery_A = mkTerm "shivery_A" ;
lin shmegegge_N = mkTerm "shmegegge_N" ;
lin shmooze_N = mkTerm "shmooze_N" ;
lin shoal_N = mkTerm "shoal_N" ;
lin shoal_V = mkTerm "shoal_V" ;
lin shock_Adv = mkTerm "shock_Adv" ;
lin shock_N = mkTerm "shock_N" ;
lin shock_V2 = mkTerm "shock_V2" ;
lin shock_brigade_N = mkTerm "shock_brigade_N" ;
lin shock_headed_A = mkTerm "shock_headed_A" ;
lin shock_worker_N = mkTerm "shock_worker_N" ;
lin shockable_A = mkTerm "shockable_A" ;
lin shocked_A = mkTerm "shocked_A" ;
lin shocker_N = mkTerm "shocker_N" ;
lin shocking_A = mkTerm "shocking_A" ;
lin shod_A = mkTerm "shod_A" ;
lin shoddiness_N = mkTerm "shoddiness_N" ;
lin shoddy_A = mkTerm "shoddy_A" ;
lin shoddy_N = mkTerm "shoddy_N" ;
lin shoe_N = mkTerm "shoe_N" ;
lin shoe_V2 = mkTerm "shoe_V2" ;
lin shoe_leather_N = mkTerm "shoe_leather_N" ;
lin shoebill_N = mkTerm "shoebill_N" ;
lin shoeblack_N = mkTerm "shoeblack_N" ;
lin shoebox_N = mkTerm "shoebox_N" ;
lin shoeful_N = mkTerm "shoeful_N" ;
lin shoehorn_N = mkTerm "shoehorn_N" ;
lin shoehorn_V2 = mkTerm "shoehorn_V2" ;
lin shoelace_N = mkTerm "shoelace_N" ;
lin shoemaker_N = mkTerm "shoemaker_N" ;
lin shoemaking_N = mkTerm "shoemaking_N" ;
lin shoeshine_N = mkTerm "shoeshine_N" ;
lin shoestring_N = mkTerm "shoestring_N" ;
lin shoetree_N = mkTerm "shoetree_N" ;
lin shofar_N = mkTerm "shofar_N" ;
lin shogi_N = mkTerm "shogi_N" ;
lin shogun_N = mkTerm "shogun_N" ;
lin shoji_N = mkTerm "shoji_N" ;
lin shoo_V = mkTerm "shoo_V" ;
lin shoo_V2 = mkTerm "shoo_V2" ;
lin shoofly_N = mkTerm "shoofly_N" ;
lin shook_N = mkTerm "shook_N" ;
lin shoot_N = mkTerm "shoot_N" ;
lin shoot_V = mkTerm "shoot_V" ;
lin shoot_V2 = mkTerm "shoot_V2" ;
lin shoot_away_V = mkTerm "shoot_away_V" ;
lin shoot_back_V = mkTerm "shoot_back_V" ;
lin shoot_for_V2 = mkTerm "shoot_for_V2" ;
lin shoot_off_V = mkTerm "shoot_off_V" ;
lin shoot_out_V = mkTerm "shoot_out_V" ;
lin shoot_up_V = mkTerm "shoot_up_V" ;
lin shoot_up_V2 = mkTerm "shoot_up_V2" ;
lin shooter_N = mkTerm "shooter_N" ;
lin shooting_N = mkTerm "shooting_N" ;
lin shooting_box_N = mkTerm "shooting_box_N" ;
lin shooting_brake_N = mkTerm "shooting_brake_N" ;
lin shooting_gallery_N = mkTerm "shooting_gallery_N" ;
lin shooting_range_N = mkTerm "shooting_range_N" ;
lin shooting_stick_N = mkTerm "shooting_stick_N" ;
lin shootout_N = mkTerm "shootout_N" ;
lin shop_N = mkTerm "shop_N" ;
lin shop_V = mkTerm "shop_V" ;
lin shop_around_V = mkTerm "shop_around_V" ;
lin shop_assistant_N = mkTerm "shop_assistant_N" ;
lin shop_bell_N = mkTerm "shop_bell_N" ;
lin shop_boy_N = mkTerm "shop_boy_N" ;
lin shop_front_N = mkTerm "shop_front_N" ;
lin shop_girl_N = mkTerm "shop_girl_N" ;
lin shop_steward_N = mkTerm "shop_steward_N" ;
lin shopaholic_N = mkTerm "shopaholic_N" ;
lin shopkeeper_N = mkTerm "shopkeeper_N" ;
lin shoplift_V = mkTerm "shoplift_V" ;
lin shoplift_V2 = mkTerm "shoplift_V2" ;
lin shoplifter_N = mkTerm "shoplifter_N" ;
lin shoplifting_N = mkTerm "shoplifting_N" ;
lin shopperFem_N = mkTerm "shopperFem_N" ;
lin shopperMasc_N = mkTerm "shopperMasc_N" ;
lin shopping_N = mkTerm "shopping_N" ;
lin shopsoiled_A = mkTerm "shopsoiled_A" ;
lin shopwalker_N = mkTerm "shopwalker_N" ;
lin shopwindow_N = mkTerm "shopwindow_N" ;
lin shopworn_A = mkTerm "shopworn_A" ;
lin shore_N = mkTerm "shore_N" ;
lin shore_V2 = mkTerm "shore_V2" ;
lin shore_up_V2 = mkTerm "shore_up_V2" ;
lin shorebird_N = mkTerm "shorebird_N" ;
lin shoreline_N = mkTerm "shoreline_N" ;
lin shoring_N = mkTerm "shoring_N" ;
lin shorn_V2 = mkTerm "shorn_V2" ;
lin short_A = mkTerm "short_A" ;
lin short_Adv = mkTerm "short_Adv" ;
lin short_N = mkTerm "short_N" ;
lin short_V = mkTerm "short_V" ;
lin short_V2 = mkTerm "short_V2" ;
lin short_change_V2 = mkTerm "short_change_V2" ;
lin short_circuit_N = mkTerm "short_circuit_N" ;
lin short_circuit_V = mkTerm "short_circuit_V" ;
lin short_circuit_V2 = mkTerm "short_circuit_V2" ;
lin short_dated_A = mkTerm "short_dated_A" ;
lin short_handed_A = mkTerm "short_handed_A" ;
lin short_lived_A = mkTerm "short_lived_A" ;
lin short_out_V = mkTerm "short_out_V" ;
lin short_range_A = mkTerm "short_range_A" ;
lin short_sighted_A = mkTerm "short_sighted_A" ;
lin short_tempered_A = mkTerm "short_tempered_A" ;
lin short_term_A = mkTerm "short_term_A" ;
lin short_winded_A = mkTerm "short_winded_A" ;
lin shortage_N = mkTerm "shortage_N" ;
lin shortbread_N = mkTerm "shortbread_N" ;
lin shortcake_N = mkTerm "shortcake_N" ;
lin shortcoming_N = mkTerm "shortcoming_N" ;
lin shortcut_N = mkTerm "shortcut_N" ;
lin shorten_V = mkTerm "shorten_V" ;
lin shorten_V2 = mkTerm "shorten_V2" ;
lin shortener_N = mkTerm "shortener_N" ;
lin shortening_N = mkTerm "shortening_N" ;
lin shortfall_N = mkTerm "shortfall_N" ;
lin shortgrass_N = mkTerm "shortgrass_N" ;
lin shorthand_A = mkTerm "shorthand_A" ;
lin shorthand_N = mkTerm "shorthand_N" ;
lin shorthorn_N = mkTerm "shorthorn_N" ;
lin shortia_N = mkTerm "shortia_N" ;
lin shortish_A = mkTerm "shortish_A" ;
lin shortlist_N = mkTerm "shortlist_N" ;
lin shortlist_V2 = mkTerm "shortlist_V2" ;
lin shortness_N = mkTerm "shortness_N" ;
lin shortstop_N = mkTerm "shortstop_N" ;
lin shortwave_N = mkTerm "shortwave_N" ;
lin shot_N = mkTerm "shot_N" ;
lin shot_down_V = mkTerm "shot_down_V" ;
lin shot_put_N = mkTerm "shot_put_N" ;
lin shot_tower_N = mkTerm "shot_tower_N" ;
lin shotgun_N = mkTerm "shotgun_N" ;
lin shotton_PN = mkTerm "shotton_PN" ;
lin shotts_PN = mkTerm "shotts_PN" ;
lin should_VV = mkTerm "should_VV" ;
lin shoulder_N = mkTerm "shoulder_N" ;
lin shoulder_V2 = mkTerm "shoulder_V2" ;
lin shoulder_blade_N = mkTerm "shoulder_blade_N" ;
lin shoulder_flash_N = mkTerm "shoulder_flash_N" ;
lin shoulder_strap_N = mkTerm "shoulder_strap_N" ;
lin shout_N = mkTerm "shout_N" ;
lin shout_V = mkTerm "shout_V" ;
lin shout_V2 = mkTerm "shout_V2" ;
lin shout_down_V2 = mkTerm "shout_down_V2" ;
lin shout_out_V2 = mkTerm "shout_out_V2" ;
lin shouting_N = mkTerm "shouting_N" ;
lin shove_N = mkTerm "shove_N" ;
lin shove_V = mkTerm "shove_V" ;
lin shove_V2 = mkTerm "shove_V2" ;
lin shove_ha'penny_N = mkTerm "shove_ha'penny_N" ;
lin shove_through_V = mkTerm "shove_through_V" ;
lin shovel_N = mkTerm "shovel_N" ;
lin shovel_V2 = mkTerm "shovel_V2" ;
lin shovel_board_N = mkTerm "shovel_board_N" ;
lin shoveler_N = mkTerm "shoveler_N" ;
lin shovelful_N = mkTerm "shovelful_N" ;
lin shovelhead_N = mkTerm "shovelhead_N" ;
lin show_N = mkTerm "show_N" ;
lin show_V = mkTerm "show_V" ;
lin show_V2 = mkTerm "show_V2" ;
lin show_VQ = mkTerm "show_VQ" ;
lin show_VS = mkTerm "show_VS" ;
lin show_around_V2 = mkTerm "show_around_V2" ;
lin show_business_N = mkTerm "show_business_N" ;
lin show_in_V2 = mkTerm "show_in_V2" ;
lin show_off_N = mkTerm "show_off_N" ;
lin show_off_V = mkTerm "show_off_V" ;
lin show_off_V2 = mkTerm "show_off_V2" ;
lin show_out_V2 = mkTerm "show_out_V2" ;
lin show_over_V3 = mkTerm "show_over_V3" ;
lin show_round_V2 = mkTerm "show_round_V2" ;
lin show_through_V = mkTerm "show_through_V" ;
lin show_up_V = mkTerm "show_up_V" ;
lin show_up_V2 = mkTerm "show_up_V2" ;
lin show_window_N = mkTerm "show_window_N" ;
lin showbiz_N = mkTerm "showbiz_N" ;
lin showboat_N = mkTerm "showboat_N" ;
lin showcase_N = mkTerm "showcase_N" ;
lin showdown_N = mkTerm "showdown_N" ;
lin shower_N = mkTerm "shower_N" ;
lin shower_V = mkTerm "shower_V" ;
lin shower_V2 = mkTerm "shower_V2" ;
lin shower_bath_N = mkTerm "shower_bath_N" ;
lin showerhead_N = mkTerm "showerhead_N" ;
lin showery_A = mkTerm "showery_A" ;
lin showgirl_N = mkTerm "showgirl_N" ;
lin showiness_N = mkTerm "showiness_N" ;
lin showing_N = mkTerm "showing_N" ;
lin showjumping_N = mkTerm "showjumping_N" ;
lin showman_N = mkTerm "showman_N" ;
lin showmanship_N = mkTerm "showmanship_N" ;
lin showplace_N = mkTerm "showplace_N" ;
lin showroom_N = mkTerm "showroom_N" ;
lin showy_A = mkTerm "showy_A" ;
lin shrapnel_N = mkTerm "shrapnel_N" ;
lin shred_N = mkTerm "shred_N" ;
lin shred_V2 = mkTerm "shred_V2" ;
lin shredder_N = mkTerm "shredder_N" ;
lin shrew_N = mkTerm "shrew_N" ;
lin shrew_mouse_N = mkTerm "shrew_mouse_N" ;
lin shrewd_A = mkTerm "shrewd_A" ;
lin shrewdness_N = mkTerm "shrewdness_N" ;
lin shrewish_A = mkTerm "shrewish_A" ;
lin shrewishness_N = mkTerm "shrewishness_N" ;
lin shrewsbury_PN = mkTerm "shrewsbury_PN" ;
lin shriek_N = mkTerm "shriek_N" ;
lin shriek_V = mkTerm "shriek_V" ;
lin shriek_V2 = mkTerm "shriek_V2" ;
lin shrift_N = mkTerm "shrift_N" ;
lin shrike_N = mkTerm "shrike_N" ;
lin shrill_A = mkTerm "shrill_A" ;
lin shrill_V = mkTerm "shrill_V" ;
lin shrill_V2 = mkTerm "shrill_V2" ;
lin shrilling_N = mkTerm "shrilling_N" ;
lin shrillness_N = mkTerm "shrillness_N" ;
lin shrimp_N = mkTerm "shrimp_N" ;
lin shrimp_V = mkTerm "shrimp_V" ;
lin shrimper_N = mkTerm "shrimper_N" ;
lin shrimpfish_N = mkTerm "shrimpfish_N" ;
lin shrine_N = mkTerm "shrine_N" ;
lin shrine_V2 = mkTerm "shrine_V2" ;
lin shrink_N = mkTerm "shrink_N" ;
lin shrink_V = mkTerm "shrink_V" ;
lin shrink_V2 = mkTerm "shrink_V2" ;
lin shrinkable_A = mkTerm "shrinkable_A" ;
lin shrinkage_N = mkTerm "shrinkage_N" ;
lin shrinking_N = mkTerm "shrinking_N" ;
lin shrive_V2 = mkTerm "shrive_V2" ;
lin shrivel_V = mkTerm "shrivel_V" ;
lin shrivel_V2 = mkTerm "shrivel_V2" ;
lin shriveled_A = mkTerm "shriveled_A" ;
lin shropshire_PN = mkTerm "shropshire_PN" ;
lin shroud_N = mkTerm "shroud_N" ;
lin shroud_V2 = mkTerm "shroud_V2" ;
lin shrove_tuesday_N = mkTerm "shrove_tuesday_N" ;
lin shrove_tuesday_PN = mkTerm "shrove_tuesday_PN" ;
lin shrub_N = mkTerm "shrub_N" ;
lin shrubbery_N = mkTerm "shrubbery_N" ;
lin shrubby_A = mkTerm "shrubby_A" ;
lin shrublet_N = mkTerm "shrublet_N" ;
lin shrug_N = mkTerm "shrug_N" ;
lin shrug_V2 = mkTerm "shrug_V2" ;
lin shrug_off_V2 = mkTerm "shrug_off_V2" ;
lin shtik_N = mkTerm "shtik_N" ;
lin shtikl_N = mkTerm "shtikl_N" ;
lin shuck_N = mkTerm "shuck_N" ;
lin shuck_V2 = mkTerm "shuck_V2" ;
lin shudder_N = mkTerm "shudder_N" ;
lin shudder_V = mkTerm "shudder_V" ;
lin shudderingly_Adv = mkTerm "shudderingly_Adv" ;
lin shuffle_N = mkTerm "shuffle_N" ;
lin shuffle_V = mkTerm "shuffle_V" ;
lin shuffle_V2 = mkTerm "shuffle_V2" ;
lin shuffleboard_N = mkTerm "shuffleboard_N" ;
lin shuffler_N = mkTerm "shuffler_N" ;
lin shufti_N = mkTerm "shufti_N" ;
lin shun_V2 = mkTerm "shun_V2" ;
lin shunt_N = mkTerm "shunt_N" ;
lin shunt_V = mkTerm "shunt_V" ;
lin shunt_V2 = mkTerm "shunt_V2" ;
lin shunter_N = mkTerm "shunter_N" ;
lin shush_V = mkTerm "shush_V" ;
lin shush_V2 = mkTerm "shush_V2" ;
lin shut_V2 = mkTerm "shut_V2" ;
lin shut_away_V2 = mkTerm "shut_away_V2" ;
lin shut_down_V2 = mkTerm "shut_down_V2" ;
lin shut_in_V2 = mkTerm "shut_in_V2" ;
lin shut_off_V = mkTerm "shut_off_V" ;
lin shut_off_V2 = mkTerm "shut_off_V2" ;
lin shut_out_V2 = mkTerm "shut_out_V2" ;
lin shut_out_of_V2 = mkTerm "shut_out_of_V2" ;
lin shut_up_V2 = mkTerm "shut_up_V2" ;
lin shut_yourself_away_V = mkTerm "shut_yourself_away_V" ;
lin shutdown_N = mkTerm "shutdown_N" ;
lin shuteye_N = mkTerm "shuteye_N" ;
lin shutout_N = mkTerm "shutout_N" ;
lin shutter_N = mkTerm "shutter_N" ;
lin shutter_V2 = mkTerm "shutter_V2" ;
lin shutterbug_N = mkTerm "shutterbug_N" ;
lin shutting_N = mkTerm "shutting_N" ;
lin shuttle_N = mkTerm "shuttle_N" ;
lin shuttle_V = mkTerm "shuttle_V" ;
lin shuttle_V2 = mkTerm "shuttle_V2" ;
lin shuttlecock_N = mkTerm "shuttlecock_N" ;
lin shy_A = mkTerm "shy_A" ;
lin shy_N = mkTerm "shy_N" ;
lin shy_V = mkTerm "shy_V" ;
lin shy_V2 = mkTerm "shy_V2" ;
lin shy_away_V = mkTerm "shy_away_V" ;
lin shy_away_from_V2 = mkTerm "shy_away_from_V2" ;
lin shyness_N = mkTerm "shyness_N" ;
lin shyster_N = mkTerm "shyster_N" ;
lin sial_N = mkTerm "sial_N" ;
lin sialadenitis_N = mkTerm "sialadenitis_N" ;
lin sialolith_N = mkTerm "sialolith_N" ;
lin siam_PN = mkTerm "siam_PN" ;
lin siamang_N = mkTerm "siamang_N" ;
lin siamese_A = mkTerm "siamese_A" ;
lin siamese_N = mkTerm "siamese_N" ;
lin sian_PN = mkTerm "sian_PN" ;
lin sibbo_PN = mkTerm "sibbo_PN" ;
lin siberian_A = mkTerm "siberian_A" ;
lin sibilant_A = mkTerm "sibilant_A" ;
lin sibilant_N = mkTerm "sibilant_N" ;
lin sibilation_N = mkTerm "sibilation_N" ;
lin sibling_N = mkTerm "sibling_N" ;
lin sibyl_N = mkTerm "sibyl_N" ;
lin sibylline_A = mkTerm "sibylline_A" ;
lin sic_Adv = mkTerm "sic_Adv" ;
lin sicilian_A = mkTerm "sicilian_A" ;
lin sicilian_N = mkTerm "sicilian_N" ;
lin sick_A = mkTerm "sick_A" ;
lin sick_N = mkTerm "sick_N" ;
lin sick_V2 = mkTerm "sick_V2" ;
lin sick_benefit_N = mkTerm "sick_benefit_N" ;
lin sick_berth_N = mkTerm "sick_berth_N" ;
lin sick_headache_N = mkTerm "sick_headache_N" ;
lin sick_leave_N = mkTerm "sick_leave_N" ;
lin sick_list_N = mkTerm "sick_list_N" ;
lin sick_parade_N = mkTerm "sick_parade_N" ;
lin sick_pay_N = mkTerm "sick_pay_N" ;
lin sick_room_N = mkTerm "sick_room_N" ;
lin sickbay_N = mkTerm "sickbay_N" ;
lin sickbed_N = mkTerm "sickbed_N" ;
lin sicken_V = mkTerm "sicken_V" ;
lin sicken_V2 = mkTerm "sicken_V2" ;
lin sickish_A = mkTerm "sickish_A" ;
lin sickle_N = mkTerm "sickle_N" ;
lin sicklepod_N = mkTerm "sicklepod_N" ;
lin sickly_A = mkTerm "sickly_A" ;
lin sickness_N = mkTerm "sickness_N" ;
lin sid_PN = mkTerm "sid_PN" ;
lin side_N = mkTerm "side_N" ;
lin side_V = mkTerm "side_V" ;
lin side_chapel_N = mkTerm "side_chapel_N" ;
lin side_dish_N = mkTerm "side_dish_N" ;
lin side_drum_N = mkTerm "side_drum_N" ;
lin side_face_Adv = mkTerm "side_face_Adv" ;
lin side_glance_N = mkTerm "side_glance_N" ;
lin side_road_N = mkTerm "side_road_N" ;
lin side_saddle_Adv = mkTerm "side_saddle_Adv" ;
lin side_saddle_N = mkTerm "side_saddle_N" ;
lin side_slip_N = mkTerm "side_slip_N" ;
lin side_slip_V = mkTerm "side_slip_V" ;
lin side_splitting_A = mkTerm "side_splitting_A" ;
lin side_stroke_N = mkTerm "side_stroke_N" ;
lin side_view_N = mkTerm "side_view_N" ;
lin side_with_V2 = mkTerm "side_with_V2" ;
lin sidearm_A = mkTerm "sidearm_A" ;
lin sidearm_Adv = mkTerm "sidearm_Adv" ;
lin sidebar_N = mkTerm "sidebar_N" ;
lin sideboard_N = mkTerm "sideboard_N" ;
lin sideburn_N = mkTerm "sideburn_N" ;
lin sidecar_N = mkTerm "sidecar_N" ;
lin sidekick_N = mkTerm "sidekick_N" ;
lin sidelight_N = mkTerm "sidelight_N" ;
lin sideline_N = mkTerm "sideline_N" ;
lin sideline_V = mkTerm "sideline_V" ;
lin sideline_V2 = mkTerm "sideline_V2" ;
lin sidelong_A = mkTerm "sidelong_A" ;
lin sidelong_Adv = mkTerm "sidelong_Adv" ;
lin sidereal_A = mkTerm "sidereal_A" ;
lin siderite_N = mkTerm "siderite_N" ;
lin sideroblast_N = mkTerm "sideroblast_N" ;
lin siderocyte_N = mkTerm "siderocyte_N" ;
lin sideropenia_N = mkTerm "sideropenia_N" ;
lin siderosis_N = mkTerm "siderosis_N" ;
lin sideshow_N = mkTerm "sideshow_N" ;
lin sidesman_N = mkTerm "sidesman_N" ;
lin sidestep_N = mkTerm "sidestep_N" ;
lin sidestep_V = mkTerm "sidestep_V" ;
lin sidestep_V2 = mkTerm "sidestep_V2" ;
lin sideswipe_N = mkTerm "sideswipe_N" ;
lin sidetrack_N = mkTerm "sidetrack_N" ;
lin sidetrack_V2 = mkTerm "sidetrack_V2" ;
lin sidewalk_N = mkTerm "sidewalk_N" ;
lin sidewall_N = mkTerm "sidewall_N" ;
lin sideward_Adv = mkTerm "sideward_Adv" ;
lin sidewards_Adv = mkTerm "sidewards_Adv" ;
lin sideway_Adv = mkTerm "sideway_Adv" ;
lin sideways_Adv = mkTerm "sideways_Adv" ;
lin sidewinder_N = mkTerm "sidewinder_N" ;
lin siding_N = mkTerm "siding_N" ;
lin sidle_V = mkTerm "sidle_V" ;
lin sidle_up_to_V2 = mkTerm "sidle_up_to_V2" ;
lin sidmouth_PN = mkTerm "sidmouth_PN" ;
lin sidney_PN = mkTerm "sidney_PN" ;
lin siege_N = mkTerm "siege_N" ;
lin sienna_N = mkTerm "sienna_N" ;
lin sierra_N = mkTerm "sierra_N" ;
lin sierra_leone_PN = mkTerm "sierra_leone_PN" ;
lin sierra_leonian_A = mkTerm "sierra_leonian_A" ;
lin sierra_leonian_N = mkTerm "sierra_leonian_N" ;
lin siesta_N = mkTerm "siesta_N" ;
lin sieve_N = mkTerm "sieve_N" ;
lin sieve_V2 = mkTerm "sieve_V2" ;
lin sievi_PN = mkTerm "sievi_PN" ;
lin sift_V = mkTerm "sift_V" ;
lin sift_V2 = mkTerm "sift_V2" ;
lin sift_through_V2 = mkTerm "sift_through_V2" ;
lin sifter_N = mkTerm "sifter_N" ;
lin sigeh_N = mkTerm "sigeh_N" ;
lin sigh_N = mkTerm "sigh_N" ;
lin sigh_V = mkTerm "sigh_V" ;
lin sigh_V2 = mkTerm "sigh_V2" ;
lin sigh_VS = mkTerm "sigh_VS" ;
lin sight_N = mkTerm "sight_N" ;
lin sight_V2 = mkTerm "sight_V2" ;
lin sighting_N = mkTerm "sighting_N" ;
lin sightless_A = mkTerm "sightless_A" ;
lin sightreader_N = mkTerm "sightreader_N" ;
lin sights_N = mkTerm "sights_N" ;
lin sightseeing_N = mkTerm "sightseeing_N" ;
lin sightseer_N = mkTerm "sightseer_N" ;
lin sigma_N = mkTerm "sigma_N" ;
lin sigmoid_A = mkTerm "sigmoid_A" ;
lin sigmoidectomy_N = mkTerm "sigmoidectomy_N" ;
lin sigmoidoscope_N = mkTerm "sigmoidoscope_N" ;
lin sigmoidoscopy_N = mkTerm "sigmoidoscopy_N" ;
lin sign_N = mkTerm "sign_N" ;
lin sign_V = mkTerm "sign_V" ;
lin sign_V2 = mkTerm "sign_V2" ;
lin sign_away_V2 = mkTerm "sign_away_V2" ;
lin sign_for_V3 = mkTerm "sign_for_V3" ;
lin sign_in_V = mkTerm "sign_in_V" ;
lin sign_in_V2 = mkTerm "sign_in_V2" ;
lin sign_into_V2 = mkTerm "sign_into_V2" ;
lin sign_off_V = mkTerm "sign_off_V" ;
lin sign_off_V2 = mkTerm "sign_off_V2" ;
lin sign_off_on_V2 = mkTerm "sign_off_on_V2" ;
lin sign_on_V = mkTerm "sign_on_V" ;
lin sign_on_V2 = mkTerm "sign_on_V2" ;
lin sign_on_with_V2 = mkTerm "sign_on_with_V2" ;
lin sign_out_V = mkTerm "sign_out_V" ;
lin sign_out_V2 = mkTerm "sign_out_V2" ;
lin sign_out_of_V2 = mkTerm "sign_out_of_V2" ;
lin sign_painter_N = mkTerm "sign_painter_N" ;
lin sign_up_V = mkTerm "sign_up_V" ;
lin sign_with_V2 = mkTerm "sign_with_V2" ;
lin signage_N = mkTerm "signage_N" ;
lin signal_A = mkTerm "signal_A" ;
lin signal_N = mkTerm "signal_N" ;
lin signal_V2 = mkTerm "signal_V2" ;
lin signal_VS = mkTerm "signal_VS" ;
lin signal_box_N = mkTerm "signal_box_N" ;
lin signale_V2 = mkTerm "signale_V2" ;
lin signale_VS = mkTerm "signale_VS" ;
lin signaler_N = mkTerm "signaler_N" ;
lin signalization_N = mkTerm "signalization_N" ;
lin signalize_V2 = mkTerm "signalize_V2" ;
lin signaller_N = mkTerm "signaller_N" ;
lin signalman_N = mkTerm "signalman_N" ;
lin signatory_N = mkTerm "signatory_N" ;
lin signature_N = mkTerm "signature_N" ;
lin signboard_N = mkTerm "signboard_N" ;
lin signer_N = mkTerm "signer_N" ;
lin signet_N = mkTerm "signet_N" ;
lin signet_ring_N = mkTerm "signet_ring_N" ;
lin significance_N = mkTerm "significance_N" ;
lin significant_A = mkTerm "significant_A" ;
lin signification_N = mkTerm "signification_N" ;
lin significative_A = mkTerm "significative_A" ;
lin signify_V = mkTerm "signify_V" ;
lin signify_V2 = mkTerm "signify_V2" ;
lin signor_N = mkTerm "signor_N" ;
lin signora_N = mkTerm "signora_N" ;
lin signore_N = mkTerm "signore_N" ;
lin signorina_N = mkTerm "signorina_N" ;
lin signpost_N = mkTerm "signpost_N" ;
lin signpost_V2 = mkTerm "signpost_V2" ;
lin siikainen_PN = mkTerm "siikainen_PN" ;
lin siikajoki_PN = mkTerm "siikajoki_PN" ;
lin siilinjärvi_PN = mkTerm "siilinjärvi_PN" ;
lin sikh_N = mkTerm "sikh_N" ;
lin silage_N = mkTerm "silage_N" ;
lin sild_N = mkTerm "sild_N" ;
lin sildenafil_N = mkTerm "sildenafil_N" ;
lin sileby_PN = mkTerm "sileby_PN" ;
lin silence_N = mkTerm "silence_N" ;
lin silence_V2 = mkTerm "silence_V2" ;
lin silencer_N = mkTerm "silencer_N" ;
lin silene_N = mkTerm "silene_N" ;
lin silent_A = mkTerm "silent_A" ;
lin silenus_N = mkTerm "silenus_N" ;
lin silesia_N = mkTerm "silesia_N" ;
lin silex_N = mkTerm "silex_N" ;
lin silhouette_N = mkTerm "silhouette_N" ;
lin silhouette_V2 = mkTerm "silhouette_V2" ;
lin silica_N = mkTerm "silica_N" ;
lin silicate_N = mkTerm "silicate_N" ;
lin siliceous_A = mkTerm "siliceous_A" ;
lin silicide_N = mkTerm "silicide_N" ;
lin silicle_N = mkTerm "silicle_N" ;
lin silicon_N = mkTerm "silicon_N" ;
lin silicone_N = mkTerm "silicone_N" ;
lin silicosis_N = mkTerm "silicosis_N" ;
lin silique_N = mkTerm "silique_N" ;
lin silk_N = mkTerm "silk_N" ;
lin silken_A = mkTerm "silken_A" ;
lin silkiness_N = mkTerm "silkiness_N" ;
lin silks_N = mkTerm "silks_N" ;
lin silkscreen_N = mkTerm "silkscreen_N" ;
lin silkworm_N = mkTerm "silkworm_N" ;
lin silky_A = mkTerm "silky_A" ;
lin sill_N = mkTerm "sill_N" ;
lin sillabub_N = mkTerm "sillabub_N" ;
lin silliness_N = mkTerm "silliness_N" ;
lin silly_A = mkTerm "silly_A" ;
lin silly_N = mkTerm "silly_N" ;
lin silo_N = mkTerm "silo_N" ;
lin siloxane_N = mkTerm "siloxane_N" ;
lin silsden_PN = mkTerm "silsden_PN" ;
lin silt_N = mkTerm "silt_N" ;
lin silt_V = mkTerm "silt_V" ;
lin silt_V2 = mkTerm "silt_V2" ;
lin silt_up_V = mkTerm "silt_up_V" ;
lin siltstone_N = mkTerm "siltstone_N" ;
lin silty_A = mkTerm "silty_A" ;
lin silurid_N = mkTerm "silurid_N" ;
lin silva_N = mkTerm "silva_N" ;
lin silvan_A = mkTerm "silvan_A" ;
lin silver_A = mkTerm "silver_A" ;
lin silver_N = mkTerm "silver_N" ;
lin silver_V = mkTerm "silver_V" ;
lin silver_V2 = mkTerm "silver_V2" ;
lin silver_fish_N = mkTerm "silver_fish_N" ;
lin silverback_N = mkTerm "silverback_N" ;
lin silverberry_N = mkTerm "silverberry_N" ;
lin silvern_A = mkTerm "silvern_A" ;
lin silverpoint_N = mkTerm "silverpoint_N" ;
lin silverrod_N = mkTerm "silverrod_N" ;
lin silverside_N = mkTerm "silverside_N" ;
lin silversides_N = mkTerm "silversides_N" ;
lin silversmith_N = mkTerm "silversmith_N" ;
lin silverspot_N = mkTerm "silverspot_N" ;
lin silversword_N = mkTerm "silversword_N" ;
lin silvervine_N = mkTerm "silvervine_N" ;
lin silverware_N = mkTerm "silverware_N" ;
lin silverweed_N = mkTerm "silverweed_N" ;
lin silverwork_N = mkTerm "silverwork_N" ;
lin silvery_A = mkTerm "silvery_A" ;
lin silvex_N = mkTerm "silvex_N" ;
lin silvia_PN = mkTerm "silvia_PN" ;
lin silviculture_N = mkTerm "silviculture_N" ;
lin sima_N = mkTerm "sima_N" ;
lin simazine_N = mkTerm "simazine_N" ;
lin simian_A = mkTerm "simian_A" ;
lin simian_N = mkTerm "simian_N" ;
lin similar_A = mkTerm "similar_A" ;
lin similarity_N = mkTerm "similarity_N" ;
lin simile_N = mkTerm "simile_N" ;
lin similitude_N = mkTerm "similitude_N" ;
lin simmer_N = mkTerm "simmer_N" ;
lin simmer_V = mkTerm "simmer_V" ;
lin simmer_V2 = mkTerm "simmer_V2" ;
lin simmer_down_V = mkTerm "simmer_down_V" ;
lin simnel_N = mkTerm "simnel_N" ;
lin simo_PN = mkTerm "simo_PN" ;
lin simon_PN = mkTerm "simon_PN" ;
lin simony_N = mkTerm "simony_N" ;
lin simoom_N = mkTerm "simoom_N" ;
lin simoon_N = mkTerm "simoon_N" ;
lin simpele_PN = mkTerm "simpele_PN" ;
lin simper_N = mkTerm "simper_N" ;
lin simper_V = mkTerm "simper_V" ;
lin simperer_N = mkTerm "simperer_N" ;
lin simperingly_Adv = mkTerm "simperingly_Adv" ;
lin simple_A = mkTerm "simple_A" ;
lin simple_N = mkTerm "simple_N" ;
lin simple_hearted_A = mkTerm "simple_hearted_A" ;
lin simple_minded_A = mkTerm "simple_minded_A" ;
lin simpleton_N = mkTerm "simpleton_N" ;
lin simplex_A = mkTerm "simplex_A" ;
lin simplicity_N = mkTerm "simplicity_N" ;
lin simplification_N = mkTerm "simplification_N" ;
lin simplify_V = mkTerm "simplify_V" ;
lin simplify_V2 = mkTerm "simplify_V2" ;
lin simplistic_A = mkTerm "simplistic_A" ;
lin simulacrum_N = mkTerm "simulacrum_N" ;
lin simulate_V2 = mkTerm "simulate_V2" ;
lin simulated_A = mkTerm "simulated_A" ;
lin simulation_N = mkTerm "simulation_N" ;
lin simulator_N = mkTerm "simulator_N" ;
lin simulcast_N = mkTerm "simulcast_N" ;
lin simultaneity_N = mkTerm "simultaneity_N" ;
lin simultaneous_A = mkTerm "simultaneous_A" ;
lin simultaneousness_N = mkTerm "simultaneousness_N" ;
lin simvastatin_N = mkTerm "simvastatin_N" ;
lin sin_N = mkTerm "sin_N" ;
lin sin_V = mkTerm "sin_V" ;
lin since_Adv = mkTerm "since_Adv" ;
lin since_Prep = mkTerm "since_Prep" ;
lin since_Subj = mkTerm "since_Subj" ;
lin since_then_Adv = mkTerm "since_then_Adv" ;
lin sincere_A = mkTerm "sincere_A" ;
lin sincerity_N = mkTerm "sincerity_N" ;
lin sinciput_N = mkTerm "sinciput_N" ;
lin sine_N = mkTerm "sine_N" ;
lin sine_die_Adv = mkTerm "sine_die_Adv" ;
lin sine_qua_non_N = mkTerm "sine_qua_non_N" ;
lin sinecure_N = mkTerm "sinecure_N" ;
lin sinew_N = mkTerm "sinew_N" ;
lin sinewy_A = mkTerm "sinewy_A" ;
lin sinful_A = mkTerm "sinful_A" ;
lin sinfulness_N = mkTerm "sinfulness_N" ;
lin sing_V = mkTerm "sing_V" ;
lin sing_V2 = mkTerm "sing_V2" ;
lin sing_along_V = mkTerm "sing_along_V" ;
lin sing_out_V = mkTerm "sing_out_V" ;
lin sing_up_V = mkTerm "sing_up_V" ;
lin singable_A = mkTerm "singable_A" ;
lin singalong_N = mkTerm "singalong_N" ;
lin singapore_PN = mkTerm "singapore_PN" ;
lin singaporeanFem_N = mkTerm "singaporeanFem_N" ;
lin singaporeanMasc_N = mkTerm "singaporeanMasc_N" ;
lin singaporean_A = mkTerm "singaporean_A" ;
lin singe_N = mkTerm "singe_N" ;
lin singe_V = mkTerm "singe_V" ;
lin singe_V2 = mkTerm "singe_V2" ;
lin singer_N = mkTerm "singer_N" ;
lin singhalese_A = mkTerm "singhalese_A" ;
lin singing_N = mkTerm "singing_N" ;
lin single_1_A = mkTerm "single_1_A" ;
lin single_2_A = mkTerm "single_2_A" ;
lin single_N = mkTerm "single_N" ;
lin single_V2 = mkTerm "single_V2" ;
lin single_breasted_A = mkTerm "single_breasted_A" ;
lin single_handed_A = mkTerm "single_handed_A" ;
lin single_handed_Adv = mkTerm "single_handed_Adv" ;
lin single_minded_A = mkTerm "single_minded_A" ;
lin single_out_V2 = mkTerm "single_out_V2" ;
lin single_spacing_N = mkTerm "single_spacing_N" ;
lin singleness_N = mkTerm "singleness_N" ;
lin singles_N = mkTerm "singles_N" ;
lin singlestick_N = mkTerm "singlestick_N" ;
lin singlet_N = mkTerm "singlet_N" ;
lin singleton_N = mkTerm "singleton_N" ;
lin singly_Adv = mkTerm "singly_Adv" ;
lin singsong_N = mkTerm "singsong_N" ;
lin singular_A = mkTerm "singular_A" ;
lin singular_N = mkTerm "singular_N" ;
lin singularity_N = mkTerm "singularity_N" ;
lin singularize_V2 = mkTerm "singularize_V2" ;
lin sinhala_N = mkTerm "sinhala_N" ;
lin sinhalese_A = mkTerm "sinhalese_A" ;
lin sinhalese_N = mkTerm "sinhalese_N" ;
lin sining_PN = mkTerm "sining_PN" ;
lin sinister_A = mkTerm "sinister_A" ;
lin sinistral_A = mkTerm "sinistral_A" ;
lin sinistrorse_A = mkTerm "sinistrorse_A" ;
lin sink_N = mkTerm "sink_N" ;
lin sink_V = mkTerm "sink_V" ;
lin sink_V2 = mkTerm "sink_V2" ;
lin sink_in_V = mkTerm "sink_in_V" ;
lin sinkable_A = mkTerm "sinkable_A" ;
lin sinker_N = mkTerm "sinker_N" ;
lin sinkhole_N = mkTerm "sinkhole_N" ;
lin sinking_N = mkTerm "sinking_N" ;
lin sinking_fund_N = mkTerm "sinking_fund_N" ;
lin sinless_A = mkTerm "sinless_A" ;
lin sinlessness_N = mkTerm "sinlessness_N" ;
lin sinn_fein_PN = mkTerm "sinn_fein_PN" ;
lin sinner_N = mkTerm "sinner_N" ;
lin sinologist_N = mkTerm "sinologist_N" ;
lin sinology_N = mkTerm "sinology_N" ;
lin sinopis_N = mkTerm "sinopis_N" ;
lin sintered_A = mkTerm "sintered_A" ;
lin sinuate_A = mkTerm "sinuate_A" ;
lin sinuosity_N = mkTerm "sinuosity_N" ;
lin sinuous_A = mkTerm "sinuous_A" ;
lin sinus_N = mkTerm "sinus_N" ;
lin sinusitis_N = mkTerm "sinusitis_N" ;
lin sinusoid_N = mkTerm "sinusoid_N" ;
lin sinusoidal_A = mkTerm "sinusoidal_A" ;
lin sioux_N = mkTerm "sioux_N" ;
lin sip_N = mkTerm "sip_N" ;
lin sip_V = mkTerm "sip_V" ;
lin sip_V2 = mkTerm "sip_V2" ;
lin siphon_N = mkTerm "siphon_N" ;
lin siphon_V = mkTerm "siphon_V" ;
lin siphon_V2 = mkTerm "siphon_V2" ;
lin siphone_off_V = mkTerm "siphone_off_V" ;
lin siphonophore_N = mkTerm "siphonophore_N" ;
lin sipper_N = mkTerm "sipper_N" ;
lin sir_N = mkTerm "sir_N" ;
lin sir_roger_de_coverley_N = mkTerm "sir_roger_de_coverley_N" ;
lin siracusa_PN = mkTerm "siracusa_PN" ;
lin sirdar_N = mkTerm "sirdar_N" ;
lin sire_N = mkTerm "sire_N" ;
lin sire_V2 = mkTerm "sire_V2" ;
lin siren_N = mkTerm "siren_N" ;
lin siris_N = mkTerm "siris_N" ;
lin sirloin_N = mkTerm "sirloin_N" ;
lin sirocco_N = mkTerm "sirocco_N" ;
lin sirrah_N = mkTerm "sirrah_N" ;
lin sirup_N = mkTerm "sirup_N" ;
lin sisal_N = mkTerm "sisal_N" ;
lin siskin_N = mkTerm "siskin_N" ;
lin sissified_A = mkTerm "sissified_A" ;
lin sissoo_N = mkTerm "sissoo_N" ;
lin sissy_N = mkTerm "sissy_N" ;
lin sister_N = mkTerm "sister_N" ;
lin sister_in_law_N = mkTerm "sister_in_law_N" ;
lin sisterhood_N = mkTerm "sisterhood_N" ;
lin sisterly_A = mkTerm "sisterly_A" ;
lin siswati_N = mkTerm "siswati_N" ;
lin sit_V = mkTerm "sit_V" ;
lin sit_V2 = mkTerm "sit_V2" ;
lin sit_about_V = mkTerm "sit_about_V" ;
lin sit_around_V = mkTerm "sit_around_V" ;
lin sit_back_V = mkTerm "sit_back_V" ;
lin sit_by_V = mkTerm "sit_by_V" ;
lin sit_down_V2 = mkTerm "sit_down_V2" ;
lin sit_for_V2 = mkTerm "sit_for_V2" ;
lin sit_in_N = mkTerm "sit_in_N" ;
lin sit_in_V2 = mkTerm "sit_in_V2" ;
lin sit_in_for_V2 = mkTerm "sit_in_for_V2" ;
lin sit_in_on_V2 = mkTerm "sit_in_on_V2" ;
lin sit_on_V2 = mkTerm "sit_on_V2" ;
lin sit_out_V2 = mkTerm "sit_out_V2" ;
lin sit_over_V2 = mkTerm "sit_over_V2" ;
lin sit_through_V2 = mkTerm "sit_through_V2" ;
lin sit_up_V = mkTerm "sit_up_V" ;
lin sit_with_V2 = mkTerm "sit_with_V2" ;
lin sitar_N = mkTerm "sitar_N" ;
lin sitcom_N = mkTerm "sitcom_N" ;
lin site_N = mkTerm "site_N" ;
lin site_V = mkTerm "site_V" ;
lin sitter_N = mkTerm "sitter_N" ;
lin sitting_N = mkTerm "sitting_N" ;
lin sitting_room_N = mkTerm "sitting_room_N" ;
lin sittingbourne_PN = mkTerm "sittingbourne_PN" ;
lin situate_V2 = mkTerm "situate_V2" ;
lin situation_N = mkTerm "situation_N" ;
lin siuntio_PN = mkTerm "siuntio_PN" ;
lin six_footer_N = mkTerm "six_footer_N" ;
lin six_shooter_N = mkTerm "six_shooter_N" ;
lin sixfold_A = mkTerm "sixfold_A" ;
lin sixfold_Adv = mkTerm "sixfold_Adv" ;
lin sixpence_N = mkTerm "sixpence_N" ;
lin sixpenny_A = mkTerm "sixpenny_A" ;
lin sixth_former_N = mkTerm "sixth_former_N" ;
lin sizable_A = mkTerm "sizable_A" ;
lin size_A = mkTerm "size_A" ;
lin size_N = mkTerm "size_N" ;
lin size_V2 = mkTerm "size_V2" ;
lin size_up_V2 = mkTerm "size_up_V2" ;
lin sizeable_A = mkTerm "sizeable_A" ;
lin sizzle_N = mkTerm "sizzle_N" ;
lin sizzle_V = mkTerm "sizzle_V" ;
lin skank_N = mkTerm "skank_N" ;
lin skate_N = mkTerm "skate_N" ;
lin skate_V = mkTerm "skate_V" ;
lin skateboard_N = mkTerm "skateboard_N" ;
lin skateboarder_N = mkTerm "skateboarder_N" ;
lin skateboarding_A = mkTerm "skateboarding_A" ;
lin skateboarding_N = mkTerm "skateboarding_N" ;
lin skater_N = mkTerm "skater_N" ;
lin skating_N = mkTerm "skating_N" ;
lin skating_rink_N = mkTerm "skating_rink_N" ;
lin skedaddle_N = mkTerm "skedaddle_N" ;
lin skedaddle_V = mkTerm "skedaddle_V" ;
lin skeet_N = mkTerm "skeet_N" ;
lin skeg_N = mkTerm "skeg_N" ;
lin skegness_PN = mkTerm "skegness_PN" ;
lin skein_N = mkTerm "skein_N" ;
lin skeletal_A = mkTerm "skeletal_A" ;
lin skeleton_N = mkTerm "skeleton_N" ;
lin skelmanthorpe_PN = mkTerm "skelmanthorpe_PN" ;
lin skelmersdale_PN = mkTerm "skelmersdale_PN" ;
lin skep_N = mkTerm "skep_N" ;
lin skepful_N = mkTerm "skepful_N" ;
lin skeptic_N = mkTerm "skeptic_N" ;
lin skeptical_A = mkTerm "skeptical_A" ;
lin skepticism_N = mkTerm "skepticism_N" ;
lin sketch_N = mkTerm "sketch_N" ;
lin sketch_V = mkTerm "sketch_V" ;
lin sketch_V2 = mkTerm "sketch_V2" ;
lin sketch_block_N = mkTerm "sketch_block_N" ;
lin sketch_book_N = mkTerm "sketch_book_N" ;
lin sketch_map_N = mkTerm "sketch_map_N" ;
lin sketcher_N = mkTerm "sketcher_N" ;
lin sketchiness_N = mkTerm "sketchiness_N" ;
lin sketchy_A = mkTerm "sketchy_A" ;
lin skew_A = mkTerm "skew_A" ;
lin skew_V2 = mkTerm "skew_V2" ;
lin skew_eyed_A = mkTerm "skew_eyed_A" ;
lin skewen_PN = mkTerm "skewen_PN" ;
lin skewer_N = mkTerm "skewer_N" ;
lin skewer_V2 = mkTerm "skewer_V2" ;
lin ski_N = mkTerm "ski_N" ;
lin ski_V = mkTerm "ski_V" ;
lin ski_bob_N = mkTerm "ski_bob_N" ;
lin ski_jump_N = mkTerm "ski_jump_N" ;
lin ski_lift_N = mkTerm "ski_lift_N" ;
lin ski_plane_N = mkTerm "ski_plane_N" ;
lin skid_N = mkTerm "skid_N" ;
lin skid_V = mkTerm "skid_V" ;
lin skid_V2 = mkTerm "skid_V2" ;
lin skidder_N = mkTerm "skidder_N" ;
lin skidpan_N = mkTerm "skidpan_N" ;
lin skier_N = mkTerm "skier_N" ;
lin skiff_N = mkTerm "skiff_N" ;
lin skiffle_N = mkTerm "skiffle_N" ;
lin skiffle_group_N = mkTerm "skiffle_group_N" ;
lin skiing_N = mkTerm "skiing_N" ;
lin skilful_A = mkTerm "skilful_A" ;
lin skill_N = mkTerm "skill_N" ;
lin skill_V = mkTerm "skill_V" ;
lin skilled_A = mkTerm "skilled_A" ;
lin skillet_N = mkTerm "skillet_N" ;
lin skillful_A = mkTerm "skillful_A" ;
lin skillfulness_N = mkTerm "skillfulness_N" ;
lin skilly_N = mkTerm "skilly_N" ;
lin skim_A = mkTerm "skim_A" ;
lin skim_N = mkTerm "skim_N" ;
lin skim_V = mkTerm "skim_V" ;
lin skim_V2 = mkTerm "skim_V2" ;
lin skimmed_milk_N = mkTerm "skimmed_milk_N" ;
lin skimmer_N = mkTerm "skimmer_N" ;
lin skimming_N = mkTerm "skimming_N" ;
lin skimp_V = mkTerm "skimp_V" ;
lin skimp_V2 = mkTerm "skimp_V2" ;
lin skimpy_A = mkTerm "skimpy_A" ;
lin skin_N = mkTerm "skin_N" ;
lin skin_V = mkTerm "skin_V" ;
lin skin_V2 = mkTerm "skin_V2" ;
lin skin_deep_A = mkTerm "skin_deep_A" ;
lin skin_diving_N = mkTerm "skin_diving_N" ;
lin skin_graft_N = mkTerm "skin_graft_N" ;
lin skin_tight_A = mkTerm "skin_tight_A" ;
lin skin_up_V = mkTerm "skin_up_V" ;
lin skin_up_V2 = mkTerm "skin_up_V2" ;
lin skinflint_N = mkTerm "skinflint_N" ;
lin skinful_N = mkTerm "skinful_N" ;
lin skinhead_N = mkTerm "skinhead_N" ;
lin skinheads_N = mkTerm "skinheads_N" ;
lin skink_N = mkTerm "skink_N" ;
lin skinless_A = mkTerm "skinless_A" ;
lin skinner_N = mkTerm "skinner_N" ;
lin skinniness_N = mkTerm "skinniness_N" ;
lin skinny_A = mkTerm "skinny_A" ;
lin skinny_N = mkTerm "skinny_N" ;
lin skint_A = mkTerm "skint_A" ;
lin skintight_A = mkTerm "skintight_A" ;
lin skip_N = mkTerm "skip_N" ;
lin skip_V = mkTerm "skip_V" ;
lin skip_V2 = mkTerm "skip_V2" ;
lin skip_off_V = mkTerm "skip_off_V" ;
lin skipjack_N = mkTerm "skipjack_N" ;
lin skipper_N = mkTerm "skipper_N" ;
lin skipper_V2 = mkTerm "skipper_V2" ;
lin skipping_rope_N = mkTerm "skipping_rope_N" ;
lin skipton_PN = mkTerm "skipton_PN" ;
lin skirl_N = mkTerm "skirl_N" ;
lin skirmish_N = mkTerm "skirmish_N" ;
lin skirmish_V = mkTerm "skirmish_V" ;
lin skirmisher_N = mkTerm "skirmisher_N" ;
lin skirret_N = mkTerm "skirret_N" ;
lin skirt_N = mkTerm "skirt_N" ;
lin skirt_V = mkTerm "skirt_V" ;
lin skirt_V2 = mkTerm "skirt_V2" ;
lin skirting_board_N = mkTerm "skirting_board_N" ;
lin skit_N = mkTerm "skit_N" ;
lin skitter_V = mkTerm "skitter_V" ;
lin skittish_A = mkTerm "skittish_A" ;
lin skittishness_N = mkTerm "skittishness_N" ;
lin skittle_N = mkTerm "skittle_N" ;
lin skittle_V2 = mkTerm "skittle_V2" ;
lin skittle_pin_N = mkTerm "skittle_pin_N" ;
lin skittles_N = mkTerm "skittles_N" ;
lin skive_off_V = mkTerm "skive_off_V" ;
lin skivvy_N = mkTerm "skivvy_N" ;
lin skopje_PN = mkTerm "skopje_PN" ;
lin skua_N = mkTerm "skua_N" ;
lin skulk_V = mkTerm "skulk_V" ;
lin skulker_N = mkTerm "skulker_N" ;
lin skull_N = mkTerm "skull_N" ;
lin skullcap_N = mkTerm "skullcap_N" ;
lin skullduggery_N = mkTerm "skullduggery_N" ;
lin skulled_A = mkTerm "skulled_A" ;
lin skunk_N = mkTerm "skunk_N" ;
lin skunkweed_N = mkTerm "skunkweed_N" ;
lin sky_N = mkTerm "sky_N" ;
lin sky_V2 = mkTerm "sky_V2" ;
lin sky_blue_A = mkTerm "sky_blue_A" ;
lin sky_blue_N = mkTerm "sky_blue_N" ;
lin sky_high_Adv = mkTerm "sky_high_Adv" ;
lin skybox_N = mkTerm "skybox_N" ;
lin skycap_N = mkTerm "skycap_N" ;
lin skydiver_N = mkTerm "skydiver_N" ;
lin skydiving_N = mkTerm "skydiving_N" ;
lin skyhook_N = mkTerm "skyhook_N" ;
lin skylark_N = mkTerm "skylark_N" ;
lin skylark_V = mkTerm "skylark_V" ;
lin skylight_N = mkTerm "skylight_N" ;
lin skyline_N = mkTerm "skyline_N" ;
lin skyrocket_N = mkTerm "skyrocket_N" ;
lin skyrocket_V = mkTerm "skyrocket_V" ;
lin skyrocket_V2 = mkTerm "skyrocket_V2" ;
lin skysail_N = mkTerm "skysail_N" ;
lin skyscraper_N = mkTerm "skyscraper_N" ;
lin skywalk_N = mkTerm "skywalk_N" ;
lin skyward_A = mkTerm "skyward_A" ;
lin skyward_Adv = mkTerm "skyward_Adv" ;
lin skywards_A = mkTerm "skywards_A" ;
lin skywards_Adv = mkTerm "skywards_Adv" ;
lin skywriting_N = mkTerm "skywriting_N" ;
lin slab_N = mkTerm "slab_N" ;
lin slack_A = mkTerm "slack_A" ;
lin slack_N = mkTerm "slack_N" ;
lin slack_V = mkTerm "slack_V" ;
lin slack_off_V = mkTerm "slack_off_V" ;
lin slacken_V = mkTerm "slacken_V" ;
lin slacken_V2 = mkTerm "slacken_V2" ;
lin slacken_off_V = mkTerm "slacken_off_V" ;
lin slacker_N = mkTerm "slacker_N" ;
lin slackness_N = mkTerm "slackness_N" ;
lin slacks_N = mkTerm "slacks_N" ;
lin slag_N = mkTerm "slag_N" ;
lin slag_heap_N = mkTerm "slag_heap_N" ;
lin slag_off_V2 = mkTerm "slag_off_V2" ;
lin slain_N = mkTerm "slain_N" ;
lin slake_V2 = mkTerm "slake_V2" ;
lin slalom_N = mkTerm "slalom_N" ;
lin slam_N = mkTerm "slam_N" ;
lin slam_V = mkTerm "slam_V" ;
lin slam_V2 = mkTerm "slam_V2" ;
lin slam_dunk_V2 = mkTerm "slam_dunk_V2" ;
lin slammer_N = mkTerm "slammer_N" ;
lin slander_N = mkTerm "slander_N" ;
lin slander_V2 = mkTerm "slander_V2" ;
lin slanderer_N = mkTerm "slanderer_N" ;
lin slanderous_A = mkTerm "slanderous_A" ;
lin slang_N = mkTerm "slang_N" ;
lin slang_V2 = mkTerm "slang_V2" ;
lin slanginess_N = mkTerm "slanginess_N" ;
lin slanguage_N = mkTerm "slanguage_N" ;
lin slangy_A = mkTerm "slangy_A" ;
lin slant_N = mkTerm "slant_N" ;
lin slant_V = mkTerm "slant_V" ;
lin slant_V2 = mkTerm "slant_V2" ;
lin slant_toward_V2 = mkTerm "slant_toward_V2" ;
lin slantingly_Adv = mkTerm "slantingly_Adv" ;
lin slantwise_Adv = mkTerm "slantwise_Adv" ;
lin slap_Adv = mkTerm "slap_Adv" ;
lin slap_N = mkTerm "slap_N" ;
lin slap_V2 = mkTerm "slap_V2" ;
lin slap_bang_Adv = mkTerm "slap_bang_Adv" ;
lin slap_happy_A = mkTerm "slap_happy_A" ;
lin slap_up_A = mkTerm "slap_up_A" ;
lin slapdash_A = mkTerm "slapdash_A" ;
lin slapdash_Adv = mkTerm "slapdash_Adv" ;
lin slapper_N = mkTerm "slapper_N" ;
lin slapshot_N = mkTerm "slapshot_N" ;
lin slapstick_A = mkTerm "slapstick_A" ;
lin slapstick_N = mkTerm "slapstick_N" ;
lin slash_N = mkTerm "slash_N" ;
lin slash_V = mkTerm "slash_V" ;
lin slash_V2 = mkTerm "slash_V2" ;
lin slasher_N = mkTerm "slasher_N" ;
lin slat_N = mkTerm "slat_N" ;
lin slate_N = mkTerm "slate_N" ;
lin slate_V2 = mkTerm "slate_V2" ;
lin slate_V2V = mkTerm "slate_V2V" ;
lin slate_club_N = mkTerm "slate_club_N" ;
lin slate_pencil_N = mkTerm "slate_pencil_N" ;
lin slating_N = mkTerm "slating_N" ;
lin slatted_A = mkTerm "slatted_A" ;
lin slattern_N = mkTerm "slattern_N" ;
lin slatternliness_N = mkTerm "slatternliness_N" ;
lin slatternly_A = mkTerm "slatternly_A" ;
lin slaty_A = mkTerm "slaty_A" ;
lin slaughter_N = mkTerm "slaughter_N" ;
lin slaughter_V2 = mkTerm "slaughter_V2" ;
lin slaughterer_N = mkTerm "slaughterer_N" ;
lin slaughterhouse_N = mkTerm "slaughterhouse_N" ;
lin slav_A = mkTerm "slav_A" ;
lin slav_N = mkTerm "slav_N" ;
lin slave_N = mkTerm "slave_N" ;
lin slave_V = mkTerm "slave_V" ;
lin slave_driver_N = mkTerm "slave_driver_N" ;
lin slave_trade_N = mkTerm "slave_trade_N" ;
lin slave_traffic_N = mkTerm "slave_traffic_N" ;
lin slaveholder_N = mkTerm "slaveholder_N" ;
lin slaveholding_A = mkTerm "slaveholding_A" ;
lin slavelike_A = mkTerm "slavelike_A" ;
lin slaver_N = mkTerm "slaver_N" ;
lin slaver_V = mkTerm "slaver_V" ;
lin slavery_N = mkTerm "slavery_N" ;
lin slavey_N = mkTerm "slavey_N" ;
lin slavish_A = mkTerm "slavish_A" ;
lin slavonic_A = mkTerm "slavonic_A" ;
lin slaw_N = mkTerm "slaw_N" ;
lin slay_V2 = mkTerm "slay_V2" ;
lin slayer_N = mkTerm "slayer_N" ;
lin sleaford_PN = mkTerm "sleaford_PN" ;
lin sleaziness_N = mkTerm "sleaziness_N" ;
lin sleazy_A = mkTerm "sleazy_A" ;
lin sled_N = mkTerm "sled_N" ;
lin sledder_N = mkTerm "sledder_N" ;
lin sledding_N = mkTerm "sledding_N" ;
lin sledge_N = mkTerm "sledge_N" ;
lin sledge_V = mkTerm "sledge_V" ;
lin sledge_V2 = mkTerm "sledge_V2" ;
lin sledgehammer_N = mkTerm "sledgehammer_N" ;
lin sleek_A = mkTerm "sleek_A" ;
lin sleek_V2 = mkTerm "sleek_V2" ;
lin sleekness_N = mkTerm "sleekness_N" ;
lin sleep_N = mkTerm "sleep_N" ;
lin sleep_V = mkTerm "sleep_V" ;
lin sleep_in_V = mkTerm "sleep_in_V" ;
lin sleep_off_V2 = mkTerm "sleep_off_V2" ;
lin sleep_on_V2 = mkTerm "sleep_on_V2" ;
lin sleep_over_V = mkTerm "sleep_over_V" ;
lin sleep_through_V2 = mkTerm "sleep_through_V2" ;
lin sleeper_N = mkTerm "sleeper_N" ;
lin sleepiness_N = mkTerm "sleepiness_N" ;
lin sleeping_A = mkTerm "sleeping_A" ;
lin sleeping_N = mkTerm "sleeping_N" ;
lin sleeping_bag_N = mkTerm "sleeping_bag_N" ;
lin sleeping_car_N = mkTerm "sleeping_car_N" ;
lin sleeping_draught_N = mkTerm "sleeping_draught_N" ;
lin sleeping_pill_N = mkTerm "sleeping_pill_N" ;
lin sleeping_sickness_N = mkTerm "sleeping_sickness_N" ;
lin sleepless_A = mkTerm "sleepless_A" ;
lin sleeplessness_N = mkTerm "sleeplessness_N" ;
lin sleepover_N = mkTerm "sleepover_N" ;
lin sleepwalker_N = mkTerm "sleepwalker_N" ;
lin sleepwalking_N = mkTerm "sleepwalking_N" ;
lin sleepy_A = mkTerm "sleepy_A" ;
lin sleepy_head_N = mkTerm "sleepy_head_N" ;
lin sleet_N = mkTerm "sleet_N" ;
lin sleet_V = mkTerm "sleet_V" ;
lin sleety_A = mkTerm "sleety_A" ;
lin sleeve_N = mkTerm "sleeve_N" ;
lin sleeved_A = mkTerm "sleeved_A" ;
lin sleeveless_A = mkTerm "sleeveless_A" ;
lin sleigh_N = mkTerm "sleigh_N" ;
lin sleigh_V = mkTerm "sleigh_V" ;
lin sleigh_V2 = mkTerm "sleigh_V2" ;
lin sleigh_bell_N = mkTerm "sleigh_bell_N" ;
lin sleight_N = mkTerm "sleight_N" ;
lin slender_A = mkTerm "slender_A" ;
lin slenderize_V = mkTerm "slenderize_V" ;
lin slenderize_V2 = mkTerm "slenderize_V2" ;
lin slenderness_N = mkTerm "slenderness_N" ;
lin sleuth_N = mkTerm "sleuth_N" ;
lin sleuth_hound_N = mkTerm "sleuth_hound_N" ;
lin slew_V = mkTerm "slew_V" ;
lin slew_V2 = mkTerm "slew_V2" ;
lin slice_N = mkTerm "slice_N" ;
lin slice_V = mkTerm "slice_V" ;
lin slice_V2 = mkTerm "slice_V2" ;
lin slice_off_V2 = mkTerm "slice_off_V2" ;
lin slice_up_V2 = mkTerm "slice_up_V2" ;
lin slicer_N = mkTerm "slicer_N" ;
lin slicing_N = mkTerm "slicing_N" ;
lin slick_A = mkTerm "slick_A" ;
lin slick_Adv = mkTerm "slick_Adv" ;
lin slick_N = mkTerm "slick_N" ;
lin slicker_N = mkTerm "slicker_N" ;
lin slickness_N = mkTerm "slickness_N" ;
lin slide_N = mkTerm "slide_N" ;
lin slide_V = mkTerm "slide_V" ;
lin slide_V2 = mkTerm "slide_V2" ;
lin slide_rule_N = mkTerm "slide_rule_N" ;
lin slider_N = mkTerm "slider_N" ;
lin slight_A = mkTerm "slight_A" ;
lin slight_N = mkTerm "slight_N" ;
lin slight_V2 = mkTerm "slight_V2" ;
lin slightingly_Adv = mkTerm "slightingly_Adv" ;
lin slightness_N = mkTerm "slightness_N" ;
lin sligo_PN = mkTerm "sligo_PN" ;
lin slim_A = mkTerm "slim_A" ;
lin slim_V = mkTerm "slim_V" ;
lin slim_V2 = mkTerm "slim_V2" ;
lin slime_N = mkTerm "slime_N" ;
lin slimed_A = mkTerm "slimed_A" ;
lin sliminess_N = mkTerm "sliminess_N" ;
lin slimness_N = mkTerm "slimness_N" ;
lin slimy_A = mkTerm "slimy_A" ;
lin sling_1_N = mkTerm "sling_1_N" ;
lin sling_2_N = mkTerm "sling_2_N" ;
lin sling_V = mkTerm "sling_V" ;
lin sling_V2 = mkTerm "sling_V2" ;
lin slingback_N = mkTerm "slingback_N" ;
lin slinger_N = mkTerm "slinger_N" ;
lin slinging_N = mkTerm "slinging_N" ;
lin slingshot_N = mkTerm "slingshot_N" ;
lin slink_V = mkTerm "slink_V" ;
lin slip_N = mkTerm "slip_N" ;
lin slip_V = mkTerm "slip_V" ;
lin slip_V2 = mkTerm "slip_V2" ;
lin slip_away_V = mkTerm "slip_away_V" ;
lin slip_by_V = mkTerm "slip_by_V" ;
lin slip_carriage_N = mkTerm "slip_carriage_N" ;
lin slip_coach_N = mkTerm "slip_coach_N" ;
lin slip_down_V = mkTerm "slip_down_V" ;
lin slip_in_V2 = mkTerm "slip_in_V2" ;
lin slip_into_V2 = mkTerm "slip_into_V2" ;
lin slip_off_V = mkTerm "slip_off_V" ;
lin slip_off_V2 = mkTerm "slip_off_V2" ;
lin slip_off_to_V2 = mkTerm "slip_off_to_V2" ;
lin slip_on_V2 = mkTerm "slip_on_V2" ;
lin slip_out_V = mkTerm "slip_out_V" ;
lin slip_road_N = mkTerm "slip_road_N" ;
lin slip_up_N = mkTerm "slip_up_N" ;
lin slip_up_V = mkTerm "slip_up_V" ;
lin slipcover_N = mkTerm "slipcover_N" ;
lin slipknot_N = mkTerm "slipknot_N" ;
lin slipon_N = mkTerm "slipon_N" ;
lin slipover_N = mkTerm "slipover_N" ;
lin slippage_N = mkTerm "slippage_N" ;
lin slipper_N = mkTerm "slipper_N" ;
lin slippered_A = mkTerm "slippered_A" ;
lin slipperiness_N = mkTerm "slipperiness_N" ;
lin slippery_A = mkTerm "slippery_A" ;
lin slippy_A = mkTerm "slippy_A" ;
lin slipshod_A = mkTerm "slipshod_A" ;
lin slipstream_N = mkTerm "slipstream_N" ;
lin slipway_N = mkTerm "slipway_N" ;
lin slit_N = mkTerm "slit_N" ;
lin slit_V2 = mkTerm "slit_V2" ;
lin slither_V = mkTerm "slither_V" ;
lin slithery_A = mkTerm "slithery_A" ;
lin sliver_N = mkTerm "sliver_N" ;
lin sliver_V = mkTerm "sliver_V" ;
lin sliver_V2 = mkTerm "sliver_V2" ;
lin slivovitz_N = mkTerm "slivovitz_N" ;
lin slob_N = mkTerm "slob_N" ;
lin slob_about_V = mkTerm "slob_about_V" ;
lin slob_around_V = mkTerm "slob_around_V" ;
lin slobber_N = mkTerm "slobber_N" ;
lin slobber_V = mkTerm "slobber_V" ;
lin slobber_V2 = mkTerm "slobber_V2" ;
lin sloe_N = mkTerm "sloe_N" ;
lin sloe_gin_N = mkTerm "sloe_gin_N" ;
lin slog_V = mkTerm "slog_V" ;
lin slog_V2 = mkTerm "slog_V2" ;
lin slogan_N = mkTerm "slogan_N" ;
lin sloganeer_N = mkTerm "sloganeer_N" ;
lin sloganeering_N = mkTerm "sloganeering_N" ;
lin slogger_N = mkTerm "slogger_N" ;
lin sloop_N = mkTerm "sloop_N" ;
lin slop_N = mkTerm "slop_N" ;
lin slop_V = mkTerm "slop_V" ;
lin slop_V2 = mkTerm "slop_V2" ;
lin slop_basin_N = mkTerm "slop_basin_N" ;
lin slop_pail_N = mkTerm "slop_pail_N" ;
lin slop_shop_N = mkTerm "slop_shop_N" ;
lin slope_N = mkTerm "slope_N" ;
lin slope_V = mkTerm "slope_V" ;
lin slope_V2 = mkTerm "slope_V2" ;
lin slope_off_V = mkTerm "slope_off_V" ;
lin slopingly_Adv = mkTerm "slopingly_Adv" ;
lin sloppiness_N = mkTerm "sloppiness_N" ;
lin sloppy_A = mkTerm "sloppy_A" ;
lin slops_N = mkTerm "slops_N" ;
lin slopseller_N = mkTerm "slopseller_N" ;
lin slosh_V = mkTerm "slosh_V" ;
lin slosh_V2 = mkTerm "slosh_V2" ;
lin slot_N = mkTerm "slot_N" ;
lin slot_V2 = mkTerm "slot_V2" ;
lin slot_machine_N = mkTerm "slot_machine_N" ;
lin sloth_N = mkTerm "sloth_N" ;
lin slothful_A = mkTerm "slothful_A" ;
lin slouch_N = mkTerm "slouch_N" ;
lin slouch_V = mkTerm "slouch_V" ;
lin slouch_hat_N = mkTerm "slouch_hat_N" ;
lin sloucher_N = mkTerm "sloucher_N" ;
lin slouchingly_Adv = mkTerm "slouchingly_Adv" ;
lin slouchy_A = mkTerm "slouchy_A" ;
lin slough_N = mkTerm "slough_N" ;
lin slough_PN = mkTerm "slough_PN" ;
lin slough_V = mkTerm "slough_V" ;
lin slough_V2 = mkTerm "slough_V2" ;
lin slough_off_V2 = mkTerm "slough_off_V2" ;
lin slovak_N = mkTerm "slovak_N" ;
lin sloven_N = mkTerm "sloven_N" ;
lin slovenian_A = mkTerm "slovenian_A" ;
lin slovenian_N = mkTerm "slovenian_N" ;
lin slovenliness_N = mkTerm "slovenliness_N" ;
lin slovenly_A = mkTerm "slovenly_A" ;
lin slow_A = mkTerm "slow_A" ;
lin slow_Adv = mkTerm "slow_Adv" ;
lin slow_V = mkTerm "slow_V" ;
lin slow_V2 = mkTerm "slow_V2" ;
lin slow_down_V = mkTerm "slow_down_V" ;
lin slow_down_V2 = mkTerm "slow_down_V2" ;
lin slow_up_V2 = mkTerm "slow_up_V2" ;
lin slow_worm_N = mkTerm "slow_worm_N" ;
lin slowcoach_N = mkTerm "slowcoach_N" ;
lin slowdown_N = mkTerm "slowdown_N" ;
lin slower_Adv = mkTerm "slower_Adv" ;
lin slowest_Adv = mkTerm "slowest_Adv" ;
lin slowgoing_A = mkTerm "slowgoing_A" ;
lin slowness_N = mkTerm "slowness_N" ;
lin slub_N = mkTerm "slub_N" ;
lin sludge_N = mkTerm "sludge_N" ;
lin slug_N = mkTerm "slug_N" ;
lin slug_V = mkTerm "slug_V" ;
lin slug_V2 = mkTerm "slug_V2" ;
lin slug_it_out_V2 = mkTerm "slug_it_out_V2" ;
lin sluggard_N = mkTerm "sluggard_N" ;
lin slugger_N = mkTerm "slugger_N" ;
lin sluggish_A = mkTerm "sluggish_A" ;
lin sluggishness_N = mkTerm "sluggishness_N" ;
lin sluice_N = mkTerm "sluice_N" ;
lin sluice_V = mkTerm "sluice_V" ;
lin sluice_V2 = mkTerm "sluice_V2" ;
lin sluice_valve_N = mkTerm "sluice_valve_N" ;
lin sluicegate_N = mkTerm "sluicegate_N" ;
lin slum_N = mkTerm "slum_N" ;
lin slum_V = mkTerm "slum_V" ;
lin slumber_N = mkTerm "slumber_N" ;
lin slumber_V = mkTerm "slumber_V" ;
lin slumber_V2 = mkTerm "slumber_V2" ;
lin slumberer_N = mkTerm "slumberer_N" ;
lin slumberous_A = mkTerm "slumberous_A" ;
lin slumgullion_N = mkTerm "slumgullion_N" ;
lin slummy_A = mkTerm "slummy_A" ;
lin slump_N = mkTerm "slump_N" ;
lin slump_V = mkTerm "slump_V" ;
lin slump_V2 = mkTerm "slump_V2" ;
lin slur_N = mkTerm "slur_N" ;
lin slur_V = mkTerm "slur_V" ;
lin slur_V2 = mkTerm "slur_V2" ;
lin slurry_N = mkTerm "slurry_N" ;
lin slush_N = mkTerm "slush_N" ;
lin slushy_A = mkTerm "slushy_A" ;
lin slut_N = mkTerm "slut_N" ;
lin sluttish_A = mkTerm "sluttish_A" ;
lin sly_A = mkTerm "sly_A" ;
lin slyness_N = mkTerm "slyness_N" ;
lin smack_Adv = mkTerm "smack_Adv" ;
lin smack_N = mkTerm "smack_N" ;
lin smack_V = mkTerm "smack_V" ;
lin smack_V2 = mkTerm "smack_V2" ;
lin smack_of_V2 = mkTerm "smack_of_V2" ;
lin smacker_N = mkTerm "smacker_N" ;
lin smacking_N = mkTerm "smacking_N" ;
lin small_A = mkTerm "small_A" ;
lin small_Adv = mkTerm "small_Adv" ;
lin small_N = mkTerm "small_N" ;
lin small_minded_A = mkTerm "small_minded_A" ;
lin smaller_A = mkTerm "smaller_A" ;
lin smallholder_N = mkTerm "smallholder_N" ;
lin smallholding_N = mkTerm "smallholding_N" ;
lin smallish_A = mkTerm "smallish_A" ;
lin smallmouth_N = mkTerm "smallmouth_N" ;
lin smallness_N = mkTerm "smallness_N" ;
lin smallpox_N = mkTerm "smallpox_N" ;
lin smalltime_A = mkTerm "smalltime_A" ;
lin smaltite_N = mkTerm "smaltite_N" ;
lin smarmy_A = mkTerm "smarmy_A" ;
lin smart_A = mkTerm "smart_A" ;
lin smart_N = mkTerm "smart_N" ;
lin smart_V = mkTerm "smart_V" ;
lin smarta_N = mkTerm "smarta_N" ;
lin smarten_V = mkTerm "smarten_V" ;
lin smarten_V2 = mkTerm "smarten_V2" ;
lin smartness_N = mkTerm "smartness_N" ;
lin smash_Adv = mkTerm "smash_Adv" ;
lin smash_N = mkTerm "smash_N" ;
lin smash_V = mkTerm "smash_V" ;
lin smash_V2 = mkTerm "smash_V2" ;
lin smash_down_V2 = mkTerm "smash_down_V2" ;
lin smash_in_V2 = mkTerm "smash_in_V2" ;
lin smash_up_N = mkTerm "smash_up_N" ;
lin smash_up_V2 = mkTerm "smash_up_V2" ;
lin smasher_N = mkTerm "smasher_N" ;
lin smashing_N = mkTerm "smashing_N" ;
lin smattering_N = mkTerm "smattering_N" ;
lin smear_N = mkTerm "smear_N" ;
lin smear_V = mkTerm "smear_V" ;
lin smear_V2 = mkTerm "smear_V2" ;
lin smear_word_N = mkTerm "smear_word_N" ;
lin smedsby_PN = mkTerm "smedsby_PN" ;
lin smegma_N = mkTerm "smegma_N" ;
lin smell_N = mkTerm "smell_N" ;
lin smell_V = mkTerm "smell_V" ;
lin smell_V2 = mkTerm "smell_V2" ;
lin smell_VA = mkTerm "smell_VA" ;
lin smelling_bottle_N = mkTerm "smelling_bottle_N" ;
lin smelly_A = mkTerm "smelly_A" ;
lin smelt_N = mkTerm "smelt_N" ;
lin smelt_V2 = mkTerm "smelt_V2" ;
lin smelter_N = mkTerm "smelter_N" ;
lin smew_N = mkTerm "smew_N" ;
lin smilax_N = mkTerm "smilax_N" ;
lin smile_N = mkTerm "smile_N" ;
lin smile_V = mkTerm "smile_V" ;
lin smiler_N = mkTerm "smiler_N" ;
lin smiley_N = mkTerm "smiley_N" ;
lin smilingly_Adv = mkTerm "smilingly_Adv" ;
lin smilo_N = mkTerm "smilo_N" ;
lin smirch_N = mkTerm "smirch_N" ;
lin smirch_V2 = mkTerm "smirch_V2" ;
lin smirk_N = mkTerm "smirk_N" ;
lin smirk_V = mkTerm "smirk_V" ;
lin smirker_N = mkTerm "smirker_N" ;
lin smite_V = mkTerm "smite_V" ;
lin smite_V2 = mkTerm "smite_V2" ;
lin smith_N = mkTerm "smith_N" ;
lin smithereens_N = mkTerm "smithereens_N" ;
lin smithy_N = mkTerm "smithy_N" ;
lin smock_N = mkTerm "smock_N" ;
lin smocking_N = mkTerm "smocking_N" ;
lin smog_N = mkTerm "smog_N" ;
lin smoggy_A = mkTerm "smoggy_A" ;
lin smoke_N = mkTerm "smoke_N" ;
lin smoke_V = mkTerm "smoke_V" ;
lin smoke_V2 = mkTerm "smoke_V2" ;
lin smoke_bomb_N = mkTerm "smoke_bomb_N" ;
lin smoke_cured_A = mkTerm "smoke_cured_A" ;
lin smoke_dried_A = mkTerm "smoke_dried_A" ;
lin smoke_out_V2 = mkTerm "smoke_out_V2" ;
lin smoke_screen_N = mkTerm "smoke_screen_N" ;
lin smokehouse_N = mkTerm "smokehouse_N" ;
lin smokeless_A = mkTerm "smokeless_A" ;
lin smoker_N = mkTerm "smoker_N" ;
lin smokestack_N = mkTerm "smokestack_N" ;
lin smoking_N = mkTerm "smoking_N" ;
lin smoking_car_N = mkTerm "smoking_car_N" ;
lin smoking_carriage_N = mkTerm "smoking_carriage_N" ;
lin smoking_compartment_N = mkTerm "smoking_compartment_N" ;
lin smoking_mixture_N = mkTerm "smoking_mixture_N" ;
lin smoking_room_N = mkTerm "smoking_room_N" ;
lin smoky_A = mkTerm "smoky_A" ;
lin smoldering_A = mkTerm "smoldering_A" ;
lin smooth_A = mkTerm "smooth_A" ;
lin smooth_N = mkTerm "smooth_N" ;
lin smooth_V = mkTerm "smooth_V" ;
lin smooth_V2 = mkTerm "smooth_V2" ;
lin smooth_bore_A = mkTerm "smooth_bore_A" ;
lin smooth_faced_A = mkTerm "smooth_faced_A" ;
lin smooth_out_V = mkTerm "smooth_out_V" ;
lin smooth_spoken_A = mkTerm "smooth_spoken_A" ;
lin smooth_tongued_A = mkTerm "smooth_tongued_A" ;
lin smoothbark_N = mkTerm "smoothbark_N" ;
lin smoothbore_N = mkTerm "smoothbore_N" ;
lin smoothhound_N = mkTerm "smoothhound_N" ;
lin smoothie_N = mkTerm "smoothie_N" ;
lin smoothing_iron_N = mkTerm "smoothing_iron_N" ;
lin smoothing_plane_N = mkTerm "smoothing_plane_N" ;
lin smoothness_N = mkTerm "smoothness_N" ;
lin smorgasbord_N = mkTerm "smorgasbord_N" ;
lin smother_N = mkTerm "smother_N" ;
lin smother_V2 = mkTerm "smother_V2" ;
lin smothering_A = mkTerm "smothering_A" ;
lin smoulder_N = mkTerm "smoulder_N" ;
lin smoulder_V = mkTerm "smoulder_V" ;
lin smudge_N = mkTerm "smudge_N" ;
lin smudge_V = mkTerm "smudge_V" ;
lin smudge_V2 = mkTerm "smudge_V2" ;
lin smudgy_A = mkTerm "smudgy_A" ;
lin smug_A = mkTerm "smug_A" ;
lin smuggle_V2 = mkTerm "smuggle_V2" ;
lin smuggle_out_V = mkTerm "smuggle_out_V" ;
lin smuggler_N = mkTerm "smuggler_N" ;
lin smuggling_N = mkTerm "smuggling_N" ;
lin smugness_N = mkTerm "smugness_N" ;
lin smut_N = mkTerm "smut_N" ;
lin smut_V2 = mkTerm "smut_V2" ;
lin smuttiness_N = mkTerm "smuttiness_N" ;
lin smutty_A = mkTerm "smutty_A" ;
lin snack_N = mkTerm "snack_N" ;
lin snack_bar_N = mkTerm "snack_bar_N" ;
lin snack_counter_N = mkTerm "snack_counter_N" ;
lin snaffle_N = mkTerm "snaffle_N" ;
lin snaffle_V2 = mkTerm "snaffle_V2" ;
lin snaffle_bit_N = mkTerm "snaffle_bit_N" ;
lin snaffle_up_V2 = mkTerm "snaffle_up_V2" ;
lin snafu_N = mkTerm "snafu_N" ;
lin snag_N = mkTerm "snag_N" ;
lin snag_V = mkTerm "snag_V" ;
lin snag_V2 = mkTerm "snag_V2" ;
lin snail_N = mkTerm "snail_N" ;
lin snailfish_N = mkTerm "snailfish_N" ;
lin snailflower_N = mkTerm "snailflower_N" ;
lin snake_N = mkTerm "snake_N" ;
lin snake_V = mkTerm "snake_V" ;
lin snake_charmer_N = mkTerm "snake_charmer_N" ;
lin snakebird_N = mkTerm "snakebird_N" ;
lin snakebite_N = mkTerm "snakebite_N" ;
lin snakeblenny_N = mkTerm "snakeblenny_N" ;
lin snakefly_N = mkTerm "snakefly_N" ;
lin snakewood_N = mkTerm "snakewood_N" ;
lin snaky_A = mkTerm "snaky_A" ;
lin snap_N = mkTerm "snap_N" ;
lin snap_V = mkTerm "snap_V" ;
lin snap_V2 = mkTerm "snap_V2" ;
lin snap_back_V = mkTerm "snap_back_V" ;
lin snap_fastener_N = mkTerm "snap_fastener_N" ;
lin snap_off_V2 = mkTerm "snap_off_V2" ;
lin snap_out_of_V2 = mkTerm "snap_out_of_V2" ;
lin snap_to_it_V2 = mkTerm "snap_to_it_V2" ;
lin snap_up_V2 = mkTerm "snap_up_V2" ;
lin snapdragon_N = mkTerm "snapdragon_N" ;
lin snapper_N = mkTerm "snapper_N" ;
lin snappish_A = mkTerm "snappish_A" ;
lin snappishness_N = mkTerm "snappishness_N" ;
lin snappy_A = mkTerm "snappy_A" ;
lin snapshot_N = mkTerm "snapshot_N" ;
lin snare_N = mkTerm "snare_N" ;
lin snare_V2 = mkTerm "snare_V2" ;
lin snare_drum_N = mkTerm "snare_drum_N" ;
lin snarer_N = mkTerm "snarer_N" ;
lin snarl_N = mkTerm "snarl_N" ;
lin snarl_V = mkTerm "snarl_V" ;
lin snarl_V2 = mkTerm "snarl_V2" ;
lin snarl_up_N = mkTerm "snarl_up_N" ;
lin snarl_up_V2 = mkTerm "snarl_up_V2" ;
lin snatch_N = mkTerm "snatch_N" ;
lin snatch_V = mkTerm "snatch_V" ;
lin snatch_V2 = mkTerm "snatch_V2" ;
lin snatcher_N = mkTerm "snatcher_N" ;
lin snazzy_A = mkTerm "snazzy_A" ;
lin sneak_N = mkTerm "sneak_N" ;
lin sneak_V = mkTerm "sneak_V" ;
lin sneak_V2 = mkTerm "sneak_V2" ;
lin sneak_out_V = mkTerm "sneak_out_V" ;
lin sneak_thief_N = mkTerm "sneak_thief_N" ;
lin sneak_up_on_V2 = mkTerm "sneak_up_on_V2" ;
lin sneakingly_Adv = mkTerm "sneakingly_Adv" ;
lin sneaky_A = mkTerm "sneaky_A" ;
lin sneer_N = mkTerm "sneer_N" ;
lin sneer_V = mkTerm "sneer_V" ;
lin sneerer_N = mkTerm "sneerer_N" ;
lin sneeringly_Adv = mkTerm "sneeringly_Adv" ;
lin sneeze_N = mkTerm "sneeze_N" ;
lin sneeze_V = mkTerm "sneeze_V" ;
lin sneezer_N = mkTerm "sneezer_N" ;
lin sneezeweed_N = mkTerm "sneezeweed_N" ;
lin sneezy_A = mkTerm "sneezy_A" ;
lin snick_N = mkTerm "snick_N" ;
lin snick_V = mkTerm "snick_V" ;
lin snick_V2 = mkTerm "snick_V2" ;
lin snicker_N = mkTerm "snicker_N" ;
lin snicker_V = mkTerm "snicker_V" ;
lin snide_A = mkTerm "snide_A" ;
lin sniff_N = mkTerm "sniff_N" ;
lin sniff_V = mkTerm "sniff_V" ;
lin sniff_V2 = mkTerm "sniff_V2" ;
lin sniff_around_V2 = mkTerm "sniff_around_V2" ;
lin sniff_at_V2 = mkTerm "sniff_at_V2" ;
lin sniff_out_V2 = mkTerm "sniff_out_V2" ;
lin sniffer_N = mkTerm "sniffer_N" ;
lin sniffle_V = mkTerm "sniffle_V" ;
lin sniffler_N = mkTerm "sniffler_N" ;
lin sniffly_A = mkTerm "sniffly_A" ;
lin sniffy_A = mkTerm "sniffy_A" ;
lin snifter_N = mkTerm "snifter_N" ;
lin snigger_N = mkTerm "snigger_N" ;
lin snigger_V = mkTerm "snigger_V" ;
lin snip_N = mkTerm "snip_N" ;
lin snip_V = mkTerm "snip_V" ;
lin snip_V2 = mkTerm "snip_V2" ;
lin snipe_N = mkTerm "snipe_N" ;
lin snipe_V = mkTerm "snipe_V" ;
lin snipe_V2 = mkTerm "snipe_V2" ;
lin snipefish_N = mkTerm "snipefish_N" ;
lin sniper_N = mkTerm "sniper_N" ;
lin snippet_N = mkTerm "snippet_N" ;
lin snipping_N = mkTerm "snipping_N" ;
lin snips_N = mkTerm "snips_N" ;
lin snit_N = mkTerm "snit_N" ;
lin snitch_V = mkTerm "snitch_V" ;
lin snitch_V2 = mkTerm "snitch_V2" ;
lin snitch_on_V2 = mkTerm "snitch_on_V2" ;
lin snivel_N = mkTerm "snivel_N" ;
lin snivel_V = mkTerm "snivel_V" ;
lin sniveller_N = mkTerm "sniveller_N" ;
lin snob_N = mkTerm "snob_N" ;
lin snobbery_N = mkTerm "snobbery_N" ;
lin snobbish_A = mkTerm "snobbish_A" ;
lin snobbishness_N = mkTerm "snobbishness_N" ;
lin snog_V = mkTerm "snog_V" ;
lin snogging_N = mkTerm "snogging_N" ;
lin snood_N = mkTerm "snood_N" ;
lin snook_N = mkTerm "snook_N" ;
lin snooker_N = mkTerm "snooker_N" ;
lin snoop_N = mkTerm "snoop_N" ;
lin snoop_V = mkTerm "snoop_V" ;
lin snooper_N = mkTerm "snooper_N" ;
lin snootiness_N = mkTerm "snootiness_N" ;
lin snooty_A = mkTerm "snooty_A" ;
lin snooze_N = mkTerm "snooze_N" ;
lin snooze_V = mkTerm "snooze_V" ;
lin snore_N = mkTerm "snore_N" ;
lin snore_V = mkTerm "snore_V" ;
lin snorer_N = mkTerm "snorer_N" ;
lin snorkel_N = mkTerm "snorkel_N" ;
lin snorkeling_N = mkTerm "snorkeling_N" ;
lin snort_N = mkTerm "snort_N" ;
lin snort_V = mkTerm "snort_V" ;
lin snort_V2 = mkTerm "snort_V2" ;
lin snort_VS = mkTerm "snort_VS" ;
lin snorter_N = mkTerm "snorter_N" ;
lin snorty_A = mkTerm "snorty_A" ;
lin snot_N = mkTerm "snot_N" ;
lin snot_nosed_A = mkTerm "snot_nosed_A" ;
lin snotty_A = mkTerm "snotty_A" ;
lin snout_N = mkTerm "snout_N" ;
lin snow_N = mkTerm "snow_N" ;
lin snow_V = mkTerm "snow_V" ;
lin snow_V2 = mkTerm "snow_V2" ;
lin snow_clad_A = mkTerm "snow_clad_A" ;
lin snow_covered_A = mkTerm "snow_covered_A" ;
lin snow_line_N = mkTerm "snow_line_N" ;
lin snow_white_A = mkTerm "snow_white_A" ;
lin snowball_N = mkTerm "snowball_N" ;
lin snowball_V = mkTerm "snowball_V" ;
lin snowball_V2 = mkTerm "snowball_V2" ;
lin snowbank_N = mkTerm "snowbank_N" ;
lin snowbell_N = mkTerm "snowbell_N" ;
lin snowberry_N = mkTerm "snowberry_N" ;
lin snowblind_A = mkTerm "snowblind_A" ;
lin snowblindness_N = mkTerm "snowblindness_N" ;
lin snowboard_N = mkTerm "snowboard_N" ;
lin snowboarder_N = mkTerm "snowboarder_N" ;
lin snowboarding_N = mkTerm "snowboarding_N" ;
lin snowbound_A = mkTerm "snowbound_A" ;
lin snowcap_N = mkTerm "snowcap_N" ;
lin snowcapped_A = mkTerm "snowcapped_A" ;
lin snowdrift_N = mkTerm "snowdrift_N" ;
lin snowdrop_N = mkTerm "snowdrop_N" ;
lin snowfall_N = mkTerm "snowfall_N" ;
lin snowfield_N = mkTerm "snowfield_N" ;
lin snowflake_N = mkTerm "snowflake_N" ;
lin snowman_N = mkTerm "snowman_N" ;
lin snowmobile_N = mkTerm "snowmobile_N" ;
lin snowplough_N = mkTerm "snowplough_N" ;
lin snowplow_N = mkTerm "snowplow_N" ;
lin snowshoe_N = mkTerm "snowshoe_N" ;
lin snowstorm_N = mkTerm "snowstorm_N" ;
lin snowsuit_N = mkTerm "snowsuit_N" ;
lin snowy_A = mkTerm "snowy_A" ;
lin snr_PN = mkTerm "snr_PN" ;
lin snub_A = mkTerm "snub_A" ;
lin snub_N = mkTerm "snub_N" ;
lin snub_V2 = mkTerm "snub_V2" ;
lin snub_nosed_A = mkTerm "snub_nosed_A" ;
lin snuff_A = mkTerm "snuff_A" ;
lin snuff_N = mkTerm "snuff_N" ;
lin snuff_V = mkTerm "snuff_V" ;
lin snuff_V2 = mkTerm "snuff_V2" ;
lin snuff_colour_A = mkTerm "snuff_colour_A" ;
lin snuff_colour_N = mkTerm "snuff_colour_N" ;
lin snuff_coloured_A = mkTerm "snuff_coloured_A" ;
lin snuff_out_V2 = mkTerm "snuff_out_V2" ;
lin snuffbox_N = mkTerm "snuffbox_N" ;
lin snuffer_N = mkTerm "snuffer_N" ;
lin snuffers_N = mkTerm "snuffers_N" ;
lin snuffle_N = mkTerm "snuffle_N" ;
lin snuffle_V = mkTerm "snuffle_V" ;
lin snuffler_N = mkTerm "snuffler_N" ;
lin snug_A = mkTerm "snug_A" ;
lin snug_N = mkTerm "snug_N" ;
lin snuggery_N = mkTerm "snuggery_N" ;
lin snuggle_V = mkTerm "snuggle_V" ;
lin snuggle_V2 = mkTerm "snuggle_V2" ;
lin snugness_N = mkTerm "snugness_N" ;
lin so_Adv = mkTerm "so_Adv" ;
lin so_N = mkTerm "so_N" ;
lin so_PConj = mkTerm "so_PConj" ;
lin so_Subj = mkTerm "so_Subj" ;
lin so_and_so_N = mkTerm "so_and_so_N" ;
lin so_called_A = mkTerm "so_called_A" ;
lin so_so_A = mkTerm "so_so_A" ;
lin so_so_Adv = mkTerm "so_so_Adv" ;
lin soak_N = mkTerm "soak_N" ;
lin soak_V = mkTerm "soak_V" ;
lin soak_V2 = mkTerm "soak_V2" ;
lin soak_off_V = mkTerm "soak_off_V" ;
lin soak_up_V = mkTerm "soak_up_V" ;
lin soaker_N = mkTerm "soaker_N" ;
lin soaking_Adv = mkTerm "soaking_Adv" ;
lin soap_N = mkTerm "soap_N" ;
lin soap_V2 = mkTerm "soap_V2" ;
lin soap_bubble_N = mkTerm "soap_bubble_N" ;
lin soap_opera_N = mkTerm "soap_opera_N" ;
lin soapberry_N = mkTerm "soapberry_N" ;
lin soapbox_N = mkTerm "soapbox_N" ;
lin soapfish_N = mkTerm "soapfish_N" ;
lin soapiness_N = mkTerm "soapiness_N" ;
lin soapstone_N = mkTerm "soapstone_N" ;
lin soapsuds_N = mkTerm "soapsuds_N" ;
lin soapweed_N = mkTerm "soapweed_N" ;
lin soapwort_N = mkTerm "soapwort_N" ;
lin soapy_A = mkTerm "soapy_A" ;
lin soar_N = mkTerm "soar_N" ;
lin soar_V = mkTerm "soar_V" ;
lin soar_V2 = mkTerm "soar_V2" ;
lin sob_N = mkTerm "sob_N" ;
lin sob_V = mkTerm "sob_V" ;
lin sob_V2 = mkTerm "sob_V2" ;
lin sob_stuff_N = mkTerm "sob_stuff_N" ;
lin sobbingly_Adv = mkTerm "sobbingly_Adv" ;
lin sober_A = mkTerm "sober_A" ;
lin sober_V = mkTerm "sober_V" ;
lin sober_V2 = mkTerm "sober_V2" ;
lin sober_sides_N = mkTerm "sober_sides_N" ;
lin sober_up_V2 = mkTerm "sober_up_V2" ;
lin soberness_N = mkTerm "soberness_N" ;
lin sobersided_A = mkTerm "sobersided_A" ;
lin sobralia_N = mkTerm "sobralia_N" ;
lin sobriety_N = mkTerm "sobriety_N" ;
lin sobriquet_N = mkTerm "sobriquet_N" ;
lin soc_N = mkTerm "soc_N" ;
lin socage_N = mkTerm "socage_N" ;
lin socalled_A = mkTerm "socalled_A" ;
lin soccer_N = mkTerm "soccer_N" ;
lin sociability_N = mkTerm "sociability_N" ;
lin sociable_A = mkTerm "sociable_A" ;
lin sociable_N = mkTerm "sociable_N" ;
lin social_A = mkTerm "social_A" ;
lin social_N = mkTerm "social_N" ;
lin social_work_N = mkTerm "social_work_N" ;
lin socialism_N = mkTerm "socialism_N" ;
lin socialist_A = mkTerm "socialist_A" ;
lin socialist_N = mkTerm "socialist_N" ;
lin socialistic_A = mkTerm "socialistic_A" ;
lin socialite_N = mkTerm "socialite_N" ;
lin sociality_N = mkTerm "sociality_N" ;
lin socialization_N = mkTerm "socialization_N" ;
lin socialize_V2 = mkTerm "socialize_V2" ;
lin socializer_N = mkTerm "socializer_N" ;
lin societal_A = mkTerm "societal_A" ;
lin society_N = mkTerm "society_N" ;
lin sociobiologic_A = mkTerm "sociobiologic_A" ;
lin sociobiologically_Adv = mkTerm "sociobiologically_Adv" ;
lin sociobiologist_N = mkTerm "sociobiologist_N" ;
lin sociobiology_N = mkTerm "sociobiology_N" ;
lin sociocultural_A = mkTerm "sociocultural_A" ;
lin socioeconomic_A = mkTerm "socioeconomic_A" ;
lin sociolinguist_N = mkTerm "sociolinguist_N" ;
lin sociolinguistic_A = mkTerm "sociolinguistic_A" ;
lin sociolinguistics_N = mkTerm "sociolinguistics_N" ;
lin sociological_A = mkTerm "sociological_A" ;
lin sociologist_N = mkTerm "sociologist_N" ;
lin sociology_N = mkTerm "sociology_N" ;
lin sociometry_N = mkTerm "sociometry_N" ;
lin sociopath_N = mkTerm "sociopath_N" ;
lin sociopathic_A = mkTerm "sociopathic_A" ;
lin sock_Adv = mkTerm "sock_Adv" ;
lin sock_N = mkTerm "sock_N" ;
lin sock_V2 = mkTerm "sock_V2" ;
lin socket_N = mkTerm "socket_N" ;
lin sockeye_N = mkTerm "sockeye_N" ;
lin socle_N = mkTerm "socle_N" ;
lin socratic_A = mkTerm "socratic_A" ;
lin sod_N = mkTerm "sod_N" ;
lin sod_V = mkTerm "sod_V" ;
lin soda_N = mkTerm "soda_N" ;
lin soda_biscuit_N = mkTerm "soda_biscuit_N" ;
lin soda_cracker_N = mkTerm "soda_cracker_N" ;
lin soda_fountain_N = mkTerm "soda_fountain_N" ;
lin soda_water_N = mkTerm "soda_water_N" ;
lin sodalist_N = mkTerm "sodalist_N" ;
lin sodalite_N = mkTerm "sodalite_N" ;
lin sodankylä_PN = mkTerm "sodankylä_PN" ;
lin sodden_A = mkTerm "sodden_A" ;
lin sodium_N = mkTerm "sodium_N" ;
lin sodoku_N = mkTerm "sodoku_N" ;
lin sodom_N = mkTerm "sodom_N" ;
lin sodomite_N = mkTerm "sodomite_N" ;
lin sodomy_N = mkTerm "sodomy_N" ;
lin sofa_N = mkTerm "sofa_N" ;
lin soffit_N = mkTerm "soffit_N" ;
lin sofia_PN = mkTerm "sofia_PN" ;
lin soft_A = mkTerm "soft_A" ;
lin soft_boiled_A = mkTerm "soft_boiled_A" ;
lin soft_footed_A = mkTerm "soft_footed_A" ;
lin soft_headed_A = mkTerm "soft_headed_A" ;
lin soft_hearted_A = mkTerm "soft_hearted_A" ;
lin soft_pedal_V = mkTerm "soft_pedal_V" ;
lin soft_pedal_V2 = mkTerm "soft_pedal_V2" ;
lin soft_soap_V2 = mkTerm "soft_soap_V2" ;
lin soft_solder_N = mkTerm "soft_solder_N" ;
lin soft_solder_V2 = mkTerm "soft_solder_V2" ;
lin soft_spoken_A = mkTerm "soft_spoken_A" ;
lin soft_witted_A = mkTerm "soft_witted_A" ;
lin softball_N = mkTerm "softball_N" ;
lin soften_V = mkTerm "soften_V" ;
lin soften_V2 = mkTerm "soften_V2" ;
lin soften_up_V2 = mkTerm "soften_up_V2" ;
lin softener_N = mkTerm "softener_N" ;
lin softening_N = mkTerm "softening_N" ;
lin softheartedness_N = mkTerm "softheartedness_N" ;
lin softie_N = mkTerm "softie_N" ;
lin softish_A = mkTerm "softish_A" ;
lin softland_V = mkTerm "softland_V" ;
lin softness_N = mkTerm "softness_N" ;
lin software_N = mkTerm "software_N" ;
lin softwood_N = mkTerm "softwood_N" ;
lin softy_N = mkTerm "softy_N" ;
lin sogginess_N = mkTerm "sogginess_N" ;
lin soggy_A = mkTerm "soggy_A" ;
lin soh_N = mkTerm "soh_N" ;
lin soho_PN = mkTerm "soho_PN" ;
lin soigne_A = mkTerm "soigne_A" ;
lin soignee_A = mkTerm "soignee_A" ;
lin soil_N = mkTerm "soil_N" ;
lin soil_V = mkTerm "soil_V" ;
lin soil_V2 = mkTerm "soil_V2" ;
lin soil_pipe_N = mkTerm "soil_pipe_N" ;
lin soiling_N = mkTerm "soiling_N" ;
lin soini_PN = mkTerm "soini_PN" ;
lin soiree_N = mkTerm "soiree_N" ;
lin sojourn_N = mkTerm "sojourn_N" ;
lin sojourn_V = mkTerm "sojourn_V" ;
lin sojourner_N = mkTerm "sojourner_N" ;
lin sol_N = mkTerm "sol_N" ;
lin sol_PN = mkTerm "sol_PN" ;
lin sol_fa_N = mkTerm "sol_fa_N" ;
lin solace_N = mkTerm "solace_N" ;
lin solace_V2 = mkTerm "solace_V2" ;
lin solan_N = mkTerm "solan_N" ;
lin solanaceous_A = mkTerm "solanaceous_A" ;
lin solar_A = mkTerm "solar_A" ;
lin solar_plexus_N = mkTerm "solar_plexus_N" ;
lin solarium_N = mkTerm "solarium_N" ;
lin solarization_N = mkTerm "solarization_N" ;
lin solder_N = mkTerm "solder_N" ;
lin solder_V2 = mkTerm "solder_V2" ;
lin solderer_N = mkTerm "solderer_N" ;
lin soldering_iron_N = mkTerm "soldering_iron_N" ;
lin soldier_N = mkTerm "soldier_N" ;
lin soldier_V = mkTerm "soldier_V" ;
lin soldier_on_V = mkTerm "soldier_on_V" ;
lin soldierfish_N = mkTerm "soldierfish_N" ;
lin soldiering_N = mkTerm "soldiering_N" ;
lin soldierly_A = mkTerm "soldierly_A" ;
lin soldiery_N = mkTerm "soldiery_N" ;
lin sole_A = mkTerm "sole_A" ;
lin sole_N = mkTerm "sole_N" ;
lin sole_V2 = mkTerm "sole_V2" ;
lin solecism_N = mkTerm "solecism_N" ;
lin soleless_A = mkTerm "soleless_A" ;
lin solemn_A = mkTerm "solemn_A" ;
lin solemnity_N = mkTerm "solemnity_N" ;
lin solemnization_N = mkTerm "solemnization_N" ;
lin solemnize_V2 = mkTerm "solemnize_V2" ;
lin solemnness_N = mkTerm "solemnness_N" ;
lin solenogaster_N = mkTerm "solenogaster_N" ;
lin solenoid_N = mkTerm "solenoid_N" ;
lin soleus_N = mkTerm "soleus_N" ;
lin solfege_N = mkTerm "solfege_N" ;
lin solferino_N = mkTerm "solferino_N" ;
lin solicit_V = mkTerm "solicit_V" ;
lin solicit_V2 = mkTerm "solicit_V2" ;
lin solicitation_N = mkTerm "solicitation_N" ;
lin solicitorFem_N = mkTerm "solicitorFem_N" ;
lin solicitorMasc_N = mkTerm "solicitorMasc_N" ;
lin solicitor_general_N = mkTerm "solicitor_general_N" ;
lin solicitorship_N = mkTerm "solicitorship_N" ;
lin solicitous_A = mkTerm "solicitous_A" ;
lin solicitude_N = mkTerm "solicitude_N" ;
lin solid_A = mkTerm "solid_A" ;
lin solid_N = mkTerm "solid_N" ;
lin solid_state_A = mkTerm "solid_state_A" ;
lin solidarity_N = mkTerm "solidarity_N" ;
lin solidification_N = mkTerm "solidification_N" ;
lin solidify_V = mkTerm "solidify_V" ;
lin solidify_V2 = mkTerm "solidify_V2" ;
lin solidity_N = mkTerm "solidity_N" ;
lin solidness_N = mkTerm "solidness_N" ;
lin solidus_N = mkTerm "solidus_N" ;
lin solihull_PN = mkTerm "solihull_PN" ;
lin soliloquize_V = mkTerm "soliloquize_V" ;
lin soliloquy_N = mkTerm "soliloquy_N" ;
lin solingen_PN = mkTerm "solingen_PN" ;
lin solipsism_N = mkTerm "solipsism_N" ;
lin solitaire_N = mkTerm "solitaire_N" ;
lin solitary_A = mkTerm "solitary_A" ;
lin soliton_N = mkTerm "soliton_N" ;
lin solitude_N = mkTerm "solitude_N" ;
lin solleret_N = mkTerm "solleret_N" ;
lin solmization_N = mkTerm "solmization_N" ;
lin solo_A = mkTerm "solo_A" ;
lin solo_N = mkTerm "solo_N" ;
lin soloist_N = mkTerm "soloist_N" ;
lin solomon_N = mkTerm "solomon_N" ;
lin solon_PN = mkTerm "solon_PN" ;
lin solstice_N = mkTerm "solstice_N" ;
lin solubility_N = mkTerm "solubility_N" ;
lin soluble_A = mkTerm "soluble_A" ;
lin solute_N = mkTerm "solute_N" ;
lin solution_1_N = mkTerm "solution_1_N" ;
lin solution_2_N = mkTerm "solution_2_N" ;
lin solvability_N = mkTerm "solvability_N" ;
lin solvable_A = mkTerm "solvable_A" ;
lin solvate_N = mkTerm "solvate_N" ;
lin solvation_N = mkTerm "solvation_N" ;
lin solve_V2 = mkTerm "solve_V2" ;
lin solvency_N = mkTerm "solvency_N" ;
lin solvent_A = mkTerm "solvent_A" ;
lin solvent_N = mkTerm "solvent_N" ;
lin som_N = mkTerm "som_N" ;
lin soma_N = mkTerm "soma_N" ;
lin somaliFem_N = mkTerm "somaliFem_N" ;
lin somaliMasc_N = mkTerm "somaliMasc_N" ;
lin somali_A = mkTerm "somali_A" ;
lin somalia_PN = mkTerm "somalia_PN" ;
lin somalianFem_N = mkTerm "somalianFem_N" ;
lin somalianMasc_N = mkTerm "somalianMasc_N" ;
lin somalian_A = mkTerm "somalian_A" ;
lin soman_N = mkTerm "soman_N" ;
lin somatic_A = mkTerm "somatic_A" ;
lin somatogenic_A = mkTerm "somatogenic_A" ;
lin somatosense_N = mkTerm "somatosense_N" ;
lin somatosensory_A = mkTerm "somatosensory_A" ;
lin somatotropin_N = mkTerm "somatotropin_N" ;
lin somber_A = mkTerm "somber_A" ;
lin sombre_A = mkTerm "sombre_A" ;
lin sombreness_N = mkTerm "sombreness_N" ;
lin sombrero_N = mkTerm "sombrero_N" ;
lin some_Det = mkTerm "some_Det" ;
lin some_Quant = mkTerm "some_Quant" ;
lin someday_Adv = mkTerm "someday_Adv" ;
lin somehow_AdV = mkTerm "somehow_AdV" ;
lin somehow_Adv = mkTerm "somehow_Adv" ;
lin someone_NP = mkTerm "someone_NP" ;
lin someplace_Adv = mkTerm "someplace_Adv" ;
lin somercotes_PN = mkTerm "somercotes_PN" ;
lin somero_PN = mkTerm "somero_PN" ;
lin somersault_N = mkTerm "somersault_N" ;
lin somersault_V = mkTerm "somersault_V" ;
lin somerset_PN = mkTerm "somerset_PN" ;
lin somesthesia_N = mkTerm "somesthesia_N" ;
lin sometime_Adv = mkTerm "sometime_Adv" ;
lin sometimes_Adv = mkTerm "sometimes_Adv" ;
lin someway_Adv = mkTerm "someway_Adv" ;
lin somewhat_Adv = mkTerm "somewhat_Adv" ;
lin somewhere_N = mkTerm "somewhere_N" ;
lin sommelier_N = mkTerm "sommelier_N" ;
lin somnambulism_N = mkTerm "somnambulism_N" ;
lin somnambulist_N = mkTerm "somnambulist_N" ;
lin somniloquist_N = mkTerm "somniloquist_N" ;
lin somnolence_N = mkTerm "somnolence_N" ;
lin somnolent_A = mkTerm "somnolent_A" ;
lin son_N = mkTerm "son_N" ;
lin son_in_law_N = mkTerm "son_in_law_N" ;
lin sonant_N = mkTerm "sonant_N" ;
lin sonar_N = mkTerm "sonar_N" ;
lin sonata_N = mkTerm "sonata_N" ;
lin sonatina_N = mkTerm "sonatina_N" ;
lin sone_N = mkTerm "sone_N" ;
lin song_N = mkTerm "song_N" ;
lin songbird_N = mkTerm "songbird_N" ;
lin songbook_N = mkTerm "songbook_N" ;
lin songster_N = mkTerm "songster_N" ;
lin songstress_N = mkTerm "songstress_N" ;
lin songwriter_N = mkTerm "songwriter_N" ;
lin songwriting_A = mkTerm "songwriting_A" ;
lin songwriting_N = mkTerm "songwriting_N" ;
lin sonia_PN = mkTerm "sonia_PN" ;
lin sonic_A = mkTerm "sonic_A" ;
lin sonkajärvi_PN = mkTerm "sonkajärvi_PN" ;
lin sonnet_N = mkTerm "sonnet_N" ;
lin sonneteer_N = mkTerm "sonneteer_N" ;
lin sonny_N = mkTerm "sonny_N" ;
lin sonogram_N = mkTerm "sonogram_N" ;
lin sonograph_N = mkTerm "sonograph_N" ;
lin sonography_N = mkTerm "sonography_N" ;
lin sonority_N = mkTerm "sonority_N" ;
lin sonorous_A = mkTerm "sonorous_A" ;
lin sonsy_A = mkTerm "sonsy_A" ;
lin soochow_PN = mkTerm "soochow_PN" ;
lin soon_AdV = mkTerm "soon_AdV" ;
lin soon_Adv = mkTerm "soon_Adv" ;
lin sooner_Adv = mkTerm "sooner_Adv" ;
lin soonest_Adv = mkTerm "soonest_Adv" ;
lin soot_N = mkTerm "soot_N" ;
lin soot_V2 = mkTerm "soot_V2" ;
lin sooth_N = mkTerm "sooth_N" ;
lin soothe_V2 = mkTerm "soothe_V2" ;
lin soothing_A = mkTerm "soothing_A" ;
lin soothsayer_N = mkTerm "soothsayer_N" ;
lin sooty_A = mkTerm "sooty_A" ;
lin sop_N = mkTerm "sop_N" ;
lin sop_V2 = mkTerm "sop_V2" ;
lin sophia_PN = mkTerm "sophia_PN" ;
lin sophie_PN = mkTerm "sophie_PN" ;
lin sophism_N = mkTerm "sophism_N" ;
lin sophistFem_N = mkTerm "sophistFem_N" ;
lin sophistMasc_N = mkTerm "sophistMasc_N" ;
lin sophistic_A = mkTerm "sophistic_A" ;
lin sophisticate_N = mkTerm "sophisticate_N" ;
lin sophisticated_A = mkTerm "sophisticated_A" ;
lin sophistication_N = mkTerm "sophistication_N" ;
lin sophistry_N = mkTerm "sophistry_N" ;
lin sophomore_N = mkTerm "sophomore_N" ;
lin soporific_A = mkTerm "soporific_A" ;
lin soporific_N = mkTerm "soporific_N" ;
lin sopping_A = mkTerm "sopping_A" ;
lin sopping_Adv = mkTerm "sopping_Adv" ;
lin soppy_A = mkTerm "soppy_A" ;
lin sopranino_A = mkTerm "sopranino_A" ;
lin soprano_A = mkTerm "soprano_A" ;
lin soprano_N = mkTerm "soprano_N" ;
lin sorb_N = mkTerm "sorb_N" ;
lin sorbate_N = mkTerm "sorbate_N" ;
lin sorbent_N = mkTerm "sorbent_N" ;
lin sorbet_N = mkTerm "sorbet_N" ;
lin sorcerer_N = mkTerm "sorcerer_N" ;
lin sorceress_N = mkTerm "sorceress_N" ;
lin sorcery_N = mkTerm "sorcery_N" ;
lin sordid_A = mkTerm "sordid_A" ;
lin sordidness_N = mkTerm "sordidness_N" ;
lin sore_A = mkTerm "sore_A" ;
lin sore_N = mkTerm "sore_N" ;
lin sorehead_N = mkTerm "sorehead_N" ;
lin soreness_N = mkTerm "soreness_N" ;
lin sorghum_N = mkTerm "sorghum_N" ;
lin sorgo_N = mkTerm "sorgo_N" ;
lin sorority_N = mkTerm "sorority_N" ;
lin sorption_N = mkTerm "sorption_N" ;
lin sorrel_A = mkTerm "sorrel_A" ;
lin sorrel_N = mkTerm "sorrel_N" ;
lin sorrow_N = mkTerm "sorrow_N" ;
lin sorrow_V = mkTerm "sorrow_V" ;
lin sorrowful_A = mkTerm "sorrowful_A" ;
lin sorry_A = mkTerm "sorry_A" ;
lin sorry_Interj = mkTerm "sorry_Interj" ;
lin sort_N = mkTerm "sort_N" ;
lin sort_V = mkTerm "sort_V" ;
lin sort_V2 = mkTerm "sort_V2" ;
lin sort_out_V2 = mkTerm "sort_out_V2" ;
lin sorter_N = mkTerm "sorter_N" ;
lin sortie_N = mkTerm "sortie_N" ;
lin sorting_N = mkTerm "sorting_N" ;
lin sorus_N = mkTerm "sorus_N" ;
lin sos_N = mkTerm "sos_N" ;
lin sot_N = mkTerm "sot_N" ;
lin soteriological_A = mkTerm "soteriological_A" ;
lin soteriology_N = mkTerm "soteriology_N" ;
lin sotho_A = mkTerm "sotho_A" ;
lin sotho_N = mkTerm "sotho_N" ;
lin sotkamo_PN = mkTerm "sotkamo_PN" ;
lin sottish_A = mkTerm "sottish_A" ;
lin sottishness_N = mkTerm "sottishness_N" ;
lin sotto_voce_Adv = mkTerm "sotto_voce_Adv" ;
lin sou'_east_N = mkTerm "sou'_east_N" ;
lin sou'_sou'_east_Adv = mkTerm "sou'_sou'_east_Adv" ;
lin sou'_sou'_east_N = mkTerm "sou'_sou'_east_N" ;
lin sou'_sou'_west_Adv = mkTerm "sou'_sou'_west_Adv" ;
lin sou'_sou'_west_N = mkTerm "sou'_sou'_west_N" ;
lin sou'_west_Adv = mkTerm "sou'_west_Adv" ;
lin sou'_west_N = mkTerm "sou'_west_N" ;
lin sou'_wester_N = mkTerm "sou'_wester_N" ;
lin sou_N = mkTerm "sou_N" ;
lin souari_N = mkTerm "souari_N" ;
lin soubrette_N = mkTerm "soubrette_N" ;
lin soubriquet_N = mkTerm "soubriquet_N" ;
lin souchong_N = mkTerm "souchong_N" ;
lin souffle_N = mkTerm "souffle_N" ;
lin sough_V = mkTerm "sough_V" ;
lin soughingly_Adv = mkTerm "soughingly_Adv" ;
lin souk_N = mkTerm "souk_N" ;
lin soul_N = mkTerm "soul_N" ;
lin soul_destroying_A = mkTerm "soul_destroying_A" ;
lin soul_stirring_A = mkTerm "soul_stirring_A" ;
lin soulful_A = mkTerm "soulful_A" ;
lin soulless_A = mkTerm "soulless_A" ;
lin sound_A = mkTerm "sound_A" ;
lin sound_Adv = mkTerm "sound_Adv" ;
lin sound_N = mkTerm "sound_N" ;
lin sound_V = mkTerm "sound_V" ;
lin sound_V2 = mkTerm "sound_V2" ;
lin sound_VA = mkTerm "sound_VA" ;
lin sound_VS = mkTerm "sound_VS" ;
lin sound_film_N = mkTerm "sound_film_N" ;
lin sound_off_V = mkTerm "sound_off_V" ;
lin sound_out_V2 = mkTerm "sound_out_V2" ;
lin sound_recording_N = mkTerm "sound_recording_N" ;
lin sound_wave_N = mkTerm "sound_wave_N" ;
lin soundbox_N = mkTerm "soundbox_N" ;
lin sounder_N = mkTerm "sounder_N" ;
lin sounding_N = mkTerm "sounding_N" ;
lin sounding_board_N = mkTerm "sounding_board_N" ;
lin soundless_A = mkTerm "soundless_A" ;
lin soundman_N = mkTerm "soundman_N" ;
lin soundness_N = mkTerm "soundness_N" ;
lin soundproof_A = mkTerm "soundproof_A" ;
lin soundproof_V2 = mkTerm "soundproof_V2" ;
lin soundtrack_N = mkTerm "soundtrack_N" ;
lin soup_N = mkTerm "soup_N" ;
lin soup_V2 = mkTerm "soup_V2" ;
lin soup_kitchen_N = mkTerm "soup_kitchen_N" ;
lin soupcon_N = mkTerm "soupcon_N" ;
lin soupspoon_N = mkTerm "soupspoon_N" ;
lin soupy_A = mkTerm "soupy_A" ;
lin sour_A = mkTerm "sour_A" ;
lin sour_N = mkTerm "sour_N" ;
lin sour_V = mkTerm "sour_V" ;
lin sour_V2 = mkTerm "sour_V2" ;
lin sourball_N = mkTerm "sourball_N" ;
lin source_N = mkTerm "source_N" ;
lin sourdine_N = mkTerm "sourdine_N" ;
lin sourdough_N = mkTerm "sourdough_N" ;
lin souring_N = mkTerm "souring_N" ;
lin sourness_N = mkTerm "sourness_N" ;
lin sourpuss_N = mkTerm "sourpuss_N" ;
lin soursop_N = mkTerm "soursop_N" ;
lin souse_N = mkTerm "souse_N" ;
lin souse_V2 = mkTerm "souse_V2" ;
lin soutache_N = mkTerm "soutache_N" ;
lin soutane_N = mkTerm "soutane_N" ;
lin south_A = mkTerm "south_A" ;
lin south_Adv = mkTerm "south_Adv" ;
lin south_N = mkTerm "south_N" ;
lin south_kirkby_PN = mkTerm "south_kirkby_PN" ;
lin south_normantown_PN = mkTerm "south_normantown_PN" ;
lin south_ockendon_PN = mkTerm "south_ockendon_PN" ;
lin south_shields_PN = mkTerm "south_shields_PN" ;
lin south_southeast_Adv = mkTerm "south_southeast_Adv" ;
lin south_southeast_N = mkTerm "south_southeast_N" ;
lin south_southwest_Adv = mkTerm "south_southwest_Adv" ;
lin south_southwest_N = mkTerm "south_southwest_N" ;
lin southampton_PN = mkTerm "southampton_PN" ;
lin southbound_A = mkTerm "southbound_A" ;
lin southeast_A = mkTerm "southeast_A" ;
lin southeast_Adv = mkTerm "southeast_Adv" ;
lin southeast_N = mkTerm "southeast_N" ;
lin southeaster_N = mkTerm "southeaster_N" ;
lin southeasterly_A = mkTerm "southeasterly_A" ;
lin southeastern_A = mkTerm "southeastern_A" ;
lin southeastward_A = mkTerm "southeastward_A" ;
lin southeastward_Adv = mkTerm "southeastward_Adv" ;
lin southend_on_sea_PN = mkTerm "southend_on_sea_PN" ;
lin southerly_A = mkTerm "southerly_A" ;
lin southerly_Adv = mkTerm "southerly_Adv" ;
lin southern_A = mkTerm "southern_A" ;
lin southerner_N = mkTerm "southerner_N" ;
lin southernism_N = mkTerm "southernism_N" ;
lin southernmost_A = mkTerm "southernmost_A" ;
lin southernness_N = mkTerm "southernness_N" ;
lin southernwood_N = mkTerm "southernwood_N" ;
lin southland_N = mkTerm "southland_N" ;
lin southpaw_N = mkTerm "southpaw_N" ;
lin southport_PN = mkTerm "southport_PN" ;
lin southward_Adv = mkTerm "southward_Adv" ;
lin southwards_Adv = mkTerm "southwards_Adv" ;
lin southwark_PN = mkTerm "southwark_PN" ;
lin southwest_A = mkTerm "southwest_A" ;
lin southwest_Adv = mkTerm "southwest_Adv" ;
lin southwest_N = mkTerm "southwest_N" ;
lin southwester_N = mkTerm "southwester_N" ;
lin southwesterly_A = mkTerm "southwesterly_A" ;
lin southwestern_A = mkTerm "southwestern_A" ;
lin southwestward_A = mkTerm "southwestward_A" ;
lin southwestward_Adv = mkTerm "southwestward_Adv" ;
lin souvenir_N = mkTerm "souvenir_N" ;
lin souvlaki_N = mkTerm "souvlaki_N" ;
lin souwester_N = mkTerm "souwester_N" ;
lin sovereign_A = mkTerm "sovereign_A" ;
lin sovereign_N = mkTerm "sovereign_N" ;
lin sovereignty_N = mkTerm "sovereignty_N" ;
lin soviet_A = mkTerm "soviet_A" ;
lin soviet_N = mkTerm "soviet_N" ;
lin sovietize_V2 = mkTerm "sovietize_V2" ;
lin sow_N = mkTerm "sow_N" ;
lin sow_V = mkTerm "sow_V" ;
lin sow_V2 = mkTerm "sow_V2" ;
lin sowbane_N = mkTerm "sowbane_N" ;
lin sowbelly_N = mkTerm "sowbelly_N" ;
lin sowbread_N = mkTerm "sowbread_N" ;
lin sower_N = mkTerm "sower_N" ;
lin soy_N = mkTerm "soy_N" ;
lin sozzled_A = mkTerm "sozzled_A" ;
lin spa_N = mkTerm "spa_N" ;
lin space_1_N = mkTerm "space_1_N" ;
lin space_2_N = mkTerm "space_2_N" ;
lin space_V2 = mkTerm "space_V2" ;
lin space_bar_N = mkTerm "space_bar_N" ;
lin space_capsule_N = mkTerm "space_capsule_N" ;
lin space_heater_N = mkTerm "space_heater_N" ;
lin space_helmet_N = mkTerm "space_helmet_N" ;
lin space_rocket_N = mkTerm "space_rocket_N" ;
lin space_time_N = mkTerm "space_time_N" ;
lin space_vehicle_N = mkTerm "space_vehicle_N" ;
lin spacecraft_N = mkTerm "spacecraft_N" ;
lin spaceflight_N = mkTerm "spaceflight_N" ;
lin spaceship_N = mkTerm "spaceship_N" ;
lin spacesuit_N = mkTerm "spacesuit_N" ;
lin spacetime_N = mkTerm "spacetime_N" ;
lin spacewalker_N = mkTerm "spacewalker_N" ;
lin spaceward_Adv = mkTerm "spaceward_Adv" ;
lin spacing_N = mkTerm "spacing_N" ;
lin spacious_A = mkTerm "spacious_A" ;
lin spaciousness_N = mkTerm "spaciousness_N" ;
lin spackle_N = mkTerm "spackle_N" ;
lin spade_N = mkTerm "spade_N" ;
lin spade_V2 = mkTerm "spade_V2" ;
lin spadefish_N = mkTerm "spadefish_N" ;
lin spadefoot_N = mkTerm "spadefoot_N" ;
lin spadeful_N = mkTerm "spadeful_N" ;
lin spadework_N = mkTerm "spadework_N" ;
lin spadix_N = mkTerm "spadix_N" ;
lin spaff_away_V2 = mkTerm "spaff_away_V2" ;
lin spaghetti_N = mkTerm "spaghetti_N" ;
lin spaghettini_N = mkTerm "spaghettini_N" ;
lin spain_PN = mkTerm "spain_PN" ;
lin spalding_PN = mkTerm "spalding_PN" ;
lin spall_N = mkTerm "spall_N" ;
lin spallation_N = mkTerm "spallation_N" ;
lin spam_N = mkTerm "spam_N" ;
lin spammer_N = mkTerm "spammer_N" ;
lin span_N = mkTerm "span_N" ;
lin span_V2 = mkTerm "span_V2" ;
lin spandex_N = mkTerm "spandex_N" ;
lin spandrel_N = mkTerm "spandrel_N" ;
lin spangle_N = mkTerm "spangle_N" ;
lin spangle_V2 = mkTerm "spangle_V2" ;
lin spaniard_N = mkTerm "spaniard_N" ;
lin spaniel_N = mkTerm "spaniel_N" ;
lin spanishFem_N = mkTerm "spanishFem_N" ;
lin spanishMasc_N = mkTerm "spanishMasc_N" ;
lin spanish_A = mkTerm "spanish_A" ;
lin spank_N = mkTerm "spank_N" ;
lin spank_V = mkTerm "spank_V" ;
lin spank_V2 = mkTerm "spank_V2" ;
lin spanker_N = mkTerm "spanker_N" ;
lin spanking_A = mkTerm "spanking_A" ;
lin spanking_N = mkTerm "spanking_N" ;
lin spanner_N = mkTerm "spanner_N" ;
lin spar_N = mkTerm "spar_N" ;
lin spar_V = mkTerm "spar_V" ;
lin spare_A = mkTerm "spare_A" ;
lin spare_N = mkTerm "spare_N" ;
lin spare_V = mkTerm "spare_V" ;
lin spare_V2 = mkTerm "spare_V2" ;
lin spare_rib_N = mkTerm "spare_rib_N" ;
lin spareness_N = mkTerm "spareness_N" ;
lin sparer_N = mkTerm "sparer_N" ;
lin spareribs_N = mkTerm "spareribs_N" ;
lin sparid_N = mkTerm "sparid_N" ;
lin sparing_A = mkTerm "sparing_A" ;
lin spark_N = mkTerm "spark_N" ;
lin spark_V = mkTerm "spark_V" ;
lin spark_V2 = mkTerm "spark_V2" ;
lin spark_off_V2 = mkTerm "spark_off_V2" ;
lin spark_plug_N = mkTerm "spark_plug_N" ;
lin spark_up_V2 = mkTerm "spark_up_V2" ;
lin sparking_plug_N = mkTerm "sparking_plug_N" ;
lin sparkle_N = mkTerm "sparkle_N" ;
lin sparkle_V = mkTerm "sparkle_V" ;
lin sparkler_N = mkTerm "sparkler_N" ;
lin sparling_N = mkTerm "sparling_N" ;
lin sparring_N = mkTerm "sparring_N" ;
lin sparring_match_N = mkTerm "sparring_match_N" ;
lin sparring_partner_N = mkTerm "sparring_partner_N" ;
lin sparrow_N = mkTerm "sparrow_N" ;
lin sparse_A = mkTerm "sparse_A" ;
lin sparseness_N = mkTerm "sparseness_N" ;
lin sparsity_N = mkTerm "sparsity_N" ;
lin spartanFem_N = mkTerm "spartanFem_N" ;
lin spartanMasc_N = mkTerm "spartanMasc_N" ;
lin spartan_A = mkTerm "spartan_A" ;
lin spasm_N = mkTerm "spasm_N" ;
lin spasmodic_A = mkTerm "spasmodic_A" ;
lin spasmolysis_N = mkTerm "spasmolysis_N" ;
lin spastic_A = mkTerm "spastic_A" ;
lin spastic_N = mkTerm "spastic_N" ;
lin spasticity_N = mkTerm "spasticity_N" ;
lin spat_N = mkTerm "spat_N" ;
lin spat_V = mkTerm "spat_V" ;
lin spat_V2 = mkTerm "spat_V2" ;
lin spatchcock_N = mkTerm "spatchcock_N" ;
lin spatchcock_V2 = mkTerm "spatchcock_V2" ;
lin spate_of_N2 = mkTerm "spate_of_N2" ;
lin spathe_N = mkTerm "spathe_N" ;
lin spathiphyllum_N = mkTerm "spathiphyllum_N" ;
lin spatial_A = mkTerm "spatial_A" ;
lin spatiotemporal_A = mkTerm "spatiotemporal_A" ;
lin spatter_N = mkTerm "spatter_N" ;
lin spatter_V = mkTerm "spatter_V" ;
lin spatter_V2 = mkTerm "spatter_V2" ;
lin spatterdock_N = mkTerm "spatterdock_N" ;
lin spatula_N = mkTerm "spatula_N" ;
lin spatulate_A = mkTerm "spatulate_A" ;
lin spavin_N = mkTerm "spavin_N" ;
lin spavined_A = mkTerm "spavined_A" ;
lin spawn_N = mkTerm "spawn_N" ;
lin spawn_V = mkTerm "spawn_V" ;
lin spawn_V2 = mkTerm "spawn_V2" ;
lin spawner_N = mkTerm "spawner_N" ;
lin spay_V2 = mkTerm "spay_V2" ;
lin spaying_N = mkTerm "spaying_N" ;
lin speak_V = mkTerm "speak_V" ;
lin speak_V2 = mkTerm "speak_V2" ;
lin speak_out_V = mkTerm "speak_out_V" ;
lin speak_up_V = mkTerm "speak_up_V" ;
lin speakable_A = mkTerm "speakable_A" ;
lin speakeasy_N = mkTerm "speakeasy_N" ;
lin speaker_N = mkTerm "speaker_N" ;
lin speakerphone_N = mkTerm "speakerphone_N" ;
lin speakership_N = mkTerm "speakership_N" ;
lin speaking_N = mkTerm "speaking_N" ;
lin speaking_trumpet_N = mkTerm "speaking_trumpet_N" ;
lin speaking_tube_N = mkTerm "speaking_tube_N" ;
lin spear_N = mkTerm "spear_N" ;
lin spear_V2 = mkTerm "spear_V2" ;
lin spearfish_N = mkTerm "spearfish_N" ;
lin spearhead_N = mkTerm "spearhead_N" ;
lin spearhead_V2 = mkTerm "spearhead_V2" ;
lin spearmint_N = mkTerm "spearmint_N" ;
lin spec_N = mkTerm "spec_N" ;
lin special_A = mkTerm "special_A" ;
lin special_N = mkTerm "special_N" ;
lin specialism_N = mkTerm "specialism_N" ;
lin specialist_A = mkTerm "specialist_A" ;
lin specialist_N = mkTerm "specialist_N" ;
lin specialistic_A = mkTerm "specialistic_A" ;
lin speciality_N = mkTerm "speciality_N" ;
lin specialization_N = mkTerm "specialization_N" ;
lin specialize_V = mkTerm "specialize_V" ;
lin specialize_V2 = mkTerm "specialize_V2" ;
lin specialty_N = mkTerm "specialty_N" ;
lin speciation_N = mkTerm "speciation_N" ;
lin specie_N = mkTerm "specie_N" ;
lin species_N = mkTerm "species_N" ;
lin specifiable_A = mkTerm "specifiable_A" ;
lin specific_A = mkTerm "specific_A" ;
lin specific_N = mkTerm "specific_N" ;
lin specification_N = mkTerm "specification_N" ;
lin specificity_N = mkTerm "specificity_N" ;
lin specified_A = mkTerm "specified_A" ;
lin specifier_N = mkTerm "specifier_N" ;
lin specify_V = mkTerm "specify_V" ;
lin specify_V2 = mkTerm "specify_V2" ;
lin specify_VS = mkTerm "specify_VS" ;
lin specimen_N = mkTerm "specimen_N" ;
lin specious_A = mkTerm "specious_A" ;
lin speciousness_N = mkTerm "speciousness_N" ;
lin speck_N = mkTerm "speck_N" ;
lin specked_A = mkTerm "specked_A" ;
lin speckle_N = mkTerm "speckle_N" ;
lin speckled_A = mkTerm "speckled_A" ;
lin speckless_A = mkTerm "speckless_A" ;
lin spectacle_N = mkTerm "spectacle_N" ;
lin spectacled_A = mkTerm "spectacled_A" ;
lin spectacles_N = mkTerm "spectacles_N" ;
lin spectacular_A = mkTerm "spectacular_A" ;
lin spectacular_N = mkTerm "spectacular_N" ;
lin spectatorFem_N = mkTerm "spectatorFem_N" ;
lin spectatorMasc_N = mkTerm "spectatorMasc_N" ;
lin spectinomycin_N = mkTerm "spectinomycin_N" ;
lin spectral_A = mkTerm "spectral_A" ;
lin spectre_N = mkTerm "spectre_N" ;
lin spectrogram_N = mkTerm "spectrogram_N" ;
lin spectrograph_N = mkTerm "spectrograph_N" ;
lin spectrographic_A = mkTerm "spectrographic_A" ;
lin spectrometric_A = mkTerm "spectrometric_A" ;
lin spectrophotometer_N = mkTerm "spectrophotometer_N" ;
lin spectroscope_N = mkTerm "spectroscope_N" ;
lin spectroscopic_A = mkTerm "spectroscopic_A" ;
lin spectroscopy_N = mkTerm "spectroscopy_N" ;
lin spectrum_N = mkTerm "spectrum_N" ;
lin speculate_V = mkTerm "speculate_V" ;
lin speculate_VS = mkTerm "speculate_VS" ;
lin speculation_N = mkTerm "speculation_N" ;
lin speculative_A = mkTerm "speculative_A" ;
lin speculativeness_N = mkTerm "speculativeness_N" ;
lin speculatorFem_N = mkTerm "speculatorFem_N" ;
lin speculatorMasc_N = mkTerm "speculatorMasc_N" ;
lin speculum_N = mkTerm "speculum_N" ;
lin speech_N = mkTerm "speech_N" ;
lin speech_day_N = mkTerm "speech_day_N" ;
lin speechify_V = mkTerm "speechify_V" ;
lin speechless_A = mkTerm "speechless_A" ;
lin speechlessness_N = mkTerm "speechlessness_N" ;
lin speechwriter_N = mkTerm "speechwriter_N" ;
lin speed_N = mkTerm "speed_N" ;
lin speed_V = mkTerm "speed_V" ;
lin speed_V2 = mkTerm "speed_V2" ;
lin speed_along_V = mkTerm "speed_along_V" ;
lin speed_cop_N = mkTerm "speed_cop_N" ;
lin speed_indicator_N = mkTerm "speed_indicator_N" ;
lin speed_limit_N = mkTerm "speed_limit_N" ;
lin speed_up_N = mkTerm "speed_up_N" ;
lin speed_up_V2 = mkTerm "speed_up_V2" ;
lin speedboat_N = mkTerm "speedboat_N" ;
lin speeder_N = mkTerm "speeder_N" ;
lin speeding_N = mkTerm "speeding_N" ;
lin speedometer_N = mkTerm "speedometer_N" ;
lin speedskater_N = mkTerm "speedskater_N" ;
lin speedway_N = mkTerm "speedway_N" ;
lin speedwell_N = mkTerm "speedwell_N" ;
lin speedy_A = mkTerm "speedy_A" ;
lin spelaeologist_N = mkTerm "spelaeologist_N" ;
lin spelaeology_N = mkTerm "spelaeology_N" ;
lin speleologist_N = mkTerm "speleologist_N" ;
lin speleology_N = mkTerm "speleology_N" ;
lin spell_N = mkTerm "spell_N" ;
lin spell_V = mkTerm "spell_V" ;
lin spell_V2 = mkTerm "spell_V2" ;
lin spell_out_V2 = mkTerm "spell_out_V2" ;
lin spellbinder_N = mkTerm "spellbinder_N" ;
lin spellbound_A = mkTerm "spellbound_A" ;
lin speller_N = mkTerm "speller_N" ;
lin spelling_N = mkTerm "spelling_N" ;
lin spelt_N = mkTerm "spelt_N" ;
lin spelter_N = mkTerm "spelter_N" ;
lin spenborough_PN = mkTerm "spenborough_PN" ;
lin spencer_N = mkTerm "spencer_N" ;
lin spend_V = mkTerm "spend_V" ;
lin spend_V2 = mkTerm "spend_V2" ;
lin spend_ing_V2V = mkTerm "spend_ing_V2V" ;
lin spend_to_V2V = mkTerm "spend_to_V2V" ;
lin spender_N = mkTerm "spender_N" ;
lin spending_N = mkTerm "spending_N" ;
lin spendthrift_N = mkTerm "spendthrift_N" ;
lin spennymoor_PN = mkTerm "spennymoor_PN" ;
lin sperm_N = mkTerm "sperm_N" ;
lin sperm_whale_N = mkTerm "sperm_whale_N" ;
lin spermaceti_N = mkTerm "spermaceti_N" ;
lin spermatid_N = mkTerm "spermatid_N" ;
lin spermatocele_N = mkTerm "spermatocele_N" ;
lin spermatocyte_N = mkTerm "spermatocyte_N" ;
lin spermatogenesis_N = mkTerm "spermatogenesis_N" ;
lin spermatophyte_N = mkTerm "spermatophyte_N" ;
lin spermatozoon_N = mkTerm "spermatozoon_N" ;
lin spermicidal_A = mkTerm "spermicidal_A" ;
lin spermicide_N = mkTerm "spermicide_N" ;
lin spermous_A = mkTerm "spermous_A" ;
lin spew_V = mkTerm "spew_V" ;
lin spew_V2 = mkTerm "spew_V2" ;
lin spew_out_V2 = mkTerm "spew_out_V2" ;
lin spew_up_V = mkTerm "spew_up_V" ;
lin sphagnum_N = mkTerm "sphagnum_N" ;
lin sphenion_N = mkTerm "sphenion_N" ;
lin sphere_N = mkTerm "sphere_N" ;
lin spherical_A = mkTerm "spherical_A" ;
lin sphericity_N = mkTerm "sphericity_N" ;
lin spherocyte_N = mkTerm "spherocyte_N" ;
lin spheroid_N = mkTerm "spheroid_N" ;
lin spherometer_N = mkTerm "spherometer_N" ;
lin spherule_N = mkTerm "spherule_N" ;
lin sphincter_N = mkTerm "sphincter_N" ;
lin sphingine_A = mkTerm "sphingine_A" ;
lin sphinx_N = mkTerm "sphinx_N" ;
lin sphygmomanometer_N = mkTerm "sphygmomanometer_N" ;
lin spic_N = mkTerm "spic_N" ;
lin spicate_A = mkTerm "spicate_A" ;
lin spiccato_N = mkTerm "spiccato_N" ;
lin spice_N = mkTerm "spice_N" ;
lin spice_V2 = mkTerm "spice_V2" ;
lin spicebush_N = mkTerm "spicebush_N" ;
lin spicemill_N = mkTerm "spicemill_N" ;
lin spiciness_N = mkTerm "spiciness_N" ;
lin spick_A = mkTerm "spick_A" ;
lin spicule_N = mkTerm "spicule_N" ;
lin spicy_A = mkTerm "spicy_A" ;
lin spider_N = mkTerm "spider_N" ;
lin spiderflower_N = mkTerm "spiderflower_N" ;
lin spiderwort_N = mkTerm "spiderwort_N" ;
lin spidery_A = mkTerm "spidery_A" ;
lin spiegeleisen_N = mkTerm "spiegeleisen_N" ;
lin spiel_N = mkTerm "spiel_N" ;
lin spiel_V = mkTerm "spiel_V" ;
lin spiel_V2 = mkTerm "spiel_V2" ;
lin spiff_N = mkTerm "spiff_N" ;
lin spiffing_A = mkTerm "spiffing_A" ;
lin spigot_N = mkTerm "spigot_N" ;
lin spike_N = mkTerm "spike_N" ;
lin spike_V2 = mkTerm "spike_V2" ;
lin spikelike_A = mkTerm "spikelike_A" ;
lin spikemoss_N = mkTerm "spikemoss_N" ;
lin spikenard_N = mkTerm "spikenard_N" ;
lin spiky_A = mkTerm "spiky_A" ;
lin spill_N = mkTerm "spill_N" ;
lin spill_V = mkTerm "spill_V" ;
lin spill_V2 = mkTerm "spill_V2" ;
lin spill_out_V = mkTerm "spill_out_V" ;
lin spill_over_V = mkTerm "spill_over_V" ;
lin spillage_N = mkTerm "spillage_N" ;
lin spillover_N = mkTerm "spillover_N" ;
lin spillway_N = mkTerm "spillway_N" ;
lin spin_N = mkTerm "spin_N" ;
lin spin_V = mkTerm "spin_V" ;
lin spin_V2 = mkTerm "spin_V2" ;
lin spin_drier_N = mkTerm "spin_drier_N" ;
lin spin_dry_V2 = mkTerm "spin_dry_V2" ;
lin spin_off_N = mkTerm "spin_off_N" ;
lin spin_off_V2 = mkTerm "spin_off_V2" ;
lin spin_out_V = mkTerm "spin_out_V" ;
lin spin_out_V2 = mkTerm "spin_out_V2" ;
lin spinach_N = mkTerm "spinach_N" ;
lin spinal_A = mkTerm "spinal_A" ;
lin spindle_N = mkTerm "spindle_N" ;
lin spindle_berry_N = mkTerm "spindle_berry_N" ;
lin spindle_legged_A = mkTerm "spindle_legged_A" ;
lin spindle_shanked_A = mkTerm "spindle_shanked_A" ;
lin spindle_shanks_N = mkTerm "spindle_shanks_N" ;
lin spindle_tree_N = mkTerm "spindle_tree_N" ;
lin spindlelegs_N = mkTerm "spindlelegs_N" ;
lin spindly_A = mkTerm "spindly_A" ;
lin spindrift_N = mkTerm "spindrift_N" ;
lin spine_N = mkTerm "spine_N" ;
lin spinel_N = mkTerm "spinel_N" ;
lin spineless_A = mkTerm "spineless_A" ;
lin spinelessness_N = mkTerm "spinelessness_N" ;
lin spinet_N = mkTerm "spinet_N" ;
lin spinnability_N = mkTerm "spinnability_N" ;
lin spinnable_A = mkTerm "spinnable_A" ;
lin spinnaker_N = mkTerm "spinnaker_N" ;
lin spinnbarkeit_N = mkTerm "spinnbarkeit_N" ;
lin spinner_N = mkTerm "spinner_N" ;
lin spinney_N = mkTerm "spinney_N" ;
lin spinning_N = mkTerm "spinning_N" ;
lin spinning_wheel_N = mkTerm "spinning_wheel_N" ;
lin spinoff_N = mkTerm "spinoff_N" ;
lin spinose_A = mkTerm "spinose_A" ;
lin spinous_A = mkTerm "spinous_A" ;
lin spinster_N = mkTerm "spinster_N" ;
lin spinsterhood_N = mkTerm "spinsterhood_N" ;
lin spiny_A = mkTerm "spiny_A" ;
lin spiracle_N = mkTerm "spiracle_N" ;
lin spiral_A = mkTerm "spiral_A" ;
lin spiral_N = mkTerm "spiral_N" ;
lin spiral_V = mkTerm "spiral_V" ;
lin spire_N = mkTerm "spire_N" ;
lin spirea_N = mkTerm "spirea_N" ;
lin spirillum_N = mkTerm "spirillum_N" ;
lin spirit_N = mkTerm "spirit_N" ;
lin spirit_V2 = mkTerm "spirit_V2" ;
lin spirit_away_V2 = mkTerm "spirit_away_V2" ;
lin spirit_lamp_N = mkTerm "spirit_lamp_N" ;
lin spirit_level_N = mkTerm "spirit_level_N" ;
lin spirit_off_V2 = mkTerm "spirit_off_V2" ;
lin spirit_rapper_N = mkTerm "spirit_rapper_N" ;
lin spirit_stove_N = mkTerm "spirit_stove_N" ;
lin spiritedly_Adv = mkTerm "spiritedly_Adv" ;
lin spiritless_A = mkTerm "spiritless_A" ;
lin spiritual_A = mkTerm "spiritual_A" ;
lin spiritual_N = mkTerm "spiritual_N" ;
lin spiritualism_N = mkTerm "spiritualism_N" ;
lin spiritualistFem_N = mkTerm "spiritualistFem_N" ;
lin spiritualistMasc_N = mkTerm "spiritualistMasc_N" ;
lin spiritualistic_A = mkTerm "spiritualistic_A" ;
lin spirituality_N = mkTerm "spirituality_N" ;
lin spiritualization_N = mkTerm "spiritualization_N" ;
lin spiritualize_V2 = mkTerm "spiritualize_V2" ;
lin spiritualty_N = mkTerm "spiritualty_N" ;
lin spirituous_A = mkTerm "spirituous_A" ;
lin spirochete_N = mkTerm "spirochete_N" ;
lin spirogram_N = mkTerm "spirogram_N" ;
lin spirograph_N = mkTerm "spirograph_N" ;
lin spirogyra_N = mkTerm "spirogyra_N" ;
lin spirometer_N = mkTerm "spirometer_N" ;
lin spirometry_N = mkTerm "spirometry_N" ;
lin spironolactone_N = mkTerm "spironolactone_N" ;
lin spirt_N = mkTerm "spirt_N" ;
lin spirt_V = mkTerm "spirt_V" ;
lin spirula_N = mkTerm "spirula_N" ;
lin spit_N = mkTerm "spit_N" ;
lin spit_V = mkTerm "spit_V" ;
lin spit_V2 = mkTerm "spit_V2" ;
lin spit_it_out_V2 = mkTerm "spit_it_out_V2" ;
lin spit_out_V2 = mkTerm "spit_out_V2" ;
lin spitball_N = mkTerm "spitball_N" ;
lin spite_N = mkTerm "spite_N" ;
lin spite_V2 = mkTerm "spite_V2" ;
lin spiteful_A = mkTerm "spiteful_A" ;
lin spitefulness_N = mkTerm "spitefulness_N" ;
lin spitfire_N = mkTerm "spitfire_N" ;
lin spitter_N = mkTerm "spitter_N" ;
lin spitting_N = mkTerm "spitting_N" ;
lin spittle_N = mkTerm "spittle_N" ;
lin spittoon_N = mkTerm "spittoon_N" ;
lin spitz_N = mkTerm "spitz_N" ;
lin spiv_N = mkTerm "spiv_N" ;
lin splash_N = mkTerm "splash_N" ;
lin splash_V = mkTerm "splash_V" ;
lin splash_V2 = mkTerm "splash_V2" ;
lin splash_down_V = mkTerm "splash_down_V" ;
lin splash_out_V = mkTerm "splash_out_V" ;
lin splash_out_on_V2 = mkTerm "splash_out_on_V2" ;
lin splashboard_N = mkTerm "splashboard_N" ;
lin splashdown_N = mkTerm "splashdown_N" ;
lin splasher_N = mkTerm "splasher_N" ;
lin splashy_A = mkTerm "splashy_A" ;
lin splat_N = mkTerm "splat_N" ;
lin splay_A = mkTerm "splay_A" ;
lin splay_N = mkTerm "splay_N" ;
lin splay_V = mkTerm "splay_V" ;
lin splay_V2 = mkTerm "splay_V2" ;
lin splayfoot_N = mkTerm "splayfoot_N" ;
lin splayfooted_A = mkTerm "splayfooted_A" ;
lin spleen_N = mkTerm "spleen_N" ;
lin spleenwort_N = mkTerm "spleenwort_N" ;
lin splendid_A = mkTerm "splendid_A" ;
lin splendiferous_A = mkTerm "splendiferous_A" ;
lin splendour_N = mkTerm "splendour_N" ;
lin splenectomy_N = mkTerm "splenectomy_N" ;
lin splenetic_A = mkTerm "splenetic_A" ;
lin splenic_A = mkTerm "splenic_A" ;
lin splenitis_N = mkTerm "splenitis_N" ;
lin splenius_N = mkTerm "splenius_N" ;
lin splenomegaly_N = mkTerm "splenomegaly_N" ;
lin splice_N = mkTerm "splice_N" ;
lin splice_V2 = mkTerm "splice_V2" ;
lin splicer_N = mkTerm "splicer_N" ;
lin spline_N = mkTerm "spline_N" ;
lin splint_N = mkTerm "splint_N" ;
lin splinter_N = mkTerm "splinter_N" ;
lin splinter_V = mkTerm "splinter_V" ;
lin splinter_V2 = mkTerm "splinter_V2" ;
lin splinter_proof_A = mkTerm "splinter_proof_A" ;
lin splintery_A = mkTerm "splintery_A" ;
lin split_N = mkTerm "split_N" ;
lin split_PN = mkTerm "split_PN" ;
lin split_V = mkTerm "split_V" ;
lin split_V2 = mkTerm "split_V2" ;
lin split_up_V = mkTerm "split_up_V" ;
lin split_up_V2 = mkTerm "split_up_V2" ;
lin splitsville_N = mkTerm "splitsville_N" ;
lin splitter_N = mkTerm "splitter_N" ;
lin splodge_N = mkTerm "splodge_N" ;
lin splosh_V2 = mkTerm "splosh_V2" ;
lin splotch_N = mkTerm "splotch_N" ;
lin splurge_N = mkTerm "splurge_N" ;
lin splurge_V = mkTerm "splurge_V" ;
lin splutter_N = mkTerm "splutter_N" ;
lin splutter_V = mkTerm "splutter_V" ;
lin splutter_V2 = mkTerm "splutter_V2" ;
lin spode_N = mkTerm "spode_N" ;
lin spodumene_N = mkTerm "spodumene_N" ;
lin spoil_N = mkTerm "spoil_N" ;
lin spoil_V = mkTerm "spoil_V" ;
lin spoil_V2 = mkTerm "spoil_V2" ;
lin spoil_for_V2 = mkTerm "spoil_for_V2" ;
lin spoilage_N = mkTerm "spoilage_N" ;
lin spoiler_N = mkTerm "spoiler_N" ;
lin spoilsport_N = mkTerm "spoilsport_N" ;
lin spoke_N = mkTerm "spoke_N" ;
lin spoken_A = mkTerm "spoken_A" ;
lin spokeshave_N = mkTerm "spokeshave_N" ;
lin spokesman_N = mkTerm "spokesman_N" ;
lin spokesperson_N = mkTerm "spokesperson_N" ;
lin spokeswoman_N = mkTerm "spokeswoman_N" ;
lin spoliation_N = mkTerm "spoliation_N" ;
lin spondaic_A = mkTerm "spondaic_A" ;
lin spondee_N = mkTerm "spondee_N" ;
lin spondylarthritis_N = mkTerm "spondylarthritis_N" ;
lin spondylitis_N = mkTerm "spondylitis_N" ;
lin spondylolisthesis_N = mkTerm "spondylolisthesis_N" ;
lin sponge_N = mkTerm "sponge_N" ;
lin sponge_V = mkTerm "sponge_V" ;
lin sponge_V2 = mkTerm "sponge_V2" ;
lin sponge_cake_N = mkTerm "sponge_cake_N" ;
lin sponge_down_V2 = mkTerm "sponge_down_V2" ;
lin sponge_off_V2 = mkTerm "sponge_off_V2" ;
lin sponge_on_V2 = mkTerm "sponge_on_V2" ;
lin spongefly_N = mkTerm "spongefly_N" ;
lin sponger_N = mkTerm "sponger_N" ;
lin sponginess_N = mkTerm "sponginess_N" ;
lin spongioblast_N = mkTerm "spongioblast_N" ;
lin spongy_A = mkTerm "spongy_A" ;
lin sponsor_N = mkTerm "sponsor_N" ;
lin sponsor_V2 = mkTerm "sponsor_V2" ;
lin sponsorship_N = mkTerm "sponsorship_N" ;
lin spontaneity_N = mkTerm "spontaneity_N" ;
lin spontaneous_A = mkTerm "spontaneous_A" ;
lin spontaneousness_N = mkTerm "spontaneousness_N" ;
lin spoof_N = mkTerm "spoof_N" ;
lin spoof_V2 = mkTerm "spoof_V2" ;
lin spook_N = mkTerm "spook_N" ;
lin spook_V2 = mkTerm "spook_V2" ;
lin spooky_A = mkTerm "spooky_A" ;
lin spool_N = mkTerm "spool_N" ;
lin spoon_N = mkTerm "spoon_N" ;
lin spoon_V = mkTerm "spoon_V" ;
lin spoon_V2 = mkTerm "spoon_V2" ;
lin spoonbill_N = mkTerm "spoonbill_N" ;
lin spoonerism_N = mkTerm "spoonerism_N" ;
lin spoonfeed_V2 = mkTerm "spoonfeed_V2" ;
lin spoonfeeding_N = mkTerm "spoonfeeding_N" ;
lin spoonful_N = mkTerm "spoonful_N" ;
lin spoor_N = mkTerm "spoor_N" ;
lin sporadic_A = mkTerm "sporadic_A" ;
lin sporangiophore_N = mkTerm "sporangiophore_N" ;
lin sporangium_N = mkTerm "sporangium_N" ;
lin spore_N = mkTerm "spore_N" ;
lin sporocarp_N = mkTerm "sporocarp_N" ;
lin sporogenous_A = mkTerm "sporogenous_A" ;
lin sporophore_N = mkTerm "sporophore_N" ;
lin sporophyll_N = mkTerm "sporophyll_N" ;
lin sporophyte_N = mkTerm "sporophyte_N" ;
lin sporotrichosis_N = mkTerm "sporotrichosis_N" ;
lin sporozoan_N = mkTerm "sporozoan_N" ;
lin sporozoite_N = mkTerm "sporozoite_N" ;
lin sporran_N = mkTerm "sporran_N" ;
lin sport_N = mkTerm "sport_N" ;
lin sport_V = mkTerm "sport_V" ;
lin sport_V2 = mkTerm "sport_V2" ;
lin sportingly_Adv = mkTerm "sportingly_Adv" ;
lin sportive_A = mkTerm "sportive_A" ;
lin sportiveness_N = mkTerm "sportiveness_N" ;
lin sports_car_N = mkTerm "sports_car_N" ;
lin sports_coat_N = mkTerm "sports_coat_N" ;
lin sports_editor_N = mkTerm "sports_editor_N" ;
lin sports_jacket_N = mkTerm "sports_jacket_N" ;
lin sportscast_N = mkTerm "sportscast_N" ;
lin sportsman_N = mkTerm "sportsman_N" ;
lin sportsmanlike_A = mkTerm "sportsmanlike_A" ;
lin sportsmanship_N = mkTerm "sportsmanship_N" ;
lin sportswear_N = mkTerm "sportswear_N" ;
lin sporty_A = mkTerm "sporty_A" ;
lin spot_N = mkTerm "spot_N" ;
lin spot_V = mkTerm "spot_V" ;
lin spot_V2 = mkTerm "spot_V2" ;
lin spot_VS = mkTerm "spot_VS" ;
lin spotless_A = mkTerm "spotless_A" ;
lin spotlessness_N = mkTerm "spotlessness_N" ;
lin spotlight_N = mkTerm "spotlight_N" ;
lin spotlight_V2 = mkTerm "spotlight_V2" ;
lin spotter_N = mkTerm "spotter_N" ;
lin spotty_A = mkTerm "spotty_A" ;
lin spousal_A = mkTerm "spousal_A" ;
lin spouseFem_N = mkTerm "spouseFem_N" ;
lin spouseMasc_N = mkTerm "spouseMasc_N" ;
lin spout_N = mkTerm "spout_N" ;
lin spout_V = mkTerm "spout_V" ;
lin spout_V2 = mkTerm "spout_V2" ;
lin spouter_N = mkTerm "spouter_N" ;
lin sprachgefuhl_N = mkTerm "sprachgefuhl_N" ;
lin sprag_N = mkTerm "sprag_N" ;
lin sprain_N = mkTerm "sprain_N" ;
lin sprain_V2 = mkTerm "sprain_V2" ;
lin sprat_N = mkTerm "sprat_N" ;
lin sprawl_N = mkTerm "sprawl_N" ;
lin sprawl_V = mkTerm "sprawl_V" ;
lin sprawl_V2 = mkTerm "sprawl_V2" ;
lin sprawler_N = mkTerm "sprawler_N" ;
lin sprawly_A = mkTerm "sprawly_A" ;
lin spray_N = mkTerm "spray_N" ;
lin spray_V2 = mkTerm "spray_V2" ;
lin spray_gun_N = mkTerm "spray_gun_N" ;
lin sprayer_N = mkTerm "sprayer_N" ;
lin spraying_N = mkTerm "spraying_N" ;
lin spread_N = mkTerm "spread_N" ;
lin spread_V = mkTerm "spread_V" ;
lin spread_V2 = mkTerm "spread_V2" ;
lin spread_out_V2 = mkTerm "spread_out_V2" ;
lin spread_over_N = mkTerm "spread_over_N" ;
lin spreadeagle_N = mkTerm "spreadeagle_N" ;
lin spreadeagle_V2 = mkTerm "spreadeagle_V2" ;
lin spreader_N = mkTerm "spreader_N" ;
lin spreadsheet_N = mkTerm "spreadsheet_N" ;
lin sprechgesang_N = mkTerm "sprechgesang_N" ;
lin spree_N = mkTerm "spree_N" ;
lin sprig_N = mkTerm "sprig_N" ;
lin sprigged_A = mkTerm "sprigged_A" ;
lin sprightliness_N = mkTerm "sprightliness_N" ;
lin sprightly_A = mkTerm "sprightly_A" ;
lin spring_1_N = mkTerm "spring_1_N" ;
lin spring_2_N = mkTerm "spring_2_N" ;
lin spring_3_N = mkTerm "spring_3_N" ;
lin spring_4_N = mkTerm "spring_4_N" ;
lin spring_V = mkTerm "spring_V" ;
lin spring_V2 = mkTerm "spring_V2" ;
lin spring_back_V = mkTerm "spring_back_V" ;
lin spring_balance_N = mkTerm "spring_balance_N" ;
lin spring_clean_N = mkTerm "spring_clean_N" ;
lin spring_clean_V2 = mkTerm "spring_clean_V2" ;
lin spring_cleaning_N = mkTerm "spring_cleaning_N" ;
lin spring_for_V2 = mkTerm "spring_for_V2" ;
lin spring_from_V2 = mkTerm "spring_from_V2" ;
lin spring_gun_N = mkTerm "spring_gun_N" ;
lin spring_mattress_N = mkTerm "spring_mattress_N" ;
lin spring_on_V3 = mkTerm "spring_on_V3" ;
lin spring_up_V = mkTerm "spring_up_V" ;
lin springboard_N = mkTerm "springboard_N" ;
lin springbok_N = mkTerm "springbok_N" ;
lin springer_N = mkTerm "springer_N" ;
lin springfield_PN = mkTerm "springfield_PN" ;
lin springless_A = mkTerm "springless_A" ;
lin springlike_A = mkTerm "springlike_A" ;
lin springtide_N = mkTerm "springtide_N" ;
lin springtime_N = mkTerm "springtime_N" ;
lin springy_A = mkTerm "springy_A" ;
lin sprinkle_N = mkTerm "sprinkle_N" ;
lin sprinkle_V2 = mkTerm "sprinkle_V2" ;
lin sprinkler_N = mkTerm "sprinkler_N" ;
lin sprinkling_N = mkTerm "sprinkling_N" ;
lin sprint_N = mkTerm "sprint_N" ;
lin sprint_V = mkTerm "sprint_V" ;
lin sprinter_N = mkTerm "sprinter_N" ;
lin sprit_N = mkTerm "sprit_N" ;
lin sprite_N = mkTerm "sprite_N" ;
lin sprites_N = mkTerm "sprites_N" ;
lin spritsail_N = mkTerm "spritsail_N" ;
lin spritz_N = mkTerm "spritz_N" ;
lin spritzer_N = mkTerm "spritzer_N" ;
lin sprocket_N = mkTerm "sprocket_N" ;
lin sprocket_wheel_N = mkTerm "sprocket_wheel_N" ;
lin sprog_N = mkTerm "sprog_N" ;
lin sprout_N = mkTerm "sprout_N" ;
lin sprout_V = mkTerm "sprout_V" ;
lin sprout_V2 = mkTerm "sprout_V2" ;
lin sprout_up_V = mkTerm "sprout_up_V" ;
lin spruce_A = mkTerm "spruce_A" ;
lin spruce_N = mkTerm "spruce_N" ;
lin spruce_V = mkTerm "spruce_V" ;
lin spruce_V2 = mkTerm "spruce_V2" ;
lin spruce_up_V2 = mkTerm "spruce_up_V2" ;
lin spruceness_N = mkTerm "spruceness_N" ;
lin sprue_N = mkTerm "sprue_N" ;
lin spry_A = mkTerm "spry_A" ;
lin spud_N = mkTerm "spud_N" ;
lin spue_V = mkTerm "spue_V" ;
lin spue_V2 = mkTerm "spue_V2" ;
lin spume_N = mkTerm "spume_N" ;
lin spunk_N = mkTerm "spunk_N" ;
lin spunky_A = mkTerm "spunky_A" ;
lin spur_N = mkTerm "spur_N" ;
lin spur_V = mkTerm "spur_V" ;
lin spur_V2 = mkTerm "spur_V2" ;
lin spur_on_V2 = mkTerm "spur_on_V2" ;
lin spurge_N = mkTerm "spurge_N" ;
lin spurious_A = mkTerm "spurious_A" ;
lin spuriousness_N = mkTerm "spuriousness_N" ;
lin spurn_V2 = mkTerm "spurn_V2" ;
lin spurner_N = mkTerm "spurner_N" ;
lin spurre_V2V = mkTerm "spurre_V2V" ;
lin spurt_N = mkTerm "spurt_N" ;
lin spurt_V = mkTerm "spurt_V" ;
lin sputnik_N = mkTerm "sputnik_N" ;
lin sputter_N = mkTerm "sputter_N" ;
lin sputter_V = mkTerm "sputter_V" ;
lin sputter_V2 = mkTerm "sputter_V2" ;
lin sputum_N = mkTerm "sputum_N" ;
lin spy_N = mkTerm "spy_N" ;
lin spy_V = mkTerm "spy_V" ;
lin spy_V2 = mkTerm "spy_V2" ;
lin spy_hole_N = mkTerm "spy_hole_N" ;
lin spyglass_N = mkTerm "spyglass_N" ;
lin spying_N = mkTerm "spying_N" ;
lin spymaster_N = mkTerm "spymaster_N" ;
lin spyware_N = mkTerm "spyware_N" ;
lin sq_PN = mkTerm "sq_PN" ;
lin squab_A = mkTerm "squab_A" ;
lin squab_N = mkTerm "squab_N" ;
lin squabble_N = mkTerm "squabble_N" ;
lin squabble_V = mkTerm "squabble_V" ;
lin squabbler_N = mkTerm "squabbler_N" ;
lin squad_N = mkTerm "squad_N" ;
lin squadron_N = mkTerm "squadron_N" ;
lin squalid_A = mkTerm "squalid_A" ;
lin squall_N = mkTerm "squall_N" ;
lin squall_V = mkTerm "squall_V" ;
lin squally_A = mkTerm "squally_A" ;
lin squalor_N = mkTerm "squalor_N" ;
lin squama_N = mkTerm "squama_N" ;
lin squamule_N = mkTerm "squamule_N" ;
lin squamulose_A = mkTerm "squamulose_A" ;
lin squander_V2 = mkTerm "squander_V2" ;
lin squandering_N = mkTerm "squandering_N" ;
lin squandermania_N = mkTerm "squandermania_N" ;
lin square_A = mkTerm "square_A" ;
lin square_Adv = mkTerm "square_Adv" ;
lin square_N = mkTerm "square_N" ;
lin square_V = mkTerm "square_V" ;
lin square_V2 = mkTerm "square_V2" ;
lin square_away_V2 = mkTerm "square_away_V2" ;
lin square_bashing_N = mkTerm "square_bashing_N" ;
lin square_built_A = mkTerm "square_built_A" ;
lin square_off_V = mkTerm "square_off_V" ;
lin square_off_against_V3 = mkTerm "square_off_against_V3" ;
lin square_rigged_A = mkTerm "square_rigged_A" ;
lin square_shouldered_A = mkTerm "square_shouldered_A" ;
lin square_toed_A = mkTerm "square_toed_A" ;
lin square_toes_N = mkTerm "square_toes_N" ;
lin square_up_V = mkTerm "square_up_V" ;
lin square_up_to_V2 = mkTerm "square_up_to_V2" ;
lin square_with_V2 = mkTerm "square_with_V2" ;
lin squareness_N = mkTerm "squareness_N" ;
lin squaretail_N = mkTerm "squaretail_N" ;
lin squarish_A = mkTerm "squarish_A" ;
lin squash_N = mkTerm "squash_N" ;
lin squash_V = mkTerm "squash_V" ;
lin squash_V2 = mkTerm "squash_V2" ;
lin squashy_A = mkTerm "squashy_A" ;
lin squat_A = mkTerm "squat_A" ;
lin squat_N = mkTerm "squat_N" ;
lin squat_V = mkTerm "squat_V" ;
lin squatness_N = mkTerm "squatness_N" ;
lin squatter_N = mkTerm "squatter_N" ;
lin squaw_N = mkTerm "squaw_N" ;
lin squawbush_N = mkTerm "squawbush_N" ;
lin squawk_N = mkTerm "squawk_N" ;
lin squawk_V = mkTerm "squawk_V" ;
lin squawker_N = mkTerm "squawker_N" ;
lin squeak_N = mkTerm "squeak_N" ;
lin squeak_V = mkTerm "squeak_V" ;
lin squeak_V2 = mkTerm "squeak_V2" ;
lin squeaker_N = mkTerm "squeaker_N" ;
lin squeaky_A = mkTerm "squeaky_A" ;
lin squeal_N = mkTerm "squeal_N" ;
lin squeal_V = mkTerm "squeal_V" ;
lin squeal_V2 = mkTerm "squeal_V2" ;
lin squealer_N = mkTerm "squealer_N" ;
lin squeamish_A = mkTerm "squeamish_A" ;
lin squeamishness_N = mkTerm "squeamishness_N" ;
lin squeegee_N = mkTerm "squeegee_N" ;
lin squeegee_V2 = mkTerm "squeegee_V2" ;
lin squeeze_N = mkTerm "squeeze_N" ;
lin squeeze_V = mkTerm "squeeze_V" ;
lin squeeze_V2 = mkTerm "squeeze_V2" ;
lin squeeze_in_V2 = mkTerm "squeeze_in_V2" ;
lin squeeze_out_V2 = mkTerm "squeeze_out_V2" ;
lin squeeze_up_V = mkTerm "squeeze_up_V" ;
lin squeezer_N = mkTerm "squeezer_N" ;
lin squelch_N = mkTerm "squelch_N" ;
lin squelch_V = mkTerm "squelch_V" ;
lin squelch_V2 = mkTerm "squelch_V2" ;
lin squib_N = mkTerm "squib_N" ;
lin squid_N = mkTerm "squid_N" ;
lin squiffy_A = mkTerm "squiffy_A" ;
lin squiggle_N = mkTerm "squiggle_N" ;
lin squiggly_A = mkTerm "squiggly_A" ;
lin squill_N = mkTerm "squill_N" ;
lin squilla_N = mkTerm "squilla_N" ;
lin squinch_N = mkTerm "squinch_N" ;
lin squinched_A = mkTerm "squinched_A" ;
lin squint_N = mkTerm "squint_N" ;
lin squint_V = mkTerm "squint_V" ;
lin squint_eyed_A = mkTerm "squint_eyed_A" ;
lin squinter_N = mkTerm "squinter_N" ;
lin squinty_A = mkTerm "squinty_A" ;
lin squire_N = mkTerm "squire_N" ;
lin squire_V2 = mkTerm "squire_V2" ;
lin squirearchy_N = mkTerm "squirearchy_N" ;
lin squirm_N = mkTerm "squirm_N" ;
lin squirm_V = mkTerm "squirm_V" ;
lin squirrel_N = mkTerm "squirrel_N" ;
lin squirrelfish_N = mkTerm "squirrelfish_N" ;
lin squirt_N = mkTerm "squirt_N" ;
lin squirt_V = mkTerm "squirt_V" ;
lin squirt_V2 = mkTerm "squirt_V2" ;
lin squish_N = mkTerm "squish_N" ;
lin sr_PN = mkTerm "sr_PN" ;
lin sri_lanka_PN = mkTerm "sri_lanka_PN" ;
lin sri_lankan_A = mkTerm "sri_lankan_A" ;
lin sri_lankan_N = mkTerm "sri_lankan_N" ;
lin srn_N = mkTerm "srn_N" ;
lin ss_N = mkTerm "ss_N" ;
lin st_PN = mkTerm "st_PN" ;
lin st_albans_PN = mkTerm "st_albans_PN" ;
lin st_andrews_PN = mkTerm "st_andrews_PN" ;
lin st_andrews_major_PN = mkTerm "st_andrews_major_PN" ;
lin st_austell_PN = mkTerm "st_austell_PN" ;
lin st_blazey_PN = mkTerm "st_blazey_PN" ;
lin st_helens_PN = mkTerm "st_helens_PN" ;
lin st_ives_PN = mkTerm "st_ives_PN" ;
lin st_louis_PN = mkTerm "st_louis_PN" ;
lin st_neots_PN = mkTerm "st_neots_PN" ;
lin st_paul_PN = mkTerm "st_paul_PN" ;
lin st_petersburg_PN = mkTerm "st_petersburg_PN" ;
lin st_stephen_PN = mkTerm "st_stephen_PN" ;
lin sta_PN = mkTerm "sta_PN" ;
lin stab_N = mkTerm "stab_N" ;
lin stab_V = mkTerm "stab_V" ;
lin stab_V2 = mkTerm "stab_V2" ;
lin stabber_N = mkTerm "stabber_N" ;
lin stabile_A = mkTerm "stabile_A" ;
lin stabile_N = mkTerm "stabile_N" ;
lin stability_N = mkTerm "stability_N" ;
lin stabilization_N = mkTerm "stabilization_N" ;
lin stabilize_V = mkTerm "stabilize_V" ;
lin stabilize_V2 = mkTerm "stabilize_V2" ;
lin stabilizer_N = mkTerm "stabilizer_N" ;
lin stable_A = mkTerm "stable_A" ;
lin stable_N = mkTerm "stable_N" ;
lin stable_V2 = mkTerm "stable_V2" ;
lin stable_companion_N = mkTerm "stable_companion_N" ;
lin stableboy_N = mkTerm "stableboy_N" ;
lin stableman_N = mkTerm "stableman_N" ;
lin stablemate_N = mkTerm "stablemate_N" ;
lin stabling_N = mkTerm "stabling_N" ;
lin staccato_A = mkTerm "staccato_A" ;
lin staccato_Adv = mkTerm "staccato_Adv" ;
lin stachyose_N = mkTerm "stachyose_N" ;
lin stack_N = mkTerm "stack_N" ;
lin stack_V2 = mkTerm "stack_V2" ;
lin stack_up_V = mkTerm "stack_up_V" ;
lin stack_up_V2 = mkTerm "stack_up_V2" ;
lin stack_up_against_V2 = mkTerm "stack_up_against_V2" ;
lin stacker_N = mkTerm "stacker_N" ;
lin stacks_N = mkTerm "stacks_N" ;
lin stackup_N = mkTerm "stackup_N" ;
lin stacte_N = mkTerm "stacte_N" ;
lin staddle_N = mkTerm "staddle_N" ;
lin stadium_N = mkTerm "stadium_N" ;
lin staff_1_N = mkTerm "staff_1_N" ;
lin staff_2_N = mkTerm "staff_2_N" ;
lin staff_V2 = mkTerm "staff_V2" ;
lin staff_office_N = mkTerm "staff_office_N" ;
lin staff_up_V2 = mkTerm "staff_up_V2" ;
lin stafford_PN = mkTerm "stafford_PN" ;
lin staffordshire_PN = mkTerm "staffordshire_PN" ;
lin stag_N = mkTerm "stag_N" ;
lin stag_V = mkTerm "stag_V" ;
lin stag_party_N = mkTerm "stag_party_N" ;
lin stage_N = mkTerm "stage_N" ;
lin stage_V = mkTerm "stage_V" ;
lin stage_V2 = mkTerm "stage_V2" ;
lin stage_struck_A = mkTerm "stage_struck_A" ;
lin stage_whisper_N = mkTerm "stage_whisper_N" ;
lin stagecoach_N = mkTerm "stagecoach_N" ;
lin stagecraft_N = mkTerm "stagecraft_N" ;
lin stagehand_N = mkTerm "stagehand_N" ;
lin stager_N = mkTerm "stager_N" ;
lin stagflation_N = mkTerm "stagflation_N" ;
lin stagflationary_A = mkTerm "stagflationary_A" ;
lin stagger_N = mkTerm "stagger_N" ;
lin stagger_V = mkTerm "stagger_V" ;
lin staggerbush_N = mkTerm "staggerbush_N" ;
lin staggerer_N = mkTerm "staggerer_N" ;
lin staggeringly_Adv = mkTerm "staggeringly_Adv" ;
lin staggers_N = mkTerm "staggers_N" ;
lin staghound_N = mkTerm "staghound_N" ;
lin staginess_N = mkTerm "staginess_N" ;
lin staging_N = mkTerm "staging_N" ;
lin stagnancy_N = mkTerm "stagnancy_N" ;
lin stagnant_A = mkTerm "stagnant_A" ;
lin stagnate_V = mkTerm "stagnate_V" ;
lin stagnation_N = mkTerm "stagnation_N" ;
lin stagy_A = mkTerm "stagy_A" ;
lin staid_A = mkTerm "staid_A" ;
lin staidness_N = mkTerm "staidness_N" ;
lin stain_N = mkTerm "stain_N" ;
lin stain_V = mkTerm "stain_V" ;
lin stain_V2 = mkTerm "stain_V2" ;
lin stainability_N = mkTerm "stainability_N" ;
lin stainable_A = mkTerm "stainable_A" ;
lin stainer_N = mkTerm "stainer_N" ;
lin staining_N = mkTerm "staining_N" ;
lin stainless_1_A = mkTerm "stainless_1_A" ;
lin stainless_2_A = mkTerm "stainless_2_A" ;
lin stair_N = mkTerm "stair_N" ;
lin stair_carpet_N = mkTerm "stair_carpet_N" ;
lin stair_rod_N = mkTerm "stair_rod_N" ;
lin staircase_N = mkTerm "staircase_N" ;
lin stairhead_N = mkTerm "stairhead_N" ;
lin stairway_N = mkTerm "stairway_N" ;
lin stairwell_N = mkTerm "stairwell_N" ;
lin stake_N = mkTerm "stake_N" ;
lin stake_V2 = mkTerm "stake_V2" ;
lin stake_holder_N = mkTerm "stake_holder_N" ;
lin stakeford_PN = mkTerm "stakeford_PN" ;
lin stakeout_N = mkTerm "stakeout_N" ;
lin stalactite_N = mkTerm "stalactite_N" ;
lin stalagmite_N = mkTerm "stalagmite_N" ;
lin stale_A = mkTerm "stale_A" ;
lin stale_V = mkTerm "stale_V" ;
lin stalemate_N = mkTerm "stalemate_N" ;
lin stalemate_V2 = mkTerm "stalemate_V2" ;
lin staleness_N = mkTerm "staleness_N" ;
lin stalk_N = mkTerm "stalk_N" ;
lin stalk_V = mkTerm "stalk_V" ;
lin stalk_V2 = mkTerm "stalk_V2" ;
lin stalker_N = mkTerm "stalker_N" ;
lin stalking_horse_N = mkTerm "stalking_horse_N" ;
lin stall_N = mkTerm "stall_N" ;
lin stall_V = mkTerm "stall_V" ;
lin stall_V2 = mkTerm "stall_V2" ;
lin stall_fed_A = mkTerm "stall_fed_A" ;
lin stallion_N = mkTerm "stallion_N" ;
lin stalwart_A = mkTerm "stalwart_A" ;
lin stalwart_N = mkTerm "stalwart_N" ;
lin stalybridge_PN = mkTerm "stalybridge_PN" ;
lin stamen_N = mkTerm "stamen_N" ;
lin stamford_PN = mkTerm "stamford_PN" ;
lin stamina_N = mkTerm "stamina_N" ;
lin stammel_N = mkTerm "stammel_N" ;
lin stammer_N = mkTerm "stammer_N" ;
lin stammer_V = mkTerm "stammer_V" ;
lin stammer_V2 = mkTerm "stammer_V2" ;
lin stammerer_N = mkTerm "stammerer_N" ;
lin stammeringly_Adv = mkTerm "stammeringly_Adv" ;
lin stamp_1_N = mkTerm "stamp_1_N" ;
lin stamp_2_N = mkTerm "stamp_2_N" ;
lin stamp_V = mkTerm "stamp_V" ;
lin stamp_V2 = mkTerm "stamp_V2" ;
lin stamp_album_N = mkTerm "stamp_album_N" ;
lin stamp_collector_N = mkTerm "stamp_collector_N" ;
lin stamp_dealer_N = mkTerm "stamp_dealer_N" ;
lin stamp_duty_N = mkTerm "stamp_duty_N" ;
lin stamp_out_V2 = mkTerm "stamp_out_V2" ;
lin stampede_N = mkTerm "stampede_N" ;
lin stampede_V = mkTerm "stampede_V" ;
lin stampede_V2 = mkTerm "stampede_V2" ;
lin stamper_N = mkTerm "stamper_N" ;
lin stamping_ground_N = mkTerm "stamping_ground_N" ;
lin stan_PN = mkTerm "stan_PN" ;
lin stance_N = mkTerm "stance_N" ;
lin stanch_V2 = mkTerm "stanch_V2" ;
lin stanchion_N = mkTerm "stanchion_N" ;
lin stand_N = mkTerm "stand_N" ;
lin stand_V = mkTerm "stand_V" ;
lin stand_V2 = mkTerm "stand_V2" ;
lin stand_about_V = mkTerm "stand_about_V" ;
lin stand_around_V = mkTerm "stand_around_V" ;
lin stand_aside_V = mkTerm "stand_aside_V" ;
lin stand_back_V = mkTerm "stand_back_V" ;
lin stand_by_V = mkTerm "stand_by_V" ;
lin stand_by_V2 = mkTerm "stand_by_V2" ;
lin stand_down_V = mkTerm "stand_down_V" ;
lin stand_for_V2 = mkTerm "stand_for_V2" ;
lin stand_in_N = mkTerm "stand_in_N" ;
lin stand_in_for_V2 = mkTerm "stand_in_for_V2" ;
lin stand_out_V = mkTerm "stand_out_V" ;
lin stand_to_N = mkTerm "stand_to_N" ;
lin stand_up_A = mkTerm "stand_up_A" ;
lin stand_up_V = mkTerm "stand_up_V" ;
lin stand_up_V2 = mkTerm "stand_up_V2" ;
lin stand_up_for_V2 = mkTerm "stand_up_for_V2" ;
lin stand_up_to_V2 = mkTerm "stand_up_to_V2" ;
lin standard_A = mkTerm "standard_A" ;
lin standard_N = mkTerm "standard_N" ;
lin standard_bearer_N = mkTerm "standard_bearer_N" ;
lin standardization_N = mkTerm "standardization_N" ;
lin standardize_V2 = mkTerm "standardize_V2" ;
lin standardizer_N = mkTerm "standardizer_N" ;
lin standby_A = mkTerm "standby_A" ;
lin standby_N = mkTerm "standby_N" ;
lin standdown_N = mkTerm "standdown_N" ;
lin standee_N = mkTerm "standee_N" ;
lin stander_N = mkTerm "stander_N" ;
lin standing_A = mkTerm "standing_A" ;
lin standing_N = mkTerm "standing_N" ;
lin standoffish_A = mkTerm "standoffish_A" ;
lin standoffishness_N = mkTerm "standoffishness_N" ;
lin standpipe_N = mkTerm "standpipe_N" ;
lin standpoint_N = mkTerm "standpoint_N" ;
lin standstill_N = mkTerm "standstill_N" ;
lin stanford_PN = mkTerm "stanford_PN" ;
lin stanhope_N = mkTerm "stanhope_N" ;
lin stanhopea_N = mkTerm "stanhopea_N" ;
lin stanley_PN = mkTerm "stanley_PN" ;
lin stannic_A = mkTerm "stannic_A" ;
lin stannite_N = mkTerm "stannite_N" ;
lin stanza_N = mkTerm "stanza_N" ;
lin stapedectomy_N = mkTerm "stapedectomy_N" ;
lin stapelia_N = mkTerm "stapelia_N" ;
lin stapes_N = mkTerm "stapes_N" ;
lin staphylococcal_A = mkTerm "staphylococcal_A" ;
lin staphylococcus_N = mkTerm "staphylococcus_N" ;
lin staple_A = mkTerm "staple_A" ;
lin staple_N = mkTerm "staple_N" ;
lin staple_V2 = mkTerm "staple_V2" ;
lin stapler_N = mkTerm "stapler_N" ;
lin stapling_machine_N = mkTerm "stapling_machine_N" ;
lin star_N = mkTerm "star_N" ;
lin star_V2 = mkTerm "star_V2" ;
lin starboard_A = mkTerm "starboard_A" ;
lin starboard_N = mkTerm "starboard_N" ;
lin starboard_V2 = mkTerm "starboard_V2" ;
lin starch_N = mkTerm "starch_N" ;
lin starch_V2 = mkTerm "starch_V2" ;
lin starches_N = mkTerm "starches_N" ;
lin starchless_A = mkTerm "starchless_A" ;
lin starchlike_A = mkTerm "starchlike_A" ;
lin starchy_A = mkTerm "starchy_A" ;
lin stardom_N = mkTerm "stardom_N" ;
lin stardust_N = mkTerm "stardust_N" ;
lin stare_N = mkTerm "stare_N" ;
lin stare_V = mkTerm "stare_V" ;
lin stare_V2 = mkTerm "stare_V2" ;
lin stare_down_V2 = mkTerm "stare_down_V2" ;
lin starer_N = mkTerm "starer_N" ;
lin starets_N = mkTerm "starets_N" ;
lin starfish_N = mkTerm "starfish_N" ;
lin starflower_N = mkTerm "starflower_N" ;
lin stargazer_N = mkTerm "stargazer_N" ;
lin stargazing_N = mkTerm "stargazing_N" ;
lin staring_Adv = mkTerm "staring_Adv" ;
lin stark_A = mkTerm "stark_A" ;
lin stark_Adv = mkTerm "stark_Adv" ;
lin starkers_A = mkTerm "starkers_A" ;
lin starkness_N = mkTerm "starkness_N" ;
lin starless_A = mkTerm "starless_A" ;
lin starlet_N = mkTerm "starlet_N" ;
lin starlight_N = mkTerm "starlight_N" ;
lin starlike_A = mkTerm "starlike_A" ;
lin starling_N = mkTerm "starling_N" ;
lin starlit_A = mkTerm "starlit_A" ;
lin starry_A = mkTerm "starry_A" ;
lin starry_eyed_A = mkTerm "starry_eyed_A" ;
lin starship_N = mkTerm "starship_N" ;
lin start_N = mkTerm "start_N" ;
lin start_V = mkTerm "start_V" ;
lin start_V2 = mkTerm "start_V2" ;
lin start_ing_VV = mkTerm "start_ing_VV" ;
lin start_off_V = mkTerm "start_off_V" ;
lin start_off_V2 = mkTerm "start_off_V2" ;
lin start_off_on_V2 = mkTerm "start_off_on_V2" ;
lin start_on_V2 = mkTerm "start_on_V2" ;
lin start_on_at_V2 = mkTerm "start_on_at_V2" ;
lin start_out_V = mkTerm "start_out_V" ;
lin start_out_as_V2 = mkTerm "start_out_as_V2" ;
lin start_out_to_V2 = mkTerm "start_out_to_V2" ;
lin start_over_V = mkTerm "start_over_V" ;
lin start_to_VV = mkTerm "start_to_VV" ;
lin start_up_V = mkTerm "start_up_V" ;
lin start_up_V2 = mkTerm "start_up_V2" ;
lin starter_1_N = mkTerm "starter_1_N" ;
lin starter_2_N = mkTerm "starter_2_N" ;
lin starter_3_N = mkTerm "starter_3_N" ;
lin starter_4_N = mkTerm "starter_4_N" ;
lin starter_5_N = mkTerm "starter_5_N" ;
lin starter_6_N = mkTerm "starter_6_N" ;
lin starter_7_N = mkTerm "starter_7_N" ;
lin starting_gate_N = mkTerm "starting_gate_N" ;
lin starting_point_N = mkTerm "starting_point_N" ;
lin starting_post_N = mkTerm "starting_post_N" ;
lin startle_N = mkTerm "startle_N" ;
lin startle_V2 = mkTerm "startle_V2" ;
lin startling_A = mkTerm "startling_A" ;
lin startup_N = mkTerm "startup_N" ;
lin starvation_N = mkTerm "starvation_N" ;
lin starve_V = mkTerm "starve_V" ;
lin starve_V2 = mkTerm "starve_V2" ;
lin starveling_N = mkTerm "starveling_N" ;
lin stash_V2 = mkTerm "stash_V2" ;
lin stash_away_V2 = mkTerm "stash_away_V2" ;
lin stasis_N = mkTerm "stasis_N" ;
lin state_1_N = mkTerm "state_1_N" ;
lin state_2_N = mkTerm "state_2_N" ;
lin state_V2 = mkTerm "state_V2" ;
lin state_VS = mkTerm "state_VS" ;
lin statecraft_N = mkTerm "statecraft_N" ;
lin statehood_N = mkTerm "statehood_N" ;
lin statehouse_N = mkTerm "statehouse_N" ;
lin stateless_A = mkTerm "stateless_A" ;
lin stateliness_N = mkTerm "stateliness_N" ;
lin stately_A = mkTerm "stately_A" ;
lin statement_N = mkTerm "statement_N" ;
lin stater_N = mkTerm "stater_N" ;
lin stateroom_N = mkTerm "stateroom_N" ;
lin statesman_N = mkTerm "statesman_N" ;
lin statesmanlike_A = mkTerm "statesmanlike_A" ;
lin statesmanship_N = mkTerm "statesmanship_N" ;
lin stateswoman_N = mkTerm "stateswoman_N" ;
lin statewide_A = mkTerm "statewide_A" ;
lin static_A = mkTerm "static_A" ;
lin static_N = mkTerm "static_N" ;
lin statically_Adv = mkTerm "statically_Adv" ;
lin statics_N = mkTerm "statics_N" ;
lin station_1_N = mkTerm "station_1_N" ;
lin station_2_N = mkTerm "station_2_N" ;
lin station_V2 = mkTerm "station_V2" ;
lin station_waggon_N = mkTerm "station_waggon_N" ;
lin stationariness_N = mkTerm "stationariness_N" ;
lin stationary_A = mkTerm "stationary_A" ;
lin stationer_N = mkTerm "stationer_N" ;
lin stationery_N = mkTerm "stationery_N" ;
lin stationmaster_N = mkTerm "stationmaster_N" ;
lin statistic_N = mkTerm "statistic_N" ;
lin statistical_A = mkTerm "statistical_A" ;
lin statisticianFem_N = mkTerm "statisticianFem_N" ;
lin statisticianMasc_N = mkTerm "statisticianMasc_N" ;
lin statistics_N = mkTerm "statistics_N" ;
lin stative_A = mkTerm "stative_A" ;
lin stator_N = mkTerm "stator_N" ;
lin statuary_A = mkTerm "statuary_A" ;
lin statuary_N = mkTerm "statuary_N" ;
lin statue_N = mkTerm "statue_N" ;
lin statuesque_A = mkTerm "statuesque_A" ;
lin statuette_N = mkTerm "statuette_N" ;
lin stature_N = mkTerm "stature_N" ;
lin status_N = mkTerm "status_N" ;
lin status_quo_N = mkTerm "status_quo_N" ;
lin statute_N = mkTerm "statute_N" ;
lin statute_book_N = mkTerm "statute_book_N" ;
lin statutory_A = mkTerm "statutory_A" ;
lin staunch_A = mkTerm "staunch_A" ;
lin staunch_V2 = mkTerm "staunch_V2" ;
lin staunchness_N = mkTerm "staunchness_N" ;
lin staurikosaur_N = mkTerm "staurikosaur_N" ;
lin stave_N = mkTerm "stave_N" ;
lin stave_V = mkTerm "stave_V" ;
lin stave_V2 = mkTerm "stave_V2" ;
lin stave_in_V2 = mkTerm "stave_in_V2" ;
lin stave_off_V2 = mkTerm "stave_off_V2" ;
lin stay_N = mkTerm "stay_N" ;
lin stay_V = mkTerm "stay_V" ;
lin stay_VA = mkTerm "stay_VA" ;
lin stay_at_home_N = mkTerm "stay_at_home_N" ;
lin stay_away_V = mkTerm "stay_away_V" ;
lin stay_away_from_V2 = mkTerm "stay_away_from_V2" ;
lin stay_in_V = mkTerm "stay_in_V" ;
lin stay_on_V = mkTerm "stay_on_V" ;
lin stay_out_V = mkTerm "stay_out_V" ;
lin stay_over_V = mkTerm "stay_over_V" ;
lin stay_up_V = mkTerm "stay_up_V" ;
lin stayer_N = mkTerm "stayer_N" ;
lin staysail_N = mkTerm "staysail_N" ;
lin std_PN = mkTerm "std_PN" ;
lin stead_N = mkTerm "stead_N" ;
lin steadfast_A = mkTerm "steadfast_A" ;
lin steadfastness_N = mkTerm "steadfastness_N" ;
lin steadiness_N = mkTerm "steadiness_N" ;
lin steady_A = mkTerm "steady_A" ;
lin steady_Adv = mkTerm "steady_Adv" ;
lin steady_N = mkTerm "steady_N" ;
lin steady_V = mkTerm "steady_V" ;
lin steady_V2 = mkTerm "steady_V2" ;
lin steak_N = mkTerm "steak_N" ;
lin steakhouse_N = mkTerm "steakhouse_N" ;
lin steal_N = mkTerm "steal_N" ;
lin steal_V = mkTerm "steal_V" ;
lin steal_V2 = mkTerm "steal_V2" ;
lin steal_away_V = mkTerm "steal_away_V" ;
lin steal_out_V = mkTerm "steal_out_V" ;
lin steal_over_V2 = mkTerm "steal_over_V2" ;
lin steal_up_V = mkTerm "steal_up_V" ;
lin steal_up_on_V2 = mkTerm "steal_up_on_V2" ;
lin stealth_N = mkTerm "stealth_N" ;
lin stealthy_A = mkTerm "stealthy_A" ;
lin steam_N = mkTerm "steam_N" ;
lin steam_V = mkTerm "steam_V" ;
lin steam_V2 = mkTerm "steam_V2" ;
lin steam_boiler_N = mkTerm "steam_boiler_N" ;
lin steam_coal_N = mkTerm "steam_coal_N" ;
lin steam_engine_N = mkTerm "steam_engine_N" ;
lin steam_heat_N = mkTerm "steam_heat_N" ;
lin steam_heat_V2 = mkTerm "steam_heat_V2" ;
lin steamboat_N = mkTerm "steamboat_N" ;
lin steamer_N = mkTerm "steamer_N" ;
lin steamfitter_N = mkTerm "steamfitter_N" ;
lin steamroller_N = mkTerm "steamroller_N" ;
lin steamroller_V2 = mkTerm "steamroller_V2" ;
lin steamship_N = mkTerm "steamship_N" ;
lin steamy_A = mkTerm "steamy_A" ;
lin stearic_A = mkTerm "stearic_A" ;
lin stearin_N = mkTerm "stearin_N" ;
lin steatopygia_N = mkTerm "steatopygia_N" ;
lin steatorrhea_N = mkTerm "steatorrhea_N" ;
lin steed_N = mkTerm "steed_N" ;
lin steel_N = mkTerm "steel_N" ;
lin steel_V2 = mkTerm "steel_V2" ;
lin steel_clad_A = mkTerm "steel_clad_A" ;
lin steel_plated_A = mkTerm "steel_plated_A" ;
lin steelmaker_N = mkTerm "steelmaker_N" ;
lin steelworks_N = mkTerm "steelworks_N" ;
lin steely_A = mkTerm "steely_A" ;
lin steelyard_N = mkTerm "steelyard_N" ;
lin steenbok_N = mkTerm "steenbok_N" ;
lin steep_A = mkTerm "steep_A" ;
lin steep_N = mkTerm "steep_N" ;
lin steep_V = mkTerm "steep_V" ;
lin steep_V2 = mkTerm "steep_V2" ;
lin steepen_V = mkTerm "steepen_V" ;
lin steepen_V2 = mkTerm "steepen_V2" ;
lin steeper_N = mkTerm "steeper_N" ;
lin steepish_A = mkTerm "steepish_A" ;
lin steeple_N = mkTerm "steeple_N" ;
lin steeplechase_N = mkTerm "steeplechase_N" ;
lin steeplechaser_N = mkTerm "steeplechaser_N" ;
lin steeplejack_N = mkTerm "steeplejack_N" ;
lin steepness_N = mkTerm "steepness_N" ;
lin steer_N = mkTerm "steer_N" ;
lin steer_V = mkTerm "steer_V" ;
lin steer_V2 = mkTerm "steer_V2" ;
lin steer_clear_of_V2 = mkTerm "steer_clear_of_V2" ;
lin steerable_A = mkTerm "steerable_A" ;
lin steerage_N = mkTerm "steerage_N" ;
lin steerageway_N = mkTerm "steerageway_N" ;
lin steering_N = mkTerm "steering_N" ;
lin steering_gear_N = mkTerm "steering_gear_N" ;
lin steering_wheel_N = mkTerm "steering_wheel_N" ;
lin steersman_N = mkTerm "steersman_N" ;
lin stegosaur_N = mkTerm "stegosaur_N" ;
lin stele_N = mkTerm "stele_N" ;
lin stelis_N = mkTerm "stelis_N" ;
lin stella_PN = mkTerm "stella_PN" ;
lin stellar_A = mkTerm "stellar_A" ;
lin stem_N = mkTerm "stem_N" ;
lin stem_V = mkTerm "stem_V" ;
lin stem_V2 = mkTerm "stem_V2" ;
lin stem_from_V2 = mkTerm "stem_from_V2" ;
lin stemless_A = mkTerm "stemless_A" ;
lin stemma_N = mkTerm "stemma_N" ;
lin stemmatic_A = mkTerm "stemmatic_A" ;
lin stemmatology_N = mkTerm "stemmatology_N" ;
lin stemmer_N = mkTerm "stemmer_N" ;
lin sten_PN = mkTerm "sten_PN" ;
lin stench_N = mkTerm "stench_N" ;
lin stencil_N = mkTerm "stencil_N" ;
lin stencil_V2 = mkTerm "stencil_V2" ;
lin stenograph_N = mkTerm "stenograph_N" ;
lin stenographer_N = mkTerm "stenographer_N" ;
lin stenographic_A = mkTerm "stenographic_A" ;
lin stenography_N = mkTerm "stenography_N" ;
lin stenopterygius_N = mkTerm "stenopterygius_N" ;
lin stenosed_A = mkTerm "stenosed_A" ;
lin stenosis_N = mkTerm "stenosis_N" ;
lin stent_N = mkTerm "stent_N" ;
lin stentor_N = mkTerm "stentor_N" ;
lin stentorian_A = mkTerm "stentorian_A" ;
lin step_N = mkTerm "step_N" ;
lin step_V = mkTerm "step_V" ;
lin step_V2 = mkTerm "step_V2" ;
lin step_aside_V = mkTerm "step_aside_V" ;
lin step_back_V = mkTerm "step_back_V" ;
lin step_down_V = mkTerm "step_down_V" ;
lin step_down_V2 = mkTerm "step_down_V2" ;
lin step_forward_V = mkTerm "step_forward_V" ;
lin step_in_V = mkTerm "step_in_V" ;
lin step_on_it_V2 = mkTerm "step_on_it_V2" ;
lin step_out_V = mkTerm "step_out_V" ;
lin step_to_V2 = mkTerm "step_to_V2" ;
lin step_up_V2 = mkTerm "step_up_V2" ;
lin stepbrother_N = mkTerm "stepbrother_N" ;
lin stepchild_N = mkTerm "stepchild_N" ;
lin stepdaughter_N = mkTerm "stepdaughter_N" ;
lin stepfather_N = mkTerm "stepfather_N" ;
lin stephanie_PN = mkTerm "stephanie_PN" ;
lin stephanion_N = mkTerm "stephanion_N" ;
lin stephanotis_N = mkTerm "stephanotis_N" ;
lin stephen_PN = mkTerm "stephen_PN" ;
lin stepladder_N = mkTerm "stepladder_N" ;
lin stepmother_N = mkTerm "stepmother_N" ;
lin stepparent_N = mkTerm "stepparent_N" ;
lin steppe_N = mkTerm "steppe_N" ;
lin stepper_N = mkTerm "stepper_N" ;
lin stepping_stone_N = mkTerm "stepping_stone_N" ;
lin steprelationship_N = mkTerm "steprelationship_N" ;
lin steps_N = mkTerm "steps_N" ;
lin stepsister_N = mkTerm "stepsister_N" ;
lin stepson_N = mkTerm "stepson_N" ;
lin stepwise_Adv = mkTerm "stepwise_Adv" ;
lin steradian_N = mkTerm "steradian_N" ;
lin sterculia_N = mkTerm "sterculia_N" ;
lin stereo_A = mkTerm "stereo_A" ;
lin stereo_N = mkTerm "stereo_N" ;
lin stereophonic_A = mkTerm "stereophonic_A" ;
lin stereoscope_N = mkTerm "stereoscope_N" ;
lin stereoscopic_A = mkTerm "stereoscopic_A" ;
lin stereotype_N = mkTerm "stereotype_N" ;
lin stereotype_V2 = mkTerm "stereotype_V2" ;
lin stereotypical_A = mkTerm "stereotypical_A" ;
lin sterile_A = mkTerm "sterile_A" ;
lin sterility_N = mkTerm "sterility_N" ;
lin sterilization_N = mkTerm "sterilization_N" ;
lin sterilize_V = mkTerm "sterilize_V" ;
lin sterilize_V2 = mkTerm "sterilize_V2" ;
lin sterling_A = mkTerm "sterling_A" ;
lin sterling_N = mkTerm "sterling_N" ;
lin stern_A = mkTerm "stern_A" ;
lin stern_N = mkTerm "stern_N" ;
lin sternal_A = mkTerm "sternal_A" ;
lin sternness_N = mkTerm "sternness_N" ;
lin sternocleidomastoid_N = mkTerm "sternocleidomastoid_N" ;
lin sternpost_N = mkTerm "sternpost_N" ;
lin sternum_N = mkTerm "sternum_N" ;
lin sternutator_N = mkTerm "sternutator_N" ;
lin sternutatory_A = mkTerm "sternutatory_A" ;
lin sternwheeler_N = mkTerm "sternwheeler_N" ;
lin steroid_N = mkTerm "steroid_N" ;
lin steroidal_A = mkTerm "steroidal_A" ;
lin sterol_N = mkTerm "sterol_N" ;
lin stertorous_A = mkTerm "stertorous_A" ;
lin stethoscope_N = mkTerm "stethoscope_N" ;
lin stetson_N = mkTerm "stetson_N" ;
lin steve_PN = mkTerm "steve_PN" ;
lin stevedore_N = mkTerm "stevedore_N" ;
lin steven_PN = mkTerm "steven_PN" ;
lin stevenage_PN = mkTerm "stevenage_PN" ;
lin stevenston_PN = mkTerm "stevenston_PN" ;
lin stevia_N = mkTerm "stevia_N" ;
lin stew_N = mkTerm "stew_N" ;
lin stew_V = mkTerm "stew_V" ;
lin stew_V2 = mkTerm "stew_V2" ;
lin steward_N = mkTerm "steward_N" ;
lin stewardess_N = mkTerm "stewardess_N" ;
lin stewardship_N = mkTerm "stewardship_N" ;
lin stewart_PN = mkTerm "stewart_PN" ;
lin stewing_N = mkTerm "stewing_N" ;
lin steyning_PN = mkTerm "steyning_PN" ;
lin sthene_N = mkTerm "sthene_N" ;
lin stibnite_N = mkTerm "stibnite_N" ;
lin stick_N = mkTerm "stick_N" ;
lin stick_V = mkTerm "stick_V" ;
lin stick_V2 = mkTerm "stick_V2" ;
lin stick_around_V = mkTerm "stick_around_V" ;
lin stick_at_V2 = mkTerm "stick_at_V2" ;
lin stick_by_V2 = mkTerm "stick_by_V2" ;
lin stick_down_V2 = mkTerm "stick_down_V2" ;
lin stick_in_the_mud_A = mkTerm "stick_in_the_mud_A" ;
lin stick_in_the_mud_N = mkTerm "stick_in_the_mud_N" ;
lin stick_it_to_V2 = mkTerm "stick_it_to_V2" ;
lin stick_on_A = mkTerm "stick_on_A" ;
lin stick_out_V = mkTerm "stick_out_V" ;
lin stick_out_V2 = mkTerm "stick_out_V2" ;
lin stick_out_for_V2 = mkTerm "stick_out_for_V2" ;
lin stick_to_V2 = mkTerm "stick_to_V2" ;
lin stick_together_V = mkTerm "stick_together_V" ;
lin stick_up_N = mkTerm "stick_up_N" ;
lin stick_up_V = mkTerm "stick_up_V" ;
lin stick_up_V2 = mkTerm "stick_up_V2" ;
lin stick_up_for_V2 = mkTerm "stick_up_for_V2" ;
lin stick_with_V2 = mkTerm "stick_with_V2" ;
lin stickball_N = mkTerm "stickball_N" ;
lin sticker_N = mkTerm "sticker_N" ;
lin stickiness_N = mkTerm "stickiness_N" ;
lin sticking_plaster_N = mkTerm "sticking_plaster_N" ;
lin stickleback_N = mkTerm "stickleback_N" ;
lin stickler_N = mkTerm "stickler_N" ;
lin stickpin_N = mkTerm "stickpin_N" ;
lin sticktight_N = mkTerm "sticktight_N" ;
lin stickweed_N = mkTerm "stickweed_N" ;
lin sticky_A = mkTerm "sticky_A" ;
lin stiff_A = mkTerm "stiff_A" ;
lin stiff_Adv = mkTerm "stiff_Adv" ;
lin stiff_N = mkTerm "stiff_N" ;
lin stiff_necked_A = mkTerm "stiff_necked_A" ;
lin stiffen_V = mkTerm "stiffen_V" ;
lin stiffen_V2 = mkTerm "stiffen_V2" ;
lin stiffen_up_V = mkTerm "stiffen_up_V" ;
lin stiffen_up_V2 = mkTerm "stiffen_up_V2" ;
lin stiffener_N = mkTerm "stiffener_N" ;
lin stiffening_N = mkTerm "stiffening_N" ;
lin stiffness_N = mkTerm "stiffness_N" ;
lin stifle_N = mkTerm "stifle_N" ;
lin stifle_V = mkTerm "stifle_V" ;
lin stifle_V2 = mkTerm "stifle_V2" ;
lin stifler_N = mkTerm "stifler_N" ;
lin stigma_N = mkTerm "stigma_N" ;
lin stigmata_N = mkTerm "stigmata_N" ;
lin stigmatic_A = mkTerm "stigmatic_A" ;
lin stigmatic_N = mkTerm "stigmatic_N" ;
lin stigmatism_N = mkTerm "stigmatism_N" ;
lin stigmatization_N = mkTerm "stigmatization_N" ;
lin stigmatize_V2 = mkTerm "stigmatize_V2" ;
lin stile_N = mkTerm "stile_N" ;
lin stiletto_N = mkTerm "stiletto_N" ;
lin still_A = mkTerm "still_A" ;
lin still_AdA = mkTerm "still_AdA" ;
lin still_AdV = mkTerm "still_AdV" ;
lin still_Adv = mkTerm "still_Adv" ;
lin still_N = mkTerm "still_N" ;
lin still_V2 = mkTerm "still_V2" ;
lin still_life_N = mkTerm "still_life_N" ;
lin still_room_N = mkTerm "still_room_N" ;
lin stillbirth_N = mkTerm "stillbirth_N" ;
lin stillborn_A = mkTerm "stillborn_A" ;
lin stillness_N = mkTerm "stillness_N" ;
lin stilly_A = mkTerm "stilly_A" ;
lin stilt_N = mkTerm "stilt_N" ;
lin stilted_A = mkTerm "stilted_A" ;
lin stilton_N = mkTerm "stilton_N" ;
lin stimulant_A = mkTerm "stimulant_A" ;
lin stimulant_N = mkTerm "stimulant_N" ;
lin stimulate_V2 = mkTerm "stimulate_V2" ;
lin stimulating_A = mkTerm "stimulating_A" ;
lin stimulation_N = mkTerm "stimulation_N" ;
lin stimulative_A = mkTerm "stimulative_A" ;
lin stimulus_N = mkTerm "stimulus_N" ;
lin sting_N = mkTerm "sting_N" ;
lin sting_V = mkTerm "sting_V" ;
lin sting_V2 = mkTerm "sting_V2" ;
lin stinger_N = mkTerm "stinger_N" ;
lin stinginess_N = mkTerm "stinginess_N" ;
lin stingless_A = mkTerm "stingless_A" ;
lin stingray_N = mkTerm "stingray_N" ;
lin stingy_A = mkTerm "stingy_A" ;
lin stink_N = mkTerm "stink_N" ;
lin stink_V = mkTerm "stink_V" ;
lin stink_V2 = mkTerm "stink_V2" ;
lin stinker_N = mkTerm "stinker_N" ;
lin stinkhorn_N = mkTerm "stinkhorn_N" ;
lin stint_N = mkTerm "stint_N" ;
lin stint_V = mkTerm "stint_V" ;
lin stint_V2 = mkTerm "stint_V2" ;
lin stinter_N = mkTerm "stinter_N" ;
lin stipe_N = mkTerm "stipe_N" ;
lin stipend_N = mkTerm "stipend_N" ;
lin stipendiary_A = mkTerm "stipendiary_A" ;
lin stipendiary_N = mkTerm "stipendiary_N" ;
lin stipple_V2 = mkTerm "stipple_V2" ;
lin stippler_N = mkTerm "stippler_N" ;
lin stipulate_V = mkTerm "stipulate_V" ;
lin stipulate_V2 = mkTerm "stipulate_V2" ;
lin stipulate_VS = mkTerm "stipulate_VS" ;
lin stipulation_N = mkTerm "stipulation_N" ;
lin stipule_N = mkTerm "stipule_N" ;
lin stir_N = mkTerm "stir_N" ;
lin stir_V = mkTerm "stir_V" ;
lin stir_V2 = mkTerm "stir_V2" ;
lin stir_up_V2 = mkTerm "stir_up_V2" ;
lin stirk_N = mkTerm "stirk_N" ;
lin stirling_PN = mkTerm "stirling_PN" ;
lin stirrer_N = mkTerm "stirrer_N" ;
lin stirring_N = mkTerm "stirring_N" ;
lin stirringly_Adv = mkTerm "stirringly_Adv" ;
lin stirrup_N = mkTerm "stirrup_N" ;
lin stirrup_cup_N = mkTerm "stirrup_cup_N" ;
lin stitch_N = mkTerm "stitch_N" ;
lin stitch_V = mkTerm "stitch_V" ;
lin stitch_V2 = mkTerm "stitch_V2" ;
lin stitch_up_V2 = mkTerm "stitch_up_V2" ;
lin stitcher_N = mkTerm "stitcher_N" ;
lin stitchwort_N = mkTerm "stitchwort_N" ;
lin stoat_N = mkTerm "stoat_N" ;
lin stob_N = mkTerm "stob_N" ;
lin stochastic_A = mkTerm "stochastic_A" ;
lin stock_A = mkTerm "stock_A" ;
lin stock_N = mkTerm "stock_N" ;
lin stock_V2 = mkTerm "stock_V2" ;
lin stock_cube_N = mkTerm "stock_cube_N" ;
lin stock_farmer_N = mkTerm "stock_farmer_N" ;
lin stock_in_trade_N = mkTerm "stock_in_trade_N" ;
lin stock_list_N = mkTerm "stock_list_N" ;
lin stock_still_Adv = mkTerm "stock_still_Adv" ;
lin stock_up_V = mkTerm "stock_up_V" ;
lin stockade_N = mkTerm "stockade_N" ;
lin stockade_V2 = mkTerm "stockade_V2" ;
lin stockbreeder_N = mkTerm "stockbreeder_N" ;
lin stockbroker_N = mkTerm "stockbroker_N" ;
lin stockcar_N = mkTerm "stockcar_N" ;
lin stocker_N = mkTerm "stocker_N" ;
lin stockfish_N = mkTerm "stockfish_N" ;
lin stockholder_N = mkTerm "stockholder_N" ;
lin stockholding_N = mkTerm "stockholding_N" ;
lin stockholm_PN = mkTerm "stockholm_PN" ;
lin stockinet_N = mkTerm "stockinet_N" ;
lin stockinette_N = mkTerm "stockinette_N" ;
lin stocking_N = mkTerm "stocking_N" ;
lin stockinged_A = mkTerm "stockinged_A" ;
lin stockist_N = mkTerm "stockist_N" ;
lin stockjobber_N = mkTerm "stockjobber_N" ;
lin stockman_N = mkTerm "stockman_N" ;
lin stockpile_N = mkTerm "stockpile_N" ;
lin stockpile_V2 = mkTerm "stockpile_V2" ;
lin stockpiling_N = mkTerm "stockpiling_N" ;
lin stockport_PN = mkTerm "stockport_PN" ;
lin stockpot_N = mkTerm "stockpot_N" ;
lin stockroom_N = mkTerm "stockroom_N" ;
lin stocks_N = mkTerm "stocks_N" ;
lin stocksbridge_PN = mkTerm "stocksbridge_PN" ;
lin stocktake_N = mkTerm "stocktake_N" ;
lin stocktaker_N = mkTerm "stocktaker_N" ;
lin stocktaking_N = mkTerm "stocktaking_N" ;
lin stocky_A = mkTerm "stocky_A" ;
lin stockyard_N = mkTerm "stockyard_N" ;
lin stodge_N = mkTerm "stodge_N" ;
lin stodginess_N = mkTerm "stodginess_N" ;
lin stodgy_A = mkTerm "stodgy_A" ;
lin stoep_N = mkTerm "stoep_N" ;
lin stogy_N = mkTerm "stogy_N" ;
lin stoic_A = mkTerm "stoic_A" ;
lin stoic_N = mkTerm "stoic_N" ;
lin stoical_A = mkTerm "stoical_A" ;
lin stoichiometric_A = mkTerm "stoichiometric_A" ;
lin stoichiometry_N = mkTerm "stoichiometry_N" ;
lin stoicism_N = mkTerm "stoicism_N" ;
lin stoke_V = mkTerm "stoke_V" ;
lin stoke_V2 = mkTerm "stoke_V2" ;
lin stoke_on_trent_PN = mkTerm "stoke_on_trent_PN" ;
lin stokehold_N = mkTerm "stokehold_N" ;
lin stokehole_N = mkTerm "stokehole_N" ;
lin stoker_N = mkTerm "stoker_N" ;
lin stole_N = mkTerm "stole_N" ;
lin stolen_A = mkTerm "stolen_A" ;
lin stolid_A = mkTerm "stolid_A" ;
lin stolidity_N = mkTerm "stolidity_N" ;
lin stolidness_N = mkTerm "stolidness_N" ;
lin stolon_N = mkTerm "stolon_N" ;
lin stoloniferous_A = mkTerm "stoloniferous_A" ;
lin stoma_N = mkTerm "stoma_N" ;
lin stomach_N = mkTerm "stomach_N" ;
lin stomach_V2 = mkTerm "stomach_V2" ;
lin stomach_ache_N = mkTerm "stomach_ache_N" ;
lin stomach_pump_N = mkTerm "stomach_pump_N" ;
lin stomacher_N = mkTerm "stomacher_N" ;
lin stomatal_A = mkTerm "stomatal_A" ;
lin stomatitis_N = mkTerm "stomatitis_N" ;
lin stomatopod_N = mkTerm "stomatopod_N" ;
lin stomatous_A = mkTerm "stomatous_A" ;
lin stomp_N = mkTerm "stomp_N" ;
lin stomp_V = mkTerm "stomp_V" ;
lin stomp_V2 = mkTerm "stomp_V2" ;
lin stomp_off_V = mkTerm "stomp_off_V" ;
lin stomp_on_V2 = mkTerm "stomp_on_V2" ;
lin stone_1_N = mkTerm "stone_1_N" ;
lin stone_2_N = mkTerm "stone_2_N" ;
lin stone_A = mkTerm "stone_A" ;
lin stone_PN = mkTerm "stone_PN" ;
lin stone_V2 = mkTerm "stone_V2" ;
lin stone_blind_A = mkTerm "stone_blind_A" ;
lin stone_cold_A = mkTerm "stone_cold_A" ;
lin stone_dead_A = mkTerm "stone_dead_A" ;
lin stone_deaf_A = mkTerm "stone_deaf_A" ;
lin stone_fruit_N = mkTerm "stone_fruit_N" ;
lin stone_pit_N = mkTerm "stone_pit_N" ;
lin stone_sober_A = mkTerm "stone_sober_A" ;
lin stonebreaker_N = mkTerm "stonebreaker_N" ;
lin stonechat_N = mkTerm "stonechat_N" ;
lin stonecress_N = mkTerm "stonecress_N" ;
lin stonecrop_N = mkTerm "stonecrop_N" ;
lin stonecutter_N = mkTerm "stonecutter_N" ;
lin stonefish_N = mkTerm "stonefish_N" ;
lin stonefly_N = mkTerm "stonefly_N" ;
lin stonehouse_PN = mkTerm "stonehouse_PN" ;
lin stoneless_A = mkTerm "stoneless_A" ;
lin stonemason_N = mkTerm "stonemason_N" ;
lin stoner_N = mkTerm "stoner_N" ;
lin stonewall_V2 = mkTerm "stonewall_V2" ;
lin stonewaller_N = mkTerm "stonewaller_N" ;
lin stonewalling_N = mkTerm "stonewalling_N" ;
lin stoneware_N = mkTerm "stoneware_N" ;
lin stonework_N = mkTerm "stonework_N" ;
lin stonewort_N = mkTerm "stonewort_N" ;
lin stoning_N = mkTerm "stoning_N" ;
lin stony_A = mkTerm "stony_A" ;
lin stony_broke_A = mkTerm "stony_broke_A" ;
lin stood_V2V = mkTerm "stood_V2V" ;
lin stooge_N = mkTerm "stooge_N" ;
lin stooge_V = mkTerm "stooge_V" ;
lin stool_N = mkTerm "stool_N" ;
lin stoop_N = mkTerm "stoop_N" ;
lin stoop_V = mkTerm "stoop_V" ;
lin stoop_V2 = mkTerm "stoop_V2" ;
lin stooper_N = mkTerm "stooper_N" ;
lin stop_N = mkTerm "stop_N" ;
lin stop_V = mkTerm "stop_V" ;
lin stop_V2 = mkTerm "stop_V2" ;
lin stop_VV = mkTerm "stop_VV" ;
lin stop_around_V = mkTerm "stop_around_V" ;
lin stop_back_V = mkTerm "stop_back_V" ;
lin stop_behind_V = mkTerm "stop_behind_V" ;
lin stop_by_V2 = mkTerm "stop_by_V2" ;
lin stop_in_V = mkTerm "stop_in_V" ;
lin stop_off_V = mkTerm "stop_off_V" ;
lin stop_out_V = mkTerm "stop_out_V" ;
lin stop_over_V = mkTerm "stop_over_V" ;
lin stop_up_V = mkTerm "stop_up_V" ;
lin stop_up_V2 = mkTerm "stop_up_V2" ;
lin stopcock_N = mkTerm "stopcock_N" ;
lin stopgap_N = mkTerm "stopgap_N" ;
lin stoplight_N = mkTerm "stoplight_N" ;
lin stopover_N = mkTerm "stopover_N" ;
lin stoppable_A = mkTerm "stoppable_A" ;
lin stoppage_N = mkTerm "stoppage_N" ;
lin stopper_N = mkTerm "stopper_N" ;
lin stoppered_A = mkTerm "stoppered_A" ;
lin stopping_N = mkTerm "stopping_N" ;
lin stopwatch_N = mkTerm "stopwatch_N" ;
lin storage_N = mkTerm "storage_N" ;
lin storax_N = mkTerm "storax_N" ;
lin store_N = mkTerm "store_N" ;
lin store_V2 = mkTerm "store_V2" ;
lin storehouse_N = mkTerm "storehouse_N" ;
lin storeroom_N = mkTerm "storeroom_N" ;
lin storey_N = mkTerm "storey_N" ;
lin storeyed_A = mkTerm "storeyed_A" ;
lin storied_A = mkTerm "storied_A" ;
lin stork_N = mkTerm "stork_N" ;
lin storksbill_N = mkTerm "storksbill_N" ;
lin storm_N = mkTerm "storm_N" ;
lin storm_V = mkTerm "storm_V" ;
lin storm_V2 = mkTerm "storm_V2" ;
lin storm_beaten_A = mkTerm "storm_beaten_A" ;
lin storm_bound_A = mkTerm "storm_bound_A" ;
lin storm_centre_N = mkTerm "storm_centre_N" ;
lin storm_cloud_N = mkTerm "storm_cloud_N" ;
lin storm_cone_N = mkTerm "storm_cone_N" ;
lin storm_lantern_N = mkTerm "storm_lantern_N" ;
lin storm_off_V = mkTerm "storm_off_V" ;
lin storm_out_V = mkTerm "storm_out_V" ;
lin storm_signal_N = mkTerm "storm_signal_N" ;
lin storm_tossed_A = mkTerm "storm_tossed_A" ;
lin storm_trooper_N = mkTerm "storm_trooper_N" ;
lin storminess_N = mkTerm "storminess_N" ;
lin stormproof_A = mkTerm "stormproof_A" ;
lin stormy_A = mkTerm "stormy_A" ;
lin stornoway_PN = mkTerm "stornoway_PN" ;
lin story_N = mkTerm "story_N" ;
lin storybook_N = mkTerm "storybook_N" ;
lin storyline_N = mkTerm "storyline_N" ;
lin storyteller_N = mkTerm "storyteller_N" ;
lin storytelling_N = mkTerm "storytelling_N" ;
lin stotfold_PN = mkTerm "stotfold_PN" ;
lin stotinka_N = mkTerm "stotinka_N" ;
lin stoup_N = mkTerm "stoup_N" ;
lin stourbridge_PN = mkTerm "stourbridge_PN" ;
lin stourport_on_severn_PN = mkTerm "stourport_on_severn_PN" ;
lin stout_A = mkTerm "stout_A" ;
lin stout_N = mkTerm "stout_N" ;
lin stouthearted_A = mkTerm "stouthearted_A" ;
lin stoutheartedness_N = mkTerm "stoutheartedness_N" ;
lin stoutness_N = mkTerm "stoutness_N" ;
lin stove_N = mkTerm "stove_N" ;
lin stovepipe_N = mkTerm "stovepipe_N" ;
lin stovepiped_A = mkTerm "stovepiped_A" ;
lin stovepiping_N = mkTerm "stovepiping_N" ;
lin stover_N = mkTerm "stover_N" ;
lin stow_V2 = mkTerm "stow_V2" ;
lin stow_away_V = mkTerm "stow_away_V" ;
lin stowage_N = mkTerm "stowage_N" ;
lin stowaway_N = mkTerm "stowaway_N" ;
lin stowmarket_PN = mkTerm "stowmarket_PN" ;
lin strabismus_N = mkTerm "strabismus_N" ;
lin strabotomy_N = mkTerm "strabotomy_N" ;
lin straddle_N = mkTerm "straddle_N" ;
lin straddle_V = mkTerm "straddle_V" ;
lin straddle_V2 = mkTerm "straddle_V2" ;
lin strafe_N = mkTerm "strafe_N" ;
lin strafe_V2 = mkTerm "strafe_V2" ;
lin strafer_N = mkTerm "strafer_N" ;
lin straggle_N = mkTerm "straggle_N" ;
lin straggle_V = mkTerm "straggle_V" ;
lin straggler_N = mkTerm "straggler_N" ;
lin straggly_A = mkTerm "straggly_A" ;
lin straight_A = mkTerm "straight_A" ;
lin straight_Adv = mkTerm "straight_Adv" ;
lin straight_N = mkTerm "straight_N" ;
lin straightaway_N = mkTerm "straightaway_N" ;
lin straightedge_N = mkTerm "straightedge_N" ;
lin straighten_V = mkTerm "straighten_V" ;
lin straighten_V2 = mkTerm "straighten_V2" ;
lin straighten_out_V2 = mkTerm "straighten_out_V2" ;
lin straighten_up_V = mkTerm "straighten_up_V" ;
lin straighten_up_V2 = mkTerm "straighten_up_V2" ;
lin straightener_N = mkTerm "straightener_N" ;
lin straightforward_A = mkTerm "straightforward_A" ;
lin straightness_N = mkTerm "straightness_N" ;
lin straightway_Adv = mkTerm "straightway_Adv" ;
lin strain_N = mkTerm "strain_N" ;
lin strain_V2 = mkTerm "strain_V2" ;
lin strainer_N = mkTerm "strainer_N" ;
lin strait_A = mkTerm "strait_A" ;
lin strait_N = mkTerm "strait_N" ;
lin strait_laced_A = mkTerm "strait_laced_A" ;
lin straiten_V2 = mkTerm "straiten_V2" ;
lin straitjacket_N = mkTerm "straitjacket_N" ;
lin strand_N = mkTerm "strand_N" ;
lin strand_V = mkTerm "strand_V" ;
lin strand_V2 = mkTerm "strand_V2" ;
lin strange_A = mkTerm "strange_A" ;
lin strangeness_N = mkTerm "strangeness_N" ;
lin stranger_N = mkTerm "stranger_N" ;
lin strangle_V2 = mkTerm "strangle_V2" ;
lin stranglehold_N = mkTerm "stranglehold_N" ;
lin strangler_N = mkTerm "strangler_N" ;
lin strangulation_N = mkTerm "strangulation_N" ;
lin stranraer_PN = mkTerm "stranraer_PN" ;
lin strap_N = mkTerm "strap_N" ;
lin strap_V2 = mkTerm "strap_V2" ;
lin straphanger_N = mkTerm "straphanger_N" ;
lin strapless_A = mkTerm "strapless_A" ;
lin strapless_N = mkTerm "strapless_N" ;
lin straplike_A = mkTerm "straplike_A" ;
lin strappado_N = mkTerm "strappado_N" ;
lin strapping_A = mkTerm "strapping_A" ;
lin strapping_N = mkTerm "strapping_N" ;
lin strasbourg_PN = mkTerm "strasbourg_PN" ;
lin stratagem_N = mkTerm "stratagem_N" ;
lin strategic_A = mkTerm "strategic_A" ;
lin strategical_A = mkTerm "strategical_A" ;
lin strategics_N = mkTerm "strategics_N" ;
lin strategist_N = mkTerm "strategist_N" ;
lin strategy_N = mkTerm "strategy_N" ;
lin stratford_on_avon_PN = mkTerm "stratford_on_avon_PN" ;
lin strathaven_PN = mkTerm "strathaven_PN" ;
lin strathclyde_PN = mkTerm "strathclyde_PN" ;
lin stratification_N = mkTerm "stratification_N" ;
lin stratify_V = mkTerm "stratify_V" ;
lin stratify_V2 = mkTerm "stratify_V2" ;
lin stratigraphy_N = mkTerm "stratigraphy_N" ;
lin stratosphere_N = mkTerm "stratosphere_N" ;
lin stratum_N = mkTerm "stratum_N" ;
lin stratus_N = mkTerm "stratus_N" ;
lin straw_A = mkTerm "straw_A" ;
lin straw_N = mkTerm "straw_N" ;
lin straw_V2 = mkTerm "straw_V2" ;
lin straw_coloured_A = mkTerm "straw_coloured_A" ;
lin strawberry_N = mkTerm "strawberry_N" ;
lin strawboard_N = mkTerm "strawboard_N" ;
lin strawflower_N = mkTerm "strawflower_N" ;
lin strawworm_N = mkTerm "strawworm_N" ;
lin stray_A = mkTerm "stray_A" ;
lin stray_N = mkTerm "stray_N" ;
lin stray_V = mkTerm "stray_V" ;
lin streak_N = mkTerm "streak_N" ;
lin streak_V = mkTerm "streak_V" ;
lin streak_V2 = mkTerm "streak_V2" ;
lin streaker_N = mkTerm "streaker_N" ;
lin streaky_A = mkTerm "streaky_A" ;
lin stream_N = mkTerm "stream_N" ;
lin stream_V = mkTerm "stream_V" ;
lin streambed_N = mkTerm "streambed_N" ;
lin streamer_N = mkTerm "streamer_N" ;
lin streamlet_N = mkTerm "streamlet_N" ;
lin streamline_V = mkTerm "streamline_V" ;
lin streamline_V2 = mkTerm "streamline_V2" ;
lin streamlined_A = mkTerm "streamlined_A" ;
lin streamliner_N = mkTerm "streamliner_N" ;
lin street_N = mkTerm "street_N" ;
lin street_PN = mkTerm "street_PN" ;
lin street_girl_N = mkTerm "street_girl_N" ;
lin street_urchin_N = mkTerm "street_urchin_N" ;
lin streetcar_N = mkTerm "streetcar_N" ;
lin streetlight_N = mkTerm "streetlight_N" ;
lin streetwalker_N = mkTerm "streetwalker_N" ;
lin streetwise_A = mkTerm "streetwise_A" ;
lin strength_N = mkTerm "strength_N" ;
lin strengthen_V2 = mkTerm "strengthen_V2" ;
lin strengthener_N = mkTerm "strengthener_N" ;
lin strengthening_N = mkTerm "strengthening_N" ;
lin strenuous_A = mkTerm "strenuous_A" ;
lin strenuousness_N = mkTerm "strenuousness_N" ;
lin streptobacillus_N = mkTerm "streptobacillus_N" ;
lin streptocarpus_N = mkTerm "streptocarpus_N" ;
lin streptococcal_A = mkTerm "streptococcal_A" ;
lin streptococcus_N = mkTerm "streptococcus_N" ;
lin streptodornase_N = mkTerm "streptodornase_N" ;
lin streptokinase_N = mkTerm "streptokinase_N" ;
lin streptolysin_N = mkTerm "streptolysin_N" ;
lin streptomyces_N = mkTerm "streptomyces_N" ;
lin streptomycin_N = mkTerm "streptomycin_N" ;
lin streptothricin_N = mkTerm "streptothricin_N" ;
lin stress_N = mkTerm "stress_N" ;
lin stress_V2 = mkTerm "stress_V2" ;
lin stress_VS = mkTerm "stress_VS" ;
lin stress_mark_N = mkTerm "stress_mark_N" ;
lin stressor_N = mkTerm "stressor_N" ;
lin stretch_A = mkTerm "stretch_A" ;
lin stretch_N = mkTerm "stretch_N" ;
lin stretch_V = mkTerm "stretch_V" ;
lin stretch_V2 = mkTerm "stretch_V2" ;
lin stretch_out_V = mkTerm "stretch_out_V" ;
lin stretchable_A = mkTerm "stretchable_A" ;
lin stretcher_N = mkTerm "stretcher_N" ;
lin stretcher_bearer_N = mkTerm "stretcher_bearer_N" ;
lin stretcher_party_N = mkTerm "stretcher_party_N" ;
lin stretching_N = mkTerm "stretching_N" ;
lin stretford_PN = mkTerm "stretford_PN" ;
lin streusel_N = mkTerm "streusel_N" ;
lin strew_V2 = mkTerm "strew_V2" ;
lin stria_N = mkTerm "stria_N" ;
lin striate_A = mkTerm "striate_A" ;
lin striated_A = mkTerm "striated_A" ;
lin stricken_A = mkTerm "stricken_A" ;
lin strickle_N = mkTerm "strickle_N" ;
lin strict_A = mkTerm "strict_A" ;
lin strictness_N = mkTerm "strictness_N" ;
lin stricture_N = mkTerm "stricture_N" ;
lin stride_N = mkTerm "stride_N" ;
lin stride_V = mkTerm "stride_V" ;
lin strident_A = mkTerm "strident_A" ;
lin strider_N = mkTerm "strider_N" ;
lin stridor_N = mkTerm "stridor_N" ;
lin stridulate_V = mkTerm "stridulate_V" ;
lin stridulation_N = mkTerm "stridulation_N" ;
lin strife_N = mkTerm "strife_N" ;
lin strike_1_N = mkTerm "strike_1_N" ;
lin strike_2_N = mkTerm "strike_2_N" ;
lin strike_V = mkTerm "strike_V" ;
lin strike_V2 = mkTerm "strike_V2" ;
lin strike_back_V = mkTerm "strike_back_V" ;
lin strike_down_V = mkTerm "strike_down_V" ;
lin strike_down_V2 = mkTerm "strike_down_V2" ;
lin strike_leader_N = mkTerm "strike_leader_N" ;
lin strike_off_V2 = mkTerm "strike_off_V2" ;
lin strike_on_V2 = mkTerm "strike_on_V2" ;
lin strike_out_V = mkTerm "strike_out_V" ;
lin strike_out_V2 = mkTerm "strike_out_V2" ;
lin strike_pay_N = mkTerm "strike_pay_N" ;
lin strike_up_V = mkTerm "strike_up_V" ;
lin strike_up_V2 = mkTerm "strike_up_V2" ;
lin strike_upon_V2 = mkTerm "strike_upon_V2" ;
lin strikebound_A = mkTerm "strikebound_A" ;
lin strikebreaker_N = mkTerm "strikebreaker_N" ;
lin strikebreaking_N = mkTerm "strikebreaking_N" ;
lin strikeout_N = mkTerm "strikeout_N" ;
lin striker_N = mkTerm "striker_N" ;
lin striking_A = mkTerm "striking_A" ;
lin string_1_N = mkTerm "string_1_N" ;
lin string_2_N = mkTerm "string_2_N" ;
lin string_3_N = mkTerm "string_3_N" ;
lin string_V = mkTerm "string_V" ;
lin string_V2 = mkTerm "string_V2" ;
lin string_along_V = mkTerm "string_along_V" ;
lin string_along_V2 = mkTerm "string_along_V2" ;
lin string_out_V2 = mkTerm "string_out_V2" ;
lin string_together_V2 = mkTerm "string_together_V2" ;
lin string_up_V2 = mkTerm "string_up_V2" ;
lin stringency_N = mkTerm "stringency_N" ;
lin stringent_A = mkTerm "stringent_A" ;
lin stringer_N = mkTerm "stringer_N" ;
lin stringy_A = mkTerm "stringy_A" ;
lin stringybark_N = mkTerm "stringybark_N" ;
lin strip_N = mkTerm "strip_N" ;
lin strip_V = mkTerm "strip_V" ;
lin strip_V2 = mkTerm "strip_V2" ;
lin strip_lighting_N = mkTerm "strip_lighting_N" ;
lin strip_poker_N = mkTerm "strip_poker_N" ;
lin strip_show_N = mkTerm "strip_show_N" ;
lin stripe_N = mkTerm "stripe_N" ;
lin striped_A = mkTerm "striped_A" ;
lin striper_N = mkTerm "striper_N" ;
lin striping_N = mkTerm "striping_N" ;
lin stripling_N = mkTerm "stripling_N" ;
lin stripper_N = mkTerm "stripper_N" ;
lin striptease_N = mkTerm "striptease_N" ;
lin stripy_A = mkTerm "stripy_A" ;
lin strive_V = mkTerm "strive_V" ;
lin strive_VV = mkTerm "strive_VV" ;
lin striver_N = mkTerm "striver_N" ;
lin striving_N = mkTerm "striving_N" ;
lin stroboscope_N = mkTerm "stroboscope_N" ;
lin stroke_N = mkTerm "stroke_N" ;
lin stroke_V2 = mkTerm "stroke_V2" ;
lin stroll_N = mkTerm "stroll_N" ;
lin stroll_V = mkTerm "stroll_V" ;
lin stroller_N = mkTerm "stroller_N" ;
lin stroma_N = mkTerm "stroma_N" ;
lin strong_A = mkTerm "strong_A" ;
lin strong_arm_A = mkTerm "strong_arm_A" ;
lin strong_boned_A = mkTerm "strong_boned_A" ;
lin strong_minded_A = mkTerm "strong_minded_A" ;
lin strongbox_N = mkTerm "strongbox_N" ;
lin stronghold_N = mkTerm "stronghold_N" ;
lin strongman_N = mkTerm "strongman_N" ;
lin strongroom_N = mkTerm "strongroom_N" ;
lin strontianite_N = mkTerm "strontianite_N" ;
lin strontium_N = mkTerm "strontium_N" ;
lin strop_N = mkTerm "strop_N" ;
lin strop_V2 = mkTerm "strop_V2" ;
lin strophanthin_N = mkTerm "strophanthin_N" ;
lin strophanthus_N = mkTerm "strophanthus_N" ;
lin strophe_N = mkTerm "strophe_N" ;
lin stroppy_A = mkTerm "stroppy_A" ;
lin stroud_PN = mkTerm "stroud_PN" ;
lin structural_A = mkTerm "structural_A" ;
lin structuralism_N = mkTerm "structuralism_N" ;
lin structure_N = mkTerm "structure_N" ;
lin structure_V2 = mkTerm "structure_V2" ;
lin structured_A = mkTerm "structured_A" ;
lin strudel_N = mkTerm "strudel_N" ;
lin struggle_N = mkTerm "struggle_N" ;
lin struggle_V = mkTerm "struggle_V" ;
lin struggle_VV = mkTerm "struggle_VV" ;
lin struggle_back_V = mkTerm "struggle_back_V" ;
lin struggler_N = mkTerm "struggler_N" ;
lin strum_N = mkTerm "strum_N" ;
lin strum_V = mkTerm "strum_V" ;
lin strum_V2 = mkTerm "strum_V2" ;
lin strumpet_N = mkTerm "strumpet_N" ;
lin strut_N = mkTerm "strut_N" ;
lin strut_V = mkTerm "strut_V" ;
lin struthiomimus_N = mkTerm "struthiomimus_N" ;
lin strychnine_N = mkTerm "strychnine_N" ;
lin stuart_PN = mkTerm "stuart_PN" ;
lin stub_N = mkTerm "stub_N" ;
lin stub_V2 = mkTerm "stub_V2" ;
lin stub_out_V2 = mkTerm "stub_out_V2" ;
lin stubble_N = mkTerm "stubble_N" ;
lin stubbly_A = mkTerm "stubbly_A" ;
lin stubborn_A = mkTerm "stubborn_A" ;
lin stubbornness_N = mkTerm "stubbornness_N" ;
lin stubby_A = mkTerm "stubby_A" ;
lin stucco_N = mkTerm "stucco_N" ;
lin stucco_V2 = mkTerm "stucco_V2" ;
lin stuck_V2 = mkTerm "stuck_V2" ;
lin stuck_by_V = mkTerm "stuck_by_V" ;
lin stuck_up_A = mkTerm "stuck_up_A" ;
lin stud_N = mkTerm "stud_N" ;
lin stud_V2 = mkTerm "stud_V2" ;
lin stud_farm_N = mkTerm "stud_farm_N" ;
lin stud_mare_N = mkTerm "stud_mare_N" ;
lin studbook_N = mkTerm "studbook_N" ;
lin studentFem_N = mkTerm "studentFem_N" ;
lin studentMasc_N = mkTerm "studentMasc_N" ;
lin studentship_N = mkTerm "studentship_N" ;
lin studio_N = mkTerm "studio_N" ;
lin studious_A = mkTerm "studious_A" ;
lin studiousness_N = mkTerm "studiousness_N" ;
lin studley_PN = mkTerm "studley_PN" ;
lin study_N = mkTerm "study_N" ;
lin study_V = mkTerm "study_V" ;
lin study_V2 = mkTerm "study_V2" ;
lin stuff_N = mkTerm "stuff_N" ;
lin stuff_V2 = mkTerm "stuff_V2" ;
lin stuff_up_V2 = mkTerm "stuff_up_V2" ;
lin stuffer_N = mkTerm "stuffer_N" ;
lin stuffiness_N = mkTerm "stuffiness_N" ;
lin stuffing_N = mkTerm "stuffing_N" ;
lin stuffy_A = mkTerm "stuffy_A" ;
lin stultification_N = mkTerm "stultification_N" ;
lin stultify_V2 = mkTerm "stultify_V2" ;
lin stumble_N = mkTerm "stumble_N" ;
lin stumble_V = mkTerm "stumble_V" ;
lin stumble_across_V2 = mkTerm "stumble_across_V2" ;
lin stumble_upon_V2 = mkTerm "stumble_upon_V2" ;
lin stumblebum_N = mkTerm "stumblebum_N" ;
lin stumbler_N = mkTerm "stumbler_N" ;
lin stumbling_block_N = mkTerm "stumbling_block_N" ;
lin stump_N = mkTerm "stump_N" ;
lin stump_V = mkTerm "stump_V" ;
lin stump_V2 = mkTerm "stump_V2" ;
lin stump_up_V2 = mkTerm "stump_up_V2" ;
lin stumper_N = mkTerm "stumper_N" ;
lin stumping_N = mkTerm "stumping_N" ;
lin stumpy_A = mkTerm "stumpy_A" ;
lin stun_V2 = mkTerm "stun_V2" ;
lin stun_V2S = mkTerm "stun_V2S" ;
lin stunne_V2V = mkTerm "stunne_V2V" ;
lin stunner_N = mkTerm "stunner_N" ;
lin stunning_A = mkTerm "stunning_A" ;
lin stunt_N = mkTerm "stunt_N" ;
lin stunt_V2 = mkTerm "stunt_V2" ;
lin stupa_N = mkTerm "stupa_N" ;
lin stupefaction_N = mkTerm "stupefaction_N" ;
lin stupefy_V2 = mkTerm "stupefy_V2" ;
lin stupefying_A = mkTerm "stupefying_A" ;
lin stupendous_A = mkTerm "stupendous_A" ;
lin stupid_A = mkTerm "stupid_A" ;
lin stupid_N = mkTerm "stupid_N" ;
lin stupidity_N = mkTerm "stupidity_N" ;
lin stupify_V2 = mkTerm "stupify_V2" ;
lin stupifying_A = mkTerm "stupifying_A" ;
lin stupor_N = mkTerm "stupor_N" ;
lin sturdiness_N = mkTerm "sturdiness_N" ;
lin sturdy_A = mkTerm "sturdy_A" ;
lin sturgeon_N = mkTerm "sturgeon_N" ;
lin stutter_N = mkTerm "stutter_N" ;
lin stutter_V = mkTerm "stutter_V" ;
lin stutter_V2 = mkTerm "stutter_V2" ;
lin stutterer_N = mkTerm "stutterer_N" ;
lin stutteringly_Adv = mkTerm "stutteringly_Adv" ;
lin stuttgart_PN = mkTerm "stuttgart_PN" ;
lin sty_N = mkTerm "sty_N" ;
lin stye_N = mkTerm "stye_N" ;
lin stygian_A = mkTerm "stygian_A" ;
lin style_N = mkTerm "style_N" ;
lin style_V2 = mkTerm "style_V2" ;
lin styleless_A = mkTerm "styleless_A" ;
lin stylet_N = mkTerm "stylet_N" ;
lin stylish_A = mkTerm "stylish_A" ;
lin stylishness_N = mkTerm "stylishness_N" ;
lin stylist_N = mkTerm "stylist_N" ;
lin stylistic_A = mkTerm "stylistic_A" ;
lin stylite_N = mkTerm "stylite_N" ;
lin stylization_N = mkTerm "stylization_N" ;
lin stylize_V2 = mkTerm "stylize_V2" ;
lin stylopodium_N = mkTerm "stylopodium_N" ;
lin stylus_N = mkTerm "stylus_N" ;
lin stymie_N = mkTerm "stymie_N" ;
lin stymie_V2 = mkTerm "stymie_V2" ;
lin stymy_V2 = mkTerm "stymy_V2" ;
lin styptic_A = mkTerm "styptic_A" ;
lin styptic_N = mkTerm "styptic_N" ;
lin styracosaur_N = mkTerm "styracosaur_N" ;
lin styrax_N = mkTerm "styrax_N" ;
lin styrene_N = mkTerm "styrene_N" ;
lin styx_PN = mkTerm "styx_PN" ;
lin suasion_N = mkTerm "suasion_N" ;
lin suave_A = mkTerm "suave_A" ;
lin suavity_N = mkTerm "suavity_N" ;
lin sub_N = mkTerm "sub_N" ;
lin sub_V = mkTerm "sub_V" ;
lin sub_V2 = mkTerm "sub_V2" ;
lin sub_judice_A = mkTerm "sub_judice_A" ;
lin sub_rosa_Adv = mkTerm "sub_rosa_Adv" ;
lin sub_underwrite_V2 = mkTerm "sub_underwrite_V2" ;
lin subacid_A = mkTerm "subacid_A" ;
lin subacute_A = mkTerm "subacute_A" ;
lin subaltern_N = mkTerm "subaltern_N" ;
lin subaqueous_A = mkTerm "subaqueous_A" ;
lin subarctic_A = mkTerm "subarctic_A" ;
lin subartesian_A = mkTerm "subartesian_A" ;
lin subatomic_A = mkTerm "subatomic_A" ;
lin subbase_N = mkTerm "subbase_N" ;
lin subbing_N = mkTerm "subbing_N" ;
lin subclass_N = mkTerm "subclass_N" ;
lin subclavian_A = mkTerm "subclavian_A" ;
lin subclinical_A = mkTerm "subclinical_A" ;
lin subcommittee_N = mkTerm "subcommittee_N" ;
lin subcompact_N = mkTerm "subcompact_N" ;
lin subconscious_A = mkTerm "subconscious_A" ;
lin subconscious_N = mkTerm "subconscious_N" ;
lin subconsciousness_N = mkTerm "subconsciousness_N" ;
lin subcontinent_N = mkTerm "subcontinent_N" ;
lin subcontract_N = mkTerm "subcontract_N" ;
lin subcontract_V = mkTerm "subcontract_V" ;
lin subcontract_V2 = mkTerm "subcontract_V2" ;
lin subcontractor_N = mkTerm "subcontractor_N" ;
lin subcortical_A = mkTerm "subcortical_A" ;
lin subculture_N = mkTerm "subculture_N" ;
lin subcutaneous_A = mkTerm "subcutaneous_A" ;
lin subdeacon_N = mkTerm "subdeacon_N" ;
lin subdirectory_N = mkTerm "subdirectory_N" ;
lin subdivide_V = mkTerm "subdivide_V" ;
lin subdivide_V2 = mkTerm "subdivide_V2" ;
lin subdivider_N = mkTerm "subdivider_N" ;
lin subdivision_N = mkTerm "subdivision_N" ;
lin subdominant_N = mkTerm "subdominant_N" ;
lin subduable_A = mkTerm "subduable_A" ;
lin subduction_N = mkTerm "subduction_N" ;
lin subdue_V2 = mkTerm "subdue_V2" ;
lin subduer_N = mkTerm "subduer_N" ;
lin subdural_A = mkTerm "subdural_A" ;
lin subedit_V2 = mkTerm "subedit_V2" ;
lin subeditor_N = mkTerm "subeditor_N" ;
lin subfamily_N = mkTerm "subfamily_N" ;
lin subfigure_N = mkTerm "subfigure_N" ;
lin subfusc_A = mkTerm "subfusc_A" ;
lin subgenus_N = mkTerm "subgenus_N" ;
lin subgross_A = mkTerm "subgross_A" ;
lin subgroup_N = mkTerm "subgroup_N" ;
lin subheading_N = mkTerm "subheading_N" ;
lin subhuman_A = mkTerm "subhuman_A" ;
lin subjacent_A = mkTerm "subjacent_A" ;
lin subject_1_N = mkTerm "subject_1_N" ;
lin subject_2_N = mkTerm "subject_2_N" ;
lin subject_A = mkTerm "subject_A" ;
lin subject_V2 = mkTerm "subject_V2" ;
lin subject_to_A2 = mkTerm "subject_to_A2" ;
lin subject_to_Prep = mkTerm "subject_to_Prep" ;
lin subjection_N = mkTerm "subjection_N" ;
lin subjective_A = mkTerm "subjective_A" ;
lin subjectivism_N = mkTerm "subjectivism_N" ;
lin subjectivist_N = mkTerm "subjectivist_N" ;
lin subjectivity_N = mkTerm "subjectivity_N" ;
lin subjoin_V2 = mkTerm "subjoin_V2" ;
lin subjugate_V2 = mkTerm "subjugate_V2" ;
lin subjugation_N = mkTerm "subjugation_N" ;
lin subjugator_N = mkTerm "subjugator_N" ;
lin subjunctive_A = mkTerm "subjunctive_A" ;
lin subjunctive_N = mkTerm "subjunctive_N" ;
lin subkingdom_N = mkTerm "subkingdom_N" ;
lin sublease_N = mkTerm "sublease_N" ;
lin sublease_V = mkTerm "sublease_V" ;
lin sublease_V2 = mkTerm "sublease_V2" ;
lin sublet_V = mkTerm "sublet_V" ;
lin sublet_V2 = mkTerm "sublet_V2" ;
lin sublieutenant_N = mkTerm "sublieutenant_N" ;
lin sublimate_A = mkTerm "sublimate_A" ;
lin sublimate_N = mkTerm "sublimate_N" ;
lin sublimate_V2 = mkTerm "sublimate_V2" ;
lin sublimation_N = mkTerm "sublimation_N" ;
lin sublime_A = mkTerm "sublime_A" ;
lin sublime_N = mkTerm "sublime_N" ;
lin sublimed_A = mkTerm "sublimed_A" ;
lin subliminal_A = mkTerm "subliminal_A" ;
lin sublimity_N = mkTerm "sublimity_N" ;
lin sublingual_A = mkTerm "sublingual_A" ;
lin subliterary_A = mkTerm "subliterary_A" ;
lin sublittoral_A = mkTerm "sublittoral_A" ;
lin sublunar_A = mkTerm "sublunar_A" ;
lin subluxation_N = mkTerm "subluxation_N" ;
lin submarine_A = mkTerm "submarine_A" ;
lin submarine_N = mkTerm "submarine_N" ;
lin submariner_N = mkTerm "submariner_N" ;
lin submediant_N = mkTerm "submediant_N" ;
lin submerge_V = mkTerm "submerge_V" ;
lin submerge_V2 = mkTerm "submerge_V2" ;
lin submergence_N = mkTerm "submergence_N" ;
lin submersible_A = mkTerm "submersible_A" ;
lin submersible_N = mkTerm "submersible_N" ;
lin submersion_N = mkTerm "submersion_N" ;
lin submission_N = mkTerm "submission_N" ;
lin submissive_A = mkTerm "submissive_A" ;
lin submissiveness_N = mkTerm "submissiveness_N" ;
lin submit_V = mkTerm "submit_V" ;
lin submit_V2 = mkTerm "submit_V2" ;
lin submitter_N = mkTerm "submitter_N" ;
lin submucosa_N = mkTerm "submucosa_N" ;
lin subnormal_A = mkTerm "subnormal_A" ;
lin subnormal_N = mkTerm "subnormal_N" ;
lin subnormality_N = mkTerm "subnormality_N" ;
lin suboceanic_A = mkTerm "suboceanic_A" ;
lin suborbital_A = mkTerm "suborbital_A" ;
lin suborder_N = mkTerm "suborder_N" ;
lin subordinate_A = mkTerm "subordinate_A" ;
lin subordinate_N = mkTerm "subordinate_N" ;
lin subordinate_V2 = mkTerm "subordinate_V2" ;
lin subordinateness_N = mkTerm "subordinateness_N" ;
lin subordination_N = mkTerm "subordination_N" ;
lin subordinative_A = mkTerm "subordinative_A" ;
lin suborn_V2 = mkTerm "suborn_V2" ;
lin subornation_N = mkTerm "subornation_N" ;
lin subpart_N = mkTerm "subpart_N" ;
lin subphylum_N = mkTerm "subphylum_N" ;
lin subpoena_N = mkTerm "subpoena_N" ;
lin subpoena_V2 = mkTerm "subpoena_V2" ;
lin subpopulation_N = mkTerm "subpopulation_N" ;
lin subrogation_N = mkTerm "subrogation_N" ;
lin subscribe_V = mkTerm "subscribe_V" ;
lin subscribe_V2 = mkTerm "subscribe_V2" ;
lin subscriber_N = mkTerm "subscriber_N" ;
lin subscript_A = mkTerm "subscript_A" ;
lin subscript_N = mkTerm "subscript_N" ;
lin subscription_N = mkTerm "subscription_N" ;
lin subsection_N = mkTerm "subsection_N" ;
lin subsequent_A = mkTerm "subsequent_A" ;
lin subserve_V2 = mkTerm "subserve_V2" ;
lin subservience_N = mkTerm "subservience_N" ;
lin subservient_A = mkTerm "subservient_A" ;
lin subset_N = mkTerm "subset_N" ;
lin subshrub_N = mkTerm "subshrub_N" ;
lin subside_V = mkTerm "subside_V" ;
lin subsidence_N = mkTerm "subsidence_N" ;
lin subsidiary_A = mkTerm "subsidiary_A" ;
lin subsidiary_N = mkTerm "subsidiary_N" ;
lin subsidization_N = mkTerm "subsidization_N" ;
lin subsidize_V2 = mkTerm "subsidize_V2" ;
lin subsidizer_N = mkTerm "subsidizer_N" ;
lin subsidy_N = mkTerm "subsidy_N" ;
lin subsist_V = mkTerm "subsist_V" ;
lin subsistence_N = mkTerm "subsistence_N" ;
lin subsoil_N = mkTerm "subsoil_N" ;
lin subsonic_A = mkTerm "subsonic_A" ;
lin subspace_N = mkTerm "subspace_N" ;
lin subspecies_N = mkTerm "subspecies_N" ;
lin substance_N = mkTerm "substance_N" ;
lin substandard_A = mkTerm "substandard_A" ;
lin substantial_A = mkTerm "substantial_A" ;
lin substantiality_N = mkTerm "substantiality_N" ;
lin substantiate_V2 = mkTerm "substantiate_V2" ;
lin substantiation_N = mkTerm "substantiation_N" ;
lin substantival_A = mkTerm "substantival_A" ;
lin substantive_A = mkTerm "substantive_A" ;
lin substantive_N = mkTerm "substantive_N" ;
lin substation_N = mkTerm "substation_N" ;
lin substitutable_A = mkTerm "substitutable_A" ;
lin substitute_N = mkTerm "substitute_N" ;
lin substitute_V = mkTerm "substitute_V" ;
lin substitute_V2 = mkTerm "substitute_V2" ;
lin substitution_N = mkTerm "substitution_N" ;
lin substrate_N = mkTerm "substrate_N" ;
lin substratum_N = mkTerm "substratum_N" ;
lin substring_N = mkTerm "substring_N" ;
lin substructure_N = mkTerm "substructure_N" ;
lin subsume_V2 = mkTerm "subsume_V2" ;
lin subsumption_N = mkTerm "subsumption_N" ;
lin subsurface_A = mkTerm "subsurface_A" ;
lin subsystem_N = mkTerm "subsystem_N" ;
lin subtend_V2 = mkTerm "subtend_V2" ;
lin subterfuge_N = mkTerm "subterfuge_N" ;
lin subterminal_A = mkTerm "subterminal_A" ;
lin subterranean_A = mkTerm "subterranean_A" ;
lin subthalamus_N = mkTerm "subthalamus_N" ;
lin subtilin_N = mkTerm "subtilin_N" ;
lin subtitle_N = mkTerm "subtitle_N" ;
lin subtitle_V3 = mkTerm "subtitle_V3" ;
lin subtle_A = mkTerm "subtle_A" ;
lin subtlety_N = mkTerm "subtlety_N" ;
lin subtonic_N = mkTerm "subtonic_N" ;
lin subtopia_N = mkTerm "subtopia_N" ;
lin subtotal_N = mkTerm "subtotal_N" ;
lin subtract_V2 = mkTerm "subtract_V2" ;
lin subtracter_N = mkTerm "subtracter_N" ;
lin subtraction_N = mkTerm "subtraction_N" ;
lin subtractive_A = mkTerm "subtractive_A" ;
lin subtrahend_N = mkTerm "subtrahend_N" ;
lin subtreasury_N = mkTerm "subtreasury_N" ;
lin subtropical_A = mkTerm "subtropical_A" ;
lin subtropics_N = mkTerm "subtropics_N" ;
lin subunit_N = mkTerm "subunit_N" ;
lin suburb_N = mkTerm "suburb_N" ;
lin suburban_A = mkTerm "suburban_A" ;
lin suburbanite_N = mkTerm "suburbanite_N" ;
lin suburbanized_A = mkTerm "suburbanized_A" ;
lin suburbia_N = mkTerm "suburbia_N" ;
lin subvention_N = mkTerm "subvention_N" ;
lin subversion_N = mkTerm "subversion_N" ;
lin subversive_A = mkTerm "subversive_A" ;
lin subversive_N = mkTerm "subversive_N" ;
lin subvert_V2 = mkTerm "subvert_V2" ;
lin subvocalizer_N = mkTerm "subvocalizer_N" ;
lin subway_N = mkTerm "subway_N" ;
lin subwoofer_N = mkTerm "subwoofer_N" ;
lin succedaneum_N = mkTerm "succedaneum_N" ;
lin succeed_V = mkTerm "succeed_V" ;
lin succeed_V2 = mkTerm "succeed_V2" ;
lin success_N = mkTerm "success_N" ;
lin successful_A = mkTerm "successful_A" ;
lin succession_N = mkTerm "succession_N" ;
lin successive_A = mkTerm "successive_A" ;
lin successor_N = mkTerm "successor_N" ;
lin succinct_A = mkTerm "succinct_A" ;
lin succinctness_N = mkTerm "succinctness_N" ;
lin succinic_A = mkTerm "succinic_A" ;
lin succinylcholine_N = mkTerm "succinylcholine_N" ;
lin succorer_N = mkTerm "succorer_N" ;
lin succotash_N = mkTerm "succotash_N" ;
lin succour_N = mkTerm "succour_N" ;
lin succour_V2 = mkTerm "succour_V2" ;
lin succubus_N = mkTerm "succubus_N" ;
lin succulence_N = mkTerm "succulence_N" ;
lin succulent_A = mkTerm "succulent_A" ;
lin succulent_N = mkTerm "succulent_N" ;
lin succumb_V = mkTerm "succumb_V" ;
lin succussion_N = mkTerm "succussion_N" ;
lin such_A = mkTerm "such_A" ;
lin such_Adv = mkTerm "such_Adv" ;
lin such_Predet = mkTerm "such_Predet" ;
lin such_as_Prep = mkTerm "such_as_Prep" ;
lin suchlike_A = mkTerm "suchlike_A" ;
lin suchow_PN = mkTerm "suchow_PN" ;
lin suck_N = mkTerm "suck_N" ;
lin suck_V = mkTerm "suck_V" ;
lin suck_V2 = mkTerm "suck_V2" ;
lin suck_in_V2 = mkTerm "suck_in_V2" ;
lin suck_into_V2 = mkTerm "suck_into_V2" ;
lin suck_up_V = mkTerm "suck_up_V" ;
lin suck_up_to_V2 = mkTerm "suck_up_to_V2" ;
lin suckerFem_N = mkTerm "suckerFem_N" ;
lin suckerMasc_N = mkTerm "suckerMasc_N" ;
lin sucking_N = mkTerm "sucking_N" ;
lin sucking_pig_N = mkTerm "sucking_pig_N" ;
lin suckle_V2 = mkTerm "suckle_V2" ;
lin suckling_N = mkTerm "suckling_N" ;
lin sucralfate_N = mkTerm "sucralfate_N" ;
lin sucre_N = mkTerm "sucre_N" ;
lin sucrose_N = mkTerm "sucrose_N" ;
lin suction_N = mkTerm "suction_N" ;
lin suctorial_A = mkTerm "suctorial_A" ;
lin sudan_PN = mkTerm "sudan_PN" ;
lin sudanese_A = mkTerm "sudanese_A" ;
lin sudanese_N = mkTerm "sudanese_N" ;
lin sudatorium_N = mkTerm "sudatorium_N" ;
lin sudbury_PN = mkTerm "sudbury_PN" ;
lin sudden_A = mkTerm "sudden_A" ;
lin sudden_N = mkTerm "sudden_N" ;
lin suddenness_N = mkTerm "suddenness_N" ;
lin sudoku_N = mkTerm "sudoku_N" ;
lin sudorific_N = mkTerm "sudorific_N" ;
lin sudra_N = mkTerm "sudra_N" ;
lin suds_N = mkTerm "suds_N" ;
lin sue_PN = mkTerm "sue_PN" ;
lin sue_V = mkTerm "sue_V" ;
lin sue_V2 = mkTerm "sue_V2" ;
lin sue_V2V = mkTerm "sue_V2V" ;
lin suede_N = mkTerm "suede_N" ;
lin suer_N = mkTerm "suer_N" ;
lin suet_N = mkTerm "suet_N" ;
lin suety_A = mkTerm "suety_A" ;
lin suffer_V = mkTerm "suffer_V" ;
lin suffer_V2 = mkTerm "suffer_V2" ;
lin sufferable_A = mkTerm "sufferable_A" ;
lin sufferance_N = mkTerm "sufferance_N" ;
lin sufferer_N = mkTerm "sufferer_N" ;
lin suffering_N = mkTerm "suffering_N" ;
lin suffice_V = mkTerm "suffice_V" ;
lin suffice_V2 = mkTerm "suffice_V2" ;
lin suffice_V2V = mkTerm "suffice_V2V" ;
lin sufficiency_N = mkTerm "sufficiency_N" ;
lin sufficient_A = mkTerm "sufficient_A" ;
lin suffix_N = mkTerm "suffix_N" ;
lin suffixation_N = mkTerm "suffixation_N" ;
lin suffocate_V = mkTerm "suffocate_V" ;
lin suffocate_V2 = mkTerm "suffocate_V2" ;
lin suffocation_N = mkTerm "suffocation_N" ;
lin suffolk_PN = mkTerm "suffolk_PN" ;
lin suffragan_N = mkTerm "suffragan_N" ;
lin suffrage_N = mkTerm "suffrage_N" ;
lin suffragette_N = mkTerm "suffragette_N" ;
lin suffragism_N = mkTerm "suffragism_N" ;
lin suffragist_N = mkTerm "suffragist_N" ;
lin suffrutescent_A = mkTerm "suffrutescent_A" ;
lin suffuse_V2 = mkTerm "suffuse_V2" ;
lin suffusion_N = mkTerm "suffusion_N" ;
lin suffusive_A = mkTerm "suffusive_A" ;
lin sugar_N = mkTerm "sugar_N" ;
lin sugar_V2 = mkTerm "sugar_V2" ;
lin sugar_beet_N = mkTerm "sugar_beet_N" ;
lin sugar_candy_N = mkTerm "sugar_candy_N" ;
lin sugar_cane_N = mkTerm "sugar_cane_N" ;
lin sugar_coated_A = mkTerm "sugar_coated_A" ;
lin sugar_daddy_N = mkTerm "sugar_daddy_N" ;
lin sugar_loaf_N = mkTerm "sugar_loaf_N" ;
lin sugar_refinery_N = mkTerm "sugar_refinery_N" ;
lin sugarberry_N = mkTerm "sugarberry_N" ;
lin sugariness_N = mkTerm "sugariness_N" ;
lin sugarless_A = mkTerm "sugarless_A" ;
lin sugarlump_N = mkTerm "sugarlump_N" ;
lin sugarplum_N = mkTerm "sugarplum_N" ;
lin sugary_A = mkTerm "sugary_A" ;
lin suggest_V = mkTerm "suggest_V" ;
lin suggest_V2 = mkTerm "suggest_V2" ;
lin suggest_VS = mkTerm "suggest_VS" ;
lin suggester_N = mkTerm "suggester_N" ;
lin suggestibility_N = mkTerm "suggestibility_N" ;
lin suggestible_A = mkTerm "suggestible_A" ;
lin suggestion_N = mkTerm "suggestion_N" ;
lin suggestive_A = mkTerm "suggestive_A" ;
lin suicidal_A = mkTerm "suicidal_A" ;
lin suicide_N = mkTerm "suicide_N" ;
lin suit_N = mkTerm "suit_N" ;
lin suit_V = mkTerm "suit_V" ;
lin suit_V2 = mkTerm "suit_V2" ;
lin suit_up_V = mkTerm "suit_up_V" ;
lin suitability_N = mkTerm "suitability_N" ;
lin suitable_A = mkTerm "suitable_A" ;
lin suitableness_N = mkTerm "suitableness_N" ;
lin suitcase_N = mkTerm "suitcase_N" ;
lin suite_N = mkTerm "suite_N" ;
lin suiting_N = mkTerm "suiting_N" ;
lin suitor_N = mkTerm "suitor_N" ;
lin sukiyaki_N = mkTerm "sukiyaki_N" ;
lin suksdorfia_N = mkTerm "suksdorfia_N" ;
lin sulcate_A = mkTerm "sulcate_A" ;
lin sulcus_N = mkTerm "sulcus_N" ;
lin sulfacetamide_N = mkTerm "sulfacetamide_N" ;
lin sulfadiazine_N = mkTerm "sulfadiazine_N" ;
lin sulfamethazine_N = mkTerm "sulfamethazine_N" ;
lin sulfamethoxazole_N = mkTerm "sulfamethoxazole_N" ;
lin sulfanilamide_N = mkTerm "sulfanilamide_N" ;
lin sulfapyridine_N = mkTerm "sulfapyridine_N" ;
lin sulfate_N = mkTerm "sulfate_N" ;
lin sulfide_N = mkTerm "sulfide_N" ;
lin sulfisoxazole_N = mkTerm "sulfisoxazole_N" ;
lin sulfonate_N = mkTerm "sulfonate_N" ;
lin sulfonylurea_N = mkTerm "sulfonylurea_N" ;
lin sulfur_N = mkTerm "sulfur_N" ;
lin sulfurous_A = mkTerm "sulfurous_A" ;
lin sulindac_N = mkTerm "sulindac_N" ;
lin sulk_N = mkTerm "sulk_N" ;
lin sulk_V = mkTerm "sulk_V" ;
lin sulkava_PN = mkTerm "sulkava_PN" ;
lin sulkiness_N = mkTerm "sulkiness_N" ;
lin sulky_A = mkTerm "sulky_A" ;
lin sulky_N = mkTerm "sulky_N" ;
lin sullen_A = mkTerm "sullen_A" ;
lin sullenness_N = mkTerm "sullenness_N" ;
lin sully_V2 = mkTerm "sully_V2" ;
lin sulpha_N = mkTerm "sulpha_N" ;
lin sulphate_N = mkTerm "sulphate_N" ;
lin sulphide_N = mkTerm "sulphide_N" ;
lin sulphur_N = mkTerm "sulphur_N" ;
lin sulphuretted_A = mkTerm "sulphuretted_A" ;
lin sulphuric_A = mkTerm "sulphuric_A" ;
lin sulphurous_A = mkTerm "sulphurous_A" ;
lin sultan_N = mkTerm "sultan_N" ;
lin sultana_N = mkTerm "sultana_N" ;
lin sultanate_N = mkTerm "sultanate_N" ;
lin sultriness_N = mkTerm "sultriness_N" ;
lin sultry_A = mkTerm "sultry_A" ;
lin sum_N = mkTerm "sum_N" ;
lin sum_V = mkTerm "sum_V" ;
lin sum_V2 = mkTerm "sum_V2" ;
lin sum_up_V2 = mkTerm "sum_up_V2" ;
lin sumac_N = mkTerm "sumac_N" ;
lin sumach_N = mkTerm "sumach_N" ;
lin sumatra_PN = mkTerm "sumatra_PN" ;
lin sumatran_A = mkTerm "sumatran_A" ;
lin sumatran_N = mkTerm "sumatran_N" ;
lin sumiainen_PN = mkTerm "sumiainen_PN" ;
lin summarization_N = mkTerm "summarization_N" ;
lin summarize_V2 = mkTerm "summarize_V2" ;
lin summary_A = mkTerm "summary_A" ;
lin summary_N = mkTerm "summary_N" ;
lin summation_N = mkTerm "summation_N" ;
lin summational_A = mkTerm "summational_A" ;
lin summer_N = mkTerm "summer_N" ;
lin summer_V = mkTerm "summer_V" ;
lin summercaters_N = mkTerm "summercaters_N" ;
lin summerhouse_N = mkTerm "summerhouse_N" ;
lin summertime_N = mkTerm "summertime_N" ;
lin summery_A = mkTerm "summery_A" ;
lin summing_up_N = mkTerm "summing_up_N" ;
lin summit_N = mkTerm "summit_N" ;
lin summon_V2 = mkTerm "summon_V2" ;
lin summon_up_V2 = mkTerm "summon_up_V2" ;
lin summons_N = mkTerm "summons_N" ;
lin summons_V2 = mkTerm "summons_V2" ;
lin sumo_N = mkTerm "sumo_N" ;
lin sump_N = mkTerm "sump_N" ;
lin sumpsimus_N = mkTerm "sumpsimus_N" ;
lin sumpter_N = mkTerm "sumpter_N" ;
lin sumptuary_A = mkTerm "sumptuary_A" ;
lin sumptuous_A = mkTerm "sumptuous_A" ;
lin sumptuousness_N = mkTerm "sumptuousness_N" ;
lin sun_N = mkTerm "sun_N" ;
lin sun_PN = mkTerm "sun_PN" ;
lin sun_V2 = mkTerm "sun_V2" ;
lin sun_drenched_A = mkTerm "sun_drenched_A" ;
lin sun_dried_A = mkTerm "sun_dried_A" ;
lin sun_god_N = mkTerm "sun_god_N" ;
lin sun_helmet_N = mkTerm "sun_helmet_N" ;
lin sun_lounge_N = mkTerm "sun_lounge_N" ;
lin sun_parlour_N = mkTerm "sun_parlour_N" ;
lin sun_porch_N = mkTerm "sun_porch_N" ;
lin sun_up_N = mkTerm "sun_up_N" ;
lin sun_visor_N = mkTerm "sun_visor_N" ;
lin sun_worship_N = mkTerm "sun_worship_N" ;
lin sunbaked_A = mkTerm "sunbaked_A" ;
lin sunbathe_N = mkTerm "sunbathe_N" ;
lin sunbathe_V = mkTerm "sunbathe_V" ;
lin sunbather_N = mkTerm "sunbather_N" ;
lin sunbeam_N = mkTerm "sunbeam_N" ;
lin sunblind_N = mkTerm "sunblind_N" ;
lin sunbonnet_N = mkTerm "sunbonnet_N" ;
lin sunburn_N = mkTerm "sunburn_N" ;
lin sunburned_A = mkTerm "sunburned_A" ;
lin sunburnt_A = mkTerm "sunburnt_A" ;
lin sunburst_N = mkTerm "sunburst_N" ;
lin sundae_N = mkTerm "sundae_N" ;
lin sunder_N = mkTerm "sunder_N" ;
lin sunder_V2 = mkTerm "sunder_V2" ;
lin sunderland_PN = mkTerm "sunderland_PN" ;
lin sundew_N = mkTerm "sundew_N" ;
lin sundial_N = mkTerm "sundial_N" ;
lin sundown_N = mkTerm "sundown_N" ;
lin sundowner_N = mkTerm "sundowner_N" ;
lin sundress_N = mkTerm "sundress_N" ;
lin sundries_N = mkTerm "sundries_N" ;
lin sundrops_N = mkTerm "sundrops_N" ;
lin sundry_A = mkTerm "sundry_A" ;
lin sunfish_N = mkTerm "sunfish_N" ;
lin sunflower_N = mkTerm "sunflower_N" ;
lin sunglass_N = mkTerm "sunglass_N" ;
lin sunglasses_N = mkTerm "sunglasses_N" ;
lin sunhat_N = mkTerm "sunhat_N" ;
lin sunken_A = mkTerm "sunken_A" ;
lin sunlamp_N = mkTerm "sunlamp_N" ;
lin sunless_A = mkTerm "sunless_A" ;
lin sunlight_N = mkTerm "sunlight_N" ;
lin sunlit_A = mkTerm "sunlit_A" ;
lin sunniness_N = mkTerm "sunniness_N" ;
lin sunny_A = mkTerm "sunny_A" ;
lin sunray_A = mkTerm "sunray_A" ;
lin sunray_N = mkTerm "sunray_N" ;
lin sunrise_N = mkTerm "sunrise_N" ;
lin sunroof_N = mkTerm "sunroof_N" ;
lin sunscreen_N = mkTerm "sunscreen_N" ;
lin sunset_A = mkTerm "sunset_A" ;
lin sunset_N = mkTerm "sunset_N" ;
lin sunshade_N = mkTerm "sunshade_N" ;
lin sunshine_N = mkTerm "sunshine_N" ;
lin sunshine_roof_N = mkTerm "sunshine_roof_N" ;
lin sunspot_N = mkTerm "sunspot_N" ;
lin sunstone_N = mkTerm "sunstone_N" ;
lin sunstroke_N = mkTerm "sunstroke_N" ;
lin sunsuit_N = mkTerm "sunsuit_N" ;
lin suntan_N = mkTerm "suntan_N" ;
lin suntrap_N = mkTerm "suntrap_N" ;
lin suodenniemi_PN = mkTerm "suodenniemi_PN" ;
lin suolahti_PN = mkTerm "suolahti_PN" ;
lin suomusjärvi_PN = mkTerm "suomusjärvi_PN" ;
lin suomussalmi_PN = mkTerm "suomussalmi_PN" ;
lin suonenjoki_PN = mkTerm "suonenjoki_PN" ;
lin sup_N = mkTerm "sup_N" ;
lin sup_V = mkTerm "sup_V" ;
lin sup_V2 = mkTerm "sup_V2" ;
lin super_A = mkTerm "super_A" ;
lin super_N = mkTerm "super_N" ;
lin superabundance_N = mkTerm "superabundance_N" ;
lin superabundant_A = mkTerm "superabundant_A" ;
lin superannuate_V2 = mkTerm "superannuate_V2" ;
lin superannuation_N = mkTerm "superannuation_N" ;
lin superb_A = mkTerm "superb_A" ;
lin superbug_N = mkTerm "superbug_N" ;
lin supercargo_N = mkTerm "supercargo_N" ;
lin supercede_V2 = mkTerm "supercede_V2" ;
lin supercharged_A = mkTerm "supercharged_A" ;
lin supercharger_N = mkTerm "supercharger_N" ;
lin supercilious_A = mkTerm "supercilious_A" ;
lin superciliousness_N = mkTerm "superciliousness_N" ;
lin superclass_N = mkTerm "superclass_N" ;
lin supercomputer_N = mkTerm "supercomputer_N" ;
lin superconductivity_N = mkTerm "superconductivity_N" ;
lin supercritical_A = mkTerm "supercritical_A" ;
lin superego_N = mkTerm "superego_N" ;
lin supererogation_N = mkTerm "supererogation_N" ;
lin superfamily_N = mkTerm "superfamily_N" ;
lin superfatted_A = mkTerm "superfatted_A" ;
lin superfecta_N = mkTerm "superfecta_N" ;
lin superfecundation_N = mkTerm "superfecundation_N" ;
lin superfetation_N = mkTerm "superfetation_N" ;
lin superficial_A = mkTerm "superficial_A" ;
lin superficiality_N = mkTerm "superficiality_N" ;
lin superficies_N = mkTerm "superficies_N" ;
lin superfine_A = mkTerm "superfine_A" ;
lin superfluity_N = mkTerm "superfluity_N" ;
lin superfluous_A = mkTerm "superfluous_A" ;
lin supergiant_N = mkTerm "supergiant_N" ;
lin supergrass_N = mkTerm "supergrass_N" ;
lin superhero_N = mkTerm "superhero_N" ;
lin superhighway_N = mkTerm "superhighway_N" ;
lin superhuman_A = mkTerm "superhuman_A" ;
lin superimpose_V2 = mkTerm "superimpose_V2" ;
lin superincumbent_A = mkTerm "superincumbent_A" ;
lin superinfection_N = mkTerm "superinfection_N" ;
lin superintend_V = mkTerm "superintend_V" ;
lin superintend_V2 = mkTerm "superintend_V2" ;
lin superintendence_N = mkTerm "superintendence_N" ;
lin superintendent_N = mkTerm "superintendent_N" ;
lin superior_A = mkTerm "superior_A" ;
lin superior_N = mkTerm "superior_N" ;
lin superiority_N = mkTerm "superiority_N" ;
lin superjacent_A = mkTerm "superjacent_A" ;
lin superlative_A = mkTerm "superlative_A" ;
lin superlative_N = mkTerm "superlative_N" ;
lin superman_N = mkTerm "superman_N" ;
lin supermarket_N = mkTerm "supermarket_N" ;
lin supermarketer_N = mkTerm "supermarketer_N" ;
lin supermodel_N = mkTerm "supermodel_N" ;
lin supermom_N = mkTerm "supermom_N" ;
lin supernal_A = mkTerm "supernal_A" ;
lin supernatant_A = mkTerm "supernatant_A" ;
lin supernatant_N = mkTerm "supernatant_N" ;
lin supernatural_A = mkTerm "supernatural_A" ;
lin supernatural_N = mkTerm "supernatural_N" ;
lin supernaturalism_N = mkTerm "supernaturalism_N" ;
lin supernaturalist_A = mkTerm "supernaturalist_A" ;
lin supernormal_A = mkTerm "supernormal_A" ;
lin supernova_N = mkTerm "supernova_N" ;
lin supernumerary_N = mkTerm "supernumerary_N" ;
lin superorder_N = mkTerm "superorder_N" ;
lin superordinate_A = mkTerm "superordinate_A" ;
lin superoxide_N = mkTerm "superoxide_N" ;
lin superphylum_N = mkTerm "superphylum_N" ;
lin superposition_N = mkTerm "superposition_N" ;
lin supersaturated_A = mkTerm "supersaturated_A" ;
lin superscript_A = mkTerm "superscript_A" ;
lin superscript_N = mkTerm "superscript_N" ;
lin superscription_N = mkTerm "superscription_N" ;
lin supersede_V2 = mkTerm "supersede_V2" ;
lin supersedure_N = mkTerm "supersedure_N" ;
lin supersession_N = mkTerm "supersession_N" ;
lin supersonic_A = mkTerm "supersonic_A" ;
lin superstar_N = mkTerm "superstar_N" ;
lin superstition_N = mkTerm "superstition_N" ;
lin superstitious_A = mkTerm "superstitious_A" ;
lin superstrate_N = mkTerm "superstrate_N" ;
lin superstring_N = mkTerm "superstring_N" ;
lin superstructure_N = mkTerm "superstructure_N" ;
lin supersymmetry_N = mkTerm "supersymmetry_N" ;
lin supertanker_N = mkTerm "supertanker_N" ;
lin supertax_N = mkTerm "supertax_N" ;
lin supertitle_N = mkTerm "supertitle_N" ;
lin supertonic_N = mkTerm "supertonic_N" ;
lin supertwister_N = mkTerm "supertwister_N" ;
lin supervene_V = mkTerm "supervene_V" ;
lin supervention_N = mkTerm "supervention_N" ;
lin supervise_V = mkTerm "supervise_V" ;
lin supervise_V2 = mkTerm "supervise_V2" ;
lin supervision_N = mkTerm "supervision_N" ;
lin supervisor_N = mkTerm "supervisor_N" ;
lin supervisory_A = mkTerm "supervisory_A" ;
lin supination_N = mkTerm "supination_N" ;
lin supinator_N = mkTerm "supinator_N" ;
lin supine_A = mkTerm "supine_A" ;
lin supper_N = mkTerm "supper_N" ;
lin supperless_A = mkTerm "supperless_A" ;
lin supping_N = mkTerm "supping_N" ;
lin supplant_V2 = mkTerm "supplant_V2" ;
lin supplanter_N = mkTerm "supplanter_N" ;
lin supplanting_N = mkTerm "supplanting_N" ;
lin supple_A = mkTerm "supple_A" ;
lin supplejack_N = mkTerm "supplejack_N" ;
lin supplement_N = mkTerm "supplement_N" ;
lin supplement_V2 = mkTerm "supplement_V2" ;
lin supplementary_A = mkTerm "supplementary_A" ;
lin supplementation_N = mkTerm "supplementation_N" ;
lin suppleness_N = mkTerm "suppleness_N" ;
lin suppliant_A = mkTerm "suppliant_A" ;
lin suppliant_N = mkTerm "suppliant_N" ;
lin supplicant_N = mkTerm "supplicant_N" ;
lin supplicate_V = mkTerm "supplicate_V" ;
lin supplicate_V2 = mkTerm "supplicate_V2" ;
lin supplication_N = mkTerm "supplication_N" ;
lin supplier_N = mkTerm "supplier_N" ;
lin supply_N = mkTerm "supply_N" ;
lin supply_V2 = mkTerm "supply_V2" ;
lin support_N = mkTerm "support_N" ;
lin support_V2 = mkTerm "support_V2" ;
lin supportable_A = mkTerm "supportable_A" ;
lin supporter_N = mkTerm "supporter_N" ;
lin supporting_A = mkTerm "supporting_A" ;
lin supportive_A = mkTerm "supportive_A" ;
lin suppose_V2 = mkTerm "suppose_V2" ;
lin suppose_VS = mkTerm "suppose_VS" ;
lin supposed_A = mkTerm "supposed_A" ;
lin supposition_N = mkTerm "supposition_N" ;
lin suppository_N = mkTerm "suppository_N" ;
lin suppress_V2 = mkTerm "suppress_V2" ;
lin suppressant_N = mkTerm "suppressant_N" ;
lin suppression_N = mkTerm "suppression_N" ;
lin suppressive_A = mkTerm "suppressive_A" ;
lin suppressor_N = mkTerm "suppressor_N" ;
lin suppurate_V = mkTerm "suppurate_V" ;
lin suppuration_N = mkTerm "suppuration_N" ;
lin suppurative_A = mkTerm "suppurative_A" ;
lin supra_Adv = mkTerm "supra_Adv" ;
lin suprainfection_N = mkTerm "suprainfection_N" ;
lin supranational_A = mkTerm "supranational_A" ;
lin supraorbital_A = mkTerm "supraorbital_A" ;
lin suprasegmental_A = mkTerm "suprasegmental_A" ;
lin supremacism_N = mkTerm "supremacism_N" ;
lin supremacist_N = mkTerm "supremacist_N" ;
lin supremacy_N = mkTerm "supremacy_N" ;
lin suprematism_N = mkTerm "suprematism_N" ;
lin suprematist_N = mkTerm "suprematist_N" ;
lin supreme_A = mkTerm "supreme_A" ;
lin supremo_N = mkTerm "supremo_N" ;
lin supt_PN = mkTerm "supt_PN" ;
lin sura_N = mkTerm "sura_N" ;
lin surabaja_PN = mkTerm "surabaja_PN" ;
lin surbase_N = mkTerm "surbase_N" ;
lin surcharge_N = mkTerm "surcharge_N" ;
lin surcharge_V2 = mkTerm "surcharge_V2" ;
lin surcoat_N = mkTerm "surcoat_N" ;
lin surd_N = mkTerm "surd_N" ;
lin sure_A = mkTerm "sure_A" ;
lin sure_Adv = mkTerm "sure_Adv" ;
lin sure_footed_A = mkTerm "sure_footed_A" ;
lin surefooted_A = mkTerm "surefooted_A" ;
lin sureness_N = mkTerm "sureness_N" ;
lin surety_N = mkTerm "surety_N" ;
lin surf_N = mkTerm "surf_N" ;
lin surface_A = mkTerm "surface_A" ;
lin surface_N = mkTerm "surface_N" ;
lin surface_V = mkTerm "surface_V" ;
lin surface_V2 = mkTerm "surface_V2" ;
lin surface_V2V = mkTerm "surface_V2V" ;
lin surface_VS = mkTerm "surface_VS" ;
lin surface_to_air_A = mkTerm "surface_to_air_A" ;
lin surfacing_N = mkTerm "surfacing_N" ;
lin surfbird_N = mkTerm "surfbird_N" ;
lin surfboard_N = mkTerm "surfboard_N" ;
lin surfboat_N = mkTerm "surfboat_N" ;
lin surfeit_N = mkTerm "surfeit_N" ;
lin surfeit_V2 = mkTerm "surfeit_V2" ;
lin surfer_N = mkTerm "surfer_N" ;
lin surficial_A = mkTerm "surficial_A" ;
lin surfing_N = mkTerm "surfing_N" ;
lin surfperch_N = mkTerm "surfperch_N" ;
lin surfriding_N = mkTerm "surfriding_N" ;
lin surge_N = mkTerm "surge_N" ;
lin surge_V = mkTerm "surge_V" ;
lin surge_V2 = mkTerm "surge_V2" ;
lin surge_on_V = mkTerm "surge_on_V" ;
lin surgeon_N = mkTerm "surgeon_N" ;
lin surgeonfish_N = mkTerm "surgeonfish_N" ;
lin surgery_N = mkTerm "surgery_N" ;
lin surgical_A = mkTerm "surgical_A" ;
lin suricate_N = mkTerm "suricate_N" ;
lin surliness_N = mkTerm "surliness_N" ;
lin surly_A = mkTerm "surly_A" ;
lin surmise_N = mkTerm "surmise_N" ;
lin surmise_V = mkTerm "surmise_V" ;
lin surmise_V2 = mkTerm "surmise_V2" ;
lin surmount_V2 = mkTerm "surmount_V2" ;
lin surmountable_A = mkTerm "surmountable_A" ;
lin surname_N = mkTerm "surname_N" ;
lin surpass_V2 = mkTerm "surpass_V2" ;
lin surpassing_A = mkTerm "surpassing_A" ;
lin surplice_N = mkTerm "surplice_N" ;
lin surpliced_A = mkTerm "surpliced_A" ;
lin surplus_A = mkTerm "surplus_A" ;
lin surplus_N = mkTerm "surplus_N" ;
lin surprise_N = mkTerm "surprise_N" ;
lin surprise_V2 = mkTerm "surprise_V2" ;
lin surprise_V2V = mkTerm "surprise_V2V" ;
lin surprised_A = mkTerm "surprised_A" ;
lin surpriser_N = mkTerm "surpriser_N" ;
lin surprising_A = mkTerm "surprising_A" ;
lin surreal_A = mkTerm "surreal_A" ;
lin surrealism_N = mkTerm "surrealism_N" ;
lin surrealist_N = mkTerm "surrealist_N" ;
lin surrealistic_A = mkTerm "surrealistic_A" ;
lin surrebutter_N = mkTerm "surrebutter_N" ;
lin surrejoinder_N = mkTerm "surrejoinder_N" ;
lin surrender_N = mkTerm "surrender_N" ;
lin surrender_V = mkTerm "surrender_V" ;
lin surrender_V2 = mkTerm "surrender_V2" ;
lin surrenderer_N = mkTerm "surrenderer_N" ;
lin surreptitious_A = mkTerm "surreptitious_A" ;
lin surrey_N = mkTerm "surrey_N" ;
lin surrey_PN = mkTerm "surrey_PN" ;
lin surrogate_A = mkTerm "surrogate_A" ;
lin surrogate_N = mkTerm "surrogate_N" ;
lin surround_N = mkTerm "surround_N" ;
lin surround_V2 = mkTerm "surround_V2" ;
lin surrounding_A = mkTerm "surrounding_A" ;
lin surrounding_N = mkTerm "surrounding_N" ;
lin surroundings_N = mkTerm "surroundings_N" ;
lin surtax_N = mkTerm "surtax_N" ;
lin surtax_V2 = mkTerm "surtax_V2" ;
lin surtout_N = mkTerm "surtout_N" ;
lin surveillance_N = mkTerm "surveillance_N" ;
lin survey_N = mkTerm "survey_N" ;
lin survey_V2 = mkTerm "survey_V2" ;
lin surveying_N = mkTerm "surveying_N" ;
lin surveyor_N = mkTerm "surveyor_N" ;
lin survival_N = mkTerm "survival_N" ;
lin survivalist_N = mkTerm "survivalist_N" ;
lin survive_V = mkTerm "survive_V" ;
lin survive_V2 = mkTerm "survive_V2" ;
lin survivor_N = mkTerm "survivor_N" ;
lin susan_PN = mkTerm "susan_PN" ;
lin susanna_PN = mkTerm "susanna_PN" ;
lin susceptibility_N = mkTerm "susceptibility_N" ;
lin susceptible_A = mkTerm "susceptible_A" ;
lin sushi_N = mkTerm "sushi_N" ;
lin susie_PN = mkTerm "susie_PN" ;
lin suslik_N = mkTerm "suslik_N" ;
lin suspect_A = mkTerm "suspect_A" ;
lin suspect_N = mkTerm "suspect_N" ;
lin suspect_V2 = mkTerm "suspect_V2" ;
lin suspect_VS = mkTerm "suspect_VS" ;
lin suspend_V = mkTerm "suspend_V" ;
lin suspend_V2 = mkTerm "suspend_V2" ;
lin suspender_N = mkTerm "suspender_N" ;
lin suspense_N = mkTerm "suspense_N" ;
lin suspension_N = mkTerm "suspension_N" ;
lin suspensive_A = mkTerm "suspensive_A" ;
lin suspensory_N = mkTerm "suspensory_N" ;
lin suspicion_N = mkTerm "suspicion_N" ;
lin suspicious_A = mkTerm "suspicious_A" ;
lin suss_V2 = mkTerm "suss_V2" ;
lin suss_out_V2 = mkTerm "suss_out_V2" ;
lin sussex_PN = mkTerm "sussex_PN" ;
lin sustain_V2 = mkTerm "sustain_V2" ;
lin sustainability_N = mkTerm "sustainability_N" ;
lin sustainable_A = mkTerm "sustainable_A" ;
lin sustained_A = mkTerm "sustained_A" ;
lin sustenance_N = mkTerm "sustenance_N" ;
lin sustentacular_A = mkTerm "sustentacular_A" ;
lin susurration_N = mkTerm "susurration_N" ;
lin sutler_N = mkTerm "sutler_N" ;
lin sutra_N = mkTerm "sutra_N" ;
lin suttee_N = mkTerm "suttee_N" ;
lin sutton_PN = mkTerm "sutton_PN" ;
lin sutton_at_hone_PN = mkTerm "sutton_at_hone_PN" ;
lin sutton_coldfield_PN = mkTerm "sutton_coldfield_PN" ;
lin sutton_in_ashfield_PN = mkTerm "sutton_in_ashfield_PN" ;
lin suture_N = mkTerm "suture_N" ;
lin suturing_N = mkTerm "suturing_N" ;
lin suzanne_PN = mkTerm "suzanne_PN" ;
lin suzerain_N = mkTerm "suzerain_N" ;
lin suzerainty_N = mkTerm "suzerainty_N" ;
lin svelte_A = mkTerm "svelte_A" ;
lin sverdlovsk_PN = mkTerm "sverdlovsk_PN" ;
lin svoboda_N = mkTerm "svoboda_N" ;
lin swab_N = mkTerm "swab_N" ;
lin swab_V2 = mkTerm "swab_V2" ;
lin swabbing_N = mkTerm "swabbing_N" ;
lin swad_N = mkTerm "swad_N" ;
lin swaddle_V2 = mkTerm "swaddle_V2" ;
lin swadlincote_PN = mkTerm "swadlincote_PN" ;
lin swag_N = mkTerm "swag_N" ;
lin swagger_A = mkTerm "swagger_A" ;
lin swagger_N = mkTerm "swagger_N" ;
lin swagger_V = mkTerm "swagger_V" ;
lin swaggerer_N = mkTerm "swaggerer_N" ;
lin swagman_N = mkTerm "swagman_N" ;
lin swain_N = mkTerm "swain_N" ;
lin swale_N = mkTerm "swale_N" ;
lin swallow_N = mkTerm "swallow_N" ;
lin swallow_V = mkTerm "swallow_V" ;
lin swallow_V2 = mkTerm "swallow_V2" ;
lin swallow_tailed_A = mkTerm "swallow_tailed_A" ;
lin swallow_up_V = mkTerm "swallow_up_V" ;
lin swami_N = mkTerm "swami_N" ;
lin swamp_N = mkTerm "swamp_N" ;
lin swamp_V2 = mkTerm "swamp_V2" ;
lin swampy_A = mkTerm "swampy_A" ;
lin swan's_down_N = mkTerm "swan's_down_N" ;
lin swan_N = mkTerm "swan_N" ;
lin swan_V = mkTerm "swan_V" ;
lin swan_about_V = mkTerm "swan_about_V" ;
lin swan_around_V = mkTerm "swan_around_V" ;
lin swan_in_V = mkTerm "swan_in_V" ;
lin swan_off_V = mkTerm "swan_off_V" ;
lin swan_song_N = mkTerm "swan_song_N" ;
lin swanage_PN = mkTerm "swanage_PN" ;
lin swank_A = mkTerm "swank_A" ;
lin swank_N = mkTerm "swank_N" ;
lin swank_V = mkTerm "swank_V" ;
lin swanky_A = mkTerm "swanky_A" ;
lin swanley_PN = mkTerm "swanley_PN" ;
lin swansea_PN = mkTerm "swansea_PN" ;
lin swap_N = mkTerm "swap_N" ;
lin swap_V = mkTerm "swap_V" ;
lin swap_V2 = mkTerm "swap_V2" ;
lin sward_N = mkTerm "sward_N" ;
lin swarm_N = mkTerm "swarm_N" ;
lin swarm_V = mkTerm "swarm_V" ;
lin swarm_V2 = mkTerm "swarm_V2" ;
lin swarthy_A = mkTerm "swarthy_A" ;
lin swash_N = mkTerm "swash_N" ;
lin swashbuckler_N = mkTerm "swashbuckler_N" ;
lin swashbuckling_A = mkTerm "swashbuckling_A" ;
lin swashbuckling_N = mkTerm "swashbuckling_N" ;
lin swastika_N = mkTerm "swastika_N" ;
lin swat_N = mkTerm "swat_N" ;
lin swat_V2 = mkTerm "swat_V2" ;
lin swatch_N = mkTerm "swatch_N" ;
lin swath_N = mkTerm "swath_N" ;
lin swathe_N = mkTerm "swathe_N" ;
lin swathe_V2 = mkTerm "swathe_V2" ;
lin swathing_N = mkTerm "swathing_N" ;
lin swatter_N = mkTerm "swatter_N" ;
lin sway_N = mkTerm "sway_N" ;
lin sway_V = mkTerm "sway_V" ;
lin sway_V2 = mkTerm "sway_V2" ;
lin swazi_A = mkTerm "swazi_A" ;
lin swazi_N = mkTerm "swazi_N" ;
lin swaziland_PN = mkTerm "swaziland_PN" ;
lin swear_V = mkTerm "swear_V" ;
lin swear_V2 = mkTerm "swear_V2" ;
lin swear_VV = mkTerm "swear_VV" ;
lin swear_by_V2 = mkTerm "swear_by_V2" ;
lin swear_down_V = mkTerm "swear_down_V" ;
lin swear_off_V = mkTerm "swear_off_V" ;
lin swearer_N = mkTerm "swearer_N" ;
lin swearing_N = mkTerm "swearing_N" ;
lin swearword_N = mkTerm "swearword_N" ;
lin sweat_N = mkTerm "sweat_N" ;
lin sweat_V = mkTerm "sweat_V" ;
lin sweat_V2 = mkTerm "sweat_V2" ;
lin sweat_out_V = mkTerm "sweat_out_V" ;
lin sweatband_N = mkTerm "sweatband_N" ;
lin sweatbox_N = mkTerm "sweatbox_N" ;
lin sweater_N = mkTerm "sweater_N" ;
lin sweatshirt_N = mkTerm "sweatshirt_N" ;
lin sweatshop_N = mkTerm "sweatshop_N" ;
lin sweaty_A = mkTerm "sweaty_A" ;
lin swedeFem_N = mkTerm "swedeFem_N" ;
lin swedeMasc_N = mkTerm "swedeMasc_N" ;
lin sweden_PN = mkTerm "sweden_PN" ;
lin swedishFem_N = mkTerm "swedishFem_N" ;
lin swedishMasc_N = mkTerm "swedishMasc_N" ;
lin swedish_A = mkTerm "swedish_A" ;
lin sweep_N = mkTerm "sweep_N" ;
lin sweep_V = mkTerm "sweep_V" ;
lin sweep_V2 = mkTerm "sweep_V2" ;
lin sweep_through_V2 = mkTerm "sweep_through_V2" ;
lin sweeper_N = mkTerm "sweeper_N" ;
lin sweeping_A = mkTerm "sweeping_A" ;
lin sweeping_N = mkTerm "sweeping_N" ;
lin sweepstakes_N = mkTerm "sweepstakes_N" ;
lin sweet_A = mkTerm "sweet_A" ;
lin sweet_N = mkTerm "sweet_N" ;
lin sweet_scented_A = mkTerm "sweet_scented_A" ;
lin sweetbread_N = mkTerm "sweetbread_N" ;
lin sweetbriar_N = mkTerm "sweetbriar_N" ;
lin sweetbrier_N = mkTerm "sweetbrier_N" ;
lin sweeten_V = mkTerm "sweeten_V" ;
lin sweeten_V2 = mkTerm "sweeten_V2" ;
lin sweetening_N = mkTerm "sweetening_N" ;
lin sweetheart_A = mkTerm "sweetheart_A" ;
lin sweetheart_N = mkTerm "sweetheart_N" ;
lin sweetie_N = mkTerm "sweetie_N" ;
lin sweetish_A = mkTerm "sweetish_A" ;
lin sweetleaf_N = mkTerm "sweetleaf_N" ;
lin sweetmeat_N = mkTerm "sweetmeat_N" ;
lin sweetness_N = mkTerm "sweetness_N" ;
lin sweetsop_N = mkTerm "sweetsop_N" ;
lin swell_A = mkTerm "swell_A" ;
lin swell_N = mkTerm "swell_N" ;
lin swell_V = mkTerm "swell_V" ;
lin swell_V2 = mkTerm "swell_V2" ;
lin swelling_N = mkTerm "swelling_N" ;
lin swelter_V = mkTerm "swelter_V" ;
lin sweptback_A = mkTerm "sweptback_A" ;
lin sweptwing_A = mkTerm "sweptwing_A" ;
lin swerve_N = mkTerm "swerve_N" ;
lin swerve_V = mkTerm "swerve_V" ;
lin swerve_V2 = mkTerm "swerve_V2" ;
lin swift_A = mkTerm "swift_A" ;
lin swift_N = mkTerm "swift_N" ;
lin swiftlet_N = mkTerm "swiftlet_N" ;
lin swiftness_N = mkTerm "swiftness_N" ;
lin swig_N = mkTerm "swig_N" ;
lin swig_V = mkTerm "swig_V" ;
lin swig_V2 = mkTerm "swig_V2" ;
lin swill_N = mkTerm "swill_N" ;
lin swill_V = mkTerm "swill_V" ;
lin swill_V2 = mkTerm "swill_V2" ;
lin swim_N = mkTerm "swim_N" ;
lin swim_V = mkTerm "swim_V" ;
lin swim_V2 = mkTerm "swim_V2" ;
lin swimmer_N = mkTerm "swimmer_N" ;
lin swimmeret_N = mkTerm "swimmeret_N" ;
lin swimming_N = mkTerm "swimming_N" ;
lin swimming_bath_N = mkTerm "swimming_bath_N" ;
lin swimming_costume_N = mkTerm "swimming_costume_N" ;
lin swimming_pool_N = mkTerm "swimming_pool_N" ;
lin swimmingly_Adv = mkTerm "swimmingly_Adv" ;
lin swimsuit_N = mkTerm "swimsuit_N" ;
lin swindle_N = mkTerm "swindle_N" ;
lin swindle_V = mkTerm "swindle_V" ;
lin swindle_V2 = mkTerm "swindle_V2" ;
lin swindler_N = mkTerm "swindler_N" ;
lin swindon_PN = mkTerm "swindon_PN" ;
lin swine_N = mkTerm "swine_N" ;
lin swineherd_N = mkTerm "swineherd_N" ;
lin swing_N = mkTerm "swing_N" ;
lin swing_V = mkTerm "swing_V" ;
lin swing_V2 = mkTerm "swing_V2" ;
lin swing_around_V = mkTerm "swing_around_V" ;
lin swing_at_V2 = mkTerm "swing_at_V2" ;
lin swing_by_V = mkTerm "swing_by_V" ;
lin swing_round_V = mkTerm "swing_round_V" ;
lin swinge_V2 = mkTerm "swinge_V2" ;
lin swingeing_A = mkTerm "swingeing_A" ;
lin swinger_N = mkTerm "swinger_N" ;
lin swinish_A = mkTerm "swinish_A" ;
lin swinton_PN = mkTerm "swinton_PN" ;
lin swipe_N = mkTerm "swipe_N" ;
lin swipe_V2 = mkTerm "swipe_V2" ;
lin swirl_N = mkTerm "swirl_N" ;
lin swirl_V = mkTerm "swirl_V" ;
lin swirl_V2 = mkTerm "swirl_V2" ;
lin swish_A = mkTerm "swish_A" ;
lin swish_N = mkTerm "swish_N" ;
lin swish_V = mkTerm "swish_V" ;
lin swish_V2 = mkTerm "swish_V2" ;
lin swishy_A = mkTerm "swishy_A" ;
lin swiss_A = mkTerm "swiss_A" ;
lin swiss_N = mkTerm "swiss_N" ;
lin switch_N = mkTerm "switch_N" ;
lin switch_V = mkTerm "switch_V" ;
lin switch_V2 = mkTerm "switch_V2" ;
lin switch_off_V2 = mkTerm "switch_off_V2" ;
lin switch_on_V2 = mkTerm "switch_on_V2" ;
lin switchblade_N = mkTerm "switchblade_N" ;
lin switchboard_N = mkTerm "switchboard_N" ;
lin switcher_N = mkTerm "switcher_N" ;
lin switcheroo_N = mkTerm "switcheroo_N" ;
lin switchman_N = mkTerm "switchman_N" ;
lin switzerland_PN = mkTerm "switzerland_PN" ;
lin swivel_N = mkTerm "swivel_N" ;
lin swivel_V = mkTerm "swivel_V" ;
lin swivel_V2 = mkTerm "swivel_V2" ;
lin swivet_N = mkTerm "swivet_N" ;
lin swiz_N = mkTerm "swiz_N" ;
lin swizzle_N = mkTerm "swizzle_N" ;
lin swizzle_stick_N = mkTerm "swizzle_stick_N" ;
lin swob_N = mkTerm "swob_N" ;
lin swob_V2 = mkTerm "swob_V2" ;
lin swollen_headed_A = mkTerm "swollen_headed_A" ;
lin swoon_N = mkTerm "swoon_N" ;
lin swoon_V = mkTerm "swoon_V" ;
lin swoop_N = mkTerm "swoop_N" ;
lin swoop_V = mkTerm "swoop_V" ;
lin swoop_V2 = mkTerm "swoop_V2" ;
lin swoosh_N = mkTerm "swoosh_N" ;
lin swop_N = mkTerm "swop_N" ;
lin swop_V = mkTerm "swop_V" ;
lin swop_V2 = mkTerm "swop_V2" ;
lin sword_N = mkTerm "sword_N" ;
lin sword_cane_N = mkTerm "sword_cane_N" ;
lin sword_cut_N = mkTerm "sword_cut_N" ;
lin sword_dance_N = mkTerm "sword_dance_N" ;
lin swordfish_N = mkTerm "swordfish_N" ;
lin swordplay_N = mkTerm "swordplay_N" ;
lin swordsman_N = mkTerm "swordsman_N" ;
lin swordsmanship_N = mkTerm "swordsmanship_N" ;
lin swordstick_N = mkTerm "swordstick_N" ;
lin swordtail_N = mkTerm "swordtail_N" ;
lin swore_off_V = mkTerm "swore_off_V" ;
lin swot_N = mkTerm "swot_N" ;
lin swot_V = mkTerm "swot_V" ;
lin swot_V2 = mkTerm "swot_V2" ;
lin sybarite_N = mkTerm "sybarite_N" ;
lin sybaritic_A = mkTerm "sybaritic_A" ;
lin sycamore_N = mkTerm "sycamore_N" ;
lin syconium_N = mkTerm "syconium_N" ;
lin sycophancy_N = mkTerm "sycophancy_N" ;
lin sycophant_N = mkTerm "sycophant_N" ;
lin sycophantic_A = mkTerm "sycophantic_A" ;
lin sydney_PN = mkTerm "sydney_PN" ;
lin syllabary_N = mkTerm "syllabary_N" ;
lin syllabic_A = mkTerm "syllabic_A" ;
lin syllabicate_V2 = mkTerm "syllabicate_V2" ;
lin syllabication_N = mkTerm "syllabication_N" ;
lin syllabicity_N = mkTerm "syllabicity_N" ;
lin syllabification_N = mkTerm "syllabification_N" ;
lin syllabify_V2 = mkTerm "syllabify_V2" ;
lin syllabize_V2 = mkTerm "syllabize_V2" ;
lin syllable_N = mkTerm "syllable_N" ;
lin syllabled_A = mkTerm "syllabled_A" ;
lin syllabub_N = mkTerm "syllabub_N" ;
lin syllabus_N = mkTerm "syllabus_N" ;
lin syllepsis_N = mkTerm "syllepsis_N" ;
lin syllogism_N = mkTerm "syllogism_N" ;
lin syllogist_N = mkTerm "syllogist_N" ;
lin syllogistic_A = mkTerm "syllogistic_A" ;
lin sylph_N = mkTerm "sylph_N" ;
lin sylph_like_A = mkTerm "sylph_like_A" ;
lin sylvan_A = mkTerm "sylvan_A" ;
lin sylvan_N = mkTerm "sylvan_N" ;
lin sylvanite_N = mkTerm "sylvanite_N" ;
lin sylvia_PN = mkTerm "sylvia_PN" ;
lin sylvite_N = mkTerm "sylvite_N" ;
lin symbiosis_N = mkTerm "symbiosis_N" ;
lin symbiotic_A = mkTerm "symbiotic_A" ;
lin symbol_N = mkTerm "symbol_N" ;
lin symbolatry_N = mkTerm "symbolatry_N" ;
lin symbolic_A = mkTerm "symbolic_A" ;
lin symbolical_A = mkTerm "symbolical_A" ;
lin symbolism_N = mkTerm "symbolism_N" ;
lin symbolist_N = mkTerm "symbolist_N" ;
lin symbolization_N = mkTerm "symbolization_N" ;
lin symbolize_V2 = mkTerm "symbolize_V2" ;
lin symbolizing_N = mkTerm "symbolizing_N" ;
lin symbology_N = mkTerm "symbology_N" ;
lin symmetric_A = mkTerm "symmetric_A" ;
lin symmetrical_A = mkTerm "symmetrical_A" ;
lin symmetry_N = mkTerm "symmetry_N" ;
lin sympathectomy_N = mkTerm "sympathectomy_N" ;
lin sympathetic_A = mkTerm "sympathetic_A" ;
lin sympathize_V = mkTerm "sympathize_V" ;
lin sympathizer_N = mkTerm "sympathizer_N" ;
lin sympathy_N = mkTerm "sympathy_N" ;
lin sympatric_A = mkTerm "sympatric_A" ;
lin sympatry_N = mkTerm "sympatry_N" ;
lin symphonic_A = mkTerm "symphonic_A" ;
lin symphonist_N = mkTerm "symphonist_N" ;
lin symphony_N = mkTerm "symphony_N" ;
lin symphysion_N = mkTerm "symphysion_N" ;
lin symphysis_N = mkTerm "symphysis_N" ;
lin symploce_N = mkTerm "symploce_N" ;
lin symposiast_N = mkTerm "symposiast_N" ;
lin symposium_N = mkTerm "symposium_N" ;
lin symptom_N = mkTerm "symptom_N" ;
lin symptomatic_A = mkTerm "symptomatic_A" ;
lin symptomless_A = mkTerm "symptomless_A" ;
lin synagogue_N = mkTerm "synagogue_N" ;
lin synapse_N = mkTerm "synapse_N" ;
lin synapsid_N = mkTerm "synapsid_N" ;
lin synapsis_N = mkTerm "synapsis_N" ;
lin synaptic_A = mkTerm "synaptic_A" ;
lin syncarpous_A = mkTerm "syncarpous_A" ;
lin syncategorem_N = mkTerm "syncategorem_N" ;
lin syncategorematic_A = mkTerm "syncategorematic_A" ;
lin synchrocyclotron_N = mkTerm "synchrocyclotron_N" ;
lin synchroflash_N = mkTerm "synchroflash_N" ;
lin synchromesh_N = mkTerm "synchromesh_N" ;
lin synchronic_A = mkTerm "synchronic_A" ;
lin synchronism_N = mkTerm "synchronism_N" ;
lin synchronization_N = mkTerm "synchronization_N" ;
lin synchronize_V = mkTerm "synchronize_V" ;
lin synchronize_V2 = mkTerm "synchronize_V2" ;
lin synchronous_A = mkTerm "synchronous_A" ;
lin synchrony_N = mkTerm "synchrony_N" ;
lin synchroscope_N = mkTerm "synchroscope_N" ;
lin synchrotron_N = mkTerm "synchrotron_N" ;
lin synclinal_A = mkTerm "synclinal_A" ;
lin syncopate_V2 = mkTerm "syncopate_V2" ;
lin syncopation_N = mkTerm "syncopation_N" ;
lin syncopator_N = mkTerm "syncopator_N" ;
lin syncope_N = mkTerm "syncope_N" ;
lin syncretic_A = mkTerm "syncretic_A" ;
lin syncretism_N = mkTerm "syncretism_N" ;
lin syncytium_N = mkTerm "syncytium_N" ;
lin syndactyly_N = mkTerm "syndactyly_N" ;
lin syndciate_V2 = mkTerm "syndciate_V2" ;
lin syndetic_A = mkTerm "syndetic_A" ;
lin syndic_N = mkTerm "syndic_N" ;
lin syndicalism_N = mkTerm "syndicalism_N" ;
lin syndicalistFem_N = mkTerm "syndicalistFem_N" ;
lin syndicalistMasc_N = mkTerm "syndicalistMasc_N" ;
lin syndicate_N = mkTerm "syndicate_N" ;
lin syndicate_V2 = mkTerm "syndicate_V2" ;
lin syndication_N = mkTerm "syndication_N" ;
lin syndicator_N = mkTerm "syndicator_N" ;
lin syndrome_N = mkTerm "syndrome_N" ;
lin synecdoche_N = mkTerm "synecdoche_N" ;
lin synecdochic_A = mkTerm "synecdochic_A" ;
lin synechia_N = mkTerm "synechia_N" ;
lin syneresis_N = mkTerm "syneresis_N" ;
lin synergetic_A = mkTerm "synergetic_A" ;
lin synergism_N = mkTerm "synergism_N" ;
lin synergist_N = mkTerm "synergist_N" ;
lin synergistic_A = mkTerm "synergistic_A" ;
lin synergy_N = mkTerm "synergy_N" ;
lin synesthesia_N = mkTerm "synesthesia_N" ;
lin synesthetic_A = mkTerm "synesthetic_A" ;
lin synizesis_N = mkTerm "synizesis_N" ;
lin synod_N = mkTerm "synod_N" ;
lin synoicous_A = mkTerm "synoicous_A" ;
lin synonym_N = mkTerm "synonym_N" ;
lin synonymist_N = mkTerm "synonymist_N" ;
lin synonymous_A = mkTerm "synonymous_A" ;
lin synonymy_N = mkTerm "synonymy_N" ;
lin synopsis_N = mkTerm "synopsis_N" ;
lin synoptic_A = mkTerm "synoptic_A" ;
lin synoptically_Adv = mkTerm "synoptically_Adv" ;
lin synovia_N = mkTerm "synovia_N" ;
lin synovial_A = mkTerm "synovial_A" ;
lin synovitis_N = mkTerm "synovitis_N" ;
lin synsemantic_A = mkTerm "synsemantic_A" ;
lin synset_N = mkTerm "synset_N" ;
lin syntactic_A = mkTerm "syntactic_A" ;
lin syntagma_N = mkTerm "syntagma_N" ;
lin syntagmatic_A = mkTerm "syntagmatic_A" ;
lin syntax_N = mkTerm "syntax_N" ;
lin synth_N = mkTerm "synth_N" ;
lin synthesis_N = mkTerm "synthesis_N" ;
lin synthesist_N = mkTerm "synthesist_N" ;
lin synthesize_V2 = mkTerm "synthesize_V2" ;
lin synthesizer_N = mkTerm "synthesizer_N" ;
lin synthetic_A = mkTerm "synthetic_A" ;
lin synthetic_N = mkTerm "synthetic_N" ;
lin synthetism_N = mkTerm "synthetism_N" ;
lin syphilis_N = mkTerm "syphilis_N" ;
lin syphilitic_A = mkTerm "syphilitic_A" ;
lin syphilitic_N = mkTerm "syphilitic_N" ;
lin syphon_N = mkTerm "syphon_N" ;
lin syphon_V = mkTerm "syphon_V" ;
lin syphon_V2 = mkTerm "syphon_V2" ;
lin syphon_off_V2 = mkTerm "syphon_off_V2" ;
lin syracuse_PN = mkTerm "syracuse_PN" ;
lin syria_PN = mkTerm "syria_PN" ;
lin syrian_A = mkTerm "syrian_A" ;
lin syrian_N = mkTerm "syrian_N" ;
lin syringa_N = mkTerm "syringa_N" ;
lin syringe_N = mkTerm "syringe_N" ;
lin syringe_V2 = mkTerm "syringe_V2" ;
lin syrinx_N = mkTerm "syrinx_N" ;
lin syrup_N = mkTerm "syrup_N" ;
lin syrupy_A = mkTerm "syrupy_A" ;
lin sysmä_PN = mkTerm "sysmä_PN" ;
lin system_N = mkTerm "system_N" ;
lin systematic_A = mkTerm "systematic_A" ;
lin systematics_N = mkTerm "systematics_N" ;
lin systematism_N = mkTerm "systematism_N" ;
lin systematization_N = mkTerm "systematization_N" ;
lin systematize_V2 = mkTerm "systematize_V2" ;
lin systemic_A = mkTerm "systemic_A" ;
lin systole_N = mkTerm "systole_N" ;
lin systolic_A = mkTerm "systolic_A" ;
lin syston_PN = mkTerm "syston_PN" ;
lin syzygy_N = mkTerm "syzygy_N" ;
lin säkylä_PN = mkTerm "säkylä_PN" ;
lin särkisalo_PN = mkTerm "särkisalo_PN" ;
lin säynätsalo_PN = mkTerm "säynätsalo_PN" ;
lin t_junction_N = mkTerm "t_junction_N" ;
lin t_shirt_N = mkTerm "t_shirt_N" ;
lin t_square_N = mkTerm "t_square_N" ;
lin taavetti_PN = mkTerm "taavetti_PN" ;
lin tab_N = mkTerm "tab_N" ;
lin tabard_N = mkTerm "tabard_N" ;
lin tabasco_N = mkTerm "tabasco_N" ;
lin tabbouleh_N = mkTerm "tabbouleh_N" ;
lin tabby_A = mkTerm "tabby_A" ;
lin tabby_N = mkTerm "tabby_N" ;
lin tabby_cat_N = mkTerm "tabby_cat_N" ;
lin tabernacle_N = mkTerm "tabernacle_N" ;
lin tabes_N = mkTerm "tabes_N" ;
lin tabi_N = mkTerm "tabi_N" ;
lin tablature_N = mkTerm "tablature_N" ;
lin table_1_N = mkTerm "table_1_N" ;
lin table_2_N = mkTerm "table_2_N" ;
lin table_V2 = mkTerm "table_V2" ;
lin table_d'hote_A = mkTerm "table_d'hote_A" ;
lin table_d'hote_Adv = mkTerm "table_d'hote_Adv" ;
lin table_knife_N = mkTerm "table_knife_N" ;
lin table_lifting_N = mkTerm "table_lifting_N" ;
lin table_linen_N = mkTerm "table_linen_N" ;
lin table_rapping_N = mkTerm "table_rapping_N" ;
lin table_talk_N = mkTerm "table_talk_N" ;
lin table_turning_N = mkTerm "table_turning_N" ;
lin tableau_N = mkTerm "tableau_N" ;
lin tableau_vivant_N = mkTerm "tableau_vivant_N" ;
lin tablecloth_N = mkTerm "tablecloth_N" ;
lin tablefork_N = mkTerm "tablefork_N" ;
lin tableland_N = mkTerm "tableland_N" ;
lin tablemat_N = mkTerm "tablemat_N" ;
lin tablemate_N = mkTerm "tablemate_N" ;
lin tablespoon_N = mkTerm "tablespoon_N" ;
lin tablespoonful_N = mkTerm "tablespoonful_N" ;
lin tablet_N = mkTerm "tablet_N" ;
lin tabletop_N = mkTerm "tabletop_N" ;
lin tableware_N = mkTerm "tableware_N" ;
lin tabloid_N = mkTerm "tabloid_N" ;
lin taboo_A = mkTerm "taboo_A" ;
lin taboo_N = mkTerm "taboo_N" ;
lin taboo_V2 = mkTerm "taboo_V2" ;
lin tabor_N = mkTerm "tabor_N" ;
lin taboret_N = mkTerm "taboret_N" ;
lin tabular_A = mkTerm "tabular_A" ;
lin tabulate_V2 = mkTerm "tabulate_V2" ;
lin tabulation_N = mkTerm "tabulation_N" ;
lin tabulator_N = mkTerm "tabulator_N" ;
lin tabun_N = mkTerm "tabun_N" ;
lin tachistoscope_N = mkTerm "tachistoscope_N" ;
lin tachogram_N = mkTerm "tachogram_N" ;
lin tachograph_N = mkTerm "tachograph_N" ;
lin tachometer_N = mkTerm "tachometer_N" ;
lin tachycardia_N = mkTerm "tachycardia_N" ;
lin tachylite_N = mkTerm "tachylite_N" ;
lin tachymeter_N = mkTerm "tachymeter_N" ;
lin tacit_A = mkTerm "tacit_A" ;
lin taciturn_A = mkTerm "taciturn_A" ;
lin taciturnity_N = mkTerm "taciturnity_N" ;
lin tack_N = mkTerm "tack_N" ;
lin tack_V = mkTerm "tack_V" ;
lin tack_V2 = mkTerm "tack_V2" ;
lin tack_down_V = mkTerm "tack_down_V" ;
lin tack_on_V2 = mkTerm "tack_on_V2" ;
lin tack_onto_V3 = mkTerm "tack_onto_V3" ;
lin tacker_N = mkTerm "tacker_N" ;
lin tackle_N = mkTerm "tackle_N" ;
lin tackle_V = mkTerm "tackle_V" ;
lin tackle_V2 = mkTerm "tackle_V2" ;
lin tackler_N = mkTerm "tackler_N" ;
lin tacky_A = mkTerm "tacky_A" ;
lin taco_N = mkTerm "taco_N" ;
lin taconite_N = mkTerm "taconite_N" ;
lin tact_N = mkTerm "tact_N" ;
lin tactful_A = mkTerm "tactful_A" ;
lin tactic_N = mkTerm "tactic_N" ;
lin tactical_A = mkTerm "tactical_A" ;
lin tactician_N = mkTerm "tactician_N" ;
lin tactics_N = mkTerm "tactics_N" ;
lin tactile_A = mkTerm "tactile_A" ;
lin tactless_A = mkTerm "tactless_A" ;
lin tactlessness_N = mkTerm "tactlessness_N" ;
lin tactual_A = mkTerm "tactual_A" ;
lin tad_N = mkTerm "tad_N" ;
lin tadalafil_N = mkTerm "tadalafil_N" ;
lin tadley_PN = mkTerm "tadley_PN" ;
lin tadpole_N = mkTerm "tadpole_N" ;
lin taegu_PN = mkTerm "taegu_PN" ;
lin tael_N = mkTerm "tael_N" ;
lin taenia_N = mkTerm "taenia_N" ;
lin taffeta_N = mkTerm "taffeta_N" ;
lin taffrail_N = mkTerm "taffrail_N" ;
lin taffy_N = mkTerm "taffy_N" ;
lin tag_N = mkTerm "tag_N" ;
lin tag_V = mkTerm "tag_V" ;
lin tag_V2 = mkTerm "tag_V2" ;
lin tag_V3 = mkTerm "tag_V3" ;
lin tag_along_V = mkTerm "tag_along_V" ;
lin tag_on_V2 = mkTerm "tag_on_V2" ;
lin tag_onto_V3 = mkTerm "tag_onto_V3" ;
lin tag_with_V2 = mkTerm "tag_with_V2" ;
lin tagalong_N = mkTerm "tagalong_N" ;
lin tagasaste_N = mkTerm "tagasaste_N" ;
lin tagger_N = mkTerm "tagger_N" ;
lin tagliatelle_N = mkTerm "tagliatelle_N" ;
lin tagline_N = mkTerm "tagline_N" ;
lin taguan_N = mkTerm "taguan_N" ;
lin tahini_N = mkTerm "tahini_N" ;
lin tahiti_PN = mkTerm "tahiti_PN" ;
lin tahitian_A = mkTerm "tahitian_A" ;
lin tahitian_N = mkTerm "tahitian_N" ;
lin tail_N = mkTerm "tail_N" ;
lin tail_V = mkTerm "tail_V" ;
lin tail_V2 = mkTerm "tail_V2" ;
lin tail_away_V = mkTerm "tail_away_V" ;
lin tail_back_V = mkTerm "tail_back_V" ;
lin tail_coat_N = mkTerm "tail_coat_N" ;
lin tail_end_N = mkTerm "tail_end_N" ;
lin tail_light_N = mkTerm "tail_light_N" ;
lin tail_off_V = mkTerm "tail_off_V" ;
lin tailback_N = mkTerm "tailback_N" ;
lin tailboard_N = mkTerm "tailboard_N" ;
lin tailgate_N = mkTerm "tailgate_N" ;
lin tailgater_N = mkTerm "tailgater_N" ;
lin tailless_A = mkTerm "tailless_A" ;
lin tailor_N = mkTerm "tailor_N" ;
lin tailor_V2 = mkTerm "tailor_V2" ;
lin tailor_made_A = mkTerm "tailor_made_A" ;
lin tailorbird_N = mkTerm "tailorbird_N" ;
lin tailoring_N = mkTerm "tailoring_N" ;
lin tailpiece_N = mkTerm "tailpiece_N" ;
lin tailpipe_N = mkTerm "tailpipe_N" ;
lin tailplane_N = mkTerm "tailplane_N" ;
lin tailrace_N = mkTerm "tailrace_N" ;
lin tailspin_N = mkTerm "tailspin_N" ;
lin tailstock_N = mkTerm "tailstock_N" ;
lin tailwind_N = mkTerm "tailwind_N" ;
lin taint_N = mkTerm "taint_N" ;
lin taint_V = mkTerm "taint_V" ;
lin taint_V2 = mkTerm "taint_V2" ;
lin taintless_A = mkTerm "taintless_A" ;
lin taipalsaari_PN = mkTerm "taipalsaari_PN" ;
lin taipan_N = mkTerm "taipan_N" ;
lin taipei_PN = mkTerm "taipei_PN" ;
lin taivalkoski_PN = mkTerm "taivalkoski_PN" ;
lin taivassalo_PN = mkTerm "taivassalo_PN" ;
lin taiwan_PN = mkTerm "taiwan_PN" ;
lin taiwaneseFem_N = mkTerm "taiwaneseFem_N" ;
lin taiwaneseMasc_N = mkTerm "taiwaneseMasc_N" ;
lin taiwanese_A = mkTerm "taiwanese_A" ;
lin taiyuan_PN = mkTerm "taiyuan_PN" ;
lin taka_N = mkTerm "taka_N" ;
lin take_N = mkTerm "take_N" ;
lin take_V2 = mkTerm "take_V2" ;
lin take_after_V2 = mkTerm "take_after_V2" ;
lin take_apart_V2 = mkTerm "take_apart_V2" ;
lin take_aside_V2 = mkTerm "take_aside_V2" ;
lin take_away_V2 = mkTerm "take_away_V2" ;
lin take_back_V = mkTerm "take_back_V" ;
lin take_back_V2 = mkTerm "take_back_V2" ;
lin take_down_V2 = mkTerm "take_down_V2" ;
lin take_for_V2 = mkTerm "take_for_V2" ;
lin take_home_A = mkTerm "take_home_A" ;
lin take_in_V = mkTerm "take_in_V" ;
lin take_in_V2 = mkTerm "take_in_V2" ;
lin take_it_V2 = mkTerm "take_it_V2" ;
lin take_it_out_on_V2 = mkTerm "take_it_out_on_V2" ;
lin take_it_upon_yourself_V = mkTerm "take_it_upon_yourself_V" ;
lin take_off_N = mkTerm "take_off_N" ;
lin take_off_V = mkTerm "take_off_V" ;
lin take_off_V2 = mkTerm "take_off_V2" ;
lin take_on_V = mkTerm "take_on_V" ;
lin take_on_V2 = mkTerm "take_on_V2" ;
lin take_out_V = mkTerm "take_out_V" ;
lin take_out_V2 = mkTerm "take_out_V2" ;
lin take_over_V = mkTerm "take_over_V" ;
lin take_over_V2 = mkTerm "take_over_V2" ;
lin take_through_V2 = mkTerm "take_through_V2" ;
lin take_to_V2 = mkTerm "take_to_V2" ;
lin take_up_N = mkTerm "take_up_N" ;
lin take_up_V = mkTerm "take_up_V" ;
lin take_up_V2 = mkTerm "take_up_V2" ;
lin takeaway_A = mkTerm "takeaway_A" ;
lin takeaway_N = mkTerm "takeaway_N" ;
lin takedown_N = mkTerm "takedown_N" ;
lin takeout_A = mkTerm "takeout_A" ;
lin takeout_N = mkTerm "takeout_N" ;
lin takeover_N = mkTerm "takeover_N" ;
lin taker_N = mkTerm "taker_N" ;
lin takin_N = mkTerm "takin_N" ;
lin taking_N = mkTerm "taking_N" ;
lin tala_N = mkTerm "tala_N" ;
lin talapoin_N = mkTerm "talapoin_N" ;
lin talaria_N = mkTerm "talaria_N" ;
lin talc_N = mkTerm "talc_N" ;
lin talcum_N = mkTerm "talcum_N" ;
lin tale_N = mkTerm "tale_N" ;
lin tale_bearer_N = mkTerm "tale_bearer_N" ;
lin tale_teller_N = mkTerm "tale_teller_N" ;
lin talent_N = mkTerm "talent_N" ;
lin talented_A = mkTerm "talented_A" ;
lin talentlessness_N = mkTerm "talentlessness_N" ;
lin talipot_N = mkTerm "talipot_N" ;
lin talisman_N = mkTerm "talisman_N" ;
lin talismanic_A = mkTerm "talismanic_A" ;
lin talk_N = mkTerm "talk_N" ;
lin talk_V = mkTerm "talk_V" ;
lin talk_V2 = mkTerm "talk_V2" ;
lin talk_around_V2 = mkTerm "talk_around_V2" ;
lin talk_at_V2 = mkTerm "talk_at_V2" ;
lin talk_back_V = mkTerm "talk_back_V" ;
lin talk_back_to_V2 = mkTerm "talk_back_to_V2" ;
lin talk_down_V2 = mkTerm "talk_down_V2" ;
lin talk_down_to_V2 = mkTerm "talk_down_to_V2" ;
lin talk_into_V3 = mkTerm "talk_into_V3" ;
lin talk_out_V2 = mkTerm "talk_out_V2" ;
lin talk_out_of_V3 = mkTerm "talk_out_of_V3" ;
lin talk_over_V2 = mkTerm "talk_over_V2" ;
lin talk_round_V2 = mkTerm "talk_round_V2" ;
lin talk_through_V3 = mkTerm "talk_through_V3" ;
lin talk_up_V2 = mkTerm "talk_up_V2" ;
lin talk_yourself_out_V = mkTerm "talk_yourself_out_V" ;
lin talkative_A = mkTerm "talkative_A" ;
lin talker_N = mkTerm "talker_N" ;
lin talkie_N = mkTerm "talkie_N" ;
lin talking_N = mkTerm "talking_N" ;
lin talking_point_N = mkTerm "talking_point_N" ;
lin talking_to_N = mkTerm "talking_to_N" ;
lin tall_A = mkTerm "tall_A" ;
lin tall_N = mkTerm "tall_N" ;
lin tallboy_N = mkTerm "tallboy_N" ;
lin tallgrass_N = mkTerm "tallgrass_N" ;
lin tallish_A = mkTerm "tallish_A" ;
lin tallness_N = mkTerm "tallness_N" ;
lin tallow_N = mkTerm "tallow_N" ;
lin tally_N = mkTerm "tally_N" ;
lin tally_V = mkTerm "tally_V" ;
lin tally_V2 = mkTerm "tally_V2" ;
lin tally_clerk_N = mkTerm "tally_clerk_N" ;
lin tallyman_N = mkTerm "tallyman_N" ;
lin talmud_N = mkTerm "talmud_N" ;
lin talon_N = mkTerm "talon_N" ;
lin talus_N = mkTerm "talus_N" ;
lin tam_N = mkTerm "tam_N" ;
lin tam_o'_shanter_N = mkTerm "tam_o'_shanter_N" ;
lin tamable_A = mkTerm "tamable_A" ;
lin tamale_N = mkTerm "tamale_N" ;
lin tamandua_N = mkTerm "tamandua_N" ;
lin tamarau_N = mkTerm "tamarau_N" ;
lin tamarin_N = mkTerm "tamarin_N" ;
lin tamarind_N = mkTerm "tamarind_N" ;
lin tamarisk_N = mkTerm "tamarisk_N" ;
lin tambala_N = mkTerm "tambala_N" ;
lin tambon_N = mkTerm "tambon_N" ;
lin tambour_1_N = mkTerm "tambour_1_N" ;
lin tambour_2_N = mkTerm "tambour_2_N" ;
lin tambourine_N = mkTerm "tambourine_N" ;
lin tamburica_N = mkTerm "tamburica_N" ;
lin tame_A = mkTerm "tame_A" ;
lin tame_V2 = mkTerm "tame_V2" ;
lin tameness_N = mkTerm "tameness_N" ;
lin tamer_N = mkTerm "tamer_N" ;
lin tamil_A = mkTerm "tamil_A" ;
lin tamil_N = mkTerm "tamil_N" ;
lin tammany_N = mkTerm "tammany_N" ;
lin tammela_PN = mkTerm "tammela_PN" ;
lin tammy_N = mkTerm "tammy_N" ;
lin tamp_N = mkTerm "tamp_N" ;
lin tamp_V2 = mkTerm "tamp_V2" ;
lin tamper_V = mkTerm "tamper_V" ;
lin tampere_PN = mkTerm "tampere_PN" ;
lin tampion_N = mkTerm "tampion_N" ;
lin tampon_N = mkTerm "tampon_N" ;
lin tamponade_N = mkTerm "tamponade_N" ;
lin tamworth_PN = mkTerm "tamworth_PN" ;
lin tan_A = mkTerm "tan_A" ;
lin tan_N = mkTerm "tan_N" ;
lin tan_V = mkTerm "tan_V" ;
lin tan_V2 = mkTerm "tan_V2" ;
lin tanager_N = mkTerm "tanager_N" ;
lin tanbark_N = mkTerm "tanbark_N" ;
lin tandem_Adv = mkTerm "tandem_Adv" ;
lin tandem_N = mkTerm "tandem_N" ;
lin tandoor_N = mkTerm "tandoor_N" ;
lin tanekaha_N = mkTerm "tanekaha_N" ;
lin tang_N = mkTerm "tang_N" ;
lin tanga_N = mkTerm "tanga_N" ;
lin tangelo_N = mkTerm "tangelo_N" ;
lin tangency_N = mkTerm "tangency_N" ;
lin tangent_1_N = mkTerm "tangent_1_N" ;
lin tangent_2_N = mkTerm "tangent_2_N" ;
lin tangent_A = mkTerm "tangent_A" ;
lin tangential_A = mkTerm "tangential_A" ;
lin tangerine_A = mkTerm "tangerine_A" ;
lin tangerine_N = mkTerm "tangerine_N" ;
lin tangibility_N = mkTerm "tangibility_N" ;
lin tangible_A = mkTerm "tangible_A" ;
lin tangle_N = mkTerm "tangle_N" ;
lin tangle_V = mkTerm "tangle_V" ;
lin tangle_V2 = mkTerm "tangle_V2" ;
lin tanglebush_N = mkTerm "tanglebush_N" ;
lin tango_N = mkTerm "tango_N" ;
lin tango_V = mkTerm "tango_V" ;
lin tangram_N = mkTerm "tangram_N" ;
lin tangshan_PN = mkTerm "tangshan_PN" ;
lin tangy_A = mkTerm "tangy_A" ;
lin tank_N = mkTerm "tank_N" ;
lin tank_V = mkTerm "tank_V" ;
lin tank_car_N = mkTerm "tank_car_N" ;
lin tanka_N = mkTerm "tanka_N" ;
lin tankage_N = mkTerm "tankage_N" ;
lin tankard_N = mkTerm "tankard_N" ;
lin tanker_N = mkTerm "tanker_N" ;
lin tanner_N = mkTerm "tanner_N" ;
lin tannery_N = mkTerm "tannery_N" ;
lin tannic_A = mkTerm "tannic_A" ;
lin tannin_N = mkTerm "tannin_N" ;
lin tanning_N = mkTerm "tanning_N" ;
lin tannish_A = mkTerm "tannish_A" ;
lin tannoy_N = mkTerm "tannoy_N" ;
lin tansy_N = mkTerm "tansy_N" ;
lin tantalite_N = mkTerm "tantalite_N" ;
lin tantalize_V2 = mkTerm "tantalize_V2" ;
lin tantalizer_N = mkTerm "tantalizer_N" ;
lin tantalizing_A = mkTerm "tantalizing_A" ;
lin tantalum_N = mkTerm "tantalum_N" ;
lin tantamount_A = mkTerm "tantamount_A" ;
lin tantra_N = mkTerm "tantra_N" ;
lin tantrum_N = mkTerm "tantrum_N" ;
lin tanzania_PN = mkTerm "tanzania_PN" ;
lin tanzanian_A = mkTerm "tanzanian_A" ;
lin tanzanian_N = mkTerm "tanzanian_N" ;
lin taoiseach_N = mkTerm "taoiseach_N" ;
lin tap_N = mkTerm "tap_N" ;
lin tap_V = mkTerm "tap_V" ;
lin tap_V2 = mkTerm "tap_V2" ;
lin tap_dancing_N = mkTerm "tap_dancing_N" ;
lin tap_for_V3 = mkTerm "tap_for_V3" ;
lin tap_into_V2 = mkTerm "tap_into_V2" ;
lin tap_off_with_V2 = mkTerm "tap_off_with_V2" ;
lin tap_out_V2 = mkTerm "tap_out_V2" ;
lin tap_up_V2 = mkTerm "tap_up_V2" ;
lin tapa_N = mkTerm "tapa_N" ;
lin tape_N = mkTerm "tape_N" ;
lin tape_V = mkTerm "tape_V" ;
lin tape_V2 = mkTerm "tape_V2" ;
lin tape_measure_N = mkTerm "tape_measure_N" ;
lin tape_recorder_N = mkTerm "tape_recorder_N" ;
lin tapenade_N = mkTerm "tapenade_N" ;
lin taper_N = mkTerm "taper_N" ;
lin taper_V = mkTerm "taper_V" ;
lin taper_V2 = mkTerm "taper_V2" ;
lin taper_off_V = mkTerm "taper_off_V" ;
lin tapering_N = mkTerm "tapering_N" ;
lin tapestried_A = mkTerm "tapestried_A" ;
lin tapestry_N = mkTerm "tapestry_N" ;
lin tapeworm_N = mkTerm "tapeworm_N" ;
lin taphephobia_N = mkTerm "taphephobia_N" ;
lin tapioca_N = mkTerm "tapioca_N" ;
lin tapir_N = mkTerm "tapir_N" ;
lin tapotement_N = mkTerm "tapotement_N" ;
lin tapper_N = mkTerm "tapper_N" ;
lin tappet_N = mkTerm "tappet_N" ;
lin tapping_N = mkTerm "tapping_N" ;
lin taproom_N = mkTerm "taproom_N" ;
lin taproot_N = mkTerm "taproot_N" ;
lin taps_N = mkTerm "taps_N" ;
lin tapster_N = mkTerm "tapster_N" ;
lin tar_N = mkTerm "tar_N" ;
lin tar_V2 = mkTerm "tar_V2" ;
lin tar_macadam_N = mkTerm "tar_macadam_N" ;
lin taradiddle_N = mkTerm "taradiddle_N" ;
lin taranaki_PN = mkTerm "taranaki_PN" ;
lin tarantella_N = mkTerm "tarantella_N" ;
lin tarantelle_N = mkTerm "tarantelle_N" ;
lin tarantism_N = mkTerm "tarantism_N" ;
lin taranto_PN = mkTerm "taranto_PN" ;
lin tarantula_N = mkTerm "tarantula_N" ;
lin tarboosh_N = mkTerm "tarboosh_N" ;
lin tardigrade_N = mkTerm "tardigrade_N" ;
lin tardiness_N = mkTerm "tardiness_N" ;
lin tardive_A = mkTerm "tardive_A" ;
lin tardy_A = mkTerm "tardy_A" ;
lin tare_N = mkTerm "tare_N" ;
lin target_N = mkTerm "target_N" ;
lin target_V2 = mkTerm "target_V2" ;
lin target_V2V = mkTerm "target_V2V" ;
lin tariff_N = mkTerm "tariff_N" ;
lin tarmac_N = mkTerm "tarmac_N" ;
lin tarmac_V2 = mkTerm "tarmac_V2" ;
lin tarn_N = mkTerm "tarn_N" ;
lin tarnish_N = mkTerm "tarnish_N" ;
lin tarnish_V = mkTerm "tarnish_V" ;
lin tarnish_V2 = mkTerm "tarnish_V2" ;
lin taro_N = mkTerm "taro_N" ;
lin tarpan_N = mkTerm "tarpan_N" ;
lin tarpaulin_N = mkTerm "tarpaulin_N" ;
lin tarpon_N = mkTerm "tarpon_N" ;
lin tarradiddle_N = mkTerm "tarradiddle_N" ;
lin tarragon_N = mkTerm "tarragon_N" ;
lin tarrasa_PN = mkTerm "tarrasa_PN" ;
lin tarriance_N = mkTerm "tarriance_N" ;
lin tarry_A = mkTerm "tarry_A" ;
lin tarry_V = mkTerm "tarry_V" ;
lin tarsal_A = mkTerm "tarsal_A" ;
lin tarsal_N = mkTerm "tarsal_N" ;
lin tarsier_N = mkTerm "tarsier_N" ;
lin tarsitis_N = mkTerm "tarsitis_N" ;
lin tarsus_N = mkTerm "tarsus_N" ;
lin tart_A = mkTerm "tart_A" ;
lin tart_N = mkTerm "tart_N" ;
lin tart_V2 = mkTerm "tart_V2" ;
lin tartan_N = mkTerm "tartan_N" ;
lin tartar_N = mkTerm "tartar_N" ;
lin tartaric_A = mkTerm "tartaric_A" ;
lin tartlet_N = mkTerm "tartlet_N" ;
lin tartness_N = mkTerm "tartness_N" ;
lin tartrate_N = mkTerm "tartrate_N" ;
lin tarvasjoki_PN = mkTerm "tarvasjoki_PN" ;
lin tarweed_N = mkTerm "tarweed_N" ;
lin tarwood_N = mkTerm "tarwood_N" ;
lin tashkent_PN = mkTerm "tashkent_PN" ;
lin task_N = mkTerm "task_N" ;
lin task_V2 = mkTerm "task_V2" ;
lin task_force_N = mkTerm "task_force_N" ;
lin taskmaster_N = mkTerm "taskmaster_N" ;
lin taskmistress_N = mkTerm "taskmistress_N" ;
lin tasmania_PN = mkTerm "tasmania_PN" ;
lin tassel_N = mkTerm "tassel_N" ;
lin tasseled_A = mkTerm "tasseled_A" ;
lin tasselled_A = mkTerm "tasselled_A" ;
lin tasset_N = mkTerm "tasset_N" ;
lin taste_N = mkTerm "taste_N" ;
lin taste_V = mkTerm "taste_V" ;
lin taste_V2 = mkTerm "taste_V2" ;
lin tastebud_N = mkTerm "tastebud_N" ;
lin tasteful_A = mkTerm "tasteful_A" ;
lin tastefulness_N = mkTerm "tastefulness_N" ;
lin tasteless_A = mkTerm "tasteless_A" ;
lin tastelessness_N = mkTerm "tastelessness_N" ;
lin taster_N = mkTerm "taster_N" ;
lin tasting_N = mkTerm "tasting_N" ;
lin tasty_A = mkTerm "tasty_A" ;
lin tat_N = mkTerm "tat_N" ;
lin tat_V = mkTerm "tat_V" ;
lin tat_V2 = mkTerm "tat_V2" ;
lin tatouay_N = mkTerm "tatouay_N" ;
lin tatter_N = mkTerm "tatter_N" ;
lin tatterdemalion_N = mkTerm "tatterdemalion_N" ;
lin tattered_A = mkTerm "tattered_A" ;
lin tatting_N = mkTerm "tatting_N" ;
lin tattle_N = mkTerm "tattle_N" ;
lin tattle_V = mkTerm "tattle_V" ;
lin tattle_V2 = mkTerm "tattle_V2" ;
lin tattler_N = mkTerm "tattler_N" ;
lin tattletale_N = mkTerm "tattletale_N" ;
lin tattoo_N = mkTerm "tattoo_N" ;
lin tattoo_V2 = mkTerm "tattoo_V2" ;
lin tatty_A = mkTerm "tatty_A" ;
lin tau_N = mkTerm "tau_N" ;
lin taunt_N = mkTerm "taunt_N" ;
lin taunt_V2 = mkTerm "taunt_V2" ;
lin tauntingly_Adv = mkTerm "tauntingly_Adv" ;
lin taunton_PN = mkTerm "taunton_PN" ;
lin tauon_N = mkTerm "tauon_N" ;
lin taupe_N = mkTerm "taupe_N" ;
lin taurine_A = mkTerm "taurine_A" ;
lin taurine_N = mkTerm "taurine_N" ;
lin taurus_PN = mkTerm "taurus_PN" ;
lin taut_A = mkTerm "taut_A" ;
lin tautness_N = mkTerm "tautness_N" ;
lin tautog_N = mkTerm "tautog_N" ;
lin tautological_A = mkTerm "tautological_A" ;
lin tautology_N = mkTerm "tautology_N" ;
lin taverham_PN = mkTerm "taverham_PN" ;
lin tavern_N = mkTerm "tavern_N" ;
lin tavistock_PN = mkTerm "tavistock_PN" ;
lin taw_N = mkTerm "taw_N" ;
lin tawdriness_N = mkTerm "tawdriness_N" ;
lin tawdry_A = mkTerm "tawdry_A" ;
lin tawniness_N = mkTerm "tawniness_N" ;
lin tawny_A = mkTerm "tawny_A" ;
lin tawse_N = mkTerm "tawse_N" ;
lin tax_N = mkTerm "tax_N" ;
lin tax_V2 = mkTerm "tax_V2" ;
lin tax_collector_N = mkTerm "tax_collector_N" ;
lin tax_free_A = mkTerm "tax_free_A" ;
lin taxability_N = mkTerm "taxability_N" ;
lin taxable_A = mkTerm "taxable_A" ;
lin taxation_N = mkTerm "taxation_N" ;
lin taxer_N = mkTerm "taxer_N" ;
lin taxi_N = mkTerm "taxi_N" ;
lin taxi_V = mkTerm "taxi_V" ;
lin taxi_V2 = mkTerm "taxi_V2" ;
lin taxicab_N = mkTerm "taxicab_N" ;
lin taxidermist_N = mkTerm "taxidermist_N" ;
lin taxidermy_N = mkTerm "taxidermy_N" ;
lin taxidriver_N = mkTerm "taxidriver_N" ;
lin taximeter_N = mkTerm "taximeter_N" ;
lin taxis_N = mkTerm "taxis_N" ;
lin taxiway_N = mkTerm "taxiway_N" ;
lin taxonomic_A = mkTerm "taxonomic_A" ;
lin taxonomist_N = mkTerm "taxonomist_N" ;
lin taxonomy_N = mkTerm "taxonomy_N" ;
lin taxpayer_N = mkTerm "taxpayer_N" ;
lin taxpaying_A = mkTerm "taxpaying_A" ;
lin tayra_N = mkTerm "tayra_N" ;
lin tayside_PN = mkTerm "tayside_PN" ;
lin tb_N = mkTerm "tb_N" ;
lin tbilisi_PN = mkTerm "tbilisi_PN" ;
lin te_deum_N = mkTerm "te_deum_N" ;
lin tea_N = mkTerm "tea_N" ;
lin tea_bag_N = mkTerm "tea_bag_N" ;
lin tea_break_N = mkTerm "tea_break_N" ;
lin tea_caddy_N = mkTerm "tea_caddy_N" ;
lin tea_chest_N = mkTerm "tea_chest_N" ;
lin tea_cloth_N = mkTerm "tea_cloth_N" ;
lin tea_cosy_N = mkTerm "tea_cosy_N" ;
lin tea_garden_N = mkTerm "tea_garden_N" ;
lin tea_kettle_N = mkTerm "tea_kettle_N" ;
lin tea_leaf_N = mkTerm "tea_leaf_N" ;
lin tea_party_N = mkTerm "tea_party_N" ;
lin tea_service_N = mkTerm "tea_service_N" ;
lin tea_set_N = mkTerm "tea_set_N" ;
lin tea_strainer_N = mkTerm "tea_strainer_N" ;
lin tea_table_N = mkTerm "tea_table_N" ;
lin tea_time_N = mkTerm "tea_time_N" ;
lin tea_towel_N = mkTerm "tea_towel_N" ;
lin tea_tray_N = mkTerm "tea_tray_N" ;
lin tea_trolley_N = mkTerm "tea_trolley_N" ;
lin tea_urn_N = mkTerm "tea_urn_N" ;
lin tea_wagon_N = mkTerm "tea_wagon_N" ;
lin teaberry_N = mkTerm "teaberry_N" ;
lin teacake_N = mkTerm "teacake_N" ;
lin teach_V = mkTerm "teach_V" ;
lin teach_V2 = mkTerm "teach_V2" ;
lin teach_V2V = mkTerm "teach_V2V" ;
lin teach_in_N = mkTerm "teach_in_N" ;
lin teachable_A = mkTerm "teachable_A" ;
lin teacherFem_N = mkTerm "teacherFem_N" ;
lin teacherMasc_N = mkTerm "teacherMasc_N" ;
lin teachership_N = mkTerm "teachership_N" ;
lin teaching_N = mkTerm "teaching_N" ;
lin teacup_N = mkTerm "teacup_N" ;
lin teahouse_N = mkTerm "teahouse_N" ;
lin teak_N = mkTerm "teak_N" ;
lin teal_N = mkTerm "teal_N" ;
lin team_N = mkTerm "team_N" ;
lin team_V = mkTerm "team_V" ;
lin team_up_V = mkTerm "team_up_V" ;
lin teammate_N = mkTerm "teammate_N" ;
lin teamster_N = mkTerm "teamster_N" ;
lin teamwork_N = mkTerm "teamwork_N" ;
lin teapot_N = mkTerm "teapot_N" ;
lin tear_N = mkTerm "tear_N" ;
lin tear_V = mkTerm "tear_V" ;
lin tear_V2 = mkTerm "tear_V2" ;
lin tear_apart_V2 = mkTerm "tear_apart_V2" ;
lin tear_at_V2 = mkTerm "tear_at_V2" ;
lin tear_away_V2 = mkTerm "tear_away_V2" ;
lin tear_down_V2 = mkTerm "tear_down_V2" ;
lin tear_drop_N = mkTerm "tear_drop_N" ;
lin tear_gas_N = mkTerm "tear_gas_N" ;
lin tear_into_V2 = mkTerm "tear_into_V2" ;
lin tear_off_V = mkTerm "tear_off_V" ;
lin tear_off_V2 = mkTerm "tear_off_V2" ;
lin tear_out_V = mkTerm "tear_out_V" ;
lin tear_up_V = mkTerm "tear_up_V" ;
lin tear_up_V2 = mkTerm "tear_up_V2" ;
lin tearaway_A = mkTerm "tearaway_A" ;
lin tearaway_N = mkTerm "tearaway_N" ;
lin tearful_A = mkTerm "tearful_A" ;
lin tearing_N = mkTerm "tearing_N" ;
lin tearjerker_N = mkTerm "tearjerker_N" ;
lin tearless_A = mkTerm "tearless_A" ;
lin tearoom_N = mkTerm "tearoom_N" ;
lin teary_A = mkTerm "teary_A" ;
lin tease_N = mkTerm "tease_N" ;
lin tease_V2 = mkTerm "tease_V2" ;
lin teasel_N = mkTerm "teasel_N" ;
lin teaser_N = mkTerm "teaser_N" ;
lin teashop_N = mkTerm "teashop_N" ;
lin teasing_A = mkTerm "teasing_A" ;
lin teasing_N = mkTerm "teasing_N" ;
lin teaspoon_N = mkTerm "teaspoon_N" ;
lin teaspoonful_N = mkTerm "teaspoonful_N" ;
lin teat_N = mkTerm "teat_N" ;
lin teazel_N = mkTerm "teazel_N" ;
lin teazle_N = mkTerm "teazle_N" ;
lin tebibit_N = mkTerm "tebibit_N" ;
lin tec_N = mkTerm "tec_N" ;
lin tech_N = mkTerm "tech_N" ;
lin techie_N = mkTerm "techie_N" ;
lin technetium_N = mkTerm "technetium_N" ;
lin technical_A = mkTerm "technical_A" ;
lin technical_N = mkTerm "technical_N" ;
lin technicality_N = mkTerm "technicality_N" ;
lin technician_N = mkTerm "technician_N" ;
lin technicolor_N = mkTerm "technicolor_N" ;
lin technique_N = mkTerm "technique_N" ;
lin techno_N = mkTerm "techno_N" ;
lin technobabble_N = mkTerm "technobabble_N" ;
lin technocracy_N = mkTerm "technocracy_N" ;
lin technocrat_N = mkTerm "technocrat_N" ;
lin technological_A = mkTerm "technological_A" ;
lin technologist_N = mkTerm "technologist_N" ;
lin technology_N = mkTerm "technology_N" ;
lin technophile_N = mkTerm "technophile_N" ;
lin technophilia_N = mkTerm "technophilia_N" ;
lin technophilic_A = mkTerm "technophilic_A" ;
lin technophobe_N = mkTerm "technophobe_N" ;
lin technophobia_N = mkTerm "technophobia_N" ;
lin technophobic_A = mkTerm "technophobic_A" ;
lin techy_A = mkTerm "techy_A" ;
lin tectonic_1_A = mkTerm "tectonic_1_A" ;
lin tectonic_2_A = mkTerm "tectonic_2_A" ;
lin tectonics_N = mkTerm "tectonics_N" ;
lin ted_N = mkTerm "ted_N" ;
lin ted_PN = mkTerm "ted_PN" ;
lin teddy_N = mkTerm "teddy_N" ;
lin teddy_PN = mkTerm "teddy_PN" ;
lin teddy_boy_N = mkTerm "teddy_boy_N" ;
lin tedious_A = mkTerm "tedious_A" ;
lin tediousness_N = mkTerm "tediousness_N" ;
lin tedium_N = mkTerm "tedium_N" ;
lin tee_N = mkTerm "tee_N" ;
lin tee_V = mkTerm "tee_V" ;
lin tee_V2 = mkTerm "tee_V2" ;
lin tee_off_V = mkTerm "tee_off_V" ;
lin tee_off_V2 = mkTerm "tee_off_V2" ;
lin tee_off_on_V2 = mkTerm "tee_off_on_V2" ;
lin tee_shirt_N = mkTerm "tee_shirt_N" ;
lin tee_up_V = mkTerm "tee_up_V" ;
lin teekkarikylä_PN = mkTerm "teekkarikylä_PN" ;
lin teem_V = mkTerm "teem_V" ;
lin teenage_A = mkTerm "teenage_A" ;
lin teenager_N = mkTerm "teenager_N" ;
lin teens_N = mkTerm "teens_N" ;
lin teeny_A = mkTerm "teeny_A" ;
lin teeoff_N = mkTerm "teeoff_N" ;
lin teeriniemi_PN = mkTerm "teeriniemi_PN" ;
lin teesside_PN = mkTerm "teesside_PN" ;
lin teeter_V = mkTerm "teeter_V" ;
lin teethe_V = mkTerm "teethe_V" ;
lin teething_N = mkTerm "teething_N" ;
lin teetotal_A = mkTerm "teetotal_A" ;
lin teetotaling_N = mkTerm "teetotaling_N" ;
lin teetotaller_N = mkTerm "teetotaller_N" ;
lin teetotum_N = mkTerm "teetotum_N" ;
lin teff_N = mkTerm "teff_N" ;
lin teg_N = mkTerm "teg_N" ;
lin tegular_A = mkTerm "tegular_A" ;
lin tegument_N = mkTerm "tegument_N" ;
lin teheran_PN = mkTerm "teheran_PN" ;
lin teignmouth_PN = mkTerm "teignmouth_PN" ;
lin teju_N = mkTerm "teju_N" ;
lin tektite_N = mkTerm "tektite_N" ;
lin tel_PN = mkTerm "tel_PN" ;
lin tel_aviv_PN = mkTerm "tel_aviv_PN" ;
lin telecast_N = mkTerm "telecast_N" ;
lin telecast_V2 = mkTerm "telecast_V2" ;
lin telecaster_N = mkTerm "telecaster_N" ;
lin telecom_N = mkTerm "telecom_N" ;
lin telecommunication_N = mkTerm "telecommunication_N" ;
lin telecommuting_N = mkTerm "telecommuting_N" ;
lin teleconference_N = mkTerm "teleconference_N" ;
lin telefilm_N = mkTerm "telefilm_N" ;
lin telegnosis_N = mkTerm "telegnosis_N" ;
lin telegnostic_A = mkTerm "telegnostic_A" ;
lin telegram_N = mkTerm "telegram_N" ;
lin telegraph_N = mkTerm "telegraph_N" ;
lin telegraph_V = mkTerm "telegraph_V" ;
lin telegraph_V2 = mkTerm "telegraph_V2" ;
lin telegraph_line_N = mkTerm "telegraph_line_N" ;
lin telegraph_pole_N = mkTerm "telegraph_pole_N" ;
lin telegraph_post_N = mkTerm "telegraph_post_N" ;
lin telegraph_wire_N = mkTerm "telegraph_wire_N" ;
lin telegrapher_N = mkTerm "telegrapher_N" ;
lin telegraphese_N = mkTerm "telegraphese_N" ;
lin telegraphic_A = mkTerm "telegraphic_A" ;
lin telegraphist_N = mkTerm "telegraphist_N" ;
lin telegraphy_N = mkTerm "telegraphy_N" ;
lin telekinesis_N = mkTerm "telekinesis_N" ;
lin telemark_N = mkTerm "telemark_N" ;
lin telemarketing_N = mkTerm "telemarketing_N" ;
lin telemeter_N = mkTerm "telemeter_N" ;
lin telemetered_A = mkTerm "telemetered_A" ;
lin telemetry_N = mkTerm "telemetry_N" ;
lin telencephalon_N = mkTerm "telencephalon_N" ;
lin telenovela_N = mkTerm "telenovela_N" ;
lin teleological_A = mkTerm "teleological_A" ;
lin teleologist_N = mkTerm "teleologist_N" ;
lin teleology_N = mkTerm "teleology_N" ;
lin telepathic_A = mkTerm "telepathic_A" ;
lin telepathist_N = mkTerm "telepathist_N" ;
lin telepathy_N = mkTerm "telepathy_N" ;
lin telephone_N = mkTerm "telephone_N" ;
lin telephone_V = mkTerm "telephone_V" ;
lin telephone_V2 = mkTerm "telephone_V2" ;
lin telephonic_A = mkTerm "telephonic_A" ;
lin telephonistFem_N = mkTerm "telephonistFem_N" ;
lin telephonistMasc_N = mkTerm "telephonistMasc_N" ;
lin telephony_N = mkTerm "telephony_N" ;
lin telephoto_N = mkTerm "telephoto_N" ;
lin telephotograph_N = mkTerm "telephotograph_N" ;
lin telephotography_N = mkTerm "telephotography_N" ;
lin teleportation_N = mkTerm "teleportation_N" ;
lin teleprinter_N = mkTerm "teleprinter_N" ;
lin teleprompter_N = mkTerm "teleprompter_N" ;
lin telerobotics_N = mkTerm "telerobotics_N" ;
lin telescope_N = mkTerm "telescope_N" ;
lin telescope_V = mkTerm "telescope_V" ;
lin telescope_V2 = mkTerm "telescope_V2" ;
lin telescopic_A = mkTerm "telescopic_A" ;
lin telescopy_N = mkTerm "telescopy_N" ;
lin telethermometer_N = mkTerm "telethermometer_N" ;
lin teletypewriter_N = mkTerm "teletypewriter_N" ;
lin televangelism_N = mkTerm "televangelism_N" ;
lin televangelist_N = mkTerm "televangelist_N" ;
lin televise_V2 = mkTerm "televise_V2" ;
lin television_N = mkTerm "television_N" ;
lin telex_N = mkTerm "telex_N" ;
lin telfer_N = mkTerm "telfer_N" ;
lin telford_PN = mkTerm "telford_PN" ;
lin teliospore_N = mkTerm "teliospore_N" ;
lin tell_V = mkTerm "tell_V" ;
lin tell_V2 = mkTerm "tell_V2" ;
lin tell_V2S = mkTerm "tell_V2S" ;
lin tell_V2V = mkTerm "tell_V2V" ;
lin tell_V3 = mkTerm "tell_V3" ;
lin tell_VS = mkTerm "tell_VS" ;
lin tell_apart_V2 = mkTerm "tell_apart_V2" ;
lin tell_from_V3 = mkTerm "tell_from_V3" ;
lin tell_off_V2 = mkTerm "tell_off_V2" ;
lin tell_on_V2 = mkTerm "tell_on_V2" ;
lin teller_N = mkTerm "teller_N" ;
lin telling_A = mkTerm "telling_A" ;
lin telling_N = mkTerm "telling_N" ;
lin telltale_N = mkTerm "telltale_N" ;
lin tellurian_A = mkTerm "tellurian_A" ;
lin tellurian_N = mkTerm "tellurian_N" ;
lin telluric_A = mkTerm "telluric_A" ;
lin telluride_N = mkTerm "telluride_N" ;
lin tellurium_N = mkTerm "tellurium_N" ;
lin telly_N = mkTerm "telly_N" ;
lin telocentric_A = mkTerm "telocentric_A" ;
lin telomerase_N = mkTerm "telomerase_N" ;
lin telomere_N = mkTerm "telomere_N" ;
lin telophase_N = mkTerm "telophase_N" ;
lin telpher_N = mkTerm "telpher_N" ;
lin telpherage_N = mkTerm "telpherage_N" ;
lin telstar_PN = mkTerm "telstar_PN" ;
lin temazepam_N = mkTerm "temazepam_N" ;
lin temerity_N = mkTerm "temerity_N" ;
lin temp_N = mkTerm "temp_N" ;
lin temper_N = mkTerm "temper_N" ;
lin temper_V = mkTerm "temper_V" ;
lin temper_V2 = mkTerm "temper_V2" ;
lin tempera_N = mkTerm "tempera_N" ;
lin temperament_N = mkTerm "temperament_N" ;
lin temperamental_A = mkTerm "temperamental_A" ;
lin temperance_N = mkTerm "temperance_N" ;
lin temperate_A = mkTerm "temperate_A" ;
lin temperateness_N = mkTerm "temperateness_N" ;
lin temperature_N = mkTerm "temperature_N" ;
lin tempest_N = mkTerm "tempest_N" ;
lin tempest_swept_A = mkTerm "tempest_swept_A" ;
lin tempest_tossed_A = mkTerm "tempest_tossed_A" ;
lin tempestuous_A = mkTerm "tempestuous_A" ;
lin tempestuousness_N = mkTerm "tempestuousness_N" ;
lin template_N = mkTerm "template_N" ;
lin temple_N = mkTerm "temple_N" ;
lin templet_N = mkTerm "templet_N" ;
lin tempo_N = mkTerm "tempo_N" ;
lin temporal_A = mkTerm "temporal_A" ;
lin temporality_N = mkTerm "temporality_N" ;
lin temporalty_N = mkTerm "temporalty_N" ;
lin temporariness_N = mkTerm "temporariness_N" ;
lin temporary_A = mkTerm "temporary_A" ;
lin temporary_N = mkTerm "temporary_N" ;
lin temporize_V = mkTerm "temporize_V" ;
lin temporizer_N = mkTerm "temporizer_N" ;
lin tempt_V2 = mkTerm "tempt_V2" ;
lin tempt_V2V = mkTerm "tempt_V2V" ;
lin temptable_A = mkTerm "temptable_A" ;
lin temptation_N = mkTerm "temptation_N" ;
lin tempter_N = mkTerm "tempter_N" ;
lin temptingly_Adv = mkTerm "temptingly_Adv" ;
lin temptress_N = mkTerm "temptress_N" ;
lin tempura_N = mkTerm "tempura_N" ;
lin tenability_N = mkTerm "tenability_N" ;
lin tenable_A = mkTerm "tenable_A" ;
lin tenacious_A = mkTerm "tenacious_A" ;
lin tenaciousness_N = mkTerm "tenaciousness_N" ;
lin tenacity_N = mkTerm "tenacity_N" ;
lin tenancy_N = mkTerm "tenancy_N" ;
lin tenant_N = mkTerm "tenant_N" ;
lin tenant_V2 = mkTerm "tenant_V2" ;
lin tenantry_N = mkTerm "tenantry_N" ;
lin tenby_PN = mkTerm "tenby_PN" ;
lin tench_N = mkTerm "tench_N" ;
lin tend_V2 = mkTerm "tend_V2" ;
lin tend_VV = mkTerm "tend_VV" ;
lin tendency_N = mkTerm "tendency_N" ;
lin tendentious_A = mkTerm "tendentious_A" ;
lin tendentiousness_N = mkTerm "tendentiousness_N" ;
lin tender_A = mkTerm "tender_A" ;
lin tender_N = mkTerm "tender_N" ;
lin tender_V = mkTerm "tender_V" ;
lin tender_V2 = mkTerm "tender_V2" ;
lin tender_V2V = mkTerm "tender_V2V" ;
lin tenderfoot_N = mkTerm "tenderfoot_N" ;
lin tendergreen_N = mkTerm "tendergreen_N" ;
lin tenderhearted_A = mkTerm "tenderhearted_A" ;
lin tenderization_N = mkTerm "tenderization_N" ;
lin tenderized_A = mkTerm "tenderized_A" ;
lin tenderizer_N = mkTerm "tenderizer_N" ;
lin tenderloin_N = mkTerm "tenderloin_N" ;
lin tenderness_N = mkTerm "tenderness_N" ;
lin tendinitis_N = mkTerm "tendinitis_N" ;
lin tendinous_A = mkTerm "tendinous_A" ;
lin tendon_N = mkTerm "tendon_N" ;
lin tendril_N = mkTerm "tendril_N" ;
lin tenebrous_A = mkTerm "tenebrous_A" ;
lin tenement_N = mkTerm "tenement_N" ;
lin tenement_house_N = mkTerm "tenement_house_N" ;
lin tenesmus_N = mkTerm "tenesmus_N" ;
lin tenet_N = mkTerm "tenet_N" ;
lin tenfold_A = mkTerm "tenfold_A" ;
lin tenfold_Adv = mkTerm "tenfold_Adv" ;
lin tenge_N = mkTerm "tenge_N" ;
lin tenner_N = mkTerm "tenner_N" ;
lin tennessee_PN = mkTerm "tennessee_PN" ;
lin tennis_N = mkTerm "tennis_N" ;
lin tennis_court_N = mkTerm "tennis_court_N" ;
lin tennis_elbow_N = mkTerm "tennis_elbow_N" ;
lin tenon_N = mkTerm "tenon_N" ;
lin tenor_A = mkTerm "tenor_A" ;
lin tenor_N = mkTerm "tenor_N" ;
lin tenoroon_N = mkTerm "tenoroon_N" ;
lin tenosynovitis_N = mkTerm "tenosynovitis_N" ;
lin tenpence_N = mkTerm "tenpence_N" ;
lin tenpin_N = mkTerm "tenpin_N" ;
lin tenpins_N = mkTerm "tenpins_N" ;
lin tenrec_N = mkTerm "tenrec_N" ;
lin tense_A = mkTerm "tense_A" ;
lin tense_N = mkTerm "tense_N" ;
lin tense_V = mkTerm "tense_V" ;
lin tense_V2 = mkTerm "tense_V2" ;
lin tenseness_N = mkTerm "tenseness_N" ;
lin tensile_A = mkTerm "tensile_A" ;
lin tensimeter_N = mkTerm "tensimeter_N" ;
lin tensiometer_N = mkTerm "tensiometer_N" ;
lin tension_N = mkTerm "tension_N" ;
lin tensional_A = mkTerm "tensional_A" ;
lin tensionless_A = mkTerm "tensionless_A" ;
lin tensity_N = mkTerm "tensity_N" ;
lin tensor_N = mkTerm "tensor_N" ;
lin tent_N = mkTerm "tent_N" ;
lin tent_peg_N = mkTerm "tent_peg_N" ;
lin tentacle_N = mkTerm "tentacle_N" ;
lin tentacled_A = mkTerm "tentacled_A" ;
lin tentacular_A = mkTerm "tentacular_A" ;
lin tentative_A = mkTerm "tentative_A" ;
lin tenter_N = mkTerm "tenter_N" ;
lin tenterden_PN = mkTerm "tenterden_PN" ;
lin tenterhook_N = mkTerm "tenterhook_N" ;
lin tenth_N = mkTerm "tenth_N" ;
lin tentmaker_N = mkTerm "tentmaker_N" ;
lin tentorium_N = mkTerm "tentorium_N" ;
lin tenuity_N = mkTerm "tenuity_N" ;
lin tenuous_A = mkTerm "tenuous_A" ;
lin tenure_N = mkTerm "tenure_N" ;
lin tenured_A = mkTerm "tenured_A" ;
lin tepal_N = mkTerm "tepal_N" ;
lin tepee_N = mkTerm "tepee_N" ;
lin tepid_A = mkTerm "tepid_A" ;
lin tepidity_N = mkTerm "tepidity_N" ;
lin tepidness_N = mkTerm "tepidness_N" ;
lin tequila_N = mkTerm "tequila_N" ;
lin terabit_N = mkTerm "terabit_N" ;
lin terabyte_N = mkTerm "terabyte_N" ;
lin teraflop_N = mkTerm "teraflop_N" ;
lin terahertz_N = mkTerm "terahertz_N" ;
lin teratogen_N = mkTerm "teratogen_N" ;
lin teratogenesis_N = mkTerm "teratogenesis_N" ;
lin teratogenic_A = mkTerm "teratogenic_A" ;
lin teratology_N = mkTerm "teratology_N" ;
lin teratoma_N = mkTerm "teratoma_N" ;
lin terazosin_N = mkTerm "terazosin_N" ;
lin terbinafine_N = mkTerm "terbinafine_N" ;
lin terbium_N = mkTerm "terbium_N" ;
lin terce_N = mkTerm "terce_N" ;
lin tercentenary_N = mkTerm "tercentenary_N" ;
lin tercentennial_N = mkTerm "tercentennial_N" ;
lin terebinth_N = mkTerm "terebinth_N" ;
lin teredo_N = mkTerm "teredo_N" ;
lin terence_PN = mkTerm "terence_PN" ;
lin teres_N = mkTerm "teres_N" ;
lin teresa_PN = mkTerm "teresa_PN" ;
lin terete_A = mkTerm "terete_A" ;
lin tergiversate_V = mkTerm "tergiversate_V" ;
lin tergiversation_N = mkTerm "tergiversation_N" ;
lin teriyaki_N = mkTerm "teriyaki_N" ;
lin term_N = mkTerm "term_N" ;
lin term_V2 = mkTerm "term_V2" ;
lin term_VS = mkTerm "term_VS" ;
lin termagant_N = mkTerm "termagant_N" ;
lin termer_N = mkTerm "termer_N" ;
lin termi_PN = mkTerm "termi_PN" ;
lin terminable_A = mkTerm "terminable_A" ;
lin terminal_A = mkTerm "terminal_A" ;
lin terminal_N = mkTerm "terminal_N" ;
lin terminate_V = mkTerm "terminate_V" ;
lin terminate_V2 = mkTerm "terminate_V2" ;
lin termination_N = mkTerm "termination_N" ;
lin terminative_A = mkTerm "terminative_A" ;
lin terminological_A = mkTerm "terminological_A" ;
lin terminology_N = mkTerm "terminology_N" ;
lin terminus_N = mkTerm "terminus_N" ;
lin termite_N = mkTerm "termite_N" ;
lin terms_N = mkTerm "terms_N" ;
lin tern_N = mkTerm "tern_N" ;
lin ternary_A = mkTerm "ternary_A" ;
lin ternate_A = mkTerm "ternate_A" ;
lin terpene_N = mkTerm "terpene_N" ;
lin terpsichorean_A = mkTerm "terpsichorean_A" ;
lin terr_PN = mkTerm "terr_PN" ;
lin terra_cotta_N = mkTerm "terra_cotta_N" ;
lin terra_firma_N = mkTerm "terra_firma_N" ;
lin terra_incognita_N = mkTerm "terra_incognita_N" ;
lin terrace_N = mkTerm "terrace_N" ;
lin terrace_V2 = mkTerm "terrace_V2" ;
lin terrain_N = mkTerm "terrain_N" ;
lin terrapin_N = mkTerm "terrapin_N" ;
lin terrarium_N = mkTerm "terrarium_N" ;
lin terreplein_N = mkTerm "terreplein_N" ;
lin terrestrial_A = mkTerm "terrestrial_A" ;
lin terrible_A = mkTerm "terrible_A" ;
lin terrier_N = mkTerm "terrier_N" ;
lin terrific_A = mkTerm "terrific_A" ;
lin terrify_V2 = mkTerm "terrify_V2" ;
lin terrine_N = mkTerm "terrine_N" ;
lin territorial_A = mkTerm "territorial_A" ;
lin territorial_N = mkTerm "territorial_N" ;
lin territoriality_N = mkTerm "territoriality_N" ;
lin territorialization_N = mkTerm "territorialization_N" ;
lin territory_N = mkTerm "territory_N" ;
lin terror_N = mkTerm "terror_N" ;
lin terror_stricken_A = mkTerm "terror_stricken_A" ;
lin terror_struck_A = mkTerm "terror_struck_A" ;
lin terrorism_N = mkTerm "terrorism_N" ;
lin terrorist_N = mkTerm "terrorist_N" ;
lin terrorization_N = mkTerm "terrorization_N" ;
lin terrorize_V2 = mkTerm "terrorize_V2" ;
lin terry_N = mkTerm "terry_N" ;
lin terry_PN = mkTerm "terry_PN" ;
lin terse_A = mkTerm "terse_A" ;
lin terseness_N = mkTerm "terseness_N" ;
lin tertian_A = mkTerm "tertian_A" ;
lin tertiary_A = mkTerm "tertiary_A" ;
lin tertigravida_N = mkTerm "tertigravida_N" ;
lin tervakoski_PN = mkTerm "tervakoski_PN" ;
lin tervo_PN = mkTerm "tervo_PN" ;
lin tervola_PN = mkTerm "tervola_PN" ;
lin terylene_N = mkTerm "terylene_N" ;
lin tesla_N = mkTerm "tesla_N" ;
lin tess_PN = mkTerm "tess_PN" ;
lin tessa_PN = mkTerm "tessa_PN" ;
lin tessella_N = mkTerm "tessella_N" ;
lin tessellated_A = mkTerm "tessellated_A" ;
lin tessellation_N = mkTerm "tessellation_N" ;
lin tessera_N = mkTerm "tessera_N" ;
lin tesseract_N = mkTerm "tesseract_N" ;
lin test_N = mkTerm "test_N" ;
lin test_V2 = mkTerm "test_V2" ;
lin test_drive_N = mkTerm "test_drive_N" ;
lin test_drive_V2 = mkTerm "test_drive_V2" ;
lin test_tube_N = mkTerm "test_tube_N" ;
lin testa_N = mkTerm "testa_N" ;
lin testacean_N = mkTerm "testacean_N" ;
lin testaceous_A = mkTerm "testaceous_A" ;
lin testament_N = mkTerm "testament_N" ;
lin testamentary_A = mkTerm "testamentary_A" ;
lin testate_A = mkTerm "testate_A" ;
lin testate_N = mkTerm "testate_N" ;
lin testator_N = mkTerm "testator_N" ;
lin testatrix_N = mkTerm "testatrix_N" ;
lin testbed_N = mkTerm "testbed_N" ;
lin testcross_N = mkTerm "testcross_N" ;
lin testee_N = mkTerm "testee_N" ;
lin tester_N = mkTerm "tester_N" ;
lin testicle_N = mkTerm "testicle_N" ;
lin testicular_A = mkTerm "testicular_A" ;
lin testifier_N = mkTerm "testifier_N" ;
lin testify_V = mkTerm "testify_V" ;
lin testify_V2 = mkTerm "testify_V2" ;
lin testify_VS = mkTerm "testify_VS" ;
lin testimonial_A = mkTerm "testimonial_A" ;
lin testimonial_N = mkTerm "testimonial_N" ;
lin testimony_N = mkTerm "testimony_N" ;
lin testiness_N = mkTerm "testiness_N" ;
lin testing_N = mkTerm "testing_N" ;
lin testis_N = mkTerm "testis_N" ;
lin testosterone_N = mkTerm "testosterone_N" ;
lin testudo_N = mkTerm "testudo_N" ;
lin testy_A = mkTerm "testy_A" ;
lin tetanic_A = mkTerm "tetanic_A" ;
lin tetanus_N = mkTerm "tetanus_N" ;
lin tetany_N = mkTerm "tetany_N" ;
lin tetartanopia_N = mkTerm "tetartanopia_N" ;
lin tetchiness_N = mkTerm "tetchiness_N" ;
lin tetchy_A = mkTerm "tetchy_A" ;
lin tete_a_tete_Adv = mkTerm "tete_a_tete_Adv" ;
lin tete_a_tete_N = mkTerm "tete_a_tete_N" ;
lin teth_N = mkTerm "teth_N" ;
lin tether_N = mkTerm "tether_N" ;
lin tether_V2 = mkTerm "tether_V2" ;
lin tetherball_N = mkTerm "tetherball_N" ;
lin tetra_N = mkTerm "tetra_N" ;
lin tetracaine_N = mkTerm "tetracaine_N" ;
lin tetrachlorethylene_N = mkTerm "tetrachlorethylene_N" ;
lin tetrachloride_N = mkTerm "tetrachloride_N" ;
lin tetracycline_N = mkTerm "tetracycline_N" ;
lin tetrafluoroethylene_N = mkTerm "tetrafluoroethylene_N" ;
lin tetragonal_A = mkTerm "tetragonal_A" ;
lin tetragram_N = mkTerm "tetragram_N" ;
lin tetrahalide_N = mkTerm "tetrahalide_N" ;
lin tetrahedron_N = mkTerm "tetrahedron_N" ;
lin tetrahydrocannabinol_N = mkTerm "tetrahydrocannabinol_N" ;
lin tetrahymena_N = mkTerm "tetrahymena_N" ;
lin tetralogy_N = mkTerm "tetralogy_N" ;
lin tetramerous_A = mkTerm "tetramerous_A" ;
lin tetrameter_N = mkTerm "tetrameter_N" ;
lin tetrametric_A = mkTerm "tetrametric_A" ;
lin tetrapod_N = mkTerm "tetrapod_N" ;
lin tetrasaccharide_N = mkTerm "tetrasaccharide_N" ;
lin tetraskelion_N = mkTerm "tetraskelion_N" ;
lin tetrasporangium_N = mkTerm "tetrasporangium_N" ;
lin tetraspore_N = mkTerm "tetraspore_N" ;
lin tetravalent_A = mkTerm "tetravalent_A" ;
lin tetri_N = mkTerm "tetri_N" ;
lin tetrode_N = mkTerm "tetrode_N" ;
lin tetrodotoxin_N = mkTerm "tetrodotoxin_N" ;
lin tetrose_N = mkTerm "tetrose_N" ;
lin tetroxide_N = mkTerm "tetroxide_N" ;
lin tetryl_N = mkTerm "tetryl_N" ;
lin teuton_N = mkTerm "teuton_N" ;
lin teutonic_A = mkTerm "teutonic_A" ;
lin teuva_PN = mkTerm "teuva_PN" ;
lin tewkesbury_PN = mkTerm "tewkesbury_PN" ;
lin texan_A = mkTerm "texan_A" ;
lin texan_N = mkTerm "texan_N" ;
lin texas_PN = mkTerm "texas_PN" ;
lin text_N = mkTerm "text_N" ;
lin text_out_V = mkTerm "text_out_V" ;
lin textbook_N = mkTerm "textbook_N" ;
lin textile_A = mkTerm "textile_A" ;
lin textile_N = mkTerm "textile_N" ;
lin textual_A = mkTerm "textual_A" ;
lin texture_N = mkTerm "texture_N" ;
lin textured_A = mkTerm "textured_A" ;
lin thaiFem_N = mkTerm "thaiFem_N" ;
lin thaiMasc_N = mkTerm "thaiMasc_N" ;
lin thai_A = mkTerm "thai_A" ;
lin thailand_PN = mkTerm "thailand_PN" ;
lin thalamocortical_A = mkTerm "thalamocortical_A" ;
lin thalamus_N = mkTerm "thalamus_N" ;
lin thalassemia_N = mkTerm "thalassemia_N" ;
lin thalassic_A = mkTerm "thalassic_A" ;
lin thalidomide_N = mkTerm "thalidomide_N" ;
lin thallium_N = mkTerm "thallium_N" ;
lin thalloid_A = mkTerm "thalloid_A" ;
lin thallophyte_N = mkTerm "thallophyte_N" ;
lin thallophytic_A = mkTerm "thallophytic_A" ;
lin thallus_N = mkTerm "thallus_N" ;
lin thalweg_N = mkTerm "thalweg_N" ;
lin thame_PN = mkTerm "thame_PN" ;
lin than_Prep = mkTerm "than_Prep" ;
lin than_Subj = mkTerm "than_Subj" ;
lin thanatology_N = mkTerm "thanatology_N" ;
lin thanatophobia_N = mkTerm "thanatophobia_N" ;
lin thanatopsis_N = mkTerm "thanatopsis_N" ;
lin thane_N = mkTerm "thane_N" ;
lin thaneship_N = mkTerm "thaneship_N" ;
lin thank_V2 = mkTerm "thank_V2" ;
lin thank_offering_N = mkTerm "thank_offering_N" ;
lin thankful_A = mkTerm "thankful_A" ;
lin thankfulness_N = mkTerm "thankfulness_N" ;
lin thankless_A = mkTerm "thankless_A" ;
lin thanks_Interj = mkTerm "thanks_Interj" ;
lin thanks_N = mkTerm "thanks_N" ;
lin thanks_to_Prep = mkTerm "thanks_to_Prep" ;
lin thanksgiving_N = mkTerm "thanksgiving_N" ;
lin that_AdA = mkTerm "that_AdA" ;
lin that_of_Prep = mkTerm "that_of_Prep" ;
lin thatch_N = mkTerm "thatch_N" ;
lin thatch_V2 = mkTerm "thatch_V2" ;
lin thatcham_PN = mkTerm "thatcham_PN" ;
lin thatcher_N = mkTerm "thatcher_N" ;
lin thaumatolatry_N = mkTerm "thaumatolatry_N" ;
lin thaw_N = mkTerm "thaw_N" ;
lin thaw_V = mkTerm "thaw_V" ;
lin thaw_V2 = mkTerm "thaw_V2" ;
lin the_hague_PN = mkTerm "the_hague_PN" ;
lin theanthropism_N = mkTerm "theanthropism_N" ;
lin theatre_N = mkTerm "theatre_N" ;
lin theatregoer_N = mkTerm "theatregoer_N" ;
lin theatrical_A = mkTerm "theatrical_A" ;
lin theatrical_N = mkTerm "theatrical_N" ;
lin thebe_N = mkTerm "thebe_N" ;
lin theca_N = mkTerm "theca_N" ;
lin thecodont_N = mkTerm "thecodont_N" ;
lin theft_N = mkTerm "theft_N" ;
lin theism_N = mkTerm "theism_N" ;
lin theist_A = mkTerm "theist_A" ;
lin theist_N = mkTerm "theist_N" ;
lin theistic_A = mkTerm "theistic_A" ;
lin theistical_A = mkTerm "theistical_A" ;
lin thelarche_N = mkTerm "thelarche_N" ;
lin thematic_A = mkTerm "thematic_A" ;
lin theme_N = mkTerm "theme_N" ;
lin then_Adv = mkTerm "then_Adv" ;
lin then_N = mkTerm "then_N" ;
lin then_Prep = mkTerm "then_Prep" ;
lin thenal_A = mkTerm "thenal_A" ;
lin thenar_N = mkTerm "thenar_N" ;
lin thence_Adv = mkTerm "thence_Adv" ;
lin thenceforth_Adv = mkTerm "thenceforth_Adv" ;
lin thenceforward_Adv = mkTerm "thenceforward_Adv" ;
lin theo_PN = mkTerm "theo_PN" ;
lin theocracy_N = mkTerm "theocracy_N" ;
lin theocratic_A = mkTerm "theocratic_A" ;
lin theodicy_N = mkTerm "theodicy_N" ;
lin theodolite_N = mkTerm "theodolite_N" ;
lin theodore_PN = mkTerm "theodore_PN" ;
lin theogony_N = mkTerm "theogony_N" ;
lin theologian_N = mkTerm "theologian_N" ;
lin theological_A = mkTerm "theological_A" ;
lin theology_N = mkTerm "theology_N" ;
lin theophany_N = mkTerm "theophany_N" ;
lin theophylline_N = mkTerm "theophylline_N" ;
lin theorem_N = mkTerm "theorem_N" ;
lin theoretic_A = mkTerm "theoretic_A" ;
lin theoretical_A = mkTerm "theoretical_A" ;
lin theoretician_N = mkTerm "theoretician_N" ;
lin theorist_N = mkTerm "theorist_N" ;
lin theorization_N = mkTerm "theorization_N" ;
lin theorize_V = mkTerm "theorize_V" ;
lin theorize_VS = mkTerm "theorize_VS" ;
lin theory_N = mkTerm "theory_N" ;
lin theosophical_A = mkTerm "theosophical_A" ;
lin theosophism_N = mkTerm "theosophism_N" ;
lin theosophist_N = mkTerm "theosophist_N" ;
lin theosophy_N = mkTerm "theosophy_N" ;
lin theoterrorism_N = mkTerm "theoterrorism_N" ;
lin therapeutic_A = mkTerm "therapeutic_A" ;
lin therapeutical_A = mkTerm "therapeutical_A" ;
lin therapeutics_N = mkTerm "therapeutics_N" ;
lin therapist_N = mkTerm "therapist_N" ;
lin therapsid_N = mkTerm "therapsid_N" ;
lin therapy_N = mkTerm "therapy_N" ;
lin thereabout_Adv = mkTerm "thereabout_Adv" ;
lin thereabouts_Adv = mkTerm "thereabouts_Adv" ;
lin thereafter_Adv = mkTerm "thereafter_Adv" ;
lin thereby_Adv = mkTerm "thereby_Adv" ;
lin therefor_Adv = mkTerm "therefor_Adv" ;
lin therefore_Adv = mkTerm "therefore_Adv" ;
lin therefrom_Adv = mkTerm "therefrom_Adv" ;
lin therein_Adv = mkTerm "therein_Adv" ;
lin thereinafter_Adv = mkTerm "thereinafter_Adv" ;
lin theremin_N = mkTerm "theremin_N" ;
lin thereness_N = mkTerm "thereness_N" ;
lin thereof_Adv = mkTerm "thereof_Adv" ;
lin thereon_Adv = mkTerm "thereon_Adv" ;
lin theresa_PN = mkTerm "theresa_PN" ;
lin thereto_Adv = mkTerm "thereto_Adv" ;
lin theretofore_Adv = mkTerm "theretofore_Adv" ;
lin thereunder_Adv = mkTerm "thereunder_Adv" ;
lin thereupon_Adv = mkTerm "thereupon_Adv" ;
lin therewith_Adv = mkTerm "therewith_Adv" ;
lin therewithal_Adv = mkTerm "therewithal_Adv" ;
lin therm_N = mkTerm "therm_N" ;
lin thermal_A = mkTerm "thermal_A" ;
lin thermal_N = mkTerm "thermal_N" ;
lin thermalgesia_N = mkTerm "thermalgesia_N" ;
lin thermion_N = mkTerm "thermion_N" ;
lin thermionic_A = mkTerm "thermionic_A" ;
lin thermionics_N = mkTerm "thermionics_N" ;
lin thermistor_N = mkTerm "thermistor_N" ;
lin thermoacidophile_N = mkTerm "thermoacidophile_N" ;
lin thermocautery_N = mkTerm "thermocautery_N" ;
lin thermochemistry_N = mkTerm "thermochemistry_N" ;
lin thermocoagulation_N = mkTerm "thermocoagulation_N" ;
lin thermocouple_N = mkTerm "thermocouple_N" ;
lin thermodynamic_A = mkTerm "thermodynamic_A" ;
lin thermodynamics_N = mkTerm "thermodynamics_N" ;
lin thermoelectric_A = mkTerm "thermoelectric_A" ;
lin thermoelectricity_N = mkTerm "thermoelectricity_N" ;
lin thermogram_N = mkTerm "thermogram_N" ;
lin thermograph_N = mkTerm "thermograph_N" ;
lin thermography_N = mkTerm "thermography_N" ;
lin thermogravimetry_N = mkTerm "thermogravimetry_N" ;
lin thermohydrometer_N = mkTerm "thermohydrometer_N" ;
lin thermohydrometric_A = mkTerm "thermohydrometric_A" ;
lin thermojunction_N = mkTerm "thermojunction_N" ;
lin thermolabile_A = mkTerm "thermolabile_A" ;
lin thermometer_N = mkTerm "thermometer_N" ;
lin thermometric_A = mkTerm "thermometric_A" ;
lin thermometry_N = mkTerm "thermometry_N" ;
lin thermonuclear_A = mkTerm "thermonuclear_A" ;
lin thermopile_N = mkTerm "thermopile_N" ;
lin thermoplastic_A = mkTerm "thermoplastic_A" ;
lin thermoplastic_N = mkTerm "thermoplastic_N" ;
lin thermoreceptor_N = mkTerm "thermoreceptor_N" ;
lin thermos_N = mkTerm "thermos_N" ;
lin thermosetting_A = mkTerm "thermosetting_A" ;
lin thermosphere_N = mkTerm "thermosphere_N" ;
lin thermostat_N = mkTerm "thermostat_N" ;
lin thermostatic_A = mkTerm "thermostatic_A" ;
lin thermostatics_N = mkTerm "thermostatics_N" ;
lin thermotherapy_N = mkTerm "thermotherapy_N" ;
lin thermotropism_N = mkTerm "thermotropism_N" ;
lin theropod_N = mkTerm "theropod_N" ;
lin thesaurus_N = mkTerm "thesaurus_N" ;
lin thesis_N = mkTerm "thesis_N" ;
lin thespian_A = mkTerm "thespian_A" ;
lin thespian_N = mkTerm "thespian_N" ;
lin thessaloniki_PN = mkTerm "thessaloniki_PN" ;
lin theta_N = mkTerm "theta_N" ;
lin thetford_PN = mkTerm "thetford_PN" ;
lin theurgy_N = mkTerm "theurgy_N" ;
lin theyFem_Pron = mkTerm "theyFem_Pron" ;
lin thiabendazole_N = mkTerm "thiabendazole_N" ;
lin thiazide_N = mkTerm "thiazide_N" ;
lin thiazine_N = mkTerm "thiazine_N" ;
lin thick_A = mkTerm "thick_A" ;
lin thick_Adv = mkTerm "thick_Adv" ;
lin thick_N = mkTerm "thick_N" ;
lin thick_headed_A = mkTerm "thick_headed_A" ;
lin thick_set_A = mkTerm "thick_set_A" ;
lin thick_skinned_A = mkTerm "thick_skinned_A" ;
lin thicken_V = mkTerm "thicken_V" ;
lin thicken_V2 = mkTerm "thicken_V2" ;
lin thickening_N = mkTerm "thickening_N" ;
lin thicket_N = mkTerm "thicket_N" ;
lin thickhead_N = mkTerm "thickhead_N" ;
lin thickness_N = mkTerm "thickness_N" ;
lin thickspread_A = mkTerm "thickspread_A" ;
lin thief_N = mkTerm "thief_N" ;
lin thieve_V = mkTerm "thieve_V" ;
lin thieve_V2 = mkTerm "thieve_V2" ;
lin thievery_N = mkTerm "thievery_N" ;
lin thievish_A = mkTerm "thievish_A" ;
lin thievishness_N = mkTerm "thievishness_N" ;
lin thigh_N = mkTerm "thigh_N" ;
lin thighbone_N = mkTerm "thighbone_N" ;
lin thill_N = mkTerm "thill_N" ;
lin thimble_N = mkTerm "thimble_N" ;
lin thimbleful_N = mkTerm "thimbleful_N" ;
lin thimbleweed_N = mkTerm "thimbleweed_N" ;
lin thimerosal_N = mkTerm "thimerosal_N" ;
lin thin_A = mkTerm "thin_A" ;
lin thin_Adv = mkTerm "thin_Adv" ;
lin thin_V = mkTerm "thin_V" ;
lin thin_V2 = mkTerm "thin_V2" ;
lin thin_skinned_A = mkTerm "thin_skinned_A" ;
lin thine_A = mkTerm "thine_A" ;
lin thing_N = mkTerm "thing_N" ;
lin things_N = mkTerm "things_N" ;
lin thingumabob_N = mkTerm "thingumabob_N" ;
lin thingumajig_N = mkTerm "thingumajig_N" ;
lin thingummy_N = mkTerm "thingummy_N" ;
lin think_N = mkTerm "think_N" ;
lin think_V = mkTerm "think_V" ;
lin think_V2 = mkTerm "think_V2" ;
lin think_VS = mkTerm "think_VS" ;
lin think_over_V2 = mkTerm "think_over_V2" ;
lin think_tank_N = mkTerm "think_tank_N" ;
lin think_through_V2 = mkTerm "think_through_V2" ;
lin think_up_V2 = mkTerm "think_up_V2" ;
lin thinkable_A = mkTerm "thinkable_A" ;
lin thinkerFem_N = mkTerm "thinkerFem_N" ;
lin thinkerMasc_N = mkTerm "thinkerMasc_N" ;
lin thinking_A = mkTerm "thinking_A" ;
lin thinking_N = mkTerm "thinking_N" ;
lin thinness_N = mkTerm "thinness_N" ;
lin thiobacillus_N = mkTerm "thiobacillus_N" ;
lin thiobacteria_N = mkTerm "thiobacteria_N" ;
lin thiocyanate_N = mkTerm "thiocyanate_N" ;
lin thioguanine_N = mkTerm "thioguanine_N" ;
lin thionville_PN = mkTerm "thionville_PN" ;
lin thiopental_N = mkTerm "thiopental_N" ;
lin thioridazine_N = mkTerm "thioridazine_N" ;
lin thiotepa_N = mkTerm "thiotepa_N" ;
lin thiothixene_N = mkTerm "thiothixene_N" ;
lin thiouracil_N = mkTerm "thiouracil_N" ;
lin third_rate_A = mkTerm "third_rate_A" ;
lin third_rater_N = mkTerm "third_rater_N" ;
lin thirdhand_A = mkTerm "thirdhand_A" ;
lin thirdhand_Adv = mkTerm "thirdhand_Adv" ;
lin thirsk_PN = mkTerm "thirsk_PN" ;
lin thirst_N = mkTerm "thirst_N" ;
lin thirst_V2 = mkTerm "thirst_V2" ;
lin thirsty_A = mkTerm "thirsty_A" ;
lin thistle_N = mkTerm "thistle_N" ;
lin thistledown_N = mkTerm "thistledown_N" ;
lin thistlelike_A = mkTerm "thistlelike_A" ;
lin thither_Adv = mkTerm "thither_Adv" ;
lin tho'_Adv = mkTerm "tho'_Adv" ;
lin thole_N = mkTerm "thole_N" ;
lin tholepin_N = mkTerm "tholepin_N" ;
lin thomas_PN = mkTerm "thomas_PN" ;
lin thong_N = mkTerm "thong_N" ;
lin thoracocentesis_N = mkTerm "thoracocentesis_N" ;
lin thoracotomy_N = mkTerm "thoracotomy_N" ;
lin thorax_N = mkTerm "thorax_N" ;
lin thoriated_A = mkTerm "thoriated_A" ;
lin thorite_N = mkTerm "thorite_N" ;
lin thorium_N = mkTerm "thorium_N" ;
lin thorn_N = mkTerm "thorn_N" ;
lin thornbill_N = mkTerm "thornbill_N" ;
lin thornbury_PN = mkTerm "thornbury_PN" ;
lin thorne_PN = mkTerm "thorne_PN" ;
lin thornless_A = mkTerm "thornless_A" ;
lin thorny_A = mkTerm "thorny_A" ;
lin thorough_A = mkTerm "thorough_A" ;
lin thoroughbred_A = mkTerm "thoroughbred_A" ;
lin thoroughbred_N = mkTerm "thoroughbred_N" ;
lin thoroughfare_N = mkTerm "thoroughfare_N" ;
lin thoroughgoing_A = mkTerm "thoroughgoing_A" ;
lin thoroughness_N = mkTerm "thoroughness_N" ;
lin thortveitite_N = mkTerm "thortveitite_N" ;
lin those_N = mkTerm "those_N" ;
lin though_Adv = mkTerm "though_Adv" ;
lin though_Prep = mkTerm "though_Prep" ;
lin though_Subj = mkTerm "though_Subj" ;
lin thought_N = mkTerm "thought_N" ;
lin thought_reader_N = mkTerm "thought_reader_N" ;
lin thoughtful_A = mkTerm "thoughtful_A" ;
lin thoughtfulness_N = mkTerm "thoughtfulness_N" ;
lin thoughtless_A = mkTerm "thoughtless_A" ;
lin thoughtlessness_N = mkTerm "thoughtlessness_N" ;
lin thousandfold_A = mkTerm "thousandfold_A" ;
lin thousandfold_Adv = mkTerm "thousandfold_Adv" ;
lin thraldom_N = mkTerm "thraldom_N" ;
lin thrall_N = mkTerm "thrall_N" ;
lin thrash_N = mkTerm "thrash_N" ;
lin thrash_V = mkTerm "thrash_V" ;
lin thrash_V2 = mkTerm "thrash_V2" ;
lin thrasher_N = mkTerm "thrasher_N" ;
lin thrashing_N = mkTerm "thrashing_N" ;
lin thread_N = mkTerm "thread_N" ;
lin thread_V2 = mkTerm "thread_V2" ;
lin threadbare_A = mkTerm "threadbare_A" ;
lin threadfin_N = mkTerm "threadfin_N" ;
lin threadfish_N = mkTerm "threadfish_N" ;
lin threadlike_A = mkTerm "threadlike_A" ;
lin threat_N = mkTerm "threat_N" ;
lin threaten_V = mkTerm "threaten_V" ;
lin threaten_V2 = mkTerm "threaten_V2" ;
lin threaten_VS = mkTerm "threaten_VS" ;
lin threaten_VV = mkTerm "threaten_VV" ;
lin threateningly_Adv = mkTerm "threateningly_Adv" ;
lin three_cornered_A = mkTerm "three_cornered_A" ;
lin three_d_A = mkTerm "three_d_A" ;
lin three_d_N = mkTerm "three_d_N" ;
lin three_decker_N = mkTerm "three_decker_N" ;
lin three_dimensional_A = mkTerm "three_dimensional_A" ;
lin three_figure_A = mkTerm "three_figure_A" ;
lin three_funnelled_A = mkTerm "three_funnelled_A" ;
lin three_lane_A = mkTerm "three_lane_A" ;
lin three_legged_A = mkTerm "three_legged_A" ;
lin three_piece_A = mkTerm "three_piece_A" ;
lin three_ply_A = mkTerm "three_ply_A" ;
lin three_quarter_A = mkTerm "three_quarter_A" ;
lin three_quarter_N = mkTerm "three_quarter_N" ;
lin three_score_A = mkTerm "three_score_A" ;
lin three_score_N = mkTerm "three_score_N" ;
lin three_storey_A = mkTerm "three_storey_A" ;
lin three_storeyed_A = mkTerm "three_storeyed_A" ;
lin three_wheeled_A = mkTerm "three_wheeled_A" ;
lin threefold_A = mkTerm "threefold_A" ;
lin threefold_Adv = mkTerm "threefold_Adv" ;
lin threepence_N = mkTerm "threepence_N" ;
lin threepenny_A = mkTerm "threepenny_A" ;
lin threesome_N = mkTerm "threesome_N" ;
lin threnody_N = mkTerm "threnody_N" ;
lin threonine_N = mkTerm "threonine_N" ;
lin thresh_V = mkTerm "thresh_V" ;
lin thresh_V2 = mkTerm "thresh_V2" ;
lin thresher_N = mkTerm "thresher_N" ;
lin threshing_N = mkTerm "threshing_N" ;
lin threshing_floor_N = mkTerm "threshing_floor_N" ;
lin threshing_machine_N = mkTerm "threshing_machine_N" ;
lin threshold_N = mkTerm "threshold_N" ;
lin thrice_Adv = mkTerm "thrice_Adv" ;
lin thrift_N = mkTerm "thrift_N" ;
lin thriftless_A = mkTerm "thriftless_A" ;
lin thriftlessness_N = mkTerm "thriftlessness_N" ;
lin thriftshop_N = mkTerm "thriftshop_N" ;
lin thrifty_A = mkTerm "thrifty_A" ;
lin thrill_N = mkTerm "thrill_N" ;
lin thrill_V = mkTerm "thrill_V" ;
lin thrill_V2 = mkTerm "thrill_V2" ;
lin thriller_N = mkTerm "thriller_N" ;
lin thrillful_A = mkTerm "thrillful_A" ;
lin thrips_N = mkTerm "thrips_N" ;
lin thrive_V = mkTerm "thrive_V" ;
lin throat_N = mkTerm "throat_N" ;
lin throated_A = mkTerm "throated_A" ;
lin throatwort_N = mkTerm "throatwort_N" ;
lin throaty_A = mkTerm "throaty_A" ;
lin throb_N = mkTerm "throb_N" ;
lin throb_V = mkTerm "throb_V" ;
lin throbbing_N = mkTerm "throbbing_N" ;
lin throe_N = mkTerm "throe_N" ;
lin throes_N = mkTerm "throes_N" ;
lin thrombasthenia_N = mkTerm "thrombasthenia_N" ;
lin thrombectomy_N = mkTerm "thrombectomy_N" ;
lin thrombin_N = mkTerm "thrombin_N" ;
lin thrombocytopenia_N = mkTerm "thrombocytopenia_N" ;
lin thrombocytosis_N = mkTerm "thrombocytosis_N" ;
lin thromboembolism_N = mkTerm "thromboembolism_N" ;
lin thrombolysis_N = mkTerm "thrombolysis_N" ;
lin thrombolytic_N = mkTerm "thrombolytic_N" ;
lin thrombophlebitis_N = mkTerm "thrombophlebitis_N" ;
lin thromboplastin_N = mkTerm "thromboplastin_N" ;
lin thrombosed_A = mkTerm "thrombosed_A" ;
lin thrombosis_N = mkTerm "thrombosis_N" ;
lin thrombus_N = mkTerm "thrombus_N" ;
lin throne_N = mkTerm "throne_N" ;
lin throng_N = mkTerm "throng_N" ;
lin throng_V = mkTerm "throng_V" ;
lin throng_V2 = mkTerm "throng_V2" ;
lin throstle_N = mkTerm "throstle_N" ;
lin throttle_N = mkTerm "throttle_N" ;
lin throttle_V = mkTerm "throttle_V" ;
lin throttle_V2 = mkTerm "throttle_V2" ;
lin throttle_valve_N = mkTerm "throttle_valve_N" ;
lin through_Adv = mkTerm "through_Adv" ;
lin throughout_Adv = mkTerm "throughout_Adv" ;
lin throughout_Prep = mkTerm "throughout_Prep" ;
lin throughput_N = mkTerm "throughput_N" ;
lin throughway_N = mkTerm "throughway_N" ;
lin throw_N = mkTerm "throw_N" ;
lin throw_V = mkTerm "throw_V" ;
lin throw_V2 = mkTerm "throw_V2" ;
lin throw_away_V2 = mkTerm "throw_away_V2" ;
lin throw_in_N = mkTerm "throw_in_N" ;
lin throw_in_V = mkTerm "throw_in_V" ;
lin throw_in_V2 = mkTerm "throw_in_V2" ;
lin throw_off_V = mkTerm "throw_off_V" ;
lin throw_off_V2 = mkTerm "throw_off_V2" ;
lin throw_on_V2 = mkTerm "throw_on_V2" ;
lin throw_out_V2 = mkTerm "throw_out_V2" ;
lin throw_over_V2 = mkTerm "throw_over_V2" ;
lin throw_together_V2 = mkTerm "throw_together_V2" ;
lin throw_up_V = mkTerm "throw_up_V" ;
lin throw_up_V2 = mkTerm "throw_up_V2" ;
lin throw_yourself_at_V2 = mkTerm "throw_yourself_at_V2" ;
lin throw_yourself_into_V2 = mkTerm "throw_yourself_into_V2" ;
lin throwaway_N = mkTerm "throwaway_N" ;
lin throwback_N = mkTerm "throwback_N" ;
lin thrower_N = mkTerm "thrower_N" ;
lin throwster_N = mkTerm "throwster_N" ;
lin thrum_N = mkTerm "thrum_N" ;
lin thrum_V = mkTerm "thrum_V" ;
lin thrum_V2 = mkTerm "thrum_V2" ;
lin thrush_N = mkTerm "thrush_N" ;
lin thrust_N = mkTerm "thrust_N" ;
lin thrust_V = mkTerm "thrust_V" ;
lin thrust_V2 = mkTerm "thrust_V2" ;
lin thrust_open_V = mkTerm "thrust_open_V" ;
lin thrusterFem_N = mkTerm "thrusterFem_N" ;
lin thrusterMasc_N = mkTerm "thrusterMasc_N" ;
lin thud_N = mkTerm "thud_N" ;
lin thud_V = mkTerm "thud_V" ;
lin thug_N = mkTerm "thug_N" ;
lin thuggee_N = mkTerm "thuggee_N" ;
lin thuggery_N = mkTerm "thuggery_N" ;
lin thulium_N = mkTerm "thulium_N" ;
lin thumb_N = mkTerm "thumb_N" ;
lin thumb_V2 = mkTerm "thumb_V2" ;
lin thumbhole_N = mkTerm "thumbhole_N" ;
lin thumbnail_N = mkTerm "thumbnail_N" ;
lin thumbnut_N = mkTerm "thumbnut_N" ;
lin thumbprint_N = mkTerm "thumbprint_N" ;
lin thumbscrew_N = mkTerm "thumbscrew_N" ;
lin thumbstall_N = mkTerm "thumbstall_N" ;
lin thumbtack_N = mkTerm "thumbtack_N" ;
lin thump_N = mkTerm "thump_N" ;
lin thump_V = mkTerm "thump_V" ;
lin thump_V2 = mkTerm "thump_V2" ;
lin thunder_N = mkTerm "thunder_N" ;
lin thunder_V = mkTerm "thunder_V" ;
lin thunder_V2 = mkTerm "thunder_V2" ;
lin thunderbird_N = mkTerm "thunderbird_N" ;
lin thunderbolt_N = mkTerm "thunderbolt_N" ;
lin thunderclap_N = mkTerm "thunderclap_N" ;
lin thunderer_N = mkTerm "thunderer_N" ;
lin thunderhead_N = mkTerm "thunderhead_N" ;
lin thunderous_A = mkTerm "thunderous_A" ;
lin thundershower_N = mkTerm "thundershower_N" ;
lin thunderstorm_N = mkTerm "thunderstorm_N" ;
lin thunderstruck_A = mkTerm "thunderstruck_A" ;
lin thundery_A = mkTerm "thundery_A" ;
lin thunk_N = mkTerm "thunk_N" ;
lin thurcroft_PN = mkTerm "thurcroft_PN" ;
lin thurible_N = mkTerm "thurible_N" ;
lin thurifer_N = mkTerm "thurifer_N" ;
lin thurmaston_PN = mkTerm "thurmaston_PN" ;
lin thurrock_PN = mkTerm "thurrock_PN" ;
lin thurs_PN = mkTerm "thurs_PN" ;
lin thurso_PN = mkTerm "thurso_PN" ;
lin thus_Adv = mkTerm "thus_Adv" ;
lin thwack_N = mkTerm "thwack_N" ;
lin thwack_V2 = mkTerm "thwack_V2" ;
lin thwart_N = mkTerm "thwart_N" ;
lin thwart_V2 = mkTerm "thwart_V2" ;
lin thy_A = mkTerm "thy_A" ;
lin thylacine_N = mkTerm "thylacine_N" ;
lin thyme_N = mkTerm "thyme_N" ;
lin thymine_N = mkTerm "thymine_N" ;
lin thymol_N = mkTerm "thymol_N" ;
lin thymosin_N = mkTerm "thymosin_N" ;
lin thyroglobulin_N = mkTerm "thyroglobulin_N" ;
lin thyroid_A = mkTerm "thyroid_A" ;
lin thyroid_N = mkTerm "thyroid_N" ;
lin thyroidectomy_N = mkTerm "thyroidectomy_N" ;
lin thyroiditis_N = mkTerm "thyroiditis_N" ;
lin thyronine_N = mkTerm "thyronine_N" ;
lin thyroprotein_N = mkTerm "thyroprotein_N" ;
lin thyrotoxic_A = mkTerm "thyrotoxic_A" ;
lin thyrotropin_N = mkTerm "thyrotropin_N" ;
lin thyroxine_N = mkTerm "thyroxine_N" ;
lin thyrse_N = mkTerm "thyrse_N" ;
lin thyrsopteris_N = mkTerm "thyrsopteris_N" ;
lin thysanopter_N = mkTerm "thysanopter_N" ;
lin ti_N = mkTerm "ti_N" ;
lin tiara_N = mkTerm "tiara_N" ;
lin tibet_PN = mkTerm "tibet_PN" ;
lin tibetan_A = mkTerm "tibetan_A" ;
lin tibetan_N = mkTerm "tibetan_N" ;
lin tibia_N = mkTerm "tibia_N" ;
lin tibial_A = mkTerm "tibial_A" ;
lin tibialis_N = mkTerm "tibialis_N" ;
lin tic_N = mkTerm "tic_N" ;
lin tick_N = mkTerm "tick_N" ;
lin tick_V = mkTerm "tick_V" ;
lin tick_V2 = mkTerm "tick_V2" ;
lin tick_along_V = mkTerm "tick_along_V" ;
lin tick_away_V = mkTerm "tick_away_V" ;
lin tick_by_V = mkTerm "tick_by_V" ;
lin tick_off_V = mkTerm "tick_off_V" ;
lin tick_off_V2 = mkTerm "tick_off_V2" ;
lin tick_over_V = mkTerm "tick_over_V" ;
lin tick_tock_N = mkTerm "tick_tock_N" ;
lin ticker_N = mkTerm "ticker_N" ;
lin ticker_tape_N = mkTerm "ticker_tape_N" ;
lin ticket_N = mkTerm "ticket_N" ;
lin ticket_V2 = mkTerm "ticket_V2" ;
lin ticket_collector_N = mkTerm "ticket_collector_N" ;
lin ticking_N = mkTerm "ticking_N" ;
lin tickle_N = mkTerm "tickle_N" ;
lin tickle_V = mkTerm "tickle_V" ;
lin tickle_V2 = mkTerm "tickle_V2" ;
lin tickler_N = mkTerm "tickler_N" ;
lin ticklish_A = mkTerm "ticklish_A" ;
lin ticktack_N = mkTerm "ticktack_N" ;
lin ticktacktoe_N = mkTerm "ticktacktoe_N" ;
lin tidal_A = mkTerm "tidal_A" ;
lin tidbit_N = mkTerm "tidbit_N" ;
lin tiddler_N = mkTerm "tiddler_N" ;
lin tiddley_A = mkTerm "tiddley_A" ;
lin tiddlywinks_N = mkTerm "tiddlywinks_N" ;
lin tide_N = mkTerm "tide_N" ;
lin tide_V2 = mkTerm "tide_V2" ;
lin tide_over_V2 = mkTerm "tide_over_V2" ;
lin tideland_N = mkTerm "tideland_N" ;
lin tidemark_N = mkTerm "tidemark_N" ;
lin tidewater_N = mkTerm "tidewater_N" ;
lin tideway_N = mkTerm "tideway_N" ;
lin tidiness_N = mkTerm "tidiness_N" ;
lin tidworth_PN = mkTerm "tidworth_PN" ;
lin tidy_A = mkTerm "tidy_A" ;
lin tidy_N = mkTerm "tidy_N" ;
lin tidy_V = mkTerm "tidy_V" ;
lin tidy_V2 = mkTerm "tidy_V2" ;
lin tidy_up_V2 = mkTerm "tidy_up_V2" ;
lin tidytips_N = mkTerm "tidytips_N" ;
lin tie_N = mkTerm "tie_N" ;
lin tie_V = mkTerm "tie_V" ;
lin tie_V2 = mkTerm "tie_V2" ;
lin tie_back_V2 = mkTerm "tie_back_V2" ;
lin tie_down_V2 = mkTerm "tie_down_V2" ;
lin tie_in_V = mkTerm "tie_in_V" ;
lin tie_in_V2 = mkTerm "tie_in_V2" ;
lin tie_in_with_V2 = mkTerm "tie_in_with_V2" ;
lin tie_on_A = mkTerm "tie_on_A" ;
lin tie_up_N = mkTerm "tie_up_N" ;
lin tie_up_V2 = mkTerm "tie_up_V2" ;
lin tiebreaker_N = mkTerm "tiebreaker_N" ;
lin tientsin_PN = mkTerm "tientsin_PN" ;
lin tier_N = mkTerm "tier_N" ;
lin tiercel_N = mkTerm "tiercel_N" ;
lin tiered_A = mkTerm "tiered_A" ;
lin tiff_N = mkTerm "tiff_N" ;
lin tiger_N = mkTerm "tiger_N" ;
lin tiger_lily_N = mkTerm "tiger_lily_N" ;
lin tigerish_A = mkTerm "tigerish_A" ;
lin tight_A = mkTerm "tight_A" ;
lin tight_Adv = mkTerm "tight_Adv" ;
lin tight_laced_A = mkTerm "tight_laced_A" ;
lin tight_lipped_A = mkTerm "tight_lipped_A" ;
lin tight_wad_N = mkTerm "tight_wad_N" ;
lin tighten_V = mkTerm "tighten_V" ;
lin tighten_V2 = mkTerm "tighten_V2" ;
lin tighten_up_V2 = mkTerm "tighten_up_V2" ;
lin tightening_N = mkTerm "tightening_N" ;
lin tightness_N = mkTerm "tightness_N" ;
lin tightrope_N = mkTerm "tightrope_N" ;
lin tights_N = mkTerm "tights_N" ;
lin tiglon_N = mkTerm "tiglon_N" ;
lin tigress_N = mkTerm "tigress_N" ;
lin tike_N = mkTerm "tike_N" ;
lin tilburg_PN = mkTerm "tilburg_PN" ;
lin tilbury_PN = mkTerm "tilbury_PN" ;
lin tilde_N = mkTerm "tilde_N" ;
lin tile_N = mkTerm "tile_N" ;
lin tile_V2 = mkTerm "tile_V2" ;
lin tilefish_N = mkTerm "tilefish_N" ;
lin tiler_N = mkTerm "tiler_N" ;
lin tiling_N = mkTerm "tiling_N" ;
lin till_N = mkTerm "till_N" ;
lin till_Subj = mkTerm "till_Subj" ;
lin till_V2 = mkTerm "till_V2" ;
lin tillage_N = mkTerm "tillage_N" ;
lin tiller_N = mkTerm "tiller_N" ;
lin tilling_N = mkTerm "tilling_N" ;
lin tilt_N = mkTerm "tilt_N" ;
lin tilt_V = mkTerm "tilt_V" ;
lin tilt_V2 = mkTerm "tilt_V2" ;
lin tilter_N = mkTerm "tilter_N" ;
lin tilth_N = mkTerm "tilth_N" ;
lin tiltyard_N = mkTerm "tiltyard_N" ;
lin tim_PN = mkTerm "tim_PN" ;
lin timbale_N = mkTerm "timbale_N" ;
lin timber_N = mkTerm "timber_N" ;
lin timbered_A = mkTerm "timbered_A" ;
lin timberman_N = mkTerm "timberman_N" ;
lin timbre_N = mkTerm "timbre_N" ;
lin timbrel_N = mkTerm "timbrel_N" ;
lin time_1_N = mkTerm "time_1_N" ;
lin time_2_N = mkTerm "time_2_N" ;
lin time_V2 = mkTerm "time_V2" ;
lin time_ball_N = mkTerm "time_ball_N" ;
lin time_bomb_N = mkTerm "time_bomb_N" ;
lin time_expired_A = mkTerm "time_expired_A" ;
lin time_exposure_N = mkTerm "time_exposure_N" ;
lin time_fuse_N = mkTerm "time_fuse_N" ;
lin time_honoured_A = mkTerm "time_honoured_A" ;
lin time_lag_N = mkTerm "time_lag_N" ;
lin time_limit_N = mkTerm "time_limit_N" ;
lin time_out_V = mkTerm "time_out_V" ;
lin time_out_V2 = mkTerm "time_out_V2" ;
lin time_sheet_N = mkTerm "time_sheet_N" ;
lin time_signal_N = mkTerm "time_signal_N" ;
lin time_switch_N = mkTerm "time_switch_N" ;
lin timecard_N = mkTerm "timecard_N" ;
lin timekeeper_N = mkTerm "timekeeper_N" ;
lin timekeeping_N = mkTerm "timekeeping_N" ;
lin timeless_A = mkTerm "timeless_A" ;
lin timeline_N = mkTerm "timeline_N" ;
lin timeliness_N = mkTerm "timeliness_N" ;
lin timely_A = mkTerm "timely_A" ;
lin timepiece_N = mkTerm "timepiece_N" ;
lin timer_N = mkTerm "timer_N" ;
lin times_N = mkTerm "times_N" ;
lin times_Prep = mkTerm "times_Prep" ;
lin timesaving_A = mkTerm "timesaving_A" ;
lin timeserver_N = mkTerm "timeserver_N" ;
lin timeserving_A = mkTerm "timeserving_A" ;
lin timetable_N = mkTerm "timetable_N" ;
lin timework_N = mkTerm "timework_N" ;
lin timid_A = mkTerm "timid_A" ;
lin timid_N = mkTerm "timid_N" ;
lin timidity_N = mkTerm "timidity_N" ;
lin timidness_N = mkTerm "timidness_N" ;
lin timing_N = mkTerm "timing_N" ;
lin timmy_PN = mkTerm "timmy_PN" ;
lin timolol_N = mkTerm "timolol_N" ;
lin timorous_A = mkTerm "timorous_A" ;
lin timothy_N = mkTerm "timothy_N" ;
lin timothy_PN = mkTerm "timothy_PN" ;
lin timpanist_N = mkTerm "timpanist_N" ;
lin timucu_N = mkTerm "timucu_N" ;
lin tin_N = mkTerm "tin_N" ;
lin tin_V2 = mkTerm "tin_V2" ;
lin tin_opener_N = mkTerm "tin_opener_N" ;
lin tin_pan_alley_N = mkTerm "tin_pan_alley_N" ;
lin tin_plate_N = mkTerm "tin_plate_N" ;
lin tina_PN = mkTerm "tina_PN" ;
lin tinamou_N = mkTerm "tinamou_N" ;
lin tincture_N = mkTerm "tincture_N" ;
lin tincture_V2 = mkTerm "tincture_V2" ;
lin tinder_N = mkTerm "tinder_N" ;
lin tinderbox_N = mkTerm "tinderbox_N" ;
lin tine_N = mkTerm "tine_N" ;
lin tinea_N = mkTerm "tinea_N" ;
lin tined_A = mkTerm "tined_A" ;
lin tineid_N = mkTerm "tineid_N" ;
lin tineoid_N = mkTerm "tineoid_N" ;
lin tinfoil_N = mkTerm "tinfoil_N" ;
lin ting_N = mkTerm "ting_N" ;
lin ting_V = mkTerm "ting_V" ;
lin ting_V2 = mkTerm "ting_V2" ;
lin tinge_N = mkTerm "tinge_N" ;
lin tinge_V2 = mkTerm "tinge_V2" ;
lin tingle_N = mkTerm "tingle_N" ;
lin tingle_V = mkTerm "tingle_V" ;
lin tinker_N = mkTerm "tinker_N" ;
lin tinker_V = mkTerm "tinker_V" ;
lin tinkerer_N = mkTerm "tinkerer_N" ;
lin tinkle_N = mkTerm "tinkle_N" ;
lin tinkle_V = mkTerm "tinkle_V" ;
lin tinkle_V2 = mkTerm "tinkle_V2" ;
lin tinning_N = mkTerm "tinning_N" ;
lin tinnitus_N = mkTerm "tinnitus_N" ;
lin tinny_A = mkTerm "tinny_A" ;
lin tinsel_N = mkTerm "tinsel_N" ;
lin tinsel_V2 = mkTerm "tinsel_V2" ;
lin tinselly_A = mkTerm "tinselly_A" ;
lin tinsmith_N = mkTerm "tinsmith_N" ;
lin tint_N = mkTerm "tint_N" ;
lin tint_V2 = mkTerm "tint_V2" ;
lin tintack_N = mkTerm "tintack_N" ;
lin tinter_N = mkTerm "tinter_N" ;
lin tinting_N = mkTerm "tinting_N" ;
lin tintinnabulation_N = mkTerm "tintinnabulation_N" ;
lin tinware_N = mkTerm "tinware_N" ;
lin tiny_A = mkTerm "tiny_A" ;
lin tip_N = mkTerm "tip_N" ;
lin tip_V = mkTerm "tip_V" ;
lin tip_V2 = mkTerm "tip_V2" ;
lin tip_and_run_A = mkTerm "tip_and_run_A" ;
lin tip_off_N = mkTerm "tip_off_N" ;
lin tip_off_V2 = mkTerm "tip_off_V2" ;
lin tip_over_V2 = mkTerm "tip_over_V2" ;
lin tip_top_A = mkTerm "tip_top_A" ;
lin tip_top_Adv = mkTerm "tip_top_Adv" ;
lin tip_up_A = mkTerm "tip_up_A" ;
lin tipper_N = mkTerm "tipper_N" ;
lin tipperary_PN = mkTerm "tipperary_PN" ;
lin tippet_N = mkTerm "tippet_N" ;
lin tipple_N = mkTerm "tipple_N" ;
lin tipple_V = mkTerm "tipple_V" ;
lin tipple_V2 = mkTerm "tipple_V2" ;
lin tippler_N = mkTerm "tippler_N" ;
lin tipstaff_N = mkTerm "tipstaff_N" ;
lin tipster_N = mkTerm "tipster_N" ;
lin tipsy_A = mkTerm "tipsy_A" ;
lin tiptoe_A = mkTerm "tiptoe_A" ;
lin tiptoe_Adv = mkTerm "tiptoe_Adv" ;
lin tiptoe_N = mkTerm "tiptoe_N" ;
lin tiptoe_V = mkTerm "tiptoe_V" ;
lin tiptop_N = mkTerm "tiptop_N" ;
lin tipu_N = mkTerm "tipu_N" ;
lin tirade_N = mkTerm "tirade_N" ;
lin tiramisu_N = mkTerm "tiramisu_N" ;
lin tire_N = mkTerm "tire_N" ;
lin tire_V = mkTerm "tire_V" ;
lin tire_V2 = mkTerm "tire_V2" ;
lin tire_of_V2 = mkTerm "tire_of_V2" ;
lin tire_out_V2 = mkTerm "tire_out_V2" ;
lin tired_A = mkTerm "tired_A" ;
lin tiredness_N = mkTerm "tiredness_N" ;
lin tireless_A = mkTerm "tireless_A" ;
lin tiresome_A = mkTerm "tiresome_A" ;
lin tiring_Adv = mkTerm "tiring_Adv" ;
lin tiro_N = mkTerm "tiro_N" ;
lin tisane_N = mkTerm "tisane_N" ;
lin tissue_N = mkTerm "tissue_N" ;
lin tit_N = mkTerm "tit_N" ;
lin titan_N = mkTerm "titan_N" ;
lin titanic_A = mkTerm "titanic_A" ;
lin titanium_N = mkTerm "titanium_N" ;
lin titanosaur_N = mkTerm "titanosaur_N" ;
lin titbit_N = mkTerm "titbit_N" ;
lin titer_N = mkTerm "titer_N" ;
lin titfer_N = mkTerm "titfer_N" ;
lin tithe_N = mkTerm "tithe_N" ;
lin tithe_barn_N = mkTerm "tithe_barn_N" ;
lin tither_N = mkTerm "tither_N" ;
lin titi_N = mkTerm "titi_N" ;
lin titillate_V2 = mkTerm "titillate_V2" ;
lin titillating_A = mkTerm "titillating_A" ;
lin titillation_N = mkTerm "titillation_N" ;
lin titivate_V = mkTerm "titivate_V" ;
lin titivate_V2 = mkTerm "titivate_V2" ;
lin titivation_N = mkTerm "titivation_N" ;
lin titlark_N = mkTerm "titlark_N" ;
lin title_N = mkTerm "title_N" ;
lin title_V3 = mkTerm "title_V3" ;
lin title_deed_N = mkTerm "title_deed_N" ;
lin title_page_N = mkTerm "title_page_N" ;
lin title_role_N = mkTerm "title_role_N" ;
lin titled_A = mkTerm "titled_A" ;
lin titmouse_N = mkTerm "titmouse_N" ;
lin titration_N = mkTerm "titration_N" ;
lin titrator_N = mkTerm "titrator_N" ;
lin titter_N = mkTerm "titter_N" ;
lin titter_V = mkTerm "titter_V" ;
lin titterer_N = mkTerm "titterer_N" ;
lin tittivate_V = mkTerm "tittivate_V" ;
lin tittivate_V2 = mkTerm "tittivate_V2" ;
lin tittle_N = mkTerm "tittle_N" ;
lin tittle_tattle_N = mkTerm "tittle_tattle_N" ;
lin tittle_tattle_V = mkTerm "tittle_tattle_V" ;
lin titular_A = mkTerm "titular_A" ;
lin tiverton_PN = mkTerm "tiverton_PN" ;
lin tiyin_N = mkTerm "tiyin_N" ;
lin tizzy_N = mkTerm "tizzy_N" ;
lin tl_PN = mkTerm "tl_PN" ;
lin tnt_N = mkTerm "tnt_N" ;
lin to_Adv = mkTerm "to_Adv" ;
lin to_date_Adv = mkTerm "to_date_Adv" ;
lin to_do_N = mkTerm "to_do_N" ;
lin toad_N = mkTerm "toad_N" ;
lin toad_in_the_hole_N = mkTerm "toad_in_the_hole_N" ;
lin toadfish_N = mkTerm "toadfish_N" ;
lin toadflax_N = mkTerm "toadflax_N" ;
lin toadstool_N = mkTerm "toadstool_N" ;
lin toady_N = mkTerm "toady_N" ;
lin toady_V = mkTerm "toady_V" ;
lin toast_N = mkTerm "toast_N" ;
lin toast_V = mkTerm "toast_V" ;
lin toast_V2 = mkTerm "toast_V2" ;
lin toaster_N = mkTerm "toaster_N" ;
lin toasting_N = mkTerm "toasting_N" ;
lin toasting_fork_N = mkTerm "toasting_fork_N" ;
lin toastmaster_N = mkTerm "toastmaster_N" ;
lin toastrack_N = mkTerm "toastrack_N" ;
lin tobacco_N = mkTerm "tobacco_N" ;
lin tobacconist_N = mkTerm "tobacconist_N" ;
lin tobago_PN = mkTerm "tobago_PN" ;
lin tobagonian_A = mkTerm "tobagonian_A" ;
lin tobagonian_N = mkTerm "tobagonian_N" ;
lin toboggan_N = mkTerm "toboggan_N" ;
lin toboggan_V = mkTerm "toboggan_V" ;
lin tobogganing_N = mkTerm "tobogganing_N" ;
lin tobogganist_N = mkTerm "tobogganist_N" ;
lin tobramycin_N = mkTerm "tobramycin_N" ;
lin toby_N = mkTerm "toby_N" ;
lin toby_PN = mkTerm "toby_PN" ;
lin toby_jug_N = mkTerm "toby_jug_N" ;
lin tocainide_N = mkTerm "tocainide_N" ;
lin toccata_N = mkTerm "toccata_N" ;
lin tocsin_N = mkTerm "tocsin_N" ;
lin tod_A = mkTerm "tod_A" ;
lin tod_N = mkTerm "tod_N" ;
lin today_Adv = mkTerm "today_Adv" ;
lin today_N = mkTerm "today_N" ;
lin toddle_V = mkTerm "toddle_V" ;
lin toddle_off_V = mkTerm "toddle_off_V" ;
lin toddler_N = mkTerm "toddler_N" ;
lin toddy_N = mkTerm "toddy_N" ;
lin todmorden_PN = mkTerm "todmorden_PN" ;
lin tody_N = mkTerm "tody_N" ;
lin toe_N = mkTerm "toe_N" ;
lin toe_V2 = mkTerm "toe_V2" ;
lin toea_N = mkTerm "toea_N" ;
lin toecap_N = mkTerm "toecap_N" ;
lin toed_A = mkTerm "toed_A" ;
lin toehold_N = mkTerm "toehold_N" ;
lin toeless_A = mkTerm "toeless_A" ;
lin toenail_N = mkTerm "toenail_N" ;
lin toetoe_N = mkTerm "toetoe_N" ;
lin toff_N = mkTerm "toff_N" ;
lin toffee_N = mkTerm "toffee_N" ;
lin tog_V2 = mkTerm "tog_V2" ;
lin toga_N = mkTerm "toga_N" ;
lin together_A = mkTerm "together_A" ;
lin together_Adv = mkTerm "together_Adv" ;
lin togetherness_N = mkTerm "togetherness_N" ;
lin toggle_N = mkTerm "toggle_N" ;
lin togo_PN = mkTerm "togo_PN" ;
lin togolese_A = mkTerm "togolese_A" ;
lin togolese_N = mkTerm "togolese_N" ;
lin togs_N = mkTerm "togs_N" ;
lin tohmajärvi_PN = mkTerm "tohmajärvi_PN" ;
lin toholampi_PN = mkTerm "toholampi_PN" ;
lin toijala_PN = mkTerm "toijala_PN" ;
lin toil_N = mkTerm "toil_N" ;
lin toil_V = mkTerm "toil_V" ;
lin toil_V2V = mkTerm "toil_V2V" ;
lin toil_VV = mkTerm "toil_VV" ;
lin toiler_N = mkTerm "toiler_N" ;
lin toilet_N = mkTerm "toilet_N" ;
lin toilet_paper_N = mkTerm "toilet_paper_N" ;
lin toilet_powder_N = mkTerm "toilet_powder_N" ;
lin toilet_roll_N = mkTerm "toilet_roll_N" ;
lin toilet_table_N = mkTerm "toilet_table_N" ;
lin toiletry_N = mkTerm "toiletry_N" ;
lin toilsome_A = mkTerm "toilsome_A" ;
lin toivakka_PN = mkTerm "toivakka_PN" ;
lin tokamak_N = mkTerm "tokamak_N" ;
lin tokay_N = mkTerm "tokay_N" ;
lin toke_N = mkTerm "toke_N" ;
lin token_N = mkTerm "token_N" ;
lin tokyo_PN = mkTerm "tokyo_PN" ;
lin tolazamide_N = mkTerm "tolazamide_N" ;
lin tolazoline_N = mkTerm "tolazoline_N" ;
lin tolbutamide_N = mkTerm "tolbutamide_N" ;
lin tole_N = mkTerm "tole_N" ;
lin tolerable_A = mkTerm "tolerable_A" ;
lin tolerance_N = mkTerm "tolerance_N" ;
lin tolerant_A = mkTerm "tolerant_A" ;
lin tolerate_V2 = mkTerm "tolerate_V2" ;
lin toleration_N = mkTerm "toleration_N" ;
lin toll_N = mkTerm "toll_N" ;
lin toll_V = mkTerm "toll_V" ;
lin toll_V2 = mkTerm "toll_V2" ;
lin tollbar_N = mkTerm "tollbar_N" ;
lin tollbooth_N = mkTerm "tollbooth_N" ;
lin toller_N = mkTerm "toller_N" ;
lin tollgate_N = mkTerm "tollgate_N" ;
lin tollhouse_N = mkTerm "tollhouse_N" ;
lin tollkeeper_N = mkTerm "tollkeeper_N" ;
lin tolu_N = mkTerm "tolu_N" ;
lin toluene_N = mkTerm "toluene_N" ;
lin tom_N = mkTerm "tom_N" ;
lin tom_PN = mkTerm "tom_PN" ;
lin tomahawk_N = mkTerm "tomahawk_N" ;
lin tomahawk_V2 = mkTerm "tomahawk_V2" ;
lin tomalley_N = mkTerm "tomalley_N" ;
lin tomatillo_N = mkTerm "tomatillo_N" ;
lin tomato_N = mkTerm "tomato_N" ;
lin tomb_N = mkTerm "tomb_N" ;
lin tombac_N = mkTerm "tombac_N" ;
lin tombola_N = mkTerm "tombola_N" ;
lin tomboy_N = mkTerm "tomboy_N" ;
lin tombstone_N = mkTerm "tombstone_N" ;
lin tomcat_N = mkTerm "tomcat_N" ;
lin tome_N = mkTerm "tome_N" ;
lin tomentose_A = mkTerm "tomentose_A" ;
lin tomentum_N = mkTerm "tomentum_N" ;
lin tomfool_N = mkTerm "tomfool_N" ;
lin tomfoolery_N = mkTerm "tomfoolery_N" ;
lin tommy_PN = mkTerm "tommy_PN" ;
lin tommy_gun_N = mkTerm "tommy_gun_N" ;
lin tommy_rot_N = mkTerm "tommy_rot_N" ;
lin tomograph_N = mkTerm "tomograph_N" ;
lin tomorrow_Adv = mkTerm "tomorrow_Adv" ;
lin tomorrow_N = mkTerm "tomorrow_N" ;
lin tomtate_N = mkTerm "tomtate_N" ;
lin tomtit_N = mkTerm "tomtit_N" ;
lin tomtom_N = mkTerm "tomtom_N" ;
lin ton_N = mkTerm "ton_N" ;
lin ton_V = mkTerm "ton_V" ;
lin tonal_A = mkTerm "tonal_A" ;
lin tonality_N = mkTerm "tonality_N" ;
lin tonbridge_PN = mkTerm "tonbridge_PN" ;
lin tone_N = mkTerm "tone_N" ;
lin tone_V = mkTerm "tone_V" ;
lin tone_V2 = mkTerm "tone_V2" ;
lin tone_deaf_A = mkTerm "tone_deaf_A" ;
lin tone_down_V2 = mkTerm "tone_down_V2" ;
lin tone_poem_N = mkTerm "tone_poem_N" ;
lin toneless_A = mkTerm "toneless_A" ;
lin toner_N = mkTerm "toner_N" ;
lin tonga_PN = mkTerm "tonga_PN" ;
lin tongan_A = mkTerm "tongan_A" ;
lin tongan_N = mkTerm "tongan_N" ;
lin tongs_N = mkTerm "tongs_N" ;
lin tongue_N = mkTerm "tongue_N" ;
lin tongue_in_cheek_A = mkTerm "tongue_in_cheek_A" ;
lin tongue_in_cheek_Adv = mkTerm "tongue_in_cheek_Adv" ;
lin tongue_tied_A = mkTerm "tongue_tied_A" ;
lin tongue_twister_N = mkTerm "tongue_twister_N" ;
lin tongued_A = mkTerm "tongued_A" ;
lin tonguefish_N = mkTerm "tonguefish_N" ;
lin tongueflower_N = mkTerm "tongueflower_N" ;
lin tongueless_A = mkTerm "tongueless_A" ;
lin tonguelike_A = mkTerm "tonguelike_A" ;
lin tonic_A = mkTerm "tonic_A" ;
lin tonic_N = mkTerm "tonic_N" ;
lin tonic_sol_fa_N = mkTerm "tonic_sol_fa_N" ;
lin tonicity_N = mkTerm "tonicity_N" ;
lin tonight_Adv = mkTerm "tonight_Adv" ;
lin tonight_N = mkTerm "tonight_N" ;
lin tonnage_N = mkTerm "tonnage_N" ;
lin tonne_N = mkTerm "tonne_N" ;
lin tonometer_N = mkTerm "tonometer_N" ;
lin tonometry_N = mkTerm "tonometry_N" ;
lin tons_N = mkTerm "tons_N" ;
lin tonsil_N = mkTerm "tonsil_N" ;
lin tonsillectomy_N = mkTerm "tonsillectomy_N" ;
lin tonsillitis_N = mkTerm "tonsillitis_N" ;
lin tonsorial_A = mkTerm "tonsorial_A" ;
lin tonsure_N = mkTerm "tonsure_N" ;
lin tonsure_V2 = mkTerm "tonsure_V2" ;
lin tontine_N = mkTerm "tontine_N" ;
lin tony_PN = mkTerm "tony_PN" ;
lin tonyrefail_PN = mkTerm "tonyrefail_PN" ;
lin too_Adv = mkTerm "too_Adv" ;
lin tool_N = mkTerm "tool_N" ;
lin tool_V2 = mkTerm "tool_V2" ;
lin tool_up_V2 = mkTerm "tool_up_V2" ;
lin toolbox_N = mkTerm "toolbox_N" ;
lin toolmaker_N = mkTerm "toolmaker_N" ;
lin toolshed_N = mkTerm "toolshed_N" ;
lin toot_N = mkTerm "toot_N" ;
lin toot_V = mkTerm "toot_V" ;
lin toot_V2 = mkTerm "toot_V2" ;
lin tooth_N = mkTerm "tooth_N" ;
lin toothache_N = mkTerm "toothache_N" ;
lin toothbrush_N = mkTerm "toothbrush_N" ;
lin toothed_A = mkTerm "toothed_A" ;
lin toothless_A = mkTerm "toothless_A" ;
lin toothlike_A = mkTerm "toothlike_A" ;
lin toothpaste_N = mkTerm "toothpaste_N" ;
lin toothpick_N = mkTerm "toothpick_N" ;
lin toothpowder_N = mkTerm "toothpowder_N" ;
lin toothsome_A = mkTerm "toothsome_A" ;
lin toothy_A = mkTerm "toothy_A" ;
lin tootle_N = mkTerm "tootle_N" ;
lin tootle_V = mkTerm "tootle_V" ;
lin tootle_off_V = mkTerm "tootle_off_V" ;
lin top_N = mkTerm "top_N" ;
lin top_V2 = mkTerm "top_V2" ;
lin top_boot_N = mkTerm "top_boot_N" ;
lin top_dress_V2 = mkTerm "top_dress_V2" ;
lin top_dressing_N = mkTerm "top_dressing_N" ;
lin top_flight_A = mkTerm "top_flight_A" ;
lin top_heavy_A = mkTerm "top_heavy_A" ;
lin top_hole_A = mkTerm "top_hole_A" ;
lin top_off_V2 = mkTerm "top_off_V2" ;
lin top_out_V = mkTerm "top_out_V" ;
lin top_ranking_A = mkTerm "top_ranking_A" ;
lin top_up_V2 = mkTerm "top_up_V2" ;
lin topaz_N = mkTerm "topaz_N" ;
lin topcoat_N = mkTerm "topcoat_N" ;
lin tope_V = mkTerm "tope_V" ;
lin tope_V2 = mkTerm "tope_V2" ;
lin toper_N = mkTerm "toper_N" ;
lin topgallant_A = mkTerm "topgallant_A" ;
lin topgallant_N = mkTerm "topgallant_N" ;
lin tophus_N = mkTerm "tophus_N" ;
lin topi_N = mkTerm "topi_N" ;
lin topiary_N = mkTerm "topiary_N" ;
lin topic_N = mkTerm "topic_N" ;
lin topical_A = mkTerm "topical_A" ;
lin topicality_N = mkTerm "topicality_N" ;
lin topicalization_N = mkTerm "topicalization_N" ;
lin topknot_N = mkTerm "topknot_N" ;
lin topless_A = mkTerm "topless_A" ;
lin topmast_N = mkTerm "topmast_N" ;
lin topminnow_N = mkTerm "topminnow_N" ;
lin topmost_A = mkTerm "topmost_A" ;
lin topnotch_A = mkTerm "topnotch_A" ;
lin topognosia_N = mkTerm "topognosia_N" ;
lin topographic_A = mkTerm "topographic_A" ;
lin topographical_A = mkTerm "topographical_A" ;
lin topography_N = mkTerm "topography_N" ;
lin topolatry_N = mkTerm "topolatry_N" ;
lin topological_A = mkTerm "topological_A" ;
lin topology_N = mkTerm "topology_N" ;
lin toponymy_N = mkTerm "toponymy_N" ;
lin topos_N = mkTerm "topos_N" ;
lin topper_N = mkTerm "topper_N" ;
lin topping_N = mkTerm "topping_N" ;
lin topple_V = mkTerm "topple_V" ;
lin topple_V2 = mkTerm "topple_V2" ;
lin topsail_N = mkTerm "topsail_N" ;
lin topside_N = mkTerm "topside_N" ;
lin topsoil_N = mkTerm "topsoil_N" ;
lin topspin_N = mkTerm "topspin_N" ;
lin topsy_turvy_A = mkTerm "topsy_turvy_A" ;
lin topsy_turvy_Adv = mkTerm "topsy_turvy_Adv" ;
lin topsy_turvydom_N = mkTerm "topsy_turvydom_N" ;
lin toque_N = mkTerm "toque_N" ;
lin tor_N = mkTerm "tor_N" ;
lin torbay_PN = mkTerm "torbay_PN" ;
lin torch_1_N = mkTerm "torch_1_N" ;
lin torch_2_N = mkTerm "torch_2_N" ;
lin torch_3_N = mkTerm "torch_3_N" ;
lin torch_V2 = mkTerm "torch_V2" ;
lin torch_race_N = mkTerm "torch_race_N" ;
lin torch_singer_N = mkTerm "torch_singer_N" ;
lin torchbearer_N = mkTerm "torchbearer_N" ;
lin torchlight_N = mkTerm "torchlight_N" ;
lin tore_up_V = mkTerm "tore_up_V" ;
lin toreador_N = mkTerm "toreador_N" ;
lin torero_N = mkTerm "torero_N" ;
lin torino_PN = mkTerm "torino_PN" ;
lin torment_N = mkTerm "torment_N" ;
lin torment_V2 = mkTerm "torment_V2" ;
lin tormenter_N = mkTerm "tormenter_N" ;
lin tormentor_N = mkTerm "tormentor_N" ;
lin tornado_N = mkTerm "tornado_N" ;
lin tornio_PN = mkTerm "tornio_PN" ;
lin toroid_N = mkTerm "toroid_N" ;
lin toroidal_A = mkTerm "toroidal_A" ;
lin toronto_PN = mkTerm "toronto_PN" ;
lin torpedo_N = mkTerm "torpedo_N" ;
lin torpedo_V2 = mkTerm "torpedo_V2" ;
lin torpedo_boat_N = mkTerm "torpedo_boat_N" ;
lin torpedo_tube_N = mkTerm "torpedo_tube_N" ;
lin torpid_A = mkTerm "torpid_A" ;
lin torpidity_N = mkTerm "torpidity_N" ;
lin torpidness_N = mkTerm "torpidness_N" ;
lin torpor_N = mkTerm "torpor_N" ;
lin torque_N = mkTerm "torque_N" ;
lin torr_N = mkTerm "torr_N" ;
lin torrent_N = mkTerm "torrent_N" ;
lin torrential_A = mkTerm "torrential_A" ;
lin torrid_A = mkTerm "torrid_A" ;
lin torridity_N = mkTerm "torridity_N" ;
lin torsion_N = mkTerm "torsion_N" ;
lin torso_N = mkTerm "torso_N" ;
lin tort_N = mkTerm "tort_N" ;
lin torte_N = mkTerm "torte_N" ;
lin tortellini_N = mkTerm "tortellini_N" ;
lin torticollis_N = mkTerm "torticollis_N" ;
lin tortilla_N = mkTerm "tortilla_N" ;
lin tortious_A = mkTerm "tortious_A" ;
lin tortoise_N = mkTerm "tortoise_N" ;
lin tortoiseshell_N = mkTerm "tortoiseshell_N" ;
lin tortricid_N = mkTerm "tortricid_N" ;
lin tortuosity_N = mkTerm "tortuosity_N" ;
lin tortuous_A = mkTerm "tortuous_A" ;
lin torture_N = mkTerm "torture_N" ;
lin torture_V2 = mkTerm "torture_V2" ;
lin torturer_N = mkTerm "torturer_N" ;
lin torulose_A = mkTerm "torulose_A" ;
lin torus_N = mkTerm "torus_N" ;
lin tory_N = mkTerm "tory_N" ;
lin tosh_N = mkTerm "tosh_N" ;
lin toss_N = mkTerm "toss_N" ;
lin toss_V = mkTerm "toss_V" ;
lin toss_V2 = mkTerm "toss_V2" ;
lin toss_about_V2 = mkTerm "toss_about_V2" ;
lin toss_around_V2 = mkTerm "toss_around_V2" ;
lin toss_back_V2 = mkTerm "toss_back_V2" ;
lin toss_down_V2 = mkTerm "toss_down_V2" ;
lin toss_for_V2 = mkTerm "toss_for_V2" ;
lin toss_off_V2 = mkTerm "toss_off_V2" ;
lin toss_out_V = mkTerm "toss_out_V" ;
lin toss_up_N = mkTerm "toss_up_N" ;
lin toss_up_V = mkTerm "toss_up_V" ;
lin tosser_N = mkTerm "tosser_N" ;
lin tossup_N = mkTerm "tossup_N" ;
lin tostada_N = mkTerm "tostada_N" ;
lin tot_N = mkTerm "tot_N" ;
lin tot_V = mkTerm "tot_V" ;
lin tot_V2 = mkTerm "tot_V2" ;
lin tot_up_V = mkTerm "tot_up_V" ;
lin total_A = mkTerm "total_A" ;
lin total_N = mkTerm "total_N" ;
lin total_V = mkTerm "total_V" ;
lin total_V2 = mkTerm "total_V2" ;
lin totalitarian_A = mkTerm "totalitarian_A" ;
lin totalitarian_N = mkTerm "totalitarian_N" ;
lin totalitarianism_N = mkTerm "totalitarianism_N" ;
lin totality_N = mkTerm "totality_N" ;
lin totalizator_N = mkTerm "totalizator_N" ;
lin totara_N = mkTerm "totara_N" ;
lin tote_N = mkTerm "tote_N" ;
lin tote_V2 = mkTerm "tote_V2" ;
lin totem_N = mkTerm "totem_N" ;
lin totem_pole_N = mkTerm "totem_pole_N" ;
lin totemic_A = mkTerm "totemic_A" ;
lin totemism_N = mkTerm "totemism_N" ;
lin totemist_N = mkTerm "totemist_N" ;
lin totipotency_N = mkTerm "totipotency_N" ;
lin totipotent_A = mkTerm "totipotent_A" ;
lin totnes_PN = mkTerm "totnes_PN" ;
lin totter_V = mkTerm "totter_V" ;
lin tottery_A = mkTerm "tottery_A" ;
lin toucan_N = mkTerm "toucan_N" ;
lin toucanet_N = mkTerm "toucanet_N" ;
lin touch_N = mkTerm "touch_N" ;
lin touch_V = mkTerm "touch_V" ;
lin touch_V2 = mkTerm "touch_V2" ;
lin touch_and_go_A = mkTerm "touch_and_go_A" ;
lin touch_down_V = mkTerm "touch_down_V" ;
lin touch_for_V3 = mkTerm "touch_for_V3" ;
lin touch_off_V2 = mkTerm "touch_off_V2" ;
lin touch_on_V2 = mkTerm "touch_on_V2" ;
lin touch_type_V = mkTerm "touch_type_V" ;
lin touch_up_V2 = mkTerm "touch_up_V2" ;
lin touch_upon_V2 = mkTerm "touch_upon_V2" ;
lin touchable_A = mkTerm "touchable_A" ;
lin touchback_N = mkTerm "touchback_N" ;
lin touchdown_N = mkTerm "touchdown_N" ;
lin toucher_N = mkTerm "toucher_N" ;
lin touchiness_N = mkTerm "touchiness_N" ;
lin touching_A = mkTerm "touching_A" ;
lin touchline_N = mkTerm "touchline_N" ;
lin touchstone_N = mkTerm "touchstone_N" ;
lin touchy_A = mkTerm "touchy_A" ;
lin tough_A = mkTerm "tough_A" ;
lin tough_N = mkTerm "tough_N" ;
lin toughen_V = mkTerm "toughen_V" ;
lin toughen_V2 = mkTerm "toughen_V2" ;
lin toughie_N = mkTerm "toughie_N" ;
lin toughness_N = mkTerm "toughness_N" ;
lin toulon_PN = mkTerm "toulon_PN" ;
lin toulouse_PN = mkTerm "toulouse_PN" ;
lin toupee_N = mkTerm "toupee_N" ;
lin toupeed_A = mkTerm "toupeed_A" ;
lin tour_N = mkTerm "tour_N" ;
lin tour_V = mkTerm "tour_V" ;
lin tour_V2 = mkTerm "tour_V2" ;
lin tour_de_force_N = mkTerm "tour_de_force_N" ;
lin touraco_N = mkTerm "touraco_N" ;
lin touring_N = mkTerm "touring_N" ;
lin tourism_N = mkTerm "tourism_N" ;
lin tourist_N = mkTerm "tourist_N" ;
lin touristed_A = mkTerm "touristed_A" ;
lin tourmaline_N = mkTerm "tourmaline_N" ;
lin tournament_N = mkTerm "tournament_N" ;
lin tournedos_N = mkTerm "tournedos_N" ;
lin tourney_N = mkTerm "tourney_N" ;
lin tourniquet_N = mkTerm "tourniquet_N" ;
lin tours_PN = mkTerm "tours_PN" ;
lin tourtiere_N = mkTerm "tourtiere_N" ;
lin tousle_V2 = mkTerm "tousle_V2" ;
lin tout_N = mkTerm "tout_N" ;
lin tout_V = mkTerm "tout_V" ;
lin tout_V2 = mkTerm "tout_V2" ;
lin tout_ensemble_Adv = mkTerm "tout_ensemble_Adv" ;
lin tout_ensemble_N = mkTerm "tout_ensemble_N" ;
lin tovarich_N = mkTerm "tovarich_N" ;
lin tow_N = mkTerm "tow_N" ;
lin tow_V2 = mkTerm "tow_V2" ;
lin tow_away_V2 = mkTerm "tow_away_V2" ;
lin toward_Prep = mkTerm "toward_Prep" ;
lin towards_Prep = mkTerm "towards_Prep" ;
lin towel_N = mkTerm "towel_N" ;
lin towel_V2 = mkTerm "towel_V2" ;
lin towel_horse_N = mkTerm "towel_horse_N" ;
lin towel_rack_N = mkTerm "towel_rack_N" ;
lin towel_rail_N = mkTerm "towel_rail_N" ;
lin towelling_N = mkTerm "towelling_N" ;
lin tower_N = mkTerm "tower_N" ;
lin tower_V = mkTerm "tower_V" ;
lin tower_block_N = mkTerm "tower_block_N" ;
lin tower_hamlets_PN = mkTerm "tower_hamlets_PN" ;
lin towhead_N = mkTerm "towhead_N" ;
lin towhee_N = mkTerm "towhee_N" ;
lin towing_line_N = mkTerm "towing_line_N" ;
lin towing_path_N = mkTerm "towing_path_N" ;
lin towing_rope_N = mkTerm "towing_rope_N" ;
lin towline_N = mkTerm "towline_N" ;
lin town_N = mkTerm "town_N" ;
lin town_crier_N = mkTerm "town_crier_N" ;
lin town_gas_N = mkTerm "town_gas_N" ;
lin townee_N = mkTerm "townee_N" ;
lin townie_N = mkTerm "townie_N" ;
lin township_N = mkTerm "township_N" ;
lin townsman_N = mkTerm "townsman_N" ;
lin towpath_N = mkTerm "towpath_N" ;
lin towrope_N = mkTerm "towrope_N" ;
lin toxaemia_N = mkTerm "toxaemia_N" ;
lin toxemia_N = mkTerm "toxemia_N" ;
lin toxic_A = mkTerm "toxic_A" ;
lin toxicity_N = mkTerm "toxicity_N" ;
lin toxicognath_N = mkTerm "toxicognath_N" ;
lin toxicological_A = mkTerm "toxicological_A" ;
lin toxicologist_N = mkTerm "toxicologist_N" ;
lin toxicology_N = mkTerm "toxicology_N" ;
lin toxin_N = mkTerm "toxin_N" ;
lin toxoplasmosis_N = mkTerm "toxoplasmosis_N" ;
lin toy_N = mkTerm "toy_N" ;
lin toy_V = mkTerm "toy_V" ;
lin toy_at_V2 = mkTerm "toy_at_V2" ;
lin toy_over_V2 = mkTerm "toy_over_V2" ;
lin toy_with_V2 = mkTerm "toy_with_V2" ;
lin toyon_N = mkTerm "toyon_N" ;
lin toyshop_N = mkTerm "toyshop_N" ;
lin trabeated_A = mkTerm "trabeated_A" ;
lin trabecula_N = mkTerm "trabecula_N" ;
lin trabecular_A = mkTerm "trabecular_A" ;
lin trace_N = mkTerm "trace_N" ;
lin trace_V = mkTerm "trace_V" ;
lin trace_V2 = mkTerm "trace_V2" ;
lin traceable_A = mkTerm "traceable_A" ;
lin tracer_N = mkTerm "tracer_N" ;
lin tracery_N = mkTerm "tracery_N" ;
lin trachea_N = mkTerm "trachea_N" ;
lin tracheal_A = mkTerm "tracheal_A" ;
lin tracheid_N = mkTerm "tracheid_N" ;
lin tracheitis_N = mkTerm "tracheitis_N" ;
lin tracheobronchitis_N = mkTerm "tracheobronchitis_N" ;
lin tracheostomy_N = mkTerm "tracheostomy_N" ;
lin trachodon_N = mkTerm "trachodon_N" ;
lin trachoma_N = mkTerm "trachoma_N" ;
lin tracing_N = mkTerm "tracing_N" ;
lin tracing_paper_N = mkTerm "tracing_paper_N" ;
lin track_N = mkTerm "track_N" ;
lin track_V = mkTerm "track_V" ;
lin track_V2 = mkTerm "track_V2" ;
lin track_down_V2 = mkTerm "track_down_V2" ;
lin trackball_N = mkTerm "trackball_N" ;
lin tracker_N = mkTerm "tracker_N" ;
lin trackless_A = mkTerm "trackless_A" ;
lin tract_N = mkTerm "tract_N" ;
lin tractability_N = mkTerm "tractability_N" ;
lin tractable_A = mkTerm "tractable_A" ;
lin traction_N = mkTerm "traction_N" ;
lin traction_engine_N = mkTerm "traction_engine_N" ;
lin tractive_A = mkTerm "tractive_A" ;
lin tractor_N = mkTerm "tractor_N" ;
lin tracy_PN = mkTerm "tracy_PN" ;
lin trad_N = mkTerm "trad_N" ;
lin trade_N = mkTerm "trade_N" ;
lin trade_V = mkTerm "trade_V" ;
lin trade_V2 = mkTerm "trade_V2" ;
lin trade_away_V = mkTerm "trade_away_V" ;
lin trade_down_V = mkTerm "trade_down_V" ;
lin trade_in_N = mkTerm "trade_in_N" ;
lin trade_in_V2 = mkTerm "trade_in_V2" ;
lin trade_off_V2 = mkTerm "trade_off_V2" ;
lin trade_on_V2 = mkTerm "trade_on_V2" ;
lin trade_union_N = mkTerm "trade_union_N" ;
lin trade_unionism_N = mkTerm "trade_unionism_N" ;
lin trade_unionist_N = mkTerm "trade_unionist_N" ;
lin trade_up_V = mkTerm "trade_up_V" ;
lin trade_upon_V2 = mkTerm "trade_upon_V2" ;
lin trade_wind_N = mkTerm "trade_wind_N" ;
lin tradecraft_N = mkTerm "tradecraft_N" ;
lin trademark_N = mkTerm "trademark_N" ;
lin trademarked_A = mkTerm "trademarked_A" ;
lin tradeoff_N = mkTerm "tradeoff_N" ;
lin trader_N = mkTerm "trader_N" ;
lin trades_union_N = mkTerm "trades_union_N" ;
lin tradesman_N = mkTerm "tradesman_N" ;
lin tradespeople_N = mkTerm "tradespeople_N" ;
lin trading_A = mkTerm "trading_A" ;
lin trading_N = mkTerm "trading_N" ;
lin tradition_N = mkTerm "tradition_N" ;
lin traditional_A = mkTerm "traditional_A" ;
lin traditionalism_N = mkTerm "traditionalism_N" ;
lin traditionalist_N = mkTerm "traditionalist_N" ;
lin traditionalistic_A = mkTerm "traditionalistic_A" ;
lin traduce_V2 = mkTerm "traduce_V2" ;
lin traducer_N = mkTerm "traducer_N" ;
lin traffic_N = mkTerm "traffic_N" ;
lin traffic_V = mkTerm "traffic_V" ;
lin trafficator_N = mkTerm "trafficator_N" ;
lin trafficker_N = mkTerm "trafficker_N" ;
lin tragacanth_N = mkTerm "tragacanth_N" ;
lin tragedian_N = mkTerm "tragedian_N" ;
lin tragedienne_N = mkTerm "tragedienne_N" ;
lin tragedy_N = mkTerm "tragedy_N" ;
lin tragic_A = mkTerm "tragic_A" ;
lin tragicomedy_N = mkTerm "tragicomedy_N" ;
lin tragicomic_A = mkTerm "tragicomic_A" ;
lin tragopan_N = mkTerm "tragopan_N" ;
lin tragus_N = mkTerm "tragus_N" ;
lin trail_N = mkTerm "trail_N" ;
lin trail_V = mkTerm "trail_V" ;
lin trail_V2 = mkTerm "trail_V2" ;
lin trailblazer_N = mkTerm "trailblazer_N" ;
lin trailer_N = mkTerm "trailer_N" ;
lin trailing_N = mkTerm "trailing_N" ;
lin train_N = mkTerm "train_N" ;
lin train_V = mkTerm "train_V" ;
lin train_V2 = mkTerm "train_V2" ;
lin train_V2V = mkTerm "train_V2V" ;
lin train_up_V2 = mkTerm "train_up_V2" ;
lin trainband_N = mkTerm "trainband_N" ;
lin trainbandsman_N = mkTerm "trainbandsman_N" ;
lin trainbearer_N = mkTerm "trainbearer_N" ;
lin trained_A = mkTerm "trained_A" ;
lin traineeFem_N = mkTerm "traineeFem_N" ;
lin traineeMasc_N = mkTerm "traineeMasc_N" ;
lin traineeship_N = mkTerm "traineeship_N" ;
lin trainer_N = mkTerm "trainer_N" ;
lin training_N = mkTerm "training_N" ;
lin training_college_N = mkTerm "training_college_N" ;
lin training_ship_N = mkTerm "training_ship_N" ;
lin trainload_N = mkTerm "trainload_N" ;
lin trainman_N = mkTerm "trainman_N" ;
lin traipse_V = mkTerm "traipse_V" ;
lin trait_N = mkTerm "trait_N" ;
lin traitor_N = mkTerm "traitor_N" ;
lin traitorous_A = mkTerm "traitorous_A" ;
lin traitress_N = mkTerm "traitress_N" ;
lin trajectory_N = mkTerm "trajectory_N" ;
lin tralee_PN = mkTerm "tralee_PN" ;
lin tram_N = mkTerm "tram_N" ;
lin tram_car_N = mkTerm "tram_car_N" ;
lin tramline_N = mkTerm "tramline_N" ;
lin trammel_N = mkTerm "trammel_N" ;
lin trammel_V2 = mkTerm "trammel_V2" ;
lin tramontane_A = mkTerm "tramontane_A" ;
lin tramontane_N = mkTerm "tramontane_N" ;
lin tramp_N = mkTerm "tramp_N" ;
lin tramp_V = mkTerm "tramp_V" ;
lin tramp_V2 = mkTerm "tramp_V2" ;
lin tramp_steamer_N = mkTerm "tramp_steamer_N" ;
lin trample_N = mkTerm "trample_N" ;
lin trample_V = mkTerm "trample_V" ;
lin trample_V2 = mkTerm "trample_V2" ;
lin trampler_N = mkTerm "trampler_N" ;
lin trampoline_N = mkTerm "trampoline_N" ;
lin tramway_N = mkTerm "tramway_N" ;
lin trance_N = mkTerm "trance_N" ;
lin trancelike_A = mkTerm "trancelike_A" ;
lin tranche_N = mkTerm "tranche_N" ;
lin trandolapril_N = mkTerm "trandolapril_N" ;
lin tranent_PN = mkTerm "tranent_PN" ;
lin tranquil_A = mkTerm "tranquil_A" ;
lin tranquillity_N = mkTerm "tranquillity_N" ;
lin tranquillize_V2 = mkTerm "tranquillize_V2" ;
lin tranquillizer_N = mkTerm "tranquillizer_N" ;
lin trans_PN = mkTerm "trans_PN" ;
lin transact_V2 = mkTerm "transact_V2" ;
lin transactinide_A = mkTerm "transactinide_A" ;
lin transactinide_N = mkTerm "transactinide_N" ;
lin transaction_N = mkTerm "transaction_N" ;
lin transactor_N = mkTerm "transactor_N" ;
lin transalpine_A = mkTerm "transalpine_A" ;
lin transalpine_N = mkTerm "transalpine_N" ;
lin transaminase_N = mkTerm "transaminase_N" ;
lin transamination_N = mkTerm "transamination_N" ;
lin transatlantic_A = mkTerm "transatlantic_A" ;
lin transcend_V2 = mkTerm "transcend_V2" ;
lin transcendence_N = mkTerm "transcendence_N" ;
lin transcendency_N = mkTerm "transcendency_N" ;
lin transcendent_A = mkTerm "transcendent_A" ;
lin transcendental_A = mkTerm "transcendental_A" ;
lin transcendentalism_N = mkTerm "transcendentalism_N" ;
lin transcendentalist_N = mkTerm "transcendentalist_N" ;
lin transcontinental_A = mkTerm "transcontinental_A" ;
lin transcribe_V2 = mkTerm "transcribe_V2" ;
lin transcriber_N = mkTerm "transcriber_N" ;
lin transcript_N = mkTerm "transcript_N" ;
lin transcriptase_N = mkTerm "transcriptase_N" ;
lin transcription_N = mkTerm "transcription_N" ;
lin transcultural_A = mkTerm "transcultural_A" ;
lin transdermal_A = mkTerm "transdermal_A" ;
lin transducer_N = mkTerm "transducer_N" ;
lin transduction_N = mkTerm "transduction_N" ;
lin transept_N = mkTerm "transept_N" ;
lin transeunt_A = mkTerm "transeunt_A" ;
lin transfer_N = mkTerm "transfer_N" ;
lin transfer_V = mkTerm "transfer_V" ;
lin transferability_N = mkTerm "transferability_N" ;
lin transferable_A = mkTerm "transferable_A" ;
lin transferase_N = mkTerm "transferase_N" ;
lin transferee_N = mkTerm "transferee_N" ;
lin transference_N = mkTerm "transference_N" ;
lin transferer_N = mkTerm "transferer_N" ;
lin transferor_N = mkTerm "transferor_N" ;
lin transferrin_N = mkTerm "transferrin_N" ;
lin transfiguration_N = mkTerm "transfiguration_N" ;
lin transfigure_V2 = mkTerm "transfigure_V2" ;
lin transfix_V2 = mkTerm "transfix_V2" ;
lin transform_V2 = mkTerm "transform_V2" ;
lin transformable_A = mkTerm "transformable_A" ;
lin transformation_N = mkTerm "transformation_N" ;
lin transformer_N = mkTerm "transformer_N" ;
lin transfuse_V2 = mkTerm "transfuse_V2" ;
lin transfusion_N = mkTerm "transfusion_N" ;
lin transgender_A = mkTerm "transgender_A" ;
lin transgene_N = mkTerm "transgene_N" ;
lin transgress_V = mkTerm "transgress_V" ;
lin transgress_V2 = mkTerm "transgress_V2" ;
lin transgression_N = mkTerm "transgression_N" ;
lin transgressor_N = mkTerm "transgressor_N" ;
lin transience_N = mkTerm "transience_N" ;
lin transiency_N = mkTerm "transiency_N" ;
lin transient_A = mkTerm "transient_A" ;
lin transient_N = mkTerm "transient_N" ;
lin transistor_N = mkTerm "transistor_N" ;
lin transistorized_A = mkTerm "transistorized_A" ;
lin transit_N = mkTerm "transit_N" ;
lin transition_N = mkTerm "transition_N" ;
lin transitional_A = mkTerm "transitional_A" ;
lin transitive_A = mkTerm "transitive_A" ;
lin transitivity_N = mkTerm "transitivity_N" ;
lin transitory_A = mkTerm "transitory_A" ;
lin translatable_A = mkTerm "translatable_A" ;
lin translate_V = mkTerm "translate_V" ;
lin translate_V2 = mkTerm "translate_V2" ;
lin translation_N = mkTerm "translation_N" ;
lin translational_A = mkTerm "translational_A" ;
lin translator_N = mkTerm "translator_N" ;
lin transliterate_V2 = mkTerm "transliterate_V2" ;
lin transliteration_N = mkTerm "transliteration_N" ;
lin translocation_N = mkTerm "translocation_N" ;
lin translucence_N = mkTerm "translucence_N" ;
lin translucency_N = mkTerm "translucency_N" ;
lin translucent_A = mkTerm "translucent_A" ;
lin translunar_A = mkTerm "translunar_A" ;
lin transmigrante_N = mkTerm "transmigrante_N" ;
lin transmigration_N = mkTerm "transmigration_N" ;
lin transmission_N = mkTerm "transmission_N" ;
lin transmit_V2 = mkTerm "transmit_V2" ;
lin transmittance_N = mkTerm "transmittance_N" ;
lin transmitter_N = mkTerm "transmitter_N" ;
lin transmogrification_N = mkTerm "transmogrification_N" ;
lin transmogrify_V2 = mkTerm "transmogrify_V2" ;
lin transmundane_A = mkTerm "transmundane_A" ;
lin transmutable_A = mkTerm "transmutable_A" ;
lin transmutation_N = mkTerm "transmutation_N" ;
lin transmute_V2 = mkTerm "transmute_V2" ;
lin transoceanic_A = mkTerm "transoceanic_A" ;
lin transom_N = mkTerm "transom_N" ;
lin transom_window_N = mkTerm "transom_window_N" ;
lin transparence_N = mkTerm "transparence_N" ;
lin transparency_N = mkTerm "transparency_N" ;
lin transparent_A = mkTerm "transparent_A" ;
lin transpiration_N = mkTerm "transpiration_N" ;
lin transpire_V = mkTerm "transpire_V" ;
lin transpire_V2 = mkTerm "transpire_V2" ;
lin transplacental_A = mkTerm "transplacental_A" ;
lin transplant_N = mkTerm "transplant_N" ;
lin transplant_V = mkTerm "transplant_V" ;
lin transplant_V2 = mkTerm "transplant_V2" ;
lin transplantable_A = mkTerm "transplantable_A" ;
lin transplantation_N = mkTerm "transplantation_N" ;
lin transplanter_N = mkTerm "transplanter_N" ;
lin transpolar_A = mkTerm "transpolar_A" ;
lin transponder_N = mkTerm "transponder_N" ;
lin transport_N = mkTerm "transport_N" ;
lin transport_V2 = mkTerm "transport_V2" ;
lin transportable_A = mkTerm "transportable_A" ;
lin transportation_N = mkTerm "transportation_N" ;
lin transporter_N = mkTerm "transporter_N" ;
lin transposable_A = mkTerm "transposable_A" ;
lin transpose_N = mkTerm "transpose_N" ;
lin transpose_V2 = mkTerm "transpose_V2" ;
lin transposition_N = mkTerm "transposition_N" ;
lin transposon_N = mkTerm "transposon_N" ;
lin transsexual_N = mkTerm "transsexual_N" ;
lin transsexualism_N = mkTerm "transsexualism_N" ;
lin transship_V2 = mkTerm "transship_V2" ;
lin transshipment_N = mkTerm "transshipment_N" ;
lin transubstantiation_N = mkTerm "transubstantiation_N" ;
lin transudate_N = mkTerm "transudate_N" ;
lin transuranic_A = mkTerm "transuranic_A" ;
lin transverse_A = mkTerm "transverse_A" ;
lin transvestic_A = mkTerm "transvestic_A" ;
lin transvestism_N = mkTerm "transvestism_N" ;
lin transvestite_N = mkTerm "transvestite_N" ;
lin tranylcypromine_N = mkTerm "tranylcypromine_N" ;
lin trap_N = mkTerm "trap_N" ;
lin trap_V = mkTerm "trap_V" ;
lin trap_V2 = mkTerm "trap_V2" ;
lin trap_door_N = mkTerm "trap_door_N" ;
lin trap_shooting_N = mkTerm "trap_shooting_N" ;
lin trapeze_N = mkTerm "trapeze_N" ;
lin trapezium_N = mkTerm "trapezium_N" ;
lin trapezius_N = mkTerm "trapezius_N" ;
lin trapezohedron_N = mkTerm "trapezohedron_N" ;
lin trapezoid_N = mkTerm "trapezoid_N" ;
lin trapezoidal_A = mkTerm "trapezoidal_A" ;
lin trapper_N = mkTerm "trapper_N" ;
lin trappist_N = mkTerm "trappist_N" ;
lin trapshooter_N = mkTerm "trapshooter_N" ;
lin trash_N = mkTerm "trash_N" ;
lin trash_V2 = mkTerm "trash_V2" ;
lin trashy_A = mkTerm "trashy_A" ;
lin trauma_N = mkTerm "trauma_N" ;
lin traumatic_A = mkTerm "traumatic_A" ;
lin traumatology_N = mkTerm "traumatology_N" ;
lin traumatophobia_N = mkTerm "traumatophobia_N" ;
lin travail_N = mkTerm "travail_N" ;
lin trave_N = mkTerm "trave_N" ;
lin travel_N = mkTerm "travel_N" ;
lin travel_V = mkTerm "travel_V" ;
lin travel_V2 = mkTerm "travel_V2" ;
lin travel_soiled_A = mkTerm "travel_soiled_A" ;
lin travel_stained_A = mkTerm "travel_stained_A" ;
lin travel_worn_A = mkTerm "travel_worn_A" ;
lin traveler_N = mkTerm "traveler_N" ;
lin travelled_A = mkTerm "travelled_A" ;
lin traveller_N = mkTerm "traveller_N" ;
lin travelling_N = mkTerm "travelling_N" ;
lin travelogue_N = mkTerm "travelogue_N" ;
lin traversable_A = mkTerm "traversable_A" ;
lin traversal_N = mkTerm "traversal_N" ;
lin traverse_N = mkTerm "traverse_N" ;
lin traverse_V2 = mkTerm "traverse_V2" ;
lin traverser_N = mkTerm "traverser_N" ;
lin travesty_N = mkTerm "travesty_N" ;
lin travesty_V2 = mkTerm "travesty_V2" ;
lin trawl_N = mkTerm "trawl_N" ;
lin trawl_V = mkTerm "trawl_V" ;
lin trawl_V2 = mkTerm "trawl_V2" ;
lin trawl_net_N = mkTerm "trawl_net_N" ;
lin trawler_N = mkTerm "trawler_N" ;
lin tray_N = mkTerm "tray_N" ;
lin tray_cloth_N = mkTerm "tray_cloth_N" ;
lin trazodone_N = mkTerm "trazodone_N" ;
lin treacherous_A = mkTerm "treacherous_A" ;
lin treachery_N = mkTerm "treachery_N" ;
lin treacle_N = mkTerm "treacle_N" ;
lin treacly_A = mkTerm "treacly_A" ;
lin tread_N = mkTerm "tread_N" ;
lin tread_V = mkTerm "tread_V" ;
lin tread_V2 = mkTerm "tread_V2" ;
lin treadle_N = mkTerm "treadle_N" ;
lin treadle_V = mkTerm "treadle_V" ;
lin treadmill_N = mkTerm "treadmill_N" ;
lin treas_N = mkTerm "treas_N" ;
lin treason_N = mkTerm "treason_N" ;
lin treasonable_A = mkTerm "treasonable_A" ;
lin treasonous_A = mkTerm "treasonous_A" ;
lin treasure_N = mkTerm "treasure_N" ;
lin treasure_V2 = mkTerm "treasure_V2" ;
lin treasure_house_N = mkTerm "treasure_house_N" ;
lin treasure_trove_N = mkTerm "treasure_trove_N" ;
lin treasurer_N = mkTerm "treasurer_N" ;
lin treasurership_N = mkTerm "treasurership_N" ;
lin treasury_N = mkTerm "treasury_N" ;
lin treat_N = mkTerm "treat_N" ;
lin treat_V = mkTerm "treat_V" ;
lin treat_V2 = mkTerm "treat_V2" ;
lin treatise_N = mkTerm "treatise_N" ;
lin treatment_N = mkTerm "treatment_N" ;
lin treaty_N = mkTerm "treaty_N" ;
lin treble_A = mkTerm "treble_A" ;
lin treble_N = mkTerm "treble_N" ;
lin treble_V = mkTerm "treble_V" ;
lin treble_V2 = mkTerm "treble_V2" ;
lin tredegar_PN = mkTerm "tredegar_PN" ;
lin tree_N = mkTerm "tree_N" ;
lin tree_V2 = mkTerm "tree_V2" ;
lin tree_fern_N = mkTerm "tree_fern_N" ;
lin treehopper_N = mkTerm "treehopper_N" ;
lin treeless_A = mkTerm "treeless_A" ;
lin treelet_N = mkTerm "treelet_N" ;
lin treenail_N = mkTerm "treenail_N" ;
lin trefoil_N = mkTerm "trefoil_N" ;
lin trek_N = mkTerm "trek_N" ;
lin trek_V = mkTerm "trek_V" ;
lin trek_over_V = mkTerm "trek_over_V" ;
lin trekker_N = mkTerm "trekker_N" ;
lin trellis_N = mkTerm "trellis_N" ;
lin trellis_V2 = mkTerm "trellis_V2" ;
lin tremble_N = mkTerm "tremble_N" ;
lin tremble_V = mkTerm "tremble_V" ;
lin trembles_N = mkTerm "trembles_N" ;
lin tremendous_A = mkTerm "tremendous_A" ;
lin tremolite_N = mkTerm "tremolite_N" ;
lin tremolo_N = mkTerm "tremolo_N" ;
lin tremor_N = mkTerm "tremor_N" ;
lin tremulous_A = mkTerm "tremulous_A" ;
lin trench_N = mkTerm "trench_N" ;
lin trench_V2 = mkTerm "trench_V2" ;
lin trenchancy_N = mkTerm "trenchancy_N" ;
lin trenchant_A = mkTerm "trenchant_A" ;
lin trencher_N = mkTerm "trencher_N" ;
lin trencherman_N = mkTerm "trencherman_N" ;
lin trend_N = mkTerm "trend_N" ;
lin trend_V = mkTerm "trend_V" ;
lin trend_setter_N = mkTerm "trend_setter_N" ;
lin trend_setting_N = mkTerm "trend_setting_N" ;
lin trendsetting_A = mkTerm "trendsetting_A" ;
lin trendy_A = mkTerm "trendy_A" ;
lin trepan_N = mkTerm "trepan_N" ;
lin trepan_V2 = mkTerm "trepan_V2" ;
lin trepang_N = mkTerm "trepang_N" ;
lin trephination_N = mkTerm "trephination_N" ;
lin trephine_N = mkTerm "trephine_N" ;
lin trephine_V2 = mkTerm "trephine_V2" ;
lin trepidation_N = mkTerm "trepidation_N" ;
lin treponema_N = mkTerm "treponema_N" ;
lin trespass_N = mkTerm "trespass_N" ;
lin trespass_V = mkTerm "trespass_V" ;
lin trespasser_N = mkTerm "trespasser_N" ;
lin tress_N = mkTerm "tress_N" ;
lin trestle_N = mkTerm "trestle_N" ;
lin trestle_bridge_N = mkTerm "trestle_bridge_N" ;
lin trestle_table_N = mkTerm "trestle_table_N" ;
lin trestlework_N = mkTerm "trestlework_N" ;
lin trevor_PN = mkTerm "trevor_PN" ;
lin trews_N = mkTerm "trews_N" ;
lin trey_N = mkTerm "trey_N" ;
lin triad_N = mkTerm "triad_N" ;
lin triage_N = mkTerm "triage_N" ;
lin trial_N = mkTerm "trial_N" ;
lin triamcinolone_N = mkTerm "triamcinolone_N" ;
lin triangle_N = mkTerm "triangle_N" ;
lin triangular_A = mkTerm "triangular_A" ;
lin triangularity_N = mkTerm "triangularity_N" ;
lin triangulate_A = mkTerm "triangulate_A" ;
lin triangulation_N = mkTerm "triangulation_N" ;
lin triazine_N = mkTerm "triazine_N" ;
lin triazolam_N = mkTerm "triazolam_N" ;
lin tribadism_N = mkTerm "tribadism_N" ;
lin tribadistic_A = mkTerm "tribadistic_A" ;
lin tribal_A = mkTerm "tribal_A" ;
lin tribalism_N = mkTerm "tribalism_N" ;
lin tribalization_N = mkTerm "tribalization_N" ;
lin tribe_N = mkTerm "tribe_N" ;
lin tribesman_N = mkTerm "tribesman_N" ;
lin tribologist_N = mkTerm "tribologist_N" ;
lin tribology_N = mkTerm "tribology_N" ;
lin tribromoethanol_N = mkTerm "tribromoethanol_N" ;
lin tribulation_N = mkTerm "tribulation_N" ;
lin tribunal_N = mkTerm "tribunal_N" ;
lin tribune_N = mkTerm "tribune_N" ;
lin tribuneship_N = mkTerm "tribuneship_N" ;
lin tributary_A = mkTerm "tributary_A" ;
lin tributary_N = mkTerm "tributary_N" ;
lin tribute_N = mkTerm "tribute_N" ;
lin tributyrin_N = mkTerm "tributyrin_N" ;
lin trice_N = mkTerm "trice_N" ;
lin trice_V2 = mkTerm "trice_V2" ;
lin tricentenary_A = mkTerm "tricentenary_A" ;
lin triceps_N = mkTerm "triceps_N" ;
lin triceratops_N = mkTerm "triceratops_N" ;
lin trichina_N = mkTerm "trichina_N" ;
lin trichinosis_N = mkTerm "trichinosis_N" ;
lin trichion_N = mkTerm "trichion_N" ;
lin trichloride_N = mkTerm "trichloride_N" ;
lin trichlormethiazide_N = mkTerm "trichlormethiazide_N" ;
lin trichloroethylene_N = mkTerm "trichloroethylene_N" ;
lin trichodesmium_N = mkTerm "trichodesmium_N" ;
lin trichomonad_N = mkTerm "trichomonad_N" ;
lin trichomoniasis_N = mkTerm "trichomoniasis_N" ;
lin trichotillomania_N = mkTerm "trichotillomania_N" ;
lin trichotomy_N = mkTerm "trichotomy_N" ;
lin trichroism_N = mkTerm "trichroism_N" ;
lin trichromatic_A = mkTerm "trichromatic_A" ;
lin trichuriasis_N = mkTerm "trichuriasis_N" ;
lin trick_N = mkTerm "trick_N" ;
lin trick_V2 = mkTerm "trick_V2" ;
lin trickery_N = mkTerm "trickery_N" ;
lin trickiness_N = mkTerm "trickiness_N" ;
lin trickle_N = mkTerm "trickle_N" ;
lin trickle_V = mkTerm "trickle_V" ;
lin trickle_V2 = mkTerm "trickle_V2" ;
lin trickle_down_V = mkTerm "trickle_down_V" ;
lin trickster_N = mkTerm "trickster_N" ;
lin tricksy_A = mkTerm "tricksy_A" ;
lin tricky_A = mkTerm "tricky_A" ;
lin triclinic_A = mkTerm "triclinic_A" ;
lin triclinium_N = mkTerm "triclinium_N" ;
lin tricolor_N = mkTerm "tricolor_N" ;
lin tricolour_N = mkTerm "tricolour_N" ;
lin tricorn_N = mkTerm "tricorn_N" ;
lin tricot_N = mkTerm "tricot_N" ;
lin tricuspid_A = mkTerm "tricuspid_A" ;
lin tricycle_N = mkTerm "tricycle_N" ;
lin tricyclic_N = mkTerm "tricyclic_N" ;
lin trident_N = mkTerm "trident_N" ;
lin tridymite_N = mkTerm "tridymite_N" ;
lin triennial_A = mkTerm "triennial_A" ;
lin triennial_N = mkTerm "triennial_N" ;
lin trier_N = mkTerm "trier_N" ;
lin trieste_PN = mkTerm "trieste_PN" ;
lin trifid_A = mkTerm "trifid_A" ;
lin trifle_N = mkTerm "trifle_N" ;
lin trifle_V = mkTerm "trifle_V" ;
lin trifle_V2 = mkTerm "trifle_V2" ;
lin trifler_N = mkTerm "trifler_N" ;
lin trifoliate_A = mkTerm "trifoliate_A" ;
lin trifurcation_N = mkTerm "trifurcation_N" ;
lin trigeminal_N = mkTerm "trigeminal_N" ;
lin trigger_N = mkTerm "trigger_N" ;
lin trigger_V2 = mkTerm "trigger_V2" ;
lin trigger_happy_A = mkTerm "trigger_happy_A" ;
lin triggerfish_N = mkTerm "triggerfish_N" ;
lin triglyceride_N = mkTerm "triglyceride_N" ;
lin trigon_N = mkTerm "trigon_N" ;
lin trigonometric_A = mkTerm "trigonometric_A" ;
lin trigonometrician_N = mkTerm "trigonometrician_N" ;
lin trigonometry_N = mkTerm "trigonometry_N" ;
lin trigram_N = mkTerm "trigram_N" ;
lin trihydroxy_A = mkTerm "trihydroxy_A" ;
lin triiodothyronine_N = mkTerm "triiodothyronine_N" ;
lin trilateral_A = mkTerm "trilateral_A" ;
lin trilby_N = mkTerm "trilby_N" ;
lin trilingual_A = mkTerm "trilingual_A" ;
lin trill_N = mkTerm "trill_N" ;
lin trill_V = mkTerm "trill_V" ;
lin trill_V2 = mkTerm "trill_V2" ;
lin trillion_A = mkTerm "trillion_A" ;
lin trillion_N = mkTerm "trillion_N" ;
lin trillionth_A = mkTerm "trillionth_A" ;
lin trillionth_N = mkTerm "trillionth_N" ;
lin trillium_N = mkTerm "trillium_N" ;
lin trilobate_A = mkTerm "trilobate_A" ;
lin trilobite_N = mkTerm "trilobite_N" ;
lin trilogy_N = mkTerm "trilogy_N" ;
lin trim_A = mkTerm "trim_A" ;
lin trim_N = mkTerm "trim_N" ;
lin trim_V = mkTerm "trim_V" ;
lin trim_V2 = mkTerm "trim_V2" ;
lin trimaran_N = mkTerm "trimaran_N" ;
lin trimer_N = mkTerm "trimer_N" ;
lin trimester_N = mkTerm "trimester_N" ;
lin trimipramine_N = mkTerm "trimipramine_N" ;
lin trimmer_N = mkTerm "trimmer_N" ;
lin trimming_N = mkTerm "trimming_N" ;
lin trimotored_A = mkTerm "trimotored_A" ;
lin tring_PN = mkTerm "tring_PN" ;
lin trinidad_PN = mkTerm "trinidad_PN" ;
lin trinidadian_A = mkTerm "trinidadian_A" ;
lin trinidadian_N = mkTerm "trinidadian_N" ;
lin trinitrotoluene_N = mkTerm "trinitrotoluene_N" ;
lin trinity_N = mkTerm "trinity_N" ;
lin trinket_N = mkTerm "trinket_N" ;
lin trinketry_N = mkTerm "trinketry_N" ;
lin trinucleate_A = mkTerm "trinucleate_A" ;
lin trio_N = mkTerm "trio_N" ;
lin triode_N = mkTerm "triode_N" ;
lin triolein_N = mkTerm "triolein_N" ;
lin triose_N = mkTerm "triose_N" ;
lin trioxide_N = mkTerm "trioxide_N" ;
lin trip_N = mkTerm "trip_N" ;
lin trip_V = mkTerm "trip_V" ;
lin trip_out_V = mkTerm "trip_out_V" ;
lin trip_over_V = mkTerm "trip_over_V" ;
lin trip_over_V2 = mkTerm "trip_over_V2" ;
lin trip_up_V = mkTerm "trip_up_V" ;
lin tripalmitin_N = mkTerm "tripalmitin_N" ;
lin tripartite_A = mkTerm "tripartite_A" ;
lin tripe_N = mkTerm "tripe_N" ;
lin triphammer_N = mkTerm "triphammer_N" ;
lin triphosphopyridine_N = mkTerm "triphosphopyridine_N" ;
lin tripinnate_A = mkTerm "tripinnate_A" ;
lin tripinnatifid_A = mkTerm "tripinnatifid_A" ;
lin triple_A = mkTerm "triple_A" ;
lin triple_N = mkTerm "triple_N" ;
lin triple_V = mkTerm "triple_V" ;
lin triple_V2 = mkTerm "triple_V2" ;
lin triplet_N = mkTerm "triplet_N" ;
lin tripletail_N = mkTerm "tripletail_N" ;
lin triplex_A = mkTerm "triplex_A" ;
lin triplicate_A = mkTerm "triplicate_A" ;
lin triplicate_N = mkTerm "triplicate_N" ;
lin triplicate_V2 = mkTerm "triplicate_V2" ;
lin triplicity_N = mkTerm "triplicity_N" ;
lin tripling_N = mkTerm "tripling_N" ;
lin triploid_A = mkTerm "triploid_A" ;
lin tripod_N = mkTerm "tripod_N" ;
lin tripos_N = mkTerm "tripos_N" ;
lin tripper_N = mkTerm "tripper_N" ;
lin triptych_N = mkTerm "triptych_N" ;
lin triquetral_N = mkTerm "triquetral_N" ;
lin trireme_N = mkTerm "trireme_N" ;
lin trisaccharide_N = mkTerm "trisaccharide_N" ;
lin trisect_V2 = mkTerm "trisect_V2" ;
lin triskaidekaphobia_N = mkTerm "triskaidekaphobia_N" ;
lin triskaidekaphobic_A = mkTerm "triskaidekaphobic_A" ;
lin triskelion_N = mkTerm "triskelion_N" ;
lin trismus_N = mkTerm "trismus_N" ;
lin trisomy_N = mkTerm "trisomy_N" ;
lin tristearin_N = mkTerm "tristearin_N" ;
lin trisyllable_N = mkTerm "trisyllable_N" ;
lin tritanopia_N = mkTerm "tritanopia_N" ;
lin tritanopic_A = mkTerm "tritanopic_A" ;
lin trite_A = mkTerm "trite_A" ;
lin triteness_N = mkTerm "triteness_N" ;
lin tritheism_N = mkTerm "tritheism_N" ;
lin tritheist_N = mkTerm "tritheist_N" ;
lin tritium_N = mkTerm "tritium_N" ;
lin triton_N = mkTerm "triton_N" ;
lin triumph_N = mkTerm "triumph_N" ;
lin triumph_V = mkTerm "triumph_V" ;
lin triumphal_A = mkTerm "triumphal_A" ;
lin triumphant_A = mkTerm "triumphant_A" ;
lin triumvir_N = mkTerm "triumvir_N" ;
lin triumvirate_N = mkTerm "triumvirate_N" ;
lin triune_A = mkTerm "triune_A" ;
lin trivalent_A = mkTerm "trivalent_A" ;
lin trivet_N = mkTerm "trivet_N" ;
lin trivial_A = mkTerm "trivial_A" ;
lin triviality_N = mkTerm "triviality_N" ;
lin trivialize_V2 = mkTerm "trivialize_V2" ;
lin trivium_N = mkTerm "trivium_N" ;
lin trochaic_A = mkTerm "trochaic_A" ;
lin trochanter_N = mkTerm "trochanter_N" ;
lin trochee_N = mkTerm "trochee_N" ;
lin trochlear_N = mkTerm "trochlear_N" ;
lin troglodyte_N = mkTerm "troglodyte_N" ;
lin trogon_N = mkTerm "trogon_N" ;
lin troika_N = mkTerm "troika_N" ;
lin trojan_A = mkTerm "trojan_A" ;
lin trojan_N = mkTerm "trojan_N" ;
lin troll_N = mkTerm "troll_N" ;
lin troll_V = mkTerm "troll_V" ;
lin troll_V2 = mkTerm "troll_V2" ;
lin trolley_N = mkTerm "trolley_N" ;
lin trolley_car_N = mkTerm "trolley_car_N" ;
lin trolleybus_N = mkTerm "trolleybus_N" ;
lin trollop_N = mkTerm "trollop_N" ;
lin trombiculiasis_N = mkTerm "trombiculiasis_N" ;
lin trombiculid_N = mkTerm "trombiculid_N" ;
lin trombidiid_N = mkTerm "trombidiid_N" ;
lin trombone_N = mkTerm "trombone_N" ;
lin trombonist_N = mkTerm "trombonist_N" ;
lin trompillo_N = mkTerm "trompillo_N" ;
lin troon_PN = mkTerm "troon_PN" ;
lin troop_N = mkTerm "troop_N" ;
lin troop_V = mkTerm "troop_V" ;
lin troop_V2 = mkTerm "troop_V2" ;
lin troop_carrier_N = mkTerm "troop_carrier_N" ;
lin trooper_N = mkTerm "trooper_N" ;
lin troopship_N = mkTerm "troopship_N" ;
lin trope_N = mkTerm "trope_N" ;
lin trophic_A = mkTerm "trophic_A" ;
lin trophobiosis_N = mkTerm "trophobiosis_N" ;
lin trophoblast_N = mkTerm "trophoblast_N" ;
lin trophoblastic_A = mkTerm "trophoblastic_A" ;
lin trophotropic_A = mkTerm "trophotropic_A" ;
lin trophotropism_N = mkTerm "trophotropism_N" ;
lin trophozoite_N = mkTerm "trophozoite_N" ;
lin trophy_N = mkTerm "trophy_N" ;
lin tropic_N = mkTerm "tropic_N" ;
lin tropical_A = mkTerm "tropical_A" ;
lin tropism_N = mkTerm "tropism_N" ;
lin troponym_N = mkTerm "troponym_N" ;
lin troponymy_N = mkTerm "troponymy_N" ;
lin tropopause_N = mkTerm "tropopause_N" ;
lin troposphere_N = mkTerm "troposphere_N" ;
lin trot_N = mkTerm "trot_N" ;
lin trot_V = mkTerm "trot_V" ;
lin trot_V2 = mkTerm "trot_V2" ;
lin trot_off_V = mkTerm "trot_off_V" ;
lin trot_off_to_V2 = mkTerm "trot_off_to_V2" ;
lin trot_out_V2 = mkTerm "trot_out_V2" ;
lin troth_N = mkTerm "troth_N" ;
lin trotter_N = mkTerm "trotter_N" ;
lin troubadour_N = mkTerm "troubadour_N" ;
lin trouble_N = mkTerm "trouble_N" ;
lin trouble_V2 = mkTerm "trouble_V2" ;
lin troubled_A = mkTerm "troubled_A" ;
lin troublemaker_N = mkTerm "troublemaker_N" ;
lin troubleshooter_N = mkTerm "troubleshooter_N" ;
lin troublesome_A = mkTerm "troublesome_A" ;
lin troublesomeness_N = mkTerm "troublesomeness_N" ;
lin troublous_A = mkTerm "troublous_A" ;
lin trough_N = mkTerm "trough_N" ;
lin trough_V = mkTerm "trough_V" ;
lin trough_out_V = mkTerm "trough_out_V" ;
lin trounce_V2 = mkTerm "trounce_V2" ;
lin trouncing_N = mkTerm "trouncing_N" ;
lin troupe_N = mkTerm "troupe_N" ;
lin trouper_N = mkTerm "trouper_N" ;
lin trouser_N = mkTerm "trouser_N" ;
lin trousseau_N = mkTerm "trousseau_N" ;
lin trout_N = mkTerm "trout_N" ;
lin trove_N = mkTerm "trove_N" ;
lin trowbridge_PN = mkTerm "trowbridge_PN" ;
lin trowel_N = mkTerm "trowel_N" ;
lin troy_N = mkTerm "troy_N" ;
lin truancy_N = mkTerm "truancy_N" ;
lin truant_A = mkTerm "truant_A" ;
lin truant_N = mkTerm "truant_N" ;
lin truce_N = mkTerm "truce_N" ;
lin truck_N = mkTerm "truck_N" ;
lin truckage_N = mkTerm "truckage_N" ;
lin truckle_N = mkTerm "truckle_N" ;
lin truckle_V = mkTerm "truckle_V" ;
lin truckle_bed_N = mkTerm "truckle_bed_N" ;
lin truckling_N = mkTerm "truckling_N" ;
lin truculence_N = mkTerm "truculence_N" ;
lin truculency_N = mkTerm "truculency_N" ;
lin truculent_A = mkTerm "truculent_A" ;
lin trudge_N = mkTerm "trudge_N" ;
lin trudge_V = mkTerm "trudge_V" ;
lin trudger_N = mkTerm "trudger_N" ;
lin true_A = mkTerm "true_A" ;
lin true_N = mkTerm "true_N" ;
lin true_V2 = mkTerm "true_V2" ;
lin true_blue_A = mkTerm "true_blue_A" ;
lin true_blue_N = mkTerm "true_blue_N" ;
lin true_hearted_A = mkTerm "true_hearted_A" ;
lin truelove_N = mkTerm "truelove_N" ;
lin trueness_N = mkTerm "trueness_N" ;
lin truffle_N = mkTerm "truffle_N" ;
lin truism_N = mkTerm "truism_N" ;
lin truly_AdA = mkTerm "truly_AdA" ;
lin trump_N = mkTerm "trump_N" ;
lin trump_V = mkTerm "trump_V" ;
lin trump_V2 = mkTerm "trump_V2" ;
lin trump_up_V = mkTerm "trump_up_V" ;
lin trumpery_A = mkTerm "trumpery_A" ;
lin trumpet_N = mkTerm "trumpet_N" ;
lin trumpet_V = mkTerm "trumpet_V" ;
lin trumpet_V2 = mkTerm "trumpet_V2" ;
lin trumpeter_N = mkTerm "trumpeter_N" ;
lin trumpetfish_N = mkTerm "trumpetfish_N" ;
lin trumpetwood_N = mkTerm "trumpetwood_N" ;
lin truncate_A = mkTerm "truncate_A" ;
lin truncate_V2 = mkTerm "truncate_V2" ;
lin truncation_N = mkTerm "truncation_N" ;
lin truncheon_N = mkTerm "truncheon_N" ;
lin trundle_N = mkTerm "trundle_N" ;
lin trundle_V = mkTerm "trundle_V" ;
lin trundle_V2 = mkTerm "trundle_V2" ;
lin trunk_N = mkTerm "trunk_N" ;
lin trunk_call_N = mkTerm "trunk_call_N" ;
lin trunk_line_N = mkTerm "trunk_line_N" ;
lin trunk_road_N = mkTerm "trunk_road_N" ;
lin trunking_N = mkTerm "trunking_N" ;
lin truro_PN = mkTerm "truro_PN" ;
lin truss_N = mkTerm "truss_N" ;
lin truss_V2 = mkTerm "truss_V2" ;
lin trust_N = mkTerm "trust_N" ;
lin trust_V2 = mkTerm "trust_V2" ;
lin trust_VS = mkTerm "trust_VS" ;
lin trustbuster_N = mkTerm "trustbuster_N" ;
lin trustee_N = mkTerm "trustee_N" ;
lin trusteeship_N = mkTerm "trusteeship_N" ;
lin trustful_A = mkTerm "trustful_A" ;
lin trustworthiness_N = mkTerm "trustworthiness_N" ;
lin trustworthy_A = mkTerm "trustworthy_A" ;
lin trusty_A = mkTerm "trusty_A" ;
lin trusty_N = mkTerm "trusty_N" ;
lin truth_N = mkTerm "truth_N" ;
lin truthful_A = mkTerm "truthful_A" ;
lin truthfulness_N = mkTerm "truthfulness_N" ;
lin try_N = mkTerm "try_N" ;
lin try_V = mkTerm "try_V" ;
lin try_V2 = mkTerm "try_V2" ;
lin try_VV = mkTerm "try_VV" ;
lin try_back_V = mkTerm "try_back_V" ;
lin try_for_V2 = mkTerm "try_for_V2" ;
lin try_it_on_V = mkTerm "try_it_on_V" ;
lin try_on_N = mkTerm "try_on_N" ;
lin try_on_V2 = mkTerm "try_on_V2" ;
lin try_out_N = mkTerm "try_out_N" ;
lin try_out_V = mkTerm "try_out_V" ;
lin try_out_V2 = mkTerm "try_out_V2" ;
lin try_out_for_V2 = mkTerm "try_out_for_V2" ;
lin trypsin_N = mkTerm "trypsin_N" ;
lin trypsinogen_N = mkTerm "trypsinogen_N" ;
lin tryptophan_N = mkTerm "tryptophan_N" ;
lin tryst_N = mkTerm "tryst_N" ;
lin tsar_N = mkTerm "tsar_N" ;
lin tsarina_N = mkTerm "tsarina_N" ;
lin tsetse_N = mkTerm "tsetse_N" ;
lin tsetse_fly_N = mkTerm "tsetse_fly_N" ;
lin tsinan_PN = mkTerm "tsinan_PN" ;
lin tsingtao_PN = mkTerm "tsingtao_PN" ;
lin tsitsihar_PN = mkTerm "tsitsihar_PN" ;
lin tsoris_N = mkTerm "tsoris_N" ;
lin tsunami_N = mkTerm "tsunami_N" ;
lin tsuris_N = mkTerm "tsuris_N" ;
lin tswana_A = mkTerm "tswana_A" ;
lin tswana_N = mkTerm "tswana_N" ;
lin tuatara_N = mkTerm "tuatara_N" ;
lin tub_N = mkTerm "tub_N" ;
lin tub_thumper_N = mkTerm "tub_thumper_N" ;
lin tuba_N = mkTerm "tuba_N" ;
lin tubal_A = mkTerm "tubal_A" ;
lin tubby_A = mkTerm "tubby_A" ;
lin tube_N = mkTerm "tube_N" ;
lin tube_well_N = mkTerm "tube_well_N" ;
lin tubed_A = mkTerm "tubed_A" ;
lin tubeless_A = mkTerm "tubeless_A" ;
lin tubeless_N = mkTerm "tubeless_N" ;
lin tuber_N = mkTerm "tuber_N" ;
lin tubercle_N = mkTerm "tubercle_N" ;
lin tubercular_A = mkTerm "tubercular_A" ;
lin tuberculate_A = mkTerm "tuberculate_A" ;
lin tuberculin_N = mkTerm "tuberculin_N" ;
lin tuberculoid_A = mkTerm "tuberculoid_A" ;
lin tuberculosis_N = mkTerm "tuberculosis_N" ;
lin tuberculous_A = mkTerm "tuberculous_A" ;
lin tuberose_N = mkTerm "tuberose_N" ;
lin tuberosity_N = mkTerm "tuberosity_N" ;
lin tuberous_A = mkTerm "tuberous_A" ;
lin tubful_N = mkTerm "tubful_N" ;
lin tubing_N = mkTerm "tubing_N" ;
lin tubocurarine_N = mkTerm "tubocurarine_N" ;
lin tubular_A = mkTerm "tubular_A" ;
lin tubule_N = mkTerm "tubule_N" ;
lin tuc_N = mkTerm "tuc_N" ;
lin tuck_N = mkTerm "tuck_N" ;
lin tuck_V = mkTerm "tuck_V" ;
lin tuck_V2 = mkTerm "tuck_V2" ;
lin tuck_away_V2 = mkTerm "tuck_away_V2" ;
lin tuck_in_N = mkTerm "tuck_in_N" ;
lin tuck_in_V = mkTerm "tuck_in_V" ;
lin tuck_in_V2 = mkTerm "tuck_in_V2" ;
lin tuck_into_V2 = mkTerm "tuck_into_V2" ;
lin tuck_shop_N = mkTerm "tuck_shop_N" ;
lin tuck_up_V2 = mkTerm "tuck_up_V2" ;
lin tucker_N = mkTerm "tucker_N" ;
lin tudung_N = mkTerm "tudung_N" ;
lin tues_PN = mkTerm "tues_PN" ;
lin tufa_N = mkTerm "tufa_N" ;
lin tuff_N = mkTerm "tuff_N" ;
lin tuft_N = mkTerm "tuft_N" ;
lin tufted_A = mkTerm "tufted_A" ;
lin tug_N = mkTerm "tug_N" ;
lin tug_V = mkTerm "tug_V" ;
lin tug_V2 = mkTerm "tug_V2" ;
lin tugboat_N = mkTerm "tugboat_N" ;
lin tugrik_N = mkTerm "tugrik_N" ;
lin tuille_N = mkTerm "tuille_N" ;
lin tuition_N = mkTerm "tuition_N" ;
lin tularemia_N = mkTerm "tularemia_N" ;
lin tulip_N = mkTerm "tulip_N" ;
lin tulipwood_N = mkTerm "tulipwood_N" ;
lin tulle_N = mkTerm "tulle_N" ;
lin tullibody_PN = mkTerm "tullibody_PN" ;
lin tumble_N = mkTerm "tumble_N" ;
lin tumble_V = mkTerm "tumble_V" ;
lin tumble_V2 = mkTerm "tumble_V2" ;
lin tumble_down_A = mkTerm "tumble_down_A" ;
lin tumblebug_N = mkTerm "tumblebug_N" ;
lin tumbler_N = mkTerm "tumbler_N" ;
lin tumbleweed_N = mkTerm "tumbleweed_N" ;
lin tumbrel_N = mkTerm "tumbrel_N" ;
lin tumbril_N = mkTerm "tumbril_N" ;
lin tumefaction_N = mkTerm "tumefaction_N" ;
lin tumescence_N = mkTerm "tumescence_N" ;
lin tumescent_A = mkTerm "tumescent_A" ;
lin tumid_A = mkTerm "tumid_A" ;
lin tumidity_N = mkTerm "tumidity_N" ;
lin tummy_N = mkTerm "tummy_N" ;
lin tumor_N = mkTerm "tumor_N" ;
lin tumour_N = mkTerm "tumour_N" ;
lin tumult_N = mkTerm "tumult_N" ;
lin tumultuous_A = mkTerm "tumultuous_A" ;
lin tumulus_N = mkTerm "tumulus_N" ;
lin tun_N = mkTerm "tun_N" ;
lin tuna_N = mkTerm "tuna_N" ;
lin tunaburger_N = mkTerm "tunaburger_N" ;
lin tunbridge_wells_PN = mkTerm "tunbridge_wells_PN" ;
lin tundra_N = mkTerm "tundra_N" ;
lin tune_N = mkTerm "tune_N" ;
lin tune_V = mkTerm "tune_V" ;
lin tune_V2 = mkTerm "tune_V2" ;
lin tune_in_V = mkTerm "tune_in_V" ;
lin tune_in_to_V2 = mkTerm "tune_in_to_V2" ;
lin tune_out_V2 = mkTerm "tune_out_V2" ;
lin tune_up_V2 = mkTerm "tune_up_V2" ;
lin tuneful_A = mkTerm "tuneful_A" ;
lin tunefulness_N = mkTerm "tunefulness_N" ;
lin tuneless_A = mkTerm "tuneless_A" ;
lin tuner_N = mkTerm "tuner_N" ;
lin tung_oil_N = mkTerm "tung_oil_N" ;
lin tungstate_N = mkTerm "tungstate_N" ;
lin tungsten_N = mkTerm "tungsten_N" ;
lin tunic_N = mkTerm "tunic_N" ;
lin tunicate_N = mkTerm "tunicate_N" ;
lin tuning_N = mkTerm "tuning_N" ;
lin tuning_fork_N = mkTerm "tuning_fork_N" ;
lin tunis_PN = mkTerm "tunis_PN" ;
lin tunisia_PN = mkTerm "tunisia_PN" ;
lin tunisian_A = mkTerm "tunisian_A" ;
lin tunisian_N = mkTerm "tunisian_N" ;
lin tunnel_N = mkTerm "tunnel_N" ;
lin tunnel_V = mkTerm "tunnel_V" ;
lin tunnel_V2 = mkTerm "tunnel_V2" ;
lin tunny_N = mkTerm "tunny_N" ;
lin tup_N = mkTerm "tup_N" ;
lin tupelo_N = mkTerm "tupelo_N" ;
lin tupik_N = mkTerm "tupik_N" ;
lin tuppence_N = mkTerm "tuppence_N" ;
lin tuppenny_A = mkTerm "tuppenny_A" ;
lin turban_N = mkTerm "turban_N" ;
lin turbaned_A = mkTerm "turbaned_A" ;
lin turbid_A = mkTerm "turbid_A" ;
lin turbidity_N = mkTerm "turbidity_N" ;
lin turbidness_N = mkTerm "turbidness_N" ;
lin turbinate_A = mkTerm "turbinate_A" ;
lin turbine_N = mkTerm "turbine_N" ;
lin turbogenerator_N = mkTerm "turbogenerator_N" ;
lin turbojet_N = mkTerm "turbojet_N" ;
lin turboprop_N = mkTerm "turboprop_N" ;
lin turbot_N = mkTerm "turbot_N" ;
lin turbulence_N = mkTerm "turbulence_N" ;
lin turbulent_A = mkTerm "turbulent_A" ;
lin turd_N = mkTerm "turd_N" ;
lin tureen_N = mkTerm "tureen_N" ;
lin turenki_PN = mkTerm "turenki_PN" ;
lin turf_N = mkTerm "turf_N" ;
lin turf_V2 = mkTerm "turf_V2" ;
lin turgid_A = mkTerm "turgid_A" ;
lin turgidity_N = mkTerm "turgidity_N" ;
lin turgor_N = mkTerm "turgor_N" ;
lin turin_PN = mkTerm "turin_PN" ;
lin turk_N = mkTerm "turk_N" ;
lin turkey_N = mkTerm "turkey_N" ;
lin turkey_PN = mkTerm "turkey_PN" ;
lin turkishFem_N = mkTerm "turkishFem_N" ;
lin turkishMasc_N = mkTerm "turkishMasc_N" ;
lin turkish_A = mkTerm "turkish_A" ;
lin turku_PN = mkTerm "turku_PN" ;
lin turmeric_N = mkTerm "turmeric_N" ;
lin turmoil_N = mkTerm "turmoil_N" ;
lin turn_N = mkTerm "turn_N" ;
lin turn_V = mkTerm "turn_V" ;
lin turn_V2 = mkTerm "turn_V2" ;
lin turn_VA = mkTerm "turn_VA" ;
lin turn_against_V2 = mkTerm "turn_against_V2" ;
lin turn_around_V2 = mkTerm "turn_around_V2" ;
lin turn_away_V = mkTerm "turn_away_V" ;
lin turn_away_V2 = mkTerm "turn_away_V2" ;
lin turn_back_V = mkTerm "turn_back_V" ;
lin turn_down_V2 = mkTerm "turn_down_V2" ;
lin turn_in_V = mkTerm "turn_in_V" ;
lin turn_in_V2 = mkTerm "turn_in_V2" ;
lin turn_into_V2 = mkTerm "turn_into_V2" ;
lin turn_off_N = mkTerm "turn_off_N" ;
lin turn_off_V2 = mkTerm "turn_off_V2" ;
lin turn_on_N = mkTerm "turn_on_N" ;
lin turn_on_V = mkTerm "turn_on_V" ;
lin turn_on_V2 = mkTerm "turn_on_V2" ;
lin turn_out_N = mkTerm "turn_out_N" ;
lin turn_out_V = mkTerm "turn_out_V" ;
lin turn_out_V2 = mkTerm "turn_out_V2" ;
lin turn_over_V = mkTerm "turn_over_V" ;
lin turn_over_V2 = mkTerm "turn_over_V2" ;
lin turn_round_N = mkTerm "turn_round_N" ;
lin turn_to_V2 = mkTerm "turn_to_V2" ;
lin turn_up_N = mkTerm "turn_up_N" ;
lin turn_up_V = mkTerm "turn_up_V" ;
lin turn_up_V2 = mkTerm "turn_up_V2" ;
lin turnaround_N = mkTerm "turnaround_N" ;
lin turnbuckle_N = mkTerm "turnbuckle_N" ;
lin turncoat_N = mkTerm "turncoat_N" ;
lin turncock_N = mkTerm "turncock_N" ;
lin turner_N = mkTerm "turner_N" ;
lin turnery_N = mkTerm "turnery_N" ;
lin turning_N = mkTerm "turning_N" ;
lin turning_point_N = mkTerm "turning_point_N" ;
lin turnip_N = mkTerm "turnip_N" ;
lin turnkey_N = mkTerm "turnkey_N" ;
lin turnover_N = mkTerm "turnover_N" ;
lin turnpike_N = mkTerm "turnpike_N" ;
lin turnspit_N = mkTerm "turnspit_N" ;
lin turnstile_N = mkTerm "turnstile_N" ;
lin turnstone_N = mkTerm "turnstone_N" ;
lin turntable_N = mkTerm "turntable_N" ;
lin turnverein_N = mkTerm "turnverein_N" ;
lin turpentine_N = mkTerm "turpentine_N" ;
lin turpitude_N = mkTerm "turpitude_N" ;
lin turps_N = mkTerm "turps_N" ;
lin turquoise_N = mkTerm "turquoise_N" ;
lin turreae_N = mkTerm "turreae_N" ;
lin turret_N = mkTerm "turret_N" ;
lin turtle_N = mkTerm "turtle_N" ;
lin turtledove_N = mkTerm "turtledove_N" ;
lin turtleneck_A = mkTerm "turtleneck_A" ;
lin turtleneck_N = mkTerm "turtleneck_N" ;
lin turtlenecked_A = mkTerm "turtlenecked_A" ;
lin turtler_N = mkTerm "turtler_N" ;
lin tushery_N = mkTerm "tushery_N" ;
lin tusk_N = mkTerm "tusk_N" ;
lin tusked_A = mkTerm "tusked_A" ;
lin tusker_N = mkTerm "tusker_N" ;
lin tussah_N = mkTerm "tussah_N" ;
lin tussle_N = mkTerm "tussle_N" ;
lin tussle_V = mkTerm "tussle_V" ;
lin tussock_N = mkTerm "tussock_N" ;
lin tut_V2 = mkTerm "tut_V2" ;
lin tutee_N = mkTerm "tutee_N" ;
lin tutelage_N = mkTerm "tutelage_N" ;
lin tutelary_A = mkTerm "tutelary_A" ;
lin tutor_N = mkTerm "tutor_N" ;
lin tutor_V2 = mkTerm "tutor_V2" ;
lin tutorial_A = mkTerm "tutorial_A" ;
lin tutorial_N = mkTerm "tutorial_N" ;
lin tutorship_N = mkTerm "tutorship_N" ;
lin tutti_frutti_N = mkTerm "tutti_frutti_N" ;
lin tutu_N = mkTerm "tutu_N" ;
lin tuulos_PN = mkTerm "tuulos_PN" ;
lin tuupovaara_PN = mkTerm "tuupovaara_PN" ;
lin tuusniemi_PN = mkTerm "tuusniemi_PN" ;
lin tuusula_PN = mkTerm "tuusula_PN" ;
lin tuxedo_N = mkTerm "tuxedo_N" ;
lin tuxedoed_A = mkTerm "tuxedoed_A" ;
lin tv_N = mkTerm "tv_N" ;
lin twaddle_N = mkTerm "twaddle_N" ;
lin twaddle_V = mkTerm "twaddle_V" ;
lin twaddler_N = mkTerm "twaddler_N" ;
lin twain_N = mkTerm "twain_N" ;
lin twang_N = mkTerm "twang_N" ;
lin twang_V = mkTerm "twang_V" ;
lin twang_V2 = mkTerm "twang_V2" ;
lin twayblade_N = mkTerm "twayblade_N" ;
lin tweak_N = mkTerm "tweak_N" ;
lin tweak_V2 = mkTerm "tweak_V2" ;
lin twee_A = mkTerm "twee_A" ;
lin tweed_N = mkTerm "tweed_N" ;
lin tweediness_N = mkTerm "tweediness_N" ;
lin tweedy_A = mkTerm "tweedy_A" ;
lin tween_Adv = mkTerm "tween_Adv" ;
lin tween_decks_Adv = mkTerm "tween_decks_Adv" ;
lin tweet_N = mkTerm "tweet_N" ;
lin tweet_V = mkTerm "tweet_V" ;
lin tweeter_N = mkTerm "tweeter_N" ;
lin twelfth_night_N = mkTerm "twelfth_night_N" ;
lin twelfth_night_PN = mkTerm "twelfth_night_PN" ;
lin twelvemonth_N = mkTerm "twelvemonth_N" ;
lin twerp_N = mkTerm "twerp_N" ;
lin twice_Adv = mkTerm "twice_Adv" ;
lin twiddle_N = mkTerm "twiddle_N" ;
lin twiddle_V = mkTerm "twiddle_V" ;
lin twiddle_V2 = mkTerm "twiddle_V2" ;
lin twiddler_N = mkTerm "twiddler_N" ;
lin twiddly_A = mkTerm "twiddly_A" ;
lin twig_N = mkTerm "twig_N" ;
lin twig_V = mkTerm "twig_V" ;
lin twig_V2 = mkTerm "twig_V2" ;
lin twiggy_A = mkTerm "twiggy_A" ;
lin twilight_N = mkTerm "twilight_N" ;
lin twilit_A = mkTerm "twilit_A" ;
lin twill_N = mkTerm "twill_N" ;
lin twilled_A = mkTerm "twilled_A" ;
lin twin_A = mkTerm "twin_A" ;
lin twin_N = mkTerm "twin_N" ;
lin twin_V2 = mkTerm "twin_V2" ;
lin twinberry_N = mkTerm "twinberry_N" ;
lin twine_N = mkTerm "twine_N" ;
lin twine_V = mkTerm "twine_V" ;
lin twine_V2 = mkTerm "twine_V2" ;
lin twiner_N = mkTerm "twiner_N" ;
lin twinflower_N = mkTerm "twinflower_N" ;
lin twinge_N = mkTerm "twinge_N" ;
lin twinjet_N = mkTerm "twinjet_N" ;
lin twinkle_N = mkTerm "twinkle_N" ;
lin twinkle_V = mkTerm "twinkle_V" ;
lin twinkler_N = mkTerm "twinkler_N" ;
lin twinkling_N = mkTerm "twinkling_N" ;
lin twins_N = mkTerm "twins_N" ;
lin twirl_N = mkTerm "twirl_N" ;
lin twirl_V = mkTerm "twirl_V" ;
lin twirl_V2 = mkTerm "twirl_V2" ;
lin twirlingly_Adv = mkTerm "twirlingly_Adv" ;
lin twist_N = mkTerm "twist_N" ;
lin twist_V2 = mkTerm "twist_V2" ;
lin twist_together_V = mkTerm "twist_together_V" ;
lin twisted_A = mkTerm "twisted_A" ;
lin twister_N = mkTerm "twister_N" ;
lin twisty_A = mkTerm "twisty_A" ;
lin twit_N = mkTerm "twit_N" ;
lin twit_V2 = mkTerm "twit_V2" ;
lin twitch_N = mkTerm "twitch_N" ;
lin twitch_V = mkTerm "twitch_V" ;
lin twitch_V2 = mkTerm "twitch_V2" ;
lin twitter_N = mkTerm "twitter_N" ;
lin twitter_V = mkTerm "twitter_V" ;
lin twitterer_N = mkTerm "twitterer_N" ;
lin twixt_Prep = mkTerm "twixt_Prep" ;
lin two_a_penny_A = mkTerm "two_a_penny_A" ;
lin two_edged_A = mkTerm "two_edged_A" ;
lin two_faced_A = mkTerm "two_faced_A" ;
lin two_funnelled_A = mkTerm "two_funnelled_A" ;
lin two_handed_A = mkTerm "two_handed_A" ;
lin two_piece_N = mkTerm "two_piece_N" ;
lin two_ply_A = mkTerm "two_ply_A" ;
lin two_seater_N = mkTerm "two_seater_N" ;
lin two_step_N = mkTerm "two_step_N" ;
lin two_timing_A = mkTerm "two_timing_A" ;
lin two_way_A = mkTerm "two_way_A" ;
lin twofer_N = mkTerm "twofer_N" ;
lin twofold_A = mkTerm "twofold_A" ;
lin twofold_Adv = mkTerm "twofold_Adv" ;
lin twopence_N = mkTerm "twopence_N" ;
lin twopenny_A = mkTerm "twopenny_A" ;
lin twopenny_halfpenny_A = mkTerm "twopenny_halfpenny_A" ;
lin tycoon_N = mkTerm "tycoon_N" ;
lin tying_N = mkTerm "tying_N" ;
lin tyiyn_N = mkTerm "tyiyn_N" ;
lin tyke_N = mkTerm "tyke_N" ;
lin tympanic_A = mkTerm "tympanic_A" ;
lin tympanist_N = mkTerm "tympanist_N" ;
lin tympanites_N = mkTerm "tympanites_N" ;
lin tympanitic_A = mkTerm "tympanitic_A" ;
lin tympanitis_N = mkTerm "tympanitis_N" ;
lin tympanoplasty_N = mkTerm "tympanoplasty_N" ;
lin tympanum_N = mkTerm "tympanum_N" ;
lin tyne_PN = mkTerm "tyne_PN" ;
lin tynemouth_PN = mkTerm "tynemouth_PN" ;
lin type_N = mkTerm "type_N" ;
lin type_V = mkTerm "type_V" ;
lin type_V2 = mkTerm "type_V2" ;
lin type_in_V2 = mkTerm "type_in_V2" ;
lin type_out_V2 = mkTerm "type_out_V2" ;
lin type_up_V2 = mkTerm "type_up_V2" ;
lin typecast_V2 = mkTerm "typecast_V2" ;
lin typeface_N = mkTerm "typeface_N" ;
lin typescript_N = mkTerm "typescript_N" ;
lin typesetter_N = mkTerm "typesetter_N" ;
lin typewriter_N = mkTerm "typewriter_N" ;
lin typewritten_A = mkTerm "typewritten_A" ;
lin typhoid_N = mkTerm "typhoid_N" ;
lin typhoon_N = mkTerm "typhoon_N" ;
lin typhus_N = mkTerm "typhus_N" ;
lin typical_1_A = mkTerm "typical_1_A" ;
lin typical_2_A = mkTerm "typical_2_A" ;
lin typical_3_A = mkTerm "typical_3_A" ;
lin typicality_N = mkTerm "typicality_N" ;
lin typification_N = mkTerm "typification_N" ;
lin typify_V2 = mkTerm "typify_V2" ;
lin typing_N = mkTerm "typing_N" ;
lin typist_N = mkTerm "typist_N" ;
lin typographer_N = mkTerm "typographer_N" ;
lin typographic_A = mkTerm "typographic_A" ;
lin typography_N = mkTerm "typography_N" ;
lin typology_N = mkTerm "typology_N" ;
lin tyramine_N = mkTerm "tyramine_N" ;
lin tyrannical_A = mkTerm "tyrannical_A" ;
lin tyrannicide_N = mkTerm "tyrannicide_N" ;
lin tyrannid_N = mkTerm "tyrannid_N" ;
lin tyrannize_V = mkTerm "tyrannize_V" ;
lin tyrannize_V2 = mkTerm "tyrannize_V2" ;
lin tyrannosaur_N = mkTerm "tyrannosaur_N" ;
lin tyrannous_A = mkTerm "tyrannous_A" ;
lin tyranny_N = mkTerm "tyranny_N" ;
lin tyrant_N = mkTerm "tyrant_N" ;
lin tyre_N = mkTerm "tyre_N" ;
lin tyrnävä_PN = mkTerm "tyrnävä_PN" ;
lin tyro_N = mkTerm "tyro_N" ;
lin tyrocidine_N = mkTerm "tyrocidine_N" ;
lin tyrolean_N = mkTerm "tyrolean_N" ;
lin tyrone_PN = mkTerm "tyrone_PN" ;
lin tyrosine_N = mkTerm "tyrosine_N" ;
lin tyrosinemia_N = mkTerm "tyrosinemia_N" ;
lin tyrothricin_N = mkTerm "tyrothricin_N" ;
lin tzar_N = mkTerm "tzar_N" ;
lin tzarina_N = mkTerm "tzarina_N" ;
lin tzupo_PN = mkTerm "tzupo_PN" ;
lin töysä_PN = mkTerm "töysä_PN" ;
lin u_A = mkTerm "u_A" ;
lin u_boat_N = mkTerm "u_boat_N" ;
lin u_turn_N = mkTerm "u_turn_N" ;
lin uakari_N = mkTerm "uakari_N" ;
lin ubiety_N = mkTerm "ubiety_N" ;
lin ubiquinone_N = mkTerm "ubiquinone_N" ;
lin ubiquitous_A = mkTerm "ubiquitous_A" ;
lin ubiquity_N = mkTerm "ubiquity_N" ;
lin udder_N = mkTerm "udder_N" ;
lin uddingston_PN = mkTerm "uddingston_PN" ;
lin udi_PN = mkTerm "udi_PN" ;
lin udine_PN = mkTerm "udine_PN" ;
lin ufa_PN = mkTerm "ufa_PN" ;
lin ufo_N = mkTerm "ufo_N" ;
lin uganda_PN = mkTerm "uganda_PN" ;
lin ugandan_A = mkTerm "ugandan_A" ;
lin ugandan_N = mkTerm "ugandan_N" ;
lin uglify_V2 = mkTerm "uglify_V2" ;
lin ugliness_N = mkTerm "ugliness_N" ;
lin ugly_A = mkTerm "ugly_A" ;
lin uh_Interj = mkTerm "uh_Interj" ;
lin uh_huh_Interj = mkTerm "uh_huh_Interj" ;
lin uh_uh_Interj = mkTerm "uh_uh_Interj" ;
lin uk_PN = mkTerm "uk_PN" ;
lin ukase_N = mkTerm "ukase_N" ;
lin uke_N = mkTerm "uke_N" ;
lin ukraine_PN = mkTerm "ukraine_PN" ;
lin ukulele_N = mkTerm "ukulele_N" ;
lin ulalgia_N = mkTerm "ulalgia_N" ;
lin ulatrophia_N = mkTerm "ulatrophia_N" ;
lin ulcer_N = mkTerm "ulcer_N" ;
lin ulcerate_V = mkTerm "ulcerate_V" ;
lin ulcerate_V2 = mkTerm "ulcerate_V2" ;
lin ulceration_N = mkTerm "ulceration_N" ;
lin ulcerative_A = mkTerm "ulcerative_A" ;
lin ulcerous_A = mkTerm "ulcerous_A" ;
lin ulema_N = mkTerm "ulema_N" ;
lin ulemorrhagia_N = mkTerm "ulemorrhagia_N" ;
lin ulitis_N = mkTerm "ulitis_N" ;
lin ullage_N = mkTerm "ullage_N" ;
lin ullava_PN = mkTerm "ullava_PN" ;
lin ulna_N = mkTerm "ulna_N" ;
lin ulnar_A = mkTerm "ulnar_A" ;
lin ulster_N = mkTerm "ulster_N" ;
lin ulster_PN = mkTerm "ulster_PN" ;
lin ulterior_A = mkTerm "ulterior_A" ;
lin ulteriority_N = mkTerm "ulteriority_N" ;
lin ultima_N = mkTerm "ultima_N" ;
lin ultimacy_N = mkTerm "ultimacy_N" ;
lin ultimate_A = mkTerm "ultimate_A" ;
lin ultimate_N = mkTerm "ultimate_N" ;
lin ultimatum_N = mkTerm "ultimatum_N" ;
lin ultimo_A = mkTerm "ultimo_A" ;
lin ultra_A = mkTerm "ultra_A" ;
lin ultra_vires_A = mkTerm "ultra_vires_A" ;
lin ultra_vires_Adv = mkTerm "ultra_vires_Adv" ;
lin ultracentrifugation_N = mkTerm "ultracentrifugation_N" ;
lin ultracentrifuge_N = mkTerm "ultracentrifuge_N" ;
lin ultraconservative_A = mkTerm "ultraconservative_A" ;
lin ultramarine_A = mkTerm "ultramarine_A" ;
lin ultramarine_N = mkTerm "ultramarine_N" ;
lin ultramicroscope_N = mkTerm "ultramicroscope_N" ;
lin ultramicroscopic_A = mkTerm "ultramicroscopic_A" ;
lin ultramodern_A = mkTerm "ultramodern_A" ;
lin ultramontane_A = mkTerm "ultramontane_A" ;
lin ultramontane_N = mkTerm "ultramontane_N" ;
lin ultramontanism_N = mkTerm "ultramontanism_N" ;
lin ultrasonic_A = mkTerm "ultrasonic_A" ;
lin ultrasound_N = mkTerm "ultrasound_N" ;
lin ultraviolet_A = mkTerm "ultraviolet_A" ;
lin ultraviolet_N = mkTerm "ultraviolet_N" ;
lin ululate_V = mkTerm "ululate_V" ;
lin ululation_N = mkTerm "ululation_N" ;
lin ulverston_PN = mkTerm "ulverston_PN" ;
lin ulvila_PN = mkTerm "ulvila_PN" ;
lin umbel_N = mkTerm "umbel_N" ;
lin umbellate_A = mkTerm "umbellate_A" ;
lin umbellifer_N = mkTerm "umbellifer_N" ;
lin umbelliferous_A = mkTerm "umbelliferous_A" ;
lin umbelliform_A = mkTerm "umbelliform_A" ;
lin umber_A = mkTerm "umber_A" ;
lin umber_N = mkTerm "umber_N" ;
lin umbilical_A = mkTerm "umbilical_A" ;
lin umbilicate_A = mkTerm "umbilicate_A" ;
lin umbo_N = mkTerm "umbo_N" ;
lin umbra_N = mkTerm "umbra_N" ;
lin umbrage_N = mkTerm "umbrage_N" ;
lin umbrella_A = mkTerm "umbrella_A" ;
lin umbrella_N = mkTerm "umbrella_N" ;
lin umbrellalike_A = mkTerm "umbrellalike_A" ;
lin umbrellawort_N = mkTerm "umbrellawort_N" ;
lin umlaut_N = mkTerm "umlaut_N" ;
lin umpirage_N = mkTerm "umpirage_N" ;
lin umpire_N = mkTerm "umpire_N" ;
lin umpire_V = mkTerm "umpire_V" ;
lin umpire_V2 = mkTerm "umpire_V2" ;
lin umpteen_A = mkTerm "umpteen_A" ;
lin umpteenth_A = mkTerm "umpteenth_A" ;
lin un_N = mkTerm "un_N" ;
lin un_come_at_able_A = mkTerm "un_come_at_able_A" ;
lin un_get_at_able_A = mkTerm "un_get_at_able_A" ;
lin unabashed_A = mkTerm "unabashed_A" ;
lin unabated_A = mkTerm "unabated_A" ;
lin unable_A = mkTerm "unable_A" ;
lin unabridged_A = mkTerm "unabridged_A" ;
lin unabused_A = mkTerm "unabused_A" ;
lin unaccented_A = mkTerm "unaccented_A" ;
lin unacceptability_N = mkTerm "unacceptability_N" ;
lin unacceptable_A = mkTerm "unacceptable_A" ;
lin unaccommodating_A = mkTerm "unaccommodating_A" ;
lin unaccompanied_A = mkTerm "unaccompanied_A" ;
lin unaccountable_A = mkTerm "unaccountable_A" ;
lin unaccounted_A = mkTerm "unaccounted_A" ;
lin unaccredited_A = mkTerm "unaccredited_A" ;
lin unaccustomed_A = mkTerm "unaccustomed_A" ;
lin unachievable_A = mkTerm "unachievable_A" ;
lin unacknowledged_A = mkTerm "unacknowledged_A" ;
lin unacquainted_A = mkTerm "unacquainted_A" ;
lin unacquisitive_A = mkTerm "unacquisitive_A" ;
lin unactable_A = mkTerm "unactable_A" ;
lin unadaptability_N = mkTerm "unadaptability_N" ;
lin unadaptable_A = mkTerm "unadaptable_A" ;
lin unadapted_A = mkTerm "unadapted_A" ;
lin unaddicted_A = mkTerm "unaddicted_A" ;
lin unaddressed_A = mkTerm "unaddressed_A" ;
lin unadjustable_A = mkTerm "unadjustable_A" ;
lin unadjusted_A = mkTerm "unadjusted_A" ;
lin unadoptable_A = mkTerm "unadoptable_A" ;
lin unadorned_A = mkTerm "unadorned_A" ;
lin unadulterated_A = mkTerm "unadulterated_A" ;
lin unadventurous_A = mkTerm "unadventurous_A" ;
lin unadvised_A = mkTerm "unadvised_A" ;
lin unaerated_A = mkTerm "unaerated_A" ;
lin unaffected_A = mkTerm "unaffected_A" ;
lin unaffectedness_N = mkTerm "unaffectedness_N" ;
lin unaffecting_A = mkTerm "unaffecting_A" ;
lin unaffiliated_A = mkTerm "unaffiliated_A" ;
lin unaffixed_A = mkTerm "unaffixed_A" ;
lin unafraid_A = mkTerm "unafraid_A" ;
lin unaged_A = mkTerm "unaged_A" ;
lin unaggressive_A = mkTerm "unaggressive_A" ;
lin unagitated_A = mkTerm "unagitated_A" ;
lin unaided_A = mkTerm "unaided_A" ;
lin unairworthy_A = mkTerm "unairworthy_A" ;
lin unalarming_A = mkTerm "unalarming_A" ;
lin unalert_A = mkTerm "unalert_A" ;
lin unalienable_A = mkTerm "unalienable_A" ;
lin unaligned_A = mkTerm "unaligned_A" ;
lin unalike_A = mkTerm "unalike_A" ;
lin unalloyed_A = mkTerm "unalloyed_A" ;
lin unalterability_N = mkTerm "unalterability_N" ;
lin unalterable_A = mkTerm "unalterable_A" ;
lin unaltered_A = mkTerm "unaltered_A" ;
lin unambiguity_N = mkTerm "unambiguity_N" ;
lin unambiguous_A = mkTerm "unambiguous_A" ;
lin unambitious_A = mkTerm "unambitious_A" ;
lin unamended_A = mkTerm "unamended_A" ;
lin unanalyzable_A = mkTerm "unanalyzable_A" ;
lin unanalyzed_A = mkTerm "unanalyzed_A" ;
lin unanimated_A = mkTerm "unanimated_A" ;
lin unanimity_N = mkTerm "unanimity_N" ;
lin unanimous_A = mkTerm "unanimous_A" ;
lin unannounced_A = mkTerm "unannounced_A" ;
lin unanswerable_A = mkTerm "unanswerable_A" ;
lin unanswered_A = mkTerm "unanswered_A" ;
lin unanticipated_A = mkTerm "unanticipated_A" ;
lin unapologetic_A = mkTerm "unapologetic_A" ;
lin unappareled_A = mkTerm "unappareled_A" ;
lin unapparent_A = mkTerm "unapparent_A" ;
lin unappealable_A = mkTerm "unappealable_A" ;
lin unappealing_A = mkTerm "unappealing_A" ;
lin unappendaged_A = mkTerm "unappendaged_A" ;
lin unappetizing_A = mkTerm "unappetizing_A" ;
lin unappetizingness_N = mkTerm "unappetizingness_N" ;
lin unappreciated_A = mkTerm "unappreciated_A" ;
lin unappreciative_A = mkTerm "unappreciative_A" ;
lin unapprehensive_A = mkTerm "unapprehensive_A" ;
lin unapproachability_N = mkTerm "unapproachability_N" ;
lin unapproachable_A = mkTerm "unapproachable_A" ;
lin unarguable_A = mkTerm "unarguable_A" ;
lin unargumentative_A = mkTerm "unargumentative_A" ;
lin unarmed_A = mkTerm "unarmed_A" ;
lin unarmored_A = mkTerm "unarmored_A" ;
lin unarticulated_A = mkTerm "unarticulated_A" ;
lin unary_A = mkTerm "unary_A" ;
lin unascertainable_A = mkTerm "unascertainable_A" ;
lin unashamed_A = mkTerm "unashamed_A" ;
lin unasked_A = mkTerm "unasked_A" ;
lin unassailable_A = mkTerm "unassailable_A" ;
lin unassertive_A = mkTerm "unassertive_A" ;
lin unassertiveness_N = mkTerm "unassertiveness_N" ;
lin unassigned_A = mkTerm "unassigned_A" ;
lin unassisted_A = mkTerm "unassisted_A" ;
lin unassuming_A = mkTerm "unassuming_A" ;
lin unassured_A = mkTerm "unassured_A" ;
lin unasterisked_A = mkTerm "unasterisked_A" ;
lin unattached_A = mkTerm "unattached_A" ;
lin unattainable_A = mkTerm "unattainable_A" ;
lin unattainableness_N = mkTerm "unattainableness_N" ;
lin unattended_A = mkTerm "unattended_A" ;
lin unattractive_A = mkTerm "unattractive_A" ;
lin unattractiveness_N = mkTerm "unattractiveness_N" ;
lin unattributable_A = mkTerm "unattributable_A" ;
lin unauthorized_A = mkTerm "unauthorized_A" ;
lin unavailable_A = mkTerm "unavailable_A" ;
lin unavailing_A = mkTerm "unavailing_A" ;
lin unavenged_A = mkTerm "unavenged_A" ;
lin unavoidable_A = mkTerm "unavoidable_A" ;
lin unavowed_A = mkTerm "unavowed_A" ;
lin unawakened_A = mkTerm "unawakened_A" ;
lin unaware_A = mkTerm "unaware_A" ;
lin unaware_of_A2 = mkTerm "unaware_of_A2" ;
lin unawares_Adv = mkTerm "unawares_Adv" ;
lin unawed_A = mkTerm "unawed_A" ;
lin unbacked_A = mkTerm "unbacked_A" ;
lin unbaffled_A = mkTerm "unbaffled_A" ;
lin unbalance_V2 = mkTerm "unbalance_V2" ;
lin unbalconied_A = mkTerm "unbalconied_A" ;
lin unbanded_A = mkTerm "unbanded_A" ;
lin unbaptized_A = mkTerm "unbaptized_A" ;
lin unbar_V2 = mkTerm "unbar_V2" ;
lin unbarreled_A = mkTerm "unbarreled_A" ;
lin unbearable_A = mkTerm "unbearable_A" ;
lin unbeatable_A = mkTerm "unbeatable_A" ;
lin unbeaten_A = mkTerm "unbeaten_A" ;
lin unbecoming_A = mkTerm "unbecoming_A" ;
lin unbecomingness_N = mkTerm "unbecomingness_N" ;
lin unbefitting_A = mkTerm "unbefitting_A" ;
lin unbeknown_A = mkTerm "unbeknown_A" ;
lin unbeknown_Adv = mkTerm "unbeknown_Adv" ;
lin unbeknownst_A = mkTerm "unbeknownst_A" ;
lin unbeknownst_Adv = mkTerm "unbeknownst_Adv" ;
lin unbelief_N = mkTerm "unbelief_N" ;
lin unbelievable_A = mkTerm "unbelievable_A" ;
lin unbeliever_N = mkTerm "unbeliever_N" ;
lin unbelieving_A = mkTerm "unbelieving_A" ;
lin unbeloved_A = mkTerm "unbeloved_A" ;
lin unbelted_A = mkTerm "unbelted_A" ;
lin unbend_V = mkTerm "unbend_V" ;
lin unbend_V2 = mkTerm "unbend_V2" ;
lin unbeneficed_A = mkTerm "unbeneficed_A" ;
lin unbent_A = mkTerm "unbent_A" ;
lin unbiased_A = mkTerm "unbiased_A" ;
lin unbiassed_A = mkTerm "unbiassed_A" ;
lin unbidden_A = mkTerm "unbidden_A" ;
lin unbigoted_A = mkTerm "unbigoted_A" ;
lin unbind_V2 = mkTerm "unbind_V2" ;
lin unbitter_A = mkTerm "unbitter_A" ;
lin unbleached_A = mkTerm "unbleached_A" ;
lin unblemished_A = mkTerm "unblemished_A" ;
lin unblended_A = mkTerm "unblended_A" ;
lin unblessed_A = mkTerm "unblessed_A" ;
lin unblinking_A = mkTerm "unblinking_A" ;
lin unblock_V2 = mkTerm "unblock_V2" ;
lin unblushing_A = mkTerm "unblushing_A" ;
lin unbodied_A = mkTerm "unbodied_A" ;
lin unbolt_V = mkTerm "unbolt_V" ;
lin unbolt_V2 = mkTerm "unbolt_V2" ;
lin unbooked_A = mkTerm "unbooked_A" ;
lin unbordered_A = mkTerm "unbordered_A" ;
lin unborn_A = mkTerm "unborn_A" ;
lin unbosom_V2 = mkTerm "unbosom_V2" ;
lin unbounded_A = mkTerm "unbounded_A" ;
lin unbowed_A = mkTerm "unbowed_A" ;
lin unbraced_A = mkTerm "unbraced_A" ;
lin unbrainwashed_A = mkTerm "unbrainwashed_A" ;
lin unbranched_A = mkTerm "unbranched_A" ;
lin unbranded_A = mkTerm "unbranded_A" ;
lin unbreakable_A = mkTerm "unbreakable_A" ;
lin unbreakableness_N = mkTerm "unbreakableness_N" ;
lin unbridgeable_A = mkTerm "unbridgeable_A" ;
lin unbridled_A = mkTerm "unbridled_A" ;
lin unbroken_A = mkTerm "unbroken_A" ;
lin unbrushed_A = mkTerm "unbrushed_A" ;
lin unbuckle_V2 = mkTerm "unbuckle_V2" ;
lin unburden_V2 = mkTerm "unburden_V2" ;
lin unburied_A = mkTerm "unburied_A" ;
lin unburnished_A = mkTerm "unburnished_A" ;
lin unbutton_V2 = mkTerm "unbutton_V2" ;
lin uncalled_for_A = mkTerm "uncalled_for_A" ;
lin uncamphorated_A = mkTerm "uncamphorated_A" ;
lin uncanny_A = mkTerm "uncanny_A" ;
lin uncapped_A = mkTerm "uncapped_A" ;
lin uncared_for_A = mkTerm "uncared_for_A" ;
lin uncarpeted_A = mkTerm "uncarpeted_A" ;
lin uncarved_A = mkTerm "uncarved_A" ;
lin uncastrated_A = mkTerm "uncastrated_A" ;
lin uncategorized_A = mkTerm "uncategorized_A" ;
lin uncaulked_A = mkTerm "uncaulked_A" ;
lin unceasing_A = mkTerm "unceasing_A" ;
lin uncensored_A = mkTerm "uncensored_A" ;
lin unceremonious_A = mkTerm "unceremonious_A" ;
lin unceremoniousness_N = mkTerm "unceremoniousness_N" ;
lin uncertain_A = mkTerm "uncertain_A" ;
lin uncertainty_N = mkTerm "uncertainty_N" ;
lin uncertified_A = mkTerm "uncertified_A" ;
lin unchain_V2 = mkTerm "unchain_V2" ;
lin unchallengeable_A = mkTerm "unchallengeable_A" ;
lin unchallenged_A = mkTerm "unchallenged_A" ;
lin unchangeable_A = mkTerm "unchangeable_A" ;
lin unchanged_A = mkTerm "unchanged_A" ;
lin unchanging_A = mkTerm "unchanging_A" ;
lin uncharacteristic_A = mkTerm "uncharacteristic_A" ;
lin uncharged_A = mkTerm "uncharged_A" ;
lin uncharitable_A = mkTerm "uncharitable_A" ;
lin uncharted_A = mkTerm "uncharted_A" ;
lin unchartered_A = mkTerm "unchartered_A" ;
lin unchaste_A = mkTerm "unchaste_A" ;
lin uncheckable_A = mkTerm "uncheckable_A" ;
lin unchecked_A = mkTerm "unchecked_A" ;
lin uncheerfulness_N = mkTerm "uncheerfulness_N" ;
lin unchivalrously_Adv = mkTerm "unchivalrously_Adv" ;
lin unchristian_A = mkTerm "unchristian_A" ;
lin unchristianly_A = mkTerm "unchristianly_A" ;
lin uncial_A = mkTerm "uncial_A" ;
lin uncial_N = mkTerm "uncial_N" ;
lin uncivil_A = mkTerm "uncivil_A" ;
lin uncivilized_A = mkTerm "uncivilized_A" ;
lin unclaimed_A = mkTerm "unclaimed_A" ;
lin unclassifiable_A = mkTerm "unclassifiable_A" ;
lin unclassified_A = mkTerm "unclassified_A" ;
lin uncle_N = mkTerm "uncle_N" ;
lin unclean_A = mkTerm "unclean_A" ;
lin uncleanliness_N = mkTerm "uncleanliness_N" ;
lin uncleanly_A = mkTerm "uncleanly_A" ;
lin unclear_A = mkTerm "unclear_A" ;
lin uncleared_A = mkTerm "uncleared_A" ;
lin unclearness_N = mkTerm "unclearness_N" ;
lin unclipped_A = mkTerm "unclipped_A" ;
lin unclogged_A = mkTerm "unclogged_A" ;
lin unclothed_A = mkTerm "unclothed_A" ;
lin unclouded_A = mkTerm "unclouded_A" ;
lin uncluttered_A = mkTerm "uncluttered_A" ;
lin unco_A = mkTerm "unco_A" ;
lin unco_Adv = mkTerm "unco_Adv" ;
lin unco_operative_A = mkTerm "unco_operative_A" ;
lin unco_ordinated_A = mkTerm "unco_ordinated_A" ;
lin uncoated_A = mkTerm "uncoated_A" ;
lin uncoerced_A = mkTerm "uncoerced_A" ;
lin uncoiled_A = mkTerm "uncoiled_A" ;
lin uncollected_A = mkTerm "uncollected_A" ;
lin uncolored_A = mkTerm "uncolored_A" ;
lin uncoloured_A = mkTerm "uncoloured_A" ;
lin uncombable_A = mkTerm "uncombable_A" ;
lin uncombed_A = mkTerm "uncombed_A" ;
lin uncombined_A = mkTerm "uncombined_A" ;
lin uncomfortable_A = mkTerm "uncomfortable_A" ;
lin uncommercial_A = mkTerm "uncommercial_A" ;
lin uncommercialized_A = mkTerm "uncommercialized_A" ;
lin uncommitted_A = mkTerm "uncommitted_A" ;
lin uncommon_A = mkTerm "uncommon_A" ;
lin uncommonness_N = mkTerm "uncommonness_N" ;
lin uncommunicative_A = mkTerm "uncommunicative_A" ;
lin uncommunicativeness_N = mkTerm "uncommunicativeness_N" ;
lin uncompartmented_A = mkTerm "uncompartmented_A" ;
lin uncompassionate_A = mkTerm "uncompassionate_A" ;
lin uncompensated_A = mkTerm "uncompensated_A" ;
lin uncompetitive_A = mkTerm "uncompetitive_A" ;
lin uncomplaining_A = mkTerm "uncomplaining_A" ;
lin uncompleted_A = mkTerm "uncompleted_A" ;
lin uncomplicated_A = mkTerm "uncomplicated_A" ;
lin uncomplimentary_A = mkTerm "uncomplimentary_A" ;
lin uncompounded_A = mkTerm "uncompounded_A" ;
lin uncomprehended_A = mkTerm "uncomprehended_A" ;
lin uncomprehending_A = mkTerm "uncomprehending_A" ;
lin uncompromising_A = mkTerm "uncompromising_A" ;
lin unconcealed_A = mkTerm "unconcealed_A" ;
lin unconcern_N = mkTerm "unconcern_N" ;
lin unconcerned_A = mkTerm "unconcerned_A" ;
lin unconditional_A = mkTerm "unconditional_A" ;
lin unconditioned_A = mkTerm "unconditioned_A" ;
lin unconfessed_A = mkTerm "unconfessed_A" ;
lin unconfessed_N = mkTerm "unconfessed_N" ;
lin unconfined_A = mkTerm "unconfined_A" ;
lin unconfirmed_A = mkTerm "unconfirmed_A" ;
lin unconformable_A = mkTerm "unconformable_A" ;
lin uncongenial_A = mkTerm "uncongenial_A" ;
lin uncongeniality_N = mkTerm "uncongeniality_N" ;
lin unconnected_A = mkTerm "unconnected_A" ;
lin unconnectedness_N = mkTerm "unconnectedness_N" ;
lin unconquerable_A = mkTerm "unconquerable_A" ;
lin unconquered_A = mkTerm "unconquered_A" ;
lin unconscientious_A = mkTerm "unconscientious_A" ;
lin unconscientiousness_N = mkTerm "unconscientiousness_N" ;
lin unconscionable_A = mkTerm "unconscionable_A" ;
lin unconscious_A = mkTerm "unconscious_A" ;
lin unconscious_N = mkTerm "unconscious_N" ;
lin unconsciousness_N = mkTerm "unconsciousness_N" ;
lin unconsidered_A = mkTerm "unconsidered_A" ;
lin unconsolidated_A = mkTerm "unconsolidated_A" ;
lin unconstipated_A = mkTerm "unconstipated_A" ;
lin unconstitutional_A = mkTerm "unconstitutional_A" ;
lin unconstrained_A = mkTerm "unconstrained_A" ;
lin unconstricted_A = mkTerm "unconstricted_A" ;
lin unconstructive_A = mkTerm "unconstructive_A" ;
lin unconsumed_A = mkTerm "unconsumed_A" ;
lin unconsummated_A = mkTerm "unconsummated_A" ;
lin uncontaminated_A = mkTerm "uncontaminated_A" ;
lin uncontested_A = mkTerm "uncontested_A" ;
lin uncontrollable_A = mkTerm "uncontrollable_A" ;
lin uncontrolled_A = mkTerm "uncontrolled_A" ;
lin uncontroversial_A = mkTerm "uncontroversial_A" ;
lin unconventional_A = mkTerm "unconventional_A" ;
lin unconventionality_N = mkTerm "unconventionality_N" ;
lin unconverted_A = mkTerm "unconverted_A" ;
lin unconvinced_A = mkTerm "unconvinced_A" ;
lin unconvincing_A = mkTerm "unconvincing_A" ;
lin uncooked_A = mkTerm "uncooked_A" ;
lin uncool_A = mkTerm "uncool_A" ;
lin uncordial_A = mkTerm "uncordial_A" ;
lin uncork_V2 = mkTerm "uncork_V2" ;
lin uncorrected_A = mkTerm "uncorrected_A" ;
lin uncorrelated_A = mkTerm "uncorrelated_A" ;
lin uncorroborated_A = mkTerm "uncorroborated_A" ;
lin uncorrupted_A = mkTerm "uncorrupted_A" ;
lin uncouple_V2 = mkTerm "uncouple_V2" ;
lin uncousinly_A = mkTerm "uncousinly_A" ;
lin uncouth_A = mkTerm "uncouth_A" ;
lin uncouthness_N = mkTerm "uncouthness_N" ;
lin uncover_V2 = mkTerm "uncover_V2" ;
lin uncrannied_A = mkTerm "uncrannied_A" ;
lin uncreative_A = mkTerm "uncreative_A" ;
lin uncreativeness_N = mkTerm "uncreativeness_N" ;
lin uncritical_A = mkTerm "uncritical_A" ;
lin uncropped_A = mkTerm "uncropped_A" ;
lin uncross_V2 = mkTerm "uncross_V2" ;
lin uncrowded_A = mkTerm "uncrowded_A" ;
lin uncrowned_A = mkTerm "uncrowned_A" ;
lin uncrystallized_A = mkTerm "uncrystallized_A" ;
lin unction_N = mkTerm "unction_N" ;
lin unctuous_A = mkTerm "unctuous_A" ;
lin uncultivable_A = mkTerm "uncultivable_A" ;
lin uncultivated_A = mkTerm "uncultivated_A" ;
lin uncultured_A = mkTerm "uncultured_A" ;
lin uncured_A = mkTerm "uncured_A" ;
lin uncurl_V = mkTerm "uncurl_V" ;
lin uncurl_V2 = mkTerm "uncurl_V2" ;
lin uncurved_A = mkTerm "uncurved_A" ;
lin uncus_N = mkTerm "uncus_N" ;
lin uncut_A = mkTerm "uncut_A" ;
lin undamaged_A = mkTerm "undamaged_A" ;
lin undatable_A = mkTerm "undatable_A" ;
lin undated_A = mkTerm "undated_A" ;
lin undaunted_A = mkTerm "undaunted_A" ;
lin undead_A = mkTerm "undead_A" ;
lin undecagon_N = mkTerm "undecagon_N" ;
lin undeceive_V2 = mkTerm "undeceive_V2" ;
lin undecided_A = mkTerm "undecided_A" ;
lin undeciphered_A = mkTerm "undeciphered_A" ;
lin undeclared_A = mkTerm "undeclared_A" ;
lin undedicated_A = mkTerm "undedicated_A" ;
lin undefeated_A = mkTerm "undefeated_A" ;
lin undefended_A = mkTerm "undefended_A" ;
lin undeferential_A = mkTerm "undeferential_A" ;
lin undefinable_A = mkTerm "undefinable_A" ;
lin undefined_A = mkTerm "undefined_A" ;
lin undelineated_A = mkTerm "undelineated_A" ;
lin undemanding_A = mkTerm "undemanding_A" ;
lin undemocratic_A = mkTerm "undemocratic_A" ;
lin undemonstrative_A = mkTerm "undemonstrative_A" ;
lin undeniable_A = mkTerm "undeniable_A" ;
lin undenominational_A = mkTerm "undenominational_A" ;
lin undependability_N = mkTerm "undependability_N" ;
lin undependable_A = mkTerm "undependable_A" ;
lin undepicted_A = mkTerm "undepicted_A" ;
lin under_Adv = mkTerm "under_Adv" ;
lin under_the_counter_A = mkTerm "under_the_counter_A" ;
lin underachievement_N = mkTerm "underachievement_N" ;
lin underachiever_N = mkTerm "underachiever_N" ;
lin underact_V = mkTerm "underact_V" ;
lin underact_V2 = mkTerm "underact_V2" ;
lin underage_A = mkTerm "underage_A" ;
lin underarm_A = mkTerm "underarm_A" ;
lin underarm_Adv = mkTerm "underarm_Adv" ;
lin underbelly_N = mkTerm "underbelly_N" ;
lin underbid_V2 = mkTerm "underbid_V2" ;
lin underboss_N = mkTerm "underboss_N" ;
lin underbred_A = mkTerm "underbred_A" ;
lin underbrush_N = mkTerm "underbrush_N" ;
lin undercarriage_N = mkTerm "undercarriage_N" ;
lin undercharge_N = mkTerm "undercharge_N" ;
lin undercharge_V2 = mkTerm "undercharge_V2" ;
lin underclothing_N = mkTerm "underclothing_N" ;
lin undercoat_N = mkTerm "undercoat_N" ;
lin undercoated_A = mkTerm "undercoated_A" ;
lin undercover_A = mkTerm "undercover_A" ;
lin undercurrent_N = mkTerm "undercurrent_N" ;
lin undercut_N = mkTerm "undercut_N" ;
lin undercut_V2 = mkTerm "undercut_V2" ;
lin underdeveloped_A = mkTerm "underdeveloped_A" ;
lin underdevelopment_N = mkTerm "underdevelopment_N" ;
lin underdog_N = mkTerm "underdog_N" ;
lin underdone_A = mkTerm "underdone_A" ;
lin underdressed_A = mkTerm "underdressed_A" ;
lin undereducated_A = mkTerm "undereducated_A" ;
lin underemployed_A = mkTerm "underemployed_A" ;
lin underestimate_N = mkTerm "underestimate_N" ;
lin underestimate_V2 = mkTerm "underestimate_V2" ;
lin underestimation_N = mkTerm "underestimation_N" ;
lin underevaluation_N = mkTerm "underevaluation_N" ;
lin underexpose_V2 = mkTerm "underexpose_V2" ;
lin underexposure_N = mkTerm "underexposure_N" ;
lin underfed_A = mkTerm "underfed_A" ;
lin underfelt_N = mkTerm "underfelt_N" ;
lin underfloor_A = mkTerm "underfloor_A" ;
lin underfoot_Adv = mkTerm "underfoot_Adv" ;
lin underfund_V2 = mkTerm "underfund_V2" ;
lin undergarment_N = mkTerm "undergarment_N" ;
lin undergo_V2 = mkTerm "undergo_V2" ;
lin undergraduate_N = mkTerm "undergraduate_N" ;
lin underground_A = mkTerm "underground_A" ;
lin underground_Adv = mkTerm "underground_Adv" ;
lin underground_N = mkTerm "underground_N" ;
lin undergrowth_N = mkTerm "undergrowth_N" ;
lin underhand_A = mkTerm "underhand_A" ;
lin underhand_Adv = mkTerm "underhand_Adv" ;
lin underhanded_A = mkTerm "underhanded_A" ;
lin underhung_A = mkTerm "underhung_A" ;
lin underivative_A = mkTerm "underivative_A" ;
lin underived_A = mkTerm "underived_A" ;
lin underlay_N = mkTerm "underlay_N" ;
lin underlie_V2 = mkTerm "underlie_V2" ;
lin underline_N = mkTerm "underline_N" ;
lin underline_V2 = mkTerm "underline_V2" ;
lin underling_N = mkTerm "underling_N" ;
lin underlip_N = mkTerm "underlip_N" ;
lin underlying_A = mkTerm "underlying_A" ;
lin undermanned_A = mkTerm "undermanned_A" ;
lin undermentioned_A = mkTerm "undermentioned_A" ;
lin undermine_V2 = mkTerm "undermine_V2" ;
lin underneath_Adv = mkTerm "underneath_Adv" ;
lin underneath_Prep = mkTerm "underneath_Prep" ;
lin undernourished_A = mkTerm "undernourished_A" ;
lin undernourishment_N = mkTerm "undernourishment_N" ;
lin underpants_N = mkTerm "underpants_N" ;
lin underpart_N = mkTerm "underpart_N" ;
lin underpass_N = mkTerm "underpass_N" ;
lin underpay_V2 = mkTerm "underpay_V2" ;
lin underpayment_N = mkTerm "underpayment_N" ;
lin underperform_V2 = mkTerm "underperform_V2" ;
lin underperformer_N = mkTerm "underperformer_N" ;
lin underpin_V2 = mkTerm "underpin_V2" ;
lin underpopulated_A = mkTerm "underpopulated_A" ;
lin underprivileged_A = mkTerm "underprivileged_A" ;
lin underproduction_N = mkTerm "underproduction_N" ;
lin underquote_V2 = mkTerm "underquote_V2" ;
lin underrate_V2 = mkTerm "underrate_V2" ;
lin underscore_N = mkTerm "underscore_N" ;
lin underscore_V2 = mkTerm "underscore_V2" ;
lin undersea_A = mkTerm "undersea_A" ;
lin underseal_N = mkTerm "underseal_N" ;
lin undersealed_A = mkTerm "undersealed_A" ;
lin undersecretary_N = mkTerm "undersecretary_N" ;
lin undersell_V2 = mkTerm "undersell_V2" ;
lin underseller_N = mkTerm "underseller_N" ;
lin undersexed_A = mkTerm "undersexed_A" ;
lin undershoot_V2 = mkTerm "undershoot_V2" ;
lin undershrub_N = mkTerm "undershrub_N" ;
lin underside_N = mkTerm "underside_N" ;
lin undersign_V2 = mkTerm "undersign_V2" ;
lin undersize_A = mkTerm "undersize_A" ;
lin undersized_A = mkTerm "undersized_A" ;
lin underskirt_N = mkTerm "underskirt_N" ;
lin underslung_A = mkTerm "underslung_A" ;
lin underspend_V = mkTerm "underspend_V" ;
lin underspend_V2 = mkTerm "underspend_V2" ;
lin understaffed_A = mkTerm "understaffed_A" ;
lin understand_V = mkTerm "understand_V" ;
lin understand_V2 = mkTerm "understand_V2" ;
lin understand_VS = mkTerm "understand_VS" ;
lin understandable_A = mkTerm "understandable_A" ;
lin understanding_N = mkTerm "understanding_N" ;
lin understate_V2 = mkTerm "understate_V2" ;
lin understatement_N = mkTerm "understatement_N" ;
lin understock_V2 = mkTerm "understock_V2" ;
lin understudyFem_N = mkTerm "understudyFem_N" ;
lin understudyMasc_N = mkTerm "understudyMasc_N" ;
lin understudy_V2 = mkTerm "understudy_V2" ;
lin undersurface_N = mkTerm "undersurface_N" ;
lin undertake_V2 = mkTerm "undertake_V2" ;
lin undertaker_N = mkTerm "undertaker_N" ;
lin undertaking_N = mkTerm "undertaking_N" ;
lin undertide_N = mkTerm "undertide_N" ;
lin undertone_N = mkTerm "undertone_N" ;
lin undertow_N = mkTerm "undertow_N" ;
lin undervaluation_N = mkTerm "undervaluation_N" ;
lin undervalue_V2 = mkTerm "undervalue_V2" ;
lin underwater_A = mkTerm "underwater_A" ;
lin underway_A = mkTerm "underway_A" ;
lin underwear_N = mkTerm "underwear_N" ;
lin underweight_A = mkTerm "underweight_A" ;
lin underwhelm_V2 = mkTerm "underwhelm_V2" ;
lin underwing_N = mkTerm "underwing_N" ;
lin underworld_N = mkTerm "underworld_N" ;
lin underwrite_V = mkTerm "underwrite_V" ;
lin underwrite_V2 = mkTerm "underwrite_V2" ;
lin underwriter_N = mkTerm "underwriter_N" ;
lin undescended_A = mkTerm "undescended_A" ;
lin undescriptive_A = mkTerm "undescriptive_A" ;
lin undeserved_A = mkTerm "undeserved_A" ;
lin undeserving_A = mkTerm "undeserving_A" ;
lin undesigned_A = mkTerm "undesigned_A" ;
lin undesirability_N = mkTerm "undesirability_N" ;
lin undesirable_A = mkTerm "undesirable_A" ;
lin undesirable_N = mkTerm "undesirable_N" ;
lin undesired_A = mkTerm "undesired_A" ;
lin undesirous_A = mkTerm "undesirous_A" ;
lin undestroyable_A = mkTerm "undestroyable_A" ;
lin undetectable_A = mkTerm "undetectable_A" ;
lin undetected_A = mkTerm "undetected_A" ;
lin undetermined_A = mkTerm "undetermined_A" ;
lin undeterred_A = mkTerm "undeterred_A" ;
lin undeveloped_A = mkTerm "undeveloped_A" ;
lin undeviating_A = mkTerm "undeviating_A" ;
lin undiagnosable_A = mkTerm "undiagnosable_A" ;
lin undiagnosed_A = mkTerm "undiagnosed_A" ;
lin undies_N = mkTerm "undies_N" ;
lin undifferentiated_A = mkTerm "undifferentiated_A" ;
lin undigested_A = mkTerm "undigested_A" ;
lin undignified_A = mkTerm "undignified_A" ;
lin undiluted_A = mkTerm "undiluted_A" ;
lin undiminished_A = mkTerm "undiminished_A" ;
lin undimmed_A = mkTerm "undimmed_A" ;
lin undine_N = mkTerm "undine_N" ;
lin undiplomatic_A = mkTerm "undiplomatic_A" ;
lin undiscerning_A = mkTerm "undiscerning_A" ;
lin undischarged_A = mkTerm "undischarged_A" ;
lin undisciplined_A = mkTerm "undisciplined_A" ;
lin undisclosed_A = mkTerm "undisclosed_A" ;
lin undiscovered_A = mkTerm "undiscovered_A" ;
lin undiscriminating_A = mkTerm "undiscriminating_A" ;
lin undisguised_A = mkTerm "undisguised_A" ;
lin undismayed_A = mkTerm "undismayed_A" ;
lin undisputed_A = mkTerm "undisputed_A" ;
lin undissolved_A = mkTerm "undissolved_A" ;
lin undistinguishable_A = mkTerm "undistinguishable_A" ;
lin undistinguished_A = mkTerm "undistinguished_A" ;
lin undistorted_A = mkTerm "undistorted_A" ;
lin undistributed_A = mkTerm "undistributed_A" ;
lin undisturbed_A = mkTerm "undisturbed_A" ;
lin undiversified_A = mkTerm "undiversified_A" ;
lin undividable_A = mkTerm "undividable_A" ;
lin undivided_A = mkTerm "undivided_A" ;
lin undo_V2 = mkTerm "undo_V2" ;
lin undock_V = mkTerm "undock_V" ;
lin undock_V2 = mkTerm "undock_V2" ;
lin undocumented_A = mkTerm "undocumented_A" ;
lin undoer_N = mkTerm "undoer_N" ;
lin undogmatic_A = mkTerm "undogmatic_A" ;
lin undoing_N = mkTerm "undoing_N" ;
lin undomestic_A = mkTerm "undomestic_A" ;
lin undomesticated_A = mkTerm "undomesticated_A" ;
lin undoubted_A = mkTerm "undoubted_A" ;
lin undrained_A = mkTerm "undrained_A" ;
lin undramatic_A = mkTerm "undramatic_A" ;
lin undraped_A = mkTerm "undraped_A" ;
lin undrawn_A = mkTerm "undrawn_A" ;
lin undreamed_A = mkTerm "undreamed_A" ;
lin undreamed_of_A = mkTerm "undreamed_of_A" ;
lin undreamt_A = mkTerm "undreamt_A" ;
lin undress_N = mkTerm "undress_N" ;
lin undress_V = mkTerm "undress_V" ;
lin undress_V2 = mkTerm "undress_V2" ;
lin undried_A = mkTerm "undried_A" ;
lin undrinkable_A = mkTerm "undrinkable_A" ;
lin undue_A = mkTerm "undue_A" ;
lin undulate_A = mkTerm "undulate_A" ;
lin undulate_V = mkTerm "undulate_V" ;
lin undulation_N = mkTerm "undulation_N" ;
lin undulatory_A = mkTerm "undulatory_A" ;
lin undutifulness_N = mkTerm "undutifulness_N" ;
lin undying_A = mkTerm "undying_A" ;
lin undynamic_A = mkTerm "undynamic_A" ;
lin uneager_A = mkTerm "uneager_A" ;
lin unearned_A = mkTerm "unearned_A" ;
lin unearth_V2 = mkTerm "unearth_V2" ;
lin unearthly_A = mkTerm "unearthly_A" ;
lin unease_N = mkTerm "unease_N" ;
lin uneasiness_N = mkTerm "uneasiness_N" ;
lin uneasy_A = mkTerm "uneasy_A" ;
lin uneatable_A = mkTerm "uneatable_A" ;
lin uneaten_A = mkTerm "uneaten_A" ;
lin uneconomic_A = mkTerm "uneconomic_A" ;
lin uneconomical_A = mkTerm "uneconomical_A" ;
lin unedifying_A = mkTerm "unedifying_A" ;
lin unedited_A = mkTerm "unedited_A" ;
lin uneducated_A = mkTerm "uneducated_A" ;
lin uneffective_A = mkTerm "uneffective_A" ;
lin unelaborated_A = mkTerm "unelaborated_A" ;
lin unemotional_A = mkTerm "unemotional_A" ;
lin unemotionality_N = mkTerm "unemotionality_N" ;
lin unemphatic_A = mkTerm "unemphatic_A" ;
lin unemployable_A = mkTerm "unemployable_A" ;
lin unemployed_A = mkTerm "unemployed_A" ;
lin unemployment_N = mkTerm "unemployment_N" ;
lin unenclosed_A = mkTerm "unenclosed_A" ;
lin unencouraging_A = mkTerm "unencouraging_A" ;
lin unencumbered_A = mkTerm "unencumbered_A" ;
lin unended_A = mkTerm "unended_A" ;
lin unending_A = mkTerm "unending_A" ;
lin unendowed_A = mkTerm "unendowed_A" ;
lin unendurable_A = mkTerm "unendurable_A" ;
lin unenforceable_A = mkTerm "unenforceable_A" ;
lin unenforced_A = mkTerm "unenforced_A" ;
lin unengaged_A = mkTerm "unengaged_A" ;
lin unenlightened_A = mkTerm "unenlightened_A" ;
lin unenlightening_A = mkTerm "unenlightening_A" ;
lin unenlightenment_N = mkTerm "unenlightenment_N" ;
lin unenlivened_A = mkTerm "unenlivened_A" ;
lin unenterprising_A = mkTerm "unenterprising_A" ;
lin unenthusiastic_A = mkTerm "unenthusiastic_A" ;
lin unentitled_A = mkTerm "unentitled_A" ;
lin unenviable_A = mkTerm "unenviable_A" ;
lin unequal_A = mkTerm "unequal_A" ;
lin unequalized_A = mkTerm "unequalized_A" ;
lin unequalled_A = mkTerm "unequalled_A" ;
lin unequipped_A = mkTerm "unequipped_A" ;
lin unequivocal_A = mkTerm "unequivocal_A" ;
lin unerect_A = mkTerm "unerect_A" ;
lin unerring_A = mkTerm "unerring_A" ;
lin unesco_PN = mkTerm "unesco_PN" ;
lin unestablished_A = mkTerm "unestablished_A" ;
lin unethical_A = mkTerm "unethical_A" ;
lin uneven_1_A = mkTerm "uneven_1_A" ;
lin uneven_2_A = mkTerm "uneven_2_A" ;
lin unevenness_N = mkTerm "unevenness_N" ;
lin uneventful_A = mkTerm "uneventful_A" ;
lin unexacting_A = mkTerm "unexacting_A" ;
lin unexampled_A = mkTerm "unexampled_A" ;
lin unexceeded_A = mkTerm "unexceeded_A" ;
lin unexcelled_A = mkTerm "unexcelled_A" ;
lin unexceptionable_A = mkTerm "unexceptionable_A" ;
lin unexceptional_A = mkTerm "unexceptional_A" ;
lin unexchangeability_N = mkTerm "unexchangeability_N" ;
lin unexchangeable_A = mkTerm "unexchangeable_A" ;
lin unexcitable_A = mkTerm "unexcitable_A" ;
lin unexcited_A = mkTerm "unexcited_A" ;
lin unexciting_A = mkTerm "unexciting_A" ;
lin unexclusive_A = mkTerm "unexclusive_A" ;
lin unexcused_A = mkTerm "unexcused_A" ;
lin unexhausted_A = mkTerm "unexhausted_A" ;
lin unexpansive_A = mkTerm "unexpansive_A" ;
lin unexpected_A = mkTerm "unexpected_A" ;
lin unexpectedness_N = mkTerm "unexpectedness_N" ;
lin unexpendable_A = mkTerm "unexpendable_A" ;
lin unexpired_A = mkTerm "unexpired_A" ;
lin unexplained_A = mkTerm "unexplained_A" ;
lin unexploited_A = mkTerm "unexploited_A" ;
lin unexplored_A = mkTerm "unexplored_A" ;
lin unexportable_A = mkTerm "unexportable_A" ;
lin unexposed_A = mkTerm "unexposed_A" ;
lin unexpressed_A = mkTerm "unexpressed_A" ;
lin unexpurgated_A = mkTerm "unexpurgated_A" ;
lin unextended_A = mkTerm "unextended_A" ;
lin unfaceted_A = mkTerm "unfaceted_A" ;
lin unfailing_A = mkTerm "unfailing_A" ;
lin unfair_A = mkTerm "unfair_A" ;
lin unfairness_N = mkTerm "unfairness_N" ;
lin unfaithful_A = mkTerm "unfaithful_A" ;
lin unfaithfulness_N = mkTerm "unfaithfulness_N" ;
lin unfaltering_A = mkTerm "unfaltering_A" ;
lin unfamiliar_A = mkTerm "unfamiliar_A" ;
lin unfamiliarity_N = mkTerm "unfamiliarity_N" ;
lin unfashionable_A = mkTerm "unfashionable_A" ;
lin unfasten_V = mkTerm "unfasten_V" ;
lin unfasten_V2 = mkTerm "unfasten_V2" ;
lin unfastidious_A = mkTerm "unfastidious_A" ;
lin unfathomable_A = mkTerm "unfathomable_A" ;
lin unfathomed_A = mkTerm "unfathomed_A" ;
lin unfattened_A = mkTerm "unfattened_A" ;
lin unfavorable_A = mkTerm "unfavorable_A" ;
lin unfavorableness_N = mkTerm "unfavorableness_N" ;
lin unfavourable_A = mkTerm "unfavourable_A" ;
lin unfaze_V2 = mkTerm "unfaze_V2" ;
lin unfeathered_A = mkTerm "unfeathered_A" ;
lin unfed_A = mkTerm "unfed_A" ;
lin unfeeling_A = mkTerm "unfeeling_A" ;
lin unfeelingness_N = mkTerm "unfeelingness_N" ;
lin unfeigned_A = mkTerm "unfeigned_A" ;
lin unfeminine_A = mkTerm "unfeminine_A" ;
lin unfenced_A = mkTerm "unfenced_A" ;
lin unfermented_A = mkTerm "unfermented_A" ;
lin unfertilized_A = mkTerm "unfertilized_A" ;
lin unfettered_A = mkTerm "unfettered_A" ;
lin unfilled_A = mkTerm "unfilled_A" ;
lin unfilmed_A = mkTerm "unfilmed_A" ;
lin unfinished_A = mkTerm "unfinished_A" ;
lin unfirm_A = mkTerm "unfirm_A" ;
lin unfit_A = mkTerm "unfit_A" ;
lin unfit_V2 = mkTerm "unfit_V2" ;
lin unfitness_N = mkTerm "unfitness_N" ;
lin unfixed_A = mkTerm "unfixed_A" ;
lin unflagging_A = mkTerm "unflagging_A" ;
lin unflappable_A = mkTerm "unflappable_A" ;
lin unflattering_A = mkTerm "unflattering_A" ;
lin unflavored_A = mkTerm "unflavored_A" ;
lin unfledged_A = mkTerm "unfledged_A" ;
lin unflinching_A = mkTerm "unflinching_A" ;
lin unflurried_A = mkTerm "unflurried_A" ;
lin unfocused_A = mkTerm "unfocused_A" ;
lin unfold_V = mkTerm "unfold_V" ;
lin unfold_V2 = mkTerm "unfold_V2" ;
lin unfolding_N = mkTerm "unfolding_N" ;
lin unforbearing_A = mkTerm "unforbearing_A" ;
lin unforced_A = mkTerm "unforced_A" ;
lin unforeseeable_A = mkTerm "unforeseeable_A" ;
lin unforeseen_A = mkTerm "unforeseen_A" ;
lin unforested_A = mkTerm "unforested_A" ;
lin unforethoughtful_A = mkTerm "unforethoughtful_A" ;
lin unforfeitable_A = mkTerm "unforfeitable_A" ;
lin unforgettable_A = mkTerm "unforgettable_A" ;
lin unforgivable_A = mkTerm "unforgivable_A" ;
lin unforgiving_A = mkTerm "unforgiving_A" ;
lin unformed_A = mkTerm "unformed_A" ;
lin unforthcoming_A = mkTerm "unforthcoming_A" ;
lin unfortunate_A = mkTerm "unfortunate_A" ;
lin unfortunate_N = mkTerm "unfortunate_N" ;
lin unfortunately_Adv = mkTerm "unfortunately_Adv" ;
lin unfounded_A = mkTerm "unfounded_A" ;
lin unframed_A = mkTerm "unframed_A" ;
lin unfree_A = mkTerm "unfree_A" ;
lin unfrequented_A = mkTerm "unfrequented_A" ;
lin unfretted_A = mkTerm "unfretted_A" ;
lin unfriendliness_N = mkTerm "unfriendliness_N" ;
lin unfriendly_A = mkTerm "unfriendly_A" ;
lin unfrightened_A = mkTerm "unfrightened_A" ;
lin unfrock_V2 = mkTerm "unfrock_V2" ;
lin unfrosted_A = mkTerm "unfrosted_A" ;
lin unfrozen_A = mkTerm "unfrozen_A" ;
lin unfruitful_A = mkTerm "unfruitful_A" ;
lin unfueled_A = mkTerm "unfueled_A" ;
lin unfulfilled_A = mkTerm "unfulfilled_A" ;
lin unfunctional_A = mkTerm "unfunctional_A" ;
lin unfunded_A = mkTerm "unfunded_A" ;
lin unfunny_A = mkTerm "unfunny_A" ;
lin unfurl_V = mkTerm "unfurl_V" ;
lin unfurl_V2 = mkTerm "unfurl_V2" ;
lin unfurnished_A = mkTerm "unfurnished_A" ;
lin unfurrowed_A = mkTerm "unfurrowed_A" ;
lin ungainly_A = mkTerm "ungainly_A" ;
lin ungeared_A = mkTerm "ungeared_A" ;
lin ungenerous_A = mkTerm "ungenerous_A" ;
lin ungentle_A = mkTerm "ungentle_A" ;
lin ungentlemanly_A = mkTerm "ungentlemanly_A" ;
lin unglazed_A = mkTerm "unglazed_A" ;
lin ungodliness_N = mkTerm "ungodliness_N" ;
lin ungodly_A = mkTerm "ungodly_A" ;
lin ungovernable_A = mkTerm "ungovernable_A" ;
lin ungraceful_A = mkTerm "ungraceful_A" ;
lin ungracious_A = mkTerm "ungracious_A" ;
lin ungraciousness_N = mkTerm "ungraciousness_N" ;
lin ungraded_A = mkTerm "ungraded_A" ;
lin ungrammatical_A = mkTerm "ungrammatical_A" ;
lin ungrasped_A = mkTerm "ungrasped_A" ;
lin ungrateful_A = mkTerm "ungrateful_A" ;
lin ungratefulness_N = mkTerm "ungratefulness_N" ;
lin ungregarious_A = mkTerm "ungregarious_A" ;
lin ungroomed_A = mkTerm "ungroomed_A" ;
lin ungrudging_A = mkTerm "ungrudging_A" ;
lin ungual_A = mkTerm "ungual_A" ;
lin unguaranteed_A = mkTerm "unguaranteed_A" ;
lin unguarded_A = mkTerm "unguarded_A" ;
lin unguent_N = mkTerm "unguent_N" ;
lin unguiculate_A = mkTerm "unguiculate_A" ;
lin unguiculate_N = mkTerm "unguiculate_N" ;
lin unguided_A = mkTerm "unguided_A" ;
lin ungulate_A = mkTerm "ungulate_A" ;
lin ungulate_N = mkTerm "ungulate_N" ;
lin ungummed_A = mkTerm "ungummed_A" ;
lin ungusseted_A = mkTerm "ungusseted_A" ;
lin unhallowed_A = mkTerm "unhallowed_A" ;
lin unhampered_A = mkTerm "unhampered_A" ;
lin unhand_V2 = mkTerm "unhand_V2" ;
lin unhappiness_N = mkTerm "unhappiness_N" ;
lin unhappy_A = mkTerm "unhappy_A" ;
lin unharmed_A = mkTerm "unharmed_A" ;
lin unhatched_A = mkTerm "unhatched_A" ;
lin unheaded_A = mkTerm "unheaded_A" ;
lin unhealed_A = mkTerm "unhealed_A" ;
lin unhealthful_A = mkTerm "unhealthful_A" ;
lin unhealthfulness_N = mkTerm "unhealthfulness_N" ;
lin unhealthy_A = mkTerm "unhealthy_A" ;
lin unheard_A = mkTerm "unheard_A" ;
lin unheard_of_A = mkTerm "unheard_of_A" ;
lin unhearing_A = mkTerm "unhearing_A" ;
lin unheated_A = mkTerm "unheated_A" ;
lin unheeded_A = mkTerm "unheeded_A" ;
lin unhelpful_A = mkTerm "unhelpful_A" ;
lin unhelpfulness_N = mkTerm "unhelpfulness_N" ;
lin unheralded_A = mkTerm "unheralded_A" ;
lin unhesitating_A = mkTerm "unhesitating_A" ;
lin unhewn_A = mkTerm "unhewn_A" ;
lin unhindered_A = mkTerm "unhindered_A" ;
lin unhinge_V2 = mkTerm "unhinge_V2" ;
lin unhitch_V = mkTerm "unhitch_V" ;
lin unhitch_V2 = mkTerm "unhitch_V2" ;
lin unholiness_N = mkTerm "unholiness_N" ;
lin unholy_A = mkTerm "unholy_A" ;
lin unhomogenized_A = mkTerm "unhomogenized_A" ;
lin unhook_V2 = mkTerm "unhook_V2" ;
lin unhoped_A = mkTerm "unhoped_A" ;
lin unhoped_for_A = mkTerm "unhoped_for_A" ;
lin unhorse_V2 = mkTerm "unhorse_V2" ;
lin unhurried_A = mkTerm "unhurried_A" ;
lin unhurt_A = mkTerm "unhurt_A" ;
lin unhygienic_A = mkTerm "unhygienic_A" ;
lin unicameral_A = mkTerm "unicameral_A" ;
lin unicef_PN = mkTerm "unicef_PN" ;
lin unicellular_A = mkTerm "unicellular_A" ;
lin unicorn_N = mkTerm "unicorn_N" ;
lin unicuspid_A = mkTerm "unicuspid_A" ;
lin unicycle_N = mkTerm "unicycle_N" ;
lin unicyclist_N = mkTerm "unicyclist_N" ;
lin unidentifiable_A = mkTerm "unidentifiable_A" ;
lin unidentified_A = mkTerm "unidentified_A" ;
lin unidimensional_A = mkTerm "unidimensional_A" ;
lin unidirectional_A = mkTerm "unidirectional_A" ;
lin unifacial_A = mkTerm "unifacial_A" ;
lin unification_N = mkTerm "unification_N" ;
lin unifilar_A = mkTerm "unifilar_A" ;
lin unifoliate_A = mkTerm "unifoliate_A" ;
lin uniform_A = mkTerm "uniform_A" ;
lin uniform_N = mkTerm "uniform_N" ;
lin uniformed_A = mkTerm "uniformed_A" ;
lin uniformity_N = mkTerm "uniformity_N" ;
lin unify_V2 = mkTerm "unify_V2" ;
lin unilateral_A = mkTerm "unilateral_A" ;
lin unilateralism_N = mkTerm "unilateralism_N" ;
lin unilateralist_A = mkTerm "unilateralist_A" ;
lin unilateralist_N = mkTerm "unilateralist_N" ;
lin unimaginable_A = mkTerm "unimaginable_A" ;
lin unimaginative_A = mkTerm "unimaginative_A" ;
lin unimodal_A = mkTerm "unimodal_A" ;
lin unimpaired_A = mkTerm "unimpaired_A" ;
lin unimpassioned_A = mkTerm "unimpassioned_A" ;
lin unimpeachable_A = mkTerm "unimpeachable_A" ;
lin unimpeded_A = mkTerm "unimpeded_A" ;
lin unimportance_N = mkTerm "unimportance_N" ;
lin unimportant_A = mkTerm "unimportant_A" ;
lin unimposing_A = mkTerm "unimposing_A" ;
lin unimpressed_A = mkTerm "unimpressed_A" ;
lin unimpressionable_A = mkTerm "unimpressionable_A" ;
lin unimpressive_A = mkTerm "unimpressive_A" ;
lin unimproved_A = mkTerm "unimproved_A" ;
lin unincorporated_A = mkTerm "unincorporated_A" ;
lin unindustrialized_A = mkTerm "unindustrialized_A" ;
lin uninebriated_A = mkTerm "uninebriated_A" ;
lin uninfected_A = mkTerm "uninfected_A" ;
lin uninflected_A = mkTerm "uninflected_A" ;
lin uninfluenced_A = mkTerm "uninfluenced_A" ;
lin uninfluential_A = mkTerm "uninfluential_A" ;
lin uninformative_A = mkTerm "uninformative_A" ;
lin uninformed_A = mkTerm "uninformed_A" ;
lin uninhabitable_A = mkTerm "uninhabitable_A" ;
lin uninhabited_A = mkTerm "uninhabited_A" ;
lin uninhibited_A = mkTerm "uninhibited_A" ;
lin uninitiate_A = mkTerm "uninitiate_A" ;
lin uninitiate_N = mkTerm "uninitiate_N" ;
lin uninitiated_A = mkTerm "uninitiated_A" ;
lin uninjectable_A = mkTerm "uninjectable_A" ;
lin uninjured_A = mkTerm "uninjured_A" ;
lin uninominal_A = mkTerm "uninominal_A" ;
lin uninquiring_A = mkTerm "uninquiring_A" ;
lin uninspired_A = mkTerm "uninspired_A" ;
lin uninspiring_A = mkTerm "uninspiring_A" ;
lin uninstructed_A = mkTerm "uninstructed_A" ;
lin uninstructive_A = mkTerm "uninstructive_A" ;
lin uninsurability_N = mkTerm "uninsurability_N" ;
lin uninsurable_A = mkTerm "uninsurable_A" ;
lin uninsured_A = mkTerm "uninsured_A" ;
lin unintelligent_A = mkTerm "unintelligent_A" ;
lin unintelligibility_N = mkTerm "unintelligibility_N" ;
lin unintelligible_A = mkTerm "unintelligible_A" ;
lin unintended_A = mkTerm "unintended_A" ;
lin unintentional_A = mkTerm "unintentional_A" ;
lin uninterested_A = mkTerm "uninterested_A" ;
lin uninteresting_A = mkTerm "uninteresting_A" ;
lin uninterestingness_N = mkTerm "uninterestingness_N" ;
lin uninterrupted_A = mkTerm "uninterrupted_A" ;
lin unintrusive_A = mkTerm "unintrusive_A" ;
lin uninucleate_A = mkTerm "uninucleate_A" ;
lin uninvited_A = mkTerm "uninvited_A" ;
lin uninviting_A = mkTerm "uninviting_A" ;
lin uninvolved_A = mkTerm "uninvolved_A" ;
lin union_A = mkTerm "union_A" ;
lin union_N = mkTerm "union_N" ;
lin unionism_N = mkTerm "unionism_N" ;
lin unionist_N = mkTerm "unionist_N" ;
lin unionization_N = mkTerm "unionization_N" ;
lin uniovular_A = mkTerm "uniovular_A" ;
lin uniparous_A = mkTerm "uniparous_A" ;
lin unipolar_A = mkTerm "unipolar_A" ;
lin unique_A = mkTerm "unique_A" ;
lin uniqueness_N = mkTerm "uniqueness_N" ;
lin unironed_A = mkTerm "unironed_A" ;
lin unisex_A = mkTerm "unisex_A" ;
lin unisexual_A = mkTerm "unisexual_A" ;
lin unison_N = mkTerm "unison_N" ;
lin unit_1_N = mkTerm "unit_1_N" ;
lin unit_2_N = mkTerm "unit_2_N" ;
lin unit_3_N = mkTerm "unit_3_N" ;
lin unit_4_N = mkTerm "unit_4_N" ;
lin unit_5_N = mkTerm "unit_5_N" ;
lin unit_6_N = mkTerm "unit_6_N" ;
lin unit_V2V = mkTerm "unit_V2V" ;
lin unitarian_A = mkTerm "unitarian_A" ;
lin unitarian_N = mkTerm "unitarian_N" ;
lin unitarianism_N = mkTerm "unitarianism_N" ;
lin unitary_A = mkTerm "unitary_A" ;
lin unite_V = mkTerm "unite_V" ;
lin unite_V2 = mkTerm "unite_V2" ;
lin united_A = mkTerm "united_A" ;
lin unitization_N = mkTerm "unitization_N" ;
lin unity_N = mkTerm "unity_N" ;
lin univ_PN = mkTerm "univ_PN" ;
lin univalent_A = mkTerm "univalent_A" ;
lin univalve_A = mkTerm "univalve_A" ;
lin universal_A = mkTerm "universal_A" ;
lin universal_N = mkTerm "universal_N" ;
lin universalism_N = mkTerm "universalism_N" ;
lin universalistic_A = mkTerm "universalistic_A" ;
lin universality_N = mkTerm "universality_N" ;
lin universe_N = mkTerm "universe_N" ;
lin university_N = mkTerm "university_N" ;
lin unjointed_A = mkTerm "unjointed_A" ;
lin unjust_A = mkTerm "unjust_A" ;
lin unjustifiable_A = mkTerm "unjustifiable_A" ;
lin unjustified_A = mkTerm "unjustified_A" ;
lin unkempt_A = mkTerm "unkempt_A" ;
lin unkind_A = mkTerm "unkind_A" ;
lin unkindled_A = mkTerm "unkindled_A" ;
lin unkindly_A = mkTerm "unkindly_A" ;
lin unkindness_N = mkTerm "unkindness_N" ;
lin unkissed_A = mkTerm "unkissed_A" ;
lin unknowable_A = mkTerm "unknowable_A" ;
lin unknowing_A = mkTerm "unknowing_A" ;
lin unknowingness_N = mkTerm "unknowingness_N" ;
lin unknown_A = mkTerm "unknown_A" ;
lin unknown_N = mkTerm "unknown_N" ;
lin unlabeled_A = mkTerm "unlabeled_A" ;
lin unlabelled_A = mkTerm "unlabelled_A" ;
lin unlaced_A = mkTerm "unlaced_A" ;
lin unladylike_A = mkTerm "unladylike_A" ;
lin unlamented_A = mkTerm "unlamented_A" ;
lin unlatched_A = mkTerm "unlatched_A" ;
lin unlaureled_A = mkTerm "unlaureled_A" ;
lin unlawful_A = mkTerm "unlawful_A" ;
lin unlawfulness_N = mkTerm "unlawfulness_N" ;
lin unleaded_A = mkTerm "unleaded_A" ;
lin unlearn_V2 = mkTerm "unlearn_V2" ;
lin unleash_V2 = mkTerm "unleash_V2" ;
lin unleavened_A = mkTerm "unleavened_A" ;
lin unless_Subj = mkTerm "unless_Subj" ;
lin unlettered_A = mkTerm "unlettered_A" ;
lin unlicensed_A = mkTerm "unlicensed_A" ;
lin unlighted_A = mkTerm "unlighted_A" ;
lin unlikable_A = mkTerm "unlikable_A" ;
lin unlike_A = mkTerm "unlike_A" ;
lin unlike_Prep = mkTerm "unlike_Prep" ;
lin unlikelihood_N = mkTerm "unlikelihood_N" ;
lin unlikely_A = mkTerm "unlikely_A" ;
lin unlikeness_N = mkTerm "unlikeness_N" ;
lin unlimited_A = mkTerm "unlimited_A" ;
lin unlined_A = mkTerm "unlined_A" ;
lin unlisted_A = mkTerm "unlisted_A" ;
lin unlit_A = mkTerm "unlit_A" ;
lin unliterary_A = mkTerm "unliterary_A" ;
lin unlivable_A = mkTerm "unlivable_A" ;
lin unliveried_A = mkTerm "unliveried_A" ;
lin unload_V = mkTerm "unload_V" ;
lin unload_V2 = mkTerm "unload_V2" ;
lin unloading_N = mkTerm "unloading_N" ;
lin unlobed_A = mkTerm "unlobed_A" ;
lin unlocated_A = mkTerm "unlocated_A" ;
lin unlock_V = mkTerm "unlock_V" ;
lin unlock_V2 = mkTerm "unlock_V2" ;
lin unlooked_for_A = mkTerm "unlooked_for_A" ;
lin unloose_V2 = mkTerm "unloose_V2" ;
lin unlovable_A = mkTerm "unlovable_A" ;
lin unloved_A = mkTerm "unloved_A" ;
lin unlovely_A = mkTerm "unlovely_A" ;
lin unloving_A = mkTerm "unloving_A" ;
lin unlubricated_A = mkTerm "unlubricated_A" ;
lin unlucky_A = mkTerm "unlucky_A" ;
lin unmade_A = mkTerm "unmade_A" ;
lin unmalicious_A = mkTerm "unmalicious_A" ;
lin unmalleability_N = mkTerm "unmalleability_N" ;
lin unmalleable_A = mkTerm "unmalleable_A" ;
lin unmalted_A = mkTerm "unmalted_A" ;
lin unman_V2 = mkTerm "unman_V2" ;
lin unmanageable_A = mkTerm "unmanageable_A" ;
lin unmanfully_Adv = mkTerm "unmanfully_Adv" ;
lin unmanly_A = mkTerm "unmanly_A" ;
lin unmanned_A = mkTerm "unmanned_A" ;
lin unmannered_A = mkTerm "unmannered_A" ;
lin unmannerly_A = mkTerm "unmannerly_A" ;
lin unmarked_A = mkTerm "unmarked_A" ;
lin unmarketable_A = mkTerm "unmarketable_A" ;
lin unmarried_A = mkTerm "unmarried_A" ;
lin unmask_V = mkTerm "unmask_V" ;
lin unmask_V2 = mkTerm "unmask_V2" ;
lin unmatchable_A = mkTerm "unmatchable_A" ;
lin unmatched_A = mkTerm "unmatched_A" ;
lin unmated_A = mkTerm "unmated_A" ;
lin unmeasured_A = mkTerm "unmeasured_A" ;
lin unmechanical_A = mkTerm "unmechanical_A" ;
lin unmechanized_A = mkTerm "unmechanized_A" ;
lin unmedicinal_A = mkTerm "unmedicinal_A" ;
lin unmelodious_A = mkTerm "unmelodious_A" ;
lin unmelted_A = mkTerm "unmelted_A" ;
lin unmemorable_A = mkTerm "unmemorable_A" ;
lin unmentionable_A = mkTerm "unmentionable_A" ;
lin unmercenary_A = mkTerm "unmercenary_A" ;
lin unmerciful_A = mkTerm "unmerciful_A" ;
lin unmerited_A = mkTerm "unmerited_A" ;
lin unmeritorious_A = mkTerm "unmeritorious_A" ;
lin unmethodical_A = mkTerm "unmethodical_A" ;
lin unmilitary_A = mkTerm "unmilitary_A" ;
lin unmindful_A = mkTerm "unmindful_A" ;
lin unmindfulness_N = mkTerm "unmindfulness_N" ;
lin unmined_A = mkTerm "unmined_A" ;
lin unmingled_A = mkTerm "unmingled_A" ;
lin unmistakable_A = mkTerm "unmistakable_A" ;
lin unmitigable_A = mkTerm "unmitigable_A" ;
lin unmitigated_A = mkTerm "unmitigated_A" ;
lin unmixed_A = mkTerm "unmixed_A" ;
lin unmoderated_A = mkTerm "unmoderated_A" ;
lin unmodernized_A = mkTerm "unmodernized_A" ;
lin unmodifiable_A = mkTerm "unmodifiable_A" ;
lin unmodified_A = mkTerm "unmodified_A" ;
lin unmodulated_A = mkTerm "unmodulated_A" ;
lin unmolested_A = mkTerm "unmolested_A" ;
lin unmotivated_A = mkTerm "unmotivated_A" ;
lin unmotorized_A = mkTerm "unmotorized_A" ;
lin unmourned_A = mkTerm "unmourned_A" ;
lin unmovable_A = mkTerm "unmovable_A" ;
lin unmoved_A = mkTerm "unmoved_A" ;
lin unmoving_A = mkTerm "unmoving_A" ;
lin unmown_A = mkTerm "unmown_A" ;
lin unmusical_A = mkTerm "unmusical_A" ;
lin unmyelinated_A = mkTerm "unmyelinated_A" ;
lin unnamed_A = mkTerm "unnamed_A" ;
lin unnatural_A = mkTerm "unnatural_A" ;
lin unnaturalized_A = mkTerm "unnaturalized_A" ;
lin unnaturalness_N = mkTerm "unnaturalness_N" ;
lin unnavigable_A = mkTerm "unnavigable_A" ;
lin unnecessary_A = mkTerm "unnecessary_A" ;
lin unneighborliness_N = mkTerm "unneighborliness_N" ;
lin unneighborly_A = mkTerm "unneighborly_A" ;
lin unnerve_V2 = mkTerm "unnerve_V2" ;
lin unneurotic_A = mkTerm "unneurotic_A" ;
lin unnotched_A = mkTerm "unnotched_A" ;
lin unnoticeable_A = mkTerm "unnoticeable_A" ;
lin unnoticeableness_N = mkTerm "unnoticeableness_N" ;
lin unnoticed_A = mkTerm "unnoticed_A" ;
lin unnourished_A = mkTerm "unnourished_A" ;
lin unnumbered_A = mkTerm "unnumbered_A" ;
lin unobjectionable_A = mkTerm "unobjectionable_A" ;
lin unobjective_A = mkTerm "unobjective_A" ;
lin unobligated_A = mkTerm "unobligated_A" ;
lin unobservable_A = mkTerm "unobservable_A" ;
lin unobservant_A = mkTerm "unobservant_A" ;
lin unobserved_A = mkTerm "unobserved_A" ;
lin unobstructed_A = mkTerm "unobstructed_A" ;
lin unobtainable_A = mkTerm "unobtainable_A" ;
lin unobtrusive_A = mkTerm "unobtrusive_A" ;
lin unobtrusiveness_N = mkTerm "unobtrusiveness_N" ;
lin unobvious_A = mkTerm "unobvious_A" ;
lin unoccupied_A = mkTerm "unoccupied_A" ;
lin unoffending_A = mkTerm "unoffending_A" ;
lin unofficial_A = mkTerm "unofficial_A" ;
lin unoiled_A = mkTerm "unoiled_A" ;
lin unopen_A = mkTerm "unopen_A" ;
lin unopened_A = mkTerm "unopened_A" ;
lin unopposable_A = mkTerm "unopposable_A" ;
lin unopposed_A = mkTerm "unopposed_A" ;
lin unorganized_A = mkTerm "unorganized_A" ;
lin unoriented_A = mkTerm "unoriented_A" ;
lin unoriginal_A = mkTerm "unoriginal_A" ;
lin unoriginality_N = mkTerm "unoriginality_N" ;
lin unorthodox_A = mkTerm "unorthodox_A" ;
lin unorthodoxy_N = mkTerm "unorthodoxy_N" ;
lin unostentatious_A = mkTerm "unostentatious_A" ;
lin unowned_A = mkTerm "unowned_A" ;
lin unpack_V = mkTerm "unpack_V" ;
lin unpack_V2 = mkTerm "unpack_V2" ;
lin unpackaged_A = mkTerm "unpackaged_A" ;
lin unpaid_A = mkTerm "unpaid_A" ;
lin unpaintable_A = mkTerm "unpaintable_A" ;
lin unpainted_A = mkTerm "unpainted_A" ;
lin unpalatability_N = mkTerm "unpalatability_N" ;
lin unpalatable_A = mkTerm "unpalatable_A" ;
lin unparallel_A = mkTerm "unparallel_A" ;
lin unparalleled_A = mkTerm "unparalleled_A" ;
lin unpardonable_A = mkTerm "unpardonable_A" ;
lin unparented_A = mkTerm "unparented_A" ;
lin unparliamentary_A = mkTerm "unparliamentary_A" ;
lin unpartitioned_A = mkTerm "unpartitioned_A" ;
lin unpasteurized_A = mkTerm "unpasteurized_A" ;
lin unpatented_A = mkTerm "unpatented_A" ;
lin unpatriotic_A = mkTerm "unpatriotic_A" ;
lin unpatronized_A = mkTerm "unpatronized_A" ;
lin unpaved_A = mkTerm "unpaved_A" ;
lin unpeaceable_A = mkTerm "unpeaceable_A" ;
lin unpeaceful_A = mkTerm "unpeaceful_A" ;
lin unpeopled_A = mkTerm "unpeopled_A" ;
lin unperceived_A = mkTerm "unperceived_A" ;
lin unperceptive_A = mkTerm "unperceptive_A" ;
lin unperceptiveness_N = mkTerm "unperceptiveness_N" ;
lin unperformed_A = mkTerm "unperformed_A" ;
lin unpermed_A = mkTerm "unpermed_A" ;
lin unpermissive_A = mkTerm "unpermissive_A" ;
lin unpermissiveness_N = mkTerm "unpermissiveness_N" ;
lin unperplexed_A = mkTerm "unperplexed_A" ;
lin unpersuadable_A = mkTerm "unpersuadable_A" ;
lin unpersuaded_A = mkTerm "unpersuaded_A" ;
lin unpersuasive_A = mkTerm "unpersuasive_A" ;
lin unpersuasiveness_N = mkTerm "unpersuasiveness_N" ;
lin unperturbed_A = mkTerm "unperturbed_A" ;
lin unpick_V = mkTerm "unpick_V" ;
lin unpick_V2 = mkTerm "unpick_V2" ;
lin unpierced_A = mkTerm "unpierced_A" ;
lin unpigmented_A = mkTerm "unpigmented_A" ;
lin unpillared_A = mkTerm "unpillared_A" ;
lin unplaced_A = mkTerm "unplaced_A" ;
lin unplanned_A = mkTerm "unplanned_A" ;
lin unplanted_A = mkTerm "unplanted_A" ;
lin unplayable_A = mkTerm "unplayable_A" ;
lin unplayful_A = mkTerm "unplayful_A" ;
lin unpleasant_A = mkTerm "unpleasant_A" ;
lin unpleasantness_N = mkTerm "unpleasantness_N" ;
lin unpleasingness_N = mkTerm "unpleasingness_N" ;
lin unplowed_A = mkTerm "unplowed_A" ;
lin unplug_V = mkTerm "unplug_V" ;
lin unplug_V2 = mkTerm "unplug_V2" ;
lin unplumbed_A = mkTerm "unplumbed_A" ;
lin unpointedness_N = mkTerm "unpointedness_N" ;
lin unpolished_A = mkTerm "unpolished_A" ;
lin unpolluted_A = mkTerm "unpolluted_A" ;
lin unpompous_A = mkTerm "unpompous_A" ;
lin unpopular_A = mkTerm "unpopular_A" ;
lin unpopularity_N = mkTerm "unpopularity_N" ;
lin unportable_A = mkTerm "unportable_A" ;
lin unposed_A = mkTerm "unposed_A" ;
lin unpotted_A = mkTerm "unpotted_A" ;
lin unpowered_A = mkTerm "unpowered_A" ;
lin unpracticed_A = mkTerm "unpracticed_A" ;
lin unpractised_A = mkTerm "unpractised_A" ;
lin unprecedented_A = mkTerm "unprecedented_A" ;
lin unpredictability_N = mkTerm "unpredictability_N" ;
lin unpredictable_A = mkTerm "unpredictable_A" ;
lin unpredicted_A = mkTerm "unpredicted_A" ;
lin unpredictive_A = mkTerm "unpredictive_A" ;
lin unprejudiced_A = mkTerm "unprejudiced_A" ;
lin unpremeditated_A = mkTerm "unpremeditated_A" ;
lin unprepared_A = mkTerm "unprepared_A" ;
lin unprepossessing_A = mkTerm "unprepossessing_A" ;
lin unpresidential_A = mkTerm "unpresidential_A" ;
lin unpressed_A = mkTerm "unpressed_A" ;
lin unpretentious_A = mkTerm "unpretentious_A" ;
lin unpretentiousness_N = mkTerm "unpretentiousness_N" ;
lin unpreventable_A = mkTerm "unpreventable_A" ;
lin unpriestly_A = mkTerm "unpriestly_A" ;
lin unprincipled_A = mkTerm "unprincipled_A" ;
lin unprintable_A = mkTerm "unprintable_A" ;
lin unprocessed_A = mkTerm "unprocessed_A" ;
lin unproductive_A = mkTerm "unproductive_A" ;
lin unproductiveness_N = mkTerm "unproductiveness_N" ;
lin unprofessional_A = mkTerm "unprofessional_A" ;
lin unprofitable_A = mkTerm "unprofitable_A" ;
lin unprofitableness_N = mkTerm "unprofitableness_N" ;
lin unpromising_A = mkTerm "unpromising_A" ;
lin unprompted_A = mkTerm "unprompted_A" ;
lin unpronounceable_A = mkTerm "unpronounceable_A" ;
lin unprophetic_A = mkTerm "unprophetic_A" ;
lin unpropitious_A = mkTerm "unpropitious_A" ;
lin unprotected_A = mkTerm "unprotected_A" ;
lin unprotective_A = mkTerm "unprotective_A" ;
lin unprovable_A = mkTerm "unprovable_A" ;
lin unproved_A = mkTerm "unproved_A" ;
lin unproven_A = mkTerm "unproven_A" ;
lin unprovided_A = mkTerm "unprovided_A" ;
lin unprovocative_A = mkTerm "unprovocative_A" ;
lin unprovoked_A = mkTerm "unprovoked_A" ;
lin unpublishable_A = mkTerm "unpublishable_A" ;
lin unpublished_A = mkTerm "unpublished_A" ;
lin unpunctual_A = mkTerm "unpunctual_A" ;
lin unpunished_A = mkTerm "unpunished_A" ;
lin unpurified_A = mkTerm "unpurified_A" ;
lin unputdownable_A = mkTerm "unputdownable_A" ;
lin unqualified_A = mkTerm "unqualified_A" ;
lin unquestionable_A = mkTerm "unquestionable_A" ;
lin unquestioned_A = mkTerm "unquestioned_A" ;
lin unquestioning_A = mkTerm "unquestioning_A" ;
lin unquiet_A = mkTerm "unquiet_A" ;
lin unquotable_A = mkTerm "unquotable_A" ;
lin unquote_Adv = mkTerm "unquote_Adv" ;
lin unratable_A = mkTerm "unratable_A" ;
lin unratified_A = mkTerm "unratified_A" ;
lin unravel_V = mkTerm "unravel_V" ;
lin unravel_V2 = mkTerm "unravel_V2" ;
lin unreached_A = mkTerm "unreached_A" ;
lin unreactive_A = mkTerm "unreactive_A" ;
lin unread_A = mkTerm "unread_A" ;
lin unreadable_A = mkTerm "unreadable_A" ;
lin unready_A = mkTerm "unready_A" ;
lin unreal_A = mkTerm "unreal_A" ;
lin unrealistic_A = mkTerm "unrealistic_A" ;
lin unreality_N = mkTerm "unreality_N" ;
lin unrealized_A = mkTerm "unrealized_A" ;
lin unreasonable_A = mkTerm "unreasonable_A" ;
lin unreasoning_A = mkTerm "unreasoning_A" ;
lin unreassuring_A = mkTerm "unreassuring_A" ;
lin unreceptive_A = mkTerm "unreceptive_A" ;
lin unreciprocated_A = mkTerm "unreciprocated_A" ;
lin unrecognizable_A = mkTerm "unrecognizable_A" ;
lin unrecognized_A = mkTerm "unrecognized_A" ;
lin unreconciled_A = mkTerm "unreconciled_A" ;
lin unreconstructed_A = mkTerm "unreconstructed_A" ;
lin unrecorded_A = mkTerm "unrecorded_A" ;
lin unrecoverable_A = mkTerm "unrecoverable_A" ;
lin unredeemable_A = mkTerm "unredeemable_A" ;
lin unreduced_A = mkTerm "unreduced_A" ;
lin unrefined_A = mkTerm "unrefined_A" ;
lin unreflected_A = mkTerm "unreflected_A" ;
lin unreflective_A = mkTerm "unreflective_A" ;
lin unreformable_A = mkTerm "unreformable_A" ;
lin unreformed_A = mkTerm "unreformed_A" ;
lin unrefreshed_A = mkTerm "unrefreshed_A" ;
lin unregenerate_A = mkTerm "unregenerate_A" ;
lin unregistered_A = mkTerm "unregistered_A" ;
lin unregretful_A = mkTerm "unregretful_A" ;
lin unregulated_A = mkTerm "unregulated_A" ;
lin unrehearsed_A = mkTerm "unrehearsed_A" ;
lin unrelated_A = mkTerm "unrelated_A" ;
lin unrelatedness_N = mkTerm "unrelatedness_N" ;
lin unrelaxed_A = mkTerm "unrelaxed_A" ;
lin unreleased_A = mkTerm "unreleased_A" ;
lin unrelenting_A = mkTerm "unrelenting_A" ;
lin unreliable_A = mkTerm "unreliable_A" ;
lin unrelieved_A = mkTerm "unrelieved_A" ;
lin unremarkable_A = mkTerm "unremarkable_A" ;
lin unremedied_A = mkTerm "unremedied_A" ;
lin unremitting_A = mkTerm "unremitting_A" ;
lin unremunerative_A = mkTerm "unremunerative_A" ;
lin unrenewable_A = mkTerm "unrenewable_A" ;
lin unrentable_A = mkTerm "unrentable_A" ;
lin unrepaired_A = mkTerm "unrepaired_A" ;
lin unrepeatable_A = mkTerm "unrepeatable_A" ;
lin unrepentant_A = mkTerm "unrepentant_A" ;
lin unreportable_A = mkTerm "unreportable_A" ;
lin unreported_A = mkTerm "unreported_A" ;
lin unrepresentative_A = mkTerm "unrepresentative_A" ;
lin unrepressed_A = mkTerm "unrepressed_A" ;
lin unreproducible_A = mkTerm "unreproducible_A" ;
lin unrequested_A = mkTerm "unrequested_A" ;
lin unrequited_A = mkTerm "unrequited_A" ;
lin unresentful_A = mkTerm "unresentful_A" ;
lin unreserved_A = mkTerm "unreserved_A" ;
lin unresisting_A = mkTerm "unresisting_A" ;
lin unresolvable_A = mkTerm "unresolvable_A" ;
lin unresolved_A = mkTerm "unresolved_A" ;
lin unrespectability_N = mkTerm "unrespectability_N" ;
lin unrespectable_A = mkTerm "unrespectable_A" ;
lin unresponsive_A = mkTerm "unresponsive_A" ;
lin unresponsiveness_N = mkTerm "unresponsiveness_N" ;
lin unrest_N = mkTerm "unrest_N" ;
lin unrestrained_A = mkTerm "unrestrained_A" ;
lin unrestraint_N = mkTerm "unrestraint_N" ;
lin unrestricted_A = mkTerm "unrestricted_A" ;
lin unrestrictive_A = mkTerm "unrestrictive_A" ;
lin unretentive_A = mkTerm "unretentive_A" ;
lin unreverberant_A = mkTerm "unreverberant_A" ;
lin unrevised_A = mkTerm "unrevised_A" ;
lin unrevived_A = mkTerm "unrevived_A" ;
lin unrewarded_A = mkTerm "unrewarded_A" ;
lin unrewarding_A = mkTerm "unrewarding_A" ;
lin unrhetorical_A = mkTerm "unrhetorical_A" ;
lin unrhymed_A = mkTerm "unrhymed_A" ;
lin unrhythmical_A = mkTerm "unrhythmical_A" ;
lin unrifled_A = mkTerm "unrifled_A" ;
lin unrigged_A = mkTerm "unrigged_A" ;
lin unrighteous_A = mkTerm "unrighteous_A" ;
lin unrighteousness_N = mkTerm "unrighteousness_N" ;
lin unripe_A = mkTerm "unripe_A" ;
lin unripened_A = mkTerm "unripened_A" ;
lin unrivalled_A = mkTerm "unrivalled_A" ;
lin unroll_V = mkTerm "unroll_V" ;
lin unroll_V2 = mkTerm "unroll_V2" ;
lin unromantic_A = mkTerm "unromantic_A" ;
lin unromantically_Adv = mkTerm "unromantically_Adv" ;
lin unroofed_A = mkTerm "unroofed_A" ;
lin unrouged_A = mkTerm "unrouged_A" ;
lin unruffled_A = mkTerm "unruffled_A" ;
lin unruliness_N = mkTerm "unruliness_N" ;
lin unruly_A = mkTerm "unruly_A" ;
lin unsaddle_V2 = mkTerm "unsaddle_V2" ;
lin unsafe_A = mkTerm "unsafe_A" ;
lin unsalable_A = mkTerm "unsalable_A" ;
lin unsaleable_A = mkTerm "unsaleable_A" ;
lin unsalted_A = mkTerm "unsalted_A" ;
lin unsanctioned_A = mkTerm "unsanctioned_A" ;
lin unsanitariness_N = mkTerm "unsanitariness_N" ;
lin unsanitary_A = mkTerm "unsanitary_A" ;
lin unsaponified_A = mkTerm "unsaponified_A" ;
lin unsarcastic_A = mkTerm "unsarcastic_A" ;
lin unsated_A = mkTerm "unsated_A" ;
lin unsatisfactoriness_N = mkTerm "unsatisfactoriness_N" ;
lin unsatisfactory_A = mkTerm "unsatisfactory_A" ;
lin unsatisfiable_A = mkTerm "unsatisfiable_A" ;
lin unsatisfied_A = mkTerm "unsatisfied_A" ;
lin unsatisfying_A = mkTerm "unsatisfying_A" ;
lin unsaturated_A = mkTerm "unsaturated_A" ;
lin unsavoury_A = mkTerm "unsavoury_A" ;
lin unsay_V2 = mkTerm "unsay_V2" ;
lin unscalable_A = mkTerm "unscalable_A" ;
lin unscathed_A = mkTerm "unscathed_A" ;
lin unscheduled_A = mkTerm "unscheduled_A" ;
lin unscholarly_A = mkTerm "unscholarly_A" ;
lin unschooled_A = mkTerm "unschooled_A" ;
lin unscientific_A = mkTerm "unscientific_A" ;
lin unscramble_V2 = mkTerm "unscramble_V2" ;
lin unscrew_V = mkTerm "unscrew_V" ;
lin unscrew_V2 = mkTerm "unscrew_V2" ;
lin unscripted_A = mkTerm "unscripted_A" ;
lin unscrupulous_A = mkTerm "unscrupulous_A" ;
lin unscrupulousness_N = mkTerm "unscrupulousness_N" ;
lin unsealed_A = mkTerm "unsealed_A" ;
lin unseamanlike_A = mkTerm "unseamanlike_A" ;
lin unseamed_A = mkTerm "unseamed_A" ;
lin unseasonable_A = mkTerm "unseasonable_A" ;
lin unseasonableness_N = mkTerm "unseasonableness_N" ;
lin unseasoned_A = mkTerm "unseasoned_A" ;
lin unseat_V2 = mkTerm "unseat_V2" ;
lin unseaworthy_A = mkTerm "unseaworthy_A" ;
lin unsecured_A = mkTerm "unsecured_A" ;
lin unseductive_A = mkTerm "unseductive_A" ;
lin unseeded_A = mkTerm "unseeded_A" ;
lin unseeing_A = mkTerm "unseeing_A" ;
lin unseemliness_N = mkTerm "unseemliness_N" ;
lin unseemly_A = mkTerm "unseemly_A" ;
lin unseen_A = mkTerm "unseen_A" ;
lin unseen_N = mkTerm "unseen_N" ;
lin unseeyn_A = mkTerm "unseeyn_A" ;
lin unsegmented_A = mkTerm "unsegmented_A" ;
lin unselected_A = mkTerm "unselected_A" ;
lin unselective_A = mkTerm "unselective_A" ;
lin unselfconscious_A = mkTerm "unselfconscious_A" ;
lin unselfconsciousness_N = mkTerm "unselfconsciousness_N" ;
lin unselfish_A = mkTerm "unselfish_A" ;
lin unselfishness_N = mkTerm "unselfishness_N" ;
lin unsensational_A = mkTerm "unsensational_A" ;
lin unsent_A = mkTerm "unsent_A" ;
lin unsentimentally_Adv = mkTerm "unsentimentally_Adv" ;
lin unserviceable_A = mkTerm "unserviceable_A" ;
lin unservile_A = mkTerm "unservile_A" ;
lin unsettle_V2 = mkTerm "unsettle_V2" ;
lin unsex_V2 = mkTerm "unsex_V2" ;
lin unsexy_A = mkTerm "unsexy_A" ;
lin unshaded_A = mkTerm "unshaded_A" ;
lin unshadowed_A = mkTerm "unshadowed_A" ;
lin unshakable_A = mkTerm "unshakable_A" ;
lin unshaped_A = mkTerm "unshaped_A" ;
lin unshapely_A = mkTerm "unshapely_A" ;
lin unshared_A = mkTerm "unshared_A" ;
lin unsharpened_A = mkTerm "unsharpened_A" ;
lin unshaved_A = mkTerm "unshaved_A" ;
lin unshaven_A = mkTerm "unshaven_A" ;
lin unsheared_A = mkTerm "unsheared_A" ;
lin unsheathe_V2 = mkTerm "unsheathe_V2" ;
lin unshelled_A = mkTerm "unshelled_A" ;
lin unshielded_A = mkTerm "unshielded_A" ;
lin unshockable_A = mkTerm "unshockable_A" ;
lin unshod_A = mkTerm "unshod_A" ;
lin unshrinkable_A = mkTerm "unshrinkable_A" ;
lin unshrinking_A = mkTerm "unshrinking_A" ;
lin unshuttered_A = mkTerm "unshuttered_A" ;
lin unsighted_A = mkTerm "unsighted_A" ;
lin unsightliness_N = mkTerm "unsightliness_N" ;
lin unsightly_A = mkTerm "unsightly_A" ;
lin unsigned_A = mkTerm "unsigned_A" ;
lin unsilenced_A = mkTerm "unsilenced_A" ;
lin unsinkable_A = mkTerm "unsinkable_A" ;
lin unsized_A = mkTerm "unsized_A" ;
lin unskilled_A = mkTerm "unskilled_A" ;
lin unskillfulness_N = mkTerm "unskillfulness_N" ;
lin unsleeping_A = mkTerm "unsleeping_A" ;
lin unsmiling_A = mkTerm "unsmiling_A" ;
lin unsmoothed_A = mkTerm "unsmoothed_A" ;
lin unsnarling_N = mkTerm "unsnarling_N" ;
lin unsociability_N = mkTerm "unsociability_N" ;
lin unsociable_A = mkTerm "unsociable_A" ;
lin unsocial_A = mkTerm "unsocial_A" ;
lin unsoiled_A = mkTerm "unsoiled_A" ;
lin unsold_A = mkTerm "unsold_A" ;
lin unsoldierly_A = mkTerm "unsoldierly_A" ;
lin unsolicited_A = mkTerm "unsolicited_A" ;
lin unsolvability_N = mkTerm "unsolvability_N" ;
lin unsolved_A = mkTerm "unsolved_A" ;
lin unsophisticated_A = mkTerm "unsophisticated_A" ;
lin unsorted_A = mkTerm "unsorted_A" ;
lin unsound_A = mkTerm "unsound_A" ;
lin unsoundable_A = mkTerm "unsoundable_A" ;
lin unsoundness_N = mkTerm "unsoundness_N" ;
lin unsoured_A = mkTerm "unsoured_A" ;
lin unspaced_A = mkTerm "unspaced_A" ;
lin unsparing_A = mkTerm "unsparing_A" ;
lin unspeakable_A = mkTerm "unspeakable_A" ;
lin unspecialized_A = mkTerm "unspecialized_A" ;
lin unspecific_A = mkTerm "unspecific_A" ;
lin unspecifically_Adv = mkTerm "unspecifically_Adv" ;
lin unspecified_A = mkTerm "unspecified_A" ;
lin unspectacular_A = mkTerm "unspectacular_A" ;
lin unspent_A = mkTerm "unspent_A" ;
lin unspoiled_A = mkTerm "unspoiled_A" ;
lin unspoilt_A = mkTerm "unspoilt_A" ;
lin unspoken_A = mkTerm "unspoken_A" ;
lin unsporting_A = mkTerm "unsporting_A" ;
lin unsportsmanlike_A = mkTerm "unsportsmanlike_A" ;
lin unspotted_A = mkTerm "unspotted_A" ;
lin unstable_A = mkTerm "unstable_A" ;
lin unstaged_A = mkTerm "unstaged_A" ;
lin unstained_A = mkTerm "unstained_A" ;
lin unstartling_A = mkTerm "unstartling_A" ;
lin unstated_A = mkTerm "unstated_A" ;
lin unstatesmanlike_A = mkTerm "unstatesmanlike_A" ;
lin unsteadiness_N = mkTerm "unsteadiness_N" ;
lin unsteady_A = mkTerm "unsteady_A" ;
lin unsterilized_A = mkTerm "unsterilized_A" ;
lin unstilted_A = mkTerm "unstilted_A" ;
lin unstimulating_A = mkTerm "unstimulating_A" ;
lin unstintingly_Adv = mkTerm "unstintingly_Adv" ;
lin unstirred_A = mkTerm "unstirred_A" ;
lin unstoppable_A = mkTerm "unstoppable_A" ;
lin unstoppered_A = mkTerm "unstoppered_A" ;
lin unstrained_A = mkTerm "unstrained_A" ;
lin unstratified_A = mkTerm "unstratified_A" ;
lin unstressed_A = mkTerm "unstressed_A" ;
lin unstructured_A = mkTerm "unstructured_A" ;
lin unstrung_A = mkTerm "unstrung_A" ;
lin unstuck_A = mkTerm "unstuck_A" ;
lin unstudied_A = mkTerm "unstudied_A" ;
lin unstudious_A = mkTerm "unstudious_A" ;
lin unsubdued_A = mkTerm "unsubdued_A" ;
lin unsubtle_A = mkTerm "unsubtle_A" ;
lin unsuccessful_A = mkTerm "unsuccessful_A" ;
lin unsugared_A = mkTerm "unsugared_A" ;
lin unsuitability_N = mkTerm "unsuitability_N" ;
lin unsuitable_A = mkTerm "unsuitable_A" ;
lin unsuited_A = mkTerm "unsuited_A" ;
lin unsullied_A = mkTerm "unsullied_A" ;
lin unsung_A = mkTerm "unsung_A" ;
lin unsupervised_A = mkTerm "unsupervised_A" ;
lin unsupportable_A = mkTerm "unsupportable_A" ;
lin unsupported_A = mkTerm "unsupported_A" ;
lin unsupportive_A = mkTerm "unsupportive_A" ;
lin unsuppressed_A = mkTerm "unsuppressed_A" ;
lin unsure_A = mkTerm "unsure_A" ;
lin unsurmountable_A = mkTerm "unsurmountable_A" ;
lin unsurpassable_A = mkTerm "unsurpassable_A" ;
lin unsurpassed_A = mkTerm "unsurpassed_A" ;
lin unsurprised_A = mkTerm "unsurprised_A" ;
lin unsurprising_A = mkTerm "unsurprising_A" ;
lin unsusceptibility_N = mkTerm "unsusceptibility_N" ;
lin unsusceptible_A = mkTerm "unsusceptible_A" ;
lin unsuspected_A = mkTerm "unsuspected_A" ;
lin unsuspecting_A = mkTerm "unsuspecting_A" ;
lin unsuspicious_A = mkTerm "unsuspicious_A" ;
lin unswayed_A = mkTerm "unswayed_A" ;
lin unsweet_A = mkTerm "unsweet_A" ;
lin unsweetened_A = mkTerm "unsweetened_A" ;
lin unswept_A = mkTerm "unswept_A" ;
lin unswerving_A = mkTerm "unswerving_A" ;
lin unsworn_A = mkTerm "unsworn_A" ;
lin unsyllabic_A = mkTerm "unsyllabic_A" ;
lin unsyllabled_A = mkTerm "unsyllabled_A" ;
lin unsymmetric_A = mkTerm "unsymmetric_A" ;
lin unsympathetic_A = mkTerm "unsympathetic_A" ;
lin unsympathizing_A = mkTerm "unsympathizing_A" ;
lin unsystematic_A = mkTerm "unsystematic_A" ;
lin untainted_A = mkTerm "untainted_A" ;
lin untalented_A = mkTerm "untalented_A" ;
lin untamed_A = mkTerm "untamed_A" ;
lin untangled_A = mkTerm "untangled_A" ;
lin untanned_A = mkTerm "untanned_A" ;
lin untapped_A = mkTerm "untapped_A" ;
lin untarnished_A = mkTerm "untarnished_A" ;
lin untaxed_A = mkTerm "untaxed_A" ;
lin untempered_A = mkTerm "untempered_A" ;
lin untenable_A = mkTerm "untenable_A" ;
lin untenanted_A = mkTerm "untenanted_A" ;
lin untended_A = mkTerm "untended_A" ;
lin untested_A = mkTerm "untested_A" ;
lin untethered_A = mkTerm "untethered_A" ;
lin unthawed_A = mkTerm "unthawed_A" ;
lin untheatrical_A = mkTerm "untheatrical_A" ;
lin unthematic_A = mkTerm "unthematic_A" ;
lin unthinkable_A = mkTerm "unthinkable_A" ;
lin unthinking_A = mkTerm "unthinking_A" ;
lin unthought_of_A = mkTerm "unthought_of_A" ;
lin unthoughtfulness_N = mkTerm "unthoughtfulness_N" ;
lin untidiness_N = mkTerm "untidiness_N" ;
lin untidy_A = mkTerm "untidy_A" ;
lin untie_V = mkTerm "untie_V" ;
lin untie_V2 = mkTerm "untie_V2" ;
lin untied_A = mkTerm "untied_A" ;
lin until_Prep = mkTerm "until_Prep" ;
lin until_Subj = mkTerm "until_Subj" ;
lin untilled_A = mkTerm "untilled_A" ;
lin untimbered_A = mkTerm "untimbered_A" ;
lin untimely_A = mkTerm "untimely_A" ;
lin untipped_A = mkTerm "untipped_A" ;
lin untired_A = mkTerm "untired_A" ;
lin untiring_A = mkTerm "untiring_A" ;
lin untitled_A = mkTerm "untitled_A" ;
lin unto_Prep = mkTerm "unto_Prep" ;
lin untoasted_A = mkTerm "untoasted_A" ;
lin untold_A = mkTerm "untold_A" ;
lin untouchable_A = mkTerm "untouchable_A" ;
lin untouchable_N = mkTerm "untouchable_N" ;
lin untouched_A = mkTerm "untouched_A" ;
lin untoward_A = mkTerm "untoward_A" ;
lin untraceable_A = mkTerm "untraceable_A" ;
lin untrained_A = mkTerm "untrained_A" ;
lin untrammeled_A = mkTerm "untrammeled_A" ;
lin untrammelled_A = mkTerm "untrammelled_A" ;
lin untranslatable_A = mkTerm "untranslatable_A" ;
lin untraveled_A = mkTerm "untraveled_A" ;
lin untraversable_A = mkTerm "untraversable_A" ;
lin untraversed_A = mkTerm "untraversed_A" ;
lin untreated_A = mkTerm "untreated_A" ;
lin untried_A = mkTerm "untried_A" ;
lin untrimmed_A = mkTerm "untrimmed_A" ;
lin untroubled_A = mkTerm "untroubled_A" ;
lin untrue_A = mkTerm "untrue_A" ;
lin untrustworthiness_N = mkTerm "untrustworthiness_N" ;
lin untrustworthy_A = mkTerm "untrustworthy_A" ;
lin untruth_N = mkTerm "untruth_N" ;
lin untruthful_A = mkTerm "untruthful_A" ;
lin untruthfulness_N = mkTerm "untruthfulness_N" ;
lin untucked_A = mkTerm "untucked_A" ;
lin untufted_A = mkTerm "untufted_A" ;
lin unturned_A = mkTerm "unturned_A" ;
lin untutored_A = mkTerm "untutored_A" ;
lin untwisted_A = mkTerm "untwisted_A" ;
lin untying_N = mkTerm "untying_N" ;
lin untypical_A = mkTerm "untypical_A" ;
lin ununbium_N = mkTerm "ununbium_N" ;
lin ununderstood_A = mkTerm "ununderstood_A" ;
lin ununhexium_N = mkTerm "ununhexium_N" ;
lin ununpentium_N = mkTerm "ununpentium_N" ;
lin ununquadium_N = mkTerm "ununquadium_N" ;
lin ununtrium_N = mkTerm "ununtrium_N" ;
lin unused_A = mkTerm "unused_A" ;
lin unusual_A = mkTerm "unusual_A" ;
lin unusualness_N = mkTerm "unusualness_N" ;
lin unutterable_A = mkTerm "unutterable_A" ;
lin unvaccinated_A = mkTerm "unvaccinated_A" ;
lin unvaried_A = mkTerm "unvaried_A" ;
lin unvariedness_N = mkTerm "unvariedness_N" ;
lin unvarnished_A = mkTerm "unvarnished_A" ;
lin unvarying_A = mkTerm "unvarying_A" ;
lin unveil_V = mkTerm "unveil_V" ;
lin unveil_V2 = mkTerm "unveil_V2" ;
lin unveiling_N = mkTerm "unveiling_N" ;
lin unvented_A = mkTerm "unvented_A" ;
lin unventilated_A = mkTerm "unventilated_A" ;
lin unverified_A = mkTerm "unverified_A" ;
lin unversed_A = mkTerm "unversed_A" ;
lin unvigilant_A = mkTerm "unvigilant_A" ;
lin unvindictive_A = mkTerm "unvindictive_A" ;
lin unvitrified_A = mkTerm "unvitrified_A" ;
lin unvoiced_A = mkTerm "unvoiced_A" ;
lin unvulcanized_A = mkTerm "unvulcanized_A" ;
lin unwanted_A = mkTerm "unwanted_A" ;
lin unwariness_N = mkTerm "unwariness_N" ;
lin unwarrantably_Adv = mkTerm "unwarrantably_Adv" ;
lin unwarranted_A = mkTerm "unwarranted_A" ;
lin unwary_A = mkTerm "unwary_A" ;
lin unwashed_A = mkTerm "unwashed_A" ;
lin unwavering_A = mkTerm "unwavering_A" ;
lin unwaxed_A = mkTerm "unwaxed_A" ;
lin unweaned_A = mkTerm "unweaned_A" ;
lin unwearable_A = mkTerm "unwearable_A" ;
lin unwearied_A = mkTerm "unwearied_A" ;
lin unweathered_A = mkTerm "unweathered_A" ;
lin unwebbed_A = mkTerm "unwebbed_A" ;
lin unwed_A = mkTerm "unwed_A" ;
lin unwelcome_A = mkTerm "unwelcome_A" ;
lin unwell_A = mkTerm "unwell_A" ;
lin unwholesome_A = mkTerm "unwholesome_A" ;
lin unwholesomeness_N = mkTerm "unwholesomeness_N" ;
lin unwieldiness_N = mkTerm "unwieldiness_N" ;
lin unwieldy_A = mkTerm "unwieldy_A" ;
lin unwilled_A = mkTerm "unwilled_A" ;
lin unwilling_A = mkTerm "unwilling_A" ;
lin unwillingness_N = mkTerm "unwillingness_N" ;
lin unwind_V = mkTerm "unwind_V" ;
lin unwind_V2 = mkTerm "unwind_V2" ;
lin unwise_A = mkTerm "unwise_A" ;
lin unwitnessed_A = mkTerm "unwitnessed_A" ;
lin unwitting_A = mkTerm "unwitting_A" ;
lin unwomanly_A = mkTerm "unwomanly_A" ;
lin unwonted_A = mkTerm "unwonted_A" ;
lin unwooded_A = mkTerm "unwooded_A" ;
lin unworkable_A = mkTerm "unworkable_A" ;
lin unworkmanlike_A = mkTerm "unworkmanlike_A" ;
lin unworldly_A = mkTerm "unworldly_A" ;
lin unworn_A = mkTerm "unworn_A" ;
lin unworried_A = mkTerm "unworried_A" ;
lin unworthiness_N = mkTerm "unworthiness_N" ;
lin unworthy_A = mkTerm "unworthy_A" ;
lin unwounded_A = mkTerm "unwounded_A" ;
lin unwoven_A = mkTerm "unwoven_A" ;
lin unwrap_V = mkTerm "unwrap_V" ;
lin unwrap_V2 = mkTerm "unwrap_V2" ;
lin unwrinkled_A = mkTerm "unwrinkled_A" ;
lin unwritten_A = mkTerm "unwritten_A" ;
lin unyielding_A = mkTerm "unyielding_A" ;
lin unzip_V2 = mkTerm "unzip_V2" ;
lin up_A = mkTerm "up_A" ;
lin up_Adv = mkTerm "up_Adv" ;
lin up_Prep = mkTerm "up_Prep" ;
lin up_V = mkTerm "up_V" ;
lin up_V2 = mkTerm "up_V2" ;
lin up_and_coming_A = mkTerm "up_and_coming_A" ;
lin up_beat_N = mkTerm "up_beat_N" ;
lin up_holland_PN = mkTerm "up_holland_PN" ;
lin up_market_A = mkTerm "up_market_A" ;
lin up_to_Prep = mkTerm "up_to_Prep" ;
lin up_to_date_A = mkTerm "up_to_date_A" ;
lin up_to_the_minute_A = mkTerm "up_to_the_minute_A" ;
lin upbeat_A = mkTerm "upbeat_A" ;
lin upbound_A = mkTerm "upbound_A" ;
lin upbraid_V2 = mkTerm "upbraid_V2" ;
lin upbraider_N = mkTerm "upbraider_N" ;
lin upbraiding_N = mkTerm "upbraiding_N" ;
lin upbringing_N = mkTerm "upbringing_N" ;
lin upcast_N = mkTerm "upcast_N" ;
lin upcoming_A = mkTerm "upcoming_A" ;
lin upcountry_A = mkTerm "upcountry_A" ;
lin upcountry_Adv = mkTerm "upcountry_Adv" ;
lin upcurved_A = mkTerm "upcurved_A" ;
lin update_N = mkTerm "update_N" ;
lin update_V2 = mkTerm "update_V2" ;
lin updating_N = mkTerm "updating_N" ;
lin updraft_N = mkTerm "updraft_N" ;
lin upended_A = mkTerm "upended_A" ;
lin upfield_A = mkTerm "upfield_A" ;
lin upfront_A = mkTerm "upfront_A" ;
lin upgrade_N = mkTerm "upgrade_N" ;
lin upgrade_V2 = mkTerm "upgrade_V2" ;
lin upheaval_N = mkTerm "upheaval_N" ;
lin uphill_A = mkTerm "uphill_A" ;
lin uphill_Adv = mkTerm "uphill_Adv" ;
lin uphill_N = mkTerm "uphill_N" ;
lin uphold_V2 = mkTerm "uphold_V2" ;
lin upholder_N = mkTerm "upholder_N" ;
lin upholster_V2 = mkTerm "upholster_V2" ;
lin upholsterer_N = mkTerm "upholsterer_N" ;
lin upholstery_N = mkTerm "upholstery_N" ;
lin upkeep_N = mkTerm "upkeep_N" ;
lin upland_A = mkTerm "upland_A" ;
lin upland_N = mkTerm "upland_N" ;
lin uplift_N = mkTerm "uplift_N" ;
lin uplift_V2 = mkTerm "uplift_V2" ;
lin uplifting_N = mkTerm "uplifting_N" ;
lin uplink_N = mkTerm "uplink_N" ;
lin upmost_A = mkTerm "upmost_A" ;
lin upon_Prep = mkTerm "upon_Prep" ;
lin upper_A = mkTerm "upper_A" ;
lin upper_N = mkTerm "upper_N" ;
lin uppercase_A = mkTerm "uppercase_A" ;
lin uppercut_N = mkTerm "uppercut_N" ;
lin uppermost_A = mkTerm "uppermost_A" ;
lin uppermost_Adv = mkTerm "uppermost_Adv" ;
lin uppish_A = mkTerm "uppish_A" ;
lin uppishness_N = mkTerm "uppishness_N" ;
lin uppity_A = mkTerm "uppity_A" ;
lin uppityness_N = mkTerm "uppityness_N" ;
lin upraised_A = mkTerm "upraised_A" ;
lin upright_A = mkTerm "upright_A" ;
lin upright_N = mkTerm "upright_N" ;
lin uprightness_N = mkTerm "uprightness_N" ;
lin uprising_N = mkTerm "uprising_N" ;
lin upriver_Adv = mkTerm "upriver_Adv" ;
lin uproar_N = mkTerm "uproar_N" ;
lin uproarious_A = mkTerm "uproarious_A" ;
lin uproot_V2 = mkTerm "uproot_V2" ;
lin upscale_A = mkTerm "upscale_A" ;
lin upset_A = mkTerm "upset_A" ;
lin upset_N = mkTerm "upset_N" ;
lin upset_V = mkTerm "upset_V" ;
lin upset_V2 = mkTerm "upset_V2" ;
lin upsetter_N = mkTerm "upsetter_N" ;
lin upshot_N = mkTerm "upshot_N" ;
lin upside_N = mkTerm "upside_N" ;
lin upside_down_Adv = mkTerm "upside_down_Adv" ;
lin upsilon_N = mkTerm "upsilon_N" ;
lin upstage_A = mkTerm "upstage_A" ;
lin upstage_Adv = mkTerm "upstage_Adv" ;
lin upstage_N = mkTerm "upstage_N" ;
lin upstage_V2 = mkTerm "upstage_V2" ;
lin upstager_N = mkTerm "upstager_N" ;
lin upstairs_A = mkTerm "upstairs_A" ;
lin upstairs_Adv = mkTerm "upstairs_Adv" ;
lin upstairs_N = mkTerm "upstairs_N" ;
lin upstanding_A = mkTerm "upstanding_A" ;
lin upstart_A = mkTerm "upstart_A" ;
lin upstart_N = mkTerm "upstart_N" ;
lin upstate_Adv = mkTerm "upstate_Adv" ;
lin upstream_A = mkTerm "upstream_A" ;
lin upstream_Adv = mkTerm "upstream_Adv" ;
lin upstroke_N = mkTerm "upstroke_N" ;
lin upsurge_N = mkTerm "upsurge_N" ;
lin uptake_N = mkTerm "uptake_N" ;
lin uptick_N = mkTerm "uptick_N" ;
lin uptight_A = mkTerm "uptight_A" ;
lin uptime_N = mkTerm "uptime_N" ;
lin upton_PN = mkTerm "upton_PN" ;
lin uptown_A = mkTerm "uptown_A" ;
lin uptown_Adv = mkTerm "uptown_Adv" ;
lin uptown_N = mkTerm "uptown_N" ;
lin upturn_N = mkTerm "upturn_N" ;
lin upturned_A = mkTerm "upturned_A" ;
lin upward_A = mkTerm "upward_A" ;
lin upward_Adv = mkTerm "upward_Adv" ;
lin upwards_Adv = mkTerm "upwards_Adv" ;
lin upwind_A = mkTerm "upwind_A" ;
lin upwind_Adv = mkTerm "upwind_Adv" ;
lin uracil_N = mkTerm "uracil_N" ;
lin uraninite_N = mkTerm "uraninite_N" ;
lin uranium_N = mkTerm "uranium_N" ;
lin uranoplasty_N = mkTerm "uranoplasty_N" ;
lin uranus_PN = mkTerm "uranus_PN" ;
lin uranyl_N = mkTerm "uranyl_N" ;
lin urate_N = mkTerm "urate_N" ;
lin uratemia_N = mkTerm "uratemia_N" ;
lin uraturia_N = mkTerm "uraturia_N" ;
lin urban_A = mkTerm "urban_A" ;
lin urbane_A = mkTerm "urbane_A" ;
lin urbanity_N = mkTerm "urbanity_N" ;
lin urbanization_N = mkTerm "urbanization_N" ;
lin urbanize_V2 = mkTerm "urbanize_V2" ;
lin urceolate_A = mkTerm "urceolate_A" ;
lin urceole_N = mkTerm "urceole_N" ;
lin urchin_N = mkTerm "urchin_N" ;
lin urdu_A = mkTerm "urdu_A" ;
lin urea_N = mkTerm "urea_N" ;
lin urease_N = mkTerm "urease_N" ;
lin uremia_N = mkTerm "uremia_N" ;
lin ureter_N = mkTerm "ureter_N" ;
lin ureteritis_N = mkTerm "ureteritis_N" ;
lin ureterocele_N = mkTerm "ureterocele_N" ;
lin ureterostenosis_N = mkTerm "ureterostenosis_N" ;
lin urethane_N = mkTerm "urethane_N" ;
lin urethra_N = mkTerm "urethra_N" ;
lin urethral_A = mkTerm "urethral_A" ;
lin urethritis_N = mkTerm "urethritis_N" ;
lin urethrocele_N = mkTerm "urethrocele_N" ;
lin urge_N = mkTerm "urge_N" ;
lin urge_V2 = mkTerm "urge_V2" ;
lin urge_V2V = mkTerm "urge_V2V" ;
lin urge_VS = mkTerm "urge_VS" ;
lin urge_on_V2 = mkTerm "urge_on_V2" ;
lin urge_upon_V2 = mkTerm "urge_upon_V2" ;
lin urgency_N = mkTerm "urgency_N" ;
lin urgent_A = mkTerm "urgent_A" ;
lin urging_N = mkTerm "urging_N" ;
lin urial_N = mkTerm "urial_N" ;
lin uric_A = mkTerm "uric_A" ;
lin uricaciduria_N = mkTerm "uricaciduria_N" ;
lin uricosuric_A = mkTerm "uricosuric_A" ;
lin urinal_N = mkTerm "urinal_N" ;
lin urinalysis_N = mkTerm "urinalysis_N" ;
lin urinary_A = mkTerm "urinary_A" ;
lin urinate_V = mkTerm "urinate_V" ;
lin urine_N = mkTerm "urine_N" ;
lin urjala_PN = mkTerm "urjala_PN" ;
lin urn_N = mkTerm "urn_N" ;
lin urobilin_N = mkTerm "urobilin_N" ;
lin urobilinogen_N = mkTerm "urobilinogen_N" ;
lin urocele_N = mkTerm "urocele_N" ;
lin urochesia_N = mkTerm "urochesia_N" ;
lin urochord_N = mkTerm "urochord_N" ;
lin urodele_N = mkTerm "urodele_N" ;
lin urodynia_N = mkTerm "urodynia_N" ;
lin urogenital_A = mkTerm "urogenital_A" ;
lin urolith_N = mkTerm "urolith_N" ;
lin urologist_N = mkTerm "urologist_N" ;
lin urology_N = mkTerm "urology_N" ;
lin uropathy_N = mkTerm "uropathy_N" ;
lin uropygium_N = mkTerm "uropygium_N" ;
lin ursine_A = mkTerm "ursine_A" ;
lin ursinia_N = mkTerm "ursinia_N" ;
lin ursula_PN = mkTerm "ursula_PN" ;
lin urtication_N = mkTerm "urtication_N" ;
lin uruguay_PN = mkTerm "uruguay_PN" ;
lin uruguayan_A = mkTerm "uruguayan_A" ;
lin uruguayan_N = mkTerm "uruguayan_N" ;
lin urumchi_PN = mkTerm "urumchi_PN" ;
lin us_PN = mkTerm "us_PN" ;
lin usa_PN = mkTerm "usa_PN" ;
lin usable_A = mkTerm "usable_A" ;
lin usaf_N = mkTerm "usaf_N" ;
lin usage_N = mkTerm "usage_N" ;
lin usance_N = mkTerm "usance_N" ;
lin use_N = mkTerm "use_N" ;
lin use_V = mkTerm "use_V" ;
lin use_V2 = mkTerm "use_V2" ;
lin use_VV = mkTerm "use_VV" ;
lin use_up_V = mkTerm "use_up_V" ;
lin use_up_V2 = mkTerm "use_up_V2" ;
lin useable_A = mkTerm "useable_A" ;
lin used_A = mkTerm "used_A" ;
lin used_VV = mkTerm "used_VV" ;
lin useful_A = mkTerm "useful_A" ;
lin usefulness_N = mkTerm "usefulness_N" ;
lin useless_A = mkTerm "useless_A" ;
lin uselessness_N = mkTerm "uselessness_N" ;
lin userFem_N = mkTerm "userFem_N" ;
lin userMasc_N = mkTerm "userMasc_N" ;
lin ushaw_moor_PN = mkTerm "ushaw_moor_PN" ;
lin usher_N = mkTerm "usher_N" ;
lin usher_V2 = mkTerm "usher_V2" ;
lin usher_in_V2 = mkTerm "usher_in_V2" ;
lin usherette_N = mkTerm "usherette_N" ;
lin usn_N = mkTerm "usn_N" ;
lin uss_N = mkTerm "uss_N" ;
lin ussr_N = mkTerm "ussr_N" ;
lin usual_A = mkTerm "usual_A" ;
lin usualness_N = mkTerm "usualness_N" ;
lin usufruct_N = mkTerm "usufruct_N" ;
lin usufructuary_A = mkTerm "usufructuary_A" ;
lin usufructuary_N = mkTerm "usufructuary_N" ;
lin usurer_N = mkTerm "usurer_N" ;
lin usurious_A = mkTerm "usurious_A" ;
lin usurp_V2 = mkTerm "usurp_V2" ;
lin usurpation_N = mkTerm "usurpation_N" ;
lin usurper_N = mkTerm "usurper_N" ;
lin usury_N = mkTerm "usury_N" ;
lin utah_PN = mkTerm "utah_PN" ;
lin utahraptor_N = mkTerm "utahraptor_N" ;
lin utajärvi_PN = mkTerm "utajärvi_PN" ;
lin utensil_N = mkTerm "utensil_N" ;
lin uterine_A = mkTerm "uterine_A" ;
lin uterus_N = mkTerm "uterus_N" ;
lin utilitarian_A = mkTerm "utilitarian_A" ;
lin utilitarian_N = mkTerm "utilitarian_N" ;
lin utilitarianism_N = mkTerm "utilitarianism_N" ;
lin utility_N = mkTerm "utility_N" ;
lin utilizable_A = mkTerm "utilizable_A" ;
lin utilization_N = mkTerm "utilization_N" ;
lin utilize_V2 = mkTerm "utilize_V2" ;
lin utilizer_N = mkTerm "utilizer_N" ;
lin utmost_A = mkTerm "utmost_A" ;
lin utmost_N = mkTerm "utmost_N" ;
lin utopia_N = mkTerm "utopia_N" ;
lin utopian_A = mkTerm "utopian_A" ;
lin utrecht_PN = mkTerm "utrecht_PN" ;
lin utricle_N = mkTerm "utricle_N" ;
lin utsjoki_PN = mkTerm "utsjoki_PN" ;
lin utter_A = mkTerm "utter_A" ;
lin utter_V2 = mkTerm "utter_V2" ;
lin utterance_N = mkTerm "utterance_N" ;
lin utterer_N = mkTerm "utterer_N" ;
lin uttermost_A = mkTerm "uttermost_A" ;
lin uttermost_N = mkTerm "uttermost_N" ;
lin uttoxeter_PN = mkTerm "uttoxeter_PN" ;
lin uurainen_PN = mkTerm "uurainen_PN" ;
lin uusikaupunki_PN = mkTerm "uusikaupunki_PN" ;
lin uvea_N = mkTerm "uvea_N" ;
lin uveal_A = mkTerm "uveal_A" ;
lin uveitis_N = mkTerm "uveitis_N" ;
lin uvula_N = mkTerm "uvula_N" ;
lin uvular_A = mkTerm "uvular_A" ;
lin uvulitis_N = mkTerm "uvulitis_N" ;
lin uxor_N = mkTerm "uxor_N" ;
lin uxoricide_N = mkTerm "uxoricide_N" ;
lin uxorious_A = mkTerm "uxorious_A" ;
lin uxoriousness_N = mkTerm "uxoriousness_N" ;
lin v_and_a_N = mkTerm "v_and_a_N" ;
lin vaala_PN = mkTerm "vaala_PN" ;
lin vaasa_PN = mkTerm "vaasa_PN" ;
lin vac_N = mkTerm "vac_N" ;
lin vacancy_N = mkTerm "vacancy_N" ;
lin vacant_A = mkTerm "vacant_A" ;
lin vacate_V2 = mkTerm "vacate_V2" ;
lin vacation_N = mkTerm "vacation_N" ;
lin vacation_V = mkTerm "vacation_V" ;
lin vacationer_N = mkTerm "vacationer_N" ;
lin vacationing_N = mkTerm "vacationing_N" ;
lin vacationist_N = mkTerm "vacationist_N" ;
lin vaccinate_V2 = mkTerm "vaccinate_V2" ;
lin vaccination_N = mkTerm "vaccination_N" ;
lin vaccine_N = mkTerm "vaccine_N" ;
lin vaccinee_N = mkTerm "vaccinee_N" ;
lin vaccinia_N = mkTerm "vaccinia_N" ;
lin vacillant_A = mkTerm "vacillant_A" ;
lin vacillate_V = mkTerm "vacillate_V" ;
lin vacillation_N = mkTerm "vacillation_N" ;
lin vacuity_N = mkTerm "vacuity_N" ;
lin vacuolate_A = mkTerm "vacuolate_A" ;
lin vacuole_N = mkTerm "vacuole_N" ;
lin vacuolization_N = mkTerm "vacuolization_N" ;
lin vacuous_A = mkTerm "vacuous_A" ;
lin vacuousness_N = mkTerm "vacuousness_N" ;
lin vacuum_N = mkTerm "vacuum_N" ;
lin vacuum_V2 = mkTerm "vacuum_V2" ;
lin vacuum_up_V2 = mkTerm "vacuum_up_V2" ;
lin vade_mecum_N = mkTerm "vade_mecum_N" ;
lin vagabond_A = mkTerm "vagabond_A" ;
lin vagabond_N = mkTerm "vagabond_N" ;
lin vagal_A = mkTerm "vagal_A" ;
lin vagary_N = mkTerm "vagary_N" ;
lin vagile_A = mkTerm "vagile_A" ;
lin vagina_N = mkTerm "vagina_N" ;
lin vaginal_A = mkTerm "vaginal_A" ;
lin vaginismus_N = mkTerm "vaginismus_N" ;
lin vaginitis_N = mkTerm "vaginitis_N" ;
lin vagrancy_N = mkTerm "vagrancy_N" ;
lin vagrant_A = mkTerm "vagrant_A" ;
lin vagrant_N = mkTerm "vagrant_N" ;
lin vague_A = mkTerm "vague_A" ;
lin vagueness_N = mkTerm "vagueness_N" ;
lin vagus_N = mkTerm "vagus_N" ;
lin vahto_PN = mkTerm "vahto_PN" ;
lin vain_A = mkTerm "vain_A" ;
lin vainglorious_A = mkTerm "vainglorious_A" ;
lin vainglory_N = mkTerm "vainglory_N" ;
lin vaisya_N = mkTerm "vaisya_N" ;
lin valance_N = mkTerm "valance_N" ;
lin valdecoxib_N = mkTerm "valdecoxib_N" ;
lin vale_N = mkTerm "vale_N" ;
lin valediction_N = mkTerm "valediction_N" ;
lin valedictorian_N = mkTerm "valedictorian_N" ;
lin valedictory_A = mkTerm "valedictory_A" ;
lin valence_N = mkTerm "valence_N" ;
lin valencia_PN = mkTerm "valencia_PN" ;
lin valenciennes_PN = mkTerm "valenciennes_PN" ;
lin valency_N = mkTerm "valency_N" ;
lin valent_A = mkTerm "valent_A" ;
lin valentine_N = mkTerm "valentine_N" ;
lin valerian_N = mkTerm "valerian_N" ;
lin valet_N = mkTerm "valet_N" ;
lin valet_V2 = mkTerm "valet_V2" ;
lin valetudinarian_A = mkTerm "valetudinarian_A" ;
lin valetudinarian_N = mkTerm "valetudinarian_N" ;
lin valgus_N = mkTerm "valgus_N" ;
lin valiant_A = mkTerm "valiant_A" ;
lin valid_A = mkTerm "valid_A" ;
lin validate_V2 = mkTerm "validate_V2" ;
lin validation_N = mkTerm "validation_N" ;
lin validity_N = mkTerm "validity_N" ;
lin valine_N = mkTerm "valine_N" ;
lin valise_N = mkTerm "valise_N" ;
lin valkeakoski_PN = mkTerm "valkeakoski_PN" ;
lin valladolid_PN = mkTerm "valladolid_PN" ;
lin valley_N = mkTerm "valley_N" ;
lin valorous_A = mkTerm "valorous_A" ;
lin valour_N = mkTerm "valour_N" ;
lin valsartan_N = mkTerm "valsartan_N" ;
lin valtimo_PN = mkTerm "valtimo_PN" ;
lin valuable_A = mkTerm "valuable_A" ;
lin valuable_N = mkTerm "valuable_N" ;
lin valuation_N = mkTerm "valuation_N" ;
lin value_N = mkTerm "value_N" ;
lin value_V = mkTerm "value_V" ;
lin value_V2 = mkTerm "value_V2" ;
lin value_added_A = mkTerm "value_added_A" ;
lin valueless_A = mkTerm "valueless_A" ;
lin valuelessness_N = mkTerm "valuelessness_N" ;
lin valuer_N = mkTerm "valuer_N" ;
lin valve_N = mkTerm "valve_N" ;
lin valved_A = mkTerm "valved_A" ;
lin valvotomy_N = mkTerm "valvotomy_N" ;
lin valvular_A = mkTerm "valvular_A" ;
lin valvule_N = mkTerm "valvule_N" ;
lin valvulitis_N = mkTerm "valvulitis_N" ;
lin vambrace_N = mkTerm "vambrace_N" ;
lin vammala_PN = mkTerm "vammala_PN" ;
lin vamoose_V = mkTerm "vamoose_V" ;
lin vamp_N = mkTerm "vamp_N" ;
lin vamp_V = mkTerm "vamp_V" ;
lin vamp_V2 = mkTerm "vamp_V2" ;
lin vamp_up_V2 = mkTerm "vamp_up_V2" ;
lin vampire_N = mkTerm "vampire_N" ;
lin vampirism_N = mkTerm "vampirism_N" ;
lin vampula_PN = mkTerm "vampula_PN" ;
lin van_N = mkTerm "van_N" ;
lin vanadate_N = mkTerm "vanadate_N" ;
lin vanadinite_N = mkTerm "vanadinite_N" ;
lin vanadium_N = mkTerm "vanadium_N" ;
lin vancomycin_N = mkTerm "vancomycin_N" ;
lin vancouver_PN = mkTerm "vancouver_PN" ;
lin vanda_N = mkTerm "vanda_N" ;
lin vandal_N = mkTerm "vandal_N" ;
lin vandalism_N = mkTerm "vandalism_N" ;
lin vane_N = mkTerm "vane_N" ;
lin vanessa_PN = mkTerm "vanessa_PN" ;
lin vanguard_N = mkTerm "vanguard_N" ;
lin vanilla_A = mkTerm "vanilla_A" ;
lin vanilla_N = mkTerm "vanilla_N" ;
lin vanillin_N = mkTerm "vanillin_N" ;
lin vanish_V = mkTerm "vanish_V" ;
lin vanished_A = mkTerm "vanished_A" ;
lin vanisher_N = mkTerm "vanisher_N" ;
lin vanishing_N = mkTerm "vanishing_N" ;
lin vanishingly_Adv = mkTerm "vanishingly_Adv" ;
lin vanity_N = mkTerm "vanity_N" ;
lin vanquish_V2 = mkTerm "vanquish_V2" ;
lin vantaa_PN = mkTerm "vantaa_PN" ;
lin vantage_N = mkTerm "vantage_N" ;
lin vantage_point_N = mkTerm "vantage_point_N" ;
lin vapid_A = mkTerm "vapid_A" ;
lin vapidity_N = mkTerm "vapidity_N" ;
lin vapidness_N = mkTerm "vapidness_N" ;
lin vapor_N = mkTerm "vapor_N" ;
lin vaporific_A = mkTerm "vaporific_A" ;
lin vaporization_N = mkTerm "vaporization_N" ;
lin vaporize_V = mkTerm "vaporize_V" ;
lin vaporize_V2 = mkTerm "vaporize_V2" ;
lin vaporizer_N = mkTerm "vaporizer_N" ;
lin vaporous_A = mkTerm "vaporous_A" ;
lin vapour_N = mkTerm "vapour_N" ;
lin vapour_bath_N = mkTerm "vapour_bath_N" ;
lin vaquero_N = mkTerm "vaquero_N" ;
lin vaquita_N = mkTerm "vaquita_N" ;
lin vara_N = mkTerm "vara_N" ;
lin varanasi_PN = mkTerm "varanasi_PN" ;
lin vardenafil_N = mkTerm "vardenafil_N" ;
lin variability_N = mkTerm "variability_N" ;
lin variable_A = mkTerm "variable_A" ;
lin variable_N = mkTerm "variable_N" ;
lin variableness_N = mkTerm "variableness_N" ;
lin variance_N = mkTerm "variance_N" ;
lin variant_A = mkTerm "variant_A" ;
lin variant_N = mkTerm "variant_N" ;
lin variation_N = mkTerm "variation_N" ;
lin varicelliform_A = mkTerm "varicelliform_A" ;
lin varicocele_N = mkTerm "varicocele_N" ;
lin varicolored_A = mkTerm "varicolored_A" ;
lin varicoloured_A = mkTerm "varicoloured_A" ;
lin varicose_A = mkTerm "varicose_A" ;
lin varicosis_N = mkTerm "varicosis_N" ;
lin varicosity_N = mkTerm "varicosity_N" ;
lin varied_A = mkTerm "varied_A" ;
lin variedness_N = mkTerm "variedness_N" ;
lin variegated_A = mkTerm "variegated_A" ;
lin variegation_N = mkTerm "variegation_N" ;
lin varietal_N = mkTerm "varietal_N" ;
lin variety_1_N = mkTerm "variety_1_N" ;
lin variety_2_N = mkTerm "variety_2_N" ;
lin variform_A = mkTerm "variform_A" ;
lin variolar_A = mkTerm "variolar_A" ;
lin variolation_N = mkTerm "variolation_N" ;
lin variometer_N = mkTerm "variometer_N" ;
lin variorum_A = mkTerm "variorum_A" ;
lin variorum_N = mkTerm "variorum_N" ;
lin various_A = mkTerm "various_A" ;
lin varix_N = mkTerm "varix_N" ;
lin varkaus_PN = mkTerm "varkaus_PN" ;
lin varlet_N = mkTerm "varlet_N" ;
lin varmint_N = mkTerm "varmint_N" ;
lin varna_N = mkTerm "varna_N" ;
lin varnish_N = mkTerm "varnish_N" ;
lin varnish_V2 = mkTerm "varnish_V2" ;
lin varnisher_N = mkTerm "varnisher_N" ;
lin varpaisjärvi_PN = mkTerm "varpaisjärvi_PN" ;
lin varsity_N = mkTerm "varsity_N" ;
lin varus_N = mkTerm "varus_N" ;
lin vary_V = mkTerm "vary_V" ;
lin vary_V2 = mkTerm "vary_V2" ;
lin varying_A = mkTerm "varying_A" ;
lin vascular_A = mkTerm "vascular_A" ;
lin vascularity_N = mkTerm "vascularity_N" ;
lin vascularization_N = mkTerm "vascularization_N" ;
lin vasculitis_N = mkTerm "vasculitis_N" ;
lin vase_N = mkTerm "vase_N" ;
lin vasectomy_N = mkTerm "vasectomy_N" ;
lin vaseline_N = mkTerm "vaseline_N" ;
lin vasoconstriction_N = mkTerm "vasoconstriction_N" ;
lin vasoconstrictor_N = mkTerm "vasoconstrictor_N" ;
lin vasodilation_N = mkTerm "vasodilation_N" ;
lin vasodilator_N = mkTerm "vasodilator_N" ;
lin vasomotor_A = mkTerm "vasomotor_A" ;
lin vasopressin_N = mkTerm "vasopressin_N" ;
lin vasopressor_N = mkTerm "vasopressor_N" ;
lin vasotomy_N = mkTerm "vasotomy_N" ;
lin vasovasostomy_N = mkTerm "vasovasostomy_N" ;
lin vasovesiculitis_N = mkTerm "vasovesiculitis_N" ;
lin vassal_N = mkTerm "vassal_N" ;
lin vassalage_N = mkTerm "vassalage_N" ;
lin vast_A = mkTerm "vast_A" ;
lin vasteras_PN = mkTerm "vasteras_PN" ;
lin vastness_N = mkTerm "vastness_N" ;
lin vat_N = mkTerm "vat_N" ;
lin vatican_N = mkTerm "vatican_N" ;
lin vaudeville_N = mkTerm "vaudeville_N" ;
lin vaudevillian_N = mkTerm "vaudevillian_N" ;
lin vault_N = mkTerm "vault_N" ;
lin vault_V = mkTerm "vault_V" ;
lin vault_V2 = mkTerm "vault_V2" ;
lin vaulter_N = mkTerm "vaulter_N" ;
lin vaulting_N = mkTerm "vaulting_N" ;
lin vaulting_horse_N = mkTerm "vaulting_horse_N" ;
lin vaunt_N = mkTerm "vaunt_N" ;
lin vaunt_V = mkTerm "vaunt_V" ;
lin vaunt_V2 = mkTerm "vaunt_V2" ;
lin vaunter_N = mkTerm "vaunter_N" ;
lin vauntingly_Adv = mkTerm "vauntingly_Adv" ;
lin vc_N = mkTerm "vc_N" ;
lin vd_N = mkTerm "vd_N" ;
lin veal_N = mkTerm "veal_N" ;
lin vector_N = mkTerm "vector_N" ;
lin vedalia_N = mkTerm "vedalia_N" ;
lin veer_V = mkTerm "veer_V" ;
lin veer_away_from_V2 = mkTerm "veer_away_from_V2" ;
lin veer_off_V = mkTerm "veer_off_V" ;
lin veery_N = mkTerm "veery_N" ;
lin veg_out_V = mkTerm "veg_out_V" ;
lin vegan_N = mkTerm "vegan_N" ;
lin vegetable_A = mkTerm "vegetable_A" ;
lin vegetable_N = mkTerm "vegetable_N" ;
lin vegetal_A = mkTerm "vegetal_A" ;
lin vegetarianFem_N = mkTerm "vegetarianFem_N" ;
lin vegetarianMasc_N = mkTerm "vegetarianMasc_N" ;
lin vegetarian_A = mkTerm "vegetarian_A" ;
lin vegetarianism_N = mkTerm "vegetarianism_N" ;
lin vegetate_V = mkTerm "vegetate_V" ;
lin vegetation_N = mkTerm "vegetation_N" ;
lin vegetative_A = mkTerm "vegetative_A" ;
lin vehemence_N = mkTerm "vehemence_N" ;
lin vehement_A = mkTerm "vehement_A" ;
lin vehicle_N = mkTerm "vehicle_N" ;
lin vehicular_A = mkTerm "vehicular_A" ;
lin vehmaa_PN = mkTerm "vehmaa_PN" ;
lin vehmersalmi_PN = mkTerm "vehmersalmi_PN" ;
lin veil_N = mkTerm "veil_N" ;
lin veil_V2 = mkTerm "veil_V2" ;
lin veiling_N = mkTerm "veiling_N" ;
lin vein_N = mkTerm "vein_N" ;
lin veinal_A = mkTerm "veinal_A" ;
lin veined_A = mkTerm "veined_A" ;
lin velar_A = mkTerm "velar_A" ;
lin velar_N = mkTerm "velar_N" ;
lin veld_N = mkTerm "veld_N" ;
lin velkua_PN = mkTerm "velkua_PN" ;
lin velleity_N = mkTerm "velleity_N" ;
lin vellum_N = mkTerm "vellum_N" ;
lin velocipede_N = mkTerm "velocipede_N" ;
lin velociraptor_N = mkTerm "velociraptor_N" ;
lin velocity_N = mkTerm "velocity_N" ;
lin velodrome_N = mkTerm "velodrome_N" ;
lin velour_N = mkTerm "velour_N" ;
lin veloute_N = mkTerm "veloute_N" ;
lin velvet_A = mkTerm "velvet_A" ;
lin velvet_N = mkTerm "velvet_N" ;
lin velveteen_N = mkTerm "velveteen_N" ;
lin velvetleaf_N = mkTerm "velvetleaf_N" ;
lin velvety_A = mkTerm "velvety_A" ;
lin venal_A = mkTerm "venal_A" ;
lin venality_N = mkTerm "venality_N" ;
lin venation_N = mkTerm "venation_N" ;
lin vend_V2 = mkTerm "vend_V2" ;
lin vendee_N = mkTerm "vendee_N" ;
lin vender_N = mkTerm "vender_N" ;
lin vendetta_N = mkTerm "vendetta_N" ;
lin vending_N = mkTerm "vending_N" ;
lin vendor_N = mkTerm "vendor_N" ;
lin veneer_N = mkTerm "veneer_N" ;
lin veneer_V2 = mkTerm "veneer_V2" ;
lin veneering_N = mkTerm "veneering_N" ;
lin venerability_N = mkTerm "venerability_N" ;
lin venerable_A = mkTerm "venerable_A" ;
lin venerate_V2 = mkTerm "venerate_V2" ;
lin veneration_N = mkTerm "veneration_N" ;
lin venerator_N = mkTerm "venerator_N" ;
lin venereal_A = mkTerm "venereal_A" ;
lin venereologistFem_N = mkTerm "venereologistFem_N" ;
lin venereologistMasc_N = mkTerm "venereologistMasc_N" ;
lin venereology_N = mkTerm "venereology_N" ;
lin venesection_N = mkTerm "venesection_N" ;
lin venetian_A = mkTerm "venetian_A" ;
lin venezia_PN = mkTerm "venezia_PN" ;
lin venezuela_PN = mkTerm "venezuela_PN" ;
lin venezuelan_A = mkTerm "venezuelan_A" ;
lin venezuelan_N = mkTerm "venezuelan_N" ;
lin vengeance_N = mkTerm "vengeance_N" ;
lin vengeful_A = mkTerm "vengeful_A" ;
lin venial_A = mkTerm "venial_A" ;
lin venice_PN = mkTerm "venice_PN" ;
lin venipuncture_N = mkTerm "venipuncture_N" ;
lin venison_N = mkTerm "venison_N" ;
lin venogram_N = mkTerm "venogram_N" ;
lin venography_N = mkTerm "venography_N" ;
lin venom_N = mkTerm "venom_N" ;
lin venomed_A = mkTerm "venomed_A" ;
lin venomous_A = mkTerm "venomous_A" ;
lin venous_A = mkTerm "venous_A" ;
lin vent_N = mkTerm "vent_N" ;
lin vent_V2 = mkTerm "vent_V2" ;
lin vent_hole_N = mkTerm "vent_hole_N" ;
lin venter_N = mkTerm "venter_N" ;
lin ventilate_V2 = mkTerm "ventilate_V2" ;
lin ventilation_N = mkTerm "ventilation_N" ;
lin ventilator_N = mkTerm "ventilator_N" ;
lin ventilatory_A = mkTerm "ventilatory_A" ;
lin ventnor_PN = mkTerm "ventnor_PN" ;
lin ventral_A = mkTerm "ventral_A" ;
lin ventricle_N = mkTerm "ventricle_N" ;
lin ventricose_A = mkTerm "ventricose_A" ;
lin ventricular_A = mkTerm "ventricular_A" ;
lin ventriloquism_N = mkTerm "ventriloquism_N" ;
lin ventriloquist_N = mkTerm "ventriloquist_N" ;
lin venture_N = mkTerm "venture_N" ;
lin venture_V = mkTerm "venture_V" ;
lin venture_V2 = mkTerm "venture_V2" ;
lin venture_VS = mkTerm "venture_VS" ;
lin venture_forth_V = mkTerm "venture_forth_V" ;
lin venturer_N = mkTerm "venturer_N" ;
lin venturesome_A = mkTerm "venturesome_A" ;
lin venturi_N = mkTerm "venturi_N" ;
lin venturous_A = mkTerm "venturous_A" ;
lin venue_N = mkTerm "venue_N" ;
lin venule_N = mkTerm "venule_N" ;
lin venus_PN = mkTerm "venus_PN" ;
lin vera_PN = mkTerm "vera_PN" ;
lin veracious_A = mkTerm "veracious_A" ;
lin veracity_N = mkTerm "veracity_N" ;
lin veranda_N = mkTerm "veranda_N" ;
lin verandah_N = mkTerm "verandah_N" ;
lin verapamil_N = mkTerm "verapamil_N" ;
lin verb_N = mkTerm "verb_N" ;
lin verbal_A = mkTerm "verbal_A" ;
lin verbalization_N = mkTerm "verbalization_N" ;
lin verbalize_V2 = mkTerm "verbalize_V2" ;
lin verbatim_A = mkTerm "verbatim_A" ;
lin verbatim_Adv = mkTerm "verbatim_Adv" ;
lin verbena_N = mkTerm "verbena_N" ;
lin verbiage_N = mkTerm "verbiage_N" ;
lin verbolatry_N = mkTerm "verbolatry_N" ;
lin verbose_A = mkTerm "verbose_A" ;
lin verboseness_N = mkTerm "verboseness_N" ;
lin verbosity_N = mkTerm "verbosity_N" ;
lin verdancy_N = mkTerm "verdancy_N" ;
lin verdant_A = mkTerm "verdant_A" ;
lin verdict_N = mkTerm "verdict_N" ;
lin verdigris_N = mkTerm "verdigris_N" ;
lin verdin_N = mkTerm "verdin_N" ;
lin verdure_N = mkTerm "verdure_N" ;
lin verey_A = mkTerm "verey_A" ;
lin verge_N = mkTerm "verge_N" ;
lin verge_V = mkTerm "verge_V" ;
lin verger_N = mkTerm "verger_N" ;
lin veridical_A = mkTerm "veridical_A" ;
lin verifiable_A = mkTerm "verifiable_A" ;
lin verification_N = mkTerm "verification_N" ;
lin verify_V2 = mkTerm "verify_V2" ;
lin verisimilar_A = mkTerm "verisimilar_A" ;
lin verisimilitude_N = mkTerm "verisimilitude_N" ;
lin veritable_A = mkTerm "veritable_A" ;
lin verity_N = mkTerm "verity_N" ;
lin vermicelli_N = mkTerm "vermicelli_N" ;
lin vermicide_N = mkTerm "vermicide_N" ;
lin vermicular_A = mkTerm "vermicular_A" ;
lin vermiculate_A = mkTerm "vermiculate_A" ;
lin vermiculation_N = mkTerm "vermiculation_N" ;
lin vermiculite_N = mkTerm "vermiculite_N" ;
lin vermiform_A = mkTerm "vermiform_A" ;
lin vermifuge_N = mkTerm "vermifuge_N" ;
lin vermilion_A = mkTerm "vermilion_A" ;
lin vermilion_N = mkTerm "vermilion_N" ;
lin vermin_N = mkTerm "vermin_N" ;
lin verminous_A = mkTerm "verminous_A" ;
lin vermis_N = mkTerm "vermis_N" ;
lin vermont_PN = mkTerm "vermont_PN" ;
lin vermouth_N = mkTerm "vermouth_N" ;
lin vernacular_A = mkTerm "vernacular_A" ;
lin vernacular_N = mkTerm "vernacular_N" ;
lin vernal_A = mkTerm "vernal_A" ;
lin vernation_N = mkTerm "vernation_N" ;
lin vernix_N = mkTerm "vernix_N" ;
lin vernon_PN = mkTerm "vernon_PN" ;
lin verona_PN = mkTerm "verona_PN" ;
lin veronica_N = mkTerm "veronica_N" ;
lin veronica_PN = mkTerm "veronica_PN" ;
lin verruca_N = mkTerm "verruca_N" ;
lin verrucose_A = mkTerm "verrucose_A" ;
lin versatile_A = mkTerm "versatile_A" ;
lin versatility_N = mkTerm "versatility_N" ;
lin verse_N = mkTerm "verse_N" ;
lin versed_A = mkTerm "versed_A" ;
lin versicle_N = mkTerm "versicle_N" ;
lin versification_N = mkTerm "versification_N" ;
lin versifier_N = mkTerm "versifier_N" ;
lin versify_V = mkTerm "versify_V" ;
lin versify_V2 = mkTerm "versify_V2" ;
lin version_N = mkTerm "version_N" ;
lin verso_N = mkTerm "verso_N" ;
lin verst_N = mkTerm "verst_N" ;
lin versus_Prep = mkTerm "versus_Prep" ;
lin vertebra_N = mkTerm "vertebra_N" ;
lin vertebral_A = mkTerm "vertebral_A" ;
lin vertebrate_A = mkTerm "vertebrate_A" ;
lin vertebrate_N = mkTerm "vertebrate_N" ;
lin vertex_N = mkTerm "vertex_N" ;
lin vertical_A = mkTerm "vertical_A" ;
lin vertical_N = mkTerm "vertical_N" ;
lin verticality_N = mkTerm "verticality_N" ;
lin verticil_N = mkTerm "verticil_N" ;
lin verticillate_A = mkTerm "verticillate_A" ;
lin verticilliosis_N = mkTerm "verticilliosis_N" ;
lin verticillium_N = mkTerm "verticillium_N" ;
lin vertiginous_A = mkTerm "vertiginous_A" ;
lin vertigo_N = mkTerm "vertigo_N" ;
lin verve_N = mkTerm "verve_N" ;
lin vervet_N = mkTerm "vervet_N" ;
lin very_A = mkTerm "very_A" ;
lin vesanto_PN = mkTerm "vesanto_PN" ;
lin vesical_A = mkTerm "vesical_A" ;
lin vesicant_N = mkTerm "vesicant_N" ;
lin vesicatory_A = mkTerm "vesicatory_A" ;
lin vesicle_N = mkTerm "vesicle_N" ;
lin vesicular_A = mkTerm "vesicular_A" ;
lin vesiculation_N = mkTerm "vesiculation_N" ;
lin vesiculitis_N = mkTerm "vesiculitis_N" ;
lin vesiculovirus_N = mkTerm "vesiculovirus_N" ;
lin vesilahti_PN = mkTerm "vesilahti_PN" ;
lin vesper_N = mkTerm "vesper_N" ;
lin vespers_N = mkTerm "vespers_N" ;
lin vespid_N = mkTerm "vespid_N" ;
lin vessel_N = mkTerm "vessel_N" ;
lin vest_N = mkTerm "vest_N" ;
lin vest_V = mkTerm "vest_V" ;
lin vest_V2 = mkTerm "vest_V2" ;
lin vestal_A = mkTerm "vestal_A" ;
lin vestal_N = mkTerm "vestal_N" ;
lin vestiary_A = mkTerm "vestiary_A" ;
lin vestibular_A = mkTerm "vestibular_A" ;
lin vestibule_N = mkTerm "vestibule_N" ;
lin vestige_N = mkTerm "vestige_N" ;
lin vestigial_A = mkTerm "vestigial_A" ;
lin vestiture_N = mkTerm "vestiture_N" ;
lin vestment_N = mkTerm "vestment_N" ;
lin vestmental_A = mkTerm "vestmental_A" ;
lin vestmented_A = mkTerm "vestmented_A" ;
lin vestry_N = mkTerm "vestry_N" ;
lin vestryman_N = mkTerm "vestryman_N" ;
lin vestrywoman_N = mkTerm "vestrywoman_N" ;
lin vesture_N = mkTerm "vesture_N" ;
lin vesture_V2 = mkTerm "vesture_V2" ;
lin vesuvianite_N = mkTerm "vesuvianite_N" ;
lin vet_N = mkTerm "vet_N" ;
lin vet_V2 = mkTerm "vet_V2" ;
lin vetch_N = mkTerm "vetch_N" ;
lin vetchling_N = mkTerm "vetchling_N" ;
lin veteli_PN = mkTerm "veteli_PN" ;
lin veteran_N = mkTerm "veteran_N" ;
lin veterinarian_N = mkTerm "veterinarian_N" ;
lin veterinary_A = mkTerm "veterinary_A" ;
lin veto_N = mkTerm "veto_N" ;
lin veto_V = mkTerm "veto_V" ;
lin veto_V2 = mkTerm "veto_V2" ;
lin vex_V2 = mkTerm "vex_V2" ;
lin vex_V2V = mkTerm "vex_V2V" ;
lin vexation_N = mkTerm "vexation_N" ;
lin vexatious_A = mkTerm "vexatious_A" ;
lin vhf_PN = mkTerm "vhf_PN" ;
lin via_Prep = mkTerm "via_Prep" ;
lin via_media_N = mkTerm "via_media_N" ;
lin viability_N = mkTerm "viability_N" ;
lin viable_A = mkTerm "viable_A" ;
lin viaduct_N = mkTerm "viaduct_N" ;
lin vial_N = mkTerm "vial_N" ;
lin viand_N = mkTerm "viand_N" ;
lin viatical_A = mkTerm "viatical_A" ;
lin viatication_N = mkTerm "viatication_N" ;
lin vibist_N = mkTerm "vibist_N" ;
lin vibrant_A = mkTerm "vibrant_A" ;
lin vibraphone_N = mkTerm "vibraphone_N" ;
lin vibrate_V = mkTerm "vibrate_V" ;
lin vibrate_V2 = mkTerm "vibrate_V2" ;
lin vibration_N = mkTerm "vibration_N" ;
lin vibrational_A = mkTerm "vibrational_A" ;
lin vibrato_N = mkTerm "vibrato_N" ;
lin vibrator_N = mkTerm "vibrator_N" ;
lin vibratory_A = mkTerm "vibratory_A" ;
lin vibrio_N = mkTerm "vibrio_N" ;
lin vibrionic_A = mkTerm "vibrionic_A" ;
lin vic_PN = mkTerm "vic_PN" ;
lin vicar_N = mkTerm "vicar_N" ;
lin vicarage_N = mkTerm "vicarage_N" ;
lin vicarial_A = mkTerm "vicarial_A" ;
lin vicariate_N = mkTerm "vicariate_N" ;
lin vicarious_A = mkTerm "vicarious_A" ;
lin vice_N = mkTerm "vice_N" ;
lin vice_Prep = mkTerm "vice_Prep" ;
lin vice_president_N = mkTerm "vice_president_N" ;
lin vice_versa_Adv = mkTerm "vice_versa_Adv" ;
lin vicegerent_N = mkTerm "vicegerent_N" ;
lin vicenary_A = mkTerm "vicenary_A" ;
lin vicennial_A = mkTerm "vicennial_A" ;
lin vicenza_PN = mkTerm "vicenza_PN" ;
lin viceregal_A = mkTerm "viceregal_A" ;
lin vicereine_N = mkTerm "vicereine_N" ;
lin viceroy_N = mkTerm "viceroy_N" ;
lin viceroyalty_N = mkTerm "viceroyalty_N" ;
lin viceroyship_N = mkTerm "viceroyship_N" ;
lin vichyssoise_N = mkTerm "vichyssoise_N" ;
lin vicinal_A = mkTerm "vicinal_A" ;
lin vicinity_N = mkTerm "vicinity_N" ;
lin vicious_A = mkTerm "vicious_A" ;
lin viciousness_N = mkTerm "viciousness_N" ;
lin vicissitude_N = mkTerm "vicissitude_N" ;
lin vicky_PN = mkTerm "vicky_PN" ;
lin victim_N = mkTerm "victim_N" ;
lin victimization_N = mkTerm "victimization_N" ;
lin victimize_V2 = mkTerm "victimize_V2" ;
lin victimizer_N = mkTerm "victimizer_N" ;
lin victor_N = mkTerm "victor_N" ;
lin victor_PN = mkTerm "victor_PN" ;
lin victoria_N = mkTerm "victoria_N" ;
lin victoria_PN = mkTerm "victoria_PN" ;
lin victorian_A = mkTerm "victorian_A" ;
lin victorian_N = mkTerm "victorian_N" ;
lin victoriana_N = mkTerm "victoriana_N" ;
lin victorious_A = mkTerm "victorious_A" ;
lin victory_N = mkTerm "victory_N" ;
lin victual_N = mkTerm "victual_N" ;
lin victual_V = mkTerm "victual_V" ;
lin victual_V2 = mkTerm "victual_V2" ;
lin victualer_N = mkTerm "victualer_N" ;
lin victualler_N = mkTerm "victualler_N" ;
lin vicuna_N = mkTerm "vicuna_N" ;
lin videlicet_Adv = mkTerm "videlicet_Adv" ;
lin video_N = mkTerm "video_N" ;
lin video_taped_A = mkTerm "video_taped_A" ;
lin videocassette_N = mkTerm "videocassette_N" ;
lin videodisk_N = mkTerm "videodisk_N" ;
lin videogame_N = mkTerm "videogame_N" ;
lin videotape_N = mkTerm "videotape_N" ;
lin videotape_V2 = mkTerm "videotape_V2" ;
lin vie_V = mkTerm "vie_V" ;
lin vienna_PN = mkTerm "vienna_PN" ;
lin vieremä_PN = mkTerm "vieremä_PN" ;
lin vietnam_PN = mkTerm "vietnam_PN" ;
lin vietnamese_A = mkTerm "vietnamese_A" ;
lin vietnamese_N = mkTerm "vietnamese_N" ;
lin view_1_N = mkTerm "view_1_N" ;
lin view_2_N = mkTerm "view_2_N" ;
lin view_V2 = mkTerm "view_V2" ;
lin viewable_A = mkTerm "viewable_A" ;
lin viewer_N = mkTerm "viewer_N" ;
lin viewfinder_N = mkTerm "viewfinder_N" ;
lin viewgraph_N = mkTerm "viewgraph_N" ;
lin viewless_A = mkTerm "viewless_A" ;
lin viewpark_PN = mkTerm "viewpark_PN" ;
lin viewpoint_N = mkTerm "viewpoint_N" ;
lin vigesimal_A = mkTerm "vigesimal_A" ;
lin vigil_N = mkTerm "vigil_N" ;
lin vigilance_N = mkTerm "vigilance_N" ;
lin vigilant_A = mkTerm "vigilant_A" ;
lin vigilante_N = mkTerm "vigilante_N" ;
lin vigilantism_N = mkTerm "vigilantism_N" ;
lin vignette_N = mkTerm "vignette_N" ;
lin vigo_PN = mkTerm "vigo_PN" ;
lin vigor_N = mkTerm "vigor_N" ;
lin vigorous_A = mkTerm "vigorous_A" ;
lin vigour_N = mkTerm "vigour_N" ;
lin vihanti_PN = mkTerm "vihanti_PN" ;
lin vihti_PN = mkTerm "vihti_PN" ;
lin viiala_PN = mkTerm "viiala_PN" ;
lin viitasaari_PN = mkTerm "viitasaari_PN" ;
lin viking_N = mkTerm "viking_N" ;
lin vile_A = mkTerm "vile_A" ;
lin vileness_N = mkTerm "vileness_N" ;
lin vilification_N = mkTerm "vilification_N" ;
lin vilify_V2 = mkTerm "vilify_V2" ;
lin viljakkala_PN = mkTerm "viljakkala_PN" ;
lin villa_N = mkTerm "villa_N" ;
lin village_N = mkTerm "village_N" ;
lin villager_N = mkTerm "villager_N" ;
lin villain_N = mkTerm "villain_N" ;
lin villainess_N = mkTerm "villainess_N" ;
lin villainous_A = mkTerm "villainous_A" ;
lin villainy_N = mkTerm "villainy_N" ;
lin villein_N = mkTerm "villein_N" ;
lin villeinage_N = mkTerm "villeinage_N" ;
lin villus_N = mkTerm "villus_N" ;
lin vilppula_PN = mkTerm "vilppula_PN" ;
lin vim_N = mkTerm "vim_N" ;
lin vimpeli_PN = mkTerm "vimpeli_PN" ;
lin vinaceous_A = mkTerm "vinaceous_A" ;
lin vinaigrette_N = mkTerm "vinaigrette_N" ;
lin vinblastine_N = mkTerm "vinblastine_N" ;
lin vince_PN = mkTerm "vince_PN" ;
lin vincent_PN = mkTerm "vincent_PN" ;
lin vincristine_N = mkTerm "vincristine_N" ;
lin vindicate_V2 = mkTerm "vindicate_V2" ;
lin vindication_N = mkTerm "vindication_N" ;
lin vindictive_A = mkTerm "vindictive_A" ;
lin vindictiveness_N = mkTerm "vindictiveness_N" ;
lin vine_N = mkTerm "vine_N" ;
lin vinegar_N = mkTerm "vinegar_N" ;
lin vinegariness_N = mkTerm "vinegariness_N" ;
lin vinegarroon_N = mkTerm "vinegarroon_N" ;
lin vinegary_A = mkTerm "vinegary_A" ;
lin vinery_N = mkTerm "vinery_N" ;
lin vineyard_N = mkTerm "vineyard_N" ;
lin vinifera_N = mkTerm "vinifera_N" ;
lin vinification_N = mkTerm "vinification_N" ;
lin vinkkilä_PN = mkTerm "vinkkilä_PN" ;
lin vinous_A = mkTerm "vinous_A" ;
lin vintage_A = mkTerm "vintage_A" ;
lin vintage_N = mkTerm "vintage_N" ;
lin vintager_N = mkTerm "vintager_N" ;
lin vintner_N = mkTerm "vintner_N" ;
lin vinyl_N = mkTerm "vinyl_N" ;
lin viol_N = mkTerm "viol_N" ;
lin viola_N = mkTerm "viola_N" ;
lin viola_PN = mkTerm "viola_PN" ;
lin violable_A = mkTerm "violable_A" ;
lin violate_V2 = mkTerm "violate_V2" ;
lin violation_N = mkTerm "violation_N" ;
lin violator_N = mkTerm "violator_N" ;
lin violence_N = mkTerm "violence_N" ;
lin violent_A = mkTerm "violent_A" ;
lin violet_N = mkTerm "violet_N" ;
lin violet_PN = mkTerm "violet_PN" ;
lin violin_N = mkTerm "violin_N" ;
lin violinistFem_N = mkTerm "violinistFem_N" ;
lin violinistMasc_N = mkTerm "violinistMasc_N" ;
lin violistFem_N = mkTerm "violistFem_N" ;
lin violistMasc_N = mkTerm "violistMasc_N" ;
lin viomycin_N = mkTerm "viomycin_N" ;
lin vip_N = mkTerm "vip_N" ;
lin viper_N = mkTerm "viper_N" ;
lin virago_N = mkTerm "virago_N" ;
lin viral_A = mkTerm "viral_A" ;
lin viremia_N = mkTerm "viremia_N" ;
lin vireo_N = mkTerm "vireo_N" ;
lin virga_N = mkTerm "virga_N" ;
lin virgin_A = mkTerm "virgin_A" ;
lin virgin_N = mkTerm "virgin_N" ;
lin virginal_A = mkTerm "virginal_A" ;
lin virginal_N = mkTerm "virginal_N" ;
lin virginia_N = mkTerm "virginia_N" ;
lin virginia_PN = mkTerm "virginia_PN" ;
lin virginia_water_PN = mkTerm "virginia_water_PN" ;
lin virginity_N = mkTerm "virginity_N" ;
lin virgo_PN = mkTerm "virgo_PN" ;
lin virgule_N = mkTerm "virgule_N" ;
lin viricidal_A = mkTerm "viricidal_A" ;
lin viricide_N = mkTerm "viricide_N" ;
lin virile_A = mkTerm "virile_A" ;
lin virilism_N = mkTerm "virilism_N" ;
lin virility_N = mkTerm "virility_N" ;
lin virino_N = mkTerm "virino_N" ;
lin virion_N = mkTerm "virion_N" ;
lin viroid_N = mkTerm "viroid_N" ;
lin virojoki_PN = mkTerm "virojoki_PN" ;
lin virolahti_PN = mkTerm "virolahti_PN" ;
lin virological_A = mkTerm "virological_A" ;
lin virologist_N = mkTerm "virologist_N" ;
lin virology_N = mkTerm "virology_N" ;
lin virrat_PN = mkTerm "virrat_PN" ;
lin virtasalmi_PN = mkTerm "virtasalmi_PN" ;
lin virtu_N = mkTerm "virtu_N" ;
lin virtual_A = mkTerm "virtual_A" ;
lin virtue_N = mkTerm "virtue_N" ;
lin virtuosity_N = mkTerm "virtuosity_N" ;
lin virtuoso_N = mkTerm "virtuoso_N" ;
lin virtuous_A = mkTerm "virtuous_A" ;
lin virulence_N = mkTerm "virulence_N" ;
lin virulent_A = mkTerm "virulent_A" ;
lin virus_N = mkTerm "virus_N" ;
lin vis_a_vis_Adv = mkTerm "vis_a_vis_Adv" ;
lin vis_a_vis_Prep = mkTerm "vis_a_vis_Prep" ;
lin visa_N = mkTerm "visa_N" ;
lin visa_V2 = mkTerm "visa_V2" ;
lin visage_N = mkTerm "visage_N" ;
lin visaged_A = mkTerm "visaged_A" ;
lin viscacha_N = mkTerm "viscacha_N" ;
lin viscera_N = mkTerm "viscera_N" ;
lin visceral_A = mkTerm "visceral_A" ;
lin viscid_A = mkTerm "viscid_A" ;
lin viscoelastic_A = mkTerm "viscoelastic_A" ;
lin viscometer_N = mkTerm "viscometer_N" ;
lin viscometric_A = mkTerm "viscometric_A" ;
lin viscometry_N = mkTerm "viscometry_N" ;
lin viscosity_N = mkTerm "viscosity_N" ;
lin viscount_N = mkTerm "viscount_N" ;
lin viscountcy_N = mkTerm "viscountcy_N" ;
lin viscountess_N = mkTerm "viscountess_N" ;
lin viscounty_N = mkTerm "viscounty_N" ;
lin viscous_A = mkTerm "viscous_A" ;
lin vise_N = mkTerm "vise_N" ;
lin viselike_A = mkTerm "viselike_A" ;
lin visibility_N = mkTerm "visibility_N" ;
lin visible_A = mkTerm "visible_A" ;
lin vision_N = mkTerm "vision_N" ;
lin visionary_A = mkTerm "visionary_A" ;
lin visionary_N = mkTerm "visionary_N" ;
lin visit_N = mkTerm "visit_N" ;
lin visit_V = mkTerm "visit_V" ;
lin visit_V2 = mkTerm "visit_V2" ;
lin visitant_N = mkTerm "visitant_N" ;
lin visitation_N = mkTerm "visitation_N" ;
lin visiting_N = mkTerm "visiting_N" ;
lin visitor_N = mkTerm "visitor_N" ;
lin visor_N = mkTerm "visor_N" ;
lin visored_A = mkTerm "visored_A" ;
lin vista_N = mkTerm "vista_N" ;
lin visual_A = mkTerm "visual_A" ;
lin visual_N = mkTerm "visual_N" ;
lin visualization_N = mkTerm "visualization_N" ;
lin visualize_V2 = mkTerm "visualize_V2" ;
lin visualizer_N = mkTerm "visualizer_N" ;
lin vital_A = mkTerm "vital_A" ;
lin vitalism_N = mkTerm "vitalism_N" ;
lin vitalist_N = mkTerm "vitalist_N" ;
lin vitality_N = mkTerm "vitality_N" ;
lin vitalization_N = mkTerm "vitalization_N" ;
lin vitalize_V2 = mkTerm "vitalize_V2" ;
lin vitalness_N = mkTerm "vitalness_N" ;
lin vitamin_N = mkTerm "vitamin_N" ;
lin vitiate_V2 = mkTerm "vitiate_V2" ;
lin vitiation_N = mkTerm "vitiation_N" ;
lin viticulture_N = mkTerm "viticulture_N" ;
lin viticulturist_N = mkTerm "viticulturist_N" ;
lin vitiliginous_A = mkTerm "vitiliginous_A" ;
lin vitiligo_N = mkTerm "vitiligo_N" ;
lin vitoria_PN = mkTerm "vitoria_PN" ;
lin vitrectomy_N = mkTerm "vitrectomy_N" ;
lin vitreous_A = mkTerm "vitreous_A" ;
lin vitrification_N = mkTerm "vitrification_N" ;
lin vitrify_V = mkTerm "vitrify_V" ;
lin vitrify_V2 = mkTerm "vitrify_V2" ;
lin vitriol_N = mkTerm "vitriol_N" ;
lin vitriolic_A = mkTerm "vitriolic_A" ;
lin vituperate_V2 = mkTerm "vituperate_V2" ;
lin vituperation_N = mkTerm "vituperation_N" ;
lin vituperative_A = mkTerm "vituperative_A" ;
lin viv_PN = mkTerm "viv_PN" ;
lin viva_N = mkTerm "viva_N" ;
lin viva_voce_A = mkTerm "viva_voce_A" ;
lin viva_voce_Adv = mkTerm "viva_voce_Adv" ;
lin viva_voce_N = mkTerm "viva_voce_N" ;
lin vivace_A = mkTerm "vivace_A" ;
lin vivace_Adv = mkTerm "vivace_Adv" ;
lin vivacious_A = mkTerm "vivacious_A" ;
lin vivacity_N = mkTerm "vivacity_N" ;
lin vivarium_N = mkTerm "vivarium_N" ;
lin viverrine_N = mkTerm "viverrine_N" ;
lin vivian_PN = mkTerm "vivian_PN" ;
lin vivid_A = mkTerm "vivid_A" ;
lin vividness_N = mkTerm "vividness_N" ;
lin vivien_PN = mkTerm "vivien_PN" ;
lin vivienne_PN = mkTerm "vivienne_PN" ;
lin vivification_N = mkTerm "vivification_N" ;
lin viviparous_A = mkTerm "viviparous_A" ;
lin vivisect_V2 = mkTerm "vivisect_V2" ;
lin vivisection_N = mkTerm "vivisection_N" ;
lin vivisectionist_N = mkTerm "vivisectionist_N" ;
lin vixen_N = mkTerm "vixen_N" ;
lin vixenish_A = mkTerm "vixenish_A" ;
lin viz_PN = mkTerm "viz_PN" ;
lin vizier_N = mkTerm "vizier_N" ;
lin viziership_N = mkTerm "viziership_N" ;
lin vizsla_N = mkTerm "vizsla_N" ;
lin vocable_N = mkTerm "vocable_N" ;
lin vocabulary_N = mkTerm "vocabulary_N" ;
lin vocal_A = mkTerm "vocal_A" ;
lin vocal_N = mkTerm "vocal_N" ;
lin vocalic_A = mkTerm "vocalic_A" ;
lin vocalist_N = mkTerm "vocalist_N" ;
lin vocalize_V2 = mkTerm "vocalize_V2" ;
lin vocation_N = mkTerm "vocation_N" ;
lin vocational_A = mkTerm "vocational_A" ;
lin vocative_A = mkTerm "vocative_A" ;
lin vocative_N = mkTerm "vocative_N" ;
lin vociferate_V = mkTerm "vociferate_V" ;
lin vociferate_V2 = mkTerm "vociferate_V2" ;
lin vociferation_N = mkTerm "vociferation_N" ;
lin vociferator_N = mkTerm "vociferator_N" ;
lin vociferous_A = mkTerm "vociferous_A" ;
lin vodka_N = mkTerm "vodka_N" ;
lin vogue_N = mkTerm "vogue_N" ;
lin voice_N = mkTerm "voice_N" ;
lin voice_V2 = mkTerm "voice_V2" ;
lin voiceless_A = mkTerm "voiceless_A" ;
lin voicelessness_N = mkTerm "voicelessness_N" ;
lin voiceprint_N = mkTerm "voiceprint_N" ;
lin voicer_N = mkTerm "voicer_N" ;
lin voicing_N = mkTerm "voicing_N" ;
lin void_A = mkTerm "void_A" ;
lin void_N = mkTerm "void_N" ;
lin void_V2 = mkTerm "void_V2" ;
lin voider_N = mkTerm "voider_N" ;
lin voile_N = mkTerm "voile_N" ;
lin vol_N = mkTerm "vol_N" ;
lin volatile_A = mkTerm "volatile_A" ;
lin volatile_N = mkTerm "volatile_N" ;
lin volatility_N = mkTerm "volatility_N" ;
lin volcanic_A = mkTerm "volcanic_A" ;
lin volcanism_N = mkTerm "volcanism_N" ;
lin volcano_N = mkTerm "volcano_N" ;
lin volcanology_N = mkTerm "volcanology_N" ;
lin vole_N = mkTerm "vole_N" ;
lin volgograd_PN = mkTerm "volgograd_PN" ;
lin volition_N = mkTerm "volition_N" ;
lin volitional_A = mkTerm "volitional_A" ;
lin volley_N = mkTerm "volley_N" ;
lin volley_V = mkTerm "volley_V" ;
lin volley_V2 = mkTerm "volley_V2" ;
lin volleyball_N = mkTerm "volleyball_N" ;
lin volt_N = mkTerm "volt_N" ;
lin voltage_N = mkTerm "voltage_N" ;
lin voltaic_A = mkTerm "voltaic_A" ;
lin volte_face_N = mkTerm "volte_face_N" ;
lin voltmeter_N = mkTerm "voltmeter_N" ;
lin volubility_N = mkTerm "volubility_N" ;
lin voluble_A = mkTerm "voluble_A" ;
lin volume_N = mkTerm "volume_N" ;
lin volumed_A = mkTerm "volumed_A" ;
lin volumeter_N = mkTerm "volumeter_N" ;
lin volumetric_A = mkTerm "volumetric_A" ;
lin voluminous_A = mkTerm "voluminous_A" ;
lin voluntary_A = mkTerm "voluntary_A" ;
lin voluntary_N = mkTerm "voluntary_N" ;
lin volunteerFem_N = mkTerm "volunteerFem_N" ;
lin volunteerMasc_N = mkTerm "volunteerMasc_N" ;
lin volunteer_V = mkTerm "volunteer_V" ;
lin volunteer_V2 = mkTerm "volunteer_V2" ;
lin voluptuary_N = mkTerm "voluptuary_N" ;
lin voluptuous_A = mkTerm "voluptuous_A" ;
lin voluptuousness_N = mkTerm "voluptuousness_N" ;
lin volute_N = mkTerm "volute_N" ;
lin voluted_A = mkTerm "voluted_A" ;
lin volution_N = mkTerm "volution_N" ;
lin volva_N = mkTerm "volva_N" ;
lin volvulus_N = mkTerm "volvulus_N" ;
lin vomer_N = mkTerm "vomer_N" ;
lin vomit_N = mkTerm "vomit_N" ;
lin vomit_V = mkTerm "vomit_V" ;
lin vomit_V2 = mkTerm "vomit_V2" ;
lin vomiter_N = mkTerm "vomiter_N" ;
lin vomitory_N = mkTerm "vomitory_N" ;
lin voodoo_N = mkTerm "voodoo_N" ;
lin voodooism_N = mkTerm "voodooism_N" ;
lin voracious_A = mkTerm "voracious_A" ;
lin voracity_N = mkTerm "voracity_N" ;
lin voronezh_PN = mkTerm "voronezh_PN" ;
lin vortex_N = mkTerm "vortex_N" ;
lin vorticella_N = mkTerm "vorticella_N" ;
lin votary_N = mkTerm "votary_N" ;
lin vote_N = mkTerm "vote_N" ;
lin vote_V = mkTerm "vote_V" ;
lin vote_V2 = mkTerm "vote_V2" ;
lin vote_V3 = mkTerm "vote_V3" ;
lin vote_VV = mkTerm "vote_VV" ;
lin vote_down_V = mkTerm "vote_down_V" ;
lin voteless_A = mkTerm "voteless_A" ;
lin voter_N = mkTerm "voter_N" ;
lin votive_A = mkTerm "votive_A" ;
lin vouch_V = mkTerm "vouch_V" ;
lin vouchee_N = mkTerm "vouchee_N" ;
lin voucher_1_N = mkTerm "voucher_1_N" ;
lin voucher_2_N = mkTerm "voucher_2_N" ;
lin vouchsafe_V2 = mkTerm "vouchsafe_V2" ;
lin vouge_N = mkTerm "vouge_N" ;
lin voussoir_N = mkTerm "voussoir_N" ;
lin vow_N = mkTerm "vow_N" ;
lin vow_V2 = mkTerm "vow_V2" ;
lin vow_VS = mkTerm "vow_VS" ;
lin vow_VV = mkTerm "vow_VV" ;
lin vowel_N = mkTerm "vowel_N" ;
lin vowellike_A = mkTerm "vowellike_A" ;
lin vower_N = mkTerm "vower_N" ;
lin vox_N = mkTerm "vox_N" ;
lin vox_populi_N = mkTerm "vox_populi_N" ;
lin voyage_N = mkTerm "voyage_N" ;
lin voyage_V = mkTerm "voyage_V" ;
lin voyager_N = mkTerm "voyager_N" ;
lin voyeur_N = mkTerm "voyeur_N" ;
lin voyeurism_N = mkTerm "voyeurism_N" ;
lin voyeuristic_A = mkTerm "voyeuristic_A" ;
lin vp_N = mkTerm "vp_N" ;
lin vroom_N = mkTerm "vroom_N" ;
lin vs_PN = mkTerm "vs_PN" ;
lin vs_Prep = mkTerm "vs_Prep" ;
lin vso_PN = mkTerm "vso_PN" ;
lin vulcanite_N = mkTerm "vulcanite_N" ;
lin vulcanization_N = mkTerm "vulcanization_N" ;
lin vulcanize_V2 = mkTerm "vulcanize_V2" ;
lin vulcanizer_N = mkTerm "vulcanizer_N" ;
lin vulgar_A = mkTerm "vulgar_A" ;
lin vulgarian_N = mkTerm "vulgarian_N" ;
lin vulgarism_N = mkTerm "vulgarism_N" ;
lin vulgarity_N = mkTerm "vulgarity_N" ;
lin vulgarization_N = mkTerm "vulgarization_N" ;
lin vulgarize_V2 = mkTerm "vulgarize_V2" ;
lin vulgarizer_N = mkTerm "vulgarizer_N" ;
lin vulgate_N = mkTerm "vulgate_N" ;
lin vulnerability_N = mkTerm "vulnerability_N" ;
lin vulnerable_A = mkTerm "vulnerable_A" ;
lin vulpine_A = mkTerm "vulpine_A" ;
lin vulture_N = mkTerm "vulture_N" ;
lin vulva_N = mkTerm "vulva_N" ;
lin vulvar_A = mkTerm "vulvar_A" ;
lin vulvectomy_N = mkTerm "vulvectomy_N" ;
lin vulvitis_N = mkTerm "vulvitis_N" ;
lin vulvovaginitis_N = mkTerm "vulvovaginitis_N" ;
lin vuokatti_PN = mkTerm "vuokatti_PN" ;
lin vuolijoki_PN = mkTerm "vuolijoki_PN" ;
lin vähäkyrö_PN = mkTerm "vähäkyrö_PN" ;
lin västanfjärd_PN = mkTerm "västanfjärd_PN" ;
lin vörå_PN = mkTerm "vörå_PN" ;
lin wad_N = mkTerm "wad_N" ;
lin wad_V2 = mkTerm "wad_V2" ;
lin wad_VS = mkTerm "wad_VS" ;
lin wadding_N = mkTerm "wadding_N" ;
lin waddle_N = mkTerm "waddle_N" ;
lin waddle_V = mkTerm "waddle_V" ;
lin waddler_N = mkTerm "waddler_N" ;
lin wade_V = mkTerm "wade_V" ;
lin wade_V2 = mkTerm "wade_V2" ;
lin wade_in_V = mkTerm "wade_in_V" ;
lin wade_into_V2 = mkTerm "wade_into_V2" ;
lin wade_through_V2 = mkTerm "wade_through_V2" ;
lin wader_N = mkTerm "wader_N" ;
lin waders_N = mkTerm "waders_N" ;
lin wadi_N = mkTerm "wadi_N" ;
lin wading_N = mkTerm "wading_N" ;
lin wafer_N = mkTerm "wafer_N" ;
lin waffle_N = mkTerm "waffle_N" ;
lin waffle_V = mkTerm "waffle_V" ;
lin waffle_V2 = mkTerm "waffle_V2" ;
lin waffler_N = mkTerm "waffler_N" ;
lin waft_N = mkTerm "waft_N" ;
lin waft_V2 = mkTerm "waft_V2" ;
lin wag_N = mkTerm "wag_N" ;
lin wag_V = mkTerm "wag_V" ;
lin wag_V2 = mkTerm "wag_V2" ;
lin wage_N = mkTerm "wage_N" ;
lin wage_V2 = mkTerm "wage_V2" ;
lin wage_claim_N = mkTerm "wage_claim_N" ;
lin wage_earner_N = mkTerm "wage_earner_N" ;
lin wage_freeze_N = mkTerm "wage_freeze_N" ;
lin wager_N = mkTerm "wager_N" ;
lin wager_V = mkTerm "wager_V" ;
lin wager_V2 = mkTerm "wager_V2" ;
lin wages_N = mkTerm "wages_N" ;
lin waggery_N = mkTerm "waggery_N" ;
lin waggish_A = mkTerm "waggish_A" ;
lin waggishness_N = mkTerm "waggishness_N" ;
lin waggle_V = mkTerm "waggle_V" ;
lin waggle_V2 = mkTerm "waggle_V2" ;
lin waggon_N = mkTerm "waggon_N" ;
lin waggoner_N = mkTerm "waggoner_N" ;
lin wagon_N = mkTerm "wagon_N" ;
lin wagon_lit_N = mkTerm "wagon_lit_N" ;
lin wagoner_N = mkTerm "wagoner_N" ;
lin wagonwright_N = mkTerm "wagonwright_N" ;
lin wagtail_N = mkTerm "wagtail_N" ;
lin wahoo_N = mkTerm "wahoo_N" ;
lin waif_N = mkTerm "waif_N" ;
lin wail_N = mkTerm "wail_N" ;
lin wail_V = mkTerm "wail_V" ;
lin wail_V2 = mkTerm "wail_V2" ;
lin wailer_N = mkTerm "wailer_N" ;
lin wailing_N = mkTerm "wailing_N" ;
lin wain_N = mkTerm "wain_N" ;
lin wainscot_N = mkTerm "wainscot_N" ;
lin wainscoted_A = mkTerm "wainscoted_A" ;
lin wainscoting_N = mkTerm "wainscoting_N" ;
lin waist_N = mkTerm "waist_N" ;
lin waist_deep_A = mkTerm "waist_deep_A" ;
lin waist_deep_Adv = mkTerm "waist_deep_Adv" ;
lin waist_high_A = mkTerm "waist_high_A" ;
lin waist_high_Adv = mkTerm "waist_high_Adv" ;
lin waistband_N = mkTerm "waistband_N" ;
lin waistcoat_N = mkTerm "waistcoat_N" ;
lin waistline_N = mkTerm "waistline_N" ;
lin wait_N = mkTerm "wait_N" ;
lin wait_V = mkTerm "wait_V" ;
lin wait_V2 = mkTerm "wait_V2" ;
lin wait_VV = mkTerm "wait_VV" ;
lin wait_about_V = mkTerm "wait_about_V" ;
lin wait_around_V = mkTerm "wait_around_V" ;
lin wait_behind_V = mkTerm "wait_behind_V" ;
lin wait_in_V = mkTerm "wait_in_V" ;
lin wait_on_V2 = mkTerm "wait_on_V2" ;
lin wait_out_V2 = mkTerm "wait_out_V2" ;
lin wait_up_V = mkTerm "wait_up_V" ;
lin wait_up_for_V2 = mkTerm "wait_up_for_V2" ;
lin wait_upon_V2 = mkTerm "wait_upon_V2" ;
lin waiter_N = mkTerm "waiter_N" ;
lin waiting_A = mkTerm "waiting_A" ;
lin waiting_N = mkTerm "waiting_N" ;
lin waiting_list_N = mkTerm "waiting_list_N" ;
lin waiting_room_N = mkTerm "waiting_room_N" ;
lin waitress_N = mkTerm "waitress_N" ;
lin waive_V2 = mkTerm "waive_V2" ;
lin waiver_N = mkTerm "waiver_N" ;
lin waiver_V = mkTerm "waiver_V" ;
lin wake_N = mkTerm "wake_N" ;
lin wake_V = mkTerm "wake_V" ;
lin wake_V2 = mkTerm "wake_V2" ;
lin wake_up_V = mkTerm "wake_up_V" ;
lin wake_up_V2 = mkTerm "wake_up_V2" ;
lin wakefield_PN = mkTerm "wakefield_PN" ;
lin wakeful_A = mkTerm "wakeful_A" ;
lin wakefulness_N = mkTerm "wakefulness_N" ;
lin waken_V = mkTerm "waken_V" ;
lin waken_V2 = mkTerm "waken_V2" ;
lin waker_N = mkTerm "waker_N" ;
lin waking_N = mkTerm "waking_N" ;
lin wale_N = mkTerm "wale_N" ;
lin wales_PN = mkTerm "wales_PN" ;
lin walk_N = mkTerm "walk_N" ;
lin walk_V = mkTerm "walk_V" ;
lin walk_V2 = mkTerm "walk_V2" ;
lin walk_away_from_V2 = mkTerm "walk_away_from_V2" ;
lin walk_away_with_V2 = mkTerm "walk_away_with_V2" ;
lin walk_back_from_V2 = mkTerm "walk_back_from_V2" ;
lin walk_by_V = mkTerm "walk_by_V" ;
lin walk_in_V = mkTerm "walk_in_V" ;
lin walk_in_on_V2 = mkTerm "walk_in_on_V2" ;
lin walk_into_V2 = mkTerm "walk_into_V2" ;
lin walk_off_V2 = mkTerm "walk_off_V2" ;
lin walk_off_with_V2 = mkTerm "walk_off_with_V2" ;
lin walk_on_V = mkTerm "walk_on_V" ;
lin walk_out_V = mkTerm "walk_out_V" ;
lin walk_out_on_V2 = mkTerm "walk_out_on_V2" ;
lin walk_through_V3 = mkTerm "walk_through_V3" ;
lin walk_up_V = mkTerm "walk_up_V" ;
lin walkabout_N = mkTerm "walkabout_N" ;
lin walkaway_N = mkTerm "walkaway_N" ;
lin walker_N = mkTerm "walker_N" ;
lin walkie_talkie_N = mkTerm "walkie_talkie_N" ;
lin walking_A = mkTerm "walking_A" ;
lin walking_N = mkTerm "walking_N" ;
lin walkout_N = mkTerm "walkout_N" ;
lin walkover_N = mkTerm "walkover_N" ;
lin walkway_N = mkTerm "walkway_N" ;
lin wall_N = mkTerm "wall_N" ;
lin wall_V2 = mkTerm "wall_V2" ;
lin wall_eyed_A = mkTerm "wall_eyed_A" ;
lin wall_off_V = mkTerm "wall_off_V" ;
lin wall_painting_N = mkTerm "wall_painting_N" ;
lin wall_street_PN = mkTerm "wall_street_PN" ;
lin wallaby_N = mkTerm "wallaby_N" ;
lin wallace_PN = mkTerm "wallace_PN" ;
lin wallah_N = mkTerm "wallah_N" ;
lin wallasey_PN = mkTerm "wallasey_PN" ;
lin wallboard_N = mkTerm "wallboard_N" ;
lin wallet_N = mkTerm "wallet_N" ;
lin walleye_N = mkTerm "walleye_N" ;
lin wallflower_N = mkTerm "wallflower_N" ;
lin wallingford_PN = mkTerm "wallingford_PN" ;
lin wallop_N = mkTerm "wallop_N" ;
lin wallop_V2 = mkTerm "wallop_V2" ;
lin walloper_N = mkTerm "walloper_N" ;
lin walloping_A = mkTerm "walloping_A" ;
lin wallow_N = mkTerm "wallow_N" ;
lin wallow_V = mkTerm "wallow_V" ;
lin wallpaper_N = mkTerm "wallpaper_N" ;
lin wallpaperer_N = mkTerm "wallpaperer_N" ;
lin wallsend_PN = mkTerm "wallsend_PN" ;
lin wally_N = mkTerm "wally_N" ;
lin wally_PN = mkTerm "wally_PN" ;
lin walnut_N = mkTerm "walnut_N" ;
lin walrus_N = mkTerm "walrus_N" ;
lin walsall_PN = mkTerm "walsall_PN" ;
lin walsham_PN = mkTerm "walsham_PN" ;
lin walter_PN = mkTerm "walter_PN" ;
lin waltham_forest_PN = mkTerm "waltham_forest_PN" ;
lin walton_PN = mkTerm "walton_PN" ;
lin waltz_N = mkTerm "waltz_N" ;
lin waltz_V = mkTerm "waltz_V" ;
lin waltz_V2 = mkTerm "waltz_V2" ;
lin waltz_through_V2 = mkTerm "waltz_through_V2" ;
lin waltzer_N = mkTerm "waltzer_N" ;
lin wampum_N = mkTerm "wampum_N" ;
lin wan_A = mkTerm "wan_A" ;
lin wand_N = mkTerm "wand_N" ;
lin wander_V = mkTerm "wander_V" ;
lin wander_off_V = mkTerm "wander_off_V" ;
lin wanderer_N = mkTerm "wanderer_N" ;
lin wandering_N = mkTerm "wandering_N" ;
lin wanderlust_N = mkTerm "wanderlust_N" ;
lin wandflower_N = mkTerm "wandflower_N" ;
lin wandsworth_PN = mkTerm "wandsworth_PN" ;
lin wane_N = mkTerm "wane_N" ;
lin wane_V = mkTerm "wane_V" ;
lin wangle_N = mkTerm "wangle_N" ;
lin wangle_V2 = mkTerm "wangle_V2" ;
lin waning_N = mkTerm "waning_N" ;
lin wank_N = mkTerm "wank_N" ;
lin wank_V = mkTerm "wank_V" ;
lin wanness_N = mkTerm "wanness_N" ;
lin want_N = mkTerm "want_N" ;
lin want_V = mkTerm "want_V" ;
lin want_V2 = mkTerm "want_V2" ;
lin want_V2V = mkTerm "want_V2V" ;
lin want_ad_N = mkTerm "want_ad_N" ;
lin want_in_V = mkTerm "want_in_V" ;
lin want_out_V = mkTerm "want_out_V" ;
lin wantage_PN = mkTerm "wantage_PN" ;
lin wanter_N = mkTerm "wanter_N" ;
lin wanton_A = mkTerm "wanton_A" ;
lin wanton_N = mkTerm "wanton_N" ;
lin wanton_V = mkTerm "wanton_V" ;
lin wantonness_N = mkTerm "wantonness_N" ;
lin wapiti_N = mkTerm "wapiti_N" ;
lin war_N = mkTerm "war_N" ;
lin war_V = mkTerm "war_V" ;
lin war_baby_N = mkTerm "war_baby_N" ;
lin war_bride_N = mkTerm "war_bride_N" ;
lin war_cloud_N = mkTerm "war_cloud_N" ;
lin war_cry_N = mkTerm "war_cry_N" ;
lin war_dance_N = mkTerm "war_dance_N" ;
lin war_god_N = mkTerm "war_god_N" ;
lin war_torn_A = mkTerm "war_torn_A" ;
lin war_widow_N = mkTerm "war_widow_N" ;
lin waratah_N = mkTerm "waratah_N" ;
lin warble_N = mkTerm "warble_N" ;
lin warble_V = mkTerm "warble_V" ;
lin warble_V2 = mkTerm "warble_V2" ;
lin warbler_N = mkTerm "warbler_N" ;
lin ward_N = mkTerm "ward_N" ;
lin ward_V2 = mkTerm "ward_V2" ;
lin ward_off_V = mkTerm "ward_off_V" ;
lin warden_N = mkTerm "warden_N" ;
lin wardenship_N = mkTerm "wardenship_N" ;
lin warder_N = mkTerm "warder_N" ;
lin wardership_N = mkTerm "wardership_N" ;
lin wardress_N = mkTerm "wardress_N" ;
lin wardrobe_N = mkTerm "wardrobe_N" ;
lin wardroom_N = mkTerm "wardroom_N" ;
lin ware_N = mkTerm "ware_N" ;
lin ware_PN = mkTerm "ware_PN" ;
lin ware_V2 = mkTerm "ware_V2" ;
lin warehouse_N = mkTerm "warehouse_N" ;
lin warehouser_N = mkTerm "warehouser_N" ;
lin warehousing_N = mkTerm "warehousing_N" ;
lin warfare_N = mkTerm "warfare_N" ;
lin warfarin_N = mkTerm "warfarin_N" ;
lin warhead_N = mkTerm "warhead_N" ;
lin warhorse_N = mkTerm "warhorse_N" ;
lin wariness_N = mkTerm "wariness_N" ;
lin warley_PN = mkTerm "warley_PN" ;
lin warlike_A = mkTerm "warlike_A" ;
lin warlock_N = mkTerm "warlock_N" ;
lin warlord_N = mkTerm "warlord_N" ;
lin warm_A = mkTerm "warm_A" ;
lin warm_V = mkTerm "warm_V" ;
lin warm_V2 = mkTerm "warm_V2" ;
lin warm_blooded_A = mkTerm "warm_blooded_A" ;
lin warm_hearted_A = mkTerm "warm_hearted_A" ;
lin warm_up_V = mkTerm "warm_up_V" ;
lin warmer_N = mkTerm "warmer_N" ;
lin warmheartedness_N = mkTerm "warmheartedness_N" ;
lin warming_pan_N = mkTerm "warming_pan_N" ;
lin warminster_PN = mkTerm "warminster_PN" ;
lin warmonger_N = mkTerm "warmonger_N" ;
lin warmongering_N = mkTerm "warmongering_N" ;
lin warmth_N = mkTerm "warmth_N" ;
lin warn_V = mkTerm "warn_V" ;
lin warn_V2 = mkTerm "warn_V2" ;
lin warn_V2V = mkTerm "warn_V2V" ;
lin warn_VS = mkTerm "warn_VS" ;
lin warner_N = mkTerm "warner_N" ;
lin warning_N = mkTerm "warning_N" ;
lin warp_N = mkTerm "warp_N" ;
lin warp_V = mkTerm "warp_V" ;
lin warp_V2 = mkTerm "warp_V2" ;
lin warpaint_N = mkTerm "warpaint_N" ;
lin warpath_N = mkTerm "warpath_N" ;
lin warplane_N = mkTerm "warplane_N" ;
lin warrant_N = mkTerm "warrant_N" ;
lin warrant_V2 = mkTerm "warrant_V2" ;
lin warrant_VS = mkTerm "warrant_VS" ;
lin warrantee_N = mkTerm "warrantee_N" ;
lin warrantor_N = mkTerm "warrantor_N" ;
lin warranty_N = mkTerm "warranty_N" ;
lin warren_N = mkTerm "warren_N" ;
lin warrener_N = mkTerm "warrener_N" ;
lin warrigal_N = mkTerm "warrigal_N" ;
lin warrington_PN = mkTerm "warrington_PN" ;
lin warrior_N = mkTerm "warrior_N" ;
lin warsaw_PN = mkTerm "warsaw_PN" ;
lin warship_N = mkTerm "warship_N" ;
lin warsop_PN = mkTerm "warsop_PN" ;
lin wart_N = mkTerm "wart_N" ;
lin warthog_N = mkTerm "warthog_N" ;
lin wartime_N = mkTerm "wartime_N" ;
lin warwick_PN = mkTerm "warwick_PN" ;
lin warwickshire_PN = mkTerm "warwickshire_PN" ;
lin wary_A = mkTerm "wary_A" ;
lin wasabi_N = mkTerm "wasabi_N" ;
lin wash_N = mkTerm "wash_N" ;
lin wash_V = mkTerm "wash_V" ;
lin wash_V2 = mkTerm "wash_V2" ;
lin wash_away_V2 = mkTerm "wash_away_V2" ;
lin wash_down_V2 = mkTerm "wash_down_V2" ;
lin wash_drawing_N = mkTerm "wash_drawing_N" ;
lin wash_hand_basin_N = mkTerm "wash_hand_basin_N" ;
lin wash_hand_stand_N = mkTerm "wash_hand_stand_N" ;
lin wash_house_N = mkTerm "wash_house_N" ;
lin wash_leather_N = mkTerm "wash_leather_N" ;
lin wash_out_V2 = mkTerm "wash_out_V2" ;
lin wash_over_V2 = mkTerm "wash_over_V2" ;
lin wash_up_V = mkTerm "wash_up_V" ;
lin wash_up_V2 = mkTerm "wash_up_V2" ;
lin washable_A = mkTerm "washable_A" ;
lin washbasin_N = mkTerm "washbasin_N" ;
lin washboard_N = mkTerm "washboard_N" ;
lin washbowl_N = mkTerm "washbowl_N" ;
lin washcloth_N = mkTerm "washcloth_N" ;
lin washday_N = mkTerm "washday_N" ;
lin washer_N = mkTerm "washer_N" ;
lin washerman_N = mkTerm "washerman_N" ;
lin washerwoman_N = mkTerm "washerwoman_N" ;
lin washing_N = mkTerm "washing_N" ;
lin washing_day_N = mkTerm "washing_day_N" ;
lin washing_machine_N = mkTerm "washing_machine_N" ;
lin washing_up_N = mkTerm "washing_up_N" ;
lin washington_PN = mkTerm "washington_PN" ;
lin washington_dc_PN = mkTerm "washington_dc_PN" ;
lin washout_N = mkTerm "washout_N" ;
lin washroom_N = mkTerm "washroom_N" ;
lin washstand_N = mkTerm "washstand_N" ;
lin washtub_N = mkTerm "washtub_N" ;
lin washup_N = mkTerm "washup_N" ;
lin washy_A = mkTerm "washy_A" ;
lin wasp_N = mkTerm "wasp_N" ;
lin wasp_waisted_A = mkTerm "wasp_waisted_A" ;
lin waspish_A = mkTerm "waspish_A" ;
lin wassail_N = mkTerm "wassail_N" ;
lin wassailer_N = mkTerm "wassailer_N" ;
lin wastage_N = mkTerm "wastage_N" ;
lin waste_A = mkTerm "waste_A" ;
lin waste_N = mkTerm "waste_N" ;
lin waste_V = mkTerm "waste_V" ;
lin waste_V2 = mkTerm "waste_V2" ;
lin waste_away_V = mkTerm "waste_away_V" ;
lin waste_paper_basket_N = mkTerm "waste_paper_basket_N" ;
lin waste_pipe_N = mkTerm "waste_pipe_N" ;
lin wastebasket_N = mkTerm "wastebasket_N" ;
lin wastebin_N = mkTerm "wastebin_N" ;
lin wasteful_A = mkTerm "wasteful_A" ;
lin wasteland_N = mkTerm "wasteland_N" ;
lin waster_N = mkTerm "waster_N" ;
lin wastrel_N = mkTerm "wastrel_N" ;
lin watch_1_V2 = mkTerm "watch_1_V2" ;
lin watch_2_V2 = mkTerm "watch_2_V2" ;
lin watch_N = mkTerm "watch_N" ;
lin watch_V = mkTerm "watch_V" ;
lin watch_V2V = mkTerm "watch_V2V" ;
lin watch_VS = mkTerm "watch_VS" ;
lin watch_chain_N = mkTerm "watch_chain_N" ;
lin watch_glass_N = mkTerm "watch_glass_N" ;
lin watch_guard_N = mkTerm "watch_guard_N" ;
lin watch_key_N = mkTerm "watch_key_N" ;
lin watch_out_V = mkTerm "watch_out_V" ;
lin watch_out_for_V2 = mkTerm "watch_out_for_V2" ;
lin watch_over_V2 = mkTerm "watch_over_V2" ;
lin watchband_N = mkTerm "watchband_N" ;
lin watchdog_N = mkTerm "watchdog_N" ;
lin watcherFem_N = mkTerm "watcherFem_N" ;
lin watcherMasc_N = mkTerm "watcherMasc_N" ;
lin watchful_A = mkTerm "watchful_A" ;
lin watchfulness_N = mkTerm "watchfulness_N" ;
lin watchmaker_N = mkTerm "watchmaker_N" ;
lin watchman_N = mkTerm "watchman_N" ;
lin watchtower_N = mkTerm "watchtower_N" ;
lin watchword_N = mkTerm "watchword_N" ;
lin water_N = mkTerm "water_N" ;
lin water_V = mkTerm "water_V" ;
lin water_V2 = mkTerm "water_V2" ;
lin water_biscuit_N = mkTerm "water_biscuit_N" ;
lin water_blister_N = mkTerm "water_blister_N" ;
lin water_bottle_N = mkTerm "water_bottle_N" ;
lin water_buffalo_N = mkTerm "water_buffalo_N" ;
lin water_butt_N = mkTerm "water_butt_N" ;
lin water_cart_N = mkTerm "water_cart_N" ;
lin water_closet_N = mkTerm "water_closet_N" ;
lin water_down_V2 = mkTerm "water_down_V2" ;
lin water_finder_N = mkTerm "water_finder_N" ;
lin water_glass_N = mkTerm "water_glass_N" ;
lin water_hole_N = mkTerm "water_hole_N" ;
lin water_ice_N = mkTerm "water_ice_N" ;
lin water_jacket_N = mkTerm "water_jacket_N" ;
lin water_level_N = mkTerm "water_level_N" ;
lin water_lily_N = mkTerm "water_lily_N" ;
lin water_line_N = mkTerm "water_line_N" ;
lin water_main_N = mkTerm "water_main_N" ;
lin water_nymph_N = mkTerm "water_nymph_N" ;
lin water_polo_N = mkTerm "water_polo_N" ;
lin water_power_N = mkTerm "water_power_N" ;
lin water_rat_N = mkTerm "water_rat_N" ;
lin water_rate_N = mkTerm "water_rate_N" ;
lin water_skiing_N = mkTerm "water_skiing_N" ;
lin water_skin_N = mkTerm "water_skin_N" ;
lin water_softener_N = mkTerm "water_softener_N" ;
lin water_spaniel_N = mkTerm "water_spaniel_N" ;
lin water_supply_N = mkTerm "water_supply_N" ;
lin water_tower_N = mkTerm "water_tower_N" ;
lin water_vole_N = mkTerm "water_vole_N" ;
lin water_waggon_N = mkTerm "water_waggon_N" ;
lin water_wagon_N = mkTerm "water_wagon_N" ;
lin water_wheel_N = mkTerm "water_wheel_N" ;
lin water_worn_A = mkTerm "water_worn_A" ;
lin waterbird_N = mkTerm "waterbird_N" ;
lin waterborne_A = mkTerm "waterborne_A" ;
lin waterbuck_N = mkTerm "waterbuck_N" ;
lin watercannon_N = mkTerm "watercannon_N" ;
lin waterchute_N = mkTerm "waterchute_N" ;
lin watercolour_N = mkTerm "watercolour_N" ;
lin watercolourist_N = mkTerm "watercolourist_N" ;
lin watercourse_N = mkTerm "watercourse_N" ;
lin watercraft_N = mkTerm "watercraft_N" ;
lin watercress_N = mkTerm "watercress_N" ;
lin waterdog_N = mkTerm "waterdog_N" ;
lin waterer_N = mkTerm "waterer_N" ;
lin waterfall_N = mkTerm "waterfall_N" ;
lin waterford_PN = mkTerm "waterford_PN" ;
lin waterfowl_N = mkTerm "waterfowl_N" ;
lin waterfront_N = mkTerm "waterfront_N" ;
lin waterhen_N = mkTerm "waterhen_N" ;
lin waterhyacinth_N = mkTerm "waterhyacinth_N" ;
lin wateriness_N = mkTerm "wateriness_N" ;
lin watering_N = mkTerm "watering_N" ;
lin watering_can_N = mkTerm "watering_can_N" ;
lin watering_cart_N = mkTerm "watering_cart_N" ;
lin waterleaf_N = mkTerm "waterleaf_N" ;
lin waterless_A = mkTerm "waterless_A" ;
lin waterlogged_A = mkTerm "waterlogged_A" ;
lin waterloo_N = mkTerm "waterloo_N" ;
lin waterloo_PN = mkTerm "waterloo_PN" ;
lin waterman_N = mkTerm "waterman_N" ;
lin watermark_N = mkTerm "watermark_N" ;
lin watermeal_N = mkTerm "watermeal_N" ;
lin watermelon_N = mkTerm "watermelon_N" ;
lin watermill_N = mkTerm "watermill_N" ;
lin waterproof_A = mkTerm "waterproof_A" ;
lin waterproof_N = mkTerm "waterproof_N" ;
lin waterproof_V2 = mkTerm "waterproof_V2" ;
lin waterproofing_N = mkTerm "waterproofing_N" ;
lin watershed_N = mkTerm "watershed_N" ;
lin waterside_N = mkTerm "waterside_N" ;
lin waterspout_N = mkTerm "waterspout_N" ;
lin watertable_N = mkTerm "watertable_N" ;
lin watertight_A = mkTerm "watertight_A" ;
lin waterway_N = mkTerm "waterway_N" ;
lin waterweed_N = mkTerm "waterweed_N" ;
lin waterworks_N = mkTerm "waterworks_N" ;
lin watery_A = mkTerm "watery_A" ;
lin watford_PN = mkTerm "watford_PN" ;
lin watt_N = mkTerm "watt_N" ;
lin wattage_N = mkTerm "wattage_N" ;
lin wattle_N = mkTerm "wattle_N" ;
lin wattmeter_N = mkTerm "wattmeter_N" ;
lin wave_N = mkTerm "wave_N" ;
lin wave_V = mkTerm "wave_V" ;
lin wave_V2 = mkTerm "wave_V2" ;
lin wave_aside_V2 = mkTerm "wave_aside_V2" ;
lin wave_away_V = mkTerm "wave_away_V" ;
lin wave_down_V2 = mkTerm "wave_down_V2" ;
lin wave_off_V2 = mkTerm "wave_off_V2" ;
lin wave_on_V2 = mkTerm "wave_on_V2" ;
lin waveguide_N = mkTerm "waveguide_N" ;
lin wavelength_N = mkTerm "wavelength_N" ;
lin waver_N = mkTerm "waver_N" ;
lin waver_V = mkTerm "waver_V" ;
lin waverer_N = mkTerm "waverer_N" ;
lin waviness_N = mkTerm "waviness_N" ;
lin wavy_A = mkTerm "wavy_A" ;
lin waw_N = mkTerm "waw_N" ;
lin wax_N = mkTerm "wax_N" ;
lin wax_V = mkTerm "wax_V" ;
lin wax_V2 = mkTerm "wax_V2" ;
lin wax_chandler_N = mkTerm "wax_chandler_N" ;
lin wax_paper_N = mkTerm "wax_paper_N" ;
lin waxen_A = mkTerm "waxen_A" ;
lin waxflower_N = mkTerm "waxflower_N" ;
lin waxiness_N = mkTerm "waxiness_N" ;
lin waxing_N = mkTerm "waxing_N" ;
lin waxmallow_N = mkTerm "waxmallow_N" ;
lin waxwing_N = mkTerm "waxwing_N" ;
lin waxwork_N = mkTerm "waxwork_N" ;
lin waxy_A = mkTerm "waxy_A" ;
lin waxycap_N = mkTerm "waxycap_N" ;
lin way_1_N = mkTerm "way_1_N" ;
lin way_2_N = mkTerm "way_2_N" ;
lin way_Adv = mkTerm "way_Adv" ;
lin way_out_A = mkTerm "way_out_A" ;
lin waybill_N = mkTerm "waybill_N" ;
lin wayfarer_N = mkTerm "wayfarer_N" ;
lin wayfaring_A = mkTerm "wayfaring_A" ;
lin wayfaring_N = mkTerm "wayfaring_N" ;
lin waylay_V2 = mkTerm "waylay_V2" ;
lin wayne_PN = mkTerm "wayne_PN" ;
lin ways_N = mkTerm "ways_N" ;
lin wayside_N = mkTerm "wayside_N" ;
lin wayward_A = mkTerm "wayward_A" ;
lin wc_N = mkTerm "wc_N" ;
lin weFem_Pron = mkTerm "weFem_Pron" ;
lin weak_A = mkTerm "weak_A" ;
lin weak_kneed_A = mkTerm "weak_kneed_A" ;
lin weaken_V = mkTerm "weaken_V" ;
lin weaken_V2 = mkTerm "weaken_V2" ;
lin weakener_N = mkTerm "weakener_N" ;
lin weakening_N = mkTerm "weakening_N" ;
lin weakfish_N = mkTerm "weakfish_N" ;
lin weakling_N = mkTerm "weakling_N" ;
lin weakly_A = mkTerm "weakly_A" ;
lin weakness_N = mkTerm "weakness_N" ;
lin weal_N = mkTerm "weal_N" ;
lin weald_N = mkTerm "weald_N" ;
lin wealth_N = mkTerm "wealth_N" ;
lin wealthy_A = mkTerm "wealthy_A" ;
lin wean_V2 = mkTerm "wean_V2" ;
lin wean_off_V2 = mkTerm "wean_off_V2" ;
lin weaning_N = mkTerm "weaning_N" ;
lin weapon_N = mkTerm "weapon_N" ;
lin weaponless_A = mkTerm "weaponless_A" ;
lin weaponry_N = mkTerm "weaponry_N" ;
lin wear_N = mkTerm "wear_N" ;
lin wear_PN = mkTerm "wear_PN" ;
lin wear_V = mkTerm "wear_V" ;
lin wear_V2 = mkTerm "wear_V2" ;
lin wear_away_V2 = mkTerm "wear_away_V2" ;
lin wear_down_V2 = mkTerm "wear_down_V2" ;
lin wear_off_V = mkTerm "wear_off_V" ;
lin wear_out_V = mkTerm "wear_out_V" ;
lin wear_out_V2 = mkTerm "wear_out_V2" ;
lin wearable_A = mkTerm "wearable_A" ;
lin wearer_N = mkTerm "wearer_N" ;
lin weariness_N = mkTerm "weariness_N" ;
lin wearisome_A = mkTerm "wearisome_A" ;
lin weary_A = mkTerm "weary_A" ;
lin weary_V = mkTerm "weary_V" ;
lin weary_V2 = mkTerm "weary_V2" ;
lin weasel_N = mkTerm "weasel_N" ;
lin weather_N = mkTerm "weather_N" ;
lin weather_V = mkTerm "weather_V" ;
lin weather_V2 = mkTerm "weather_V2" ;
lin weather_beaten_A = mkTerm "weather_beaten_A" ;
lin weather_bound_A = mkTerm "weather_bound_A" ;
lin weather_bureau_N = mkTerm "weather_bureau_N" ;
lin weather_chart_N = mkTerm "weather_chart_N" ;
lin weather_glass_N = mkTerm "weather_glass_N" ;
lin weather_map_N = mkTerm "weather_map_N" ;
lin weather_ship_N = mkTerm "weather_ship_N" ;
lin weather_station_N = mkTerm "weather_station_N" ;
lin weather_vane_N = mkTerm "weather_vane_N" ;
lin weatherboarding_N = mkTerm "weatherboarding_N" ;
lin weathercock_N = mkTerm "weathercock_N" ;
lin weatherliness_N = mkTerm "weatherliness_N" ;
lin weatherly_A = mkTerm "weatherly_A" ;
lin weatherman_N = mkTerm "weatherman_N" ;
lin weatherproof_A = mkTerm "weatherproof_A" ;
lin weave_N = mkTerm "weave_N" ;
lin weave_V = mkTerm "weave_V" ;
lin weave_V2 = mkTerm "weave_V2" ;
lin weaverFem_N = mkTerm "weaverFem_N" ;
lin weaverMasc_N = mkTerm "weaverMasc_N" ;
lin weaverbird_N = mkTerm "weaverbird_N" ;
lin weaving_N = mkTerm "weaving_N" ;
lin web_1_N = mkTerm "web_1_N" ;
lin web_2_N = mkTerm "web_2_N" ;
lin web_footed_A = mkTerm "web_footed_A" ;
lin web_toed_A = mkTerm "web_toed_A" ;
lin webbed_A = mkTerm "webbed_A" ;
lin webbing_N = mkTerm "webbing_N" ;
lin webcam_N = mkTerm "webcam_N" ;
lin weber_N = mkTerm "weber_N" ;
lin webfoot_N = mkTerm "webfoot_N" ;
lin weblog_N = mkTerm "weblog_N" ;
lin webmaster_N = mkTerm "webmaster_N" ;
lin webpage_N = mkTerm "webpage_N" ;
lin website_N = mkTerm "website_N" ;
lin webworm_N = mkTerm "webworm_N" ;
lin wed_A = mkTerm "wed_A" ;
lin wed_PN = mkTerm "wed_PN" ;
lin wed_V = mkTerm "wed_V" ;
lin wed_V2 = mkTerm "wed_V2" ;
lin wedding_N = mkTerm "wedding_N" ;
lin wedding_cake_N = mkTerm "wedding_cake_N" ;
lin wedding_ring_N = mkTerm "wedding_ring_N" ;
lin wedge_N = mkTerm "wedge_N" ;
lin wedge_V = mkTerm "wedge_V" ;
lin wedge_V2 = mkTerm "wedge_V2" ;
lin wedgie_N = mkTerm "wedgie_N" ;
lin wedlock_N = mkTerm "wedlock_N" ;
lin wee_A = mkTerm "wee_A" ;
lin wee_N = mkTerm "wee_N" ;
lin wee_V = mkTerm "wee_V" ;
lin wee_wee_N = mkTerm "wee_wee_N" ;
lin weed_N = mkTerm "weed_N" ;
lin weed_V = mkTerm "weed_V" ;
lin weed_V2 = mkTerm "weed_V2" ;
lin weed_out_V2 = mkTerm "weed_out_V2" ;
lin weeder_N = mkTerm "weeder_N" ;
lin weedkiller_N = mkTerm "weedkiller_N" ;
lin weedless_A = mkTerm "weedless_A" ;
lin weeds_N = mkTerm "weeds_N" ;
lin weedy_A = mkTerm "weedy_A" ;
lin week_N = mkTerm "week_N" ;
lin weekday_N = mkTerm "weekday_N" ;
lin weekend_N = mkTerm "weekend_N" ;
lin weekend_V = mkTerm "weekend_V" ;
lin weekender_N = mkTerm "weekender_N" ;
lin weeklong_A = mkTerm "weeklong_A" ;
lin weekly_A = mkTerm "weekly_A" ;
lin weekly_Adv = mkTerm "weekly_Adv" ;
lin weekly_N = mkTerm "weekly_N" ;
lin weeknight_N = mkTerm "weeknight_N" ;
lin weeny_A = mkTerm "weeny_A" ;
lin weep_V = mkTerm "weep_V" ;
lin weep_V2 = mkTerm "weep_V2" ;
lin weeper_N = mkTerm "weeper_N" ;
lin weepiness_N = mkTerm "weepiness_N" ;
lin weepy_A = mkTerm "weepy_A" ;
lin weevil_N = mkTerm "weevil_N" ;
lin weft_N = mkTerm "weft_N" ;
lin weigela_N = mkTerm "weigela_N" ;
lin weigh_V = mkTerm "weigh_V" ;
lin weigh_V2 = mkTerm "weigh_V2" ;
lin weigh_down_on_V2 = mkTerm "weigh_down_on_V2" ;
lin weigh_in_V = mkTerm "weigh_in_V" ;
lin weigh_in_on_V2 = mkTerm "weigh_in_on_V2" ;
lin weigh_on_V2 = mkTerm "weigh_on_V2" ;
lin weigh_out_V2 = mkTerm "weigh_out_V2" ;
lin weigh_up_V2 = mkTerm "weigh_up_V2" ;
lin weighbridge_N = mkTerm "weighbridge_N" ;
lin weigher_N = mkTerm "weigher_N" ;
lin weighing_machine_N = mkTerm "weighing_machine_N" ;
lin weight_N = mkTerm "weight_N" ;
lin weight_V2 = mkTerm "weight_V2" ;
lin weightiness_N = mkTerm "weightiness_N" ;
lin weightless_A = mkTerm "weightless_A" ;
lin weightlessness_N = mkTerm "weightlessness_N" ;
lin weightlift_N = mkTerm "weightlift_N" ;
lin weightlifter_N = mkTerm "weightlifter_N" ;
lin weightlifting_N = mkTerm "weightlifting_N" ;
lin weighty_A = mkTerm "weighty_A" ;
lin weir_N = mkTerm "weir_N" ;
lin weird_A = mkTerm "weird_A" ;
lin weird_out_V2 = mkTerm "weird_out_V2" ;
lin weirdie_N = mkTerm "weirdie_N" ;
lin weirdness_N = mkTerm "weirdness_N" ;
lin weka_N = mkTerm "weka_N" ;
lin welcher_N = mkTerm "welcher_N" ;
lin welcome_A = mkTerm "welcome_A" ;
lin welcome_N = mkTerm "welcome_N" ;
lin welcome_V2 = mkTerm "welcome_V2" ;
lin welcoming_A = mkTerm "welcoming_A" ;
lin weld_N = mkTerm "weld_N" ;
lin weld_V = mkTerm "weld_V" ;
lin weld_V2 = mkTerm "weld_V2" ;
lin welder_N = mkTerm "welder_N" ;
lin welding_N = mkTerm "welding_N" ;
lin weldment_N = mkTerm "weldment_N" ;
lin welfare_N = mkTerm "welfare_N" ;
lin welfarist_A = mkTerm "welfarist_A" ;
lin welkin_N = mkTerm "welkin_N" ;
lin well_A = mkTerm "well_A" ;
lin well_Interj = mkTerm "well_Interj" ;
lin well_N = mkTerm "well_N" ;
lin well_V = mkTerm "well_V" ;
lin well_adjusted_A = mkTerm "well_adjusted_A" ;
lin well_advised_A = mkTerm "well_advised_A" ;
lin well_appointed_A = mkTerm "well_appointed_A" ;
lin well_balanced_A = mkTerm "well_balanced_A" ;
lin well_behaved_A = mkTerm "well_behaved_A" ;
lin well_being_N = mkTerm "well_being_N" ;
lin well_born_A = mkTerm "well_born_A" ;
lin well_bred_A = mkTerm "well_bred_A" ;
lin well_conducted_A = mkTerm "well_conducted_A" ;
lin well_connected_A = mkTerm "well_connected_A" ;
lin well_disposed_A = mkTerm "well_disposed_A" ;
lin well_doer_N = mkTerm "well_doer_N" ;
lin well_doing_N = mkTerm "well_doing_N" ;
lin well_favoured_A = mkTerm "well_favoured_A" ;
lin well_found_A = mkTerm "well_found_A" ;
lin well_founded_A = mkTerm "well_founded_A" ;
lin well_groomed_A = mkTerm "well_groomed_A" ;
lin well_grounded_A = mkTerm "well_grounded_A" ;
lin well_heeled_A = mkTerm "well_heeled_A" ;
lin well_informed_A = mkTerm "well_informed_A" ;
lin well_intentioned_A = mkTerm "well_intentioned_A" ;
lin well_knit_A = mkTerm "well_knit_A" ;
lin well_known_A = mkTerm "well_known_A" ;
lin well_lined_A = mkTerm "well_lined_A" ;
lin well_marked_A = mkTerm "well_marked_A" ;
lin well_meaning_A = mkTerm "well_meaning_A" ;
lin well_meant_A = mkTerm "well_meant_A" ;
lin well_nigh_Adv = mkTerm "well_nigh_Adv" ;
lin well_read_A = mkTerm "well_read_A" ;
lin well_rounded_A = mkTerm "well_rounded_A" ;
lin well_set_A = mkTerm "well_set_A" ;
lin well_shaven_A = mkTerm "well_shaven_A" ;
lin well_spoken_A = mkTerm "well_spoken_A" ;
lin well_timed_A = mkTerm "well_timed_A" ;
lin well_to_do_A = mkTerm "well_to_do_A" ;
lin well_tried_A = mkTerm "well_tried_A" ;
lin well_turned_A = mkTerm "well_turned_A" ;
lin well_up_V = mkTerm "well_up_V" ;
lin well_water_N = mkTerm "well_water_N" ;
lin well_wisher_N = mkTerm "well_wisher_N" ;
lin well_worn_A = mkTerm "well_worn_A" ;
lin wellbeing_N = mkTerm "wellbeing_N" ;
lin wellerism_N = mkTerm "wellerism_N" ;
lin wellhead_N = mkTerm "wellhead_N" ;
lin wellingborough_PN = mkTerm "wellingborough_PN" ;
lin wellington_N = mkTerm "wellington_N" ;
lin wellington_PN = mkTerm "wellington_PN" ;
lin wells_PN = mkTerm "wells_PN" ;
lin welsh_A = mkTerm "welsh_A" ;
lin welsh_N = mkTerm "welsh_N" ;
lin welsh_V = mkTerm "welsh_V" ;
lin welsher_N = mkTerm "welsher_N" ;
lin welshman_N = mkTerm "welshman_N" ;
lin welshpool_PN = mkTerm "welshpool_PN" ;
lin welt_N = mkTerm "welt_N" ;
lin welter_A = mkTerm "welter_A" ;
lin welter_N = mkTerm "welter_N" ;
lin welter_V = mkTerm "welter_V" ;
lin welterweight_N = mkTerm "welterweight_N" ;
lin welwitschia_N = mkTerm "welwitschia_N" ;
lin welwyn_PN = mkTerm "welwyn_PN" ;
lin welwyn_garden_city_PN = mkTerm "welwyn_garden_city_PN" ;
lin wen_N = mkTerm "wen_N" ;
lin wench_N = mkTerm "wench_N" ;
lin wench_V = mkTerm "wench_V" ;
lin wencher_N = mkTerm "wencher_N" ;
lin wend_V2 = mkTerm "wend_V2" ;
lin wendover_PN = mkTerm "wendover_PN" ;
lin wendy_PN = mkTerm "wendy_PN" ;
lin werewolf_N = mkTerm "werewolf_N" ;
lin wesleyan_A = mkTerm "wesleyan_A" ;
lin wesleyan_N = mkTerm "wesleyan_N" ;
lin west_A = mkTerm "west_A" ;
lin west_Adv = mkTerm "west_Adv" ;
lin west_N = mkTerm "west_N" ;
lin west_bromwich_PN = mkTerm "west_bromwich_PN" ;
lin west_country_A = mkTerm "west_country_A" ;
lin west_end_A = mkTerm "west_end_A" ;
lin westbound_A = mkTerm "westbound_A" ;
lin westbound_N = mkTerm "westbound_N" ;
lin westbury_PN = mkTerm "westbury_PN" ;
lin westerly_A = mkTerm "westerly_A" ;
lin westerly_Adv = mkTerm "westerly_Adv" ;
lin western_A = mkTerm "western_A" ;
lin western_N = mkTerm "western_N" ;
lin westerner_N = mkTerm "westerner_N" ;
lin westernization_N = mkTerm "westernization_N" ;
lin westernize_V2 = mkTerm "westernize_V2" ;
lin westernmost_A = mkTerm "westernmost_A" ;
lin westhoughton_PN = mkTerm "westhoughton_PN" ;
lin westmeath_PN = mkTerm "westmeath_PN" ;
lin westminster_PN = mkTerm "westminster_PN" ;
lin westmoreland_PN = mkTerm "westmoreland_PN" ;
lin weston_super_mare_PN = mkTerm "weston_super_mare_PN" ;
lin westside_A = mkTerm "westside_A" ;
lin westward_A = mkTerm "westward_A" ;
lin westward_Adv = mkTerm "westward_Adv" ;
lin westwards_Adv = mkTerm "westwards_Adv" ;
lin wet_A = mkTerm "wet_A" ;
lin wet_N = mkTerm "wet_N" ;
lin wet_V2 = mkTerm "wet_V2" ;
lin wet_nurse_N = mkTerm "wet_nurse_N" ;
lin wether_N = mkTerm "wether_N" ;
lin wetherby_PN = mkTerm "wetherby_PN" ;
lin wetland_N = mkTerm "wetland_N" ;
lin wetness_N = mkTerm "wetness_N" ;
lin wetter_N = mkTerm "wetter_N" ;
lin wetting_N = mkTerm "wetting_N" ;
lin wexford_PN = mkTerm "wexford_PN" ;
lin weymouth_PN = mkTerm "weymouth_PN" ;
lin whack_N = mkTerm "whack_N" ;
lin whack_V2 = mkTerm "whack_V2" ;
lin whack_off_V = mkTerm "whack_off_V" ;
lin whacker_N = mkTerm "whacker_N" ;
lin whacking_Adv = mkTerm "whacking_Adv" ;
lin whacking_N = mkTerm "whacking_N" ;
lin whale_N = mkTerm "whale_N" ;
lin whale_V = mkTerm "whale_V" ;
lin whaleboat_N = mkTerm "whaleboat_N" ;
lin whalebone_N = mkTerm "whalebone_N" ;
lin whaler_N = mkTerm "whaler_N" ;
lin whaley_bridge_PN = mkTerm "whaley_bridge_PN" ;
lin whaling_N = mkTerm "whaling_N" ;
lin whaling_gun_N = mkTerm "whaling_gun_N" ;
lin whammy_N = mkTerm "whammy_N" ;
lin whang_Adv = mkTerm "whang_Adv" ;
lin whang_N = mkTerm "whang_N" ;
lin whang_V2 = mkTerm "whang_V2" ;
lin wharf_N = mkTerm "wharf_N" ;
lin wharfage_N = mkTerm "wharfage_N" ;
lin what_for_N = mkTerm "what_for_N" ;
lin whate'er_A = mkTerm "whate'er_A" ;
lin whatever_A = mkTerm "whatever_A" ;
lin whatever_Quant = mkTerm "whatever_Quant" ;
lin whatnot_N = mkTerm "whatnot_N" ;
lin whatsoe'er_A = mkTerm "whatsoe'er_A" ;
lin whatsoever_A = mkTerm "whatsoever_A" ;
lin whatsoever_Adv = mkTerm "whatsoever_Adv" ;
lin wheat_N = mkTerm "wheat_N" ;
lin wheatear_N = mkTerm "wheatear_N" ;
lin wheaten_A = mkTerm "wheaten_A" ;
lin wheatfield_N = mkTerm "wheatfield_N" ;
lin wheatflake_N = mkTerm "wheatflake_N" ;
lin wheatgrass_N = mkTerm "wheatgrass_N" ;
lin wheatley_hill_PN = mkTerm "wheatley_hill_PN" ;
lin wheatworm_N = mkTerm "wheatworm_N" ;
lin wheedle_V2 = mkTerm "wheedle_V2" ;
lin wheedler_N = mkTerm "wheedler_N" ;
lin wheel_N = mkTerm "wheel_N" ;
lin wheel_V = mkTerm "wheel_V" ;
lin wheel_V2 = mkTerm "wheel_V2" ;
lin wheel_around_V = mkTerm "wheel_around_V" ;
lin wheel_out_V2 = mkTerm "wheel_out_V2" ;
lin wheel_round_V = mkTerm "wheel_round_V" ;
lin wheel_up_V = mkTerm "wheel_up_V" ;
lin wheelbarrow_N = mkTerm "wheelbarrow_N" ;
lin wheelbase_N = mkTerm "wheelbase_N" ;
lin wheelchair_N = mkTerm "wheelchair_N" ;
lin wheeler_N = mkTerm "wheeler_N" ;
lin wheelhouse_N = mkTerm "wheelhouse_N" ;
lin wheeling_N = mkTerm "wheeling_N" ;
lin wheelless_A = mkTerm "wheelless_A" ;
lin wheelwork_N = mkTerm "wheelwork_N" ;
lin wheelwright_N = mkTerm "wheelwright_N" ;
lin wheeze_N = mkTerm "wheeze_N" ;
lin wheeze_V = mkTerm "wheeze_V" ;
lin wheeze_V2 = mkTerm "wheeze_V2" ;
lin wheeziness_N = mkTerm "wheeziness_N" ;
lin wheezy_A = mkTerm "wheezy_A" ;
lin whelk_N = mkTerm "whelk_N" ;
lin whelp_N = mkTerm "whelp_N" ;
lin whelp_V = mkTerm "whelp_V" ;
lin whence_Adv = mkTerm "whence_Adv" ;
lin whencesoever_A = mkTerm "whencesoever_A" ;
lin whenever_Adv = mkTerm "whenever_Adv" ;
lin where_Subj = mkTerm "where_Subj" ;
lin where_as_Prep = mkTerm "where_as_Prep" ;
lin whereabouts_Adv = mkTerm "whereabouts_Adv" ;
lin whereabouts_N = mkTerm "whereabouts_N" ;
lin whereas_Prep = mkTerm "whereas_Prep" ;
lin whereas_Subj = mkTerm "whereas_Subj" ;
lin whereat_Adv = mkTerm "whereat_Adv" ;
lin whereby_Adv = mkTerm "whereby_Adv" ;
lin wherefore_Adv = mkTerm "wherefore_Adv" ;
lin wherein_IAdv = mkTerm "wherein_IAdv" ;
lin wherein_Subj = mkTerm "wherein_Subj" ;
lin whereof_Adv = mkTerm "whereof_Adv" ;
lin whereon_Adv = mkTerm "whereon_Adv" ;
lin wheresoever_Adv = mkTerm "wheresoever_Adv" ;
lin whereto_Adv = mkTerm "whereto_Adv" ;
lin whereunto_Adv = mkTerm "whereunto_Adv" ;
lin whereupon_Adv = mkTerm "whereupon_Adv" ;
lin wherever_Adv = mkTerm "wherever_Adv" ;
lin wherewith_Adv = mkTerm "wherewith_Adv" ;
lin wherewithal_Adv = mkTerm "wherewithal_Adv" ;
lin wherewithal_N = mkTerm "wherewithal_N" ;
lin wherry_N = mkTerm "wherry_N" ;
lin whet_V2 = mkTerm "whet_V2" ;
lin whether_Prep = mkTerm "whether_Prep" ;
lin whether_Subj = mkTerm "whether_Subj" ;
lin whetstone_N = mkTerm "whetstone_N" ;
lin whey_N = mkTerm "whey_N" ;
lin whichever_Quant = mkTerm "whichever_Quant" ;
lin whichsoever_A = mkTerm "whichsoever_A" ;
lin whiff_N = mkTerm "whiff_N" ;
lin whiffer_N = mkTerm "whiffer_N" ;
lin whiffletree_N = mkTerm "whiffletree_N" ;
lin whig_N = mkTerm "whig_N" ;
lin while_N = mkTerm "while_N" ;
lin while_Subj = mkTerm "while_Subj" ;
lin while_V2 = mkTerm "while_V2" ;
lin while_away_V2 = mkTerm "while_away_V2" ;
lin whilst_Subj = mkTerm "whilst_Subj" ;
lin whim_N = mkTerm "whim_N" ;
lin whimper_N = mkTerm "whimper_N" ;
lin whimper_V = mkTerm "whimper_V" ;
lin whimper_V2 = mkTerm "whimper_V2" ;
lin whimsey_N = mkTerm "whimsey_N" ;
lin whimsical_A = mkTerm "whimsical_A" ;
lin whimsicality_N = mkTerm "whimsicality_N" ;
lin whimsy_N = mkTerm "whimsy_N" ;
lin whin_N = mkTerm "whin_N" ;
lin whinchat_N = mkTerm "whinchat_N" ;
lin whine_N = mkTerm "whine_N" ;
lin whine_V = mkTerm "whine_V" ;
lin whine_V2 = mkTerm "whine_V2" ;
lin whiner_N = mkTerm "whiner_N" ;
lin whinny_N = mkTerm "whinny_N" ;
lin whinny_V = mkTerm "whinny_V" ;
lin whinstone_N = mkTerm "whinstone_N" ;
lin whip_N = mkTerm "whip_N" ;
lin whip_V = mkTerm "whip_V" ;
lin whip_V2 = mkTerm "whip_V2" ;
lin whip_into_V2 = mkTerm "whip_into_V2" ;
lin whip_out_V2 = mkTerm "whip_out_V2" ;
lin whip_out_of_V2 = mkTerm "whip_out_of_V2" ;
lin whip_round_N = mkTerm "whip_round_N" ;
lin whip_through_V2 = mkTerm "whip_through_V2" ;
lin whip_up_V2 = mkTerm "whip_up_V2" ;
lin whipcord_N = mkTerm "whipcord_N" ;
lin whiplash_N = mkTerm "whiplash_N" ;
lin whipper_in_N = mkTerm "whipper_in_N" ;
lin whippersnapper_N = mkTerm "whippersnapper_N" ;
lin whippet_N = mkTerm "whippet_N" ;
lin whipping_N = mkTerm "whipping_N" ;
lin whipping_boy_N = mkTerm "whipping_boy_N" ;
lin whipping_post_N = mkTerm "whipping_post_N" ;
lin whipping_top_N = mkTerm "whipping_top_N" ;
lin whippoorwill_N = mkTerm "whippoorwill_N" ;
lin whippy_A = mkTerm "whippy_A" ;
lin whipsaw_V2 = mkTerm "whipsaw_V2" ;
lin whipstitch_N = mkTerm "whipstitch_N" ;
lin whiptail_N = mkTerm "whiptail_N" ;
lin whir_N = mkTerm "whir_N" ;
lin whir_V = mkTerm "whir_V" ;
lin whirl_N = mkTerm "whirl_N" ;
lin whirl_V = mkTerm "whirl_V" ;
lin whirl_V2 = mkTerm "whirl_V2" ;
lin whirler_N = mkTerm "whirler_N" ;
lin whirligig_N = mkTerm "whirligig_N" ;
lin whirlpool_N = mkTerm "whirlpool_N" ;
lin whirlwind_N = mkTerm "whirlwind_N" ;
lin whirr_N = mkTerm "whirr_N" ;
lin whirr_V = mkTerm "whirr_V" ;
lin whisk_N = mkTerm "whisk_N" ;
lin whisk_V = mkTerm "whisk_V" ;
lin whisk_V2 = mkTerm "whisk_V2" ;
lin whisk_away_V2 = mkTerm "whisk_away_V2" ;
lin whisker_N = mkTerm "whisker_N" ;
lin whiskered_A = mkTerm "whiskered_A" ;
lin whiskey_N = mkTerm "whiskey_N" ;
lin whisper_N = mkTerm "whisper_N" ;
lin whisper_V = mkTerm "whisper_V" ;
lin whisper_V2 = mkTerm "whisper_V2" ;
lin whisperer_N = mkTerm "whisperer_N" ;
lin whispering_N = mkTerm "whispering_N" ;
lin whispering_gallery_N = mkTerm "whispering_gallery_N" ;
lin whist_N = mkTerm "whist_N" ;
lin whist_drive_N = mkTerm "whist_drive_N" ;
lin whistle_N = mkTerm "whistle_N" ;
lin whistle_V = mkTerm "whistle_V" ;
lin whistle_V2 = mkTerm "whistle_V2" ;
lin whistle_stop_N = mkTerm "whistle_stop_N" ;
lin whistler_N = mkTerm "whistler_N" ;
lin whistling_N = mkTerm "whistling_N" ;
lin whit_N = mkTerm "whit_N" ;
lin whitburn_PN = mkTerm "whitburn_PN" ;
lin whitby_PN = mkTerm "whitby_PN" ;
lin whitchurch_PN = mkTerm "whitchurch_PN" ;
lin white_A = mkTerm "white_A" ;
lin white_N = mkTerm "white_N" ;
lin white_collar_A = mkTerm "white_collar_A" ;
lin white_hot_A = mkTerm "white_hot_A" ;
lin white_lipped_A = mkTerm "white_lipped_A" ;
lin white_livered_A = mkTerm "white_livered_A" ;
lin white_out_V2 = mkTerm "white_out_V2" ;
lin whitebait_N = mkTerm "whitebait_N" ;
lin whitecap_N = mkTerm "whitecap_N" ;
lin whitecup_N = mkTerm "whitecup_N" ;
lin whiteface_N = mkTerm "whiteface_N" ;
lin whitefish_N = mkTerm "whitefish_N" ;
lin whitefly_N = mkTerm "whitefly_N" ;
lin whitehall_PN = mkTerm "whitehall_PN" ;
lin whitehaven_PN = mkTerm "whitehaven_PN" ;
lin whitehead_N = mkTerm "whitehead_N" ;
lin whitelash_N = mkTerm "whitelash_N" ;
lin whiten_V = mkTerm "whiten_V" ;
lin whiten_V2 = mkTerm "whiten_V2" ;
lin whiteness_N = mkTerm "whiteness_N" ;
lin whitening_N = mkTerm "whitening_N" ;
lin whiteout_N = mkTerm "whiteout_N" ;
lin whitethorn_N = mkTerm "whitethorn_N" ;
lin whitewash_N = mkTerm "whitewash_N" ;
lin whitewash_V2 = mkTerm "whitewash_V2" ;
lin whitey_N = mkTerm "whitey_N" ;
lin whither_Adv = mkTerm "whither_Adv" ;
lin whithersoever_Adv = mkTerm "whithersoever_Adv" ;
lin whiting_N = mkTerm "whiting_N" ;
lin whitish_A = mkTerm "whitish_A" ;
lin whitley_bay_PN = mkTerm "whitley_bay_PN" ;
lin whitlow_N = mkTerm "whitlow_N" ;
lin whitlowwort_N = mkTerm "whitlowwort_N" ;
lin whitstable_PN = mkTerm "whitstable_PN" ;
lin whitsun_N = mkTerm "whitsun_N" ;
lin whitsun_PN = mkTerm "whitsun_PN" ;
lin whitsuntide_N = mkTerm "whitsuntide_N" ;
lin whitsuntide_PN = mkTerm "whitsuntide_PN" ;
lin whittle_V = mkTerm "whittle_V" ;
lin whittle_V2 = mkTerm "whittle_V2" ;
lin whittle_le_woods_PN = mkTerm "whittle_le_woods_PN" ;
lin whittler_N = mkTerm "whittler_N" ;
lin whittlesey_PN = mkTerm "whittlesey_PN" ;
lin whitworth_PN = mkTerm "whitworth_PN" ;
lin whiz_N = mkTerm "whiz_N" ;
lin whiz_V = mkTerm "whiz_V" ;
lin whizbang_N = mkTerm "whizbang_N" ;
lin whizz_kid_N = mkTerm "whizz_kid_N" ;
lin who_PN = mkTerm "who_PN" ;
lin whodunit_N = mkTerm "whodunit_N" ;
lin whoever_NP = mkTerm "whoever_NP" ;
lin whole_A = mkTerm "whole_A" ;
lin whole_N = mkTerm "whole_N" ;
lin whole_wheat_N = mkTerm "whole_wheat_N" ;
lin wholehearted_A = mkTerm "wholehearted_A" ;
lin wholeheartedness_N = mkTerm "wholeheartedness_N" ;
lin wholemeal_N = mkTerm "wholemeal_N" ;
lin wholeness_N = mkTerm "wholeness_N" ;
lin wholesale_A = mkTerm "wholesale_A" ;
lin wholesale_Adv = mkTerm "wholesale_Adv" ;
lin wholesale_N = mkTerm "wholesale_N" ;
lin wholesale_V2 = mkTerm "wholesale_V2" ;
lin wholesaler_N = mkTerm "wholesaler_N" ;
lin wholesome_A = mkTerm "wholesome_A" ;
lin wholesomeness_N = mkTerm "wholesomeness_N" ;
lin whoop_N = mkTerm "whoop_N" ;
lin whoop_V = mkTerm "whoop_V" ;
lin whoop_V2 = mkTerm "whoop_V2" ;
lin whoopee_Interj = mkTerm "whoopee_Interj" ;
lin whooper_N = mkTerm "whooper_N" ;
lin whooping_cough_N = mkTerm "whooping_cough_N" ;
lin whop_V2 = mkTerm "whop_V2" ;
lin whopper_N = mkTerm "whopper_N" ;
lin whopping_A = mkTerm "whopping_A" ;
lin whopping_Adv = mkTerm "whopping_Adv" ;
lin whore_N = mkTerm "whore_N" ;
lin whorehouse_N = mkTerm "whorehouse_N" ;
lin whoremaster_N = mkTerm "whoremaster_N" ;
lin whoremonger_N = mkTerm "whoremonger_N" ;
lin whorl_N = mkTerm "whorl_N" ;
lin whorled_A = mkTerm "whorled_A" ;
lin why_N = mkTerm "why_N" ;
lin whydah_N = mkTerm "whydah_N" ;
lin wi_N = mkTerm "wi_N" ;
lin wick_N = mkTerm "wick_N" ;
lin wick_PN = mkTerm "wick_PN" ;
lin wicked_A = mkTerm "wicked_A" ;
lin wickedness_N = mkTerm "wickedness_N" ;
lin wicker_N = mkTerm "wicker_N" ;
lin wickerwork_N = mkTerm "wickerwork_N" ;
lin wicket_N = mkTerm "wicket_N" ;
lin wicket_door_N = mkTerm "wicket_door_N" ;
lin wicket_gate_N = mkTerm "wicket_gate_N" ;
lin wicket_keeper_N = mkTerm "wicket_keeper_N" ;
lin wickford_PN = mkTerm "wickford_PN" ;
lin wickiup_N = mkTerm "wickiup_N" ;
lin wicklow_PN = mkTerm "wicklow_PN" ;
lin wide_A = mkTerm "wide_A" ;
lin wide_Adv = mkTerm "wide_Adv" ;
lin wide_awake_A = mkTerm "wide_awake_A" ;
lin widen_V2 = mkTerm "widen_V2" ;
lin wideness_N = mkTerm "wideness_N" ;
lin widening_N = mkTerm "widening_N" ;
lin widespread_A = mkTerm "widespread_A" ;
lin widgeon_N = mkTerm "widgeon_N" ;
lin widnes_PN = mkTerm "widnes_PN" ;
lin widow_N = mkTerm "widow_N" ;
lin widowed_A = mkTerm "widowed_A" ;
lin widower_N = mkTerm "widower_N" ;
lin widowhood_N = mkTerm "widowhood_N" ;
lin width_N = mkTerm "width_N" ;
lin wield_V2 = mkTerm "wield_V2" ;
lin wieldy_A = mkTerm "wieldy_A" ;
lin wiesbaden_PN = mkTerm "wiesbaden_PN" ;
lin wiesenboden_N = mkTerm "wiesenboden_N" ;
lin wife_N = mkTerm "wife_N" ;
lin wifelike_A = mkTerm "wifelike_A" ;
lin wifely_A = mkTerm "wifely_A" ;
lin wig_N = mkTerm "wig_N" ;
lin wig_out_V = mkTerm "wig_out_V" ;
lin wigan_PN = mkTerm "wigan_PN" ;
lin wigged_A = mkTerm "wigged_A" ;
lin wigging_N = mkTerm "wigging_N" ;
lin wiggle_N = mkTerm "wiggle_N" ;
lin wiggle_V = mkTerm "wiggle_V" ;
lin wiggle_V2 = mkTerm "wiggle_V2" ;
lin wiggle_out_V = mkTerm "wiggle_out_V" ;
lin wiggle_out_of_V2 = mkTerm "wiggle_out_of_V2" ;
lin wiggler_N = mkTerm "wiggler_N" ;
lin wiggliness_N = mkTerm "wiggliness_N" ;
lin wiggly_A = mkTerm "wiggly_A" ;
lin wight_N = mkTerm "wight_N" ;
lin wight_PN = mkTerm "wight_PN" ;
lin wigless_A = mkTerm "wigless_A" ;
lin wigmaker_N = mkTerm "wigmaker_N" ;
lin wigwam_N = mkTerm "wigwam_N" ;
lin wiki_N = mkTerm "wiki_N" ;
lin wild_A = mkTerm "wild_A" ;
lin wild_Adv = mkTerm "wild_Adv" ;
lin wild_N = mkTerm "wild_N" ;
lin wildcat_A = mkTerm "wildcat_A" ;
lin wildcat_N = mkTerm "wildcat_N" ;
lin wildcatter_N = mkTerm "wildcatter_N" ;
lin wildebeest_N = mkTerm "wildebeest_N" ;
lin wilderness_N = mkTerm "wilderness_N" ;
lin wildfire_N = mkTerm "wildfire_N" ;
lin wildflower_N = mkTerm "wildflower_N" ;
lin wildfowl_N = mkTerm "wildfowl_N" ;
lin wilding_N = mkTerm "wilding_N" ;
lin wildlife_N = mkTerm "wildlife_N" ;
lin wildness_N = mkTerm "wildness_N" ;
lin wile_N = mkTerm "wile_N" ;
lin wilf_PN = mkTerm "wilf_PN" ;
lin wilfrid_PN = mkTerm "wilfrid_PN" ;
lin wilful_A = mkTerm "wilful_A" ;
lin wilfulness_N = mkTerm "wilfulness_N" ;
lin wilhelmshaven_PN = mkTerm "wilhelmshaven_PN" ;
lin will_N = mkTerm "will_N" ;
lin will_PN = mkTerm "will_PN" ;
lin will_V = mkTerm "will_V" ;
lin will_V2 = mkTerm "will_V2" ;
lin will_o'_the_wisp_N = mkTerm "will_o'_the_wisp_N" ;
lin willet_N = mkTerm "willet_N" ;
lin willful_A = mkTerm "willful_A" ;
lin william_PN = mkTerm "william_PN" ;
lin willie_PN = mkTerm "willie_PN" ;
lin willies_N = mkTerm "willies_N" ;
lin willing_A = mkTerm "willing_A" ;
lin willingness_N = mkTerm "willingness_N" ;
lin willington_PN = mkTerm "willington_PN" ;
lin willow_N = mkTerm "willow_N" ;
lin willow_pattern_N = mkTerm "willow_pattern_N" ;
lin willow_tree_N = mkTerm "willow_tree_N" ;
lin willowherb_N = mkTerm "willowherb_N" ;
lin willowware_N = mkTerm "willowware_N" ;
lin willowy_A = mkTerm "willowy_A" ;
lin willpower_N = mkTerm "willpower_N" ;
lin willy_PN = mkTerm "willy_PN" ;
lin willy_nilly_Adv = mkTerm "willy_nilly_Adv" ;
lin wilmslow_PN = mkTerm "wilmslow_PN" ;
lin wilt_N = mkTerm "wilt_N" ;
lin wilt_V = mkTerm "wilt_V" ;
lin wilt_V2 = mkTerm "wilt_V2" ;
lin wilton_N = mkTerm "wilton_N" ;
lin wiltshire_PN = mkTerm "wiltshire_PN" ;
lin wily_A = mkTerm "wily_A" ;
lin wimbourne_PN = mkTerm "wimbourne_PN" ;
lin wimbourne_minster_PN = mkTerm "wimbourne_minster_PN" ;
lin wimp_N = mkTerm "wimp_N" ;
lin wimp_out_V = mkTerm "wimp_out_V" ;
lin wimpish_A = mkTerm "wimpish_A" ;
lin wimple_N = mkTerm "wimple_N" ;
lin win_N = mkTerm "win_N" ;
lin win_V = mkTerm "win_V" ;
lin win_V2 = mkTerm "win_V2" ;
lin win_back_V = mkTerm "win_back_V" ;
lin win_down_V = mkTerm "win_down_V" ;
lin win_over_V = mkTerm "win_over_V" ;
lin win_up_V = mkTerm "win_up_V" ;
lin wince_N = mkTerm "wince_N" ;
lin wince_V = mkTerm "wince_V" ;
lin wince_V2 = mkTerm "wince_V2" ;
lin wincey_N = mkTerm "wincey_N" ;
lin winceyette_N = mkTerm "winceyette_N" ;
lin winch_N = mkTerm "winch_N" ;
lin winch_V2 = mkTerm "winch_V2" ;
lin winchester_PN = mkTerm "winchester_PN" ;
lin wind_N = mkTerm "wind_N" ;
lin wind_V = mkTerm "wind_V" ;
lin wind_down_V = mkTerm "wind_down_V" ;
lin wind_down_V2 = mkTerm "wind_down_V2" ;
lin wind_gauge_N = mkTerm "wind_gauge_N" ;
lin wind_on_V = mkTerm "wind_on_V" ;
lin wind_tunnel_N = mkTerm "wind_tunnel_N" ;
lin wind_up_V = mkTerm "wind_up_V" ;
lin wind_up_V2 = mkTerm "wind_up_V2" ;
lin windage_N = mkTerm "windage_N" ;
lin windbag_N = mkTerm "windbag_N" ;
lin windblown_A = mkTerm "windblown_A" ;
lin windbreak_N = mkTerm "windbreak_N" ;
lin windbreaker_N = mkTerm "windbreaker_N" ;
lin windburn_N = mkTerm "windburn_N" ;
lin windburned_A = mkTerm "windburned_A" ;
lin windcheater_N = mkTerm "windcheater_N" ;
lin winder_N = mkTerm "winder_N" ;
lin windermere_PN = mkTerm "windermere_PN" ;
lin windfall_N = mkTerm "windfall_N" ;
lin windflower_N = mkTerm "windflower_N" ;
lin windiness_N = mkTerm "windiness_N" ;
lin winding_sheet_N = mkTerm "winding_sheet_N" ;
lin windjammer_N = mkTerm "windjammer_N" ;
lin windlass_N = mkTerm "windlass_N" ;
lin windless_A = mkTerm "windless_A" ;
lin windmill_N = mkTerm "windmill_N" ;
lin window_N = mkTerm "window_N" ;
lin window_box_N = mkTerm "window_box_N" ;
lin window_dressing_N = mkTerm "window_dressing_N" ;
lin windowpane_N = mkTerm "windowpane_N" ;
lin windowsill_N = mkTerm "windowsill_N" ;
lin windpipe_N = mkTerm "windpipe_N" ;
lin windscreen_N = mkTerm "windscreen_N" ;
lin windscreen_wiper_N = mkTerm "windscreen_wiper_N" ;
lin windshield_N = mkTerm "windshield_N" ;
lin windsock_N = mkTerm "windsock_N" ;
lin windsor_PN = mkTerm "windsor_PN" ;
lin windstorm_N = mkTerm "windstorm_N" ;
lin windswept_A = mkTerm "windswept_A" ;
lin windward_A = mkTerm "windward_A" ;
lin windward_Adv = mkTerm "windward_Adv" ;
lin windward_N = mkTerm "windward_N" ;
lin windy_A = mkTerm "windy_A" ;
lin wine_N = mkTerm "wine_N" ;
lin wine_V2 = mkTerm "wine_V2" ;
lin wineberry_N = mkTerm "wineberry_N" ;
lin wineglass_N = mkTerm "wineglass_N" ;
lin winemaking_N = mkTerm "winemaking_N" ;
lin winepress_N = mkTerm "winepress_N" ;
lin winery_N = mkTerm "winery_N" ;
lin wineskin_N = mkTerm "wineskin_N" ;
lin wing_N = mkTerm "wing_N" ;
lin wing_V = mkTerm "wing_V" ;
lin wing_V2 = mkTerm "wing_V2" ;
lin wing_commander_N = mkTerm "wing_commander_N" ;
lin wing_nut_N = mkTerm "wing_nut_N" ;
lin wing_screw_N = mkTerm "wing_screw_N" ;
lin wingate_PN = mkTerm "wingate_PN" ;
lin wingback_N = mkTerm "wingback_N" ;
lin winger_N = mkTerm "winger_N" ;
lin wingless_A = mkTerm "wingless_A" ;
lin winglike_A = mkTerm "winglike_A" ;
lin wingman_N = mkTerm "wingman_N" ;
lin wings_N = mkTerm "wings_N" ;
lin wingspan_N = mkTerm "wingspan_N" ;
lin wingspread_N = mkTerm "wingspread_N" ;
lin wingstem_N = mkTerm "wingstem_N" ;
lin winifred_PN = mkTerm "winifred_PN" ;
lin wink_N = mkTerm "wink_N" ;
lin wink_V = mkTerm "wink_V" ;
lin wink_V2 = mkTerm "wink_V2" ;
lin winker_N = mkTerm "winker_N" ;
lin winkle_N = mkTerm "winkle_N" ;
lin winkle_V2 = mkTerm "winkle_V2" ;
lin winkle_out_V2 = mkTerm "winkle_out_V2" ;
lin winless_A = mkTerm "winless_A" ;
lin winner_N = mkTerm "winner_N" ;
lin winnie_PN = mkTerm "winnie_PN" ;
lin winning_A = mkTerm "winning_A" ;
lin winning_N = mkTerm "winning_N" ;
lin winning_post_N = mkTerm "winning_post_N" ;
lin winnings_N = mkTerm "winnings_N" ;
lin winnipeg_PN = mkTerm "winnipeg_PN" ;
lin winnow_N = mkTerm "winnow_N" ;
lin winnow_V2 = mkTerm "winnow_V2" ;
lin winsford_PN = mkTerm "winsford_PN" ;
lin winsome_A = mkTerm "winsome_A" ;
lin winsomeness_N = mkTerm "winsomeness_N" ;
lin winter_N = mkTerm "winter_N" ;
lin winter_V = mkTerm "winter_V" ;
lin wintergreen_N = mkTerm "wintergreen_N" ;
lin wintery_A = mkTerm "wintery_A" ;
lin wintry_A = mkTerm "wintry_A" ;
lin winy_A = mkTerm "winy_A" ;
lin wipe_N = mkTerm "wipe_N" ;
lin wipe_V = mkTerm "wipe_V" ;
lin wipe_V2 = mkTerm "wipe_V2" ;
lin wipe_out_V = mkTerm "wipe_out_V" ;
lin wipe_out_V2 = mkTerm "wipe_out_V2" ;
lin wipeout_N = mkTerm "wipeout_N" ;
lin wiper_N = mkTerm "wiper_N" ;
lin wire_N = mkTerm "wire_N" ;
lin wire_V = mkTerm "wire_V" ;
lin wire_V2 = mkTerm "wire_V2" ;
lin wire_haired_A = mkTerm "wire_haired_A" ;
lin wire_up_V2 = mkTerm "wire_up_V2" ;
lin wirehair_N = mkTerm "wirehair_N" ;
lin wireless_A = mkTerm "wireless_A" ;
lin wireless_N = mkTerm "wireless_N" ;
lin wireman_N = mkTerm "wireman_N" ;
lin wirepuller_N = mkTerm "wirepuller_N" ;
lin wirer_N = mkTerm "wirer_N" ;
lin wiretap_N = mkTerm "wiretap_N" ;
lin wirework_N = mkTerm "wirework_N" ;
lin wireworm_N = mkTerm "wireworm_N" ;
lin wiriness_N = mkTerm "wiriness_N" ;
lin wiring_N = mkTerm "wiring_N" ;
lin wiry_A = mkTerm "wiry_A" ;
lin wisbech_PN = mkTerm "wisbech_PN" ;
lin wisconsin_PN = mkTerm "wisconsin_PN" ;
lin wisdom_N = mkTerm "wisdom_N" ;
lin wisdom_tooth_N = mkTerm "wisdom_tooth_N" ;
lin wise_A = mkTerm "wise_A" ;
lin wise_N = mkTerm "wise_N" ;
lin wise_up_V = mkTerm "wise_up_V" ;
lin wiseacre_N = mkTerm "wiseacre_N" ;
lin wisecrack_N = mkTerm "wisecrack_N" ;
lin wisecrack_V = mkTerm "wisecrack_V" ;
lin wisent_N = mkTerm "wisent_N" ;
lin wish_N = mkTerm "wish_N" ;
lin wish_V = mkTerm "wish_V" ;
lin wish_V2 = mkTerm "wish_V2" ;
lin wish_V2V = mkTerm "wish_V2V" ;
lin wish_VS = mkTerm "wish_VS" ;
lin wish_VV = mkTerm "wish_VV" ;
lin wishbone_N = mkTerm "wishbone_N" ;
lin wishful_A = mkTerm "wishful_A" ;
lin wishfulness_N = mkTerm "wishfulness_N" ;
lin wishing_cap_N = mkTerm "wishing_cap_N" ;
lin wishy_washy_A = mkTerm "wishy_washy_A" ;
lin wisp_N = mkTerm "wisp_N" ;
lin wisplike_A = mkTerm "wisplike_A" ;
lin wispy_A = mkTerm "wispy_A" ;
lin wisteria_N = mkTerm "wisteria_N" ;
lin wistful_A = mkTerm "wistful_A" ;
lin wistfulness_N = mkTerm "wistfulness_N" ;
lin wit_N = mkTerm "wit_N" ;
lin witch_N = mkTerm "witch_N" ;
lin witch_doctor_N = mkTerm "witch_doctor_N" ;
lin witch_elm_N = mkTerm "witch_elm_N" ;
lin witch_hazel_N = mkTerm "witch_hazel_N" ;
lin witch_hunt_N = mkTerm "witch_hunt_N" ;
lin witchcraft_N = mkTerm "witchcraft_N" ;
lin witchery_N = mkTerm "witchery_N" ;
lin witchgrass_N = mkTerm "witchgrass_N" ;
lin witching_A = mkTerm "witching_A" ;
lin witching_N = mkTerm "witching_N" ;
lin witchlike_A = mkTerm "witchlike_A" ;
lin with_a_view_to_Prep = mkTerm "with_a_view_to_Prep" ;
lin with_regard_to_Prep = mkTerm "with_regard_to_Prep" ;
lin with_respect_to_Prep = mkTerm "with_respect_to_Prep" ;
lin withal_Adv = mkTerm "withal_Adv" ;
lin witham_PN = mkTerm "witham_PN" ;
lin withdraw_V = mkTerm "withdraw_V" ;
lin withdraw_V2 = mkTerm "withdraw_V2" ;
lin withdrawal_N = mkTerm "withdrawal_N" ;
lin withdrawer_N = mkTerm "withdrawer_N" ;
lin withe_N = mkTerm "withe_N" ;
lin wither_V = mkTerm "wither_V" ;
lin wither_V2 = mkTerm "wither_V2" ;
lin witheringly_Adv = mkTerm "witheringly_Adv" ;
lin withernsea_PN = mkTerm "withernsea_PN" ;
lin withers_N = mkTerm "withers_N" ;
lin withhold_V2 = mkTerm "withhold_V2" ;
lin withholder_N = mkTerm "withholder_N" ;
lin withholding_N = mkTerm "withholding_N" ;
lin within_Adv = mkTerm "within_Adv" ;
lin within_Prep = mkTerm "within_Prep" ;
lin withstand_V2 = mkTerm "withstand_V2" ;
lin withstander_N = mkTerm "withstander_N" ;
lin withy_N = mkTerm "withy_N" ;
lin witless_A = mkTerm "witless_A" ;
lin witness_N = mkTerm "witness_N" ;
lin witness_V = mkTerm "witness_V" ;
lin witness_V2 = mkTerm "witness_V2" ;
lin witness_box_N = mkTerm "witness_box_N" ;
lin witness_stand_N = mkTerm "witness_stand_N" ;
lin witney_PN = mkTerm "witney_PN" ;
lin wits_N = mkTerm "wits_N" ;
lin witticism_N = mkTerm "witticism_N" ;
lin witting_A = mkTerm "witting_A" ;
lin wittol_N = mkTerm "wittol_N" ;
lin witty_A = mkTerm "witty_A" ;
lin wive_V = mkTerm "wive_V" ;
lin wive_V2 = mkTerm "wive_V2" ;
lin wizard_A = mkTerm "wizard_A" ;
lin wizard_N = mkTerm "wizard_N" ;
lin wizardry_N = mkTerm "wizardry_N" ;
lin wizened_A = mkTerm "wizened_A" ;
lin wk_N = mkTerm "wk_N" ;
lin woad_N = mkTerm "woad_N" ;
lin wobble_N = mkTerm "wobble_N" ;
lin wobble_V = mkTerm "wobble_V" ;
lin wobble_V2 = mkTerm "wobble_V2" ;
lin wobbler_N = mkTerm "wobbler_N" ;
lin wobbly_A = mkTerm "wobbly_A" ;
lin woburn_PN = mkTerm "woburn_PN" ;
lin woe_N = mkTerm "woe_N" ;
lin woebegone_A = mkTerm "woebegone_A" ;
lin woeful_A = mkTerm "woeful_A" ;
lin wog_N = mkTerm "wog_N" ;
lin wok_N = mkTerm "wok_N" ;
lin wokingham_PN = mkTerm "wokingham_PN" ;
lin wold_N = mkTerm "wold_N" ;
lin wolf's_bane_N = mkTerm "wolf's_bane_N" ;
lin wolf_N = mkTerm "wolf_N" ;
lin wolf_V2 = mkTerm "wolf_V2" ;
lin wolf_cub_N = mkTerm "wolf_cub_N" ;
lin wolffish_N = mkTerm "wolffish_N" ;
lin wolfhound_N = mkTerm "wolfhound_N" ;
lin wolfish_A = mkTerm "wolfish_A" ;
lin wolflike_A = mkTerm "wolflike_A" ;
lin wolfram_N = mkTerm "wolfram_N" ;
lin wolframite_N = mkTerm "wolframite_N" ;
lin wolfsbane_N = mkTerm "wolfsbane_N" ;
lin wollastonite_N = mkTerm "wollastonite_N" ;
lin wolverhampton_PN = mkTerm "wolverhampton_PN" ;
lin wolverine_N = mkTerm "wolverine_N" ;
lin wolverton_PN = mkTerm "wolverton_PN" ;
lin woman_N = mkTerm "woman_N" ;
lin womanhood_N = mkTerm "womanhood_N" ;
lin womanish_A = mkTerm "womanish_A" ;
lin womanize_V = mkTerm "womanize_V" ;
lin womanizer_N = mkTerm "womanizer_N" ;
lin womankind_N = mkTerm "womankind_N" ;
lin womanlike_A = mkTerm "womanlike_A" ;
lin womanliness_N = mkTerm "womanliness_N" ;
lin womanly_A = mkTerm "womanly_A" ;
lin womb_N = mkTerm "womb_N" ;
lin wombat_N = mkTerm "wombat_N" ;
lin wombourne_PN = mkTerm "wombourne_PN" ;
lin wonder_N = mkTerm "wonder_N" ;
lin wonder_V = mkTerm "wonder_V" ;
lin wonder_VQ = mkTerm "wonder_VQ" ;
lin wonder_struck_A = mkTerm "wonder_struck_A" ;
lin wonderer_N = mkTerm "wonderer_N" ;
lin wonderful_A = mkTerm "wonderful_A" ;
lin wonderingly_Adv = mkTerm "wonderingly_Adv" ;
lin wonderland_N = mkTerm "wonderland_N" ;
lin wonderment_N = mkTerm "wonderment_N" ;
lin wonderworking_A = mkTerm "wonderworking_A" ;
lin wondrous_A = mkTerm "wondrous_A" ;
lin wondrous_Adv = mkTerm "wondrous_Adv" ;
lin wonky_A = mkTerm "wonky_A" ;
lin wont_A = mkTerm "wont_A" ;
lin wont_N = mkTerm "wont_N" ;
lin wonted_A = mkTerm "wonted_A" ;
lin woo_V2 = mkTerm "woo_V2" ;
lin wood_N = mkTerm "wood_N" ;
lin wood_block_N = mkTerm "wood_block_N" ;
lin wood_pulp_N = mkTerm "wood_pulp_N" ;
lin woodbine_N = mkTerm "woodbine_N" ;
lin woodborer_N = mkTerm "woodborer_N" ;
lin woodbridge_PN = mkTerm "woodbridge_PN" ;
lin woodcarver_N = mkTerm "woodcarver_N" ;
lin woodcarving_N = mkTerm "woodcarving_N" ;
lin woodcock_N = mkTerm "woodcock_N" ;
lin woodcraft_N = mkTerm "woodcraft_N" ;
lin woodcut_N = mkTerm "woodcut_N" ;
lin woodcutter_N = mkTerm "woodcutter_N" ;
lin wooded_A = mkTerm "wooded_A" ;
lin wooden_A = mkTerm "wooden_A" ;
lin woodenheaded_A = mkTerm "woodenheaded_A" ;
lin woodenness_N = mkTerm "woodenness_N" ;
lin woodenware_N = mkTerm "woodenware_N" ;
lin woodhewer_N = mkTerm "woodhewer_N" ;
lin woodiness_N = mkTerm "woodiness_N" ;
lin woodland_N = mkTerm "woodland_N" ;
lin woodlouse_N = mkTerm "woodlouse_N" ;
lin woodman_N = mkTerm "woodman_N" ;
lin woodpecker_N = mkTerm "woodpecker_N" ;
lin woodpile_N = mkTerm "woodpile_N" ;
lin woodruff_N = mkTerm "woodruff_N" ;
lin woodscrew_N = mkTerm "woodscrew_N" ;
lin woodshed_N = mkTerm "woodshed_N" ;
lin woodsia_N = mkTerm "woodsia_N" ;
lin woodsman_N = mkTerm "woodsman_N" ;
lin woodsy_A = mkTerm "woodsy_A" ;
lin woodwaxen_N = mkTerm "woodwaxen_N" ;
lin woodwind_N = mkTerm "woodwind_N" ;
lin woodwork_N = mkTerm "woodwork_N" ;
lin woodworker_N = mkTerm "woodworker_N" ;
lin woodworm_N = mkTerm "woodworm_N" ;
lin woody_A = mkTerm "woody_A" ;
lin wooer_N = mkTerm "wooer_N" ;
lin woof_N = mkTerm "woof_N" ;
lin woofer_N = mkTerm "woofer_N" ;
lin wool_N = mkTerm "wool_N" ;
lin woolen_A = mkTerm "woolen_A" ;
lin woolgathering_A = mkTerm "woolgathering_A" ;
lin woolgathering_N = mkTerm "woolgathering_N" ;
lin woollen_A = mkTerm "woollen_A" ;
lin woolly_A = mkTerm "woolly_A" ;
lin wooly_A = mkTerm "wooly_A" ;
lin wooly_N = mkTerm "wooly_N" ;
lin wootton_bassett_PN = mkTerm "wootton_bassett_PN" ;
lin wop_N = mkTerm "wop_N" ;
lin worcester_PN = mkTerm "worcester_PN" ;
lin word_N = mkTerm "word_N" ;
lin word_V2 = mkTerm "word_V2" ;
lin word_division_N = mkTerm "word_division_N" ;
lin word_painter_N = mkTerm "word_painter_N" ;
lin word_perfect_A = mkTerm "word_perfect_A" ;
lin word_picture_N = mkTerm "word_picture_N" ;
lin word_splitting_N = mkTerm "word_splitting_N" ;
lin word_up_V2 = mkTerm "word_up_V2" ;
lin wordbook_N = mkTerm "wordbook_N" ;
lin wordiness_N = mkTerm "wordiness_N" ;
lin wording_N = mkTerm "wording_N" ;
lin wordless_A = mkTerm "wordless_A" ;
lin wordmonger_N = mkTerm "wordmonger_N" ;
lin wordnet_N = mkTerm "wordnet_N" ;
lin words_N = mkTerm "words_N" ;
lin wordsmith_N = mkTerm "wordsmith_N" ;
lin wordy_A = mkTerm "wordy_A" ;
lin work_1_V = mkTerm "work_1_V" ;
lin work_2_V = mkTerm "work_2_V" ;
lin work_N = mkTerm "work_N" ;
lin work_V2 = mkTerm "work_V2" ;
lin work_in_N = mkTerm "work_in_N" ;
lin work_off_V2 = mkTerm "work_off_V2" ;
lin work_on_V2 = mkTerm "work_on_V2" ;
lin work_out_N = mkTerm "work_out_N" ;
lin work_out_V = mkTerm "work_out_V" ;
lin work_out_V2 = mkTerm "work_out_V2" ;
lin work_over_V2 = mkTerm "work_over_V2" ;
lin work_study_N = mkTerm "work_study_N" ;
lin work_through_V2 = mkTerm "work_through_V2" ;
lin work_together_V = mkTerm "work_together_V" ;
lin work_up_V = mkTerm "work_up_V" ;
lin workable_A = mkTerm "workable_A" ;
lin workaday_A = mkTerm "workaday_A" ;
lin workaholic_N = mkTerm "workaholic_N" ;
lin workaholism_N = mkTerm "workaholism_N" ;
lin workbag_N = mkTerm "workbag_N" ;
lin workbasket_N = mkTerm "workbasket_N" ;
lin workbench_N = mkTerm "workbench_N" ;
lin workboard_N = mkTerm "workboard_N" ;
lin workbook_N = mkTerm "workbook_N" ;
lin workbox_N = mkTerm "workbox_N" ;
lin workday_N = mkTerm "workday_N" ;
lin worker_N = mkTerm "worker_N" ;
lin workforce_N = mkTerm "workforce_N" ;
lin workhorse_N = mkTerm "workhorse_N" ;
lin workhouse_N = mkTerm "workhouse_N" ;
lin working_A = mkTerm "working_A" ;
lin working_N = mkTerm "working_N" ;
lin working_class_A = mkTerm "working_class_A" ;
lin working_out_N = mkTerm "working_out_N" ;
lin workington_PN = mkTerm "workington_PN" ;
lin workload_N = mkTerm "workload_N" ;
lin workman_N = mkTerm "workman_N" ;
lin workmanlike_A = mkTerm "workmanlike_A" ;
lin workmanship_N = mkTerm "workmanship_N" ;
lin workmate_N = mkTerm "workmate_N" ;
lin workpiece_N = mkTerm "workpiece_N" ;
lin workplace_N = mkTerm "workplace_N" ;
lin workroom_N = mkTerm "workroom_N" ;
lin works_N = mkTerm "works_N" ;
lin worksheet_N = mkTerm "worksheet_N" ;
lin workshop_N = mkTerm "workshop_N" ;
lin workshy_A = mkTerm "workshy_A" ;
lin worksop_PN = mkTerm "worksop_PN" ;
lin workspace_N = mkTerm "workspace_N" ;
lin workstation_N = mkTerm "workstation_N" ;
lin worktable_N = mkTerm "worktable_N" ;
lin workwear_N = mkTerm "workwear_N" ;
lin workweek_N = mkTerm "workweek_N" ;
lin world_N = mkTerm "world_N" ;
lin world_weary_A = mkTerm "world_weary_A" ;
lin worldliness_N = mkTerm "worldliness_N" ;
lin worldling_N = mkTerm "worldling_N" ;
lin worldly_A = mkTerm "worldly_A" ;
lin worldwide_A = mkTerm "worldwide_A" ;
lin worldwide_Adv = mkTerm "worldwide_Adv" ;
lin worm_N = mkTerm "worm_N" ;
lin worm_V2 = mkTerm "worm_V2" ;
lin worm_eaten_A = mkTerm "worm_eaten_A" ;
lin worm_gear_N = mkTerm "worm_gear_N" ;
lin wormcast_N = mkTerm "wormcast_N" ;
lin wormhole_N = mkTerm "wormhole_N" ;
lin wormwood_N = mkTerm "wormwood_N" ;
lin wormy_A = mkTerm "wormy_A" ;
lin worried_A = mkTerm "worried_A" ;
lin worrier_N = mkTerm "worrier_N" ;
lin worrisome_A = mkTerm "worrisome_A" ;
lin worry_N = mkTerm "worry_N" ;
lin worry_V = mkTerm "worry_V" ;
lin worry_V2 = mkTerm "worry_V2" ;
lin worry_VS = mkTerm "worry_VS" ;
lin worrying_A = mkTerm "worrying_A" ;
lin worrying_N = mkTerm "worrying_N" ;
lin worse_A = mkTerm "worse_A" ;
lin worse_Adv = mkTerm "worse_Adv" ;
lin worse_N = mkTerm "worse_N" ;
lin worsen_V = mkTerm "worsen_V" ;
lin worsen_V2 = mkTerm "worsen_V2" ;
lin worsening_N = mkTerm "worsening_N" ;
lin worship_N = mkTerm "worship_N" ;
lin worship_V = mkTerm "worship_V" ;
lin worship_V2 = mkTerm "worship_V2" ;
lin worshiper_N = mkTerm "worshiper_N" ;
lin worshipful_A = mkTerm "worshipful_A" ;
lin worshipper_N = mkTerm "worshipper_N" ;
lin worst_A = mkTerm "worst_A" ;
lin worst_Adv = mkTerm "worst_Adv" ;
lin worst_V2 = mkTerm "worst_V2" ;
lin worsted_N = mkTerm "worsted_N" ;
lin wort_N = mkTerm "wort_N" ;
lin worth_A = mkTerm "worth_A" ;
lin worth_N = mkTerm "worth_N" ;
lin worth_Prep = mkTerm "worth_Prep" ;
lin worthiness_N = mkTerm "worthiness_N" ;
lin worthing_PN = mkTerm "worthing_PN" ;
lin worthless_A = mkTerm "worthless_A" ;
lin worthlessness_N = mkTerm "worthlessness_N" ;
lin worthwhile_A = mkTerm "worthwhile_A" ;
lin worthwhileness_N = mkTerm "worthwhileness_N" ;
lin worthy_A = mkTerm "worthy_A" ;
lin worthy_N = mkTerm "worthy_N" ;
lin would_be_A = mkTerm "would_be_A" ;
lin wound_N = mkTerm "wound_N" ;
lin wound_V2 = mkTerm "wound_V2" ;
lin wound_up_V = mkTerm "wound_up_V" ;
lin wounded_N = mkTerm "wounded_N" ;
lin woven_A = mkTerm "woven_A" ;
lin wow_Interj = mkTerm "wow_Interj" ;
lin wow_N = mkTerm "wow_N" ;
lin wpb_N = mkTerm "wpb_N" ;
lin wpm_N = mkTerm "wpm_N" ;
lin wrac_N = mkTerm "wrac_N" ;
lin wrack_N = mkTerm "wrack_N" ;
lin wrack_V2 = mkTerm "wrack_V2" ;
lin wraf_N = mkTerm "wraf_N" ;
lin wraith_N = mkTerm "wraith_N" ;
lin wrangle_N = mkTerm "wrangle_N" ;
lin wrangle_V = mkTerm "wrangle_V" ;
lin wrangler_N = mkTerm "wrangler_N" ;
lin wrap_N = mkTerm "wrap_N" ;
lin wrap_V = mkTerm "wrap_V" ;
lin wrap_V2 = mkTerm "wrap_V2" ;
lin wrap_around_V2 = mkTerm "wrap_around_V2" ;
lin wrap_up_V = mkTerm "wrap_up_V" ;
lin wrap_up_V2 = mkTerm "wrap_up_V2" ;
lin wraparound_N = mkTerm "wraparound_N" ;
lin wrapper_N = mkTerm "wrapper_N" ;
lin wrapping_N = mkTerm "wrapping_N" ;
lin wrasse_N = mkTerm "wrasse_N" ;
lin wrath_N = mkTerm "wrath_N" ;
lin wrathful_A = mkTerm "wrathful_A" ;
lin wreak_V2 = mkTerm "wreak_V2" ;
lin wreath_N = mkTerm "wreath_N" ;
lin wreathe_V = mkTerm "wreathe_V" ;
lin wreathe_V2 = mkTerm "wreathe_V2" ;
lin wreck_N = mkTerm "wreck_N" ;
lin wreck_V2 = mkTerm "wreck_V2" ;
lin wreckage_N = mkTerm "wreckage_N" ;
lin wrecker_N = mkTerm "wrecker_N" ;
lin wren_N = mkTerm "wren_N" ;
lin wrench_N = mkTerm "wrench_N" ;
lin wrench_V2 = mkTerm "wrench_V2" ;
lin wrest_V2 = mkTerm "wrest_V2" ;
lin wrester_N = mkTerm "wrester_N" ;
lin wrestle_N = mkTerm "wrestle_N" ;
lin wrestle_V = mkTerm "wrestle_V" ;
lin wrestle_V2 = mkTerm "wrestle_V2" ;
lin wrestler_N = mkTerm "wrestler_N" ;
lin wrestling_N = mkTerm "wrestling_N" ;
lin wretch_N = mkTerm "wretch_N" ;
lin wretched_A = mkTerm "wretched_A" ;
lin wretchedness_N = mkTerm "wretchedness_N" ;
lin wrexham_PN = mkTerm "wrexham_PN" ;
lin wrick_N = mkTerm "wrick_N" ;
lin wrick_V2 = mkTerm "wrick_V2" ;
lin wriggle_N = mkTerm "wriggle_N" ;
lin wriggle_V = mkTerm "wriggle_V" ;
lin wriggle_V2 = mkTerm "wriggle_V2" ;
lin wriggle_out_of_V2 = mkTerm "wriggle_out_of_V2" ;
lin wriggler_N = mkTerm "wriggler_N" ;
lin wright_N = mkTerm "wright_N" ;
lin wring_N = mkTerm "wring_N" ;
lin wring_V2 = mkTerm "wring_V2" ;
lin wringer_N = mkTerm "wringer_N" ;
lin wrinkle_N = mkTerm "wrinkle_N" ;
lin wrinkle_V = mkTerm "wrinkle_V" ;
lin wrinkle_V2 = mkTerm "wrinkle_V2" ;
lin wrinkly_A = mkTerm "wrinkly_A" ;
lin wrist_N = mkTerm "wrist_N" ;
lin wristband_N = mkTerm "wristband_N" ;
lin wristlet_N = mkTerm "wristlet_N" ;
lin wristwatch_N = mkTerm "wristwatch_N" ;
lin writ_N = mkTerm "writ_N" ;
lin writ_large_A = mkTerm "writ_large_A" ;
lin write_V = mkTerm "write_V" ;
lin write_V2 = mkTerm "write_V2" ;
lin write_VS = mkTerm "write_VS" ;
lin write_down_V2 = mkTerm "write_down_V2" ;
lin write_in_V = mkTerm "write_in_V" ;
lin write_off_N = mkTerm "write_off_N" ;
lin write_off_V2 = mkTerm "write_off_V2" ;
lin write_out_V2 = mkTerm "write_out_V2" ;
lin write_up_N = mkTerm "write_up_N" ;
lin write_up_V2 = mkTerm "write_up_V2" ;
lin writer_N = mkTerm "writer_N" ;
lin writhe_V = mkTerm "writhe_V" ;
lin writing_N = mkTerm "writing_N" ;
lin writing_desk_N = mkTerm "writing_desk_N" ;
lin writing_ink_N = mkTerm "writing_ink_N" ;
lin writing_paper_N = mkTerm "writing_paper_N" ;
lin written_A = mkTerm "written_A" ;
lin writtle_PN = mkTerm "writtle_PN" ;
lin wrns_N = mkTerm "wrns_N" ;
lin wroclaw_PN = mkTerm "wroclaw_PN" ;
lin wrong_A = mkTerm "wrong_A" ;
lin wrong_Adv = mkTerm "wrong_Adv" ;
lin wrong_N = mkTerm "wrong_N" ;
lin wrong_V2 = mkTerm "wrong_V2" ;
lin wrong_headed_A = mkTerm "wrong_headed_A" ;
lin wrongdoer_N = mkTerm "wrongdoer_N" ;
lin wrongdoing_N = mkTerm "wrongdoing_N" ;
lin wrongful_A = mkTerm "wrongful_A" ;
lin wrongness_N = mkTerm "wrongness_N" ;
lin wroth_A = mkTerm "wroth_A" ;
lin wroughton_PN = mkTerm "wroughton_PN" ;
lin wry_A = mkTerm "wry_A" ;
lin wrymouth_N = mkTerm "wrymouth_N" ;
lin wryneck_N = mkTerm "wryneck_N" ;
lin wt_N = mkTerm "wt_N" ;
lin wuhan_PN = mkTerm "wuhan_PN" ;
lin wulfenite_N = mkTerm "wulfenite_N" ;
lin wuppertal_PN = mkTerm "wuppertal_PN" ;
lin wurtzite_N = mkTerm "wurtzite_N" ;
lin wurzburg_PN = mkTerm "wurzburg_PN" ;
lin wusih_PN = mkTerm "wusih_PN" ;
lin wycombe_PN = mkTerm "wycombe_PN" ;
lin wymondham_PN = mkTerm "wymondham_PN" ;
lin wyoming_PN = mkTerm "wyoming_PN" ;
lin wythall_PN = mkTerm "wythall_PN" ;
lin wyvern_N = mkTerm "wyvern_N" ;
lin x_ray_N = mkTerm "x_ray_N" ;
lin x_ray_V2 = mkTerm "x_ray_V2" ;
lin xanthate_N = mkTerm "xanthate_N" ;
lin xanthelasma_N = mkTerm "xanthelasma_N" ;
lin xanthine_N = mkTerm "xanthine_N" ;
lin xanthoma_N = mkTerm "xanthoma_N" ;
lin xanthomatosis_N = mkTerm "xanthomatosis_N" ;
lin xanthomonad_N = mkTerm "xanthomonad_N" ;
lin xanthophyll_N = mkTerm "xanthophyll_N" ;
lin xanthopsia_N = mkTerm "xanthopsia_N" ;
lin xanthosis_N = mkTerm "xanthosis_N" ;
lin xenogeneic_A = mkTerm "xenogeneic_A" ;
lin xenolith_N = mkTerm "xenolith_N" ;
lin xenon_N = mkTerm "xenon_N" ;
lin xenophobia_N = mkTerm "xenophobia_N" ;
lin xenophobic_A = mkTerm "xenophobic_A" ;
lin xenotime_N = mkTerm "xenotime_N" ;
lin xenotransplant_N = mkTerm "xenotransplant_N" ;
lin xeranthemum_N = mkTerm "xeranthemum_N" ;
lin xeric_A = mkTerm "xeric_A" ;
lin xeroderma_N = mkTerm "xeroderma_N" ;
lin xerographic_A = mkTerm "xerographic_A" ;
lin xerography_N = mkTerm "xerography_N" ;
lin xerophthalmia_N = mkTerm "xerophthalmia_N" ;
lin xerophytic_A = mkTerm "xerophytic_A" ;
lin xeroradiography_N = mkTerm "xeroradiography_N" ;
lin xerostomia_N = mkTerm "xerostomia_N" ;
lin xerox_N = mkTerm "xerox_N" ;
lin xerox_V2 = mkTerm "xerox_V2" ;
lin xi_N = mkTerm "xi_N" ;
lin xmas_N = mkTerm "xmas_N" ;
lin xmas_PN = mkTerm "xmas_PN" ;
lin xylem_N = mkTerm "xylem_N" ;
lin xylene_N = mkTerm "xylene_N" ;
lin xylophone_N = mkTerm "xylophone_N" ;
lin xylophonist_N = mkTerm "xylophonist_N" ;
lin xylosma_N = mkTerm "xylosma_N" ;
lin yacca_N = mkTerm "yacca_N" ;
lin yacht_N = mkTerm "yacht_N" ;
lin yacht_V = mkTerm "yacht_V" ;
lin yacht_club_N = mkTerm "yacht_club_N" ;
lin yachting_N = mkTerm "yachting_N" ;
lin yachtsman_N = mkTerm "yachtsman_N" ;
lin yack_on_V = mkTerm "yack_on_V" ;
lin yagi_N = mkTerm "yagi_N" ;
lin yahoo_N = mkTerm "yahoo_N" ;
lin yak_N = mkTerm "yak_N" ;
lin yak_on_V = mkTerm "yak_on_V" ;
lin yak_on_about_V2 = mkTerm "yak_on_about_V2" ;
lin yakuza_N = mkTerm "yakuza_N" ;
lin yam_N = mkTerm "yam_N" ;
lin yammer_V = mkTerm "yammer_V" ;
lin yammer_on_V = mkTerm "yammer_on_V" ;
lin yammer_on_about_V2 = mkTerm "yammer_on_about_V2" ;
lin yang_N = mkTerm "yang_N" ;
lin yank_N = mkTerm "yank_N" ;
lin yank_V2 = mkTerm "yank_V2" ;
lin yank_out_V = mkTerm "yank_out_V" ;
lin yankee_N = mkTerm "yankee_N" ;
lin yanker_N = mkTerm "yanker_N" ;
lin yap_N = mkTerm "yap_N" ;
lin yap_V = mkTerm "yap_V" ;
lin yard_N = mkTerm "yard_N" ;
lin yard_measure_N = mkTerm "yard_measure_N" ;
lin yardage_N = mkTerm "yardage_N" ;
lin yardarm_N = mkTerm "yardarm_N" ;
lin yarder_N = mkTerm "yarder_N" ;
lin yardgrass_N = mkTerm "yardgrass_N" ;
lin yardie_N = mkTerm "yardie_N" ;
lin yardman_N = mkTerm "yardman_N" ;
lin yardmaster_N = mkTerm "yardmaster_N" ;
lin yardstick_N = mkTerm "yardstick_N" ;
lin yarmouth_PN = mkTerm "yarmouth_PN" ;
lin yarmulke_N = mkTerm "yarmulke_N" ;
lin yarn_N = mkTerm "yarn_N" ;
lin yarn_V = mkTerm "yarn_V" ;
lin yaroslavi_PN = mkTerm "yaroslavi_PN" ;
lin yarrow_N = mkTerm "yarrow_N" ;
lin yashmak_N = mkTerm "yashmak_N" ;
lin yataghan_N = mkTerm "yataghan_N" ;
lin yate_PN = mkTerm "yate_PN" ;
lin yateley_PN = mkTerm "yateley_PN" ;
lin yautia_N = mkTerm "yautia_N" ;
lin yaw_N = mkTerm "yaw_N" ;
lin yaw_V = mkTerm "yaw_V" ;
lin yawl_N = mkTerm "yawl_N" ;
lin yawn_N = mkTerm "yawn_N" ;
lin yawn_V = mkTerm "yawn_V" ;
lin yawner_N = mkTerm "yawner_N" ;
lin yaws_N = mkTerm "yaws_N" ;
lin yea_Adv = mkTerm "yea_Adv" ;
lin yea_N = mkTerm "yea_N" ;
lin yeah_Interj = mkTerm "yeah_Interj" ;
lin year_N = mkTerm "year_N" ;
lin yearbook_N = mkTerm "yearbook_N" ;
lin yearling_N = mkTerm "yearling_N" ;
lin yearlong_A = mkTerm "yearlong_A" ;
lin yearly_A = mkTerm "yearly_A" ;
lin yearly_Adv = mkTerm "yearly_Adv" ;
lin yearn_V = mkTerm "yearn_V" ;
lin yearning_N = mkTerm "yearning_N" ;
lin yearningly_Adv = mkTerm "yearningly_Adv" ;
lin yeast_N = mkTerm "yeast_N" ;
lin yeasty_A = mkTerm "yeasty_A" ;
lin yell_N = mkTerm "yell_N" ;
lin yell_V = mkTerm "yell_V" ;
lin yell_V2 = mkTerm "yell_V2" ;
lin yell_out_V = mkTerm "yell_out_V" ;
lin yelling_N = mkTerm "yelling_N" ;
lin yellow_A = mkTerm "yellow_A" ;
lin yellow_N = mkTerm "yellow_N" ;
lin yellow_V = mkTerm "yellow_V" ;
lin yellow_V2 = mkTerm "yellow_V2" ;
lin yellow_bellied_A = mkTerm "yellow_bellied_A" ;
lin yellow_flag_N = mkTerm "yellow_flag_N" ;
lin yellowcake_N = mkTerm "yellowcake_N" ;
lin yellowfin_N = mkTerm "yellowfin_N" ;
lin yellowhammer_N = mkTerm "yellowhammer_N" ;
lin yellowish_A = mkTerm "yellowish_A" ;
lin yellowlegs_N = mkTerm "yellowlegs_N" ;
lin yellowness_N = mkTerm "yellowness_N" ;
lin yellowtail_N = mkTerm "yellowtail_N" ;
lin yellowthroat_N = mkTerm "yellowthroat_N" ;
lin yellowwood_N = mkTerm "yellowwood_N" ;
lin yelp_V = mkTerm "yelp_V" ;
lin yemen_PN = mkTerm "yemen_PN" ;
lin yemeni_A = mkTerm "yemeni_A" ;
lin yemeni_N = mkTerm "yemeni_N" ;
lin yen_N = mkTerm "yen_N" ;
lin yen_V = mkTerm "yen_V" ;
lin yenta_N = mkTerm "yenta_N" ;
lin yeoman_N = mkTerm "yeoman_N" ;
lin yeomanry_N = mkTerm "yeomanry_N" ;
lin yeovil_PN = mkTerm "yeovil_PN" ;
lin yep_Interj = mkTerm "yep_Interj" ;
lin yerevan_PN = mkTerm "yerevan_PN" ;
lin yes_Interj = mkTerm "yes_Interj" ;
lin yeshiva_N = mkTerm "yeshiva_N" ;
lin yesterday_Adv = mkTerm "yesterday_Adv" ;
lin yesterday_N = mkTerm "yesterday_N" ;
lin yet_1_Adv = mkTerm "yet_1_Adv" ;
lin yet_2_Adv = mkTerm "yet_2_Adv" ;
lin yet_AdV = mkTerm "yet_AdV" ;
lin yeti_N = mkTerm "yeti_N" ;
lin yew_N = mkTerm "yew_N" ;
lin yew_tree_N = mkTerm "yew_tree_N" ;
lin yha_N = mkTerm "yha_N" ;
lin yiddish_N = mkTerm "yiddish_N" ;
lin yield_N = mkTerm "yield_N" ;
lin yield_V2 = mkTerm "yield_V2" ;
lin yield_to_V2 = mkTerm "yield_to_V2" ;
lin yield_up_V = mkTerm "yield_up_V" ;
lin yin_N = mkTerm "yin_N" ;
lin yip_N = mkTerm "yip_N" ;
lin yips_N = mkTerm "yips_N" ;
lin ylem_N = mkTerm "ylem_N" ;
lin yli_ii_PN = mkTerm "yli_ii_PN" ;
lin ylihärmä_PN = mkTerm "ylihärmä_PN" ;
lin ylikiiminki_PN = mkTerm "ylikiiminki_PN" ;
lin ylistaro_PN = mkTerm "ylistaro_PN" ;
lin ylitornio_PN = mkTerm "ylitornio_PN" ;
lin ylivieska_PN = mkTerm "ylivieska_PN" ;
lin ylämaa_PN = mkTerm "ylämaa_PN" ;
lin yläne_PN = mkTerm "yläne_PN" ;
lin ylöjärvi_PN = mkTerm "ylöjärvi_PN" ;
lin ymca_N = mkTerm "ymca_N" ;
lin yo_yo_N = mkTerm "yo_yo_N" ;
lin yob_N = mkTerm "yob_N" ;
lin yobibit_N = mkTerm "yobibit_N" ;
lin yodel_N = mkTerm "yodel_N" ;
lin yodel_V = mkTerm "yodel_V" ;
lin yodel_V2 = mkTerm "yodel_V2" ;
lin yodeling_N = mkTerm "yodeling_N" ;
lin yodeller_N = mkTerm "yodeller_N" ;
lin yodh_N = mkTerm "yodh_N" ;
lin yoga_N = mkTerm "yoga_N" ;
lin yoghourt_N = mkTerm "yoghourt_N" ;
lin yogi_N = mkTerm "yogi_N" ;
lin yogistic_A = mkTerm "yogistic_A" ;
lin yoke_N = mkTerm "yoke_N" ;
lin yoke_V = mkTerm "yoke_V" ;
lin yoke_V2 = mkTerm "yoke_V2" ;
lin yokel_N = mkTerm "yokel_N" ;
lin yokohama_PN = mkTerm "yokohama_PN" ;
lin yolk_N = mkTerm "yolk_N" ;
lin yon_A = mkTerm "yon_A" ;
lin yon_Adv = mkTerm "yon_Adv" ;
lin yonder_A = mkTerm "yonder_A" ;
lin yonder_Adv = mkTerm "yonder_Adv" ;
lin yore_N = mkTerm "yore_N" ;
lin york_PN = mkTerm "york_PN" ;
lin yorkley_PN = mkTerm "yorkley_PN" ;
lin yorkshire_PN = mkTerm "yorkshire_PN" ;
lin yottabit_N = mkTerm "yottabit_N" ;
lin yottabyte_N = mkTerm "yottabyte_N" ;
lin youPlFem_Pron = mkTerm "youPlFem_Pron" ;
lin youPolFem_Pron = mkTerm "youPolFem_Pron" ;
lin youSgFem_Pron = mkTerm "youSgFem_Pron" ;
lin young_A = mkTerm "young_A" ;
lin young_N = mkTerm "young_N" ;
lin younger_A = mkTerm "younger_A" ;
lin youngish_A = mkTerm "youngish_A" ;
lin youngness_N = mkTerm "youngness_N" ;
lin youngster_N = mkTerm "youngster_N" ;
lin youth_N = mkTerm "youth_N" ;
lin youthful_A = mkTerm "youthful_A" ;
lin youthfulness_N = mkTerm "youthfulness_N" ;
lin yowl_V = mkTerm "yowl_V" ;
lin ypäjä_PN = mkTerm "ypäjä_PN" ;
lin yr_N = mkTerm "yr_N" ;
lin ystradgynlais_PN = mkTerm "ystradgynlais_PN" ;
lin ytterbium_N = mkTerm "ytterbium_N" ;
lin yttrium_N = mkTerm "yttrium_N" ;
lin yuan_N = mkTerm "yuan_N" ;
lin yucca_N = mkTerm "yucca_N" ;
lin yugoslav_A = mkTerm "yugoslav_A" ;
lin yugoslav_N = mkTerm "yugoslav_N" ;
lin yugoslavia_PN = mkTerm "yugoslavia_PN" ;
lin yugoslavian_A = mkTerm "yugoslavian_A" ;
lin yugoslavian_N = mkTerm "yugoslavian_N" ;
lin yukon_PN = mkTerm "yukon_PN" ;
lin yule_N = mkTerm "yule_N" ;
lin yule_log_N = mkTerm "yule_log_N" ;
lin yuletide_N = mkTerm "yuletide_N" ;
lin yuppie_N = mkTerm "yuppie_N" ;
lin yurt_N = mkTerm "yurt_N" ;
lin yvonne_PN = mkTerm "yvonne_PN" ;
lin ywca_N = mkTerm "ywca_N" ;
lin zabaglione_N = mkTerm "zabaglione_N" ;
lin zagreb_PN = mkTerm "zagreb_PN" ;
lin zaire_N = mkTerm "zaire_N" ;
lin zaire_PN = mkTerm "zaire_PN" ;
lin zairean_A = mkTerm "zairean_A" ;
lin zairean_N = mkTerm "zairean_N" ;
lin zakat_N = mkTerm "zakat_N" ;
lin zambia_PN = mkTerm "zambia_PN" ;
lin zambian_A = mkTerm "zambian_A" ;
lin zambian_N = mkTerm "zambian_N" ;
lin zamia_N = mkTerm "zamia_N" ;
lin zany_A = mkTerm "zany_A" ;
lin zany_N = mkTerm "zany_N" ;
lin zap_N = mkTerm "zap_N" ;
lin zap_V2 = mkTerm "zap_V2" ;
lin zaporozhye_PN = mkTerm "zaporozhye_PN" ;
lin zapper_N = mkTerm "zapper_N" ;
lin zaragoza_PN = mkTerm "zaragoza_PN" ;
lin zarf_N = mkTerm "zarf_N" ;
lin zayin_N = mkTerm "zayin_N" ;
lin zeal_N = mkTerm "zeal_N" ;
lin zealand_PN = mkTerm "zealand_PN" ;
lin zealander_A = mkTerm "zealander_A" ;
lin zealander_N = mkTerm "zealander_N" ;
lin zealotFem_N = mkTerm "zealotFem_N" ;
lin zealotMasc_N = mkTerm "zealotMasc_N" ;
lin zealotry_N = mkTerm "zealotry_N" ;
lin zealous_A = mkTerm "zealous_A" ;
lin zeaxanthin_N = mkTerm "zeaxanthin_N" ;
lin zebibit_N = mkTerm "zebibit_N" ;
lin zebra_N = mkTerm "zebra_N" ;
lin zebrawood_N = mkTerm "zebrawood_N" ;
lin zebu_N = mkTerm "zebu_N" ;
lin zee_N = mkTerm "zee_N" ;
lin zen_N = mkTerm "zen_N" ;
lin zenith_N = mkTerm "zenith_N" ;
lin zenithal_A = mkTerm "zenithal_A" ;
lin zeolite_N = mkTerm "zeolite_N" ;
lin zephyr_N = mkTerm "zephyr_N" ;
lin zeppelin_N = mkTerm "zeppelin_N" ;
lin zero_A = mkTerm "zero_A" ;
lin zero_N = mkTerm "zero_N" ;
lin zero_V = mkTerm "zero_V" ;
lin zero_in_V = mkTerm "zero_in_V" ;
lin zero_in_on_V2 = mkTerm "zero_in_on_V2" ;
lin zero_out_V2 = mkTerm "zero_out_V2" ;
lin zeroth_A = mkTerm "zeroth_A" ;
lin zest_N = mkTerm "zest_N" ;
lin zestful_A = mkTerm "zestful_A" ;
lin zeta_N = mkTerm "zeta_N" ;
lin zettabit_N = mkTerm "zettabit_N" ;
lin zettabyte_N = mkTerm "zettabyte_N" ;
lin zeugma_N = mkTerm "zeugma_N" ;
lin zidovudine_N = mkTerm "zidovudine_N" ;
lin ziggurat_N = mkTerm "ziggurat_N" ;
lin zigzag_A = mkTerm "zigzag_A" ;
lin zigzag_Adv = mkTerm "zigzag_Adv" ;
lin zigzag_N = mkTerm "zigzag_N" ;
lin zigzag_V = mkTerm "zigzag_V" ;
lin zill_N = mkTerm "zill_N" ;
lin zillion_A = mkTerm "zillion_A" ;
lin zimbabwe_PN = mkTerm "zimbabwe_PN" ;
lin zimbabwean_A = mkTerm "zimbabwean_A" ;
lin zimbabwean_N = mkTerm "zimbabwean_N" ;
lin zinc_N = mkTerm "zinc_N" ;
lin zinfandel_N = mkTerm "zinfandel_N" ;
lin zing_N = mkTerm "zing_N" ;
lin zinger_N = mkTerm "zinger_N" ;
lin zinkenite_N = mkTerm "zinkenite_N" ;
lin zinnia_N = mkTerm "zinnia_N" ;
lin zinnwaldite_N = mkTerm "zinnwaldite_N" ;
lin zion_N = mkTerm "zion_N" ;
lin zionism_N = mkTerm "zionism_N" ;
lin zionist_A = mkTerm "zionist_A" ;
lin zionist_N = mkTerm "zionist_N" ;
lin zip_N = mkTerm "zip_N" ;
lin zip_V2 = mkTerm "zip_V2" ;
lin zip_around_V2 = mkTerm "zip_around_V2" ;
lin zip_by_V2 = mkTerm "zip_by_V2" ;
lin zip_code_N = mkTerm "zip_code_N" ;
lin zip_fastener_N = mkTerm "zip_fastener_N" ;
lin zip_it_V = mkTerm "zip_it_V" ;
lin zip_through_V = mkTerm "zip_through_V" ;
lin zip_up_V = mkTerm "zip_up_V" ;
lin zipper_N = mkTerm "zipper_N" ;
lin zircon_N = mkTerm "zircon_N" ;
lin zirconium_N = mkTerm "zirconium_N" ;
lin zither_N = mkTerm "zither_N" ;
lin ziti_N = mkTerm "ziti_N" ;
lin zizz_N = mkTerm "zizz_N" ;
lin zloty_N = mkTerm "zloty_N" ;
lin zoanthropy_N = mkTerm "zoanthropy_N" ;
lin zodiac_N = mkTerm "zodiac_N" ;
lin zodiacal_A = mkTerm "zodiacal_A" ;
lin zoe_PN = mkTerm "zoe_PN" ;
lin zoic_A = mkTerm "zoic_A" ;
lin zombie_N = mkTerm "zombie_N" ;
lin zonal_A = mkTerm "zonal_A" ;
lin zone_N = mkTerm "zone_N" ;
lin zone_V2 = mkTerm "zone_V2" ;
lin zone_in_V = mkTerm "zone_in_V" ;
lin zone_in_on_V2 = mkTerm "zone_in_on_V2" ;
lin zone_out_V = mkTerm "zone_out_V" ;
lin zoning_N = mkTerm "zoning_N" ;
lin zonk_out_V = mkTerm "zonk_out_V" ;
lin zonule_N = mkTerm "zonule_N" ;
lin zoo_N = mkTerm "zoo_N" ;
lin zooid_N = mkTerm "zooid_N" ;
lin zoolatry_N = mkTerm "zoolatry_N" ;
lin zoological_A = mkTerm "zoological_A" ;
lin zoologist_N = mkTerm "zoologist_N" ;
lin zoology_N = mkTerm "zoology_N" ;
lin zoom_N = mkTerm "zoom_N" ;
lin zoom_V = mkTerm "zoom_V" ;
lin zoom_in_V = mkTerm "zoom_in_V" ;
lin zoom_in_on_V2 = mkTerm "zoom_in_on_V2" ;
lin zoom_off_V = mkTerm "zoom_off_V" ;
lin zoom_out_V = mkTerm "zoom_out_V" ;
lin zoomastigote_N = mkTerm "zoomastigote_N" ;
lin zoomorphism_N = mkTerm "zoomorphism_N" ;
lin zoonosis_N = mkTerm "zoonosis_N" ;
lin zoonotic_A = mkTerm "zoonotic_A" ;
lin zoophilia_N = mkTerm "zoophilia_N" ;
lin zoophobia_N = mkTerm "zoophobia_N" ;
lin zoophyte_N = mkTerm "zoophyte_N" ;
lin zooplankton_N = mkTerm "zooplankton_N" ;
lin zoopsia_N = mkTerm "zoopsia_N" ;
lin zoospore_N = mkTerm "zoospore_N" ;
lin zoot_suit_N = mkTerm "zoot_suit_N" ;
lin zoril_N = mkTerm "zoril_N" ;
lin zoysia_N = mkTerm "zoysia_N" ;
lin zucchini_N = mkTerm "zucchini_N" ;
lin zurich_PN = mkTerm "zurich_PN" ;
lin zwieback_N = mkTerm "zwieback_N" ;
lin zydeco_N = mkTerm "zydeco_N" ;
lin zygodactyl_A = mkTerm "zygodactyl_A" ;
lin zygoma_N = mkTerm "zygoma_N" ;
lin zygomatic_A = mkTerm "zygomatic_A" ;
lin zygomorphic_A = mkTerm "zygomorphic_A" ;
lin zygospore_N = mkTerm "zygospore_N" ;
lin zygote_N = mkTerm "zygote_N" ;
lin zygotene_N = mkTerm "zygotene_N" ;
lin zygotic_A = mkTerm "zygotic_A" ;
lin zymase_N = mkTerm "zymase_N" ;
lin zymoid_A = mkTerm "zymoid_A" ;
lin zymology_N = mkTerm "zymology_N" ;
lin zymosis_N = mkTerm "zymosis_N" ;
lin zymotic_A = mkTerm "zymotic_A" ;
lin äetsä_PN = mkTerm "äetsä_PN" ;
lin ähtäri_PN = mkTerm "ähtäri_PN" ;
lin äänekoski_PN = mkTerm "äänekoski_PN" ;

}