-- This dictionary is derived from SALDO, see:
-- https://spraakbanken.gu.se/eng/resource/saldo
--
-- Original module by Malin Ahlberg has been moved to OldDictSwe.
-- Both are inherited by DictSwe, to guarantee backward compatibility.
-- This updated version with renamed identifiers is maintained by John J. Camilleri

concrete NewDictSwe of NewDictSweAbs = CatSwe ** open ParadigmsSwe in {

flags
  optimize=values ; coding=utf8 ;

lin
  A_bomb_1_N = mkN "A-bomb" "A-bomber" ; -- A-bomb..nn.1
  A_kassa_1_N = mkN "A-kassa" ; -- A-kassa..nn.1
  A_lag_1_N = mkN "A-lag" neutrum  ; -- A-lag..nn.1
  A_lagare_1_N = mkN "A-lagare" utrum  ; -- A-lagare..nn.1
  A_människa_1_N = mkN "A-människa" ; -- A-människa..nn.1
  A_vitamin_1_N = mkN "A-vitamin" "A-vitaminet" "A-vitaminer" "A-vitaminerna" ; -- A-vitamin..nn.1
  A_vitaminbrist_1_N = mkN "A-vitaminbrist" ; -- A-vitaminbrist..nn.1
  ABS_broms_1_N = mkN "ABS-broms" ; -- ABS-broms..nn.1
  ADHD_symtom_1_N = mkN "ADHD-symtom" neutrum  ; -- ADHD-symtom..nn.1
  AT_läkare_1_N = mkN "AT-läkare" utrum  ; -- AT-läkare..nn.1
  AV_block_1_N = mkN "AV-block" neutrum  ; -- AV-block..nn.1
  Administrator_1_N = mkN "Administrator" "Administratorer" ; -- Administrator..nn.1
  Afghanistaninsats_1_N = mkN "Afghanistaninsats" ; -- Afghanistaninsats..nn.1
  Afghanistantrupp_1_N = mkN "Afghanistantrupp" "Afghanistantrupper" ; -- Afghanistantrupp..nn.1
  Afrikatrad_1_N = mkN "Afrikatrad" "Afrikatrader" ; -- Afrikatrad..nn.1
  Alexanderhugg_1_N = mkN "Alexanderhugg" neutrum  ; -- Alexanderhugg..nn.1
  Alfapet_1_N = mkN "Alfapet" neutrum  ; -- Alfapet..nn.1
  Almedalental_1_N = mkN "Almedalental" neutrum  ; -- Almedalental..nn.1
  Almedalstal_1_N = mkN "Almedalstal" neutrum  ; -- Almedalstal..nn.1
  Almedalsvecka_1_N = mkN "Almedalsvecka" ; -- Almedalsvecka..nn.1
  Android_1_N = mkN "Android" "Androider" ; -- Android..nn.1
  Androidlur_1_N = mkN "Androidlur" ; -- Androidlur..nn.1
  Androidmobil_1_N = mkN "Androidmobil" "Androidmobiler" ; -- Androidmobil..nn.1
  Antarktisfördrag_1_N = mkN "Antarktisfördrag" neutrum  ; -- Antarktisfördrag..nn.1
  Antarktisprojekt_1_N = mkN "Antarktisprojekt" neutrum  ; -- Antarktisprojekt..nn.1
  Apolloprogram_1_N = mkN "Apolloprogram" "Apolloprogrammet" "Apolloprogram" "Apolloprogrammen" ; -- Apolloprogram..nn.1
  Arianeraket_1_N = mkN "Arianeraket" "Arianeraketer" ; -- Arianeraket..nn.1
  Asien_rundresa_1_N = mkN "Asien-rundresa" ; -- Asien-rundresa..nn.1
  B_lag_1_N = mkN "B-lag" neutrum  ; -- B-lag..nn.1
  B_människa_1_N = mkN "B-människa" ; -- B-människa..nn.1
  B_vitamin_1_N = mkN "B-vitamin" "B-vitaminet" "B-vitaminer" "B-vitaminerna" ; -- B-vitamin..nn.1
  B_vitaminbrist_1_N = mkN "B-vitaminbrist" "B-vitaminbrister" ; -- B-vitaminbrist..nn.1
  BLARK_1_N = mkN "BLARK" ; -- BLARK..nn.1
  BNP_tillväxt_1_N = mkN "BNP-tillväxt" ; -- BNP-tillväxt..nn.1
  Bachfuga_1_N = mkN "Bachfuga" ; -- Bachfuga..nn.1
  Ballograf_1_N = mkN "Ballograf" "Ballografer" ; -- Ballograf..nn.1
  Banverk_1_N = mkN "Banverk" neutrum  ; -- Banverk..nn.1
  Banverkspersonal_1_N = mkN "Banverkspersonal" ; -- Banverkspersonal..nn.1
  Bayeuxtapet_1_N = mkN "Bayeuxtapet" ; -- Bayeuxtapet..nn.1
  Beethovensonat_1_N = mkN "Beethovensonat" "Beethovensonater" ; -- Beethovensonat..nn.1
  Berlinmur_1_N = mkN "Berlinmur" ; -- Berlinmur..nn.1
  Bondbrud_1_N = mkN "Bondbrud" ; -- Bondbrud..nn.1
  Bondfilm_1_N = mkN "Bondfilm" "Bondfilmer" ; -- Bondfilm..nn.1
  Bonnierkoncern_1_N = mkN "Bonnierkoncern" ; -- Bonnierkoncern..nn.1
  Bristoltrakt_1_N = mkN "Bristoltrakt" ; -- Bristoltrakt..nn.1
  Bromelia_1_N = mkN "Bromelia" ; -- Bromelia..nn.1
  Brommamamma_1_N = mkN "Brommamamma" ; -- Brommamamma..nn.1
  C_dur_1_N = mkN "C-dur" ; -- C-dur..nn.1
  C_durskala_1_N = mkN "C-durskala" ; -- C-durskala..nn.1
  C_vitamin_1_N = mkN "C-vitamin" "C-vitaminet" "C-vitaminer" "C-vitaminerna" ; -- C-vitamin..nn.1
  C_vitaminbrist_1_N = mkN "C-vitaminbrist" ; -- C-vitaminbrist..nn.1
  C14_metod_1_N = mkN "C14-metod" ; -- C14-metod..nn.1
  CD_spelare_1_N = mkN "CD-spelare" utrum  ; -- CD-spelare..nn.1
  CP_skadad_1_A = mkA "CP-skadad" ; -- CP-skadad..av.1
  Calzone_1_N = mkN "Calzone" utrum  ; -- Calzone..nn.1
  Centauristjärna_1_N = mkN "Centauristjärna" ; -- Centauristjärna..nn.1
  Chicago_baserad_1_A = mkA "Chicago-baserad" ; -- Chicago-baserad..av.1
  Chicagobaserad_1_A = mkA "Chicagobaserad" ; -- Chicagobaserad..av.1
  Citroen_1_N = mkN "Citroen" "Citroener" ; -- Citroen..nn.1
  Cointreau_1_N = mkN "Cointreau" ; -- Cointreau..nn.1
  Cp_skadad_1_A = mkA "Cp-skadad" ; -- Cp-skadad..av.1
  D_vitamin_1_N = mkN "D-vitamin" "D-vitaminet" "D-vitaminer" "D-vitaminerna" ; -- D-vitamin..nn.1
  D_vitaminbrist_1_N = mkN "D-vitaminbrist" ; -- D-vitaminbrist..nn.1
  DNA_kedja_1_N = mkN "DNA-kedja" ; -- DNA-kedja..nn.1
  DNA_molekyl_1_N = mkN "DNA-molekyl" "DNA-molekyler" ; -- DNA-molekyl..nn.1
  DNA_profil_1_N = mkN "DNA-profil" "DNA-profiler" ; -- DNA-profil..nn.1
  DNA_sekvens_1_N = mkN "DNA-sekvens" "DNA-sekvenser" ; -- DNA-sekvens..nn.1
  DNA_sekvensering_1_N = mkN "DNA-sekvensering" ; -- DNA-sekvensering..nn.1
  DNA_sträng_1_N = mkN "DNA-sträng" ; -- DNA-sträng..nn.1
  DNA_test_1_N = mkN "DNA-test" neutrum  ; -- DNA-test..nn.1
  DNA_testa_1_V = mkV "DNA-testar" ; -- DNA-testa..vb.1
  DNA_testande_1_N = mkN "DNA-testande" ; -- DNA-testande..nn.1
  DNA_testning_1_N = mkN "DNA-testning" ; -- DNA-testning..nn.1
  DNA_uppsättning_1_N = mkN "DNA-uppsättning" ; -- DNA-uppsättning..nn.1
  DVD_film_1_N = mkN "DVD-film" "DVD-filmer" ; -- DVD-film..nn.1
  DVD_spelare_1_N = mkN "DVD-spelare" utrum  ; -- DVD-spelare..nn.1
  Delftporslin_1_N = mkN "Delftporslin" "Delftporslinet" "Delftporsliner" "Delftporslinerna" ; -- Delftporslin..nn.1
  DraMaten_1_N = mkN "DraMaten" ; -- DraMaten..nn.1
  Dramaten_1_N = mkN "Dramaten" ; -- Dramaten..nn.1
  Dramatenchef_1_N = mkN "Dramatenchef" "Dramatenchefer" ; -- Dramatenchef..nn.1
  Dubaifrossa_1_N = mkN "Dubaifrossa" ; -- Dubaifrossa..nn.1
  E_godkänd_1_A = mkA "E-godkänd" ; -- E-godkänd..av.1
  EHEC_smitta_1_N = mkN "EHEC-smitta" ; -- EHEC-smitta..nn.1
  EHEC_1_N = mkN "EHEC" ; -- EHEC..nn.1
  EU_intern_1_A = mkA "EU-intern" ; -- EU-intern..av.1
  EU_kommission_1_N = mkN "EU-kommission" ; -- EU-kommission..nn.1
  EU_korrespondent_1_N = mkN "EU-korrespondent" "EU-korrespondenter" ; -- EU-korrespondent..nn.1
  EU_land_1_N = mkN "EU-land" "EU-landet" "EU-länder" "EU-länderna" ; -- EU-land..nn.1
  EU_migrant_1_N = mkN "EU-migrant" "EU-migranter" ; -- EU-migrant..nn.1
  EU_minister_1_N = mkN "EU-minister" ; -- EU-minister..nn.1
  EU_parlament_1_N = mkN "EU-parlament" neutrum  ; -- EU-parlament..nn.1
  EU_parlamentariker_1_N = mkN "EU-parlamentariker" "EU-parlamentarikern" "EU-parlamentariker" "EU-parlamentarikerna" ; -- EU-parlamentariker..nn.1
  EU_skeptisk_1_A = mkA "EU-skeptisk" ; -- EU-skeptisk..av.1
  EU_utvidgning_1_N = mkN "EU-utvidgning" ; -- EU-utvidgning..nn.1
  EU_val_1_N = mkN "EU-val" neutrum  ; -- EU-val..nn.1
  Efta_land_1_N = mkN "Efta-land" "Efta-landet" "Efta-länder" "Efta-länderna" ; -- Efta-land..nn.1
  Eisenhowerepok_1_N = mkN "Eisenhowerepok" ; -- Eisenhowerepok..nn.1
  Europaparlament_1_N = mkN "Europaparlament" neutrum  ; -- Europaparlament..nn.1
  Europaråd_1_N = mkN "Europaråd" neutrum  ; -- Europaråd..nn.1
  Europarådsparlament_1_N = mkN "Europarådsparlament" neutrum  ; -- Europarådsparlament..nn.1
  Europarådsparlamentariker_1_N = mkN "Europarådsparlamentariker" "Europarådsparlamentarikern" "Europarådsparlamentariker" "Europarådsparlamentarikerna" ; -- Europarådsparlamentariker..nn.1
  Europaunion_1_N = mkN "Europaunion" ; -- Europaunion..nn.1
  FN_organ_1_N = mkN "FN-organ" neutrum  ; -- FN-organ..nn.1
  FN_tribunal_1_N = mkN "FN-tribunal" "FN-tribunaler" ; -- FN-tribunal..nn.1
  Facebookbild_1_N = mkN "Facebookbild" "Facebookbilder" ; -- Facebookbild..nn.1
  Facebookgrupp_1_N = mkN "Facebookgrupp" "Facebookgrupper" ; -- Facebookgrupp..nn.1
  Falubo_1_N = mkN "Falubo" "Falubor" ; -- Falubo..nn.1
  Fia_1_N = mkN "Fia" ; -- Fia..nn.1
  Finans_1_N = mkN "Finans" ; -- Finans..nn.1
  Fisk_1_N = mkN "Fisk" ; -- Fisk..nn.1
  Foppatoffel_1_N = mkN "Foppatoffla" ; -- Foppatoffel..nn.1
  Frankenstein_1_N = mkN "Frankenstein" ; -- Frankenstein..nn.1
  Frimurareorden_1_N = mkN "Frimurareorden" ; -- Frimurareorden..nn.1
  Frimurarorden_1_N = mkN "Frimurarorden" ; -- Frimurarorden..nn.1
  G_kraft_1_N = mkN "G-kraft" "G-krafter" ; -- G-kraft..nn.1
  G_punkt_1_N = mkN "G-punkt" "G-punkter" ; -- G-punkt..nn.1
  GPS_a_1_V = mkV "GPS-ar" ; -- GPS-a..vb.1
  GPSa_1_V = mkV "GPSar" ; -- GPSa..vb.1
  GPSa_2_V = mkV "GPS:ar" ; -- GPSa..vb.2
  Gadaffitrogen_1_A = mkA "Gadaffitrogen" ; -- Gadaffitrogen..av.1
  Gnosjöanda_1_N = mkN "Gnosjöanda" ; -- Gnosjöanda..nn.1
  Golgatavandring_1_N = mkN "Golgatavandring" ; -- Golgatavandring..nn.1
  Gotlandsfärja_1_N = mkN "Gotlandsfärja" ; -- Gotlandsfärja..nn.1
  Greenwichmeridian_1_N = mkN "Greenwichmeridian" ; -- Greenwichmeridian..nn.1
  Gripenplan_1_N = mkN "Gripenplan" neutrum  ; -- Gripenplan..nn.1
  Gävlebo_1_N = mkN "Gävlebo" "Gävlebor" ; -- Gävlebo..nn.1
  Göteborgsmålare_1_N = mkN "Göteborgsmålare" utrum  ; -- Göteborgsmålare..nn.1
  Hagasessa_1_N = mkN "Hagasessa" ; -- Hagasessa..nn.1
  Hausdorffdimension_1_N = mkN "Hausdorffdimension" ; -- Hausdorffdimension..nn.1
  Havanna_1_N = mkN "Havanna" ; -- Havanna..nn.1
  Havannacigarr_1_N = mkN "Havannacigarr" "Havannacigarrer" ; -- Havannacigarr..nn.1
  Helsingforsvän_1_N = mkN "Helsingforsvän" "Helsingforsvännen" "Helsingforsvänner" "Helsingforsvännerna" ; -- Helsingforsvän..nn.1
  Higgsboson_1_N = mkN "Higgsboson" "Higgsbosoner" ; -- Higgsboson..nn.1
  Higgspartikel_1_N = mkN "Higgspartikel" ; -- Higgspartikel..nn.1
  Hiroshimabomb_1_N = mkN "Hiroshimabomb" "Hiroshimabomber" ; -- Hiroshimabomb..nn.1
  Hitchcockfilm_1_N = mkN "Hitchcockfilm" "Hitchcockfilmer" ; -- Hitchcockfilm..nn.1
  Hollywoodfru_1_N = mkN "Hollywoodfru" ; -- Hollywoodfru..nn.1
  Hultsfredsfestival_1_N = mkN "Hultsfredsfestival" ; -- Hultsfredsfestival..nn.1
  Hårgalåt_1_N = mkN "Hårgalåt" ; -- Hårgalåt..nn.1
  I_land_1_N = mkN "I-land" "I-landet" "I-länder" "I-länderna" ; -- I-land..nn.1
  IB_avslöjande_1_N = mkN "IB-avslöjande" ; -- IB-avslöjande..nn.1
  IC_krets_1_N = mkN "IC-krets" ; -- IC-krets..nn.1
  ID_bricka_1_N = mkN "ID-bricka" ; -- ID-bricka..nn.1
  ID_kort_1_N = mkN "ID-kort" neutrum  ; -- ID-kort..nn.1
  IKEA_möbel_1_N = mkN "IKEA-möbel" "IKEA-möbeln" "IKEA-möbler" "IKEA-möblerna" ; -- IKEA-möbel..nn.1
  IP_nummer_1_N = mkN "IP-nummer" neutrum  ; -- IP-nummer..nn.1
  IT_företag_1_N = mkN "IT-företag" neutrum  ; -- IT-företag..nn.1
  IT_jätte_1_N = mkN "IT-jätte" utrum  ; -- IT-jätte..nn.1
  Ikeavaruhus_1_N = mkN "Ikeavaruhus" neutrum  ; -- Ikeavaruhus..nn.1
  Internet_1_N = mkN "Internet" ; -- Internet..nn.1
  Jacksoninspirerad_1_A = mkA "Jacksoninspirerad" ; -- Jacksoninspirerad..av.1
  Jantelag_1_N = mkN "Jantelag" ; -- Jantelag..nn.1
  Japanoro_1_N = mkN "Japanoro" ; -- Japanoro..nn.1
  Jungfru_1_N = mkN "Jungfru" "Jungfrun" "Jungfrur" "Jungfrurna" ; -- Jungfru..nn.1
  Jupitermåne_1_N = mkN "Jupitermåne" utrum  ; -- Jupitermåne..nn.1
  K_märka_1_V = mkV "K-märker" ; -- K-märka..vb.1
  K_märkande_1_N = mkN "K-märkande" ; -- K-märkande..nn.1
  KU_anmäla_1_V = mkV "KU-anmäler" ; -- KU-anmäla..vb.1
  Kafkaartad_1_A = mkA "Kafkaartad" ; -- Kafkaartad..av.1
  Kafkaesk_1_A = mkA "Kafkaesk" ; -- Kafkaesk..av.1
  Kafkalik_1_A = mkA "Kafkalik" ; -- Kafkalik..av.1
  Kafkastämning_1_N = mkN "Kafkastämning" ; -- Kafkastämning..nn.1
  Kairobesök_1_N = mkN "Kairobesök" neutrum  ; -- Kairobesök..nn.1
  Kalmarbo_1_N = mkN "Kalmarbo" "Kalmarbor" ; -- Kalmarbo..nn.1
  Karlstadsbo_1_N = mkN "Karlstadsbo" "Karlstadsbor" ; -- Karlstadsbo..nn.1
  Katynmassaker_1_N = mkN "Katynmassaker" "Katynmassakern" "Katynmassakrer" "Katynmassakrerna" ; -- Katynmassaker..nn.1
  Kevlar_1_N = mkN "Kevlar" ; -- Kevlar..nn.1
  Kinabesök_1_N = mkN "Kinabesök" neutrum  ; -- Kinabesök..nn.1
  Kirunatrakt_1_N = mkN "Kirunatrakt" ; -- Kirunatrakt..nn.1
  Kleopatragestalt_1_N = mkN "Kleopatragestalt" ; -- Kleopatragestalt..nn.1
  Koranbränning_1_N = mkN "Koranbränning" ; -- Koranbränning..nn.1
  Koranbål_1_N = mkN "Koranbål" neutrum  ; -- Koranbål..nn.1
  Koreakrig_1_N = mkN "Koreakrig" neutrum  ; -- Koreakrig..nn.1
  Kramforstrakt_1_N = mkN "Kramforstrakt" ; -- Kramforstrakt..nn.1
  Kremldirektiv_1_N = mkN "Kremldirektiv" neutrum  ; -- Kremldirektiv..nn.1
  Krimkrig_1_N = mkN "Krimkrig" neutrum  ; -- Krimkrig..nn.1
  Kräfta_2_N = mkN "Kräfta" ; -- Kräfta..nn.2
  Kubakris_1_N = mkN "Kubakris" "Kubakriser" ; -- Kubakris..nn.1
  Köchelnummer_1_N = mkN "Köchelnummer" neutrum  ; -- Köchelnummer..nn.1
  Köpenhamnsackord_1_N = mkN "Köpenhamnsackord" neutrum  ; -- Köpenhamnsackord..nn.1
  LCD_skärm_1_N = mkN "LCD-skärm" ; -- LCD-skärm..nn.1
  LCD_teve_1_N = mkN "LCD-teve" "LCD-teven" "LCD-tevear" "LCD-tevearna" ; -- LCD-teve..nn.1
  LED_belysning_1_N = mkN "LED-belysning" ; -- LED-belysning..nn.1
  LED_lampa_1_N = mkN "LED-lampa" ; -- LED-lampa..nn.1
  LKAB_konflikt_1_N = mkN "LKAB-konflikt" ; -- LKAB-konflikt..nn.1
  LO_chef_1_N = mkN "LO-chef" "LO-chefer" ; -- LO-chef..nn.1
  LO_ordförande_1_N = mkN "LO-ordförande" "LO-ordföranden" "LO-ordföranden" "LO-ordförandena" ; -- LO-ordförande..nn.1
  Lejon_1_N = mkN "Lejon" neutrum  ; -- Lejon..nn.1
  Linköpingsbo_1_N = mkN "Linköpingsbo" "Linköpingsbor" ; -- Linköpingsbo..nn.1
  Linnélärjunge_1_N = mkN "Linnélärjunge" utrum  ; -- Linnélärjunge..nn.1
  Lissabonfördrag_1_N = mkN "Lissabonfördrag" neutrum  ; -- Lissabonfördrag..nn.1
  Livsmedelsverk_1_N = mkN "Livsmedelsverk" neutrum  ; -- Livsmedelsverk..nn.1
  Ljubjankafängelse_1_N = mkN "Ljubjankafängelse" ; -- Ljubjankafängelse..nn.1
  Londonbaserad_1_A = mkA "Londonbaserad" ; -- Londonbaserad..av.1
  Lulebo_1_N = mkN "Lulebo" "Lulebor" ; -- Lulebo..nn.1
  Luleåbo_1_N = mkN "Luleåbo" "Luleåbor" ; -- Luleåbo..nn.1
  MAO_aktivitet_1_N = mkN "MAO-aktivitet" "MAO-aktiviteter" ; -- MAO-aktivitet..nn.1
  MAO_enzym_1_N = mkN "MAO-enzym" neutrum  ; -- MAO-enzym..nn.1
  MEFA_1_N = mkN "MEFA" "MEFAn" "MEFor" "MEForna" ; -- MEFA..nn.1
  MP3_bok_1_N = mkN "MP3-bok" "MP3-böcker" ; -- MP3-bok..nn.1
  MP3_spelare_1_N = mkN "MP3-spelare" utrum  ; -- MP3-spelare..nn.1
  Malmöbo_1_N = mkN "Malmöbo" "Malmöbor" ; -- Malmöbo..nn.1
  Malmökafé_1_N = mkN "Malmökafé" "Malmökaféet" "Malmökaféer" "Malmökaféerna" ; -- Malmökafé..nn.1
  Marseillebaserad_1_A = mkA "Marseillebaserad" ; -- Marseillebaserad..av.1
  Marsresa_1_N = mkN "Marsresa" ; -- Marsresa..nn.1
  Marylandaccent_1_N = mkN "Marylandaccent" "Marylandaccenter" ; -- Marylandaccent..nn.1
  Mecka_1_N = mkN "Mecka" "Meckat" "Meckan" "Meckana" ; -- Mecka..nn.1
  Medelhavsinspirerad_1_A = mkA "Medelhavsinspirerad" ; -- Medelhavsinspirerad..av.1
  Medelhavsland_1_N = mkN "Medelhavsland" "Medelhavslandet" "Medelhavsländer" "Medelhavsländerna" ; -- Medelhavsland..nn.1
  Medelshavskultur_1_N = mkN "Medelshavskultur" "Medelshavskulturer" ; -- Medelshavskultur..nn.1
  Mellanösternkonflikt_1_N = mkN "Mellanösternkonflikt" ; -- Mellanösternkonflikt..nn.1
  Mello_1_N = mkN "Mello" ; -- Mello..nn.1
  Melodifestival_1_N = mkN "Melodifestival" ; -- Melodifestival..nn.1
  Merca_1_N = mkN "Merca" ; -- Merca..nn.1
  Mercedes_1_N = mkN "Mercedes" ; -- Mercedes..nn.1
  Mersa_1_N = mkN "Mersa" ; -- Mersa..nn.1
  Metallordförande_1_N = mkN "Metallordförande" "Metallordföranden" "Metallordföranden" "Metallordförandena" ; -- Metallordförande..nn.1
  Migrationsverk_1_N = mkN "Migrationsverk" neutrum  ; -- Migrationsverk..nn.1
  Miljöförvaltning_1_N = mkN "Miljöförvaltning" ; -- Miljöförvaltning..nn.1
  Mississippiflod_1_N = mkN "Mississippiflod" ; -- Mississippiflod..nn.1
  Missouriflod_1_N = mkN "Missouriflod" ; -- Missouriflod..nn.1
  Monopol_1_N = mkN "Monopol" neutrum  ; -- Monopol..nn.1
  Montessoriskola_1_N = mkN "Montessoriskola" ; -- Montessoriskola..nn.1
  Mosebok_1_N = mkN "Mosebok" "Moseböcker" ; -- Mosebok..nn.1
  Moskvaborgmästare_1_N = mkN "Moskvaborgmästare" utrum  ; -- Moskvaborgmästare..nn.1
  Moskvatrogen_1_A = mkA "Moskvatrogen" ; -- Moskvatrogen..av.1
  Moskvatrogenhet_1_N = mkN "Moskvatrogenhet" ; -- Moskvatrogenhet..nn.1
  Moskvavänlig_1_A = mkA "Moskvavänlig" ; -- Moskvavänlig..av.1
  Moskvavänlighet_1_N = mkN "Moskvavänlighet" ; -- Moskvavänlighet..nn.1
  Moskvich_1_N = mkN "Moskvich" ; -- Moskvich..nn.1
  Moskvitj_1_N = mkN "Moskvitj" ; -- Moskvitj..nn.1
  Muhammedkarikatyr_1_N = mkN "Muhammedkarikatyr" "Muhammedkarikatyrer" ; -- Muhammedkarikatyr..nn.1
  Munchlitografi_1_N = mkN "Munchlitografi" "Munchlitografier" ; -- Munchlitografi..nn.1
  Mångfaldsbarometer_1_N = mkN "Mångfaldsbarometer" ; -- Mångfaldsbarometer..nn.1
  NSA_läcka_1_N = mkN "NSA-läcka" ; -- NSA-läcka..nn.1
  Nationalencyklopedi_1_N = mkN "Nationalencyklopedi" ; -- Nationalencyklopedi..nn.1
  Natohelikopter_1_N = mkN "Natohelikopter" ; -- Natohelikopter..nn.1
  Natoledd_1_A = mkA "Natoledd" ; -- Natoledd..av.1
  Natomedlemskap_1_N = mkN "Natomedlemskap" neutrum  ; -- Natomedlemskap..nn.1
  Natosoldat_1_N = mkN "Natosoldat" "Natosoldater" ; -- Natosoldat..nn.1
  Natotrupp_1_N = mkN "Natotrupp" "Natotrupper" ; -- Natotrupp..nn.1
  Naturvårdsverk_1_N = mkN "Naturvårdsverk" neutrum  ; -- Naturvårdsverk..nn.1
  Newcastlesjuka_1_N = mkN "Newcastlesjuka" ; -- Newcastlesjuka..nn.1
  Newcastlesmitta_1_N = mkN "Newcastlesmitta" ; -- Newcastlesmitta..nn.1
  Nobelpriskandidat_1_N = mkN "Nobelpriskandidat" "Nobelpriskandidater" ; -- Nobelpriskandidat..nn.1
  Nordpolsexpedition_1_N = mkN "Nordpolsexpedition" ; -- Nordpolsexpedition..nn.1
  Norrmalmstorgssyndrom_1_N = mkN "Norrmalmstorgssyndrom" neutrum  ; -- Norrmalmstorgssyndrom..nn.1
  OCR_a_1_V = mkV "OCR-ar" ; -- OCR-a..vb.1
  OCR_ande_1_N = mkN "OCR-ande" ; -- OCR-ande..nn.1
  OCRa_1_V = mkV "OCR:ar" ; -- OCRa..vb.1
  OCRande_1_N = mkN "OCR:ande" ; -- OCRande..nn.1
  OECD_land_1_N = mkN "OECD-land" "OECD-landet" "OECD-länder" "OECD-länderna" ; -- OECD-land..nn.1
  OK_1_A = mkA "OK" ; -- OK..av.1
  Oscarsbelönad_1_A = mkA "Oscarsbelönad" ; -- Oscarsbelönad..av.1
  Oscarsnominerad_1_A = mkA "Oscarsnominerad" ; -- Oscarsnominerad..av.1
  Osloavtal_1_N = mkN "Osloavtal" neutrum  ; -- Osloavtal..nn.1
  Othello_1_N = mkN "Othello" ; -- Othello..nn.1
  Oxe_1_N = mkN "Oxe" utrum  ; -- Oxe..nn.1
  Oxfordkommatering_1_N = mkN "Oxfordkommatering" ; -- Oxfordkommatering..nn.1
  Oxfordstudent_1_N = mkN "Oxfordstudent" "Oxfordstudenter" ; -- Oxfordstudent..nn.1
  PCB_förbud_1_N = mkN "PCB-förbud" neutrum  ; -- PCB-förbud..nn.1
  PCB_förening_1_N = mkN "PCB-förening" ; -- PCB-förening..nn.1
  PCB_förgiftning_1_N = mkN "PCB-förgiftning" ; -- PCB-förgiftning..nn.1
  PCB_halt_1_N = mkN "PCB-halt" "PCB-halter" ; -- PCB-halt..nn.1
  PCB_olja_1_N = mkN "PCB-olja" ; -- PCB-olja..nn.1
  PIN_kod_1_N = mkN "PIN-kod" "PIN-koder" ; -- PIN-kod..nn.1
  PR_kupp_1_N = mkN "PR-kupp" "PR-kupper" ; -- PR-kupp..nn.1
  PR_man_1_N = mkN "PR-man" "PR-mannen" "PR-män" "PR-männen" ; -- PR-man..nn.1
  PRkupp_1_N = mkN "PRkupp" "PRkupper" ; -- PRkupp..nn.1
  PVC_beläggning_1_N = mkN "PVC-beläggning" ; -- PVC-beläggning..nn.1
  Palestinafråga_1_N = mkN "Palestinafråga" ; -- Palestinafråga..nn.1
  Palmehat_1_N = mkN "Palmehat" neutrum  ; -- Palmehat..nn.1
  Papyrusaktie_1_N = mkN "Papyrusaktie" "Papyrusaktier" ; -- Papyrusaktie..nn.1
  Parisflygplats_1_N = mkN "Parisflygplats" "Parisflygplatser" ; -- Parisflygplats..nn.1
  Patentverk_1_N = mkN "Patentverk" neutrum  ; -- Patentverk..nn.1
  Pippiinspirerad_1_A = mkA "Pippiinspirerad" ; -- Pippiinspirerad..av.1
  PowerPoint_1_N = mkN "PowerPoint" ; -- PowerPoint..nn.1
  Powerpoint_1_N = mkN "Powerpoint" ; -- Powerpoint..nn.1
  QR_kod_1_N = mkN "QR-kod" "QR-koder" ; -- QR-kod..nn.1
  ROT_avdrag_1_N = mkN "ROT-avdrag" neutrum  ; -- ROT-avdrag..nn.1
  RUT_avdrag_1_N = mkN "RUT-avdrag" neutrum  ; -- RUT-avdrag..nn.1
  Rembrandt_1_N = mkN "Rembrandt" "Rembrandter" ; -- Rembrandt..nn.1
  Rikspolisstyrelse_1_N = mkN "Rikspolisstyrelse" utrum  ; -- Rikspolisstyrelse..nn.1
  Rioja_1_N = mkN "Rioja" ; -- Rioja..nn.1
  Risk_1_N = mkN "Risk" ; -- Risk..nn.1
  Rolls_1_N = mkN "Rolls" ; -- Rolls..nn.1
  Romeo_och_Julia_strategi_1_N = mkN "Romeo-och-Julia-strategi" "Romeo-och-Julia-strategier" ; -- Romeo-och-Julia-strategi..nn.1
  SAP_program_1_N = mkN "SAP-program" "SAP-programmet" "SAP-program" "SAP-programmen" ; -- SAP-program..nn.1
  SAS_chef_1_N = mkN "SAS-chef" "SAS-chefer" ; -- SAS-chef..nn.1
  SAS_flygvärdinna_1_N = mkN "SAS-flygvärdinna" ; -- SAS-flygvärdinna..nn.1
  SCOPE_rapport_1_N = mkN "SCOPE-rapport" "SCOPE-rapporter" ; -- SCOPE-rapport..nn.1
  SIFO_undersökning_1_N = mkN "SIFO-undersökning" ; -- SIFO-undersökning..nn.1
  SIM_kort_1_N = mkN "SIM-kort" neutrum  ; -- SIM-kort..nn.1
  SMSa_1_V = mkV "SMS:ar" ; -- SMSa..vb.1
  Saab_1_N = mkN "Saab" ; -- Saab..nn.1
  Salazar_regim_1_N = mkN "Salazar-regim" "Salazar-regimer" ; -- Salazar-regim..nn.1
  Shakespearedrama_1_N = mkN "Shakespearedrama" "Shakespearedramat" "Shakespearedramer" "Shakespearedramerna" ; -- Shakespearedrama..nn.1
  Sheratonstil_1_N = mkN "Sheratonstil" ; -- Sheratonstil..nn.1
  Sifoundersökning_1_N = mkN "Sifoundersökning" ; -- Sifoundersökning..nn.1
  Sir_1_N = mkN "Sir" ; -- Sir..nn.1
  Sjöfartsverk_1_N = mkN "Sjöfartsverk" neutrum  ; -- Sjöfartsverk..nn.1
  Skagenmålare_1_N = mkN "Skagenmålare" utrum  ; -- Skagenmålare..nn.1
  Skolinspektion_1_N = mkN "Skolinspektion" ; -- Skolinspektion..nn.1
  Skolverk_1_N = mkN "Skolverk" neutrum  ; -- Skolverk..nn.1
  Skorpion_1_N = mkN "Skorpion" ; -- Skorpion..nn.1
  Skytt_1_N = mkN "Skytt" ; -- Skytt..nn.1
  Sokratesdialog_1_N = mkN "Sokratesdialog" "Sokratesdialoger" ; -- Sokratesdialog..nn.1
  Sovjetsystem_1_N = mkN "Sovjetsystem" neutrum  ; -- Sovjetsystem..nn.1
  Stadsbyggnadskontor_1_N = mkN "Stadsbyggnadskontor" neutrum  ; -- Stadsbyggnadskontor..nn.1
  Stasiagent_1_N = mkN "Stasiagent" "Stasiagenter" ; -- Stasiagent..nn.1
  Stasianställd_1_A = mkA "Stasianställd" "Stasianställt" ; -- Stasianställd..av.1
  Statoilmack_1_N = mkN "Statoilmack" ; -- Statoilmack..nn.1
  Statskontor_1_N = mkN "Statskontor" neutrum  ; -- Statskontor..nn.1
  Stenbock_1_N = mkN "Stenbock" ; -- Stenbock..nn.1
  Stillahavsfiske_1_N = mkN "Stillahavsfiske" ; -- Stillahavsfiske..nn.1
  Stillahavsskvadron_1_N = mkN "Stillahavsskvadron" "Stillahavsskvadroner" ; -- Stillahavsskvadron..nn.1
  Stockholmsarena_1_N = mkN "Stockholmsarena" ; -- Stockholmsarena..nn.1
  Stockholmsbörs_1_N = mkN "Stockholmsbörs" ; -- Stockholmsbörs..nn.1
  Stockholmsfotograf_1_N = mkN "Stockholmsfotograf" "Stockholmsfotografer" ; -- Stockholmsfotograf..nn.1
  Stockholmsguide_1_N = mkN "Stockholmsguide" "Stockholmsguider" ; -- Stockholmsguide..nn.1
  Stockholmshelg_1_N = mkN "Stockholmshelg" "Stockholmshelger" ; -- Stockholmshelg..nn.1
  Stockholmsmässig_1_A = mkA "Stockholmsmässig" ; -- Stockholmsmässig..av.1
  Stockholmsområde_1_N = mkN "Stockholmsområde" ; -- Stockholmsområde..nn.1
  Stockholmsregion_1_N = mkN "Stockholmsregion" ; -- Stockholmsregion..nn.1
  Stockholmssyndrom_1_N = mkN "Stockholmssyndrom" neutrum  ; -- Stockholmssyndrom..nn.1
  Stockholmstrakt_1_N = mkN "Stockholmstrakt" ; -- Stockholmstrakt..nn.1
  Strindbergsutgåva_1_N = mkN "Strindbergsutgåva" ; -- Strindbergsutgåva..nn.1
  Strålsäkerhetsmyndighet_1_N = mkN "Strålsäkerhetsmyndighet" ; -- Strålsäkerhetsmyndighet..nn.1
  Sturemord_1_N = mkN "Sturemord" neutrum  ; -- Sturemord..nn.1
  Stureplansmördare_1_N = mkN "Stureplansmördare" utrum  ; -- Stureplansmördare..nn.1
  Stureplansprofil_1_N = mkN "Stureplansprofil" "Stureplansprofiler" ; -- Stureplansprofil..nn.1
  Sundsvallsbo_1_N = mkN "Sundsvallsbo" "Sundsvallsbor" ; -- Sundsvallsbo..nn.1
  Svensson_1_N = mkN "Svensson" "Svenssöner" ; -- Svensson..nn.1
  Sverigedemokrat_1_N = mkN "Sverigedemokrat" "Sverigedemokrater" ; -- Sverigedemokrat..nn.1
  Sverigemästerskap_1_N = mkN "Sverigemästerskap" neutrum  ; -- Sverigemästerskap..nn.1
  Södermalmsbo_1_N = mkN "Södermalmsbo" "Södermalmsbor" ; -- Södermalmsbo..nn.1
  Södermalmvåning_1_N = mkN "Södermalmvåning" ; -- Södermalmvåning..nn.1
  T_shirt_1_N = mkN "T-shirt" ; -- T-shirt..nn.1
  T_sprit_1_N = mkN "T-sprit" ; -- T-sprit..nn.1
  T_tröja_1_N = mkN "T-tröja" ; -- T-tröja..nn.1
  TV_abonnemang_1_N = mkN "TV-abonnemang" neutrum  ; -- TV-abonnemang..nn.1
  TV_antenn_1_N = mkN "TV-antenn" "TV-antenner" ; -- TV-antenn..nn.1
  TV_apparat_1_N = mkN "TV-apparat" "TV-apparater" ; -- TV-apparat..nn.1
  TV_bild_1_N = mkN "TV-bild" "TV-bilder" ; -- TV-bild..nn.1
  TV_chef_1_N = mkN "TV-chef" "TV-chefer" ; -- TV-chef..nn.1
  TV_evangelist_1_N = mkN "TV-evangelist" "TV-evangelister" ; -- TV-evangelist..nn.1
  TV_intervju_1_N = mkN "TV-intervju" "TV-intervjun" "TV-intervjuer" "TV-intervjuerna" ; -- TV-intervju..nn.1
  TV_kamera_1_N = mkN "TV-kamera" ; -- TV-kamera..nn.1
  TV_kanal_1_N = mkN "TV-kanal" "TV-kanaler" ; -- TV-kanal..nn.1
  TV_konferens_1_N = mkN "TV-konferens" "TV-konferenser" ; -- TV-konferens..nn.1
  TV_leverantör_1_N = mkN "TV-leverantör" "TV-leverantörer" ; -- TV-leverantör..nn.1
  TV_mast_1_N = mkN "TV-mast" "TV-master" ; -- TV-mast..nn.1
  TV_meteorolog_1_N = mkN "TV-meteorolog" "TV-meteorologer" ; -- TV-meteorolog..nn.1
  TV_mottagare_1_N = mkN "TV-mottagare" utrum  ; -- TV-mottagare..nn.1
  TV_nyhet_1_N = mkN "TV-nyhet" "TV-nyheter" ; -- TV-nyhet..nn.1
  TV_predikant_1_N = mkN "TV-predikant" "TV-predikanter" ; -- TV-predikant..nn.1
  TV_producent_1_N = mkN "TV-producent" "TV-producenter" ; -- TV-producent..nn.1
  TV_profil_1_N = mkN "TV-profil" "TV-profiler" ; -- TV-profil..nn.1
  TV_program_1_N = mkN "TV-program" "TV-programmet" "TV-program" "TV-programmen" ; -- TV-program..nn.1
  TV_reklam_1_N = mkN "TV-reklam" ; -- TV-reklam..nn.1
  TV_reparatör_1_N = mkN "TV-reparatör" "TV-reparatörer" ; -- TV-reparatör..nn.1
  TV_ruta_1_N = mkN "TV-ruta" ; -- TV-ruta..nn.1
  TV_serie_1_N = mkN "TV-serie" "TV-serier" ; -- TV-serie..nn.1
  TV_signal_1_N = mkN "TV-signal" "TV-signaler" ; -- TV-signal..nn.1
  TV_skärm_1_N = mkN "TV-skärm" ; -- TV-skärm..nn.1
  TV_soffa_1_N = mkN "TV-soffa" ; -- TV-soffa..nn.1
  TV_studio_1_N = mkN "TV-studio" "TV-studior" ; -- TV-studio..nn.1
  TV_sändare_1_N = mkN "TV-sändare" utrum  ; -- TV-sändare..nn.1
  TV_sändning_1_N = mkN "TV-sändning" ; -- TV-sändning..nn.1
  TV_såpa_1_N = mkN "TV-såpa" ; -- TV-såpa..nn.1
  TV_tittande_1_N = mkN "TV-tittande" ; -- TV-tittande..nn.1
  TV_tittare_1_N = mkN "TV-tittare" utrum  ; -- TV-tittare..nn.1
  TV_övervakning_1_N = mkN "TV-övervakning" ; -- TV-övervakning..nn.1
  Tarzanfilm_1_N = mkN "Tarzanfilm" "Tarzanfilmer" ; -- Tarzanfilm..nn.1
  Telialand_1_N = mkN "Telialand" neutrum  ; -- Telialand..nn.1
  Teutoburgerslag_1_N = mkN "Teutoburgerslag" neutrum  ; -- Teutoburgerslag..nn.1
  Tjernobylnedfall_1_N = mkN "Tjernobylnedfall" neutrum  ; -- Tjernobylnedfall..nn.1
  Tjernobylolycka_1_N = mkN "Tjernobylolycka" ; -- Tjernobylolycka..nn.1
  Tokyobörs_1_N = mkN "Tokyobörs" ; -- Tokyobörs..nn.1
  Trafikkontor_1_N = mkN "Trafikkontor" neutrum  ; -- Trafikkontor..nn.1
  Trafiksäkerhetsverk_1_N = mkN "Trafiksäkerhetsverk" neutrum  ; -- Trafiksäkerhetsverk..nn.1
  Tvilling_1_N = mkN "Tvilling" ; -- Tvilling..nn.1
  Törnrosasömn_1_N = mkN "Törnrosasömn" ; -- Törnrosasömn..nn.1
  U_land_1_N = mkN "U-land" "U-landet" "U-länder" "U-länderna" ; -- U-land..nn.1
  U_sväng_1_N = mkN "U-sväng" ; -- U-sväng..nn.1
  USA_vänlig_1_A = mkA "USA-vänlig" ; -- USA-vänlig..av.1
  USA_vänlighet_1_N = mkN "USA-vänlighet" ; -- USA-vänlighet..nn.1
  USB_minne_1_N = mkN "USB-minne" ; -- USB-minne..nn.1
  USB_sladd_1_N = mkN "USB-sladd" ; -- USB-sladd..nn.1
  Uno_1_N = mkN "Uno" ; -- Uno..nn.1
  Uppsalabo_1_N = mkN "Uppsalabo" "Uppsalabor" ; -- Uppsalabo..nn.1
  VAB_dag_1_N = mkN "VAB-dag" ; -- VAB-dag..nn.1
  VAB_1_N = mkN "VAB" ; -- VAB..nn.1
  VABB_dag_1_N = mkN "VABB-dag" ; -- VABB-dag..nn.1
  VABB_1_N = mkN "VABB" ; -- VABB..nn.1
  VVS_armatur_1_N = mkN "VVS-armatur" "VVS-armaturer" ; -- VVS-armatur..nn.1
  Vadstenadiarium_1_N = mkN "Vadstenadiarium" "Vadstenadiariet" "Vadstenadiarier" "Vadstenadiarierna" ; -- Vadstenadiarium..nn.1
  Vattuman_1_N = mkN "Vattuman" "Vattumannen" "Vattumän" "Vattumännen" ; -- Vattuman..nn.1
  Vaxholmskonflikt_1_N = mkN "Vaxholmskonflikt" ; -- Vaxholmskonflikt..nn.1
  Vellingemoderat_1_N = mkN "Vellingemoderat" "Vellingemoderater" ; -- Vellingemoderat..nn.1
  Viagra_1_N = mkN "Viagra" ; -- Viagra..nn.1
  Vietnamkrig_1_N = mkN "Vietnamkrig" neutrum  ; -- Vietnamkrig..nn.1
  Vietnampolitik_1_N = mkN "Vietnampolitik" ; -- Vietnampolitik..nn.1
  Vietnamveteran_1_N = mkN "Vietnamveteran" "Vietnamveteraner" ; -- Vietnamveteran..nn.1
  Visa_kort_1_N = mkN "Visa-kort" neutrum  ; -- Visa-kort..nn.1
  Visakort_1_N = mkN "Visakort" neutrum  ; -- Visakort..nn.1
  Visbyvecka_1_N = mkN "Visbyvecka" ; -- Visbyvecka..nn.1
  Volkswagenbuss_1_N = mkN "Volkswagenbuss" ; -- Volkswagenbuss..nn.1
  Volvo_1_N = mkN "Volvo" ; -- Volvo..nn.1
  Volvoanställd_1_A = mkA "Volvoanställd" "Volvoanställt" ; -- Volvoanställd..av.1
  Vädur_1_N = mkN "Vädur" ; -- Vädur..nn.1
  Vägverk_1_N = mkN "Vägverk" neutrum  ; -- Vägverk..nn.1
  Världsbank_1_N = mkN "Världsbank" ; -- Världsbank..nn.1
  Världsnaturfond_1_N = mkN "Världsnaturfond" ; -- Världsnaturfond..nn.1
  Vätternrunda_1_N = mkN "Vätternrunda" ; -- Vätternrunda..nn.1
  Växjötrakt_1_N = mkN "Växjötrakt" ; -- Växjötrakt..nn.1
  Våg_1_N = mkN "Våg" "Vågor" ; -- Våg..nn.1
  X_formad_1_A = mkA "X-formad" ; -- X-formad..av.1
  X_formig_1_A = mkA "X-formig" ; -- X-formig..av.1
  X_kromosom_1_N = mkN "X-kromosom" "X-kromosomer" ; -- X-kromosom..nn.1
  Xformad_1_A = mkA "Xformad" ; -- Xformad..av.1
  Xformig_1_A = mkA "Xformig" ; -- Xformig..av.1
  Y_kromosom_1_N = mkN "Y-kromosom" "Y-kromosomer" ; -- Y-kromosom..nn.1
  Yalelås_1_N = mkN "Yalelås" neutrum  ; -- Yalelås..nn.1
  Yatzy_1_N = mkN "Yatzy" ; -- Yatzy..nn.1
  Z_partikel_1_N = mkN "Z-partikel" ; -- Z-partikel..nn.1
  Zlatan_groda_1_N = mkN "Zlatan-groda" ; -- Zlatan-groda..nn.1
  _00_tal_1_N = mkN "00-tal" neutrum  ; -- _00-tal..nn.1
  _1100_tal_1_N = mkN "1100-tal" neutrum  ; -- _1100-tal..nn.1
  _12_kanthylsa_1_N = mkN "12-kanthylsa" ; -- _12-kanthylsa..nn.1
  _12_kantshylsa_1_N = mkN "12-kantshylsa" ; -- _12-kantshylsa..nn.1
  _1200_tal_1_N = mkN "1200-tal" neutrum  ; -- _1200-tal..nn.1
  _1300_tal_1_N = mkN "1300-tal" neutrum  ; -- _1300-tal..nn.1
  _1400_tal_1_N = mkN "1400-tal" neutrum  ; -- _1400-tal..nn.1
  _15_årsstraff_1_N = mkN "15-årsstraff" neutrum  ; -- _15-årsstraff..nn.1
  _1500_tal_1_N = mkN "1500-tal" neutrum  ; -- _1500-tal..nn.1
  _1600_tal_1_N = mkN "1600-tal" neutrum  ; -- _1600-tal..nn.1
  _1700_tal_1_N = mkN "1700-tal" neutrum  ; -- _1700-tal..nn.1
  _1800_tal_1_N = mkN "1800-tal" neutrum  ; -- _1800-tal..nn.1
  _1800_talsmode_1_N = mkN "1800-talsmode" ; -- _1800-talsmode..nn.1
  _1870_tal_1_N = mkN "1870-tal" neutrum  ; -- _1870-tal..nn.1
  _1880_tal_1_N = mkN "1880-tal" neutrum  ; -- _1880-tal..nn.1
  _1890_tal_1_N = mkN "1890-tal" neutrum  ; -- _1890-tal..nn.1
  _1900_tal_1_N = mkN "1900-tal" neutrum  ; -- _1900-tal..nn.1
  _1910_tal_1_N = mkN "1910-tal" neutrum  ; -- _1910-tal..nn.1
  _1920_tal_1_N = mkN "1920-tal" neutrum  ; -- _1920-tal..nn.1
  _1930_tal_1_N = mkN "1930-tal" neutrum  ; -- _1930-tal..nn.1
  _1940_tal_1_N = mkN "1940-tal" neutrum  ; -- _1940-tal..nn.1
  _1950_tal_1_N = mkN "1950-tal" neutrum  ; -- _1950-tal..nn.1
  _1960_tal_1_N = mkN "1960-tal" neutrum  ; -- _1960-tal..nn.1
  _1970_tal_1_N = mkN "1970-tal" neutrum  ; -- _1970-tal..nn.1
  _1980_tal_1_N = mkN "1980-tal" neutrum  ; -- _1980-tal..nn.1
  _1990_tal_1_N = mkN "1990-tal" neutrum  ; -- _1990-tal..nn.1
  _2_taktsolja_1_N = mkN "2-taktsolja" ; -- _2-taktsolja..nn.1
  _20_tal_1_N = mkN "20-tal" neutrum  ; -- _20-tal..nn.1
  _2000_tal_1_N = mkN "2000-tal" neutrum  ; -- _2000-tal..nn.1
  _3_fasström_1_N = mkN "3-fasström" "3-fasströmmen" "3-fasströmmar" "3-fasströmmarna" ; -- _3-fasström..nn.1
  _30_tal_1_N = mkN "30-tal" neutrum  ; -- _30-tal..nn.1
  _40_tal_1_N = mkN "40-tal" neutrum  ; -- _40-tal..nn.1
  _40_åring_1_N = mkN "40-åring" ; -- _40-åring..nn.1
  _5_armad_1_A = mkA "5-armad" ; -- _5-armad..av.1
  _5_punktslaser_1_N = mkN "5-punktslaser" ; -- _5-punktslaser..nn.1
  _50_tal_1_N = mkN "50-tal" neutrum  ; -- _50-tal..nn.1
  _50_talsinspirerad_1_A = mkA "50-talsinspirerad" ; -- _50-talsinspirerad..av.1
  _60_tal_1_N = mkN "60-tal" neutrum  ; -- _60-tal..nn.1
  _60_årsjubileum_1_N = mkN "60-årsjubileum" "60-årsjubileet" "60-årsjubileer" "60-årsjubileerna" ; -- _60-årsjubileum..nn.1
  _7_armad_1_A = mkA "7-armad" ; -- _7-armad..av.1
  _70_tal_1_N = mkN "70-tal" neutrum  ; -- _70-tal..nn.1
  _80_tal_1_N = mkN "80-tal" neutrum  ; -- _80-tal..nn.1
  _90_tal_1_N = mkN "90-tal" neutrum  ; -- _90-tal..nn.1
  _95_oktanig_1_A = mkA "95-oktanig" ; -- _95-oktanig..av.1
  a_bomb_1_N = mkN "a-bomb" "a-bomber" ; -- a-bomb..nn.1
  a_kassa_1_N = mkN "a-kassa" ; -- a-kassa..nn.1
  a_vitaminbrist_1_N = mkN "a-vitaminbrist" ; -- a-vitaminbrist..nn.1
  abakus_1_N = mkN "abakus" "abakuser" ; -- abakus..nn.1
  abalone_1_N = mkN "abalone" "abaloner" ; -- abalone..nn.1
  abandon_1_N = mkN "abandon" ; -- abandon..nn.1
  abbedissa_1_N = mkN "abbedissa" ; -- abbedissa..nn.1
  abborre_1_N = mkN "abborre" utrum  ; -- abborre..nn.1
  abborrfisk_1_N = mkN "abborrfisk" ; -- abborrfisk..nn.1
  abborrliknande_1_A = mkA "abborrliknande" ; -- abborrliknande..av.1
  abborrpinne_1_N = mkN "abborrpinne" utrum  ; -- abborrpinne..nn.1
  abbot_1_N = mkN "abbot" ; -- abbot..nn.1
  abbotlig_1_A = mkA "abbotlig" ; -- abbotlig..av.1
  abbotskap_1_N = mkN "abbotskap" neutrum  ; -- abbotskap..nn.1
  abbotskloster_1_N = mkN "abbotskloster" neutrum  ; -- abbotskloster..nn.1
  abbotsstav_1_N = mkN "abbotsstav" ; -- abbotsstav..nn.1
  abbotsstift_1_N = mkN "abbotsstift" neutrum  ; -- abbotsstift..nn.1
  abbotsvärdighet_1_N = mkN "abbotsvärdighet" ; -- abbotsvärdighet..nn.1
  abbreviation_1_N = mkN "abbreviation" ; -- abbreviation..nn.1
  abbreviatur_1_N = mkN "abbreviatur" "abbreviaturer" ; -- abbreviatur..nn.1
  abbreviera_1_V = mkV "abbrevierar" ; -- abbreviera..vb.1
  abbrevierande_1_N = mkN "abbrevierande" ; -- abbrevierande..nn.1
  abbrevierbar_1_A = mkA "abbrevierbar" ; -- abbrevierbar..av.1
  abbrevierbarhet_1_N = mkN "abbrevierbarhet" ; -- abbrevierbarhet..nn.1
  abbreviering_1_N = mkN "abbreviering" ; -- abbreviering..nn.1
  abbé_1_N = mkN "abbé" "abbéer" ; -- abbé..nn.1
  abc_bok_1_N = mkN "abc-bok" "abc-böcker" ; -- abc-bok..nn.1
  abchazisk_1_A = mkA "abchazisk" ; -- abchazisk..av.1
  abderitisk_1_A = mkA "abderitisk" ; -- abderitisk..av.1
  abdikation_1_N = mkN "abdikation" ; -- abdikation..nn.1
  abdikationsakt_1_N = mkN "abdikationsakt" "abdikationsakter" ; -- abdikationsakt..nn.1
  abdikationshot_1_N = mkN "abdikationshot" neutrum  ; -- abdikationshot..nn.1
  abdikera_1_V = mkV "abdikerar" ; -- abdikera..vb.1
  abdikerande_1_N = mkN "abdikerande" ; -- abdikerande..nn.1
  abdikerbar_1_A = mkA "abdikerbar" ; -- abdikerbar..av.1
  abdikerbarhet_1_N = mkN "abdikerbarhet" ; -- abdikerbarhet..nn.1
  abdikering_1_N = mkN "abdikering" ; -- abdikering..nn.1
  abdomen_1_N = mkN "abdomen" "abdomen" "abdomen" "abdomen" ; -- abdomen..nn.1
  abdominal_1_A = mkA "abdominal" ; -- abdominal..av.1
  abducensnervsjukdom_1_N = mkN "abducensnervsjukdom" ; -- abducensnervsjukdom..nn.1
  abducensnervskada_1_N = mkN "abducensnervskada" ; -- abducensnervskada..nn.1
  aber_1_N = mkN "aber" neutrum  ; -- aber..nn.1
  aberration_1_N = mkN "aberration" ; -- aberration..nn.1
  abessinier_1_N = mkN "abessinier" "abessiniern" "abessinier" "abessinierna" ; -- abessinier..nn.1
  abessinsk_1_A = mkA "abessinsk" ; -- abessinsk..av.1
  abessinska_1_N = mkN "abessinska" ; -- abessinska..nn.1
  abessiv_1_N = mkN "abessiv" "abessiver" ; -- abessiv..nn.1
  abetalipoproteinemi_1_N = mkN "abetalipoproteinemi" ; -- abetalipoproteinemi..nn.1
  abilitet_1_N = mkN "abilitet" "abiliteter" ; -- abilitet..nn.1
  abiturient_1_N = mkN "abiturient" "abiturienter" ; -- abiturient..nn.1
  abiturientexamen_1_N = mkN "abiturientexamen" "abiturientexamen" "abiturientexamina" "abiturientexamina" ; -- abiturientexamen..nn.1
  ablation_1_N = mkN "ablation" ; -- ablation..nn.1
  ablativ_1_N = mkN "ablativ" "ablativer" ; -- ablativ..nn.1
  ablativform_1_N = mkN "ablativform" "ablativformer" ; -- ablativform..nn.1
  abnorm_1_A = mkA "abnorm" ; -- abnorm..av.1
  abnormalitet_1_N = mkN "abnormalitet" "abnormaliteter" ; -- abnormalitet..nn.1
  abnormitet_1_N = mkN "abnormitet" "abnormiteter" ; -- abnormitet..nn.1
  abolition_1_N = mkN "abolition" ; -- abolition..nn.1
  abolitionist_1_N = mkN "abolitionist" "abolitionister" ; -- abolitionist..nn.1
  abolitionistisk_1_A = mkA "abolitionistisk" ; -- abolitionistisk..av.1
  abominabel_1_A = mkA "abominabel" ; -- abominabel..av.1
  abonnemang_1_N = mkN "abonnemang" neutrum  ; -- abonnemang..nn.1
  abonnemangspris_1_N = mkN "abonnemangspris" "abonnemangspriser" ; -- abonnemangspris..nn.1
  abonnent_1_N = mkN "abonnent" "abonnenter" ; -- abonnent..nn.1
  abonnera_1_V = mkV "abonnerar" ; -- abonnera..vb.1
  abonnerande_1_N = mkN "abonnerande" ; -- abonnerande..nn.1
  abonnerbar_1_A = mkA "abonnerbar" ; -- abonnerbar..av.1
  abonnerbarhet_1_N = mkN "abonnerbarhet" ; -- abonnerbarhet..nn.1
  abonnering_1_N = mkN "abonnering" ; -- abonnering..nn.1
  aborigin_1_N = mkN "aborigin" "aboriginer" ; -- aborigin..nn.1
  aboriginer_1_N = mkN "aboriginer" "aboriginern" "aboriginer" "aboriginerna" ; -- aboriginer..nn.1
  aboriginsk_1_A = mkA "aboriginsk" ; -- aboriginsk..av.1
  aborre_1_N = mkN "aborre" utrum  ; -- aborre..nn.1
  abort_1_N = mkN "abort" "aborter" ; -- abort..nn.1
  abortera_1_V = mkV "aborterar" ; -- abortera..vb.1
  aborterande_1_N = mkN "aborterande" ; -- aborterande..nn.1
  aborterbar_1_A = mkA "aborterbar" ; -- aborterbar..av.1
  aborterbarhet_1_N = mkN "aborterbarhet" ; -- aborterbarhet..nn.1
  abortering_1_N = mkN "abortering" ; -- abortering..nn.1
  abortfråga_1_N = mkN "abortfråga" ; -- abortfråga..nn.1
  abortiv_1_A = mkA "abortiv" ; -- abortiv..av.1
  abortmotstånd_1_N = mkN "abortmotstånd" neutrum  ; -- abortmotstånd..nn.1
  abortmotståndare_1_N = mkN "abortmotståndare" utrum  ; -- abortmotståndare..nn.1
  abortpiller_1_N = mkN "abortpiller" neutrum  ; -- abortpiller..nn.1
  aborträtt_1_N = mkN "aborträtt" "aborträtter" ; -- aborträtt..nn.1
  abortrådgivning_1_N = mkN "abortrådgivning" ; -- abortrådgivning..nn.1
  abortrådgivning_2_N = mkN "abortrådgivning" ; -- abortrådgivning..nn.2
  abortör_1_N = mkN "abortör" "abortörer" ; -- abortör..nn.1
  abradera_1_V = mkV "abraderar" ; -- abradera..vb.1
  abraderande_1_N = mkN "abraderande" ; -- abraderande..nn.1
  abraderbar_1_A = mkA "abraderbar" ; -- abraderbar..av.1
  abraderbarhet_1_N = mkN "abraderbarhet" ; -- abraderbarhet..nn.1
  abradering_1_N = mkN "abradering" ; -- abradering..nn.1
  abrasion_1_N = mkN "abrasion" ; -- abrasion..nn.1
  abrovink_1_N = mkN "abrovink" "abrovinker" ; -- abrovink..nn.1
  abrovinsch_1_N = mkN "abrovinsch" "abrovinscher" ; -- abrovinsch..nn.1
  abrupt_1_A = mkA "abrupt" "abrupt" ; -- abrupt..av.1
  abrupthet_1_N = mkN "abrupthet" ; -- abrupthet..nn.1
  abscess_1_N = mkN "abscess" "abscesser" ; -- abscess..nn.1
  abscessbildning_1_N = mkN "abscessbildning" ; -- abscessbildning..nn.1
  absens_1_N = mkN "absens" "absenser" ; -- absens..nn.1
  absensepilepsi_1_N = mkN "absensepilepsi" ; -- absensepilepsi..nn.1
  absid_1_N = mkN "absid" "absider" ; -- absid..nn.1
  absint_1_N = mkN "absint" "absinter" ; -- absint..nn.1
  abskissa_1_N = mkN "abskissa" ; -- abskissa..nn.1
  absolut_1_A = mkA "absolut" "absolut" ; -- absolut..av.1
  absolutbelopp_1_N = mkN "absolutbelopp" neutrum  ; -- absolutbelopp..nn.1
  absoluthet_1_N = mkN "absoluthet" ; -- absoluthet..nn.1
  absolution_1_N = mkN "absolution" ; -- absolution..nn.1
  absolutism_1_N = mkN "absolutism" "absolutismer" ; -- absolutism..nn.1
  absolutist_1_N = mkN "absolutist" "absolutister" ; -- absolutist..nn.1
  absolutistisk_1_A = mkA "absolutistisk" ; -- absolutistisk..av.1
  absolutiv_1_N = mkN "absolutiv" "absolutiver" ; -- absolutiv..nn.1
  absolutivobjekt_1_N = mkN "absolutivobjekt" neutrum  ; -- absolutivobjekt..nn.1
  absolutivsubjekt_1_N = mkN "absolutivsubjekt" neutrum  ; -- absolutivsubjekt..nn.1
  absolvera_1_V = mkV "absolverar" ; -- absolvera..vb.1
  absolverande_1_N = mkN "absolverande" ; -- absolverande..nn.1
  absolverbar_1_A = mkA "absolverbar" ; -- absolverbar..av.1
  absolverbarhet_1_N = mkN "absolverbarhet" ; -- absolverbarhet..nn.1
  absolvering_1_N = mkN "absolvering" ; -- absolvering..nn.1
  absorbator_1_N = mkN "absorbator" "absorbatorer" ; -- absorbator..nn.1
  absorber_1_N = mkN "absorber" ; -- absorber..nn.1
  absorbera_1_V = mkV "absorberar" ; -- absorbera..vb.1
  absorbera_2_V = mkV "absorberar" ; -- absorbera..vb.2
  absorberande_1_N = mkN "absorberande" ; -- absorberande..nn.1
  absorberbar_1_A = mkA "absorberbar" ; -- absorberbar..av.1
  absorberbarhet_1_N = mkN "absorberbarhet" ; -- absorberbarhet..nn.1
  absorbering_1_N = mkN "absorbering" ; -- absorbering..nn.1
  absorberingsförmåga_1_N = mkN "absorberingsförmåga" ; -- absorberingsförmåga..nn.1
  absorption_1_N = mkN "absorption" ; -- absorption..nn.1
  absorptionslinje_1_N = mkN "absorptionslinje" "absorptionslinjer" ; -- absorptionslinje..nn.1
  abstinens_1_N = mkN "abstinens" ; -- abstinens..nn.1
  abstinenssyndrom_1_N = mkN "abstinenssyndrom" neutrum  ; -- abstinenssyndrom..nn.1
  abstrahera_1_V = mkV "abstraherar" ; -- abstrahera..vb.1
  abstraherande_1_N = mkN "abstraherande" ; -- abstraherande..nn.1
  abstraherbar_1_A = mkA "abstraherbar" ; -- abstraherbar..av.1
  abstraherbarhet_1_N = mkN "abstraherbarhet" ; -- abstraherbarhet..nn.1
  abstrahering_1_N = mkN "abstrahering" ; -- abstrahering..nn.1
  abstrakt_1_A = mkA "abstrakt" "abstrakt" ; -- abstrakt..av.1
  abstrakt_1_N = mkN "abstrakt" "abstraktet" "abstrakter" "abstrakterna" ; -- abstrakt..nn.1
  abstrakthet_1_N = mkN "abstrakthet" ; -- abstrakthet..nn.1
  abstraktion_1_N = mkN "abstraktion" ; -- abstraktion..nn.1
  abstraktionsförmåga_1_N = mkN "abstraktionsförmåga" ; -- abstraktionsförmåga..nn.1
  abstraktändelse_1_N = mkN "abstraktändelse" "abstraktändelser" ; -- abstraktändelse..nn.1
  abstrus_1_A = mkA "abstrus" ; -- abstrus..av.1
  absurd_1_A = mkA "absurd" "absurt" ; -- absurd..av.1
  absurdhet_1_N = mkN "absurdhet" ; -- absurdhet..nn.1
  absurdism_1_N = mkN "absurdism" "absurdismer" ; -- absurdism..nn.1
  absurdistisk_1_A = mkA "absurdistisk" ; -- absurdistisk..av.1
  absurditet_1_N = mkN "absurditet" "absurditeter" ; -- absurditet..nn.1
  abundans_1_N = mkN "abundans" ; -- abundans..nn.1
  abundant_1_A = mkA "abundant" "abundant" ; -- abundant..av.1
  abyssal_1_A = mkA "abyssal" ; -- abyssal..av.1
  acanthamoebakeratit_1_N = mkN "acanthamoebakeratit" "acanthamoebakeratiter" ; -- acanthamoebakeratit..nn.1
  accedera_1_V = mkV "accederar" ; -- accedera..vb.1
  accederande_1_N = mkN "accederande" ; -- accederande..nn.1
  accederbar_1_A = mkA "accederbar" ; -- accederbar..av.1
  accederbarhet_1_N = mkN "accederbarhet" ; -- accederbarhet..nn.1
  accedering_1_N = mkN "accedering" ; -- accedering..nn.1
  acceleration_1_N = mkN "acceleration" ; -- acceleration..nn.1
  accelerationsfält_1_N = mkN "accelerationsfält" neutrum  ; -- accelerationsfält..nn.1
  accelerationslag_1_N = mkN "accelerationslag" ; -- accelerationslag..nn.1
  accelerator_1_N = mkN "accelerator" "acceleratorer" ; -- accelerator..nn.1
  acceleratormaskin_1_N = mkN "acceleratormaskin" "acceleratormaskiner" ; -- acceleratormaskin..nn.1
  acceleratorsystem_1_N = mkN "acceleratorsystem" neutrum  ; -- acceleratorsystem..nn.1
  accelerera_1_V = mkV "accelererar" ; -- accelerera..vb.1
  accelerera_2_V = mkV "accelererar" ; -- accelerera..vb.2
  accelererande_1_N = mkN "accelererande" ; -- accelererande..nn.1
  accelererbar_1_A = mkA "accelererbar" ; -- accelererbar..av.1
  accelererbarhet_1_N = mkN "accelererbarhet" ; -- accelererbarhet..nn.1
  accelerering_1_N = mkN "accelerering" ; -- accelerering..nn.1
  accent_1_N = mkN "accent" "accenter" ; -- accent..nn.1
  accentbeteckning_1_N = mkN "accentbeteckning" ; -- accentbeteckning..nn.1
  accentförskjutning_1_N = mkN "accentförskjutning" ; -- accentförskjutning..nn.1
  accenttecken_1_N = mkN "accenttecken" "accenttecknet" "accenttecken" "accenttecknen" ; -- accenttecken..nn.1
  accentuera_1_V = mkV "accentuerar" ; -- accentuera..vb.1
  accentuerande_1_N = mkN "accentuerande" ; -- accentuerande..nn.1
  accentuerbar_1_A = mkA "accentuerbar" ; -- accentuerbar..av.1
  accentuerbarhet_1_N = mkN "accentuerbarhet" ; -- accentuerbarhet..nn.1
  accentuering_1_N = mkN "accentuering" ; -- accentuering..nn.1
  accept_1_N = mkN "accept" neutrum  ; -- accept..nn.1
  accept_2_N = mkN "accept" "accepter" ; -- accept..nn.2
  acceptabel_1_A = mkA "acceptabel" ; -- acceptabel..av.1
  acceptans_1_N = mkN "acceptans" ; -- acceptans..nn.1
  acceptant_1_N = mkN "acceptant" "acceptanter" ; -- acceptant..nn.1
  acceptera_1_V = mkV "accepterar" ; -- acceptera..vb.1
  accepterande_1_N = mkN "accepterande" ; -- accepterande..nn.1
  accepterbar_1_A = mkA "accepterbar" ; -- accepterbar..av.1
  accepterbarhet_1_N = mkN "accepterbarhet" ; -- accepterbarhet..nn.1
  acceptering_1_N = mkN "acceptering" ; -- acceptering..nn.1
  acceptkredit_1_N = mkN "acceptkredit" "acceptkrediter" ; -- acceptkredit..nn.1
  acceptpris_1_N = mkN "acceptpris" neutrum  ; -- acceptpris..nn.1
  access_1_N = mkN "access" "accesser" ; -- access..nn.1
  accessa_1_V = mkV "accessar" ; -- accessa..vb.1
  accessande_1_N = mkN "accessande" ; -- accessande..nn.1
  accession_1_N = mkN "accession" ; -- accession..nn.1
  accessionskatalog_1_N = mkN "accessionskatalog" "accessionskataloger" ; -- accessionskatalog..nn.1
  accessoar_1_N = mkN "accessoar" "accessoarer" ; -- accessoar..nn.1
  accessorisk_1_A = mkA "accessorisk" ; -- accessorisk..av.1
  accesstid_1_N = mkN "accesstid" "accesstider" ; -- accesstid..nn.1
  accidens_1_N = mkN "accidens" "accidenser" ; -- accidens..nn.1
  accidenstryck_1_N = mkN "accidenstryck" neutrum  ; -- accidenstryck..nn.1
  accidentell_1_A = mkA "accidentell" ; -- accidentell..av.1
  accis_1_N = mkN "accis" "acciser" ; -- accis..nn.1
  accisfri_1_A = mkA "accisfri" "accisfritt" ; -- accisfri..av.1
  accispliktig_1_A = mkA "accispliktig" ; -- accispliktig..av.1
  acerolakörsbär_1_N = mkN "acerolakörsbär" neutrum  ; -- acerolakörsbär..nn.1
  acetaldehyd_1_N = mkN "acetaldehyd" "acetaldehyder" ; -- acetaldehyd..nn.1
  acetat_1_N = mkN "acetat" neutrum  ; -- acetat..nn.1
  aceton_1_N = mkN "aceton" ; -- aceton..nn.1
  acetylen_1_N = mkN "acetylen" neutrum  ; -- acetylen..nn.1
  acetylengas_1_N = mkN "acetylengas" ; -- acetylengas..nn.1
  acetylenlampa_1_N = mkN "acetylenlampa" ; -- acetylenlampa..nn.1
  acetylsalicylsyra_1_N = mkN "acetylsalicylsyra" ; -- acetylsalicylsyra..nn.1
  aciditet_1_N = mkN "aciditet" "aciditeter" ; -- aciditet..nn.1
  acidos_1_N = mkN "acidos" "acidoser" ; -- acidos..nn.1
  acinetobacterinfektion_1_N = mkN "acinetobacterinfektion" ; -- acinetobacterinfektion..nn.1
  acinärcellskarcinom_1_N = mkN "acinärcellskarcinom" neutrum  ; -- acinärcellskarcinom..nn.1
  ackja_1_N = mkN "ackja" ; -- ackja..nn.1
  acklamation_1_N = mkN "acklamation" ; -- acklamation..nn.1
  acklamationsval_1_N = mkN "acklamationsval" neutrum  ; -- acklamationsval..nn.1
  acklimatisation_1_N = mkN "acklimatisation" ; -- acklimatisation..nn.1
  acklimatisera_1_V = mkV "acklimatiserar" ; -- acklimatisera..vb.1
  acklimatiserande_1_N = mkN "acklimatiserande" ; -- acklimatiserande..nn.1
  acklimatiserbar_1_A = mkA "acklimatiserbar" ; -- acklimatiserbar..av.1
  acklimatiserbarhet_1_N = mkN "acklimatiserbarhet" ; -- acklimatiserbarhet..nn.1
  acklimatisering_1_N = mkN "acklimatisering" ; -- acklimatisering..nn.1
  ackommodation_1_N = mkN "ackommodation" ; -- ackommodation..nn.1
  ackommodationsförmåga_1_N = mkN "ackommodationsförmåga" ; -- ackommodationsförmåga..nn.1
  ackommodationsväxel_1_N = mkN "ackommodationsväxel" ; -- ackommodationsväxel..nn.1
  ackommodera_1_V = mkV "ackommoderar" ; -- ackommodera..vb.1
  ackommoderande_1_N = mkN "ackommoderande" ; -- ackommoderande..nn.1
  ackommoderbar_1_A = mkA "ackommoderbar" ; -- ackommoderbar..av.1
  ackommoderbarhet_1_N = mkN "ackommoderbarhet" ; -- ackommoderbarhet..nn.1
  ackommodering_1_N = mkN "ackommodering" ; -- ackommodering..nn.1
  ackompanjatör_1_N = mkN "ackompanjatör" "ackompanjatörer" ; -- ackompanjatör..nn.1
  ackompanjemang_1_N = mkN "ackompanjemang" neutrum  ; -- ackompanjemang..nn.1
  ackompanjera_1_V = mkV "ackompanjerar" ; -- ackompanjera..vb.1
  ackompanjerande_1_N = mkN "ackompanjerande" ; -- ackompanjerande..nn.1
  ackompanjerbar_1_A = mkA "ackompanjerbar" ; -- ackompanjerbar..av.1
  ackompanjerbarhet_1_N = mkN "ackompanjerbarhet" ; -- ackompanjerbarhet..nn.1
  ackompanjering_1_N = mkN "ackompanjering" ; -- ackompanjering..nn.1
  ackord_1_N = mkN "ackord" neutrum  ; -- ackord..nn.1
  ackord_2_N = mkN "ackord" neutrum  ; -- ackord..nn.2
  ackordera_1_V = mkV "ackorderar" ; -- ackordera..vb.1
  ackorderande_1_N = mkN "ackorderande" ; -- ackorderande..nn.1
  ackorderbar_1_A = mkA "ackorderbar" ; -- ackorderbar..av.1
  ackorderbarhet_1_N = mkN "ackorderbarhet" ; -- ackorderbarhet..nn.1
  ackordering_1_N = mkN "ackordering" ; -- ackordering..nn.1
  ackordgrepp_1_N = mkN "ackordgrepp" neutrum  ; -- ackordgrepp..nn.1
  ackordion_1_N = mkN "ackordion" "ackordiet" "ackordier" "ackordierna" ; -- ackordion..nn.1
  ackordlära_1_N = mkN "ackordlära" ; -- ackordlära..nn.1
  ackordsarbete_1_N = mkN "ackordsarbete" ; -- ackordsarbete..nn.1
  ackordshets_1_N = mkN "ackordshets" ; -- ackordshets..nn.1
  ackordslön_1_N = mkN "ackordslön" "ackordslöner" ; -- ackordslön..nn.1
  ackordssumma_1_N = mkN "ackordssumma" ; -- ackordssumma..nn.1
  ackordssättning_1_N = mkN "ackordssättning" ; -- ackordssättning..nn.1
  ackordsättning_1_N = mkN "ackordsättning" ; -- ackordsättning..nn.1
  ackreditera_1_V = mkV "ackrediterar" ; -- ackreditera..vb.1
  ackrediterande_1_N = mkN "ackrediterande" ; -- ackrediterande..nn.1
  ackrediterbar_1_A = mkA "ackrediterbar" ; -- ackrediterbar..av.1
  ackrediterbarhet_1_N = mkN "ackrediterbarhet" ; -- ackrediterbarhet..nn.1
  ackreditering_1_N = mkN "ackreditering" ; -- ackreditering..nn.1
  ackumulation_1_N = mkN "ackumulation" ; -- ackumulation..nn.1
  ackumulator_1_N = mkN "ackumulator" "ackumulatorer" ; -- ackumulator..nn.1
  ackumulera_1_V = mkV "ackumulerar" ; -- ackumulera..vb.1
  ackumulerande_1_N = mkN "ackumulerande" ; -- ackumulerande..nn.1
  ackumulerbar_1_A = mkA "ackumulerbar" ; -- ackumulerbar..av.1
  ackumulerbarhet_1_N = mkN "ackumulerbarhet" ; -- ackumulerbarhet..nn.1
  ackumulering_1_N = mkN "ackumulering" ; -- ackumulering..nn.1
  ackurat_1_A = mkA "ackurat" "ackurat" ; -- ackurat..av.1
  ackuratess_1_N = mkN "ackuratess" ; -- ackuratess..nn.1
  ackusativ_1_A = mkA "ackusativ" ; -- ackusativ..av.1
  ackusativ_1_N = mkN "ackusativ" "ackusativer" ; -- ackusativ..nn.1
  ackusativobjekt_1_N = mkN "ackusativobjekt" neutrum  ; -- ackusativobjekt..nn.1
  ackusativändelse_1_N = mkN "ackusativändelse" "ackusativändelser" ; -- ackusativändelse..nn.1
  ackusatorisk_1_A = mkA "ackusatorisk" ; -- ackusatorisk..av.1
  ackuschör_1_N = mkN "ackuschör" "ackuschörer" ; -- ackuschör..nn.1
  ackuschörska_1_N = mkN "ackuschörska" ; -- ackuschörska..nn.1
  ackvirera_1_V = mkV "ackvirerar" ; -- ackvirera..vb.1
  ackvirerande_1_N = mkN "ackvirerande" ; -- ackvirerande..nn.1
  ackvirerbar_1_A = mkA "ackvirerbar" ; -- ackvirerbar..av.1
  ackvirerbarhet_1_N = mkN "ackvirerbarhet" ; -- ackvirerbarhet..nn.1
  ackvirering_1_N = mkN "ackvirering" ; -- ackvirering..nn.1
  ackvisition_1_N = mkN "ackvisition" ; -- ackvisition..nn.1
  ackvisitionskatalog_1_N = mkN "ackvisitionskatalog" "ackvisitionskataloger" ; -- ackvisitionskatalog..nn.1
  ackvisitör_1_N = mkN "ackvisitör" "ackvisitörer" ; -- ackvisitör..nn.1
  acne_1_N = mkN "acne" utrum  ; -- acne..nn.1
  actinobacillusinfektion_1_N = mkN "actinobacillusinfektion" ; -- actinobacillusinfektion..nn.1
  actinomycetalesinfektion_1_N = mkN "actinomycetalesinfektion" ; -- actinomycetalesinfektion..nn.1
  action_1_N = mkN "action" ; -- action..nn.1
  actionfilm_1_N = mkN "actionfilm" "actionfilmer" ; -- actionfilm..nn.1
  actionrulle_1_N = mkN "actionrulle" utrum  ; -- actionrulle..nn.1
  actionstjärna_1_N = mkN "actionstjärna" ; -- actionstjärna..nn.1
  adagio_1_N = mkN "adagio" "adagiot" "adagion" "adagiona" ; -- adagio..nn.1
  adagiosats_1_N = mkN "adagiosats" "adagiosatser" ; -- adagiosats..nn.1
  adamantinom_1_N = mkN "adamantinom" neutrum  ; -- adamantinom..nn.1
  adamsdräkt_1_N = mkN "adamsdräkt" ; -- adamsdräkt..nn.1
  adamsäpple_1_N = mkN "adamsäpple" ; -- adamsäpple..nn.1
  adaptation_1_N = mkN "adaptation" ; -- adaptation..nn.1
  adapter_1_N = mkN "adapter" ; -- adapter..nn.1
  adaptera_1_V = mkV "adapterar" ; -- adaptera..vb.1
  adapterande_1_N = mkN "adapterande" ; -- adapterande..nn.1
  adapterbar_1_A = mkA "adapterbar" ; -- adapterbar..av.1
  adapterbarhet_1_N = mkN "adapterbarhet" ; -- adapterbarhet..nn.1
  adaptering_1_N = mkN "adaptering" ; -- adaptering..nn.1
  adaption_1_N = mkN "adaption" ; -- adaption..nn.1
  adaptiv_1_A = mkA "adaptiv" ; -- adaptiv..av.1
  addend_1_N = mkN "addend" "addender" ; -- addend..nn.1
  addenda_1_N = mkN "addenda" "addendan" "addenda" "addendana" ; -- addenda..nn.1
  addera_1_V = mkV "adderar" ; -- addera..vb.1
  adderande_1_N = mkN "adderande" ; -- adderande..nn.1
  adderbar_1_A = mkA "adderbar" ; -- adderbar..av.1
  adderbarhet_1_N = mkN "adderbarhet" ; -- adderbarhet..nn.1
  addering_1_N = mkN "addering" ; -- addering..nn.1
  addiktion_1_N = mkN "addiktion" ; -- addiktion..nn.1
  addiktolog_1_N = mkN "addiktolog" "addiktologer" ; -- addiktolog..nn.1
  additament_1_N = mkN "additament" neutrum  ; -- additament..nn.1
  addition_1_N = mkN "addition" ; -- addition..nn.1
  additionstecken_1_N = mkN "additionstecken" "additionstecknet" "additionstecken" "additionstecknen" ; -- additionstecken..nn.1
  additiv_1_A = mkA "additiv" ; -- additiv..av.1
  additiv_1_N = mkN "additiv" neutrum  ; -- additiv..nn.1
  adduktion_1_N = mkN "adduktion" ; -- adduktion..nn.1
  adekvat_1_A = mkA "adekvat" "adekvat" ; -- adekvat..av.1
  adel_1_N = mkN "adel" ; -- adel..nn.1
  adelsbrev_1_N = mkN "adelsbrev" neutrum  ; -- adelsbrev..nn.1
  adelsdam_1_N = mkN "adelsdam" "adelsdamer" ; -- adelsdam..nn.1
  adelsgods_1_N = mkN "adelsgods" neutrum  ; -- adelsgods..nn.1
  adelshem_1_N = mkN "adelshem" "adelshemmet" "adelshem" "adelshemmen" ; -- adelshem..nn.1
  adelshögfärd_1_N = mkN "adelshögfärd" ; -- adelshögfärd..nn.1
  adelskalender_1_N = mkN "adelskalender" ; -- adelskalender..nn.1
  adelskap_1_N = mkN "adelskap" neutrum  ; -- adelskap..nn.1
  adelskrets_1_N = mkN "adelskrets" ; -- adelskrets..nn.1
  adelskultur_1_N = mkN "adelskultur" ; -- adelskultur..nn.1
  adelsman_1_N = mkN "adelsman" "adelsmannen" "adelsmän" "adelsmännen" ; -- adelsman..nn.1
  adelsmatrikel_1_N = mkN "adelsmatrikel" ; -- adelsmatrikel..nn.1
  adelsmärke_1_N = mkN "adelsmärke" ; -- adelsmärke..nn.1
  adelsprivilegium_1_N = mkN "adelsprivilegium" "adelsprivilegiet" "adelsprivilegier" "adelsprivilegierna" ; -- adelsprivilegium..nn.1
  adelssläkt_1_N = mkN "adelssläkt" "adelssläkter" ; -- adelssläkt..nn.1
  adelsstånd_1_N = mkN "adelsstånd" neutrum  ; -- adelsstånd..nn.1
  adelsätt_1_N = mkN "adelsätt" "adelsätter" ; -- adelsätt..nn.1
  adenit_1_N = mkN "adenit" "adeniter" ; -- adenit..nn.1
  adenofibrom_1_N = mkN "adenofibrom" neutrum  ; -- adenofibrom..nn.1
  adenoid_1_A = mkA "adenoid" ; -- adenoid..av.1
  adenoid_1_N = mkN "adenoid" "adenoider" ; -- adenoid..nn.1
  adenokarcinom_1_N = mkN "adenokarcinom" neutrum  ; -- adenokarcinom..nn.1
  adenolymfom_1_N = mkN "adenolymfom" neutrum  ; -- adenolymfom..nn.1
  adenom_1_N = mkN "adenom" neutrum  ; -- adenom..nn.1
  adenomyoepiteliom_1_N = mkN "adenomyoepiteliom" neutrum  ; -- adenomyoepiteliom..nn.1
  adenomyom_1_N = mkN "adenomyom" neutrum  ; -- adenomyom..nn.1
  adenophoreainfektion_1_N = mkN "adenophoreainfektion" ; -- adenophoreainfektion..nn.1
  adenosarkom_1_N = mkN "adenosarkom" neutrum  ; -- adenosarkom..nn.1
  adenovirusinfektion_1_N = mkN "adenovirusinfektion" ; -- adenovirusinfektion..nn.1
  adept_1_N = mkN "adept" "adepter" ; -- adept..nn.1
  adertonde_1_A = mkA "adertonde" ; -- adertonde..av.1
  adertonhundratal_1_N = mkN "adertonhundratal" neutrum  ; -- adertonhundratal..nn.1
  adessiv_1_N = mkN "adessiv" "adessiver" ; -- adessiv..nn.1
  adhd_symtom_1_N = mkN "adhd-symtom" neutrum  ; -- adhd-symtom..nn.1
  adherens_1_N = mkN "adherens" ; -- adherens..nn.1
  adhesion_1_N = mkN "adhesion" ; -- adhesion..nn.1
  adhesionskraft_1_N = mkN "adhesionskraft" "adhesionskrafter" ; -- adhesionskraft..nn.1
  adhesiv_1_A = mkA "adhesiv" ; -- adhesiv..av.1
  adiabatisk_1_A = mkA "adiabatisk" ; -- adiabatisk..av.1
  adiafora_1_N = mkN "adiafora" "adiaforan" "adiafora" "adiaforana" ; -- adiafora..nn.1
  adiaforistisk_1_A = mkA "adiaforistisk" ; -- adiaforistisk..av.1
  adidasgympasko_1_N = mkN "adidasgympasko" "adidasgympaskor" ; -- adidasgympasko..nn.1
  adipositas_1_N = mkN "adipositas" ; -- adipositas..nn.1
  adjektiv_1_N = mkN "adjektiv" neutrum  ; -- adjektiv..nn.1
  adjektivattribut_1_N = mkN "adjektivattribut" neutrum  ; -- adjektivattribut..nn.1
  adjektivfras_1_N = mkN "adjektivfras" "adjektivfraser" ; -- adjektivfras..nn.1
  adjektivisk_1_A = mkA "adjektivisk" ; -- adjektivisk..av.1
  adjektivistisk_1_A = mkA "adjektivistisk" ; -- adjektivistisk..av.1
  adjektivändelse_1_N = mkN "adjektivändelse" "adjektivändelser" ; -- adjektivändelse..nn.1
  adjungera_1_V = mkV "adjungerar" ; -- adjungera..vb.1
  adjungerande_1_N = mkN "adjungerande" ; -- adjungerande..nn.1
  adjungerbar_1_A = mkA "adjungerbar" ; -- adjungerbar..av.1
  adjungerbarhet_1_N = mkN "adjungerbarhet" ; -- adjungerbarhet..nn.1
  adjungering_1_N = mkN "adjungering" ; -- adjungering..nn.1
  adjunkt_1_N = mkN "adjunkt" "adjunkter" ; -- adjunkt..nn.1
  adjunktion_1_N = mkN "adjunktion" ; -- adjunktion..nn.1
  adjunktur_1_N = mkN "adjunktur" "adjunkturer" ; -- adjunktur..nn.1
  adjutant_1_N = mkN "adjutant" "adjutanter" ; -- adjutant..nn.1
  adjö_1_N = mkN "adjö" "adjöt" "adjön" "adjöna" ; -- adjö..nn.1
  adla_1_V = mkV "adlar" ; -- adla..vb.1
  adlande_1_N = mkN "adlande" ; -- adlande..nn.1
  adlig_1_A = mkA "adlig" ; -- adlig..av.1
  adlighet_1_N = mkN "adlighet" ; -- adlighet..nn.1
  administration_1_N = mkN "administration" ; -- administration..nn.1
  administrativ_1_A = mkA "administrativ" ; -- administrativ..av.1
  administrator_1_N = mkN "administrator" "administratorer" ; -- administrator..nn.1
  administratör_1_N = mkN "administratör" "administratörer" ; -- administratör..nn.1
  administratörsstatus_1_N = mkN "administratörsstatus" ; -- administratörsstatus..nn.1
  administrera_1_V = mkV "administrerar" ; -- administrera..vb.1
  administrerande_1_N = mkN "administrerande" ; -- administrerande..nn.1
  administrerbar_1_A = mkA "administrerbar" ; -- administrerbar..av.1
  administrerbarhet_1_N = mkN "administrerbarhet" ; -- administrerbarhet..nn.1
  administrering_1_N = mkN "administrering" ; -- administrering..nn.1
  admonition_1_N = mkN "admonition" ; -- admonition..nn.1
  adnexasjukdom_1_N = mkN "adnexasjukdom" ; -- adnexasjukdom..nn.1
  adnexit_1_N = mkN "adnexit" "adnexiter" ; -- adnexit..nn.1
  adobe_1_N = mkN "adobe" utrum  ; -- adobe..nn.1
  adolescens_1_N = mkN "adolescens" ; -- adolescens..nn.1
  adonis_1_N = mkN "adonis" ; -- adonis..nn.1
  adonisgestalt_1_N = mkN "adonisgestalt" "adonisgestalter" ; -- adonisgestalt..nn.1
  adoptant_1_N = mkN "adoptant" "adoptanter" ; -- adoptant..nn.1
  adoptera_1_V = mkV "adopterar" ; -- adoptera..vb.1
  adopterande_1_N = mkN "adopterande" ; -- adopterande..nn.1
  adopterbar_1_A = mkA "adopterbar" ; -- adopterbar..av.1
  adopterbarhet_1_N = mkN "adopterbarhet" ; -- adopterbarhet..nn.1
  adoptering_1_N = mkN "adoptering" ; -- adoptering..nn.1
  adoption_1_N = mkN "adoption" ; -- adoption..nn.1
  adoptiv_1_A = mkA "adoptiv" ; -- adoptiv..av.1
  adoptivbarn_1_N = mkN "adoptivbarn" neutrum  ; -- adoptivbarn..nn.1
  adoptivförälder_1_N = mkN "adoptivförälder" ; -- adoptivförälder..nn.1
  adoptivson_1_N = mkN "adoptivson" "adoptivsöner" ; -- adoptivson..nn.1
  adoratör_1_N = mkN "adoratör" "adoratörer" ; -- adoratör..nn.1
  adrenalin_1_N = mkN "adrenalin" "adrenaliner" ; -- adrenalin..nn.1
  adrenalinkick_1_N = mkN "adrenalinkick" ; -- adrenalinkick..nn.1
  adrenalinstinn_1_A = mkA "adrenalinstinn" "adrenalinstint" ; -- adrenalinstinn..av.1
  adrenoleukodystrofi_1_N = mkN "adrenoleukodystrofi" ; -- adrenoleukodystrofi..nn.1
  adrenomyeloneuropati_1_N = mkN "adrenomyeloneuropati" ; -- adrenomyeloneuropati..nn.1
  adress_1_N = mkN "adress" "adresser" ; -- adress..nn.1
  adressat_1_N = mkN "adressat" "adressater" ; -- adressat..nn.1
  adressbuss_1_N = mkN "adressbuss" ; -- adressbuss..nn.1
  adressera_1_V = mkV "adresserar" ; -- adressera..vb.1
  adresserande_1_N = mkN "adresserande" ; -- adresserande..nn.1
  adresserbar_1_A = mkA "adresserbar" ; -- adresserbar..av.1
  adresserbarhet_1_N = mkN "adresserbarhet" ; -- adresserbarhet..nn.1
  adressering_1_N = mkN "adressering" ; -- adressering..nn.1
  adresskalender_1_N = mkN "adresskalender" ; -- adresskalender..nn.1
  adresskort_1_N = mkN "adresskort" neutrum  ; -- adresskort..nn.1
  adresskälla_1_N = mkN "adresskälla" ; -- adresskälla..nn.1
  adresslapp_1_N = mkN "adresslapp" ; -- adresslapp..nn.1
  adriatisk_1_A = mkA "adriatisk" ; -- adriatisk..av.1
  adsorbera_1_V = mkV "adsorberar" ; -- adsorbera..vb.1
  adsorberande_1_N = mkN "adsorberande" ; -- adsorberande..nn.1
  adsorberbar_1_A = mkA "adsorberbar" ; -- adsorberbar..av.1
  adsorberbarhet_1_N = mkN "adsorberbarhet" ; -- adsorberbarhet..nn.1
  adsorbering_1_N = mkN "adsorbering" ; -- adsorbering..nn.1
  adsorption_1_N = mkN "adsorption" ; -- adsorption..nn.1
  adstringerande_1_A = mkA "adstringerande" ; -- adstringerande..av.1
  aducera_1_V = mkV "aducerar" ; -- aducera..vb.1
  aducerande_1_N = mkN "aducerande" ; -- aducerande..nn.1
  aducerbar_1_A = mkA "aducerbar" ; -- aducerbar..av.1
  aducerbarhet_1_N = mkN "aducerbarhet" ; -- aducerbarhet..nn.1
  aducering_1_N = mkN "aducering" ; -- aducering..nn.1
  advent_1_N = mkN "advent" neutrum  ; -- advent..nn.1
  adventist_1_N = mkN "adventist" "adventister" ; -- adventist..nn.1
  adventistisk_1_A = mkA "adventistisk" ; -- adventistisk..av.1
  adventiv_1_A = mkA "adventiv" ; -- adventiv..av.1
  adventskalender_1_N = mkN "adventskalender" ; -- adventskalender..nn.1
  adventsljusstake_1_N = mkN "adventsljusstake" utrum  ; -- adventsljusstake..nn.1
  adventsmys_1_N = mkN "adventsmys" neutrum  ; -- adventsmys..nn.1
  adventsstake_1_N = mkN "adventsstake" utrum  ; -- adventsstake..nn.1
  adventsstjärna_1_N = mkN "adventsstjärna" ; -- adventsstjärna..nn.1
  adverb_1_N = mkN "adverb" neutrum  ; -- adverb..nn.1
  adverbial_1_N = mkN "adverbial" neutrum  ; -- adverbial..nn.1
  adverbialbestämning_1_N = mkN "adverbialbestämning" ; -- adverbialbestämning..nn.1
  adverbialsats_1_N = mkN "adverbialsats" "adverbialsatser" ; -- adverbialsats..nn.1
  adverbiell_1_A = mkA "adverbiell" ; -- adverbiell..av.1
  advers_1_N = mkN "advers" "adverser" ; -- advers..nn.1
  adversativ_1_A = mkA "adversativ" ; -- adversativ..av.1
  advocera_1_V = mkV "advocerar" ; -- advocera..vb.1
  advocerande_1_N = mkN "advocerande" ; -- advocerande..nn.1
  advocerbar_1_A = mkA "advocerbar" ; -- advocerbar..av.1
  advocerbarhet_1_N = mkN "advocerbarhet" ; -- advocerbarhet..nn.1
  advocering_1_N = mkN "advocering" ; -- advocering..nn.1
  advokat_1_N = mkN "advokat" "advokater" ; -- advokat..nn.1
  advokatbyrå_1_N = mkN "advokatbyrå" "advokatbyråer" ; -- advokatbyrå..nn.1
  advokatfiskal_1_N = mkN "advokatfiskal" "advokatfiskaler" ; -- advokatfiskal..nn.1
  advokathjälp_1_N = mkN "advokathjälp" ; -- advokathjälp..nn.1
  advokatknep_1_N = mkN "advokatknep" neutrum  ; -- advokatknep..nn.1
  advokatkontor_1_N = mkN "advokatkontor" neutrum  ; -- advokatkontor..nn.1
  advokatorisk_1_A = mkA "advokatorisk" ; -- advokatorisk..av.1
  advokatsamfund_1_N = mkN "advokatsamfund" neutrum  ; -- advokatsamfund..nn.1
  advokatstorm_1_N = mkN "advokatstorm" ; -- advokatstorm..nn.1
  advokatyr_1_N = mkN "advokatyr" "advokatyrer" ; -- advokatyr..nn.1
  adxukiböna_1_N = mkN "adxukiböna" ; -- adxukiböna..nn.1
  aerob_1_A = mkA "aerob" ; -- aerob..av.1
  aerobisk_1_A = mkA "aerobisk" ; -- aerobisk..av.1
  aerodrom_1_N = mkN "aerodrom" "aerodromer" ; -- aerodrom..nn.1
  aerodynamik_1_N = mkN "aerodynamik" ; -- aerodynamik..nn.1
  aerodynamisk_1_A = mkA "aerodynamisk" ; -- aerodynamisk..av.1
  aerofagi_1_N = mkN "aerofagi" ; -- aerofagi..nn.1
  aerogel_1_N = mkN "aerogel" "aerogeler" ; -- aerogel..nn.1
  aerogram_1_N = mkN "aerogram" "aerogrammet" "aerogram" "aerogrammen" ; -- aerogram..nn.1
  aerologi_1_N = mkN "aerologi" ; -- aerologi..nn.1
  aeromekanik_1_N = mkN "aeromekanik" ; -- aeromekanik..nn.1
  aeronaut_1_N = mkN "aeronaut" "aeronauter" ; -- aeronaut..nn.1
  aeronautik_1_N = mkN "aeronautik" ; -- aeronautik..nn.1
  aeronautisk_1_A = mkA "aeronautisk" ; -- aeronautisk..av.1
  aeroplan_1_N = mkN "aeroplan" neutrum  ; -- aeroplan..nn.1
  aerosol_1_N = mkN "aerosol" "aerosoler" ; -- aerosol..nn.1
  aerosolform_1_N = mkN "aerosolform" ; -- aerosolform..nn.1
  aerostat_1_N = mkN "aerostat" "aerostater" ; -- aerostat..nn.1
  aerostatik_1_N = mkN "aerostatik" ; -- aerostatik..nn.1
  aerostatisk_1_A = mkA "aerostatisk" ; -- aerostatisk..av.1
  afaki_1_N = mkN "afaki" ; -- afaki..nn.1
  afasi_1_N = mkN "afasi" "afasier" ; -- afasi..nn.1
  afasisk_1_A = mkA "afasisk" ; -- afasisk..av.1
  afatiker_1_N = mkN "afatiker" "afatikern" "afatiker" "afatikerna" ; -- afatiker..nn.1
  afatisk_1_A = mkA "afatisk" ; -- afatisk..av.1
  afelium_1_N = mkN "afelium" "afeliet" "afelier" "afelierna" ; -- afelium..nn.1
  affekt_1_N = mkN "affekt" "affekter" ; -- affekt..nn.1
  affektanfall_1_N = mkN "affektanfall" neutrum  ; -- affektanfall..nn.1
  affektation_1_N = mkN "affektation" ; -- affektation..nn.1
  affekterad_1_A = mkA "affekterad" ; -- affekterad..av.1
  affektfri_1_A = mkA "affektfri" "affektfritt" ; -- affektfri..av.1
  affektion_1_N = mkN "affektion" ; -- affektion..nn.1
  affektionsvärde_1_N = mkN "affektionsvärde" ; -- affektionsvärde..nn.1
  affektiv_1_A = mkA "affektiv" ; -- affektiv..av.1
  afficiera_1_V = mkV "afficierar" ; -- afficiera..vb.1
  afficierande_1_N = mkN "afficierande" ; -- afficierande..nn.1
  afficierbar_1_A = mkA "afficierbar" ; -- afficierbar..av.1
  afficierbarhet_1_N = mkN "afficierbarhet" ; -- afficierbarhet..nn.1
  afficiering_1_N = mkN "afficiering" ; -- afficiering..nn.1
  affidavit_1_N = mkN "affidavit" neutrum  ; -- affidavit..nn.1
  affin_1_A = mkA "affin" ; -- affin..av.1
  affinage_1_N = mkN "affinage" "affinaget" "affinage" "affinagen" ; -- affinage..nn.1
  affinera_1_V = mkV "affinerar" ; -- affinera..vb.1
  affinerande_1_N = mkN "affinerande" ; -- affinerande..nn.1
  affinerbar_1_A = mkA "affinerbar" ; -- affinerbar..av.1
  affinerbarhet_1_N = mkN "affinerbarhet" ; -- affinerbarhet..nn.1
  affinering_1_N = mkN "affinering" ; -- affinering..nn.1
  affinitet_1_N = mkN "affinitet" "affiniteter" ; -- affinitet..nn.1
  affirmativ_1_A = mkA "affirmativ" ; -- affirmativ..av.1
  affisch_1_N = mkN "affisch" "affischer" ; -- affisch..nn.1
  affischera_1_V = mkV "affischerar" ; -- affischera..vb.1
  affischerande_1_N = mkN "affischerande" ; -- affischerande..nn.1
  affischerbar_1_A = mkA "affischerbar" ; -- affischerbar..av.1
  affischerbarhet_1_N = mkN "affischerbarhet" ; -- affischerbarhet..nn.1
  affischering_1_N = mkN "affischering" ; -- affischering..nn.1
  affischkampanj_1_N = mkN "affischkampanj" "affischkampanjer" ; -- affischkampanj..nn.1
  affischmässig_1_A = mkA "affischmässig" ; -- affischmässig..av.1
  affischnamn_1_N = mkN "affischnamn" neutrum  ; -- affischnamn..nn.1
  affischpelare_1_N = mkN "affischpelare" utrum  ; -- affischpelare..nn.1
  affischstil_1_N = mkN "affischstil" ; -- affischstil..nn.1
  affischör_1_N = mkN "affischör" "affischörer" ; -- affischör..nn.1
  affix_1_N = mkN "affix" neutrum  ; -- affix..nn.1
  affrikata_1_N = mkN "affrikata" ; -- affrikata..nn.1
  affär_1_N = mkN "affär" "affärer" ; -- affär..nn.1
  affärsavtal_1_N = mkN "affärsavtal" neutrum  ; -- affärsavtal..nn.1
  affärsbank_1_N = mkN "affärsbank" "affärsbanker" ; -- affärsbank..nn.1
  affärsbegåvning_1_N = mkN "affärsbegåvning" ; -- affärsbegåvning..nn.1
  affärsbegåvning_2_N = mkN "affärsbegåvning" ; -- affärsbegåvning..nn.2
  affärsbekant_1_N = mkN "affärsbekant" "affärsbekanten" "affärsbekanta" "affärsbekanterna" ; -- affärsbekant..nn.1
  affärsbiträde_1_N = mkN "affärsbiträde" ; -- affärsbiträde..nn.1
  affärsbrev_1_N = mkN "affärsbrev" neutrum  ; -- affärsbrev..nn.1
  affärsbyrå_1_N = mkN "affärsbyrå" "affärsbyråer" ; -- affärsbyrå..nn.1
  affärscentrum_1_N = mkN "affärscentrum" neutrum  ; -- affärscentrum..nn.1
  affärsdistrikt_1_N = mkN "affärsdistrikt" neutrum  ; -- affärsdistrikt..nn.1
  affärsdrivande_1_A = mkA "affärsdrivande" ; -- affärsdrivande..av.1
  affärsfastighet_1_N = mkN "affärsfastighet" "affärsfastigheter" ; -- affärsfastighet..nn.1
  affärsförbindelse_1_N = mkN "affärsförbindelse" "affärsförbindelser" ; -- affärsförbindelse..nn.1
  affärsföretag_1_N = mkN "affärsföretag" neutrum  ; -- affärsföretag..nn.1
  affärsförslag_1_N = mkN "affärsförslag" neutrum  ; -- affärsförslag..nn.1
  affärsgata_1_N = mkN "affärsgata" ; -- affärsgata..nn.1
  affärsgeni_1_N = mkN "affärsgeni" "affärsgeniet" "affärsgenier" "affärsgenierna" ; -- affärsgeni..nn.1
  affärshandling_1_N = mkN "affärshandling" ; -- affärshandling..nn.1
  affärshuvud_1_N = mkN "affärshuvud" "affärshuvudet" "affärshuvud" "affärshuvudena" ; -- affärshuvud..nn.1
  affärsidé_1_N = mkN "affärsidé" "affärsidéer" ; -- affärsidé..nn.1
  affärskedja_1_N = mkN "affärskedja" ; -- affärskedja..nn.1
  affärskvarter_1_N = mkN "affärskvarter" "affärskvarteret" "affärskvarter" "affärskvarteren" ; -- affärskvarter..nn.1
  affärsliv_1_N = mkN "affärsliv" neutrum  ; -- affärsliv..nn.1
  affärslokal_1_N = mkN "affärslokal" "affärslokaler" ; -- affärslokal..nn.1
  affärsman_1_N = mkN "affärsman" "affärsmannen" "affärsmän" "affärsmännen" ; -- affärsman..nn.1
  affärsmannamässig_1_A = mkA "affärsmannamässig" ; -- affärsmannamässig..av.1
  affärsmoral_1_N = mkN "affärsmoral" ; -- affärsmoral..nn.1
  affärsmässig_1_A = mkA "affärsmässig" ; -- affärsmässig..av.1
  affärsmässig_2_A = mkA "affärsmässig" ; -- affärsmässig..av.2
  affärsmässighet_1_N = mkN "affärsmässighet" ; -- affärsmässighet..nn.1
  affärspapper_1_N = mkN "affärspapper" neutrum  ; -- affärspapper..nn.1
  affärsresa_1_N = mkN "affärsresa" ; -- affärsresa..nn.1
  affärsresenär_1_N = mkN "affärsresenär" "affärsresenärer" ; -- affärsresenär..nn.1
  affärsstil_1_N = mkN "affärsstil" ; -- affärsstil..nn.1
  affärsstråk_1_N = mkN "affärsstråk" neutrum  ; -- affärsstråk..nn.1
  affärsställning_1_N = mkN "affärsställning" ; -- affärsställning..nn.1
  affärstid_1_N = mkN "affärstid" "affärstider" ; -- affärstid..nn.1
  affärstransaktion_1_N = mkN "affärstransaktion" ; -- affärstransaktion..nn.1
  affärsuppgörelse_1_N = mkN "affärsuppgörelse" "affärsuppgörelser" ; -- affärsuppgörelse..nn.1
  affärsverk_1_N = mkN "affärsverk" neutrum  ; -- affärsverk..nn.1
  affärsverksamhet_1_N = mkN "affärsverksamhet" "affärsverksamheter" ; -- affärsverksamhet..nn.1
  affärsvärld_1_N = mkN "affärsvärld" ; -- affärsvärld..nn.1
  afghan_1_N = mkN "afghan" "afghaner" ; -- afghan..nn.1
  afghansk_1_A = mkA "afghansk" ; -- afghansk..av.1
  afghanska_1_N = mkN "afghanska" ; -- afghanska..nn.1
  afghanska_2_N = mkN "afghanska" ; -- afghanska..nn.2
  afibrinogenemi_1_N = mkN "afibrinogenemi" ; -- afibrinogenemi..nn.1
  afoni_1_N = mkN "afoni" ; -- afoni..nn.1
  aforism_1_N = mkN "aforism" "aforismer" ; -- aforism..nn.1
  aforistiker_1_N = mkN "aforistiker" "aforistikern" "aforistiker" "aforistikerna" ; -- aforistiker..nn.1
  aforistisk_1_A = mkA "aforistisk" ; -- aforistisk..av.1
  afrikaans_1_N = mkN "afrikaans" ; -- afrikaans..nn.1
  afrikainspirerad_1_A = mkA "afrikainspirerad" ; -- afrikainspirerad..av.1
  afrikan_1_N = mkN "afrikan" "afrikaner" ; -- afrikan..nn.1
  afrikanisera_1_V = mkV "afrikaniserar" ; -- afrikanisera..vb.1
  afrikaniserande_1_N = mkN "afrikaniserande" ; -- afrikaniserande..nn.1
  afrikaniserbar_1_A = mkA "afrikaniserbar" ; -- afrikaniserbar..av.1
  afrikaniserbarhet_1_N = mkN "afrikaniserbarhet" ; -- afrikaniserbarhet..nn.1
  afrikanisering_1_N = mkN "afrikanisering" ; -- afrikanisering..nn.1
  afrikansk_1_A = mkA "afrikansk" ; -- afrikansk..av.1
  afrikanska_1_N = mkN "afrikanska" ; -- afrikanska..nn.1
  afro_asiatisk_1_A = mkA "afro-asiatisk" ; -- afro-asiatisk..av.1
  afroamerikan_1_N = mkN "afroamerikan" "afroamerikaner" ; -- afroamerikan..nn.1
  afroamerikansk_1_A = mkA "afroamerikansk" ; -- afroamerikansk..av.1
  afroasiatisk_1_A = mkA "afroasiatisk" ; -- afroasiatisk..av.1
  afrodisiakum_1_N = mkN "afrodisiakum" "afrodisiakumet" "afrodisiaka" "afrodisiakana" ; -- afrodisiakum..nn.1
  afrofobi_1_N = mkN "afrofobi" ; -- afrofobi..nn.1
  afrofrisyr_1_N = mkN "afrofrisyr" "afrofrisyrer" ; -- afrofrisyr..nn.1
  afrokam_1_N = mkN "afrokam" "afrokammen" "afrokammar" "afrokammarna" ; -- afrokam..nn.1
  afrosvensk_1_N = mkN "afrosvensk" ; -- afrosvensk..nn.1
  afton_1_N = mkN "afton" "aftonen" "aftnar" "aftnarna" ; -- afton..nn.1
  aftonandakt_1_N = mkN "aftonandakt" "aftonandakter" ; -- aftonandakt..nn.1
  aftonbelysning_1_N = mkN "aftonbelysning" ; -- aftonbelysning..nn.1
  aftonbrasa_1_N = mkN "aftonbrasa" ; -- aftonbrasa..nn.1
  aftonbön_1_N = mkN "aftonbön" "aftonböner" ; -- aftonbön..nn.1
  aftondagg_1_N = mkN "aftondagg" ; -- aftondagg..nn.1
  aftondräkt_1_N = mkN "aftondräkt" "aftondräkter" ; -- aftondräkt..nn.1
  aftonfjäril_1_N = mkN "aftonfjäril" ; -- aftonfjäril..nn.1
  aftongudstjänst_1_N = mkN "aftongudstjänst" "aftongudstjänster" ; -- aftongudstjänst..nn.1
  aftonhandske_1_N = mkN "aftonhandske" utrum  ; -- aftonhandske..nn.1
  aftonhimmel_1_N = mkN "aftonhimmel" ; -- aftonhimmel..nn.1
  aftonklänning_1_N = mkN "aftonklänning" ; -- aftonklänning..nn.1
  aftonkvist_1_N = mkN "aftonkvist" ; -- aftonkvist..nn.1
  aftonkyla_1_N = mkN "aftonkyla" ; -- aftonkyla..nn.1
  aftonluft_1_N = mkN "aftonluft" ; -- aftonluft..nn.1
  aftonmål_1_N = mkN "aftonmål" neutrum  ; -- aftonmål..nn.1
  aftonmåltid_1_N = mkN "aftonmåltid" "aftonmåltider" ; -- aftonmåltid..nn.1
  aftonpipa_1_N = mkN "aftonpipa" ; -- aftonpipa..nn.1
  aftonplenum_1_N = mkN "aftonplenum" neutrum  ; -- aftonplenum..nn.1
  aftonpromenad_1_N = mkN "aftonpromenad" "aftonpromenader" ; -- aftonpromenad..nn.1
  aftonpsalm_1_N = mkN "aftonpsalm" "aftonpsalmer" ; -- aftonpsalm..nn.1
  aftonrodnad_1_N = mkN "aftonrodnad" "aftonrodnader" ; -- aftonrodnad..nn.1
  aftonsamkväm_1_N = mkN "aftonsamkväm" neutrum  ; -- aftonsamkväm..nn.1
  aftonskola_1_N = mkN "aftonskola" ; -- aftonskola..nn.1
  aftonskymning_1_N = mkN "aftonskymning" ; -- aftonskymning..nn.1
  aftonsol_1_N = mkN "aftonsol" ; -- aftonsol..nn.1
  aftonstjärna_1_N = mkN "aftonstjärna" ; -- aftonstjärna..nn.1
  aftonstund_1_N = mkN "aftonstund" "aftonstunder" ; -- aftonstund..nn.1
  aftonstämning_1_N = mkN "aftonstämning" ; -- aftonstämning..nn.1
  aftonsång_1_N = mkN "aftonsång" "aftonsånger" ; -- aftonsång..nn.1
  aftontidning_1_N = mkN "aftontidning" ; -- aftontidning..nn.1
  aftontoalett_1_N = mkN "aftontoalett" "aftontoaletter" ; -- aftontoalett..nn.1
  aftonunderhållning_1_N = mkN "aftonunderhållning" ; -- aftonunderhållning..nn.1
  aftonvard_1_N = mkN "aftonvard" "aftonvarder" ; -- aftonvard..nn.1
  aftonvind_1_N = mkN "aftonvind" ; -- aftonvind..nn.1
  aftonvisit_1_N = mkN "aftonvisit" "aftonvisiter" ; -- aftonvisit..nn.1
  ag_1_N = mkN "ag" ; -- ag..nn.1
  aga_1_N = mkN "aga" ; -- aga..nn.1
  aga_2_N = mkN "aga" ; -- aga..nn.2
  aga_1_V = mkV "agar" ; -- aga..vb.1
  agammaglobulinemi_1_N = mkN "agammaglobulinemi" ; -- agammaglobulinemi..nn.1
  agande_1_N = mkN "agande" ; -- agande..nn.1
  agar_1_N = mkN "agar" neutrum  ; -- agar..nn.1
  agat_1_N = mkN "agat" "agater" ; -- agat..nn.1
  agatglas_1_N = mkN "agatglas" neutrum  ; -- agatglas..nn.1
  agave_1_N = mkN "agave" "agaver" ; -- agave..nn.1
  agenda_1_N = mkN "agenda" ; -- agenda..nn.1
  agens_1_N = mkN "agens" "agenser" ; -- agens..nn.1
  agent_1_N = mkN "agent" "agenter" ; -- agent..nn.1
  agentfilm_1_N = mkN "agentfilm" "agentfilmer" ; -- agentfilm..nn.1
  agentkontor_1_N = mkN "agentkontor" neutrum  ; -- agentkontor..nn.1
  agentskap_1_N = mkN "agentskap" neutrum  ; -- agentskap..nn.1
  agentur_1_N = mkN "agentur" "agenturer" ; -- agentur..nn.1
  agera_1_V = mkV "agerar" ; -- agera..vb.1
  agera_2_V = mkV "agerar" ; -- agera..vb.2
  agerande_1_N = mkN "agerande" ; -- agerande..nn.1
  agerbar_1_A = mkA "agerbar" ; -- agerbar..av.1
  agerbarhet_1_N = mkN "agerbarhet" ; -- agerbarhet..nn.1
  ageusi_1_N = mkN "ageusi" ; -- ageusi..nn.1
  agg_1_N = mkN "agg" neutrum  ; -- agg..nn.1
  aggande_1_A = mkA "aggande" ; -- aggande..av.1
  aggfri_1_A = mkA "aggfri" "aggfritt" ; -- aggfri..av.1
  agglomerat_1_N = mkN "agglomerat" neutrum  ; -- agglomerat..nn.1
  agglomeration_1_N = mkN "agglomeration" ; -- agglomeration..nn.1
  agglomerera_1_V = mkV "agglomererar" ; -- agglomerera..vb.1
  agglomererande_1_N = mkN "agglomererande" ; -- agglomererande..nn.1
  agglomererbar_1_A = mkA "agglomererbar" ; -- agglomererbar..av.1
  agglomererbarhet_1_N = mkN "agglomererbarhet" ; -- agglomererbarhet..nn.1
  agglomerering_1_N = mkN "agglomerering" ; -- agglomerering..nn.1
  agglutination_1_N = mkN "agglutination" ; -- agglutination..nn.1
  agglutinera_1_V = mkV "agglutinerar" ; -- agglutinera..vb.1
  agglutinerande_1_N = mkN "agglutinerande" ; -- agglutinerande..nn.1
  agglutinerbar_1_A = mkA "agglutinerbar" ; -- agglutinerbar..av.1
  agglutinerbarhet_1_N = mkN "agglutinerbarhet" ; -- agglutinerbarhet..nn.1
  agglutinering_1_N = mkN "agglutinering" ; -- agglutinering..nn.1
  aggravera_1_V = mkV "aggraverar" ; -- aggravera..vb.1
  aggregat_1_N = mkN "aggregat" neutrum  ; -- aggregat..nn.1
  aggregation_1_N = mkN "aggregation" ; -- aggregation..nn.1
  aggregationsform_1_N = mkN "aggregationsform" "aggregationsformer" ; -- aggregationsform..nn.1
  aggregationstillstånd_1_N = mkN "aggregationstillstånd" neutrum  ; -- aggregationstillstånd..nn.1
  aggression_1_N = mkN "aggression" ; -- aggression..nn.1
  aggressionsbehov_1_N = mkN "aggressionsbehov" neutrum  ; -- aggressionsbehov..nn.1
  aggressionshämning_1_N = mkN "aggressionshämning" ; -- aggressionshämning..nn.1
  aggressiv_1_A = mkA "aggressiv" ; -- aggressiv..av.1
  aggressivitet_1_N = mkN "aggressivitet" "aggressiviteter" ; -- aggressivitet..nn.1
  agitation_1_N = mkN "agitation" ; -- agitation..nn.1
  agitationsresa_1_N = mkN "agitationsresa" ; -- agitationsresa..nn.1
  agitationsvisa_1_N = mkN "agitationsvisa" ; -- agitationsvisa..nn.1
  agitator_1_N = mkN "agitator" "agitatorer" ; -- agitator..nn.1
  agitatorisk_1_A = mkA "agitatorisk" ; -- agitatorisk..av.1
  agitera_1_V = mkV "agiterar" ; -- agitera..vb.1
  agiterande_1_N = mkN "agiterande" ; -- agiterande..nn.1
  agiterbar_1_A = mkA "agiterbar" ; -- agiterbar..av.1
  agiterbarhet_1_N = mkN "agiterbarhet" ; -- agiterbarhet..nn.1
  agitering_1_N = mkN "agitering" ; -- agitering..nn.1
  agn_1_N = mkN "agn" neutrum  ; -- agn..nn.1
  agna_1_V = mkV "agnar" ; -- agna..vb.1
  agnande_1_N = mkN "agnande" ; -- agnande..nn.1
  agnat_1_N = mkN "agnat" "agnater" ; -- agnat..nn.1
  agnatisk_1_A = mkA "agnatisk" ; -- agnatisk..av.1
  agnblommig_1_A = mkA "agnblommig" ; -- agnblommig..av.1
  agnborst_1_N = mkN "agnborst" neutrum  ; -- agnborst..nn.1
  agnosi_1_N = mkN "agnosi" "agnosier" ; -- agnosi..nn.1
  agnosticism_1_N = mkN "agnosticism" "agnosticismer" ; -- agnosticism..nn.1
  agnostiker_1_N = mkN "agnostiker" "agnostikern" "agnostiker" "agnostikerna" ; -- agnostiker..nn.1
  agnostisk_1_A = mkA "agnostisk" ; -- agnostisk..av.1
  agnrost_1_N = mkN "agnrost" ; -- agnrost..nn.1
  agogik_1_N = mkN "agogik" ; -- agogik..nn.1
  agoni_1_N = mkN "agoni" "agonier" ; -- agoni..nn.1
  agonistisk_1_A = mkA "agonistisk" ; -- agonistisk..av.1
  agorafobi_1_N = mkN "agorafobi" ; -- agorafobi..nn.1
  agraff_1_N = mkN "agraff" "agraffer" ; -- agraff..nn.1
  agrafi_1_N = mkN "agrafi" ; -- agrafi..nn.1
  agranulocytos_1_N = mkN "agranulocytos" ; -- agranulocytos..nn.1
  agrar_1_A = mkA "agrar" ; -- agrar..av.1
  agrar_1_N = mkN "agrar" "agrarer" ; -- agrar..nn.1
  agrarförbund_1_N = mkN "agrarförbund" neutrum  ; -- agrarförbund..nn.1
  agrarkommunistisk_1_A = mkA "agrarkommunistisk" ; -- agrarkommunistisk..av.1
  agrarpolitik_1_N = mkN "agrarpolitik" ; -- agrarpolitik..nn.1
  agreabel_1_A = mkA "agreabel" ; -- agreabel..av.1
  agremang_1_N = mkN "agremang" neutrum  ; -- agremang..nn.1
  agrikultur_1_N = mkN "agrikultur" ; -- agrikultur..nn.1
  agrikulturell_1_A = mkA "agrikulturell" ; -- agrikulturell..av.1
  agrikulturkemi_1_N = mkN "agrikulturkemi" ; -- agrikulturkemi..nn.1
  agronom_1_N = mkN "agronom" "agronomer" ; -- agronom..nn.1
  agronomi_1_N = mkN "agronomi" ; -- agronomi..nn.1
  agronomisk_1_A = mkA "agronomisk" ; -- agronomisk..av.1
  aguti_1_N = mkN "aguti" "agutin" "agutier" "agutierna" ; -- aguti..nn.1
  agyri_1_N = mkN "agyri" ; -- agyri..nn.1
  aha_upplevelse_1_N = mkN "aha-upplevelse" "aha-upplevelser" ; -- aha-upplevelse..nn.1
  ahaupplevelse_1_N = mkN "ahaupplevelse" "ahaupplevelser" ; -- ahaupplevelse..nn.1
  aids_demens_1_N = mkN "aids-demens" "aids-demenser" ; -- aids-demens..nn.1
  aids_1_N = mkN "aids" ; -- aids..nn.1
  aidsmedicin_1_N = mkN "aidsmedicin" "aidsmediciner" ; -- aidsmedicin..nn.1
  aidspanik_1_N = mkN "aidspanik" "aidspaniker" ; -- aidspanik..nn.1
  aidssjuk_1_A = mkA "aidssjuk" ; -- aidssjuk..av.1
  aikido_1_N = mkN "aikido" ; -- aikido..nn.1
  aikidotrick_1_N = mkN "aikidotrick" neutrum  ; -- aikidotrick..nn.1
  air_1_N = mkN "air" "airer" ; -- air..nn.1
  airbag_1_N = mkN "airbag" ; -- airbag..nn.1
  airbagsensor_1_N = mkN "airbagsensor" "airbagsensorer" ; -- airbagsensor..nn.1
  airdaleterrier_1_N = mkN "airdaleterrier" "airdaleterriern" "airdaleterrier" "airdaleterrierna" ; -- airdaleterrier..nn.1
  ajour_1_A = mkA "ajour" ; -- ajour..av.1
  ajournera_1_V = mkV "ajournerar" ; -- ajournera..vb.1
  ajournerande_1_N = mkN "ajournerande" ; -- ajournerande..nn.1
  ajournerbar_1_A = mkA "ajournerbar" ; -- ajournerbar..av.1
  ajournerbarhet_1_N = mkN "ajournerbarhet" ; -- ajournerbarhet..nn.1
  ajournering_1_N = mkN "ajournering" ; -- ajournering..nn.1
  ajowain_1_N = mkN "ajowain" ; -- ajowain..nn.1
  ajowan_1_N = mkN "ajowan" ; -- ajowan..nn.1
  ajwain_1_N = mkN "ajwain" ; -- ajwain..nn.1
  ajwan_1_N = mkN "ajwan" ; -- ajwan..nn.1
  akacia_1_N = mkN "akacia" ; -- akacia..nn.1
  akademi_1_N = mkN "akademi" "akademier" ; -- akademi..nn.1
  akademiker_1_N = mkN "akademiker" "akademikern" "akademiker" "akademikerna" ; -- akademiker..nn.1
  akademisk_1_A = mkA "akademisk" ; -- akademisk..av.1
  akademist_1_N = mkN "akademist" "akademister" ; -- akademist..nn.1
  akant_1_N = mkN "akant" "akanter" ; -- akant..nn.1
  akantolys_1_N = mkN "akantolys" "akantolyser" ; -- akantolys..nn.1
  akantom_1_N = mkN "akantom" neutrum  ; -- akantom..nn.1
  akantus_1_N = mkN "akantus" ; -- akantus..nn.1
  akantusblad_1_N = mkN "akantusblad" neutrum  ; -- akantusblad..nn.1
  akatalasemi_1_N = mkN "akatalasemi" ; -- akatalasemi..nn.1
  akatalektisk_1_A = mkA "akatalektisk" ; -- akatalektisk..av.1
  akilleshäl_1_N = mkN "akilleshäl" ; -- akilleshäl..nn.1
  akillessena_1_N = mkN "akillessena" ; -- akillessena..nn.1
  akleja_1_N = mkN "akleja" ; -- akleja..nn.1
  aklorhydri_1_N = mkN "aklorhydri" ; -- aklorhydri..nn.1
  akne_1_N = mkN "akne" utrum  ; -- akne..nn.1
  akneiformutslag_1_N = mkN "akneiformutslag" neutrum  ; -- akneiformutslag..nn.1
  akondroplasi_1_N = mkN "akondroplasi" ; -- akondroplasi..nn.1
  akribi_1_N = mkN "akribi" ; -- akribi..nn.1
  akro_osteolys_1_N = mkN "akro-osteolys" "akro-osteolyser" ; -- akro-osteolys..nn.1
  akrobat_1_N = mkN "akrobat" "akrobater" ; -- akrobat..nn.1
  akrobatik_1_N = mkN "akrobatik" ; -- akrobatik..nn.1
  akrobatisk_1_A = mkA "akrobatisk" ; -- akrobatisk..av.1
  akrobatisk_2_A = mkA "akrobatisk" ; -- akrobatisk..av.2
  akrocefali_1_N = mkN "akrocefali" ; -- akrocefali..nn.1
  akrocefalosyndaktyli_1_N = mkN "akrocefalosyndaktyli" ; -- akrocefalosyndaktyli..nn.1
  akrodermatit_1_N = mkN "akrodermatit" "akrodermatiter" ; -- akrodermatit..nn.1
  akrodyni_1_N = mkN "akrodyni" ; -- akrodyni..nn.1
  akromatisk_1_A = mkA "akromatisk" ; -- akromatisk..av.1
  akromegali_1_N = mkN "akromegali" "akromegalier" ; -- akromegali..nn.1
  akronym_1_N = mkN "akronym" "akronymer" ; -- akronym..nn.1
  akropol_1_N = mkN "akropol" "akropoler" ; -- akropol..nn.1
  akrospirom_1_N = mkN "akrospirom" neutrum  ; -- akrospirom..nn.1
  akrostikon_1_N = mkN "akrostikon" neutrum  ; -- akrostikon..nn.1
  akroterion_1_N = mkN "akroterion" "akroterion" "akroterier" "akroterierna" ; -- akroterion..nn.1
  akryl_1_N = mkN "akryl" ; -- akryl..nn.1
  akt_1_N = mkN "akt" "akter" ; -- akt..nn.1
  akta_1_V = mkV "aktar" ; -- akta..vb.1
  akta_2_V = mkV "aktar" ; -- akta..vb.2
  aktande_1_N = mkN "aktande" ; -- aktande..nn.1
  aktant_1_N = mkN "aktant" "aktanter" ; -- aktant..nn.1
  akter_1_N = mkN "akter" ; -- akter..nn.1
  akterdel_1_N = mkN "akterdel" "akterdelen" "akterdelar" "akterdelarna" ; -- akterdel..nn.1
  akterdäck_1_N = mkN "akterdäck" neutrum  ; -- akterdäck..nn.1
  akterhytt_1_N = mkN "akterhytt" "akterhytter" ; -- akterhytt..nn.1
  akterkastell_1_N = mkN "akterkastell" neutrum  ; -- akterkastell..nn.1
  akterlig_1_A = mkA "akterlig" ; -- akterlig..av.1
  akterlik_1_N = mkN "akterlik" neutrum  ; -- akterlik..nn.1
  aktersalong_1_N = mkN "aktersalong" "aktersalonger" ; -- aktersalong..nn.1
  aktersegel_1_N = mkN "aktersegel" neutrum  ; -- aktersegel..nn.1
  akterseglad_1_A = mkA "akterseglad" ; -- akterseglad..av.1
  akterskepp_1_N = mkN "akterskepp" neutrum  ; -- akterskepp..nn.1
  aktersnurra_1_N = mkN "aktersnurra" ; -- aktersnurra..nn.1
  akterspegel_1_N = mkN "akterspegel" ; -- akterspegel..nn.1
  akterst_1_Adv = mkAdv "akterst" ; -- akterst..ab.1
  akterstäv_1_N = mkN "akterstäv" ; -- akterstäv..nn.1
  akterut_1_Adv = mkAdv "akterut" ; -- akterut..ab.1
  akterända_1_N = mkN "akterända" ; -- akterända..nn.1
  akteröver_1_Adv = mkAdv "akteröver" ; -- akteröver..ab.1
  aktförklaring_1_N = mkN "aktförklaring" ; -- aktförklaring..nn.1
  aktgivning_1_N = mkN "aktgivning" ; -- aktgivning..nn.1
  aktie_1_N = mkN "aktie" "aktier" ; -- aktie..nn.1
  aktiebolag_1_N = mkN "aktiebolag" neutrum  ; -- aktiebolag..nn.1
  aktiebrev_1_N = mkN "aktiebrev" neutrum  ; -- aktiebrev..nn.1
  aktiebubbla_1_N = mkN "aktiebubbla" ; -- aktiebubbla..nn.1
  aktiebörs_1_N = mkN "aktiebörs" "aktiebörser" ; -- aktiebörs..nn.1
  aktieemission_1_N = mkN "aktieemission" ; -- aktieemission..nn.1
  aktiefond_1_N = mkN "aktiefond" "aktiefonder" ; -- aktiefond..nn.1
  aktiehandel_1_N = mkN "aktiehandel" ; -- aktiehandel..nn.1
  aktieinnehav_1_N = mkN "aktieinnehav" neutrum  ; -- aktieinnehav..nn.1
  aktiekapital_1_N = mkN "aktiekapital" neutrum  ; -- aktiekapital..nn.1
  aktiekupong_1_N = mkN "aktiekupong" "aktiekuponger" ; -- aktiekupong..nn.1
  aktiekurs_1_N = mkN "aktiekurs" "aktiekurser" ; -- aktiekurs..nn.1
  aktiemajoritet_1_N = mkN "aktiemajoritet" "aktiemajoriteter" ; -- aktiemajoritet..nn.1
  aktiemarknad_1_N = mkN "aktiemarknad" "aktiemarknader" ; -- aktiemarknad..nn.1
  aktieportfölj_1_N = mkN "aktieportfölj" "aktieportföljer" ; -- aktieportfölj..nn.1
  aktiepost_1_N = mkN "aktiepost" "aktieposter" ; -- aktiepost..nn.1
  aktiespara_1_V = mkV "aktiesparar" ; -- aktiespara..vb.1
  aktiesparande_1_N = mkN "aktiesparande" ; -- aktiesparande..nn.1
  aktiesparare_1_N = mkN "aktiesparare" utrum  ; -- aktiesparare..nn.1
  aktiesparklubb_1_N = mkN "aktiesparklubb" ; -- aktiesparklubb..nn.1
  aktiestock_1_N = mkN "aktiestock" ; -- aktiestock..nn.1
  aktieutdelning_1_N = mkN "aktieutdelning" ; -- aktieutdelning..nn.1
  aktievinst_1_N = mkN "aktievinst" "aktievinster" ; -- aktievinst..nn.1
  aktieägande_1_N = mkN "aktieägande" ; -- aktieägande..nn.1
  aktieägare_1_N = mkN "aktieägare" utrum  ; -- aktieägare..nn.1
  aktindelning_1_N = mkN "aktindelning" ; -- aktindelning..nn.1
  aktinium_1_N = mkN "aktinium" neutrum  ; -- aktinium..nn.1
  aktinobacillos_1_N = mkN "aktinobacillos" ; -- aktinobacillos..nn.1
  aktinomykos_1_N = mkN "aktinomykos" ; -- aktinomykos..nn.1
  aktion_1_N = mkN "aktion" ; -- aktion..nn.1
  aktionistisk_1_A = mkA "aktionistisk" ; -- aktionistisk..av.1
  aktionsart_1_N = mkN "aktionsart" "aktionsarter" ; -- aktionsart..nn.1
  aktionsgrupp_1_N = mkN "aktionsgrupp" "aktionsgrupper" ; -- aktionsgrupp..nn.1
  aktionsplan_1_N = mkN "aktionsplan" "aktionsplaner" ; -- aktionsplan..nn.1
  aktionsradie_1_N = mkN "aktionsradie" "aktionsradier" ; -- aktionsradie..nn.1
  aktionsström_1_N = mkN "aktionsström" "aktionsströmmen" "aktionsströmmar" "aktionsströmmarna" ; -- aktionsström..nn.1
  aktionssätt_1_N = mkN "aktionssätt" neutrum  ; -- aktionssätt..nn.1
  aktionsturbin_1_N = mkN "aktionsturbin" "aktionsturbiner" ; -- aktionsturbin..nn.1
  aktiv_1_A = mkA "aktiv" ; -- aktiv..av.1
  aktiva_1_N = mkN "aktiva" "aktivan" "aktiva" "aktivana" ; -- aktiva..nn.1
  aktivera_1_V = mkV "aktiverar" ; -- aktivera..vb.1
  aktiverande_1_N = mkN "aktiverande" ; -- aktiverande..nn.1
  aktiverbar_1_A = mkA "aktiverbar" ; -- aktiverbar..av.1
  aktiverbarhet_1_N = mkN "aktiverbarhet" ; -- aktiverbarhet..nn.1
  aktivering_1_N = mkN "aktivering" ; -- aktivering..nn.1
  aktiveringsmönster_1_N = mkN "aktiveringsmönster" neutrum  ; -- aktiveringsmönster..nn.1
  aktivism_1_N = mkN "aktivism" "aktivismer" ; -- aktivism..nn.1
  aktivist_1_N = mkN "aktivist" "aktivister" ; -- aktivist..nn.1
  aktivistisk_1_A = mkA "aktivistisk" ; -- aktivistisk..av.1
  aktivitet_1_N = mkN "aktivitet" "aktiviteter" ; -- aktivitet..nn.1
  aktivitetsersättning_1_N = mkN "aktivitetsersättning" ; -- aktivitetsersättning..nn.1
  aktivum_1_N = mkN "aktivum" "aktivum" "aktiver" "aktiverna" ; -- aktivum..nn.1
  aktning_1_N = mkN "aktning" ; -- aktning..nn.1
  aktningsbetygelse_1_N = mkN "aktningsbetygelse" "aktningsbetygelser" ; -- aktningsbetygelse..nn.1
  aktningsbevis_1_N = mkN "aktningsbevis" neutrum  ; -- aktningsbevis..nn.1
  aktningsfull_1_A = mkA "aktningsfull" ; -- aktningsfull..av.1
  aktningsfullhet_1_N = mkN "aktningsfullhet" ; -- aktningsfullhet..nn.1
  aktningsvärd_1_A = mkA "aktningsvärd" "aktningsvärt" ; -- aktningsvärd..av.1
  aktningsvärdhet_1_N = mkN "aktningsvärdhet" ; -- aktningsvärdhet..nn.1
  aktor_1_N = mkN "aktor" "aktorer" ; -- aktor..nn.1
  aktris_1_N = mkN "aktris" "aktriser" ; -- aktris..nn.1
  aktsam_1_A = mkA "aktsam" "aktsamt" "aktsamma" "aktsamma" "aktsammare" "aktsammast" "aktsammaste" ; -- aktsam..av.1
  aktsamhet_1_N = mkN "aktsamhet" "aktsamheter" ; -- aktsamhet..nn.1
  aktsamhetsplikt_1_N = mkN "aktsamhetsplikt" "aktsamhetsplikter" ; -- aktsamhetsplikt..nn.1
  aktslut_1_N = mkN "aktslut" neutrum  ; -- aktslut..nn.1
  aktstycke_1_N = mkN "aktstycke" ; -- aktstycke..nn.1
  aktualisation_1_N = mkN "aktualisation" ; -- aktualisation..nn.1
  aktualisera_1_V = mkV "aktualiserar" ; -- aktualisera..vb.1
  aktualiserande_1_N = mkN "aktualiserande" ; -- aktualiserande..nn.1
  aktualiserbar_1_A = mkA "aktualiserbar" ; -- aktualiserbar..av.1
  aktualiserbarhet_1_N = mkN "aktualiserbarhet" ; -- aktualiserbarhet..nn.1
  aktualisering_1_N = mkN "aktualisering" ; -- aktualisering..nn.1
  aktualism_1_N = mkN "aktualism" ; -- aktualism..nn.1
  aktualistisk_1_A = mkA "aktualistisk" ; -- aktualistisk..av.1
  aktualitet_1_N = mkN "aktualitet" "aktualiteter" ; -- aktualitet..nn.1
  aktualitetspress_1_N = mkN "aktualitetspress" ; -- aktualitetspress..nn.1
  aktuarie_1_N = mkN "aktuarie" "aktuarier" ; -- aktuarie..nn.1
  aktuell_1_A = mkA "aktuell" ; -- aktuell..av.1
  aktör_1_N = mkN "aktör" "aktörer" ; -- aktör..nn.1
  akupunktur_1_N = mkN "akupunktur" ; -- akupunktur..nn.1
  akupunktör_1_N = mkN "akupunktör" "akupunktörer" ; -- akupunktör..nn.1
  akustik_1_N = mkN "akustik" ; -- akustik..nn.1
  akustiker_1_N = mkN "akustiker" "akustikern" "akustiker" "akustikerna" ; -- akustiker..nn.1
  akustikplatta_1_N = mkN "akustikplatta" ; -- akustikplatta..nn.1
  akustikusneurinom_1_N = mkN "akustikusneurinom" neutrum  ; -- akustikusneurinom..nn.1
  akustisk_1_A = mkA "akustisk" ; -- akustisk..av.1
  akut_1_Adv = mkAdv "akut" ; -- akut..ab.1
  akut_1_A = mkA "akut" "akut" ; -- akut..av.1
  akut_1_N = mkN "akut" "akuter" ; -- akut..nn.1
  akutavdelning_1_N = mkN "akutavdelning" ; -- akutavdelning..nn.1
  akutfall_1_N = mkN "akutfall" neutrum  ; -- akutfall..nn.1
  akutfasreaktion_1_N = mkN "akutfasreaktion" ; -- akutfasreaktion..nn.1
  akuthjälp_1_N = mkN "akuthjälp" ; -- akuthjälp..nn.1
  akutmottagning_1_N = mkN "akutmottagning" ; -- akutmottagning..nn.1
  akutopererad_1_A = mkA "akutopererad" ; -- akutopererad..av.1
  akutvård_1_N = mkN "akutvård" ; -- akutvård..nn.1
  akutvårdsdata_1_N = mkN "akutvårdsdata" "akutvårdsdatat" "akutvårdsdata" "akutvårdsdatana" ; -- akutvårdsdata..nn.1
  akvakultur_1_N = mkN "akvakultur" "akvakulturer" ; -- akvakultur..nn.1
  akvamarin_1_N = mkN "akvamarin" "akvamariner" ; -- akvamarin..nn.1
  akvanaut_1_N = mkN "akvanaut" "akvanauter" ; -- akvanaut..nn.1
  akvaplaning_1_N = mkN "akvaplaning" ; -- akvaplaning..nn.1
  akvarell_1_N = mkN "akvarell" "akvareller" ; -- akvarell..nn.1
  akvarellfärg_1_N = mkN "akvarellfärg" "akvarellfärger" ; -- akvarellfärg..nn.1
  akvarellist_1_N = mkN "akvarellist" "akvarellister" ; -- akvarellist..nn.1
  akvarellmålare_1_N = mkN "akvarellmålare" utrum  ; -- akvarellmålare..nn.1
  akvarelltryck_1_N = mkN "akvarelltryck" neutrum  ; -- akvarelltryck..nn.1
  akvarellutställning_1_N = mkN "akvarellutställning" ; -- akvarellutställning..nn.1
  akvariefisk_1_N = mkN "akvariefisk" ; -- akvariefisk..nn.1
  akvaristik_1_N = mkN "akvaristik" ; -- akvaristik..nn.1
  akvaristisk_1_A = mkA "akvaristisk" ; -- akvaristisk..av.1
  akvarium_1_N = mkN "akvarium" "akvariet" "akvarier" "akvarierna" ; -- akvarium..nn.1
  akvatint_1_N = mkN "akvatint" "akvatinter" ; -- akvatint..nn.1
  akvatisk_1_A = mkA "akvatisk" ; -- akvatisk..av.1
  akvavit_1_N = mkN "akvavit" "akvaviter" ; -- akvavit..nn.1
  akvedukt_1_N = mkN "akvedukt" "akvedukter" ; -- akvedukt..nn.1
  al_1_N = mkN "al" ; -- al..nn.1
  alabaster_1_N = mkN "alabaster" ; -- alabaster..nn.1
  alabasterliknande_1_A = mkA "alabasterliknande" ; -- alabasterliknande..av.1
  alabastervit_1_A = mkA "alabastervit" ; -- alabastervit..av.1
  aladåb_1_N = mkN "aladåb" "aladåber" ; -- aladåb..nn.1
  alagreck_1_N = mkN "alagreck" "alagrecker" ; -- alagreck..nn.1
  alan_1_N = mkN "alan" "alaner" ; -- alan..nn.1
  alanin_1_N = mkN "alanin" neutrum  ; -- alanin..nn.1
  alant_1_N = mkN "alant" "alanter" ; -- alant..nn.1
  alarm_1_N = mkN "alarm" neutrum  ; -- alarm..nn.1
  alarm_2_N = mkN "alarm" neutrum  ; -- alarm..nn.2
  alarmanordning_1_N = mkN "alarmanordning" ; -- alarmanordning..nn.1
  alarmera_1_V = mkV "alarmerar" ; -- alarmera..vb.1
  alarmerande_1_A = mkA "alarmerande" ; -- alarmerande..av.1
  alarmerande_1_N = mkN "alarmerande" ; -- alarmerande..nn.1
  alarmerbar_1_A = mkA "alarmerbar" ; -- alarmerbar..av.1
  alarmerbarhet_1_N = mkN "alarmerbarhet" ; -- alarmerbarhet..nn.1
  alarmering_1_N = mkN "alarmering" ; -- alarmering..nn.1
  alarmism_1_N = mkN "alarmism" ; -- alarmism..nn.1
  alarmist_1_N = mkN "alarmist" "alarmister" ; -- alarmist..nn.1
  alarmistisk_1_A = mkA "alarmistisk" ; -- alarmistisk..av.1
  alarmklocka_1_N = mkN "alarmklocka" ; -- alarmklocka..nn.1
  alarmsignal_1_N = mkN "alarmsignal" "alarmsignaler" ; -- alarmsignal..nn.1
  alarmskott_1_N = mkN "alarmskott" neutrum  ; -- alarmskott..nn.1
  alarmtrumma_1_N = mkN "alarmtrumma" ; -- alarmtrumma..nn.1
  alba_1_N = mkN "alba" ; -- alba..nn.1
  alban_1_N = mkN "alban" "albaner" ; -- alban..nn.1
  albansk_1_A = mkA "albansk" ; -- albansk..av.1
  albanska_1_N = mkN "albanska" ; -- albanska..nn.1
  albanska_2_N = mkN "albanska" ; -- albanska..nn.2
  albatross_1_N = mkN "albatross" "albatrosser" ; -- albatross..nn.1
  albigens_1_N = mkN "albigens" "albigenser" ; -- albigens..nn.1
  albigenser_1_N = mkN "albigenser" "albigensern" "albigenser" "albigenserna" ; -- albigenser..nn.1
  albigensisk_1_A = mkA "albigensisk" ; -- albigensisk..av.1
  albinism_1_N = mkN "albinism" "albinismer" ; -- albinism..nn.1
  albinistisk_1_A = mkA "albinistisk" ; -- albinistisk..av.1
  albino_1_N = mkN "albino" "albinon" "albinos" "albinosarna" ; -- albino..nn.1
  album_1_N = mkN "album" neutrum  ; -- album..nn.1
  albumin_1_N = mkN "albumin" "albuminer" ; -- albumin..nn.1
  albuminuri_1_N = mkN "albuminuri" ; -- albuminuri..nn.1
  albuske_1_N = mkN "albuske" utrum  ; -- albuske..nn.1
  albyl_1_N = mkN "albyl" "albylen" "albyl" "albylen" ; -- albyl..nn.1
  alcantara_1_N = mkN "alcantara" ; -- alcantara..nn.1
  aldehyd_1_N = mkN "aldehyd" "aldehyder" ; -- aldehyd..nn.1
  aldrig_1_Adv = mkAdv "aldrig" ; -- aldrig..ab.1
  ale_1_N = mkN "ale" ; -- ale..nn.1
  alemann_1_N = mkN "alemann" "alemanner" ; -- alemann..nn.1
  alert_1_A = mkA "alert" "alert" ; -- alert..av.1
  alexanderhugg_1_N = mkN "alexanderhugg" neutrum  ; -- alexanderhugg..nn.1
  alexandrin_1_N = mkN "alexandrin" "alexandriner" ; -- alexandrin..nn.1
  alexandrinsk_1_A = mkA "alexandrinsk" ; -- alexandrinsk..av.1
  alexi_1_N = mkN "alexi" "alexier" ; -- alexi..nn.1
  alf_1_N = mkN "alf" "alfer" ; -- alf..nn.1
  alfa_1_N = mkN "alfa" "alfat" "alfan" "alfana" ; -- alfa..nn.1
  alfabet_1_N = mkN "alfabet" neutrum  ; -- alfabet..nn.1
  alfabetisera_1_V = mkV "alfabetiserar" ; -- alfabetisera..vb.1
  alfabetiserande_1_N = mkN "alfabetiserande" ; -- alfabetiserande..nn.1
  alfabetiserbar_1_A = mkA "alfabetiserbar" ; -- alfabetiserbar..av.1
  alfabetiserbarhet_1_N = mkN "alfabetiserbarhet" ; -- alfabetiserbarhet..nn.1
  alfabetisering_1_N = mkN "alfabetisering" ; -- alfabetisering..nn.1
  alfabetisk_1_A = mkA "alfabetisk" ; -- alfabetisk..av.1
  alfahanne_1_N = mkN "alfahanne" utrum  ; -- alfahanne..nn.1
  alfalfa_1_N = mkN "alfalfa" ; -- alfalfa..nn.1
  alfamannosidos_1_N = mkN "alfamannosidos" ; -- alfamannosidos..nn.1
  alfametyltyrosin_1_N = mkN "alfametyltyrosin" "alfametyltyrosiner" ; -- alfametyltyrosin..nn.1
  alfanumerisk_1_A = mkA "alfanumerisk" ; -- alfanumerisk..av.1
  alfapartikel_1_N = mkN "alfapartikel" ; -- alfapartikel..nn.1
  alfapet_1_N = mkN "alfapet" neutrum  ; -- alfapet..nn.1
  alfastrålning_1_N = mkN "alfastrålning" ; -- alfastrålning..nn.1
  alfasönderfall_1_N = mkN "alfasönderfall" neutrum  ; -- alfasönderfall..nn.1
  alfatalassemi_1_N = mkN "alfatalassemi" ; -- alfatalassemi..nn.1
  alfavirusinfektion_1_N = mkN "alfavirusinfektion" ; -- alfavirusinfektion..nn.1
  alfkors_1_N = mkN "alfkors" neutrum  ; -- alfkors..nn.1
  alfons_1_N = mkN "alfons" "alfonser" ; -- alfons..nn.1
  alfågel_1_N = mkN "alfågel" ; -- alfågel..nn.1
  alfågelskytte_1_N = mkN "alfågelskytte" ; -- alfågelskytte..nn.1
  alförrädare_1_N = mkN "alförrädare" utrum  ; -- alförrädare..nn.1
  alg_1_N = mkN "alg" "alger" ; -- alg..nn.1
  algblomning_1_N = mkN "algblomning" ; -- algblomning..nn.1
  algebra_1_N = mkN "algebra" ; -- algebra..nn.1
  algebraiker_1_N = mkN "algebraiker" "algebraikern" "algebraiker" "algebraikerna" ; -- algebraiker..nn.1
  algebraisk_1_A = mkA "algebraisk" ; -- algebraisk..av.1
  algerier_1_N = mkN "algerier" "algeriern" "algerier" "algerierna" ; -- algerier..nn.1
  algerisk_1_A = mkA "algerisk" ; -- algerisk..av.1
  algeriska_1_N = mkN "algeriska" ; -- algeriska..nn.1
  algmatta_1_N = mkN "algmatta" ; -- algmatta..nn.1
  algolog_1_N = mkN "algolog" "algologer" ; -- algolog..nn.1
  algologi_1_N = mkN "algologi" ; -- algologi..nn.1
  algologisk_1_A = mkA "algologisk" ; -- algologisk..av.1
  algonk_1_N = mkN "algonk" ; -- algonk..nn.1
  algoritm_1_N = mkN "algoritm" "algoritmer" ; -- algoritm..nn.1
  algren_1_N = mkN "algren" "algrenen" "algrenar" "algrenarna" ; -- algren..nn.1
  algtvätt_1_N = mkN "algtvätt" ; -- algtvätt..nn.1
  alibi_1_N = mkN "alibi" "alibit" "alibin" "alibina" ; -- alibi..nn.1
  alibibevis_1_N = mkN "alibibevis" neutrum  ; -- alibibevis..nn.1
  alibistisk_1_A = mkA "alibistisk" ; -- alibistisk..av.1
  alienation_1_N = mkN "alienation" ; -- alienation..nn.1
  alienationsupplevelse_1_N = mkN "alienationsupplevelse" "alienationsupplevelser" ; -- alienationsupplevelse..nn.1
  alienera_1_V = mkV "alienerar" ; -- alienera..vb.1
  alienerande_1_N = mkN "alienerande" ; -- alienerande..nn.1
  alienerbar_1_A = mkA "alienerbar" ; -- alienerbar..av.1
  alienerbarhet_1_N = mkN "alienerbarhet" ; -- alienerbarhet..nn.1
  alienering_1_N = mkN "alienering" ; -- alienering..nn.1
  alifatisk_1_A = mkA "alifatisk" ; -- alifatisk..av.1
  alika_1_N = mkN "alika" ; -- alika..nn.1
  alimentär_1_A = mkA "alimentär" ; -- alimentär..av.1
  alisarin_1_N = mkN "alisarin" ; -- alisarin..nn.1
  alka_1_N = mkN "alka" ; -- alka..nn.1
  alkaisk_1_A = mkA "alkaisk" ; -- alkaisk..av.1
  alkali_1_N = mkN "alkali" "alkalit" "alkalier" "alkalierna" ; -- alkali..nn.1
  alkaliblått_1_N = mkN "alkaliblått" ; -- alkaliblått..nn.1
  alkalilut_1_N = mkN "alkalilut" ; -- alkalilut..nn.1
  alkalimetall_1_N = mkN "alkalimetall" "alkalimetaller" ; -- alkalimetall..nn.1
  alkalisk_1_A = mkA "alkalisk" ; -- alkalisk..av.1
  alkaloid_1_N = mkN "alkaloid" "alkaloider" ; -- alkaloid..nn.1
  alkalos_1_N = mkN "alkalos" "alkaloser" ; -- alkalos..nn.1
  alkan_1_N = mkN "alkan" "alkaner" ; -- alkan..nn.1
  alkanna_1_N = mkN "alkanna" ; -- alkanna..nn.1
  alkanol_1_N = mkN "alkanol" "alkanoler" ; -- alkanol..nn.1
  alkaptonuri_1_N = mkN "alkaptonuri" ; -- alkaptonuri..nn.1
  alkekung_1_N = mkN "alkekung" ; -- alkekung..nn.1
  alkemi_1_N = mkN "alkemi" ; -- alkemi..nn.1
  alkemisk_1_A = mkA "alkemisk" ; -- alkemisk..av.1
  alkemist_1_N = mkN "alkemist" "alkemister" ; -- alkemist..nn.1
  alkemistisk_1_A = mkA "alkemistisk" ; -- alkemistisk..av.1
  alkfågel_1_N = mkN "alkfågel" ; -- alkfågel..nn.1
  alkis_1_N = mkN "alkis" ; -- alkis..nn.1
  alkohol_1_N = mkN "alkohol" "alkoholer" ; -- alkohol..nn.1
  alkoholabstinens_1_N = mkN "alkoholabstinens" ; -- alkoholabstinens..nn.1
  alkoholabstinensanfall_1_N = mkN "alkoholabstinensanfall" neutrum  ; -- alkoholabstinensanfall..nn.1
  alkoholberusning_1_N = mkN "alkoholberusning" ; -- alkoholberusning..nn.1
  alkoholcirrhos_1_N = mkN "alkoholcirrhos" "alkoholcirrhoser" ; -- alkoholcirrhos..nn.1
  alkoholcirros_1_N = mkN "alkoholcirros" "alkoholcirroser" ; -- alkoholcirros..nn.1
  alkoholfri_1_A = mkA "alkoholfri" "alkoholfritt" ; -- alkoholfri..av.1
  alkoholförbud_1_N = mkN "alkoholförbud" neutrum  ; -- alkoholförbud..nn.1
  alkoholförgiftning_1_N = mkN "alkoholförgiftning" ; -- alkoholförgiftning..nn.1
  alkoholförtäring_1_N = mkN "alkoholförtäring" ; -- alkoholförtäring..nn.1
  alkoholhalt_1_N = mkN "alkoholhalt" "alkoholhalter" ; -- alkoholhalt..nn.1
  alkoholhaltig_1_A = mkA "alkoholhaltig" ; -- alkoholhaltig..av.1
  alkoholinnehav_1_N = mkN "alkoholinnehav" neutrum  ; -- alkoholinnehav..nn.1
  alkoholintoxikation_1_N = mkN "alkoholintoxikation" ; -- alkoholintoxikation..nn.1
  alkoholiserad_1_A = mkA "alkoholiserad" ; -- alkoholiserad..av.1
  alkoholisk_1_A = mkA "alkoholisk" ; -- alkoholisk..av.1
  alkoholism_1_N = mkN "alkoholism" "alkoholismer" ; -- alkoholism..nn.1
  alkoholist_1_N = mkN "alkoholist" "alkoholister" ; -- alkoholist..nn.1
  alkoholistanstalt_1_N = mkN "alkoholistanstalt" "alkoholistanstalter" ; -- alkoholistanstalt..nn.1
  alkoholistisk_1_A = mkA "alkoholistisk" ; -- alkoholistisk..av.1
  alkoholkardiomyopati_1_N = mkN "alkoholkardiomyopati" "alkoholkardiomyopatier" ; -- alkoholkardiomyopati..nn.1
  alkoholkonsumtion_1_N = mkN "alkoholkonsumtion" ; -- alkoholkonsumtion..nn.1
  alkoholmissbruk_1_N = mkN "alkoholmissbruk" neutrum  ; -- alkoholmissbruk..nn.1
  alkoholmissbrukande_1_N = mkN "alkoholmissbrukande" ; -- alkoholmissbrukande..nn.1
  alkoholmissbrukare_1_N = mkN "alkoholmissbrukare" utrum  ; -- alkoholmissbrukare..nn.1
  alkoholneuropati_1_N = mkN "alkoholneuropati" "alkoholneuropatier" ; -- alkoholneuropati..nn.1
  alkoholometer_1_N = mkN "alkoholometer" ; -- alkoholometer..nn.1
  alkoholpolicy_1_N = mkN "alkoholpolicy" "alkoholpolicyn" "alkoholpolicysar" "alkoholpolicysarna" ; -- alkoholpolicy..nn.1
  alkoholpolitik_1_N = mkN "alkoholpolitik" ; -- alkoholpolitik..nn.1
  alkoholpolitisk_1_A = mkA "alkoholpolitisk" ; -- alkoholpolitisk..av.1
  alkoholpsykos_1_N = mkN "alkoholpsykos" "alkoholpsykoser" ; -- alkoholpsykos..nn.1
  alkoholpåverkad_1_A = mkA "alkoholpåverkad" ; -- alkoholpåverkad..av.1
  alkoholrelaterad_1_A = mkA "alkoholrelaterad" ; -- alkoholrelaterad..av.1
  alkoholskada_1_N = mkN "alkoholskada" ; -- alkoholskada..nn.1
  alkoholskatt_1_N = mkN "alkoholskatt" "alkoholskatter" ; -- alkoholskatt..nn.1
  alkoholstark_1_A = mkA "alkoholstark" ; -- alkoholstark..av.1
  alkoholstyrka_1_N = mkN "alkoholstyrka" ; -- alkoholstyrka..nn.1
  alkoholsvag_1_A = mkA "alkoholsvag" ; -- alkoholsvag..av.1
  alkoholsvaghet_1_N = mkN "alkoholsvaghet" ; -- alkoholsvaghet..nn.1
  alkoholtest_1_N = mkN "alkoholtest" neutrum  ; -- alkoholtest..nn.1
  alkoholvana_1_N = mkN "alkoholvana" ; -- alkoholvana..nn.1
  alkolås_1_N = mkN "alkolås" neutrum  ; -- alkolås..nn.1
  alkotest_1_N = mkN "alkotest" neutrum  ; -- alkotest..nn.1
  alkotte_1_N = mkN "alkotte" utrum  ; -- alkotte..nn.1
  alkov_1_N = mkN "alkov" "alkover" ; -- alkov..nn.1
  alkovsäng_1_N = mkN "alkovsäng" ; -- alkovsäng..nn.1
  alkyd_1_N = mkN "alkyd" "alkyder" ; -- alkyd..nn.1
  alkyl_1_N = mkN "alkyl" "alkyler" ; -- alkyl..nn.1
  alkyn_1_N = mkN "alkyn" "alkyner" ; -- alkyn..nn.1
  alla_1_N = mkN "alla" ; -- alla..nn.1
  allativ_1_N = mkN "allativ" "allativer" ; -- allativ..nn.1
  allbekant_1_A = mkA "allbekant" "allbekant" ; -- allbekant..av.1
  alldaglig_1_A = mkA "alldaglig" ; -- alldaglig..av.1
  alldaglighet_1_N = mkN "alldaglighet" ; -- alldaglighet..nn.1
  alldeles_1_Adv = mkAdv "alldeles" ; -- alldeles..ab.1
  allegat_1_N = mkN "allegat" neutrum  ; -- allegat..nn.1
  allegori_1_N = mkN "allegori" "allegorier" ; -- allegori..nn.1
  allegorisera_1_V = mkV "allegoriserar" ; -- allegorisera..vb.1
  allegoriserande_1_N = mkN "allegoriserande" ; -- allegoriserande..nn.1
  allegoriserbar_1_A = mkA "allegoriserbar" ; -- allegoriserbar..av.1
  allegoriserbarhet_1_N = mkN "allegoriserbarhet" ; -- allegoriserbarhet..nn.1
  allegorisering_1_N = mkN "allegorisering" ; -- allegorisering..nn.1
  allegorisk_1_A = mkA "allegorisk" ; -- allegorisk..av.1
  allegretto_1_N = mkN "allegretto" "allegrettot" "allegretton" "allegrettona" ; -- allegretto..nn.1
  allegro_1_N = mkN "allegro" "allegrot" "allegron" "allegrona" ; -- allegro..nn.1
  allegrosats_1_N = mkN "allegrosats" "allegrosatser" ; -- allegrosats..nn.1
  allehanda_1_A = mkA "allehanda" ; -- allehanda..av.1
  allel_1_N = mkN "allel" "alleler" ; -- allel..nn.1
  allemansfond_1_N = mkN "allemansfond" "allemansfonder" ; -- allemansfond..nn.1
  allemansrätt_1_N = mkN "allemansrätt" ; -- allemansrätt..nn.1
  allen_1_A = mkA "allen" ; -- allen..av.1
  allena_1_A = mkA "allena" ; -- allena..av.1
  allenarådande_1_A = mkA "allenarådande" ; -- allenarådande..av.1
  allenastyre_1_N = mkN "allenastyre" ; -- allenastyre..nn.1
  allergen_1_A = mkA "allergen" "allergent" ; -- allergen..av.1
  allergen_1_N = mkN "allergen" neutrum  ; -- allergen..nn.1
  allergi_1_N = mkN "allergi" "allergier" ; -- allergi..nn.1
  allergiframkallande_1_A = mkA "allergiframkallande" ; -- allergiframkallande..av.1
  allergiker_1_N = mkN "allergiker" "allergikern" "allergiker" "allergikerna" ; -- allergiker..nn.1
  allergimedicin_1_N = mkN "allergimedicin" "allergimediciner" ; -- allergimedicin..nn.1
  allergisk_1_A = mkA "allergisk" ; -- allergisk..av.1
  allergitablett_1_N = mkN "allergitablett" "allergitabletter" ; -- allergitablett..nn.1
  allergolog_1_N = mkN "allergolog" "allergologer" ; -- allergolog..nn.1
  allergologi_1_N = mkN "allergologi" ; -- allergologi..nn.1
  allestädesnärvarande_1_A = mkA "allestädesnärvarande" ; -- allestädesnärvarande..av.1
  alleuropeisk_1_A = mkA "alleuropeisk" ; -- alleuropeisk..av.1
  allfader_1_N = mkN "allfader" ; -- allfader..nn.1
  allfarväg_1_N = mkN "allfarväg" ; -- allfarväg..nn.1
  allgod_1_A = mkA "allgod" ; -- allgod..av.1
  allgodhet_1_N = mkN "allgodhet" ; -- allgodhet..nn.1
  allhelgonadag_1_N = mkN "allhelgonadag" ; -- allhelgonadag..nn.1
  allhelgonamässa_1_N = mkN "allhelgonamässa" ; -- allhelgonamässa..nn.1
  allhärskare_1_N = mkN "allhärskare" utrum  ; -- allhärskare..nn.1
  allians_1_N = mkN "allians" "allianser" ; -- allians..nn.1
  alliansfri_1_A = mkA "alliansfri" "alliansfritt" ; -- alliansfri..av.1
  allianskollega_1_N = mkN "allianskollega" ; -- allianskollega..nn.1
  alliansparti_1_N = mkN "alliansparti" "allianspartiet" "allianspartier" "allianspartierna" ; -- alliansparti..nn.1
  alliansregering_1_N = mkN "alliansregering" ; -- alliansregering..nn.1
  alliansring_1_N = mkN "alliansring" ; -- alliansring..nn.1
  alliera_1_V = mkV "allierar" ; -- alliera..vb.1
  allierad_1_A = mkA "allierad" ; -- allierad..av.1
  allierande_1_N = mkN "allierande" ; -- allierande..nn.1
  allierbar_1_A = mkA "allierbar" ; -- allierbar..av.1
  allierbarhet_1_N = mkN "allierbarhet" ; -- allierbarhet..nn.1
  alliering_1_N = mkN "alliering" ; -- alliering..nn.1
  alligator_1_N = mkN "alligator" "alligatorer" ; -- alligator..nn.1
  allitteration_1_N = mkN "allitteration" ; -- allitteration..nn.1
  allitterera_1_V = mkV "allittererar" ; -- allitterera..vb.1
  allittererande_1_N = mkN "allittererande" ; -- allittererande..nn.1
  allittererbar_1_A = mkA "allittererbar" ; -- allittererbar..av.1
  allittererbarhet_1_N = mkN "allittererbarhet" ; -- allittererbarhet..nn.1
  allitterering_1_N = mkN "allitterering" ; -- allitterering..nn.1
  allkonstnär_1_N = mkN "allkonstnär" "allkonstnärer" ; -- allkonstnär..nn.1
  allkonstverk_1_N = mkN "allkonstverk" neutrum  ; -- allkonstverk..nn.1
  allmakt_1_N = mkN "allmakt" ; -- allmakt..nn.1
  allmaktsord_1_N = mkN "allmaktsord" neutrum  ; -- allmaktsord..nn.1
  allmoge_1_N = mkN "allmoge" utrum  ; -- allmoge..nn.1
  allmogeblå_1_A = mkA "allmogeblå" "allmogeblått" ; -- allmogeblå..av.1
  allmogebroderi_1_N = mkN "allmogebroderi" "allmogebroderiet" "allmogebroderier" "allmogebroderierna" ; -- allmogebroderi..nn.1
  allmogedräkt_1_N = mkN "allmogedräkt" "allmogedräkter" ; -- allmogedräkt..nn.1
  allmogekultur_1_N = mkN "allmogekultur" "allmogekulturer" ; -- allmogekultur..nn.1
  allmogemål_1_N = mkN "allmogemål" neutrum  ; -- allmogemål..nn.1
  allmogesed_1_N = mkN "allmogesed" "allmogeseder" ; -- allmogesed..nn.1
  allmogesmycke_1_N = mkN "allmogesmycke" ; -- allmogesmycke..nn.1
  allmogespråk_1_N = mkN "allmogespråk" neutrum  ; -- allmogespråk..nn.1
  allmogevävnad_1_N = mkN "allmogevävnad" "allmogevävnader" ; -- allmogevävnad..nn.1
  allmosa_1_N = mkN "allmosa" ; -- allmosa..nn.1
  allmän_1_A = mkA "allmän" "allmänt" "allmänna" "allmänna" "allmännare" "allmännast" "allmännaste" ; -- allmän..av.1
  allmänanda_1_N = mkN "allmänanda" ; -- allmänanda..nn.1
  allmänbefinnande_1_N = mkN "allmänbefinnande" ; -- allmänbefinnande..nn.1
  allmänbegrepp_1_N = mkN "allmänbegrepp" neutrum  ; -- allmänbegrepp..nn.1
  allmänbegåvning_1_N = mkN "allmänbegåvning" ; -- allmänbegåvning..nn.1
  allmänbegåvning_2_N = mkN "allmänbegåvning" ; -- allmänbegåvning..nn.2
  allmänbilda_1_V = mkV "allmänbildar" ; -- allmänbilda..vb.1
  allmänbildad_1_A = mkA "allmänbildad" ; -- allmänbildad..av.1
  allmänbildande_1_N = mkN "allmänbildande" ; -- allmänbildande..nn.1
  allmänbildning_1_N = mkN "allmänbildning" ; -- allmänbildning..nn.1
  allmänborgerlig_1_A = mkA "allmänborgerlig" ; -- allmänborgerlig..av.1
  allmänfarlig_1_A = mkA "allmänfarlig" ; -- allmänfarlig..av.1
  allmänfarlighet_1_N = mkN "allmänfarlighet" ; -- allmänfarlighet..nn.1
  allmängiltig_1_A = mkA "allmängiltig" ; -- allmängiltig..av.1
  allmängiltighet_1_N = mkN "allmängiltighet" "allmängiltigheter" ; -- allmängiltighet..nn.1
  allmängods_1_N = mkN "allmängods" neutrum  ; -- allmängods..nn.1
  allmänhet_1_N = mkN "allmänhet" "allmänheter" ; -- allmänhet..nn.1
  allmänhumanistisk_1_A = mkA "allmänhumanistisk" ; -- allmänhumanistisk..av.1
  allmänintresse_1_N = mkN "allmänintresse" ; -- allmänintresse..nn.1
  allmänläkare_1_N = mkN "allmänläkare" utrum  ; -- allmänläkare..nn.1
  allmänmodernistisk_1_A = mkA "allmänmodernistisk" ; -- allmänmodernistisk..av.1
  allmänmänsklig_1_A = mkA "allmänmänsklig" ; -- allmänmänsklig..av.1
  allmänmänsklighet_1_N = mkN "allmänmänsklighet" ; -- allmänmänsklighet..nn.1
  allmännelig_1_A = mkA "allmännelig" ; -- allmännelig..av.1
  allmännelighet_1_N = mkN "allmännelighet" ; -- allmännelighet..nn.1
  allmänning_1_N = mkN "allmänning" ; -- allmänning..nn.1
  allmännytta_1_N = mkN "allmännytta" ; -- allmännytta..nn.1
  allmännyttig_1_A = mkA "allmännyttig" ; -- allmännyttig..av.1
  allmännyttighet_1_N = mkN "allmännyttighet" ; -- allmännyttighet..nn.1
  allmänpolitisk_1_A = mkA "allmänpolitisk" ; -- allmänpolitisk..av.1
  allmänpraktiker_1_N = mkN "allmänpraktiker" "allmänpraktikern" "allmänpraktiker" "allmänpraktikerna" ; -- allmänpraktiker..nn.1
  allmänpraktiserande_1_A = mkA "allmänpraktiserande" ; -- allmänpraktiserande..av.1
  allmänprevention_1_N = mkN "allmänprevention" ; -- allmänprevention..nn.1
  allmänpreventiv_1_A = mkA "allmänpreventiv" ; -- allmänpreventiv..av.1
  allmäntillstånd_1_N = mkN "allmäntillstånd" neutrum  ; -- allmäntillstånd..nn.1
  allmäntjänstgöring_1_N = mkN "allmäntjänstgöring" ; -- allmäntjänstgöring..nn.1
  allnationell_1_A = mkA "allnationell" ; -- allnationell..av.1
  allod_1_N = mkN "allod" "allodet" "alloder" "alloderna" ; -- allod..nn.1
  allodial_1_A = mkA "allodial" ; -- allodial..av.1
  allodium_1_N = mkN "allodium" "allodiet" "allodier" "allodierna" ; -- allodium..nn.1
  allofon_1_N = mkN "allofon" "allofoner" ; -- allofon..nn.1
  allograf_1_N = mkN "allograf" "allografer" ; -- allograf..nn.1
  allokera_1_V = mkV "allokerar" ; -- allokera..vb.1
  allokerande_1_N = mkN "allokerande" ; -- allokerande..nn.1
  allokerbar_1_A = mkA "allokerbar" ; -- allokerbar..av.1
  allokerbarhet_1_N = mkN "allokerbarhet" ; -- allokerbarhet..nn.1
  allokering_1_N = mkN "allokering" ; -- allokering..nn.1
  allokton_1_A = mkA "allokton" ; -- allokton..av.1
  allokution_1_N = mkN "allokution" ; -- allokution..nn.1
  allomfattande_1_A = mkA "allomfattande" ; -- allomfattande..av.1
  allomorf_1_A = mkA "allomorf" ; -- allomorf..av.1
  allomorf_1_N = mkN "allomorf" "allomorfer" ; -- allomorf..nn.1
  allongeperuk_1_N = mkN "allongeperuk" "allongeperuker" ; -- allongeperuk..nn.1
  allopat_1_N = mkN "allopat" "allopater" ; -- allopat..nn.1
  allopati_1_N = mkN "allopati" ; -- allopati..nn.1
  allopatisk_1_A = mkA "allopatisk" ; -- allopatisk..av.1
  allraheligaste_1_A = mkA "allraheligaste" ; -- allraheligaste..av.1
  allriskförsäkring_1_N = mkN "allriskförsäkring" ; -- allriskförsäkring..nn.1
  allround_1_A = mkA "allround" ; -- allround..av.1
  allroundsåg_1_N = mkN "allroundsåg" ; -- allroundsåg..nn.1
  allrum_1_N = mkN "allrum" "allrummet" "allrum" "allrummen" ; -- allrum..nn.1
  allrådande_1_A = mkA "allrådande" ; -- allrådande..av.1
  alls_1_Adv = mkAdv "alls" ; -- alls..ab.1
  allseende_1_A = mkA "allseende" ; -- allseende..av.1
  allshärjarting_1_N = mkN "allshärjarting" neutrum  ; -- allshärjarting..nn.1
  allsidig_1_A = mkA "allsidig" ; -- allsidig..av.1
  allsidighet_1_N = mkN "allsidighet" ; -- allsidighet..nn.1
  allsköns_1_A = mkA "allsköns" ; -- allsköns..av.1
  allsmäktig_1_A = mkA "allsmäktig" ; -- allsmäktig..av.1
  allsmäktighet_1_N = mkN "allsmäktighet" ; -- allsmäktighet..nn.1
  allströmsapparat_1_N = mkN "allströmsapparat" "allströmsapparater" ; -- allströmsapparat..nn.1
  allsvensk_1_A = mkA "allsvensk" ; -- allsvensk..av.1
  allsvenska_1_N = mkN "allsvenska" ; -- allsvenska..nn.1
  allsvåldig_1_A = mkA "allsvåldig" ; -- allsvåldig..av.1
  allsvåldighet_1_N = mkN "allsvåldighet" ; -- allsvåldighet..nn.1
  allsång_1_N = mkN "allsång" "allsånger" ; -- allsång..nn.1
  allsångsledare_1_N = mkN "allsångsledare" utrum  ; -- allsångsledare..nn.1
  allt_1_Adv = mkAdv "allt" ; -- allt..ab.1
  allt_1_N = mkN "allt" neutrum  ; -- allt..nn.1
  alltemellan_1_Adv = mkAdv "alltemellan" ; -- alltemellan..ab.1
  alltemellanåt_1_Adv = mkAdv "alltemellanåt" ; -- alltemellanåt..ab.1
  alltframgent_1_Adv = mkAdv "alltframgent" ; -- alltframgent..ab.1
  alltför_1_Adv = mkAdv "alltför" ; -- alltför..ab.1
  alltiallo_1_N = mkN "alltiallo" "alltiallot" "alltiallon" "alltiallona" ; -- alltiallo..nn.1
  alltigenom_1_Adv = mkAdv "alltigenom" ; -- alltigenom..ab.1
  allting_1_N = mkN "allting" neutrum  ; -- allting..nn.1
  alltmer_1_Adv = mkAdv "alltmer" ; -- alltmer..ab.1
  alltmera_1_Adv = mkAdv "alltmera" ; -- alltmera..ab.1
  alltmindre_1_Adv = mkAdv "alltmindre" ; -- alltmindre..ab.1
  alltnog_1_Adv = mkAdv "alltnog" ; -- alltnog..ab.1
  alltomfattande_1_A = mkA "alltomfattande" ; -- alltomfattande..av.1
  alltså_1_Adv = mkAdv "alltså" ; -- alltså..ab.1
  alludera_1_V = mkV "alluderar" ; -- alludera..vb.1
  alluderande_1_N = mkN "alluderande" ; -- alluderande..nn.1
  alluderbar_1_A = mkA "alluderbar" ; -- alluderbar..av.1
  alluderbarhet_1_N = mkN "alluderbarhet" ; -- alluderbarhet..nn.1
  alludering_1_N = mkN "alludering" ; -- alludering..nn.1
  allusion_1_N = mkN "allusion" ; -- allusion..nn.1
  allusionsvis_1_Adv = mkAdv "allusionsvis" ; -- allusionsvis..ab.1
  alluvial_1_A = mkA "alluvial" ; -- alluvial..av.1
  alluvialbildning_1_N = mkN "alluvialbildning" ; -- alluvialbildning..nn.1
  alluvialland_1_N = mkN "alluvialland" neutrum  ; -- alluvialland..nn.1
  alluvialperiod_1_N = mkN "alluvialperiod" "alluvialperioder" ; -- alluvialperiod..nn.1
  alluvium_1_N = mkN "alluvium" "alluviet" "alluvier" "alluvierna" ; -- alluvium..nn.1
  allvar_1_N = mkN "allvar" neutrum  ; -- allvar..nn.1
  allvarlig_1_A = mkA "allvarlig" ; -- allvarlig..av.1
  allvarligen_1_Adv = mkAdv "allvarligen" ; -- allvarligen..ab.1
  allvarlighet_1_N = mkN "allvarlighet" ; -- allvarlighet..nn.1
  allvarsam_1_A = mkA "allvarsam" "allvarsamt" "allvarsamma" "allvarsamma" "allvarsammare" "allvarsammast" "allvarsammaste" ; -- allvarsam..av.1
  allvarsamhet_1_N = mkN "allvarsamhet" "allvarsamheter" ; -- allvarsamhet..nn.1
  allvarsord_1_N = mkN "allvarsord" neutrum  ; -- allvarsord..nn.1
  allvarstyngd_1_A = mkA "allvarstyngd" "allvarstyngt" ; -- allvarstyngd..av.1
  allvarstyngdhet_1_N = mkN "allvarstyngdhet" ; -- allvarstyngdhet..nn.1
  allvetande_1_A = mkA "allvetande" ; -- allvetande..av.1
  allvetare_1_N = mkN "allvetare" utrum  ; -- allvetare..nn.1
  allvis_1_A = mkA "allvis" ; -- allvis..av.1
  allvishet_1_N = mkN "allvishet" ; -- allvishet..nn.1
  allväders_1_A = mkA "allväders" ; -- allväders..av.1
  allvädersskydd_1_N = mkN "allvädersskydd" neutrum  ; -- allvädersskydd..nn.1
  allvädersstövel_1_N = mkN "allvädersstövel" ; -- allvädersstövel..nn.1
  allätande_1_A = mkA "allätande" ; -- allätande..av.1
  allätare_1_N = mkN "allätare" utrum  ; -- allätare..nn.1
  allé_1_N = mkN "allé" "alléer" ; -- allé..nn.1
  alm_1_N = mkN "alm" ; -- alm..nn.1
  almanack_1_N = mkN "almanack" "almanacker" ; -- almanack..nn.1
  almanacka_1_N = mkN "almanacka" ; -- almanacka..nn.1
  almanacksblad_1_N = mkN "almanacksblad" neutrum  ; -- almanacksblad..nn.1
  alme_1_N = mkN "alme" ; -- alme..nn.1
  almfällning_1_N = mkN "almfällning" ; -- almfällning..nn.1
  almgren_1_N = mkN "almgren" "almgrenen" "almgrenar" "almgrenarna" ; -- almgren..nn.1
  almsav_1_N = mkN "almsav" ; -- almsav..nn.1
  almsjuka_1_N = mkN "almsjuka" ; -- almsjuka..nn.1
  almstrid_1_N = mkN "almstrid" "almstrider" ; -- almstrid..nn.1
  aln_1_N = mkN "aln" ; -- aln..nn.1
  alnmått_1_N = mkN "alnmått" neutrum  ; -- alnmått..nn.1
  alnsbred_1_A = mkA "alnsbred" "alnsbrett" ; -- alnsbred..av.1
  alnsdjup_1_A = mkA "alnsdjup" ; -- alnsdjup..av.1
  alnshög_1_A = mkA "alnshög" ; -- alnshög..av.1
  alnslång_1_A = mkA "alnslång" ; -- alnslång..av.1
  aloe_1_N = mkN "aloe" "aloer" ; -- aloe..nn.1
  aloebaserad_1_A = mkA "aloebaserad" ; -- aloebaserad..av.1
  alopecia_1_N = mkN "alopecia" ; -- alopecia..nn.1
  alp_1_N = mkN "alp" "alper" ; -- alp..nn.1
  alpacka_1_N = mkN "alpacka" ; -- alpacka..nn.1
  alpacka_2_N = mkN "alpacka" ; -- alpacka..nn.2
  alpackatyg_1_N = mkN "alpackatyg" neutrum  ; -- alpackatyg..nn.1
  alpackaull_1_N = mkN "alpackaull" ; -- alpackaull..nn.1
  alpbestigning_1_N = mkN "alpbestigning" ; -- alpbestigning..nn.1
  alpget_1_N = mkN "alpget" "alpgetter" ; -- alpget..nn.1
  alphorn_1_N = mkN "alphorn" neutrum  ; -- alphorn..nn.1
  alpidyll_1_N = mkN "alpidyll" "alpidyller" ; -- alpidyll..nn.1
  alpin_1_A = mkA "alpin" ; -- alpin..av.1
  alpinism_1_N = mkN "alpinism" "alpinismer" ; -- alpinism..nn.1
  alpinist_1_N = mkN "alpinist" "alpinister" ; -- alpinist..nn.1
  alpinsk_1_A = mkA "alpinsk" ; -- alpinsk..av.1
  alpjägare_1_N = mkN "alpjägare" utrum  ; -- alpjägare..nn.1
  alpkedja_1_N = mkN "alpkedja" ; -- alpkedja..nn.1
  alpland_1_N = mkN "alpland" "alplandet" "alpländer" "alpländerna" ; -- alpland..nn.1
  alpregion_1_N = mkN "alpregion" ; -- alpregion..nn.1
  alpros_1_N = mkN "alpros" "alprosor" ; -- alpros..nn.1
  alpspets_1_N = mkN "alpspets" ; -- alpspets..nn.1
  alpstav_1_N = mkN "alpstav" ; -- alpstav..nn.1
  alpstig_1_N = mkN "alpstig" ; -- alpstig..nn.1
  alptopp_1_N = mkN "alptopp" ; -- alptopp..nn.1
  alpvandring_1_N = mkN "alpvandring" ; -- alpvandring..nn.1
  alpviol_1_N = mkN "alpviol" "alpvioler" ; -- alpviol..nn.1
  alpväg_1_N = mkN "alpväg" ; -- alpväg..nn.1
  alruna_1_N = mkN "alruna" ; -- alruna..nn.1
  alsikeklöver_1_N = mkN "alsikeklöver" ; -- alsikeklöver..nn.1
  alspån_1_N = mkN "alspån" neutrum  ; -- alspån..nn.1
  alster_1_N = mkN "alster" neutrum  ; -- alster..nn.1
  alstra_1_V = mkV "alstrar" ; -- alstra..vb.1
  alstrande_1_N = mkN "alstrande" ; -- alstrande..nn.1
  alstrare_1_N = mkN "alstrare" utrum  ; -- alstrare..nn.1
  alstring_1_N = mkN "alstring" ; -- alstring..nn.1
  alt_1_N = mkN "alt" ; -- alt..nn.1
  altaisk_1_A = mkA "altaisk" ; -- altaisk..av.1
  altan_1_N = mkN "altan" "altaner" ; -- altan..nn.1
  altanbräda_1_N = mkN "altanbräda" ; -- altanbräda..nn.1
  altandörr_1_N = mkN "altandörr" ; -- altandörr..nn.1
  altanfäste_1_N = mkN "altanfäste" ; -- altanfäste..nn.1
  altarbild_1_N = mkN "altarbild" "altarbilder" ; -- altarbild..nn.1
  altarbord_1_N = mkN "altarbord" neutrum  ; -- altarbord..nn.1
  altarbrun_1_N = mkN "altarbrun" neutrum  ; -- altarbrun..nn.1
  altardisk_1_N = mkN "altardisk" ; -- altardisk..nn.1
  altarduk_1_N = mkN "altarduk" ; -- altarduk..nn.1
  altare_1_N = mkN "altare" "altaret" "altaren" "altarna" ; -- altare..nn.1
  altargång_1_N = mkN "altargång" ; -- altargång..nn.1
  altarkläde_1_N = mkN "altarkläde" ; -- altarkläde..nn.1
  altarkors_1_N = mkN "altarkors" neutrum  ; -- altarkors..nn.1
  altarkärl_1_N = mkN "altarkärl" neutrum  ; -- altarkärl..nn.1
  altarlykta_1_N = mkN "altarlykta" ; -- altarlykta..nn.1
  altarmålning_1_N = mkN "altarmålning" ; -- altarmålning..nn.1
  altarprydnad_1_N = mkN "altarprydnad" "altarprydnader" ; -- altarprydnad..nn.1
  altarring_1_N = mkN "altarring" ; -- altarring..nn.1
  altarrund_1_N = mkN "altarrund" "altarrunder" ; -- altarrund..nn.1
  altarskrud_1_N = mkN "altarskrud" ; -- altarskrud..nn.1
  altarskåp_1_N = mkN "altarskåp" neutrum  ; -- altarskåp..nn.1
  altartavla_1_N = mkN "altartavla" ; -- altartavla..nn.1
  altartjänst_1_N = mkN "altartjänst" "altartjänster" ; -- altartjänst..nn.1
  altaruppsats_1_N = mkN "altaruppsats" "altaruppsatser" ; -- altaruppsats..nn.1
  altbasun_1_N = mkN "altbasun" "altbasuner" ; -- altbasun..nn.1
  altea_1_N = mkN "altea" ; -- altea..nn.1
  alteasirap_1_N = mkN "alteasirap" ; -- alteasirap..nn.1
  alteration_1_N = mkN "alteration" ; -- alteration..nn.1
  altererad_1_A = mkA "altererad" ; -- altererad..av.1
  alternativ_1_A = mkA "alternativ" ; -- alternativ..av.1
  alternativ_1_N = mkN "alternativ" neutrum  ; -- alternativ..nn.1
  alternativfråga_1_N = mkN "alternativfråga" ; -- alternativfråga..nn.1
  alternativkurs_1_N = mkN "alternativkurs" "alternativkurser" ; -- alternativkurs..nn.1
  alternativt_1_Adv = mkAdv "alternativt" ; -- alternativt..ab.1
  alternatvinkel_1_N = mkN "alternatvinkel" ; -- alternatvinkel..nn.1
  alternera_1_V = mkV "alternerar" ; -- alternera..vb.1
  alternerande_1_N = mkN "alternerande" ; -- alternerande..nn.1
  alternerbar_1_A = mkA "alternerbar" ; -- alternerbar..av.1
  alternerbarhet_1_N = mkN "alternerbarhet" ; -- alternerbarhet..nn.1
  alternering_1_N = mkN "alternering" ; -- alternering..nn.1
  altfiol_1_N = mkN "altfiol" "altfioler" ; -- altfiol..nn.1
  altflöjt_1_N = mkN "altflöjt" "altflöjter" ; -- altflöjt..nn.1
  althorn_1_N = mkN "althorn" neutrum  ; -- althorn..nn.1
  altita_1_N = mkN "altita" ; -- altita..nn.1
  altitud_1_N = mkN "altitud" "altituder" ; -- altitud..nn.1
  altklarinett_1_N = mkN "altklarinett" "altklarinetter" ; -- altklarinett..nn.1
  altklav_1_N = mkN "altklav" "altklaver" ; -- altklav..nn.1
  altparti_1_N = mkN "altparti" "altpartiet" "altpartier" "altpartierna" ; -- altparti..nn.1
  altruism_1_N = mkN "altruism" "altruismer" ; -- altruism..nn.1
  altruist_1_N = mkN "altruist" "altruister" ; -- altruist..nn.1
  altruistisk_1_A = mkA "altruistisk" ; -- altruistisk..av.1
  altröst_1_N = mkN "altröst" "altröster" ; -- altröst..nn.1
  altsträng_1_N = mkN "altsträng" ; -- altsträng..nn.1
  altstämma_1_N = mkN "altstämma" ; -- altstämma..nn.1
  altsångare_1_N = mkN "altsångare" utrum  ; -- altsångare..nn.1
  altsångerska_1_N = mkN "altsångerska" ; -- altsångerska..nn.1
  altviolin_1_N = mkN "altviolin" "altvioliner" ; -- altviolin..nn.1
  aluminera_1_V = mkV "aluminerar" ; -- aluminera..vb.1
  aluminerande_1_N = mkN "aluminerande" ; -- aluminerande..nn.1
  aluminerbar_1_A = mkA "aluminerbar" ; -- aluminerbar..av.1
  aluminerbarhet_1_N = mkN "aluminerbarhet" ; -- aluminerbarhet..nn.1
  aluminering_1_N = mkN "aluminering" ; -- aluminering..nn.1
  aluminium_1_N = mkN "aluminium" neutrum  ; -- aluminium..nn.1
  aluminiumfabrik_1_N = mkN "aluminiumfabrik" "aluminiumfabriker" ; -- aluminiumfabrik..nn.1
  aluminiumfolie_1_N = mkN "aluminiumfolie" "aluminiumfolier" ; -- aluminiumfolie..nn.1
  aluminiumjon_1_N = mkN "aluminiumjon" "aluminiumjoner" ; -- aluminiumjon..nn.1
  aluminiumkärl_1_N = mkN "aluminiumkärl" neutrum  ; -- aluminiumkärl..nn.1
  aluminiumlinjal_1_N = mkN "aluminiumlinjal" "aluminiumlinjaler" ; -- aluminiumlinjal..nn.1
  aluminiumnät_1_N = mkN "aluminiumnät" neutrum  ; -- aluminiumnät..nn.1
  aluminiumpulver_1_N = mkN "aluminiumpulver" neutrum  ; -- aluminiumpulver..nn.1
  aluminiumsmältverk_1_N = mkN "aluminiumsmältverk" neutrum  ; -- aluminiumsmältverk..nn.1
  alumn_1_N = mkN "alumn" "alumner" ; -- alumn..nn.1
  alun_1_N = mkN "alun" ; -- alun..nn.1
  alunhaltig_1_A = mkA "alunhaltig" ; -- alunhaltig..av.1
  alunit_1_N = mkN "alunit" ; -- alunit..nn.1
  alunskiffer_1_N = mkN "alunskiffer" ; -- alunskiffer..nn.1
  alv_1_N = mkN "alv" ; -- alv..nn.1
  alv_2_N = mkN "alv" "alver" ; -- alv..nn.2
  alvar_1_N = mkN "alvar" ; -- alvar..nn.1
  alvarsmark_1_N = mkN "alvarsmark" "alvarsmarker" ; -- alvarsmark..nn.1
  alveol_1_N = mkN "alveol" "alveoler" ; -- alveol..nn.1
  alveolar_1_A = mkA "alveolar" ; -- alveolar..av.1
  alveolar_1_N = mkN "alveolar" "alveolarer" ; -- alveolar..nn.1
  alveolarben_1_N = mkN "alveolarben" neutrum  ; -- alveolarben..nn.1
  alveolarresorption_1_N = mkN "alveolarresorption" ; -- alveolarresorption..nn.1
  alvluckra_1_V = mkV "alvluckrar" ; -- alvluckra..vb.1
  alvluckrande_1_N = mkN "alvluckrande" ; -- alvluckrande..nn.1
  alvplog_1_N = mkN "alvplog" ; -- alvplog..nn.1
  alzheimer_1_N = mkN "alzheimer" ; -- alzheimer..nn.1
  alzheimers_1_N = mkN "alzheimers" ; -- alzheimers..nn.1
  amalgam_1_N = mkN "amalgam" neutrum  ; -- amalgam..nn.1
  amalgamera_1_V = mkV "amalgamerar" ; -- amalgamera..vb.1
  amalgamerande_1_N = mkN "amalgamerande" ; -- amalgamerande..nn.1
  amalgamerbar_1_A = mkA "amalgamerbar" ; -- amalgamerbar..av.1
  amalgamerbarhet_1_N = mkN "amalgamerbarhet" ; -- amalgamerbarhet..nn.1
  amalgamering_1_N = mkN "amalgamering" ; -- amalgamering..nn.1
  amanuens_1_N = mkN "amanuens" "amanuenser" ; -- amanuens..nn.1
  amarant_1_N = mkN "amarant" "amaranter" ; -- amarant..nn.1
  amaryllis_1_N = mkN "amaryllis" ; -- amaryllis..nn.1
  amason_1_N = mkN "amason" "amasoner" ; -- amason..nn.1
  amatör_1_N = mkN "amatör" "amatörer" ; -- amatör..nn.1
  amatörastronom_1_N = mkN "amatörastronom" "amatörastronomer" ; -- amatörastronom..nn.1
  amatörbestämmelse_1_N = mkN "amatörbestämmelse" "amatörbestämmelser" ; -- amatörbestämmelse..nn.1
  amatörbombtillverkning_1_N = mkN "amatörbombtillverkning" ; -- amatörbombtillverkning..nn.1
  amatörforskare_1_N = mkN "amatörforskare" utrum  ; -- amatörforskare..nn.1
  amatöridrott_1_N = mkN "amatöridrott" "amatöridrotter" ; -- amatöridrott..nn.1
  amatörism_1_N = mkN "amatörism" "amatörismer" ; -- amatörism..nn.1
  amatöristisk_1_A = mkA "amatöristisk" ; -- amatöristisk..av.1
  amatörmässig_1_A = mkA "amatörmässig" ; -- amatörmässig..av.1
  amatörmässighet_1_N = mkN "amatörmässighet" ; -- amatörmässighet..nn.1
  amatörmålare_1_N = mkN "amatörmålare" utrum  ; -- amatörmålare..nn.1
  amatörprojekt_1_N = mkN "amatörprojekt" neutrum  ; -- amatörprojekt..nn.1
  amatörregel_1_N = mkN "amatörregel" "amatörregeln" "amatörregler" "amatörreglerna" ; -- amatörregel..nn.1
  amatörsändare_1_N = mkN "amatörsändare" utrum  ; -- amatörsändare..nn.1
  amatörteater_1_N = mkN "amatörteater" ; -- amatörteater..nn.1
  amatörteleskop_1_N = mkN "amatörteleskop" neutrum  ; -- amatörteleskop..nn.1
  amatörvideo_1_N = mkN "amatörvideo" "amatörvideor" ; -- amatörvideo..nn.1
  amazon_1_N = mkN "amazon" "amazoner" ; -- amazon..nn.1
  ambassad_1_N = mkN "ambassad" "ambassader" ; -- ambassad..nn.1
  ambassadpersonal_1_N = mkN "ambassadpersonal" ; -- ambassadpersonal..nn.1
  ambassadris_1_N = mkN "ambassadris" "ambassadriser" ; -- ambassadris..nn.1
  ambassadråd_1_N = mkN "ambassadråd" neutrum  ; -- ambassadråd..nn.1
  ambassadsekreterare_1_N = mkN "ambassadsekreterare" utrum  ; -- ambassadsekreterare..nn.1
  ambassadör_1_N = mkN "ambassadör" "ambassadörer" ; -- ambassadör..nn.1
  ambassadörsmässig_1_A = mkA "ambassadörsmässig" ; -- ambassadörsmässig..av.1
  ambassadörspost_1_N = mkN "ambassadörspost" "ambassadörsposter" ; -- ambassadörspost..nn.1
  ambidexter_1_A = mkA "ambidexter" ; -- ambidexter..av.1
  ambidextri_1_N = mkN "ambidextri" ; -- ambidextri..nn.1
  ambiguitet_1_N = mkN "ambiguitet" "ambiguiteter" ; -- ambiguitet..nn.1
  ambiofoni_1_N = mkN "ambiofoni" ; -- ambiofoni..nn.1
  ambition_1_N = mkN "ambition" ; -- ambition..nn.1
  ambitionsnivå_1_N = mkN "ambitionsnivå" "ambitionsnivåer" ; -- ambitionsnivå..nn.1
  ambitionssak_1_N = mkN "ambitionssak" "ambitionssaker" ; -- ambitionssak..nn.1
  ambitiös_1_A = mkA "ambitiös" ; -- ambitiös..av.1
  ambivalens_1_N = mkN "ambivalens" ; -- ambivalens..nn.1
  ambivalent_1_A = mkA "ambivalent" "ambivalent" ; -- ambivalent..av.1
  amblyopi_1_N = mkN "amblyopi" ; -- amblyopi..nn.1
  ambra_1_N = mkN "ambra" ; -- ambra..nn.1
  ambradoft_1_N = mkN "ambradoft" ; -- ambradoft..nn.1
  ambrosia_1_N = mkN "ambrosia" ; -- ambrosia..nn.1
  ambrosisk_1_A = mkA "ambrosisk" ; -- ambrosisk..av.1
  ambulans_1_N = mkN "ambulans" "ambulanser" ; -- ambulans..nn.1
  ambulansflyg_1_N = mkN "ambulansflyg" neutrum  ; -- ambulansflyg..nn.1
  ambulansförare_1_N = mkN "ambulansförare" utrum  ; -- ambulansförare..nn.1
  ambulanshelikopter_1_N = mkN "ambulanshelikopter" ; -- ambulanshelikopter..nn.1
  ambulanskår_1_N = mkN "ambulanskår" "ambulanskårer" ; -- ambulanskår..nn.1
  ambulansman_1_N = mkN "ambulansman" "ambulansmannen" "ambulansmän" "ambulansmännen" ; -- ambulansman..nn.1
  ambulanspersonal_1_N = mkN "ambulanspersonal" ; -- ambulanspersonal..nn.1
  ambulanssjukskötare_1_N = mkN "ambulanssjukskötare" utrum  ; -- ambulanssjukskötare..nn.1
  ambulanssjuksköterska_1_N = mkN "ambulanssjuksköterska" ; -- ambulanssjuksköterska..nn.1
  ambulanssjukvårdare_1_N = mkN "ambulanssjukvårdare" utrum  ; -- ambulanssjukvårdare..nn.1
  ambulatorisk_1_A = mkA "ambulatorisk" ; -- ambulatorisk..av.1
  ambulera_1_V = mkV "ambulerar" ; -- ambulera..vb.1
  ambulerande_1_N = mkN "ambulerande" ; -- ambulerande..nn.1
  ambulerbar_1_A = mkA "ambulerbar" ; -- ambulerbar..av.1
  ambulerbarhet_1_N = mkN "ambulerbarhet" ; -- ambulerbarhet..nn.1
  ambulering_1_N = mkN "ambulering" ; -- ambulering..nn.1
  ameloblastom_1_N = mkN "ameloblastom" neutrum  ; -- ameloblastom..nn.1
  amendemang_1_N = mkN "amendemang" neutrum  ; -- amendemang..nn.1
  amenorre_1_N = mkN "amenorre" "amenorreen" "amenorreer" "amenorreerna" ; -- amenorre..nn.1
  americium_1_N = mkN "americium" neutrum  ; -- americium..nn.1
  amerikabiljett_1_N = mkN "amerikabiljett" "amerikabiljetter" ; -- amerikabiljett..nn.1
  amerikan_1_N = mkN "amerikan" "amerikaner" ; -- amerikan..nn.1
  amerikanare_1_N = mkN "amerikanare" utrum  ; -- amerikanare..nn.1
  amerikanisera_1_V = mkV "amerikaniserar" ; -- amerikanisera..vb.1
  amerikaniserande_1_N = mkN "amerikaniserande" ; -- amerikaniserande..nn.1
  amerikaniserbar_1_A = mkA "amerikaniserbar" ; -- amerikaniserbar..av.1
  amerikaniserbarhet_1_N = mkN "amerikaniserbarhet" ; -- amerikaniserbarhet..nn.1
  amerikanisering_1_N = mkN "amerikanisering" ; -- amerikanisering..nn.1
  amerikanism_1_N = mkN "amerikanism" "amerikanismer" ; -- amerikanism..nn.1
  amerikansk_1_A = mkA "amerikansk" ; -- amerikansk..av.1
  amerikanska_1_N = mkN "amerikanska" ; -- amerikanska..nn.1
  amerikanska_2_N = mkN "amerikanska" ; -- amerikanska..nn.2
  amerikansktillverkad_1_A = mkA "amerikansktillverkad" ; -- amerikansktillverkad..av.1
  ametist_1_N = mkN "ametist" "ametister" ; -- ametist..nn.1
  ametistblå_1_A = mkA "ametistblå" "ametistblått" ; -- ametistblå..av.1
  ametistsmycke_1_N = mkN "ametistsmycke" ; -- ametistsmycke..nn.1
  amfetamin_1_N = mkN "amfetamin" "amfetaminer" ; -- amfetamin..nn.1
  amfetaminbeslag_1_N = mkN "amfetaminbeslag" neutrum  ; -- amfetaminbeslag..nn.1
  amfetaminmissbruk_1_N = mkN "amfetaminmissbruk" neutrum  ; -- amfetaminmissbruk..nn.1
  amfibie_1_N = mkN "amfibie" "amfibier" ; -- amfibie..nn.1
  amfibieplan_1_N = mkN "amfibieplan" neutrum  ; -- amfibieplan..nn.1
  amfibisk_1_A = mkA "amfibisk" ; -- amfibisk..av.1
  amfibolit_1_N = mkN "amfibolit" "amfiboliter" ; -- amfibolit..nn.1
  amfiteater_1_N = mkN "amfiteater" ; -- amfiteater..nn.1
  amfiteatralisk_1_A = mkA "amfiteatralisk" ; -- amfiteatralisk..av.1
  amfora_1_N = mkN "amfora" ; -- amfora..nn.1
  ami_1_N = mkN "ami" "amier" ; -- ami..nn.1
  amid_1_N = mkN "amid" "amider" ; -- amid..nn.1
  amin_1_N = mkN "amin" "aminer" ; -- amin..nn.1
  aminosyra_1_N = mkN "aminosyra" ; -- aminosyra..nn.1
  amiral_1_N = mkN "amiral" "amiraler" ; -- amiral..nn.1
  amiralitet_1_N = mkN "amiralitet" neutrum  ; -- amiralitet..nn.1
  amiralsflagga_1_N = mkN "amiralsflagga" ; -- amiralsflagga..nn.1
  amiralsperson_1_N = mkN "amiralsperson" "amiralspersoner" ; -- amiralsperson..nn.1
  amiralstitel_1_N = mkN "amiralstitel" ; -- amiralstitel..nn.1
  amma_1_N = mkN "amma" ; -- amma..nn.1
  amma_1_V = mkV "ammar" ; -- amma..vb.1
  ammande_1_N = mkN "ammande" ; -- ammande..nn.1
  ammoniak_1_N = mkN "ammoniak" ; -- ammoniak..nn.1
  ammoniaklukt_1_N = mkN "ammoniaklukt" ; -- ammoniaklukt..nn.1
  ammoniaklösning_1_N = mkN "ammoniaklösning" ; -- ammoniaklösning..nn.1
  ammonit_1_N = mkN "ammonit" "ammoniter" ; -- ammonit..nn.1
  ammonium_1_N = mkN "ammonium" neutrum  ; -- ammonium..nn.1
  ammoniumklorid_1_N = mkN "ammoniumklorid" ; -- ammoniumklorid..nn.1
  ammoniumnitrat_1_N = mkN "ammoniumnitrat" "ammoniumnitrater" ; -- ammoniumnitrat..nn.1
  ammoniumnitratlösning_1_N = mkN "ammoniumnitratlösning" ; -- ammoniumnitratlösning..nn.1
  ammunition_1_N = mkN "ammunition" ; -- ammunition..nn.1
  ammunitionsväska_1_N = mkN "ammunitionsväska" ; -- ammunitionsväska..nn.1
  amnesi_1_N = mkN "amnesi" "amnesier" ; -- amnesi..nn.1
  amnesti_1_N = mkN "amnesti" "amnestier" ; -- amnesti..nn.1
  amnestidekret_1_N = mkN "amnestidekret" neutrum  ; -- amnestidekret..nn.1
  amnestilag_1_N = mkN "amnestilag" ; -- amnestilag..nn.1
  amning_1_N = mkN "amning" ; -- amning..nn.1
  amningsbehå_1_N = mkN "amningsbehå" ; -- amningsbehå..nn.1
  amningsdepression_1_N = mkN "amningsdepression" ; -- amningsdepression..nn.1
  amningsfanatiker_1_N = mkN "amningsfanatiker" "amningsfanatikern" "amningsfanatiker" "amningsfanatikerna" ; -- amningsfanatiker..nn.1
  amningsfanatism_1_N = mkN "amningsfanatism" ; -- amningsfanatism..nn.1
  amningsfascism_1_N = mkN "amningsfascism" ; -- amningsfascism..nn.1
  amningsfascist_1_N = mkN "amningsfascist" "amningsfascister" ; -- amningsfascist..nn.1
  amningsförakt_1_N = mkN "amningsförakt" neutrum  ; -- amningsförakt..nn.1
  amningsmobbare_1_N = mkN "amningsmobbare" utrum  ; -- amningsmobbare..nn.1
  amningssvårighet_1_N = mkN "amningssvårighet" "amningssvårigheter" ; -- amningssvårighet..nn.1
  amnionbandsyndrom_1_N = mkN "amnionbandsyndrom" neutrum  ; -- amnionbandsyndrom..nn.1
  amoebiasis_1_N = mkN "amoebiasis" ; -- amoebiasis..nn.1
  amoralisk_1_A = mkA "amoralisk" ; -- amoralisk..av.1
  amoralism_1_N = mkN "amoralism" "amoralismer" ; -- amoralism..nn.1
  amoralitet_1_N = mkN "amoralitet" "amoraliteter" ; -- amoralitet..nn.1
  amorbåge_1_N = mkN "amorbåge" utrum  ; -- amorbåge..nn.1
  amorf_1_A = mkA "amorf" ; -- amorf..av.1
  amorfism_1_N = mkN "amorfism" "amorfismer" ; -- amorfism..nn.1
  amorin_1_N = mkN "amorin" "amoriner" ; -- amorin..nn.1
  amortera_1_V = mkV "amorterar" ; -- amortera..vb.1
  amorterande_1_N = mkN "amorterande" ; -- amorterande..nn.1
  amorterbar_1_A = mkA "amorterbar" ; -- amorterbar..av.1
  amorterbarhet_1_N = mkN "amorterbarhet" ; -- amorterbarhet..nn.1
  amortering_1_N = mkN "amortering" ; -- amortering..nn.1
  amorteringsfond_1_N = mkN "amorteringsfond" "amorteringsfonder" ; -- amorteringsfond..nn.1
  amorteringsfri_1_A = mkA "amorteringsfri" "amorteringsfritt" ; -- amorteringsfri..av.1
  amorteringslån_1_N = mkN "amorteringslån" neutrum  ; -- amorteringslån..nn.1
  amorteringsplan_1_N = mkN "amorteringsplan" "amorteringsplaner" ; -- amorteringsplan..nn.1
  amorös_1_A = mkA "amorös" ; -- amorös..av.1
  ampel_1_A = mkA "ampel" ; -- ampel..av.1
  ampel_1_N = mkN "ampel" ; -- ampel..nn.1
  amper_1_A = mkA "amper" ; -- amper..av.1
  ampere_1_N = mkN "ampere" "amperen" "ampere" "amperena" ; -- ampere..nn.1
  amperemeter_1_N = mkN "amperemeter" ; -- amperemeter..nn.1
  amperesekund_1_N = mkN "amperesekund" "amperesekunder" ; -- amperesekund..nn.1
  amperevarv_1_N = mkN "amperevarv" neutrum  ; -- amperevarv..nn.1
  amperhet_1_N = mkN "amperhet" ; -- amperhet..nn.1
  amplifiera_1_V = mkV "amplifierar" ; -- amplifiera..vb.1
  amplifierande_1_N = mkN "amplifierande" ; -- amplifierande..nn.1
  amplifierbar_1_A = mkA "amplifierbar" ; -- amplifierbar..av.1
  amplifierbarhet_1_N = mkN "amplifierbarhet" ; -- amplifierbarhet..nn.1
  amplifiering_1_N = mkN "amplifiering" ; -- amplifiering..nn.1
  amplitud_1_N = mkN "amplitud" "amplituder" ; -- amplitud..nn.1
  amplitudmodulera_1_V = mkV "amplitudmodulerar" ; -- amplitudmodulera..vb.1
  amplitudmodulerande_1_N = mkN "amplitudmodulerande" ; -- amplitudmodulerande..nn.1
  amplitudmodulerbar_1_A = mkA "amplitudmodulerbar" ; -- amplitudmodulerbar..av.1
  amplitudmodulerbarhet_1_N = mkN "amplitudmodulerbarhet" ; -- amplitudmodulerbarhet..nn.1
  amplitudmodulering_1_N = mkN "amplitudmodulering" ; -- amplitudmodulering..nn.1
  ampull_1_N = mkN "ampull" "ampuller" ; -- ampull..nn.1
  amputation_1_N = mkN "amputation" ; -- amputation..nn.1
  amputera_1_V = mkV "amputerar" ; -- amputera..vb.1
  amputerande_1_N = mkN "amputerande" ; -- amputerande..nn.1
  amputerbar_1_A = mkA "amputerbar" ; -- amputerbar..av.1
  amputerbarhet_1_N = mkN "amputerbarhet" ; -- amputerbarhet..nn.1
  amputering_1_N = mkN "amputering" ; -- amputering..nn.1
  amsaga_1_N = mkN "amsaga" ; -- amsaga..nn.1
  amt_1_N = mkN "amt" neutrum  ; -- amt..nn.1
  amtman_1_N = mkN "amtman" "amtmannen" "amtmän" "amtmännen" ; -- amtman..nn.1
  amulett_1_N = mkN "amulett" "amuletter" ; -- amulett..nn.1
  amylas_1_N = mkN "amylas" "amylaser" ; -- amylas..nn.1
  amyloidneuropati_1_N = mkN "amyloidneuropati" "amyloidneuropatier" ; -- amyloidneuropati..nn.1
  amyloidos_1_N = mkN "amyloidos" "amyloidoser" ; -- amyloidos..nn.1
  amyloidplack_1_N = mkN "amyloidplack" ; -- amyloidplack..nn.1
  amyotrofi_1_N = mkN "amyotrofi" "amyotrofier" ; -- amyotrofi..nn.1
  amöba_1_N = mkN "amöba" ; -- amöba..nn.1
  amöbadysenteri_1_N = mkN "amöbadysenteri" ; -- amöbadysenteri..nn.1
  amöbainfektion_1_N = mkN "amöbainfektion" ; -- amöbainfektion..nn.1
  ana_1_V = mkV "anar" ; -- ana..vb.1
  anabaptism_1_N = mkN "anabaptism" "anabaptismer" ; -- anabaptism..nn.1
  anabaptist_1_N = mkN "anabaptist" "anabaptister" ; -- anabaptist..nn.1
  anabaptistisk_1_A = mkA "anabaptistisk" ; -- anabaptistisk..av.1
  anabatisk_1_A = mkA "anabatisk" ; -- anabatisk..av.1
  anabol_1_A = mkA "anabol" ; -- anabol..av.1
  anabol_1_N = mkN "anabol" "anaboler" ; -- anabol..nn.1
  anadrom_1_A = mkA "anadrom" ; -- anadrom..av.1
  anaerob_1_A = mkA "anaerob" ; -- anaerob..av.1
  anafor_1_N = mkN "anafor" "anaforen" "anaforer" "anaforerna" ; -- anafor..nn.1
  anaforisk_1_A = mkA "anaforisk" ; -- anaforisk..av.1
  anafylaxi_1_N = mkN "anafylaxi" "anafylaxier" ; -- anafylaxi..nn.1
  anagram_1_N = mkN "anagram" "anagrammet" "anagram" "anagrammen" ; -- anagram..nn.1
  anakolut_1_N = mkN "anakolut" "anakoluter" ; -- anakolut..nn.1
  anakolutisk_1_A = mkA "anakolutisk" ; -- anakolutisk..av.1
  anakonda_1_N = mkN "anakonda" ; -- anakonda..nn.1
  anakoret_1_N = mkN "anakoret" "anakoreter" ; -- anakoret..nn.1
  anakreontisk_1_A = mkA "anakreontisk" ; -- anakreontisk..av.1
  anakronism_1_N = mkN "anakronism" "anakronismer" ; -- anakronism..nn.1
  anakronistisk_1_A = mkA "anakronistisk" ; -- anakronistisk..av.1
  anal_1_A = mkA "anal" ; -- anal..av.1
  analatresi_1_N = mkN "analatresi" ; -- analatresi..nn.1
  analbuminemi_1_N = mkN "analbuminemi" ; -- analbuminemi..nn.1
  analcancer_1_N = mkN "analcancer" ; -- analcancer..nn.1
  analeptik_1_N = mkN "analeptik" ; -- analeptik..nn.1
  analfabet_1_N = mkN "analfabet" "analfabeter" ; -- analfabet..nn.1
  analfabetisk_1_A = mkA "analfabetisk" ; -- analfabetisk..av.1
  analfabetism_1_N = mkN "analfabetism" "analfabetismer" ; -- analfabetism..nn.1
  analfena_1_N = mkN "analfena" ; -- analfena..nn.1
  analfissur_1_N = mkN "analfissur" "analfissurer" ; -- analfissur..nn.1
  analgetika_1_N = mkN "analgetika" "analgetikat" "analgetika" "analgetikana" ; -- analgetika..nn.1
  analinkontinens_1_N = mkN "analinkontinens" "analinkontinenser" ; -- analinkontinens..nn.1
  analkörtel_1_N = mkN "analkörtel" ; -- analkörtel..nn.1
  analkörtelcancer_1_N = mkN "analkörtelcancer" ; -- analkörtelcancer..nn.1
  analkörteltumör_1_N = mkN "analkörteltumör" "analkörteltumörer" ; -- analkörteltumör..nn.1
  analog_1_A = mkA "analog" ; -- analog..av.1
  analogi_1_N = mkN "analogi" "analogier" ; -- analogi..nn.1
  analogibevis_1_N = mkN "analogibevis" neutrum  ; -- analogibevis..nn.1
  analogibildning_1_N = mkN "analogibildning" ; -- analogibildning..nn.1
  analogisk_1_A = mkA "analogisk" ; -- analogisk..av.1
  analogislut_1_N = mkN "analogislut" neutrum  ; -- analogislut..nn.1
  analsex_1_N = mkN "analsex" neutrum  ; -- analsex..nn.1
  analsfinkter_1_N = mkN "analsfinkter" ; -- analsfinkter..nn.1
  analsjukdom_1_N = mkN "analsjukdom" ; -- analsjukdom..nn.1
  analtumör_1_N = mkN "analtumör" "analtumörer" ; -- analtumör..nn.1
  analulcer_1_N = mkN "analulcer" "analulcerer" ; -- analulcer..nn.1
  analys_1_N = mkN "analys" "analyser" ; -- analys..nn.1
  analysera_1_V = mkV "analyserar" ; -- analysera..vb.1
  analyserande_1_N = mkN "analyserande" ; -- analyserande..nn.1
  analyserbar_1_A = mkA "analyserbar" ; -- analyserbar..av.1
  analyserbarhet_1_N = mkN "analyserbarhet" ; -- analyserbarhet..nn.1
  analysering_1_N = mkN "analysering" ; -- analysering..nn.1
  analysmetodik_1_N = mkN "analysmetodik" "analysmetodiker" ; -- analysmetodik..nn.1
  analytiker_1_N = mkN "analytiker" "analytikern" "analytiker" "analytikerna" ; -- analytiker..nn.1
  analytisk_1_A = mkA "analytisk" ; -- analytisk..av.1
  analöppning_1_N = mkN "analöppning" ; -- analöppning..nn.1
  anamma_1_V = mkV "anammar" ; -- anamma..vb.1
  anammande_1_N = mkN "anammande" ; -- anammande..nn.1
  anamnes_1_N = mkN "anamnes" "anamneser" ; -- anamnes..nn.1
  ananas_1_N = mkN "ananas" ; -- ananas..nn.1
  ananassallad_1_N = mkN "ananassallad" "ananassallader" ; -- ananassallad..nn.1
  anande_1_N = mkN "anande" ; -- anande..nn.1
  anapest_1_N = mkN "anapest" "anapester" ; -- anapest..nn.1
  anapestisk_1_A = mkA "anapestisk" ; -- anapestisk..av.1
  anaplasi_1_N = mkN "anaplasi" "anaplasier" ; -- anaplasi..nn.1
  anaplasmainfektion_1_N = mkN "anaplasmainfektion" ; -- anaplasmainfektion..nn.1
  anaplasmos_1_N = mkN "anaplasmos" ; -- anaplasmos..nn.1
  anarki_1_N = mkN "anarki" ; -- anarki..nn.1
  anarkisk_1_A = mkA "anarkisk" ; -- anarkisk..av.1
  anarkism_1_N = mkN "anarkism" "anarkismer" ; -- anarkism..nn.1
  anarkist_1_N = mkN "anarkist" "anarkister" ; -- anarkist..nn.1
  anarkistisk_1_A = mkA "anarkistisk" ; -- anarkistisk..av.1
  anarkokapitalistisk_1_A = mkA "anarkokapitalistisk" ; -- anarkokapitalistisk..av.1
  anarkokommunistisk_1_A = mkA "anarkokommunistisk" ; -- anarkokommunistisk..av.1
  anarkoprimitivistisk_1_A = mkA "anarkoprimitivistisk" ; -- anarkoprimitivistisk..av.1
  anarkosyndikalism_1_N = mkN "anarkosyndikalism" "anarkosyndikalismer" ; -- anarkosyndikalism..nn.1
  anarkosyndikalist_1_N = mkN "anarkosyndikalist" "anarkosyndikalister" ; -- anarkosyndikalist..nn.1
  anarkosyndikalistisk_1_A = mkA "anarkosyndikalistisk" ; -- anarkosyndikalistisk..av.1
  anastas_1_N = mkN "anastas" "anastaser" ; -- anastas..nn.1
  anastatisk_1_A = mkA "anastatisk" ; -- anastatisk..av.1
  anastigmatisk_1_A = mkA "anastigmatisk" ; -- anastigmatisk..av.1
  anastomos_1_N = mkN "anastomos" "anastomoser" ; -- anastomos..nn.1
  anastomosläckage_1_N = mkN "anastomosläckage" ; -- anastomosläckage..nn.1
  anatema_1_N = mkN "anatema" "anatemat" "anatemer" "anatemerna" ; -- anatema..nn.1
  anatolisk_1_A = mkA "anatolisk" ; -- anatolisk..av.1
  anatom_1_N = mkN "anatom" "anatomer" ; -- anatom..nn.1
  anatomi_1_N = mkN "anatomi" ; -- anatomi..nn.1
  anatomisal_1_N = mkN "anatomisal" ; -- anatomisal..nn.1
  anatomisk_1_A = mkA "anatomisk" ; -- anatomisk..av.1
  anbefalla_1_V = mkV "anbefaller" ; -- anbefalla..vb.1
  anbefallande_1_N = mkN "anbefallande" ; -- anbefallande..nn.1
  anbefallning_1_N = mkN "anbefallning" ; -- anbefallning..nn.1
  anbelanga_1_V = mkV "anbelangar" ; -- anbelanga..vb.1
  anbelangande_1_N = mkN "anbelangande" ; -- anbelangande..nn.1
  anblick_1_N = mkN "anblick" ; -- anblick..nn.1
  anblåspipa_1_N = mkN "anblåspipa" ; -- anblåspipa..nn.1
  anbringa_1_V = mkV "anbringar" ; -- anbringa..vb.1
  anbringande_1_N = mkN "anbringande" ; -- anbringande..nn.1
  anbringning_1_N = mkN "anbringning" ; -- anbringning..nn.1
  anbrott_1_N = mkN "anbrott" neutrum  ; -- anbrott..nn.1
  anbud_1_N = mkN "anbud" neutrum  ; -- anbud..nn.1
  anbudsgivare_1_N = mkN "anbudsgivare" utrum  ; -- anbudsgivare..nn.1
  ancestor_1_N = mkN "ancestor" "ancestorer" ; -- ancestor..nn.1
  anciennitet_1_N = mkN "anciennitet" "ancienniteter" ; -- anciennitet..nn.1
  and_1_N = mkN "and" "änder" ; -- and..nn.1
  and_2_N = mkN "and" ; -- and..nn.2
  anda_1_N = mkN "anda" ; -- anda..nn.1
  andakt_1_N = mkN "andakt" "andakter" ; -- andakt..nn.1
  andaktsbok_1_N = mkN "andaktsbok" "andaktsböcker" ; -- andaktsbok..nn.1
  andaktsfull_1_A = mkA "andaktsfull" ; -- andaktsfull..av.1
  andaktsfullhet_1_N = mkN "andaktsfullhet" ; -- andaktsfullhet..nn.1
  andaktslitteratur_1_N = mkN "andaktslitteratur" ; -- andaktslitteratur..nn.1
  andaktssal_1_N = mkN "andaktssal" ; -- andaktssal..nn.1
  andaktsstund_1_N = mkN "andaktsstund" "andaktsstunder" ; -- andaktsstund..nn.1
  andaktsutövning_1_N = mkN "andaktsutövning" ; -- andaktsutövning..nn.1
  andaktsövning_1_N = mkN "andaktsövning" ; -- andaktsövning..nn.1
  andalusisk_1_A = mkA "andalusisk" ; -- andalusisk..av.1
  andante_1_N = mkN "andante" ; -- andante..nn.1
  ande_1_N = mkN "ande" utrum  ; -- ande..nn.1
  andebesvärjare_1_N = mkN "andebesvärjare" utrum  ; -- andebesvärjare..nn.1
  andebesvärjelse_1_N = mkN "andebesvärjelse" "andebesvärjelser" ; -- andebesvärjelse..nn.1
  andedrag_1_N = mkN "andedrag" neutrum  ; -- andedrag..nn.1
  andedräkt_1_N = mkN "andedräkt" "andedräkter" ; -- andedräkt..nn.1
  andefattig_1_A = mkA "andefattig" ; -- andefattig..av.1
  andefattigdom_1_N = mkN "andefattigdom" ; -- andefattigdom..nn.1
  andefattighet_1_N = mkN "andefattighet" ; -- andefattighet..nn.1
  andekraft_1_N = mkN "andekraft" "andekrafter" ; -- andekraft..nn.1
  andel_1_N = mkN "andel" "andelen" "andelar" "andelarna" ; -- andel..nn.1
  andelsförening_1_N = mkN "andelsförening" ; -- andelsförening..nn.1
  andelös_1_A = mkA "andelös" ; -- andelös..av.1
  andelöshet_1_N = mkN "andelöshet" ; -- andelöshet..nn.1
  andemeddelande_1_N = mkN "andemeddelande" ; -- andemeddelande..nn.1
  andemening_1_N = mkN "andemening" ; -- andemening..nn.1
  anderike_1_N = mkN "anderike" ; -- anderike..nn.1
  anderöst_1_N = mkN "anderöst" "anderöster" ; -- anderöst..nn.1
  andeskådande_1_N = mkN "andeskådande" ; -- andeskådande..nn.1
  andeskådare_1_N = mkN "andeskådare" utrum  ; -- andeskådare..nn.1
  andeskåderi_1_N = mkN "andeskåderi" "andeskåderiet" "andeskåderier" "andeskåderierna" ; -- andeskåderi..nn.1
  andeskådning_1_N = mkN "andeskådning" ; -- andeskådning..nn.1
  andestämma_1_N = mkN "andestämma" ; -- andestämma..nn.1
  andesyn_1_N = mkN "andesyn" "andesyner" ; -- andesyn..nn.1
  andetag_1_N = mkN "andetag" neutrum  ; -- andetag..nn.1
  andeuppenbarelse_1_N = mkN "andeuppenbarelse" "andeuppenbarelser" ; -- andeuppenbarelse..nn.1
  andeutdrivare_1_N = mkN "andeutdrivare" utrum  ; -- andeutdrivare..nn.1
  andevärld_1_N = mkN "andevärld" ; -- andevärld..nn.1
  andeväsen_1_N = mkN "andeväsen" "andeväsendet" "andeväsen" "andeväsena" ; -- andeväsen..nn.1
  andfigur_1_N = mkN "andfigur" "andfigurer" ; -- andfigur..nn.1
  andfådd_1_A = mkA "andfådd" ; -- andfådd..av.1
  andfåddhet_1_N = mkN "andfåddhet" ; -- andfåddhet..nn.1
  andfågel_1_N = mkN "andfågel" ; -- andfågel..nn.1
  andhämtning_1_N = mkN "andhämtning" ; -- andhämtning..nn.1
  andhämtningspaus_1_N = mkN "andhämtningspaus" "andhämtningspauser" ; -- andhämtningspaus..nn.1
  andhål_1_N = mkN "andhål" neutrum  ; -- andhål..nn.1
  andjakt_1_N = mkN "andjakt" "andjakter" ; -- andjakt..nn.1
  andlig_1_A = mkA "andlig" ; -- andlig..av.1
  andligen_1_Adv = mkAdv "andligen" ; -- andligen..ab.1
  andlighet_1_N = mkN "andlighet" ; -- andlighet..nn.1
  andlös_1_A = mkA "andlös" ; -- andlös..av.1
  andlöshet_1_N = mkN "andlöshet" ; -- andlöshet..nn.1
  andmat_1_N = mkN "andmat" ; -- andmat..nn.1
  andning_1_N = mkN "andning" ; -- andning..nn.1
  andningsacidos_1_N = mkN "andningsacidos" ; -- andningsacidos..nn.1
  andningsalkalos_1_N = mkN "andningsalkalos" ; -- andningsalkalos..nn.1
  andningsapparat_1_N = mkN "andningsapparat" "andningsapparater" ; -- andningsapparat..nn.1
  andningsbesvär_1_N = mkN "andningsbesvär" neutrum  ; -- andningsbesvär..nn.1
  andningsenzym_1_N = mkN "andningsenzym" neutrum  ; -- andningsenzym..nn.1
  andningsförlamning_1_N = mkN "andningsförlamning" ; -- andningsförlamning..nn.1
  andningshjälp_1_N = mkN "andningshjälp" ; -- andningshjälp..nn.1
  andningshål_1_N = mkN "andningshål" neutrum  ; -- andningshål..nn.1
  andningsinsufficiens_1_N = mkN "andningsinsufficiens" "andningsinsufficienser" ; -- andningsinsufficiens..nn.1
  andningsljud_1_N = mkN "andningsljud" neutrum  ; -- andningsljud..nn.1
  andningsorgan_1_N = mkN "andningsorgan" neutrum  ; -- andningsorgan..nn.1
  andningsparalys_1_N = mkN "andningsparalys" "andningsparalyser" ; -- andningsparalys..nn.1
  andningspaus_1_N = mkN "andningspaus" "andningspauser" ; -- andningspaus..nn.1
  andningsreaktion_1_N = mkN "andningsreaktion" ; -- andningsreaktion..nn.1
  andningsrör_1_N = mkN "andningsrör" neutrum  ; -- andningsrör..nn.1
  andningsrörelse_1_N = mkN "andningsrörelse" "andningsrörelser" ; -- andningsrörelse..nn.1
  andningsskydd_1_N = mkN "andningsskydd" neutrum  ; -- andningsskydd..nn.1
  andningsstillestånd_1_N = mkN "andningsstillestånd" neutrum  ; -- andningsstillestånd..nn.1
  andningsstörning_1_N = mkN "andningsstörning" ; -- andningsstörning..nn.1
  andningssvikt_1_N = mkN "andningssvikt" "andningssvikter" ; -- andningssvikt..nn.1
  andningssvårighet_1_N = mkN "andningssvårighet" "andningssvårigheter" ; -- andningssvårighet..nn.1
  andningsuppehåll_1_N = mkN "andningsuppehåll" neutrum  ; -- andningsuppehåll..nn.1
  andningsväg_1_N = mkN "andningsväg" ; -- andningsväg..nn.1
  andnöd_1_N = mkN "andnöd" ; -- andnöd..nn.1
  andorran_1_N = mkN "andorran" "andorraner" ; -- andorran..nn.1
  andorransk_1_A = mkA "andorransk" ; -- andorransk..av.1
  andorranska_1_N = mkN "andorranska" ; -- andorranska..nn.1
  andouillette_1_N = mkN "andouillette" "andouilletter" ; -- andouillette..nn.1
  andra_1_V = mkV "andraga" "androg" "andragit" ; -- andra..vb.1
  andrabas_1_N = mkN "andrabas" ; -- andrabas..nn.1
  andrabil_1_N = mkN "andrabil" ; -- andrabil..nn.1
  andraderivata_1_N = mkN "andraderivata" ; -- andraderivata..nn.1
  andrag_1_N = mkN "andrag" neutrum  ; -- andrag..nn.1
  andragande_1_N = mkN "andragande" ; -- andragande..nn.1
  andragradsekvation_1_N = mkN "andragradsekvation" ; -- andragradsekvation..nn.1
  andrahandsbutik_1_N = mkN "andrahandsbutik" "andrahandsbutiker" ; -- andrahandsbutik..nn.1
  andrahandscitat_1_N = mkN "andrahandscitat" neutrum  ; -- andrahandscitat..nn.1
  andrahandsfaktorer_1_N = mkN "andrahandsfaktorer" "andrahandsfaktorerer" ; -- andrahandsfaktorer..nn.1
  andrahandsföremål_1_N = mkN "andrahandsföremål" neutrum  ; -- andrahandsföremål..nn.1
  andrahandsinformation_1_N = mkN "andrahandsinformation" ; -- andrahandsinformation..nn.1
  andrahandskälla_1_N = mkN "andrahandskälla" ; -- andrahandskälla..nn.1
  andrahandsuppgift_1_N = mkN "andrahandsuppgift" "andrahandsuppgifter" ; -- andrahandsuppgift..nn.1
  andrahandsval_1_N = mkN "andrahandsval" neutrum  ; -- andrahandsval..nn.1
  andrahandsvärde_1_N = mkN "andrahandsvärde" ; -- andrahandsvärde..nn.1
  andrake_1_N = mkN "andrake" utrum  ; -- andrake..nn.1
  andraklassbiljett_1_N = mkN "andraklassbiljett" "andraklassbiljetter" ; -- andraklassbiljett..nn.1
  andraklasspassagerare_1_N = mkN "andraklasspassagerare" utrum  ; -- andraklasspassagerare..nn.1
  andranamn_1_N = mkN "andranamn" neutrum  ; -- andranamn..nn.1
  andraopponent_1_N = mkN "andraopponent" "andraopponenter" ; -- andraopponent..nn.1
  andraplacering_1_N = mkN "andraplacering" ; -- andraplacering..nn.1
  andraplans_1_A = mkA "andraplans" ; -- andraplans..av.1
  andraplats_1_N = mkN "andraplats" "andraplatser" ; -- andraplats..nn.1
  andraslagsförmåga_1_N = mkN "andraslagsförmåga" ; -- andraslagsförmåga..nn.1
  andratenor_1_N = mkN "andratenor" "andratenoren" "andratenorer" "andratenorerna" ; -- andratenor..nn.1
  andratidning_1_N = mkN "andratidning" ; -- andratidning..nn.1
  andreaskors_1_N = mkN "andreaskors" neutrum  ; -- andreaskors..nn.1
  andrebas_1_N = mkN "andrebas" ; -- andrebas..nn.1
  andrechef_1_N = mkN "andrechef" "andrechefer" ; -- andrechef..nn.1
  andreopponent_1_N = mkN "andreopponent" "andreopponenter" ; -- andreopponent..nn.1
  andretenor_1_N = mkN "andretenor" "andretenoren" "andretenorer" "andretenorerna" ; -- andretenor..nn.1
  androblastom_1_N = mkN "androblastom" neutrum  ; -- androblastom..nn.1
  androfani_1_N = mkN "androfani" ; -- androfani..nn.1
  androfobi_1_N = mkN "androfobi" ; -- androfobi..nn.1
  androgenokänslighetssyndrom_1_N = mkN "androgenokänslighetssyndrom" neutrum  ; -- androgenokänslighetssyndrom..nn.1
  androgyn_1_A = mkA "androgyn" ; -- androgyn..av.1
  androgyn_1_N = mkN "androgyn" "androgyner" ; -- androgyn..nn.1
  androgynhet_1_N = mkN "androgynhet" ; -- androgynhet..nn.1
  android_1_N = mkN "android" "androider" ; -- android..nn.1
  androidlur_1_N = mkN "androidlur" ; -- androidlur..nn.1
  androidmobil_1_N = mkN "androidmobil" "androidmobiler" ; -- androidmobil..nn.1
  andryg_1_A = mkA "andryg" ; -- andryg..av.1
  andryghet_1_N = mkN "andryghet" ; -- andryghet..nn.1
  andsträck_1_N = mkN "andsträck" neutrum  ; -- andsträck..nn.1
  andtruten_1_A = mkA "andtruten" ; -- andtruten..av.1
  andtrutenhet_1_N = mkN "andtrutenhet" ; -- andtrutenhet..nn.1
  andtäppa_1_N = mkN "andtäppa" ; -- andtäppa..nn.1
  andtäppt_1_A = mkA "andtäppt" "andtäppt" ; -- andtäppt..av.1
  andur_1_N = mkN "andur" "andurn" "andrar" "andrarna" ; -- andur..nn.1
  andäktig_1_A = mkA "andäktig" ; -- andäktig..av.1
  andäktighet_1_N = mkN "andäktighet" ; -- andäktighet..nn.1
  anekdot_1_N = mkN "anekdot" "anekdoter" ; -- anekdot..nn.1
  anekdotartad_1_A = mkA "anekdotartad" ; -- anekdotartad..av.1
  anekdotberättare_1_N = mkN "anekdotberättare" utrum  ; -- anekdotberättare..nn.1
  anekdotflora_1_N = mkN "anekdotflora" ; -- anekdotflora..nn.1
  anekdotisk_1_A = mkA "anekdotisk" ; -- anekdotisk..av.1
  anekdotsamling_1_N = mkN "anekdotsamling" ; -- anekdotsamling..nn.1
  anemi_1_N = mkN "anemi" "anemier" ; -- anemi..nn.1
  anemisk_1_A = mkA "anemisk" ; -- anemisk..av.1
  anemometer_1_N = mkN "anemometer" ; -- anemometer..nn.1
  anemon_1_N = mkN "anemon" "anemoner" ; -- anemon..nn.1
  anencefali_1_N = mkN "anencefali" ; -- anencefali..nn.1
  aneroidbarometer_1_N = mkN "aneroidbarometer" ; -- aneroidbarometer..nn.1
  anestesi_1_N = mkN "anestesi" "anestesier" ; -- anestesi..nn.1
  anestesiolog_1_N = mkN "anestesiolog" "anestesiologer" ; -- anestesiolog..nn.1
  anestesiologi_1_N = mkN "anestesiologi" ; -- anestesiologi..nn.1
  anestesirum_1_N = mkN "anestesirum" "anestesirummet" "anestesirum" "anestesirummen" ; -- anestesirum..nn.1
  anestetika_1_N = mkN "anestetika" "anestetikat" "anestetika" "anestetikana" ; -- anestetika..nn.1
  anestetisk_1_A = mkA "anestetisk" ; -- anestetisk..av.1
  anetoderma_1_N = mkN "anetoderma" ; -- anetoderma..nn.1
  aneuploidi_1_N = mkN "aneuploidi" ; -- aneuploidi..nn.1
  aneurysm_1_N = mkN "aneurysm" "aneurysmer" ; -- aneurysm..nn.1
  anfader_1_N = mkN "anfader" "anfadern" "anfäder" "anfäderna" ; -- anfader..nn.1
  anfall_1_N = mkN "anfall" neutrum  ; -- anfall..nn.1
  anfalla_1_V = mkV "anfalla" "anföll" "anfallit" ; -- anfalla..vb.1
  anfallande_1_N = mkN "anfallande" ; -- anfallande..nn.1
  anfallare_1_N = mkN "anfallare" utrum  ; -- anfallare..nn.1
  anfallsbas_1_N = mkN "anfallsbas" "anfallsbaser" ; -- anfallsbas..nn.1
  anfallsfront_1_N = mkN "anfallsfront" "anfallsfronter" ; -- anfallsfront..nn.1
  anfallskrig_1_N = mkN "anfallskrig" neutrum  ; -- anfallskrig..nn.1
  anfallslinje_1_N = mkN "anfallslinje" "anfallslinjer" ; -- anfallslinje..nn.1
  anfallsmässig_1_A = mkA "anfallsmässig" ; -- anfallsmässig..av.1
  anfallsområde_1_N = mkN "anfallsområde" ; -- anfallsområde..nn.1
  anfallsrörelse_1_N = mkN "anfallsrörelse" "anfallsrörelser" ; -- anfallsrörelse..nn.1
  anfallssignal_1_N = mkN "anfallssignal" "anfallssignaler" ; -- anfallssignal..nn.1
  anfallsspel_1_N = mkN "anfallsspel" "anfallsspelet" "anfallsspel" "anfallsspelen" ; -- anfallsspel..nn.1
  anfallsspelare_1_N = mkN "anfallsspelare" utrum  ; -- anfallsspelare..nn.1
  anfallsvapen_1_N = mkN "anfallsvapen" "anfallsvapnet" "anfallsvapen" "anfallsvapnen" ; -- anfallsvapen..nn.1
  anfallsvinkel_1_N = mkN "anfallsvinkel" ; -- anfallsvinkel..nn.1
  anfallsvåg_1_N = mkN "anfallsvåg" "anfallsvågor" ; -- anfallsvåg..nn.1
  anfang_1_N = mkN "anfang" "anfanger" ; -- anfang..nn.1
  anfart_1_N = mkN "anfart" "anfarter" ; -- anfart..nn.1
  anflog_1_N = mkN "anflog" neutrum  ; -- anflog..nn.1
  anflygning_1_N = mkN "anflygning" ; -- anflygning..nn.1
  anfräta_1_V = mkV "anfräter" ; -- anfräta..vb.1
  anfrätande_1_N = mkN "anfrätande" ; -- anfrätande..nn.1
  anfrätning_1_N = mkN "anfrätning" ; -- anfrätning..nn.1
  anfrätt_1_A = mkA "anfrätt" ; -- anfrätt..av.1
  anfäkta_1_V = mkV "anfäktar" ; -- anfäkta..vb.1
  anfäktad_1_A = mkA "anfäktad" ; -- anfäktad..av.1
  anfäktande_1_N = mkN "anfäktande" ; -- anfäktande..nn.1
  anfäktelse_1_N = mkN "anfäktelse" "anfäktelser" ; -- anfäktelse..nn.1
  anfäktning_1_N = mkN "anfäktning" ; -- anfäktning..nn.1
  anföra_1_V = mkV "anföra" "anförde" "anfört" ; -- anföra..vb.1
  anförande_1_N = mkN "anförande" ; -- anförande..nn.1
  anförare_1_N = mkN "anförare" utrum  ; -- anförare..nn.1
  anförarförmåga_1_N = mkN "anförarförmåga" ; -- anförarförmåga..nn.1
  anförarskap_1_N = mkN "anförarskap" neutrum  ; -- anförarskap..nn.1
  anförarskicklighet_1_N = mkN "anförarskicklighet" "anförarskickligheter" ; -- anförarskicklighet..nn.1
  anföring_1_N = mkN "anföring" ; -- anföring..nn.1
  anföringssats_1_N = mkN "anföringssats" "anföringssatser" ; -- anföringssats..nn.1
  anföringstecken_1_N = mkN "anföringstecken" "anföringstecknet" "anföringstecken" "anföringstecknen" ; -- anföringstecken..nn.1
  anföringsverb_1_N = mkN "anföringsverb" neutrum  ; -- anföringsverb..nn.1
  anförtro_1_V = mkV "anförtror" ; -- anförtro..vb.1
  anförtroende_1_N = mkN "anförtroende" ; -- anförtroende..nn.1
  anförvant_1_N = mkN "anförvant" "anförvanter" ; -- anförvant..nn.1
  anförvantskap_1_N = mkN "anförvantskap" neutrum  ; -- anförvantskap..nn.1
  ange_1_V = mkV "angiva" "angav" "angivit" ; -- ange..vb.1
  angel_1_N = mkN "angel" ; -- angel..nn.1
  angelologi_1_N = mkN "angelologi" ; -- angelologi..nn.1
  angelsachsare_1_N = mkN "angelsachsare" utrum  ; -- angelsachsare..nn.1
  angelsachsisk_1_A = mkA "angelsachsisk" ; -- angelsachsisk..av.1
  angelsaxare_1_N = mkN "angelsaxare" utrum  ; -- angelsaxare..nn.1
  angelsaxisk_1_A = mkA "angelsaxisk" ; -- angelsaxisk..av.1
  angelägen_1_A = mkA "angelägen" ; -- angelägen..av.1
  angelägenhet_1_N = mkN "angelägenhet" "angelägenheter" ; -- angelägenhet..nn.1
  angenäm_1_A = mkA "angenäm" ; -- angenäm..av.1
  angenämhet_1_N = mkN "angenämhet" ; -- angenämhet..nn.1
  angina_1_N = mkN "angina" ; -- angina..nn.1
  angiodysplasi_1_N = mkN "angiodysplasi" "angiodysplasier" ; -- angiodysplasi..nn.1
  angiofibrom_1_N = mkN "angiofibrom" neutrum  ; -- angiofibrom..nn.1
  angiografi_1_N = mkN "angiografi" ; -- angiografi..nn.1
  angiokeratom_1_N = mkN "angiokeratom" neutrum  ; -- angiokeratom..nn.1
  angioleiomyom_1_N = mkN "angioleiomyom" neutrum  ; -- angioleiomyom..nn.1
  angiolipom_1_N = mkN "angiolipom" neutrum  ; -- angiolipom..nn.1
  angiologi_1_N = mkN "angiologi" ; -- angiologi..nn.1
  angiom_1_N = mkN "angiom" neutrum  ; -- angiom..nn.1
  angiomatos_1_N = mkN "angiomatos" ; -- angiomatos..nn.1
  angiomyolipom_1_N = mkN "angiomyolipom" neutrum  ; -- angiomyolipom..nn.1
  angiomyom_1_N = mkN "angiomyom" neutrum  ; -- angiomyom..nn.1
  angiosperm_1_N = mkN "angiosperm" "angiospermer" ; -- angiosperm..nn.1
  angioödem_1_N = mkN "angioödem" "angioödemer" ; -- angioödem..nn.1
  angit_1_N = mkN "angit" "angiter" ; -- angit..nn.1
  angivande_1_N = mkN "angivande" ; -- angivande..nn.1
  angivare_1_N = mkN "angivare" utrum  ; -- angivare..nn.1
  angivelse_1_N = mkN "angivelse" "angivelser" ; -- angivelse..nn.1
  angivelsebrott_1_N = mkN "angivelsebrott" neutrum  ; -- angivelsebrott..nn.1
  angiveri_1_N = mkN "angiveri" "angiveriet" "angiverier" "angiverierna" ; -- angiveri..nn.1
  angiverilag_1_N = mkN "angiverilag" ; -- angiverilag..nn.1
  angla_1_V = mkV "anglar" ; -- angla..vb.1
  anglande_1_N = mkN "anglande" ; -- anglande..nn.1
  anglicism_1_N = mkN "anglicism" "anglicismer" ; -- anglicism..nn.1
  anglicistisk_1_A = mkA "anglicistisk" ; -- anglicistisk..av.1
  anglifiera_1_V = mkV "anglifierar" ; -- anglifiera..vb.1
  anglifierande_1_N = mkN "anglifierande" ; -- anglifierande..nn.1
  anglifierbar_1_A = mkA "anglifierbar" ; -- anglifierbar..av.1
  anglifierbarhet_1_N = mkN "anglifierbarhet" ; -- anglifierbarhet..nn.1
  anglifiering_1_N = mkN "anglifiering" ; -- anglifiering..nn.1
  anglikansk_1_A = mkA "anglikansk" ; -- anglikansk..av.1
  anglisera_1_V = mkV "angliserar" ; -- anglisera..vb.1
  angliserande_1_N = mkN "angliserande" ; -- angliserande..nn.1
  angliserbar_1_A = mkA "angliserbar" ; -- angliserbar..av.1
  angliserbarhet_1_N = mkN "angliserbarhet" ; -- angliserbarhet..nn.1
  anglisering_1_N = mkN "anglisering" ; -- anglisering..nn.1
  anglist_1_N = mkN "anglist" "anglister" ; -- anglist..nn.1
  angloamerikansk_1_A = mkA "angloamerikansk" ; -- angloamerikansk..av.1
  anglosachsare_1_N = mkN "anglosachsare" utrum  ; -- anglosachsare..nn.1
  anglosachsisk_1_A = mkA "anglosachsisk" ; -- anglosachsisk..av.1
  anglosaxare_1_N = mkN "anglosaxare" utrum  ; -- anglosaxare..nn.1
  anglosaxisk_1_A = mkA "anglosaxisk" ; -- anglosaxisk..av.1
  angläs_1_N = mkN "angläs" "angläser" ; -- angläs..nn.1
  angolan_1_N = mkN "angolan" "angolaner" ; -- angolan..nn.1
  angolansk_1_A = mkA "angolansk" ; -- angolansk..av.1
  angolanska_1_N = mkN "angolanska" ; -- angolanska..nn.1
  angoragarn_1_N = mkN "angoragarn" neutrum  ; -- angoragarn..nn.1
  angoraget_1_N = mkN "angoraget" "angoragetter" ; -- angoraget..nn.1
  angorajumper_1_N = mkN "angorajumper" ; -- angorajumper..nn.1
  angorakatt_1_N = mkN "angorakatt" "angorakatter" ; -- angorakatt..nn.1
  angoraull_1_N = mkN "angoraull" ; -- angoraull..nn.1
  angostura_1_N = mkN "angostura" ; -- angostura..nn.1
  angrepp_1_N = mkN "angrepp" neutrum  ; -- angrepp..nn.1
  angreppsmål_1_N = mkN "angreppsmål" neutrum  ; -- angreppsmål..nn.1
  angreppspunkt_1_N = mkN "angreppspunkt" "angreppspunkter" ; -- angreppspunkt..nn.1
  angreppssätt_1_N = mkN "angreppssätt" neutrum  ; -- angreppssätt..nn.1
  angripa_1_V = mkV "angripa" "angrep" "angripit" ; -- angripa..vb.1
  angripande_1_N = mkN "angripande" ; -- angripande..nn.1
  angripare_1_N = mkN "angripare" utrum  ; -- angripare..nn.1
  angripbar_1_A = mkA "angripbar" ; -- angripbar..av.1
  angränsa_1_V = mkV "angränsar" ; -- angränsa..vb.1
  angränsande_1_A = mkA "angränsande" ; -- angränsande..av.1
  angränsande_1_N = mkN "angränsande" ; -- angränsande..nn.1
  angå_1_V = mkV "angå" "angick" "angått" ; -- angå..vb.1
  angöra_1_V = mkV "angöra" "angjorde" "angjort" ; -- angöra..vb.1
  angörande_1_N = mkN "angörande" ; -- angörande..nn.1
  anhalt_1_N = mkN "anhalt" "anhalter" ; -- anhalt..nn.1
  anhang_1_N = mkN "anhang" neutrum  ; -- anhang..nn.1
  anhopa_1_V = mkV "anhopar" ; -- anhopa..vb.1
  anhopande_1_N = mkN "anhopande" ; -- anhopande..nn.1
  anhopning_1_N = mkN "anhopning" ; -- anhopning..nn.1
  anhängare_1_N = mkN "anhängare" utrum  ; -- anhängare..nn.1
  anhängarskara_1_N = mkN "anhängarskara" ; -- anhängarskara..nn.1
  anhängig_1_A = mkA "anhängig" ; -- anhängig..av.1
  anhåll_1_N = mkN "anhåll" neutrum  ; -- anhåll..nn.1
  anhålla_1_V = mkV "anhålla" "anhöll" "anhållit" ; -- anhålla..vb.1
  anhållan_1_N = mkN "anhållan" "anhållan" "anhållanden" "anhållandena" ; -- anhållan..nn.1
  anhållande_1_N = mkN "anhållande" ; -- anhållande..nn.1
  anhållningsbeslut_1_N = mkN "anhållningsbeslut" neutrum  ; -- anhållningsbeslut..nn.1
  anhörig_1_A = mkA "anhörig" ; -- anhörig..av.1
  anhörigdag_1_N = mkN "anhörigdag" ; -- anhörigdag..nn.1
  anhörighet_1_N = mkN "anhörighet" ; -- anhörighet..nn.1
  anhöriginvandring_1_N = mkN "anhöriginvandring" ; -- anhöriginvandring..nn.1
  anhörigvård_1_N = mkN "anhörigvård" ; -- anhörigvård..nn.1
  anhörigvårdare_1_N = mkN "anhörigvårdare" utrum  ; -- anhörigvårdare..nn.1
  anilin_1_N = mkN "anilin" ; -- anilin..nn.1
  anilinfärg_1_N = mkN "anilinfärg" "anilinfärger" ; -- anilinfärg..nn.1
  anilinfärgad_1_A = mkA "anilinfärgad" ; -- anilinfärgad..av.1
  anilinolja_1_N = mkN "anilinolja" ; -- anilinolja..nn.1
  anilinröd_1_A = mkA "anilinröd" "anilinrött" ; -- anilinröd..av.1
  animal_1_A = mkA "animal" ; -- animal..av.1
  animalisk_1_A = mkA "animalisk" ; -- animalisk..av.1
  animation_1_N = mkN "animation" ; -- animation..nn.1
  animatör_1_N = mkN "animatör" "animatörer" ; -- animatör..nn.1
  animera_1_V = mkV "animerar" ; -- animera..vb.1
  animerad_1_A = mkA "animerad" ; -- animerad..av.1
  animerande_1_N = mkN "animerande" ; -- animerande..nn.1
  animerbar_1_A = mkA "animerbar" ; -- animerbar..av.1
  animerbarhet_1_N = mkN "animerbarhet" ; -- animerbarhet..nn.1
  animering_1_N = mkN "animering" ; -- animering..nn.1
  animism_1_N = mkN "animism" "animismer" ; -- animism..nn.1
  animistisk_1_A = mkA "animistisk" ; -- animistisk..av.1
  animositet_1_N = mkN "animositet" "animositeter" ; -- animositet..nn.1
  aning_1_N = mkN "aning" ; -- aning..nn.1
  aningen_1_Adv = mkAdv "aningen" ; -- aningen..ab.1
  aningens_1_Adv = mkAdv "aningens" ; -- aningens..ab.1
  aningsfull_1_A = mkA "aningsfull" ; -- aningsfull..av.1
  aningslös_1_A = mkA "aningslös" ; -- aningslös..av.1
  aningslöshet_1_N = mkN "aningslöshet" "aningslösheter" ; -- aningslöshet..nn.1
  aniridi_1_N = mkN "aniridi" ; -- aniridi..nn.1
  anis_1_N = mkN "anis" ; -- anis..nn.1
  anisakiasis_1_N = mkN "anisakiasis" "anisakiasiser" ; -- anisakiasis..nn.1
  anisbrännvin_1_N = mkN "anisbrännvin" "anisbrännvinet" "anisbrännviner" "anisbrännvinerna" ; -- anisbrännvin..nn.1
  anisbröd_1_N = mkN "anisbröd" neutrum  ; -- anisbröd..nn.1
  aniseikoni_1_N = mkN "aniseikoni" ; -- aniseikoni..nn.1
  anisett_1_N = mkN "anisett" "anisetter" ; -- anisett..nn.1
  anisettlikör_1_N = mkN "anisettlikör" "anisettlikörer" ; -- anisettlikör..nn.1
  anislikör_1_N = mkN "anislikör" "anislikörer" ; -- anislikör..nn.1
  anisokori_1_N = mkN "anisokori" ; -- anisokori..nn.1
  anisolja_1_N = mkN "anisolja" ; -- anisolja..nn.1
  anisometropi_1_N = mkN "anisometropi" ; -- anisometropi..nn.1
  anjon_1_N = mkN "anjon" "anjoner" ; -- anjon..nn.1
  anka_1_N = mkN "anka" ; -- anka..nn.1
  ankar_1_N = mkN "ankar" ; -- ankar..nn.1
  ankararm_1_N = mkN "ankararm" ; -- ankararm..nn.1
  ankarboj_1_N = mkN "ankarboj" ; -- ankarboj..nn.1
  ankarbult_1_N = mkN "ankarbult" ; -- ankarbult..nn.1
  ankare_1_N = mkN "ankare" "ankaret" "ankaren" "ankarna" ; -- ankare..nn.1
  ankarfly_1_N = mkN "ankarfly" "ankarflyet" "ankarflyn" "ankarflyna" ; -- ankarfly..nn.1
  ankarfäste_1_N = mkN "ankarfäste" ; -- ankarfäste..nn.1
  ankargrund_1_N = mkN "ankargrund" "ankargrunder" ; -- ankargrund..nn.1
  ankarjärn_1_N = mkN "ankarjärn" neutrum  ; -- ankarjärn..nn.1
  ankarkabel_1_N = mkN "ankarkabel" ; -- ankarkabel..nn.1
  ankarklys_1_N = mkN "ankarklys" neutrum  ; -- ankarklys..nn.1
  ankarkropp_1_N = mkN "ankarkropp" ; -- ankarkropp..nn.1
  ankarkätting_1_N = mkN "ankarkätting" ; -- ankarkätting..nn.1
  ankarlindning_1_N = mkN "ankarlindning" ; -- ankarlindning..nn.1
  ankarplats_1_N = mkN "ankarplats" "ankarplatser" ; -- ankarplats..nn.1
  ankarslut_1_N = mkN "ankarslut" neutrum  ; -- ankarslut..nn.1
  ankarspel_1_N = mkN "ankarspel" "ankarspelet" "ankarspel" "ankarspelen" ; -- ankarspel..nn.1
  ankarstock_1_N = mkN "ankarstock" ; -- ankarstock..nn.1
  ankartross_1_N = mkN "ankartross" ; -- ankartross..nn.1
  ankartåg_1_N = mkN "ankartåg" neutrum  ; -- ankartåg..nn.1
  ankarur_1_N = mkN "ankarur" neutrum  ; -- ankarur..nn.1
  ankbonde_1_N = mkN "ankbonde" "ankbönder" ; -- ankbonde..nn.1
  ankbröst_1_N = mkN "ankbröst" neutrum  ; -- ankbröst..nn.1
  ankdamm_1_N = mkN "ankdamm" ; -- ankdamm..nn.1
  ankel_1_N = mkN "ankel" ; -- ankel..nn.1
  ankelled_1_N = mkN "ankelled" "ankelleder" ; -- ankelled..nn.1
  ankellång_1_A = mkA "ankellång" ; -- ankellång..av.1
  ankelsocka_1_N = mkN "ankelsocka" ; -- ankelsocka..nn.1
  ankism_1_N = mkN "ankism" ; -- ankism..nn.1
  ankistisk_1_A = mkA "ankistisk" ; -- ankistisk..av.1
  anklaga_1_V = mkV "anklagar" ; -- anklaga..vb.1
  anklagande_1_N = mkN "anklagande" ; -- anklagande..nn.1
  anklagare_1_N = mkN "anklagare" utrum  ; -- anklagare..nn.1
  anklagelse_1_N = mkN "anklagelse" "anklagelser" ; -- anklagelse..nn.1
  anklagelseakt_1_N = mkN "anklagelseakt" "anklagelseakter" ; -- anklagelseakt..nn.1
  anklagelsepunkt_1_N = mkN "anklagelsepunkt" "anklagelsepunkter" ; -- anklagelsepunkt..nn.1
  anklagelseskrift_1_N = mkN "anklagelseskrift" "anklagelseskrifter" ; -- anklagelseskrift..nn.1
  anklang_1_N = mkN "anklang" "anklanger" ; -- anklang..nn.1
  ankläpp_1_N = mkN "ankläpp" ; -- ankläpp..nn.1
  anknyta_1_V = mkV "anknyta" "anknöt" "anknutit" ; -- anknyta..vb.1
  anknytande_1_N = mkN "anknytande" ; -- anknytande..nn.1
  anknytning_1_N = mkN "anknytning" ; -- anknytning..nn.1
  ankomma_1_V = mkV "ankomma" "ankom" "ankommit" ; -- ankomma..vb.1
  ankommande_1_N = mkN "ankommande" ; -- ankommande..nn.1
  ankommen_1_A = mkA "ankommen" "ankommet" "ankomna" "ankomna" "ankomnare" "ankomnast" "ankomnaste" ; -- ankommen..av.1
  ankommenhet_1_N = mkN "ankommenhet" ; -- ankommenhet..nn.1
  ankomst_1_N = mkN "ankomst" "ankomster" ; -- ankomst..nn.1
  ankomstdag_1_N = mkN "ankomstdag" ; -- ankomstdag..nn.1
  ankomsthall_1_N = mkN "ankomsthall" ; -- ankomsthall..nn.1
  ankomstkommun_1_N = mkN "ankomstkommun" "ankomstkommuner" ; -- ankomstkommun..nn.1
  ankomstort_1_N = mkN "ankomstort" "ankomstorter" ; -- ankomstort..nn.1
  ankomststation_1_N = mkN "ankomststation" ; -- ankomststation..nn.1
  ankomsttid_1_N = mkN "ankomsttid" "ankomsttider" ; -- ankomsttid..nn.1
  ankra_1_V = mkV "ankrar" ; -- ankra..vb.1
  ankrande_1_N = mkN "ankrande" ; -- ankrande..nn.1
  ankring_1_N = mkN "ankring" ; -- ankring..nn.1
  ankringsplats_1_N = mkN "ankringsplats" "ankringsplatser" ; -- ankringsplats..nn.1
  ankunge_1_N = mkN "ankunge" utrum  ; -- ankunge..nn.1
  ankylos_1_N = mkN "ankylos" ; -- ankylos..nn.1
  ankylostomiasis_1_N = mkN "ankylostomiasis" "ankylostomiasiser" ; -- ankylostomiasis..nn.1
  ankägg_1_N = mkN "ankägg" neutrum  ; -- ankägg..nn.1
  anlag_1_N = mkN "anlag" neutrum  ; -- anlag..nn.1
  anlagsbärare_1_N = mkN "anlagsbärare" utrum  ; -- anlagsbärare..nn.1
  anlagstest_1_N = mkN "anlagstest" neutrum  ; -- anlagstest..nn.1
  anlagstestning_1_N = mkN "anlagstestning" ; -- anlagstestning..nn.1
  anledning_1_N = mkN "anledning" ; -- anledning..nn.1
  anlete_1_N = mkN "anlete" ; -- anlete..nn.1
  anletsdrag_1_N = mkN "anletsdrag" neutrum  ; -- anletsdrag..nn.1
  anligga_1_V = mkV "anligga" "anlåg" "anlegat" ; -- anligga..vb.1
  anliggande_1_N = mkN "anliggande" ; -- anliggande..nn.1
  anliggning_1_N = mkN "anliggning" ; -- anliggning..nn.1
  anliggningspunkt_1_N = mkN "anliggningspunkt" "anliggningspunkter" ; -- anliggningspunkt..nn.1
  anliggningsyta_1_N = mkN "anliggningsyta" ; -- anliggningsyta..nn.1
  anlita_1_V = mkV "anlitar" ; -- anlita..vb.1
  anlitande_1_N = mkN "anlitande" ; -- anlitande..nn.1
  anlopp_1_N = mkN "anlopp" neutrum  ; -- anlopp..nn.1
  anloppshamn_1_N = mkN "anloppshamn" ; -- anloppshamn..nn.1
  anlupen_1_A = mkA "anlupen" ; -- anlupen..av.1
  anlupenhet_1_N = mkN "anlupenhet" ; -- anlupenhet..nn.1
  anlägga_1_V = mkV "anlägga" "anla" "anlagt" ; -- anlägga..vb.1
  anläggande_1_N = mkN "anläggande" ; -- anläggande..nn.1
  anläggare_1_N = mkN "anläggare" utrum  ; -- anläggare..nn.1
  anläggning_1_N = mkN "anläggning" ; -- anläggning..nn.1
  anläggning_2_N = mkN "anläggning" ; -- anläggning..nn.2
  anläggningsarbetare_1_N = mkN "anläggningsarbetare" utrum  ; -- anläggningsarbetare..nn.1
  anläggningskostnad_1_N = mkN "anläggningskostnad" "anläggningskostnader" ; -- anläggningskostnad..nn.1
  anläggningsplats_1_N = mkN "anläggningsplats" "anläggningsplatser" ; -- anläggningsplats..nn.1
  anläggningstillgång_1_N = mkN "anläggningstillgång" ; -- anläggningstillgång..nn.1
  anläggningsyta_1_N = mkN "anläggningsyta" ; -- anläggningsyta..nn.1
  anlända_1_V = mkV "anländer" ; -- anlända..vb.1
  anländande_1_N = mkN "anländande" ; -- anländande..nn.1
  anlöpa_1_V = mkV "anlöper" ; -- anlöpa..vb.1
  anlöpande_1_N = mkN "anlöpande" ; -- anlöpande..nn.1
  anlöpning_1_N = mkN "anlöpning" ; -- anlöpning..nn.1
  anlöpningshamn_1_N = mkN "anlöpningshamn" ; -- anlöpningshamn..nn.1
  anmana_1_V = mkV "anmanar" ; -- anmana..vb.1
  anmanande_1_N = mkN "anmanande" ; -- anmanande..nn.1
  anmaning_1_N = mkN "anmaning" ; -- anmaning..nn.1
  anmarsch_1_N = mkN "anmarsch" "anmarscher" ; -- anmarsch..nn.1
  anmarschering_1_N = mkN "anmarschering" ; -- anmarschering..nn.1
  anmoda_1_V = mkV "anmodar" ; -- anmoda..vb.1
  anmodande_1_N = mkN "anmodande" ; -- anmodande..nn.1
  anmoder_1_N = mkN "anmoder" "anmodern" "anmödrar" "anmödrarna" ; -- anmoder..nn.1
  anmäla_1_V = mkV "anmäler" ; -- anmäla..vb.1
  anmälan_2_N = mkN "anmälan" "anmälan" "anmälningar" "anmälningarna" ; -- anmälan..nn.2
  anmälande_1_N = mkN "anmälande" ; -- anmälande..nn.1
  anmälare_1_N = mkN "anmälare" utrum  ; -- anmälare..nn.1
  anmälning_1_N = mkN "anmälning" ; -- anmälning..nn.1
  anmälningsbenägenhet_1_N = mkN "anmälningsbenägenhet" "anmälningsbenägenheter" ; -- anmälningsbenägenhet..nn.1
  anmälningsplikt_1_N = mkN "anmälningsplikt" ; -- anmälningsplikt..nn.1
  anmälningspliktig_1_A = mkA "anmälningspliktig" ; -- anmälningspliktig..av.1
  anmälningsskyldig_1_A = mkA "anmälningsskyldig" ; -- anmälningsskyldig..av.1
  anmälningstid_1_N = mkN "anmälningstid" "anmälningstider" ; -- anmälningstid..nn.1
  anmärka_1_V = mkV "anmärker" ; -- anmärka..vb.1
  anmärkande_1_N = mkN "anmärkande" ; -- anmärkande..nn.1
  anmärkare_1_N = mkN "anmärkare" utrum  ; -- anmärkare..nn.1
  anmärkning_1_N = mkN "anmärkning" ; -- anmärkning..nn.1
  anmärkningsbok_1_N = mkN "anmärkningsbok" "anmärkningsböcker" ; -- anmärkningsbok..nn.1
  anmärkningsvärd_1_A = mkA "anmärkningsvärd" "anmärkningsvärt" ; -- anmärkningsvärd..av.1
  anmärkningsvärdhet_1_N = mkN "anmärkningsvärdhet" ; -- anmärkningsvärdhet..nn.1
  annalist_1_N = mkN "annalist" "annalister" ; -- annalist..nn.1
  annalkande_1_A = mkA "annalkande" ; -- annalkande..av.1
  annalkande_1_N = mkN "annalkande" ; -- annalkande..nn.1
  annalskrivning_1_N = mkN "annalskrivning" ; -- annalskrivning..nn.1
  annandag_1_N = mkN "annandag" ; -- annandag..nn.1
  annanstans_1_Adv = mkAdv "annanstans" ; -- annanstans..ab.1
  annars_1_Adv = mkAdv "annars" ; -- annars..ab.1
  annatto_1_N = mkN "annatto" ; -- annatto..nn.1
  annektera_1_V = mkV "annekterar" ; -- annektera..vb.1
  annekterande_1_N = mkN "annekterande" ; -- annekterande..nn.1
  annekterbar_1_A = mkA "annekterbar" ; -- annekterbar..av.1
  annekterbarhet_1_N = mkN "annekterbarhet" ; -- annekterbarhet..nn.1
  annektering_1_N = mkN "annektering" ; -- annektering..nn.1
  annektion_1_N = mkN "annektion" ; -- annektion..nn.1
  annex_1_N = mkN "annex" neutrum  ; -- annex..nn.1
  annexförsamling_1_N = mkN "annexförsamling" ; -- annexförsamling..nn.1
  annexion_1_N = mkN "annexion" ; -- annexion..nn.1
  annexionspolitik_1_N = mkN "annexionspolitik" ; -- annexionspolitik..nn.1
  annexkyrka_1_N = mkN "annexkyrka" ; -- annexkyrka..nn.1
  annihilation_1_N = mkN "annihilation" ; -- annihilation..nn.1
  annihilera_1_V = mkV "annihilerar" ; -- annihilera..vb.1
  annihilerande_1_N = mkN "annihilerande" ; -- annihilerande..nn.1
  annihilerbar_1_A = mkA "annihilerbar" ; -- annihilerbar..av.1
  annihilerbarhet_1_N = mkN "annihilerbarhet" ; -- annihilerbarhet..nn.1
  annihilering_1_N = mkN "annihilering" ; -- annihilering..nn.1
  anno_1_Adv = mkAdv "anno" ; -- anno..ab.1
  annons_1_N = mkN "annons" "annonser" ; -- annons..nn.1
  annonsblad_1_N = mkN "annonsblad" neutrum  ; -- annonsblad..nn.1
  annonsbojkott_1_N = mkN "annonsbojkott" "annonsbojkotter" ; -- annonsbojkott..nn.1
  annonsbyrå_1_N = mkN "annonsbyrå" "annonsbyråer" ; -- annonsbyrå..nn.1
  annonsera_1_V = mkV "annonserar" ; -- annonsera..vb.1
  annonserande_1_N = mkN "annonserande" ; -- annonserande..nn.1
  annonserbar_1_A = mkA "annonserbar" ; -- annonserbar..av.1
  annonserbarhet_1_N = mkN "annonserbarhet" ; -- annonserbarhet..nn.1
  annonsering_1_N = mkN "annonsering" ; -- annonsering..nn.1
  annonsinkomst_1_N = mkN "annonsinkomst" "annonsinkomster" ; -- annonsinkomst..nn.1
  annonskampanj_1_N = mkN "annonskampanj" "annonskampanjer" ; -- annonskampanj..nn.1
  annonspelare_1_N = mkN "annonspelare" utrum  ; -- annonspelare..nn.1
  annonsplats_1_N = mkN "annonsplats" "annonsplatser" ; -- annonsplats..nn.1
  annonssvar_1_N = mkN "annonssvar" neutrum  ; -- annonssvar..nn.1
  annonstavla_1_N = mkN "annonstavla" ; -- annonstavla..nn.1
  annonstidning_1_N = mkN "annonstidning" ; -- annonstidning..nn.1
  annonsör_1_N = mkN "annonsör" "annonsörer" ; -- annonsör..nn.1
  annorledes_1_Adv = mkAdv "annorledes" ; -- annorledes..ab.1
  annorlunda_1_Adv = mkAdv "annorlunda" ; -- annorlunda..ab.1
  annorlunda_1_A = mkA "annorlunda" ; -- annorlunda..av.1
  annorstädes_1_Adv = mkAdv "annorstädes" ; -- annorstädes..ab.1
  annotation_1_N = mkN "annotation" ; -- annotation..nn.1
  annotationsbok_1_N = mkN "annotationsbok" "annotationsböcker" ; -- annotationsbok..nn.1
  annotera_1_V = mkV "annoterar" ; -- annotera..vb.1
  annoterande_1_N = mkN "annoterande" ; -- annoterande..nn.1
  annoterbar_1_A = mkA "annoterbar" ; -- annoterbar..av.1
  annoterbarhet_1_N = mkN "annoterbarhet" ; -- annoterbarhet..nn.1
  annotering_1_N = mkN "annotering" ; -- annotering..nn.1
  annuell_1_A = mkA "annuell" ; -- annuell..av.1
  annuitet_1_N = mkN "annuitet" "annuiteter" ; -- annuitet..nn.1
  annuitetslån_1_N = mkN "annuitetslån" neutrum  ; -- annuitetslån..nn.1
  annullera_1_V = mkV "annullerar" ; -- annullera..vb.1
  annullerande_1_N = mkN "annullerande" ; -- annullerande..nn.1
  annullerbar_1_A = mkA "annullerbar" ; -- annullerbar..av.1
  annullerbarhet_1_N = mkN "annullerbarhet" ; -- annullerbarhet..nn.1
  annullering_1_N = mkN "annullering" ; -- annullering..nn.1
  anod_1_N = mkN "anod" "anoder" ; -- anod..nn.1
  anodisera_1_V = mkV "anodiserar" ; -- anodisera..vb.1
  anodiserande_1_N = mkN "anodiserande" ; -- anodiserande..nn.1
  anodiserbar_1_A = mkA "anodiserbar" ; -- anodiserbar..av.1
  anodiserbarhet_1_N = mkN "anodiserbarhet" ; -- anodiserbarhet..nn.1
  anodisering_1_N = mkN "anodisering" ; -- anodisering..nn.1
  anodonti_1_N = mkN "anodonti" ; -- anodonti..nn.1
  anoftalmi_1_N = mkN "anoftalmi" ; -- anoftalmi..nn.1
  anomal_1_A = mkA "anomal" ; -- anomal..av.1
  anomali_1_N = mkN "anomali" "anomalier" ; -- anomali..nn.1
  anomalisk_1_A = mkA "anomalisk" ; -- anomalisk..av.1
  anomalistisk_1_A = mkA "anomalistisk" ; -- anomalistisk..av.1
  anomi_1_N = mkN "anomi" "anomier" ; -- anomi..nn.1
  anonym_1_A = mkA "anonym" ; -- anonym..av.1
  anonymhet_1_N = mkN "anonymhet" ; -- anonymhet..nn.1
  anonymisera_1_V = mkV "anonymiserar" ; -- anonymisera..vb.1
  anonymiserande_1_N = mkN "anonymiserande" ; -- anonymiserande..nn.1
  anonymiserbar_1_A = mkA "anonymiserbar" ; -- anonymiserbar..av.1
  anonymiserbarhet_1_N = mkN "anonymiserbarhet" ; -- anonymiserbarhet..nn.1
  anonymisering_1_N = mkN "anonymisering" ; -- anonymisering..nn.1
  anonymiseringsverktyg_1_N = mkN "anonymiseringsverktyg" neutrum  ; -- anonymiseringsverktyg..nn.1
  anonymitet_1_N = mkN "anonymitet" "anonymiteter" ; -- anonymitet..nn.1
  anorak_1_N = mkN "anorak" "anoraker" ; -- anorak..nn.1
  anordna_1_V = mkV "anordnar" ; -- anordna..vb.1
  anordnande_1_N = mkN "anordnande" ; -- anordnande..nn.1
  anordnare_1_N = mkN "anordnare" utrum  ; -- anordnare..nn.1
  anordning_1_N = mkN "anordning" ; -- anordning..nn.1
  anorektiker_1_N = mkN "anorektiker" "anorektikern" "anorektiker" "anorektikerna" ; -- anorektiker..nn.1
  anorektisk_1_A = mkA "anorektisk" ; -- anorektisk..av.1
  anorektiskhet_1_N = mkN "anorektiskhet" ; -- anorektiskhet..nn.1
  anorexi_1_N = mkN "anorexi" "anorexier" ; -- anorexi..nn.1
  anorexihets_1_N = mkN "anorexihets" ; -- anorexihets..nn.1
  anormal_1_A = mkA "anormal" ; -- anormal..av.1
  anosmi_1_N = mkN "anosmi" ; -- anosmi..nn.1
  anoxemi_1_N = mkN "anoxemi" ; -- anoxemi..nn.1
  anoxi_1_N = mkN "anoxi" ; -- anoxi..nn.1
  anpart_1_N = mkN "anpart" ; -- anpart..nn.1
  anpassa_1_V = mkV "anpassar" ; -- anpassa..vb.1
  anpassande_1_N = mkN "anpassande" ; -- anpassande..nn.1
  anpassbar_1_A = mkA "anpassbar" ; -- anpassbar..av.1
  anpassbarhet_1_N = mkN "anpassbarhet" ; -- anpassbarhet..nn.1
  anpasslig_1_A = mkA "anpasslig" ; -- anpasslig..av.1
  anpasslighet_1_N = mkN "anpasslighet" ; -- anpasslighet..nn.1
  anpassling_1_N = mkN "anpassling" ; -- anpassling..nn.1
  anpassning_1_N = mkN "anpassning" ; -- anpassning..nn.1
  anpassningsbar_1_A = mkA "anpassningsbar" ; -- anpassningsbar..av.1
  anpassningsförmåga_1_N = mkN "anpassningsförmåga" ; -- anpassningsförmåga..nn.1
  anpassningsgrupp_1_N = mkN "anpassningsgrupp" "anpassningsgrupper" ; -- anpassningsgrupp..nn.1
  anpassningsklinik_1_N = mkN "anpassningsklinik" "anpassningskliniker" ; -- anpassningsklinik..nn.1
  anrik_1_A = mkA "anrik" ; -- anrik..av.1
  anrika_1_V = mkV "anrikar" ; -- anrika..vb.1
  anrikande_1_N = mkN "anrikande" ; -- anrikande..nn.1
  anrikhet_1_N = mkN "anrikhet" ; -- anrikhet..nn.1
  anrikning_1_N = mkN "anrikning" ; -- anrikning..nn.1
  anrikningsanläggning_1_N = mkN "anrikningsanläggning" ; -- anrikningsanläggning..nn.1
  anrop_1_N = mkN "anrop" neutrum  ; -- anrop..nn.1
  anropa_1_V = mkV "anropar" ; -- anropa..vb.1
  anropande_1_N = mkN "anropande" ; -- anropande..nn.1
  anropning_1_N = mkN "anropning" ; -- anropning..nn.1
  anropsknapp_1_N = mkN "anropsknapp" ; -- anropsknapp..nn.1
  anropsnummer_1_N = mkN "anropsnummer" neutrum  ; -- anropsnummer..nn.1
  anropssignal_1_N = mkN "anropssignal" "anropssignaler" ; -- anropssignal..nn.1
  anryckning_1_N = mkN "anryckning" ; -- anryckning..nn.1
  anrätta_1_V = mkV "anrättar" ; -- anrätta..vb.1
  anrättande_1_N = mkN "anrättande" ; -- anrättande..nn.1
  anrättning_1_N = mkN "anrättning" ; -- anrättning..nn.1
  ans_1_N = mkN "ans" ; -- ans..nn.1
  ansa_1_V = mkV "ansar" ; -- ansa..vb.1
  ansamla_1_V = mkV "ansamlar" ; -- ansamla..vb.1
  ansamlande_1_N = mkN "ansamlande" ; -- ansamlande..nn.1
  ansamling_1_N = mkN "ansamling" ; -- ansamling..nn.1
  ansande_1_N = mkN "ansande" ; -- ansande..nn.1
  ansats_1_N = mkN "ansats" "ansatser" ; -- ansats..nn.1
  ansatsbana_1_N = mkN "ansatsbana" ; -- ansatsbana..nn.1
  ansatsrör_1_N = mkN "ansatsrör" neutrum  ; -- ansatsrör..nn.1
  anse_1_V = mkV "anse" "ansåg" "ansett" ; -- anse..vb.1
  ansedd_1_A = mkA "ansedd" ; -- ansedd..av.1
  anseddhet_1_N = mkN "anseddhet" ; -- anseddhet..nn.1
  ansedel_1_N = mkN "ansedel" ; -- ansedel..nn.1
  anseende_1_N = mkN "anseende" ; -- anseende..nn.1
  ansenlig_1_A = mkA "ansenlig" ; -- ansenlig..av.1
  ansenlighet_1_N = mkN "ansenlighet" ; -- ansenlighet..nn.1
  ansikte_1_N = mkN "ansikte" ; -- ansikte..nn.1
  ansiktsasymmetri_1_N = mkN "ansiktsasymmetri" "ansiktsasymmetrier" ; -- ansiktsasymmetri..nn.1
  ansiktsbehandling_1_N = mkN "ansiktsbehandling" ; -- ansiktsbehandling..nn.1
  ansiktsbehåring_1_N = mkN "ansiktsbehåring" ; -- ansiktsbehåring..nn.1
  ansiktsbjudning_1_N = mkN "ansiktsbjudning" ; -- ansiktsbjudning..nn.1
  ansiktsblind_1_A = mkA "ansiktsblind" ; -- ansiktsblind..av.1
  ansiktsblindhet_1_N = mkN "ansiktsblindhet" "ansiktsblindheter" ; -- ansiktsblindhet..nn.1
  ansiktscancer_1_N = mkN "ansiktscancer" ; -- ansiktscancer..nn.1
  ansiktsdermatos_1_N = mkN "ansiktsdermatos" "ansiktsdermatoser" ; -- ansiktsdermatos..nn.1
  ansiktsdrag_1_N = mkN "ansiktsdrag" neutrum  ; -- ansiktsdrag..nn.1
  ansiktsform_1_N = mkN "ansiktsform" "ansiktsformer" ; -- ansiktsform..nn.1
  ansiktsfärg_1_N = mkN "ansiktsfärg" "ansiktsfärger" ; -- ansiktsfärg..nn.1
  ansiktsförlamning_1_N = mkN "ansiktsförlamning" ; -- ansiktsförlamning..nn.1
  ansiktsigenkänning_1_N = mkN "ansiktsigenkänning" ; -- ansiktsigenkänning..nn.1
  ansiktskräm_1_N = mkN "ansiktskräm" "ansiktskrämer" ; -- ansiktskräm..nn.1
  ansiktslyft_1_N = mkN "ansiktslyft" neutrum  ; -- ansiktslyft..nn.1
  ansiktslyftning_1_N = mkN "ansiktslyftning" ; -- ansiktslyftning..nn.1
  ansiktslös_1_A = mkA "ansiktslös" ; -- ansiktslös..av.1
  ansiktsmask_1_N = mkN "ansiktsmask" "ansiktsmasker" ; -- ansiktsmask..nn.1
  ansiktsmissbildning_1_N = mkN "ansiktsmissbildning" ; -- ansiktsmissbildning..nn.1
  ansiktsmuskel_1_N = mkN "ansiktsmuskel" "ansiktsmuskeln" "ansiktsmuskler" "ansiktsmusklerna" ; -- ansiktsmuskel..nn.1
  ansiktsmålning_1_N = mkN "ansiktsmålning" ; -- ansiktsmålning..nn.1
  ansiktsnerv_1_N = mkN "ansiktsnerv" "ansiktsnerver" ; -- ansiktsnerv..nn.1
  ansiktsnervssjukdom_1_N = mkN "ansiktsnervssjukdom" ; -- ansiktsnervssjukdom..nn.1
  ansiktsneuralgi_1_N = mkN "ansiktsneuralgi" "ansiktsneuralgier" ; -- ansiktsneuralgi..nn.1
  ansiktsoval_1_N = mkN "ansiktsoval" "ansiktsovaler" ; -- ansiktsoval..nn.1
  ansiktsskada_1_N = mkN "ansiktsskada" ; -- ansiktsskada..nn.1
  ansiktsskydd_1_N = mkN "ansiktsskydd" neutrum  ; -- ansiktsskydd..nn.1
  ansiktssmärta_1_N = mkN "ansiktssmärta" ; -- ansiktssmärta..nn.1
  ansiktstumör_1_N = mkN "ansiktstumör" "ansiktstumörer" ; -- ansiktstumör..nn.1
  ansiktsuttryck_1_N = mkN "ansiktsuttryck" neutrum  ; -- ansiktsuttryck..nn.1
  ansjovis_1_N = mkN "ansjovis" ; -- ansjovis..nn.1
  anskaffa_1_V = mkV "anskaffar" ; -- anskaffa..vb.1
  anskaffande_1_N = mkN "anskaffande" ; -- anskaffande..nn.1
  anskaffare_1_N = mkN "anskaffare" utrum  ; -- anskaffare..nn.1
  anskaffbar_1_A = mkA "anskaffbar" ; -- anskaffbar..av.1
  anskaffning_1_N = mkN "anskaffning" ; -- anskaffning..nn.1
  anskaffningsdag_1_N = mkN "anskaffningsdag" ; -- anskaffningsdag..nn.1
  anskaffningskostnad_1_N = mkN "anskaffningskostnad" "anskaffningskostnader" ; -- anskaffningskostnad..nn.1
  anskri_1_N = mkN "anskri" "anskriet" "anskrin" "anskrina" ; -- anskri..nn.1
  anskriven_1_A = mkA "anskriven" ; -- anskriven..av.1
  anskrämlig_1_A = mkA "anskrämlig" ; -- anskrämlig..av.1
  anskrämlighet_1_N = mkN "anskrämlighet" "anskrämligheter" ; -- anskrämlighet..nn.1
  anslag_1_N = mkN "anslag" neutrum  ; -- anslag..nn.1
  anslagsbeviljande_1_A = mkA "anslagsbeviljande" ; -- anslagsbeviljande..av.1
  anslagsbevillning_1_N = mkN "anslagsbevillning" ; -- anslagsbevillning..nn.1
  anslagsframställning_1_N = mkN "anslagsframställning" ; -- anslagsframställning..nn.1
  anslagsfråga_1_N = mkN "anslagsfråga" ; -- anslagsfråga..nn.1
  anslagsgivande_1_A = mkA "anslagsgivande" ; -- anslagsgivande..av.1
  anslagsmässig_1_A = mkA "anslagsmässig" ; -- anslagsmässig..av.1
  anslagssumma_1_N = mkN "anslagssumma" ; -- anslagssumma..nn.1
  anslagstavla_1_N = mkN "anslagstavla" ; -- anslagstavla..nn.1
  anslagstid_1_N = mkN "anslagstid" "anslagstider" ; -- anslagstid..nn.1
  anslagsäskande_1_N = mkN "anslagsäskande" ; -- anslagsäskande..nn.1
  ansluta_1_V = mkV "ansluta" "anslöt" "anslutit" ; -- ansluta..vb.1
  anslutande_1_N = mkN "anslutande" ; -- anslutande..nn.1
  anslutning_1_N = mkN "anslutning" ; -- anslutning..nn.1
  anslutningsavtal_1_N = mkN "anslutningsavtal" neutrum  ; -- anslutningsavtal..nn.1
  anslutningsbox_1_N = mkN "anslutningsbox" ; -- anslutningsbox..nn.1
  anslutningskabel_1_N = mkN "anslutningskabel" ; -- anslutningskabel..nn.1
  anslutningskontakt_1_N = mkN "anslutningskontakt" "anslutningskontakter" ; -- anslutningskontakt..nn.1
  anslutningspunkt_1_N = mkN "anslutningspunkt" "anslutningspunkter" ; -- anslutningspunkt..nn.1
  anslutningsserver_1_N = mkN "anslutningsserver" ; -- anslutningsserver..nn.1
  anslutningssladd_1_N = mkN "anslutningssladd" ; -- anslutningssladd..nn.1
  anslå_1_V = mkV "anslå" "anslog" "anslagit" ; -- anslå..vb.1
  anslående_1_A = mkA "anslående" ; -- anslående..av.1
  anslående_1_N = mkN "anslående" ; -- anslående..nn.1
  ansning_1_N = mkN "ansning" ; -- ansning..nn.1
  anspann_1_N = mkN "anspann" neutrum  ; -- anspann..nn.1
  anspela_1_V = mkV "anspelar" ; -- anspela..vb.1
  anspelande_1_N = mkN "anspelande" ; -- anspelande..nn.1
  anspelning_1_N = mkN "anspelning" ; -- anspelning..nn.1
  anspråk_1_N = mkN "anspråk" neutrum  ; -- anspråk..nn.1
  anspråklös_1_A = mkA "anspråklös" ; -- anspråklös..av.1
  anspråksfull_1_A = mkA "anspråksfull" ; -- anspråksfull..av.1
  anspråksfullhet_1_N = mkN "anspråksfullhet" ; -- anspråksfullhet..nn.1
  anspråkslös_1_A = mkA "anspråkslös" ; -- anspråkslös..av.1
  anspråkslöshet_1_N = mkN "anspråkslöshet" "anspråkslösheter" ; -- anspråkslöshet..nn.1
  anspänd_1_A = mkA "anspänd" ; -- anspänd..av.1
  anspändhet_1_N = mkN "anspändhet" ; -- anspändhet..nn.1
  anspänning_1_N = mkN "anspänning" ; -- anspänning..nn.1
  anstalt_1_N = mkN "anstalt" "anstalter" ; -- anstalt..nn.1
  anstalta_1_V = mkV "anstaltar" ; -- anstalta..vb.1
  anstaltande_1_N = mkN "anstaltande" ; -- anstaltande..nn.1
  anstaltspastor_1_N = mkN "anstaltspastor" "anstaltspastorer" ; -- anstaltspastor..nn.1
  anstaltsvistelse_1_N = mkN "anstaltsvistelse" "anstaltsvistelser" ; -- anstaltsvistelse..nn.1
  anstaltsvård_1_N = mkN "anstaltsvård" ; -- anstaltsvård..nn.1
  anstifta_1_V = mkV "anstiftar" ; -- anstifta..vb.1
  anstiftande_1_N = mkN "anstiftande" ; -- anstiftande..nn.1
  anstiftare_1_N = mkN "anstiftare" utrum  ; -- anstiftare..nn.1
  anstiftelse_1_N = mkN "anstiftelse" utrum  ; -- anstiftelse..nn.1
  anstorma_1_V = mkV "anstormar" ; -- anstorma..vb.1
  anstormande_1_N = mkN "anstormande" ; -- anstormande..nn.1
  anstormning_1_N = mkN "anstormning" ; -- anstormning..nn.1
  anstruken_1_A = mkA "anstruken" ; -- anstruken..av.1
  anstrukenhet_1_N = mkN "anstrukenhet" ; -- anstrukenhet..nn.1
  anstryka_1_V = mkV "anstryka" "anströk" "anstrukit" ; -- anstryka..vb.1
  anstrykande_1_N = mkN "anstrykande" ; -- anstrykande..nn.1
  anstrykare_1_N = mkN "anstrykare" utrum  ; -- anstrykare..nn.1
  anstrykning_1_N = mkN "anstrykning" ; -- anstrykning..nn.1
  anstränga_1_V = mkV "anstränger" ; -- anstränga..vb.1
  ansträngande_1_A = mkA "ansträngande" ; -- ansträngande..av.1
  ansträngande_1_N = mkN "ansträngande" ; -- ansträngande..nn.1
  ansträngd_1_A = mkA "ansträngd" "ansträngt" ; -- ansträngd..av.1
  ansträngdhet_1_N = mkN "ansträngdhet" ; -- ansträngdhet..nn.1
  ansträngning_1_N = mkN "ansträngning" ; -- ansträngning..nn.1
  ansträngningsinkontinens_1_N = mkN "ansträngningsinkontinens" ; -- ansträngningsinkontinens..nn.1
  anstucken_1_A = mkA "anstucken" ; -- anstucken..av.1
  anstuckenhet_1_N = mkN "anstuckenhet" ; -- anstuckenhet..nn.1
  anställa_1_V = mkV "anställer" ; -- anställa..vb.1
  anställande_1_N = mkN "anställande" ; -- anställande..nn.1
  anställare_1_N = mkN "anställare" utrum  ; -- anställare..nn.1
  anställbar_1_A = mkA "anställbar" ; -- anställbar..av.1
  anställd_1_A = mkA "anställd" "anställt" ; -- anställd..av.1
  anställning_1_N = mkN "anställning" ; -- anställning..nn.1
  anställningsavtal_1_N = mkN "anställningsavtal" neutrum  ; -- anställningsavtal..nn.1
  anställningsbar_1_A = mkA "anställningsbar" ; -- anställningsbar..av.1
  anställningsintervju_1_N = mkN "anställningsintervju" "anställningsintervjun" "anställningsintervjuer" "anställningsintervjuerna" ; -- anställningsintervju..nn.1
  anställningskommitté_1_N = mkN "anställningskommitté" "anställningskommittéer" ; -- anställningskommitté..nn.1
  anställningskontrakt_1_N = mkN "anställningskontrakt" neutrum  ; -- anställningskontrakt..nn.1
  anställningsrättighet_1_N = mkN "anställningsrättighet" "anställningsrättigheter" ; -- anställningsrättighet..nn.1
  anställningsskydd_1_N = mkN "anställningsskydd" neutrum  ; -- anställningsskydd..nn.1
  anställningsstopp_1_N = mkN "anställningsstopp" neutrum  ; -- anställningsstopp..nn.1
  anställningstid_1_N = mkN "anställningstid" "anställningstider" ; -- anställningstid..nn.1
  anställningstrygghet_1_N = mkN "anställningstrygghet" ; -- anställningstrygghet..nn.1
  anställningsvillkor_1_N = mkN "anställningsvillkor" neutrum  ; -- anställningsvillkor..nn.1
  anständig_1_A = mkA "anständig" ; -- anständig..av.1
  anständighet_1_N = mkN "anständighet" "anständigheter" ; -- anständighet..nn.1
  anständighetsbegrepp_1_N = mkN "anständighetsbegrepp" neutrum  ; -- anständighetsbegrepp..nn.1
  anständigtvis_1_Adv = mkAdv "anständigtvis" ; -- anständigtvis..ab.1
  anstå_1_V = mkV "anstå" "anstod" "anstått" ; -- anstå..vb.1
  anstående_1_N = mkN "anstående" ; -- anstående..nn.1
  anstånd_1_N = mkN "anstånd" neutrum  ; -- anstånd..nn.1
  anståndstid_1_N = mkN "anståndstid" "anståndstider" ; -- anståndstid..nn.1
  anstöt_1_N = mkN "anstöt" ; -- anstöt..nn.1
  anstötlig_1_A = mkA "anstötlig" ; -- anstötlig..av.1
  anstötlighet_1_N = mkN "anstötlighet" "anstötligheter" ; -- anstötlighet..nn.1
  ansvar_1_N = mkN "ansvar" neutrum  ; -- ansvar..nn.1
  ansvara_1_V = mkV "ansvarar" ; -- ansvara..vb.1
  ansvarande_1_N = mkN "ansvarande" ; -- ansvarande..nn.1
  ansvarig_1_A = mkA "ansvarig" ; -- ansvarig..av.1
  ansvarighet_1_N = mkN "ansvarighet" ; -- ansvarighet..nn.1
  ansvarighetsförsäkring_1_N = mkN "ansvarighetsförsäkring" ; -- ansvarighetsförsäkring..nn.1
  ansvaring_1_N = mkN "ansvaring" ; -- ansvaring..nn.1
  ansvarsbefrielse_1_N = mkN "ansvarsbefrielse" "ansvarsbefrielser" ; -- ansvarsbefrielse..nn.1
  ansvarsfri_1_A = mkA "ansvarsfri" "ansvarsfritt" ; -- ansvarsfri..av.1
  ansvarsfrihet_1_N = mkN "ansvarsfrihet" "ansvarsfriheter" ; -- ansvarsfrihet..nn.1
  ansvarsfull_1_A = mkA "ansvarsfull" ; -- ansvarsfull..av.1
  ansvarsfullhet_1_N = mkN "ansvarsfullhet" ; -- ansvarsfullhet..nn.1
  ansvarsförsäkring_1_N = mkN "ansvarsförsäkring" ; -- ansvarsförsäkring..nn.1
  ansvarskännande_1_A = mkA "ansvarskännande" ; -- ansvarskännande..av.1
  ansvarskännande_1_N = mkN "ansvarskännande" ; -- ansvarskännande..nn.1
  ansvarskänsla_1_N = mkN "ansvarskänsla" ; -- ansvarskänsla..nn.1
  ansvarslös_1_A = mkA "ansvarslös" ; -- ansvarslös..av.1
  ansvarslöshet_1_N = mkN "ansvarslöshet" ; -- ansvarslöshet..nn.1
  ansvarsnämnd_1_N = mkN "ansvarsnämnd" "ansvarsnämnder" ; -- ansvarsnämnd..nn.1
  ansvarsområde_1_N = mkN "ansvarsområde" ; -- ansvarsområde..nn.1
  ansvarspåföljd_1_N = mkN "ansvarspåföljd" "ansvarspåföljder" ; -- ansvarspåföljd..nn.1
  ansvarsskyldig_1_A = mkA "ansvarsskyldig" ; -- ansvarsskyldig..av.1
  ansvarsskyldighet_1_N = mkN "ansvarsskyldighet" "ansvarsskyldigheter" ; -- ansvarsskyldighet..nn.1
  ansvarstagande_1_A = mkA "ansvarstagande" ; -- ansvarstagande..av.1
  ansvarstagande_1_N = mkN "ansvarstagande" ; -- ansvarstagande..nn.1
  ansvarsutkrävande_1_N = mkN "ansvarsutkrävande" ; -- ansvarsutkrävande..nn.1
  ansvarsyrkande_1_N = mkN "ansvarsyrkande" ; -- ansvarsyrkande..nn.1
  ansvälla_1_V = mkV "ansväller" ; -- ansvälla..vb.1
  ansvällande_1_N = mkN "ansvällande" ; -- ansvällande..nn.1
  ansvälld_1_A = mkA "ansvälld" "ansvällt" ; -- ansvälld..av.1
  ansvälldhet_1_N = mkN "ansvälldhet" ; -- ansvälldhet..nn.1
  ansvällning_1_N = mkN "ansvällning" ; -- ansvällning..nn.1
  ansätta_1_V = mkV "ansätta" "ansätter" "ansätt" "ansatte" "ansatt" "ansatt" ; -- ansätta..vb.1
  ansättande_1_N = mkN "ansättande" ; -- ansättande..nn.1
  ansättning_1_N = mkN "ansättning" ; -- ansättning..nn.1
  ansättningsskruv_1_N = mkN "ansättningsskruv" ; -- ansättningsskruv..nn.1
  ansöka_1_V = mkV "ansöker" ; -- ansöka..vb.1
  ansökande_1_N = mkN "ansökande" ; -- ansökande..nn.1
  ansökarland_1_N = mkN "ansökarland" "ansökarlandet" "ansökarländer" "ansökarländerna" ; -- ansökarland..nn.1
  ansökning_1_N = mkN "ansökning" ; -- ansökning..nn.1
  ansökningshandling_1_N = mkN "ansökningshandling" ; -- ansökningshandling..nn.1
  ansökningspapper_1_N = mkN "ansökningspapper" neutrum  ; -- ansökningspapper..nn.1
  ansökningstid_1_N = mkN "ansökningstid" "ansökningstider" ; -- ansökningstid..nn.1
  ansökningstryck_1_N = mkN "ansökningstryck" neutrum  ; -- ansökningstryck..nn.1
  anta_1_V = mkV "antaga" "antog" "antagit" ; -- anta..vb.1
  antabus_1_N = mkN "antabus" ; -- antabus..nn.1
  antagande_1_N = mkN "antagande" ; -- antagande..nn.1
  antaglig_1_A = mkA "antaglig" ; -- antaglig..av.1
  antagligen_1_Adv = mkAdv "antagligen" ; -- antagligen..ab.1
  antaglighet_1_N = mkN "antaglighet" ; -- antaglighet..nn.1
  antagning_1_N = mkN "antagning" ; -- antagning..nn.1
  antagningsbevis_1_N = mkN "antagningsbevis" neutrum  ; -- antagningsbevis..nn.1
  antagonism_1_N = mkN "antagonism" "antagonismer" ; -- antagonism..nn.1
  antagonist_1_N = mkN "antagonist" "antagonister" ; -- antagonist..nn.1
  antagonistisk_1_A = mkA "antagonistisk" ; -- antagonistisk..av.1
  antal_1_N = mkN "antal" neutrum  ; -- antal..nn.1
  antalsberäkning_1_N = mkN "antalsberäkning" ; -- antalsberäkning..nn.1
  antalsmässig_1_A = mkA "antalsmässig" ; -- antalsmässig..av.1
  antarktisk_1_A = mkA "antarktisk" ; -- antarktisk..av.1
  antasta_1_V = mkV "antastar" ; -- antasta..vb.1
  antastande_1_N = mkN "antastande" ; -- antastande..nn.1
  antavla_1_N = mkN "antavla" ; -- antavla..nn.1
  antecedentia_1_N = mkN "antecedentia" "antecedentiat" "antecedentia" "antecedentiana" ; -- antecedentia..nn.1
  antecipation_1_N = mkN "antecipation" ; -- antecipation..nn.1
  antecipativ_1_A = mkA "antecipativ" ; -- antecipativ..av.1
  antecipera_1_V = mkV "anteciperar" ; -- antecipera..vb.1
  anteciperande_1_N = mkN "anteciperande" ; -- anteciperande..nn.1
  anteciperbar_1_A = mkA "anteciperbar" ; -- anteciperbar..av.1
  anteciperbarhet_1_N = mkN "anteciperbarhet" ; -- anteciperbarhet..nn.1
  antecipering_1_N = mkN "antecipering" ; -- antecipering..nn.1
  anteckna_1_V = mkV "antecknar" ; -- anteckna..vb.1
  antecknande_1_N = mkN "antecknande" ; -- antecknande..nn.1
  antecknare_1_N = mkN "antecknare" utrum  ; -- antecknare..nn.1
  anteckning_1_N = mkN "anteckning" ; -- anteckning..nn.1
  anteckningsblock_1_N = mkN "anteckningsblock" neutrum  ; -- anteckningsblock..nn.1
  anteckningsbok_1_N = mkN "anteckningsbok" "anteckningsböcker" ; -- anteckningsbok..nn.1
  antedatera_1_V = mkV "antedaterar" ; -- antedatera..vb.1
  antedaterande_1_N = mkN "antedaterande" ; -- antedaterande..nn.1
  antedaterbar_1_A = mkA "antedaterbar" ; -- antedaterbar..av.1
  antedaterbarhet_1_N = mkN "antedaterbarhet" ; -- antedaterbarhet..nn.1
  antedatering_1_N = mkN "antedatering" ; -- antedatering..nn.1
  antediluviansk_1_A = mkA "antediluviansk" ; -- antediluviansk..av.1
  antefix_1_N = mkN "antefix" "antefixer" ; -- antefix..nn.1
  antenn_1_N = mkN "antenn" "antenner" ; -- antenn..nn.1
  antennkabel_1_N = mkN "antennkabel" ; -- antennkabel..nn.1
  antennkörtel_1_N = mkN "antennkörtel" ; -- antennkörtel..nn.1
  antennuttag_1_N = mkN "antennuttag" neutrum  ; -- antennuttag..nn.1
  antependium_1_N = mkN "antependium" "antependiet" "antependier" "antependierna" ; -- antependium..nn.1
  antepenultima_1_N = mkN "antepenultima" ; -- antepenultima..nn.1
  anti_gbm_sjukdom_1_N = mkN "anti-gbm-sjukdom" ; -- anti-gbm-sjukdom..nn.1
  anti_1_A = mkA "anti" ; -- anti..av.1
  antiabortlag_1_N = mkN "antiabortlag" ; -- antiabortlag..nn.1
  antiamerikansk_1_A = mkA "antiamerikansk" ; -- antiamerikansk..av.1
  antibakteriell_1_A = mkA "antibakteriell" ; -- antibakteriell..av.1
  antibarbarus_1_N = mkN "antibarbarus" ; -- antibarbarus..nn.1
  antibiotika_1_N = mkN "antibiotika" ; -- antibiotika..nn.1
  antibiotikabehandling_1_N = mkN "antibiotikabehandling" ; -- antibiotikabehandling..nn.1
  antibiotikaresistens_1_N = mkN "antibiotikaresistens" ; -- antibiotikaresistens..nn.1
  antibiotikaresistent_1_A = mkA "antibiotikaresistent" "antibiotikaresistent" ; -- antibiotikaresistent..av.1
  antibiotikum_1_N = mkN "antibiotikum" "antibiotikumet" "antibiotika" "antibiotikana" ; -- antibiotikum..nn.1
  antibiotisk_1_A = mkA "antibiotisk" ; -- antibiotisk..av.1
  antichambrera_1_V = mkV "antichambrerar" ; -- antichambrera..vb.1
  antichambrerande_1_N = mkN "antichambrerande" ; -- antichambrerande..nn.1
  antichambrerbar_1_A = mkA "antichambrerbar" ; -- antichambrerbar..av.1
  antichambrerbarhet_1_N = mkN "antichambrerbarhet" ; -- antichambrerbarhet..nn.1
  antichambrering_1_N = mkN "antichambrering" ; -- antichambrering..nn.1
  anticyklon_1_N = mkN "anticyklon" "anticykloner" ; -- anticyklon..nn.1
  antidemokrat_1_N = mkN "antidemokrat" "antidemokrater" ; -- antidemokrat..nn.1
  antidemokratisk_1_A = mkA "antidemokratisk" ; -- antidemokratisk..av.1
  antidepressiv_1_A = mkA "antidepressiv" ; -- antidepressiv..av.1
  antidiskrimineringsbyrå_1_N = mkN "antidiskrimineringsbyrå" "antidiskrimineringsbyråer" ; -- antidiskrimineringsbyrå..nn.1
  antidot_1_N = mkN "antidot" "antidotet" "antidoter" "antidoterna" ; -- antidot..nn.1
  antielitistisk_1_A = mkA "antielitistisk" ; -- antielitistisk..av.1
  antietablissemangsretorik_1_N = mkN "antietablissemangsretorik" ; -- antietablissemangsretorik..nn.1
  antieuropeisk_1_A = mkA "antieuropeisk" ; -- antieuropeisk..av.1
  antiexpressionistisk_1_A = mkA "antiexpressionistisk" ; -- antiexpressionistisk..av.1
  antifascistisk_1_A = mkA "antifascistisk" ; -- antifascistisk..av.1
  antifoni_1_N = mkN "antifoni" "antifonier" ; -- antifoni..nn.1
  antifosfolipidsyndrom_1_N = mkN "antifosfolipidsyndrom" neutrum  ; -- antifosfolipidsyndrom..nn.1
  antifundamentalistisk_1_A = mkA "antifundamentalistisk" ; -- antifundamentalistisk..av.1
  antigen_1_N = mkN "antigen" "antigener" ; -- antigen..nn.1
  antiguan_1_N = mkN "antiguan" "antiguaner" ; -- antiguan..nn.1
  antiguansk_1_A = mkA "antiguansk" ; -- antiguansk..av.1
  antiguanska_1_N = mkN "antiguanska" ; -- antiguanska..nn.1
  antihelix_1_N = mkN "antihelix" ; -- antihelix..nn.1
  antihistamin_1_N = mkN "antihistamin" "antihistaminet" "antihistaminer" "antihistaminerna" ; -- antihistamin..nn.1
  antihjälte_1_N = mkN "antihjälte" utrum  ; -- antihjälte..nn.1
  antihumanistisk_1_A = mkA "antihumanistisk" ; -- antihumanistisk..av.1
  antiidealistisk_1_A = mkA "antiidealistisk" ; -- antiidealistisk..av.1
  antiimperialistisk_1_A = mkA "antiimperialistisk" ; -- antiimperialistisk..av.1
  antiindividualistisk_1_A = mkA "antiindividualistisk" ; -- antiindividualistisk..av.1
  antiinflammatorisk_1_A = mkA "antiinflammatorisk" ; -- antiinflammatorisk..av.1
  antiintellektualism_1_N = mkN "antiintellektualism" "antiintellektualismer" ; -- antiintellektualism..nn.1
  antiintellektualistisk_1_A = mkA "antiintellektualistisk" ; -- antiintellektualistisk..av.1
  antiintellektuell_1_A = mkA "antiintellektuell" ; -- antiintellektuell..av.1
  antiislamistisk_1_A = mkA "antiislamistisk" ; -- antiislamistisk..av.1
  antijudisk_1_A = mkA "antijudisk" ; -- antijudisk..av.1
  antik_1_A = mkA "antik" ; -- antik..av.1
  antik_1_N = mkN "antik" ; -- antik..nn.1
  antikbehandla_1_V = mkV "antikbehandlar" ; -- antikbehandla..vb.1
  antikbehandlande_1_N = mkN "antikbehandlande" ; -- antikbehandlande..nn.1
  antikfynda_1_V = mkV "antikfyndar" ; -- antikfynda..vb.1
  antikfyndande_1_N = mkN "antikfyndande" ; -- antikfyndande..nn.1
  antikisera_1_V = mkV "antikiserar" ; -- antikisera..vb.1
  antikiserande_1_N = mkN "antikiserande" ; -- antikiserande..nn.1
  antikiserbar_1_A = mkA "antikiserbar" ; -- antikiserbar..av.1
  antikiserbarhet_1_N = mkN "antikiserbarhet" ; -- antikiserbarhet..nn.1
  antikisering_1_N = mkN "antikisering" ; -- antikisering..nn.1
  antiklerikal_1_A = mkA "antiklerikal" ; -- antiklerikal..av.1
  antiklimax_1_N = mkN "antiklimax" ; -- antiklimax..nn.1
  antiklinal_1_N = mkN "antiklinal" "antiklinaler" ; -- antiklinal..nn.1
  antikljus_1_N = mkN "antikljus" neutrum  ; -- antikljus..nn.1
  antikommunism_1_N = mkN "antikommunism" "antikommunismer" ; -- antikommunism..nn.1
  antikommunistisk_1_A = mkA "antikommunistisk" ; -- antikommunistisk..av.1
  antikonceptionell_1_A = mkA "antikonceptionell" ; -- antikonceptionell..av.1
  antikorruptionsaktivist_1_N = mkN "antikorruptionsaktivist" "antikorruptionsaktivister" ; -- antikorruptionsaktivist..nn.1
  antikorruptionskonferens_1_N = mkN "antikorruptionskonferens" "antikorruptionskonferenser" ; -- antikorruptionskonferens..nn.1
  antikrist_1_N = mkN "antikrist" ; -- antikrist..nn.1
  antikristlig_1_A = mkA "antikristlig" ; -- antikristlig..av.1
  antikropp_1_N = mkN "antikropp" ; -- antikropp..nn.1
  antikroppsbrist_1_N = mkN "antikroppsbrist" ; -- antikroppsbrist..nn.1
  antiksamling_1_N = mkN "antiksamling" ; -- antiksamling..nn.1
  antikva_1_N = mkN "antikva" ; -- antikva..nn.1
  antikvariat_1_N = mkN "antikvariat" neutrum  ; -- antikvariat..nn.1
  antikvarie_1_N = mkN "antikvarie" "antikvarier" ; -- antikvarie..nn.1
  antikvarisk_1_A = mkA "antikvarisk" ; -- antikvarisk..av.1
  antikverad_1_A = mkA "antikverad" ; -- antikverad..av.1
  antikvitet_1_N = mkN "antikvitet" "antikviteter" ; -- antikvitet..nn.1
  antikvitetshandel_1_N = mkN "antikvitetshandel" ; -- antikvitetshandel..nn.1
  antikvitetshandlare_1_N = mkN "antikvitetshandlare" utrum  ; -- antikvitetshandlare..nn.1
  antikvitetsjägare_1_N = mkN "antikvitetsjägare" utrum  ; -- antikvitetsjägare..nn.1
  antikvitetssamling_1_N = mkN "antikvitetssamling" ; -- antikvitetssamling..nn.1
  antikvärde_1_N = mkN "antikvärde" ; -- antikvärde..nn.1
  antilop_1_N = mkN "antilop" "antiloper" ; -- antilop..nn.1
  antimakass_1_N = mkN "antimakass" "antimakasser" ; -- antimakass..nn.1
  antimateria_1_N = mkN "antimateria" ; -- antimateria..nn.1
  antimilitarism_1_N = mkN "antimilitarism" "antimilitarismer" ; -- antimilitarism..nn.1
  antimilitarist_1_N = mkN "antimilitarist" "antimilitarister" ; -- antimilitarist..nn.1
  antimilitaristisk_1_A = mkA "antimilitaristisk" ; -- antimilitaristisk..av.1
  antimon_1_N = mkN "antimon" ; -- antimon..nn.1
  antimonglans_1_N = mkN "antimonglans" ; -- antimonglans..nn.1
  antimögelbehandlad_1_A = mkA "antimögelbehandlad" ; -- antimögelbehandlad..av.1
  antinazistisk_1_A = mkA "antinazistisk" ; -- antinazistisk..av.1
  antingen_1_Adv = mkAdv "antingen" ; -- antingen..ab.1
  antinomi_1_N = mkN "antinomi" "antinomier" ; -- antinomi..nn.1
  antioxidant_1_N = mkN "antioxidant" "antioxidanter" ; -- antioxidant..nn.1
  antioxidationsmedel_1_N = mkN "antioxidationsmedel" neutrum  ; -- antioxidationsmedel..nn.1
  antipartikel_1_N = mkN "antipartikel" ; -- antipartikel..nn.1
  antipassad_1_N = mkN "antipassad" "antipassader" ; -- antipassad..nn.1
  antipati_1_N = mkN "antipati" "antipatier" ; -- antipati..nn.1
  antipatisk_1_A = mkA "antipatisk" ; -- antipatisk..av.1
  antipod_1_N = mkN "antipod" "antipoder" ; -- antipod..nn.1
  antipodisk_1_A = mkA "antipodisk" ; -- antipodisk..av.1
  antipolitisk_1_A = mkA "antipolitisk" ; -- antipolitisk..av.1
  antipsykiatri_1_N = mkN "antipsykiatri" ; -- antipsykiatri..nn.1
  antirasistisk_1_A = mkA "antirasistisk" ; -- antirasistisk..av.1
  antireflexbehandla_1_V = mkV "antireflexbehandlar" ; -- antireflexbehandla..vb.1
  antireligiös_1_A = mkA "antireligiös" ; -- antireligiös..av.1
  antirojalistisk_1_A = mkA "antirojalistisk" ; -- antirojalistisk..av.1
  antirullningsfena_1_N = mkN "antirullningsfena" ; -- antirullningsfena..nn.1
  antirynkkräm_1_N = mkN "antirynkkräm" "antirynkkrämer" ; -- antirynkkräm..nn.1
  antisemit_1_N = mkN "antisemit" "antisemiter" ; -- antisemit..nn.1
  antisemitisk_1_A = mkA "antisemitisk" ; -- antisemitisk..av.1
  antisemitism_1_N = mkN "antisemitism" "antisemitismer" ; -- antisemitism..nn.1
  antisemitledare_1_N = mkN "antisemitledare" utrum  ; -- antisemitledare..nn.1
  antiseptik_1_N = mkN "antiseptik" ; -- antiseptik..nn.1
  antiseptika_1_N = mkN "antiseptika" "antiseptikat" "antiseptika" "antiseptikana" ; -- antiseptika..nn.1
  antiseptisk_1_A = mkA "antiseptisk" ; -- antiseptisk..av.1
  antisionism_1_N = mkN "antisionism" "antisionismer" ; -- antisionism..nn.1
  antisionistisk_1_A = mkA "antisionistisk" ; -- antisionistisk..av.1
  antiskating_1_N = mkN "antiskating" ; -- antiskating..nn.1
  antisladdsystem_1_N = mkN "antisladdsystem" neutrum  ; -- antisladdsystem..nn.1
  antistatisk_1_A = mkA "antistatisk" ; -- antistatisk..av.1
  antistatmedel_1_N = mkN "antistatmedel" neutrum  ; -- antistatmedel..nn.1
  antisyrisk_1_A = mkA "antisyrisk" ; -- antisyrisk..av.1
  antites_1_N = mkN "antites" "antiteser" ; -- antites..nn.1
  antitetisk_1_A = mkA "antitetisk" ; -- antitetisk..av.1
  antitoxin_1_N = mkN "antitoxin" "antitoxiner" ; -- antitoxin..nn.1
  antitragus_1_N = mkN "antitragus" ; -- antitragus..nn.1
  antivibrationshandtag_1_N = mkN "antivibrationshandtag" neutrum  ; -- antivibrationshandtag..nn.1
  antiviral_1_A = mkA "antiviral" ; -- antiviral..av.1
  antivirusexpert_1_N = mkN "antivirusexpert" "antivirusexperter" ; -- antivirusexpert..nn.1
  antivirusprogram_1_N = mkN "antivirusprogram" "antivirusprogrammet" "antivirusprogram" "antivirusprogrammen" ; -- antivirusprogram..nn.1
  antiålderskräm_1_N = mkN "antiålderskräm" "antiålderskrämer" ; -- antiålderskräm..nn.1
  antologi_1_N = mkN "antologi" "antologier" ; -- antologi..nn.1
  antonym_1_A = mkA "antonym" ; -- antonym..av.1
  antonym_1_N = mkN "antonym" "antonymer" ; -- antonym..nn.1
  antracit_1_N = mkN "antracit" ; -- antracit..nn.1
  antracitkol_1_N = mkN "antracitkol" neutrum  ; -- antracitkol..nn.1
  antrakos_1_N = mkN "antrakos" ; -- antrakos..nn.1
  antrakosilikos_1_N = mkN "antrakosilikos" ; -- antrakosilikos..nn.1
  antrax_1_N = mkN "antrax" "antraxer" ; -- antrax..nn.1
  antropisk_1_A = mkA "antropisk" ; -- antropisk..av.1
  antropocentrisk_1_A = mkA "antropocentrisk" ; -- antropocentrisk..av.1
  antropofag_1_N = mkN "antropofag" "antropofager" ; -- antropofag..nn.1
  antropofagi_1_N = mkN "antropofagi" ; -- antropofagi..nn.1
  antropoid_1_N = mkN "antropoid" "antropoider" ; -- antropoid..nn.1
  antropolog_1_N = mkN "antropolog" "antropologer" ; -- antropolog..nn.1
  antropologi_1_N = mkN "antropologi" ; -- antropologi..nn.1
  antropologisk_1_A = mkA "antropologisk" ; -- antropologisk..av.1
  antropomorf_1_A = mkA "antropomorf" ; -- antropomorf..av.1
  antropomorfisk_1_A = mkA "antropomorfisk" ; -- antropomorfisk..av.1
  antropomorfism_1_N = mkN "antropomorfism" "antropomorfismer" ; -- antropomorfism..nn.1
  antropomorfistisk_1_A = mkA "antropomorfistisk" ; -- antropomorfistisk..av.1
  antroposof_1_N = mkN "antroposof" "antroposofer" ; -- antroposof..nn.1
  antroposofi_1_N = mkN "antroposofi" ; -- antroposofi..nn.1
  antroposofisk_1_A = mkA "antroposofisk" ; -- antroposofisk..av.1
  anträda_1_V = mkV "anträda" "anträdde" "anträtt" ; -- anträda..vb.1
  anträdande_1_N = mkN "anträdande" ; -- anträdande..nn.1
  anträde_1_N = mkN "anträde" ; -- anträde..nn.1
  anträffa_1_V = mkV "anträffar" ; -- anträffa..vb.1
  anträffande_1_N = mkN "anträffande" ; -- anträffande..nn.1
  anträffbar_1_A = mkA "anträffbar" ; -- anträffbar..av.1
  anträffbarhet_1_N = mkN "anträffbarhet" ; -- anträffbarhet..nn.1
  antvarda_1_V = mkV "antvardar" ; -- antvarda..vb.1
  antvardande_1_N = mkN "antvardande" ; -- antvardande..nn.1
  antyda_1_V = mkV "antyda" "antydde" "antytt" ; -- antyda..vb.1
  antydande_1_N = mkN "antydande" ; -- antydande..nn.1
  antydning_1_N = mkN "antydning" ; -- antydning..nn.1
  antydningsvis_1_Adv = mkAdv "antydningsvis" ; -- antydningsvis..ab.1
  antända_1_V = mkV "antänder" ; -- antända..vb.1
  antändande_1_N = mkN "antändande" ; -- antändande..nn.1
  antändbar_1_A = mkA "antändbar" ; -- antändbar..av.1
  antändbarhet_1_N = mkN "antändbarhet" ; -- antändbarhet..nn.1
  antändning_1_N = mkN "antändning" ; -- antändning..nn.1
  antåg_1_N = mkN "antåg" neutrum  ; -- antåg..nn.1
  antåga_1_V = mkV "antågar" ; -- antåga..vb.1
  antågande_1_N = mkN "antågande" ; -- antågande..nn.1
  anuri_1_N = mkN "anuri" ; -- anuri..nn.1
  anus_1_N = mkN "anus" ; -- anus..nn.1
  anvisa_1_V = mkV "anvisar" ; -- anvisa..vb.1
  anvisande_1_N = mkN "anvisande" ; -- anvisande..nn.1
  anvisning_1_N = mkN "anvisning" ; -- anvisning..nn.1
  anvisningskommun_1_N = mkN "anvisningskommun" "anvisningskommuner" ; -- anvisningskommun..nn.1
  anvisningsläkare_1_N = mkN "anvisningsläkare" utrum  ; -- anvisningsläkare..nn.1
  använda_1_V = mkV "använder" ; -- använda..vb.1
  användande_1_N = mkN "användande" ; -- användande..nn.1
  användare_1_N = mkN "användare" utrum  ; -- användare..nn.1
  användargrupp_1_N = mkN "användargrupp" "användargrupper" ; -- användargrupp..nn.1
  användarvänlig_1_A = mkA "användarvänlig" ; -- användarvänlig..av.1
  användarvänlighet_1_N = mkN "användarvänlighet" ; -- användarvänlighet..nn.1
  användbar_1_A = mkA "användbar" ; -- användbar..av.1
  användbarhet_1_N = mkN "användbarhet" "användbarheter" ; -- användbarhet..nn.1
  användbarhetsaspekt_1_N = mkN "användbarhetsaspekt" "användbarhetsaspekter" ; -- användbarhetsaspekt..nn.1
  användning_1_N = mkN "användning" ; -- användning..nn.1
  användningslösning_1_N = mkN "användningslösning" ; -- användningslösning..nn.1
  användningsmöjlighet_1_N = mkN "användningsmöjlighet" "användningsmöjligheter" ; -- användningsmöjlighet..nn.1
  användningsområde_1_N = mkN "användningsområde" ; -- användningsområde..nn.1
  användningssätt_1_N = mkN "användningssätt" neutrum  ; -- användningssätt..nn.1
  aorist_1_N = mkN "aorist" "aorister" ; -- aorist..nn.1
  aorta_1_N = mkN "aorta" ; -- aorta..nn.1
  aortaaneurysm_1_N = mkN "aortaaneurysm" neutrum  ; -- aortaaneurysm..nn.1
  aortabristning_1_N = mkN "aortabristning" ; -- aortabristning..nn.1
  aortabråck_1_N = mkN "aortabråck" neutrum  ; -- aortabråck..nn.1
  aortabåge_1_N = mkN "aortabåge" utrum  ; -- aortabåge..nn.1
  aortabågesyndrom_1_N = mkN "aortabågesyndrom" neutrum  ; -- aortabågesyndrom..nn.1
  aortadissektion_1_N = mkN "aortadissektion" ; -- aortadissektion..nn.1
  aortaförträngning_1_N = mkN "aortaförträngning" ; -- aortaförträngning..nn.1
  aortainflammation_1_N = mkN "aortainflammation" ; -- aortainflammation..nn.1
  aortainsufficiens_1_N = mkN "aortainsufficiens" "aortainsufficienser" ; -- aortainsufficiens..nn.1
  aortaklaff_1_N = mkN "aortaklaff" ; -- aortaklaff..nn.1
  aortaklaffinsufficiens_1_N = mkN "aortaklaffinsufficiens" "aortaklaffinsufficienser" ; -- aortaklaffinsufficiens..nn.1
  aortaklaffläckage_1_N = mkN "aortaklaffläckage" "aortaklaffläckageen" "aortaklaffläckageer" "aortaklaffläckageerna" ; -- aortaklaffläckage..nn.1
  aortaklaffprolaps_1_N = mkN "aortaklaffprolaps" "aortaklaffprolapser" ; -- aortaklaffprolaps..nn.1
  aortaklaffstenos_1_N = mkN "aortaklaffstenos" "aortaklaffstenoser" ; -- aortaklaffstenos..nn.1
  aortaklafförträngning_1_N = mkN "aortaklafförträngning" ; -- aortaklafförträngning..nn.1
  aortakoarktation_1_N = mkN "aortakoarktation" ; -- aortakoarktation..nn.1
  aortaruptur_1_N = mkN "aortaruptur" "aortarupturer" ; -- aortaruptur..nn.1
  aortasjukdom_1_N = mkN "aortasjukdom" ; -- aortasjukdom..nn.1
  aortastenos_1_N = mkN "aortastenos" "aortastenoser" ; -- aortastenos..nn.1
  aortit_syndrom_1_N = mkN "aortit-syndrom" neutrum  ; -- aortit-syndrom..nn.1
  aortit_1_N = mkN "aortit" "aortiter" ; -- aortit..nn.1
  apa_1_A = mkA "apa" ; -- apa..av.1
  apa_1_N = mkN "apa" ; -- apa..nn.1
  apache_1_N = mkN "apache" "apacher" ; -- apache..nn.1
  apanage_1_N = mkN "apanage" "apanaget" "apanage" "apanagen" ; -- apanage..nn.1
  apanagebelopp_1_N = mkN "apanagebelopp" neutrum  ; -- apanagebelopp..nn.1
  apart_1_A = mkA "apart" "apart" ; -- apart..av.1
  apart_1_N = mkN "apart" "aparter" ; -- apart..nn.1
  apartheid_1_N = mkN "apartheid" ; -- apartheid..nn.1
  apartheidlag_1_N = mkN "apartheidlag" ; -- apartheidlag..nn.1
  apartheidregim_1_N = mkN "apartheidregim" "apartheidregimer" ; -- apartheidregim..nn.1
  apati_1_N = mkN "apati" "apatier" ; -- apati..nn.1
  apatisk_1_A = mkA "apatisk" ; -- apatisk..av.1
  apatit_1_N = mkN "apatit" ; -- apatit..nn.1
  apbrödsträd_1_N = mkN "apbrödsträd" neutrum  ; -- apbrödsträd..nn.1
  apc_resistens_1_N = mkN "apc-resistens" ; -- apc-resistens..nn.1
  apekatt_1_N = mkN "apekatt" "apekatter" ; -- apekatt..nn.1
  apel_1_N = mkN "apel" ; -- apel..nn.1
  apelgrå_1_A = mkA "apelgrå" "apelgrått" ; -- apelgrå..av.1
  apelkastad_1_A = mkA "apelkastad" ; -- apelkastad..av.1
  apelsin_1_N = mkN "apelsin" "apelsiner" ; -- apelsin..nn.1
  apelsingelé_1_N = mkN "apelsingelé" "apelsingeléer" ; -- apelsingelé..nn.1
  apelsinglass_1_N = mkN "apelsinglass" ; -- apelsinglass..nn.1
  apelsinjuice_1_N = mkN "apelsinjuice" "apelsinjuicer" ; -- apelsinjuice..nn.1
  apelsinklyfta_1_N = mkN "apelsinklyfta" ; -- apelsinklyfta..nn.1
  apelsinmarmelad_1_N = mkN "apelsinmarmelad" "apelsinmarmelader" ; -- apelsinmarmelad..nn.1
  apelsinmousse_1_N = mkN "apelsinmousse" "apelsinmousser" ; -- apelsinmousse..nn.1
  apelsinmoussetårta_1_N = mkN "apelsinmoussetårta" ; -- apelsinmoussetårta..nn.1
  apelsinsaft_1_N = mkN "apelsinsaft" "apelsinsafter" ; -- apelsinsaft..nn.1
  apelsinskal_1_N = mkN "apelsinskal" neutrum  ; -- apelsinskal..nn.1
  apelsinträd_1_N = mkN "apelsinträd" neutrum  ; -- apelsinträd..nn.1
  aperi_1_N = mkN "aperi" "aperiet" "aperier" "aperierna" ; -- aperi..nn.1
  aperitif_1_N = mkN "aperitif" "aperitifer" ; -- aperitif..nn.1
  apermi_1_N = mkN "apermi" ; -- apermi..nn.1
  apertur_1_N = mkN "apertur" "aperturer" ; -- apertur..nn.1
  apetidin_1_N = mkN "apetidin" "apetidiner" ; -- apetidin..nn.1
  apex_1_N = mkN "apex" neutrum  ; -- apex..nn.1
  aphelium_1_N = mkN "aphelium" "apheliet" "aphelier" "aphelierna" ; -- aphelium..nn.1
  aphjärna_1_N = mkN "aphjärna" ; -- aphjärna..nn.1
  aphona_1_N = mkN "aphona" ; -- aphona..nn.1
  apkoppa_1_N = mkN "apkoppa" ; -- apkoppa..nn.1
  aplik_1_A = mkA "aplik" ; -- aplik..av.1
  aplik_1_N = mkN "aplik" neutrum  ; -- aplik..nn.1
  apliknande_1_A = mkA "apliknande" ; -- apliknande..av.1
  aplomb_1_N = mkN "aplomb" ; -- aplomb..nn.1
  apmänniska_1_N = mkN "apmänniska" ; -- apmänniska..nn.1
  apne_1_N = mkN "apne" "apneer" ; -- apne..nn.1
  apné_1_N = mkN "apné" "apnéer" ; -- apné..nn.1
  apodiktisk_1_A = mkA "apodiktisk" ; -- apodiktisk..av.1
  apogeum_1_N = mkN "apogeum" neutrum  ; -- apogeum..nn.1
  apokalyps_1_N = mkN "apokalyps" "apokalypser" ; -- apokalyps..nn.1
  apokalyptisk_1_A = mkA "apokalyptisk" ; -- apokalyptisk..av.1
  apokope_1_N = mkN "apokope" utrum  ; -- apokope..nn.1
  apokrin_1_A = mkA "apokrin" ; -- apokrin..av.1
  apokryfisk_1_A = mkA "apokryfisk" ; -- apokryfisk..av.1
  apolitisk_1_A = mkA "apolitisk" ; -- apolitisk..av.1
  apollinisk_1_A = mkA "apollinisk" ; -- apollinisk..av.1
  apollinsk_1_A = mkA "apollinsk" ; -- apollinsk..av.1
  apollofjäril_1_N = mkN "apollofjäril" ; -- apollofjäril..nn.1
  apologet_1_N = mkN "apologet" "apologeter" ; -- apologet..nn.1
  apologetik_1_N = mkN "apologetik" ; -- apologetik..nn.1
  apologetisk_1_A = mkA "apologetisk" ; -- apologetisk..av.1
  apologi_1_N = mkN "apologi" "apologier" ; -- apologi..nn.1
  apologist_1_N = mkN "apologist" "apologister" ; -- apologist..nn.1
  apomorfi_1_N = mkN "apomorfi" "apomorfier" ; -- apomorfi..nn.1
  apoplektisk_1_A = mkA "apoplektisk" ; -- apoplektisk..av.1
  apoplexi_1_N = mkN "apoplexi" "apoplexier" ; -- apoplexi..nn.1
  apostel_1_N = mkN "apostel" ; -- apostel..nn.1
  aposteriorisk_1_A = mkA "aposteriorisk" ; -- aposteriorisk..av.1
  apostolisk_1_A = mkA "apostolisk" ; -- apostolisk..av.1
  apostrof_1_N = mkN "apostrof" "apostrofer" ; -- apostrof..nn.1
  apostrofera_1_V = mkV "apostroferar" ; -- apostrofera..vb.1
  apostroferande_1_N = mkN "apostroferande" ; -- apostroferande..nn.1
  apostroferbar_1_A = mkA "apostroferbar" ; -- apostroferbar..av.1
  apostroferbarhet_1_N = mkN "apostroferbarhet" ; -- apostroferbarhet..nn.1
  apostrofering_1_N = mkN "apostrofering" ; -- apostrofering..nn.1
  apotek_1_N = mkN "apotek" neutrum  ; -- apotek..nn.1
  apotekare_1_N = mkN "apotekare" utrum  ; -- apotekare..nn.1
  apotekskedja_1_N = mkN "apotekskedja" ; -- apotekskedja..nn.1
  apotekskö_1_N = mkN "apotekskö" "apotekskön" "apoteksköer" "apoteksköerna" ; -- apotekskö..nn.1
  apoteksväxt_1_N = mkN "apoteksväxt" "apoteksväxter" ; -- apoteksväxt..nn.1
  apoteksvåg_1_N = mkN "apoteksvåg" ; -- apoteksvåg..nn.1
  apoteos_1_N = mkN "apoteos" "apoteoser" ; -- apoteos..nn.1
  apothesium_1_N = mkN "apothesium" "apothesiet" "apothesier" "apothesierna" ; -- apothesium..nn.1
  app_1_N = mkN "app" ; -- app..nn.1
  appa_1_V = mkV "appar" ; -- appa..vb.1
  apparans_1_N = mkN "apparans" "apparanser" ; -- apparans..nn.1
  apparat_1_N = mkN "apparat" "apparater" ; -- apparat..nn.1
  apparatrum_1_N = mkN "apparatrum" "apparatrummet" "apparatrum" "apparatrummen" ; -- apparatrum..nn.1
  apparatur_1_N = mkN "apparatur" "apparaturer" ; -- apparatur..nn.1
  apparition_1_N = mkN "apparition" ; -- apparition..nn.1
  appell_1_N = mkN "appell" "appeller" ; -- appell..nn.1
  appellant_1_N = mkN "appellant" "appellanter" ; -- appellant..nn.1
  appellationsdomstol_1_N = mkN "appellationsdomstol" ; -- appellationsdomstol..nn.1
  appellativ_1_N = mkN "appellativ" neutrum  ; -- appellativ..nn.1
  appellera_1_V = mkV "appellerar" ; -- appellera..vb.1
  appellerande_1_N = mkN "appellerande" ; -- appellerande..nn.1
  appellerbar_1_A = mkA "appellerbar" ; -- appellerbar..av.1
  appellerbarhet_1_N = mkN "appellerbarhet" ; -- appellerbarhet..nn.1
  appellering_1_N = mkN "appellering" ; -- appellering..nn.1
  appendicit_1_N = mkN "appendicit" "appendiciter" ; -- appendicit..nn.1
  appendix_1_N = mkN "appendix" neutrum  ; -- appendix..nn.1
  appendixcancer_1_N = mkN "appendixcancer" ; -- appendixcancer..nn.1
  appendixtumör_1_N = mkN "appendixtumör" "appendixtumörer" ; -- appendixtumör..nn.1
  apperception_1_N = mkN "apperception" ; -- apperception..nn.1
  applicera_1_V = mkV "applicerar" ; -- applicera..vb.1
  applicerande_1_N = mkN "applicerande" ; -- applicerande..nn.1
  applicerbar_1_A = mkA "applicerbar" ; -- applicerbar..av.1
  applicerbarhet_1_N = mkN "applicerbarhet" ; -- applicerbarhet..nn.1
  applicering_1_N = mkN "applicering" ; -- applicering..nn.1
  applikation_1_N = mkN "applikation" ; -- applikation..nn.1
  applikator_1_N = mkN "applikator" "applikatorer" ; -- applikator..nn.1
  applikatorisk_1_A = mkA "applikatorisk" ; -- applikatorisk..av.1
  applikatur_1_N = mkN "applikatur" "applikaturer" ; -- applikatur..nn.1
  applåd_1_N = mkN "applåd" "applåder" ; -- applåd..nn.1
  applådera_1_V = mkV "applåderar" ; -- applådera..vb.1
  applåderande_1_N = mkN "applåderande" ; -- applåderande..nn.1
  applåderbar_1_A = mkA "applåderbar" ; -- applåderbar..av.1
  applåderbarhet_1_N = mkN "applåderbarhet" ; -- applåderbarhet..nn.1
  applådering_1_N = mkN "applådering" ; -- applådering..nn.1
  applådsalva_1_N = mkN "applådsalva" ; -- applådsalva..nn.1
  applådåska_1_N = mkN "applådåska" ; -- applådåska..nn.1
  apport_1_N = mkN "apport" "apporter" ; -- apport..nn.1
  apportera_1_V = mkV "apporterar" ; -- apportera..vb.1
  apporterande_1_N = mkN "apporterande" ; -- apporterande..nn.1
  apporterbar_1_A = mkA "apporterbar" ; -- apporterbar..av.1
  apporterbarhet_1_N = mkN "apporterbarhet" ; -- apporterbarhet..nn.1
  apportering_1_N = mkN "apportering" ; -- apportering..nn.1
  apposition_1_N = mkN "apposition" ; -- apposition..nn.1
  appreciera_1_V = mkV "apprecierar" ; -- appreciera..vb.1
  apprecierande_1_N = mkN "apprecierande" ; -- apprecierande..nn.1
  apprecierbar_1_A = mkA "apprecierbar" ; -- apprecierbar..av.1
  apprecierbarhet_1_N = mkN "apprecierbarhet" ; -- apprecierbarhet..nn.1
  appreciering_1_N = mkN "appreciering" ; -- appreciering..nn.1
  appretera_1_V = mkV "appreterar" ; -- appretera..vb.1
  appreterande_1_N = mkN "appreterande" ; -- appreterande..nn.1
  appreterbar_1_A = mkA "appreterbar" ; -- appreterbar..av.1
  appreterbarhet_1_N = mkN "appreterbarhet" ; -- appreterbarhet..nn.1
  appretering_1_N = mkN "appretering" ; -- appretering..nn.1
  appretur_1_N = mkN "appretur" "appreturer" ; -- appretur..nn.1
  appretyr_1_N = mkN "appretyr" "appretyrer" ; -- appretyr..nn.1
  approach_1_N = mkN "approach" "approacher" ; -- approach..nn.1
  approbabel_1_A = mkA "approbabel" ; -- approbabel..av.1
  approbatur_1_N = mkN "approbatur" neutrum  ; -- approbatur..nn.1
  approchera_1_V = mkV "approcherar" ; -- approchera..vb.1
  approcherande_1_N = mkN "approcherande" ; -- approcherande..nn.1
  approcherbar_1_A = mkA "approcherbar" ; -- approcherbar..av.1
  approcherbarhet_1_N = mkN "approcherbarhet" ; -- approcherbarhet..nn.1
  approchering_1_N = mkN "approchering" ; -- approchering..nn.1
  approximation_1_N = mkN "approximation" ; -- approximation..nn.1
  approximationsteori_1_N = mkN "approximationsteori" "approximationsteorier" ; -- approximationsteori..nn.1
  approximationsvis_1_Adv = mkAdv "approximationsvis" ; -- approximationsvis..ab.1
  approximativ_1_A = mkA "approximativ" ; -- approximativ..av.1
  approximera_1_V = mkV "approximerar" ; -- approximera..vb.1
  approximerande_1_N = mkN "approximerande" ; -- approximerande..nn.1
  approximerbar_1_A = mkA "approximerbar" ; -- approximerbar..av.1
  approximerbarhet_1_N = mkN "approximerbarhet" ; -- approximerbarhet..nn.1
  approximering_1_N = mkN "approximering" ; -- approximering..nn.1
  aprak_1_A = mkA "aprak" ; -- aprak..av.1
  apraxi_1_N = mkN "apraxi" "apraxier" ; -- apraxi..nn.1
  aprikos_1_N = mkN "aprikos" "aprikoser" ; -- aprikos..nn.1
  april_1_N = mkN "april" ; -- april..nn.1
  aprildag_1_N = mkN "aprildag" ; -- aprildag..nn.1
  aprilskämt_1_N = mkN "aprilskämt" neutrum  ; -- aprilskämt..nn.1
  aprilsnö_1_N = mkN "aprilsnö" ; -- aprilsnö..nn.1
  aprilväder_1_N = mkN "aprilväder" neutrum  ; -- aprilväder..nn.1
  apriorisk_1_A = mkA "apriorisk" ; -- apriorisk..av.1
  apropå_1_Adv = mkAdv "apropå" ; -- apropå..ab.1
  apropå_1_N = mkN "apropå" "apropåt" "apropåer" "apropåerna" ; -- apropå..nn.1
  apsjukdom_1_N = mkN "apsjukdom" ; -- apsjukdom..nn.1
  apsort_1_N = mkN "apsort" "apsorter" ; -- apsort..nn.1
  apspel_1_N = mkN "apspel" "apspelet" "apspel" "apspelen" ; -- apspel..nn.1
  aptera_1_V = mkV "apterar" ; -- aptera..vb.1
  apterande_1_N = mkN "apterande" ; -- apterande..nn.1
  apterbar_1_A = mkA "apterbar" ; -- apterbar..av.1
  apterbarhet_1_N = mkN "apterbarhet" ; -- apterbarhet..nn.1
  aptering_1_N = mkN "aptering" ; -- aptering..nn.1
  aptit_1_N = mkN "aptit" ; -- aptit..nn.1
  aptitlig_1_A = mkA "aptitlig" ; -- aptitlig..av.1
  aptitlighet_1_N = mkN "aptitlighet" "aptitligheter" ; -- aptitlighet..nn.1
  aptitlöshet_1_N = mkN "aptitlöshet" "aptitlösheter" ; -- aptitlöshet..nn.1
  aptitretande_1_A = mkA "aptitretande" ; -- aptitretande..av.1
  aptitretare_1_N = mkN "aptitretare" utrum  ; -- aptitretare..nn.1
  apudom_1_N = mkN "apudom" neutrum  ; -- apudom..nn.1
  ar_1_N = mkN "ar" neutrum  ; -- ar..nn.1
  ara_1_N = mkN "ara" ; -- ara..nn.1
  arab_1_N = mkN "arab" "araber" ; -- arab..nn.1
  arabesk_1_N = mkN "arabesk" "arabesker" ; -- arabesk..nn.1
  arabeskmönster_1_N = mkN "arabeskmönster" neutrum  ; -- arabeskmönster..nn.1
  arabisk_1_A = mkA "arabisk" ; -- arabisk..av.1
  arabiska_1_N = mkN "arabiska" ; -- arabiska..nn.1
  arabiska_2_N = mkN "arabiska" ; -- arabiska..nn.2
  arabiskspråkig_1_A = mkA "arabiskspråkig" ; -- arabiskspråkig..av.1
  arabisktalande_1_A = mkA "arabisktalande" ; -- arabisktalande..av.1
  arabist_1_N = mkN "arabist" "arabister" ; -- arabist..nn.1
  arabland_1_N = mkN "arabland" "arablandet" "arabländer" "arabländerna" ; -- arabland..nn.1
  arabvärld_1_N = mkN "arabvärld" ; -- arabvärld..nn.1
  araknidism_1_N = mkN "araknidism" ; -- araknidism..nn.1
  araknodaktyli_1_N = mkN "araknodaktyli" ; -- araknodaktyli..nn.1
  araknoidalcysta_1_N = mkN "araknoidalcysta" ; -- araknoidalcysta..nn.1
  araknoidit_1_N = mkN "araknoidit" "araknoiditer" ; -- araknoidit..nn.1
  aralia_1_N = mkN "aralia" ; -- aralia..nn.1
  arameiska_1_N = mkN "arameiska" ; -- arameiska..nn.1
  aramid_1_N = mkN "aramid" "aramider" ; -- aramid..nn.1
  arbeta_1_V = mkV "arbetar" ; -- arbeta..vb.1
  arbetande_1_N = mkN "arbetande" ; -- arbetande..nn.1
  arbetarbostad_1_N = mkN "arbetarbostad" "arbetarbostäder" ; -- arbetarbostad..nn.1
  arbetare_1_N = mkN "arbetare" utrum  ; -- arbetare..nn.1
  arbetareparti_1_N = mkN "arbetareparti" "arbetarepartiet" "arbetarepartier" "arbetarepartierna" ; -- arbetareparti..nn.1
  arbetarförening_1_N = mkN "arbetarförening" ; -- arbetarförening..nn.1
  arbetargrupp_1_N = mkN "arbetargrupp" "arbetargrupper" ; -- arbetargrupp..nn.1
  arbetarinstitut_1_N = mkN "arbetarinstitut" neutrum  ; -- arbetarinstitut..nn.1
  arbetarklass_1_N = mkN "arbetarklass" "arbetarklasser" ; -- arbetarklass..nn.1
  arbetarkommun_1_N = mkN "arbetarkommun" "arbetarkommuner" ; -- arbetarkommun..nn.1
  arbetarkvarter_1_N = mkN "arbetarkvarter" "arbetarkvarteret" "arbetarkvarter" "arbetarkvarteren" ; -- arbetarkvarter..nn.1
  arbetarparti_1_N = mkN "arbetarparti" "arbetarpartiet" "arbetarpartier" "arbetarpartierna" ; -- arbetarparti..nn.1
  arbetarregering_1_N = mkN "arbetarregering" ; -- arbetarregering..nn.1
  arbetarråd_1_N = mkN "arbetarråd" neutrum  ; -- arbetarråd..nn.1
  arbetarrörelse_1_N = mkN "arbetarrörelse" "arbetarrörelser" ; -- arbetarrörelse..nn.1
  arbetarskydd_1_N = mkN "arbetarskydd" neutrum  ; -- arbetarskydd..nn.1
  arbetarskyddsstyrelse_1_N = mkN "arbetarskyddsstyrelse" utrum  ; -- arbetarskyddsstyrelse..nn.1
  arbetarstam_1_N = mkN "arbetarstam" "arbetarstammen" "arbetarstammar" "arbetarstammarna" ; -- arbetarstam..nn.1
  arbetarsång_1_N = mkN "arbetarsång" "arbetarsånger" ; -- arbetarsång..nn.1
  arbetaruppror_1_N = mkN "arbetaruppror" neutrum  ; -- arbetaruppror..nn.1
  arbetarväljare_1_N = mkN "arbetarväljare" utrum  ; -- arbetarväljare..nn.1
  arbete_1_N = mkN "arbete" ; -- arbete..nn.1
  arbetsam_1_A = mkA "arbetsam" "arbetsamt" "arbetsamma" "arbetsamma" "arbetsammare" "arbetsammast" "arbetsammaste" ; -- arbetsam..av.1
  arbetsamhet_1_N = mkN "arbetsamhet" ; -- arbetsamhet..nn.1
  arbetsanstalt_1_N = mkN "arbetsanstalt" "arbetsanstalter" ; -- arbetsanstalt..nn.1
  arbetsavtal_1_N = mkN "arbetsavtal" neutrum  ; -- arbetsavtal..nn.1
  arbetsbas_1_N = mkN "arbetsbas" ; -- arbetsbas..nn.1
  arbetsbelastning_1_N = mkN "arbetsbelastning" ; -- arbetsbelastning..nn.1
  arbetsbelysning_1_N = mkN "arbetsbelysning" ; -- arbetsbelysning..nn.1
  arbetsbeskrivning_1_N = mkN "arbetsbeskrivning" ; -- arbetsbeskrivning..nn.1
  arbetsbesparande_1_A = mkA "arbetsbesparande" ; -- arbetsbesparande..av.1
  arbetsbesparing_1_N = mkN "arbetsbesparing" ; -- arbetsbesparing..nn.1
  arbetsbetyg_1_N = mkN "arbetsbetyg" neutrum  ; -- arbetsbetyg..nn.1
  arbetsbi_1_N = mkN "arbetsbi" "arbetsbiet" "arbetsbin" "arbetsbina" ; -- arbetsbi..nn.1
  arbetsblus_1_N = mkN "arbetsblus" ; -- arbetsblus..nn.1
  arbetsbok_1_N = mkN "arbetsbok" "arbetsböcker" ; -- arbetsbok..nn.1
  arbetsbord_1_N = mkN "arbetsbord" neutrum  ; -- arbetsbord..nn.1
  arbetsbredd_1_N = mkN "arbetsbredd" "arbetsbredder" ; -- arbetsbredd..nn.1
  arbetsbrist_1_N = mkN "arbetsbrist" ; -- arbetsbrist..nn.1
  arbetsbyte_1_N = mkN "arbetsbyte" ; -- arbetsbyte..nn.1
  arbetsbänk_1_N = mkN "arbetsbänk" ; -- arbetsbänk..nn.1
  arbetsbås_1_N = mkN "arbetsbås" neutrum  ; -- arbetsbås..nn.1
  arbetsbörda_1_N = mkN "arbetsbörda" ; -- arbetsbörda..nn.1
  arbetschef_1_N = mkN "arbetschef" "arbetschefer" ; -- arbetschef..nn.1
  arbetsdag_1_N = mkN "arbetsdag" ; -- arbetsdag..nn.1
  arbetsdelning_1_N = mkN "arbetsdelning" ; -- arbetsdelning..nn.1
  arbetsdjur_1_N = mkN "arbetsdjur" neutrum  ; -- arbetsdjur..nn.1
  arbetsdomstol_1_N = mkN "arbetsdomstol" ; -- arbetsdomstol..nn.1
  arbetsdräkt_1_N = mkN "arbetsdräkt" "arbetsdräkter" ; -- arbetsdräkt..nn.1
  arbetsdräng_1_N = mkN "arbetsdräng" ; -- arbetsdräng..nn.1
  arbetsduglig_1_A = mkA "arbetsduglig" ; -- arbetsduglig..av.1
  arbetsduglighet_1_N = mkN "arbetsduglighet" ; -- arbetsduglighet..nn.1
  arbetsfolk_1_N = mkN "arbetsfolk" neutrum  ; -- arbetsfolk..nn.1
  arbetsform_1_N = mkN "arbetsform" "arbetsformer" ; -- arbetsform..nn.1
  arbetsfred_1_N = mkN "arbetsfred" ; -- arbetsfred..nn.1
  arbetsfri_1_A = mkA "arbetsfri" "arbetsfritt" ; -- arbetsfri..av.1
  arbetsfält_1_N = mkN "arbetsfält" neutrum  ; -- arbetsfält..nn.1
  arbetsfånge_1_N = mkN "arbetsfånge" utrum  ; -- arbetsfånge..nn.1
  arbetsför_1_A = mkA "arbetsför" ; -- arbetsför..av.1
  arbetsfördelning_1_N = mkN "arbetsfördelning" ; -- arbetsfördelning..nn.1
  arbetsförhet_1_N = mkN "arbetsförhet" ; -- arbetsförhet..nn.1
  arbetsförhållande_1_N = mkN "arbetsförhållande" ; -- arbetsförhållande..nn.1
  arbetsförman_1_N = mkN "arbetsförman" "arbetsförmannen" "arbetsförmän" "arbetsförmännen" ; -- arbetsförman..nn.1
  arbetsförmedlare_1_N = mkN "arbetsförmedlare" utrum  ; -- arbetsförmedlare..nn.1
  arbetsförmedling_1_N = mkN "arbetsförmedling" ; -- arbetsförmedling..nn.1
  arbetsförmåga_1_N = mkN "arbetsförmåga" ; -- arbetsförmåga..nn.1
  arbetsförmågeutredning_1_N = mkN "arbetsförmågeutredning" ; -- arbetsförmågeutredning..nn.1
  arbetsförtjänst_1_N = mkN "arbetsförtjänst" "arbetsförtjänster" ; -- arbetsförtjänst..nn.1
  arbetsgivaravgift_1_N = mkN "arbetsgivaravgift" "arbetsgivaravgifter" ; -- arbetsgivaravgift..nn.1
  arbetsgivare_1_N = mkN "arbetsgivare" utrum  ; -- arbetsgivare..nn.1
  arbetsgivareförening_1_N = mkN "arbetsgivareförening" ; -- arbetsgivareförening..nn.1
  arbetsgivarförening_1_N = mkN "arbetsgivarförening" ; -- arbetsgivarförening..nn.1
  arbetsgivarinträde_1_N = mkN "arbetsgivarinträde" ; -- arbetsgivarinträde..nn.1
  arbetsgivarorganisation_1_N = mkN "arbetsgivarorganisation" ; -- arbetsgivarorganisation..nn.1
  arbetsglädje_1_N = mkN "arbetsglädje" utrum  ; -- arbetsglädje..nn.1
  arbetsgrupp_1_N = mkN "arbetsgrupp" "arbetsgrupper" ; -- arbetsgrupp..nn.1
  arbetshandikapp_1_N = mkN "arbetshandikapp" neutrum  ; -- arbetshandikapp..nn.1
  arbetshandikappad_1_A = mkA "arbetshandikappad" ; -- arbetshandikappad..av.1
  arbetshandske_1_N = mkN "arbetshandske" utrum  ; -- arbetshandske..nn.1
  arbetshus_1_N = mkN "arbetshus" neutrum  ; -- arbetshus..nn.1
  arbetshypotes_1_N = mkN "arbetshypotes" "arbetshypoteser" ; -- arbetshypotes..nn.1
  arbetshäst_1_N = mkN "arbetshäst" ; -- arbetshäst..nn.1
  arbetsinkomst_1_N = mkN "arbetsinkomst" "arbetsinkomster" ; -- arbetsinkomst..nn.1
  arbetsinrättning_1_N = mkN "arbetsinrättning" ; -- arbetsinrättning..nn.1
  arbetsinsats_1_N = mkN "arbetsinsats" "arbetsinsatser" ; -- arbetsinsats..nn.1
  arbetsinställelse_1_N = mkN "arbetsinställelse" "arbetsinställelser" ; -- arbetsinställelse..nn.1
  arbetsintensitet_1_N = mkN "arbetsintensitet" ; -- arbetsintensitet..nn.1
  arbetsintensiv_1_A = mkA "arbetsintensiv" ; -- arbetsintensiv..av.1
  arbetsintervju_1_N = mkN "arbetsintervju" "arbetsintervjun" "arbetsintervjuer" "arbetsintervjuerna" ; -- arbetsintervju..nn.1
  arbetsiver_1_N = mkN "arbetsiver" ; -- arbetsiver..nn.1
  arbetsjacka_1_N = mkN "arbetsjacka" ; -- arbetsjacka..nn.1
  arbetskamrat_1_N = mkN "arbetskamrat" "arbetskamrater" ; -- arbetskamrat..nn.1
  arbetskarl_1_N = mkN "arbetskarl" ; -- arbetskarl..nn.1
  arbetsklimat_1_N = mkN "arbetsklimat" neutrum  ; -- arbetsklimat..nn.1
  arbetskommendering_1_N = mkN "arbetskommendering" ; -- arbetskommendering..nn.1
  arbetskonflikt_1_N = mkN "arbetskonflikt" "arbetskonflikter" ; -- arbetskonflikt..nn.1
  arbetskostnad_1_N = mkN "arbetskostnad" "arbetskostnader" ; -- arbetskostnad..nn.1
  arbetskraft_1_N = mkN "arbetskraft" ; -- arbetskraft..nn.1
  arbetskraftsintensiv_1_A = mkA "arbetskraftsintensiv" ; -- arbetskraftsintensiv..av.1
  arbetskraftsinvandrare_1_N = mkN "arbetskraftsinvandrare" utrum  ; -- arbetskraftsinvandrare..nn.1
  arbetskraftsinvandring_1_N = mkN "arbetskraftsinvandring" ; -- arbetskraftsinvandring..nn.1
  arbetskrävande_1_A = mkA "arbetskrävande" ; -- arbetskrävande..av.1
  arbetsköpare_1_N = mkN "arbetsköpare" utrum  ; -- arbetsköpare..nn.1
  arbetslag_1_N = mkN "arbetslag" neutrum  ; -- arbetslag..nn.1
  arbetsledande_1_A = mkA "arbetsledande" ; -- arbetsledande..av.1
  arbetsledare_1_N = mkN "arbetsledare" utrum  ; -- arbetsledare..nn.1
  arbetsliv_1_N = mkN "arbetsliv" neutrum  ; -- arbetsliv..nn.1
  arbetslivserfarenhet_1_N = mkN "arbetslivserfarenhet" "arbetslivserfarenheter" ; -- arbetslivserfarenhet..nn.1
  arbetslivsfond_1_N = mkN "arbetslivsfond" "arbetslivsfonder" ; -- arbetslivsfond..nn.1
  arbetslokal_1_N = mkN "arbetslokal" "arbetslokaler" ; -- arbetslokal..nn.1
  arbetslust_1_N = mkN "arbetslust" ; -- arbetslust..nn.1
  arbetsläger_1_N = mkN "arbetsläger" neutrum  ; -- arbetsläger..nn.1
  arbetslängd_1_N = mkN "arbetslängd" "arbetslängder" ; -- arbetslängd..nn.1
  arbetslön_1_N = mkN "arbetslön" "arbetslöner" ; -- arbetslön..nn.1
  arbetslös_1_A = mkA "arbetslös" ; -- arbetslös..av.1
  arbetslöshet_1_N = mkN "arbetslöshet" "arbetslösheter" ; -- arbetslöshet..nn.1
  arbetslöshetsförsäkring_1_N = mkN "arbetslöshetsförsäkring" ; -- arbetslöshetsförsäkring..nn.1
  arbetslöshetsperiod_1_N = mkN "arbetslöshetsperiod" "arbetslöshetsperioder" ; -- arbetslöshetsperiod..nn.1
  arbetslöshetsstatistik_1_N = mkN "arbetslöshetsstatistik" ; -- arbetslöshetsstatistik..nn.1
  arbetsmanskap_1_N = mkN "arbetsmanskap" neutrum  ; -- arbetsmanskap..nn.1
  arbetsmarknad_1_N = mkN "arbetsmarknad" "arbetsmarknader" ; -- arbetsmarknad..nn.1
  arbetsmarknadskonflikt_1_N = mkN "arbetsmarknadskonflikt" "arbetsmarknadskonflikter" ; -- arbetsmarknadskonflikt..nn.1
  arbetsmarknadsminister_1_N = mkN "arbetsmarknadsminister" ; -- arbetsmarknadsminister..nn.1
  arbetsmarknadsmässig_1_A = mkA "arbetsmarknadsmässig" ; -- arbetsmarknadsmässig..av.1
  arbetsmarknadspolitik_1_N = mkN "arbetsmarknadspolitik" ; -- arbetsmarknadspolitik..nn.1
  arbetsmarknadspolitisk_1_A = mkA "arbetsmarknadspolitisk" ; -- arbetsmarknadspolitisk..av.1
  arbetsmarknadsstatistik_1_N = mkN "arbetsmarknadsstatistik" ; -- arbetsmarknadsstatistik..nn.1
  arbetsmarknadsstyrelse_1_N = mkN "arbetsmarknadsstyrelse" utrum  ; -- arbetsmarknadsstyrelse..nn.1
  arbetsmarknadsutbildning_1_N = mkN "arbetsmarknadsutbildning" ; -- arbetsmarknadsutbildning..nn.1
  arbetsmarknadsåtgärd_1_N = mkN "arbetsmarknadsåtgärd" "arbetsmarknadsåtgärder" ; -- arbetsmarknadsåtgärd..nn.1
  arbetsmaskin_1_N = mkN "arbetsmaskin" "arbetsmaskiner" ; -- arbetsmaskin..nn.1
  arbetsmaterial_1_N = mkN "arbetsmaterial" neutrum  ; -- arbetsmaterial..nn.1
  arbetsmetod_1_N = mkN "arbetsmetod" "arbetsmetoder" ; -- arbetsmetod..nn.1
  arbetsmiljö_1_N = mkN "arbetsmiljö" "arbetsmiljön" "arbetsmiljöer" "arbetsmiljöerna" ; -- arbetsmiljö..nn.1
  arbetsmiljöbrott_1_N = mkN "arbetsmiljöbrott" neutrum  ; -- arbetsmiljöbrott..nn.1
  arbetsmiljömässig_1_A = mkA "arbetsmiljömässig" ; -- arbetsmiljömässig..av.1
  arbetsmiljömål_1_N = mkN "arbetsmiljömål" neutrum  ; -- arbetsmiljömål..nn.1
  arbetsminne_1_N = mkN "arbetsminne" ; -- arbetsminne..nn.1
  arbetsminnestest_1_N = mkN "arbetsminnestest" neutrum  ; -- arbetsminnestest..nn.1
  arbetsmoment_1_N = mkN "arbetsmoment" neutrum  ; -- arbetsmoment..nn.1
  arbetsmoral_1_N = mkN "arbetsmoral" "arbetsmoraler" ; -- arbetsmoral..nn.1
  arbetsmyra_1_N = mkN "arbetsmyra" ; -- arbetsmyra..nn.1
  arbetsmängd_1_N = mkN "arbetsmängd" "arbetsmängder" ; -- arbetsmängd..nn.1
  arbetsmänniska_1_N = mkN "arbetsmänniska" ; -- arbetsmänniska..nn.1
  arbetsmässig_1_A = mkA "arbetsmässig" ; -- arbetsmässig..av.1
  arbetsmätning_1_N = mkN "arbetsmätning" ; -- arbetsmätning..nn.1
  arbetsnamn_1_N = mkN "arbetsnamn" neutrum  ; -- arbetsnamn..nn.1
  arbetsnarkoman_1_N = mkN "arbetsnarkoman" "arbetsnarkomaner" ; -- arbetsnarkoman..nn.1
  arbetsnedläggelse_1_N = mkN "arbetsnedläggelse" "arbetsnedläggelser" ; -- arbetsnedläggelse..nn.1
  arbetsnämnd_1_N = mkN "arbetsnämnd" "arbetsnämnder" ; -- arbetsnämnd..nn.1
  arbetsoförmögen_1_A = mkA "arbetsoförmögen" ; -- arbetsoförmögen..av.1
  arbetsområde_1_N = mkN "arbetsområde" ; -- arbetsområde..nn.1
  arbetsordning_1_N = mkN "arbetsordning" ; -- arbetsordning..nn.1
  arbetsorganisation_1_N = mkN "arbetsorganisation" ; -- arbetsorganisation..nn.1
  arbetspass_1_N = mkN "arbetspass" neutrum  ; -- arbetspass..nn.1
  arbetspendla_1_V = mkV "arbetspendlar" ; -- arbetspendla..vb.1
  arbetspendlande_1_N = mkN "arbetspendlande" ; -- arbetspendlande..nn.1
  arbetspersonal_1_N = mkN "arbetspersonal" "arbetspersonaler" ; -- arbetspersonal..nn.1
  arbetsplan_1_N = mkN "arbetsplan" "arbetsplaner" ; -- arbetsplan..nn.1
  arbetsplats_1_N = mkN "arbetsplats" "arbetsplatser" ; -- arbetsplats..nn.1
  arbetsplatsolycka_1_N = mkN "arbetsplatsolycka" ; -- arbetsplatsolycka..nn.1
  arbetsplenum_1_N = mkN "arbetsplenum" neutrum  ; -- arbetsplenum..nn.1
  arbetspremiss_1_N = mkN "arbetspremiss" "arbetspremisser" ; -- arbetspremiss..nn.1
  arbetsprogram_1_N = mkN "arbetsprogram" "arbetsprogrammet" "arbetsprogram" "arbetsprogrammen" ; -- arbetsprogram..nn.1
  arbetsprov_1_N = mkN "arbetsprov" neutrum  ; -- arbetsprov..nn.1
  arbetsredskap_1_N = mkN "arbetsredskap" neutrum  ; -- arbetsredskap..nn.1
  arbetsrelaterad_1_A = mkA "arbetsrelaterad" ; -- arbetsrelaterad..av.1
  arbetsrelation_1_N = mkN "arbetsrelation" ; -- arbetsrelation..nn.1
  arbetsro_1_N = mkN "arbetsro" ; -- arbetsro..nn.1
  arbetsrum_1_N = mkN "arbetsrum" "arbetsrummet" "arbetsrum" "arbetsrummen" ; -- arbetsrum..nn.1
  arbetsrätt_1_N = mkN "arbetsrätt" ; -- arbetsrätt..nn.1
  arbetsrättslig_1_A = mkA "arbetsrättslig" ; -- arbetsrättslig..av.1
  arbetssal_1_N = mkN "arbetssal" ; -- arbetssal..nn.1
  arbetsschema_1_N = mkN "arbetsschema" "arbetsschemat" "arbetsscheman" "arbetsschemana" ; -- arbetsschema..nn.1
  arbetsseger_1_N = mkN "arbetsseger" ; -- arbetsseger..nn.1
  arbetssituation_1_N = mkN "arbetssituation" ; -- arbetssituation..nn.1
  arbetsskada_1_N = mkN "arbetsskada" ; -- arbetsskada..nn.1
  arbetsskadad_1_A = mkA "arbetsskadad" ; -- arbetsskadad..av.1
  arbetsskicklig_1_A = mkA "arbetsskicklig" ; -- arbetsskicklig..av.1
  arbetsskicklighet_1_N = mkN "arbetsskicklighet" ; -- arbetsskicklighet..nn.1
  arbetsskräck_1_N = mkN "arbetsskräck" ; -- arbetsskräck..nn.1
  arbetsskygg_1_A = mkA "arbetsskygg" ; -- arbetsskygg..av.1
  arbetsskygghet_1_N = mkN "arbetsskygghet" ; -- arbetsskygghet..nn.1
  arbetsstudieman_1_N = mkN "arbetsstudieman" "arbetsstudiemannen" "arbetsstudiemän" "arbetsstudiemännen" ; -- arbetsstudieman..nn.1
  arbetsstycke_1_N = mkN "arbetsstycke" ; -- arbetsstycke..nn.1
  arbetsstyrka_1_N = mkN "arbetsstyrka" ; -- arbetsstyrka..nn.1
  arbetssätt_1_N = mkN "arbetssätt" neutrum  ; -- arbetssätt..nn.1
  arbetssång_1_N = mkN "arbetssång" "arbetssånger" ; -- arbetssång..nn.1
  arbetssökande_1_A = mkA "arbetssökande" ; -- arbetssökande..av.1
  arbetssökande_1_N = mkN "arbetssökande" "arbetssökanden" "arbetssökanden" "arbetssökandena" ; -- arbetssökande..nn.1
  arbetssökande_2_N = mkN "arbetssökande" ; -- arbetssökande..nn.2
  arbetstagare_1_N = mkN "arbetstagare" utrum  ; -- arbetstagare..nn.1
  arbetstakt_1_N = mkN "arbetstakt" ; -- arbetstakt..nn.1
  arbetstemperatur_1_N = mkN "arbetstemperatur" "arbetstemperaturer" ; -- arbetstemperatur..nn.1
  arbetsterapeut_1_N = mkN "arbetsterapeut" "arbetsterapeuter" ; -- arbetsterapeut..nn.1
  arbetsterapi_1_N = mkN "arbetsterapi" ; -- arbetsterapi..nn.1
  arbetstid_1_N = mkN "arbetstid" "arbetstider" ; -- arbetstid..nn.1
  arbetstidsförkortning_1_N = mkN "arbetstidsförkortning" ; -- arbetstidsförkortning..nn.1
  arbetstidsregel_1_N = mkN "arbetstidsregel" "arbetstidsregeln" "arbetstidsregler" "arbetstidsreglerna" ; -- arbetstidsregel..nn.1
  arbetstidsreglering_1_N = mkN "arbetstidsreglering" ; -- arbetstidsreglering..nn.1
  arbetstillfälle_1_N = mkN "arbetstillfälle" ; -- arbetstillfälle..nn.1
  arbetstillstånd_1_N = mkN "arbetstillstånd" neutrum  ; -- arbetstillstånd..nn.1
  arbetstimme_1_N = mkN "arbetstimme" utrum  ; -- arbetstimme..nn.1
  arbetsträna_1_V = mkV "arbetstränar" ; -- arbetsträna..vb.1
  arbetstränande_1_N = mkN "arbetstränande" ; -- arbetstränande..nn.1
  arbetsträning_1_N = mkN "arbetsträning" ; -- arbetsträning..nn.1
  arbetstvist_1_N = mkN "arbetstvist" "arbetstvister" ; -- arbetstvist..nn.1
  arbetsuppgift_1_N = mkN "arbetsuppgift" "arbetsuppgifter" ; -- arbetsuppgift..nn.1
  arbetsutskott_1_N = mkN "arbetsutskott" neutrum  ; -- arbetsutskott..nn.1
  arbetsvan_1_A = mkA "arbetsvan" ; -- arbetsvan..av.1
  arbetsvana_1_N = mkN "arbetsvana" ; -- arbetsvana..nn.1
  arbetsvecka_1_N = mkN "arbetsvecka" ; -- arbetsvecka..nn.1
  arbetsverktyg_1_N = mkN "arbetsverktyg" neutrum  ; -- arbetsverktyg..nn.1
  arbetsvilja_1_N = mkN "arbetsvilja" ; -- arbetsvilja..nn.1
  arbetsvillig_1_A = mkA "arbetsvillig" ; -- arbetsvillig..av.1
  arbetsvillighet_1_N = mkN "arbetsvillighet" ; -- arbetsvillighet..nn.1
  arbetsvillkor_1_N = mkN "arbetsvillkor" neutrum  ; -- arbetsvillkor..nn.1
  arbetsvärdering_1_N = mkN "arbetsvärdering" ; -- arbetsvärdering..nn.1
  arbetsväska_1_N = mkN "arbetsväska" ; -- arbetsväska..nn.1
  arbetsvård_1_N = mkN "arbetsvård" ; -- arbetsvård..nn.1
  arbetsår_1_N = mkN "arbetsår" neutrum  ; -- arbetsår..nn.1
  arbitrage_1_N = mkN "arbitrage" ; -- arbitrage..nn.1
  arbiträr_1_A = mkA "arbiträr" ; -- arbiträr..av.1
  arboretum_1_N = mkN "arboretum" neutrum  ; -- arboretum..nn.1
  arborist_1_N = mkN "arborist" "arborister" ; -- arborist..nn.1
  arborr_1_N = mkN "arborr" ; -- arborr..nn.1
  arborra_1_V = mkV "arborrar" ; -- arborra..vb.1
  arborrande_1_N = mkN "arborrande" ; -- arborrande..nn.1
  arbovirusencefalit_1_N = mkN "arbovirusencefalit" "arbovirusencefaliter" ; -- arbovirusencefalit..nn.1
  arbovirusinfektion_1_N = mkN "arbovirusinfektion" ; -- arbovirusinfektion..nn.1
  arcusmoln_1_N = mkN "arcusmoln" neutrum  ; -- arcusmoln..nn.1
  ardenner_1_N = mkN "ardenner" "ardennern" "ardenner" "ardennerna" ; -- ardenner..nn.1
  area_1_N = mkN "area" ; -- area..nn.1
  areal_1_N = mkN "areal" "arealer" ; -- areal..nn.1
  arealmässig_1_A = mkA "arealmässig" ; -- arealmässig..av.1
  arena_1_N = mkN "arena" ; -- arena..nn.1
  arenabygge_1_N = mkN "arenabygge" ; -- arenabygge..nn.1
  arenateater_1_N = mkN "arenateater" ; -- arenateater..nn.1
  arenavirusinfektion_1_N = mkN "arenavirusinfektion" ; -- arenavirusinfektion..nn.1
  areometer_1_N = mkN "areometer" ; -- areometer..nn.1
  areopag_1_N = mkN "areopag" "areopager" ; -- areopag..nn.1
  arg_1_A = mkA "arg" ; -- arg..av.1
  argbigga_1_N = mkN "argbigga" ; -- argbigga..nn.1
  argentinare_1_N = mkN "argentinare" utrum  ; -- argentinare..nn.1
  argentinsk_1_A = mkA "argentinsk" ; -- argentinsk..av.1
  argentinska_1_N = mkN "argentinska" ; -- argentinska..nn.1
  arghet_1_N = mkN "arghet" ; -- arghet..nn.1
  argininbärnstensaciduri_1_N = mkN "argininbärnstensaciduri" ; -- argininbärnstensaciduri..nn.1
  argon_1_N = mkN "argon" ; -- argon..nn.1
  argot_1_N = mkN "argot" ; -- argot..nn.1
  argsint_1_A = mkA "argsint" "argsint" ; -- argsint..av.1
  argsinthet_1_N = mkN "argsinthet" ; -- argsinthet..nn.1
  argument_1_N = mkN "argument" neutrum  ; -- argument..nn.1
  argumentation_1_N = mkN "argumentation" ; -- argumentation..nn.1
  argumentationsanalys_1_N = mkN "argumentationsanalys" ; -- argumentationsanalys..nn.1
  argumentativ_1_A = mkA "argumentativ" ; -- argumentativ..av.1
  argumentera_1_V = mkV "argumenterar" ; -- argumentera..vb.1
  argumenterande_1_N = mkN "argumenterande" ; -- argumenterande..nn.1
  argumenterbar_1_A = mkA "argumenterbar" ; -- argumenterbar..av.1
  argumenterbarhet_1_N = mkN "argumenterbarhet" ; -- argumenterbarhet..nn.1
  argumentering_1_N = mkN "argumentering" ; -- argumentering..nn.1
  argumentrik_1_A = mkA "argumentrik" ; -- argumentrik..av.1
  argumentrikedom_1_N = mkN "argumentrikedom" ; -- argumentrikedom..nn.1
  argusöga_1_N = mkN "argusöga" "argusögat" "argusögon" "argusögonen" ; -- argusöga..nn.1
  argyri_1_N = mkN "argyri" ; -- argyri..nn.1
  arhinencefali_1_N = mkN "arhinencefali" ; -- arhinencefali..nn.1
  aria_1_N = mkN "aria" ; -- aria..nn.1
  ariadnetråd_1_N = mkN "ariadnetråd" ; -- ariadnetråd..nn.1
  arian_1_N = mkN "arian" "arianer" ; -- arian..nn.1
  arianism_1_N = mkN "arianism" "arianismer" ; -- arianism..nn.1
  ariansk_1_A = mkA "ariansk" ; -- ariansk..av.1
  arid_1_A = mkA "arid" ; -- arid..av.1
  arier_1_N = mkN "arier" "ariern" "arier" "arierna" ; -- arier..nn.1
  arioso_1_N = mkN "arioso" "ariosot" "arioson" "ariosona" ; -- arioso..nn.1
  arisk_1_A = mkA "arisk" ; -- arisk..av.1
  aristokrat_1_N = mkN "aristokrat" "aristokrater" ; -- aristokrat..nn.1
  aristokrati_1_N = mkN "aristokrati" "aristokratier" ; -- aristokrati..nn.1
  aristokratisk_1_A = mkA "aristokratisk" ; -- aristokratisk..av.1
  aristokratvälde_1_N = mkN "aristokratvälde" ; -- aristokratvälde..nn.1
  aritet_1_N = mkN "aritet" "ariteter" ; -- aritet..nn.1
  aritmetik_1_N = mkN "aritmetik" ; -- aritmetik..nn.1
  aritmetiker_1_N = mkN "aritmetiker" "aritmetikern" "aritmetiker" "aritmetikerna" ; -- aritmetiker..nn.1
  aritmetisk_1_A = mkA "aritmetisk" ; -- aritmetisk..av.1
  ark_1_N = mkN "ark" neutrum  ; -- ark..nn.1
  ark_2_N = mkN "ark" ; -- ark..nn.2
  arkad_1_N = mkN "arkad" "arkader" ; -- arkad..nn.1
  arkadgång_1_N = mkN "arkadgång" ; -- arkadgång..nn.1
  arkadisk_1_A = mkA "arkadisk" ; -- arkadisk..av.1
  arkadspel_1_N = mkN "arkadspel" "arkadspelet" "arkadspel" "arkadspelen" ; -- arkadspel..nn.1
  arkaisera_1_V = mkV "arkaiserar" ; -- arkaisera..vb.1
  arkaiserande_1_N = mkN "arkaiserande" ; -- arkaiserande..nn.1
  arkaiserbar_1_A = mkA "arkaiserbar" ; -- arkaiserbar..av.1
  arkaiserbarhet_1_N = mkN "arkaiserbarhet" ; -- arkaiserbarhet..nn.1
  arkaisering_1_N = mkN "arkaisering" ; -- arkaisering..nn.1
  arkaisk_1_A = mkA "arkaisk" ; -- arkaisk..av.1
  arkaism_1_N = mkN "arkaism" "arkaismer" ; -- arkaism..nn.1
  arkaistisk_1_A = mkA "arkaistisk" ; -- arkaistisk..av.1
  arkebusera_1_V = mkV "arkebuserar" ; -- arkebusera..vb.1
  arkebuserande_1_N = mkN "arkebuserande" ; -- arkebuserande..nn.1
  arkebuserbar_1_A = mkA "arkebuserbar" ; -- arkebuserbar..av.1
  arkebuserbarhet_1_N = mkN "arkebuserbarhet" ; -- arkebuserbarhet..nn.1
  arkebusering_1_N = mkN "arkebusering" ; -- arkebusering..nn.1
  arkeikum_1_N = mkN "arkeikum" ; -- arkeikum..nn.1
  arkeolog_1_N = mkN "arkeolog" "arkeologer" ; -- arkeolog..nn.1
  arkeologi_1_N = mkN "arkeologi" ; -- arkeologi..nn.1
  arkeologisk_1_A = mkA "arkeologisk" ; -- arkeologisk..av.1
  arkeologiämne_1_N = mkN "arkeologiämne" ; -- arkeologiämne..nn.1
  arkeologkongress_1_N = mkN "arkeologkongress" "arkeologkongresser" ; -- arkeologkongress..nn.1
  arketyp_1_N = mkN "arketyp" "arketyper" ; -- arketyp..nn.1
  arketypisk_1_A = mkA "arketypisk" ; -- arketypisk..av.1
  arkiater_1_N = mkN "arkiater" "arkiatern" "arkiatrer" "arkiatrerna" ; -- arkiater..nn.1
  arkipelag_1_N = mkN "arkipelag" "arkipelager" ; -- arkipelag..nn.1
  arkitekt_1_N = mkN "arkitekt" "arkitekter" ; -- arkitekt..nn.1
  arkitektonik_1_N = mkN "arkitektonik" ; -- arkitektonik..nn.1
  arkitektonisk_1_A = mkA "arkitektonisk" ; -- arkitektonisk..av.1
  arkitektur_1_N = mkN "arkitektur" "arkitekturer" ; -- arkitektur..nn.1
  arkitekturpolitik_1_N = mkN "arkitekturpolitik" ; -- arkitekturpolitik..nn.1
  arkitekturpolitisk_1_A = mkA "arkitekturpolitisk" ; -- arkitekturpolitisk..av.1
  arkitekturritning_1_N = mkN "arkitekturritning" ; -- arkitekturritning..nn.1
  arkitrav_1_N = mkN "arkitrav" "arkitraver" ; -- arkitrav..nn.1
  arkiv_1_N = mkN "arkiv" neutrum  ; -- arkiv..nn.1
  arkivalieskåp_1_N = mkN "arkivalieskåp" neutrum  ; -- arkivalieskåp..nn.1
  arkivalisk_1_A = mkA "arkivalisk" ; -- arkivalisk..av.1
  arkivarbetare_1_N = mkN "arkivarbetare" utrum  ; -- arkivarbetare..nn.1
  arkivarbete_1_N = mkN "arkivarbete" ; -- arkivarbete..nn.1
  arkivarie_1_N = mkN "arkivarie" "arkivarier" ; -- arkivarie..nn.1
  arkivera_1_V = mkV "arkiverar" ; -- arkivera..vb.1
  arkiverande_1_N = mkN "arkiverande" ; -- arkiverande..nn.1
  arkiverbar_1_A = mkA "arkiverbar" ; -- arkiverbar..av.1
  arkiverbarhet_1_N = mkN "arkiverbarhet" ; -- arkiverbarhet..nn.1
  arkivering_1_N = mkN "arkivering" ; -- arkivering..nn.1
  arkivexemplar_1_N = mkN "arkivexemplar" neutrum  ; -- arkivexemplar..nn.1
  arkivforskning_1_N = mkN "arkivforskning" ; -- arkivforskning..nn.1
  arkivmaterial_1_N = mkN "arkivmaterial" neutrum  ; -- arkivmaterial..nn.1
  arkivolt_1_N = mkN "arkivolt" "arkivolter" ; -- arkivolt..nn.1
  arkivsamling_1_N = mkN "arkivsamling" ; -- arkivsamling..nn.1
  arkivstudie_1_N = mkN "arkivstudie" "arkivstudier" ; -- arkivstudie..nn.1
  arksignatur_1_N = mkN "arksignatur" "arksignaturer" ; -- arksignatur..nn.1
  arktisk_1_A = mkA "arktisk" ; -- arktisk..av.1
  arkvis_1_Adv = mkAdv "arkvis" ; -- arkvis..ab.1
  arm_1_A = mkA "arm" ; -- arm..av.1
  arm_1_N = mkN "arm" ; -- arm..nn.1
  armada_1_N = mkN "armada" ; -- armada..nn.1
  armagnac_1_N = mkN "armagnac" ; -- armagnac..nn.1
  armatur_1_N = mkN "armatur" "armaturer" ; -- armatur..nn.1
  armband_1_N = mkN "armband" neutrum  ; -- armband..nn.1
  armbandslås_1_N = mkN "armbandslås" neutrum  ; -- armbandslås..nn.1
  armbandsur_1_N = mkN "armbandsur" neutrum  ; -- armbandsur..nn.1
  armbindel_1_N = mkN "armbindel" ; -- armbindel..nn.1
  armborst_1_N = mkN "armborst" neutrum  ; -- armborst..nn.1
  armborstpil_1_N = mkN "armborstpil" ; -- armborstpil..nn.1
  armborstskytt_1_N = mkN "armborstskytt" ; -- armborstskytt..nn.1
  armbrott_1_N = mkN "armbrott" neutrum  ; -- armbrott..nn.1
  armbrytning_1_N = mkN "armbrytning" ; -- armbrytning..nn.1
  armbågande_1_N = mkN "armbågande" ; -- armbågande..nn.1
  armbåge_1_N = mkN "armbåge" utrum  ; -- armbåge..nn.1
  armbågsben_1_N = mkN "armbågsben" neutrum  ; -- armbågsben..nn.1
  armbågsled_1_N = mkN "armbågsled" "armbågsleder" ; -- armbågsled..nn.1
  armbågsnerv_1_N = mkN "armbågsnerv" "armbågsnerver" ; -- armbågsnerv..nn.1
  armbågsskydd_1_N = mkN "armbågsskydd" neutrum  ; -- armbågsskydd..nn.1
  armbågssträckare_1_N = mkN "armbågssträckare" utrum  ; -- armbågssträckare..nn.1
  armbågsutskott_1_N = mkN "armbågsutskott" neutrum  ; -- armbågsutskott..nn.1
  armböjning_1_N = mkN "armböjning" ; -- armböjning..nn.1
  armcylinder_1_N = mkN "armcylinder" ; -- armcylinder..nn.1
  armdyna_1_N = mkN "armdyna" ; -- armdyna..nn.1
  armenier_1_N = mkN "armenier" "armeniern" "armenier" "armenierna" ; -- armenier..nn.1
  armenisk_1_A = mkA "armenisk" ; -- armenisk..av.1
  armeniska_1_N = mkN "armeniska" ; -- armeniska..nn.1
  armeniska_2_N = mkN "armeniska" ; -- armeniska..nn.2
  armera_1_V = mkV "armerar" ; -- armera..vb.1
  armerande_1_N = mkN "armerande" ; -- armerande..nn.1
  armerbar_1_A = mkA "armerbar" ; -- armerbar..av.1
  armerbarhet_1_N = mkN "armerbarhet" ; -- armerbarhet..nn.1
  armering_1_N = mkN "armering" ; -- armering..nn.1
  armeringsjärn_1_N = mkN "armeringsjärn" neutrum  ; -- armeringsjärn..nn.1
  armfläta_1_N = mkN "armfläta" ; -- armfläta..nn.1
  armfoting_1_N = mkN "armfoting" ; -- armfoting..nn.1
  armföring_1_N = mkN "armföring" ; -- armföring..nn.1
  armgång_1_N = mkN "armgång" ; -- armgång..nn.1
  armhet_1_N = mkN "armhet" ; -- armhet..nn.1
  armhävning_1_N = mkN "armhävning" ; -- armhävning..nn.1
  armhåla_1_N = mkN "armhåla" ; -- armhåla..nn.1
  armhålsstöd_1_N = mkN "armhålsstöd" neutrum  ; -- armhålsstöd..nn.1
  armkraft_1_N = mkN "armkraft" "armkrafter" ; -- armkraft..nn.1
  armkrok_1_N = mkN "armkrok" ; -- armkrok..nn.1
  armkrokskedja_1_N = mkN "armkrokskedja" ; -- armkrokskedja..nn.1
  armled_1_N = mkN "armled" "armleder" ; -- armled..nn.1
  armljusstake_1_N = mkN "armljusstake" utrum  ; -- armljusstake..nn.1
  armlängd_1_N = mkN "armlängd" "armlängder" ; -- armlängd..nn.1
  armlås_1_N = mkN "armlås" neutrum  ; -- armlås..nn.1
  armmudd_1_N = mkN "armmudd" ; -- armmudd..nn.1
  armmuskel_1_N = mkN "armmuskel" "armmuskeln" "armmuskler" "armmusklerna" ; -- armmuskel..nn.1
  armod_1_N = mkN "armod" neutrum  ; -- armod..nn.1
  armodslöfte_1_N = mkN "armodslöfte" ; -- armodslöfte..nn.1
  armpolyp_1_N = mkN "armpolyp" "armpolyper" ; -- armpolyp..nn.1
  armring_1_N = mkN "armring" ; -- armring..nn.1
  armrörelse_1_N = mkN "armrörelse" "armrörelser" ; -- armrörelse..nn.1
  armskada_1_N = mkN "armskada" ; -- armskada..nn.1
  armslängd_1_N = mkN "armslängd" "armslängder" ; -- armslängd..nn.1
  armslång_1_A = mkA "armslång" ; -- armslång..av.1
  armstark_1_A = mkA "armstark" ; -- armstark..av.1
  armstjock_1_A = mkA "armstjock" ; -- armstjock..av.1
  armstol_1_N = mkN "armstol" ; -- armstol..nn.1
  armsträckning_1_N = mkN "armsträckning" ; -- armsträckning..nn.1
  armstump_1_N = mkN "armstump" ; -- armstump..nn.1
  armstyrka_1_N = mkN "armstyrka" ; -- armstyrka..nn.1
  armstöd_1_N = mkN "armstöd" neutrum  ; -- armstöd..nn.1
  armsvag_1_A = mkA "armsvag" ; -- armsvag..av.1
  armsvett_1_N = mkN "armsvett" ; -- armsvett..nn.1
  armtag_1_N = mkN "armtag" neutrum  ; -- armtag..nn.1
  armtrakt_1_N = mkN "armtrakt" "armtrakter" ; -- armtrakt..nn.1
  armveck_1_N = mkN "armveck" neutrum  ; -- armveck..nn.1
  armé_1_N = mkN "armé" "arméer" ; -- armé..nn.1
  arméattaché_1_N = mkN "arméattaché" "arméattachéer" ; -- arméattaché..nn.1
  arméavdelning_1_N = mkN "arméavdelning" ; -- arméavdelning..nn.1
  arméchef_1_N = mkN "arméchef" "arméchefer" ; -- arméchef..nn.1
  arméförband_1_N = mkN "arméförband" neutrum  ; -- arméförband..nn.1
  arméfördelning_1_N = mkN "arméfördelning" ; -- arméfördelning..nn.1
  arméförvaltning_1_N = mkN "arméförvaltning" ; -- arméförvaltning..nn.1
  armégeneral_1_N = mkN "armégeneral" "armégeneraler" ; -- armégeneral..nn.1
  armégevär_1_N = mkN "armégevär" neutrum  ; -- armégevär..nn.1
  arméhelikopter_1_N = mkN "arméhelikopter" ; -- arméhelikopter..nn.1
  arméhäst_1_N = mkN "arméhäst" ; -- arméhäst..nn.1
  armékommuniké_1_N = mkN "armékommuniké" "armékommunikéer" ; -- armékommuniké..nn.1
  armékår_1_N = mkN "armékår" "armékårer" ; -- armékår..nn.1
  arméorganisation_1_N = mkN "arméorganisation" ; -- arméorganisation..nn.1
  arméstab_1_N = mkN "arméstab" "arméstaber" ; -- arméstab..nn.1
  arméunderstöd_1_N = mkN "arméunderstöd" neutrum  ; -- arméunderstöd..nn.1
  arom_1_N = mkN "arom" "aromer" ; -- arom..nn.1
  aromatisk_1_A = mkA "aromatisk" ; -- aromatisk..av.1
  aromglas_1_N = mkN "aromglas" neutrum  ; -- aromglas..nn.1
  aromkupa_1_N = mkN "aromkupa" ; -- aromkupa..nn.1
  arpeggio_1_N = mkN "arpeggio" "arpeggiot" "arpeggion" "arpeggiona" ; -- arpeggio..nn.1
  arr_1_N = mkN "arr" neutrum  ; -- arr..nn.1
  arra_1_V = mkV "arrar" ; -- arra..vb.1
  arrak_1_N = mkN "arrak" ; -- arrak..nn.1
  arrakpunch_1_N = mkN "arrakpunch" ; -- arrakpunch..nn.1
  arrakpunsch_1_N = mkN "arrakpunsch" ; -- arrakpunsch..nn.1
  arrakspunsch_1_N = mkN "arrakspunsch" ; -- arrakspunsch..nn.1
  arrakssmak_1_N = mkN "arrakssmak" "arrakssmaker" ; -- arrakssmak..nn.1
  arrakstoddy_1_N = mkN "arrakstoddy" "arrakstoddyn" "arrakstoddar" "arrakstoddarna" ; -- arrakstoddy..nn.1
  arrangemang_1_N = mkN "arrangemang" neutrum  ; -- arrangemang..nn.1
  arrangemangsmässig_1_A = mkA "arrangemangsmässig" ; -- arrangemangsmässig..av.1
  arrangera_1_V = mkV "arrangerar" ; -- arrangera..vb.1
  arrangerande_1_N = mkN "arrangerande" ; -- arrangerande..nn.1
  arrangerbar_1_A = mkA "arrangerbar" ; -- arrangerbar..av.1
  arrangerbarhet_1_N = mkN "arrangerbarhet" ; -- arrangerbarhet..nn.1
  arrangering_1_N = mkN "arrangering" ; -- arrangering..nn.1
  arrangör_1_N = mkN "arrangör" "arrangörer" ; -- arrangör..nn.1
  arrangörsmässig_1_A = mkA "arrangörsmässig" ; -- arrangörsmässig..av.1
  arrendator_1_N = mkN "arrendator" "arrendatorer" ; -- arrendator..nn.1
  arrende_1_N = mkN "arrende" ; -- arrende..nn.1
  arrendeavgift_1_N = mkN "arrendeavgift" "arrendeavgifter" ; -- arrendeavgift..nn.1
  arrendebelopp_1_N = mkN "arrendebelopp" neutrum  ; -- arrendebelopp..nn.1
  arrendekontrakt_1_N = mkN "arrendekontrakt" neutrum  ; -- arrendekontrakt..nn.1
  arrendera_1_V = mkV "arrenderar" ; -- arrendera..vb.1
  arrenderande_1_N = mkN "arrenderande" ; -- arrenderande..nn.1
  arrenderbar_1_A = mkA "arrenderbar" ; -- arrenderbar..av.1
  arrenderbarhet_1_N = mkN "arrenderbarhet" ; -- arrenderbarhet..nn.1
  arrendering_1_N = mkN "arrendering" ; -- arrendering..nn.1
  arrendevillkor_1_N = mkN "arrendevillkor" neutrum  ; -- arrendevillkor..nn.1
  arrest_1_N = mkN "arrest" "arrester" ; -- arrest..nn.1
  arrestant_1_N = mkN "arrestant" "arrestanter" ; -- arrestant..nn.1
  arrestavdelning_1_N = mkN "arrestavdelning" ; -- arrestavdelning..nn.1
  arrestera_1_V = mkV "arresterar" ; -- arrestera..vb.1
  arresterande_1_N = mkN "arresterande" ; -- arresterande..nn.1
  arresterbar_1_A = mkA "arresterbar" ; -- arresterbar..av.1
  arresterbarhet_1_N = mkN "arresterbarhet" ; -- arresterbarhet..nn.1
  arrestering_1_N = mkN "arrestering" ; -- arrestering..nn.1
  arresteringsorder_1_N = mkN "arresteringsorder" ; -- arresteringsorder..nn.1
  arrestlokal_1_N = mkN "arrestlokal" "arrestlokaler" ; -- arrestlokal..nn.1
  arrestrum_1_N = mkN "arrestrum" "arrestrummet" "arrestrum" "arrestrummen" ; -- arrestrum..nn.1
  arreststraff_1_N = mkN "arreststraff" neutrum  ; -- arreststraff..nn.1
  arresttid_1_N = mkN "arresttid" "arresttider" ; -- arresttid..nn.1
  arriverad_1_A = mkA "arriverad" ; -- arriverad..av.1
  arrivist_1_N = mkN "arrivist" "arrivister" ; -- arrivist..nn.1
  arriärgarde_1_N = mkN "arriärgarde" ; -- arriärgarde..nn.1
  arrogans_1_N = mkN "arrogans" ; -- arrogans..nn.1
  arrogant_1_A = mkA "arrogant" "arrogant" ; -- arrogant..av.1
  arrondera_1_V = mkV "arronderar" ; -- arrondera..vb.1
  arronderande_1_N = mkN "arronderande" ; -- arronderande..nn.1
  arronderbar_1_A = mkA "arronderbar" ; -- arronderbar..av.1
  arronderbarhet_1_N = mkN "arronderbarhet" ; -- arronderbarhet..nn.1
  arrondering_1_N = mkN "arrondering" ; -- arrondering..nn.1
  arrondissemang_1_N = mkN "arrondissemang" neutrum  ; -- arrondissemang..nn.1
  arrondissement_1_N = mkN "arrondissement" neutrum  ; -- arrondissement..nn.1
  arrowrot_1_N = mkN "arrowrot" "arrowrötter" ; -- arrowrot..nn.1
  arschel_1_N = mkN "arschel" ; -- arschel..nn.1
  arschle_1_N = mkN "arschle" ; -- arschle..nn.1
  arsel_1_N = mkN "arsel" ; -- arsel..nn.1
  arsenal_1_N = mkN "arsenal" "arsenaler" ; -- arsenal..nn.1
  arsenalsbyggnad_1_N = mkN "arsenalsbyggnad" "arsenalsbyggnader" ; -- arsenalsbyggnad..nn.1
  arsenik_1_N = mkN "arsenik" ; -- arsenik..nn.1
  arsenikdos_1_N = mkN "arsenikdos" "arsenikdoser" ; -- arsenikdos..nn.1
  arsenikfri_1_A = mkA "arsenikfri" "arsenikfritt" ; -- arsenikfri..av.1
  arsenikförgiftning_1_N = mkN "arsenikförgiftning" ; -- arsenikförgiftning..nn.1
  arsenikhalt_1_N = mkN "arsenikhalt" "arsenikhalter" ; -- arsenikhalt..nn.1
  arsenikhaltig_1_A = mkA "arsenikhaltig" ; -- arsenikhaltig..av.1
  arsenikkis_1_N = mkN "arsenikkis" "arsenikkiser" ; -- arsenikkis..nn.1
  arsenikmord_1_N = mkN "arsenikmord" neutrum  ; -- arsenikmord..nn.1
  arsenikväte_1_N = mkN "arsenikväte" ; -- arsenikväte..nn.1
  arsle_1_N = mkN "arsle" ; -- arsle..nn.1
  art_1_N = mkN "art" "arter" ; -- art..nn.1
  artbank_1_N = mkN "artbank" "artbanker" ; -- artbank..nn.1
  artbeskrivning_1_N = mkN "artbeskrivning" ; -- artbeskrivning..nn.1
  artbestämma_1_V = mkV "artbestämmer" ; -- artbestämma..vb.1
  artbestämmande_1_N = mkN "artbestämmande" ; -- artbestämmande..nn.1
  artbestämning_1_N = mkN "artbestämning" ; -- artbestämning..nn.1
  artbildning_1_N = mkN "artbildning" ; -- artbildning..nn.1
  artbildningsteori_1_N = mkN "artbildningsteori" "artbildningsteorier" ; -- artbildningsteori..nn.1
  artdatabank_1_N = mkN "artdatabank" "artdatabanker" ; -- artdatabank..nn.1
  artefakt_1_N = mkN "artefakt" "artefakter" ; -- artefakt..nn.1
  artegen_1_A = mkA "artegen" ; -- artegen..av.1
  artegenhet_1_N = mkN "artegenhet" ; -- artegenhet..nn.1
  arteriell_1_A = mkA "arteriell" ; -- arteriell..av.1
  arterioskleros_1_N = mkN "arterioskleros" "arterioskleroser" ; -- arterioskleros..nn.1
  arterit_1_N = mkN "arterit" "arteriter" ; -- arterit..nn.1
  arterivirusinfektion_1_N = mkN "arterivirusinfektion" ; -- arterivirusinfektion..nn.1
  artesisk_1_A = mkA "artesisk" ; -- artesisk..av.1
  artfrämmande_1_A = mkA "artfrämmande" ; -- artfrämmande..av.1
  artfrände_1_N = mkN "artfrände" "artfränder" ; -- artfrände..nn.1
  artförändring_1_N = mkN "artförändring" ; -- artförändring..nn.1
  artificiell_1_A = mkA "artificiell" ; -- artificiell..av.1
  artig_1_A = mkA "artig" ; -- artig..av.1
  artighet_1_N = mkN "artighet" "artigheter" ; -- artighet..nn.1
  artighetsbetygelse_1_N = mkN "artighetsbetygelse" "artighetsbetygelser" ; -- artighetsbetygelse..nn.1
  artighetsbevis_1_N = mkN "artighetsbevis" neutrum  ; -- artighetsbevis..nn.1
  artighetsfras_1_N = mkN "artighetsfras" "artighetsfraser" ; -- artighetsfras..nn.1
  artighetsvisit_1_N = mkN "artighetsvisit" "artighetsvisiter" ; -- artighetsvisit..nn.1
  artikel_1_N = mkN "artikel" ; -- artikel..nn.1
  artikelförfattare_1_N = mkN "artikelförfattare" utrum  ; -- artikelförfattare..nn.1
  artikelserie_1_N = mkN "artikelserie" "artikelserier" ; -- artikelserie..nn.1
  artikulation_1_N = mkN "artikulation" ; -- artikulation..nn.1
  artikulationsbas_1_N = mkN "artikulationsbas" "artikulationsbaser" ; -- artikulationsbas..nn.1
  artikulationsrubbning_1_N = mkN "artikulationsrubbning" ; -- artikulationsrubbning..nn.1
  artikulationsställe_1_N = mkN "artikulationsställe" ; -- artikulationsställe..nn.1
  artikulera_1_V = mkV "artikulerar" ; -- artikulera..vb.1
  artikulerande_1_N = mkN "artikulerande" ; -- artikulerande..nn.1
  artikulerbar_1_A = mkA "artikulerbar" ; -- artikulerbar..av.1
  artikulerbarhet_1_N = mkN "artikulerbarhet" ; -- artikulerbarhet..nn.1
  artikulering_1_N = mkN "artikulering" ; -- artikulering..nn.1
  artilleri_1_N = mkN "artilleri" neutrum  ; -- artilleri..nn.1
  artilleribatteri_1_N = mkN "artilleribatteri" "artilleribatteriet" "artilleribatterier" "artilleribatterierna" ; -- artilleribatteri..nn.1
  artilleribeskjutning_1_N = mkN "artilleribeskjutning" ; -- artilleribeskjutning..nn.1
  artilleriduell_1_N = mkN "artilleriduell" "artilleridueller" ; -- artilleriduell..nn.1
  artillerield_1_N = mkN "artillerield" ; -- artillerield..nn.1
  artilleriförband_1_N = mkN "artilleriförband" neutrum  ; -- artilleriförband..nn.1
  artillerigranat_1_N = mkN "artillerigranat" "artillerigranater" ; -- artillerigranat..nn.1
  artillerimanskap_1_N = mkN "artillerimanskap" neutrum  ; -- artillerimanskap..nn.1
  artilleripjäs_1_N = mkN "artilleripjäs" "artilleripjäser" ; -- artilleripjäs..nn.1
  artilleriregemente_1_N = mkN "artilleriregemente" ; -- artilleriregemente..nn.1
  artillerist_1_N = mkN "artillerist" "artillerister" ; -- artillerist..nn.1
  artillerivapen_1_N = mkN "artillerivapen" "artillerivapnet" "artillerivapen" "artillerivapnen" ; -- artillerivapen..nn.1
  artist_1_N = mkN "artist" "artister" ; -- artist..nn.1
  artistbana_1_N = mkN "artistbana" ; -- artistbana..nn.1
  artisteri_1_N = mkN "artisteri" neutrum  ; -- artisteri..nn.1
  artistframträdande_1_N = mkN "artistframträdande" ; -- artistframträdande..nn.1
  artistisk_1_A = mkA "artistisk" ; -- artistisk..av.1
  artistliv_1_N = mkN "artistliv" neutrum  ; -- artistliv..nn.1
  artistmässig_1_A = mkA "artistmässig" ; -- artistmässig..av.1
  artistnamn_1_N = mkN "artistnamn" neutrum  ; -- artistnamn..nn.1
  artnamn_1_N = mkN "artnamn" neutrum  ; -- artnamn..nn.1
  artonde_1_A = mkA "artonde" ; -- artonde..av.1
  artonhundranittiotal_1_N = mkN "artonhundranittiotal" neutrum  ; -- artonhundranittiotal..nn.1
  artonhundrasjuttiotal_1_N = mkN "artonhundrasjuttiotal" neutrum  ; -- artonhundrasjuttiotal..nn.1
  artonhundratal_1_N = mkN "artonhundratal" neutrum  ; -- artonhundratal..nn.1
  artonhundratalsmode_1_N = mkN "artonhundratalsmode" ; -- artonhundratalsmode..nn.1
  artonhundraåttiotal_1_N = mkN "artonhundraåttiotal" neutrum  ; -- artonhundraåttiotal..nn.1
  artonårig_1_A = mkA "artonårig" ; -- artonårig..av.1
  artonåring_1_N = mkN "artonåring" ; -- artonåring..nn.1
  artonårsdag_1_N = mkN "artonårsdag" ; -- artonårsdag..nn.1
  artonårsmyndighet_1_N = mkN "artonårsmyndighet" ; -- artonårsmyndighet..nn.1
  artotek_1_N = mkN "artotek" neutrum  ; -- artotek..nn.1
  artralgi_1_N = mkN "artralgi" ; -- artralgi..nn.1
  artrik_1_A = mkA "artrik" ; -- artrik..av.1
  artrikhet_1_N = mkN "artrikhet" ; -- artrikhet..nn.1
  artrit_1_N = mkN "artrit" "artriter" ; -- artrit..nn.1
  artrogrypos_1_N = mkN "artrogrypos" ; -- artrogrypos..nn.1
  artros_1_N = mkN "artros" "artroser" ; -- artros..nn.1
  artroskopi_1_N = mkN "artroskopi" "artroskopier" ; -- artroskopi..nn.1
  artskild_1_A = mkA "artskild" "artskilt" ; -- artskild..av.1
  artskildhet_1_N = mkN "artskildhet" ; -- artskildhet..nn.1
  artskillnad_1_N = mkN "artskillnad" "artskillnader" ; -- artskillnad..nn.1
  artär_1_N = mkN "artär" "artärer" ; -- artär..nn.1
  artärbråck_1_N = mkN "artärbråck" neutrum  ; -- artärbråck..nn.1
  artärinflammation_1_N = mkN "artärinflammation" ; -- artärinflammation..nn.1
  artärvägg_1_N = mkN "artärvägg" ; -- artärvägg..nn.1
  arv_1_N = mkN "arv" neutrum  ; -- arv..nn.1
  arve_1_N = mkN "arv" ; -- arve..nn.1
  arvedel_1_N = mkN "arvedel" "arvedelen" "arvedelar" "arvedelarna" ; -- arvedel..nn.1
  arvegods_1_N = mkN "arvegods" neutrum  ; -- arvegods..nn.1
  arvejord_1_N = mkN "arvejord" ; -- arvejord..nn.1
  arvfiende_1_N = mkN "arvfiende" "arvfiender" ; -- arvfiende..nn.1
  arvfurste_1_N = mkN "arvfurste" utrum  ; -- arvfurste..nn.1
  arvföljd_1_N = mkN "arvföljd" "arvföljder" ; -- arvföljd..nn.1
  arvföljdskrig_1_N = mkN "arvföljdskrig" neutrum  ; -- arvföljdskrig..nn.1
  arvförening_1_N = mkN "arvförening" ; -- arvförening..nn.1
  arvinge_1_N = mkN "arvinge" utrum  ; -- arvinge..nn.1
  arvkonung_1_N = mkN "arvkonung" ; -- arvkonung..nn.1
  arvland_1_N = mkN "arvland" "arvlandet" "arvländer" "arvländerna" ; -- arvland..nn.1
  arvlåtare_1_N = mkN "arvlåtare" utrum  ; -- arvlåtare..nn.1
  arvlös_1_A = mkA "arvlös" ; -- arvlös..av.1
  arvlöshet_1_N = mkN "arvlöshet" ; -- arvlöshet..nn.1
  arvode_1_N = mkN "arvode" ; -- arvode..nn.1
  arvodera_1_V = mkV "arvoderar" ; -- arvodera..vb.1
  arvoderande_1_N = mkN "arvoderande" ; -- arvoderande..nn.1
  arvoderbar_1_A = mkA "arvoderbar" ; -- arvoderbar..av.1
  arvoderbarhet_1_N = mkN "arvoderbarhet" ; -- arvoderbarhet..nn.1
  arvodering_1_N = mkN "arvodering" ; -- arvodering..nn.1
  arvodesbelopp_1_N = mkN "arvodesbelopp" neutrum  ; -- arvodesbelopp..nn.1
  arvord_1_N = mkN "arvord" neutrum  ; -- arvord..nn.1
  arvprins_1_N = mkN "arvprins" ; -- arvprins..nn.1
  arvrike_1_N = mkN "arvrike" ; -- arvrike..nn.1
  arvsanlag_1_N = mkN "arvsanlag" neutrum  ; -- arvsanlag..nn.1
  arvsanspråk_1_N = mkN "arvsanspråk" neutrum  ; -- arvsanspråk..nn.1
  arvsberättigad_1_A = mkA "arvsberättigad" ; -- arvsberättigad..av.1
  arvsfaktor_1_N = mkN "arvsfaktor" "arvsfaktorer" ; -- arvsfaktor..nn.1
  arvsfond_1_N = mkN "arvsfond" "arvsfonder" ; -- arvsfond..nn.1
  arvsfråga_1_N = mkN "arvsfråga" ; -- arvsfråga..nn.1
  arvsföljd_1_N = mkN "arvsföljd" "arvsföljder" ; -- arvsföljd..nn.1
  arvskatt_1_N = mkN "arvskatt" "arvskatter" ; -- arvskatt..nn.1
  arvskifte_1_N = mkN "arvskifte" ; -- arvskifte..nn.1
  arvslott_1_N = mkN "arvslott" "arvslotter" ; -- arvslott..nn.1
  arvsmassa_1_N = mkN "arvsmassa" ; -- arvsmassa..nn.1
  arvsmedel_1_N = mkN "arvsmedel" neutrum  ; -- arvsmedel..nn.1
  arvsmolekyl_1_N = mkN "arvsmolekyl" "arvsmolekyler" ; -- arvsmolekyl..nn.1
  arvsmässig_1_A = mkA "arvsmässig" ; -- arvsmässig..av.1
  arvsordning_1_N = mkN "arvsordning" ; -- arvsordning..nn.1
  arvsrätt_1_N = mkN "arvsrätt" "arvsrätter" ; -- arvsrätt..nn.1
  arvssak_1_N = mkN "arvssak" "arvssaker" ; -- arvssak..nn.1
  arvsskatt_1_N = mkN "arvsskatt" "arvsskatter" ; -- arvsskatt..nn.1
  arvstvist_1_N = mkN "arvstvist" "arvstvister" ; -- arvstvist..nn.1
  arvsynd_1_N = mkN "arvsynd" "arvsynder" ; -- arvsynd..nn.1
  arvtagare_1_N = mkN "arvtagare" utrum  ; -- arvtagare..nn.1
  arvtant_1_N = mkN "arvtant" "arvtanter" ; -- arvtant..nn.1
  arytmi_1_N = mkN "arytmi" "arytmier" ; -- arytmi..nn.1
  as_1_N = mkN "as" neutrum  ; -- as..nn.1
  as_2_N = mkN "as" ; -- as..nn.2
  asa_1_V = mkV "asar" ; -- asa..vb.1
  asagud_1_N = mkN "asagud" ; -- asagud..nn.1
  asalära_1_N = mkN "asalära" ; -- asalära..nn.1
  asande_1_N = mkN "asande" ; -- asande..nn.1
  asasläkt_1_N = mkN "asasläkt" ; -- asasläkt..nn.1
  asatid_1_N = mkN "asatid" ; -- asatid..nn.1
  asatro_1_N = mkN "asatro" ; -- asatro..nn.1
  asatroende_1_A = mkA "asatroende" ; -- asatroende..av.1
  asbagge_1_N = mkN "asbagge" utrum  ; -- asbagge..nn.1
  asberusad_1_A = mkA "asberusad" ; -- asberusad..av.1
  asbest_1_N = mkN "asbest" ; -- asbest..nn.1
  asbestarbetare_1_N = mkN "asbestarbetare" utrum  ; -- asbestarbetare..nn.1
  asbestartad_1_A = mkA "asbestartad" ; -- asbestartad..av.1
  asbestcement_1_N = mkN "asbestcement" ; -- asbestcement..nn.1
  asbestlunga_1_N = mkN "asbestlunga" ; -- asbestlunga..nn.1
  asbestos_1_N = mkN "asbestos" ; -- asbestos..nn.1
  asbestplatta_1_N = mkN "asbestplatta" ; -- asbestplatta..nn.1
  asbestsanering_1_N = mkN "asbestsanering" ; -- asbestsanering..nn.1
  asbesttråd_1_N = mkN "asbesttråd" ; -- asbesttråd..nn.1
  ascaridiasis_1_N = mkN "ascaridiasis" "ascaridiasiser" ; -- ascaridiasis..nn.1
  ascarididainfektion_1_N = mkN "ascarididainfektion" ; -- ascarididainfektion..nn.1
  ascendent_1_N = mkN "ascendent" "ascendenter" ; -- ascendent..nn.1
  aschel_1_N = mkN "aschel" ; -- aschel..nn.1
  aschle_1_N = mkN "aschle" ; -- aschle..nn.1
  ascites_1_N = mkN "ascites" ; -- ascites..nn.1
  asenkel_1_A = mkA "asenkel" ; -- asenkel..av.1
  aseptik_1_N = mkN "aseptik" ; -- aseptik..nn.1
  aseptisk_1_A = mkA "aseptisk" ; -- aseptisk..av.1
  asexuell_1_A = mkA "asexuell" ; -- asexuell..av.1
  asfalt_1_N = mkN "asfalt" "asfalter" ; -- asfalt..nn.1
  asfaltemulsion_1_N = mkN "asfaltemulsion" ; -- asfaltemulsion..nn.1
  asfaltera_1_V = mkV "asfalterar" ; -- asfaltera..vb.1
  asfalterande_1_N = mkN "asfalterande" ; -- asfalterande..nn.1
  asfalterbar_1_A = mkA "asfalterbar" ; -- asfalterbar..av.1
  asfalterbarhet_1_N = mkN "asfalterbarhet" ; -- asfalterbarhet..nn.1
  asfaltering_1_N = mkN "asfaltering" ; -- asfaltering..nn.1
  asfaltlack_1_N = mkN "asfaltlack" "asfaltlacker" ; -- asfaltlack..nn.1
  asfaltmoped_1_N = mkN "asfaltmoped" "asfaltmopeder" ; -- asfaltmoped..nn.1
  asfaltplatta_1_N = mkN "asfaltplatta" ; -- asfaltplatta..nn.1
  asfluga_1_N = mkN "asfluga" ; -- asfluga..nn.1
  asfull_1_A = mkA "asfull" ; -- asfull..av.1
  asfyxi_1_N = mkN "asfyxi" ; -- asfyxi..nn.1
  asfyxiskada_1_N = mkN "asfyxiskada" ; -- asfyxiskada..nn.1
  asfågel_1_N = mkN "asfågel" ; -- asfågel..nn.1
  asförbannad_1_A = mkA "asförbannad" ; -- asförbannad..av.1
  asgam_1_N = mkN "asgam" ; -- asgam..nn.1
  asgarva_1_V = mkV "asgarvar" ; -- asgarva..vb.1
  ashkenaz_1_N = mkN "ashkenaz" "ashkenazer" ; -- ashkenaz..nn.1
  ashkenazisk_1_A = mkA "ashkenazisk" ; -- ashkenazisk..av.1
  asiat_1_N = mkN "asiat" "asiater" ; -- asiat..nn.1
  asiatisk_1_A = mkA "asiatisk" ; -- asiatisk..av.1
  asiatiska_1_N = mkN "asiatiska" ; -- asiatiska..nn.1
  asimut_1_N = mkN "asimut" "asimuter" ; -- asimut..nn.1
  ask_1_N = mkN "ask" ; -- ask..nn.1
  aska_1_N = mkN "aska" ; -- aska..nn.1
  aska_1_V = mkV "askar" ; -- aska..vb.1
  askande_1_N = mkN "askande" ; -- askande..nn.1
  askblond_1_A = mkA "askblond" ; -- askblond..av.1
  aske_1_N = mkN "aske" ; -- aske..nn.1
  askenas_1_N = mkN "askenas" "askenaser" ; -- askenas..nn.1
  askeruption_1_N = mkN "askeruption" ; -- askeruption..nn.1
  askes_1_N = mkN "askes" ; -- askes..nn.1
  asket_1_N = mkN "asket" "asketer" ; -- asket..nn.1
  asketisk_1_A = mkA "asketisk" ; -- asketisk..av.1
  asketism_1_N = mkN "asketism" "asketismer" ; -- asketism..nn.1
  asketliv_1_N = mkN "asketliv" neutrum  ; -- asketliv..nn.1
  askexplosion_1_N = mkN "askexplosion" ; -- askexplosion..nn.1
  askfat_1_N = mkN "askfat" neutrum  ; -- askfat..nn.1
  askfri_1_A = mkA "askfri" "askfritt" ; -- askfri..av.1
  askfrihet_1_N = mkN "askfrihet" ; -- askfrihet..nn.1
  askgrå_1_A = mkA "askgrå" "askgrått" ; -- askgrå..av.1
  askhot_1_N = mkN "askhot" neutrum  ; -- askhot..nn.1
  askhög_1_N = mkN "askhög" ; -- askhög..nn.1
  askkoncentration_1_N = mkN "askkoncentration" ; -- askkoncentration..nn.1
  askkopp_1_N = mkN "askkopp" ; -- askkopp..nn.1
  askkris_1_N = mkN "askkris" "askkriser" ; -- askkris..nn.1
  asklock_1_N = mkN "asklock" neutrum  ; -- asklock..nn.1
  askmoln_1_N = mkN "askmoln" neutrum  ; -- askmoln..nn.1
  askonsdag_1_N = mkN "askonsdag" ; -- askonsdag..nn.1
  askorbinsyra_1_N = mkN "askorbinsyra" ; -- askorbinsyra..nn.1
  askorbinsyrabrist_1_N = mkN "askorbinsyrabrist" ; -- askorbinsyrabrist..nn.1
  askpartikel_1_N = mkN "askpartikel" ; -- askpartikel..nn.1
  askpuff_1_N = mkN "askpuff" ; -- askpuff..nn.1
  askregn_1_N = mkN "askregn" neutrum  ; -- askregn..nn.1
  askskott_1_N = mkN "askskott" neutrum  ; -- askskott..nn.1
  askskottssjuka_1_N = mkN "askskottssjuka" ; -- askskottssjuka..nn.1
  askspridning_1_N = mkN "askspridning" ; -- askspridning..nn.1
  asktipp_1_N = mkN "asktipp" ; -- asktipp..nn.1
  askträ_1_N = mkN "askträ" neutrum  ; -- askträ..nn.1
  askunge_1_N = mkN "askunge" utrum  ; -- askunge..nn.1
  askurna_1_N = mkN "askurna" ; -- askurna..nn.1
  asocial_1_A = mkA "asocial" ; -- asocial..av.1
  asocialitet_1_N = mkN "asocialitet" "asocialiteter" ; -- asocialitet..nn.1
  asp_1_N = mkN "asp" ; -- asp..nn.1
  aspackad_1_A = mkA "aspackad" ; -- aspackad..av.1
  aspartylglukosaminuri_1_N = mkN "aspartylglukosaminuri" ; -- aspartylglukosaminuri..nn.1
  aspbark_1_N = mkN "aspbark" ; -- aspbark..nn.1
  aspdunge_1_N = mkN "aspdunge" utrum  ; -- aspdunge..nn.1
  aspe_1_N = mkN "aspe" ; -- aspe..nn.1
  aspekt_1_N = mkN "aspekt" "aspekter" ; -- aspekt..nn.1
  aspergillos_1_N = mkN "aspergillos" ; -- aspergillos..nn.1
  aspgren_1_N = mkN "aspgren" "aspgrenen" "aspgrenar" "aspgrenarna" ; -- aspgren..nn.1
  asphänge_1_N = mkN "asphänge" ; -- asphänge..nn.1
  aspirant_1_N = mkN "aspirant" "aspiranter" ; -- aspirant..nn.1
  aspirata_1_N = mkN "aspirata" ; -- aspirata..nn.1
  aspiration_1_N = mkN "aspiration" ; -- aspiration..nn.1
  aspirationspneumoni_1_N = mkN "aspirationspneumoni" ; -- aspirationspneumoni..nn.1
  aspirera_1_V = mkV "aspirerar" ; -- aspirera..vb.1
  aspirerad_1_A = mkA "aspirerad" ; -- aspirerad..av.1
  aspirerande_1_N = mkN "aspirerande" ; -- aspirerande..nn.1
  aspirerbar_1_A = mkA "aspirerbar" ; -- aspirerbar..av.1
  aspirerbarhet_1_N = mkN "aspirerbarhet" ; -- aspirerbarhet..nn.1
  aspirering_1_N = mkN "aspirering" ; -- aspirering..nn.1
  aspirin_1_N = mkN "aspirin" "aspiriner" ; -- aspirin..nn.1
  asplöv_1_N = mkN "asplöv" neutrum  ; -- asplöv..nn.1
  aspsly_1_N = mkN "aspsly" neutrum  ; -- aspsly..nn.1
  ass_1_N = mkN "ass" neutrum  ; -- ass..nn.1
  assegaj_1_N = mkN "assegaj" "assegajer" ; -- assegaj..nn.1
  assessor_1_N = mkN "assessor" "assessorer" ; -- assessor..nn.1
  assiett_1_N = mkN "assiett" "assietter" ; -- assiett..nn.1
  assiettgaffel_1_N = mkN "assiettgaffel" ; -- assiettgaffel..nn.1
  assignant_1_N = mkN "assignant" "assignanter" ; -- assignant..nn.1
  assignation_1_N = mkN "assignation" ; -- assignation..nn.1
  assignera_1_V = mkV "assignerar" ; -- assignera..vb.1
  assignerande_1_N = mkN "assignerande" ; -- assignerande..nn.1
  assignerbar_1_A = mkA "assignerbar" ; -- assignerbar..av.1
  assignerbarhet_1_N = mkN "assignerbarhet" ; -- assignerbarhet..nn.1
  assignering_1_N = mkN "assignering" ; -- assignering..nn.1
  assimilation_1_N = mkN "assimilation" ; -- assimilation..nn.1
  assimilationsprocess_1_N = mkN "assimilationsprocess" "assimilationsprocesser" ; -- assimilationsprocess..nn.1
  assimilera_1_V = mkV "assimilerar" ; -- assimilera..vb.1
  assimilerande_1_N = mkN "assimilerande" ; -- assimilerande..nn.1
  assimilerbar_1_A = mkA "assimilerbar" ; -- assimilerbar..av.1
  assimilerbarhet_1_N = mkN "assimilerbarhet" ; -- assimilerbarhet..nn.1
  assimilering_1_N = mkN "assimilering" ; -- assimilering..nn.1
  assist_1_N = mkN "assist" "assisten" "assist" "assisten" ; -- assist..nn.1
  assistans_1_N = mkN "assistans" "assistanser" ; -- assistans..nn.1
  assistdrottning_1_N = mkN "assistdrottning" ; -- assistdrottning..nn.1
  assistent_1_N = mkN "assistent" "assistenter" ; -- assistent..nn.1
  assistera_1_V = mkV "assisterar" ; -- assistera..vb.1
  assisterande_1_N = mkN "assisterande" ; -- assisterande..nn.1
  assisterbar_1_A = mkA "assisterbar" ; -- assisterbar..av.1
  assisterbarhet_1_N = mkN "assisterbarhet" ; -- assisterbarhet..nn.1
  assistering_1_N = mkN "assistering" ; -- assistering..nn.1
  assistkung_1_N = mkN "assistkung" ; -- assistkung..nn.1
  association_1_N = mkN "association" ; -- association..nn.1
  associationsbana_1_N = mkN "associationsbana" ; -- associationsbana..nn.1
  associationskedja_1_N = mkN "associationskedja" ; -- associationskedja..nn.1
  associationslexikon_1_N = mkN "associationslexikon" neutrum  ; -- associationslexikon..nn.1
  associationspsykologi_1_N = mkN "associationspsykologi" ; -- associationspsykologi..nn.1
  associationsrik_1_A = mkA "associationsrik" ; -- associationsrik..av.1
  associationsrikedom_1_N = mkN "associationsrikedom" ; -- associationsrikedom..nn.1
  associativ_1_A = mkA "associativ" ; -- associativ..av.1
  associera_1_V = mkV "associerar" ; -- associera..vb.1
  associerande_1_N = mkN "associerande" ; -- associerande..nn.1
  associerbar_1_A = mkA "associerbar" ; -- associerbar..av.1
  associerbarhet_1_N = mkN "associerbarhet" ; -- associerbarhet..nn.1
  associering_1_N = mkN "associering" ; -- associering..nn.1
  assonans_1_N = mkN "assonans" "assonanser" ; -- assonans..nn.1
  assuradör_1_N = mkN "assuradör" "assuradörer" ; -- assuradör..nn.1
  assurans_1_N = mkN "assurans" "assuranser" ; -- assurans..nn.1
  assuransspruta_1_N = mkN "assuransspruta" ; -- assuransspruta..nn.1
  assurera_1_V = mkV "assurerar" ; -- assurera..vb.1
  assurerande_1_N = mkN "assurerande" ; -- assurerande..nn.1
  assurerbar_1_A = mkA "assurerbar" ; -- assurerbar..av.1
  assurerbarhet_1_N = mkN "assurerbarhet" ; -- assurerbarhet..nn.1
  assurering_1_N = mkN "assurering" ; -- assurering..nn.1
  assyrier_1_N = mkN "assyrier" "assyriern" "assyrier" "assyrierna" ; -- assyrier..nn.1
  assyrisk_1_A = mkA "assyrisk" ; -- assyrisk..av.1
  assyriska_1_N = mkN "assyriska" ; -- assyriska..nn.1
  assyriska_2_N = mkN "assyriska" ; -- assyriska..nn.2
  asså_1_Adv = mkAdv "asså" ; -- asså..ab.1
  astat_1_N = mkN "astat" ; -- astat..nn.1
  asteni_1_N = mkN "asteni" "astenier" ; -- asteni..nn.1
  asteniker_1_N = mkN "asteniker" "astenikern" "asteniker" "astenikerna" ; -- asteniker..nn.1
  astenisk_1_A = mkA "astenisk" ; -- astenisk..av.1
  astenopi_1_N = mkN "astenopi" ; -- astenopi..nn.1
  astenozoospermi_1_N = mkN "astenozoospermi" ; -- astenozoospermi..nn.1
  aster_1_N = mkN "aster" ; -- aster..nn.1
  asterisk_1_N = mkN "asterisk" "asterisker" ; -- asterisk..nn.1
  asteroid_1_N = mkN "asteroid" "asteroider" ; -- asteroid..nn.1
  asteroidnedfall_1_N = mkN "asteroidnedfall" neutrum  ; -- asteroidnedfall..nn.1
  asteroidnedslag_1_N = mkN "asteroidnedslag" neutrum  ; -- asteroidnedslag..nn.1
  astigmatiker_1_N = mkN "astigmatiker" "astigmatikern" "astigmatiker" "astigmatikerna" ; -- astigmatiker..nn.1
  astigmatisk_1_A = mkA "astigmatisk" ; -- astigmatisk..av.1
  astigmatism_1_N = mkN "astigmatism" "astigmatismer" ; -- astigmatism..nn.1
  astma_1_N = mkN "astma" ; -- astma..nn.1
  astmatiker_1_N = mkN "astmatiker" "astmatikern" "astmatiker" "astmatikerna" ; -- astmatiker..nn.1
  astmatisk_1_A = mkA "astmatisk" ; -- astmatisk..av.1
  astrakan_1_N = mkN "astrakan" "astrakaner" ; -- astrakan..nn.1
  astrakan_2_N = mkN "astrakan" "astrakaner" ; -- astrakan..nn.2
  astral_1_A = mkA "astral" ; -- astral..av.1
  astralkropp_1_N = mkN "astralkropp" ; -- astralkropp..nn.1
  astrocytom_1_N = mkN "astrocytom" neutrum  ; -- astrocytom..nn.1
  astrofotografi_1_N = mkN "astrofotografi" "astrofotografiet" "astrofotografier" "astrofotografierna" ; -- astrofotografi..nn.1
  astrofysik_1_N = mkN "astrofysik" ; -- astrofysik..nn.1
  astrofysiker_1_N = mkN "astrofysiker" "astrofysikern" "astrofysiker" "astrofysikerna" ; -- astrofysiker..nn.1
  astrolabium_1_N = mkN "astrolabium" "astrolabiet" "astrolabier" "astrolabierna" ; -- astrolabium..nn.1
  astrolog_1_N = mkN "astrolog" "astrologer" ; -- astrolog..nn.1
  astrologi_1_N = mkN "astrologi" ; -- astrologi..nn.1
  astrologisk_1_A = mkA "astrologisk" ; -- astrologisk..av.1
  astronaut_1_N = mkN "astronaut" "astronauter" ; -- astronaut..nn.1
  astronautik_1_N = mkN "astronautik" "astronautiker" ; -- astronautik..nn.1
  astronom_1_N = mkN "astronom" "astronomer" ; -- astronom..nn.1
  astronomi_1_N = mkN "astronomi" ; -- astronomi..nn.1
  astronomisk_1_A = mkA "astronomisk" ; -- astronomisk..av.1
  astronomisk_2_A = mkA "astronomisk" ; -- astronomisk..av.2
  astrovirusinfektion_1_N = mkN "astrovirusinfektion" ; -- astrovirusinfektion..nn.1
  asyl_1_N = mkN "asyl" "asyler" ; -- asyl..nn.1
  asylland_1_N = mkN "asylland" "asyllandet" "asylländer" "asylländerna" ; -- asylland..nn.1
  asylmottagning_1_N = mkN "asylmottagning" ; -- asylmottagning..nn.1
  asylpolitik_1_N = mkN "asylpolitik" ; -- asylpolitik..nn.1
  asylrätt_1_N = mkN "asylrätt" ; -- asylrätt..nn.1
  asylskäl_1_N = mkN "asylskäl" neutrum  ; -- asylskäl..nn.1
  asylsökande_1_A = mkA "asylsökande" ; -- asylsökande..av.1
  asylsökande_1_N = mkN "asylsökande" "asylsökanden" "asylsökanden" "asylsökandena" ; -- asylsökande..nn.1
  asymmetri_1_N = mkN "asymmetri" "asymmetrier" ; -- asymmetri..nn.1
  asymmetrisk_1_A = mkA "asymmetrisk" ; -- asymmetrisk..av.1
  asymptot_1_N = mkN "asymptot" "asymptoter" ; -- asymptot..nn.1
  asyndes_1_N = mkN "asyndes" "asyndeser" ; -- asyndes..nn.1
  asyndetisk_1_A = mkA "asyndetisk" ; -- asyndetisk..av.1
  asyndeton_1_N = mkN "asyndeton" "asyndeton" "asyndeton" "asyndetonen" ; -- asyndeton..nn.1
  asynja_1_N = mkN "asynja" ; -- asynja..nn.1
  asynkron_1_A = mkA "asynkron" ; -- asynkron..av.1
  asystoli_1_N = mkN "asystoli" "asystolier" ; -- asystoli..nn.1
  asätare_1_N = mkN "asätare" utrum  ; -- asätare..nn.1
  ataktisk_1_A = mkA "ataktisk" ; -- ataktisk..av.1
  ataraktika_1_N = mkN "ataraktika" "ataraktikat" "ataraktika" "ataraktikana" ; -- ataraktika..nn.1
  ataraxi_1_N = mkN "ataraxi" ; -- ataraxi..nn.1
  atavism_1_N = mkN "atavism" "atavismer" ; -- atavism..nn.1
  atavistisk_1_A = mkA "atavistisk" ; -- atavistisk..av.1
  ataxi_1_N = mkN "ataxi" "ataxier" ; -- ataxi..nn.1
  ateism_1_N = mkN "ateism" "ateismer" ; -- ateism..nn.1
  ateist_1_N = mkN "ateist" "ateister" ; -- ateist..nn.1
  ateistisk_1_A = mkA "ateistisk" ; -- ateistisk..av.1
  atelektas_1_N = mkN "atelektas" "atelektaser" ; -- atelektas..nn.1
  ateljé_1_N = mkN "ateljé" "ateljéer" ; -- ateljé..nn.1
  ateljébild_1_N = mkN "ateljébild" "ateljébilder" ; -- ateljébild..nn.1
  ateljéfönster_1_N = mkN "ateljéfönster" neutrum  ; -- ateljéfönster..nn.1
  ateljévåning_1_N = mkN "ateljévåning" ; -- ateljévåning..nn.1
  atenienn_1_N = mkN "atenienn" "atenienner" ; -- atenienn..nn.1
  atensk_1_A = mkA "atensk" ; -- atensk..av.1
  aterogenes_1_N = mkN "aterogenes" ; -- aterogenes..nn.1
  aterom_1_N = mkN "aterom" neutrum  ; -- aterom..nn.1
  ateroskleros_1_N = mkN "ateroskleros" "ateroskleroser" ; -- ateroskleros..nn.1
  atetos_1_N = mkN "atetos" ; -- atetos..nn.1
  atlantisk_1_A = mkA "atlantisk" ; -- atlantisk..av.1
  atlantångare_1_N = mkN "atlantångare" utrum  ; -- atlantångare..nn.1
  atlas_1_N = mkN "atlas" "atlaser" ; -- atlas..nn.1
  atlas_2_N = mkN "atlas" ; -- atlas..nn.2
  atlasbindning_1_N = mkN "atlasbindning" ; -- atlasbindning..nn.1
  atlaskota_1_N = mkN "atlaskota" ; -- atlaskota..nn.1
  atlasspinnare_1_N = mkN "atlasspinnare" utrum  ; -- atlasspinnare..nn.1
  atlet_1_N = mkN "atlet" "atleter" ; -- atlet..nn.1
  atletisk_1_A = mkA "atletisk" ; -- atletisk..av.1
  atletklubb_1_N = mkN "atletklubb" ; -- atletklubb..nn.1
  atmosfär_1_N = mkN "atmosfär" "atmosfärer" ; -- atmosfär..nn.1
  atmosfärforskare_1_N = mkN "atmosfärforskare" utrum  ; -- atmosfärforskare..nn.1
  atmosfärisk_1_A = mkA "atmosfärisk" ; -- atmosfärisk..av.1
  atmosfärkemist_1_N = mkN "atmosfärkemist" "atmosfärkemister" ; -- atmosfärkemist..nn.1
  atmosfärsförhållande_1_N = mkN "atmosfärsförhållande" ; -- atmosfärsförhållande..nn.1
  atmosfärslager_1_N = mkN "atmosfärslager" neutrum  ; -- atmosfärslager..nn.1
  atmosfärstryck_1_N = mkN "atmosfärstryck" neutrum  ; -- atmosfärstryck..nn.1
  atmosfärtryck_1_N = mkN "atmosfärtryck" neutrum  ; -- atmosfärtryck..nn.1
  atoll_1_N = mkN "atoll" "atoller" ; -- atoll..nn.1
  atom_1_N = mkN "atom" "atomer" ; -- atom..nn.1
  atombomb_1_N = mkN "atombomb" "atombomber" ; -- atombomb..nn.1
  atombomba_1_V = mkV "atombombar" ; -- atombomba..vb.1
  atombombande_1_N = mkN "atombombande" ; -- atombombande..nn.1
  atombombsfällning_1_N = mkN "atombombsfällning" ; -- atombombsfällning..nn.1
  atombombsöverlevande_1_A = mkA "atombombsöverlevande" ; -- atombombsöverlevande..av.1
  atombrygga_1_N = mkN "atombrygga" ; -- atombrygga..nn.1
  atomdriven_1_A = mkA "atomdriven" ; -- atomdriven..av.1
  atomenergi_1_N = mkN "atomenergi" ; -- atomenergi..nn.1
  atomenergiorgan_1_N = mkN "atomenergiorgan" neutrum  ; -- atomenergiorgan..nn.1
  atomenergiorganisation_1_N = mkN "atomenergiorganisation" ; -- atomenergiorganisation..nn.1
  atomfysik_1_N = mkN "atomfysik" ; -- atomfysik..nn.1
  atomgrupp_1_N = mkN "atomgrupp" "atomgrupper" ; -- atomgrupp..nn.1
  atomism_1_N = mkN "atomism" "atomismer" ; -- atomism..nn.1
  atomistisk_1_A = mkA "atomistisk" ; -- atomistisk..av.1
  atomjon_1_N = mkN "atomjon" "atomjoner" ; -- atomjon..nn.1
  atomklocka_1_N = mkN "atomklocka" ; -- atomklocka..nn.1
  atomkraft_1_N = mkN "atomkraft" ; -- atomkraft..nn.1
  atomkraftmikroskop_1_N = mkN "atomkraftmikroskop" neutrum  ; -- atomkraftmikroskop..nn.1
  atomkraftsutbyggnad_1_N = mkN "atomkraftsutbyggnad" "atomkraftsutbyggnader" ; -- atomkraftsutbyggnad..nn.1
  atomkärna_1_N = mkN "atomkärna" ; -- atomkärna..nn.1
  atomlära_1_N = mkN "atomlära" ; -- atomlära..nn.1
  atommassa_1_N = mkN "atommassa" ; -- atommassa..nn.1
  atommodell_1_N = mkN "atommodell" "atommodeller" ; -- atommodell..nn.1
  atomnummer_1_N = mkN "atomnummer" neutrum  ; -- atomnummer..nn.1
  atomreaktor_1_N = mkN "atomreaktor" "atomreaktorer" ; -- atomreaktor..nn.1
  atomspektrum_1_N = mkN "atomspektrum" neutrum  ; -- atomspektrum..nn.1
  atomteori_1_N = mkN "atomteori" "atomteorier" ; -- atomteori..nn.1
  atomubåt_1_N = mkN "atomubåt" ; -- atomubåt..nn.1
  atomur_1_N = mkN "atomur" neutrum  ; -- atomur..nn.1
  atomvapen_1_N = mkN "atomvapen" "atomvapnet" "atomvapen" "atomvapnen" ; -- atomvapen..nn.1
  atomvikt_1_N = mkN "atomvikt" "atomvikter" ; -- atomvikt..nn.1
  atomvinter_1_N = mkN "atomvinter" ; -- atomvinter..nn.1
  atomär_1_A = mkA "atomär" ; -- atomär..av.1
  atonal_1_A = mkA "atonal" ; -- atonal..av.1
  atoni_1_N = mkN "atoni" "atonier" ; -- atoni..nn.1
  atopi_1_N = mkN "atopi" "atopier" ; -- atopi..nn.1
  atrieflimmer_1_N = mkN "atrieflimmer" neutrum  ; -- atrieflimmer..nn.1
  atrium_1_N = mkN "atrium" "atriet" "atrier" "atrierna" ; -- atrium..nn.1
  atrofi_1_N = mkN "atrofi" "atrofier" ; -- atrofi..nn.1
  atrofiera_1_V = mkV "atrofierar" ; -- atrofiera..vb.1
  atrofierande_1_N = mkN "atrofierande" ; -- atrofierande..nn.1
  atrofierbar_1_A = mkA "atrofierbar" ; -- atrofierbar..av.1
  atrofierbarhet_1_N = mkN "atrofierbarhet" ; -- atrofierbarhet..nn.1
  atrofiering_1_N = mkN "atrofiering" ; -- atrofiering..nn.1
  atrofisk_1_A = mkA "atrofisk" ; -- atrofisk..av.1
  atropin_1_N = mkN "atropin" ; -- atropin..nn.1
  att_sats_1_N = mkN "att-sats" "att-satser" ; -- att-sats..nn.1
  attaché_1_N = mkN "attaché" "attachéer" ; -- attaché..nn.1
  attachéväska_1_N = mkN "attachéväska" ; -- attachéväska..nn.1
  attack_1_N = mkN "attack" "attacker" ; -- attack..nn.1
  attackdykare_1_N = mkN "attackdykare" utrum  ; -- attackdykare..nn.1
  attackera_1_V = mkV "attackerar" ; -- attackera..vb.1
  attackerande_1_N = mkN "attackerande" ; -- attackerande..nn.1
  attackerbar_1_A = mkA "attackerbar" ; -- attackerbar..av.1
  attackerbarhet_1_N = mkN "attackerbarhet" ; -- attackerbarhet..nn.1
  attackering_1_N = mkN "attackering" ; -- attackering..nn.1
  attackflyg_1_N = mkN "attackflyg" neutrum  ; -- attackflyg..nn.1
  attackflygplan_1_N = mkN "attackflygplan" neutrum  ; -- attackflygplan..nn.1
  attackförmåga_1_N = mkN "attackförmåga" ; -- attackförmåga..nn.1
  attackhelikopter_1_N = mkN "attackhelikopter" ; -- attackhelikopter..nn.1
  attackplan_1_N = mkN "attackplan" neutrum  ; -- attackplan..nn.1
  attacksignal_1_N = mkN "attacksignal" "attacksignaler" ; -- attacksignal..nn.1
  attan_1_N = mkN "attan" ; -- attan..nn.1
  attentat_1_N = mkN "attentat" neutrum  ; -- attentat..nn.1
  attentator_1_N = mkN "attentator" "attentatorer" ; -- attentator..nn.1
  attentatsman_1_N = mkN "attentatsman" "attentatsmannen" "attentatsmän" "attentatsmännen" ; -- attentatsman..nn.1
  attest_1_N = mkN "attest" "attester" ; -- attest..nn.1
  attestera_1_V = mkV "attesterar" ; -- attestera..vb.1
  attesterande_1_N = mkN "attesterande" ; -- attesterande..nn.1
  attesterbar_1_A = mkA "attesterbar" ; -- attesterbar..av.1
  attesterbarhet_1_N = mkN "attesterbarhet" ; -- attesterbarhet..nn.1
  attestering_1_N = mkN "attestering" ; -- attestering..nn.1
  attika_1_N = mkN "attika" ; -- attika..nn.1
  attila_1_N = mkN "attila" ; -- attila..nn.1
  attiralj_1_N = mkN "attiralj" "attiraljer" ; -- attiralj..nn.1
  attisk_1_A = mkA "attisk" ; -- attisk..av.1
  attityd_1_N = mkN "attityd" "attityder" ; -- attityd..nn.1
  attitydförändring_1_N = mkN "attitydförändring" ; -- attitydförändring..nn.1
  attitydmässig_1_A = mkA "attitydmässig" ; -- attitydmässig..av.1
  attitydundersökning_1_N = mkN "attitydundersökning" ; -- attitydundersökning..nn.1
  attrahera_1_V = mkV "attraherar" ; -- attrahera..vb.1
  attraherande_1_N = mkN "attraherande" ; -- attraherande..nn.1
  attraherbar_1_A = mkA "attraherbar" ; -- attraherbar..av.1
  attraherbarhet_1_N = mkN "attraherbarhet" ; -- attraherbarhet..nn.1
  attrahering_1_N = mkN "attrahering" ; -- attrahering..nn.1
  attraktion_1_N = mkN "attraktion" ; -- attraktion..nn.1
  attraktionskraft_1_N = mkN "attraktionskraft" "attraktionskrafter" ; -- attraktionskraft..nn.1
  attraktionslag_1_N = mkN "attraktionslag" ; -- attraktionslag..nn.1
  attraktiv_1_A = mkA "attraktiv" ; -- attraktiv..av.1
  attraktivitet_1_N = mkN "attraktivitet" ; -- attraktivitet..nn.1
  attrapp_1_N = mkN "attrapp" "attrapper" ; -- attrapp..nn.1
  attrappera_1_V = mkV "attrapperar" ; -- attrappera..vb.1
  attrapperande_1_N = mkN "attrapperande" ; -- attrapperande..nn.1
  attrapperbar_1_A = mkA "attrapperbar" ; -- attrapperbar..av.1
  attrapperbarhet_1_N = mkN "attrapperbarhet" ; -- attrapperbarhet..nn.1
  attrappering_1_N = mkN "attrappering" ; -- attrappering..nn.1
  attribuera_1_V = mkV "attribuerar" ; -- attribuera..vb.1
  attribuerande_1_N = mkN "attribuerande" ; -- attribuerande..nn.1
  attribuerbar_1_A = mkA "attribuerbar" ; -- attribuerbar..av.1
  attribuerbarhet_1_N = mkN "attribuerbarhet" ; -- attribuerbarhet..nn.1
  attribuering_1_N = mkN "attribuering" ; -- attribuering..nn.1
  attribut_1_N = mkN "attribut" neutrum  ; -- attribut..nn.1
  attribution_1_N = mkN "attribution" ; -- attribution..nn.1
  attributiv_1_A = mkA "attributiv" ; -- attributiv..av.1
  attributsamling_1_N = mkN "attributsamling" ; -- attributsamling..nn.1
  attributsats_1_N = mkN "attributsats" "attributsatser" ; -- attributsats..nn.1
  atypi_1_N = mkN "atypi" "atypier" ; -- atypi..nn.1
  atypisk_1_A = mkA "atypisk" ; -- atypisk..av.1
  au_pair_flicka_1_N = mkN "au-pair-flicka" ; -- au-pair-flicka..nn.1
  au_pair_1_N = mkN "au-pair" "au-pairer" ; -- au-pair..nn.1
  aubergin_1_N = mkN "aubergin" ; -- aubergin..nn.1
  aubergine_1_N = mkN "aubergine" "auberginer" ; -- aubergine..nn.1
  audiens_1_N = mkN "audiens" "audienser" ; -- audiens..nn.1
  audiensdag_1_N = mkN "audiensdag" ; -- audiensdag..nn.1
  audienssal_1_N = mkN "audienssal" ; -- audienssal..nn.1
  audienssökande_1_N = mkN "audienssökande" "audienssökanden" "audienssökanden" "audienssökandena" ; -- audienssökande..nn.1
  audiogram_1_N = mkN "audiogram" "audiogrammet" "audiogram" "audiogrammen" ; -- audiogram..nn.1
  audiologi_1_N = mkN "audiologi" ; -- audiologi..nn.1
  audiometer_1_N = mkN "audiometer" ; -- audiometer..nn.1
  audiovisuell_1_A = mkA "audiovisuell" ; -- audiovisuell..av.1
  audit_1_N = mkN "audit" ; -- audit..nn.1
  auditiv_1_A = mkA "auditiv" ; -- auditiv..av.1
  auditorium_1_N = mkN "auditorium" "auditoriet" "auditorier" "auditorierna" ; -- auditorium..nn.1
  auditör_1_N = mkN "auditör" "auditörer" ; -- auditör..nn.1
  audivisuell_1_A = mkA "audivisuell" ; -- audivisuell..av.1
  auerlampa_1_N = mkN "auerlampa" ; -- auerlampa..nn.1
  auerstrumpa_1_N = mkN "auerstrumpa" ; -- auerstrumpa..nn.1
  augiasstall_1_N = mkN "augiasstall" neutrum  ; -- augiasstall..nn.1
  augment_1_N = mkN "augment" neutrum  ; -- augment..nn.1
  augur_1_N = mkN "augur" "augurer" ; -- augur..nn.1
  augusti_1_N = mkN "augusti" ; -- augusti..nn.1
  augustidag_1_N = mkN "augustidag" ; -- augustidag..nn.1
  augustimånsken_1_N = mkN "augustimånsken" neutrum  ; -- augustimånsken..nn.1
  augustinatt_1_N = mkN "augustinatt" "augustinätter" ; -- augustinatt..nn.1
  augustipäron_1_N = mkN "augustipäron" neutrum  ; -- augustipäron..nn.1
  augustisol_1_N = mkN "augustisol" ; -- augustisol..nn.1
  augustnominerad_1_A = mkA "augustnominerad" ; -- augustnominerad..av.1
  auktion_1_N = mkN "auktion" ; -- auktion..nn.1
  auktionera_1_V = mkV "auktionerar" ; -- auktionera..vb.1
  auktionerande_1_N = mkN "auktionerande" ; -- auktionerande..nn.1
  auktionerare_1_N = mkN "auktionerare" utrum  ; -- auktionerare..nn.1
  auktionerbar_1_A = mkA "auktionerbar" ; -- auktionerbar..av.1
  auktionerbarhet_1_N = mkN "auktionerbarhet" ; -- auktionerbarhet..nn.1
  auktionering_1_N = mkN "auktionering" ; -- auktionering..nn.1
  auktionist_1_N = mkN "auktionist" "auktionister" ; -- auktionist..nn.1
  auktionsbridge_1_N = mkN "auktionsbridge" utrum  ; -- auktionsbridge..nn.1
  auktionsdag_1_N = mkN "auktionsdag" ; -- auktionsdag..nn.1
  auktionsförrättare_1_N = mkN "auktionsförrättare" utrum  ; -- auktionsförrättare..nn.1
  auktionsinrop_1_N = mkN "auktionsinrop" neutrum  ; -- auktionsinrop..nn.1
  auktionskammare_1_N = mkN "auktionskammare" "auktionskammaren" "auktionskammare" "auktionskamrarna" ; -- auktionskammare..nn.1
  auktionsklubba_1_N = mkN "auktionsklubba" ; -- auktionsklubba..nn.1
  auktionsprotokoll_1_N = mkN "auktionsprotokoll" neutrum  ; -- auktionsprotokoll..nn.1
  auktionsutropare_1_N = mkN "auktionsutropare" utrum  ; -- auktionsutropare..nn.1
  auktionsverk_1_N = mkN "auktionsverk" neutrum  ; -- auktionsverk..nn.1
  auktor_1_N = mkN "auktor" "auktorer" ; -- auktor..nn.1
  auktorisation_1_N = mkN "auktorisation" ; -- auktorisation..nn.1
  auktorisera_1_V = mkV "auktoriserar" ; -- auktorisera..vb.1
  auktoriserande_1_N = mkN "auktoriserande" ; -- auktoriserande..nn.1
  auktoriserbar_1_A = mkA "auktoriserbar" ; -- auktoriserbar..av.1
  auktoriserbarhet_1_N = mkN "auktoriserbarhet" ; -- auktoriserbarhet..nn.1
  auktorisering_1_N = mkN "auktorisering" ; -- auktorisering..nn.1
  auktoritativ_1_A = mkA "auktoritativ" ; -- auktoritativ..av.1
  auktoritet_1_N = mkN "auktoritet" "auktoriteter" ; -- auktoritet..nn.1
  auktoritetsbunden_1_A = mkA "auktoritetsbunden" ; -- auktoritetsbunden..av.1
  auktoritetsbundenhet_1_N = mkN "auktoritetsbundenhet" ; -- auktoritetsbundenhet..nn.1
  auktoritetstro_1_N = mkN "auktoritetstro" ; -- auktoritetstro..nn.1
  auktoritär_1_A = mkA "auktoritär" ; -- auktoritär..av.1
  auktorrätt_1_N = mkN "auktorrätt" ; -- auktorrätt..nn.1
  auktorskap_1_N = mkN "auktorskap" neutrum  ; -- auktorskap..nn.1
  auktorsrätt_1_N = mkN "auktorsrätt" ; -- auktorsrätt..nn.1
  aula_1_N = mkN "aula" ; -- aula..nn.1
  aura_1_N = mkN "aura" ; -- aura..nn.1
  auramigrän_1_N = mkN "auramigrän" "auramigräner" ; -- auramigrän..nn.1
  auskultant_1_N = mkN "auskultant" "auskultanter" ; -- auskultant..nn.1
  auskultation_1_N = mkN "auskultation" ; -- auskultation..nn.1
  auskultera_1_V = mkV "auskulterar" ; -- auskultera..vb.1
  auskulterande_1_N = mkN "auskulterande" ; -- auskulterande..nn.1
  auskulterbar_1_A = mkA "auskulterbar" ; -- auskulterbar..av.1
  auskulterbarhet_1_N = mkN "auskulterbarhet" ; -- auskulterbarhet..nn.1
  auskultering_1_N = mkN "auskultering" ; -- auskultering..nn.1
  australiensare_1_N = mkN "australiensare" utrum  ; -- australiensare..nn.1
  australiensisk_1_A = mkA "australiensisk" ; -- australiensisk..av.1
  australier_1_N = mkN "australier" "australiern" "australier" "australierna" ; -- australier..nn.1
  australisk_1_A = mkA "australisk" ; -- australisk..av.1
  australiska_1_N = mkN "australiska" ; -- australiska..nn.1
  autarki_1_N = mkN "autarki" "autarkier" ; -- autarki..nn.1
  autencitet_1_N = mkN "autencitet" "autenciteter" ; -- autencitet..nn.1
  autenticera_1_V = mkV "autenticerar" ; -- autenticera..vb.1
  autenticerande_1_N = mkN "autenticerande" ; -- autenticerande..nn.1
  autenticerbar_1_A = mkA "autenticerbar" ; -- autenticerbar..av.1
  autenticerbarhet_1_N = mkN "autenticerbarhet" ; -- autenticerbarhet..nn.1
  autenticering_1_N = mkN "autenticering" ; -- autenticering..nn.1
  autenticitet_1_N = mkN "autenticitet" "autenticiteter" ; -- autenticitet..nn.1
  autentifiera_1_V = mkV "autentifierar" ; -- autentifiera..vb.1
  autentifierande_1_N = mkN "autentifierande" ; -- autentifierande..nn.1
  autentifierbar_1_A = mkA "autentifierbar" ; -- autentifierbar..av.1
  autentifierbarhet_1_N = mkN "autentifierbarhet" ; -- autentifierbarhet..nn.1
  autentifiering_1_N = mkN "autentifiering" ; -- autentifiering..nn.1
  autentisera_1_V = mkV "autentiserar" ; -- autentisera..vb.1
  autentiserande_1_N = mkN "autentiserande" ; -- autentiserande..nn.1
  autentiserbar_1_A = mkA "autentiserbar" ; -- autentiserbar..av.1
  autentiserbarhet_1_N = mkN "autentiserbarhet" ; -- autentiserbarhet..nn.1
  autentisering_1_N = mkN "autentisering" ; -- autentisering..nn.1
  autentisk_1_A = mkA "autentisk" ; -- autentisk..av.1
  auteur_1_N = mkN "auteur" "auteurer" ; -- auteur..nn.1
  autism_1_N = mkN "autism" "autismer" ; -- autism..nn.1
  autist_1_N = mkN "autist" "autister" ; -- autist..nn.1
  autistisk_1_A = mkA "autistisk" ; -- autistisk..av.1
  auto_PEEP_1_N = mkN "auto-PEEP" ; -- auto-PEEP..nn.1
  autodafé_1_N = mkN "autodafé" "autodaféer" ; -- autodafé..nn.1
  autodidakt_1_N = mkN "autodidakt" "autodidakter" ; -- autodidakt..nn.1
  autodigestion_1_N = mkN "autodigestion" ; -- autodigestion..nn.1
  autodrom_1_N = mkN "autodrom" "autodromer" ; -- autodrom..nn.1
  autograf_1_N = mkN "autograf" "autografer" ; -- autograf..nn.1
  autografjägare_1_N = mkN "autografjägare" utrum  ; -- autografjägare..nn.1
  autografsamling_1_N = mkN "autografsamling" ; -- autografsamling..nn.1
  autoimmun_1_A = mkA "autoimmun" ; -- autoimmun..av.1
  autoklav_1_N = mkN "autoklav" "autoklaver" ; -- autoklav..nn.1
  autokrat_1_N = mkN "autokrat" "autokrater" ; -- autokrat..nn.1
  autokrati_1_N = mkN "autokrati" "autokratier" ; -- autokrati..nn.1
  autokratisk_1_A = mkA "autokratisk" ; -- autokratisk..av.1
  autokton_1_A = mkA "autokton" ; -- autokton..av.1
  autolys_1_N = mkN "autolys" "autolyser" ; -- autolys..nn.1
  automagisk_1_A = mkA "automagisk" ; -- automagisk..av.1
  automat_1_N = mkN "automat" "automater" ; -- automat..nn.1
  automatateori_1_N = mkN "automatateori" ; -- automatateori..nn.1
  automateld_1_N = mkN "automateld" ; -- automateld..nn.1
  automatgevär_1_N = mkN "automatgevär" neutrum  ; -- automatgevär..nn.1
  automatik_1_N = mkN "automatik" ; -- automatik..nn.1
  automation_1_N = mkN "automation" ; -- automation..nn.1
  automatisera_1_V = mkV "automatiserar" ; -- automatisera..vb.1
  automatiserande_1_N = mkN "automatiserande" ; -- automatiserande..nn.1
  automatiserbar_1_A = mkA "automatiserbar" ; -- automatiserbar..av.1
  automatiserbarhet_1_N = mkN "automatiserbarhet" ; -- automatiserbarhet..nn.1
  automatisering_1_N = mkN "automatisering" ; -- automatisering..nn.1
  automatisk_1_A = mkA "automatisk" ; -- automatisk..av.1
  automatkarbin_1_N = mkN "automatkarbin" "automatkarbiner" ; -- automatkarbin..nn.1
  automatsäkring_1_N = mkN "automatsäkring" ; -- automatsäkring..nn.1
  automatteori_1_N = mkN "automatteori" ; -- automatteori..nn.1
  automatuttag_1_N = mkN "automatuttag" neutrum  ; -- automatuttag..nn.1
  automatvapen_1_N = mkN "automatvapen" "automatvapnet" "automatvapen" "automatvapnen" ; -- automatvapen..nn.1
  automobil_1_N = mkN "automobil" "automobiler" ; -- automobil..nn.1
  autonom_1_A = mkA "autonom" ; -- autonom..av.1
  autonomi_1_N = mkN "autonomi" ; -- autonomi..nn.1
  autopilot_1_N = mkN "autopilot" "autopiloter" ; -- autopilot..nn.1
  autopsi_1_N = mkN "autopsi" "autopsier" ; -- autopsi..nn.1
  autostrada_1_N = mkN "autostrada" ; -- autostrada..nn.1
  autotypi_1_N = mkN "autotypi" "autotypier" ; -- autotypi..nn.1
  av_1_A = mkA "av" ; -- av..av.1
  ava_1_N = mkN "ava" ; -- ava..nn.1
  ava_1_V = mkV "avar" ; -- ava..vb.1
  avaktivera_1_V = mkV "avaktiverar" ; -- avaktivera..vb.1
  avaktiverande_1_N = mkN "avaktiverande" ; -- avaktiverande..nn.1
  avaktiverbar_1_A = mkA "avaktiverbar" ; -- avaktiverbar..av.1
  avaktiverbarhet_1_N = mkN "avaktiverbarhet" ; -- avaktiverbarhet..nn.1
  avaktivering_1_N = mkN "avaktivering" ; -- avaktivering..nn.1
  avancemang_1_N = mkN "avancemang" neutrum  ; -- avancemang..nn.1
  avancera_1_V = mkV "avancerar" ; -- avancera..vb.1
  avancerad_1_A = mkA "avancerad" ; -- avancerad..av.1
  avancerande_1_N = mkN "avancerande" ; -- avancerande..nn.1
  avancerbar_1_A = mkA "avancerbar" ; -- avancerbar..av.1
  avancerbarhet_1_N = mkN "avancerbarhet" ; -- avancerbarhet..nn.1
  avancering_1_N = mkN "avancering" ; -- avancering..nn.1
  avande_1_N = mkN "avande" ; -- avande..nn.1
  avannons_1_N = mkN "avannons" "avannonser" ; -- avannons..nn.1
  avannonsera_1_V = mkV "avannonserar" ; -- avannonsera..vb.1
  avannonserande_1_N = mkN "avannonserande" ; -- avannonserande..nn.1
  avannonserbar_1_A = mkA "avannonserbar" ; -- avannonserbar..av.1
  avannonserbarhet_1_N = mkN "avannonserbarhet" ; -- avannonserbarhet..nn.1
  avannonsering_1_N = mkN "avannonsering" ; -- avannonsering..nn.1
  avans_1_N = mkN "avans" "avanser" ; -- avans..nn.1
  avantgarde_1_N = mkN "avantgarde" ; -- avantgarde..nn.1
  avantgardism_1_N = mkN "avantgardism" "avantgardismer" ; -- avantgardism..nn.1
  avantgardist_1_N = mkN "avantgardist" "avantgardister" ; -- avantgardist..nn.1
  avantgardistisk_1_A = mkA "avantgardistisk" ; -- avantgardistisk..av.1
  avantloge_1_N = mkN "avantloge" "avantloger" ; -- avantloge..nn.1
  avantscen_1_N = mkN "avantscen" "avantscener" ; -- avantscen..nn.1
  avart_1_N = mkN "avart" "avarter" ; -- avart..nn.1
  avatar_1_N = mkN "avatar" "avatarer" ; -- avatar..nn.1
  avbalka_1_V = mkV "avbalkar" ; -- avbalka..vb.1
  avbalkande_1_N = mkN "avbalkande" ; -- avbalkande..nn.1
  avbalkning_1_N = mkN "avbalkning" ; -- avbalkning..nn.1
  avbarka_1_V = mkV "avbarkar" ; -- avbarka..vb.1
  avbarkning_1_N = mkN "avbarkning" ; -- avbarkning..nn.1
  avbasning_1_N = mkN "avbasning" ; -- avbasning..nn.1
  avbeställa_1_V = mkV "avbeställer" ; -- avbeställa..vb.1
  avbeställande_1_N = mkN "avbeställande" ; -- avbeställande..nn.1
  avbeställning_1_N = mkN "avbeställning" ; -- avbeställning..nn.1
  avbeta_1_V = mkV "avbetar" ; -- avbeta..vb.1
  avbetala_1_V = mkV "avbetalar" ; -- avbetala..vb.1
  avbetalande_1_N = mkN "avbetalande" ; -- avbetalande..nn.1
  avbetalning_1_N = mkN "avbetalning" ; -- avbetalning..nn.1
  avbetalningsaffär_1_N = mkN "avbetalningsaffär" "avbetalningsaffärer" ; -- avbetalningsaffär..nn.1
  avbetalningsarrangemang_1_N = mkN "avbetalningsarrangemang" neutrum  ; -- avbetalningsarrangemang..nn.1
  avbetalningsköp_1_N = mkN "avbetalningsköp" neutrum  ; -- avbetalningsköp..nn.1
  avbetalningslån_1_N = mkN "avbetalningslån" neutrum  ; -- avbetalningslån..nn.1
  avbetalningsplan_1_N = mkN "avbetalningsplan" "avbetalningsplaner" ; -- avbetalningsplan..nn.1
  avbetalningsvillkor_1_N = mkN "avbetalningsvillkor" neutrum  ; -- avbetalningsvillkor..nn.1
  avbetande_1_N = mkN "avbetande" ; -- avbetande..nn.1
  avbetingning_1_N = mkN "avbetingning" ; -- avbetingning..nn.1
  avbetning_1_N = mkN "avbetning" ; -- avbetning..nn.1
  avbetsling_1_N = mkN "avbetsling" ; -- avbetsling..nn.1
  avbild_1_N = mkN "avbild" "avbilder" ; -- avbild..nn.1
  avbilda_1_V = mkV "avbildar" ; -- avbilda..vb.1
  avbildande_1_N = mkN "avbildande" ; -- avbildande..nn.1
  avbildning_1_N = mkN "avbildning" ; -- avbildning..nn.1
  avbildningsfel_1_N = mkN "avbildningsfel" "avbildningsfelet" "avbildningsfel" "avbildningsfelen" ; -- avbildningsfel..nn.1
  avbinda_1_V = mkV "avbinda" "avband" "avbundit" ; -- avbinda..vb.1
  avbindande_1_N = mkN "avbindande" ; -- avbindande..nn.1
  avbindning_1_N = mkN "avbindning" ; -- avbindning..nn.1
  avbitare_1_N = mkN "avbitare" utrum  ; -- avbitare..nn.1
  avbitartång_1_N = mkN "avbitartång" "avbitartänger" ; -- avbitartång..nn.1
  avbiten_1_A = mkA "avbiten" ; -- avbiten..av.1
  avbitning_1_N = mkN "avbitning" ; -- avbitning..nn.1
  avbländning_1_N = mkN "avbländning" ; -- avbländning..nn.1
  avblåsa_1_V = mkV "avblåser" ; -- avblåsa..vb.1
  avblåsande_1_N = mkN "avblåsande" ; -- avblåsande..nn.1
  avblåsning_1_N = mkN "avblåsning" ; -- avblåsning..nn.1
  avboka_1_V = mkV "avbokar" ; -- avboka..vb.1
  avbokande_1_N = mkN "avbokande" ; -- avbokande..nn.1
  avbokning_1_N = mkN "avbokning" ; -- avbokning..nn.1
  avborstning_1_N = mkN "avborstning" ; -- avborstning..nn.1
  avbrott_1_N = mkN "avbrott" neutrum  ; -- avbrott..nn.1
  avbruten_1_A = mkA "avbruten" ; -- avbruten..av.1
  avbryta_1_V = mkV "avbryta" "avbröt" "avbrutit" ; -- avbryta..vb.1
  avbrytande_1_N = mkN "avbrytande" ; -- avbrytande..nn.1
  avbrytare_1_N = mkN "avbrytare" utrum  ; -- avbrytare..nn.1
  avbrytning_1_N = mkN "avbrytning" ; -- avbrytning..nn.1
  avbräck_1_N = mkN "avbräck" neutrum  ; -- avbräck..nn.1
  avbränning_1_N = mkN "avbränning" ; -- avbränning..nn.1
  avbröstning_1_N = mkN "avbröstning" ; -- avbröstning..nn.1
  avbytarbänk_1_N = mkN "avbytarbänk" ; -- avbytarbänk..nn.1
  avbytare_1_N = mkN "avbytare" utrum  ; -- avbytare..nn.1
  avbäring_1_N = mkN "avbäring" ; -- avbäring..nn.1
  avbärning_1_N = mkN "avbärning" ; -- avbärning..nn.1
  avböja_1_V = mkV "avböja" "avböjde" "avböjt" ; -- avböja..vb.1
  avböja_2_V = mkV "avböja" "avböjde" "avböjt" ; -- avböja..vb.2
  avböjande_1_N = mkN "avböjande" ; -- avböjande..nn.1
  avböjning_1_N = mkN "avböjning" ; -- avböjning..nn.1
  avbön_1_N = mkN "avbön" "avböner" ; -- avbön..nn.1
  avbörda_1_V = mkV "avbördar" ; -- avbörda..vb.1
  avbördande_1_N = mkN "avbördande" ; -- avbördande..nn.1
  avdagata_1_V = mkV "avdagataga" "avdagatog" "avdagatagit" ; -- avdagata..vb.1
  avdagatagande_1_N = mkN "avdagatagande" ; -- avdagatagande..nn.1
  avdamning_1_N = mkN "avdamning" ; -- avdamning..nn.1
  avdankad_1_A = mkA "avdankad" ; -- avdankad..av.1
  avdela_1_V = mkV "avdelar" ; -- avdela..vb.1
  avdelande_1_N = mkN "avdelande" ; -- avdelande..nn.1
  avdelning_1_N = mkN "avdelning" ; -- avdelning..nn.1
  avdelningschef_1_N = mkN "avdelningschef" "avdelningschefer" ; -- avdelningschef..nn.1
  avdelningsdirektör_1_N = mkN "avdelningsdirektör" "avdelningsdirektörer" ; -- avdelningsdirektör..nn.1
  avdelningskontor_1_N = mkN "avdelningskontor" neutrum  ; -- avdelningskontor..nn.1
  avdelningsläkare_1_N = mkN "avdelningsläkare" utrum  ; -- avdelningsläkare..nn.1
  avdelningssköterska_1_N = mkN "avdelningssköterska" ; -- avdelningssköterska..nn.1
  avdelningsvis_1_Adv = mkAdv "avdelningsvis" ; -- avdelningsvis..ab.1
  avdikning_1_N = mkN "avdikning" ; -- avdikning..nn.1
  avdiskning_1_N = mkN "avdiskning" ; -- avdiskning..nn.1
  avdomning_1_N = mkN "avdomning" ; -- avdomning..nn.1
  avdrag_1_N = mkN "avdrag" neutrum  ; -- avdrag..nn.1
  avdragsgill_1_A = mkA "avdragsgill" ; -- avdragsgill..av.1
  avdragsglad_1_A = mkA "avdragsglad" "avdragsglatt" ; -- avdragsglad..av.1
  avdragsmöjlighet_1_N = mkN "avdragsmöjlighet" "avdragsmöjligheter" ; -- avdragsmöjlighet..nn.1
  avdragsrätt_1_N = mkN "avdragsrätt" ; -- avdragsrätt..nn.1
  avdramatisera_1_V = mkV "avdramatiserar" ; -- avdramatisera..vb.1
  avdramatiserande_1_N = mkN "avdramatiserande" ; -- avdramatiserande..nn.1
  avdramatiserbar_1_A = mkA "avdramatiserbar" ; -- avdramatiserbar..av.1
  avdramatiserbarhet_1_N = mkN "avdramatiserbarhet" ; -- avdramatiserbarhet..nn.1
  avdramatisering_1_N = mkN "avdramatisering" ; -- avdramatisering..nn.1
  avdrift_1_N = mkN "avdrift" ; -- avdrift..nn.1
  avdriva_1_V = mkV "avdriva" "avdrev" "avdrivit" ; -- avdriva..vb.1
  avdrivande_1_N = mkN "avdrivande" ; -- avdrivande..nn.1
  avdukning_1_N = mkN "avdukning" ; -- avdukning..nn.1
  avdunsta_1_V = mkV "avdunstar" ; -- avdunsta..vb.1
  avdunstande_1_N = mkN "avdunstande" ; -- avdunstande..nn.1
  avdunstning_1_N = mkN "avdunstning" ; -- avdunstning..nn.1
  avdämma_1_V = mkV "avdämmer" ; -- avdämma..vb.1
  avdämmande_1_N = mkN "avdämmande" ; -- avdämmande..nn.1
  avdämning_1_N = mkN "avdämning" ; -- avdämning..nn.1
  avdöd_1_A = mkA "avdöd" "avdött" ; -- avdöd..av.1
  avdöma_1_V = mkV "avdömer" ; -- avdöma..vb.1
  avdömande_1_N = mkN "avdömande" ; -- avdömande..nn.1
  ave_1_N = mkN "ave" ; -- ave..nn.1
  avec_1_N = mkN "avec" "avecer" ; -- avec..nn.1
  avel_1_N = mkN "avel" ; -- avel..nn.1
  avelsdjur_1_N = mkN "avelsdjur" neutrum  ; -- avelsdjur..nn.1
  avelsduglig_1_A = mkA "avelsduglig" ; -- avelsduglig..av.1
  avelshingst_1_N = mkN "avelshingst" ; -- avelshingst..nn.1
  avelssto_1_N = mkN "avelssto" "avelsstot" "avelsston" "avelsstona" ; -- avelssto..nn.1
  avenbok_1_N = mkN "avenbok" ; -- avenbok..nn.1
  aveny_1_N = mkN "aveny" "avenyer" ; -- aveny..nn.1
  avers_1_N = mkN "avers" "averser" ; -- avers..nn.1
  aversion_1_N = mkN "aversion" ; -- aversion..nn.1
  aversionsterapi_1_N = mkN "aversionsterapi" ; -- aversionsterapi..nn.1
  avfall_1_N = mkN "avfall" neutrum  ; -- avfall..nn.1
  avfalla_1_V = mkV "avfalla" "avföll" "avfallit" ; -- avfalla..vb.1
  avfallande_1_N = mkN "avfallande" ; -- avfallande..nn.1
  avfallen_1_A = mkA "avfallen" ; -- avfallen..av.1
  avfallsbrunn_1_N = mkN "avfallsbrunn" ; -- avfallsbrunn..nn.1
  avfallsdike_1_N = mkN "avfallsdike" ; -- avfallsdike..nn.1
  avfallsfoder_1_N = mkN "avfallsfoder" neutrum  ; -- avfallsfoder..nn.1
  avfallshantering_1_N = mkN "avfallshantering" ; -- avfallshantering..nn.1
  avfallskvarn_1_N = mkN "avfallskvarn" ; -- avfallskvarn..nn.1
  avfallsråvara_1_N = mkN "avfallsråvara" ; -- avfallsråvara..nn.1
  avfallsupplag_1_N = mkN "avfallsupplag" neutrum  ; -- avfallsupplag..nn.1
  avfallsvatten_1_N = mkN "avfallsvatten" "avfallsvattnet" "avfallsvatten" "avfallsvattnen" ; -- avfallsvatten..nn.1
  avfallsvirke_1_N = mkN "avfallsvirke" ; -- avfallsvirke..nn.1
  avfalsning_1_N = mkN "avfalsning" ; -- avfalsning..nn.1
  avfart_1_N = mkN "avfart" "avfarter" ; -- avfart..nn.1
  avfasning_1_N = mkN "avfasning" ; -- avfasning..nn.1
  avfatta_1_V = mkV "avfattar" ; -- avfatta..vb.1
  avfattande_1_N = mkN "avfattande" ; -- avfattande..nn.1
  avfattning_1_N = mkN "avfattning" ; -- avfattning..nn.1
  avfejning_1_N = mkN "avfejning" ; -- avfejning..nn.1
  avfetta_1_V = mkV "avfettar" ; -- avfetta..vb.1
  avfettande_1_N = mkN "avfettande" ; -- avfettande..nn.1
  avfettning_1_N = mkN "avfettning" ; -- avfettning..nn.1
  avfettningsmedel_1_N = mkN "avfettningsmedel" neutrum  ; -- avfettningsmedel..nn.1
  avfilning_1_N = mkN "avfilning" ; -- avfilning..nn.1
  avfiltrering_1_N = mkN "avfiltrering" ; -- avfiltrering..nn.1
  avfjällning_1_N = mkN "avfjällning" ; -- avfjällning..nn.1
  avflagnad_1_A = mkA "avflagnad" ; -- avflagnad..av.1
  avflytta_1_V = mkV "avflyttar" ; -- avflytta..vb.1
  avflyttande_1_N = mkN "avflyttande" ; -- avflyttande..nn.1
  avflyttning_1_N = mkN "avflyttning" ; -- avflyttning..nn.1
  avflyttningsförbud_1_N = mkN "avflyttningsförbud" neutrum  ; -- avflyttningsförbud..nn.1
  avflöde_1_N = mkN "avflöde" ; -- avflöde..nn.1
  avfolka_1_V = mkV "avfolkar" ; -- avfolka..vb.1
  avfolkande_1_N = mkN "avfolkande" ; -- avfolkande..nn.1
  avfolkning_1_N = mkN "avfolkning" ; -- avfolkning..nn.1
  avfolkningsområde_1_N = mkN "avfolkningsområde" ; -- avfolkningsområde..nn.1
  avfordra_1_V = mkV "avfordrar" ; -- avfordra..vb.1
  avfordrande_1_N = mkN "avfordrande" ; -- avfordrande..nn.1
  avforsling_1_N = mkN "avforsling" ; -- avforsling..nn.1
  avfrosta_1_V = mkV "avfrostar" ; -- avfrosta..vb.1
  avfrostande_1_N = mkN "avfrostande" ; -- avfrostande..nn.1
  avfrostning_1_N = mkN "avfrostning" ; -- avfrostning..nn.1
  avfukta_1_V = mkV "avfuktar" ; -- avfukta..vb.1
  avfuktande_1_N = mkN "avfuktande" ; -- avfuktande..nn.1
  avfuktare_1_N = mkN "avfuktare" utrum  ; -- avfuktare..nn.1
  avfyra_1_V = mkV "avfyrar" ; -- avfyra..vb.1
  avfyrande_1_N = mkN "avfyrande" ; -- avfyrande..nn.1
  avfyrning_1_N = mkN "avfyrning" ; -- avfyrning..nn.1
  avfyrningskod_1_N = mkN "avfyrningskod" "avfyrningskoder" ; -- avfyrningskod..nn.1
  avfyrningsprocedur_1_N = mkN "avfyrningsprocedur" "avfyrningsprocedurer" ; -- avfyrningsprocedur..nn.1
  avfällig_1_A = mkA "avfällig" ; -- avfällig..av.1
  avfällighet_1_N = mkN "avfällighet" ; -- avfällighet..nn.1
  avfälling_1_N = mkN "avfälling" ; -- avfälling..nn.1
  avfärd_1_N = mkN "avfärd" "avfärder" ; -- avfärd..nn.1
  avfärda_1_V = mkV "avfärdar" ; -- avfärda..vb.1
  avfärdande_1_N = mkN "avfärdande" ; -- avfärdande..nn.1
  avfärgning_1_N = mkN "avfärgning" ; -- avfärgning..nn.1
  avföda_1_N = mkN "avföda" ; -- avföda..nn.1
  avföra_1_V = mkV "avföra" "avförde" "avfört" ; -- avföra..vb.1
  avförande_1_N = mkN "avförande" ; -- avförande..nn.1
  avföring_1_N = mkN "avföring" ; -- avföring..nn.1
  avföringsinkontinens_1_N = mkN "avföringsinkontinens" ; -- avföringsinkontinens..nn.1
  avföringsmedel_1_N = mkN "avföringsmedel" neutrum  ; -- avföringsmedel..nn.1
  avföringstransplantat_1_N = mkN "avföringstransplantat" neutrum  ; -- avföringstransplantat..nn.1
  avföringstransplantation_1_N = mkN "avföringstransplantation" ; -- avföringstransplantation..nn.1
  avgasförgiftning_1_N = mkN "avgasförgiftning" ; -- avgasförgiftning..nn.1
  avgasrening_1_N = mkN "avgasrening" ; -- avgasrening..nn.1
  avgasrör_1_N = mkN "avgasrör" neutrum  ; -- avgasrör..nn.1
  avge_1_V = mkV "avgiva" "avgav" "avgivit" ; -- avge..vb.1
  avgift_1_N = mkN "avgift" "avgifter" ; -- avgift..nn.1
  avgifta_1_V = mkV "avgiftar" ; -- avgifta..vb.1
  avgiftande_1_N = mkN "avgiftande" ; -- avgiftande..nn.1
  avgiftning_1_N = mkN "avgiftning" ; -- avgiftning..nn.1
  avgiftningsklinik_1_N = mkN "avgiftningsklinik" "avgiftningskliniker" ; -- avgiftningsklinik..nn.1
  avgiftsbelägga_1_V = mkV "avgiftsbelägga" "avgiftsbela" "avgiftsbelagt" ; -- avgiftsbelägga..vb.1
  avgiftsbeläggande_1_N = mkN "avgiftsbeläggande" ; -- avgiftsbeläggande..nn.1
  avgiftsfri_1_A = mkA "avgiftsfri" "avgiftsfritt" ; -- avgiftsfri..av.1
  avgiftsfrihet_1_N = mkN "avgiftsfrihet" ; -- avgiftsfrihet..nn.1
  avgivande_1_N = mkN "avgivande" ; -- avgivande..nn.1
  avgjord_1_A = mkA "avgjord" "avgjort" ; -- avgjord..av.1
  avgjutning_1_N = mkN "avgjutning" ; -- avgjutning..nn.1
  avglans_1_N = mkN "avglans" ; -- avglans..nn.1
  avgnagning_1_N = mkN "avgnagning" ; -- avgnagning..nn.1
  avgnuggning_1_N = mkN "avgnuggning" ; -- avgnuggning..nn.1
  avgrena_1_V = mkV "avgrenar" ; -- avgrena..vb.1
  avgrenande_1_N = mkN "avgrenande" ; -- avgrenande..nn.1
  avgrening_1_N = mkN "avgrening" ; -- avgrening..nn.1
  avgrund_1_N = mkN "avgrund" "avgrunder" ; -- avgrund..nn.1
  avgrundsande_1_N = mkN "avgrundsande" utrum  ; -- avgrundsande..nn.1
  avgrundsdjup_1_A = mkA "avgrundsdjup" ; -- avgrundsdjup..av.1
  avgrundsdjup_1_N = mkN "avgrundsdjup" neutrum  ; -- avgrundsdjup..nn.1
  avgrundseld_1_N = mkN "avgrundseld" ; -- avgrundseld..nn.1
  avgrundslik_1_A = mkA "avgrundslik" ; -- avgrundslik..av.1
  avgrundsrand_1_N = mkN "avgrundsrand" ; -- avgrundsrand..nn.1
  avgrundsskara_1_N = mkN "avgrundsskara" ; -- avgrundsskara..nn.1
  avgränsa_1_V = mkV "avgränsar" ; -- avgränsa..vb.1
  avgränsande_1_N = mkN "avgränsande" ; -- avgränsande..nn.1
  avgränsning_1_N = mkN "avgränsning" ; -- avgränsning..nn.1
  avgud_1_N = mkN "avgud" ; -- avgud..nn.1
  avguda_1_V = mkV "avgudar" ; -- avguda..vb.1
  avgudabild_1_N = mkN "avgudabild" "avgudabilder" ; -- avgudabild..nn.1
  avgudadyrkare_1_N = mkN "avgudadyrkare" utrum  ; -- avgudadyrkare..nn.1
  avgudande_1_N = mkN "avgudande" ; -- avgudande..nn.1
  avguderi_1_N = mkN "avguderi" neutrum  ; -- avguderi..nn.1
  avgäld_1_N = mkN "avgäld" "avgälder" ; -- avgäld..nn.1
  avgärda_1_V = mkV "avgärdar" ; -- avgärda..vb.1
  avgärdande_1_N = mkN "avgärdande" ; -- avgärdande..nn.1
  avgärdning_1_N = mkN "avgärdning" ; -- avgärdning..nn.1
  avgå_1_V = mkV "avgå" "avgår" "avgå" "avgick" "avgått" "avgången" ; -- avgå..vb.1
  avgående_1_N = mkN "avgående" ; -- avgående..nn.1
  avgång_1_N = mkN "avgång" ; -- avgång..nn.1
  avgångsbetyg_1_N = mkN "avgångsbetyg" neutrum  ; -- avgångsbetyg..nn.1
  avgångsbidrag_1_N = mkN "avgångsbidrag" neutrum  ; -- avgångsbidrag..nn.1
  avgångsersättning_1_N = mkN "avgångsersättning" ; -- avgångsersättning..nn.1
  avgångshall_1_N = mkN "avgångshall" ; -- avgångshall..nn.1
  avgångsklass_1_N = mkN "avgångsklass" "avgångsklasser" ; -- avgångsklass..nn.1
  avgångskrav_1_N = mkN "avgångskrav" neutrum  ; -- avgångskrav..nn.1
  avgångssignal_1_N = mkN "avgångssignal" "avgångssignaler" ; -- avgångssignal..nn.1
  avgångstid_1_N = mkN "avgångstid" "avgångstider" ; -- avgångstid..nn.1
  avgångsvederlag_1_N = mkN "avgångsvederlag" neutrum  ; -- avgångsvederlag..nn.1
  avgöra_1_V = mkV "avgöra" "avgjorde" "avgjort" ; -- avgöra..vb.1
  avgörande_1_A = mkA "avgörande" ; -- avgörande..av.1
  avgörande_1_N = mkN "avgörande" ; -- avgörande..nn.1
  avhackning_1_N = mkN "avhackning" ; -- avhackning..nn.1
  avhakning_1_N = mkN "avhakning" ; -- avhakning..nn.1
  avhandla_1_V = mkV "avhandlar" ; -- avhandla..vb.1
  avhandlande_1_N = mkN "avhandlande" ; -- avhandlande..nn.1
  avhandling_1_N = mkN "avhandling" ; -- avhandling..nn.1
  avhaspling_1_N = mkN "avhaspling" ; -- avhaspling..nn.1
  avhjälpa_1_V = mkV "avhjälper" ; -- avhjälpa..vb.1
  avhjälpande_1_N = mkN "avhjälpande" ; -- avhjälpande..nn.1
  avhopp_1_N = mkN "avhopp" neutrum  ; -- avhopp..nn.1
  avhoppad_1_A = mkA "avhoppad" ; -- avhoppad..av.1
  avhoppare_1_N = mkN "avhoppare" utrum  ; -- avhoppare..nn.1
  avhorna_1_V = mkV "avhornar" ; -- avhorna..vb.1
  avhornande_1_N = mkN "avhornande" ; -- avhornande..nn.1
  avhorning_1_N = mkN "avhorning" ; -- avhorning..nn.1
  avhuggning_1_N = mkN "avhuggning" ; -- avhuggning..nn.1
  avhumanisera_1_V = mkV "avhumaniserar" ; -- avhumanisera..vb.1
  avhumaniserande_1_N = mkN "avhumaniserande" ; -- avhumaniserande..nn.1
  avhumanisering_1_N = mkN "avhumanisering" ; -- avhumanisering..nn.1
  avhysa_1_V = mkV "avhyser" ; -- avhysa..vb.1
  avhysande_1_N = mkN "avhysande" ; -- avhysande..nn.1
  avhysning_1_N = mkN "avhysning" ; -- avhysning..nn.1
  avhyvling_1_N = mkN "avhyvling" ; -- avhyvling..nn.1
  avhäktning_1_N = mkN "avhäktning" ; -- avhäktning..nn.1
  avhällning_1_N = mkN "avhällning" ; -- avhällning..nn.1
  avhällningsöppning_1_N = mkN "avhällningsöppning" ; -- avhällningsöppning..nn.1
  avhämta_1_V = mkV "avhämtar" ; -- avhämta..vb.1
  avhämtande_1_N = mkN "avhämtande" ; -- avhämtande..nn.1
  avhämtning_1_N = mkN "avhämtning" ; -- avhämtning..nn.1
  avhända_1_V = mkV "avhänder" ; -- avhända..vb.1
  avhändande_1_N = mkN "avhändande" ; -- avhändande..nn.1
  avhändbar_1_A = mkA "avhändbar" ; -- avhändbar..av.1
  avhändbarhet_1_N = mkN "avhändbarhet" ; -- avhändbarhet..nn.1
  avhänga_1_V = mkV "avhänger" ; -- avhänga..vb.1
  avhängande_1_N = mkN "avhängande" ; -- avhängande..nn.1
  avhängd_1_A = mkA "avhängd" "avhängt" ; -- avhängd..av.1
  avhängig_1_A = mkA "avhängig" ; -- avhängig..av.1
  avhängighet_1_N = mkN "avhängighet" ; -- avhängighet..nn.1
  avhärda_1_V = mkV "avhärdar" ; -- avhärda..vb.1
  avhärdande_1_N = mkN "avhärdande" ; -- avhärdande..nn.1
  avhästning_1_N = mkN "avhästning" ; -- avhästning..nn.1
  avhåll_1_N = mkN "avhåll" neutrum  ; -- avhåll..nn.1
  avhålla_1_V = mkV "avhålla" "avhöll" "avhållit" ; -- avhålla..vb.1
  avhållande_1_N = mkN "avhållande" ; -- avhållande..nn.1
  avhållen_1_A = mkA "avhållen" ; -- avhållen..av.1
  avhållsam_1_A = mkA "avhållsam" "avhållsamt" "avhållsamma" "avhållsamma" "avhållsammare" "avhållsammast" "avhållsammaste" ; -- avhållsam..av.1
  avhållsamhet_1_N = mkN "avhållsamhet" ; -- avhållsamhet..nn.1
  avhöra_1_V = mkV "avhöra" "avhörde" "avhört" ; -- avhöra..vb.1
  avhörande_1_N = mkN "avhörande" ; -- avhörande..nn.1
  avhösta_1_V = mkV "avhöstar" ; -- avhösta..vb.1
  avhöstande_1_N = mkN "avhöstande" ; -- avhöstande..nn.1
  avi_1_N = mkN "avi" "avier" ; -- avi..nn.1
  aviarium_1_N = mkN "aviarium" "aviariet" "aviarier" "aviarierna" ; -- aviarium..nn.1
  aviatik_1_N = mkN "aviatik" ; -- aviatik..nn.1
  aviatiker_1_N = mkN "aviatiker" "aviatikern" "aviatiker" "aviatikerna" ; -- aviatiker..nn.1
  aviatisk_1_A = mkA "aviatisk" ; -- aviatisk..av.1
  aviatör_1_N = mkN "aviatör" "aviatörer" ; -- aviatör..nn.1
  avig_1_A = mkA "avig" ; -- avig..av.1
  aviga_1_N = mkN "aviga" ; -- aviga..nn.1
  avigsida_1_N = mkN "avigsida" ; -- avigsida..nn.1
  avindividualisera_1_V = mkV "avindividualiserar" ; -- avindividualisera..vb.1
  avindividualiserande_1_N = mkN "avindividualiserande" ; -- avindividualiserande..nn.1
  avindividualisering_1_N = mkN "avindividualisering" ; -- avindividualisering..nn.1
  avinstallera_1_V = mkV "avinstallerar" ; -- avinstallera..vb.1
  avinstallerande_1_N = mkN "avinstallerande" ; -- avinstallerande..nn.1
  avinstallerbar_1_A = mkA "avinstallerbar" ; -- avinstallerbar..av.1
  avinstallering_1_N = mkN "avinstallering" ; -- avinstallering..nn.1
  avintellektualisera_1_V = mkV "avintellektualiserar" ; -- avintellektualisera..vb.1
  avintellektualiserande_1_N = mkN "avintellektualiserande" ; -- avintellektualiserande..nn.1
  avintellektualiserbar_1_A = mkA "avintellektualiserbar" ; -- avintellektualiserbar..av.1
  avintellektualisering_1_N = mkN "avintellektualisering" ; -- avintellektualisering..nn.1
  avis_1_N = mkN "avis" "aviser" ; -- avis..nn.1
  avisa_1_N = mkN "avisa" ; -- avisa..nn.1
  avisa_1_V = mkV "avisar" ; -- avisa..vb.1
  avisande_1_N = mkN "avisande" ; -- avisande..nn.1
  avisera_1_V = mkV "aviserar" ; -- avisera..vb.1
  aviserande_1_N = mkN "aviserande" ; -- aviserande..nn.1
  aviserbar_1_A = mkA "aviserbar" ; -- aviserbar..av.1
  aviserbarhet_1_N = mkN "aviserbarhet" ; -- aviserbarhet..nn.1
  avisering_1_N = mkN "avisering" ; -- avisering..nn.1
  aviseringsperiod_1_N = mkN "aviseringsperiod" "aviseringsperioder" ; -- aviseringsperiod..nn.1
  avisning_1_N = mkN "avisning" ; -- avisning..nn.1
  avisningsanläggning_1_N = mkN "avisningsanläggning" ; -- avisningsanläggning..nn.1
  avisofartyg_1_N = mkN "avisofartyg" neutrum  ; -- avisofartyg..nn.1
  avitaminos_1_N = mkN "avitaminos" "avitaminoser" ; -- avitaminos..nn.1
  avjaga_1_V = mkV "avjagar" ; -- avjaga..vb.1
  avjagande_1_N = mkN "avjagande" ; -- avjagande..nn.1
  avjämna_1_V = mkV "avjämnar" ; -- avjämna..vb.1
  avjämnande_1_N = mkN "avjämnande" ; -- avjämnande..nn.1
  avjämning_1_N = mkN "avjämning" ; -- avjämning..nn.1
  avkalka_1_V = mkV "avkalkar" ; -- avkalka..vb.1
  avkalkande_1_N = mkN "avkalkande" ; -- avkalkande..nn.1
  avkapning_1_N = mkN "avkapning" ; -- avkapning..nn.1
  avkasta_1_V = mkV "avkastar" ; -- avkasta..vb.1
  avkastande_1_N = mkN "avkastande" ; -- avkastande..nn.1
  avkastning_1_N = mkN "avkastning" ; -- avkastning..nn.1
  avkastningskrav_1_N = mkN "avkastningskrav" neutrum  ; -- avkastningskrav..nn.1
  avklappning_1_N = mkN "avklappning" ; -- avklappning..nn.1
  avklara_1_V = mkV "avklarar" ; -- avklara..vb.1
  avklara_2_V = mkV "avklarar" ; -- avklara..vb.2
  avklarande_1_N = mkN "avklarande" ; -- avklarande..nn.1
  avklarnad_1_A = mkA "avklarnad" ; -- avklarnad..av.1
  avklinga_1_V = mkV "avklingar" ; -- avklinga..vb.1
  avklingande_1_N = mkN "avklingande" ; -- avklingande..nn.1
  avklippning_1_N = mkN "avklippning" ; -- avklippning..nn.1
  avklä_1_V = mkV "avklä" "avklädde" "avklätt" ; -- avklä..vb.1
  avklädande_1_N = mkN "avklädande" ; -- avklädande..nn.1
  avklädning_1_N = mkN "avklädning" ; -- avklädning..nn.1
  avknackning_1_N = mkN "avknackning" ; -- avknackning..nn.1
  avknipning_1_N = mkN "avknipning" ; -- avknipning..nn.1
  avknoppa_1_V = mkV "avknoppar" ; -- avknoppa..vb.1
  avknoppande_1_N = mkN "avknoppande" ; -- avknoppande..nn.1
  avknoppning_1_N = mkN "avknoppning" ; -- avknoppning..nn.1
  avknoppningsföretag_1_N = mkN "avknoppningsföretag" neutrum  ; -- avknoppningsföretag..nn.1
  avknäppning_1_N = mkN "avknäppning" ; -- avknäppning..nn.1
  avkoda_1_V = mkV "avkodar" ; -- avkoda..vb.1
  avkok_1_N = mkN "avkok" neutrum  ; -- avkok..nn.1
  avkokning_1_N = mkN "avkokning" ; -- avkokning..nn.1
  avkolonisera_1_V = mkV "avkoloniserar" ; -- avkolonisera..vb.1
  avkoloniserande_1_N = mkN "avkoloniserande" ; -- avkoloniserande..nn.1
  avkoloniserbar_1_A = mkA "avkoloniserbar" ; -- avkoloniserbar..av.1
  avkoloniserbarhet_1_N = mkN "avkoloniserbarhet" ; -- avkoloniserbarhet..nn.1
  avkolonisering_1_N = mkN "avkolonisering" ; -- avkolonisering..nn.1
  avkomling_1_N = mkN "avkomling" ; -- avkomling..nn.1
  avkomma_1_N = mkN "avkomma" ; -- avkomma..nn.1
  avkomst_1_N = mkN "avkomst" ; -- avkomst..nn.1
  avkomsträtt_1_N = mkN "avkomsträtt" ; -- avkomsträtt..nn.1
  avkoppla_1_V = mkV "avkopplar" ; -- avkoppla..vb.1
  avkopplande_1_N = mkN "avkopplande" ; -- avkopplande..nn.1
  avkoppling_1_N = mkN "avkoppling" ; -- avkoppling..nn.1
  avkorta_1_V = mkV "avkortar" ; -- avkorta..vb.1
  avkortande_1_N = mkN "avkortande" ; -- avkortande..nn.1
  avkortning_1_N = mkN "avkortning" ; -- avkortning..nn.1
  avkrattning_1_N = mkN "avkrattning" ; -- avkrattning..nn.1
  avkriminalisera_1_V = mkV "avkriminaliserar" ; -- avkriminalisera..vb.1
  avkriminaliserande_1_N = mkN "avkriminaliserande" ; -- avkriminaliserande..nn.1
  avkriminaliserbar_1_A = mkA "avkriminaliserbar" ; -- avkriminaliserbar..av.1
  avkriminaliserbarhet_1_N = mkN "avkriminaliserbarhet" ; -- avkriminaliserbarhet..nn.1
  avkriminalisering_1_N = mkN "avkriminalisering" ; -- avkriminalisering..nn.1
  avkristna_1_V = mkV "avkristnar" ; -- avkristna..vb.1
  avkristnande_1_N = mkN "avkristnande" ; -- avkristnande..nn.1
  avkristning_1_N = mkN "avkristning" ; -- avkristning..nn.1
  avkrok_1_N = mkN "avkrok" ; -- avkrok..nn.1
  avkrokning_1_N = mkN "avkrokning" ; -- avkrokning..nn.1
  avkrängning_1_N = mkN "avkrängning" ; -- avkrängning..nn.1
  avkräva_1_V = mkV "avkräver" ; -- avkräva..vb.1
  avkrävande_1_N = mkN "avkrävande" ; -- avkrävande..nn.1
  avkrävning_1_N = mkN "avkrävning" ; -- avkrävning..nn.1
  avkunna_1_V = mkV "avkunnar" ; -- avkunna..vb.1
  avkunnande_1_N = mkN "avkunnande" ; -- avkunnande..nn.1
  avkvistning_1_N = mkN "avkvistning" ; -- avkvistning..nn.1
  avkyla_1_V = mkV "avkyler" ; -- avkyla..vb.1
  avkylare_1_N = mkN "avkylare" utrum  ; -- avkylare..nn.1
  avkylning_1_N = mkN "avkylning" ; -- avkylning..nn.1
  avkänna_1_V = mkV "avkänna" "avkände" "avkänt" ; -- avkänna..vb.1
  avkännare_1_N = mkN "avkännare" utrum  ; -- avkännare..nn.1
  avkänning_1_N = mkN "avkänning" ; -- avkänning..nn.1
  avkänningssystem_1_N = mkN "avkänningssystem" neutrum  ; -- avkänningssystem..nn.1
  avköna_1_V = mkV "avkönar" ; -- avköna..vb.1
  avkönande_1_N = mkN "avkönande" ; -- avkönande..nn.1
  avkörningsramp_1_N = mkN "avkörningsramp" "avkörningsramper" ; -- avkörningsramp..nn.1
  avla_1_V = mkV "avlar" ; -- avla..vb.1
  avlagd_1_A = mkA "avlagd" "avlagt" ; -- avlagd..av.1
  avlagra_1_V = mkV "avlagrar" ; -- avlagra..vb.1
  avlagrande_1_N = mkN "avlagrande" ; -- avlagrande..nn.1
  avlagring_1_N = mkN "avlagring" ; -- avlagring..nn.1
  avlande_1_N = mkN "avlande" ; -- avlande..nn.1
  avlassning_1_N = mkN "avlassning" ; -- avlassning..nn.1
  avlasta_1_V = mkV "avlastar" ; -- avlasta..vb.1
  avlastande_1_N = mkN "avlastande" ; -- avlastande..nn.1
  avlastare_1_N = mkN "avlastare" utrum  ; -- avlastare..nn.1
  avlastning_1_N = mkN "avlastning" ; -- avlastning..nn.1
  avlastningsort_1_N = mkN "avlastningsort" "avlastningsorter" ; -- avlastningsort..nn.1
  avlastningsplats_1_N = mkN "avlastningsplats" "avlastningsplatser" ; -- avlastningsplats..nn.1
  avlat_1_N = mkN "avlat" ; -- avlat..nn.1
  avlatsbrev_1_N = mkN "avlatsbrev" neutrum  ; -- avlatsbrev..nn.1
  avleda_1_V = mkV "avleda" "avledde" "avlett" ; -- avleda..vb.1
  avledande_1_N = mkN "avledande" ; -- avledande..nn.1
  avledare_1_N = mkN "avledare" utrum  ; -- avledare..nn.1
  avledning_1_N = mkN "avledning" ; -- avledning..nn.1
  avledningsdike_1_N = mkN "avledningsdike" ; -- avledningsdike..nn.1
  avledningsrör_1_N = mkN "avledningsrör" neutrum  ; -- avledningsrör..nn.1
  avledningsändelse_1_N = mkN "avledningsändelse" "avledningsändelser" ; -- avledningsändelse..nn.1
  avlelse_1_N = mkN "avlelse" utrum  ; -- avlelse..nn.1
  avleverera_1_V = mkV "avlevererar" ; -- avleverera..vb.1
  avleverering_1_N = mkN "avleverering" ; -- avleverering..nn.1
  avlida_1_V = mkV "avlida" "avled" "avlidit" ; -- avlida..vb.1
  avlidande_1_N = mkN "avlidande" ; -- avlidande..nn.1
  avliden_1_A = mkA "avliden" ; -- avliden..av.1
  avlindning_1_N = mkN "avlindning" ; -- avlindning..nn.1
  avling_1_N = mkN "avling" ; -- avling..nn.1
  avlinge_1_N = mkN "avlinge" ; -- avlinge..nn.1
  avliva_1_V = mkV "avlivar" ; -- avliva..vb.1
  avlivande_1_N = mkN "avlivande" ; -- avlivande..nn.1
  avljud_1_N = mkN "avljud" neutrum  ; -- avljud..nn.1
  avljudsvokal_1_N = mkN "avljudsvokal" "avljudsvokaler" ; -- avljudsvokal..nn.1
  avlocka_1_V = mkV "avlockar" ; -- avlocka..vb.1
  avlockande_1_N = mkN "avlockande" ; -- avlockande..nn.1
  avlopp_1_N = mkN "avlopp" neutrum  ; -- avlopp..nn.1
  avloppsbrunn_1_N = mkN "avloppsbrunn" ; -- avloppsbrunn..nn.1
  avloppsdike_1_N = mkN "avloppsdike" ; -- avloppsdike..nn.1
  avloppskanal_1_N = mkN "avloppskanal" "avloppskanaler" ; -- avloppskanal..nn.1
  avloppsledning_1_N = mkN "avloppsledning" ; -- avloppsledning..nn.1
  avloppsledningsrör_1_N = mkN "avloppsledningsrör" neutrum  ; -- avloppsledningsrör..nn.1
  avloppsrensare_1_N = mkN "avloppsrensare" utrum  ; -- avloppsrensare..nn.1
  avloppsrensning_1_N = mkN "avloppsrensning" ; -- avloppsrensning..nn.1
  avloppsrensningsslang_1_N = mkN "avloppsrensningsslang" ; -- avloppsrensningsslang..nn.1
  avloppsränna_1_N = mkN "avloppsränna" ; -- avloppsränna..nn.1
  avloppsrör_1_N = mkN "avloppsrör" neutrum  ; -- avloppsrör..nn.1
  avloppssystem_1_N = mkN "avloppssystem" neutrum  ; -- avloppssystem..nn.1
  avloppstrumma_1_N = mkN "avloppstrumma" ; -- avloppstrumma..nn.1
  avloppsvatten_1_N = mkN "avloppsvatten" "avloppsvattnet" "avloppsvatten" "avloppsvattnen" ; -- avloppsvatten..nn.1
  avlossa_1_V = mkV "avlossar" ; -- avlossa..vb.1
  avlossande_1_N = mkN "avlossande" ; -- avlossande..nn.1
  avlusa_1_V = mkV "avlusar" ; -- avlusa..vb.1
  avlusande_1_N = mkN "avlusande" ; -- avlusande..nn.1
  avlusning_1_N = mkN "avlusning" ; -- avlusning..nn.1
  avlusningsmedel_1_N = mkN "avlusningsmedel" neutrum  ; -- avlusningsmedel..nn.1
  avluta_1_V = mkV "avlutar" ; -- avluta..vb.1
  avlutande_1_N = mkN "avlutande" ; -- avlutande..nn.1
  avlysa_1_V = mkV "avlyser" ; -- avlysa..vb.1
  avlysande_1_N = mkN "avlysande" ; -- avlysande..nn.1
  avlysning_1_N = mkN "avlysning" ; -- avlysning..nn.1
  avlyssna_1_V = mkV "avlyssnar" ; -- avlyssna..vb.1
  avlyssnande_1_N = mkN "avlyssnande" ; -- avlyssnande..nn.1
  avlyssning_1_N = mkN "avlyssning" ; -- avlyssning..nn.1
  avlyssningsapparatur_1_N = mkN "avlyssningsapparatur" "avlyssningsapparaturer" ; -- avlyssningsapparatur..nn.1
  avlyssningshärva_1_N = mkN "avlyssningshärva" ; -- avlyssningshärva..nn.1
  avlyssningsskandal_1_N = mkN "avlyssningsskandal" "avlyssningsskandaler" ; -- avlyssningsskandal..nn.1
  avlyssningsutrustning_1_N = mkN "avlyssningsutrustning" ; -- avlyssningsutrustning..nn.1
  avlägga_1_V = mkV "avlägga" "avla" "avlagt" ; -- avlägga..vb.1
  avläggande_1_N = mkN "avläggande" ; -- avläggande..nn.1
  avläggare_1_N = mkN "avläggare" utrum  ; -- avläggare..nn.1
  avläggning_1_N = mkN "avläggning" ; -- avläggning..nn.1
  avlägsen_1_A = mkA "avlägsen" ; -- avlägsen..av.1
  avlägsenhet_1_N = mkN "avlägsenhet" ; -- avlägsenhet..nn.1
  avlägsna_1_V = mkV "avlägsnar" ; -- avlägsna..vb.1
  avlägsnande_1_N = mkN "avlägsnande" ; -- avlägsnande..nn.1
  avlämna_1_V = mkV "avlämnar" ; -- avlämna..vb.1
  avlämnande_1_N = mkN "avlämnande" ; -- avlämnande..nn.1
  avlämning_1_N = mkN "avlämning" ; -- avlämning..nn.1
  avlänka_1_V = mkV "avlänkar" ; -- avlänka..vb.1
  avlänkande_1_N = mkN "avlänkande" ; -- avlänkande..nn.1
  avläsa_1_V = mkV "avläser" ; -- avläsa..vb.1
  avläsande_1_N = mkN "avläsande" ; -- avläsande..nn.1
  avläsare_1_N = mkN "avläsare" utrum  ; -- avläsare..nn.1
  avläsbar_1_A = mkA "avläsbar" ; -- avläsbar..av.1
  avläsbarhet_1_N = mkN "avläsbarhet" ; -- avläsbarhet..nn.1
  avläsning_1_N = mkN "avläsning" ; -- avläsning..nn.1
  avlång_1_A = mkA "avlång" ; -- avlång..av.1
  avlånghet_1_N = mkN "avlånghet" ; -- avlånghet..nn.1
  avlåta_1_V = mkV "avlåta" "avlät" "avlåtit" ; -- avlåta..vb.1
  avlåtande_1_N = mkN "avlåtande" ; -- avlåtande..nn.1
  avlöna_1_V = mkV "avlönar" ; -- avlöna..vb.1
  avlönande_1_N = mkN "avlönande" ; -- avlönande..nn.1
  avlöning_1_N = mkN "avlöning" ; -- avlöning..nn.1
  avlöpa_1_V = mkV "avlöper" ; -- avlöpa..vb.1
  avlöpande_1_N = mkN "avlöpande" ; -- avlöpande..nn.1
  avlöpning_1_N = mkN "avlöpning" ; -- avlöpning..nn.1
  avlösa_1_V = mkV "avlöser" ; -- avlösa..vb.1
  avlösande_1_N = mkN "avlösande" ; -- avlösande..nn.1
  avlösning_1_N = mkN "avlösning" ; -- avlösning..nn.1
  avlöva_1_V = mkV "avlövar" ; -- avlöva..vb.1
  avlövande_1_N = mkN "avlövande" ; -- avlövande..nn.1
  avlövning_1_N = mkN "avlövning" ; -- avlövning..nn.1
  avlövningsmedel_1_N = mkN "avlövningsmedel" neutrum  ; -- avlövningsmedel..nn.1
  avmagnetisera_1_V = mkV "avmagnetiserar" ; -- avmagnetisera..vb.1
  avmagnetiserande_1_N = mkN "avmagnetiserande" ; -- avmagnetiserande..nn.1
  avmagnetiserbar_1_A = mkA "avmagnetiserbar" ; -- avmagnetiserbar..av.1
  avmagnetiserbarhet_1_N = mkN "avmagnetiserbarhet" ; -- avmagnetiserbarhet..nn.1
  avmagnetisering_1_N = mkN "avmagnetisering" ; -- avmagnetisering..nn.1
  avmagnetiseringsprocess_1_N = mkN "avmagnetiseringsprocess" "avmagnetiseringsprocesser" ; -- avmagnetiseringsprocess..nn.1
  avmagrad_1_A = mkA "avmagrad" ; -- avmagrad..av.1
  avmagring_1_N = mkN "avmagring" ; -- avmagring..nn.1
  avmarsch_1_N = mkN "avmarsch" "avmarscher" ; -- avmarsch..nn.1
  avmaska_1_V = mkV "avmaskar" ; -- avmaska..vb.1
  avmaskande_1_N = mkN "avmaskande" ; -- avmaskande..nn.1
  avmaskning_1_N = mkN "avmaskning" ; -- avmaskning..nn.1
  avmaskningskur_1_N = mkN "avmaskningskur" "avmaskningskurer" ; -- avmaskningskur..nn.1
  avmasta_1_V = mkV "avmastar" ; -- avmasta..vb.1
  avmastande_1_N = mkN "avmastande" ; -- avmastande..nn.1
  avmatta_1_V = mkV "avmattar" ; -- avmatta..vb.1
  avmattande_1_N = mkN "avmattande" ; -- avmattande..nn.1
  avmattning_1_N = mkN "avmattning" ; -- avmattning..nn.1
  avmattningsperiod_1_N = mkN "avmattningsperiod" "avmattningsperioder" ; -- avmattningsperiod..nn.1
  avmejning_1_N = mkN "avmejning" ; -- avmejning..nn.1
  avmejsling_1_N = mkN "avmejsling" ; -- avmejsling..nn.1
  avmystifiera_1_V = mkV "avmystifierar" ; -- avmystifiera..vb.1
  avmystifierande_1_N = mkN "avmystifierande" ; -- avmystifierande..nn.1
  avmystifierbar_1_A = mkA "avmystifierbar" ; -- avmystifierbar..av.1
  avmystifierbarhet_1_N = mkN "avmystifierbarhet" ; -- avmystifierbarhet..nn.1
  avmystifiering_1_N = mkN "avmystifiering" ; -- avmystifiering..nn.1
  avmäta_1_V = mkV "avmäter" ; -- avmäta..vb.1
  avmätande_1_N = mkN "avmätande" ; -- avmätande..nn.1
  avmätning_1_N = mkN "avmätning" ; -- avmätning..nn.1
  avmätt_1_A = mkA "avmätt" ; -- avmätt..av.1
  avmätthet_1_N = mkN "avmätthet" ; -- avmätthet..nn.1
  avmålning_1_N = mkN "avmålning" ; -- avmålning..nn.1
  avmönstra_1_V = mkV "avmönstrar" ; -- avmönstra..vb.1
  avmönstring_1_N = mkN "avmönstring" ; -- avmönstring..nn.1
  avnavla_1_V = mkV "avnavlar" ; -- avnavla..vb.1
  avnavlande_1_N = mkN "avnavlande" ; -- avnavlande..nn.1
  avnazifiera_1_V = mkV "avnazifierar" ; -- avnazifiera..vb.1
  avnazifierande_1_N = mkN "avnazifierande" ; -- avnazifierande..nn.1
  avnazifierbar_1_A = mkA "avnazifierbar" ; -- avnazifierbar..av.1
  avnazifierbarhet_1_N = mkN "avnazifierbarhet" ; -- avnazifierbarhet..nn.1
  avnazifiering_1_N = mkN "avnazifiering" ; -- avnazifiering..nn.1
  avnjuta_1_V = mkV "avnjuta" "avnjöt" "avnjutit" ; -- avnjuta..vb.1
  avnjutande_1_N = mkN "avnjutande" ; -- avnjutande..nn.1
  avnypning_1_N = mkN "avnypning" ; -- avnypning..nn.1
  avnystning_1_N = mkN "avnystning" ; -- avnystning..nn.1
  avnämare_1_N = mkN "avnämare" utrum  ; -- avnämare..nn.1
  avnötning_1_N = mkN "avnötning" ; -- avnötning..nn.1
  avocado_1_N = mkN "avocado" "avocador" ; -- avocado..nn.1
  avocadosås_1_N = mkN "avocadosås" "avocadosåser" ; -- avocadosås..nn.1
  avog_1_A = mkA "avog" ; -- avog..av.1
  avoghet_1_N = mkN "avoghet" ; -- avoghet..nn.1
  avokado_1_N = mkN "avokado" "avokador" ; -- avokado..nn.1
  avokadosås_1_N = mkN "avokadosås" "avokadosåser" ; -- avokadosås..nn.1
  avpackning_1_N = mkN "avpackning" ; -- avpackning..nn.1
  avpassa_1_V = mkV "avpassar" ; -- avpassa..vb.1
  avpassande_1_N = mkN "avpassande" ; -- avpassande..nn.1
  avpassning_1_N = mkN "avpassning" ; -- avpassning..nn.1
  avpatrullera_1_V = mkV "avpatrullerar" ; -- avpatrullera..vb.1
  avpatrullerande_1_N = mkN "avpatrullerande" ; -- avpatrullerande..nn.1
  avpatrullerbar_1_A = mkA "avpatrullerbar" ; -- avpatrullerbar..av.1
  avpatrullerbarhet_1_N = mkN "avpatrullerbarhet" ; -- avpatrullerbarhet..nn.1
  avpatrullering_1_N = mkN "avpatrullering" ; -- avpatrullering..nn.1
  avpersonifiera_1_V = mkV "avpersonifierar" ; -- avpersonifiera..vb.1
  avpersonifierande_1_N = mkN "avpersonifierande" ; -- avpersonifierande..nn.1
  avpersonifiering_1_N = mkN "avpersonifiering" ; -- avpersonifiering..nn.1
  avplana_1_V = mkV "avplanar" ; -- avplana..vb.1
  avplanande_1_N = mkN "avplanande" ; -- avplanande..nn.1
  avplaning_1_N = mkN "avplaning" ; -- avplaning..nn.1
  avplockning_1_N = mkN "avplockning" ; -- avplockning..nn.1
  avpolering_1_N = mkN "avpolering" ; -- avpolering..nn.1
  avpolitisera_1_V = mkV "avpolitiserar" ; -- avpolitisera..vb.1
  avpolitiserande_1_N = mkN "avpolitiserande" ; -- avpolitiserande..nn.1
  avpolitiserbar_1_A = mkA "avpolitiserbar" ; -- avpolitiserbar..av.1
  avpolitiserbarhet_1_N = mkN "avpolitiserbarhet" ; -- avpolitiserbarhet..nn.1
  avpolitisering_1_N = mkN "avpolitisering" ; -- avpolitisering..nn.1
  avpollettera_1_V = mkV "avpolletterar" ; -- avpollettera..vb.1
  avpolletterande_1_N = mkN "avpolletterande" ; -- avpolletterande..nn.1
  avpolletterbar_1_A = mkA "avpolletterbar" ; -- avpolletterbar..av.1
  avpolletterbarhet_1_N = mkN "avpolletterbarhet" ; -- avpolletterbarhet..nn.1
  avpollettering_1_N = mkN "avpollettering" ; -- avpollettering..nn.1
  avporträttera_1_V = mkV "avporträtterar" ; -- avporträttera..vb.1
  avporträtterande_1_N = mkN "avporträtterande" ; -- avporträtterande..nn.1
  avporträtterbar_1_A = mkA "avporträtterbar" ; -- avporträtterbar..av.1
  avporträtterbarhet_1_N = mkN "avporträtterbarhet" ; -- avporträtterbarhet..nn.1
  avporträttering_1_N = mkN "avporträttering" ; -- avporträttering..nn.1
  avpressa_1_V = mkV "avpressar" ; -- avpressa..vb.1
  avpressande_1_N = mkN "avpressande" ; -- avpressande..nn.1
  avprickning_1_N = mkN "avprickning" ; -- avprickning..nn.1
  avputsning_1_N = mkN "avputsning" ; -- avputsning..nn.1
  avrad_1_N = mkN "avrad" ; -- avrad..nn.1
  avradikalisera_1_V = mkV "avradikaliserar" ; -- avradikalisera..vb.1
  avradikaliserande_1_N = mkN "avradikaliserande" ; -- avradikaliserande..nn.1
  avradikalisering_1_N = mkN "avradikalisering" ; -- avradikalisering..nn.1
  avrakad_1_A = mkA "avrakad" ; -- avrakad..av.1
  avreagera_1_V = mkV "avreagerar" ; -- avreagera..vb.1
  avreagerande_1_N = mkN "avreagerande" ; -- avreagerande..nn.1
  avreagerbar_1_A = mkA "avreagerbar" ; -- avreagerbar..av.1
  avreagerbarhet_1_N = mkN "avreagerbarhet" ; -- avreagerbarhet..nn.1
  avreagering_1_N = mkN "avreagering" ; -- avreagering..nn.1
  avreda_1_V = mkV "avreda" "avredde" "avrett" ; -- avreda..vb.1
  avredande_1_N = mkN "avredande" ; -- avredande..nn.1
  avredning_1_N = mkN "avredning" ; -- avredning..nn.1
  avregistrera_1_V = mkV "avregistrerar" ; -- avregistrera..vb.1
  avregistrerande_1_N = mkN "avregistrerande" ; -- avregistrerande..nn.1
  avregistrerbar_1_A = mkA "avregistrerbar" ; -- avregistrerbar..av.1
  avregistrerbarhet_1_N = mkN "avregistrerbarhet" ; -- avregistrerbarhet..nn.1
  avregistrering_1_N = mkN "avregistrering" ; -- avregistrering..nn.1
  avreglera_1_V = mkV "avreglerar" ; -- avreglera..vb.1
  avreglerande_1_N = mkN "avreglerande" ; -- avreglerande..nn.1
  avreglerbar_1_A = mkA "avreglerbar" ; -- avreglerbar..av.1
  avreglerbarhet_1_N = mkN "avreglerbarhet" ; -- avreglerbarhet..nn.1
  avreglering_1_N = mkN "avreglering" ; -- avreglering..nn.1
  avrens_1_N = mkN "avrens" neutrum  ; -- avrens..nn.1
  avrensning_1_N = mkN "avrensning" ; -- avrensning..nn.1
  avresa_1_N = mkN "avresa" ; -- avresa..nn.1
  avresa_1_V = mkV "avreser" ; -- avresa..vb.1
  avresande_1_N = mkN "avresande" ; -- avresande..nn.1
  avringning_1_N = mkN "avringning" ; -- avringning..nn.1
  avrinna_1_V = mkV "avrinna" "avrann" "avrunnit" ; -- avrinna..vb.1
  avrinnande_1_N = mkN "avrinnande" ; -- avrinnande..nn.1
  avrinning_1_N = mkN "avrinning" ; -- avrinning..nn.1
  avritning_1_N = mkN "avritning" ; -- avritning..nn.1
  avrivning_1_N = mkN "avrivning" ; -- avrivning..nn.1
  avromantisera_1_V = mkV "avromantiserar" ; -- avromantisera..vb.1
  avromantiserande_1_N = mkN "avromantiserande" ; -- avromantiserande..nn.1
  avromantiserbar_1_A = mkA "avromantiserbar" ; -- avromantiserbar..av.1
  avromantiserbarhet_1_N = mkN "avromantiserbarhet" ; -- avromantiserbarhet..nn.1
  avromantisering_1_N = mkN "avromantisering" ; -- avromantisering..nn.1
  avrop_1_N = mkN "avrop" neutrum  ; -- avrop..nn.1
  avrullning_1_N = mkN "avrullning" ; -- avrullning..nn.1
  avrunda_1_V = mkV "avrundar" ; -- avrunda..vb.1
  avrundande_1_N = mkN "avrundande" ; -- avrundande..nn.1
  avrundning_1_N = mkN "avrundning" ; -- avrundning..nn.1
  avrusta_1_V = mkV "avrustar" ; -- avrusta..vb.1
  avrustande_1_N = mkN "avrustande" ; -- avrustande..nn.1
  avrustning_1_N = mkN "avrustning" ; -- avrustning..nn.1
  avräkna_1_V = mkV "avräknar" ; -- avräkna..vb.1
  avräknande_1_N = mkN "avräknande" ; -- avräknande..nn.1
  avräkning_1_N = mkN "avräkning" ; -- avräkning..nn.1
  avräkningsnota_1_N = mkN "avräkningsnota" ; -- avräkningsnota..nn.1
  avrätta_1_V = mkV "avrättar" ; -- avrätta..vb.1
  avrättande_1_N = mkN "avrättande" ; -- avrättande..nn.1
  avrättning_1_N = mkN "avrättning" ; -- avrättning..nn.1
  avrättningsdag_1_N = mkN "avrättningsdag" ; -- avrättningsdag..nn.1
  avrättningslista_1_N = mkN "avrättningslista" ; -- avrättningslista..nn.1
  avrättningsplats_1_N = mkN "avrättningsplats" "avrättningsplatser" ; -- avrättningsplats..nn.1
  avråda_1_V = mkV "avråda" "avrådde" "avrått" ; -- avråda..vb.1
  avrådande_1_N = mkN "avrådande" ; -- avrådande..nn.1
  avröjning_1_N = mkN "avröjning" ; -- avröjning..nn.1
  avsadling_1_N = mkN "avsadling" ; -- avsadling..nn.1
  avsaknad_1_N = mkN "avsaknad" "avsaknader" ; -- avsaknad..nn.1
  avsaktning_1_N = mkN "avsaktning" ; -- avsaktning..nn.1
  avsalta_1_V = mkV "avsaltar" ; -- avsalta..vb.1
  avsaltande_1_N = mkN "avsaltande" ; -- avsaltande..nn.1
  avsalu_1_N = mkN "avsalu" ; -- avsalu..nn.1
  avsats_1_N = mkN "avsats" "avsatser" ; -- avsats..nn.1
  avse_1_V = mkV "avse" "avsåg" "avsett" ; -- avse..vb.1
  avsedd_1_A = mkA "avsedd" ; -- avsedd..av.1
  avseende_1_N = mkN "avseende" ; -- avseende..nn.1
  avsegla_1_V = mkV "avseglar" ; -- avsegla..vb.1
  avseglande_1_N = mkN "avseglande" ; -- avseglande..nn.1
  avsegling_1_N = mkN "avsegling" ; -- avsegling..nn.1
  avseglingsdag_1_N = mkN "avseglingsdag" ; -- avseglingsdag..nn.1
  avseglingsort_1_N = mkN "avseglingsort" "avseglingsorter" ; -- avseglingsort..nn.1
  avselning_1_N = mkN "avselning" ; -- avselning..nn.1
  avsevärd_1_A = mkA "avsevärd" "avsevärt" ; -- avsevärd..av.1
  avsides_1_A = mkA "avsides" ; -- avsides..av.1
  avsidesliv_1_N = mkN "avsidesliv" neutrum  ; -- avsidesliv..nn.1
  avsigkommen_1_A = mkA "avsigkommen" "avsigkommet" "avsigkomna" "avsigkomna" "avsigkomnare" "avsigkomnast" "avsigkomnaste" ; -- avsigkommen..av.1
  avsigkommenhet_1_N = mkN "avsigkommenhet" ; -- avsigkommenhet..nn.1
  avsikt_1_N = mkN "avsikt" "avsikter" ; -- avsikt..nn.1
  avsiktlig_1_A = mkA "avsiktlig" ; -- avsiktlig..av.1
  avsiktligen_1_Adv = mkAdv "avsiktligen" ; -- avsiktligen..ab.1
  avsiktlighet_1_N = mkN "avsiktlighet" ; -- avsiktlighet..nn.1
  avsiktsbisats_1_N = mkN "avsiktsbisats" "avsiktsbisatser" ; -- avsiktsbisats..nn.1
  avsiktsförklaring_1_N = mkN "avsiktsförklaring" ; -- avsiktsförklaring..nn.1
  avsiktslös_1_A = mkA "avsiktslös" ; -- avsiktslös..av.1
  avsiktssats_1_N = mkN "avsiktssats" "avsiktssatser" ; -- avsiktssats..nn.1
  avsilning_1_N = mkN "avsilning" ; -- avsilning..nn.1
  avsittning_1_N = mkN "avsittning" ; -- avsittning..nn.1
  avsjunga_1_V = mkV "avsjunga" "avsjöng" "avsjungit" ; -- avsjunga..vb.1
  avsjungande_1_N = mkN "avsjungande" ; -- avsjungande..nn.1
  avskaffa_1_V = mkV "avskaffar" ; -- avskaffa..vb.1
  avskaffande_1_N = mkN "avskaffande" ; -- avskaffande..nn.1
  avskaffning_1_N = mkN "avskaffning" ; -- avskaffning..nn.1
  avskakning_1_N = mkN "avskakning" ; -- avskakning..nn.1
  avskalning_1_N = mkN "avskalning" ; -- avskalning..nn.1
  avskava_1_V = mkV "avskaver" ; -- avskava..vb.1
  avskavande_1_N = mkN "avskavande" ; -- avskavande..nn.1
  avskavning_1_N = mkN "avskavning" ; -- avskavning..nn.1
  avsked_1_N = mkN "avsked" neutrum  ; -- avsked..nn.1
  avskeda_1_V = mkV "avskedar" ; -- avskeda..vb.1
  avskedande_1_N = mkN "avskedande" ; -- avskedande..nn.1
  avskedsbrev_1_N = mkN "avskedsbrev" neutrum  ; -- avskedsbrev..nn.1
  avskedsbägare_1_N = mkN "avskedsbägare" utrum  ; -- avskedsbägare..nn.1
  avskedsdikt_1_N = mkN "avskedsdikt" "avskedsdikter" ; -- avskedsdikt..nn.1
  avskedsfest_1_N = mkN "avskedsfest" "avskedsfester" ; -- avskedsfest..nn.1
  avskedsföreställning_1_N = mkN "avskedsföreställning" ; -- avskedsföreställning..nn.1
  avskedshälsning_1_N = mkN "avskedshälsning" ; -- avskedshälsning..nn.1
  avskedskalas_1_N = mkN "avskedskalas" neutrum  ; -- avskedskalas..nn.1
  avskedsknull_1_N = mkN "avskedsknull" neutrum  ; -- avskedsknull..nn.1
  avskedskyss_1_N = mkN "avskedskyss" ; -- avskedskyss..nn.1
  avskedsmiddag_1_N = mkN "avskedsmiddag" ; -- avskedsmiddag..nn.1
  avskedsord_1_N = mkN "avskedsord" neutrum  ; -- avskedsord..nn.1
  avskedsskål_1_N = mkN "avskedsskål" ; -- avskedsskål..nn.1
  avskedssång_1_N = mkN "avskedssång" "avskedssånger" ; -- avskedssång..nn.1
  avskedstagande_1_N = mkN "avskedstagande" ; -- avskedstagande..nn.1
  avskedstal_1_N = mkN "avskedstal" neutrum  ; -- avskedstal..nn.1
  avskedsturné_1_N = mkN "avskedsturné" "avskedsturnéer" ; -- avskedsturné..nn.1
  avskedsuppvaktning_1_N = mkN "avskedsuppvaktning" ; -- avskedsuppvaktning..nn.1
  avskedsvisit_1_N = mkN "avskedsvisit" "avskedsvisiter" ; -- avskedsvisit..nn.1
  avskeppa_1_V = mkV "avskeppar" ; -- avskeppa..vb.1
  avskeppning_1_N = mkN "avskeppning" ; -- avskeppning..nn.1
  avskeppningshamn_1_N = mkN "avskeppningshamn" ; -- avskeppningshamn..nn.1
  avskeppningsort_1_N = mkN "avskeppningsort" "avskeppningsorter" ; -- avskeppningsort..nn.1
  avskild_1_A = mkA "avskild" "avskilt" ; -- avskild..av.1
  avskildhet_1_N = mkN "avskildhet" "avskildheter" ; -- avskildhet..nn.1
  avskilja_1_V = mkV "avskilja" "avskilde" "avskilt" ; -- avskilja..vb.1
  avskiljande_1_N = mkN "avskiljande" ; -- avskiljande..nn.1
  avskiljbar_1_A = mkA "avskiljbar" ; -- avskiljbar..av.1
  avskiljbarhet_1_N = mkN "avskiljbarhet" ; -- avskiljbarhet..nn.1
  avskiljning_1_N = mkN "avskiljning" ; -- avskiljning..nn.1
  avskjuta_1_V = mkV "avskjuta" "avsköt" "avskjutit" ; -- avskjuta..vb.1
  avskjutande_1_N = mkN "avskjutande" ; -- avskjutande..nn.1
  avskjutning_1_N = mkN "avskjutning" ; -- avskjutning..nn.1
  avskogning_1_N = mkN "avskogning" ; -- avskogning..nn.1
  avskottning_1_N = mkN "avskottning" ; -- avskottning..nn.1
  avskrap_1_N = mkN "avskrap" neutrum  ; -- avskrap..nn.1
  avskrapning_1_N = mkN "avskrapning" ; -- avskrapning..nn.1
  avskrift_1_N = mkN "avskrift" "avskrifter" ; -- avskrift..nn.1
  avskriva_1_V = mkV "avskriva" "avskrev" "avskrivit" ; -- avskriva..vb.1
  avskrivande_1_N = mkN "avskrivande" ; -- avskrivande..nn.1
  avskrivare_1_N = mkN "avskrivare" utrum  ; -- avskrivare..nn.1
  avskrivning_1_N = mkN "avskrivning" ; -- avskrivning..nn.1
  avskrivningsobjekt_1_N = mkN "avskrivningsobjekt" neutrum  ; -- avskrivningsobjekt..nn.1
  avskrot_1_N = mkN "avskrot" ; -- avskrot..nn.1
  avskrubbning_1_N = mkN "avskrubbning" ; -- avskrubbning..nn.1
  avskruvning_1_N = mkN "avskruvning" ; -- avskruvning..nn.1
  avskräcka_1_V = mkV "avskräcker" ; -- avskräcka..vb.1
  avskräckande_1_N = mkN "avskräckande" ; -- avskräckande..nn.1
  avskräckning_1_N = mkN "avskräckning" ; -- avskräckning..nn.1
  avskräckningsmedel_1_N = mkN "avskräckningsmedel" neutrum  ; -- avskräckningsmedel..nn.1
  avskräckningspolitik_1_N = mkN "avskräckningspolitik" ; -- avskräckningspolitik..nn.1
  avskräda_1_V = mkV "avskräda" "avskrädde" "avskrätt" ; -- avskräda..vb.1
  avskrädande_1_N = mkN "avskrädande" ; -- avskrädande..nn.1
  avskräde_1_N = mkN "avskräde" ; -- avskräde..nn.1
  avskrädeshög_1_N = mkN "avskrädeshög" ; -- avskrädeshög..nn.1
  avskrädning_1_N = mkN "avskrädning" ; -- avskrädning..nn.1
  avskuddning_1_N = mkN "avskuddning" ; -- avskuddning..nn.1
  avskumning_1_N = mkN "avskumning" ; -- avskumning..nn.1
  avskurning_1_N = mkN "avskurning" ; -- avskurning..nn.1
  avsky_1_V = mkV "avskyr" ; -- avsky..vb.1
  avskydd_1_A = mkA "avskydd" ; -- avskydd..av.1
  avskyende_1_N = mkN "avskyende" ; -- avskyende..nn.1
  avskyffling_1_N = mkN "avskyffling" ; -- avskyffling..nn.1
  avskyväckande_1_A = mkA "avskyväckande" ; -- avskyväckande..av.1
  avskyvärd_1_A = mkA "avskyvärd" "avskyvärt" ; -- avskyvärd..av.1
  avskyvärdhet_1_N = mkN "avskyvärdhet" ; -- avskyvärdhet..nn.1
  avskära_1_V = mkV "avskära" "avskar" "avskurit" ; -- avskära..vb.1
  avskärande_1_N = mkN "avskärande" ; -- avskärande..nn.1
  avskärare_1_N = mkN "avskärare" utrum  ; -- avskärare..nn.1
  avskärma_1_V = mkV "avskärmar" ; -- avskärma..vb.1
  avskärmande_1_N = mkN "avskärmande" ; -- avskärmande..nn.1
  avskärmning_1_N = mkN "avskärmning" ; -- avskärmning..nn.1
  avskärning_1_N = mkN "avskärning" ; -- avskärning..nn.1
  avsköljning_1_N = mkN "avsköljning" ; -- avsköljning..nn.1
  avslag_1_N = mkN "avslag" neutrum  ; -- avslag..nn.1
  avslagen_1_A = mkA "avslagen" ; -- avslagen..av.1
  avslagenhet_1_N = mkN "avslagenhet" ; -- avslagenhet..nn.1
  avslappnad_1_A = mkA "avslappnad" ; -- avslappnad..av.1
  avslappning_1_N = mkN "avslappning" ; -- avslappning..nn.1
  avslappningsskiva_1_N = mkN "avslappningsskiva" ; -- avslappningsskiva..nn.1
  avslappningsövning_1_N = mkN "avslappningsövning" ; -- avslappningsövning..nn.1
  avslickning_1_N = mkN "avslickning" ; -- avslickning..nn.1
  avslipa_1_V = mkV "avslipar" ; -- avslipa..vb.1
  avslipande_1_N = mkN "avslipande" ; -- avslipande..nn.1
  avslipning_1_N = mkN "avslipning" ; -- avslipning..nn.1
  avslita_1_V = mkV "avslita" "avslet" "avslitit" ; -- avslita..vb.1
  avslitande_1_N = mkN "avslitande" ; -- avslitande..nn.1
  avslut_1_N = mkN "avslut" neutrum  ; -- avslut..nn.1
  avsluta_1_V = mkV "avslutar" ; -- avsluta..vb.1
  avslutande_1_N = mkN "avslutande" ; -- avslutande..nn.1
  avslutning_1_N = mkN "avslutning" ; -- avslutning..nn.1
  avslutningsfest_1_N = mkN "avslutningsfest" "avslutningsfester" ; -- avslutningsfest..nn.1
  avslutningsvis_1_Adv = mkAdv "avslutningsvis" ; -- avslutningsvis..ab.1
  avslängning_1_N = mkN "avslängning" ; -- avslängning..nn.1
  avsläppning_1_N = mkN "avsläppning" ; -- avsläppning..nn.1
  avslå_1_V = mkV "avslå" "avslog" "avslagit" ; -- avslå..vb.1
  avslående_1_N = mkN "avslående" ; -- avslående..nn.1
  avslöja_1_V = mkV "avslöjar" ; -- avslöja..vb.1
  avslöjande_1_N = mkN "avslöjande" ; -- avslöjande..nn.1
  avslöjning_1_N = mkN "avslöjning" ; -- avslöjning..nn.1
  avsmak_1_N = mkN "avsmak" ; -- avsmak..nn.1
  avsmaka_1_V = mkV "avsmakar" ; -- avsmaka..vb.1
  avsmakande_1_N = mkN "avsmakande" ; -- avsmakande..nn.1
  avsmakning_1_N = mkN "avsmakning" ; -- avsmakning..nn.1
  avsmalna_1_V = mkV "avsmalnar" ; -- avsmalna..vb.1
  avsmalnande_1_N = mkN "avsmalnande" ; -- avsmalnande..nn.1
  avsmalning_1_N = mkN "avsmalning" ; -- avsmalning..nn.1
  avsmältning_1_N = mkN "avsmältning" ; -- avsmältning..nn.1
  avsnitt_1_N = mkN "avsnitt" neutrum  ; -- avsnitt..nn.1
  avsnoppa_1_V = mkV "avsnoppar" ; -- avsnoppa..vb.1
  avsnoppad_1_A = mkA "avsnoppad" ; -- avsnoppad..av.1
  avsnoppande_1_N = mkN "avsnoppande" ; -- avsnoppande..nn.1
  avsnäsning_1_N = mkN "avsnäsning" ; -- avsnäsning..nn.1
  avsnöra_1_V = mkV "avsnöra" "avsnörde" "avsnört" ; -- avsnöra..vb.1
  avsnörande_1_N = mkN "avsnörande" ; -- avsnörande..nn.1
  avsnörning_1_N = mkN "avsnörning" ; -- avsnörning..nn.1
  avsnörningsteori_1_N = mkN "avsnörningsteori" "avsnörningsteorier" ; -- avsnörningsteori..nn.1
  avsocialisera_1_V = mkV "avsocialiserar" ; -- avsocialisera..vb.1
  avsocialiserande_1_N = mkN "avsocialiserande" ; -- avsocialiserande..nn.1
  avsocialiserbar_1_A = mkA "avsocialiserbar" ; -- avsocialiserbar..av.1
  avsocialiserbarhet_1_N = mkN "avsocialiserbarhet" ; -- avsocialiserbarhet..nn.1
  avsocialisering_1_N = mkN "avsocialisering" ; -- avsocialisering..nn.1
  avsomna_1_V = mkV "avsomnar" ; -- avsomna..vb.1
  avsomnande_1_N = mkN "avsomnande" ; -- avsomnande..nn.1
  avsopning_1_N = mkN "avsopning" ; -- avsopning..nn.1
  avspark_1_N = mkN "avspark" ; -- avspark..nn.1
  avsparkning_1_N = mkN "avsparkning" ; -- avsparkning..nn.1
  avspegla_1_V = mkV "avspeglar" ; -- avspegla..vb.1
  avspeglande_1_N = mkN "avspeglande" ; -- avspeglande..nn.1
  avspegling_1_N = mkN "avspegling" ; -- avspegling..nn.1
  avspela_1_V = mkV "avspelar" ; -- avspela..vb.1
  avspelande_1_N = mkN "avspelande" ; -- avspelande..nn.1
  avspelning_1_N = mkN "avspelning" ; -- avspelning..nn.1
  avspisa_1_V = mkV "avspisar" ; -- avspisa..vb.1
  avspisande_1_N = mkN "avspisande" ; -- avspisande..nn.1
  avspisning_1_N = mkN "avspisning" ; -- avspisning..nn.1
  avspolning_1_N = mkN "avspolning" ; -- avspolning..nn.1
  avsprång_1_N = mkN "avsprång" neutrum  ; -- avsprång..nn.1
  avspänd_1_A = mkA "avspänd" ; -- avspänd..av.1
  avspändhet_1_N = mkN "avspändhet" ; -- avspändhet..nn.1
  avspänning_1_N = mkN "avspänning" ; -- avspänning..nn.1
  avspänningspedagog_1_N = mkN "avspänningspedagog" "avspänningspedagoger" ; -- avspänningspedagog..nn.1
  avspärra_1_V = mkV "avspärrar" ; -- avspärra..vb.1
  avspärrande_1_N = mkN "avspärrande" ; -- avspärrande..nn.1
  avspärrning_1_N = mkN "avspärrning" ; -- avspärrning..nn.1
  avspärrningsband_1_N = mkN "avspärrningsband" neutrum  ; -- avspärrningsband..nn.1
  avstalinisera_1_V = mkV "avstaliniserar" ; -- avstalinisera..vb.1
  avstaliniserande_1_N = mkN "avstaliniserande" ; -- avstaliniserande..nn.1
  avstaliniserbar_1_A = mkA "avstaliniserbar" ; -- avstaliniserbar..av.1
  avstaliniserbarhet_1_N = mkN "avstaliniserbarhet" ; -- avstaliniserbarhet..nn.1
  avstalinisering_1_N = mkN "avstalinisering" ; -- avstalinisering..nn.1
  avstamp_1_N = mkN "avstamp" neutrum  ; -- avstamp..nn.1
  avstanna_1_V = mkV "avstannar" ; -- avstanna..vb.1
  avstannande_1_N = mkN "avstannande" ; -- avstannande..nn.1
  avstava_1_V = mkV "avstavar" ; -- avstava..vb.1
  avstavande_1_N = mkN "avstavande" ; -- avstavande..nn.1
  avstavning_1_N = mkN "avstavning" ; -- avstavning..nn.1
  avstavningsregel_1_N = mkN "avstavningsregel" "avstavningsregeln" "avstavningsregler" "avstavningsreglerna" ; -- avstavningsregel..nn.1
  avstavningssätt_1_N = mkN "avstavningssätt" neutrum  ; -- avstavningssätt..nn.1
  avsteg_1_N = mkN "avsteg" neutrum  ; -- avsteg..nn.1
  avstickare_1_N = mkN "avstickare" utrum  ; -- avstickare..nn.1
  avstickning_1_N = mkN "avstickning" ; -- avstickning..nn.1
  avstigning_1_N = mkN "avstigning" ; -- avstigning..nn.1
  avstigningsplats_1_N = mkN "avstigningsplats" "avstigningsplatser" ; -- avstigningsplats..nn.1
  avstjälpning_1_N = mkN "avstjälpning" ; -- avstjälpning..nn.1
  avstjälpningscentral_1_N = mkN "avstjälpningscentral" "avstjälpningscentraler" ; -- avstjälpningscentral..nn.1
  avstjälpningsplats_1_N = mkN "avstjälpningsplats" "avstjälpningsplatser" ; -- avstjälpningsplats..nn.1
  avstressa_1_V = mkV "avstressar" ; -- avstressa..vb.1
  avstressad_1_A = mkA "avstressad" ; -- avstressad..av.1
  avstressande_1_N = mkN "avstressande" ; -- avstressande..nn.1
  avstycka_1_V = mkV "avstyckar" ; -- avstycka..vb.1
  avstyckande_1_N = mkN "avstyckande" ; -- avstyckande..nn.1
  avstyckning_1_N = mkN "avstyckning" ; -- avstyckning..nn.1
  avstyra_1_V = mkV "avstyra" "avstyrde" "avstyrt" ; -- avstyra..vb.1
  avstyrande_1_N = mkN "avstyrande" ; -- avstyrande..nn.1
  avstyrka_1_V = mkV "avstyrker" ; -- avstyrka..vb.1
  avstyrkande_1_N = mkN "avstyrkande" ; -- avstyrkande..nn.1
  avställa_1_V = mkV "avställer" ; -- avställa..vb.1
  avställande_1_N = mkN "avställande" ; -- avställande..nn.1
  avställning_1_N = mkN "avställning" ; -- avställning..nn.1
  avställningsyta_1_N = mkN "avställningsyta" ; -- avställningsyta..nn.1
  avstämma_1_V = mkV "avstämmer" ; -- avstämma..vb.1
  avstämmande_1_N = mkN "avstämmande" ; -- avstämmande..nn.1
  avstämning_1_N = mkN "avstämning" ; -- avstämning..nn.1
  avstämpling_1_N = mkN "avstämpling" ; -- avstämpling..nn.1
  avstänga_1_V = mkV "avstänger" ; -- avstänga..vb.1
  avstängande_1_N = mkN "avstängande" ; -- avstängande..nn.1
  avstängare_1_N = mkN "avstängare" utrum  ; -- avstängare..nn.1
  avstängning_1_N = mkN "avstängning" ; -- avstängning..nn.1
  avstå_1_V = mkV "avstå" "avstod" "avstått" ; -- avstå..vb.1
  avstående_1_N = mkN "avstående" ; -- avstående..nn.1
  avstånd_1_N = mkN "avstånd" neutrum  ; -- avstånd..nn.1
  avståndsbedömning_1_N = mkN "avståndsbedömning" ; -- avståndsbedömning..nn.1
  avståndsinformation_1_N = mkN "avståndsinformation" ; -- avståndsinformation..nn.1
  avståndskraft_1_N = mkN "avståndskraft" "avståndskrafter" ; -- avståndskraft..nn.1
  avståndsmätare_1_N = mkN "avståndsmätare" utrum  ; -- avståndsmätare..nn.1
  avståndsmätning_1_N = mkN "avståndsmätning" ; -- avståndsmätning..nn.1
  avståndstagande_1_N = mkN "avståndstagande" ; -- avståndstagande..nn.1
  avstöra_1_V = mkV "avstöra" "avstörde" "avstört" ; -- avstöra..vb.1
  avstörande_1_N = mkN "avstörande" ; -- avstörande..nn.1
  avstöta_1_V = mkV "avstöter" ; -- avstöta..vb.1
  avstötande_1_N = mkN "avstötande" ; -- avstötande..nn.1
  avstötning_1_N = mkN "avstötning" ; -- avstötning..nn.1
  avsugning_1_N = mkN "avsugning" ; -- avsugning..nn.1
  avsutten_1_A = mkA "avsutten" ; -- avsutten..av.1
  avsvalkning_1_N = mkN "avsvalkning" ; -- avsvalkning..nn.1
  avsvalna_1_V = mkV "avsvalnar" ; -- avsvalna..vb.1
  avsvalnande_1_N = mkN "avsvalnande" ; -- avsvalnande..nn.1
  avsvalning_1_N = mkN "avsvalning" ; -- avsvalning..nn.1
  avsvalningshastighet_1_N = mkN "avsvalningshastighet" ; -- avsvalningshastighet..nn.1
  avsvavla_1_V = mkV "avsvavlar" ; -- avsvavla..vb.1
  avsvavlande_1_N = mkN "avsvavlande" ; -- avsvavlande..nn.1
  avsvimma_1_V = mkV "avsvimmar" ; -- avsvimma..vb.1
  avsvimmande_1_N = mkN "avsvimmande" ; -- avsvimmande..nn.1
  avsvimning_1_N = mkN "avsvimning" ; -- avsvimning..nn.1
  avsvuren_1_A = mkA "avsvuren" ; -- avsvuren..av.1
  avsvärja_1_V = mkV "avsvära" "avsvär" "avsvärj" "avsvärjde" "avsvärjt" "avsvuren" ; -- avsvärja..vb.1
  avsvärjande_1_N = mkN "avsvärjande" ; -- avsvärjande..nn.1
  avsvärjning_1_N = mkN "avsvärjning" ; -- avsvärjning..nn.1
  avsyna_1_V = mkV "avsynar" ; -- avsyna..vb.1
  avsynande_1_N = mkN "avsynande" ; -- avsynande..nn.1
  avsynare_1_N = mkN "avsynare" utrum  ; -- avsynare..nn.1
  avsyning_1_N = mkN "avsyning" ; -- avsyning..nn.1
  avsäga_1_V = mkV "avsäja" "avsa" "avsagt" ; -- avsäga..vb.1
  avsägande_1_N = mkN "avsägande" ; -- avsägande..nn.1
  avsägelse_1_N = mkN "avsägelse" "avsägelser" ; -- avsägelse..nn.1
  avsända_1_V = mkV "avsänder" ; -- avsända..vb.1
  avsändande_1_N = mkN "avsändande" ; -- avsändande..nn.1
  avsändare_1_N = mkN "avsändare" utrum  ; -- avsändare..nn.1
  avsändarnummer_1_N = mkN "avsändarnummer" neutrum  ; -- avsändarnummer..nn.1
  avsändning_1_N = mkN "avsändning" ; -- avsändning..nn.1
  avsätta_1_V = mkV "avsätta" "avsätter" "avsätt" "avsatte" "avsatt" "avsatt" ; -- avsätta..vb.1
  avsättande_1_N = mkN "avsättande" ; -- avsättande..nn.1
  avsättlig_1_A = mkA "avsättlig" ; -- avsättlig..av.1
  avsättlighet_1_N = mkN "avsättlighet" ; -- avsättlighet..nn.1
  avsättning_1_N = mkN "avsättning" ; -- avsättning..nn.1
  avsättningsbassäng_1_N = mkN "avsättningsbassäng" "avsättningsbassänger" ; -- avsättningsbassäng..nn.1
  avsåga_1_V = mkV "avsågar" ; -- avsåga..vb.1
  avsågande_1_N = mkN "avsågande" ; -- avsågande..nn.1
  avsågning_1_N = mkN "avsågning" ; -- avsågning..nn.1
  avsöka_1_V = mkV "avsöker" ; -- avsöka..vb.1
  avsökande_1_N = mkN "avsökande" ; -- avsökande..nn.1
  avsökare_1_N = mkN "avsökare" utrum  ; -- avsökare..nn.1
  avsöndra_1_V = mkV "avsöndrar" ; -- avsöndra..vb.1
  avsöndrande_1_N = mkN "avsöndrande" ; -- avsöndrande..nn.1
  avsöndring_1_N = mkN "avsöndring" ; -- avsöndring..nn.1
  avta_1_V = mkV "avtaga" "avtog" "avtagit" ; -- avta..vb.1
  avtacka_1_V = mkV "avtackar" ; -- avtacka..vb.1
  avtackande_1_N = mkN "avtackande" ; -- avtackande..nn.1
  avtacklad_1_A = mkA "avtacklad" ; -- avtacklad..av.1
  avtackling_1_N = mkN "avtackling" ; -- avtackling..nn.1
  avtackning_1_N = mkN "avtackning" ; -- avtackning..nn.1
  avtagande_1_A = mkA "avtagande" ; -- avtagande..av.1
  avtagande_1_N = mkN "avtagande" ; -- avtagande..nn.1
  avtagbar_1_A = mkA "avtagbar" ; -- avtagbar..av.1
  avtagbarhet_1_N = mkN "avtagbarhet" ; -- avtagbarhet..nn.1
  avtagning_1_N = mkN "avtagning" ; -- avtagning..nn.1
  avtagsväg_1_N = mkN "avtagsväg" ; -- avtagsväg..nn.1
  avtal_1_N = mkN "avtal" neutrum  ; -- avtal..nn.1
  avtala_1_V = mkV "avtalar" ; -- avtala..vb.1
  avtalande_1_N = mkN "avtalande" ; -- avtalande..nn.1
  avtalsbrott_1_N = mkN "avtalsbrott" neutrum  ; -- avtalsbrott..nn.1
  avtalsenlig_1_A = mkA "avtalsenlig" ; -- avtalsenlig..av.1
  avtalsenlighet_1_N = mkN "avtalsenlighet" ; -- avtalsenlighet..nn.1
  avtalsfrihet_1_N = mkN "avtalsfrihet" "avtalsfriheter" ; -- avtalsfrihet..nn.1
  avtalsförhandling_1_N = mkN "avtalsförhandling" ; -- avtalsförhandling..nn.1
  avtalsmässig_1_A = mkA "avtalsmässig" ; -- avtalsmässig..av.1
  avtalspension_1_N = mkN "avtalspension" ; -- avtalspension..nn.1
  avtalspensionär_1_N = mkN "avtalspensionär" "avtalspensionärer" ; -- avtalspensionär..nn.1
  avtalsperiod_1_N = mkN "avtalsperiod" "avtalsperioder" ; -- avtalsperiod..nn.1
  avtalsrätt_1_N = mkN "avtalsrätt" ; -- avtalsrätt..nn.1
  avtalsrörelse_1_N = mkN "avtalsrörelse" "avtalsrörelser" ; -- avtalsrörelse..nn.1
  avtalssekreterare_1_N = mkN "avtalssekreterare" utrum  ; -- avtalssekreterare..nn.1
  avtalsslutande_1_A = mkA "avtalsslutande" ; -- avtalsslutande..av.1
  avtalsstridig_1_A = mkA "avtalsstridig" ; -- avtalsstridig..av.1
  avtappa_1_V = mkV "avtappar" ; -- avtappa..vb.1
  avtappande_1_N = mkN "avtappande" ; -- avtappande..nn.1
  avtappning_1_N = mkN "avtappning" ; -- avtappning..nn.1
  avteckna_1_V = mkV "avtecknar" ; -- avteckna..vb.1
  avtecknande_1_N = mkN "avtecknande" ; -- avtecknande..nn.1
  avteckning_1_N = mkN "avteckning" ; -- avteckning..nn.1
  avtjäna_1_V = mkV "avtjänar" ; -- avtjäna..vb.1
  avtjänande_1_N = mkN "avtjänande" ; -- avtjänande..nn.1
  avtona_1_V = mkV "avtonar" ; -- avtona..vb.1
  avtonande_1_N = mkN "avtonande" ; -- avtonande..nn.1
  avtoning_1_N = mkN "avtoning" ; -- avtoning..nn.1
  avtorka_1_V = mkV "avtorkar" ; -- avtorka..vb.1
  avtorkning_1_N = mkN "avtorkning" ; -- avtorkning..nn.1
  avtrappa_1_V = mkV "avtrappar" ; -- avtrappa..vb.1
  avtrappande_1_N = mkN "avtrappande" ; -- avtrappande..nn.1
  avtroppning_1_N = mkN "avtroppning" ; -- avtroppning..nn.1
  avtrubba_1_V = mkV "avtrubbar" ; -- avtrubba..vb.1
  avtrubbande_1_N = mkN "avtrubbande" ; -- avtrubbande..nn.1
  avtrubbning_1_N = mkN "avtrubbning" ; -- avtrubbning..nn.1
  avtryck_1_N = mkN "avtryck" neutrum  ; -- avtryck..nn.1
  avtryckare_1_N = mkN "avtryckare" utrum  ; -- avtryckare..nn.1
  avtryckning_1_N = mkN "avtryckning" ; -- avtryckning..nn.1
  avträda_1_V = mkV "avträda" "avträdde" "avträtt" ; -- avträda..vb.1
  avträdande_1_N = mkN "avträdande" ; -- avträdande..nn.1
  avträdare_1_N = mkN "avträdare" utrum  ; -- avträdare..nn.1
  avträde_1_N = mkN "avträde" ; -- avträde..nn.1
  avträdelse_1_N = mkN "avträdelse" "avträdelser" ; -- avträdelse..nn.1
  avtunna_1_V = mkV "avtunnar" ; -- avtunna..vb.1
  avtunnande_1_N = mkN "avtunnande" ; -- avtunnande..nn.1
  avtunning_1_N = mkN "avtunning" ; -- avtunning..nn.1
  avtvagning_1_N = mkN "avtvagning" ; -- avtvagning..nn.1
  avtvinga_1_V = mkV "avtvingar" ; -- avtvinga..vb.1
  avtvingande_1_N = mkN "avtvingande" ; -- avtvingande..nn.1
  avtvättning_1_N = mkN "avtvättning" ; -- avtvättning..nn.1
  avtvå_1_V = mkV "avtvår" ; -- avtvå..vb.1
  avtvående_1_N = mkN "avtvående" ; -- avtvående..nn.1
  avtyning_1_N = mkN "avtyning" ; -- avtyning..nn.1
  avtäcka_1_V = mkV "avtäcker" ; -- avtäcka..vb.1
  avtäckande_1_N = mkN "avtäckande" ; -- avtäckande..nn.1
  avtäckning_1_N = mkN "avtäckning" ; -- avtäckning..nn.1
  avtäckningsceremoni_1_N = mkN "avtäckningsceremoni" "avtäckningsceremonier" ; -- avtäckningsceremoni..nn.1
  avtändande_1_A = mkA "avtändande" ; -- avtändande..av.1
  avtärd_1_A = mkA "avtärd" "avtärt" ; -- avtärd..av.1
  avtärdhet_1_N = mkN "avtärdhet" ; -- avtärdhet..nn.1
  avtåg_1_N = mkN "avtåg" neutrum  ; -- avtåg..nn.1
  avtåga_1_V = mkV "avtågar" ; -- avtåga..vb.1
  avtågande_1_N = mkN "avtågande" ; -- avtågande..nn.1
  avulavirusinfektion_1_N = mkN "avulavirusinfektion" ; -- avulavirusinfektion..nn.1
  avund_1_N = mkN "avund" ; -- avund..nn.1
  avundsam_1_A = mkA "avundsam" "avundsamt" "avundsamma" "avundsamma" "avundsammare" "avundsammast" "avundsammaste" ; -- avundsam..av.1
  avundsamhet_1_N = mkN "avundsamhet" ; -- avundsamhet..nn.1
  avundsfri_1_A = mkA "avundsfri" "avundsfritt" ; -- avundsfri..av.1
  avundsfull_1_A = mkA "avundsfull" ; -- avundsfull..av.1
  avundsjuk_1_A = mkA "avundsjuk" ; -- avundsjuk..av.1
  avundsjuka_1_N = mkN "avundsjuka" ; -- avundsjuka..nn.1
  avundsjukhet_1_N = mkN "avundsjukhet" ; -- avundsjukhet..nn.1
  avundsman_1_N = mkN "avundsman" "avundsmannen" "avundsmän" "avundsmännen" ; -- avundsman..nn.1
  avundsvärd_1_A = mkA "avundsvärd" "avundsvärt" ; -- avundsvärd..av.1
  avundsvärdhet_1_N = mkN "avundsvärdhet" ; -- avundsvärdhet..nn.1
  avvakta_1_V = mkV "avvaktar" ; -- avvakta..vb.1
  avvaktande_1_N = mkN "avvaktande" ; -- avvaktande..nn.1
  avvara_1_V = mkV "avvarar" ; -- avvara..vb.1
  avvarad_1_A = mkA "avvarad" ; -- avvarad..av.1
  avvarande_1_N = mkN "avvarande" ; -- avvarande..nn.1
  avvattna_1_V = mkV "avvattnar" ; -- avvattna..vb.1
  avvattnande_1_N = mkN "avvattnande" ; -- avvattnande..nn.1
  avvattning_1_N = mkN "avvattning" ; -- avvattning..nn.1
  avveckla_1_V = mkV "avvecklar" ; -- avveckla..vb.1
  avvecklande_1_N = mkN "avvecklande" ; -- avvecklande..nn.1
  avveckling_1_N = mkN "avveckling" ; -- avveckling..nn.1
  avvecklingsbeslut_1_N = mkN "avvecklingsbeslut" neutrum  ; -- avvecklingsbeslut..nn.1
  avverka_1_V = mkV "avverkar" ; -- avverka..vb.1
  avverkande_1_N = mkN "avverkande" ; -- avverkande..nn.1
  avverkning_1_N = mkN "avverkning" ; -- avverkning..nn.1
  avverkningsarbete_1_N = mkN "avverkningsarbete" ; -- avverkningsarbete..nn.1
  avverkningsrätt_1_N = mkN "avverkningsrätt" "avverkningsrätter" ; -- avverkningsrätt..nn.1
  avvika_1_V = mkV "avvika" "avviker" "avvik" "avvek" "avvikt" "avviken" ; -- avvika..vb.1
  avvikande_1_A = mkA "avvikande" ; -- avvikande..av.1
  avvikande_1_N = mkN "avvikande" ; -- avvikande..nn.1
  avvikare_1_N = mkN "avvikare" utrum  ; -- avvikare..nn.1
  avvikelse_1_N = mkN "avvikelse" "avvikelser" ; -- avvikelse..nn.1
  avvikelseprocent_1_N = mkN "avvikelseprocent" "avvikelseprocenten" "avvikelseprocent" "avvikelseprocenten" ; -- avvikelseprocent..nn.1
  avviken_1_A = mkA "avviken" ; -- avviken..av.1
  avvindning_1_N = mkN "avvindning" ; -- avvindning..nn.1
  avvinna_1_V = mkV "avvinna" "avvann" "avvunnit" ; -- avvinna..vb.1
  avvinnande_1_N = mkN "avvinnande" ; -- avvinnande..nn.1
  avvisa_1_V = mkV "avvisar" ; -- avvisa..vb.1
  avvisande_1_N = mkN "avvisande" ; -- avvisande..nn.1
  avvisare_1_N = mkN "avvisare" utrum  ; -- avvisare..nn.1
  avvisning_1_N = mkN "avvisning" ; -- avvisning..nn.1
  avvisningsbeslut_1_N = mkN "avvisningsbeslut" neutrum  ; -- avvisningsbeslut..nn.1
  avvita_1_V = mkV "avvitar" ; -- avvita..vb.1
  avvitande_1_N = mkN "avvitande" ; -- avvitande..nn.1
  avvittra_1_V = mkV "avvittrar" ; -- avvittra..vb.1
  avvittrande_1_N = mkN "avvittrande" ; -- avvittrande..nn.1
  avväg_1_N = mkN "avväg" ; -- avväg..nn.1
  avväga_1_V = mkV "avväger" ; -- avväga..vb.1
  avvägande_1_N = mkN "avvägande" ; -- avvägande..nn.1
  avvägning_1_N = mkN "avvägning" ; -- avvägning..nn.1
  avvägningsinstrument_1_N = mkN "avvägningsinstrument" neutrum  ; -- avvägningsinstrument..nn.1
  avvältring_1_N = mkN "avvältring" ; -- avvältring..nn.1
  avvända_1_V = mkV "avvänder" ; -- avvända..vb.1
  avvändande_1_N = mkN "avvändande" ; -- avvändande..nn.1
  avvändning_1_N = mkN "avvändning" ; -- avvändning..nn.1
  avvänja_1_V = mkV "avvänja" "avvande" "avvant" ; -- avvänja..vb.1
  avvänjande_1_N = mkN "avvänjande" ; -- avvänjande..nn.1
  avvänjning_1_N = mkN "avvänjning" ; -- avvänjning..nn.1
  avvänjningstid_1_N = mkN "avvänjningstid" "avvänjningstider" ; -- avvänjningstid..nn.1
  avväpna_1_V = mkV "avväpnar" ; -- avväpna..vb.1
  avväpnande_1_A = mkA "avväpnande" ; -- avväpnande..av.1
  avväpnande_1_N = mkN "avväpnande" ; -- avväpnande..nn.1
  avvärja_1_V = mkV "avvärja" "avvärjde" "avvärjt" ; -- avvärja..vb.1
  avvärjande_1_N = mkN "avvärjande" ; -- avvärjande..nn.1
  avvärjning_1_N = mkN "avvärjning" ; -- avvärjning..nn.1
  avväxling_1_N = mkN "avväxling" ; -- avväxling..nn.1
  avytterlig_1_A = mkA "avytterlig" ; -- avytterlig..av.1
  avytterlighet_1_N = mkN "avytterlighet" ; -- avytterlighet..nn.1
  avyttra_1_V = mkV "avyttrar" ; -- avyttra..vb.1
  avyttrande_1_N = mkN "avyttrande" ; -- avyttrande..nn.1
  aväta_1_V = mkV "aväta" "avåt" "avätit" ; -- aväta..vb.1
  avätande_1_N = mkN "avätande" ; -- avätande..nn.1
  avåkning_1_N = mkN "avåkning" ; -- avåkning..nn.1
  ax_1_N = mkN "ax" neutrum  ; -- ax..nn.1
  ax_2_N = mkN "ax" neutrum  ; -- ax..nn.2
  axa_1_V = mkV "axar" ; -- axa..vb.1
  axande_1_N = mkN "axande" ; -- axande..nn.1
  axblommig_1_A = mkA "axblommig" ; -- axblommig..av.1
  axel_1_N = mkN "axel" ; -- axel..nn.1
  axelband_1_N = mkN "axelband" neutrum  ; -- axelband..nn.1
  axelbred_1_A = mkA "axelbred" "axelbrett" ; -- axelbred..av.1
  axelbössa_1_N = mkN "axelbössa" ; -- axelbössa..nn.1
  axeldiameter_1_N = mkN "axeldiameter" ; -- axeldiameter..nn.1
  axelfraktur_1_N = mkN "axelfraktur" "axelfrakturer" ; -- axelfraktur..nn.1
  axelgehäng_1_N = mkN "axelgehäng" neutrum  ; -- axelgehäng..nn.1
  axelhål_1_N = mkN "axelhål" neutrum  ; -- axelhål..nn.1
  axelhölster_1_N = mkN "axelhölster" neutrum  ; -- axelhölster..nn.1
  axelinflammation_1_N = mkN "axelinflammation" ; -- axelinflammation..nn.1
  axelklaff_1_N = mkN "axelklaff" ; -- axelklaff..nn.1
  axelkoppling_1_N = mkN "axelkoppling" ; -- axelkoppling..nn.1
  axellager_1_N = mkN "axellager" neutrum  ; -- axellager..nn.1
  axelled_1_N = mkN "axelled" "axelleder" ; -- axelled..nn.1
  axelledsdislokation_1_N = mkN "axelledsdislokation" ; -- axelledsdislokation..nn.1
  axelledsluxation_1_N = mkN "axelledsluxation" ; -- axelledsluxation..nn.1
  axellång_1_A = mkA "axellång" ; -- axellång..av.1
  axelmuff_1_N = mkN "axelmuff" ; -- axelmuff..nn.1
  axelrem_1_N = mkN "axelrem" "axelremmen" "axelremmar" "axelremmarna" ; -- axelrem..nn.1
  axelremsväska_1_N = mkN "axelremsväska" ; -- axelremsväska..nn.1
  axelriktning_1_N = mkN "axelriktning" ; -- axelriktning..nn.1
  axelring_1_N = mkN "axelring" ; -- axelring..nn.1
  axelryckning_1_N = mkN "axelryckning" ; -- axelryckning..nn.1
  axelset_1_N = mkN "axelset" neutrum  ; -- axelset..nn.1
  axelsmärta_1_N = mkN "axelsmärta" ; -- axelsmärta..nn.1
  axelsprint_1_N = mkN "axelsprint" ; -- axelsprint..nn.1
  axelvadd_1_N = mkN "axelvadd" ; -- axelvadd..nn.1
  axformig_1_A = mkA "axformig" ; -- axformig..av.1
  axial_1_A = mkA "axial" ; -- axial..av.1
  axillarkrycka_1_N = mkN "axillarkrycka" ; -- axillarkrycka..nn.1
  axiom_1_N = mkN "axiom" neutrum  ; -- axiom..nn.1
  axiomatisera_1_V = mkV "axiomatiserar" ; -- axiomatisera..vb.1
  axiomatiserande_1_N = mkN "axiomatiserande" ; -- axiomatiserande..nn.1
  axiomatiserbar_1_A = mkA "axiomatiserbar" ; -- axiomatiserbar..av.1
  axiomatiserbarhet_1_N = mkN "axiomatiserbarhet" ; -- axiomatiserbarhet..nn.1
  axiomatisering_1_N = mkN "axiomatisering" ; -- axiomatisering..nn.1
  axiomatisk_1_A = mkA "axiomatisk" ; -- axiomatisk..av.1
  axion_1_N = mkN "axion" ; -- axion..nn.1
  axionförtätning_1_N = mkN "axionförtätning" ; -- axionförtätning..nn.1
  axla_1_V = mkV "axlar" ; -- axla..vb.1
  axlande_1_N = mkN "axlande" ; -- axlande..nn.1
  axplock_1_N = mkN "axplock" neutrum  ; -- axplock..nn.1
  axsvingel_1_N = mkN "axsvingel" ; -- axsvingel..nn.1
  ayahuasca_1_N = mkN "ayahuasca" ; -- ayahuasca..nn.1
  ayatolla_1_N = mkN "ayatolla" ; -- ayatolla..nn.1
  ayatollah_1_N = mkN "ayatollah" ; -- ayatollah..nn.1
  ayrshireboskap_1_N = mkN "ayrshireboskap" ; -- ayrshireboskap..nn.1
  azalea_1_N = mkN "azalea" ; -- azalea..nn.1
  azerbajdzjan_1_N = mkN "azerbajdzjan" "azerbajdzjaner" ; -- azerbajdzjan..nn.1
  azerbajdzjansk_1_A = mkA "azerbajdzjansk" ; -- azerbajdzjansk..av.1
  azerbajdzjanska_1_N = mkN "azerbajdzjanska" ; -- azerbajdzjanska..nn.1
  azerbajdzjanska_2_N = mkN "azerbajdzjanska" ; -- azerbajdzjanska..nn.2
  azimut_1_N = mkN "azimut" ; -- azimut..nn.1
  azoospermi_1_N = mkN "azoospermi" ; -- azoospermi..nn.1
  azotemi_1_N = mkN "azotemi" ; -- azotemi..nn.1
  aztek_1_N = mkN "aztek" "azteker" ; -- aztek..nn.1
  aztekisk_1_A = mkA "aztekisk" ; -- aztekisk..av.1
  azur_1_N = mkN "azur" ; -- azur..nn.1
  azurblå_1_A = mkA "azurblå" "azurblått" ; -- azurblå..av.1
  azurfärg_1_N = mkN "azurfärg" ; -- azurfärg..nn.1
  ba_1_Adv = mkAdv "ba" ; -- ba..ab.1
  babbel_1_N = mkN "babbel" neutrum  ; -- babbel..nn.1
  babbla_1_V = mkV "babblar" ; -- babbla..vb.1
  babblande_1_N = mkN "babblande" ; -- babblande..nn.1
  babblare_1_N = mkN "babblare" utrum  ; -- babblare..nn.1
  babian_1_N = mkN "babian" "babianer" ; -- babian..nn.1
  babianröv_1_N = mkN "babianröv" ; -- babianröv..nn.1
  babord_1_Adv = mkAdv "babord" ; -- babord..ab.1
  babord_1_N = mkN "babord" ; -- babord..nn.1
  babordsida_1_N = mkN "babordsida" ; -- babordsida..nn.1
  babordsvakt_1_N = mkN "babordsvakt" "babordsvakter" ; -- babordsvakt..nn.1
  babordsåra_1_N = mkN "babordsåra" ; -- babordsåra..nn.1
  babusjka_1_N = mkN "babusjka" ; -- babusjka..nn.1
  baby_1_N = mkN "baby" "babyn" "babies" "babiesarna" ; -- baby..nn.1
  babyboom_1_N = mkN "babyboom" "babyboomer" ; -- babyboom..nn.1
  babybyxa_1_N = mkN "babybyxa" ; -- babybyxa..nn.1
  babydräkt_1_N = mkN "babydräkt" "babydräkter" ; -- babydräkt..nn.1
  babylonier_1_N = mkN "babylonier" "babyloniern" "babylonier" "babylonierna" ; -- babylonier..nn.1
  babylonisk_1_A = mkA "babylonisk" ; -- babylonisk..av.1
  babylycka_1_N = mkN "babylycka" ; -- babylycka..nn.1
  babysitter_1_N = mkN "babysitter" ; -- babysitter..nn.1
  babysketch_1_N = mkN "babysketch" "babysketcher" ; -- babysketch..nn.1
  baccarat_1_N = mkN "baccarat" ; -- baccarat..nn.1
  bacill_1_N = mkN "bacill" "baciller" ; -- bacill..nn.1
  bacillbärare_1_N = mkN "bacillbärare" utrum  ; -- bacillbärare..nn.1
  bacillfri_1_A = mkA "bacillfri" "bacillfritt" ; -- bacillfri..av.1
  bacillskräck_1_N = mkN "bacillskräck" ; -- bacillskräck..nn.1
  back_1_N = mkN "back" ; -- back..nn.1
  backa_1_N = mkN "backa" ; -- backa..nn.1
  backa_1_V = mkV "backar" ; -- backa..vb.1
  backa_2_V = mkV "backar" ; -- backa..vb.2
  backanal_1_N = mkN "backanal" "backanaler" ; -- backanal..nn.1
  backanalant_1_N = mkN "backanalant" "backanalanter" ; -- backanalant..nn.1
  backanalisk_1_A = mkA "backanalisk" ; -- backanalisk..av.1
  backande_1_N = mkN "backande" ; -- backande..nn.1
  backanis_1_N = mkN "backanis" ; -- backanis..nn.1
  backant_1_N = mkN "backant" "backanter" ; -- backant..nn.1
  backe_1_N = mkN "backe" utrum  ; -- backe..nn.1
  backfisch_1_N = mkN "backfisch" ; -- backfisch..nn.1
  backgammon_1_N = mkN "backgammon" ; -- backgammon..nn.1
  backhammer_1_N = mkN "backhammer" "backhammern" "backhamrar" "backhamrarna" ; -- backhammer..nn.1
  backhand_1_N = mkN "backhand" ; -- backhand..nn.1
  backhoppare_1_N = mkN "backhoppare" utrum  ; -- backhoppare..nn.1
  backhoppning_1_N = mkN "backhoppning" ; -- backhoppning..nn.1
  backig_1_A = mkA "backig" ; -- backig..av.1
  backighet_1_N = mkN "backighet" ; -- backighet..nn.1
  backkrön_1_N = mkN "backkrön" neutrum  ; -- backkrön..nn.1
  backlandskap_1_N = mkN "backlandskap" neutrum  ; -- backlandskap..nn.1
  backning_1_N = mkN "backning" ; -- backning..nn.1
  backpacker_1_N = mkN "backpacker" "backpackern" "backpackers" "backpackersarna" ; -- backpacker..nn.1
  backpacking_1_N = mkN "backpacking" ; -- backpacking..nn.1
  backsignal_1_N = mkN "backsignal" "backsignaler" ; -- backsignal..nn.1
  backsippa_1_N = mkN "backsippa" ; -- backsippa..nn.1
  backslag_1_N = mkN "backslag" neutrum  ; -- backslag..nn.1
  backspegel_1_N = mkN "backspegel" ; -- backspegel..nn.1
  backstag_1_N = mkN "backstag" neutrum  ; -- backstag..nn.1
  backström_1_N = mkN "backström" "backströmmen" "backströmmar" "backströmmarna" ; -- backström..nn.1
  backstuga_1_N = mkN "backstuga" ; -- backstuga..nn.1
  backstugusittare_1_N = mkN "backstugusittare" utrum  ; -- backstugusittare..nn.1
  backsvala_1_N = mkN "backsvala" ; -- backsvala..nn.1
  backsöta_1_N = mkN "backsöta" ; -- backsöta..nn.1
  backtimjan_1_N = mkN "backtimjan" ; -- backtimjan..nn.1
  backup_1_N = mkN "backup" "backupen" "backups" "backuperna" ; -- backup..nn.1
  backupa_1_V = mkV "backupar" ; -- backupa..vb.1
  backupande_1_N = mkN "backupande" ; -- backupande..nn.1
  backupp_1_N = mkN "backupp" "backuppen" "backupps" "backupperna" ; -- backupp..nn.1
  backuppa_1_V = mkV "backuppar" ; -- backuppa..vb.1
  backuppande_1_N = mkN "backuppande" ; -- backuppande..nn.1
  backvial_1_N = mkN "backvial" "backvialer" ; -- backvial..nn.1
  backväxel_1_N = mkN "backväxel" ; -- backväxel..nn.1
  bacon_1_N = mkN "bacon" ; -- bacon..nn.1
  bad_1_N = mkN "bad" neutrum  ; -- bad..nn.1
  bada_1_V = mkV "badar" ; -- bada..vb.1
  badande_1_N = mkN "badande" ; -- badande..nn.1
  badanka_1_N = mkN "badanka" ; -- badanka..nn.1
  badanläggning_1_N = mkN "badanläggning" ; -- badanläggning..nn.1
  badanstalt_1_N = mkN "badanstalt" "badanstalter" ; -- badanstalt..nn.1
  badare_1_N = mkN "badare" utrum  ; -- badare..nn.1
  badbassäng_1_N = mkN "badbassäng" "badbassänger" ; -- badbassäng..nn.1
  badbild_1_N = mkN "badbild" "badbilder" ; -- badbild..nn.1
  badborste_1_N = mkN "badborste" utrum  ; -- badborste..nn.1
  badbyxa_1_N = mkN "badbyxa" ; -- badbyxa..nn.1
  badda_1_V = mkV "baddar" ; -- badda..vb.1
  baddande_1_N = mkN "baddande" ; -- baddande..nn.1
  baddare_1_N = mkN "baddare" utrum  ; -- baddare..nn.1
  baddjävel_1_N = mkN "baddjävel" ; -- baddjävel..nn.1
  baddning_1_N = mkN "baddning" ; -- baddning..nn.1
  baddräkt_1_N = mkN "baddräkt" "baddräkter" ; -- baddräkt..nn.1
  badensare_1_N = mkN "badensare" utrum  ; -- badensare..nn.1
  badensisk_1_A = mkA "badensisk" ; -- badensisk..av.1
  badflicka_1_N = mkN "badflicka" ; -- badflicka..nn.1
  badförbud_1_N = mkN "badförbud" neutrum  ; -- badförbud..nn.1
  badgäst_1_N = mkN "badgäst" "badgäster" ; -- badgäst..nn.1
  badhandduk_1_N = mkN "badhandduk" ; -- badhandduk..nn.1
  badhus_1_N = mkN "badhus" neutrum  ; -- badhus..nn.1
  badhytt_1_N = mkN "badhytt" "badhytter" ; -- badhytt..nn.1
  badinrättning_1_N = mkN "badinrättning" ; -- badinrättning..nn.1
  badkappa_1_N = mkN "badkappa" ; -- badkappa..nn.1
  badkar_1_N = mkN "badkar" neutrum  ; -- badkar..nn.1
  badkarseffekt_1_N = mkN "badkarseffekt" "badkarseffekter" ; -- badkarseffekt..nn.1
  badkarskant_1_N = mkN "badkarskant" "badkarskanter" ; -- badkarskant..nn.1
  badklippa_1_N = mkN "badklippa" ; -- badklippa..nn.1
  badlakan_1_N = mkN "badlakan" neutrum  ; -- badlakan..nn.1
  badläkare_1_N = mkN "badläkare" utrum  ; -- badläkare..nn.1
  badminton_1_N = mkN "badminton" ; -- badminton..nn.1
  badmintonboll_1_N = mkN "badmintonboll" ; -- badmintonboll..nn.1
  badmintonrack_1_N = mkN "badmintonrack" ; -- badmintonrack..nn.1
  badmintonracket_1_N = mkN "badmintonracket" ; -- badmintonracket..nn.1
  badmössa_1_N = mkN "badmössa" ; -- badmössa..nn.1
  badning_1_N = mkN "badning" ; -- badning..nn.1
  badort_1_N = mkN "badort" "badorter" ; -- badort..nn.1
  badortsliv_1_N = mkN "badortsliv" neutrum  ; -- badortsliv..nn.1
  badortsstad_1_N = mkN "badortsstad" "badortsstäder" ; -- badortsstad..nn.1
  badplats_1_N = mkN "badplats" "badplatser" ; -- badplats..nn.1
  badresa_1_N = mkN "badresa" ; -- badresa..nn.1
  badrum_1_N = mkN "badrum" "badrummet" "badrum" "badrummen" ; -- badrum..nn.1
  badrumsdörr_1_N = mkN "badrumsdörr" ; -- badrumsdörr..nn.1
  badrumsfläkt_1_N = mkN "badrumsfläkt" ; -- badrumsfläkt..nn.1
  badrumsfärg_1_N = mkN "badrumsfärg" "badrumsfärger" ; -- badrumsfärg..nn.1
  badrumsgolv_1_N = mkN "badrumsgolv" neutrum  ; -- badrumsgolv..nn.1
  badrumskakel_1_N = mkN "badrumskakel" neutrum  ; -- badrumskakel..nn.1
  badrumsmöbel_1_N = mkN "badrumsmöbel" "badrumsmöbeln" "badrumsmöbler" "badrumsmöblerna" ; -- badrumsmöbel..nn.1
  badrumsskåp_1_N = mkN "badrumsskåp" neutrum  ; -- badrumsskåp..nn.1
  badrumsspegel_1_N = mkN "badrumsspegel" ; -- badrumsspegel..nn.1
  badsalt_1_N = mkN "badsalt" "badsaltet" "badsalter" "badsalterna" ; -- badsalt..nn.1
  badsemester_1_N = mkN "badsemester" ; -- badsemester..nn.1
  badsjö_1_N = mkN "badsjö" ; -- badsjö..nn.1
  badsko_1_N = mkN "badsko" "badskor" ; -- badsko..nn.1
  badstrand_1_N = mkN "badstrand" "badstränder" ; -- badstrand..nn.1
  badstuga_1_N = mkN "badstuga" ; -- badstuga..nn.1
  badställe_1_N = mkN "badställe" ; -- badställe..nn.1
  badtoffel_1_N = mkN "badtoffla" ; -- badtoffel..nn.1
  badtunna_1_N = mkN "badtunna" ; -- badtunna..nn.1
  badturist_1_N = mkN "badturist" "badturister" ; -- badturist..nn.1
  badvakt_1_N = mkN "badvakt" "badvakter" ; -- badvakt..nn.1
  badvatten_1_N = mkN "badvatten" "badvattnet" "badvatten" "badvattnen" ; -- badvatten..nn.1
  bag_in_box_1_N = mkN "bag-in-box" ; -- bag-in-box..nn.1
  bag_1_N = mkN "bag" ; -- bag..nn.1
  bagage_1_N = mkN "bagage" ; -- bagage..nn.1
  bagage_2_N = mkN "bagage" ; -- bagage..nn.2
  bagagehylla_1_N = mkN "bagagehylla" ; -- bagagehylla..nn.1
  bagageinlämning_1_N = mkN "bagageinlämning" ; -- bagageinlämning..nn.1
  bagagekärra_1_N = mkN "bagagekärra" ; -- bagagekärra..nn.1
  bagagelucka_1_N = mkN "bagagelucka" ; -- bagagelucka..nn.1
  bagagerum_1_N = mkN "bagagerum" "bagagerummet" "bagagerum" "bagagerummen" ; -- bagagerum..nn.1
  bagagestropp_1_N = mkN "bagagestropp" ; -- bagagestropp..nn.1
  bagageutrymme_1_N = mkN "bagageutrymme" ; -- bagageutrymme..nn.1
  bagagevagn_1_N = mkN "bagagevagn" ; -- bagagevagn..nn.1
  bagarbod_1_N = mkN "bagarbod" ; -- bagarbod..nn.1
  bagare_1_N = mkN "bagare" utrum  ; -- bagare..nn.1
  bagarmössa_1_N = mkN "bagarmössa" ; -- bagarmössa..nn.1
  bagarstuga_1_N = mkN "bagarstuga" ; -- bagarstuga..nn.1
  bagatell_1_N = mkN "bagatell" "bagateller" ; -- bagatell..nn.1
  bagatellartad_1_A = mkA "bagatellartad" ; -- bagatellartad..av.1
  bagatellisera_1_V = mkV "bagatelliserar" ; -- bagatellisera..vb.1
  bagatelliserande_1_N = mkN "bagatelliserande" ; -- bagatelliserande..nn.1
  bagatelliserbar_1_A = mkA "bagatelliserbar" ; -- bagatelliserbar..av.1
  bagatelliserbarhet_1_N = mkN "bagatelliserbarhet" ; -- bagatelliserbarhet..nn.1
  bagatellisering_1_N = mkN "bagatellisering" ; -- bagatellisering..nn.1
  bagatellmål_1_N = mkN "bagatellmål" neutrum  ; -- bagatellmål..nn.1
  bagel_1_N = mkN "bagel" "bageln" "bagels" "bagelsarna" ; -- bagel..nn.1
  bageri_1_N = mkN "bageri" "bageriet" "bagerier" "bagerierna" ; -- bageri..nn.1
  bagerimargarin_1_N = mkN "bagerimargarin" "bagerimargarinet" "bagerimargariner" "bagerimargarinerna" ; -- bagerimargarin..nn.1
  bagerirörelse_1_N = mkN "bagerirörelse" "bagerirörelser" ; -- bagerirörelse..nn.1
  bagg_1_N = mkN "bagg" ; -- bagg..nn.1
  baggböla_1_V = mkV "baggbölar" ; -- baggböla..vb.1
  baggbölande_1_N = mkN "baggbölande" ; -- baggbölande..nn.1
  baggbölare_1_N = mkN "baggbölare" utrum  ; -- baggbölare..nn.1
  baggböleri_1_N = mkN "baggböleri" neutrum  ; -- baggböleri..nn.1
  bagge_1_N = mkN "bagge" utrum  ; -- bagge..nn.1
  bagis_1_N = mkN "bagis" ; -- bagis..nn.1
  baguette_1_N = mkN "baguette" "baguetter" ; -- baguette..nn.1
  bahaman_1_N = mkN "bahaman" "bahamaner" ; -- bahaman..nn.1
  bahamansk_1_A = mkA "bahamansk" ; -- bahamansk..av.1
  bahamanska_1_N = mkN "bahamanska" ; -- bahamanska..nn.1
  bahrainare_1_N = mkN "bahrainare" utrum  ; -- bahrainare..nn.1
  bahrainsk_1_A = mkA "bahrainsk" ; -- bahrainsk..av.1
  bahrainska_1_N = mkN "bahrainska" ; -- bahrainska..nn.1
  bahytt_1_N = mkN "bahytt" "bahytter" ; -- bahytt..nn.1
  baissa_1_V = mkV "baissar" ; -- baissa..vb.1
  baissande_1_N = mkN "baissande" ; -- baissande..nn.1
  baisse_1_N = mkN "baisse" "baisser" ; -- baisse..nn.1
  baissespekulation_1_N = mkN "baissespekulation" ; -- baissespekulation..nn.1
  baja_maja_1_N = mkN "baja-maja" ; -- baja-maja..nn.1
  baja_1_V = mkV "bajar" ; -- baja..vb.1
  bajadär_1_N = mkN "bajadär" "bajadärer" ; -- bajadär..nn.1
  bajamaja_1_N = mkN "bajamaja" ; -- bajamaja..nn.1
  bajande_1_N = mkN "bajande" ; -- bajande..nn.1
  bajersk_1_A = mkA "bajersk" ; -- bajersk..av.1
  bajonett_1_N = mkN "bajonett" "bajonetter" ; -- bajonett..nn.1
  bajonettanfall_1_N = mkN "bajonettanfall" neutrum  ; -- bajonettanfall..nn.1
  bajonettbalja_1_N = mkN "bajonettbalja" ; -- bajonettbalja..nn.1
  bajonettfattning_1_N = mkN "bajonettfattning" ; -- bajonettfattning..nn.1
  bajonettförsedd_1_A = mkA "bajonettförsedd" ; -- bajonettförsedd..av.1
  bajonettspets_1_N = mkN "bajonettspets" ; -- bajonettspets..nn.1
  bajrare_1_N = mkN "bajrare" utrum  ; -- bajrare..nn.1
  bajs_1_N = mkN "bajs" neutrum  ; -- bajs..nn.1
  bajsa_1_V = mkV "bajsar" ; -- bajsa..vb.1
  bajsande_1_N = mkN "bajsande" ; -- bajsande..nn.1
  bajsbrun_1_A = mkA "bajsbrun" ; -- bajsbrun..av.1
  bajshög_1_N = mkN "bajshög" ; -- bajshög..nn.1
  bajsig_1_A = mkA "bajsig" ; -- bajsig..av.1
  bajskorv_1_N = mkN "bajskorv" ; -- bajskorv..nn.1
  bajsnödig_1_A = mkA "bajsnödig" ; -- bajsnödig..av.1
  bajstransplantat_1_N = mkN "bajstransplantat" neutrum  ; -- bajstransplantat..nn.1
  bajstransplantation_1_N = mkN "bajstransplantation" ; -- bajstransplantation..nn.1
  bak_1_N = mkN "bak" ; -- bak..nn.1
  bak_2_N = mkN "bak" neutrum  ; -- bak..nn.2
  baka_1_V = mkV "bakar" ; -- baka..vb.1
  bakande_1_N = mkN "bakande" ; -- bakande..nn.1
  bakarv_1_N = mkN "bakarv" neutrum  ; -- bakarv..nn.1
  bakarvinge_1_N = mkN "bakarvinge" utrum  ; -- bakarvinge..nn.1
  bakaxel_1_N = mkN "bakaxel" ; -- bakaxel..nn.1
  bakaxelväxel_1_N = mkN "bakaxelväxel" ; -- bakaxelväxel..nn.1
  bakben_1_N = mkN "bakben" neutrum  ; -- bakben..nn.1
  bakbinda_1_V = mkV "bakbinda" "bakband" "bakbundit" ; -- bakbinda..vb.1
  bakbindande_1_N = mkN "bakbindande" ; -- bakbindande..nn.1
  bakbindning_1_N = mkN "bakbindning" ; -- bakbindning..nn.1
  bakblåsare_1_N = mkN "bakblåsare" utrum  ; -- bakblåsare..nn.1
  bakdanta_1_V = mkV "bakdantar" ; -- bakdanta..vb.1
  bakdantande_1_N = mkN "bakdantande" ; -- bakdantande..nn.1
  bakdantare_1_N = mkN "bakdantare" utrum  ; -- bakdantare..nn.1
  bakdanteri_1_N = mkN "bakdanteri" neutrum  ; -- bakdanteri..nn.1
  bakdel_1_N = mkN "bakdel" "bakdelen" "bakdelar" "bakdelarna" ; -- bakdel..nn.1
  bakdäck_1_N = mkN "bakdäck" neutrum  ; -- bakdäck..nn.1
  bakdörr_1_N = mkN "bakdörr" ; -- bakdörr..nn.1
  bakelit_1_N = mkN "bakelit" ; -- bakelit..nn.1
  bakelse_1_N = mkN "bakelse" "bakelser" ; -- bakelse..nn.1
  bakerst_1_Adv = mkAdv "bakerst" ; -- bakerst..ab.1
  bakersta_1_A = mkA "bakersta" ; -- bakersta..av.1
  bakficka_1_N = mkN "bakficka" ; -- bakficka..nn.1
  bakflygel_1_N = mkN "bakflygel" ; -- bakflygel..nn.1
  bakfot_1_N = mkN "bakfot" "bakfötter" ; -- bakfot..nn.1
  bakfull_1_A = mkA "bakfull" ; -- bakfull..av.1
  bakfullhet_1_N = mkN "bakfullhet" ; -- bakfullhet..nn.1
  bakfylla_1_N = mkN "bakfylla" ; -- bakfylla..nn.1
  bakgata_1_N = mkN "bakgata" ; -- bakgata..nn.1
  bakgrund_1_N = mkN "bakgrund" "bakgrunder" ; -- bakgrund..nn.1
  bakgrundsfigur_1_N = mkN "bakgrundsfigur" "bakgrundsfigurer" ; -- bakgrundsfigur..nn.1
  bakgrundsljud_1_N = mkN "bakgrundsljud" neutrum  ; -- bakgrundsljud..nn.1
  bakgrundsmusik_1_N = mkN "bakgrundsmusik" ; -- bakgrundsmusik..nn.1
  bakgrundsreportage_1_N = mkN "bakgrundsreportage" "bakgrundsreportaget" "bakgrundsreportage" "bakgrundsreportagen" ; -- bakgrundsreportage..nn.1
  bakgrundsskildring_1_N = mkN "bakgrundsskildring" ; -- bakgrundsskildring..nn.1
  bakgrundssorl_1_N = mkN "bakgrundssorl" neutrum  ; -- bakgrundssorl..nn.1
  bakgrundsstrålning_1_N = mkN "bakgrundsstrålning" ; -- bakgrundsstrålning..nn.1
  bakgrundstal_1_N = mkN "bakgrundstal" neutrum  ; -- bakgrundstal..nn.1
  bakgrundston_1_N = mkN "bakgrundston" "bakgrundstoner" ; -- bakgrundston..nn.1
  bakgrundsvariabel_1_N = mkN "bakgrundsvariabel" "bakgrundsvariabeln" "bakgrundsvariabler" "bakgrundsvariablerna" ; -- bakgrundsvariabel..nn.1
  bakgård_1_N = mkN "bakgård" ; -- bakgård..nn.1
  bakhal_1_A = mkA "bakhal" ; -- bakhal..av.1
  bakhas_1_N = mkN "bakhas" ; -- bakhas..nn.1
  bakhjul_1_N = mkN "bakhjul" neutrum  ; -- bakhjul..nn.1
  bakhjulsdriven_1_A = mkA "bakhjulsdriven" ; -- bakhjulsdriven..av.1
  bakhov_1_N = mkN "bakhov" ; -- bakhov..nn.1
  bakhuvud_1_N = mkN "bakhuvud" "bakhuvudet" "bakhuvud" "bakhuvudena" ; -- bakhuvud..nn.1
  bakhåll_1_N = mkN "bakhåll" neutrum  ; -- bakhåll..nn.1
  baki_1_Adv = mkAdv "baki" ; -- baki..ab.1
  bakifrån_1_Adv = mkAdv "bakifrån" ; -- bakifrån..ab.1
  bakis_1_A = mkA "bakis" ; -- bakis..av.1
  bakjour_1_N = mkN "bakjour" "bakjourer" ; -- bakjour..nn.1
  bakkant_1_N = mkN "bakkant" "bakkanter" ; -- bakkant..nn.1
  bakkappa_1_N = mkN "bakkappa" ; -- bakkappa..nn.1
  bakkropp_1_N = mkN "bakkropp" ; -- bakkropp..nn.1
  bakladdare_1_N = mkN "bakladdare" utrum  ; -- bakladdare..nn.1
  bakladdning_1_N = mkN "bakladdning" ; -- bakladdning..nn.1
  baklampa_1_N = mkN "baklampa" ; -- baklampa..nn.1
  bakland_1_N = mkN "bakland" neutrum  ; -- bakland..nn.1
  bakljus_1_N = mkN "bakljus" neutrum  ; -- bakljus..nn.1
  bakljusramp_1_N = mkN "bakljusramp" "bakljusramper" ; -- bakljusramp..nn.1
  baklucka_1_N = mkN "baklucka" ; -- baklucka..nn.1
  baklukt_1_N = mkN "baklukt" ; -- baklukt..nn.1
  baklängesordbok_1_N = mkN "baklängesordbok" "baklängesordböcker" ; -- baklängesordbok..nn.1
  baklängesvandring_1_N = mkN "baklängesvandring" ; -- baklängesvandring..nn.1
  bakläxa_1_N = mkN "bakläxa" ; -- bakläxa..nn.1
  bakning_1_N = mkN "bakning" ; -- bakning..nn.1
  bakom_1_A = mkA "bakom" ; -- bakom..av.1
  bakomliggande_1_A = mkA "bakomliggande" ; -- bakomliggande..av.1
  bakomsittande_1_A = mkA "bakomsittande" ; -- bakomsittande..av.1
  bakomvarande_1_A = mkA "bakomvarande" ; -- bakomvarande..av.1
  bakplåt_1_N = mkN "bakplåt" ; -- bakplåt..nn.1
  bakplåtspapper_1_N = mkN "bakplåtspapper" neutrum  ; -- bakplåtspapper..nn.1
  bakport_1_N = mkN "bakport" ; -- bakport..nn.1
  bakprojektion_1_N = mkN "bakprojektion" ; -- bakprojektion..nn.1
  bakpulver_1_N = mkN "bakpulver" neutrum  ; -- bakpulver..nn.1
  bakpå_1_Adv = mkAdv "bakpå" ; -- bakpå..ab.1
  bakrus_1_N = mkN "bakrus" neutrum  ; -- bakrus..nn.1
  bakruta_1_N = mkN "bakruta" ; -- bakruta..nn.1
  baksida_1_N = mkN "baksida" ; -- baksida..nn.1
  baksidesreklam_1_N = mkN "baksidesreklam" ; -- baksidesreklam..nn.1
  baksidestext_1_N = mkN "baksidestext" "baksidestexter" ; -- baksidestext..nn.1
  bakslag_1_N = mkN "bakslag" neutrum  ; -- bakslag..nn.1
  bakslagsventil_1_N = mkN "bakslagsventil" "bakslagsventiler" ; -- bakslagsventil..nn.1
  bakslug_1_A = mkA "bakslug" ; -- bakslug..av.1
  bakslughet_1_N = mkN "bakslughet" ; -- bakslughet..nn.1
  baksmälla_1_N = mkN "baksmälla" ; -- baksmälla..nn.1
  bakspår_1_N = mkN "bakspår" neutrum  ; -- bakspår..nn.1
  baksteg_1_N = mkN "baksteg" neutrum  ; -- baksteg..nn.1
  bakstreck_1_N = mkN "bakstreck" neutrum  ; -- bakstreck..nn.1
  baksträvare_1_N = mkN "baksträvare" utrum  ; -- baksträvare..nn.1
  bakström_1_N = mkN "bakström" "bakströmmen" "bakströmmar" "bakströmmarna" ; -- bakström..nn.1
  bakstycke_1_N = mkN "bakstycke" ; -- bakstycke..nn.1
  baksäte_1_N = mkN "baksäte" ; -- baksäte..nn.1
  baktal_1_N = mkN "baktal" neutrum  ; -- baktal..nn.1
  baktala_1_V = mkV "baktalar" ; -- baktala..vb.1
  baktalande_1_N = mkN "baktalande" ; -- baktalande..nn.1
  baktalare_1_N = mkN "baktalare" utrum  ; -- baktalare..nn.1
  baktanke_1_N = mkN "baktanke" utrum  ; -- baktanke..nn.1
  baktass_1_N = mkN "baktass" ; -- baktass..nn.1
  baktericid_1_A = mkA "baktericid" ; -- baktericid..av.1
  baktericid_1_N = mkN "baktericid" "baktericider" ; -- baktericid..nn.1
  bakterie_1_N = mkN "bakterie" "bakterier" ; -- bakterie..nn.1
  bakterieart_1_N = mkN "bakterieart" "bakteriearter" ; -- bakterieart..nn.1
  bakteriedödande_1_A = mkA "bakteriedödande" ; -- bakteriedödande..av.1
  bakterieflora_1_N = mkN "bakterieflora" ; -- bakterieflora..nn.1
  bakteriefri_1_A = mkA "bakteriefri" "bakteriefritt" ; -- bakteriefri..av.1
  bakteriehärd_1_N = mkN "bakteriehärd" ; -- bakteriehärd..nn.1
  bakterieinfektion_1_N = mkN "bakterieinfektion" ; -- bakterieinfektion..nn.1
  bakteriekultur_1_N = mkN "bakteriekultur" "bakteriekulturer" ; -- bakteriekultur..nn.1
  bakteriell_1_A = mkA "bakteriell" ; -- bakteriell..av.1
  bakteriesmittad_1_A = mkA "bakteriesmittad" ; -- bakteriesmittad..av.1
  bakteriofag_1_N = mkN "bakteriofag" "bakteriofager" ; -- bakteriofag..nn.1
  bakteriolog_1_N = mkN "bakteriolog" "bakteriologer" ; -- bakteriolog..nn.1
  bakteriologi_1_N = mkN "bakteriologi" ; -- bakteriologi..nn.1
  bakteriologisk_1_A = mkA "bakteriologisk" ; -- bakteriologisk..av.1
  baktill_1_Adv = mkAdv "baktill" ; -- baktill..ab.1
  baktrappa_1_N = mkN "baktrappa" ; -- baktrappa..nn.1
  baktung_1_A = mkA "baktung" ; -- baktung..av.1
  baktunghet_1_N = mkN "baktunghet" ; -- baktunghet..nn.1
  bakugn_1_N = mkN "bakugn" ; -- bakugn..nn.1
  bakut_1_Adv = mkAdv "bakut" ; -- bakut..ab.1
  bakvagn_1_N = mkN "bakvagn" ; -- bakvagn..nn.1
  bakvatten_1_N = mkN "bakvatten" "bakvattnet" "bakvatten" "bakvattnen" ; -- bakvatten..nn.1
  bakverk_1_N = mkN "bakverk" neutrum  ; -- bakverk..nn.1
  bakvid_1_Adv = mkAdv "bakvid" ; -- bakvid..ab.1
  bakvikt_1_N = mkN "bakvikt" "bakvikter" ; -- bakvikt..nn.1
  bakvinge_1_N = mkN "bakvinge" utrum  ; -- bakvinge..nn.1
  bakväg_1_N = mkN "bakväg" ; -- bakväg..nn.1
  bakvägg_1_N = mkN "bakvägg" ; -- bakvägg..nn.1
  bakvänd_1_A = mkA "bakvänd" ; -- bakvänd..av.1
  bakvändhet_1_N = mkN "bakvändhet" ; -- bakvändhet..nn.1
  bakända_1_N = mkN "bakända" ; -- bakända..nn.1
  bakände_1_N = mkN "bakände" utrum  ; -- bakände..nn.1
  bakåtblickande_1_A = mkA "bakåtblickande" ; -- bakåtblickande..av.1
  bakåtkammad_1_A = mkA "bakåtkammad" ; -- bakåtkammad..av.1
  bakåtlutad_1_A = mkA "bakåtlutad" ; -- bakåtlutad..av.1
  bakåtriktad_1_A = mkA "bakåtriktad" ; -- bakåtriktad..av.1
  bakåträknande_1_A = mkA "bakåträknande" ; -- bakåträknande..av.1
  bakåtsteg_1_N = mkN "bakåtsteg" neutrum  ; -- bakåtsteg..nn.1
  bakåtsträvande_1_A = mkA "bakåtsträvande" ; -- bakåtsträvande..av.1
  bakåtsträvare_1_N = mkN "bakåtsträvare" utrum  ; -- bakåtsträvare..nn.1
  baköver_1_Adv = mkAdv "baköver" ; -- baköver..ab.1
  bal_1_N = mkN "bal" ; -- bal..nn.1
  bal_2_N = mkN "bal" "baler" ; -- bal..nn.2
  bala_1_V = mkV "balar" ; -- bala..vb.1
  balaclava_1_N = mkN "balaclava" ; -- balaclava..nn.1
  balaklava_1_N = mkN "balaklava" ; -- balaklava..nn.1
  balalajka_1_N = mkN "balalajka" ; -- balalajka..nn.1
  balalajkaspelare_1_N = mkN "balalajkaspelare" utrum  ; -- balalajkaspelare..nn.1
  balande_1_N = mkN "balande" ; -- balande..nn.1
  balans_1_N = mkN "balans" "balanser" ; -- balans..nn.1
  balans_2_N = mkN "balans" ; -- balans..nn.2
  balansakt_1_N = mkN "balansakt" "balansakter" ; -- balansakt..nn.1
  balansera_1_V = mkV "balanserar" ; -- balansera..vb.1
  balansera_2_V = mkV "balanserar" ; -- balansera..vb.2
  balanserad_1_A = mkA "balanserad" ; -- balanserad..av.1
  balanserande_1_N = mkN "balanserande" ; -- balanserande..nn.1
  balanserbar_1_A = mkA "balanserbar" ; -- balanserbar..av.1
  balanserbarhet_1_N = mkN "balanserbarhet" ; -- balanserbarhet..nn.1
  balansering_1_N = mkN "balansering" ; -- balansering..nn.1
  balanserstång_1_N = mkN "balanserstång" "balanserstänger" ; -- balanserstång..nn.1
  balansgång_1_N = mkN "balansgång" ; -- balansgång..nn.1
  balanshjul_1_N = mkN "balanshjul" neutrum  ; -- balanshjul..nn.1
  balanskonstnär_1_N = mkN "balanskonstnär" "balanskonstnärer" ; -- balanskonstnär..nn.1
  balanskonto_1_N = mkN "balanskonto" "balanskontot" "balanskonton" "balanskontona" ; -- balanskonto..nn.1
  balansnummer_1_N = mkN "balansnummer" neutrum  ; -- balansnummer..nn.1
  balansorgan_1_N = mkN "balansorgan" neutrum  ; -- balansorgan..nn.1
  balansplog_1_N = mkN "balansplog" ; -- balansplog..nn.1
  balansroder_1_N = mkN "balansroder" neutrum  ; -- balansroder..nn.1
  balansrubbning_1_N = mkN "balansrubbning" ; -- balansrubbning..nn.1
  balansräkning_1_N = mkN "balansräkning" ; -- balansräkning..nn.1
  balanssinne_1_N = mkN "balanssinne" ; -- balanssinne..nn.1
  balansvåg_1_N = mkN "balansvåg" ; -- balansvåg..nn.1
  balata_1_N = mkN "balata" ; -- balata..nn.1
  baldakin_1_N = mkN "baldakin" "baldakiner" ; -- baldakin..nn.1
  baldersbrå_1_N = mkN "baldersbrå" "baldersbråt" "baldersbrån" "baldersbråna" ; -- baldersbrå..nn.1
  baldrottning_1_N = mkN "baldrottning" ; -- baldrottning..nn.1
  bale_1_N = mkN "bale" utrum  ; -- bale..nn.1
  balett_1_N = mkN "balett" "baletter" ; -- balett..nn.1
  balettdans_1_N = mkN "balettdans" "balettdanser" ; -- balettdans..nn.1
  balettdansör_1_N = mkN "balettdansör" "balettdansörer" ; -- balettdansör..nn.1
  balettdansös_1_N = mkN "balettdansös" "balettdansöser" ; -- balettdansös..nn.1
  balettflicka_1_N = mkN "balettflicka" ; -- balettflicka..nn.1
  balettmästare_1_N = mkN "balettmästare" utrum  ; -- balettmästare..nn.1
  balgäst_1_N = mkN "balgäst" "balgäster" ; -- balgäst..nn.1
  balinesisk_1_A = mkA "balinesisk" ; -- balinesisk..av.1
  balja_1_N = mkN "balja" ; -- balja..nn.1
  baljväxt_1_N = mkN "baljväxt" "baljväxter" ; -- baljväxt..nn.1
  balk_1_N = mkN "balk" ; -- balk..nn.1
  balkanfolk_1_N = mkN "balkanfolk" neutrum  ; -- balkanfolk..nn.1
  balkaniserad_1_A = mkA "balkaniserad" ; -- balkaniserad..av.1
  balkanisering_1_N = mkN "balkanisering" ; -- balkanisering..nn.1
  balkansk_1_A = mkA "balkansk" ; -- balkansk..av.1
  balkknä_1_N = mkN "balkknä" "balkknät" "balkknän" "balkknäna" ; -- balkknä..nn.1
  balklänning_1_N = mkN "balklänning" ; -- balklänning..nn.1
  balkmått_1_N = mkN "balkmått" neutrum  ; -- balkmått..nn.1
  balkong_1_N = mkN "balkong" "balkonger" ; -- balkong..nn.1
  balkongdörr_1_N = mkN "balkongdörr" ; -- balkongdörr..nn.1
  balkonglåda_1_N = mkN "balkonglåda" ; -- balkonglåda..nn.1
  balkongräcke_1_N = mkN "balkongräcke" ; -- balkongräcke..nn.1
  balksko_1_N = mkN "balksko" "balkskor" ; -- balksko..nn.1
  balkverk_1_N = mkN "balkverk" neutrum  ; -- balkverk..nn.1
  balkvägare_1_N = mkN "balkvägare" utrum  ; -- balkvägare..nn.1
  ball_1_A = mkA "ball" ; -- ball..av.1
  ballad_1_N = mkN "ballad" "ballader" ; -- ballad..nn.1
  balladdiktning_1_N = mkN "balladdiktning" ; -- balladdiktning..nn.1
  ballast_1_N = mkN "ballast" "ballaster" ; -- ballast..nn.1
  balle_1_N = mkN "balle" utrum  ; -- balle..nn.1
  ballerina_1_N = mkN "ballerina" ; -- ballerina..nn.1
  ballhet_1_N = mkN "ballhet" ; -- ballhet..nn.1
  ballistik_1_N = mkN "ballistik" ; -- ballistik..nn.1
  ballistisk_1_A = mkA "ballistisk" ; -- ballistisk..av.1
  ballograf_1_N = mkN "ballograf" "ballografer" ; -- ballograf..nn.1
  ballong_1_N = mkN "ballong" "ballonger" ; -- ballong..nn.1
  ballongbluff_1_N = mkN "ballongbluff" ; -- ballongbluff..nn.1
  ballongboll_1_N = mkN "ballongboll" ; -- ballongboll..nn.1
  ballongburen_1_A = mkA "ballongburen" ; -- ballongburen..av.1
  ballongdäck_1_N = mkN "ballongdäck" neutrum  ; -- ballongdäck..nn.1
  ballongfamilj_1_N = mkN "ballongfamilj" "ballongfamiljer" ; -- ballongfamilj..nn.1
  ballongfärd_1_N = mkN "ballongfärd" "ballongfärder" ; -- ballongfärd..nn.1
  ballonggas_1_N = mkN "ballonggas" "ballonggaser" ; -- ballonggas..nn.1
  ballonggondol_1_N = mkN "ballonggondol" "ballonggondoler" ; -- ballonggondol..nn.1
  ballongmage_1_N = mkN "ballongmage" utrum  ; -- ballongmage..nn.1
  ballongpojke_1_N = mkN "ballongpojke" utrum  ; -- ballongpojke..nn.1
  ballongprick_1_N = mkN "ballongprick" ; -- ballongprick..nn.1
  ballongsegel_1_N = mkN "ballongsegel" neutrum  ; -- ballongsegel..nn.1
  ballongvisp_1_N = mkN "ballongvisp" ; -- ballongvisp..nn.1
  balloptikon_1_N = mkN "balloptikon" neutrum  ; -- balloptikon..nn.1
  ballotera_1_V = mkV "balloterar" ; -- ballotera..vb.1
  balloterande_1_N = mkN "balloterande" ; -- balloterande..nn.1
  balloterbar_1_A = mkA "balloterbar" ; -- balloterbar..av.1
  balloterbarhet_1_N = mkN "balloterbarhet" ; -- balloterbarhet..nn.1
  ballotering_1_N = mkN "ballotering" ; -- ballotering..nn.1
  balneolog_1_N = mkN "balneolog" "balneologer" ; -- balneolog..nn.1
  balneologi_1_N = mkN "balneologi" ; -- balneologi..nn.1
  balneologisk_1_A = mkA "balneologisk" ; -- balneologisk..av.1
  balsa_1_N = mkN "balsa" ; -- balsa..nn.1
  balsal_1_N = mkN "balsal" ; -- balsal..nn.1
  balsam_1_N = mkN "balsam" "balsamer" ; -- balsam..nn.1
  balsamdoftande_1_A = mkA "balsamdoftande" ; -- balsamdoftande..av.1
  balsamera_1_V = mkV "balsamerar" ; -- balsamera..vb.1
  balsamerande_1_N = mkN "balsamerande" ; -- balsamerande..nn.1
  balsamerbar_1_A = mkA "balsamerbar" ; -- balsamerbar..av.1
  balsamerbarhet_1_N = mkN "balsamerbarhet" ; -- balsamerbarhet..nn.1
  balsamering_1_N = mkN "balsamering" ; -- balsamering..nn.1
  balsamin_1_N = mkN "balsamin" "balsaminer" ; -- balsamin..nn.1
  balsamisk_1_A = mkA "balsamisk" ; -- balsamisk..av.1
  balsamterpentin_1_N = mkN "balsamterpentin" "balsamterpentiner" ; -- balsamterpentin..nn.1
  balsaträ_1_N = mkN "balsaträ" neutrum  ; -- balsaträ..nn.1
  balt_1_N = mkN "balt" "balter" ; -- balt..nn.1
  baltisk_1_A = mkA "baltisk" ; -- baltisk..av.1
  baltiska_1_N = mkN "baltiska" ; -- baltiska..nn.1
  baltutlämning_1_N = mkN "baltutlämning" ; -- baltutlämning..nn.1
  baluns_1_N = mkN "baluns" "balunser" ; -- baluns..nn.1
  baluster_1_N = mkN "baluster" ; -- baluster..nn.1
  balustrad_1_N = mkN "balustrad" "balustrader" ; -- balustrad..nn.1
  bamba_1_N = mkN "bamba" ; -- bamba..nn.1
  bambu_1_N = mkN "bambu" ; -- bambu..nn.1
  bamburör_1_N = mkN "bamburör" neutrum  ; -- bamburör..nn.1
  bambusoffa_1_N = mkN "bambusoffa" ; -- bambusoffa..nn.1
  ban_1_N = mkN "ban" ; -- ban..nn.1
  ban_2_N = mkN "ban" "baner" ; -- ban..nn.2
  bana_1_N = mkN "bana" ; -- bana..nn.1
  banal_1_A = mkA "banal" ; -- banal..av.1
  banalisera_1_V = mkV "banaliserar" ; -- banalisera..vb.1
  banaliserande_1_N = mkN "banaliserande" ; -- banaliserande..nn.1
  banaliserbar_1_A = mkA "banaliserbar" ; -- banaliserbar..av.1
  banaliserbarhet_1_N = mkN "banaliserbarhet" ; -- banaliserbarhet..nn.1
  banalisering_1_N = mkN "banalisering" ; -- banalisering..nn.1
  banalitet_1_N = mkN "banalitet" "banaliteter" ; -- banalitet..nn.1
  banan_1_N = mkN "banan" "bananer" ; -- banan..nn.1
  bananbana_1_N = mkN "bananbana" ; -- bananbana..nn.1
  bananfluga_1_N = mkN "bananfluga" ; -- bananfluga..nn.1
  bananformad_1_A = mkA "bananformad" ; -- bananformad..av.1
  banankontakt_1_N = mkN "banankontakt" "banankontakter" ; -- banankontakt..nn.1
  bananrepublik_1_N = mkN "bananrepublik" "bananrepubliker" ; -- bananrepublik..nn.1
  bananstock_1_N = mkN "bananstock" ; -- bananstock..nn.1
  bananträd_1_N = mkN "bananträd" neutrum  ; -- bananträd..nn.1
  banarbete_1_N = mkN "banarbete" ; -- banarbete..nn.1
  banbrytande_1_A = mkA "banbrytande" ; -- banbrytande..av.1
  banbrytare_1_N = mkN "banbrytare" utrum  ; -- banbrytare..nn.1
  banco_1_N = mkN "banco" ; -- banco..nn.1
  band_1_N = mkN "band" neutrum  ; -- band..nn.1
  banda_1_V = mkV "bandar" ; -- banda..vb.1
  bandage_1_N = mkN "bandage" "bandaget" "bandage" "bandagen" ; -- bandage..nn.1
  bandande_1_N = mkN "bandande" ; -- bandande..nn.1
  bandel_1_N = mkN "bandel" "bandelen" "bandelar" "bandelarna" ; -- bandel..nn.1
  banderol_1_N = mkN "banderol" "banderoler" ; -- banderol..nn.1
  banderoll_1_N = mkN "banderoll" "banderoller" ; -- banderoll..nn.1
  bandfordon_1_N = mkN "bandfordon" neutrum  ; -- bandfordon..nn.1
  bandformig_1_A = mkA "bandformig" ; -- bandformig..av.1
  bandgenerator_1_N = mkN "bandgenerator" "bandgeneratorer" ; -- bandgenerator..nn.1
  bandhund_1_N = mkN "bandhund" ; -- bandhund..nn.1
  bandit_1_N = mkN "bandit" "banditer" ; -- bandit..nn.1
  banditaktig_1_A = mkA "banditaktig" ; -- banditaktig..av.1
  banditgäng_1_N = mkN "banditgäng" neutrum  ; -- banditgäng..nn.1
  bandjärn_1_N = mkN "bandjärn" neutrum  ; -- bandjärn..nn.1
  bandkantning_1_N = mkN "bandkantning" ; -- bandkantning..nn.1
  bandkniv_1_N = mkN "bandkniv" ; -- bandkniv..nn.1
  bandmedlem_1_N = mkN "bandmedlem" "bandmedlemmen" "bandmedlemmar" "bandmedlemmarna" ; -- bandmedlem..nn.1
  bandolär_1_N = mkN "bandolär" neutrum  ; -- bandolär..nn.1
  bandotek_1_N = mkN "bandotek" neutrum  ; -- bandotek..nn.1
  bandspektrum_1_N = mkN "bandspektrum" neutrum  ; -- bandspektrum..nn.1
  bandspelare_1_N = mkN "bandspelare" utrum  ; -- bandspelare..nn.1
  bandstation_1_N = mkN "bandstation" ; -- bandstation..nn.1
  bandstump_1_N = mkN "bandstump" ; -- bandstump..nn.1
  bandsåg_1_N = mkN "bandsåg" ; -- bandsåg..nn.1
  bandtraktor_1_N = mkN "bandtraktor" "bandtraktorer" ; -- bandtraktor..nn.1
  bandupptagning_1_N = mkN "bandupptagning" ; -- bandupptagning..nn.1
  bandvimpel_1_N = mkN "bandvimpel" ; -- bandvimpel..nn.1
  bandyboll_1_N = mkN "bandyboll" ; -- bandyboll..nn.1
  bandyfanatiker_1_N = mkN "bandyfanatiker" "bandyfanatikern" "bandyfanatiker" "bandyfanatikerna" ; -- bandyfanatiker..nn.1
  bandyklubba_1_N = mkN "bandyklubba" ; -- bandyklubba..nn.1
  bandyrör_1_N = mkN "bandyrör" neutrum  ; -- bandyrör..nn.1
  bandyslag_1_N = mkN "bandyslag" neutrum  ; -- bandyslag..nn.1
  bane_1_N = mkN "bane" ; -- bane..nn.1
  banehugg_1_N = mkN "banehugg" neutrum  ; -- banehugg..nn.1
  baneman_1_N = mkN "baneman" "banemannen" "banemän" "banemännen" ; -- baneman..nn.1
  baner_1_N = mkN "baner" "baneret" "baner" "baneren" ; -- baner..nn.1
  banerförare_1_N = mkN "banerförare" utrum  ; -- banerförare..nn.1
  banesår_1_N = mkN "banesår" neutrum  ; -- banesår..nn.1
  bang_1_A = mkA "bang" ; -- bang..av.1
  bang_1_N = mkN "bang" ; -- bang..nn.1
  banghet_1_N = mkN "banghet" ; -- banghet..nn.1
  bangladeshare_1_N = mkN "bangladeshare" utrum  ; -- bangladeshare..nn.1
  bangladeshier_1_N = mkN "bangladeshier" "bangladeshiern" "bangladeshier" "bangladeshierna" ; -- bangladeshier..nn.1
  bangladeshisk_1_A = mkA "bangladeshisk" ; -- bangladeshisk..av.1
  bangladeshiska_1_N = mkN "bangladeshiska" ; -- bangladeshiska..nn.1
  bangolf_1_N = mkN "bangolf" ; -- bangolf..nn.1
  bangård_1_N = mkN "bangård" ; -- bangård..nn.1
  banhall_1_N = mkN "banhall" ; -- banhall..nn.1
  baning_1_N = mkN "baning" ; -- baning..nn.1
  banjo_1_N = mkN "banjo" "banjor" ; -- banjo..nn.1
  banjoinstrument_1_N = mkN "banjoinstrument" neutrum  ; -- banjoinstrument..nn.1
  bank_1_N = mkN "bank" ; -- bank..nn.1
  bank_2_N = mkN "bank" "banker" ; -- bank..nn.2
  banka_1_V = mkV "bankar" ; -- banka..vb.1
  bankande_1_N = mkN "bankande" ; -- bankande..nn.1
  bankanställd_1_A = mkA "bankanställd" "bankanställt" ; -- bankanställd..av.1
  bankbok_1_N = mkN "bankbok" "bankböcker" ; -- bankbok..nn.1
  bankdirektion_1_N = mkN "bankdirektion" ; -- bankdirektion..nn.1
  bankdirektör_1_N = mkN "bankdirektör" "bankdirektörer" ; -- bankdirektör..nn.1
  bankett_1_N = mkN "bankett" "banketter" ; -- bankett..nn.1
  bankfack_1_N = mkN "bankfack" neutrum  ; -- bankfack..nn.1
  bankföretag_1_N = mkN "bankföretag" neutrum  ; -- bankföretag..nn.1
  bankgiro_1_N = mkN "bankgiro" "bankgirot" "bankgiron" "bankgirona" ; -- bankgiro..nn.1
  bankhus_1_N = mkN "bankhus" neutrum  ; -- bankhus..nn.1
  bankinrättning_1_N = mkN "bankinrättning" ; -- bankinrättning..nn.1
  bankinspektion_1_N = mkN "bankinspektion" ; -- bankinspektion..nn.1
  bankir_1_N = mkN "bankir" "bankirer" ; -- bankir..nn.1
  bankirfirma_1_N = mkN "bankirfirma" ; -- bankirfirma..nn.1
  bankirhustru_1_N = mkN "bankirhustru" "bankirhustrun" "bankirhustrur" "bankirhustrurna" ; -- bankirhustru..nn.1
  bankkamrer_1_N = mkN "bankkamrer" "bankkamrerer" ; -- bankkamrer..nn.1
  bankkapital_1_N = mkN "bankkapital" neutrum  ; -- bankkapital..nn.1
  bankkassör_1_N = mkN "bankkassör" "bankkassörer" ; -- bankkassör..nn.1
  bankkollaps_1_N = mkN "bankkollaps" "bankkollapser" ; -- bankkollaps..nn.1
  bankkonto_1_N = mkN "bankkonto" "bankkontot" "bankkonton" "bankkontona" ; -- bankkonto..nn.1
  bankkontor_1_N = mkN "bankkontor" neutrum  ; -- bankkontor..nn.1
  bankkort_1_N = mkN "bankkort" neutrum  ; -- bankkort..nn.1
  bankkund_1_N = mkN "bankkund" "bankkunder" ; -- bankkund..nn.1
  banklag_1_N = mkN "banklag" ; -- banklag..nn.1
  banklån_1_N = mkN "banklån" neutrum  ; -- banklån..nn.1
  bankman_1_N = mkN "bankman" "bankmannen" "bankmän" "bankmännen" ; -- bankman..nn.1
  bankmässig_1_A = mkA "bankmässig" ; -- bankmässig..av.1
  banknisse_1_N = mkN "banknisse" utrum  ; -- banknisse..nn.1
  banko_1_N = mkN "banko" ; -- banko..nn.1
  bankofullmäktig_1_N = mkN "bankofullmäktig" "bankofullmäktigen" "bankofullmäktige" "bankofullmäktigena" ; -- bankofullmäktig..nn.1
  bankomat_1_N = mkN "bankomat" "bankomater" ; -- bankomat..nn.1
  bankomatkort_1_N = mkN "bankomatkort" neutrum  ; -- bankomatkort..nn.1
  bankomatkupp_1_N = mkN "bankomatkupp" "bankomatkupper" ; -- bankomatkupp..nn.1
  bankomatrånare_1_N = mkN "bankomatrånare" utrum  ; -- bankomatrånare..nn.1
  bankpalats_1_N = mkN "bankpalats" neutrum  ; -- bankpalats..nn.1
  bankpanik_1_N = mkN "bankpanik" ; -- bankpanik..nn.1
  bankreglering_1_N = mkN "bankreglering" ; -- bankreglering..nn.1
  bankrutt_1_A = mkA "bankrutt" ; -- bankrutt..av.1
  bankrutt_1_N = mkN "bankrutt" "bankrutter" ; -- bankrutt..nn.1
  bankruttera_1_V = mkV "bankrutterar" ; -- bankruttera..vb.1
  bankrutterande_1_N = mkN "bankrutterande" ; -- bankrutterande..nn.1
  bankrutterbar_1_A = mkA "bankrutterbar" ; -- bankrutterbar..av.1
  bankrutterbarhet_1_N = mkN "bankrutterbarhet" ; -- bankrutterbarhet..nn.1
  bankruttering_1_N = mkN "bankruttering" ; -- bankruttering..nn.1
  bankruttförklaring_1_N = mkN "bankruttförklaring" ; -- bankruttförklaring..nn.1
  bankruttmässig_1_A = mkA "bankruttmässig" ; -- bankruttmässig..av.1
  bankruttör_1_N = mkN "bankruttör" "bankruttörer" ; -- bankruttör..nn.1
  bankränta_1_N = mkN "bankränta" ; -- bankränta..nn.1
  bankrån_1_N = mkN "bankrån" neutrum  ; -- bankrån..nn.1
  bankrånare_1_N = mkN "bankrånare" utrum  ; -- bankrånare..nn.1
  bankrörelse_1_N = mkN "bankrörelse" "bankrörelser" ; -- bankrörelse..nn.1
  banksektor_1_N = mkN "banksektor" "banksektorer" ; -- banksektor..nn.1
  banksparande_1_N = mkN "banksparande" ; -- banksparande..nn.1
  bankstyrelse_1_N = mkN "bankstyrelse" "bankstyrelser" ; -- bankstyrelse..nn.1
  banktjänsteman_1_N = mkN "banktjänsteman" "banktjänstemannen" "banktjänstemän" "banktjänstemännen" ; -- banktjänsteman..nn.1
  bankväsen_1_N = mkN "bankväsen" neutrum  ; -- bankväsen..nn.1
  bankväxel_1_N = mkN "bankväxel" ; -- bankväxel..nn.1
  banlöpning_1_N = mkN "banlöpning" ; -- banlöpning..nn.1
  bann_1_N = mkN "bann" neutrum  ; -- bann..nn.1
  banna_1_V = mkV "bannar" ; -- banna..vb.1
  bannande_1_N = mkN "bannande" ; -- bannande..nn.1
  bannbulla_1_N = mkN "bannbulla" ; -- bannbulla..nn.1
  bannlysa_1_V = mkV "bannlyser" ; -- bannlysa..vb.1
  bannlysande_1_N = mkN "bannlysande" ; -- bannlysande..nn.1
  bannlysning_1_N = mkN "bannlysning" ; -- bannlysning..nn.1
  bannstråle_1_N = mkN "bannstråle" utrum  ; -- bannstråle..nn.1
  bannät_1_N = mkN "bannät" neutrum  ; -- bannät..nn.1
  banrekord_1_N = mkN "banrekord" neutrum  ; -- banrekord..nn.1
  banrörelse_1_N = mkN "banrörelse" "banrörelser" ; -- banrörelse..nn.1
  banskjutning_1_N = mkN "banskjutning" ; -- banskjutning..nn.1
  banskytte_1_N = mkN "banskytte" ; -- banskytte..nn.1
  banta_1_V = mkV "bantar" ; -- banta..vb.1
  banta_2_V = mkV "bantar" ; -- banta..vb.2
  bantamvikt_1_N = mkN "bantamvikt" ; -- bantamvikt..nn.1
  bantamviktare_1_N = mkN "bantamviktare" utrum  ; -- bantamviktare..nn.1
  bantande_1_N = mkN "bantande" ; -- bantande..nn.1
  bantlär_1_N = mkN "bantlär" neutrum  ; -- bantlär..nn.1
  bantning_1_N = mkN "bantning" ; -- bantning..nn.1
  bantningshysteri_1_N = mkN "bantningshysteri" ; -- bantningshysteri..nn.1
  bantningskur_1_N = mkN "bantningskur" "bantningskurer" ; -- bantningskur..nn.1
  bantningsmedel_1_N = mkN "bantningsmedel" neutrum  ; -- bantningsmedel..nn.1
  bantningspiller_1_N = mkN "bantningspiller" neutrum  ; -- bantningspiller..nn.1
  bantufolk_1_N = mkN "bantufolk" neutrum  ; -- bantufolk..nn.1
  bantuspråk_1_N = mkN "bantuspråk" neutrum  ; -- bantuspråk..nn.1
  banunderhåll_1_N = mkN "banunderhåll" neutrum  ; -- banunderhåll..nn.1
  banvagn_1_N = mkN "banvagn" ; -- banvagn..nn.1
  banvakt_1_N = mkN "banvakt" "banvakter" ; -- banvakt..nn.1
  banvall_1_N = mkN "banvall" ; -- banvall..nn.1
  banverk_1_N = mkN "banverk" neutrum  ; -- banverk..nn.1
  banverkspersonal_1_N = mkN "banverkspersonal" ; -- banverkspersonal..nn.1
  baptism_1_N = mkN "baptism" "baptismer" ; -- baptism..nn.1
  baptist_1_N = mkN "baptist" "baptister" ; -- baptist..nn.1
  baptistdop_1_N = mkN "baptistdop" neutrum  ; -- baptistdop..nn.1
  baptisterium_1_N = mkN "baptisterium" "baptisteriet" "baptisterier" "baptisterierna" ; -- baptisterium..nn.1
  baptistisk_1_A = mkA "baptistisk" ; -- baptistisk..av.1
  baptistpastor_1_N = mkN "baptistpastor" "baptistpastorer" ; -- baptistpastor..nn.1
  baptistpredikant_1_N = mkN "baptistpredikant" "baptistpredikanter" ; -- baptistpredikant..nn.1
  bar_1_A = mkA "bar" ; -- bar..av.1
  bar_1_N = mkN "bar" "barer" ; -- bar..nn.1
  bar_2_N = mkN "bar" "baren" "bar" "baren" ; -- bar..nn.2
  bara_1_Adv = mkAdv "bara" ; -- bara..ab.1
  barack_1_N = mkN "barack" "baracker" ; -- barack..nn.1
  barackläger_1_N = mkN "barackläger" neutrum  ; -- barackläger..nn.1
  bararmad_1_A = mkA "bararmad" ; -- bararmad..av.1
  baraxlad_1_A = mkA "baraxlad" ; -- baraxlad..av.1
  barbadier_1_N = mkN "barbadier" "barbadiern" "barbadier" "barbadierna" ; -- barbadier..nn.1
  barbadisk_1_A = mkA "barbadisk" ; -- barbadisk..av.1
  barbadiska_1_N = mkN "barbadiska" ; -- barbadiska..nn.1
  barbar_1_N = mkN "barbar" "barbarer" ; -- barbar..nn.1
  barbarhövding_1_N = mkN "barbarhövding" ; -- barbarhövding..nn.1
  barbari_1_N = mkN "barbari" neutrum  ; -- barbari..nn.1
  barbarisk_1_A = mkA "barbarisk" ; -- barbarisk..av.1
  barbarism_1_N = mkN "barbarism" "barbarismer" ; -- barbarism..nn.1
  barbent_1_A = mkA "barbent" "barbent" ; -- barbent..av.1
  barberare_1_N = mkN "barberare" utrum  ; -- barberare..nn.1
  barberarstol_1_N = mkN "barberarstol" ; -- barberarstol..nn.1
  barbiturat_1_N = mkN "barbiturat" neutrum  ; -- barbiturat..nn.1
  barbröstad_1_A = mkA "barbröstad" ; -- barbröstad..av.1
  bard_1_N = mkN "bard" "barder" ; -- bard..nn.1
  bardisan_1_N = mkN "bardisan" "bardisaner" ; -- bardisan..nn.1
  bardisk_1_N = mkN "bardisk" ; -- bardisk..nn.1
  bardun_1_N = mkN "bardun" "barduner" ; -- bardun..nn.1
  bardval_1_N = mkN "bardval" ; -- bardval..nn.1
  barett_1_N = mkN "barett" "baretter" ; -- barett..nn.1
  barfota_1_A = mkA "barfota" ; -- barfota..av.1
  barfotad_1_A = mkA "barfotad" ; -- barfotad..av.1
  barfotalasse_1_N = mkN "barfotalasse" utrum  ; -- barfotalasse..nn.1
  barfotaläkare_1_N = mkN "barfotaläkare" utrum  ; -- barfotaläkare..nn.1
  barfotalöpning_1_N = mkN "barfotalöpning" ; -- barfotalöpning..nn.1
  barfotamunk_1_N = mkN "barfotamunk" ; -- barfotamunk..nn.1
  barfrost_1_N = mkN "barfrost" ; -- barfrost..nn.1
  barhet_1_N = mkN "barhet" ; -- barhet..nn.1
  barhuvad_1_A = mkA "barhuvad" ; -- barhuvad..av.1
  barhänt_1_A = mkA "barhänt" "barhänt" ; -- barhänt..av.1
  bariton_1_N = mkN "bariton" "baritoner" ; -- bariton..nn.1
  barium_1_N = mkN "barium" neutrum  ; -- barium..nn.1
  bariumförening_1_N = mkN "bariumförening" ; -- bariumförening..nn.1
  bariumsalt_1_N = mkN "bariumsalt" "bariumsaltet" "bariumsalter" "bariumsalterna" ; -- bariumsalt..nn.1
  bariumsulfat_1_N = mkN "bariumsulfat" neutrum  ; -- bariumsulfat..nn.1
  bark_1_N = mkN "bark" "barker" ; -- bark..nn.1
  bark_2_N = mkN "bark" ; -- bark..nn.2
  barka_1_V = mkV "barkar" ; -- barka..vb.1
  barka_2_V = mkV "barkar" ; -- barka..vb.2
  barkande_1_N = mkN "barkande" ; -- barkande..nn.1
  barkaroll_1_N = mkN "barkaroll" "barkaroller" ; -- barkaroll..nn.1
  barkass_1_N = mkN "barkass" "barkasser" ; -- barkass..nn.1
  barkborre_1_N = mkN "barkborre" utrum  ; -- barkborre..nn.1
  barkbröd_1_N = mkN "barkbröd" neutrum  ; -- barkbröd..nn.1
  barkbåt_1_N = mkN "barkbåt" ; -- barkbåt..nn.1
  barkis_1_N = mkN "barkis" ; -- barkis..nn.1
  barklag_1_N = mkN "barklag" ; -- barklag..nn.1
  barkskepp_1_N = mkN "barkskepp" neutrum  ; -- barkskepp..nn.1
  barkspade_1_N = mkN "barkspade" utrum  ; -- barkspade..nn.1
  barktäkt_1_N = mkN "barktäkt" "barktäkter" ; -- barktäkt..nn.1
  barkund_1_N = mkN "barkund" "barkunder" ; -- barkund..nn.1
  barkympa_1_V = mkV "barkympar" ; -- barkympa..vb.1
  barkympande_1_N = mkN "barkympande" ; -- barkympande..nn.1
  barlast_1_N = mkN "barlast" "barlaster" ; -- barlast..nn.1
  barlasta_1_V = mkV "barlastar" ; -- barlasta..vb.1
  barlastande_1_N = mkN "barlastande" ; -- barlastande..nn.1
  barlastköl_1_N = mkN "barlastköl" ; -- barlastköl..nn.1
  barlastning_1_N = mkN "barlastning" ; -- barlastning..nn.1
  barm_1_N = mkN "barm" ; -- barm..nn.1
  barmark_1_N = mkN "barmark" "barmarker" ; -- barmark..nn.1
  barmhärtig_1_A = mkA "barmhärtig" ; -- barmhärtig..av.1
  barmhärtighet_1_N = mkN "barmhärtighet" "barmhärtigheter" ; -- barmhärtighet..nn.1
  barmhärtighetsgärning_1_N = mkN "barmhärtighetsgärning" ; -- barmhärtighetsgärning..nn.1
  barmhärtighetsmord_1_N = mkN "barmhärtighetsmord" neutrum  ; -- barmhärtighetsmord..nn.1
  barmhärtighetsverk_1_N = mkN "barmhärtighetsverk" neutrum  ; -- barmhärtighetsverk..nn.1
  barn_1_N = mkN "barn" neutrum  ; -- barn..nn.1
  barnadödlighet_1_N = mkN "barnadödlighet" "barnadödligheter" ; -- barnadödlighet..nn.1
  barnafar_1_N = mkN "barnafader" "barnafadern" "barnafäder" "barnafäderna" ; -- barnafar..nn.1
  barnafödande_1_N = mkN "barnafödande" ; -- barnafödande..nn.1
  barnaföderska_1_N = mkN "barnaföderska" ; -- barnaföderska..nn.1
  barnaga_1_N = mkN "barnaga" ; -- barnaga..nn.1
  barnahjärta_1_N = mkN "barnahjärta" "barnahjärtat" "barnahjärtan" "barnahjärtana" ; -- barnahjärta..nn.1
  barnalstrande_1_N = mkN "barnalstrande" ; -- barnalstrande..nn.1
  barnamord_1_N = mkN "barnamord" neutrum  ; -- barnamord..nn.1
  barnamördare_1_N = mkN "barnamördare" utrum  ; -- barnamördare..nn.1
  barnansikte_1_N = mkN "barnansikte" ; -- barnansikte..nn.1
  barnarbete_1_N = mkN "barnarbete" ; -- barnarbete..nn.1
  barnarbetskraft_1_N = mkN "barnarbetskraft" ; -- barnarbetskraft..nn.1
  barnarov_1_N = mkN "barnarov" neutrum  ; -- barnarov..nn.1
  barnasinne_1_N = mkN "barnasinne" ; -- barnasinne..nn.1
  barnasjäl_1_N = mkN "barnasjäl" ; -- barnasjäl..nn.1
  barnaskara_1_N = mkN "barnaskara" ; -- barnaskara..nn.1
  barnatro_1_N = mkN "barnatro" ; -- barnatro..nn.1
  barnavård_1_N = mkN "barnavård" ; -- barnavård..nn.1
  barnavårdscentral_1_N = mkN "barnavårdscentral" "barnavårdscentraler" ; -- barnavårdscentral..nn.1
  barnavårdsman_1_N = mkN "barnavårdsman" "barnavårdsmannen" "barnavårdsmän" "barnavårdsmännen" ; -- barnavårdsman..nn.1
  barnavårdsnämnd_1_N = mkN "barnavårdsnämnd" "barnavårdsnämnder" ; -- barnavårdsnämnd..nn.1
  barnbarn_1_N = mkN "barnbarn" neutrum  ; -- barnbarn..nn.1
  barnbarnsbarn_1_N = mkN "barnbarnsbarn" neutrum  ; -- barnbarnsbarn..nn.1
  barnbeck_1_N = mkN "barnbeck" neutrum  ; -- barnbeck..nn.1
  barnbegränsning_1_N = mkN "barnbegränsning" ; -- barnbegränsning..nn.1
  barnbespisning_1_N = mkN "barnbespisning" ; -- barnbespisning..nn.1
  barnbesök_1_N = mkN "barnbesök" neutrum  ; -- barnbesök..nn.1
  barnbidrag_1_N = mkN "barnbidrag" neutrum  ; -- barnbidrag..nn.1
  barnbok_1_N = mkN "barnbok" "barnböcker" ; -- barnbok..nn.1
  barnboksfigur_1_N = mkN "barnboksfigur" "barnboksfigurer" ; -- barnboksfigur..nn.1
  barnby_1_N = mkN "barnby" "barnbyn" "barnbyar" "barnbyarna" ; -- barnby..nn.1
  barnbördshus_1_N = mkN "barnbördshus" neutrum  ; -- barnbördshus..nn.1
  barncrosshjälm_1_N = mkN "barncrosshjälm" ; -- barncrosshjälm..nn.1
  barncykel_1_N = mkN "barncykel" ; -- barncykel..nn.1
  barndaghem_1_N = mkN "barndaghem" "barndaghemmet" "barndaghem" "barndaghemmen" ; -- barndaghem..nn.1
  barndom_1_N = mkN "barndom" ; -- barndom..nn.1
  barndomsforskning_1_N = mkN "barndomsforskning" ; -- barndomsforskning..nn.1
  barndomshem_1_N = mkN "barndomshem" "barndomshemmet" "barndomshem" "barndomshemmen" ; -- barndomshem..nn.1
  barndomskompis_1_N = mkN "barndomskompis" ; -- barndomskompis..nn.1
  barndomsminne_1_N = mkN "barndomsminne" ; -- barndomsminne..nn.1
  barndomsparadis_1_N = mkN "barndomsparadis" neutrum  ; -- barndomsparadis..nn.1
  barndomsstad_1_N = mkN "barndomsstad" "barndomsstäder" ; -- barndomsstad..nn.1
  barndomstillstånd_1_N = mkN "barndomstillstånd" neutrum  ; -- barndomstillstånd..nn.1
  barndomsupplevelse_1_N = mkN "barndomsupplevelse" "barndomsupplevelser" ; -- barndomsupplevelse..nn.1
  barndomsvän_1_N = mkN "barndomsvän" "barndomsvännen" "barndomsvänner" "barndomsvännerna" ; -- barndomsvän..nn.1
  barndop_1_N = mkN "barndop" neutrum  ; -- barndop..nn.1
  barndos_1_N = mkN "barndos" "barndoser" ; -- barndos..nn.1
  barnfamilj_1_N = mkN "barnfamilj" "barnfamiljer" ; -- barnfamilj..nn.1
  barnfattigdom_1_N = mkN "barnfattigdom" ; -- barnfattigdom..nn.1
  barnfetma_1_N = mkN "barnfetma" ; -- barnfetma..nn.1
  barnflicka_1_N = mkN "barnflicka" ; -- barnflicka..nn.1
  barnfotomodell_1_N = mkN "barnfotomodell" "barnfotomodeller" ; -- barnfotomodell..nn.1
  barnfödd_1_A = mkA "barnfödd" ; -- barnfödd..av.1
  barnförbjuden_1_A = mkA "barnförbjuden" ; -- barnförbjuden..av.1
  barnförbjudenhet_1_N = mkN "barnförbjudenhet" ; -- barnförbjudenhet..nn.1
  barnförlamning_1_N = mkN "barnförlamning" ; -- barnförlamning..nn.1
  barngrupp_1_N = mkN "barngrupp" "barngrupper" ; -- barngrupp..nn.1
  barnhem_1_N = mkN "barnhem" "barnhemmet" "barnhem" "barnhemmen" ; -- barnhem..nn.1
  barnhemsbarn_1_N = mkN "barnhemsbarn" neutrum  ; -- barnhemsbarn..nn.1
  barnhemsplacering_1_N = mkN "barnhemsplacering" ; -- barnhemsplacering..nn.1
  barnhus_1_N = mkN "barnhus" neutrum  ; -- barnhus..nn.1
  barnhusbarn_1_N = mkN "barnhusbarn" neutrum  ; -- barnhusbarn..nn.1
  barnhuvud_1_N = mkN "barnhuvud" "barnhuvudet" "barnhuvud" "barnhuvudena" ; -- barnhuvud..nn.1
  barnjungfru_1_N = mkN "barnjungfru" "barnjungfrun" "barnjungfrur" "barnjungfrurna" ; -- barnjungfru..nn.1
  barnkalas_1_N = mkN "barnkalas" neutrum  ; -- barnkalas..nn.1
  barnkammare_1_N = mkN "barnkammare" "barnkammaren" "barnkammare" "barnkamrarna" ; -- barnkammare..nn.1
  barnkammarfönster_1_N = mkN "barnkammarfönster" neutrum  ; -- barnkammarfönster..nn.1
  barnkammarsaga_1_N = mkN "barnkammarsaga" ; -- barnkammarsaga..nn.1
  barnklinik_1_N = mkN "barnklinik" "barnkliniker" ; -- barnklinik..nn.1
  barnknullare_1_N = mkN "barnknullare" utrum  ; -- barnknullare..nn.1
  barnkoloni_1_N = mkN "barnkoloni" "barnkolonier" ; -- barnkoloni..nn.1
  barnkonvention_1_N = mkN "barnkonvention" ; -- barnkonvention..nn.1
  barnkorståg_1_N = mkN "barnkorståg" neutrum  ; -- barnkorståg..nn.1
  barnkropp_1_N = mkN "barnkropp" ; -- barnkropp..nn.1
  barnkär_1_A = mkA "barnkär" ; -- barnkär..av.1
  barnkör_1_N = mkN "barnkör" "barnkörer" ; -- barnkör..nn.1
  barnledig_1_A = mkA "barnledig" ; -- barnledig..av.1
  barnledighet_1_N = mkN "barnledighet" ; -- barnledighet..nn.1
  barnlek_1_N = mkN "barnlek" ; -- barnlek..nn.1
  barnläkare_1_N = mkN "barnläkare" utrum  ; -- barnläkare..nn.1
  barnläkarskrå_1_N = mkN "barnläkarskrå" "barnläkarskrået" "barnläkarskrån" "barnläkarskråna" ; -- barnläkarskrå..nn.1
  barnlös_1_A = mkA "barnlös" ; -- barnlös..av.1
  barnlöshet_1_N = mkN "barnlöshet" ; -- barnlöshet..nn.1
  barnmat_1_N = mkN "barnmat" ; -- barnmat..nn.1
  barnmedicin_1_N = mkN "barnmedicin" ; -- barnmedicin..nn.1
  barnmedicin_2_N = mkN "barnmedicin" "barnmediciner" ; -- barnmedicin..nn.2
  barnmedicinsk_1_A = mkA "barnmedicinsk" ; -- barnmedicinsk..av.1
  barnmisshandel_1_N = mkN "barnmisshandel" ; -- barnmisshandel..nn.1
  barnmorska_1_N = mkN "barnmorska" ; -- barnmorska..nn.1
  barnneurolog_1_N = mkN "barnneurolog" "barnneurologer" ; -- barnneurolog..nn.1
  barnomsorg_1_N = mkN "barnomsorg" ; -- barnomsorg..nn.1
  barnomsorgsavgift_1_N = mkN "barnomsorgsavgift" "barnomsorgsavgifter" ; -- barnomsorgsavgift..nn.1
  barnomsorgskostnad_1_N = mkN "barnomsorgskostnad" "barnomsorgskostnader" ; -- barnomsorgskostnad..nn.1
  barnparkering_1_N = mkN "barnparkering" ; -- barnparkering..nn.1
  barnpassning_1_N = mkN "barnpassning" ; -- barnpassning..nn.1
  barnpiga_1_N = mkN "barnpiga" ; -- barnpiga..nn.1
  barnplågeri_1_N = mkN "barnplågeri" neutrum  ; -- barnplågeri..nn.1
  barnpornografi_1_N = mkN "barnpornografi" ; -- barnpornografi..nn.1
  barnpornografisk_1_A = mkA "barnpornografisk" ; -- barnpornografisk..av.1
  barnporr_1_N = mkN "barnporr" ; -- barnporr..nn.1
  barnporranklagad_1_A = mkA "barnporranklagad" ; -- barnporranklagad..av.1
  barnporrhärva_1_N = mkN "barnporrhärva" ; -- barnporrhärva..nn.1
  barnporrmål_1_N = mkN "barnporrmål" neutrum  ; -- barnporrmål..nn.1
  barnprogram_1_N = mkN "barnprogram" "barnprogrammet" "barnprogram" "barnprogrammen" ; -- barnprogram..nn.1
  barnpsykiatri_1_N = mkN "barnpsykiatri" ; -- barnpsykiatri..nn.1
  barnpsykiatrisk_1_A = mkA "barnpsykiatrisk" ; -- barnpsykiatrisk..av.1
  barnrik_1_A = mkA "barnrik" ; -- barnrik..av.1
  barnrov_1_N = mkN "barnrov" neutrum  ; -- barnrov..nn.1
  barnrättskämpe_1_N = mkN "barnrättskämpe" utrum  ; -- barnrättskämpe..nn.1
  barnröst_1_N = mkN "barnröst" "barnröster" ; -- barnröst..nn.1
  barnsaga_1_N = mkN "barnsaga" ; -- barnsaga..nn.1
  barnsak_1_N = mkN "barnsak" "barnsaker" ; -- barnsak..nn.1
  barnsbörd_1_N = mkN "barnsbörd" "barnsbörder" ; -- barnsbörd..nn.1
  barnsjukdom_1_N = mkN "barnsjukdom" ; -- barnsjukdom..nn.1
  barnsjukhus_1_N = mkN "barnsjukhus" neutrum  ; -- barnsjukhus..nn.1
  barnsko_1_N = mkN "barnsko" "barnskor" ; -- barnsko..nn.1
  barnskottkärra_1_N = mkN "barnskottkärra" ; -- barnskottkärra..nn.1
  barnskratt_1_N = mkN "barnskratt" neutrum  ; -- barnskratt..nn.1
  barnskrik_1_N = mkN "barnskrik" neutrum  ; -- barnskrik..nn.1
  barnskötare_1_N = mkN "barnskötare" utrum  ; -- barnskötare..nn.1
  barnskötarlinje_1_N = mkN "barnskötarlinje" "barnskötarlinjer" ; -- barnskötarlinje..nn.1
  barnsköterska_1_N = mkN "barnsköterska" ; -- barnsköterska..nn.1
  barnslig_1_A = mkA "barnslig" ; -- barnslig..av.1
  barnslighet_1_N = mkN "barnslighet" "barnsligheter" ; -- barnslighet..nn.1
  barnsmugglare_1_N = mkN "barnsmugglare" utrum  ; -- barnsmugglare..nn.1
  barnsmugglarliga_1_N = mkN "barnsmugglarliga" ; -- barnsmugglarliga..nn.1
  barnsmuggling_1_N = mkN "barnsmuggling" ; -- barnsmuggling..nn.1
  barnsnor_1_N = mkN "barnsnor" ; -- barnsnor..nn.1
  barnsnöd_1_N = mkN "barnsnöd" ; -- barnsnöd..nn.1
  barnsoldat_1_N = mkN "barnsoldat" "barnsoldater" ; -- barnsoldat..nn.1
  barnspråk_1_N = mkN "barnspråk" neutrum  ; -- barnspråk..nn.1
  barnstuga_1_N = mkN "barnstuga" ; -- barnstuga..nn.1
  barnsäker_1_A = mkA "barnsäker" ; -- barnsäker..av.1
  barnsäkerhet_1_N = mkN "barnsäkerhet" ; -- barnsäkerhet..nn.1
  barnsäng_1_N = mkN "barnsäng" ; -- barnsäng..nn.1
  barnsängsfeber_1_N = mkN "barnsängsfeber" ; -- barnsängsfeber..nn.1
  barnsängskvinna_1_N = mkN "barnsängskvinna" ; -- barnsängskvinna..nn.1
  barnteckning_1_N = mkN "barnteckning" ; -- barnteckning..nn.1
  barntillsyn_1_N = mkN "barntillsyn" ; -- barntillsyn..nn.1
  barntillåten_1_A = mkA "barntillåten" ; -- barntillåten..av.1
  barntillåtenhet_1_N = mkN "barntillåtenhet" ; -- barntillåtenhet..nn.1
  barntoalett_1_N = mkN "barntoalett" "barntoaletter" ; -- barntoalett..nn.1
  barnunge_1_N = mkN "barnunge" utrum  ; -- barnunge..nn.1
  barnvagn_1_N = mkN "barnvagn" ; -- barnvagn..nn.1
  barnvakt_1_N = mkN "barnvakt" "barnvakter" ; -- barnvakt..nn.1
  barnvattenkanna_1_N = mkN "barnvattenkanna" ; -- barnvattenkanna..nn.1
  barnvisa_1_N = mkN "barnvisa" ; -- barnvisa..nn.1
  barnvälgörenhetsorganisation_1_N = mkN "barnvälgörenhetsorganisation" ; -- barnvälgörenhetsorganisation..nn.1
  barnvänlig_1_A = mkA "barnvänlig" ; -- barnvänlig..av.1
  barock_1_A = mkA "barock" ; -- barock..av.1
  barock_1_N = mkN "barock" ; -- barock..nn.1
  barockkonst_1_N = mkN "barockkonst" "barockkonster" ; -- barockkonst..nn.1
  barocklyrik_1_N = mkN "barocklyrik" ; -- barocklyrik..nn.1
  barockmusik_1_N = mkN "barockmusik" ; -- barockmusik..nn.1
  barockmässig_1_A = mkA "barockmässig" ; -- barockmässig..av.1
  barockmålare_1_N = mkN "barockmålare" utrum  ; -- barockmålare..nn.1
  barockpalats_1_N = mkN "barockpalats" neutrum  ; -- barockpalats..nn.1
  barockpärla_1_N = mkN "barockpärla" ; -- barockpärla..nn.1
  barockstil_1_N = mkN "barockstil" ; -- barockstil..nn.1
  barograf_1_N = mkN "barograf" "barografer" ; -- barograf..nn.1
  barogram_1_N = mkN "barogram" "barogrammet" "barogram" "barogrammen" ; -- barogram..nn.1
  barometer_1_N = mkN "barometer" ; -- barometer..nn.1
  barometerfall_1_N = mkN "barometerfall" neutrum  ; -- barometerfall..nn.1
  barometerstånd_1_N = mkN "barometerstånd" neutrum  ; -- barometerstånd..nn.1
  barometrisk_1_A = mkA "barometrisk" ; -- barometrisk..av.1
  baron_1_N = mkN "baron" "baroner" ; -- baron..nn.1
  baronessa_1_N = mkN "baronessa" ; -- baronessa..nn.1
  barospirator_1_N = mkN "barospirator" "barospiratorer" ; -- barospirator..nn.1
  barr_1_N = mkN "barr" neutrum  ; -- barr..nn.1
  barr_2_N = mkN "barr" "barrer" ; -- barr..nn.2
  barra_1_V = mkV "barrar" ; -- barra..vb.1
  barrande_1_N = mkN "barrande" ; -- barrande..nn.1
  barrdoft_1_N = mkN "barrdoft" "barrdofter" ; -- barrdoft..nn.1
  barre_1_N = mkN "barre" utrum  ; -- barre..nn.1
  barrig_1_A = mkA "barrig" ; -- barrig..av.1
  barrikad_1_N = mkN "barrikad" "barrikader" ; -- barrikad..nn.1
  barrikadera_1_V = mkV "barrikaderar" ; -- barrikadera..vb.1
  barrikaderande_1_N = mkN "barrikaderande" ; -- barrikaderande..nn.1
  barrikaderbar_1_A = mkA "barrikaderbar" ; -- barrikaderbar..av.1
  barrikaderbarhet_1_N = mkN "barrikaderbarhet" ; -- barrikaderbarhet..nn.1
  barrikadering_1_N = mkN "barrikadering" ; -- barrikadering..nn.1
  barrikadkämpe_1_N = mkN "barrikadkämpe" utrum  ; -- barrikadkämpe..nn.1
  barrikadstrid_1_N = mkN "barrikadstrid" "barrikadstrider" ; -- barrikadstrid..nn.1
  barriär_1_N = mkN "barriär" "barriärer" ; -- barriär..nn.1
  barriärrev_1_N = mkN "barriärrev" neutrum  ; -- barriärrev..nn.1
  barrskog_1_N = mkN "barrskog" ; -- barrskog..nn.1
  barrskogsgräns_1_N = mkN "barrskogsgräns" "barrskogsgränser" ; -- barrskogsgräns..nn.1
  barrskogsnunna_1_N = mkN "barrskogsnunna" ; -- barrskogsnunna..nn.1
  barrskogsregion_1_N = mkN "barrskogsregion" ; -- barrskogsregion..nn.1
  barrskogstäckt_1_A = mkA "barrskogstäckt" "barrskogstäckt" ; -- barrskogstäckt..av.1
  barrträd_1_N = mkN "barrträd" neutrum  ; -- barrträd..nn.1
  barrträdskotte_1_N = mkN "barrträdskotte" utrum  ; -- barrträdskotte..nn.1
  barrträdsplanta_1_N = mkN "barrträdsplanta" ; -- barrträdsplanta..nn.1
  barrträdssort_1_N = mkN "barrträdssort" "barrträdssorter" ; -- barrträdssort..nn.1
  barrved_1_N = mkN "barrved" ; -- barrved..nn.1
  barservering_1_N = mkN "barservering" ; -- barservering..nn.1
  barsk_1_A = mkA "barsk" ; -- barsk..av.1
  barskhet_1_N = mkN "barskhet" ; -- barskhet..nn.1
  barskrapad_1_A = mkA "barskrapad" ; -- barskrapad..av.1
  barskåp_1_N = mkN "barskåp" neutrum  ; -- barskåp..nn.1
  barstol_1_N = mkN "barstol" ; -- barstol..nn.1
  bartender_1_N = mkN "bartender" ; -- bartender..nn.1
  barvinter_1_N = mkN "barvinter" ; -- barvinter..nn.1
  barysfär_1_N = mkN "barysfär" "barysfärer" ; -- barysfär..nn.1
  baryt_1_N = mkN "baryt" ; -- baryt..nn.1
  baryton_1_N = mkN "baryton" "barytoner" ; -- baryton..nn.1
  bas_1_N = mkN "bas" ; -- bas..nn.1
  bas_2_N = mkN "bas" "baser" ; -- bas..nn.2
  bas_3_N = mkN "bas" ; -- bas..nn.3
  bas_4_N = mkN "bas" ; -- bas..nn.4
  basa_1_V = mkV "basar" ; -- basa..vb.1
  basal_1_A = mkA "basal" ; -- basal..av.1
  basalt_1_N = mkN "basalt" ; -- basalt..nn.1
  basande_1_N = mkN "basande" ; -- basande..nn.1
  basar_1_N = mkN "basar" "basarer" ; -- basar..nn.1
  basbelopp_1_N = mkN "basbelopp" neutrum  ; -- basbelopp..nn.1
  baseball_1_N = mkN "baseball" ; -- baseball..nn.1
  baseballsträ_1_N = mkN "baseballsträ" "baseballsträt" "baseballsträn" "baseballsträna" ; -- baseballsträ..nn.1
  baseballträ_1_N = mkN "baseballträ" "baseballträt" "baseballträn" "baseballträna" ; -- baseballträ..nn.1
  baseboll_1_N = mkN "baseboll" ; -- baseboll..nn.1
  baseboll_2_N = mkN "baseboll" ; -- baseboll..nn.2
  basebollsträ_1_N = mkN "basebollsträ" "basebollsträt" "basebollsträn" "basebollsträna" ; -- basebollsträ..nn.1
  basebollträ_1_N = mkN "basebollträ" "basebollträt" "basebollträn" "basebollträna" ; -- basebollträ..nn.1
  basedow_1_N = mkN "basedow" ; -- basedow..nn.1
  basenhet_1_N = mkN "basenhet" "basenheter" ; -- basenhet..nn.1
  basera_1_V = mkV "baserar" ; -- basera..vb.1
  baserande_1_N = mkN "baserande" ; -- baserande..nn.1
  baserbar_1_A = mkA "baserbar" ; -- baserbar..av.1
  baserbarhet_1_N = mkN "baserbarhet" ; -- baserbarhet..nn.1
  basering_1_N = mkN "basering" ; -- basering..nn.1
  basfiol_1_N = mkN "basfiol" "basfioler" ; -- basfiol..nn.1
  basfiolsfodral_1_N = mkN "basfiolsfodral" neutrum  ; -- basfiolsfodral..nn.1
  basfiolsfodralsmakare_1_N = mkN "basfiolsfodralsmakare" utrum  ; -- basfiolsfodralsmakare..nn.1
  basfiolsfodralsmakaregesäll_1_N = mkN "basfiolsfodralsmakaregesäll" "basfiolsfodralsmakaregesäller" ; -- basfiolsfodralsmakaregesäll..nn.1
  basfärdighet_1_N = mkN "basfärdighet" "basfärdigheter" ; -- basfärdighet..nn.1
  basföda_1_N = mkN "basföda" ; -- basföda..nn.1
  basgitarr_1_N = mkN "basgitarr" "basgitarrer" ; -- basgitarr..nn.1
  basilika_1_N = mkN "basilika" ; -- basilika..nn.1
  basilisk_1_N = mkN "basilisk" "basilisker" ; -- basilisk..nn.1
  basis_1_N = mkN "basis" ; -- basis..nn.1
  basisk_1_A = mkA "basisk" ; -- basisk..av.1
  basist_1_N = mkN "basist" "basister" ; -- basist..nn.1
  bask_1_N = mkN "bask" "basker" ; -- bask..nn.1
  basker_1_N = mkN "basker" ; -- basker..nn.1
  basket_1_N = mkN "basket" ; -- basket..nn.1
  basketboll_1_N = mkN "basketboll" ; -- basketboll..nn.1
  basketboll_2_N = mkN "basketboll" ; -- basketboll..nn.2
  basketproffs_1_N = mkN "basketproffs" neutrum  ; -- basketproffs..nn.1
  baskisk_1_A = mkA "baskisk" ; -- baskisk..av.1
  baskiska_1_N = mkN "baskiska" ; -- baskiska..nn.1
  baskiska_2_N = mkN "baskiska" ; -- baskiska..nn.2
  basklarinett_1_N = mkN "basklarinett" "basklarinetter" ; -- basklarinett..nn.1
  basklav_1_N = mkN "basklav" ; -- basklav..nn.1
  baslinje_1_N = mkN "baslinje" "baslinjer" ; -- baslinje..nn.1
  basläger_1_N = mkN "basläger" neutrum  ; -- basläger..nn.1
  basning_1_N = mkN "basning" ; -- basning..nn.1
  basnot_1_N = mkN "basnot" "basnoter" ; -- basnot..nn.1
  basorganisation_1_N = mkN "basorganisation" ; -- basorganisation..nn.1
  baspar_1_N = mkN "baspar" neutrum  ; -- baspar..nn.1
  basparti_1_N = mkN "basparti" "baspartiet" "baspartier" "baspartierna" ; -- basparti..nn.1
  basplatta_1_N = mkN "basplatta" ; -- basplatta..nn.1
  basrelief_1_N = mkN "basrelief" "basreliefer" ; -- basrelief..nn.1
  basrelieftavla_1_N = mkN "basrelieftavla" ; -- basrelieftavla..nn.1
  basröst_1_N = mkN "basröst" "basröster" ; -- basröst..nn.1
  basse_1_N = mkN "basse" utrum  ; -- basse..nn.1
  basset_1_N = mkN "basset" ; -- basset..nn.1
  bassetthorn_1_N = mkN "bassetthorn" neutrum  ; -- bassetthorn..nn.1
  bassning_1_N = mkN "bassning" ; -- bassning..nn.1
  basstation_1_N = mkN "basstation" ; -- basstation..nn.1
  bassträcka_1_N = mkN "bassträcka" ; -- bassträcka..nn.1
  bassträng_1_N = mkN "bassträng" ; -- bassträng..nn.1
  basstämma_1_N = mkN "basstämma" ; -- basstämma..nn.1
  bassäng_1_N = mkN "bassäng" "bassänger" ; -- bassäng..nn.1
  bassångare_1_N = mkN "bassångare" utrum  ; -- bassångare..nn.1
  bast_1_N = mkN "bast" neutrum  ; -- bast..nn.1
  bast_2_N = mkN "bast" neutrum  ; -- bast..nn.2
  basta_1_V = mkV "bastar" ; -- basta..vb.1
  bastande_1_N = mkN "bastande" ; -- bastande..nn.1
  bastant_1_A = mkA "bastant" "bastant" ; -- bastant..av.1
  bastanthet_1_N = mkN "bastanthet" ; -- bastanthet..nn.1
  bastard_1_N = mkN "bastard" "bastarder" ; -- bastard..nn.1
  bastardform_1_N = mkN "bastardform" "bastardformer" ; -- bastardform..nn.1
  bastardnäktergal_1_N = mkN "bastardnäktergal" ; -- bastardnäktergal..nn.1
  bastcell_1_N = mkN "bastcell" "bastceller" ; -- bastcell..nn.1
  bastfiber_1_N = mkN "bastfiber" "bastfibern" "bastfibrer" "bastfibrerna" ; -- bastfiber..nn.1
  bastingering_1_N = mkN "bastingering" ; -- bastingering..nn.1
  bastion_1_N = mkN "bastion" ; -- bastion..nn.1
  bastkjol_1_N = mkN "bastkjol" ; -- bastkjol..nn.1
  bastmatta_1_N = mkN "bastmatta" ; -- bastmatta..nn.1
  baston_1_N = mkN "baston" "bastoner" ; -- baston..nn.1
  bastonad_1_N = mkN "bastonad" "bastonader" ; -- bastonad..nn.1
  bastrep_1_N = mkN "bastrep" neutrum  ; -- bastrep..nn.1
  bastrumma_1_N = mkN "bastrumma" ; -- bastrumma..nn.1
  bastu_1_N = mkN "bastu" "bastun" "bastur" "basturna" ; -- bastu..nn.1
  bastuaggregat_1_N = mkN "bastuaggregat" neutrum  ; -- bastuaggregat..nn.1
  bastuba_1_N = mkN "bastuba" ; -- bastuba..nn.1
  bastubad_1_N = mkN "bastubad" neutrum  ; -- bastubad..nn.1
  bastuförening_1_N = mkN "bastuförening" ; -- bastuförening..nn.1
  bastuklubb_1_N = mkN "bastuklubb" ; -- bastuklubb..nn.1
  bastuugn_1_N = mkN "bastuugn" ; -- bastuugn..nn.1
  bastuvärme_1_N = mkN "bastuvärme" utrum  ; -- bastuvärme..nn.1
  basun_1_N = mkN "basun" "basuner" ; -- basun..nn.1
  basunblåsande_1_N = mkN "basunblåsande" ; -- basunblåsande..nn.1
  basunist_1_N = mkN "basunist" "basunister" ; -- basunist..nn.1
  basunklang_1_N = mkN "basunklang" "basunklanger" ; -- basunklang..nn.1
  basunregister_1_N = mkN "basunregister" neutrum  ; -- basunregister..nn.1
  basunstöt_1_N = mkN "basunstöt" ; -- basunstöt..nn.1
  basvara_1_N = mkN "basvara" ; -- basvara..nn.1
  basvinkel_1_N = mkN "basvinkel" ; -- basvinkel..nn.1
  basväg_1_N = mkN "basväg" ; -- basväg..nn.1
  basyta_1_N = mkN "basyta" ; -- basyta..nn.1
  basår_1_N = mkN "basår" neutrum  ; -- basår..nn.1
  batalj_1_N = mkN "batalj" "bataljer" ; -- batalj..nn.1
  bataljmålare_1_N = mkN "bataljmålare" utrum  ; -- bataljmålare..nn.1
  bataljmålning_1_N = mkN "bataljmålning" ; -- bataljmålning..nn.1
  bataljon_1_N = mkN "bataljon" "bataljoner" ; -- bataljon..nn.1
  bataljonsadjutant_1_N = mkN "bataljonsadjutant" "bataljonsadjutanter" ; -- bataljonsadjutant..nn.1
  bataljonschef_1_N = mkN "bataljonschef" "bataljonschefer" ; -- bataljonschef..nn.1
  bataljonsvis_1_Adv = mkAdv "bataljonsvis" ; -- bataljonsvis..ab.1
  batat_1_N = mkN "batat" "batater" ; -- batat..nn.1
  batik_1_N = mkN "batik" ; -- batik..nn.1
  batist_1_N = mkN "batist" "batister" ; -- batist..nn.1
  batong_1_N = mkN "batong" "batonger" ; -- batong..nn.1
  batongslag_1_N = mkN "batongslag" neutrum  ; -- batongslag..nn.1
  batongstånd_1_N = mkN "batongstånd" neutrum  ; -- batongstånd..nn.1
  batongsvingande_1_A = mkA "batongsvingande" ; -- batongsvingande..av.1
  batongsvingande_1_N = mkN "batongsvingande" ; -- batongsvingande..nn.1
  batteri_1_N = mkN "batteri" "batteriet" "batterier" "batterierna" ; -- batteri..nn.1
  batteridrift_1_N = mkN "batteridrift" ; -- batteridrift..nn.1
  batteridriven_1_A = mkA "batteridriven" ; -- batteridriven..av.1
  batterield_1_N = mkN "batterield" ; -- batterield..nn.1
  batteriklämma_1_N = mkN "batteriklämma" ; -- batteriklämma..nn.1
  batteriladdare_1_N = mkN "batteriladdare" utrum  ; -- batteriladdare..nn.1
  batteriladdning_1_N = mkN "batteriladdning" ; -- batteriladdning..nn.1
  batteriprovare_1_N = mkN "batteriprovare" utrum  ; -- batteriprovare..nn.1
  batteriradio_1_N = mkN "batteriradio" ; -- batteriradio..nn.1
  batterisekatör_1_N = mkN "batterisekatör" "batterisekatörer" ; -- batterisekatör..nn.1
  batterist_1_N = mkN "batterist" "batterister" ; -- batterist..nn.1
  batteritändning_1_N = mkN "batteritändning" ; -- batteritändning..nn.1
  batting_1_N = mkN "batting" ; -- batting..nn.1
  batysfär_1_N = mkN "batysfär" "batysfärer" ; -- batysfär..nn.1
  baud_1_N = mkN "baud" "bauden" "baud" "bauden" ; -- baud..nn.1
  bautasten_1_N = mkN "bautasten" "bautastenen" "bautastenar" "bautastenarna" ; -- bautasten..nn.1
  bauxit_1_N = mkN "bauxit" ; -- bauxit..nn.1
  baxa_1_V = mkV "baxar" ; -- baxa..vb.1
  baxande_1_N = mkN "baxande" ; -- baxande..nn.1
  baxna_1_V = mkV "baxnar" ; -- baxna..vb.1
  baxnande_1_N = mkN "baxnande" ; -- baxnande..nn.1
  bayersk_1_A = mkA "bayersk" ; -- bayersk..av.1
  bazooka_1_N = mkN "bazooka" ; -- bazooka..nn.1
  be_1_V = mkV "beda" "bad" "bett" ; -- be..vb.1
  bea_1_N = mkN "bea" ; -- bea..nn.1
  beagle_1_N = mkN "beagle" utrum  ; -- beagle..nn.1
  beakta_1_V = mkV "beaktar" ; -- beakta..vb.1
  beaktande_1_N = mkN "beaktande" ; -- beaktande..nn.1
  beaktansvärd_1_A = mkA "beaktansvärd" "beaktansvärt" ; -- beaktansvärd..av.1
  bearbeta_1_V = mkV "bearbetar" ; -- bearbeta..vb.1
  bearbetande_1_N = mkN "bearbetande" ; -- bearbetande..nn.1
  bearbetare_1_N = mkN "bearbetare" utrum  ; -- bearbetare..nn.1
  bearbetning_1_N = mkN "bearbetning" ; -- bearbetning..nn.1
  bearnaise_1_N = mkN "bearnaise" "bearnaiser" ; -- bearnaise..nn.1
  bearnaisesås_1_N = mkN "bearnaisesås" "bearnaisesåser" ; -- bearnaisesås..nn.1
  bearnäs_1_N = mkN "bearnäs" "bearnäser" ; -- bearnäs..nn.1
  bearnässås_1_N = mkN "bearnässås" "bearnässåser" ; -- bearnässås..nn.1
  beatifiera_1_V = mkV "beatifierar" ; -- beatifiera..vb.1
  beatifierande_1_N = mkN "beatifierande" ; -- beatifierande..nn.1
  beatifierbar_1_A = mkA "beatifierbar" ; -- beatifierbar..av.1
  beatifierbarhet_1_N = mkN "beatifierbarhet" ; -- beatifierbarhet..nn.1
  beatifiering_1_N = mkN "beatifiering" ; -- beatifiering..nn.1
  beatnik_1_N = mkN "beatnik" ; -- beatnik..nn.1
  bebis_1_N = mkN "bebis" ; -- bebis..nn.1
  beblandande_1_N = mkN "beblandande" ; -- beblandande..nn.1
  beblandelse_1_N = mkN "beblandelse" utrum  ; -- beblandelse..nn.1
  bebo_1_V = mkV "bebor" ; -- bebo..vb.1
  bebodd_1_A = mkA "bebodd" ; -- bebodd..av.1
  beboelig_1_A = mkA "beboelig" ; -- beboelig..av.1
  beboelighet_1_N = mkN "beboelighet" ; -- beboelighet..nn.1
  beboende_1_N = mkN "beboende" ; -- beboende..nn.1
  bebolig_1_A = mkA "bebolig" ; -- bebolig..av.1
  bebolighet_1_N = mkN "bebolighet" ; -- bebolighet..nn.1
  bebop_1_N = mkN "bebop" ; -- bebop..nn.1
  bebygga_1_V = mkV "bebygger" ; -- bebygga..vb.1
  bebyggande_1_N = mkN "bebyggande" ; -- bebyggande..nn.1
  bebyggare_1_N = mkN "bebyggare" utrum  ; -- bebyggare..nn.1
  bebyggelse_1_N = mkN "bebyggelse" "bebyggelser" ; -- bebyggelse..nn.1
  bebyggelsenamn_1_N = mkN "bebyggelsenamn" neutrum  ; -- bebyggelsenamn..nn.1
  bebåda_1_V = mkV "bebådar" ; -- bebåda..vb.1
  bebådande_1_N = mkN "bebådande" ; -- bebådande..nn.1
  bebådelse_1_N = mkN "bebådelse" "bebådelser" ; -- bebådelse..nn.1
  bebådelsedag_1_N = mkN "bebådelsedag" ; -- bebådelsedag..nn.1
  bebådning_1_N = mkN "bebådning" ; -- bebådning..nn.1
  becherovka_1_N = mkN "becherovka" ; -- becherovka..nn.1
  beck_1_N = mkN "beck" neutrum  ; -- beck..nn.1
  becka_1_V = mkV "beckar" ; -- becka..vb.1
  beckande_1_N = mkN "beckande" ; -- beckande..nn.1
  beckasin_1_N = mkN "beckasin" "beckasiner" ; -- beckasin..nn.1
  beckig_1_A = mkA "beckig" ; -- beckig..av.1
  beckighet_1_N = mkN "beckighet" ; -- beckighet..nn.1
  beckmörk_1_A = mkA "beckmörk" ; -- beckmörk..av.1
  beckmörker_1_N = mkN "beckmörker" neutrum  ; -- beckmörker..nn.1
  beckpärla_1_N = mkN "beckpärla" ; -- beckpärla..nn.1
  becksvart_1_A = mkA "becksvart" "becksvart" ; -- becksvart..av.1
  becquerel_1_N = mkN "becquerel" "becquerelen" "becquerel" "becquerelen" ; -- becquerel..nn.1
  bedagad_1_A = mkA "bedagad" ; -- bedagad..av.1
  bedarra_1_V = mkV "bedarrar" ; -- bedarra..vb.1
  bedarrande_1_N = mkN "bedarrande" ; -- bedarrande..nn.1
  bedarrning_1_N = mkN "bedarrning" ; -- bedarrning..nn.1
  bedjande_1_A = mkA "bedjande" ; -- bedjande..av.1
  bedjande_1_N = mkN "bedjande" ; -- bedjande..nn.1
  bedra_1_V = mkV "bedraga" "bedrog" "bedragit" ; -- bedra..vb.1
  bedragande_1_N = mkN "bedragande" ; -- bedragande..nn.1
  bedragare_1_N = mkN "bedragare" utrum  ; -- bedragare..nn.1
  bedragerska_1_N = mkN "bedragerska" ; -- bedragerska..nn.1
  bedrift_1_N = mkN "bedrift" "bedrifter" ; -- bedrift..nn.1
  bedriva_1_V = mkV "bedriva" "bedrev" "bedrivit" ; -- bedriva..vb.1
  bedrivande_1_N = mkN "bedrivande" ; -- bedrivande..nn.1
  bedrägeri_1_N = mkN "bedrägeri" "bedrägeriet" "bedrägerier" "bedrägerierna" ; -- bedrägeri..nn.1
  bedrägeribrott_1_N = mkN "bedrägeribrott" neutrum  ; -- bedrägeribrott..nn.1
  bedrägerirotel_1_N = mkN "bedrägerirotel" ; -- bedrägerirotel..nn.1
  bedräglig_1_A = mkA "bedräglig" ; -- bedräglig..av.1
  bedräglighet_1_N = mkN "bedräglighet" "bedrägligheter" ; -- bedräglighet..nn.1
  bedröva_1_V = mkV "bedrövar" ; -- bedröva..vb.1
  bedrövad_1_A = mkA "bedrövad" ; -- bedrövad..av.1
  bedrövande_1_N = mkN "bedrövande" ; -- bedrövande..nn.1
  bedrövelse_1_N = mkN "bedrövelse" "bedrövelser" ; -- bedrövelse..nn.1
  bedrövlig_1_A = mkA "bedrövlig" ; -- bedrövlig..av.1
  bedrövlighet_1_N = mkN "bedrövlighet" "bedrövligheter" ; -- bedrövlighet..nn.1
  beduin_1_N = mkN "beduin" "beduiner" ; -- beduin..nn.1
  bedyra_1_V = mkV "bedyrar" ; -- bedyra..vb.1
  bedyrande_1_N = mkN "bedyrande" ; -- bedyrande..nn.1
  bedåra_1_V = mkV "bedårar" ; -- bedåra..vb.1
  bedårande_1_A = mkA "bedårande" ; -- bedårande..av.1
  bedårande_1_N = mkN "bedårande" ; -- bedårande..nn.1
  bedöma_1_V = mkV "bedömer" ; -- bedöma..vb.1
  bedömande_1_N = mkN "bedömande" ; -- bedömande..nn.1
  bedömare_1_N = mkN "bedömare" utrum  ; -- bedömare..nn.1
  bedömning_1_N = mkN "bedömning" ; -- bedömning..nn.1
  bedöva_1_V = mkV "bedövar" ; -- bedöva..vb.1
  bedövande_1_N = mkN "bedövande" ; -- bedövande..nn.1
  bedövning_1_N = mkN "bedövning" ; -- bedövning..nn.1
  bedövningsmedel_1_N = mkN "bedövningsmedel" neutrum  ; -- bedövningsmedel..nn.1
  beediga_1_V = mkV "beedigar" ; -- beediga..vb.1
  beedigande_1_N = mkN "beedigande" ; -- beedigande..nn.1
  beende_1_A = mkA "beende" ; -- beende..av.1
  beende_1_N = mkN "beende" ; -- beende..nn.1
  befalla_1_V = mkV "befaller" ; -- befalla..vb.1
  befallande_1_A = mkA "befallande" ; -- befallande..av.1
  befallande_1_N = mkN "befallande" ; -- befallande..nn.1
  befallning_1_N = mkN "befallning" ; -- befallning..nn.1
  befallningshavande_1_N = mkN "befallningshavande" "befallningshavanden" "befallningshavanden" "befallningshavandena" ; -- befallningshavande..nn.1
  befallningsman_1_N = mkN "befallningsman" "befallningsmannen" "befallningsmän" "befallningsmännen" ; -- befallningsman..nn.1
  befara_1_V = mkV "befarar" ; -- befara..vb.1
  befara_2_V = mkV "befara" "befor" "befarit" ; -- befara..vb.2
  befarande_1_N = mkN "befarande" ; -- befarande..nn.1
  befaren_1_A = mkA "befaren" ; -- befaren..av.1
  befattning_1_N = mkN "befattning" ; -- befattning..nn.1
  befattningshavare_1_N = mkN "befattningshavare" utrum  ; -- befattningshavare..nn.1
  befattningsmässig_1_A = mkA "befattningsmässig" ; -- befattningsmässig..av.1
  befinna_1_V = mkV "befinna" "befann" "befunnit" ; -- befinna..vb.1
  befinnande_1_N = mkN "befinnande" ; -- befinnande..nn.1
  befintlig_1_A = mkA "befintlig" ; -- befintlig..av.1
  befintlighet_1_N = mkN "befintlighet" "befintligheter" ; -- befintlighet..nn.1
  befjädrad_1_A = mkA "befjädrad" ; -- befjädrad..av.1
  befjädring_1_N = mkN "befjädring" ; -- befjädring..nn.1
  befläcka_1_V = mkV "befläckar" ; -- befläcka..vb.1
  befläckande_1_N = mkN "befläckande" ; -- befläckande..nn.1
  befläckelse_1_N = mkN "befläckelse" "befläckelser" ; -- befläckelse..nn.1
  befogad_1_A = mkA "befogad" ; -- befogad..av.1
  befogenhet_1_N = mkN "befogenhet" "befogenheter" ; -- befogenhet..nn.1
  befogenhetsförskjutning_1_N = mkN "befogenhetsförskjutning" ; -- befogenhetsförskjutning..nn.1
  befolka_1_V = mkV "befolkar" ; -- befolka..vb.1
  befolkande_1_N = mkN "befolkande" ; -- befolkande..nn.1
  befolkning_1_N = mkN "befolkning" ; -- befolkning..nn.1
  befolkningsexplosion_1_N = mkN "befolkningsexplosion" ; -- befolkningsexplosion..nn.1
  befolkningsgrupp_1_N = mkN "befolkningsgrupp" "befolkningsgrupper" ; -- befolkningsgrupp..nn.1
  befolkningsmässig_1_A = mkA "befolkningsmässig" ; -- befolkningsmässig..av.1
  befolkningspolitik_1_N = mkN "befolkningspolitik" ; -- befolkningspolitik..nn.1
  befolkningspolitisk_1_A = mkA "befolkningspolitisk" ; -- befolkningspolitisk..av.1
  befolkningspyramid_1_N = mkN "befolkningspyramid" "befolkningspyramider" ; -- befolkningspyramid..nn.1
  befolkningsstatistik_1_N = mkN "befolkningsstatistik" "befolkningsstatistiker" ; -- befolkningsstatistik..nn.1
  befolkningstillväxt_1_N = mkN "befolkningstillväxt" ; -- befolkningstillväxt..nn.1
  befolkningsundersökning_1_N = mkN "befolkningsundersökning" ; -- befolkningsundersökning..nn.1
  befolkningsökning_1_N = mkN "befolkningsökning" ; -- befolkningsökning..nn.1
  befordra_1_V = mkV "befordrar" ; -- befordra..vb.1
  befordran_1_N = mkN "befordran" "befordran" "befordringar" "befordringarna" ; -- befordran..nn.1
  befordrande_1_N = mkN "befordrande" ; -- befordrande..nn.1
  befordrare_1_N = mkN "befordrare" utrum  ; -- befordrare..nn.1
  befordring_1_N = mkN "befordring" ; -- befordring..nn.1
  befordringsgrund_1_N = mkN "befordringsgrund" "befordringsgrunder" ; -- befordringsgrund..nn.1
  befordringsgång_1_N = mkN "befordringsgång" ; -- befordringsgång..nn.1
  befrakta_1_V = mkV "befraktar" ; -- befrakta..vb.1
  befraktande_1_N = mkN "befraktande" ; -- befraktande..nn.1
  befraktare_1_N = mkN "befraktare" utrum  ; -- befraktare..nn.1
  befraktning_1_N = mkN "befraktning" ; -- befraktning..nn.1
  befransad_1_A = mkA "befransad" ; -- befransad..av.1
  befria_1_V = mkV "befriar" ; -- befria..vb.1
  befriande_1_A = mkA "befriande" ; -- befriande..av.1
  befriande_1_N = mkN "befriande" ; -- befriande..nn.1
  befriare_1_N = mkN "befriare" utrum  ; -- befriare..nn.1
  befrielse_1_N = mkN "befrielse" "befrielser" ; -- befrielse..nn.1
  befrielseakt_1_N = mkN "befrielseakt" "befrielseakter" ; -- befrielseakt..nn.1
  befrielsearmé_1_N = mkN "befrielsearmé" "befrielsearméer" ; -- befrielsearmé..nn.1
  befrielsefront_1_N = mkN "befrielsefront" "befrielsefronter" ; -- befrielsefront..nn.1
  befrielsekamp_1_N = mkN "befrielsekamp" "befrielsekamper" ; -- befrielsekamp..nn.1
  befrielsekrig_1_N = mkN "befrielsekrig" neutrum  ; -- befrielsekrig..nn.1
  befrielserörelse_1_N = mkN "befrielserörelse" "befrielserörelser" ; -- befrielserörelse..nn.1
  befrukta_1_V = mkV "befruktar" ; -- befrukta..vb.1
  befruktande_1_N = mkN "befruktande" ; -- befruktande..nn.1
  befruktning_1_N = mkN "befruktning" ; -- befruktning..nn.1
  befruktningsorgan_1_N = mkN "befruktningsorgan" neutrum  ; -- befruktningsorgan..nn.1
  befruktningsögonblick_1_N = mkN "befruktningsögonblick" neutrum  ; -- befruktningsögonblick..nn.1
  befrynda_1_V = mkV "befryndar" ; -- befrynda..vb.1
  befryndad_1_A = mkA "befryndad" ; -- befryndad..av.1
  befryndande_1_N = mkN "befryndande" ; -- befryndande..nn.1
  befrämja_1_V = mkV "befrämjar" ; -- befrämja..vb.1
  befrämjande_1_N = mkN "befrämjande" ; -- befrämjande..nn.1
  befrämjare_1_N = mkN "befrämjare" utrum  ; -- befrämjare..nn.1
  befullmäktiga_1_V = mkV "befullmäktigar" ; -- befullmäktiga..vb.1
  befullmäktigande_1_N = mkN "befullmäktigande" ; -- befullmäktigande..nn.1
  befäl_1_N = mkN "befäl" neutrum  ; -- befäl..nn.1
  befäl_2_N = mkN "befäl" neutrum  ; -- befäl..nn.2
  befälhavande_1_A = mkA "befälhavande" ; -- befälhavande..av.1
  befälhavare_1_N = mkN "befälhavare" utrum  ; -- befälhavare..nn.1
  befälselev_1_N = mkN "befälselev" "befälselever" ; -- befälselev..nn.1
  befälsföring_1_N = mkN "befälsföring" ; -- befälsföring..nn.1
  befälsgrad_1_N = mkN "befälsgrad" "befälsgrader" ; -- befälsgrad..nn.1
  befälsordning_1_N = mkN "befälsordning" ; -- befälsordning..nn.1
  befälsperson_1_N = mkN "befälsperson" "befälspersoner" ; -- befälsperson..nn.1
  befälsställning_1_N = mkN "befälsställning" ; -- befälsställning..nn.1
  befälstalang_1_N = mkN "befälstalang" "befälstalanger" ; -- befälstalang..nn.1
  befälstecken_1_N = mkN "befälstecken" "befälstecknet" "befälstecken" "befälstecknen" ; -- befälstecken..nn.1
  befälsuppdrag_1_N = mkN "befälsuppdrag" neutrum  ; -- befälsuppdrag..nn.1
  befängd_1_A = mkA "befängd" "befängt" ; -- befängd..av.1
  befängdhet_1_N = mkN "befängdhet" "befängdheter" ; -- befängdhet..nn.1
  befästa_1_V = mkV "befästa" "befäster" "befäst" "befäste" "befäst" "befäst" ; -- befästa..vb.1
  befästande_1_N = mkN "befästande" ; -- befästande..nn.1
  befästning_1_N = mkN "befästning" ; -- befästning..nn.1
  befästningsgrav_1_N = mkN "befästningsgrav" ; -- befästningsgrav..nn.1
  befästningskonst_1_N = mkN "befästningskonst" ; -- befästningskonst..nn.1
  befästningslinje_1_N = mkN "befästningslinje" "befästningslinjer" ; -- befästningslinje..nn.1
  befästningsskydd_1_N = mkN "befästningsskydd" neutrum  ; -- befästningsskydd..nn.1
  befästningsverk_1_N = mkN "befästningsverk" neutrum  ; -- befästningsverk..nn.1
  begabba_1_V = mkV "begabbar" ; -- begabba..vb.1
  begabbande_1_N = mkN "begabbande" ; -- begabbande..nn.1
  begabbare_1_N = mkN "begabbare" utrum  ; -- begabbare..nn.1
  begabberi_1_N = mkN "begabberi" neutrum  ; -- begabberi..nn.1
  begagna_1_V = mkV "begagnar" ; -- begagna..vb.1
  begagnad_1_A = mkA "begagnad" ; -- begagnad..av.1
  begagnande_1_N = mkN "begagnande" ; -- begagnande..nn.1
  begagnatköp_1_N = mkN "begagnatköp" neutrum  ; -- begagnatköp..nn.1
  begapa_1_V = mkV "begapar" ; -- begapa..vb.1
  begapande_1_N = mkN "begapande" ; -- begapande..nn.1
  begapning_1_N = mkN "begapning" ; -- begapning..nn.1
  begeistrad_1_A = mkA "begeistrad" ; -- begeistrad..av.1
  begeistring_1_N = mkN "begeistring" ; -- begeistring..nn.1
  beginerå_1_N = mkN "beginerå" "beginerån" "beginerår" "beginerårna" ; -- beginerå..nn.1
  begivande_1_N = mkN "begivande" ; -- begivande..nn.1
  begiven_1_A = mkA "begiven" ; -- begiven..av.1
  begivenhet_1_N = mkN "begivenhet" "begivenheter" ; -- begivenhet..nn.1
  begivenhet_2_N = mkN "begivenhet" ; -- begivenhet..nn.2
  begjuta_1_V = mkV "begjuta" "begöt" "begjutit" ; -- begjuta..vb.1
  begjutande_1_N = mkN "begjutande" ; -- begjutande..nn.1
  begjutning_1_N = mkN "begjutning" ; -- begjutning..nn.1
  beglänsa_1_V = mkV "beglänser" ; -- beglänsa..vb.1
  beglänsande_1_N = mkN "beglänsande" ; -- beglänsande..nn.1
  beglänsning_1_N = mkN "beglänsning" ; -- beglänsning..nn.1
  begonia_1_N = mkN "begonia" ; -- begonia..nn.1
  begrava_1_V = mkV "begraver" ; -- begrava..vb.1
  begravande_1_N = mkN "begravande" ; -- begravande..nn.1
  begravning_1_N = mkN "begravning" ; -- begravning..nn.1
  begravningsakt_1_N = mkN "begravningsakt" "begravningsakter" ; -- begravningsakt..nn.1
  begravningsbok_1_N = mkN "begravningsbok" "begravningsböcker" ; -- begravningsbok..nn.1
  begravningsbyrå_1_N = mkN "begravningsbyrå" "begravningsbyråer" ; -- begravningsbyrå..nn.1
  begravningsceremoni_1_N = mkN "begravningsceremoni" "begravningsceremonier" ; -- begravningsceremoni..nn.1
  begravningsdag_1_N = mkN "begravningsdag" ; -- begravningsdag..nn.1
  begravningsentreprenör_1_N = mkN "begravningsentreprenör" "begravningsentreprenörer" ; -- begravningsentreprenör..nn.1
  begravningsgäst_1_N = mkN "begravningsgäst" "begravningsgäster" ; -- begravningsgäst..nn.1
  begravningshjälp_1_N = mkN "begravningshjälp" ; -- begravningshjälp..nn.1
  begravningshögtidlighet_1_N = mkN "begravningshögtidlighet" "begravningshögtidligheter" ; -- begravningshögtidlighet..nn.1
  begravningskalas_1_N = mkN "begravningskalas" neutrum  ; -- begravningskalas..nn.1
  begravningskassa_1_N = mkN "begravningskassa" ; -- begravningskassa..nn.1
  begravningskrans_1_N = mkN "begravningskrans" ; -- begravningskrans..nn.1
  begravningsmarsch_1_N = mkN "begravningsmarsch" "begravningsmarscher" ; -- begravningsmarsch..nn.1
  begravningsmin_1_N = mkN "begravningsmin" "begravningsminer" ; -- begravningsmin..nn.1
  begravningsplats_1_N = mkN "begravningsplats" "begravningsplatser" ; -- begravningsplats..nn.1
  begravningspoesi_1_N = mkN "begravningspoesi" ; -- begravningspoesi..nn.1
  begravningsprocession_1_N = mkN "begravningsprocession" ; -- begravningsprocession..nn.1
  begravningspsalm_1_N = mkN "begravningspsalm" "begravningspsalmer" ; -- begravningspsalm..nn.1
  begravningsringning_1_N = mkN "begravningsringning" ; -- begravningsringning..nn.1
  begravningsspel_1_N = mkN "begravningsspel" "begravningsspelet" "begravningsspel" "begravningsspelen" ; -- begravningsspel..nn.1
  begravningståg_1_N = mkN "begravningståg" neutrum  ; -- begravningståg..nn.1
  begrepp_1_N = mkN "begrepp" neutrum  ; -- begrepp..nn.1
  begreppsanalys_1_N = mkN "begreppsanalys" "begreppsanalyser" ; -- begreppsanalys..nn.1
  begreppsanalytisk_1_A = mkA "begreppsanalytisk" ; -- begreppsanalytisk..av.1
  begreppsapparat_1_N = mkN "begreppsapparat" "begreppsapparater" ; -- begreppsapparat..nn.1
  begreppsbestämning_1_N = mkN "begreppsbestämning" ; -- begreppsbestämning..nn.1
  begreppsbildning_1_N = mkN "begreppsbildning" ; -- begreppsbildning..nn.1
  begreppsexercis_1_N = mkN "begreppsexercis" "begreppsexerciser" ; -- begreppsexercis..nn.1
  begreppsförvirring_1_N = mkN "begreppsförvirring" ; -- begreppsförvirring..nn.1
  begreppsindelning_1_N = mkN "begreppsindelning" ; -- begreppsindelning..nn.1
  begreppsinnehåll_1_N = mkN "begreppsinnehåll" neutrum  ; -- begreppsinnehåll..nn.1
  begreppslig_1_A = mkA "begreppslig" ; -- begreppslig..av.1
  begreppslighet_1_N = mkN "begreppslighet" ; -- begreppslighet..nn.1
  begreppsmässig_1_A = mkA "begreppsmässig" ; -- begreppsmässig..av.1
  begreppsmässighet_1_N = mkN "begreppsmässighet" ; -- begreppsmässighet..nn.1
  begreppsnivå_1_N = mkN "begreppsnivå" "begreppsnivåer" ; -- begreppsnivå..nn.1
  begreppssystem_1_N = mkN "begreppssystem" neutrum  ; -- begreppssystem..nn.1
  begripa_1_V = mkV "begripa" "begrep" "begripit" ; -- begripa..vb.1
  begripande_1_N = mkN "begripande" ; -- begripande..nn.1
  begriplig_1_A = mkA "begriplig" ; -- begriplig..av.1
  begriplighet_1_N = mkN "begriplighet" "begripligheter" ; -- begriplighet..nn.1
  begrunda_1_V = mkV "begrundar" ; -- begrunda..vb.1
  begrundande_1_N = mkN "begrundande" ; -- begrundande..nn.1
  begränsa_1_V = mkV "begränsar" ; -- begränsa..vb.1
  begränsad_1_A = mkA "begränsad" ; -- begränsad..av.1
  begränsande_1_N = mkN "begränsande" ; -- begränsande..nn.1
  begränsning_1_N = mkN "begränsning" ; -- begränsning..nn.1
  begränsningslinje_1_N = mkN "begränsningslinje" "begränsningslinjer" ; -- begränsningslinje..nn.1
  begränsningsyta_1_N = mkN "begränsningsyta" ; -- begränsningsyta..nn.1
  begråta_1_V = mkV "begråta" "begrät" "begråtit" ; -- begråta..vb.1
  begråtande_1_N = mkN "begråtande" ; -- begråtande..nn.1
  begynna_1_V = mkV "begynna" "begynte" "begynt" ; -- begynna..vb.1
  begynnande_1_N = mkN "begynnande" ; -- begynnande..nn.1
  begynnelse_1_N = mkN "begynnelse" "begynnelser" ; -- begynnelse..nn.1
  begynnelsebokstav_1_N = mkN "begynnelsebokstav" "begynnelsebokstäver" ; -- begynnelsebokstav..nn.1
  begynnelsehastighet_1_N = mkN "begynnelsehastighet" "begynnelsehastigheter" ; -- begynnelsehastighet..nn.1
  begynnelselön_1_N = mkN "begynnelselön" "begynnelselöner" ; -- begynnelselön..nn.1
  begynnelserim_1_N = mkN "begynnelserim" "begynnelserimmet" "begynnelserim" "begynnelserimmen" ; -- begynnelserim..nn.1
  begynnelseskede_1_N = mkN "begynnelseskede" ; -- begynnelseskede..nn.1
  begynnelsespråk_1_N = mkN "begynnelsespråk" neutrum  ; -- begynnelsespråk..nn.1
  begynnelsestadium_1_N = mkN "begynnelsestadium" "begynnelsestadiet" "begynnelsestadier" "begynnelsestadierna" ; -- begynnelsestadium..nn.1
  begynnelsevärde_1_N = mkN "begynnelsevärde" ; -- begynnelsevärde..nn.1
  begär_1_N = mkN "begär" neutrum  ; -- begär..nn.1
  begära_1_V = mkV "begära" "begärde" "begärt" ; -- begära..vb.1
  begärande_1_N = mkN "begärande" ; -- begärande..nn.1
  begärelse_1_N = mkN "begärelse" "begärelser" ; -- begärelse..nn.1
  begärlig_1_A = mkA "begärlig" ; -- begärlig..av.1
  begärlighet_1_N = mkN "begärlighet" "begärligheter" ; -- begärlighet..nn.1
  begärsliv_1_N = mkN "begärsliv" neutrum  ; -- begärsliv..nn.1
  begå_1_V = mkV "begå" "begår" "begå" "begick" "begått" "begången" ; -- begå..vb.1
  begående_1_N = mkN "begående" ; -- begående..nn.1
  begåva_1_V = mkV "begåvar" ; -- begåva..vb.1
  begåvad_1_A = mkA "begåvad" ; -- begåvad..av.1
  begåvande_1_N = mkN "begåvande" ; -- begåvande..nn.1
  begåvning_1_N = mkN "begåvning" ; -- begåvning..nn.1
  begåvning_2_N = mkN "begåvning" ; -- begåvning..nn.2
  begåvningsmässig_1_A = mkA "begåvningsmässig" ; -- begåvningsmässig..av.1
  begåvningsreserv_1_N = mkN "begåvningsreserv" "begåvningsreserver" ; -- begåvningsreserv..nn.1
  behag_1_N = mkN "behag" neutrum  ; -- behag..nn.1
  behaga_1_V = mkV "behagar" ; -- behaga..vb.1
  behagande_1_N = mkN "behagande" ; -- behagande..nn.1
  behagfull_1_A = mkA "behagfull" ; -- behagfull..av.1
  behagfullhet_1_N = mkN "behagfullhet" "behagfullheter" ; -- behagfullhet..nn.1
  behaglig_1_A = mkA "behaglig" ; -- behaglig..av.1
  behaglighet_1_N = mkN "behaglighet" "behagligheter" ; -- behaglighet..nn.1
  behagsjuk_1_A = mkA "behagsjuk" ; -- behagsjuk..av.1
  behagsjuka_1_N = mkN "behagsjuka" ; -- behagsjuka..nn.1
  behagsjukhet_1_N = mkN "behagsjukhet" ; -- behagsjukhet..nn.1
  behandla_1_V = mkV "behandlar" ; -- behandla..vb.1
  behandlande_1_N = mkN "behandlande" ; -- behandlande..nn.1
  behandling_1_N = mkN "behandling" ; -- behandling..nn.1
  behandlingsalternativ_1_N = mkN "behandlingsalternativ" neutrum  ; -- behandlingsalternativ..nn.1
  behandlingsbar_1_A = mkA "behandlingsbar" ; -- behandlingsbar..av.1
  behandlingsbarhet_1_N = mkN "behandlingsbarhet" ; -- behandlingsbarhet..nn.1
  behandlingsenhet_1_N = mkN "behandlingsenhet" "behandlingsenheter" ; -- behandlingsenhet..nn.1
  behandlingshem_1_N = mkN "behandlingshem" "behandlingshemmet" "behandlingshem" "behandlingshemmen" ; -- behandlingshem..nn.1
  behandlingsmetod_1_N = mkN "behandlingsmetod" "behandlingsmetoder" ; -- behandlingsmetod..nn.1
  behandlingsmässig_1_A = mkA "behandlingsmässig" ; -- behandlingsmässig..av.1
  behandlingsprogram_1_N = mkN "behandlingsprogram" "behandlingsprogrammet" "behandlingsprogram" "behandlingsprogrammen" ; -- behandlingsprogram..nn.1
  behandlingsrum_1_N = mkN "behandlingsrum" "behandlingsrummet" "behandlingsrum" "behandlingsrummen" ; -- behandlingsrum..nn.1
  behandlingssätt_1_N = mkN "behandlingssätt" neutrum  ; -- behandlingssätt..nn.1
  behandskad_1_A = mkA "behandskad" ; -- behandskad..av.1
  behaviorism_1_N = mkN "behaviorism" "behaviorismer" ; -- behaviorism..nn.1
  behaviorist_1_N = mkN "behaviorist" "behaviorister" ; -- behaviorist..nn.1
  behavioristisk_1_A = mkA "behavioristisk" ; -- behavioristisk..av.1
  behjälplig_1_A = mkA "behjälplig" ; -- behjälplig..av.1
  behjälplighet_1_N = mkN "behjälplighet" ; -- behjälplighet..nn.1
  behjärtad_1_A = mkA "behjärtad" ; -- behjärtad..av.1
  behjärtansvärd_1_A = mkA "behjärtansvärd" "behjärtansvärt" ; -- behjärtansvärd..av.1
  behjärtenhet_1_N = mkN "behjärtenhet" "behjärtenheter" ; -- behjärtenhet..nn.1
  behornad_1_A = mkA "behornad" ; -- behornad..av.1
  behov_1_N = mkN "behov" neutrum  ; -- behov..nn.1
  behovlös_1_A = mkA "behovlös" ; -- behovlös..av.1
  behovlöshet_1_N = mkN "behovlöshet" "behovlösheter" ; -- behovlöshet..nn.1
  behovsprincip_1_N = mkN "behovsprincip" "behovsprinciper" ; -- behovsprincip..nn.1
  behovsprövad_1_A = mkA "behovsprövad" ; -- behovsprövad..av.1
  behovsprövning_1_N = mkN "behovsprövning" ; -- behovsprövning..nn.1
  behovstillfredsställelse_1_N = mkN "behovstillfredsställelse" "behovstillfredsställelser" ; -- behovstillfredsställelse..nn.1
  behovstryck_1_N = mkN "behovstryck" neutrum  ; -- behovstryck..nn.1
  behäftad_1_A = mkA "behäftad" ; -- behäftad..av.1
  behändig_1_A = mkA "behändig" ; -- behändig..av.1
  behändighet_1_N = mkN "behändighet" ; -- behändighet..nn.1
  behänga_1_V = mkV "behänger" ; -- behänga..vb.1
  behängande_1_N = mkN "behängande" ; -- behängande..nn.1
  behängning_1_N = mkN "behängning" ; -- behängning..nn.1
  behärska_1_V = mkV "behärskar" ; -- behärska..vb.1
  behärskad_1_A = mkA "behärskad" ; -- behärskad..av.1
  behärskande_1_N = mkN "behärskande" ; -- behärskande..nn.1
  behärskning_1_N = mkN "behärskning" ; -- behärskning..nn.1
  behå_1_N = mkN "behå" ; -- behå..nn.1
  behålla_1_V = mkV "behålla" "behöll" "behållit" ; -- behålla..vb.1
  behållande_1_N = mkN "behållande" ; -- behållande..nn.1
  behållare_1_N = mkN "behållare" utrum  ; -- behållare..nn.1
  behållen_1_A = mkA "behållen" ; -- behållen..av.1
  behållning_1_N = mkN "behållning" ; -- behållning..nn.1
  behårad_1_A = mkA "behårad" ; -- behårad..av.1
  behåring_1_N = mkN "behåring" ; -- behåring..nn.1
  behörig_1_A = mkA "behörig" ; -- behörig..av.1
  behörighet_1_N = mkN "behörighet" "behörigheter" ; -- behörighet..nn.1
  behörighetsbevis_1_N = mkN "behörighetsbevis" neutrum  ; -- behörighetsbevis..nn.1
  behöva_1_V = mkV "behöver" ; -- behöva..vb.1
  behövande_1_A = mkA "behövande" ; -- behövande..av.1
  behövande_1_N = mkN "behövande" ; -- behövande..nn.1
  behövlig_1_A = mkA "behövlig" ; -- behövlig..av.1
  behövlighet_1_N = mkN "behövlighet" ; -- behövlighet..nn.1
  beige_1_A = mkA "beige" "beiget" ; -- beige..av.1
  beige_1_N = mkN "beige" ; -- beige..nn.1
  beivra_1_V = mkV "beivrar" ; -- beivra..vb.1
  beivrande_1_N = mkN "beivrande" ; -- beivrande..nn.1
  beivrare_1_N = mkN "beivrare" utrum  ; -- beivrare..nn.1
  bej_1_N = mkN "bej" "bejer" ; -- bej..nn.1
  bejaka_1_V = mkV "bejakar" ; -- bejaka..vb.1
  bejakande_1_N = mkN "bejakande" ; -- bejakande..nn.1
  bejakning_1_N = mkN "bejakning" ; -- bejakning..nn.1
  bejubla_1_V = mkV "bejublar" ; -- bejubla..vb.1
  bejublande_1_N = mkN "bejublande" ; -- bejublande..nn.1
  bekaja_1_V = mkV "bekajar" ; -- bekaja..vb.1
  bekajande_1_N = mkN "bekajande" ; -- bekajande..nn.1
  bekant_1_A = mkA "bekant" "bekant" ; -- bekant..av.1
  bekant_1_N = mkN "bekant" "bekanten" "bekanta" "bekanterna" ; -- bekant..nn.1
  bekanta_1_V = mkV "bekantar" ; -- bekanta..vb.1
  bekantande_1_N = mkN "bekantande" ; -- bekantande..nn.1
  bekantgöra_1_V = mkV "bekantgöra" "bekantgjorde" "bekantgjort" ; -- bekantgöra..vb.1
  bekantgörande_1_N = mkN "bekantgörande" ; -- bekantgörande..nn.1
  bekanting_1_N = mkN "bekanting" ; -- bekanting..nn.1
  bekantskap_1_N = mkN "bekantskap" "bekantskaper" ; -- bekantskap..nn.1
  bekantskapskrets_1_N = mkN "bekantskapskrets" ; -- bekantskapskrets..nn.1
  bekika_1_V = mkV "bekikar" ; -- bekika..vb.1
  bekikande_1_N = mkN "bekikande" ; -- bekikande..nn.1
  beklaga_1_V = mkV "beklagar" ; -- beklaga..vb.1
  beklagande_1_N = mkN "beklagande" ; -- beklagande..nn.1
  beklagansvärd_1_A = mkA "beklagansvärd" "beklagansvärt" ; -- beklagansvärd..av.1
  beklaglig_1_A = mkA "beklaglig" ; -- beklaglig..av.1
  beklagligen_1_Adv = mkAdv "beklagligen" ; -- beklagligen..ab.1
  beklaglighet_1_N = mkN "beklaglighet" ; -- beklaglighet..nn.1
  beklagligtvis_1_Adv = mkAdv "beklagligtvis" ; -- beklagligtvis..ab.1
  beklä_1_V = mkV "beklä" "beklädde" "beklätt" ; -- beklä..vb.1
  beklädande_1_N = mkN "beklädande" ; -- beklädande..nn.1
  beklädnad_1_N = mkN "beklädnad" "beklädnader" ; -- beklädnad..nn.1
  beklädning_1_N = mkN "beklädning" ; -- beklädning..nn.1
  beklämd_1_A = mkA "beklämd" "beklämt" ; -- beklämd..av.1
  beklämdhet_1_N = mkN "beklämdhet" ; -- beklämdhet..nn.1
  beklämmande_1_A = mkA "beklämmande" ; -- beklämmande..av.1
  beklämning_1_N = mkN "beklämning" ; -- beklämning..nn.1
  beknip_1_N = mkN "beknip" neutrum  ; -- beknip..nn.1
  beknipa_1_V = mkV "beknipa" "beknep" "beknipit" ; -- beknipa..vb.1
  beknipande_1_N = mkN "beknipande" ; -- beknipande..nn.1
  bekomma_1_V = mkV "bekomma" "bekom" "bekommit" ; -- bekomma..vb.1
  bekommande_1_N = mkN "bekommande" ; -- bekommande..nn.1
  bekosta_1_V = mkV "bekostar" ; -- bekosta..vb.1
  bekostande_1_N = mkN "bekostande" ; -- bekostande..nn.1
  bekostnad_1_N = mkN "bekostnad" "bekostnader" ; -- bekostnad..nn.1
  bekransa_1_V = mkV "bekransar" ; -- bekransa..vb.1
  bekransande_1_N = mkN "bekransande" ; -- bekransande..nn.1
  bekransning_1_N = mkN "bekransning" ; -- bekransning..nn.1
  bekriga_1_V = mkV "bekrigar" ; -- bekriga..vb.1
  bekrigande_1_N = mkN "bekrigande" ; -- bekrigande..nn.1
  bekräfta_1_V = mkV "bekräftar" ; -- bekräfta..vb.1
  bekräftande_1_N = mkN "bekräftande" ; -- bekräftande..nn.1
  bekräftelse_1_N = mkN "bekräftelse" "bekräftelser" ; -- bekräftelse..nn.1
  bekräftelsebehov_1_N = mkN "bekräftelsebehov" neutrum  ; -- bekräftelsebehov..nn.1
  bekräftelsesökande_1_A = mkA "bekräftelsesökande" ; -- bekräftelsesökande..av.1
  bekröna_1_V = mkV "bekröna" "bekröner" "bekrön" "bekrönte" "bekrönt" "bekrönt" ; -- bekröna..vb.1
  bekrönande_1_N = mkN "bekrönande" ; -- bekrönande..nn.1
  bekröning_1_N = mkN "bekröning" ; -- bekröning..nn.1
  bekväm_1_A = mkA "bekväm" ; -- bekväm..av.1
  bekvämhet_1_N = mkN "bekvämhet" ; -- bekvämhet..nn.1
  bekvämlighet_1_N = mkN "bekvämlighet" "bekvämligheter" ; -- bekvämlighet..nn.1
  bekvämlighetsflagg_1_N = mkN "bekvämlighetsflagg" ; -- bekvämlighetsflagg..nn.1
  bekvämlighetshänsyn_1_N = mkN "bekvämlighetshänsyn" "bekvämlighetshänsynen" "bekvämlighetshänsyn" "bekvämlighetshänsynen" ; -- bekvämlighetshänsyn..nn.1
  bekvämlighetsinrättning_1_N = mkN "bekvämlighetsinrättning" ; -- bekvämlighetsinrättning..nn.1
  bekymmer_1_N = mkN "bekymmer" neutrum  ; -- bekymmer..nn.1
  bekymmerfri_1_A = mkA "bekymmerfri" "bekymmerfritt" ; -- bekymmerfri..av.1
  bekymmersam_1_A = mkA "bekymmersam" "bekymmersamt" "bekymmersamma" "bekymmersamma" "bekymmersammare" "bekymmersammast" "bekymmersammaste" ; -- bekymmersam..av.1
  bekymmersamhet_1_N = mkN "bekymmersamhet" ; -- bekymmersamhet..nn.1
  bekymmersfri_1_A = mkA "bekymmersfri" "bekymmersfritt" ; -- bekymmersfri..av.1
  bekymmersfull_1_A = mkA "bekymmersfull" ; -- bekymmersfull..av.1
  bekymmerslös_1_A = mkA "bekymmerslös" ; -- bekymmerslös..av.1
  bekymmerslöshet_1_N = mkN "bekymmerslöshet" ; -- bekymmerslöshet..nn.1
  bekymmersrynka_1_N = mkN "bekymmersrynka" ; -- bekymmersrynka..nn.1
  bekymra_1_V = mkV "bekymrar" ; -- bekymra..vb.1
  bekymrad_1_A = mkA "bekymrad" ; -- bekymrad..av.1
  bekymrande_1_N = mkN "bekymrande" ; -- bekymrande..nn.1
  bekyttad_1_A = mkA "bekyttad" ; -- bekyttad..av.1
  bekämpa_1_V = mkV "bekämpar" ; -- bekämpa..vb.1
  bekämpande_1_N = mkN "bekämpande" ; -- bekämpande..nn.1
  bekämpare_1_N = mkN "bekämpare" utrum  ; -- bekämpare..nn.1
  bekämpning_1_N = mkN "bekämpning" ; -- bekämpning..nn.1
  bekämpningsmedel_1_N = mkN "bekämpningsmedel" neutrum  ; -- bekämpningsmedel..nn.1
  bekänna_1_V = mkV "bekänna" "bekände" "bekänt" ; -- bekänna..vb.1
  bekännande_1_N = mkN "bekännande" ; -- bekännande..nn.1
  bekännare_1_N = mkN "bekännare" utrum  ; -- bekännare..nn.1
  bekännelse_1_N = mkN "bekännelse" "bekännelser" ; -- bekännelse..nn.1
  bekännelsefrihet_1_N = mkN "bekännelsefrihet" "bekännelsefriheter" ; -- bekännelsefrihet..nn.1
  bekännelseroman_1_N = mkN "bekännelseroman" "bekännelseromaner" ; -- bekännelseroman..nn.1
  bekännelseskrift_1_N = mkN "bekännelseskrift" "bekännelseskrifter" ; -- bekännelseskrift..nn.1
  belacka_1_V = mkV "belackar" ; -- belacka..vb.1
  belackande_1_N = mkN "belackande" ; -- belackande..nn.1
  belackare_1_N = mkN "belackare" utrum  ; -- belackare..nn.1
  belag_1_N = mkN "belag" neutrum  ; -- belag..nn.1
  belamra_1_V = mkV "belamrar" ; -- belamra..vb.1
  belamrande_1_N = mkN "belamrande" ; -- belamrande..nn.1
  belanga_1_V = mkV "belangar" ; -- belanga..vb.1
  belangande_1_N = mkN "belangande" ; -- belangande..nn.1
  belasta_1_V = mkV "belastar" ; -- belasta..vb.1
  belastande_1_N = mkN "belastande" ; -- belastande..nn.1
  belastning_1_N = mkN "belastning" ; -- belastning..nn.1
  belastningsregister_1_N = mkN "belastningsregister" neutrum  ; -- belastningsregister..nn.1
  belastningsskada_1_N = mkN "belastningsskada" ; -- belastningsskada..nn.1
  belastningsuppgift_1_N = mkN "belastningsuppgift" "belastningsuppgifter" ; -- belastningsuppgift..nn.1
  belcanto_1_N = mkN "belcanto" ; -- belcanto..nn.1
  bele_1_V = mkV "bele" "belog" "belett" ; -- bele..vb.1
  beledsaga_1_V = mkV "beledsagar" ; -- beledsaga..vb.1
  beledsagande_1_N = mkN "beledsagande" ; -- beledsagande..nn.1
  beledsagare_1_N = mkN "beledsagare" utrum  ; -- beledsagare..nn.1
  beledsagning_1_N = mkN "beledsagning" ; -- beledsagning..nn.1
  beleende_1_N = mkN "beleende" ; -- beleende..nn.1
  belemnit_1_N = mkN "belemnit" "belemniter" ; -- belemnit..nn.1
  belevad_1_A = mkA "belevad" ; -- belevad..av.1
  belevenhet_1_N = mkN "belevenhet" "belevenheter" ; -- belevenhet..nn.1
  belgare_1_N = mkN "belgare" utrum  ; -- belgare..nn.1
  belgier_1_N = mkN "belgier" "belgiern" "belgier" "belgierna" ; -- belgier..nn.1
  belgisk_1_A = mkA "belgisk" ; -- belgisk..av.1
  belgiska_1_N = mkN "belgiska" ; -- belgiska..nn.1
  belizier_1_N = mkN "belizier" "beliziern" "belizier" "belizierna" ; -- belizier..nn.1
  belizisk_1_A = mkA "belizisk" ; -- belizisk..av.1
  beliziska_1_N = mkN "beliziska" ; -- beliziska..nn.1
  beljuga_1_V = mkV "beljuga" "beljög" "beljugit" ; -- beljuga..vb.1
  beljugande_1_N = mkN "beljugande" ; -- beljugande..nn.1
  belladonna_1_N = mkN "belladonna" ; -- belladonna..nn.1
  belletrist_1_N = mkN "belletrist" "belletrister" ; -- belletrist..nn.1
  belletristik_1_N = mkN "belletristik" ; -- belletristik..nn.1
  belletristisk_1_A = mkA "belletristisk" ; -- belletristisk..av.1
  bellis_1_N = mkN "bellis" ; -- bellis..nn.1
  bellit_1_N = mkN "bellit" ; -- bellit..nn.1
  belopp_1_N = mkN "belopp" neutrum  ; -- belopp..nn.1
  belysa_1_V = mkV "belyser" ; -- belysa..vb.1
  belysande_1_A = mkA "belysande" ; -- belysande..av.1
  belysande_1_N = mkN "belysande" ; -- belysande..nn.1
  belysning_1_N = mkN "belysning" ; -- belysning..nn.1
  belysningsarmatur_1_N = mkN "belysningsarmatur" "belysningsarmaturer" ; -- belysningsarmatur..nn.1
  belysningsmässa_1_N = mkN "belysningsmässa" ; -- belysningsmässa..nn.1
  belysningsström_1_N = mkN "belysningsström" "belysningsströmmen" "belysningsströmmar" "belysningsströmmarna" ; -- belysningsström..nn.1
  belysningsstyrka_1_N = mkN "belysningsstyrka" ; -- belysningsstyrka..nn.1
  belägen_1_A = mkA "belägen" ; -- belägen..av.1
  belägenhet_1_N = mkN "belägenhet" "belägenheter" ; -- belägenhet..nn.1
  belägg_1_N = mkN "belägg" neutrum  ; -- belägg..nn.1
  belägga_1_V = mkV "belägga" "bela" "belagt" ; -- belägga..vb.1
  beläggande_1_N = mkN "beläggande" ; -- beläggande..nn.1
  beläggning_1_N = mkN "beläggning" ; -- beläggning..nn.1
  beläggningsgrad_1_N = mkN "beläggningsgrad" "beläggningsgrader" ; -- beläggningsgrad..nn.1
  beläggningsring_1_N = mkN "beläggningsring" ; -- beläggningsring..nn.1
  beläggningssnöre_1_N = mkN "beläggningssnöre" ; -- beläggningssnöre..nn.1
  beläggningsstämpel_1_N = mkN "beläggningsstämpel" ; -- beläggningsstämpel..nn.1
  beläggställe_1_N = mkN "beläggställe" ; -- beläggställe..nn.1
  belägra_1_V = mkV "belägrar" ; -- belägra..vb.1
  belägrande_1_N = mkN "belägrande" ; -- belägrande..nn.1
  belägring_1_N = mkN "belägring" ; -- belägring..nn.1
  belägringsartilleri_1_N = mkN "belägringsartilleri" neutrum  ; -- belägringsartilleri..nn.1
  belägringskonst_1_N = mkN "belägringskonst" ; -- belägringskonst..nn.1
  belägringstillstånd_1_N = mkN "belägringstillstånd" neutrum  ; -- belägringstillstånd..nn.1
  belägringstorn_1_N = mkN "belägringstorn" neutrum  ; -- belägringstorn..nn.1
  beläsenhet_1_N = mkN "beläsenhet" "beläsenheter" ; -- beläsenhet..nn.1
  beläst_1_A = mkA "beläst" "beläst" ; -- beläst..av.1
  belästhet_1_N = mkN "belästhet" "belästheter" ; -- belästhet..nn.1
  beläte_1_N = mkN "beläte" ; -- beläte..nn.1
  belåna_1_V = mkV "belånar" ; -- belåna..vb.1
  belånande_1_N = mkN "belånande" ; -- belånande..nn.1
  belåning_1_N = mkN "belåning" ; -- belåning..nn.1
  belåningsgrad_1_N = mkN "belåningsgrad" "belåningsgrader" ; -- belåningsgrad..nn.1
  belåten_1_A = mkA "belåten" ; -- belåten..av.1
  belåtenhet_1_N = mkN "belåtenhet" "belåtenheter" ; -- belåtenhet..nn.1
  belöna_1_V = mkV "belönar" ; -- belöna..vb.1
  belönande_1_N = mkN "belönande" ; -- belönande..nn.1
  belöning_1_N = mkN "belöning" ; -- belöning..nn.1
  belöningsmedalj_1_N = mkN "belöningsmedalj" "belöningsmedaljer" ; -- belöningsmedalj..nn.1
  belöningssystem_1_N = mkN "belöningssystem" neutrum  ; -- belöningssystem..nn.1
  bemanna_1_V = mkV "bemannar" ; -- bemanna..vb.1
  bemannad_1_A = mkA "bemannad" ; -- bemannad..av.1
  bemannande_1_N = mkN "bemannande" ; -- bemannande..nn.1
  bemanning_1_N = mkN "bemanning" ; -- bemanning..nn.1
  bemanningsföretag_1_N = mkN "bemanningsföretag" neutrum  ; -- bemanningsföretag..nn.1
  bemanningsverksamhet_1_N = mkN "bemanningsverksamhet" "bemanningsverksamheter" ; -- bemanningsverksamhet..nn.1
  bemantla_1_V = mkV "bemantlar" ; -- bemantla..vb.1
  bemantlande_1_N = mkN "bemantlande" ; -- bemantlande..nn.1
  bemedla_1_V = mkV "bemedlar" ; -- bemedla..vb.1
  bemedlad_1_A = mkA "bemedlad" ; -- bemedlad..av.1
  bemedlande_1_N = mkN "bemedlande" ; -- bemedlande..nn.1
  bemedling_1_N = mkN "bemedling" ; -- bemedling..nn.1
  bemyndiga_1_V = mkV "bemyndigar" ; -- bemyndiga..vb.1
  bemyndigande_1_N = mkN "bemyndigande" ; -- bemyndigande..nn.1
  bemälde_1_A = mkA "bemälde" ; -- bemälde..av.1
  bemänga_1_V = mkV "bemänger" ; -- bemänga..vb.1
  bemängande_1_N = mkN "bemängande" ; -- bemängande..nn.1
  bemärka_1_V = mkV "bemärker" ; -- bemärka..vb.1
  bemärkande_1_N = mkN "bemärkande" ; -- bemärkande..nn.1
  bemärkelse_1_N = mkN "bemärkelse" "bemärkelser" ; -- bemärkelse..nn.1
  bemärkelsedag_1_N = mkN "bemärkelsedag" ; -- bemärkelsedag..nn.1
  bemärkt_1_A = mkA "bemärkt" "bemärkt" ; -- bemärkt..av.1
  bemärkthet_1_N = mkN "bemärkthet" ; -- bemärkthet..nn.1
  bemästra_1_V = mkV "bemästrar" ; -- bemästra..vb.1
  bemästrande_1_N = mkN "bemästrande" ; -- bemästrande..nn.1
  bemåla_1_V = mkV "bemålar" ; -- bemåla..vb.1
  bemålande_1_N = mkN "bemålande" ; -- bemålande..nn.1
  bemålning_1_N = mkN "bemålning" ; -- bemålning..nn.1
  bemödande_1_N = mkN "bemödande" ; -- bemödande..nn.1
  bemöta_1_V = mkV "bemöter" ; -- bemöta..vb.1
  bemötande_1_N = mkN "bemötande" ; -- bemötande..nn.1
  ben_1_N = mkN "ben" neutrum  ; -- ben..nn.1
  bena_1_N = mkN "bena" ; -- bena..nn.1
  bena_1_V = mkV "benar" ; -- bena..vb.1
  benande_1_N = mkN "benande" ; -- benande..nn.1
  benaska_1_N = mkN "benaska" ; -- benaska..nn.1
  benbildning_1_N = mkN "benbildning" ; -- benbildning..nn.1
  benbrosk_1_N = mkN "benbrosk" neutrum  ; -- benbrosk..nn.1
  benbrott_1_N = mkN "benbrott" neutrum  ; -- benbrott..nn.1
  benediktin_1_N = mkN "benediktin" "benediktiner" ; -- benediktin..nn.1
  benediktinerkloster_1_N = mkN "benediktinerkloster" neutrum  ; -- benediktinerkloster..nn.1
  benediktinermunk_1_N = mkN "benediktinermunk" ; -- benediktinermunk..nn.1
  benediktinerorden_1_N = mkN "benediktinerorden" ; -- benediktinerorden..nn.1
  benediktinkloster_1_N = mkN "benediktinkloster" neutrum  ; -- benediktinkloster..nn.1
  benediktinorden_1_N = mkN "benediktinorden" ; -- benediktinorden..nn.1
  beneficium_1_N = mkN "beneficium" "beneficiet" "beneficier" "beneficierna" ; -- beneficium..nn.1
  benefik_1_A = mkA "benefik" ; -- benefik..av.1
  benfisk_1_N = mkN "benfisk" ; -- benfisk..nn.1
  benfragment_1_N = mkN "benfragment" neutrum  ; -- benfragment..nn.1
  benfri_1_A = mkA "benfri" "benfritt" ; -- benfri..av.1
  benfärgad_1_A = mkA "benfärgad" ; -- benfärgad..av.1
  bengalisk_1_A = mkA "bengalisk" ; -- bengalisk..av.1
  benget_1_N = mkN "benget" "bengetter" ; -- benget..nn.1
  bengädda_1_N = mkN "bengädda" ; -- bengädda..nn.1
  benhinna_1_N = mkN "benhinna" ; -- benhinna..nn.1
  benhinneinflammation_1_N = mkN "benhinneinflammation" ; -- benhinneinflammation..nn.1
  benhus_1_N = mkN "benhus" neutrum  ; -- benhus..nn.1
  benhård_1_A = mkA "benhård" "benhårt" ; -- benhård..av.1
  benhårdhet_1_N = mkN "benhårdhet" ; -- benhårdhet..nn.1
  benig_1_A = mkA "benig" ; -- benig..av.1
  benign_1_A = mkA "benign" ; -- benign..av.1
  beninier_1_N = mkN "beninier" "beniniern" "beninier" "beninierna" ; -- beninier..nn.1
  beninsk_1_A = mkA "beninsk" ; -- beninsk..av.1
  beninska_1_N = mkN "beninska" ; -- beninska..nn.1
  benjamin_1_N = mkN "benjamin" ; -- benjamin..nn.1
  benjaminfikus_1_N = mkN "benjaminfikus" ; -- benjaminfikus..nn.1
  benkirurg_1_N = mkN "benkirurg" "benkirurger" ; -- benkirurg..nn.1
  benknota_1_N = mkN "benknota" ; -- benknota..nn.1
  benknäckare_1_N = mkN "benknäckare" utrum  ; -- benknäckare..nn.1
  benling_1_N = mkN "benling" ; -- benling..nn.1
  benlås_1_N = mkN "benlås" neutrum  ; -- benlås..nn.1
  benmjöl_1_N = mkN "benmjöl" neutrum  ; -- benmjöl..nn.1
  benmuskel_1_N = mkN "benmuskel" "benmuskeln" "benmuskler" "benmusklerna" ; -- benmuskel..nn.1
  benmärg_1_N = mkN "benmärg" ; -- benmärg..nn.1
  benmärgscancer_1_N = mkN "benmärgscancer" ; -- benmärgscancer..nn.1
  benpipa_1_N = mkN "benpipa" ; -- benpipa..nn.1
  benporslin_1_N = mkN "benporslin" "benporslinet" "benporsliner" "benporslinerna" ; -- benporslin..nn.1
  benprotes_1_N = mkN "benprotes" "benproteser" ; -- benprotes..nn.1
  benrangel_1_N = mkN "benrangel" neutrum  ; -- benrangel..nn.1
  benrangelsman_1_N = mkN "benrangelsman" "benrangelsmannen" "benrangelsmän" "benrangelsmännen" ; -- benrangelsman..nn.1
  benrest_1_N = mkN "benrest" "benrester" ; -- benrest..nn.1
  benröta_1_N = mkN "benröta" ; -- benröta..nn.1
  bensen_1_N = mkN "bensen" neutrum  ; -- bensen..nn.1
  bensin_1_N = mkN "bensin" ; -- bensin..nn.1
  bensinautomat_1_N = mkN "bensinautomat" "bensinautomater" ; -- bensinautomat..nn.1
  bensinbolag_1_N = mkN "bensinbolag" neutrum  ; -- bensinbolag..nn.1
  bensinbomb_1_N = mkN "bensinbomb" "bensinbomber" ; -- bensinbomb..nn.1
  bensinbrist_1_N = mkN "bensinbrist" ; -- bensinbrist..nn.1
  bensindriven_1_A = mkA "bensindriven" ; -- bensindriven..av.1
  bensindunk_1_N = mkN "bensindunk" ; -- bensindunk..nn.1
  bensinförbrukning_1_N = mkN "bensinförbrukning" ; -- bensinförbrukning..nn.1
  bensinförsäljning_1_N = mkN "bensinförsäljning" ; -- bensinförsäljning..nn.1
  bensinmack_1_N = mkN "bensinmack" ; -- bensinmack..nn.1
  bensinmotor_1_N = mkN "bensinmotor" "bensinmotorer" ; -- bensinmotor..nn.1
  bensinpris_1_N = mkN "bensinpris" neutrum  ; -- bensinpris..nn.1
  bensinpump_1_N = mkN "bensinpump" ; -- bensinpump..nn.1
  bensinskatt_1_N = mkN "bensinskatt" "bensinskatter" ; -- bensinskatt..nn.1
  bensinskattehöjning_1_N = mkN "bensinskattehöjning" ; -- bensinskattehöjning..nn.1
  bensinslukande_1_A = mkA "bensinslukande" ; -- bensinslukande..av.1
  bensinsnål_1_A = mkA "bensinsnål" ; -- bensinsnål..av.1
  bensinsnålhet_1_N = mkN "bensinsnålhet" ; -- bensinsnålhet..nn.1
  bensinstation_1_N = mkN "bensinstation" ; -- bensinstation..nn.1
  bensinstopp_1_N = mkN "bensinstopp" neutrum  ; -- bensinstopp..nn.1
  bensintank_1_N = mkN "bensintank" ; -- bensintank..nn.1
  bensintillsats_1_N = mkN "bensintillsats" "bensintillsatser" ; -- bensintillsats..nn.1
  benskada_1_N = mkN "benskada" ; -- benskada..nn.1
  benskena_1_N = mkN "benskena" ; -- benskena..nn.1
  benskydd_1_N = mkN "benskydd" neutrum  ; -- benskydd..nn.1
  benskör_1_A = mkA "benskör" ; -- benskör..av.1
  benskörhet_1_N = mkN "benskörhet" "benskörheter" ; -- benskörhet..nn.1
  bensoe_1_N = mkN "bensoe" utrum  ; -- bensoe..nn.1
  bensoesyra_1_N = mkN "bensoesyra" ; -- bensoesyra..nn.1
  bensol_1_N = mkN "bensol" ; -- bensol..nn.1
  benspets_1_N = mkN "benspets" ; -- benspets..nn.1
  benstamp_1_N = mkN "benstamp" ; -- benstamp..nn.1
  benstomme_1_N = mkN "benstomme" utrum  ; -- benstomme..nn.1
  bensträckare_1_N = mkN "bensträckare" utrum  ; -- bensträckare..nn.1
  benstråle_1_N = mkN "benstråle" utrum  ; -- benstråle..nn.1
  bensubstans_1_N = mkN "bensubstans" "bensubstanser" ; -- bensubstans..nn.1
  bensvulst_1_N = mkN "bensvulst" "bensvulster" ; -- bensvulst..nn.1
  bensår_1_N = mkN "bensår" neutrum  ; -- bensår..nn.1
  bentonit_1_N = mkN "bentonit" "bentoniter" ; -- bentonit..nn.1
  bentonitlager_1_N = mkN "bentonitlager" neutrum  ; -- bentonitlager..nn.1
  bentrakt_1_N = mkN "bentrakt" "bentrakter" ; -- bentrakt..nn.1
  bentuberkulos_1_N = mkN "bentuberkulos" ; -- bentuberkulos..nn.1
  bentyl_1_N = mkN "bentyl" ; -- bentyl..nn.1
  benutskott_1_N = mkN "benutskott" neutrum  ; -- benutskott..nn.1
  benved_1_N = mkN "benved" ; -- benved..nn.1
  benvit_1_A = mkA "benvit" ; -- benvit..av.1
  benvävnad_1_N = mkN "benvävnad" "benvävnader" ; -- benvävnad..nn.1
  benägen_1_A = mkA "benägen" ; -- benägen..av.1
  benägenhet_1_N = mkN "benägenhet" "benägenheter" ; -- benägenhet..nn.1
  benämna_1_V = mkV "benämner" ; -- benämna..vb.1
  benämnande_1_N = mkN "benämnande" ; -- benämnande..nn.1
  benämning_1_N = mkN "benämning" ; -- benämning..nn.1
  benåda_1_V = mkV "benådar" ; -- benåda..vb.1
  benådande_1_N = mkN "benådande" ; -- benådande..nn.1
  benådning_1_N = mkN "benådning" ; -- benådning..nn.1
  beordra_1_V = mkV "beordrar" ; -- beordra..vb.1
  beordrande_1_N = mkN "beordrande" ; -- beordrande..nn.1
  beostare_1_N = mkN "beostare" "beostarar" ; -- beostare..nn.1
  bepansra_1_V = mkV "bepansrar" ; -- bepansra..vb.1
  bepansrande_1_N = mkN "bepansrande" ; -- bepansrande..nn.1
  bepansring_1_N = mkN "bepansring" ; -- bepansring..nn.1
  beprisa_1_V = mkV "beprisar" ; -- beprisa..vb.1
  beprisande_1_N = mkN "beprisande" ; -- beprisande..nn.1
  beprisning_1_N = mkN "beprisning" ; -- beprisning..nn.1
  bepryda_1_V = mkV "bepryda" "beprydde" "beprytt" ; -- bepryda..vb.1
  beprydande_1_N = mkN "beprydande" ; -- beprydande..nn.1
  beprövad_1_A = mkA "beprövad" ; -- beprövad..av.1
  bepudra_1_V = mkV "bepudrar" ; -- bepudra..vb.1
  bepudrande_1_N = mkN "bepudrande" ; -- bepudrande..nn.1
  beramad_1_A = mkA "beramad" ; -- beramad..av.1
  berber_1_N = mkN "berber" "berbern" "berber" "berberna" ; -- berber..nn.1
  berberis_1_N = mkN "berberis" ; -- berberis..nn.1
  berceuse_1_N = mkN "berceuse" "berceuser" ; -- berceuse..nn.1
  bereda_1_V = mkV "bereda" "beredde" "berett" ; -- bereda..vb.1
  beredande_1_N = mkN "beredande" ; -- beredande..nn.1
  beredare_1_N = mkN "beredare" utrum  ; -- beredare..nn.1
  beredd_1_A = mkA "beredd" ; -- beredd..av.1
  beredelse_1_N = mkN "beredelse" "beredelser" ; -- beredelse..nn.1
  beredning_1_N = mkN "beredning" ; -- beredning..nn.1
  beredning_2_N = mkN "beredning" ; -- beredning..nn.2
  beredningsnämnd_1_N = mkN "beredningsnämnd" "beredningsnämnder" ; -- beredningsnämnd..nn.1
  beredningssätt_1_N = mkN "beredningssätt" neutrum  ; -- beredningssätt..nn.1
  beredningsutskott_1_N = mkN "beredningsutskott" neutrum  ; -- beredningsutskott..nn.1
  beredskap_1_N = mkN "beredskap" "beredskaper" ; -- beredskap..nn.1
  beredskapsarbete_1_N = mkN "beredskapsarbete" ; -- beredskapsarbete..nn.1
  beredskapskommissarie_1_N = mkN "beredskapskommissarie" "beredskapskommissarier" ; -- beredskapskommissarie..nn.1
  beredskapslager_1_N = mkN "beredskapslager" neutrum  ; -- beredskapslager..nn.1
  beredskapslagring_1_N = mkN "beredskapslagring" ; -- beredskapslagring..nn.1
  beredskapsmässig_1_A = mkA "beredskapsmässig" ; -- beredskapsmässig..av.1
  beredskapsplan_1_N = mkN "beredskapsplan" neutrum  ; -- beredskapsplan..nn.1
  beredskapsstat_1_N = mkN "beredskapsstat" "beredskapsstater" ; -- beredskapsstat..nn.1
  beredskapstid_1_N = mkN "beredskapstid" "beredskapstider" ; -- beredskapstid..nn.1
  beredskapstjänst_1_N = mkN "beredskapstjänst" "beredskapstjänster" ; -- beredskapstjänst..nn.1
  beredvillig_1_A = mkA "beredvillig" ; -- beredvillig..av.1
  beredvillighet_1_N = mkN "beredvillighet" "beredvilligheter" ; -- beredvillighet..nn.1
  berest_1_A = mkA "berest" "berest" ; -- berest..av.1
  beresthet_1_N = mkN "beresthet" ; -- beresthet..nn.1
  berg_och_dalbana_1_N = mkN "berg-och-dalbana" ; -- berg-och-dalbana..nn.1
  berg_1_N = mkN "berg" neutrum  ; -- berg..nn.1
  bergakung_1_N = mkN "bergakung" ; -- bergakung..nn.1
  bergamott_1_N = mkN "bergamott" "bergamotter" ; -- bergamott..nn.1
  bergand_1_N = mkN "bergand" "bergänder" ; -- bergand..nn.1
  bergart_1_N = mkN "bergart" "bergarter" ; -- bergart..nn.1
  bergartslager_1_N = mkN "bergartslager" neutrum  ; -- bergartslager..nn.1
  bergbana_1_N = mkN "bergbana" ; -- bergbana..nn.1
  bergbestigare_1_N = mkN "bergbestigare" utrum  ; -- bergbestigare..nn.1
  bergbestigning_1_N = mkN "bergbestigning" ; -- bergbestigning..nn.1
  bergborr_1_N = mkN "bergborr" ; -- bergborr..nn.1
  bergborrning_1_N = mkN "bergborrning" ; -- bergborrning..nn.1
  bergbäck_1_N = mkN "bergbäck" ; -- bergbäck..nn.1
  bergfast_1_A = mkA "bergfast" "bergfast" ; -- bergfast..av.1
  bergfin_1_A = mkA "bergfin" ; -- bergfin..av.1
  bergfink_1_N = mkN "bergfink" ; -- bergfink..nn.1
  berggrund_1_N = mkN "berggrund" "berggrunder" ; -- berggrund..nn.1
  berggylta_1_N = mkN "berggylta" ; -- berggylta..nn.1
  berghäll_1_N = mkN "berghäll" ; -- berghäll..nn.1
  bergig_1_A = mkA "bergig" ; -- bergig..av.1
  bergighet_1_N = mkN "bergighet" ; -- bergighet..nn.1
  bergis_1_A = mkA "bergis" ; -- bergis..av.1
  bergis_1_N = mkN "bergis" ; -- bergis..nn.1
  bergkam_1_N = mkN "bergkam" "bergkammen" "bergkammar" "bergkammarna" ; -- bergkam..nn.1
  bergklack_1_N = mkN "bergklack" ; -- bergklack..nn.1
  bergknalle_1_N = mkN "bergknalle" utrum  ; -- bergknalle..nn.1
  bergkristall_1_N = mkN "bergkristall" "bergkristaller" ; -- bergkristall..nn.1
  bergkrön_1_N = mkN "bergkrön" neutrum  ; -- bergkrön..nn.1
  bergkulle_1_N = mkN "bergkulle" utrum  ; -- bergkulle..nn.1
  bergland_1_N = mkN "bergland" neutrum  ; -- bergland..nn.1
  berglandskap_1_N = mkN "berglandskap" neutrum  ; -- berglandskap..nn.1
  bergnymf_1_N = mkN "bergnymf" "bergnymfer" ; -- bergnymf..nn.1
  bergolja_1_N = mkN "bergolja" ; -- bergolja..nn.1
  bergpass_1_N = mkN "bergpass" neutrum  ; -- bergpass..nn.1
  bergras_1_N = mkN "bergras" neutrum  ; -- bergras..nn.1
  bergrum_1_N = mkN "bergrum" "bergrummet" "bergrum" "bergrummen" ; -- bergrum..nn.1
  bergrygg_1_N = mkN "bergrygg" ; -- bergrygg..nn.1
  bergsartilleri_1_N = mkN "bergsartilleri" neutrum  ; -- bergsartilleri..nn.1
  bergsbestigare_1_N = mkN "bergsbestigare" utrum  ; -- bergsbestigare..nn.1
  bergsbestigning_1_N = mkN "bergsbestigning" ; -- bergsbestigning..nn.1
  bergsbestigningsexpedition_1_N = mkN "bergsbestigningsexpedition" ; -- bergsbestigningsexpedition..nn.1
  bergsbestigningsolycka_1_N = mkN "bergsbestigningsolycka" ; -- bergsbestigningsolycka..nn.1
  bergsbrant_1_N = mkN "bergsbrant" "bergsbranter" ; -- bergsbrant..nn.1
  bergsbruk_1_N = mkN "bergsbruk" neutrum  ; -- bergsbruk..nn.1
  bergsbygd_1_N = mkN "bergsbygd" "bergsbygder" ; -- bergsbygd..nn.1
  bergsdrift_1_N = mkN "bergsdrift" ; -- bergsdrift..nn.1
  bergsformation_1_N = mkN "bergsformation" ; -- bergsformation..nn.1
  bergsget_1_N = mkN "bergsget" "bergsgetter" ; -- bergsget..nn.1
  bergsglaciär_1_N = mkN "bergsglaciär" "bergsglaciärer" ; -- bergsglaciär..nn.1
  bergsgorilla_1_N = mkN "bergsgorilla" ; -- bergsgorilla..nn.1
  bergshantering_1_N = mkN "bergshantering" ; -- bergshantering..nn.1
  bergsingenjör_1_N = mkN "bergsingenjör" "bergsingenjörer" ; -- bergsingenjör..nn.1
  bergsjägare_1_N = mkN "bergsjägare" utrum  ; -- bergsjägare..nn.1
  bergskam_1_N = mkN "bergskam" "bergskammen" "bergskammar" "bergskammarna" ; -- bergskam..nn.1
  bergskedja_1_N = mkN "bergskedja" ; -- bergskedja..nn.1
  bergskedjebildning_1_N = mkN "bergskedjebildning" ; -- bergskedjebildning..nn.1
  bergsklack_1_N = mkN "bergsklack" ; -- bergsklack..nn.1
  bergsklimat_1_N = mkN "bergsklimat" neutrum  ; -- bergsklimat..nn.1
  bergsklyfta_1_N = mkN "bergsklyfta" ; -- bergsklyfta..nn.1
  bergsklättrare_1_N = mkN "bergsklättrare" utrum  ; -- bergsklättrare..nn.1
  bergsklättring_1_N = mkN "bergsklättring" ; -- bergsklättring..nn.1
  bergskred_1_N = mkN "bergskred" neutrum  ; -- bergskred..nn.1
  bergskreva_1_N = mkN "bergskreva" ; -- bergskreva..nn.1
  bergskrön_1_N = mkN "bergskrön" neutrum  ; -- bergskrön..nn.1
  bergslag_1_N = mkN "bergslag" "bergslager" ; -- bergslag..nn.1
  bergslager_1_N = mkN "bergslager" neutrum  ; -- bergslager..nn.1
  bergslandskap_1_N = mkN "bergslandskap" neutrum  ; -- bergslandskap..nn.1
  bergsluft_1_N = mkN "bergsluft" ; -- bergsluft..nn.1
  bergsman_1_N = mkN "bergsman" "bergsmannen" "bergsmän" "bergsmännen" ; -- bergsman..nn.1
  bergsmassiv_1_N = mkN "bergsmassiv" neutrum  ; -- bergsmassiv..nn.1
  bergsområde_1_N = mkN "bergsområde" ; -- bergsområde..nn.1
  bergspets_1_N = mkN "bergspets" ; -- bergspets..nn.1
  bergsplatå_1_N = mkN "bergsplatå" "bergsplatåer" ; -- bergsplatå..nn.1
  bergsrygg_1_N = mkN "bergsrygg" ; -- bergsrygg..nn.1
  bergssida_1_N = mkN "bergssida" ; -- bergssida..nn.1
  bergsskola_1_N = mkN "bergsskola" ; -- bergsskola..nn.1
  bergssluttning_1_N = mkN "bergssluttning" ; -- bergssluttning..nn.1
  bergsstam_1_N = mkN "bergsstam" "bergsstammen" "bergsstammar" "bergsstammarna" ; -- bergsstam..nn.1
  bergsstup_1_N = mkN "bergsstup" neutrum  ; -- bergsstup..nn.1
  bergstopp_1_N = mkN "bergstopp" ; -- bergstopp..nn.1
  bergstrakt_1_N = mkN "bergstrakt" "bergstrakter" ; -- bergstrakt..nn.1
  bergstup_1_N = mkN "bergstup" neutrum  ; -- bergstup..nn.1
  bergsyra_1_N = mkN "bergsyra" ; -- bergsyra..nn.1
  bergszebra_1_N = mkN "bergszebra" ; -- bergszebra..nn.1
  bergsäker_1_A = mkA "bergsäker" ; -- bergsäker..av.1
  bergsäkerhet_1_N = mkN "bergsäkerhet" ; -- bergsäkerhet..nn.1
  bergtagen_1_A = mkA "bergtagen" ; -- bergtagen..av.1
  bergtall_1_N = mkN "bergtall" ; -- bergtall..nn.1
  bergtopp_1_N = mkN "bergtopp" ; -- bergtopp..nn.1
  bergtroll_1_N = mkN "bergtroll" neutrum  ; -- bergtroll..nn.1
  berguv_1_N = mkN "berguv" ; -- berguv..nn.1
  bergvandrare_1_N = mkN "bergvandrare" utrum  ; -- bergvandrare..nn.1
  bergvandring_1_N = mkN "bergvandring" ; -- bergvandring..nn.1
  bergvind_1_N = mkN "bergvind" ; -- bergvind..nn.1
  bergvägg_1_N = mkN "bergvägg" ; -- bergvägg..nn.1
  bergvärme_1_N = mkN "bergvärme" ; -- bergvärme..nn.1
  bergås_1_N = mkN "bergås" ; -- bergås..nn.1
  beridare_1_N = mkN "beridare" utrum  ; -- beridare..nn.1
  beriden_1_A = mkA "beriden" ; -- beriden..av.1
  berika_1_V = mkV "berikar" ; -- berika..vb.1
  berikande_1_N = mkN "berikande" ; -- berikande..nn.1
  beriktiga_1_V = mkV "beriktigar" ; -- beriktiga..vb.1
  beriktigande_1_N = mkN "beriktigande" ; -- beriktigande..nn.1
  berkelium_1_N = mkN "berkelium" neutrum  ; -- berkelium..nn.1
  berkis_1_N = mkN "berkis" ; -- berkis..nn.1
  berlinerblå_1_A = mkA "berlinerblå" "berlinerblått" ; -- berlinerblå..av.1
  berlinerblått_1_N = mkN "berlinerblått" ; -- berlinerblått..nn.1
  berlock_1_N = mkN "berlock" "berlocker" ; -- berlock..nn.1
  bermudarigg_1_N = mkN "bermudarigg" ; -- bermudarigg..nn.1
  bernäs_1_N = mkN "bernäs" "bernäser" ; -- bernäs..nn.1
  bernässås_1_N = mkN "bernässås" "bernässåser" ; -- bernässås..nn.1
  bero_1_V = mkV "beror" ; -- bero..vb.1
  beroende_1_A = mkA "beroende" ; -- beroende..av.1
  beroende_1_N = mkN "beroende" ; -- beroende..nn.1
  beroende_2_N = mkN "beroende" ; -- beroende..nn.2
  beroendeframkallande_1_A = mkA "beroendeframkallande" ; -- beroendeframkallande..av.1
  beroendeförhållande_1_N = mkN "beroendeförhållande" ; -- beroendeförhållande..nn.1
  beroendeproblem_1_N = mkN "beroendeproblem" neutrum  ; -- beroendeproblem..nn.1
  beroendeställning_1_N = mkN "beroendeställning" ; -- beroendeställning..nn.1
  berså_1_N = mkN "berså" "bersåer" ; -- berså..nn.1
  bertel_1_N = mkN "bertel" ; -- bertel..nn.1
  berusa_1_V = mkV "berusar" ; -- berusa..vb.1
  berusad_1_A = mkA "berusad" ; -- berusad..av.1
  berusande_1_A = mkA "berusande" ; -- berusande..av.1
  berusande_1_N = mkN "berusande" ; -- berusande..nn.1
  berusning_1_N = mkN "berusning" ; -- berusning..nn.1
  berusningsgrad_1_N = mkN "berusningsgrad" "berusningsgrader" ; -- berusningsgrad..nn.1
  beryktad_1_A = mkA "beryktad" ; -- beryktad..av.1
  beryll_1_N = mkN "beryll" "beryller" ; -- beryll..nn.1
  beryllgrön_1_A = mkA "beryllgrön" ; -- beryllgrön..av.1
  beryllium_1_N = mkN "beryllium" neutrum  ; -- beryllium..nn.1
  beräkna_1_V = mkV "beräknar" ; -- beräkna..vb.1
  beräknad_1_A = mkA "beräknad" ; -- beräknad..av.1
  beräknande_1_A = mkA "beräknande" ; -- beräknande..av.1
  beräknande_1_N = mkN "beräknande" ; -- beräknande..nn.1
  beräknelig_1_A = mkA "beräknelig" ; -- beräknelig..av.1
  beräknelighet_1_N = mkN "beräknelighet" ; -- beräknelighet..nn.1
  beräkning_1_N = mkN "beräkning" ; -- beräkning..nn.1
  beräkningsgrund_1_N = mkN "beräkningsgrund" "beräkningsgrunder" ; -- beräkningsgrund..nn.1
  beräkningsmetod_1_N = mkN "beräkningsmetod" "beräkningsmetoder" ; -- beräkningsmetod..nn.1
  beräkningsmässig_1_A = mkA "beräkningsmässig" ; -- beräkningsmässig..av.1
  beräkningssätt_1_N = mkN "beräkningssätt" neutrum  ; -- beräkningssätt..nn.1
  berätta_1_V = mkV "berättar" ; -- berätta..vb.1
  berättande_1_A = mkA "berättande" ; -- berättande..av.1
  berättande_1_N = mkN "berättande" ; -- berättande..nn.1
  berättarbegåvning_1_N = mkN "berättarbegåvning" ; -- berättarbegåvning..nn.1
  berättare_1_N = mkN "berättare" utrum  ; -- berättare..nn.1
  berättarförmåga_1_N = mkN "berättarförmåga" ; -- berättarförmåga..nn.1
  berättarglädje_1_N = mkN "berättarglädje" utrum  ; -- berättarglädje..nn.1
  berättarjag_1_N = mkN "berättarjag" neutrum  ; -- berättarjag..nn.1
  berättarkonst_1_N = mkN "berättarkonst" "berättarkonster" ; -- berättarkonst..nn.1
  berättarmässig_1_A = mkA "berättarmässig" ; -- berättarmässig..av.1
  berättarperspektiv_1_N = mkN "berättarperspektiv" neutrum  ; -- berättarperspektiv..nn.1
  berättarröst_1_N = mkN "berättarröst" "berättarröster" ; -- berättarröst..nn.1
  berättarstil_1_N = mkN "berättarstil" ; -- berättarstil..nn.1
  berättartalang_1_N = mkN "berättartalang" "berättartalanger" ; -- berättartalang..nn.1
  berättarteknik_1_N = mkN "berättarteknik" "berättartekniker" ; -- berättarteknik..nn.1
  berättarteknisk_1_A = mkA "berättarteknisk" ; -- berättarteknisk..av.1
  berättelse_1_N = mkN "berättelse" "berättelser" ; -- berättelse..nn.1
  berättiga_1_V = mkV "berättigar" ; -- berättiga..vb.1
  berättigad_1_A = mkA "berättigad" ; -- berättigad..av.1
  berättigande_1_N = mkN "berättigande" ; -- berättigande..nn.1
  berömd_1_A = mkA "berömd" "berömt" ; -- berömd..av.1
  berömdhet_1_N = mkN "berömdhet" "berömdheter" ; -- berömdhet..nn.1
  berömlig_1_A = mkA "berömlig" ; -- berömlig..av.1
  berömlighet_1_N = mkN "berömlighet" "berömligheter" ; -- berömlighet..nn.1
  berömma_1_V = mkV "berömmer" ; -- berömma..vb.1
  berömmande_1_N = mkN "berömmande" ; -- berömmande..nn.1
  berömmelse_1_N = mkN "berömmelse" utrum  ; -- berömmelse..nn.1
  berömvärd_1_A = mkA "berömvärd" "berömvärt" ; -- berömvärd..av.1
  berömvärdhet_1_N = mkN "berömvärdhet" ; -- berömvärdhet..nn.1
  beröra_1_V = mkV "beröra" "berörde" "berört" ; -- beröra..vb.1
  berörande_1_N = mkN "berörande" ; -- berörande..nn.1
  berörd_1_A = mkA "berörd" "berört" ; -- berörd..av.1
  beröring_1_N = mkN "beröring" ; -- beröring..nn.1
  beröringsassociation_1_N = mkN "beröringsassociation" ; -- beröringsassociation..nn.1
  beröringselektricitet_1_N = mkN "beröringselektricitet" "beröringselektriciteter" ; -- beröringselektricitet..nn.1
  beröringsfri_1_A = mkA "beröringsfri" "beröringsfritt" ; -- beröringsfri..av.1
  beröringspunkt_1_N = mkN "beröringspunkt" "beröringspunkter" ; -- beröringspunkt..nn.1
  beröringsskräck_1_N = mkN "beröringsskräck" ; -- beröringsskräck..nn.1
  beröringsångest_1_N = mkN "beröringsångest" ; -- beröringsångest..nn.1
  beröva_1_V = mkV "berövar" ; -- beröva..vb.1
  berövande_1_N = mkN "berövande" ; -- berövande..nn.1
  besanna_1_V = mkV "besannar" ; -- besanna..vb.1
  besannande_1_N = mkN "besannande" ; -- besannande..nn.1
  besatt_1_A = mkA "besatt" ; -- besatt..av.1
  besatthet_1_N = mkN "besatthet" "besattheter" ; -- besatthet..nn.1
  bese_1_V = mkV "bese" "besåg" "besett" ; -- bese..vb.1
  beseende_1_N = mkN "beseende" ; -- beseende..nn.1
  besegla_1_V = mkV "beseglar" ; -- besegla..vb.1
  beseglande_1_N = mkN "beseglande" ; -- beseglande..nn.1
  besegling_1_N = mkN "besegling" ; -- besegling..nn.1
  besegra_1_V = mkV "besegrar" ; -- besegra..vb.1
  besegrande_1_N = mkN "besegrande" ; -- besegrande..nn.1
  besegrare_1_N = mkN "besegrare" utrum  ; -- besegrare..nn.1
  besick_1_N = mkN "besick" ; -- besick..nn.1
  besiffrad_1_A = mkA "besiffrad" ; -- besiffrad..av.1
  besiffring_1_N = mkN "besiffring" ; -- besiffring..nn.1
  besiktiga_1_V = mkV "besiktigar" ; -- besiktiga..vb.1
  besiktigande_1_N = mkN "besiktigande" ; -- besiktigande..nn.1
  besiktning_1_N = mkN "besiktning" ; -- besiktning..nn.1
  besiktningsinstrument_1_N = mkN "besiktningsinstrument" neutrum  ; -- besiktningsinstrument..nn.1
  besiktningsman_1_N = mkN "besiktningsman" "besiktningsmannen" "besiktningsmän" "besiktningsmännen" ; -- besiktningsman..nn.1
  besiktningsprotokoll_1_N = mkN "besiktningsprotokoll" neutrum  ; -- besiktningsprotokoll..nn.1
  besinna_1_V = mkV "besinnar" ; -- besinna..vb.1
  besinnad_1_A = mkA "besinnad" ; -- besinnad..av.1
  besinnande_1_N = mkN "besinnande" ; -- besinnande..nn.1
  besinning_1_N = mkN "besinning" ; -- besinning..nn.1
  besinningsfull_1_A = mkA "besinningsfull" ; -- besinningsfull..av.1
  besinningsfullhet_1_N = mkN "besinningsfullhet" ; -- besinningsfullhet..nn.1
  besinningslös_1_A = mkA "besinningslös" ; -- besinningslös..av.1
  besinningslöshet_1_N = mkN "besinningslöshet" "besinningslösheter" ; -- besinningslöshet..nn.1
  besique_1_N = mkN "besique" utrum  ; -- besique..nn.1
  besitta_1_V = mkV "besitta" "besatt" "besuttit" ; -- besitta..vb.1
  besittande_1_N = mkN "besittande" ; -- besittande..nn.1
  besittning_1_N = mkN "besittning" ; -- besittning..nn.1
  besittningshavare_1_N = mkN "besittningshavare" utrum  ; -- besittningshavare..nn.1
  besittningsrätt_1_N = mkN "besittningsrätt" "besittningsrätter" ; -- besittningsrätt..nn.1
  besittningsskydd_1_N = mkN "besittningsskydd" neutrum  ; -- besittningsskydd..nn.1
  besittningstagande_1_N = mkN "besittningstagande" ; -- besittningstagande..nn.1
  besittningstid_1_N = mkN "besittningstid" "besittningstider" ; -- besittningstid..nn.1
  besjunga_1_V = mkV "besjunga" "besjöng" "besjungit" ; -- besjunga..vb.1
  besjungande_1_N = mkN "besjungande" ; -- besjungande..nn.1
  besjungen_1_A = mkA "besjungen" ; -- besjungen..av.1
  besjäla_1_V = mkV "besjälar" ; -- besjäla..vb.1
  besjälad_1_A = mkA "besjälad" ; -- besjälad..av.1
  besjälande_1_N = mkN "besjälande" ; -- besjälande..nn.1
  besk_1_A = mkA "besk" ; -- besk..av.1
  besk_1_N = mkN "besk" ; -- besk..nn.1
  beska_1_N = mkN "beska" ; -- beska..nn.1
  beskaffad_1_A = mkA "beskaffad" ; -- beskaffad..av.1
  beskaffenhet_1_N = mkN "beskaffenhet" "beskaffenheter" ; -- beskaffenhet..nn.1
  beskatta_1_V = mkV "beskattar" ; -- beskatta..vb.1
  beskattande_1_N = mkN "beskattande" ; -- beskattande..nn.1
  beskattning_1_N = mkN "beskattning" ; -- beskattning..nn.1
  beskattningsbar_1_A = mkA "beskattningsbar" ; -- beskattningsbar..av.1
  beskattningsbarhet_1_N = mkN "beskattningsbarhet" ; -- beskattningsbarhet..nn.1
  beskattningsgrund_1_N = mkN "beskattningsgrund" "beskattningsgrunder" ; -- beskattningsgrund..nn.1
  beskattningsgrundande_1_A = mkA "beskattningsgrundande" ; -- beskattningsgrundande..av.1
  beskattningsmakt_1_N = mkN "beskattningsmakt" ; -- beskattningsmakt..nn.1
  beskattningsnämnd_1_N = mkN "beskattningsnämnd" "beskattningsnämnder" ; -- beskattningsnämnd..nn.1
  beskattningsprincip_1_N = mkN "beskattningsprincip" "beskattningsprinciper" ; -- beskattningsprincip..nn.1
  beskattningsrätt_1_N = mkN "beskattningsrätt" ; -- beskattningsrätt..nn.1
  beskattningssätt_1_N = mkN "beskattningssätt" neutrum  ; -- beskattningssätt..nn.1
  beskattningsår_1_N = mkN "beskattningsår" neutrum  ; -- beskattningsår..nn.1
  besked_1_N = mkN "besked" neutrum  ; -- besked..nn.1
  beskedlig_1_A = mkA "beskedlig" ; -- beskedlig..av.1
  beskedlighet_1_N = mkN "beskedlighet" ; -- beskedlighet..nn.1
  beskhet_1_N = mkN "beskhet" "beskheter" ; -- beskhet..nn.1
  beskicka_1_V = mkV "beskickar" ; -- beskicka..vb.1
  beskickande_1_N = mkN "beskickande" ; -- beskickande..nn.1
  beskickning_1_N = mkN "beskickning" ; -- beskickning..nn.1
  beskickningschef_1_N = mkN "beskickningschef" "beskickningschefer" ; -- beskickningschef..nn.1
  beskjuta_1_V = mkV "beskjuta" "besköt" "beskjutit" ; -- beskjuta..vb.1
  beskjutande_1_N = mkN "beskjutande" ; -- beskjutande..nn.1
  beskjutning_1_N = mkN "beskjutning" ; -- beskjutning..nn.1
  beskriva_1_V = mkV "beskriva" "beskrev" "beskrivit" ; -- beskriva..vb.1
  beskrivande_1_A = mkA "beskrivande" ; -- beskrivande..av.1
  beskrivande_1_N = mkN "beskrivande" ; -- beskrivande..nn.1
  beskrivbar_1_A = mkA "beskrivbar" ; -- beskrivbar..av.1
  beskrivbarhet_1_N = mkN "beskrivbarhet" ; -- beskrivbarhet..nn.1
  beskrivning_1_N = mkN "beskrivning" ; -- beskrivning..nn.1
  besksöta_1_N = mkN "besksöta" ; -- besksöta..nn.1
  beskugga_1_V = mkV "beskuggar" ; -- beskugga..vb.1
  beskuggande_1_N = mkN "beskuggande" ; -- beskuggande..nn.1
  beskuggning_1_N = mkN "beskuggning" ; -- beskuggning..nn.1
  beskydd_1_N = mkN "beskydd" neutrum  ; -- beskydd..nn.1
  beskydda_1_V = mkV "beskyddar" ; -- beskydda..vb.1
  beskyddande_1_N = mkN "beskyddande" ; -- beskyddande..nn.1
  beskyddare_1_N = mkN "beskyddare" utrum  ; -- beskyddare..nn.1
  beskyddarverksamhet_1_N = mkN "beskyddarverksamhet" "beskyddarverksamheter" ; -- beskyddarverksamhet..nn.1
  beskylla_1_V = mkV "beskyller" ; -- beskylla..vb.1
  beskyllande_1_N = mkN "beskyllande" ; -- beskyllande..nn.1
  beskyllning_1_N = mkN "beskyllning" ; -- beskyllning..nn.1
  beskäftig_1_A = mkA "beskäftig" ; -- beskäftig..av.1
  beskäftighet_1_N = mkN "beskäftighet" "beskäftigheter" ; -- beskäftighet..nn.1
  beskällare_1_N = mkN "beskällare" utrum  ; -- beskällare..nn.1
  beskällaresjuka_1_N = mkN "beskällaresjuka" ; -- beskällaresjuka..nn.1
  beskällarsjuka_1_N = mkN "beskällarsjuka" ; -- beskällarsjuka..nn.1
  beskänkt_1_A = mkA "beskänkt" "beskänkt" ; -- beskänkt..av.1
  beskära_1_V = mkV "beskära" "beskärde" "beskärt" ; -- beskära..vb.1
  beskära_2_V = mkV "beskära" "beskar" "beskurit" ; -- beskära..vb.2
  beskärande_1_N = mkN "beskärande" ; -- beskärande..nn.1
  beskärd_1_A = mkA "beskärd" "beskärt" ; -- beskärd..av.1
  beskärm_1_N = mkN "beskärm" neutrum  ; -- beskärm..nn.1
  beskärma_1_V = mkV "beskärmar" ; -- beskärma..vb.1
  beskärmande_1_N = mkN "beskärmande" ; -- beskärmande..nn.1
  beskärmare_1_N = mkN "beskärmare" utrum  ; -- beskärmare..nn.1
  beskärmelse_1_N = mkN "beskärmelse" "beskärmelser" ; -- beskärmelse..nn.1
  beskärning_1_N = mkN "beskärning" ; -- beskärning..nn.1
  beskåda_1_V = mkV "beskådar" ; -- beskåda..vb.1
  beskådande_1_N = mkN "beskådande" ; -- beskådande..nn.1
  beskådning_1_N = mkN "beskådning" ; -- beskådning..nn.1
  beslag_1_N = mkN "beslag" neutrum  ; -- beslag..nn.1
  beslagare_1_N = mkN "beslagare" utrum  ; -- beslagare..nn.1
  beslaglägga_1_V = mkV "beslaglägga" "beslagla" "beslaglagt" ; -- beslaglägga..vb.1
  beslagläggande_1_N = mkN "beslagläggande" ; -- beslagläggande..nn.1
  beslagsband_1_N = mkN "beslagsband" neutrum  ; -- beslagsband..nn.1
  beslagsrätt_1_N = mkN "beslagsrätt" ; -- beslagsrätt..nn.1
  beslagssmed_1_N = mkN "beslagssmed" "beslagssmeder" ; -- beslagssmed..nn.1
  beslagssmide_1_N = mkN "beslagssmide" ; -- beslagssmide..nn.1
  beslagta_1_V = mkV "beslagtaga" "beslagtog" "beslagtagit" ; -- beslagta..vb.1
  beslagtagande_1_N = mkN "beslagtagande" ; -- beslagtagande..nn.1
  beslut_1_N = mkN "beslut" neutrum  ; -- beslut..nn.1
  besluta_1_V = mkV "beslutar" ; -- besluta..vb.1
  beslutande_1_N = mkN "beslutande" ; -- beslutande..nn.1
  beslutanderätt_1_N = mkN "beslutanderätt" ; -- beslutanderätt..nn.1
  besluten_1_A = mkA "besluten" ; -- besluten..av.1
  beslutenhet_1_N = mkN "beslutenhet" ; -- beslutenhet..nn.1
  beslutenlig_1_A = mkA "beslutenlig" ; -- beslutenlig..av.1
  beslutenlighet_1_N = mkN "beslutenlighet" ; -- beslutenlighet..nn.1
  beslutfattande_1_A = mkA "beslutfattande" ; -- beslutfattande..av.1
  beslutfattande_1_N = mkN "beslutfattande" ; -- beslutfattande..nn.1
  beslutfattare_1_N = mkN "beslutfattare" utrum  ; -- beslutfattare..nn.1
  beslutför_1_A = mkA "beslutför" ; -- beslutför..av.1
  beslutförhet_1_N = mkN "beslutförhet" ; -- beslutförhet..nn.1
  beslutmässig_1_A = mkA "beslutmässig" ; -- beslutmässig..av.1
  beslutmässighet_1_N = mkN "beslutmässighet" ; -- beslutmässighet..nn.1
  beslutnivå_1_N = mkN "beslutnivå" "beslutnivåer" ; -- beslutnivå..nn.1
  beslutsam_1_A = mkA "beslutsam" "beslutsamt" "beslutsamma" "beslutsamma" "beslutsammare" "beslutsammast" "beslutsammaste" ; -- beslutsam..av.1
  beslutsamhet_1_N = mkN "beslutsamhet" "beslutsamheter" ; -- beslutsamhet..nn.1
  beslutsenlig_1_A = mkA "beslutsenlig" ; -- beslutsenlig..av.1
  beslutsenlighet_1_N = mkN "beslutsenlighet" ; -- beslutsenlighet..nn.1
  beslutsfattande_1_A = mkA "beslutsfattande" ; -- beslutsfattande..av.1
  beslutsfattande_1_N = mkN "beslutsfattande" ; -- beslutsfattande..nn.1
  beslutsfattare_1_N = mkN "beslutsfattare" utrum  ; -- beslutsfattare..nn.1
  beslutsför_1_A = mkA "beslutsför" ; -- beslutsför..av.1
  beslutsförhet_1_N = mkN "beslutsförhet" ; -- beslutsförhet..nn.1
  beslutsförmåga_1_N = mkN "beslutsförmåga" ; -- beslutsförmåga..nn.1
  beslutshierarki_1_N = mkN "beslutshierarki" "beslutshierarkier" ; -- beslutshierarki..nn.1
  beslutskaos_1_N = mkN "beslutskaos" neutrum  ; -- beslutskaos..nn.1
  beslutskapabel_1_A = mkA "beslutskapabel" ; -- beslutskapabel..av.1
  beslutskorridor_1_N = mkN "beslutskorridor" "beslutskorridoren" "beslutskorridorer" "beslutskorridorerna" ; -- beslutskorridor..nn.1
  beslutsmässig_1_A = mkA "beslutsmässig" ; -- beslutsmässig..av.1
  beslutsmässighet_1_N = mkN "beslutsmässighet" ; -- beslutsmässighet..nn.1
  beslutsnivå_1_N = mkN "beslutsnivå" "beslutsnivåer" ; -- beslutsnivå..nn.1
  beslutsprocess_1_N = mkN "beslutsprocess" "beslutsprocesser" ; -- beslutsprocess..nn.1
  beslutsrum_1_N = mkN "beslutsrum" "beslutsrummet" "beslutsrum" "beslutsrummen" ; -- beslutsrum..nn.1
  beslutsrymd_1_N = mkN "beslutsrymd" "beslutsrymder" ; -- beslutsrymd..nn.1
  beslutsrätt_1_N = mkN "beslutsrätt" ; -- beslutsrätt..nn.1
  beslutsunderlag_1_N = mkN "beslutsunderlag" neutrum  ; -- beslutsunderlag..nn.1
  beslutsångest_1_N = mkN "beslutsångest" ; -- beslutsångest..nn.1
  besläktad_1_A = mkA "besläktad" ; -- besläktad..av.1
  beslå_1_V = mkV "beslå" "beslog" "beslagit" ; -- beslå..vb.1
  beslående_1_N = mkN "beslående" ; -- beslående..nn.1
  beslöja_1_V = mkV "beslöjar" ; -- beslöja..vb.1
  beslöjad_1_A = mkA "beslöjad" ; -- beslöjad..av.1
  beslöjande_1_N = mkN "beslöjande" ; -- beslöjande..nn.1
  beslöjning_1_N = mkN "beslöjning" ; -- beslöjning..nn.1
  besman_1_N = mkN "besman" neutrum  ; -- besman..nn.1
  besmanskrok_1_N = mkN "besmanskrok" ; -- besmanskrok..nn.1
  besmitta_1_V = mkV "besmittar" ; -- besmitta..vb.1
  besmittande_1_N = mkN "besmittande" ; -- besmittande..nn.1
  besmittelse_1_N = mkN "besmittelse" "besmittelser" ; -- besmittelse..nn.1
  besmörja_1_V = mkV "besmörja" "besmorde" "besmort" ; -- besmörja..vb.1
  besmörjande_1_N = mkN "besmörjande" ; -- besmörjande..nn.1
  besockra_1_V = mkV "besockrar" ; -- besockra..vb.1
  besockrande_1_N = mkN "besockrande" ; -- besockrande..nn.1
  besolda_1_V = mkV "besoldar" ; -- besolda..vb.1
  besoldande_1_N = mkN "besoldande" ; -- besoldande..nn.1
  besoldning_1_N = mkN "besoldning" ; -- besoldning..nn.1
  bespara_1_V = mkV "bespara" "besparade" "besparat" ; -- bespara..vb.1
  besparande_1_N = mkN "besparande" ; -- besparande..nn.1
  besparing_1_N = mkN "besparing" ; -- besparing..nn.1
  besparingskrav_1_N = mkN "besparingskrav" neutrum  ; -- besparingskrav..nn.1
  besparingsskog_1_N = mkN "besparingsskog" ; -- besparingsskog..nn.1
  besparingstorped_1_N = mkN "besparingstorped" "besparingstorpeder" ; -- besparingstorped..nn.1
  bespeja_1_V = mkV "bespejar" ; -- bespeja..vb.1
  bespejande_1_N = mkN "bespejande" ; -- bespejande..nn.1
  bespejning_1_N = mkN "bespejning" ; -- bespejning..nn.1
  bespisa_1_V = mkV "bespisar" ; -- bespisa..vb.1
  bespisande_1_N = mkN "bespisande" ; -- bespisande..nn.1
  bespisning_1_N = mkN "bespisning" ; -- bespisning..nn.1
  bespola_1_V = mkV "bespolar" ; -- bespola..vb.1
  bespolande_1_N = mkN "bespolande" ; -- bespolande..nn.1
  bespotta_1_V = mkV "bespottar" ; -- bespotta..vb.1
  bespottande_1_N = mkN "bespottande" ; -- bespottande..nn.1
  bespottare_1_N = mkN "bespottare" utrum  ; -- bespottare..nn.1
  bespottelse_1_N = mkN "bespottelse" "bespottelser" ; -- bespottelse..nn.1
  bespruta_1_V = mkV "besprutar" ; -- bespruta..vb.1
  besprutande_1_N = mkN "besprutande" ; -- besprutande..nn.1
  besprutning_1_N = mkN "besprutning" ; -- besprutning..nn.1
  besprutningsmedel_1_N = mkN "besprutningsmedel" neutrum  ; -- besprutningsmedel..nn.1
  besprutningsvätska_1_N = mkN "besprutningsvätska" ; -- besprutningsvätska..nn.1
  bessemerblåsning_1_N = mkN "bessemerblåsning" ; -- bessemerblåsning..nn.1
  bessemerstål_1_N = mkN "bessemerstål" neutrum  ; -- bessemerstål..nn.1
  bessemerugn_1_N = mkN "bessemerugn" ; -- bessemerugn..nn.1
  besservisser_1_N = mkN "besservisser" ; -- besservisser..nn.1
  besserwisser_1_N = mkN "besserwisser" ; -- besserwisser..nn.1
  besserwisserattityd_1_N = mkN "besserwisserattityd" "besserwisserattityder" ; -- besserwisserattityd..nn.1
  besserwissra_1_V = mkV "besserwissrar" ; -- besserwissra..vb.1
  besserwissrande_1_N = mkN "besserwissrande" ; -- besserwissrande..nn.1
  best_1_N = mkN "best" ; -- best..nn.1
  bestialisk_1_A = mkA "bestialisk" ; -- bestialisk..av.1
  bestialitet_1_N = mkN "bestialitet" "bestialiteter" ; -- bestialitet..nn.1
  bestick_1_N = mkN "bestick" neutrum  ; -- bestick..nn.1
  besticka_1_V = mkV "besticka" "bestack" "bestuckit" ; -- besticka..vb.1
  bestickande_1_A = mkA "bestickande" ; -- bestickande..av.1
  bestickande_1_N = mkN "bestickande" ; -- bestickande..nn.1
  bestickföring_1_N = mkN "bestickföring" ; -- bestickföring..nn.1
  besticklig_1_A = mkA "besticklig" ; -- besticklig..av.1
  besticklighet_1_N = mkN "besticklighet" ; -- besticklighet..nn.1
  bestickning_1_N = mkN "bestickning" ; -- bestickning..nn.1
  bestiga_1_V = mkV "bestiga" "besteg" "bestigit" ; -- bestiga..vb.1
  bestigande_1_N = mkN "bestigande" ; -- bestigande..nn.1
  bestigning_1_N = mkN "bestigning" ; -- bestigning..nn.1
  bestjäla_1_V = mkV "bestjäla" "bestjäl" "bestjäl" "bestal" "bestulit" "bestulen" ; -- bestjäla..vb.1
  bestjälande_1_N = mkN "bestjälande" ; -- bestjälande..nn.1
  bestorma_1_V = mkV "bestormar" ; -- bestorma..vb.1
  bestormande_1_N = mkN "bestormande" ; -- bestormande..nn.1
  bestormning_1_N = mkN "bestormning" ; -- bestormning..nn.1
  bestraffa_1_V = mkV "bestraffar" ; -- bestraffa..vb.1
  bestraffande_1_N = mkN "bestraffande" ; -- bestraffande..nn.1
  bestraffning_1_N = mkN "bestraffning" ; -- bestraffning..nn.1
  bestraffningskrig_1_N = mkN "bestraffningskrig" neutrum  ; -- bestraffningskrig..nn.1
  bestraffningsmedel_1_N = mkN "bestraffningsmedel" neutrum  ; -- bestraffningsmedel..nn.1
  bestraffningssätt_1_N = mkN "bestraffningssätt" neutrum  ; -- bestraffningssätt..nn.1
  bestrida_1_V = mkV "bestrida" "bestridde" "bestridit" ; -- bestrida..vb.1
  bestridande_1_N = mkN "bestridande" ; -- bestridande..nn.1
  bestryka_1_V = mkV "bestryka" "beströk" "bestrukit" ; -- bestryka..vb.1
  bestrykande_1_N = mkN "bestrykande" ; -- bestrykande..nn.1
  bestrykning_1_N = mkN "bestrykning" ; -- bestrykning..nn.1
  bestråla_1_V = mkV "bestrålar" ; -- bestråla..vb.1
  bestrålande_1_N = mkN "bestrålande" ; -- bestrålande..nn.1
  bestrålning_1_N = mkN "bestrålning" ; -- bestrålning..nn.1
  beströ_1_V = mkV "beströr" ; -- beströ..vb.1
  beströende_1_N = mkN "beströende" ; -- beströende..nn.1
  bestseller_1_N = mkN "bestseller" ; -- bestseller..nn.1
  bestsellerförfattare_1_N = mkN "bestsellerförfattare" utrum  ; -- bestsellerförfattare..nn.1
  bestycka_1_V = mkV "bestyckar" ; -- bestycka..vb.1
  bestyckande_1_N = mkN "bestyckande" ; -- bestyckande..nn.1
  bestyckning_1_N = mkN "bestyckning" ; -- bestyckning..nn.1
  bestyr_1_N = mkN "bestyr" neutrum  ; -- bestyr..nn.1
  bestyra_1_V = mkV "bestyra" "bestyrde" "bestyrt" ; -- bestyra..vb.1
  bestyrande_1_N = mkN "bestyrande" ; -- bestyrande..nn.1
  bestyrka_1_V = mkV "bestyrker" ; -- bestyrka..vb.1
  bestyrkande_1_N = mkN "bestyrkande" ; -- bestyrkande..nn.1
  beställa_1_V = mkV "beställer" ; -- beställa..vb.1
  beställa_2_V = mkV "beställer" ; -- beställa..vb.2
  beställande_1_N = mkN "beställande" ; -- beställande..nn.1
  beställare_1_N = mkN "beställare" utrum  ; -- beställare..nn.1
  beställning_1_N = mkN "beställning" ; -- beställning..nn.1
  beställningsarbete_1_N = mkN "beställningsarbete" ; -- beställningsarbete..nn.1
  beställningsavgift_1_N = mkN "beställningsavgift" "beställningsavgifter" ; -- beställningsavgift..nn.1
  beställningsmord_1_N = mkN "beställningsmord" neutrum  ; -- beställningsmord..nn.1
  beställningsverk_1_N = mkN "beställningsverk" neutrum  ; -- beställningsverk..nn.1
  beställsam_1_A = mkA "beställsam" "beställsamt" "beställsamma" "beställsamma" "beställsammare" "beställsammast" "beställsammaste" ; -- beställsam..av.1
  beställsamhet_1_N = mkN "beställsamhet" ; -- beställsamhet..nn.1
  beställt_1_A = mkA "beställt" ; -- beställt..av.1
  bestämbar_1_A = mkA "bestämbar" ; -- bestämbar..av.1
  bestämbarhet_1_N = mkN "bestämbarhet" ; -- bestämbarhet..nn.1
  bestämd_1_A = mkA "bestämd" "bestämt" ; -- bestämd..av.1
  bestämdhet_1_N = mkN "bestämdhet" ; -- bestämdhet..nn.1
  bestämma_1_V = mkV "bestämmer" ; -- bestämma..vb.1
  bestämmande_1_N = mkN "bestämmande" ; -- bestämmande..nn.1
  bestämmanderätt_1_N = mkN "bestämmanderätt" ; -- bestämmanderätt..nn.1
  bestämmelse_1_N = mkN "bestämmelse" "bestämmelser" ; -- bestämmelse..nn.1
  bestämmelseort_1_N = mkN "bestämmelseort" "bestämmelseorter" ; -- bestämmelseort..nn.1
  bestämning_1_N = mkN "bestämning" ; -- bestämning..nn.1
  bestämningsord_1_N = mkN "bestämningsord" neutrum  ; -- bestämningsord..nn.1
  beständig_1_A = mkA "beständig" ; -- beständig..av.1
  beständighet_1_N = mkN "beständighet" "beständigheter" ; -- beständighet..nn.1
  bestänka_1_V = mkV "bestänker" ; -- bestänka..vb.1
  bestänkande_1_N = mkN "bestänkande" ; -- bestänkande..nn.1
  bestänkning_1_N = mkN "bestänkning" ; -- bestänkning..nn.1
  bestå_1_V = mkV "bestå" "bestod" "bestått" ; -- bestå..vb.1
  bestå_2_V = mkV "bestå" "bestod" "bestådd" ; -- bestå..vb.2
  bestående_1_A = mkA "bestående" ; -- bestående..av.1
  bestående_1_N = mkN "bestående" ; -- bestående..nn.1
  bestånd_1_N = mkN "bestånd" neutrum  ; -- bestånd..nn.1
  beståndande_1_A = mkA "beståndande" ; -- beståndande..av.1
  beståndsbildande_1_A = mkA "beståndsbildande" ; -- beståndsbildande..av.1
  beståndsdel_1_N = mkN "beståndsdel" "beståndsdelen" "beståndsdelar" "beståndsdelarna" ; -- beståndsdel..nn.1
  beståndsmässig_1_A = mkA "beståndsmässig" ; -- beståndsmässig..av.1
  bestört_1_A = mkA "bestört" "bestört" ; -- bestört..av.1
  bestörthet_1_N = mkN "bestörthet" ; -- bestörthet..nn.1
  bestörtning_1_N = mkN "bestörtning" ; -- bestörtning..nn.1
  besudla_1_V = mkV "besudlar" ; -- besudla..vb.1
  besudlande_1_N = mkN "besudlande" ; -- besudlande..nn.1
  besudling_1_N = mkN "besudling" ; -- besudling..nn.1
  besutten_1_A = mkA "besutten" ; -- besutten..av.1
  besuttenhet_1_N = mkN "besuttenhet" ; -- besuttenhet..nn.1
  besvara_1_V = mkV "besvarar" ; -- besvara..vb.1
  besvarande_1_N = mkN "besvarande" ; -- besvarande..nn.1
  besvikelse_1_N = mkN "besvikelse" "besvikelser" ; -- besvikelse..nn.1
  besviken_1_A = mkA "besviken" ; -- besviken..av.1
  besvikenhet_1_N = mkN "besvikenhet" ; -- besvikenhet..nn.1
  besvär_1_N = mkN "besvär" neutrum  ; -- besvär..nn.1
  besvära_1_V = mkV "besvärar" ; -- besvära..vb.1
  besvärad_1_A = mkA "besvärad" ; -- besvärad..av.1
  besvärande_1_A = mkA "besvärande" ; -- besvärande..av.1
  besvärande_1_N = mkN "besvärande" ; -- besvärande..nn.1
  besvärja_1_V = mkV "besvära" "besvär" "besvärj" "besvärjde" "besvärjt" "besvuren" ; -- besvärja..vb.1
  besvärjande_1_N = mkN "besvärjande" ; -- besvärjande..nn.1
  besvärjare_1_N = mkN "besvärjare" utrum  ; -- besvärjare..nn.1
  besvärjelse_1_N = mkN "besvärjelse" "besvärjelser" ; -- besvärjelse..nn.1
  besvärjelseformel_1_N = mkN "besvärjelseformel" "besvärjelseformeln" "besvärjelseformler" "besvärjelseformlerna" ; -- besvärjelseformel..nn.1
  besvärjning_1_N = mkN "besvärjning" ; -- besvärjning..nn.1
  besvärlig_1_A = mkA "besvärlig" ; -- besvärlig..av.1
  besvärlighet_1_N = mkN "besvärlighet" "besvärligheter" ; -- besvärlighet..nn.1
  besvärsfri_1_A = mkA "besvärsfri" "besvärsfritt" ; -- besvärsfri..av.1
  besvärsgrund_1_N = mkN "besvärsgrund" "besvärsgrunder" ; -- besvärsgrund..nn.1
  besvärshandling_1_N = mkN "besvärshandling" ; -- besvärshandling..nn.1
  besvärshänvisning_1_N = mkN "besvärshänvisning" ; -- besvärshänvisning..nn.1
  besvärsinlaga_1_N = mkN "besvärsinlaga" ; -- besvärsinlaga..nn.1
  besvärsinstans_1_N = mkN "besvärsinstans" "besvärsinstanser" ; -- besvärsinstans..nn.1
  besvärsmyndighet_1_N = mkN "besvärsmyndighet" "besvärsmyndigheter" ; -- besvärsmyndighet..nn.1
  besvärsmål_1_N = mkN "besvärsmål" neutrum  ; -- besvärsmål..nn.1
  besvärsrätt_1_N = mkN "besvärsrätt" ; -- besvärsrätt..nn.1
  besvärsskrift_1_N = mkN "besvärsskrift" "besvärsskrifter" ; -- besvärsskrift..nn.1
  besvärssubjekt_1_N = mkN "besvärssubjekt" neutrum  ; -- besvärssubjekt..nn.1
  besvärstid_1_N = mkN "besvärstid" "besvärstider" ; -- besvärstid..nn.1
  besvärsväg_1_N = mkN "besvärsväg" ; -- besvärsväg..nn.1
  besvågrad_1_A = mkA "besvågrad" ; -- besvågrad..av.1
  besynnerlig_1_A = mkA "besynnerlig" ; -- besynnerlig..av.1
  besynnerlighet_1_N = mkN "besynnerlighet" "besynnerligheter" ; -- besynnerlighet..nn.1
  besätta_1_V = mkV "besätta" "besätter" "besätt" "besatte" "besatt" "besatt" ; -- besätta..vb.1
  besättande_1_N = mkN "besättande" ; -- besättande..nn.1
  besättning_1_N = mkN "besättning" ; -- besättning..nn.1
  besättningsband_1_N = mkN "besättningsband" neutrum  ; -- besättningsband..nn.1
  besättningsman_1_N = mkN "besättningsman" "besättningsmannen" "besättningsmän" "besättningsmännen" ; -- besättningsman..nn.1
  besättningsmedlem_1_N = mkN "besättningsmedlem" "besättningsmedlemmen" "besättningsmedlemmar" "besättningsmedlemmarna" ; -- besättningsmedlem..nn.1
  beså_1_V = mkV "besår" ; -- beså..vb.1
  besående_1_N = mkN "besående" ; -- besående..nn.1
  besök_1_N = mkN "besök" neutrum  ; -- besök..nn.1
  besöka_1_V = mkV "besöker" ; -- besöka..vb.1
  besökande_1_N = mkN "besökande" "besökanden" "besökanden" "besökandena" ; -- besökande..nn.1
  besökande_2_N = mkN "besökande" ; -- besökande..nn.2
  besökare_1_N = mkN "besökare" utrum  ; -- besökare..nn.1
  besöksadress_1_N = mkN "besöksadress" "besöksadresser" ; -- besöksadress..nn.1
  besöksbok_1_N = mkN "besöksbok" "besöksböcker" ; -- besöksbok..nn.1
  besöksdag_1_N = mkN "besöksdag" ; -- besöksdag..nn.1
  besöksfåtölj_1_N = mkN "besöksfåtölj" "besöksfåtöljer" ; -- besöksfåtölj..nn.1
  besöksförbud_1_N = mkN "besöksförbud" neutrum  ; -- besöksförbud..nn.1
  besöksnäring_1_N = mkN "besöksnäring" ; -- besöksnäring..nn.1
  besöksrekord_1_N = mkN "besöksrekord" neutrum  ; -- besöksrekord..nn.1
  besöksrestriktion_1_N = mkN "besöksrestriktion" ; -- besöksrestriktion..nn.1
  besöksrum_1_N = mkN "besöksrum" "besöksrummet" "besöksrum" "besöksrummen" ; -- besöksrum..nn.1
  besöksstol_1_N = mkN "besöksstol" ; -- besöksstol..nn.1
  besökstid_1_N = mkN "besökstid" "besökstider" ; -- besökstid..nn.1
  besökstopp_1_N = mkN "besökstopp" neutrum  ; -- besökstopp..nn.1
  besörja_1_V = mkV "besörja" "besörjde" "besörjt" ; -- besörja..vb.1
  besörjande_1_N = mkN "besörjande" ; -- besörjande..nn.1
  bet_1_N = mkN "bet" ; -- bet..nn.1
  beta_1_N = mkN "beta" ; -- beta..nn.1
  beta_2_N = mkN "beta" "betat" "betan" "betana" ; -- beta..nn.2
  beta_1_V = mkV "betar" ; -- beta..vb.1
  beta_2_V = mkV "betaga" "betog" "betagit" ; -- beta..vb.2
  betablockerare_1_N = mkN "betablockerare" utrum  ; -- betablockerare..nn.1
  betagande_1_A = mkA "betagande" ; -- betagande..av.1
  betagande_1_N = mkN "betagande" ; -- betagande..nn.1
  betagen_1_A = mkA "betagen" ; -- betagen..av.1
  betagenhet_1_N = mkN "betagenhet" ; -- betagenhet..nn.1
  betala_1_V = mkV "betalar" ; -- betala..vb.1
  betalande_1_N = mkN "betalande" ; -- betalande..nn.1
  betalare_1_N = mkN "betalare" utrum  ; -- betalare..nn.1
  betalartikel_1_N = mkN "betalartikel" ; -- betalartikel..nn.1
  betalbar_1_A = mkA "betalbar" ; -- betalbar..av.1
  betalbarhet_1_N = mkN "betalbarhet" ; -- betalbarhet..nn.1
  betalkort_1_N = mkN "betalkort" neutrum  ; -- betalkort..nn.1
  betalkurs_1_N = mkN "betalkurs" "betalkurser" ; -- betalkurs..nn.1
  betalning_1_N = mkN "betalning" ; -- betalning..nn.1
  betalningsanmärkning_1_N = mkN "betalningsanmärkning" ; -- betalningsanmärkning..nn.1
  betalningsanstånd_1_N = mkN "betalningsanstånd" neutrum  ; -- betalningsanstånd..nn.1
  betalningsavtal_1_N = mkN "betalningsavtal" neutrum  ; -- betalningsavtal..nn.1
  betalningsbalans_1_N = mkN "betalningsbalans" "betalningsbalanser" ; -- betalningsbalans..nn.1
  betalningsbevis_1_N = mkN "betalningsbevis" neutrum  ; -- betalningsbevis..nn.1
  betalningsdag_1_N = mkN "betalningsdag" ; -- betalningsdag..nn.1
  betalningsfri_1_A = mkA "betalningsfri" "betalningsfritt" ; -- betalningsfri..av.1
  betalningsfrist_1_N = mkN "betalningsfrist" "betalningsfrister" ; -- betalningsfrist..nn.1
  betalningsföreläggande_1_N = mkN "betalningsföreläggande" ; -- betalningsföreläggande..nn.1
  betalningsförmåga_1_N = mkN "betalningsförmåga" ; -- betalningsförmåga..nn.1
  betalningsgill_1_A = mkA "betalningsgill" ; -- betalningsgill..av.1
  betalningsinställelse_1_N = mkN "betalningsinställelse" "betalningsinställelser" ; -- betalningsinställelse..nn.1
  betalningsmedel_1_N = mkN "betalningsmedel" neutrum  ; -- betalningsmedel..nn.1
  betalningsskyldig_1_A = mkA "betalningsskyldig" ; -- betalningsskyldig..av.1
  betalningsskyldighet_1_N = mkN "betalningsskyldighet" ; -- betalningsskyldighet..nn.1
  betalningssäkra_1_V = mkV "betalningssäkrar" ; -- betalningssäkra..vb.1
  betalningstermin_1_N = mkN "betalningstermin" "betalningsterminer" ; -- betalningstermin..nn.1
  betalningstid_1_N = mkN "betalningstid" "betalningstider" ; -- betalningstid..nn.1
  betalningsvilja_1_N = mkN "betalningsvilja" ; -- betalningsvilja..nn.1
  betalningsvillkor_1_N = mkN "betalningsvillkor" neutrum  ; -- betalningsvillkor..nn.1
  betalsex_1_N = mkN "betalsex" neutrum  ; -- betalsex..nn.1
  betaltjänst_1_N = mkN "betaltjänst" "betaltjänster" ; -- betaltjänst..nn.1
  betande_1_N = mkN "betande" ; -- betande..nn.1
  betapartikel_1_N = mkN "betapartikel" ; -- betapartikel..nn.1
  betastrålande_1_A = mkA "betastrålande" ; -- betastrålande..av.1
  betastrålning_1_N = mkN "betastrålning" ; -- betastrålning..nn.1
  betasönderfall_1_N = mkN "betasönderfall" neutrum  ; -- betasönderfall..nn.1
  betatron_1_N = mkN "betatron" "betatroner" ; -- betatron..nn.1
  bete_1_N = mkN "bete" ; -- bete..nn.1
  bete_2_N = mkN "bete" utrum  ; -- bete..nn.2
  beteckna_1_V = mkV "betecknar" ; -- beteckna..vb.1
  betecknande_1_A = mkA "betecknande" ; -- betecknande..av.1
  betecknande_1_N = mkN "betecknande" ; -- betecknande..nn.1
  beteckning_1_N = mkN "beteckning" ; -- beteckning..nn.1
  beteckningssätt_1_N = mkN "beteckningssätt" neutrum  ; -- beteckningssätt..nn.1
  beteende_1_N = mkN "beteende" ; -- beteende..nn.1
  beteendebehandling_1_N = mkN "beteendebehandling" ; -- beteendebehandling..nn.1
  beteendeforskning_1_N = mkN "beteendeforskning" ; -- beteendeforskning..nn.1
  beteendemässig_1_A = mkA "beteendemässig" ; -- beteendemässig..av.1
  beteendemönster_1_N = mkN "beteendemönster" neutrum  ; -- beteendemönster..nn.1
  beteendepsykologi_1_N = mkN "beteendepsykologi" ; -- beteendepsykologi..nn.1
  beteenderubbning_1_N = mkN "beteenderubbning" ; -- beteenderubbning..nn.1
  beteendeterapeut_1_N = mkN "beteendeterapeut" "beteendeterapeuter" ; -- beteendeterapeut..nn.1
  beteendeterapi_1_N = mkN "beteendeterapi" ; -- beteendeterapi..nn.1
  beteendevetare_1_N = mkN "beteendevetare" utrum  ; -- beteendevetare..nn.1
  beteendevetenskap_1_N = mkN "beteendevetenskap" "beteendevetenskaper" ; -- beteendevetenskap..nn.1
  beteendevetenskaplig_1_A = mkA "beteendevetenskaplig" ; -- beteendevetenskaplig..av.1
  betel_1_N = mkN "betel" ; -- betel..nn.1
  betelblad_1_N = mkN "betelblad" neutrum  ; -- betelblad..nn.1
  betelnöt_1_N = mkN "betelnöt" "betelnötter" ; -- betelnöt..nn.1
  betelpalm_1_N = mkN "betelpalm" "betelpalmer" ; -- betelpalm..nn.1
  beteltuggare_1_N = mkN "beteltuggare" utrum  ; -- beteltuggare..nn.1
  beteltuggning_1_N = mkN "beteltuggning" ; -- beteltuggning..nn.1
  betesgång_1_N = mkN "betesgång" ; -- betesgång..nn.1
  beteshage_1_N = mkN "beteshage" utrum  ; -- beteshage..nn.1
  betesland_1_N = mkN "betesland" neutrum  ; -- betesland..nn.1
  betesmark_1_N = mkN "betesmark" "betesmarker" ; -- betesmark..nn.1
  betesområde_1_N = mkN "betesområde" ; -- betesområde..nn.1
  betesplats_1_N = mkN "betesplats" "betesplatser" ; -- betesplats..nn.1
  betessläpp_1_N = mkN "betessläpp" ; -- betessläpp..nn.1
  betesutsläpp_1_N = mkN "betesutsläpp" ; -- betesutsläpp..nn.1
  beting_1_N = mkN "beting" neutrum  ; -- beting..nn.1
  beting_2_N = mkN "beting" ; -- beting..nn.2
  betinga_1_V = mkV "betingar" ; -- betinga..vb.1
  betingad_1_A = mkA "betingad" ; -- betingad..av.1
  betingande_1_N = mkN "betingande" ; -- betingande..nn.1
  betingelse_1_N = mkN "betingelse" "betingelser" ; -- betingelse..nn.1
  betingning_1_N = mkN "betingning" ; -- betingning..nn.1
  betingsarbete_1_N = mkN "betingsarbete" ; -- betingsarbete..nn.1
  betingsläsning_1_N = mkN "betingsläsning" ; -- betingsläsning..nn.1
  betitla_1_V = mkV "betitlar" ; -- betitla..vb.1
  betitlande_1_N = mkN "betitlande" ; -- betitlande..nn.1
  betitta_1_V = mkV "betittar" ; -- betitta..vb.1
  betittande_1_N = mkN "betittande" ; -- betittande..nn.1
  betjäna_1_V = mkV "betjänar" ; -- betjäna..vb.1
  betjänande_1_N = mkN "betjänande" ; -- betjänande..nn.1
  betjäning_1_N = mkN "betjäning" ; -- betjäning..nn.1
  betjäningsavgift_1_N = mkN "betjäningsavgift" "betjäningsavgifter" ; -- betjäningsavgift..nn.1
  betjänt_1_A = mkA "betjänt" "betjänt" ; -- betjänt..av.1
  betjänt_1_N = mkN "betjänt" "betjänter" ; -- betjänt..nn.1
  betkampanj_1_N = mkN "betkampanj" "betkampanjer" ; -- betkampanj..nn.1
  betmedel_1_N = mkN "betmedel" neutrum  ; -- betmedel..nn.1
  betning_1_N = mkN "betning" ; -- betning..nn.1
  betodling_1_N = mkN "betodling" ; -- betodling..nn.1
  betona_1_V = mkV "betonar" ; -- betona..vb.1
  betonad_1_A = mkA "betonad" ; -- betonad..av.1
  betonande_1_N = mkN "betonande" ; -- betonande..nn.1
  betong_1_N = mkN "betong" "betonger" ; -- betong..nn.1
  betongbjälklag_1_N = mkN "betongbjälklag" neutrum  ; -- betongbjälklag..nn.1
  betongblandare_1_N = mkN "betongblandare" utrum  ; -- betongblandare..nn.1
  betongblock_1_N = mkN "betongblock" neutrum  ; -- betongblock..nn.1
  betongbädd_1_N = mkN "betongbädd" ; -- betongbädd..nn.1
  betongera_1_V = mkV "betongerar" ; -- betongera..vb.1
  betongerande_1_N = mkN "betongerande" ; -- betongerande..nn.1
  betongerbar_1_A = mkA "betongerbar" ; -- betongerbar..av.1
  betongerbarhet_1_N = mkN "betongerbarhet" ; -- betongerbarhet..nn.1
  betongering_1_N = mkN "betongering" ; -- betongering..nn.1
  betongfärg_1_N = mkN "betongfärg" "betongfärger" ; -- betongfärg..nn.1
  betonggolv_1_N = mkN "betonggolv" neutrum  ; -- betonggolv..nn.1
  betonghinder_1_N = mkN "betonghinder" neutrum  ; -- betonghinder..nn.1
  betonghäck_1_N = mkN "betonghäck" ; -- betonghäck..nn.1
  betongmaskin_1_N = mkN "betongmaskin" "betongmaskiner" ; -- betongmaskin..nn.1
  betongparti_1_N = mkN "betongparti" "betongpartiet" "betongpartier" "betongpartierna" ; -- betongparti..nn.1
  betongpåle_1_N = mkN "betongpåle" utrum  ; -- betongpåle..nn.1
  betongsugga_1_N = mkN "betongsugga" ; -- betongsugga..nn.1
  betongvalv_1_N = mkN "betongvalv" neutrum  ; -- betongvalv..nn.1
  betongvibrator_1_N = mkN "betongvibrator" "betongvibratorer" ; -- betongvibrator..nn.1
  betoning_1_N = mkN "betoning" ; -- betoning..nn.1
  betrakta_1_V = mkV "betraktar" ; -- betrakta..vb.1
  betraktande_1_N = mkN "betraktande" ; -- betraktande..nn.1
  betraktare_1_N = mkN "betraktare" utrum  ; -- betraktare..nn.1
  betraktelse_1_N = mkN "betraktelse" "betraktelser" ; -- betraktelse..nn.1
  betraktelsesätt_1_N = mkN "betraktelsesätt" neutrum  ; -- betraktelsesätt..nn.1
  betro_1_V = mkV "betror" ; -- betro..vb.1
  betrodd_1_A = mkA "betrodd" ; -- betrodd..av.1
  betroddhet_1_N = mkN "betroddhet" ; -- betroddhet..nn.1
  betroende_1_N = mkN "betroende" ; -- betroende..nn.1
  betryck_1_N = mkN "betryck" neutrum  ; -- betryck..nn.1
  betrycka_1_V = mkV "betrycker" ; -- betrycka..vb.1
  betryckande_1_N = mkN "betryckande" ; -- betryckande..nn.1
  betryckt_1_A = mkA "betryckt" "betryckt" ; -- betryckt..av.1
  betryckthet_1_N = mkN "betryckthet" ; -- betryckthet..nn.1
  betrygga_1_V = mkV "betryggar" ; -- betrygga..vb.1
  betryggande_1_A = mkA "betryggande" ; -- betryggande..av.1
  betryggande_1_N = mkN "betryggande" ; -- betryggande..nn.1
  beträda_1_V = mkV "beträda" "beträdde" "beträtt" ; -- beträda..vb.1
  beträdande_1_N = mkN "beträdande" ; -- beträdande..nn.1
  beträffa_1_V = mkV "beträffar" ; -- beträffa..vb.1
  beträffande_1_N = mkN "beträffande" ; -- beträffande..nn.1
  beträngd_1_A = mkA "beträngd" "beträngt" ; -- beträngd..av.1
  beträngdhet_1_N = mkN "beträngdhet" ; -- beträngdhet..nn.1
  bets_1_N = mkN "bets" "betser" ; -- bets..nn.1
  betsa_1_V = mkV "betsar" ; -- betsa..vb.1
  betsande_1_N = mkN "betsande" ; -- betsande..nn.1
  betsel_1_N = mkN "betsel" neutrum  ; -- betsel..nn.1
  betsla_1_V = mkV "betslar" ; -- betsla..vb.1
  betslande_1_N = mkN "betslande" ; -- betslande..nn.1
  betsling_1_N = mkN "betsling" ; -- betsling..nn.1
  betsmedel_1_N = mkN "betsmedel" neutrum  ; -- betsmedel..nn.1
  betsning_1_N = mkN "betsning" ; -- betsning..nn.1
  betsocker_1_N = mkN "betsocker" neutrum  ; -- betsocker..nn.1
  betsockerindustri_1_N = mkN "betsockerindustri" "betsockerindustrier" ; -- betsockerindustri..nn.1
  bett_1_N = mkN "bett" neutrum  ; -- bett..nn.1
  bettel_1_N = mkN "bettel" ; -- bettel..nn.1
  bettla_1_V = mkV "bettlar" ; -- bettla..vb.1
  bettlande_1_N = mkN "bettlande" ; -- bettlande..nn.1
  bettlare_1_N = mkN "bettlare" utrum  ; -- bettlare..nn.1
  bettleri_1_N = mkN "bettleri" neutrum  ; -- bettleri..nn.1
  bettskena_1_N = mkN "bettskena" ; -- bettskena..nn.1
  betunga_1_V = mkV "betungar" ; -- betunga..vb.1
  betungande_1_A = mkA "betungande" ; -- betungande..av.1
  betungande_1_N = mkN "betungande" ; -- betungande..nn.1
  betuttad_1_A = mkA "betuttad" ; -- betuttad..av.1
  betvinga_1_V = mkV "betvingar" ; -- betvinga..vb.1
  betvingande_1_A = mkA "betvingande" ; -- betvingande..av.1
  betvingande_1_N = mkN "betvingande" ; -- betvingande..nn.1
  betvingare_1_N = mkN "betvingare" utrum  ; -- betvingare..nn.1
  betvivla_1_V = mkV "betvivlar" ; -- betvivla..vb.1
  betvivlande_1_N = mkN "betvivlande" ; -- betvivlande..nn.1
  betyda_1_V = mkV "betyda" "betydde" "betytt" ; -- betyda..vb.1
  betydande_1_A = mkA "betydande" ; -- betydande..av.1
  betydande_1_N = mkN "betydande" ; -- betydande..nn.1
  betydelse_1_N = mkN "betydelse" "betydelser" ; -- betydelse..nn.1
  betydelsebärande_1_A = mkA "betydelsebärande" ; -- betydelsebärande..av.1
  betydelsefattig_1_A = mkA "betydelsefattig" ; -- betydelsefattig..av.1
  betydelsefull_1_A = mkA "betydelsefull" ; -- betydelsefull..av.1
  betydelsefullhet_1_N = mkN "betydelsefullhet" ; -- betydelsefullhet..nn.1
  betydelseförskjutning_1_N = mkN "betydelseförskjutning" ; -- betydelseförskjutning..nn.1
  betydelseförändring_1_N = mkN "betydelseförändring" ; -- betydelseförändring..nn.1
  betydelseglidning_1_N = mkN "betydelseglidning" ; -- betydelseglidning..nn.1
  betydelselager_1_N = mkN "betydelselager" neutrum  ; -- betydelselager..nn.1
  betydelselära_1_N = mkN "betydelselära" ; -- betydelselära..nn.1
  betydelselös_1_A = mkA "betydelselös" ; -- betydelselös..av.1
  betydelselöshet_1_N = mkN "betydelselöshet" ; -- betydelselöshet..nn.1
  betydelsemässig_1_A = mkA "betydelsemässig" ; -- betydelsemässig..av.1
  betydelsenyans_1_N = mkN "betydelsenyans" "betydelsenyanser" ; -- betydelsenyans..nn.1
  betydelseskikt_1_N = mkN "betydelseskikt" neutrum  ; -- betydelseskikt..nn.1
  betydelseutveckling_1_N = mkN "betydelseutveckling" ; -- betydelseutveckling..nn.1
  betydenhet_1_N = mkN "betydenhet" "betydenheter" ; -- betydenhet..nn.1
  betydlig_1_A = mkA "betydlig" ; -- betydlig..av.1
  betydlighet_1_N = mkN "betydlighet" ; -- betydlighet..nn.1
  betyg_1_N = mkN "betyg" neutrum  ; -- betyg..nn.1
  betyga_1_V = mkV "betygar" ; -- betyga..vb.1
  betygande_1_N = mkN "betygande" ; -- betygande..nn.1
  betygelse_1_N = mkN "betygelse" "betygelser" ; -- betygelse..nn.1
  betyghöjning_1_N = mkN "betyghöjning" ; -- betyghöjning..nn.1
  betygkramare_1_N = mkN "betygkramare" utrum  ; -- betygkramare..nn.1
  betygsavskrift_1_N = mkN "betygsavskrift" "betygsavskrifter" ; -- betygsavskrift..nn.1
  betygsfri_1_A = mkA "betygsfri" "betygsfritt" ; -- betygsfri..av.1
  betygsgrad_1_N = mkN "betygsgrad" "betygsgrader" ; -- betygsgrad..nn.1
  betygshets_1_N = mkN "betygshets" ; -- betygshets..nn.1
  betygshöjning_1_N = mkN "betygshöjning" ; -- betygshöjning..nn.1
  betygsjäkt_1_N = mkN "betygsjäkt" ; -- betygsjäkt..nn.1
  betygskatalog_1_N = mkN "betygskatalog" "betygskataloger" ; -- betygskatalog..nn.1
  betygsnämnd_1_N = mkN "betygsnämnd" "betygsnämnder" ; -- betygsnämnd..nn.1
  betygsskala_1_N = mkN "betygsskala" ; -- betygsskala..nn.1
  betygsstress_1_N = mkN "betygsstress" ; -- betygsstress..nn.1
  betygssänkning_1_N = mkN "betygssänkning" ; -- betygssänkning..nn.1
  betygssätta_1_V = mkV "betygssätta" "betygssätter" "betygssätt" "betygssatte" "betygssatt" "betygssatt" ; -- betygssätta..vb.1
  betygssättande_1_N = mkN "betygssättande" ; -- betygssättande..nn.1
  betygssättning_1_N = mkN "betygssättning" ; -- betygssättning..nn.1
  betygsänkning_1_N = mkN "betygsänkning" ; -- betygsänkning..nn.1
  betygsätta_1_V = mkV "betygsätta" "betygsätter" "betygsätt" "betygsatte" "betygsatt" "betygsatt" ; -- betygsätta..vb.1
  betygsättande_1_N = mkN "betygsättande" ; -- betygsättande..nn.1
  betygsättning_1_N = mkN "betygsättning" ; -- betygsättning..nn.1
  betäcka_1_V = mkV "betäcker" ; -- betäcka..vb.1
  betäckande_1_N = mkN "betäckande" ; -- betäckande..nn.1
  betäckning_1_N = mkN "betäckning" ; -- betäckning..nn.1
  betäckningsavgift_1_N = mkN "betäckningsavgift" "betäckningsavgifter" ; -- betäckningsavgift..nn.1
  betänka_1_V = mkV "betänker" ; -- betänka..vb.1
  betänkande_1_N = mkN "betänkande" ; -- betänkande..nn.1
  betänketid_1_N = mkN "betänketid" "betänketider" ; -- betänketid..nn.1
  betänklig_1_A = mkA "betänklig" ; -- betänklig..av.1
  betänklighet_1_N = mkN "betänklighet" "betänkligheter" ; -- betänklighet..nn.1
  betänksam_1_A = mkA "betänksam" "betänksamt" "betänksamma" "betänksamma" "betänksammare" "betänksammast" "betänksammaste" ; -- betänksam..av.1
  betänksamhet_1_N = mkN "betänksamhet" ; -- betänksamhet..nn.1
  betänkt_1_A = mkA "betänkt" "betänkt" ; -- betänkt..av.1
  beundra_1_V = mkV "beundrar" ; -- beundra..vb.1
  beundrande_1_N = mkN "beundrande" ; -- beundrande..nn.1
  beundransvärd_1_A = mkA "beundransvärd" "beundransvärt" ; -- beundransvärd..av.1
  beundransvärdhet_1_N = mkN "beundransvärdhet" ; -- beundransvärdhet..nn.1
  beundrare_1_N = mkN "beundrare" utrum  ; -- beundrare..nn.1
  beundrarinna_1_N = mkN "beundrarinna" ; -- beundrarinna..nn.1
  bevaka_1_V = mkV "bevakar" ; -- bevaka..vb.1
  bevakande_1_N = mkN "bevakande" ; -- bevakande..nn.1
  bevakning_1_N = mkN "bevakning" ; -- bevakning..nn.1
  bevakningsinlaga_1_N = mkN "bevakningsinlaga" ; -- bevakningsinlaga..nn.1
  bevakningsinsats_1_N = mkN "bevakningsinsats" "bevakningsinsatser" ; -- bevakningsinsats..nn.1
  bevakningskedja_1_N = mkN "bevakningskedja" ; -- bevakningskedja..nn.1
  bevakningsområde_1_N = mkN "bevakningsområde" ; -- bevakningsområde..nn.1
  bevakningsuppdrag_1_N = mkN "bevakningsuppdrag" neutrum  ; -- bevakningsuppdrag..nn.1
  bevandrad_1_A = mkA "bevandrad" ; -- bevandrad..av.1
  bevara_1_V = mkV "bevarar" ; -- bevara..vb.1
  bevarande_1_N = mkN "bevarande" ; -- bevarande..nn.1
  bevarandeomständighet_1_N = mkN "bevarandeomständighet" "bevarandeomständigheter" ; -- bevarandeomständighet..nn.1
  bevare_1_V = mkV "bevare" ; -- bevare..vb.1
  bevattna_1_V = mkV "bevattnar" ; -- bevattna..vb.1
  bevattnande_1_N = mkN "bevattnande" ; -- bevattnande..nn.1
  bevattning_1_N = mkN "bevattning" ; -- bevattning..nn.1
  bevattningsanläggning_1_N = mkN "bevattningsanläggning" ; -- bevattningsanläggning..nn.1
  bevattningsförbud_1_N = mkN "bevattningsförbud" neutrum  ; -- bevattningsförbud..nn.1
  bevattningskanal_1_N = mkN "bevattningskanal" "bevattningskanaler" ; -- bevattningskanal..nn.1
  bevattningsregel_1_N = mkN "bevattningsregel" "bevattningsregeln" "bevattningsregler" "bevattningsreglerna" ; -- bevattningsregel..nn.1
  bevattningssystem_1_N = mkN "bevattningssystem" neutrum  ; -- bevattningssystem..nn.1
  beveka_1_V = mkV "beveker" ; -- beveka..vb.1
  bevekande_1_A = mkA "bevekande" ; -- bevekande..av.1
  bevekande_1_N = mkN "bevekande" ; -- bevekande..nn.1
  bevekelse_1_N = mkN "bevekelse" "bevekelser" ; -- bevekelse..nn.1
  bevekelsegrund_1_N = mkN "bevekelsegrund" "bevekelsegrunder" ; -- bevekelsegrund..nn.1
  bevilja_1_V = mkV "beviljar" ; -- bevilja..vb.1
  beviljande_1_N = mkN "beviljande" ; -- beviljande..nn.1
  bevillning_1_N = mkN "bevillning" ; -- bevillning..nn.1
  bevillningsavgift_1_N = mkN "bevillningsavgift" "bevillningsavgifter" ; -- bevillningsavgift..nn.1
  bevillningsutskott_1_N = mkN "bevillningsutskott" neutrum  ; -- bevillningsutskott..nn.1
  bevingad_1_A = mkA "bevingad" ; -- bevingad..av.1
  bevis_1_N = mkN "bevis" neutrum  ; -- bevis..nn.1
  bevisa_1_V = mkV "bevisar" ; -- bevisa..vb.1
  bevisande_1_N = mkN "bevisande" ; -- bevisande..nn.1
  bevisbar_1_A = mkA "bevisbar" ; -- bevisbar..av.1
  bevisbarhet_1_N = mkN "bevisbarhet" ; -- bevisbarhet..nn.1
  bevisbörda_1_N = mkN "bevisbörda" ; -- bevisbörda..nn.1
  bevisföring_1_N = mkN "bevisföring" ; -- bevisföring..nn.1
  bevisförvanskning_1_N = mkN "bevisförvanskning" ; -- bevisförvanskning..nn.1
  beviskedja_1_N = mkN "beviskedja" ; -- beviskedja..nn.1
  beviskraft_1_N = mkN "beviskraft" "beviskrafter" ; -- beviskraft..nn.1
  beviskraftig_1_A = mkA "beviskraftig" ; -- beviskraftig..av.1
  beviskraftighet_1_N = mkN "beviskraftighet" ; -- beviskraftighet..nn.1
  beviskrav_1_N = mkN "beviskrav" neutrum  ; -- beviskrav..nn.1
  bevislig_1_A = mkA "bevislig" ; -- bevislig..av.1
  bevisligen_1_Adv = mkAdv "bevisligen" ; -- bevisligen..ab.1
  bevislighet_1_N = mkN "bevislighet" ; -- bevislighet..nn.1
  bevismaterial_1_N = mkN "bevismaterial" neutrum  ; -- bevismaterial..nn.1
  bevismedel_1_N = mkN "bevismedel" neutrum  ; -- bevismedel..nn.1
  bevismässig_1_A = mkA "bevismässig" ; -- bevismässig..av.1
  bevisning_1_N = mkN "bevisning" ; -- bevisning..nn.1
  bevisprövning_1_N = mkN "bevisprövning" ; -- bevisprövning..nn.1
  bevisskyldig_1_A = mkA "bevisskyldig" ; -- bevisskyldig..av.1
  bevisskyldighet_1_N = mkN "bevisskyldighet" ; -- bevisskyldighet..nn.1
  bevissvårighet_1_N = mkN "bevissvårighet" "bevissvårigheter" ; -- bevissvårighet..nn.1
  bevissäkring_1_N = mkN "bevissäkring" ; -- bevissäkring..nn.1
  bevista_1_V = mkV "bevistar" ; -- bevista..vb.1
  bevistande_1_N = mkN "bevistande" ; -- bevistande..nn.1
  bevisvärde_1_N = mkN "bevisvärde" ; -- bevisvärde..nn.1
  bevisvärdering_1_N = mkN "bevisvärdering" ; -- bevisvärdering..nn.1
  bevittna_1_V = mkV "bevittnar" ; -- bevittna..vb.1
  bevittnande_1_N = mkN "bevittnande" ; -- bevittnande..nn.1
  bevuxen_1_A = mkA "bevuxen" ; -- bevuxen..av.1
  bevänt_1_A = mkA "bevänt" ; -- bevänt..av.1
  beväpna_1_V = mkV "beväpnar" ; -- beväpna..vb.1
  beväpnad_1_A = mkA "beväpnad" ; -- beväpnad..av.1
  beväpnande_1_N = mkN "beväpnande" ; -- beväpnande..nn.1
  beväpning_1_N = mkN "beväpning" ; -- beväpning..nn.1
  bevära_1_V = mkV "bevärar" ; -- bevära..vb.1
  bevärande_1_N = mkN "bevärande" ; -- bevärande..nn.1
  bevärdiga_1_V = mkV "bevärdigar" ; -- bevärdiga..vb.1
  bevärdigande_1_N = mkN "bevärdigande" ; -- bevärdigande..nn.1
  beväring_1_N = mkN "beväring" ; -- beväring..nn.1
  beväxt_1_A = mkA "beväxt" "beväxt" ; -- beväxt..av.1
  bevågen_1_A = mkA "bevågen" ; -- bevågen..av.1
  bevågenhet_1_N = mkN "bevågenhet" "bevågenheter" ; -- bevågenhet..nn.1
  bezique_1_N = mkN "bezique" utrum  ; -- bezique..nn.1
  bhutanes_1_N = mkN "bhutanes" "bhutaneser" ; -- bhutanes..nn.1
  bhutanesisk_1_A = mkA "bhutanesisk" ; -- bhutanesisk..av.1
  bhutanesiska_1_N = mkN "bhutanesiska" ; -- bhutanesiska..nn.1
  bi_1_A = mkA "bi" ; -- bi..av.1
  bi_1_N = mkN "bi" "biet" "bin" "bina" ; -- bi..nn.1
  biaccent_1_N = mkN "biaccent" "biaccenter" ; -- biaccent..nn.1
  bias_1_N = mkN "bias" "biaser" ; -- bias..nn.1
  biavel_1_N = mkN "biavel" ; -- biavel..nn.1
  biavsikt_1_N = mkN "biavsikt" "biavsikter" ; -- biavsikt..nn.1
  bibana_1_N = mkN "bibana" ; -- bibana..nn.1
  bibehålla_1_V = mkV "bibehålla" "bibehöll" "bibehållit" ; -- bibehålla..vb.1
  bibehållande_1_N = mkN "bibehållande" ; -- bibehållande..nn.1
  bibehållen_1_A = mkA "bibehållen" ; -- bibehållen..av.1
  bibel_1_N = mkN "bibel" ; -- bibel..nn.1
  bibelcitat_1_N = mkN "bibelcitat" neutrum  ; -- bibelcitat..nn.1
  bibelexeget_1_N = mkN "bibelexeget" "bibelexegeter" ; -- bibelexeget..nn.1
  bibelforskning_1_N = mkN "bibelforskning" ; -- bibelforskning..nn.1
  bibelförklaring_1_N = mkN "bibelförklaring" ; -- bibelförklaring..nn.1
  bibelhandskrift_1_N = mkN "bibelhandskrift" "bibelhandskrifter" ; -- bibelhandskrift..nn.1
  bibelkanon_1_N = mkN "bibelkanon" "bibelkanon" "bibelkanoner" "bibelkanonerna" ; -- bibelkanon..nn.1
  bibelkommission_1_N = mkN "bibelkommission" ; -- bibelkommission..nn.1
  bibelkonkordans_1_N = mkN "bibelkonkordans" "bibelkonkordanser" ; -- bibelkonkordans..nn.1
  bibelkristen_1_A = mkA "bibelkristen" ; -- bibelkristen..av.1
  bibelkristenhet_1_N = mkN "bibelkristenhet" ; -- bibelkristenhet..nn.1
  bibelkritik_1_N = mkN "bibelkritik" ; -- bibelkritik..nn.1
  bibelkunnig_1_A = mkA "bibelkunnig" ; -- bibelkunnig..av.1
  bibelkunnighet_1_N = mkN "bibelkunnighet" ; -- bibelkunnighet..nn.1
  bibelord_1_N = mkN "bibelord" neutrum  ; -- bibelord..nn.1
  bibelsamtal_1_N = mkN "bibelsamtal" neutrum  ; -- bibelsamtal..nn.1
  bibelsprängd_1_A = mkA "bibelsprängd" "bibelsprängt" ; -- bibelsprängd..av.1
  bibelsprängdhet_1_N = mkN "bibelsprängdhet" ; -- bibelsprängdhet..nn.1
  bibelspråk_1_N = mkN "bibelspråk" neutrum  ; -- bibelspråk..nn.1
  bibelställe_1_N = mkN "bibelställe" ; -- bibelställe..nn.1
  bibelsällskap_1_N = mkN "bibelsällskap" neutrum  ; -- bibelsällskap..nn.1
  bibeltext_1_N = mkN "bibeltext" "bibeltexter" ; -- bibeltext..nn.1
  bibeltolkning_1_N = mkN "bibeltolkning" ; -- bibeltolkning..nn.1
  bibeltroende_1_A = mkA "bibeltroende" ; -- bibeltroende..av.1
  bibeltrogen_1_A = mkA "bibeltrogen" ; -- bibeltrogen..av.1
  bibeltrogenhet_1_N = mkN "bibeltrogenhet" ; -- bibeltrogenhet..nn.1
  bibelvers_1_N = mkN "bibelvers" ; -- bibelvers..nn.1
  bibelöversättning_1_N = mkN "bibelöversättning" ; -- bibelöversättning..nn.1
  bibestämning_1_N = mkN "bibestämning" ; -- bibestämning..nn.1
  bibetydelse_1_N = mkN "bibetydelse" "bibetydelser" ; -- bibetydelse..nn.1
  biblicism_1_N = mkN "biblicism" "biblicismer" ; -- biblicism..nn.1
  biblicistisk_1_A = mkA "biblicistisk" ; -- biblicistisk..av.1
  bibliofil_1_N = mkN "bibliofil" "bibliofiler" ; -- bibliofil..nn.1
  bibliofilupplaga_1_N = mkN "bibliofilupplaga" ; -- bibliofilupplaga..nn.1
  bibliograf_1_N = mkN "bibliograf" "bibliografer" ; -- bibliograf..nn.1
  bibliografi_1_N = mkN "bibliografi" "bibliografier" ; -- bibliografi..nn.1
  bibliografisk_1_A = mkA "bibliografisk" ; -- bibliografisk..av.1
  biblioman_1_N = mkN "biblioman" "bibliomaner" ; -- biblioman..nn.1
  bibliomani_1_N = mkN "bibliomani" ; -- bibliomani..nn.1
  bibliometri_1_N = mkN "bibliometri" ; -- bibliometri..nn.1
  bibliotek_1_N = mkN "bibliotek" neutrum  ; -- bibliotek..nn.1
  bibliotekarie_1_N = mkN "bibliotekarie" "bibliotekarier" ; -- bibliotekarie..nn.1
  biblioteksavgift_1_N = mkN "biblioteksavgift" "biblioteksavgifter" ; -- biblioteksavgift..nn.1
  biblioteksband_1_N = mkN "biblioteksband" neutrum  ; -- biblioteksband..nn.1
  biblioteksbelysning_1_N = mkN "biblioteksbelysning" ; -- biblioteksbelysning..nn.1
  biblioteksbord_1_N = mkN "biblioteksbord" neutrum  ; -- biblioteksbord..nn.1
  biblioteksbrand_1_N = mkN "biblioteksbrand" "biblioteksbränder" ; -- biblioteksbrand..nn.1
  bibliotekshögskola_1_N = mkN "bibliotekshögskola" ; -- bibliotekshögskola..nn.1
  bibliotekskatalog_1_N = mkN "bibliotekskatalog" "bibliotekskataloger" ; -- bibliotekskatalog..nn.1
  bibliotekslån_1_N = mkN "bibliotekslån" neutrum  ; -- bibliotekslån..nn.1
  biblisk_1_A = mkA "biblisk" ; -- biblisk..av.1
  biblomma_1_N = mkN "biblomma" ; -- biblomma..nn.1
  bibringa_1_V = mkV "bibringar" ; -- bibringa..vb.1
  bibringande_1_N = mkN "bibringande" ; -- bibringande..nn.1
  bibröd_1_N = mkN "bibröd" neutrum  ; -- bibröd..nn.1
  biceps_1_N = mkN "biceps" ; -- biceps..nn.1
  bicepsmuskel_1_N = mkN "bicepsmuskel" "bicepsmuskeln" "bicepsmuskler" "bicepsmusklerna" ; -- bicepsmuskel..nn.1
  bicepssena_1_N = mkN "bicepssena" ; -- bicepssena..nn.1
  bida_1_V = mkV "bidar" ; -- bida..vb.1
  bidande_1_N = mkN "bidande" ; -- bidande..nn.1
  bidevindare_1_N = mkN "bidevindare" utrum  ; -- bidevindare..nn.1
  bidevindsegel_1_N = mkN "bidevindsegel" neutrum  ; -- bidevindsegel..nn.1
  bidevindseglare_1_N = mkN "bidevindseglare" utrum  ; -- bidevindseglare..nn.1
  bidra_1_V = mkV "bidraga" "bidrog" "bidragit" ; -- bidra..vb.1
  bidrag_1_N = mkN "bidrag" neutrum  ; -- bidrag..nn.1
  bidragande_1_A = mkA "bidragande" ; -- bidragande..av.1
  bidragande_1_N = mkN "bidragande" ; -- bidragande..nn.1
  bidragsberoende_1_N = mkN "bidragsberoende" ; -- bidragsberoende..nn.1
  bidragsdel_1_N = mkN "bidragsdel" "bidragsdelen" "bidragsdelar" "bidragsdelarna" ; -- bidragsdel..nn.1
  bidragsfusk_1_N = mkN "bidragsfusk" neutrum  ; -- bidragsfusk..nn.1
  bidragsfuskare_1_N = mkN "bidragsfuskare" utrum  ; -- bidragsfuskare..nn.1
  bidragsförskott_1_N = mkN "bidragsförskott" neutrum  ; -- bidragsförskott..nn.1
  bidragsgivare_1_N = mkN "bidragsgivare" utrum  ; -- bidragsgivare..nn.1
  bidragsgrundande_1_A = mkA "bidragsgrundande" ; -- bidragsgrundande..av.1
  bidragsmiljon_1_N = mkN "bidragsmiljon" "bidragsmiljoner" ; -- bidragsmiljon..nn.1
  bidragsskyldighet_1_N = mkN "bidragsskyldighet" "bidragsskyldigheter" ; -- bidragsskyldighet..nn.1
  bidrottning_1_N = mkN "bidrottning" ; -- bidrottning..nn.1
  bidé_1_N = mkN "bidé" "bidéer" ; -- bidé..nn.1
  biedermeierstil_1_N = mkN "biedermeierstil" ; -- biedermeierstil..nn.1
  bieffekt_1_N = mkN "bieffekt" "bieffekter" ; -- bieffekt..nn.1
  bienn_1_A = mkA "bienn" "bient" ; -- bienn..av.1
  biennal_1_N = mkN "biennal" "biennaler" ; -- biennal..nn.1
  bifall_1_N = mkN "bifall" neutrum  ; -- bifall..nn.1
  bifalla_1_V = mkV "bifalla" "biföll" "bifallit" ; -- bifalla..vb.1
  bifallande_1_N = mkN "bifallande" ; -- bifallande..nn.1
  bifallsnick_1_N = mkN "bifallsnick" ; -- bifallsnick..nn.1
  bifallsrop_1_N = mkN "bifallsrop" neutrum  ; -- bifallsrop..nn.1
  bifallsstorm_1_N = mkN "bifallsstorm" ; -- bifallsstorm..nn.1
  bifallsyttring_1_N = mkN "bifallsyttring" ; -- bifallsyttring..nn.1
  bifenyl_1_N = mkN "bifenyl" "bifenyler" ; -- bifenyl..nn.1
  biff_1_A = mkA "biff" ; -- biff..av.1
  biff_1_N = mkN "biff" ; -- biff..nn.1
  biffdjur_1_N = mkN "biffdjur" neutrum  ; -- biffdjur..nn.1
  biffig_1_A = mkA "biffig" ; -- biffig..av.1
  biffighet_1_N = mkN "biffighet" ; -- biffighet..nn.1
  biffko_1_N = mkN "biffko" "biffkor" ; -- biffko..nn.1
  biffrad_1_N = mkN "biffrad" "biffrader" ; -- biffrad..nn.1
  biffstek_1_N = mkN "biffstek" ; -- biffstek..nn.1
  biffyxa_1_N = mkN "biffyxa" ; -- biffyxa..nn.1
  bifigur_1_N = mkN "bifigur" "bifigurer" ; -- bifigur..nn.1
  bifilar_1_A = mkA "bifilar" ; -- bifilar..av.1
  bifilär_1_A = mkA "bifilär" ; -- bifilär..av.1
  biflod_1_N = mkN "biflod" "bifloder" ; -- biflod..nn.1
  biflöde_1_N = mkN "biflöde" ; -- biflöde..nn.1
  bifoga_1_V = mkV "bifogar" ; -- bifoga..vb.1
  bifogande_1_N = mkN "bifogande" ; -- bifogande..nn.1
  bifokalglas_1_N = mkN "bifokalglas" neutrum  ; -- bifokalglas..nn.1
  biform_1_N = mkN "biform" "biformer" ; -- biform..nn.1
  bifurkation_1_N = mkN "bifurkation" ; -- bifurkation..nn.1
  biförtjänst_1_N = mkN "biförtjänst" "biförtjänster" ; -- biförtjänst..nn.1
  bigami_1_N = mkN "bigami" ; -- bigami..nn.1
  bigamist_1_N = mkN "bigamist" "bigamister" ; -- bigamist..nn.1
  bigarrå_1_N = mkN "bigarrå" "bigarråer" ; -- bigarrå..nn.1
  bigata_1_N = mkN "bigata" ; -- bigata..nn.1
  bigift_1_N = mkN "bigift" "bigiftet" "bigifter" "bigifterna" ; -- bigift..nn.1
  bigott_1_A = mkA "bigott" ; -- bigott..av.1
  bigotteri_1_N = mkN "bigotteri" "bigotteriet" "bigotterier" "bigotterierna" ; -- bigotteri..nn.1
  bigram_1_N = mkN "bigram" "bigrammet" "bigram" "bigrammen" ; -- bigram..nn.1
  bigård_1_N = mkN "bigård" ; -- bigård..nn.1
  bihandling_1_N = mkN "bihandling" ; -- bihandling..nn.1
  bihang_1_N = mkN "bihang" neutrum  ; -- bihang..nn.1
  bihav_1_N = mkN "bihav" neutrum  ; -- bihav..nn.1
  bihus_1_N = mkN "bihus" neutrum  ; -- bihus..nn.1
  bihustru_1_N = mkN "bihustru" "bihustrun" "bihustrur" "bihustrurna" ; -- bihustru..nn.1
  bihuva_1_N = mkN "bihuva" ; -- bihuva..nn.1
  bihåla_1_N = mkN "bihåla" ; -- bihåla..nn.1
  bihåleinflammation_1_N = mkN "bihåleinflammation" ; -- bihåleinflammation..nn.1
  biinkomst_1_N = mkN "biinkomst" "biinkomster" ; -- biinkomst..nn.1
  bikarbonat_1_N = mkN "bikarbonat" ; -- bikarbonat..nn.1
  bikini_1_N = mkN "bikini" "bikinin" "bikinis" "bikinisen" ; -- bikini..nn.1
  bikiniprydd_1_A = mkA "bikiniprydd" ; -- bikiniprydd..av.1
  biklöv_1_N = mkN "biklöv" ; -- biklöv..nn.1
  bikonkav_1_A = mkA "bikonkav" ; -- bikonkav..av.1
  bikonvex_1_A = mkA "bikonvex" ; -- bikonvex..av.1
  bikrona_1_N = mkN "bikrona" ; -- bikrona..nn.1
  bikt_1_N = mkN "bikt" "bikter" ; -- bikt..nn.1
  bikta_1_V = mkV "biktar" ; -- bikta..vb.1
  biktande_1_N = mkN "biktande" ; -- biktande..nn.1
  biktbarn_1_N = mkN "biktbarn" neutrum  ; -- biktbarn..nn.1
  biktfar_1_N = mkN "biktfader" "biktfadern" "biktfäder" "biktfäderna" ; -- biktfar..nn.1
  biktstol_1_N = mkN "biktstol" ; -- biktstol..nn.1
  bikupa_1_N = mkN "bikupa" ; -- bikupa..nn.1
  bikvadrat_1_N = mkN "bikvadrat" "bikvadrater" ; -- bikvadrat..nn.1
  bikvadratisk_1_A = mkA "bikvadratisk" ; -- bikvadratisk..av.1
  bil_1_N = mkN "bil" ; -- bil..nn.1
  bila_1_N = mkN "bila" ; -- bila..nn.1
  bila_1_V = mkV "bilar" ; -- bila..vb.1
  bila_2_V = mkV "bilar" ; -- bila..vb.2
  bilabial_1_A = mkA "bilabial" ; -- bilabial..av.1
  bilaccis_1_N = mkN "bilaccis" "bilacciser" ; -- bilaccis..nn.1
  bilaffär_1_N = mkN "bilaffär" "bilaffärer" ; -- bilaffär..nn.1
  bilaga_1_N = mkN "bilaga" ; -- bilaga..nn.1
  biland_1_N = mkN "biland" "bilandet" "biländer" "biländerna" ; -- biland..nn.1
  bilande_1_N = mkN "bilande" ; -- bilande..nn.1
  bilantenn_1_N = mkN "bilantenn" "bilantenner" ; -- bilantenn..nn.1
  bilateral_1_A = mkA "bilateral" ; -- bilateral..av.1
  bilbana_1_N = mkN "bilbana" ; -- bilbana..nn.1
  bilbatteri_1_N = mkN "bilbatteri" "bilbatteriet" "bilbatterier" "bilbatterierna" ; -- bilbatteri..nn.1
  bilbesiktning_1_N = mkN "bilbesiktning" ; -- bilbesiktning..nn.1
  bilbingo_1_N = mkN "bilbingo" ; -- bilbingo..nn.1
  bilboké_1_N = mkN "bilboké" "bilbokéer" ; -- bilboké..nn.1
  bilbrand_1_N = mkN "bilbrand" "bilbränder" ; -- bilbrand..nn.1
  bilbransch_1_N = mkN "bilbransch" ; -- bilbransch..nn.1
  bilbroms_1_N = mkN "bilbroms" ; -- bilbroms..nn.1
  bilburen_1_A = mkA "bilburen" ; -- bilburen..av.1
  bilbyggeri_1_N = mkN "bilbyggeri" "bilbyggeriet" "bilbyggerier" "bilbyggerierna" ; -- bilbyggeri..nn.1
  bilbälte_1_N = mkN "bilbälte" ; -- bilbälte..nn.1
  bild_1_N = mkN "bild" "bilder" ; -- bild..nn.1
  bilda_1_V = mkV "bildar" ; -- bilda..vb.1
  bildad_1_A = mkA "bildad" ; -- bildad..av.1
  bildammsugare_1_N = mkN "bildammsugare" utrum  ; -- bildammsugare..nn.1
  bildande_1_A = mkA "bildande" ; -- bildande..av.1
  bildande_1_N = mkN "bildande" ; -- bildande..nn.1
  bildband_1_N = mkN "bildband" neutrum  ; -- bildband..nn.1
  bildbar_1_A = mkA "bildbar" ; -- bildbar..av.1
  bildbarhet_1_N = mkN "bildbarhet" ; -- bildbarhet..nn.1
  bildberättelse_1_N = mkN "bildberättelse" "bildberättelser" ; -- bildberättelse..nn.1
  bildbevis_1_N = mkN "bildbevis" neutrum  ; -- bildbevis..nn.1
  bilderbok_1_N = mkN "bilderbok" "bilderböcker" ; -- bilderbok..nn.1
  bildflöde_1_N = mkN "bildflöde" ; -- bildflöde..nn.1
  bildgalleri_1_N = mkN "bildgalleri" "bildgalleriet" "bildgallerier" "bildgallerierna" ; -- bildgalleri..nn.1
  bildgåta_1_N = mkN "bildgåta" ; -- bildgåta..nn.1
  bildhuggare_1_N = mkN "bildhuggare" utrum  ; -- bildhuggare..nn.1
  bildhuggarkonst_1_N = mkN "bildhuggarkonst" ; -- bildhuggarkonst..nn.1
  bildhuggarmejsel_1_N = mkN "bildhuggarmejsel" ; -- bildhuggarmejsel..nn.1
  bildhuggeri_1_N = mkN "bildhuggeri" "bildhuggeriet" "bildhuggerier" "bildhuggerierna" ; -- bildhuggeri..nn.1
  bildhållning_1_N = mkN "bildhållning" ; -- bildhållning..nn.1
  bildinnehav_1_N = mkN "bildinnehav" neutrum  ; -- bildinnehav..nn.1
  bildkarta_1_N = mkN "bildkarta" ; -- bildkarta..nn.1
  bildkonst_1_N = mkN "bildkonst" "bildkonster" ; -- bildkonst..nn.1
  bildkryss_1_N = mkN "bildkryss" neutrum  ; -- bildkryss..nn.1
  bildlig_1_A = mkA "bildlig" ; -- bildlig..av.1
  bildlighet_1_N = mkN "bildlighet" ; -- bildlighet..nn.1
  bildlik_1_A = mkA "bildlik" ; -- bildlik..av.1
  bildlikhet_1_N = mkN "bildlikhet" ; -- bildlikhet..nn.1
  bildmanipulation_1_N = mkN "bildmanipulation" ; -- bildmanipulation..nn.1
  bildmaterial_1_N = mkN "bildmaterial" neutrum  ; -- bildmaterial..nn.1
  bildminne_1_N = mkN "bildminne" ; -- bildminne..nn.1
  bildmonitor_1_N = mkN "bildmonitor" "bildmonitorer" ; -- bildmonitor..nn.1
  bildmässig_1_A = mkA "bildmässig" ; -- bildmässig..av.1
  bildmässighet_1_N = mkN "bildmässighet" ; -- bildmässighet..nn.1
  bildning_1_N = mkN "bildning" ; -- bildning..nn.1
  bildningsanstalt_1_N = mkN "bildningsanstalt" "bildningsanstalter" ; -- bildningsanstalt..nn.1
  bildningsaristokrat_1_N = mkN "bildningsaristokrat" "bildningsaristokrater" ; -- bildningsaristokrat..nn.1
  bildningsfel_1_N = mkN "bildningsfel" "bildningsfelet" "bildningsfel" "bildningsfelen" ; -- bildningsfel..nn.1
  bildningsföraktare_1_N = mkN "bildningsföraktare" utrum  ; -- bildningsföraktare..nn.1
  bildningsförbund_1_N = mkN "bildningsförbund" neutrum  ; -- bildningsförbund..nn.1
  bildningsgrad_1_N = mkN "bildningsgrad" "bildningsgrader" ; -- bildningsgrad..nn.1
  bildningsgång_1_N = mkN "bildningsgång" ; -- bildningsgång..nn.1
  bildningshögfärd_1_N = mkN "bildningshögfärd" ; -- bildningshögfärd..nn.1
  bildningsmässig_1_A = mkA "bildningsmässig" ; -- bildningsmässig..av.1
  bildningsnivå_1_N = mkN "bildningsnivå" "bildningsnivåer" ; -- bildningsnivå..nn.1
  bildningsorganisation_1_N = mkN "bildningsorganisation" ; -- bildningsorganisation..nn.1
  bildningsroman_1_N = mkN "bildningsroman" "bildningsromaner" ; -- bildningsroman..nn.1
  bildningstörst_1_N = mkN "bildningstörst" ; -- bildningstörst..nn.1
  bildningsverksamhet_1_N = mkN "bildningsverksamhet" "bildningsverksamheter" ; -- bildningsverksamhet..nn.1
  bildningsvärme_1_N = mkN "bildningsvärme" ; -- bildningsvärme..nn.1
  bildprakt_1_N = mkN "bildprakt" ; -- bildprakt..nn.1
  bildradio_1_N = mkN "bildradio" ; -- bildradio..nn.1
  bildredaktör_1_N = mkN "bildredaktör" "bildredaktörer" ; -- bildredaktör..nn.1
  bildreportage_1_N = mkN "bildreportage" "bildreportaget" "bildreportage" "bildreportagen" ; -- bildreportage..nn.1
  bildrik_1_A = mkA "bildrik" ; -- bildrik..av.1
  bildrikedom_1_N = mkN "bildrikedom" ; -- bildrikedom..nn.1
  bildrulle_1_N = mkN "bildrulle" utrum  ; -- bildrulle..nn.1
  bildrulle_2_1_N = mkN "bildrulle" utrum  ; -- bildrulle_2..nn.1
  bildruta_1_N = mkN "bildruta" ; -- bildruta..nn.1
  bildrör_1_N = mkN "bildrör" neutrum  ; -- bildrör..nn.1
  bildsida_1_N = mkN "bildsida" ; -- bildsida..nn.1
  bildsignal_1_N = mkN "bildsignal" "bildsignaler" ; -- bildsignal..nn.1
  bildskrift_1_N = mkN "bildskrift" "bildskrifter" ; -- bildskrift..nn.1
  bildskärm_1_N = mkN "bildskärm" ; -- bildskärm..nn.1
  bildskärpa_1_N = mkN "bildskärpa" ; -- bildskärpa..nn.1
  bildskön_1_A = mkA "bildskön" ; -- bildskön..av.1
  bildskönhet_1_N = mkN "bildskönhet" ; -- bildskönhet..nn.1
  bildsnidare_1_N = mkN "bildsnidare" utrum  ; -- bildsnidare..nn.1
  bildsnideri_1_N = mkN "bildsnideri" "bildsnideriet" "bildsniderier" "bildsniderierna" ; -- bildsnideri..nn.1
  bildspel_1_N = mkN "bildspel" "bildspelet" "bildspel" "bildspelen" ; -- bildspel..nn.1
  bildspråk_1_N = mkN "bildspråk" neutrum  ; -- bildspråk..nn.1
  bildsten_1_N = mkN "bildsten" "bildstenen" "bildstenar" "bildstenarna" ; -- bildsten..nn.1
  bildstod_1_N = mkN "bildstod" "bildstoder" ; -- bildstod..nn.1
  bildstormare_1_N = mkN "bildstormare" utrum  ; -- bildstormare..nn.1
  bildstrid_1_N = mkN "bildstrid" "bildstrider" ; -- bildstrid..nn.1
  bildsvit_1_N = mkN "bildsvit" "bildsviter" ; -- bildsvit..nn.1
  bildtelefon_1_N = mkN "bildtelefon" "bildtelefoner" ; -- bildtelefon..nn.1
  bildtelegrafi_1_N = mkN "bildtelegrafi" ; -- bildtelegrafi..nn.1
  bildtext_1_N = mkN "bildtext" "bildtexter" ; -- bildtext..nn.1
  bildtolkning_1_N = mkN "bildtolkning" ; -- bildtolkning..nn.1
  bildverk_1_N = mkN "bildverk" neutrum  ; -- bildverk..nn.1
  bildvävnad_1_N = mkN "bildvävnad" "bildvävnader" ; -- bildvävnad..nn.1
  bildäck_1_N = mkN "bildäck" neutrum  ; -- bildäck..nn.1
  bildöverföring_1_N = mkN "bildöverföring" ; -- bildöverföring..nn.1
  bilfabrik_1_N = mkN "bilfabrik" "bilfabriker" ; -- bilfabrik..nn.1
  bilfabrikör_1_N = mkN "bilfabrikör" "bilfabrikörer" ; -- bilfabrikör..nn.1
  bilfri_1_A = mkA "bilfri" "bilfritt" ; -- bilfri..av.1
  bilfärd_1_N = mkN "bilfärd" "bilfärder" ; -- bilfärd..nn.1
  bilfärja_1_N = mkN "bilfärja" ; -- bilfärja..nn.1
  bilfönster_1_N = mkN "bilfönster" neutrum  ; -- bilfönster..nn.1
  bilförare_1_N = mkN "bilförare" utrum  ; -- bilförare..nn.1
  bilförsäkring_1_N = mkN "bilförsäkring" ; -- bilförsäkring..nn.1
  bilförsäljare_1_N = mkN "bilförsäljare" utrum  ; -- bilförsäljare..nn.1
  bilgolv_1_N = mkN "bilgolv" neutrum  ; -- bilgolv..nn.1
  bilhammare_1_N = mkN "bilhammare" "bilhammaren" "bilhammare" "bilhamrarna" ; -- bilhammare..nn.1
  bilhjul_1_N = mkN "bilhjul" neutrum  ; -- bilhjul..nn.1
  bilhögtalare_1_N = mkN "bilhögtalare" utrum  ; -- bilhögtalare..nn.1
  bilindustri_1_N = mkN "bilindustri" "bilindustrier" ; -- bilindustri..nn.1
  bilingual_1_A = mkA "bilingual" ; -- bilingual..av.1
  bilingualism_1_N = mkN "bilingualism" "bilingualismer" ; -- bilingualism..nn.1
  bilism_1_N = mkN "bilism" "bilismer" ; -- bilism..nn.1
  bilist_1_N = mkN "bilist" "bilister" ; -- bilist..nn.1
  bilistisk_1_A = mkA "bilistisk" ; -- bilistisk..av.1
  biljard_1_N = mkN "biljard" "biljarder" ; -- biljard..nn.1
  biljardboll_1_N = mkN "biljardboll" ; -- biljardboll..nn.1
  biljardbollsuniversum_1_N = mkN "biljardbollsuniversum" neutrum  ; -- biljardbollsuniversum..nn.1
  biljardbord_1_N = mkN "biljardbord" neutrum  ; -- biljardbord..nn.1
  biljardkäpp_1_N = mkN "biljardkäpp" ; -- biljardkäpp..nn.1
  biljardkö_1_N = mkN "biljardkö" "biljardkön" "biljardköer" "biljardköerna" ; -- biljardkö..nn.1
  biljardsalong_1_N = mkN "biljardsalong" "biljardsalonger" ; -- biljardsalong..nn.1
  biljardspel_1_N = mkN "biljardspel" "biljardspelet" "biljardspel" "biljardspelen" ; -- biljardspel..nn.1
  biljett_1_N = mkN "biljett" "biljetter" ; -- biljett..nn.1
  biljettautomat_1_N = mkN "biljettautomat" "biljettautomater" ; -- biljettautomat..nn.1
  biljettbok_1_N = mkN "biljettbok" "biljettböcker" ; -- biljettbok..nn.1
  biljettbokning_1_N = mkN "biljettbokning" ; -- biljettbokning..nn.1
  biljettbråk_1_N = mkN "biljettbråk" neutrum  ; -- biljettbråk..nn.1
  biljettexpedition_1_N = mkN "biljettexpedition" ; -- biljettexpedition..nn.1
  biljettficka_1_N = mkN "biljettficka" ; -- biljettficka..nn.1
  biljettförsäljare_1_N = mkN "biljettförsäljare" utrum  ; -- biljettförsäljare..nn.1
  biljettförsäljning_1_N = mkN "biljettförsäljning" ; -- biljettförsäljning..nn.1
  biljetthäfte_1_N = mkN "biljetthäfte" ; -- biljetthäfte..nn.1
  biljetthärva_1_N = mkN "biljetthärva" ; -- biljetthärva..nn.1
  biljettinkomst_1_N = mkN "biljettinkomst" "biljettinkomster" ; -- biljettinkomst..nn.1
  biljettkontor_1_N = mkN "biljettkontor" neutrum  ; -- biljettkontor..nn.1
  biljettkontroll_1_N = mkN "biljettkontroll" "biljettkontroller" ; -- biljettkontroll..nn.1
  biljettköp_1_N = mkN "biljettköp" neutrum  ; -- biljettköp..nn.1
  biljettlucka_1_N = mkN "biljettlucka" ; -- biljettlucka..nn.1
  biljettlös_1_A = mkA "biljettlös" ; -- biljettlös..av.1
  biljettmaskin_1_N = mkN "biljettmaskin" "biljettmaskiner" ; -- biljettmaskin..nn.1
  biljettpris_1_N = mkN "biljettpris" neutrum  ; -- biljettpris..nn.1
  biljettsläpp_1_N = mkN "biljettsläpp" neutrum  ; -- biljettsläpp..nn.1
  biljettvisering_1_N = mkN "biljettvisering" ; -- biljettvisering..nn.1
  biljettång_1_N = mkN "biljettång" "biljettänger" ; -- biljettång..nn.1
  biljon_1_N = mkN "biljon" "biljoner" ; -- biljon..nn.1
  biljonte_1_A = mkA "biljonte" ; -- biljonte..av.1
  biljud_1_N = mkN "biljud" neutrum  ; -- biljud..nn.1
  bilkaross_1_N = mkN "bilkaross" "bilkarosser" ; -- bilkaross..nn.1
  bilkarta_1_N = mkN "bilkarta" ; -- bilkarta..nn.1
  bilklädsel_1_N = mkN "bilklädsel" ; -- bilklädsel..nn.1
  bilkonstruktör_1_N = mkN "bilkonstruktör" "bilkonstruktörer" ; -- bilkonstruktör..nn.1
  bilkrasch_1_N = mkN "bilkrasch" "bilkrascher" ; -- bilkrasch..nn.1
  bilkrock_1_N = mkN "bilkrock" ; -- bilkrock..nn.1
  bilkupé_1_N = mkN "bilkupé" "bilkupéer" ; -- bilkupé..nn.1
  bilkyrkogård_1_N = mkN "bilkyrkogård" ; -- bilkyrkogård..nn.1
  bilkår_1_N = mkN "bilkår" "bilkårer" ; -- bilkår..nn.1
  bilkårist_1_N = mkN "bilkårist" "bilkårister" ; -- bilkårist..nn.1
  bilkö_1_N = mkN "bilkö" "bilkön" "bilköer" "bilköerna" ; -- bilkö..nn.1
  bilköp_1_N = mkN "bilköp" neutrum  ; -- bilköp..nn.1
  bilkörning_1_N = mkN "bilkörning" ; -- bilkörning..nn.1
  bill_1_N = mkN "bill" ; -- bill..nn.1
  bill_2_N = mkN "bill" ; -- bill..nn.2
  billa_1_N = mkN "billa" ; -- billa..nn.1
  billampa_1_N = mkN "billampa" ; -- billampa..nn.1
  billast_1_N = mkN "billast" "billaster" ; -- billast..nn.1
  billiard_1_N = mkN "billiard" "billiarder" ; -- billiard..nn.1
  billig_1_A = mkA "billig" ; -- billig..av.1
  billighet_1_N = mkN "billighet" "billigheter" ; -- billighet..nn.1
  billighet_2_N = mkN "billighet" ; -- billighet..nn.2
  billighetsupplaga_1_N = mkN "billighetsupplaga" ; -- billighetsupplaga..nn.1
  billion_1_N = mkN "billion" ; -- billion..nn.1
  billionte_1_A = mkA "billionte" ; -- billionte..av.1
  billjus_1_N = mkN "billjus" neutrum  ; -- billjus..nn.1
  billots_1_N = mkN "billots" ; -- billots..nn.1
  billykta_1_N = mkN "billykta" ; -- billykta..nn.1
  billån_1_N = mkN "billån" neutrum  ; -- billån..nn.1
  billås_1_N = mkN "billås" neutrum  ; -- billås..nn.1
  bilmaskin_1_N = mkN "bilmaskin" "bilmaskiner" ; -- bilmaskin..nn.1
  bilmekaniker_1_N = mkN "bilmekaniker" "bilmekanikern" "bilmekaniker" "bilmekanikerna" ; -- bilmekaniker..nn.1
  bilmotor_1_N = mkN "bilmotor" "bilmotorer" ; -- bilmotor..nn.1
  bilmärke_1_N = mkN "bilmärke" ; -- bilmärke..nn.1
  bilmålvakt_1_N = mkN "bilmålvakt" "bilmålvakter" ; -- bilmålvakt..nn.1
  bilnavigator_1_N = mkN "bilnavigator" "bilnavigatorer" ; -- bilnavigator..nn.1
  bilning_1_N = mkN "bilning" ; -- bilning..nn.1
  bilnummer_1_N = mkN "bilnummer" neutrum  ; -- bilnummer..nn.1
  bilnyckel_1_N = mkN "bilnyckel" ; -- bilnyckel..nn.1
  bilolycka_1_N = mkN "bilolycka" ; -- bilolycka..nn.1
  bilpark_1_N = mkN "bilpark" "bilparker" ; -- bilpark..nn.1
  bilparkering_1_N = mkN "bilparkering" ; -- bilparkering..nn.1
  bilplåt_1_N = mkN "bilplåt" ; -- bilplåt..nn.1
  bilpool_1_N = mkN "bilpool" "bilpooler" ; -- bilpool..nn.1
  bilprovning_1_N = mkN "bilprovning" ; -- bilprovning..nn.1
  bilradio_1_N = mkN "bilradio" "bilradior" ; -- bilradio..nn.1
  bilradioapparat_1_N = mkN "bilradioapparat" "bilradioapparater" ; -- bilradioapparat..nn.1
  bilrally_1_N = mkN "bilrally" "bilrallyt" "bilrallyn" "bilrallyna" ; -- bilrally..nn.1
  bilratt_1_N = mkN "bilratt" ; -- bilratt..nn.1
  bilregister_1_N = mkN "bilregister" neutrum  ; -- bilregister..nn.1
  bilrengöring_1_N = mkN "bilrengöring" ; -- bilrengöring..nn.1
  bilresa_1_N = mkN "bilresa" ; -- bilresa..nn.1
  bilring_1_N = mkN "bilring" ; -- bilring..nn.1
  bilrock_1_N = mkN "bilrock" ; -- bilrock..nn.1
  bilruta_1_N = mkN "bilruta" ; -- bilruta..nn.1
  bilschampo_1_N = mkN "bilschampo" "bilschampot" "bilschampon" "bilschampona" ; -- bilschampo..nn.1
  bilschamposvamp_1_N = mkN "bilschamposvamp" ; -- bilschamposvamp..nn.1
  bilsjuk_1_A = mkA "bilsjuk" ; -- bilsjuk..av.1
  bilsjuka_1_N = mkN "bilsjuka" ; -- bilsjuka..nn.1
  bilsjukhet_1_N = mkN "bilsjukhet" ; -- bilsjukhet..nn.1
  bilskatt_1_N = mkN "bilskatt" "bilskatter" ; -- bilskatt..nn.1
  bilskojare_1_N = mkN "bilskojare" utrum  ; -- bilskojare..nn.1
  bilskola_1_N = mkN "bilskola" ; -- bilskola..nn.1
  bilskrot_1_N = mkN "bilskrot" ; -- bilskrot..nn.1
  bilskrotning_1_N = mkN "bilskrotning" ; -- bilskrotning..nn.1
  bilskrotningspremie_1_N = mkN "bilskrotningspremie" "bilskrotningspremier" ; -- bilskrotningspremie..nn.1
  bilsläpkärra_1_N = mkN "bilsläpkärra" ; -- bilsläpkärra..nn.1
  bilspackel_1_N = mkN "bilspackel" neutrum  ; -- bilspackel..nn.1
  bilstol_1_N = mkN "bilstol" ; -- bilstol..nn.1
  bilstöld_1_N = mkN "bilstöld" "bilstölder" ; -- bilstöld..nn.1
  bilsäte_1_N = mkN "bilsäte" ; -- bilsäte..nn.1
  biltak_1_N = mkN "biltak" neutrum  ; -- biltak..nn.1
  biltelefon_1_N = mkN "biltelefon" "biltelefoner" ; -- biltelefon..nn.1
  biltillverkare_1_N = mkN "biltillverkare" utrum  ; -- biltillverkare..nn.1
  biltillverkning_1_N = mkN "biltillverkning" ; -- biltillverkning..nn.1
  biltjuv_1_N = mkN "biltjuv" ; -- biltjuv..nn.1
  biltog_1_A = mkA "biltog" ; -- biltog..av.1
  biltoghet_1_N = mkN "biltoghet" ; -- biltoghet..nn.1
  biltrafik_1_N = mkN "biltrafik" ; -- biltrafik..nn.1
  biltull_1_N = mkN "biltull" ; -- biltull..nn.1
  biltunnel_1_N = mkN "biltunnel" ; -- biltunnel..nn.1
  biltur_1_N = mkN "biltur" "bilturer" ; -- biltur..nn.1
  biltvätt_1_N = mkN "biltvätt" ; -- biltvätt..nn.1
  biltvättborste_1_N = mkN "biltvättborste" utrum  ; -- biltvättborste..nn.1
  biltävling_1_N = mkN "biltävling" ; -- biltävling..nn.1
  bilvax_1_N = mkN "bilvax" "bilvaxet" "bilvaxer" "bilvaxerna" ; -- bilvax..nn.1
  bilverkstad_1_N = mkN "bilverkstad" "bilverkstäder" ; -- bilverkstad..nn.1
  bilvrak_1_N = mkN "bilvrak" neutrum  ; -- bilvrak..nn.1
  bilväg_1_N = mkN "bilväg" ; -- bilväg..nn.1
  bilyxa_1_N = mkN "bilyxa" ; -- bilyxa..nn.1
  bilägare_1_N = mkN "bilägare" utrum  ; -- bilägare..nn.1
  biläger_1_N = mkN "biläger" neutrum  ; -- biläger..nn.1
  bilägga_1_V = mkV "bilägga" "bila" "bilagt" ; -- bilägga..vb.1
  biläggande_1_N = mkN "biläggande" ; -- biläggande..nn.1
  biläggning_1_N = mkN "biläggning" ; -- biläggning..nn.1
  bilåkning_1_N = mkN "bilåkning" ; -- bilåkning..nn.1
  bimbo_1_N = mkN "bimbo" "bimbot" "bimbo" "bimbon" ; -- bimbo..nn.1
  bimbofilm_1_N = mkN "bimbofilm" "bimbofilmer" ; -- bimbofilm..nn.1
  bimetall_1_N = mkN "bimetall" "bimetaller" ; -- bimetall..nn.1
  bimetallism_1_N = mkN "bimetallism" "bimetallismer" ; -- bimetallism..nn.1
  bimåne_1_N = mkN "bimåne" utrum  ; -- bimåne..nn.1
  binamn_1_N = mkN "binamn" neutrum  ; -- binamn..nn.1
  bind_1_N = mkN "bind" neutrum  ; -- bind..nn.1
  binda_1_N = mkN "binda" ; -- binda..nn.1
  binda_1_V = mkV "binda" "band" "bundit" ; -- binda..vb.1
  bindande_1_A = mkA "bindande" ; -- bindande..av.1
  bindande_1_N = mkN "bindande" ; -- bindande..nn.1
  bindare_1_N = mkN "bindare" utrum  ; -- bindare..nn.1
  bindbjälke_1_N = mkN "bindbjälke" utrum  ; -- bindbjälke..nn.1
  bindehinna_1_N = mkN "bindehinna" ; -- bindehinna..nn.1
  bindehinneinflammation_1_N = mkN "bindehinneinflammation" ; -- bindehinneinflammation..nn.1
  bindel_1_N = mkN "bindel" ; -- bindel..nn.1
  bindemedel_1_N = mkN "bindemedel" neutrum  ; -- bindemedel..nn.1
  bindenyckel_1_N = mkN "bindenyckel" ; -- bindenyckel..nn.1
  bindeord_1_N = mkN "bindeord" neutrum  ; -- bindeord..nn.1
  binderi_1_N = mkN "binderi" "binderiet" "binderier" "binderierna" ; -- binderi..nn.1
  bindestreck_1_N = mkN "bindestreck" neutrum  ; -- bindestreck..nn.1
  bindesubstans_1_N = mkN "bindesubstans" "bindesubstanser" ; -- bindesubstans..nn.1
  bindesäck_1_N = mkN "bindesäck" ; -- bindesäck..nn.1
  bindevokal_1_N = mkN "bindevokal" "bindevokaler" ; -- bindevokal..nn.1
  bindgalen_1_A = mkA "bindgalen" ; -- bindgalen..av.1
  bindgalenhet_1_N = mkN "bindgalenhet" ; -- bindgalenhet..nn.1
  bindgarn_1_N = mkN "bindgarn" neutrum  ; -- bindgarn..nn.1
  bindning_1_N = mkN "bindning" ; -- bindning..nn.1
  bindningstid_1_N = mkN "bindningstid" "bindningstider" ; -- bindningstid..nn.1
  bindnål_1_N = mkN "bindnål" ; -- bindnål..nn.1
  bindsel_1_N = mkN "bindsel" neutrum  ; -- bindsel..nn.1
  bindsle_1_N = mkN "bindsle" ; -- bindsle..nn.1
  bindsten_1_N = mkN "bindsten" "bindstenen" "bindstenar" "bindstenarna" ; -- bindsten..nn.1
  bindsula_1_N = mkN "bindsula" ; -- bindsula..nn.1
  bindtråd_1_N = mkN "bindtråd" ; -- bindtråd..nn.1
  bindväv_1_N = mkN "bindväv" ; -- bindväv..nn.1
  bindvävsfiber_1_N = mkN "bindvävsfiber" "bindvävsfibern" "bindvävsfibrer" "bindvävsfibrerna" ; -- bindvävsfiber..nn.1
  bindvävshinna_1_N = mkN "bindvävshinna" ; -- bindvävshinna..nn.1
  bindvävskapsel_1_N = mkN "bindvävskapsel" ; -- bindvävskapsel..nn.1
  bindvävssjukdom_1_N = mkN "bindvävssjukdom" ; -- bindvävssjukdom..nn.1
  bindvävssäck_1_N = mkN "bindvävssäck" ; -- bindvävssäck..nn.1
  bindvävstråd_1_N = mkN "bindvävstråd" ; -- bindvävstråd..nn.1
  bindämne_1_N = mkN "bindämne" ; -- bindämne..nn.1
  binga_1_N = mkN "binga" ; -- binga..nn.1
  binge_1_N = mkN "binge" utrum  ; -- binge..nn.1
  bingel_1_N = mkN "bingel" ; -- bingel..nn.1
  bingo_1_N = mkN "bingo" ; -- bingo..nn.1
  bingobricka_1_N = mkN "bingobricka" ; -- bingobricka..nn.1
  bingosugen_1_A = mkA "bingosugen" ; -- bingosugen..av.1
  bingosugenhet_1_N = mkN "bingosugenhet" ; -- bingosugenhet..nn.1
  binjure_1_N = mkN "binjure" utrum  ; -- binjure..nn.1
  binjurebark_1_N = mkN "binjurebark" ; -- binjurebark..nn.1
  binka_1_N = mkN "binka" ; -- binka..nn.1
  binnikemask_1_N = mkN "binnikemask" ; -- binnikemask..nn.1
  binokel_1_N = mkN "binokel" ; -- binokel..nn.1
  binokulär_1_A = mkA "binokulär" ; -- binokulär..av.1
  binom_1_N = mkN "binom" neutrum  ; -- binom..nn.1
  binomial_1_A = mkA "binomial" ; -- binomial..av.1
  binär_1_A = mkA "binär" ; -- binär..av.1
  binäring_1_N = mkN "binäring" ; -- binäring..nn.1
  bio_1_N = mkN "bio" ; -- bio..nn.1
  bioaktuell_1_A = mkA "bioaktuell" ; -- bioaktuell..av.1
  biobank_1_N = mkN "biobank" "biobanker" ; -- biobank..nn.1
  biobankning_1_N = mkN "biobankning" ; -- biobankning..nn.1
  biobesök_1_N = mkN "biobesök" neutrum  ; -- biobesök..nn.1
  biobiljett_1_N = mkN "biobiljett" "biobiljetter" ; -- biobiljett..nn.1
  biobränsle_1_N = mkN "biobränsle" ; -- biobränsle..nn.1
  biocid_1_N = mkN "biocid" "biocider" ; -- biocid..nn.1
  biodlare_1_N = mkN "biodlare" utrum  ; -- biodlare..nn.1
  biodling_1_N = mkN "biodling" ; -- biodling..nn.1
  biodrivmedel_1_N = mkN "biodrivmedel" neutrum  ; -- biodrivmedel..nn.1
  bioduk_1_N = mkN "bioduk" ; -- bioduk..nn.1
  biodynamik_1_N = mkN "biodynamik" ; -- biodynamik..nn.1
  biodynamisk_1_A = mkA "biodynamisk" ; -- biodynamisk..av.1
  biofilm_1_N = mkN "biofilm" "biofilmer" ; -- biofilm..nn.1
  biofysik_1_N = mkN "biofysik" ; -- biofysik..nn.1
  biofysisk_1_A = mkA "biofysisk" ; -- biofysisk..av.1
  bioföreställning_1_N = mkN "bioföreställning" ; -- bioföreställning..nn.1
  biogas_1_N = mkN "biogas" "biogaser" ; -- biogas..nn.1
  biogasanläggning_1_N = mkN "biogasanläggning" ; -- biogasanläggning..nn.1
  biogasdriven_1_A = mkA "biogasdriven" ; -- biogasdriven..av.1
  biogasproduktion_1_N = mkN "biogasproduktion" ; -- biogasproduktion..nn.1
  biogasrening_1_N = mkN "biogasrening" ; -- biogasrening..nn.1
  biogen_1_A = mkA "biogen" "biogent" ; -- biogen..av.1
  biogenes_1_N = mkN "biogenes" ; -- biogenes..nn.1
  biogenetisk_1_A = mkA "biogenetisk" ; -- biogenetisk..av.1
  biogeografi_1_N = mkN "biogeografi" ; -- biogeografi..nn.1
  biograf_1_N = mkN "biograf" "biografer" ; -- biograf..nn.1
  biografbyrå_1_N = mkN "biografbyrå" "biografbyråer" ; -- biografbyrå..nn.1
  biografera_1_V = mkV "biograferar" ; -- biografera..vb.1
  biograferande_1_N = mkN "biograferande" ; -- biograferande..nn.1
  biograferbar_1_A = mkA "biograferbar" ; -- biograferbar..av.1
  biograferbarhet_1_N = mkN "biograferbarhet" ; -- biograferbarhet..nn.1
  biografering_1_N = mkN "biografering" ; -- biografering..nn.1
  biografföreståndare_1_N = mkN "biografföreståndare" utrum  ; -- biografföreståndare..nn.1
  biografi_1_N = mkN "biografi" "biografier" ; -- biografi..nn.1
  biografisk_1_A = mkA "biografisk" ; -- biografisk..av.1
  biografmässig_1_A = mkA "biografmässig" ; -- biografmässig..av.1
  biograforgel_1_N = mkN "biograforgel" ; -- biograforgel..nn.1
  biografpublik_1_N = mkN "biografpublik" ; -- biografpublik..nn.1
  biografteater_1_N = mkN "biografteater" ; -- biografteater..nn.1
  biokemi_1_N = mkN "biokemi" ; -- biokemi..nn.1
  biokemisk_1_A = mkA "biokemisk" ; -- biokemisk..av.1
  biokemist_1_N = mkN "biokemist" "biokemister" ; -- biokemist..nn.1
  bioklimatologi_1_N = mkN "bioklimatologi" ; -- bioklimatologi..nn.1
  biokronologi_1_N = mkN "biokronologi" ; -- biokronologi..nn.1
  biolog_1_N = mkN "biolog" "biologer" ; -- biolog..nn.1
  biologi_1_N = mkN "biologi" ; -- biologi..nn.1
  biologibok_1_N = mkN "biologibok" "biologiböcker" ; -- biologibok..nn.1
  biologisk_1_A = mkA "biologisk" ; -- biologisk..av.1
  biomassa_1_N = mkN "biomassa" ; -- biomassa..nn.1
  biomedicin_1_N = mkN "biomedicin" ; -- biomedicin..nn.1
  biomedicinsk_1_A = mkA "biomedicinsk" ; -- biomedicinsk..av.1
  biometri_1_N = mkN "biometri" ; -- biometri..nn.1
  biometrisk_1_A = mkA "biometrisk" ; -- biometrisk..av.1
  biomständighet_1_N = mkN "biomständighet" "biomständigheter" ; -- biomständighet..nn.1
  biopremiär_1_N = mkN "biopremiär" "biopremiärer" ; -- biopremiär..nn.1
  bioreaktor_1_N = mkN "bioreaktor" "bioreaktorer" ; -- bioreaktor..nn.1
  biorytm_1_N = mkN "biorytm" ; -- biorytm..nn.1
  biosalong_1_N = mkN "biosalong" "biosalonger" ; -- biosalong..nn.1
  biosfär_1_N = mkN "biosfär" "biosfärer" ; -- biosfär..nn.1
  bioteknik_1_N = mkN "bioteknik" "biotekniker" ; -- bioteknik..nn.1
  bioteknisk_1_A = mkA "bioteknisk" ; -- bioteknisk..av.1
  bioteknologisk_1_A = mkA "bioteknologisk" ; -- bioteknologisk..av.1
  biotisk_1_A = mkA "biotisk" ; -- biotisk..av.1
  biotop_1_N = mkN "biotop" "biotoper" ; -- biotop..nn.1
  biotyp_1_N = mkN "biotyp" "biotyper" ; -- biotyp..nn.1
  biperson_1_N = mkN "biperson" "bipersoner" ; -- biperson..nn.1
  biplan_1_N = mkN "biplan" neutrum  ; -- biplan..nn.1
  biplanet_1_N = mkN "biplanet" "biplaneter" ; -- biplanet..nn.1
  bipolaritet_1_N = mkN "bipolaritet" "bipolariteter" ; -- bipolaritet..nn.1
  bipolär_1_A = mkA "bipolär" ; -- bipolär..av.1
  biprodukt_1_N = mkN "biprodukt" "biprodukter" ; -- biprodukt..nn.1
  bir_1_N = mkN "bir" neutrum  ; -- bir..nn.1
  bira_1_N = mkN "bira" ; -- bira..nn.1
  birdie_1_N = mkN "birdie" "birdien" "birdies" "birdiesarna" ; -- birdie..nn.1
  birem_1_N = mkN "birem" "biremer" ; -- birem..nn.1
  birfilare_1_N = mkN "birfilare" utrum  ; -- birfilare..nn.1
  biroll_1_N = mkN "biroll" "biroller" ; -- biroll..nn.1
  birot_1_N = mkN "birot" "birötter" ; -- birot..nn.1
  bisak_1_N = mkN "bisak" "bisaker" ; -- bisak..nn.1
  bisam_1_N = mkN "bisam" ; -- bisam..nn.1
  bisamhälle_1_N = mkN "bisamhälle" ; -- bisamhälle..nn.1
  bisamoxe_1_N = mkN "bisamoxe" utrum  ; -- bisamoxe..nn.1
  bisamråtta_1_N = mkN "bisamråtta" ; -- bisamråtta..nn.1
  bisamsvin_1_N = mkN "bisamsvin" neutrum  ; -- bisamsvin..nn.1
  bisarr_1_A = mkA "bisarr" ; -- bisarr..av.1
  bisarreri_1_N = mkN "bisarreri" "bisarreriet" "bisarrerier" "bisarrerierna" ; -- bisarreri..nn.1
  bisarrhet_1_N = mkN "bisarrhet" ; -- bisarrhet..nn.1
  bisats_1_N = mkN "bisats" "bisatser" ; -- bisats..nn.1
  bisatsordföljd_1_N = mkN "bisatsordföljd" "bisatsordföljder" ; -- bisatsordföljd..nn.1
  bischoff_1_N = mkN "bischoff" ; -- bischoff..nn.1
  bisektris_1_N = mkN "bisektris" "bisektriser" ; -- bisektris..nn.1
  bisexualitet_1_N = mkN "bisexualitet" "bisexualiteter" ; -- bisexualitet..nn.1
  bisexuell_1_A = mkA "bisexuell" ; -- bisexuell..av.1
  bisfenol_1_N = mkN "bisfenol" "bisfenoler" ; -- bisfenol..nn.1
  bisittare_1_N = mkN "bisittare" utrum  ; -- bisittare..nn.1
  biskop_1_N = mkN "biskop" ; -- biskop..nn.1
  biskoplig_1_A = mkA "biskoplig" ; -- biskoplig..av.1
  biskoplighet_1_N = mkN "biskoplighet" ; -- biskoplighet..nn.1
  biskopsdöme_1_N = mkN "biskopsdöme" ; -- biskopsdöme..nn.1
  biskopskors_1_N = mkN "biskopskors" neutrum  ; -- biskopskors..nn.1
  biskopskräckla_1_N = mkN "biskopskräckla" ; -- biskopskräckla..nn.1
  biskopskräkla_1_N = mkN "biskopskräkla" ; -- biskopskräkla..nn.1
  biskopsmössa_1_N = mkN "biskopsmössa" ; -- biskopsmössa..nn.1
  biskopsmöte_1_N = mkN "biskopsmöte" ; -- biskopsmöte..nn.1
  biskopsskrud_1_N = mkN "biskopsskrud" ; -- biskopsskrud..nn.1
  biskopsstav_1_N = mkN "biskopsstav" ; -- biskopsstav..nn.1
  biskopsstift_1_N = mkN "biskopsstift" neutrum  ; -- biskopsstift..nn.1
  biskopsstol_1_N = mkN "biskopsstol" ; -- biskopsstol..nn.1
  biskopssäte_1_N = mkN "biskopssäte" ; -- biskopssäte..nn.1
  biskopsval_1_N = mkN "biskopsval" neutrum  ; -- biskopsval..nn.1
  biskopsvisitation_1_N = mkN "biskopsvisitation" ; -- biskopsvisitation..nn.1
  biskvi_1_N = mkN "biskvi" "biskvier" ; -- biskvi..nn.1
  bisköldkörtel_1_N = mkN "bisköldkörtel" ; -- bisköldkörtel..nn.1
  biskötsel_1_N = mkN "biskötsel" ; -- biskötsel..nn.1
  bismak_1_N = mkN "bismak" "bismaker" ; -- bismak..nn.1
  bisol_1_N = mkN "bisol" ; -- bisol..nn.1
  bison_1_N = mkN "bison" ; -- bison..nn.1
  bisonoxe_1_N = mkN "bisonoxe" utrum  ; -- bisonoxe..nn.1
  bisp_1_N = mkN "bisp" ; -- bisp..nn.1
  bispringa_1_V = mkV "bispringa" "bisprang" "bisprungit" ; -- bispringa..vb.1
  bispringande_1_N = mkN "bispringande" ; -- bispringande..nn.1
  bissauguinean_1_N = mkN "bissauguinean" "bissauguineaner" ; -- bissauguinean..nn.1
  bissauguineansk_1_A = mkA "bissauguineansk" ; -- bissauguineansk..av.1
  bissauguineanska_1_N = mkN "bissauguineanska" ; -- bissauguineanska..nn.1
  bissera_1_V = mkV "bisserar" ; -- bissera..vb.1
  bisserande_1_N = mkN "bisserande" ; -- bisserande..nn.1
  bisserbar_1_A = mkA "bisserbar" ; -- bisserbar..av.1
  bisserbarhet_1_N = mkN "bisserbarhet" ; -- bisserbarhet..nn.1
  bissering_1_N = mkN "bissering" ; -- bissering..nn.1
  bister_1_A = mkA "bister" ; -- bister..av.1
  bister_1_N = mkN "bister" neutrum  ; -- bister..nn.1
  bisterhet_1_N = mkN "bisterhet" ; -- bisterhet..nn.1
  bistick_1_N = mkN "bistick" neutrum  ; -- bistick..nn.1
  bisting_1_N = mkN "bisting" neutrum  ; -- bisting..nn.1
  bistock_1_N = mkN "bistock" ; -- bistock..nn.1
  bistro_1_N = mkN "bistro" "bistron" "bistroer" "bistroerna" ; -- bistro..nn.1
  bisträcka_1_V = mkV "bisträcker" ; -- bisträcka..vb.1
  bisträckande_1_N = mkN "bisträckande" ; -- bisträckande..nn.1
  bisturi_1_N = mkN "bisturi" "bisturier" ; -- bisturi..nn.1
  bistyng_1_N = mkN "bistyng" neutrum  ; -- bistyng..nn.1
  bistå_1_V = mkV "bistå" "bistod" "bistått" ; -- bistå..vb.1
  bistående_1_N = mkN "bistående" ; -- bistående..nn.1
  bistånd_1_N = mkN "bistånd" neutrum  ; -- bistånd..nn.1
  biståndsförvaltning_1_N = mkN "biståndsförvaltning" ; -- biståndsförvaltning..nn.1
  biståndsland_1_N = mkN "biståndsland" "biståndslandet" "biståndsländer" "biståndsländerna" ; -- biståndsland..nn.1
  biståndsminister_1_N = mkN "biståndsminister" ; -- biståndsminister..nn.1
  biståndsmål_1_N = mkN "biståndsmål" neutrum  ; -- biståndsmål..nn.1
  biståndsorgan_1_N = mkN "biståndsorgan" neutrum  ; -- biståndsorgan..nn.1
  biståndspolitik_1_N = mkN "biståndspolitik" ; -- biståndspolitik..nn.1
  biståndspolitisk_1_A = mkA "biståndspolitisk" ; -- biståndspolitisk..av.1
  biståndsprogram_1_N = mkN "biståndsprogram" "biståndsprogrammet" "biståndsprogram" "biståndsprogrammen" ; -- biståndsprogram..nn.1
  biståndsprojekt_1_N = mkN "biståndsprojekt" neutrum  ; -- biståndsprojekt..nn.1
  biståndsskepp_1_N = mkN "biståndsskepp" neutrum  ; -- biståndsskepp..nn.1
  bisvärm_1_N = mkN "bisvärm" ; -- bisvärm..nn.1
  bisyssla_1_N = mkN "bisyssla" ; -- bisyssla..nn.1
  bisätta_1_V = mkV "bisätta" "bisätter" "bisätt" "bisatte" "bisatt" "bisatt" ; -- bisätta..vb.1
  bisättande_1_N = mkN "bisättande" ; -- bisättande..nn.1
  bisättning_1_N = mkN "bisättning" ; -- bisättning..nn.1
  bit_1_N = mkN "bit" ; -- bit..nn.1
  bit_2_N = mkN "bit" ; -- bit..nn.2
  bita_1_V = mkV "bita" "bet" "bitit" ; -- bita..vb.1
  bita_2_V = mkV "bitar" ; -- bita..vb.2
  bitande_1_A = mkA "bitande" ; -- bitande..av.1
  bitande_1_N = mkN "bitande" ; -- bitande..nn.1
  bitanke_1_N = mkN "bitanke" utrum  ; -- bitanke..nn.1
  bitch_1_N = mkN "bitch" ; -- bitch..nn.1
  bitchig_1_A = mkA "bitchig" ; -- bitchig..av.1
  bitecken_1_N = mkN "bitecken" "bitecknet" "bitecken" "bitecknen" ; -- bitecken..nn.1
  biten_1_A = mkA "biten" ; -- biten..av.1
  bitestikel_1_N = mkN "bitestikel" ; -- bitestikel..nn.1
  bitmärke_1_N = mkN "bitmärke" ; -- bitmärke..nn.1
  biton_1_N = mkN "biton" "bitoner" ; -- biton..nn.1
  bitryck_1_N = mkN "bitryck" neutrum  ; -- bitryck..nn.1
  biträda_1_V = mkV "biträda" "biträdde" "biträtt" ; -- biträda..vb.1
  biträdande_1_A = mkA "biträdande" ; -- biträdande..av.1
  biträdande_1_N = mkN "biträdande" ; -- biträdande..nn.1
  biträde_1_N = mkN "biträde" ; -- biträde..nn.1
  bits_1_N = mkN "bits" neutrum  ; -- bits..nn.1
  bitshållare_1_N = mkN "bitshållare" utrum  ; -- bitshållare..nn.1
  bitsk_1_A = mkA "bitsk" ; -- bitsk..av.1
  bitskhet_1_N = mkN "bitskhet" ; -- bitskhet..nn.1
  bitsocker_1_N = mkN "bitsocker" neutrum  ; -- bitsocker..nn.1
  bitsår_1_N = mkN "bitsår" neutrum  ; -- bitsår..nn.1
  bittelitenhet_1_N = mkN "bittelitenhet" ; -- bittelitenhet..nn.1
  bitter_1_A = mkA "bitter" ; -- bitter..av.1
  bitterhet_1_N = mkN "bitterhet" "bitterheter" ; -- bitterhet..nn.1
  bitterkall_1_A = mkA "bitterkall" ; -- bitterkall..av.1
  bitterligen_1_Adv = mkAdv "bitterligen" ; -- bitterligen..ab.1
  bitterljuv_1_A = mkA "bitterljuv" ; -- bitterljuv..av.1
  bitterljuvhet_1_N = mkN "bitterljuvhet" ; -- bitterljuvhet..nn.1
  bittermandel_1_N = mkN "bittermandel" ; -- bittermandel..nn.1
  bittermandelolja_1_N = mkN "bittermandelolja" ; -- bittermandelolja..nn.1
  bittersalt_1_A = mkA "bittersalt" "bittersalt" ; -- bittersalt..av.1
  bittersalt_1_N = mkN "bittersalt" neutrum  ; -- bittersalt..nn.1
  bittersta_1_A = mkA "bittersta" ; -- bittersta..av.1
  bittersöt_1_A = mkA "bittersöt" ; -- bittersöt..av.1
  bittersöta_1_N = mkN "bittersöta" ; -- bittersöta..nn.1
  bituminös_1_A = mkA "bituminös" ; -- bituminös..av.1
  bitvarg_1_N = mkN "bitvarg" ; -- bitvarg..nn.1
  bitvis_1_Adv = mkAdv "bitvis" ; -- bitvis..ab.1
  bivack_1_N = mkN "bivack" "bivacker" ; -- bivack..nn.1
  bivackera_1_V = mkV "bivackerar" ; -- bivackera..vb.1
  bivackerande_1_N = mkN "bivackerande" ; -- bivackerande..nn.1
  bivackerbar_1_A = mkA "bivackerbar" ; -- bivackerbar..av.1
  bivackerbarhet_1_N = mkN "bivackerbarhet" ; -- bivackerbarhet..nn.1
  bivackering_1_N = mkN "bivackering" ; -- bivackering..nn.1
  bivax_1_N = mkN "bivax" neutrum  ; -- bivax..nn.1
  biverkning_1_N = mkN "biverkning" ; -- biverkning..nn.1
  biverkningsfall_1_N = mkN "biverkningsfall" neutrum  ; -- biverkningsfall..nn.1
  biverkningsrapport_1_N = mkN "biverkningsrapport" "biverkningsrapporter" ; -- biverkningsrapport..nn.1
  bivråk_1_N = mkN "bivråk" ; -- bivråk..nn.1
  biväg_1_N = mkN "biväg" ; -- biväg..nn.1
  biyngel_1_N = mkN "biyngel" neutrum  ; -- biyngel..nn.1
  biämne_1_N = mkN "biämne" ; -- biämne..nn.1
  biätare_1_N = mkN "biätare" utrum  ; -- biätare..nn.1
  bjuda_1_V = mkV "bjuda" "bjöd" "bjudit" ; -- bjuda..vb.1
  bjudande_1_N = mkN "bjudande" ; -- bjudande..nn.1
  bjudcigarr_1_N = mkN "bjudcigarr" "bjudcigarrer" ; -- bjudcigarr..nn.1
  bjudning_1_N = mkN "bjudning" ; -- bjudning..nn.1
  bjugg_1_N = mkN "bjugg" ; -- bjugg..nn.1
  bjussa_1_V = mkV "bjussar" ; -- bjussa..vb.1
  bjussande_1_N = mkN "bjussande" ; -- bjussande..nn.1
  bjäbb_1_N = mkN "bjäbb" neutrum  ; -- bjäbb..nn.1
  bjäbba_1_V = mkV "bjäbbar" ; -- bjäbba..vb.1
  bjäbbande_1_N = mkN "bjäbbande" ; -- bjäbbande..nn.1
  bjäbbig_1_A = mkA "bjäbbig" ; -- bjäbbig..av.1
  bjäbbighet_1_N = mkN "bjäbbighet" "bjäbbigheter" ; -- bjäbbighet..nn.1
  bjäfs_1_N = mkN "bjäfs" neutrum  ; -- bjäfs..nn.1
  bjälke_1_N = mkN "bjälke" utrum  ; -- bjälke..nn.1
  bjälkhuvud_1_N = mkN "bjälkhuvud" "bjälkhuvudet" "bjälkhuvud" "bjälkhuvudena" ; -- bjälkhuvud..nn.1
  bjälklag_1_N = mkN "bjälklag" neutrum  ; -- bjälklag..nn.1
  bjälkverk_1_N = mkN "bjälkverk" neutrum  ; -- bjälkverk..nn.1
  bjällerklang_1_N = mkN "bjällerklang" ; -- bjällerklang..nn.1
  bjällko_1_N = mkN "bjällko" "bjällkor" ; -- bjällko..nn.1
  bjällra_1_N = mkN "bjällra" ; -- bjällra..nn.1
  bjärt_1_A = mkA "bjärt" "bjärt" ; -- bjärt..av.1
  bjärtgrön_1_A = mkA "bjärtgrön" ; -- bjärtgrön..av.1
  bjärthet_1_N = mkN "bjärthet" ; -- bjärthet..nn.1
  bjässe_1_N = mkN "bjässe" utrum  ; -- bjässe..nn.1
  björk_1_N = mkN "björk" ; -- björk..nn.1
  björkblad_1_N = mkN "björkblad" neutrum  ; -- björkblad..nn.1
  björke_1_N = mkN "björke" ; -- björke..nn.1
  björkgren_1_N = mkN "björkgren" "björkgrenen" "björkgrenar" "björkgrenarna" ; -- björkgren..nn.1
  björkgräns_1_N = mkN "björkgräns" ; -- björkgräns..nn.1
  björkhage_1_N = mkN "björkhage" utrum  ; -- björkhage..nn.1
  björklag_1_N = mkN "björklag" ; -- björklag..nn.1
  björklöv_1_N = mkN "björklöv" neutrum  ; -- björklöv..nn.1
  björkna_1_N = mkN "björkna" ; -- björkna..nn.1
  björknäver_1_N = mkN "björknäver" ; -- björknäver..nn.1
  björkpollen_1_N = mkN "björkpollen" neutrum  ; -- björkpollen..nn.1
  björkregion_1_N = mkN "björkregion" ; -- björkregion..nn.1
  björkris_1_N = mkN "björkris" neutrum  ; -- björkris..nn.1
  björksav_1_N = mkN "björksav" ; -- björksav..nn.1
  björkskog_1_N = mkN "björkskog" ; -- björkskog..nn.1
  björksly_1_N = mkN "björksly" neutrum  ; -- björksly..nn.1
  björksopp_1_N = mkN "björksopp" ; -- björksopp..nn.1
  björktrast_1_N = mkN "björktrast" ; -- björktrast..nn.1
  björkved_1_N = mkN "björkved" ; -- björkved..nn.1
  björn_1_N = mkN "björn" ; -- björn..nn.1
  björna_1_V = mkV "björnar" ; -- björna..vb.1
  björnande_1_N = mkN "björnande" ; -- björnande..nn.1
  björnbindsel_1_N = mkN "björnbindsel" neutrum  ; -- björnbindsel..nn.1
  björnbindsle_1_N = mkN "björnbindsle" ; -- björnbindsle..nn.1
  björnbär_1_N = mkN "björnbär" neutrum  ; -- björnbär..nn.1
  björnbärsbuske_1_N = mkN "björnbärsbuske" utrum  ; -- björnbärsbuske..nn.1
  björnfloka_1_N = mkN "björnfloka" ; -- björnfloka..nn.1
  björngrop_1_N = mkN "björngrop" ; -- björngrop..nn.1
  björnhallon_1_N = mkN "björnhallon" neutrum  ; -- björnhallon..nn.1
  björnhona_1_N = mkN "björnhona" ; -- björnhona..nn.1
  björnhund_1_N = mkN "björnhund" ; -- björnhund..nn.1
  björnide_1_N = mkN "björnide" ; -- björnide..nn.1
  björninna_1_N = mkN "björninna" ; -- björninna..nn.1
  björnjakt_1_N = mkN "björnjakt" "björnjakter" ; -- björnjakt..nn.1
  björnliknande_1_A = mkA "björnliknande" ; -- björnliknande..av.1
  björnloka_1_N = mkN "björnloka" ; -- björnloka..nn.1
  björnmossa_1_N = mkN "björnmossa" ; -- björnmossa..nn.1
  björnram_1_N = mkN "björnram" ; -- björnram..nn.1
  björnsax_1_N = mkN "björnsax" ; -- björnsax..nn.1
  björnskall_1_N = mkN "björnskall" neutrum  ; -- björnskall..nn.1
  björnskinn_1_N = mkN "björnskinn" neutrum  ; -- björnskinn..nn.1
  björnskinnsmössa_1_N = mkN "björnskinnsmössa" ; -- björnskinnsmössa..nn.1
  björnskådning_1_N = mkN "björnskådning" ; -- björnskådning..nn.1
  björntjänst_1_N = mkN "björntjänst" "björntjänster" ; -- björntjänst..nn.1
  björntråd_1_N = mkN "björntråd" ; -- björntråd..nn.1
  black_1_A = mkA "black" ; -- black..av.1
  black_1_N = mkN "black" ; -- black..nn.1
  blackhet_1_N = mkN "blackhet" ; -- blackhet..nn.1
  blackig_1_A = mkA "blackig" ; -- blackig..av.1
  blackighet_1_N = mkN "blackighet" ; -- blackighet..nn.1
  blackout_1_N = mkN "blackout" "blackouter" ; -- blackout..nn.1
  blad_1_N = mkN "blad" neutrum  ; -- blad..nn.1
  blada_1_V = mkV "bladar" ; -- blada..vb.1
  bladande_1_N = mkN "bladande" ; -- bladande..nn.1
  bladbagge_1_N = mkN "bladbagge" utrum  ; -- bladbagge..nn.1
  bladbildning_1_N = mkN "bladbildning" ; -- bladbildning..nn.1
  bladbyte_1_N = mkN "bladbyte" ; -- bladbyte..nn.1
  bladder_1_N = mkN "bladder" neutrum  ; -- bladder..nn.1
  bladdra_1_V = mkV "bladdrar" ; -- bladdra..vb.1
  bladdrande_1_N = mkN "bladdrande" ; -- bladdrande..nn.1
  bladfot_1_N = mkN "bladfot" "bladfötter" ; -- bladfot..nn.1
  bladfoting_1_N = mkN "bladfoting" ; -- bladfoting..nn.1
  bladguld_1_N = mkN "bladguld" neutrum  ; -- bladguld..nn.1
  bladig_1_A = mkA "bladig" ; -- bladig..av.1
  bladknopp_1_N = mkN "bladknopp" ; -- bladknopp..nn.1
  bladkrans_1_N = mkN "bladkrans" ; -- bladkrans..nn.1
  bladkål_1_N = mkN "bladkål" ; -- bladkål..nn.1
  bladloppa_1_N = mkN "bladloppa" ; -- bladloppa..nn.1
  bladlus_1_N = mkN "bladlus" "bladlusen" "bladlöss" "bladlössen" ; -- bladlus..nn.1
  bladlängd_1_N = mkN "bladlängd" "bladlängder" ; -- bladlängd..nn.1
  bladmage_1_N = mkN "bladmage" utrum  ; -- bladmage..nn.1
  bladmetall_1_N = mkN "bladmetall" ; -- bladmetall..nn.1
  bladminerare_1_N = mkN "bladminerare" utrum  ; -- bladminerare..nn.1
  bladmossa_1_N = mkN "bladmossa" ; -- bladmossa..nn.1
  bladmögel_1_N = mkN "bladmögel" neutrum  ; -- bladmögel..nn.1
  bladnerv_1_N = mkN "bladnerv" "bladnerver" ; -- bladnerv..nn.1
  bladning_1_N = mkN "bladning" ; -- bladning..nn.1
  bladrik_1_A = mkA "bladrik" ; -- bladrik..av.1
  bladrullsjuka_1_N = mkN "bladrullsjuka" ; -- bladrullsjuka..nn.1
  bladrött_1_N = mkN "bladrött" ; -- bladrött..nn.1
  bladsilver_1_N = mkN "bladsilver" neutrum  ; -- bladsilver..nn.1
  bladskaft_1_N = mkN "bladskaft" neutrum  ; -- bladskaft..nn.1
  bladskärarmyra_1_N = mkN "bladskärarmyra" ; -- bladskärarmyra..nn.1
  bladspänning_1_N = mkN "bladspänning" ; -- bladspänning..nn.1
  bladstekel_1_N = mkN "bladstekel" ; -- bladstekel..nn.1
  bladställning_1_N = mkN "bladställning" ; -- bladställning..nn.1
  bladverk_1_N = mkN "bladverk" neutrum  ; -- bladverk..nn.1
  bladväxt_1_N = mkN "bladväxt" "bladväxter" ; -- bladväxt..nn.1
  blaffa_1_N = mkN "blaffa" ; -- blaffa..nn.1
  blaggarn_1_N = mkN "blaggarn" neutrum  ; -- blaggarn..nn.1
  blaj_1_N = mkN "blaj" neutrum  ; -- blaj..nn.1
  blaja_1_V = mkV "blajar" ; -- blaja..vb.1
  blajande_1_N = mkN "blajande" ; -- blajande..nn.1
  blam_1_N = mkN "blam" "blamer" ; -- blam..nn.1
  blamage_1_N = mkN "blamage" "blamager" ; -- blamage..nn.1
  blamant_1_A = mkA "blamant" "blamant" ; -- blamant..av.1
  blanchera_1_V = mkV "blancherar" ; -- blanchera..vb.1
  blancherande_1_N = mkN "blancherande" ; -- blancherande..nn.1
  blancherbar_1_A = mkA "blancherbar" ; -- blancherbar..av.1
  blancherbarhet_1_N = mkN "blancherbarhet" ; -- blancherbarhet..nn.1
  blanchering_1_N = mkN "blanchering" ; -- blanchering..nn.1
  blancmangé_1_N = mkN "blancmangé" "blancmangéer" ; -- blancmangé..nn.1
  blanda_1_V = mkV "blandar" ; -- blanda..vb.1
  blandad_1_A = mkA "blandad" ; -- blandad..av.1
  blandande_1_N = mkN "blandande" ; -- blandande..nn.1
  blandare_1_N = mkN "blandare" utrum  ; -- blandare..nn.1
  blanddricka_1_N = mkN "blanddricka" ; -- blanddricka..nn.1
  blanddryck_1_N = mkN "blanddryck" ; -- blanddryck..nn.1
  blandekonomi_1_N = mkN "blandekonomi" "blandekonomier" ; -- blandekonomi..nn.1
  blandfoder_1_N = mkN "blandfoder" neutrum  ; -- blandfoder..nn.1
  blandfolk_1_N = mkN "blandfolk" neutrum  ; -- blandfolk..nn.1
  blandform_1_N = mkN "blandform" "blandformer" ; -- blandform..nn.1
  blandfärg_1_N = mkN "blandfärg" "blandfärger" ; -- blandfärg..nn.1
  blandkultur_1_N = mkN "blandkultur" "blandkulturer" ; -- blandkultur..nn.1
  blandning_1_N = mkN "blandning" ; -- blandning..nn.1
  blandningsförhållande_1_N = mkN "blandningsförhållande" ; -- blandningsförhållande..nn.1
  blandningskran_1_N = mkN "blandningskran" ; -- blandningskran..nn.1
  blandras_1_N = mkN "blandras" "blandraser" ; -- blandras..nn.1
  blandrashund_1_N = mkN "blandrashund" ; -- blandrashund..nn.1
  blandskog_1_N = mkN "blandskog" ; -- blandskog..nn.1
  blandspråk_1_N = mkN "blandspråk" neutrum  ; -- blandspråk..nn.1
  blandsäd_1_N = mkN "blandsäd" ; -- blandsäd..nn.1
  blandtyp_1_N = mkN "blandtyp" "blandtyper" ; -- blandtyp..nn.1
  blandvatten_1_N = mkN "blandvatten" "blandvattnet" "blandvatten" "blandvattnen" ; -- blandvatten..nn.1
  blandäktenskap_1_N = mkN "blandäktenskap" neutrum  ; -- blandäktenskap..nn.1
  blank_1_A = mkA "blank" ; -- blank..av.1
  blanka_1_N = mkN "blanka" ; -- blanka..nn.1
  blanka_1_V = mkV "blankar" ; -- blanka..vb.1
  blankande_1_N = mkN "blankande" ; -- blankande..nn.1
  blankborste_1_N = mkN "blankborste" utrum  ; -- blankborste..nn.1
  blankett_1_N = mkN "blankett" "blanketter" ; -- blankett..nn.1
  blankettraseri_1_N = mkN "blankettraseri" neutrum  ; -- blankettraseri..nn.1
  blankettskåp_1_N = mkN "blankettskåp" neutrum  ; -- blankettskåp..nn.1
  blankgalvad_1_A = mkA "blankgalvad" ; -- blankgalvad..av.1
  blankhet_1_N = mkN "blankhet" ; -- blankhet..nn.1
  blankis_1_N = mkN "blankis" ; -- blankis..nn.1
  blanklax_1_N = mkN "blanklax" ; -- blanklax..nn.1
  blankläder_1_N = mkN "blankläder" neutrum  ; -- blankläder..nn.1
  blankning_1_N = mkN "blankning" ; -- blankning..nn.1
  blankningsaffär_1_N = mkN "blankningsaffär" "blankningsaffärer" ; -- blankningsaffär..nn.1
  blankningsförbud_1_N = mkN "blankningsförbud" neutrum  ; -- blankningsförbud..nn.1
  blankoaccept_1_N = mkN "blankoaccept" "blankoaccepter" ; -- blankoaccept..nn.1
  blankocheck_1_N = mkN "blankocheck" ; -- blankocheck..nn.1
  blankofullmakt_1_N = mkN "blankofullmakt" "blankofullmakter" ; -- blankofullmakt..nn.1
  blankoförsäljning_1_N = mkN "blankoförsäljning" ; -- blankoförsäljning..nn.1
  blankokredit_1_N = mkN "blankokredit" "blankokrediter" ; -- blankokredit..nn.1
  blankotransport_1_N = mkN "blankotransport" "blankotransporter" ; -- blankotransport..nn.1
  blankoväxel_1_N = mkN "blankoväxel" ; -- blankoväxel..nn.1
  blankoöverlåtelse_1_N = mkN "blankoöverlåtelse" utrum  ; -- blankoöverlåtelse..nn.1
  blankpolera_1_V = mkV "blankpolerar" ; -- blankpolera..vb.1
  blankpolerande_1_N = mkN "blankpolerande" ; -- blankpolerande..nn.1
  blankpolerbar_1_A = mkA "blankpolerbar" ; -- blankpolerbar..av.1
  blankpolerbarhet_1_N = mkN "blankpolerbarhet" ; -- blankpolerbarhet..nn.1
  blankpolering_1_N = mkN "blankpolering" ; -- blankpolering..nn.1
  blankputsad_1_A = mkA "blankputsad" ; -- blankputsad..av.1
  blankröstare_1_N = mkN "blankröstare" utrum  ; -- blankröstare..nn.1
  blanksej_1_N = mkN "blanksej" ; -- blanksej..nn.1
  blankskinn_1_N = mkN "blankskinn" neutrum  ; -- blankskinn..nn.1
  blankslipa_1_V = mkV "blankslipar" ; -- blankslipa..vb.1
  blankslipande_1_N = mkN "blankslipande" ; -- blankslipande..nn.1
  blankslipning_1_N = mkN "blankslipning" ; -- blankslipning..nn.1
  blanksliten_1_A = mkA "blanksliten" ; -- blanksliten..av.1
  blanksmörja_1_N = mkN "blanksmörja" ; -- blanksmörja..nn.1
  blanksvärta_1_N = mkN "blanksvärta" ; -- blanksvärta..nn.1
  blankvatten_1_N = mkN "blankvatten" "blankvattnet" "blankvatten" "blankvattnen" ; -- blankvatten..nn.1
  blankvers_1_N = mkN "blankvers" ; -- blankvers..nn.1
  blankål_1_N = mkN "blankål" ; -- blankål..nn.1
  blark_1_N = mkN "blark" ; -- blark..nn.1
  blarr_1_N = mkN "blarr" neutrum  ; -- blarr..nn.1
  blarra_1_V = mkV "blarrar" ; -- blarra..vb.1
  blarrande_1_N = mkN "blarrande" ; -- blarrande..nn.1
  blaserad_1_A = mkA "blaserad" ; -- blaserad..av.1
  blasfemi_1_N = mkN "blasfemi" "blasfemier" ; -- blasfemi..nn.1
  blasfemisk_1_A = mkA "blasfemisk" ; -- blasfemisk..av.1
  blask_1_N = mkN "blask" neutrum  ; -- blask..nn.1
  blaska_1_N = mkN "blaska" ; -- blaska..nn.1
  blaska_1_V = mkV "blaskar" ; -- blaska..vb.1
  blaskande_1_N = mkN "blaskande" ; -- blaskande..nn.1
  blaskig_1_A = mkA "blaskig" ; -- blaskig..av.1
  blaskighet_1_N = mkN "blaskighet" ; -- blaskighet..nn.1
  blasonering_1_N = mkN "blasonering" ; -- blasonering..nn.1
  blast_1_N = mkN "blast" ; -- blast..nn.1
  blastula_1_N = mkN "blastula" ; -- blastula..nn.1
  blasé_1_A = mkA "blasé" ; -- blasé..av.1
  blatte_1_N = mkN "blatte" utrum  ; -- blatte..nn.1
  blazer_1_N = mkN "blazer" ; -- blazer..nn.1
  blazerklädd_1_A = mkA "blazerklädd" ; -- blazerklädd..av.1
  bleck_1_N = mkN "bleck" neutrum  ; -- bleck..nn.1
  bleckblåsinstrument_1_N = mkN "bleckblåsinstrument" neutrum  ; -- bleckblåsinstrument..nn.1
  bleckburk_1_N = mkN "bleckburk" ; -- bleckburk..nn.1
  bleckinstrument_1_N = mkN "bleckinstrument" neutrum  ; -- bleckinstrument..nn.1
  bleckmusik_1_N = mkN "bleckmusik" ; -- bleckmusik..nn.1
  bleckplåt_1_N = mkN "bleckplåt" ; -- bleckplåt..nn.1
  bleckslagare_1_N = mkN "bleckslagare" utrum  ; -- bleckslagare..nn.1
  bleckslageri_1_N = mkN "bleckslageri" "bleckslageriet" "bleckslagerier" "bleckslagerierna" ; -- bleckslageri..nn.1
  blecksmak_1_N = mkN "blecksmak" ; -- blecksmak..nn.1
  blek_1_A = mkA "blek" ; -- blek..av.1
  bleka_1_V = mkV "bleker" ; -- bleka..vb.1
  blekande_1_N = mkN "blekande" ; -- blekande..nn.1
  blekansikte_1_N = mkN "blekansikte" ; -- blekansikte..nn.1
  blekblå_1_A = mkA "blekblå" "blekblått" ; -- blekblå..av.1
  bleke_1_N = mkN "bleke" ; -- bleke..nn.1
  blekeri_1_N = mkN "blekeri" "blekeriet" "blekerier" "blekerierna" ; -- blekeri..nn.1
  blekfet_1_A = mkA "blekfet" ; -- blekfet..av.1
  blekfethet_1_N = mkN "blekfethet" ; -- blekfethet..nn.1
  blekfis_1_N = mkN "blekfis" ; -- blekfis..nn.1
  blekglaserad_1_A = mkA "blekglaserad" ; -- blekglaserad..av.1
  blekgul_1_A = mkA "blekgul" ; -- blekgul..av.1
  blekhet_1_N = mkN "blekhet" "blekheter" ; -- blekhet..nn.1
  bleking_1_N = mkN "bleking" ; -- bleking..nn.1
  blekingseka_1_N = mkN "blekingseka" ; -- blekingseka..nn.1
  blekingsk_1_A = mkA "blekingsk" ; -- blekingsk..av.1
  blekingska_1_N = mkN "blekingska" ; -- blekingska..nn.1
  blekingska_2_N = mkN "blekingska" ; -- blekingska..nn.2
  blekjord_1_N = mkN "blekjord" ; -- blekjord..nn.1
  bleklagd_1_A = mkA "bleklagd" "bleklagt" ; -- bleklagd..av.1
  bleklagdhet_1_N = mkN "bleklagdhet" ; -- bleklagdhet..nn.1
  blekmedel_1_N = mkN "blekmedel" neutrum  ; -- blekmedel..nn.1
  blekna_1_V = mkV "bleknar" ; -- blekna..vb.1
  bleknande_1_N = mkN "bleknande" ; -- bleknande..nn.1
  blekning_1_N = mkN "blekning" ; -- blekning..nn.1
  bleknos_1_N = mkN "bleknos" ; -- bleknos..nn.1
  blekröd_1_A = mkA "blekröd" "blekrött" ; -- blekröd..av.1
  bleksiktig_1_A = mkA "bleksiktig" ; -- bleksiktig..av.1
  bleksiktighet_1_N = mkN "bleksiktighet" ; -- bleksiktighet..nn.1
  bleksot_1_N = mkN "bleksot" ; -- bleksot..nn.1
  blekvätska_1_N = mkN "blekvätska" ; -- blekvätska..nn.1
  blemma_1_N = mkN "blemma" ; -- blemma..nn.1
  blemmig_1_A = mkA "blemmig" ; -- blemmig..av.1
  blessera_1_V = mkV "blesserar" ; -- blessera..vb.1
  blesserande_1_N = mkN "blesserande" ; -- blesserande..nn.1
  blesserbar_1_A = mkA "blesserbar" ; -- blesserbar..av.1
  blesserbarhet_1_N = mkN "blesserbarhet" ; -- blesserbarhet..nn.1
  blessering_1_N = mkN "blessering" ; -- blessering..nn.1
  blessyr_1_N = mkN "blessyr" "blessyrer" ; -- blessyr..nn.1
  bli_1_V = mkV "bliva" "blev" "blivit" ; -- bli..vb.1
  blick_1_N = mkN "blick" ; -- blick..nn.1
  blicka_1_V = mkV "blickar" ; -- blicka..vb.1
  blickande_1_N = mkN "blickande" ; -- blickande..nn.1
  blickfält_1_N = mkN "blickfält" neutrum  ; -- blickfält..nn.1
  blickfång_1_N = mkN "blickfång" neutrum  ; -- blickfång..nn.1
  blickpunkt_1_N = mkN "blickpunkt" ; -- blickpunkt..nn.1
  blickstilla_1_A = mkA "blickstilla" ; -- blickstilla..av.1
  blid_1_A = mkA "blid" "blitt" ; -- blid..av.1
  blida_1_N = mkN "blida" ; -- blida..nn.1
  blidgrad_1_N = mkN "blidgrad" "blidgrader" ; -- blidgrad..nn.1
  blidhet_1_N = mkN "blidhet" ; -- blidhet..nn.1
  blidka_1_V = mkV "blidkar" ; -- blidka..vb.1
  blidkande_1_N = mkN "blidkande" ; -- blidkande..nn.1
  blidvinter_1_N = mkN "blidvinter" ; -- blidvinter..nn.1
  blidväder_1_N = mkN "blidväder" neutrum  ; -- blidväder..nn.1
  bliende_1_N = mkN "bliende" ; -- bliende..nn.1
  blig_1_N = mkN "blig" neutrum  ; -- blig..nn.1
  bliga_1_V = mkV "bligar" ; -- bliga..vb.1
  bligande_1_N = mkN "bligande" ; -- bligande..nn.1
  blind_1_A = mkA "blind" ; -- blind..av.1
  blinda_1_N = mkN "blinda" ; -- blinda..nn.1
  blindalfabet_1_N = mkN "blindalfabet" neutrum  ; -- blindalfabet..nn.1
  blindbock_1_N = mkN "blindbock" ; -- blindbock..nn.1
  blindbotten_1_N = mkN "blindbotten" ; -- blindbotten..nn.1
  blindbroms_1_N = mkN "blindbroms" ; -- blindbroms..nn.1
  blinddörr_1_N = mkN "blinddörr" ; -- blinddörr..nn.1
  blindera_1_V = mkV "blinderar" ; -- blindera..vb.1
  blinderande_1_N = mkN "blinderande" ; -- blinderande..nn.1
  blinderbar_1_A = mkA "blinderbar" ; -- blinderbar..av.1
  blinderbarhet_1_N = mkN "blinderbarhet" ; -- blinderbarhet..nn.1
  blindering_1_N = mkN "blindering" ; -- blindering..nn.1
  blindflygning_1_N = mkN "blindflygning" ; -- blindflygning..nn.1
  blindfönster_1_N = mkN "blindfönster" neutrum  ; -- blindfönster..nn.1
  blindgata_1_N = mkN "blindgata" ; -- blindgata..nn.1
  blindgångare_1_N = mkN "blindgångare" utrum  ; -- blindgångare..nn.1
  blindhet_1_N = mkN "blindhet" ; -- blindhet..nn.1
  blindhund_1_N = mkN "blindhund" ; -- blindhund..nn.1
  blindinstitut_1_N = mkN "blindinstitut" neutrum  ; -- blindinstitut..nn.1
  blindkarta_1_N = mkN "blindkarta" ; -- blindkarta..nn.1
  blindlandning_1_N = mkN "blindlandning" ; -- blindlandning..nn.1
  blindlykta_1_N = mkN "blindlykta" ; -- blindlykta..nn.1
  blindnässla_1_N = mkN "blindnässla" ; -- blindnässla..nn.1
  blindparti_1_N = mkN "blindparti" "blindpartiet" "blindpartier" "blindpartierna" ; -- blindparti..nn.1
  blindpassagerare_1_N = mkN "blindpassagerare" utrum  ; -- blindpassagerare..nn.1
  blindpatron_1_N = mkN "blindpatron" "blindpatroner" ; -- blindpatron..nn.1
  blindpipa_1_N = mkN "blindpipa" ; -- blindpipa..nn.1
  blindpressa_1_V = mkV "blindpressar" ; -- blindpressa..vb.1
  blindpressande_1_N = mkN "blindpressande" ; -- blindpressande..nn.1
  blindpressning_1_N = mkN "blindpressning" ; -- blindpressning..nn.1
  blindrote_1_N = mkN "blindrote" utrum  ; -- blindrote..nn.1
  blindrå_1_N = mkN "blindrå" "blindrån" "blindrår" "blindrårna" ; -- blindrå..nn.1
  blindschack_1_N = mkN "blindschack" neutrum  ; -- blindschack..nn.1
  blindskola_1_N = mkN "blindskola" ; -- blindskola..nn.1
  blindskrift_1_N = mkN "blindskrift" ; -- blindskrift..nn.1
  blindskär_1_N = mkN "blindskär" neutrum  ; -- blindskär..nn.1
  blindspår_1_N = mkN "blindspår" neutrum  ; -- blindspår..nn.1
  blindstyre_1_N = mkN "blindstyre" ; -- blindstyre..nn.1
  blindtarm_1_N = mkN "blindtarm" ; -- blindtarm..nn.1
  blindtarmsinflammation_1_N = mkN "blindtarmsinflammation" ; -- blindtarmsinflammation..nn.1
  blindtarmsoperation_1_N = mkN "blindtarmsoperation" ; -- blindtarmsoperation..nn.1
  blindtryck_1_N = mkN "blindtryck" neutrum  ; -- blindtryck..nn.1
  bling_bling_1_N = mkN "bling-bling" neutrum  ; -- bling-bling..nn.1
  bling_1_N = mkN "bling" neutrum  ; -- bling..nn.1
  blinga_1_V = mkV "blingar" ; -- blinga..vb.1
  blingande_1_N = mkN "blingande" ; -- blingande..nn.1
  blingning_1_N = mkN "blingning" ; -- blingning..nn.1
  blini_1_N = mkN "blini" "blinier" ; -- blini..nn.1
  blink_1_N = mkN "blink" neutrum  ; -- blink..nn.1
  blink_2_N = mkN "blink" ; -- blink..nn.2
  blinka_1_V = mkV "blinkar" ; -- blinka..vb.1
  blinkande_1_N = mkN "blinkande" ; -- blinkande..nn.1
  blinker_1_N = mkN "blinker" ; -- blinker..nn.1
  blinkfyr_1_N = mkN "blinkfyr" ; -- blinkfyr..nn.1
  blinkhinna_1_N = mkN "blinkhinna" ; -- blinkhinna..nn.1
  blinkljus_1_N = mkN "blinkljus" neutrum  ; -- blinkljus..nn.1
  blinkning_1_N = mkN "blinkning" ; -- blinkning..nn.1
  blinning_1_N = mkN "blinning" ; -- blinning..nn.1
  blip_1_N = mkN "blip" ; -- blip..nn.1
  blipp_1_N = mkN "blipp" ; -- blipp..nn.1
  blippa_1_V = mkV "blippar" ; -- blippa..vb.1
  blippande_1_N = mkN "blippande" ; -- blippande..nn.1
  blippning_1_N = mkN "blippning" ; -- blippning..nn.1
  blivande_1_A = mkA "blivande" ; -- blivande..av.1
  blivande_1_N = mkN "blivande" ; -- blivande..nn.1
  blixt_1_N = mkN "blixt" ; -- blixt..nn.1
  blixtanfall_1_N = mkN "blixtanfall" neutrum  ; -- blixtanfall..nn.1
  blixtbelysning_1_N = mkN "blixtbelysning" ; -- blixtbelysning..nn.1
  blixtbesök_1_N = mkN "blixtbesök" neutrum  ; -- blixtbesök..nn.1
  blixtfoto_1_N = mkN "blixtfoto" "blixtfotot" "blixtfoton" "blixtfotona" ; -- blixtfoto..nn.1
  blixtfotografera_1_V = mkV "blixtfotograferar" ; -- blixtfotografera..vb.1
  blixtfotograferande_1_N = mkN "blixtfotograferande" ; -- blixtfotograferande..nn.1
  blixtfotograferbar_1_A = mkA "blixtfotograferbar" ; -- blixtfotograferbar..av.1
  blixtfotograferbarhet_1_N = mkN "blixtfotograferbarhet" ; -- blixtfotograferbarhet..nn.1
  blixtfotografering_1_N = mkN "blixtfotografering" ; -- blixtfotografering..nn.1
  blixtfyr_1_N = mkN "blixtfyr" ; -- blixtfyr..nn.1
  blixtförälskad_1_A = mkA "blixtförälskad" ; -- blixtförälskad..av.1
  blixthalka_1_N = mkN "blixthalka" ; -- blixthalka..nn.1
  blixtinkalla_1_V = mkV "blixtinkallar" ; -- blixtinkalla..vb.1
  blixtinkallad_1_A = mkA "blixtinkallad" ; -- blixtinkallad..av.1
  blixtinkallande_1_N = mkN "blixtinkallande" ; -- blixtinkallande..nn.1
  blixtinkallelse_1_N = mkN "blixtinkallelse" "blixtinkallelser" ; -- blixtinkallelse..nn.1
  blixtinvasion_1_N = mkN "blixtinvasion" ; -- blixtinvasion..nn.1
  blixtkrig_1_N = mkN "blixtkrig" neutrum  ; -- blixtkrig..nn.1
  blixtlampa_1_N = mkN "blixtlampa" ; -- blixtlampa..nn.1
  blixtljus_1_N = mkN "blixtljus" neutrum  ; -- blixtljus..nn.1
  blixtlås_1_N = mkN "blixtlås" neutrum  ; -- blixtlås..nn.1
  blixtnedslag_1_N = mkN "blixtnedslag" neutrum  ; -- blixtnedslag..nn.1
  blixtpatron_1_N = mkN "blixtpatron" "blixtpatroner" ; -- blixtpatron..nn.1
  blixtpulver_1_N = mkN "blixtpulver" neutrum  ; -- blixtpulver..nn.1
  blixtra_1_V = mkV "blixtrar" ; -- blixtra..vb.1
  blixtrande_1_A = mkA "blixtrande" ; -- blixtrande..av.1
  blixtrande_1_N = mkN "blixtrande" ; -- blixtrande..nn.1
  blixtsamtal_1_N = mkN "blixtsamtal" neutrum  ; -- blixtsamtal..nn.1
  blixtsnabb_1_A = mkA "blixtsnabb" ; -- blixtsnabb..av.1
  blixtsnabbhet_1_N = mkN "blixtsnabbhet" ; -- blixtsnabbhet..nn.1
  blixtutryckning_1_N = mkN "blixtutryckning" ; -- blixtutryckning..nn.1
  blixtvisit_1_N = mkN "blixtvisit" "blixtvisiter" ; -- blixtvisit..nn.1
  block_1_N = mkN "block" neutrum  ; -- block..nn.1
  blocka_1_V = mkV "blockar" ; -- blocka..vb.1
  blockad_1_N = mkN "blockad" "blockader" ; -- blockad..nn.1
  blockadbrott_1_N = mkN "blockadbrott" neutrum  ; -- blockadbrott..nn.1
  blockadbrytare_1_N = mkN "blockadbrytare" utrum  ; -- blockadbrytare..nn.1
  blockalmanack_1_N = mkN "blockalmanack" "blockalmanacker" ; -- blockalmanack..nn.1
  blockalmanacka_1_N = mkN "blockalmanacka" ; -- blockalmanacka..nn.1
  blockande_1_N = mkN "blockande" ; -- blockande..nn.1
  blockbildning_1_N = mkN "blockbildning" ; -- blockbildning..nn.1
  blockchoklad_1_N = mkN "blockchoklad" ; -- blockchoklad..nn.1
  blockdiagram_1_N = mkN "blockdiagram" "blockdiagrammet" "blockdiagram" "blockdiagrammen" ; -- blockdiagram..nn.1
  blockera_1_V = mkV "blockerar" ; -- blockera..vb.1
  blockerande_1_N = mkN "blockerande" ; -- blockerande..nn.1
  blockerbar_1_A = mkA "blockerbar" ; -- blockerbar..av.1
  blockerbarhet_1_N = mkN "blockerbarhet" ; -- blockerbarhet..nn.1
  blockering_1_N = mkN "blockering" ; -- blockering..nn.1
  blockflöjt_1_N = mkN "blockflöjt" "blockflöjter" ; -- blockflöjt..nn.1
  blockgräns_1_N = mkN "blockgräns" "blockgränser" ; -- blockgräns..nn.1
  blockhus_1_N = mkN "blockhus" neutrum  ; -- blockhus..nn.1
  blockig_1_A = mkA "blockig" ; -- blockig..av.1
  blockighet_1_N = mkN "blockighet" ; -- blockighet..nn.1
  blockmark_1_N = mkN "blockmark" ; -- blockmark..nn.1
  blockpolitik_1_N = mkN "blockpolitik" ; -- blockpolitik..nn.1
  blockpolitisk_1_A = mkA "blockpolitisk" ; -- blockpolitisk..av.1
  blocksignal_1_N = mkN "blocksignal" "blocksignaler" ; -- blocksignal..nn.1
  blockskiva_1_N = mkN "blockskiva" ; -- blockskiva..nn.1
  blocksystem_1_N = mkN "blocksystem" neutrum  ; -- blocksystem..nn.1
  blocktalja_1_N = mkN "blocktalja" ; -- blocktalja..nn.1
  blocktrissa_1_N = mkN "blocktrissa" ; -- blocktrissa..nn.1
  blocktyg_1_N = mkN "blocktyg" neutrum  ; -- blocktyg..nn.1
  blocktänkande_1_N = mkN "blocktänkande" ; -- blocktänkande..nn.1
  blockvagn_1_N = mkN "blockvagn" ; -- blockvagn..nn.1
  blockämne_1_N = mkN "blockämne" ; -- blockämne..nn.1
  blocköverskridande_1_A = mkA "blocköverskridande" ; -- blocköverskridande..av.1
  blod_hjärnbarriär_1_N = mkN "blod-hjärnbarriär" "blod-hjärnbarriärer" ; -- blod-hjärnbarriär..nn.1
  blod_1_N = mkN "blod" ; -- blod..nn.1
  bloda_1_V = mkV "blodar" ; -- bloda..vb.1
  blodande_1_N = mkN "blodande" ; -- blodande..nn.1
  blodapelsin_1_N = mkN "blodapelsin" "blodapelsiner" ; -- blodapelsin..nn.1
  blodbad_1_N = mkN "blodbad" neutrum  ; -- blodbad..nn.1
  blodbank_1_N = mkN "blodbank" "blodbanker" ; -- blodbank..nn.1
  blodbefläckad_1_A = mkA "blodbefläckad" ; -- blodbefläckad..av.1
  blodbestänkt_1_A = mkA "blodbestänkt" "blodbestänkt" ; -- blodbestänkt..av.1
  blodbesudlad_1_A = mkA "blodbesudlad" ; -- blodbesudlad..av.1
  blodblåsa_1_N = mkN "blodblåsa" ; -- blodblåsa..nn.1
  blodbok_1_N = mkN "blodbok" ; -- blodbok..nn.1
  blodbrist_1_N = mkN "blodbrist" ; -- blodbrist..nn.1
  blodcancer_1_N = mkN "blodcancer" ; -- blodcancer..nn.1
  blodcell_1_N = mkN "blodcell" "blodceller" ; -- blodcell..nn.1
  blodcirkulation_1_N = mkN "blodcirkulation" ; -- blodcirkulation..nn.1
  bloddoping_1_N = mkN "bloddoping" ; -- bloddoping..nn.1
  bloddrypande_1_A = mkA "bloddrypande" ; -- bloddrypande..av.1
  bloddränkt_1_A = mkA "bloddränkt" "bloddränkt" ; -- bloddränkt..av.1
  blodfattig_1_A = mkA "blodfattig" ; -- blodfattig..av.1
  blodfattighet_1_N = mkN "blodfattighet" ; -- blodfattighet..nn.1
  blodfläck_1_N = mkN "blodfläck" ; -- blodfläck..nn.1
  blodflöde_1_N = mkN "blodflöde" ; -- blodflöde..nn.1
  blodfull_1_A = mkA "blodfull" ; -- blodfull..av.1
  blodfullhet_1_N = mkN "blodfullhet" ; -- blodfullhet..nn.1
  blodfyllning_1_N = mkN "blodfyllning" ; -- blodfyllning..nn.1
  blodfärgämne_1_N = mkN "blodfärgämne" ; -- blodfärgämne..nn.1
  blodförgiftning_1_N = mkN "blodförgiftning" ; -- blodförgiftning..nn.1
  blodförlust_1_N = mkN "blodförlust" ; -- blodförlust..nn.1
  blodförtunnande_1_A = mkA "blodförtunnande" ; -- blodförtunnande..av.1
  blodgenomströmning_1_N = mkN "blodgenomströmning" ; -- blodgenomströmning..nn.1
  blodgivarcentral_1_N = mkN "blodgivarcentral" "blodgivarcentraler" ; -- blodgivarcentral..nn.1
  blodgivare_1_N = mkN "blodgivare" utrum  ; -- blodgivare..nn.1
  blodgivning_1_N = mkN "blodgivning" ; -- blodgivning..nn.1
  blodgrape_1_N = mkN "blodgrape" utrum  ; -- blodgrape..nn.1
  blodgrupp_1_N = mkN "blodgrupp" "blodgrupper" ; -- blodgrupp..nn.1
  blodgång_1_N = mkN "blodgång" ; -- blodgång..nn.1
  blodhosta_1_N = mkN "blodhosta" ; -- blodhosta..nn.1
  blodhostning_1_N = mkN "blodhostning" ; -- blodhostning..nn.1
  blodhund_1_N = mkN "blodhund" ; -- blodhund..nn.1
  blodig_1_A = mkA "blodig" ; -- blodig..av.1
  blodigel_1_N = mkN "blodigel" ; -- blodigel..nn.1
  blodighet_1_N = mkN "blodighet" "blodigheter" ; -- blodighet..nn.1
  blodisande_1_A = mkA "blodisande" ; -- blodisande..av.1
  blodkorv_1_N = mkN "blodkorv" ; -- blodkorv..nn.1
  blodkropp_1_N = mkN "blodkropp" ; -- blodkropp..nn.1
  blodkräfta_1_N = mkN "blodkräfta" ; -- blodkräfta..nn.1
  blodkräkning_1_N = mkN "blodkräkning" ; -- blodkräkning..nn.1
  blodkärl_1_N = mkN "blodkärl" neutrum  ; -- blodkärl..nn.1
  blodkärlsbråck_1_N = mkN "blodkärlsbråck" neutrum  ; -- blodkärlsbråck..nn.1
  blodledare_1_N = mkN "blodledare" utrum  ; -- blodledare..nn.1
  blodlever_1_N = mkN "blodlever" ; -- blodlever..nn.1
  blodlutsalt_1_N = mkN "blodlutsalt" neutrum  ; -- blodlutsalt..nn.1
  blodlutssalt_1_N = mkN "blodlutssalt" neutrum  ; -- blodlutssalt..nn.1
  blodlönn_1_N = mkN "blodlönn" ; -- blodlönn..nn.1
  blodlös_1_A = mkA "blodlös" ; -- blodlös..av.1
  blodlöshet_1_N = mkN "blodlöshet" ; -- blodlöshet..nn.1
  blodmat_1_N = mkN "blodmat" ; -- blodmat..nn.1
  blodnäva_1_N = mkN "blodnäva" ; -- blodnäva..nn.1
  blodomlopp_1_N = mkN "blodomlopp" neutrum  ; -- blodomlopp..nn.1
  blodpalt_1_N = mkN "blodpalt" ; -- blodpalt..nn.1
  blodplasma_1_N = mkN "blodplasma" ; -- blodplasma..nn.1
  blodplätt_1_N = mkN "blodplätt" ; -- blodplätt..nn.1
  blodpropp_1_N = mkN "blodpropp" ; -- blodpropp..nn.1
  blodprotein_1_N = mkN "blodprotein" "blodproteinet" "blodproteiner" "blodproteinerna" ; -- blodprotein..nn.1
  blodprov_1_N = mkN "blodprov" neutrum  ; -- blodprov..nn.1
  blodprovstagning_1_N = mkN "blodprovstagning" ; -- blodprovstagning..nn.1
  blodpudding_1_N = mkN "blodpudding" ; -- blodpudding..nn.1
  blodpuddingsbit_1_N = mkN "blodpuddingsbit" ; -- blodpuddingsbit..nn.1
  blodpump_1_N = mkN "blodpump" ; -- blodpump..nn.1
  blodpöl_1_N = mkN "blodpöl" ; -- blodpöl..nn.1
  blodrand_1_N = mkN "blodrand" "blodränder" ; -- blodrand..nn.1
  blodregn_1_N = mkN "blodregn" neutrum  ; -- blodregn..nn.1
  blodriska_1_N = mkN "blodriska" ; -- blodriska..nn.1
  blodrot_1_N = mkN "blodrot" ; -- blodrot..nn.1
  blodröd_1_A = mkA "blodröd" "blodrött" ; -- blodröd..av.1
  blodsband_1_N = mkN "blodsband" neutrum  ; -- blodsband..nn.1
  blodsdiamant_1_N = mkN "blodsdiamant" "blodsdiamanter" ; -- blodsdiamant..nn.1
  blodsdrama_1_N = mkN "blodsdrama" "blodsdramat" "blodsdramer" "blodsdramerna" ; -- blodsdrama..nn.1
  blodsdroppe_1_N = mkN "blodsdroppe" utrum  ; -- blodsdroppe..nn.1
  blodsdåd_1_N = mkN "blodsdåd" neutrum  ; -- blodsdåd..nn.1
  blodserum_1_N = mkN "blodserum" neutrum  ; -- blodserum..nn.1
  blodshämnare_1_N = mkN "blodshämnare" utrum  ; -- blodshämnare..nn.1
  blodshämnd_1_N = mkN "blodshämnd" ; -- blodshämnd..nn.1
  blodsjukdom_1_N = mkN "blodsjukdom" ; -- blodsjukdom..nn.1
  blodsmak_1_N = mkN "blodsmak" ; -- blodsmak..nn.1
  blodsmystik_1_N = mkN "blodsmystik" ; -- blodsmystik..nn.1
  blodsocker_1_N = mkN "blodsocker" neutrum  ; -- blodsocker..nn.1
  blodsockersvacka_1_N = mkN "blodsockersvacka" ; -- blodsockersvacka..nn.1
  blodspenning_1_N = mkN "blodspenning" ; -- blodspenning..nn.1
  blodspottning_1_N = mkN "blodspottning" ; -- blodspottning..nn.1
  blodsprängd_1_A = mkA "blodsprängd" "blodsprängt" ; -- blodsprängd..av.1
  blodsprängdhet_1_N = mkN "blodsprängdhet" ; -- blodsprängdhet..nn.1
  blodspår_1_N = mkN "blodspår" neutrum  ; -- blodspår..nn.1
  blodstallning_1_N = mkN "blodstallning" ; -- blodstallning..nn.1
  blodstensmalm_1_N = mkN "blodstensmalm" ; -- blodstensmalm..nn.1
  blodstillande_1_A = mkA "blodstillande" ; -- blodstillande..av.1
  blodstillning_1_N = mkN "blodstillning" ; -- blodstillning..nn.1
  blodstinn_1_A = mkA "blodstinn" "blodstint" ; -- blodstinn..av.1
  blodstinnhet_1_N = mkN "blodstinnhet" ; -- blodstinnhet..nn.1
  blodstockning_1_N = mkN "blodstockning" ; -- blodstockning..nn.1
  blodstänkt_1_A = mkA "blodstänkt" "blodstänkt" ; -- blodstänkt..av.1
  blodstörtning_1_N = mkN "blodstörtning" ; -- blodstörtning..nn.1
  blodsugande_1_A = mkA "blodsugande" ; -- blodsugande..av.1
  blodsugare_1_N = mkN "blodsugare" utrum  ; -- blodsugare..nn.1
  blodsugeri_1_N = mkN "blodsugeri" neutrum  ; -- blodsugeri..nn.1
  blodsutgjutelse_1_N = mkN "blodsutgjutelse" "blodsutgjutelser" ; -- blodsutgjutelse..nn.1
  blodsvettning_1_N = mkN "blodsvettning" ; -- blodsvettning..nn.1
  blodsvulst_1_N = mkN "blodsvulst" "blodsvulster" ; -- blodsvulst..nn.1
  blodsystem_1_N = mkN "blodsystem" neutrum  ; -- blodsystem..nn.1
  blodsänka_1_N = mkN "blodsänka" ; -- blodsänka..nn.1
  blodtappning_1_N = mkN "blodtappning" ; -- blodtappning..nn.1
  blodtransfusion_1_N = mkN "blodtransfusion" ; -- blodtransfusion..nn.1
  blodtryck_1_N = mkN "blodtryck" neutrum  ; -- blodtryck..nn.1
  blodtryckshöjande_1_A = mkA "blodtryckshöjande" ; -- blodtryckshöjande..av.1
  blodtryckshöjning_1_N = mkN "blodtryckshöjning" ; -- blodtryckshöjning..nn.1
  blodtryckssänkande_1_A = mkA "blodtryckssänkande" ; -- blodtryckssänkande..av.1
  blodtryckssänkning_1_N = mkN "blodtryckssänkning" ; -- blodtryckssänkning..nn.1
  blodtyp_1_N = mkN "blodtyp" "blodtyper" ; -- blodtyp..nn.1
  blodtörst_1_N = mkN "blodtörst" ; -- blodtörst..nn.1
  blodtörstig_1_A = mkA "blodtörstig" ; -- blodtörstig..av.1
  blodtörstighet_1_N = mkN "blodtörstighet" ; -- blodtörstighet..nn.1
  blodutgjutning_1_N = mkN "blodutgjutning" ; -- blodutgjutning..nn.1
  blodvallning_1_N = mkN "blodvallning" ; -- blodvallning..nn.1
  blodvite_1_N = mkN "blodvite" ; -- blodvite..nn.1
  blodvittring_1_N = mkN "blodvittring" ; -- blodvittring..nn.1
  blodvärde_1_N = mkN "blodvärde" ; -- blodvärde..nn.1
  blodvätska_1_N = mkN "blodvätska" ; -- blodvätska..nn.1
  blodvåg_1_N = mkN "blodvåg" "blodvågor" ; -- blodvåg..nn.1
  blodåder_1_N = mkN "blodådra" ; -- blodåder..nn.1
  blodöverfyllnad_1_N = mkN "blodöverfyllnad" "blodöverfyllnader" ; -- blodöverfyllnad..nn.1
  blodöverföring_1_N = mkN "blodöverföring" ; -- blodöverföring..nn.1
  blog_1_N = mkN "blog" ; -- blog..nn.1
  bloga_1_V = mkV "blogar" ; -- bloga..vb.1
  blogande_1_N = mkN "blogande" ; -- blogande..nn.1
  blogare_1_N = mkN "blogare" utrum  ; -- blogare..nn.1
  blogg_1_N = mkN "blogg" ; -- blogg..nn.1
  blogga_1_V = mkV "bloggar" ; -- blogga..vb.1
  bloggande_1_N = mkN "bloggande" ; -- bloggande..nn.1
  bloggare_1_N = mkN "bloggare" utrum  ; -- bloggare..nn.1
  bloggerska_1_N = mkN "bloggerska" ; -- bloggerska..nn.1
  blogginlägg_1_N = mkN "blogginlägg" neutrum  ; -- blogginlägg..nn.1
  bloggosfär_1_N = mkN "bloggosfär" "bloggosfärer" ; -- bloggosfär..nn.1
  bloginlägg_1_N = mkN "bloginlägg" neutrum  ; -- bloginlägg..nn.1
  blogosfär_1_N = mkN "blogosfär" "blogosfärer" ; -- blogosfär..nn.1
  blomaxel_1_N = mkN "blomaxel" ; -- blomaxel..nn.1
  blombefruktning_1_N = mkN "blombefruktning" ; -- blombefruktning..nn.1
  blomblad_1_N = mkN "blomblad" neutrum  ; -- blomblad..nn.1
  blombord_1_N = mkN "blombord" neutrum  ; -- blombord..nn.1
  blombotten_1_N = mkN "blombotten" ; -- blombotten..nn.1
  blombukett_1_N = mkN "blombukett" "blombuketter" ; -- blombukett..nn.1
  blomdoft_1_N = mkN "blomdoft" "blomdofter" ; -- blomdoft..nn.1
  blomfat_1_N = mkN "blomfat" neutrum  ; -- blomfat..nn.1
  blomfjäll_1_N = mkN "blomfjäll" neutrum  ; -- blomfjäll..nn.1
  blomflock_1_N = mkN "blomflock" ; -- blomflock..nn.1
  blomfoder_1_N = mkN "blomfoder" neutrum  ; -- blomfoder..nn.1
  blomform_1_N = mkN "blomform" "blomformer" ; -- blomform..nn.1
  blomfäste_1_N = mkN "blomfäste" ; -- blomfäste..nn.1
  blomholk_1_N = mkN "blomholk" ; -- blomholk..nn.1
  blomhuvud_1_N = mkN "blomhuvud" "blomhuvudet" "blomhuvud" "blomhuvudena" ; -- blomhuvud..nn.1
  blomhylle_1_N = mkN "blomhylle" ; -- blomhylle..nn.1
  blomhänge_1_N = mkN "blomhänge" ; -- blomhänge..nn.1
  blomhölster_1_N = mkN "blomhölster" neutrum  ; -- blomhölster..nn.1
  blomjord_1_N = mkN "blomjord" ; -- blomjord..nn.1
  blomkalk_1_N = mkN "blomkalk" ; -- blomkalk..nn.1
  blomklase_1_N = mkN "blomklase" utrum  ; -- blomklase..nn.1
  blomklädd_1_A = mkA "blomklädd" ; -- blomklädd..av.1
  blomknippe_1_N = mkN "blomknippe" ; -- blomknippe..nn.1
  blomknopp_1_N = mkN "blomknopp" ; -- blomknopp..nn.1
  blomkolv_1_N = mkN "blomkolv" ; -- blomkolv..nn.1
  blomkorg_1_N = mkN "blomkorg" ; -- blomkorg..nn.1
  blomkrans_1_N = mkN "blomkrans" ; -- blomkrans..nn.1
  blomkrona_1_N = mkN "blomkrona" ; -- blomkrona..nn.1
  blomkruka_1_N = mkN "blomkruka" ; -- blomkruka..nn.1
  blomkvast_1_N = mkN "blomkvast" ; -- blomkvast..nn.1
  blomkäpp_1_N = mkN "blomkäpp" ; -- blomkäpp..nn.1
  blomkål_1_N = mkN "blomkål" ; -- blomkål..nn.1
  blomkålshuvud_1_N = mkN "blomkålshuvud" "blomkålshuvudet" "blomkålshuvud" "blomkålshuvudena" ; -- blomkålshuvud..nn.1
  blomkålssvamp_1_N = mkN "blomkålssvamp" ; -- blomkålssvamp..nn.1
  blomkålsöra_1_N = mkN "blomkålsöra" "blomkålsörat" "blomkålsöron" "blomkålsöronen" ; -- blomkålsöra..nn.1
  blomlåda_1_N = mkN "blomlåda" ; -- blomlåda..nn.1
  blomma_1_N = mkN "blomma" ; -- blomma..nn.1
  blomma_1_V = mkV "blommar" ; -- blomma..vb.1
  blommande_1_N = mkN "blommande" ; -- blommande..nn.1
  blommerad_1_A = mkA "blommerad" ; -- blommerad..av.1
  blommig_1_A = mkA "blommig" ; -- blommig..av.1
  blommighet_1_N = mkN "blommighet" "blommigheter" ; -- blommighet..nn.1
  blommografera_1_V = mkV "blommograferar" ; -- blommografera..vb.1
  blommograferande_1_N = mkN "blommograferande" ; -- blommograferande..nn.1
  blommograferbar_1_A = mkA "blommograferbar" ; -- blommograferbar..av.1
  blommograferbarhet_1_N = mkN "blommograferbarhet" ; -- blommograferbarhet..nn.1
  blommografering_1_N = mkN "blommografering" ; -- blommografering..nn.1
  blommogram_1_N = mkN "blommogram" "blommogrammet" "blommogram" "blommogrammen" ; -- blommogram..nn.1
  blommönster_1_N = mkN "blommönster" neutrum  ; -- blommönster..nn.1
  blomning_1_N = mkN "blomning" ; -- blomning..nn.1
  blomningstid_1_N = mkN "blomningstid" "blomningstider" ; -- blomningstid..nn.1
  blomplanta_1_N = mkN "blomplanta" ; -- blomplanta..nn.1
  blomskaft_1_N = mkN "blomskaft" neutrum  ; -- blomskaft..nn.1
  blomst_1_N = mkN "blomst" ; -- blomst..nn.1
  blomster_1_N = mkN "blomster" neutrum  ; -- blomster..nn.1
  blomsteraffär_1_N = mkN "blomsteraffär" "blomsteraffärer" ; -- blomsteraffär..nn.1
  blomsterbord_1_N = mkN "blomsterbord" neutrum  ; -- blomsterbord..nn.1
  blomsterbädd_1_N = mkN "blomsterbädd" ; -- blomsterbädd..nn.1
  blomsterdoft_1_N = mkN "blomsterdoft" "blomsterdofter" ; -- blomsterdoft..nn.1
  blomsterdoftande_1_A = mkA "blomsterdoftande" ; -- blomsterdoftande..av.1
  blomsterflicka_1_N = mkN "blomsterflicka" ; -- blomsterflicka..nn.1
  blomsterförmedling_1_N = mkN "blomsterförmedling" ; -- blomsterförmedling..nn.1
  blomsterförsäljerska_1_N = mkN "blomsterförsäljerska" ; -- blomsterförsäljerska..nn.1
  blomstergirland_1_N = mkN "blomstergirland" "blomstergirlander" ; -- blomstergirland..nn.1
  blomstergård_1_N = mkN "blomstergård" ; -- blomstergård..nn.1
  blomsterhandel_1_N = mkN "blomsterhandel" ; -- blomsterhandel..nn.1
  blomsterhandlare_1_N = mkN "blomsterhandlare" utrum  ; -- blomsterhandlare..nn.1
  blomsterhonung_1_N = mkN "blomsterhonung" ; -- blomsterhonung..nn.1
  blomsterklädd_1_A = mkA "blomsterklädd" ; -- blomsterklädd..av.1
  blomsterkrans_1_N = mkN "blomsterkrans" ; -- blomsterkrans..nn.1
  blomsterkransa_1_V = mkV "blomsterkransar" ; -- blomsterkransa..vb.1
  blomsterkvast_1_N = mkN "blomsterkvast" ; -- blomsterkvast..nn.1
  blomsterlåda_1_N = mkN "blomsterlåda" ; -- blomsterlåda..nn.1
  blomsterlök_1_N = mkN "blomsterlök" ; -- blomsterlök..nn.1
  blomstermålare_1_N = mkN "blomstermålare" utrum  ; -- blomstermålare..nn.1
  blomstermånad_1_N = mkN "blomstermånad" "blomstermånader" ; -- blomstermånad..nn.1
  blomsterodling_1_N = mkN "blomsterodling" ; -- blomsterodling..nn.1
  blomsterprakt_1_N = mkN "blomsterprakt" ; -- blomsterprakt..nn.1
  blomsterrabatt_1_N = mkN "blomsterrabatt" "blomsterrabatter" ; -- blomsterrabatt..nn.1
  blomstersmycka_1_V = mkV "blomstersmyckar" ; -- blomstersmycka..vb.1
  blomsterspruta_1_N = mkN "blomsterspruta" ; -- blomsterspruta..nn.1
  blomsterspråk_1_N = mkN "blomsterspråk" neutrum  ; -- blomsterspråk..nn.1
  blomstertid_1_N = mkN "blomstertid" "blomstertider" ; -- blomstertid..nn.1
  blomsterträdgård_1_N = mkN "blomsterträdgård" ; -- blomsterträdgård..nn.1
  blomsteruppsats_1_N = mkN "blomsteruppsats" "blomsteruppsatser" ; -- blomsteruppsats..nn.1
  blomstervas_1_N = mkN "blomstervas" "blomstervaser" ; -- blomstervas..nn.1
  blomsteräng_1_N = mkN "blomsteräng" ; -- blomsteräng..nn.1
  blomstjälk_1_N = mkN "blomstjälk" ; -- blomstjälk..nn.1
  blomstoft_1_N = mkN "blomstoft" neutrum  ; -- blomstoft..nn.1
  blomstra_1_V = mkV "blomstrar" ; -- blomstra..vb.1
  blomstrande_1_N = mkN "blomstrande" ; -- blomstrande..nn.1
  blomstring_1_N = mkN "blomstring" ; -- blomstring..nn.1
  blomstringsperiod_1_N = mkN "blomstringsperiod" "blomstringsperioder" ; -- blomstringsperiod..nn.1
  blomstringstid_1_N = mkN "blomstringstid" "blomstringstider" ; -- blomstringstid..nn.1
  blomställ_1_N = mkN "blomställ" neutrum  ; -- blomställ..nn.1
  blomställning_1_N = mkN "blomställning" ; -- blomställning..nn.1
  blomtjuv_1_N = mkN "blomtjuv" ; -- blomtjuv..nn.1
  blomvas_1_N = mkN "blomvas" "blomvaser" ; -- blomvas..nn.1
  blomvass_1_N = mkN "blomvass" ; -- blomvass..nn.1
  blomväxt_1_N = mkN "blomväxt" "blomväxter" ; -- blomväxt..nn.1
  blond_1_A = mkA "blond" ; -- blond..av.1
  blond_1_N = mkN "blond" "blonder" ; -- blond..nn.1
  blondera_1_V = mkV "blonderar" ; -- blondera..vb.1
  blonderande_1_N = mkN "blonderande" ; -- blonderande..nn.1
  blonderbar_1_A = mkA "blonderbar" ; -- blonderbar..av.1
  blonderbarhet_1_N = mkN "blonderbarhet" ; -- blonderbarhet..nn.1
  blondering_1_N = mkN "blondering" ; -- blondering..nn.1
  blondhet_1_N = mkN "blondhet" ; -- blondhet..nn.1
  blondin_1_N = mkN "blondin" "blondiner" ; -- blondin..nn.1
  bloss_1_N = mkN "bloss" neutrum  ; -- bloss..nn.1
  blossa_1_V = mkV "blossar" ; -- blossa..vb.1
  blossande_1_N = mkN "blossande" ; -- blossande..nn.1
  blot_1_N = mkN "blot" neutrum  ; -- blot..nn.1
  blota_1_V = mkV "blotar" ; -- blota..vb.1
  blotande_1_N = mkN "blotande" ; -- blotande..nn.1
  blott_1_A = mkA "blott" ; -- blott..av.1
  blotta_1_N = mkN "blotta" ; -- blotta..nn.1
  blotta_1_V = mkV "blottar" ; -- blotta..vb.1
  blottande_1_N = mkN "blottande" ; -- blottande..nn.1
  blottare_1_N = mkN "blottare" utrum  ; -- blottare..nn.1
  blottlägga_1_V = mkV "blottlägga" "blottla" "blottlagt" ; -- blottlägga..vb.1
  blottläggande_1_N = mkN "blottläggande" ; -- blottläggande..nn.1
  blottläggning_1_N = mkN "blottläggning" ; -- blottläggning..nn.1
  blottställa_1_V = mkV "blottställer" ; -- blottställa..vb.1
  blottställande_1_N = mkN "blottställande" ; -- blottställande..nn.1
  blottställd_1_A = mkA "blottställd" "blottställt" ; -- blottställd..av.1
  blottställdhet_1_N = mkN "blottställdhet" ; -- blottställdhet..nn.1
  blottställning_1_N = mkN "blottställning" ; -- blottställning..nn.1
  blowout_1_N = mkN "blowout" "blowouter" ; -- blowout..nn.1
  bludder_1_N = mkN "bludder" neutrum  ; -- bludder..nn.1
  bluddra_1_V = mkV "bluddrar" ; -- bluddra..vb.1
  bluddrande_1_N = mkN "bluddrande" ; -- bluddrande..nn.1
  blues_1_N = mkN "blues" ; -- blues..nn.1
  bluff_1_N = mkN "bluff" ; -- bluff..nn.1
  bluffa_1_V = mkV "bluffar" ; -- bluffa..vb.1
  bluffaktura_1_N = mkN "bluffaktura" ; -- bluffaktura..nn.1
  bluffande_1_N = mkN "bluffande" ; -- bluffande..nn.1
  bluffbygge_1_N = mkN "bluffbygge" ; -- bluffbygge..nn.1
  bluffmakare_1_N = mkN "bluffmakare" utrum  ; -- bluffmakare..nn.1
  bluffpiller_1_N = mkN "bluffpiller" neutrum  ; -- bluffpiller..nn.1
  bluffprojekt_1_N = mkN "bluffprojekt" neutrum  ; -- bluffprojekt..nn.1
  blund_1_N = mkN "blund" ; -- blund..nn.1
  blunda_1_V = mkV "blundar" ; -- blunda..vb.1
  blundande_1_N = mkN "blundande" ; -- blundande..nn.1
  blunddocka_1_N = mkN "blunddocka" ; -- blunddocka..nn.1
  blunder_1_N = mkN "blunder" ; -- blunder..nn.1
  blus_1_N = mkN "blus" ; -- blus..nn.1
  blusliv_1_N = mkN "blusliv" neutrum  ; -- blusliv..nn.1
  bly_1_N = mkN "bly" neutrum  ; -- bly..nn.1
  blya_1_V = mkV "blyar" ; -- blya..vb.1
  blyacetat_1_N = mkN "blyacetat" neutrum  ; -- blyacetat..nn.1
  blyackumulator_1_N = mkN "blyackumulator" "blyackumulatorer" ; -- blyackumulator..nn.1
  blyaktig_1_A = mkA "blyaktig" ; -- blyaktig..av.1
  blyande_1_N = mkN "blyande" ; -- blyande..nn.1
  blyaska_1_N = mkN "blyaska" ; -- blyaska..nn.1
  blyazid_1_N = mkN "blyazid" "blyazider" ; -- blyazid..nn.1
  blybatteri_1_N = mkN "blybatteri" "blybatteriet" "blybatterier" "blybatterierna" ; -- blybatteri..nn.1
  blyblomma_1_N = mkN "blyblomma" ; -- blyblomma..nn.1
  blydagg_1_N = mkN "blydagg" ; -- blydagg..nn.1
  blyerts_1_N = mkN "blyerts" ; -- blyerts..nn.1
  blyertsgrå_1_A = mkA "blyertsgrå" "blyertsgrått" ; -- blyertsgrå..av.1
  blyertspenna_1_N = mkN "blyertspenna" ; -- blyertspenna..nn.1
  blyfolie_1_N = mkN "blyfolie" "blyfolier" ; -- blyfolie..nn.1
  blyfri_1_A = mkA "blyfri" "blyfritt" ; -- blyfri..av.1
  blyfärg_1_N = mkN "blyfärg" "blyfärger" ; -- blyfärg..nn.1
  blyfärgad_1_A = mkA "blyfärgad" ; -- blyfärgad..av.1
  blyförening_1_N = mkN "blyförening" ; -- blyförening..nn.1
  blyförgiftad_1_A = mkA "blyförgiftad" ; -- blyförgiftad..av.1
  blyförgiftning_1_N = mkN "blyförgiftning" ; -- blyförgiftning..nn.1
  blyg_1_A = mkA "blyg" ; -- blyg..av.1
  blygd_1_N = mkN "blygd" ; -- blygd..nn.1
  blygdben_1_N = mkN "blygdben" neutrum  ; -- blygdben..nn.1
  blygdhår_1_N = mkN "blygdhår" neutrum  ; -- blygdhår..nn.1
  blygdhår_2_N = mkN "blygdhår" neutrum  ; -- blygdhår..nn.2
  blygdläpp_1_N = mkN "blygdläpp" ; -- blygdläpp..nn.1
  blyghet_1_N = mkN "blyghet" "blygheter" ; -- blyghet..nn.1
  blyglans_1_N = mkN "blyglans" ; -- blyglans..nn.1
  blyglas_1_N = mkN "blyglas" neutrum  ; -- blyglas..nn.1
  blyglete_1_N = mkN "blyglete" ; -- blyglete..nn.1
  blygrå_1_A = mkA "blygrå" "blygrått" ; -- blygrå..av.1
  blygsam_1_A = mkA "blygsam" "blygsamt" "blygsamma" "blygsamma" "blygsammare" "blygsammast" "blygsammaste" ; -- blygsam..av.1
  blygsamhet_1_N = mkN "blygsamhet" "blygsamheter" ; -- blygsamhet..nn.1
  blygsel_1_N = mkN "blygsel" ; -- blygsel..nn.1
  blygult_1_N = mkN "blygult" ; -- blygult..nn.1
  blyhagel_1_N = mkN "blyhagel" neutrum  ; -- blyhagel..nn.1
  blyhalt_1_N = mkN "blyhalt" "blyhalter" ; -- blyhalt..nn.1
  blyhaltig_1_A = mkA "blyhaltig" ; -- blyhaltig..av.1
  blykula_1_N = mkN "blykula" ; -- blykula..nn.1
  blykyld_1_A = mkA "blykyld" "blykylt" ; -- blykyld..av.1
  blyköl_1_N = mkN "blyköl" ; -- blyköl..nn.1
  blylod_1_N = mkN "blylod" neutrum  ; -- blylod..nn.1
  blymantel_1_N = mkN "blymantel" ; -- blymantel..nn.1
  blymönja_1_N = mkN "blymönja" ; -- blymönja..nn.1
  blyoxid_1_N = mkN "blyoxid" "blyoxider" ; -- blyoxid..nn.1
  blyplåt_1_N = mkN "blyplåt" ; -- blyplåt..nn.1
  blysalva_1_N = mkN "blysalva" ; -- blysalva..nn.1
  blysocker_1_N = mkN "blysocker" neutrum  ; -- blysocker..nn.1
  blytetraetyl_1_N = mkN "blytetraetyl" ; -- blytetraetyl..nn.1
  blytung_1_A = mkA "blytung" ; -- blytung..av.1
  blytunghet_1_N = mkN "blytunghet" ; -- blytunghet..nn.1
  blytyngd_1_N = mkN "blytyngd" "blytyngder" ; -- blytyngd..nn.1
  blyvitt_1_N = mkN "blyvitt" ; -- blyvitt..nn.1
  blyättika_1_N = mkN "blyättika" ; -- blyättika..nn.1
  bläck_1_N = mkN "bläck" neutrum  ; -- bläck..nn.1
  bläcka_1_N = mkN "bläcka" ; -- bläcka..nn.1
  bläcka_1_V = mkV "bläckar" ; -- bläcka..vb.1
  bläckande_1_N = mkN "bläckande" ; -- bläckande..nn.1
  bläckblåsa_1_N = mkN "bläckblåsa" ; -- bläckblåsa..nn.1
  bläckfisk_1_N = mkN "bläckfisk" ; -- bläckfisk..nn.1
  bläckfläck_1_N = mkN "bläckfläck" ; -- bläckfläck..nn.1
  bläckhorn_1_N = mkN "bläckhorn" neutrum  ; -- bläckhorn..nn.1
  bläckig_1_A = mkA "bläckig" ; -- bläckig..av.1
  bläckkörtel_1_N = mkN "bläckkörtel" ; -- bläckkörtel..nn.1
  bläckpenna_1_N = mkN "bläckpenna" ; -- bläckpenna..nn.1
  bläckplump_1_N = mkN "bläckplump" ; -- bläckplump..nn.1
  bläckpulver_1_N = mkN "bläckpulver" neutrum  ; -- bläckpulver..nn.1
  bläcksuddare_1_N = mkN "bläcksuddare" utrum  ; -- bläcksuddare..nn.1
  bläcksvamp_1_N = mkN "bläcksvamp" ; -- bläcksvamp..nn.1
  bläcksvart_1_A = mkA "bläcksvart" "bläcksvart" ; -- bläcksvart..av.1
  bläcksäck_1_N = mkN "bläcksäck" ; -- bläcksäck..nn.1
  bläckteckning_1_N = mkN "bläckteckning" ; -- bläckteckning..nn.1
  bläda_1_V = mkV "blädar" ; -- bläda..vb.1
  blädande_1_N = mkN "blädande" ; -- blädande..nn.1
  blädderblock_1_N = mkN "blädderblock" neutrum  ; -- blädderblock..nn.1
  blädderbok_1_N = mkN "blädderbok" "blädderböcker" ; -- blädderbok..nn.1
  bläddra_1_N = mkN "bläddra" ; -- bläddra..nn.1
  bläddra_1_V = mkV "bläddrar" ; -- bläddra..vb.1
  bläddrande_1_N = mkN "bläddrande" ; -- bläddrande..nn.1
  blädning_1_N = mkN "blädning" ; -- blädning..nn.1
  blända_1_V = mkV "bländar" ; -- blända..vb.1
  bländande_1_A = mkA "bländande" ; -- bländande..av.1
  bländande_1_N = mkN "bländande" ; -- bländande..nn.1
  bländare_1_N = mkN "bländare" utrum  ; -- bländare..nn.1
  blände_1_N = mkN "blände" ; -- blände..nn.1
  bländfri_1_A = mkA "bländfri" "bländfritt" ; -- bländfri..av.1
  bländning_1_N = mkN "bländning" ; -- bländning..nn.1
  bländrisk_1_N = mkN "bländrisk" "bländrisker" ; -- bländrisk..nn.1
  bländskiva_1_N = mkN "bländskiva" ; -- bländskiva..nn.1
  bländskydd_1_N = mkN "bländskydd" neutrum  ; -- bländskydd..nn.1
  bländverk_1_N = mkN "bländverk" neutrum  ; -- bländverk..nn.1
  bländvit_1_A = mkA "bländvit" ; -- bländvit..av.1
  bläng_1_N = mkN "bläng" ; -- bläng..nn.1
  blänga_1_V = mkV "blänger" ; -- blänga..vb.1
  blängande_1_N = mkN "blängande" ; -- blängande..nn.1
  blängning_1_N = mkN "blängning" ; -- blängning..nn.1
  blänk_1_N = mkN "blänk" ; -- blänk..nn.1
  blänka_1_V = mkV "blänker" ; -- blänka..vb.1
  blänkande_1_N = mkN "blänkande" ; -- blänkande..nn.1
  blänkare_1_N = mkN "blänkare" utrum  ; -- blänkare..nn.1
  blänke_1_N = mkN "blänke" ; -- blänke..nn.1
  blänkfyr_1_N = mkN "blänkfyr" ; -- blänkfyr..nn.1
  blänkning_1_N = mkN "blänkning" ; -- blänkning..nn.1
  bläs_1_N = mkN "bläs" ; -- bläs..nn.1
  bläsand_1_N = mkN "bläsand" "bläsänder" ; -- bläsand..nn.1
  bläsbock_1_N = mkN "bläsbock" ; -- bläsbock..nn.1
  bläsgås_1_N = mkN "bläsgås" "bläsgåsen" "bläsgäss" "bläsgässen" ; -- bläsgås..nn.1
  blästa_1_V = mkV "blästar" ; -- blästa..vb.1
  blästande_1_N = mkN "blästande" ; -- blästande..nn.1
  bläster_1_N = mkN "bläster" ; -- bläster..nn.1
  blästerrör_1_N = mkN "blästerrör" neutrum  ; -- blästerrör..nn.1
  blästerugn_1_N = mkN "blästerugn" ; -- blästerugn..nn.1
  blästra_1_V = mkV "blästrar" ; -- blästra..vb.1
  blästrande_1_N = mkN "blästrande" ; -- blästrande..nn.1
  blå_1_A = mkA "blå" "blått" ; -- blå..av.1
  blåaktig_1_A = mkA "blåaktig" ; -- blåaktig..av.1
  blåaktighet_1_N = mkN "blåaktighet" ; -- blåaktighet..nn.1
  blåanlupen_1_A = mkA "blåanlupen" ; -- blåanlupen..av.1
  blåblodig_1_A = mkA "blåblodig" ; -- blåblodig..av.1
  blåblodighet_1_N = mkN "blåblodighet" ; -- blåblodighet..nn.1
  blåbyxa_1_N = mkN "blåbyxa" ; -- blåbyxa..nn.1
  blåbär_1_N = mkN "blåbär" neutrum  ; -- blåbär..nn.1
  blåbärsbuske_1_N = mkN "blåbärsbuske" utrum  ; -- blåbärsbuske..nn.1
  blåbärspannkaka_1_N = mkN "blåbärspannkaka" ; -- blåbärspannkaka..nn.1
  blåbärsplockare_1_N = mkN "blåbärsplockare" utrum  ; -- blåbärsplockare..nn.1
  blåbärsris_1_N = mkN "blåbärsris" neutrum  ; -- blåbärsris..nn.1
  blåbärssaft_1_N = mkN "blåbärssaft" "blåbärssafter" ; -- blåbärssaft..nn.1
  blåbärssoppa_1_N = mkN "blåbärssoppa" ; -- blåbärssoppa..nn.1
  blåbärssylt_1_N = mkN "blåbärssylt" "blåbärssylter" ; -- blåbärssylt..nn.1
  blåduva_1_N = mkN "blåduva" ; -- blåduva..nn.1
  blådåre_1_N = mkN "blådåre" utrum  ; -- blådåre..nn.1
  blåeld_1_N = mkN "blåeld" ; -- blåeld..nn.1
  blåelse_1_N = mkN "blåelse" utrum  ; -- blåelse..nn.1
  blåfrusen_1_A = mkA "blåfrusen" ; -- blåfrusen..av.1
  blåförskjutning_1_N = mkN "blåförskjutning" ; -- blåförskjutning..nn.1
  blågrå_1_A = mkA "blågrå" "blågrått" ; -- blågrå..av.1
  blågrön_1_A = mkA "blågrön" ; -- blågrön..av.1
  blågrönalg_1_N = mkN "blågrönalg" "blågrönalger" ; -- blågrönalg..nn.1
  blågul_1_A = mkA "blågul" ; -- blågul..av.1
  blåhaj_1_N = mkN "blåhaj" ; -- blåhaj..nn.1
  blåhake_1_N = mkN "blåhake" utrum  ; -- blåhake..nn.1
  blåhallon_1_N = mkN "blåhallon" neutrum  ; -- blåhallon..nn.1
  blåhet_1_N = mkN "blåhet" ; -- blåhet..nn.1
  blåhjon_1_N = mkN "blåhjon" neutrum  ; -- blåhjon..nn.1
  blåholts_1_N = mkN "blåholts" ; -- blåholts..nn.1
  blåis_1_N = mkN "blåis" ; -- blåis..nn.1
  blåjacka_1_N = mkN "blåjacka" ; -- blåjacka..nn.1
  blåjord_1_N = mkN "blåjord" ; -- blåjord..nn.1
  blåklint_1_N = mkN "blåklint" ; -- blåklint..nn.1
  blåklocka_1_N = mkN "blåklocka" ; -- blåklocka..nn.1
  blåklädd_1_A = mkA "blåklädd" ; -- blåklädd..av.1
  blåkopia_1_N = mkN "blåkopia" ; -- blåkopia..nn.1
  blåkopiera_1_V = mkV "blåkopierar" ; -- blåkopiera..vb.1
  blåkopierande_1_N = mkN "blåkopierande" ; -- blåkopierande..nn.1
  blåkopierbar_1_A = mkA "blåkopierbar" ; -- blåkopierbar..av.1
  blåkopierbarhet_1_N = mkN "blåkopierbarhet" ; -- blåkopierbarhet..nn.1
  blåkopiering_1_N = mkN "blåkopiering" ; -- blåkopiering..nn.1
  blåkråka_1_N = mkN "blåkråka" ; -- blåkråka..nn.1
  blåkullafärd_1_N = mkN "blåkullafärd" "blåkullafärder" ; -- blåkullafärd..nn.1
  blåkål_1_N = mkN "blåkål" ; -- blåkål..nn.1
  blåköra_1_V = mkV "blåköra" "blåkörde" "blåkört" ; -- blåköra..vb.1
  blåkörande_1_N = mkN "blåkörande" ; -- blåkörande..nn.1
  blålera_1_N = mkN "blålera" ; -- blålera..nn.1
  blålila_1_A = mkA "blålila" ; -- blålila..av.1
  blåljuga_1_V = mkV "blåljuga" "blåljög" "blåljugit" ; -- blåljuga..vb.1
  blåljus_1_N = mkN "blåljus" neutrum  ; -- blåljus..nn.1
  blålusern_1_N = mkN "blålusern" ; -- blålusern..nn.1
  blåmes_1_N = mkN "blåmes" ; -- blåmes..nn.1
  blåmusseron_1_N = mkN "blåmusseron" "blåmusseroner" ; -- blåmusseron..nn.1
  blåmussla_1_N = mkN "blåmussla" ; -- blåmussla..nn.1
  blåmärke_1_N = mkN "blåmärke" ; -- blåmärke..nn.1
  blåmålad_1_A = mkA "blåmålad" ; -- blåmålad..av.1
  blåmålning_1_N = mkN "blåmålning" ; -- blåmålning..nn.1
  blåna_1_V = mkV "blånar" ; -- blåna..vb.1
  blånad_1_N = mkN "blånad" "blånader" ; -- blånad..nn.1
  blånande_1_N = mkN "blånande" ; -- blånande..nn.1
  blåneka_1_V = mkV "blånekar" ; -- blåneka..vb.1
  blånekande_1_N = mkN "blånekande" ; -- blånekande..nn.1
  blåpenna_1_N = mkN "blåpenna" ; -- blåpenna..nn.1
  blåprickig_1_A = mkA "blåprickig" ; -- blåprickig..av.1
  blårandig_1_A = mkA "blårandig" ; -- blårandig..av.1
  blåregn_1_N = mkN "blåregn" neutrum  ; -- blåregn..nn.1
  blårutig_1_A = mkA "blårutig" ; -- blårutig..av.1
  blåräv_1_N = mkN "blåräv" ; -- blåräv..nn.1
  blåröd_1_A = mkA "blåröd" "blårött" ; -- blåröd..av.1
  blåsa_1_N = mkN "blåsa" ; -- blåsa..nn.1
  blåsa_1_V = mkV "blåser" ; -- blåsa..vb.1
  blåsa_2_V = mkV "blåser" ; -- blåsa..vb.2
  blåsande_1_N = mkN "blåsande" ; -- blåsande..nn.1
  blåsare_1_N = mkN "blåsare" utrum  ; -- blåsare..nn.1
  blåsbälg_1_N = mkN "blåsbälg" ; -- blåsbälg..nn.1
  blåsfoting_1_N = mkN "blåsfoting" ; -- blåsfoting..nn.1
  blåshals_1_N = mkN "blåshals" ; -- blåshals..nn.1
  blåshalskörtel_1_N = mkN "blåshalskörtel" ; -- blåshalskörtel..nn.1
  blåshål_1_N = mkN "blåshål" neutrum  ; -- blåshål..nn.1
  blåsig_1_A = mkA "blåsig" ; -- blåsig..av.1
  blåsinstrument_1_N = mkN "blåsinstrument" neutrum  ; -- blåsinstrument..nn.1
  blåsippa_1_N = mkN "blåsippa" ; -- blåsippa..nn.1
  blåsjuka_1_N = mkN "blåsjuka" ; -- blåsjuka..nn.1
  blåskatarr_1_N = mkN "blåskatarr" "blåskatarrer" ; -- blåskatarr..nn.1
  blåskimrande_1_A = mkA "blåskimrande" ; -- blåskimrande..av.1
  blåslagen_1_A = mkA "blåslagen" ; -- blåslagen..av.1
  blåslampa_1_N = mkN "blåslampa" ; -- blåslampa..nn.1
  blåsljud_1_N = mkN "blåsljud" neutrum  ; -- blåsljud..nn.1
  blåsmask_1_N = mkN "blåsmask" ; -- blåsmask..nn.1
  blåsning_1_N = mkN "blåsning" ; -- blåsning..nn.1
  blåsorkester_1_N = mkN "blåsorkester" ; -- blåsorkester..nn.1
  blåspistol_1_N = mkN "blåspistol" "blåspistoler" ; -- blåspistol..nn.1
  blåsprit_1_N = mkN "blåsprit" ; -- blåsprit..nn.1
  blåsrör_1_N = mkN "blåsrör" neutrum  ; -- blåsrör..nn.1
  blåssten_1_N = mkN "blåssten" "blåsstenen" "blåsstenar" "blåsstenarna" ; -- blåssten..nn.1
  blåst_1_A = mkA "blåst" "blåst" ; -- blåst..av.1
  blåst_1_N = mkN "blåst" ; -- blåst..nn.1
  blåsthet_1_N = mkN "blåsthet" ; -- blåsthet..nn.1
  blåstrumpa_1_N = mkN "blåstrumpa" ; -- blåstrumpa..nn.1
  blåställ_1_N = mkN "blåställ" neutrum  ; -- blåställ..nn.1
  blåstång_1_N = mkN "blåstång" ; -- blåstång..nn.1
  blåsur_1_A = mkA "blåsur" ; -- blåsur..av.1
  blåsurhet_1_N = mkN "blåsurhet" ; -- blåsurhet..nn.1
  blåsvart_1_A = mkA "blåsvart" "blåsvart" ; -- blåsvart..av.1
  blåsväder_1_N = mkN "blåsväder" neutrum  ; -- blåsväder..nn.1
  blåsyra_1_N = mkN "blåsyra" ; -- blåsyra..nn.1
  blåsört_1_N = mkN "blåsört" ; -- blåsört..nn.1
  blåtira_1_N = mkN "blåtira" ; -- blåtira..nn.1
  blåtonad_1_A = mkA "blåtonad" ; -- blåtonad..av.1
  blåträ_1_N = mkN "blåträ" neutrum  ; -- blåträ..nn.1
  blåtunga_1_N = mkN "blåtunga" ; -- blåtunga..nn.1
  blåtåtel_1_N = mkN "blåtåtel" ; -- blåtåtel..nn.1
  blåval_1_N = mkN "blåval" ; -- blåval..nn.1
  blåvarm_1_A = mkA "blåvarm" ; -- blåvarm..av.1
  blåved_1_N = mkN "blåved" ; -- blåved..nn.1
  blåvinge_1_N = mkN "blåvinge" utrum  ; -- blåvinge..nn.1
  blåviolett_1_A = mkA "blåviolett" ; -- blåviolett..av.1
  blåvit_1_A = mkA "blåvit" ; -- blåvit..av.1
  blåvitling_1_N = mkN "blåvitling" ; -- blåvitling..nn.1
  blåvärme_1_N = mkN "blåvärme" utrum  ; -- blåvärme..nn.1
  blåögd_1_A = mkA "blåögd" "blåögt" ; -- blåögd..av.1
  blåögdhet_1_N = mkN "blåögdhet" ; -- blåögdhet..nn.1
  blöda_1_V = mkV "blöda" "blödde" "blött" ; -- blöda..vb.1
  blödande_1_N = mkN "blödande" ; -- blödande..nn.1
  blödare_1_N = mkN "blödare" utrum  ; -- blödare..nn.1
  blödarsjuka_1_N = mkN "blödarsjuka" ; -- blödarsjuka..nn.1
  blödig_1_A = mkA "blödig" ; -- blödig..av.1
  blödighet_1_N = mkN "blödighet" "blödigheter" ; -- blödighet..nn.1
  blödning_1_N = mkN "blödning" ; -- blödning..nn.1
  blöja_1_N = mkN "blöja" ; -- blöja..nn.1
  blöjbyte_1_N = mkN "blöjbyte" ; -- blöjbyte..nn.1
  blöjålder_1_N = mkN "blöjålder" ; -- blöjålder..nn.1
  blöt_1_A = mkA "blöt" ; -- blöt..av.1
  blöta_1_N = mkN "blöta" ; -- blöta..nn.1
  blöta_1_V = mkV "blöter" ; -- blöta..vb.1
  blötande_1_N = mkN "blötande" ; -- blötande..nn.1
  blötdjur_1_N = mkN "blötdjur" neutrum  ; -- blötdjur..nn.1
  blötfoder_1_N = mkN "blötfoder" neutrum  ; -- blötfoder..nn.1
  blöthet_1_N = mkN "blöthet" ; -- blöthet..nn.1
  blötlägga_1_V = mkV "blötlägga" "blötla" "blötlagt" ; -- blötlägga..vb.1
  blötläggande_1_N = mkN "blötläggande" ; -- blötläggande..nn.1
  blötläggning_1_N = mkN "blötläggning" ; -- blötläggning..nn.1
  blötläggningsmedel_1_N = mkN "blötläggningsmedel" neutrum  ; -- blötläggningsmedel..nn.1
  blötna_1_V = mkV "blötnar" ; -- blötna..vb.1
  blötnande_1_N = mkN "blötnande" ; -- blötnande..nn.1
  blötning_1_N = mkN "blötning" ; -- blötning..nn.1
  blötröta_1_N = mkN "blötröta" ; -- blötröta..nn.1
  blötsnö_1_N = mkN "blötsnö" ; -- blötsnö..nn.1
  blötsvart_1_A = mkA "blötsvart" "blötsvart" ; -- blötsvart..av.1
  bo_1_N = mkN "bo" "boet" "bon" "bona" ; -- bo..nn.1
  bo_1_V = mkV "bor" ; -- bo..vb.1
  boa_1_N = mkN "boa" ; -- boa..nn.1
  boaorm_1_N = mkN "boaorm" ; -- boaorm..nn.1
  board_1_N = mkN "board" ; -- board..nn.1
  boardingcard_1_N = mkN "boardingcard" neutrum  ; -- boardingcard..nn.1
  boardingkort_1_N = mkN "boardingkort" neutrum  ; -- boardingkort..nn.1
  boasera_1_V = mkV "boaserar" ; -- boasera..vb.1
  boaserande_1_N = mkN "boaserande" ; -- boaserande..nn.1
  boaserbar_1_A = mkA "boaserbar" ; -- boaserbar..av.1
  boaserbarhet_1_N = mkN "boaserbarhet" ; -- boaserbarhet..nn.1
  boasering_1_N = mkN "boasering" ; -- boasering..nn.1
  bob_1_N = mkN "bob" ; -- bob..nn.1
  bobb_1_N = mkN "bobb" ; -- bobb..nn.1
  bobba_1_N = mkN "bobba" ; -- bobba..nn.1
  bobba_1_V = mkV "bobbar" ; -- bobba..vb.1
  bobbande_1_N = mkN "bobbande" ; -- bobbande..nn.1
  bobin_1_N = mkN "bobin" "bobiner" ; -- bobin..nn.1
  boboll_1_N = mkN "boboll" ; -- boboll..nn.1
  boboll_2_N = mkN "boboll" ; -- boboll..nn.2
  bobsleigh_1_N = mkN "bobsleigh" ; -- bobsleigh..nn.1
  boccia_1_N = mkN "boccia" ; -- boccia..nn.1
  bock_1_N = mkN "bock" ; -- bock..nn.1
  bocka_1_V = mkV "bockar" ; -- bocka..vb.1
  bockande_1_N = mkN "bockande" ; -- bockande..nn.1
  bockbent_1_A = mkA "bockbent" "bockbent" ; -- bockbent..av.1
  bockbenthet_1_N = mkN "bockbenthet" ; -- bockbenthet..nn.1
  bockblad_1_N = mkN "bockblad" neutrum  ; -- bockblad..nn.1
  bockbro_1_N = mkN "bockbro" ; -- bockbro..nn.1
  bockbränning_1_N = mkN "bockbränning" ; -- bockbränning..nn.1
  bockfot_1_N = mkN "bockfot" "bockfötter" ; -- bockfot..nn.1
  bockhorn_1_N = mkN "bockhorn" neutrum  ; -- bockhorn..nn.1
  bockhornsklöver_1_N = mkN "bockhornsklöver" ; -- bockhornsklöver..nn.1
  bockhornsklöverfrö_1_N = mkN "bockhornsklöverfrö" "bockhornsklöverfröet" "bockhornsklöverfrön" "bockhornsklöverfröna" ; -- bockhornsklöverfrö..nn.1
  bockning_1_N = mkN "bockning" ; -- bockning..nn.1
  bockprov_1_N = mkN "bockprov" neutrum  ; -- bockprov..nn.1
  bockskägg_1_N = mkN "bockskägg" neutrum  ; -- bockskägg..nn.1
  bocksprång_1_N = mkN "bocksprång" neutrum  ; -- bocksprång..nn.1
  bocktörne_1_N = mkN "bocktörne" ; -- bocktörne..nn.1
  bockverktyg_1_N = mkN "bockverktyg" neutrum  ; -- bockverktyg..nn.1
  bockvinkel_1_N = mkN "bockvinkel" ; -- bockvinkel..nn.1
  bocköl_1_N = mkN "bocköl" neutrum  ; -- bocköl..nn.1
  bod_1_N = mkN "bod" ; -- bod..nn.1
  bodbetjänt_1_N = mkN "bodbetjänt" "bodbetjänter" ; -- bodbetjänt..nn.1
  bodega_1_N = mkN "bodega" ; -- bodega..nn.1
  bodelning_1_N = mkN "bodelning" ; -- bodelning..nn.1
  bodknodd_1_N = mkN "bodknodd" ; -- bodknodd..nn.1
  bodlänga_1_N = mkN "bodlänga" ; -- bodlänga..nn.1
  bodmeri_1_N = mkN "bodmeri" "bodmeriet" "bodmerier" "bodmerierna" ; -- bodmeri..nn.1
  bodräkt_1_N = mkN "bodräkt" ; -- bodräkt..nn.1
  bodybuilding_1_N = mkN "bodybuilding" ; -- bodybuilding..nn.1
  boende_1_N = mkN "boende" ; -- boende..nn.1
  boende_2_N = mkN "boende" "boenden" "boende" "boendena" ; -- boende..nn.2
  boendeform_1_N = mkN "boendeform" "boendeformer" ; -- boendeform..nn.1
  boendekostnad_1_N = mkN "boendekostnad" "boendekostnader" ; -- boendekostnad..nn.1
  boendesegregering_1_N = mkN "boendesegregering" ; -- boendesegregering..nn.1
  boer_1_N = mkN "boer" "boern" "boer" "boerna" ; -- boer..nn.1
  boett_1_N = mkN "boett" "boetter" ; -- boett..nn.1
  boettlås_1_N = mkN "boettlås" ; -- boettlås..nn.1
  bofast_1_A = mkA "bofast" "bofast" ; -- bofast..av.1
  bofasthet_1_N = mkN "bofasthet" ; -- bofasthet..nn.1
  bofink_1_N = mkN "bofink" ; -- bofink..nn.1
  bofinksdrill_1_N = mkN "bofinksdrill" ; -- bofinksdrill..nn.1
  bofinkssång_1_N = mkN "bofinkssång" "bofinkssånger" ; -- bofinkssång..nn.1
  bofällig_1_A = mkA "bofällig" ; -- bofällig..av.1
  bofällighet_1_N = mkN "bofällighet" ; -- bofällighet..nn.1
  bog_1_N = mkN "bog" ; -- bog..nn.1
  bogankare_1_N = mkN "bogankare" "bogankaret" "bogankaren" "bogankarna" ; -- bogankare..nn.1
  bogblad_1_N = mkN "bogblad" neutrum  ; -- bogblad..nn.1
  bogbruten_1_A = mkA "bogbruten" ; -- bogbruten..av.1
  boggi_1_N = mkN "boggi" "boggin" "boggier" "boggierna" ; -- boggi..nn.1
  boggitryck_1_N = mkN "boggitryck" neutrum  ; -- boggitryck..nn.1
  boghalt_1_A = mkA "boghalt" "boghalt" ; -- boghalt..av.1
  boghöjd_1_N = mkN "boghöjd" "boghöjder" ; -- boghöjd..nn.1
  bogpropeller_1_N = mkN "bogpropeller" ; -- bogpropeller..nn.1
  bogsera_1_V = mkV "bogserar" ; -- bogsera..vb.1
  bogserande_1_N = mkN "bogserande" ; -- bogserande..nn.1
  bogserare_1_N = mkN "bogserare" utrum  ; -- bogserare..nn.1
  bogserbar_1_A = mkA "bogserbar" ; -- bogserbar..av.1
  bogserbarhet_1_N = mkN "bogserbarhet" ; -- bogserbarhet..nn.1
  bogserbåt_1_N = mkN "bogserbåt" ; -- bogserbåt..nn.1
  bogsergalge_1_N = mkN "bogsergalge" utrum  ; -- bogsergalge..nn.1
  bogsering_1_N = mkN "bogsering" ; -- bogsering..nn.1
  bogserlina_1_N = mkN "bogserlina" ; -- bogserlina..nn.1
  bogsersläp_1_N = mkN "bogsersläp" neutrum  ; -- bogsersläp..nn.1
  bogsertross_1_N = mkN "bogsertross" ; -- bogsertross..nn.1
  bogspröt_1_N = mkN "bogspröt" neutrum  ; -- bogspröt..nn.1
  bogvisir_1_N = mkN "bogvisir" neutrum  ; -- bogvisir..nn.1
  bogvåg_1_N = mkN "bogvåg" "bogvågor" ; -- bogvåg..nn.1
  bogvågsknall_1_N = mkN "bogvågsknall" ; -- bogvågsknall..nn.1
  bohag_1_N = mkN "bohag" neutrum  ; -- bohag..nn.1
  bohagsförteckning_1_N = mkN "bohagsförteckning" ; -- bohagsförteckning..nn.1
  bohem_1_N = mkN "bohem" "bohemer" ; -- bohem..nn.1
  bohemartad_1_A = mkA "bohemartad" ; -- bohemartad..av.1
  bohemisk_1_A = mkA "bohemisk" ; -- bohemisk..av.1
  bohemliv_1_N = mkN "bohemliv" neutrum  ; -- bohemliv..nn.1
  bohuseka_1_N = mkN "bohuseka" ; -- bohuseka..nn.1
  bohusläning_1_N = mkN "bohusläning" ; -- bohusläning..nn.1
  bohuslänning_1_N = mkN "bohuslänning" ; -- bohuslänning..nn.1
  bohuslänsk_1_A = mkA "bohuslänsk" ; -- bohuslänsk..av.1
  bohuslänska_1_N = mkN "bohuslänska" ; -- bohuslänska..nn.1
  bohuslänska_2_N = mkN "bohuslänska" ; -- bohuslänska..nn.2
  boj_1_N = mkN "boj" ; -- boj..nn.1
  boj_2_N = mkN "boj" "bojer" ; -- boj..nn.2
  boja_1_N = mkN "boja" ; -- boja..nn.1
  bojar_1_N = mkN "bojar" "bojarer" ; -- bojar..nn.1
  bojkott_1_N = mkN "bojkott" "bojkotter" ; -- bojkott..nn.1
  bojkotta_1_V = mkV "bojkottar" ; -- bojkotta..vb.1
  bojkottande_1_N = mkN "bojkottande" ; -- bojkottande..nn.1
  bojkottning_1_N = mkN "bojkottning" ; -- bojkottning..nn.1
  bok_1_N = mkN "bok" "böcker" ; -- bok..nn.1
  bok_2_N = mkN "bok" ; -- bok..nn.2
  boka_1_V = mkV "bokar" ; -- boka..vb.1
  bokande_1_N = mkN "bokande" ; -- bokande..nn.1
  bokanmälan_1_N = mkN "bokanmälan" "bokanmälan" "bokanmälningar" "bokanmälningarna" ; -- bokanmälan..nn.1
  bokauktion_1_N = mkN "bokauktion" ; -- bokauktion..nn.1
  bokband_1_N = mkN "bokband" neutrum  ; -- bokband..nn.1
  bokbindare_1_N = mkN "bokbindare" utrum  ; -- bokbindare..nn.1
  bokbinderi_1_N = mkN "bokbinderi" "bokbinderiet" "bokbinderier" "bokbinderierna" ; -- bokbinderi..nn.1
  bokbindning_1_N = mkN "bokbindning" ; -- bokbindning..nn.1
  bokbränning_1_N = mkN "bokbränning" ; -- bokbränning..nn.1
  bokbuss_1_N = mkN "bokbuss" ; -- bokbuss..nn.1
  bokcirkel_1_N = mkN "bokcirkel" ; -- bokcirkel..nn.1
  bokdamm_1_N = mkN "bokdamm" ; -- bokdamm..nn.1
  boke_1_N = mkN "boke" ; -- boke..nn.1
  boken_1_A = mkA "boken" ; -- boken..av.1
  bokenhet_1_N = mkN "bokenhet" ; -- bokenhet..nn.1
  bokfilm_1_N = mkN "bokfilm" "bokfilmer" ; -- bokfilm..nn.1
  bokflod_1_N = mkN "bokflod" "bokfloder" ; -- bokflod..nn.1
  bokform_1_N = mkN "bokform" ; -- bokform..nn.1
  bokformat_1_N = mkN "bokformat" neutrum  ; -- bokformat..nn.1
  bokföra_1_V = mkV "bokföra" "bokförde" "bokfört" ; -- bokföra..vb.1
  bokförande_1_N = mkN "bokförande" ; -- bokförande..nn.1
  bokförare_1_N = mkN "bokförare" utrum  ; -- bokförare..nn.1
  bokföring_1_N = mkN "bokföring" ; -- bokföring..nn.1
  bokföringsbrott_1_N = mkN "bokföringsbrott" neutrum  ; -- bokföringsbrott..nn.1
  bokföringsmässig_1_A = mkA "bokföringsmässig" ; -- bokföringsmässig..av.1
  bokföringsmässighet_1_N = mkN "bokföringsmässighet" ; -- bokföringsmässighet..nn.1
  bokföringsplikt_1_N = mkN "bokföringsplikt" ; -- bokföringsplikt..nn.1
  bokföringsskyldig_1_A = mkA "bokföringsskyldig" ; -- bokföringsskyldig..av.1
  bokföringsskyldighet_1_N = mkN "bokföringsskyldighet" "bokföringsskyldigheter" ; -- bokföringsskyldighet..nn.1
  bokföringsår_1_N = mkN "bokföringsår" neutrum  ; -- bokföringsår..nn.1
  bokförlag_1_N = mkN "bokförlag" neutrum  ; -- bokförlag..nn.1
  bokförläggare_1_N = mkN "bokförläggare" utrum  ; -- bokförläggare..nn.1
  bokförråd_1_N = mkN "bokförråd" neutrum  ; -- bokförråd..nn.1
  bokhandel_1_N = mkN "bokhandel" ; -- bokhandel..nn.1
  bokhandelsdisk_1_N = mkN "bokhandelsdisk" ; -- bokhandelsdisk..nn.1
  bokhandlare_1_N = mkN "bokhandlare" utrum  ; -- bokhandlare..nn.1
  bokhantverk_1_N = mkN "bokhantverk" neutrum  ; -- bokhantverk..nn.1
  bokhylla_1_N = mkN "bokhylla" ; -- bokhylla..nn.1
  bokhållare_1_N = mkN "bokhållare" utrum  ; -- bokhållare..nn.1
  bokhålleri_1_N = mkN "bokhålleri" neutrum  ; -- bokhålleri..nn.1
  bokkasse_1_N = mkN "bokkasse" utrum  ; -- bokkasse..nn.1
  bokkatalog_1_N = mkN "bokkatalog" "bokkataloger" ; -- bokkatalog..nn.1
  bokklubb_1_N = mkN "bokklubb" ; -- bokklubb..nn.1
  bokkännare_1_N = mkN "bokkännare" utrum  ; -- bokkännare..nn.1
  boklig_1_A = mkA "boklig" ; -- boklig..av.1
  boklighet_1_N = mkN "boklighet" ; -- boklighet..nn.1
  boklärd_1_A = mkA "boklärd" "boklärt" ; -- boklärd..av.1
  boklärdhet_1_N = mkN "boklärdhet" ; -- boklärdhet..nn.1
  boklärdom_1_N = mkN "boklärdom" ; -- boklärdom..nn.1
  bokläsande_1_A = mkA "bokläsande" ; -- bokläsande..av.1
  bokläsande_1_N = mkN "bokläsande" ; -- bokläsande..nn.1
  boklåda_1_N = mkN "boklåda" ; -- boklåda..nn.1
  boklån_1_N = mkN "boklån" neutrum  ; -- boklån..nn.1
  bokmagasin_1_N = mkN "bokmagasin" neutrum  ; -- bokmagasin..nn.1
  bokmakulatur_1_N = mkN "bokmakulatur" ; -- bokmakulatur..nn.1
  bokmal_1_N = mkN "bokmal" ; -- bokmal..nn.1
  bokmarknad_1_N = mkN "bokmarknad" "bokmarknader" ; -- bokmarknad..nn.1
  bokmärke_1_N = mkN "bokmärke" ; -- bokmärke..nn.1
  bokmässa_1_N = mkN "bokmässa" ; -- bokmässa..nn.1
  bokmål_1_N = mkN "bokmål" neutrum  ; -- bokmål..nn.1
  bokna_1_V = mkV "boknar" ; -- bokna..vb.1
  boknande_1_N = mkN "boknande" ; -- boknande..nn.1
  bokning_1_N = mkN "bokning" ; -- bokning..nn.1
  bokollon_1_N = mkN "bokollon" neutrum  ; -- bokollon..nn.1
  bokomslag_1_N = mkN "bokomslag" neutrum  ; -- bokomslag..nn.1
  bokpärm_1_N = mkN "bokpärm" ; -- bokpärm..nn.1
  bokrad_1_N = mkN "bokrad" "bokrader" ; -- bokrad..nn.1
  bokrea_1_N = mkN "bokrea" ; -- bokrea..nn.1
  bokrulle_1_N = mkN "bokrulle" utrum  ; -- bokrulle..nn.1
  bokrygg_1_N = mkN "bokrygg" ; -- bokrygg..nn.1
  boksamlare_1_N = mkN "boksamlare" utrum  ; -- boksamlare..nn.1
  boksamling_1_N = mkN "boksamling" ; -- boksamling..nn.1
  boksida_1_N = mkN "boksida" ; -- boksida..nn.1
  bokskatt_1_N = mkN "bokskatt" "bokskatter" ; -- bokskatt..nn.1
  bokskog_1_N = mkN "bokskog" ; -- bokskog..nn.1
  bokskrivande_1_A = mkA "bokskrivande" ; -- bokskrivande..av.1
  bokskrivande_1_N = mkN "bokskrivande" ; -- bokskrivande..nn.1
  bokskåp_1_N = mkN "bokskåp" neutrum  ; -- bokskåp..nn.1
  bokslukare_1_N = mkN "bokslukare" utrum  ; -- bokslukare..nn.1
  bokslut_1_N = mkN "bokslut" neutrum  ; -- bokslut..nn.1
  bokspråk_1_N = mkN "bokspråk" neutrum  ; -- bokspråk..nn.1
  bokstav_1_N = mkN "bokstav" "bokstäver" ; -- bokstav..nn.1
  bokstavera_1_V = mkV "bokstaverar" ; -- bokstavera..vb.1
  bokstaverande_1_N = mkN "bokstaverande" ; -- bokstaverande..nn.1
  bokstaverbar_1_A = mkA "bokstaverbar" ; -- bokstaverbar..av.1
  bokstaverbarhet_1_N = mkN "bokstaverbarhet" ; -- bokstaverbarhet..nn.1
  bokstavering_1_N = mkN "bokstavering" ; -- bokstavering..nn.1
  bokstavlig_1_A = mkA "bokstavlig" ; -- bokstavlig..av.1
  bokstavligen_1_Adv = mkAdv "bokstavligen" ; -- bokstavligen..ab.1
  bokstavlighet_1_N = mkN "bokstavlighet" "bokstavligheter" ; -- bokstavlighet..nn.1
  bokstavsbarn_1_N = mkN "bokstavsbarn" neutrum  ; -- bokstavsbarn..nn.1
  bokstavsbeteckning_1_N = mkN "bokstavsbeteckning" ; -- bokstavsbeteckning..nn.1
  bokstavsdiagnos_1_N = mkN "bokstavsdiagnos" "bokstavsdiagnoser" ; -- bokstavsdiagnos..nn.1
  bokstavsföljd_1_N = mkN "bokstavsföljd" "bokstavsföljder" ; -- bokstavsföljd..nn.1
  bokstavsinspiration_1_N = mkN "bokstavsinspiration" ; -- bokstavsinspiration..nn.1
  bokstavsmystik_1_N = mkN "bokstavsmystik" ; -- bokstavsmystik..nn.1
  bokstavsordning_1_N = mkN "bokstavsordning" ; -- bokstavsordning..nn.1
  bokstavsrim_1_N = mkN "bokstavsrim" "bokstavsrimmet" "bokstavsrim" "bokstavsrimmen" ; -- bokstavsrim..nn.1
  bokstavssallad_1_N = mkN "bokstavssallad" ; -- bokstavssallad..nn.1
  bokstavsskrift_1_N = mkN "bokstavsskrift" ; -- bokstavsskrift..nn.1
  bokstavsstans_1_N = mkN "bokstavsstans" ; -- bokstavsstans..nn.1
  bokstavstecken_1_N = mkN "bokstavstecken" "bokstavstecknet" "bokstavstecken" "bokstavstecknen" ; -- bokstavstecken..nn.1
  bokstavstro_1_N = mkN "bokstavstro" ; -- bokstavstro..nn.1
  bokstavstrogen_1_A = mkA "bokstavstrogen" ; -- bokstavstrogen..av.1
  bokstavstrogenhet_1_N = mkN "bokstavstrogenhet" ; -- bokstavstrogenhet..nn.1
  bokstavsträl_1_N = mkN "bokstavsträl" ; -- bokstavsträl..nn.1
  bokstavsvuxen_1_A = mkA "bokstavsvuxen" ; -- bokstavsvuxen..av.1
  bokstipendium_1_N = mkN "bokstipendium" "bokstipendiet" "bokstipendier" "bokstipendierna" ; -- bokstipendium..nn.1
  bokställ_1_N = mkN "bokställ" neutrum  ; -- bokställ..nn.1
  bokstöd_1_N = mkN "bokstöd" neutrum  ; -- bokstöd..nn.1
  boksynt_1_A = mkA "boksynt" "boksynt" ; -- boksynt..av.1
  boksynthet_1_N = mkN "boksynthet" ; -- boksynthet..nn.1
  boktitel_1_N = mkN "boktitel" ; -- boktitel..nn.1
  boktorn_1_N = mkN "boktorn" neutrum  ; -- boktorn..nn.1
  boktrave_1_N = mkN "boktrave" utrum  ; -- boktrave..nn.1
  boktryck_1_N = mkN "boktryck" neutrum  ; -- boktryck..nn.1
  boktryckare_1_N = mkN "boktryckare" utrum  ; -- boktryckare..nn.1
  boktryckarkonst_1_N = mkN "boktryckarkonst" ; -- boktryckarkonst..nn.1
  boktryckeri_1_N = mkN "boktryckeri" "boktryckeriet" "boktryckerier" "boktryckerierna" ; -- boktryckeri..nn.1
  boktrycksstil_1_N = mkN "boktrycksstil" ; -- boktrycksstil..nn.1
  bokuppslag_1_N = mkN "bokuppslag" neutrum  ; -- bokuppslag..nn.1
  bokval_1_N = mkN "bokval" neutrum  ; -- bokval..nn.1
  bokverk_1_N = mkN "bokverk" neutrum  ; -- bokverk..nn.1
  bokversion_1_N = mkN "bokversion" ; -- bokversion..nn.1
  bokvurm_1_N = mkN "bokvurm" ; -- bokvurm..nn.1
  bokvän_1_N = mkN "bokvän" "bokvännen" "bokvänner" "bokvännerna" ; -- bokvän..nn.1
  bokälskare_1_N = mkN "bokälskare" utrum  ; -- bokälskare..nn.1
  bol_1_N = mkN "bol" neutrum  ; -- bol..nn.1
  bola_1_V = mkV "bolar" ; -- bola..vb.1
  bolag_1_N = mkN "bolag" neutrum  ; -- bolag..nn.1
  bolagisera_1_V = mkV "bolagiserar" ; -- bolagisera..vb.1
  bolagiserande_1_N = mkN "bolagiserande" ; -- bolagiserande..nn.1
  bolagiserbar_1_A = mkA "bolagiserbar" ; -- bolagiserbar..av.1
  bolagisering_1_N = mkN "bolagisering" ; -- bolagisering..nn.1
  bolagsman_1_N = mkN "bolagsman" "bolagsmannen" "bolagsmän" "bolagsmännen" ; -- bolagsman..nn.1
  bolagsordning_1_N = mkN "bolagsordning" ; -- bolagsordning..nn.1
  bolagsskog_1_N = mkN "bolagsskog" ; -- bolagsskog..nn.1
  bolagsstyrelse_1_N = mkN "bolagsstyrelse" "bolagsstyrelser" ; -- bolagsstyrelse..nn.1
  bolagsstämma_1_N = mkN "bolagsstämma" ; -- bolagsstämma..nn.1
  bolagsägare_1_N = mkN "bolagsägare" utrum  ; -- bolagsägare..nn.1
  bolande_1_N = mkN "bolande" ; -- bolande..nn.1
  bolare_1_N = mkN "bolare" utrum  ; -- bolare..nn.1
  boleri_1_N = mkN "boleri" neutrum  ; -- boleri..nn.1
  bolero_1_N = mkN "bolero" "boleron" "boleroer" "boleroerna" ; -- bolero..nn.1
  bolid_1_N = mkN "bolid" "bolider" ; -- bolid..nn.1
  bolin_1_N = mkN "bolin" "boliner" ; -- bolin..nn.1
  bolivian_1_N = mkN "bolivian" "bolivianer" ; -- bolivian..nn.1
  boliviansk_1_A = mkA "boliviansk" ; -- boliviansk..av.1
  bolivianska_1_N = mkN "bolivianska" ; -- bolivianska..nn.1
  boll_1_N = mkN "boll" ; -- boll..nn.1
  bolla_1_V = mkV "bollar" ; -- bolla..vb.1
  bollande_1_N = mkN "bollande" ; -- bollande..nn.1
  bollbehandling_1_N = mkN "bollbehandling" ; -- bollbehandling..nn.1
  bollhav_1_N = mkN "bollhav" neutrum  ; -- bollhav..nn.1
  bollhus_1_N = mkN "bollhus" neutrum  ; -- bollhus..nn.1
  bollkalle_1_N = mkN "bollkalle" utrum  ; -- bollkalle..nn.1
  bollkastning_1_N = mkN "bollkastning" ; -- bollkastning..nn.1
  bollning_1_N = mkN "bollning" ; -- bollning..nn.1
  bollplan_1_N = mkN "bollplan" "bollplaner" ; -- bollplan..nn.1
  bollplank_1_N = mkN "bollplank" neutrum  ; -- bollplank..nn.1
  bollpojke_1_N = mkN "bollpojke" utrum  ; -- bollpojke..nn.1
  bollsinne_1_N = mkN "bollsinne" ; -- bollsinne..nn.1
  bollspel_1_N = mkN "bollspel" "bollspelet" "bollspel" "bollspelen" ; -- bollspel..nn.1
  bollspelare_1_N = mkN "bollspelare" utrum  ; -- bollspelare..nn.1
  bollträ_1_N = mkN "bollträ" "bollträt" "bollträn" "bollträna" ; -- bollträ..nn.1
  bolma_1_V = mkV "bolmar" ; -- bolma..vb.1
  bolmande_1_N = mkN "bolmande" ; -- bolmande..nn.1
  bolmört_1_N = mkN "bolmört" ; -- bolmört..nn.1
  bolmörtsgift_1_N = mkN "bolmörtsgift" neutrum  ; -- bolmörtsgift..nn.1
  bolmörtsskivling_1_N = mkN "bolmörtsskivling" ; -- bolmörtsskivling..nn.1
  bolsjevik_1_N = mkN "bolsjevik" "bolsjeviker" ; -- bolsjevik..nn.1
  bolsjevikisk_1_A = mkA "bolsjevikisk" ; -- bolsjevikisk..av.1
  bolsjevism_1_N = mkN "bolsjevism" "bolsjevismer" ; -- bolsjevism..nn.1
  bolsjevistisk_1_A = mkA "bolsjevistisk" ; -- bolsjevistisk..av.1
  bolster_1_N = mkN "bolster" ; -- bolster..nn.1
  bolsterstock_1_N = mkN "bolsterstock" ; -- bolsterstock..nn.1
  bolstervagn_1_N = mkN "bolstervagn" ; -- bolstervagn..nn.1
  bolstervar_1_N = mkN "bolstervar" neutrum  ; -- bolstervar..nn.1
  bolån_1_N = mkN "bolån" neutrum  ; -- bolån..nn.1
  bolånekris_1_N = mkN "bolånekris" "bolånekriser" ; -- bolånekris..nn.1
  bolånekund_1_N = mkN "bolånekund" "bolånekunder" ; -- bolånekund..nn.1
  bolåneränta_1_N = mkN "bolåneränta" ; -- bolåneränta..nn.1
  bom_1_N = mkN "bom" "bommen" "bommar" "bommarna" ; -- bom..nn.1
  bomaterial_1_N = mkN "bomaterial" neutrum  ; -- bomaterial..nn.1
  bomb_1_N = mkN "bomb" "bomber" ; -- bomb..nn.1
  bomba_1_V = mkV "bombar" ; -- bomba..vb.1
  bombad_1_A = mkA "bombad" ; -- bombad..av.1
  bombande_1_N = mkN "bombande" ; -- bombande..nn.1
  bombanfall_1_N = mkN "bombanfall" neutrum  ; -- bombanfall..nn.1
  bombardemang_1_N = mkN "bombardemang" neutrum  ; -- bombardemang..nn.1
  bombardera_1_V = mkV "bombarderar" ; -- bombardera..vb.1
  bombarderande_1_N = mkN "bombarderande" ; -- bombarderande..nn.1
  bombarderbar_1_A = mkA "bombarderbar" ; -- bombarderbar..av.1
  bombarderbarhet_1_N = mkN "bombarderbarhet" ; -- bombarderbarhet..nn.1
  bombardering_1_N = mkN "bombardering" ; -- bombardering..nn.1
  bombare_1_N = mkN "bombare" utrum  ; -- bombare..nn.1
  bombasm_1_N = mkN "bombasm" "bombasmer" ; -- bombasm..nn.1
  bombastisk_1_A = mkA "bombastisk" ; -- bombastisk..av.1
  bombattack_1_N = mkN "bombattack" "bombattacker" ; -- bombattack..nn.1
  bombattentat_1_N = mkN "bombattentat" neutrum  ; -- bombattentat..nn.1
  bombdåd_1_N = mkN "bombdåd" neutrum  ; -- bombdåd..nn.1
  bombering_1_N = mkN "bombering" ; -- bombering..nn.1
  bombfast_1_A = mkA "bombfast" "bombfast" ; -- bombfast..av.1
  bombfasthet_1_N = mkN "bombfasthet" ; -- bombfasthet..nn.1
  bombflyg_1_N = mkN "bombflyg" neutrum  ; -- bombflyg..nn.1
  bombfri_1_A = mkA "bombfri" "bombfritt" ; -- bombfri..av.1
  bombfällning_1_N = mkN "bombfällning" ; -- bombfällning..nn.1
  bombhot_1_N = mkN "bombhot" neutrum  ; -- bombhot..nn.1
  bombkrater_1_N = mkN "bombkrater" ; -- bombkrater..nn.1
  bombkrig_1_N = mkN "bombkrig" neutrum  ; -- bombkrig..nn.1
  bomblarm_1_N = mkN "bomblarm" neutrum  ; -- bomblarm..nn.1
  bombman_1_N = mkN "bombman" "bombmannen" "bombmän" "bombmännen" ; -- bombman..nn.1
  bombmatta_1_N = mkN "bombmatta" ; -- bombmatta..nn.1
  bombnedslag_1_N = mkN "bombnedslag" neutrum  ; -- bombnedslag..nn.1
  bombning_1_N = mkN "bombning" ; -- bombning..nn.1
  bomboffer_1_N = mkN "bomboffer" neutrum  ; -- bomboffer..nn.1
  bombplan_1_N = mkN "bombplan" neutrum  ; -- bombplan..nn.1
  bombraid_1_N = mkN "bombraid" "bombraider" ; -- bombraid..nn.1
  bombräd_1_N = mkN "bombräd" "bombräder" ; -- bombräd..nn.1
  bombsikte_1_N = mkN "bombsikte" ; -- bombsikte..nn.1
  bombskydd_1_N = mkN "bombskydd" neutrum  ; -- bombskydd..nn.1
  bombskyddssektion_1_N = mkN "bombskyddssektion" ; -- bombskyddssektion..nn.1
  bombsplitter_1_N = mkN "bombsplitter" neutrum  ; -- bombsplitter..nn.1
  bombsäker_1_A = mkA "bombsäker" ; -- bombsäker..av.1
  bombsäkerhet_1_N = mkN "bombsäkerhet" ; -- bombsäkerhet..nn.1
  bombtillverkning_1_N = mkN "bombtillverkning" ; -- bombtillverkning..nn.1
  bomcylinder_1_N = mkN "bomcylinder" ; -- bomcylinder..nn.1
  bomma_1_V = mkV "bommar" ; -- bomma..vb.1
  bommande_1_N = mkN "bommande" ; -- bommande..nn.1
  bomolja_1_N = mkN "bomolja" ; -- bomolja..nn.1
  bomsadel_1_N = mkN "bomsadel" ; -- bomsadel..nn.1
  bomsegel_1_N = mkN "bomsegel" neutrum  ; -- bomsegel..nn.1
  bomskott_1_N = mkN "bomskott" neutrum  ; -- bomskott..nn.1
  bomull_1_N = mkN "bomull" ; -- bomull..nn.1
  bomullsbal_1_N = mkN "bomullsbal" ; -- bomullsbal..nn.1
  bomullsband_1_N = mkN "bomullsband" neutrum  ; -- bomullsband..nn.1
  bomullsbuske_1_N = mkN "bomullsbuske" utrum  ; -- bomullsbuske..nn.1
  bomullsflanell_1_N = mkN "bomullsflanell" "bomullsflaneller" ; -- bomullsflanell..nn.1
  bomullsfrö_1_N = mkN "bomullsfrö" "bomullsfröet" "bomullsfrön" "bomullsfröna" ; -- bomullsfrö..nn.1
  bomullsfrökaka_1_N = mkN "bomullsfrökaka" ; -- bomullsfrökaka..nn.1
  bomullsfröolja_1_N = mkN "bomullsfröolja" ; -- bomullsfröolja..nn.1
  bomullsgarn_1_N = mkN "bomullsgarn" neutrum  ; -- bomullsgarn..nn.1
  bomullsklänning_1_N = mkN "bomullsklänning" ; -- bomullsklänning..nn.1
  bomullskrut_1_N = mkN "bomullskrut" neutrum  ; -- bomullskrut..nn.1
  bomullspinne_1_N = mkN "bomullspinne" utrum  ; -- bomullspinne..nn.1
  bomullsplantage_1_N = mkN "bomullsplantage" "bomullsplantager" ; -- bomullsplantage..nn.1
  bomullsplockare_1_N = mkN "bomullsplockare" utrum  ; -- bomullsplockare..nn.1
  bomullsservett_1_N = mkN "bomullsservett" "bomullsservetter" ; -- bomullsservett..nn.1
  bomullsskjorta_1_N = mkN "bomullsskjorta" ; -- bomullsskjorta..nn.1
  bomullsspinneri_1_N = mkN "bomullsspinneri" "bomullsspinneriet" "bomullsspinnerier" "bomullsspinnerierna" ; -- bomullsspinneri..nn.1
  bomullsstrumpa_1_N = mkN "bomullsstrumpa" ; -- bomullsstrumpa..nn.1
  bomullstops_1_N = mkN "bomullstops" ; -- bomullstops..nn.1
  bomullstrassel_1_N = mkN "bomullstrassel" neutrum  ; -- bomullstrassel..nn.1
  bomullstrikå_1_N = mkN "bomullstrikå" ; -- bomullstrikå..nn.1
  bomullstråd_1_N = mkN "bomullstråd" ; -- bomullstråd..nn.1
  bomullstuss_1_N = mkN "bomullstuss" ; -- bomullstuss..nn.1
  bomullstyg_1_N = mkN "bomullstyg" neutrum  ; -- bomullstyg..nn.1
  bomullsväv_1_N = mkN "bomullsväv" ; -- bomullsväv..nn.1
  bomullsvävnad_1_N = mkN "bomullsvävnad" "bomullsvävnader" ; -- bomullsvävnad..nn.1
  bomullsväxt_1_N = mkN "bomullsväxt" "bomullsväxter" ; -- bomullsväxt..nn.1
  bomärke_1_N = mkN "bomärke" ; -- bomärke..nn.1
  bona_1_V = mkV "bonar" ; -- bona..vb.1
  bonad_1_N = mkN "bonad" "bonader" ; -- bonad..nn.1
  bonande_1_N = mkN "bonande" ; -- bonande..nn.1
  bonbonjär_1_N = mkN "bonbonjär" "bonbonjärer" ; -- bonbonjär..nn.1
  bondage_1_N = mkN "bondage" ; -- bondage..nn.1
  bondaktig_1_A = mkA "bondaktig" ; -- bondaktig..av.1
  bondaktighet_1_N = mkN "bondaktighet" ; -- bondaktighet..nn.1
  bondbrud_1_N = mkN "bondbrud" ; -- bondbrud..nn.1
  bondböna_1_N = mkN "bondböna" ; -- bondböna..nn.1
  bonddryg_1_A = mkA "bonddryg" ; -- bonddryg..av.1
  bonddryghet_1_N = mkN "bonddryghet" ; -- bonddryghet..nn.1
  bonddräng_1_N = mkN "bonddräng" ; -- bonddräng..nn.1
  bonde_1_N = mkN "bonde" "bönder" ; -- bonde..nn.1
  bondearmé_1_N = mkN "bondearmé" "bondearméer" ; -- bondearmé..nn.1
  bondebefolkning_1_N = mkN "bondebefolkning" ; -- bondebefolkning..nn.1
  bondefred_1_N = mkN "bondefred" "bondefreder" ; -- bondefred..nn.1
  bondegeneration_1_N = mkN "bondegeneration" ; -- bondegeneration..nn.1
  bondehemman_1_N = mkN "bondehemman" neutrum  ; -- bondehemman..nn.1
  bondehär_1_N = mkN "bondehär" ; -- bondehär..nn.1
  bondekultur_1_N = mkN "bondekultur" "bondekulturer" ; -- bondekultur..nn.1
  bondenostalgi_1_N = mkN "bondenostalgi" "bondenostalgier" ; -- bondenostalgi..nn.1
  bondenostalgisk_1_A = mkA "bondenostalgisk" ; -- bondenostalgisk..av.1
  bondepraktika_1_N = mkN "bondepraktika" ; -- bondepraktika..nn.1
  bondeprotest_1_N = mkN "bondeprotest" "bondeprotester" ; -- bondeprotest..nn.1
  bondesamhälle_1_N = mkN "bondesamhälle" ; -- bondesamhälle..nn.1
  bondesjäl_1_N = mkN "bondesjäl" ; -- bondesjäl..nn.1
  bondeskog_1_N = mkN "bondeskog" ; -- bondeskog..nn.1
  bondesläkt_1_N = mkN "bondesläkt" "bondesläkter" ; -- bondesläkt..nn.1
  bondestånd_1_N = mkN "bondestånd" neutrum  ; -- bondestånd..nn.1
  bondetåg_1_N = mkN "bondetåg" neutrum  ; -- bondetåg..nn.1
  bondeuppbåd_1_N = mkN "bondeuppbåd" neutrum  ; -- bondeuppbåd..nn.1
  bondeuppror_1_N = mkN "bondeuppror" neutrum  ; -- bondeuppror..nn.1
  bondfamilj_1_N = mkN "bondfamilj" "bondfamiljer" ; -- bondfamilj..nn.1
  bondflicka_1_N = mkN "bondflicka" ; -- bondflicka..nn.1
  bondfolk_1_N = mkN "bondfolk" neutrum  ; -- bondfolk..nn.1
  bondfångare_1_N = mkN "bondfångare" utrum  ; -- bondfångare..nn.1
  bondförnuft_1_N = mkN "bondförnuft" neutrum  ; -- bondförnuft..nn.1
  bondförstånd_1_N = mkN "bondförstånd" neutrum  ; -- bondförstånd..nn.1
  bondförsök_1_N = mkN "bondförsök" neutrum  ; -- bondförsök..nn.1
  bondgumma_1_N = mkN "bondgumma" ; -- bondgumma..nn.1
  bondgård_1_N = mkN "bondgård" ; -- bondgård..nn.1
  bondhustru_1_N = mkN "bondhustru" "bondhustrun" "bondhustrur" "bondhustrurna" ; -- bondhustru..nn.1
  bondkalas_1_N = mkN "bondkalas" neutrum  ; -- bondkalas..nn.1
  bondkatt_1_N = mkN "bondkatt" "bondkatter" ; -- bondkatt..nn.1
  bondkomik_1_N = mkN "bondkomik" ; -- bondkomik..nn.1
  bondkomiker_1_N = mkN "bondkomiker" "bondkomikern" "bondkomiker" "bondkomikerna" ; -- bondkomiker..nn.1
  bondland_1_N = mkN "bondland" neutrum  ; -- bondland..nn.1
  bondlurk_1_N = mkN "bondlurk" ; -- bondlurk..nn.1
  bondläpp_1_N = mkN "bondläpp" ; -- bondläpp..nn.1
  bondmora_1_N = mkN "bondmora" ; -- bondmora..nn.1
  bondneka_1_V = mkV "bondnekar" ; -- bondneka..vb.1
  bondnekande_1_N = mkN "bondnekande" ; -- bondnekande..nn.1
  bondpermis_1_N = mkN "bondpermis" ; -- bondpermis..nn.1
  bondpermission_1_N = mkN "bondpermission" ; -- bondpermission..nn.1
  bondpolska_1_N = mkN "bondpolska" ; -- bondpolska..nn.1
  bondsk_1_A = mkA "bondsk" ; -- bondsk..av.1
  bondska_1_N = mkN "bondska" ; -- bondska..nn.1
  bondskhet_1_N = mkN "bondskhet" ; -- bondskhet..nn.1
  bondslug_1_A = mkA "bondslug" ; -- bondslug..av.1
  bondslughet_1_N = mkN "bondslughet" ; -- bondslughet..nn.1
  bondspelman_1_N = mkN "bondspelman" "bondspelmannen" "bondspelmän" "bondspelmännen" ; -- bondspelman..nn.1
  bondstuga_1_N = mkN "bondstuga" ; -- bondstuga..nn.1
  bondtolva_1_N = mkN "bondtolva" ; -- bondtolva..nn.1
  bondtur_1_N = mkN "bondtur" ; -- bondtur..nn.1
  bondtölp_1_N = mkN "bondtölp" ; -- bondtölp..nn.1
  bondvischa_1_N = mkN "bondvischa" ; -- bondvischa..nn.1
  bondånger_1_N = mkN "bondånger" ; -- bondånger..nn.1
  bong_1_N = mkN "bong" ; -- bong..nn.1
  bonga_1_V = mkV "bongar" ; -- bonga..vb.1
  bongande_1_N = mkN "bongande" ; -- bongande..nn.1
  bongotrumma_1_N = mkN "bongotrumma" ; -- bongotrumma..nn.1
  boning_1_N = mkN "boning" ; -- boning..nn.1
  boningshus_1_N = mkN "boningshus" neutrum  ; -- boningshus..nn.1
  boningsort_1_N = mkN "boningsort" "boningsorter" ; -- boningsort..nn.1
  boningsplats_1_N = mkN "boningsplats" "boningsplatser" ; -- boningsplats..nn.1
  boningsrum_1_N = mkN "boningsrum" "boningsrummet" "boningsrum" "boningsrummen" ; -- boningsrum..nn.1
  bonitera_1_V = mkV "boniterar" ; -- bonitera..vb.1
  boniterande_1_N = mkN "boniterande" ; -- boniterande..nn.1
  boniterbar_1_A = mkA "boniterbar" ; -- boniterbar..av.1
  boniterbarhet_1_N = mkN "boniterbarhet" ; -- boniterbarhet..nn.1
  bonitering_1_N = mkN "bonitering" ; -- bonitering..nn.1
  bonitet_1_N = mkN "bonitet" "boniteter" ; -- bonitet..nn.1
  bonjour_1_N = mkN "bonjour" "bonjourer" ; -- bonjour..nn.1
  bonmot_1_N = mkN "bonmot" neutrum  ; -- bonmot..nn.1
  bonnett_1_N = mkN "bonnett" "bonnetter" ; -- bonnett..nn.1
  bonnig_1_A = mkA "bonnig" ; -- bonnig..av.1
  bonnläpp_1_N = mkN "bonnläpp" ; -- bonnläpp..nn.1
  bonobo_1_N = mkN "bonobo" "bonobor" ; -- bonobo..nn.1
  bonus_1_N = mkN "bonus" ; -- bonus..nn.1
  bonusbarn_1_N = mkN "bonusbarn" neutrum  ; -- bonusbarn..nn.1
  bonusklass_1_N = mkN "bonusklass" "bonusklasser" ; -- bonusklass..nn.1
  bonusregel_1_N = mkN "bonusregel" "bonusregeln" "bonusregler" "bonusreglerna" ; -- bonusregel..nn.1
  bonussystem_1_N = mkN "bonussystem" neutrum  ; -- bonussystem..nn.1
  bonvax_1_N = mkN "bonvax" "bonvaxet" "bonvaxer" "bonvaxerna" ; -- bonvax..nn.1
  bookmaker_1_N = mkN "bookmaker" "bookmakern" "bookmakers" "bookmakersen" ; -- bookmaker..nn.1
  boom_1_N = mkN "boom" ; -- boom..nn.1
  booma_1_V = mkV "boomar" ; -- booma..vb.1
  boomande_1_N = mkN "boomande" ; -- boomande..nn.1
  boomår_1_N = mkN "boomår" neutrum  ; -- boomår..nn.1
  boosta_1_V = mkV "boostar" ; -- boosta..vb.1
  boostande_1_N = mkN "boostande" ; -- boostande..nn.1
  boostning_1_N = mkN "boostning" ; -- boostning..nn.1
  boota_1_V = mkV "bootar" ; -- boota..vb.1
  boparasit_1_N = mkN "boparasit" "boparasiter" ; -- boparasit..nn.1
  boplats_1_N = mkN "boplats" "boplatser" ; -- boplats..nn.1
  boplatsgrävning_1_N = mkN "boplatsgrävning" ; -- boplatsgrävning..nn.1
  bopris_1_N = mkN "bopris" neutrum  ; -- bopris..nn.1
  boprisbubbla_1_N = mkN "boprisbubbla" ; -- boprisbubbla..nn.1
  bor_1_N = mkN "bor" ; -- bor..nn.1
  borax_1_N = mkN "borax" ; -- borax..nn.1
  bord_1_N = mkN "bord" neutrum  ; -- bord..nn.1
  borda_1_V = mkV "bordar" ; -- borda..vb.1
  bordande_1_N = mkN "bordande" ; -- bordande..nn.1
  borddans_1_N = mkN "borddans" "borddanser" ; -- borddans..nn.1
  bordduk_1_N = mkN "bordduk" ; -- bordduk..nn.1
  bordeaux_1_N = mkN "bordeaux" "bordeauxer" ; -- bordeaux..nn.1
  bordeauxvin_1_N = mkN "bordeauxvin" "bordeauxvinet" "bordeauxviner" "bordeauxvinerna" ; -- bordeauxvin..nn.1
  bordeauxvätska_1_N = mkN "bordeauxvätska" ; -- bordeauxvätska..nn.1
  bordell_1_N = mkN "bordell" "bordeller" ; -- bordell..nn.1
  bordellverksamhet_1_N = mkN "bordellverksamhet" "bordellverksamheter" ; -- bordellverksamhet..nn.1
  bordellvärd_1_N = mkN "bordellvärd" ; -- bordellvärd..nn.1
  bordgång_1_N = mkN "bordgång" ; -- bordgång..nn.1
  bordhyvel_1_N = mkN "bordhyvel" ; -- bordhyvel..nn.1
  bordlägga_1_V = mkV "bordlägga" "bordla" "bordlagt" ; -- bordlägga..vb.1
  bordläggande_1_N = mkN "bordläggande" ; -- bordläggande..nn.1
  bordläggning_1_N = mkN "bordläggning" ; -- bordläggning..nn.1
  bordläggningsplenum_1_N = mkN "bordläggningsplenum" neutrum  ; -- bordläggningsplenum..nn.1
  bordlöpare_1_N = mkN "bordlöpare" utrum  ; -- bordlöpare..nn.1
  bordning_1_N = mkN "bordning" ; -- bordning..nn.1
  bordplanka_1_N = mkN "bordplanka" ; -- bordplanka..nn.1
  bordsamtal_1_N = mkN "bordsamtal" neutrum  ; -- bordsamtal..nn.1
  bordsben_1_N = mkN "bordsben" neutrum  ; -- bordsben..nn.1
  bordsbeställning_1_N = mkN "bordsbeställning" ; -- bordsbeställning..nn.1
  bordsbön_1_N = mkN "bordsbön" "bordsböner" ; -- bordsbön..nn.1
  bordsdam_1_N = mkN "bordsdam" "bordsdamer" ; -- bordsdam..nn.1
  bordsdryck_1_N = mkN "bordsdryck" "bordsdrycker" ; -- bordsdryck..nn.1
  bordservis_1_N = mkN "bordservis" "bordserviser" ; -- bordservis..nn.1
  bordsfilt_1_N = mkN "bordsfilt" ; -- bordsfilt..nn.1
  bordsgranne_1_N = mkN "bordsgranne" utrum  ; -- bordsgranne..nn.1
  bordsgäst_1_N = mkN "bordsgäst" "bordsgäster" ; -- bordsgäst..nn.1
  bordsilver_1_N = mkN "bordsilver" neutrum  ; -- bordsilver..nn.1
  bordskamrat_1_N = mkN "bordskamrat" "bordskamrater" ; -- bordskamrat..nn.1
  bordskant_1_N = mkN "bordskant" "bordskanter" ; -- bordskant..nn.1
  bordskavaljer_1_N = mkN "bordskavaljer" "bordskavaljerer" ; -- bordskavaljer..nn.1
  bordskick_1_N = mkN "bordskick" neutrum  ; -- bordskick..nn.1
  bordskiva_1_N = mkN "bordskiva" ; -- bordskiva..nn.1
  bordskniv_1_N = mkN "bordskniv" ; -- bordskniv..nn.1
  bordskrydda_1_N = mkN "bordskrydda" ; -- bordskrydda..nn.1
  bordslampa_1_N = mkN "bordslampa" ; -- bordslampa..nn.1
  bordslinne_1_N = mkN "bordslinne" ; -- bordslinne..nn.1
  bordsmargarin_1_N = mkN "bordsmargarin" "bordsmargarinet" "bordsmargariner" "bordsmargarinerna" ; -- bordsmargarin..nn.1
  bordssalt_1_N = mkN "bordssalt" neutrum  ; -- bordssalt..nn.1
  bordssamtal_1_N = mkN "bordssamtal" neutrum  ; -- bordssamtal..nn.1
  bordsservis_1_N = mkN "bordsservis" "bordsserviser" ; -- bordsservis..nn.1
  bordssilver_1_N = mkN "bordssilver" neutrum  ; -- bordssilver..nn.1
  bordsskick_1_N = mkN "bordsskick" neutrum  ; -- bordsskick..nn.1
  bordsskiva_1_N = mkN "bordsskiva" ; -- bordsskiva..nn.1
  bordsspegel_1_N = mkN "bordsspegel" ; -- bordsspegel..nn.1
  bordsstudsare_1_N = mkN "bordsstudsare" utrum  ; -- bordsstudsare..nn.1
  bordsställ_1_N = mkN "bordsställ" neutrum  ; -- bordsställ..nn.1
  bordssällskap_1_N = mkN "bordssällskap" neutrum  ; -- bordssällskap..nn.1
  bordstudsare_1_N = mkN "bordstudsare" utrum  ; -- bordstudsare..nn.1
  bordsuppsats_1_N = mkN "bordsuppsats" "bordsuppsatser" ; -- bordsuppsats..nn.1
  bordsvatten_1_N = mkN "bordsvatten" "bordsvattnet" "bordsvatten" "bordsvattnen" ; -- bordsvatten..nn.1
  bordsvin_1_N = mkN "bordsvin" "bordsvinet" "bordsviner" "bordsvinerna" ; -- bordsvin..nn.1
  bordsvisa_1_N = mkN "bordsvisa" ; -- bordsvisa..nn.1
  bordtennis_1_N = mkN "bordtennis" ; -- bordtennis..nn.1
  bordtennisbord_1_N = mkN "bordtennisbord" neutrum  ; -- bordtennisbord..nn.1
  bordtennisrack_1_N = mkN "bordtennisrack" ; -- bordtennisrack..nn.1
  bordtennisracket_1_N = mkN "bordtennisracket" ; -- bordtennisracket..nn.1
  bordvisa_1_N = mkN "bordvisa" ; -- bordvisa..nn.1
  boreal_1_A = mkA "boreal" ; -- boreal..av.1
  boren_1_A = mkA "boren" ; -- boren..av.1
  borg_1_N = mkN "borg" ; -- borg..nn.1
  borga_1_V = mkV "borgar" ; -- borga..vb.1
  borgande_1_N = mkN "borgande" ; -- borgande..nn.1
  borgaras_1_N = mkN "borgaras" neutrum  ; -- borgaras..nn.1
  borgarbeväpning_1_N = mkN "borgarbeväpning" ; -- borgarbeväpning..nn.1
  borgarbrev_1_N = mkN "borgarbrev" neutrum  ; -- borgarbrev..nn.1
  borgardöme_1_N = mkN "borgardöme" ; -- borgardöme..nn.1
  borgare_1_N = mkN "borgare" utrum  ; -- borgare..nn.1
  borgarfamilj_1_N = mkN "borgarfamilj" "borgarfamiljer" ; -- borgarfamilj..nn.1
  borgargarde_1_N = mkN "borgargarde" ; -- borgargarde..nn.1
  borgarhus_1_N = mkN "borgarhus" neutrum  ; -- borgarhus..nn.1
  borgarklass_1_N = mkN "borgarklass" "borgarklasser" ; -- borgarklass..nn.1
  borgarpress_1_N = mkN "borgarpress" ; -- borgarpress..nn.1
  borgarråd_1_N = mkN "borgarråd" neutrum  ; -- borgarråd..nn.1
  borgarskola_1_N = mkN "borgarskola" ; -- borgarskola..nn.1
  borgarsläkt_1_N = mkN "borgarsläkt" "borgarsläkter" ; -- borgarsläkt..nn.1
  borgarstånd_1_N = mkN "borgarstånd" neutrum  ; -- borgarstånd..nn.1
  borgensförbindelse_1_N = mkN "borgensförbindelse" "borgensförbindelser" ; -- borgensförbindelse..nn.1
  borgenslån_1_N = mkN "borgenslån" neutrum  ; -- borgenslån..nn.1
  borgensman_1_N = mkN "borgensman" "borgensmannen" "borgensmän" "borgensmännen" ; -- borgensman..nn.1
  borgenssumma_1_N = mkN "borgenssumma" ; -- borgenssumma..nn.1
  borgensåtagande_1_N = mkN "borgensåtagande" ; -- borgensåtagande..nn.1
  borgenär_1_N = mkN "borgenär" "borgenärer" ; -- borgenär..nn.1
  borgenärsed_1_N = mkN "borgenärsed" "borgenärseder" ; -- borgenärsed..nn.1
  borgerlig_1_A = mkA "borgerlig" ; -- borgerlig..av.1
  borgerlighet_1_N = mkN "borgerlighet" "borgerligheter" ; -- borgerlighet..nn.1
  borgerlighet_2_N = mkN "borgerlighet" ; -- borgerlighet..nn.2
  borgerskap_1_N = mkN "borgerskap" neutrum  ; -- borgerskap..nn.1
  borgfred_1_N = mkN "borgfred" "borgfreder" ; -- borgfred..nn.1
  borggård_1_N = mkN "borggård" ; -- borggård..nn.1
  borgis_1_N = mkN "borgis" ; -- borgis..nn.1
  borgmästare_1_N = mkN "borgmästare" utrum  ; -- borgmästare..nn.1
  borgruin_1_N = mkN "borgruin" "borgruiner" ; -- borgruin..nn.1
  borgtorn_1_N = mkN "borgtorn" neutrum  ; -- borgtorn..nn.1
  boricka_1_N = mkN "boricka" ; -- boricka..nn.1
  borkarbid_1_N = mkN "borkarbid" "borkarbider" ; -- borkarbid..nn.1
  bornera_1_V = mkV "bornerar" ; -- bornera..vb.1
  bornerad_1_A = mkA "bornerad" ; -- bornerad..av.1
  bornerande_1_N = mkN "bornerande" ; -- bornerande..nn.1
  bornering_1_N = mkN "bornering" ; -- bornering..nn.1
  bornyr_1_N = mkN "bornyr" ; -- bornyr..nn.1
  borr_1_N = mkN "borr" ; -- borr..nn.1
  borr_2_N = mkN "borr" ; -- borr..nn.2
  borra_1_V = mkV "borrar" ; -- borra..vb.1
  borrande_1_N = mkN "borrande" ; -- borrande..nn.1
  borrchuck_1_N = mkN "borrchuck" ; -- borrchuck..nn.1
  borrdiameter_1_N = mkN "borrdiameter" ; -- borrdiameter..nn.1
  borrelia_1_N = mkN "borrelia" ; -- borrelia..nn.1
  borreliavaccin_1_N = mkN "borreliavaccin" neutrum  ; -- borreliavaccin..nn.1
  borrhammare_1_N = mkN "borrhammare" "borrhammaren" "borrhammare" "borrhamrarna" ; -- borrhammare..nn.1
  borrhål_1_N = mkN "borrhål" neutrum  ; -- borrhål..nn.1
  borrhålsvägg_1_N = mkN "borrhålsvägg" ; -- borrhålsvägg..nn.1
  borrigg_1_N = mkN "borrigg" ; -- borrigg..nn.1
  borrjigg_1_N = mkN "borrjigg" ; -- borrjigg..nn.1
  borrklinka_1_N = mkN "borrklinka" ; -- borrklinka..nn.1
  borrkrona_1_N = mkN "borrkrona" ; -- borrkrona..nn.1
  borrkärna_1_N = mkN "borrkärna" ; -- borrkärna..nn.1
  borrlängd_1_N = mkN "borrlängd" "borrlängder" ; -- borrlängd..nn.1
  borrmaskin_1_N = mkN "borrmaskin" "borrmaskiner" ; -- borrmaskin..nn.1
  borrmussla_1_N = mkN "borrmussla" ; -- borrmussla..nn.1
  borrning_1_N = mkN "borrning" ; -- borrning..nn.1
  borrningsolycka_1_N = mkN "borrningsolycka" ; -- borrningsolycka..nn.1
  borrplattform_1_N = mkN "borrplattform" ; -- borrplattform..nn.1
  borrspindel_1_N = mkN "borrspindel" ; -- borrspindel..nn.1
  borrspån_1_N = mkN "borrspån" neutrum  ; -- borrspån..nn.1
  borrstål_1_N = mkN "borrstål" neutrum  ; -- borrstål..nn.1
  borrsväng_1_N = mkN "borrsväng" ; -- borrsväng..nn.1
  borrtorn_1_N = mkN "borrtorn" neutrum  ; -- borrtorn..nn.1
  borrutrustning_1_N = mkN "borrutrustning" ; -- borrutrustning..nn.1
  borsjtj_1_N = mkN "borsjtj" ; -- borsjtj..nn.1
  borst_1_N = mkN "borst" neutrum  ; -- borst..nn.1
  borsta_1_V = mkV "borstar" ; -- borsta..vb.1
  borstande_1_N = mkN "borstande" ; -- borstande..nn.1
  borstbindare_1_N = mkN "borstbindare" utrum  ; -- borstbindare..nn.1
  borstbinderi_1_N = mkN "borstbinderi" "borstbinderiet" "borstbinderier" "borstbinderierna" ; -- borstbinderi..nn.1
  borste_1_N = mkN "borste" utrum  ; -- borste..nn.1
  borstgarnityr_1_N = mkN "borstgarnityr" neutrum  ; -- borstgarnityr..nn.1
  borstgräs_1_N = mkN "borstgräs" neutrum  ; -- borstgräs..nn.1
  borstig_1_A = mkA "borstig" ; -- borstig..av.1
  borstighet_1_N = mkN "borstighet" ; -- borstighet..nn.1
  borstlös_1_A = mkA "borstlös" ; -- borstlös..av.1
  borstlöshet_1_N = mkN "borstlöshet" ; -- borstlöshet..nn.1
  borstmask_1_N = mkN "borstmask" ; -- borstmask..nn.1
  borstnate_1_N = mkN "borstnate" utrum  ; -- borstnate..nn.1
  borstnejlika_1_N = mkN "borstnejlika" ; -- borstnejlika..nn.1
  borstning_1_N = mkN "borstning" ; -- borstning..nn.1
  borstsvans_1_N = mkN "borstsvans" ; -- borstsvans..nn.1
  borstviskare_1_N = mkN "borstviskare" utrum  ; -- borstviskare..nn.1
  borsyra_1_N = mkN "borsyra" ; -- borsyra..nn.1
  bortadopterad_1_A = mkA "bortadopterad" ; -- bortadopterad..av.1
  bortafiasko_1_N = mkN "bortafiasko" "bortafiaskot" "bortafiaskon" "bortafiaskona" ; -- bortafiasko..nn.1
  bortaförlora_1_V = mkV "bortaförlorar" ; -- bortaförlora..vb.1
  bortaförlust_1_N = mkN "bortaförlust" "bortaförluster" ; -- bortaförlust..nn.1
  bortaförsäkring_1_N = mkN "bortaförsäkring" ; -- bortaförsäkring..nn.1
  bortalag_1_N = mkN "bortalag" neutrum  ; -- bortalag..nn.1
  bortalagad_1_A = mkA "bortalagad" ; -- bortalagad..av.1
  bortamatch_1_N = mkN "bortamatch" "bortamatcher" ; -- bortamatch..nn.1
  bortaplan_1_N = mkN "bortaplan" "bortaplaner" ; -- bortaplan..nn.1
  bortarbeta_1_V = mkV "bortarbetar" ; -- bortarbeta..vb.1
  bortarbetande_1_N = mkN "bortarbetande" ; -- bortarbetande..nn.1
  bortarbetning_1_N = mkN "bortarbetning" ; -- bortarbetning..nn.1
  bortarrendering_1_N = mkN "bortarrendering" ; -- bortarrendering..nn.1
  bortaseger_1_N = mkN "bortaseger" ; -- bortaseger..nn.1
  bortasegra_1_V = mkV "bortasegrar" ; -- bortasegra..vb.1
  bortaspelare_1_N = mkN "bortaspelare" utrum  ; -- bortaspelare..nn.1
  bortauktionering_1_N = mkN "bortauktionering" ; -- bortauktionering..nn.1
  bortavaro_1_N = mkN "bortavaro" ; -- bortavaro..nn.1
  bortavinna_1_V = mkV "bortavinna" "bortavann" "bortavunnit" ; -- bortavinna..vb.1
  bortavinst_1_N = mkN "bortavinst" "bortavinster" ; -- bortavinst..nn.1
  bortbjuden_1_A = mkA "bortbjuden" ; -- bortbjuden..av.1
  bortbjudning_1_N = mkN "bortbjudning" ; -- bortbjudning..nn.1
  bortblandning_1_N = mkN "bortblandning" ; -- bortblandning..nn.1
  bortblåsning_1_N = mkN "bortblåsning" ; -- bortblåsning..nn.1
  bortblåst_1_A = mkA "bortblåst" "bortblåst" ; -- bortblåst..av.1
  bortbyting_1_N = mkN "bortbyting" ; -- bortbyting..nn.1
  bortdomna_1_V = mkV "bortdomnar" ; -- bortdomna..vb.1
  bortdomnande_1_N = mkN "bortdomnande" ; -- bortdomnande..nn.1
  bortdomning_1_N = mkN "bortdomning" ; -- bortdomning..nn.1
  bortdriva_1_V = mkV "bortdriva" "bortdrev" "bortdrivit" ; -- bortdriva..vb.1
  bortdrivande_1_N = mkN "bortdrivande" ; -- bortdrivande..nn.1
  bortdrivning_1_N = mkN "bortdrivning" ; -- bortdrivning..nn.1
  bortdunstning_1_N = mkN "bortdunstning" ; -- bortdunstning..nn.1
  bortdöende_1_A = mkA "bortdöende" ; -- bortdöende..av.1
  bortdömning_1_N = mkN "bortdömning" ; -- bortdömning..nn.1
  borterst_1_Adv = mkAdv "borterst" ; -- borterst..ab.1
  bortfall_1_N = mkN "bortfall" neutrum  ; -- bortfall..nn.1
  bortfalla_1_V = mkV "bortfalla" "bortföll" "bortfallit" ; -- bortfalla..vb.1
  bortfallande_1_N = mkN "bortfallande" ; -- bortfallande..nn.1
  bortflugen_1_A = mkA "bortflugen" ; -- bortflugen..av.1
  bortflyttning_1_N = mkN "bortflyttning" ; -- bortflyttning..nn.1
  bortforsla_1_V = mkV "bortforslar" ; -- bortforsla..vb.1
  bortforslande_1_N = mkN "bortforslande" ; -- bortforslande..nn.1
  bortforsling_1_N = mkN "bortforsling" ; -- bortforsling..nn.1
  bortfärd_1_N = mkN "bortfärd" ; -- bortfärd..nn.1
  bortföra_1_V = mkV "bortföra" "bortförde" "bortfört" ; -- bortföra..vb.1
  bortförande_1_N = mkN "bortförande" ; -- bortförande..nn.1
  bortförklara_1_V = mkV "bortförklarar" ; -- bortförklara..vb.1
  bortförklarande_1_N = mkN "bortförklarande" ; -- bortförklarande..nn.1
  bortförklaring_1_N = mkN "bortförklaring" ; -- bortförklaring..nn.1
  bortförklaringsteologi_1_N = mkN "bortförklaringsteologi" ; -- bortförklaringsteologi..nn.1
  bortgivande_1_N = mkN "bortgivande" ; -- bortgivande..nn.1
  bortglömd_1_A = mkA "bortglömd" "bortglömt" ; -- bortglömd..av.1
  bortglömdhet_1_N = mkN "bortglömdhet" ; -- bortglömdhet..nn.1
  bortgå_1_V = mkV "bortgå" "bortgick" "bortgått" ; -- bortgå..vb.1
  bortgående_1_N = mkN "bortgående" ; -- bortgående..nn.1
  bortgång_1_N = mkN "bortgång" ; -- bortgång..nn.1
  bortgången_1_A = mkA "bortgången" ; -- bortgången..av.1
  bortifrån_1_Adv = mkAdv "bortifrån" ; -- bortifrån..ab.1
  bortkastad_1_A = mkA "bortkastad" ; -- bortkastad..av.1
  bortklippning_1_N = mkN "bortklippning" ; -- bortklippning..nn.1
  bortkollring_1_N = mkN "bortkollring" ; -- bortkollring..nn.1
  bortkommen_1_A = mkA "bortkommen" "bortkommet" "bortkomna" "bortkomna" "bortkomnare" "bortkomnast" "bortkomnaste" ; -- bortkommen..av.1
  bortkommenhet_1_N = mkN "bortkommenhet" ; -- bortkommenhet..nn.1
  bortkörd_1_A = mkA "bortkörd" "bortkört" ; -- bortkörd..av.1
  bortlottning_1_N = mkN "bortlottning" ; -- bortlottning..nn.1
  bortlova_1_V = mkV "bortlovar" ; -- bortlova..vb.1
  bortlovande_1_N = mkN "bortlovande" ; -- bortlovande..nn.1
  bortläggning_1_N = mkN "bortläggning" ; -- bortläggning..nn.1
  bortlåning_1_N = mkN "bortlåning" ; -- bortlåning..nn.1
  bortmarsch_1_N = mkN "bortmarsch" ; -- bortmarsch..nn.1
  bortmontera_1_V = mkV "bortmonterar" ; -- bortmontera..vb.1
  bortmota_1_V = mkV "bortmotar" ; -- bortmota..vb.1
  bortmotande_1_N = mkN "bortmotande" ; -- bortmotande..nn.1
  bortmotning_1_N = mkN "bortmotning" ; -- bortmotning..nn.1
  bortnötning_1_N = mkN "bortnötning" ; -- bortnötning..nn.1
  bortodling_1_N = mkN "bortodling" ; -- bortodling..nn.1
  bortoperera_1_V = mkV "bortopererar" ; -- bortoperera..vb.1
  bortopererande_1_N = mkN "bortopererande" ; -- bortopererande..nn.1
  bortovaro_1_N = mkN "bortovaro" ; -- bortovaro..nn.1
  bortplockning_1_N = mkN "bortplockning" ; -- bortplockning..nn.1
  bortplottrande_1_N = mkN "bortplottrande" ; -- bortplottrande..nn.1
  bortrakning_1_N = mkN "bortrakning" ; -- bortrakning..nn.1
  bortrationalisera_1_V = mkV "bortrationaliserar" ; -- bortrationalisera..vb.1
  bortrationaliserande_1_N = mkN "bortrationaliserande" ; -- bortrationaliserande..nn.1
  bortrationalisering_1_N = mkN "bortrationalisering" ; -- bortrationalisering..nn.1
  bortrensning_1_N = mkN "bortrensning" ; -- bortrensning..nn.1
  bortresa_1_N = mkN "bortresa" ; -- bortresa..nn.1
  bortresonera_1_V = mkV "bortresonerar" ; -- bortresonera..vb.1
  bortresonerande_1_N = mkN "bortresonerande" ; -- bortresonerande..nn.1
  bortresonerbar_1_A = mkA "bortresonerbar" ; -- bortresonerbar..av.1
  bortresonerbarhet_1_N = mkN "bortresonerbarhet" ; -- bortresonerbarhet..nn.1
  bortresonering_1_N = mkN "bortresonering" ; -- bortresonering..nn.1
  bortrest_1_A = mkA "bortrest" "bortrest" ; -- bortrest..av.1
  bortresthet_1_N = mkN "bortresthet" ; -- bortresthet..nn.1
  bortrinna_1_V = mkV "bortrinna" "bortrann" "bortrunnit" ; -- bortrinna..vb.1
  bortrinnande_1_N = mkN "bortrinnande" ; -- bortrinnande..nn.1
  bortrivning_1_N = mkN "bortrivning" ; -- bortrivning..nn.1
  bortryckning_1_N = mkN "bortryckning" ; -- bortryckning..nn.1
  bortryckt_1_A = mkA "bortryckt" "bortryckt" ; -- bortryckt..av.1
  borträkna_1_V = mkV "borträknar" ; -- borträkna..vb.1
  borträknande_1_N = mkN "borträknande" ; -- borträknande..nn.1
  bortröjning_1_N = mkN "bortröjning" ; -- bortröjning..nn.1
  bortröva_1_V = mkV "bortrövar" ; -- bortröva..vb.1
  bortrövande_1_N = mkN "bortrövande" ; -- bortrövande..nn.1
  bortschabblad_1_A = mkA "bortschabblad" ; -- bortschabblad..av.1
  bortschackring_1_N = mkN "bortschackring" ; -- bortschackring..nn.1
  bortse_1_V = mkV "bortse" "bortsåg" "bortsett" ; -- bortse..vb.1
  bortseende_1_N = mkN "bortseende" ; -- bortseende..nn.1
  bortsida_1_N = mkN "bortsida" ; -- bortsida..nn.1
  bortskaffa_1_V = mkV "bortskaffar" ; -- bortskaffa..vb.1
  bortskaffande_1_N = mkN "bortskaffande" ; -- bortskaffande..nn.1
  bortskaffning_1_N = mkN "bortskaffning" ; -- bortskaffning..nn.1
  bortskjuten_1_A = mkA "bortskjuten" ; -- bortskjuten..av.1
  bortskrapning_1_N = mkN "bortskrapning" ; -- bortskrapning..nn.1
  bortskrivning_1_N = mkN "bortskrivning" ; -- bortskrivning..nn.1
  bortskrämma_1_V = mkV "bortskrämma" "bortskrämme" "bortskrämt" ; -- bortskrämma..vb.1
  bortskrämmande_1_N = mkN "bortskrämmande" ; -- bortskrämmande..nn.1
  bortskrämning_1_N = mkN "bortskrämning" ; -- bortskrämning..nn.1
  bortskämd_1_A = mkA "bortskämd" "bortskämt" ; -- bortskämd..av.1
  bortskämdhet_1_N = mkN "bortskämdhet" "bortskämdheter" ; -- bortskämdhet..nn.1
  bortskänka_1_V = mkV "bortskänker" ; -- bortskänka..vb.1
  bortskänkande_1_N = mkN "bortskänkande" ; -- bortskänkande..nn.1
  bortskänkning_1_N = mkN "bortskänkning" ; -- bortskänkning..nn.1
  bortskärning_1_N = mkN "bortskärning" ; -- bortskärning..nn.1
  bortsköljning_1_N = mkN "bortsköljning" ; -- bortsköljning..nn.1
  bortslumpa_1_V = mkV "bortslumpar" ; -- bortslumpa..vb.1
  bortslumpande_1_N = mkN "bortslumpande" ; -- bortslumpande..nn.1
  bortslumpning_1_N = mkN "bortslumpning" ; -- bortslumpning..nn.1
  bortsluta_1_V = mkV "bortsluta" "bortslöt" "bortslutit" ; -- bortsluta..vb.1
  bortslutande_1_N = mkN "bortslutande" ; -- bortslutande..nn.1
  bortspolning_1_N = mkN "bortspolning" ; -- bortspolning..nn.1
  bortsprängning_1_N = mkN "bortsprängning" ; -- bortsprängning..nn.1
  bortstötning_1_N = mkN "bortstötning" ; -- bortstötning..nn.1
  bortsättning_1_N = mkN "bortsättning" ; -- bortsättning..nn.1
  bortta_1_V = mkV "borttaga" "borttog" "borttagit" ; -- bortta..vb.1
  borttagande_1_N = mkN "borttagande" ; -- borttagande..nn.1
  borttagning_1_N = mkN "borttagning" ; -- borttagning..nn.1
  borttappa_1_V = mkV "borttappar" ; -- borttappa..vb.1
  borttappad_1_A = mkA "borttappad" ; -- borttappad..av.1
  borttappande_1_N = mkN "borttappande" ; -- borttappande..nn.1
  borttorka_1_V = mkV "borttorkar" ; -- borttorka..vb.1
  borttorkande_1_N = mkN "borttorkande" ; -- borttorkande..nn.1
  borttränga_1_V = mkV "borttränger" ; -- borttränga..vb.1
  bortträngande_1_N = mkN "bortträngande" ; -- bortträngande..nn.1
  bortträngning_1_N = mkN "bortträngning" ; -- bortträngning..nn.1
  borttvagning_1_N = mkN "borttvagning" ; -- borttvagning..nn.1
  borttvättning_1_N = mkN "borttvättning" ; -- borttvättning..nn.1
  bortvikt_1_N = mkN "bortvikt" ; -- bortvikt..nn.1
  bortvräka_1_V = mkV "bortvräker" ; -- bortvräka..vb.1
  bortvräkande_1_N = mkN "bortvräkande" ; -- bortvräkande..nn.1
  bortväg_1_N = mkN "bortväg" ; -- bortväg..nn.1
  bortvältning_1_N = mkN "bortvältning" ; -- bortvältning..nn.1
  bortvältring_1_N = mkN "bortvältring" ; -- bortvältring..nn.1
  bortvänd_1_A = mkA "bortvänd" ; -- bortvänd..av.1
  bortända_1_N = mkN "bortända" ; -- bortända..nn.1
  bortände_1_N = mkN "bortände" utrum  ; -- bortände..nn.1
  bortödsling_1_N = mkN "bortödsling" ; -- bortödsling..nn.1
  bortöver_1_Adv = mkAdv "bortöver" ; -- bortöver..ab.1
  bosatt_1_A = mkA "bosatt" ; -- bosatt..av.1
  bosch_1_N = mkN "bosch" neutrum  ; -- bosch..nn.1
  boskap_1_N = mkN "boskap" ; -- boskap..nn.1
  boskapsavel_1_N = mkN "boskapsavel" ; -- boskapsavel..nn.1
  boskapsdrift_1_N = mkN "boskapsdrift" ; -- boskapsdrift..nn.1
  boskapsfoder_1_N = mkN "boskapsfoder" neutrum  ; -- boskapsfoder..nn.1
  boskapshjord_1_N = mkN "boskapshjord" ; -- boskapshjord..nn.1
  boskapsmarknad_1_N = mkN "boskapsmarknad" "boskapsmarknader" ; -- boskapsmarknad..nn.1
  boskapspest_1_N = mkN "boskapspest" ; -- boskapspest..nn.1
  boskapsras_1_N = mkN "boskapsras" "boskapsraser" ; -- boskapsras..nn.1
  boskapsskötande_1_A = mkA "boskapsskötande" ; -- boskapsskötande..av.1
  boskapsskötare_1_N = mkN "boskapsskötare" utrum  ; -- boskapsskötare..nn.1
  boskapsskötsel_1_N = mkN "boskapsskötsel" ; -- boskapsskötsel..nn.1
  boskapsstock_1_N = mkN "boskapsstock" ; -- boskapsstock..nn.1
  boskapsstängsel_1_N = mkN "boskapsstängsel" neutrum  ; -- boskapsstängsel..nn.1
  boskapstjuv_1_N = mkN "boskapstjuv" ; -- boskapstjuv..nn.1
  boskapsuppfödning_1_N = mkN "boskapsuppfödning" ; -- boskapsuppfödning..nn.1
  boskifte_1_N = mkN "boskifte" ; -- boskifte..nn.1
  boskillnad_1_N = mkN "boskillnad" "boskillnader" ; -- boskillnad..nn.1
  bosniak_1_N = mkN "bosniak" "bosniaker" ; -- bosniak..nn.1
  bosnienkroatisk_1_A = mkA "bosnienkroatisk" ; -- bosnienkroatisk..av.1
  bosnienserbisk_1_A = mkA "bosnienserbisk" ; -- bosnienserbisk..av.1
  bosnier_1_N = mkN "bosnier" "bosniern" "bosnier" "bosnierna" ; -- bosnier..nn.1
  bosnisk_1_A = mkA "bosnisk" ; -- bosnisk..av.1
  bosniska_1_N = mkN "bosniska" ; -- bosniska..nn.1
  boson_1_N = mkN "boson" "bosoner" ; -- boson..nn.1
  boss_1_N = mkN "boss" ; -- boss..nn.1
  boss_2_N = mkN "boss" neutrum  ; -- boss..nn.2
  bossig_1_A = mkA "bossig" ; -- bossig..av.1
  bossighet_1_N = mkN "bossighet" ; -- bossighet..nn.1
  bossvälde_1_N = mkN "bossvälde" ; -- bossvälde..nn.1
  bostad_1_N = mkN "bostad" "bostäder" ; -- bostad..nn.1
  bostadsadress_1_N = mkN "bostadsadress" "bostadsadresser" ; -- bostadsadress..nn.1
  bostadsband_1_N = mkN "bostadsband" neutrum  ; -- bostadsband..nn.1
  bostadsbestånd_1_N = mkN "bostadsbestånd" neutrum  ; -- bostadsbestånd..nn.1
  bostadsbidrag_1_N = mkN "bostadsbidrag" neutrum  ; -- bostadsbidrag..nn.1
  bostadsbolag_1_N = mkN "bostadsbolag" neutrum  ; -- bostadsbolag..nn.1
  bostadsbrist_1_N = mkN "bostadsbrist" ; -- bostadsbrist..nn.1
  bostadsbubbla_1_N = mkN "bostadsbubbla" ; -- bostadsbubbla..nn.1
  bostadsbyggande_1_N = mkN "bostadsbyggande" ; -- bostadsbyggande..nn.1
  bostadsexpert_1_N = mkN "bostadsexpert" "bostadsexperter" ; -- bostadsexpert..nn.1
  bostadsförbättringslån_1_N = mkN "bostadsförbättringslån" neutrum  ; -- bostadsförbättringslån..nn.1
  bostadsföretag_1_N = mkN "bostadsföretag" neutrum  ; -- bostadsföretag..nn.1
  bostadsförmedling_1_N = mkN "bostadsförmedling" ; -- bostadsförmedling..nn.1
  bostadshus_1_N = mkN "bostadshus" neutrum  ; -- bostadshus..nn.1
  bostadsinspektion_1_N = mkN "bostadsinspektion" ; -- bostadsinspektion..nn.1
  bostadsklipp_1_N = mkN "bostadsklipp" neutrum  ; -- bostadsklipp..nn.1
  bostadskooperation_1_N = mkN "bostadskooperation" ; -- bostadskooperation..nn.1
  bostadskredit_1_N = mkN "bostadskredit" "bostadskrediter" ; -- bostadskredit..nn.1
  bostadskvarter_1_N = mkN "bostadskvarter" "bostadskvarteret" "bostadskvarter" "bostadskvarteren" ; -- bostadskvarter..nn.1
  bostadskö_1_N = mkN "bostadskö" "bostadskön" "bostadsköer" "bostadsköerna" ; -- bostadskö..nn.1
  bostadsköp_1_N = mkN "bostadsköp" neutrum  ; -- bostadsköp..nn.1
  bostadslägenhet_1_N = mkN "bostadslägenhet" "bostadslägenheter" ; -- bostadslägenhet..nn.1
  bostadslänga_1_N = mkN "bostadslänga" ; -- bostadslänga..nn.1
  bostadslån_1_N = mkN "bostadslån" neutrum  ; -- bostadslån..nn.1
  bostadslös_1_A = mkA "bostadslös" ; -- bostadslös..av.1
  bostadslöshet_1_N = mkN "bostadslöshet" ; -- bostadslöshet..nn.1
  bostadsmarknad_1_N = mkN "bostadsmarknad" "bostadsmarknader" ; -- bostadsmarknad..nn.1
  bostadsmiljö_1_N = mkN "bostadsmiljö" "bostadsmiljön" "bostadsmiljöer" "bostadsmiljöerna" ; -- bostadsmiljö..nn.1
  bostadsmässig_1_A = mkA "bostadsmässig" ; -- bostadsmässig..av.1
  bostadsnämnd_1_N = mkN "bostadsnämnd" "bostadsnämnder" ; -- bostadsnämnd..nn.1
  bostadsområde_1_N = mkN "bostadsområde" ; -- bostadsområde..nn.1
  bostadspolitik_1_N = mkN "bostadspolitik" ; -- bostadspolitik..nn.1
  bostadspolitisk_1_A = mkA "bostadspolitisk" ; -- bostadspolitisk..av.1
  bostadspris_1_N = mkN "bostadspris" neutrum  ; -- bostadspris..nn.1
  bostadsproduktion_1_N = mkN "bostadsproduktion" ; -- bostadsproduktion..nn.1
  bostadsrätt_1_N = mkN "bostadsrätt" "bostadsrätter" ; -- bostadsrätt..nn.1
  bostadsrättsförening_1_N = mkN "bostadsrättsförening" ; -- bostadsrättsförening..nn.1
  bostadsrättsinnehavare_1_N = mkN "bostadsrättsinnehavare" utrum  ; -- bostadsrättsinnehavare..nn.1
  bostadsrättspris_1_N = mkN "bostadsrättspris" neutrum  ; -- bostadsrättspris..nn.1
  bostadssocial_1_A = mkA "bostadssocial" ; -- bostadssocial..av.1
  bostadssparande_1_N = mkN "bostadssparande" ; -- bostadssparande..nn.1
  bostadsstyrelse_1_N = mkN "bostadsstyrelse" "bostadsstyrelser" ; -- bostadsstyrelse..nn.1
  bostadssökande_1_N = mkN "bostadssökande" "bostadssökanden" "bostadssökanden" "bostadssökandena" ; -- bostadssökande..nn.1
  bostadstillägg_1_N = mkN "bostadstillägg" neutrum  ; -- bostadstillägg..nn.1
  boston_1_N = mkN "boston" ; -- boston..nn.1
  bostongurka_1_N = mkN "bostongurka" ; -- bostongurka..nn.1
  bostonvals_1_N = mkN "bostonvals" "bostonvalser" ; -- bostonvals..nn.1
  boställe_1_N = mkN "boställe" ; -- boställe..nn.1
  bosättare_1_N = mkN "bosättare" utrum  ; -- bosättare..nn.1
  bosättning_1_N = mkN "bosättning" ; -- bosättning..nn.1
  bosättningsaffär_1_N = mkN "bosättningsaffär" "bosättningsaffärer" ; -- bosättningsaffär..nn.1
  bosättningslån_1_N = mkN "bosättningslån" neutrum  ; -- bosättningslån..nn.1
  bosättningsort_1_N = mkN "bosättningsort" "bosättningsorter" ; -- bosättningsort..nn.1
  bosättningsstopp_1_N = mkN "bosättningsstopp" neutrum  ; -- bosättningsstopp..nn.1
  bot_1_N = mkN "bot" ; -- bot..nn.1
  bot_2_N = mkN "bot" ; -- bot..nn.2
  bot_3_N = mkN "bot" ; -- bot..nn.3
  bota_1_V = mkV "botar" ; -- bota..vb.1
  botande_1_N = mkN "botande" ; -- botande..nn.1
  botanik_1_N = mkN "botanik" ; -- botanik..nn.1
  botaniker_1_N = mkN "botaniker" "botanikern" "botaniker" "botanikerna" ; -- botaniker..nn.1
  botanikspade_1_N = mkN "botanikspade" utrum  ; -- botanikspade..nn.1
  botanisera_1_V = mkV "botaniserar" ; -- botanisera..vb.1
  botaniserande_1_N = mkN "botaniserande" ; -- botaniserande..nn.1
  botanisering_1_N = mkN "botanisering" ; -- botanisering..nn.1
  botanisk_1_A = mkA "botanisk" ; -- botanisk..av.1
  botanist_1_N = mkN "botanist" "botanister" ; -- botanist..nn.1
  botanistspade_1_N = mkN "botanistspade" utrum  ; -- botanistspade..nn.1
  botbar_1_A = mkA "botbar" ; -- botbar..av.1
  botbarhet_1_N = mkN "botbarhet" ; -- botbarhet..nn.1
  botdag_1_N = mkN "botdag" ; -- botdag..nn.1
  botemedel_1_N = mkN "botemedel" neutrum  ; -- botemedel..nn.1
  botfärdig_1_A = mkA "botfärdig" ; -- botfärdig..av.1
  botfärdighet_1_N = mkN "botfärdighet" ; -- botfärdighet..nn.1
  botgörare_1_N = mkN "botgörare" utrum  ; -- botgörare..nn.1
  botgörartåg_1_N = mkN "botgörartåg" neutrum  ; -- botgörartåg..nn.1
  botgörelse_1_N = mkN "botgörelse" "botgörelser" ; -- botgörelse..nn.1
  botgöring_1_N = mkN "botgöring" ; -- botgöring..nn.1
  botlig_1_A = mkA "botlig" ; -- botlig..av.1
  botlighet_1_N = mkN "botlighet" ; -- botlighet..nn.1
  botox_1_N = mkN "botox" ; -- botox..nn.1
  botoxförlamning_1_N = mkN "botoxförlamning" ; -- botoxförlamning..nn.1
  botswanier_1_N = mkN "botswanier" "botswaniern" "botswanier" "botswanierna" ; -- botswanier..nn.1
  botswansk_1_A = mkA "botswansk" ; -- botswansk..av.1
  botswanska_1_N = mkN "botswanska" ; -- botswanska..nn.1
  botten_1_A = mkA "botten" ; -- botten..av.1
  botten_1_N = mkN "botten" ; -- botten..nn.1
  bottenavlagring_1_N = mkN "bottenavlagring" ; -- bottenavlagring..nn.1
  bottenbjälke_1_N = mkN "bottenbjälke" utrum  ; -- bottenbjälke..nn.1
  bottendjur_1_N = mkN "bottendjur" neutrum  ; -- bottendjur..nn.1
  bottendålig_1_A = mkA "bottendålig" ; -- bottendålig..av.1
  bottendålighet_1_N = mkN "bottendålighet" ; -- bottendålighet..nn.1
  bottendöd_1_N = mkN "bottendöd" ; -- bottendöd..nn.1
  bottenfast_1_A = mkA "bottenfast" "bottenfast" ; -- bottenfast..av.1
  bottenformation_1_N = mkN "bottenformation" ; -- bottenformation..nn.1
  bottenfrysa_1_V = mkV "bottenfryser" ; -- bottenfrysa..vb.1
  bottenfrysande_1_N = mkN "bottenfrysande" ; -- bottenfrysande..nn.1
  bottenfällning_1_N = mkN "bottenfällning" ; -- bottenfällning..nn.1
  bottenfärg_1_N = mkN "bottenfärg" "bottenfärger" ; -- bottenfärg..nn.1
  bottengarn_1_N = mkN "bottengarn" neutrum  ; -- bottengarn..nn.1
  bottenhederlig_1_A = mkA "bottenhederlig" ; -- bottenhederlig..av.1
  bottenhederlighet_1_N = mkN "bottenhederlighet" ; -- bottenhederlighet..nn.1
  bottenis_1_N = mkN "bottenis" ; -- bottenis..nn.1
  bottenkran_1_N = mkN "bottenkran" ; -- bottenkran..nn.1
  bottenkurs_1_N = mkN "bottenkurs" "bottenkurser" ; -- bottenkurs..nn.1
  bottenkvark_1_N = mkN "bottenkvark" ; -- bottenkvark..nn.1
  bottenkänning_1_N = mkN "bottenkänning" ; -- bottenkänning..nn.1
  bottenlag_1_N = mkN "bottenlag" neutrum  ; -- bottenlag..nn.1
  bottenlevande_1_A = mkA "bottenlevande" ; -- bottenlevande..av.1
  bottenläge_1_N = mkN "bottenläge" ; -- bottenläge..nn.1
  bottenlån_1_N = mkN "bottenlån" neutrum  ; -- bottenlån..nn.1
  bottenlös_1_A = mkA "bottenlös" ; -- bottenlös..av.1
  bottenlöshet_1_N = mkN "bottenlöshet" "bottenlösheter" ; -- bottenlöshet..nn.1
  bottenmagnet_1_N = mkN "bottenmagnet" "bottenmagneter" ; -- bottenmagnet..nn.1
  bottenmorän_1_N = mkN "bottenmorän" ; -- bottenmorän..nn.1
  bottennapp_1_N = mkN "bottennapp" neutrum  ; -- bottennapp..nn.1
  bottenplan_1_N = mkN "bottenplan" neutrum  ; -- bottenplan..nn.1
  bottenplatta_1_N = mkN "bottenplatta" ; -- bottenplatta..nn.1
  bottenrekord_1_N = mkN "bottenrekord" neutrum  ; -- bottenrekord..nn.1
  bottenrev_1_N = mkN "bottenrev" neutrum  ; -- bottenrev..nn.1
  bottenreva_1_V = mkV "bottenrevar" ; -- bottenreva..vb.1
  bottenrevande_1_N = mkN "bottenrevande" ; -- bottenrevande..nn.1
  bottensats_1_N = mkN "bottensats" "bottensatser" ; -- bottensats..nn.1
  bottensediment_1_N = mkN "bottensediment" neutrum  ; -- bottensediment..nn.1
  bottenskikt_1_N = mkN "bottenskikt" neutrum  ; -- bottenskikt..nn.1
  bottenskola_1_N = mkN "bottenskola" ; -- bottenskola..nn.1
  bottenskrap_1_N = mkN "bottenskrap" neutrum  ; -- bottenskrap..nn.1
  bottenskrapa_1_N = mkN "bottenskrapa" ; -- bottenskrapa..nn.1
  bottenskrapa_1_V = mkV "bottenskrapar" ; -- bottenskrapa..vb.1
  bottenskrapande_1_N = mkN "bottenskrapande" ; -- bottenskrapande..nn.1
  bottenskvätt_1_N = mkN "bottenskvätt" ; -- bottenskvätt..nn.1
  bottenskyla_1_N = mkN "bottenskyla" ; -- bottenskyla..nn.1
  bottenstock_1_N = mkN "bottenstock" ; -- bottenstock..nn.1
  bottentryck_1_N = mkN "bottentryck" neutrum  ; -- bottentryck..nn.1
  bottenvatten_1_N = mkN "bottenvatten" "bottenvattnet" "bottenvatten" "bottenvattnen" ; -- bottenvatten..nn.1
  bottenventil_1_N = mkN "bottenventil" "bottenventiler" ; -- bottenventil..nn.1
  bottenvåning_1_N = mkN "bottenvåning" ; -- bottenvåning..nn.1
  bottenyta_1_N = mkN "bottenyta" ; -- bottenyta..nn.1
  bottin_1_N = mkN "bottin" "bottiner" ; -- bottin..nn.1
  bottna_1_V = mkV "bottnar" ; -- bottna..vb.1
  bottnande_1_N = mkN "bottnande" ; -- bottnande..nn.1
  bottning_1_N = mkN "bottning" ; -- bottning..nn.1
  bottnisk_1_A = mkA "bottnisk" ; -- bottnisk..av.1
  botulin_1_N = mkN "botulin" neutrum  ; -- botulin..nn.1
  botulism_1_N = mkN "botulism" "botulismer" ; -- botulism..nn.1
  boudoir_1_N = mkN "boudoir" "boudoirer" ; -- boudoir..nn.1
  bouillabaisse_1_N = mkN "bouillabaisse" utrum  ; -- bouillabaisse..nn.1
  boule_1_N = mkN "boule" utrum  ; -- boule..nn.1
  boulevard_1_N = mkN "boulevard" "boulevarder" ; -- boulevard..nn.1
  boulevardpress_1_N = mkN "boulevardpress" ; -- boulevardpress..nn.1
  bouppteckning_1_N = mkN "bouppteckning" ; -- bouppteckning..nn.1
  bouquet_1_N = mkN "bouquet" "bouqueter" ; -- bouquet..nn.1
  bourbon_1_N = mkN "bourbon" ; -- bourbon..nn.1
  bourgeoisie_1_N = mkN "bourgeoisie" utrum  ; -- bourgeoisie..nn.1
  bourgogne_1_N = mkN "bourgogne" "bourgogner" ; -- bourgogne..nn.1
  bourgognevin_1_N = mkN "bourgognevin" "bourgognevinet" "bourgogneviner" "bourgognevinerna" ; -- bourgognevin..nn.1
  boutique_1_N = mkN "boutique" "boutiquer" ; -- boutique..nn.1
  boutredare_1_N = mkN "boutredare" "boutredareen" "boutredarear" "boutredarearna" ; -- boutredare..nn.1
  boutredning_1_N = mkN "boutredning" ; -- boutredning..nn.1
  boutredningsman_1_N = mkN "boutredningsman" "boutredningsmannen" "boutredningsmän" "boutredningsmännen" ; -- boutredningsman..nn.1
  bouzouki_1_N = mkN "bouzouki" "bouzoukin" "bouzoukis" "bouzoukisen" ; -- bouzouki..nn.1
  bov_1_N = mkN "bov" ; -- bov..nn.1
  bovaktig_1_A = mkA "bovaktig" ; -- bovaktig..av.1
  bovaktighet_1_N = mkN "bovaktighet" ; -- bovaktighet..nn.1
  bovete_1_N = mkN "bovete" ; -- bovete..nn.1
  boveteplätt_1_N = mkN "boveteplätt" ; -- boveteplätt..nn.1
  bovfysionomi_1_N = mkN "bovfysionomi" "bovfysionomier" ; -- bovfysionomi..nn.1
  bovstreck_1_N = mkN "bovstreck" neutrum  ; -- bovstreck..nn.1
  bowla_1_V = mkV "bowlar" ; -- bowla..vb.1
  bowlande_1_N = mkN "bowlande" ; -- bowlande..nn.1
  bowlare_1_N = mkN "bowlare" utrum  ; -- bowlare..nn.1
  bowling_1_N = mkN "bowling" ; -- bowling..nn.1
  bowlingbana_1_N = mkN "bowlingbana" ; -- bowlingbana..nn.1
  bowlinghall_1_N = mkN "bowlinghall" ; -- bowlinghall..nn.1
  bowlingklot_1_N = mkN "bowlingklot" neutrum  ; -- bowlingklot..nn.1
  box_1_N = mkN "box" ; -- box..nn.1
  box_2_N = mkN "box" neutrum  ; -- box..nn.2
  boxa_1_V = mkV "boxar" ; -- boxa..vb.1
  boxande_1_N = mkN "boxande" ; -- boxande..nn.1
  boxare_1_N = mkN "boxare" utrum  ; -- boxare..nn.1
  boxboll_1_N = mkN "boxboll" ; -- boxboll..nn.1
  boxer_1_N = mkN "boxer" ; -- boxer..nn.1
  boxervalp_1_N = mkN "boxervalp" ; -- boxervalp..nn.1
  boxhandske_1_N = mkN "boxhandske" utrum  ; -- boxhandske..nn.1
  boxkalv_1_N = mkN "boxkalv" ; -- boxkalv..nn.1
  boxning_1_N = mkN "boxning" ; -- boxning..nn.1
  boxningslokal_1_N = mkN "boxningslokal" "boxningslokaler" ; -- boxningslokal..nn.1
  boxningsmatch_1_N = mkN "boxningsmatch" "boxningsmatcher" ; -- boxningsmatch..nn.1
  boxningsring_1_N = mkN "boxningsring" ; -- boxningsring..nn.1
  boxningstränad_1_A = mkA "boxningstränad" ; -- boxningstränad..av.1
  boxningsträning_1_N = mkN "boxningsträning" ; -- boxningsträning..nn.1
  boxnummer_1_N = mkN "boxnummer" neutrum  ; -- boxnummer..nn.1
  boyscout_1_N = mkN "boyscout" "boyscouter" ; -- boyscout..nn.1
  boägg_1_N = mkN "boägg" neutrum  ; -- boägg..nn.1
  bra_1_Adv = mkAdv "bra" ; -- bra..ab.1
  bra_2_Adv = mkAdv "bra" ; -- bra..ab.2
  bra_1_A = mkA "bra" "bra" "bra" "bättre" "bäst" ; -- bra..av.1
  bra_2_A = mkA "bra" ; -- bra..av.2
  bracka_1_N = mkN "bracka" ; -- bracka..nn.1
  brackig_1_A = mkA "brackig" ; -- brackig..av.1
  brackighet_1_N = mkN "brackighet" ; -- brackighet..nn.1
  brackvattenlevande_1_A = mkA "brackvattenlevande" ; -- brackvattenlevande..av.1
  bragd_1_N = mkN "bragd" "bragder" ; -- bragd..nn.1
  bragdguld_1_N = mkN "bragdguld" neutrum  ; -- bragdguld..nn.1
  bragdlopp_1_N = mkN "bragdlopp" neutrum  ; -- bragdlopp..nn.1
  bragdmässig_1_A = mkA "bragdmässig" ; -- bragdmässig..av.1
  bragelöfte_1_N = mkN "bragelöfte" ; -- bragelöfte..nn.1
  brailleskrift_1_N = mkN "brailleskrift" ; -- brailleskrift..nn.1
  brainstorming_1_N = mkN "brainstorming" ; -- brainstorming..nn.1
  brak_1_N = mkN "brak" neutrum  ; -- brak..nn.1
  braka_1_V = mkV "brakar" ; -- braka..vb.1
  brakande_1_N = mkN "brakande" ; -- brakande..nn.1
  brakfest_1_N = mkN "brakfest" "brakfester" ; -- brakfest..nn.1
  brakfiasko_1_N = mkN "brakfiasko" "brakfiaskot" "brakfiaskon" "brakfiaskona" ; -- brakfiasko..nn.1
  brakmiddag_1_N = mkN "brakmiddag" ; -- brakmiddag..nn.1
  brakskit_1_N = mkN "brakskit" ; -- brakskit..nn.1
  brakskiva_1_N = mkN "brakskiva" ; -- brakskiva..nn.1
  braksuccé_1_N = mkN "braksuccé" "braksuccéer" ; -- braksuccé..nn.1
  brakteat_1_N = mkN "brakteat" "brakteater" ; -- brakteat..nn.1
  brakved_1_N = mkN "brakved" ; -- brakved..nn.1
  brakycefal_1_A = mkA "brakycefal" ; -- brakycefal..av.1
  brakycefali_1_N = mkN "brakycefali" ; -- brakycefali..nn.1
  bralla_1_N = mkN "bralla" ; -- bralla..nn.1
  brallis_1_N = mkN "brallis" ; -- brallis..nn.1
  braman_1_N = mkN "braman" "bramaner" ; -- braman..nn.1
  bramanism_1_N = mkN "bramanism" "bramanismer" ; -- bramanism..nn.1
  bramansk_1_A = mkA "bramansk" ; -- bramansk..av.1
  bramin_1_N = mkN "bramin" "braminer" ; -- bramin..nn.1
  bramsegel_1_N = mkN "bramsegel" neutrum  ; -- bramsegel..nn.1
  bramstång_1_N = mkN "bramstång" "bramstänger" ; -- bramstång..nn.1
  brand_1_N = mkN "brand" "bränder" ; -- brand..nn.1
  brandalarm_1_N = mkN "brandalarm" neutrum  ; -- brandalarm..nn.1
  brandartikel_1_N = mkN "brandartikel" ; -- brandartikel..nn.1
  brandattentat_1_N = mkN "brandattentat" neutrum  ; -- brandattentat..nn.1
  brandbefäl_1_N = mkN "brandbefäl" neutrum  ; -- brandbefäl..nn.1
  brandbil_1_N = mkN "brandbil" ; -- brandbil..nn.1
  brandbomb_1_N = mkN "brandbomb" "brandbomber" ; -- brandbomb..nn.1
  brandbotten_1_N = mkN "brandbotten" ; -- brandbotten..nn.1
  brandchef_1_N = mkN "brandchef" "brandchefer" ; -- brandchef..nn.1
  branddike_1_N = mkN "branddike" ; -- branddike..nn.1
  branddörr_1_N = mkN "branddörr" ; -- branddörr..nn.1
  brandfackla_1_N = mkN "brandfackla" ; -- brandfackla..nn.1
  brandfara_1_N = mkN "brandfara" ; -- brandfara..nn.1
  brandfarlig_1_A = mkA "brandfarlig" ; -- brandfarlig..av.1
  brandfarlighet_1_N = mkN "brandfarlighet" ; -- brandfarlighet..nn.1
  brandfri_1_A = mkA "brandfri" "brandfritt" ; -- brandfri..av.1
  brandförsvar_1_N = mkN "brandförsvar" neutrum  ; -- brandförsvar..nn.1
  brandförsäkra_1_V = mkV "brandförsäkrar" ; -- brandförsäkra..vb.1
  brandförsäkring_1_N = mkN "brandförsäkring" ; -- brandförsäkring..nn.1
  brandförsäkringsavtal_1_N = mkN "brandförsäkringsavtal" neutrum  ; -- brandförsäkringsavtal..nn.1
  brandförsäkringsbelopp_1_N = mkN "brandförsäkringsbelopp" neutrum  ; -- brandförsäkringsbelopp..nn.1
  brandförsäkringsbolag_1_N = mkN "brandförsäkringsbolag" neutrum  ; -- brandförsäkringsbolag..nn.1
  brandförsäkringsvärde_1_N = mkN "brandförsäkringsvärde" ; -- brandförsäkringsvärde..nn.1
  brandgata_1_N = mkN "brandgata" ; -- brandgata..nn.1
  brandgavel_1_N = mkN "brandgavel" ; -- brandgavel..nn.1
  brandgranat_1_N = mkN "brandgranat" "brandgranater" ; -- brandgranat..nn.1
  brandgrav_1_N = mkN "brandgrav" ; -- brandgrav..nn.1
  brandgul_1_A = mkA "brandgul" ; -- brandgul..av.1
  brandhärd_1_N = mkN "brandhärd" ; -- brandhärd..nn.1
  brandhärdig_1_A = mkA "brandhärdig" ; -- brandhärdig..av.1
  brandhärdighet_1_N = mkN "brandhärdighet" ; -- brandhärdighet..nn.1
  brandhärja_1_V = mkV "brandhärjar" ; -- brandhärja..vb.1
  brandhärjande_1_N = mkN "brandhärjande" ; -- brandhärjande..nn.1
  brandingenjör_1_N = mkN "brandingenjör" "brandingenjörer" ; -- brandingenjör..nn.1
  brandinspektion_1_N = mkN "brandinspektion" ; -- brandinspektion..nn.1
  brandinspektör_1_N = mkN "brandinspektör" "brandinspektörer" ; -- brandinspektör..nn.1
  brandkapten_1_N = mkN "brandkapten" "brandkaptener" ; -- brandkapten..nn.1
  brandkatastrof_1_N = mkN "brandkatastrof" "brandkatastrofer" ; -- brandkatastrof..nn.1
  brandkår_1_N = mkN "brandkår" "brandkårer" ; -- brandkår..nn.1
  brandkårsfrivillig_1_A = mkA "brandkårsfrivillig" ; -- brandkårsfrivillig..av.1
  brandkårsutryckning_1_N = mkN "brandkårsutryckning" ; -- brandkårsutryckning..nn.1
  brandlager_1_N = mkN "brandlager" neutrum  ; -- brandlager..nn.1
  brandlarm_1_N = mkN "brandlarm" neutrum  ; -- brandlarm..nn.1
  brandlukt_1_N = mkN "brandlukt" ; -- brandlukt..nn.1
  brandman_1_N = mkN "brandman" "brandmannen" "brandmän" "brandmännen" ; -- brandman..nn.1
  brandmansgrepp_1_N = mkN "brandmansgrepp" neutrum  ; -- brandmansgrepp..nn.1
  brandmur_1_N = mkN "brandmur" ; -- brandmur..nn.1
  brandoffer_1_N = mkN "brandoffer" neutrum  ; -- brandoffer..nn.1
  brandorsak_1_N = mkN "brandorsak" "brandorsaker" ; -- brandorsak..nn.1
  brandpost_1_N = mkN "brandpost" "brandposter" ; -- brandpost..nn.1
  brandredskap_1_N = mkN "brandredskap" neutrum  ; -- brandredskap..nn.1
  brandrest_1_N = mkN "brandrest" "brandrester" ; -- brandrest..nn.1
  brandrök_1_N = mkN "brandrök" ; -- brandrök..nn.1
  brandrör_1_N = mkN "brandrör" neutrum  ; -- brandrör..nn.1
  brandschaktare_1_N = mkN "brandschaktare" utrum  ; -- brandschaktare..nn.1
  brandsegel_1_N = mkN "brandsegel" neutrum  ; -- brandsegel..nn.1
  brandskada_1_N = mkN "brandskada" ; -- brandskada..nn.1
  brandskadad_1_A = mkA "brandskadad" ; -- brandskadad..av.1
  brandskatt_1_N = mkN "brandskatt" "brandskatter" ; -- brandskatt..nn.1
  brandskatta_1_V = mkV "brandskattar" ; -- brandskatta..vb.1
  brandskattande_1_N = mkN "brandskattande" ; -- brandskattande..nn.1
  brandskattning_1_N = mkN "brandskattning" ; -- brandskattning..nn.1
  brandskydd_1_N = mkN "brandskydd" neutrum  ; -- brandskydd..nn.1
  brandskyddslagstiftning_1_N = mkN "brandskyddslagstiftning" ; -- brandskyddslagstiftning..nn.1
  brandskåp_1_N = mkN "brandskåp" neutrum  ; -- brandskåp..nn.1
  brandslang_1_N = mkN "brandslang" ; -- brandslang..nn.1
  brandsläckarattrapp_1_N = mkN "brandsläckarattrapp" "brandsläckarattrapper" ; -- brandsläckarattrapp..nn.1
  brandsläckare_1_N = mkN "brandsläckare" utrum  ; -- brandsläckare..nn.1
  brandsoldat_1_N = mkN "brandsoldat" "brandsoldater" ; -- brandsoldat..nn.1
  brandspruta_1_N = mkN "brandspruta" ; -- brandspruta..nn.1
  brandstation_1_N = mkN "brandstation" ; -- brandstation..nn.1
  brandstege_1_N = mkN "brandstege" utrum  ; -- brandstege..nn.1
  brandstod_1_N = mkN "brandstod" ; -- brandstod..nn.1
  brandstodsbolag_1_N = mkN "brandstodsbolag" neutrum  ; -- brandstodsbolag..nn.1
  brandstyrka_1_N = mkN "brandstyrka" ; -- brandstyrka..nn.1
  brandsvamp_1_N = mkN "brandsvamp" ; -- brandsvamp..nn.1
  brandsyn_1_N = mkN "brandsyn" "brandsyner" ; -- brandsyn..nn.1
  brandsäker_1_A = mkA "brandsäker" ; -- brandsäker..av.1
  brandsäkerhet_1_N = mkN "brandsäkerhet" ; -- brandsäkerhet..nn.1
  brandtal_1_N = mkN "brandtal" neutrum  ; -- brandtal..nn.1
  brandtorn_1_N = mkN "brandtorn" neutrum  ; -- brandtorn..nn.1
  brandvakt_1_N = mkN "brandvakt" "brandvakter" ; -- brandvakt..nn.1
  brandvarnare_1_N = mkN "brandvarnare" utrum  ; -- brandvarnare..nn.1
  brandväsen_1_N = mkN "brandväsen" neutrum  ; -- brandväsen..nn.1
  brandövning_1_N = mkN "brandövning" ; -- brandövning..nn.1
  bransch_1_N = mkN "bransch" "branscher" ; -- bransch..nn.1
  branschförening_1_N = mkN "branschförening" ; -- branschförening..nn.1
  branschledande_1_A = mkA "branschledande" ; -- branschledande..av.1
  branschmässig_1_A = mkA "branschmässig" ; -- branschmässig..av.1
  branschorganisation_1_N = mkN "branschorganisation" ; -- branschorganisation..nn.1
  branschråd_1_N = mkN "branschråd" neutrum  ; -- branschråd..nn.1
  branschtidning_1_N = mkN "branschtidning" ; -- branschtidning..nn.1
  branschvana_1_N = mkN "branschvana" ; -- branschvana..nn.1
  brant_1_A = mkA "brant" "brant" ; -- brant..av.1
  brant_1_N = mkN "brant" "branter" ; -- brant..nn.1
  branthet_1_N = mkN "branthet" ; -- branthet..nn.1
  brasa_1_N = mkN "brasa" ; -- brasa..nn.1
  brasilian_1_N = mkN "brasilian" "brasilianer" ; -- brasilian..nn.1
  brasilianare_1_N = mkN "brasilianare" utrum  ; -- brasilianare..nn.1
  brasiliansk_1_A = mkA "brasiliansk" ; -- brasiliansk..av.1
  brasilianska_1_N = mkN "brasilianska" ; -- brasilianska..nn.1
  brasilier_1_N = mkN "brasilier" "brasiliern" "brasilier" "brasilierna" ; -- brasilier..nn.1
  braska_1_V = mkV "braskar" ; -- braska..vb.1
  braskande_1_A = mkA "braskande" ; -- braskande..av.1
  braskande_1_N = mkN "braskande" ; -- braskande..nn.1
  brasklapp_1_N = mkN "brasklapp" ; -- brasklapp..nn.1
  brass_1_N = mkN "brass" neutrum  ; -- brass..nn.1
  brassa_1_V = mkV "brassar" ; -- brassa..vb.1
  brassande_1_N = mkN "brassande" ; -- brassande..nn.1
  brasse_1_N = mkN "brasse" utrum  ; -- brasse..nn.1
  braständare_1_N = mkN "braständare" utrum  ; -- braständare..nn.1
  brasved_1_N = mkN "brasved" ; -- brasved..nn.1
  brat_1_N = mkN "brat" ; -- brat..nn.1
  brats_1_N = mkN "brats" ; -- brats..nn.1
  bravad_1_N = mkN "bravad" "bravader" ; -- bravad..nn.1
  bravera_1_V = mkV "braverar" ; -- bravera..vb.1
  braverande_1_N = mkN "braverande" ; -- braverande..nn.1
  bravorop_1_N = mkN "bravorop" neutrum  ; -- bravorop..nn.1
  bravur_1_N = mkN "bravur" ; -- bravur..nn.1
  bravuraria_1_N = mkN "bravuraria" ; -- bravuraria..nn.1
  bravurnummer_1_N = mkN "bravurnummer" neutrum  ; -- bravurnummer..nn.1
  bravurroll_1_N = mkN "bravurroll" "bravurroller" ; -- bravurroll..nn.1
  braxen_1_N = mkN "braxen" ; -- braxen..nn.1
  braxengräs_1_N = mkN "braxengräs" neutrum  ; -- braxengräs..nn.1
  braxenmygga_1_N = mkN "braxenmygga" ; -- braxenmygga..nn.1
  braxenpanka_1_N = mkN "braxenpanka" ; -- braxenpanka..nn.1
  bre_1_V = mkV "bre" "bredde" "brett" ; -- bre..vb.1
  break_1_N = mkN "break" neutrum  ; -- break..nn.1
  breakdance_1_N = mkN "breakdance" utrum  ; -- breakdance..nn.1
  breccia_1_N = mkN "breccia" ; -- breccia..nn.1
  bred_1_A = mkA "bred" "brett" ; -- bred..av.1
  bredande_1_N = mkN "bredande" ; -- bredande..nn.1
  bredaxlad_1_A = mkA "bredaxlad" ; -- bredaxlad..av.1
  bredband_1_N = mkN "bredband" neutrum  ; -- bredband..nn.1
  bredbandsföretag_1_N = mkN "bredbandsföretag" neutrum  ; -- bredbandsföretag..nn.1
  bredbar_1_A = mkA "bredbar" ; -- bredbar..av.1
  bredbarhet_1_N = mkN "bredbarhet" ; -- bredbarhet..nn.1
  bredbent_1_A = mkA "bredbent" "bredbent" ; -- bredbent..av.1
  bredbenthet_1_N = mkN "bredbenthet" ; -- bredbenthet..nn.1
  bredbladig_1_A = mkA "bredbladig" ; -- bredbladig..av.1
  bredbladighet_1_N = mkN "bredbladighet" ; -- bredbladighet..nn.1
  bredbrättad_1_A = mkA "bredbrättad" ; -- bredbrättad..av.1
  bredbrättig_1_A = mkA "bredbrättig" ; -- bredbrättig..av.1
  bredbrättighet_1_N = mkN "bredbrättighet" ; -- bredbrättighet..nn.1
  bredd_1_N = mkN "bredd" "bredder" ; -- bredd..nn.1
  bredda_1_V = mkV "breddar" ; -- bredda..vb.1
  breddande_1_N = mkN "breddande" ; -- breddande..nn.1
  breddgrad_1_N = mkN "breddgrad" "breddgrader" ; -- breddgrad..nn.1
  breddidrott_1_N = mkN "breddidrott" "breddidrotter" ; -- breddidrott..nn.1
  breddmässig_1_A = mkA "breddmässig" ; -- breddmässig..av.1
  breddning_1_N = mkN "breddning" ; -- breddning..nn.1
  bredhet_1_N = mkN "bredhet" ; -- bredhet..nn.1
  bredkäftad_1_A = mkA "bredkäftad" ; -- bredkäftad..av.1
  bredmun_1_N = mkN "bredmun" "bredmunnen" "bredmunnar" "bredmunnarna" ; -- bredmun..nn.1
  bredmynt_1_A = mkA "bredmynt" "bredmynt" ; -- bredmynt..av.1
  bredmynthet_1_N = mkN "bredmynthet" ; -- bredmynthet..nn.1
  bredrandig_1_A = mkA "bredrandig" ; -- bredrandig..av.1
  bredrandighet_1_N = mkN "bredrandighet" ; -- bredrandighet..nn.1
  bredsida_1_N = mkN "bredsida" ; -- bredsida..nn.1
  bredskyggig_1_A = mkA "bredskyggig" ; -- bredskyggig..av.1
  bredskyggighet_1_N = mkN "bredskyggighet" ; -- bredskyggighet..nn.1
  bredspackel_1_N = mkN "bredspackel" ; -- bredspackel..nn.1
  bredspektrumantiviral_1_A = mkA "bredspektrumantiviral" ; -- bredspektrumantiviral..av.1
  bredspårig_1_A = mkA "bredspårig" ; -- bredspårig..av.1
  bredspårighet_1_N = mkN "bredspårighet" ; -- bredspårighet..nn.1
  bredså_1_V = mkV "bredsår" ; -- bredså..vb.1
  bredsådd_1_N = mkN "bredsådd" ; -- bredsådd..nn.1
  bredsående_1_N = mkN "bredsående" ; -- bredsående..nn.1
  bredvidläsning_1_N = mkN "bredvidläsning" ; -- bredvidläsning..nn.1
  breende_1_N = mkN "breende" ; -- breende..nn.1
  brems_1_N = mkN "brems" ; -- brems..nn.1
  bremsa_1_V = mkV "bremsar" ; -- bremsa..vb.1
  bremsande_1_N = mkN "bremsande" ; -- bremsande..nn.1
  bremsning_1_N = mkN "bremsning" ; -- bremsning..nn.1
  bresilja_1_N = mkN "bresilja" ; -- bresilja..nn.1
  bretagnare_1_N = mkN "bretagnare" utrum  ; -- bretagnare..nn.1
  bretagnisk_1_A = mkA "bretagnisk" ; -- bretagnisk..av.1
  bretagniska_1_N = mkN "bretagniska" ; -- bretagniska..nn.1
  bretagniska_2_N = mkN "bretagniska" ; -- bretagniska..nn.2
  breton_1_N = mkN "breton" "bretoner" ; -- breton..nn.1
  bretonsk_1_A = mkA "bretonsk" ; -- bretonsk..av.1
  bretonska_1_N = mkN "bretonska" ; -- bretonska..nn.1
  bretonska_2_N = mkN "bretonska" ; -- bretonska..nn.2
  brev_1_N = mkN "brev" neutrum  ; -- brev..nn.1
  brevbomb_1_N = mkN "brevbomb" "brevbomber" ; -- brevbomb..nn.1
  brevbärare_1_N = mkN "brevbärare" utrum  ; -- brevbärare..nn.1
  brevbäring_1_N = mkN "brevbäring" ; -- brevbäring..nn.1
  brevcensur_1_N = mkN "brevcensur" ; -- brevcensur..nn.1
  brevdialog_1_N = mkN "brevdialog" "brevdialoger" ; -- brevdialog..nn.1
  brevduva_1_N = mkN "brevduva" ; -- brevduva..nn.1
  brevenkät_1_N = mkN "brevenkät" "brevenkäter" ; -- brevenkät..nn.1
  brevfack_1_N = mkN "brevfack" neutrum  ; -- brevfack..nn.1
  brevfråga_1_N = mkN "brevfråga" ; -- brevfråga..nn.1
  brevförsändelse_1_N = mkN "brevförsändelse" "brevförsändelser" ; -- brevförsändelse..nn.1
  brevhemlighet_1_N = mkN "brevhemlighet" "brevhemligheter" ; -- brevhemlighet..nn.1
  brevhuvud_1_N = mkN "brevhuvud" "brevhuvudet" "brevhuvud" "brevhuvudena" ; -- brevhuvud..nn.1
  breviarium_1_N = mkN "breviarium" "breviariet" "breviarier" "breviarierna" ; -- breviarium..nn.1
  brevinkast_1_N = mkN "brevinkast" neutrum  ; -- brevinkast..nn.1
  brevkort_1_N = mkN "brevkort" neutrum  ; -- brevkort..nn.1
  brevlapp_1_N = mkN "brevlapp" ; -- brevlapp..nn.1
  brevledes_1_Adv = mkAdv "brevledes" ; -- brevledes..ab.1
  brevlåda_1_N = mkN "brevlåda" ; -- brevlåda..nn.1
  brevlådeföretag_1_N = mkN "brevlådeföretag" neutrum  ; -- brevlådeföretag..nn.1
  brevlådeliknande_1_A = mkA "brevlådeliknande" ; -- brevlådeliknande..av.1
  brevlådetömning_1_N = mkN "brevlådetömning" ; -- brevlådetömning..nn.1
  brevpapper_1_N = mkN "brevpapper" neutrum  ; -- brevpapper..nn.1
  brevporto_1_N = mkN "brevporto" "brevportot" "brevporton" "brevportona" ; -- brevporto..nn.1
  brevpress_1_N = mkN "brevpress" ; -- brevpress..nn.1
  brevroman_1_N = mkN "brevroman" "brevromaner" ; -- brevroman..nn.1
  brevsamling_1_N = mkN "brevsamling" ; -- brevsamling..nn.1
  brevskola_1_N = mkN "brevskola" ; -- brevskola..nn.1
  brevskrivande_1_A = mkA "brevskrivande" ; -- brevskrivande..av.1
  brevskrivande_1_N = mkN "brevskrivande" ; -- brevskrivande..nn.1
  brevskrivare_1_N = mkN "brevskrivare" utrum  ; -- brevskrivare..nn.1
  brevskörd_1_N = mkN "brevskörd" ; -- brevskörd..nn.1
  brevstil_1_N = mkN "brevstil" ; -- brevstil..nn.1
  brevställ_1_N = mkN "brevställ" neutrum  ; -- brevställ..nn.1
  brevställare_1_N = mkN "brevställare" utrum  ; -- brevställare..nn.1
  brevsvar_1_N = mkN "brevsvar" neutrum  ; -- brevsvar..nn.1
  brevtelegram_1_N = mkN "brevtelegram" "brevtelegrammet" "brevtelegram" "brevtelegrammen" ; -- brevtelegram..nn.1
  brevvän_1_N = mkN "brevvän" "brevvännen" "brevvänner" "brevvännerna" ; -- brevvän..nn.1
  brevväxla_1_V = mkV "brevväxlar" ; -- brevväxla..vb.1
  brevväxlande_1_N = mkN "brevväxlande" ; -- brevväxlande..nn.1
  brevväxling_1_N = mkN "brevväxling" ; -- brevväxling..nn.1
  brevvåg_1_N = mkN "brevvåg" ; -- brevvåg..nn.1
  brevöppnare_1_N = mkN "brevöppnare" utrum  ; -- brevöppnare..nn.1
  bricka_1_N = mkN "bricka" ; -- bricka..nn.1
  brickband_1_N = mkN "brickband" neutrum  ; -- brickband..nn.1
  brickbord_1_N = mkN "brickbord" neutrum  ; -- brickbord..nn.1
  brickduk_1_N = mkN "brickduk" ; -- brickduk..nn.1
  bricklunch_1_N = mkN "bricklunch" "brickluncher" ; -- bricklunch..nn.1
  brickplockare_1_N = mkN "brickplockare" utrum  ; -- brickplockare..nn.1
  brickunderlägg_1_N = mkN "brickunderlägg" neutrum  ; -- brickunderlägg..nn.1
  brickvävd_1_A = mkA "brickvävd" "brickvävt" ; -- brickvävd..av.1
  brickvävning_1_N = mkN "brickvävning" ; -- brickvävning..nn.1
  bridge_1_N = mkN "bridge" utrum  ; -- bridge..nn.1
  bridgebord_1_N = mkN "bridgebord" neutrum  ; -- bridgebord..nn.1
  bridgejunta_1_N = mkN "bridgejunta" ; -- bridgejunta..nn.1
  bridong_1_N = mkN "bridong" "bridonger" ; -- bridong..nn.1
  bridreaktor_1_N = mkN "bridreaktor" "bridreaktorer" ; -- bridreaktor..nn.1
  briefa_1_V = mkV "briefar" ; -- briefa..vb.1
  briefande_1_N = mkN "briefande" ; -- briefande..nn.1
  brigad_1_N = mkN "brigad" "brigader" ; -- brigad..nn.1
  brigadchef_1_N = mkN "brigadchef" "brigadchefer" ; -- brigadchef..nn.1
  brigadgeneral_1_N = mkN "brigadgeneral" "brigadgeneraler" ; -- brigadgeneral..nn.1
  brigadstab_1_N = mkN "brigadstab" "brigadstaber" ; -- brigadstab..nn.1
  brigadvis_1_Adv = mkAdv "brigadvis" ; -- brigadvis..ab.1
  brigadvis_1_A = mkA "brigadvis" ; -- brigadvis..av.1
  brigadör_1_N = mkN "brigadör" "brigadörer" ; -- brigadör..nn.1
  brigantin_1_N = mkN "brigantin" "brigantiner" ; -- brigantin..nn.1
  brigg_1_N = mkN "brigg" ; -- brigg..nn.1
  briggsegel_1_N = mkN "briggsegel" neutrum  ; -- briggsegel..nn.1
  brikett_1_N = mkN "brikett" "briketter" ; -- brikett..nn.1
  brikettera_1_V = mkV "briketterar" ; -- brikettera..vb.1
  briketterande_1_N = mkN "briketterande" ; -- briketterande..nn.1
  briketterbar_1_A = mkA "briketterbar" ; -- briketterbar..av.1
  briketterbarhet_1_N = mkN "briketterbarhet" ; -- briketterbarhet..nn.1
  brikettering_1_N = mkN "brikettering" ; -- brikettering..nn.1
  brikettpress_1_N = mkN "brikettpress" ; -- brikettpress..nn.1
  brikollstöt_1_N = mkN "brikollstöt" ; -- brikollstöt..nn.1
  briljans_1_N = mkN "briljans" ; -- briljans..nn.1
  briljant_1_A = mkA "briljant" "briljant" ; -- briljant..av.1
  briljant_1_N = mkN "briljant" "briljanter" ; -- briljant..nn.1
  briljanterad_1_A = mkA "briljanterad" ; -- briljanterad..av.1
  briljantglas_1_N = mkN "briljantglas" neutrum  ; -- briljantglas..nn.1
  briljantin_1_N = mkN "briljantin" ; -- briljantin..nn.1
  briljantring_1_N = mkN "briljantring" ; -- briljantring..nn.1
  briljantsmyckad_1_A = mkA "briljantsmyckad" ; -- briljantsmyckad..av.1
  briljantsmycke_1_N = mkN "briljantsmycke" ; -- briljantsmycke..nn.1
  briljera_1_V = mkV "briljerar" ; -- briljera..vb.1
  briljerande_1_N = mkN "briljerande" ; -- briljerande..nn.1
  briljering_1_N = mkN "briljering" ; -- briljering..nn.1
  brilliant_1_N = mkN "brilliant" ; -- brilliant..nn.1
  bringa_1_N = mkN "bringa" ; -- bringa..nn.1
  bringa_1_V = mkV "bringar" ; -- bringa..vb.1
  bringande_1_N = mkN "bringande" ; -- bringande..nn.1
  brink_1_N = mkN "brink" ; -- brink..nn.1
  brinna_1_V = mkV "brinna" "brann" "brunnit" ; -- brinna..vb.1
  brinna_2_V = mkV "brinna" "brann" "brunnit" ; -- brinna..vb.2
  brinnande_1_A = mkA "brinnande" ; -- brinnande..av.1
  brinnande_1_N = mkN "brinnande" ; -- brinnande..nn.1
  brinnsträcka_1_N = mkN "brinnsträcka" ; -- brinnsträcka..nn.1
  brio_1_N = mkN "brio" ; -- brio..nn.1
  bris_1_N = mkN "bris" ; -- bris..nn.1
  brisad_1_N = mkN "brisad" "brisader" ; -- brisad..nn.1
  brisans_1_N = mkN "brisans" "brisanser" ; -- brisans..nn.1
  brisansgranat_1_N = mkN "brisansgranat" "brisansgranater" ; -- brisansgranat..nn.1
  brisant_1_A = mkA "brisant" "brisant" ; -- brisant..av.1
  brisant_1_N = mkN "brisant" "brisanter" ; -- brisant..nn.1
  brisera_1_V = mkV "briserar" ; -- brisera..vb.1
  briserande_1_N = mkN "briserande" ; -- briserande..nn.1
  briserbar_1_A = mkA "briserbar" ; -- briserbar..av.1
  briserbarhet_1_N = mkN "briserbarhet" ; -- briserbarhet..nn.1
  brisering_1_N = mkN "brisering" ; -- brisering..nn.1
  brisken_1_A = mkA "brisken" ; -- brisken..av.1
  briskenhet_1_N = mkN "briskenhet" ; -- briskenhet..nn.1
  brissling_1_N = mkN "brissling" ; -- brissling..nn.1
  brist_1_N = mkN "brist" "brister" ; -- brist..nn.1
  brista_1_V = mkV "brista" "brast" "brustit" ; -- brista..vb.1
  brista_2_V = mkV "brista" "brast" "brustit" ; -- brista..vb.2
  bristande_1_A = mkA "bristande" ; -- bristande..av.1
  bristande_1_N = mkN "bristande" ; -- bristande..nn.1
  bristfällig_1_A = mkA "bristfällig" ; -- bristfällig..av.1
  bristfällighet_1_N = mkN "bristfällighet" "bristfälligheter" ; -- bristfällighet..nn.1
  bristläge_1_N = mkN "bristläge" ; -- bristläge..nn.1
  bristning_1_N = mkN "bristning" ; -- bristning..nn.1
  bristningsgräns_1_N = mkN "bristningsgräns" ; -- bristningsgräns..nn.1
  bristsituation_1_N = mkN "bristsituation" ; -- bristsituation..nn.1
  bristsjukdom_1_N = mkN "bristsjukdom" ; -- bristsjukdom..nn.1
  bristvara_1_N = mkN "bristvara" ; -- bristvara..nn.1
  bristyrke_1_N = mkN "bristyrke" ; -- bristyrke..nn.1
  britanniametall_1_N = mkN "britanniametall" ; -- britanniametall..nn.1
  britannisk_1_A = mkA "britannisk" ; -- britannisk..av.1
  brits_1_N = mkN "brits" ; -- brits..nn.1
  britt_1_N = mkN "britt" "britter" ; -- britt..nn.1
  brittisk_1_A = mkA "brittisk" ; -- brittisk..av.1
  brittiska_1_N = mkN "brittiska" ; -- brittiska..nn.1
  brittmässa_1_N = mkN "brittmässa" ; -- brittmässa..nn.1
  brittsommar_1_N = mkN "brittsommar" "brittsommaren" "brittsomrar" "brittsomrarna" ; -- brittsommar..nn.1
  brittsommarväder_1_N = mkN "brittsommarväder" neutrum  ; -- brittsommarväder..nn.1
  bro_1_N = mkN "bro" ; -- bro..nn.1
  broa_1_V = mkV "broar" ; -- broa..vb.1
  broande_1_N = mkN "broande" ; -- broande..nn.1
  broavgift_1_N = mkN "broavgift" "broavgifter" ; -- broavgift..nn.1
  brobana_1_N = mkN "brobana" ; -- brobana..nn.1
  brobelastning_1_N = mkN "brobelastning" ; -- brobelastning..nn.1
  brobygge_1_N = mkN "brobygge" ; -- brobygge..nn.1
  brobyggnad_1_N = mkN "brobyggnad" ; -- brobyggnad..nn.1
  brobänk_1_N = mkN "brobänk" ; -- brobänk..nn.1
  brochette_1_N = mkN "brochette" "brochetter" ; -- brochette..nn.1
  brock_1_N = mkN "brock" ; -- brock..nn.1
  brock_2_N = mkN "brock" neutrum  ; -- brock..nn.2
  brockband_1_N = mkN "brockband" neutrum  ; -- brockband..nn.1
  brockfågel_1_N = mkN "brockfågel" ; -- brockfågel..nn.1
  brodd_1_N = mkN "brodd" ; -- brodd..nn.1
  brodda_1_V = mkV "broddar" ; -- brodda..vb.1
  broddande_1_N = mkN "broddande" ; -- broddande..nn.1
  broder_1_N = mkN "broder" "brodern" "bröder" "bröderna" ; -- broder..nn.1
  brodera_1_V = mkV "broderar" ; -- brodera..vb.1
  broderande_1_N = mkN "broderande" ; -- broderande..nn.1
  broderbar_1_A = mkA "broderbar" ; -- broderbar..av.1
  broderbarhet_1_N = mkN "broderbarhet" ; -- broderbarhet..nn.1
  broderbok_1_N = mkN "broderbok" "broderböcker" ; -- broderbok..nn.1
  broderbåge_1_N = mkN "broderbåge" utrum  ; -- broderbåge..nn.1
  broderfolk_1_N = mkN "broderfolk" neutrum  ; -- broderfolk..nn.1
  brodergarn_1_N = mkN "brodergarn" neutrum  ; -- brodergarn..nn.1
  broderi_1_N = mkN "broderi" "broderiet" "broderier" "broderierna" ; -- broderi..nn.1
  brodering_1_N = mkN "brodering" ; -- brodering..nn.1
  broderland_1_N = mkN "broderland" "broderlandet" "broderländer" "broderländerna" ; -- broderland..nn.1
  broderlig_1_A = mkA "broderlig" ; -- broderlig..av.1
  broderlighet_1_N = mkN "broderlighet" ; -- broderlighet..nn.1
  brodermord_1_N = mkN "brodermord" neutrum  ; -- brodermord..nn.1
  brodermördare_1_N = mkN "brodermördare" utrum  ; -- brodermördare..nn.1
  brodernål_1_N = mkN "brodernål" ; -- brodernål..nn.1
  brodersax_1_N = mkN "brodersax" ; -- brodersax..nn.1
  brodersilke_1_N = mkN "brodersilke" ; -- brodersilke..nn.1
  broderskap_1_N = mkN "broderskap" neutrum  ; -- broderskap..nn.1
  broderskärlek_1_N = mkN "broderskärlek" ; -- broderskärlek..nn.1
  brodersöm_1_N = mkN "brodersöm" "brodersömmen" "brodersömmar" "brodersömmarna" ; -- brodersöm..nn.1
  brodyr_1_N = mkN "brodyr" "brodyrer" ; -- brodyr..nn.1
  brodös_1_N = mkN "brodös" "brodöser" ; -- brodös..nn.1
  brofäste_1_N = mkN "brofäste" ; -- brofäste..nn.1
  brohus_1_N = mkN "brohus" neutrum  ; -- brohus..nn.1
  brohuvud_1_N = mkN "brohuvud" "brohuvudet" "brohuvud" "brohuvudena" ; -- brohuvud..nn.1
  broiler_1_N = mkN "broiler" ; -- broiler..nn.1
  brok_1_N = mkN "brok" ; -- brok..nn.1
  brokad_1_N = mkN "brokad" "brokader" ; -- brokad..nn.1
  brokanal_1_N = mkN "brokanal" "brokanaler" ; -- brokanal..nn.1
  brokar_1_N = mkN "brokar" neutrum  ; -- brokar..nn.1
  brokbladig_1_A = mkA "brokbladig" ; -- brokbladig..av.1
  brokbladighet_1_N = mkN "brokbladighet" ; -- brokbladighet..nn.1
  brokblommig_1_A = mkA "brokblommig" ; -- brokblommig..av.1
  brokblommighet_1_N = mkN "brokblommighet" ; -- brokblommighet..nn.1
  brokig_1_A = mkA "brokig" ; -- brokig..av.1
  brokighet_1_N = mkN "brokighet" "brokigheter" ; -- brokighet..nn.1
  brokista_1_N = mkN "brokista" ; -- brokista..nn.1
  brokspett_1_N = mkN "brokspett" ; -- brokspett..nn.1
  brolla_1_N = mkN "brolla" ; -- brolla..nn.1
  brolopp_1_N = mkN "brolopp" neutrum  ; -- brolopp..nn.1
  brolägga_1_V = mkV "brolägga" "brola" "brolagt" ; -- brolägga..vb.1
  broläggande_1_N = mkN "broläggande" ; -- broläggande..nn.1
  brom_1_N = mkN "brom" ; -- brom..nn.1
  bromelia_1_N = mkN "bromelia" ; -- bromelia..nn.1
  bromera_1_V = mkV "bromerar" ; -- bromera..vb.1
  bromerande_1_N = mkN "bromerande" ; -- bromerande..nn.1
  bromerbar_1_A = mkA "bromerbar" ; -- bromerbar..av.1
  bromerbarhet_1_N = mkN "bromerbarhet" ; -- bromerbarhet..nn.1
  bromering_1_N = mkN "bromering" ; -- bromering..nn.1
  bromförgiftning_1_N = mkN "bromförgiftning" ; -- bromförgiftning..nn.1
  bromid_1_N = mkN "bromid" "bromider" ; -- bromid..nn.1
  bromism_1_N = mkN "bromism" "bromismer" ; -- bromism..nn.1
  bromläcka_1_N = mkN "bromläcka" ; -- bromläcka..nn.1
  broms_1_N = mkN "broms" ; -- broms..nn.1
  bromsa_1_V = mkV "bromsar" ; -- bromsa..vb.1
  bromsande_1_N = mkN "bromsande" ; -- bromsande..nn.1
  bromsare_1_N = mkN "bromsare" utrum  ; -- bromsare..nn.1
  bromsback_1_N = mkN "bromsback" ; -- bromsback..nn.1
  bromsband_1_N = mkN "bromsband" neutrum  ; -- bromsband..nn.1
  bromsbelägg_1_N = mkN "bromsbelägg" neutrum  ; -- bromsbelägg..nn.1
  bromsblock_1_N = mkN "bromsblock" neutrum  ; -- bromsblock..nn.1
  bromscylinder_1_N = mkN "bromscylinder" ; -- bromscylinder..nn.1
  bromsfading_1_N = mkN "bromsfading" ; -- bromsfading..nn.1
  bromsfel_1_N = mkN "bromsfel" "bromsfelet" "bromsfel" "bromsfelen" ; -- bromsfel..nn.1
  bromsgaller_1_N = mkN "bromsgaller" neutrum  ; -- bromsgaller..nn.1
  bromshandtag_1_N = mkN "bromshandtag" neutrum  ; -- bromshandtag..nn.1
  bromsilverpapper_1_N = mkN "bromsilverpapper" neutrum  ; -- bromsilverpapper..nn.1
  bromsklaff_1_N = mkN "bromsklaff" ; -- bromsklaff..nn.1
  bromskloss_1_N = mkN "bromskloss" ; -- bromskloss..nn.1
  bromskraft_1_N = mkN "bromskraft" ; -- bromskraft..nn.1
  bromsljus_1_N = mkN "bromsljus" neutrum  ; -- bromsljus..nn.1
  bromsmedicin_1_N = mkN "bromsmedicin" "bromsmediciner" ; -- bromsmedicin..nn.1
  bromsning_1_N = mkN "bromsning" ; -- bromsning..nn.1
  bromsolja_1_N = mkN "bromsolja" ; -- bromsolja..nn.1
  bromspedal_1_N = mkN "bromspedal" "bromspedaler" ; -- bromspedal..nn.1
  bromsraket_1_N = mkN "bromsraket" "bromsraketer" ; -- bromsraket..nn.1
  bromsservo_1_N = mkN "bromsservo" ; -- bromsservo..nn.1
  bromsskiva_1_N = mkN "bromsskiva" ; -- bromsskiva..nn.1
  bromssko_1_N = mkN "bromssko" "bromsskor" ; -- bromssko..nn.1
  bromsskärm_1_N = mkN "bromsskärm" ; -- bromsskärm..nn.1
  bromsspår_1_N = mkN "bromsspår" neutrum  ; -- bromsspår..nn.1
  bromssträcka_1_N = mkN "bromssträcka" ; -- bromssträcka..nn.1
  bromsstrålning_1_N = mkN "bromsstrålning" ; -- bromsstrålning..nn.1
  bromssystem_1_N = mkN "bromssystem" neutrum  ; -- bromssystem..nn.1
  bromstrumma_1_N = mkN "bromstrumma" ; -- bromstrumma..nn.1
  bromsvagn_1_N = mkN "bromsvagn" ; -- bromsvagn..nn.1
  bromsvätska_1_N = mkN "bromsvätska" ; -- bromsvätska..nn.1
  bromtymolblått_1_N = mkN "bromtymolblått" ; -- bromtymolblått..nn.1
  bromural_1_N = mkN "bromural" neutrum  ; -- bromural..nn.1
  bromväte_1_N = mkN "bromväte" ; -- bromväte..nn.1
  bromvätesyra_1_N = mkN "bromvätesyra" ; -- bromvätesyra..nn.1
  bromyl_1_N = mkN "bromyl" ; -- bromyl..nn.1
  bronkialastma_1_N = mkN "bronkialastma" ; -- bronkialastma..nn.1
  bronkit_1_N = mkN "bronkit" "bronkiter" ; -- bronkit..nn.1
  bronkografi_1_N = mkN "bronkografi" "bronkografier" ; -- bronkografi..nn.1
  bronkoskop_1_N = mkN "bronkoskop" neutrum  ; -- bronkoskop..nn.1
  bronkoskopi_1_N = mkN "bronkoskopi" "bronkoskopier" ; -- bronkoskopi..nn.1
  brons_1_N = mkN "brons" neutrum  ; -- brons..nn.1
  brons_2_N = mkN "brons" "bronser" ; -- brons..nn.2
  brons_3_N = mkN "brons" "bronser" ; -- brons..nn.3
  bronsborste_1_N = mkN "bronsborste" utrum  ; -- bronsborste..nn.1
  bronsera_1_V = mkV "bronserar" ; -- bronsera..vb.1
  bronserande_1_N = mkN "bronserande" ; -- bronserande..nn.1
  bronserbar_1_A = mkA "bronserbar" ; -- bronserbar..av.1
  bronserbarhet_1_N = mkN "bronserbarhet" ; -- bronserbarhet..nn.1
  bronsering_1_N = mkN "bronsering" ; -- bronsering..nn.1
  bronsfärg_1_N = mkN "bronsfärg" ; -- bronsfärg..nn.1
  bronsfärgad_1_A = mkA "bronsfärgad" ; -- bronsfärgad..av.1
  bronsförgylla_1_V = mkV "bronsförgyller" ; -- bronsförgylla..vb.1
  bronsförgyllande_1_N = mkN "bronsförgyllande" ; -- bronsförgyllande..nn.1
  bronsinfattad_1_A = mkA "bronsinfattad" ; -- bronsinfattad..av.1
  bronskanna_1_N = mkN "bronskanna" ; -- bronskanna..nn.1
  bronsknapp_1_N = mkN "bronsknapp" ; -- bronsknapp..nn.1
  bronskärl_1_N = mkN "bronskärl" neutrum  ; -- bronskärl..nn.1
  bronsmedalj_1_N = mkN "bronsmedalj" "bronsmedaljer" ; -- bronsmedalj..nn.1
  bronsmedaljör_1_N = mkN "bronsmedaljör" "bronsmedaljörer" ; -- bronsmedaljör..nn.1
  bronsmynt_1_N = mkN "bronsmynt" neutrum  ; -- bronsmynt..nn.1
  bronsmärke_1_N = mkN "bronsmärke" ; -- bronsmärke..nn.1
  bronssmycke_1_N = mkN "bronssmycke" ; -- bronssmycke..nn.1
  bronsspänne_1_N = mkN "bronsspänne" ; -- bronsspänne..nn.1
  bronsstaty_1_N = mkN "bronsstaty" "bronsstatyer" ; -- bronsstaty..nn.1
  bronsstatyett_1_N = mkN "bronsstatyett" "bronsstatyetter" ; -- bronsstatyett..nn.1
  bronssvärd_1_N = mkN "bronssvärd" neutrum  ; -- bronssvärd..nn.1
  bronstavla_1_N = mkN "bronstavla" ; -- bronstavla..nn.1
  bronsyxa_1_N = mkN "bronsyxa" ; -- bronsyxa..nn.1
  bronsålder_1_N = mkN "bronsålder" ; -- bronsålder..nn.1
  bronsåldersfynd_1_N = mkN "bronsåldersfynd" neutrum  ; -- bronsåldersfynd..nn.1
  bronsåldersgrav_1_N = mkN "bronsåldersgrav" ; -- bronsåldersgrav..nn.1
  bronsåldersmänniska_1_N = mkN "bronsåldersmänniska" ; -- bronsåldersmänniska..nn.1
  broolycka_1_N = mkN "broolycka" ; -- broolycka..nn.1
  bropelare_1_N = mkN "bropelare" utrum  ; -- bropelare..nn.1
  bropeng_1_N = mkN "bropeng" ; -- bropeng..nn.1
  bropenning_1_N = mkN "bropenning" ; -- bropenning..nn.1
  broplanka_1_N = mkN "broplanka" ; -- broplanka..nn.1
  bror_1_N = mkN "bror" "bröder" ; -- bror..nn.1
  brorsa_1_N = mkN "brorsa" ; -- brorsa..nn.1
  brorsarv_1_N = mkN "brorsarv" neutrum  ; -- brorsarv..nn.1
  brorsbarn_1_N = mkN "brorsbarn" neutrum  ; -- brorsbarn..nn.1
  brorsdotter_1_N = mkN "brorsdotter" "brorsdottern" "brorsdöttrar" "brorsdöttrarna" ; -- brorsdotter..nn.1
  brorskål_1_N = mkN "brorskål" ; -- brorskål..nn.1
  brorslott_1_N = mkN "brorslott" "brorslotter" ; -- brorslott..nn.1
  brorson_1_N = mkN "brorson" "brorsöner" ; -- brorson..nn.1
  brorsskål_1_N = mkN "brorsskål" ; -- brorsskål..nn.1
  brosch_1_N = mkN "brosch" "broscher" ; -- brosch..nn.1
  broschera_1_V = mkV "broscherar" ; -- broschera..vb.1
  broscherad_1_A = mkA "broscherad" ; -- broscherad..av.1
  broscherande_1_N = mkN "broscherande" ; -- broscherande..nn.1
  broscherbar_1_A = mkA "broscherbar" ; -- broscherbar..av.1
  broscherbarhet_1_N = mkN "broscherbarhet" ; -- broscherbarhet..nn.1
  broschering_1_N = mkN "broschering" ; -- broschering..nn.1
  broschyr_1_N = mkN "broschyr" "broschyrer" ; -- broschyr..nn.1
  brosk_1_N = mkN "brosk" neutrum  ; -- brosk..nn.1
  broskartad_1_A = mkA "broskartad" ; -- broskartad..av.1
  broskfisk_1_N = mkN "broskfisk" ; -- broskfisk..nn.1
  broskhinna_1_N = mkN "broskhinna" ; -- broskhinna..nn.1
  broskskiva_1_N = mkN "broskskiva" ; -- broskskiva..nn.1
  broskskivling_1_N = mkN "broskskivling" ; -- broskskivling..nn.1
  brosksvamp_1_N = mkN "brosksvamp" ; -- brosksvamp..nn.1
  broskverk_1_N = mkN "broskverk" neutrum  ; -- broskverk..nn.1
  broskvävnad_1_N = mkN "broskvävnad" "broskvävnader" ; -- broskvävnad..nn.1
  broslagning_1_N = mkN "broslagning" ; -- broslagning..nn.1
  brosme_1_N = mkN "brosme" utrum  ; -- brosme..nn.1
  brospann_1_N = mkN "brospann" neutrum  ; -- brospann..nn.1
  brossla_1_V = mkV "brosslar" ; -- brossla..vb.1
  brosslande_1_N = mkN "brosslande" ; -- brosslande..nn.1
  brotsch_1_N = mkN "brotsch" ; -- brotsch..nn.1
  brotscha_1_V = mkV "brotschar" ; -- brotscha..vb.1
  brotschande_1_N = mkN "brotschande" ; -- brotschande..nn.1
  brott_1_N = mkN "brott" neutrum  ; -- brott..nn.1
  brott_2_N = mkN "brott" neutrum  ; -- brott..nn.2
  brottare_1_N = mkN "brottare" utrum  ; -- brottare..nn.1
  brottarlegendar_1_N = mkN "brottarlegendar" "brottarlegendarer" ; -- brottarlegendar..nn.1
  brottmål_1_N = mkN "brottmål" neutrum  ; -- brottmål..nn.1
  brottmålsdomare_1_N = mkN "brottmålsdomare" utrum  ; -- brottmålsdomare..nn.1
  brottmålsdomstol_1_N = mkN "brottmålsdomstol" ; -- brottmålsdomstol..nn.1
  brottmålsprocess_1_N = mkN "brottmålsprocess" "brottmålsprocesser" ; -- brottmålsprocess..nn.1
  brottning_1_N = mkN "brottning" ; -- brottning..nn.1
  brottningsgrepp_1_N = mkN "brottningsgrepp" neutrum  ; -- brottningsgrepp..nn.1
  brottningskamp_1_N = mkN "brottningskamp" "brottningskamper" ; -- brottningskamp..nn.1
  brottningsmatch_1_N = mkN "brottningsmatch" "brottningsmatcher" ; -- brottningsmatch..nn.1
  brottningsring_1_N = mkN "brottningsring" ; -- brottningsring..nn.1
  brottsbalk_1_N = mkN "brottsbalk" ; -- brottsbalk..nn.1
  brottsbekämpande_1_N = mkN "brottsbekämpande" ; -- brottsbekämpande..nn.1
  brottsbekämpning_1_N = mkN "brottsbekämpning" ; -- brottsbekämpning..nn.1
  brottsbevakning_1_N = mkN "brottsbevakning" ; -- brottsbevakning..nn.1
  brottsförebyggande_1_A = mkA "brottsförebyggande" ; -- brottsförebyggande..av.1
  brottshistoria_1_N = mkN "brottshistoria" ; -- brottshistoria..nn.1
  brottsjournalistik_1_N = mkN "brottsjournalistik" ; -- brottsjournalistik..nn.1
  brottsjö_1_N = mkN "brottsjö" ; -- brottsjö..nn.1
  brottskonkurrens_1_N = mkN "brottskonkurrens" ; -- brottskonkurrens..nn.1
  brottslig_1_A = mkA "brottslig" ; -- brottslig..av.1
  brottslighet_1_N = mkN "brottslighet" "brottsligheter" ; -- brottslighet..nn.1
  brottsling_1_N = mkN "brottsling" ; -- brottsling..nn.1
  brottsmisstanke_1_N = mkN "brottsmisstanke" utrum  ; -- brottsmisstanke..nn.1
  brottsmisstänkt_1_A = mkA "brottsmisstänkt" "brottsmisstänkt" ; -- brottsmisstänkt..av.1
  brottsmål_1_N = mkN "brottsmål" neutrum  ; -- brottsmål..nn.1
  brottsoffer_1_N = mkN "brottsoffer" neutrum  ; -- brottsoffer..nn.1
  brottsplats_1_N = mkN "brottsplats" "brottsplatser" ; -- brottsplats..nn.1
  brottsplatsexpert_1_N = mkN "brottsplatsexpert" "brottsplatsexperter" ; -- brottsplatsexpert..nn.1
  brottsplatstekniker_1_N = mkN "brottsplatstekniker" "brottsplatsteknikern" "brottsplatstekniker" "brottsplatsteknikerna" ; -- brottsplatstekniker..nn.1
  brottsplatsundersökning_1_N = mkN "brottsplatsundersökning" ; -- brottsplatsundersökning..nn.1
  brottsprovokation_1_N = mkN "brottsprovokation" ; -- brottsprovokation..nn.1
  brottsregister_1_N = mkN "brottsregister" neutrum  ; -- brottsregister..nn.1
  brottsrekvisit_1_N = mkN "brottsrekvisit" neutrum  ; -- brottsrekvisit..nn.1
  brottsrubricering_1_N = mkN "brottsrubricering" ; -- brottsrubricering..nn.1
  brottstillfälle_1_N = mkN "brottstillfälle" ; -- brottstillfälle..nn.1
  brottstycke_1_N = mkN "brottstycke" ; -- brottstycke..nn.1
  brottställe_1_N = mkN "brottställe" ; -- brottställe..nn.1
  brottsutreda_1_V = mkV "brottsutredar" ; -- brottsutreda..vb.1
  brottsutredande_1_N = mkN "brottsutredande" ; -- brottsutredande..nn.1
  brottsutredning_1_N = mkN "brottsutredning" ; -- brottsutredning..nn.1
  brottyta_1_N = mkN "brottyta" ; -- brottyta..nn.1
  brovalv_1_N = mkN "brovalv" neutrum  ; -- brovalv..nn.1
  browning_1_N = mkN "browning" ; -- browning..nn.1
  broöppning_1_N = mkN "broöppning" ; -- broöppning..nn.1
  bruckel_1_N = mkN "bruckel" neutrum  ; -- bruckel..nn.1
  bruckla_1_V = mkV "brucklar" ; -- bruckla..vb.1
  brucklande_1_N = mkN "brucklande" ; -- brucklande..nn.1
  brud_1_N = mkN "brud" ; -- brud..nn.1
  brudand_1_N = mkN "brudand" "brudänder" ; -- brudand..nn.1
  brudborste_1_N = mkN "brudborste" utrum  ; -- brudborste..nn.1
  brudbröd_1_N = mkN "brudbröd" neutrum  ; -- brudbröd..nn.1
  brudbukett_1_N = mkN "brudbukett" "brudbuketter" ; -- brudbukett..nn.1
  brudfoto_1_N = mkN "brudfoto" "brudfotot" "brudfoton" "brudfotona" ; -- brudfoto..nn.1
  brudfrämma_1_N = mkN "brudfrämma" ; -- brudfrämma..nn.1
  brudfölje_1_N = mkN "brudfölje" ; -- brudfölje..nn.1
  brudgum_1_N = mkN "brudgum" "brudgummen" "brudgummar" "brudgummarna" ; -- brudgum..nn.1
  brudgåva_1_N = mkN "brudgåva" ; -- brudgåva..nn.1
  brudklänning_1_N = mkN "brudklänning" ; -- brudklänning..nn.1
  brudkrona_1_N = mkN "brudkrona" ; -- brudkrona..nn.1
  brudköp_1_N = mkN "brudköp" neutrum  ; -- brudköp..nn.1
  brudmystik_1_N = mkN "brudmystik" ; -- brudmystik..nn.1
  brudnäbb_1_N = mkN "brudnäbb" ; -- brudnäbb..nn.1
  brudpall_1_N = mkN "brudpall" ; -- brudpall..nn.1
  brudpar_1_N = mkN "brudpar" neutrum  ; -- brudpar..nn.1
  brudpäll_1_N = mkN "brudpäll" ; -- brudpäll..nn.1
  brudrov_1_N = mkN "brudrov" neutrum  ; -- brudrov..nn.1
  brudslöja_1_N = mkN "brudslöja" ; -- brudslöja..nn.1
  brudsporre_1_N = mkN "brudsporre" utrum  ; -- brudsporre..nn.1
  brudstol_1_N = mkN "brudstol" ; -- brudstol..nn.1
  brudsäng_1_N = mkN "brudsäng" ; -- brudsäng..nn.1
  brudtärna_1_N = mkN "brudtärna" ; -- brudtärna..nn.1
  brudöverlämning_1_N = mkN "brudöverlämning" ; -- brudöverlämning..nn.1
  brugd_1_N = mkN "brugd" "brugder" ; -- brugd..nn.1
  bruk_1_N = mkN "bruk" neutrum  ; -- bruk..nn.1
  bruk_2_N = mkN "bruk" neutrum  ; -- bruk..nn.2
  bruka_1_V = mkV "brukar" ; -- bruka..vb.1
  brukande_1_N = mkN "brukande" ; -- brukande..nn.1
  brukare_1_N = mkN "brukare" utrum  ; -- brukare..nn.1
  brukbar_1_A = mkA "brukbar" ; -- brukbar..av.1
  brukbarhet_1_N = mkN "brukbarhet" ; -- brukbarhet..nn.1
  bruklig_1_A = mkA "bruklig" ; -- bruklig..av.1
  bruklighet_1_N = mkN "bruklighet" "brukligheter" ; -- bruklighet..nn.1
  brukning_1_N = mkN "brukning" ; -- brukning..nn.1
  brukningsenhet_1_N = mkN "brukningsenhet" "brukningsenheter" ; -- brukningsenhet..nn.1
  bruksanvisning_1_N = mkN "bruksanvisning" ; -- bruksanvisning..nn.1
  bruksarbetare_1_N = mkN "bruksarbetare" utrum  ; -- bruksarbetare..nn.1
  bruksartikel_1_N = mkN "bruksartikel" ; -- bruksartikel..nn.1
  bruksdisponent_1_N = mkN "bruksdisponent" "bruksdisponenter" ; -- bruksdisponent..nn.1
  bruksdjur_1_N = mkN "bruksdjur" neutrum  ; -- bruksdjur..nn.1
  bruksdrift_1_N = mkN "bruksdrift" ; -- bruksdrift..nn.1
  bruksföremål_1_N = mkN "bruksföremål" neutrum  ; -- bruksföremål..nn.1
  brukshund_1_N = mkN "brukshund" ; -- brukshund..nn.1
  brukskonst_1_N = mkN "brukskonst" ; -- brukskonst..nn.1
  brukslagare_1_N = mkN "brukslagare" utrum  ; -- brukslagare..nn.1
  brukslev_1_N = mkN "brukslev" ; -- brukslev..nn.1
  brukslå_1_V = mkV "brukslå" "brukslog" "brukslagit" ; -- brukslå..vb.1
  brukslående_1_N = mkN "brukslående" ; -- brukslående..nn.1
  bruksort_1_N = mkN "bruksort" "bruksorter" ; -- bruksort..nn.1
  brukspatron_1_N = mkN "brukspatron" "brukspatroner" ; -- brukspatron..nn.1
  bruksrörelse_1_N = mkN "bruksrörelse" "bruksrörelser" ; -- bruksrörelse..nn.1
  brukssamhälle_1_N = mkN "brukssamhälle" ; -- brukssamhälle..nn.1
  bruksvärde_1_N = mkN "bruksvärde" ; -- bruksvärde..nn.1
  bruksvärdeshyra_1_N = mkN "bruksvärdeshyra" ; -- bruksvärdeshyra..nn.1
  brulépudding_1_N = mkN "brulépudding" ; -- brulépudding..nn.1
  brumbas_1_N = mkN "brumbas" ; -- brumbas..nn.1
  brumbjörn_1_N = mkN "brumbjörn" ; -- brumbjörn..nn.1
  brumkör_1_N = mkN "brumkör" "brumkörer" ; -- brumkör..nn.1
  brumma_1_V = mkV "brummar" ; -- brumma..vb.1
  brummande_1_N = mkN "brummande" ; -- brummande..nn.1
  brummare_1_N = mkN "brummare" utrum  ; -- brummare..nn.1
  brumning_1_N = mkN "brumning" ; -- brumning..nn.1
  brun_1_A = mkA "brun" ; -- brun..av.1
  brunaktig_1_A = mkA "brunaktig" ; -- brunaktig..av.1
  brunaktighet_1_N = mkN "brunaktighet" ; -- brunaktighet..nn.1
  brunalg_1_N = mkN "brunalg" "brunalger" ; -- brunalg..nn.1
  brunand_1_N = mkN "brunand" "brunänder" ; -- brunand..nn.1
  brunbetsa_1_V = mkV "brunbetsar" ; -- brunbetsa..vb.1
  brunbetsande_1_N = mkN "brunbetsande" ; -- brunbetsande..nn.1
  brunbetsning_1_N = mkN "brunbetsning" ; -- brunbetsning..nn.1
  brunbränd_1_A = mkA "brunbränd" ; -- brunbränd..av.1
  brunbär_1_N = mkN "brunbär" neutrum  ; -- brunbär..nn.1
  brunch_1_N = mkN "brunch" "bruncher" ; -- brunch..nn.1
  brunchtest_1_N = mkN "brunchtest" neutrum  ; -- brunchtest..nn.1
  bruneier_1_N = mkN "bruneier" "bruneiern" "bruneier" "bruneierna" ; -- bruneier..nn.1
  bruneisk_1_A = mkA "bruneisk" ; -- bruneisk..av.1
  bruneiska_1_N = mkN "bruneiska" ; -- bruneiska..nn.1
  brunera_1_V = mkV "brunerar" ; -- brunera..vb.1
  brunerande_1_N = mkN "brunerande" ; -- brunerande..nn.1
  brunerbar_1_A = mkA "brunerbar" ; -- brunerbar..av.1
  brunerbarhet_1_N = mkN "brunerbarhet" ; -- brunerbarhet..nn.1
  brunering_1_N = mkN "brunering" ; -- brunering..nn.1
  brunett_1_A = mkA "brunett" ; -- brunett..av.1
  brunett_1_N = mkN "brunett" "brunetter" ; -- brunett..nn.1
  brunfärga_1_V = mkV "brunfärgar" ; -- brunfärga..vb.1
  brunfärgad_1_A = mkA "brunfärgad" ; -- brunfärgad..av.1
  brunfärgande_1_N = mkN "brunfärgande" ; -- brunfärgande..nn.1
  brunglänsande_1_A = mkA "brunglänsande" ; -- brunglänsande..av.1
  brungrå_1_A = mkA "brungrå" "brungrått" ; -- brungrå..av.1
  brungul_1_A = mkA "brungul" ; -- brungul..av.1
  brunhet_1_N = mkN "brunhet" ; -- brunhet..nn.1
  brunhyad_1_A = mkA "brunhyad" ; -- brunhyad..av.1
  brunhårig_1_A = mkA "brunhårig" ; -- brunhårig..av.1
  brunhårighet_1_N = mkN "brunhårighet" ; -- brunhårighet..nn.1
  brunjord_1_N = mkN "brunjord" ; -- brunjord..nn.1
  brunkol_1_N = mkN "brunkol" neutrum  ; -- brunkol..nn.1
  brunkolsdoft_1_N = mkN "brunkolsdoft" ; -- brunkolsdoft..nn.1
  brunkulla_1_N = mkN "brunkulla" ; -- brunkulla..nn.1
  brunkål_1_N = mkN "brunkål" ; -- brunkål..nn.1
  brunlackerad_1_A = mkA "brunlackerad" ; -- brunlackerad..av.1
  brunmurrig_1_A = mkA "brunmurrig" ; -- brunmurrig..av.1
  brunmurrighet_1_N = mkN "brunmurrighet" ; -- brunmurrighet..nn.1
  brunmålad_1_A = mkA "brunmålad" ; -- brunmålad..av.1
  brunn_1_N = mkN "brunn" ; -- brunn..nn.1
  brunnsdrickning_1_N = mkN "brunnsdrickning" ; -- brunnsdrickning..nn.1
  brunnshus_1_N = mkN "brunnshus" neutrum  ; -- brunnshus..nn.1
  brunnskall_1_A = mkA "brunnskall" ; -- brunnskall..av.1
  brunnskar_1_N = mkN "brunnskar" neutrum  ; -- brunnskar..nn.1
  brunnskur_1_N = mkN "brunnskur" "brunnskurer" ; -- brunnskur..nn.1
  brunnsläkare_1_N = mkN "brunnsläkare" utrum  ; -- brunnsläkare..nn.1
  brunnsort_1_N = mkN "brunnsort" "brunnsorter" ; -- brunnsort..nn.1
  brunnspark_1_N = mkN "brunnspark" ; -- brunnspark..nn.1
  brunnssvängel_1_N = mkN "brunnssvängel" ; -- brunnssvängel..nn.1
  brunnsvatten_1_N = mkN "brunnsvatten" "brunnsvattnet" "brunnsvatten" "brunnsvattnen" ; -- brunnsvatten..nn.1
  brunnsöppning_1_N = mkN "brunnsöppning" ; -- brunnsöppning..nn.1
  brunockra_1_N = mkN "brunockra" ; -- brunockra..nn.1
  brunrost_1_N = mkN "brunrost" ; -- brunrost..nn.1
  brunrutig_1_A = mkA "brunrutig" ; -- brunrutig..av.1
  brunrutighet_1_N = mkN "brunrutighet" ; -- brunrutighet..nn.1
  brunråtta_1_N = mkN "brunråtta" ; -- brunråtta..nn.1
  brunröd_1_A = mkA "brunröd" "brunrött" ; -- brunröd..av.1
  brunröta_1_N = mkN "brunröta" ; -- brunröta..nn.1
  brunskjorta_1_N = mkN "brunskjorta" ; -- brunskjorta..nn.1
  brunskära_1_N = mkN "brunskära" ; -- brunskära..nn.1
  brunsmutsig_1_A = mkA "brunsmutsig" ; -- brunsmutsig..av.1
  brunst_1_N = mkN "brunst" ; -- brunst..nn.1
  brunstig_1_A = mkA "brunstig" ; -- brunstig..av.1
  brunstighet_1_N = mkN "brunstighet" ; -- brunstighet..nn.1
  brunsttid_1_N = mkN "brunsttid" "brunsttider" ; -- brunsttid..nn.1
  brunsvart_1_A = mkA "brunsvart" "brunsvart" ; -- brunsvart..av.1
  brunte_1_N = mkN "brunte" utrum  ; -- brunte..nn.1
  brunögd_1_A = mkA "brunögd" "brunögt" ; -- brunögd..av.1
  brunögdhet_1_N = mkN "brunögdhet" ; -- brunögdhet..nn.1
  brunört_1_N = mkN "brunört" "brunörter" ; -- brunört..nn.1
  brus_1_N = mkN "brus" neutrum  ; -- brus..nn.1
  brusa_1_V = mkV "brusar" ; -- brusa..vb.1
  brusande_1_N = mkN "brusande" ; -- brusande..nn.1
  brusdryck_1_N = mkN "brusdryck" "brusdrycker" ; -- brusdryck..nn.1
  brushane_1_N = mkN "brushane" utrum  ; -- brushane..nn.1
  brushuvud_1_N = mkN "brushuvud" "brushuvudet" "brushuvud" "brushuvudena" ; -- brushuvud..nn.1
  brusig_1_A = mkA "brusig" ; -- brusig..av.1
  brusighet_1_N = mkN "brusighet" "brusigheter" ; -- brusighet..nn.1
  brustablett_1_N = mkN "brustablett" "brustabletter" ; -- brustablett..nn.1
  brusten_1_A = mkA "brusten" ; -- brusten..av.1
  brustenhet_1_N = mkN "brustenhet" ; -- brustenhet..nn.1
  brutal_1_A = mkA "brutal" ; -- brutal..av.1
  brutalisera_1_V = mkV "brutaliserar" ; -- brutalisera..vb.1
  brutaliserande_1_N = mkN "brutaliserande" ; -- brutaliserande..nn.1
  brutaliserbar_1_A = mkA "brutaliserbar" ; -- brutaliserbar..av.1
  brutaliserbarhet_1_N = mkN "brutaliserbarhet" ; -- brutaliserbarhet..nn.1
  brutalisering_1_N = mkN "brutalisering" ; -- brutalisering..nn.1
  brutalitet_1_N = mkN "brutalitet" "brutaliteter" ; -- brutalitet..nn.1
  bruten_1_A = mkA "bruten" ; -- bruten..av.1
  brutta_1_N = mkN "brutta" ; -- brutta..nn.1
  brutto_1_N = mkN "brutto" "bruttot" "brutton" "bruttona" ; -- brutto..nn.1
  bruttoavkastning_1_N = mkN "bruttoavkastning" ; -- bruttoavkastning..nn.1
  bruttobehållning_1_N = mkN "bruttobehållning" ; -- bruttobehållning..nn.1
  bruttobelopp_1_N = mkN "bruttobelopp" neutrum  ; -- bruttobelopp..nn.1
  bruttodräktighet_1_N = mkN "bruttodräktighet" "bruttodräktigheter" ; -- bruttodräktighet..nn.1
  bruttoformel_1_N = mkN "bruttoformel" "bruttoformeln" "bruttoformler" "bruttoformlerna" ; -- bruttoformel..nn.1
  bruttoinkomst_1_N = mkN "bruttoinkomst" "bruttoinkomster" ; -- bruttoinkomst..nn.1
  bruttolön_1_N = mkN "bruttolön" "bruttolöner" ; -- bruttolön..nn.1
  bruttonationalprodukt_1_N = mkN "bruttonationalprodukt" "bruttonationalprodukter" ; -- bruttonationalprodukt..nn.1
  bruttopris_1_N = mkN "bruttopris" neutrum  ; -- bruttopris..nn.1
  bruttoregisterton_1_N = mkN "bruttoregisterton" "bruttoregistertonnet" "bruttoregisterton" "bruttoregistertonnen" ; -- bruttoregisterton..nn.1
  bruttovikt_1_N = mkN "bruttovikt" ; -- bruttovikt..nn.1
  bruttovinst_1_N = mkN "bruttovinst" "bruttovinster" ; -- bruttovinst..nn.1
  bruttovärde_1_N = mkN "bruttovärde" ; -- bruttovärde..nn.1
  bry_1_N = mkN "bry" neutrum  ; -- bry..nn.1
  bry_1_V = mkV "bryr" ; -- bry..vb.1
  brydd_1_A = mkA "brydd" ; -- brydd..av.1
  bryddhet_1_N = mkN "bryddhet" ; -- bryddhet..nn.1
  bryderi_1_N = mkN "bryderi" "bryderiet" "bryderier" "bryderierna" ; -- bryderi..nn.1
  brydsam_1_A = mkA "brydsam" "brydsamt" "brydsamma" "brydsamma" "brydsammare" "brydsammast" "brydsammaste" ; -- brydsam..av.1
  brydsamhet_1_N = mkN "brydsamhet" ; -- brydsamhet..nn.1
  bryende_1_N = mkN "bryende" ; -- bryende..nn.1
  brygd_1_N = mkN "brygd" "brygder" ; -- brygd..nn.1
  brygga_1_N = mkN "brygga" ; -- brygga..nn.1
  brygga_1_V = mkV "brygger" ; -- brygga..vb.1
  brygga_2_V = mkV "bryggar" ; -- brygga..vb.2
  bryggande_1_N = mkN "bryggande" ; -- bryggande..nn.1
  bryggarbil_1_N = mkN "bryggarbil" ; -- bryggarbil..nn.1
  bryggare_1_N = mkN "bryggare" utrum  ; -- bryggare..nn.1
  bryggdans_1_N = mkN "bryggdans" ; -- bryggdans..nn.1
  bryggeri_1_N = mkN "bryggeri" "bryggeriet" "bryggerier" "bryggerierna" ; -- bryggeri..nn.1
  bryggerijäst_1_N = mkN "bryggerijäst" ; -- bryggerijäst..nn.1
  bryggerijätte_1_N = mkN "bryggerijätte" utrum  ; -- bryggerijätte..nn.1
  brygghus_1_N = mkN "brygghus" neutrum  ; -- brygghus..nn.1
  bryggjäst_1_N = mkN "bryggjäst" ; -- bryggjäst..nn.1
  bryggkaffe_1_N = mkN "bryggkaffe" ; -- bryggkaffe..nn.1
  bryggkant_1_N = mkN "bryggkant" "bryggkanter" ; -- bryggkant..nn.1
  bryggmald_1_A = mkA "bryggmald" "bryggmalt" ; -- bryggmald..av.1
  bryggmalen_1_A = mkA "bryggmalen" ; -- bryggmalen..av.1
  bryggplats_1_N = mkN "bryggplats" "bryggplatser" ; -- bryggplats..nn.1
  bryggvåg_1_N = mkN "bryggvåg" ; -- bryggvåg..nn.1
  brylling_1_N = mkN "brylling" ; -- brylling..nn.1
  brylå_1_N = mkN "brylå" "brylåer" ; -- brylå..nn.1
  brylépudding_1_N = mkN "brylépudding" ; -- brylépudding..nn.1
  bryn_1_N = mkN "bryn" neutrum  ; -- bryn..nn.1
  bryna_1_V = mkV "bryna" "bryner" "bryn" "brynte" "brynt" "brynt" ; -- bryna..vb.1
  bryna_2_V = mkV "brynar" ; -- bryna..vb.2
  brynande_1_N = mkN "brynande" ; -- brynande..nn.1
  bryne_1_N = mkN "bryne" ; -- bryne..nn.1
  brynja_1_N = mkN "brynja" ; -- brynja..nn.1
  brynset_1_N = mkN "brynset" neutrum  ; -- brynset..nn.1
  brynsten_1_N = mkN "brynsten" "brynstenen" "brynstenar" "brynstenarna" ; -- brynsten..nn.1
  brynstål_1_N = mkN "brynstål" neutrum  ; -- brynstål..nn.1
  bryolog_1_N = mkN "bryolog" "bryologer" ; -- bryolog..nn.1
  bryologi_1_N = mkN "bryologi" ; -- bryologi..nn.1
  brysk_1_A = mkA "brysk" ; -- brysk..av.1
  bryskhet_1_N = mkN "bryskhet" ; -- bryskhet..nn.1
  brysselkål_1_N = mkN "brysselkål" ; -- brysselkål..nn.1
  brysselmatta_1_N = mkN "brysselmatta" ; -- brysselmatta..nn.1
  brysselspets_1_N = mkN "brysselspets" ; -- brysselspets..nn.1
  bryta_1_V = mkV "bryta" "bröt" "brutit" ; -- bryta..vb.1
  brytande_1_N = mkN "brytande" ; -- brytande..nn.1
  brytare_1_N = mkN "brytare" utrum  ; -- brytare..nn.1
  brytarfel_1_N = mkN "brytarfel" "brytarfelet" "brytarfel" "brytarfelen" ; -- brytarfel..nn.1
  brytbar_1_A = mkA "brytbar" ; -- brytbar..av.1
  brytbarhet_1_N = mkN "brytbarhet" ; -- brytbarhet..nn.1
  brytblad_1_N = mkN "brytblad" neutrum  ; -- brytblad..nn.1
  brytbladskniv_1_N = mkN "brytbladskniv" ; -- brytbladskniv..nn.1
  brytböna_1_N = mkN "brytböna" ; -- brytböna..nn.1
  bryte_1_N = mkN "bryte" utrum  ; -- bryte..nn.1
  brytning_1_N = mkN "brytning" ; -- brytning..nn.1
  brytningsexponent_1_N = mkN "brytningsexponent" "brytningsexponenter" ; -- brytningsexponent..nn.1
  brytningsfel_1_N = mkN "brytningsfel" "brytningsfelet" "brytningsfel" "brytningsfelen" ; -- brytningsfel..nn.1
  brytningsförmåga_1_N = mkN "brytningsförmåga" ; -- brytningsförmåga..nn.1
  brytningsgräns_1_N = mkN "brytningsgräns" ; -- brytningsgräns..nn.1
  brytningsindex_1_N = mkN "brytningsindex" neutrum  ; -- brytningsindex..nn.1
  brytningsperiod_1_N = mkN "brytningsperiod" "brytningsperioder" ; -- brytningsperiod..nn.1
  brytningspunkt_1_N = mkN "brytningspunkt" "brytningspunkter" ; -- brytningspunkt..nn.1
  brytningstid_1_N = mkN "brytningstid" "brytningstider" ; -- brytningstid..nn.1
  brytningsvinkel_1_N = mkN "brytningsvinkel" ; -- brytningsvinkel..nn.1
  brytningsår_1_N = mkN "brytningsår" neutrum  ; -- brytningsår..nn.1
  brytpunkt_1_N = mkN "brytpunkt" "brytpunkter" ; -- brytpunkt..nn.1
  brytvapen_1_N = mkN "brytvapen" "brytvapnet" "brytvapen" "brytvapnen" ; -- brytvapen..nn.1
  bräck_1_N = mkN "bräck" neutrum  ; -- bräck..nn.1
  bräcka_1_V = mkV "bräcker" ; -- bräcka..vb.1
  bräckage_1_N = mkN "bräckage" ; -- bräckage..nn.1
  bräckande_1_N = mkN "bräckande" ; -- bräckande..nn.1
  bräckhammare_1_N = mkN "bräckhammare" "bräckhammaren" "bräckhammare" "bräckhamrarna" ; -- bräckhammare..nn.1
  bräckjärn_1_N = mkN "bräckjärn" neutrum  ; -- bräckjärn..nn.1
  bräckkorv_1_N = mkN "bräckkorv" ; -- bräckkorv..nn.1
  bräcklig_1_A = mkA "bräcklig" ; -- bräcklig..av.1
  bräcklighet_1_N = mkN "bräcklighet" ; -- bräcklighet..nn.1
  bräckning_1_N = mkN "bräckning" ; -- bräckning..nn.1
  bräckt_1_A = mkA "bräckt" "bräckt" ; -- bräckt..av.1
  bräckthet_1_N = mkN "bräckthet" ; -- bräckthet..nn.1
  bräckvatten_1_N = mkN "bräckvatten" "bräckvattnet" "bräckvatten" "bräckvattnen" ; -- bräckvatten..nn.1
  bräda_1_N = mkN "bräda" ; -- bräda..nn.1
  bräda_1_V = mkV "brädar" ; -- bräda..vb.1
  brädande_1_N = mkN "brädande" ; -- brädande..nn.1
  brädbeklä_1_V = mkV "brädbeklä" "brädbeklädde" "brädbeklätt" ; -- brädbeklä..vb.1
  brädbeklädande_1_N = mkN "brädbeklädande" ; -- brädbeklädande..nn.1
  brädbeklädd_1_A = mkA "brädbeklädd" ; -- brädbeklädd..av.1
  brädbeklädnad_1_N = mkN "brädbeklädnad" "brädbeklädnader" ; -- brädbeklädnad..nn.1
  brädbeslå_1_V = mkV "brädbeslå" "brädbeslog" "brädbeslagit" ; -- brädbeslå..vb.1
  brädbeslående_1_N = mkN "brädbeslående" ; -- brädbeslående..nn.1
  brädd_1_N = mkN "brädd" ; -- brädd..nn.1
  brädda_1_V = mkV "bräddar" ; -- brädda..vb.1
  bräddande_1_N = mkN "bräddande" ; -- bräddande..nn.1
  bräddavlopp_1_N = mkN "bräddavlopp" neutrum  ; -- bräddavlopp..nn.1
  bräddfull_1_A = mkA "bräddfull" ; -- bräddfull..av.1
  bräddfullhet_1_N = mkN "bräddfullhet" ; -- bräddfullhet..nn.1
  bräddfylld_1_A = mkA "bräddfylld" "bräddfyllt" ; -- bräddfylld..av.1
  bräddfylldhet_1_N = mkN "bräddfylldhet" ; -- bräddfylldhet..nn.1
  bräde_1_N = mkN "bräde" ; -- bräde..nn.1
  brädfodra_1_V = mkV "brädfodrar" ; -- brädfodra..vb.1
  brädfodrande_1_N = mkN "brädfodrande" ; -- brädfodrande..nn.1
  brädgång_1_N = mkN "brädgång" ; -- brädgång..nn.1
  brädgård_1_N = mkN "brädgård" ; -- brädgård..nn.1
  brädplank_1_N = mkN "brädplank" neutrum  ; -- brädplank..nn.1
  brädsegla_1_V = mkV "brädseglar" ; -- brädsegla..vb.1
  brädseglande_1_N = mkN "brädseglande" ; -- brädseglande..nn.1
  brädslå_1_V = mkV "brädslå" "brädslog" "brädslagit" ; -- brädslå..vb.1
  brädslående_1_N = mkN "brädslående" ; -- brädslående..nn.1
  brädspel_1_N = mkN "brädspel" "brädspelet" "brädspel" "brädspelen" ; -- brädspel..nn.1
  brädvägg_1_N = mkN "brädvägg" ; -- brädvägg..nn.1
  bräka_1_V = mkV "bräker" ; -- bräka..vb.1
  bräkande_1_N = mkN "bräkande" ; -- bräkande..nn.1
  bräken_1_N = mkN "bräken" ; -- bräken..nn.1
  bräkning_1_N = mkN "bräkning" ; -- bräkning..nn.1
  bräm_1_N = mkN "bräm" neutrum  ; -- bräm..nn.1
  bräma_1_V = mkV "brämar" ; -- bräma..vb.1
  brämande_1_N = mkN "brämande" ; -- brämande..nn.1
  bränna_1_V = mkV "bränna" "brände" "bränt" ; -- bränna..vb.1
  brännande_1_A = mkA "brännande" ; -- brännande..av.1
  brännande_1_N = mkN "brännande" ; -- brännande..nn.1
  brännare_1_N = mkN "brännare" utrum  ; -- brännare..nn.1
  brännbar_1_A = mkA "brännbar" ; -- brännbar..av.1
  brännbarhet_1_N = mkN "brännbarhet" ; -- brännbarhet..nn.1
  brännblåsa_1_N = mkN "brännblåsa" ; -- brännblåsa..nn.1
  brännboll_1_N = mkN "brännboll" ; -- brännboll..nn.1
  brännboll_2_N = mkN "brännboll" ; -- brännboll..nn.2
  brännbollskast_1_N = mkN "brännbollskast" neutrum  ; -- brännbollskast..nn.1
  brännbollsträ_1_N = mkN "brännbollsträ" "brännbollsträt" "brännbollsträn" "brännbollsträna" ; -- brännbollsträ..nn.1
  bränne_1_N = mkN "bränne" ; -- bränne..nn.1
  bränneri_1_N = mkN "bränneri" "bränneriet" "brännerier" "brännerierna" ; -- bränneri..nn.1
  brännglas_1_N = mkN "brännglas" neutrum  ; -- brännglas..nn.1
  brännhet_1_A = mkA "brännhet" ; -- brännhet..av.1
  brännhår_1_N = mkN "brännhår" neutrum  ; -- brännhår..nn.1
  bränning_1_N = mkN "bränning" ; -- bränning..nn.1
  brännjärn_1_N = mkN "brännjärn" neutrum  ; -- brännjärn..nn.1
  brännkammare_1_N = mkN "brännkammare" utrum  ; -- brännkammare..nn.1
  brännlack_1_N = mkN "brännlack" ; -- brännlack..nn.1
  brännlackera_1_V = mkV "brännlackerar" ; -- brännlackera..vb.1
  brännlackerande_1_N = mkN "brännlackerande" ; -- brännlackerande..nn.1
  brännlackerbar_1_A = mkA "brännlackerbar" ; -- brännlackerbar..av.1
  brännlackerbarhet_1_N = mkN "brännlackerbarhet" ; -- brännlackerbarhet..nn.1
  brännlackering_1_N = mkN "brännlackering" ; -- brännlackering..nn.1
  brännmanet_1_N = mkN "brännmanet" "brännmaneter" ; -- brännmanet..nn.1
  brännmaterial_1_N = mkN "brännmaterial" neutrum  ; -- brännmaterial..nn.1
  brännmärka_1_V = mkV "brännmärker" ; -- brännmärka..vb.1
  brännmärkande_1_N = mkN "brännmärkande" ; -- brännmärkande..nn.1
  brännmärke_1_N = mkN "brännmärke" ; -- brännmärke..nn.1
  brännmärkning_1_N = mkN "brännmärkning" ; -- brännmärkning..nn.1
  brännoffer_1_N = mkN "brännoffer" neutrum  ; -- brännoffer..nn.1
  brännolja_1_N = mkN "brännolja" ; -- brännolja..nn.1
  brännpunkt_1_N = mkN "brännpunkt" "brännpunkter" ; -- brännpunkt..nn.1
  brännskada_1_N = mkN "brännskada" ; -- brännskada..nn.1
  brännskada_1_V = mkV "brännskadar" ; -- brännskada..vb.1
  brännskadad_1_A = mkA "brännskadad" ; -- brännskadad..av.1
  brännskadande_1_N = mkN "brännskadande" ; -- brännskadande..nn.1
  brännstål_1_N = mkN "brännstål" neutrum  ; -- brännstål..nn.1
  brännsår_1_N = mkN "brännsår" neutrum  ; -- brännsår..nn.1
  bränntorv_1_N = mkN "bränntorv" ; -- bränntorv..nn.1
  brännugn_1_N = mkN "brännugn" ; -- brännugn..nn.1
  brännved_1_N = mkN "brännved" ; -- brännved..nn.1
  brännvidd_1_N = mkN "brännvidd" "brännvidder" ; -- brännvidd..nn.1
  brännvin_1_N = mkN "brännvin" "brännvinet" "brännviner" "brännvinerna" ; -- brännvin..nn.1
  brännvinsadvokat_1_N = mkN "brännvinsadvokat" "brännvinsadvokater" ; -- brännvinsadvokat..nn.1
  brännvinsbas_1_N = mkN "brännvinsbas" ; -- brännvinsbas..nn.1
  brännvinsbord_1_N = mkN "brännvinsbord" neutrum  ; -- brännvinsbord..nn.1
  brännvinsbränneri_1_N = mkN "brännvinsbränneri" "brännvinsbränneriet" "brännvinsbrännerier" "brännvinsbrännerierna" ; -- brännvinsbränneri..nn.1
  brännvinsbränning_1_N = mkN "brännvinsbränning" ; -- brännvinsbränning..nn.1
  brännvinsdestilleri_1_N = mkN "brännvinsdestilleri" "brännvinsdestilleriet" "brännvinsdestillerier" "brännvinsdestillerierna" ; -- brännvinsdestilleri..nn.1
  brännvinsdestillering_1_N = mkN "brännvinsdestillering" ; -- brännvinsdestillering..nn.1
  brännvinsglas_1_N = mkN "brännvinsglas" neutrum  ; -- brännvinsglas..nn.1
  brännvinsnäsa_1_N = mkN "brännvinsnäsa" ; -- brännvinsnäsa..nn.1
  brännvinsprovare_1_N = mkN "brännvinsprovare" utrum  ; -- brännvinsprovare..nn.1
  brännyta_1_N = mkN "brännyta" ; -- brännyta..nn.1
  brännässla_1_N = mkN "brännässla" ; -- brännässla..nn.1
  bränsle_1_N = mkN "bränsle" ; -- bränsle..nn.1
  bränslebesparande_1_A = mkA "bränslebesparande" ; -- bränslebesparande..av.1
  bränslebesparing_1_N = mkN "bränslebesparing" ; -- bränslebesparing..nn.1
  bränslebrist_1_N = mkN "bränslebrist" ; -- bränslebrist..nn.1
  bränslecell_1_N = mkN "bränslecell" "bränsleceller" ; -- bränslecell..nn.1
  bränslecellsdriven_1_A = mkA "bränslecellsdriven" ; -- bränslecellsdriven..av.1
  bränslecellskonstruktion_1_N = mkN "bränslecellskonstruktion" ; -- bränslecellskonstruktion..nn.1
  bränslecellskraftverk_1_N = mkN "bränslecellskraftverk" neutrum  ; -- bränslecellskraftverk..nn.1
  bränslecellstyp_1_N = mkN "bränslecellstyp" "bränslecellstyper" ; -- bränslecellstyp..nn.1
  bränsledepå_1_N = mkN "bränsledepå" "bränsledepåer" ; -- bränsledepå..nn.1
  bränsleelement_1_N = mkN "bränsleelement" neutrum  ; -- bränsleelement..nn.1
  bränslefilter_1_N = mkN "bränslefilter" neutrum  ; -- bränslefilter..nn.1
  bränslefält_1_N = mkN "bränslefält" neutrum  ; -- bränslefält..nn.1
  bränsleförbrukning_1_N = mkN "bränsleförbrukning" ; -- bränsleförbrukning..nn.1
  bränsleförråd_1_N = mkN "bränsleförråd" neutrum  ; -- bränsleförråd..nn.1
  bränslegas_1_N = mkN "bränslegas" "bränslegaser" ; -- bränslegas..nn.1
  bränslekanal_1_N = mkN "bränslekanal" "bränslekanaler" ; -- bränslekanal..nn.1
  bränslekris_1_N = mkN "bränslekris" "bränslekriser" ; -- bränslekris..nn.1
  bränslemätare_1_N = mkN "bränslemätare" utrum  ; -- bränslemätare..nn.1
  bränsleomvandlare_1_N = mkN "bränsleomvandlare" utrum  ; -- bränsleomvandlare..nn.1
  bränsleransonering_1_N = mkN "bränsleransonering" ; -- bränsleransonering..nn.1
  bränsleslukande_1_A = mkA "bränsleslukande" ; -- bränsleslukande..av.1
  bränslesnål_1_A = mkA "bränslesnål" ; -- bränslesnål..av.1
  bränslesnålhet_1_N = mkN "bränslesnålhet" ; -- bränslesnålhet..nn.1
  bränslestav_1_N = mkN "bränslestav" ; -- bränslestav..nn.1
  bränsletank_1_N = mkN "bränsletank" ; -- bränsletank..nn.1
  bränsletillägg_1_N = mkN "bränsletillägg" neutrum  ; -- bränsletillägg..nn.1
  bränsletyp_1_N = mkN "bränsletyp" "bränsletyper" ; -- bränsletyp..nn.1
  bränsleåtgång_1_N = mkN "bränsleåtgång" ; -- bränsleåtgång..nn.1
  bräsch_1_N = mkN "bräsch" "bräscher" ; -- bräsch..nn.1
  bräsera_1_V = mkV "bräserar" ; -- bräsera..vb.1
  bräserande_1_N = mkN "bräserande" ; -- bräserande..nn.1
  bräserbar_1_A = mkA "bräserbar" ; -- bräserbar..av.1
  bräserbarhet_1_N = mkN "bräserbarhet" ; -- bräserbarhet..nn.1
  bräsering_1_N = mkN "bräsering" ; -- bräsering..nn.1
  bräsma_1_N = mkN "bräsma" ; -- bräsma..nn.1
  bräss_1_N = mkN "bräss" ; -- bräss..nn.1
  brätte_1_N = mkN "brätte" ; -- brätte..nn.1
  bråck_1_N = mkN "bråck" neutrum  ; -- bråck..nn.1
  bråckband_1_N = mkN "bråckband" neutrum  ; -- bråckband..nn.1
  bråd_1_A = mkA "bråd" "brått" ; -- bråd..av.1
  bråddjup_1_A = mkA "bråddjup" ; -- bråddjup..av.1
  bråddjup_1_N = mkN "bråddjup" neutrum  ; -- bråddjup..nn.1
  bråddjuphet_1_N = mkN "bråddjuphet" ; -- bråddjuphet..nn.1
  brådhet_1_N = mkN "brådhet" ; -- brådhet..nn.1
  brådmogen_1_A = mkA "brådmogen" ; -- brådmogen..av.1
  brådmogenhet_1_N = mkN "brådmogenhet" ; -- brådmogenhet..nn.1
  brådmognad_1_N = mkN "brådmognad" ; -- brådmognad..nn.1
  brådska_1_N = mkN "brådska" ; -- brådska..nn.1
  brådska_1_V = mkV "brådskar" ; -- brådska..vb.1
  brådskande_1_A = mkA "brådskande" ; -- brådskande..av.1
  brådskande_1_N = mkN "brådskande" ; -- brådskande..nn.1
  brådstörtad_1_A = mkA "brådstörtad" ; -- brådstörtad..av.1
  bråk_1_N = mkN "bråk" neutrum  ; -- bråk..nn.1
  bråka_1_N = mkN "bråka" ; -- bråka..nn.1
  bråka_1_V = mkV "bråkar" ; -- bråka..vb.1
  bråka_2_V = mkV "bråkar" ; -- bråka..vb.2
  bråkande_1_N = mkN "bråkande" ; -- bråkande..nn.1
  bråkdel_1_N = mkN "bråkdel" "bråkdelen" "bråkdelar" "bråkdelarna" ; -- bråkdel..nn.1
  bråkig_1_A = mkA "bråkig" ; -- bråkig..av.1
  bråkighet_1_N = mkN "bråkighet" ; -- bråkighet..nn.1
  bråkmakare_1_N = mkN "bråkmakare" utrum  ; -- bråkmakare..nn.1
  bråkräkning_1_N = mkN "bråkräkning" ; -- bråkräkning..nn.1
  bråkstake_1_N = mkN "bråkstake" utrum  ; -- bråkstake..nn.1
  bråkstreck_1_N = mkN "bråkstreck" neutrum  ; -- bråkstreck..nn.1
  bråktal_1_N = mkN "bråktal" neutrum  ; -- bråktal..nn.1
  brånad_1_N = mkN "brånad" "brånader" ; -- brånad..nn.1
  bråte_1_N = mkN "bråte" ; -- bråte..nn.1
  bråttom_1_A = mkA "bråttom" ; -- bråttom..av.1
  bröa_1_V = mkV "bröar" ; -- bröa..vb.1
  bröande_1_N = mkN "bröande" ; -- bröande..nn.1
  bröd_1_N = mkN "bröd" neutrum  ; -- bröd..nn.1
  bröda_1_V = mkV "brödar" ; -- bröda..vb.1
  brödande_1_N = mkN "brödande" ; -- brödande..nn.1
  brödbagge_1_N = mkN "brödbagge" utrum  ; -- brödbagge..nn.1
  brödbak_1_N = mkN "brödbak" neutrum  ; -- brödbak..nn.1
  brödbit_1_N = mkN "brödbit" ; -- brödbit..nn.1
  brödbrist_1_N = mkN "brödbrist" ; -- brödbrist..nn.1
  brödburk_1_N = mkN "brödburk" ; -- brödburk..nn.1
  brödfat_1_N = mkN "brödfat" neutrum  ; -- brödfat..nn.1
  brödfrukt_1_N = mkN "brödfrukt" "brödfrukter" ; -- brödfrukt..nn.1
  brödföda_1_N = mkN "brödföda" ; -- brödföda..nn.1
  bröding_1_N = mkN "bröding" ; -- bröding..nn.1
  brödkaka_1_N = mkN "brödkaka" ; -- brödkaka..nn.1
  brödkant_1_N = mkN "brödkant" "brödkanter" ; -- brödkant..nn.1
  brödkavel_1_N = mkN "brödkavel" ; -- brödkavel..nn.1
  brödkavle_1_N = mkN "brödkavle" utrum  ; -- brödkavle..nn.1
  brödkniv_1_N = mkN "brödkniv" ; -- brödkniv..nn.1
  brödkorg_1_N = mkN "brödkorg" ; -- brödkorg..nn.1
  brödkö_1_N = mkN "brödkö" "brödkön" "brödköer" "brödköerna" ; -- brödkö..nn.1
  brödlös_1_A = mkA "brödlös" ; -- brödlös..av.1
  brödlöshet_1_N = mkN "brödlöshet" ; -- brödlöshet..nn.1
  brödnagg_1_N = mkN "brödnagg" ; -- brödnagg..nn.1
  brödpris_1_N = mkN "brödpris" neutrum  ; -- brödpris..nn.1
  brödpudding_1_N = mkN "brödpudding" ; -- brödpudding..nn.1
  brödrafolk_1_N = mkN "brödrafolk" neutrum  ; -- brödrafolk..nn.1
  brödralag_1_N = mkN "brödralag" neutrum  ; -- brödralag..nn.1
  brödrapar_1_N = mkN "brödrapar" neutrum  ; -- brödrapar..nn.1
  brödrasinne_1_N = mkN "brödrasinne" ; -- brödrasinne..nn.1
  brödraskap_1_N = mkN "brödraskap" neutrum  ; -- brödraskap..nn.1
  brödrost_1_N = mkN "brödrost" ; -- brödrost..nn.1
  brödsbrytelse_1_N = mkN "brödsbrytelse" "brödsbrytelser" ; -- brödsbrytelse..nn.1
  brödskiva_1_N = mkN "brödskiva" ; -- brödskiva..nn.1
  brödskriveri_1_N = mkN "brödskriveri" "brödskriveriet" "brödskriverier" "brödskriverierna" ; -- brödskriveri..nn.1
  brödsmula_1_N = mkN "brödsmula" ; -- brödsmula..nn.1
  brödspade_1_N = mkN "brödspade" utrum  ; -- brödspade..nn.1
  brödstil_1_N = mkN "brödstil" ; -- brödstil..nn.1
  brödstycke_1_N = mkN "brödstycke" ; -- brödstycke..nn.1
  brödsäd_1_N = mkN "brödsäd" ; -- brödsäd..nn.1
  brödtext_1_N = mkN "brödtext" ; -- brödtext..nn.1
  bröl_1_N = mkN "bröl" neutrum  ; -- bröl..nn.1
  bröla_1_V = mkV "brölar" ; -- bröla..vb.1
  brölande_1_N = mkN "brölande" ; -- brölande..nn.1
  bröllop_1_N = mkN "bröllop" neutrum  ; -- bröllop..nn.1
  bröllopsbuss_1_N = mkN "bröllopsbuss" ; -- bröllopsbuss..nn.1
  bröllopsdag_1_N = mkN "bröllopsdag" ; -- bröllopsdag..nn.1
  bröllopsdikt_1_N = mkN "bröllopsdikt" "bröllopsdikter" ; -- bröllopsdikt..nn.1
  bröllopsfest_1_N = mkN "bröllopsfest" "bröllopsfester" ; -- bröllopsfest..nn.1
  bröllopsfoto_1_N = mkN "bröllopsfoto" "bröllopsfotot" "bröllopsfoton" "bröllopsfotona" ; -- bröllopsfoto..nn.1
  bröllopsgäst_1_N = mkN "bröllopsgäst" "bröllopsgäster" ; -- bröllopsgäst..nn.1
  bröllopsgåva_1_N = mkN "bröllopsgåva" ; -- bröllopsgåva..nn.1
  bröllopsinspirerad_1_A = mkA "bröllopsinspirerad" ; -- bröllopsinspirerad..av.1
  bröllopsklänning_1_N = mkN "bröllopsklänning" ; -- bröllopsklänning..nn.1
  bröllopsmarsch_1_N = mkN "bröllopsmarsch" "bröllopsmarscher" ; -- bröllopsmarsch..nn.1
  bröllopsmåltid_1_N = mkN "bröllopsmåltid" "bröllopsmåltider" ; -- bröllopsmåltid..nn.1
  bröllopsnatt_1_N = mkN "bröllopsnatt" "bröllopsnätter" ; -- bröllopsnatt..nn.1
  bröllopspar_1_N = mkN "bröllopspar" neutrum  ; -- bröllopspar..nn.1
  bröllopsplan_1_N = mkN "bröllopsplan" "bröllopsplaner" ; -- bröllopsplan..nn.1
  bröllopspoet_1_N = mkN "bröllopspoet" "bröllopspoeter" ; -- bröllopspoet..nn.1
  bröllopspresent_1_N = mkN "bröllopspresent" "bröllopspresenter" ; -- bröllopspresent..nn.1
  bröllopsresa_1_N = mkN "bröllopsresa" ; -- bröllopsresa..nn.1
  bröllopsresmål_1_N = mkN "bröllopsresmål" neutrum  ; -- bröllopsresmål..nn.1
  bröllopssed_1_N = mkN "bröllopssed" "bröllopsseder" ; -- bröllopssed..nn.1
  bröllopssällskap_1_N = mkN "bröllopssällskap" neutrum  ; -- bröllopssällskap..nn.1
  bröllopstårta_1_N = mkN "bröllopstårta" ; -- bröllopstårta..nn.1
  bröllopsvideo_1_N = mkN "bröllopsvideo" "bröllopsvideor" ; -- bröllopsvideo..nn.1
  bröllopsvittne_1_N = mkN "bröllopsvittne" ; -- bröllopsvittne..nn.1
  bröllopsyra_1_N = mkN "bröllopsyra" ; -- bröllopsyra..nn.1
  bröst_1_N = mkN "bröst" neutrum  ; -- bröst..nn.1
  brösta_1_N = mkN "brösta" ; -- brösta..nn.1
  bröstarv_1_N = mkN "bröstarv" neutrum  ; -- bröstarv..nn.1
  bröstarvinge_1_N = mkN "bröstarvinge" utrum  ; -- bröstarvinge..nn.1
  bröstbarn_1_N = mkN "bröstbarn" neutrum  ; -- bröstbarn..nn.1
  bröstben_1_N = mkN "bröstben" neutrum  ; -- bröstben..nn.1
  bröstbild_1_N = mkN "bröstbild" "bröstbilder" ; -- bröstbild..nn.1
  bröstböld_1_N = mkN "bröstböld" "bröstbölder" ; -- bröstböld..nn.1
  bröstcancer_1_N = mkN "bröstcancer" ; -- bröstcancer..nn.1
  bröstcancerdiagnos_1_N = mkN "bröstcancerdiagnos" "bröstcancerdiagnoser" ; -- bröstcancerdiagnos..nn.1
  bröstcancerkirurgi_1_N = mkN "bröstcancerkirurgi" ; -- bröstcancerkirurgi..nn.1
  bröstfena_1_N = mkN "bröstfena" ; -- bröstfena..nn.1
  bröstficka_1_N = mkN "bröstficka" ; -- bröstficka..nn.1
  bröstförstoring_1_N = mkN "bröstförstoring" ; -- bröstförstoring..nn.1
  bröstgång_1_N = mkN "bröstgång" ; -- bröstgång..nn.1
  brösthåla_1_N = mkN "brösthåla" ; -- brösthåla..nn.1
  brösthöjd_1_N = mkN "brösthöjd" ; -- brösthöjd..nn.1
  bröstimplantat_1_N = mkN "bröstimplantat" neutrum  ; -- bröstimplantat..nn.1
  bröstingrepp_1_N = mkN "bröstingrepp" neutrum  ; -- bröstingrepp..nn.1
  bröstkaramell_1_N = mkN "bröstkaramell" "bröstkarameller" ; -- bröstkaramell..nn.1
  bröstkatarr_1_N = mkN "bröstkatarr" "bröstkatarrer" ; -- bröstkatarr..nn.1
  bröstklang_1_N = mkN "bröstklang" ; -- bröstklang..nn.1
  bröstknöl_1_N = mkN "bröstknöl" ; -- bröstknöl..nn.1
  bröstkompression_1_N = mkN "bröstkompression" ; -- bröstkompression..nn.1
  bröstkorg_1_N = mkN "bröstkorg" ; -- bröstkorg..nn.1
  bröstkota_1_N = mkN "bröstkota" ; -- bröstkota..nn.1
  bröstkramp_1_N = mkN "bröstkramp" "bröstkramper" ; -- bröstkramp..nn.1
  bröstkörtel_1_N = mkN "bröstkörtel" ; -- bröstkörtel..nn.1
  bröstlapp_1_N = mkN "bröstlapp" ; -- bröstlapp..nn.1
  bröstlidande_1_N = mkN "bröstlidande" ; -- bröstlidande..nn.1
  bröstmjölk_1_N = mkN "bröstmjölk" ; -- bröstmjölk..nn.1
  bröstmjölkspumpsutspel_1_N = mkN "bröstmjölkspumpsutspel" "bröstmjölkspumpsutspelet" "bröstmjölkspumpsutspel" "bröstmjölkspumpsutspelen" ; -- bröstmjölkspumpsutspel..nn.1
  bröstmur_1_N = mkN "bröstmur" ; -- bröstmur..nn.1
  bröstmuskel_1_N = mkN "bröstmuskel" "bröstmuskeln" "bröstmuskler" "bröstmusklerna" ; -- bröstmuskel..nn.1
  bröstmått_1_N = mkN "bröstmått" neutrum  ; -- bröstmått..nn.1
  bröstning_1_N = mkN "bröstning" ; -- bröstning..nn.1
  bröstoperation_1_N = mkN "bröstoperation" ; -- bröstoperation..nn.1
  bröstparti_1_N = mkN "bröstparti" "bröstpartiet" "bröstpartier" "bröstpartierna" ; -- bröstparti..nn.1
  bröstpatient_1_N = mkN "bröstpatient" "bröstpatienter" ; -- bröstpatient..nn.1
  bröstpump_1_N = mkN "bröstpump" ; -- bröstpump..nn.1
  bröstpumpsutspel_1_N = mkN "bröstpumpsutspel" "bröstpumpsutspelet" "bröstpumpsutspel" "bröstpumpsutspelen" ; -- bröstpumpsutspel..nn.1
  bröstregister_1_N = mkN "bröstregister" neutrum  ; -- bröstregister..nn.1
  bröstsimmare_1_N = mkN "bröstsimmare" utrum  ; -- bröstsimmare..nn.1
  bröstsimtag_1_N = mkN "bröstsimtag" neutrum  ; -- bröstsimtag..nn.1
  bröstsjuk_1_A = mkA "bröstsjuk" ; -- bröstsjuk..av.1
  bröstskydd_1_N = mkN "bröstskydd" neutrum  ; -- bröstskydd..nn.1
  bröstsocker_1_N = mkN "bröstsocker" neutrum  ; -- bröstsocker..nn.1
  bröstsugande_1_A = mkA "bröstsugande" ; -- bröstsugande..av.1
  bröstton_1_N = mkN "bröstton" "brösttoner" ; -- bröstton..nn.1
  bröstvidd_1_N = mkN "bröstvidd" "bröstvidder" ; -- bröstvidd..nn.1
  bröstvärk_1_N = mkN "bröstvärk" ; -- bröstvärk..nn.1
  bröstvärn_1_N = mkN "bröstvärn" neutrum  ; -- bröstvärn..nn.1
  bröstvårta_1_N = mkN "bröstvårta" ; -- bröstvårta..nn.1
  bröt_1_N = mkN "bröt" ; -- bröt..nn.1
  bröthake_1_N = mkN "bröthake" utrum  ; -- bröthake..nn.1
  brötling_1_N = mkN "brötling" ; -- brötling..nn.1
  bua_1_V = mkV "buar" ; -- bua..vb.1
  buande_1_N = mkN "buande" ; -- buande..nn.1
  bubba_1_V = mkV "bubbar" ; -- bubba..vb.1
  bubbande_1_N = mkN "bubbande" ; -- bubbande..nn.1
  bubbel_1_N = mkN "bubbel" neutrum  ; -- bubbel..nn.1
  bubbelbad_1_N = mkN "bubbelbad" neutrum  ; -- bubbelbad..nn.1
  bubbelbadkar_1_N = mkN "bubbelbadkar" neutrum  ; -- bubbelbadkar..nn.1
  bubbelgum_1_N = mkN "bubbelgum" "bubbelgummet" "bubbelgum" "bubbelgummen" ; -- bubbelgum..nn.1
  bubbelkammare_1_N = mkN "bubbelkammare" "bubbelkammaren" "bubbelkammare" "bubbelkamrarna" ; -- bubbelkammare..nn.1
  bubbelpool_1_N = mkN "bubbelpool" "bubbelpooler" ; -- bubbelpool..nn.1
  bubbla_1_N = mkN "bubbla" ; -- bubbla..nn.1
  bubbla_1_V = mkV "bubblar" ; -- bubbla..vb.1
  bubblande_1_N = mkN "bubblande" ; -- bubblande..nn.1
  bubblare_1_N = mkN "bubblare" utrum  ; -- bubblare..nn.1
  bubblig_1_A = mkA "bubblig" ; -- bubblig..av.1
  bubblighet_1_N = mkN "bubblighet" ; -- bubblighet..nn.1
  bubon_1_N = mkN "bubon" "buboner" ; -- bubon..nn.1
  buckla_1_N = mkN "buckla" ; -- buckla..nn.1
  bucklig_1_A = mkA "bucklig" ; -- bucklig..av.1
  bucklighet_1_N = mkN "bucklighet" ; -- bucklighet..nn.1
  buckram_1_N = mkN "buckram" ; -- buckram..nn.1
  bud_1_N = mkN "bud" neutrum  ; -- bud..nn.1
  buda_1_V = mkV "budar" ; -- buda..vb.1
  budande_1_N = mkN "budande" ; -- budande..nn.1
  budbyrå_1_N = mkN "budbyrå" "budbyråer" ; -- budbyrå..nn.1
  budbärare_1_N = mkN "budbärare" utrum  ; -- budbärare..nn.1
  buddha_1_N = mkN "buddha" ; -- buddha..nn.1
  buddhism_1_N = mkN "buddhism" "buddhismer" ; -- buddhism..nn.1
  buddhist_1_N = mkN "buddhist" "buddhister" ; -- buddhist..nn.1
  buddhistisk_1_A = mkA "buddhistisk" ; -- buddhistisk..av.1
  buddism_1_N = mkN "buddism" "buddismer" ; -- buddism..nn.1
  buddist_1_N = mkN "buddist" "buddister" ; -- buddist..nn.1
  buddistisk_1_A = mkA "buddistisk" ; -- buddistisk..av.1
  budget_1_N = mkN "budget" ; -- budget..nn.1
  budgetalternativ_1_N = mkN "budgetalternativ" neutrum  ; -- budgetalternativ..nn.1
  budgetansvarig_1_A = mkA "budgetansvarig" ; -- budgetansvarig..av.1
  budgetarbete_1_N = mkN "budgetarbete" ; -- budgetarbete..nn.1
  budgetdisciplin_1_N = mkN "budgetdisciplin" ; -- budgetdisciplin..nn.1
  budgetera_1_V = mkV "budgeterar" ; -- budgetera..vb.1
  budgeterande_1_N = mkN "budgeterande" ; -- budgeterande..nn.1
  budgeterare_1_N = mkN "budgeterare" utrum  ; -- budgeterare..nn.1
  budgeterbar_1_A = mkA "budgeterbar" ; -- budgeterbar..av.1
  budgeterbarhet_1_N = mkN "budgeterbarhet" ; -- budgeterbarhet..nn.1
  budgetering_1_N = mkN "budgetering" ; -- budgetering..nn.1
  budgetflyg_1_N = mkN "budgetflyg" neutrum  ; -- budgetflyg..nn.1
  budgetförordning_1_N = mkN "budgetförordning" ; -- budgetförordning..nn.1
  budgetförslag_1_N = mkN "budgetförslag" neutrum  ; -- budgetförslag..nn.1
  budgetmotion_1_N = mkN "budgetmotion" ; -- budgetmotion..nn.1
  budgetmässig_1_A = mkA "budgetmässig" ; -- budgetmässig..av.1
  budgetpolitik_1_N = mkN "budgetpolitik" ; -- budgetpolitik..nn.1
  budgetpolitisk_1_A = mkA "budgetpolitisk" ; -- budgetpolitisk..av.1
  budgetproposition_1_N = mkN "budgetproposition" ; -- budgetproposition..nn.1
  budgetresa_1_N = mkN "budgetresa" ; -- budgetresa..nn.1
  budgetsanering_1_N = mkN "budgetsanering" ; -- budgetsanering..nn.1
  budgetspa_1_N = mkN "budgetspa" "budgetspat" "budgetspan" "budgetspana" ; -- budgetspa..nn.1
  budgetstup_1_N = mkN "budgetstup" ; -- budgetstup..nn.1
  budgetunderskott_1_N = mkN "budgetunderskott" neutrum  ; -- budgetunderskott..nn.1
  budgetvariant_1_N = mkN "budgetvariant" "budgetvarianter" ; -- budgetvariant..nn.1
  budgetär_1_A = mkA "budgetär" ; -- budgetär..av.1
  budgetår_1_N = mkN "budgetår" neutrum  ; -- budgetår..nn.1
  budgetöverskott_1_N = mkN "budgetöverskott" neutrum  ; -- budgetöverskott..nn.1
  budgivning_1_N = mkN "budgivning" ; -- budgivning..nn.1
  budkavel_1_N = mkN "budkavel" ; -- budkavel..nn.1
  budkavle_1_N = mkN "budkavle" utrum  ; -- budkavle..nn.1
  budkavlelöpning_1_N = mkN "budkavlelöpning" ; -- budkavlelöpning..nn.1
  budning_1_N = mkN "budning" ; -- budning..nn.1
  budo_1_N = mkN "budo" ; -- budo..nn.1
  budoar_1_N = mkN "budoar" "budoarer" ; -- budoar..nn.1
  budoarmässig_1_A = mkA "budoarmässig" ; -- budoarmässig..av.1
  budord_1_N = mkN "budord" neutrum  ; -- budord..nn.1
  budskap_1_N = mkN "budskap" neutrum  ; -- budskap..nn.1
  buff_1_N = mkN "buff" ; -- buff..nn.1
  buffa_1_N = mkN "buffa" ; -- buffa..nn.1
  buffa_1_V = mkV "buffar" ; -- buffa..vb.1
  buffande_1_N = mkN "buffande" ; -- buffande..nn.1
  buffaopera_1_N = mkN "buffaopera" ; -- buffaopera..nn.1
  buffel_1_N = mkN "buffel" ; -- buffel..nn.1
  buffelaktig_1_A = mkA "buffelaktig" ; -- buffelaktig..av.1
  buffelaktighet_1_N = mkN "buffelaktighet" ; -- buffelaktighet..nn.1
  buffelhjord_1_N = mkN "buffelhjord" ; -- buffelhjord..nn.1
  buffert_1_N = mkN "buffert" ; -- buffert..nn.1
  buffertkapacitet_1_N = mkN "buffertkapacitet" "buffertkapaciteter" ; -- buffertkapacitet..nn.1
  buffertlager_1_N = mkN "buffertlager" neutrum  ; -- buffertlager..nn.1
  buffertlösning_1_N = mkN "buffertlösning" ; -- buffertlösning..nn.1
  buffertstat_1_N = mkN "buffertstat" "buffertstater" ; -- buffertstat..nn.1
  bufflig_1_A = mkA "bufflig" ; -- bufflig..av.1
  bufflighet_1_N = mkN "bufflighet" "buffligheter" ; -- bufflighet..nn.1
  buffra_1_V = mkV "buffrar" ; -- buffra..vb.1
  buffrande_1_N = mkN "buffrande" ; -- buffrande..nn.1
  buffringsförmåga_1_N = mkN "buffringsförmåga" ; -- buffringsförmåga..nn.1
  buffé_1_N = mkN "buffé" "bufféer" ; -- buffé..nn.1
  bug_1_N = mkN "bug" ; -- bug..nn.1
  buga_1_V = mkV "bugar" ; -- buga..vb.1
  bugande_1_N = mkN "bugande" ; -- bugande..nn.1
  bugg_1_N = mkN "bugg" ; -- bugg..nn.1
  bugg_2_N = mkN "bugg" ; -- bugg..nn.2
  bugga_1_V = mkV "buggar" ; -- bugga..vb.1
  buggande_1_N = mkN "buggande" ; -- buggande..nn.1
  buggfix_1_N = mkN "buggfix" ; -- buggfix..nn.1
  buggning_1_N = mkN "buggning" ; -- buggning..nn.1
  bugning_1_N = mkN "bugning" ; -- bugning..nn.1
  buk_1_N = mkN "buk" ; -- buk..nn.1
  bukett_1_N = mkN "bukett" "buketter" ; -- bukett..nn.1
  bukettgrönt_1_N = mkN "bukettgrönt" ; -- bukettgrönt..nn.1
  bukfetma_1_N = mkN "bukfetma" ; -- bukfetma..nn.1
  bukfett_1_N = mkN "bukfett" neutrum  ; -- bukfett..nn.1
  bukfettslager_1_N = mkN "bukfettslager" neutrum  ; -- bukfettslager..nn.1
  bukformig_1_A = mkA "bukformig" ; -- bukformig..av.1
  bukfylla_1_N = mkN "bukfylla" ; -- bukfylla..nn.1
  bukfyllnad_1_N = mkN "bukfyllnad" ; -- bukfyllnad..nn.1
  bukgjord_1_N = mkN "bukgjord" ; -- bukgjord..nn.1
  bukhinna_1_N = mkN "bukhinna" ; -- bukhinna..nn.1
  bukhinneinflammation_1_N = mkN "bukhinneinflammation" ; -- bukhinneinflammation..nn.1
  bukhåla_1_N = mkN "bukhåla" ; -- bukhåla..nn.1
  bukig_1_A = mkA "bukig" ; -- bukig..av.1
  bukighet_1_N = mkN "bukighet" ; -- bukighet..nn.1
  buklanda_1_V = mkV "buklandar" ; -- buklanda..vb.1
  buklandande_1_N = mkN "buklandande" ; -- buklandande..nn.1
  bukmuskel_1_N = mkN "bukmuskel" "bukmuskeln" "bukmuskler" "bukmusklerna" ; -- bukmuskel..nn.1
  bukolisk_1_A = mkA "bukolisk" ; -- bukolisk..av.1
  bukskott_1_N = mkN "bukskott" neutrum  ; -- bukskott..nn.1
  bukspott_1_N = mkN "bukspott" ; -- bukspott..nn.1
  bukspottkörtel_1_N = mkN "bukspottkörtel" ; -- bukspottkörtel..nn.1
  bukstinn_1_A = mkA "bukstinn" "bukstint" ; -- bukstinn..av.1
  bukstinnhet_1_N = mkN "bukstinnhet" ; -- bukstinnhet..nn.1
  buksvåger_1_N = mkN "buksvåger" ; -- buksvåger..nn.1
  bukt_1_N = mkN "bukt" "bukter" ; -- bukt..nn.1
  bukta_1_V = mkV "buktar" ; -- bukta..vb.1
  buktala_1_V = mkV "buktalar" ; -- buktala..vb.1
  buktalande_1_N = mkN "buktalande" ; -- buktalande..nn.1
  buktalare_1_N = mkN "buktalare" utrum  ; -- buktalare..nn.1
  buktaleri_1_N = mkN "buktaleri" neutrum  ; -- buktaleri..nn.1
  buktande_1_N = mkN "buktande" ; -- buktande..nn.1
  buktig_1_A = mkA "buktig" ; -- buktig..av.1
  buktighet_1_N = mkN "buktighet" ; -- buktighet..nn.1
  buktning_1_N = mkN "buktning" ; -- buktning..nn.1
  bukvägg_1_N = mkN "bukvägg" ; -- bukvägg..nn.1
  bukvätska_1_N = mkN "bukvätska" ; -- bukvätska..nn.1
  bula_1_N = mkN "bula" ; -- bula..nn.1
  bulb_1_N = mkN "bulb" "bulber" ; -- bulb..nn.1
  bulbjärn_1_N = mkN "bulbjärn" neutrum  ; -- bulbjärn..nn.1
  buldan_1_N = mkN "buldan" ; -- buldan..nn.1
  bulemi_1_N = mkN "bulemi" ; -- bulemi..nn.1
  bulemiker_1_N = mkN "bulemiker" "bulemikern" "bulemiker" "bulemikerna" ; -- bulemiker..nn.1
  bulevard_1_N = mkN "bulevard" "bulevarder" ; -- bulevard..nn.1
  bulgar_1_N = mkN "bulgar" "bulgarer" ; -- bulgar..nn.1
  bulgarisk_1_A = mkA "bulgarisk" ; -- bulgarisk..av.1
  bulgariska_1_N = mkN "bulgariska" ; -- bulgariska..nn.1
  bulgariska_2_N = mkN "bulgariska" ; -- bulgariska..nn.2
  bulgur_1_N = mkN "bulgur" ; -- bulgur..nn.1
  bulimi_1_N = mkN "bulimi" ; -- bulimi..nn.1
  bulimiker_1_N = mkN "bulimiker" "bulimikern" "bulimiker" "bulimikerna" ; -- bulimiker..nn.1
  buljong_1_N = mkN "buljong" "buljonger" ; -- buljong..nn.1
  buljongben_1_N = mkN "buljongben" neutrum  ; -- buljongben..nn.1
  buljongkött_1_N = mkN "buljongkött" neutrum  ; -- buljongkött..nn.1
  buljongtärning_1_N = mkN "buljongtärning" ; -- buljongtärning..nn.1
  bulk_1_N = mkN "bulk" ; -- bulk..nn.1
  bulkfartyg_1_N = mkN "bulkfartyg" neutrum  ; -- bulkfartyg..nn.1
  bulklast_1_N = mkN "bulklast" "bulklaster" ; -- bulklast..nn.1
  bulklastare_1_N = mkN "bulklastare" utrum  ; -- bulklastare..nn.1
  bulkmedel_1_N = mkN "bulkmedel" neutrum  ; -- bulkmedel..nn.1
  bulla_1_N = mkN "bulla" ; -- bulla..nn.1
  bullbak_1_N = mkN "bullbak" neutrum  ; -- bullbak..nn.1
  bulldogg_1_N = mkN "bulldogg" ; -- bulldogg..nn.1
  bulldozer_1_N = mkN "bulldozer" ; -- bulldozer..nn.1
  bulle_1_N = mkN "bulle" utrum  ; -- bulle..nn.1
  buller_1_N = mkN "buller" neutrum  ; -- buller..nn.1
  bullerbas_1_N = mkN "bullerbas" ; -- bullerbas..nn.1
  bullerblomster_1_N = mkN "bullerblomster" neutrum  ; -- bullerblomster..nn.1
  bullerdämpande_1_A = mkA "bullerdämpande" ; -- bullerdämpande..av.1
  bullerdämpning_1_N = mkN "bullerdämpning" ; -- bullerdämpning..nn.1
  bullerförminskande_1_A = mkA "bullerförminskande" ; -- bullerförminskande..av.1
  bullerkrav_1_N = mkN "bullerkrav" neutrum  ; -- bullerkrav..nn.1
  bullermatta_1_N = mkN "bullermatta" ; -- bullermatta..nn.1
  bullersam_1_A = mkA "bullersam" "bullersamt" "bullersamma" "bullersamma" "bullersammare" "bullersammast" "bullersammaste" ; -- bullersam..av.1
  bullersamhet_1_N = mkN "bullersamhet" ; -- bullersamhet..nn.1
  bullerskada_1_N = mkN "bullerskada" ; -- bullerskada..nn.1
  bullerskärm_1_N = mkN "bullerskärm" ; -- bullerskärm..nn.1
  bullersten_1_N = mkN "bullersten" "bullerstenen" "bullerstenar" "bullerstenarna" ; -- bullersten..nn.1
  bullerutsatt_1_A = mkA "bullerutsatt" ; -- bullerutsatt..av.1
  bullervall_1_N = mkN "bullervall" ; -- bullervall..nn.1
  bullervägg_1_N = mkN "bullervägg" ; -- bullervägg..nn.1
  bulletin_1_N = mkN "bulletin" "bulletiner" ; -- bulletin..nn.1
  bullig_1_A = mkA "bullig" ; -- bullig..av.1
  bullighet_1_N = mkN "bullighet" ; -- bullighet..nn.1
  bullra_1_V = mkV "bullrar" ; -- bullra..vb.1
  bullrande_1_N = mkN "bullrande" ; -- bullrande..nn.1
  bullrig_1_A = mkA "bullrig" ; -- bullrig..av.1
  bullrighet_1_N = mkN "bullrighet" ; -- bullrighet..nn.1
  bullshit_1_N = mkN "bullshit" ; -- bullshit..nn.1
  bulna_1_V = mkV "bulnar" ; -- bulna..vb.1
  bulnad_1_N = mkN "bulnad" "bulnader" ; -- bulnad..nn.1
  bulnande_1_N = mkN "bulnande" ; -- bulnande..nn.1
  bulsig_1_A = mkA "bulsig" ; -- bulsig..av.1
  bulsighet_1_N = mkN "bulsighet" ; -- bulsighet..nn.1
  bult_1_N = mkN "bult" ; -- bult..nn.1
  bulta_1_V = mkV "bultar" ; -- bulta..vb.1
  bultande_1_N = mkN "bultande" ; -- bultande..nn.1
  bulthuvud_1_N = mkN "bulthuvud" "bulthuvudet" "bulthuvud" "bulthuvudena" ; -- bulthuvud..nn.1
  bulthål_1_N = mkN "bulthål" neutrum  ; -- bulthål..nn.1
  bultning_1_N = mkN "bultning" ; -- bultning..nn.1
  bultpistol_1_N = mkN "bultpistol" "bultpistoler" ; -- bultpistol..nn.1
  bultsax_1_N = mkN "bultsax" ; -- bultsax..nn.1
  bultskalle_1_N = mkN "bultskalle" utrum  ; -- bultskalle..nn.1
  bulvan_1_N = mkN "bulvan" "bulvaner" ; -- bulvan..nn.1
  bulvanverksamhet_1_N = mkN "bulvanverksamhet" "bulvanverksamheter" ; -- bulvanverksamhet..nn.1
  bumerang_1_N = mkN "bumerang" "bumeranger" ; -- bumerang..nn.1
  bumling_1_N = mkN "bumling" ; -- bumling..nn.1
  bums_1_Adv = mkAdv "bums" ; -- bums..ab.1
  bunden_1_A = mkA "bunden" ; -- bunden..av.1
  bundenhet_1_N = mkN "bundenhet" ; -- bundenhet..nn.1
  bundis_1_A = mkA "bundis" ; -- bundis..av.1
  bundsförvant_1_N = mkN "bundsförvant" "bundsförvanter" ; -- bundsförvant..nn.1
  bundsförvantskap_1_N = mkN "bundsförvantskap" neutrum  ; -- bundsförvantskap..nn.1
  bungalow_1_N = mkN "bungalow" "bungalowen" "bungalows" "bungalowerna" ; -- bungalow..nn.1
  bunke_1_N = mkN "bunke" utrum  ; -- bunke..nn.1
  bunker_1_N = mkN "bunker" ; -- bunker..nn.1
  bunkra_1_V = mkV "bunkrar" ; -- bunkra..vb.1
  bunkrande_1_N = mkN "bunkrande" ; -- bunkrande..nn.1
  bunkring_1_N = mkN "bunkring" ; -- bunkring..nn.1
  bunkringsolja_1_N = mkN "bunkringsolja" ; -- bunkringsolja..nn.1
  bunkringsplats_1_N = mkN "bunkringsplats" "bunkringsplatser" ; -- bunkringsplats..nn.1
  bunkringsstation_1_N = mkN "bunkringsstation" ; -- bunkringsstation..nn.1
  bunkstål_1_N = mkN "bunkstål" neutrum  ; -- bunkstål..nn.1
  bunsenbrännare_1_N = mkN "bunsenbrännare" utrum  ; -- bunsenbrännare..nn.1
  bunt_1_N = mkN "bunt" ; -- bunt..nn.1
  bunta_1_V = mkV "buntar" ; -- bunta..vb.1
  buntande_1_N = mkN "buntande" ; -- buntande..nn.1
  buntband_1_N = mkN "buntband" neutrum  ; -- buntband..nn.1
  buntmakare_1_N = mkN "buntmakare" utrum  ; -- buntmakare..nn.1
  buntning_1_N = mkN "buntning" ; -- buntning..nn.1
  buntvis_1_Adv = mkAdv "buntvis" ; -- buntvis..ab.1
  bur_1_N = mkN "bur" ; -- bur..nn.1
  burbrev_1_N = mkN "burbrev" neutrum  ; -- burbrev..nn.1
  burdus_1_A = mkA "burdus" ; -- burdus..av.1
  burfågel_1_N = mkN "burfågel" ; -- burfågel..nn.1
  burgarbar_1_N = mkN "burgarbar" "burgarbarer" ; -- burgarbar..nn.1
  burgare_1_N = mkN "burgare" utrum  ; -- burgare..nn.1
  burgarrestaurang_1_N = mkN "burgarrestaurang" "burgarrestauranger" ; -- burgarrestaurang..nn.1
  burgarställe_1_N = mkN "burgarställe" ; -- burgarställe..nn.1
  burgen_1_A = mkA "burgen" ; -- burgen..av.1
  burgenhet_1_N = mkN "burgenhet" ; -- burgenhet..nn.1
  burgerbar_1_N = mkN "burgerbar" "burgerbarer" ; -- burgerbar..nn.1
  burgerrestaurang_1_N = mkN "burgerrestaurang" "burgerrestauranger" ; -- burgerrestaurang..nn.1
  burgerställe_1_N = mkN "burgerställe" ; -- burgerställe..nn.1
  burgund_1_N = mkN "burgund" "burgunder" ; -- burgund..nn.1
  burgunder_1_N = mkN "burgunder" "burgundern" "burgunder" "burgunderna" ; -- burgunder..nn.1
  burhöns_1_N = mkN "burhöns" neutrum  ; -- burhöns..nn.1
  burk_1_N = mkN "burk" ; -- burk..nn.1
  burka_1_N = mkN "burka" ; -- burka..nn.1
  burka_1_V = mkV "burkar" ; -- burka..vb.1
  burkaförbud_1_N = mkN "burkaförbud" neutrum  ; -- burkaförbud..nn.1
  burkande_1_N = mkN "burkande" ; -- burkande..nn.1
  burkhållare_1_N = mkN "burkhållare" utrum  ; -- burkhållare..nn.1
  burkinier_1_N = mkN "burkinier" "burkiniern" "burkinier" "burkinierna" ; -- burkinier..nn.1
  burkinsk_1_A = mkA "burkinsk" ; -- burkinsk..av.1
  burkinska_1_N = mkN "burkinska" ; -- burkinska..nn.1
  burkmat_1_N = mkN "burkmat" ; -- burkmat..nn.1
  burkslav_1_N = mkN "burkslav" ; -- burkslav..nn.1
  burköl_1_N = mkN "burköl" neutrum  ; -- burköl..nn.1
  burköppnare_1_N = mkN "burköppnare" utrum  ; -- burköppnare..nn.1
  burlesk_1_A = mkA "burlesk" ; -- burlesk..av.1
  burlesk_1_N = mkN "burlesk" "burlesker" ; -- burlesk..nn.1
  burleskeri_1_N = mkN "burleskeri" "burleskeriet" "burleskerier" "burleskerierna" ; -- burleskeri..nn.1
  burman_1_N = mkN "burman" "burmaner" ; -- burman..nn.1
  burmansk_1_A = mkA "burmansk" ; -- burmansk..av.1
  burmanska_1_N = mkN "burmanska" ; -- burmanska..nn.1
  burmanska_2_N = mkN "burmanska" ; -- burmanska..nn.2
  burmes_1_N = mkN "burmes" "burmeser" ; -- burmes..nn.1
  burmesisk_1_A = mkA "burmesisk" ; -- burmesisk..av.1
  burmesiska_1_N = mkN "burmesiska" ; -- burmesiska..nn.1
  burmesiska_2_N = mkN "burmesiska" ; -- burmesiska..nn.2
  burnus_1_N = mkN "burnus" ; -- burnus..nn.1
  burr_1_N = mkN "burr" neutrum  ; -- burr..nn.1
  burrig_1_A = mkA "burrig" ; -- burrig..av.1
  burrighet_1_N = mkN "burrighet" ; -- burrighet..nn.1
  burschikos_1_A = mkA "burschikos" ; -- burschikos..av.1
  burskap_1_N = mkN "burskap" neutrum  ; -- burskap..nn.1
  burspråk_1_N = mkN "burspråk" neutrum  ; -- burspråk..nn.1
  burspråksfönster_1_N = mkN "burspråksfönster" neutrum  ; -- burspråksfönster..nn.1
  burundier_1_N = mkN "burundier" "burundiern" "burundier" "burundierna" ; -- burundier..nn.1
  burundisk_1_A = mkA "burundisk" ; -- burundisk..av.1
  burundiska_1_N = mkN "burundiska" ; -- burundiska..nn.1
  bus_1_N = mkN "bus" neutrum  ; -- bus..nn.1
  busa_1_V = mkV "busar" ; -- busa..vb.1
  busande_1_N = mkN "busande" ; -- busande..nn.1
  buse_1_N = mkN "buse" utrum  ; -- buse..nn.1
  busenkel_1_A = mkA "busenkel" ; -- busenkel..av.1
  busfason_1_N = mkN "busfason" "busfasoner" ; -- busfason..nn.1
  busfrö_1_N = mkN "busfrö" "busfröet" "busfrön" "busfröna" ; -- busfrö..nn.1
  bush_1_N = mkN "bush" ; -- bush..nn.1
  bushman_1_N = mkN "bushman" "bushmannen" "bushmän" "bushmännen" ; -- bushman..nn.1
  busig_1_A = mkA "busig" ; -- busig..av.1
  busighet_1_N = mkN "busighet" ; -- busighet..nn.1
  business_1_N = mkN "business" ; -- business..nn.1
  buska_1_V = mkV "buskar" ; -- buska..vb.1
  buska_2_V = mkV "buskar" ; -- buska..vb.2
  buskablyg_1_A = mkA "buskablyg" ; -- buskablyg..av.1
  buskablyghet_1_N = mkN "buskablyghet" ; -- buskablyghet..nn.1
  buskage_1_N = mkN "buskage" "buskaget" "buskage" "buskagen" ; -- buskage..nn.1
  buskagitation_1_N = mkN "buskagitation" ; -- buskagitation..nn.1
  buskande_1_N = mkN "buskande" ; -- buskande..nn.1
  buskartad_1_A = mkA "buskartad" ; -- buskartad..av.1
  buskbevuxen_1_A = mkA "buskbevuxen" ; -- buskbevuxen..av.1
  buske_1_N = mkN "buske" utrum  ; -- buske..nn.1
  buskig_1_A = mkA "buskig" ; -- buskig..av.1
  buskighet_1_N = mkN "buskighet" ; -- buskighet..nn.1
  buskis_1_N = mkN "buskis" ; -- buskis..nn.1
  buskliknande_1_A = mkA "buskliknande" ; -- buskliknande..av.1
  buskskvätta_1_N = mkN "buskskvätta" ; -- buskskvätta..nn.1
  busksly_1_N = mkN "busksly" "buskslyt" "buskslyn" "buskslyna" ; -- busksly..nn.1
  busksnår_1_N = mkN "busksnår" neutrum  ; -- busksnår..nn.1
  buskteater_1_N = mkN "buskteater" ; -- buskteater..nn.1
  buskväxt_1_N = mkN "buskväxt" "buskväxter" ; -- buskväxt..nn.1
  buskörare_1_N = mkN "buskörare" utrum  ; -- buskörare..nn.1
  buskörning_1_N = mkN "buskörning" ; -- buskörning..nn.1
  busliv_1_N = mkN "busliv" neutrum  ; -- busliv..nn.1
  busringa_1_V = mkV "busringer" ; -- busringa..vb.1
  busringande_1_N = mkN "busringande" ; -- busringande..nn.1
  busringare_1_N = mkN "busringare" utrum  ; -- busringare..nn.1
  busringning_1_N = mkN "busringning" ; -- busringning..nn.1
  buss_1_A = mkA "buss" ; -- buss..av.1
  buss_1_N = mkN "buss" ; -- buss..nn.1
  bussa_1_V = mkV "bussar" ; -- bussa..vb.1
  bussande_1_N = mkN "bussande" ; -- bussande..nn.1
  bussankomst_1_N = mkN "bussankomst" "bussankomster" ; -- bussankomst..nn.1
  bussarong_1_N = mkN "bussarong" "bussaronger" ; -- bussarong..nn.1
  bussavgång_1_N = mkN "bussavgång" ; -- bussavgång..nn.1
  busschaufför_1_N = mkN "busschaufför" "busschaufförer" ; -- busschaufför..nn.1
  bussförare_1_N = mkN "bussförare" utrum  ; -- bussförare..nn.1
  bussförbindelse_1_N = mkN "bussförbindelse" "bussförbindelser" ; -- bussförbindelse..nn.1
  busshållplats_1_N = mkN "busshållplats" "busshållplatser" ; -- busshållplats..nn.1
  bussig_1_A = mkA "bussig" ; -- bussig..av.1
  bussighet_1_N = mkN "bussighet" ; -- bussighet..nn.1
  busskort_1_N = mkN "busskort" neutrum  ; -- busskort..nn.1
  busskrock_1_N = mkN "busskrock" ; -- busskrock..nn.1
  busskur_1_N = mkN "busskur" ; -- busskur..nn.1
  busslast_1_N = mkN "busslast" "busslaster" ; -- busslast..nn.1
  busslinje_1_N = mkN "busslinje" "busslinjer" ; -- busslinje..nn.1
  bussning_1_N = mkN "bussning" ; -- bussning..nn.1
  busspassagerare_1_N = mkN "busspassagerare" utrum  ; -- busspassagerare..nn.1
  bussresa_1_N = mkN "bussresa" ; -- bussresa..nn.1
  busstation_1_N = mkN "busstation" ; -- busstation..nn.1
  busstaxa_1_N = mkN "busstaxa" ; -- busstaxa..nn.1
  bussterminal_1_N = mkN "bussterminal" "bussterminaler" ; -- bussterminal..nn.1
  busstidtabell_1_N = mkN "busstidtabell" "busstidtabeller" ; -- busstidtabell..nn.1
  busstrafik_1_N = mkN "busstrafik" ; -- busstrafik..nn.1
  busstransport_1_N = mkN "busstransport" "busstransporter" ; -- busstransport..nn.1
  busstur_1_N = mkN "busstur" "bussturer" ; -- busstur..nn.1
  busunge_1_N = mkN "busunge" utrum  ; -- busunge..nn.1
  busvissla_1_V = mkV "busvisslar" ; -- busvissla..vb.1
  busvisslande_1_N = mkN "busvisslande" ; -- busvisslande..nn.1
  busvissling_1_N = mkN "busvissling" ; -- busvissling..nn.1
  busväder_1_N = mkN "busväder" neutrum  ; -- busväder..nn.1
  butadien_1_N = mkN "butadien" neutrum  ; -- butadien..nn.1
  butan_1_N = mkN "butan" "butaner" ; -- butan..nn.1
  butanol_1_N = mkN "butanol" ; -- butanol..nn.1
  butelj_1_N = mkN "butelj" "buteljer" ; -- butelj..nn.1
  buteljborste_1_N = mkN "buteljborste" utrum  ; -- buteljborste..nn.1
  buteljbotten_1_N = mkN "buteljbotten" ; -- buteljbotten..nn.1
  buteljera_1_V = mkV "buteljerar" ; -- buteljera..vb.1
  buteljerande_1_N = mkN "buteljerande" ; -- buteljerande..nn.1
  buteljerbar_1_A = mkA "buteljerbar" ; -- buteljerbar..av.1
  buteljerbarhet_1_N = mkN "buteljerbarhet" ; -- buteljerbarhet..nn.1
  buteljering_1_N = mkN "buteljering" ; -- buteljering..nn.1
  buteljglas_1_N = mkN "buteljglas" neutrum  ; -- buteljglas..nn.1
  buteljgrön_1_A = mkA "buteljgrön" ; -- buteljgrön..av.1
  buteljlack_1_N = mkN "buteljlack" neutrum  ; -- buteljlack..nn.1
  butik_1_N = mkN "butik" "butiker" ; -- butik..nn.1
  butiksanställd_1_A = mkA "butiksanställd" "butiksanställt" ; -- butiksanställd..av.1
  butiksbaka_1_V = mkV "butiksbakar" ; -- butiksbaka..vb.1
  butiksbakad_1_A = mkA "butiksbakad" ; -- butiksbakad..av.1
  butiksbiträde_1_N = mkN "butiksbiträde" ; -- butiksbiträde..nn.1
  butiksdörr_1_N = mkN "butiksdörr" ; -- butiksdörr..nn.1
  butiksfönster_1_N = mkN "butiksfönster" neutrum  ; -- butiksfönster..nn.1
  butiksinnehavare_1_N = mkN "butiksinnehavare" utrum  ; -- butiksinnehavare..nn.1
  butikskedja_1_N = mkN "butikskedja" ; -- butikskedja..nn.1
  butiksrån_1_N = mkN "butiksrån" neutrum  ; -- butiksrån..nn.1
  butiksstängningslag_1_N = mkN "butiksstängningslag" ; -- butiksstängningslag..nn.1
  butikstjuv_1_N = mkN "butikstjuv" ; -- butikstjuv..nn.1
  butiksägare_1_N = mkN "butiksägare" utrum  ; -- butiksägare..nn.1
  butler_1_N = mkN "butler" "butlern" "butlers" "butlersarna" ; -- butler..nn.1
  butter_1_A = mkA "butter" ; -- butter..av.1
  butterhet_1_N = mkN "butterhet" ; -- butterhet..nn.1
  butterkaka_1_N = mkN "butterkaka" ; -- butterkaka..nn.1
  butyl_1_N = mkN "butyl" "butyler" ; -- butyl..nn.1
  butylalkohol_1_N = mkN "butylalkohol" ; -- butylalkohol..nn.1
  buxbom_1_N = mkN "buxbom" ; -- buxbom..nn.1
  by_1_N = mkN "by" "byn" "byar" "byarna" ; -- by..nn.1
  byalag_1_N = mkN "byalag" neutrum  ; -- byalag..nn.1
  byamål_1_N = mkN "byamål" neutrum  ; -- byamål..nn.1
  bybo_1_N = mkN "bybo" "bybor" ; -- bybo..nn.1
  byffé_1_N = mkN "byffé" "byfféer" ; -- byffé..nn.1
  byfogde_1_N = mkN "byfogde" utrum  ; -- byfogde..nn.1
  byfåne_1_N = mkN "byfåne" utrum  ; -- byfåne..nn.1
  bygata_1_N = mkN "bygata" ; -- bygata..nn.1
  bygd_1_N = mkN "bygd" "bygder" ; -- bygd..nn.1
  bygdeborg_1_N = mkN "bygdeborg" ; -- bygdeborg..nn.1
  bygdegård_1_N = mkN "bygdegård" ; -- bygdegård..nn.1
  bygdemål_1_N = mkN "bygdemål" neutrum  ; -- bygdemål..nn.1
  bygdepatriotism_1_N = mkN "bygdepatriotism" ; -- bygdepatriotism..nn.1
  bygel_1_N = mkN "bygel" ; -- bygel..nn.1
  bygelhorn_1_N = mkN "bygelhorn" neutrum  ; -- bygelhorn..nn.1
  bygelhäst_1_N = mkN "bygelhäst" ; -- bygelhäst..nn.1
  bygellås_1_N = mkN "bygellås" neutrum  ; -- bygellås..nn.1
  bygelrem_1_N = mkN "bygelrem" "bygelremmen" "bygelremmar" "bygelremmarna" ; -- bygelrem..nn.1
  bygga_1_V = mkV "bygger" ; -- bygga..vb.1
  byggande_1_N = mkN "byggande" ; -- byggande..nn.1
  byggarbetare_1_N = mkN "byggarbetare" utrum  ; -- byggarbetare..nn.1
  byggarbetskran_1_N = mkN "byggarbetskran" ; -- byggarbetskran..nn.1
  byggarbetsplats_1_N = mkN "byggarbetsplats" "byggarbetsplatser" ; -- byggarbetsplats..nn.1
  byggare_1_N = mkN "byggare" utrum  ; -- byggare..nn.1
  byggbeslag_1_N = mkN "byggbeslag" neutrum  ; -- byggbeslag..nn.1
  byggcontainer_1_N = mkN "byggcontainer" ; -- byggcontainer..nn.1
  byggdamm_1_N = mkN "byggdamm" neutrum  ; -- byggdamm..nn.1
  byggdispens_1_N = mkN "byggdispens" "byggdispenser" ; -- byggdispens..nn.1
  bygge_1_N = mkN "bygge" ; -- bygge..nn.1
  byggelement_1_N = mkN "byggelement" neutrum  ; -- byggelement..nn.1
  byggenskap_1_N = mkN "byggenskap" ; -- byggenskap..nn.1
  byggfirma_1_N = mkN "byggfirma" ; -- byggfirma..nn.1
  byggflopp_1_N = mkN "byggflopp" ; -- byggflopp..nn.1
  byggföretag_1_N = mkN "byggföretag" neutrum  ; -- byggföretag..nn.1
  byggherre_1_N = mkN "byggherre" utrum  ; -- byggherre..nn.1
  byggjätte_1_N = mkN "byggjätte" utrum  ; -- byggjätte..nn.1
  byggkloss_1_N = mkN "byggkloss" ; -- byggkloss..nn.1
  byggkostnad_1_N = mkN "byggkostnad" "byggkostnader" ; -- byggkostnad..nn.1
  bygglag_1_N = mkN "bygglag" ; -- bygglag..nn.1
  bygglekplats_1_N = mkN "bygglekplats" "bygglekplatser" ; -- bygglekplats..nn.1
  bygglov_1_N = mkN "bygglov" neutrum  ; -- bygglov..nn.1
  bygglåda_1_N = mkN "bygglåda" ; -- bygglåda..nn.1
  byggmaterial_1_N = mkN "byggmaterial" neutrum  ; -- byggmaterial..nn.1
  byggmiss_1_N = mkN "byggmiss" ; -- byggmiss..nn.1
  byggmästardotter_1_N = mkN "byggmästardotter" "byggmästardottern" "byggmästardöttrar" "byggmästardöttrarna" ; -- byggmästardotter..nn.1
  byggmästare_1_N = mkN "byggmästare" utrum  ; -- byggmästare..nn.1
  byggnad_1_N = mkN "byggnad" "byggnader" ; -- byggnad..nn.1
  byggnadsarbetare_1_N = mkN "byggnadsarbetare" utrum  ; -- byggnadsarbetare..nn.1
  byggnadsbråte_1_N = mkN "byggnadsbråte" ; -- byggnadsbråte..nn.1
  byggnadsfirma_1_N = mkN "byggnadsfirma" ; -- byggnadsfirma..nn.1
  byggnadsföretag_1_N = mkN "byggnadsföretag" neutrum  ; -- byggnadsföretag..nn.1
  byggnadsindustri_1_N = mkN "byggnadsindustri" "byggnadsindustrier" ; -- byggnadsindustri..nn.1
  byggnadskomplex_1_N = mkN "byggnadskomplex" neutrum  ; -- byggnadskomplex..nn.1
  byggnadskonst_1_N = mkN "byggnadskonst" ; -- byggnadskonst..nn.1
  byggnadskonstruktion_1_N = mkN "byggnadskonstruktion" ; -- byggnadskonstruktion..nn.1
  byggnadskontor_1_N = mkN "byggnadskontor" neutrum  ; -- byggnadskontor..nn.1
  byggnadskredit_1_N = mkN "byggnadskredit" "byggnadskrediter" ; -- byggnadskredit..nn.1
  byggnadskreditiv_1_N = mkN "byggnadskreditiv" neutrum  ; -- byggnadskreditiv..nn.1
  byggnadslov_1_N = mkN "byggnadslov" neutrum  ; -- byggnadslov..nn.1
  byggnadslån_1_N = mkN "byggnadslån" neutrum  ; -- byggnadslån..nn.1
  byggnadsmaterial_1_N = mkN "byggnadsmaterial" neutrum  ; -- byggnadsmaterial..nn.1
  byggnadsminne_1_N = mkN "byggnadsminne" ; -- byggnadsminne..nn.1
  byggnadsmässig_1_A = mkA "byggnadsmässig" ; -- byggnadsmässig..av.1
  byggnadsnämnd_1_N = mkN "byggnadsnämnd" "byggnadsnämnder" ; -- byggnadsnämnd..nn.1
  byggnadsplan_1_N = mkN "byggnadsplan" "byggnadsplaner" ; -- byggnadsplan..nn.1
  byggnadsplats_1_N = mkN "byggnadsplats" "byggnadsplatser" ; -- byggnadsplats..nn.1
  byggnadssnickare_1_N = mkN "byggnadssnickare" utrum  ; -- byggnadssnickare..nn.1
  byggnadssockel_1_N = mkN "byggnadssockel" ; -- byggnadssockel..nn.1
  byggnadssten_1_N = mkN "byggnadssten" "byggnadsstenen" "byggnadsstenar" "byggnadsstenarna" ; -- byggnadssten..nn.1
  byggnadsstil_1_N = mkN "byggnadsstil" ; -- byggnadsstil..nn.1
  byggnadsstomme_1_N = mkN "byggnadsstomme" utrum  ; -- byggnadsstomme..nn.1
  byggnadsstyrelse_1_N = mkN "byggnadsstyrelse" "byggnadsstyrelser" ; -- byggnadsstyrelse..nn.1
  byggnadsställning_1_N = mkN "byggnadsställning" ; -- byggnadsställning..nn.1
  byggnadssätt_1_N = mkN "byggnadssätt" neutrum  ; -- byggnadssätt..nn.1
  byggnadsteknik_1_N = mkN "byggnadsteknik" "byggnadstekniker" ; -- byggnadsteknik..nn.1
  byggnadsteknisk_1_A = mkA "byggnadsteknisk" ; -- byggnadsteknisk..av.1
  byggnadstillstånd_1_N = mkN "byggnadstillstånd" neutrum  ; -- byggnadstillstånd..nn.1
  byggnadstimmer_1_N = mkN "byggnadstimmer" neutrum  ; -- byggnadstimmer..nn.1
  byggnadsverk_1_N = mkN "byggnadsverk" neutrum  ; -- byggnadsverk..nn.1
  byggnadsvirke_1_N = mkN "byggnadsvirke" ; -- byggnadsvirke..nn.1
  byggnation_1_N = mkN "byggnation" ; -- byggnation..nn.1
  byggning_1_N = mkN "byggning" ; -- byggning..nn.1
  byggnorm_1_N = mkN "byggnorm" "byggnormer" ; -- byggnorm..nn.1
  byggpass_1_N = mkN "byggpass" neutrum  ; -- byggpass..nn.1
  byggplan_1_N = mkN "byggplan" "byggplaner" ; -- byggplan..nn.1
  byggprojekt_1_N = mkN "byggprojekt" neutrum  ; -- byggprojekt..nn.1
  byggsats_1_N = mkN "byggsats" "byggsatser" ; -- byggsats..nn.1
  byggsektor_1_N = mkN "byggsektor" "byggsektorer" ; -- byggsektor..nn.1
  byggstart_1_N = mkN "byggstart" "byggstarter" ; -- byggstart..nn.1
  byggsten_1_N = mkN "byggsten" "byggstenen" "byggstenar" "byggstenarna" ; -- byggsten..nn.1
  byggstopp_1_N = mkN "byggstopp" neutrum  ; -- byggstopp..nn.1
  byggställning_1_N = mkN "byggställning" ; -- byggställning..nn.1
  byggtid_1_N = mkN "byggtid" "byggtider" ; -- byggtid..nn.1
  byggtork_1_N = mkN "byggtork" ; -- byggtork..nn.1
  byggvara_1_N = mkN "byggvara" ; -- byggvara..nn.1
  byggvaruhus_1_N = mkN "byggvaruhus" neutrum  ; -- byggvaruhus..nn.1
  byggvarukedja_1_N = mkN "byggvarukedja" ; -- byggvarukedja..nn.1
  byhus_1_N = mkN "byhus" neutrum  ; -- byhus..nn.1
  byig_1_A = mkA "byig" ; -- byig..av.1
  byk_1_N = mkN "byk" ; -- byk..nn.1
  byka_1_V = mkV "byker" ; -- byka..vb.1
  bykande_1_N = mkN "bykande" ; -- bykande..nn.1
  byke_1_N = mkN "byke" ; -- byke..nn.1
  bykgryta_1_N = mkN "bykgryta" ; -- bykgryta..nn.1
  byling_1_N = mkN "byling" ; -- byling..nn.1
  bylsig_1_A = mkA "bylsig" ; -- bylsig..av.1
  bylsighet_1_N = mkN "bylsighet" ; -- bylsighet..nn.1
  bylte_1_N = mkN "bylte" ; -- bylte..nn.1
  bymoln_1_N = mkN "bymoln" neutrum  ; -- bymoln..nn.1
  bymoské_1_N = mkN "bymoské" "bymoskéer" ; -- bymoské..nn.1
  byområde_1_N = mkN "byområde" ; -- byområde..nn.1
  byordning_1_N = mkN "byordning" ; -- byordning..nn.1
  byracka_1_N = mkN "byracka" ; -- byracka..nn.1
  byrett_1_N = mkN "byrett" "byretter" ; -- byrett..nn.1
  byrå_1_N = mkN "byrå" ; -- byrå..nn.1
  byrå_2_N = mkN "byrå" "byråer" ; -- byrå..nn.2
  byråassistent_1_N = mkN "byråassistent" "byråassistenter" ; -- byråassistent..nn.1
  byråchef_1_N = mkN "byråchef" "byråchefer" ; -- byråchef..nn.1
  byrådirektör_1_N = mkN "byrådirektör" "byrådirektörer" ; -- byrådirektör..nn.1
  byråkrat_1_N = mkN "byråkrat" "byråkrater" ; -- byråkrat..nn.1
  byråkrati_1_N = mkN "byråkrati" "byråkratier" ; -- byråkrati..nn.1
  byråkratisera_1_V = mkV "byråkratiserar" ; -- byråkratisera..vb.1
  byråkratiserande_1_N = mkN "byråkratiserande" ; -- byråkratiserande..nn.1
  byråkratiserbar_1_A = mkA "byråkratiserbar" ; -- byråkratiserbar..av.1
  byråkratiserbarhet_1_N = mkN "byråkratiserbarhet" ; -- byråkratiserbarhet..nn.1
  byråkratisering_1_N = mkN "byråkratisering" ; -- byråkratisering..nn.1
  byråkratisk_1_A = mkA "byråkratisk" ; -- byråkratisk..av.1
  byråkratism_1_N = mkN "byråkratism" "byråkratismer" ; -- byråkratism..nn.1
  byrålåda_1_N = mkN "byrålåda" ; -- byrålåda..nn.1
  byråsekreterare_1_N = mkN "byråsekreterare" utrum  ; -- byråsekreterare..nn.1
  bysamfällighet_1_N = mkN "bysamfällighet" "bysamfälligheter" ; -- bysamfällighet..nn.1
  bysantin_1_N = mkN "bysantin" "bysantiner" ; -- bysantin..nn.1
  bysantinism_1_N = mkN "bysantinism" "bysantinismer" ; -- bysantinism..nn.1
  bysantinsk_1_A = mkA "bysantinsk" ; -- bysantinsk..av.1
  byskola_1_N = mkN "byskola" ; -- byskola..nn.1
  bysnille_1_N = mkN "bysnille" ; -- bysnille..nn.1
  byssja_1_N = mkN "byssja" ; -- byssja..nn.1
  byst_1_N = mkN "byst" "byster" ; -- byst..nn.1
  bystdrottning_1_N = mkN "bystdrottning" ; -- bystdrottning..nn.1
  bysthållare_1_N = mkN "bysthållare" utrum  ; -- bysthållare..nn.1
  bystmått_1_N = mkN "bystmått" neutrum  ; -- bystmått..nn.1
  bystämma_1_N = mkN "bystämma" ; -- bystämma..nn.1
  bysätta_1_V = mkV "bysätta" "bysätter" "bysätt" "bysatte" "bysatt" "bysatt" ; -- bysätta..vb.1
  bysättande_1_N = mkN "bysättande" ; -- bysättande..nn.1
  bysättning_1_N = mkN "bysättning" ; -- bysättning..nn.1
  byta_1_V = mkV "byter" ; -- byta..vb.1
  bytande_1_N = mkN "bytande" ; -- bytande..nn.1
  byte_1_N = mkN "byte" ; -- byte..nn.1
  byte_2_N = mkN "byte" "byten" "byte" "bytena" ; -- byte..nn.2
  bytesaffär_1_N = mkN "bytesaffär" "bytesaffärer" ; -- bytesaffär..nn.1
  bytesartikel_1_N = mkN "bytesartikel" ; -- bytesartikel..nn.1
  bytesbalans_1_N = mkN "bytesbalans" ; -- bytesbalans..nn.1
  bytesbalansunderskott_1_N = mkN "bytesbalansunderskott" neutrum  ; -- bytesbalansunderskott..nn.1
  bytesbalansöverskott_1_N = mkN "bytesbalansöverskott" neutrum  ; -- bytesbalansöverskott..nn.1
  bytesbrev_1_N = mkN "bytesbrev" neutrum  ; -- bytesbrev..nn.1
  bytesdjur_1_N = mkN "bytesdjur" neutrum  ; -- bytesdjur..nn.1
  byteshandel_1_N = mkN "byteshandel" ; -- byteshandel..nn.1
  byteshushållning_1_N = mkN "byteshushållning" ; -- byteshushållning..nn.1
  byteslägenhet_1_N = mkN "byteslägenhet" "byteslägenheter" ; -- byteslägenhet..nn.1
  bytesmedel_1_N = mkN "bytesmedel" neutrum  ; -- bytesmedel..nn.1
  bytesobjekt_1_N = mkN "bytesobjekt" neutrum  ; -- bytesobjekt..nn.1
  bytesvara_1_N = mkN "bytesvara" ; -- bytesvara..nn.1
  bytesvärde_1_N = mkN "bytesvärde" ; -- bytesvärde..nn.1
  byting_1_N = mkN "byting" ; -- byting..nn.1
  bytta_1_N = mkN "bytta" ; -- bytta..nn.1
  byväg_1_N = mkN "byväg" ; -- byväg..nn.1
  byx_1_N = mkN "byx" ; -- byx..nn.1
  byxa_1_N = mkN "byxa" ; -- byxa..nn.1
  byxbak_1_N = mkN "byxbak" ; -- byxbak..nn.1
  byxben_1_N = mkN "byxben" neutrum  ; -- byxben..nn.1
  byxdress_1_N = mkN "byxdress" ; -- byxdress..nn.1
  byxdräkt_1_N = mkN "byxdräkt" "byxdräkter" ; -- byxdräkt..nn.1
  byxficka_1_N = mkN "byxficka" ; -- byxficka..nn.1
  byxholk_1_N = mkN "byxholk" ; -- byxholk..nn.1
  byxhälla_1_N = mkN "byxhälla" ; -- byxhälla..nn.1
  byxis_1_A = mkA "byxis" ; -- byxis..av.1
  byxkjol_1_N = mkN "byxkjol" ; -- byxkjol..nn.1
  byxklämma_1_N = mkN "byxklämma" ; -- byxklämma..nn.1
  byxklåda_1_N = mkN "byxklåda" ; -- byxklåda..nn.1
  byxknä_1_N = mkN "byxknä" "byxknät" "byxknän" "byxknäna" ; -- byxknä..nn.1
  byxlös_1_A = mkA "byxlös" ; -- byxlös..av.1
  byxlöshet_1_N = mkN "byxlöshet" ; -- byxlöshet..nn.1
  byxslag_1_N = mkN "byxslag" neutrum  ; -- byxslag..nn.1
  byxångest_1_N = mkN "byxångest" ; -- byxångest..nn.1
  byäldste_1_N = mkN "byäldste" utrum  ; -- byäldste..nn.1
  bäbis_1_N = mkN "bäbis" ; -- bäbis..nn.1
  bäck_1_N = mkN "bäck" ; -- bäck..nn.1
  bäckahäst_1_N = mkN "bäckahäst" ; -- bäckahäst..nn.1
  bäcken_1_N = mkN "bäcken" neutrum  ; -- bäcken..nn.1
  bäckenben_1_N = mkN "bäckenben" neutrum  ; -- bäckenben..nn.1
  bäckenförträngning_1_N = mkN "bäckenförträngning" ; -- bäckenförträngning..nn.1
  bäckenhåla_1_N = mkN "bäckenhåla" ; -- bäckenhåla..nn.1
  bäckenuppluckring_1_N = mkN "bäckenuppluckring" ; -- bäckenuppluckring..nn.1
  bäckforell_1_N = mkN "bäckforell" "bäckforeller" ; -- bäckforell..nn.1
  bäckmynning_1_N = mkN "bäckmynning" ; -- bäckmynning..nn.1
  bäckravin_1_N = mkN "bäckravin" "bäckraviner" ; -- bäckravin..nn.1
  bäckröding_1_N = mkN "bäckröding" ; -- bäckröding..nn.1
  bäckvatten_1_N = mkN "bäckvatten" "bäckvattnet" "bäckvatten" "bäckvattnen" ; -- bäckvatten..nn.1
  bäcköring_1_N = mkN "bäcköring" ; -- bäcköring..nn.1
  bädd_1_N = mkN "bädd" ; -- bädd..nn.1
  bädda_1_V = mkV "bäddar" ; -- bädda..vb.1
  bädda_2_V = mkV "bäddar" ; -- bädda..vb.2
  bäddande_1_N = mkN "bäddande" ; -- bäddande..nn.1
  bäddjacka_1_N = mkN "bäddjacka" ; -- bäddjacka..nn.1
  bäddning_1_N = mkN "bäddning" ; -- bäddning..nn.1
  bäddsoffa_1_N = mkN "bäddsoffa" ; -- bäddsoffa..nn.1
  bäddutrustning_1_N = mkN "bäddutrustning" ; -- bäddutrustning..nn.1
  bägare_1_N = mkN "bägare" utrum  ; -- bägare..nn.1
  bägarkorall_1_N = mkN "bägarkorall" "bägarkoraller" ; -- bägarkorall..nn.1
  bägarmanet_1_N = mkN "bägarmanet" "bägarmaneter" ; -- bägarmanet..nn.1
  bägarsvamp_1_N = mkN "bägarsvamp" ; -- bägarsvamp..nn.1
  bälg_1_N = mkN "bälg" ; -- bälg..nn.1
  bälga_1_V = mkV "bälgar" ; -- bälga..vb.1
  bälgande_1_N = mkN "bälgande" ; -- bälgande..nn.1
  bälgformad_1_A = mkA "bälgformad" ; -- bälgformad..av.1
  bälgkamera_1_N = mkN "bälgkamera" ; -- bälgkamera..nn.1
  bälgliknande_1_A = mkA "bälgliknande" ; -- bälgliknande..av.1
  bälgvante_1_N = mkN "bälgvante" utrum  ; -- bälgvante..nn.1
  bälta_1_N = mkN "bälta" ; -- bälta..nn.1
  bälta_1_V = mkV "bältar" ; -- bälta..vb.1
  bältande_1_N = mkN "bältande" ; -- bältande..nn.1
  bältdjur_1_N = mkN "bältdjur" neutrum  ; -- bältdjur..nn.1
  bälte_1_N = mkN "bälte" ; -- bälte..nn.1
  bältesläggning_1_N = mkN "bältesläggning" ; -- bältesläggning..nn.1
  bältespännare_1_N = mkN "bältespännare" utrum  ; -- bältespännare..nn.1
  bältestvång_1_N = mkN "bältestvång" neutrum  ; -- bältestvång..nn.1
  bältning_1_N = mkN "bältning" ; -- bältning..nn.1
  bältros_1_N = mkN "bältros" ; -- bältros..nn.1
  bända_1_V = mkV "bänder" ; -- bända..vb.1
  bändande_1_N = mkN "bändande" ; -- bändande..nn.1
  bändelband_1_N = mkN "bändelband" neutrum  ; -- bändelband..nn.1
  bändjärn_1_N = mkN "bändjärn" neutrum  ; -- bändjärn..nn.1
  bändning_1_N = mkN "bändning" ; -- bändning..nn.1
  bändsel_1_N = mkN "bändsel" ; -- bändsel..nn.1
  bändsla_1_V = mkV "bändslar" ; -- bändsla..vb.1
  bändslande_1_N = mkN "bändslande" ; -- bändslande..nn.1
  bäng_1_A = mkA "bäng" ; -- bäng..av.1
  bängel_1_N = mkN "bängel" ; -- bängel..nn.1
  bänghet_1_N = mkN "bänghet" ; -- bänghet..nn.1
  bänk_1_N = mkN "bänk" ; -- bänk..nn.1
  bänka_1_V = mkV "bänkar" ; -- bänka..vb.1
  bänka_2_V = mkV "bänkar" ; -- bänka..vb.2
  bänkad_1_A = mkA "bänkad" ; -- bänkad..av.1
  bänkgranne_1_N = mkN "bänkgranne" utrum  ; -- bänkgranne..nn.1
  bänkkamrat_1_N = mkN "bänkkamrat" "bänkkamrater" ; -- bänkkamrat..nn.1
  bänknummer_1_N = mkN "bänknummer" neutrum  ; -- bänknummer..nn.1
  bänkplats_1_N = mkN "bänkplats" "bänkplatser" ; -- bänkplats..nn.1
  bänkpress_1_N = mkN "bänkpress" ; -- bänkpress..nn.1
  bänkrad_1_N = mkN "bänkrad" "bänkrader" ; -- bänkrad..nn.1
  bänkskåp_1_N = mkN "bänkskåp" neutrum  ; -- bänkskåp..nn.1
  bänkslipmaskin_1_N = mkN "bänkslipmaskin" "bänkslipmaskiner" ; -- bänkslipmaskin..nn.1
  bänkspis_1_N = mkN "bänkspis" ; -- bänkspis..nn.1
  bänsel_1_N = mkN "bänsel" ; -- bänsel..nn.1
  bänsla_1_V = mkV "bänslar" ; -- bänsla..vb.1
  bänslande_1_N = mkN "bänslande" ; -- bänslande..nn.1
  bär_1_N = mkN "bär" neutrum  ; -- bär..nn.1
  bära_1_V = mkV "bära" "bar" "burit" ; -- bära..vb.1
  bärande_1_A = mkA "bärande" ; -- bärande..av.1
  bärande_1_N = mkN "bärande" ; -- bärande..nn.1
  bärare_1_N = mkN "bärare" utrum  ; -- bärare..nn.1
  bärarlag_1_N = mkN "bärarlag" neutrum  ; -- bärarlag..nn.1
  bärbar_1_A = mkA "bärbar" ; -- bärbar..av.1
  bärbarhet_1_N = mkN "bärbarhet" ; -- bärbarhet..nn.1
  bärbjälke_1_N = mkN "bärbjälke" utrum  ; -- bärbjälke..nn.1
  bärbuske_1_N = mkN "bärbuske" utrum  ; -- bärbuske..nn.1
  bärfis_1_N = mkN "bärfis" ; -- bärfis..nn.1
  bärfrekvens_1_N = mkN "bärfrekvens" "bärfrekvenser" ; -- bärfrekvens..nn.1
  bärga_1_V = mkV "bärgar" ; -- bärga..vb.1
  bärgande_1_N = mkN "bärgande" ; -- bärgande..nn.1
  bärgare_1_N = mkN "bärgare" utrum  ; -- bärgare..nn.1
  bärgarlön_1_N = mkN "bärgarlön" "bärgarlöner" ; -- bärgarlön..nn.1
  bärgning_1_N = mkN "bärgning" ; -- bärgning..nn.1
  bärgningsbil_1_N = mkN "bärgningsbil" ; -- bärgningsbil..nn.1
  bärgningsföretag_1_N = mkN "bärgningsföretag" neutrum  ; -- bärgningsföretag..nn.1
  bärgningsledare_1_N = mkN "bärgningsledare" utrum  ; -- bärgningsledare..nn.1
  bärgningspersonal_1_N = mkN "bärgningspersonal" ; -- bärgningspersonal..nn.1
  bärgningsväder_1_N = mkN "bärgningsväder" neutrum  ; -- bärgningsväder..nn.1
  bärhandtag_1_N = mkN "bärhandtag" neutrum  ; -- bärhandtag..nn.1
  bärhjälp_1_N = mkN "bärhjälp" ; -- bärhjälp..nn.1
  bärig_1_A = mkA "bärig" ; -- bärig..av.1
  bärighet_1_N = mkN "bärighet" ; -- bärighet..nn.1
  bäring_1_N = mkN "bäring" ; -- bäring..nn.1
  bärkasse_1_N = mkN "bärkasse" utrum  ; -- bärkasse..nn.1
  bärkotte_1_N = mkN "bärkotte" utrum  ; -- bärkotte..nn.1
  bärkraft_1_N = mkN "bärkraft" ; -- bärkraft..nn.1
  bärkraftig_1_A = mkA "bärkraftig" ; -- bärkraftig..av.1
  bärkraftighet_1_N = mkN "bärkraftighet" ; -- bärkraftighet..nn.1
  bärlager_1_N = mkN "bärlager" neutrum  ; -- bärlager..nn.1
  bärm_1_N = mkN "bärm" "bärmer" ; -- bärm..nn.1
  bärmark_1_N = mkN "bärmark" "bärmarker" ; -- bärmark..nn.1
  bärnstensfärgad_1_A = mkA "bärnstensfärgad" ; -- bärnstensfärgad..av.1
  bärnstenssmycke_1_N = mkN "bärnstenssmycke" ; -- bärnstenssmycke..nn.1
  bärnstenssyra_1_N = mkN "bärnstenssyra" ; -- bärnstenssyra..nn.1
  bärnäs_1_N = mkN "bärnäs" "bärnäser" ; -- bärnäs..nn.1
  bärnässås_1_N = mkN "bärnässås" "bärnässåser" ; -- bärnässås..nn.1
  bärpelare_1_N = mkN "bärpelare" utrum  ; -- bärpelare..nn.1
  bärplan_1_N = mkN "bärplan" neutrum  ; -- bärplan..nn.1
  bärplansbåt_1_N = mkN "bärplansbåt" ; -- bärplansbåt..nn.1
  bärplockare_1_N = mkN "bärplockare" utrum  ; -- bärplockare..nn.1
  bärplockning_1_N = mkN "bärplockning" ; -- bärplockning..nn.1
  bärpåse_1_N = mkN "bärpåse" utrum  ; -- bärpåse..nn.1
  bärraket_1_N = mkN "bärraket" "bärraketer" ; -- bärraket..nn.1
  bärrem_1_N = mkN "bärrem" "bärremmen" "bärremmar" "bärremmarna" ; -- bärrem..nn.1
  bärs_1_N = mkN "bärs" ; -- bärs..nn.1
  bärs_2_N = mkN "bärs" ; -- bärs..nn.2
  bärsa_1_N = mkN "bärsa" ; -- bärsa..nn.1
  bärsa_2_N = mkN "bärsa" ; -- bärsa..nn.2
  bärsa_1_V = mkV "bärsar" ; -- bärsa..vb.1
  bärsande_1_N = mkN "bärsande" ; -- bärsande..nn.1
  bärsele_1_N = mkN "bärsele" utrum  ; -- bärsele..nn.1
  bärstol_1_N = mkN "bärstol" ; -- bärstol..nn.1
  bärsärk_1_N = mkN "bärsärk" ; -- bärsärk..nn.1
  bärsärkagång_1_N = mkN "bärsärkagång" ; -- bärsärkagång..nn.1
  bärsärkaraseri_1_N = mkN "bärsärkaraseri" neutrum  ; -- bärsärkaraseri..nn.1
  bärvidd_1_N = mkN "bärvidd" "bärvidder" ; -- bärvidd..nn.1
  bärvin_1_N = mkN "bärvin" "bärvinet" "bärviner" "bärvinerna" ; -- bärvin..nn.1
  bärvåg_1_N = mkN "bärvåg" "bärvågor" ; -- bärvåg..nn.1
  bäst_före_dag_1_N = mkN "bäst-före-dag" ; -- bäst-före-dag..nn.1
  bäst_före_datum_1_N = mkN "bäst-före-datum" ; -- bäst-före-datum..nn.1
  bästeman_1_N = mkN "bästeman" "bästemannen" "bästemän" "bästemännen" ; -- bästeman..nn.1
  bästföre_dag_1_N = mkN "bästföre-dag" ; -- bästföre-dag..nn.1
  bästföre_datum_1_N = mkN "bästföre-datum" ; -- bästföre-datum..nn.1
  bästföredag_1_N = mkN "bästföredag" ; -- bästföredag..nn.1
  bästföredatum_1_N = mkN "bästföredatum" ; -- bästföredatum..nn.1
  bästis_1_N = mkN "bästis" ; -- bästis..nn.1
  bästsäljande_1_A = mkA "bästsäljande" ; -- bästsäljande..av.1
  bästsäljare_1_N = mkN "bästsäljare" utrum  ; -- bästsäljare..nn.1
  bästsäljarism_1_N = mkN "bästsäljarism" ; -- bästsäljarism..nn.1
  bästsäljarlista_1_N = mkN "bästsäljarlista" ; -- bästsäljarlista..nn.1
  bättra_1_V = mkV "bättrar" ; -- bättra..vb.1
  bättrande_1_N = mkN "bättrande" ; -- bättrande..nn.1
  bättring_1_N = mkN "bättring" ; -- bättring..nn.1
  bäva_1_V = mkV "bävar" ; -- bäva..vb.1
  bävande_1_N = mkN "bävande" ; -- bävande..nn.1
  bäver_1_N = mkN "bäver" ; -- bäver..nn.1
  bävergäll_1_N = mkN "bävergäll" ; -- bävergäll..nn.1
  bävernylon_1_N = mkN "bävernylon" ; -- bävernylon..nn.1
  bävernylonoverall_1_N = mkN "bävernylonoverall" "bävernylonoveraller" ; -- bävernylonoverall..nn.1
  bäverpäls_1_N = mkN "bäverpäls" ; -- bäverpäls..nn.1
  bäverråtta_1_N = mkN "bäverråtta" ; -- bäverråtta..nn.1
  bävning_1_N = mkN "bävning" ; -- bävning..nn.1
  båda_1_N = mkN "båda" ; -- båda..nn.1
  båda_1_V = mkV "bådar" ; -- båda..vb.1
  bådande_1_N = mkN "bådande" ; -- bådande..nn.1
  både_1_N = mkN "både" utrum  ; -- både..nn.1
  båg_1_N = mkN "båg" neutrum  ; -- båg..nn.1
  båga_1_V = mkV "bågar" ; -- båga..vb.1
  bågande_1_N = mkN "bågande" ; -- bågande..nn.1
  bågbro_1_N = mkN "bågbro" ; -- bågbro..nn.1
  båge_1_N = mkN "båge" utrum  ; -- båge..nn.1
  bågfil_1_N = mkN "bågfil" ; -- bågfil..nn.1
  bågform_1_N = mkN "bågform" "bågformer" ; -- bågform..nn.1
  bågformad_1_A = mkA "bågformad" ; -- bågformad..av.1
  bågformig_1_A = mkA "bågformig" ; -- bågformig..av.1
  bågformighet_1_N = mkN "bågformighet" ; -- bågformighet..nn.1
  bågfris_1_N = mkN "bågfris" "bågfriser" ; -- bågfris..nn.1
  bågfält_1_N = mkN "bågfält" neutrum  ; -- bågfält..nn.1
  bågfönster_1_N = mkN "bågfönster" neutrum  ; -- bågfönster..nn.1
  båggång_1_N = mkN "båggång" ; -- båggång..nn.1
  bågig_1_A = mkA "bågig" ; -- bågig..av.1
  båglampa_1_N = mkN "båglampa" ; -- båglampa..nn.1
  båglinje_1_N = mkN "båglinje" "båglinjer" ; -- båglinje..nn.1
  bågljus_1_N = mkN "bågljus" neutrum  ; -- bågljus..nn.1
  bågminut_1_N = mkN "bågminut" "bågminuter" ; -- bågminut..nn.1
  bågna_1_V = mkV "bågnar" ; -- bågna..vb.1
  bågnande_1_N = mkN "bågnande" ; -- bågnande..nn.1
  bågsekund_1_N = mkN "bågsekund" "bågsekunder" ; -- bågsekund..nn.1
  bågskytt_1_N = mkN "bågskytt" ; -- bågskytt..nn.1
  bågskytte_1_N = mkN "bågskytte" ; -- bågskytte..nn.1
  bågskyttefält_1_N = mkN "bågskyttefält" neutrum  ; -- bågskyttefält..nn.1
  bågsträng_1_N = mkN "bågsträng" ; -- bågsträng..nn.1
  bågsvetsning_1_N = mkN "bågsvetsning" ; -- bågsvetsning..nn.1
  bågsåg_1_N = mkN "bågsåg" ; -- bågsåg..nn.1
  bågvalv_1_N = mkN "bågvalv" neutrum  ; -- bågvalv..nn.1
  båk_1_N = mkN "båk" ; -- båk..nn.1
  bål_1_N = mkN "bål" ; -- bål..nn.1
  bål_2_N = mkN "bål" neutrum  ; -- bål..nn.2
  båld_1_A = mkA "båld" "bålt" ; -- båld..av.1
  båldhet_1_N = mkN "båldhet" ; -- båldhet..nn.1
  bålgeting_1_N = mkN "bålgeting" ; -- bålgeting..nn.1
  bålrullning_1_N = mkN "bålrullning" ; -- bålrullning..nn.1
  bålrörelse_1_N = mkN "bålrörelse" "bålrörelser" ; -- bålrörelse..nn.1
  bålverk_1_N = mkN "bålverk" neutrum  ; -- bålverk..nn.1
  bålväxt_1_N = mkN "bålväxt" "bålväxter" ; -- bålväxt..nn.1
  bångstyrig_1_A = mkA "bångstyrig" ; -- bångstyrig..av.1
  bångstyrighet_1_N = mkN "bångstyrighet" ; -- bångstyrighet..nn.1
  bår_1_N = mkN "bår" ; -- bår..nn.1
  bårbärare_1_N = mkN "bårbärare" utrum  ; -- bårbärare..nn.1
  bårbärning_1_N = mkN "bårbärning" ; -- bårbärning..nn.1
  bård_1_N = mkN "bård" "bårder" ; -- bård..nn.1
  bårdmönster_1_N = mkN "bårdmönster" neutrum  ; -- bårdmönster..nn.1
  bårhus_1_N = mkN "bårhus" neutrum  ; -- bårhus..nn.1
  bårlärka_1_N = mkN "bårlärka" ; -- bårlärka..nn.1
  bås_1_N = mkN "bås" neutrum  ; -- bås..nn.1
  båt_1_N = mkN "båt" ; -- båt..nn.1
  båta_1_V = mkV "båtar" ; -- båta..vb.1
  båtande_1_N = mkN "båtande" ; -- båtande..nn.1
  båtankomst_1_N = mkN "båtankomst" "båtankomster" ; -- båtankomst..nn.1
  båtavgång_1_N = mkN "båtavgång" ; -- båtavgång..nn.1
  båtben_1_N = mkN "båtben" neutrum  ; -- båtben..nn.1
  båtbotten_1_N = mkN "båtbotten" ; -- båtbotten..nn.1
  båtbrygga_1_N = mkN "båtbrygga" ; -- båtbrygga..nn.1
  båtbyggare_1_N = mkN "båtbyggare" utrum  ; -- båtbyggare..nn.1
  båtbygge_1_N = mkN "båtbygge" ; -- båtbygge..nn.1
  båtbyggeri_1_N = mkN "båtbyggeri" "båtbyggeriet" "båtbyggerier" "båtbyggerierna" ; -- båtbyggeri..nn.1
  båtdäck_1_N = mkN "båtdäck" neutrum  ; -- båtdäck..nn.1
  båtfart_1_N = mkN "båtfart" ; -- båtfart..nn.1
  båtformig_1_A = mkA "båtformig" ; -- båtformig..av.1
  båtfärd_1_N = mkN "båtfärd" "båtfärder" ; -- båtfärd..nn.1
  båtgrav_1_N = mkN "båtgrav" ; -- båtgrav..nn.1
  båthall_1_N = mkN "båthall" ; -- båthall..nn.1
  båthus_1_N = mkN "båthus" neutrum  ; -- båthus..nn.1
  båtklubb_1_N = mkN "båtklubb" ; -- båtklubb..nn.1
  båtliknande_1_A = mkA "båtliknande" ; -- båtliknande..av.1
  båtlägenhet_1_N = mkN "båtlägenhet" "båtlägenheter" ; -- båtlägenhet..nn.1
  båtmotor_1_N = mkN "båtmotor" "båtmotorer" ; -- båtmotor..nn.1
  båtmässa_1_N = mkN "båtmässa" ; -- båtmässa..nn.1
  båtmössa_1_N = mkN "båtmössa" ; -- båtmössa..nn.1
  båtnad_1_N = mkN "båtnad" "båtnader" ; -- båtnad..nn.1
  båtpendla_1_V = mkV "båtpendlar" ; -- båtpendla..vb.1
  båtpendlande_1_N = mkN "båtpendlande" ; -- båtpendlande..nn.1
  båtpendling_1_N = mkN "båtpendling" ; -- båtpendling..nn.1
  båtplats_1_N = mkN "båtplats" "båtplatser" ; -- båtplats..nn.1
  båtresa_1_N = mkN "båtresa" ; -- båtresa..nn.1
  båtshake_1_N = mkN "båtshake" utrum  ; -- båtshake..nn.1
  båtskjul_1_N = mkN "båtskjul" neutrum  ; -- båtskjul..nn.1
  båtskrå_1_N = mkN "båtskrå" "båtskrået" "båtskrån" "båtskråna" ; -- båtskrå..nn.1
  båtsman_1_N = mkN "båtsman" "båtsmannen" "båtsmän" "båtsmännen" ; -- båtsman..nn.1
  båtsmansstol_1_N = mkN "båtsmansstol" ; -- båtsmansstol..nn.1
  båtspant_1_N = mkN "båtspant" neutrum  ; -- båtspant..nn.1
  båtterminal_1_N = mkN "båtterminal" "båtterminaler" ; -- båtterminal..nn.1
  båttidtabell_1_N = mkN "båttidtabell" "båttidtabeller" ; -- båttidtabell..nn.1
  båttrafik_1_N = mkN "båttrafik" ; -- båttrafik..nn.1
  båttransport_1_N = mkN "båttransport" "båttransporter" ; -- båttransport..nn.1
  båttur_1_N = mkN "båttur" "båtturer" ; -- båttur..nn.1
  båttävling_1_N = mkN "båttävling" ; -- båttävling..nn.1
  båtutflykt_1_N = mkN "båtutflykt" "båtutflykter" ; -- båtutflykt..nn.1
  båtvagga_1_N = mkN "båtvagga" ; -- båtvagga..nn.1
  båtvård_1_N = mkN "båtvård" ; -- båtvård..nn.1
  båtvårdsmedel_1_N = mkN "båtvårdsmedel" neutrum  ; -- båtvårdsmedel..nn.1
  båtyxa_1_N = mkN "båtyxa" ; -- båtyxa..nn.1
  béarnaise_1_N = mkN "béarnaise" "béarnaiser" ; -- béarnaise..nn.1
  béarnaisesås_1_N = mkN "béarnaisesås" "béarnaisesåser" ; -- béarnaisesås..nn.1
  böckling_1_N = mkN "böckling" ; -- böckling..nn.1
  bödel_1_N = mkN "bödel" ; -- bödel..nn.1
  bödelsdräng_1_N = mkN "bödelsdräng" ; -- bödelsdräng..nn.1
  bödelssvärd_1_N = mkN "bödelssvärd" neutrum  ; -- bödelssvärd..nn.1
  bödelsyxa_1_N = mkN "bödelsyxa" ; -- bödelsyxa..nn.1
  bög_1_N = mkN "bög" ; -- bög..nn.1
  bögdöd_1_N = mkN "bögdöd" ; -- bögdöd..nn.1
  bögporr_1_N = mkN "bögporr" ; -- bögporr..nn.1
  böhmare_1_N = mkN "böhmare" utrum  ; -- böhmare..nn.1
  böhmisk_1_A = mkA "böhmisk" ; -- böhmisk..av.1
  böj_1_N = mkN "böj" ; -- böj..nn.1
  böja_1_V = mkV "böja" "böjde" "böjt" ; -- böja..vb.1
  böjande_1_N = mkN "böjande" ; -- böjande..nn.1
  böjare_1_N = mkN "böjare" utrum  ; -- böjare..nn.1
  böjarmuskel_1_N = mkN "böjarmuskel" "böjarmuskeln" "böjarmuskler" "böjarmusklerna" ; -- böjarmuskel..nn.1
  böjbar_1_A = mkA "böjbar" ; -- böjbar..av.1
  böjbarhet_1_N = mkN "böjbarhet" ; -- böjbarhet..nn.1
  böjd_1_A = mkA "böjd" "böjt" ; -- böjd..av.1
  böjdhet_1_N = mkN "böjdhet" ; -- böjdhet..nn.1
  böjelse_1_N = mkN "böjelse" "böjelser" ; -- böjelse..nn.1
  böjhållfasthet_1_N = mkN "böjhållfasthet" "böjhållfastheter" ; -- böjhållfasthet..nn.1
  böjlig_1_A = mkA "böjlig" ; -- böjlig..av.1
  böjlighet_1_N = mkN "böjlighet" ; -- böjlighet..nn.1
  böjmuskel_1_N = mkN "böjmuskel" "böjmuskeln" "böjmuskler" "böjmusklerna" ; -- böjmuskel..nn.1
  böjning_1_N = mkN "böjning" ; -- böjning..nn.1
  böjningsexempel_1_N = mkN "böjningsexempel" neutrum  ; -- böjningsexempel..nn.1
  böjningsform_1_N = mkN "böjningsform" "böjningsformer" ; -- böjningsform..nn.1
  böjningsmönster_1_N = mkN "böjningsmönster" neutrum  ; -- böjningsmönster..nn.1
  böjningssätt_1_N = mkN "böjningssätt" neutrum  ; -- böjningssätt..nn.1
  böjningsändelse_1_N = mkN "böjningsändelse" "böjningsändelser" ; -- böjningsändelse..nn.1
  böjprov_1_N = mkN "böjprov" neutrum  ; -- böjprov..nn.1
  böjträ_1_N = mkN "böjträ" neutrum  ; -- böjträ..nn.1
  bök_1_N = mkN "bök" neutrum  ; -- bök..nn.1
  böka_1_V = mkV "bökar" ; -- böka..vb.1
  bökande_1_N = mkN "bökande" ; -- bökande..nn.1
  bökig_1_A = mkA "bökig" ; -- bökig..av.1
  bökning_1_N = mkN "bökning" ; -- bökning..nn.1
  böl_1_N = mkN "böl" neutrum  ; -- böl..nn.1
  böla_1_V = mkV "bölar" ; -- böla..vb.1
  bölande_1_N = mkN "bölande" ; -- bölande..nn.1
  böld_1_N = mkN "böld" "bölder" ; -- böld..nn.1
  böldpest_1_N = mkN "böldpest" ; -- böldpest..nn.1
  bölja_1_N = mkN "bölja" ; -- bölja..nn.1
  bölja_1_V = mkV "böljar" ; -- bölja..vb.1
  böljande_1_N = mkN "böljande" ; -- böljande..nn.1
  böljegång_1_N = mkN "böljegång" ; -- böljegång..nn.1
  böljeslag_1_N = mkN "böljeslag" neutrum  ; -- böljeslag..nn.1
  böljeslagsmärke_1_N = mkN "böljeslagsmärke" ; -- böljeslagsmärke..nn.1
  bölning_1_N = mkN "bölning" ; -- bölning..nn.1
  bön_1_N = mkN "bön" "böner" ; -- bön..nn.1
  böna_1_N = mkN "böna" ; -- böna..nn.1
  böna_1_V = mkV "bönar" ; -- böna..vb.1
  bönande_1_N = mkN "bönande" ; -- bönande..nn.1
  bönbok_1_N = mkN "bönbok" "bönböcker" ; -- bönbok..nn.1
  böndag_1_N = mkN "böndag" ; -- böndag..nn.1
  böneanrop_1_N = mkN "böneanrop" neutrum  ; -- böneanrop..nn.1
  bönegudstjänst_1_N = mkN "bönegudstjänst" "bönegudstjänster" ; -- bönegudstjänst..nn.1
  bönehus_1_N = mkN "bönehus" neutrum  ; -- bönehus..nn.1
  böneman_1_N = mkN "böneman" "bönemannen" "bönemän" "bönemännen" ; -- böneman..nn.1
  bönematta_1_N = mkN "bönematta" ; -- bönematta..nn.1
  bönemöte_1_N = mkN "bönemöte" ; -- bönemöte..nn.1
  böneramp_1_N = mkN "böneramp" "böneramper" ; -- böneramp..nn.1
  bönerum_1_N = mkN "bönerum" "bönerummet" "bönerum" "bönerummen" ; -- bönerum..nn.1
  bönesal_1_N = mkN "bönesal" ; -- bönesal..nn.1
  böneskrift_1_N = mkN "böneskrift" "böneskrifter" ; -- böneskrift..nn.1
  bönestund_1_N = mkN "bönestund" "bönestunder" ; -- bönestund..nn.1
  böneutropare_1_N = mkN "böneutropare" utrum  ; -- böneutropare..nn.1
  bönfalla_1_V = mkV "bönfalla" "bönföll" "bönfallit" ; -- bönfalla..vb.1
  bönfallande_1_N = mkN "bönfallande" ; -- bönfallande..nn.1
  bönformig_1_A = mkA "bönformig" ; -- bönformig..av.1
  böngrodd_1_N = mkN "böngrodd" ; -- böngrodd..nn.1
  bönhas_1_N = mkN "bönhas" ; -- bönhas..nn.1
  bönhus_1_N = mkN "bönhus" neutrum  ; -- bönhus..nn.1
  bönhöra_1_V = mkV "bönhöra" "bönhörde" "bönhört" ; -- bönhöra..vb.1
  bönhörande_1_N = mkN "bönhörande" ; -- bönhörande..nn.1
  bönhörelse_1_N = mkN "bönhörelse" "bönhörelser" ; -- bönhörelse..nn.1
  bönkaffe_1_N = mkN "bönkaffe" ; -- bönkaffe..nn.1
  bönlig_1_A = mkA "bönlig" ; -- bönlig..av.1
  bönpall_1_N = mkN "bönpall" ; -- bönpall..nn.1
  bönskida_1_N = mkN "bönskida" ; -- bönskida..nn.1
  bönväxt_1_N = mkN "bönväxt" "bönväxter" ; -- bönväxt..nn.1
  böra_1_V = mkV "böra" "borde" "bort" ; -- böra..vb.1
  börande_1_N = mkN "börande" ; -- börande..nn.1
  börd_1_N = mkN "börd" ; -- börd..nn.1
  börda_1_N = mkN "börda" ; -- börda..nn.1
  bördig_1_A = mkA "bördig" ; -- bördig..av.1
  bördig_2_A = mkA "bördig" ; -- bördig..av.2
  bördighet_1_N = mkN "bördighet" ; -- bördighet..nn.1
  bördsadel_1_N = mkN "bördsadel" ; -- bördsadel..nn.1
  bördsaristokrati_1_N = mkN "bördsaristokrati" "bördsaristokratier" ; -- bördsaristokrati..nn.1
  bördshögfärd_1_N = mkN "bördshögfärd" ; -- bördshögfärd..nn.1
  bördsrätt_1_N = mkN "bördsrätt" ; -- bördsrätt..nn.1
  bördsstolt_1_A = mkA "bördsstolt" "bördsstolt" ; -- bördsstolt..av.1
  bördsstolthet_1_N = mkN "bördsstolthet" ; -- bördsstolthet..nn.1
  börja_1_V = mkV "börjar" ; -- börja..vb.1
  börja_2_V = mkV "börjar" ; -- börja..vb.2
  börjande_1_N = mkN "börjande" ; -- börjande..nn.1
  börs_1_N = mkN "börs" ; -- börs..nn.1
  börs_2_N = mkN "börs" "börser" ; -- börs..nn.2
  börsanalys_1_N = mkN "börsanalys" "börsanalyser" ; -- börsanalys..nn.1
  börsanalytiker_1_N = mkN "börsanalytiker" "börsanalytikern" "börsanalytiker" "börsanalytikerna" ; -- börsanalytiker..nn.1
  börsbolag_1_N = mkN "börsbolag" neutrum  ; -- börsbolag..nn.1
  börsjobbare_1_N = mkN "börsjobbare" utrum  ; -- börsjobbare..nn.1
  börskaos_1_N = mkN "börskaos" neutrum  ; -- börskaos..nn.1
  börskrasch_1_N = mkN "börskrasch" "börskrascher" ; -- börskrasch..nn.1
  börskurs_1_N = mkN "börskurs" "börskurser" ; -- börskurs..nn.1
  börsmäklare_1_N = mkN "börsmäklare" utrum  ; -- börsmäklare..nn.1
  börsmässig_1_A = mkA "börsmässig" ; -- börsmässig..av.1
  börsnotera_1_V = mkV "börsnoterar" ; -- börsnotera..vb.1
  börsnoterande_1_N = mkN "börsnoterande" ; -- börsnoterande..nn.1
  börsnoterbar_1_A = mkA "börsnoterbar" ; -- börsnoterbar..av.1
  börsnoterbarhet_1_N = mkN "börsnoterbarhet" ; -- börsnoterbarhet..nn.1
  börsnotering_1_N = mkN "börsnotering" ; -- börsnotering..nn.1
  börsoro_1_N = mkN "börsoro" ; -- börsoro..nn.1
  börsras_1_N = mkN "börsras" neutrum  ; -- börsras..nn.1
  börssal_1_N = mkN "börssal" ; -- börssal..nn.1
  börsspekulant_1_N = mkN "börsspekulant" "börsspekulanter" ; -- börsspekulant..nn.1
  börsspekulation_1_N = mkN "börsspekulation" ; -- börsspekulation..nn.1
  börsstyrelse_1_N = mkN "börsstyrelse" "börsstyrelser" ; -- börsstyrelse..nn.1
  börstelegraf_1_N = mkN "börstelegraf" "börstelegrafer" ; -- börstelegraf..nn.1
  börsuppgång_1_N = mkN "börsuppgång" ; -- börsuppgång..nn.1
  börsutveckling_1_N = mkN "börsutveckling" ; -- börsutveckling..nn.1
  börsyra_1_N = mkN "börsyra" ; -- börsyra..nn.1
  börting_1_N = mkN "börting" ; -- börting..nn.1
  bössa_1_N = mkN "bössa" ; -- bössa..nn.1
  bösshåll_1_N = mkN "bösshåll" neutrum  ; -- bösshåll..nn.1
  bössinsamling_1_N = mkN "bössinsamling" ; -- bössinsamling..nn.1
  bösta_1_V = mkV "böstar" ; -- bösta..vb.1
  böstande_1_N = mkN "böstande" ; -- böstande..nn.1
  böta_1_V = mkV "bötar" ; -- böta..vb.1
  bötande_1_N = mkN "bötande" ; -- bötande..nn.1
  bötesbelopp_1_N = mkN "bötesbelopp" neutrum  ; -- bötesbelopp..nn.1
  bötesstraff_1_N = mkN "bötesstraff" neutrum  ; -- bötesstraff..nn.1
  bötessumma_1_N = mkN "bötessumma" ; -- bötessumma..nn.1
  bötfälla_1_V = mkV "bötfäller" ; -- bötfälla..vb.1
  bötfällande_1_N = mkN "bötfällande" ; -- bötfällande..nn.1
  bövel_1_N = mkN "bövel" ; -- bövel..nn.1
  cab_1_N = mkN "cab" ; -- cab..nn.1
  cabb_1_N = mkN "cabb" ; -- cabb..nn.1
  cabotage_1_N = mkN "cabotage" ; -- cabotage..nn.1
  cabriolet_1_N = mkN "cabriolet" "cabrioleter" ; -- cabriolet..nn.1
  caddie_1_N = mkN "caddie" "caddier" ; -- caddie..nn.1
  cafe_1_N = mkN "cafe" "cafeet" "cafeer" "cafeerna" ; -- cafe..nn.1
  cafeteria_1_N = mkN "cafeteria" ; -- cafeteria..nn.1
  café_1_N = mkN "café" "caféet" "caféer" "caféerna" ; -- café..nn.1
  cafébord_1_N = mkN "cafébord" neutrum  ; -- cafébord..nn.1
  caldera_1_N = mkN "caldera" ; -- caldera..nn.1
  californium_1_N = mkN "californium" neutrum  ; -- californium..nn.1
  callcenter_1_N = mkN "callcenter" neutrum  ; -- callcenter..nn.1
  callgirl_1_N = mkN "callgirl" "callgirlen" "callgirls" "callgirlsarna" ; -- callgirl..nn.1
  calmettevaccinering_1_N = mkN "calmettevaccinering" ; -- calmettevaccinering..nn.1
  calvados_1_N = mkN "calvados" "calvadoser" ; -- calvados..nn.1
  calypso_1_N = mkN "calypso" ; -- calypso..nn.1
  calzone_1_N = mkN "calzone" utrum  ; -- calzone..nn.1
  camembert_1_N = mkN "camembert" ; -- camembert..nn.1
  camorra_1_N = mkN "camorra" ; -- camorra..nn.1
  camouflage_1_N = mkN "camouflage" "camouflaget" "camouflage" "camouflagen" ; -- camouflage..nn.1
  camouflera_1_V = mkV "camouflerar" ; -- camouflera..vb.1
  camouflerande_1_N = mkN "camouflerande" ; -- camouflerande..nn.1
  camouflerbar_1_A = mkA "camouflerbar" ; -- camouflerbar..av.1
  camouflerbarhet_1_N = mkN "camouflerbarhet" ; -- camouflerbarhet..nn.1
  camouflering_1_N = mkN "camouflering" ; -- camouflering..nn.1
  camp_1_A = mkA "camp" "camp" ; -- camp..av.1
  campa_1_V = mkV "campar" ; -- campa..vb.1
  campande_1_N = mkN "campande" ; -- campande..nn.1
  campare_1_N = mkN "campare" utrum  ; -- campare..nn.1
  camphet_1_N = mkN "camphet" ; -- camphet..nn.1
  camping_1_N = mkN "camping" ; -- camping..nn.1
  campingkök_1_N = mkN "campingkök" neutrum  ; -- campingkök..nn.1
  campinglampa_1_N = mkN "campinglampa" ; -- campinglampa..nn.1
  campingplats_1_N = mkN "campingplats" "campingplatser" ; -- campingplats..nn.1
  campingstuga_1_N = mkN "campingstuga" ; -- campingstuga..nn.1
  campus_1_N = mkN "campus" neutrum  ; -- campus..nn.1
  canasta_1_N = mkN "canasta" ; -- canasta..nn.1
  cancan_1_N = mkN "cancan" ; -- cancan..nn.1
  cancer_1_N = mkN "cancer" ; -- cancer..nn.1
  cancerbehandling_1_N = mkN "cancerbehandling" ; -- cancerbehandling..nn.1
  cancerbekämpning_1_N = mkN "cancerbekämpning" ; -- cancerbekämpning..nn.1
  cancerfall_1_N = mkN "cancerfall" neutrum  ; -- cancerfall..nn.1
  cancerfara_1_N = mkN "cancerfara" ; -- cancerfara..nn.1
  cancerform_1_N = mkN "cancerform" "cancerformer" ; -- cancerform..nn.1
  cancerforskare_1_N = mkN "cancerforskare" utrum  ; -- cancerforskare..nn.1
  cancerforskning_1_N = mkN "cancerforskning" ; -- cancerforskning..nn.1
  cancerframkallande_1_A = mkA "cancerframkallande" ; -- cancerframkallande..av.1
  cancerogen_1_A = mkA "cancerogen" "cancerogent" ; -- cancerogen..av.1
  cancerogen_1_N = mkN "cancerogen" "cancerogener" ; -- cancerogen..nn.1
  cancerrisk_1_N = mkN "cancerrisk" "cancerrisker" ; -- cancerrisk..nn.1
  cancersjuk_1_A = mkA "cancersjuk" ; -- cancersjuk..av.1
  cancerspridning_1_N = mkN "cancerspridning" ; -- cancerspridning..nn.1
  cancersvulst_1_N = mkN "cancersvulst" "cancersvulster" ; -- cancersvulst..nn.1
  cancertumör_1_N = mkN "cancertumör" "cancertumörer" ; -- cancertumör..nn.1
  canceruppföljning_1_N = mkN "canceruppföljning" ; -- canceruppföljning..nn.1
  candela_1_N = mkN "candela" "candelan" "candela" "candelana" ; -- candela..nn.1
  cannabis_1_N = mkN "cannabis" ; -- cannabis..nn.1
  cannabisodling_1_N = mkN "cannabisodling" ; -- cannabisodling..nn.1
  cannabisplanta_1_N = mkN "cannabisplanta" ; -- cannabisplanta..nn.1
  canossavandring_1_N = mkN "canossavandring" ; -- canossavandring..nn.1
  cantilena_1_N = mkN "cantilena" ; -- cantilena..nn.1
  cape_1_N = mkN "cape" "caper" ; -- cape..nn.1
  cappuccino_1_N = mkN "cappuccino" "cappuccinon" "cappuccino" "cappuccinona" ; -- cappuccino..nn.1
  cappuccinokopp_1_N = mkN "cappuccinokopp" ; -- cappuccinokopp..nn.1
  carambole_1_N = mkN "carambole" utrum  ; -- carambole..nn.1
  carcinogen_1_A = mkA "carcinogen" "carcinogent" ; -- carcinogen..av.1
  carcinogen_1_N = mkN "carcinogen" "carcinogener" ; -- carcinogen..nn.1
  cardigan_1_N = mkN "cardigan" "cardiganen" "cardigans" "cardigansarna" ; -- cardigan..nn.1
  carpa_1_V = mkV "carpar" ; -- carpa..vb.1
  cartesiansk_1_A = mkA "cartesiansk" ; -- cartesiansk..av.1
  casanova_1_N = mkN "casanova" ; -- casanova..nn.1
  cash_1_N = mkN "cash" neutrum  ; -- cash..nn.1
  cashew_1_N = mkN "cashew" "cashewn" "cashews" "cashewsen" ; -- cashew..nn.1
  cashewnöt_1_N = mkN "cashewnöt" "cashewnötter" ; -- cashewnöt..nn.1
  casino_1_N = mkN "casino" "casinot" "casinon" "casinona" ; -- casino..nn.1
  casting_1_N = mkN "casting" ; -- casting..nn.1
  catch_as_catch_can_1_N = mkN "catch-as-catch-can" ; -- catch-as-catch-can..nn.1
  catera_1_V = mkV "caterar" ; -- catera..vb.1
  caterande_1_N = mkN "caterande" ; -- caterande..nn.1
  catering_1_N = mkN "catering" ; -- catering..nn.1
  cateringbransch_1_N = mkN "cateringbransch" ; -- cateringbransch..nn.1
  caterpillar_1_N = mkN "caterpillar" "caterpillarn" "caterpillrar" "caterpillrarna" ; -- caterpillar..nn.1
  catgut_1_N = mkN "catgut" ; -- catgut..nn.1
  catwalk_1_N = mkN "catwalk" "catwalker" ; -- catwalk..nn.1
  catwalka_1_V = mkV "catwalkar" ; -- catwalka..vb.1
  catwalkande_1_N = mkN "catwalkande" ; -- catwalkande..nn.1
  cavatina_1_N = mkN "cavatina" ; -- cavatina..nn.1
  cd_rom_1_N = mkN "cd-rom" "cd-rommen" "cd-rom" "cd-rommen" ; -- cd-rom..nn.1
  cd_spelare_1_N = mkN "cd-spelare" utrum  ; -- cd-spelare..nn.1
  ceder_1_N = mkN "ceder" ; -- ceder..nn.1
  cedera_1_V = mkV "cederar" ; -- cedera..vb.1
  cederande_1_N = mkN "cederande" ; -- cederande..nn.1
  cederbar_1_A = mkA "cederbar" ; -- cederbar..av.1
  cederbarhet_1_N = mkN "cederbarhet" ; -- cederbarhet..nn.1
  cedering_1_N = mkN "cedering" ; -- cedering..nn.1
  cederskog_1_N = mkN "cederskog" ; -- cederskog..nn.1
  cedilj_1_N = mkN "cedilj" "cediljer" ; -- cedilj..nn.1
  cediljtecken_1_N = mkN "cediljtecken" "cediljtecknet" "cediljtecken" "cediljtecknen" ; -- cediljtecken..nn.1
  cedrat_1_N = mkN "cedrat" neutrum  ; -- cedrat..nn.1
  cedroolja_1_N = mkN "cedroolja" ; -- cedroolja..nn.1
  celeber_1_A = mkA "celeber" ; -- celeber..av.1
  celebrera_1_V = mkV "celebrerar" ; -- celebrera..vb.1
  celebrerande_1_N = mkN "celebrerande" ; -- celebrerande..nn.1
  celebrerbar_1_A = mkA "celebrerbar" ; -- celebrerbar..av.1
  celebrerbarhet_1_N = mkN "celebrerbarhet" ; -- celebrerbarhet..nn.1
  celebrering_1_N = mkN "celebrering" ; -- celebrering..nn.1
  celebritet_1_N = mkN "celebritet" "celebriteter" ; -- celebritet..nn.1
  celebritetsjournalistik_1_N = mkN "celebritetsjournalistik" ; -- celebritetsjournalistik..nn.1
  celest_1_A = mkA "celest" "celest" ; -- celest..av.1
  celesta_1_N = mkN "celesta" ; -- celesta..nn.1
  celibat_1_N = mkN "celibat" neutrum  ; -- celibat..nn.1
  celibatliv_1_N = mkN "celibatliv" neutrum  ; -- celibatliv..nn.1
  celibatlöfte_1_N = mkN "celibatlöfte" ; -- celibatlöfte..nn.1
  cell_1_N = mkN "cell" "celler" ; -- cell..nn.1
  cella_1_N = mkN "cella" ; -- cella..nn.1
  cellandning_1_N = mkN "cellandning" ; -- cellandning..nn.1
  cellbildning_1_N = mkN "cellbildning" ; -- cellbildning..nn.1
  cellbiologi_1_N = mkN "cellbiologi" ; -- cellbiologi..nn.1
  celldelning_1_N = mkN "celldelning" ; -- celldelning..nn.1
  cellfängelse_1_N = mkN "cellfängelse" "cellfängelset" "cellfängelser" "cellfängelserna" ; -- cellfängelse..nn.1
  cellgift_1_N = mkN "cellgift" "cellgiftet" "cellgifter" "cellgifterna" ; -- cellgift..nn.1
  cellgiftsbehandling_1_N = mkN "cellgiftsbehandling" ; -- cellgiftsbehandling..nn.1
  cellgranne_1_N = mkN "cellgranne" utrum  ; -- cellgranne..nn.1
  cellini_1_N = mkN "cellini" ; -- cellini..nn.1
  cellist_1_N = mkN "cellist" "cellister" ; -- cellist..nn.1
  cellkamrat_1_N = mkN "cellkamrat" "cellkamrater" ; -- cellkamrat..nn.1
  cellkärna_1_N = mkN "cellkärna" ; -- cellkärna..nn.1
  cellmembran_1_N = mkN "cellmembran" neutrum  ; -- cellmembran..nn.1
  cello_1_N = mkN "cello" "cellon" "celli" "cellorna" ; -- cello..nn.1
  cellodling_1_N = mkN "cellodling" ; -- cellodling..nn.1
  cellofan_1_N = mkN "cellofan" ; -- cellofan..nn.1
  cellplasma_1_N = mkN "cellplasma" "cellplasman" "cellplasmer" "cellplasmerna" ; -- cellplasma..nn.1
  cellprov_1_N = mkN "cellprov" neutrum  ; -- cellprov..nn.1
  cellsjok_1_N = mkN "cellsjok" neutrum  ; -- cellsjok..nn.1
  cellskikt_1_N = mkN "cellskikt" neutrum  ; -- cellskikt..nn.1
  cellskräck_1_N = mkN "cellskräck" ; -- cellskräck..nn.1
  cellspänning_1_N = mkN "cellspänning" ; -- cellspänning..nn.1
  cellstoff_1_N = mkN "cellstoff" ; -- cellstoff..nn.1
  cellstraff_1_N = mkN "cellstraff" neutrum  ; -- cellstraff..nn.1
  cellstruktur_1_N = mkN "cellstruktur" "cellstrukturer" ; -- cellstruktur..nn.1
  cellsubstans_1_N = mkN "cellsubstans" "cellsubstanser" ; -- cellsubstans..nn.1
  cellterapi_1_N = mkN "cellterapi" ; -- cellterapi..nn.1
  celltråd_1_N = mkN "celltråd" ; -- celltråd..nn.1
  celltyp_1_N = mkN "celltyp" "celltyper" ; -- celltyp..nn.1
  cellulas_1_N = mkN "cellulas" ; -- cellulas..nn.1
  celluloid_1_N = mkN "celluloid" ; -- celluloid..nn.1
  cellulosa_1_N = mkN "cellulosa" ; -- cellulosa..nn.1
  cellulosaetanol_1_N = mkN "cellulosaetanol" "cellulosaetanoler" ; -- cellulosaetanol..nn.1
  cellulosafabrik_1_N = mkN "cellulosafabrik" "cellulosafabriker" ; -- cellulosafabrik..nn.1
  cellulosaförtunning_1_N = mkN "cellulosaförtunning" ; -- cellulosaförtunning..nn.1
  cellulosaindustri_1_N = mkN "cellulosaindustri" "cellulosaindustrier" ; -- cellulosaindustri..nn.1
  cellulosalack_1_N = mkN "cellulosalack" neutrum  ; -- cellulosalack..nn.1
  cellulosamolekyl_1_N = mkN "cellulosamolekyl" "cellulosamolekyler" ; -- cellulosamolekyl..nn.1
  cellulosanitrat_1_N = mkN "cellulosanitrat" neutrum  ; -- cellulosanitrat..nn.1
  cellulosaplast_1_N = mkN "cellulosaplast" "cellulosaplaster" ; -- cellulosaplast..nn.1
  cellulosavadd_1_N = mkN "cellulosavadd" ; -- cellulosavadd..nn.1
  cellulär_1_A = mkA "cellulär" ; -- cellulär..av.1
  cellvägg_1_N = mkN "cellvägg" ; -- cellvägg..nn.1
  cellvävnad_1_N = mkN "cellvävnad" "cellvävnader" ; -- cellvävnad..nn.1
  celsiusgrad_1_N = mkN "celsiusgrad" "celsiusgrader" ; -- celsiusgrad..nn.1
  celsiusskala_1_N = mkN "celsiusskala" ; -- celsiusskala..nn.1
  celsiustermometer_1_N = mkN "celsiustermometer" ; -- celsiustermometer..nn.1
  celt_1_N = mkN "celt" "celter" ; -- celt..nn.1
  cembalist_1_N = mkN "cembalist" "cembalister" ; -- cembalist..nn.1
  cembalo_1_N = mkN "cembalo" "cembalon" "cembali" "cembalorna" ; -- cembalo..nn.1
  cembalobyggare_1_N = mkN "cembalobyggare" utrum  ; -- cembalobyggare..nn.1
  cembalobygge_1_N = mkN "cembalobygge" ; -- cembalobygge..nn.1
  cembalotillverkning_1_N = mkN "cembalotillverkning" ; -- cembalotillverkning..nn.1
  cement_1_N = mkN "cement" ; -- cement..nn.1
  cementa_1_V = mkV "cementar" ; -- cementa..vb.1
  cementande_1_N = mkN "cementande" ; -- cementande..nn.1
  cementblandare_1_N = mkN "cementblandare" utrum  ; -- cementblandare..nn.1
  cementera_1_V = mkV "cementerar" ; -- cementera..vb.1
  cementerande_1_N = mkN "cementerande" ; -- cementerande..nn.1
  cementerbar_1_A = mkA "cementerbar" ; -- cementerbar..av.1
  cementerbarhet_1_N = mkN "cementerbarhet" ; -- cementerbarhet..nn.1
  cementering_1_N = mkN "cementering" ; -- cementering..nn.1
  cementfärg_1_N = mkN "cementfärg" "cementfärger" ; -- cementfärg..nn.1
  cementrör_1_N = mkN "cementrör" neutrum  ; -- cementrör..nn.1
  cenakel_1_N = mkN "cenakel" neutrum  ; -- cenakel..nn.1
  cendré_1_A = mkA "cendré" ; -- cendré..av.1
  cendréfärgad_1_A = mkA "cendréfärgad" ; -- cendréfärgad..av.1
  censor_1_N = mkN "censor" "censorer" ; -- censor..nn.1
  censur_1_N = mkN "censur" ; -- censur..nn.1
  censurera_1_V = mkV "censurerar" ; -- censurera..vb.1
  censurerande_1_N = mkN "censurerande" ; -- censurerande..nn.1
  censurerbar_1_A = mkA "censurerbar" ; -- censurerbar..av.1
  censurerbarhet_1_N = mkN "censurerbarhet" ; -- censurerbarhet..nn.1
  censurering_1_N = mkN "censurering" ; -- censurering..nn.1
  censurfrihet_1_N = mkN "censurfrihet" ; -- censurfrihet..nn.1
  censurförordning_1_N = mkN "censurförordning" ; -- censurförordning..nn.1
  censurhinder_1_N = mkN "censurhinder" neutrum  ; -- censurhinder..nn.1
  censurtvång_1_N = mkN "censurtvång" neutrum  ; -- censurtvång..nn.1
  census_1_N = mkN "census" ; -- census..nn.1
  cent_1_N = mkN "cent" "centen" "cent" "centen" ; -- cent..nn.1
  centaur_1_N = mkN "centaur" "centaurer" ; -- centaur..nn.1
  centaurgestalt_1_N = mkN "centaurgestalt" "centaurgestalter" ; -- centaurgestalt..nn.1
  center_1_N = mkN "center" ; -- center..nn.1
  center_2_N = mkN "center" "centret" "centrer" "centrerna" ; -- center..nn.2
  centerback_1_N = mkN "centerback" ; -- centerback..nn.1
  centerbord_1_N = mkN "centerbord" neutrum  ; -- centerbord..nn.1
  centercourt_1_N = mkN "centercourt" ; -- centercourt..nn.1
  centerforward_1_N = mkN "centerforward" ; -- centerforward..nn.1
  centerhalv_1_N = mkN "centerhalv" ; -- centerhalv..nn.1
  centerism_1_N = mkN "centerism" "centerismer" ; -- centerism..nn.1
  centerledare_1_N = mkN "centerledare" utrum  ; -- centerledare..nn.1
  centerparti_1_N = mkN "centerparti" "centerpartiet" "centerpartier" "centerpartierna" ; -- centerparti..nn.1
  centerpartist_1_N = mkN "centerpartist" "centerpartister" ; -- centerpartist..nn.1
  centerpartistisk_1_A = mkA "centerpartistisk" ; -- centerpartistisk..av.1
  centerprofil_1_N = mkN "centerprofil" "centerprofiler" ; -- centerprofil..nn.1
  centigram_1_N = mkN "centigram" "centigrammet" "centigram" "centigrammen" ; -- centigram..nn.1
  centiliter_1_N = mkN "centiliter" "centilitern" "centiliter" "centiliterna" ; -- centiliter..nn.1
  centilong_1_N = mkN "centilong" "centilongen" "centilong" "centilongen" ; -- centilong..nn.1
  centimeter_1_N = mkN "centimeter" ; -- centimeter..nn.1
  centimeterlång_1_A = mkA "centimeterlång" ; -- centimeterlång..av.1
  centimeterskala_1_N = mkN "centimeterskala" ; -- centimeterskala..nn.1
  centimeterstor_1_A = mkA "centimeterstor" ; -- centimeterstor..av.1
  centimetertjock_1_A = mkA "centimetertjock" ; -- centimetertjock..av.1
  centner_1_N = mkN "centner" "centnern" "centner" "centnerna" ; -- centner..nn.1
  centra_1_V = mkV "centrar" ; -- centra..vb.1
  central_1_A = mkA "central" ; -- central..av.1
  central_1_N = mkN "central" "centraler" ; -- central..nn.1
  centralafrikan_1_N = mkN "centralafrikan" "centralafrikaner" ; -- centralafrikan..nn.1
  centralafrikansk_1_A = mkA "centralafrikansk" ; -- centralafrikansk..av.1
  centralafrikanska_1_N = mkN "centralafrikanska" ; -- centralafrikanska..nn.1
  centralamerikan_1_N = mkN "centralamerikan" "centralamerikaner" ; -- centralamerikan..nn.1
  centralamerikanare_1_N = mkN "centralamerikanare" utrum  ; -- centralamerikanare..nn.1
  centralamerikansk_1_A = mkA "centralamerikansk" ; -- centralamerikansk..av.1
  centralanstalt_1_N = mkN "centralanstalt" "centralanstalter" ; -- centralanstalt..nn.1
  centralantenn_1_N = mkN "centralantenn" "centralantenner" ; -- centralantenn..nn.1
  centralasiatisk_1_A = mkA "centralasiatisk" ; -- centralasiatisk..av.1
  centralbank_1_N = mkN "centralbank" "centralbanker" ; -- centralbank..nn.1
  centralbankschef_1_N = mkN "centralbankschef" "centralbankschefer" ; -- centralbankschef..nn.1
  centralbyggnad_1_N = mkN "centralbyggnad" "centralbyggnader" ; -- centralbyggnad..nn.1
  centralbyrå_1_N = mkN "centralbyrå" "centralbyråer" ; -- centralbyrå..nn.1
  centraldirigerad_1_A = mkA "centraldirigerad" ; -- centraldirigerad..av.1
  centralenhet_1_N = mkN "centralenhet" "centralenheter" ; -- centralenhet..nn.1
  centraleuropeisk_1_A = mkA "centraleuropeisk" ; -- centraleuropeisk..av.1
  centralfigur_1_N = mkN "centralfigur" "centralfigurer" ; -- centralfigur..nn.1
  centralförbund_1_N = mkN "centralförbund" neutrum  ; -- centralförbund..nn.1
  centralförsvar_1_N = mkN "centralförsvar" neutrum  ; -- centralförsvar..nn.1
  centralförvaltning_1_N = mkN "centralförvaltning" ; -- centralförvaltning..nn.1
  centralgestalt_1_N = mkN "centralgestalt" "centralgestalter" ; -- centralgestalt..nn.1
  centralisation_1_N = mkN "centralisation" ; -- centralisation..nn.1
  centralisera_1_V = mkV "centraliserar" ; -- centralisera..vb.1
  centraliserande_1_N = mkN "centraliserande" ; -- centraliserande..nn.1
  centraliserbar_1_A = mkA "centraliserbar" ; -- centraliserbar..av.1
  centraliserbarhet_1_N = mkN "centraliserbarhet" ; -- centraliserbarhet..nn.1
  centralisering_1_N = mkN "centralisering" ; -- centralisering..nn.1
  centralism_1_N = mkN "centralism" "centralismer" ; -- centralism..nn.1
  centralistisk_1_A = mkA "centralistisk" ; -- centralistisk..av.1
  centralkommitté_1_N = mkN "centralkommitté" "centralkommittéer" ; -- centralkommitté..nn.1
  centralkontor_1_N = mkN "centralkontor" neutrum  ; -- centralkontor..nn.1
  centralkyrka_1_N = mkN "centralkyrka" ; -- centralkyrka..nn.1
  centrallasarett_1_N = mkN "centrallasarett" neutrum  ; -- centrallasarett..nn.1
  centrallyrik_1_N = mkN "centrallyrik" ; -- centrallyrik..nn.1
  centrallyrisk_1_A = mkA "centrallyrisk" ; -- centrallyrisk..av.1
  centralmakt_1_N = mkN "centralmakt" "centralmakter" ; -- centralmakt..nn.1
  centralmått_1_N = mkN "centralmått" neutrum  ; -- centralmått..nn.1
  centralnämnd_1_N = mkN "centralnämnd" "centralnämnder" ; -- centralnämnd..nn.1
  centralorganisation_1_N = mkN "centralorganisation" ; -- centralorganisation..nn.1
  centralort_1_N = mkN "centralort" "centralorter" ; -- centralort..nn.1
  centralpunkt_1_N = mkN "centralpunkt" "centralpunkter" ; -- centralpunkt..nn.1
  centralradio_1_N = mkN "centralradio" ; -- centralradio..nn.1
  centralregering_1_N = mkN "centralregering" ; -- centralregering..nn.1
  centralrörelse_1_N = mkN "centralrörelse" "centralrörelser" ; -- centralrörelse..nn.1
  centralskola_1_N = mkN "centralskola" ; -- centralskola..nn.1
  centralstation_1_N = mkN "centralstation" ; -- centralstation..nn.1
  centralstimulantia_1_N = mkN "centralstimulantia" "centralstimulantian" "centralstimulantia" "centralstimulantiana" ; -- centralstimulantia..nn.1
  centralstimulerande_1_A = mkA "centralstimulerande" ; -- centralstimulerande..av.1
  centralstyrd_1_A = mkA "centralstyrd" "centralstyrt" ; -- centralstyrd..av.1
  centralstyrelse_1_N = mkN "centralstyrelse" "centralstyrelser" ; -- centralstyrelse..nn.1
  centralvärme_1_N = mkN "centralvärme" utrum  ; -- centralvärme..nn.1
  centrande_1_N = mkN "centrande" ; -- centrande..nn.1
  centrecourt_1_N = mkN "centrecourt" ; -- centrecourt..nn.1
  centrera_1_V = mkV "centrerar" ; -- centrera..vb.1
  centrerande_1_N = mkN "centrerande" ; -- centrerande..nn.1
  centrerbar_1_A = mkA "centrerbar" ; -- centrerbar..av.1
  centrerbarhet_1_N = mkN "centrerbarhet" ; -- centrerbarhet..nn.1
  centrering_1_N = mkN "centrering" ; -- centrering..nn.1
  centrifug_1_N = mkN "centrifug" "centrifuger" ; -- centrifug..nn.1
  centrifugal_1_A = mkA "centrifugal" ; -- centrifugal..av.1
  centrifugalkraft_1_N = mkN "centrifugalkraft" ; -- centrifugalkraft..nn.1
  centrifugalpump_1_N = mkN "centrifugalpump" ; -- centrifugalpump..nn.1
  centrifugera_1_V = mkV "centrifugerar" ; -- centrifugera..vb.1
  centrifugerande_1_N = mkN "centrifugerande" ; -- centrifugerande..nn.1
  centrifugerbar_1_A = mkA "centrifugerbar" ; -- centrifugerbar..av.1
  centrifugerbarhet_1_N = mkN "centrifugerbarhet" ; -- centrifugerbarhet..nn.1
  centrifugering_1_N = mkN "centrifugering" ; -- centrifugering..nn.1
  centripetal_1_A = mkA "centripetal" ; -- centripetal..av.1
  centripetalkraft_1_N = mkN "centripetalkraft" ; -- centripetalkraft..nn.1
  centrisk_1_A = mkA "centrisk" ; -- centrisk..av.1
  centrum_1_N = mkN "centrum" neutrum  ; -- centrum..nn.1
  centumspråk_1_N = mkN "centumspråk" neutrum  ; -- centumspråk..nn.1
  centurion_1_N = mkN "centurion" ; -- centurion..nn.1
  cepe_1_A = mkA "cepe" ; -- cepe..av.1
  cerat_1_N = mkN "cerat" neutrum  ; -- cerat..nn.1
  cerebral_1_A = mkA "cerebral" ; -- cerebral..av.1
  cerebrospinal_1_A = mkA "cerebrospinal" ; -- cerebrospinal..av.1
  cerebrospinalvätska_1_N = mkN "cerebrospinalvätska" ; -- cerebrospinalvätska..nn.1
  ceremoni_1_N = mkN "ceremoni" "ceremonier" ; -- ceremoni..nn.1
  ceremoniel_1_N = mkN "ceremoniel" "ceremonielet" "ceremoniel" "ceremonielen" ; -- ceremoniel..nn.1
  ceremoniell_1_A = mkA "ceremoniell" ; -- ceremoniell..av.1
  ceremonimästare_1_N = mkN "ceremonimästare" utrum  ; -- ceremonimästare..nn.1
  ceremoniös_1_A = mkA "ceremoniös" ; -- ceremoniös..av.1
  cerise_1_A = mkA "cerise" ; -- cerise..av.1
  cerise_1_N = mkN "cerise" "ceriser" ; -- cerise..nn.1
  cerisefärgad_1_A = mkA "cerisefärgad" ; -- cerisefärgad..av.1
  cerium_1_N = mkN "cerium" neutrum  ; -- cerium..nn.1
  cernera_1_V = mkV "cernerar" ; -- cernera..vb.1
  cernerande_1_N = mkN "cernerande" ; -- cernerande..nn.1
  cernerbar_1_A = mkA "cernerbar" ; -- cernerbar..av.1
  cernerbarhet_1_N = mkN "cernerbarhet" ; -- cernerbarhet..nn.1
  cernering_1_N = mkN "cernering" ; -- cernering..nn.1
  cert_1_N = mkN "cert" "certer" ; -- cert..nn.1
  certeparti_1_N = mkN "certeparti" "certepartiet" "certepartier" "certepartierna" ; -- certeparti..nn.1
  certifiera_1_V = mkV "certifierar" ; -- certifiera..vb.1
  certifierande_1_N = mkN "certifierande" ; -- certifierande..nn.1
  certifiering_1_N = mkN "certifiering" ; -- certifiering..nn.1
  certifikat_1_N = mkN "certifikat" neutrum  ; -- certifikat..nn.1
  cervelatkorv_1_N = mkN "cervelatkorv" ; -- cervelatkorv..nn.1
  cesarisk_1_A = mkA "cesarisk" ; -- cesarisk..av.1
  cesarism_1_N = mkN "cesarism" "cesarismer" ; -- cesarism..nn.1
  cesium_1_N = mkN "cesium" neutrum  ; -- cesium..nn.1
  cession_1_N = mkN "cession" ; -- cession..nn.1
  cesur_1_N = mkN "cesur" "cesurer" ; -- cesur..nn.1
  cha_cha_1_N = mkN "cha-cha" ; -- cha-cha..nn.1
  chagrin_1_N = mkN "chagrin" ; -- chagrin..nn.1
  chagräng_1_N = mkN "chagräng" ; -- chagräng..nn.1
  chalmersk_1_A = mkA "chalmersk" ; -- chalmersk..av.1
  chamotte_1_N = mkN "chamotte" utrum  ; -- chamotte..nn.1
  champagne_1_N = mkN "champagne" "champagner" ; -- champagne..nn.1
  champagnebaksmälla_1_N = mkN "champagnebaksmälla" ; -- champagnebaksmälla..nn.1
  champagnebärgning_1_N = mkN "champagnebärgning" ; -- champagnebärgning..nn.1
  champagneflaska_1_N = mkN "champagneflaska" ; -- champagneflaska..nn.1
  champagneglas_1_N = mkN "champagneglas" neutrum  ; -- champagneglas..nn.1
  champagnekork_1_N = mkN "champagnekork" ; -- champagnekork..nn.1
  champagnesabel_1_N = mkN "champagnesabel" ; -- champagnesabel..nn.1
  champagnesprutande_1_A = mkA "champagnesprutande" ; -- champagnesprutande..av.1
  champagnesprutande_1_N = mkN "champagnesprutande" ; -- champagnesprutande..nn.1
  champagnevaskare_1_N = mkN "champagnevaskare" utrum  ; -- champagnevaskare..nn.1
  champagnevisp_1_N = mkN "champagnevisp" ; -- champagnevisp..nn.1
  champinjon_1_N = mkN "champinjon" "champinjoner" ; -- champinjon..nn.1
  champinjonbädd_1_N = mkN "champinjonbädd" ; -- champinjonbädd..nn.1
  champion_1_N = mkN "champion" "championen" "champions" "championsarna" ; -- champion..nn.1
  championat_1_N = mkN "championat" neutrum  ; -- championat..nn.1
  changemang_1_N = mkN "changemang" neutrum  ; -- changemang..nn.1
  changera_1_V = mkV "changerar" ; -- changera..vb.1
  changerande_1_N = mkN "changerande" ; -- changerande..nn.1
  changering_1_N = mkN "changering" ; -- changering..nn.1
  changsera_1_V = mkV "changserar" ; -- changsera..vb.1
  changserande_1_N = mkN "changserande" ; -- changserande..nn.1
  changsering_1_N = mkN "changsering" ; -- changsering..nn.1
  chans_1_N = mkN "chans" "chanser" ; -- chans..nn.1
  chansa_1_V = mkV "chansar" ; -- chansa..vb.1
  chansande_1_N = mkN "chansande" ; -- chansande..nn.1
  chansartad_1_A = mkA "chansartad" ; -- chansartad..av.1
  chansera_1_V = mkV "chanserar" ; -- chansera..vb.1
  chanserande_1_N = mkN "chanserande" ; -- chanserande..nn.1
  chansering_1_N = mkN "chansering" ; -- chansering..nn.1
  chanslös_1_A = mkA "chanslös" ; -- chanslös..av.1
  chanslöshet_1_N = mkN "chanslöshet" ; -- chanslöshet..nn.1
  chansmässig_1_A = mkA "chansmässig" ; -- chansmässig..av.1
  chansning_1_N = mkN "chansning" ; -- chansning..nn.1
  chanson_1_N = mkN "chanson" "chansoner" ; -- chanson..nn.1
  chansonett_1_N = mkN "chansonett" "chansonetter" ; -- chansonett..nn.1
  chansonettsångerska_1_N = mkN "chansonettsångerska" ; -- chansonettsångerska..nn.1
  chanstagare_1_N = mkN "chanstagare" utrum  ; -- chanstagare..nn.1
  chanstagning_1_N = mkN "chanstagning" ; -- chanstagning..nn.1
  chapeau_claque_1_N = mkN "chapeau-claque" "chapeau-claquer" ; -- chapeau-claque..nn.1
  char_1_N = mkN "char" "charer" ; -- char..nn.1
  charabang_1_N = mkN "charabang" "charabanger" ; -- charabang..nn.1
  charad_1_N = mkN "charad" "charader" ; -- charad..nn.1
  charge_1_N = mkN "charge" "charger" ; -- charge..nn.1
  chargera_1_V = mkV "chargerar" ; -- chargera..vb.1
  chargerande_1_N = mkN "chargerande" ; -- chargerande..nn.1
  chargerbar_1_A = mkA "chargerbar" ; -- chargerbar..av.1
  chargerbarhet_1_N = mkN "chargerbarhet" ; -- chargerbarhet..nn.1
  chargering_1_N = mkN "chargering" ; -- chargering..nn.1
  chargé_d_affaires_1_N = mkN "chargé-d'affaires" "chargé-d'affaireser" ; -- chargé-d-affaires..nn.1
  chark_1_N = mkN "chark" ; -- chark..nn.1
  charkuteri_1_N = mkN "charkuteri" "charkuteriet" "charkuterier" "charkuterierna" ; -- charkuteri..nn.1
  charkuterist_1_N = mkN "charkuterist" "charkuterister" ; -- charkuterist..nn.1
  charkuterivara_1_N = mkN "charkuterivara" ; -- charkuterivara..nn.1
  charkvara_1_N = mkN "charkvara" ; -- charkvara..nn.1
  charlatan_1_N = mkN "charlatan" "charlataner" ; -- charlatan..nn.1
  charlataneri_1_N = mkN "charlataneri" "charlataneriet" "charlatanerier" "charlatanerierna" ; -- charlataneri..nn.1
  charlatanmässig_1_A = mkA "charlatanmässig" ; -- charlatanmässig..av.1
  charleston_1_N = mkN "charleston" ; -- charleston..nn.1
  charm_1_N = mkN "charm" ; -- charm..nn.1
  charma_1_V = mkV "charmar" ; -- charma..vb.1
  charmande_1_N = mkN "charmande" ; -- charmande..nn.1
  charmant_1_A = mkA "charmant" "charmant" ; -- charmant..av.1
  charmera_1_V = mkV "charmerar" ; -- charmera..vb.1
  charmerande_1_N = mkN "charmerande" ; -- charmerande..nn.1
  charmerbar_1_A = mkA "charmerbar" ; -- charmerbar..av.1
  charmerbarhet_1_N = mkN "charmerbarhet" ; -- charmerbarhet..nn.1
  charmering_1_N = mkN "charmering" ; -- charmering..nn.1
  charmeuse_1_N = mkN "charmeuse" utrum  ; -- charmeuse..nn.1
  charmfull_1_A = mkA "charmfull" ; -- charmfull..av.1
  charmfullhet_1_N = mkN "charmfullhet" ; -- charmfullhet..nn.1
  charmig_1_A = mkA "charmig" ; -- charmig..av.1
  charmighet_1_N = mkN "charmighet" ; -- charmighet..nn.1
  charmkurs_1_N = mkN "charmkurs" "charmkurser" ; -- charmkurs..nn.1
  charmkvark_1_N = mkN "charmkvark" ; -- charmkvark..nn.1
  charmlös_1_A = mkA "charmlös" ; -- charmlös..av.1
  charmlöshet_1_N = mkN "charmlöshet" "charmlösheter" ; -- charmlöshet..nn.1
  charmoffensiv_1_N = mkN "charmoffensiv" "charmoffensiver" ; -- charmoffensiv..nn.1
  charmtroll_1_N = mkN "charmtroll" neutrum  ; -- charmtroll..nn.1
  charmör_1_N = mkN "charmör" "charmörer" ; -- charmör..nn.1
  charner_1_N = mkN "charner" "charneret" "charner" "charneren" ; -- charner..nn.1
  charpi_1_N = mkN "charpi" neutrum  ; -- charpi..nn.1
  charta_1_N = mkN "charta" ; -- charta..nn.1
  charter_1_N = mkN "charter" ; -- charter..nn.1
  charterresa_1_N = mkN "charterresa" ; -- charterresa..nn.1
  charterturist_1_N = mkN "charterturist" "charterturister" ; -- charterturist..nn.1
  chartra_1_V = mkV "chartrar" ; -- chartra..vb.1
  chartrande_1_N = mkN "chartrande" ; -- chartrande..nn.1
  chartreuse_1_N = mkN "chartreuse" "chartreuser" ; -- chartreuse..nn.1
  chassi_1_N = mkN "chassi" "chassiet" "chassier" "chassierna" ; -- chassi..nn.1
  chassidism_1_N = mkN "chassidism" "chassidismer" ; -- chassidism..nn.1
  chassidistisk_1_A = mkA "chassidistisk" ; -- chassidistisk..av.1
  chat_1_N = mkN "chat" ; -- chat..nn.1
  chateaubriand_1_N = mkN "chateaubriand" "chateaubriander" ; -- chateaubriand..nn.1
  chatt_1_N = mkN "chatt" ; -- chatt..nn.1
  chatta_1_V = mkV "chattar" ; -- chatta..vb.1
  chattande_1_N = mkN "chattande" ; -- chattande..nn.1
  chattkonversation_1_N = mkN "chattkonversation" ; -- chattkonversation..nn.1
  chaufför_1_N = mkN "chaufför" "chaufförer" ; -- chaufför..nn.1
  chausserad_1_A = mkA "chausserad" ; -- chausserad..av.1
  chaussé_1_N = mkN "chaussé" "chausséer" ; -- chaussé..nn.1
  chauvinism_1_N = mkN "chauvinism" "chauvinismer" ; -- chauvinism..nn.1
  chauvinist_1_N = mkN "chauvinist" "chauvinister" ; -- chauvinist..nn.1
  chauvinistisk_1_A = mkA "chauvinistisk" ; -- chauvinistisk..av.1
  check_1_N = mkN "check" ; -- check..nn.1
  checka_1_V = mkV "checkar" ; -- checka..vb.1
  checkande_1_N = mkN "checkande" ; -- checkande..nn.1
  checkbok_1_N = mkN "checkbok" "checkböcker" ; -- checkbok..nn.1
  checkhäfte_1_N = mkN "checkhäfte" ; -- checkhäfte..nn.1
  checkkonto_1_N = mkN "checkkonto" "checkkontot" "checkkonton" "checkkontona" ; -- checkkonto..nn.1
  checkkredit_1_N = mkN "checkkredit" "checkkrediter" ; -- checkkredit..nn.1
  checklista_1_N = mkN "checklista" ; -- checklista..nn.1
  checklön_1_N = mkN "checklön" "checklöner" ; -- checklön..nn.1
  checkräkning_1_N = mkN "checkräkning" ; -- checkräkning..nn.1
  checksumma_1_N = mkN "checksumma" ; -- checksumma..nn.1
  cheddarost_1_N = mkN "cheddarost" ; -- cheddarost..nn.1
  chef_d_oeuvre_1_N = mkN "chef-d'oeuvre" ; -- chef-d-oeuvre..nn.1
  chef_1_N = mkN "chef" "chefer" ; -- chef..nn.1
  chefa_1_V = mkV "chefar" ; -- chefa..vb.1
  chefande_1_N = mkN "chefande" ; -- chefande..nn.1
  chefredaktör_1_N = mkN "chefredaktör" "chefredaktörer" ; -- chefredaktör..nn.1
  chefsegenskap_1_N = mkN "chefsegenskap" "chefsegenskaper" ; -- chefsegenskap..nn.1
  chefsekonom_1_N = mkN "chefsekonom" "chefsekonomer" ; -- chefsekonom..nn.1
  chefsfartyg_1_N = mkN "chefsfartyg" neutrum  ; -- chefsfartyg..nn.1
  chefsflytt_1_N = mkN "chefsflytt" ; -- chefsflytt..nn.1
  chefsideolog_1_N = mkN "chefsideolog" "chefsideologer" ; -- chefsideolog..nn.1
  chefsjobb_1_N = mkN "chefsjobb" neutrum  ; -- chefsjobb..nn.1
  chefskap_1_N = mkN "chefskap" neutrum  ; -- chefskap..nn.1
  chefskirurg_1_N = mkN "chefskirurg" "chefskirurger" ; -- chefskirurg..nn.1
  chefsmikrobiolog_1_N = mkN "chefsmikrobiolog" "chefsmikrobiologer" ; -- chefsmikrobiolog..nn.1
  chefsplats_1_N = mkN "chefsplats" "chefsplatser" ; -- chefsplats..nn.1
  chefsskap_1_N = mkN "chefsskap" neutrum  ; -- chefsskap..nn.1
  chefsställning_1_N = mkN "chefsställning" ; -- chefsställning..nn.1
  chefstjänsteman_1_N = mkN "chefstjänsteman" "chefstjänstemannen" "chefstjänstemän" "chefstjänstemännen" ; -- chefstjänsteman..nn.1
  chefsåklagare_1_N = mkN "chefsåklagare" utrum  ; -- chefsåklagare..nn.1
  chemis_1_N = mkN "chemis" "chemiser" ; -- chemis..nn.1
  chemisett_1_N = mkN "chemisett" "chemisetter" ; -- chemisett..nn.1
  cherimoya_1_N = mkN "cherimoya" ; -- cherimoya..nn.1
  chevaleresk_1_A = mkA "chevaleresk" ; -- chevaleresk..av.1
  chevelyr_1_N = mkN "chevelyr" "chevelyrer" ; -- chevelyr..nn.1
  cheviot_1_N = mkN "cheviot" "chevioter" ; -- cheviot..nn.1
  chevreau_1_N = mkN "chevreau" ; -- chevreau..nn.1
  chevrotera_1_V = mkV "chevroterar" ; -- chevrotera..vb.1
  chevroterande_1_N = mkN "chevroterande" ; -- chevroterande..nn.1
  chevroterbar_1_A = mkA "chevroterbar" ; -- chevroterbar..av.1
  chevroterbarhet_1_N = mkN "chevroterbarhet" ; -- chevroterbarhet..nn.1
  chevrotering_1_N = mkN "chevrotering" ; -- chevrotering..nn.1
  cheyenne_1_N = mkN "cheyenne" "cheyenner" ; -- cheyenne..nn.1
  chi_1_N = mkN "chi" neutrum  ; -- chi..nn.1
  chibbe_1_N = mkN "chibbe" utrum  ; -- chibbe..nn.1
  chic_1_A = mkA "chic" ; -- chic..av.1
  chichet_1_N = mkN "chichet" ; -- chichet..nn.1
  chiffer_1_N = mkN "chiffer" neutrum  ; -- chiffer..nn.1
  chiffernyckel_1_N = mkN "chiffernyckel" ; -- chiffernyckel..nn.1
  chifferskrift_1_N = mkN "chifferskrift" "chifferskrifter" ; -- chifferskrift..nn.1
  chiffong_1_N = mkN "chiffong" "chiffonger" ; -- chiffong..nn.1
  chiffonggarnering_1_N = mkN "chiffonggarnering" ; -- chiffonggarnering..nn.1
  chiffongklänning_1_N = mkN "chiffongklänning" ; -- chiffongklänning..nn.1
  chiffonjé_1_N = mkN "chiffonjé" "chiffonjéer" ; -- chiffonjé..nn.1
  chiffrera_1_V = mkV "chiffrerar" ; -- chiffrera..vb.1
  chiffrerande_1_N = mkN "chiffrerande" ; -- chiffrerande..nn.1
  chiffrerbar_1_A = mkA "chiffrerbar" ; -- chiffrerbar..av.1
  chiffrerbarhet_1_N = mkN "chiffrerbarhet" ; -- chiffrerbarhet..nn.1
  chiffrering_1_N = mkN "chiffrering" ; -- chiffrering..nn.1
  chikan_1_N = mkN "chikan" "chikaner" ; -- chikan..nn.1
  chikanera_1_V = mkV "chikanerar" ; -- chikanera..vb.1
  chikanerande_1_N = mkN "chikanerande" ; -- chikanerande..nn.1
  chikanerbar_1_A = mkA "chikanerbar" ; -- chikanerbar..av.1
  chikanerbarhet_1_N = mkN "chikanerbarhet" ; -- chikanerbarhet..nn.1
  chikanering_1_N = mkN "chikanering" ; -- chikanering..nn.1
  chilen_1_N = mkN "chilen" "chilener" ; -- chilen..nn.1
  chilenare_1_N = mkN "chilenare" utrum  ; -- chilenare..nn.1
  chilensk_1_A = mkA "chilensk" ; -- chilensk..av.1
  chilenska_1_N = mkN "chilenska" ; -- chilenska..nn.1
  chilesalpeter_1_N = mkN "chilesalpeter" ; -- chilesalpeter..nn.1
  chilisås_1_N = mkN "chilisås" ; -- chilisås..nn.1
  chilla_1_V = mkV "chillar" ; -- chilla..vb.1
  chillande_1_N = mkN "chillande" ; -- chillande..nn.1
  chimpa_1_V = mkV "chimpar" ; -- chimpa..vb.1
  chimpande_1_N = mkN "chimpande" ; -- chimpande..nn.1
  chimpans_1_N = mkN "chimpans" "chimpanser" ; -- chimpans..nn.1
  chimping_1_N = mkN "chimping" ; -- chimping..nn.1
  chimpning_1_N = mkN "chimpning" ; -- chimpning..nn.1
  chimär_1_N = mkN "chimär" "chimärer" ; -- chimär..nn.1
  chimärisk_1_A = mkA "chimärisk" ; -- chimärisk..av.1
  chinchilla_1_N = mkN "chinchilla" ; -- chinchilla..nn.1
  chinjong_1_N = mkN "chinjong" "chinjonger" ; -- chinjong..nn.1
  chintz_1_N = mkN "chintz" ; -- chintz..nn.1
  chip_1_N = mkN "chip" neutrum  ; -- chip..nn.1
  chips_1_N = mkN "chips" neutrum  ; -- chips..nn.1
  chipssug_1_N = mkN "chipssug" neutrum  ; -- chipssug..nn.1
  chirre_1_N = mkN "chirre" utrum  ; -- chirre..nn.1
  chock_1_N = mkN "chock" "chocker" ; -- chock..nn.1
  chocka_1_V = mkV "chockar" ; -- chocka..vb.1
  chockande_1_N = mkN "chockande" ; -- chockande..nn.1
  chockartad_1_A = mkA "chockartad" ; -- chockartad..av.1
  chockbehandla_1_V = mkV "chockbehandlar" ; -- chockbehandla..vb.1
  chockbehandlande_1_N = mkN "chockbehandlande" ; -- chockbehandlande..nn.1
  chockbehandling_1_N = mkN "chockbehandling" ; -- chockbehandling..nn.1
  chockbeskatta_1_V = mkV "chockbeskattar" ; -- chockbeskatta..vb.1
  chockbeskattande_1_N = mkN "chockbeskattande" ; -- chockbeskattande..nn.1
  chockbeskattning_1_N = mkN "chockbeskattning" ; -- chockbeskattning..nn.1
  chockbesked_1_N = mkN "chockbesked" neutrum  ; -- chockbesked..nn.1
  chockbild_1_N = mkN "chockbild" "chockbilder" ; -- chockbild..nn.1
  chockera_1_V = mkV "chockerar" ; -- chockera..vb.1
  chockerande_1_N = mkN "chockerande" ; -- chockerande..nn.1
  chockerbar_1_A = mkA "chockerbar" ; -- chockerbar..av.1
  chockerbarhet_1_N = mkN "chockerbarhet" ; -- chockerbarhet..nn.1
  chockering_1_N = mkN "chockering" ; -- chockering..nn.1
  chockfas_1_N = mkN "chockfas" "chockfaser" ; -- chockfas..nn.1
  chockhöja_1_V = mkV "chockhöja" "chockhöjde" "chockhöjt" ; -- chockhöja..vb.1
  chockhöjande_1_N = mkN "chockhöjande" ; -- chockhöjande..nn.1
  chockhöjning_1_N = mkN "chockhöjning" ; -- chockhöjning..nn.1
  chockreaktion_1_N = mkN "chockreaktion" ; -- chockreaktion..nn.1
  chockrosa_1_A = mkA "chockrosa" ; -- chockrosa..av.1
  chockterapi_1_N = mkN "chockterapi" "chockterapier" ; -- chockterapi..nn.1
  chocktillstånd_1_N = mkN "chocktillstånd" neutrum  ; -- chocktillstånd..nn.1
  chockvåg_1_N = mkN "chockvåg" "chockvågor" ; -- chockvåg..nn.1
  choka_1_V = mkV "chokar" ; -- choka..vb.1
  chokande_1_N = mkN "chokande" ; -- chokande..nn.1
  choke_1_N = mkN "choke" utrum  ; -- choke..nn.1
  choklad_1_N = mkN "choklad" "choklader" ; -- choklad..nn.1
  choklad_2_N = mkN "choklad" neutrum  ; -- choklad..nn.2
  chokladbit_1_N = mkN "chokladbit" ; -- chokladbit..nn.1
  chokladboll_1_N = mkN "chokladboll" ; -- chokladboll..nn.1
  chokladbrun_1_A = mkA "chokladbrun" ; -- chokladbrun..av.1
  chokladglass_1_N = mkN "chokladglass" ; -- chokladglass..nn.1
  chokladgodis_1_N = mkN "chokladgodis" neutrum  ; -- chokladgodis..nn.1
  chokladgodis_2_N = mkN "chokladgodis" ; -- chokladgodis..nn.2
  chokladkaka_1_N = mkN "chokladkaka" ; -- chokladkaka..nn.1
  chokladlins_1_N = mkN "chokladlins" "chokladlinser" ; -- chokladlins..nn.1
  chokladlycka_1_N = mkN "chokladlycka" ; -- chokladlycka..nn.1
  chokladpudding_1_N = mkN "chokladpudding" ; -- chokladpudding..nn.1
  chokladtårta_1_N = mkN "chokladtårta" ; -- chokladtårta..nn.1
  chorizo_stoppning_1_N = mkN "chorizo-stoppning" ; -- chorizo-stoppning..nn.1
  chorizo_1_N = mkN "chorizo" "chorizor" ; -- chorizo..nn.1
  chosefri_1_A = mkA "chosefri" "chosefritt" ; -- chosefri..av.1
  chosig_1_A = mkA "chosig" ; -- chosig..av.1
  chuck_1_N = mkN "chuck" ; -- chuck..nn.1
  cicero_1_N = mkN "cicero" ; -- cicero..nn.1
  ciceron_1_N = mkN "ciceron" "ciceroner" ; -- ciceron..nn.1
  cider_1_N = mkN "cider" ; -- cider..nn.1
  cig_1_N = mkN "cig" ; -- cig..nn.1
  cigarett_1_N = mkN "cigarett" "cigaretter" ; -- cigarett..nn.1
  cigarettautomat_1_N = mkN "cigarettautomat" "cigarettautomater" ; -- cigarettautomat..nn.1
  cigarettetui_1_N = mkN "cigarettetui" "cigarettetuit" "cigarettetuin" "cigarettetuien" ; -- cigarettetui..nn.1
  cigarettfimp_1_N = mkN "cigarettfimp" ; -- cigarettfimp..nn.1
  cigarettförsäljning_1_N = mkN "cigarettförsäljning" ; -- cigarettförsäljning..nn.1
  cigarettlimpa_1_N = mkN "cigarettlimpa" ; -- cigarettlimpa..nn.1
  cigarettpaket_1_N = mkN "cigarettpaket" neutrum  ; -- cigarettpaket..nn.1
  cigarettrök_1_N = mkN "cigarettrök" ; -- cigarettrök..nn.1
  cigarettrökning_1_N = mkN "cigarettrökning" ; -- cigarettrökning..nn.1
  cigarettuttag_1_N = mkN "cigarettuttag" neutrum  ; -- cigarettuttag..nn.1
  cigarettändare_1_N = mkN "cigarettändare" utrum  ; -- cigarettändare..nn.1
  cigarettändarkontakt_1_N = mkN "cigarettändarkontakt" "cigarettändarkontakter" ; -- cigarettändarkontakt..nn.1
  cigarettändaruttag_1_N = mkN "cigarettändaruttag" neutrum  ; -- cigarettändaruttag..nn.1
  cigarill_1_N = mkN "cigarill" "cigariller" ; -- cigarill..nn.1
  cigarr_1_N = mkN "cigarr" "cigarrer" ; -- cigarr..nn.1
  cigarrcigarett_1_N = mkN "cigarrcigarett" "cigarrcigaretter" ; -- cigarrcigarett..nn.1
  cigarrcigarrett_1_N = mkN "cigarrcigarrett" "cigarrcigarretter" ; -- cigarrcigarrett..nn.1
  cigarrett_1_N = mkN "cigarrett" "cigarretter" ; -- cigarrett..nn.1
  cigarrettfimp_1_N = mkN "cigarrettfimp" ; -- cigarrettfimp..nn.1
  cigarrettlimpa_1_N = mkN "cigarrettlimpa" ; -- cigarrettlimpa..nn.1
  cigarrettobak_1_N = mkN "cigarrettobak" ; -- cigarrettobak..nn.1
  cigarrettpaket_1_N = mkN "cigarrettpaket" neutrum  ; -- cigarrettpaket..nn.1
  cigarrettrök_1_N = mkN "cigarrettrök" ; -- cigarrettrök..nn.1
  cigarrettuttag_1_N = mkN "cigarrettuttag" neutrum  ; -- cigarrettuttag..nn.1
  cigarrettändare_1_N = mkN "cigarrettändare" utrum  ; -- cigarrettändare..nn.1
  cigarrettändarkontakt_1_N = mkN "cigarrettändarkontakt" "cigarrettändarkontakter" ; -- cigarrettändarkontakt..nn.1
  cigarrettändaruttag_1_N = mkN "cigarrettändaruttag" neutrum  ; -- cigarrettändaruttag..nn.1
  cigarrill_1_N = mkN "cigarrill" "cigarriller" ; -- cigarrill..nn.1
  cigarrlåda_1_N = mkN "cigarrlåda" ; -- cigarrlåda..nn.1
  cigarrsnopp_1_N = mkN "cigarrsnopp" ; -- cigarrsnopp..nn.1
  cigarrsnoppare_1_N = mkN "cigarrsnoppare" utrum  ; -- cigarrsnoppare..nn.1
  cigarrtändare_1_N = mkN "cigarrtändare" utrum  ; -- cigarrtändare..nn.1
  cigg_1_N = mkN "cigg" ; -- cigg..nn.1
  cikada_1_N = mkN "cikada" ; -- cikada..nn.1
  ciklid_1_N = mkN "ciklid" "ciklider" ; -- ciklid..nn.1
  ciklidfisk_1_N = mkN "ciklidfisk" ; -- ciklidfisk..nn.1
  ciklidfiskfauna_1_N = mkN "ciklidfiskfauna" ; -- ciklidfiskfauna..nn.1
  cikoria_1_N = mkN "cikoria" ; -- cikoria..nn.1
  ciliarkropp_1_N = mkN "ciliarkropp" ; -- ciliarkropp..nn.1
  ciliarmuskel_1_N = mkN "ciliarmuskel" "ciliarmuskeln" "ciliarmuskler" "ciliarmusklerna" ; -- ciliarmuskel..nn.1
  cilie_1_N = mkN "cilie" "cilier" ; -- cilie..nn.1
  cineast_1_N = mkN "cineast" "cineaster" ; -- cineast..nn.1
  cinematek_1_N = mkN "cinematek" neutrum  ; -- cinematek..nn.1
  cineraria_1_N = mkN "cineraria" ; -- cineraria..nn.1
  cinnober_1_N = mkN "cinnober" ; -- cinnober..nn.1
  cinnoberfärg_1_N = mkN "cinnoberfärg" "cinnoberfärger" ; -- cinnoberfärg..nn.1
  cinnoberröd_1_A = mkA "cinnoberröd" "cinnoberrött" ; -- cinnoberröd..av.1
  cirkapris_1_N = mkN "cirkapris" neutrum  ; -- cirkapris..nn.1
  cirkel_1_N = mkN "cirkel" ; -- cirkel..nn.1
  cirkelbana_1_N = mkN "cirkelbana" ; -- cirkelbana..nn.1
  cirkelben_1_N = mkN "cirkelben" neutrum  ; -- cirkelben..nn.1
  cirkelbevis_1_N = mkN "cirkelbevis" neutrum  ; -- cirkelbevis..nn.1
  cirkelbåge_1_N = mkN "cirkelbåge" utrum  ; -- cirkelbåge..nn.1
  cirkeldefinition_1_N = mkN "cirkeldefinition" ; -- cirkeldefinition..nn.1
  cirkelform_1_N = mkN "cirkelform" ; -- cirkelform..nn.1
  cirkelformad_1_A = mkA "cirkelformad" "cirkelformadt" ; -- cirkelformad..av.1
  cirkelgång_1_N = mkN "cirkelgång" ; -- cirkelgång..nn.1
  cirkelledare_1_N = mkN "cirkelledare" utrum  ; -- cirkelledare..nn.1
  cirkelperiferi_1_N = mkN "cirkelperiferi" "cirkelperiferier" ; -- cirkelperiferi..nn.1
  cirkelprocess_1_N = mkN "cirkelprocess" "cirkelprocesser" ; -- cirkelprocess..nn.1
  cirkelrund_1_A = mkA "cirkelrund" ; -- cirkelrund..av.1
  cirkelrundhet_1_N = mkN "cirkelrundhet" ; -- cirkelrundhet..nn.1
  cirkelrörelse_1_N = mkN "cirkelrörelse" "cirkelrörelser" ; -- cirkelrörelse..nn.1
  cirkelsegment_1_N = mkN "cirkelsegment" neutrum  ; -- cirkelsegment..nn.1
  cirkelsektor_1_N = mkN "cirkelsektor" "cirkelsektorer" ; -- cirkelsektor..nn.1
  cirkelslut_1_N = mkN "cirkelslut" neutrum  ; -- cirkelslut..nn.1
  cirkelsåg_1_N = mkN "cirkelsåg" ; -- cirkelsåg..nn.1
  cirkla_1_V = mkV "cirklar" ; -- cirkla..vb.1
  cirklande_1_N = mkN "cirklande" ; -- cirklande..nn.1
  cirkulation_1_N = mkN "cirkulation" ; -- cirkulation..nn.1
  cirkulationsplats_1_N = mkN "cirkulationsplats" "cirkulationsplatser" ; -- cirkulationsplats..nn.1
  cirkulationspump_1_N = mkN "cirkulationspump" ; -- cirkulationspump..nn.1
  cirkulationsrubbning_1_N = mkN "cirkulationsrubbning" ; -- cirkulationsrubbning..nn.1
  cirkulera_1_V = mkV "cirkulerar" ; -- cirkulera..vb.1
  cirkulerande_1_N = mkN "cirkulerande" ; -- cirkulerande..nn.1
  cirkulerbar_1_A = mkA "cirkulerbar" ; -- cirkulerbar..av.1
  cirkulerbarhet_1_N = mkN "cirkulerbarhet" ; -- cirkulerbarhet..nn.1
  cirkulering_1_N = mkN "cirkulering" ; -- cirkulering..nn.1
  cirkulär_1_A = mkA "cirkulär" ; -- cirkulär..av.1
  cirkulär_1_N = mkN "cirkulär" neutrum  ; -- cirkulär..nn.1
  cirkulärbrev_1_N = mkN "cirkulärbrev" neutrum  ; -- cirkulärbrev..nn.1
  cirkulärledare_1_N = mkN "cirkulärledare" utrum  ; -- cirkulärledare..nn.1
  cirkumflex_1_N = mkN "cirkumflex" "cirkumflexer" ; -- cirkumflex..nn.1
  cirkumpolar_1_A = mkA "cirkumpolar" ; -- cirkumpolar..av.1
  cirkumpolär_1_A = mkA "cirkumpolär" ; -- cirkumpolär..av.1
  cirkus_1_N = mkN "cirkus" ; -- cirkus..nn.1
  cirkusarena_1_N = mkN "cirkusarena" ; -- cirkusarena..nn.1
  cirkusartist_1_N = mkN "cirkusartist" "cirkusartister" ; -- cirkusartist..nn.1
  cirkusbyggnad_1_N = mkN "cirkusbyggnad" "cirkusbyggnader" ; -- cirkusbyggnad..nn.1
  cirkusdjur_1_N = mkN "cirkusdjur" neutrum  ; -- cirkusdjur..nn.1
  cirkuselefant_1_N = mkN "cirkuselefant" "cirkuselefanter" ; -- cirkuselefant..nn.1
  cirkusföreställning_1_N = mkN "cirkusföreställning" ; -- cirkusföreställning..nn.1
  cirkusmanege_1_N = mkN "cirkusmanege" "cirkusmaneger" ; -- cirkusmanege..nn.1
  cirkusmässig_1_A = mkA "cirkusmässig" ; -- cirkusmässig..av.1
  cirkusnummer_1_N = mkN "cirkusnummer" neutrum  ; -- cirkusnummer..nn.1
  cirkustält_1_N = mkN "cirkustält" neutrum  ; -- cirkustält..nn.1
  cirkusvagn_1_N = mkN "cirkusvagn" ; -- cirkusvagn..nn.1
  cirrhos_1_N = mkN "cirrhos" "cirrhoser" ; -- cirrhos..nn.1
  cirros_1_N = mkN "cirros" "cirroser" ; -- cirros..nn.1
  cirrus_1_N = mkN "cirrus" ; -- cirrus..nn.1
  cirrusmoln_1_N = mkN "cirrusmoln" neutrum  ; -- cirrusmoln..nn.1
  cisalpinsk_1_A = mkA "cisalpinsk" ; -- cisalpinsk..av.1
  ciselera_1_V = mkV "ciselerar" ; -- ciselera..vb.1
  ciselerande_1_N = mkN "ciselerande" ; -- ciselerande..nn.1
  ciselerbar_1_A = mkA "ciselerbar" ; -- ciselerbar..av.1
  ciselerbarhet_1_N = mkN "ciselerbarhet" ; -- ciselerbarhet..nn.1
  ciselering_1_N = mkN "ciselering" ; -- ciselering..nn.1
  ciselör_1_N = mkN "ciselör" "ciselörer" ; -- ciselör..nn.1
  cisperson_1_N = mkN "cisperson" "cispersoner" ; -- cisperson..nn.1
  ciss_1_N = mkN "ciss" neutrum  ; -- ciss..nn.1
  cissexualitet_1_N = mkN "cissexualitet" ; -- cissexualitet..nn.1
  cissexuell_1_A = mkA "cissexuell" ; -- cissexuell..av.1
  cissus_1_N = mkN "cissus" ; -- cissus..nn.1
  cisterciens_1_N = mkN "cisterciens" "cistercienser" ; -- cisterciens..nn.1
  cistercienserkloster_1_N = mkN "cistercienserkloster" neutrum  ; -- cistercienserkloster..nn.1
  cisterciensermunk_1_N = mkN "cisterciensermunk" ; -- cisterciensermunk..nn.1
  cistercienserorden_1_N = mkN "cistercienserorden" ; -- cistercienserorden..nn.1
  cisterciensorden_1_N = mkN "cisterciensorden" ; -- cisterciensorden..nn.1
  cistern_1_N = mkN "cistern" "cisterner" ; -- cistern..nn.1
  cisulal_1_N = mkN "cisulal" ; -- cisulal..nn.1
  citadell_1_N = mkN "citadell" neutrum  ; -- citadell..nn.1
  citat_1_N = mkN "citat" neutrum  ; -- citat..nn.1
  citation_1_N = mkN "citation" ; -- citation..nn.1
  citationstecken_1_N = mkN "citationstecken" "citationstecknet" "citationstecken" "citationstecknen" ; -- citationstecken..nn.1
  citatord_1_N = mkN "citatord" neutrum  ; -- citatord..nn.1
  citattecken_1_N = mkN "citattecken" "citattecknet" "citattecken" "citattecknen" ; -- citattecken..nn.1
  citera_1_V = mkV "citerar" ; -- citera..vb.1
  citerande_1_N = mkN "citerande" ; -- citerande..nn.1
  citerbar_1_A = mkA "citerbar" ; -- citerbar..av.1
  citerbarhet_1_N = mkN "citerbarhet" ; -- citerbarhet..nn.1
  citering_1_N = mkN "citering" ; -- citering..nn.1
  citrat_1_N = mkN "citrat" neutrum  ; -- citrat..nn.1
  citrin_1_N = mkN "citrin" "citriner" ; -- citrin..nn.1
  citroen_1_N = mkN "citroen" "citroener" ; -- citroen..nn.1
  citron_1_N = mkN "citron" "citroner" ; -- citron..nn.1
  citronbakelse_1_N = mkN "citronbakelse" "citronbakelser" ; -- citronbakelse..nn.1
  citrondoft_1_N = mkN "citrondoft" "citrondofter" ; -- citrondoft..nn.1
  citronfjäril_1_N = mkN "citronfjäril" ; -- citronfjäril..nn.1
  citrongräsolja_1_N = mkN "citrongräsolja" ; -- citrongräsolja..nn.1
  citrongul_1_A = mkA "citrongul" ; -- citrongul..av.1
  citronläsk_1_N = mkN "citronläsk" "citronläsken" "citronläsk" "citronläsken" ; -- citronläsk..nn.1
  citronmarinerad_1_A = mkA "citronmarinerad" ; -- citronmarinerad..av.1
  citronmeliss_1_N = mkN "citronmeliss" ; -- citronmeliss..nn.1
  citronmousse_1_N = mkN "citronmousse" "citronmousser" ; -- citronmousse..nn.1
  citronolja_1_N = mkN "citronolja" ; -- citronolja..nn.1
  citronsaft_1_N = mkN "citronsaft" "citronsafter" ; -- citronsaft..nn.1
  citronskal_1_N = mkN "citronskal" neutrum  ; -- citronskal..nn.1
  citronsorbet_1_N = mkN "citronsorbet" ; -- citronsorbet..nn.1
  citronsyra_1_N = mkN "citronsyra" ; -- citronsyra..nn.1
  citronträd_1_N = mkN "citronträd" neutrum  ; -- citronträd..nn.1
  citrus_1_N = mkN "citrus" ; -- citrus..nn.1
  citrusfrukt_1_N = mkN "citrusfrukt" "citrusfrukter" ; -- citrusfrukt..nn.1
  citrussmak_1_N = mkN "citrussmak" ; -- citrussmak..nn.1
  citterspel_1_N = mkN "citterspel" "citterspelet" "citterspel" "citterspelen" ; -- citterspel..nn.1
  citterspelare_1_N = mkN "citterspelare" utrum  ; -- citterspelare..nn.1
  cittra_1_N = mkN "cittra" ; -- cittra..nn.1
  cittra_2_N = mkN "cittra" ; -- cittra..nn.2
  city_1_N = mkN "city" "cityt" "cityn" "cityna" ; -- city..nn.1
  citydress_1_N = mkN "citydress" ; -- citydress..nn.1
  citykärna_1_N = mkN "citykärna" ; -- citykärna..nn.1
  cityliv_1_N = mkN "cityliv" neutrum  ; -- cityliv..nn.1
  cityljus_1_N = mkN "cityljus" neutrum  ; -- cityljus..nn.1
  civil_1_A = mkA "civil" ; -- civil..av.1
  civilanställd_1_A = mkA "civilanställd" "civilanställt" ; -- civilanställd..av.1
  civilbefolkning_1_N = mkN "civilbefolkning" ; -- civilbefolkning..nn.1
  civilbegravning_1_N = mkN "civilbegravning" ; -- civilbegravning..nn.1
  civildepartement_1_N = mkN "civildepartement" neutrum  ; -- civildepartement..nn.1
  civilekonom_1_N = mkN "civilekonom" "civilekonomer" ; -- civilekonom..nn.1
  civilflyg_1_N = mkN "civilflyg" neutrum  ; -- civilflyg..nn.1
  civilförsvar_1_N = mkN "civilförsvar" neutrum  ; -- civilförsvar..nn.1
  civilförsvarspersonal_1_N = mkN "civilförsvarspersonal" ; -- civilförsvarspersonal..nn.1
  civilingenjör_1_N = mkN "civilingenjör" "civilingenjörer" ; -- civilingenjör..nn.1
  civilisation_1_N = mkN "civilisation" ; -- civilisation..nn.1
  civilisationsprocess_1_N = mkN "civilisationsprocess" "civilisationsprocesser" ; -- civilisationsprocess..nn.1
  civilisatorisk_1_A = mkA "civilisatorisk" ; -- civilisatorisk..av.1
  civilisera_1_V = mkV "civiliserar" ; -- civilisera..vb.1
  civiliserad_1_A = mkA "civiliserad" ; -- civiliserad..av.1
  civiliserande_1_N = mkN "civiliserande" ; -- civiliserande..nn.1
  civiliserbar_1_A = mkA "civiliserbar" ; -- civiliserbar..av.1
  civiliserbarhet_1_N = mkN "civiliserbarhet" ; -- civiliserbarhet..nn.1
  civilisering_1_N = mkN "civilisering" ; -- civilisering..nn.1
  civilist_1_N = mkN "civilist" "civilister" ; -- civilist..nn.1
  civilklädd_1_A = mkA "civilklädd" ; -- civilklädd..av.1
  civilkurage_1_N = mkN "civilkurage" ; -- civilkurage..nn.1
  civillag_1_N = mkN "civillag" ; -- civillag..nn.1
  civilmilitär_1_A = mkA "civilmilitär" ; -- civilmilitär..av.1
  civilmilitär_1_N = mkN "civilmilitär" "civilmilitärer" ; -- civilmilitär..nn.1
  civilminister_1_N = mkN "civilminister" ; -- civilminister..nn.1
  civilmotstånd_1_N = mkN "civilmotstånd" neutrum  ; -- civilmotstånd..nn.1
  civilmål_1_N = mkN "civilmål" neutrum  ; -- civilmål..nn.1
  civilprocess_1_N = mkN "civilprocess" "civilprocesser" ; -- civilprocess..nn.1
  civilrätt_1_N = mkN "civilrätt" ; -- civilrätt..nn.1
  civilrättslig_1_A = mkA "civilrättslig" ; -- civilrättslig..av.1
  civilstat_1_N = mkN "civilstat" "civilstater" ; -- civilstat..nn.1
  civilstånd_1_N = mkN "civilstånd" neutrum  ; -- civilstånd..nn.1
  civiläktenskap_1_N = mkN "civiläktenskap" neutrum  ; -- civiläktenskap..nn.1
  clairobscur_1_N = mkN "clairobscur" "clairobscurer" ; -- clairobscur..nn.1
  clairvoyance_1_N = mkN "clairvoyance" utrum  ; -- clairvoyance..nn.1
  clairvoyant_1_A = mkA "clairvoyant" "clairvoyant" ; -- clairvoyant..av.1
  cleara_1_V = mkV "clearar" ; -- cleara..vb.1
  clearande_1_N = mkN "clearande" ; -- clearande..nn.1
  clearing_1_N = mkN "clearing" ; -- clearing..nn.1
  clematis_1_N = mkN "clematis" ; -- clematis..nn.1
  clementin_1_N = mkN "clementin" "clementiner" ; -- clementin..nn.1
  clinch_1_N = mkN "clinch" ; -- clinch..nn.1
  clips_1_N = mkN "clips" neutrum  ; -- clips..nn.1
  clitoris_1_N = mkN "clitoris" ; -- clitoris..nn.1
  cloisonvägg_1_N = mkN "cloisonvägg" ; -- cloisonvägg..nn.1
  cloqué_1_N = mkN "cloqué" "cloquéer" ; -- cloqué..nn.1
  clou_1_N = mkN "clou" ; -- clou..nn.1
  clown_1_N = mkN "clown" "clowner" ; -- clown..nn.1
  clowneri_1_N = mkN "clowneri" "clowneriet" "clownerier" "clownerierna" ; -- clowneri..nn.1
  clownupptåg_1_N = mkN "clownupptåg" neutrum  ; -- clownupptåg..nn.1
  club_blazer_1_N = mkN "club-blazer" ; -- club-blazer..nn.1
  clubstek_1_N = mkN "clubstek" ; -- clubstek..nn.1
  coach_1_N = mkN "coach" ; -- coach..nn.1
  coca_1_N = mkN "coca" ; -- coca..nn.1
  cocacola_1_N = mkN "cocacola" ; -- cocacola..nn.1
  cochleaimplantat_1_N = mkN "cochleaimplantat" neutrum  ; -- cochleaimplantat..nn.1
  cochlearimplantat_1_N = mkN "cochlearimplantat" neutrum  ; -- cochlearimplantat..nn.1
  cockerspaniel_1_N = mkN "cockerspaniel" "cockerspanieln" "cockerspaniels" "cockerspanielarna" ; -- cockerspaniel..nn.1
  cockpit_1_N = mkN "cockpit" ; -- cockpit..nn.1
  cocktail_1_N = mkN "cocktail" ; -- cocktail..nn.1
  cocktailbjudning_1_N = mkN "cocktailbjudning" ; -- cocktailbjudning..nn.1
  cocktailbord_1_N = mkN "cocktailbord" neutrum  ; -- cocktailbord..nn.1
  cocktailbär_1_N = mkN "cocktailbär" neutrum  ; -- cocktailbär..nn.1
  cocktailglas_1_N = mkN "cocktailglas" neutrum  ; -- cocktailglas..nn.1
  cocktailmusik_1_N = mkN "cocktailmusik" ; -- cocktailmusik..nn.1
  cocktailparty_1_N = mkN "cocktailparty" "cocktailpartyt" "cocktailpartyn" "cocktailpartyna" ; -- cocktailparty..nn.1
  coda_1_N = mkN "coda" ; -- coda..nn.1
  codex_1_N = mkN "codex" ; -- codex..nn.1
  cointreau_1_N = mkN "cointreau" ; -- cointreau..nn.1
  coitus_1_N = mkN "coitus" ; -- coitus..nn.1
  cokacola_1_N = mkN "cokacola" ; -- cokacola..nn.1
  cokakola_1_N = mkN "cokakola" ; -- cokakola..nn.1
  cola_1_N = mkN "cola" ; -- cola..nn.1
  colibakterie_1_N = mkN "colibakterie" "colibakterier" ; -- colibakterie..nn.1
  collage_1_N = mkN "collage" "collaget" "collage" "collagen" ; -- collage..nn.1
  college_1_N = mkN "college" "colleget" "college" "collegen" ; -- college..nn.1
  collegeflicka_1_N = mkN "collegeflicka" ; -- collegeflicka..nn.1
  collegepojke_1_N = mkN "collegepojke" utrum  ; -- collegepojke..nn.1
  collegetröja_1_N = mkN "collegetröja" ; -- collegetröja..nn.1
  collie_1_N = mkN "collie" "collier" ; -- collie..nn.1
  collier_1_N = mkN "collier" "collierer" ; -- collier..nn.1
  cologne_1_N = mkN "cologne" "cologner" ; -- cologne..nn.1
  colombian_1_N = mkN "colombian" "colombianer" ; -- colombian..nn.1
  colombiansk_1_A = mkA "colombiansk" ; -- colombiansk..av.1
  colombianska_1_N = mkN "colombianska" ; -- colombianska..nn.1
  coltan_1_N = mkN "coltan" neutrum  ; -- coltan..nn.1
  come_back_1_N = mkN "come-back" "come-backer" ; -- come-back..nn.1
  comeback_1_N = mkN "comeback" "comebacker" ; -- comeback..nn.1
  commando_1_N = mkN "commando" "commandon" "commandos" "commandosarna" ; -- commando..nn.1
  commandotrupp_1_N = mkN "commandotrupp" "commandotrupper" ; -- commandotrupp..nn.1
  comorier_1_N = mkN "comorier" "comoriern" "comorier" "comorierna" ; -- comorier..nn.1
  comorisk_1_A = mkA "comorisk" ; -- comorisk..av.1
  comoriska_1_N = mkN "comoriska" ; -- comoriska..nn.1
  complet_1_N = mkN "complet" ; -- complet..nn.1
  conferencier_1_N = mkN "conferencier" "conferencierer" ; -- conferencier..nn.1
  conférencier_1_N = mkN "conférencier" "conférencierer" ; -- conférencier..nn.1
  consensus_1_N = mkN "consensus" ; -- consensus..nn.1
  consensuskultur_1_N = mkN "consensuskultur" "consensuskulturer" ; -- consensuskultur..nn.1
  consommé_1_N = mkN "consommé" "consomméer" ; -- consommé..nn.1
  container_1_N = mkN "container" ; -- container..nn.1
  containerfartyg_1_N = mkN "containerfartyg" neutrum  ; -- containerfartyg..nn.1
  contortatall_1_N = mkN "contortatall" ; -- contortatall..nn.1
  cool_1_A = mkA "cool" ; -- cool..av.1
  coolhet_1_N = mkN "coolhet" ; -- coolhet..nn.1
  copy_cat_1_N = mkN "copy-cat" "copy-caten" "copy-cats" "copy-catsarna" ; -- copy-cat..nn.1
  copycat_1_N = mkN "copycat" "copycaten" "copycats" "copycatsarna" ; -- copycat..nn.1
  copyright_1_N = mkN "copyright" ; -- copyright..nn.1
  copywriter_1_N = mkN "copywriter" "copywritern" "copywriters" "copywritersarna" ; -- copywriter..nn.1
  corioliskraft_1_N = mkN "corioliskraft" ; -- corioliskraft..nn.1
  cornichon_1_N = mkN "cornichon" "cornichonen" "cornichons" "cornichonerna" ; -- cornichon..nn.1
  coronacell_1_N = mkN "coronacell" "coronaceller" ; -- coronacell..nn.1
  corps_de_logi_1_N = mkN "corps-de-logi" "corps-de-logiet" "corps-de-logier" "corps-de-logierna" ; -- corps-de-logi..nn.1
  corpus_1_N = mkN "corpus" ; -- corpus..nn.1
  cortege_1_N = mkN "cortege" "corteger" ; -- cortege..nn.1
  cortex_1_N = mkN "cortex" ; -- cortex..nn.1
  cortical_1_A = mkA "cortical" ; -- cortical..av.1
  cortison_1_N = mkN "cortison" "cortisoner" ; -- cortison..nn.1
  cortisonbehandling_1_N = mkN "cortisonbehandling" ; -- cortisonbehandling..nn.1
  cortège_1_N = mkN "cortège" "cortèger" ; -- cortège..nn.1
  cosinus_1_N = mkN "cosinus" ; -- cosinus..nn.1
  costarican_1_N = mkN "costarican" "costaricaner" ; -- costarican..nn.1
  costaricansk_1_A = mkA "costaricansk" ; -- costaricansk..av.1
  costaricanska_1_N = mkN "costaricanska" ; -- costaricanska..nn.1
  cotangens_1_N = mkN "cotangens" ; -- cotangens..nn.1
  cotangent_1_N = mkN "cotangent" "cotangenter" ; -- cotangent..nn.1
  coulomb_1_N = mkN "coulomb" "coulomben" "coulomb" "coulomben" ; -- coulomb..nn.1
  countrymusik_1_N = mkN "countrymusik" ; -- countrymusik..nn.1
  countrysång_1_N = mkN "countrysång" "countrysånger" ; -- countrysång..nn.1
  coupe_1_N = mkN "coupe" "couper" ; -- coupe..nn.1
  couronne_1_N = mkN "couronne" ; -- couronne..nn.1
  courtage_1_N = mkN "courtage" ; -- courtage..nn.1
  cous_cous_1_N = mkN "cous-cous" ; -- cous-cous..nn.1
  couscous_1_N = mkN "couscous" ; -- couscous..nn.1
  cover_1_N = mkN "cover" "covern" "covers" "coversarna" ; -- cover..nn.1
  coverlåt_1_N = mkN "coverlåt" ; -- coverlåt..nn.1
  coverversion_1_N = mkN "coverversion" ; -- coverversion..nn.1
  covra_1_V = mkV "covrar" ; -- covra..vb.1
  cowboy_1_N = mkN "cowboy" "cowboyen" "cowboys" "cowboyerna" ; -- cowboy..nn.1
  cowboyhatt_1_N = mkN "cowboyhatt" ; -- cowboyhatt..nn.1
  coyote_1_N = mkN "coyote" "coyoter" ; -- coyote..nn.1
  cp_skadad_1_A = mkA "cp-skadad" ; -- cp-skadad..av.1
  crawl_1_N = mkN "crawl" ; -- crawl..nn.1
  crawla_1_V = mkV "crawlar" ; -- crawla..vb.1
  crawlande_1_N = mkN "crawlande" ; -- crawlande..nn.1
  crazy_1_A = mkA "crazy" ; -- crazy..av.1
  cred_1_N = mkN "cred" ; -- cred..nn.1
  credd_1_N = mkN "credd" ; -- credd..nn.1
  credo_1_N = mkN "credo" "credot" "credon" "credona" ; -- credo..nn.1
  creme_1_N = mkN "creme" "cremer" ; -- creme..nn.1
  creme_2_N = mkN "creme" ; -- creme..nn.2
  crepe_1_N = mkN "crepe" "creper" ; -- crepe..nn.1
  crescendo_1_N = mkN "crescendo" "crescendot" "crescendon" "crescendona" ; -- crescendo..nn.1
  cricket_1_N = mkN "cricket" ; -- cricket..nn.1
  cricketklubba_1_N = mkN "cricketklubba" ; -- cricketklubba..nn.1
  croissant_1_N = mkN "croissant" "croissanter" ; -- croissant..nn.1
  croquis_1_N = mkN "croquis" "croquiser" ; -- croquis..nn.1
  crosschecking_1_N = mkN "crosschecking" ; -- crosschecking..nn.1
  crosshandske_1_N = mkN "crosshandske" utrum  ; -- crosshandske..nn.1
  crosshjälm_1_N = mkN "crosshjälm" ; -- crosshjälm..nn.1
  croupier_1_N = mkN "croupier" "croupierer" ; -- croupier..nn.1
  crust_1_N = mkN "crust" ; -- crust..nn.1
  crème_de_la_crème_1_N = mkN "crème-de-la-crème" utrum  ; -- crème-de-la-crème..nn.1
  crème_1_N = mkN "crème" "crèmer" ; -- crème..nn.1
  crème_2_N = mkN "crème" ; -- crème..nn.2
  crèpe_1_N = mkN "crèpe" "crèper" ; -- crèpe..nn.1
  crêpe_1_N = mkN "crêpe" "crêper" ; -- crêpe..nn.1
  crêpegarn_1_N = mkN "crêpegarn" neutrum  ; -- crêpegarn..nn.1
  csardas_1_N = mkN "csardas" ; -- csardas..nn.1
  cuban_1_N = mkN "cuban" "cubaner" ; -- cuban..nn.1
  cubansk_1_A = mkA "cubansk" ; -- cubansk..av.1
  cumulus_1_N = mkN "cumulus" ; -- cumulus..nn.1
  cumuluscell_1_N = mkN "cumuluscell" "cumulusceller" ; -- cumuluscell..nn.1
  cumulusmoln_1_N = mkN "cumulusmoln" neutrum  ; -- cumulusmoln..nn.1
  cup_1_N = mkN "cup" "cuper" ; -- cup..nn.1
  curare_1_N = mkN "curare" ; -- curare..nn.1
  curatera_1_V = mkV "curaterar" ; -- curatera..vb.1
  curaterande_1_N = mkN "curaterande" ; -- curaterande..nn.1
  curaterbar_1_A = mkA "curaterbar" ; -- curaterbar..av.1
  curaterbarhet_1_N = mkN "curaterbarhet" ; -- curaterbarhet..nn.1
  curator_1_N = mkN "curator" "curatorer" ; -- curator..nn.1
  curaçao_1_N = mkN "curaçao" ; -- curaçao..nn.1
  curera_1_V = mkV "curerar" ; -- curera..vb.1
  curerande_1_N = mkN "curerande" ; -- curerande..nn.1
  curerbar_1_A = mkA "curerbar" ; -- curerbar..av.1
  curerbarhet_1_N = mkN "curerbarhet" ; -- curerbarhet..nn.1
  curia_1_N = mkN "curia" ; -- curia..nn.1
  curie_1_N = mkN "curie" "curien" "curie" "curiena" ; -- curie..nn.1
  curium_1_N = mkN "curium" neutrum  ; -- curium..nn.1
  curla_1_V = mkV "curlar" ; -- curla..vb.1
  curla_2_V = mkV "curlar" ; -- curla..vb.2
  curlande_1_N = mkN "curlande" ; -- curlande..nn.1
  curling_1_N = mkN "curling" ; -- curling..nn.1
  curlingbarn_1_N = mkN "curlingbarn" neutrum  ; -- curlingbarn..nn.1
  curlingfinal_1_N = mkN "curlingfinal" "curlingfinaler" ; -- curlingfinal..nn.1
  curlingförälder_1_N = mkN "curlingförälder" ; -- curlingförälder..nn.1
  curlingtävling_1_N = mkN "curlingtävling" ; -- curlingtävling..nn.1
  currygryta_1_N = mkN "currygryta" ; -- currygryta..nn.1
  cyan_1_N = mkN "cyan" ; -- cyan..nn.1
  cyanblå_1_A = mkA "cyanblå" "cyanblått" ; -- cyanblå..av.1
  cyanid_1_N = mkN "cyanid" "cyanider" ; -- cyanid..nn.1
  cyankalium_1_N = mkN "cyankalium" neutrum  ; -- cyankalium..nn.1
  cyanobakterie_1_N = mkN "cyanobakterie" "cyanobakterier" ; -- cyanobakterie..nn.1
  cyanos_1_N = mkN "cyanos" ; -- cyanos..nn.1
  cyanväte_1_N = mkN "cyanväte" ; -- cyanväte..nn.1
  cyanvätesyra_1_N = mkN "cyanvätesyra" ; -- cyanvätesyra..nn.1
  cyberbrottslighet_1_N = mkN "cyberbrottslighet" "cyberbrottsligheter" ; -- cyberbrottslighet..nn.1
  cybernetik_1_N = mkN "cybernetik" ; -- cybernetik..nn.1
  cybernetisk_1_A = mkA "cybernetisk" ; -- cybernetisk..av.1
  cyberrymd_1_N = mkN "cyberrymd" ; -- cyberrymd..nn.1
  cybersex_1_N = mkN "cybersex" neutrum  ; -- cybersex..nn.1
  cyberstrategi_1_N = mkN "cyberstrategi" "cyberstrategier" ; -- cyberstrategi..nn.1
  cybervärld_1_N = mkN "cybervärld" ; -- cybervärld..nn.1
  cybervåld_1_N = mkN "cybervåld" neutrum  ; -- cybervåld..nn.1
  cyborg_1_N = mkN "cyborg" "cyborger" ; -- cyborg..nn.1
  cykel_1_N = mkN "cykel" ; -- cykel..nn.1
  cykel_2_N = mkN "cykel" ; -- cykel..nn.2
  cykelbana_1_N = mkN "cykelbana" ; -- cykelbana..nn.1
  cykeldäck_1_N = mkN "cykeldäck" neutrum  ; -- cykeldäck..nn.1
  cykelergometer_1_N = mkN "cykelergometer" ; -- cykelergometer..nn.1
  cykelhjälm_1_N = mkN "cykelhjälm" ; -- cykelhjälm..nn.1
  cykelkedja_1_N = mkN "cykelkedja" ; -- cykelkedja..nn.1
  cykelklämma_1_N = mkN "cykelklämma" ; -- cykelklämma..nn.1
  cykelkrock_1_N = mkN "cykelkrock" ; -- cykelkrock..nn.1
  cykelkrok_1_N = mkN "cykelkrok" ; -- cykelkrok..nn.1
  cykellykta_1_N = mkN "cykellykta" ; -- cykellykta..nn.1
  cykellås_1_N = mkN "cykellås" neutrum  ; -- cykellås..nn.1
  cykelnyckel_1_N = mkN "cykelnyckel" ; -- cykelnyckel..nn.1
  cykelpump_1_N = mkN "cykelpump" ; -- cykelpump..nn.1
  cykelram_1_N = mkN "cykelram" ; -- cykelram..nn.1
  cykelsadel_1_N = mkN "cykelsadel" ; -- cykelsadel..nn.1
  cykelslang_1_N = mkN "cykelslang" ; -- cykelslang..nn.1
  cykelstyre_1_N = mkN "cykelstyre" ; -- cykelstyre..nn.1
  cykelställ_1_N = mkN "cykelställ" neutrum  ; -- cykelställ..nn.1
  cykelstöld_1_N = mkN "cykelstöld" "cykelstölder" ; -- cykelstöld..nn.1
  cykeltrupp_1_N = mkN "cykeltrupp" "cykeltrupper" ; -- cykeltrupp..nn.1
  cykeltävling_1_N = mkN "cykeltävling" ; -- cykeltävling..nn.1
  cykelutflykt_1_N = mkN "cykelutflykt" "cykelutflykter" ; -- cykelutflykt..nn.1
  cykelventil_1_N = mkN "cykelventil" "cykelventiler" ; -- cykelventil..nn.1
  cykelväg_1_N = mkN "cykelväg" ; -- cykelväg..nn.1
  cykelåkning_1_N = mkN "cykelåkning" ; -- cykelåkning..nn.1
  cykla_1_V = mkV "cyklar" ; -- cykla..vb.1
  cyklamat_1_N = mkN "cyklamat" ; -- cyklamat..nn.1
  cyklamen_1_N = mkN "cyklamen" "cyklamen" "cyklamer" "cyklamerna" ; -- cyklamen..nn.1
  cyklande_1_N = mkN "cyklande" ; -- cyklande..nn.1
  cykling_1_N = mkN "cykling" ; -- cykling..nn.1
  cyklisk_1_A = mkA "cyklisk" ; -- cyklisk..av.1
  cyklism_1_N = mkN "cyklism" "cyklismer" ; -- cyklism..nn.1
  cyklist_1_N = mkN "cyklist" "cyklister" ; -- cyklist..nn.1
  cykloid_1_N = mkN "cykloid" "cykloider" ; -- cykloid..nn.1
  cyklometer_1_N = mkN "cyklometer" ; -- cyklometer..nn.1
  cyklon_1_N = mkN "cyklon" "cykloner" ; -- cyklon..nn.1
  cyklonartad_1_A = mkA "cyklonartad" ; -- cyklonartad..av.1
  cyklonfamilj_1_N = mkN "cyklonfamilj" "cyklonfamiljer" ; -- cyklonfamilj..nn.1
  cyklop_1_N = mkN "cyklop" "cykloper" ; -- cyklop..nn.1
  cyklop_2_N = mkN "cyklop" neutrum  ; -- cyklop..nn.2
  cyklopisk_1_A = mkA "cyklopisk" ; -- cyklopisk..av.1
  cyklopöga_1_N = mkN "cyklopöga" "cyklopögat" "cyklopögon" "cyklopögonen" ; -- cyklopöga..nn.1
  cyklotron_1_N = mkN "cyklotron" "cyklotroner" ; -- cyklotron..nn.1
  cyklotym_1_A = mkA "cyklotym" ; -- cyklotym..av.1
  cylinder_1_N = mkN "cylinder" ; -- cylinder..nn.1
  cylinderblock_1_N = mkN "cylinderblock" neutrum  ; -- cylinderblock..nn.1
  cylinderform_1_N = mkN "cylinderform" "cylinderformer" ; -- cylinderform..nn.1
  cylinderformad_1_A = mkA "cylinderformad" ; -- cylinderformad..av.1
  cylinderglas_1_N = mkN "cylinderglas" neutrum  ; -- cylinderglas..nn.1
  cylinderhatt_1_N = mkN "cylinderhatt" ; -- cylinderhatt..nn.1
  cylinderlås_1_N = mkN "cylinderlås" neutrum  ; -- cylinderlås..nn.1
  cylinderpress_1_N = mkN "cylinderpress" ; -- cylinderpress..nn.1
  cylinderur_1_N = mkN "cylinderur" neutrum  ; -- cylinderur..nn.1
  cylindrisk_1_A = mkA "cylindrisk" ; -- cylindrisk..av.1
  cymbal_1_N = mkN "cymbal" "cymbaler" ; -- cymbal..nn.1
  cymbalklang_1_N = mkN "cymbalklang" "cymbalklanger" ; -- cymbalklang..nn.1
  cyniker_1_N = mkN "cyniker" "cynikern" "cyniker" "cynikerna" ; -- cyniker..nn.1
  cynisk_1_A = mkA "cynisk" ; -- cynisk..av.1
  cynism_1_N = mkN "cynism" "cynismer" ; -- cynism..nn.1
  cypress_1_N = mkN "cypress" "cypresser" ; -- cypress..nn.1
  cypresskrans_1_N = mkN "cypresskrans" ; -- cypresskrans..nn.1
  cypriot_1_N = mkN "cypriot" "cyprioter" ; -- cypriot..nn.1
  cypriotisk_1_A = mkA "cypriotisk" ; -- cypriotisk..av.1
  cypriotiska_1_N = mkN "cypriotiska" ; -- cypriotiska..nn.1
  cysta_1_N = mkN "cysta" ; -- cysta..nn.1
  cystoskop_1_N = mkN "cystoskop" neutrum  ; -- cystoskop..nn.1
  cystoskopi_1_N = mkN "cystoskopi" "cystoskopier" ; -- cystoskopi..nn.1
  cytologi_1_N = mkN "cytologi" ; -- cytologi..nn.1
  cytologisk_1_A = mkA "cytologisk" ; -- cytologisk..av.1
  cytoplasma_1_N = mkN "cytoplasma" ; -- cytoplasma..nn.1
  dadaism_1_N = mkN "dadaism" "dadaismer" ; -- dadaism..nn.1
  dadaist_1_N = mkN "dadaist" "dadaister" ; -- dadaist..nn.1
  dadaistisk_1_A = mkA "dadaistisk" ; -- dadaistisk..av.1
  dadda_1_N = mkN "dadda" ; -- dadda..nn.1
  dadda_1_V = mkV "daddar" ; -- dadda..vb.1
  daddande_1_N = mkN "daddande" ; -- daddande..nn.1
  dadel_1_N = mkN "dadel" ; -- dadel..nn.1
  dadelpalm_1_N = mkN "dadelpalm" "dadelpalmer" ; -- dadelpalm..nn.1
  dag_1_N = mkN "dag" ; -- dag..nn.1
  dagakarl_1_N = mkN "dagakarl" ; -- dagakarl..nn.1
  dagaktiv_1_A = mkA "dagaktiv" ; -- dagaktiv..av.1
  dagavdelning_1_N = mkN "dagavdelning" ; -- dagavdelning..nn.1
  dagbarn_1_N = mkN "dagbarn" neutrum  ; -- dagbarn..nn.1
  dagbarnvårdare_1_N = mkN "dagbarnvårdare" utrum  ; -- dagbarnvårdare..nn.1
  dagbefäl_1_N = mkN "dagbefäl" neutrum  ; -- dagbefäl..nn.1
  dagblad_1_N = mkN "dagblad" neutrum  ; -- dagblad..nn.1
  dagblind_1_A = mkA "dagblind" ; -- dagblind..av.1
  dagblindhet_1_N = mkN "dagblindhet" ; -- dagblindhet..nn.1
  dagbok_1_N = mkN "dagbok" "dagböcker" ; -- dagbok..nn.1
  dagboksanteckning_1_N = mkN "dagboksanteckning" ; -- dagboksanteckning..nn.1
  dagboksskrivande_1_A = mkA "dagboksskrivande" ; -- dagboksskrivande..av.1
  dagboksskrivande_1_N = mkN "dagboksskrivande" ; -- dagboksskrivande..nn.1
  dagbrott_1_N = mkN "dagbrott" neutrum  ; -- dagbrott..nn.1
  dagbrytning_1_N = mkN "dagbrytning" ; -- dagbrytning..nn.1
  dagbräckning_1_N = mkN "dagbräckning" ; -- dagbräckning..nn.1
  dagcentral_1_N = mkN "dagcentral" "dagcentraler" ; -- dagcentral..nn.1
  dagcentrum_1_N = mkN "dagcentrum" neutrum  ; -- dagcentrum..nn.1
  dagdjur_1_N = mkN "dagdjur" neutrum  ; -- dagdjur..nn.1
  dagdrivare_1_N = mkN "dagdrivare" utrum  ; -- dagdrivare..nn.1
  dagdrivarliv_1_N = mkN "dagdrivarliv" neutrum  ; -- dagdrivarliv..nn.1
  dagdriveri_1_N = mkN "dagdriveri" neutrum  ; -- dagdriveri..nn.1
  dagdröm_1_N = mkN "dagdröm" "dagdrömmen" "dagdrömmar" "dagdrömmarna" ; -- dagdröm..nn.1
  dagdrömma_1_V = mkV "dagdrömmer" ; -- dagdrömma..vb.1
  dagdrömmande_1_N = mkN "dagdrömmande" ; -- dagdrömmande..nn.1
  dagdrömmare_1_N = mkN "dagdrömmare" utrum  ; -- dagdrömmare..nn.1
  dagdrömmeri_1_N = mkN "dagdrömmeri" "dagdrömmeriet" "dagdrömmerier" "dagdrömmerierna" ; -- dagdrömmeri..nn.1
  dagenefterhuvudvärk_1_N = mkN "dagenefterhuvudvärk" ; -- dagenefterhuvudvärk..nn.1
  dagenefterpiller_1_N = mkN "dagenefterpiller" neutrum  ; -- dagenefterpiller..nn.1
  dagenefterstämning_1_N = mkN "dagenefterstämning" ; -- dagenefterstämning..nn.1
  dagens_1_N = mkN "dagens" ; -- dagens..nn.1
  dager_1_N = mkN "dager" ; -- dager..nn.1
  dagerrotyp_1_N = mkN "dagerrotyp" "dagerrotyper" ; -- dagerrotyp..nn.1
  dagerrotypi_1_N = mkN "dagerrotypi" "dagerrotypier" ; -- dagerrotypi..nn.1
  dagfjäril_1_N = mkN "dagfjäril" ; -- dagfjäril..nn.1
  dagg_1_N = mkN "dagg" ; -- dagg..nn.1
  dagg_2_N = mkN "dagg" ; -- dagg..nn.2
  dagga_1_V = mkV "daggar" ; -- dagga..vb.1
  daggande_1_N = mkN "daggande" ; -- daggande..nn.1
  daggdroppe_1_N = mkN "daggdroppe" utrum  ; -- daggdroppe..nn.1
  daggert_1_N = mkN "daggert" ; -- daggert..nn.1
  daggfrisk_1_A = mkA "daggfrisk" ; -- daggfrisk..av.1
  daggig_1_A = mkA "daggig" ; -- daggig..av.1
  daggighet_1_N = mkN "daggighet" ; -- daggighet..nn.1
  daggkåpa_1_N = mkN "daggkåpa" ; -- daggkåpa..nn.1
  daggmask_1_N = mkN "daggmask" ; -- daggmask..nn.1
  daggpunkt_1_N = mkN "daggpunkt" "daggpunkter" ; -- daggpunkt..nn.1
  daggryning_1_N = mkN "daggryning" ; -- daggryning..nn.1
  daggvåt_1_A = mkA "daggvåt" ; -- daggvåt..av.1
  daghavande_1_A = mkA "daghavande" ; -- daghavande..av.1
  daghavande_1_N = mkN "daghavande" "daghavanden" "daghavanden" "daghavandena" ; -- daghavande..nn.1
  daghem_1_N = mkN "daghem" "daghemmet" "daghem" "daghemmen" ; -- daghem..nn.1
  daghemsföreståndare_1_N = mkN "daghemsföreståndare" utrum  ; -- daghemsföreståndare..nn.1
  daghemsplats_1_N = mkN "daghemsplats" "daghemsplatser" ; -- daghemsplats..nn.1
  dagis_1_N = mkN "dagis" neutrum  ; -- dagis..nn.1
  dagisfröken_1_N = mkN "dagisfröken" ; -- dagisfröken..nn.1
  dagisplats_1_N = mkN "dagisplats" "dagisplatser" ; -- dagisplats..nn.1
  dagjämning_1_N = mkN "dagjämning" ; -- dagjämning..nn.1
  dagjämningspunkt_1_N = mkN "dagjämningspunkt" ; -- dagjämningspunkt..nn.1
  dagkarl_1_N = mkN "dagkarl" ; -- dagkarl..nn.1
  dagledig_1_A = mkA "dagledig" ; -- dagledig..av.1
  daglega_1_N = mkN "daglega" ; -- daglega..nn.1
  daglig_1_A = mkA "daglig" ; -- daglig..av.1
  dagligdags_1_Adv = mkAdv "dagligdags" ; -- dagligdags..ab.1
  dagligen_1_Adv = mkAdv "dagligen" ; -- dagligen..ab.1
  daglighet_1_N = mkN "daglighet" ; -- daglighet..nn.1
  dagligstuga_1_N = mkN "dagligstuga" ; -- dagligstuga..nn.1
  dagligvara_1_N = mkN "dagligvara" ; -- dagligvara..nn.1
  daglön_1_N = mkN "daglön" "daglöner" ; -- daglön..nn.1
  daglönare_1_N = mkN "daglönare" utrum  ; -- daglönare..nn.1
  dagmamma_1_N = mkN "dagmamma" ; -- dagmamma..nn.1
  dagning_1_N = mkN "dagning" ; -- dagning..nn.1
  dago_1_N = mkN "dago" "dagon" "dagos" "dagosarna" ; -- dago..nn.1
  dagofficer_1_N = mkN "dagofficer" "dagofficeren" "dagofficerare" "dagofficerarna" ; -- dagofficer..nn.1
  dagorder_1_N = mkN "dagorder" ; -- dagorder..nn.1
  dagordning_1_N = mkN "dagordning" ; -- dagordning..nn.1
  dagort_1_N = mkN "dagort" "dagorter" ; -- dagort..nn.1
  dagpenning_1_N = mkN "dagpenning" ; -- dagpenning..nn.1
  dagrum_1_N = mkN "dagrum" "dagrummet" "dagrum" "dagrummen" ; -- dagrum..nn.1
  dags_1_N = mkN "dags" ; -- dags..nn.1
  dagsaktuell_1_A = mkA "dagsaktuell" ; -- dagsaktuell..av.1
  dagsbehov_1_N = mkN "dagsbehov" neutrum  ; -- dagsbehov..nn.1
  dagsbot_1_N = mkN "dagsbot" "dagsböter" ; -- dagsbot..nn.1
  dagsedel_1_N = mkN "dagsedel" ; -- dagsedel..nn.1
  dagsfärsk_1_A = mkA "dagsfärsk" ; -- dagsfärsk..av.1
  dagshetta_1_N = mkN "dagshetta" ; -- dagshetta..nn.1
  dagskassa_1_N = mkN "dagskassa" ; -- dagskassa..nn.1
  dagskryssning_1_N = mkN "dagskryssning" ; -- dagskryssning..nn.1
  dagskrönika_1_N = mkN "dagskrönika" ; -- dagskrönika..nn.1
  dagsled_1_N = mkN "dagsled" "dagsleder" ; -- dagsled..nn.1
  dagsljus_1_N = mkN "dagsljus" neutrum  ; -- dagsljus..nn.1
  dagsläge_1_N = mkN "dagsläge" ; -- dagsläge..nn.1
  dagslända_1_N = mkN "dagslända" ; -- dagslända..nn.1
  dagsländeliv_1_N = mkN "dagsländeliv" neutrum  ; -- dagsländeliv..nn.1
  dagslång_1_A = mkA "dagslång" ; -- dagslång..av.1
  dagsmarsch_1_N = mkN "dagsmarsch" "dagsmarscher" ; -- dagsmarsch..nn.1
  dagsmeja_1_N = mkN "dagsmeja" ; -- dagsmeja..nn.1
  dagsnyhet_1_N = mkN "dagsnyhet" "dagsnyheter" ; -- dagsnyhet..nn.1
  dagspenning_1_N = mkN "dagspenning" ; -- dagspenning..nn.1
  dagspolitisk_1_A = mkA "dagspolitisk" ; -- dagspolitisk..av.1
  dagspress_1_N = mkN "dagspress" ; -- dagspress..nn.1
  dagsprogram_1_N = mkN "dagsprogram" "dagsprogrammet" "dagsprogram" "dagsprogrammen" ; -- dagsprogram..nn.1
  dagsranson_1_N = mkN "dagsranson" "dagsransoner" ; -- dagsranson..nn.1
  dagsregn_1_N = mkN "dagsregn" neutrum  ; -- dagsregn..nn.1
  dagsresa_1_N = mkN "dagsresa" ; -- dagsresa..nn.1
  dagstemperatur_1_N = mkN "dagstemperatur" "dagstemperaturer" ; -- dagstemperatur..nn.1
  dagstidning_1_N = mkN "dagstidning" ; -- dagstidning..nn.1
  dagstidningsredaktör_1_N = mkN "dagstidningsredaktör" "dagstidningsredaktörer" ; -- dagstidningsredaktör..nn.1
  dagsverkare_1_N = mkN "dagsverkare" utrum  ; -- dagsverkare..nn.1
  dagsverke_1_N = mkN "dagsverke" ; -- dagsverke..nn.1
  dagsvers_1_N = mkN "dagsvers" "dagsverser" ; -- dagsvers..nn.1
  dagsversskribent_1_N = mkN "dagsversskribent" "dagsversskribenter" ; -- dagsversskribent..nn.1
  dagsvärde_1_N = mkN "dagsvärde" ; -- dagsvärde..nn.1
  dagteckna_1_V = mkV "dagtecknar" ; -- dagteckna..vb.1
  dagtecknande_1_N = mkN "dagtecknande" ; -- dagtecknande..nn.1
  dagteckning_1_N = mkN "dagteckning" ; -- dagteckning..nn.1
  dagtid_1_N = mkN "dagtid" "dagtider" ; -- dagtid..nn.1
  dagtinga_1_V = mkV "dagtingar" ; -- dagtinga..vb.1
  dagtingande_1_N = mkN "dagtingande" ; -- dagtingande..nn.1
  dagtraktamente_1_N = mkN "dagtraktamente" ; -- dagtraktamente..nn.1
  dagtåg_1_N = mkN "dagtåg" neutrum  ; -- dagtåg..nn.1
  dagvakt_1_N = mkN "dagvakt" "dagvakter" ; -- dagvakt..nn.1
  dagvatten_1_N = mkN "dagvatten" "dagvattnet" "dagvatten" "dagvattnen" ; -- dagvatten..nn.1
  dagvill_1_A = mkA "dagvill" ; -- dagvill..av.1
  dagvillhet_1_N = mkN "dagvillhet" ; -- dagvillhet..nn.1
  dagvård_1_N = mkN "dagvård" ; -- dagvård..nn.1
  dagöppning_1_N = mkN "dagöppning" ; -- dagöppning..nn.1
  dahlia_1_N = mkN "dahlia" ; -- dahlia..nn.1
  dakapo_1_N = mkN "dakapo" "dakapot" "dakapon" "dakapona" ; -- dakapo..nn.1
  daktyl_1_N = mkN "daktyl" "daktyler" ; -- daktyl..nn.1
  daktylisk_1_A = mkA "daktylisk" ; -- daktylisk..av.1
  dal_1_N = mkN "dal" ; -- dal..nn.1
  dala_1_V = mkV "dalar" ; -- dala..vb.1
  dalahäst_1_N = mkN "dalahäst" ; -- dalahäst..nn.1
  dalamässig_1_A = mkA "dalamässig" ; -- dalamässig..av.1
  dalande_1_N = mkN "dalande" ; -- dalande..nn.1
  dalbo_1_N = mkN "dalbo" "dalbor" ; -- dalbo..nn.1
  dalbotten_1_N = mkN "dalbotten" ; -- dalbotten..nn.1
  daldans_1_N = mkN "daldans" "daldanser" ; -- daldans..nn.1
  daler_1_N = mkN "daler" "dalern" "daler" "dalerna" ; -- daler..nn.1
  dalgång_1_N = mkN "dalgång" ; -- dalgång..nn.1
  dalj_1_N = mkN "dalj" neutrum  ; -- dalj..nn.1
  dalkarl_1_N = mkN "dalkarl" ; -- dalkarl..nn.1
  dalkjusa_1_N = mkN "dalkjusa" ; -- dalkjusa..nn.1
  dalkulla_1_N = mkN "dalkulla" ; -- dalkulla..nn.1
  daller_1_N = mkN "daller" neutrum  ; -- daller..nn.1
  dallergräs_1_N = mkN "dallergräs" neutrum  ; -- dallergräs..nn.1
  dallra_1_V = mkV "dallrar" ; -- dallra..vb.1
  dallrande_1_N = mkN "dallrande" ; -- dallrande..nn.1
  dallring_1_N = mkN "dallring" ; -- dallring..nn.1
  dalmas_1_N = mkN "dalmas" ; -- dalmas..nn.1
  dalmatiner_1_N = mkN "dalmatiner" "dalmatinern" "dalmatiner" "dalmatinerna" ; -- dalmatiner..nn.1
  dalmål_1_N = mkN "dalmål" neutrum  ; -- dalmål..nn.1
  dalmålning_1_N = mkN "dalmålning" ; -- dalmålning..nn.1
  dalning_1_N = mkN "dalning" ; -- dalning..nn.1
  dalprofil_1_N = mkN "dalprofil" "dalprofiler" ; -- dalprofil..nn.1
  dalripa_1_N = mkN "dalripa" ; -- dalripa..nn.1
  dalsk_1_A = mkA "dalsk" ; -- dalsk..av.1
  dalska_1_N = mkN "dalska" ; -- dalska..nn.1
  dalskida_1_N = mkN "dalskida" ; -- dalskida..nn.1
  dalsluttning_1_N = mkN "dalsluttning" ; -- dalsluttning..nn.1
  dalsländsk_1_A = mkA "dalsländsk" ; -- dalsländsk..av.1
  dalsländska_1_N = mkN "dalsländska" ; -- dalsländska..nn.1
  dalsländska_2_N = mkN "dalsländska" ; -- dalsländska..nn.2
  dalslänning_1_N = mkN "dalslänning" ; -- dalslänning..nn.1
  dalsänka_1_N = mkN "dalsänka" ; -- dalsänka..nn.1
  dalt_1_N = mkN "dalt" neutrum  ; -- dalt..nn.1
  dalta_1_V = mkV "daltar" ; -- dalta..vb.1
  daltande_1_N = mkN "daltande" ; -- daltande..nn.1
  dalvind_1_N = mkN "dalvind" ; -- dalvind..nn.1
  dam_1_N = mkN "dam" "damer" ; -- dam..nn.1
  dam_2_N = mkN "dam" ; -- dam..nn.2
  damask_1_N = mkN "damask" "damasker" ; -- damask..nn.1
  damaskenerklinga_1_N = mkN "damaskenerklinga" ; -- damaskenerklinga..nn.1
  damaskenerstål_1_N = mkN "damaskenerstål" neutrum  ; -- damaskenerstål..nn.1
  damaskering_1_N = mkN "damaskering" ; -- damaskering..nn.1
  damast_1_N = mkN "damast" "damaster" ; -- damast..nn.1
  damastduk_1_N = mkN "damastduk" ; -- damastduk..nn.1
  damastservett_1_N = mkN "damastservett" "damastservetter" ; -- damastservett..nn.1
  dambesök_1_N = mkN "dambesök" neutrum  ; -- dambesök..nn.1
  dambinda_1_N = mkN "dambinda" ; -- dambinda..nn.1
  dambjudning_1_N = mkN "dambjudning" ; -- dambjudning..nn.1
  dambricka_1_N = mkN "dambricka" ; -- dambricka..nn.1
  dambräde_1_N = mkN "dambräde" ; -- dambräde..nn.1
  damcykel_1_N = mkN "damcykel" ; -- damcykel..nn.1
  damejeanne_1_N = mkN "damejeanne" "damejeanner" ; -- damejeanne..nn.1
  damfotboll_1_N = mkN "damfotboll" ; -- damfotboll..nn.1
  damfrisering_1_N = mkN "damfrisering" ; -- damfrisering..nn.1
  damfrisör_1_N = mkN "damfrisör" "damfrisörer" ; -- damfrisör..nn.1
  damfrisörska_1_N = mkN "damfrisörska" ; -- damfrisörska..nn.1
  damgambit_1_N = mkN "damgambit" ; -- damgambit..nn.1
  damhandske_1_N = mkN "damhandske" utrum  ; -- damhandske..nn.1
  damhatt_1_N = mkN "damhatt" ; -- damhatt..nn.1
  damig_1_A = mkA "damig" ; -- damig..av.1
  damkonfektion_1_N = mkN "damkonfektion" ; -- damkonfektion..nn.1
  damkör_1_N = mkN "damkör" "damkörer" ; -- damkör..nn.1
  damlag_1_N = mkN "damlag" neutrum  ; -- damlag..nn.1
  damlandslag_1_N = mkN "damlandslag" neutrum  ; -- damlandslag..nn.1
  damm_1_N = mkN "damm" ; -- damm..nn.1
  damm_2_N = mkN "damm" neutrum  ; -- damm..nn.2
  damma_1_V = mkV "dammar" ; -- damma..vb.1
  damma_2_V = mkV "dammar" ; -- damma..vb.2
  dammande_1_N = mkN "dammande" ; -- dammande..nn.1
  dammanläggning_1_N = mkN "dammanläggning" ; -- dammanläggning..nn.1
  dammbindningsmedel_1_N = mkN "dammbindningsmedel" neutrum  ; -- dammbindningsmedel..nn.1
  dammbygge_1_N = mkN "dammbygge" ; -- dammbygge..nn.1
  dammfri_1_A = mkA "dammfri" "dammfritt" ; -- dammfri..av.1
  dammfäste_1_N = mkN "dammfäste" ; -- dammfäste..nn.1
  dammförsök_1_N = mkN "dammförsök" neutrum  ; -- dammförsök..nn.1
  dammgömma_1_N = mkN "dammgömma" ; -- dammgömma..nn.1
  dammig_1_A = mkA "dammig" ; -- dammig..av.1
  dammighet_1_N = mkN "dammighet" ; -- dammighet..nn.1
  dammkorn_1_N = mkN "dammkorn" neutrum  ; -- dammkorn..nn.1
  dammkvalster_1_N = mkN "dammkvalster" neutrum  ; -- dammkvalster..nn.1
  dammlager_1_N = mkN "dammlager" neutrum  ; -- dammlager..nn.1
  dammlucka_1_N = mkN "dammlucka" ; -- dammlucka..nn.1
  dammlunga_1_N = mkN "dammlunga" ; -- dammlunga..nn.1
  dammode_1_N = mkN "dammode" ; -- dammode..nn.1
  dammodell_1_N = mkN "dammodell" "dammodeller" ; -- dammodell..nn.1
  dammoln_1_N = mkN "dammoln" neutrum  ; -- dammoln..nn.1
  dammport_1_N = mkN "dammport" ; -- dammport..nn.1
  dammpump_1_N = mkN "dammpump" ; -- dammpump..nn.1
  dammråtta_1_N = mkN "dammråtta" ; -- dammråtta..nn.1
  dammspiral_1_N = mkN "dammspiral" "dammspiraler" ; -- dammspiral..nn.1
  dammsuga_1_V = mkV "dammsuga" "dammsög" "dammsugit" ; -- dammsuga..vb.1
  dammsugande_1_N = mkN "dammsugande" ; -- dammsugande..nn.1
  dammsugaragent_1_N = mkN "dammsugaragent" "dammsugaragenter" ; -- dammsugaragent..nn.1
  dammsugare_1_N = mkN "dammsugare" utrum  ; -- dammsugare..nn.1
  dammsugarförsäljning_1_N = mkN "dammsugarförsäljning" ; -- dammsugarförsäljning..nn.1
  dammsugarpåse_1_N = mkN "dammsugarpåse" utrum  ; -- dammsugarpåse..nn.1
  dammsugning_1_N = mkN "dammsugning" ; -- dammsugning..nn.1
  dammsäkerhet_1_N = mkN "dammsäkerhet" ; -- dammsäkerhet..nn.1
  dammtorka_1_V = mkV "dammtorkar" ; -- dammtorka..vb.1
  dammtorkande_1_N = mkN "dammtorkande" ; -- dammtorkande..nn.1
  dammtrasa_1_N = mkN "dammtrasa" ; -- dammtrasa..nn.1
  dammussla_1_N = mkN "dammussla" ; -- dammussla..nn.1
  dammvippa_1_N = mkN "dammvippa" ; -- dammvippa..nn.1
  dammvirvel_1_N = mkN "dammvirvel" ; -- dammvirvel..nn.1
  damning_1_N = mkN "damning" ; -- damning..nn.1
  damoklessvärd_1_N = mkN "damoklessvärd" neutrum  ; -- damoklessvärd..nn.1
  dampa_1_V = mkV "dampar" ; -- dampa..vb.1
  dampa_2_V = mkV "dampar" ; -- dampa..vb.2
  dampande_1_N = mkN "dampande" ; -- dampande..nn.1
  dampjäs_1_N = mkN "dampjäs" "dampjäser" ; -- dampjäs..nn.1
  damrum_1_N = mkN "damrum" "damrummet" "damrum" "damrummen" ; -- damrum..nn.1
  damsida_1_N = mkN "damsida" ; -- damsida..nn.1
  damsingel_1_N = mkN "damsingel" ; -- damsingel..nn.1
  damskjorta_1_N = mkN "damskjorta" ; -- damskjorta..nn.1
  damsko_1_N = mkN "damsko" "damskor" ; -- damsko..nn.1
  damslalom_1_N = mkN "damslalom" ; -- damslalom..nn.1
  damspel_1_N = mkN "damspel" "damspelet" "damspel" "damspelen" ; -- damspel..nn.1
  damstrumpa_1_N = mkN "damstrumpa" ; -- damstrumpa..nn.1
  damsällskap_1_N = mkN "damsällskap" neutrum  ; -- damsällskap..nn.1
  damtidning_1_N = mkN "damtidning" ; -- damtidning..nn.1
  damtoalett_1_N = mkN "damtoalett" "damtoaletter" ; -- damtoalett..nn.1
  damur_1_N = mkN "damur" neutrum  ; -- damur..nn.1
  damväska_1_N = mkN "damväska" ; -- damväska..nn.1
  dan_1_A = mkA "dan" ; -- dan..av.1
  dana_1_V = mkV "danar" ; -- dana..vb.1
  danaarv_1_N = mkN "danaarv" neutrum  ; -- danaarv..nn.1
  danad_1_A = mkA "danad" ; -- danad..av.1
  danande_1_N = mkN "danande" ; -- danande..nn.1
  danare_1_N = mkN "danare" utrum  ; -- danare..nn.1
  dandy_1_N = mkN "dandy" "dandyn" "dandysar" "dandysarna" ; -- dandy..nn.1
  dangla_1_V = mkV "danglar" ; -- dangla..vb.1
  danglande_1_N = mkN "danglande" ; -- danglande..nn.1
  daning_1_N = mkN "daning" ; -- daning..nn.1
  danism_1_N = mkN "danism" "danismer" ; -- danism..nn.1
  dank_1_N = mkN "dank" ; -- dank..nn.1
  dann_1_A = mkA "dann" ; -- dann..av.1
  danneman_1_N = mkN "danneman" "dannemannen" "dannemän" "dannemännen" ; -- danneman..nn.1
  dans_1_N = mkN "dans" "danser" ; -- dans..nn.1
  dansa_1_V = mkV "dansar" ; -- dansa..vb.1
  dansande_1_N = mkN "dansande" ; -- dansande..nn.1
  dansant_1_A = mkA "dansant" "dansant" ; -- dansant..av.1
  dansare_1_N = mkN "dansare" utrum  ; -- dansare..nn.1
  dansbana_1_N = mkN "dansbana" ; -- dansbana..nn.1
  dansband_1_N = mkN "dansband" neutrum  ; -- dansband..nn.1
  dansbandskultur_1_N = mkN "dansbandskultur" "dansbandskulturer" ; -- dansbandskultur..nn.1
  dansbandsvecka_1_N = mkN "dansbandsvecka" ; -- dansbandsvecka..nn.1
  dansbaneelände_1_N = mkN "dansbaneelände" ; -- dansbaneelände..nn.1
  danserska_1_N = mkN "danserska" ; -- danserska..nn.1
  dansförbud_1_N = mkN "dansförbud" neutrum  ; -- dansförbud..nn.1
  dansgille_1_N = mkN "dansgille" ; -- dansgille..nn.1
  dansgolv_1_N = mkN "dansgolv" neutrum  ; -- dansgolv..nn.1
  dansgolvslejon_1_N = mkN "dansgolvslejon" neutrum  ; -- dansgolvslejon..nn.1
  danshak_1_N = mkN "danshak" neutrum  ; -- danshak..nn.1
  dansk_1_A = mkA "dansk" ; -- dansk..av.1
  dansk_1_N = mkN "dansk" ; -- dansk..nn.1
  danska_1_N = mkN "danska" ; -- danska..nn.1
  danska_2_N = mkN "danska" ; -- danska..nn.2
  danskhat_1_N = mkN "danskhat" neutrum  ; -- danskhat..nn.1
  danskhet_1_N = mkN "danskhet" ; -- danskhet..nn.1
  danskonst_1_N = mkN "danskonst" "danskonster" ; -- danskonst..nn.1
  dansktalande_1_A = mkA "dansktalande" ; -- dansktalande..av.1
  danskägd_1_A = mkA "danskägd" "danskägt" ; -- danskägd..av.1
  dansledare_1_N = mkN "dansledare" utrum  ; -- dansledare..nn.1
  danslek_1_N = mkN "danslek" ; -- danslek..nn.1
  danslektion_1_N = mkN "danslektion" ; -- danslektion..nn.1
  danslysten_1_A = mkA "danslysten" ; -- danslysten..av.1
  dansmusik_1_N = mkN "dansmusik" ; -- dansmusik..nn.1
  dansmässig_1_A = mkA "dansmässig" ; -- dansmässig..av.1
  dansmästare_1_N = mkN "dansmästare" utrum  ; -- dansmästare..nn.1
  dansorkester_1_N = mkN "dansorkester" ; -- dansorkester..nn.1
  dansrestaurang_1_N = mkN "dansrestaurang" "dansrestauranger" ; -- dansrestaurang..nn.1
  dansrytm_1_N = mkN "dansrytm" "dansrytmer" ; -- dansrytm..nn.1
  danssalong_1_N = mkN "danssalong" "danssalonger" ; -- danssalong..nn.1
  danssjuka_1_N = mkN "danssjuka" ; -- danssjuka..nn.1
  danssko_1_N = mkN "danssko" "dansskor" ; -- danssko..nn.1
  dansskola_1_N = mkN "dansskola" ; -- dansskola..nn.1
  danssteg_1_N = mkN "danssteg" neutrum  ; -- danssteg..nn.1
  dansställe_1_N = mkN "dansställe" ; -- dansställe..nn.1
  danstakt_1_N = mkN "danstakt" "danstakter" ; -- danstakt..nn.1
  danstillställning_1_N = mkN "danstillställning" ; -- danstillställning..nn.1
  dansundervisning_1_N = mkN "dansundervisning" ; -- dansundervisning..nn.1
  dansvimmel_1_N = mkN "dansvimmel" neutrum  ; -- dansvimmel..nn.1
  dansvänlig_1_A = mkA "dansvänlig" ; -- dansvänlig..av.1
  dansör_1_N = mkN "dansör" "dansörer" ; -- dansör..nn.1
  dansös_1_N = mkN "dansös" "dansöser" ; -- dansös..nn.1
  darr_1_N = mkN "darr" neutrum  ; -- darr..nn.1
  darra_1_V = mkV "darrar" ; -- darra..vb.1
  darrande_1_A = mkA "darrande" ; -- darrande..av.1
  darrande_1_N = mkN "darrande" ; -- darrande..nn.1
  darrgräs_1_N = mkN "darrgräs" neutrum  ; -- darrgräs..nn.1
  darrhänt_1_A = mkA "darrhänt" "darrhänt" ; -- darrhänt..av.1
  darrhänthet_1_N = mkN "darrhänthet" ; -- darrhänthet..nn.1
  darrig_1_A = mkA "darrig" ; -- darrig..av.1
  darrighet_1_N = mkN "darrighet" ; -- darrighet..nn.1
  darrning_1_N = mkN "darrning" ; -- darrning..nn.1
  darrocka_1_N = mkN "darrocka" ; -- darrocka..nn.1
  darrål_1_N = mkN "darrål" ; -- darrål..nn.1
  dart_1_N = mkN "dart" ; -- dart..nn.1
  dartpil_1_N = mkN "dartpil" ; -- dartpil..nn.1
  dartspel_1_N = mkN "dartspel" "dartspelet" "dartspel" "dartspelen" ; -- dartspel..nn.1
  darttavla_1_N = mkN "darttavla" ; -- darttavla..nn.1
  darwinfink_1_N = mkN "darwinfink" ; -- darwinfink..nn.1
  darwinism_1_N = mkN "darwinism" "darwinismer" ; -- darwinism..nn.1
  darwinist_1_N = mkN "darwinist" "darwinister" ; -- darwinist..nn.1
  darwinistisk_1_A = mkA "darwinistisk" ; -- darwinistisk..av.1
  dask_1_N = mkN "dask" neutrum  ; -- dask..nn.1
  daska_1_V = mkV "daskar" ; -- daska..vb.1
  daskande_1_N = mkN "daskande" ; -- daskande..nn.1
  daskig_1_A = mkA "daskig" ; -- daskig..av.1
  daskighet_1_N = mkN "daskighet" ; -- daskighet..nn.1
  dass_1_N = mkN "dass" neutrum  ; -- dass..nn.1
  dassa_1_V = mkV "dassar" ; -- dassa..vb.1
  dassande_1_N = mkN "dassande" ; -- dassande..nn.1
  dassig_1_A = mkA "dassig" ; -- dassig..av.1
  dassighet_1_N = mkN "dassighet" ; -- dassighet..nn.1
  dasspapper_1_N = mkN "dasspapper" neutrum  ; -- dasspapper..nn.1
  dat_1_N = mkN "dat" "dater" ; -- dat..nn.1
  data_1_N = mkN "data" "datat" "data" "datana" ; -- data..nn.1
  data_2_N = mkN "data" ; -- data..nn.2
  dataanläggning_1_N = mkN "dataanläggning" ; -- dataanläggning..nn.1
  databank_1_N = mkN "databank" "databanker" ; -- databank..nn.1
  databas_1_N = mkN "databas" "databaser" ; -- databas..nn.1
  databearbetning_1_N = mkN "databearbetning" ; -- databearbetning..nn.1
  databehandla_1_V = mkV "databehandlar" ; -- databehandla..vb.1
  databehandlande_1_N = mkN "databehandlande" ; -- databehandlande..nn.1
  databehandling_1_N = mkN "databehandling" ; -- databehandling..nn.1
  datacentral_1_N = mkN "datacentral" "datacentraler" ; -- datacentral..nn.1
  datafil_1_N = mkN "datafil" "datafiler" ; -- datafil..nn.1
  dataformat_1_N = mkN "dataformat" neutrum  ; -- dataformat..nn.1
  datahackare_1_N = mkN "datahackare" utrum  ; -- datahackare..nn.1
  datahaveri_1_N = mkN "datahaveri" "datahaveriet" "datahaverier" "datahaverierna" ; -- datahaveri..nn.1
  datainsamling_1_N = mkN "datainsamling" ; -- datainsamling..nn.1
  datainsamlingskampanj_1_N = mkN "datainsamlingskampanj" "datainsamlingskampanjer" ; -- datainsamlingskampanj..nn.1
  dataintensiv_1_A = mkA "dataintensiv" ; -- dataintensiv..av.1
  dataintrång_1_N = mkN "dataintrång" neutrum  ; -- dataintrång..nn.1
  dataintrångsskandal_1_N = mkN "dataintrångsskandal" "dataintrångsskandaler" ; -- dataintrångsskandal..nn.1
  datakommunikation_1_N = mkN "datakommunikation" ; -- datakommunikation..nn.1
  datakraft_1_N = mkN "datakraft" ; -- datakraft..nn.1
  datakrasch_1_N = mkN "datakrasch" "datakrascher" ; -- datakrasch..nn.1
  datakörning_1_N = mkN "datakörning" ; -- datakörning..nn.1
  datalagring_1_N = mkN "datalagring" ; -- datalagring..nn.1
  datalagringsdirektiv_1_N = mkN "datalagringsdirektiv" neutrum  ; -- datalagringsdirektiv..nn.1
  datalagringsföretag_1_N = mkN "datalagringsföretag" neutrum  ; -- datalagringsföretag..nn.1
  datalingvistik_1_N = mkN "datalingvistik" ; -- datalingvistik..nn.1
  datalogi_1_N = mkN "datalogi" ; -- datalogi..nn.1
  datamaskin_1_N = mkN "datamaskin" "datamaskiner" ; -- datamaskin..nn.1
  datamaskinell_1_A = mkA "datamaskinell" ; -- datamaskinell..av.1
  datamaterial_1_N = mkN "datamaterial" neutrum  ; -- datamaterial..nn.1
  dataminne_1_N = mkN "dataminne" ; -- dataminne..nn.1
  datamängd_1_N = mkN "datamängd" "datamängder" ; -- datamängd..nn.1
  datanät_1_N = mkN "datanät" neutrum  ; -- datanät..nn.1
  datapolitik_1_N = mkN "datapolitik" ; -- datapolitik..nn.1
  datapolitisk_1_A = mkA "datapolitisk" ; -- datapolitisk..av.1
  dataprogram_1_N = mkN "dataprogram" "dataprogrammet" "dataprogram" "dataprogrammen" ; -- dataprogram..nn.1
  dataregister_1_N = mkN "dataregister" neutrum  ; -- dataregister..nn.1
  datasimulering_1_N = mkN "datasimulering" ; -- datasimulering..nn.1
  dataskärm_1_N = mkN "dataskärm" ; -- dataskärm..nn.1
  dataspel_1_N = mkN "dataspel" "dataspelet" "dataspel" "dataspelen" ; -- dataspel..nn.1
  datasystem_1_N = mkN "datasystem" neutrum  ; -- datasystem..nn.1
  dataterminal_1_N = mkN "dataterminal" "dataterminaler" ; -- dataterminal..nn.1
  datautbyte_1_N = mkN "datautbyte" ; -- datautbyte..nn.1
  datautbytesöverenskommelse_1_N = mkN "datautbytesöverenskommelse" "datautbytesöverenskommelser" ; -- datautbytesöverenskommelse..nn.1
  datavirus_1_N = mkN "datavirus" neutrum  ; -- datavirus..nn.1
  datavision_1_N = mkN "datavision" ; -- datavision..nn.1
  date_1_N = mkN "date" "dater" ; -- date..nn.1
  datera_1_V = mkV "daterar" ; -- datera..vb.1
  daterande_1_N = mkN "daterande" ; -- daterande..nn.1
  daterbar_1_A = mkA "daterbar" ; -- daterbar..av.1
  daterbarhet_1_N = mkN "daterbarhet" ; -- daterbarhet..nn.1
  datering_1_N = mkN "datering" ; -- datering..nn.1
  dateringsmetod_1_N = mkN "dateringsmetod" "dateringsmetoder" ; -- dateringsmetod..nn.1
  dativ_1_N = mkN "dativ" "dativer" ; -- dativ..nn.1
  dativform_1_N = mkN "dativform" "dativformer" ; -- dativform..nn.1
  dativobjekt_1_N = mkN "dativobjekt" neutrum  ; -- dativobjekt..nn.1
  dato_1_N = mkN "dato" ; -- dato..nn.1
  dator_1_N = mkN "dator" "datorer" ; -- dator..nn.1
  datoradress_1_N = mkN "datoradress" "datoradresser" ; -- datoradress..nn.1
  datoranimera_1_V = mkV "datoranimerar" ; -- datoranimera..vb.1
  datoranimerad_1_A = mkA "datoranimerad" ; -- datoranimerad..av.1
  datoranimerande_1_N = mkN "datoranimerande" ; -- datoranimerande..nn.1
  datoranimering_1_N = mkN "datoranimering" ; -- datoranimering..nn.1
  datoranläggning_1_N = mkN "datoranläggning" ; -- datoranläggning..nn.1
  datorbaserad_1_A = mkA "datorbaserad" ; -- datorbaserad..av.1
  datorbearbetning_1_N = mkN "datorbearbetning" ; -- datorbearbetning..nn.1
  datorbehandling_1_N = mkN "datorbehandling" ; -- datorbehandling..nn.1
  datorberäkning_1_N = mkN "datorberäkning" ; -- datorberäkning..nn.1
  datordrift_1_N = mkN "datordrift" ; -- datordrift..nn.1
  datorfodral_1_N = mkN "datorfodral" neutrum  ; -- datorfodral..nn.1
  datorförsäljning_1_N = mkN "datorförsäljning" ; -- datorförsäljning..nn.1
  datorhaveri_1_N = mkN "datorhaveri" "datorhaveriet" "datorhaverier" "datorhaverierna" ; -- datorhaveri..nn.1
  datorintrång_1_N = mkN "datorintrång" neutrum  ; -- datorintrång..nn.1
  datorisera_1_V = mkV "datoriserar" ; -- datorisera..vb.1
  datoriserande_1_N = mkN "datoriserande" ; -- datoriserande..nn.1
  datoriserbar_1_A = mkA "datoriserbar" ; -- datoriserbar..av.1
  datoriserbarhet_1_N = mkN "datoriserbarhet" ; -- datoriserbarhet..nn.1
  datorisering_1_N = mkN "datorisering" ; -- datorisering..nn.1
  datorkommunikation_1_N = mkN "datorkommunikation" ; -- datorkommunikation..nn.1
  datorkraft_1_N = mkN "datorkraft" ; -- datorkraft..nn.1
  datorlingvistik_1_N = mkN "datorlingvistik" ; -- datorlingvistik..nn.1
  datorminne_1_N = mkN "datorminne" ; -- datorminne..nn.1
  datormodell_1_N = mkN "datormodell" "datormodeller" ; -- datormodell..nn.1
  datormässa_1_N = mkN "datormässa" ; -- datormässa..nn.1
  datorprogram_1_N = mkN "datorprogram" "datorprogrammet" "datorprogram" "datorprogrammen" ; -- datorprogram..nn.1
  datorprogrammerare_1_N = mkN "datorprogrammerare" utrum  ; -- datorprogrammerare..nn.1
  datorrelaterad_1_A = mkA "datorrelaterad" ; -- datorrelaterad..av.1
  datorsimulera_1_V = mkV "datorsimulerar" ; -- datorsimulera..vb.1
  datorsimulerande_1_N = mkN "datorsimulerande" ; -- datorsimulerande..nn.1
  datorsimulering_1_N = mkN "datorsimulering" ; -- datorsimulering..nn.1
  datorskärm_1_N = mkN "datorskärm" ; -- datorskärm..nn.1
  datorsladd_1_N = mkN "datorsladd" ; -- datorsladd..nn.1
  datorstöd_1_N = mkN "datorstöd" neutrum  ; -- datorstöd..nn.1
  datorsystem_1_N = mkN "datorsystem" neutrum  ; -- datorsystem..nn.1
  datortelefon_1_N = mkN "datortelefon" "datortelefoner" ; -- datortelefon..nn.1
  datortomografi_1_N = mkN "datortomografi" "datortomografier" ; -- datortomografi..nn.1
  datorutrustning_1_N = mkN "datorutrustning" ; -- datorutrustning..nn.1
  datorvirus_1_N = mkN "datorvirus" neutrum  ; -- datorvirus..nn.1
  datorväxel_1_N = mkN "datorväxel" ; -- datorväxel..nn.1
  datta_1_V = mkV "dattar" ; -- datta..vb.1
  dattande_1_N = mkN "dattande" ; -- dattande..nn.1
  datten_1_N = mkN "datten" ; -- datten..nn.1
  datum_1_N = mkN "datum" ; -- datum..nn.1
  datumgräns_1_N = mkN "datumgräns" "datumgränser" ; -- datumgräns..nn.1
  datummärka_1_V = mkV "datummärker" ; -- datummärka..vb.1
  datummärkande_1_N = mkN "datummärkande" ; -- datummärkande..nn.1
  datummärkning_1_N = mkN "datummärkning" ; -- datummärkning..nn.1
  datumparkera_1_V = mkV "datumparkerar" ; -- datumparkera..vb.1
  datumparkerande_1_N = mkN "datumparkerande" ; -- datumparkerande..nn.1
  datumparkerbar_1_A = mkA "datumparkerbar" ; -- datumparkerbar..av.1
  datumparkerbarhet_1_N = mkN "datumparkerbarhet" ; -- datumparkerbarhet..nn.1
  datumparkering_1_N = mkN "datumparkering" ; -- datumparkering..nn.1
  datumstämpel_1_N = mkN "datumstämpel" ; -- datumstämpel..nn.1
  datumvisare_1_N = mkN "datumvisare" utrum  ; -- datumvisare..nn.1
  davidsstjärna_1_N = mkN "davidsstjärna" ; -- davidsstjärna..nn.1
  deadline_1_N = mkN "deadline" utrum  ; -- deadline..nn.1
  deaktivera_1_V = mkV "deaktiverar" ; -- deaktivera..vb.1
  deaktiverande_1_N = mkN "deaktiverande" ; -- deaktiverande..nn.1
  deaktiverbar_1_A = mkA "deaktiverbar" ; -- deaktiverbar..av.1
  deaktiverbarhet_1_N = mkN "deaktiverbarhet" ; -- deaktiverbarhet..nn.1
  deaktivering_1_N = mkN "deaktivering" ; -- deaktivering..nn.1
  debacle_1_N = mkN "debacle" "debaclet" "debacle" "debaclen" ; -- debacle..nn.1
  debarkera_1_V = mkV "debarkerar" ; -- debarkera..vb.1
  debarkerande_1_N = mkN "debarkerande" ; -- debarkerande..nn.1
  debarkerbar_1_A = mkA "debarkerbar" ; -- debarkerbar..av.1
  debarkerbarhet_1_N = mkN "debarkerbarhet" ; -- debarkerbarhet..nn.1
  debarkering_1_N = mkN "debarkering" ; -- debarkering..nn.1
  debatt_1_N = mkN "debatt" "debatter" ; -- debatt..nn.1
  debattartikel_1_N = mkN "debattartikel" ; -- debattartikel..nn.1
  debattdeltagare_1_N = mkN "debattdeltagare" utrum  ; -- debattdeltagare..nn.1
  debattera_1_V = mkV "debatterar" ; -- debattera..vb.1
  debatterande_1_N = mkN "debatterande" ; -- debatterande..nn.1
  debatterbar_1_A = mkA "debatterbar" ; -- debatterbar..av.1
  debatterbarhet_1_N = mkN "debatterbarhet" ; -- debatterbarhet..nn.1
  debattering_1_N = mkN "debattering" ; -- debattering..nn.1
  debattforum_1_N = mkN "debattforum" neutrum  ; -- debattforum..nn.1
  debattinlägg_1_N = mkN "debattinlägg" neutrum  ; -- debattinlägg..nn.1
  debattknep_1_N = mkN "debattknep" neutrum  ; -- debattknep..nn.1
  debattmässig_1_A = mkA "debattmässig" ; -- debattmässig..av.1
  debattprogram_1_N = mkN "debattprogram" "debattprogrammet" "debattprogram" "debattprogrammen" ; -- debattprogram..nn.1
  debattsida_1_N = mkN "debattsida" ; -- debattsida..nn.1
  debattör_1_N = mkN "debattör" "debattörer" ; -- debattör..nn.1
  debet_1_N = mkN "debet" ; -- debet..nn.1
  debetsedel_1_N = mkN "debetsedel" ; -- debetsedel..nn.1
  debetsida_1_N = mkN "debetsida" ; -- debetsida..nn.1
  debetsumma_1_N = mkN "debetsumma" ; -- debetsumma..nn.1
  debil_1_A = mkA "debil" ; -- debil..av.1
  debilitet_1_N = mkN "debilitet" "debiliteter" ; -- debilitet..nn.1
  debit_1_N = mkN "debit" "debiter" ; -- debit..nn.1
  debitera_1_V = mkV "debiterar" ; -- debitera..vb.1
  debiterande_1_N = mkN "debiterande" ; -- debiterande..nn.1
  debiterbar_1_A = mkA "debiterbar" ; -- debiterbar..av.1
  debiterbarhet_1_N = mkN "debiterbarhet" ; -- debiterbarhet..nn.1
  debitering_1_N = mkN "debitering" ; -- debitering..nn.1
  debut_1_N = mkN "debut" "debuter" ; -- debut..nn.1
  debutalbum_1_N = mkN "debutalbum" neutrum  ; -- debutalbum..nn.1
  debutant_1_N = mkN "debutant" "debutanter" ; -- debutant..nn.1
  debutbok_1_N = mkN "debutbok" "debutböcker" ; -- debutbok..nn.1
  debutera_1_V = mkV "debuterar" ; -- debutera..vb.1
  debuterande_1_N = mkN "debuterande" ; -- debuterande..nn.1
  debutering_1_N = mkN "debutering" ; -- debutering..nn.1
  debutroman_1_N = mkN "debutroman" "debutromaner" ; -- debutroman..nn.1
  december_1_N = mkN "december" ; -- december..nn.1
  decemberkväll_1_N = mkN "decemberkväll" ; -- decemberkväll..nn.1
  decennium_1_N = mkN "decennium" "decenniet" "decennier" "decennierna" ; -- decennium..nn.1
  decentralisation_1_N = mkN "decentralisation" ; -- decentralisation..nn.1
  decentralisera_1_V = mkV "decentraliserar" ; -- decentralisera..vb.1
  decentraliserande_1_N = mkN "decentraliserande" ; -- decentraliserande..nn.1
  decentraliserbar_1_A = mkA "decentraliserbar" ; -- decentraliserbar..av.1
  decentraliserbarhet_1_N = mkN "decentraliserbarhet" ; -- decentraliserbarhet..nn.1
  decentralisering_1_N = mkN "decentralisering" ; -- decentralisering..nn.1
  decharge_1_N = mkN "decharge" "decharger" ; -- decharge..nn.1
  dechargedebatt_1_N = mkN "dechargedebatt" "dechargedebatter" ; -- dechargedebatt..nn.1
  dechiffrera_1_V = mkV "dechiffrerar" ; -- dechiffrera..vb.1
  dechiffrerande_1_N = mkN "dechiffrerande" ; -- dechiffrerande..nn.1
  dechiffrerbar_1_A = mkA "dechiffrerbar" ; -- dechiffrerbar..av.1
  dechiffrerbarhet_1_N = mkN "dechiffrerbarhet" ; -- dechiffrerbarhet..nn.1
  dechiffrering_1_N = mkN "dechiffrering" ; -- dechiffrering..nn.1
  decibel_1_N = mkN "decibel" "decibelen" "decibel" "decibelen" ; -- decibel..nn.1
  deciderad_1_A = mkA "deciderad" ; -- deciderad..av.1
  deciliter_1_N = mkN "deciliter" "decilitern" "deciliter" "deciliterna" ; -- deciliter..nn.1
  decilitermått_1_N = mkN "decilitermått" neutrum  ; -- decilitermått..nn.1
  decimal_1_N = mkN "decimal" "decimaler" ; -- decimal..nn.1
  decimalbråk_1_N = mkN "decimalbråk" neutrum  ; -- decimalbråk..nn.1
  decimalkomma_1_N = mkN "decimalkomma" "decimalkommat" "decimalkomman" "decimalkommana" ; -- decimalkomma..nn.1
  decimalsystem_1_N = mkN "decimalsystem" neutrum  ; -- decimalsystem..nn.1
  decimaltal_1_N = mkN "decimaltal" neutrum  ; -- decimaltal..nn.1
  decimaltecken_1_N = mkN "decimaltecken" "decimaltecknet" "decimaltecken" "decimaltecknen" ; -- decimaltecken..nn.1
  decimera_1_V = mkV "decimerar" ; -- decimera..vb.1
  decimerande_1_N = mkN "decimerande" ; -- decimerande..nn.1
  decimerbar_1_A = mkA "decimerbar" ; -- decimerbar..av.1
  decimerbarhet_1_N = mkN "decimerbarhet" ; -- decimerbarhet..nn.1
  decimering_1_N = mkN "decimering" ; -- decimering..nn.1
  decimeter_1_N = mkN "decimeter" ; -- decimeter..nn.1
  decimeterlång_1_A = mkA "decimeterlång" ; -- decimeterlång..av.1
  decimeterstor_1_A = mkA "decimeterstor" ; -- decimeterstor..av.1
  deciton_1_N = mkN "deciton" "decitonnet" "deciton" "decitonnen" ; -- deciton..nn.1
  deckardrottning_1_N = mkN "deckardrottning" ; -- deckardrottning..nn.1
  deckare_1_N = mkN "deckare" utrum  ; -- deckare..nn.1
  deckarförfattare_1_N = mkN "deckarförfattare" utrum  ; -- deckarförfattare..nn.1
  deckarkung_1_N = mkN "deckarkung" ; -- deckarkung..nn.1
  dedicera_1_V = mkV "dedicerar" ; -- dedicera..vb.1
  dedicerande_1_N = mkN "dedicerande" ; -- dedicerande..nn.1
  dedicerbar_1_A = mkA "dedicerbar" ; -- dedicerbar..av.1
  dedicerbarhet_1_N = mkN "dedicerbarhet" ; -- dedicerbarhet..nn.1
  dedicering_1_N = mkN "dedicering" ; -- dedicering..nn.1
  dedikation_1_N = mkN "dedikation" ; -- dedikation..nn.1
  dedikationsexemplar_1_N = mkN "dedikationsexemplar" neutrum  ; -- dedikationsexemplar..nn.1
  dedikera_1_V = mkV "dedikerar" ; -- dedikera..vb.1
  dedikerande_1_N = mkN "dedikerande" ; -- dedikerande..nn.1
  dedikerbar_1_A = mkA "dedikerbar" ; -- dedikerbar..av.1
  dedikerbarhet_1_N = mkN "dedikerbarhet" ; -- dedikerbarhet..nn.1
  dedikering_1_N = mkN "dedikering" ; -- dedikering..nn.1
  deducera_1_V = mkV "deducerar" ; -- deducera..vb.1
  deducerande_1_N = mkN "deducerande" ; -- deducerande..nn.1
  deducerbar_1_A = mkA "deducerbar" ; -- deducerbar..av.1
  deducerbarhet_1_N = mkN "deducerbarhet" ; -- deducerbarhet..nn.1
  deducering_1_N = mkN "deducering" ; -- deducering..nn.1
  deduktion_1_N = mkN "deduktion" ; -- deduktion..nn.1
  deduktiv_1_A = mkA "deduktiv" ; -- deduktiv..av.1
  defaitism_1_N = mkN "defaitism" "defaitismer" ; -- defaitism..nn.1
  defaitist_1_N = mkN "defaitist" "defaitister" ; -- defaitist..nn.1
  defaitistisk_1_A = mkA "defaitistisk" ; -- defaitistisk..av.1
  defekt_1_A = mkA "defekt" "defekt" ; -- defekt..av.1
  defekt_1_N = mkN "defekt" "defekter" ; -- defekt..nn.1
  defenestrera_1_V = mkV "defenestrerar" ; -- defenestrera..vb.1
  defenestrerande_1_N = mkN "defenestrerande" ; -- defenestrerande..nn.1
  defenestrering_1_N = mkN "defenestrering" ; -- defenestrering..nn.1
  defensiv_1_A = mkA "defensiv" ; -- defensiv..av.1
  defensiv_1_N = mkN "defensiv" ; -- defensiv..nn.1
  defibrillator_1_N = mkN "defibrillator" "defibrillatorer" ; -- defibrillator..nn.1
  deficit_1_N = mkN "deficit" neutrum  ; -- deficit..nn.1
  defilera_1_V = mkV "defilerar" ; -- defilera..vb.1
  defilerande_1_N = mkN "defilerande" ; -- defilerande..nn.1
  defilerbar_1_A = mkA "defilerbar" ; -- defilerbar..av.1
  defilerbarhet_1_N = mkN "defilerbarhet" ; -- defilerbarhet..nn.1
  defilering_1_N = mkN "defilering" ; -- defilering..nn.1
  defilé_1_N = mkN "defilé" "defiléer" ; -- defilé..nn.1
  definiera_1_V = mkV "definierar" ; -- definiera..vb.1
  definierande_1_N = mkN "definierande" ; -- definierande..nn.1
  definierbar_1_A = mkA "definierbar" ; -- definierbar..av.1
  definierbarhet_1_N = mkN "definierbarhet" ; -- definierbarhet..nn.1
  definiering_1_N = mkN "definiering" ; -- definiering..nn.1
  definit_1_A = mkA "definit" "definit" ; -- definit..av.1
  definithet_1_N = mkN "definithet" ; -- definithet..nn.1
  definition_1_N = mkN "definition" ; -- definition..nn.1
  definitionsmängd_1_N = mkN "definitionsmängd" "definitionsmängder" ; -- definitionsmängd..nn.1
  definitionsmässig_1_A = mkA "definitionsmässig" ; -- definitionsmässig..av.1
  definitionsmässighet_1_N = mkN "definitionsmässighet" ; -- definitionsmässighet..nn.1
  definitiv_1_A = mkA "definitiv" ; -- definitiv..av.1
  deflagration_1_N = mkN "deflagration" ; -- deflagration..nn.1
  deflation_1_N = mkN "deflation" ; -- deflation..nn.1
  defloration_1_N = mkN "defloration" ; -- defloration..nn.1
  deflorera_1_V = mkV "deflorerar" ; -- deflorera..vb.1
  deflorerande_1_N = mkN "deflorerande" ; -- deflorerande..nn.1
  deflorerbar_1_A = mkA "deflorerbar" ; -- deflorerbar..av.1
  deflorerbarhet_1_N = mkN "deflorerbarhet" ; -- deflorerbarhet..nn.1
  deflorering_1_N = mkN "deflorering" ; -- deflorering..nn.1
  deformation_1_N = mkN "deformation" ; -- deformation..nn.1
  deformera_1_V = mkV "deformerar" ; -- deformera..vb.1
  deformerande_1_N = mkN "deformerande" ; -- deformerande..nn.1
  deformerbar_1_A = mkA "deformerbar" ; -- deformerbar..av.1
  deformerbarhet_1_N = mkN "deformerbarhet" ; -- deformerbarhet..nn.1
  deformering_1_N = mkN "deformering" ; -- deformering..nn.1
  deformitet_1_N = mkN "deformitet" "deformiteter" ; -- deformitet..nn.1
  defroster_1_N = mkN "defroster" ; -- defroster..nn.1
  deg_1_N = mkN "deg" ; -- deg..nn.1
  deg_2_N = mkN "deg" ; -- deg..nn.2
  dega_1_V = mkV "degar" ; -- dega..vb.1
  degande_1_N = mkN "degande" ; -- degande..nn.1
  degartad_1_A = mkA "degartad" ; -- degartad..av.1
  degel_1_N = mkN "degel" ; -- degel..nn.1
  degeneration_1_N = mkN "degeneration" ; -- degeneration..nn.1
  degenerativ_1_A = mkA "degenerativ" ; -- degenerativ..av.1
  degenerera_1_V = mkV "degenererar" ; -- degenerera..vb.1
  degenererande_1_N = mkN "degenererande" ; -- degenererande..nn.1
  degenererbar_1_A = mkA "degenererbar" ; -- degenererbar..av.1
  degenererbarhet_1_N = mkN "degenererbarhet" ; -- degenererbarhet..nn.1
  degenerering_1_N = mkN "degenerering" ; -- degenerering..nn.1
  degig_1_A = mkA "degig" ; -- degig..av.1
  deglaciation_1_N = mkN "deglaciation" ; -- deglaciation..nn.1
  dego_1_N = mkN "dego" "degon" "degos" "degosarna" ; -- dego..nn.1
  degradation_1_N = mkN "degradation" ; -- degradation..nn.1
  degradera_1_V = mkV "degraderar" ; -- degradera..vb.1
  degraderande_1_N = mkN "degraderande" ; -- degraderande..nn.1
  degraderbar_1_A = mkA "degraderbar" ; -- degraderbar..av.1
  degraderbarhet_1_N = mkN "degraderbarhet" ; -- degraderbarhet..nn.1
  degradering_1_N = mkN "degradering" ; -- degradering..nn.1
  degrand_1_N = mkN "degrand" "degränder" ; -- degrand..nn.1
  degression_1_N = mkN "degression" ; -- degression..nn.1
  degspad_1_N = mkN "degspad" neutrum  ; -- degspad..nn.1
  degspade_1_N = mkN "degspade" utrum  ; -- degspade..nn.1
  degustera_1_V = mkV "degusterar" ; -- degustera..vb.1
  degusterande_1_N = mkN "degusterande" ; -- degusterande..nn.1
  degustering_1_N = mkN "degustering" ; -- degustering..nn.1
  deiktisk_1_A = mkA "deiktisk" ; -- deiktisk..av.1
  deism_1_N = mkN "deism" "deismer" ; -- deism..nn.1
  deist_1_N = mkN "deist" "deister" ; -- deist..nn.1
  deistisk_1_A = mkA "deistisk" ; -- deistisk..av.1
  deja_1_N = mkN "deja" ; -- deja..nn.1
  dejlig_1_A = mkA "dejlig" ; -- dejlig..av.1
  dejlighet_1_N = mkN "dejlighet" ; -- dejlighet..nn.1
  dejsa_1_V = mkV "dejsar" ; -- dejsa..vb.1
  dejsande_1_N = mkN "dejsande" ; -- dejsande..nn.1
  dejt_1_N = mkN "dejt" ; -- dejt..nn.1
  dejta_1_V = mkV "dejtar" ; -- dejta..vb.1
  dejtande_1_N = mkN "dejtande" ; -- dejtande..nn.1
  dejting_1_N = mkN "dejting" ; -- dejting..nn.1
  dejtingsajt_1_N = mkN "dejtingsajt" "dejtingsajter" ; -- dejtingsajt..nn.1
  dejtingtips_1_N = mkN "dejtingtips" neutrum  ; -- dejtingtips..nn.1
  dekad_1_N = mkN "dekad" "dekader" ; -- dekad..nn.1
  dekadans_1_N = mkN "dekadans" ; -- dekadans..nn.1
  dekadens_1_N = mkN "dekadens" ; -- dekadens..nn.1
  dekadent_1_A = mkA "dekadent" "dekadent" ; -- dekadent..av.1
  dekadisk_1_A = mkA "dekadisk" ; -- dekadisk..av.1
  dekal_1_N = mkN "dekal" "dekaler" ; -- dekal..nn.1
  dekalkomani_1_N = mkN "dekalkomani" ; -- dekalkomani..nn.1
  dekalog_1_N = mkN "dekalog" ; -- dekalog..nn.1
  dekan_1_N = mkN "dekan" "dekaner" ; -- dekan..nn.1
  dekanat_1_N = mkN "dekanat" neutrum  ; -- dekanat..nn.1
  dekantera_1_V = mkV "dekanterar" ; -- dekantera..vb.1
  dekanterande_1_N = mkN "dekanterande" ; -- dekanterande..nn.1
  dekanterbar_1_A = mkA "dekanterbar" ; -- dekanterbar..av.1
  dekanterbarhet_1_N = mkN "dekanterbarhet" ; -- dekanterbarhet..nn.1
  dekantering_1_N = mkN "dekantering" ; -- dekantering..nn.1
  dekanus_1_N = mkN "dekanus" ; -- dekanus..nn.1
  dekapitera_1_V = mkV "dekapiterar" ; -- dekapitera..vb.1
  dekapiterande_1_N = mkN "dekapiterande" ; -- dekapiterande..nn.1
  dekapiterbar_1_A = mkA "dekapiterbar" ; -- dekapiterbar..av.1
  dekapiterbarhet_1_N = mkN "dekapiterbarhet" ; -- dekapiterbarhet..nn.1
  dekapitering_1_N = mkN "dekapitering" ; -- dekapitering..nn.1
  deklamation_1_N = mkN "deklamation" ; -- deklamation..nn.1
  deklamatorisk_1_A = mkA "deklamatorisk" ; -- deklamatorisk..av.1
  deklamatör_1_N = mkN "deklamatör" "deklamatörer" ; -- deklamatör..nn.1
  deklamera_1_V = mkV "deklamerar" ; -- deklamera..vb.1
  deklamerande_1_N = mkN "deklamerande" ; -- deklamerande..nn.1
  deklamerbar_1_A = mkA "deklamerbar" ; -- deklamerbar..av.1
  deklamerbarhet_1_N = mkN "deklamerbarhet" ; -- deklamerbarhet..nn.1
  deklamering_1_N = mkN "deklamering" ; -- deklamering..nn.1
  deklarant_1_N = mkN "deklarant" "deklaranter" ; -- deklarant..nn.1
  deklaration_1_N = mkN "deklaration" ; -- deklaration..nn.1
  deklarationsblankett_1_N = mkN "deklarationsblankett" "deklarationsblanketter" ; -- deklarationsblankett..nn.1
  deklarationsdags_1_N = mkN "deklarationsdags" ; -- deklarationsdags..nn.1
  deklarera_1_V = mkV "deklarerar" ; -- deklarera..vb.1
  deklarerande_1_N = mkN "deklarerande" ; -- deklarerande..nn.1
  deklarerbar_1_A = mkA "deklarerbar" ; -- deklarerbar..av.1
  deklarerbarhet_1_N = mkN "deklarerbarhet" ; -- deklarerbarhet..nn.1
  deklarering_1_N = mkN "deklarering" ; -- deklarering..nn.1
  deklassera_1_V = mkV "deklasserar" ; -- deklassera..vb.1
  deklasserande_1_N = mkN "deklasserande" ; -- deklasserande..nn.1
  deklasserbar_1_A = mkA "deklasserbar" ; -- deklasserbar..av.1
  deklasserbarhet_1_N = mkN "deklasserbarhet" ; -- deklasserbarhet..nn.1
  deklassering_1_N = mkN "deklassering" ; -- deklassering..nn.1
  deklination_1_N = mkN "deklination" ; -- deklination..nn.1
  deklinationsnål_1_N = mkN "deklinationsnål" ; -- deklinationsnål..nn.1
  deklinera_1_V = mkV "deklinerar" ; -- deklinera..vb.1
  deklinerande_1_N = mkN "deklinerande" ; -- deklinerande..nn.1
  deklinerbar_1_A = mkA "deklinerbar" ; -- deklinerbar..av.1
  deklinerbarhet_1_N = mkN "deklinerbarhet" ; -- deklinerbarhet..nn.1
  deklinering_1_N = mkN "deklinering" ; -- deklinering..nn.1
  dekokt_1_N = mkN "dekokt" "dekokter" ; -- dekokt..nn.1
  dekolletage_1_N = mkN "dekolletage" "dekolletaget" "dekolletage" "dekolletagen" ; -- dekolletage..nn.1
  dekolleterad_1_A = mkA "dekolleterad" ; -- dekolleterad..av.1
  dekolletering_1_N = mkN "dekolletering" ; -- dekolletering..nn.1
  dekomposition_1_N = mkN "dekomposition" ; -- dekomposition..nn.1
  dekompression_1_N = mkN "dekompression" ; -- dekompression..nn.1
  dekor_1_N = mkN "dekor" "dekoren" "dekorer" "dekorerna" ; -- dekor..nn.1
  dekoration_1_N = mkN "dekoration" ; -- dekoration..nn.1
  dekorationsbrasa_1_N = mkN "dekorationsbrasa" ; -- dekorationsbrasa..nn.1
  dekorationsgran_1_N = mkN "dekorationsgran" ; -- dekorationsgran..nn.1
  dekorationslist_1_N = mkN "dekorationslist" "dekorationslister" ; -- dekorationslist..nn.1
  dekorationsmålare_1_N = mkN "dekorationsmålare" utrum  ; -- dekorationsmålare..nn.1
  dekorationsmålning_1_N = mkN "dekorationsmålning" ; -- dekorationsmålning..nn.1
  dekorativ_1_A = mkA "dekorativ" ; -- dekorativ..av.1
  dekoratör_1_N = mkN "dekoratör" "dekoratörer" ; -- dekoratör..nn.1
  dekorera_1_V = mkV "dekorerar" ; -- dekorera..vb.1
  dekorerande_1_N = mkN "dekorerande" ; -- dekorerande..nn.1
  dekorerbar_1_A = mkA "dekorerbar" ; -- dekorerbar..av.1
  dekorerbarhet_1_N = mkN "dekorerbarhet" ; -- dekorerbarhet..nn.1
  dekorering_1_N = mkN "dekorering" ; -- dekorering..nn.1
  dekorglans_1_N = mkN "dekorglans" ; -- dekorglans..nn.1
  dekorputs_1_N = mkN "dekorputs" ; -- dekorputs..nn.1
  dekorum_1_N = mkN "dekorum" neutrum  ; -- dekorum..nn.1
  dekouragera_1_V = mkV "dekouragerar" ; -- dekouragera..vb.1
  dekouragerande_1_N = mkN "dekouragerande" ; -- dekouragerande..nn.1
  dekouragerbar_1_A = mkA "dekouragerbar" ; -- dekouragerbar..av.1
  dekouragerbarhet_1_N = mkN "dekouragerbarhet" ; -- dekouragerbarhet..nn.1
  dekouragering_1_N = mkN "dekouragering" ; -- dekouragering..nn.1
  dekret_1_N = mkN "dekret" neutrum  ; -- dekret..nn.1
  dekretera_1_V = mkV "dekreterar" ; -- dekretera..vb.1
  dekreterande_1_N = mkN "dekreterande" ; -- dekreterande..nn.1
  dekreterbar_1_A = mkA "dekreterbar" ; -- dekreterbar..av.1
  dekreterbarhet_1_N = mkN "dekreterbarhet" ; -- dekreterbarhet..nn.1
  dekretering_1_N = mkN "dekretering" ; -- dekretering..nn.1
  del_1_N = mkN "del" ; -- del..nn.1
  dela_1_V = mkV "delar" ; -- dela..vb.1
  delabialiserad_1_A = mkA "delabialiserad" ; -- delabialiserad..av.1
  delad_1_A = mkA "delad" ; -- delad..av.1
  delaktig_1_A = mkA "delaktig" ; -- delaktig..av.1
  delaktighet_1_N = mkN "delaktighet" "delaktigheter" ; -- delaktighet..nn.1
  delande_1_N = mkN "delande" ; -- delande..nn.1
  delativ_1_N = mkN "delativ" "delativer" ; -- delativ..nn.1
  delbar_1_A = mkA "delbar" ; -- delbar..av.1
  delbarhet_1_N = mkN "delbarhet" ; -- delbarhet..nn.1
  delbetala_1_V = mkV "delbetalar" ; -- delbetala..vb.1
  delbetalande_1_N = mkN "delbetalande" ; -- delbetalande..nn.1
  delbetalning_1_N = mkN "delbetalning" ; -- delbetalning..nn.1
  delegat_1_N = mkN "delegat" "delegater" ; -- delegat..nn.1
  delegation_1_N = mkN "delegation" ; -- delegation..nn.1
  delegera_1_V = mkV "delegerar" ; -- delegera..vb.1
  delegerande_1_N = mkN "delegerande" ; -- delegerande..nn.1
  delegerbar_1_A = mkA "delegerbar" ; -- delegerbar..av.1
  delegerbarhet_1_N = mkN "delegerbarhet" ; -- delegerbarhet..nn.1
  delegering_1_N = mkN "delegering" ; -- delegering..nn.1
  delfin_1_N = mkN "delfin" "delfiner" ; -- delfin..nn.1
  delfinansiera_1_V = mkV "delfinansierar" ; -- delfinansiera..vb.1
  delfinansierande_1_N = mkN "delfinansierande" ; -- delfinansierande..nn.1
  delfinansiering_1_N = mkN "delfinansiering" ; -- delfinansiering..nn.1
  delfinsprång_1_N = mkN "delfinsprång" neutrum  ; -- delfinsprång..nn.1
  delfående_1_N = mkN "delfående" ; -- delfående..nn.1
  delge_1_V = mkV "delgiva" "delgav" "delgivit" ; -- delge..vb.1
  delgivande_1_N = mkN "delgivande" ; -- delgivande..nn.1
  delgivning_1_N = mkN "delgivning" ; -- delgivning..nn.1
  delgivningsman_1_N = mkN "delgivningsman" "delgivningsmannen" "delgivningsmän" "delgivningsmännen" ; -- delgivningsman..nn.1
  deliciös_1_A = mkA "deliciös" ; -- deliciös..av.1
  delikat_1_A = mkA "delikat" "delikat" ; -- delikat..av.1
  delikatess_1_N = mkN "delikatess" "delikatesser" ; -- delikatess..nn.1
  delikatessdisk_1_N = mkN "delikatessdisk" ; -- delikatessdisk..nn.1
  delikatessjäv_1_N = mkN "delikatessjäv" neutrum  ; -- delikatessjäv..nn.1
  delikt_1_N = mkN "delikt" neutrum  ; -- delikt..nn.1
  delinkvent_1_N = mkN "delinkvent" "delinkventer" ; -- delinkvent..nn.1
  delirant_1_N = mkN "delirant" "deliranter" ; -- delirant..nn.1
  delkaskoförsäkring_1_N = mkN "delkaskoförsäkring" ; -- delkaskoförsäkring..nn.1
  delkategori_1_N = mkN "delkategori" "delkategorier" ; -- delkategori..nn.1
  delkultur_1_N = mkN "delkultur" "delkulturer" ; -- delkultur..nn.1
  dellikvid_1_N = mkN "dellikvid" "dellikvider" ; -- dellikvid..nn.1
  delmängd_1_N = mkN "delmängd" "delmängder" ; -- delmängd..nn.1
  delning_1_N = mkN "delning" ; -- delning..nn.1
  delningslinje_1_N = mkN "delningslinje" "delningslinjer" ; -- delningslinje..nn.1
  delningspunkt_1_N = mkN "delningspunkt" "delningspunkter" ; -- delningspunkt..nn.1
  delningsstreck_1_N = mkN "delningsstreck" neutrum  ; -- delningsstreck..nn.1
  delningssätt_1_N = mkN "delningssätt" neutrum  ; -- delningssätt..nn.1
  delperiod_1_N = mkN "delperiod" "delperioder" ; -- delperiod..nn.1
  delprojekt_1_N = mkN "delprojekt" neutrum  ; -- delprojekt..nn.1
  delrepublik_1_N = mkN "delrepublik" "delrepubliker" ; -- delrepublik..nn.1
  dels_1_Adv = mkAdv "dels" ; -- dels..ab.1
  delstat_1_N = mkN "delstat" "delstater" ; -- delstat..nn.1
  delstatlig_1_A = mkA "delstatlig" ; -- delstatlig..av.1
  delstatsregering_1_N = mkN "delstatsregering" ; -- delstatsregering..nn.1
  delstreck_1_N = mkN "delstreck" neutrum  ; -- delstreck..nn.1
  delsträcka_1_N = mkN "delsträcka" ; -- delsträcka..nn.1
  delta_1_N = mkN "delta" "deltat" "deltan" "deltana" ; -- delta..nn.1
  delta_2_N = mkN "delta" "deltat" "deltan" "deltana" ; -- delta..nn.2
  delta_1_V = mkV "deltaga" "deltog" "deltagit" ; -- delta..vb.1
  deltaformad_1_A = mkA "deltaformad" ; -- deltaformad..av.1
  deltagande_1_A = mkA "deltagande" ; -- deltagande..av.1
  deltagande_1_N = mkN "deltagande" ; -- deltagande..nn.1
  deltagare_1_N = mkN "deltagare" utrum  ; -- deltagare..nn.1
  deltakrokodil_1_N = mkN "deltakrokodil" "deltakrokodiler" ; -- deltakrokodil..nn.1
  deltamuskel_1_N = mkN "deltamuskel" "deltamuskeln" "deltamuskler" "deltamusklerna" ; -- deltamuskel..nn.1
  deltavinge_1_N = mkN "deltavinge" utrum  ; -- deltavinge..nn.1
  deltid_1_N = mkN "deltid" "deltider" ; -- deltid..nn.1
  deltidare_1_N = mkN "deltidare" utrum  ; -- deltidare..nn.1
  deltidsanställd_1_A = mkA "deltidsanställd" "deltidsanställt" ; -- deltidsanställd..av.1
  deltidsarbeta_1_V = mkV "deltidsarbetar" ; -- deltidsarbeta..vb.1
  deltidsarbetande_1_A = mkA "deltidsarbetande" ; -- deltidsarbetande..av.1
  deltidsarbete_1_N = mkN "deltidsarbete" ; -- deltidsarbete..nn.1
  deltidsarbetslös_1_A = mkA "deltidsarbetslös" ; -- deltidsarbetslös..av.1
  deltidsarbetslöshet_1_N = mkN "deltidsarbetslöshet" ; -- deltidsarbetslöshet..nn.1
  deltidssjuk_1_A = mkA "deltidssjuk" ; -- deltidssjuk..av.1
  deltidssjukskriven_1_A = mkA "deltidssjukskriven" ; -- deltidssjukskriven..av.1
  deltävling_1_N = mkN "deltävling" ; -- deltävling..nn.1
  delvis_1_Adv = mkAdv "delvis" ; -- delvis..ab.1
  delvis_1_A = mkA "delvis" ; -- delvis..av.1
  delägare_1_N = mkN "delägare" utrum  ; -- delägare..nn.1
  dema_1_V = mkV "demar" ; -- dema..vb.1
  demagog_1_N = mkN "demagog" "demagoger" ; -- demagog..nn.1
  demagogi_1_N = mkN "demagogi" ; -- demagogi..nn.1
  demagogisk_1_A = mkA "demagogisk" ; -- demagogisk..av.1
  demande_1_N = mkN "demande" ; -- demande..nn.1
  demarkationslinje_1_N = mkN "demarkationslinje" "demarkationslinjer" ; -- demarkationslinje..nn.1
  demarsch_1_N = mkN "demarsch" "demarscher" ; -- demarsch..nn.1
  demaskera_1_V = mkV "demaskerar" ; -- demaskera..vb.1
  demaskerande_1_N = mkN "demaskerande" ; -- demaskerande..nn.1
  demaskerbar_1_A = mkA "demaskerbar" ; -- demaskerbar..av.1
  demaskerbarhet_1_N = mkN "demaskerbarhet" ; -- demaskerbarhet..nn.1
  demaskering_1_N = mkN "demaskering" ; -- demaskering..nn.1
  demens_1_N = mkN "demens" ; -- demens..nn.1
  demenshandikapp_1_N = mkN "demenshandikapp" neutrum  ; -- demenshandikapp..nn.1
  demenspatient_1_N = mkN "demenspatient" "demenspatienter" ; -- demenspatient..nn.1
  demensrelaterad_1_A = mkA "demensrelaterad" ; -- demensrelaterad..av.1
  demensrisk_1_N = mkN "demensrisk" "demensrisker" ; -- demensrisk..nn.1
  demenssjuk_1_A = mkA "demenssjuk" ; -- demenssjuk..av.1
  demenssjukdom_1_N = mkN "demenssjukdom" ; -- demenssjukdom..nn.1
  demensutveckling_1_N = mkN "demensutveckling" ; -- demensutveckling..nn.1
  dement_1_A = mkA "dement" ; -- dement..av.1
  dementera_1_V = mkV "dementerar" ; -- dementera..vb.1
  dementerande_1_N = mkN "dementerande" ; -- dementerande..nn.1
  dementerbar_1_A = mkA "dementerbar" ; -- dementerbar..av.1
  dementerbarhet_1_N = mkN "dementerbarhet" ; -- dementerbarhet..nn.1
  dementering_1_N = mkN "dementering" ; -- dementering..nn.1
  dementi_1_N = mkN "dementi" "dementier" ; -- dementi..nn.1
  demeriterande_1_A = mkA "demeriterande" ; -- demeriterande..av.1
  demi_sec_1_N = mkN "demi-sec" ; -- demi-sec..nn.1
  demilitarisera_1_V = mkV "demilitariserar" ; -- demilitarisera..vb.1
  demilitariserande_1_N = mkN "demilitariserande" ; -- demilitariserande..nn.1
  demilitariserbar_1_A = mkA "demilitariserbar" ; -- demilitariserbar..av.1
  demilitariserbarhet_1_N = mkN "demilitariserbarhet" ; -- demilitariserbarhet..nn.1
  demilitarisering_1_N = mkN "demilitarisering" ; -- demilitarisering..nn.1
  demimond_1_N = mkN "demimond" "demimonder" ; -- demimond..nn.1
  demission_1_N = mkN "demission" ; -- demission..nn.1
  demissionera_1_V = mkV "demissionerar" ; -- demissionera..vb.1
  demissionerande_1_N = mkN "demissionerande" ; -- demissionerande..nn.1
  demissionering_1_N = mkN "demissionering" ; -- demissionering..nn.1
  demiurg_1_N = mkN "demiurg" "demiurger" ; -- demiurg..nn.1
  demo_1_N = mkN "demo" "demot" "demo" "demon" ; -- demo..nn.1
  demobilisera_1_V = mkV "demobiliserar" ; -- demobilisera..vb.1
  demobiliserande_1_N = mkN "demobiliserande" ; -- demobiliserande..nn.1
  demobiliserbar_1_A = mkA "demobiliserbar" ; -- demobiliserbar..av.1
  demobiliserbarhet_1_N = mkN "demobiliserbarhet" ; -- demobiliserbarhet..nn.1
  demobilisering_1_N = mkN "demobilisering" ; -- demobilisering..nn.1
  demoeffekt_1_N = mkN "demoeffekt" "demoeffekter" ; -- demoeffekt..nn.1
  demografi_1_N = mkN "demografi" ; -- demografi..nn.1
  demografisk_1_A = mkA "demografisk" ; -- demografisk..av.1
  demoinspelning_1_N = mkN "demoinspelning" ; -- demoinspelning..nn.1
  demokrat_1_N = mkN "demokrat" "demokrater" ; -- demokrat..nn.1
  demokrati_1_N = mkN "demokrati" "demokratier" ; -- demokrati..nn.1
  demokratibygge_1_N = mkN "demokratibygge" ; -- demokratibygge..nn.1
  demokratiförespråkare_1_N = mkN "demokratiförespråkare" utrum  ; -- demokratiförespråkare..nn.1
  demokratiförkämpe_1_N = mkN "demokratiförkämpe" utrum  ; -- demokratiförkämpe..nn.1
  demokratirörelse_1_N = mkN "demokratirörelse" "demokratirörelser" ; -- demokratirörelse..nn.1
  demokratisera_1_V = mkV "demokratiserar" ; -- demokratisera..vb.1
  demokratiserande_1_N = mkN "demokratiserande" ; -- demokratiserande..nn.1
  demokratiserbar_1_A = mkA "demokratiserbar" ; -- demokratiserbar..av.1
  demokratiserbarhet_1_N = mkN "demokratiserbarhet" ; -- demokratiserbarhet..nn.1
  demokratisering_1_N = mkN "demokratisering" ; -- demokratisering..nn.1
  demokratiseringsprocess_1_N = mkN "demokratiseringsprocess" "demokratiseringsprocesser" ; -- demokratiseringsprocess..nn.1
  demokratisk_1_A = mkA "demokratisk" ; -- demokratisk..av.1
  demokratism_1_N = mkN "demokratism" "demokratismer" ; -- demokratism..nn.1
  demokratisnack_1_N = mkN "demokratisnack" neutrum  ; -- demokratisnack..nn.1
  demokratiutveckling_1_N = mkN "demokratiutveckling" ; -- demokratiutveckling..nn.1
  demolera_1_V = mkV "demolerar" ; -- demolera..vb.1
  demolerande_1_N = mkN "demolerande" ; -- demolerande..nn.1
  demolerbar_1_A = mkA "demolerbar" ; -- demolerbar..av.1
  demolerbarhet_1_N = mkN "demolerbarhet" ; -- demolerbarhet..nn.1
  demolering_1_N = mkN "demolering" ; -- demolering..nn.1
  demon_1_N = mkN "demon" "demoner" ; -- demon..nn.1
  demoni_1_N = mkN "demoni" ; -- demoni..nn.1
  demonisera_1_V = mkV "demoniserar" ; -- demonisera..vb.1
  demoniserande_1_N = mkN "demoniserande" ; -- demoniserande..nn.1
  demoniserbar_1_A = mkA "demoniserbar" ; -- demoniserbar..av.1
  demoniserbarhet_1_N = mkN "demoniserbarhet" ; -- demoniserbarhet..nn.1
  demonisering_1_N = mkN "demonisering" ; -- demonisering..nn.1
  demonisk_1_A = mkA "demonisk" ; -- demonisk..av.1
  demonologi_1_N = mkN "demonologi" ; -- demonologi..nn.1
  demonologisk_1_A = mkA "demonologisk" ; -- demonologisk..av.1
  demonregissör_1_N = mkN "demonregissör" "demonregissörer" ; -- demonregissör..nn.1
  demonstrant_1_N = mkN "demonstrant" "demonstranter" ; -- demonstrant..nn.1
  demonstration_1_N = mkN "demonstration" ; -- demonstration..nn.1
  demonstrationsfrihet_1_N = mkN "demonstrationsfrihet" "demonstrationsfriheter" ; -- demonstrationsfrihet..nn.1
  demonstrationstillstånd_1_N = mkN "demonstrationstillstånd" neutrum  ; -- demonstrationstillstånd..nn.1
  demonstrationståg_1_N = mkN "demonstrationståg" neutrum  ; -- demonstrationståg..nn.1
  demonstrativ_1_A = mkA "demonstrativ" ; -- demonstrativ..av.1
  demonstrativpronomen_1_N = mkN "demonstrativpronomen" neutrum  ; -- demonstrativpronomen..nn.1
  demonstratris_1_N = mkN "demonstratris" "demonstratriser" ; -- demonstratris..nn.1
  demonstratör_1_N = mkN "demonstratör" "demonstratörer" ; -- demonstratör..nn.1
  demonstrera_1_V = mkV "demonstrerar" ; -- demonstrera..vb.1
  demonstrera_2_V = mkV "demonstrerar" ; -- demonstrera..vb.2
  demonstrerande_1_N = mkN "demonstrerande" ; -- demonstrerande..nn.1
  demonstrerbar_1_A = mkA "demonstrerbar" ; -- demonstrerbar..av.1
  demonstrerbarhet_1_N = mkN "demonstrerbarhet" ; -- demonstrerbarhet..nn.1
  demonstrering_1_N = mkN "demonstrering" ; -- demonstrering..nn.1
  demontera_1_V = mkV "demonterar" ; -- demontera..vb.1
  demonterande_1_N = mkN "demonterande" ; -- demonterande..nn.1
  demonterbar_1_A = mkA "demonterbar" ; -- demonterbar..av.1
  demonterbarhet_1_N = mkN "demonterbarhet" ; -- demonterbarhet..nn.1
  demontering_1_N = mkN "demontering" ; -- demontering..nn.1
  demoralisation_1_N = mkN "demoralisation" ; -- demoralisation..nn.1
  demoralisera_1_V = mkV "demoraliserar" ; -- demoralisera..vb.1
  demoraliserande_1_N = mkN "demoraliserande" ; -- demoraliserande..nn.1
  demoraliserbar_1_A = mkA "demoraliserbar" ; -- demoraliserbar..av.1
  demoraliserbarhet_1_N = mkN "demoraliserbarhet" ; -- demoraliserbarhet..nn.1
  demoralisering_1_N = mkN "demoralisering" ; -- demoralisering..nn.1
  demotape_1_N = mkN "demotape" "demotaper" ; -- demotape..nn.1
  denar_1_N = mkN "denar" "denarer" ; -- denar..nn.1
  denaturalisation_1_N = mkN "denaturalisation" ; -- denaturalisation..nn.1
  denaturalisera_1_V = mkV "denaturaliserar" ; -- denaturalisera..vb.1
  denaturaliserande_1_N = mkN "denaturaliserande" ; -- denaturaliserande..nn.1
  denaturaliserbar_1_A = mkA "denaturaliserbar" ; -- denaturaliserbar..av.1
  denaturaliserbarhet_1_N = mkN "denaturaliserbarhet" ; -- denaturaliserbarhet..nn.1
  denaturalisering_1_N = mkN "denaturalisering" ; -- denaturalisering..nn.1
  denaturera_1_V = mkV "denaturerar" ; -- denaturera..vb.1
  denaturerande_1_N = mkN "denaturerande" ; -- denaturerande..nn.1
  denaturerbar_1_A = mkA "denaturerbar" ; -- denaturerbar..av.1
  denaturerbarhet_1_N = mkN "denaturerbarhet" ; -- denaturerbarhet..nn.1
  denaturering_1_N = mkN "denaturering" ; -- denaturering..nn.1
  dendrit_1_N = mkN "dendrit" "dendriter" ; -- dendrit..nn.1
  dendrokronologi_1_N = mkN "dendrokronologi" ; -- dendrokronologi..nn.1
  dendrokronologisk_1_A = mkA "dendrokronologisk" ; -- dendrokronologisk..av.1
  dendrolog_1_N = mkN "dendrolog" "dendrologer" ; -- dendrolog..nn.1
  dendrologi_1_N = mkN "dendrologi" ; -- dendrologi..nn.1
  denier_1_N = mkN "denier" "denieren" "denier" "denieren" ; -- denier..nn.1
  denim_1_N = mkN "denim" ; -- denim..nn.1
  denotation_1_N = mkN "denotation" ; -- denotation..nn.1
  denotativ_1_A = mkA "denotativ" ; -- denotativ..av.1
  denotera_1_V = mkV "denoterar" ; -- denotera..vb.1
  denoterande_1_N = mkN "denoterande" ; -- denoterande..nn.1
  denoterbar_1_A = mkA "denoterbar" ; -- denoterbar..av.1
  denoterbarhet_1_N = mkN "denoterbarhet" ; -- denoterbarhet..nn.1
  denotering_1_N = mkN "denotering" ; -- denotering..nn.1
  densitet_1_N = mkN "densitet" "densiteter" ; -- densitet..nn.1
  densitometer_1_N = mkN "densitometer" ; -- densitometer..nn.1
  densometer_1_N = mkN "densometer" ; -- densometer..nn.1
  dental_1_A = mkA "dental" ; -- dental..av.1
  dental_1_N = mkN "dental" "dentaler" ; -- dental..nn.1
  dentalljud_1_N = mkN "dentalljud" neutrum  ; -- dentalljud..nn.1
  dentist_1_N = mkN "dentist" "dentister" ; -- dentist..nn.1
  denudation_1_N = mkN "denudation" ; -- denudation..nn.1
  denudera_1_V = mkV "denuderar" ; -- denudera..vb.1
  denuderande_1_N = mkN "denuderande" ; -- denuderande..nn.1
  denuderbar_1_A = mkA "denuderbar" ; -- denuderbar..av.1
  denuderbarhet_1_N = mkN "denuderbarhet" ; -- denuderbarhet..nn.1
  denudering_1_N = mkN "denudering" ; -- denudering..nn.1
  denukleariserad_1_A = mkA "denukleariserad" ; -- denukleariserad..av.1
  denuklearisering_1_N = mkN "denuklearisering" ; -- denuklearisering..nn.1
  deodorant_1_N = mkN "deodorant" "deodoranter" ; -- deodorant..nn.1
  deodorisera_1_V = mkV "deodoriserar" ; -- deodorisera..vb.1
  deodoriserande_1_N = mkN "deodoriserande" ; -- deodoriserande..nn.1
  deodoriserbar_1_A = mkA "deodoriserbar" ; -- deodoriserbar..av.1
  deodoriserbarhet_1_N = mkN "deodoriserbarhet" ; -- deodoriserbarhet..nn.1
  deodorisering_1_N = mkN "deodorisering" ; -- deodorisering..nn.1
  departement_1_N = mkN "departement" neutrum  ; -- departement..nn.1
  departemental_1_A = mkA "departemental" ; -- departemental..av.1
  departementschef_1_N = mkN "departementschef" "departementschefer" ; -- departementschef..nn.1
  departementsråd_1_N = mkN "departementsråd" neutrum  ; -- departementsråd..nn.1
  departementsärende_1_N = mkN "departementsärende" ; -- departementsärende..nn.1
  depatriera_1_V = mkV "depatrierar" ; -- depatriera..vb.1
  depatrierande_1_N = mkN "depatrierande" ; -- depatrierande..nn.1
  depatrierbar_1_A = mkA "depatrierbar" ; -- depatrierbar..av.1
  depatrierbarhet_1_N = mkN "depatrierbarhet" ; -- depatrierbarhet..nn.1
  depatriering_1_N = mkN "depatriering" ; -- depatriering..nn.1
  dependens_1_N = mkN "dependens" "dependenser" ; -- dependens..nn.1
  depens_1_N = mkN "depens" "depenser" ; -- depens..nn.1
  depensera_1_V = mkV "depenserar" ; -- depensera..vb.1
  depenserande_1_N = mkN "depenserande" ; -- depenserande..nn.1
  depenserbar_1_A = mkA "depenserbar" ; -- depenserbar..av.1
  depenserbarhet_1_N = mkN "depenserbarhet" ; -- depenserbarhet..nn.1
  depensering_1_N = mkN "depensering" ; -- depensering..nn.1
  depersonalisation_1_N = mkN "depersonalisation" ; -- depersonalisation..nn.1
  depesch_1_N = mkN "depesch" "depescher" ; -- depesch..nn.1
  depeschbyrå_1_N = mkN "depeschbyrå" "depeschbyråer" ; -- depeschbyrå..nn.1
  deplacement_1_N = mkN "deplacement" neutrum  ; -- deplacement..nn.1
  deplacera_1_V = mkV "deplacerar" ; -- deplacera..vb.1
  deplacerande_1_N = mkN "deplacerande" ; -- deplacerande..nn.1
  deplacerbar_1_A = mkA "deplacerbar" ; -- deplacerbar..av.1
  deplacerbarhet_1_N = mkN "deplacerbarhet" ; -- deplacerbarhet..nn.1
  deplacering_1_N = mkN "deplacering" ; -- deplacering..nn.1
  depolarisator_1_N = mkN "depolarisator" "depolarisatorer" ; -- depolarisator..nn.1
  deponens_1_N = mkN "deponens" "deponens" "deponens" "deponensen" ; -- deponens..nn.1
  deponent_1_N = mkN "deponent" "deponenter" ; -- deponent..nn.1
  deponentiell_1_A = mkA "deponentiell" ; -- deponentiell..av.1
  deponera_1_V = mkV "deponerar" ; -- deponera..vb.1
  deponerande_1_N = mkN "deponerande" ; -- deponerande..nn.1
  deponerbar_1_A = mkA "deponerbar" ; -- deponerbar..av.1
  deponerbarhet_1_N = mkN "deponerbarhet" ; -- deponerbarhet..nn.1
  deponering_1_N = mkN "deponering" ; -- deponering..nn.1
  deponi_1_N = mkN "deponi" "deponier" ; -- deponi..nn.1
  deportation_1_N = mkN "deportation" ; -- deportation..nn.1
  deportationsort_1_N = mkN "deportationsort" "deportationsorter" ; -- deportationsort..nn.1
  deportera_1_V = mkV "deporterar" ; -- deportera..vb.1
  deporterande_1_N = mkN "deporterande" ; -- deporterande..nn.1
  deporterbar_1_A = mkA "deporterbar" ; -- deporterbar..av.1
  deporterbarhet_1_N = mkN "deporterbarhet" ; -- deporterbarhet..nn.1
  deportering_1_N = mkN "deportering" ; -- deportering..nn.1
  deposition_1_N = mkN "deposition" ; -- deposition..nn.1
  depositionsbevis_1_N = mkN "depositionsbevis" neutrum  ; -- depositionsbevis..nn.1
  depositum_1_N = mkN "depositum" "depositumet" "deposita" "depositana" ; -- depositum..nn.1
  deppa_1_V = mkV "deppar" ; -- deppa..vb.1
  deppad_1_A = mkA "deppad" ; -- deppad..av.1
  deppande_1_N = mkN "deppande" ; -- deppande..nn.1
  deppig_1_A = mkA "deppig" ; -- deppig..av.1
  deppighet_1_N = mkN "deppighet" ; -- deppighet..nn.1
  depprock_1_N = mkN "depprock" neutrum  ; -- depprock..nn.1
  depprockare_1_N = mkN "depprockare" utrum  ; -- depprockare..nn.1
  depravation_1_N = mkN "depravation" ; -- depravation..nn.1
  depraverad_1_A = mkA "depraverad" ; -- depraverad..av.1
  depreciera_1_V = mkV "deprecierar" ; -- depreciera..vb.1
  deprecierande_1_N = mkN "deprecierande" ; -- deprecierande..nn.1
  deprecierbar_1_A = mkA "deprecierbar" ; -- deprecierbar..av.1
  deprecierbarhet_1_N = mkN "deprecierbarhet" ; -- deprecierbarhet..nn.1
  depreciering_1_N = mkN "depreciering" ; -- depreciering..nn.1
  depression_1_N = mkN "depression" ; -- depression..nn.1
  depressionsdiagnos_1_N = mkN "depressionsdiagnos" "depressionsdiagnoser" ; -- depressionsdiagnos..nn.1
  depressionssymtom_1_N = mkN "depressionssymtom" neutrum  ; -- depressionssymtom..nn.1
  depressiv_1_A = mkA "depressiv" ; -- depressiv..av.1
  deprimerad_1_A = mkA "deprimerad" ; -- deprimerad..av.1
  deprimerande_1_A = mkA "deprimerande" ; -- deprimerande..av.1
  deprivation_1_N = mkN "deprivation" ; -- deprivation..nn.1
  deputation_1_N = mkN "deputation" ; -- deputation..nn.1
  deputerad_1_N = mkN "deputerad" "deputeraden" "deputerade" "deputeradena" ; -- deputerad..nn.1
  depå_1_N = mkN "depå" "depåer" ; -- depå..nn.1
  depåfynd_1_N = mkN "depåfynd" neutrum  ; -- depåfynd..nn.1
  depåstöd_1_N = mkN "depåstöd" neutrum  ; -- depåstöd..nn.1
  derangera_1_V = mkV "derangerar" ; -- derangera..vb.1
  derangerande_1_N = mkN "derangerande" ; -- derangerande..nn.1
  derangerbar_1_A = mkA "derangerbar" ; -- derangerbar..av.1
  derangerbarhet_1_N = mkN "derangerbarhet" ; -- derangerbarhet..nn.1
  derangering_1_N = mkN "derangering" ; -- derangering..nn.1
  derby_1_N = mkN "derby" "derbyt" "derbyn" "derbyna" ; -- derby..nn.1
  derivat_1_N = mkN "derivat" neutrum  ; -- derivat..nn.1
  derivata_1_N = mkN "derivata" ; -- derivata..nn.1
  derivation_1_N = mkN "derivation" ; -- derivation..nn.1
  derivera_1_V = mkV "deriverar" ; -- derivera..vb.1
  deriverande_1_N = mkN "deriverande" ; -- deriverande..nn.1
  deriverbar_1_A = mkA "deriverbar" ; -- deriverbar..av.1
  deriverbarhet_1_N = mkN "deriverbarhet" ; -- deriverbarhet..nn.1
  derivering_1_N = mkN "derivering" ; -- derivering..nn.1
  dermatit_1_N = mkN "dermatit" "dermatiter" ; -- dermatit..nn.1
  dermatolog_1_N = mkN "dermatolog" "dermatologer" ; -- dermatolog..nn.1
  dermatologi_1_N = mkN "dermatologi" ; -- dermatologi..nn.1
  dermatologisk_1_A = mkA "dermatologisk" ; -- dermatologisk..av.1
  dermatos_1_N = mkN "dermatos" "dermatoser" ; -- dermatos..nn.1
  dervisch_1_N = mkN "dervisch" "dervischer" ; -- dervisch..nn.1
  dervischdans_1_N = mkN "dervischdans" "dervischdanser" ; -- dervischdans..nn.1
  desarmera_1_V = mkV "desarmerar" ; -- desarmera..vb.1
  desarmerande_1_N = mkN "desarmerande" ; -- desarmerande..nn.1
  desarmerbar_1_A = mkA "desarmerbar" ; -- desarmerbar..av.1
  desarmerbarhet_1_N = mkN "desarmerbarhet" ; -- desarmerbarhet..nn.1
  desarmering_1_N = mkN "desarmering" ; -- desarmering..nn.1
  desavouera_1_V = mkV "desavouerar" ; -- desavouera..vb.1
  desavouerande_1_N = mkN "desavouerande" ; -- desavouerande..nn.1
  desavouerbar_1_A = mkA "desavouerbar" ; -- desavouerbar..av.1
  desavouerbarhet_1_N = mkN "desavouerbarhet" ; -- desavouerbarhet..nn.1
  desavouering_1_N = mkN "desavouering" ; -- desavouering..nn.1
  descendens_1_N = mkN "descendens" ; -- descendens..nn.1
  descendent_1_N = mkN "descendent" "descendenter" ; -- descendent..nn.1
  desegregation_1_N = mkN "desegregation" ; -- desegregation..nn.1
  desengagemang_1_N = mkN "desengagemang" neutrum  ; -- desengagemang..nn.1
  desensibilisera_1_V = mkV "desensibiliserar" ; -- desensibilisera..vb.1
  desensibiliserande_1_N = mkN "desensibiliserande" ; -- desensibiliserande..nn.1
  desensibiliserbar_1_A = mkA "desensibiliserbar" ; -- desensibiliserbar..av.1
  desensibiliserbarhet_1_N = mkN "desensibiliserbarhet" ; -- desensibiliserbarhet..nn.1
  desensibilisering_1_N = mkN "desensibilisering" ; -- desensibilisering..nn.1
  desertera_1_V = mkV "deserterar" ; -- desertera..vb.1
  deserterande_1_N = mkN "deserterande" ; -- deserterande..nn.1
  desertering_1_N = mkN "desertering" ; -- desertering..nn.1
  desertör_1_N = mkN "desertör" "desertörer" ; -- desertör..nn.1
  deshabillé_1_N = mkN "deshabillé" "deshabilléer" ; -- deshabillé..nn.1
  design_1_N = mkN "design" ; -- design..nn.1
  designa_1_V = mkV "designar" ; -- designa..vb.1
  designande_1_N = mkN "designande" ; -- designande..nn.1
  designer_1_N = mkN "designer" "designern" "designers" "designersen" ; -- designer..nn.1
  designera_1_V = mkV "designerar" ; -- designera..vb.1
  designerande_1_N = mkN "designerande" ; -- designerande..nn.1
  designerbar_1_A = mkA "designerbar" ; -- designerbar..av.1
  designerbarhet_1_N = mkN "designerbarhet" ; -- designerbarhet..nn.1
  designering_1_N = mkN "designering" ; -- designering..nn.1
  designmässig_1_A = mkA "designmässig" ; -- designmässig..av.1
  designskola_1_N = mkN "designskola" ; -- designskola..nn.1
  designstudent_1_N = mkN "designstudent" "designstudenter" ; -- designstudent..nn.1
  designtävling_1_N = mkN "designtävling" ; -- designtävling..nn.1
  desillusion_1_N = mkN "desillusion" ; -- desillusion..nn.1
  desillusionerad_1_A = mkA "desillusionerad" ; -- desillusionerad..av.1
  desinfektera_1_V = mkV "desinfekterar" ; -- desinfektera..vb.1
  desinfekterande_1_N = mkN "desinfekterande" ; -- desinfekterande..nn.1
  desinfekterbar_1_A = mkA "desinfekterbar" ; -- desinfekterbar..av.1
  desinfekterbarhet_1_N = mkN "desinfekterbarhet" ; -- desinfekterbarhet..nn.1
  desinfektering_1_N = mkN "desinfektering" ; -- desinfektering..nn.1
  desinfektion_1_N = mkN "desinfektion" ; -- desinfektion..nn.1
  desinfektionsmedel_1_N = mkN "desinfektionsmedel" neutrum  ; -- desinfektionsmedel..nn.1
  desinfektör_1_N = mkN "desinfektör" "desinfektörer" ; -- desinfektör..nn.1
  desinficera_1_V = mkV "desinficerar" ; -- desinficera..vb.1
  desinficerande_1_N = mkN "desinficerande" ; -- desinficerande..nn.1
  desinficerbar_1_A = mkA "desinficerbar" ; -- desinficerbar..av.1
  desinficerbarhet_1_N = mkN "desinficerbarhet" ; -- desinficerbarhet..nn.1
  desinficering_1_N = mkN "desinficering" ; -- desinficering..nn.1
  desinficeringsmedel_1_N = mkN "desinficeringsmedel" neutrum  ; -- desinficeringsmedel..nn.1
  desinformation_1_N = mkN "desinformation" ; -- desinformation..nn.1
  desinformera_1_V = mkV "desinformerar" ; -- desinformera..vb.1
  desinformerande_1_N = mkN "desinformerande" ; -- desinformerande..nn.1
  desinformerbar_1_A = mkA "desinformerbar" ; -- desinformerbar..av.1
  desinformerbarhet_1_N = mkN "desinformerbarhet" ; -- desinformerbarhet..nn.1
  desinformering_1_N = mkN "desinformering" ; -- desinformering..nn.1
  desinsektion_1_N = mkN "desinsektion" ; -- desinsektion..nn.1
  desintegration_1_N = mkN "desintegration" ; -- desintegration..nn.1
  desintresserad_1_A = mkA "desintresserad" ; -- desintresserad..av.1
  deskription_1_N = mkN "deskription" ; -- deskription..nn.1
  deskriptiv_1_A = mkA "deskriptiv" ; -- deskriptiv..av.1
  deskriptor_1_N = mkN "deskriptor" "deskriptorer" ; -- deskriptor..nn.1
  desorganisation_1_N = mkN "desorganisation" ; -- desorganisation..nn.1
  desorganisera_1_V = mkV "desorganiserar" ; -- desorganisera..vb.1
  desorganiserande_1_N = mkN "desorganiserande" ; -- desorganiserande..nn.1
  desorganiserbar_1_A = mkA "desorganiserbar" ; -- desorganiserbar..av.1
  desorganiserbarhet_1_N = mkN "desorganiserbarhet" ; -- desorganiserbarhet..nn.1
  desorganisering_1_N = mkN "desorganisering" ; -- desorganisering..nn.1
  desorienterad_1_A = mkA "desorienterad" ; -- desorienterad..av.1
  desorientering_1_N = mkN "desorientering" ; -- desorientering..nn.1
  desperado_1_N = mkN "desperado" "desperador" ; -- desperado..nn.1
  desperat_1_A = mkA "desperat" "desperat" ; -- desperat..av.1
  desperation_1_N = mkN "desperation" ; -- desperation..nn.1
  despot_1_N = mkN "despot" "despoter" ; -- despot..nn.1
  despoti_1_N = mkN "despoti" "despotier" ; -- despoti..nn.1
  despotisk_1_A = mkA "despotisk" ; -- despotisk..av.1
  despotism_1_N = mkN "despotism" "despotismer" ; -- despotism..nn.1
  dessbättre_1_Adv = mkAdv "dessbättre" ; -- dessbättre..ab.1
  dessemellan_1_Adv = mkAdv "dessemellan" ; -- dessemellan..ab.1
  dessert_1_N = mkN "dessert" "desserter" ; -- dessert..nn.1
  dessertfrukt_1_N = mkN "dessertfrukt" "dessertfrukter" ; -- dessertfrukt..nn.1
  dessertgaffel_1_N = mkN "dessertgaffel" ; -- dessertgaffel..nn.1
  dessertkniv_1_N = mkN "dessertkniv" ; -- dessertkniv..nn.1
  dessertost_1_N = mkN "dessertost" ; -- dessertost..nn.1
  dessertsked_1_N = mkN "dessertsked" ; -- dessertsked..nn.1
  dessertskål_1_N = mkN "dessertskål" ; -- dessertskål..nn.1
  dessertsås_1_N = mkN "dessertsås" "dessertsåser" ; -- dessertsås..nn.1
  desserttallrik_1_N = mkN "desserttallrik" ; -- desserttallrik..nn.1
  dessertvin_1_N = mkN "dessertvin" "dessertvinet" "dessertviner" "dessertvinerna" ; -- dessertvin..nn.1
  dessförinnan_1_Adv = mkAdv "dessförinnan" ; -- dessförinnan..ab.1
  dessförutan_1_Adv = mkAdv "dessförutan" ; -- dessförutan..ab.1
  dessinatör_1_N = mkN "dessinatör" "dessinatörer" ; -- dessinatör..nn.1
  desslikes_1_Adv = mkAdv "desslikes" ; -- desslikes..ab.1
  dessutom_1_Adv = mkAdv "dessutom" ; -- dessutom..ab.1
  dessvärre_1_Adv = mkAdv "dessvärre" ; -- dessvärre..ab.1
  dessäng_1_N = mkN "dessäng" "dessänger" ; -- dessäng..nn.1
  destabilisera_1_V = mkV "destabiliserar" ; -- destabilisera..vb.1
  destabiliserande_1_A = mkA "destabiliserande" ; -- destabiliserande..av.1
  destabiliserande_1_N = mkN "destabiliserande" ; -- destabiliserande..nn.1
  destabiliserbar_1_A = mkA "destabiliserbar" ; -- destabiliserbar..av.1
  destabiliserbarhet_1_N = mkN "destabiliserbarhet" ; -- destabiliserbarhet..nn.1
  destillat_1_N = mkN "destillat" neutrum  ; -- destillat..nn.1
  destillation_1_N = mkN "destillation" ; -- destillation..nn.1
  destillationsapparat_1_N = mkN "destillationsapparat" "destillationsapparater" ; -- destillationsapparat..nn.1
  destillera_1_V = mkV "destillerar" ; -- destillera..vb.1
  destillerande_1_N = mkN "destillerande" ; -- destillerande..nn.1
  destillerbar_1_A = mkA "destillerbar" ; -- destillerbar..av.1
  destillerbarhet_1_N = mkN "destillerbarhet" ; -- destillerbarhet..nn.1
  destillering_1_N = mkN "destillering" ; -- destillering..nn.1
  destination_1_N = mkN "destination" ; -- destination..nn.1
  destinationshamn_1_N = mkN "destinationshamn" ; -- destinationshamn..nn.1
  destinationsort_1_N = mkN "destinationsort" "destinationsorter" ; -- destinationsort..nn.1
  destinatär_1_N = mkN "destinatär" "destinatärer" ; -- destinatär..nn.1
  destinatör_1_N = mkN "destinatör" "destinatörer" ; -- destinatör..nn.1
  destinera_1_V = mkV "destinerar" ; -- destinera..vb.1
  destinerande_1_N = mkN "destinerande" ; -- destinerande..nn.1
  destinerbar_1_A = mkA "destinerbar" ; -- destinerbar..av.1
  destinerbarhet_1_N = mkN "destinerbarhet" ; -- destinerbarhet..nn.1
  destinering_1_N = mkN "destinering" ; -- destinering..nn.1
  desto_1_Adv = mkAdv "desto" ; -- desto..ab.1
  destruent_1_N = mkN "destruent" "destruenter" ; -- destruent..nn.1
  destruera_1_V = mkV "destruerar" ; -- destruera..vb.1
  destruerande_1_N = mkN "destruerande" ; -- destruerande..nn.1
  destruerbar_1_A = mkA "destruerbar" ; -- destruerbar..av.1
  destruerbarhet_1_N = mkN "destruerbarhet" ; -- destruerbarhet..nn.1
  destruering_1_N = mkN "destruering" ; -- destruering..nn.1
  destruktion_1_N = mkN "destruktion" ; -- destruktion..nn.1
  destruktionsanläggning_1_N = mkN "destruktionsanläggning" ; -- destruktionsanläggning..nn.1
  destruktiv_1_A = mkA "destruktiv" ; -- destruktiv..av.1
  det_genus_1_N = mkN "det-genus" neutrum  ; -- det-genus..nn.1
  detachement_1_N = mkN "detachement" neutrum  ; -- detachement..nn.1
  detachera_1_V = mkV "detacherar" ; -- detachera..vb.1
  detacherande_1_N = mkN "detacherande" ; -- detacherande..nn.1
  detacherbar_1_A = mkA "detacherbar" ; -- detacherbar..av.1
  detacherbarhet_1_N = mkN "detacherbarhet" ; -- detacherbarhet..nn.1
  detachering_1_N = mkN "detachering" ; -- detachering..nn.1
  detachör_1_N = mkN "detachör" "detachörer" ; -- detachör..nn.1
  detalj_1_N = mkN "detalj" "detaljer" ; -- detalj..nn.1
  detaljanmärkning_1_N = mkN "detaljanmärkning" ; -- detaljanmärkning..nn.1
  detaljarbete_1_N = mkN "detaljarbete" ; -- detaljarbete..nn.1
  detaljbestämmelse_1_N = mkN "detaljbestämmelse" "detaljbestämmelser" ; -- detaljbestämmelse..nn.1
  detaljerad_1_A = mkA "detaljerad" ; -- detaljerad..av.1
  detaljering_1_N = mkN "detaljering" ; -- detaljering..nn.1
  detaljfattig_1_A = mkA "detaljfattig" ; -- detaljfattig..av.1
  detaljfattigdom_1_N = mkN "detaljfattigdom" ; -- detaljfattigdom..nn.1
  detaljfixerad_1_A = mkA "detaljfixerad" ; -- detaljfixerad..av.1
  detaljfråga_1_N = mkN "detaljfråga" ; -- detaljfråga..nn.1
  detaljgranska_1_V = mkV "detaljgranskar" ; -- detaljgranska..vb.1
  detaljgranskande_1_N = mkN "detaljgranskande" ; -- detaljgranskande..nn.1
  detaljhandel_1_N = mkN "detaljhandel" ; -- detaljhandel..nn.1
  detaljhandlare_1_N = mkN "detaljhandlare" utrum  ; -- detaljhandlare..nn.1
  detaljist_1_N = mkN "detaljist" "detaljister" ; -- detaljist..nn.1
  detaljkarta_1_N = mkN "detaljkarta" ; -- detaljkarta..nn.1
  detaljkunskap_1_N = mkN "detaljkunskap" "detaljkunskaper" ; -- detaljkunskap..nn.1
  detaljkännedom_1_N = mkN "detaljkännedom" ; -- detaljkännedom..nn.1
  detaljplan_1_N = mkN "detaljplan" "detaljplaner" ; -- detaljplan..nn.1
  detaljpris_1_N = mkN "detaljpris" neutrum  ; -- detaljpris..nn.1
  detaljreglera_1_V = mkV "detaljreglerar" ; -- detaljreglera..vb.1
  detaljreglerande_1_N = mkN "detaljreglerande" ; -- detaljreglerande..nn.1
  detaljreglerbar_1_A = mkA "detaljreglerbar" ; -- detaljreglerbar..av.1
  detaljreglerbarhet_1_N = mkN "detaljreglerbarhet" ; -- detaljreglerbarhet..nn.1
  detaljreglering_1_N = mkN "detaljreglering" ; -- detaljreglering..nn.1
  detaljrik_1_A = mkA "detaljrik" ; -- detaljrik..av.1
  detaljrikedom_1_N = mkN "detaljrikedom" ; -- detaljrikedom..nn.1
  detaljrikhet_1_N = mkN "detaljrikhet" ; -- detaljrikhet..nn.1
  detaljritning_1_N = mkN "detaljritning" ; -- detaljritning..nn.1
  detaljskärpa_1_N = mkN "detaljskärpa" ; -- detaljskärpa..nn.1
  detaljstudium_1_N = mkN "detaljstudium" "detaljstudiet" "detaljstudier" "detaljstudierna" ; -- detaljstudium..nn.1
  detaljstyra_1_V = mkV "detaljstyra" "detaljstyrde" "detaljstyrt" ; -- detaljstyra..vb.1
  detaljstyrande_1_N = mkN "detaljstyrande" ; -- detaljstyrande..nn.1
  detaljstyrning_1_N = mkN "detaljstyrning" ; -- detaljstyrning..nn.1
  detaljuppgift_1_N = mkN "detaljuppgift" "detaljuppgifter" ; -- detaljuppgift..nn.1
  detaljutförande_1_N = mkN "detaljutförande" ; -- detaljutförande..nn.1
  detektera_1_V = mkV "detekterar" ; -- detektera..vb.1
  detekterande_1_N = mkN "detekterande" ; -- detekterande..nn.1
  detekterbar_1_A = mkA "detekterbar" ; -- detekterbar..av.1
  detekterbarhet_1_N = mkN "detekterbarhet" ; -- detekterbarhet..nn.1
  detektering_1_N = mkN "detektering" ; -- detektering..nn.1
  detektiv_1_A = mkA "detektiv" ; -- detektiv..av.1
  detektiv_1_N = mkN "detektiv" "detektiver" ; -- detektiv..nn.1
  detektivarbete_1_N = mkN "detektivarbete" ; -- detektivarbete..nn.1
  detektivberättelse_1_N = mkN "detektivberättelse" "detektivberättelser" ; -- detektivberättelse..nn.1
  detektivroman_1_N = mkN "detektivroman" "detektivromaner" ; -- detektivroman..nn.1
  detektor_1_N = mkN "detektor" "detektorer" ; -- detektor..nn.1
  detergent_1_N = mkN "detergent" "detergenter" ; -- detergent..nn.1
  determination_1_N = mkN "determination" ; -- determination..nn.1
  determinativ_1_A = mkA "determinativ" ; -- determinativ..av.1
  determinativpronomen_1_N = mkN "determinativpronomen" neutrum  ; -- determinativpronomen..nn.1
  determinera_1_V = mkV "determinerar" ; -- determinera..vb.1
  determinerande_1_N = mkN "determinerande" ; -- determinerande..nn.1
  determinerbar_1_A = mkA "determinerbar" ; -- determinerbar..av.1
  determinerbarhet_1_N = mkN "determinerbarhet" ; -- determinerbarhet..nn.1
  determinering_1_N = mkN "determinering" ; -- determinering..nn.1
  determinism_1_N = mkN "determinism" ; -- determinism..nn.1
  determinist_1_N = mkN "determinist" "determinister" ; -- determinist..nn.1
  deterministisk_1_A = mkA "deterministisk" ; -- deterministisk..av.1
  detgenus_1_N = mkN "detgenus" neutrum  ; -- detgenus..nn.1
  detonation_1_N = mkN "detonation" ; -- detonation..nn.1
  detonationshastighet_1_N = mkN "detonationshastighet" "detonationshastigheter" ; -- detonationshastighet..nn.1
  detonationstryck_1_N = mkN "detonationstryck" neutrum  ; -- detonationstryck..nn.1
  detonationszon_1_N = mkN "detonationszon" "detonationszoner" ; -- detonationszon..nn.1
  detonator_1_N = mkN "detonator" "detonatorer" ; -- detonator..nn.1
  detonera_1_V = mkV "detonerar" ; -- detonera..vb.1
  detonerande_1_N = mkN "detonerande" ; -- detonerande..nn.1
  detonerbar_1_A = mkA "detonerbar" ; -- detonerbar..av.1
  detonerbarhet_1_N = mkN "detonerbarhet" ; -- detonerbarhet..nn.1
  detonering_1_N = mkN "detonering" ; -- detonering..nn.1
  detronisera_1_V = mkV "detroniserar" ; -- detronisera..vb.1
  detroniserande_1_N = mkN "detroniserande" ; -- detroniserande..nn.1
  detroniserbar_1_A = mkA "detroniserbar" ; -- detroniserbar..av.1
  detroniserbarhet_1_N = mkN "detroniserbarhet" ; -- detroniserbarhet..nn.1
  detronisering_1_N = mkN "detronisering" ; -- detronisering..nn.1
  deuterium_1_N = mkN "deuterium" neutrum  ; -- deuterium..nn.1
  deuteron_1_N = mkN "deuteron" "deuteroner" ; -- deuteron..nn.1
  deutron_1_N = mkN "deutron" "deutroner" ; -- deutron..nn.1
  devalvera_1_V = mkV "devalverar" ; -- devalvera..vb.1
  devalverande_1_N = mkN "devalverande" ; -- devalverande..nn.1
  devalverbar_1_A = mkA "devalverbar" ; -- devalverbar..av.1
  devalverbarhet_1_N = mkN "devalverbarhet" ; -- devalverbarhet..nn.1
  devalvering_1_N = mkN "devalvering" ; -- devalvering..nn.1
  deviation_1_N = mkN "deviation" ; -- deviation..nn.1
  deviera_1_V = mkV "devierar" ; -- deviera..vb.1
  devierande_1_N = mkN "devierande" ; -- devierande..nn.1
  deviering_1_N = mkN "deviering" ; -- deviering..nn.1
  devis_1_N = mkN "devis" "deviser" ; -- devis..nn.1
  devon_1_N = mkN "devon" ; -- devon..nn.1
  devot_1_A = mkA "devot" "devot" ; -- devot..av.1
  dextran_1_N = mkN "dextran" "dextraner" ; -- dextran..nn.1
  dextrin_1_N = mkN "dextrin" "dextriner" ; -- dextrin..nn.1
  dhivehi_1_N = mkN "dhivehi" ; -- dhivehi..nn.1
  dia_1_N = mkN "dia" ; -- dia..nn.1
  dia_1_V = mkV "diar" ; -- dia..vb.1
  diabas_1_N = mkN "diabas" "diabaser" ; -- diabas..nn.1
  diabetesmedicin_1_N = mkN "diabetesmedicin" "diabetesmediciner" ; -- diabetesmedicin..nn.1
  diabetiker_1_N = mkN "diabetiker" "diabetikern" "diabetiker" "diabetikerna" ; -- diabetiker..nn.1
  diabetisk_1_A = mkA "diabetisk" ; -- diabetisk..av.1
  diabild_1_N = mkN "diabild" "diabilder" ; -- diabild..nn.1
  diabolisk_1_A = mkA "diabolisk" ; -- diabolisk..av.1
  diadem_1_N = mkN "diadem" neutrum  ; -- diadem..nn.1
  diafilm_1_N = mkN "diafilm" "diafilmer" ; -- diafilm..nn.1
  diafragma_1_N = mkN "diafragma" ; -- diafragma..nn.1
  diagnos_1_N = mkN "diagnos" "diagnoser" ; -- diagnos..nn.1
  diagnosmetod_1_N = mkN "diagnosmetod" "diagnosmetoder" ; -- diagnosmetod..nn.1
  diagnosticera_1_V = mkV "diagnosticerar" ; -- diagnosticera..vb.1
  diagnosticerande_1_N = mkN "diagnosticerande" ; -- diagnosticerande..nn.1
  diagnosticerbar_1_A = mkA "diagnosticerbar" ; -- diagnosticerbar..av.1
  diagnosticerbarhet_1_N = mkN "diagnosticerbarhet" ; -- diagnosticerbarhet..nn.1
  diagnosticering_1_N = mkN "diagnosticering" ; -- diagnosticering..nn.1
  diagnostik_1_N = mkN "diagnostik" ; -- diagnostik..nn.1
  diagnostiker_1_N = mkN "diagnostiker" "diagnostikern" "diagnostiker" "diagnostikerna" ; -- diagnostiker..nn.1
  diagnostisera_1_V = mkV "diagnostiserar" ; -- diagnostisera..vb.1
  diagnostiserande_1_N = mkN "diagnostiserande" ; -- diagnostiserande..nn.1
  diagnostiserbar_1_A = mkA "diagnostiserbar" ; -- diagnostiserbar..av.1
  diagnostiserbarhet_1_N = mkN "diagnostiserbarhet" ; -- diagnostiserbarhet..nn.1
  diagnostisering_1_N = mkN "diagnostisering" ; -- diagnostisering..nn.1
  diagnostisk_1_A = mkA "diagnostisk" ; -- diagnostisk..av.1
  diagonal_1_A = mkA "diagonal" ; -- diagonal..av.1
  diagonal_1_N = mkN "diagonal" "diagonaler" ; -- diagonal..nn.1
  diagonala_1_V = mkV "diagonalar" ; -- diagonala..vb.1
  diagonalande_1_N = mkN "diagonalande" ; -- diagonalande..nn.1
  diagonalbyggnad_1_N = mkN "diagonalbyggnad" "diagonalbyggnader" ; -- diagonalbyggnad..nn.1
  diagonallinje_1_N = mkN "diagonallinje" "diagonallinjer" ; -- diagonallinje..nn.1
  diagram_1_N = mkN "diagram" "diagrammet" "diagram" "diagrammen" ; -- diagram..nn.1
  diakon_1_N = mkN "diakon" "diakoner" ; -- diakon..nn.1
  diakoni_1_N = mkN "diakoni" ; -- diakoni..nn.1
  diakonissa_1_N = mkN "diakonissa" ; -- diakonissa..nn.1
  diakonissanstalt_1_N = mkN "diakonissanstalt" "diakonissanstalter" ; -- diakonissanstalt..nn.1
  diakonistyrelse_1_N = mkN "diakonistyrelse" "diakonistyrelser" ; -- diakonistyrelse..nn.1
  diakritisk_1_A = mkA "diakritisk" ; -- diakritisk..av.1
  diakron_1_A = mkA "diakron" ; -- diakron..av.1
  diakronisk_1_A = mkA "diakronisk" ; -- diakronisk..av.1
  dialekt_1_N = mkN "dialekt" "dialekter" ; -- dialekt..nn.1
  dialektal_1_A = mkA "dialektal" ; -- dialektal..av.1
  dialektforskning_1_N = mkN "dialektforskning" ; -- dialektforskning..nn.1
  dialektgeografi_1_N = mkN "dialektgeografi" ; -- dialektgeografi..nn.1
  dialektgeografisk_1_A = mkA "dialektgeografisk" ; -- dialektgeografisk..av.1
  dialektik_1_N = mkN "dialektik" ; -- dialektik..nn.1
  dialektiker_1_N = mkN "dialektiker" "dialektikern" "dialektiker" "dialektikerna" ; -- dialektiker..nn.1
  dialektisk_1_A = mkA "dialektisk" ; -- dialektisk..av.1
  dialektolog_1_N = mkN "dialektolog" "dialektologer" ; -- dialektolog..nn.1
  dialektologi_1_N = mkN "dialektologi" ; -- dialektologi..nn.1
  dialektologisk_1_A = mkA "dialektologisk" ; -- dialektologisk..av.1
  dialektord_1_N = mkN "dialektord" neutrum  ; -- dialektord..nn.1
  dialektordbok_1_N = mkN "dialektordbok" "dialektordböcker" ; -- dialektordbok..nn.1
  dialektstudium_1_N = mkN "dialektstudium" "dialektstudiet" "dialektstudier" "dialektstudierna" ; -- dialektstudium..nn.1
  dialektuttal_1_N = mkN "dialektuttal" neutrum  ; -- dialektuttal..nn.1
  dialog_1_N = mkN "dialog" "dialoger" ; -- dialog..nn.1
  dialogform_1_N = mkN "dialogform" ; -- dialogform..nn.1
  dialogisk_1_A = mkA "dialogisk" ; -- dialogisk..av.1
  dialogparti_1_N = mkN "dialogparti" "dialogpartiet" "dialogpartier" "dialogpartierna" ; -- dialogparti..nn.1
  dialogpedagogik_1_N = mkN "dialogpedagogik" ; -- dialogpedagogik..nn.1
  dialys_1_N = mkN "dialys" "dialyser" ; -- dialys..nn.1
  dialysera_1_V = mkV "dialyserar" ; -- dialysera..vb.1
  dialyserande_1_N = mkN "dialyserande" ; -- dialyserande..nn.1
  dialyserbar_1_A = mkA "dialyserbar" ; -- dialyserbar..av.1
  dialyserbarhet_1_N = mkN "dialyserbarhet" ; -- dialyserbarhet..nn.1
  dialysering_1_N = mkN "dialysering" ; -- dialysering..nn.1
  dialytisk_1_A = mkA "dialytisk" ; -- dialytisk..av.1
  diamant_1_N = mkN "diamant" "diamanter" ; -- diamant..nn.1
  diamantborr_1_N = mkN "diamantborr" ; -- diamantborr..nn.1
  diamantbrynstål_1_N = mkN "diamantbrynstål" neutrum  ; -- diamantbrynstål..nn.1
  diamantbröllop_1_N = mkN "diamantbröllop" neutrum  ; -- diamantbröllop..nn.1
  diamantprydd_1_A = mkA "diamantprydd" ; -- diamantprydd..av.1
  diamantring_1_N = mkN "diamantring" ; -- diamantring..nn.1
  diamantskärare_1_N = mkN "diamantskärare" utrum  ; -- diamantskärare..nn.1
  diamantsmycke_1_N = mkN "diamantsmycke" ; -- diamantsmycke..nn.1
  diamanttjuv_1_N = mkN "diamanttjuv" ; -- diamanttjuv..nn.1
  diameter_1_N = mkN "diameter" ; -- diameter..nn.1
  diametral_1_A = mkA "diametral" ; -- diametral..av.1
  diande_1_N = mkN "diande" ; -- diande..nn.1
  diapositiv_1_N = mkN "diapositiv" neutrum  ; -- diapositiv..nn.1
  diarieföra_1_V = mkV "diarieföra" "diarieförde" "diariefört" ; -- diarieföra..vb.1
  diarieförande_1_N = mkN "diarieförande" ; -- diarieförande..nn.1
  diarienummer_1_N = mkN "diarienummer" neutrum  ; -- diarienummer..nn.1
  diarium_1_N = mkN "diarium" "diariet" "diarier" "diarierna" ; -- diarium..nn.1
  diarré_1_N = mkN "diarré" "diarréer" ; -- diarré..nn.1
  diaspora_1_N = mkN "diaspora" ; -- diaspora..nn.1
  diasporagrupp_1_N = mkN "diasporagrupp" "diasporagrupper" ; -- diasporagrupp..nn.1
  diastas_1_N = mkN "diastas" "diastaser" ; -- diastas..nn.1
  diastole_1_N = mkN "diastole" utrum  ; -- diastole..nn.1
  diastolisk_1_A = mkA "diastolisk" ; -- diastolisk..av.1
  diatermi_1_N = mkN "diatermi" ; -- diatermi..nn.1
  diatonisk_1_A = mkA "diatonisk" ; -- diatonisk..av.1
  diatrib_1_N = mkN "diatrib" "diatriber" ; -- diatrib..nn.1
  dibarn_1_N = mkN "dibarn" neutrum  ; -- dibarn..nn.1
  dibbla_1_V = mkV "dibblar" ; -- dibbla..vb.1
  dibblande_1_N = mkN "dibblande" ; -- dibblande..nn.1
  didaktik_1_N = mkN "didaktik" ; -- didaktik..nn.1
  didaktiker_1_N = mkN "didaktiker" "didaktikern" "didaktiker" "didaktikerna" ; -- didaktiker..nn.1
  didaktisk_1_A = mkA "didaktisk" ; -- didaktisk..av.1
  diddling_1_N = mkN "diddling" ; -- diddling..nn.1
  diesel_1_N = mkN "diesel" ; -- diesel..nn.1
  dieseldriven_1_A = mkA "dieseldriven" ; -- dieseldriven..av.1
  dieselgenerator_1_N = mkN "dieselgenerator" "dieselgeneratorer" ; -- dieselgenerator..nn.1
  dieselhybrid_1_N = mkN "dieselhybrid" "dieselhybrider" ; -- dieselhybrid..nn.1
  dieselkraftverk_1_N = mkN "dieselkraftverk" neutrum  ; -- dieselkraftverk..nn.1
  dieselmotor_1_N = mkN "dieselmotor" "dieselmotorer" ; -- dieselmotor..nn.1
  dieselmotorrengöring_1_N = mkN "dieselmotorrengöring" ; -- dieselmotorrengöring..nn.1
  dieselolja_1_N = mkN "dieselolja" ; -- dieselolja..nn.1
  dieselpump_1_N = mkN "dieselpump" ; -- dieselpump..nn.1
  diet_1_N = mkN "diet" "dieter" ; -- diet..nn.1
  dietetik_1_N = mkN "dietetik" ; -- dietetik..nn.1
  dietetisk_1_A = mkA "dietetisk" ; -- dietetisk..av.1
  dietik_1_N = mkN "dietik" ; -- dietik..nn.1
  dietisk_1_A = mkA "dietisk" ; -- dietisk..av.1
  dietist_1_N = mkN "dietist" "dietister" ; -- dietist..nn.1
  differens_1_N = mkN "differens" "differenser" ; -- differens..nn.1
  different_1_A = mkA "different" "different" ; -- different..av.1
  differential_1_N = mkN "differential" "differentialer" ; -- differential..nn.1
  differentialekvation_1_N = mkN "differentialekvation" ; -- differentialekvation..nn.1
  differentialkalkyl_1_N = mkN "differentialkalkyl" "differentialkalkyler" ; -- differentialkalkyl..nn.1
  differentialräkning_1_N = mkN "differentialräkning" ; -- differentialräkning..nn.1
  differentialspärr_1_N = mkN "differentialspärr" ; -- differentialspärr..nn.1
  differentialväxel_1_N = mkN "differentialväxel" ; -- differentialväxel..nn.1
  differentiell_1_A = mkA "differentiell" ; -- differentiell..av.1
  differentiera_1_V = mkV "differentierar" ; -- differentiera..vb.1
  differentierande_1_N = mkN "differentierande" ; -- differentierande..nn.1
  differentierbar_1_A = mkA "differentierbar" ; -- differentierbar..av.1
  differentierbarhet_1_N = mkN "differentierbarhet" ; -- differentierbarhet..nn.1
  differentiering_1_N = mkN "differentiering" ; -- differentiering..nn.1
  diffraktion_1_N = mkN "diffraktion" ; -- diffraktion..nn.1
  diffraktionsspektrum_1_N = mkN "diffraktionsspektrum" neutrum  ; -- diffraktionsspektrum..nn.1
  diffundera_1_V = mkV "diffunderar" ; -- diffundera..vb.1
  diffunderande_1_N = mkN "diffunderande" ; -- diffunderande..nn.1
  diffunderbar_1_A = mkA "diffunderbar" ; -- diffunderbar..av.1
  diffunderbarhet_1_N = mkN "diffunderbarhet" ; -- diffunderbarhet..nn.1
  diffundering_1_N = mkN "diffundering" ; -- diffundering..nn.1
  diffus_1_A = mkA "diffus" ; -- diffus..av.1
  diffusion_1_N = mkN "diffusion" ; -- diffusion..nn.1
  difteri_1_N = mkN "difteri" ; -- difteri..nn.1
  diftong_1_N = mkN "diftong" "diftonger" ; -- diftong..nn.1
  diftongera_1_V = mkV "diftongerar" ; -- diftongera..vb.1
  diftongerande_1_N = mkN "diftongerande" ; -- diftongerande..nn.1
  diftongerbar_1_A = mkA "diftongerbar" ; -- diftongerbar..av.1
  diftongerbarhet_1_N = mkN "diftongerbarhet" ; -- diftongerbarhet..nn.1
  diftongering_1_N = mkN "diftongering" ; -- diftongering..nn.1
  diftongisk_1_A = mkA "diftongisk" ; -- diftongisk..av.1
  diftongljud_1_N = mkN "diftongljud" neutrum  ; -- diftongljud..nn.1
  digel_1_N = mkN "digel" ; -- digel..nn.1
  digelpress_1_N = mkN "digelpress" ; -- digelpress..nn.1
  diger_1_A = mkA "diger" ; -- diger..av.1
  digerdöd_1_N = mkN "digerdöd" ; -- digerdöd..nn.1
  digerera_1_V = mkV "digererar" ; -- digerera..vb.1
  digererande_1_N = mkN "digererande" ; -- digererande..nn.1
  digererbar_1_A = mkA "digererbar" ; -- digererbar..av.1
  digererbarhet_1_N = mkN "digererbarhet" ; -- digererbarhet..nn.1
  digerering_1_N = mkN "digerering" ; -- digerering..nn.1
  digestion_1_N = mkN "digestion" ; -- digestion..nn.1
  digga_1_V = mkV "diggar" ; -- digga..vb.1
  diggande_1_N = mkN "diggande" ; -- diggande..nn.1
  digital_teve_1_N = mkN "digital-teve" "digital-teven" "digital-tevear" "digital-tevearna" ; -- digital-teve..nn.1
  digital_1_A = mkA "digital" ; -- digital..av.1
  digitalbox_1_N = mkN "digitalbox" ; -- digitalbox..nn.1
  digitalis_1_N = mkN "digitalis" ; -- digitalis..nn.1
  digitalisera_1_V = mkV "digitaliserar" ; -- digitalisera..vb.1
  digitaliserad_1_A = mkA "digitaliserad" ; -- digitaliserad..av.1
  digitaliserande_1_N = mkN "digitaliserande" ; -- digitaliserande..nn.1
  digitaliserbar_1_A = mkA "digitaliserbar" ; -- digitaliserbar..av.1
  digitaliserbarhet_1_N = mkN "digitaliserbarhet" ; -- digitaliserbarhet..nn.1
  digitalisering_1_N = mkN "digitalisering" ; -- digitalisering..nn.1
  digitalkamera_1_N = mkN "digitalkamera" ; -- digitalkamera..nn.1
  digitallåda_1_N = mkN "digitallåda" ; -- digitallåda..nn.1
  digitalteve_1_N = mkN "digitalteve" "digitalteven" "digitaltevear" "digitaltevearna" ; -- digitalteve..nn.1
  digivning_1_N = mkN "digivning" ; -- digivning..nn.1
  diglossi_1_N = mkN "diglossi" ; -- diglossi..nn.1
  digna_1_V = mkV "dignar" ; -- digna..vb.1
  dignande_1_N = mkN "dignande" ; -- dignande..nn.1
  dignitet_1_N = mkN "dignitet" "digniteter" ; -- dignitet..nn.1
  dignitär_1_N = mkN "dignitär" "dignitärer" ; -- dignitär..nn.1
  digression_1_N = mkN "digression" ; -- digression..nn.1
  dika_1_V = mkV "dikar" ; -- dika..vb.1
  dikande_1_N = mkN "dikande" ; -- dikande..nn.1
  dikare_1_N = mkN "dikare" utrum  ; -- dikare..nn.1
  dike_1_N = mkN "dike" ; -- dike..nn.1
  dikesgrävare_1_N = mkN "dikesgrävare" utrum  ; -- dikesgrävare..nn.1
  dikeskörning_1_N = mkN "dikeskörning" ; -- dikeskörning..nn.1
  dikesren_1_N = mkN "dikesren" "dikesrenen" "dikesrenar" "dikesrenarna" ; -- dikesren..nn.1
  diklin_1_A = mkA "diklin" ; -- diklin..av.1
  diklin_1_N = mkN "diklin" "dikliner" ; -- diklin..nn.1
  dikning_1_N = mkN "dikning" ; -- dikning..nn.1
  dikotomi_1_N = mkN "dikotomi" "dikotomier" ; -- dikotomi..nn.1
  dikotyledon_1_A = mkA "dikotyledon" ; -- dikotyledon..av.1
  dikotyledon_1_N = mkN "dikotyledon" "dikotyledoner" ; -- dikotyledon..nn.1
  dikt_1_Adv = mkAdv "dikt" ; -- dikt..ab.1
  dikt_1_N = mkN "dikt" "dikter" ; -- dikt..nn.1
  dikta_1_V = mkV "diktar" ; -- dikta..vb.1
  diktafon_1_N = mkN "diktafon" "diktafoner" ; -- diktafon..nn.1
  diktamen_1_N = mkN "diktamen" "diktamen" "diktamina" "diktamina" ; -- diktamen..nn.1
  diktamensskrivning_1_N = mkN "diktamensskrivning" ; -- diktamensskrivning..nn.1
  diktan_1_N = mkN "diktan" ; -- diktan..nn.1
  diktande_1_N = mkN "diktande" ; -- diktande..nn.1
  diktarbegåvning_1_N = mkN "diktarbegåvning" ; -- diktarbegåvning..nn.1
  diktare_1_N = mkN "diktare" utrum  ; -- diktare..nn.1
  diktarfurste_1_N = mkN "diktarfurste" utrum  ; -- diktarfurste..nn.1
  diktarfursteroll_1_N = mkN "diktarfursteroll" "diktarfursteroller" ; -- diktarfursteroll..nn.1
  diktargrupp_1_N = mkN "diktargrupp" "diktargrupper" ; -- diktargrupp..nn.1
  diktarskap_1_N = mkN "diktarskap" neutrum  ; -- diktarskap..nn.1
  diktart_1_N = mkN "diktart" "diktarter" ; -- diktart..nn.1
  diktat_1_N = mkN "diktat" neutrum  ; -- diktat..nn.1
  diktator_1_N = mkN "diktator" "diktatorer" ; -- diktator..nn.1
  diktatorisk_1_A = mkA "diktatorisk" ; -- diktatorisk..av.1
  diktatorsmakt_1_N = mkN "diktatorsmakt" ; -- diktatorsmakt..nn.1
  diktatur_1_N = mkN "diktatur" "diktaturer" ; -- diktatur..nn.1
  diktaturregim_1_N = mkN "diktaturregim" "diktaturregimer" ; -- diktaturregim..nn.1
  diktcykel_1_N = mkN "diktcykel" ; -- diktcykel..nn.1
  diktera_1_V = mkV "dikterar" ; -- diktera..vb.1
  dikterande_1_N = mkN "dikterande" ; -- dikterande..nn.1
  dikterbar_1_A = mkA "dikterbar" ; -- dikterbar..av.1
  dikterbarhet_1_N = mkN "dikterbarhet" ; -- dikterbarhet..nn.1
  diktering_1_N = mkN "diktering" ; -- diktering..nn.1
  dikteringsmaskin_1_N = mkN "dikteringsmaskin" "dikteringsmaskiner" ; -- dikteringsmaskin..nn.1
  diktfragment_1_N = mkN "diktfragment" neutrum  ; -- diktfragment..nn.1
  dikthäfte_1_N = mkN "dikthäfte" ; -- dikthäfte..nn.1
  diktion_1_N = mkN "diktion" ; -- diktion..nn.1
  diktjag_1_N = mkN "diktjag" neutrum  ; -- diktjag..nn.1
  diktkonst_1_N = mkN "diktkonst" ; -- diktkonst..nn.1
  diktmässig_1_A = mkA "diktmässig" ; -- diktmässig..av.1
  diktning_1_N = mkN "diktning" ; -- diktning..nn.1
  diktsamling_1_N = mkN "diktsamling" ; -- diktsamling..nn.1
  diktverk_1_N = mkN "diktverk" neutrum  ; -- diktverk..nn.1
  dikväveoxid_1_N = mkN "dikväveoxid" "dikväveoxider" ; -- dikväveoxid..nn.1
  dila_1_V = mkV "dilar" ; -- dila..vb.1
  dilamm_1_N = mkN "dilamm" neutrum  ; -- dilamm..nn.1
  dilande_1_N = mkN "dilande" ; -- dilande..nn.1
  dilatation_1_N = mkN "dilatation" ; -- dilatation..nn.1
  dilatationsfog_1_N = mkN "dilatationsfog" ; -- dilatationsfog..nn.1
  dildo_1_N = mkN "dildo" ; -- dildo..nn.1
  dilemma_1_N = mkN "dilemma" "dilemmat" "dilemman" "dilemmana" ; -- dilemma..nn.1
  dilettant_1_N = mkN "dilettant" "dilettanter" ; -- dilettant..nn.1
  dilettanteri_1_N = mkN "dilettanteri" neutrum  ; -- dilettanteri..nn.1
  dilettantisk_1_A = mkA "dilettantisk" ; -- dilettantisk..av.1
  dilettantism_1_N = mkN "dilettantism" "dilettantismer" ; -- dilettantism..nn.1
  dilettantmässig_1_A = mkA "dilettantmässig" ; -- dilettantmässig..av.1
  dilettantmässighet_1_N = mkN "dilettantmässighet" ; -- dilettantmässighet..nn.1
  diligens_1_N = mkN "diligens" "diligenser" ; -- diligens..nn.1
  dill_1_N = mkN "dill" ; -- dill..nn.1
  dilla_1_V = mkV "dillar" ; -- dilla..vb.1
  dillande_1_N = mkN "dillande" ; -- dillande..nn.1
  dille_1_N = mkN "dille" ; -- dille..nn.1
  dilleri_1_N = mkN "dilleri" "dilleriet" "dillerier" "dillerierna" ; -- dilleri..nn.1
  dillkrona_1_N = mkN "dillkrona" ; -- dillkrona..nn.1
  dillkvist_1_N = mkN "dillkvist" ; -- dillkvist..nn.1
  dillkött_1_N = mkN "dillkött" neutrum  ; -- dillkött..nn.1
  dillsås_1_N = mkN "dillsås" "dillsåser" ; -- dillsås..nn.1
  dimbank_1_N = mkN "dimbank" ; -- dimbank..nn.1
  dimbildning_1_N = mkN "dimbildning" ; -- dimbildning..nn.1
  dimblå_1_A = mkA "dimblå" "dimblått" ; -- dimblå..av.1
  dimbåge_1_N = mkN "dimbåge" utrum  ; -- dimbåge..nn.1
  dimension_1_N = mkN "dimension" ; -- dimension..nn.1
  dimensionera_1_V = mkV "dimensionerar" ; -- dimensionera..vb.1
  dimensionerande_1_N = mkN "dimensionerande" ; -- dimensionerande..nn.1
  dimensionerbar_1_A = mkA "dimensionerbar" ; -- dimensionerbar..av.1
  dimensionerbarhet_1_N = mkN "dimensionerbarhet" ; -- dimensionerbarhet..nn.1
  dimensionering_1_N = mkN "dimensionering" ; -- dimensionering..nn.1
  dimensionsavverkning_1_N = mkN "dimensionsavverkning" ; -- dimensionsavverkning..nn.1
  dimensionslös_1_A = mkA "dimensionslös" ; -- dimensionslös..av.1
  dimfri_1_A = mkA "dimfri" "dimfritt" ; -- dimfri..av.1
  dimfrost_1_N = mkN "dimfrost" ; -- dimfrost..nn.1
  dimgestalt_1_N = mkN "dimgestalt" "dimgestalter" ; -- dimgestalt..nn.1
  dimhöljd_1_A = mkA "dimhöljd" "dimhöljt" ; -- dimhöljd..av.1
  diminuendo_1_N = mkN "diminuendo" "diminuendot" "diminuendon" "diminuendona" ; -- diminuendo..nn.1
  diminutiv_1_A = mkA "diminutiv" ; -- diminutiv..av.1
  diminutiv_1_N = mkN "diminutiv" "diminutiver" ; -- diminutiv..nn.1
  dimission_1_N = mkN "dimission" ; -- dimission..nn.1
  dimkammare_1_N = mkN "dimkammare" "dimkammaren" "dimkammare" "dimkamrarna" ; -- dimkammare..nn.1
  dimljus_1_N = mkN "dimljus" neutrum  ; -- dimljus..nn.1
  dimma_1_N = mkN "dimma" ; -- dimma..nn.1
  dimmig_1_A = mkA "dimmig" ; -- dimmig..av.1
  dimmighet_1_N = mkN "dimmighet" ; -- dimmighet..nn.1
  dimmoln_1_N = mkN "dimmoln" neutrum  ; -- dimmoln..nn.1
  dimorf_1_A = mkA "dimorf" ; -- dimorf..av.1
  dimorfi_1_N = mkN "dimorfi" "dimorfier" ; -- dimorfi..nn.1
  dimorfism_1_N = mkN "dimorfism" "dimorfismer" ; -- dimorfism..nn.1
  dimpa_1_V = mkV "dimpa" "damp" "dumpit" ; -- dimpa..vb.1
  dimpande_1_N = mkN "dimpande" ; -- dimpande..nn.1
  dimridå_1_N = mkN "dimridå" "dimridåer" ; -- dimridå..nn.1
  dimslöja_1_N = mkN "dimslöja" ; -- dimslöja..nn.1
  dinar_1_N = mkN "dinar" "dinarer" ; -- dinar..nn.1
  dinatriumvätefosfat_1_N = mkN "dinatriumvätefosfat" neutrum  ; -- dinatriumvätefosfat..nn.1
  dinera_1_V = mkV "dinerar" ; -- dinera..vb.1
  dinerande_1_N = mkN "dinerande" ; -- dinerande..nn.1
  dinering_1_N = mkN "dinering" ; -- dinering..nn.1
  ding_1_A = mkA "ding" ; -- ding..av.1
  dinge_1_N = mkN "dinge" utrum  ; -- dinge..nn.1
  dingeldangel_1_N = mkN "dingeldangel" neutrum  ; -- dingeldangel..nn.1
  dinghet_1_N = mkN "dinghet" ; -- dinghet..nn.1
  dingla_1_V = mkV "dinglar" ; -- dingla..vb.1
  dinglande_1_N = mkN "dinglande" ; -- dinglande..nn.1
  dingo_1_N = mkN "dingo" "dingor" ; -- dingo..nn.1
  dinkel_1_N = mkN "dinkel" ; -- dinkel..nn.1
  dinosaur_1_N = mkN "dinosaur" "dinosaurer" ; -- dinosaur..nn.1
  dinosaurie_1_N = mkN "dinosaurie" "dinosaurier" ; -- dinosaurie..nn.1
  dinosaurieart_1_N = mkN "dinosaurieart" "dinosauriearter" ; -- dinosaurieart..nn.1
  diné_1_N = mkN "diné" "dinéer" ; -- diné..nn.1
  diod_1_N = mkN "diod" "dioder" ; -- diod..nn.1
  dionysisk_1_A = mkA "dionysisk" ; -- dionysisk..av.1
  diopter_1_N = mkN "diopter" ; -- diopter..nn.1
  dioptri_1_N = mkN "dioptri" "dioptrier" ; -- dioptri..nn.1
  dioptrik_1_N = mkN "dioptrik" ; -- dioptrik..nn.1
  dioptrisk_1_A = mkA "dioptrisk" ; -- dioptrisk..av.1
  diorama_1_N = mkN "diorama" "dioramat" "dioramor" "dioramorna" ; -- diorama..nn.1
  diorit_1_N = mkN "diorit" "dioriter" ; -- diorit..nn.1
  dioskur_1_N = mkN "dioskur" "dioskurer" ; -- dioskur..nn.1
  dioxin_1_N = mkN "dioxin" "dioxinet" "dioxiner" "dioxinerna" ; -- dioxin..nn.1
  dip_1_N = mkN "dip" ; -- dip..nn.1
  diperiod_1_N = mkN "diperiod" "diperioder" ; -- diperiod..nn.1
  diploid_1_A = mkA "diploid" ; -- diploid..av.1
  diplom_1_N = mkN "diplom" neutrum  ; -- diplom..nn.1
  diplomat_1_N = mkN "diplomat" "diplomater" ; -- diplomat..nn.1
  diplomatarisk_1_A = mkA "diplomatarisk" ; -- diplomatarisk..av.1
  diplomatarium_1_N = mkN "diplomatarium" "diplomatariet" "diplomatarier" "diplomatarierna" ; -- diplomatarium..nn.1
  diplomatbostad_1_N = mkN "diplomatbostad" "diplomatbostäder" ; -- diplomatbostad..nn.1
  diplomatdotter_1_N = mkN "diplomatdotter" "diplomatdottern" "diplomatdöttrar" "diplomatdöttrarna" ; -- diplomatdotter..nn.1
  diplomathustru_1_N = mkN "diplomathustru" "diplomathustrun" "diplomathustrur" "diplomathustrurna" ; -- diplomathustru..nn.1
  diplomati_1_N = mkN "diplomati" ; -- diplomati..nn.1
  diplomatik_1_N = mkN "diplomatik" ; -- diplomatik..nn.1
  diplomatisk_1_A = mkA "diplomatisk" ; -- diplomatisk..av.1
  diplomatisk_2_A = mkA "diplomatisk" ; -- diplomatisk..av.2
  diplomatkrets_1_N = mkN "diplomatkrets" ; -- diplomatkrets..nn.1
  diplomatkälla_1_N = mkN "diplomatkälla" ; -- diplomatkälla..nn.1
  diplomatkår_1_N = mkN "diplomatkår" "diplomatkårer" ; -- diplomatkår..nn.1
  diplomatpass_1_N = mkN "diplomatpass" neutrum  ; -- diplomatpass..nn.1
  diplomatportfölj_1_N = mkN "diplomatportfölj" "diplomatportföljer" ; -- diplomatportfölj..nn.1
  diplomatpost_1_N = mkN "diplomatpost" ; -- diplomatpost..nn.1
  diplomera_1_V = mkV "diplomerar" ; -- diplomera..vb.1
  diplomerande_1_N = mkN "diplomerande" ; -- diplomerande..nn.1
  diplomerbar_1_A = mkA "diplomerbar" ; -- diplomerbar..av.1
  diplomerbarhet_1_N = mkN "diplomerbarhet" ; -- diplomerbarhet..nn.1
  diplomering_1_N = mkN "diplomering" ; -- diplomering..nn.1
  diplomingenjör_1_N = mkN "diplomingenjör" "diplomingenjörer" ; -- diplomingenjör..nn.1
  dipmix_1_N = mkN "dipmix" ; -- dipmix..nn.1
  dipol_1_N = mkN "dipol" "dipoler" ; -- dipol..nn.1
  dipp_1_N = mkN "dipp" ; -- dipp..nn.1
  dippa_1_V = mkV "dippar" ; -- dippa..vb.1
  dippa_2_V = mkV "dippar" ; -- dippa..vb.2
  dippande_1_N = mkN "dippande" ; -- dippande..nn.1
  dipsan_1_N = mkN "dipsan" neutrum  ; -- dipsan..nn.1
  dipsoman_1_N = mkN "dipsoman" "dipsomaner" ; -- dipsoman..nn.1
  dipsomani_1_N = mkN "dipsomani" ; -- dipsomani..nn.1
  diptyk_1_N = mkN "diptyk" "diptyker" ; -- diptyk..nn.1
  direkt_1_A = mkA "direkt" "direkt" ; -- direkt..av.1
  direktdemokrati_1_N = mkN "direktdemokrati" ; -- direktdemokrati..nn.1
  direktflyg_1_N = mkN "direktflyg" neutrum  ; -- direktflyg..nn.1
  direkthet_1_N = mkN "direkthet" "direktheter" ; -- direkthet..nn.1
  direktinflytande_1_N = mkN "direktinflytande" ; -- direktinflytande..nn.1
  direktinsprutning_1_N = mkN "direktinsprutning" ; -- direktinsprutning..nn.1
  direktion_1_N = mkN "direktion" ; -- direktion..nn.1
  direktionskraft_1_N = mkN "direktionskraft" ; -- direktionskraft..nn.1
  direktiv_1_N = mkN "direktiv" neutrum  ; -- direktiv..nn.1
  direktkonfrontation_1_N = mkN "direktkonfrontation" ; -- direktkonfrontation..nn.1
  direktkontakt_1_N = mkN "direktkontakt" "direktkontakter" ; -- direktkontakt..nn.1
  direktlinje_1_N = mkN "direktlinje" "direktlinjer" ; -- direktlinje..nn.1
  direktlyftande_1_A = mkA "direktlyftande" ; -- direktlyftande..av.1
  direktmetod_1_N = mkN "direktmetod" "direktmetoder" ; -- direktmetod..nn.1
  direktor_1_N = mkN "direktor" "direktorer" ; -- direktor..nn.1
  direktreferat_1_N = mkN "direktreferat" neutrum  ; -- direktreferat..nn.1
  direktreklam_1_N = mkN "direktreklam" ; -- direktreklam..nn.1
  direktreklamsbolag_1_N = mkN "direktreklamsbolag" neutrum  ; -- direktreklamsbolag..nn.1
  direktremiss_1_N = mkN "direktremiss" "direktremisser" ; -- direktremiss..nn.1
  direktris_1_N = mkN "direktris" "direktriser" ; -- direktris..nn.1
  direktskott_1_N = mkN "direktskott" neutrum  ; -- direktskott..nn.1
  direktsända_1_V = mkV "direktsänder" ; -- direktsända..vb.1
  direktsändande_1_N = mkN "direktsändande" ; -- direktsändande..nn.1
  direktsändning_1_N = mkN "direktsändning" ; -- direktsändning..nn.1
  direktträff_1_N = mkN "direktträff" ; -- direktträff..nn.1
  direktverkande_1_A = mkA "direktverkande" ; -- direktverkande..av.1
  direktväxel_1_N = mkN "direktväxel" ; -- direktväxel..nn.1
  direktör_1_N = mkN "direktör" "direktörer" ; -- direktör..nn.1
  dirigent_1_N = mkN "dirigent" "dirigenter" ; -- dirigent..nn.1
  dirigera_1_V = mkV "dirigerar" ; -- dirigera..vb.1
  dirigerande_1_N = mkN "dirigerande" ; -- dirigerande..nn.1
  dirigerbar_1_A = mkA "dirigerbar" ; -- dirigerbar..av.1
  dirigerbarhet_1_N = mkN "dirigerbarhet" ; -- dirigerbarhet..nn.1
  dirigering_1_N = mkN "dirigering" ; -- dirigering..nn.1
  dirigism_1_N = mkN "dirigism" "dirigismer" ; -- dirigism..nn.1
  dirk_1_N = mkN "dirk" ; -- dirk..nn.1
  dirka_1_V = mkV "dirkar" ; -- dirka..vb.1
  dirkande_1_N = mkN "dirkande" ; -- dirkande..nn.1
  dirra_1_V = mkV "dirrar" ; -- dirra..vb.1
  dirrande_1_N = mkN "dirrande" ; -- dirrande..nn.1
  dis_1_N = mkN "dis" neutrum  ; -- dis..nn.1
  dis_2_N = mkN "dis" "diser" ; -- dis..nn.2
  disackarid_1_N = mkN "disackarid" "disackarider" ; -- disackarid..nn.1
  disambiguera_1_V = mkV "disambiguerar" ; -- disambiguera..vb.1
  disambiguerande_1_N = mkN "disambiguerande" ; -- disambiguerande..nn.1
  disambiguerbar_1_A = mkA "disambiguerbar" ; -- disambiguerbar..av.1
  disambiguerbarhet_1_N = mkN "disambiguerbarhet" ; -- disambiguerbarhet..nn.1
  discipel_1_N = mkN "discipel" ; -- discipel..nn.1
  disciplin_1_N = mkN "disciplin" "discipliner" ; -- disciplin..nn.1
  disciplinbot_1_N = mkN "disciplinbot" "disciplinböter" ; -- disciplinbot..nn.1
  disciplinera_1_V = mkV "disciplinerar" ; -- disciplinera..vb.1
  disciplinerad_1_A = mkA "disciplinerad" ; -- disciplinerad..av.1
  disciplinerande_1_N = mkN "disciplinerande" ; -- disciplinerande..nn.1
  disciplinerbar_1_A = mkA "disciplinerbar" ; -- disciplinerbar..av.1
  disciplinerbarhet_1_N = mkN "disciplinerbarhet" ; -- disciplinerbarhet..nn.1
  disciplinering_1_N = mkN "disciplinering" ; -- disciplinering..nn.1
  disciplingräns_1_N = mkN "disciplingräns" "disciplingränser" ; -- disciplingräns..nn.1
  disciplinmål_1_N = mkN "disciplinmål" neutrum  ; -- disciplinmål..nn.1
  disciplinnämnd_1_N = mkN "disciplinnämnd" "disciplinnämnder" ; -- disciplinnämnd..nn.1
  disciplinpåföljd_1_N = mkN "disciplinpåföljd" "disciplinpåföljder" ; -- disciplinpåföljd..nn.1
  disciplinstraff_1_N = mkN "disciplinstraff" neutrum  ; -- disciplinstraff..nn.1
  disciplinstress_1_N = mkN "disciplinstress" ; -- disciplinstress..nn.1
  disciplinär_1_A = mkA "disciplinär" ; -- disciplinär..av.1
  disciplinärende_1_N = mkN "disciplinärende" ; -- disciplinärende..nn.1
  discjockey_1_N = mkN "discjockey" ; -- discjockey..nn.1
  disco_1_N = mkN "disco" "discot" "discon" "discona" ; -- disco..nn.1
  disco_2_N = mkN "disco" ; -- disco..nn.2
  discokula_1_N = mkN "discokula" ; -- discokula..nn.1
  discomusik_1_N = mkN "discomusik" ; -- discomusik..nn.1
  disharmoni_1_N = mkN "disharmoni" "disharmonier" ; -- disharmoni..nn.1
  disharmoniera_1_V = mkV "disharmonierar" ; -- disharmoniera..vb.1
  disharmonierande_1_N = mkN "disharmonierande" ; -- disharmonierande..nn.1
  disharmonierbar_1_A = mkA "disharmonierbar" ; -- disharmonierbar..av.1
  disharmonierbarhet_1_N = mkN "disharmonierbarhet" ; -- disharmonierbarhet..nn.1
  disharmoniering_1_N = mkN "disharmoniering" ; -- disharmoniering..nn.1
  disharmonisk_1_A = mkA "disharmonisk" ; -- disharmonisk..av.1
  disig_1_A = mkA "disig" ; -- disig..av.1
  disighet_1_N = mkN "disighet" ; -- disighet..nn.1
  disjunkt_1_A = mkA "disjunkt" "disjunkt" ; -- disjunkt..av.1
  disjunktion_1_N = mkN "disjunktion" ; -- disjunktion..nn.1
  disjunktiv_1_A = mkA "disjunktiv" ; -- disjunktiv..av.1
  disk_1_N = mkN "disk" ; -- disk..nn.1
  diska_1_V = mkV "diskar" ; -- diska..vb.1
  diska_2_V = mkV "diskar" ; -- diska..vb.2
  diskande_1_N = mkN "diskande" ; -- diskande..nn.1
  diskant_1_N = mkN "diskant" "diskanter" ; -- diskant..nn.1
  diskantklav_1_N = mkN "diskantklav" "diskantklaver" ; -- diskantklav..nn.1
  diskare_1_N = mkN "diskare" utrum  ; -- diskare..nn.1
  diskbalja_1_N = mkN "diskbalja" ; -- diskbalja..nn.1
  diskblomma_1_N = mkN "diskblomma" ; -- diskblomma..nn.1
  diskbrock_1_N = mkN "diskbrock" neutrum  ; -- diskbrock..nn.1
  diskbråck_1_N = mkN "diskbråck" neutrum  ; -- diskbråck..nn.1
  diskbänk_1_N = mkN "diskbänk" ; -- diskbänk..nn.1
  diskett_1_N = mkN "diskett" "disketter" ; -- diskett..nn.1
  diskhandske_1_N = mkN "diskhandske" utrum  ; -- diskhandske..nn.1
  diskho_1_N = mkN "diskho" ; -- diskho..nn.1
  diskjockey_1_N = mkN "diskjockey" ; -- diskjockey..nn.1
  diskmaskin_1_N = mkN "diskmaskin" "diskmaskiner" ; -- diskmaskin..nn.1
  diskmedel_1_N = mkN "diskmedel" neutrum  ; -- diskmedel..nn.1
  diskning_1_N = mkN "diskning" ; -- diskning..nn.1
  diskning_2_N = mkN "diskning" ; -- diskning..nn.2
  disko_1_N = mkN "disko" "diskot" "diskon" "diskona" ; -- disko..nn.1
  disko_2_N = mkN "disko" ; -- disko..nn.2
  diskofil_1_N = mkN "diskofil" "diskofiler" ; -- diskofil..nn.1
  diskomusik_1_N = mkN "diskomusik" ; -- diskomusik..nn.1
  diskontera_1_V = mkV "diskonterar" ; -- diskontera..vb.1
  diskonterande_1_N = mkN "diskonterande" ; -- diskonterande..nn.1
  diskonterbar_1_A = mkA "diskonterbar" ; -- diskonterbar..av.1
  diskonterbarhet_1_N = mkN "diskonterbarhet" ; -- diskonterbarhet..nn.1
  diskontering_1_N = mkN "diskontering" ; -- diskontering..nn.1
  diskontinuerlig_1_A = mkA "diskontinuerlig" ; -- diskontinuerlig..av.1
  diskontinuerlighet_1_N = mkN "diskontinuerlighet" ; -- diskontinuerlighet..nn.1
  diskontinuitet_1_N = mkN "diskontinuitet" "diskontinuiteter" ; -- diskontinuitet..nn.1
  diskontnota_1_N = mkN "diskontnota" ; -- diskontnota..nn.1
  diskonto_1_N = mkN "diskonto" "diskontot" "diskonton" "diskontona" ; -- diskonto..nn.1
  diskontör_1_N = mkN "diskontör" "diskontörer" ; -- diskontör..nn.1
  diskordans_1_N = mkN "diskordans" "diskordanser" ; -- diskordans..nn.1
  diskordant_1_A = mkA "diskordant" "diskordant" ; -- diskordant..av.1
  diskotek_1_N = mkN "diskotek" neutrum  ; -- diskotek..nn.1
  diskplockare_1_N = mkN "diskplockare" utrum  ; -- diskplockare..nn.1
  diskreditera_1_V = mkV "diskrediterar" ; -- diskreditera..vb.1
  diskrediterande_1_N = mkN "diskrediterande" ; -- diskrediterande..nn.1
  diskrediterbar_1_A = mkA "diskrediterbar" ; -- diskrediterbar..av.1
  diskrediterbarhet_1_N = mkN "diskrediterbarhet" ; -- diskrediterbarhet..nn.1
  diskreditering_1_N = mkN "diskreditering" ; -- diskreditering..nn.1
  diskrepans_1_N = mkN "diskrepans" "diskrepanser" ; -- diskrepans..nn.1
  diskret_1_A = mkA "diskret" "diskret" ; -- diskret..av.1
  diskretion_1_N = mkN "diskretion" ; -- diskretion..nn.1
  diskriminera_1_V = mkV "diskriminerar" ; -- diskriminera..vb.1
  diskriminerande_1_N = mkN "diskriminerande" ; -- diskriminerande..nn.1
  diskriminerbar_1_A = mkA "diskriminerbar" ; -- diskriminerbar..av.1
  diskriminerbarhet_1_N = mkN "diskriminerbarhet" ; -- diskriminerbarhet..nn.1
  diskriminering_1_N = mkN "diskriminering" ; -- diskriminering..nn.1
  diskrimineringsbekämpning_1_N = mkN "diskrimineringsbekämpning" ; -- diskrimineringsbekämpning..nn.1
  diskrimineringslagstiftning_1_N = mkN "diskrimineringslagstiftning" ; -- diskrimineringslagstiftning..nn.1
  diskrum_1_N = mkN "diskrum" "diskrummet" "diskrum" "diskrummen" ; -- diskrum..nn.1
  diskställ_1_N = mkN "diskställ" neutrum  ; -- diskställ..nn.1
  disktorkning_1_N = mkN "disktorkning" ; -- disktorkning..nn.1
  disktrasa_1_N = mkN "disktrasa" ; -- disktrasa..nn.1
  diskurs_1_N = mkN "diskurs" "diskurser" ; -- diskurs..nn.1
  diskursiv_1_A = mkA "diskursiv" ; -- diskursiv..av.1
  diskus_1_N = mkN "diskus" ; -- diskus..nn.1
  diskuskastare_1_N = mkN "diskuskastare" utrum  ; -- diskuskastare..nn.1
  diskuskastning_1_N = mkN "diskuskastning" ; -- diskuskastning..nn.1
  diskussion_1_N = mkN "diskussion" ; -- diskussion..nn.1
  diskussionsforum_1_N = mkN "diskussionsforum" neutrum  ; -- diskussionsforum..nn.1
  diskussionsprotokoll_1_N = mkN "diskussionsprotokoll" neutrum  ; -- diskussionsprotokoll..nn.1
  diskussionsunderlag_1_N = mkN "diskussionsunderlag" neutrum  ; -- diskussionsunderlag..nn.1
  diskussionsämne_1_N = mkN "diskussionsämne" ; -- diskussionsämne..nn.1
  diskutabel_1_A = mkA "diskutabel" ; -- diskutabel..av.1
  diskutera_1_V = mkV "diskuterar" ; -- diskutera..vb.1
  diskuterande_1_N = mkN "diskuterande" ; -- diskuterande..nn.1
  diskuterbar_1_A = mkA "diskuterbar" ; -- diskuterbar..av.1
  diskuterbarhet_1_N = mkN "diskuterbarhet" ; -- diskuterbarhet..nn.1
  diskutering_1_N = mkN "diskutering" ; -- diskutering..nn.1
  diskvalificera_1_V = mkV "diskvalificerar" ; -- diskvalificera..vb.1
  diskvalificerande_1_N = mkN "diskvalificerande" ; -- diskvalificerande..nn.1
  diskvalificerbar_1_A = mkA "diskvalificerbar" ; -- diskvalificerbar..av.1
  diskvalificerbarhet_1_N = mkN "diskvalificerbarhet" ; -- diskvalificerbarhet..nn.1
  diskvalificering_1_N = mkN "diskvalificering" ; -- diskvalificering..nn.1
  diskvalifikation_1_N = mkN "diskvalifikation" ; -- diskvalifikation..nn.1
  diskvatten_1_N = mkN "diskvatten" "diskvattnet" "diskvatten" "diskvattnen" ; -- diskvatten..nn.1
  dislokation_1_N = mkN "dislokation" ; -- dislokation..nn.1
  disparat_1_A = mkA "disparat" "disparat" ; -- disparat..av.1
  dispasch_1_N = mkN "dispasch" "dispascher" ; -- dispasch..nn.1
  dispaschera_1_V = mkV "dispascherar" ; -- dispaschera..vb.1
  dispascherande_1_N = mkN "dispascherande" ; -- dispascherande..nn.1
  dispascherbar_1_A = mkA "dispascherbar" ; -- dispascherbar..av.1
  dispascherbarhet_1_N = mkN "dispascherbarhet" ; -- dispascherbarhet..nn.1
  dispaschering_1_N = mkN "dispaschering" ; -- dispaschering..nn.1
  dispaschör_1_N = mkN "dispaschör" "dispaschörer" ; -- dispaschör..nn.1
  dispens_1_N = mkN "dispens" "dispenser" ; -- dispens..nn.1
  dispensera_1_V = mkV "dispenserar" ; -- dispensera..vb.1
  dispenserande_1_N = mkN "dispenserande" ; -- dispenserande..nn.1
  dispenserbar_1_A = mkA "dispenserbar" ; -- dispenserbar..av.1
  dispenserbarhet_1_N = mkN "dispenserbarhet" ; -- dispenserbarhet..nn.1
  dispensering_1_N = mkN "dispensering" ; -- dispensering..nn.1
  dispensär_1_N = mkN "dispensär" "dispensärer" ; -- dispensär..nn.1
  dispergera_1_V = mkV "dispergerar" ; -- dispergera..vb.1
  dispergerande_1_N = mkN "dispergerande" ; -- dispergerande..nn.1
  dispergerbar_1_A = mkA "dispergerbar" ; -- dispergerbar..av.1
  dispergerbarhet_1_N = mkN "dispergerbarhet" ; -- dispergerbarhet..nn.1
  dispergering_1_N = mkN "dispergering" ; -- dispergering..nn.1
  dispers_1_A = mkA "dispers" ; -- dispers..av.1
  dispersion_1_N = mkN "dispersion" ; -- dispersion..nn.1
  display_1_N = mkN "display" "displayen" "displayer" "displayerna" ; -- display..nn.1
  disponent_1_N = mkN "disponent" "disponenter" ; -- disponent..nn.1
  disponera_1_V = mkV "disponerar" ; -- disponera..vb.1
  disponerad_1_A = mkA "disponerad" ; -- disponerad..av.1
  disponerande_1_N = mkN "disponerande" ; -- disponerande..nn.1
  disponerbar_1_A = mkA "disponerbar" ; -- disponerbar..av.1
  disponerbarhet_1_N = mkN "disponerbarhet" ; -- disponerbarhet..nn.1
  disponering_1_N = mkN "disponering" ; -- disponering..nn.1
  disponibel_1_A = mkA "disponibel" ; -- disponibel..av.1
  disponibilitet_1_N = mkN "disponibilitet" "disponibiliteter" ; -- disponibilitet..nn.1
  disposition_1_N = mkN "disposition" ; -- disposition..nn.1
  dispositionsfond_1_N = mkN "dispositionsfond" "dispositionsfonder" ; -- dispositionsfond..nn.1
  dispositionsrätt_1_N = mkN "dispositionsrätt" ; -- dispositionsrätt..nn.1
  dispositiv_1_A = mkA "dispositiv" ; -- dispositiv..av.1
  disproportion_1_N = mkN "disproportion" ; -- disproportion..nn.1
  disproportionerlig_1_A = mkA "disproportionerlig" ; -- disproportionerlig..av.1
  disproportionerlighet_1_N = mkN "disproportionerlighet" ; -- disproportionerlighet..nn.1
  disputation_1_N = mkN "disputation" ; -- disputation..nn.1
  disputationsakt_1_N = mkN "disputationsakt" "disputationsakter" ; -- disputationsakt..nn.1
  disputera_1_V = mkV "disputerar" ; -- disputera..vb.1
  disputerande_1_N = mkN "disputerande" ; -- disputerande..nn.1
  disputerbar_1_A = mkA "disputerbar" ; -- disputerbar..av.1
  disputerbarhet_1_N = mkN "disputerbarhet" ; -- disputerbarhet..nn.1
  disputering_1_N = mkN "disputering" ; -- disputering..nn.1
  dispyt_1_N = mkN "dispyt" "dispyter" ; -- dispyt..nn.1
  diss_1_N = mkN "diss" neutrum  ; -- diss..nn.1
  dissa_1_V = mkV "dissar" ; -- dissa..vb.1
  dissande_1_N = mkN "dissande" ; -- dissande..nn.1
  dissekera_1_V = mkV "dissekerar" ; -- dissekera..vb.1
  dissekerande_1_N = mkN "dissekerande" ; -- dissekerande..nn.1
  dissekerbar_1_A = mkA "dissekerbar" ; -- dissekerbar..av.1
  dissekerbarhet_1_N = mkN "dissekerbarhet" ; -- dissekerbarhet..nn.1
  dissekering_1_N = mkN "dissekering" ; -- dissekering..nn.1
  dissektion_1_N = mkN "dissektion" ; -- dissektion..nn.1
  dissenter_1_N = mkN "dissenter" "dissentern" "dissenters" "dissentersen" ; -- dissenter..nn.1
  dissertation_1_N = mkN "dissertation" ; -- dissertation..nn.1
  dissident_1_N = mkN "dissident" "dissidenter" ; -- dissident..nn.1
  dissimilation_1_N = mkN "dissimilation" ; -- dissimilation..nn.1
  dissimilera_1_V = mkV "dissimilerar" ; -- dissimilera..vb.1
  dissimilerande_1_N = mkN "dissimilerande" ; -- dissimilerande..nn.1
  dissimilerbar_1_A = mkA "dissimilerbar" ; -- dissimilerbar..av.1
  dissimilerbarhet_1_N = mkN "dissimilerbarhet" ; -- dissimilerbarhet..nn.1
  dissimilering_1_N = mkN "dissimilering" ; -- dissimilering..nn.1
  dissociation_1_N = mkN "dissociation" ; -- dissociation..nn.1
  dissociera_1_V = mkV "dissocierar" ; -- dissociera..vb.1
  dissocierande_1_N = mkN "dissocierande" ; -- dissocierande..nn.1
  dissocierbar_1_A = mkA "dissocierbar" ; -- dissocierbar..av.1
  dissocierbarhet_1_N = mkN "dissocierbarhet" ; -- dissocierbarhet..nn.1
  dissociering_1_N = mkN "dissociering" ; -- dissociering..nn.1
  dissonans_1_N = mkN "dissonans" "dissonanser" ; -- dissonans..nn.1
  dissonant_1_A = mkA "dissonant" "dissonant" ; -- dissonant..av.1
  dissonant_1_N = mkN "dissonant" "dissonanter" ; -- dissonant..nn.1
  dissonera_1_V = mkV "dissonerar" ; -- dissonera..vb.1
  dissonerande_1_N = mkN "dissonerande" ; -- dissonerande..nn.1
  dissonering_1_N = mkN "dissonering" ; -- dissonering..nn.1
  distans_1_N = mkN "distans" "distanser" ; -- distans..nn.1
  distansbygel_1_N = mkN "distansbygel" ; -- distansbygel..nn.1
  distansera_1_V = mkV "distanserar" ; -- distansera..vb.1
  distanserande_1_N = mkN "distanserande" ; -- distanserande..nn.1
  distanserbar_1_A = mkA "distanserbar" ; -- distanserbar..av.1
  distanserbarhet_1_N = mkN "distanserbarhet" ; -- distanserbarhet..nn.1
  distansering_1_N = mkN "distansering" ; -- distansering..nn.1
  distansflygning_1_N = mkN "distansflygning" ; -- distansflygning..nn.1
  distanshögskola_1_N = mkN "distanshögskola" ; -- distanshögskola..nn.1
  distanslös_1_A = mkA "distanslös" ; -- distanslös..av.1
  distansminut_1_N = mkN "distansminut" "distansminuten" "distansminutrar" "distansminutrarna" ; -- distansminut..nn.1
  distansmätare_1_N = mkN "distansmätare" utrum  ; -- distansmätare..nn.1
  distansmätning_1_N = mkN "distansmätning" ; -- distansmätning..nn.1
  distansritt_1_N = mkN "distansritt" ; -- distansritt..nn.1
  distansundervisning_1_N = mkN "distansundervisning" ; -- distansundervisning..nn.1
  distikon_1_N = mkN "distikon" neutrum  ; -- distikon..nn.1
  disting_1_N = mkN "disting" neutrum  ; -- disting..nn.1
  distingerad_1_A = mkA "distingerad" ; -- distingerad..av.1
  distinkt_1_A = mkA "distinkt" "distinkt" ; -- distinkt..av.1
  distinktion_1_N = mkN "distinktion" ; -- distinktion..nn.1
  distorsion_1_N = mkN "distorsion" ; -- distorsion..nn.1
  distrahera_1_V = mkV "distraherar" ; -- distrahera..vb.1
  distraherad_1_A = mkA "distraherad" ; -- distraherad..av.1
  distraherande_1_N = mkN "distraherande" ; -- distraherande..nn.1
  distraherbar_1_A = mkA "distraherbar" ; -- distraherbar..av.1
  distraherbarhet_1_N = mkN "distraherbarhet" ; -- distraherbarhet..nn.1
  distrahering_1_N = mkN "distrahering" ; -- distrahering..nn.1
  distraktion_1_N = mkN "distraktion" ; -- distraktion..nn.1
  distraktor_1_N = mkN "distraktor" "distraktorer" ; -- distraktor..nn.1
  distribuent_1_N = mkN "distribuent" "distribuenter" ; -- distribuent..nn.1
  distribuera_1_V = mkV "distribuerar" ; -- distribuera..vb.1
  distribuerande_1_N = mkN "distribuerande" ; -- distribuerande..nn.1
  distribuerbar_1_A = mkA "distribuerbar" ; -- distribuerbar..av.1
  distribuerbarhet_1_N = mkN "distribuerbarhet" ; -- distribuerbarhet..nn.1
  distribuering_1_N = mkN "distribuering" ; -- distribuering..nn.1
  distribunal_1_N = mkN "distribunal" "distribunaler" ; -- distribunal..nn.1
  distribution_1_N = mkN "distribution" ; -- distribution..nn.1
  distributionscentral_1_N = mkN "distributionscentral" "distributionscentraler" ; -- distributionscentral..nn.1
  distributionsföretag_1_N = mkN "distributionsföretag" neutrum  ; -- distributionsföretag..nn.1
  distributiv_1_A = mkA "distributiv" ; -- distributiv..av.1
  distributör_1_N = mkN "distributör" "distributörer" ; -- distributör..nn.1
  distrikt_1_N = mkN "distrikt" neutrum  ; -- distrikt..nn.1
  distriktsläkare_1_N = mkN "distriktsläkare" utrum  ; -- distriktsläkare..nn.1
  distriktsmästare_1_N = mkN "distriktsmästare" utrum  ; -- distriktsmästare..nn.1
  distriktsmästerskap_1_N = mkN "distriktsmästerskap" neutrum  ; -- distriktsmästerskap..nn.1
  distriktsordförande_1_N = mkN "distriktsordförande" "distriktsordföranden" "distriktsordföranden" "distriktsordförandena" ; -- distriktsordförande..nn.1
  disträ_1_A = mkA "disträ" ; -- disträ..av.1
  disös_1_N = mkN "disös" "disöser" ; -- disös..nn.1
  ditflugen_1_A = mkA "ditflugen" ; -- ditflugen..av.1
  ditfärd_1_N = mkN "ditfärd" ; -- ditfärd..nn.1
  dithörande_1_A = mkA "dithörande" ; -- dithörande..av.1
  ditin_1_Adv = mkAdv "ditin" ; -- ditin..ab.1
  ditkomst_1_N = mkN "ditkomst" ; -- ditkomst..nn.1
  dito_1_A = mkA "dito" ; -- dito..av.1
  ditresa_1_N = mkN "ditresa" ; -- ditresa..nn.1
  dittillsvarande_1_A = mkA "dittillsvarande" ; -- dittillsvarande..av.1
  ditut_1_Adv = mkAdv "ditut" ; -- ditut..ab.1
  dityramb_1_N = mkN "dityramb" "dityramber" ; -- dityramb..nn.1
  dityrambisk_1_A = mkA "dityrambisk" ; -- dityrambisk..av.1
  diva_1_N = mkN "diva" ; -- diva..nn.1
  divan_1_N = mkN "divan" "divaner" ; -- divan..nn.1
  divergens_1_N = mkN "divergens" "divergenser" ; -- divergens..nn.1
  divergent_1_A = mkA "divergent" "divergent" ; -- divergent..av.1
  divergera_1_V = mkV "divergerar" ; -- divergera..vb.1
  divergerande_1_N = mkN "divergerande" ; -- divergerande..nn.1
  divergerbar_1_A = mkA "divergerbar" ; -- divergerbar..av.1
  divergerbarhet_1_N = mkN "divergerbarhet" ; -- divergerbarhet..nn.1
  divergering_1_N = mkN "divergering" ; -- divergering..nn.1
  diverse_1_A = mkA "diverse" ; -- diverse..av.1
  diversearbetare_1_N = mkN "diversearbetare" utrum  ; -- diversearbetare..nn.1
  diversehandel_1_N = mkN "diversehandel" ; -- diversehandel..nn.1
  diversifiera_1_V = mkV "diversifierar" ; -- diversifiera..vb.1
  diversifierande_1_N = mkN "diversifierande" ; -- diversifierande..nn.1
  diversifierbar_1_A = mkA "diversifierbar" ; -- diversifierbar..av.1
  diversifierbarhet_1_N = mkN "diversifierbarhet" ; -- diversifierbarhet..nn.1
  diversifiering_1_N = mkN "diversifiering" ; -- diversifiering..nn.1
  diversion_1_N = mkN "diversion" ; -- diversion..nn.1
  divertissemang_1_N = mkN "divertissemang" neutrum  ; -- divertissemang..nn.1
  dividend_1_N = mkN "dividend" "dividender" ; -- dividend..nn.1
  dividera_1_V = mkV "dividerar" ; -- dividera..vb.1
  dividerande_1_N = mkN "dividerande" ; -- dividerande..nn.1
  dividerbar_1_A = mkA "dividerbar" ; -- dividerbar..av.1
  dividerbarhet_1_N = mkN "dividerbarhet" ; -- dividerbarhet..nn.1
  dividering_1_N = mkN "dividering" ; -- dividering..nn.1
  divig_1_A = mkA "divig" ; -- divig..av.1
  divinatorisk_1_A = mkA "divinatorisk" ; -- divinatorisk..av.1
  divis_1_N = mkN "divis" "diviser" ; -- divis..nn.1
  division_1_N = mkN "division" ; -- division..nn.1
  divisionschef_1_N = mkN "divisionschef" "divisionschefer" ; -- divisionschef..nn.1
  divisionsfana_1_N = mkN "divisionsfana" ; -- divisionsfana..nn.1
  divisionsgeneral_1_N = mkN "divisionsgeneral" "divisionsgeneraler" ; -- divisionsgeneral..nn.1
  divisor_1_N = mkN "divisor" "divisorer" ; -- divisor..nn.1
  dixieland_1_N = mkN "dixieland" ; -- dixieland..nn.1
  djiboutier_1_N = mkN "djiboutier" "djiboutiern" "djiboutier" "djiboutierna" ; -- djiboutier..nn.1
  djiboutisk_1_A = mkA "djiboutisk" ; -- djiboutisk..av.1
  djiboutiska_1_N = mkN "djiboutiska" ; -- djiboutiska..nn.1
  djonk_1_N = mkN "djonk" "djonker" ; -- djonk..nn.1
  djungel_1_N = mkN "djungel" "djungeln" "djungler" "djunglerna" ; -- djungel..nn.1
  djungelbryn_1_N = mkN "djungelbryn" neutrum  ; -- djungelbryn..nn.1
  djungeltelegraf_1_N = mkN "djungeltelegraf" ; -- djungeltelegraf..nn.1
  djup_1_A = mkA "djup" ; -- djup..av.1
  djup_1_N = mkN "djup" neutrum  ; -- djup..nn.1
  djupavslappning_1_N = mkN "djupavslappning" ; -- djupavslappning..nn.1
  djupbergart_1_N = mkN "djupbergart" "djupbergarter" ; -- djupbergart..nn.1
  djupbild_1_N = mkN "djupbild" "djupbilder" ; -- djupbild..nn.1
  djupblå_1_A = mkA "djupblå" "djupblått" ; -- djupblå..av.1
  djupborra_1_V = mkV "djupborrar" ; -- djupborra..vb.1
  djupborrad_1_A = mkA "djupborrad" ; -- djupborrad..av.1
  djupborrande_1_A = mkA "djupborrande" ; -- djupborrande..av.1
  djupborrande_1_N = mkN "djupborrande" ; -- djupborrande..nn.1
  djupborrning_1_N = mkN "djupborrning" ; -- djupborrning..nn.1
  djupbrytning_1_N = mkN "djupbrytning" ; -- djupbrytning..nn.1
  djupdimension_1_N = mkN "djupdimension" ; -- djupdimension..nn.1
  djupdykning_1_N = mkN "djupdykning" ; -- djupdykning..nn.1
  djupfrysa_1_V = mkV "djupfryser" ; -- djupfrysa..vb.1
  djupfrysande_1_N = mkN "djupfrysande" ; -- djupfrysande..nn.1
  djupfuktande_1_A = mkA "djupfuktande" ; -- djupfuktande..av.1
  djupgrön_1_A = mkA "djupgrön" ; -- djupgrön..av.1
  djupgående_1_A = mkA "djupgående" ; -- djupgående..av.1
  djupgående_1_N = mkN "djupgående" ; -- djupgående..nn.1
  djuphav_1_N = mkN "djuphav" neutrum  ; -- djuphav..nn.1
  djuphavsbotten_1_N = mkN "djuphavsbotten" ; -- djuphavsbotten..nn.1
  djuphavsfisk_1_N = mkN "djuphavsfisk" ; -- djuphavsfisk..nn.1
  djuphavsgrav_1_N = mkN "djuphavsgrav" ; -- djuphavsgrav..nn.1
  djuphavsvatten_1_N = mkN "djuphavsvatten" "djuphavsvattnet" "djuphavsvatten" "djuphavsvattnen" ; -- djuphavsvatten..nn.1
  djuphet_1_N = mkN "djuphet" ; -- djuphet..nn.1
  djuping_1_N = mkN "djuping" ; -- djuping..nn.1
  djupintervju_1_N = mkN "djupintervju" "djupintervjun" "djupintervjuer" "djupintervjuerna" ; -- djupintervju..nn.1
  djupkultur_1_N = mkN "djupkultur" ; -- djupkultur..nn.1
  djuplek_1_N = mkN "djuplek" ; -- djuplek..nn.1
  djuplod_1_N = mkN "djuplod" neutrum  ; -- djuplod..nn.1
  djuploda_1_V = mkV "djuplodar" ; -- djuploda..vb.1
  djuplodande_1_A = mkA "djuplodande" ; -- djuplodande..av.1
  djuplodande_1_N = mkN "djuplodande" ; -- djuplodande..nn.1
  djuplodning_1_N = mkN "djuplodning" ; -- djuplodning..nn.1
  djupmask_1_N = mkN "djupmask" ; -- djupmask..nn.1
  djupna_1_V = mkV "djupnar" ; -- djupna..vb.1
  djupnande_1_N = mkN "djupnande" ; -- djupnande..nn.1
  djuppsykologi_1_N = mkN "djuppsykologi" ; -- djuppsykologi..nn.1
  djuprengörande_1_A = mkA "djuprengörande" ; -- djuprengörande..av.1
  djuprotad_1_A = mkA "djuprotad" ; -- djuprotad..av.1
  djupröd_1_A = mkA "djupröd" "djuprött" ; -- djupröd..av.1
  djupsinne_1_N = mkN "djupsinne" ; -- djupsinne..nn.1
  djupsinnig_1_A = mkA "djupsinnig" ; -- djupsinnig..av.1
  djupsinnighet_1_N = mkN "djupsinnighet" "djupsinnigheter" ; -- djupsinnighet..nn.1
  djupstruktur_1_N = mkN "djupstruktur" "djupstrukturer" ; -- djupstruktur..nn.1
  djupsömn_1_N = mkN "djupsömn" ; -- djupsömn..nn.1
  djuptallrik_1_N = mkN "djuptallrik" ; -- djuptallrik..nn.1
  djuptryck_1_N = mkN "djuptryck" neutrum  ; -- djuptryck..nn.1
  djuptänkt_1_A = mkA "djuptänkt" "djuptänkt" ; -- djuptänkt..av.1
  djuptänkthet_1_N = mkN "djuptänkthet" ; -- djuptänkthet..nn.1
  djupurladdning_1_N = mkN "djupurladdning" ; -- djupurladdning..nn.1
  djupvatten_1_N = mkN "djupvatten" "djupvattnet" "djupvatten" "djupvattnen" ; -- djupvatten..nn.1
  djur_1_N = mkN "djur" neutrum  ; -- djur..nn.1
  djuranatomi_1_N = mkN "djuranatomi" ; -- djuranatomi..nn.1
  djurangrepp_1_N = mkN "djurangrepp" neutrum  ; -- djurangrepp..nn.1
  djurart_1_N = mkN "djurart" "djurarter" ; -- djurart..nn.1
  djurben_1_N = mkN "djurben" neutrum  ; -- djurben..nn.1
  djurblod_1_N = mkN "djurblod" ; -- djurblod..nn.1
  djurbok_1_N = mkN "djurbok" "djurböcker" ; -- djurbok..nn.1
  djurdel_1_N = mkN "djurdel" "djurdelen" "djurdelar" "djurdelarna" ; -- djurdel..nn.1
  djurfabel_1_N = mkN "djurfabel" "djurfabeln" "djurfabler" "djurfablerna" ; -- djurfabel..nn.1
  djurfoder_1_N = mkN "djurfoder" neutrum  ; -- djurfoder..nn.1
  djurfot_1_N = mkN "djurfot" "djurfötter" ; -- djurfot..nn.1
  djurförbud_1_N = mkN "djurförbud" neutrum  ; -- djurförbud..nn.1
  djurförsök_1_N = mkN "djurförsök" neutrum  ; -- djurförsök..nn.1
  djurförädling_1_N = mkN "djurförädling" ; -- djurförädling..nn.1
  djurgeografi_1_N = mkN "djurgeografi" ; -- djurgeografi..nn.1
  djurgrupp_1_N = mkN "djurgrupp" "djurgrupper" ; -- djurgrupp..nn.1
  djurgård_1_N = mkN "djurgård" ; -- djurgård..nn.1
  djurhamn_1_N = mkN "djurhamn" ; -- djurhamn..nn.1
  djurhud_1_N = mkN "djurhud" ; -- djurhud..nn.1
  djurhuvud_1_N = mkN "djurhuvud" "djurhuvudet" "djurhuvud" "djurhuvudena" ; -- djurhuvud..nn.1
  djurhälsa_1_N = mkN "djurhälsa" ; -- djurhälsa..nn.1
  djurhållning_1_N = mkN "djurhållning" ; -- djurhållning..nn.1
  djurhövdad_1_A = mkA "djurhövdad" ; -- djurhövdad..av.1
  djurisk_1_A = mkA "djurisk" ; -- djurisk..av.1
  djuriskhet_1_N = mkN "djuriskhet" ; -- djuriskhet..nn.1
  djurkadaver_1_N = mkN "djurkadaver" neutrum  ; -- djurkadaver..nn.1
  djurkrets_1_N = mkN "djurkrets" ; -- djurkrets..nn.1
  djurkropp_1_N = mkN "djurkropp" ; -- djurkropp..nn.1
  djurliknande_1_A = mkA "djurliknande" ; -- djurliknande..av.1
  djurliv_1_N = mkN "djurliv" neutrum  ; -- djurliv..nn.1
  djurläkare_1_N = mkN "djurläkare" utrum  ; -- djurläkare..nn.1
  djurläte_1_N = mkN "djurläte" ; -- djurläte..nn.1
  djurmat_1_N = mkN "djurmat" ; -- djurmat..nn.1
  djurmålning_1_N = mkN "djurmålning" ; -- djurmålning..nn.1
  djurmålning_2_N = mkN "djurmålning" ; -- djurmålning..nn.2
  djurornamentik_1_N = mkN "djurornamentik" ; -- djurornamentik..nn.1
  djurpark_1_N = mkN "djurpark" "djurparker" ; -- djurpark..nn.1
  djurparksvarg_1_N = mkN "djurparksvarg" ; -- djurparksvarg..nn.1
  djurplankton_1_N = mkN "djurplankton" neutrum  ; -- djurplankton..nn.1
  djurplågare_1_N = mkN "djurplågare" utrum  ; -- djurplågare..nn.1
  djurplågeri_1_N = mkN "djurplågeri" neutrum  ; -- djurplågeri..nn.1
  djurpsykologi_1_N = mkN "djurpsykologi" ; -- djurpsykologi..nn.1
  djurrike_1_N = mkN "djurrike" ; -- djurrike..nn.1
  djurrättsaktivist_1_N = mkN "djurrättsaktivist" "djurrättsaktivister" ; -- djurrättsaktivist..nn.1
  djurrättsfråga_1_N = mkN "djurrättsfråga" ; -- djurrättsfråga..nn.1
  djursjukhus_1_N = mkN "djursjukhus" neutrum  ; -- djursjukhus..nn.1
  djurskinn_1_N = mkN "djurskinn" neutrum  ; -- djurskinn..nn.1
  djurskydd_1_N = mkN "djurskydd" neutrum  ; -- djurskydd..nn.1
  djurskyddsförening_1_N = mkN "djurskyddsförening" ; -- djurskyddsförening..nn.1
  djurskyddsinspektör_1_N = mkN "djurskyddsinspektör" "djurskyddsinspektörer" ; -- djurskyddsinspektör..nn.1
  djurskyddslagstiftning_1_N = mkN "djurskyddslagstiftning" ; -- djurskyddslagstiftning..nn.1
  djurskyddsmässig_1_A = mkA "djurskyddsmässig" ; -- djurskyddsmässig..av.1
  djurskötare_1_N = mkN "djurskötare" utrum  ; -- djurskötare..nn.1
  djurskötsel_1_N = mkN "djurskötsel" ; -- djurskötsel..nn.1
  djurslag_1_N = mkN "djurslag" neutrum  ; -- djurslag..nn.1
  djurstig_1_N = mkN "djurstig" ; -- djurstig..nn.1
  djurtarm_1_N = mkN "djurtarm" ; -- djurtarm..nn.1
  djurtillsyn_1_N = mkN "djurtillsyn" ; -- djurtillsyn..nn.1
  djurtämjare_1_N = mkN "djurtämjare" utrum  ; -- djurtämjare..nn.1
  djuruppfödning_1_N = mkN "djuruppfödning" ; -- djuruppfödning..nn.1
  djurutställning_1_N = mkN "djurutställning" ; -- djurutställning..nn.1
  djurvän_1_N = mkN "djurvän" "djurvännen" "djurvänner" "djurvännerna" ; -- djurvän..nn.1
  djurvänlig_1_A = mkA "djurvänlig" ; -- djurvänlig..av.1
  djurvänlighet_1_N = mkN "djurvänlighet" ; -- djurvänlighet..nn.1
  djurvärld_1_N = mkN "djurvärld" ; -- djurvärld..nn.1
  djäklig_1_A = mkA "djäklig" ; -- djäklig..av.1
  djäklighet_1_N = mkN "djäklighet" "djäkligheter" ; -- djäklighet..nn.1
  djäkne_1_N = mkN "djäkne" utrum  ; -- djäkne..nn.1
  djärv_1_A = mkA "djärv" ; -- djärv..av.1
  djärvhet_1_N = mkN "djärvhet" "djärvheter" ; -- djärvhet..nn.1
  djävel_1_N = mkN "djävel" ; -- djävel..nn.1
  djävelsk_1_A = mkA "djävelsk" ; -- djävelsk..av.1
  djävelskap_1_N = mkN "djävelskap" neutrum  ; -- djävelskap..nn.1
  djävelstyg_1_N = mkN "djävelstyg" neutrum  ; -- djävelstyg..nn.1
  djävla_1_A = mkA "djävla" ; -- djävla..av.1
  djävlig_1_A = mkA "djävlig" ; -- djävlig..av.1
  djävlighet_1_N = mkN "djävlighet" "djävligheter" ; -- djävlighet..nn.1
  djävligt_1_Adv = mkAdv "djävligt" ; -- djävligt..ab.1
  djävul_1_N = mkN "djävul" "djävulen" "djävlar" "djävlarna" ; -- djävul..nn.1
  djävulsbesvärjare_1_N = mkN "djävulsbesvärjare" utrum  ; -- djävulsbesvärjare..nn.1
  djävulsbesvärjelse_1_N = mkN "djävulsbesvärjelse" "djävulsbesvärjelser" ; -- djävulsbesvärjelse..nn.1
  djävulsk_1_A = mkA "djävulsk" ; -- djävulsk..av.1
  djävulskap_1_N = mkN "djävulskap" neutrum  ; -- djävulskap..nn.1
  djävulskonst_1_N = mkN "djävulskonst" "djävulskonster" ; -- djävulskonst..nn.1
  djävulsspiral_1_N = mkN "djävulsspiral" "djävulsspiraler" ; -- djävulsspiral..nn.1
  djävulstro_1_N = mkN "djävulstro" ; -- djävulstro..nn.1
  djävulstyg_1_N = mkN "djävulstyg" neutrum  ; -- djävulstyg..nn.1
  djävulusisk_1_A = mkA "djävulusisk" ; -- djävulusisk..av.1
  dna_kedja_1_N = mkN "dna-kedja" ; -- dna-kedja..nn.1
  dna_molekyl_1_N = mkN "dna-molekyl" "dna-molekyler" ; -- dna-molekyl..nn.1
  dna_profil_1_N = mkN "dna-profil" "dna-profiler" ; -- dna-profil..nn.1
  dna_sekvens_1_N = mkN "dna-sekvens" "dna-sekvenser" ; -- dna-sekvens..nn.1
  dna_sekvensering_1_N = mkN "dna-sekvensering" ; -- dna-sekvensering..nn.1
  dna_spår_1_N = mkN "dna-spår" neutrum  ; -- dna-spår..nn.1
  dna_sträng_1_N = mkN "dna-sträng" ; -- dna-sträng..nn.1
  dna_test_1_N = mkN "dna-test" neutrum  ; -- dna-test..nn.1
  dna_testa_1_V = mkV "dna-testar" ; -- dna-testa..vb.1
  dna_testande_1_N = mkN "dna-testande" ; -- dna-testande..nn.1
  dna_testning_1_N = mkN "dna-testning" ; -- dna-testning..nn.1
  dna_uppsättning_1_N = mkN "dna-uppsättning" ; -- dna-uppsättning..nn.1
  doa_1_V = mkV "doar" ; -- doa..vb.1
  doakör_1_N = mkN "doakör" "doakörer" ; -- doakör..nn.1
  doande_1_N = mkN "doande" ; -- doande..nn.1
  dobbel_1_N = mkN "dobbel" neutrum  ; -- dobbel..nn.1
  dobbla_1_V = mkV "dobblar" ; -- dobbla..vb.1
  dobblande_1_N = mkN "dobblande" ; -- dobblande..nn.1
  dobblare_1_N = mkN "dobblare" utrum  ; -- dobblare..nn.1
  docent_1_N = mkN "docent" "docenter" ; -- docent..nn.1
  docentur_1_N = mkN "docentur" "docenturer" ; -- docentur..nn.1
  docera_1_V = mkV "docerar" ; -- docera..vb.1
  docera_2_V = mkV "docerar" ; -- docera..vb.2
  docerande_1_N = mkN "docerande" ; -- docerande..nn.1
  docerbar_1_A = mkA "docerbar" ; -- docerbar..av.1
  docerbarhet_1_N = mkN "docerbarhet" ; -- docerbarhet..nn.1
  docering_1_N = mkN "docering" ; -- docering..nn.1
  docering_2_N = mkN "docering" ; -- docering..nn.2
  dock_1_Adv = mkAdv "dock" ; -- dock..ab.1
  docka_1_N = mkN "docka" ; -- docka..nn.1
  docka_1_V = mkV "dockar" ; -- docka..vb.1
  dockaktig_1_A = mkA "dockaktig" ; -- dockaktig..av.1
  dockaktighet_1_N = mkN "dockaktighet" ; -- dockaktighet..nn.1
  dockande_1_N = mkN "dockande" ; -- dockande..nn.1
  dockansikte_1_N = mkN "dockansikte" ; -- dockansikte..nn.1
  dockkudde_1_N = mkN "dockkudde" utrum  ; -- dockkudde..nn.1
  dockperuk_1_N = mkN "dockperuk" "dockperuker" ; -- dockperuk..nn.1
  dockskåp_1_N = mkN "dockskåp" neutrum  ; -- dockskåp..nn.1
  docksöt_1_A = mkA "docksöt" ; -- docksöt..av.1
  dockteater_1_N = mkN "dockteater" ; -- dockteater..nn.1
  dodekaeder_1_N = mkN "dodekaeder" ; -- dodekaeder..nn.1
  doft_1_N = mkN "doft" "dofter" ; -- doft..nn.1
  doft_2_N = mkN "doft" ; -- doft..nn.2
  dofta_1_V = mkV "doftar" ; -- dofta..vb.1
  dofta_2_V = mkV "doftar" ; -- dofta..vb.2
  doftande_1_N = mkN "doftande" ; -- doftande..nn.1
  doftljus_1_N = mkN "doftljus" neutrum  ; -- doftljus..nn.1
  doftlös_1_A = mkA "doftlös" ; -- doftlös..av.1
  doftlöshet_1_N = mkN "doftlöshet" ; -- doftlöshet..nn.1
  doftmarkera_1_V = mkV "doftmarkerar" ; -- doftmarkera..vb.1
  doftmarkerande_1_N = mkN "doftmarkerande" ; -- doftmarkerande..nn.1
  doftmarkerbar_1_A = mkA "doftmarkerbar" ; -- doftmarkerbar..av.1
  doftmarkerbarhet_1_N = mkN "doftmarkerbarhet" ; -- doftmarkerbarhet..nn.1
  doftmarkering_1_N = mkN "doftmarkering" ; -- doftmarkering..nn.1
  doftrik_1_A = mkA "doftrik" ; -- doftrik..av.1
  doftsinne_1_N = mkN "doftsinne" ; -- doftsinne..nn.1
  doftsvag_1_A = mkA "doftsvag" ; -- doftsvag..av.1
  doftsvaghet_1_N = mkN "doftsvaghet" ; -- doftsvaghet..nn.1
  doftämne_1_N = mkN "doftämne" ; -- doftämne..nn.1
  dogcart_1_N = mkN "dogcart" "dogcarter" ; -- dogcart..nn.1
  doge_1_N = mkN "doge" "doger" ; -- doge..nn.1
  dogg_1_N = mkN "dogg" ; -- dogg..nn.1
  dogm_1_N = mkN "dogm" "dogmer" ; -- dogm..nn.1
  dogmatik_1_N = mkN "dogmatik" ; -- dogmatik..nn.1
  dogmatiker_1_N = mkN "dogmatiker" "dogmatikern" "dogmatiker" "dogmatikerna" ; -- dogmatiker..nn.1
  dogmatisera_1_V = mkV "dogmatiserar" ; -- dogmatisera..vb.1
  dogmatiserande_1_N = mkN "dogmatiserande" ; -- dogmatiserande..nn.1
  dogmatiserbar_1_A = mkA "dogmatiserbar" ; -- dogmatiserbar..av.1
  dogmatiserbarhet_1_N = mkN "dogmatiserbarhet" ; -- dogmatiserbarhet..nn.1
  dogmatisering_1_N = mkN "dogmatisering" ; -- dogmatisering..nn.1
  dogmatisk_1_A = mkA "dogmatisk" ; -- dogmatisk..av.1
  dogmatism_1_N = mkN "dogmatism" "dogmatismer" ; -- dogmatism..nn.1
  dogmsystem_1_N = mkN "dogmsystem" neutrum  ; -- dogmsystem..nn.1
  doja_1_N = mkN "doja" ; -- doja..nn.1
  dok_1_N = mkN "dok" neutrum  ; -- dok..nn.1
  doktor_1_N = mkN "doktor" "doktorer" ; -- doktor..nn.1
  doktorand_1_N = mkN "doktorand" "doktorander" ; -- doktorand..nn.1
  doktorera_1_V = mkV "doktorerar" ; -- doktorera..vb.1
  doktorerande_1_N = mkN "doktorerande" ; -- doktorerande..nn.1
  doktorering_1_N = mkN "doktorering" ; -- doktorering..nn.1
  doktorsavhandling_1_N = mkN "doktorsavhandling" ; -- doktorsavhandling..nn.1
  doktorsdisputation_1_N = mkN "doktorsdisputation" ; -- doktorsdisputation..nn.1
  doktorsexamen_1_N = mkN "doktorsexamen" "doktorsexamen" "doktorsexamina" "doktorsexamina" ; -- doktorsexamen..nn.1
  doktorsfisk_1_N = mkN "doktorsfisk" ; -- doktorsfisk..nn.1
  doktorsgrad_1_N = mkN "doktorsgrad" "doktorsgrader" ; -- doktorsgrad..nn.1
  doktorshatt_1_N = mkN "doktorshatt" ; -- doktorshatt..nn.1
  doktorska_1_N = mkN "doktorska" ; -- doktorska..nn.1
  doktorspromotion_1_N = mkN "doktorspromotion" ; -- doktorspromotion..nn.1
  doktorsring_1_N = mkN "doktorsring" ; -- doktorsring..nn.1
  doktrin_1_N = mkN "doktrin" "doktriner" ; -- doktrin..nn.1
  doktrinarism_1_N = mkN "doktrinarism" "doktrinarismer" ; -- doktrinarism..nn.1
  doktrinär_1_A = mkA "doktrinär" ; -- doktrinär..av.1
  dokument_1_N = mkN "dokument" neutrum  ; -- dokument..nn.1
  dokumentalist_1_N = mkN "dokumentalist" "dokumentalister" ; -- dokumentalist..nn.1
  dokumentarisk_1_A = mkA "dokumentarisk" ; -- dokumentarisk..av.1
  dokumentation_1_N = mkN "dokumentation" ; -- dokumentation..nn.1
  dokumentera_1_V = mkV "dokumenterar" ; -- dokumentera..vb.1
  dokumenterande_1_N = mkN "dokumenterande" ; -- dokumenterande..nn.1
  dokumenterbar_1_A = mkA "dokumenterbar" ; -- dokumenterbar..av.1
  dokumenterbarhet_1_N = mkN "dokumenterbarhet" ; -- dokumenterbarhet..nn.1
  dokumentering_1_N = mkN "dokumentering" ; -- dokumentering..nn.1
  dokumentkreditiv_1_N = mkN "dokumentkreditiv" neutrum  ; -- dokumentkreditiv..nn.1
  dokumentpacke_1_N = mkN "dokumentpacke" utrum  ; -- dokumentpacke..nn.1
  dokumentpapper_1_N = mkN "dokumentpapper" neutrum  ; -- dokumentpapper..nn.1
  dokumentportfölj_1_N = mkN "dokumentportfölj" "dokumentportföljer" ; -- dokumentportfölj..nn.1
  dokumentsamling_1_N = mkN "dokumentsamling" ; -- dokumentsamling..nn.1
  dokumentskåp_1_N = mkN "dokumentskåp" neutrum  ; -- dokumentskåp..nn.1
  dokumentär_1_A = mkA "dokumentär" ; -- dokumentär..av.1
  dokumentär_1_N = mkN "dokumentär" "dokumentärer" ; -- dokumentär..nn.1
  dokumentärfilm_1_N = mkN "dokumentärfilm" "dokumentärfilmer" ; -- dokumentärfilm..nn.1
  dokumentärprogram_1_N = mkN "dokumentärprogram" "dokumentärprogrammet" "dokumentärprogram" "dokumentärprogrammen" ; -- dokumentärprogram..nn.1
  dokumentärroman_1_N = mkN "dokumentärroman" "dokumentärromaner" ; -- dokumentärroman..nn.1
  dokusåpa_1_N = mkN "dokusåpa" ; -- dokusåpa..nn.1
  dokusåpadeltagare_1_N = mkN "dokusåpadeltagare" utrum  ; -- dokusåpadeltagare..nn.1
  dokusåpakändis_1_N = mkN "dokusåpakändis" ; -- dokusåpakändis..nn.1
  dold_1_A = mkA "dold" "dolt" ; -- dold..av.1
  doldhet_1_N = mkN "doldhet" ; -- doldhet..nn.1
  doldis_1_N = mkN "doldis" ; -- doldis..nn.1
  dolikocefal_1_A = mkA "dolikocefal" ; -- dolikocefal..av.1
  dolikocefal_1_N = mkN "dolikocefal" "dolikocefaler" ; -- dolikocefal..nn.1
  dolikocefali_1_N = mkN "dolikocefali" "dolikocefalier" ; -- dolikocefali..nn.1
  dolk_1_N = mkN "dolk" ; -- dolk..nn.1
  dolkstöt_1_N = mkN "dolkstöt" ; -- dolkstöt..nn.1
  dolkstötslegend_1_N = mkN "dolkstötslegend" "dolkstötslegender" ; -- dolkstötslegend..nn.1
  dollar_1_N = mkN "dollar" "dollarn" "dollar" "dollarna" ; -- dollar..nn.1
  dollardiplomati_1_N = mkN "dollardiplomati" ; -- dollardiplomati..nn.1
  dollargrin_1_N = mkN "dollargrin" neutrum  ; -- dollargrin..nn.1
  dollarprinsessa_1_N = mkN "dollarprinsessa" ; -- dollarprinsessa..nn.1
  dollarsedel_1_N = mkN "dollarsedel" ; -- dollarsedel..nn.1
  dollarturist_1_N = mkN "dollarturist" "dollarturister" ; -- dollarturist..nn.1
  dolma_1_N = mkN "dolma" "dolman" "dolmar" "dolmarna" ; -- dolma..nn.1
  dolma_2_N = mkN "dolma" ; -- dolma..nn.2
  dolomit_1_N = mkN "dolomit" "dolomiter" ; -- dolomit..nn.1
  dolsk_1_A = mkA "dolsk" ; -- dolsk..av.1
  dolskhet_1_N = mkN "dolskhet" ; -- dolskhet..nn.1
  dom_1_N = mkN "dom" ; -- dom..nn.1
  dom_2_N = mkN "dom" "domer" ; -- dom..nn.2
  domare_1_N = mkN "domare" utrum  ; -- domare..nn.1
  domared_1_N = mkN "domared" "domareder" ; -- domared..nn.1
  domaredans_1_N = mkN "domaredans" "domaredanser" ; -- domaredans..nn.1
  domarkår_1_N = mkN "domarkår" "domarkårer" ; -- domarkår..nn.1
  domarornat_1_N = mkN "domarornat" "domarornater" ; -- domarornat..nn.1
  domarpost_1_N = mkN "domarpost" "domarposter" ; -- domarpost..nn.1
  domarring_1_N = mkN "domarring" ; -- domarring..nn.1
  domarsäte_1_N = mkN "domarsäte" ; -- domarsäte..nn.1
  dombok_1_N = mkN "dombok" "domböcker" ; -- dombok..nn.1
  domdera_1_V = mkV "domderar" ; -- domdera..vb.1
  domderande_1_N = mkN "domderande" ; -- domderande..nn.1
  domdering_1_N = mkN "domdering" ; -- domdering..nn.1
  domedag_1_N = mkN "domedag" ; -- domedag..nn.1
  domedagspredikant_1_N = mkN "domedagspredikant" "domedagspredikanter" ; -- domedagspredikant..nn.1
  domedagspredikning_1_N = mkN "domedagspredikning" ; -- domedagspredikning..nn.1
  domedagsprofet_1_N = mkN "domedagsprofet" "domedagsprofeter" ; -- domedagsprofet..nn.1
  domedagsstämning_1_N = mkN "domedagsstämning" ; -- domedagsstämning..nn.1
  domedagstänkande_1_N = mkN "domedagstänkande" ; -- domedagstänkande..nn.1
  domedagsvapen_1_N = mkN "domedagsvapen" "domedagsvapnet" "domedagsvapen" "domedagsvapnen" ; -- domedagsvapen..nn.1
  domesticera_1_V = mkV "domesticerar" ; -- domesticera..vb.1
  domesticerande_1_N = mkN "domesticerande" ; -- domesticerande..nn.1
  domesticerbar_1_A = mkA "domesticerbar" ; -- domesticerbar..av.1
  domesticerbarhet_1_N = mkN "domesticerbarhet" ; -- domesticerbarhet..nn.1
  domesticering_1_N = mkN "domesticering" ; -- domesticering..nn.1
  domestik_1_N = mkN "domestik" "domestiker" ; -- domestik..nn.1
  domfälla_1_V = mkV "domfäller" ; -- domfälla..vb.1
  domfällande_1_N = mkN "domfällande" ; -- domfällande..nn.1
  domför_1_A = mkA "domför" ; -- domför..av.1
  domhavande_1_A = mkA "domhavande" ; -- domhavande..av.1
  domherre_1_N = mkN "domherre" utrum  ; -- domherre..nn.1
  domicil_1_N = mkN "domicil" neutrum  ; -- domicil..nn.1
  domiciliera_1_V = mkV "domicilierar" ; -- domiciliera..vb.1
  domicilierande_1_N = mkN "domicilierande" ; -- domicilierande..nn.1
  domicilierbar_1_A = mkA "domicilierbar" ; -- domicilierbar..av.1
  domicilierbarhet_1_N = mkN "domicilierbarhet" ; -- domicilierbarhet..nn.1
  domiciliering_1_N = mkN "domiciliering" ; -- domiciliering..nn.1
  domina_1_N = mkN "domina" ; -- domina..nn.1
  dominans_1_N = mkN "dominans" ; -- dominans..nn.1
  dominant_1_A = mkA "dominant" "dominant" ; -- dominant..av.1
  dominant_1_N = mkN "dominant" "dominanter" ; -- dominant..nn.1
  dominatrix_1_N = mkN "dominatrix" "dominatrixer" ; -- dominatrix..nn.1
  dominera_1_V = mkV "dominerar" ; -- dominera..vb.1
  dominerande_1_A = mkA "dominerande" ; -- dominerande..av.1
  dominerande_1_N = mkN "dominerande" ; -- dominerande..nn.1
  dominerbar_1_A = mkA "dominerbar" ; -- dominerbar..av.1
  dominerbarhet_1_N = mkN "dominerbarhet" ; -- dominerbarhet..nn.1
  dominering_1_N = mkN "dominering" ; -- dominering..nn.1
  dominikan_1_N = mkN "dominikan" "dominikaner" ; -- dominikan..nn.1
  dominikanerkloster_1_N = mkN "dominikanerkloster" neutrum  ; -- dominikanerkloster..nn.1
  dominikanermunk_1_N = mkN "dominikanermunk" ; -- dominikanermunk..nn.1
  dominikanerorden_1_N = mkN "dominikanerorden" ; -- dominikanerorden..nn.1
  dominikankloster_1_N = mkN "dominikankloster" neutrum  ; -- dominikankloster..nn.1
  dominikanmunk_1_N = mkN "dominikanmunk" ; -- dominikanmunk..nn.1
  dominikanorden_1_N = mkN "dominikanorden" ; -- dominikanorden..nn.1
  dominikansk_1_A = mkA "dominikansk" ; -- dominikansk..av.1
  dominikanska_1_N = mkN "dominikanska" ; -- dominikanska..nn.1
  dominikansyster_1_N = mkN "dominikansyster" ; -- dominikansyster..nn.1
  dominiker_1_N = mkN "dominiker" "dominikern" "dominiker" "dominikerna" ; -- dominiker..nn.1
  dominikisk_1_A = mkA "dominikisk" ; -- dominikisk..av.1
  dominikiska_1_N = mkN "dominikiska" ; -- dominikiska..nn.1
  dominion_1_N = mkN "dominion" "dominion" "dominier" "dominierna" ; -- dominion..nn.1
  domino_1_N = mkN "domino" "dominor" ; -- domino..nn.1
  dominobricka_1_N = mkN "dominobricka" ; -- dominobricka..nn.1
  dominoeffekt_1_N = mkN "dominoeffekt" "dominoeffekter" ; -- dominoeffekt..nn.1
  dominohav_1_N = mkN "dominohav" neutrum  ; -- dominohav..nn.1
  dominospel_1_N = mkN "dominospel" "dominospelet" "dominospel" "dominospelen" ; -- dominospel..nn.1
  dominoteori_1_N = mkN "dominoteori" "dominoteorier" ; -- dominoteori..nn.1
  domkapitel_1_N = mkN "domkapitel" neutrum  ; -- domkapitel..nn.1
  domkraft_1_N = mkN "domkraft" "domkrafter" ; -- domkraft..nn.1
  domkraftsolja_1_N = mkN "domkraftsolja" ; -- domkraftsolja..nn.1
  domkrets_1_N = mkN "domkrets" ; -- domkrets..nn.1
  domkval_1_N = mkN "domkval" neutrum  ; -- domkval..nn.1
  domkyrka_1_N = mkN "domkyrka" ; -- domkyrka..nn.1
  domkyrkoadjunkt_1_N = mkN "domkyrkoadjunkt" "domkyrkoadjunkter" ; -- domkyrkoadjunkt..nn.1
  domkyrkoförsamling_1_N = mkN "domkyrkoförsamling" ; -- domkyrkoförsamling..nn.1
  domna_1_V = mkV "domnar" ; -- domna..vb.1
  domnande_1_N = mkN "domnande" ; -- domnande..nn.1
  domning_1_N = mkN "domning" ; -- domning..nn.1
  domprost_1_N = mkN "domprost" ; -- domprost..nn.1
  domptera_1_V = mkV "dompterar" ; -- domptera..vb.1
  dompterande_1_N = mkN "dompterande" ; -- dompterande..nn.1
  dompterbar_1_A = mkA "dompterbar" ; -- dompterbar..av.1
  dompterbarhet_1_N = mkN "dompterbarhet" ; -- dompterbarhet..nn.1
  domptering_1_N = mkN "domptering" ; -- domptering..nn.1
  domptör_1_N = mkN "domptör" "domptörer" ; -- domptör..nn.1
  domptörsfason_1_N = mkN "domptörsfason" "domptörsfasoner" ; -- domptörsfason..nn.1
  domsaga_1_N = mkN "domsaga" ; -- domsaga..nn.1
  domskäl_1_N = mkN "domskäl" neutrum  ; -- domskäl..nn.1
  domslut_1_N = mkN "domslut" neutrum  ; -- domslut..nn.1
  domsrätt_1_N = mkN "domsrätt" ; -- domsrätt..nn.1
  domssöndag_1_N = mkN "domssöndag" ; -- domssöndag..nn.1
  domstol_1_N = mkN "domstol" ; -- domstol..nn.1
  domstolsbeslut_1_N = mkN "domstolsbeslut" neutrum  ; -- domstolsbeslut..nn.1
  domstolsbetjänt_1_N = mkN "domstolsbetjänt" "domstolsbetjänter" ; -- domstolsbetjänt..nn.1
  domstolsförhandling_1_N = mkN "domstolsförhandling" ; -- domstolsförhandling..nn.1
  domstolsledamot_1_N = mkN "domstolsledamot" "domstolsledamöter" ; -- domstolsledamot..nn.1
  domstolsmässig_1_A = mkA "domstolsmässig" ; -- domstolsmässig..av.1
  domstolsmål_1_N = mkN "domstolsmål" neutrum  ; -- domstolsmål..nn.1
  domstolsprotokoll_1_N = mkN "domstolsprotokoll" neutrum  ; -- domstolsprotokoll..nn.1
  domstolssammanträde_1_N = mkN "domstolssammanträde" ; -- domstolssammanträde..nn.1
  domstolssession_1_N = mkN "domstolssession" ; -- domstolssession..nn.1
  domstolsverk_1_N = mkN "domstolsverk" neutrum  ; -- domstolsverk..nn.1
  domsöndag_1_N = mkN "domsöndag" ; -- domsöndag..nn.1
  domvilla_1_N = mkN "domvilla" ; -- domvilla..nn.1
  domvärjo_1_N = mkN "domvärjo" ; -- domvärjo..nn.1
  domän_1_N = mkN "domän" "domäner" ; -- domän..nn.1
  domänförvaltning_1_N = mkN "domänförvaltning" ; -- domänförvaltning..nn.1
  domänintendent_1_N = mkN "domänintendent" "domänintendenter" ; -- domänintendent..nn.1
  domänstyrelse_1_N = mkN "domänstyrelse" "domänstyrelser" ; -- domänstyrelse..nn.1
  domänverk_1_N = mkN "domänverk" neutrum  ; -- domänverk..nn.1
  don_1_N = mkN "don" neutrum  ; -- don..nn.1
  don_2_N = mkN "don" ; -- don..nn.2
  dona_1_N = mkN "dona" ; -- dona..nn.1
  dona_1_V = mkV "donar" ; -- dona..vb.1
  donande_1_N = mkN "donande" ; -- donande..nn.1
  donation_1_N = mkN "donation" ; -- donation..nn.1
  donationsbrev_1_N = mkN "donationsbrev" neutrum  ; -- donationsbrev..nn.1
  donationsjord_1_N = mkN "donationsjord" ; -- donationsjord..nn.1
  donationsmedel_1_N = mkN "donationsmedel" neutrum  ; -- donationsmedel..nn.1
  donator_1_N = mkN "donator" "donatorer" ; -- donator..nn.1
  donera_1_V = mkV "donerar" ; -- donera..vb.1
  donerande_1_N = mkN "donerande" ; -- donerande..nn.1
  donerbar_1_A = mkA "donerbar" ; -- donerbar..av.1
  donerbarhet_1_N = mkN "donerbarhet" ; -- donerbarhet..nn.1
  donering_1_N = mkN "donering" ; -- donering..nn.1
  doning_1_N = mkN "doning" ; -- doning..nn.1
  donjuan_1_N = mkN "donjuan" "donjuan" "donjuaner" "donjuanerna" ; -- donjuan..nn.1
  donk_1_N = mkN "donk" neutrum  ; -- donk..nn.1
  donka_1_V = mkV "donkar" ; -- donka..vb.1
  donka_2_V = mkV "donkar" ; -- donka..vb.2
  donkande_1_N = mkN "donkande" ; -- donkande..nn.1
  donkeypanna_1_N = mkN "donkeypanna" ; -- donkeypanna..nn.1
  donläge_1_N = mkN "donläge" ; -- donläge..nn.1
  donna_1_N = mkN "donna" ; -- donna..nn.1
  dop_1_N = mkN "dop" neutrum  ; -- dop..nn.1
  dopa_1_V = mkV "dopar" ; -- dopa..vb.1
  dopamin_1_N = mkN "dopamin" "dopaminer" ; -- dopamin..nn.1
  dopaminblåsa_1_N = mkN "dopaminblåsa" ; -- dopaminblåsa..nn.1
  dopaminkänslig_1_A = mkA "dopaminkänslig" ; -- dopaminkänslig..av.1
  dopaminkänslighet_1_N = mkN "dopaminkänslighet" ; -- dopaminkänslighet..nn.1
  dopande_1_N = mkN "dopande" ; -- dopande..nn.1
  dopattest_1_N = mkN "dopattest" "dopattester" ; -- dopattest..nn.1
  dopbassäng_1_N = mkN "dopbassäng" "dopbassänger" ; -- dopbassäng..nn.1
  dopfunt_1_N = mkN "dopfunt" ; -- dopfunt..nn.1
  doping_1_N = mkN "doping" ; -- doping..nn.1
  dopingbrott_1_N = mkN "dopingbrott" neutrum  ; -- dopingbrott..nn.1
  dopinghärva_1_N = mkN "dopinghärva" ; -- dopinghärva..nn.1
  dopingpreparat_1_N = mkN "dopingpreparat" neutrum  ; -- dopingpreparat..nn.1
  dopnamn_1_N = mkN "dopnamn" neutrum  ; -- dopnamn..nn.1
  dopning_1_N = mkN "dopning" ; -- dopning..nn.1
  dopningsbrott_1_N = mkN "dopningsbrott" neutrum  ; -- dopningsbrott..nn.1
  dopningshärva_1_N = mkN "dopningshärva" ; -- dopningshärva..nn.1
  dopningspreparat_1_N = mkN "dopningspreparat" neutrum  ; -- dopningspreparat..nn.1
  dopp_1_N = mkN "dopp" neutrum  ; -- dopp..nn.1
  dopp_2_N = mkN "dopp" neutrum  ; -- dopp..nn.2
  doppa_1_V = mkV "doppar" ; -- doppa..vb.1
  doppande_1_N = mkN "doppande" ; -- doppande..nn.1
  doppardag_1_N = mkN "doppardag" ; -- doppardag..nn.1
  dopparedag_1_N = mkN "dopparedag" ; -- dopparedag..nn.1
  dopping_1_N = mkN "dopping" ; -- dopping..nn.1
  dopplereffekt_1_N = mkN "dopplereffekt" ; -- dopplereffekt..nn.1
  doppning_1_N = mkN "doppning" ; -- doppning..nn.1
  doppsko_1_N = mkN "doppsko" "doppskor" ; -- doppsko..nn.1
  doppvärmare_1_N = mkN "doppvärmare" utrum  ; -- doppvärmare..nn.1
  dopskål_1_N = mkN "dopskål" ; -- dopskål..nn.1
  dopvittne_1_N = mkN "dopvittne" ; -- dopvittne..nn.1
  dorer_1_N = mkN "dorer" "dorern" "dorer" "dorerna" ; -- dorer..nn.1
  dorisk_1_A = mkA "dorisk" ; -- dorisk..av.1
  dormitorium_1_N = mkN "dormitorium" "dormitoriet" "dormitorier" "dormitorierna" ; -- dormitorium..nn.1
  dorn_1_N = mkN "dorn" ; -- dorn..nn.1
  dorsal_1_A = mkA "dorsal" ; -- dorsal..av.1
  dorsal_1_N = mkN "dorsal" "dorsaler" ; -- dorsal..nn.1
  dorsk_1_A = mkA "dorsk" ; -- dorsk..av.1
  dorskhet_1_N = mkN "dorskhet" ; -- dorskhet..nn.1
  dos_1_N = mkN "dos" "doser" ; -- dos..nn.1
  dosa_1_N = mkN "dosa" ; -- dosa..nn.1
  dosbarometer_1_N = mkN "dosbarometer" ; -- dosbarometer..nn.1
  dosekvivalent_1_N = mkN "dosekvivalent" "dosekvivalenter" ; -- dosekvivalent..nn.1
  dosera_1_V = mkV "doserar" ; -- dosera..vb.1
  doserande_1_N = mkN "doserande" ; -- doserande..nn.1
  doserbar_1_A = mkA "doserbar" ; -- doserbar..av.1
  doserbarhet_1_N = mkN "doserbarhet" ; -- doserbarhet..nn.1
  dosering_1_N = mkN "dosering" ; -- dosering..nn.1
  dosimeter_1_N = mkN "dosimeter" ; -- dosimeter..nn.1
  dosimetri_1_N = mkN "dosimetri" ; -- dosimetri..nn.1
  dosis_1_N = mkN "dosis" ; -- dosis..nn.1
  doslibell_1_N = mkN "doslibell" "doslibeller" ; -- doslibell..nn.1
  dosmätare_1_N = mkN "dosmätare" utrum  ; -- dosmätare..nn.1
  dossera_1_V = mkV "dosserar" ; -- dossera..vb.1
  dosserande_1_N = mkN "dosserande" ; -- dosserande..nn.1
  dosserbar_1_A = mkA "dosserbar" ; -- dosserbar..av.1
  dosserbarhet_1_N = mkN "dosserbarhet" ; -- dosserbarhet..nn.1
  dossering_1_N = mkN "dossering" ; -- dossering..nn.1
  dossier_1_N = mkN "dossier" "dossiern" "dossierer" "dossiererna" ; -- dossier..nn.1
  dossié_1_N = mkN "dossié" "dossiéer" ; -- dossié..nn.1
  dotation_1_N = mkN "dotation" ; -- dotation..nn.1
  dotera_1_V = mkV "doterar" ; -- dotera..vb.1
  doterande_1_N = mkN "doterande" ; -- doterande..nn.1
  doterbar_1_A = mkA "doterbar" ; -- doterbar..av.1
  doterbarhet_1_N = mkN "doterbarhet" ; -- doterbarhet..nn.1
  dotering_1_N = mkN "dotering" ; -- dotering..nn.1
  dotter_1_N = mkN "dotter" "dottern" "döttrar" "döttrarna" ; -- dotter..nn.1
  dotterbarn_1_N = mkN "dotterbarn" neutrum  ; -- dotterbarn..nn.1
  dotterbolag_1_N = mkN "dotterbolag" neutrum  ; -- dotterbolag..nn.1
  dottercell_1_N = mkN "dottercell" "dotterceller" ; -- dottercell..nn.1
  dotterdotter_1_N = mkN "dotterdotter" "dotterdottern" "dotterdöttrar" "dotterdöttrarna" ; -- dotterdotter..nn.1
  dotterföretag_1_N = mkN "dotterföretag" neutrum  ; -- dotterföretag..nn.1
  dotterförsamling_1_N = mkN "dotterförsamling" ; -- dotterförsamling..nn.1
  dotterlig_1_A = mkA "dotterlig" ; -- dotterlig..av.1
  dotterlighet_1_N = mkN "dotterlighet" ; -- dotterlighet..nn.1
  dotterskap_1_N = mkN "dotterskap" neutrum  ; -- dotterskap..nn.1
  dotterson_1_N = mkN "dotterson" "dottersöner" ; -- dotterson..nn.1
  dotterspråk_1_N = mkN "dotterspråk" neutrum  ; -- dotterspråk..nn.1
  dottersvulst_1_N = mkN "dottersvulst" "dottersvulster" ; -- dottersvulst..nn.1
  dottertumör_1_N = mkN "dottertumör" "dottertumörer" ; -- dottertumör..nn.1
  doublé_2_N = mkN "doublé" "doubléer" ; -- doublé..nn.2
  dov_1_A = mkA "dov" ; -- dov..av.1
  dovhet_1_N = mkN "dovhet" ; -- dovhet..nn.1
  dovhjort_1_N = mkN "dovhjort" ; -- dovhjort..nn.1
  downperiod_1_N = mkN "downperiod" "downperioder" ; -- downperiod..nn.1
  doyen_1_N = mkN "doyen" "doyener" ; -- doyen..nn.1
  dra_1_V = mkV "draga" "drog" "dragit" ; -- dra..vb.1
  drabant_1_N = mkN "drabant" "drabanter" ; -- drabant..nn.1
  drabantstat_1_N = mkN "drabantstat" "drabantstater" ; -- drabantstat..nn.1
  drabba_1_V = mkV "drabbar" ; -- drabba..vb.1
  drabbande_1_N = mkN "drabbande" ; -- drabbande..nn.1
  drabbning_1_N = mkN "drabbning" ; -- drabbning..nn.1
  drachma_1_N = mkN "drachma" "drachman" "drachmer" "drachmerna" ; -- drachma..nn.1
  drag_1_N = mkN "drag" neutrum  ; -- drag..nn.1
  drag_2_N = mkN "drag" neutrum  ; -- drag..nn.2
  dragande_1_N = mkN "dragande" ; -- dragande..nn.1
  dragare_1_N = mkN "dragare" utrum  ; -- dragare..nn.1
  dragband_1_N = mkN "dragband" neutrum  ; -- dragband..nn.1
  dragbasun_1_N = mkN "dragbasun" "dragbasuner" ; -- dragbasun..nn.1
  dragbil_1_N = mkN "dragbil" ; -- dragbil..nn.1
  dragbänk_1_N = mkN "dragbänk" ; -- dragbänk..nn.1
  dragdjur_1_N = mkN "dragdjur" neutrum  ; -- dragdjur..nn.1
  dragen_1_A = mkA "dragen" ; -- dragen..av.1
  dragenhet_1_N = mkN "dragenhet" ; -- dragenhet..nn.1
  dragenhet_2_N = mkN "dragenhet" "dragenheter" ; -- dragenhet..nn.2
  dragera_1_V = mkV "dragerar" ; -- dragera..vb.1
  dragerande_1_N = mkN "dragerande" ; -- dragerande..nn.1
  dragerbar_1_A = mkA "dragerbar" ; -- dragerbar..av.1
  dragerbarhet_1_N = mkN "dragerbarhet" ; -- dragerbarhet..nn.1
  dragering_1_N = mkN "dragering" ; -- dragering..nn.1
  dragfri_1_A = mkA "dragfri" "dragfritt" ; -- dragfri..av.1
  dragg_1_N = mkN "dragg" ; -- dragg..nn.1
  dragga_1_V = mkV "draggar" ; -- dragga..vb.1
  draggande_1_N = mkN "draggande" ; -- draggande..nn.1
  dragglina_1_N = mkN "dragglina" ; -- dragglina..nn.1
  draggning_1_N = mkN "draggning" ; -- draggning..nn.1
  dragharmonika_1_N = mkN "dragharmonika" ; -- dragharmonika..nn.1
  draghjälp_1_N = mkN "draghjälp" ; -- draghjälp..nn.1
  draghäst_1_N = mkN "draghäst" ; -- draghäst..nn.1
  draghållfasthet_1_N = mkN "draghållfasthet" "draghållfastheter" ; -- draghållfasthet..nn.1
  dragig_1_A = mkA "dragig" ; -- dragig..av.1
  dragkamp_1_N = mkN "dragkamp" "dragkamper" ; -- dragkamp..nn.1
  dragkedja_1_N = mkN "dragkedja" ; -- dragkedja..nn.1
  dragkista_1_N = mkN "dragkista" ; -- dragkista..nn.1
  dragkraft_1_N = mkN "dragkraft" ; -- dragkraft..nn.1
  dragkrok_1_N = mkN "dragkrok" ; -- dragkrok..nn.1
  dragkärra_1_N = mkN "dragkärra" ; -- dragkärra..nn.1
  draglapp_1_N = mkN "draglapp" ; -- draglapp..nn.1
  draglina_1_N = mkN "draglina" ; -- draglina..nn.1
  draglucka_1_N = mkN "draglucka" ; -- draglucka..nn.1
  dragläge_1_N = mkN "dragläge" ; -- dragläge..nn.1
  dragnagel_1_N = mkN "dragnagel" ; -- dragnagel..nn.1
  dragning_1_N = mkN "dragning" ; -- dragning..nn.1
  dragningskraft_1_N = mkN "dragningskraft" ; -- dragningskraft..nn.1
  dragningslista_1_N = mkN "dragningslista" ; -- dragningslista..nn.1
  dragnät_1_N = mkN "dragnät" neutrum  ; -- dragnät..nn.1
  dragoman_1_N = mkN "dragoman" "dragomaner" ; -- dragoman..nn.1
  dragon_1_N = mkN "dragon" "dragoner" ; -- dragon..nn.1
  dragplåster_1_N = mkN "dragplåster" neutrum  ; -- dragplåster..nn.1
  dragpress_1_N = mkN "dragpress" ; -- dragpress..nn.1
  dragpressning_1_N = mkN "dragpressning" ; -- dragpressning..nn.1
  dragprov_1_N = mkN "dragprov" neutrum  ; -- dragprov..nn.1
  dragracing_1_N = mkN "dragracing" ; -- dragracing..nn.1
  dragrem_1_N = mkN "dragrem" "dragremmen" "dragremmar" "dragremmarna" ; -- dragrem..nn.1
  dragrep_1_N = mkN "dragrep" neutrum  ; -- dragrep..nn.1
  dragshow_1_N = mkN "dragshow" "dragshower" ; -- dragshow..nn.1
  dragskiva_1_N = mkN "dragskiva" ; -- dragskiva..nn.1
  dragsko_1_N = mkN "dragsko" "dragskor" ; -- dragsko..nn.1
  dragskåp_1_N = mkN "dragskåp" neutrum  ; -- dragskåp..nn.1
  dragsnöre_1_N = mkN "dragsnöre" ; -- dragsnöre..nn.1
  dragspel_1_N = mkN "dragspel" "dragspelet" "dragspel" "dragspelen" ; -- dragspel..nn.1
  dragspelsmusik_1_N = mkN "dragspelsmusik" ; -- dragspelsmusik..nn.1
  dragstift_1_N = mkN "dragstift" neutrum  ; -- dragstift..nn.1
  dragstyrka_1_N = mkN "dragstyrka" ; -- dragstyrka..nn.1
  dragstång_1_N = mkN "dragstång" "dragstänger" ; -- dragstång..nn.1
  dragupprepning_1_N = mkN "dragupprepning" ; -- dragupprepning..nn.1
  dragväg_1_N = mkN "dragväg" ; -- dragväg..nn.1
  dragé_1_N = mkN "dragé" "dragéer" ; -- dragé..nn.1
  draja_1_N = mkN "draja" ; -- draja..nn.1
  drakblod_1_N = mkN "drakblod" neutrum  ; -- drakblod..nn.1
  drakblodsträd_1_N = mkN "drakblodsträd" neutrum  ; -- drakblodsträd..nn.1
  drake_1_N = mkN "drake" utrum  ; -- drake..nn.1
  drakflygare_1_N = mkN "drakflygare" utrum  ; -- drakflygare..nn.1
  drakhuvudfisk_1_N = mkN "drakhuvudfisk" ; -- drakhuvudfisk..nn.1
  drakma_1_N = mkN "drakma" "drakman" "drakmer" "drakmerna" ; -- drakma..nn.1
  drakonisk_1_A = mkA "drakonisk" ; -- drakonisk..av.1
  drakskepp_1_N = mkN "drakskepp" neutrum  ; -- drakskepp..nn.1
  drakslinga_1_N = mkN "drakslinga" ; -- drakslinga..nn.1
  drakstjärt_1_N = mkN "drakstjärt" ; -- drakstjärt..nn.1
  draksådd_1_N = mkN "draksådd" "draksådder" ; -- draksådd..nn.1
  draködla_1_N = mkN "draködla" ; -- draködla..nn.1
  dram_1_N = mkN "dram" ; -- dram..nn.1
  drama_1_N = mkN "drama" "dramat" "dramer" "dramerna" ; -- drama..nn.1
  dramakonst_1_N = mkN "dramakonst" ; -- dramakonst..nn.1
  dramaten_1_N = mkN "dramaten" ; -- dramaten..nn.1
  dramatik_1_N = mkN "dramatik" ; -- dramatik..nn.1
  dramatiker_1_N = mkN "dramatiker" "dramatikern" "dramatiker" "dramatikerna" ; -- dramatiker..nn.1
  dramatisera_1_V = mkV "dramatiserar" ; -- dramatisera..vb.1
  dramatiserande_1_N = mkN "dramatiserande" ; -- dramatiserande..nn.1
  dramatiserbar_1_A = mkA "dramatiserbar" ; -- dramatiserbar..av.1
  dramatiserbarhet_1_N = mkN "dramatiserbarhet" ; -- dramatiserbarhet..nn.1
  dramatisering_1_N = mkN "dramatisering" ; -- dramatisering..nn.1
  dramatisk_1_A = mkA "dramatisk" ; -- dramatisk..av.1
  dramaturg_1_N = mkN "dramaturg" "dramaturger" ; -- dramaturg..nn.1
  dramaturgi_1_N = mkN "dramaturgi" "dramaturgin" "dramaturgier" "dramaturgierna" ; -- dramaturgi..nn.1
  dramaturgisk_1_A = mkA "dramaturgisk" ; -- dramaturgisk..av.1
  drank_1_N = mkN "drank" ; -- drank..nn.1
  drapa_1_N = mkN "drapa" ; -- drapa..nn.1
  drapera_1_V = mkV "draperar" ; -- drapera..vb.1
  draperande_1_N = mkN "draperande" ; -- draperande..nn.1
  draperbar_1_A = mkA "draperbar" ; -- draperbar..av.1
  draperbarhet_1_N = mkN "draperbarhet" ; -- draperbarhet..nn.1
  draperi_1_N = mkN "draperi" "draperiet" "draperier" "draperierna" ; -- draperi..nn.1
  drapering_1_N = mkN "drapering" ; -- drapering..nn.1
  drastisk_1_A = mkA "drastisk" ; -- drastisk..av.1
  drasut_1_N = mkN "drasut" "drasuter" ; -- drasut..nn.1
  dratta_1_V = mkV "drattar" ; -- dratta..vb.1
  drattande_1_N = mkN "drattande" ; -- drattande..nn.1
  drav_1_N = mkN "drav" ; -- drav..nn.1
  dravel_1_N = mkN "dravel" neutrum  ; -- dravel..nn.1
  dravid_1_N = mkN "dravid" "dravider" ; -- dravid..nn.1
  dravidfolk_1_N = mkN "dravidfolk" neutrum  ; -- dravidfolk..nn.1
  dravidisk_1_A = mkA "dravidisk" ; -- dravidisk..av.1
  dravla_1_V = mkV "dravlar" ; -- dravla..vb.1
  dravlande_1_N = mkN "dravlande" ; -- dravlande..nn.1
  dregel_1_N = mkN "dregel" ; -- dregel..nn.1
  dregla_1_V = mkV "dreglar" ; -- dregla..vb.1
  dreglande_1_N = mkN "dreglande" ; -- dreglande..nn.1
  dreja_1_V = mkV "drejar" ; -- dreja..vb.1
  drejande_1_N = mkN "drejande" ; -- drejande..nn.1
  drejskiva_1_N = mkN "drejskiva" ; -- drejskiva..nn.1
  drejvända_1_V = mkV "drejvänder" ; -- drejvända..vb.1
  drejvändande_1_N = mkN "drejvändande" ; -- drejvändande..nn.1
  dress_1_N = mkN "dress" ; -- dress..nn.1
  dressera_1_V = mkV "dresserar" ; -- dressera..vb.1
  dresserande_1_N = mkN "dresserande" ; -- dresserande..nn.1
  dresserbar_1_A = mkA "dresserbar" ; -- dresserbar..av.1
  dresserbarhet_1_N = mkN "dresserbarhet" ; -- dresserbarhet..nn.1
  dressering_1_N = mkN "dressering" ; -- dressering..nn.1
  dressin_1_N = mkN "dressin" "dressiner" ; -- dressin..nn.1
  dressing_1_N = mkN "dressing" ; -- dressing..nn.1
  dressyr_1_N = mkN "dressyr" "dressyrer" ; -- dressyr..nn.1
  dressyrridning_1_N = mkN "dressyrridning" ; -- dressyrridning..nn.1
  dressör_1_N = mkN "dressör" "dressörer" ; -- dressör..nn.1
  drev_1_N = mkN "drev" neutrum  ; -- drev..nn.1
  drev_2_N = mkN "drev" neutrum  ; -- drev..nn.2
  dreva_1_V = mkV "drevar" ; -- dreva..vb.1
  drevande_1_N = mkN "drevande" ; -- drevande..nn.1
  drever_1_N = mkN "drever" ; -- drever..nn.1
  drevhund_1_N = mkN "drevhund" ; -- drevhund..nn.1
  drevjakt_1_N = mkN "drevjakt" "drevjakter" ; -- drevjakt..nn.1
  drevkarl_1_N = mkN "drevkarl" ; -- drevkarl..nn.1
  drevkedja_1_N = mkN "drevkedja" ; -- drevkedja..nn.1
  drevning_1_N = mkN "drevning" ; -- drevning..nn.1
  dribbla_1_V = mkV "dribblar" ; -- dribbla..vb.1
  dribblande_1_N = mkN "dribblande" ; -- dribblande..nn.1
  dribbler_1_N = mkN "dribbler" "dribblern" "dribblers" "dribblersen" ; -- dribbler..nn.1
  dribbling_1_N = mkN "dribbling" ; -- dribbling..nn.1
  dricka_2_N = mkN "dricka" ; -- dricka..nn.2
  dricka_1_V = mkV "dricka" "drack" "druckit" ; -- dricka..vb.1
  drickande_1_N = mkN "drickande" ; -- drickande..nn.1
  drickankare_1_N = mkN "drickankare" "drickankaret" "drickankaren" "drickankarna" ; -- drickankare..nn.1
  drickbar_1_A = mkA "drickbar" ; -- drickbar..av.1
  drickbarhet_1_N = mkN "drickbarhet" ; -- drickbarhet..nn.1
  drickning_1_N = mkN "drickning" ; -- drickning..nn.1
  dricks_1_N = mkN "dricks" ; -- dricks..nn.1
  dricksglas_1_N = mkN "dricksglas" neutrum  ; -- dricksglas..nn.1
  drickspeng_1_N = mkN "drickspeng" ; -- drickspeng..nn.1
  dricksvatten_1_N = mkN "dricksvatten" "dricksvattnet" "dricksvatten" "dricksvattnen" ; -- dricksvatten..nn.1
  drift_1_N = mkN "drift" ; -- drift..nn.1
  drift_2_N = mkN "drift" "drifter" ; -- drift..nn.2
  drifta_1_V = mkV "driftar" ; -- drifta..vb.1
  driftande_1_N = mkN "driftande" ; -- driftande..nn.1
  driftbudget_1_N = mkN "driftbudget" ; -- driftbudget..nn.1
  driftfel_1_N = mkN "driftfel" "driftfelet" "driftfel" "driftfelen" ; -- driftfel..nn.1
  driftig_1_A = mkA "driftig" ; -- driftig..av.1
  driftighet_1_N = mkN "driftighet" ; -- driftighet..nn.1
  driftkapital_1_N = mkN "driftkapital" neutrum  ; -- driftkapital..nn.1
  driftkostnad_1_N = mkN "driftkostnad" "driftkostnader" ; -- driftkostnad..nn.1
  driftkucku_1_N = mkN "driftkucku" ; -- driftkucku..nn.1
  driftliv_1_N = mkN "driftliv" neutrum  ; -- driftliv..nn.1
  driftmässig_1_A = mkA "driftmässig" ; -- driftmässig..av.1
  driftning_1_N = mkN "driftning" ; -- driftning..nn.1
  driftskostnad_1_N = mkN "driftskostnad" "driftskostnader" ; -- driftskostnad..nn.1
  driftsmässig_1_A = mkA "driftsmässig" ; -- driftsmässig..av.1
  driftsstöd_1_N = mkN "driftsstöd" neutrum  ; -- driftsstöd..nn.1
  driftstillestånd_1_N = mkN "driftstillestånd" neutrum  ; -- driftstillestånd..nn.1
  driftstillstånd_1_N = mkN "driftstillstånd" neutrum  ; -- driftstillstånd..nn.1
  driftstopp_1_N = mkN "driftstopp" neutrum  ; -- driftstopp..nn.1
  driftsäker_1_A = mkA "driftsäker" ; -- driftsäker..av.1
  driftsäkerhet_1_N = mkN "driftsäkerhet" ; -- driftsäkerhet..nn.1
  driftsäkerhetsmässig_1_A = mkA "driftsäkerhetsmässig" ; -- driftsäkerhetsmässig..av.1
  drifttid_1_N = mkN "drifttid" "drifttider" ; -- drifttid..nn.1
  drifttillgänglighet_1_N = mkN "drifttillgänglighet" ; -- drifttillgänglighet..nn.1
  driftvärn_1_N = mkN "driftvärn" neutrum  ; -- driftvärn..nn.1
  drill_1_N = mkN "drill" ; -- drill..nn.1
  drilla_1_V = mkV "drillar" ; -- drilla..vb.1
  drillande_1_N = mkN "drillande" ; -- drillande..nn.1
  drillborr_1_N = mkN "drillborr" ; -- drillborr..nn.1
  drillflicka_1_N = mkN "drillflicka" ; -- drillflicka..nn.1
  drilling_1_N = mkN "drilling" ; -- drilling..nn.1
  drillprogram_1_N = mkN "drillprogram" "drillprogrammet" "drillprogram" "drillprogrammen" ; -- drillprogram..nn.1
  drillsnäppa_1_N = mkN "drillsnäppa" ; -- drillsnäppa..nn.1
  drillstav_1_N = mkN "drillstav" ; -- drillstav..nn.1
  drink_1_N = mkN "drink" ; -- drink..nn.1
  drinkare_1_N = mkN "drinkare" utrum  ; -- drinkare..nn.1
  dristig_1_A = mkA "dristig" ; -- dristig..av.1
  dristighet_1_N = mkN "dristighet" ; -- dristighet..nn.1
  drittel_1_N = mkN "drittel" ; -- drittel..nn.1
  driv_1_N = mkN "driv" ; -- driv..nn.1
  driv_2_N = mkN "driv" neutrum  ; -- driv..nn.2
  driva_1_N = mkN "driva" ; -- driva..nn.1
  driva_1_V = mkV "driva" "drev" "drivit" ; -- driva..vb.1
  driva_2_V = mkV "driva" "drev" "drivit" ; -- driva..vb.2
  drivande_1_A = mkA "drivande" ; -- drivande..av.1
  drivande_1_N = mkN "drivande" ; -- drivande..nn.1
  drivankare_1_N = mkN "drivankare" "drivankaret" "drivankaren" "drivankarna" ; -- drivankare..nn.1
  drivaxel_1_N = mkN "drivaxel" ; -- drivaxel..nn.1
  drivband_1_N = mkN "drivband" neutrum  ; -- drivband..nn.1
  drivbänk_1_N = mkN "drivbänk" ; -- drivbänk..nn.1
  drive_1_N = mkN "drive" utrum  ; -- drive..nn.1
  driven_1_A = mkA "driven" ; -- driven..av.1
  drivenhet_1_N = mkN "drivenhet" ; -- drivenhet..nn.1
  driveri_1_N = mkN "driveri" neutrum  ; -- driveri..nn.1
  drivfjäder_1_N = mkN "drivfjäder" ; -- drivfjäder..nn.1
  drivflykt_1_N = mkN "drivflykt" ; -- drivflykt..nn.1
  drivgarn_1_N = mkN "drivgarn" neutrum  ; -- drivgarn..nn.1
  drivhjul_1_N = mkN "drivhjul" neutrum  ; -- drivhjul..nn.1
  drivhus_1_N = mkN "drivhus" neutrum  ; -- drivhus..nn.1
  drivhuseffekt_1_N = mkN "drivhuseffekt" ; -- drivhuseffekt..nn.1
  drivhusklimat_1_N = mkN "drivhusklimat" neutrum  ; -- drivhusklimat..nn.1
  drivhusplanta_1_N = mkN "drivhusplanta" ; -- drivhusplanta..nn.1
  drivis_1_N = mkN "drivis" ; -- drivis..nn.1
  drivkedja_1_N = mkN "drivkedja" ; -- drivkedja..nn.1
  drivkraft_1_N = mkN "drivkraft" "drivkrafter" ; -- drivkraft..nn.1
  drivlina_1_N = mkN "drivlina" ; -- drivlina..nn.1
  drivmedel_1_N = mkN "drivmedel" neutrum  ; -- drivmedel..nn.1
  drivmedelsbehov_1_N = mkN "drivmedelsbehov" neutrum  ; -- drivmedelsbehov..nn.1
  drivning_1_N = mkN "drivning" ; -- drivning..nn.1
  drivrem_1_N = mkN "drivrem" "drivremmen" "drivremmar" "drivremmarna" ; -- drivrem..nn.1
  drivsand_1_N = mkN "drivsand" ; -- drivsand..nn.1
  drivsnö_1_N = mkN "drivsnö" ; -- drivsnö..nn.1
  drivved_1_N = mkN "drivved" ; -- drivved..nn.1
  drivverk_1_N = mkN "drivverk" neutrum  ; -- drivverk..nn.1
  drog_1_N = mkN "drog" "droger" ; -- drog..nn.1
  droga_1_V = mkV "drogar" ; -- droga..vb.1
  drogande_1_N = mkN "drogande" ; -- drogande..nn.1
  drogberoende_1_N = mkN "drogberoende" ; -- drogberoende..nn.1
  drogeffekt_1_N = mkN "drogeffekt" "drogeffekter" ; -- drogeffekt..nn.1
  drogeri_1_N = mkN "drogeri" "drogeriet" "drogerier" "drogerierna" ; -- drogeri..nn.1
  drogfri_1_A = mkA "drogfri" "drogfritt" ; -- drogfri..av.1
  droghandel_1_N = mkN "droghandel" ; -- droghandel..nn.1
  droghandlare_1_N = mkN "droghandlare" utrum  ; -- droghandlare..nn.1
  drogliberal_1_A = mkA "drogliberal" ; -- drogliberal..av.1
  drogliberal_1_N = mkN "drogliberal" "drogliberaler" ; -- drogliberal..nn.1
  drogliberalism_1_N = mkN "drogliberalism" ; -- drogliberalism..nn.1
  drogmissbruk_1_N = mkN "drogmissbruk" neutrum  ; -- drogmissbruk..nn.1
  drogmissbrukande_1_A = mkA "drogmissbrukande" ; -- drogmissbrukande..av.1
  drogmissbrukare_1_N = mkN "drogmissbrukare" utrum  ; -- drogmissbrukare..nn.1
  drogmyt_1_N = mkN "drogmyt" "drogmyter" ; -- drogmyt..nn.1
  drogpolicy_1_N = mkN "drogpolicy" "drogpolicyn" "drogpolicysar" "drogpolicysarna" ; -- drogpolicy..nn.1
  drogpåverkad_1_A = mkA "drogpåverkad" ; -- drogpåverkad..av.1
  drogrelaterad_1_A = mkA "drogrelaterad" ; -- drogrelaterad..av.1
  drogsug_1_N = mkN "drogsug" neutrum  ; -- drogsug..nn.1
  drogtest_1_N = mkN "drogtest" neutrum  ; -- drogtest..nn.1
  drogtesta_1_V = mkV "drogtestar" ; -- drogtesta..vb.1
  drogtestande_1_N = mkN "drogtestande" ; -- drogtestande..nn.1
  drogtestning_1_N = mkN "drogtestning" ; -- drogtestning..nn.1
  drogvana_1_N = mkN "drogvana" ; -- drogvana..nn.1
  dromedar_1_N = mkN "dromedar" "dromedarer" ; -- dromedar..nn.1
  dront_1_N = mkN "dront" "dronter" ; -- dront..nn.1
  drop_in_1_N = mkN "drop-in" ; -- drop-in..nn.1
  dropin_1_N = mkN "dropin" ; -- dropin..nn.1
  dropp_1_N = mkN "dropp" neutrum  ; -- dropp..nn.1
  droppa_1_V = mkV "droppar" ; -- droppa..vb.1
  droppa_2_V = mkV "droppar" ; -- droppa..vb.2
  droppande_1_N = mkN "droppande" ; -- droppande..nn.1
  droppe_1_N = mkN "droppe" utrum  ; -- droppe..nn.1
  droppflaska_1_N = mkN "droppflaska" ; -- droppflaska..nn.1
  droppfri_1_A = mkA "droppfri" "droppfritt" ; -- droppfri..av.1
  droppglas_1_N = mkN "droppglas" neutrum  ; -- droppglas..nn.1
  droppinfektion_1_N = mkN "droppinfektion" ; -- droppinfektion..nn.1
  droppkork_1_N = mkN "droppkork" ; -- droppkork..nn.1
  droppnäsa_1_N = mkN "droppnäsa" ; -- droppnäsa..nn.1
  droppspets_1_N = mkN "droppspets" ; -- droppspets..nn.1
  droppsten_1_N = mkN "droppsten" "droppstenen" "droppstenar" "droppstenarna" ; -- droppsten..nn.1
  droppstensgrotta_1_N = mkN "droppstensgrotta" ; -- droppstensgrotta..nn.1
  droppstilla_1_Adv = mkAdv "droppstilla" ; -- droppstilla..ab.1
  droppvis_1_Adv = mkAdv "droppvis" ; -- droppvis..ab.1
  droska_1_N = mkN "droska" ; -- droska..nn.1
  droskbil_1_N = mkN "droskbil" ; -- droskbil..nn.1
  droskförare_1_N = mkN "droskförare" utrum  ; -- droskförare..nn.1
  drossel_1_N = mkN "drossel" ; -- drossel..nn.1
  drots_1_N = mkN "drots" ; -- drots..nn.1
  drott_1_N = mkN "drott" ; -- drott..nn.1
  drottkväde_1_N = mkN "drottkväde" ; -- drottkväde..nn.1
  drottning_1_N = mkN "drottning" ; -- drottning..nn.1
  drottningbesatt_1_A = mkA "drottningbesatt" ; -- drottningbesatt..av.1
  drottningkrona_1_N = mkN "drottningkrona" ; -- drottningkrona..nn.1
  drottninglik_1_A = mkA "drottninglik" ; -- drottninglik..av.1
  drottningsylt_1_N = mkN "drottningsylt" "drottningsylter" ; -- drottningsylt..nn.1
  drucken_1_A = mkA "drucken" ; -- drucken..av.1
  druckenhet_1_N = mkN "druckenhet" ; -- druckenhet..nn.1
  drufs_1_N = mkN "drufs" ; -- drufs..nn.1
  druid_1_N = mkN "druid" "druider" ; -- druid..nn.1
  druidisk_1_A = mkA "druidisk" ; -- druidisk..av.1
  druidkult_1_N = mkN "druidkult" "druidkulter" ; -- druidkult..nn.1
  drul_1_N = mkN "drul" ; -- drul..nn.1
  drulig_1_A = mkA "drulig" ; -- drulig..av.1
  drulla_1_V = mkV "drullar" ; -- drulla..vb.1
  drullande_1_N = mkN "drullande" ; -- drullande..nn.1
  drulle_1_N = mkN "drulle" utrum  ; -- drulle..nn.1
  drulleförsäkring_1_N = mkN "drulleförsäkring" ; -- drulleförsäkring..nn.1
  drullig_1_A = mkA "drullig" ; -- drullig..av.1
  drullighet_1_N = mkN "drullighet" "drulligheter" ; -- drullighet..nn.1
  drullputt_1_N = mkN "drullputt" ; -- drullputt..nn.1
  drumla_1_V = mkV "drumlar" ; -- drumla..vb.1
  drumlande_1_N = mkN "drumlande" ; -- drumlande..nn.1
  drumlig_1_A = mkA "drumlig" ; -- drumlig..av.1
  drumlighet_1_N = mkN "drumlighet" "drumligheter" ; -- drumlighet..nn.1
  drummel_1_N = mkN "drummel" "drummeln" "drummlar" "drummlarna" ; -- drummel..nn.1
  drummelaktig_1_A = mkA "drummelaktig" ; -- drummelaktig..av.1
  drummelaktighet_1_N = mkN "drummelaktighet" ; -- drummelaktighet..nn.1
  drunkna_1_V = mkV "drunknar" ; -- drunkna..vb.1
  drunknande_1_N = mkN "drunknande" ; -- drunknande..nn.1
  drunkning_1_N = mkN "drunkning" ; -- drunkning..nn.1
  drunkningsdöd_1_N = mkN "drunkningsdöd" ; -- drunkningsdöd..nn.1
  drunkningsmetafor_1_N = mkN "drunkningsmetafor" "drunkningsmetaforen" "drunkningsmetaforer" "drunkningsmetaforerna" ; -- drunkningsmetafor..nn.1
  drunkningsolycka_1_N = mkN "drunkningsolycka" ; -- drunkningsolycka..nn.1
  drunkningsår_1_N = mkN "drunkningsår" neutrum  ; -- drunkningsår..nn.1
  drus_1_N = mkN "drus" "druser" ; -- drus..nn.1
  druva_1_N = mkN "druva" ; -- druva..nn.1
  druvblå_1_A = mkA "druvblå" "druvblått" ; -- druvblå..av.1
  druvbörd_1_N = mkN "druvbörd" "druvbörder" ; -- druvbörd..nn.1
  druvfläder_1_N = mkN "druvfläder" ; -- druvfläder..nn.1
  druvgurka_1_N = mkN "druvgurka" ; -- druvgurka..nn.1
  druvhagel_1_N = mkN "druvhagel" neutrum  ; -- druvhagel..nn.1
  druvklase_1_N = mkN "druvklase" utrum  ; -- druvklase..nn.1
  druvrussin_1_N = mkN "druvrussin" neutrum  ; -- druvrussin..nn.1
  druvsaft_1_N = mkN "druvsaft" "druvsafter" ; -- druvsaft..nn.1
  druvsocker_1_N = mkN "druvsocker" neutrum  ; -- druvsocker..nn.1
  dryad_1_N = mkN "dryad" "dryader" ; -- dryad..nn.1
  dryck_1_N = mkN "dryck" "drycker" ; -- dryck..nn.1
  dryck_2_N = mkN "dryck" neutrum  ; -- dryck..nn.2
  dryckenskap_1_N = mkN "dryckenskap" ; -- dryckenskap..nn.1
  dryckesbroder_1_N = mkN "dryckesbroder" "dryckesbrodern" "dryckesbröder" "dryckesbröderna" ; -- dryckesbroder..nn.1
  dryckesbägare_1_N = mkN "dryckesbägare" utrum  ; -- dryckesbägare..nn.1
  dryckesfråga_1_N = mkN "dryckesfråga" ; -- dryckesfråga..nn.1
  dryckesgille_1_N = mkN "dryckesgille" ; -- dryckesgille..nn.1
  dryckeshorn_1_N = mkN "dryckeshorn" neutrum  ; -- dryckeshorn..nn.1
  dryckeskärl_1_N = mkN "dryckeskärl" neutrum  ; -- dryckeskärl..nn.1
  dryckeslag_1_N = mkN "dryckeslag" neutrum  ; -- dryckeslag..nn.1
  dryckesoffer_1_N = mkN "dryckesoffer" neutrum  ; -- dryckesoffer..nn.1
  dryckesorgie_1_N = mkN "dryckesorgie" "dryckesorgier" ; -- dryckesorgie..nn.1
  dryckesservis_1_N = mkN "dryckesservis" "dryckesserviser" ; -- dryckesservis..nn.1
  dryckesvana_1_N = mkN "dryckesvana" ; -- dryckesvana..nn.1
  dryckesvisa_1_N = mkN "dryckesvisa" ; -- dryckesvisa..nn.1
  dryckjom_1_N = mkN "dryckjom" ; -- dryckjom..nn.1
  dryfta_1_V = mkV "dryftar" ; -- dryfta..vb.1
  dryftande_1_N = mkN "dryftande" ; -- dryftande..nn.1
  dryftning_1_N = mkN "dryftning" ; -- dryftning..nn.1
  dryg_1_A = mkA "dryg" ; -- dryg..av.1
  dryghet_1_N = mkN "dryghet" "drygheter" ; -- dryghet..nn.1
  drygsel_1_N = mkN "drygsel" ; -- drygsel..nn.1
  drypa_1_V = mkV "drypa" "dröp" "drypt" ; -- drypa..vb.1
  drypande_1_N = mkN "drypande" ; -- drypande..nn.1
  drypning_1_N = mkN "drypning" ; -- drypning..nn.1
  drägel_1_N = mkN "drägel" ; -- drägel..nn.1
  drägg_1_N = mkN "drägg" ; -- drägg..nn.1
  drägla_1_V = mkV "dräglar" ; -- drägla..vb.1
  dräglande_1_N = mkN "dräglande" ; -- dräglande..nn.1
  dräglig_1_A = mkA "dräglig" ; -- dräglig..av.1
  dräglighet_1_N = mkN "dräglighet" ; -- dräglighet..nn.1
  dräkt_1_N = mkN "dräkt" "dräkter" ; -- dräkt..nn.1
  dräktig_1_A = mkA "dräktig" ; -- dräktig..av.1
  dräktighet_1_N = mkN "dräktighet" "dräktigheter" ; -- dräktighet..nn.1
  dräktskick_1_N = mkN "dräktskick" neutrum  ; -- dräktskick..nn.1
  dräktspänne_1_N = mkN "dräktspänne" ; -- dräktspänne..nn.1
  dräll_1_N = mkN "dräll" ; -- dräll..nn.1
  drälla_1_V = mkV "dräller" ; -- drälla..vb.1
  drällande_1_N = mkN "drällande" ; -- drällande..nn.1
  drämma_1_V = mkV "drämmer" ; -- drämma..vb.1
  drämmande_1_N = mkN "drämmande" ; -- drämmande..nn.1
  drän_1_N = mkN "drän" "dräner" ; -- drän..nn.1
  dränage_1_N = mkN "dränage" ; -- dränage..nn.1
  dränera_1_V = mkV "dränerar" ; -- dränera..vb.1
  dränerande_1_N = mkN "dränerande" ; -- dränerande..nn.1
  dränerbar_1_A = mkA "dränerbar" ; -- dränerbar..av.1
  dränerbarhet_1_N = mkN "dränerbarhet" ; -- dränerbarhet..nn.1
  dränering_1_N = mkN "dränering" ; -- dränering..nn.1
  dräneringsdike_1_N = mkN "dräneringsdike" ; -- dräneringsdike..nn.1
  dräneringsområde_1_N = mkN "dräneringsområde" ; -- dräneringsområde..nn.1
  dräneringsrör_1_N = mkN "dräneringsrör" neutrum  ; -- dräneringsrör..nn.1
  dräng_1_N = mkN "dräng" ; -- dräng..nn.1
  drängtjänst_1_N = mkN "drängtjänst" "drängtjänster" ; -- drängtjänst..nn.1
  dränka_1_V = mkV "dränker" ; -- dränka..vb.1
  dränkande_1_N = mkN "dränkande" ; -- dränkande..nn.1
  dränkbar_1_A = mkA "dränkbar" ; -- dränkbar..av.1
  dränkbarhet_1_N = mkN "dränkbarhet" ; -- dränkbarhet..nn.1
  dränkning_1_N = mkN "dränkning" ; -- dränkning..nn.1
  dräpa_1_V = mkV "dräper" ; -- dräpa..vb.1
  dräpande_1_A = mkA "dräpande" ; -- dräpande..av.1
  dräpande_1_N = mkN "dräpande" ; -- dräpande..nn.1
  drätsel_1_N = mkN "drätsel" ; -- drätsel..nn.1
  drätselkammare_1_N = mkN "drätselkammare" "drätselkammaren" "drätselkammare" "drätselkamrarna" ; -- drätselkammare..nn.1
  drätselnämnd_1_N = mkN "drätselnämnd" "drätselnämnder" ; -- drätselnämnd..nn.1
  drätt_1_N = mkN "drätt" ; -- drätt..nn.1
  dråp_1_N = mkN "dråp" neutrum  ; -- dråp..nn.1
  dråpare_1_N = mkN "dråpare" utrum  ; -- dråpare..nn.1
  dråplig_1_A = mkA "dråplig" ; -- dråplig..av.1
  dråplighet_1_N = mkN "dråplighet" "dråpligheter" ; -- dråplighet..nn.1
  dråprättegång_1_N = mkN "dråprättegång" ; -- dråprättegång..nn.1
  dråpslag_1_N = mkN "dråpslag" neutrum  ; -- dråpslag..nn.1
  dråsa_1_V = mkV "dråsar" ; -- dråsa..vb.1
  dråsande_1_N = mkN "dråsande" ; -- dråsande..nn.1
  dråse_1_N = mkN "dråse" utrum  ; -- dråse..nn.1
  drög_1_N = mkN "drög" ; -- drög..nn.1
  dröglapp_1_N = mkN "dröglapp" ; -- dröglapp..nn.1
  dröja_1_V = mkV "dröja" "dröjde" "dröjt" ; -- dröja..vb.1
  dröjande_1_N = mkN "dröjande" ; -- dröjande..nn.1
  dröjsmål_1_N = mkN "dröjsmål" neutrum  ; -- dröjsmål..nn.1
  dröjsmålsränta_1_N = mkN "dröjsmålsränta" ; -- dröjsmålsränta..nn.1
  dröm_1_N = mkN "dröm" "drömmen" "drömmar" "drömmarna" ; -- dröm..nn.1
  drömbild_1_N = mkN "drömbild" "drömbilder" ; -- drömbild..nn.1
  drömbok_1_N = mkN "drömbok" "drömböcker" ; -- drömbok..nn.1
  drömdejt_1_N = mkN "drömdejt" ; -- drömdejt..nn.1
  drömgräns_1_N = mkN "drömgräns" "drömgränser" ; -- drömgräns..nn.1
  drömkandidat_1_N = mkN "drömkandidat" "drömkandidater" ; -- drömkandidat..nn.1
  drömlandskap_1_N = mkN "drömlandskap" neutrum  ; -- drömlandskap..nn.1
  drömlik_1_A = mkA "drömlik" ; -- drömlik..av.1
  drömlikhet_1_N = mkN "drömlikhet" ; -- drömlikhet..nn.1
  drömliknande_1_A = mkA "drömliknande" ; -- drömliknande..av.1
  drömliv_1_N = mkN "drömliv" neutrum  ; -- drömliv..nn.1
  drömlön_1_N = mkN "drömlön" "drömlöner" ; -- drömlön..nn.1
  drömma_1_V = mkV "drömmer" ; -- drömma..vb.1
  drömmande_1_N = mkN "drömmande" ; -- drömmande..nn.1
  drömmare_1_N = mkN "drömmare" utrum  ; -- drömmare..nn.1
  drömmeri_1_N = mkN "drömmeri" "drömmeriet" "drömmerier" "drömmerierna" ; -- drömmeri..nn.1
  drömmil_1_N = mkN "drömmil" ; -- drömmil..nn.1
  drömmål_1_N = mkN "drömmål" neutrum  ; -- drömmål..nn.1
  drömresa_1_N = mkN "drömresa" ; -- drömresa..nn.1
  drömrumpa_1_N = mkN "drömrumpa" ; -- drömrumpa..nn.1
  drömsk_1_A = mkA "drömsk" ; -- drömsk..av.1
  drömskapelse_1_N = mkN "drömskapelse" "drömskapelser" ; -- drömskapelse..nn.1
  drömskhet_1_N = mkN "drömskhet" ; -- drömskhet..nn.1
  drömslott_1_N = mkN "drömslott" neutrum  ; -- drömslott..nn.1
  drömstart_1_N = mkN "drömstart" "drömstarter" ; -- drömstart..nn.1
  drömsyn_1_N = mkN "drömsyn" "drömsyner" ; -- drömsyn..nn.1
  drömsällskap_1_N = mkN "drömsällskap" neutrum  ; -- drömsällskap..nn.1
  drömsömn_1_N = mkN "drömsömn" ; -- drömsömn..nn.1
  drömtydande_1_N = mkN "drömtydande" ; -- drömtydande..nn.1
  drömtydare_1_N = mkN "drömtydare" utrum  ; -- drömtydare..nn.1
  drömtydning_1_N = mkN "drömtydning" ; -- drömtydning..nn.1
  drömtydningsbok_1_N = mkN "drömtydningsbok" "drömtydningsböcker" ; -- drömtydningsbok..nn.1
  drömvärld_1_N = mkN "drömvärld" ; -- drömvärld..nn.1
  dröna_1_V = mkV "drönar" ; -- dröna..vb.1
  drönande_1_N = mkN "drönande" ; -- drönande..nn.1
  drönarattack_1_N = mkN "drönarattack" "drönarattacker" ; -- drönarattack..nn.1
  drönarbas_1_N = mkN "drönarbas" ; -- drönarbas..nn.1
  drönare_1_N = mkN "drönare" utrum  ; -- drönare..nn.1
  drönarförespråkare_1_N = mkN "drönarförespråkare" utrum  ; -- drönarförespråkare..nn.1
  drönarliv_1_N = mkN "drönarliv" neutrum  ; -- drönarliv..nn.1
  drönarräd_1_N = mkN "drönarräd" "drönarräder" ; -- drönarräd..nn.1
  dröppel_1_N = mkN "dröppel" ; -- dröppel..nn.1
  drösa_1_V = mkV "dröser" ; -- drösa..vb.1
  drösande_1_N = mkN "drösande" ; -- drösande..nn.1
  dröse_1_N = mkN "drös" ; -- dröse..nn.1
  drösvis_1_Adv = mkAdv "drösvis" ; -- drösvis..ab.1
  dua_1_V = mkV "duar" ; -- dua..vb.1
  dual_1_N = mkN "dual" "dualer" ; -- dual..nn.1
  dualform_1_N = mkN "dualform" "dualformer" ; -- dualform..nn.1
  dualis_1_N = mkN "dualis" ; -- dualis..nn.1
  dualism_1_N = mkN "dualism" "dualismer" ; -- dualism..nn.1
  dualist_1_N = mkN "dualist" "dualister" ; -- dualist..nn.1
  dualistisk_1_A = mkA "dualistisk" ; -- dualistisk..av.1
  duande_1_N = mkN "duande" ; -- duande..nn.1
  dubb_1_N = mkN "dubb" ; -- dubb..nn.1
  dubba_1_V = mkV "dubbar" ; -- dubba..vb.1
  dubbande_1_N = mkN "dubbande" ; -- dubbande..nn.1
  dubbdocka_1_N = mkN "dubbdocka" ; -- dubbdocka..nn.1
  dubbdäck_1_N = mkN "dubbdäck" neutrum  ; -- dubbdäck..nn.1
  dubbdäcksförbud_1_N = mkN "dubbdäcksförbud" neutrum  ; -- dubbdäcksförbud..nn.1
  dubbel_1_A = mkA "dubbel" ; -- dubbel..av.1
  dubbel_1_N = mkN "dubbel" ; -- dubbel..nn.1
  dubbelagent_1_N = mkN "dubbelagent" "dubbelagenter" ; -- dubbelagent..nn.1
  dubbelansikte_1_N = mkN "dubbelansikte" ; -- dubbelansikte..nn.1
  dubbelarbetande_1_A = mkA "dubbelarbetande" ; -- dubbelarbetande..av.1
  dubbelbeckasin_1_N = mkN "dubbelbeckasin" "dubbelbeckasiner" ; -- dubbelbeckasin..nn.1
  dubbelbeskatta_1_V = mkV "dubbelbeskattar" ; -- dubbelbeskatta..vb.1
  dubbelbeskattande_1_N = mkN "dubbelbeskattande" ; -- dubbelbeskattande..nn.1
  dubbelbiff_1_N = mkN "dubbelbiff" ; -- dubbelbiff..nn.1
  dubbelbindning_1_N = mkN "dubbelbindning" ; -- dubbelbindning..nn.1
  dubbelbluff_1_N = mkN "dubbelbluff" ; -- dubbelbluff..nn.1
  dubbelbotten_1_N = mkN "dubbelbotten" ; -- dubbelbotten..nn.1
  dubbelbottnad_1_A = mkA "dubbelbottnad" ; -- dubbelbottnad..av.1
  dubbelbredd_1_N = mkN "dubbelbredd" "dubbelbredder" ; -- dubbelbredd..nn.1
  dubbelbrytning_1_N = mkN "dubbelbrytning" ; -- dubbelbrytning..nn.1
  dubbelbröllop_1_N = mkN "dubbelbröllop" neutrum  ; -- dubbelbröllop..nn.1
  dubbelbössa_1_N = mkN "dubbelbössa" ; -- dubbelbössa..nn.1
  dubbeldäckare_1_N = mkN "dubbeldäckare" utrum  ; -- dubbeldäckare..nn.1
  dubbeldörr_1_N = mkN "dubbeldörr" ; -- dubbeldörr..nn.1
  dubbelexponera_1_V = mkV "dubbelexponerar" ; -- dubbelexponera..vb.1
  dubbelexponerande_1_N = mkN "dubbelexponerande" ; -- dubbelexponerande..nn.1
  dubbelexponerbar_1_A = mkA "dubbelexponerbar" ; -- dubbelexponerbar..av.1
  dubbelexponerbarhet_1_N = mkN "dubbelexponerbarhet" ; -- dubbelexponerbarhet..nn.1
  dubbelexponering_1_N = mkN "dubbelexponering" ; -- dubbelexponering..nn.1
  dubbelfel_1_N = mkN "dubbelfel" "dubbelfelet" "dubbelfel" "dubbelfelen" ; -- dubbelfel..nn.1
  dubbelfönster_1_N = mkN "dubbelfönster" neutrum  ; -- dubbelfönster..nn.1
  dubbelgarage_1_N = mkN "dubbelgarage" "dubbelgaraget" "dubbelgarage" "dubbelgaragen" ; -- dubbelgarage..nn.1
  dubbelgrepp_1_N = mkN "dubbelgrepp" neutrum  ; -- dubbelgrepp..nn.1
  dubbelgångare_1_N = mkN "dubbelgångare" utrum  ; -- dubbelgångare..nn.1
  dubbelhaka_1_N = mkN "dubbelhaka" ; -- dubbelhaka..nn.1
  dubbelhandsfattning_1_N = mkN "dubbelhandsfattning" ; -- dubbelhandsfattning..nn.1
  dubbelhet_1_N = mkN "dubbelhet" "dubbelheter" ; -- dubbelhet..nn.1
  dubbelhytt_1_N = mkN "dubbelhytt" "dubbelhytter" ; -- dubbelhytt..nn.1
  dubbelhäftande_1_A = mkA "dubbelhäftande" ; -- dubbelhäftande..av.1
  dubbelhölster_1_N = mkN "dubbelhölster" neutrum  ; -- dubbelhölster..nn.1
  dubbelklick_1_N = mkN "dubbelklick" neutrum  ; -- dubbelklick..nn.1
  dubbelklicka_1_V = mkV "dubbelklickar" ; -- dubbelklicka..vb.1
  dubbelklickande_1_N = mkN "dubbelklickande" ; -- dubbelklickande..nn.1
  dubbelklickning_1_N = mkN "dubbelklickning" ; -- dubbelklickning..nn.1
  dubbelknäppt_1_A = mkA "dubbelknäppt" "dubbelknäppt" ; -- dubbelknäppt..av.1
  dubbelkoll_1_N = mkN "dubbelkoll" ; -- dubbelkoll..nn.1
  dubbelkolla_1_V = mkV "dubbelkollar" ; -- dubbelkolla..vb.1
  dubbelkollande_1_N = mkN "dubbelkollande" ; -- dubbelkollande..nn.1
  dubbelkollning_1_N = mkN "dubbelkollning" ; -- dubbelkollning..nn.1
  dubbelkommando_1_N = mkN "dubbelkommando" "dubbelkommandot" "dubbelkommandon" "dubbelkommandona" ; -- dubbelkommando..nn.1
  dubbelkontakt_1_N = mkN "dubbelkontakt" "dubbelkontakter" ; -- dubbelkontakt..nn.1
  dubbelkvartett_1_N = mkN "dubbelkvartett" "dubbelkvartetter" ; -- dubbelkvartett..nn.1
  dubbelkör_1_N = mkN "dubbelkör" "dubbelkörer" ; -- dubbelkör..nn.1
  dubbelliv_1_N = mkN "dubbelliv" neutrum  ; -- dubbelliv..nn.1
  dubbelmadrass_1_N = mkN "dubbelmadrass" "dubbelmadrasser" ; -- dubbelmadrass..nn.1
  dubbelmening_1_N = mkN "dubbelmening" ; -- dubbelmening..nn.1
  dubbelmoral_1_N = mkN "dubbelmoral" ; -- dubbelmoral..nn.1
  dubbelmord_1_N = mkN "dubbelmord" neutrum  ; -- dubbelmord..nn.1
  dubbelnamn_1_N = mkN "dubbelnamn" neutrum  ; -- dubbelnamn..nn.1
  dubbelnatur_1_N = mkN "dubbelnatur" "dubbelnaturer" ; -- dubbelnatur..nn.1
  dubbelnelson_1_N = mkN "dubbelnelson" ; -- dubbelnelson..nn.1
  dubbelnöt_1_N = mkN "dubbelnöt" "dubbelnötter" ; -- dubbelnöt..nn.1
  dubbelpanera_1_V = mkV "dubbelpanerar" ; -- dubbelpanera..vb.1
  dubbelpanerande_1_N = mkN "dubbelpanerande" ; -- dubbelpanerande..nn.1
  dubbelpanering_1_N = mkN "dubbelpanering" ; -- dubbelpanering..nn.1
  dubbelpipig_1_A = mkA "dubbelpipig" ; -- dubbelpipig..av.1
  dubbelrevolution_1_N = mkN "dubbelrevolution" ; -- dubbelrevolution..nn.1
  dubbelriktad_1_A = mkA "dubbelriktad" ; -- dubbelriktad..av.1
  dubbelroll_1_N = mkN "dubbelroll" "dubbelroller" ; -- dubbelroll..nn.1
  dubbelrum_1_N = mkN "dubbelrum" "dubbelrummet" "dubbelrum" "dubbelrummen" ; -- dubbelrum..nn.1
  dubbelrör_1_N = mkN "dubbelrör" neutrum  ; -- dubbelrör..nn.1
  dubbelsalt_1_N = mkN "dubbelsalt" "dubbelsaltet" "dubbelsalter" "dubbelsalterna" ; -- dubbelsalt..nn.1
  dubbelseende_1_N = mkN "dubbelseende" ; -- dubbelseende..nn.1
  dubbelsidig_1_A = mkA "dubbelsidig" ; -- dubbelsidig..av.1
  dubbelspel_1_N = mkN "dubbelspel" "dubbelspelet" "dubbelspel" "dubbelspelen" ; -- dubbelspel..nn.1
  dubbelspår_1_N = mkN "dubbelspår" neutrum  ; -- dubbelspår..nn.1
  dubbelspårig_1_A = mkA "dubbelspårig" ; -- dubbelspårig..av.1
  dubbelspårsutbyggnad_1_N = mkN "dubbelspårsutbyggnad" "dubbelspårsutbyggnader" ; -- dubbelspårsutbyggnad..nn.1
  dubbelstjärna_1_N = mkN "dubbelstjärna" ; -- dubbelstjärna..nn.1
  dubbelstjärnsystem_1_N = mkN "dubbelstjärnsystem" neutrum  ; -- dubbelstjärnsystem..nn.1
  dubbelsträngad_1_A = mkA "dubbelsträngad" ; -- dubbelsträngad..av.1
  dubbelsyn_1_N = mkN "dubbelsyn" ; -- dubbelsyn..nn.1
  dubbelsäkring_1_N = mkN "dubbelsäkring" ; -- dubbelsäkring..nn.1
  dubbelsäng_1_N = mkN "dubbelsäng" ; -- dubbelsäng..nn.1
  dubbeltimma_1_N = mkN "dubbeltimma" ; -- dubbeltimma..nn.1
  dubbeltimme_1_N = mkN "dubbeltimme" utrum  ; -- dubbeltimme..nn.1
  dubbeltrast_1_N = mkN "dubbeltrast" ; -- dubbeltrast..nn.1
  dubbelträff_1_N = mkN "dubbelträff" ; -- dubbelträff..nn.1
  dubbeltrådig_1_A = mkA "dubbeltrådig" ; -- dubbeltrådig..av.1
  dubbeltydig_1_A = mkA "dubbeltydig" ; -- dubbeltydig..av.1
  dubbeltydighet_1_N = mkN "dubbeltydighet" ; -- dubbeltydighet..nn.1
  dubbelverkande_1_A = mkA "dubbelverkande" ; -- dubbelverkande..av.1
  dubbelvikt_1_A = mkA "dubbelvikt" "dubbelvikt" ; -- dubbelvikt..av.1
  dubbelörn_1_N = mkN "dubbelörn" ; -- dubbelörn..nn.1
  dubbfri_1_A = mkA "dubbfri" "dubbfritt" ; -- dubbfri..av.1
  dubbförbud_1_N = mkN "dubbförbud" neutrum  ; -- dubbförbud..nn.1
  dubbhöjd_1_N = mkN "dubbhöjd" "dubbhöjder" ; -- dubbhöjd..nn.1
  dubbla_1_V = mkV "dubblar" ; -- dubbla..vb.1
  dubblande_1_N = mkN "dubblande" ; -- dubblande..nn.1
  dubblare_1_N = mkN "dubblare" utrum  ; -- dubblare..nn.1
  dubblera_1_V = mkV "dubblerar" ; -- dubblera..vb.1
  dubblerande_1_N = mkN "dubblerande" ; -- dubblerande..nn.1
  dubblerbar_1_A = mkA "dubblerbar" ; -- dubblerbar..av.1
  dubblerbarhet_1_N = mkN "dubblerbarhet" ; -- dubblerbarhet..nn.1
  dubblering_1_N = mkN "dubblering" ; -- dubblering..nn.1
  dubblett_1_N = mkN "dubblett" "dubbletter" ; -- dubblett..nn.1
  dubblé_2_N = mkN "dubblé" "dubbléer" ; -- dubblé..nn.2
  dubbning_1_N = mkN "dubbning" ; -- dubbning..nn.1
  dubbslitage_1_N = mkN "dubbslitage" ; -- dubbslitage..nn.1
  dubiös_1_A = mkA "dubiös" ; -- dubiös..av.1
  dublett_1_N = mkN "dublett" "dubletter" ; -- dublett..nn.1
  dubror_1_N = mkN "dubror" "dubröder" ; -- dubror..nn.1
  duchatel_1_N = mkN "duchatel" "duchateler" ; -- duchatel..nn.1
  duchesse_1_N = mkN "duchesse" utrum  ; -- duchesse..nn.1
  ducka_1_V = mkV "duckar" ; -- ducka..vb.1
  duckande_1_N = mkN "duckande" ; -- duckande..nn.1
  duell_1_N = mkN "duell" "dueller" ; -- duell..nn.1
  duellant_1_N = mkN "duellant" "duellanter" ; -- duellant..nn.1
  duellera_1_V = mkV "duellerar" ; -- duellera..vb.1
  duellerande_1_N = mkN "duellerande" ; -- duellerande..nn.1
  duellering_1_N = mkN "duellering" ; -- duellering..nn.1
  duellväsen_1_N = mkN "duellväsen" neutrum  ; -- duellväsen..nn.1
  duenna_1_N = mkN "duenna" ; -- duenna..nn.1
  duett_1_N = mkN "duett" "duetter" ; -- duett..nn.1
  duettsång_1_N = mkN "duettsång" ; -- duettsång..nn.1
  duffel_1_N = mkN "duffel" ; -- duffel..nn.1
  duga_1_V = mkV "duga" "dugade" "dugit" ; -- duga..vb.1
  dugande_1_A = mkA "dugande" ; -- dugande..av.1
  dugande_1_N = mkN "dugande" ; -- dugande..nn.1
  dugga_1_V = mkV "duggar" ; -- dugga..vb.1
  duggande_1_N = mkN "duggande" ; -- duggande..nn.1
  duggregn_1_N = mkN "duggregn" neutrum  ; -- duggregn..nn.1
  duggregna_1_V = mkV "duggregnar" ; -- duggregna..vb.1
  duggregnande_1_N = mkN "duggregnande" ; -- duggregnande..nn.1
  duglig_1_A = mkA "duglig" ; -- duglig..av.1
  duglighet_1_N = mkN "duglighet" "dugligheter" ; -- duglighet..nn.1
  duk_1_N = mkN "duk" ; -- duk..nn.1
  duka_1_V = mkV "dukar" ; -- duka..vb.1
  dukagång_1_N = mkN "dukagång" ; -- dukagång..nn.1
  dukande_1_N = mkN "dukande" ; -- dukande..nn.1
  dukat_1_N = mkN "dukat" "dukater" ; -- dukat..nn.1
  dukning_1_N = mkN "dukning" ; -- dukning..nn.1
  dukt_1_N = mkN "dukt" "dukter" ; -- dukt..nn.1
  duktig_1_A = mkA "duktig" ; -- duktig..av.1
  duktighet_1_N = mkN "duktighet" ; -- duktighet..nn.1
  dulcian_1_N = mkN "dulcian" "dulcianer" ; -- dulcian..nn.1
  dum_1_A = mkA "dum" "dumt" "dumma" "dumma" "dummare" "dummast" "dummaste" ; -- dum..av.1
  duma_1_N = mkN "duma" ; -- duma..nn.1
  dumbom_1_N = mkN "dumbom" "dumbommen" "dumbommar" "dumbommarna" ; -- dumbom..nn.1
  dumburk_1_N = mkN "dumburk" ; -- dumburk..nn.1
  dumdristig_1_A = mkA "dumdristig" ; -- dumdristig..av.1
  dumdristighet_1_N = mkN "dumdristighet" ; -- dumdristighet..nn.1
  dumdryg_1_A = mkA "dumdryg" ; -- dumdryg..av.1
  dumdryghet_1_N = mkN "dumdryghet" ; -- dumdryghet..nn.1
  dumdumkula_1_N = mkN "dumdumkula" ; -- dumdumkula..nn.1
  dumhet_1_N = mkN "dumhet" "dumheter" ; -- dumhet..nn.1
  dumhuvud_1_N = mkN "dumhuvud" "dumhuvudet" "dumhuvud" "dumhuvudena" ; -- dumhuvud..nn.1
  dumkåt_1_A = mkA "dumkåt" ; -- dumkåt..av.1
  dummer_1_N = mkN "dummer" "dummern" "dummar" "dummarna" ; -- dummer..nn.1
  dummerjöns_1_N = mkN "dummerjöns" ; -- dummerjöns..nn.1
  dumming_1_N = mkN "dumming" ; -- dumming..nn.1
  dummy_1_N = mkN "dummy" "dummyn" "dummysar" "dummysarna" ; -- dummy..nn.1
  dumpa_1_V = mkV "dumpar" ; -- dumpa..vb.1
  dumpande_1_N = mkN "dumpande" ; -- dumpande..nn.1
  dumper_1_N = mkN "dumper" ; -- dumper..nn.1
  dumpning_1_N = mkN "dumpning" ; -- dumpning..nn.1
  dumskalle_1_N = mkN "dumskalle" utrum  ; -- dumskalle..nn.1
  dumskallemajoritet_1_N = mkN "dumskallemajoritet" "dumskallemajoriteter" ; -- dumskallemajoritet..nn.1
  dumsnut_1_N = mkN "dumsnut" ; -- dumsnut..nn.1
  dumsnål_1_A = mkA "dumsnål" ; -- dumsnål..av.1
  dumstrut_1_N = mkN "dumstrut" ; -- dumstrut..nn.1
  dun_1_N = mkN "dun" neutrum  ; -- dun..nn.1
  duna_1_V = mkV "dunar" ; -- duna..vb.1
  dunande_1_N = mkN "dunande" ; -- dunande..nn.1
  dunboll_1_N = mkN "dunboll" ; -- dunboll..nn.1
  dunbolster_1_N = mkN "dunbolster" ; -- dunbolster..nn.1
  dunbädd_1_N = mkN "dunbädd" ; -- dunbädd..nn.1
  dunder_1_N = mkN "dunder" neutrum  ; -- dunder..nn.1
  dundergud_1_N = mkN "dundergud" ; -- dundergud..nn.1
  dunderhonung_1_N = mkN "dunderhonung" ; -- dunderhonung..nn.1
  dunderkur_1_N = mkN "dunderkur" "dunderkurer" ; -- dunderkur..nn.1
  dundermedicin_1_N = mkN "dundermedicin" "dundermediciner" ; -- dundermedicin..nn.1
  dundra_1_V = mkV "dundrar" ; -- dundra..vb.1
  dundrande_1_N = mkN "dundrande" ; -- dundrande..nn.1
  dunge_1_N = mkN "dunge" utrum  ; -- dunge..nn.1
  dunig_1_A = mkA "dunig" ; -- dunig..av.1
  dunk_1_N = mkN "dunk" ; -- dunk..nn.1
  dunk_2_N = mkN "dunk" neutrum  ; -- dunk..nn.2
  dunka_1_V = mkV "dunkar" ; -- dunka..vb.1
  dunkande_1_N = mkN "dunkande" ; -- dunkande..nn.1
  dunkel_1_A = mkA "dunkel" ; -- dunkel..av.1
  dunkel_1_N = mkN "dunkel" neutrum  ; -- dunkel..nn.1
  dunkelblå_1_A = mkA "dunkelblå" "dunkelblått" ; -- dunkelblå..av.1
  dunkelhet_1_N = mkN "dunkelhet" "dunkelheter" ; -- dunkelhet..nn.1
  dunkning_1_N = mkN "dunkning" ; -- dunkning..nn.1
  dunkudde_1_N = mkN "dunkudde" utrum  ; -- dunkudde..nn.1
  dunlätt_1_A = mkA "dunlätt" ; -- dunlätt..av.1
  dunmjuk_1_A = mkA "dunmjuk" ; -- dunmjuk..av.1
  duns_1_N = mkN "duns" ; -- duns..nn.1
  dunsa_1_V = mkV "dunsar" ; -- dunsa..vb.1
  dunsande_1_N = mkN "dunsande" ; -- dunsande..nn.1
  dunst_1_N = mkN "dunst" "dunster" ; -- dunst..nn.1
  dunsta_1_V = mkV "dunstar" ; -- dunsta..vb.1
  dunsta_2_V = mkV "dunstar" ; -- dunsta..vb.2
  dunstande_1_N = mkN "dunstande" ; -- dunstande..nn.1
  dunstig_1_A = mkA "dunstig" ; -- dunstig..av.1
  dunstighet_1_N = mkN "dunstighet" ; -- dunstighet..nn.1
  duntäcke_1_N = mkN "duntäcke" ; -- duntäcke..nn.1
  dununge_1_N = mkN "dununge" utrum  ; -- dununge..nn.1
  duo_1_N = mkN "duo" "duor" ; -- duo..nn.1
  duodecimalsystem_1_N = mkN "duodecimalsystem" neutrum  ; -- duodecimalsystem..nn.1
  duodes_1_N = mkN "duodes" "duodeser" ; -- duodes..nn.1
  duodesformat_1_N = mkN "duodesformat" neutrum  ; -- duodesformat..nn.1
  dupera_1_V = mkV "duperar" ; -- dupera..vb.1
  duperande_1_N = mkN "duperande" ; -- duperande..nn.1
  duperbar_1_A = mkA "duperbar" ; -- duperbar..av.1
  duperbarhet_1_N = mkN "duperbarhet" ; -- duperbarhet..nn.1
  dupering_1_N = mkN "dupering" ; -- dupering..nn.1
  duplett_1_N = mkN "duplett" "dupletter" ; -- duplett..nn.1
  duplexfärg_1_N = mkN "duplexfärg" "duplexfärger" ; -- duplexfärg..nn.1
  duplicera_1_V = mkV "duplicerar" ; -- duplicera..vb.1
  duplicerande_1_N = mkN "duplicerande" ; -- duplicerande..nn.1
  duplicerbar_1_A = mkA "duplicerbar" ; -- duplicerbar..av.1
  duplicerbarhet_1_N = mkN "duplicerbarhet" ; -- duplicerbarhet..nn.1
  duplicering_1_N = mkN "duplicering" ; -- duplicering..nn.1
  duplik_1_N = mkN "duplik" "dupliker" ; -- duplik..nn.1
  duplikat_1_N = mkN "duplikat" neutrum  ; -- duplikat..nn.1
  duplikator_1_N = mkN "duplikator" "duplikatorer" ; -- duplikator..nn.1
  dur_1_N = mkN "dur" ; -- dur..nn.1
  durabel_1_A = mkA "durabel" "durabelt" ; -- durabel..av.1
  durackord_1_N = mkN "durackord" neutrum  ; -- durackord..nn.1
  duralexglas_1_N = mkN "duralexglas" neutrum  ; -- duralexglas..nn.1
  duraluminium_1_N = mkN "duraluminium" neutrum  ; -- duraluminium..nn.1
  durativ_1_A = mkA "durativ" ; -- durativ..av.1
  dureform_1_N = mkN "dureform" "dureformer" ; -- dureform..nn.1
  durk_1_N = mkN "durk" ; -- durk..nn.1
  durka_1_V = mkV "durkar" ; -- durka..vb.1
  durkande_1_N = mkN "durkande" ; -- durkande..nn.1
  durkdriven_1_A = mkA "durkdriven" ; -- durkdriven..av.1
  durkmönster_1_N = mkN "durkmönster" neutrum  ; -- durkmönster..nn.1
  durkslag_1_N = mkN "durkslag" neutrum  ; -- durkslag..nn.1
  duroplast_1_N = mkN "duroplast" "duroplaster" ; -- duroplast..nn.1
  durra_1_N = mkN "durra" ; -- durra..nn.1
  durskala_1_N = mkN "durskala" ; -- durskala..nn.1
  durtonart_1_N = mkN "durtonart" "durtonarter" ; -- durtonart..nn.1
  durumvete_1_N = mkN "durumvete" ; -- durumvete..nn.1
  dus_1_N = mkN "dus" "dusen" "dus" "dusen" ; -- dus..nn.1
  dusch_1_N = mkN "dusch" ; -- dusch..nn.1
  duscha_1_V = mkV "duschar" ; -- duscha..vb.1
  duschande_1_N = mkN "duschande" ; -- duschande..nn.1
  duschbrunn_1_N = mkN "duschbrunn" ; -- duschbrunn..nn.1
  duschdraperi_1_N = mkN "duschdraperi" "duschdraperiet" "duschdraperier" "duschdraperierna" ; -- duschdraperi..nn.1
  duschhandduk_1_N = mkN "duschhandduk" ; -- duschhandduk..nn.1
  duschhandtag_1_N = mkN "duschhandtag" neutrum  ; -- duschhandtag..nn.1
  duschkräm_1_N = mkN "duschkräm" "duschkrämer" ; -- duschkräm..nn.1
  duschslang_1_N = mkN "duschslang" ; -- duschslang..nn.1
  duschvana_1_N = mkN "duschvana" ; -- duschvana..nn.1
  duschvägg_1_N = mkN "duschvägg" ; -- duschvägg..nn.1
  dusk_1_N = mkN "dusk" neutrum  ; -- dusk..nn.1
  duska_1_V = mkV "duskar" ; -- duska..vb.1
  duskande_1_N = mkN "duskande" ; -- duskande..nn.1
  duskål_1_N = mkN "duskål" ; -- duskål..nn.1
  dussin_1_N = mkN "dussin" neutrum  ; -- dussin..nn.1
  dussinarbete_1_N = mkN "dussinarbete" ; -- dussinarbete..nn.1
  dussinmänniska_1_N = mkN "dussinmänniska" ; -- dussinmänniska..nn.1
  dussinroman_1_N = mkN "dussinroman" "dussinromaner" ; -- dussinroman..nn.1
  dussintal_1_N = mkN "dussintal" neutrum  ; -- dussintal..nn.1
  dussinvara_1_N = mkN "dussinvara" ; -- dussinvara..nn.1
  dussinvis_1_Adv = mkAdv "dussinvis" ; -- dussinvis..ab.1
  dust_1_N = mkN "dust" "duster" ; -- dust..nn.1
  dusör_1_N = mkN "dusör" "dusörer" ; -- dusör..nn.1
  duva_1_N = mkN "duva" ; -- duva..nn.1
  duva_1_V = mkV "duvar" ; -- duva..vb.1
  duvande_1_N = mkN "duvande" ; -- duvande..nn.1
  duvblå_1_A = mkA "duvblå" "duvblått" ; -- duvblå..av.1
  duven_1_A = mkA "duven" ; -- duven..av.1
  duvenhet_1_N = mkN "duvenhet" ; -- duvenhet..nn.1
  duvfågel_1_N = mkN "duvfågel" ; -- duvfågel..nn.1
  duvhök_1_N = mkN "duvhök" ; -- duvhök..nn.1
  duvjävel_1_N = mkN "duvjävel" ; -- duvjävel..nn.1
  duvkulla_1_N = mkN "duvkulla" ; -- duvkulla..nn.1
  duvna_1_V = mkV "duvnar" ; -- duvna..vb.1
  duvnande_1_N = mkN "duvnande" ; -- duvnande..nn.1
  duvning_1_N = mkN "duvning" ; -- duvning..nn.1
  duvpolitik_1_N = mkN "duvpolitik" ; -- duvpolitik..nn.1
  duvpost_1_N = mkN "duvpost" ; -- duvpost..nn.1
  duvslag_1_N = mkN "duvslag" neutrum  ; -- duvslag..nn.1
  duvunge_1_N = mkN "duvunge" utrum  ; -- duvunge..nn.1
  dvala_1_N = mkN "dvala" ; -- dvala..nn.1
  dvallik_1_A = mkA "dvallik" ; -- dvallik..av.1
  dvd_film_1_N = mkN "dvd-film" "dvd-filmer" ; -- dvd-film..nn.1
  dvd_rom_1_N = mkN "dvd-rom" "dvd-rommen" "dvd-rom" "dvd-rommen" ; -- dvd-rom..nn.1
  dvd_spelare_1_N = mkN "dvd-spelare" utrum  ; -- dvd-spelare..nn.1
  dvärg_1_N = mkN "dvärg" ; -- dvärg..nn.1
  dvärgaktig_1_A = mkA "dvärgaktig" ; -- dvärgaktig..av.1
  dvärgaktighet_1_N = mkN "dvärgaktighet" ; -- dvärgaktighet..nn.1
  dvärgalåt_1_N = mkN "dvärgalåt" ; -- dvärgalåt..nn.1
  dvärgartad_1_A = mkA "dvärgartad" ; -- dvärgartad..av.1
  dvärgbeckasin_1_N = mkN "dvärgbeckasin" "dvärgbeckasiner" ; -- dvärgbeckasin..nn.1
  dvärgbjörk_1_N = mkN "dvärgbjörk" ; -- dvärgbjörk..nn.1
  dvärgbrytare_1_N = mkN "dvärgbrytare" utrum  ; -- dvärgbrytare..nn.1
  dvärgbuske_1_N = mkN "dvärgbuske" utrum  ; -- dvärgbuske..nn.1
  dvärggalax_1_N = mkN "dvärggalax" "dvärggalaxer" ; -- dvärggalax..nn.1
  dvärghamster_1_N = mkN "dvärghamster" ; -- dvärghamster..nn.1
  dvärghund_1_N = mkN "dvärghund" ; -- dvärghund..nn.1
  dvärglik_1_A = mkA "dvärglik" ; -- dvärglik..av.1
  dvärgmås_1_N = mkN "dvärgmås" ; -- dvärgmås..nn.1
  dvärgschimpans_1_N = mkN "dvärgschimpans" "dvärgschimpanser" ; -- dvärgschimpans..nn.1
  dvärgtall_1_N = mkN "dvärgtall" ; -- dvärgtall..nn.1
  dvärgväxt_1_N = mkN "dvärgväxt" ; -- dvärgväxt..nn.1
  dyblad_1_N = mkN "dyblad" neutrum  ; -- dyblad..nn.1
  dyblöt_1_A = mkA "dyblöt" ; -- dyblöt..av.1
  dyblöthet_1_N = mkN "dyblöthet" ; -- dyblöthet..nn.1
  dyborre_1_N = mkN "dyborre" utrum  ; -- dyborre..nn.1
  dybotten_1_N = mkN "dybotten" ; -- dybotten..nn.1
  dyckert_1_N = mkN "dyckert" ; -- dyckert..nn.1
  dygd_1_N = mkN "dygd" "dygder" ; -- dygd..nn.1
  dygdemönster_1_N = mkN "dygdemönster" neutrum  ; -- dygdemönster..nn.1
  dygderik_1_A = mkA "dygderik" ; -- dygderik..av.1
  dygdig_1_A = mkA "dygdig" ; -- dygdig..av.1
  dygdighet_1_N = mkN "dygdighet" ; -- dygdighet..nn.1
  dygn_1_N = mkN "dygn" neutrum  ; -- dygn..nn.1
  dygnetruntöppen_1_A = mkA "dygnetruntöppen" ; -- dygnetruntöppen..av.1
  dygnslång_1_A = mkA "dygnslång" ; -- dygnslång..av.1
  dygnsring_1_N = mkN "dygnsring" ; -- dygnsring..nn.1
  dygnsrytm_1_N = mkN "dygnsrytm" "dygnsrytmer" ; -- dygnsrytm..nn.1
  dygnsvila_1_N = mkN "dygnsvila" ; -- dygnsvila..nn.1
  dygnsvill_1_A = mkA "dygnsvill" ; -- dygnsvill..av.1
  dygnsvillhet_1_N = mkN "dygnsvillhet" ; -- dygnsvillhet..nn.1
  dygnsvis_1_Adv = mkAdv "dygnsvis" ; -- dygnsvis..ab.1
  dygnsvis_1_A = mkA "dygnsvis" ; -- dygnsvis..av.1
  dyig_1_A = mkA "dyig" ; -- dyig..av.1
  dyighet_1_N = mkN "dyighet" ; -- dyighet..nn.1
  dyka_1_V = mkV "dyker" ; -- dyka..vb.1
  dykand_1_N = mkN "dykand" "dykänder" ; -- dykand..nn.1
  dykande_1_N = mkN "dykande" ; -- dykande..nn.1
  dykarbagge_1_N = mkN "dykarbagge" utrum  ; -- dykarbagge..nn.1
  dykardräkt_1_N = mkN "dykardräkt" "dykardräkter" ; -- dykardräkt..nn.1
  dykare_1_N = mkN "dykare" utrum  ; -- dykare..nn.1
  dykarklocka_1_N = mkN "dykarklocka" ; -- dykarklocka..nn.1
  dykarsjuka_1_N = mkN "dykarsjuka" ; -- dykarsjuka..nn.1
  dykarutrustning_1_N = mkN "dykarutrustning" ; -- dykarutrustning..nn.1
  dykdalb_1_N = mkN "dykdalb" "dykdalber" ; -- dykdalb..nn.1
  dykeri_1_N = mkN "dykeri" neutrum  ; -- dykeri..nn.1
  dykning_1_N = mkN "dykning" ; -- dykning..nn.1
  dykningsolycka_1_N = mkN "dykningsolycka" ; -- dykningsolycka..nn.1
  dykolycka_1_N = mkN "dykolycka" ; -- dykolycka..nn.1
  dymling_1_N = mkN "dymling" ; -- dymling..nn.1
  dymlingförband_1_N = mkN "dymlingförband" neutrum  ; -- dymlingförband..nn.1
  dymmelonsdag_1_N = mkN "dymmelonsdag" ; -- dymmelonsdag..nn.1
  dymmelvecka_1_N = mkN "dymmelvecka" ; -- dymmelvecka..nn.1
  dyn_1_N = mkN "dyn" "dyner" ; -- dyn..nn.1
  dyn_2_N = mkN "dyn" neutrum  ; -- dyn..nn.2
  dyna_1_N = mkN "dyna" ; -- dyna..nn.1
  dynamik_1_N = mkN "dynamik" ; -- dynamik..nn.1
  dynamisk_1_A = mkA "dynamisk" ; -- dynamisk..av.1
  dynamism_1_N = mkN "dynamism" "dynamismer" ; -- dynamism..nn.1
  dynamistisk_1_A = mkA "dynamistisk" ; -- dynamistisk..av.1
  dynamit_1_N = mkN "dynamit" ; -- dynamit..nn.1
  dynamitard_1_N = mkN "dynamitard" "dynamitarder" ; -- dynamitard..nn.1
  dynamitgubbe_1_N = mkN "dynamitgubbe" utrum  ; -- dynamitgubbe..nn.1
  dynamo_1_N = mkN "dynamo" "dynamor" ; -- dynamo..nn.1
  dynamometer_1_N = mkN "dynamometer" ; -- dynamometer..nn.1
  dynasti_1_N = mkN "dynasti" "dynastier" ; -- dynasti..nn.1
  dynastigrundare_1_N = mkN "dynastigrundare" utrum  ; -- dynastigrundare..nn.1
  dynastisk_1_A = mkA "dynastisk" ; -- dynastisk..av.1
  dynga_1_N = mkN "dynga" ; -- dynga..nn.1
  dyngbagge_1_N = mkN "dyngbagge" utrum  ; -- dyngbagge..nn.1
  dyngfluga_1_N = mkN "dyngfluga" ; -- dyngfluga..nn.1
  dyngfull_1_A = mkA "dyngfull" ; -- dyngfull..av.1
  dynggrep_1_N = mkN "dynggrep" ; -- dynggrep..nn.1
  dyngig_1_A = mkA "dyngig" ; -- dyngig..av.1
  dyngrak_1_A = mkA "dyngrak" ; -- dyngrak..av.1
  dyngspridare_1_N = mkN "dyngspridare" utrum  ; -- dyngspridare..nn.1
  dyngsur_1_A = mkA "dyngsur" ; -- dyngsur..av.1
  dyngsurhet_1_N = mkN "dyngsurhet" ; -- dyngsurhet..nn.1
  dyning_1_N = mkN "dyning" ; -- dyning..nn.1
  dynlandskap_1_N = mkN "dynlandskap" neutrum  ; -- dynlandskap..nn.1
  dynt_1_N = mkN "dynt" ; -- dynt..nn.1
  dypöl_1_N = mkN "dypöl" ; -- dypöl..nn.1
  dyr_1_A = mkA "dyr" ; -- dyr..av.1
  dyrbar_1_A = mkA "dyrbar" ; -- dyrbar..av.1
  dyrbarhet_1_N = mkN "dyrbarhet" "dyrbarheter" ; -- dyrbarhet..nn.1
  dyrgrip_1_N = mkN "dyrgrip" ; -- dyrgrip..nn.1
  dyrhet_1_N = mkN "dyrhet" ; -- dyrhet..nn.1
  dyrk_1_N = mkN "dyrk" ; -- dyrk..nn.1
  dyrka_1_V = mkV "dyrkar" ; -- dyrka..vb.1
  dyrkande_1_N = mkN "dyrkande" ; -- dyrkande..nn.1
  dyrkansvärd_1_A = mkA "dyrkansvärd" "dyrkansvärt" ; -- dyrkansvärd..av.1
  dyrkansvärdhet_1_N = mkN "dyrkansvärdhet" ; -- dyrkansvärdhet..nn.1
  dyrkare_1_N = mkN "dyrkare" utrum  ; -- dyrkare..nn.1
  dyrkfri_1_A = mkA "dyrkfri" "dyrkfritt" ; -- dyrkfri..av.1
  dyrköpt_1_A = mkA "dyrköpt" "dyrköpt" ; -- dyrköpt..av.1
  dyrköpthet_1_N = mkN "dyrköpthet" ; -- dyrköpthet..nn.1
  dyrort_1_N = mkN "dyrort" "dyrorter" ; -- dyrort..nn.1
  dyrortsgrupp_1_N = mkN "dyrortsgrupp" "dyrortsgrupper" ; -- dyrortsgrupp..nn.1
  dyrortsgruppering_1_N = mkN "dyrortsgruppering" ; -- dyrortsgruppering..nn.1
  dyrtid_1_N = mkN "dyrtid" "dyrtider" ; -- dyrtid..nn.1
  dyrtidstillägg_1_N = mkN "dyrtidstillägg" neutrum  ; -- dyrtidstillägg..nn.1
  dys_1_N = mkN "dys" "dyser" ; -- dys..nn.1
  dysa_1_N = mkN "dysa" ; -- dysa..nn.1
  dyscha_1_N = mkN "dyscha" ; -- dyscha..nn.1
  dyschatell_1_N = mkN "dyschatell" "dyschateller" ; -- dyschatell..nn.1
  dysenteri_1_N = mkN "dysenteri" "dysenterier" ; -- dysenteri..nn.1
  dysergi_1_N = mkN "dysergi" "dysergier" ; -- dysergi..nn.1
  dysfori_1_N = mkN "dysfori" "dysforier" ; -- dysfori..nn.1
  dysfunktionell_1_A = mkA "dysfunktionell" ; -- dysfunktionell..av.1
  dyslektiker_1_N = mkN "dyslektiker" "dyslektikern" "dyslektiker" "dyslektikerna" ; -- dyslektiker..nn.1
  dyslektisk_1_A = mkA "dyslektisk" ; -- dyslektisk..av.1
  dyslexi_1_N = mkN "dyslexi" "dyslexier" ; -- dyslexi..nn.1
  dyslexiker_1_N = mkN "dyslexiker" "dyslexikern" "dyslexiker" "dyslexikerna" ; -- dyslexiker..nn.1
  dyslexisk_1_A = mkA "dyslexisk" ; -- dyslexisk..av.1
  dyspepsi_1_N = mkN "dyspepsi" "dyspepsier" ; -- dyspepsi..nn.1
  dysprosium_1_N = mkN "dysprosium" neutrum  ; -- dysprosium..nn.1
  dyster_1_A = mkA "dyster" ; -- dyster..av.1
  dysterhet_1_N = mkN "dysterhet" "dysterheter" ; -- dysterhet..nn.1
  dysterkvist_1_N = mkN "dysterkvist" ; -- dysterkvist..nn.1
  dystopi_1_N = mkN "dystopi" "dystopier" ; -- dystopi..nn.1
  dystopisk_1_A = mkA "dystopisk" ; -- dystopisk..av.1
  dystopiskhet_1_N = mkN "dystopiskhet" ; -- dystopiskhet..nn.1
  dystrof_1_A = mkA "dystrof" ; -- dystrof..av.1
  dystrofi_1_N = mkN "dystrofi" "dystrofier" ; -- dystrofi..nn.1
  dyvelsträck_1_N = mkN "dyvelsträck" ; -- dyvelsträck..nn.1
  dyvik_1_N = mkN "dyvik" ; -- dyvik..nn.1
  dyvik_2_1_N = mkN "dyvik" ; -- dyvik_2..nn.1
  dyvika_1_N = mkN "dyvika" ; -- dyvika..nn.1
  dyvikare_1_N = mkN "dyvikare" utrum  ; -- dyvikare..nn.1
  dyvåt_1_A = mkA "dyvåt" ; -- dyvåt..av.1
  däck_1_N = mkN "däck" neutrum  ; -- däck..nn.1
  däck_2_N = mkN "däck" neutrum  ; -- däck..nn.2
  däcka_1_V = mkV "däckar" ; -- däcka..vb.1
  däckad_1_A = mkA "däckad" ; -- däckad..av.1
  däckande_1_N = mkN "däckande" ; -- däckande..nn.1
  däckavtagning_1_N = mkN "däckavtagning" ; -- däckavtagning..nn.1
  däckbytarhelg_1_N = mkN "däckbytarhelg" "däckbytarhelger" ; -- däckbytarhelg..nn.1
  däckbyte_1_N = mkN "däckbyte" ; -- däckbyte..nn.1
  däckdimension_1_N = mkN "däckdimension" ; -- däckdimension..nn.1
  däckel_1_N = mkN "däckel" ; -- däckel..nn.1
  däcker_1_N = mkN "däcker" neutrum  ; -- däcker..nn.1
  däckglans_1_N = mkN "däckglans" ; -- däckglans..nn.1
  däckhotell_1_N = mkN "däckhotell" neutrum  ; -- däckhotell..nn.1
  däckhållare_1_N = mkN "däckhållare" utrum  ; -- däckhållare..nn.1
  däckjärn_1_N = mkN "däckjärn" neutrum  ; -- däckjärn..nn.1
  däckmärkning_1_N = mkN "däckmärkning" ; -- däckmärkning..nn.1
  däckmärkningsklämma_1_N = mkN "däckmärkningsklämma" ; -- däckmärkningsklämma..nn.1
  däckpåse_1_N = mkN "däckpåse" utrum  ; -- däckpåse..nn.1
  däcksbalk_1_N = mkN "däcksbalk" ; -- däcksbalk..nn.1
  däckslast_1_N = mkN "däckslast" "däckslaster" ; -- däckslast..nn.1
  däcksmanskap_1_N = mkN "däcksmanskap" neutrum  ; -- däcksmanskap..nn.1
  däckspassagerare_1_N = mkN "däckspassagerare" utrum  ; -- däckspassagerare..nn.1
  däcksplanka_1_N = mkN "däcksplanka" ; -- däcksplanka..nn.1
  däckventil_1_N = mkN "däckventil" "däckventiler" ; -- däckventil..nn.1
  däckverkstad_1_N = mkN "däckverkstad" "däckverkstäder" ; -- däckverkstad..nn.1
  dägga_1_V = mkV "däggar" ; -- dägga..vb.1
  däggande_1_N = mkN "däggande" ; -- däggande..nn.1
  däggdjur_1_N = mkN "däggdjur" neutrum  ; -- däggdjur..nn.1
  däggdjursgrupp_1_N = mkN "däggdjursgrupp" "däggdjursgrupper" ; -- däggdjursgrupp..nn.1
  däggdjurstand_1_N = mkN "däggdjurstand" "däggdjurständer" ; -- däggdjurstand..nn.1
  däggdjurstyp_1_N = mkN "däggdjurstyp" "däggdjurstyper" ; -- däggdjurstyp..nn.1
  däggdjursunge_1_N = mkN "däggdjursunge" utrum  ; -- däggdjursunge..nn.1
  däld_1_N = mkN "däld" "dälder" ; -- däld..nn.1
  dämma_1_V = mkV "dämmer" ; -- dämma..vb.1
  dämmande_1_N = mkN "dämmande" ; -- dämmande..nn.1
  dämmare_1_N = mkN "dämmare" utrum  ; -- dämmare..nn.1
  dämme_1_N = mkN "dämme" ; -- dämme..nn.1
  dämning_1_N = mkN "dämning" ; -- dämning..nn.1
  dämpa_1_V = mkV "dämpar" ; -- dämpa..vb.1
  dämpad_1_A = mkA "dämpad" ; -- dämpad..av.1
  dämpande_1_N = mkN "dämpande" ; -- dämpande..nn.1
  dämpare_1_N = mkN "dämpare" utrum  ; -- dämpare..nn.1
  dämpbox_1_N = mkN "dämpbox" ; -- dämpbox..nn.1
  dämpning_1_N = mkN "dämpning" ; -- dämpning..nn.1
  däng_1_N = mkN "däng" neutrum  ; -- däng..nn.1
  dänga_1_V = mkV "dänger" ; -- dänga..vb.1
  dängande_1_N = mkN "dängande" ; -- dängande..nn.1
  dänka_1_V = mkV "dänker" ; -- dänka..vb.1
  dänkande_1_N = mkN "dänkande" ; -- dänkande..nn.1
  därav_1_Adv = mkAdv "därav" ; -- därav..ab.1
  därbakom_1_Adv = mkAdv "därbakom" ; -- därbakom..ab.1
  därborta_1_Adv = mkAdv "därborta" ; -- därborta..ab.1
  därbortom_1_Adv = mkAdv "därbortom" ; -- därbortom..ab.1
  därefter_1_Adv = mkAdv "därefter" ; -- därefter..ab.1
  däremellan_1_Adv = mkAdv "däremellan" ; -- däremellan..ab.1
  däremot_1_Adv = mkAdv "däremot" ; -- däremot..ab.1
  därframme_1_Adv = mkAdv "därframme" ; -- därframme..ab.1
  därför_1_Adv = mkAdv "därför" ; -- därför..ab.1
  därföre_1_Adv = mkAdv "därföre" ; -- därföre..ab.1
  därhän_1_Adv = mkAdv "därhän" ; -- därhän..ab.1
  däri_1_Adv = mkAdv "däri" ; -- däri..ab.1
  däribland_1_Adv = mkAdv "däribland" ; -- däribland..ab.1
  därifrån_1_Adv = mkAdv "därifrån" ; -- därifrån..ab.1
  därigenom_1_Adv = mkAdv "därigenom" ; -- därigenom..ab.1
  därinifrån_1_Adv = mkAdv "därinifrån" ; -- därinifrån..ab.1
  därinnanför_1_Adv = mkAdv "därinnanför" ; -- därinnanför..ab.1
  därinne_1_Adv = mkAdv "därinne" ; -- därinne..ab.1
  därjämte_1_Adv = mkAdv "därjämte" ; -- därjämte..ab.1
  därmed_1_Adv = mkAdv "därmed" ; -- därmed..ab.1
  därnedanför_1_Adv = mkAdv "därnedanför" ; -- därnedanför..ab.1
  därnere_1_Adv = mkAdv "därnere" ; -- därnere..ab.1
  därnäst_1_Adv = mkAdv "därnäst" ; -- därnäst..ab.1
  därom_1_Adv = mkAdv "därom" ; -- därom..ab.1
  däromkring_1_Adv = mkAdv "däromkring" ; -- däromkring..ab.1
  däroppe_1_Adv = mkAdv "däroppe" ; -- däroppe..ab.1
  därovanför_1_Adv = mkAdv "därovanför" ; -- därovanför..ab.1
  därproducerad_1_A = mkA "därproducerad" ; -- därproducerad..av.1
  därpå_1_Adv = mkAdv "därpå" ; -- därpå..ab.1
  därstädes_1_Adv = mkAdv "därstädes" ; -- därstädes..ab.1
  därtappad_1_A = mkA "därtappad" ; -- därtappad..av.1
  därtill_1_Adv = mkAdv "därtill" ; -- därtill..ab.1
  därunder_1_Adv = mkAdv "därunder" ; -- därunder..ab.1
  däruppe_1_Adv = mkAdv "däruppe" ; -- däruppe..ab.1
  däruppifrån_1_Adv = mkAdv "däruppifrån" ; -- däruppifrån..ab.1
  därur_1_Adv = mkAdv "därur" ; -- därur..ab.1
  därutanför_1_Adv = mkAdv "därutanför" ; -- därutanför..ab.1
  därutav_1_Adv = mkAdv "därutav" ; -- därutav..ab.1
  därute_1_Adv = mkAdv "därute" ; -- därute..ab.1
  därutinnan_1_Adv = mkAdv "därutinnan" ; -- därutinnan..ab.1
  därutur_1_Adv = mkAdv "därutur" ; -- därutur..ab.1
  därutöver_1_Adv = mkAdv "därutöver" ; -- därutöver..ab.1
  därvarande_1_A = mkA "därvarande" ; -- därvarande..av.1
  därvid_1_Adv = mkAdv "därvid" ; -- därvid..ab.1
  därvidlag_1_Adv = mkAdv "därvidlag" ; -- därvidlag..ab.1
  däråt_1_Adv = mkAdv "däråt" ; -- däråt..ab.1
  däröver_1_Adv = mkAdv "däröver" ; -- däröver..ab.1
  däst_1_A = mkA "däst" "däst" ; -- däst..av.1
  dästhet_1_N = mkN "dästhet" ; -- dästhet..nn.1
  däven_1_A = mkA "däven" ; -- däven..av.1
  dävenhet_1_N = mkN "dävenhet" ; -- dävenhet..nn.1
  dävert_1_N = mkN "dävert" ; -- dävert..nn.1
  dävna_1_V = mkV "dävnar" ; -- dävna..vb.1
  dävnande_1_N = mkN "dävnande" ; -- dävnande..nn.1
  däxel_1_N = mkN "däxel" ; -- däxel..nn.1
  då_2_Adv = mkAdv "då" ; -- då..ab.2
  dåd_1_N = mkN "dåd" neutrum  ; -- dåd..nn.1
  dådkraft_1_N = mkN "dådkraft" ; -- dådkraft..nn.1
  dådkraftig_1_A = mkA "dådkraftig" ; -- dådkraftig..av.1
  dådlös_1_A = mkA "dådlös" ; -- dådlös..av.1
  dådlöshet_1_N = mkN "dådlöshet" ; -- dådlöshet..nn.1
  dådra_1_N = mkN "dådra" ; -- dådra..nn.1
  dådrafrö_1_N = mkN "dådrafrö" "dådrafröt" "dådrafrön" "dådrafröen" ; -- dådrafrö..nn.1
  dålig_1_A = mkA "dålig" ; -- dålig..av.1
  dålighet_1_N = mkN "dålighet" "dåligheter" ; -- dålighet..nn.1
  dån_1_N = mkN "dån" neutrum  ; -- dån..nn.1
  dån_2_N = mkN "dån" ; -- dån..nn.2
  dåna_1_V = mkV "dånar" ; -- dåna..vb.1
  dåna_2_V = mkV "dånar" ; -- dåna..vb.2
  dånande_1_N = mkN "dånande" ; -- dånande..nn.1
  dåning_1_N = mkN "dåning" ; -- dåning..nn.1
  dåra_1_V = mkV "dårar" ; -- dåra..vb.1
  dåraktig_1_A = mkA "dåraktig" ; -- dåraktig..av.1
  dåraktighet_1_N = mkN "dåraktighet" "dåraktigheter" ; -- dåraktighet..nn.1
  dårande_1_N = mkN "dårande" ; -- dårande..nn.1
  dårdoktor_1_N = mkN "dårdoktor" "dårdoktorer" ; -- dårdoktor..nn.1
  dåre_1_N = mkN "dåre" utrum  ; -- dåre..nn.1
  dårfink_1_N = mkN "dårfink" ; -- dårfink..nn.1
  dårhus_1_N = mkN "dårhus" neutrum  ; -- dårhus..nn.1
  dårhusmässig_1_A = mkA "dårhusmässig" ; -- dårhusmässig..av.1
  dårskap_1_N = mkN "dårskap" "dårskaper" ; -- dårskap..nn.1
  dås_1_N = mkN "dås" neutrum  ; -- dås..nn.1
  dåsa_1_V = mkV "dåsar" ; -- dåsa..vb.1
  dåsande_1_N = mkN "dåsande" ; -- dåsande..nn.1
  dåsig_1_A = mkA "dåsig" ; -- dåsig..av.1
  dåsighet_1_N = mkN "dåsighet" "dåsigheter" ; -- dåsighet..nn.1
  dåtid_1_N = mkN "dåtid" ; -- dåtid..nn.1
  dåtida_1_A = mkA "dåtida" ; -- dåtida..av.1
  dåvarande_1_A = mkA "dåvarande" ; -- dåvarande..av.1
  détente_1_N = mkN "détente" utrum  ; -- détente..nn.1
  dö_1_V = mkV "dö" "dog" "dött" ; -- dö..vb.1
  döbattang_1_N = mkN "döbattang" "döbattanger" ; -- döbattang..nn.1
  döblek_1_A = mkA "döblek" ; -- döblek..av.1
  döblekhet_1_N = mkN "döblekhet" ; -- döblekhet..nn.1
  död_1_A = mkA "död" "dött" ; -- död..av.1
  död_1_N = mkN "död" ; -- död..nn.1
  döda_1_V = mkV "dödar" ; -- döda..vb.1
  dödande_1_A = mkA "dödande" ; -- dödande..av.1
  dödande_1_N = mkN "dödande" ; -- dödande..nn.1
  dödbakad_1_A = mkA "dödbakad" ; -- dödbakad..av.1
  dödbränd_1_A = mkA "dödbränd" ; -- dödbränd..av.1
  döddansare_1_N = mkN "döddansare" utrum  ; -- döddansare..nn.1
  dödfull_1_A = mkA "dödfull" ; -- dödfull..av.1
  dödfödd_1_A = mkA "dödfödd" ; -- dödfödd..av.1
  dödförklara_1_V = mkV "dödförklarar" ; -- dödförklara..vb.1
  dödförklarande_1_N = mkN "dödförklarande" ; -- dödförklarande..nn.1
  dödgrävare_1_N = mkN "dödgrävare" utrum  ; -- dödgrävare..nn.1
  dödhet_1_N = mkN "dödhet" ; -- dödhet..nn.1
  döding_1_N = mkN "döding" ; -- döding..nn.1
  dödis_1_N = mkN "dödis" ; -- dödis..nn.1
  dödkött_1_N = mkN "dödkött" neutrum  ; -- dödkött..nn.1
  dödlig_1_A = mkA "dödlig" ; -- dödlig..av.1
  dödlighet_1_N = mkN "dödlighet" "dödligheter" ; -- dödlighet..nn.1
  dödlighet_2_N = mkN "dödlighet" ; -- dödlighet..nn.2
  dödlighetsprocent_1_N = mkN "dödlighetsprocent" ; -- dödlighetsprocent..nn.1
  dödläge_1_N = mkN "dödläge" ; -- dödläge..nn.1
  dödmansgrepp_1_N = mkN "dödmansgrepp" neutrum  ; -- dödmansgrepp..nn.1
  dödperiod_1_N = mkN "dödperiod" "dödperioder" ; -- dödperiod..nn.1
  dödsannons_1_N = mkN "dödsannons" "dödsannonser" ; -- dödsannons..nn.1
  dödsattest_1_N = mkN "dödsattest" "dödsattester" ; -- dödsattest..nn.1
  dödsbakterie_1_N = mkN "dödsbakterie" "dödsbakterier" ; -- dödsbakterie..nn.1
  dödsbevis_1_N = mkN "dödsbevis" neutrum  ; -- dödsbevis..nn.1
  dödsblek_1_A = mkA "dödsblek" ; -- dödsblek..av.1
  dödsblekhet_1_N = mkN "dödsblekhet" ; -- dödsblekhet..nn.1
  dödsbo_1_N = mkN "dödsbo" "dödsboet" "dödsbon" "dödsbona" ; -- dödsbo..nn.1
  dödsbringande_1_A = mkA "dödsbringande" ; -- dödsbringande..av.1
  dödsbud_1_N = mkN "dödsbud" neutrum  ; -- dödsbud..nn.1
  dödsbädd_1_N = mkN "dödsbädd" ; -- dödsbädd..nn.1
  dödscell_1_N = mkN "dödscell" "dödsceller" ; -- dödscell..nn.1
  dödsdag_1_N = mkN "dödsdag" ; -- dödsdag..nn.1
  dödsdans_1_N = mkN "dödsdans" "dödsdanser" ; -- dödsdans..nn.1
  dödsdom_1_N = mkN "dödsdom" ; -- dödsdom..nn.1
  dödsdömd_1_A = mkA "dödsdömd" "dödsdömt" ; -- dödsdömd..av.1
  dödsfall_1_N = mkN "dödsfall" neutrum  ; -- dödsfall..nn.1
  dödsfara_1_N = mkN "dödsfara" ; -- dödsfara..nn.1
  dödsfas_1_N = mkN "dödsfas" "dödsfaser" ; -- dödsfas..nn.1
  dödsfiende_1_N = mkN "dödsfiende" "dödsfiender" ; -- dödsfiende..nn.1
  dödsflygning_1_N = mkN "dödsflygning" ; -- dödsflygning..nn.1
  dödsfälla_1_N = mkN "dödsfälla" ; -- dödsfälla..nn.1
  dödsförakt_1_N = mkN "dödsförakt" neutrum  ; -- dödsförakt..nn.1
  dödsföraktande_1_A = mkA "dödsföraktande" ; -- dödsföraktande..av.1
  dödsförbannad_1_A = mkA "dödsförbannad" ; -- dödsförbannad..av.1
  dödsförskräckt_1_A = mkA "dödsförskräckt" "dödsförskräckt" ; -- dödsförskräckt..av.1
  dödshjälp_1_N = mkN "dödshjälp" ; -- dödshjälp..nn.1
  dödshjälpsdebatt_1_N = mkN "dödshjälpsdebatt" "dödshjälpsdebatter" ; -- dödshjälpsdebatt..nn.1
  dödshot_1_N = mkN "dödshot" neutrum  ; -- dödshot..nn.1
  dödsjö_1_N = mkN "dödsjö" ; -- dödsjö..nn.1
  dödskalle_1_N = mkN "dödskalle" utrum  ; -- dödskalle..nn.1
  dödskallefjäril_1_N = mkN "dödskallefjäril" ; -- dödskallefjäril..nn.1
  dödskallefynd_1_N = mkN "dödskallefynd" neutrum  ; -- dödskallefynd..nn.1
  dödskamp_1_N = mkN "dödskamp" "dödskamper" ; -- dödskamp..nn.1
  dödsklinik_1_N = mkN "dödsklinik" "dödskliniker" ; -- dödsklinik..nn.1
  dödskrasch_1_N = mkN "dödskrasch" "dödskrascher" ; -- dödskrasch..nn.1
  dödskval_1_N = mkN "dödskval" neutrum  ; -- dödskval..nn.1
  dödskyla_1_N = mkN "dödskyla" ; -- dödskyla..nn.1
  dödslista_1_N = mkN "dödslista" ; -- dödslista..nn.1
  dödsmarsch_1_N = mkN "dödsmarsch" "dödsmarscher" ; -- dödsmarsch..nn.1
  dödsmask_1_N = mkN "dödsmask" "dödsmasker" ; -- dödsmask..nn.1
  dödsmetal_1_N = mkN "dödsmetal" ; -- dödsmetal..nn.1
  dödsmetall_1_N = mkN "dödsmetall" ; -- dödsmetall..nn.1
  dödsminut_1_N = mkN "dödsminut" "dödsminuter" ; -- dödsminut..nn.1
  dödsmisshandel_1_N = mkN "dödsmisshandel" ; -- dödsmisshandel..nn.1
  dödsmärkt_1_A = mkA "dödsmärkt" "dödsmärkt" ; -- dödsmärkt..av.1
  dödsoffer_1_N = mkN "dödsoffer" neutrum  ; -- dödsoffer..nn.1
  dödsolycka_1_N = mkN "dödsolycka" ; -- dödsolycka..nn.1
  dödsorsak_1_N = mkN "dödsorsak" "dödsorsaker" ; -- dödsorsak..nn.1
  dödsorsaksregister_1_N = mkN "dödsorsaksregister" neutrum  ; -- dödsorsaksregister..nn.1
  dödspatrull_1_N = mkN "dödspatrull" "dödspatruller" ; -- dödspatrull..nn.1
  dödsrike_1_N = mkN "dödsrike" ; -- dödsrike..nn.1
  dödsringning_1_N = mkN "dödsringning" ; -- dödsringning..nn.1
  dödsrossling_1_N = mkN "dödsrossling" ; -- dödsrossling..nn.1
  dödsruna_1_N = mkN "dödsruna" ; -- dödsruna..nn.1
  dödsryckning_1_N = mkN "dödsryckning" ; -- dödsryckning..nn.1
  dödssiffra_1_N = mkN "dödssiffra" ; -- dödssiffra..nn.1
  dödssjuk_1_A = mkA "dödssjuk" ; -- dödssjuk..av.1
  dödssjukhet_1_N = mkN "dödssjukhet" ; -- dödssjukhet..nn.1
  dödsskjuta_1_V = mkV "dödsskjuta" "dödssköt" "dödsskjutit" ; -- dödsskjuta..vb.1
  dödsskjutande_1_N = mkN "dödsskjutande" ; -- dödsskjutande..nn.1
  dödsskjuten_1_A = mkA "dödsskjuten" ; -- dödsskjuten..av.1
  dödsskjutning_1_N = mkN "dödsskjutning" ; -- dödsskjutning..nn.1
  dödsskott_1_N = mkN "dödsskott" neutrum  ; -- dödsskott..nn.1
  dödsskugga_1_N = mkN "dödsskugga" ; -- dödsskugga..nn.1
  dödsskvadron_1_N = mkN "dödsskvadron" "dödsskvadroner" ; -- dödsskvadron..nn.1
  dödsstelhet_1_N = mkN "dödsstelhet" "dödsstelheter" ; -- dödsstelhet..nn.1
  dödsstilla_1_A = mkA "dödsstilla" ; -- dödsstilla..av.1
  dödsstillhet_1_N = mkN "dödsstillhet" ; -- dödsstillhet..nn.1
  dödsstjärna_1_N = mkN "dödsstjärna" ; -- dödsstjärna..nn.1
  dödsstraff_1_N = mkN "dödsstraff" neutrum  ; -- dödsstraff..nn.1
  dödsstraffsanhängare_1_N = mkN "dödsstraffsanhängare" utrum  ; -- dödsstraffsanhängare..nn.1
  dödsstund_1_N = mkN "dödsstund" "dödsstunder" ; -- dödsstund..nn.1
  dödsstörta_1_V = mkV "dödsstörtar" ; -- dödsstörta..vb.1
  dödsstörtande_1_N = mkN "dödsstörtande" ; -- dödsstörtande..nn.1
  dödsstörtning_1_N = mkN "dödsstörtning" ; -- dödsstörtning..nn.1
  dödsstöt_1_N = mkN "dödsstöt" ; -- dödsstöt..nn.1
  dödssynd_1_N = mkN "dödssynd" "dödssynder" ; -- dödssynd..nn.1
  dödssätt_1_N = mkN "dödssätt" neutrum  ; -- dödssätt..nn.1
  dödssömn_1_N = mkN "dödssömn" ; -- dödssömn..nn.1
  dödstal_1_N = mkN "dödstal" neutrum  ; -- dödstal..nn.1
  dödstillfälle_1_N = mkN "dödstillfälle" ; -- dödstillfälle..nn.1
  dödstimme_1_N = mkN "dödstimme" utrum  ; -- dödstimme..nn.1
  dödstråkig_1_A = mkA "dödstråkig" ; -- dödstråkig..av.1
  dödstråkighet_1_N = mkN "dödstråkighet" ; -- dödstråkighet..nn.1
  dödstrött_1_A = mkA "dödstrött" ; -- dödstrött..av.1
  dödströtthet_1_N = mkN "dödströtthet" ; -- dödströtthet..nn.1
  dödstyst_1_A = mkA "dödstyst" "dödstyst" ; -- dödstyst..av.1
  dödstystnad_1_N = mkN "dödstystnad" "dödstystnader" ; -- dödstystnad..nn.1
  dödsur_1_N = mkN "dödsur" neutrum  ; -- dödsur..nn.1
  dödsvånda_1_N = mkN "dödsvånda" ; -- dödsvånda..nn.1
  dödsängel_1_N = mkN "dödsängel" ; -- dödsängel..nn.1
  dödsångest_1_N = mkN "dödsångest" ; -- dödsångest..nn.1
  dödsår_1_N = mkN "dödsår" neutrum  ; -- dödsår..nn.1
  dödtid_1_N = mkN "dödtid" ; -- dödtid..nn.1
  dödvikt_1_N = mkN "dödvikt" ; -- dödvikt..nn.1
  döende_1_A = mkA "döende" ; -- döende..av.1
  döende_1_N = mkN "döende" ; -- döende..nn.1
  döfull_1_A = mkA "döfull" ; -- döfull..av.1
  döförbannad_1_A = mkA "döförbannad" ; -- döförbannad..av.1
  döförskräckt_1_A = mkA "döförskräckt" "döförskräckt" ; -- döförskräckt..av.1
  dögling_1_N = mkN "dögling" ; -- dögling..nn.1
  döing_1_N = mkN "döing" ; -- döing..nn.1
  dölja_1_V = mkV "dölja" "dolde" "dolt" ; -- dölja..vb.1
  döljande_1_N = mkN "döljande" ; -- döljande..nn.1
  döma_1_V = mkV "dömer" ; -- döma..vb.1
  dömande_1_N = mkN "dömande" ; -- dömande..nn.1
  dön_1_N = mkN "dön" neutrum  ; -- dön..nn.1
  döna_1_V = mkV "dönar" ; -- döna..vb.1
  dönande_1_N = mkN "dönande" ; -- dönande..nn.1
  döpa_1_V = mkV "döper" ; -- döpa..vb.1
  döpande_1_N = mkN "döpande" ; -- döpande..nn.1
  döpare_1_N = mkN "döpare" utrum  ; -- döpare..nn.1
  döpelse_1_N = mkN "döpelse" utrum  ; -- döpelse..nn.1
  dörj_1_N = mkN "dörj" ; -- dörj..nn.1
  dörja_1_V = mkV "dörjar" ; -- dörja..vb.1
  dörjande_1_N = mkN "dörjande" ; -- dörjande..nn.1
  dörr_1_N = mkN "dörr" ; -- dörr..nn.1
  dörrblad_1_N = mkN "dörrblad" neutrum  ; -- dörrblad..nn.1
  dörrfärg_1_N = mkN "dörrfärg" "dörrfärger" ; -- dörrfärg..nn.1
  dörrförhänge_1_N = mkN "dörrförhänge" ; -- dörrförhänge..nn.1
  dörrförsäljare_1_N = mkN "dörrförsäljare" utrum  ; -- dörrförsäljare..nn.1
  dörrhake_1_N = mkN "dörrhake" utrum  ; -- dörrhake..nn.1
  dörrhandtag_1_N = mkN "dörrhandtag" neutrum  ; -- dörrhandtag..nn.1
  dörrkarm_1_N = mkN "dörrkarm" ; -- dörrkarm..nn.1
  dörrkedja_1_N = mkN "dörrkedja" ; -- dörrkedja..nn.1
  dörrklinka_1_N = mkN "dörrklinka" ; -- dörrklinka..nn.1
  dörrklocka_1_N = mkN "dörrklocka" ; -- dörrklocka..nn.1
  dörrknackare_1_N = mkN "dörrknackare" utrum  ; -- dörrknackare..nn.1
  dörrknackning_1_N = mkN "dörrknackning" ; -- dörrknackning..nn.1
  dörrknackningskampanj_1_N = mkN "dörrknackningskampanj" "dörrknackningskampanjer" ; -- dörrknackningskampanj..nn.1
  dörrknackningsoperation_1_N = mkN "dörrknackningsoperation" ; -- dörrknackningsoperation..nn.1
  dörrkrans_1_N = mkN "dörrkrans" ; -- dörrkrans..nn.1
  dörrlås_1_N = mkN "dörrlås" neutrum  ; -- dörrlås..nn.1
  dörrmatta_1_N = mkN "dörrmatta" ; -- dörrmatta..nn.1
  dörrnyckel_1_N = mkN "dörrnyckel" ; -- dörrnyckel..nn.1
  dörrpost_1_N = mkN "dörrpost" "dörrposter" ; -- dörrpost..nn.1
  dörrspegel_1_N = mkN "dörrspegel" ; -- dörrspegel..nn.1
  dörrstolpe_1_N = mkN "dörrstolpe" utrum  ; -- dörrstolpe..nn.1
  dörrstängare_1_N = mkN "dörrstängare" utrum  ; -- dörrstängare..nn.1
  dörrvakt_1_N = mkN "dörrvakt" "dörrvakter" ; -- dörrvakt..nn.1
  dörrvaktare_1_N = mkN "dörrvaktare" utrum  ; -- dörrvaktare..nn.1
  dörrvred_1_N = mkN "dörrvred" neutrum  ; -- dörrvred..nn.1
  dörröga_1_N = mkN "dörröga" "dörrögat" "dörrögon" "dörrögonen" ; -- dörröga..nn.1
  dörröppnare_1_N = mkN "dörröppnare" utrum  ; -- dörröppnare..nn.1
  dörröppning_1_N = mkN "dörröppning" ; -- dörröppning..nn.1
  dös_1_N = mkN "dös" ; -- dös..nn.1
  dösjuk_1_A = mkA "dösjuk" ; -- dösjuk..av.1
  döskraj_1_A = mkA "döskraj" ; -- döskraj..av.1
  dösnack_1_N = mkN "dösnack" neutrum  ; -- dösnack..nn.1
  dötråkig_1_A = mkA "dötråkig" ; -- dötråkig..av.1
  dötrött_1_A = mkA "dötrött" ; -- dötrött..av.1
  dötyst_1_A = mkA "dötyst" "dötyst" ; -- dötyst..av.1
  döv_1_A = mkA "döv" ; -- döv..av.1
  döva_1_V = mkV "dövar" ; -- döva..vb.1
  dövande_1_N = mkN "dövande" ; -- dövande..nn.1
  dövblind_1_A = mkA "dövblind" ; -- dövblind..av.1
  dövblindhet_1_N = mkN "dövblindhet" ; -- dövblindhet..nn.1
  dövhet_1_N = mkN "dövhet" "dövheter" ; -- dövhet..nn.1
  dövning_1_N = mkN "dövning" ; -- dövning..nn.1
  dövstum_1_A = mkA "dövstum" "dövstumt" "dövstumma" "dövstumma" "dövstummare" "dövstummast" "dövstummaste" ; -- dövstum..av.1
  dövstumhet_1_N = mkN "dövstumhet" ; -- dövstumhet..nn.1
  e_bok_1_N = mkN "e-bok" "e-böcker" ; -- e-bok..nn.1
  e_bokläsare_1_N = mkN "e-bokläsare" utrum  ; -- e-bokläsare..nn.1
  e_brev_1_N = mkN "e-brev" neutrum  ; -- e-brev..nn.1
  e_brevledes_1_Adv = mkAdv "e-brevledes" ; -- e-brevledes..ab.1
  e_leg_1_N = mkN "e-leg" neutrum  ; -- e-leg..nn.1
  e_legg_1_N = mkN "e-legg" neutrum  ; -- e-legg..nn.1
  e_legitimation_1_N = mkN "e-legitimation" ; -- e-legitimation..nn.1
  e_mail_1_N = mkN "e-mail" ; -- e-mail..nn.1
  e_mail_2_N = mkN "e-mail" neutrum  ; -- e-mail..nn.2
  e_maila_1_V = mkV "e-mailar" ; -- e-maila..vb.1
  e_mailande_1_N = mkN "e-mailande" ; -- e-mailande..nn.1
  e_post_1_N = mkN "e-post" ; -- e-post..nn.1
  e_posta_1_V = mkV "e-postar" ; -- e-posta..vb.1
  e_postande_1_N = mkN "e-postande" ; -- e-postande..nn.1
  e_postare_1_N = mkN "e-postare" utrum  ; -- e-postare..nn.1
  e_postbrev_1_N = mkN "e-postbrev" neutrum  ; -- e-postbrev..nn.1
  e_postledes_1_Adv = mkAdv "e-postledes" ; -- e-postledes..ab.1
  e_postmeddelande_1_N = mkN "e-postmeddelande" ; -- e-postmeddelande..nn.1
  e_tidning_1_N = mkN "e-tidning" ; -- e-tidning..nn.1
  e_tidskrift_1_N = mkN "e-tidskrift" "e-tidskrifter" ; -- e-tidskrift..nn.1
  e_vetenskap_1_N = mkN "e-vetenskap" "e-vetenskaper" ; -- e-vetenskap..nn.1
  eau_de_cologne_1_N = mkN "eau-de-cologne" "eau-de-cologner" ; -- eau-de-cologne..nn.1
  eau_de_toilette_1_N = mkN "eau-de-toilette" utrum  ; -- eau-de-toilette..nn.1
  eau_de_vie_1_N = mkN "eau-de-vie" utrum  ; -- eau-de-vie..nn.1
  ebb_1_N = mkN "ebb" ; -- ebb..nn.1
  ebba_1_V = mkV "ebbar" ; -- ebba..vb.1
  ebbande_1_N = mkN "ebbande" ; -- ebbande..nn.1
  ebenholts_1_N = mkN "ebenholts" ; -- ebenholts..nn.1
  ebenholtsbetsad_1_A = mkA "ebenholtsbetsad" ; -- ebenholtsbetsad..av.1
  ebenist_1_N = mkN "ebenist" "ebenister" ; -- ebenist..nn.1
  ebolavirus_1_N = mkN "ebolavirus" neutrum  ; -- ebolavirus..nn.1
  ebonit_1_N = mkN "ebonit" ; -- ebonit..nn.1
  ebonitstav_1_N = mkN "ebonitstav" ; -- ebonitstav..nn.1
  ebrev_1_N = mkN "ebrev" neutrum  ; -- ebrev..nn.1
  ebrevledes_1_Adv = mkAdv "ebrevledes" ; -- ebrevledes..ab.1
  echaufferad_1_A = mkA "echaufferad" ; -- echaufferad..av.1
  echelong_1_N = mkN "echelong" "echelonger" ; -- echelong..nn.1
  ecklesiastik_1_A = mkA "ecklesiastik" ; -- ecklesiastik..av.1
  ecklesiastikdepartement_1_N = mkN "ecklesiastikdepartement" neutrum  ; -- ecklesiastikdepartement..nn.1
  ecklesiastikminister_1_N = mkN "ecklesiastikminister" ; -- ecklesiastikminister..nn.1
  ecklesiastisk_1_A = mkA "ecklesiastisk" ; -- ecklesiastisk..av.1
  ecuadorian_1_N = mkN "ecuadorian" "ecuadorianer" ; -- ecuadorian..nn.1
  ecuadoriansk_1_A = mkA "ecuadoriansk" ; -- ecuadoriansk..av.1
  ecuadorianska_1_N = mkN "ecuadorianska" ; -- ecuadorianska..nn.1
  ed_1_N = mkN "ed" "eder" ; -- ed..nn.1
  ed_2_N = mkN "ed" neutrum  ; -- ed..nn.2
  eda_1_N = mkN "eda" ; -- eda..nn.1
  edamerost_1_N = mkN "edamerost" ; -- edamerost..nn.1
  edda_1_N = mkN "edda" ; -- edda..nn.1
  edelweiss_1_N = mkN "edelweiss" ; -- edelweiss..nn.1
  edera_1_V = mkV "ederar" ; -- edera..vb.1
  ederande_1_N = mkN "ederande" ; -- ederande..nn.1
  ederbar_1_A = mkA "ederbar" ; -- ederbar..av.1
  ederbarhet_1_N = mkN "ederbarhet" ; -- ederbarhet..nn.1
  edering_1_N = mkN "edering" ; -- edering..nn.1
  edfäst_1_A = mkA "edfäst" "edfäst" ; -- edfäst..av.1
  edfästa_1_V = mkV "edfästa" "edfäster" "edfäst" "edfäste" "edfäst" "edfäst" ; -- edfästa..vb.1
  edfästande_1_N = mkN "edfästande" ; -- edfästande..nn.1
  edgång_1_N = mkN "edgång" ; -- edgång..nn.1
  edikt_1_N = mkN "edikt" neutrum  ; -- edikt..nn.1
  edil_1_N = mkN "edil" "ediler" ; -- edil..nn.1
  edition_1_N = mkN "edition" ; -- edition..nn.1
  edlig_1_A = mkA "edlig" ; -- edlig..av.1
  edligen_1_Adv = mkAdv "edligen" ; -- edligen..ab.1
  edlighet_1_N = mkN "edlighet" ; -- edlighet..nn.1
  edsansvar_1_N = mkN "edsansvar" neutrum  ; -- edsansvar..nn.1
  edsbrott_1_N = mkN "edsbrott" neutrum  ; -- edsbrott..nn.1
  edsförpliktelse_1_N = mkN "edsförpliktelse" "edsförpliktelser" ; -- edsförpliktelse..nn.1
  edsgång_1_N = mkN "edsgång" ; -- edsgång..nn.1
  edsvuren_1_A = mkA "edsvuren" ; -- edsvuren..av.1
  edsöre_1_N = mkN "edsöre" ; -- edsöre..nn.1
  edsöresbrott_1_N = mkN "edsöresbrott" neutrum  ; -- edsöresbrott..nn.1
  efedrin_1_N = mkN "efedrin" "efedriner" ; -- efedrin..nn.1
  efemerid_1_N = mkN "efemerid" "efemerider" ; -- efemerid..nn.1
  efemeridtid_1_N = mkN "efemeridtid" ; -- efemeridtid..nn.1
  efemär_1_A = mkA "efemär" ; -- efemär..av.1
  effacera_1_V = mkV "effacerar" ; -- effacera..vb.1
  effacerande_1_N = mkN "effacerande" ; -- effacerande..nn.1
  effacerbar_1_A = mkA "effacerbar" ; -- effacerbar..av.1
  effacerbarhet_1_N = mkN "effacerbarhet" ; -- effacerbarhet..nn.1
  effacering_1_N = mkN "effacering" ; -- effacering..nn.1
  effekt_1_N = mkN "effekt" "effekter" ; -- effekt..nn.1
  effektfaktor_1_N = mkN "effektfaktor" "effektfaktorer" ; -- effektfaktor..nn.1
  effektfrånskiljare_1_N = mkN "effektfrånskiljare" utrum  ; -- effektfrånskiljare..nn.1
  effektfull_1_A = mkA "effektfull" ; -- effektfull..av.1
  effektfullhet_1_N = mkN "effektfullhet" ; -- effektfullhet..nn.1
  effektförstärkare_1_N = mkN "effektförstärkare" utrum  ; -- effektförstärkare..nn.1
  effektgarn_1_N = mkN "effektgarn" neutrum  ; -- effektgarn..nn.1
  effektiv_1_A = mkA "effektiv" ; -- effektiv..av.1
  effektivera_1_V = mkV "effektiverar" ; -- effektivera..vb.1
  effektiverande_1_N = mkN "effektiverande" ; -- effektiverande..nn.1
  effektiverbar_1_A = mkA "effektiverbar" ; -- effektiverbar..av.1
  effektiverbarhet_1_N = mkN "effektiverbarhet" ; -- effektiverbarhet..nn.1
  effektivering_1_N = mkN "effektivering" ; -- effektivering..nn.1
  effektivisera_1_V = mkV "effektiviserar" ; -- effektivisera..vb.1
  effektiviserande_1_N = mkN "effektiviserande" ; -- effektiviserande..nn.1
  effektiviserbar_1_A = mkA "effektiviserbar" ; -- effektiviserbar..av.1
  effektiviserbarhet_1_N = mkN "effektiviserbarhet" ; -- effektiviserbarhet..nn.1
  effektivisering_1_N = mkN "effektivisering" ; -- effektivisering..nn.1
  effektivitet_1_N = mkN "effektivitet" "effektiviteter" ; -- effektivitet..nn.1
  effektivitetsargument_1_N = mkN "effektivitetsargument" neutrum  ; -- effektivitetsargument..nn.1
  effektivitetsmässig_1_A = mkA "effektivitetsmässig" ; -- effektivitetsmässig..av.1
  effektläge_1_N = mkN "effektläge" ; -- effektläge..nn.1
  effektlös_1_A = mkA "effektlös" ; -- effektlös..av.1
  effektlöshet_1_N = mkN "effektlöshet" ; -- effektlöshet..nn.1
  effektmässig_1_A = mkA "effektmässig" ; -- effektmässig..av.1
  effektskapande_1_A = mkA "effektskapande" ; -- effektskapande..av.1
  effektsökeri_1_N = mkN "effektsökeri" "effektsökeriet" "effektsökerier" "effektsökerierna" ; -- effektsökeri..nn.1
  effektuera_1_V = mkV "effektuerar" ; -- effektuera..vb.1
  effektuerande_1_N = mkN "effektuerande" ; -- effektuerande..nn.1
  effektuerbar_1_A = mkA "effektuerbar" ; -- effektuerbar..av.1
  effektuerbarhet_1_N = mkN "effektuerbarhet" ; -- effektuerbarhet..nn.1
  effektuering_1_N = mkN "effektuering" ; -- effektuering..nn.1
  effektökning_1_N = mkN "effektökning" ; -- effektökning..nn.1
  effeminerad_1_A = mkA "effeminerad" ; -- effeminerad..av.1
  efor_1_N = mkN "efor" "eforen" "eforer" "eforerna" ; -- efor..nn.1
  eforus_1_N = mkN "eforus" "eforus" "eforer" "eforerna" ; -- eforus..nn.1
  efter_1_A = mkA "efter" ; -- efter..av.1
  efteraccept_1_N = mkN "efteraccept" neutrum  ; -- efteraccept..nn.1
  efteranmäla_1_V = mkV "efteranmäler" ; -- efteranmäla..vb.1
  efterapa_1_V = mkV "efterapar" ; -- efterapa..vb.1
  efterapande_1_N = mkN "efterapande" ; -- efterapande..nn.1
  efterapare_1_N = mkN "efterapare" utrum  ; -- efterapare..nn.1
  efterapning_1_N = mkN "efterapning" ; -- efterapning..nn.1
  efterarbete_1_N = mkN "efterarbete" ; -- efterarbete..nn.1
  efterbehandla_1_V = mkV "efterbehandlar" ; -- efterbehandla..vb.1
  efterbehandlande_1_N = mkN "efterbehandlande" ; -- efterbehandlande..nn.1
  efterbesiktning_1_N = mkN "efterbesiktning" ; -- efterbesiktning..nn.1
  efterbeskattning_1_N = mkN "efterbeskattning" ; -- efterbeskattning..nn.1
  efterbeställning_1_N = mkN "efterbeställning" ; -- efterbeställning..nn.1
  efterbetalning_1_N = mkN "efterbetalning" ; -- efterbetalning..nn.1
  efterbevakning_1_N = mkN "efterbevakning" ; -- efterbevakning..nn.1
  efterbild_1_N = mkN "efterbild" "efterbilder" ; -- efterbild..nn.1
  efterbilda_1_V = mkV "efterbildar" ; -- efterbilda..vb.1
  efterbildande_1_N = mkN "efterbildande" ; -- efterbildande..nn.1
  efterbildare_1_N = mkN "efterbildare" utrum  ; -- efterbildare..nn.1
  efterbildning_1_N = mkN "efterbildning" ; -- efterbildning..nn.1
  efterbliven_1_A = mkA "efterbliven" ; -- efterbliven..av.1
  efterblivenhet_1_N = mkN "efterblivenhet" ; -- efterblivenhet..nn.1
  efterblomning_1_N = mkN "efterblomning" ; -- efterblomning..nn.1
  efterblomstring_1_N = mkN "efterblomstring" ; -- efterblomstring..nn.1
  efterblödning_1_N = mkN "efterblödning" ; -- efterblödning..nn.1
  efterbrännare_1_N = mkN "efterbrännare" utrum  ; -- efterbrännare..nn.1
  efterbrännkammare_1_N = mkN "efterbrännkammare" "efterbrännkammaren" "efterbrännkammare" "efterbrännkamrarna" ; -- efterbrännkammare..nn.1
  efterbörd_1_N = mkN "efterbörd" "efterbörder" ; -- efterbörd..nn.1
  efterbörs_1_N = mkN "efterbörs" "efterbörser" ; -- efterbörs..nn.1
  efterdatera_1_V = mkV "efterdaterar" ; -- efterdatera..vb.1
  efterdaterande_1_N = mkN "efterdaterande" ; -- efterdaterande..nn.1
  efterdaterbar_1_A = mkA "efterdaterbar" ; -- efterdaterbar..av.1
  efterdaterbarhet_1_N = mkN "efterdaterbarhet" ; -- efterdaterbarhet..nn.1
  efterdatering_1_N = mkN "efterdatering" ; -- efterdatering..nn.1
  efterdebitera_1_V = mkV "efterdebiterar" ; -- efterdebitera..vb.1
  efterdebiterande_1_N = mkN "efterdebiterande" ; -- efterdebiterande..nn.1
  efterdebiterbar_1_A = mkA "efterdebiterbar" ; -- efterdebiterbar..av.1
  efterdebiterbarhet_1_N = mkN "efterdebiterbarhet" ; -- efterdebiterbarhet..nn.1
  efterdebitering_1_N = mkN "efterdebitering" ; -- efterdebitering..nn.1
  efterdyning_1_N = mkN "efterdyning" ; -- efterdyning..nn.1
  efterdöme_1_N = mkN "efterdöme" ; -- efterdöme..nn.1
  efterdömlig_1_A = mkA "efterdömlig" ; -- efterdömlig..av.1
  efterdömlighet_1_N = mkN "efterdömlighet" ; -- efterdömlighet..nn.1
  efterfest_1_N = mkN "efterfest" "efterfester" ; -- efterfest..nn.1
  efterforska_1_V = mkV "efterforskar" ; -- efterforska..vb.1
  efterforskande_1_N = mkN "efterforskande" ; -- efterforskande..nn.1
  efterforskning_1_N = mkN "efterforskning" ; -- efterforskning..nn.1
  efterfråga_1_V = mkV "efterfrågar" ; -- efterfråga..vb.1
  efterfrågad_1_A = mkA "efterfrågad" ; -- efterfrågad..av.1
  efterfrågande_1_N = mkN "efterfrågande" ; -- efterfrågande..nn.1
  efterfrågning_1_N = mkN "efterfrågning" ; -- efterfrågning..nn.1
  efterfölja_1_V = mkV "efterfölja" "efterföljde" "efterföljt" ; -- efterfölja..vb.1
  efterföljande_1_N = mkN "efterföljande" ; -- efterföljande..nn.1
  efterföljansvärd_1_A = mkA "efterföljansvärd" "efterföljansvärt" ; -- efterföljansvärd..av.1
  efterföljare_1_N = mkN "efterföljare" utrum  ; -- efterföljare..nn.1
  efterföljd_1_N = mkN "efterföljd" ; -- efterföljd..nn.1
  efterföljelse_1_N = mkN "efterföljelse" "efterföljelser" ; -- efterföljelse..nn.1
  efterge_1_V = mkV "eftergiva" "eftergav" "eftergivit" ; -- efterge..vb.1
  eftergift_1_N = mkN "eftergift" "eftergifter" ; -- eftergift..nn.1
  eftergivande_1_N = mkN "eftergivande" ; -- eftergivande..nn.1
  eftergiven_1_A = mkA "eftergiven" ; -- eftergiven..av.1
  eftergivenhet_1_N = mkN "eftergivenhet" "eftergivenheter" ; -- eftergivenhet..nn.1
  eftergivlig_1_A = mkA "eftergivlig" ; -- eftergivlig..av.1
  eftergivlighet_1_N = mkN "eftergivlighet" ; -- eftergivlighet..nn.1
  eftergjord_1_A = mkA "eftergjord" "eftergjort" ; -- eftergjord..av.1
  efterglans_1_N = mkN "efterglans" ; -- efterglans..nn.1
  eftergranskning_1_N = mkN "eftergranskning" ; -- eftergranskning..nn.1
  eftergymnasial_1_A = mkA "eftergymnasial" ; -- eftergymnasial..av.1
  eftergöra_1_V = mkV "eftergöra" "eftergjorde" "eftergjort" ; -- eftergöra..vb.1
  eftergörande_1_N = mkN "eftergörande" ; -- eftergörande..nn.1
  efterhand_1_Adv = mkAdv "efterhand" ; -- efterhand..ab.1
  efterhand_1_N = mkN "efterhand" ; -- efterhand..nn.1
  efterhandskonstruktion_1_N = mkN "efterhandskonstruktion" ; -- efterhandskonstruktion..nn.1
  efterhängsen_1_A = mkA "efterhängsen" ; -- efterhängsen..av.1
  efterhängsenhet_1_N = mkN "efterhängsenhet" ; -- efterhängsenhet..nn.1
  efterhärma_1_V = mkV "efterhärmar" ; -- efterhärma..vb.1
  efterhärmande_1_N = mkN "efterhärmande" ; -- efterhärmande..nn.1
  efterhärmare_1_N = mkN "efterhärmare" utrum  ; -- efterhärmare..nn.1
  efterhärmning_1_N = mkN "efterhärmning" ; -- efterhärmning..nn.1
  efterhålla_1_V = mkV "efterhålla" "efterhöll" "efterhållit" ; -- efterhålla..vb.1
  efterhållande_1_N = mkN "efterhållande" ; -- efterhållande..nn.1
  efterhöra_1_V = mkV "efterhöra" "efterhörde" "efterhört" ; -- efterhöra..vb.1
  efterhörande_1_N = mkN "efterhörande" ; -- efterhörande..nn.1
  efterhöst_1_N = mkN "efterhöst" ; -- efterhöst..nn.1
  efterjäsning_1_N = mkN "efterjäsning" ; -- efterjäsning..nn.1
  efterklang_1_N = mkN "efterklang" "efterklanger" ; -- efterklang..nn.1
  efterklok_1_A = mkA "efterklok" ; -- efterklok..av.1
  efterklokhet_1_N = mkN "efterklokhet" ; -- efterklokhet..nn.1
  efterkokning_1_N = mkN "efterkokning" ; -- efterkokning..nn.1
  efterkomma_1_V = mkV "efterkomma" "efterkom" "efterkommit" ; -- efterkomma..vb.1
  efterkommande_1_N = mkN "efterkommande" "efterkommanden" "efterkommanden" "efterkommandena" ; -- efterkommande..nn.1
  efterkommande_2_N = mkN "efterkommande" ; -- efterkommande..nn.2
  efterkonstruktion_1_N = mkN "efterkonstruktion" ; -- efterkonstruktion..nn.1
  efterkontroll_1_N = mkN "efterkontroll" "efterkontroller" ; -- efterkontroll..nn.1
  efterkrav_1_N = mkN "efterkrav" neutrum  ; -- efterkrav..nn.1
  efterkrigsdecennium_1_N = mkN "efterkrigsdecennium" "efterkrigsdecenniet" "efterkrigsdecennier" "efterkrigsdecennierna" ; -- efterkrigsdecennium..nn.1
  efterkrigstid_1_N = mkN "efterkrigstid" "efterkrigstider" ; -- efterkrigstid..nn.1
  efterkultur_1_N = mkN "efterkultur" ; -- efterkultur..nn.1
  efterkänning_1_N = mkN "efterkänning" ; -- efterkänning..nn.1
  efterled_1_N = mkN "efterled" neutrum  ; -- efterled..nn.1
  efterleva_1_V = mkV "efterlever" ; -- efterleva..vb.1
  efterlevande_1_A = mkA "efterlevande" ; -- efterlevande..av.1
  efterlevande_1_N = mkN "efterlevande" ; -- efterlevande..nn.1
  efterlevandeskydd_1_N = mkN "efterlevandeskydd" neutrum  ; -- efterlevandeskydd..nn.1
  efterleverska_1_N = mkN "efterleverska" ; -- efterleverska..nn.1
  efterlevnad_1_N = mkN "efterlevnad" "efterlevnader" ; -- efterlevnad..nn.1
  efterlevnadskontroll_1_N = mkN "efterlevnadskontroll" "efterlevnadskontroller" ; -- efterlevnadskontroll..nn.1
  efterliggande_1_A = mkA "efterliggande" ; -- efterliggande..av.1
  efterlikna_1_V = mkV "efterliknar" ; -- efterlikna..vb.1
  efterliknande_1_N = mkN "efterliknande" ; -- efterliknande..nn.1
  efterlysa_1_V = mkV "efterlyser" ; -- efterlysa..vb.1
  efterlysande_1_N = mkN "efterlysande" ; -- efterlysande..nn.1
  efterlysning_1_N = mkN "efterlysning" ; -- efterlysning..nn.1
  efterlämna_1_V = mkV "efterlämnar" ; -- efterlämna..vb.1
  efterlämnande_1_N = mkN "efterlämnande" ; -- efterlämnande..nn.1
  efterlämning_1_N = mkN "efterlämning" ; -- efterlämning..nn.1
  efterlängtad_1_A = mkA "efterlängtad" ; -- efterlängtad..av.1
  efterlåta_1_V = mkV "efterlåta" "efterlät" "efterlåtit" ; -- efterlåta..vb.1
  efterlåtande_1_N = mkN "efterlåtande" ; -- efterlåtande..nn.1
  efterlåten_1_A = mkA "efterlåten" ; -- efterlåten..av.1
  efterlåtenhet_1_N = mkN "efterlåtenhet" ; -- efterlåtenhet..nn.1
  eftermassage_1_N = mkN "eftermassage" utrum  ; -- eftermassage..nn.1
  eftermiddag_1_N = mkN "eftermiddag" ; -- eftermiddag..nn.1
  eftermiddagsbris_1_N = mkN "eftermiddagsbris" ; -- eftermiddagsbris..nn.1
  eftermiddagsjobb_1_N = mkN "eftermiddagsjobb" neutrum  ; -- eftermiddagsjobb..nn.1
  eftermiddagskaffe_1_N = mkN "eftermiddagskaffe" ; -- eftermiddagskaffe..nn.1
  eftermiddagslur_1_N = mkN "eftermiddagslur" ; -- eftermiddagslur..nn.1
  eftermiddagspass_1_N = mkN "eftermiddagspass" neutrum  ; -- eftermiddagspass..nn.1
  eftermiddagsrusning_1_N = mkN "eftermiddagsrusning" ; -- eftermiddagsrusning..nn.1
  eftermiddagssejour_1_N = mkN "eftermiddagssejour" "eftermiddagssejourer" ; -- eftermiddagssejour..nn.1
  eftermiddagsskymning_1_N = mkN "eftermiddagsskymning" ; -- eftermiddagsskymning..nn.1
  eftermiddagste_1_N = mkN "eftermiddagste" ; -- eftermiddagste..nn.1
  eftermiddagstimme_1_N = mkN "eftermiddagstimme" utrum  ; -- eftermiddagstimme..nn.1
  eftermiddagstrafik_1_N = mkN "eftermiddagstrafik" ; -- eftermiddagstrafik..nn.1
  eftermogna_1_V = mkV "eftermognar" ; -- eftermogna..vb.1
  eftermognad_1_N = mkN "eftermognad" ; -- eftermognad..nn.1
  eftermognande_1_N = mkN "eftermognande" ; -- eftermognande..nn.1
  eftermäle_1_N = mkN "eftermäle" ; -- eftermäle..nn.1
  efternamn_1_N = mkN "efternamn" neutrum  ; -- efternamn..nn.1
  efternatt_1_N = mkN "efternatt" ; -- efternatt..nn.1
  efterord_1_N = mkN "efterord" neutrum  ; -- efterord..nn.1
  efterplock_1_N = mkN "efterplock" neutrum  ; -- efterplock..nn.1
  efterplockning_1_N = mkN "efterplockning" ; -- efterplockning..nn.1
  efterprövning_1_N = mkN "efterprövning" ; -- efterprövning..nn.1
  efterputs_1_N = mkN "efterputs" ; -- efterputs..nn.1
  efterrationalisera_1_V = mkV "efterrationaliserar" ; -- efterrationalisera..vb.1
  efterrationaliserande_1_N = mkN "efterrationaliserande" ; -- efterrationaliserande..nn.1
  efterrationaliserbar_1_A = mkA "efterrationaliserbar" ; -- efterrationaliserbar..av.1
  efterrationaliserbarhet_1_N = mkN "efterrationaliserbarhet" ; -- efterrationaliserbarhet..nn.1
  efterrationalisering_1_N = mkN "efterrationalisering" ; -- efterrationalisering..nn.1
  efterräkning_1_N = mkN "efterräkning" ; -- efterräkning..nn.1
  efterrätt_1_N = mkN "efterrätt" "efterrätter" ; -- efterrätt..nn.1
  efterrättelse_1_N = mkN "efterrättelse" utrum  ; -- efterrättelse..nn.1
  efterrättssoppa_1_N = mkN "efterrättssoppa" ; -- efterrättssoppa..nn.1
  eftersaknad_1_A = mkA "eftersaknad" ; -- eftersaknad..av.1
  eftersaknad_1_N = mkN "eftersaknad" ; -- eftersaknad..nn.1
  eftersats_1_N = mkN "eftersats" "eftersatser" ; -- eftersats..nn.1
  efterse_1_V = mkV "efterse" "eftersåg" "eftersett" ; -- efterse..vb.1
  efterseende_1_N = mkN "efterseende" ; -- efterseende..nn.1
  eftersinna_1_V = mkV "eftersinnar" ; -- eftersinna..vb.1
  eftersinnande_1_A = mkA "eftersinnande" ; -- eftersinnande..av.1
  eftersinnande_1_N = mkN "eftersinnande" ; -- eftersinnande..nn.1
  eftersits_1_N = mkN "eftersits" ; -- eftersits..nn.1
  efterskalv_1_N = mkN "efterskalv" ; -- efterskalv..nn.1
  efterskickning_1_N = mkN "efterskickning" ; -- efterskickning..nn.1
  efterskott_1_N = mkN "efterskott" neutrum  ; -- efterskott..nn.1
  efterskrift_1_N = mkN "efterskrift" "efterskrifter" ; -- efterskrift..nn.1
  efterskänka_1_V = mkV "efterskänker" ; -- efterskänka..vb.1
  efterskänkande_1_N = mkN "efterskänkande" ; -- efterskänkande..nn.1
  efterskänkning_1_N = mkN "efterskänkning" ; -- efterskänkning..nn.1
  efterskörd_1_N = mkN "efterskörd" ; -- efterskörd..nn.1
  efterslag_1_N = mkN "efterslag" neutrum  ; -- efterslag..nn.1
  eftersläckning_1_N = mkN "eftersläckning" ; -- eftersläckning..nn.1
  eftersläng_1_N = mkN "eftersläng" ; -- eftersläng..nn.1
  eftersläntrande_1_A = mkA "eftersläntrande" ; -- eftersläntrande..av.1
  eftersläntrare_1_N = mkN "eftersläntrare" utrum  ; -- eftersläntrare..nn.1
  eftersläpning_1_N = mkN "eftersläpning" ; -- eftersläpning..nn.1
  efterslåtter_1_N = mkN "efterslåtter" ; -- efterslåtter..nn.1
  eftersmak_1_N = mkN "eftersmak" ; -- eftersmak..nn.1
  eftersnack_1_N = mkN "eftersnack" neutrum  ; -- eftersnack..nn.1
  eftersommar_1_N = mkN "eftersommar" "eftersommaren" "eftersomrar" "eftersomrarna" ; -- eftersommar..nn.1
  efterspana_1_V = mkV "efterspanar" ; -- efterspana..vb.1
  efterspanad_1_A = mkA "efterspanad" ; -- efterspanad..av.1
  efterspanande_1_N = mkN "efterspanande" ; -- efterspanande..nn.1
  efterspaning_1_N = mkN "efterspaning" ; -- efterspaning..nn.1
  efterspel_1_N = mkN "efterspel" "efterspelet" "efterspel" "efterspelen" ; -- efterspel..nn.1
  efterstava_1_V = mkV "efterstavar" ; -- efterstava..vb.1
  efterstavande_1_N = mkN "efterstavande" ; -- efterstavande..nn.1
  efterstavning_1_N = mkN "efterstavning" ; -- efterstavning..nn.1
  eftersträva_1_V = mkV "eftersträvar" ; -- eftersträva..vb.1
  eftersträvande_1_N = mkN "eftersträvande" ; -- eftersträvande..nn.1
  eftersträvansvärd_1_A = mkA "eftersträvansvärd" "eftersträvansvärt" ; -- eftersträvansvärd..av.1
  eftersträvansvärdhet_1_N = mkN "eftersträvansvärdhet" ; -- eftersträvansvärdhet..nn.1
  efterstygn_1_N = mkN "efterstygn" neutrum  ; -- efterstygn..nn.1
  efterställd_1_A = mkA "efterställd" "efterställt" ; -- efterställd..av.1
  eftersupning_1_N = mkN "eftersupning" ; -- eftersupning..nn.1
  eftersyn_1_N = mkN "eftersyn" ; -- eftersyn..nn.1
  eftersynkronisera_1_V = mkV "eftersynkroniserar" ; -- eftersynkronisera..vb.1
  eftersynkroniserande_1_N = mkN "eftersynkroniserande" ; -- eftersynkroniserande..nn.1
  eftersynkroniserbar_1_A = mkA "eftersynkroniserbar" ; -- eftersynkroniserbar..av.1
  eftersynkroniserbarhet_1_N = mkN "eftersynkroniserbarhet" ; -- eftersynkroniserbarhet..nn.1
  eftersynkronisering_1_N = mkN "eftersynkronisering" ; -- eftersynkronisering..nn.1
  eftersäga_1_V = mkV "eftersäja" "eftersa" "eftersagt" ; -- eftersäga..vb.1
  eftersägande_1_N = mkN "eftersägande" ; -- eftersägande..nn.1
  eftersägare_1_N = mkN "eftersägare" utrum  ; -- eftersägare..nn.1
  eftersägning_1_N = mkN "eftersägning" ; -- eftersägning..nn.1
  eftersända_1_V = mkV "eftersänder" ; -- eftersända..vb.1
  eftersändande_1_N = mkN "eftersändande" ; -- eftersändande..nn.1
  eftersändning_1_N = mkN "eftersändning" ; -- eftersändning..nn.1
  eftersätta_1_V = mkV "eftersätta" "eftersätter" "eftersätt" "eftersatte" "eftersatt" "eftersatt" ; -- eftersätta..vb.1
  eftersättande_1_N = mkN "eftersättande" ; -- eftersättande..nn.1
  eftersättsblad_1_N = mkN "eftersättsblad" neutrum  ; -- eftersättsblad..nn.1
  eftersök_1_N = mkN "eftersök" neutrum  ; -- eftersök..nn.1
  eftersöka_1_V = mkV "eftersöker" ; -- eftersöka..vb.1
  eftersökande_1_N = mkN "eftersökande" ; -- eftersökande..nn.1
  eftersökning_1_N = mkN "eftersökning" ; -- eftersökning..nn.1
  eftersökt_1_A = mkA "eftersökt" "eftersökt" ; -- eftersökt..av.1
  eftersökthet_1_N = mkN "eftersökthet" ; -- eftersökthet..nn.1
  eftertanke_1_N = mkN "eftertanke" utrum  ; -- eftertanke..nn.1
  eftertaxera_1_V = mkV "eftertaxerar" ; -- eftertaxera..vb.1
  eftertaxerande_1_N = mkN "eftertaxerande" ; -- eftertaxerande..nn.1
  eftertaxerbar_1_A = mkA "eftertaxerbar" ; -- eftertaxerbar..av.1
  eftertaxerbarhet_1_N = mkN "eftertaxerbarhet" ; -- eftertaxerbarhet..nn.1
  eftertaxering_1_N = mkN "eftertaxering" ; -- eftertaxering..nn.1
  eftertextnot_1_N = mkN "eftertextnot" "eftertextnoter" ; -- eftertextnot..nn.1
  eftertorkning_1_N = mkN "eftertorkning" ; -- eftertorkning..nn.1
  eftertrakta_1_V = mkV "eftertraktar" ; -- eftertrakta..vb.1
  eftertraktande_1_N = mkN "eftertraktande" ; -- eftertraktande..nn.1
  eftertraktansvärd_1_A = mkA "eftertraktansvärd" "eftertraktansvärt" ; -- eftertraktansvärd..av.1
  eftertraktansvärdhet_1_N = mkN "eftertraktansvärdhet" ; -- eftertraktansvärdhet..nn.1
  eftertrav_1_N = mkN "eftertrav" neutrum  ; -- eftertrav..nn.1
  eftertrupp_1_N = mkN "eftertrupp" "eftertrupper" ; -- eftertrupp..nn.1
  eftertryck_1_N = mkN "eftertryck" neutrum  ; -- eftertryck..nn.1
  eftertrycklig_1_A = mkA "eftertrycklig" ; -- eftertrycklig..av.1
  eftertryckligen_1_Adv = mkAdv "eftertryckligen" ; -- eftertryckligen..ab.1
  eftertrycklighet_1_N = mkN "eftertrycklighet" ; -- eftertrycklighet..nn.1
  efterträda_1_V = mkV "efterträda" "efterträdde" "efterträtt" ; -- efterträda..vb.1
  efterträdande_1_N = mkN "efterträdande" ; -- efterträdande..nn.1
  efterträdare_1_N = mkN "efterträdare" utrum  ; -- efterträdare..nn.1
  efterträdarkandidat_1_N = mkN "efterträdarkandidat" "efterträdarkandidater" ; -- efterträdarkandidat..nn.1
  eftertrå_1_V = mkV "eftertrår" ; -- eftertrå..vb.1
  eftertrående_1_N = mkN "eftertrående" ; -- eftertrående..nn.1
  eftertänksam_1_A = mkA "eftertänksam" "eftertänksamt" "eftertänksamma" "eftertänksamma" "eftertänksammare" "eftertänksammast" "eftertänksammaste" ; -- eftertänksam..av.1
  eftertänksamhet_1_N = mkN "eftertänksamhet" ; -- eftertänksamhet..nn.1
  efterundersökning_1_N = mkN "efterundersökning" ; -- efterundersökning..nn.1
  efterutbildning_1_N = mkN "efterutbildning" ; -- efterutbildning..nn.1
  eftervalsanalys_1_N = mkN "eftervalsanalys" "eftervalsanalyser" ; -- eftervalsanalys..nn.1
  eftervalsdebatt_1_N = mkN "eftervalsdebatt" "eftervalsdebatter" ; -- eftervalsdebatt..nn.1
  efterverkning_1_N = mkN "efterverkning" ; -- efterverkning..nn.1
  eftervinter_1_N = mkN "eftervinter" ; -- eftervinter..nn.1
  eftervis_1_A = mkA "eftervis" ; -- eftervis..av.1
  eftervishet_1_N = mkN "eftervishet" ; -- eftervishet..nn.1
  eftervärk_1_N = mkN "eftervärk" ; -- eftervärk..nn.1
  eftervärld_1_N = mkN "eftervärld" ; -- eftervärld..nn.1
  eftervärme_1_N = mkN "eftervärme" utrum  ; -- eftervärme..nn.1
  efterväxt_1_N = mkN "efterväxt" ; -- efterväxt..nn.1
  eftervård_1_N = mkN "eftervård" ; -- eftervård..nn.1
  efteråt_1_Adv = mkAdv "efteråt" ; -- efteråt..ab.1
  egal_1_A = mkA "egal" ; -- egal..av.1
  egalisera_1_V = mkV "egaliserar" ; -- egalisera..vb.1
  egaliserande_1_N = mkN "egaliserande" ; -- egaliserande..nn.1
  egaliserbar_1_A = mkA "egaliserbar" ; -- egaliserbar..av.1
  egaliserbarhet_1_N = mkN "egaliserbarhet" ; -- egaliserbarhet..nn.1
  egalisering_1_N = mkN "egalisering" ; -- egalisering..nn.1
  egalitet_1_N = mkN "egalitet" "egaliteter" ; -- egalitet..nn.1
  egalitär_1_A = mkA "egalitär" ; -- egalitär..av.1
  egard_1_N = mkN "egard" ; -- egard..nn.1
  egeisk_1_A = mkA "egeisk" ; -- egeisk..av.1
  egen_1_A = mkA "egen" "eget" ; -- egen..av.1
  egenart_1_N = mkN "egenart" ; -- egenart..nn.1
  egenartad_1_A = mkA "egenartad" ; -- egenartad..av.1
  egendesignad_1_A = mkA "egendesignad" ; -- egendesignad..av.1
  egendiagnos_1_N = mkN "egendiagnos" "egendiagnoser" ; -- egendiagnos..nn.1
  egendiagnostik_1_N = mkN "egendiagnostik" ; -- egendiagnostik..nn.1
  egendom_1_N = mkN "egendom" ; -- egendom..nn.1
  egendomlig_1_A = mkA "egendomlig" ; -- egendomlig..av.1
  egendomlighet_1_N = mkN "egendomlighet" "egendomligheter" ; -- egendomlighet..nn.1
  egendomsaffär_1_N = mkN "egendomsaffär" "egendomsaffärer" ; -- egendomsaffär..nn.1
  egendomsbrott_1_N = mkN "egendomsbrott" neutrum  ; -- egendomsbrott..nn.1
  egendomsfolk_1_N = mkN "egendomsfolk" neutrum  ; -- egendomsfolk..nn.1
  egendomsförsäkring_1_N = mkN "egendomsförsäkring" ; -- egendomsförsäkring..nn.1
  egendomsförsäljning_1_N = mkN "egendomsförsäljning" ; -- egendomsförsäljning..nn.1
  egendomsgemenskap_1_N = mkN "egendomsgemenskap" ; -- egendomsgemenskap..nn.1
  egendomsköp_1_N = mkN "egendomsköp" neutrum  ; -- egendomsköp..nn.1
  egendomslös_1_A = mkA "egendomslös" ; -- egendomslös..av.1
  egendomslöshet_1_N = mkN "egendomslöshet" ; -- egendomslöshet..nn.1
  egenfrekvens_1_N = mkN "egenfrekvens" "egenfrekvenser" ; -- egenfrekvens..nn.1
  egenhet_1_N = mkN "egenhet" "egenheter" ; -- egenhet..nn.1
  egenhändig_1_A = mkA "egenhändig" ; -- egenhändig..av.1
  egenhändighet_1_N = mkN "egenhändighet" ; -- egenhändighet..nn.1
  egenintresse_1_N = mkN "egenintresse" ; -- egenintresse..nn.1
  egenkomponerad_1_A = mkA "egenkomponerad" ; -- egenkomponerad..av.1
  egenkonstruerad_1_A = mkA "egenkonstruerad" ; -- egenkonstruerad..av.1
  egenkär_1_A = mkA "egenkär" ; -- egenkär..av.1
  egenkärlek_1_N = mkN "egenkärlek" ; -- egenkärlek..nn.1
  egenmäktig_1_A = mkA "egenmäktig" ; -- egenmäktig..av.1
  egenmäktighet_1_N = mkN "egenmäktighet" ; -- egenmäktighet..nn.1
  egennamn_1_N = mkN "egennamn" neutrum  ; -- egennamn..nn.1
  egennytta_1_N = mkN "egennytta" ; -- egennytta..nn.1
  egennyttig_1_A = mkA "egennyttig" ; -- egennyttig..av.1
  egennyttighet_1_N = mkN "egennyttighet" ; -- egennyttighet..nn.1
  egenodlad_1_A = mkA "egenodlad" ; -- egenodlad..av.1
  egenproducerad_1_A = mkA "egenproducerad" ; -- egenproducerad..av.1
  egenremiss_1_N = mkN "egenremiss" "egenremisser" ; -- egenremiss..nn.1
  egenrättfärdig_1_A = mkA "egenrättfärdig" ; -- egenrättfärdig..av.1
  egenrättfärdighet_1_N = mkN "egenrättfärdighet" ; -- egenrättfärdighet..nn.1
  egenrådig_1_A = mkA "egenrådig" ; -- egenrådig..av.1
  egenrådighet_1_N = mkN "egenrådighet" ; -- egenrådighet..nn.1
  egenrörelse_1_N = mkN "egenrörelse" utrum  ; -- egenrörelse..nn.1
  egensinne_1_N = mkN "egensinne" ; -- egensinne..nn.1
  egensinnig_1_A = mkA "egensinnig" ; -- egensinnig..av.1
  egensinnighet_1_N = mkN "egensinnighet" ; -- egensinnighet..nn.1
  egenskap_1_N = mkN "egenskap" "egenskaper" ; -- egenskap..nn.1
  egenskapsgenitiv_1_N = mkN "egenskapsgenitiv" "egenskapsgenitiver" ; -- egenskapsgenitiv..nn.1
  egenskapsord_1_N = mkN "egenskapsord" neutrum  ; -- egenskapsord..nn.1
  egensvänga_1_V = mkV "egensvänger" ; -- egensvänga..vb.1
  egensvängande_1_N = mkN "egensvängande" ; -- egensvängande..nn.1
  egensvängning_1_N = mkN "egensvängning" ; -- egensvängning..nn.1
  egentid_1_N = mkN "egentid" ; -- egentid..nn.1
  egentillverkad_1_A = mkA "egentillverkad" ; -- egentillverkad..av.1
  egentlig_1_A = mkA "egentlig" ; -- egentlig..av.1
  egentligen_1_Adv = mkAdv "egentligen" ; -- egentligen..ab.1
  egenvarm_1_A = mkA "egenvarm" ; -- egenvarm..av.1
  egenvärde_1_N = mkN "egenvärde" ; -- egenvärde..nn.1
  egg_1_N = mkN "egg" ; -- egg..nn.1
  egga_1_V = mkV "eggar" ; -- egga..vb.1
  eggande_1_N = mkN "eggande" ; -- eggande..nn.1
  eggelse_1_N = mkN "eggelse" "eggelser" ; -- eggelse..nn.1
  eggjärn_1_N = mkN "eggjärn" neutrum  ; -- eggjärn..nn.1
  eggvapen_1_N = mkN "eggvapen" "eggvapnet" "eggvapen" "eggvapnen" ; -- eggvapen..nn.1
  eggvass_1_A = mkA "eggvass" ; -- eggvass..av.1
  eggverktyg_1_N = mkN "eggverktyg" neutrum  ; -- eggverktyg..nn.1
  egid_1_N = mkN "egid" ; -- egid..nn.1
  egnahem_1_N = mkN "egnahem" "egnahemmet" "egnahem" "egnahemmen" ; -- egnahem..nn.1
  egoboosta_1_V = mkV "egoboostar" ; -- egoboosta..vb.1
  egoboostande_1_N = mkN "egoboostande" ; -- egoboostande..nn.1
  egoboostning_1_N = mkN "egoboostning" ; -- egoboostning..nn.1
  egocentricitet_1_N = mkN "egocentricitet" "egocentriciteter" ; -- egocentricitet..nn.1
  egocentriker_1_N = mkN "egocentriker" "egocentrikern" "egocentriker" "egocentrikerna" ; -- egocentriker..nn.1
  egocentrisk_1_A = mkA "egocentrisk" ; -- egocentrisk..av.1
  egoism_1_N = mkN "egoism" "egoismer" ; -- egoism..nn.1
  egoist_1_N = mkN "egoist" "egoister" ; -- egoist..nn.1
  egoistisk_1_A = mkA "egoistisk" ; -- egoistisk..av.1
  egotism_1_N = mkN "egotism" "egotismer" ; -- egotism..nn.1
  egotripp_1_N = mkN "egotripp" ; -- egotripp..nn.1
  egotrippad_1_A = mkA "egotrippad" ; -- egotrippad..av.1
  egotrippare_1_N = mkN "egotrippare" utrum  ; -- egotrippare..nn.1
  egypter_1_N = mkN "egypter" "egyptern" "egypter" "egypterna" ; -- egypter..nn.1
  egyptienne_1_N = mkN "egyptienne" ; -- egyptienne..nn.1
  egyptier_1_N = mkN "egyptier" "egyptiern" "egyptier" "egyptierna" ; -- egyptier..nn.1
  egyptisk_1_A = mkA "egyptisk" ; -- egyptisk..av.1
  egyptiska_1_N = mkN "egyptiska" ; -- egyptiska..nn.1
  egyptiska_2_N = mkN "egyptiska" ; -- egyptiska..nn.2
  egyptolog_1_N = mkN "egyptolog" "egyptologer" ; -- egyptolog..nn.1
  egyptologi_1_N = mkN "egyptologi" ; -- egyptologi..nn.1
  egyptomani_1_N = mkN "egyptomani" ; -- egyptomani..nn.1
  ehec_smitta_1_N = mkN "ehec-smitta" ; -- ehec-smitta..nn.1
  ehec_1_N = mkN "ehec" ; -- ehec..nn.1
  eidetik_1_N = mkN "eidetik" ; -- eidetik..nn.1
  eidetisk_1_A = mkA "eidetisk" ; -- eidetisk..av.1
  einsteinium_1_N = mkN "einsteinium" neutrum  ; -- einsteinium..nn.1
  einsteinsk_1_A = mkA "einsteinsk" ; -- einsteinsk..av.1
  ej_1_Adv = mkAdv "ej" ; -- ej..ab.1
  ejakulat_1_N = mkN "ejakulat" neutrum  ; -- ejakulat..nn.1
  ejakulation_1_N = mkN "ejakulation" ; -- ejakulation..nn.1
  ejakulera_1_V = mkV "ejakulerar" ; -- ejakulera..vb.1
  ejakulerande_1_N = mkN "ejakulerande" ; -- ejakulerande..nn.1
  ejakulering_1_N = mkN "ejakulering" ; -- ejakulering..nn.1
  ejder_1_N = mkN "ejder" ; -- ejder..nn.1
  ejderdun_1_N = mkN "ejderdun" neutrum  ; -- ejderdun..nn.1
  ejderdunskudde_1_N = mkN "ejderdunskudde" utrum  ; -- ejderdunskudde..nn.1
  ejderhona_1_N = mkN "ejderhona" ; -- ejderhona..nn.1
  ejderunge_1_N = mkN "ejderunge" utrum  ; -- ejderunge..nn.1
  ejektor_1_N = mkN "ejektor" "ejektorer" ; -- ejektor..nn.1
  ek_1_N = mkN "ek" ; -- ek..nn.1
  eka_1_N = mkN "eka" ; -- eka..nn.1
  eka_1_V = mkV "ekar" ; -- eka..vb.1
  eka_2_V = mkV "ekar" ; -- eka..vb.2
  ekande_1_N = mkN "ekande" ; -- ekande..nn.1
  ekavverkning_1_N = mkN "ekavverkning" ; -- ekavverkning..nn.1
  ekavverkningsförbud_1_N = mkN "ekavverkningsförbud" neutrum  ; -- ekavverkningsförbud..nn.1
  ekbacke_1_N = mkN "ekbacke" utrum  ; -- ekbacke..nn.1
  ekbock_1_N = mkN "ekbock" ; -- ekbock..nn.1
  ekdörr_1_N = mkN "ekdörr" ; -- ekdörr..nn.1
  eke_1_N = mkN "eke" ; -- eke..nn.1
  eker_1_N = mkN "eker" ; -- eker..nn.1
  ekfat_1_N = mkN "ekfat" neutrum  ; -- ekfat..nn.1
  ekfatslagra_1_V = mkV "ekfatslagrar" ; -- ekfatslagra..vb.1
  ekfatslagrande_1_N = mkN "ekfatslagrande" ; -- ekfatslagrande..nn.1
  ekipage_1_N = mkN "ekipage" "ekipaget" "ekipage" "ekipagen" ; -- ekipage..nn.1
  ekipera_1_V = mkV "ekiperar" ; -- ekipera..vb.1
  ekiperande_1_N = mkN "ekiperande" ; -- ekiperande..nn.1
  ekiperbar_1_A = mkA "ekiperbar" ; -- ekiperbar..av.1
  ekiperbarhet_1_N = mkN "ekiperbarhet" ; -- ekiperbarhet..nn.1
  ekipering_1_N = mkN "ekipering" ; -- ekipering..nn.1
  ekiperingsaffär_1_N = mkN "ekiperingsaffär" "ekiperingsaffärer" ; -- ekiperingsaffär..nn.1
  ekivok_1_A = mkA "ekivok" ; -- ekivok..av.1
  eklampsi_1_N = mkN "eklampsi" "eklampsier" ; -- eklampsi..nn.1
  eklatant_1_A = mkA "eklatant" "eklatant" ; -- eklatant..av.1
  eklatera_1_V = mkV "eklaterar" ; -- eklatera..vb.1
  eklaterande_1_N = mkN "eklaterande" ; -- eklaterande..nn.1
  eklaterbar_1_A = mkA "eklaterbar" ; -- eklaterbar..av.1
  eklaterbarhet_1_N = mkN "eklaterbarhet" ; -- eklaterbarhet..nn.1
  eklatering_1_N = mkN "eklatering" ; -- eklatering..nn.1
  eklatt_1_A = mkA "eklatt" ; -- eklatt..av.1
  eklekticism_1_N = mkN "eklekticism" "eklekticismer" ; -- eklekticism..nn.1
  eklektiker_1_N = mkN "eklektiker" "eklektikern" "eklektiker" "eklektikerna" ; -- eklektiker..nn.1
  eklektisk_1_A = mkA "eklektisk" ; -- eklektisk..av.1
  eklips_1_N = mkN "eklips" "eklipser" ; -- eklips..nn.1
  ekliptika_1_N = mkN "ekliptika" ; -- ekliptika..nn.1
  eklog_1_N = mkN "eklog" "ekloger" ; -- eklog..nn.1
  eklut_1_N = mkN "eklut" ; -- eklut..nn.1
  eklärera_1_V = mkV "eklärerar" ; -- eklärera..vb.1
  eklärerande_1_N = mkN "eklärerande" ; -- eklärerande..nn.1
  eklärerbar_1_A = mkA "eklärerbar" ; -- eklärerbar..av.1
  eklärerbarhet_1_N = mkN "eklärerbarhet" ; -- eklärerbarhet..nn.1
  eklärering_1_N = mkN "eklärering" ; -- eklärering..nn.1
  eklöv_1_N = mkN "eklöv" neutrum  ; -- eklöv..nn.1
  eko_porr_1_N = mkN "eko-porr" ; -- eko-porr..nn.1
  eko_1_N = mkN "eko" "ekot" "ekon" "ekona" ; -- eko..nn.1
  ekoaktivism_1_N = mkN "ekoaktivism" ; -- ekoaktivism..nn.1
  ekoaktivist_1_N = mkN "ekoaktivist" "ekoaktivister" ; -- ekoaktivist..nn.1
  ekobrott_1_N = mkN "ekobrott" neutrum  ; -- ekobrott..nn.1
  ekofascistisk_1_A = mkA "ekofascistisk" ; -- ekofascistisk..av.1
  ekokammare_1_N = mkN "ekokammare" "ekokammaren" "ekokammare" "ekokamrarna" ; -- ekokammare..nn.1
  ekollon_1_N = mkN "ekollon" neutrum  ; -- ekollon..nn.1
  ekolobby_1_N = mkN "ekolobby" "ekolobbyer" ; -- ekolobby..nn.1
  ekolod_1_N = mkN "ekolod" neutrum  ; -- ekolod..nn.1
  ekoloda_1_V = mkV "ekolodar" ; -- ekoloda..vb.1
  ekolodande_1_N = mkN "ekolodande" ; -- ekolodande..nn.1
  ekolog_1_N = mkN "ekolog" "ekologer" ; -- ekolog..nn.1
  ekologi_1_N = mkN "ekologi" ; -- ekologi..nn.1
  ekologisk_1_A = mkA "ekologisk" ; -- ekologisk..av.1
  ekonom_1_N = mkN "ekonom" "ekonomer" ; -- ekonom..nn.1
  ekonometri_1_N = mkN "ekonometri" ; -- ekonometri..nn.1
  ekonomexamen_1_N = mkN "ekonomexamen" "ekonomexamen" "ekonomexamina" "ekonomexamina" ; -- ekonomexamen..nn.1
  ekonomi_1_N = mkN "ekonomi" "ekonomier" ; -- ekonomi..nn.1
  ekonomiansvarig_1_A = mkA "ekonomiansvarig" ; -- ekonomiansvarig..av.1
  ekonomiavdelning_1_N = mkN "ekonomiavdelning" ; -- ekonomiavdelning..nn.1
  ekonomibiträde_1_N = mkN "ekonomibiträde" ; -- ekonomibiträde..nn.1
  ekonomibrev_1_N = mkN "ekonomibrev" neutrum  ; -- ekonomibrev..nn.1
  ekonomibyggnad_1_N = mkN "ekonomibyggnad" "ekonomibyggnader" ; -- ekonomibyggnad..nn.1
  ekonomichef_1_N = mkN "ekonomichef" "ekonomichefer" ; -- ekonomichef..nn.1
  ekonomie_1_A = mkA "ekonomie" ; -- ekonomie..av.1
  ekonomiföreståndare_1_N = mkN "ekonomiföreståndare" utrum  ; -- ekonomiföreståndare..nn.1
  ekonomiförpackning_1_N = mkN "ekonomiförpackning" ; -- ekonomiförpackning..nn.1
  ekonomiförvaltare_1_N = mkN "ekonomiförvaltare" utrum  ; -- ekonomiförvaltare..nn.1
  ekonomiklass_1_N = mkN "ekonomiklass" ; -- ekonomiklass..nn.1
  ekonomikrönikör_1_N = mkN "ekonomikrönikör" "ekonomikrönikörer" ; -- ekonomikrönikör..nn.1
  ekonomilära_1_N = mkN "ekonomilära" ; -- ekonomilära..nn.1
  ekonomipaket_1_N = mkN "ekonomipaket" neutrum  ; -- ekonomipaket..nn.1
  ekonomipersonal_1_N = mkN "ekonomipersonal" ; -- ekonomipersonal..nn.1
  ekonomirätt_1_N = mkN "ekonomirätt" ; -- ekonomirätt..nn.1
  ekonomisera_1_V = mkV "ekonomiserar" ; -- ekonomisera..vb.1
  ekonomiserande_1_N = mkN "ekonomiserande" ; -- ekonomiserande..nn.1
  ekonomiserbar_1_A = mkA "ekonomiserbar" ; -- ekonomiserbar..av.1
  ekonomiserbarhet_1_N = mkN "ekonomiserbarhet" ; -- ekonomiserbarhet..nn.1
  ekonomisering_1_N = mkN "ekonomisering" ; -- ekonomisering..nn.1
  ekonomisk_politisk_1_A = mkA "ekonomisk-politisk" ; -- ekonomisk-politisk..av.1
  ekonomisk_1_A = mkA "ekonomisk" ; -- ekonomisk..av.1
  ekonomisk_2_A = mkA "ekonomisk" ; -- ekonomisk..av.2
  ekonomiskpolitisk_1_A = mkA "ekonomiskpolitisk" ; -- ekonomiskpolitisk..av.1
  ekonomiskt_politisk_1_A = mkA "ekonomiskt-politisk" ; -- ekonomiskt-politisk..av.1
  ekonomisktpolitisk_1_A = mkA "ekonomisktpolitisk" ; -- ekonomisktpolitisk..av.1
  ekonomiutbildning_1_N = mkN "ekonomiutbildning" ; -- ekonomiutbildning..nn.1
  ekonomlinje_1_N = mkN "ekonomlinje" "ekonomlinjer" ; -- ekonomlinje..nn.1
  ekonomutbildning_1_N = mkN "ekonomutbildning" ; -- ekonomutbildning..nn.1
  ekoodlad_1_A = mkA "ekoodlad" ; -- ekoodlad..av.1
  ekoporr_1_N = mkN "ekoporr" ; -- ekoporr..nn.1
  ekoradio_1_N = mkN "ekoradio" "ekoradior" ; -- ekoradio..nn.1
  ekorrbär_1_N = mkN "ekorrbär" neutrum  ; -- ekorrbär..nn.1
  ekorrdjur_1_N = mkN "ekorrdjur" neutrum  ; -- ekorrdjur..nn.1
  ekorre_1_N = mkN "ekorre" utrum  ; -- ekorre..nn.1
  ekorrhjul_1_N = mkN "ekorrhjul" neutrum  ; -- ekorrhjul..nn.1
  ekorrliknande_1_A = mkA "ekorrliknande" ; -- ekorrliknande..av.1
  ekorröd_1_A = mkA "ekorröd" "ekorrött" ; -- ekorröd..av.1
  ekosystem_1_N = mkN "ekosystem" neutrum  ; -- ekosystem..nn.1
  ekoturist_1_N = mkN "ekoturist" "ekoturister" ; -- ekoturist..nn.1
  ekotyp_1_N = mkN "ekotyp" "ekotyper" ; -- ekotyp..nn.1
  ekovin_1_N = mkN "ekovin" "ekovinet" "ekoviner" "ekovinerna" ; -- ekovin..nn.1
  ekoxe_1_N = mkN "ekoxe" utrum  ; -- ekoxe..nn.1
  ekrin_1_A = mkA "ekrin" ; -- ekrin..av.1
  eksem_1_N = mkN "eksem" neutrum  ; -- eksem..nn.1
  ekskog_1_N = mkN "ekskog" ; -- ekskog..nn.1
  ekspinnare_1_N = mkN "ekspinnare" utrum  ; -- ekspinnare..nn.1
  ekstock_1_N = mkN "ekstock" ; -- ekstock..nn.1
  ektoderm_1_N = mkN "ektoderm" neutrum  ; -- ektoderm..nn.1
  ektomi_1_N = mkN "ektomi" "ektomier" ; -- ektomi..nn.1
  ekumenik_1_N = mkN "ekumenik" ; -- ekumenik..nn.1
  ekumenisk_1_A = mkA "ekumenisk" ; -- ekumenisk..av.1
  ekumenism_1_N = mkN "ekumenism" "ekumenismer" ; -- ekumenism..nn.1
  ekvation_1_N = mkN "ekvation" ; -- ekvation..nn.1
  ekvatorial_1_A = mkA "ekvatorial" ; -- ekvatorial..av.1
  ekvatorialbälte_1_N = mkN "ekvatorialbälte" ; -- ekvatorialbälte..nn.1
  ekvatorialguinean_1_N = mkN "ekvatorialguinean" "ekvatorialguineaner" ; -- ekvatorialguinean..nn.1
  ekvatorialguineansk_1_A = mkA "ekvatorialguineansk" ; -- ekvatorialguineansk..av.1
  ekvatorialguineanska_1_N = mkN "ekvatorialguineanska" ; -- ekvatorialguineanska..nn.1
  ekvatorialström_1_N = mkN "ekvatorialström" "ekvatorialströmmen" "ekvatorialströmmar" "ekvatorialströmmarna" ; -- ekvatorialström..nn.1
  ekvatorialzon_1_N = mkN "ekvatorialzon" "ekvatorialzoner" ; -- ekvatorialzon..nn.1
  ekvatoriell_1_A = mkA "ekvatoriell" ; -- ekvatoriell..av.1
  ekvatorshöjd_1_N = mkN "ekvatorshöjd" ; -- ekvatorshöjd..nn.1
  ekvatorsplan_1_N = mkN "ekvatorsplan" neutrum  ; -- ekvatorsplan..nn.1
  ekvecklare_1_N = mkN "ekvecklare" utrum  ; -- ekvecklare..nn.1
  ekvidistans_1_N = mkN "ekvidistans" "ekvidistanser" ; -- ekvidistans..nn.1
  ekvidistant_1_A = mkA "ekvidistant" "ekvidistant" ; -- ekvidistant..av.1
  ekvilibrera_1_V = mkV "ekvilibrerar" ; -- ekvilibrera..vb.1
  ekvilibrerande_1_N = mkN "ekvilibrerande" ; -- ekvilibrerande..nn.1
  ekvilibrist_1_N = mkN "ekvilibrist" "ekvilibrister" ; -- ekvilibrist..nn.1
  ekvilibristik_1_N = mkN "ekvilibristik" ; -- ekvilibristik..nn.1
  ekvilibristisk_1_A = mkA "ekvilibristisk" ; -- ekvilibristisk..av.1
  ekvilibrium_1_N = mkN "ekvilibrium" "ekvilibriet" "ekvilibrier" "ekvilibrierna" ; -- ekvilibrium..nn.1
  ekvipotentiallinje_1_N = mkN "ekvipotentiallinje" "ekvipotentiallinjer" ; -- ekvipotentiallinje..nn.1
  ekvipotentialyta_1_N = mkN "ekvipotentialyta" ; -- ekvipotentialyta..nn.1
  ekvirke_1_N = mkN "ekvirke" ; -- ekvirke..nn.1
  ekvivalens_1_N = mkN "ekvivalens" ; -- ekvivalens..nn.1
  ekvivalent_1_A = mkA "ekvivalent" "ekvivalent" ; -- ekvivalent..av.1
  ekvivalent_1_N = mkN "ekvivalent" "ekvivalenter" ; -- ekvivalent..nn.1
  ekvivalentvikt_1_N = mkN "ekvivalentvikt" "ekvivalentvikter" ; -- ekvivalentvikt..nn.1
  el_1_N = mkN "el" ; -- el..nn.1
  elaborera_1_V = mkV "elaborerar" ; -- elaborera..vb.1
  elaborerande_1_N = mkN "elaborerande" ; -- elaborerande..nn.1
  elaborerbar_1_A = mkA "elaborerbar" ; -- elaborerbar..av.1
  elaborerbarhet_1_N = mkN "elaborerbarhet" ; -- elaborerbarhet..nn.1
  elaborering_1_N = mkN "elaborering" ; -- elaborering..nn.1
  elak_1_A = mkA "elak" ; -- elak..av.1
  elakartad_1_A = mkA "elakartad" ; -- elakartad..av.1
  elakhet_1_N = mkN "elakhet" "elakheter" ; -- elakhet..nn.1
  elaking_1_N = mkN "elaking" ; -- elaking..nn.1
  elallergi_1_N = mkN "elallergi" "elallergier" ; -- elallergi..nn.1
  eland_1_N = mkN "eland" "elander" ; -- eland..nn.1
  elandantilop_1_N = mkN "elandantilop" "elandantiloper" ; -- elandantilop..nn.1
  elapparat_1_N = mkN "elapparat" "elapparater" ; -- elapparat..nn.1
  elasticitet_1_N = mkN "elasticitet" "elasticiteter" ; -- elasticitet..nn.1
  elasticitetsgräns_1_N = mkN "elasticitetsgräns" "elasticitetsgränser" ; -- elasticitetsgräns..nn.1
  elastisera_1_V = mkV "elastiserar" ; -- elastisera..vb.1
  elastiserande_1_N = mkN "elastiserande" ; -- elastiserande..nn.1
  elastiserbar_1_A = mkA "elastiserbar" ; -- elastiserbar..av.1
  elastiserbarhet_1_N = mkN "elastiserbarhet" ; -- elastiserbarhet..nn.1
  elastisering_1_N = mkN "elastisering" ; -- elastisering..nn.1
  elastisk_1_A = mkA "elastisk" ; -- elastisk..av.1
  elativ_1_N = mkN "elativ" "elativer" ; -- elativ..nn.1
  elavbrott_1_N = mkN "elavbrott" neutrum  ; -- elavbrott..nn.1
  elavläsning_1_N = mkN "elavläsning" ; -- elavläsning..nn.1
  elbil_1_N = mkN "elbil" ; -- elbil..nn.1
  elbilsförespråkare_1_N = mkN "elbilsförespråkare" utrum  ; -- elbilsförespråkare..nn.1
  elbilspionjär_1_N = mkN "elbilspionjär" "elbilspionjärer" ; -- elbilspionjär..nn.1
  elborste_1_N = mkN "elborste" utrum  ; -- elborste..nn.1
  elbörs_1_N = mkN "elbörs" "elbörser" ; -- elbörs..nn.1
  elchock_1_N = mkN "elchock" "elchocker" ; -- elchock..nn.1
  eld_1_N = mkN "eld" ; -- eld..nn.1
  eld_2_N = mkN "eld" ; -- eld..nn.2
  eld_3_N = mkN "eld" ; -- eld..nn.3
  elda_1_V = mkV "eldar" ; -- elda..vb.1
  eldande_1_N = mkN "eldande" ; -- eldande..nn.1
  eldare_1_N = mkN "eldare" utrum  ; -- eldare..nn.1
  eldavstånd_1_N = mkN "eldavstånd" neutrum  ; -- eldavstånd..nn.1
  eldbegängelse_1_N = mkN "eldbegängelse" "eldbegängelser" ; -- eldbegängelse..nn.1
  eldbrand_1_N = mkN "eldbrand" "eldbränder" ; -- eldbrand..nn.1
  elddisciplin_1_N = mkN "elddisciplin" ; -- elddisciplin..nn.1
  elddon_1_N = mkN "elddon" neutrum  ; -- elddon..nn.1
  elddop_1_N = mkN "elddop" neutrum  ; -- elddop..nn.1
  elddyrkare_1_N = mkN "elddyrkare" utrum  ; -- elddyrkare..nn.1
  eldfara_1_N = mkN "eldfara" ; -- eldfara..nn.1
  eldfarlig_1_A = mkA "eldfarlig" ; -- eldfarlig..av.1
  eldfarlighet_1_N = mkN "eldfarlighet" ; -- eldfarlighet..nn.1
  eldfast_1_A = mkA "eldfast" "eldfast" ; -- eldfast..av.1
  eldfasthet_1_N = mkN "eldfasthet" ; -- eldfasthet..nn.1
  eldfluga_1_N = mkN "eldfluga" ; -- eldfluga..nn.1
  eldfängd_1_A = mkA "eldfängd" "eldfängt" ; -- eldfängd..av.1
  eldfängdhet_1_N = mkN "eldfängdhet" ; -- eldfängdhet..nn.1
  eldgaffel_1_N = mkN "eldgaffel" ; -- eldgaffel..nn.1
  eldgaffelsrak_1_A = mkA "eldgaffelsrak" ; -- eldgaffelsrak..av.1
  eldgivning_1_N = mkN "eldgivning" ; -- eldgivning..nn.1
  eldgnista_1_N = mkN "eldgnista" ; -- eldgnista..nn.1
  eldhandvapen_1_N = mkN "eldhandvapen" "eldhandvapnet" "eldhandvapen" "eldhandvapnen" ; -- eldhandvapen..nn.1
  eldhastighet_1_N = mkN "eldhastighet" "eldhastigheter" ; -- eldhastighet..nn.1
  eldhav_1_N = mkN "eldhav" neutrum  ; -- eldhav..nn.1
  eldhund_1_N = mkN "eldhund" ; -- eldhund..nn.1
  eldhus_1_N = mkN "eldhus" neutrum  ; -- eldhus..nn.1
  eldhärd_1_N = mkN "eldhärd" ; -- eldhärd..nn.1
  eldhärdig_1_A = mkA "eldhärdig" ; -- eldhärdig..av.1
  eldhärdighet_1_N = mkN "eldhärdighet" ; -- eldhärdighet..nn.1
  eldhärja_1_V = mkV "eldhärjar" ; -- eldhärja..vb.1
  eldhärjande_1_N = mkN "eldhärjande" ; -- eldhärjande..nn.1
  eldig_1_A = mkA "eldig" ; -- eldig..av.1
  eldighet_1_N = mkN "eldighet" ; -- eldighet..nn.1
  eldkanal_1_N = mkN "eldkanal" "eldkanaler" ; -- eldkanal..nn.1
  eldkastare_1_N = mkN "eldkastare" utrum  ; -- eldkastare..nn.1
  eldkol_1_N = mkN "eldkol" neutrum  ; -- eldkol..nn.1
  eldkommando_1_N = mkN "eldkommando" "eldkommandot" "eldkommandon" "eldkommandona" ; -- eldkommando..nn.1
  eldkraft_1_N = mkN "eldkraft" ; -- eldkraft..nn.1
  eldkula_1_N = mkN "eldkula" ; -- eldkula..nn.1
  eldkvast_1_N = mkN "eldkvast" ; -- eldkvast..nn.1
  eldledare_1_N = mkN "eldledare" utrum  ; -- eldledare..nn.1
  eldledning_1_N = mkN "eldledning" ; -- eldledning..nn.1
  eldlinje_1_N = mkN "eldlinje" "eldlinjer" ; -- eldlinje..nn.1
  eldning_1_N = mkN "eldning" ; -- eldning..nn.1
  eldningsolja_1_N = mkN "eldningsolja" ; -- eldningsolja..nn.1
  eldorado_1_N = mkN "eldorado" "eldoradot" "eldoradon" "eldoradona" ; -- eldorado..nn.1
  eldpelare_1_N = mkN "eldpelare" utrum  ; -- eldpelare..nn.1
  eldprov_1_N = mkN "eldprov" neutrum  ; -- eldprov..nn.1
  eldredskap_1_N = mkN "eldredskap" neutrum  ; -- eldredskap..nn.1
  eldregn_1_N = mkN "eldregn" neutrum  ; -- eldregn..nn.1
  eldrift_1_N = mkN "eldrift" ; -- eldrift..nn.1
  eldriven_1_A = mkA "eldriven" ; -- eldriven..av.1
  eldrum_1_N = mkN "eldrum" "eldrummet" "eldrum" "eldrummen" ; -- eldrum..nn.1
  eldröd_1_A = mkA "eldröd" "eldrött" ; -- eldröd..av.1
  eldrör_1_N = mkN "eldrör" neutrum  ; -- eldrör..nn.1
  eldsalamander_1_N = mkN "eldsalamander" ; -- eldsalamander..nn.1
  eldsats_1_N = mkN "eldsats" "eldsatser" ; -- eldsats..nn.1
  eldsdyrkare_1_N = mkN "eldsdyrkare" utrum  ; -- eldsdyrkare..nn.1
  eldsignal_1_N = mkN "eldsignal" "eldsignaler" ; -- eldsignal..nn.1
  eldsignalering_1_N = mkN "eldsignalering" ; -- eldsignalering..nn.1
  eldsjäl_1_N = mkN "eldsjäl" ; -- eldsjäl..nn.1
  eldsken_1_N = mkN "eldsken" neutrum  ; -- eldsken..nn.1
  eldskrift_1_N = mkN "eldskrift" ; -- eldskrift..nn.1
  eldskur_1_N = mkN "eldskur" ; -- eldskur..nn.1
  eldskydd_1_N = mkN "eldskydd" neutrum  ; -- eldskydd..nn.1
  eldsljus_1_N = mkN "eldsljus" neutrum  ; -- eldsljus..nn.1
  eldslukare_1_N = mkN "eldslukare" utrum  ; -- eldslukare..nn.1
  eldsläckare_1_N = mkN "eldsläckare" utrum  ; -- eldsläckare..nn.1
  eldsläckning_1_N = mkN "eldsläckning" ; -- eldsläckning..nn.1
  eldsländare_1_N = mkN "eldsländare" utrum  ; -- eldsländare..nn.1
  eldslåga_1_N = mkN "eldslåga" ; -- eldslåga..nn.1
  eldsmärke_1_N = mkN "eldsmärke" ; -- eldsmärke..nn.1
  eldspruta_1_N = mkN "eldspruta" ; -- eldspruta..nn.1
  eldsprutande_1_A = mkA "eldsprutande" ; -- eldsprutande..av.1
  eldstad_1_N = mkN "eldstad" "eldstäder" ; -- eldstad..nn.1
  eldstod_1_N = mkN "eldstod" "eldstoder" ; -- eldstod..nn.1
  eldstorm_1_N = mkN "eldstorm" ; -- eldstorm..nn.1
  eldstrid_1_N = mkN "eldstrid" "eldstrider" ; -- eldstrid..nn.1
  eldstrimma_1_N = mkN "eldstrimma" ; -- eldstrimma..nn.1
  eldställning_1_N = mkN "eldställning" ; -- eldställning..nn.1
  eldstål_1_N = mkN "eldstål" neutrum  ; -- eldstål..nn.1
  eldsvåda_1_N = mkN "eldsvåda" ; -- eldsvåda..nn.1
  eldsvådetillbud_1_N = mkN "eldsvådetillbud" neutrum  ; -- eldsvådetillbud..nn.1
  eldsvådeunge_1_N = mkN "eldsvådeunge" utrum  ; -- eldsvådeunge..nn.1
  eldsäker_1_A = mkA "eldsäker" ; -- eldsäker..av.1
  eldsäkerhet_1_N = mkN "eldsäkerhet" ; -- eldsäkerhet..nn.1
  eldsäkra_1_V = mkV "eldsäkrar" ; -- eldsäkra..vb.1
  eldsäkrande_1_N = mkN "eldsäkrande" ; -- eldsäkrande..nn.1
  eldtång_1_N = mkN "eldtång" "eldtänger" ; -- eldtång..nn.1
  eldunderstöd_1_N = mkN "eldunderstöd" neutrum  ; -- eldunderstöd..nn.1
  eldupphör_1_N = mkN "eldupphör" neutrum  ; -- eldupphör..nn.1
  eldupphörorder_1_N = mkN "eldupphörorder" ; -- eldupphörorder..nn.1
  eldvakt_1_N = mkN "eldvakt" "eldvakter" ; -- eldvakt..nn.1
  eldvakta_1_V = mkV "eldvaktar" ; -- eldvakta..vb.1
  eldvaktande_1_N = mkN "eldvaktande" ; -- eldvaktande..nn.1
  eldvaktare_1_N = mkN "eldvaktare" utrum  ; -- eldvaktare..nn.1
  eldvapen_1_N = mkN "eldvapen" "eldvapnet" "eldvapen" "eldvapnen" ; -- eldvapen..nn.1
  eldyta_1_N = mkN "eldyta" ; -- eldyta..nn.1
  eldöverfall_1_N = mkN "eldöverfall" neutrum  ; -- eldöverfall..nn.1
  elefant_1_N = mkN "elefant" "elefanter" ; -- elefant..nn.1
  elefantbete_1_N = mkN "elefantbete" utrum  ; -- elefantbete..nn.1
  elefantgräs_1_N = mkN "elefantgräs" neutrum  ; -- elefantgräs..nn.1
  elefanthanne_1_N = mkN "elefanthanne" utrum  ; -- elefanthanne..nn.1
  elefanthud_1_N = mkN "elefanthud" ; -- elefanthud..nn.1
  elefantinhopp_1_N = mkN "elefantinhopp" neutrum  ; -- elefantinhopp..nn.1
  elefantnäbbmus_1_N = mkN "elefantnäbbmus" "elefantnäbbmusen" "elefantnäbbmöss" "elefantnäbbmössen" ; -- elefantnäbbmus..nn.1
  elefantsjuka_1_N = mkN "elefantsjuka" ; -- elefantsjuka..nn.1
  elefantsköldpadda_1_N = mkN "elefantsköldpadda" ; -- elefantsköldpadda..nn.1
  elefantupplopp_1_N = mkN "elefantupplopp" neutrum  ; -- elefantupplopp..nn.1
  elegans_1_N = mkN "elegans" ; -- elegans..nn.1
  elegant_1_A = mkA "elegant" "elegant" ; -- elegant..av.1
  elegi_1_N = mkN "elegi" "elegier" ; -- elegi..nn.1
  elegisk_1_A = mkA "elegisk" ; -- elegisk..av.1
  elektor_1_N = mkN "elektor" "elektorer" ; -- elektor..nn.1
  elektorsröst_1_N = mkN "elektorsröst" "elektorsröster" ; -- elektorsröst..nn.1
  elektorsval_1_N = mkN "elektorsval" neutrum  ; -- elektorsval..nn.1
  elektricitet_1_N = mkN "elektricitet" "elektriciteter" ; -- elektricitet..nn.1
  elektricitetsmängd_1_N = mkN "elektricitetsmängd" "elektricitetsmängder" ; -- elektricitetsmängd..nn.1
  elektricitetsorsakad_1_A = mkA "elektricitetsorsakad" ; -- elektricitetsorsakad..av.1
  elektricitetsverk_1_N = mkN "elektricitetsverk" neutrum  ; -- elektricitetsverk..nn.1
  elektrificera_1_V = mkV "elektrificerar" ; -- elektrificera..vb.1
  elektrificerande_1_N = mkN "elektrificerande" ; -- elektrificerande..nn.1
  elektrificerbar_1_A = mkA "elektrificerbar" ; -- elektrificerbar..av.1
  elektrificerbarhet_1_N = mkN "elektrificerbarhet" ; -- elektrificerbarhet..nn.1
  elektrificering_1_N = mkN "elektrificering" ; -- elektrificering..nn.1
  elektrifiera_1_V = mkV "elektrifierar" ; -- elektrifiera..vb.1
  elektrifierande_1_N = mkN "elektrifierande" ; -- elektrifierande..nn.1
  elektrifierbar_1_A = mkA "elektrifierbar" ; -- elektrifierbar..av.1
  elektrifierbarhet_1_N = mkN "elektrifierbarhet" ; -- elektrifierbarhet..nn.1
  elektrifiering_1_N = mkN "elektrifiering" ; -- elektrifiering..nn.1
  elektriker_1_N = mkN "elektriker" "elektrikern" "elektriker" "elektrikerna" ; -- elektriker..nn.1
  elektrikermejsel_1_N = mkN "elektrikermejsel" ; -- elektrikermejsel..nn.1
  elektrikermejselsats_1_N = mkN "elektrikermejselsats" "elektrikermejselsatser" ; -- elektrikermejselsats..nn.1
  elektrisera_1_V = mkV "elektriserar" ; -- elektrisera..vb.1
  elektriserande_1_N = mkN "elektriserande" ; -- elektriserande..nn.1
  elektriserbar_1_A = mkA "elektriserbar" ; -- elektriserbar..av.1
  elektriserbarhet_1_N = mkN "elektriserbarhet" ; -- elektriserbarhet..nn.1
  elektrisering_1_N = mkN "elektrisering" ; -- elektrisering..nn.1
  elektrisk_1_A = mkA "elektrisk" ; -- elektrisk..av.1
  elektroakustik_1_N = mkN "elektroakustik" ; -- elektroakustik..nn.1
  elektroakustisk_1_A = mkA "elektroakustisk" ; -- elektroakustisk..av.1
  elektrochock_1_N = mkN "elektrochock" "elektrochocker" ; -- elektrochock..nn.1
  elektrod_1_N = mkN "elektrod" "elektroder" ; -- elektrod..nn.1
  elektrodynamik_1_N = mkN "elektrodynamik" ; -- elektrodynamik..nn.1
  elektroencefalografi_1_N = mkN "elektroencefalografi" "elektroencefalografier" ; -- elektroencefalografi..nn.1
  elektroencefalogram_1_N = mkN "elektroencefalogram" "elektroencefalogrammet" "elektroencefalogram" "elektroencefalogrammen" ; -- elektroencefalogram..nn.1
  elektrofilter_1_N = mkN "elektrofilter" neutrum  ; -- elektrofilter..nn.1
  elektrofor_1_N = mkN "elektrofor" "elektroforen" "elektroforer" "elektroforerna" ; -- elektrofor..nn.1
  elektrofores_1_N = mkN "elektrofores" ; -- elektrofores..nn.1
  elektrofysik_1_N = mkN "elektrofysik" ; -- elektrofysik..nn.1
  elektrofysiologi_1_N = mkN "elektrofysiologi" ; -- elektrofysiologi..nn.1
  elektroingenjör_1_N = mkN "elektroingenjör" "elektroingenjörer" ; -- elektroingenjör..nn.1
  elektrokardiografi_1_N = mkN "elektrokardiografi" "elektrokardiografier" ; -- elektrokardiografi..nn.1
  elektrokardiogram_1_N = mkN "elektrokardiogram" "elektrokardiogrammet" "elektrokardiogram" "elektrokardiogrammen" ; -- elektrokardiogram..nn.1
  elektrokemi_1_N = mkN "elektrokemi" ; -- elektrokemi..nn.1
  elektrokemisk_1_A = mkA "elektrokemisk" ; -- elektrokemisk..av.1
  elektrolys_1_N = mkN "elektrolys" "elektrolyser" ; -- elektrolys..nn.1
  elektrolyt_1_N = mkN "elektrolyt" "elektrolyter" ; -- elektrolyt..nn.1
  elektrolytisk_1_A = mkA "elektrolytisk" ; -- elektrolytisk..av.1
  elektromagnet_1_N = mkN "elektromagnet" "elektromagneter" ; -- elektromagnet..nn.1
  elektromagnetisk_1_A = mkA "elektromagnetisk" ; -- elektromagnetisk..av.1
  elektromagnetism_1_N = mkN "elektromagnetism" "elektromagnetismer" ; -- elektromagnetism..nn.1
  elektromekanisk_1_A = mkA "elektromekanisk" ; -- elektromekanisk..av.1
  elektrometallurgi_1_N = mkN "elektrometallurgi" ; -- elektrometallurgi..nn.1
  elektrometer_1_N = mkN "elektrometer" ; -- elektrometer..nn.1
  elektromotor_1_N = mkN "elektromotor" "elektromotorer" ; -- elektromotor..nn.1
  elektromotorisk_1_A = mkA "elektromotorisk" ; -- elektromotorisk..av.1
  elektron_1_N = mkN "elektron" "elektroner" ; -- elektron..nn.1
  elektron_2_N = mkN "elektron" neutrum  ; -- elektron..nn.2
  elektronbana_1_N = mkN "elektronbana" ; -- elektronbana..nn.1
  elektronblixt_1_N = mkN "elektronblixt" ; -- elektronblixt..nn.1
  elektronegativitet_1_N = mkN "elektronegativitet" "elektronegativiteter" ; -- elektronegativitet..nn.1
  elektronhölje_1_N = mkN "elektronhölje" ; -- elektronhölje..nn.1
  elektronik_1_N = mkN "elektronik" ; -- elektronik..nn.1
  elektronikkedja_1_N = mkN "elektronikkedja" ; -- elektronikkedja..nn.1
  elektronikkomponent_1_N = mkN "elektronikkomponent" "elektronikkomponenter" ; -- elektronikkomponent..nn.1
  elektronikmejsel_1_N = mkN "elektronikmejsel" ; -- elektronikmejsel..nn.1
  elektronisk_1_A = mkA "elektronisk" ; -- elektronisk..av.1
  elektronkamera_1_N = mkN "elektronkamera" ; -- elektronkamera..nn.1
  elektronmikroskop_1_N = mkN "elektronmikroskop" neutrum  ; -- elektronmikroskop..nn.1
  elektronmikroskopbild_1_N = mkN "elektronmikroskopbild" "elektronmikroskopbilder" ; -- elektronmikroskopbild..nn.1
  elektronmikroskopi_1_N = mkN "elektronmikroskopi" "elektronmikroskopier" ; -- elektronmikroskopi..nn.1
  elektronmoln_1_N = mkN "elektronmoln" neutrum  ; -- elektronmoln..nn.1
  elektronneutrino_1_N = mkN "elektronneutrino" "elektronneutrinor" ; -- elektronneutrino..nn.1
  elektronpar_1_N = mkN "elektronpar" neutrum  ; -- elektronpar..nn.1
  elektronparbindning_1_N = mkN "elektronparbindning" ; -- elektronparbindning..nn.1
  elektronrör_1_N = mkN "elektronrör" neutrum  ; -- elektronrör..nn.1
  elektronrörsdiod_1_N = mkN "elektronrörsdiod" "elektronrörsdioder" ; -- elektronrörsdiod..nn.1
  elektronskal_1_N = mkN "elektronskal" neutrum  ; -- elektronskal..nn.1
  elektronstråle_1_N = mkN "elektronstråle" utrum  ; -- elektronstråle..nn.1
  elektronugn_1_N = mkN "elektronugn" ; -- elektronugn..nn.1
  elektronvolt_1_N = mkN "elektronvolt" "elektronvolten" "elektronvolt" "elektronvolten" ; -- elektronvolt..nn.1
  elektroskop_1_N = mkN "elektroskop" neutrum  ; -- elektroskop..nn.1
  elektrostatik_1_N = mkN "elektrostatik" ; -- elektrostatik..nn.1
  elektrostatisk_1_A = mkA "elektrostatisk" ; -- elektrostatisk..av.1
  elektrostriktion_1_N = mkN "elektrostriktion" ; -- elektrostriktion..nn.1
  elektrostål_1_N = mkN "elektrostål" neutrum  ; -- elektrostål..nn.1
  elektrosvag_1_A = mkA "elektrosvag" ; -- elektrosvag..av.1
  elektroteknik_1_N = mkN "elektroteknik" ; -- elektroteknik..nn.1
  elektrotekniker_1_N = mkN "elektrotekniker" "elektroteknikern" "elektrotekniker" "elektroteknikerna" ; -- elektrotekniker..nn.1
  elektroteknisk_1_A = mkA "elektroteknisk" ; -- elektroteknisk..av.1
  elektroterapi_1_N = mkN "elektroterapi" ; -- elektroterapi..nn.1
  elektrotyp_1_N = mkN "elektrotyp" "elektrotyper" ; -- elektrotyp..nn.1
  element_1_N = mkN "element" neutrum  ; -- element..nn.1
  elementa_1_N = mkN "elementa" "elementat" "elementa" "elementana" ; -- elementa..nn.1
  elementaranalys_1_N = mkN "elementaranalys" ; -- elementaranalys..nn.1
  elementarande_1_N = mkN "elementarande" utrum  ; -- elementarande..nn.1
  elementarbok_1_N = mkN "elementarbok" "elementarböcker" ; -- elementarbok..nn.1
  elementarladdning_1_N = mkN "elementarladdning" ; -- elementarladdning..nn.1
  elementarläroverk_1_N = mkN "elementarläroverk" neutrum  ; -- elementarläroverk..nn.1
  elementarpartikel_1_N = mkN "elementarpartikel" ; -- elementarpartikel..nn.1
  elementarskola_1_N = mkN "elementarskola" ; -- elementarskola..nn.1
  elementfärg_1_N = mkN "elementfärg" "elementfärger" ; -- elementfärg..nn.1
  elementpensel_1_N = mkN "elementpensel" ; -- elementpensel..nn.1
  elementär_1_A = mkA "elementär" ; -- elementär..av.1
  elementärkraft_1_N = mkN "elementärkraft" "elementärkrafter" ; -- elementärkraft..nn.1
  elenergi_1_N = mkN "elenergi" ; -- elenergi..nn.1
  elev_1_N = mkN "elev" "elever" ; -- elev..nn.1
  elevation_1_N = mkN "elevation" ; -- elevation..nn.1
  elevator_1_N = mkN "elevator" "elevatorer" ; -- elevator..nn.1
  elevfartyg_1_N = mkN "elevfartyg" neutrum  ; -- elevfartyg..nn.1
  elevhem_1_N = mkN "elevhem" "elevhemmet" "elevhem" "elevhemmen" ; -- elevhem..nn.1
  elevhälsovård_1_N = mkN "elevhälsovård" ; -- elevhälsovård..nn.1
  elevlista_1_N = mkN "elevlista" ; -- elevlista..nn.1
  elevråd_1_N = mkN "elevråd" neutrum  ; -- elevråd..nn.1
  elevskola_1_N = mkN "elevskola" ; -- elevskola..nn.1
  elevunderlag_1_N = mkN "elevunderlag" neutrum  ; -- elevunderlag..nn.1
  elevvård_1_N = mkN "elevvård" ; -- elevvård..nn.1
  elfenben_1_N = mkN "elfenben" neutrum  ; -- elfenben..nn.1
  elfenbensbit_1_N = mkN "elfenbensbit" ; -- elfenbensbit..nn.1
  elfenbensfärgad_1_A = mkA "elfenbensfärgad" ; -- elfenbensfärgad..av.1
  elfenbenspalm_1_N = mkN "elfenbenspalm" "elfenbenspalmer" ; -- elfenbenspalm..nn.1
  elfenbenspapper_1_N = mkN "elfenbenspapper" neutrum  ; -- elfenbenspapper..nn.1
  elfenbenssvärta_1_N = mkN "elfenbenssvärta" ; -- elfenbenssvärta..nn.1
  elfenbenstorn_1_N = mkN "elfenbenstorn" neutrum  ; -- elfenbenstorn..nn.1
  elfenbensvit_1_A = mkA "elfenbensvit" ; -- elfenbensvit..av.1
  elfordon_1_N = mkN "elfordon" neutrum  ; -- elfordon..nn.1
  elfte_1_A = mkA "elfte" ; -- elfte..av.1
  elfteplats_1_N = mkN "elfteplats" "elfteplatser" ; -- elfteplats..nn.1
  elförbrukning_1_N = mkN "elförbrukning" ; -- elförbrukning..nn.1
  elförsörjning_1_N = mkN "elförsörjning" ; -- elförsörjning..nn.1
  elförzinkad_1_A = mkA "elförzinkad" ; -- elförzinkad..av.1
  elgenerator_1_N = mkN "elgenerator" "elgeneratorer" ; -- elgenerator..nn.1
  elgitarr_1_N = mkN "elgitarr" "elgitarrer" ; -- elgitarr..nn.1
  elgräsklippare_1_N = mkN "elgräsklippare" utrum  ; -- elgräsklippare..nn.1
  elhybrid_1_N = mkN "elhybrid" "elhybrider" ; -- elhybrid..nn.1
  elhybridbil_1_N = mkN "elhybridbil" ; -- elhybridbil..nn.1
  elhyvel_1_N = mkN "elhyvel" ; -- elhyvel..nn.1
  elidera_1_V = mkV "eliderar" ; -- elidera..vb.1
  eliderande_1_N = mkN "eliderande" ; -- eliderande..nn.1
  eliderbar_1_A = mkA "eliderbar" ; -- eliderbar..av.1
  eliderbarhet_1_N = mkN "eliderbarhet" ; -- eliderbarhet..nn.1
  elidering_1_N = mkN "elidering" ; -- elidering..nn.1
  elimination_1_N = mkN "elimination" ; -- elimination..nn.1
  eliminera_1_V = mkV "eliminerar" ; -- eliminera..vb.1
  eliminerande_1_N = mkN "eliminerande" ; -- eliminerande..nn.1
  eliminerbar_1_A = mkA "eliminerbar" ; -- eliminerbar..av.1
  eliminerbarhet_1_N = mkN "eliminerbarhet" ; -- eliminerbarhet..nn.1
  eliminering_1_N = mkN "eliminering" ; -- eliminering..nn.1
  elintensiv_1_A = mkA "elintensiv" ; -- elintensiv..av.1
  elisabetansk_1_A = mkA "elisabetansk" ; -- elisabetansk..av.1
  elision_1_N = mkN "elision" ; -- elision..nn.1
  elit_1_N = mkN "elit" "eliter" ; -- elit..nn.1
  elitförband_1_N = mkN "elitförband" neutrum  ; -- elitförband..nn.1
  elitgymnastik_1_N = mkN "elitgymnastik" ; -- elitgymnastik..nn.1
  elitidrott_1_N = mkN "elitidrott" "elitidrotter" ; -- elitidrott..nn.1
  elitidrottsman_1_N = mkN "elitidrottsman" "elitidrottsmannen" "elitidrottsmän" "elitidrottsmännen" ; -- elitidrottsman..nn.1
  elitisk_1_A = mkA "elitisk" ; -- elitisk..av.1
  elitism_1_N = mkN "elitism" "elitismer" ; -- elitism..nn.1
  elitistisk_1_A = mkA "elitistisk" ; -- elitistisk..av.1
  elitkår_1_N = mkN "elitkår" "elitkårer" ; -- elitkår..nn.1
  elitlag_1_N = mkN "elitlag" neutrum  ; -- elitlag..nn.1
  elitmässig_1_A = mkA "elitmässig" ; -- elitmässig..av.1
  elitnivå_1_N = mkN "elitnivå" "elitnivåer" ; -- elitnivå..nn.1
  elitserie_1_N = mkN "elitserie" "elitserier" ; -- elitserie..nn.1
  elitseriemässig_1_A = mkA "elitseriemässig" ; -- elitseriemässig..av.1
  elitsoldat_1_N = mkN "elitsoldat" "elitsoldater" ; -- elitsoldat..nn.1
  elitteori_1_N = mkN "elitteori" "elitteorier" ; -- elitteori..nn.1
  elittrupp_1_N = mkN "elittrupp" "elittrupper" ; -- elittrupp..nn.1
  elittänk_1_N = mkN "elittänk" neutrum  ; -- elittänk..nn.1
  elittänkande_1_N = mkN "elittänkande" ; -- elittänkande..nn.1
  elixir_1_N = mkN "elixir" neutrum  ; -- elixir..nn.1
  eljes_1_Adv = mkAdv "eljes" ; -- eljes..ab.1
  eljest_1_Adv = mkAdv "eljest" ; -- eljest..ab.1
  elkabel_1_N = mkN "elkabel" ; -- elkabel..nn.1
  elkedjesåg_1_N = mkN "elkedjesåg" ; -- elkedjesåg..nn.1
  elkonsumtion_1_N = mkN "elkonsumtion" ; -- elkonsumtion..nn.1
  elkoppling_1_N = mkN "elkoppling" ; -- elkoppling..nn.1
  elkraft_1_N = mkN "elkraft" ; -- elkraft..nn.1
  elkraftsaggregat_1_N = mkN "elkraftsaggregat" neutrum  ; -- elkraftsaggregat..nn.1
  elledning_1_N = mkN "elledning" ; -- elledning..nn.1
  ellips_1_N = mkN "ellips" "ellipser" ; -- ellips..nn.1
  ellipsformad_1_A = mkA "ellipsformad" ; -- ellipsformad..av.1
  ellipsoid_1_N = mkN "ellipsoid" "ellipsoider" ; -- ellipsoid..nn.1
  elliptisk_1_A = mkA "elliptisk" ; -- elliptisk..av.1
  elljus_1_N = mkN "elljus" neutrum  ; -- elljus..nn.1
  elljusslinga_1_N = mkN "elljusslinga" ; -- elljusslinga..nn.1
  elljusspår_1_N = mkN "elljusspår" neutrum  ; -- elljusspår..nn.1
  ellok_1_N = mkN "ellok" neutrum  ; -- ellok..nn.1
  elmanövrerad_1_A = mkA "elmanövrerad" ; -- elmanövrerad..av.1
  elmarknad_1_N = mkN "elmarknad" "elmarknader" ; -- elmarknad..nn.1
  elmotor_1_N = mkN "elmotor" "elmotorer" ; -- elmotor..nn.1
  elmotordrift_1_N = mkN "elmotordrift" ; -- elmotordrift..nn.1
  elmotordriven_1_A = mkA "elmotordriven" ; -- elmotordriven..av.1
  elmseld_1_N = mkN "elmseld" ; -- elmseld..nn.1
  elmutterdragare_1_N = mkN "elmutterdragare" utrum  ; -- elmutterdragare..nn.1
  elmätare_1_N = mkN "elmätare" utrum  ; -- elmätare..nn.1
  elnät_1_N = mkN "elnät" neutrum  ; -- elnät..nn.1
  eloge_1_N = mkN "eloge" "eloger" ; -- eloge..nn.1
  elokvens_1_N = mkN "elokvens" ; -- elokvens..nn.1
  elokvent_1_A = mkA "elokvent" "elokvent" ; -- elokvent..av.1
  elongation_1_N = mkN "elongation" ; -- elongation..nn.1
  eloquentia_1_N = mkN "eloquentia" ; -- eloquentia..nn.1
  elorgel_1_N = mkN "elorgel" ; -- elorgel..nn.1
  eloxera_1_V = mkV "eloxerar" ; -- eloxera..vb.1
  eloxerande_1_N = mkN "eloxerande" ; -- eloxerande..nn.1
  eloxerbar_1_A = mkA "eloxerbar" ; -- eloxerbar..av.1
  eloxerbarhet_1_N = mkN "eloxerbarhet" ; -- eloxerbarhet..nn.1
  eloxering_1_N = mkN "eloxering" ; -- eloxering..nn.1
  elpistol_1_N = mkN "elpistol" "elpistoler" ; -- elpistol..nn.1
  elplatta_1_N = mkN "elplatta" ; -- elplatta..nn.1
  elpris_1_N = mkN "elpris" neutrum  ; -- elpris..nn.1
  elpropp_1_N = mkN "elpropp" ; -- elpropp..nn.1
  elritsa_1_N = mkN "elritsa" ; -- elritsa..nn.1
  elsevir_1_N = mkN "elsevir" "elsevirer" ; -- elsevir..nn.1
  elskandal_1_N = mkN "elskandal" "elskandaler" ; -- elskandal..nn.1
  elskrot_1_N = mkN "elskrot" neutrum  ; -- elskrot..nn.1
  elspis_1_N = mkN "elspis" ; -- elspis..nn.1
  elstolpe_1_N = mkN "elstolpe" utrum  ; -- elstolpe..nn.1
  elström_1_N = mkN "elström" "elströmmen" "elströmmar" "elströmmarna" ; -- elström..nn.1
  elstängsel_1_N = mkN "elstängsel" neutrum  ; -- elstängsel..nn.1
  elstöt_1_N = mkN "elstöt" ; -- elstöt..nn.1
  eltejp_1_N = mkN "eltejp" ; -- eltejp..nn.1
  eludera_1_V = mkV "eluderar" ; -- eludera..vb.1
  eluderande_1_N = mkN "eluderande" ; -- eluderande..nn.1
  eluderbar_1_A = mkA "eluderbar" ; -- eluderbar..av.1
  eluderbarhet_1_N = mkN "eluderbarhet" ; -- eluderbarhet..nn.1
  eludering_1_N = mkN "eludering" ; -- eludering..nn.1
  eluera_1_V = mkV "eluerar" ; -- eluera..vb.1
  eluerande_1_N = mkN "eluerande" ; -- eluerande..nn.1
  eluerbar_1_A = mkA "eluerbar" ; -- eluerbar..av.1
  eluerbarhet_1_N = mkN "eluerbarhet" ; -- eluerbarhet..nn.1
  eluering_1_N = mkN "eluering" ; -- eluering..nn.1
  elusion_1_N = mkN "elusion" ; -- elusion..nn.1
  eluttag_1_N = mkN "eluttag" neutrum  ; -- eluttag..nn.1
  eluvial_1_A = mkA "eluvial" ; -- eluvial..av.1
  eluvium_1_N = mkN "eluvium" ; -- eluvium..nn.1
  elva_1_N = mkN "elva" ; -- elva..nn.1
  elvadimensionell_1_A = mkA "elvadimensionell" ; -- elvadimensionell..av.1
  elvahundratal_1_N = mkN "elvahundratal" neutrum  ; -- elvahundratal..nn.1
  elvamannalag_1_N = mkN "elvamannalag" neutrum  ; -- elvamannalag..nn.1
  elvaårig_1_A = mkA "elvaårig" ; -- elvaårig..av.1
  elvaåring_1_N = mkN "elvaåring" ; -- elvaåring..nn.1
  elvaårsgräns_1_N = mkN "elvaårsgräns" ; -- elvaårsgräns..nn.1
  elvaårsperiod_1_N = mkN "elvaårsperiod" "elvaårsperioder" ; -- elvaårsperiod..nn.1
  elverk_1_N = mkN "elverk" neutrum  ; -- elverk..nn.1
  elvisp_1_N = mkN "elvisp" ; -- elvisp..nn.1
  elvispfabrik_1_N = mkN "elvispfabrik" "elvispfabriker" ; -- elvispfabrik..nn.1
  elvärme_1_N = mkN "elvärme" utrum  ; -- elvärme..nn.1
  elyseisk_1_A = mkA "elyseisk" ; -- elyseisk..av.1
  elzevier_1_N = mkN "elzevier" "elzevierer" ; -- elzevier..nn.1
  elända_1_A = mkA "elända" ; -- elända..av.1
  elände_1_N = mkN "elände" ; -- elände..nn.1
  eländesförutsägelse_1_N = mkN "eländesförutsägelse" "eländesförutsägelser" ; -- eländesförutsägelse..nn.1
  eländesrapportering_1_N = mkN "eländesrapportering" ; -- eländesrapportering..nn.1
  eländesskildring_1_N = mkN "eländesskildring" ; -- eländesskildring..nn.1
  eländig_1_A = mkA "eländig" ; -- eländig..av.1
  eländighet_1_N = mkN "eländighet" ; -- eländighet..nn.1
  elöverkänslig_1_A = mkA "elöverkänslig" ; -- elöverkänslig..av.1
  email_1_N = mkN "email" ; -- email..nn.1
  email_2_N = mkN "email" neutrum  ; -- email..nn.2
  emalj_1_N = mkN "emalj" "emaljer" ; -- emalj..nn.1
  emaljera_1_V = mkV "emaljerar" ; -- emaljera..vb.1
  emaljerande_1_N = mkN "emaljerande" ; -- emaljerande..nn.1
  emaljerbar_1_A = mkA "emaljerbar" ; -- emaljerbar..av.1
  emaljerbarhet_1_N = mkN "emaljerbarhet" ; -- emaljerbarhet..nn.1
  emaljering_1_N = mkN "emaljering" ; -- emaljering..nn.1
  emaljfyllning_1_N = mkN "emaljfyllning" ; -- emaljfyllning..nn.1
  emaljfärg_1_N = mkN "emaljfärg" "emaljfärger" ; -- emaljfärg..nn.1
  emaljglas_1_N = mkN "emaljglas" neutrum  ; -- emaljglas..nn.1
  emaljinläggning_1_N = mkN "emaljinläggning" ; -- emaljinläggning..nn.1
  emaljlack_1_N = mkN "emaljlack" "emaljlacket" "emaljlacker" "emaljlackerna" ; -- emaljlack..nn.1
  emaljmålning_1_N = mkN "emaljmålning" ; -- emaljmålning..nn.1
  emaljplomb_1_N = mkN "emaljplomb" "emaljplomber" ; -- emaljplomb..nn.1
  emaljöga_1_N = mkN "emaljöga" "emaljögat" "emaljögon" "emaljögonen" ; -- emaljöga..nn.1
  emaljör_1_N = mkN "emaljör" "emaljörer" ; -- emaljör..nn.1
  emanation_1_N = mkN "emanation" ; -- emanation..nn.1
  emancipation_1_N = mkN "emancipation" ; -- emancipation..nn.1
  emancipera_1_V = mkV "emanciperar" ; -- emancipera..vb.1
  emanciperande_1_N = mkN "emanciperande" ; -- emanciperande..nn.1
  emanciperbar_1_A = mkA "emanciperbar" ; -- emanciperbar..av.1
  emanciperbarhet_1_N = mkN "emanciperbarhet" ; -- emanciperbarhet..nn.1
  emancipering_1_N = mkN "emancipering" ; -- emancipering..nn.1
  emanera_1_V = mkV "emanerar" ; -- emanera..vb.1
  emanerande_1_N = mkN "emanerande" ; -- emanerande..nn.1
  emanering_1_N = mkN "emanering" ; -- emanering..nn.1
  emballage_1_N = mkN "emballage" "emballaget" "emballage" "emballagen" ; -- emballage..nn.1
  emballera_1_V = mkV "emballerar" ; -- emballera..vb.1
  emballerande_1_N = mkN "emballerande" ; -- emballerande..nn.1
  emballerbar_1_A = mkA "emballerbar" ; -- emballerbar..av.1
  emballerbarhet_1_N = mkN "emballerbarhet" ; -- emballerbarhet..nn.1
  emballering_1_N = mkN "emballering" ; -- emballering..nn.1
  embargo_1_N = mkN "embargo" ; -- embargo..nn.1
  embarkera_1_V = mkV "embarkerar" ; -- embarkera..vb.1
  embarkerande_1_N = mkN "embarkerande" ; -- embarkerande..nn.1
  embarkerbar_1_A = mkA "embarkerbar" ; -- embarkerbar..av.1
  embarkerbarhet_1_N = mkN "embarkerbarhet" ; -- embarkerbarhet..nn.1
  embarkering_1_N = mkN "embarkering" ; -- embarkering..nn.1
  embarras_1_N = mkN "embarras" ; -- embarras..nn.1
  embellera_1_V = mkV "embellerar" ; -- embellera..vb.1
  embellerande_1_N = mkN "embellerande" ; -- embellerande..nn.1
  embellerbar_1_A = mkA "embellerbar" ; -- embellerbar..av.1
  embellerbarhet_1_N = mkN "embellerbarhet" ; -- embellerbarhet..nn.1
  embellering_1_N = mkN "embellering" ; -- embellering..nn.1
  emblem_1_N = mkN "emblem" neutrum  ; -- emblem..nn.1
  emblematik_1_N = mkN "emblematik" ; -- emblematik..nn.1
  emblematisk_1_A = mkA "emblematisk" ; -- emblematisk..av.1
  emblematiskhet_1_N = mkN "emblematiskhet" ; -- emblematiskhet..nn.1
  emboli_1_N = mkN "emboli" "embolier" ; -- emboli..nn.1
  embonpoint_1_N = mkN "embonpoint" ; -- embonpoint..nn.1
  embryo_1_N = mkN "embryo" "embryot" "embryon" "embryona" ; -- embryo..nn.1
  embryolog_1_N = mkN "embryolog" "embryologer" ; -- embryolog..nn.1
  embryologi_1_N = mkN "embryologi" ; -- embryologi..nn.1
  embryonal_1_A = mkA "embryonal" ; -- embryonal..av.1
  embryonisk_1_A = mkA "embryonisk" ; -- embryonisk..av.1
  embryosäck_1_N = mkN "embryosäck" ; -- embryosäck..nn.1
  emellanåt_1_Adv = mkAdv "emellanåt" ; -- emellanåt..ab.1
  emellertid_1_Adv = mkAdv "emellertid" ; -- emellertid..ab.1
  emendation_1_N = mkN "emendation" ; -- emendation..nn.1
  emendera_1_V = mkV "emenderar" ; -- emendera..vb.1
  emenderande_1_N = mkN "emenderande" ; -- emenderande..nn.1
  emenderbar_1_A = mkA "emenderbar" ; -- emenderbar..av.1
  emenderbarhet_1_N = mkN "emenderbarhet" ; -- emenderbarhet..nn.1
  emendering_1_N = mkN "emendering" ; -- emendering..nn.1
  emergent_1_A = mkA "emergent" "emergent" ; -- emergent..av.1
  emeritus_1_N = mkN "emeritus" "emeritus" "emeriti" "emeritina" ; -- emeritus..nn.1
  emfas_1_N = mkN "emfas" ; -- emfas..nn.1
  emfatisk_1_A = mkA "emfatisk" ; -- emfatisk..av.1
  emfysem_1_N = mkN "emfysem" neutrum  ; -- emfysem..nn.1
  emigrant_1_N = mkN "emigrant" "emigranter" ; -- emigrant..nn.1
  emigration_1_N = mkN "emigration" ; -- emigration..nn.1
  emigrera_1_V = mkV "emigrerar" ; -- emigrera..vb.1
  emigrerande_1_N = mkN "emigrerande" ; -- emigrerande..nn.1
  emigrerbar_1_A = mkA "emigrerbar" ; -- emigrerbar..av.1
  emigrerbarhet_1_N = mkN "emigrerbarhet" ; -- emigrerbarhet..nn.1
  emigrering_1_N = mkN "emigrering" ; -- emigrering..nn.1
  eminens_1_N = mkN "eminens" "eminenser" ; -- eminens..nn.1
  eminent_1_A = mkA "eminent" "eminent" ; -- eminent..av.1
  eminenthet_1_N = mkN "eminenthet" ; -- eminenthet..nn.1
  emir_1_N = mkN "emir" "emirer" ; -- emir..nn.1
  emiratier_1_N = mkN "emiratier" "emiratiern" "emiratier" "emiratierna" ; -- emiratier..nn.1
  emiratisk_1_A = mkA "emiratisk" ; -- emiratisk..av.1
  emiratiska_1_N = mkN "emiratiska" ; -- emiratiska..nn.1
  emissarie_1_N = mkN "emissarie" "emissarier" ; -- emissarie..nn.1
  emission_1_N = mkN "emission" ; -- emission..nn.1
  emissionskurs_1_N = mkN "emissionskurs" "emissionskurser" ; -- emissionskurs..nn.1
  emitter_1_N = mkN "emitter" ; -- emitter..nn.1
  emittera_1_V = mkV "emitterar" ; -- emittera..vb.1
  emitterande_1_N = mkN "emitterande" ; -- emitterande..nn.1
  emitterbar_1_A = mkA "emitterbar" ; -- emitterbar..av.1
  emitterbarhet_1_N = mkN "emitterbarhet" ; -- emitterbarhet..nn.1
  emittering_1_N = mkN "emittering" ; -- emittering..nn.1
  emma_1_N = mkN "emma" ; -- emma..nn.1
  emmentaler_1_N = mkN "emmentaler" ; -- emmentaler..nn.1
  emmervete_1_N = mkN "emmervete" ; -- emmervete..nn.1
  emo_1_N = mkN "emo" "emot" "emo" "emon" ; -- emo..nn.1
  emollition_1_N = mkN "emollition" ; -- emollition..nn.1
  emotion_1_N = mkN "emotion" ; -- emotion..nn.1
  emotionalisera_1_V = mkV "emotionaliserar" ; -- emotionalisera..vb.1
  emotionaliserande_1_N = mkN "emotionaliserande" ; -- emotionaliserande..nn.1
  emotionalisering_1_N = mkN "emotionalisering" ; -- emotionalisering..nn.1
  emotionell_1_A = mkA "emotionell" ; -- emotionell..av.1
  emotiv_1_A = mkA "emotiv" ; -- emotiv..av.1
  emotse_1_V = mkV "emotse" "emotsåg" "emotsett" ; -- emotse..vb.1
  emotseende_1_N = mkN "emotseende" ; -- emotseende..nn.1
  emotstå_1_V = mkV "emotstå" "emotstår" "emotstå" "emotstod" "emotstått" "emotstånden" ; -- emotstå..vb.1
  emotstående_1_N = mkN "emotstående" ; -- emotstående..nn.1
  emotta_1_V = mkV "emottaga" "emottog" "emottagit" ; -- emotta..vb.1
  emottagande_1_N = mkN "emottagande" ; -- emottagande..nn.1
  empati_1_N = mkN "empati" ; -- empati..nn.1
  empatibefriad_1_A = mkA "empatibefriad" ; -- empatibefriad..av.1
  empatilös_1_A = mkA "empatilös" ; -- empatilös..av.1
  empatisk_1_A = mkA "empatisk" ; -- empatisk..av.1
  empatistörd_1_A = mkA "empatistörd" "empatistört" ; -- empatistörd..av.1
  empir_1_N = mkN "empir" ; -- empir..nn.1
  empire_1_N = mkN "empire" utrum  ; -- empire..nn.1
  empirestil_1_N = mkN "empirestil" ; -- empirestil..nn.1
  empiri_1_N = mkN "empiri" ; -- empiri..nn.1
  empiriker_1_N = mkN "empiriker" "empirikern" "empiriker" "empirikerna" ; -- empiriker..nn.1
  empirisk_1_A = mkA "empirisk" ; -- empirisk..av.1
  empirism_1_N = mkN "empirism" "empirismer" ; -- empirism..nn.1
  empirist_1_N = mkN "empirist" "empirister" ; -- empirist..nn.1
  empiristisk_1_A = mkA "empiristisk" ; -- empiristisk..av.1
  empyem_1_N = mkN "empyem" neutrum  ; -- empyem..nn.1
  emsersalt_1_N = mkN "emsersalt" neutrum  ; -- emsersalt..nn.1
  emu_1_N = mkN "emu" "emun" "emuer" "emuerna" ; -- emu..nn.1
  emulgera_1_V = mkV "emulgerar" ; -- emulgera..vb.1
  emulgerande_1_N = mkN "emulgerande" ; -- emulgerande..nn.1
  emulgerbar_1_A = mkA "emulgerbar" ; -- emulgerbar..av.1
  emulgerbarhet_1_N = mkN "emulgerbarhet" ; -- emulgerbarhet..nn.1
  emulgering_1_N = mkN "emulgering" ; -- emulgering..nn.1
  emulsion_1_N = mkN "emulsion" ; -- emulsion..nn.1
  emulsionsfärg_1_N = mkN "emulsionsfärg" "emulsionsfärger" ; -- emulsionsfärg..nn.1
  emulsionssprängämne_1_N = mkN "emulsionssprängämne" ; -- emulsionssprängämne..nn.1
  en_tous_cas_1_N = mkN "en-tous-cas" ; -- en-tous-cas..nn.1
  en_1_Adv = mkAdv "en" ; -- en..ab.1
  en_1_N = mkN "en" "enen" "enar" "enarna" ; -- en..nn.1
  ena_1_V = mkV "enar" ; -- ena..vb.1
  enahanda_1_A = mkA "enahanda" ; -- enahanda..av.1
  enaktare_1_N = mkN "enaktare" utrum  ; -- enaktare..nn.1
  enande_1_N = mkN "enande" ; -- enande..nn.1
  enarmad_1_A = mkA "enarmad" ; -- enarmad..av.1
  enarmig_1_A = mkA "enarmig" ; -- enarmig..av.1
  enarådande_1_A = mkA "enarådande" ; -- enarådande..av.1
  enastående_1_A = mkA "enastående" ; -- enastående..av.1
  enaxlad_1_A = mkA "enaxlad" ; -- enaxlad..av.1
  enaxlig_1_A = mkA "enaxlig" ; -- enaxlig..av.1
  enaxlighet_1_N = mkN "enaxlighet" ; -- enaxlighet..nn.1
  enbacke_1_N = mkN "enbacke" utrum  ; -- enbacke..nn.1
  enbart_1_Adv = mkAdv "enbart" ; -- enbart..ab.1
  enbasisk_1_A = mkA "enbasisk" ; -- enbasisk..av.1
  enbent_1_A = mkA "enbent" "enbent" ; -- enbent..av.1
  enbenthet_1_N = mkN "enbenthet" ; -- enbenthet..nn.1
  enbet_1_N = mkN "enbet" neutrum  ; -- enbet..nn.1
  enbladig_1_A = mkA "enbladig" ; -- enbladig..av.1
  enblommig_1_A = mkA "enblommig" ; -- enblommig..av.1
  enbuske_1_N = mkN "enbuske" utrum  ; -- enbuske..nn.1
  enbyggare_1_N = mkN "enbyggare" utrum  ; -- enbyggare..nn.1
  enbäddsrum_1_N = mkN "enbäddsrum" "enbäddsrummet" "enbäddsrum" "enbäddsrummen" ; -- enbäddsrum..nn.1
  enbär_1_N = mkN "enbär" neutrum  ; -- enbär..nn.1
  enbärsbrännvin_1_N = mkN "enbärsbrännvin" neutrum  ; -- enbärsbrännvin..nn.1
  encefalit_1_N = mkN "encefalit" "encefaliter" ; -- encefalit..nn.1
  encefalografi_1_N = mkN "encefalografi" "encefalografier" ; -- encefalografi..nn.1
  encellig_1_A = mkA "encellig" ; -- encellig..av.1
  encellighet_1_N = mkN "encellighet" ; -- encellighet..nn.1
  encyklika_1_N = mkN "encyklika" ; -- encyklika..nn.1
  encyklopedi_1_N = mkN "encyklopedi" "encyklopedier" ; -- encyklopedi..nn.1
  encyklopedisk_1_A = mkA "encyklopedisk" ; -- encyklopedisk..av.1
  encyklopedist_1_N = mkN "encyklopedist" "encyklopedister" ; -- encyklopedist..nn.1
  endagsbesök_1_N = mkN "endagsbesök" neutrum  ; -- endagsbesök..nn.1
  endast_1_Adv = mkAdv "endast" ; -- endast..ab.1
  endaste_1_A = mkA "endaste" ; -- endaste..av.1
  endels_1_Adv = mkAdv "endels" ; -- endels..ab.1
  endemi_1_N = mkN "endemi" "endemier" ; -- endemi..nn.1
  endemisk_1_A = mkA "endemisk" ; -- endemisk..av.1
  endera_1_Adv = mkAdv "endera" ; -- endera..ab.1
  endimensionell_1_A = mkA "endimensionell" ; -- endimensionell..av.1
  endiv_1_N = mkN "endiv" "endiver" ; -- endiv..nn.1
  endogen_1_A = mkA "endogen" "endogent" ; -- endogen..av.1
  endokrin_1_A = mkA "endokrin" ; -- endokrin..av.1
  endokrinolog_1_N = mkN "endokrinolog" "endokrinologer" ; -- endokrinolog..nn.1
  endokrinologi_1_N = mkN "endokrinologi" ; -- endokrinologi..nn.1
  endonym_1_N = mkN "endonym" "endonymer" ; -- endonym..nn.1
  endorfin_1_N = mkN "endorfin" "endorfinet" "endorfiner" "endorfinerna" ; -- endorfin..nn.1
  endoskopi_1_N = mkN "endoskopi" "endoskopier" ; -- endoskopi..nn.1
  endoskopisk_1_A = mkA "endoskopisk" ; -- endoskopisk..av.1
  endossat_1_N = mkN "endossat" "endossater" ; -- endossat..nn.1
  endossemang_1_N = mkN "endossemang" neutrum  ; -- endossemang..nn.1
  endossement_1_N = mkN "endossement" neutrum  ; -- endossement..nn.1
  endossent_1_N = mkN "endossent" "endossenter" ; -- endossent..nn.1
  endossera_1_V = mkV "endosserar" ; -- endossera..vb.1
  endosserande_1_N = mkN "endosserande" ; -- endosserande..nn.1
  endosserbar_1_A = mkA "endosserbar" ; -- endosserbar..av.1
  endosserbarhet_1_N = mkN "endosserbarhet" ; -- endosserbarhet..nn.1
  endossering_1_N = mkN "endossering" ; -- endossering..nn.1
  endotermisk_1_A = mkA "endotermisk" ; -- endotermisk..av.1
  endräkt_1_N = mkN "endräkt" ; -- endräkt..nn.1
  endräktig_1_A = mkA "endräktig" ; -- endräktig..av.1
  ene_1_N = mkN "ene" ; -- ene..nn.1
  energi_1_N = mkN "energi" "energier" ; -- energi..nn.1
  energialternativ_1_N = mkN "energialternativ" neutrum  ; -- energialternativ..nn.1
  energibehov_1_N = mkN "energibehov" neutrum  ; -- energibehov..nn.1
  energibesparande_1_A = mkA "energibesparande" ; -- energibesparande..av.1
  energibrist_1_N = mkN "energibrist" ; -- energibrist..nn.1
  energidepartement_1_N = mkN "energidepartement" neutrum  ; -- energidepartement..nn.1
  energidryck_1_N = mkN "energidryck" "energidrycker" ; -- energidryck..nn.1
  energieffektiv_1_A = mkA "energieffektiv" ; -- energieffektiv..av.1
  energieffektivisering_1_N = mkN "energieffektivisering" ; -- energieffektivisering..nn.1
  energieffektivitet_1_N = mkN "energieffektivitet" "energieffektiviteter" ; -- energieffektivitet..nn.1
  energiform_1_N = mkN "energiform" "energiformer" ; -- energiform..nn.1
  energiförbrukande_1_A = mkA "energiförbrukande" ; -- energiförbrukande..av.1
  energiförbrukare_1_N = mkN "energiförbrukare" utrum  ; -- energiförbrukare..nn.1
  energiförbrukning_1_N = mkN "energiförbrukning" ; -- energiförbrukning..nn.1
  energiförlust_1_N = mkN "energiförlust" "energiförluster" ; -- energiförlust..nn.1
  energiförsörjning_1_N = mkN "energiförsörjning" ; -- energiförsörjning..nn.1
  energigivande_1_A = mkA "energigivande" ; -- energigivande..av.1
  energiinnehåll_1_N = mkN "energiinnehåll" neutrum  ; -- energiinnehåll..nn.1
  energiintag_1_N = mkN "energiintag" neutrum  ; -- energiintag..nn.1
  energiintensiv_1_A = mkA "energiintensiv" ; -- energiintensiv..av.1
  energiknippe_1_N = mkN "energiknippe" ; -- energiknippe..nn.1
  energikoncentration_1_N = mkN "energikoncentration" ; -- energikoncentration..nn.1
  energikrävande_1_A = mkA "energikrävande" ; -- energikrävande..av.1
  energikälla_1_N = mkN "energikälla" ; -- energikälla..nn.1
  energilös_1_A = mkA "energilös" ; -- energilös..av.1
  energimarknad_1_N = mkN "energimarknad" "energimarknader" ; -- energimarknad..nn.1
  energimix_1_N = mkN "energimix" "energimixer" ; -- energimix..nn.1
  energimängd_1_N = mkN "energimängd" "energimängder" ; -- energimängd..nn.1
  energimässig_1_A = mkA "energimässig" ; -- energimässig..av.1
  energiomställning_1_N = mkN "energiomställning" ; -- energiomställning..nn.1
  energiomsättning_1_N = mkN "energiomsättning" ; -- energiomsättning..nn.1
  energiomvandling_1_N = mkN "energiomvandling" ; -- energiomvandling..nn.1
  energiomvandlingscentrum_1_N = mkN "energiomvandlingscentrum" neutrum  ; -- energiomvandlingscentrum..nn.1
  energipolitik_1_N = mkN "energipolitik" ; -- energipolitik..nn.1
  energipolitisk_1_A = mkA "energipolitisk" ; -- energipolitisk..av.1
  energiprincip_1_N = mkN "energiprincip" ; -- energiprincip..nn.1
  energiproduktion_1_N = mkN "energiproduktion" ; -- energiproduktion..nn.1
  energirik_1_A = mkA "energirik" ; -- energirik..av.1
  energirikhet_1_N = mkN "energirikhet" ; -- energirikhet..nn.1
  energisk_1_A = mkA "energisk" ; -- energisk..av.1
  energiskatt_1_N = mkN "energiskatt" "energiskatter" ; -- energiskatt..nn.1
  energiskog_1_N = mkN "energiskog" ; -- energiskog..nn.1
  energislukande_1_A = mkA "energislukande" ; -- energislukande..av.1
  energislöseri_1_N = mkN "energislöseri" neutrum  ; -- energislöseri..nn.1
  energisnål_1_A = mkA "energisnål" ; -- energisnål..av.1
  energisparande_1_A = mkA "energisparande" ; -- energisparande..av.1
  energisystem_1_N = mkN "energisystem" neutrum  ; -- energisystem..nn.1
  energiteori_1_N = mkN "energiteori" "energiteorier" ; -- energiteori..nn.1
  energitillstånd_1_N = mkN "energitillstånd" neutrum  ; -- energitillstånd..nn.1
  energiuppgörelse_1_N = mkN "energiuppgörelse" "energiuppgörelser" ; -- energiuppgörelse..nn.1
  energiupptagande_1_A = mkA "energiupptagande" ; -- energiupptagande..av.1
  energiutstrålning_1_N = mkN "energiutstrålning" ; -- energiutstrålning..nn.1
  energiutveckling_1_N = mkN "energiutveckling" ; -- energiutveckling..nn.1
  energiverk_1_N = mkN "energiverk" neutrum  ; -- energiverk..nn.1
  energivinst_1_N = mkN "energivinst" "energivinster" ; -- energivinst..nn.1
  energiåtgång_1_N = mkN "energiåtgång" ; -- energiåtgång..nn.1
  enervera_1_V = mkV "enerverar" ; -- enervera..vb.1
  enerverande_1_N = mkN "enerverande" ; -- enerverande..nn.1
  enerverbar_1_A = mkA "enerverbar" ; -- enerverbar..av.1
  enerverbarhet_1_N = mkN "enerverbarhet" ; -- enerverbarhet..nn.1
  enervering_1_N = mkN "enervering" ; -- enervering..nn.1
  enfald_1_N = mkN "enfald" ; -- enfald..nn.1
  enfaldeligen_1_Adv = mkAdv "enfaldeligen" ; -- enfaldeligen..ab.1
  enfaldig_1_A = mkA "enfaldig" ; -- enfaldig..av.1
  enfaldighet_1_N = mkN "enfaldighet" ; -- enfaldighet..nn.1
  enfamiljshus_1_N = mkN "enfamiljshus" neutrum  ; -- enfamiljshus..nn.1
  enfas_1_A = mkA "enfas" ; -- enfas..av.1
  enfasig_1_A = mkA "enfasig" ; -- enfasig..av.1
  enformig_1_A = mkA "enformig" ; -- enformig..av.1
  enformighet_1_N = mkN "enformighet" ; -- enformighet..nn.1
  enfotad_1_A = mkA "enfotad" ; -- enfotad..av.1
  enfoting_1_N = mkN "enfoting" ; -- enfoting..nn.1
  enfrågeparti_1_N = mkN "enfrågeparti" "enfrågepartiet" "enfrågepartier" "enfrågepartierna" ; -- enfrågeparti..nn.1
  enfärgad_1_A = mkA "enfärgad" ; -- enfärgad..av.1
  enfödd_1_A = mkA "enfödd" ; -- enfödd..av.1
  enföräldersfamilj_1_N = mkN "enföräldersfamilj" "enföräldersfamiljer" ; -- enföräldersfamilj..nn.1
  engagemang_1_N = mkN "engagemang" neutrum  ; -- engagemang..nn.1
  engagera_1_V = mkV "engagerar" ; -- engagera..vb.1
  engagerad_1_A = mkA "engagerad" ; -- engagerad..av.1
  engagerande_1_N = mkN "engagerande" ; -- engagerande..nn.1
  engagerbar_1_A = mkA "engagerbar" ; -- engagerbar..av.1
  engagerbarhet_1_N = mkN "engagerbarhet" ; -- engagerbarhet..nn.1
  engagering_1_N = mkN "engagering" ; -- engagering..nn.1
  engelsk_1_A = mkA "engelsk" ; -- engelsk..av.1
  engelska_1_N = mkN "engelska" ; -- engelska..nn.1
  engelska_2_N = mkN "engelska" ; -- engelska..nn.2
  engelskakurs_1_N = mkN "engelskakurs" "engelskakurser" ; -- engelskakurs..nn.1
  engelskalektion_1_N = mkN "engelskalektion" ; -- engelskalektion..nn.1
  engelskalärare_1_N = mkN "engelskalärare" utrum  ; -- engelskalärare..nn.1
  engelskaundervisning_1_N = mkN "engelskaundervisning" ; -- engelskaundervisning..nn.1
  engelskkurs_1_N = mkN "engelskkurs" "engelskkurser" ; -- engelskkurs..nn.1
  engelsklektion_1_N = mkN "engelsklektion" ; -- engelsklektion..nn.1
  engelsklärare_1_N = mkN "engelsklärare" utrum  ; -- engelsklärare..nn.1
  engelskspråkig_1_A = mkA "engelskspråkig" ; -- engelskspråkig..av.1
  engelskspråkighet_1_N = mkN "engelskspråkighet" ; -- engelskspråkighet..nn.1
  engelskspåkig_1_A = mkA "engelskspåkig" ; -- engelskspåkig..av.1
  engelskspåkighet_1_N = mkN "engelskspåkighet" ; -- engelskspåkighet..nn.1
  engelsktalande_1_A = mkA "engelsktalande" ; -- engelsktalande..av.1
  engelskundervisning_1_N = mkN "engelskundervisning" ; -- engelskundervisning..nn.1
  engelsman_1_N = mkN "engelsman" "engelsmannen" "engelsmän" "engelsmännen" ; -- engelsman..nn.1
  engifte_1_N = mkN "engifte" ; -- engifte..nn.1
  englergrad_1_N = mkN "englergrad" "englergrader" ; -- englergrad..nn.1
  engram_1_N = mkN "engram" "engrammet" "engram" "engrammen" ; -- engram..nn.1
  engrossist_1_N = mkN "engrossist" "engrossister" ; -- engrossist..nn.1
  engång_1_Adv = mkAdv "engång" ; -- engång..ab.1
  engångitiden_1_Adv = mkAdv "engångitiden" ; -- engångitiden..ab.1
  engångs_1_A = mkA "engångs" ; -- engångs..av.1
  engångsartikel_1_N = mkN "engångsartikel" ; -- engångsartikel..nn.1
  engångsdos_1_N = mkN "engångsdos" "engångsdoser" ; -- engångsdos..nn.1
  engångsflaska_1_N = mkN "engångsflaska" ; -- engångsflaska..nn.1
  engångsföreteelse_1_N = mkN "engångsföreteelse" "engångsföreteelser" ; -- engångsföreteelse..nn.1
  engångshandduk_1_N = mkN "engångshandduk" ; -- engångshandduk..nn.1
  engångskaraktär_1_N = mkN "engångskaraktär" ; -- engångskaraktär..nn.1
  engångskostnad_1_N = mkN "engångskostnad" "engångskostnader" ; -- engångskostnad..nn.1
  engångsligg_1_N = mkN "engångsligg" neutrum  ; -- engångsligg..nn.1
  engångsnatur_1_N = mkN "engångsnatur" ; -- engångsnatur..nn.1
  engångsnäsduk_1_N = mkN "engångsnäsduk" ; -- engångsnäsduk..nn.1
  engångsservett_1_N = mkN "engångsservett" "engångsservetter" ; -- engångsservett..nn.1
  engångsskatt_1_N = mkN "engångsskatt" "engångsskatter" ; -- engångsskatt..nn.1
  engångstallrik_1_N = mkN "engångstallrik" ; -- engångstallrik..nn.1
  engångsvärde_1_N = mkN "engångsvärde" ; -- engångsvärde..nn.1
  enharmonisk_1_A = mkA "enharmonisk" ; -- enharmonisk..av.1
  enhet_1_N = mkN "enhet" "enheter" ; -- enhet..nn.1
  enhetlig_1_A = mkA "enhetlig" ; -- enhetlig..av.1
  enhetlighet_1_N = mkN "enhetlighet" ; -- enhetlighet..nn.1
  enhetscirkel_1_N = mkN "enhetscirkel" ; -- enhetscirkel..nn.1
  enhetsflygplan_1_N = mkN "enhetsflygplan" neutrum  ; -- enhetsflygplan..nn.1
  enhetsfront_1_N = mkN "enhetsfront" "enhetsfronter" ; -- enhetsfront..nn.1
  enhetsladdning_1_N = mkN "enhetsladdning" ; -- enhetsladdning..nn.1
  enhetslast_1_N = mkN "enhetslast" "enhetslaster" ; -- enhetslast..nn.1
  enhetsmått_1_N = mkN "enhetsmått" neutrum  ; -- enhetsmått..nn.1
  enhetsparti_1_N = mkN "enhetsparti" "enhetspartiet" "enhetspartier" "enhetspartierna" ; -- enhetsparti..nn.1
  enhetspatron_1_N = mkN "enhetspatron" "enhetspatroner" ; -- enhetspatron..nn.1
  enhetsporto_1_N = mkN "enhetsporto" "enhetsportot" "enhetsporton" "enhetsportona" ; -- enhetsporto..nn.1
  enhetspris_1_N = mkN "enhetspris" neutrum  ; -- enhetspris..nn.1
  enhetsskola_1_N = mkN "enhetsskola" ; -- enhetsskola..nn.1
  enhetssträvande_1_N = mkN "enhetssträvande" ; -- enhetssträvande..nn.1
  enhetsvektor_1_N = mkN "enhetsvektor" "enhetsvektorer" ; -- enhetsvektor..nn.1
  enhjulig_1_A = mkA "enhjulig" ; -- enhjulig..av.1
  enhjulighet_1_N = mkN "enhjulighet" ; -- enhjulighet..nn.1
  enhjuling_1_N = mkN "enhjuling" ; -- enhjuling..nn.1
  enhjärtbladig_1_A = mkA "enhjärtbladig" ; -- enhjärtbladig..av.1
  enhällig_1_A = mkA "enhällig" ; -- enhällig..av.1
  enhällighet_1_N = mkN "enhällighet" ; -- enhällighet..nn.1
  enhänt_1_A = mkA "enhänt" "enhänt" ; -- enhänt..av.1
  enhörning_1_N = mkN "enhörning" ; -- enhörning..nn.1
  enig_1_A = mkA "enig" ; -- enig..av.1
  enighet_1_N = mkN "enighet" "enigheter" ; -- enighet..nn.1
  enigmatisk_1_A = mkA "enigmatisk" ; -- enigmatisk..av.1
  enjambemang_1_N = mkN "enjambemang" neutrum  ; -- enjambemang..nn.1
  enkammarsystem_1_N = mkN "enkammarsystem" neutrum  ; -- enkammarsystem..nn.1
  enkannerligen_1_Adv = mkAdv "enkannerligen" ; -- enkannerligen..ab.1
  enkel_1_A = mkA "enkel" ; -- enkel..av.1
  enkelbeckasin_1_N = mkN "enkelbeckasin" "enkelbeckasiner" ; -- enkelbeckasin..nn.1
  enkelbiff_1_N = mkN "enkelbiff" ; -- enkelbiff..nn.1
  enkelbiljett_1_N = mkN "enkelbiljett" "enkelbiljetter" ; -- enkelbiljett..nn.1
  enkelbredd_1_N = mkN "enkelbredd" "enkelbredder" ; -- enkelbredd..nn.1
  enkelhet_1_N = mkN "enkelhet" "enkelheter" ; -- enkelhet..nn.1
  enkelkikare_1_N = mkN "enkelkikare" utrum  ; -- enkelkikare..nn.1
  enkelknäppning_1_N = mkN "enkelknäppning" ; -- enkelknäppning..nn.1
  enkelknäppt_1_A = mkA "enkelknäppt" "enkelknäppt" ; -- enkelknäppt..av.1
  enkelkvartett_1_N = mkN "enkelkvartett" "enkelkvartetter" ; -- enkelkvartett..nn.1
  enkelladdare_1_N = mkN "enkelladdare" utrum  ; -- enkelladdare..nn.1
  enkelnervig_1_A = mkA "enkelnervig" ; -- enkelnervig..av.1
  enkelpipig_1_A = mkA "enkelpipig" ; -- enkelpipig..av.1
  enkelrad_1_N = mkN "enkelrad" "enkelrader" ; -- enkelrad..nn.1
  enkelrenad_1_A = mkA "enkelrenad" ; -- enkelrenad..av.1
  enkelrikta_1_V = mkV "enkelriktar" ; -- enkelrikta..vb.1
  enkelriktad_1_A = mkA "enkelriktad" ; -- enkelriktad..av.1
  enkelriktande_1_N = mkN "enkelriktande" ; -- enkelriktande..nn.1
  enkelrum_1_N = mkN "enkelrum" "enkelrummet" "enkelrum" "enkelrummen" ; -- enkelrum..nn.1
  enkelskriva_1_V = mkV "enkelskriva" "enkelskrev" "enkelskrivit" ; -- enkelskriva..vb.1
  enkelskrivande_1_N = mkN "enkelskrivande" ; -- enkelskrivande..nn.1
  enkelspel_1_N = mkN "enkelspel" "enkelspelet" "enkelspel" "enkelspelen" ; -- enkelspel..nn.1
  enkelspårig_1_A = mkA "enkelspårig" ; -- enkelspårig..av.1
  enkelspårighet_1_N = mkN "enkelspårighet" ; -- enkelspårighet..nn.1
  enkelstjärna_1_N = mkN "enkelstjärna" ; -- enkelstjärna..nn.1
  enkelsträngad_1_A = mkA "enkelsträngad" ; -- enkelsträngad..av.1
  enkelsäng_1_N = mkN "enkelsäng" ; -- enkelsäng..nn.1
  enkelteckna_1_V = mkV "enkeltecknar" ; -- enkelteckna..vb.1
  enkeltecknande_1_N = mkN "enkeltecknande" ; -- enkeltecknande..nn.1
  enkeltimma_1_N = mkN "enkeltimma" ; -- enkeltimma..nn.1
  enkeltimme_1_N = mkN "enkeltimme" utrum  ; -- enkeltimme..nn.1
  enkla_1_V = mkV "enklar" ; -- enkla..vb.1
  enklande_1_N = mkN "enklande" ; -- enklande..nn.1
  enklang_1_N = mkN "enklang" ; -- enklang..nn.1
  enklav_1_N = mkN "enklav" "enklaver" ; -- enklav..nn.1
  enklavisering_1_N = mkN "enklavisering" ; -- enklavisering..nn.1
  enklitisk_1_A = mkA "enklitisk" ; -- enklitisk..av.1
  enkomponents_1_A = mkA "enkomponents" ; -- enkomponents..av.1
  enkomponentskitt_1_N = mkN "enkomponentskitt" neutrum  ; -- enkomponentskitt..nn.1
  enkorn_1_N = mkN "enkorn" neutrum  ; -- enkorn..nn.1
  enkrona_1_N = mkN "enkrona" ; -- enkrona..nn.1
  enkät_1_N = mkN "enkät" "enkäter" ; -- enkät..nn.1
  enkätsvar_1_N = mkN "enkätsvar" neutrum  ; -- enkätsvar..nn.1
  enkätundersökning_1_N = mkN "enkätundersökning" ; -- enkätundersökning..nn.1
  enkönad_1_A = mkA "enkönad" ; -- enkönad..av.1
  enkönsregel_1_N = mkN "enkönsregel" "enkönsregeln" "enkönsregler" "enkönsreglerna" ; -- enkönsregel..nn.1
  enlevera_1_V = mkV "enleverar" ; -- enlevera..vb.1
  enleverande_1_N = mkN "enleverande" ; -- enleverande..nn.1
  enleverbar_1_A = mkA "enleverbar" ; -- enleverbar..av.1
  enleverbarhet_1_N = mkN "enleverbarhet" ; -- enleverbarhet..nn.1
  enlevering_1_N = mkN "enlevering" ; -- enlevering..nn.1
  enmansföreställning_1_N = mkN "enmansföreställning" ; -- enmansföreställning..nn.1
  enmansgrav_1_N = mkN "enmansgrav" ; -- enmansgrav..nn.1
  enmanslivbåt_1_N = mkN "enmanslivbåt" ; -- enmanslivbåt..nn.1
  enmanspublik_1_N = mkN "enmanspublik" "enmanspubliker" ; -- enmanspublik..nn.1
  enmansshow_1_N = mkN "enmansshow" "enmansshower" ; -- enmansshow..nn.1
  enmansteater_1_N = mkN "enmansteater" ; -- enmansteater..nn.1
  enmansvalkrets_1_N = mkN "enmansvalkrets" ; -- enmansvalkrets..nn.1
  enmastad_1_A = mkA "enmastad" ; -- enmastad..av.1
  enmastare_1_N = mkN "enmastare" utrum  ; -- enmastare..nn.1
  enmotorig_1_A = mkA "enmotorig" ; -- enmotorig..av.1
  enna_1_Adv = mkAdv "enna" ; -- enna..ab.1
  enorm_1_A = mkA "enorm" ; -- enorm..av.1
  enormhet_1_N = mkN "enormhet" ; -- enormhet..nn.1
  enpartistat_1_N = mkN "enpartistat" "enpartistater" ; -- enpartistat..nn.1
  enpersonsfamilj_1_N = mkN "enpersonsfamilj" "enpersonsfamiljer" ; -- enpersonsfamilj..nn.1
  enpersonshushåll_1_N = mkN "enpersonshushåll" neutrum  ; -- enpersonshushåll..nn.1
  enplanshus_1_N = mkN "enplanshus" neutrum  ; -- enplanshus..nn.1
  enplansvilla_1_N = mkN "enplansvilla" ; -- enplansvilla..nn.1
  enpolig_1_A = mkA "enpolig" ; -- enpolig..av.1
  enpolighet_1_N = mkN "enpolighet" ; -- enpolighet..nn.1
  enpucklig_1_A = mkA "enpucklig" ; -- enpucklig..av.1
  enpucklighet_1_N = mkN "enpucklighet" ; -- enpucklighet..nn.1
  enris_1_N = mkN "enris" neutrum  ; -- enris..nn.1
  enrisrökt_1_A = mkA "enrisrökt" "enrisrökt" ; -- enrisrökt..av.1
  enrollera_1_V = mkV "enrollerar" ; -- enrollera..vb.1
  enrollerande_1_N = mkN "enrollerande" ; -- enrollerande..nn.1
  enrollerbar_1_A = mkA "enrollerbar" ; -- enrollerbar..av.1
  enrollerbarhet_1_N = mkN "enrollerbarhet" ; -- enrollerbarhet..nn.1
  enrollering_1_N = mkN "enrollering" ; -- enrollering..nn.1
  enrummare_1_N = mkN "enrummare" utrum  ; -- enrummare..nn.1
  enrumslägenhet_1_N = mkN "enrumslägenhet" "enrumslägenheter" ; -- enrumslägenhet..nn.1
  enrådig_1_A = mkA "enrådig" ; -- enrådig..av.1
  ens_1_Adv = mkAdv "ens" ; -- ens..ab.1
  ens_1_A = mkA "ens" ; -- ens..av.1
  ensa_1_V = mkV "ensar" ; -- ensa..vb.1
  ensak_1_N = mkN "ensak" "ensaker" ; -- ensak..nn.1
  ensam_1_A = mkA "ensam" "ensamt" "ensamma" "ensamma" "ensammare" "ensammast" "ensammaste" ; -- ensam..av.1
  ensamagerande_1_A = mkA "ensamagerande" ; -- ensamagerande..av.1
  ensamanländande_1_A = mkA "ensamanländande" ; -- ensamanländande..av.1
  ensamflygning_1_N = mkN "ensamflygning" ; -- ensamflygning..nn.1
  ensamförälder_1_N = mkN "ensamförälder" ; -- ensamförälder..nn.1
  ensamgård_1_N = mkN "ensamgård" ; -- ensamgård..nn.1
  ensamhet_1_N = mkN "ensamhet" "ensamheter" ; -- ensamhet..nn.1
  ensamhushåll_1_N = mkN "ensamhushåll" neutrum  ; -- ensamhushåll..nn.1
  ensamkommande_1_A = mkA "ensamkommande" ; -- ensamkommande..av.1
  ensamrätt_1_N = mkN "ensamrätt" "ensamrätter" ; -- ensamrätt..nn.1
  ensamseglare_1_N = mkN "ensamseglare" utrum  ; -- ensamseglare..nn.1
  ensamstående_1_A = mkA "ensamstående" ; -- ensamstående..av.1
  ensamvarg_1_N = mkN "ensamvarg" ; -- ensamvarg..nn.1
  ensande_1_N = mkN "ensande" ; -- ensande..nn.1
  ensartad_1_A = mkA "ensartad" ; -- ensartad..av.1
  ense_1_A = mkA "ense" ; -- ense..av.1
  ensemble_1_N = mkN "ensemble" "ensembler" ; -- ensemble..nn.1
  ensfyr_1_N = mkN "ensfyr" ; -- ensfyr..nn.1
  ensidig_1_A = mkA "ensidig" ; -- ensidig..av.1
  ensidighet_1_N = mkN "ensidighet" ; -- ensidighet..nn.1
  ensiffrig_1_A = mkA "ensiffrig" ; -- ensiffrig..av.1
  ensilage_1_N = mkN "ensilage" ; -- ensilage..nn.1
  ensilera_1_V = mkV "ensilerar" ; -- ensilera..vb.1
  ensilerande_1_N = mkN "ensilerande" ; -- ensilerande..nn.1
  ensilerbar_1_A = mkA "ensilerbar" ; -- ensilerbar..av.1
  ensilerbarhet_1_N = mkN "ensilerbarhet" ; -- ensilerbarhet..nn.1
  ensilering_1_N = mkN "ensilering" ; -- ensilering..nn.1
  ensitsig_1_A = mkA "ensitsig" ; -- ensitsig..av.1
  ensittare_1_N = mkN "ensittare" utrum  ; -- ensittare..nn.1
  enskeppig_1_A = mkA "enskeppig" ; -- enskeppig..av.1
  enskifte_1_N = mkN "enskifte" ; -- enskifte..nn.1
  enskild_1_A = mkA "enskild" "enskilt" ; -- enskild..av.1
  enskildhet_1_N = mkN "enskildhet" "enskildheter" ; -- enskildhet..nn.1
  enslig_1_A = mkA "enslig" ; -- enslig..av.1
  enslighet_1_N = mkN "enslighet" ; -- enslighet..nn.1
  ensling_1_N = mkN "ensling" ; -- ensling..nn.1
  enslinje_1_N = mkN "enslinje" "enslinjer" ; -- enslinje..nn.1
  enspann_1_N = mkN "enspann" neutrum  ; -- enspann..nn.1
  enspråkig_1_A = mkA "enspråkig" ; -- enspråkig..av.1
  enspråkighet_1_N = mkN "enspråkighet" ; -- enspråkighet..nn.1
  enspänd_1_A = mkA "enspänd" ; -- enspänd..av.1
  enstaka_1_A = mkA "enstaka" ; -- enstaka..av.1
  enstavig_1_A = mkA "enstavig" ; -- enstavig..av.1
  enstavighet_1_N = mkN "enstavighet" ; -- enstavighet..nn.1
  enstavighetsaccent_1_N = mkN "enstavighetsaccent" ; -- enstavighetsaccent..nn.1
  enstegstätad_1_A = mkA "enstegstätad" ; -- enstegstätad..av.1
  enstensmur_1_N = mkN "enstensmur" ; -- enstensmur..nn.1
  enstjärnig_1_A = mkA "enstjärnig" ; -- enstjärnig..av.1
  enstämmig_1_A = mkA "enstämmig" ; -- enstämmig..av.1
  enstämmighet_1_N = mkN "enstämmighet" ; -- enstämmighet..nn.1
  enständig_1_A = mkA "enständig" ; -- enständig..av.1
  enständighet_1_N = mkN "enständighet" ; -- enständighet..nn.1
  enstörig_1_A = mkA "enstörig" ; -- enstörig..av.1
  enstörighet_1_N = mkN "enstörighet" ; -- enstörighet..nn.1
  enstöring_1_N = mkN "enstöring" ; -- enstöring..nn.1
  ental_1_N = mkN "ental" neutrum  ; -- ental..nn.1
  entalpi_1_N = mkN "entalpi" ; -- entalpi..nn.1
  entalsform_1_N = mkN "entalsform" "entalsformer" ; -- entalsform..nn.1
  entent_1_N = mkN "entent" "ententer" ; -- entent..nn.1
  entente_1_N = mkN "entente" "ententer" ; -- entente..nn.1
  enter_1_N = mkN "enter" ; -- enter..nn.1
  enterknapp_1_N = mkN "enterknapp" ; -- enterknapp..nn.1
  entertainer_1_N = mkN "entertainer" "entertainern" "entertainers" "entertainersen" ; -- entertainer..nn.1
  entertangent_1_N = mkN "entertangent" "entertangenter" ; -- entertangent..nn.1
  entita_1_N = mkN "entita" ; -- entita..nn.1
  entitet_1_N = mkN "entitet" "entiteter" ; -- entitet..nn.1
  entlediga_1_V = mkV "entledigar" ; -- entlediga..vb.1
  entledigande_1_N = mkN "entledigande" ; -- entledigande..nn.1
  entomolog_1_N = mkN "entomolog" "entomologer" ; -- entomolog..nn.1
  entomologi_1_N = mkN "entomologi" ; -- entomologi..nn.1
  entomologisk_1_A = mkA "entomologisk" ; -- entomologisk..av.1
  entonig_1_A = mkA "entonig" ; -- entonig..av.1
  entonighet_1_N = mkN "entonighet" ; -- entonighet..nn.1
  entrecote_1_N = mkN "entrecote" "entrecoter" ; -- entrecote..nn.1
  entrecôte_1_N = mkN "entrecôte" "entrecôter" ; -- entrecôte..nn.1
  entreprenad_1_N = mkN "entreprenad" "entreprenader" ; -- entreprenad..nn.1
  entreprenadmaskin_1_N = mkN "entreprenadmaskin" "entreprenadmaskiner" ; -- entreprenadmaskin..nn.1
  entreprenör_1_N = mkN "entreprenör" "entreprenörer" ; -- entreprenör..nn.1
  entreprenörsanda_1_N = mkN "entreprenörsanda" ; -- entreprenörsanda..nn.1
  entreprenörskap_1_N = mkN "entreprenörskap" neutrum  ; -- entreprenörskap..nn.1
  entresol_1_N = mkN "entresol" "entresoler" ; -- entresol..nn.1
  entresoll_1_N = mkN "entresoll" "entresoller" ; -- entresoll..nn.1
  entresolvåning_1_N = mkN "entresolvåning" ; -- entresolvåning..nn.1
  entropi_1_N = mkN "entropi" ; -- entropi..nn.1
  enträgen_1_A = mkA "enträgen" ; -- enträgen..av.1
  enträgenhet_1_N = mkN "enträgenhet" ; -- enträgenhet..nn.1
  entré_1_N = mkN "entré" "entréer" ; -- entré..nn.1
  entréavgift_1_N = mkN "entréavgift" "entréavgifter" ; -- entréavgift..nn.1
  entrébiljett_1_N = mkN "entrébiljett" "entrébiljetter" ; -- entrébiljett..nn.1
  entrédörr_1_N = mkN "entrédörr" ; -- entrédörr..nn.1
  entrérätt_1_N = mkN "entrérätt" "entrérätter" ; -- entrérätt..nn.1
  entumsspik_1_N = mkN "entumsspik" ; -- entumsspik..nn.1
  entusiasm_1_N = mkN "entusiasm" ; -- entusiasm..nn.1
  entusiasmera_1_V = mkV "entusiasmerar" ; -- entusiasmera..vb.1
  entusiasmerande_1_N = mkN "entusiasmerande" ; -- entusiasmerande..nn.1
  entusiasmerbar_1_A = mkA "entusiasmerbar" ; -- entusiasmerbar..av.1
  entusiasmerbarhet_1_N = mkN "entusiasmerbarhet" ; -- entusiasmerbarhet..nn.1
  entusiasmering_1_N = mkN "entusiasmering" ; -- entusiasmering..nn.1
  entusiast_1_N = mkN "entusiast" "entusiaster" ; -- entusiast..nn.1
  entusiastisk_1_A = mkA "entusiastisk" ; -- entusiastisk..av.1
  entusiastsajt_1_N = mkN "entusiastsajt" "entusiastsajter" ; -- entusiastsajt..nn.1
  entydig_1_A = mkA "entydig" ; -- entydig..av.1
  entydighet_1_N = mkN "entydighet" "entydigheter" ; -- entydighet..nn.1
  entypsbåt_1_N = mkN "entypsbåt" ; -- entypsbåt..nn.1
  enumeration_1_N = mkN "enumeration" ; -- enumeration..nn.1
  enveten_1_A = mkA "enveten" ; -- enveten..av.1
  envetenhet_1_N = mkN "envetenhet" ; -- envetenhet..nn.1
  envig_1_N = mkN "envig" ; -- envig..nn.1
  environg_1_N = mkN "environg" "environger" ; -- environg..nn.1
  envis_1_A = mkA "envis" ; -- envis..av.1
  envishet_1_N = mkN "envishet" ; -- envishet..nn.1
  envoyé_1_N = mkN "envoyé" "envoyéer" ; -- envoyé..nn.1
  envägskommunikation_1_N = mkN "envägskommunikation" ; -- envägskommunikation..nn.1
  envälde_1_N = mkN "envälde" ; -- envälde..nn.1
  enväldig_1_A = mkA "enväldig" ; -- enväldig..av.1
  enväldighet_1_N = mkN "enväldighet" ; -- enväldighet..nn.1
  envärd_1_A = mkA "envärd" "envärt" ; -- envärd..av.1
  envåldshärskare_1_N = mkN "envåldshärskare" utrum  ; -- envåldshärskare..nn.1
  envåldsmakt_1_N = mkN "envåldsmakt" ; -- envåldsmakt..nn.1
  envåningsbarack_1_N = mkN "envåningsbarack" "envåningsbaracker" ; -- envåningsbarack..nn.1
  envåningshus_1_N = mkN "envåningshus" neutrum  ; -- envåningshus..nn.1
  enzym_1_N = mkN "enzym" neutrum  ; -- enzym..nn.1
  enzymrubbning_1_N = mkN "enzymrubbning" ; -- enzymrubbning..nn.1
  enzymsystem_1_N = mkN "enzymsystem" neutrum  ; -- enzymsystem..nn.1
  enzymtvättmedel_1_N = mkN "enzymtvättmedel" neutrum  ; -- enzymtvättmedel..nn.1
  enäggstvilling_1_N = mkN "enäggstvilling" ; -- enäggstvilling..nn.1
  enögd_1_A = mkA "enögd" "enögt" ; -- enögd..av.1
  enögdhet_1_N = mkN "enögdhet" ; -- enögdhet..nn.1
  eoarkeikum_1_N = mkN "eoarkeikum" ; -- eoarkeikum..nn.1
  eocen_1_N = mkN "eocen" ; -- eocen..nn.1
  eoler_1_N = mkN "eoler" "eolern" "eoler" "eolerna" ; -- eoler..nn.1
  eolier_1_N = mkN "eolier" "eoliern" "eolier" "eolierna" ; -- eolier..nn.1
  eolisk_1_A = mkA "eolisk" ; -- eolisk..av.1
  eolsharpa_1_N = mkN "eolsharpa" ; -- eolsharpa..nn.1
  eon_1_N = mkN "eon" "eoner" ; -- eon..nn.1
  eosin_1_N = mkN "eosin" "eosiner" ; -- eosin..nn.1
  epatraktor_1_N = mkN "epatraktor" "epatraktorer" ; -- epatraktor..nn.1
  epicentrum_1_N = mkN "epicentrum" neutrum  ; -- epicentrum..nn.1
  epicykel_1_N = mkN "epicykel" "epicykeln" "epicykler" "epicyklerna" ; -- epicykel..nn.1
  epidemi_1_N = mkN "epidemi" "epidemier" ; -- epidemi..nn.1
  epidemiologi_1_N = mkN "epidemiologi" ; -- epidemiologi..nn.1
  epidemiologisk_1_A = mkA "epidemiologisk" ; -- epidemiologisk..av.1
  epidemisjukhus_1_N = mkN "epidemisjukhus" neutrum  ; -- epidemisjukhus..nn.1
  epidemisk_1_A = mkA "epidemisk" ; -- epidemisk..av.1
  epidemolog_1_N = mkN "epidemolog" "epidemologer" ; -- epidemolog..nn.1
  epiduralblockad_1_N = mkN "epiduralblockad" "epiduralblockader" ; -- epiduralblockad..nn.1
  epifani_1_N = mkN "epifani" "epifanier" ; -- epifani..nn.1
  epifanisk_1_A = mkA "epifanisk" ; -- epifanisk..av.1
  epifenomen_1_N = mkN "epifenomen" neutrum  ; -- epifenomen..nn.1
  epifys_1_N = mkN "epifys" "epifyser" ; -- epifys..nn.1
  epifyt_1_N = mkN "epifyt" "epifyter" ; -- epifyt..nn.1
  epigenetisk_1_A = mkA "epigenetisk" ; -- epigenetisk..av.1
  epigon_1_N = mkN "epigon" "epigoner" ; -- epigon..nn.1
  epigoneri_1_N = mkN "epigoneri" neutrum  ; -- epigoneri..nn.1
  epigrafik_1_N = mkN "epigrafik" ; -- epigrafik..nn.1
  epigram_1_N = mkN "epigram" "epigrammet" "epigram" "epigrammen" ; -- epigram..nn.1
  epigrammatisk_1_A = mkA "epigrammatisk" ; -- epigrammatisk..av.1
  epik_1_N = mkN "epik" ; -- epik..nn.1
  epiker_1_N = mkN "epiker" "epikern" "epiker" "epikerna" ; -- epiker..nn.1
  epikureisk_1_A = mkA "epikureisk" ; -- epikureisk..av.1
  epikurism_1_N = mkN "epikurism" "epikurismer" ; -- epikurism..nn.1
  epikuré_1_N = mkN "epikuré" "epikuréer" ; -- epikuré..nn.1
  epikuréism_1_N = mkN "epikuréism" ; -- epikuréism..nn.1
  epilepsi_1_N = mkN "epilepsi" "epilepsier" ; -- epilepsi..nn.1
  epileptiker_1_N = mkN "epileptiker" "epileptikern" "epileptiker" "epileptikerna" ; -- epileptiker..nn.1
  epileptisk_1_A = mkA "epileptisk" ; -- epileptisk..av.1
  epilera_1_V = mkV "epilerar" ; -- epilera..vb.1
  epilerande_1_N = mkN "epilerande" ; -- epilerande..nn.1
  epilerbar_1_A = mkA "epilerbar" ; -- epilerbar..av.1
  epilerbarhet_1_N = mkN "epilerbarhet" ; -- epilerbarhet..nn.1
  epilering_1_N = mkN "epilering" ; -- epilering..nn.1
  epilog_1_N = mkN "epilog" "epiloger" ; -- epilog..nn.1
  epinefrin_1_N = mkN "epinefrin" "epinefriner" ; -- epinefrin..nn.1
  episk_1_A = mkA "episk" ; -- episk..av.1
  episkop_1_N = mkN "episkop" neutrum  ; -- episkop..nn.1
  episkopal_1_A = mkA "episkopal" ; -- episkopal..av.1
  episkopalkyrka_1_N = mkN "episkopalkyrka" ; -- episkopalkyrka..nn.1
  episkopat_1_N = mkN "episkopat" neutrum  ; -- episkopat..nn.1
  episod_1_N = mkN "episod" "episoder" ; -- episod..nn.1
  episodisk_1_A = mkA "episodisk" ; -- episodisk..av.1
  epistel_1_N = mkN "epistel" ; -- epistel..nn.1
  epistemologi_1_N = mkN "epistemologi" ; -- epistemologi..nn.1
  epistolär_1_A = mkA "epistolär" ; -- epistolär..av.1
  epistyl_1_N = mkN "epistyl" "epistyler" ; -- epistyl..nn.1
  epitaf_1_N = mkN "epitaf" "epitafet" "epitafer" "epitaferna" ; -- epitaf..nn.1
  epitafium_1_N = mkN "epitafium" "epitafiet" "epitafier" "epitafierna" ; -- epitafium..nn.1
  epitel_1_N = mkN "epitel" "epitelet" "epitel" "epitelen" ; -- epitel..nn.1
  epitelcell_1_N = mkN "epitelcell" "epitelceller" ; -- epitelcell..nn.1
  epitet_1_N = mkN "epitet" neutrum  ; -- epitet..nn.1
  epizoisk_1_A = mkA "epizoisk" ; -- epizoisk..av.1
  epizooti_1_N = mkN "epizooti" "epizootier" ; -- epizooti..nn.1
  epok_1_N = mkN "epok" "epoker" ; -- epok..nn.1
  epokgörande_1_A = mkA "epokgörande" ; -- epokgörande..av.1
  epos_1_N = mkN "epos" neutrum  ; -- epos..nn.1
  epost_1_N = mkN "epost" ; -- epost..nn.1
  eposta_1_V = mkV "epostar" ; -- eposta..vb.1
  epostande_1_N = mkN "epostande" ; -- epostande..nn.1
  epostare_1_N = mkN "epostare" utrum  ; -- epostare..nn.1
  epostbrev_1_N = mkN "epostbrev" neutrum  ; -- epostbrev..nn.1
  epostledes_1_Adv = mkAdv "epostledes" ; -- epostledes..ab.1
  epostmeddelande_1_N = mkN "epostmeddelande" ; -- epostmeddelande..nn.1
  epoxylim_1_N = mkN "epoxylim" "epoxylimmet" "epoxylimmer" "epoxylimmerna" ; -- epoxylim..nn.1
  epsilon_1_N = mkN "epsilon" neutrum  ; -- epsilon..nn.1
  epålett_1_N = mkN "epålett" "epåletter" ; -- epålett..nn.1
  era_1_N = mkN "era" ; -- era..nn.1
  erbarmlig_1_A = mkA "erbarmlig" ; -- erbarmlig..av.1
  erbarmligen_1_Adv = mkAdv "erbarmligen" ; -- erbarmligen..ab.1
  erbarmlighet_1_N = mkN "erbarmlighet" "erbarmligheter" ; -- erbarmlighet..nn.1
  erbium_1_N = mkN "erbium" neutrum  ; -- erbium..nn.1
  erbjuda_1_V = mkV "erbjuda" "erbjöd" "erbjudit" ; -- erbjuda..vb.1
  erbjudande_1_N = mkN "erbjudande" ; -- erbjudande..nn.1
  erektion_1_N = mkN "erektion" ; -- erektion..nn.1
  erektionsnöd_1_N = mkN "erektionsnöd" ; -- erektionsnöd..nn.1
  eremit_1_N = mkN "eremit" "eremiter" ; -- eremit..nn.1
  eremitage_1_N = mkN "eremitage" "eremitaget" "eremitage" "eremitagen" ; -- eremitage..nn.1
  eremitisk_1_A = mkA "eremitisk" ; -- eremitisk..av.1
  eremitkräfta_1_N = mkN "eremitkräfta" ; -- eremitkräfta..nn.1
  eremitliv_1_N = mkN "eremitliv" neutrum  ; -- eremitliv..nn.1
  erfara_1_V = mkV "erfara" "erfor" "erfarit" ; -- erfara..vb.1
  erfarande_1_N = mkN "erfarande" ; -- erfarande..nn.1
  erfaren_1_A = mkA "erfaren" ; -- erfaren..av.1
  erfarenhet_1_N = mkN "erfarenhet" "erfarenheter" ; -- erfarenhet..nn.1
  erfarenhetsbank_1_N = mkN "erfarenhetsbank" "erfarenhetsbanker" ; -- erfarenhetsbank..nn.1
  erfarenhetsbaserad_1_A = mkA "erfarenhetsbaserad" ; -- erfarenhetsbaserad..av.1
  erfarenhetsgrundad_1_A = mkA "erfarenhetsgrundad" ; -- erfarenhetsgrundad..av.1
  erfarenhetsmässig_1_A = mkA "erfarenhetsmässig" ; -- erfarenhetsmässig..av.1
  erfarenhetsmässighet_1_N = mkN "erfarenhetsmässighet" ; -- erfarenhetsmässighet..nn.1
  erfarenhetssfär_1_N = mkN "erfarenhetssfär" "erfarenhetssfärer" ; -- erfarenhetssfär..nn.1
  erfarenhetsvärld_1_N = mkN "erfarenhetsvärld" ; -- erfarenhetsvärld..nn.1
  erforderlig_1_A = mkA "erforderlig" ; -- erforderlig..av.1
  erforderlighet_1_N = mkN "erforderlighet" ; -- erforderlighet..nn.1
  erfordra_1_V = mkV "erfordrar" ; -- erfordra..vb.1
  erfordrande_1_N = mkN "erfordrande" ; -- erfordrande..nn.1
  ergativ_1_A = mkA "ergativ" ; -- ergativ..av.1
  ergativ_1_N = mkN "ergativ" "ergativer" ; -- ergativ..nn.1
  ergativsubjekt_1_N = mkN "ergativsubjekt" neutrum  ; -- ergativsubjekt..nn.1
  ergometer_1_N = mkN "ergometer" ; -- ergometer..nn.1
  ergonom_1_N = mkN "ergonom" "ergonomer" ; -- ergonom..nn.1
  ergonometrisk_1_A = mkA "ergonometrisk" ; -- ergonometrisk..av.1
  ergonomi_1_N = mkN "ergonomi" ; -- ergonomi..nn.1
  ergonomisk_1_A = mkA "ergonomisk" ; -- ergonomisk..av.1
  erhålla_1_V = mkV "erhålla" "erhöll" "erhållit" ; -- erhålla..vb.1
  erhållande_1_N = mkN "erhållande" ; -- erhållande..nn.1
  erigera_1_V = mkV "erigerar" ; -- erigera..vb.1
  erigerande_1_N = mkN "erigerande" ; -- erigerande..nn.1
  erigerbar_1_A = mkA "erigerbar" ; -- erigerbar..av.1
  erigerbarhet_1_N = mkN "erigerbarhet" ; -- erigerbarhet..nn.1
  erigering_1_N = mkN "erigering" ; -- erigering..nn.1
  eriksgata_1_N = mkN "eriksgata" ; -- eriksgata..nn.1
  erinnye_1_N = mkN "erinnye" "erinnyer" ; -- erinnye..nn.1
  erinra_1_V = mkV "erinrar" ; -- erinra..vb.1
  erinran_1_N = mkN "erinran" "erinran" "erinringar" "erinringarna" ; -- erinran..nn.1
  erinrande_1_N = mkN "erinrande" ; -- erinrande..nn.1
  erinring_1_N = mkN "erinring" ; -- erinring..nn.1
  erisäpple_1_N = mkN "erisäpple" ; -- erisäpple..nn.1
  eritrean_1_N = mkN "eritrean" "eritreaner" ; -- eritrean..nn.1
  eritreansk_1_A = mkA "eritreansk" ; -- eritreansk..av.1
  eritreanska_1_N = mkN "eritreanska" ; -- eritreanska..nn.1
  eritreanska_2_N = mkN "eritreanska" ; -- eritreanska..nn.2
  erkänd_1_A = mkA "erkänd" ; -- erkänd..av.1
  erkändhet_1_N = mkN "erkändhet" ; -- erkändhet..nn.1
  erkänna_1_V = mkV "erkänna" "erkände" "erkänt" ; -- erkänna..vb.1
  erkännande_1_N = mkN "erkännande" ; -- erkännande..nn.1
  erkännansvärd_1_A = mkA "erkännansvärd" "erkännansvärt" ; -- erkännansvärd..av.1
  erkännsam_1_A = mkA "erkännsam" "erkännsamt" "erkännsamma" "erkännsamma" "erkännsammare" "erkännsammast" "erkännsammaste" ; -- erkännsam..av.1
  erkännsamhet_1_N = mkN "erkännsamhet" ; -- erkännsamhet..nn.1
  erkänsla_1_N = mkN "erkänsla" ; -- erkänsla..nn.1
  erlägga_1_V = mkV "erlägga" "erla" "erlagt" ; -- erlägga..vb.1
  erläggande_1_N = mkN "erläggande" ; -- erläggande..nn.1
  ernå_1_V = mkV "ernår" ; -- ernå..vb.1
  ernåelig_1_A = mkA "ernåelig" ; -- ernåelig..av.1
  ernående_1_N = mkN "ernående" ; -- ernående..nn.1
  erodera_1_V = mkV "eroderar" ; -- erodera..vb.1
  eroderande_1_N = mkN "eroderande" ; -- eroderande..nn.1
  eroderbar_1_A = mkA "eroderbar" ; -- eroderbar..av.1
  eroderbarhet_1_N = mkN "eroderbarhet" ; -- eroderbarhet..nn.1
  erodering_1_N = mkN "erodering" ; -- erodering..nn.1
  erogen_1_A = mkA "erogen" "erogent" ; -- erogen..av.1
  erosion_1_N = mkN "erosion" ; -- erosion..nn.1
  erosionsskada_1_N = mkN "erosionsskada" ; -- erosionsskada..nn.1
  erosionsstrand_1_N = mkN "erosionsstrand" "erosionsstränder" ; -- erosionsstrand..nn.1
  erotik_1_N = mkN "erotik" ; -- erotik..nn.1
  erotiker_1_N = mkN "erotiker" "erotikern" "erotiker" "erotikerna" ; -- erotiker..nn.1
  erotisera_1_V = mkV "erotiserar" ; -- erotisera..vb.1
  erotiserande_1_N = mkN "erotiserande" ; -- erotiserande..nn.1
  erotisering_1_N = mkN "erotisering" ; -- erotisering..nn.1
  erotisk_1_A = mkA "erotisk" ; -- erotisk..av.1
  erotogen_1_A = mkA "erotogen" "erotogent" ; -- erotogen..av.1
  erotoman_1_A = mkA "erotoman" ; -- erotoman..av.1
  erotoman_1_N = mkN "erotoman" "erotomaner" ; -- erotoman..nn.1
  erotomani_1_N = mkN "erotomani" ; -- erotomani..nn.1
  errata_1_N = mkN "errata" "erratan" "errata" "erratana" ; -- errata..nn.1
  erratisk_1_A = mkA "erratisk" ; -- erratisk..av.1
  ersmässa_1_N = mkN "ersmässa" ; -- ersmässa..nn.1
  ersätta_1_V = mkV "ersätta" "ersätter" "ersätt" "ersatte" "ersatt" "ersatt" ; -- ersätta..vb.1
  ersättande_1_N = mkN "ersättande" ; -- ersättande..nn.1
  ersättare_1_N = mkN "ersättare" utrum  ; -- ersättare..nn.1
  ersättlig_1_A = mkA "ersättlig" ; -- ersättlig..av.1
  ersättlighet_1_N = mkN "ersättlighet" ; -- ersättlighet..nn.1
  ersättning_1_N = mkN "ersättning" ; -- ersättning..nn.1
  ersättningsanspråk_1_N = mkN "ersättningsanspråk" neutrum  ; -- ersättningsanspråk..nn.1
  ersättningsansvar_1_N = mkN "ersättningsansvar" neutrum  ; -- ersättningsansvar..nn.1
  ersättningsbelopp_1_N = mkN "ersättningsbelopp" neutrum  ; -- ersättningsbelopp..nn.1
  ersättningsberättigad_1_A = mkA "ersättningsberättigad" ; -- ersättningsberättigad..av.1
  ersättningsbuss_1_N = mkN "ersättningsbuss" ; -- ersättningsbuss..nn.1
  ersättningsnivå_1_N = mkN "ersättningsnivå" "ersättningsnivåer" ; -- ersättningsnivå..nn.1
  ersättningsskyldig_1_A = mkA "ersättningsskyldig" ; -- ersättningsskyldig..av.1
  ersättningsskyldighet_1_N = mkN "ersättningsskyldighet" ; -- ersättningsskyldighet..nn.1
  ertappa_1_V = mkV "ertappar" ; -- ertappa..vb.1
  ertappande_1_N = mkN "ertappande" ; -- ertappande..nn.1
  ertappning_1_N = mkN "ertappning" ; -- ertappning..nn.1
  eruption_1_N = mkN "eruption" ; -- eruption..nn.1
  eruptiv_1_A = mkA "eruptiv" ; -- eruptiv..av.1
  eruptivbergart_1_N = mkN "eruptivbergart" "eruptivbergarter" ; -- eruptivbergart..nn.1
  erytropoitin_1_N = mkN "erytropoitin" "erytropoitiner" ; -- erytropoitin..nn.1
  erövra_1_V = mkV "erövrar" ; -- erövra..vb.1
  erövrande_1_N = mkN "erövrande" ; -- erövrande..nn.1
  erövrare_1_N = mkN "erövrare" utrum  ; -- erövrare..nn.1
  erövring_1_N = mkN "erövring" ; -- erövring..nn.1
  erövringslysten_1_A = mkA "erövringslysten" ; -- erövringslysten..av.1
  erövringståg_1_N = mkN "erövringståg" neutrum  ; -- erövringståg..nn.1
  escudo_1_N = mkN "escudo" "escudon" "escudos" "escudosarna" ; -- escudo..nn.1
  eselhuvud_1_N = mkN "eselhuvud" "eselhuvudet" "eselhuvud" "eselhuvudena" ; -- eselhuvud..nn.1
  eskader_1_N = mkN "eskader" ; -- eskader..nn.1
  eskalation_1_N = mkN "eskalation" ; -- eskalation..nn.1
  eskalera_1_V = mkV "eskalerar" ; -- eskalera..vb.1
  eskalerande_1_N = mkN "eskalerande" ; -- eskalerande..nn.1
  eskalerbar_1_A = mkA "eskalerbar" ; -- eskalerbar..av.1
  eskalerbarhet_1_N = mkN "eskalerbarhet" ; -- eskalerbarhet..nn.1
  eskalering_1_N = mkN "eskalering" ; -- eskalering..nn.1
  eskapad_1_N = mkN "eskapad" "eskapader" ; -- eskapad..nn.1
  eskapism_1_N = mkN "eskapism" "eskapismer" ; -- eskapism..nn.1
  eskapistisk_1_A = mkA "eskapistisk" ; -- eskapistisk..av.1
  eskarp_1_N = mkN "eskarp" "eskarper" ; -- eskarp..nn.1
  eskatolog_1_N = mkN "eskatolog" "eskatologer" ; -- eskatolog..nn.1
  eskatologi_1_N = mkN "eskatologi" ; -- eskatologi..nn.1
  eskatologisk_1_A = mkA "eskatologisk" ; -- eskatologisk..av.1
  eskimå_1_N = mkN "eskimå" "eskimåer" ; -- eskimå..nn.1
  eskimåhund_1_N = mkN "eskimåhund" ; -- eskimåhund..nn.1
  eskimåiska_1_N = mkN "eskimåiska" ; -- eskimåiska..nn.1
  eskort_1_N = mkN "eskort" "eskorter" ; -- eskort..nn.1
  eskortbransch_1_N = mkN "eskortbransch" ; -- eskortbransch..nn.1
  eskortera_1_V = mkV "eskorterar" ; -- eskortera..vb.1
  eskorterande_1_N = mkN "eskorterande" ; -- eskorterande..nn.1
  eskorterbar_1_A = mkA "eskorterbar" ; -- eskorterbar..av.1
  eskorterbarhet_1_N = mkN "eskorterbarhet" ; -- eskorterbarhet..nn.1
  eskortering_1_N = mkN "eskortering" ; -- eskortering..nn.1
  eskortflicka_1_N = mkN "eskortflicka" ; -- eskortflicka..nn.1
  eskortkvinna_1_N = mkN "eskortkvinna" ; -- eskortkvinna..nn.1
  eskulap_1_N = mkN "eskulap" "eskulaper" ; -- eskulap..nn.1
  eskulapstav_1_N = mkN "eskulapstav" ; -- eskulapstav..nn.1
  esoterisk_1_A = mkA "esoterisk" ; -- esoterisk..av.1
  espadrill_1_N = mkN "espadrill" "espadriller" ; -- espadrill..nn.1
  espagnolett_1_N = mkN "espagnolett" "espagnoletter" ; -- espagnolett..nn.1
  esparto_1_N = mkN "esparto" ; -- esparto..nn.1
  espartogräs_1_N = mkN "espartogräs" neutrum  ; -- espartogräs..nn.1
  esperantist_1_N = mkN "esperantist" "esperantister" ; -- esperantist..nn.1
  esperanto_1_N = mkN "esperanto" ; -- esperanto..nn.1
  esplanad_1_N = mkN "esplanad" "esplanader" ; -- esplanad..nn.1
  espresso_1_N = mkN "espresso" ; -- espresso..nn.1
  espressobryggare_1_N = mkN "espressobryggare" utrum  ; -- espressobryggare..nn.1
  espri_1_N = mkN "espri" ; -- espri..nn.1
  espri_2_N = mkN "espri" "esprier" ; -- espri..nn.2
  esprit_1_N = mkN "esprit" ; -- esprit..nn.1
  esprit_2_N = mkN "esprit" "espriter" ; -- esprit..nn.2
  ess_1_N = mkN "ess" neutrum  ; -- ess..nn.1
  essay_1_N = mkN "essay" "essayer" ; -- essay..nn.1
  essayist_1_N = mkN "essayist" "essayister" ; -- essayist..nn.1
  essayistik_1_N = mkN "essayistik" "essayistiker" ; -- essayistik..nn.1
  essayistisk_1_A = mkA "essayistisk" ; -- essayistisk..av.1
  essaysamling_1_N = mkN "essaysamling" ; -- essaysamling..nn.1
  essens_1_N = mkN "essens" ; -- essens..nn.1
  essens_2_N = mkN "essens" "essenser" ; -- essens..nn.2
  essentiell_1_A = mkA "essentiell" ; -- essentiell..av.1
  essiv_1_N = mkN "essiv" "essiver" ; -- essiv..nn.1
  essä_1_N = mkN "essä" "essän" "essäer" "essäerna" ; -- essä..nn.1
  essäbok_1_N = mkN "essäbok" "essäböcker" ; -- essäbok..nn.1
  essäfråga_1_N = mkN "essäfråga" ; -- essäfråga..nn.1
  essäist_1_N = mkN "essäist" "essäister" ; -- essäist..nn.1
  essäistik_1_N = mkN "essäistik" ; -- essäistik..nn.1
  essäistisk_1_A = mkA "essäistisk" ; -- essäistisk..av.1
  essäsamling_1_N = mkN "essäsamling" ; -- essäsamling..nn.1
  essäskrivande_1_A = mkA "essäskrivande" ; -- essäskrivande..av.1
  essäskrivande_1_N = mkN "essäskrivande" ; -- essäskrivande..nn.1
  essäuppgift_1_N = mkN "essäuppgift" "essäuppgifter" ; -- essäuppgift..nn.1
  est_1_N = mkN "est" "ester" ; -- est..nn.1
  ester_1_N = mkN "ester" ; -- ester..nn.1
  esterplast_1_N = mkN "esterplast" "esterplaster" ; -- esterplast..nn.1
  estet_1_N = mkN "estet" "esteter" ; -- estet..nn.1
  esteticera_1_V = mkV "esteticerar" ; -- esteticera..vb.1
  esteticerande_1_N = mkN "esteticerande" ; -- esteticerande..nn.1
  esteticerbar_1_A = mkA "esteticerbar" ; -- esteticerbar..av.1
  esteticerbarhet_1_N = mkN "esteticerbarhet" ; -- esteticerbarhet..nn.1
  esteticering_1_N = mkN "esteticering" ; -- esteticering..nn.1
  esteticism_1_N = mkN "esteticism" "esteticismer" ; -- esteticism..nn.1
  estetik_1_N = mkN "estetik" ; -- estetik..nn.1
  estetiker_1_N = mkN "estetiker" "estetikern" "estetiker" "estetikerna" ; -- estetiker..nn.1
  estetisera_1_V = mkV "estetiserar" ; -- estetisera..vb.1
  estetiserande_1_N = mkN "estetiserande" ; -- estetiserande..nn.1
  estetiserbar_1_A = mkA "estetiserbar" ; -- estetiserbar..av.1
  estetiserbarhet_1_N = mkN "estetiserbarhet" ; -- estetiserbarhet..nn.1
  estetisering_1_N = mkN "estetisering" ; -- estetisering..nn.1
  estetisk_1_A = mkA "estetisk" ; -- estetisk..av.1
  estimera_1_V = mkV "estimerar" ; -- estimera..vb.1
  estimerande_1_N = mkN "estimerande" ; -- estimerande..nn.1
  estimerbar_1_A = mkA "estimerbar" ; -- estimerbar..av.1
  estimerbarhet_1_N = mkN "estimerbarhet" ; -- estimerbarhet..nn.1
  estimering_1_N = mkN "estimering" ; -- estimering..nn.1
  estländare_1_N = mkN "estländare" utrum  ; -- estländare..nn.1
  estländsk_1_A = mkA "estländsk" ; -- estländsk..av.1
  estländska_1_N = mkN "estländska" ; -- estländska..nn.1
  estnisk_1_A = mkA "estnisk" ; -- estnisk..av.1
  estniska_1_N = mkN "estniska" ; -- estniska..nn.1
  estniska_2_N = mkN "estniska" ; -- estniska..nn.2
  estrad_1_N = mkN "estrad" "estrader" ; -- estrad..nn.1
  estradartist_1_N = mkN "estradartist" "estradartister" ; -- estradartist..nn.1
  estraddebatt_1_N = mkN "estraddebatt" "estraddebatter" ; -- estraddebatt..nn.1
  estradplats_1_N = mkN "estradplats" "estradplatser" ; -- estradplats..nn.1
  estradsamtal_1_N = mkN "estradsamtal" neutrum  ; -- estradsamtal..nn.1
  estradör_1_N = mkN "estradör" "estradörer" ; -- estradör..nn.1
  eta_1_N = mkN "eta" "etat" "etan" "etana" ; -- eta..nn.1
  etablera_1_V = mkV "etablerar" ; -- etablera..vb.1
  etablerad_1_A = mkA "etablerad" ; -- etablerad..av.1
  etablerande_1_N = mkN "etablerande" ; -- etablerande..nn.1
  etablerbar_1_A = mkA "etablerbar" ; -- etablerbar..av.1
  etablerbarhet_1_N = mkN "etablerbarhet" ; -- etablerbarhet..nn.1
  etablering_1_N = mkN "etablering" ; -- etablering..nn.1
  etablissemang_1_N = mkN "etablissemang" neutrum  ; -- etablissemang..nn.1
  etablissemangsföreträdare_1_N = mkN "etablissemangsföreträdare" utrum  ; -- etablissemangsföreträdare..nn.1
  etablissement_1_N = mkN "etablissement" neutrum  ; -- etablissement..nn.1
  etage_1_N = mkN "etage" "etagen" "etage" "etagen" ; -- etage..nn.1
  etagevåning_1_N = mkN "etagevåning" ; -- etagevåning..nn.1
  etagär_1_N = mkN "etagär" "etagärer" ; -- etagär..nn.1
  etalong_1_N = mkN "etalong" "etalonger" ; -- etalong..nn.1
  etan_1_N = mkN "etan" "etaner" ; -- etan..nn.1
  etanol_1_N = mkN "etanol" ; -- etanol..nn.1
  etanolbil_1_N = mkN "etanolbil" ; -- etanolbil..nn.1
  etanoldriven_1_A = mkA "etanoldriven" ; -- etanoldriven..av.1
  etapp_1_N = mkN "etapp" "etapper" ; -- etapp..nn.1
  etapplinje_1_N = mkN "etapplinje" "etapplinjer" ; -- etapplinje..nn.1
  etappstation_1_N = mkN "etappstation" ; -- etappstation..nn.1
  etappvis_1_Adv = mkAdv "etappvis" ; -- etappvis..ab.1
  etappväsen_1_N = mkN "etappväsen" neutrum  ; -- etappväsen..nn.1
  eten_1_N = mkN "eten" neutrum  ; -- eten..nn.1
  etenplast_1_N = mkN "etenplast" ; -- etenplast..nn.1
  eter_1_N = mkN "eter" ; -- eter..nn.1
  eter_2_N = mkN "eter" ; -- eter..nn.2
  eterflaska_1_N = mkN "eterflaska" ; -- eterflaska..nn.1
  eterisation_1_N = mkN "eterisation" ; -- eterisation..nn.1
  eterisera_1_V = mkV "eteriserar" ; -- eterisera..vb.1
  eteriserande_1_N = mkN "eteriserande" ; -- eteriserande..nn.1
  eteriserbar_1_A = mkA "eteriserbar" ; -- eteriserbar..av.1
  eteriserbarhet_1_N = mkN "eteriserbarhet" ; -- eteriserbarhet..nn.1
  eterisering_1_N = mkN "eterisering" ; -- eterisering..nn.1
  eterisk_1_A = mkA "eterisk" ; -- eterisk..av.1
  etermediemonopol_1_N = mkN "etermediemonopol" neutrum  ; -- etermediemonopol..nn.1
  etermedium_1_N = mkN "etermedium" "etermediet" "etermedia" "etermediana" ; -- etermedium..nn.1
  eternell_1_N = mkN "eternell" "eterneller" ; -- eternell..nn.1
  etik_1_N = mkN "etik" ; -- etik..nn.1
  etiker_1_N = mkN "etiker" "etikern" "etiker" "etikerna" ; -- etiker..nn.1
  etikett_1_N = mkN "etikett" "etiketter" ; -- etikett..nn.1
  etikettera_1_V = mkV "etiketterar" ; -- etikettera..vb.1
  etiketterande_1_N = mkN "etiketterande" ; -- etiketterande..nn.1
  etiketterbar_1_A = mkA "etiketterbar" ; -- etiketterbar..av.1
  etiketterbarhet_1_N = mkN "etiketterbarhet" ; -- etiketterbarhet..nn.1
  etikettering_1_N = mkN "etikettering" ; -- etikettering..nn.1
  etikettmoln_1_N = mkN "etikettmoln" neutrum  ; -- etikettmoln..nn.1
  etikettråd_1_N = mkN "etikettråd" neutrum  ; -- etikettråd..nn.1
  etikettsfel_1_N = mkN "etikettsfel" "etikettsfelet" "etikettsfel" "etikettsfelen" ; -- etikettsfel..nn.1
  etikettsfråga_1_N = mkN "etikettsfråga" ; -- etikettsfråga..nn.1
  etikettsmässig_1_A = mkA "etikettsmässig" ; -- etikettsmässig..av.1
  etikpröva_1_V = mkV "etikprövar" ; -- etikpröva..vb.1
  etikprövande_1_N = mkN "etikprövande" ; -- etikprövande..nn.1
  etikprövning_1_N = mkN "etikprövning" ; -- etikprövning..nn.1
  etikprövningslag_1_N = mkN "etikprövningslag" ; -- etikprövningslag..nn.1
  etiolering_1_N = mkN "etiolering" ; -- etiolering..nn.1
  etiologi_1_N = mkN "etiologi" ; -- etiologi..nn.1
  etiologisk_1_A = mkA "etiologisk" ; -- etiologisk..av.1
  etiop_1_N = mkN "etiop" "etioper" ; -- etiop..nn.1
  etiopier_1_N = mkN "etiopier" "etiopiern" "etiopier" "etiopierna" ; -- etiopier..nn.1
  etiopisk_1_A = mkA "etiopisk" ; -- etiopisk..av.1
  etiopiska_1_N = mkN "etiopiska" ; -- etiopiska..nn.1
  etiopiska_2_N = mkN "etiopiska" ; -- etiopiska..nn.2
  etisk_1_A = mkA "etisk" ; -- etisk..av.1
  etnicitet_1_N = mkN "etnicitet" "etniciteter" ; -- etnicitet..nn.1
  etnifiera_1_V = mkV "etnifierar" ; -- etnifiera..vb.1
  etnifierande_1_N = mkN "etnifierande" ; -- etnifierande..nn.1
  etnifierbar_1_A = mkA "etnifierbar" ; -- etnifierbar..av.1
  etnifierbarhet_1_N = mkN "etnifierbarhet" "etnifierbarheter" ; -- etnifierbarhet..nn.1
  etnifiering_1_N = mkN "etnifiering" ; -- etnifiering..nn.1
  etnisk_1_A = mkA "etnisk" ; -- etnisk..av.1
  etnocentrisk_1_A = mkA "etnocentrisk" ; -- etnocentrisk..av.1
  etnocentrism_1_N = mkN "etnocentrism" "etnocentrismer" ; -- etnocentrism..nn.1
  etnograf_1_N = mkN "etnograf" "etnografer" ; -- etnograf..nn.1
  etnografi_1_N = mkN "etnografi" ; -- etnografi..nn.1
  etnografisk_1_A = mkA "etnografisk" ; -- etnografisk..av.1
  etnolog_1_N = mkN "etnolog" "etnologer" ; -- etnolog..nn.1
  etnologi_1_N = mkN "etnologi" ; -- etnologi..nn.1
  etnologisk_1_A = mkA "etnologisk" ; -- etnologisk..av.1
  etolog_1_N = mkN "etolog" "etologer" ; -- etolog..nn.1
  etologi_1_N = mkN "etologi" ; -- etologi..nn.1
  etologisk_1_A = mkA "etologisk" ; -- etologisk..av.1
  etrusk_1_N = mkN "etrusk" "etrusker" ; -- etrusk..nn.1
  etrusker_1_N = mkN "etrusker" "etruskern" "etrusker" "etruskerna" ; -- etrusker..nn.1
  etruskisk_1_A = mkA "etruskisk" ; -- etruskisk..av.1
  etruskiska_1_N = mkN "etruskiska" ; -- etruskiska..nn.1
  etruskiska_2_N = mkN "etruskiska" ; -- etruskiska..nn.2
  etruskologi_1_N = mkN "etruskologi" ; -- etruskologi..nn.1
  etsa_1_V = mkV "etsar" ; -- etsa..vb.1
  etsande_1_N = mkN "etsande" ; -- etsande..nn.1
  etsare_1_N = mkN "etsare" utrum  ; -- etsare..nn.1
  etsmedel_1_N = mkN "etsmedel" neutrum  ; -- etsmedel..nn.1
  etsning_1_N = mkN "etsning" ; -- etsning..nn.1
  etsnål_1_N = mkN "etsnål" ; -- etsnål..nn.1
  ett_tu_tre_1_Adv = mkAdv "ett-tu-tre" ; -- ett-tu-tre..ab.1
  ett_1_A = mkA "ett" ; -- ett..av.1
  etta_1_N = mkN "etta" ; -- etta..nn.1
  etter_1_N = mkN "etter" neutrum  ; -- etter..nn.1
  ettermyra_1_N = mkN "ettermyra" ; -- ettermyra..nn.1
  ettrig_1_A = mkA "ettrig" ; -- ettrig..av.1
  ettrighet_1_N = mkN "ettrighet" ; -- ettrighet..nn.1
  ettrumslägenhet_1_N = mkN "ettrumslägenhet" "ettrumslägenheter" ; -- ettrumslägenhet..nn.1
  ettstruken_1_A = mkA "ettstruken" ; -- ettstruken..av.1
  ettårig_1_A = mkA "ettårig" ; -- ettårig..av.1
  ettåring_1_N = mkN "ettåring" ; -- ettåring..nn.1
  ettöring_1_N = mkN "ettöring" ; -- ettöring..nn.1
  etui_1_N = mkN "etui" "etuit" "etuin" "etuien" ; -- etui..nn.1
  etyd_1_N = mkN "etyd" "etyder" ; -- etyd..nn.1
  etyl_1_N = mkN "etyl" ; -- etyl..nn.1
  etylalkohol_1_N = mkN "etylalkohol" ; -- etylalkohol..nn.1
  etylen_1_N = mkN "etylen" neutrum  ; -- etylen..nn.1
  etymolog_1_N = mkN "etymolog" "etymologer" ; -- etymolog..nn.1
  etymologi_1_N = mkN "etymologi" "etymologier" ; -- etymologi..nn.1
  etymologisera_1_V = mkV "etymologiserar" ; -- etymologisera..vb.1
  etymologiserande_1_N = mkN "etymologiserande" ; -- etymologiserande..nn.1
  etymologiserbar_1_A = mkA "etymologiserbar" ; -- etymologiserbar..av.1
  etymologiserbarhet_1_N = mkN "etymologiserbarhet" ; -- etymologiserbarhet..nn.1
  etymologisering_1_N = mkN "etymologisering" ; -- etymologisering..nn.1
  etymologisk_1_A = mkA "etymologisk" ; -- etymologisk..av.1
  etyn_1_N = mkN "etyn" neutrum  ; -- etyn..nn.1
  eudemonism_1_N = mkN "eudemonism" "eudemonismer" ; -- eudemonism..nn.1
  eufemism_1_N = mkN "eufemism" "eufemismer" ; -- eufemism..nn.1
  eufemistisk_1_A = mkA "eufemistisk" ; -- eufemistisk..av.1
  eufoni_1_N = mkN "eufoni" "eufonier" ; -- eufoni..nn.1
  euforbia_1_N = mkN "euforbia" ; -- euforbia..nn.1
  eufori_1_N = mkN "eufori" "euforier" ; -- eufori..nn.1
  euforisk_1_A = mkA "euforisk" ; -- euforisk..av.1
  eugenik_1_N = mkN "eugenik" ; -- eugenik..nn.1
  eukalyptus_1_N = mkN "eukalyptus" ; -- eukalyptus..nn.1
  eukalyptusdoftande_1_A = mkA "eukalyptusdoftande" ; -- eukalyptusdoftande..av.1
  eukalyptusolja_1_N = mkN "eukalyptusolja" ; -- eukalyptusolja..nn.1
  eukaryot_1_N = mkN "eukaryot" "eukaryoter" ; -- eukaryot..nn.1
  euklidisk_1_A = mkA "euklidisk" ; -- euklidisk..av.1
  eumenid_1_N = mkN "eumenid" "eumenider" ; -- eumenid..nn.1
  eunuck_1_N = mkN "eunuck" "eunucker" ; -- eunuck..nn.1
  eurasier_1_N = mkN "eurasier" "eurasiern" "eurasier" "eurasierna" ; -- eurasier..nn.1
  eurasisk_1_A = mkA "eurasisk" ; -- eurasisk..av.1
  eurasiska_1_N = mkN "eurasiska" ; -- eurasiska..nn.1
  euro_1_N = mkN "euro" "euron" "euro" "eurona" ; -- euro..nn.1
  eurodollar_1_N = mkN "eurodollar" "eurodollarn" "eurodollar" "eurodollarna" ; -- eurodollar..nn.1
  euroislam_1_N = mkN "euroislam" ; -- euroislam..nn.1
  eurokalabalik_1_N = mkN "eurokalabalik" "eurokalabaliker" ; -- eurokalabalik..nn.1
  eurokommunism_1_N = mkN "eurokommunism" "eurokommunismer" ; -- eurokommunism..nn.1
  eurokommunistisk_1_A = mkA "eurokommunistisk" ; -- eurokommunistisk..av.1
  eurokris_1_N = mkN "eurokris" "eurokriser" ; -- eurokris..nn.1
  euroland_1_N = mkN "euroland" "eurolandet" "euroländer" "euroländerna" ; -- euroland..nn.1
  europabörs_1_N = mkN "europabörs" "europabörser" ; -- europabörs..nn.1
  europamästare_1_N = mkN "europamästare" utrum  ; -- europamästare..nn.1
  europamästerskap_1_N = mkN "europamästerskap" neutrum  ; -- europamästerskap..nn.1
  europaparlamentsval_1_N = mkN "europaparlamentsval" neutrum  ; -- europaparlamentsval..nn.1
  europaväg_1_N = mkN "europaväg" ; -- europaväg..nn.1
  europavänster_1_N = mkN "europavänster" ; -- europavänster..nn.1
  europeisera_1_V = mkV "europeiserar" ; -- europeisera..vb.1
  europeiserande_1_N = mkN "europeiserande" ; -- europeiserande..nn.1
  europeiserbar_1_A = mkA "europeiserbar" ; -- europeiserbar..av.1
  europeiserbarhet_1_N = mkN "europeiserbarhet" ; -- europeiserbarhet..nn.1
  europeisering_1_N = mkN "europeisering" ; -- europeisering..nn.1
  europeisk_1_A = mkA "europeisk" ; -- europeisk..av.1
  europeiska_1_N = mkN "europeiska" ; -- europeiska..nn.1
  europid_1_A = mkA "europid" ; -- europid..av.1
  europid_1_N = mkN "europid" "europider" ; -- europid..nn.1
  europium_1_N = mkN "europium" ; -- europium..nn.1
  europé_1_N = mkN "europé" "européer" ; -- europé..nn.1
  eurosamarbete_1_N = mkN "eurosamarbete" ; -- eurosamarbete..nn.1
  euroskeptisk_1_A = mkA "euroskeptisk" ; -- euroskeptisk..av.1
  eurovaluta_1_N = mkN "eurovaluta" ; -- eurovaluta..nn.1
  eurovision_1_N = mkN "eurovision" ; -- eurovision..nn.1
  eurytmi_1_N = mkN "eurytmi" "eurytmier" ; -- eurytmi..nn.1
  eusocialitet_1_N = mkN "eusocialitet" ; -- eusocialitet..nn.1
  eutanasi_1_N = mkN "eutanasi" ; -- eutanasi..nn.1
  eutrof_1_A = mkA "eutrof" ; -- eutrof..av.1
  eva_1_N = mkN "eva" ; -- eva..nn.1
  evakostym_1_N = mkN "evakostym" "evakostymer" ; -- evakostym..nn.1
  evakuera_1_V = mkV "evakuerar" ; -- evakuera..vb.1
  evakuerande_1_N = mkN "evakuerande" ; -- evakuerande..nn.1
  evakuerbar_1_A = mkA "evakuerbar" ; -- evakuerbar..av.1
  evakuerbarhet_1_N = mkN "evakuerbarhet" ; -- evakuerbarhet..nn.1
  evakuering_1_N = mkN "evakuering" ; -- evakuering..nn.1
  evaluera_1_V = mkV "evaluerar" ; -- evaluera..vb.1
  evaluerande_1_N = mkN "evaluerande" ; -- evaluerande..nn.1
  evaluerbar_1_A = mkA "evaluerbar" ; -- evaluerbar..av.1
  evaluerbarhet_1_N = mkN "evaluerbarhet" ; -- evaluerbarhet..nn.1
  evaluering_1_N = mkN "evaluering" ; -- evaluering..nn.1
  evalvera_1_V = mkV "evalverar" ; -- evalvera..vb.1
  evalverande_1_N = mkN "evalverande" ; -- evalverande..nn.1
  evalverbar_1_A = mkA "evalverbar" ; -- evalverbar..av.1
  evalverbarhet_1_N = mkN "evalverbarhet" ; -- evalverbarhet..nn.1
  evalvering_1_N = mkN "evalvering" ; -- evalvering..nn.1
  evangeliebok_1_N = mkN "evangeliebok" "evangelieböcker" ; -- evangeliebok..nn.1
  evangelietext_1_N = mkN "evangelietext" "evangelietexter" ; -- evangelietext..nn.1
  evangelisation_1_N = mkN "evangelisation" ; -- evangelisation..nn.1
  evangelisera_1_V = mkV "evangeliserar" ; -- evangelisera..vb.1
  evangeliserande_1_N = mkN "evangeliserande" ; -- evangeliserande..nn.1
  evangelisering_1_N = mkN "evangelisering" ; -- evangelisering..nn.1
  evangelisk_1_A = mkA "evangelisk" ; -- evangelisk..av.1
  evangelist_1_N = mkN "evangelist" "evangelister" ; -- evangelist..nn.1
  evangelium_1_N = mkN "evangelium" "evangeliet" "evangelier" "evangelierna" ; -- evangelium..nn.1
  evaporation_1_N = mkN "evaporation" ; -- evaporation..nn.1
  evaporera_1_V = mkV "evaporerar" ; -- evaporera..vb.1
  evaporerande_1_N = mkN "evaporerande" ; -- evaporerande..nn.1
  evaporerbar_1_A = mkA "evaporerbar" ; -- evaporerbar..av.1
  evaporerbarhet_1_N = mkN "evaporerbarhet" ; -- evaporerbarhet..nn.1
  evaporering_1_N = mkN "evaporering" ; -- evaporering..nn.1
  evart_1_Adv = mkAdv "evart" ; -- evart..ab.1
  evenemang_1_N = mkN "evenemang" neutrum  ; -- evenemang..nn.1
  eventualitet_1_N = mkN "eventualitet" "eventualiteter" ; -- eventualitet..nn.1
  eventuell_1_A = mkA "eventuell" ; -- eventuell..av.1
  evergreen_1_N = mkN "evergreen" "evergreenen" "evergreens" "evergreensarna" ; -- evergreen..nn.1
  evertebrat_1_N = mkN "evertebrat" "evertebrater" ; -- evertebrat..nn.1
  evidens_1_N = mkN "evidens" ; -- evidens..nn.1
  evidensbaserad_1_A = mkA "evidensbaserad" ; -- evidensbaserad..av.1
  evident_1_A = mkA "evident" "evident" ; -- evident..av.1
  evig_1_A = mkA "evig" ; -- evig..av.1
  evighet_1_N = mkN "evighet" "evigheter" ; -- evighet..nn.1
  evighetsblomma_1_N = mkN "evighetsblomma" ; -- evighetsblomma..nn.1
  evighetsfilter_1_N = mkN "evighetsfilter" neutrum  ; -- evighetsfilter..nn.1
  evighetsgäldenär_1_N = mkN "evighetsgäldenär" "evighetsgäldenärer" ; -- evighetsgäldenär..nn.1
  evighetskalender_1_N = mkN "evighetskalender" ; -- evighetskalender..nn.1
  evighetslång_1_A = mkA "evighetslång" ; -- evighetslång..av.1
  evighetsmaskin_1_N = mkN "evighetsmaskin" "evighetsmaskiner" ; -- evighetsmaskin..nn.1
  evinnerlig_1_A = mkA "evinnerlig" ; -- evinnerlig..av.1
  evinnerligen_1_Adv = mkAdv "evinnerligen" ; -- evinnerligen..ab.1
  evinnerlighet_1_N = mkN "evinnerlighet" ; -- evinnerlighet..nn.1
  evolution_1_N = mkN "evolution" ; -- evolution..nn.1
  evolutionism_1_N = mkN "evolutionism" "evolutionismer" ; -- evolutionism..nn.1
  evolutionist_1_N = mkN "evolutionist" "evolutionister" ; -- evolutionist..nn.1
  evolutionistisk_1_A = mkA "evolutionistisk" ; -- evolutionistisk..av.1
  evolutionsbiolog_1_N = mkN "evolutionsbiolog" "evolutionsbiologer" ; -- evolutionsbiolog..nn.1
  evolutionsforskning_1_N = mkN "evolutionsforskning" ; -- evolutionsforskning..nn.1
  evolutionsmekanism_1_N = mkN "evolutionsmekanism" "evolutionsmekanismer" ; -- evolutionsmekanism..nn.1
  evolutionsmässig_1_A = mkA "evolutionsmässig" ; -- evolutionsmässig..av.1
  evolutionsmässighet_1_N = mkN "evolutionsmässighet" ; -- evolutionsmässighet..nn.1
  evolutionsteori_1_N = mkN "evolutionsteori" "evolutionsteorier" ; -- evolutionsteori..nn.1
  evolutionär_1_A = mkA "evolutionär" ; -- evolutionär..av.1
  evärdlig_1_A = mkA "evärdlig" ; -- evärdlig..av.1
  evärdlighet_1_N = mkN "evärdlighet" ; -- evärdlighet..nn.1
  ex_1_N = mkN "ex" neutrum  ; -- ex..nn.1
  exabyte_1_N = mkN "exabyte" "exabyten" "exabyte" "exabytena" ; -- exabyte..nn.1
  exakt_1_A = mkA "exakt" "exakt" ; -- exakt..av.1
  exakthet_1_N = mkN "exakthet" "exaktheter" ; -- exakthet..nn.1
  exaltation_1_N = mkN "exaltation" ; -- exaltation..nn.1
  exalterad_1_A = mkA "exalterad" ; -- exalterad..av.1
  examen_1_N = mkN "examen" "examen" "examina" "examina" ; -- examen..nn.1
  examensarbete_1_N = mkN "examensarbete" ; -- examensarbete..nn.1
  examensfråga_1_N = mkN "examensfråga" ; -- examensfråga..nn.1
  examensuppgift_1_N = mkN "examensuppgift" "examensuppgifter" ; -- examensuppgift..nn.1
  examinand_1_N = mkN "examinand" "examinander" ; -- examinand..nn.1
  examination_1_N = mkN "examination" ; -- examination..nn.1
  examinator_1_N = mkN "examinator" "examinatorer" ; -- examinator..nn.1
  examinatorium_1_N = mkN "examinatorium" "examinatoriet" "examinatorier" "examinatorierna" ; -- examinatorium..nn.1
  examinera_1_V = mkV "examinerar" ; -- examinera..vb.1
  examinerande_1_N = mkN "examinerande" ; -- examinerande..nn.1
  examinerbar_1_A = mkA "examinerbar" ; -- examinerbar..av.1
  examinerbarhet_1_N = mkN "examinerbarhet" ; -- examinerbarhet..nn.1
  examinering_1_N = mkN "examinering" ; -- examinering..nn.1
  exantem_1_N = mkN "exantem" neutrum  ; -- exantem..nn.1
  excellens_1_N = mkN "excellens" "excellenser" ; -- excellens..nn.1
  excellent_1_A = mkA "excellent" "excellent" ; -- excellent..av.1
  excellera_1_V = mkV "excellerar" ; -- excellera..vb.1
  excellerande_1_N = mkN "excellerande" ; -- excellerande..nn.1
  excellering_1_N = mkN "excellering" ; -- excellering..nn.1
  excenter_1_N = mkN "excenter" ; -- excenter..nn.1
  excenteraxel_1_N = mkN "excenteraxel" ; -- excenteraxel..nn.1
  excenterskiva_1_N = mkN "excenterskiva" ; -- excenterskiva..nn.1
  excenterstång_1_N = mkN "excenterstång" "excenterstänger" ; -- excenterstång..nn.1
  excentricitet_1_N = mkN "excentricitet" "excentriciteter" ; -- excentricitet..nn.1
  excentriker_1_N = mkN "excentriker" "excentrikern" "excentriker" "excentrikerna" ; -- excentriker..nn.1
  excentrisk_1_A = mkA "excentrisk" ; -- excentrisk..av.1
  exceptionell_1_A = mkA "exceptionell" ; -- exceptionell..av.1
  excerpera_1_V = mkV "excerperar" ; -- excerpera..vb.1
  excerperande_1_N = mkN "excerperande" ; -- excerperande..nn.1
  excerperbar_1_A = mkA "excerperbar" ; -- excerperbar..av.1
  excerperbarhet_1_N = mkN "excerperbarhet" ; -- excerperbarhet..nn.1
  excerpering_1_N = mkN "excerpering" ; -- excerpering..nn.1
  excerpist_1_N = mkN "excerpist" "excerpister" ; -- excerpist..nn.1
  excerpt_1_N = mkN "excerpt" "excerpter" ; -- excerpt..nn.1
  excess_1_N = mkN "excess" "excesser" ; -- excess..nn.1
  excessiv_1_A = mkA "excessiv" ; -- excessiv..av.1
  excision_1_N = mkN "excision" ; -- excision..nn.1
  excitation_1_N = mkN "excitation" ; -- excitation..nn.1
  excitera_1_V = mkV "exciterar" ; -- excitera..vb.1
  exciterande_1_N = mkN "exciterande" ; -- exciterande..nn.1
  exciterbar_1_A = mkA "exciterbar" ; -- exciterbar..av.1
  exciterbarhet_1_N = mkN "exciterbarhet" ; -- exciterbarhet..nn.1
  excitering_1_N = mkN "excitering" ; -- excitering..nn.1
  exeges_1_N = mkN "exeges" ; -- exeges..nn.1
  exeget_1_N = mkN "exeget" "exegeter" ; -- exeget..nn.1
  exegetik_1_N = mkN "exegetik" ; -- exegetik..nn.1
  exegetisk_1_A = mkA "exegetisk" ; -- exegetisk..av.1
  exekution_1_N = mkN "exekution" ; -- exekution..nn.1
  exekutionspluton_1_N = mkN "exekutionspluton" "exekutionsplutoner" ; -- exekutionspluton..nn.1
  exekutiv_1_A = mkA "exekutiv" ; -- exekutiv..av.1
  exekutiv_1_N = mkN "exekutiv" "exekutiver" ; -- exekutiv..nn.1
  exekutor_1_N = mkN "exekutor" "exekutorer" ; -- exekutor..nn.1
  exekutorisk_1_A = mkA "exekutorisk" ; -- exekutorisk..av.1
  exekutör_1_N = mkN "exekutör" "exekutörer" ; -- exekutör..nn.1
  exekvera_1_V = mkV "exekverar" ; -- exekvera..vb.1
  exekverande_1_N = mkN "exekverande" ; -- exekverande..nn.1
  exekverbar_1_A = mkA "exekverbar" ; -- exekverbar..av.1
  exekverbarhet_1_N = mkN "exekverbarhet" ; -- exekverbarhet..nn.1
  exekvering_1_N = mkN "exekvering" ; -- exekvering..nn.1
  exempel_1_N = mkN "exempel" neutrum  ; -- exempel..nn.1
  exempellös_1_A = mkA "exempellös" ; -- exempellös..av.1
  exempellöshet_1_N = mkN "exempellöshet" "exempellösheter" ; -- exempellöshet..nn.1
  exempelsamling_1_N = mkN "exempelsamling" ; -- exempelsamling..nn.1
  exempelvis_1_Adv = mkAdv "exempelvis" ; -- exempelvis..ab.1
  exemplar_1_N = mkN "exemplar" neutrum  ; -- exemplar..nn.1
  exemplarisk_1_A = mkA "exemplarisk" ; -- exemplarisk..av.1
  exemplifiera_1_V = mkV "exemplifierar" ; -- exemplifiera..vb.1
  exemplifierande_1_N = mkN "exemplifierande" ; -- exemplifierande..nn.1
  exemplifierbar_1_A = mkA "exemplifierbar" ; -- exemplifierbar..av.1
  exemplifierbarhet_1_N = mkN "exemplifierbarhet" ; -- exemplifierbarhet..nn.1
  exemplifiering_1_N = mkN "exemplifiering" ; -- exemplifiering..nn.1
  exemplifikation_1_N = mkN "exemplifikation" ; -- exemplifikation..nn.1
  exercera_1_V = mkV "exercerar" ; -- exercera..vb.1
  exercerande_1_N = mkN "exercerande" ; -- exercerande..nn.1
  exercerbar_1_A = mkA "exercerbar" ; -- exercerbar..av.1
  exercerbarhet_1_N = mkN "exercerbarhet" ; -- exercerbarhet..nn.1
  exercering_1_N = mkN "exercering" ; -- exercering..nn.1
  exercis_1_N = mkN "exercis" "exerciser" ; -- exercis..nn.1
  exercisfält_1_N = mkN "exercisfält" neutrum  ; -- exercisfält..nn.1
  exflickvän_1_N = mkN "exflickvän" "exflickvännen" "exflickvänner" "exflickvännerna" ; -- exflickvän..nn.1
  exfru_1_N = mkN "exfru" ; -- exfru..nn.1
  exhalterad_1_A = mkA "exhalterad" ; -- exhalterad..av.1
  exhibitionism_1_N = mkN "exhibitionism" "exhibitionismer" ; -- exhibitionism..nn.1
  exhibitionist_1_N = mkN "exhibitionist" "exhibitionister" ; -- exhibitionist..nn.1
  exhibitionistisk_1_A = mkA "exhibitionistisk" ; -- exhibitionistisk..av.1
  exhustru_1_N = mkN "exhustru" "exhustrun" "exhustrur" "exhustrurna" ; -- exhustru..nn.1
  exigibel_1_A = mkA "exigibel" ; -- exigibel..av.1
  exil_1_N = mkN "exil" ; -- exil..nn.1
  exilhuvudstad_1_N = mkN "exilhuvudstad" "exilhuvudstäder" ; -- exilhuvudstad..nn.1
  exin_1_N = mkN "exin" "exiner" ; -- exin..nn.1
  existens_1_N = mkN "existens" "existenser" ; -- existens..nn.1
  existensberättigande_1_N = mkN "existensberättigande" ; -- existensberättigande..nn.1
  existensform_1_N = mkN "existensform" "existensformer" ; -- existensform..nn.1
  existensmedel_1_N = mkN "existensmedel" neutrum  ; -- existensmedel..nn.1
  existensminimum_1_N = mkN "existensminimum" neutrum  ; -- existensminimum..nn.1
  existensvillkor_1_N = mkN "existensvillkor" neutrum  ; -- existensvillkor..nn.1
  existentialism_1_N = mkN "existentialism" "existentialismer" ; -- existentialism..nn.1
  existentialistisk_1_A = mkA "existentialistisk" ; -- existentialistisk..av.1
  existentiell_1_A = mkA "existentiell" ; -- existentiell..av.1
  existera_1_V = mkV "existerar" ; -- existera..vb.1
  existerande_1_A = mkA "existerande" ; -- existerande..av.1
  existerande_1_N = mkN "existerande" ; -- existerande..nn.1
  exklamation_1_N = mkN "exklamation" ; -- exklamation..nn.1
  exklamatorisk_1_A = mkA "exklamatorisk" ; -- exklamatorisk..av.1
  exklav_1_N = mkN "exklav" "exklaver" ; -- exklav..nn.1
  exkludera_1_V = mkV "exkluderar" ; -- exkludera..vb.1
  exkluderande_1_N = mkN "exkluderande" ; -- exkluderande..nn.1
  exkluderbar_1_A = mkA "exkluderbar" ; -- exkluderbar..av.1
  exkluderbarhet_1_N = mkN "exkluderbarhet" ; -- exkluderbarhet..nn.1
  exkludering_1_N = mkN "exkludering" ; -- exkludering..nn.1
  exklusiv_1_A = mkA "exklusiv" ; -- exklusiv..av.1
  exklusivitet_1_N = mkN "exklusivitet" "exklusiviteter" ; -- exklusivitet..nn.1
  exkommunicera_1_V = mkV "exkommunicerar" ; -- exkommunicera..vb.1
  exkommunicerande_1_N = mkN "exkommunicerande" ; -- exkommunicerande..nn.1
  exkommunicerbar_1_A = mkA "exkommunicerbar" ; -- exkommunicerbar..av.1
  exkommunicerbarhet_1_N = mkN "exkommunicerbarhet" ; -- exkommunicerbarhet..nn.1
  exkommunicering_1_N = mkN "exkommunicering" ; -- exkommunicering..nn.1
  exkommunikation_1_N = mkN "exkommunikation" ; -- exkommunikation..nn.1
  exkommunistisk_1_A = mkA "exkommunistisk" ; -- exkommunistisk..av.1
  exkonung_1_N = mkN "exkonung" ; -- exkonung..nn.1
  exkrement_1_N = mkN "exkrement" "exkrementet" "exkrementer" "exkrementerna" ; -- exkrement..nn.1
  exkremental_1_A = mkA "exkremental" ; -- exkremental..av.1
  exkret_1_N = mkN "exkret" neutrum  ; -- exkret..nn.1
  exkretion_1_N = mkN "exkretion" ; -- exkretion..nn.1
  exkung_1_N = mkN "exkung" ; -- exkung..nn.1
  exkurs_1_N = mkN "exkurs" "exkurser" ; -- exkurs..nn.1
  exkursion_1_N = mkN "exkursion" ; -- exkursion..nn.1
  exlibris_1_N = mkN "exlibris" neutrum  ; -- exlibris..nn.1
  exodus_1_N = mkN "exodus" ; -- exodus..nn.1
  exoftalmometer_1_N = mkN "exoftalmometer" ; -- exoftalmometer..nn.1
  exoftalmus_1_N = mkN "exoftalmus" ; -- exoftalmus..nn.1
  exogen_1_A = mkA "exogen" "exogent" ; -- exogen..av.1
  exonym_1_N = mkN "exonym" "exonymer" ; -- exonym..nn.1
  exoplanet_1_N = mkN "exoplanet" "exoplaneter" ; -- exoplanet..nn.1
  exorcism_1_N = mkN "exorcism" "exorcismer" ; -- exorcism..nn.1
  exorcist_1_N = mkN "exorcist" "exorcister" ; -- exorcist..nn.1
  exorcistisk_1_A = mkA "exorcistisk" ; -- exorcistisk..av.1
  exoterisk_1_A = mkA "exoterisk" ; -- exoterisk..av.1
  exotermisk_1_A = mkA "exotermisk" ; -- exotermisk..av.1
  exotisk_1_A = mkA "exotisk" ; -- exotisk..av.1
  exotism_1_N = mkN "exotism" "exotismer" ; -- exotism..nn.1
  exotistisk_1_A = mkA "exotistisk" ; -- exotistisk..av.1
  expandera_1_V = mkV "expanderar" ; -- expandera..vb.1
  expanderande_1_N = mkN "expanderande" ; -- expanderande..nn.1
  expanderbar_1_A = mkA "expanderbar" ; -- expanderbar..av.1
  expanderbarhet_1_N = mkN "expanderbarhet" ; -- expanderbarhet..nn.1
  expandering_1_N = mkN "expandering" ; -- expandering..nn.1
  expansibel_1_A = mkA "expansibel" ; -- expansibel..av.1
  expansion_1_N = mkN "expansion" ; -- expansion..nn.1
  expansionism_1_N = mkN "expansionism" "expansionismer" ; -- expansionism..nn.1
  expansionistisk_1_A = mkA "expansionistisk" ; -- expansionistisk..av.1
  expansionskraft_1_N = mkN "expansionskraft" ; -- expansionskraft..nn.1
  expansionskärl_1_N = mkN "expansionskärl" neutrum  ; -- expansionskärl..nn.1
  expansionsplan_1_N = mkN "expansionsplan" "expansionsplaner" ; -- expansionsplan..nn.1
  expansionstakt_1_N = mkN "expansionstakt" ; -- expansionstakt..nn.1
  expansionsvilja_1_N = mkN "expansionsvilja" ; -- expansionsvilja..nn.1
  expansiv_1_A = mkA "expansiv" ; -- expansiv..av.1
  expatriera_1_V = mkV "expatrierar" ; -- expatriera..vb.1
  expatrierande_1_N = mkN "expatrierande" ; -- expatrierande..nn.1
  expatrierbar_1_A = mkA "expatrierbar" ; -- expatrierbar..av.1
  expatrierbarhet_1_N = mkN "expatrierbarhet" ; -- expatrierbarhet..nn.1
  expatriering_1_N = mkN "expatriering" ; -- expatriering..nn.1
  expediera_1_V = mkV "expedierar" ; -- expediera..vb.1
  expedierande_1_N = mkN "expedierande" ; -- expedierande..nn.1
  expedierbar_1_A = mkA "expedierbar" ; -- expedierbar..av.1
  expedierbarhet_1_N = mkN "expedierbarhet" ; -- expedierbarhet..nn.1
  expediering_1_N = mkN "expediering" ; -- expediering..nn.1
  expedit_1_A = mkA "expedit" "expedit" ; -- expedit..av.1
  expedit_1_N = mkN "expedit" "expediter" ; -- expedit..nn.1
  expedition_1_N = mkN "expedition" ; -- expedition..nn.1
  expeditionschef_1_N = mkN "expeditionschef" "expeditionschefer" ; -- expeditionschef..nn.1
  expeditionskår_1_N = mkN "expeditionskår" "expeditionskårer" ; -- expeditionskår..nn.1
  expeditionsledare_1_N = mkN "expeditionsledare" utrum  ; -- expeditionsledare..nn.1
  expeditionsministär_1_N = mkN "expeditionsministär" "expeditionsministärer" ; -- expeditionsministär..nn.1
  expeditionsregering_1_N = mkN "expeditionsregering" ; -- expeditionsregering..nn.1
  expeditionsvakt_1_N = mkN "expeditionsvakt" "expeditionsvakter" ; -- expeditionsvakt..nn.1
  expeditör_1_N = mkN "expeditör" "expeditörer" ; -- expeditör..nn.1
  expektoration_1_N = mkN "expektoration" ; -- expektoration..nn.1
  expektorera_1_V = mkV "expektorerar" ; -- expektorera..vb.1
  expektorerande_1_N = mkN "expektorerande" ; -- expektorerande..nn.1
  expektorerbar_1_A = mkA "expektorerbar" ; -- expektorerbar..av.1
  expektorerbarhet_1_N = mkN "expektorerbarhet" ; -- expektorerbarhet..nn.1
  expektorering_1_N = mkN "expektorering" ; -- expektorering..nn.1
  experiment_1_N = mkN "experiment" neutrum  ; -- experiment..nn.1
  experimentalfysiker_1_N = mkN "experimentalfysiker" "experimentalfysikern" "experimentalfysiker" "experimentalfysikerna" ; -- experimentalfysiker..nn.1
  experimentalkirurgi_1_N = mkN "experimentalkirurgi" ; -- experimentalkirurgi..nn.1
  experimentator_1_N = mkN "experimentator" "experimentatorer" ; -- experimentator..nn.1
  experimentell_1_A = mkA "experimentell" ; -- experimentell..av.1
  experimentera_1_V = mkV "experimenterar" ; -- experimentera..vb.1
  experimenterande_1_N = mkN "experimenterande" ; -- experimenterande..nn.1
  experimentering_1_N = mkN "experimentering" ; -- experimentering..nn.1
  experimentfält_1_N = mkN "experimentfält" neutrum  ; -- experimentfält..nn.1
  experimentgymnasium_1_N = mkN "experimentgymnasium" "experimentgymnasiet" "experimentgymnasier" "experimentgymnasierna" ; -- experimentgymnasium..nn.1
  experimentlusta_1_N = mkN "experimentlusta" ; -- experimentlusta..nn.1
  experimentstation_1_N = mkN "experimentstation" ; -- experimentstation..nn.1
  expert_1_N = mkN "expert" "experter" ; -- expert..nn.1
  expertgrupp_1_N = mkN "expertgrupp" "expertgrupper" ; -- expertgrupp..nn.1
  expertis_1_N = mkN "expertis" ; -- expertis..nn.1
  expertkommentator_1_N = mkN "expertkommentator" "expertkommentatorer" ; -- expertkommentator..nn.1
  expertkommitté_1_N = mkN "expertkommitté" "expertkommittéer" ; -- expertkommitté..nn.1
  expertkrets_1_N = mkN "expertkrets" ; -- expertkrets..nn.1
  expertspråk_1_N = mkN "expertspråk" neutrum  ; -- expertspråk..nn.1
  expertutlåtande_1_N = mkN "expertutlåtande" ; -- expertutlåtande..nn.1
  expertutredare_1_N = mkN "expertutredare" utrum  ; -- expertutredare..nn.1
  explanativ_1_A = mkA "explanativ" ; -- explanativ..av.1
  explicera_1_V = mkV "explicerar" ; -- explicera..vb.1
  explicerande_1_N = mkN "explicerande" ; -- explicerande..nn.1
  explicerbar_1_A = mkA "explicerbar" ; -- explicerbar..av.1
  explicerbarhet_1_N = mkN "explicerbarhet" ; -- explicerbarhet..nn.1
  explicering_1_N = mkN "explicering" ; -- explicering..nn.1
  explicit_1_A = mkA "explicit" "explicit" ; -- explicit..av.1
  explicithet_1_N = mkN "explicithet" ; -- explicithet..nn.1
  explikation_1_N = mkN "explikation" ; -- explikation..nn.1
  exploatera_1_V = mkV "exploaterar" ; -- exploatera..vb.1
  exploaterande_1_N = mkN "exploaterande" ; -- exploaterande..nn.1
  exploaterbar_1_A = mkA "exploaterbar" ; -- exploaterbar..av.1
  exploaterbarhet_1_N = mkN "exploaterbarhet" ; -- exploaterbarhet..nn.1
  exploatering_1_N = mkN "exploatering" ; -- exploatering..nn.1
  exploateringsyta_1_N = mkN "exploateringsyta" ; -- exploateringsyta..nn.1
  exploatör_1_N = mkN "exploatör" "exploatörer" ; -- exploatör..nn.1
  explodera_1_V = mkV "exploderar" ; -- explodera..vb.1
  exploderande_1_N = mkN "exploderande" ; -- exploderande..nn.1
  exploderbar_1_A = mkA "exploderbar" ; -- exploderbar..av.1
  exploderbarhet_1_N = mkN "exploderbarhet" ; -- exploderbarhet..nn.1
  explodering_1_N = mkN "explodering" ; -- explodering..nn.1
  explosion_1_N = mkN "explosion" ; -- explosion..nn.1
  explosionsartad_1_A = mkA "explosionsartad" ; -- explosionsartad..av.1
  explosionsförlopp_1_N = mkN "explosionsförlopp" neutrum  ; -- explosionsförlopp..nn.1
  explosionshärd_1_N = mkN "explosionshärd" ; -- explosionshärd..nn.1
  explosionsmotor_1_N = mkN "explosionsmotor" "explosionsmotorer" ; -- explosionsmotor..nn.1
  explosionsområde_1_N = mkN "explosionsområde" ; -- explosionsområde..nn.1
  explosionsrisk_1_N = mkN "explosionsrisk" "explosionsrisker" ; -- explosionsrisk..nn.1
  explosionssätt_1_N = mkN "explosionssätt" neutrum  ; -- explosionssätt..nn.1
  explosionsögonblick_1_N = mkN "explosionsögonblick" neutrum  ; -- explosionsögonblick..nn.1
  explosiv_1_A = mkA "explosiv" ; -- explosiv..av.1
  explosiva_1_N = mkN "explosiva" ; -- explosiva..nn.1
  expo_1_N = mkN "expo" "expor" ; -- expo..nn.1
  expojkvän_1_N = mkN "expojkvän" "expojkvännen" "expojkvänner" "expojkvännerna" ; -- expojkvän..nn.1
  exponent_1_N = mkN "exponent" "exponenter" ; -- exponent..nn.1
  exponentialfunktion_1_N = mkN "exponentialfunktion" ; -- exponentialfunktion..nn.1
  exponentiell_1_A = mkA "exponentiell" ; -- exponentiell..av.1
  exponera_1_V = mkV "exponerar" ; -- exponera..vb.1
  exponerande_1_N = mkN "exponerande" ; -- exponerande..nn.1
  exponerbar_1_A = mkA "exponerbar" ; -- exponerbar..av.1
  exponerbarhet_1_N = mkN "exponerbarhet" ; -- exponerbarhet..nn.1
  exponering_1_N = mkN "exponering" ; -- exponering..nn.1
  exponeringsmätare_1_N = mkN "exponeringsmätare" utrum  ; -- exponeringsmätare..nn.1
  export_1_N = mkN "export" "exporter" ; -- export..nn.1
  exportartikel_1_N = mkN "exportartikel" ; -- exportartikel..nn.1
  exportberoende_1_A = mkA "exportberoende" ; -- exportberoende..av.1
  exportberoende_1_N = mkN "exportberoende" ; -- exportberoende..nn.1
  exportbolag_1_N = mkN "exportbolag" neutrum  ; -- exportbolag..nn.1
  exportera_1_V = mkV "exporterar" ; -- exportera..vb.1
  exporterande_1_N = mkN "exporterande" ; -- exporterande..nn.1
  exporterbar_1_A = mkA "exporterbar" ; -- exporterbar..av.1
  exporterbarhet_1_N = mkN "exporterbarhet" ; -- exporterbarhet..nn.1
  exportering_1_N = mkN "exportering" ; -- exportering..nn.1
  exportfrämjande_1_A = mkA "exportfrämjande" ; -- exportfrämjande..av.1
  exportförbud_1_N = mkN "exportförbud" neutrum  ; -- exportförbud..nn.1
  exporthandel_1_N = mkN "exporthandel" ; -- exporthandel..nn.1
  exportindustri_1_N = mkN "exportindustri" "exportindustrier" ; -- exportindustri..nn.1
  exportinkomst_1_N = mkN "exportinkomst" "exportinkomster" ; -- exportinkomst..nn.1
  exportmarknad_1_N = mkN "exportmarknad" "exportmarknader" ; -- exportmarknad..nn.1
  exportsprit_1_N = mkN "exportsprit" ; -- exportsprit..nn.1
  exportöl_1_N = mkN "exportöl" neutrum  ; -- exportöl..nn.1
  exportör_1_N = mkN "exportör" "exportörer" ; -- exportör..nn.1
  exposition_1_N = mkN "exposition" ; -- exposition..nn.1
  exposé_1_N = mkN "exposé" "exposéer" ; -- exposé..nn.1
  expresident_1_N = mkN "expresident" "expresidenter" ; -- expresident..nn.1
  express_1_N = mkN "express" "expresser" ; -- express..nn.1
  expressbrev_1_N = mkN "expressbrev" neutrum  ; -- expressbrev..nn.1
  expressbud_1_N = mkN "expressbud" neutrum  ; -- expressbud..nn.1
  expressbyrå_1_N = mkN "expressbyrå" "expressbyråer" ; -- expressbyrå..nn.1
  expressförsändelse_1_N = mkN "expressförsändelse" "expressförsändelser" ; -- expressförsändelse..nn.1
  expressionism_1_N = mkN "expressionism" "expressionismer" ; -- expressionism..nn.1
  expressionist_1_N = mkN "expressionist" "expressionister" ; -- expressionist..nn.1
  expressionistisk_1_A = mkA "expressionistisk" ; -- expressionistisk..av.1
  expressiv_1_A = mkA "expressiv" ; -- expressiv..av.1
  expressivitet_1_N = mkN "expressivitet" "expressiviteter" ; -- expressivitet..nn.1
  expresståg_1_N = mkN "expresståg" neutrum  ; -- expresståg..nn.1
  expropriation_1_N = mkN "expropriation" ; -- expropriation..nn.1
  expropriationslag_1_N = mkN "expropriationslag" ; -- expropriationslag..nn.1
  expropriera_1_V = mkV "exproprierar" ; -- expropriera..vb.1
  exproprierande_1_N = mkN "exproprierande" ; -- exproprierande..nn.1
  exproprierbar_1_A = mkA "exproprierbar" ; -- exproprierbar..av.1
  exproprierbarhet_1_N = mkN "exproprierbarhet" ; -- exproprierbarhet..nn.1
  expropriering_1_N = mkN "expropriering" ; -- expropriering..nn.1
  exregent_1_N = mkN "exregent" "exregenter" ; -- exregent..nn.1
  exsickat_1_N = mkN "exsickat" neutrum  ; -- exsickat..nn.1
  exsickator_1_N = mkN "exsickator" "exsickatorer" ; -- exsickator..nn.1
  exspektans_1_N = mkN "exspektans" ; -- exspektans..nn.1
  exspiration_1_N = mkN "exspiration" ; -- exspiration..nn.1
  exspiratorisk_1_A = mkA "exspiratorisk" ; -- exspiratorisk..av.1
  exstirpera_1_V = mkV "exstirperar" ; -- exstirpera..vb.1
  exstirperande_1_N = mkN "exstirperande" ; -- exstirperande..nn.1
  exstirperbar_1_A = mkA "exstirperbar" ; -- exstirperbar..av.1
  exstirperbarhet_1_N = mkN "exstirperbarhet" ; -- exstirperbarhet..nn.1
  exstirpering_1_N = mkN "exstirpering" ; -- exstirpering..nn.1
  exsudat_1_N = mkN "exsudat" neutrum  ; -- exsudat..nn.1
  extas_1_N = mkN "extas" ; -- extas..nn.1
  extatisk_1_A = mkA "extatisk" ; -- extatisk..av.1
  extemporera_1_V = mkV "extemporerar" ; -- extemporera..vb.1
  extemporerande_1_N = mkN "extemporerande" ; -- extemporerande..nn.1
  extemporerbar_1_A = mkA "extemporerbar" ; -- extemporerbar..av.1
  extemporerbarhet_1_N = mkN "extemporerbarhet" ; -- extemporerbarhet..nn.1
  extemporering_1_N = mkN "extemporering" ; -- extemporering..nn.1
  extension_1_N = mkN "extension" ; -- extension..nn.1
  extensiv_1_A = mkA "extensiv" ; -- extensiv..av.1
  exteriör_1_A = mkA "exteriör" ; -- exteriör..av.1
  exteriör_1_N = mkN "exteriör" "exteriörer" ; -- exteriör..nn.1
  exteriörbedömning_1_N = mkN "exteriörbedömning" ; -- exteriörbedömning..nn.1
  extern_1_A = mkA "extern" ; -- extern..av.1
  extern_1_N = mkN "extern" "externer" ; -- extern..nn.1
  externat_1_N = mkN "externat" neutrum  ; -- externat..nn.1
  exterritorialrätt_1_N = mkN "exterritorialrätt" ; -- exterritorialrätt..nn.1
  exterritoriell_1_A = mkA "exterritoriell" ; -- exterritoriell..av.1
  extra_1_A = mkA "extra" ; -- extra..av.1
  extraarbete_1_N = mkN "extraarbete" ; -- extraarbete..nn.1
  extrafilt_1_N = mkN "extrafilt" ; -- extrafilt..nn.1
  extrafin_1_A = mkA "extrafin" ; -- extrafin..av.1
  extrahera_1_V = mkV "extraherar" ; -- extrahera..vb.1
  extraherande_1_N = mkN "extraherande" ; -- extraherande..nn.1
  extraherbar_1_A = mkA "extraherbar" ; -- extraherbar..av.1
  extraherbarhet_1_N = mkN "extraherbarhet" ; -- extraherbarhet..nn.1
  extrahering_1_N = mkN "extrahering" ; -- extrahering..nn.1
  extrahud_1_N = mkN "extrahud" ; -- extrahud..nn.1
  extrainkallad_1_A = mkA "extrainkallad" ; -- extrainkallad..av.1
  extrainkomst_1_N = mkN "extrainkomst" "extrainkomster" ; -- extrainkomst..nn.1
  extrajobb_1_N = mkN "extrajobb" neutrum  ; -- extrajobb..nn.1
  extrajudiciell_1_A = mkA "extrajudiciell" ; -- extrajudiciell..av.1
  extraknäck_1_N = mkN "extraknäck" neutrum  ; -- extraknäck..nn.1
  extraknäcka_1_V = mkV "extraknäcker" ; -- extraknäcka..vb.1
  extraknäckande_1_N = mkN "extraknäckande" ; -- extraknäckande..nn.1
  extrakongress_1_N = mkN "extrakongress" "extrakongresser" ; -- extrakongress..nn.1
  extrakontant_1_A = mkA "extrakontant" "extrakontant" ; -- extrakontant..av.1
  extrakt_1_N = mkN "extrakt" neutrum  ; -- extrakt..nn.1
  extraktion_1_N = mkN "extraktion" ; -- extraktion..nn.1
  extraktivämne_1_N = mkN "extraktivämne" ; -- extraktivämne..nn.1
  extraktor_1_N = mkN "extraktor" "extraktorer" ; -- extraktor..nn.1
  extralampa_1_N = mkN "extralampa" ; -- extralampa..nn.1
  extraljus_1_N = mkN "extraljus" neutrum  ; -- extraljus..nn.1
  extralärare_1_N = mkN "extralärare" utrum  ; -- extralärare..nn.1
  extramural_1_A = mkA "extramural" ; -- extramural..av.1
  extranummer_1_N = mkN "extranummer" neutrum  ; -- extranummer..nn.1
  extraordinarie_1_A = mkA "extraordinarie" ; -- extraordinarie..av.1
  extraordinarie_1_N = mkN "extraordinarie" "extraordinarier" ; -- extraordinarie..nn.1
  extraordinär_1_A = mkA "extraordinär" ; -- extraordinär..av.1
  extrapersonal_1_N = mkN "extrapersonal" ; -- extrapersonal..nn.1
  extrapolation_1_N = mkN "extrapolation" ; -- extrapolation..nn.1
  extrapolera_1_V = mkV "extrapolerar" ; -- extrapolera..vb.1
  extrapolerande_1_N = mkN "extrapolerande" ; -- extrapolerande..nn.1
  extrapolerbar_1_A = mkA "extrapolerbar" ; -- extrapolerbar..av.1
  extrapolerbarhet_1_N = mkN "extrapolerbarhet" ; -- extrapolerbarhet..nn.1
  extrapolering_1_N = mkN "extrapolering" ; -- extrapolering..nn.1
  extrapris_1_N = mkN "extrapris" neutrum  ; -- extrapris..nn.1
  extraranson_1_N = mkN "extraranson" "extraransoner" ; -- extraranson..nn.1
  extrasol_1_N = mkN "extrasol" ; -- extrasol..nn.1
  extrastämma_1_N = mkN "extrastämma" ; -- extrastämma..nn.1
  extraterritoriell_1_A = mkA "extraterritoriell" ; -- extraterritoriell..av.1
  extratur_1_N = mkN "extratur" "extraturer" ; -- extratur..nn.1
  extratåg_1_N = mkN "extratåg" neutrum  ; -- extratåg..nn.1
  extraupplaga_1_N = mkN "extraupplaga" ; -- extraupplaga..nn.1
  extrauterin_1_A = mkA "extrauterin" ; -- extrauterin..av.1
  extravagans_1_N = mkN "extravagans" "extravaganser" ; -- extravagans..nn.1
  extravagant_1_A = mkA "extravagant" "extravagant" ; -- extravagant..av.1
  extrem_1_A = mkA "extrem" ; -- extrem..av.1
  extrem_1_N = mkN "extrem" "extremer" ; -- extrem..nn.1
  extremfall_1_N = mkN "extremfall" neutrum  ; -- extremfall..nn.1
  extremhöger_1_N = mkN "extremhöger" ; -- extremhöger..nn.1
  extremism_1_N = mkN "extremism" "extremismer" ; -- extremism..nn.1
  extremist_1_N = mkN "extremist" "extremister" ; -- extremist..nn.1
  extremistisk_1_A = mkA "extremistisk" ; -- extremistisk..av.1
  extremitet_1_N = mkN "extremitet" "extremiteter" ; -- extremitet..nn.1
  extremkyla_1_N = mkN "extremkyla" ; -- extremkyla..nn.1
  extremnationalist_1_N = mkN "extremnationalist" "extremnationalister" ; -- extremnationalist..nn.1
  extremskidåkare_1_N = mkN "extremskidåkare" utrum  ; -- extremskidåkare..nn.1
  extremskidåkning_1_N = mkN "extremskidåkning" ; -- extremskidåkning..nn.1
  extremväder_1_N = mkN "extremväder" neutrum  ; -- extremväder..nn.1
  extremvänster_1_N = mkN "extremvänster" ; -- extremvänster..nn.1
  extremvärde_1_N = mkN "extremvärde" ; -- extremvärde..nn.1
  extrinsisk_1_A = mkA "extrinsisk" ; -- extrinsisk..av.1
  extrovert_1_A = mkA "extrovert" "extrovert" ; -- extrovert..av.1
  extroverthet_1_N = mkN "extroverthet" ; -- extroverthet..nn.1
  eye_liner_1_N = mkN "eye-liner" "eye-linern" "eye-liners" "eye-linersarna" ; -- eye-liner..nn.1
  eyeliner_1_N = mkN "eyeliner" "eyelinern" "eyeliners" "eyelinersarna" ; -- eyeliner..nn.1
  f_1_N = mkN "f" neutrum  ; -- f..nn.1
  fabel_1_N = mkN "fabel" "fabeln" "fabler" "fablerna" ; -- fabel..nn.1
  fabelaktig_1_A = mkA "fabelaktig" ; -- fabelaktig..av.1
  fabelaktighet_1_N = mkN "fabelaktighet" ; -- fabelaktighet..nn.1
  fabeldiktare_1_N = mkN "fabeldiktare" utrum  ; -- fabeldiktare..nn.1
  fabeldjur_1_N = mkN "fabeldjur" neutrum  ; -- fabeldjur..nn.1
  fabelhjälte_1_N = mkN "fabelhjälte" utrum  ; -- fabelhjälte..nn.1
  fabla_1_V = mkV "fablar" ; -- fabla..vb.1
  fablande_1_N = mkN "fablande" ; -- fablande..nn.1
  fabricera_1_V = mkV "fabricerar" ; -- fabricera..vb.1
  fabricerande_1_N = mkN "fabricerande" ; -- fabricerande..nn.1
  fabricerbar_1_A = mkA "fabricerbar" ; -- fabricerbar..av.1
  fabricerbarhet_1_N = mkN "fabricerbarhet" ; -- fabricerbarhet..nn.1
  fabricering_1_N = mkN "fabricering" ; -- fabricering..nn.1
  fabrik_1_N = mkN "fabrik" "fabriker" ; -- fabrik..nn.1
  fabrikant_1_N = mkN "fabrikant" "fabrikanter" ; -- fabrikant..nn.1
  fabrikat_1_N = mkN "fabrikat" neutrum  ; -- fabrikat..nn.1
  fabrikation_1_N = mkN "fabrikation" ; -- fabrikation..nn.1
  fabriksanläggning_1_N = mkN "fabriksanläggning" ; -- fabriksanläggning..nn.1
  fabriksarbetande_1_A = mkA "fabriksarbetande" ; -- fabriksarbetande..av.1
  fabriksarbetare_1_N = mkN "fabriksarbetare" utrum  ; -- fabriksarbetare..nn.1
  fabriksbyggnad_1_N = mkN "fabriksbyggnad" "fabriksbyggnader" ; -- fabriksbyggnad..nn.1
  fabrikskomplex_1_N = mkN "fabrikskomplex" neutrum  ; -- fabrikskomplex..nn.1
  fabrikskvarter_1_N = mkN "fabrikskvarter" "fabrikskvarteret" "fabrikskvarter" "fabrikskvarteren" ; -- fabrikskvarter..nn.1
  fabrikslänga_1_N = mkN "fabrikslänga" ; -- fabrikslänga..nn.1
  fabriksmässig_1_A = mkA "fabriksmässig" ; -- fabriksmässig..av.1
  fabriksmässighet_1_N = mkN "fabriksmässighet" ; -- fabriksmässighet..nn.1
  fabriksny_1_A = mkA "fabriksny" "fabriksnytt" ; -- fabriksny..av.1
  fabriksområde_1_N = mkN "fabriksområde" ; -- fabriksområde..nn.1
  fabrikspipa_1_N = mkN "fabrikspipa" ; -- fabrikspipa..nn.1
  fabriksport_1_N = mkN "fabriksport" ; -- fabriksport..nn.1
  fabrikspris_1_N = mkN "fabrikspris" neutrum  ; -- fabrikspris..nn.1
  fabriksskorsten_1_N = mkN "fabriksskorsten" "fabriksskorstenen" "fabriksskorstenar" "fabriksskorstenarna" ; -- fabriksskorsten..nn.1
  fabrikstomt_1_N = mkN "fabrikstomt" "fabrikstomter" ; -- fabrikstomt..nn.1
  fabrikör_1_N = mkN "fabrikör" "fabrikörer" ; -- fabrikör..nn.1
  fabulera_1_V = mkV "fabulerar" ; -- fabulera..vb.1
  fabulerande_1_N = mkN "fabulerande" ; -- fabulerande..nn.1
  fabulerbar_1_A = mkA "fabulerbar" ; -- fabulerbar..av.1
  fabulerbarhet_1_N = mkN "fabulerbarhet" ; -- fabulerbarhet..nn.1
  fabulering_1_N = mkN "fabulering" ; -- fabulering..nn.1
  fabulös_1_A = mkA "fabulös" ; -- fabulös..av.1
  facebooka_1_V = mkV "facebookar" ; -- facebooka..vb.1
  facebookande_1_N = mkN "facebookande" ; -- facebookande..nn.1
  facebookbild_1_N = mkN "facebookbild" "facebookbilder" ; -- facebookbild..nn.1
  facebookgrupp_1_N = mkN "facebookgrupp" "facebookgrupper" ; -- facebookgrupp..nn.1
  facebooksida_1_N = mkN "facebooksida" ; -- facebooksida..nn.1
  facett_1_N = mkN "facett" "facetter" ; -- facett..nn.1
  facettera_1_V = mkV "facetterar" ; -- facettera..vb.1
  facetterad_1_A = mkA "facetterad" ; -- facetterad..av.1
  facetterande_1_N = mkN "facetterande" ; -- facetterande..nn.1
  facetterbar_1_A = mkA "facetterbar" ; -- facetterbar..av.1
  facetterbarhet_1_N = mkN "facetterbarhet" ; -- facetterbarhet..nn.1
  facettering_1_N = mkN "facettering" ; -- facettering..nn.1
  facettöga_1_N = mkN "facettöga" "facettögat" "facettögon" "facettögonen" ; -- facettöga..nn.1
  facil_1_A = mkA "facil" ; -- facil..av.1
  facilitet_1_N = mkN "facilitet" "faciliteter" ; -- facilitet..nn.1
  fack_1_N = mkN "fack" neutrum  ; -- fack..nn.1
  fackelblomster_1_N = mkN "fackelblomster" neutrum  ; -- fackelblomster..nn.1
  fackelbärare_1_N = mkN "fackelbärare" utrum  ; -- fackelbärare..nn.1
  fackelsken_1_N = mkN "fackelsken" neutrum  ; -- fackelsken..nn.1
  fackeltåg_1_N = mkN "fackeltåg" neutrum  ; -- fackeltåg..nn.1
  fackförbund_1_N = mkN "fackförbund" neutrum  ; -- fackförbund..nn.1
  fackförening_1_N = mkN "fackförening" ; -- fackförening..nn.1
  fackföreningsfientlig_1_A = mkA "fackföreningsfientlig" ; -- fackföreningsfientlig..av.1
  fackföreningsrörelse_1_N = mkN "fackföreningsrörelse" "fackföreningsrörelser" ; -- fackföreningsrörelse..nn.1
  fackhögskola_1_N = mkN "fackhögskola" ; -- fackhögskola..nn.1
  fackidiot_1_N = mkN "fackidiot" "fackidioter" ; -- fackidiot..nn.1
  fackklubb_1_N = mkN "fackklubb" ; -- fackklubb..nn.1
  fackkunnig_1_A = mkA "fackkunnig" ; -- fackkunnig..av.1
  fackkunnighet_1_N = mkN "fackkunnighet" ; -- fackkunnighet..nn.1
  fackkunskap_1_N = mkN "fackkunskap" "fackkunskaper" ; -- fackkunskap..nn.1
  fackla_1_N = mkN "fackla" ; -- fackla..nn.1
  facklig_politisk_1_A = mkA "facklig-politisk" ; -- facklig-politisk..av.1
  facklig_1_A = mkA "facklig" ; -- facklig..av.1
  facklighet_1_N = mkN "facklighet" ; -- facklighet..nn.1
  fackligpolitisk_1_A = mkA "fackligpolitisk" ; -- fackligpolitisk..av.1
  fackligt_politisk_1_A = mkA "fackligt-politisk" ; -- fackligt-politisk..av.1
  fackligtpolitisk_1_A = mkA "fackligtpolitisk" ; -- fackligtpolitisk..av.1
  facklitteratur_1_N = mkN "facklitteratur" ; -- facklitteratur..nn.1
  facklärare_1_N = mkN "facklärare" utrum  ; -- facklärare..nn.1
  fackman_1_N = mkN "fackman" "fackmannen" "fackmän" "fackmännen" ; -- fackman..nn.1
  fackmannamässig_1_A = mkA "fackmannamässig" ; -- fackmannamässig..av.1
  fackminister_1_N = mkN "fackminister" ; -- fackminister..nn.1
  fackmässig_1_A = mkA "fackmässig" ; -- fackmässig..av.1
  fackmässighet_1_N = mkN "fackmässighet" ; -- fackmässighet..nn.1
  fackordbok_1_N = mkN "fackordbok" "fackordböcker" ; -- fackordbok..nn.1
  fackorgan_1_N = mkN "fackorgan" neutrum  ; -- fackorgan..nn.1
  fackpress_1_N = mkN "fackpress" ; -- fackpress..nn.1
  fackprosa_1_N = mkN "fackprosa" ; -- fackprosa..nn.1
  fackskola_1_N = mkN "fackskola" ; -- fackskola..nn.1
  fackspråk_1_N = mkN "fackspråk" neutrum  ; -- fackspråk..nn.1
  fackstudium_1_N = mkN "fackstudium" "fackstudiet" "fackstudier" "fackstudierna" ; -- fackstudium..nn.1
  fackterm_1_N = mkN "fackterm" "facktermer" ; -- fackterm..nn.1
  facktidskrift_1_N = mkN "facktidskrift" "facktidskrifter" ; -- facktidskrift..nn.1
  fackutskottsprincip_1_N = mkN "fackutskottsprincip" "fackutskottsprinciper" ; -- fackutskottsprincip..nn.1
  fackverk_1_N = mkN "fackverk" neutrum  ; -- fackverk..nn.1
  fackverksbom_1_N = mkN "fackverksbom" "fackverksbommen" "fackverksbommar" "fackverksbommarna" ; -- fackverksbom..nn.1
  fackverksmast_1_N = mkN "fackverksmast" "fackverksmaster" ; -- fackverksmast..nn.1
  factoring_1_N = mkN "factoring" ; -- factoring..nn.1
  fadd_1_A = mkA "fadd" ; -- fadd..av.1
  fadder_1_N = mkN "fadder" ; -- fadder..nn.1
  fadderbarn_1_N = mkN "fadderbarn" neutrum  ; -- fadderbarn..nn.1
  faddergala_1_N = mkN "faddergala" ; -- faddergala..nn.1
  faddergåva_1_N = mkN "faddergåva" ; -- faddergåva..nn.1
  fadderskap_1_N = mkN "fadderskap" neutrum  ; -- fadderskap..nn.1
  faddhet_1_N = mkN "faddhet" ; -- faddhet..nn.1
  fader_1_N = mkN "fader" "fadern" "fäder" "fäderna" ; -- fader..nn.1
  faderlig_1_A = mkA "faderlig" ; -- faderlig..av.1
  faderlighet_1_N = mkN "faderlighet" ; -- faderlighet..nn.1
  faderlös_1_A = mkA "faderlös" ; -- faderlös..av.1
  fadermord_1_N = mkN "fadermord" neutrum  ; -- fadermord..nn.1
  fadermördare_1_N = mkN "fadermördare" utrum  ; -- fadermördare..nn.1
  fadersarv_1_N = mkN "fadersarv" neutrum  ; -- fadersarv..nn.1
  fadersfigur_1_N = mkN "fadersfigur" "fadersfigurer" ; -- fadersfigur..nn.1
  fadersgestalt_1_N = mkN "fadersgestalt" "fadersgestalter" ; -- fadersgestalt..nn.1
  fadershjärta_1_N = mkN "fadershjärta" "fadershjärtat" "fadershjärtan" "fadershjärtana" ; -- fadershjärta..nn.1
  fadershus_1_N = mkN "fadershus" neutrum  ; -- fadershus..nn.1
  faderskap_1_N = mkN "faderskap" neutrum  ; -- faderskap..nn.1
  faderskomplex_1_N = mkN "faderskomplex" neutrum  ; -- faderskomplex..nn.1
  faderskärlek_1_N = mkN "faderskärlek" ; -- faderskärlek..nn.1
  fadersnamn_1_N = mkN "fadersnamn" neutrum  ; -- fadersnamn..nn.1
  fadersuppror_1_N = mkN "fadersuppror" neutrum  ; -- fadersuppror..nn.1
  fadersvälde_1_N = mkN "fadersvälde" ; -- fadersvälde..nn.1
  fadervår_1_N = mkN "fadervår" neutrum  ; -- fadervår..nn.1
  fading_1_N = mkN "fading" ; -- fading..nn.1
  fadäs_1_N = mkN "fadäs" "fadäser" ; -- fadäs..nn.1
  faffa_1_N = mkN "faffa" ; -- faffa..nn.1
  fager_1_A = mkA "fager" ; -- fager..av.1
  fagott_1_N = mkN "fagott" "fagotter" ; -- fagott..nn.1
  fagottist_1_N = mkN "fagottist" "fagottister" ; -- fagottist..nn.1
  faiblesse_1_N = mkN "faiblesse" "faiblesser" ; -- faiblesse..nn.1
  fajans_1_N = mkN "fajans" "fajanser" ; -- fajans..nn.1
  fajansfabrik_1_N = mkN "fajansfabrik" "fajansfabriker" ; -- fajansfabrik..nn.1
  fajansfat_1_N = mkN "fajansfat" neutrum  ; -- fajansfat..nn.1
  fajanskärl_1_N = mkN "fajanskärl" neutrum  ; -- fajanskärl..nn.1
  fajansskål_1_N = mkN "fajansskål" ; -- fajansskål..nn.1
  fajt_1_N = mkN "fajt" "fajter" ; -- fajt..nn.1
  fajter_1_N = mkN "fajter" "fajtern" "fajters" "fajtersen" ; -- fajter..nn.1
  fakir_1_N = mkN "fakir" "fakirer" ; -- fakir..nn.1
  faksimil_1_N = mkN "faksimil" neutrum  ; -- faksimil..nn.1
  faksimile_1_N = mkN "faksimile" "faksimiler" ; -- faksimile..nn.1
  faksimilera_1_V = mkV "faksimilerar" ; -- faksimilera..vb.1
  faksimiletryck_1_N = mkN "faksimiletryck" neutrum  ; -- faksimiletryck..nn.1
  faksimiltryck_1_N = mkN "faksimiltryck" neutrum  ; -- faksimiltryck..nn.1
  fakta_1_N = mkN "fakta" ; -- fakta..nn.1
  faktabaserad_1_A = mkA "faktabaserad" ; -- faktabaserad..av.1
  faktafel_1_N = mkN "faktafel" "faktafelet" "faktafel" "faktafelen" ; -- faktafel..nn.1
  faktafolder_1_N = mkN "faktafolder" ; -- faktafolder..nn.1
  faktagranskning_1_N = mkN "faktagranskning" ; -- faktagranskning..nn.1
  faktagroda_1_N = mkN "faktagroda" ; -- faktagroda..nn.1
  faktakoll_1_N = mkN "faktakoll" ; -- faktakoll..nn.1
  faktamässig_1_A = mkA "faktamässig" ; -- faktamässig..av.1
  faktaspäckad_1_A = mkA "faktaspäckad" ; -- faktaspäckad..av.1
  fakticitet_1_N = mkN "fakticitet" "fakticiteter" ; -- fakticitet..nn.1
  faktisk_1_A = mkA "faktisk" ; -- faktisk..av.1
  faktiskhet_1_N = mkN "faktiskhet" ; -- faktiskhet..nn.1
  faktoid_1_N = mkN "faktoid" "faktoider" ; -- faktoid..nn.1
  faktor_1_N = mkN "faktor" "faktorer" ; -- faktor..nn.1
  faktoranalys_1_N = mkN "faktoranalys" "faktoranalyser" ; -- faktoranalys..nn.1
  faktori_1_N = mkN "faktori" "faktoriet" "faktorier" "faktorierna" ; -- faktori..nn.1
  faktotum_1_N = mkN "faktotum" neutrum  ; -- faktotum..nn.1
  faktum_1_N = mkN "faktum" neutrum  ; -- faktum..nn.1
  faktur_1_N = mkN "faktur" ; -- faktur..nn.1
  faktura_1_N = mkN "faktura" ; -- faktura..nn.1
  fakturera_1_V = mkV "fakturerar" ; -- fakturera..vb.1
  fakturerande_1_N = mkN "fakturerande" ; -- fakturerande..nn.1
  fakturerbar_1_A = mkA "fakturerbar" ; -- fakturerbar..av.1
  fakturerbarhet_1_N = mkN "fakturerbarhet" ; -- fakturerbarhet..nn.1
  fakturering_1_N = mkN "fakturering" ; -- fakturering..nn.1
  fakultativ_1_A = mkA "fakultativ" ; -- fakultativ..av.1
  fakultet_1_N = mkN "fakultet" "fakulteter" ; -- fakultet..nn.1
  fakultetsgräns_1_N = mkN "fakultetsgräns" "fakultetsgränser" ; -- fakultetsgräns..nn.1
  fakultetsopponent_1_N = mkN "fakultetsopponent" "fakultetsopponenter" ; -- fakultetsopponent..nn.1
  fakultetssammanträde_1_N = mkN "fakultetssammanträde" ; -- fakultetssammanträde..nn.1
  fal_1_A = mkA "fal" ; -- fal..av.1
  falafel_1_N = mkN "falafel" ; -- falafel..nn.1
  falafelbulle_1_N = mkN "falafelbulle" utrum  ; -- falafelbulle..nn.1
  falang_1_N = mkN "falang" "falanger" ; -- falang..nn.1
  falangist_1_N = mkN "falangist" "falangister" ; -- falangist..nn.1
  falangstrid_1_N = mkN "falangstrid" "falangstrider" ; -- falangstrid..nn.1
  falerner_1_N = mkN "falerner" ; -- falerner..nn.1
  falhet_1_N = mkN "falhet" ; -- falhet..nn.1
  falk_1_N = mkN "falk" ; -- falk..nn.1
  falka_1_V = mkV "falkar" ; -- falka..vb.1
  falkande_1_N = mkN "falkande" ; -- falkande..nn.1
  falkblick_1_N = mkN "falkblick" ; -- falkblick..nn.1
  falkenerare_1_N = mkN "falkenerare" utrum  ; -- falkenerare..nn.1
  falkjakt_1_N = mkN "falkjakt" "falkjakter" ; -- falkjakt..nn.1
  falkonett_1_N = mkN "falkonett" "falkonetter" ; -- falkonett..nn.1
  falköga_1_N = mkN "falköga" "falkögat" "falkögon" "falkögonen" ; -- falköga..nn.1
  fall_1_N = mkN "fall" neutrum  ; -- fall..nn.1
  falla_1_V = mkV "falla" "föll" "fallit" ; -- falla..vb.1
  fallande_1_N = mkN "fallande" ; -- fallande..nn.1
  fallandesjuka_1_N = mkN "fallandesjuka" ; -- fallandesjuka..nn.1
  fallandesot_1_N = mkN "fallandesot" ; -- fallandesot..nn.1
  fallbeskrivning_1_N = mkN "fallbeskrivning" ; -- fallbeskrivning..nn.1
  fallbila_1_N = mkN "fallbila" ; -- fallbila..nn.1
  fallen_1_A = mkA "fallen" ; -- fallen..av.1
  fallenhet_1_N = mkN "fallenhet" "fallenheter" ; -- fallenhet..nn.1
  fallera_1_V = mkV "fallerar" ; -- fallera..vb.1
  fallerande_1_N = mkN "fallerande" ; -- fallerande..nn.1
  fallering_1_N = mkN "fallering" ; -- fallering..nn.1
  fallfara_1_N = mkN "fallfara" ; -- fallfara..nn.1
  fallfrukt_1_N = mkN "fallfrukt" "fallfrukter" ; -- fallfrukt..nn.1
  fallfärdig_1_A = mkA "fallfärdig" ; -- fallfärdig..av.1
  fallfärdighet_1_N = mkN "fallfärdighet" ; -- fallfärdighet..nn.1
  fallgrop_1_N = mkN "fallgrop" ; -- fallgrop..nn.1
  fallhammare_1_N = mkN "fallhammare" "fallhammaren" "fallhammare" "fallhamrarna" ; -- fallhammare..nn.1
  fallhöjd_1_N = mkN "fallhöjd" "fallhöjder" ; -- fallhöjd..nn.1
  fallissemang_1_N = mkN "fallissemang" neutrum  ; -- fallissemang..nn.1
  fallmålstavla_1_N = mkN "fallmålstavla" ; -- fallmålstavla..nn.1
  fallolycka_1_N = mkN "fallolycka" ; -- fallolycka..nn.1
  fallos_1_N = mkN "fallos" ; -- fallos..nn.1
  fallout_1_N = mkN "fallout" ; -- fallout..nn.1
  fallrep_1_N = mkN "fallrep" neutrum  ; -- fallrep..nn.1
  fallrepstrappa_1_N = mkN "fallrepstrappa" ; -- fallrepstrappa..nn.1
  fallseger_1_N = mkN "fallseger" ; -- fallseger..nn.1
  fallskada_1_N = mkN "fallskada" ; -- fallskada..nn.1
  fallskärm_1_N = mkN "fallskärm" ; -- fallskärm..nn.1
  fallskärmsförbund_1_N = mkN "fallskärmsförbund" neutrum  ; -- fallskärmsförbund..nn.1
  fallskärmshopp_1_N = mkN "fallskärmshopp" neutrum  ; -- fallskärmshopp..nn.1
  fallskärmshoppande_1_N = mkN "fallskärmshoppande" ; -- fallskärmshoppande..nn.1
  fallskärmshoppare_1_N = mkN "fallskärmshoppare" utrum  ; -- fallskärmshoppare..nn.1
  fallskärmshoppning_1_N = mkN "fallskärmshoppning" ; -- fallskärmshoppning..nn.1
  fallskärmsjägare_1_N = mkN "fallskärmsjägare" utrum  ; -- fallskärmsjägare..nn.1
  fallskärmsklubb_1_N = mkN "fallskärmsklubb" ; -- fallskärmsklubb..nn.1
  fallskärmsliknande_1_A = mkA "fallskärmsliknande" ; -- fallskärmsliknande..av.1
  fallskärmsolycka_1_N = mkN "fallskärmsolycka" ; -- fallskärmsolycka..nn.1
  fallskärmstrick_1_N = mkN "fallskärmstrick" neutrum  ; -- fallskärmstrick..nn.1
  fallskärmstrupp_1_N = mkN "fallskärmstrupp" "fallskärmstrupper" ; -- fallskärmstrupp..nn.1
  fallstudie_1_N = mkN "fallstudie" "fallstudier" ; -- fallstudie..nn.1
  falltavla_1_N = mkN "falltavla" ; -- falltavla..nn.1
  fallucka_1_N = mkN "fallucka" ; -- fallucka..nn.1
  fallverk_1_N = mkN "fallverk" neutrum  ; -- fallverk..nn.1
  fallvind_1_N = mkN "fallvind" ; -- fallvind..nn.1
  falna_1_V = mkV "falnar" ; -- falna..vb.1
  falnande_1_N = mkN "falnande" ; -- falnande..nn.1
  fals_1_N = mkN "fals" ; -- fals..nn.1
  falsa_1_V = mkV "falsar" ; -- falsa..vb.1
  falsande_1_N = mkN "falsande" ; -- falsande..nn.1
  falsarium_1_N = mkN "falsarium" "falsariet" "falsarier" "falsarierna" ; -- falsarium..nn.1
  falsett_1_N = mkN "falsett" ; -- falsett..nn.1
  falsettilsken_1_A = mkA "falsettilsken" ; -- falsettilsken..av.1
  falsettröst_1_N = mkN "falsettröst" "falsettröster" ; -- falsettröst..nn.1
  falsettsång_1_N = mkN "falsettsång" ; -- falsettsång..nn.1
  falsifiera_1_V = mkV "falsifierar" ; -- falsifiera..vb.1
  falsifierande_1_N = mkN "falsifierande" ; -- falsifierande..nn.1
  falsifierbar_1_A = mkA "falsifierbar" ; -- falsifierbar..av.1
  falsifierbarhet_1_N = mkN "falsifierbarhet" ; -- falsifierbarhet..nn.1
  falsifiering_1_N = mkN "falsifiering" ; -- falsifiering..nn.1
  falsifikat_1_N = mkN "falsifikat" neutrum  ; -- falsifikat..nn.1
  falsk_1_A = mkA "falsk" ; -- falsk..av.1
  falskalarm_1_N = mkN "falskalarm" neutrum  ; -- falskalarm..nn.1
  falskeligen_1_Adv = mkAdv "falskeligen" ; -- falskeligen..ab.1
  falskhet_1_N = mkN "falskhet" "falskheter" ; -- falskhet..nn.1
  falsklarm_1_N = mkN "falsklarm" neutrum  ; -- falsklarm..nn.1
  falskmynta_1_V = mkV "falskmyntar" ; -- falskmynta..vb.1
  falskmyntande_1_N = mkN "falskmyntande" ; -- falskmyntande..nn.1
  falskmyntare_1_N = mkN "falskmyntare" utrum  ; -- falskmyntare..nn.1
  falskmyntning_1_N = mkN "falskmyntning" ; -- falskmyntning..nn.1
  falskskylta_1_V = mkV "falskskyltar" ; -- falskskylta..vb.1
  falskskyltande_1_N = mkN "falskskyltande" ; -- falskskyltande..nn.1
  falskskyltning_1_N = mkN "falskskyltning" ; -- falskskyltning..nn.1
  falskspel_1_N = mkN "falskspel" "falskspelet" "falskspel" "falskspelen" ; -- falskspel..nn.1
  falskspelare_1_N = mkN "falskspelare" utrum  ; -- falskspelare..nn.1
  falubo_1_N = mkN "falubo" "falubor" ; -- falubo..nn.1
  falukorv_1_N = mkN "falukorv" ; -- falukorv..nn.1
  faluröd_1_A = mkA "faluröd" "falurött" ; -- faluröd..av.1
  familj_1_N = mkN "familj" "familjer" ; -- familj..nn.1
  familjaritet_1_N = mkN "familjaritet" "familjariteter" ; -- familjaritet..nn.1
  familjeangelägenhet_1_N = mkN "familjeangelägenhet" "familjeangelägenheter" ; -- familjeangelägenhet..nn.1
  familjearkiv_1_N = mkN "familjearkiv" neutrum  ; -- familjearkiv..nn.1
  familjeband_1_N = mkN "familjeband" neutrum  ; -- familjeband..nn.1
  familjebidrag_1_N = mkN "familjebidrag" neutrum  ; -- familjebidrag..nn.1
  familjebild_1_N = mkN "familjebild" "familjebilder" ; -- familjebild..nn.1
  familjebiljett_1_N = mkN "familjebiljett" "familjebiljetter" ; -- familjebiljett..nn.1
  familjebolag_1_N = mkN "familjebolag" neutrum  ; -- familjebolag..nn.1
  familjedaghem_1_N = mkN "familjedaghem" "familjedaghemmet" "familjedaghem" "familjedaghemmen" ; -- familjedaghem..nn.1
  familjedrag_1_N = mkN "familjedrag" neutrum  ; -- familjedrag..nn.1
  familjedrama_1_N = mkN "familjedrama" "familjedramat" "familjedramer" "familjedramerna" ; -- familjedrama..nn.1
  familjefar_1_N = mkN "familjefader" "familjefadern" "familjefäder" "familjefäderna" ; -- familjefar..nn.1
  familjefejd_1_N = mkN "familjefejd" "familjefejder" ; -- familjefejd..nn.1
  familjeflicka_1_N = mkN "familjeflicka" ; -- familjeflicka..nn.1
  familjefoto_1_N = mkN "familjefoto" "familjefotot" "familjefoton" "familjefotona" ; -- familjefoto..nn.1
  familjeföretag_1_N = mkN "familjeföretag" neutrum  ; -- familjeföretag..nn.1
  familjeförsörjare_1_N = mkN "familjeförsörjare" utrum  ; -- familjeförsörjare..nn.1
  familjegods_1_N = mkN "familjegods" neutrum  ; -- familjegods..nn.1
  familjegrav_1_N = mkN "familjegrav" ; -- familjegrav..nn.1
  familjehem_1_N = mkN "familjehem" "familjehemmet" "familjehem" "familjehemmen" ; -- familjehem..nn.1
  familjehemlighet_1_N = mkN "familjehemlighet" "familjehemligheter" ; -- familjehemlighet..nn.1
  familjehotell_1_N = mkN "familjehotell" neutrum  ; -- familjehotell..nn.1
  familjeideal_1_N = mkN "familjeideal" neutrum  ; -- familjeideal..nn.1
  familjejordbruk_1_N = mkN "familjejordbruk" neutrum  ; -- familjejordbruk..nn.1
  familjekrets_1_N = mkN "familjekrets" ; -- familjekrets..nn.1
  familjekänsla_1_N = mkN "familjekänsla" ; -- familjekänsla..nn.1
  familjeliv_1_N = mkN "familjeliv" neutrum  ; -- familjeliv..nn.1
  familjemedlem_1_N = mkN "familjemedlem" "familjemedlemmen" "familjemedlemmar" "familjemedlemmarna" ; -- familjemedlem..nn.1
  familjemiddag_1_N = mkN "familjemiddag" ; -- familjemiddag..nn.1
  familjemys_1_N = mkN "familjemys" neutrum  ; -- familjemys..nn.1
  familjemässig_1_A = mkA "familjemässig" ; -- familjemässig..av.1
  familjenamn_1_N = mkN "familjenamn" neutrum  ; -- familjenamn..nn.1
  familjepenning_1_N = mkN "familjepenning" ; -- familjepenning..nn.1
  familjepension_1_N = mkN "familjepension" ; -- familjepension..nn.1
  familjeplanering_1_N = mkN "familjeplanering" ; -- familjeplanering..nn.1
  familjeplaneringsregel_1_N = mkN "familjeplaneringsregel" "familjeplaneringsregeln" "familjeplaneringsregler" "familjeplaneringsreglerna" ; -- familjeplaneringsregel..nn.1
  familjepolitik_1_N = mkN "familjepolitik" ; -- familjepolitik..nn.1
  familjepolitisk_1_A = mkA "familjepolitisk" ; -- familjepolitisk..av.1
  familjeprogram_1_N = mkN "familjeprogram" "familjeprogrammet" "familjeprogram" "familjeprogrammen" ; -- familjeprogram..nn.1
  familjerabatt_1_N = mkN "familjerabatt" "familjerabatter" ; -- familjerabatt..nn.1
  familjerätt_1_N = mkN "familjerätt" ; -- familjerätt..nn.1
  familjerättslig_1_A = mkA "familjerättslig" ; -- familjerättslig..av.1
  familjerådgivning_1_N = mkN "familjerådgivning" ; -- familjerådgivning..nn.1
  familjestiftelse_1_N = mkN "familjestiftelse" "familjestiftelser" ; -- familjestiftelse..nn.1
  familjeterapi_1_N = mkN "familjeterapi" ; -- familjeterapi..nn.1
  familjetillhörighet_1_N = mkN "familjetillhörighet" ; -- familjetillhörighet..nn.1
  familjetradition_1_N = mkN "familjetradition" ; -- familjetradition..nn.1
  familjeunderhållning_1_N = mkN "familjeunderhållning" ; -- familjeunderhållning..nn.1
  familjevåld_1_N = mkN "familjevåld" neutrum  ; -- familjevåld..nn.1
  familjevård_1_N = mkN "familjevård" ; -- familjevård..nn.1
  familjeöverhuvud_1_N = mkN "familjeöverhuvud" "familjeöverhuvudet" "familjeöverhuvud" "familjeöverhuvudena" ; -- familjeöverhuvud..nn.1
  familjär_1_A = mkA "familjär" ; -- familjär..av.1
  famla_1_V = mkV "famlar" ; -- famla..vb.1
  famlande_1_A = mkA "famlande" ; -- famlande..av.1
  famlande_1_N = mkN "famlande" ; -- famlande..nn.1
  fammo_1_N = mkN "fammo" ; -- fammo..nn.1
  famn_1_N = mkN "famn" ; -- famn..nn.1
  famna_1_V = mkV "famnar" ; -- famna..vb.1
  famnande_1_N = mkN "famnande" ; -- famnande..nn.1
  famntag_1_N = mkN "famntag" neutrum  ; -- famntag..nn.1
  famös_1_A = mkA "famös" ; -- famös..av.1
  fan_2_N = mkN "fan" "fanen" "fans" "fansarna" ; -- fan..nn.2
  fan_3_N = mkN "fan" neutrum  ; -- fan..nn.3
  fana_1_N = mkN "fana" ; -- fana..nn.1
  fanatiker_1_N = mkN "fanatiker" "fanatikern" "fanatiker" "fanatikerna" ; -- fanatiker..nn.1
  fanatisk_1_A = mkA "fanatisk" ; -- fanatisk..av.1
  fanatism_1_N = mkN "fanatism" "fanatismer" ; -- fanatism..nn.1
  fanborg_1_N = mkN "fanborg" ; -- fanborg..nn.1
  fanbärare_1_N = mkN "fanbärare" utrum  ; -- fanbärare..nn.1
  fandango_1_N = mkN "fandango" "fandangon" "fandangoer" "fandangoerna" ; -- fandango..nn.1
  faned_1_N = mkN "faned" "faneder" ; -- faned..nn.1
  faner_1_N = mkN "faner" "faneret" "faner" "faneren" ; -- faner..nn.1
  fanera_1_V = mkV "fanerar" ; -- fanera..vb.1
  fanerogam_1_A = mkA "fanerogam" ; -- fanerogam..av.1
  fanerogam_1_N = mkN "fanerogam" "fanerogamer" ; -- fanerogam..nn.1
  fanerozoikum_1_N = mkN "fanerozoikum" ; -- fanerozoikum..nn.1
  fanfar_1_N = mkN "fanfar" "fanfarer" ; -- fanfar..nn.1
  fanflykt_1_N = mkN "fanflykt" ; -- fanflykt..nn.1
  fanjunkare_1_N = mkN "fanjunkare" utrum  ; -- fanjunkare..nn.1
  fanken_1_N = mkN "fanken" ; -- fanken..nn.1
  fanskap_1_N = mkN "fanskap" neutrum  ; -- fanskap..nn.1
  fanstyg_1_N = mkN "fanstyg" neutrum  ; -- fanstyg..nn.1
  fantasi_1_N = mkN "fantasi" "fantasier" ; -- fantasi..nn.1
  fantasialster_1_N = mkN "fantasialster" neutrum  ; -- fantasialster..nn.1
  fantasibild_1_N = mkN "fantasibild" "fantasibilder" ; -- fantasibild..nn.1
  fantasidjur_1_N = mkN "fantasidjur" neutrum  ; -- fantasidjur..nn.1
  fantasieggande_1_A = mkA "fantasieggande" ; -- fantasieggande..av.1
  fantasifigur_1_N = mkN "fantasifigur" "fantasifigurer" ; -- fantasifigur..nn.1
  fantasifoster_1_N = mkN "fantasifoster" neutrum  ; -- fantasifoster..nn.1
  fantasifull_1_A = mkA "fantasifull" ; -- fantasifull..av.1
  fantasifullhet_1_N = mkN "fantasifullhet" "fantasifullheter" ; -- fantasifullhet..nn.1
  fantasigestalt_1_N = mkN "fantasigestalt" "fantasigestalter" ; -- fantasigestalt..nn.1
  fantasikraft_1_N = mkN "fantasikraft" ; -- fantasikraft..nn.1
  fantasiliv_1_N = mkN "fantasiliv" neutrum  ; -- fantasiliv..nn.1
  fantasilös_1_A = mkA "fantasilös" ; -- fantasilös..av.1
  fantasilöshet_1_N = mkN "fantasilöshet" "fantasilösheter" ; -- fantasilöshet..nn.1
  fantasiprodukt_1_N = mkN "fantasiprodukt" "fantasiprodukter" ; -- fantasiprodukt..nn.1
  fantasirik_1_A = mkA "fantasirik" ; -- fantasirik..av.1
  fantasirikedom_1_N = mkN "fantasirikedom" ; -- fantasirikedom..nn.1
  fantasirikhet_1_N = mkN "fantasirikhet" ; -- fantasirikhet..nn.1
  fantasiskapelse_1_N = mkN "fantasiskapelse" "fantasiskapelser" ; -- fantasiskapelse..nn.1
  fantasispel_1_N = mkN "fantasispel" "fantasispelet" "fantasispel" "fantasispelen" ; -- fantasispel..nn.1
  fantasivarelse_1_N = mkN "fantasivarelse" "fantasivarelser" ; -- fantasivarelse..nn.1
  fantasivärld_1_N = mkN "fantasivärld" ; -- fantasivärld..nn.1
  fantast_1_N = mkN "fantast" "fantaster" ; -- fantast..nn.1
  fantasteri_1_N = mkN "fantasteri" "fantasteriet" "fantasterier" "fantasterierna" ; -- fantasteri..nn.1
  fantastik_1_N = mkN "fantastik" ; -- fantastik..nn.1
  fantastisk_1_A = mkA "fantastisk" ; -- fantastisk..av.1
  fantisera_1_V = mkV "fantiserar" ; -- fantisera..vb.1
  fantiserande_1_N = mkN "fantiserande" ; -- fantiserande..nn.1
  fantiserbar_1_A = mkA "fantiserbar" ; -- fantiserbar..av.1
  fantiserbarhet_1_N = mkN "fantiserbarhet" ; -- fantiserbarhet..nn.1
  fantisering_1_N = mkN "fantisering" ; -- fantisering..nn.1
  fantom_1_N = mkN "fantom" neutrum  ; -- fantom..nn.1
  fantom_2_N = mkN "fantom" "fantomer" ; -- fantom..nn.2
  fantombild_1_N = mkN "fantombild" "fantombilder" ; -- fantombild..nn.1
  fantomlik_1_A = mkA "fantomlik" ; -- fantomlik..av.1
  fantomsmärta_1_N = mkN "fantomsmärta" ; -- fantomsmärta..nn.1
  fantomsnygg_1_A = mkA "fantomsnygg" ; -- fantomsnygg..av.1
  fantomsnygghet_1_N = mkN "fantomsnygghet" ; -- fantomsnygghet..nn.1
  fanvakt_1_N = mkN "fanvakt" "fanvakter" ; -- fanvakt..nn.1
  far_1_N = mkN "fader" "fadern" "fäder" "fäderna" ; -- far..nn.1
  fara_1_N = mkN "fara" ; -- fara..nn.1
  fara_1_V = mkV "fara" "for" "farit" ; -- fara..vb.1
  farad_1_N = mkN "farad" "faraden" "farad" "faraden" ; -- farad..nn.1
  farande_1_N = mkN "farande" ; -- farande..nn.1
  farao_1_N = mkN "farao" "faraon" "faraoner" "faraonerna" ; -- farao..nn.1
  faraokatt_1_N = mkN "faraokatt" "faraokatter" ; -- faraokatt..nn.1
  faraonisk_1_A = mkA "faraonisk" ; -- faraonisk..av.1
  farbar_1_A = mkA "farbar" ; -- farbar..av.1
  farbarhet_1_N = mkN "farbarhet" ; -- farbarhet..nn.1
  farbroderlig_1_A = mkA "farbroderlig" ; -- farbroderlig..av.1
  farbroderlighet_1_N = mkN "farbroderlighet" ; -- farbroderlighet..nn.1
  farbror_1_N = mkN "farbror" "farbröder" ; -- farbror..nn.1
  fardag_1_N = mkN "fardag" ; -- fardag..nn.1
  farfar_1_N = mkN "farfader" "farfadern" "farfäder" "farfäderna" ; -- farfar..nn.1
  farfarsfar_1_N = mkN "farfarsfader" "farfarsfadern" "farfarsfäder" "farfarsfäderna" ; -- farfarsfar..nn.1
  farförälder_1_N = mkN "farförälder" ; -- farförälder..nn.1
  fargalt_1_N = mkN "fargalt" ; -- fargalt..nn.1
  farhåga_1_N = mkN "farhåga" ; -- farhåga..nn.1
  farin_1_N = mkN "farin" ; -- farin..nn.1
  farinsocker_1_N = mkN "farinsocker" neutrum  ; -- farinsocker..nn.1
  fariseisk_1_A = mkA "fariseisk" ; -- fariseisk..av.1
  fariseism_1_N = mkN "fariseism" "fariseismer" ; -- fariseism..nn.1
  farisé_1_N = mkN "farisé" "fariséer" ; -- farisé..nn.1
  fariséism_1_N = mkN "fariséism" ; -- fariséism..nn.1
  farkost_1_N = mkN "farkost" "farkoster" ; -- farkost..nn.1
  farled_1_N = mkN "farled" "farleder" ; -- farled..nn.1
  farledsfyr_1_N = mkN "farledsfyr" ; -- farledsfyr..nn.1
  farlig_1_A = mkA "farlig" ; -- farlig..av.1
  farlighet_1_N = mkN "farlighet" "farligheter" ; -- farlighet..nn.1
  farlighetsstämpel_1_N = mkN "farlighetsstämpel" ; -- farlighetsstämpel..nn.1
  farm_1_N = mkN "farm" ; -- farm..nn.1
  farmaceut_1_N = mkN "farmaceut" "farmaceuter" ; -- farmaceut..nn.1
  farmaceutisk_1_A = mkA "farmaceutisk" ; -- farmaceutisk..av.1
  farmacevt_1_N = mkN "farmacevt" "farmacevter" ; -- farmacevt..nn.1
  farmacevtisk_1_A = mkA "farmacevtisk" ; -- farmacevtisk..av.1
  farmaci_1_N = mkN "farmaci" ; -- farmaci..nn.1
  farmacie_1_A = mkA "farmacie" ; -- farmacie..av.1
  farmaka_1_N = mkN "farmaka" "farmakat" "farmaka" "farmakana" ; -- farmaka..nn.1
  farmakognosi_1_N = mkN "farmakognosi" ; -- farmakognosi..nn.1
  farmakolog_1_N = mkN "farmakolog" "farmakologer" ; -- farmakolog..nn.1
  farmakologi_1_N = mkN "farmakologi" ; -- farmakologi..nn.1
  farmakologisk_1_A = mkA "farmakologisk" ; -- farmakologisk..av.1
  farmakopé_1_N = mkN "farmakopé" "farmakopéer" ; -- farmakopé..nn.1
  farmardomkraft_1_N = mkN "farmardomkraft" "farmardomkrafter" ; -- farmardomkraft..nn.1
  farmare_1_N = mkN "farmare" utrum  ; -- farmare..nn.1
  farmor_1_N = mkN "farmor" "farmodern" "farmödrar" "farmödrarna" ; -- farmor..nn.1
  farofylld_1_A = mkA "farofylld" "farofyllt" ; -- farofylld..av.1
  farofylldhet_1_N = mkN "farofylldhet" ; -- farofylldhet..nn.1
  farozon_1_N = mkN "farozon" "farozoner" ; -- farozon..nn.1
  fars_1_N = mkN "fars" "farser" ; -- fars..nn.1
  farsa_1_N = mkN "farsa" ; -- farsa..nn.1
  farsartad_1_A = mkA "farsartad" ; -- farsartad..av.1
  farsarv_1_N = mkN "farsarv" neutrum  ; -- farsarv..nn.1
  farsgubbe_1_N = mkN "farsgubbe" utrum  ; -- farsgubbe..nn.1
  farsi_1_N = mkN "farsi" ; -- farsi..nn.1
  farsot_1_N = mkN "farsot" "farsoter" ; -- farsot..nn.1
  farsotsår_1_N = mkN "farsotsår" neutrum  ; -- farsotsår..nn.1
  farstu_1_N = mkN "farstu" "farstun" "farstur" "farsturna" ; -- farstu..nn.1
  farstukvist_1_N = mkN "farstukvist" ; -- farstukvist..nn.1
  farstutrappa_1_N = mkN "farstutrappa" ; -- farstutrappa..nn.1
  fart_1_N = mkN "fart" "farter" ; -- fart..nn.1
  fartblind_1_A = mkA "fartblind" ; -- fartblind..av.1
  fartblindhet_1_N = mkN "fartblindhet" ; -- fartblindhet..nn.1
  fartdåre_1_N = mkN "fartdåre" utrum  ; -- fartdåre..nn.1
  fartfena_1_N = mkN "fartfena" ; -- fartfena..nn.1
  fartfylld_1_A = mkA "fartfylld" "fartfyllt" ; -- fartfylld..av.1
  fartfylldhet_1_N = mkN "fartfylldhet" ; -- fartfylldhet..nn.1
  farthinder_1_N = mkN "farthinder" neutrum  ; -- farthinder..nn.1
  farthållare_1_N = mkN "farthållare" utrum  ; -- farthållare..nn.1
  fartkamera_1_N = mkN "fartkamera" ; -- fartkamera..nn.1
  fartminskning_1_N = mkN "fartminskning" ; -- fartminskning..nn.1
  fartrand_1_N = mkN "fartrand" "fartränder" ; -- fartrand..nn.1
  fartreglage_1_N = mkN "fartreglage" "fartreglaget" "fartreglage" "fartreglagen" ; -- fartreglage..nn.1
  fartspärr_1_N = mkN "fartspärr" ; -- fartspärr..nn.1
  fartupplevelse_1_N = mkN "fartupplevelse" "fartupplevelser" ; -- fartupplevelse..nn.1
  fartvind_1_N = mkN "fartvind" ; -- fartvind..nn.1
  fartyg_1_N = mkN "fartyg" neutrum  ; -- fartyg..nn.1
  fartygsanpassad_1_A = mkA "fartygsanpassad" ; -- fartygsanpassad..av.1
  fartygsbesättning_1_N = mkN "fartygsbesättning" ; -- fartygsbesättning..nn.1
  fartygsbotten_1_N = mkN "fartygsbotten" ; -- fartygsbotten..nn.1
  fartygsbyggartradition_1_N = mkN "fartygsbyggartradition" ; -- fartygsbyggartradition..nn.1
  fartygsdäck_1_N = mkN "fartygsdäck" neutrum  ; -- fartygsdäck..nn.1
  fartygsflagg_1_N = mkN "fartygsflagg" ; -- fartygsflagg..nn.1
  fartygsincident_1_N = mkN "fartygsincident" "fartygsincidenter" ; -- fartygsincident..nn.1
  fartygskapten_1_N = mkN "fartygskapten" "fartygskaptener" ; -- fartygskapten..nn.1
  fartygskatastrof_1_N = mkN "fartygskatastrof" "fartygskatastrofer" ; -- fartygskatastrof..nn.1
  fartygskollision_1_N = mkN "fartygskollision" ; -- fartygskollision..nn.1
  fartygskonvoj_1_N = mkN "fartygskonvoj" "fartygskonvojer" ; -- fartygskonvoj..nn.1
  fartygskurs_1_N = mkN "fartygskurs" "fartygskurser" ; -- fartygskurs..nn.1
  fartygslast_1_N = mkN "fartygslast" "fartygslaster" ; -- fartygslast..nn.1
  fartygslucka_1_N = mkN "fartygslucka" ; -- fartygslucka..nn.1
  fartygsorkester_1_N = mkN "fartygsorkester" ; -- fartygsorkester..nn.1
  fartygsproviant_1_N = mkN "fartygsproviant" ; -- fartygsproviant..nn.1
  fartygssida_1_N = mkN "fartygssida" ; -- fartygssida..nn.1
  fartygsskrov_1_N = mkN "fartygsskrov" neutrum  ; -- fartygsskrov..nn.1
  fartygsstormning_1_N = mkN "fartygsstormning" ; -- fartygsstormning..nn.1
  fartygstjänstgöring_1_N = mkN "fartygstjänstgöring" ; -- fartygstjänstgöring..nn.1
  fartygstrafik_1_N = mkN "fartygstrafik" ; -- fartygstrafik..nn.1
  fartygstyp_1_N = mkN "fartygstyp" "fartygstyper" ; -- fartygstyp..nn.1
  fartygsvrak_1_N = mkN "fartygsvrak" neutrum  ; -- fartygsvrak..nn.1
  farvatten_1_N = mkN "farvatten" "farvattnet" "farvatten" "farvattnen" ; -- farvatten..nn.1
  farväl_1_N = mkN "farväl" neutrum  ; -- farväl..nn.1
  faryngal_1_A = mkA "faryngal" ; -- faryngal..av.1
  fas_1_N = mkN "fas" "faser" ; -- fas..nn.1
  fasa_1_N = mkN "fasa" ; -- fasa..nn.1
  fasa_1_V = mkV "fasar" ; -- fasa..vb.1
  fasa_2_V = mkV "fasar" ; -- fasa..vb.2
  fasad_1_N = mkN "fasad" "fasader" ; -- fasad..nn.1
  fasadpensel_1_N = mkN "fasadpensel" ; -- fasadpensel..nn.1
  fasadplatta_1_N = mkN "fasadplatta" ; -- fasadplatta..nn.1
  fasadtegel_1_N = mkN "fasadtegel" neutrum  ; -- fasadtegel..nn.1
  fasan_1_N = mkN "fasan" "fasaner" ; -- fasan..nn.1
  fasande_1_N = mkN "fasande" ; -- fasande..nn.1
  fasansfull_1_A = mkA "fasansfull" ; -- fasansfull..av.1
  fasansfullhet_1_N = mkN "fasansfullhet" "fasansfullheter" ; -- fasansfullhet..nn.1
  fasaväckande_1_A = mkA "fasaväckande" ; -- fasaväckande..av.1
  fascination_1_N = mkN "fascination" ; -- fascination..nn.1
  fascinera_1_V = mkV "fascinerar" ; -- fascinera..vb.1
  fascinerad_1_A = mkA "fascinerad" ; -- fascinerad..av.1
  fascinerande_1_N = mkN "fascinerande" ; -- fascinerande..nn.1
  fascinerbar_1_A = mkA "fascinerbar" ; -- fascinerbar..av.1
  fascinerbarhet_1_N = mkN "fascinerbarhet" ; -- fascinerbarhet..nn.1
  fascinering_1_N = mkN "fascinering" ; -- fascinering..nn.1
  fascism_1_N = mkN "fascism" "fascismer" ; -- fascism..nn.1
  fascist_1_N = mkN "fascist" "fascister" ; -- fascist..nn.1
  fascistisk_1_A = mkA "fascistisk" ; -- fascistisk..av.1
  fascistoid_1_A = mkA "fascistoid" ; -- fascistoid..av.1
  fasen_1_N = mkN "fasen" ; -- fasen..nn.1
  fasett_1_N = mkN "fasett" "fasetter" ; -- fasett..nn.1
  fasettera_1_V = mkV "fasetterar" ; -- fasettera..vb.1
  fasetterad_1_A = mkA "fasetterad" ; -- fasetterad..av.1
  fasetterande_1_N = mkN "fasetterande" ; -- fasetterande..nn.1
  fasetterbar_1_A = mkA "fasetterbar" ; -- fasetterbar..av.1
  fasetterbarhet_1_N = mkN "fasetterbarhet" ; -- fasetterbarhet..nn.1
  fasettering_1_N = mkN "fasettering" ; -- fasettering..nn.1
  fasettöga_1_N = mkN "fasettöga" "fasettögat" "fasettögon" "fasettögonen" ; -- fasettöga..nn.1
  fasförskjutning_1_N = mkN "fasförskjutning" ; -- fasförskjutning..nn.1
  fashionabel_1_A = mkA "fashionabel" ; -- fashionabel..av.1
  fasingen_1_N = mkN "fasingen" ; -- fasingen..nn.1
  faskikel_1_N = mkN "faskikel" ; -- faskikel..nn.1
  faskin_1_N = mkN "faskin" "faskiner" ; -- faskin..nn.1
  faskinkniv_1_N = mkN "faskinkniv" ; -- faskinkniv..nn.1
  faslig_1_A = mkA "faslig" ; -- faslig..av.1
  faslighet_1_N = mkN "faslighet" "fasligheter" ; -- faslighet..nn.1
  fason_1_N = mkN "fason" "fasoner" ; -- fason..nn.1
  fasonera_1_V = mkV "fasonerar" ; -- fasonera..vb.1
  fasonerande_1_N = mkN "fasonerande" ; -- fasonerande..nn.1
  fasonerbar_1_A = mkA "fasonerbar" ; -- fasonerbar..av.1
  fasonerbarhet_1_N = mkN "fasonerbarhet" ; -- fasonerbarhet..nn.1
  fasonering_1_N = mkN "fasonering" ; -- fasonering..nn.1
  fasonlig_1_A = mkA "fasonlig" ; -- fasonlig..av.1
  fasspänning_1_N = mkN "fasspänning" ; -- fasspänning..nn.1
  fast_1_A = mkA "fast" "fast" ; -- fast..av.1
  fasta_1_N = mkN "fasta" ; -- fasta..nn.1
  fasta_1_V = mkV "fastar" ; -- fasta..vb.1
  fastage_1_N = mkN "fastage" "fastaget" "fastage" "fastagen" ; -- fastage..nn.1
  fastande_1_N = mkN "fastande" ; -- fastande..nn.1
  fastanställd_1_A = mkA "fastanställd" "fastanställt" ; -- fastanställd..av.1
  fastbindning_1_N = mkN "fastbindning" ; -- fastbindning..nn.1
  fastboende_1_A = mkA "fastboende" ; -- fastboende..av.1
  fastebrev_1_N = mkN "fastebrev" neutrum  ; -- fastebrev..nn.1
  fastedag_1_N = mkN "fastedag" ; -- fastedag..nn.1
  fastemånad_1_N = mkN "fastemånad" "fastemånader" ; -- fastemånad..nn.1
  faster_1_N = mkN "faster" ; -- faster..nn.1
  fastetid_1_N = mkN "fastetid" "fastetider" ; -- fastetid..nn.1
  fastfrusen_1_A = mkA "fastfrusen" ; -- fastfrusen..av.1
  fastfrysning_1_N = mkN "fastfrysning" ; -- fastfrysning..nn.1
  fastgöra_1_V = mkV "fastgöra" "fastgjorde" "fastgjort" ; -- fastgöra..vb.1
  fastgörande_1_N = mkN "fastgörande" ; -- fastgörande..nn.1
  fasthakning_1_N = mkN "fasthakning" ; -- fasthakning..nn.1
  fasthet_1_N = mkN "fasthet" "fastheter" ; -- fasthet..nn.1
  fasthängande_1_A = mkA "fasthängande" ; -- fasthängande..av.1
  fasthålla_1_V = mkV "fasthålla" "fasthöll" "fasthållit" ; -- fasthålla..vb.1
  fasthållande_1_N = mkN "fasthållande" ; -- fasthållande..nn.1
  fasthållning_1_N = mkN "fasthållning" ; -- fasthållning..nn.1
  fastighet_1_N = mkN "fastighet" "fastigheter" ; -- fastighet..nn.1
  fastighetsaffär_1_N = mkN "fastighetsaffär" "fastighetsaffärer" ; -- fastighetsaffär..nn.1
  fastighetsbolag_1_N = mkN "fastighetsbolag" neutrum  ; -- fastighetsbolag..nn.1
  fastighetsbransch_1_N = mkN "fastighetsbransch" ; -- fastighetsbransch..nn.1
  fastighetsbubbla_1_N = mkN "fastighetsbubbla" ; -- fastighetsbubbla..nn.1
  fastighetsbyrå_1_N = mkN "fastighetsbyrå" "fastighetsbyråer" ; -- fastighetsbyrå..nn.1
  fastighetsförsäljning_1_N = mkN "fastighetsförsäljning" ; -- fastighetsförsäljning..nn.1
  fastighetsindex_1_N = mkN "fastighetsindex" neutrum  ; -- fastighetsindex..nn.1
  fastighetskontor_1_N = mkN "fastighetskontor" neutrum  ; -- fastighetskontor..nn.1
  fastighetskris_1_N = mkN "fastighetskris" "fastighetskriser" ; -- fastighetskris..nn.1
  fastighetsköp_1_N = mkN "fastighetsköp" neutrum  ; -- fastighetsköp..nn.1
  fastighetslån_1_N = mkN "fastighetslån" neutrum  ; -- fastighetslån..nn.1
  fastighetsmogul_1_N = mkN "fastighetsmogul" "fastighetsmoguler" ; -- fastighetsmogul..nn.1
  fastighetsmäklare_1_N = mkN "fastighetsmäklare" utrum  ; -- fastighetsmäklare..nn.1
  fastighetsnämnd_1_N = mkN "fastighetsnämnd" "fastighetsnämnder" ; -- fastighetsnämnd..nn.1
  fastighetspris_1_N = mkN "fastighetspris" neutrum  ; -- fastighetspris..nn.1
  fastighetsskatt_1_N = mkN "fastighetsskatt" "fastighetsskatter" ; -- fastighetsskatt..nn.1
  fastighetsskötare_1_N = mkN "fastighetsskötare" utrum  ; -- fastighetsskötare..nn.1
  fastighetsspekulation_1_N = mkN "fastighetsspekulation" ; -- fastighetsspekulation..nn.1
  fastighetstaxera_1_V = mkV "fastighetstaxerar" ; -- fastighetstaxera..vb.1
  fastighetstaxerande_1_N = mkN "fastighetstaxerande" ; -- fastighetstaxerande..nn.1
  fastighetstaxerbar_1_A = mkA "fastighetstaxerbar" ; -- fastighetstaxerbar..av.1
  fastighetstaxerbarhet_1_N = mkN "fastighetstaxerbarhet" ; -- fastighetstaxerbarhet..nn.1
  fastighetstaxering_1_N = mkN "fastighetstaxering" ; -- fastighetstaxering..nn.1
  fastighetsägare_1_N = mkN "fastighetsägare" utrum  ; -- fastighetsägare..nn.1
  fastkedja_1_N = mkN "fastkedja" ; -- fastkedja..nn.1
  fastkedja_1_V = mkV "fastkedjar" ; -- fastkedja..vb.1
  fastkedjande_1_N = mkN "fastkedjande" ; -- fastkedjande..nn.1
  fastklistra_1_V = mkV "fastklistrar" ; -- fastklistra..vb.1
  fastklistrande_1_N = mkN "fastklistrande" ; -- fastklistrande..nn.1
  fastklämning_1_N = mkN "fastklämning" ; -- fastklämning..nn.1
  fastkoppling_1_N = mkN "fastkoppling" ; -- fastkoppling..nn.1
  fastlag_1_N = mkN "fastlag" ; -- fastlag..nn.1
  fastlagsbulla_1_N = mkN "fastlagsbulla" ; -- fastlagsbulla..nn.1
  fastlagsbulle_1_N = mkN "fastlagsbulle" utrum  ; -- fastlagsbulle..nn.1
  fastlagsris_1_N = mkN "fastlagsris" neutrum  ; -- fastlagsris..nn.1
  fastlagssöndag_1_N = mkN "fastlagssöndag" ; -- fastlagssöndag..nn.1
  fastlagsvecka_1_N = mkN "fastlagsvecka" ; -- fastlagsvecka..nn.1
  fastland_1_N = mkN "fastland" neutrum  ; -- fastland..nn.1
  fastlandsbo_1_N = mkN "fastlandsbo" "fastlandsbor" ; -- fastlandsbo..nn.1
  fastlandsklimat_1_N = mkN "fastlandsklimat" neutrum  ; -- fastlandsklimat..nn.1
  fastlimning_1_N = mkN "fastlimning" ; -- fastlimning..nn.1
  fastlägga_1_V = mkV "fastlägga" "fastla" "fastlagt" ; -- fastlägga..vb.1
  fastläggande_1_N = mkN "fastläggande" ; -- fastläggande..nn.1
  fastlänning_1_N = mkN "fastlänning" ; -- fastlänning..nn.1
  fastlåst_1_A = mkA "fastlåst" "fastlåst" ; -- fastlåst..av.1
  fastlödning_1_N = mkN "fastlödning" ; -- fastlödning..nn.1
  fastna_1_V = mkV "fastnar" ; -- fastna..vb.1
  fastnaglad_1_A = mkA "fastnaglad" ; -- fastnaglad..av.1
  fastnagling_1_N = mkN "fastnagling" ; -- fastnagling..nn.1
  fastnande_1_N = mkN "fastnande" ; -- fastnande..nn.1
  fastnitning_1_N = mkN "fastnitning" ; -- fastnitning..nn.1
  fastskruvad_1_A = mkA "fastskruvad" ; -- fastskruvad..av.1
  fastskruvning_1_N = mkN "fastskruvning" ; -- fastskruvning..nn.1
  fastslagning_1_N = mkN "fastslagning" ; -- fastslagning..nn.1
  fastslå_1_V = mkV "fastslå" "fastslog" "fastslagit" ; -- fastslå..vb.1
  fastslående_1_N = mkN "fastslående" ; -- fastslående..nn.1
  fastspikad_1_A = mkA "fastspikad" ; -- fastspikad..av.1
  fastspikning_1_N = mkN "fastspikning" ; -- fastspikning..nn.1
  fastspänning_1_N = mkN "fastspänning" ; -- fastspänning..nn.1
  fastställa_1_V = mkV "fastställer" ; -- fastställa..vb.1
  fastställande_1_N = mkN "fastställande" ; -- fastställande..nn.1
  fastställelse_1_N = mkN "fastställelse" "fastställelser" ; -- fastställelse..nn.1
  fastsurrad_1_A = mkA "fastsurrad" ; -- fastsurrad..av.1
  fastsurrning_1_N = mkN "fastsurrning" ; -- fastsurrning..nn.1
  fastsätta_1_V = mkV "fastsätta" "fastsätter" "fastsätt" "fastsatte" "fastsatt" "fastsatt" ; -- fastsätta..vb.1
  fastsättande_1_N = mkN "fastsättande" ; -- fastsättande..nn.1
  fastsättning_1_N = mkN "fastsättning" ; -- fastsättning..nn.1
  fastta_1_V = mkV "fasttaga" "fasttog" "fasttagit" ; -- fastta..vb.1
  fasttagande_1_N = mkN "fasttagande" ; -- fasttagande..nn.1
  fasttagning_1_N = mkN "fasttagning" ; -- fasttagning..nn.1
  fasttejpad_1_A = mkA "fasttejpad" ; -- fasttejpad..av.1
  fasttråckling_1_N = mkN "fasttråckling" ; -- fasttråckling..nn.1
  fastväxning_1_N = mkN "fastväxning" ; -- fastväxning..nn.1
  fat_1_N = mkN "fat" neutrum  ; -- fat..nn.1
  fatabur_1_N = mkN "fatabur" "fataburer" ; -- fatabur..nn.1
  fatal_1_A = mkA "fatal" ; -- fatal..av.1
  fataliedag_1_N = mkN "fataliedag" ; -- fataliedag..nn.1
  fatalietid_1_N = mkN "fatalietid" "fatalietider" ; -- fatalietid..nn.1
  fatalism_1_N = mkN "fatalism" "fatalismer" ; -- fatalism..nn.1
  fatalist_1_N = mkN "fatalist" "fatalister" ; -- fatalist..nn.1
  fatalistisk_1_A = mkA "fatalistisk" ; -- fatalistisk..av.1
  fatalitet_1_N = mkN "fatalitet" "fataliteter" ; -- fatalitet..nn.1
  fatbur_1_N = mkN "fatbur" "fatburer" ; -- fatbur..nn.1
  fatt_1_A = mkA "fatt" ; -- fatt..av.1
  fatta_1_V = mkV "fattar" ; -- fatta..vb.1
  fatta_2_V = mkV "fattar" ; -- fatta..vb.2
  fattad_1_A = mkA "fattad" ; -- fattad..av.1
  fattande_1_N = mkN "fattande" ; -- fattande..nn.1
  fattbar_1_A = mkA "fattbar" ; -- fattbar..av.1
  fattbarhet_1_N = mkN "fattbarhet" "fattbarheter" ; -- fattbarhet..nn.1
  fattig_1_A = mkA "fattig" ; -- fattig..av.1
  fattigbarn_1_N = mkN "fattigbarn" neutrum  ; -- fattigbarn..nn.1
  fattigdom_1_N = mkN "fattigdom" ; -- fattigdom..nn.1
  fattigdom_2_N = mkN "fattigdom" ; -- fattigdom..nn.2
  fattigdomsbevis_1_N = mkN "fattigdomsbevis" neutrum  ; -- fattigdomsbevis..nn.1
  fattigdomsfälla_1_N = mkN "fattigdomsfälla" ; -- fattigdomsfälla..nn.1
  fattigdomslöfte_1_N = mkN "fattigdomslöfte" ; -- fattigdomslöfte..nn.1
  fattigdomsminskning_1_N = mkN "fattigdomsminskning" ; -- fattigdomsminskning..nn.1
  fattigdomsstreck_1_N = mkN "fattigdomsstreck" neutrum  ; -- fattigdomsstreck..nn.1
  fattighjon_1_N = mkN "fattighjon" neutrum  ; -- fattighjon..nn.1
  fattighjälp_1_N = mkN "fattighjälp" ; -- fattighjälp..nn.1
  fattighus_1_N = mkN "fattighus" neutrum  ; -- fattighus..nn.1
  fattigkvarter_1_N = mkN "fattigkvarter" "fattigkvarteret" "fattigkvarter" "fattigkvarteren" ; -- fattigkvarter..nn.1
  fattiglapp_1_N = mkN "fattiglapp" ; -- fattiglapp..nn.1
  fattigstuga_1_N = mkN "fattigstuga" ; -- fattigstuga..nn.1
  fattigunderstöd_1_N = mkN "fattigunderstöd" neutrum  ; -- fattigunderstöd..nn.1
  fattigvård_1_N = mkN "fattigvård" ; -- fattigvård..nn.1
  fattlig_1_A = mkA "fattlig" ; -- fattlig..av.1
  fattlighet_1_N = mkN "fattlighet" ; -- fattlighet..nn.1
  fattning_1_N = mkN "fattning" ; -- fattning..nn.1
  fattningsförmåga_1_N = mkN "fattningsförmåga" ; -- fattningsförmåga..nn.1
  fattningsgåva_1_N = mkN "fattningsgåva" ; -- fattningsgåva..nn.1
  fatwa_1_N = mkN "fatwa" ; -- fatwa..nn.1
  fatöl_1_N = mkN "fatöl" neutrum  ; -- fatöl..nn.1
  faun_1_N = mkN "faun" "fauner" ; -- faun..nn.1
  fauna_1_N = mkN "fauna" ; -- fauna..nn.1
  faunist_1_N = mkN "faunist" "faunister" ; -- faunist..nn.1
  faunistik_1_N = mkN "faunistik" ; -- faunistik..nn.1
  faunistisk_1_A = mkA "faunistisk" ; -- faunistisk..av.1
  faute_1_N = mkN "faute" "fauter" ; -- faute..nn.1
  favo_1_N = mkN "favo" "favot" "favo" "favon" ; -- favo..nn.1
  favorisera_1_V = mkV "favoriserar" ; -- favorisera..vb.1
  favoriserande_1_N = mkN "favoriserande" ; -- favoriserande..nn.1
  favoriserbar_1_A = mkA "favoriserbar" ; -- favoriserbar..av.1
  favoriserbarhet_1_N = mkN "favoriserbarhet" ; -- favoriserbarhet..nn.1
  favorisering_1_N = mkN "favorisering" ; -- favorisering..nn.1
  favorit_1_N = mkN "favorit" "favoriter" ; -- favorit..nn.1
  favoritaccessoar_1_N = mkN "favoritaccessoar" "favoritaccessoarer" ; -- favoritaccessoar..nn.1
  favoritbild_1_N = mkN "favoritbild" "favoritbilder" ; -- favoritbild..nn.1
  favoritfik_1_N = mkN "favoritfik" neutrum  ; -- favoritfik..nn.1
  favoritförfattare_1_N = mkN "favoritförfattare" utrum  ; -- favoritförfattare..nn.1
  favorithak_1_N = mkN "favorithak" neutrum  ; -- favorithak..nn.1
  favoritknep_1_N = mkN "favoritknep" neutrum  ; -- favoritknep..nn.1
  favoritmelodi_1_N = mkN "favoritmelodi" "favoritmelodier" ; -- favoritmelodi..nn.1
  favoritnöje_1_N = mkN "favoritnöje" ; -- favoritnöje..nn.1
  favoritplats_1_N = mkN "favoritplats" "favoritplatser" ; -- favoritplats..nn.1
  favoritpsalm_1_N = mkN "favoritpsalm" "favoritpsalmer" ; -- favoritpsalm..nn.1
  favoritrestaurang_1_N = mkN "favoritrestaurang" "favoritrestauranger" ; -- favoritrestaurang..nn.1
  favoriträtt_1_N = mkN "favoriträtt" "favoriträtter" ; -- favoriträtt..nn.1
  favoritskådespelerska_1_N = mkN "favoritskådespelerska" ; -- favoritskådespelerska..nn.1
  favoritstrand_1_N = mkN "favoritstrand" "favoritstränder" ; -- favoritstrand..nn.1
  favoritsystem_1_N = mkN "favoritsystem" neutrum  ; -- favoritsystem..nn.1
  favorittippad_1_A = mkA "favorittippad" ; -- favorittippad..av.1
  favvo_1_N = mkN "favvo" "favvot" "favvo" "favvon" ; -- favvo..nn.1
  favör_1_N = mkN "favör" "favörer" ; -- favör..nn.1
  fax_1_N = mkN "fax" ; -- fax..nn.1
  fax_2_N = mkN "fax" neutrum  ; -- fax..nn.2
  faxa_1_V = mkV "faxar" ; -- faxa..vb.1
  faxande_1_N = mkN "faxande" ; -- faxande..nn.1
  fe_1_N = mkN "fe" "feer" ; -- fe..nn.1
  featureprogram_1_N = mkN "featureprogram" "featureprogrammet" "featureprogram" "featureprogrammen" ; -- featureprogram..nn.1
  feber_1_N = mkN "feber" ; -- feber..nn.1
  feberaktig_1_A = mkA "feberaktig" ; -- feberaktig..av.1
  feberaktighet_1_N = mkN "feberaktighet" ; -- feberaktighet..nn.1
  feberanfall_1_N = mkN "feberanfall" neutrum  ; -- feberanfall..nn.1
  feberdröm_1_N = mkN "feberdröm" "feberdrömmen" "feberdrömmar" "feberdrömmarna" ; -- feberdröm..nn.1
  feberdämpande_1_A = mkA "feberdämpande" ; -- feberdämpande..av.1
  feberepidemi_1_N = mkN "feberepidemi" "feberepidemier" ; -- feberepidemi..nn.1
  feberfantasi_1_N = mkN "feberfantasi" "feberfantasier" ; -- feberfantasi..nn.1
  feberfri_1_A = mkA "feberfri" "feberfritt" ; -- feberfri..av.1
  feberhet_1_A = mkA "feberhet" ; -- feberhet..av.1
  feberhetta_1_N = mkN "feberhetta" ; -- feberhetta..nn.1
  feberkurva_1_N = mkN "feberkurva" ; -- feberkurva..nn.1
  febernedsättande_1_A = mkA "febernedsättande" ; -- febernedsättande..av.1
  febersjuk_1_A = mkA "febersjuk" ; -- febersjuk..av.1
  febersjukdom_1_N = mkN "febersjukdom" ; -- febersjukdom..nn.1
  feberstillande_1_A = mkA "feberstillande" ; -- feberstillande..av.1
  febertermometer_1_N = mkN "febertermometer" ; -- febertermometer..nn.1
  febertopp_1_N = mkN "febertopp" ; -- febertopp..nn.1
  feberyra_1_N = mkN "feberyra" ; -- feberyra..nn.1
  febrig_1_A = mkA "febrig" ; -- febrig..av.1
  febrighet_1_N = mkN "febrighet" ; -- febrighet..nn.1
  febril_1_A = mkA "febril" ; -- febril..av.1
  februari_1_N = mkN "februari" ; -- februari..nn.1
  februarilov_1_N = mkN "februarilov" neutrum  ; -- februarilov..nn.1
  februarioffensiv_1_N = mkN "februarioffensiv" "februarioffensiver" ; -- februarioffensiv..nn.1
  februarisol_1_N = mkN "februarisol" ; -- februarisol..nn.1
  federal_1_A = mkA "federal" ; -- federal..av.1
  federalism_1_N = mkN "federalism" "federalismer" ; -- federalism..nn.1
  federalist_1_N = mkN "federalist" "federalister" ; -- federalist..nn.1
  federalistisk_1_A = mkA "federalistisk" ; -- federalistisk..av.1
  federation_1_N = mkN "federation" ; -- federation..nn.1
  federativ_1_A = mkA "federativ" ; -- federativ..av.1
  federerad_1_A = mkA "federerad" ; -- federerad..av.1
  fedrottning_1_N = mkN "fedrottning" ; -- fedrottning..nn.1
  feedback_1_N = mkN "feedback" ; -- feedback..nn.1
  feeri_1_N = mkN "feeri" "feeriet" "feerier" "feerierna" ; -- feeri..nn.1
  feg_1_A = mkA "feg" ; -- feg..av.1
  fega_1_V = mkV "fegar" ; -- fega..vb.1
  feghet_1_N = mkN "feghet" "fegheter" ; -- feghet..nn.1
  fegis_1_N = mkN "fegis" ; -- fegis..nn.1
  fegspel_1_N = mkN "fegspel" "fegspelet" "fegspel" "fegspelen" ; -- fegspel..nn.1
  feja_1_V = mkV "fejar" ; -- feja..vb.1
  fejande_1_N = mkN "fejande" ; -- fejande..nn.1
  fejd_1_N = mkN "fejd" "fejder" ; -- fejd..nn.1
  fejda_1_V = mkV "fejdar" ; -- fejda..vb.1
  fejda_2_V = mkV "fejdar" ; -- fejda..vb.2
  fejka_1_V = mkV "fejkar" ; -- fejka..vb.1
  fejkande_1_N = mkN "fejkande" ; -- fejkande..nn.1
  fejning_1_N = mkN "fejning" ; -- fejning..nn.1
  fekal_1_A = mkA "fekal" ; -- fekal..av.1
  fel_1_A = mkA "fel" ; -- fel..av.1
  fel_1_N = mkN "fel" neutrum  ; -- fel..nn.1
  fel_2_N = mkN "fel" neutrum  ; -- fel..nn.2
  fela_1_N = mkN "fela" ; -- fela..nn.1
  fela_1_V = mkV "felar" ; -- fela..vb.1
  felaktig_1_A = mkA "felaktig" ; -- felaktig..av.1
  felaktighet_1_N = mkN "felaktighet" "felaktigheter" ; -- felaktighet..nn.1
  felande_1_N = mkN "felande" ; -- felande..nn.1
  felbedöma_1_V = mkV "felbedömer" ; -- felbedöma..vb.1
  felbedömande_1_N = mkN "felbedömande" ; -- felbedömande..nn.1
  felbedömning_1_N = mkN "felbedömning" ; -- felbedömning..nn.1
  felbehandlad_1_A = mkA "felbehandlad" ; -- felbehandlad..av.1
  felbehandling_1_N = mkN "felbehandling" ; -- felbehandling..nn.1
  felberäkning_1_N = mkN "felberäkning" ; -- felberäkning..nn.1
  felbeskuren_1_A = mkA "felbeskuren" ; -- felbeskuren..av.1
  felciterad_1_A = mkA "felciterad" ; -- felciterad..av.1
  feldaterad_1_A = mkA "feldaterad" ; -- feldaterad..av.1
  feldatering_1_N = mkN "feldatering" ; -- feldatering..nn.1
  feldiagnos_1_N = mkN "feldiagnos" "feldiagnoser" ; -- feldiagnos..nn.1
  feldosera_1_V = mkV "feldoserar" ; -- feldosera..vb.1
  feldoserande_1_N = mkN "feldoserande" ; -- feldoserande..nn.1
  feldosering_1_N = mkN "feldosering" ; -- feldosering..nn.1
  feldrag_1_N = mkN "feldrag" neutrum  ; -- feldrag..nn.1
  felfinnare_1_N = mkN "felfinnare" utrum  ; -- felfinnare..nn.1
  felfinneri_1_N = mkN "felfinneri" neutrum  ; -- felfinneri..nn.1
  felfri_1_A = mkA "felfri" "felfritt" ; -- felfri..av.1
  felfrihet_1_N = mkN "felfrihet" ; -- felfrihet..nn.1
  felgrepp_1_N = mkN "felgrepp" neutrum  ; -- felgrepp..nn.1
  felhandling_1_N = mkN "felhandling" ; -- felhandling..nn.1
  felinformerad_1_A = mkA "felinformerad" ; -- felinformerad..av.1
  felinvestering_1_N = mkN "felinvestering" ; -- felinvestering..nn.1
  felkokt_1_A = mkA "felkokt" "felkokt" ; -- felkokt..av.1
  felkonstruerad_1_A = mkA "felkonstruerad" ; -- felkonstruerad..av.1
  felkälla_1_N = mkN "felkälla" ; -- felkälla..nn.1
  felköp_1_N = mkN "felköp" neutrum  ; -- felköp..nn.1
  felläsning_1_N = mkN "felläsning" ; -- felläsning..nn.1
  felmarginal_1_N = mkN "felmarginal" "felmarginaler" ; -- felmarginal..nn.1
  felnavigera_1_V = mkV "felnavigerar" ; -- felnavigera..vb.1
  felnavigerande_1_N = mkN "felnavigerande" ; -- felnavigerande..nn.1
  felnavigering_1_N = mkN "felnavigering" ; -- felnavigering..nn.1
  felparkera_1_V = mkV "felparkerar" ; -- felparkera..vb.1
  felparkerande_1_N = mkN "felparkerande" ; -- felparkerande..nn.1
  felparkerbar_1_A = mkA "felparkerbar" ; -- felparkerbar..av.1
  felparkerbarhet_1_N = mkN "felparkerbarhet" ; -- felparkerbarhet..nn.1
  felparkering_1_N = mkN "felparkering" ; -- felparkering..nn.1
  felplacerad_1_A = mkA "felplacerad" ; -- felplacerad..av.1
  felprioritera_1_V = mkV "felprioriterar" ; -- felprioritera..vb.1
  felprioriterande_1_N = mkN "felprioriterande" ; -- felprioriterande..nn.1
  felprioritering_1_N = mkN "felprioritering" ; -- felprioritering..nn.1
  felprocent_1_N = mkN "felprocent" "felprocenten" "felprocent" "felprocenten" ; -- felprocent..nn.1
  felriktad_1_A = mkA "felriktad" ; -- felriktad..av.1
  felräkning_1_N = mkN "felräkning" ; -- felräkning..nn.1
  felräkningspeng_1_N = mkN "felräkningspeng" ; -- felräkningspeng..nn.1
  felsatsning_1_N = mkN "felsatsning" ; -- felsatsning..nn.1
  felskriven_1_A = mkA "felskriven" ; -- felskriven..av.1
  felskrivning_1_N = mkN "felskrivning" ; -- felskrivning..nn.1
  felslagen_1_A = mkA "felslagen" ; -- felslagen..av.1
  felslut_1_N = mkN "felslut" neutrum  ; -- felslut..nn.1
  felslående_1_N = mkN "felslående" ; -- felslående..nn.1
  felstavad_1_A = mkA "felstavad" ; -- felstavad..av.1
  felsteg_1_N = mkN "felsteg" neutrum  ; -- felsteg..nn.1
  felställd_1_A = mkA "felställd" "felställt" ; -- felställd..av.1
  felsyn_1_N = mkN "felsyn" ; -- felsyn..nn.1
  felsägning_1_N = mkN "felsägning" ; -- felsägning..nn.1
  felsökare_1_N = mkN "felsökare" utrum  ; -- felsökare..nn.1
  feltolka_1_V = mkV "feltolkar" ; -- feltolka..vb.1
  feltolkande_1_N = mkN "feltolkande" ; -- feltolkande..nn.1
  feltolkning_1_N = mkN "feltolkning" ; -- feltolkning..nn.1
  feltryck_1_N = mkN "feltryck" neutrum  ; -- feltryck..nn.1
  feltryckt_1_A = mkA "feltryckt" "feltryckt" ; -- feltryckt..av.1
  feltänk_1_N = mkN "feltänk" neutrum  ; -- feltänk..nn.1
  felunderrättad_1_A = mkA "felunderrättad" ; -- felunderrättad..av.1
  felutveckling_1_N = mkN "felutveckling" ; -- felutveckling..nn.1
  felval_1_N = mkN "felval" neutrum  ; -- felval..nn.1
  femaktare_1_N = mkN "femaktare" utrum  ; -- femaktare..nn.1
  femarmad_1_A = mkA "femarmad" ; -- femarmad..av.1
  fembarnsmamma_1_N = mkN "fembarnsmamma" ; -- fembarnsmamma..nn.1
  femcylindrig_1_A = mkA "femcylindrig" ; -- femcylindrig..av.1
  femdagarsvecka_1_N = mkN "femdagarsvecka" ; -- femdagarsvecka..nn.1
  femdelning_1_N = mkN "femdelning" ; -- femdelning..nn.1
  femdubbel_1_A = mkA "femdubben" ; -- femdubbel..av.1
  femdubbla_1_V = mkV "femdubblar" ; -- femdubbla..vb.1
  femdubblande_1_N = mkN "femdubblande" ; -- femdubblande..nn.1
  femdubbling_1_N = mkN "femdubbling" ; -- femdubbling..nn.1
  femdygnsprognos_1_N = mkN "femdygnsprognos" "femdygnsprognoser" ; -- femdygnsprognos..nn.1
  femetta_1_N = mkN "femetta" ; -- femetta..nn.1
  femfaldig_1_A = mkA "femfaldig" ; -- femfaldig..av.1
  femfaldiga_1_V = mkV "femfaldigar" ; -- femfaldiga..vb.1
  femfaldigande_1_N = mkN "femfaldigande" ; -- femfaldigande..nn.1
  femfemma_1_N = mkN "femfemma" ; -- femfemma..nn.1
  femfilmskontrakt_1_N = mkN "femfilmskontrakt" neutrum  ; -- femfilmskontrakt..nn.1
  femflikig_1_A = mkA "femflikig" ; -- femflikig..av.1
  femgradig_1_A = mkA "femgradig" ; -- femgradig..av.1
  femhundrade_1_A = mkA "femhundrade" ; -- femhundrade..av.1
  femhundrakronorssedel_1_N = mkN "femhundrakronorssedel" ; -- femhundrakronorssedel..nn.1
  femhörnig_1_A = mkA "femhörnig" ; -- femhörnig..av.1
  femhörning_1_N = mkN "femhörning" ; -- femhörning..nn.1
  feminin_1_A = mkA "feminin" ; -- feminin..av.1
  feminin_2_A = mkA "feminin" ; -- feminin..av.2
  femininbildning_1_N = mkN "femininbildning" ; -- femininbildning..nn.1
  femininform_1_N = mkN "femininform" "femininformer" ; -- femininform..nn.1
  femininum_1_N = mkN "femininum" "femininum" "femininer" "femininerna" ; -- femininum..nn.1
  femininändelse_1_N = mkN "femininändelse" "femininändelser" ; -- femininändelse..nn.1
  feminiserad_1_A = mkA "feminiserad" ; -- feminiserad..av.1
  feminism_1_N = mkN "feminism" "feminismer" ; -- feminism..nn.1
  feminist_1_N = mkN "feminist" "feminister" ; -- feminist..nn.1
  feministisk_1_A = mkA "feministisk" ; -- feministisk..av.1
  feministtjafs_1_N = mkN "feministtjafs" neutrum  ; -- feministtjafs..nn.1
  femkamp_1_N = mkN "femkamp" "femkamper" ; -- femkamp..nn.1
  femkort_1_N = mkN "femkort" ; -- femkort..nn.1
  femkrona_1_N = mkN "femkrona" ; -- femkrona..nn.1
  femkronorsmynt_1_N = mkN "femkronorsmynt" neutrum  ; -- femkronorsmynt..nn.1
  femling_1_N = mkN "femling" ; -- femling..nn.1
  femma_1_N = mkN "femma" ; -- femma..nn.1
  femmarkerkorv_1_N = mkN "femmarkerkorv" ; -- femmarkerkorv..nn.1
  femmil_1_N = mkN "femmil" ; -- femmil..nn.1
  femprocentig_1_A = mkA "femprocentig" ; -- femprocentig..av.1
  fempunktslaser_1_N = mkN "fempunktslaser" ; -- fempunktslaser..nn.1
  fempunktsplan_1_N = mkN "fempunktsplan" "fempunktsplaner" ; -- fempunktsplan..nn.1
  femrummare_1_N = mkN "femrummare" utrum  ; -- femrummare..nn.1
  femrumslägenhet_1_N = mkN "femrumslägenhet" "femrumslägenheter" ; -- femrumslägenhet..nn.1
  femsidig_1_A = mkA "femsidig" ; -- femsidig..av.1
  femsiffrig_1_A = mkA "femsiffrig" ; -- femsiffrig..av.1
  femsitsig_1_A = mkA "femsitsig" ; -- femsitsig..av.1
  femstjärnig_1_A = mkA "femstjärnig" ; -- femstjärnig..av.1
  femstämmig_1_A = mkA "femstämmig" ; -- femstämmig..av.1
  femtal_1_N = mkN "femtal" neutrum  ; -- femtal..nn.1
  femte_1_A = mkA "femte" ; -- femte..av.1
  femtedel_1_N = mkN "femtedel" "femtedelen" "femtedelar" "femtedelarna" ; -- femtedel..nn.1
  femtekolonn_1_N = mkN "femtekolonn" "femtekolonner" ; -- femtekolonn..nn.1
  femtekolonnare_1_N = mkN "femtekolonnare" utrum  ; -- femtekolonnare..nn.1
  femteplats_1_N = mkN "femteplats" "femteplatser" ; -- femteplats..nn.1
  femtidollarsedel_1_N = mkN "femtidollarsedel" ; -- femtidollarsedel..nn.1
  femtielfte_1_A = mkA "femtielfte" ; -- femtielfte..av.1
  femtikronorssedel_1_N = mkN "femtikronorssedel" ; -- femtikronorssedel..nn.1
  femtilapp_1_N = mkN "femtilapp" ; -- femtilapp..nn.1
  femtiliters_1_A = mkA "femtiliters" ; -- femtiliters..av.1
  femtiodollarsedel_1_N = mkN "femtiodollarsedel" ; -- femtiodollarsedel..nn.1
  femtioelfte_1_A = mkA "femtioelfte" ; -- femtioelfte..av.1
  femtiokronorssedel_1_N = mkN "femtiokronorssedel" ; -- femtiokronorssedel..nn.1
  femtiometerssträcka_1_N = mkN "femtiometerssträcka" ; -- femtiometerssträcka..nn.1
  femtionde_1_A = mkA "femtionde" ; -- femtionde..av.1
  femtiotal_1_N = mkN "femtiotal" neutrum  ; -- femtiotal..nn.1
  femtiotalist_1_N = mkN "femtiotalist" "femtiotalister" ; -- femtiotalist..nn.1
  femtiotalsinspirerad_1_A = mkA "femtiotalsinspirerad" ; -- femtiotalsinspirerad..av.1
  femtioårig_1_A = mkA "femtioårig" ; -- femtioårig..av.1
  femtioårsdag_1_N = mkN "femtioårsdag" ; -- femtioårsdag..nn.1
  femtioårsjubileum_1_N = mkN "femtioårsjubileum" "femtioårsjubileet" "femtioårsjubileer" "femtioårsjubileerna" ; -- femtioårsjubileum..nn.1
  femtioöring_1_N = mkN "femtioöring" ; -- femtioöring..nn.1
  femtital_1_N = mkN "femtital" neutrum  ; -- femtital..nn.1
  femtitalist_1_N = mkN "femtitalist" "femtitalister" ; -- femtitalist..nn.1
  femtiårsdag_1_N = mkN "femtiårsdag" ; -- femtiårsdag..nn.1
  femtiöring_1_N = mkN "femtiöring" ; -- femtiöring..nn.1
  femtocell_1_N = mkN "femtocell" "femtoceller" ; -- femtocell..nn.1
  femtonbarnsmamma_1_N = mkN "femtonbarnsmamma" ; -- femtonbarnsmamma..nn.1
  femtonde_1_A = mkA "femtonde" ; -- femtonde..av.1
  femtondedel_1_N = mkN "femtondedel" "femtondedelen" "femtondedelar" "femtondedelarna" ; -- femtondedel..nn.1
  femtondel_1_N = mkN "femtondel" "femtondelen" "femtondelar" "femtondelarna" ; -- femtondel..nn.1
  femtonhundrameterslopp_1_N = mkN "femtonhundrameterslopp" neutrum  ; -- femtonhundrameterslopp..nn.1
  femtonhundratal_1_N = mkN "femtonhundratal" neutrum  ; -- femtonhundratal..nn.1
  femtontal_1_N = mkN "femtontal" neutrum  ; -- femtontal..nn.1
  femtonårig_1_A = mkA "femtonårig" ; -- femtonårig..av.1
  femtonåring_1_N = mkN "femtonåring" ; -- femtonåring..nn.1
  femtonårsstraff_1_N = mkN "femtonårsstraff" neutrum  ; -- femtonårsstraff..nn.1
  femtumsspik_1_N = mkN "femtumsspik" ; -- femtumsspik..nn.1
  femuddig_1_A = mkA "femuddig" ; -- femuddig..av.1
  femväxlad_1_A = mkA "femväxlad" ; -- femväxlad..av.1
  femårig_1_A = mkA "femårig" ; -- femårig..av.1
  femåring_1_N = mkN "femåring" ; -- femåring..nn.1
  femårsperiod_1_N = mkN "femårsperiod" "femårsperioder" ; -- femårsperiod..nn.1
  femårsplan_1_N = mkN "femårsplan" "femårsplaner" ; -- femårsplan..nn.1
  femöring_1_N = mkN "femöring" ; -- femöring..nn.1
  fena_1_A = mkA "fena" ; -- fena..av.1
  fena_1_N = mkN "fena" ; -- fena..nn.1
  fender_1_N = mkN "fender" ; -- fender..nn.1
  fendert_1_N = mkN "fendert" ; -- fendert..nn.1
  fenedrin_1_N = mkN "fenedrin" "fenedriner" ; -- fenedrin..nn.1
  fenicier_1_N = mkN "fenicier" "feniciern" "fenicier" "fenicierna" ; -- fenicier..nn.1
  fenicisk_1_A = mkA "fenicisk" ; -- fenicisk..av.1
  fenixbål_1_N = mkN "fenixbål" neutrum  ; -- fenixbål..nn.1
  fenköl_1_N = mkN "fenköl" ; -- fenköl..nn.1
  fenmetralin_1_N = mkN "fenmetralin" "fenmetraliner" ; -- fenmetralin..nn.1
  fennicism_1_N = mkN "fennicism" "fennicismer" ; -- fennicism..nn.1
  fennoman_1_N = mkN "fennoman" "fennomaner" ; -- fennoman..nn.1
  fennomani_1_N = mkN "fennomani" ; -- fennomani..nn.1
  fenol_1_N = mkN "fenol" "fenoler" ; -- fenol..nn.1
  fenolftalein_1_N = mkN "fenolftalein" "fenolftaleiner" ; -- fenolftalein..nn.1
  fenolisk_1_A = mkA "fenolisk" ; -- fenolisk..av.1
  fenomen_1_N = mkN "fenomen" neutrum  ; -- fenomen..nn.1
  fenomenal_1_A = mkA "fenomenal" ; -- fenomenal..av.1
  fenomenalism_1_N = mkN "fenomenalism" "fenomenalismer" ; -- fenomenalism..nn.1
  fenomenologi_1_N = mkN "fenomenologi" ; -- fenomenologi..nn.1
  fenomenologisk_1_A = mkA "fenomenologisk" ; -- fenomenologisk..av.1
  fenomenvärld_1_N = mkN "fenomenvärld" ; -- fenomenvärld..nn.1
  fenoplast_1_N = mkN "fenoplast" "fenoplaster" ; -- fenoplast..nn.1
  fenotyp_1_N = mkN "fenotyp" "fenotyper" ; -- fenotyp..nn.1
  fenoxisyra_1_N = mkN "fenoxisyra" ; -- fenoxisyra..nn.1
  fenval_1_N = mkN "fenval" ; -- fenval..nn.1
  feodal_1_A = mkA "feodal" ; -- feodal..av.1
  feodalherre_1_N = mkN "feodalherre" utrum  ; -- feodalherre..nn.1
  feodalism_1_N = mkN "feodalism" "feodalismer" ; -- feodalism..nn.1
  feodalistisk_1_A = mkA "feodalistisk" ; -- feodalistisk..av.1
  feodalväsen_1_N = mkN "feodalväsen" neutrum  ; -- feodalväsen..nn.1
  ferie_1_N = mkN "ferie" "ferier" ; -- ferie..nn.1
  ferieskola_1_N = mkN "ferieskola" ; -- ferieskola..nn.1
  ferietid_1_N = mkN "ferietid" "ferietider" ; -- ferietid..nn.1
  ferm_1_A = mkA "ferm" ; -- ferm..av.1
  fermat_1_N = mkN "fermat" neutrum  ; -- fermat..nn.1
  ferment_1_N = mkN "ferment" neutrum  ; -- ferment..nn.1
  fermentera_1_V = mkV "fermenterar" ; -- fermentera..vb.1
  fermenterande_1_N = mkN "fermenterande" ; -- fermenterande..nn.1
  fermenterbar_1_A = mkA "fermenterbar" ; -- fermenterbar..av.1
  fermenterbarhet_1_N = mkN "fermenterbarhet" ; -- fermenterbarhet..nn.1
  fermentering_1_N = mkN "fermentering" ; -- fermentering..nn.1
  fermhet_1_N = mkN "fermhet" ; -- fermhet..nn.1
  fermitet_1_N = mkN "fermitet" "fermiteter" ; -- fermitet..nn.1
  fermium_1_N = mkN "fermium" neutrum  ; -- fermium..nn.1
  fernissa_1_N = mkN "fernissa" ; -- fernissa..nn.1
  fernissa_1_V = mkV "fernissar" ; -- fernissa..vb.1
  fernissande_1_N = mkN "fernissande" ; -- fernissande..nn.1
  feromon_1_N = mkN "feromon" "feromoner" ; -- feromon..nn.1
  ferrit_1_N = mkN "ferrit" "ferriter" ; -- ferrit..nn.1
  ferritkärna_1_N = mkN "ferritkärna" ; -- ferritkärna..nn.1
  ferrolegering_1_N = mkN "ferrolegering" ; -- ferrolegering..nn.1
  ferrum_1_N = mkN "ferrum" neutrum  ; -- ferrum..nn.1
  fertil_1_A = mkA "fertil" ; -- fertil..av.1
  fertilitet_1_N = mkN "fertilitet" "fertiliteter" ; -- fertilitet..nn.1
  fest_1_N = mkN "fest" "fester" ; -- fest..nn.1
  festa_1_V = mkV "festar" ; -- festa..vb.1
  festande_1_N = mkN "festande" ; -- festande..nn.1
  festarrangör_1_N = mkN "festarrangör" "festarrangörer" ; -- festarrangör..nn.1
  festbord_1_N = mkN "festbord" neutrum  ; -- festbord..nn.1
  festdag_1_N = mkN "festdag" ; -- festdag..nn.1
  festdeltagare_1_N = mkN "festdeltagare" utrum  ; -- festdeltagare..nn.1
  festdräkt_1_N = mkN "festdräkt" "festdräkter" ; -- festdräkt..nn.1
  festfixare_1_N = mkN "festfixare" utrum  ; -- festfixare..nn.1
  festföremål_1_N = mkN "festföremål" neutrum  ; -- festföremål..nn.1
  festgeneral_1_N = mkN "festgeneral" "festgeneraler" ; -- festgeneral..nn.1
  festglädje_1_N = mkN "festglädje" utrum  ; -- festglädje..nn.1
  festival_1_N = mkN "festival" "festivaler" ; -- festival..nn.1
  festivalbiljett_1_N = mkN "festivalbiljett" "festivalbiljetter" ; -- festivalbiljett..nn.1
  festivaljury_1_N = mkN "festivaljury" "festivaljuryer" ; -- festivaljury..nn.1
  festivalluff_1_N = mkN "festivalluff" ; -- festivalluff..nn.1
  festivaltält_1_N = mkN "festivaltält" neutrum  ; -- festivaltält..nn.1
  festivitas_1_N = mkN "festivitas" ; -- festivitas..nn.1
  festivitet_1_N = mkN "festivitet" "festiviteter" ; -- festivitet..nn.1
  festkamrat_1_N = mkN "festkamrat" "festkamrater" ; -- festkamrat..nn.1
  festklädd_1_A = mkA "festklädd" ; -- festklädd..av.1
  festklänning_1_N = mkN "festklänning" ; -- festklänning..nn.1
  festkompis_1_N = mkN "festkompis" ; -- festkompis..nn.1
  festkväll_1_N = mkN "festkväll" ; -- festkväll..nn.1
  festlig_1_A = mkA "festlig" ; -- festlig..av.1
  festlighet_1_N = mkN "festlighet" "festligheter" ; -- festlighet..nn.1
  festlighet_2_N = mkN "festlighet" ; -- festlighet..nn.2
  festlokal_1_N = mkN "festlokal" "festlokaler" ; -- festlokal..nn.1
  festmiddag_1_N = mkN "festmiddag" ; -- festmiddag..nn.1
  festmåltid_1_N = mkN "festmåltid" "festmåltider" ; -- festmåltid..nn.1
  feston_1_N = mkN "feston" "festoner" ; -- feston..nn.1
  festong_1_N = mkN "festong" "festonger" ; -- festong..nn.1
  festplanering_1_N = mkN "festplanering" ; -- festplanering..nn.1
  festprisse_1_N = mkN "festprisse" utrum  ; -- festprisse..nn.1
  festprogram_1_N = mkN "festprogram" "festprogrammet" "festprogram" "festprogrammen" ; -- festprogram..nn.1
  festsal_1_N = mkN "festsal" ; -- festsal..nn.1
  festskrift_1_N = mkN "festskrift" "festskrifter" ; -- festskrift..nn.1
  festspel_1_N = mkN "festspel" "festspelet" "festspel" "festspelen" ; -- festspel..nn.1
  feststämning_1_N = mkN "feststämning" ; -- feststämning..nn.1
  festtal_1_N = mkN "festtal" neutrum  ; -- festtal..nn.1
  festtalare_1_N = mkN "festtalare" utrum  ; -- festtalare..nn.1
  festtåg_1_N = mkN "festtåg" neutrum  ; -- festtåg..nn.1
  festutstyrsel_1_N = mkN "festutstyrsel" ; -- festutstyrsel..nn.1
  festvärdinna_1_N = mkN "festvärdinna" ; -- festvärdinna..nn.1
  festvåning_1_N = mkN "festvåning" ; -- festvåning..nn.1
  fet_1_A = mkA "fet" ; -- fet..av.1
  fetaost_1_N = mkN "fetaost" ; -- fetaost..nn.1
  fetblad_1_N = mkN "fetblad" neutrum  ; -- fetblad..nn.1
  fetera_1_V = mkV "feterar" ; -- fetera..vb.1
  feterande_1_N = mkN "feterande" ; -- feterande..nn.1
  feterbar_1_A = mkA "feterbar" ; -- feterbar..av.1
  feterbarhet_1_N = mkN "feterbarhet" ; -- feterbarhet..nn.1
  fetering_1_N = mkN "fetering" ; -- fetering..nn.1
  fethet_1_N = mkN "fethet" ; -- fethet..nn.1
  fetisch_1_N = mkN "fetisch" "fetischer" ; -- fetisch..nn.1
  fetischism_1_N = mkN "fetischism" "fetischismer" ; -- fetischism..nn.1
  fetischist_1_N = mkN "fetischist" "fetischister" ; -- fetischist..nn.1
  fetischistisk_1_A = mkA "fetischistisk" ; -- fetischistisk..av.1
  fetknopp_1_N = mkN "fetknopp" ; -- fetknopp..nn.1
  fetlagd_1_A = mkA "fetlagd" "fetlagt" ; -- fetlagd..av.1
  fetlagdhet_1_N = mkN "fetlagdhet" ; -- fetlagdhet..nn.1
  fetma_1_N = mkN "fetma" ; -- fetma..nn.1
  fetma_1_V = mkV "fetmar" ; -- fetma..vb.1
  fetmaepidemi_1_N = mkN "fetmaepidemi" "fetmaepidemier" ; -- fetmaepidemi..nn.1
  fetmande_1_N = mkN "fetmande" ; -- fetmande..nn.1
  fetna_1_V = mkV "fetnar" ; -- fetna..vb.1
  fetnande_1_N = mkN "fetnande" ; -- fetnande..nn.1
  fets_1_N = mkN "fets" "fetser" ; -- fets..nn.1
  fetsill_1_N = mkN "fetsill" ; -- fetsill..nn.1
  fetstil_1_N = mkN "fetstil" ; -- fetstil..nn.1
  fett_1_N = mkN "fett" "fettet" "fetter" "fetterna" ; -- fett..nn.1
  fettförbränning_1_N = mkN "fettförbränning" ; -- fettförbränning..nn.1
  fettglänsande_1_A = mkA "fettglänsande" ; -- fettglänsande..av.1
  fetthalt_1_N = mkN "fetthalt" "fetthalter" ; -- fetthalt..nn.1
  fetthaltig_1_A = mkA "fetthaltig" ; -- fetthaltig..av.1
  fetthaltighet_1_N = mkN "fetthaltighet" ; -- fetthaltighet..nn.1
  fetthjärta_1_N = mkN "fetthjärta" "fetthjärtat" "fetthjärtan" "fetthjärtana" ; -- fetthjärta..nn.1
  fetthärdning_1_N = mkN "fetthärdning" ; -- fetthärdning..nn.1
  fettisdag_1_N = mkN "fettisdag" ; -- fettisdag..nn.1
  fettisdagsbulla_1_N = mkN "fettisdagsbulla" ; -- fettisdagsbulla..nn.1
  fettisdagsbulle_1_N = mkN "fettisdagsbulle" utrum  ; -- fettisdagsbulle..nn.1
  fettklump_1_N = mkN "fettklump" ; -- fettklump..nn.1
  fettkörtel_1_N = mkN "fettkörtel" ; -- fettkörtel..nn.1
  fettlever_1_N = mkN "fettlever" ; -- fettlever..nn.1
  fettlösande_1_A = mkA "fettlösande" ; -- fettlösande..av.1
  fettlöslig_1_A = mkA "fettlöslig" ; -- fettlöslig..av.1
  fettlöslighet_1_N = mkN "fettlöslighet" "fettlösligheter" ; -- fettlöslighet..nn.1
  fetto_1_N = mkN "fetto" "fettot" "fetton" "fettona" ; -- fetto..nn.1
  fettprocent_1_N = mkN "fettprocent" "fettprocenten" "fettprocent" "fettprocenten" ; -- fettprocent..nn.1
  fettpärla_1_N = mkN "fettpärla" ; -- fettpärla..nn.1
  fettreserv_1_N = mkN "fettreserv" "fettreserver" ; -- fettreserv..nn.1
  fettrik_1_A = mkA "fettrik" ; -- fettrik..av.1
  fettrikhet_1_N = mkN "fettrikhet" ; -- fettrikhet..nn.1
  fettsnål_1_A = mkA "fettsnål" ; -- fettsnål..av.1
  fettsot_1_N = mkN "fettsot" ; -- fettsot..nn.1
  fettspruta_1_N = mkN "fettspruta" ; -- fettspruta..nn.1
  fettsvansfår_1_N = mkN "fettsvansfår" neutrum  ; -- fettsvansfår..nn.1
  fettsyra_1_N = mkN "fettsyra" ; -- fettsyra..nn.1
  fettvalk_1_N = mkN "fettvalk" ; -- fettvalk..nn.1
  fettväv_1_N = mkN "fettväv" ; -- fettväv..nn.1
  fettvävnad_1_N = mkN "fettvävnad" "fettvävnader" ; -- fettvävnad..nn.1
  fettämne_1_N = mkN "fettämne" ; -- fettämne..nn.1
  fetvadd_1_N = mkN "fetvadd" ; -- fetvadd..nn.1
  fez_1_N = mkN "fez" "fezer" ; -- fez..nn.1
  fi_1_N = mkN "fi" neutrum  ; -- fi..nn.1
  fia_1_N = mkN "fia" ; -- fia..nn.1
  fial_1_N = mkN "fial" "fialer" ; -- fial..nn.1
  fiasko_1_N = mkN "fiasko" "fiaskot" "fiaskon" "fiaskona" ; -- fiasko..nn.1
  fiaskoartad_1_A = mkA "fiaskoartad" ; -- fiaskoartad..av.1
  fiaskokonferens_1_N = mkN "fiaskokonferens" "fiaskokonferenser" ; -- fiaskokonferens..nn.1
  fibbla_1_N = mkN "fibbla" ; -- fibbla..nn.1
  fiber_1_N = mkN "fiber" "fibern" "fibrer" "fibrerna" ; -- fiber..nn.1
  fiberblandning_1_N = mkN "fiberblandning" ; -- fiberblandning..nn.1
  fiberkabel_1_N = mkN "fiberkabel" ; -- fiberkabel..nn.1
  fiberoptik_1_N = mkN "fiberoptik" ; -- fiberoptik..nn.1
  fiberoptisk_1_A = mkA "fiberoptisk" ; -- fiberoptisk..av.1
  fiberplatta_1_N = mkN "fiberplatta" ; -- fiberplatta..nn.1
  fiberrik_1_A = mkA "fiberrik" ; -- fiberrik..av.1
  fiberrikhet_1_N = mkN "fiberrikhet" ; -- fiberrikhet..nn.1
  fiberspik_1_N = mkN "fiberspik" ; -- fiberspik..nn.1
  fibertillsats_1_N = mkN "fibertillsats" "fibertillsatser" ; -- fibertillsats..nn.1
  fiberväxt_1_N = mkN "fiberväxt" "fiberväxter" ; -- fiberväxt..nn.1
  fibrig_1_A = mkA "fibrig" ; -- fibrig..av.1
  fibrighet_1_N = mkN "fibrighet" ; -- fibrighet..nn.1
  fibrill_1_N = mkN "fibrill" "fibriller" ; -- fibrill..nn.1
  fibrillin_1_N = mkN "fibrillin" "fibrilliner" ; -- fibrillin..nn.1
  fibrin_1_N = mkN "fibrin" neutrum  ; -- fibrin..nn.1
  fibrinogen_1_N = mkN "fibrinogen" "fibrinogener" ; -- fibrinogen..nn.1
  fibromyalgi_1_N = mkN "fibromyalgi" "fibromyalgier" ; -- fibromyalgi..nn.1
  fibrös_1_A = mkA "fibrös" ; -- fibrös..av.1
  fibula_1_N = mkN "fibula" ; -- fibula..nn.1
  ficka_1_N = mkN "ficka" ; -- ficka..nn.1
  fickformat_1_N = mkN "fickformat" neutrum  ; -- fickformat..nn.1
  fickhandbok_1_N = mkN "fickhandbok" "fickhandböcker" ; -- fickhandbok..nn.1
  fickkalkylator_1_N = mkN "fickkalkylator" "fickkalkylatorer" ; -- fickkalkylator..nn.1
  fickkniv_1_N = mkN "fickkniv" ; -- fickkniv..nn.1
  ficklampa_1_N = mkN "ficklampa" ; -- ficklampa..nn.1
  ficklock_1_N = mkN "ficklock" neutrum  ; -- ficklock..nn.1
  fickparkera_1_V = mkV "fickparkerar" ; -- fickparkera..vb.1
  fickparkerande_1_N = mkN "fickparkerande" ; -- fickparkerande..nn.1
  fickparkerbar_1_A = mkA "fickparkerbar" ; -- fickparkerbar..av.1
  fickparkerbarhet_1_N = mkN "fickparkerbarhet" ; -- fickparkerbarhet..nn.1
  fickparkering_1_N = mkN "fickparkering" ; -- fickparkering..nn.1
  fickpeng_1_N = mkN "fickpeng" ; -- fickpeng..nn.1
  fickplunta_1_N = mkN "fickplunta" ; -- fickplunta..nn.1
  fickspegel_1_N = mkN "fickspegel" ; -- fickspegel..nn.1
  fickstöld_1_N = mkN "fickstöld" "fickstölder" ; -- fickstöld..nn.1
  ficktjuv_1_N = mkN "ficktjuv" ; -- ficktjuv..nn.1
  fickur_1_N = mkN "fickur" neutrum  ; -- fickur..nn.1
  fiction_novell_1_N = mkN "fiction-novell" "fiction-noveller" ; -- fiction-novell..nn.1
  fiction_1_N = mkN "fiction" ; -- fiction..nn.1
  fideikommiss_1_N = mkN "fideikommiss" neutrum  ; -- fideikommiss..nn.1
  fidjian_1_N = mkN "fidjian" "fidjianer" ; -- fidjian..nn.1
  fidus_1_N = mkN "fidus" ; -- fidus..nn.1
  fiende_1_N = mkN "fiende" "fiender" ; -- fiende..nn.1
  fiendearmé_1_N = mkN "fiendearmé" "fiendearméer" ; -- fiendearmé..nn.1
  fiendeland_1_N = mkN "fiendeland" "fiendelandet" "fiendeländer" "fiendeländerna" ; -- fiendeland..nn.1
  fiendelinje_1_N = mkN "fiendelinje" "fiendelinjer" ; -- fiendelinje..nn.1
  fiendesoldat_1_N = mkN "fiendesoldat" "fiendesoldater" ; -- fiendesoldat..nn.1
  fiendskap_1_N = mkN "fiendskap" "fiendskaper" ; -- fiendskap..nn.1
  fientlig_1_A = mkA "fientlig" ; -- fientlig..av.1
  fientlighet_1_N = mkN "fientlighet" "fientligheter" ; -- fientlighet..nn.1
  fiffel_1_N = mkN "fiffel" neutrum  ; -- fiffel..nn.1
  fiffig_1_A = mkA "fiffig" ; -- fiffig..av.1
  fiffighet_1_N = mkN "fiffighet" "fiffigheter" ; -- fiffighet..nn.1
  fiffla_1_V = mkV "fifflar" ; -- fiffla..vb.1
  fifflande_1_N = mkN "fifflande" ; -- fifflande..nn.1
  fifflare_1_N = mkN "fifflare" utrum  ; -- fifflare..nn.1
  fight_1_N = mkN "fight" "fighter" ; -- fight..nn.1
  fighter_1_N = mkN "fighter" "fightern" "fighters" "fightersen" ; -- fighter..nn.1
  figur_1_N = mkN "figur" "figurer" ; -- figur..nn.1
  figurant_1_N = mkN "figurant" "figuranter" ; -- figurant..nn.1
  figuration_1_N = mkN "figuration" ; -- figuration..nn.1
  figurativ_1_A = mkA "figurativ" ; -- figurativ..av.1
  figurera_1_V = mkV "figurerar" ; -- figurera..vb.1
  figurerande_1_N = mkN "figurerande" ; -- figurerande..nn.1
  figurering_1_N = mkN "figurering" ; -- figurering..nn.1
  figurlig_1_A = mkA "figurlig" ; -- figurlig..av.1
  figurlighet_1_N = mkN "figurlighet" ; -- figurlighet..nn.1
  figursydd_1_A = mkA "figursydd" ; -- figursydd..av.1
  figurteckning_1_N = mkN "figurteckning" ; -- figurteckning..nn.1
  figuråkare_1_N = mkN "figuråkare" utrum  ; -- figuråkare..nn.1
  figuråkning_1_N = mkN "figuråkning" ; -- figuråkning..nn.1
  fijian_1_N = mkN "fijian" "fijianer" ; -- fijian..nn.1
  fijiansk_1_A = mkA "fijiansk" ; -- fijiansk..av.1
  fijianska_1_N = mkN "fijianska" ; -- fijianska..nn.1
  fijianska_2_N = mkN "fijianska" ; -- fijianska..nn.2
  fik_1_N = mkN "fik" neutrum  ; -- fik..nn.1
  fika_1_N = mkN "fika" ; -- fika..nn.1
  fika_1_V = mkV "fikar" ; -- fika..vb.1
  fikadags_1_N = mkN "fikadags" ; -- fikadags..nn.1
  fikahörna_1_N = mkN "fikahörna" ; -- fikahörna..nn.1
  fikande_1_N = mkN "fikande" ; -- fikande..nn.1
  fikapaus_1_N = mkN "fikapaus" "fikapauser" ; -- fikapaus..nn.1
  fikarum_1_N = mkN "fikarum" "fikarummet" "fikarum" "fikarummen" ; -- fikarum..nn.1
  fiken_1_A = mkA "fiken" ; -- fiken..av.1
  fikenhet_1_N = mkN "fikenhet" ; -- fikenhet..nn.1
  fikon_1_N = mkN "fikon" neutrum  ; -- fikon..nn.1
  fikonlöv_1_N = mkN "fikonlöv" neutrum  ; -- fikonlöv..nn.1
  fikonspråk_1_N = mkN "fikonspråk" neutrum  ; -- fikonspråk..nn.1
  fikonträd_1_N = mkN "fikonträd" neutrum  ; -- fikonträd..nn.1
  fiktion_1_N = mkN "fiktion" ; -- fiktion..nn.1
  fiktionalism_1_N = mkN "fiktionalism" "fiktionalismer" ; -- fiktionalism..nn.1
  fiktionsprosa_1_N = mkN "fiktionsprosa" ; -- fiktionsprosa..nn.1
  fiktiv_1_A = mkA "fiktiv" ; -- fiktiv..av.1
  fikus_1_N = mkN "fikus" ; -- fikus..nn.1
  fil_1_N = mkN "fil" "filer" ; -- fil..nn.1
  fil_2_N = mkN "fil" ; -- fil..nn.2
  fil_3_N = mkN "fil" ; -- fil..nn.3
  fila_1_V = mkV "filar" ; -- fila..vb.1
  filande_1_N = mkN "filande" ; -- filande..nn.1
  filantrop_1_N = mkN "filantrop" "filantroper" ; -- filantrop..nn.1
  filantropi_1_N = mkN "filantropi" ; -- filantropi..nn.1
  filantropisk_1_A = mkA "filantropisk" ; -- filantropisk..av.1
  filare_1_N = mkN "filare" utrum  ; -- filare..nn.1
  filateli_1_N = mkN "filateli" ; -- filateli..nn.1
  filatelist_1_N = mkN "filatelist" "filatelister" ; -- filatelist..nn.1
  filatelistisk_1_A = mkA "filatelistisk" ; -- filatelistisk..av.1
  filatelistklubb_1_N = mkN "filatelistklubb" ; -- filatelistklubb..nn.1
  filbunke_1_N = mkN "filbunke" utrum  ; -- filbunke..nn.1
  filbyte_1_N = mkN "filbyte" ; -- filbyte..nn.1
  fildelare_1_N = mkN "fildelare" utrum  ; -- fildelare..nn.1
  fildelning_1_N = mkN "fildelning" ; -- fildelning..nn.1
  file_1_N = mkN "file" "fileer" ; -- file..nn.1
  filea_1_V = mkV "filear" ; -- filea..vb.1
  fileande_1_N = mkN "fileande" ; -- fileande..nn.1
  filera_1_V = mkV "filerar" ; -- filera..vb.1
  filerande_1_N = mkN "filerande" ; -- filerande..nn.1
  filerbar_1_A = mkA "filerbar" ; -- filerbar..av.1
  filerbarhet_1_N = mkN "filerbarhet" ; -- filerbarhet..nn.1
  filering_1_N = mkN "filering" ; -- filering..nn.1
  filering_2_N = mkN "filering" ; -- filering..nn.2
  filhandtag_1_N = mkN "filhandtag" neutrum  ; -- filhandtag..nn.1
  filharmoni_1_N = mkN "filharmoni" ; -- filharmoni..nn.1
  filharmoniker_1_N = mkN "filharmoniker" "filharmonikern" "filharmoniker" "filharmonikerna" ; -- filharmoniker..nn.1
  filharmonisk_1_A = mkA "filharmonisk" ; -- filharmonisk..av.1
  filial_1_N = mkN "filial" "filialer" ; -- filial..nn.1
  filialavdelning_1_N = mkN "filialavdelning" ; -- filialavdelning..nn.1
  filialkontor_1_N = mkN "filialkontor" neutrum  ; -- filialkontor..nn.1
  filibuster_1_N = mkN "filibuster" ; -- filibuster..nn.1
  filibustring_1_N = mkN "filibustring" ; -- filibustring..nn.1
  filigram_1_N = mkN "filigram" ; -- filigram..nn.1
  filigran_1_N = mkN "filigran" neutrum  ; -- filigran..nn.1
  filipin_1_N = mkN "filipin" "filipiner" ; -- filipin..nn.1
  filippik_1_N = mkN "filippik" "filippiker" ; -- filippik..nn.1
  filippinare_1_N = mkN "filippinare" utrum  ; -- filippinare..nn.1
  filippinsk_1_A = mkA "filippinsk" ; -- filippinsk..av.1
  filippinska_1_N = mkN "filippinska" ; -- filippinska..nn.1
  filister_1_N = mkN "filister" ; -- filister..nn.1
  filiströs_1_A = mkA "filiströs" ; -- filiströs..av.1
  filisté_1_N = mkN "filisté" "filistéer" ; -- filisté..nn.1
  filklove_1_N = mkN "filklove" utrum  ; -- filklove..nn.1
  filkörning_1_N = mkN "filkörning" ; -- filkörning..nn.1
  filler_1_N = mkN "filler" ; -- filler..nn.1
  film_1_N = mkN "film" "filmer" ; -- film..nn.1
  filma_1_V = mkV "filmar" ; -- filma..vb.1
  filmaffisch_1_N = mkN "filmaffisch" "filmaffischer" ; -- filmaffisch..nn.1
  filmande_1_N = mkN "filmande" ; -- filmande..nn.1
  filmare_1_N = mkN "filmare" utrum  ; -- filmare..nn.1
  filmaskin_1_N = mkN "filmaskin" "filmaskiner" ; -- filmaskin..nn.1
  filmateljé_1_N = mkN "filmateljé" "filmateljéer" ; -- filmateljé..nn.1
  filmatisera_1_V = mkV "filmatiserar" ; -- filmatisera..vb.1
  filmatiserande_1_N = mkN "filmatiserande" ; -- filmatiserande..nn.1
  filmatiserbar_1_A = mkA "filmatiserbar" ; -- filmatiserbar..av.1
  filmatiserbarhet_1_N = mkN "filmatiserbarhet" ; -- filmatiserbarhet..nn.1
  filmatisering_1_N = mkN "filmatisering" ; -- filmatisering..nn.1
  filmatisk_1_A = mkA "filmatisk" ; -- filmatisk..av.1
  filmavsnitt_1_N = mkN "filmavsnitt" neutrum  ; -- filmavsnitt..nn.1
  filmberättande_1_N = mkN "filmberättande" ; -- filmberättande..nn.1
  filmbild_1_N = mkN "filmbild" "filmbilder" ; -- filmbild..nn.1
  filmbolag_1_N = mkN "filmbolag" neutrum  ; -- filmbolag..nn.1
  filmbransch_1_N = mkN "filmbransch" ; -- filmbransch..nn.1
  filmcensur_1_N = mkN "filmcensur" ; -- filmcensur..nn.1
  filmdebut_1_N = mkN "filmdebut" "filmdebuter" ; -- filmdebut..nn.1
  filmdebutera_1_V = mkV "filmdebuterar" ; -- filmdebutera..vb.1
  filmdebuterande_1_N = mkN "filmdebuterande" ; -- filmdebuterande..nn.1
  filmdebutering_1_N = mkN "filmdebutering" ; -- filmdebutering..nn.1
  filmexpert_1_N = mkN "filmexpert" "filmexperter" ; -- filmexpert..nn.1
  filmfars_1_N = mkN "filmfars" "filmfarser" ; -- filmfars..nn.1
  filmfestival_1_N = mkN "filmfestival" "filmfestivaler" ; -- filmfestival..nn.1
  filmfotograf_1_N = mkN "filmfotograf" "filmfotografer" ; -- filmfotograf..nn.1
  filmframkallning_1_N = mkN "filmframkallning" ; -- filmframkallning..nn.1
  filmgestalt_1_N = mkN "filmgestalt" "filmgestalter" ; -- filmgestalt..nn.1
  filmgranskning_1_N = mkN "filmgranskning" ; -- filmgranskning..nn.1
  filmhistoria_1_N = mkN "filmhistoria" "filmhistorian" "filmhistorier" "filmhistorierna" ; -- filmhistoria..nn.1
  filmhistorisk_1_A = mkA "filmhistorisk" ; -- filmhistorisk..av.1
  filmindustri_1_N = mkN "filmindustri" "filmindustrier" ; -- filmindustri..nn.1
  filminspelning_1_N = mkN "filminspelning" ; -- filminspelning..nn.1
  filmintresserad_1_A = mkA "filmintresserad" ; -- filmintresserad..av.1
  filmisk_1_A = mkA "filmisk" ; -- filmisk..av.1
  filmjölk_1_N = mkN "filmjölk" ; -- filmjölk..nn.1
  filmkamera_1_N = mkN "filmkamera" ; -- filmkamera..nn.1
  filmklipp_1_N = mkN "filmklipp" neutrum  ; -- filmklipp..nn.1
  filmklippning_1_N = mkN "filmklippning" ; -- filmklippning..nn.1
  filmkomedi_1_N = mkN "filmkomedi" "filmkomedier" ; -- filmkomedi..nn.1
  filmmanuskript_1_N = mkN "filmmanuskript" neutrum  ; -- filmmanuskript..nn.1
  filmmatiné_1_N = mkN "filmmatiné" "filmmatinéer" ; -- filmmatiné..nn.1
  filmmusik_1_N = mkN "filmmusik" ; -- filmmusik..nn.1
  filmmässig_1_A = mkA "filmmässig" ; -- filmmässig..av.1
  filmning_1_N = mkN "filmning" ; -- filmning..nn.1
  filmotek_1_N = mkN "filmotek" neutrum  ; -- filmotek..nn.1
  filmpremiär_1_N = mkN "filmpremiär" "filmpremiärer" ; -- filmpremiär..nn.1
  filmpris_1_N = mkN "filmpris" neutrum  ; -- filmpris..nn.1
  filmproducent_1_N = mkN "filmproducent" "filmproducenter" ; -- filmproducent..nn.1
  filmproduktion_1_N = mkN "filmproduktion" ; -- filmproduktion..nn.1
  filmprofessor_1_N = mkN "filmprofessor" "filmprofessorer" ; -- filmprofessor..nn.1
  filmregissör_1_N = mkN "filmregissör" "filmregissörer" ; -- filmregissör..nn.1
  filmroll_1_N = mkN "filmroll" "filmroller" ; -- filmroll..nn.1
  filmrulle_1_N = mkN "filmrulle" utrum  ; -- filmrulle..nn.1
  filmscen_1_N = mkN "filmscen" "filmscener" ; -- filmscen..nn.1
  filmskapare_1_N = mkN "filmskapare" utrum  ; -- filmskapare..nn.1
  filmskådespelare_1_N = mkN "filmskådespelare" utrum  ; -- filmskådespelare..nn.1
  filmskådespelerska_1_N = mkN "filmskådespelerska" ; -- filmskådespelerska..nn.1
  filmsnutt_1_N = mkN "filmsnutt" ; -- filmsnutt..nn.1
  filmstjärna_1_N = mkN "filmstjärna" ; -- filmstjärna..nn.1
  filmstudio_1_N = mkN "filmstudio" "filmstudior" ; -- filmstudio..nn.1
  filmtecknare_1_N = mkN "filmtecknare" utrum  ; -- filmtecknare..nn.1
  filmtidskrift_1_N = mkN "filmtidskrift" "filmtidskrifter" ; -- filmtidskrift..nn.1
  filmtittande_1_A = mkA "filmtittande" ; -- filmtittande..av.1
  filmtittande_1_N = mkN "filmtittande" ; -- filmtittande..nn.1
  filmtrave_1_N = mkN "filmtrave" utrum  ; -- filmtrave..nn.1
  filmversion_1_N = mkN "filmversion" ; -- filmversion..nn.1
  filmvetenskap_1_N = mkN "filmvetenskap" "filmvetenskaper" ; -- filmvetenskap..nn.1
  filmvisning_1_N = mkN "filmvisning" ; -- filmvisning..nn.1
  filning_1_N = mkN "filning" ; -- filning..nn.1
  filolog_1_N = mkN "filolog" "filologer" ; -- filolog..nn.1
  filologi_1_N = mkN "filologi" "filologier" ; -- filologi..nn.1
  filologisk_1_A = mkA "filologisk" ; -- filologisk..av.1
  filosof_1_N = mkN "filosof" "filosofer" ; -- filosof..nn.1
  filosofem_1_N = mkN "filosofem" neutrum  ; -- filosofem..nn.1
  filosofera_1_V = mkV "filosoferar" ; -- filosofera..vb.1
  filosoferande_1_N = mkN "filosoferande" ; -- filosoferande..nn.1
  filosofering_1_N = mkN "filosofering" ; -- filosofering..nn.1
  filosofi_1_N = mkN "filosofi" "filosofier" ; -- filosofi..nn.1
  filosofie_1_A = mkA "filosofie" ; -- filosofie..av.1
  filosofilärare_1_N = mkN "filosofilärare" utrum  ; -- filosofilärare..nn.1
  filosofisk_1_A = mkA "filosofisk" ; -- filosofisk..av.1
  filosofkollega_1_N = mkN "filosofkollega" ; -- filosofkollega..nn.1
  filspån_1_N = mkN "filspån" neutrum  ; -- filspån..nn.1
  filt_1_N = mkN "filt" ; -- filt..nn.1
  filta_1_V = mkV "filtar" ; -- filta..vb.1
  filtande_1_N = mkN "filtande" ; -- filtande..nn.1
  filter_1_N = mkN "filter" neutrum  ; -- filter..nn.1
  filtercigarett_1_N = mkN "filtercigarett" "filtercigaretter" ; -- filtercigarett..nn.1
  filterludd_1_N = mkN "filterludd" ; -- filterludd..nn.1
  filterpåse_1_N = mkN "filterpåse" utrum  ; -- filterpåse..nn.1
  filthatt_1_N = mkN "filthatt" ; -- filthatt..nn.1
  filtrat_1_N = mkN "filtrat" neutrum  ; -- filtrat..nn.1
  filtrera_1_V = mkV "filtrerar" ; -- filtrera..vb.1
  filtrerande_1_N = mkN "filtrerande" ; -- filtrerande..nn.1
  filtrerbar_1_A = mkA "filtrerbar" ; -- filtrerbar..av.1
  filtrerbarhet_1_N = mkN "filtrerbarhet" ; -- filtrerbarhet..nn.1
  filtrering_1_N = mkN "filtrering" ; -- filtrering..nn.1
  filtrerpapper_1_N = mkN "filtrerpapper" neutrum  ; -- filtrerpapper..nn.1
  filtspets_1_N = mkN "filtspets" ; -- filtspets..nn.1
  filttoffel_1_N = mkN "filttoffla" ; -- filttoffel..nn.1
  filttomte_1_N = mkN "filttomte" utrum  ; -- filttomte..nn.1
  filttäckt_1_A = mkA "filttäckt" "filttäckt" ; -- filttäckt..av.1
  filtyta_1_N = mkN "filtyta" ; -- filtyta..nn.1
  filur_1_N = mkN "filur" "filurer" ; -- filur..nn.1
  filé_1_N = mkN "filé" "filéer" ; -- filé..nn.1
  fimbulvinter_1_N = mkN "fimbulvinter" ; -- fimbulvinter..nn.1
  fimmelstång_1_N = mkN "fimmelstång" "fimmelstänger" ; -- fimmelstång..nn.1
  fimmerstång_1_N = mkN "fimmerstång" "fimmerstänger" ; -- fimmerstång..nn.1
  fimp_1_N = mkN "fimp" ; -- fimp..nn.1
  fimpa_1_V = mkV "fimpar" ; -- fimpa..vb.1
  fimpande_1_N = mkN "fimpande" ; -- fimpande..nn.1
  fimpkastare_1_N = mkN "fimpkastare" utrum  ; -- fimpkastare..nn.1
  fimpsug_1_N = mkN "fimpsug" ; -- fimpsug..nn.1
  fin_1_A = mkA "fin" ; -- fin..av.1
  final_1_A = mkA "final" ; -- final..av.1
  final_1_N = mkN "final" "finaler" ; -- final..nn.1
  finaldags_1_N = mkN "finaldags" ; -- finaldags..nn.1
  finalist_1_N = mkN "finalist" "finalister" ; -- finalist..nn.1
  finalklar_1_A = mkA "finalklar" ; -- finalklar..av.1
  finalmiss_1_N = mkN "finalmiss" ; -- finalmiss..nn.1
  finalplats_1_N = mkN "finalplats" "finalplatser" ; -- finalplats..nn.1
  finalsats_1_N = mkN "finalsats" "finalsatser" ; -- finalsats..nn.1
  finalseger_1_N = mkN "finalseger" ; -- finalseger..nn.1
  finans_1_N = mkN "finans" ; -- finans..nn.1
  finanschef_1_N = mkN "finanschef" "finanschefer" ; -- finanschef..nn.1
  finansdebatt_1_N = mkN "finansdebatt" "finansdebatter" ; -- finansdebatt..nn.1
  finansdepartement_1_N = mkN "finansdepartement" neutrum  ; -- finansdepartement..nn.1
  finansdistrikt_1_N = mkN "finansdistrikt" neutrum  ; -- finansdistrikt..nn.1
  finansförvaltning_1_N = mkN "finansförvaltning" ; -- finansförvaltning..nn.1
  finanshaj_1_N = mkN "finanshaj" ; -- finanshaj..nn.1
  finansiell_1_A = mkA "finansiell" ; -- finansiell..av.1
  finansiera_1_V = mkV "finansierar" ; -- finansiera..vb.1
  finansierande_1_N = mkN "finansierande" ; -- finansierande..nn.1
  finansierbar_1_A = mkA "finansierbar" ; -- finansierbar..av.1
  finansierbarhet_1_N = mkN "finansierbarhet" ; -- finansierbarhet..nn.1
  finansiering_1_N = mkN "finansiering" ; -- finansiering..nn.1
  finansinspektion_1_N = mkN "finansinspektion" ; -- finansinspektion..nn.1
  finansiär_1_N = mkN "finansiär" "finansiärer" ; -- finansiär..nn.1
  finanskrasch_1_N = mkN "finanskrasch" "finanskrascher" ; -- finanskrasch..nn.1
  finanskris_1_N = mkN "finanskris" "finanskriser" ; -- finanskris..nn.1
  finansman_1_N = mkN "finansman" "finansmannen" "finansmän" "finansmännen" ; -- finansman..nn.1
  finansmarknad_1_N = mkN "finansmarknad" "finansmarknader" ; -- finansmarknad..nn.1
  finansminister_1_N = mkN "finansminister" ; -- finansminister..nn.1
  finansministerium_1_N = mkN "finansministerium" "finansministeriet" "finansministerier" "finansministerierna" ; -- finansministerium..nn.1
  finansnetto_1_N = mkN "finansnetto" "finansnettot" "finansnetton" "finansnettona" ; -- finansnetto..nn.1
  finansplan_1_N = mkN "finansplan" "finansplaner" ; -- finansplan..nn.1
  finanspolitik_1_N = mkN "finanspolitik" ; -- finanspolitik..nn.1
  finanspolitisk_1_A = mkA "finanspolitisk" ; -- finanspolitisk..av.1
  finansrätt_1_N = mkN "finansrätt" ; -- finansrätt..nn.1
  finansrättslig_1_A = mkA "finansrättslig" ; -- finansrättslig..av.1
  finansskojare_1_N = mkN "finansskojare" utrum  ; -- finansskojare..nn.1
  finansutskott_1_N = mkN "finansutskott" neutrum  ; -- finansutskott..nn.1
  finansvalp_1_N = mkN "finansvalp" ; -- finansvalp..nn.1
  finbruk_1_N = mkN "finbruk" neutrum  ; -- finbruk..nn.1
  finbränna_1_V = mkV "finbränna" "finbrände" "finbränt" ; -- finbränna..vb.1
  finbrännande_1_N = mkN "finbrännande" ; -- finbrännande..nn.1
  finemang_1_Adv = mkAdv "finemang" ; -- finemang..ab.1
  finess_1_N = mkN "finess" "finesser" ; -- finess..nn.1
  finfin_1_A = mkA "finfin" ; -- finfin..av.1
  finfördela_1_V = mkV "finfördelar" ; -- finfördela..vb.1
  finfördelande_1_N = mkN "finfördelande" ; -- finfördelande..nn.1
  finger_1_N = mkN "finger" ; -- finger..nn.1
  fingera_1_V = mkV "fingerar" ; -- fingera..vb.1
  fingerad_1_A = mkA "fingerad" ; -- fingerad..av.1
  fingerande_1_N = mkN "fingerande" ; -- fingerande..nn.1
  fingeravtryck_1_N = mkN "fingeravtryck" neutrum  ; -- fingeravtryck..nn.1
  fingeravtrycksaspekt_1_N = mkN "fingeravtrycksaspekt" "fingeravtrycksaspekter" ; -- fingeravtrycksaspekt..nn.1
  fingerbar_1_A = mkA "fingerbar" ; -- fingerbar..av.1
  fingerbarhet_1_N = mkN "fingerbarhet" ; -- fingerbarhet..nn.1
  fingerblomma_1_N = mkN "fingerblomma" ; -- fingerblomma..nn.1
  fingerbläck_1_N = mkN "fingerbläck" neutrum  ; -- fingerbläck..nn.1
  fingerborg_1_N = mkN "fingerborg" ; -- fingerborg..nn.1
  fingerborgsblomma_1_N = mkN "fingerborgsblomma" ; -- fingerborgsblomma..nn.1
  fingerbred_1_A = mkA "fingerbred" "fingerbrett" ; -- fingerbred..av.1
  fingerbredd_1_N = mkN "fingerbredd" "fingerbredder" ; -- fingerbredd..nn.1
  fingerböjarmuskel_1_N = mkN "fingerböjarmuskel" "fingerböjarmuskeln" "fingerböjarmuskler" "fingerböjarmusklerna" ; -- fingerböjarmuskel..nn.1
  fingerfärdig_1_A = mkA "fingerfärdig" ; -- fingerfärdig..av.1
  fingerfärdighet_1_N = mkN "fingerfärdighet" ; -- fingerfärdighet..nn.1
  fingerfärg_1_N = mkN "fingerfärg" "fingerfärger" ; -- fingerfärg..nn.1
  fingerhandske_1_N = mkN "fingerhandske" utrum  ; -- fingerhandske..nn.1
  fingerhud_1_N = mkN "fingerhud" ; -- fingerhud..nn.1
  fingering_1_N = mkN "fingering" ; -- fingering..nn.1
  fingerknäppning_1_N = mkN "fingerknäppning" ; -- fingerknäppning..nn.1
  fingerkrok_1_N = mkN "fingerkrok" ; -- fingerkrok..nn.1
  fingerled_1_N = mkN "fingerled" "fingerleder" ; -- fingerled..nn.1
  fingernagel_1_N = mkN "fingernagel" ; -- fingernagel..nn.1
  fingernerv_1_N = mkN "fingernerv" "fingernerver" ; -- fingernerv..nn.1
  fingerprov_1_N = mkN "fingerprov" neutrum  ; -- fingerprov..nn.1
  fingerring_1_N = mkN "fingerring" ; -- fingerring..nn.1
  fingerskiva_1_N = mkN "fingerskiva" ; -- fingerskiva..nn.1
  fingerspets_1_N = mkN "fingerspets" ; -- fingerspets..nn.1
  fingersträckarmuskel_1_N = mkN "fingersträckarmuskel" "fingersträckarmuskeln" "fingersträckarmuskler" "fingersträckarmusklerna" ; -- fingersträckarmuskel..nn.1
  fingersvamp_1_N = mkN "fingersvamp" ; -- fingersvamp..nn.1
  fingersättning_1_N = mkN "fingersättning" ; -- fingersättning..nn.1
  fingertopp_1_N = mkN "fingertopp" ; -- fingertopp..nn.1
  fingertoppskänsla_1_N = mkN "fingertoppskänsla" ; -- fingertoppskänsla..nn.1
  fingertoppsnyans_1_N = mkN "fingertoppsnyans" "fingertoppsnyanser" ; -- fingertoppsnyans..nn.1
  fingertuta_1_N = mkN "fingertuta" ; -- fingertuta..nn.1
  fingervante_1_N = mkN "fingervante" utrum  ; -- fingervante..nn.1
  fingervisning_1_N = mkN "fingervisning" ; -- fingervisning..nn.1
  fingerört_1_N = mkN "fingerört" "fingerörter" ; -- fingerört..nn.1
  fingerövning_1_N = mkN "fingerövning" ; -- fingerövning..nn.1
  fingra_1_V = mkV "fingrar" ; -- fingra..vb.1
  fingrad_1_A = mkA "fingrad" ; -- fingrad..av.1
  fingraderad_1_A = mkA "fingraderad" ; -- fingraderad..av.1
  fingrande_1_N = mkN "fingrande" ; -- fingrande..nn.1
  fingranska_1_V = mkV "fingranskar" ; -- fingranska..vb.1
  fingranskande_1_N = mkN "fingranskande" ; -- fingranskande..nn.1
  finhacka_1_V = mkV "finhackar" ; -- finhacka..vb.1
  finhackad_1_A = mkA "finhackad" ; -- finhackad..av.1
  finhet_1_N = mkN "finhet" ; -- finhet..nn.1
  finhet_2_N = mkN "finhet" "finheter" ; -- finhet..nn.2
  finhyllt_1_A = mkA "finhyllt" "finhyllt" ; -- finhyllt..av.1
  finhyllthet_1_N = mkN "finhyllthet" ; -- finhyllthet..nn.1
  finingång_1_N = mkN "finingång" ; -- finingång..nn.1
  fininställa_1_V = mkV "fininställer" ; -- fininställa..vb.1
  fininställande_1_N = mkN "fininställande" ; -- fininställande..nn.1
  finish_1_N = mkN "finish" ; -- finish..nn.1
  finit_1_A = mkA "finit" "finit" ; -- finit..av.1
  finjustera_1_V = mkV "finjusterar" ; -- finjustera..vb.1
  finjusterande_1_N = mkN "finjusterande" ; -- finjusterande..nn.1
  finjusterbar_1_A = mkA "finjusterbar" ; -- finjusterbar..av.1
  finjusterbarhet_1_N = mkN "finjusterbarhet" ; -- finjusterbarhet..nn.1
  finjustering_1_N = mkN "finjustering" ; -- finjustering..nn.1
  fink_1_N = mkN "fink" ; -- fink..nn.1
  finka_1_N = mkN "finka" ; -- finka..nn.1
  finka_1_V = mkV "finkar" ; -- finka..vb.1
  finkalibrig_1_A = mkA "finkalibrig" ; -- finkalibrig..av.1
  finkalibrighet_1_N = mkN "finkalibrighet" ; -- finkalibrighet..nn.1
  finkamma_1_V = mkV "finkammar" ; -- finkamma..vb.1
  finkammande_1_N = mkN "finkammande" ; -- finkammande..nn.1
  finkamning_1_N = mkN "finkamning" ; -- finkamning..nn.1
  finkande_1_N = mkN "finkande" ; -- finkande..nn.1
  finkart_1_N = mkN "finkart" "finkarter" ; -- finkart..nn.1
  finkel_1_N = mkN "finkel" ; -- finkel..nn.1
  finkelolja_1_N = mkN "finkelolja" ; -- finkelolja..nn.1
  finkfågel_1_N = mkN "finkfågel" ; -- finkfågel..nn.1
  finklädd_1_A = mkA "finklädd" ; -- finklädd..av.1
  finkläddhet_1_N = mkN "finkläddhet" ; -- finkläddhet..nn.1
  finkornig_1_A = mkA "finkornig" ; -- finkornig..av.1
  finkornighet_1_N = mkN "finkornighet" ; -- finkornighet..nn.1
  finkultur_1_N = mkN "finkultur" ; -- finkultur..nn.1
  finkulturell_1_A = mkA "finkulturell" ; -- finkulturell..av.1
  finkunge_1_N = mkN "finkunge" utrum  ; -- finkunge..nn.1
  finkänsla_1_N = mkN "finkänsla" ; -- finkänsla..nn.1
  finkänslig_1_A = mkA "finkänslig" ; -- finkänslig..av.1
  finkänslighet_1_N = mkN "finkänslighet" "finkänsligheter" ; -- finkänslighet..nn.1
  finlandisera_1_V = mkV "finlandiserar" ; -- finlandisera..vb.1
  finlandiserande_1_N = mkN "finlandiserande" ; -- finlandiserande..nn.1
  finlandiserbar_1_A = mkA "finlandiserbar" ; -- finlandiserbar..av.1
  finlandiserbarhet_1_N = mkN "finlandiserbarhet" ; -- finlandiserbarhet..nn.1
  finlandisering_1_N = mkN "finlandisering" ; -- finlandisering..nn.1
  finlandism_1_N = mkN "finlandism" "finlandismer" ; -- finlandism..nn.1
  finlandssvensk_1_A = mkA "finlandssvensk" ; -- finlandssvensk..av.1
  finlandssvensk_1_N = mkN "finlandssvensk" ; -- finlandssvensk..nn.1
  finlandssvenska_1_N = mkN "finlandssvenska" ; -- finlandssvenska..nn.1
  finlandssvenska_2_N = mkN "finlandssvenska" ; -- finlandssvenska..nn.2
  finlek_1_N = mkN "finlek" ; -- finlek..nn.1
  finlemmad_1_A = mkA "finlemmad" ; -- finlemmad..av.1
  finlir_1_N = mkN "finlir" neutrum  ; -- finlir..nn.1
  finländare_1_N = mkN "finländare" utrum  ; -- finländare..nn.1
  finländsk_1_A = mkA "finländsk" ; -- finländsk..av.1
  finländska_1_N = mkN "finländska" ; -- finländska..nn.1
  finmala_1_V = mkV "finmaler" ; -- finmala..vb.1
  finmalande_1_N = mkN "finmalande" ; -- finmalande..nn.1
  finmalning_1_N = mkN "finmalning" ; -- finmalning..nn.1
  finmaskig_1_A = mkA "finmaskig" ; -- finmaskig..av.1
  finmaskighet_1_N = mkN "finmaskighet" ; -- finmaskighet..nn.1
  finmat_1_N = mkN "finmat" ; -- finmat..nn.1
  finmekaniker_1_N = mkN "finmekaniker" "finmekanikern" "finmekaniker" "finmekanikerna" ; -- finmekaniker..nn.1
  finmekanisk_1_A = mkA "finmekanisk" ; -- finmekanisk..av.1
  finmotorik_1_N = mkN "finmotorik" ; -- finmotorik..nn.1
  finna_1_V = mkV "finna" "fann" "funnit" ; -- finna..vb.1
  finnande_1_N = mkN "finnande" ; -- finnande..nn.1
  finne_1_N = mkN "finne" utrum  ; -- finne..nn.1
  finnig_1_A = mkA "finnig" ; -- finnig..av.1
  finnighet_1_N = mkN "finnighet" ; -- finnighet..nn.1
  finnjolle_1_N = mkN "finnjolle" utrum  ; -- finnjolle..nn.1
  finnkamp_1_N = mkN "finnkamp" "finnkamper" ; -- finnkamp..nn.1
  finnmark_1_N = mkN "finnmark" "finnmarker" ; -- finnmark..nn.1
  finpapper_1_N = mkN "finpapper" neutrum  ; -- finpapper..nn.1
  finpappersbruk_1_N = mkN "finpappersbruk" neutrum  ; -- finpappersbruk..nn.1
  finputs_1_N = mkN "finputs" ; -- finputs..nn.1
  finputsa_1_V = mkV "finputsar" ; -- finputsa..vb.1
  finputsande_1_N = mkN "finputsande" ; -- finputsande..nn.1
  finriven_1_A = mkA "finriven" ; -- finriven..av.1
  finrum_1_N = mkN "finrum" "finrummet" "finrum" "finrummen" ; -- finrum..nn.1
  finsikta_1_V = mkV "finsiktar" ; -- finsikta..vb.1
  finsiktande_1_N = mkN "finsiktande" ; -- finsiktande..nn.1
  finsiktning_1_N = mkN "finsiktning" ; -- finsiktning..nn.1
  finsilver_1_N = mkN "finsilver" neutrum  ; -- finsilver..nn.1
  finsk_ugrisk_1_A = mkA "finsk-ugrisk" ; -- finsk-ugrisk..av.1
  finsk_1_A = mkA "finsk" ; -- finsk..av.1
  finska_1_N = mkN "finska" ; -- finska..nn.1
  finska_2_N = mkN "finska" ; -- finska..nn.2
  finskhet_1_N = mkN "finskhet" "finskheter" ; -- finskhet..nn.1
  finsko_1_N = mkN "finsko" "finskor" ; -- finsko..nn.1
  finskspråkig_1_A = mkA "finskspråkig" ; -- finskspråkig..av.1
  finsktalande_1_A = mkA "finsktalande" ; -- finsktalande..av.1
  finskugrisk_1_A = mkA "finskugrisk" ; -- finskugrisk..av.1
  finskuren_1_A = mkA "finskuren" ; -- finskuren..av.1
  finskägd_1_A = mkA "finskägd" "finskägt" ; -- finskägd..av.1
  finskåp_1_N = mkN "finskåp" neutrum  ; -- finskåp..nn.1
  finslipa_1_V = mkV "finslipar" ; -- finslipa..vb.1
  finslipande_1_N = mkN "finslipande" ; -- finslipande..nn.1
  finslipning_1_N = mkN "finslipning" ; -- finslipning..nn.1
  finsmakare_1_N = mkN "finsmakare" utrum  ; -- finsmakare..nn.1
  finsmide_1_N = mkN "finsmide" ; -- finsmide..nn.1
  finsnickare_1_N = mkN "finsnickare" utrum  ; -- finsnickare..nn.1
  finsnickeri_1_N = mkN "finsnickeri" "finsnickeriet" "finsnickerier" "finsnickerierna" ; -- finsnickeri..nn.1
  finspackel_1_N = mkN "finspackel" neutrum  ; -- finspackel..nn.1
  finsprit_1_N = mkN "finsprit" ; -- finsprit..nn.1
  finspunnen_1_A = mkA "finspunnen" "finspunnet" "finspunna" "finspunna" "finspunnare" "finspunnast" "finspunnaste" ; -- finspunnen..av.1
  finspäntad_1_A = mkA "finspäntad" ; -- finspäntad..av.1
  finstil_1_N = mkN "finstil" ; -- finstil..nn.1
  finstilt_1_A = mkA "finstilt" "finstilt" ; -- finstilt..av.1
  finstrimlad_1_A = mkA "finstrimlad" ; -- finstrimlad..av.1
  finstruktur_1_N = mkN "finstruktur" "finstrukturer" ; -- finstruktur..nn.1
  finstämd_1_A = mkA "finstämd" "finstämt" ; -- finstämd..av.1
  finstämdhet_1_N = mkN "finstämdhet" ; -- finstämdhet..nn.1
  fint_1_N = mkN "fint" "finter" ; -- fint..nn.1
  finta_1_V = mkV "fintar" ; -- finta..vb.1
  fintande_1_N = mkN "fintande" ; -- fintande..nn.1
  fintlig_1_A = mkA "fintlig" ; -- fintlig..av.1
  fintlighet_1_N = mkN "fintlighet" "fintligheter" ; -- fintlighet..nn.1
  fintrådig_1_A = mkA "fintrådig" ; -- fintrådig..av.1
  fintvätt_1_N = mkN "fintvätt" ; -- fintvätt..nn.1
  finurlig_1_A = mkA "finurlig" ; -- finurlig..av.1
  finurlighet_1_N = mkN "finurlighet" "finurligheter" ; -- finurlighet..nn.1
  fiol_1_N = mkN "fiol" "fioler" ; -- fiol..nn.1
  fiolblock_1_N = mkN "fiolblock" neutrum  ; -- fiolblock..nn.1
  fiolbyggare_1_N = mkN "fiolbyggare" utrum  ; -- fiolbyggare..nn.1
  fiollåda_1_N = mkN "fiollåda" ; -- fiollåda..nn.1
  fiolspelare_1_N = mkN "fiolspelare" utrum  ; -- fiolspelare..nn.1
  fiolsträng_1_N = mkN "fiolsträng" ; -- fiolsträng..nn.1
  fiolstråke_1_N = mkN "fiolstråke" utrum  ; -- fiolstråke..nn.1
  fiolvirtuos_1_N = mkN "fiolvirtuos" "fiolvirtuoser" ; -- fiolvirtuos..nn.1
  fioritur_1_N = mkN "fioritur" "fioriturer" ; -- fioritur..nn.1
  fippla_1_V = mkV "fipplar" ; -- fippla..vb.1
  fipplande_1_N = mkN "fipplande" ; -- fipplande..nn.1
  fipplig_1_A = mkA "fipplig" ; -- fipplig..av.1
  fipplighet_1_N = mkN "fipplighet" ; -- fipplighet..nn.1
  fira_1_V = mkV "firar" ; -- fira..vb.1
  firande_1_N = mkN "firande" ; -- firande..nn.1
  firma_1_N = mkN "firma" ; -- firma..nn.1
  firmafest_1_N = mkN "firmafest" "firmafester" ; -- firmafest..nn.1
  firmament_1_N = mkN "firmament" neutrum  ; -- firmament..nn.1
  firmamärke_1_N = mkN "firmamärke" ; -- firmamärke..nn.1
  firmanamn_1_N = mkN "firmanamn" neutrum  ; -- firmanamn..nn.1
  firmatecknare_1_N = mkN "firmatecknare" utrum  ; -- firmatecknare..nn.1
  firmateckning_1_N = mkN "firmateckning" ; -- firmateckning..nn.1
  firn_1_N = mkN "firn" ; -- firn..nn.1
  firngräns_1_N = mkN "firngräns" "firngränser" ; -- firngräns..nn.1
  firning_1_N = mkN "firning" ; -- firning..nn.1
  firre_1_N = mkN "firre" utrum  ; -- firre..nn.1
  fis_1_N = mkN "fis" ; -- fis..nn.1
  fisande_1_N = mkN "fisande" ; -- fisande..nn.1
  fischy_1_N = mkN "fischy" "fischyer" ; -- fischy..nn.1
  fisförnäm_1_A = mkA "fisförnäm" ; -- fisförnäm..av.1
  fisförnämhet_1_N = mkN "fisförnämhet" ; -- fisförnämhet..nn.1
  fisig_1_A = mkA "fisig" ; -- fisig..av.1
  fisk_1_N = mkN "fisk" ; -- fisk..nn.1
  fisk_2_N = mkN "fisk" ; -- fisk..nn.2
  fiska_1_V = mkV "fiskar" ; -- fiska..vb.1
  fiskafänge_1_N = mkN "fiskafänge" ; -- fiskafänge..nn.1
  fiskal_1_A = mkA "fiskal" ; -- fiskal..av.1
  fiskal_1_N = mkN "fiskal" "fiskaler" ; -- fiskal..nn.1
  fiskalisk_1_A = mkA "fiskalisk" ; -- fiskalisk..av.1
  fiskande_1_N = mkN "fiskande" ; -- fiskande..nn.1
  fiskare_1_N = mkN "fiskare" utrum  ; -- fiskare..nn.1
  fiskart_1_N = mkN "fiskart" "fiskarter" ; -- fiskart..nn.1
  fiskben_1_N = mkN "fiskben" neutrum  ; -- fiskben..nn.1
  fiskbensmönster_1_N = mkN "fiskbensmönster" neutrum  ; -- fiskbensmönster..nn.1
  fiskbestick_1_N = mkN "fiskbestick" neutrum  ; -- fiskbestick..nn.1
  fiskblåsa_1_N = mkN "fiskblåsa" ; -- fiskblåsa..nn.1
  fiskbulle_1_N = mkN "fiskbulle" utrum  ; -- fiskbulle..nn.1
  fiskdamm_1_N = mkN "fiskdamm" ; -- fiskdamm..nn.1
  fiskdöd_1_N = mkN "fiskdöd" ; -- fiskdöd..nn.1
  fiske_1_N = mkN "fiske" ; -- fiske..nn.1
  fiskeansvarig_1_A = mkA "fiskeansvarig" ; -- fiskeansvarig..av.1
  fiskebank_1_N = mkN "fiskebank" ; -- fiskebank..nn.1
  fiskebåt_1_N = mkN "fiskebåt" ; -- fiskebåt..nn.1
  fiskebåtsbesättning_1_N = mkN "fiskebåtsbesättning" ; -- fiskebåtsbesättning..nn.1
  fiskedon_1_N = mkN "fiskedon" neutrum  ; -- fiskedon..nn.1
  fiskedrag_1_N = mkN "fiskedrag" neutrum  ; -- fiskedrag..nn.1
  fiskefartyg_1_N = mkN "fiskefartyg" neutrum  ; -- fiskefartyg..nn.1
  fiskegräns_1_N = mkN "fiskegräns" "fiskegränser" ; -- fiskegräns..nn.1
  fiskekniv_1_N = mkN "fiskekniv" ; -- fiskekniv..nn.1
  fiskekort_1_N = mkN "fiskekort" neutrum  ; -- fiskekort..nn.1
  fiskekrok_1_N = mkN "fiskekrok" ; -- fiskekrok..nn.1
  fiskelag_1_N = mkN "fiskelag" ; -- fiskelag..nn.1
  fiskelina_1_N = mkN "fiskelina" ; -- fiskelina..nn.1
  fiskelycka_1_N = mkN "fiskelycka" ; -- fiskelycka..nn.1
  fiskeläge_1_N = mkN "fiskeläge" ; -- fiskeläge..nn.1
  fiskenation_1_N = mkN "fiskenation" ; -- fiskenation..nn.1
  fiskenät_1_N = mkN "fiskenät" neutrum  ; -- fiskenät..nn.1
  fiskeolycka_1_N = mkN "fiskeolycka" ; -- fiskeolycka..nn.1
  fiskeredskap_1_N = mkN "fiskeredskap" neutrum  ; -- fiskeredskap..nn.1
  fiskeri_1_N = mkN "fiskeri" "fiskeriet" "fiskerier" "fiskerierna" ; -- fiskeri..nn.1
  fiskeristyrelse_1_N = mkN "fiskeristyrelse" "fiskeristyrelser" ; -- fiskeristyrelse..nn.1
  fiskestuga_1_N = mkN "fiskestuga" ; -- fiskestuga..nn.1
  fiskevatten_1_N = mkN "fiskevatten" "fiskevattnet" "fiskevatten" "fiskevattnen" ; -- fiskevatten..nn.1
  fiskevård_1_N = mkN "fiskevård" ; -- fiskevård..nn.1
  fiskezon_1_N = mkN "fiskezon" "fiskezoner" ; -- fiskezon..nn.1
  fiskfilé_1_N = mkN "fiskfilé" "fiskfiléer" ; -- fiskfilé..nn.1
  fiskfärs_1_N = mkN "fiskfärs" "fiskfärser" ; -- fiskfärs..nn.1
  fiskfångst_1_N = mkN "fiskfångst" "fiskfångster" ; -- fiskfångst..nn.1
  fiskgjuse_1_N = mkN "fiskgjuse" utrum  ; -- fiskgjuse..nn.1
  fiskguano_1_N = mkN "fiskguano" ; -- fiskguano..nn.1
  fiskhalster_1_N = mkN "fiskhalster" neutrum  ; -- fiskhalster..nn.1
  fiskhamn_1_N = mkN "fiskhamn" ; -- fiskhamn..nn.1
  fiskhuvud_1_N = mkN "fiskhuvud" "fiskhuvudet" "fiskhuvud" "fiskhuvudena" ; -- fiskhuvud..nn.1
  fiskkniv_1_N = mkN "fiskkniv" ; -- fiskkniv..nn.1
  fiskkrok_1_N = mkN "fiskkrok" ; -- fiskkrok..nn.1
  fiskleverolja_1_N = mkN "fiskleverolja" ; -- fiskleverolja..nn.1
  fisklevertran_1_N = mkN "fisklevertran" ; -- fisklevertran..nn.1
  fisklik_1_A = mkA "fisklik" ; -- fisklik..av.1
  fisklikhet_1_N = mkN "fisklikhet" ; -- fisklikhet..nn.1
  fisklina_1_N = mkN "fisklina" ; -- fisklina..nn.1
  fisklir_1_N = mkN "fisklir" neutrum  ; -- fisklir..nn.1
  fiskmjöl_1_N = mkN "fiskmjöl" neutrum  ; -- fiskmjöl..nn.1
  fiskmun_1_N = mkN "fiskmun" "fiskmunnen" "fiskmunnar" "fiskmunnarna" ; -- fiskmun..nn.1
  fiskmåltid_1_N = mkN "fiskmåltid" "fiskmåltider" ; -- fiskmåltid..nn.1
  fiskmås_1_N = mkN "fiskmås" ; -- fiskmås..nn.1
  fisknot_1_N = mkN "fisknot" ; -- fisknot..nn.1
  fisknät_1_N = mkN "fisknät" neutrum  ; -- fisknät..nn.1
  fiskodling_1_N = mkN "fiskodling" ; -- fiskodling..nn.1
  fiskolja_1_N = mkN "fiskolja" ; -- fiskolja..nn.1
  fiskpedikyr_1_N = mkN "fiskpedikyr" ; -- fiskpedikyr..nn.1
  fiskpinne_1_N = mkN "fiskpinne" utrum  ; -- fiskpinne..nn.1
  fiskpudding_1_N = mkN "fiskpudding" ; -- fiskpudding..nn.1
  fiskredskap_1_N = mkN "fiskredskap" neutrum  ; -- fiskredskap..nn.1
  fiskrens_1_N = mkN "fiskrens" neutrum  ; -- fiskrens..nn.1
  fiskrik_1_A = mkA "fiskrik" ; -- fiskrik..av.1
  fiskrätt_1_N = mkN "fiskrätt" "fiskrätter" ; -- fiskrätt..nn.1
  fisksoppa_1_N = mkN "fisksoppa" ; -- fisksoppa..nn.1
  fiskspad_1_N = mkN "fiskspad" neutrum  ; -- fiskspad..nn.1
  fiskstim_1_N = mkN "fiskstim" "fiskstimmet" "fiskstim" "fiskstimmen" ; -- fiskstim..nn.1
  fiskstjärt_1_N = mkN "fiskstjärt" ; -- fiskstjärt..nn.1
  fisksump_1_N = mkN "fisksump" ; -- fisksump..nn.1
  fisksås_1_N = mkN "fisksås" "fisksåser" ; -- fisksås..nn.1
  fisktom_1_A = mkA "fisktom" "fisktomt" "fisktomma" "fisktomma" "fisktommare" "fisktommast" "fisktommaste" ; -- fisktom..av.1
  fisktomhet_1_N = mkN "fisktomhet" ; -- fisktomhet..nn.1
  fisktrappa_1_N = mkN "fisktrappa" ; -- fisktrappa..nn.1
  fisktärna_1_N = mkN "fisktärna" ; -- fisktärna..nn.1
  fiskvandring_1_N = mkN "fiskvandring" ; -- fiskvandring..nn.1
  fiskvin_1_N = mkN "fiskvin" "fiskvinet" "fiskviner" "fiskvinerna" ; -- fiskvin..nn.1
  fiskyngel_1_N = mkN "fiskyngel" neutrum  ; -- fiskyngel..nn.1
  fiskätande_1_N = mkN "fiskätande" ; -- fiskätande..nn.1
  fiskådra_1_N = mkN "fiskådra" ; -- fiskådra..nn.1
  fisködla_1_N = mkN "fisködla" ; -- fisködla..nn.1
  fisköga_1_N = mkN "fisköga" "fiskögat" "fiskögon" "fiskögonen" ; -- fisköga..nn.1
  fissil_1_A = mkA "fissil" ; -- fissil..av.1
  fission_1_N = mkN "fission" ; -- fission..nn.1
  fissur_1_N = mkN "fissur" "fissurer" ; -- fissur..nn.1
  fistel_1_N = mkN "fistel" ; -- fistel..nn.1
  fistulös_1_A = mkA "fistulös" ; -- fistulös..av.1
  fitness_1_N = mkN "fitness" ; -- fitness..nn.1
  fitta_1_N = mkN "fitta" ; -- fitta..nn.1
  fittrakt_1_N = mkN "fittrakt" "fittrakter" ; -- fittrakt..nn.1
  fittsafari_1_N = mkN "fittsafari" "fittsafarin" "fittsafaris" "fittsafarisarna" ; -- fittsafari..nn.1
  fittstim_1_N = mkN "fittstim" "fittstimmet" "fittstim" "fittstimmen" ; -- fittstim..nn.1
  fix_1_A = mkA "fix" ; -- fix..av.1
  fix_1_N = mkN "fix" ; -- fix..nn.1
  fix_2_N = mkN "fix" neutrum  ; -- fix..nn.2
  fixa_1_V = mkV "fixar" ; -- fixa..vb.1
  fixande_1_N = mkN "fixande" ; -- fixande..nn.1
  fixare_1_N = mkN "fixare" utrum  ; -- fixare..nn.1
  fixativ_1_N = mkN "fixativ" neutrum  ; -- fixativ..nn.1
  fixera_1_V = mkV "fixerar" ; -- fixera..vb.1
  fixerad_1_A = mkA "fixerad" ; -- fixerad..av.1
  fixerande_1_N = mkN "fixerande" ; -- fixerande..nn.1
  fixerbad_1_N = mkN "fixerbad" neutrum  ; -- fixerbad..nn.1
  fixerbar_1_A = mkA "fixerbar" ; -- fixerbar..av.1
  fixerbarhet_1_N = mkN "fixerbarhet" ; -- fixerbarhet..nn.1
  fixering_1_N = mkN "fixering" ; -- fixering..nn.1
  fixeringsbild_1_N = mkN "fixeringsbild" "fixeringsbilder" ; -- fixeringsbild..nn.1
  fixhet_1_N = mkN "fixhet" ; -- fixhet..nn.1
  fixkam_1_N = mkN "fixkam" "fixkammen" "fixkammar" "fixkammarna" ; -- fixkam..nn.1
  fixpunkt_1_N = mkN "fixpunkt" "fixpunkter" ; -- fixpunkt..nn.1
  fixstjärna_1_N = mkN "fixstjärna" ; -- fixstjärna..nn.1
  fixtur_1_N = mkN "fixtur" "fixturer" ; -- fixtur..nn.1
  fjant_1_N = mkN "fjant" ; -- fjant..nn.1
  fjant_2_N = mkN "fjant" neutrum  ; -- fjant..nn.2
  fjanta_1_V = mkV "fjantar" ; -- fjanta..vb.1
  fjantande_1_N = mkN "fjantande" ; -- fjantande..nn.1
  fjanteri_1_N = mkN "fjanteri" "fjanteriet" "fjanterier" "fjanterierna" ; -- fjanteri..nn.1
  fjantig_1_A = mkA "fjantig" ; -- fjantig..av.1
  fjantighet_1_N = mkN "fjantighet" ; -- fjantighet..nn.1
  fjantstämpel_1_N = mkN "fjantstämpel" ; -- fjantstämpel..nn.1
  fjolla_1_N = mkN "fjolla" ; -- fjolla..nn.1
  fjolleri_1_N = mkN "fjolleri" "fjolleriet" "fjollerier" "fjollerierna" ; -- fjolleri..nn.1
  fjollig_1_A = mkA "fjollig" ; -- fjollig..av.1
  fjollighet_1_N = mkN "fjollighet" "fjolligheter" ; -- fjollighet..nn.1
  fjolår_1_N = mkN "fjolår" neutrum  ; -- fjolår..nn.1
  fjolårsgräs_1_N = mkN "fjolårsgräs" neutrum  ; -- fjolårsgräs..nn.1
  fjomperi_1_N = mkN "fjomperi" "fjomperiet" "fjomperier" "fjomperierna" ; -- fjomperi..nn.1
  fjompig_1_A = mkA "fjompig" ; -- fjompig..av.1
  fjompighet_1_N = mkN "fjompighet" ; -- fjompighet..nn.1
  fjong_1_N = mkN "fjong" ; -- fjong..nn.1
  fjord_1_N = mkN "fjord" ; -- fjord..nn.1
  fjordhäst_1_N = mkN "fjordhäst" ; -- fjordhäst..nn.1
  fjording_1_N = mkN "fjording" ; -- fjording..nn.1
  fjortis_1_N = mkN "fjortis" ; -- fjortis..nn.1
  fjortonde_1_A = mkA "fjortonde" ; -- fjortonde..av.1
  fjortonhundratal_1_N = mkN "fjortonhundratal" neutrum  ; -- fjortonhundratal..nn.1
  fjortonårig_1_A = mkA "fjortonårig" ; -- fjortonårig..av.1
  fjortonåring_1_N = mkN "fjortonåring" ; -- fjortonåring..nn.1
  fjun_1_N = mkN "fjun" neutrum  ; -- fjun..nn.1
  fjunig_1_A = mkA "fjunig" ; -- fjunig..av.1
  fjuttholme_1_N = mkN "fjuttholme" utrum  ; -- fjuttholme..nn.1
  fjuttig_1_A = mkA "fjuttig" ; -- fjuttig..av.1
  fjuttighet_1_N = mkN "fjuttighet" ; -- fjuttighet..nn.1
  fjäder_1_N = mkN "fjäder" ; -- fjäder..nn.1
  fjäderbeklädnad_1_N = mkN "fjäderbeklädnad" "fjäderbeklädnader" ; -- fjäderbeklädnad..nn.1
  fjäderboll_1_N = mkN "fjäderboll" ; -- fjäderboll..nn.1
  fjäderbuske_1_N = mkN "fjäderbuske" utrum  ; -- fjäderbuske..nn.1
  fjäderdosa_1_N = mkN "fjäderdosa" ; -- fjäderdosa..nn.1
  fjäderdräkt_1_N = mkN "fjäderdräkt" "fjäderdräkter" ; -- fjäderdräkt..nn.1
  fjäderformad_1_A = mkA "fjäderformad" ; -- fjäderformad..av.1
  fjäderfä_1_N = mkN "fjäderfä" "fjäderfät" "fjäderfän" "fjäderfäna" ; -- fjäderfä..nn.1
  fjädergräs_1_N = mkN "fjädergräs" neutrum  ; -- fjädergräs..nn.1
  fjäderklädd_1_A = mkA "fjäderklädd" ; -- fjäderklädd..av.1
  fjäderkudde_1_N = mkN "fjäderkudde" utrum  ; -- fjäderkudde..nn.1
  fjäderliknande_1_A = mkA "fjäderliknande" ; -- fjäderliknande..av.1
  fjäderluftgevär_1_N = mkN "fjäderluftgevär" neutrum  ; -- fjäderluftgevär..nn.1
  fjäderlätt_1_A = mkA "fjäderlätt" ; -- fjäderlätt..av.1
  fjäderlätthet_1_N = mkN "fjäderlätthet" ; -- fjäderlätthet..nn.1
  fjädermoln_1_N = mkN "fjädermoln" neutrum  ; -- fjädermoln..nn.1
  fjädermygga_1_N = mkN "fjädermygga" ; -- fjädermygga..nn.1
  fjäderpensel_1_N = mkN "fjäderpensel" ; -- fjäderpensel..nn.1
  fjäderskrud_1_N = mkN "fjäderskrud" ; -- fjäderskrud..nn.1
  fjäderstål_1_N = mkN "fjäderstål" neutrum  ; -- fjäderstål..nn.1
  fjädertyp_1_N = mkN "fjädertyp" "fjädertyper" ; -- fjädertyp..nn.1
  fjädervikt_1_N = mkN "fjädervikt" ; -- fjädervikt..nn.1
  fjädervinge_1_N = mkN "fjädervinge" utrum  ; -- fjädervinge..nn.1
  fjädervåg_1_N = mkN "fjädervåg" ; -- fjädervåg..nn.1
  fjädra_1_V = mkV "fjädrar" ; -- fjädra..vb.1
  fjädrande_1_N = mkN "fjädrande" ; -- fjädrande..nn.1
  fjädring_1_N = mkN "fjädring" ; -- fjädring..nn.1
  fjädringskapacitet_1_N = mkN "fjädringskapacitet" ; -- fjädringskapacitet..nn.1
  fjädringsmekanism_1_N = mkN "fjädringsmekanism" "fjädringsmekanismer" ; -- fjädringsmekanism..nn.1
  fjäll_1_N = mkN "fjäll" neutrum  ; -- fjäll..nn.1
  fjälla_1_N = mkN "fjälla" ; -- fjälla..nn.1
  fjälla_1_V = mkV "fjällar" ; -- fjälla..vb.1
  fjälla_2_V = mkV "fjällar" ; -- fjälla..vb.2
  fjällande_1_N = mkN "fjällande" ; -- fjällande..nn.1
  fjällandskap_1_N = mkN "fjällandskap" neutrum  ; -- fjällandskap..nn.1
  fjällbilist_1_N = mkN "fjällbilist" "fjällbilister" ; -- fjällbilist..nn.1
  fjällbjörk_1_N = mkN "fjällbjörk" ; -- fjällbjörk..nn.1
  fjällbrud_1_N = mkN "fjällbrud" ; -- fjällbrud..nn.1
  fjällbygd_1_N = mkN "fjällbygd" "fjällbygder" ; -- fjällbygd..nn.1
  fjällbäck_1_N = mkN "fjällbäck" ; -- fjällbäck..nn.1
  fjälldal_1_N = mkN "fjälldal" ; -- fjälldal..nn.1
  fjällig_1_A = mkA "fjällig" ; -- fjällig..av.1
  fjällighet_1_N = mkN "fjällighet" ; -- fjällighet..nn.1
  fjällik_1_A = mkA "fjällik" ; -- fjällik..av.1
  fjällikhet_1_N = mkN "fjällikhet" ; -- fjällikhet..nn.1
  fjällkedja_1_N = mkN "fjällkedja" ; -- fjällkedja..nn.1
  fjällnatur_1_N = mkN "fjällnatur" ; -- fjällnatur..nn.1
  fjällning_1_N = mkN "fjällning" ; -- fjällning..nn.1
  fjällnära_1_A = mkA "fjällnära" ; -- fjällnära..av.1
  fjällpanelshus_1_N = mkN "fjällpanelshus" neutrum  ; -- fjällpanelshus..nn.1
  fjällpansar_1_N = mkN "fjällpansar" neutrum  ; -- fjällpansar..nn.1
  fjällparti_1_N = mkN "fjällparti" "fjällpartiet" "fjällpartier" "fjällpartierna" ; -- fjällparti..nn.1
  fjällpipare_1_N = mkN "fjällpipare" utrum  ; -- fjällpipare..nn.1
  fjällplatå_1_N = mkN "fjällplatå" "fjällplatåer" ; -- fjällplatå..nn.1
  fjällregion_1_N = mkN "fjällregion" ; -- fjällregion..nn.1
  fjällripa_1_N = mkN "fjällripa" ; -- fjällripa..nn.1
  fjällrygg_1_N = mkN "fjällrygg" ; -- fjällrygg..nn.1
  fjällräv_1_N = mkN "fjällräv" ; -- fjällräv..nn.1
  fjällsemester_1_N = mkN "fjällsemester" ; -- fjällsemester..nn.1
  fjällsippa_1_N = mkN "fjällsippa" ; -- fjällsippa..nn.1
  fjällsjö_1_N = mkN "fjällsjö" ; -- fjällsjö..nn.1
  fjällskivling_1_N = mkN "fjällskivling" ; -- fjällskivling..nn.1
  fjällsluttning_1_N = mkN "fjällsluttning" ; -- fjällsluttning..nn.1
  fjällspets_1_N = mkN "fjällspets" ; -- fjällspets..nn.1
  fjällstation_1_N = mkN "fjällstation" ; -- fjällstation..nn.1
  fjällstuga_1_N = mkN "fjällstuga" ; -- fjällstuga..nn.1
  fjällsyra_1_N = mkN "fjällsyra" ; -- fjällsyra..nn.1
  fjälltopp_1_N = mkN "fjälltopp" ; -- fjälltopp..nn.1
  fjälltrakt_1_N = mkN "fjälltrakt" "fjälltrakter" ; -- fjälltrakt..nn.1
  fjällturist_1_N = mkN "fjällturist" "fjällturister" ; -- fjällturist..nn.1
  fjälluft_1_N = mkN "fjälluft" ; -- fjälluft..nn.1
  fjälluggla_1_N = mkN "fjälluggla" ; -- fjälluggla..nn.1
  fjällvandra_1_V = mkV "fjällvandrar" ; -- fjällvandra..vb.1
  fjällvandrande_1_N = mkN "fjällvandrande" ; -- fjällvandrande..nn.1
  fjällvandrare_1_N = mkN "fjällvandrare" utrum  ; -- fjällvandrare..nn.1
  fjällvandring_1_N = mkN "fjällvandring" ; -- fjällvandring..nn.1
  fjällvråk_1_N = mkN "fjällvråk" ; -- fjällvråk..nn.1
  fjällvärld_1_N = mkN "fjällvärld" ; -- fjällvärld..nn.1
  fjällämmel_1_N = mkN "fjällämmel" "fjällämmeln" "fjällämmlar" "fjällämmlarna" ; -- fjällämmel..nn.1
  fjälster_1_N = mkN "fjälster" neutrum  ; -- fjälster..nn.1
  fjär_1_A = mkA "fjär" ; -- fjär..av.1
  fjärd_1_N = mkN "fjärd" ; -- fjärd..nn.1
  fjärde_1_A = mkA "fjärde" ; -- fjärde..av.1
  fjärdedel_1_N = mkN "fjärdedel" "fjärdedelen" "fjärdedelar" "fjärdedelarna" ; -- fjärdedel..nn.1
  fjärdegradsekvation_1_N = mkN "fjärdegradsekvation" ; -- fjärdegradsekvation..nn.1
  fjärdeplats_1_N = mkN "fjärdeplats" "fjärdeplatser" ; -- fjärdeplats..nn.1
  fjärding_1_N = mkN "fjärding" ; -- fjärding..nn.1
  fjärdingsman_1_N = mkN "fjärdingsman" "fjärdingsmannen" "fjärdingsmän" "fjärdingsmännen" ; -- fjärdingsman..nn.1
  fjärdingsväg_1_N = mkN "fjärdingsväg" "fjärdingsvägen" "fjärdingsväg" "fjärdingsvägen" ; -- fjärdingsväg..nn.1
  fjärhet_1_N = mkN "fjärhet" ; -- fjärhet..nn.1
  fjäril_1_N = mkN "fjäril" ; -- fjäril..nn.1
  fjärilsart_1_N = mkN "fjärilsart" "fjärilsarter" ; -- fjärilsart..nn.1
  fjärilsblomma_1_N = mkN "fjärilsblomma" ; -- fjärilsblomma..nn.1
  fjärilseffekt_1_N = mkN "fjärilseffekt" ; -- fjärilseffekt..nn.1
  fjärilslarv_1_N = mkN "fjärilslarv" "fjärilslarver" ; -- fjärilslarv..nn.1
  fjärilslätt_1_A = mkA "fjärilslätt" ; -- fjärilslätt..av.1
  fjärilsvinge_1_N = mkN "fjärilsvinge" utrum  ; -- fjärilsvinge..nn.1
  fjärma_1_V = mkV "fjärmar" ; -- fjärma..vb.1
  fjärmande_1_N = mkN "fjärmande" ; -- fjärmande..nn.1
  fjärr_1_N = mkN "fjärr" ; -- fjärr..nn.1
  fjärran_1_Adv = mkAdv "fjärran" ; -- fjärran..ab.1
  fjärran_1_A = mkA "fjärran" ; -- fjärran..av.1
  fjärranblickande_1_A = mkA "fjärranblickande" ; -- fjärranblickande..av.1
  fjärrblockera_1_V = mkV "fjärrblockerar" ; -- fjärrblockera..vb.1
  fjärrblockerande_1_N = mkN "fjärrblockerande" ; -- fjärrblockerande..nn.1
  fjärrblockerbar_1_A = mkA "fjärrblockerbar" ; -- fjärrblockerbar..av.1
  fjärrblockerbarhet_1_N = mkN "fjärrblockerbarhet" ; -- fjärrblockerbarhet..nn.1
  fjärrblockering_1_N = mkN "fjärrblockering" ; -- fjärrblockering..nn.1
  fjärrhandel_1_N = mkN "fjärrhandel" ; -- fjärrhandel..nn.1
  fjärris_1_N = mkN "fjärris" ; -- fjärris..nn.1
  fjärrkontroll_1_N = mkN "fjärrkontroll" "fjärrkontroller" ; -- fjärrkontroll..nn.1
  fjärrpunkt_1_N = mkN "fjärrpunkt" "fjärrpunkter" ; -- fjärrpunkt..nn.1
  fjärrseende_1_A = mkA "fjärrseende" ; -- fjärrseende..av.1
  fjärrskrivare_1_N = mkN "fjärrskrivare" utrum  ; -- fjärrskrivare..nn.1
  fjärrskrivmaskin_1_N = mkN "fjärrskrivmaskin" "fjärrskrivmaskiner" ; -- fjärrskrivmaskin..nn.1
  fjärrskådande_1_A = mkA "fjärrskådande" ; -- fjärrskådande..av.1
  fjärrskådare_1_N = mkN "fjärrskådare" utrum  ; -- fjärrskådare..nn.1
  fjärrströmbrytare_1_N = mkN "fjärrströmbrytare" utrum  ; -- fjärrströmbrytare..nn.1
  fjärrstyrd_1_A = mkA "fjärrstyrd" "fjärrstyrt" ; -- fjärrstyrd..av.1
  fjärrtrafik_1_N = mkN "fjärrtrafik" ; -- fjärrtrafik..nn.1
  fjärrtåg_1_N = mkN "fjärrtåg" neutrum  ; -- fjärrtåg..nn.1
  fjärrvärme_1_N = mkN "fjärrvärme" utrum  ; -- fjärrvärme..nn.1
  fjärrvärmegranskning_1_N = mkN "fjärrvärmegranskning" ; -- fjärrvärmegranskning..nn.1
  fjärrvärmepris_1_N = mkN "fjärrvärmepris" neutrum  ; -- fjärrvärmepris..nn.1
  fjärsing_1_N = mkN "fjärsing" ; -- fjärsing..nn.1
  fjärt_1_N = mkN "fjärt" ; -- fjärt..nn.1
  fjärta_1_V = mkV "fjärtar" ; -- fjärta..vb.1
  fjärtande_1_N = mkN "fjärtande" ; -- fjärtande..nn.1
  fjäsk_1_N = mkN "fjäsk" neutrum  ; -- fjäsk..nn.1
  fjäska_1_V = mkV "fjäskar" ; -- fjäska..vb.1
  fjäskande_1_N = mkN "fjäskande" ; -- fjäskande..nn.1
  fjäsker_1_N = mkN "fjäsker" ; -- fjäsker..nn.1
  fjäskig_1_A = mkA "fjäskig" ; -- fjäskig..av.1
  fjäskighet_1_N = mkN "fjäskighet" ; -- fjäskighet..nn.1
  fjät_1_N = mkN "fjät" neutrum  ; -- fjät..nn.1
  fjättra_1_V = mkV "fjättrar" ; -- fjättra..vb.1
  fjättrande_1_N = mkN "fjättrande" ; -- fjättrande..nn.1
  fjöl_1_N = mkN "fjöl" ; -- fjöl..nn.1
  fjöla_1_V = mkV "fjölar" ; -- fjöla..vb.1
  flabb_1_N = mkN "flabb" ; -- flabb..nn.1
  flabb_2_N = mkN "flabb" neutrum  ; -- flabb..nn.2
  flabba_1_V = mkV "flabbar" ; -- flabba..vb.1
  flabbande_1_N = mkN "flabbande" ; -- flabbande..nn.1
  flabbig_1_A = mkA "flabbig" ; -- flabbig..av.1
  flabbighet_1_N = mkN "flabbighet" ; -- flabbighet..nn.1
  flack_1_A = mkA "flack" ; -- flack..av.1
  flacka_1_V = mkV "flackar" ; -- flacka..vb.1
  flackande_1_N = mkN "flackande" ; -- flackande..nn.1
  flackbanepjäs_1_N = mkN "flackbanepjäs" "flackbanepjäser" ; -- flackbanepjäs..nn.1
  flackeld_1_N = mkN "flackeld" ; -- flackeld..nn.1
  flackhet_1_N = mkN "flackhet" ; -- flackhet..nn.1
  flackland_1_N = mkN "flackland" neutrum  ; -- flackland..nn.1
  fladder_1_N = mkN "fladder" neutrum  ; -- fladder..nn.1
  fladdermus_1_N = mkN "fladdermus" "fladdermusen" "fladdermöss" "fladdermössen" ; -- fladdermus..nn.1
  fladdermusfåtölj_1_N = mkN "fladdermusfåtölj" "fladdermusfåtöljer" ; -- fladdermusfåtölj..nn.1
  fladdermusliknande_1_A = mkA "fladdermusliknande" ; -- fladdermusliknande..av.1
  fladdra_1_V = mkV "fladdrar" ; -- fladdra..vb.1
  fladdrande_1_N = mkN "fladdrande" ; -- fladdrande..nn.1
  fladdrig_1_A = mkA "fladdrig" ; -- fladdrig..av.1
  fladdrighet_1_N = mkN "fladdrighet" ; -- fladdrighet..nn.1
  flaga_1_N = mkN "flaga" ; -- flaga..nn.1
  flaga_1_V = mkV "flagar" ; -- flaga..vb.1
  flagande_1_N = mkN "flagande" ; -- flagande..nn.1
  flagell_1_N = mkN "flagell" "flageller" ; -- flagell..nn.1
  flagellant_1_N = mkN "flagellant" "flagellanter" ; -- flagellant..nn.1
  flagellantism_1_N = mkN "flagellantism" ; -- flagellantism..nn.1
  flagellat_1_N = mkN "flagellat" "flagellater" ; -- flagellat..nn.1
  flageolett_1_N = mkN "flageolett" "flageoletter" ; -- flageolett..nn.1
  flagg_1_N = mkN "flagg" ; -- flagg..nn.1
  flagga_1_N = mkN "flagga" ; -- flagga..nn.1
  flagga_1_V = mkV "flaggar" ; -- flagga..vb.1
  flaggande_1_N = mkN "flaggande" ; -- flaggande..nn.1
  flaggbränning_1_N = mkN "flaggbränning" ; -- flaggbränning..nn.1
  flaggdag_1_N = mkN "flaggdag" ; -- flaggdag..nn.1
  flaggduk_1_N = mkN "flaggduk" ; -- flaggduk..nn.1
  flaggkapten_1_N = mkN "flaggkapten" "flaggkaptener" ; -- flaggkapten..nn.1
  flagglina_1_N = mkN "flagglina" ; -- flagglina..nn.1
  flaggman_1_N = mkN "flaggman" "flaggmannen" "flaggmän" "flaggmännen" ; -- flaggman..nn.1
  flaggning_1_N = mkN "flaggning" ; -- flaggning..nn.1
  flaggprydd_1_A = mkA "flaggprydd" ; -- flaggprydd..av.1
  flaggsignal_1_N = mkN "flaggsignal" "flaggsignaler" ; -- flaggsignal..nn.1
  flaggskepp_1_N = mkN "flaggskepp" neutrum  ; -- flaggskepp..nn.1
  flaggskändning_1_N = mkN "flaggskändning" ; -- flaggskändning..nn.1
  flaggspel_1_N = mkN "flaggspel" "flaggspelet" "flaggspel" "flaggspelen" ; -- flaggspel..nn.1
  flaggstång_1_N = mkN "flaggstång" "flaggstänger" ; -- flaggstång..nn.1
  flaggvakt_1_N = mkN "flaggvakt" "flaggvakter" ; -- flaggvakt..nn.1
  flaggviftande_1_A = mkA "flaggviftande" ; -- flaggviftande..av.1
  flaggviftande_1_N = mkN "flaggviftande" ; -- flaggviftande..nn.1
  flaggviftning_1_N = mkN "flaggviftning" ; -- flaggviftning..nn.1
  flagig_1_A = mkA "flagig" ; -- flagig..av.1
  flagna_1_V = mkV "flagnar" ; -- flagna..vb.1
  flagnande_1_N = mkN "flagnande" ; -- flagnande..nn.1
  flagrant_1_A = mkA "flagrant" "flagrant" ; -- flagrant..av.1
  flak_1_N = mkN "flak" neutrum  ; -- flak..nn.1
  flakmoppe_1_N = mkN "flakmoppe" utrum  ; -- flakmoppe..nn.1
  flakong_1_N = mkN "flakong" "flakonger" ; -- flakong..nn.1
  flakvagn_1_N = mkN "flakvagn" ; -- flakvagn..nn.1
  flambera_1_V = mkV "flamberar" ; -- flambera..vb.1
  flamberande_1_N = mkN "flamberande" ; -- flamberande..nn.1
  flamberbar_1_A = mkA "flamberbar" ; -- flamberbar..av.1
  flamberbarhet_1_N = mkN "flamberbarhet" ; -- flamberbarhet..nn.1
  flambering_1_N = mkN "flambering" ; -- flambering..nn.1
  flamenco_1_N = mkN "flamenco" "flamencon" "flamencoer" "flamencoerna" ; -- flamenco..nn.1
  flamencogitarrist_1_N = mkN "flamencogitarrist" "flamencogitarrister" ; -- flamencogitarrist..nn.1
  flamingo_1_N = mkN "flamingo" "flamingor" ; -- flamingo..nn.1
  flamländare_1_N = mkN "flamländare" utrum  ; -- flamländare..nn.1
  flamländsk_1_A = mkA "flamländsk" ; -- flamländsk..av.1
  flamländska_1_N = mkN "flamländska" ; -- flamländska..nn.1
  flamländska_2_N = mkN "flamländska" ; -- flamländska..nn.2
  flamma_1_N = mkN "flamma" ; -- flamma..nn.1
  flamma_1_V = mkV "flammar" ; -- flamma..vb.1
  flammande_1_N = mkN "flammande" ; -- flammande..nn.1
  flammig_1_A = mkA "flammig" ; -- flammig..av.1
  flammighet_1_N = mkN "flammighet" ; -- flammighet..nn.1
  flampunkt_1_N = mkN "flampunkt" "flampunkter" ; -- flampunkt..nn.1
  flams_1_N = mkN "flams" neutrum  ; -- flams..nn.1
  flamsa_1_N = mkN "flamsa" ; -- flamsa..nn.1
  flamsa_1_V = mkV "flamsar" ; -- flamsa..vb.1
  flamsande_1_N = mkN "flamsande" ; -- flamsande..nn.1
  flamsig_1_A = mkA "flamsig" ; -- flamsig..av.1
  flamsighet_1_N = mkN "flamsighet" ; -- flamsighet..nn.1
  flamsk_1_A = mkA "flamsk" ; -- flamsk..av.1
  flamskhet_1_N = mkN "flamskhet" ; -- flamskhet..nn.1
  flamskvävnad_1_N = mkN "flamskvävnad" "flamskvävnader" ; -- flamskvävnad..nn.1
  flamskyddsmedel_1_N = mkN "flamskyddsmedel" neutrum  ; -- flamskyddsmedel..nn.1
  flamugn_1_N = mkN "flamugn" ; -- flamugn..nn.1
  flandrisk_1_A = mkA "flandrisk" ; -- flandrisk..av.1
  flanell_1_N = mkN "flanell" "flaneller" ; -- flanell..nn.1
  flanellborste_1_N = mkN "flanellborste" utrum  ; -- flanellborste..nn.1
  flanellkostym_1_N = mkN "flanellkostym" "flanellkostymer" ; -- flanellkostym..nn.1
  flanellograf_1_N = mkN "flanellograf" "flanellografer" ; -- flanellograf..nn.1
  flanellpyjamas_1_N = mkN "flanellpyjamas" ; -- flanellpyjamas..nn.1
  flanera_1_V = mkV "flanerar" ; -- flanera..vb.1
  flanerande_1_N = mkN "flanerande" ; -- flanerande..nn.1
  flanering_1_N = mkN "flanering" ; -- flanering..nn.1
  flank_1_N = mkN "flank" "flanker" ; -- flank..nn.1
  flankanfall_1_N = mkN "flankanfall" neutrum  ; -- flankanfall..nn.1
  flankera_1_V = mkV "flankerar" ; -- flankera..vb.1
  flankerande_1_N = mkN "flankerande" ; -- flankerande..nn.1
  flankerbar_1_A = mkA "flankerbar" ; -- flankerbar..av.1
  flankerbarhet_1_N = mkN "flankerbarhet" ; -- flankerbarhet..nn.1
  flankering_1_N = mkN "flankering" ; -- flankering..nn.1
  flanör_1_N = mkN "flanör" "flanörer" ; -- flanör..nn.1
  flark_1_N = mkN "flark" ; -- flark..nn.1
  flarn_1_N = mkN "flarn" neutrum  ; -- flarn..nn.1
  flashig_1_A = mkA "flashig" ; -- flashig..av.1
  flaska_1_N = mkN "flaska" ; -- flaska..nn.1
  flaskbarn_1_N = mkN "flaskbarn" neutrum  ; -- flaskbarn..nn.1
  flaskborste_1_N = mkN "flaskborste" utrum  ; -- flaskborste..nn.1
  flaskbrist_1_N = mkN "flaskbrist" ; -- flaskbrist..nn.1
  flaskhals_1_N = mkN "flaskhals" ; -- flaskhals..nn.1
  flaskhål_1_N = mkN "flaskhål" neutrum  ; -- flaskhål..nn.1
  flaskkastning_1_N = mkN "flaskkastning" ; -- flaskkastning..nn.1
  flaskkurbits_1_N = mkN "flaskkurbits" ; -- flaskkurbits..nn.1
  flasklock_1_N = mkN "flasklock" neutrum  ; -- flasklock..nn.1
  flasknosdelfin_1_N = mkN "flasknosdelfin" "flasknosdelfiner" ; -- flasknosdelfin..nn.1
  flaskpost_1_N = mkN "flaskpost" ; -- flaskpost..nn.1
  flasköppnare_1_N = mkN "flasköppnare" utrum  ; -- flasköppnare..nn.1
  flasköppning_1_N = mkN "flasköppning" ; -- flasköppning..nn.1
  flat_1_A = mkA "flat" ; -- flat..av.1
  flata_1_N = mkN "flata" ; -- flata..nn.1
  flatbottnad_1_A = mkA "flatbottnad" ; -- flatbottnad..av.1
  flatbröd_1_N = mkN "flatbröd" neutrum  ; -- flatbröd..nn.1
  flateka_1_N = mkN "flateka" ; -- flateka..nn.1
  flatfisk_1_N = mkN "flatfisk" ; -- flatfisk..nn.1
  flatgarv_1_N = mkN "flatgarv" neutrum  ; -- flatgarv..nn.1
  flathet_1_N = mkN "flathet" ; -- flathet..nn.1
  flatlus_1_N = mkN "flatlus" "flatlusen" "flatlöss" "flatlössen" ; -- flatlus..nn.1
  flatsida_1_N = mkN "flatsida" ; -- flatsida..nn.1
  flatskratt_1_N = mkN "flatskratt" neutrum  ; -- flatskratt..nn.1
  flatskratta_1_V = mkV "flatskrattar" ; -- flatskratta..vb.1
  flatskrattande_1_N = mkN "flatskrattande" ; -- flatskrattande..nn.1
  flattera_1_V = mkV "flatterar" ; -- flattera..vb.1
  flatterande_1_N = mkN "flatterande" ; -- flatterande..nn.1
  flatterbar_1_A = mkA "flatterbar" ; -- flatterbar..av.1
  flatterbarhet_1_N = mkN "flatterbarhet" ; -- flatterbarhet..nn.1
  flattering_1_N = mkN "flattering" ; -- flattering..nn.1
  flatulens_1_N = mkN "flatulens" "flatulenser" ; -- flatulens..nn.1
  flau_1_A = mkA "flau" ; -- flau..av.1
  flax_1_N = mkN "flax" ; -- flax..nn.1
  flax_2_N = mkN "flax" neutrum  ; -- flax..nn.2
  flaxa_1_V = mkV "flaxar" ; -- flaxa..vb.1
  flaxande_1_N = mkN "flaxande" ; -- flaxande..nn.1
  flaxig_1_A = mkA "flaxig" ; -- flaxig..av.1
  flaxighet_1_N = mkN "flaxighet" ; -- flaxighet..nn.1
  flaxning_1_N = mkN "flaxning" ; -- flaxning..nn.1
  fleece_foder_1_N = mkN "fleece-foder" neutrum  ; -- fleece-foder..nn.1
  fleece_1_N = mkN "fleece" ; -- fleece..nn.1
  flegma_1_N = mkN "flegma" ; -- flegma..nn.1
  flegmatiker_1_N = mkN "flegmatiker" "flegmatikern" "flegmatiker" "flegmatikerna" ; -- flegmatiker..nn.1
  flegmatisk_1_A = mkA "flegmatisk" ; -- flegmatisk..av.1
  flektera_1_V = mkV "flekterar" ; -- flektera..vb.1
  flekterande_1_N = mkN "flekterande" ; -- flekterande..nn.1
  flekterbar_1_A = mkA "flekterbar" ; -- flekterbar..av.1
  flekterbarhet_1_N = mkN "flekterbarhet" ; -- flekterbarhet..nn.1
  flektering_1_N = mkN "flektering" ; -- flektering..nn.1
  flektion_1_N = mkN "flektion" ; -- flektion..nn.1
  flensost_1_N = mkN "flensost" ; -- flensost..nn.1
  flerbarnsfamilj_1_N = mkN "flerbarnsfamilj" "flerbarnsfamiljer" ; -- flerbarnsfamilj..nn.1
  flerbarnsmamma_1_N = mkN "flerbarnsmamma" ; -- flerbarnsmamma..nn.1
  flerbarnsmor_1_N = mkN "flerbarnsmor" "flerbarnsmodern" "flerbarnsmödrar" "flerbarnsmödrarna" ; -- flerbarnsmor..nn.1
  flerbostadshus_1_N = mkN "flerbostadshus" neutrum  ; -- flerbostadshus..nn.1
  flercellig_1_A = mkA "flercellig" ; -- flercellig..av.1
  flercellighet_1_N = mkN "flercellighet" ; -- flercellighet..nn.1
  flerdubbel_1_A = mkA "flerdubbel" ; -- flerdubbel..av.1
  flerdubbla_1_V = mkV "flerdubblar" ; -- flerdubbla..vb.1
  flerdubblande_1_N = mkN "flerdubblande" ; -- flerdubblande..nn.1
  flerfaldig_1_A = mkA "flerfaldig" ; -- flerfaldig..av.1
  flerfaldiga_1_V = mkV "flerfaldigar" ; -- flerfaldiga..vb.1
  flerfaldigande_1_N = mkN "flerfaldigande" ; -- flerfaldigande..nn.1
  flerfamiljshus_1_N = mkN "flerfamiljshus" neutrum  ; -- flerfamiljshus..nn.1
  flerfärgad_1_A = mkA "flerfärgad" ; -- flerfärgad..av.1
  flerfärgstryck_1_N = mkN "flerfärgstryck" neutrum  ; -- flerfärgstryck..nn.1
  flergångs_1_A = mkA "flergångs" ; -- flergångs..av.1
  flergångsförbrytare_1_N = mkN "flergångsförbrytare" utrum  ; -- flergångsförbrytare..nn.1
  flerhandikapp_1_N = mkN "flerhandikapp" neutrum  ; -- flerhandikapp..nn.1
  flerhandikappad_1_A = mkA "flerhandikappad" ; -- flerhandikappad..av.1
  flerhet_1_N = mkN "flerhet" "flerheter" ; -- flerhet..nn.1
  flermansvalkrets_1_N = mkN "flermansvalkrets" ; -- flermansvalkrets..nn.1
  fleromättad_1_A = mkA "fleromättad" ; -- fleromättad..av.1
  flerording_1_N = mkN "flerording" ; -- flerording..nn.1
  flerordsenhet_1_N = mkN "flerordsenhet" "flerordsenheter" ; -- flerordsenhet..nn.1
  flerpartisystem_1_N = mkN "flerpartisystem" neutrum  ; -- flerpartisystem..nn.1
  flersidig_1_A = mkA "flersidig" ; -- flersidig..av.1
  flersiffrig_1_A = mkA "flersiffrig" ; -- flersiffrig..av.1
  flerspråkig_1_A = mkA "flerspråkig" ; -- flerspråkig..av.1
  flerspråkighet_1_N = mkN "flerspråkighet" ; -- flerspråkighet..nn.1
  flerstammig_1_A = mkA "flerstammig" ; -- flerstammig..av.1
  flerstavig_1_A = mkA "flerstavig" ; -- flerstavig..av.1
  flerstavighet_1_N = mkN "flerstavighet" ; -- flerstavighet..nn.1
  flerstämmig_1_A = mkA "flerstämmig" ; -- flerstämmig..av.1
  flerstämmighet_1_N = mkN "flerstämmighet" ; -- flerstämmighet..nn.1
  flertal_1_N = mkN "flertal" neutrum  ; -- flertal..nn.1
  flertydig_1_A = mkA "flertydig" ; -- flertydig..av.1
  flertydighet_1_N = mkN "flertydighet" ; -- flertydighet..nn.1
  flervalsfråga_1_N = mkN "flervalsfråga" ; -- flervalsfråga..nn.1
  flervalstest_1_N = mkN "flervalstest" neutrum  ; -- flervalstest..nn.1
  flervalsuppgift_1_N = mkN "flervalsuppgift" "flervalsuppgifter" ; -- flervalsuppgift..nn.1
  flervåningshus_1_N = mkN "flervåningshus" neutrum  ; -- flervåningshus..nn.1
  flerårig_1_A = mkA "flerårig" ; -- flerårig..av.1
  fles_1_N = mkN "fles" ; -- fles..nn.1
  flexa_1_V = mkV "flexar" ; -- flexa..vb.1
  flexande_1_N = mkN "flexande" ; -- flexande..nn.1
  flexibel_1_A = mkA "flexibel" ; -- flexibel..av.1
  flexibilitet_1_N = mkN "flexibilitet" ; -- flexibilitet..nn.1
  flexion_1_N = mkN "flexion" ; -- flexion..nn.1
  flexionsform_1_N = mkN "flexionsform" "flexionsformer" ; -- flexionsform..nn.1
  flexionsändelse_1_N = mkN "flexionsändelse" "flexionsändelser" ; -- flexionsändelse..nn.1
  flexislang_1_N = mkN "flexislang" ; -- flexislang..nn.1
  flexivisk_1_A = mkA "flexivisk" ; -- flexivisk..av.1
  flexklocka_1_N = mkN "flexklocka" ; -- flexklocka..nn.1
  flextid_1_N = mkN "flextid" "flextider" ; -- flextid..nn.1
  flexur_1_N = mkN "flexur" "flexurer" ; -- flexur..nn.1
  flicka_1_N = mkN "flicka" ; -- flicka..nn.1
  flickaktig_1_A = mkA "flickaktig" ; -- flickaktig..av.1
  flickaktighet_1_N = mkN "flickaktighet" ; -- flickaktighet..nn.1
  flickansikte_1_N = mkN "flickansikte" ; -- flickansikte..nn.1
  flickbok_1_N = mkN "flickbok" "flickböcker" ; -- flickbok..nn.1
  flickboksfantasi_1_N = mkN "flickboksfantasi" "flickboksfantasier" ; -- flickboksfantasi..nn.1
  flickbokshjältinna_1_N = mkN "flickbokshjältinna" ; -- flickbokshjältinna..nn.1
  flickboksklassiker_1_N = mkN "flickboksklassiker" "flickboksklassikern" "flickboksklassiker" "flickboksklassikerna" ; -- flickboksklassiker..nn.1
  flickbokstradition_1_N = mkN "flickbokstradition" ; -- flickbokstradition..nn.1
  flickebarn_1_N = mkN "flickebarn" neutrum  ; -- flickebarn..nn.1
  flickfotograf_1_N = mkN "flickfotograf" "flickfotografer" ; -- flickfotograf..nn.1
  flickjägare_1_N = mkN "flickjägare" utrum  ; -- flickjägare..nn.1
  flickkalv_1_N = mkN "flickkalv" ; -- flickkalv..nn.1
  flickkör_1_N = mkN "flickkör" "flickkörer" ; -- flickkör..nn.1
  flickmatch_1_N = mkN "flickmatch" "flickmatcher" ; -- flickmatch..nn.1
  flicknamn_1_N = mkN "flicknamn" neutrum  ; -- flicknamn..nn.1
  flickpension_1_N = mkN "flickpension" ; -- flickpension..nn.1
  flickröst_1_N = mkN "flickröst" "flickröster" ; -- flickröst..nn.1
  flickscout_1_N = mkN "flickscout" "flickscouter" ; -- flickscout..nn.1
  flickskola_1_N = mkN "flickskola" ; -- flickskola..nn.1
  flickslända_1_N = mkN "flickslända" ; -- flickslända..nn.1
  flicksnärta_1_N = mkN "flicksnärta" ; -- flicksnärta..nn.1
  flicktycke_1_N = mkN "flicktycke" ; -- flicktycke..nn.1
  flickunge_1_N = mkN "flickunge" utrum  ; -- flickunge..nn.1
  flickvän_1_N = mkN "flickvän" "flickvännen" "flickvänner" "flickvännerna" ; -- flickvän..nn.1
  flight_1_N = mkN "flight" "flighter" ; -- flight..nn.1
  flik_1_N = mkN "flik" ; -- flik..nn.1
  flikad_1_A = mkA "flikad" ; -- flikad..av.1
  flikig_1_A = mkA "flikig" ; -- flikig..av.1
  flikighet_1_N = mkN "flikighet" ; -- flikighet..nn.1
  flimmer_1_N = mkN "flimmer" neutrum  ; -- flimmer..nn.1
  flimmercell_1_N = mkN "flimmercell" "flimmerceller" ; -- flimmercell..nn.1
  flimmerhår_1_N = mkN "flimmerhår" neutrum  ; -- flimmerhår..nn.1
  flimra_1_V = mkV "flimrar" ; -- flimra..vb.1
  flimrande_1_N = mkN "flimrande" ; -- flimrande..nn.1
  flimrig_1_A = mkA "flimrig" ; -- flimrig..av.1
  flimrighet_1_N = mkN "flimrighet" ; -- flimrighet..nn.1
  flin_1_N = mkN "flin" neutrum  ; -- flin..nn.1
  flina_1_V = mkV "flinar" ; -- flina..vb.1
  flinande_1_N = mkN "flinande" ; -- flinande..nn.1
  flinare_1_N = mkN "flinare" utrum  ; -- flinare..nn.1
  flinga_1_N = mkN "flinga" ; -- flinga..nn.1
  flingsalt_1_N = mkN "flingsalt" "flingsaltet" "flingsalter" "flingsalterna" ; -- flingsalt..nn.1
  flink_1_A = mkA "flink" ; -- flink..av.1
  flinkhet_1_N = mkN "flinkhet" ; -- flinkhet..nn.1
  flint_1_N = mkN "flint" ; -- flint..nn.1
  flinta_1_N = mkN "flinta" ; -- flinta..nn.1
  flintgods_1_N = mkN "flintgods" neutrum  ; -- flintgods..nn.1
  flintlås_1_N = mkN "flintlås" neutrum  ; -- flintlås..nn.1
  flintlåsgevär_1_N = mkN "flintlåsgevär" neutrum  ; -- flintlåsgevär..nn.1
  flintskalle_1_N = mkN "flintskalle" utrum  ; -- flintskalle..nn.1
  flintskallig_1_A = mkA "flintskallig" ; -- flintskallig..av.1
  flintskallighet_1_N = mkN "flintskallighet" ; -- flintskallighet..nn.1
  flintyxa_1_N = mkN "flintyxa" ; -- flintyxa..nn.1
  flipperkula_1_N = mkN "flipperkula" ; -- flipperkula..nn.1
  flipperspel_1_N = mkN "flipperspel" "flipperspelet" "flipperspel" "flipperspelen" ; -- flipperspel..nn.1
  flipprig_1_A = mkA "flipprig" ; -- flipprig..av.1
  flirt_1_N = mkN "flirt" ; -- flirt..nn.1
  flirta_1_V = mkV "flirtar" ; -- flirta..vb.1
  flirtande_1_N = mkN "flirtande" ; -- flirtande..nn.1
  flirtig_1_A = mkA "flirtig" ; -- flirtig..av.1
  flirtighet_1_N = mkN "flirtighet" ; -- flirtighet..nn.1
  flis_1_N = mkN "flis" ; -- flis..nn.1
  flisa_1_N = mkN "flisa" ; -- flisa..nn.1
  flisig_1_A = mkA "flisig" ; -- flisig..av.1
  flisighet_1_N = mkN "flisighet" ; -- flisighet..nn.1
  flit_1_N = mkN "flit" ; -- flit..nn.1
  flitig_1_A = mkA "flitig" ; -- flitig..av.1
  flo_1_N = mkN "flo" ; -- flo..nn.1
  floatglas_1_N = mkN "floatglas" neutrum  ; -- floatglas..nn.1
  flock_1_N = mkN "flock" ; -- flock..nn.1
  flock_2_N = mkN "flock" neutrum  ; -- flock..nn.2
  flockbeteende_1_N = mkN "flockbeteende" ; -- flockbeteende..nn.1
  flockblommig_1_A = mkA "flockblommig" ; -- flockblommig..av.1
  flockdjur_1_N = mkN "flockdjur" neutrum  ; -- flockdjur..nn.1
  flockig_1_A = mkA "flockig" ; -- flockig..av.1
  flockighet_1_N = mkN "flockighet" ; -- flockighet..nn.1
  flockinstinkt_1_N = mkN "flockinstinkt" "flockinstinkter" ; -- flockinstinkt..nn.1
  flockkamrat_1_N = mkN "flockkamrat" "flockkamrater" ; -- flockkamrat..nn.1
  flockvis_1_Adv = mkAdv "flockvis" ; -- flockvis..ab.1
  flod_1_N = mkN "flod" "floder" ; -- flod..nn.1
  flodarm_1_N = mkN "flodarm" ; -- flodarm..nn.1
  flodbrädd_1_N = mkN "flodbrädd" ; -- flodbrädd..nn.1
  flodbädd_1_N = mkN "flodbädd" ; -- flodbädd..nn.1
  flodbåt_1_N = mkN "flodbåt" ; -- flodbåt..nn.1
  floddal_1_N = mkN "floddal" ; -- floddal..nn.1
  floddelta_1_N = mkN "floddelta" "floddeltat" "floddeltan" "floddeltana" ; -- floddelta..nn.1
  flodfart_1_N = mkN "flodfart" ; -- flodfart..nn.1
  flodfåra_1_N = mkN "flodfåra" ; -- flodfåra..nn.1
  flodgud_1_N = mkN "flodgud" ; -- flodgud..nn.1
  flodhäst_1_N = mkN "flodhäst" ; -- flodhäst..nn.1
  flodhästunge_1_N = mkN "flodhästunge" utrum  ; -- flodhästunge..nn.1
  flodiller_1_N = mkN "flodiller" ; -- flodiller..nn.1
  flodkrabba_1_N = mkN "flodkrabba" ; -- flodkrabba..nn.1
  flodkrök_1_N = mkN "flodkrök" ; -- flodkrök..nn.1
  flodmynning_1_N = mkN "flodmynning" ; -- flodmynning..nn.1
  flodområde_1_N = mkN "flodområde" ; -- flodområde..nn.1
  flodprofil_1_N = mkN "flodprofil" "flodprofiler" ; -- flodprofil..nn.1
  flodslätt_1_N = mkN "flodslätt" "flodslätter" ; -- flodslätt..nn.1
  flodstrand_1_N = mkN "flodstrand" "flodstränder" ; -- flodstrand..nn.1
  flodsvin_1_N = mkN "flodsvin" neutrum  ; -- flodsvin..nn.1
  flodsystem_1_N = mkN "flodsystem" neutrum  ; -- flodsystem..nn.1
  flodterrass_1_N = mkN "flodterrass" "flodterrasser" ; -- flodterrass..nn.1
  flodvatten_1_N = mkN "flodvatten" "flodvattnet" "flodvatten" "flodvattnen" ; -- flodvatten..nn.1
  flodvåg_1_N = mkN "flodvåg" "flodvågor" ; -- flodvåg..nn.1
  flodångare_1_N = mkN "flodångare" utrum  ; -- flodångare..nn.1
  flodövergång_1_N = mkN "flodövergång" ; -- flodövergång..nn.1
  flogrönn_1_N = mkN "flogrönn" ; -- flogrönn..nn.1
  flop_1_N = mkN "flop" ; -- flop..nn.1
  flopp_1_N = mkN "flopp" ; -- flopp..nn.1
  floppa_1_V = mkV "floppar" ; -- floppa..vb.1
  floppande_1_N = mkN "floppande" ; -- floppande..nn.1
  floppning_1_N = mkN "floppning" ; -- floppning..nn.1
  floppsatsning_1_N = mkN "floppsatsning" ; -- floppsatsning..nn.1
  flor_1_N = mkN "flor" neutrum  ; -- flor..nn.1
  flor_2_N = mkN "flor" ; -- flor..nn.2
  flora_1_N = mkN "flora" ; -- flora..nn.1
  florentinsk_1_A = mkA "florentinsk" ; -- florentinsk..av.1
  florera_1_V = mkV "florerar" ; -- florera..vb.1
  florerande_1_N = mkN "florerande" ; -- florerande..nn.1
  florering_1_N = mkN "florering" ; -- florering..nn.1
  florett_1_N = mkN "florett" "floretter" ; -- florett..nn.1
  florettfäktning_1_N = mkN "florettfäktning" ; -- florettfäktning..nn.1
  florettfäktningskurs_1_N = mkN "florettfäktningskurs" "florettfäktningskurser" ; -- florettfäktningskurs..nn.1
  florettstick_1_N = mkN "florettstick" neutrum  ; -- florettstick..nn.1
  florilegium_1_N = mkN "florilegium" "florilegiet" "florilegier" "florilegierna" ; -- florilegium..nn.1
  florin_1_N = mkN "florin" "floriner" ; -- florin..nn.1
  florist_1_N = mkN "florist" "florister" ; -- florist..nn.1
  floristik_1_N = mkN "floristik" ; -- floristik..nn.1
  floristisk_1_A = mkA "floristisk" ; -- floristisk..av.1
  florsocker_1_N = mkN "florsocker" neutrum  ; -- florsocker..nn.1
  floskel_1_N = mkN "floskel" "floskeln" "floskler" "flosklerna" ; -- floskel..nn.1
  floskelpatriot_1_N = mkN "floskelpatriot" "floskelpatrioter" ; -- floskelpatriot..nn.1
  floskulös_1_A = mkA "floskulös" ; -- floskulös..av.1
  flossa_1_N = mkN "flossa" ; -- flossa..nn.1
  flossa_1_V = mkV "flossar" ; -- flossa..vb.1
  flossad_1_A = mkA "flossad" ; -- flossad..av.1
  flossande_1_N = mkN "flossande" ; -- flossande..nn.1
  flossning_1_N = mkN "flossning" ; -- flossning..nn.1
  flotation_1_N = mkN "flotation" ; -- flotation..nn.1
  flott_1_A = mkA "flott" ; -- flott..av.1
  flott_1_N = mkN "flott" neutrum  ; -- flott..nn.1
  flotta_1_N = mkN "flotta" ; -- flotta..nn.1
  flotta_1_V = mkV "flottar" ; -- flotta..vb.1
  flottande_1_N = mkN "flottande" ; -- flottande..nn.1
  flottare_1_N = mkN "flottare" utrum  ; -- flottare..nn.1
  flottbas_1_N = mkN "flottbas" "flottbaser" ; -- flottbas..nn.1
  flottbesök_1_N = mkN "flottbesök" neutrum  ; -- flottbesök..nn.1
  flottbro_1_N = mkN "flottbro" ; -- flottbro..nn.1
  flotte_1_N = mkN "flotte" utrum  ; -- flotte..nn.1
  flottenhet_1_N = mkN "flottenhet" "flottenheter" ; -- flottenhet..nn.1
  flottfläck_1_N = mkN "flottfläck" ; -- flottfläck..nn.1
  flotthet_1_N = mkN "flotthet" ; -- flotthet..nn.1
  flottig_1_A = mkA "flottig" ; -- flottig..av.1
  flottighet_1_N = mkN "flottighet" ; -- flottighet..nn.1
  flottilj_1_N = mkN "flottilj" "flottiljer" ; -- flottilj..nn.1
  flottist_1_N = mkN "flottist" "flottister" ; -- flottist..nn.1
  flottled_1_N = mkN "flottled" "flottleder" ; -- flottled..nn.1
  flottning_1_N = mkN "flottning" ; -- flottning..nn.1
  flottningstimmer_1_N = mkN "flottningstimmer" neutrum  ; -- flottningstimmer..nn.1
  flottstrateg_1_N = mkN "flottstrateg" "flottstrateger" ; -- flottstrateg..nn.1
  flottstyrman_1_N = mkN "flottstyrman" "flottstyrmannen" "flottstyrmän" "flottstyrmännen" ; -- flottstyrman..nn.1
  flottyr_1_N = mkN "flottyr" "flottyrer" ; -- flottyr..nn.1
  flottyrkoka_1_V = mkV "flottyrkoker" ; -- flottyrkoka..vb.1
  flottyrkokande_1_N = mkN "flottyrkokande" ; -- flottyrkokande..nn.1
  flottör_1_N = mkN "flottör" "flottörer" ; -- flottör..nn.1
  flottövning_1_N = mkN "flottövning" ; -- flottövning..nn.1
  flox_1_N = mkN "flox" ; -- flox..nn.1
  fluffig_1_A = mkA "fluffig" ; -- fluffig..av.1
  fluffighet_1_N = mkN "fluffighet" "fluffigheter" ; -- fluffighet..nn.1
  fluga_1_N = mkN "fluga" ; -- fluga..nn.1
  flugblomster_1_N = mkN "flugblomster" neutrum  ; -- flugblomster..nn.1
  flugfiske_1_N = mkN "flugfiske" ; -- flugfiske..nn.1
  flugpapper_1_N = mkN "flugpapper" neutrum  ; -- flugpapper..nn.1
  flugsmuts_1_N = mkN "flugsmuts" ; -- flugsmuts..nn.1
  flugsmälla_1_N = mkN "flugsmälla" ; -- flugsmälla..nn.1
  flugsnappare_1_N = mkN "flugsnappare" utrum  ; -- flugsnappare..nn.1
  flugsvamp_1_N = mkN "flugsvamp" ; -- flugsvamp..nn.1
  flugvifta_1_N = mkN "flugvifta" ; -- flugvifta..nn.1
  flugvikt_1_N = mkN "flugvikt" ; -- flugvikt..nn.1
  fluid_1_N = mkN "fluid" "fluider" ; -- fluid..nn.1
  fluidisera_1_V = mkV "fluidiserar" ; -- fluidisera..vb.1
  fluidiserande_1_N = mkN "fluidiserande" ; -- fluidiserande..nn.1
  fluidiserbar_1_A = mkA "fluidiserbar" ; -- fluidiserbar..av.1
  fluidiserbarhet_1_N = mkN "fluidiserbarhet" ; -- fluidiserbarhet..nn.1
  fluidisering_1_N = mkN "fluidisering" ; -- fluidisering..nn.1
  fluidum_1_N = mkN "fluidum" "fluidet" "fluida" "fluidana" ; -- fluidum..nn.1
  flukt_1_N = mkN "flukt" ; -- flukt..nn.1
  flukta_1_V = mkV "fluktar" ; -- flukta..vb.1
  fluktande_1_N = mkN "fluktande" ; -- fluktande..nn.1
  fluktuation_1_N = mkN "fluktuation" ; -- fluktuation..nn.1
  fluktuera_1_V = mkV "fluktuerar" ; -- fluktuera..vb.1
  fluktuerande_1_N = mkN "fluktuerande" ; -- fluktuerande..nn.1
  fluktuering_1_N = mkN "fluktuering" ; -- fluktuering..nn.1
  flumkurs_1_N = mkN "flumkurs" "flumkurser" ; -- flumkurs..nn.1
  flumma_1_V = mkV "flummar" ; -- flumma..vb.1
  flummande_1_N = mkN "flummande" ; -- flummande..nn.1
  flummig_1_A = mkA "flummig" ; -- flummig..av.1
  flummighet_1_N = mkN "flummighet" ; -- flummighet..nn.1
  flumpedagogik_1_N = mkN "flumpedagogik" ; -- flumpedagogik..nn.1
  flundra_1_N = mkN "flundra" ; -- flundra..nn.1
  flunsa_1_N = mkN "flunsa" ; -- flunsa..nn.1
  fluor_1_N = mkN "fluor" ; -- fluor..nn.1
  fluorbehandling_1_N = mkN "fluorbehandling" ; -- fluorbehandling..nn.1
  fluorera_1_V = mkV "fluorerar" ; -- fluorera..vb.1
  fluorerande_1_N = mkN "fluorerande" ; -- fluorerande..nn.1
  fluorerbar_1_A = mkA "fluorerbar" ; -- fluorerbar..av.1
  fluorerbarhet_1_N = mkN "fluorerbarhet" ; -- fluorerbarhet..nn.1
  fluorering_1_N = mkN "fluorering" ; -- fluorering..nn.1
  fluorescens_1_N = mkN "fluorescens" ; -- fluorescens..nn.1
  fluorescera_1_V = mkV "fluorescerar" ; -- fluorescera..vb.1
  fluorescerande_1_N = mkN "fluorescerande" ; -- fluorescerande..nn.1
  fluorescering_1_N = mkN "fluorescering" ; -- fluorescering..nn.1
  fluorhalt_1_N = mkN "fluorhalt" "fluorhalter" ; -- fluorhalt..nn.1
  fluorhaltig_1_A = mkA "fluorhaltig" ; -- fluorhaltig..av.1
  fluorid_1_N = mkN "fluorid" "fluorider" ; -- fluorid..nn.1
  fluoridera_1_V = mkV "fluoriderar" ; -- fluoridera..vb.1
  fluoriderande_1_N = mkN "fluoriderande" ; -- fluoriderande..nn.1
  fluoriderbar_1_A = mkA "fluoriderbar" ; -- fluoriderbar..av.1
  fluoriderbarhet_1_N = mkN "fluoriderbarhet" ; -- fluoriderbarhet..nn.1
  fluoridering_1_N = mkN "fluoridering" ; -- fluoridering..nn.1
  fluss_1_N = mkN "fluss" "flusser" ; -- fluss..nn.1
  flussglas_1_N = mkN "flussglas" neutrum  ; -- flussglas..nn.1
  flussmedel_1_N = mkN "flussmedel" neutrum  ; -- flussmedel..nn.1
  flusspat_1_N = mkN "flusspat" ; -- flusspat..nn.1
  fluster_1_N = mkN "fluster" neutrum  ; -- fluster..nn.1
  fluvial_1_A = mkA "fluvial" ; -- fluvial..av.1
  fly_1_N = mkN "fly" "flyet" "flyn" "flyna" ; -- fly..nn.1
  fly_1_V = mkV "flyr" ; -- fly..vb.1
  flyende_1_N = mkN "flyende" ; -- flyende..nn.1
  flyfotad_1_A = mkA "flyfotad" ; -- flyfotad..av.1
  flyfotadhet_1_N = mkN "flyfotadhet" ; -- flyfotadhet..nn.1
  flyg_1_N = mkN "flyg" neutrum  ; -- flyg..nn.1
  flyg_2_N = mkN "flyg" neutrum  ; -- flyg..nn.2
  flyga_1_V = mkV "flyga" "flög" "flugit" ; -- flyga..vb.1
  flygande_1_N = mkN "flygande" ; -- flygande..nn.1
  flyganfall_1_N = mkN "flyganfall" neutrum  ; -- flyganfall..nn.1
  flygankomst_1_N = mkN "flygankomst" "flygankomster" ; -- flygankomst..nn.1
  flygare_1_N = mkN "flygare" utrum  ; -- flygare..nn.1
  flygattaché_1_N = mkN "flygattaché" "flygattachéer" ; -- flygattaché..nn.1
  flygattack_1_N = mkN "flygattack" "flygattacker" ; -- flygattack..nn.1
  flygavgång_1_N = mkN "flygavgång" ; -- flygavgång..nn.1
  flygbas_1_N = mkN "flygbas" "flygbaser" ; -- flygbas..nn.1
  flygbasbarack_1_N = mkN "flygbasbarack" "flygbasbaracker" ; -- flygbasbarack..nn.1
  flygbensin_1_N = mkN "flygbensin" ; -- flygbensin..nn.1
  flygbild_1_N = mkN "flygbild" "flygbilder" ; -- flygbild..nn.1
  flygbiljett_1_N = mkN "flygbiljett" "flygbiljetter" ; -- flygbiljett..nn.1
  flygblad_1_N = mkN "flygblad" neutrum  ; -- flygblad..nn.1
  flygbolag_1_N = mkN "flygbolag" neutrum  ; -- flygbolag..nn.1
  flygbomb_1_N = mkN "flygbomb" "flygbomber" ; -- flygbomb..nn.1
  flygbomba_1_V = mkV "flygbombar" ; -- flygbomba..vb.1
  flygbombande_1_N = mkN "flygbombande" ; -- flygbombande..nn.1
  flygbro_1_N = mkN "flygbro" ; -- flygbro..nn.1
  flygbränsle_1_N = mkN "flygbränsle" ; -- flygbränsle..nn.1
  flygbuss_1_N = mkN "flygbuss" ; -- flygbuss..nn.1
  flygbåt_1_N = mkN "flygbåt" ; -- flygbåt..nn.1
  flygcertifikat_1_N = mkN "flygcertifikat" neutrum  ; -- flygcertifikat..nn.1
  flygdrama_1_N = mkN "flygdrama" "flygdramat" "flygdramer" "flygdramerna" ; -- flygdrama..nn.1
  flygekorre_1_N = mkN "flygekorre" utrum  ; -- flygekorre..nn.1
  flygel_1_N = mkN "flygel" ; -- flygel..nn.1
  flygelbyggnad_1_N = mkN "flygelbyggnad" "flygelbyggnader" ; -- flygelbyggnad..nn.1
  flygfisk_1_N = mkN "flygfisk" ; -- flygfisk..nn.1
  flygflotta_1_N = mkN "flygflotta" ; -- flygflotta..nn.1
  flygfoto_1_N = mkN "flygfoto" "flygfotot" "flygfoton" "flygfotona" ; -- flygfoto..nn.1
  flygfotogen_1_N = mkN "flygfotogen" neutrum  ; -- flygfotogen..nn.1
  flygfotografi_1_N = mkN "flygfotografi" "flygfotografiet" "flygfotografier" "flygfotografierna" ; -- flygfotografi..nn.1
  flygfrakt_1_N = mkN "flygfrakt" "flygfrakter" ; -- flygfrakt..nn.1
  flygfä_1_N = mkN "flygfä" "flygfät" "flygfän" "flygfäna" ; -- flygfä..nn.1
  flygfält_1_N = mkN "flygfält" neutrum  ; -- flygfält..nn.1
  flygfärd_1_N = mkN "flygfärd" "flygfärder" ; -- flygfärd..nn.1
  flygfärdig_1_A = mkA "flygfärdig" ; -- flygfärdig..av.1
  flygfärdighet_1_N = mkN "flygfärdighet" ; -- flygfärdighet..nn.1
  flygförare_1_N = mkN "flygförare" utrum  ; -- flygförare..nn.1
  flygförband_1_N = mkN "flygförband" neutrum  ; -- flygförband..nn.1
  flygförbud_1_N = mkN "flygförbud" neutrum  ; -- flygförbud..nn.1
  flygförbudszon_1_N = mkN "flygförbudszon" "flygförbudszoner" ; -- flygförbudszon..nn.1
  flygg_1_A = mkA "flygg" ; -- flygg..av.1
  flygghet_1_N = mkN "flygghet" ; -- flygghet..nn.1
  flyghastighet_1_N = mkN "flyghastighet" "flyghastigheter" ; -- flyghastighet..nn.1
  flyghavre_1_N = mkN "flyghavre" utrum  ; -- flyghavre..nn.1
  flyghund_1_N = mkN "flyghund" ; -- flyghund..nn.1
  flyghål_1_N = mkN "flyghål" neutrum  ; -- flyghål..nn.1
  flygindustri_1_N = mkN "flygindustri" "flygindustrier" ; -- flygindustri..nn.1
  flygkaos_1_N = mkN "flygkaos" neutrum  ; -- flygkaos..nn.1
  flygkapacitet_1_N = mkN "flygkapacitet" "flygkapaciteter" ; -- flygkapacitet..nn.1
  flygkapning_1_N = mkN "flygkapning" ; -- flygkapning..nn.1
  flygkapten_1_N = mkN "flygkapten" "flygkaptener" ; -- flygkapten..nn.1
  flygkatastrof_1_N = mkN "flygkatastrof" "flygkatastrofer" ; -- flygkatastrof..nn.1
  flygkonst_1_N = mkN "flygkonst" "flygkonster" ; -- flygkonst..nn.1
  flygkorridor_1_N = mkN "flygkorridor" "flygkorridoren" "flygkorridorer" "flygkorridorerna" ; -- flygkorridor..nn.1
  flygkropp_1_N = mkN "flygkropp" ; -- flygkropp..nn.1
  flygkår_1_N = mkN "flygkår" "flygkårer" ; -- flygkår..nn.1
  flyglarm_1_N = mkN "flyglarm" neutrum  ; -- flyglarm..nn.1
  flygledare_1_N = mkN "flygledare" utrum  ; -- flygledare..nn.1
  flygledarstrejk_1_N = mkN "flygledarstrejk" "flygledarstrejker" ; -- flygledarstrejk..nn.1
  flygledes_1_Adv = mkAdv "flygledes" ; -- flygledes..ab.1
  flygledning_1_N = mkN "flygledning" ; -- flygledning..nn.1
  flyglinje_1_N = mkN "flyglinje" "flyglinjer" ; -- flyglinje..nn.1
  flyglägenhet_1_N = mkN "flyglägenhet" "flyglägenheter" ; -- flyglägenhet..nn.1
  flygmaskin_1_N = mkN "flygmaskin" "flygmaskiner" ; -- flygmaskin..nn.1
  flygmyra_1_N = mkN "flygmyra" ; -- flygmyra..nn.1
  flygning_1_N = mkN "flygning" ; -- flygning..nn.1
  flygpassagerare_1_N = mkN "flygpassagerare" utrum  ; -- flygpassagerare..nn.1
  flygpersonal_1_N = mkN "flygpersonal" ; -- flygpersonal..nn.1
  flygplan_1_N = mkN "flygplan" neutrum  ; -- flygplan..nn.1
  flygplansbesättning_1_N = mkN "flygplansbesättning" ; -- flygplansbesättning..nn.1
  flygplanshangar_1_N = mkN "flygplanshangar" "flygplanshangarn" "flygplanshangarer" "flygplanshangarerna" ; -- flygplanshangar..nn.1
  flygplanskabin_1_N = mkN "flygplanskabin" "flygplanskabiner" ; -- flygplanskabin..nn.1
  flygplansluft_1_N = mkN "flygplansluft" ; -- flygplansluft..nn.1
  flygplansmodell_1_N = mkN "flygplansmodell" "flygplansmodeller" ; -- flygplansmodell..nn.1
  flygplansroder_1_N = mkN "flygplansroder" neutrum  ; -- flygplansroder..nn.1
  flygplanstillverkare_1_N = mkN "flygplanstillverkare" utrum  ; -- flygplanstillverkare..nn.1
  flygplanstoa_1_N = mkN "flygplanstoa" ; -- flygplanstoa..nn.1
  flygplansvinge_1_N = mkN "flygplansvinge" utrum  ; -- flygplansvinge..nn.1
  flygplats_1_N = mkN "flygplats" "flygplatser" ; -- flygplats..nn.1
  flygplatsservering_1_N = mkN "flygplatsservering" ; -- flygplatsservering..nn.1
  flygpost_1_N = mkN "flygpost" ; -- flygpost..nn.1
  flygresa_1_N = mkN "flygresa" ; -- flygresa..nn.1
  flygräd_1_N = mkN "flygräd" "flygräder" ; -- flygräd..nn.1
  flygrädd_1_A = mkA "flygrädd" ; -- flygrädd..av.1
  flygrönn_1_N = mkN "flygrönn" ; -- flygrönn..nn.1
  flygsand_1_N = mkN "flygsand" ; -- flygsand..nn.1
  flygsandsfält_1_N = mkN "flygsandsfält" neutrum  ; -- flygsandsfält..nn.1
  flygskrift_1_N = mkN "flygskrift" "flygskrifter" ; -- flygskrift..nn.1
  flygstol_1_N = mkN "flygstol" ; -- flygstol..nn.1
  flygstopp_1_N = mkN "flygstopp" neutrum  ; -- flygstopp..nn.1
  flygstörning_1_N = mkN "flygstörning" ; -- flygstörning..nn.1
  flygsäkerhet_1_N = mkN "flygsäkerhet" ; -- flygsäkerhet..nn.1
  flygsäkerhetsexpert_1_N = mkN "flygsäkerhetsexpert" "flygsäkerhetsexperter" ; -- flygsäkerhetsexpert..nn.1
  flygsäkerhetskonsult_1_N = mkN "flygsäkerhetskonsult" "flygsäkerhetskonsulter" ; -- flygsäkerhetskonsult..nn.1
  flygtaxi_1_N = mkN "flygtaxi" "flygtaxin" "flygtaxi" "flygtaxina" ; -- flygtaxi..nn.1
  flygterminal_1_N = mkN "flygterminal" "flygterminaler" ; -- flygterminal..nn.1
  flygtidtabell_1_N = mkN "flygtidtabell" "flygtidtabeller" ; -- flygtidtabell..nn.1
  flygtrafik_1_N = mkN "flygtrafik" ; -- flygtrafik..nn.1
  flygtrafikledare_1_N = mkN "flygtrafikledare" utrum  ; -- flygtrafikledare..nn.1
  flygtrafikledning_1_N = mkN "flygtrafikledning" ; -- flygtrafikledning..nn.1
  flygtransport_1_N = mkN "flygtransport" "flygtransporter" ; -- flygtransport..nn.1
  flygtur_1_N = mkN "flygtur" "flygturer" ; -- flygtur..nn.1
  flygutbildning_1_N = mkN "flygutbildning" ; -- flygutbildning..nn.1
  flygvapen_1_N = mkN "flygvapen" "flygvapnet" "flygvapen" "flygvapnen" ; -- flygvapen..nn.1
  flygvapenchef_1_N = mkN "flygvapenchef" "flygvapenchefer" ; -- flygvapenchef..nn.1
  flygväg_1_N = mkN "flygväg" ; -- flygväg..nn.1
  flygvärdinna_1_N = mkN "flygvärdinna" ; -- flygvärdinna..nn.1
  flygödla_1_N = mkN "flygödla" ; -- flygödla..nn.1
  flyhänt_1_A = mkA "flyhänt" "flyhänt" ; -- flyhänt..av.1
  flyhänthet_1_N = mkN "flyhänthet" ; -- flyhänthet..nn.1
  flykt_1_N = mkN "flykt" "flykter" ; -- flykt..nn.1
  flykt_2_N = mkN "flykt" ; -- flykt..nn.2
  flykta_1_V = mkV "flyktar" ; -- flykta..vb.1
  flyktande_1_N = mkN "flyktande" ; -- flyktande..nn.1
  flyktfara_1_N = mkN "flyktfara" ; -- flyktfara..nn.1
  flyktfordon_1_N = mkN "flyktfordon" neutrum  ; -- flyktfordon..nn.1
  flyktförsök_1_N = mkN "flyktförsök" neutrum  ; -- flyktförsök..nn.1
  flyktig_1_A = mkA "flyktig" ; -- flyktig..av.1
  flyktighet_1_N = mkN "flyktighet" ; -- flyktighet..nn.1
  flyktighet_2_N = mkN "flyktighet" "flyktigheter" ; -- flyktighet..nn.2
  flykting_1_N = mkN "flykting" ; -- flykting..nn.1
  flyktingbarn_1_N = mkN "flyktingbarn" neutrum  ; -- flyktingbarn..nn.1
  flyktingfamilj_1_N = mkN "flyktingfamilj" "flyktingfamiljer" ; -- flyktingfamilj..nn.1
  flyktinggömmare_1_N = mkN "flyktinggömmare" utrum  ; -- flyktinggömmare..nn.1
  flyktinglik_1_N = mkN "flyktinglik" neutrum  ; -- flyktinglik..nn.1
  flyktingläger_1_N = mkN "flyktingläger" neutrum  ; -- flyktingläger..nn.1
  flyktingmottagande_1_N = mkN "flyktingmottagande" ; -- flyktingmottagande..nn.1
  flyktingmottagning_1_N = mkN "flyktingmottagning" ; -- flyktingmottagning..nn.1
  flyktingpolitik_1_N = mkN "flyktingpolitik" ; -- flyktingpolitik..nn.1
  flyktingström_1_N = mkN "flyktingström" "flyktingströmmen" "flyktingströmmar" "flyktingströmmarna" ; -- flyktingström..nn.1
  flyktmekanism_1_N = mkN "flyktmekanism" "flyktmekanismer" ; -- flyktmekanism..nn.1
  flyktmöjlighet_1_N = mkN "flyktmöjlighet" "flyktmöjligheter" ; -- flyktmöjlighet..nn.1
  flyktreaktion_1_N = mkN "flyktreaktion" ; -- flyktreaktion..nn.1
  flyktrisk_1_N = mkN "flyktrisk" "flyktrisker" ; -- flyktrisk..nn.1
  flyktväg_1_N = mkN "flyktväg" ; -- flyktväg..nn.1
  flyt_1_N = mkN "flyt" neutrum  ; -- flyt..nn.1
  flyta_1_V = mkV "flyta" "flöt" "flutit" ; -- flyta..vb.1
  flytande_1_N = mkN "flytande" ; -- flytande..nn.1
  flytdocka_1_N = mkN "flytdocka" ; -- flytdocka..nn.1
  flytetyg_1_N = mkN "flytetyg" neutrum  ; -- flytetyg..nn.1
  flythjälp_1_N = mkN "flythjälp" ; -- flythjälp..nn.1
  flytjord_1_N = mkN "flytjord" ; -- flytjord..nn.1
  flytning_1_N = mkN "flytning" ; -- flytning..nn.1
  flytsand_1_N = mkN "flytsand" ; -- flytsand..nn.1
  flytspackel_1_N = mkN "flytspackel" neutrum  ; -- flytspackel..nn.1
  flytspackla_1_V = mkV "flytspacklar" ; -- flytspackla..vb.1
  flytspacklande_1_N = mkN "flytspacklande" ; -- flytspacklande..nn.1
  flytspackling_1_N = mkN "flytspackling" ; -- flytspackling..nn.1
  flytt_1_N = mkN "flytt" ; -- flytt..nn.1
  flytta_1_V = mkV "flyttar" ; -- flytta..vb.1
  flyttande_1_N = mkN "flyttande" ; -- flyttande..nn.1
  flyttbar_1_A = mkA "flyttbar" ; -- flyttbar..av.1
  flyttbarhet_1_N = mkN "flyttbarhet" ; -- flyttbarhet..nn.1
  flyttbestyr_1_N = mkN "flyttbestyr" neutrum  ; -- flyttbestyr..nn.1
  flyttblock_1_N = mkN "flyttblock" neutrum  ; -- flyttblock..nn.1
  flyttdag_1_N = mkN "flyttdag" ; -- flyttdag..nn.1
  flyttfågel_1_N = mkN "flyttfågel" ; -- flyttfågel..nn.1
  flyttgröt_1_N = mkN "flyttgröt" ; -- flyttgröt..nn.1
  flyttid_1_N = mkN "flyttid" "flyttider" ; -- flyttid..nn.1
  flyttkarl_1_N = mkN "flyttkarl" ; -- flyttkarl..nn.1
  flyttkartong_1_N = mkN "flyttkartong" "flyttkartonger" ; -- flyttkartong..nn.1
  flyttlass_1_N = mkN "flyttlass" neutrum  ; -- flyttlass..nn.1
  flyttlasspolitik_1_N = mkN "flyttlasspolitik" ; -- flyttlasspolitik..nn.1
  flyttlåda_1_N = mkN "flyttlåda" ; -- flyttlåda..nn.1
  flyttning_1_N = mkN "flyttning" ; -- flyttning..nn.1
  flyttningsdag_1_N = mkN "flyttningsdag" ; -- flyttningsdag..nn.1
  flyttningsförbud_1_N = mkN "flyttningsförbud" neutrum  ; -- flyttningsförbud..nn.1
  flyttningstid_1_N = mkN "flyttningstid" "flyttningstider" ; -- flyttningstid..nn.1
  flytträtt_1_A = mkA "flytträtt" ; -- flytträtt..av.1
  flyttsak_1_N = mkN "flyttsak" "flyttsaker" ; -- flyttsak..nn.1
  flyttstök_1_N = mkN "flyttstök" neutrum  ; -- flyttstök..nn.1
  flytungad_1_A = mkA "flytungad" ; -- flytungad..av.1
  flytungadhet_1_N = mkN "flytungadhet" ; -- flytungadhet..nn.1
  flytväst_1_N = mkN "flytväst" ; -- flytväst..nn.1
  flytvästlag_1_N = mkN "flytvästlag" ; -- flytvästlag..nn.1
  fläck_1_N = mkN "fläck" ; -- fläck..nn.1
  fläcka_1_V = mkV "fläckar" ; -- fläcka..vb.1
  fläckande_1_N = mkN "fläckande" ; -- fläckande..nn.1
  fläckborttagning_1_N = mkN "fläckborttagning" ; -- fläckborttagning..nn.1
  fläckborttagningsmedel_1_N = mkN "fläckborttagningsmedel" neutrum  ; -- fläckborttagningsmedel..nn.1
  fläckfeber_1_N = mkN "fläckfeber" ; -- fläckfeber..nn.1
  fläckfri_1_A = mkA "fläckfri" "fläckfritt" ; -- fläckfri..av.1
  fläckfrihet_1_N = mkN "fläckfrihet" ; -- fläckfrihet..nn.1
  fläckig_1_A = mkA "fläckig" ; -- fläckig..av.1
  fläckighet_1_N = mkN "fläckighet" ; -- fläckighet..nn.1
  fläcklös_1_A = mkA "fläcklös" ; -- fläcklös..av.1
  fläcktyfus_1_N = mkN "fläcktyfus" ; -- fläcktyfus..nn.1
  fläckvis_1_Adv = mkAdv "fläckvis" ; -- fläckvis..ab.1
  fläder_1_N = mkN "fläder" ; -- fläder..nn.1
  fläderbär_1_N = mkN "fläderbär" neutrum  ; -- fläderbär..nn.1
  flädermus_1_N = mkN "flädermus" "flädermusen" "flädermöss" "flädermössen" ; -- flädermus..nn.1
  flädermärg_1_N = mkN "flädermärg" ; -- flädermärg..nn.1
  flädermärgskula_1_N = mkN "flädermärgskula" ; -- flädermärgskula..nn.1
  fläka_1_V = mkV "fläker" ; -- fläka..vb.1
  fläkande_1_N = mkN "fläkande" ; -- fläkande..nn.1
  fläkning_1_N = mkN "fläkning" ; -- fläkning..nn.1
  fläkt_1_N = mkN "fläkt" ; -- fläkt..nn.1
  fläkta_1_V = mkV "fläktar" ; -- fläkta..vb.1
  fläktande_1_N = mkN "fläktande" ; -- fläktande..nn.1
  fläktning_1_N = mkN "fläktning" ; -- fläktning..nn.1
  flämta_1_V = mkV "flämtar" ; -- flämta..vb.1
  flämtande_1_N = mkN "flämtande" ; -- flämtande..nn.1
  flämtning_1_N = mkN "flämtning" ; -- flämtning..nn.1
  fläng_1_A = mkA "fläng" ; -- fläng..av.1
  fläng_1_N = mkN "fläng" neutrum  ; -- fläng..nn.1
  flänga_1_V = mkV "flänger" ; -- flänga..vb.1
  flänga_2_V = mkV "flänger" ; -- flänga..vb.2
  flängande_1_N = mkN "flängande" ; -- flängande..nn.1
  flänghet_1_N = mkN "flänghet" ; -- flänghet..nn.1
  flängig_1_A = mkA "flängig" ; -- flängig..av.1
  flängighet_1_N = mkN "flängighet" ; -- flängighet..nn.1
  flängning_1_N = mkN "flängning" ; -- flängning..nn.1
  fläns_1_N = mkN "fläns" ; -- fläns..nn.1
  flänsa_1_V = mkV "flänsar" ; -- flänsa..vb.1
  flänsande_1_N = mkN "flänsande" ; -- flänsande..nn.1
  flänskniv_1_N = mkN "flänskniv" ; -- flänskniv..nn.1
  flänsost_1_N = mkN "flänsost" ; -- flänsost..nn.1
  flärd_1_N = mkN "flärd" ; -- flärd..nn.1
  flärdfri_1_A = mkA "flärdfri" "flärdfritt" ; -- flärdfri..av.1
  flärdfrihet_1_N = mkN "flärdfrihet" ; -- flärdfrihet..nn.1
  flärdfull_1_A = mkA "flärdfull" ; -- flärdfull..av.1
  flärdfullhet_1_N = mkN "flärdfullhet" "flärdfullheter" ; -- flärdfullhet..nn.1
  flärdlös_1_A = mkA "flärdlös" ; -- flärdlös..av.1
  flärdlöshet_1_N = mkN "flärdlöshet" "flärdlösheter" ; -- flärdlöshet..nn.1
  flärp_1_N = mkN "flärp" ; -- flärp..nn.1
  flärpa_1_N = mkN "flärpa" ; -- flärpa..nn.1
  fläsk_1_N = mkN "fläsk" neutrum  ; -- fläsk..nn.1
  fläskfilé_1_N = mkN "fläskfilé" "fläskfiléer" ; -- fläskfilé..nn.1
  fläskfärs_1_N = mkN "fläskfärs" "fläskfärser" ; -- fläskfärs..nn.1
  fläskhare_1_N = mkN "fläskhare" "fläskharar" ; -- fläskhare..nn.1
  fläskig_1_A = mkA "fläskig" ; -- fläskig..av.1
  fläskighet_1_N = mkN "fläskighet" ; -- fläskighet..nn.1
  fläskkarré_1_N = mkN "fläskkarré" "fläskkarréer" ; -- fläskkarré..nn.1
  fläskkorv_1_N = mkN "fläskkorv" ; -- fläskkorv..nn.1
  fläskkotlett_1_N = mkN "fläskkotlett" "fläskkotletter" ; -- fläskkotlett..nn.1
  fläskkött_1_N = mkN "fläskkött" neutrum  ; -- fläskkött..nn.1
  fläsklägg_1_N = mkN "fläsklägg" ; -- fläsklägg..nn.1
  fläskläpp_1_N = mkN "fläskläpp" ; -- fläskläpp..nn.1
  fläskpannkaka_1_N = mkN "fläskpannkaka" ; -- fläskpannkaka..nn.1
  fläskstycke_1_N = mkN "fläskstycke" ; -- fläskstycke..nn.1
  fläsktärning_1_N = mkN "fläsktärning" ; -- fläsktärning..nn.1
  fläskänger_1_N = mkN "fläskänger" ; -- fläskänger..nn.1
  fläta_1_N = mkN "fläta" ; -- fläta..nn.1
  fläta_1_V = mkV "flätar" ; -- fläta..vb.1
  flätande_1_N = mkN "flätande" ; -- flätande..nn.1
  flätning_1_N = mkN "flätning" ; -- flätning..nn.1
  flätverk_1_N = mkN "flätverk" neutrum  ; -- flätverk..nn.1
  flå_1_V = mkV "flår" ; -- flå..vb.1
  flåbuse_1_N = mkN "flåbuse" utrum  ; -- flåbuse..nn.1
  flådig_1_A = mkA "flådig" ; -- flådig..av.1
  flående_1_N = mkN "flående" ; -- flående..nn.1
  flåhacka_1_N = mkN "flåhacka" ; -- flåhacka..nn.1
  flåhacka_1_V = mkV "flåhackar" ; -- flåhacka..vb.1
  flåhackande_1_N = mkN "flåhackande" ; -- flåhackande..nn.1
  flåhackning_1_N = mkN "flåhackning" ; -- flåhackning..nn.1
  flås_1_N = mkN "flås" neutrum  ; -- flås..nn.1
  flåsa_1_V = mkV "flåsar" ; -- flåsa..vb.1
  flåsande_1_N = mkN "flåsande" ; -- flåsande..nn.1
  flåsig_1_A = mkA "flåsig" ; -- flåsig..av.1
  flåsning_1_N = mkN "flåsning" ; -- flåsning..nn.1
  flåspatos_1_N = mkN "flåspatos" neutrum  ; -- flåspatos..nn.1
  flöda_1_V = mkV "flödar" ; -- flöda..vb.1
  flödande_1_N = mkN "flödande" ; -- flödande..nn.1
  flöde_1_N = mkN "flöde" ; -- flöde..nn.1
  flödesdiagram_1_N = mkN "flödesdiagram" "flödesdiagrammet" "flödesdiagram" "flödesdiagrammen" ; -- flödesdiagram..nn.1
  flödesschema_1_N = mkN "flödesschema" "flödesschemat" "flödesscheman" "flödesschemana" ; -- flödesschema..nn.1
  flöj_1_N = mkN "flöj" ; -- flöj..nn.1
  flöjel_1_N = mkN "flöjel" ; -- flöjel..nn.1
  flöjla_1_V = mkV "flöjlar" ; -- flöjla..vb.1
  flöjlande_1_N = mkN "flöjlande" ; -- flöjlande..nn.1
  flöjt_1_N = mkN "flöjt" "flöjter" ; -- flöjt..nn.1
  flöjta_1_V = mkV "flöjtar" ; -- flöjta..vb.1
  flöjtande_1_N = mkN "flöjtande" ; -- flöjtande..nn.1
  flöjtist_1_N = mkN "flöjtist" "flöjtister" ; -- flöjtist..nn.1
  flöjtton_1_N = mkN "flöjtton" "flöjttoner" ; -- flöjtton..nn.1
  flöjttravär_1_N = mkN "flöjttravär" "flöjttravärer" ; -- flöjttravär..nn.1
  flört_1_N = mkN "flört" "flörter" ; -- flört..nn.1
  flörta_1_V = mkV "flörtar" ; -- flörta..vb.1
  flörtande_1_N = mkN "flörtande" ; -- flörtande..nn.1
  flörtig_1_A = mkA "flörtig" ; -- flörtig..av.1
  flörtighet_1_N = mkN "flörtighet" ; -- flörtighet..nn.1
  flörtkula_1_N = mkN "flörtkula" ; -- flörtkula..nn.1
  flörtlampa_1_N = mkN "flörtlampa" ; -- flörtlampa..nn.1
  flöte_1_N = mkN "flöte" ; -- flöte..nn.1
  flöts_1_N = mkN "flöts" "flötser" ; -- flöts..nn.1
  fnas_1_N = mkN "fnas" neutrum  ; -- fnas..nn.1
  fnasig_1_A = mkA "fnasig" ; -- fnasig..av.1
  fnask_1_N = mkN "fnask" neutrum  ; -- fnask..nn.1
  fnaska_1_V = mkV "fnaskar" ; -- fnaska..vb.1
  fnaskande_1_N = mkN "fnaskande" ; -- fnaskande..nn.1
  fnasker_1_N = mkN "fnasker" ; -- fnasker..nn.1
  fnatt_1_N = mkN "fnatt" ; -- fnatt..nn.1
  fnatta_1_V = mkV "fnattar" ; -- fnatta..vb.1
  fnattande_1_N = mkN "fnattande" ; -- fnattande..nn.1
  fniss_1_N = mkN "fniss" neutrum  ; -- fniss..nn.1
  fnissa_1_V = mkV "fnissar" ; -- fnissa..vb.1
  fnissande_1_N = mkN "fnissande" ; -- fnissande..nn.1
  fnissig_1_A = mkA "fnissig" ; -- fnissig..av.1
  fnissighet_1_N = mkN "fnissighet" ; -- fnissighet..nn.1
  fnissning_1_N = mkN "fnissning" ; -- fnissning..nn.1
  fnitter_1_N = mkN "fnitter" neutrum  ; -- fnitter..nn.1
  fnittra_1_V = mkV "fnittrar" ; -- fnittra..vb.1
  fnittrande_1_N = mkN "fnittrande" ; -- fnittrande..nn.1
  fnittrig_1_A = mkA "fnittrig" ; -- fnittrig..av.1
  fnittrighet_1_N = mkN "fnittrighet" ; -- fnittrighet..nn.1
  fnoskig_1_A = mkA "fnoskig" ; -- fnoskig..av.1
  fnoskighet_1_N = mkN "fnoskighet" "fnoskigheter" ; -- fnoskighet..nn.1
  fnysande_1_N = mkN "fnysande" ; -- fnysande..nn.1
  fnysning_1_N = mkN "fnysning" ; -- fnysning..nn.1
  fnöske_1_N = mkN "fnöske" ; -- fnöske..nn.1
  fnösksvamp_1_N = mkN "fnösksvamp" ; -- fnösksvamp..nn.1
  fnöskticka_1_N = mkN "fnöskticka" ; -- fnöskticka..nn.1
  foaje_1_N = mkN "foaje" "foajeer" ; -- foaje..nn.1
  foajé_1_N = mkN "foajé" "foajéer" ; -- foajé..nn.1
  fobi_1_N = mkN "fobi" "fobier" ; -- fobi..nn.1
  fobiträning_1_N = mkN "fobiträning" ; -- fobiträning..nn.1
  fock_1_N = mkN "fock" ; -- fock..nn.1
  focka_1_V = mkV "fockar" ; -- focka..vb.1
  fockande_1_N = mkN "fockande" ; -- fockande..nn.1
  fockmast_1_N = mkN "fockmast" "fockmaster" ; -- fockmast..nn.1
  fockning_1_N = mkN "fockning" ; -- fockning..nn.1
  focksegel_1_N = mkN "focksegel" neutrum  ; -- focksegel..nn.1
  focus_1_N = mkN "focus" ; -- focus..nn.1
  foder_1_N = mkN "foder" neutrum  ; -- foder..nn.1
  foderbeta_1_N = mkN "foderbeta" ; -- foderbeta..nn.1
  foderblad_1_N = mkN "foderblad" neutrum  ; -- foderblad..nn.1
  foderbrist_1_N = mkN "foderbrist" ; -- foderbrist..nn.1
  foderkaka_1_N = mkN "foderkaka" ; -- foderkaka..nn.1
  foderlada_1_N = mkN "foderlada" ; -- foderlada..nn.1
  fodermark_1_N = mkN "fodermark" "fodermarker" ; -- fodermark..nn.1
  fodermängd_1_N = mkN "fodermängd" "fodermängder" ; -- fodermängd..nn.1
  foderpåse_1_N = mkN "foderpåse" utrum  ; -- foderpåse..nn.1
  fodersäd_1_N = mkN "fodersäd" ; -- fodersäd..nn.1
  fodertyg_1_N = mkN "fodertyg" neutrum  ; -- fodertyg..nn.1
  fodervärd_1_N = mkN "fodervärd" ; -- fodervärd..nn.1
  fodervärde_1_N = mkN "fodervärde" ; -- fodervärde..nn.1
  foderväxt_1_N = mkN "foderväxt" "foderväxter" ; -- foderväxt..nn.1
  fodra_1_V = mkV "fodrar" ; -- fodra..vb.1
  fodral_1_N = mkN "fodral" neutrum  ; -- fodral..nn.1
  fodrande_1_N = mkN "fodrande" ; -- fodrande..nn.1
  fog_1_N = mkN "fog" ; -- fog..nn.1
  fog_2_N = mkN "fog" ; -- fog..nn.2
  foga_1_V = mkV "fogar" ; -- foga..vb.1
  fogande_1_N = mkN "fogande" ; -- fogande..nn.1
  fogde_1_N = mkN "fogde" utrum  ; -- fogde..nn.1
  fogemorfem_1_N = mkN "fogemorfem" neutrum  ; -- fogemorfem..nn.1
  fogeord_1_N = mkN "fogeord" neutrum  ; -- fogeord..nn.1
  foglig_1_A = mkA "foglig" ; -- foglig..av.1
  foglighet_1_N = mkN "foglighet" ; -- foglighet..nn.1
  foglossning_1_N = mkN "foglossning" ; -- foglossning..nn.1
  fogmassa_1_N = mkN "fogmassa" ; -- fogmassa..nn.1
  fogning_1_N = mkN "fogning" ; -- fogning..nn.1
  fogspruta_1_N = mkN "fogspruta" ; -- fogspruta..nn.1
  fogstryka_1_V = mkV "fogstryka" "fogströk" "fogstrukit" ; -- fogstryka..vb.1
  fogstrykande_1_N = mkN "fogstrykande" ; -- fogstrykande..nn.1
  fogstrykning_1_N = mkN "fogstrykning" ; -- fogstrykning..nn.1
  fogsvans_1_N = mkN "fogsvans" ; -- fogsvans..nn.1
  fokal_1_A = mkA "fokal" ; -- fokal..av.1
  fokaldistans_1_N = mkN "fokaldistans" "fokaldistanser" ; -- fokaldistans..nn.1
  fokalplan_1_N = mkN "fokalplan" neutrum  ; -- fokalplan..nn.1
  fokus_1_N = mkN "fokus" ; -- fokus..nn.1
  fokusera_1_V = mkV "fokuserar" ; -- fokusera..vb.1
  fokuserande_1_N = mkN "fokuserande" ; -- fokuserande..nn.1
  fokuserbar_1_A = mkA "fokuserbar" ; -- fokuserbar..av.1
  fokuserbarhet_1_N = mkN "fokuserbarhet" ; -- fokuserbarhet..nn.1
  fokusering_1_N = mkN "fokusering" ; -- fokusering..nn.1
  folder_1_N = mkN "folder" ; -- folder..nn.1
  foliant_1_N = mkN "foliant" "folianter" ; -- foliant..nn.1
  folie_1_N = mkN "folie" "folier" ; -- folie..nn.1
  foliehatt_1_N = mkN "foliehatt" ; -- foliehatt..nn.1
  foliera_1_V = mkV "folierar" ; -- foliera..vb.1
  folierande_1_N = mkN "folierande" ; -- folierande..nn.1
  folierbar_1_A = mkA "folierbar" ; -- folierbar..av.1
  folierbarhet_1_N = mkN "folierbarhet" ; -- folierbarhet..nn.1
  foliering_1_N = mkN "foliering" ; -- foliering..nn.1
  folio_1_N = mkN "folio" ; -- folio..nn.1
  folioformat_1_N = mkN "folioformat" neutrum  ; -- folioformat..nn.1
  folk_1_N = mkN "folk" neutrum  ; -- folk..nn.1
  folkanda_1_N = mkN "folkanda" ; -- folkanda..nn.1
  folkarmé_1_N = mkN "folkarmé" "folkarméer" ; -- folkarmé..nn.1
  folkbank_1_N = mkN "folkbank" "folkbanker" ; -- folkbank..nn.1
  folkbibliotek_1_N = mkN "folkbibliotek" neutrum  ; -- folkbibliotek..nn.1
  folkbildande_1_A = mkA "folkbildande" ; -- folkbildande..av.1
  folkbildning_1_N = mkN "folkbildning" ; -- folkbildning..nn.1
  folkbildningstidskrift_1_N = mkN "folkbildningstidskrift" "folkbildningstidskrifter" ; -- folkbildningstidskrift..nn.1
  folkbok_1_N = mkN "folkbok" "folkböcker" ; -- folkbok..nn.1
  folkbokföra_1_V = mkV "folkbokföra" "folkbokförde" "folkbokfört" ; -- folkbokföra..vb.1
  folkbokförande_1_N = mkN "folkbokförande" ; -- folkbokförande..nn.1
  folkbokföring_1_N = mkN "folkbokföring" ; -- folkbokföring..nn.1
  folkbåt_1_N = mkN "folkbåt" ; -- folkbåt..nn.1
  folkdans_1_N = mkN "folkdans" "folkdanser" ; -- folkdans..nn.1
  folkdansare_1_N = mkN "folkdansare" utrum  ; -- folkdansare..nn.1
  folkdemokrati_1_N = mkN "folkdemokrati" "folkdemokratier" ; -- folkdemokrati..nn.1
  folkdemokratisk_1_A = mkA "folkdemokratisk" ; -- folkdemokratisk..av.1
  folkdikt_1_N = mkN "folkdikt" "folkdikter" ; -- folkdikt..nn.1
  folkdiktning_1_N = mkN "folkdiktning" ; -- folkdiktning..nn.1
  folkdjup_1_N = mkN "folkdjup" neutrum  ; -- folkdjup..nn.1
  folkdomstol_1_N = mkN "folkdomstol" ; -- folkdomstol..nn.1
  folkdräkt_1_N = mkN "folkdräkt" "folkdräkter" ; -- folkdräkt..nn.1
  folketing_1_N = mkN "folketing" neutrum  ; -- folketing..nn.1
  folketymologi_1_N = mkN "folketymologi" "folketymologier" ; -- folketymologi..nn.1
  folketymologisk_1_A = mkA "folketymologisk" ; -- folketymologisk..av.1
  folkfest_1_N = mkN "folkfest" "folkfester" ; -- folkfest..nn.1
  folkfront_1_N = mkN "folkfront" "folkfronter" ; -- folkfront..nn.1
  folkförakt_1_N = mkN "folkförakt" neutrum  ; -- folkförakt..nn.1
  folkfördrivning_1_N = mkN "folkfördrivning" ; -- folkfördrivning..nn.1
  folkförsamling_1_N = mkN "folkförsamling" ; -- folkförsamling..nn.1
  folkförsörjning_1_N = mkN "folkförsörjning" ; -- folkförsörjning..nn.1
  folkgrupp_1_N = mkN "folkgrupp" "folkgrupper" ; -- folkgrupp..nn.1
  folkhav_1_N = mkN "folkhav" neutrum  ; -- folkhav..nn.1
  folkhem_1_N = mkN "folkhem" "folkhemmet" "folkhem" "folkhemmen" ; -- folkhem..nn.1
  folkhemsideologi_1_N = mkN "folkhemsideologi" "folkhemsideologier" ; -- folkhemsideologi..nn.1
  folkhemsidyll_1_N = mkN "folkhemsidyll" "folkhemsidyller" ; -- folkhemsidyll..nn.1
  folkhemsk_1_A = mkA "folkhemsk" ; -- folkhemsk..av.1
  folkhemskoryfé_1_N = mkN "folkhemskoryfé" "folkhemskoryféer" ; -- folkhemskoryfé..nn.1
  folkhemsnostalgi_1_N = mkN "folkhemsnostalgi" "folkhemsnostalgier" ; -- folkhemsnostalgi..nn.1
  folkhemstanke_1_N = mkN "folkhemstanke" utrum  ; -- folkhemstanke..nn.1
  folkhjälte_1_N = mkN "folkhjälte" utrum  ; -- folkhjälte..nn.1
  folkhop_1_N = mkN "folkhop" ; -- folkhop..nn.1
  folkhälsa_1_N = mkN "folkhälsa" ; -- folkhälsa..nn.1
  folkhälsoarbete_1_N = mkN "folkhälsoarbete" ; -- folkhälsoarbete..nn.1
  folkhögskola_1_N = mkN "folkhögskola" ; -- folkhögskola..nn.1
  folkilsken_1_A = mkA "folkilsken" ; -- folkilsken..av.1
  folkilskenhet_1_N = mkN "folkilskenhet" ; -- folkilskenhet..nn.1
  folkis_1_N = mkN "folkis" ; -- folkis..nn.1
  folkkommissarie_1_N = mkN "folkkommissarie" "folkkommissarier" ; -- folkkommissarie..nn.1
  folkkommun_1_N = mkN "folkkommun" "folkkommuner" ; -- folkkommun..nn.1
  folkkongress_1_N = mkN "folkkongress" "folkkongresser" ; -- folkkongress..nn.1
  folkkonst_1_N = mkN "folkkonst" ; -- folkkonst..nn.1
  folkkär_1_A = mkA "folkkär" ; -- folkkär..av.1
  folkkök_1_N = mkN "folkkök" neutrum  ; -- folkkök..nn.1
  folklager_1_N = mkN "folklager" neutrum  ; -- folklager..nn.1
  folkland_1_N = mkN "folkland" "folklandet" "folkländer" "folkländerna" ; -- folkland..nn.1
  folkledare_1_N = mkN "folkledare" utrum  ; -- folkledare..nn.1
  folklek_1_N = mkN "folklek" ; -- folklek..nn.1
  folklig_1_A = mkA "folklig" ; -- folklig..av.1
  folklighet_1_N = mkN "folklighet" "folkligheter" ; -- folklighet..nn.1
  folkliv_1_N = mkN "folkliv" neutrum  ; -- folkliv..nn.1
  folklivsforskare_1_N = mkN "folklivsforskare" utrum  ; -- folklivsforskare..nn.1
  folklivsforskning_1_N = mkN "folklivsforskning" ; -- folklivsforskning..nn.1
  folklivsskildring_1_N = mkN "folklivsskildring" ; -- folklivsskildring..nn.1
  folklore_1_N = mkN "folklore" utrum  ; -- folklore..nn.1
  folklorist_1_N = mkN "folklorist" "folklorister" ; -- folklorist..nn.1
  folkloristik_1_N = mkN "folkloristik" ; -- folkloristik..nn.1
  folkloristisk_1_A = mkA "folkloristisk" ; -- folkloristisk..av.1
  folklustspel_1_N = mkN "folklustspel" "folklustspelet" "folklustspel" "folklustspelen" ; -- folklustspel..nn.1
  folklynne_1_N = mkN "folklynne" ; -- folklynne..nn.1
  folkmakt_1_N = mkN "folkmakt" ; -- folkmakt..nn.1
  folkmassa_1_N = mkN "folkmassa" ; -- folkmassa..nn.1
  folkmedicin_1_N = mkN "folkmedicin" "folkmediciner" ; -- folkmedicin..nn.1
  folkmedvetande_1_N = mkN "folkmedvetande" ; -- folkmedvetande..nn.1
  folkmelodi_1_N = mkN "folkmelodi" "folkmelodier" ; -- folkmelodi..nn.1
  folkminne_1_N = mkN "folkminne" ; -- folkminne..nn.1
  folkminskning_1_N = mkN "folkminskning" ; -- folkminskning..nn.1
  folkmord_1_N = mkN "folkmord" neutrum  ; -- folkmord..nn.1
  folkmordsåtalad_1_A = mkA "folkmordsåtalad" ; -- folkmordsåtalad..av.1
  folkmusik_1_N = mkN "folkmusik" ; -- folkmusik..nn.1
  folkmusiker_1_N = mkN "folkmusiker" "folkmusikern" "folkmusiker" "folkmusikerna" ; -- folkmusiker..nn.1
  folkmängd_1_N = mkN "folkmängd" "folkmängder" ; -- folkmängd..nn.1
  folkmål_1_N = mkN "folkmål" neutrum  ; -- folkmål..nn.1
  folkmöte_1_N = mkN "folkmöte" ; -- folkmöte..nn.1
  folknöje_1_N = mkN "folknöje" ; -- folknöje..nn.1
  folkomflyttning_1_N = mkN "folkomflyttning" ; -- folkomflyttning..nn.1
  folkomrösta_1_V = mkV "folkomröstar" ; -- folkomrösta..vb.1
  folkomröstande_1_N = mkN "folkomröstande" ; -- folkomröstande..nn.1
  folkomröstning_1_N = mkN "folkomröstning" ; -- folkomröstning..nn.1
  folkopinion_1_N = mkN "folkopinion" ; -- folkopinion..nn.1
  folkpark_1_N = mkN "folkpark" "folkparker" ; -- folkpark..nn.1
  folkparksorkester_1_N = mkN "folkparksorkester" ; -- folkparksorkester..nn.1
  folkparti_1_N = mkN "folkparti" "folkpartiet" "folkpartier" "folkpartierna" ; -- folkparti..nn.1
  folkpartist_1_N = mkN "folkpartist" "folkpartister" ; -- folkpartist..nn.1
  folkpartistisk_1_A = mkA "folkpartistisk" ; -- folkpartistisk..av.1
  folkpension_1_N = mkN "folkpension" ; -- folkpension..nn.1
  folkpensionär_1_N = mkN "folkpensionär" "folkpensionärer" ; -- folkpensionär..nn.1
  folkpoesi_1_N = mkN "folkpoesi" ; -- folkpoesi..nn.1
  folkrepresentant_1_N = mkN "folkrepresentant" "folkrepresentanter" ; -- folkrepresentant..nn.1
  folkrepresentation_1_N = mkN "folkrepresentation" ; -- folkrepresentation..nn.1
  folkrepublik_1_N = mkN "folkrepublik" "folkrepubliker" ; -- folkrepublik..nn.1
  folkresning_1_N = mkN "folkresning" ; -- folkresning..nn.1
  folkrik_1_A = mkA "folkrik" ; -- folkrik..av.1
  folkrikhet_1_N = mkN "folkrikhet" ; -- folkrikhet..nn.1
  folkriksdag_1_N = mkN "folkriksdag" ; -- folkriksdag..nn.1
  folkrädd_1_A = mkA "folkrädd" ; -- folkrädd..av.1
  folkräkning_1_N = mkN "folkräkning" ; -- folkräkning..nn.1
  folkrätt_1_N = mkN "folkrätt" ; -- folkrätt..nn.1
  folkrättslig_1_A = mkA "folkrättslig" ; -- folkrättslig..av.1
  folkrörelse_1_N = mkN "folkrörelse" "folkrörelser" ; -- folkrörelse..nn.1
  folksaga_1_N = mkN "folksaga" ; -- folksaga..nn.1
  folksamling_1_N = mkN "folksamling" ; -- folksamling..nn.1
  folksjukdom_1_N = mkN "folksjukdom" ; -- folksjukdom..nn.1
  folkskock_1_N = mkN "folkskock" ; -- folkskock..nn.1
  folkskockning_1_N = mkN "folkskockning" ; -- folkskockning..nn.1
  folkskola_1_N = mkN "folkskola" ; -- folkskola..nn.1
  folkskolelärare_1_N = mkN "folkskolelärare" utrum  ; -- folkskolelärare..nn.1
  folkskollärare_1_N = mkN "folkskollärare" utrum  ; -- folkskollärare..nn.1
  folkskygg_1_A = mkA "folkskygg" ; -- folkskygg..av.1
  folkskygghet_1_N = mkN "folkskygghet" ; -- folkskygghet..nn.1
  folkslag_1_N = mkN "folkslag" neutrum  ; -- folkslag..nn.1
  folkspillra_1_N = mkN "folkspillra" ; -- folkspillra..nn.1
  folkspråk_1_N = mkN "folkspråk" neutrum  ; -- folkspråk..nn.1
  folkstam_1_N = mkN "folkstam" "folkstammen" "folkstammar" "folkstammarna" ; -- folkstam..nn.1
  folkstorm_1_N = mkN "folkstorm" ; -- folkstorm..nn.1
  folkstyre_1_N = mkN "folkstyre" ; -- folkstyre..nn.1
  folksägen_1_N = mkN "folksägen" "folksägenn" "folksägner" "folksägnerna" ; -- folksägen..nn.1
  folksång_1_N = mkN "folksång" "folksånger" ; -- folksång..nn.1
  folktalare_1_N = mkN "folktalare" utrum  ; -- folktalare..nn.1
  folktandvård_1_N = mkN "folktandvård" ; -- folktandvård..nn.1
  folkteater_1_N = mkN "folkteater" ; -- folkteater..nn.1
  folkting_1_N = mkN "folkting" neutrum  ; -- folkting..nn.1
  folktom_1_A = mkA "folktom" "folktomt" "folktomma" "folktomma" "folktommare" "folktommast" "folktommaste" ; -- folktom..av.1
  folktomhet_1_N = mkN "folktomhet" ; -- folktomhet..nn.1
  folkton_1_N = mkN "folkton" ; -- folkton..nn.1
  folktribun_1_N = mkN "folktribun" "folktribuner" ; -- folktribun..nn.1
  folktro_1_N = mkN "folktro" ; -- folktro..nn.1
  folkträngsel_1_N = mkN "folkträngsel" ; -- folkträngsel..nn.1
  folktät_1_A = mkA "folktät" ; -- folktät..av.1
  folktäthet_1_N = mkN "folktäthet" "folktätheter" ; -- folktäthet..nn.1
  folkundervisning_1_N = mkN "folkundervisning" ; -- folkundervisning..nn.1
  folkuniversitet_1_N = mkN "folkuniversitet" neutrum  ; -- folkuniversitet..nn.1
  folkupplaga_1_N = mkN "folkupplaga" ; -- folkupplaga..nn.1
  folkupplysning_1_N = mkN "folkupplysning" ; -- folkupplysning..nn.1
  folkuppviglare_1_N = mkN "folkuppviglare" utrum  ; -- folkuppviglare..nn.1
  folkvald_1_A = mkA "folkvald" "folkvalt" ; -- folkvald..av.1
  folkvandring_1_N = mkN "folkvandring" ; -- folkvandring..nn.1
  folkvandringstid_1_N = mkN "folkvandringstid" ; -- folkvandringstid..nn.1
  folkvett_1_N = mkN "folkvett" neutrum  ; -- folkvett..nn.1
  folkvettsexpert_1_N = mkN "folkvettsexpert" "folkvettsexperter" ; -- folkvettsexpert..nn.1
  folkvilja_1_N = mkN "folkvilja" ; -- folkvilja..nn.1
  folkvimmel_1_N = mkN "folkvimmel" neutrum  ; -- folkvimmel..nn.1
  folkvisa_1_N = mkN "folkvisa" ; -- folkvisa..nn.1
  folkviseton_1_N = mkN "folkviseton" "folkvisetoner" ; -- folkviseton..nn.1
  folkvälde_1_N = mkN "folkvälde" ; -- folkvälde..nn.1
  folkvän_1_N = mkN "folkvän" "folkvännen" "folkvänner" "folkvännerna" ; -- folkvän..nn.1
  folkökning_1_N = mkN "folkökning" ; -- folkökning..nn.1
  folköl_1_N = mkN "folköl" neutrum  ; -- folköl..nn.1
  folle_1_N = mkN "folle" utrum  ; -- folle..nn.1
  follikel_1_N = mkN "follikel" ; -- follikel..nn.1
  follikelstimulerande_1_A = mkA "follikelstimulerande" ; -- follikelstimulerande..av.1
  fon_1_N = mkN "fon" "foner" ; -- fon..nn.1
  fond_1_N = mkN "fond" "fonder" ; -- fond..nn.1
  fond_2_N = mkN "fond" "fonder" ; -- fond..nn.2
  fondaktie_1_N = mkN "fondaktie" "fondaktier" ; -- fondaktie..nn.1
  fondbestämmelse_1_N = mkN "fondbestämmelse" "fondbestämmelser" ; -- fondbestämmelse..nn.1
  fondbolag_1_N = mkN "fondbolag" neutrum  ; -- fondbolag..nn.1
  fondbörs_1_N = mkN "fondbörs" "fondbörser" ; -- fondbörs..nn.1
  fondemission_1_N = mkN "fondemission" ; -- fondemission..nn.1
  fondera_1_V = mkV "fonderar" ; -- fondera..vb.1
  fonderande_1_N = mkN "fonderande" ; -- fonderande..nn.1
  fonderbar_1_A = mkA "fonderbar" ; -- fonderbar..av.1
  fonderbarhet_1_N = mkN "fonderbarhet" ; -- fonderbarhet..nn.1
  fondering_1_N = mkN "fondering" ; -- fondering..nn.1
  fondkommissionär_1_N = mkN "fondkommissionär" "fondkommissionärer" ; -- fondkommissionär..nn.1
  fondmäklarbransch_1_N = mkN "fondmäklarbransch" ; -- fondmäklarbransch..nn.1
  fondmäklare_1_N = mkN "fondmäklare" utrum  ; -- fondmäklare..nn.1
  fondmäklarfirma_1_N = mkN "fondmäklarfirma" ; -- fondmäklarfirma..nn.1
  fondmäkleri_1_N = mkN "fondmäkleri" neutrum  ; -- fondmäkleri..nn.1
  fondmålning_1_N = mkN "fondmålning" ; -- fondmålning..nn.1
  fondpapper_1_N = mkN "fondpapper" neutrum  ; -- fondpapper..nn.1
  fondstämpel_1_N = mkN "fondstämpel" ; -- fondstämpel..nn.1
  fondtapet_1_N = mkN "fondtapet" "fondtapeter" ; -- fondtapet..nn.1
  fondue_1_N = mkN "fondue" "fonduer" ; -- fondue..nn.1
  fondy_1_N = mkN "fondy" "fondyer" ; -- fondy..nn.1
  fonem_1_N = mkN "fonem" neutrum  ; -- fonem..nn.1
  fonematisk_1_A = mkA "fonematisk" ; -- fonematisk..av.1
  fonetik_1_N = mkN "fonetik" ; -- fonetik..nn.1
  fonetiker_1_N = mkN "fonetiker" "fonetikern" "fonetiker" "fonetikerna" ; -- fonetiker..nn.1
  fonetisk_1_A = mkA "fonetisk" ; -- fonetisk..av.1
  foniater_1_N = mkN "foniater" "foniatern" "foniatrer" "foniatrerna" ; -- foniater..nn.1
  foniatri_1_N = mkN "foniatri" ; -- foniatri..nn.1
  foniatrik_1_N = mkN "foniatrik" ; -- foniatrik..nn.1
  foniatriker_1_N = mkN "foniatriker" "foniatrikern" "foniatriker" "foniatrikerna" ; -- foniatriker..nn.1
  foniatrisk_1_A = mkA "foniatrisk" ; -- foniatrisk..av.1
  fonograf_1_N = mkN "fonograf" "fonografer" ; -- fonograf..nn.1
  fonogram_1_N = mkN "fonogram" "fonogrammet" "fonogram" "fonogrammen" ; -- fonogram..nn.1
  fonolog_1_N = mkN "fonolog" "fonologer" ; -- fonolog..nn.1
  fonologi_1_N = mkN "fonologi" ; -- fonologi..nn.1
  fonologisk_1_A = mkA "fonologisk" ; -- fonologisk..av.1
  fonotek_1_N = mkN "fonotek" neutrum  ; -- fonotek..nn.1
  font_1_N = mkN "font" "fonter" ; -- font..nn.1
  fontanell_1_N = mkN "fontanell" "fontaneller" ; -- fontanell..nn.1
  fontän_1_N = mkN "fontän" "fontäner" ; -- fontän..nn.1
  fontänkräkning_1_N = mkN "fontänkräkning" ; -- fontänkräkning..nn.1
  fontänpump_1_N = mkN "fontänpump" ; -- fontänpump..nn.1
  foppatoffel_1_N = mkN "foppatoffla" ; -- foppatoffel..nn.1
  fora_1_N = mkN "fora" ; -- fora..nn.1
  forcera_1_V = mkV "forcerar" ; -- forcera..vb.1
  forcerad_1_A = mkA "forcerad" ; -- forcerad..av.1
  forcerande_1_N = mkN "forcerande" ; -- forcerande..nn.1
  forcerbar_1_A = mkA "forcerbar" ; -- forcerbar..av.1
  forcerbarhet_1_N = mkN "forcerbarhet" ; -- forcerbarhet..nn.1
  forcering_1_N = mkN "forcering" ; -- forcering..nn.1
  fordomdags_1_Adv = mkAdv "fordomdags" ; -- fordomdags..ab.1
  fordon_1_N = mkN "fordon" neutrum  ; -- fordon..nn.1
  fordonskolonn_1_N = mkN "fordonskolonn" "fordonskolonner" ; -- fordonskolonn..nn.1
  fordonsuppställning_1_N = mkN "fordonsuppställning" ; -- fordonsuppställning..nn.1
  fordonsvikt_1_N = mkN "fordonsvikt" "fordonsvikter" ; -- fordonsvikt..nn.1
  fordra_1_V = mkV "fordrar" ; -- fordra..vb.1
  fordran_1_N = mkN "fordran" "fordran" "fordringar" "fordringarna" ; -- fordran..nn.1
  fordrande_1_A = mkA "fordrande" ; -- fordrande..av.1
  fordrande_1_N = mkN "fordrande" ; -- fordrande..nn.1
  fordring_1_N = mkN "fordring" ; -- fordring..nn.1
  fordringsfull_1_A = mkA "fordringsfull" ; -- fordringsfull..av.1
  fordringsfullhet_1_N = mkN "fordringsfullhet" ; -- fordringsfullhet..nn.1
  fordringslös_1_A = mkA "fordringslös" ; -- fordringslös..av.1
  fordringsägare_1_N = mkN "fordringsägare" utrum  ; -- fordringsägare..nn.1
  fordskrälle_1_N = mkN "fordskrälle" ; -- fordskrälle..nn.1
  forechecka_1_V = mkV "forecheckar" ; -- forechecka..vb.1
  forecheckande_1_N = mkN "forecheckande" ; -- forecheckande..nn.1
  forehand_1_N = mkN "forehand" ; -- forehand..nn.1
  forell_1_N = mkN "forell" "foreller" ; -- forell..nn.1
  forensisk_1_A = mkA "forensisk" ; -- forensisk..av.1
  form_1_N = mkN "form" ; -- form..nn.1
  form_2_N = mkN "form" "former" ; -- form..nn.2
  form_3_N = mkN "form" ; -- form..nn.3
  forma_1_V = mkV "formar" ; -- forma..vb.1
  formaldehyd_1_N = mkN "formaldehyd" "formaldehyder" ; -- formaldehyd..nn.1
  formalia_1_N = mkN "formalia" "formaliat" "formalia" "formaliana" ; -- formalia..nn.1
  formalin_1_N = mkN "formalin" ; -- formalin..nn.1
  formalisera_1_V = mkV "formaliserar" ; -- formalisera..vb.1
  formaliserande_1_N = mkN "formaliserande" ; -- formaliserande..nn.1
  formaliserbar_1_A = mkA "formaliserbar" ; -- formaliserbar..av.1
  formaliserbarhet_1_N = mkN "formaliserbarhet" ; -- formaliserbarhet..nn.1
  formalisering_1_N = mkN "formalisering" ; -- formalisering..nn.1
  formalism_1_N = mkN "formalism" "formalismer" ; -- formalism..nn.1
  formalist_1_N = mkN "formalist" "formalister" ; -- formalist..nn.1
  formalistisk_1_A = mkA "formalistisk" ; -- formalistisk..av.1
  formalitet_1_N = mkN "formalitet" "formaliteter" ; -- formalitet..nn.1
  formande_1_N = mkN "formande" ; -- formande..nn.1
  formant_1_N = mkN "formant" "formanter" ; -- formant..nn.1
  formare_1_N = mkN "formare" utrum  ; -- formare..nn.1
  format_1_N = mkN "format" neutrum  ; -- format..nn.1
  formatera_1_V = mkV "formaterar" ; -- formatera..vb.1
  formaterande_1_N = mkN "formaterande" ; -- formaterande..nn.1
  formatering_1_N = mkN "formatering" ; -- formatering..nn.1
  formation_1_N = mkN "formation" ; -- formation..nn.1
  formatspecifikation_1_N = mkN "formatspecifikation" ; -- formatspecifikation..nn.1
  formbakelse_1_N = mkN "formbakelse" "formbakelser" ; -- formbakelse..nn.1
  formbar_1_A = mkA "formbar" ; -- formbar..av.1
  formbarhet_1_N = mkN "formbarhet" ; -- formbarhet..nn.1
  formbildning_1_N = mkN "formbildning" ; -- formbildning..nn.1
  formbildningsproblem_1_N = mkN "formbildningsproblem" neutrum  ; -- formbildningsproblem..nn.1
  formbröd_1_N = mkN "formbröd" neutrum  ; -- formbröd..nn.1
  formbunden_1_A = mkA "formbunden" ; -- formbunden..av.1
  formbundenhet_1_N = mkN "formbundenhet" ; -- formbundenhet..nn.1
  formel_1_N = mkN "formel" "formeln" "formler" "formlerna" ; -- formel..nn.1
  formelbil_1_N = mkN "formelbil" ; -- formelbil..nn.1
  formelenhet_1_N = mkN "formelenhet" "formelenheter" ; -- formelenhet..nn.1
  formell_1_A = mkA "formell" ; -- formell..av.1
  formera_1_V = mkV "formerar" ; -- formera..vb.1
  formerande_1_N = mkN "formerande" ; -- formerande..nn.1
  formerbar_1_A = mkA "formerbar" ; -- formerbar..av.1
  formerbarhet_1_N = mkN "formerbarhet" ; -- formerbarhet..nn.1
  formering_1_N = mkN "formering" ; -- formering..nn.1
  formfaktor_1_N = mkN "formfaktor" "formfaktoren" "formfaktorer" "formfaktorerna" ; -- formfaktor..nn.1
  formfel_1_N = mkN "formfel" "formfelet" "formfel" "formfelen" ; -- formfel..nn.1
  formfranska_1_N = mkN "formfranska" ; -- formfranska..nn.1
  formfråga_1_N = mkN "formfråga" ; -- formfråga..nn.1
  formfulländad_1_A = mkA "formfulländad" ; -- formfulländad..av.1
  formfulländning_1_N = mkN "formfulländning" ; -- formfulländning..nn.1
  formge_1_V = mkV "formgiva" "formgav" "formgivit" ; -- formge..vb.1
  formgivande_1_N = mkN "formgivande" ; -- formgivande..nn.1
  formgivare_1_N = mkN "formgivare" utrum  ; -- formgivare..nn.1
  formgivning_1_N = mkN "formgivning" ; -- formgivning..nn.1
  formgjuta_1_V = mkV "formgjuta" "formgöt" "formgjutit" ; -- formgjuta..vb.1
  formgjutande_1_N = mkN "formgjutande" ; -- formgjutande..nn.1
  formgods_1_N = mkN "formgods" neutrum  ; -- formgods..nn.1
  formidabel_1_A = mkA "formidabel" ; -- formidabel..av.1
  formkurva_1_N = mkN "formkurva" ; -- formkurva..nn.1
  formlig_1_A = mkA "formlig" ; -- formlig..av.1
  formligen_1_Adv = mkAdv "formligen" ; -- formligen..ab.1
  formlighet_1_N = mkN "formlighet" ; -- formlighet..nn.1
  formlära_1_N = mkN "formlära" ; -- formlära..nn.1
  formlös_1_A = mkA "formlös" ; -- formlös..av.1
  formlöshet_1_N = mkN "formlöshet" ; -- formlöshet..nn.1
  formmässig_1_A = mkA "formmässig" ; -- formmässig..av.1
  formmässighet_1_N = mkN "formmässighet" ; -- formmässighet..nn.1
  formning_1_N = mkN "formning" ; -- formning..nn.1
  formord_1_N = mkN "formord" neutrum  ; -- formord..nn.1
  formpressa_1_V = mkV "formpressar" ; -- formpressa..vb.1
  formpressande_1_N = mkN "formpressande" ; -- formpressande..nn.1
  formpressning_1_N = mkN "formpressning" ; -- formpressning..nn.1
  formrik_1_A = mkA "formrik" ; -- formrik..av.1
  formrikedom_1_N = mkN "formrikedom" ; -- formrikedom..nn.1
  formrikhet_1_N = mkN "formrikhet" ; -- formrikhet..nn.1
  formsak_1_N = mkN "formsak" "formsaker" ; -- formsak..nn.1
  formsand_1_N = mkN "formsand" ; -- formsand..nn.1
  formsinne_1_N = mkN "formsinne" ; -- formsinne..nn.1
  formskön_1_A = mkA "formskön" ; -- formskön..av.1
  formskönhet_1_N = mkN "formskönhet" ; -- formskönhet..nn.1
  formspel_1_N = mkN "formspel" "formspelet" "formspel" "formspelen" ; -- formspel..nn.1
  formspråk_1_N = mkN "formspråk" neutrum  ; -- formspråk..nn.1
  formstark_1_A = mkA "formstark" ; -- formstark..av.1
  formstridig_1_A = mkA "formstridig" ; -- formstridig..av.1
  formsvacka_1_N = mkN "formsvacka" ; -- formsvacka..nn.1
  formula_1_N = mkN "formula" ; -- formula..nn.1
  formulera_1_V = mkV "formulerar" ; -- formulera..vb.1
  formulerande_1_N = mkN "formulerande" ; -- formulerande..nn.1
  formulerbar_1_A = mkA "formulerbar" ; -- formulerbar..av.1
  formulerbarhet_1_N = mkN "formulerbarhet" ; -- formulerbarhet..nn.1
  formulering_1_N = mkN "formulering" ; -- formulering..nn.1
  formulär_1_N = mkN "formulär" neutrum  ; -- formulär..nn.1
  formvidrig_1_A = mkA "formvidrig" ; -- formvidrig..av.1
  formvidrighet_1_N = mkN "formvidrighet" "formvidrigheter" ; -- formvidrighet..nn.1
  forn_1_A = mkA "forn" ; -- forn..av.1
  fornborg_1_N = mkN "fornborg" ; -- fornborg..nn.1
  fornegyptier_1_N = mkN "fornegyptier" "fornegyptiern" "fornegyptier" "fornegyptierna" ; -- fornegyptier..nn.1
  fornegyptisk_1_A = mkA "fornegyptisk" ; -- fornegyptisk..av.1
  fornegyptiska_1_N = mkN "fornegyptiska" ; -- fornegyptiska..nn.1
  fornfolk_1_N = mkN "fornfolk" neutrum  ; -- fornfolk..nn.1
  fornforskare_1_N = mkN "fornforskare" utrum  ; -- fornforskare..nn.1
  fornforskning_1_N = mkN "fornforskning" ; -- fornforskning..nn.1
  fornfynd_1_N = mkN "fornfynd" neutrum  ; -- fornfynd..nn.1
  forngrekisk_1_A = mkA "forngrekisk" ; -- forngrekisk..av.1
  fornhet_1_N = mkN "fornhet" ; -- fornhet..nn.1
  fornisländsk_1_A = mkA "fornisländsk" ; -- fornisländsk..av.1
  fornitaliensk_1_A = mkA "fornitaliensk" ; -- fornitaliensk..av.1
  fornkeltisk_1_A = mkA "fornkeltisk" ; -- fornkeltisk..av.1
  fornkunskap_1_N = mkN "fornkunskap" ; -- fornkunskap..nn.1
  fornlämning_1_N = mkN "fornlämning" ; -- fornlämning..nn.1
  fornminne_1_N = mkN "fornminne" ; -- fornminne..nn.1
  fornminnesbrott_1_N = mkN "fornminnesbrott" neutrum  ; -- fornminnesbrott..nn.1
  fornminnesförening_1_N = mkN "fornminnesförening" ; -- fornminnesförening..nn.1
  fornminneslag_1_N = mkN "fornminneslag" ; -- fornminneslag..nn.1
  fornminnessamling_1_N = mkN "fornminnessamling" ; -- fornminnessamling..nn.1
  fornminnesskylt_1_N = mkN "fornminnesskylt" ; -- fornminnesskylt..nn.1
  fornnordisk_1_A = mkA "fornnordisk" ; -- fornnordisk..av.1
  fornromersk_1_A = mkA "fornromersk" ; -- fornromersk..av.1
  fornsak_1_N = mkN "fornsak" "fornsaker" ; -- fornsak..nn.1
  fornskrift_1_N = mkN "fornskrift" "fornskrifter" ; -- fornskrift..nn.1
  fornspråk_1_N = mkN "fornspråk" neutrum  ; -- fornspråk..nn.1
  fornstor_1_A = mkA "fornstor" ; -- fornstor..av.1
  fornsvensk_1_A = mkA "fornsvensk" ; -- fornsvensk..av.1
  forntid_1_N = mkN "forntid" "forntider" ; -- forntid..nn.1
  forntida_1_A = mkA "forntida" ; -- forntida..av.1
  forntysk_1_A = mkA "forntysk" ; -- forntysk..av.1
  fornvästnordisk_1_A = mkA "fornvästnordisk" ; -- fornvästnordisk..av.1
  fornyrdislag_1_N = mkN "fornyrdislag" neutrum  ; -- fornyrdislag..nn.1
  fors_1_N = mkN "fors" ; -- fors..nn.1
  forsa_1_V = mkV "forsar" ; -- forsa..vb.1
  forsande_1_N = mkN "forsande" ; -- forsande..nn.1
  forsbåt_1_N = mkN "forsbåt" ; -- forsbåt..nn.1
  forsfärd_1_N = mkN "forsfärd" "forsfärder" ; -- forsfärd..nn.1
  forshuvud_1_N = mkN "forshuvud" "forshuvudet" "forshuvud" "forshuvudena" ; -- forshuvud..nn.1
  forska_1_V = mkV "forskar" ; -- forska..vb.1
  forskande_1_N = mkN "forskande" ; -- forskande..nn.1
  forskarassistent_1_N = mkN "forskarassistent" "forskarassistenter" ; -- forskarassistent..nn.1
  forskare_1_N = mkN "forskare" utrum  ; -- forskare..nn.1
  forskargrupp_1_N = mkN "forskargrupp" "forskargrupper" ; -- forskargrupp..nn.1
  forskarkonspiration_1_N = mkN "forskarkonspiration" ; -- forskarkonspiration..nn.1
  forskarlag_1_N = mkN "forskarlag" neutrum  ; -- forskarlag..nn.1
  forskarledighet_1_N = mkN "forskarledighet" "forskarledigheter" ; -- forskarledighet..nn.1
  forskarmässig_1_A = mkA "forskarmässig" ; -- forskarmässig..av.1
  forskarutbildning_1_N = mkN "forskarutbildning" ; -- forskarutbildning..nn.1
  forskarvärld_1_N = mkN "forskarvärld" ; -- forskarvärld..nn.1
  forskning_1_N = mkN "forskning" ; -- forskning..nn.1
  forskningsarbete_1_N = mkN "forskningsarbete" ; -- forskningsarbete..nn.1
  forskningsbibliotek_1_N = mkN "forskningsbibliotek" neutrum  ; -- forskningsbibliotek..nn.1
  forskningscenter_1_N = mkN "forskningscenter" "forskningscentret" "forskningscentrer" "forskningscentrerna" ; -- forskningscenter..nn.1
  forskningsetik_1_N = mkN "forskningsetik" ; -- forskningsetik..nn.1
  forskningsetisk_1_A = mkA "forskningsetisk" ; -- forskningsetisk..av.1
  forskningsfartyg_1_N = mkN "forskningsfartyg" neutrum  ; -- forskningsfartyg..nn.1
  forskningsfinansiering_1_N = mkN "forskningsfinansiering" ; -- forskningsfinansiering..nn.1
  forskningsforskningsstödjande_1_A = mkA "forskningsforskningsstödjande" ; -- forskningsforskningsstödjande..av.1
  forskningsframsteg_1_N = mkN "forskningsframsteg" neutrum  ; -- forskningsframsteg..nn.1
  forskningsfusk_1_N = mkN "forskningsfusk" neutrum  ; -- forskningsfusk..nn.1
  forskningsfält_1_N = mkN "forskningsfält" neutrum  ; -- forskningsfält..nn.1
  forskningsfärd_1_N = mkN "forskningsfärd" "forskningsfärder" ; -- forskningsfärd..nn.1
  forskningsfäste_1_N = mkN "forskningsfäste" ; -- forskningsfäste..nn.1
  forskningsingenjör_1_N = mkN "forskningsingenjör" "forskningsingenjörer" ; -- forskningsingenjör..nn.1
  forskningsinriktning_1_N = mkN "forskningsinriktning" ; -- forskningsinriktning..nn.1
  forskningsinsats_1_N = mkN "forskningsinsats" "forskningsinsatser" ; -- forskningsinsats..nn.1
  forskningsinstitut_1_N = mkN "forskningsinstitut" neutrum  ; -- forskningsinstitut..nn.1
  forskningskompetens_1_N = mkN "forskningskompetens" "forskningskompetenser" ; -- forskningskompetens..nn.1
  forskningskvalitet_1_N = mkN "forskningskvalitet" ; -- forskningskvalitet..nn.1
  forskningslaboratorium_1_N = mkN "forskningslaboratorium" "forskningslaboratoriet" "forskningslaboratorier" "forskningslaboratorierna" ; -- forskningslaboratorium..nn.1
  forskningsmetodik_1_N = mkN "forskningsmetodik" "forskningsmetodiker" ; -- forskningsmetodik..nn.1
  forskningsmiljö_1_N = mkN "forskningsmiljö" "forskningsmiljön" "forskningsmiljöer" "forskningsmiljöerna" ; -- forskningsmiljö..nn.1
  forskningsmässig_1_A = mkA "forskningsmässig" ; -- forskningsmässig..av.1
  forskningsområde_1_N = mkN "forskningsområde" ; -- forskningsområde..nn.1
  forskningsorganisation_1_N = mkN "forskningsorganisation" ; -- forskningsorganisation..nn.1
  forskningspolitik_1_N = mkN "forskningspolitik" ; -- forskningspolitik..nn.1
  forskningspolitisk_1_A = mkA "forskningspolitisk" ; -- forskningspolitisk..av.1
  forskningsprocess_1_N = mkN "forskningsprocess" "forskningsprocesser" ; -- forskningsprocess..nn.1
  forskningsprogram_1_N = mkN "forskningsprogram" "forskningsprogrammet" "forskningsprogram" "forskningsprogrammen" ; -- forskningsprogram..nn.1
  forskningsprojekt_1_N = mkN "forskningsprojekt" neutrum  ; -- forskningsprojekt..nn.1
  forskningsproposition_1_N = mkN "forskningsproposition" ; -- forskningsproposition..nn.1
  forskningsresa_1_N = mkN "forskningsresa" ; -- forskningsresa..nn.1
  forskningsresande_1_N = mkN "forskningsresande" "forskningsresanden" "forskningsresanden" "forskningsresandena" ; -- forskningsresande..nn.1
  forskningsresultat_1_N = mkN "forskningsresultat" neutrum  ; -- forskningsresultat..nn.1
  forskningsråd_1_N = mkN "forskningsråd" neutrum  ; -- forskningsråd..nn.1
  forskningsrön_1_N = mkN "forskningsrön" neutrum  ; -- forskningsrön..nn.1
  forskningssatellit_1_N = mkN "forskningssatellit" "forskningssatelliter" ; -- forskningssatellit..nn.1
  forskningsstation_1_N = mkN "forskningsstation" ; -- forskningsstation..nn.1
  forskningssyfte_1_N = mkN "forskningssyfte" ; -- forskningssyfte..nn.1
  forsla_1_V = mkV "forslar" ; -- forsla..vb.1
  forslande_1_N = mkN "forslande" ; -- forslande..nn.1
  forsling_1_N = mkN "forsling" ; -- forsling..nn.1
  forsränning_1_N = mkN "forsränning" ; -- forsränning..nn.1
  forstväsen_1_N = mkN "forstväsen" neutrum  ; -- forstväsen..nn.1
  forsythia_1_N = mkN "forsythia" ; -- forsythia..nn.1
  forsärla_1_N = mkN "forsärla" ; -- forsärla..nn.1
  fort_1_Adv = mkAdv "fort" ; -- fort..ab.1
  fort_1_N = mkN "fort" neutrum  ; -- fort..nn.1
  fortbestå_1_V = mkV "fortbestå" "fortbestod" "fortbestått" ; -- fortbestå..vb.1
  fortbestående_1_N = mkN "fortbestående" ; -- fortbestående..nn.1
  fortbestånd_1_N = mkN "fortbestånd" neutrum  ; -- fortbestånd..nn.1
  fortbildning_1_N = mkN "fortbildning" ; -- fortbildning..nn.1
  fortbildningskurs_1_N = mkN "fortbildningskurs" "fortbildningskurser" ; -- fortbildningskurs..nn.1
  forte_1_N = mkN "forte" ; -- forte..nn.1
  fortel_1_N = mkN "fortel" ; -- fortel..nn.1
  fortepiano_1_N = mkN "fortepiano" "fortepianot" "fortepianon" "fortepianona" ; -- fortepiano..nn.1
  fortfara_1_V = mkV "fortfara" "fortfor" "fortfarit" ; -- fortfara..vb.1
  fortfarande_1_Adv = mkAdv "fortfarande" ; -- fortfarande..ab.1
  fortfarande_1_N = mkN "fortfarande" ; -- fortfarande..nn.1
  fortfärdig_1_A = mkA "fortfärdig" ; -- fortfärdig..av.1
  fortfärdighet_1_N = mkN "fortfärdighet" ; -- fortfärdighet..nn.1
  fortgå_1_V = mkV "fortgå" "fortgick" "fortgått" ; -- fortgå..vb.1
  fortgående_1_A = mkA "fortgående" ; -- fortgående..av.1
  fortgående_1_N = mkN "fortgående" ; -- fortgående..nn.1
  fortgång_1_N = mkN "fortgång" ; -- fortgång..nn.1
  fortifikation_1_N = mkN "fortifikation" ; -- fortifikation..nn.1
  fortifikationsförvaltning_1_N = mkN "fortifikationsförvaltning" ; -- fortifikationsförvaltning..nn.1
  fortifikationskår_1_N = mkN "fortifikationskår" "fortifikationskårer" ; -- fortifikationskår..nn.1
  fortis_1_A = mkA "fortis" ; -- fortis..av.1
  fortissimo_1_N = mkN "fortissimo" "fortissimot" "fortissimon" "fortissimona" ; -- fortissimo..nn.1
  fortkomst_1_N = mkN "fortkomst" "fortkomster" ; -- fortkomst..nn.1
  fortköra_1_V = mkV "fortköra" "fortkörde" "fortkört" ; -- fortköra..vb.1
  fortkörande_1_N = mkN "fortkörande" ; -- fortkörande..nn.1
  fortkörare_1_N = mkN "fortkörare" utrum  ; -- fortkörare..nn.1
  fortkörning_1_N = mkN "fortkörning" ; -- fortkörning..nn.1
  fortleva_1_V = mkV "fortlever" ; -- fortleva..vb.1
  fortlevande_1_N = mkN "fortlevande" ; -- fortlevande..nn.1
  fortlöpa_1_V = mkV "fortlöper" ; -- fortlöpa..vb.1
  fortlöpande_1_A = mkA "fortlöpande" ; -- fortlöpande..av.1
  fortlöpande_1_N = mkN "fortlöpande" ; -- fortlöpande..nn.1
  fortplantning_1_N = mkN "fortplantning" ; -- fortplantning..nn.1
  fortplantningsdrift_1_N = mkN "fortplantningsdrift" "fortplantningsdrifter" ; -- fortplantningsdrift..nn.1
  fortplantningsförmåga_1_N = mkN "fortplantningsförmåga" ; -- fortplantningsförmåga..nn.1
  fortplantningshastighet_1_N = mkN "fortplantningshastighet" ; -- fortplantningshastighet..nn.1
  fortplantningsmässig_1_A = mkA "fortplantningsmässig" ; -- fortplantningsmässig..av.1
  fortplantningsområde_1_N = mkN "fortplantningsområde" ; -- fortplantningsområde..nn.1
  fortplantningsorgan_1_N = mkN "fortplantningsorgan" neutrum  ; -- fortplantningsorgan..nn.1
  fortran_1_N = mkN "fortran" ; -- fortran..nn.1
  fortsatt_1_Adv = mkAdv "fortsatt" ; -- fortsatt..ab.1
  fortskaffa_1_V = mkV "fortskaffar" ; -- fortskaffa..vb.1
  fortskaffande_1_N = mkN "fortskaffande" ; -- fortskaffande..nn.1
  fortskaffning_1_N = mkN "fortskaffning" ; -- fortskaffning..nn.1
  fortskaffningsmedel_1_N = mkN "fortskaffningsmedel" neutrum  ; -- fortskaffningsmedel..nn.1
  fortskaffningssätt_1_N = mkN "fortskaffningssätt" neutrum  ; -- fortskaffningssätt..nn.1
  fortskrida_1_V = mkV "fortskrida" "fortskred" "fortskridit" ; -- fortskrida..vb.1
  fortskridande_1_N = mkN "fortskridande" ; -- fortskridande..nn.1
  fortskridning_1_N = mkN "fortskridning" ; -- fortskridning..nn.1
  fortsätta_1_V = mkV "fortsätta" "fortsätter" "fortsätt" "fortsatte" "fortsatt" "fortsatt" ; -- fortsätta..vb.1
  fortsättande_1_N = mkN "fortsättande" ; -- fortsättande..nn.1
  fortsättare_1_N = mkN "fortsättare" utrum  ; -- fortsättare..nn.1
  fortsättning_1_N = mkN "fortsättning" ; -- fortsättning..nn.1
  fortsättningskrig_1_N = mkN "fortsättningskrig" neutrum  ; -- fortsättningskrig..nn.1
  fortsättningsskola_1_N = mkN "fortsättningsskola" ; -- fortsättningsskola..nn.1
  fortsättningsvis_1_Adv = mkAdv "fortsättningsvis" ; -- fortsättningsvis..ab.1
  fortuna_1_N = mkN "fortuna" ; -- fortuna..nn.1
  fortvara_1_V = mkV "fortvarar" ; -- fortvara..vb.1
  fortvarande_1_A = mkA "fortvarande" ; -- fortvarande..av.1
  fortvaro_1_N = mkN "fortvaro" ; -- fortvaro..nn.1
  forum_1_N = mkN "forum" neutrum  ; -- forum..nn.1
  forumtidning_1_N = mkN "forumtidning" ; -- forumtidning..nn.1
  forward_1_N = mkN "forward" ; -- forward..nn.1
  fosfat_1_N = mkN "fosfat" neutrum  ; -- fosfat..nn.1
  fosfatera_1_V = mkV "fosfaterar" ; -- fosfatera..vb.1
  fosfaterande_1_N = mkN "fosfaterande" ; -- fosfaterande..nn.1
  fosfaterbar_1_A = mkA "fosfaterbar" ; -- fosfaterbar..av.1
  fosfaterbarhet_1_N = mkN "fosfaterbarhet" ; -- fosfaterbarhet..nn.1
  fosfatering_1_N = mkN "fosfatering" ; -- fosfatering..nn.1
  fosforescens_1_N = mkN "fosforescens" ; -- fosforescens..nn.1
  fosforescent_1_A = mkA "fosforescent" "fosforescent" ; -- fosforescent..av.1
  fosforescera_1_V = mkV "fosforescerar" ; -- fosforescera..vb.1
  fosforescerande_1_N = mkN "fosforescerande" ; -- fosforescerande..nn.1
  fosforescering_1_N = mkN "fosforescering" ; -- fosforescering..nn.1
  fosforit_1_N = mkN "fosforit" "fosforiter" ; -- fosforit..nn.1
  fosforsyra_1_N = mkN "fosforsyra" ; -- fosforsyra..nn.1
  fosforsyracell_1_N = mkN "fosforsyracell" "fosforsyraceller" ; -- fosforsyracell..nn.1
  fosforutsläpp_1_N = mkN "fosforutsläpp" neutrum  ; -- fosforutsläpp..nn.1
  fossil_1_A = mkA "fossil" ; -- fossil..av.1
  fossil_1_N = mkN "fossil" neutrum  ; -- fossil..nn.1
  fossilbransch_1_N = mkN "fossilbransch" ; -- fossilbransch..nn.1
  fossilbränsle_1_N = mkN "fossilbränsle" ; -- fossilbränsle..nn.1
  fossilfri_1_A = mkA "fossilfri" "fossilfritt" ; -- fossilfri..av.1
  fossilfynd_1_N = mkN "fossilfynd" neutrum  ; -- fossilfynd..nn.1
  fossilförsäljning_1_N = mkN "fossilförsäljning" ; -- fossilförsäljning..nn.1
  fossilgas_1_N = mkN "fossilgas" ; -- fossilgas..nn.1
  fossilgasledning_1_N = mkN "fossilgasledning" ; -- fossilgasledning..nn.1
  fossilgasnät_1_N = mkN "fossilgasnät" neutrum  ; -- fossilgasnät..nn.1
  fossilisation_1_N = mkN "fossilisation" ; -- fossilisation..nn.1
  fossilisera_1_V = mkV "fossiliserar" ; -- fossilisera..vb.1
  fossiliserande_1_N = mkN "fossiliserande" ; -- fossiliserande..nn.1
  fossiliserbar_1_A = mkA "fossiliserbar" ; -- fossiliserbar..av.1
  fossiliserbarhet_1_N = mkN "fossiliserbarhet" ; -- fossiliserbarhet..nn.1
  fossilisering_1_N = mkN "fossilisering" ; -- fossilisering..nn.1
  fossiljägare_1_N = mkN "fossiljägare" utrum  ; -- fossiljägare..nn.1
  fossilletande_1_N = mkN "fossilletande" ; -- fossilletande..nn.1
  fossilletare_1_N = mkN "fossilletare" utrum  ; -- fossilletare..nn.1
  fossilletarexpedition_1_N = mkN "fossilletarexpedition" ; -- fossilletarexpedition..nn.1
  fossilminskning_1_N = mkN "fossilminskning" ; -- fossilminskning..nn.1
  fossilsamling_1_N = mkN "fossilsamling" ; -- fossilsamling..nn.1
  fossing_1_N = mkN "fossing" ; -- fossing..nn.1
  fostbrödralag_1_N = mkN "fostbrödralag" neutrum  ; -- fostbrödralag..nn.1
  foster_1_N = mkN "foster" neutrum  ; -- foster..nn.1
  fosterbarn_1_N = mkN "fosterbarn" neutrum  ; -- fosterbarn..nn.1
  fosterbror_1_N = mkN "fosterbror" "fosterbröder" ; -- fosterbror..nn.1
  fosterdotter_1_N = mkN "fosterdotter" "fosterdottern" "fosterdöttrar" "fosterdöttrarna" ; -- fosterdotter..nn.1
  fosterfamilj_1_N = mkN "fosterfamilj" "fosterfamiljer" ; -- fosterfamilj..nn.1
  fosterfar_1_N = mkN "fosterfader" "fosterfadern" "fosterfäder" "fosterfäderna" ; -- fosterfar..nn.1
  fosterfördrivning_1_N = mkN "fosterfördrivning" ; -- fosterfördrivning..nn.1
  fosterförälder_1_N = mkN "fosterförälder" ; -- fosterförälder..nn.1
  fosterhem_1_N = mkN "fosterhem" "fosterhemmet" "fosterhem" "fosterhemmen" ; -- fosterhem..nn.1
  fosterhinna_1_N = mkN "fosterhinna" ; -- fosterhinna..nn.1
  fosterjord_1_N = mkN "fosterjord" ; -- fosterjord..nn.1
  fosterland_1_N = mkN "fosterland" "fosterlandet" "fosterländer" "fosterländerna" ; -- fosterland..nn.1
  fosterlandsförrädare_1_N = mkN "fosterlandsförrädare" utrum  ; -- fosterlandsförrädare..nn.1
  fosterlandsförsvarare_1_N = mkN "fosterlandsförsvarare" utrum  ; -- fosterlandsförsvarare..nn.1
  fosterlandskärlek_1_N = mkN "fosterlandskärlek" ; -- fosterlandskärlek..nn.1
  fosterlandssinnad_1_A = mkA "fosterlandssinnad" ; -- fosterlandssinnad..av.1
  fosterlandsvän_1_N = mkN "fosterlandsvän" "fosterlandsvännen" "fosterlandsvänner" "fosterlandsvännerna" ; -- fosterlandsvän..nn.1
  fosterlandsälskande_1_A = mkA "fosterlandsälskande" ; -- fosterlandsälskande..av.1
  fosterljud_1_N = mkN "fosterljud" neutrum  ; -- fosterljud..nn.1
  fosterläge_1_N = mkN "fosterläge" ; -- fosterläge..nn.1
  fosterländsk_1_A = mkA "fosterländsk" ; -- fosterländsk..av.1
  fosterländskhet_1_N = mkN "fosterländskhet" ; -- fosterländskhet..nn.1
  fostermor_1_N = mkN "fostermor" "fostermodern" "fostermödrar" "fostermödrarna" ; -- fostermor..nn.1
  fosterskada_1_N = mkN "fosterskada" ; -- fosterskada..nn.1
  fosterson_1_N = mkN "fosterson" "fostersöner" ; -- fosterson..nn.1
  fosterställning_1_N = mkN "fosterställning" ; -- fosterställning..nn.1
  fostersyskon_1_N = mkN "fostersyskon" neutrum  ; -- fostersyskon..nn.1
  fostersyster_1_N = mkN "fostersyster" ; -- fostersyster..nn.1
  fostertest_1_N = mkN "fostertest" neutrum  ; -- fostertest..nn.1
  fosterutveckling_1_N = mkN "fosterutveckling" ; -- fosterutveckling..nn.1
  fostervatten_1_N = mkN "fostervatten" "fostervattnet" "fostervatten" "fostervattnen" ; -- fostervatten..nn.1
  fostra_1_V = mkV "fostrar" ; -- fostra..vb.1
  fostrande_1_N = mkN "fostrande" ; -- fostrande..nn.1
  fostrare_1_N = mkN "fostrare" utrum  ; -- fostrare..nn.1
  fot_1_N = mkN "fot" "fötter" ; -- fot..nn.1
  fot_2_N = mkN "fot" "foten" "fot" "foten" ; -- fot..nn.2
  fota_1_V = mkV "fotar" ; -- fota..vb.1
  fotabjälle_1_N = mkN "fotabjälle" ; -- fotabjälle..nn.1
  fotande_1_N = mkN "fotande" ; -- fotande..nn.1
  fotangel_1_N = mkN "fotangel" ; -- fotangel..nn.1
  fotarbete_1_N = mkN "fotarbete" ; -- fotarbete..nn.1
  fotavtryck_1_N = mkN "fotavtryck" neutrum  ; -- fotavtryck..nn.1
  fotbad_1_N = mkN "fotbad" neutrum  ; -- fotbad..nn.1
  fotbeklädnad_1_N = mkN "fotbeklädnad" "fotbeklädnader" ; -- fotbeklädnad..nn.1
  fotbjudning_1_N = mkN "fotbjudning" ; -- fotbjudning..nn.1
  fotblad_1_N = mkN "fotblad" neutrum  ; -- fotblad..nn.1
  fotboja_1_N = mkN "fotboja" ; -- fotboja..nn.1
  fotboll_1_N = mkN "fotboll" ; -- fotboll..nn.1
  fotboll_2_N = mkN "fotboll" ; -- fotboll..nn.2
  fotbollförbund_1_N = mkN "fotbollförbund" neutrum  ; -- fotbollförbund..nn.1
  fotbollsarena_1_N = mkN "fotbollsarena" ; -- fotbollsarena..nn.1
  fotbollsbråk_1_N = mkN "fotbollsbråk" neutrum  ; -- fotbollsbråk..nn.1
  fotbollsdomare_1_N = mkN "fotbollsdomare" utrum  ; -- fotbollsdomare..nn.1
  fotbollsdominerad_1_A = mkA "fotbollsdominerad" ; -- fotbollsdominerad..av.1
  fotbollsexpert_1_N = mkN "fotbollsexpert" "fotbollsexperter" ; -- fotbollsexpert..nn.1
  fotbollsfeber_1_N = mkN "fotbollsfeber" ; -- fotbollsfeber..nn.1
  fotbollsförbund_1_N = mkN "fotbollsförbund" neutrum  ; -- fotbollsförbund..nn.1
  fotbollshuligan_1_N = mkN "fotbollshuligan" "fotbollshuliganer" ; -- fotbollshuligan..nn.1
  fotbollskedja_1_N = mkN "fotbollskedja" ; -- fotbollskedja..nn.1
  fotbollskrig_1_N = mkN "fotbollskrig" neutrum  ; -- fotbollskrig..nn.1
  fotbollslag_1_N = mkN "fotbollslag" neutrum  ; -- fotbollslag..nn.1
  fotbollslandslag_1_N = mkN "fotbollslandslag" neutrum  ; -- fotbollslandslag..nn.1
  fotbollsledare_1_N = mkN "fotbollsledare" utrum  ; -- fotbollsledare..nn.1
  fotbollsläktare_1_N = mkN "fotbollsläktare" utrum  ; -- fotbollsläktare..nn.1
  fotbollsmatch_1_N = mkN "fotbollsmatch" "fotbollsmatcher" ; -- fotbollsmatch..nn.1
  fotbollsmässig_1_A = mkA "fotbollsmässig" ; -- fotbollsmässig..av.1
  fotbollsmål_1_N = mkN "fotbollsmål" neutrum  ; -- fotbollsmål..nn.1
  fotbollsplan_1_N = mkN "fotbollsplan" "fotbollsplaner" ; -- fotbollsplan..nn.1
  fotbollsspelande_1_A = mkA "fotbollsspelande" ; -- fotbollsspelande..av.1
  fotbollsspelande_1_N = mkN "fotbollsspelande" ; -- fotbollsspelande..nn.1
  fotbollsspelare_1_N = mkN "fotbollsspelare" utrum  ; -- fotbollsspelare..nn.1
  fotbollsstadion_1_N = mkN "fotbollsstadion" neutrum  ; -- fotbollsstadion..nn.1
  fotbollsstjärna_1_N = mkN "fotbollsstjärna" ; -- fotbollsstjärna..nn.1
  fotbollstips_1_N = mkN "fotbollstips" neutrum  ; -- fotbollstips..nn.1
  fotbollstokig_1_A = mkA "fotbollstokig" ; -- fotbollstokig..av.1
  fotbollstränare_1_N = mkN "fotbollstränare" utrum  ; -- fotbollstränare..nn.1
  fotbollsturnering_1_N = mkN "fotbollsturnering" ; -- fotbollsturnering..nn.1
  fotbollstuta_1_N = mkN "fotbollstuta" ; -- fotbollstuta..nn.1
  fotbollsvärld_1_N = mkN "fotbollsvärld" ; -- fotbollsvärld..nn.1
  fotbroms_1_N = mkN "fotbroms" ; -- fotbroms..nn.1
  fotfel_1_N = mkN "fotfel" "fotfelet" "fotfel" "fotfelen" ; -- fotfel..nn.1
  fotfolk_1_N = mkN "fotfolk" neutrum  ; -- fotfolk..nn.1
  fotfäste_1_N = mkN "fotfäste" ; -- fotfäste..nn.1
  fotgängare_1_N = mkN "fotgängare" utrum  ; -- fotgängare..nn.1
  fotino_1_N = mkN "fotino" "fotinor" ; -- fotino..nn.1
  fotknöl_1_N = mkN "fotknöl" ; -- fotknöl..nn.1
  fotknölssågning_1_N = mkN "fotknölssågning" ; -- fotknölssågning..nn.1
  fotled_1_N = mkN "fotled" "fotleder" ; -- fotled..nn.1
  fotlist_1_N = mkN "fotlist" "fotlister" ; -- fotlist..nn.1
  fotnot_1_N = mkN "fotnot" "fotnötter" ; -- fotnot..nn.1
  foto_1_N = mkN "foto" "fotot" "foton" "fotona" ; -- foto..nn.1
  fotoaffär_1_N = mkN "fotoaffär" "fotoaffärer" ; -- fotoaffär..nn.1
  fotoateljé_1_N = mkN "fotoateljé" "fotoateljéer" ; -- fotoateljé..nn.1
  fotoautomat_1_N = mkN "fotoautomat" "fotoautomater" ; -- fotoautomat..nn.1
  fotoblixt_1_N = mkN "fotoblixt" ; -- fotoblixt..nn.1
  fotocell_1_N = mkN "fotocell" "fotoceller" ; -- fotocell..nn.1
  fotoelektricitet_1_N = mkN "fotoelektricitet" "fotoelektriciteter" ; -- fotoelektricitet..nn.1
  fotoelektrisk_1_A = mkA "fotoelektrisk" ; -- fotoelektrisk..av.1
  fotogen_1_N = mkN "fotogen" neutrum  ; -- fotogen..nn.1
  fotogendunk_1_N = mkN "fotogendunk" ; -- fotogendunk..nn.1
  fotogenique_1_A = mkA "fotogenique" ; -- fotogenique..av.1
  fotogenisk_1_A = mkA "fotogenisk" ; -- fotogenisk..av.1
  fotogenkök_1_N = mkN "fotogenkök" neutrum  ; -- fotogenkök..nn.1
  fotogenlampa_1_N = mkN "fotogenlampa" ; -- fotogenlampa..nn.1
  fotogenmotor_1_N = mkN "fotogenmotor" "fotogenmotorer" ; -- fotogenmotor..nn.1
  fotograf_1_N = mkN "fotograf" "fotografer" ; -- fotograf..nn.1
  fotografera_1_V = mkV "fotograferar" ; -- fotografera..vb.1
  fotograferande_1_N = mkN "fotograferande" ; -- fotograferande..nn.1
  fotograferbar_1_A = mkA "fotograferbar" ; -- fotograferbar..av.1
  fotograferbarhet_1_N = mkN "fotograferbarhet" ; -- fotograferbarhet..nn.1
  fotografering_1_N = mkN "fotografering" ; -- fotografering..nn.1
  fotografi_1_N = mkN "fotografi" "fotografiet" "fotografier" "fotografierna" ; -- fotografi..nn.1
  fotografik_1_N = mkN "fotografik" ; -- fotografik..nn.1
  fotografiplåt_1_N = mkN "fotografiplåt" ; -- fotografiplåt..nn.1
  fotografisk_1_A = mkA "fotografisk" ; -- fotografisk..av.1
  fotogram_1_N = mkN "fotogram" "fotogrammet" "fotogram" "fotogrammen" ; -- fotogram..nn.1
  fotogrammetri_1_N = mkN "fotogrammetri" ; -- fotogrammetri..nn.1
  fotogrammetrisk_1_A = mkA "fotogrammetrisk" ; -- fotogrammetrisk..av.1
  fotogravyr_1_N = mkN "fotogravyr" "fotogravyrer" ; -- fotogravyr..nn.1
  fotohandlare_1_N = mkN "fotohandlare" utrum  ; -- fotohandlare..nn.1
  fotointresse_1_N = mkN "fotointresse" ; -- fotointresse..nn.1
  fotokarriär_1_N = mkN "fotokarriär" "fotokarriärer" ; -- fotokarriär..nn.1
  fotokarta_1_N = mkN "fotokarta" ; -- fotokarta..nn.1
  fotokemi_1_N = mkN "fotokemi" ; -- fotokemi..nn.1
  fotokemisk_1_A = mkA "fotokemisk" ; -- fotokemisk..av.1
  fotokonst_1_N = mkN "fotokonst" ; -- fotokonst..nn.1
  fotokopia_1_N = mkN "fotokopia" ; -- fotokopia..nn.1
  fotokopiera_1_V = mkV "fotokopierar" ; -- fotokopiera..vb.1
  fotokopierande_1_N = mkN "fotokopierande" ; -- fotokopierande..nn.1
  fotokopierbar_1_A = mkA "fotokopierbar" ; -- fotokopierbar..av.1
  fotokopierbarhet_1_N = mkN "fotokopierbarhet" ; -- fotokopierbarhet..nn.1
  fotokopiering_1_N = mkN "fotokopiering" ; -- fotokopiering..nn.1
  fotolitografi_1_N = mkN "fotolitografi" "fotolitografier" ; -- fotolitografi..nn.1
  fotometer_1_N = mkN "fotometer" ; -- fotometer..nn.1
  fotometri_1_N = mkN "fotometri" ; -- fotometri..nn.1
  fotomodell_1_N = mkN "fotomodell" "fotomodeller" ; -- fotomodell..nn.1
  fotomontage_1_N = mkN "fotomontage" "fotomontaget" "fotomontage" "fotomontagen" ; -- fotomontage..nn.1
  foton_1_N = mkN "foton" "fotoner" ; -- foton..nn.1
  fotopris_1_N = mkN "fotopris" neutrum  ; -- fotopris..nn.1
  fotoresistor_1_N = mkN "fotoresistor" "fotoresistorer" ; -- fotoresistor..nn.1
  fotosfär_1_N = mkN "fotosfär" "fotosfärer" ; -- fotosfär..nn.1
  fotostatkopia_1_N = mkN "fotostatkopia" ; -- fotostatkopia..nn.1
  fotostatkopiera_1_V = mkV "fotostatkopierar" ; -- fotostatkopiera..vb.1
  fotostatkopierande_1_N = mkN "fotostatkopierande" ; -- fotostatkopierande..nn.1
  fotostatkopierbar_1_A = mkA "fotostatkopierbar" ; -- fotostatkopierbar..av.1
  fotostatkopierbarhet_1_N = mkN "fotostatkopierbarhet" ; -- fotostatkopierbarhet..nn.1
  fotostatkopiering_1_N = mkN "fotostatkopiering" ; -- fotostatkopiering..nn.1
  fotosyntes_1_N = mkN "fotosyntes" "fotosynteser" ; -- fotosyntes..nn.1
  fotosättning_1_N = mkN "fotosättning" ; -- fotosättning..nn.1
  fotpall_1_N = mkN "fotpall" ; -- fotpall..nn.1
  fotpanel_1_N = mkN "fotpanel" "fotpaneler" ; -- fotpanel..nn.1
  fotpedal_1_N = mkN "fotpedal" "fotpedaler" ; -- fotpedal..nn.1
  fotplatta_1_N = mkN "fotplatta" ; -- fotplatta..nn.1
  fotriktig_1_A = mkA "fotriktig" ; -- fotriktig..av.1
  fotriktighet_1_N = mkN "fotriktighet" ; -- fotriktighet..nn.1
  foträt_1_A = mkA "foträt" ; -- foträt..av.1
  fotsack_1_N = mkN "fotsack" ; -- fotsack..nn.1
  fotsid_1_A = mkA "fotsid" "fotsitt" ; -- fotsid..av.1
  fotskada_1_N = mkN "fotskada" ; -- fotskada..nn.1
  fotskrapa_1_N = mkN "fotskrapa" ; -- fotskrapa..nn.1
  fotsoldat_1_N = mkN "fotsoldat" "fotsoldater" ; -- fotsoldat..nn.1
  fotspår_1_N = mkN "fotspår" neutrum  ; -- fotspår..nn.1
  fotsteg_1_N = mkN "fotsteg" neutrum  ; -- fotsteg..nn.1
  fotställning_1_N = mkN "fotställning" ; -- fotställning..nn.1
  fotstöd_1_N = mkN "fotstöd" neutrum  ; -- fotstöd..nn.1
  fotsula_1_N = mkN "fotsula" ; -- fotsula..nn.1
  fotsvett_1_N = mkN "fotsvett" ; -- fotsvett..nn.1
  fottvagning_1_N = mkN "fottvagning" ; -- fottvagning..nn.1
  fotvalv_1_N = mkN "fotvalv" neutrum  ; -- fotvalv..nn.1
  fotvandra_1_V = mkV "fotvandrar" ; -- fotvandra..vb.1
  fotvandrande_1_N = mkN "fotvandrande" ; -- fotvandrande..nn.1
  fotvandrare_1_N = mkN "fotvandrare" utrum  ; -- fotvandrare..nn.1
  fotvandring_1_N = mkN "fotvandring" ; -- fotvandring..nn.1
  fotvänlig_1_A = mkA "fotvänlig" ; -- fotvänlig..av.1
  fotvänlighet_1_N = mkN "fotvänlighet" ; -- fotvänlighet..nn.1
  fotvård_1_N = mkN "fotvård" ; -- fotvård..nn.1
  fotvårdssalong_1_N = mkN "fotvårdssalong" "fotvårdssalonger" ; -- fotvårdssalong..nn.1
  fotvårta_1_N = mkN "fotvårta" ; -- fotvårta..nn.1
  fotända_1_N = mkN "fotända" ; -- fotända..nn.1
  fotände_1_N = mkN "fotände" utrum  ; -- fotände..nn.1
  foul_1_N = mkN "foul" "foulen" "fouls" "foulerna" ; -- foul..nn.1
  foulard_1_N = mkN "foulard" ; -- foulard..nn.1
  foxterrier_1_N = mkN "foxterrier" "foxterriern" "foxterrier" "foxterrierna" ; -- foxterrier..nn.1
  foxtrot_1_N = mkN "foxtrot" ; -- foxtrot..nn.1
  foxtrott_1_N = mkN "foxtrott" ; -- foxtrott..nn.1
  foxtrottakt_1_N = mkN "foxtrottakt" ; -- foxtrottakt..nn.1
  foyer_1_N = mkN "foyer" "foyern" "foyerer" "foyererna" ; -- foyer..nn.1
  frack_1_N = mkN "frack" ; -- frack..nn.1
  frackklädd_1_A = mkA "frackklädd" ; -- frackklädd..av.1
  fradga_1_N = mkN "fradga" ; -- fradga..nn.1
  fradga_1_V = mkV "fradgar" ; -- fradga..vb.1
  fradgande_1_N = mkN "fradgande" ; -- fradgande..nn.1
  fradgig_1_A = mkA "fradgig" ; -- fradgig..av.1
  fragil_1_A = mkA "fragil" ; -- fragil..av.1
  fragment_1_N = mkN "fragment" neutrum  ; -- fragment..nn.1
  fragmentarisk_1_A = mkA "fragmentarisk" ; -- fragmentarisk..av.1
  fragmentera_1_V = mkV "fragmenterar" ; -- fragmentera..vb.1
  fragmenterande_1_N = mkN "fragmenterande" ; -- fragmenterande..nn.1
  fragmenterbar_1_A = mkA "fragmenterbar" ; -- fragmenterbar..av.1
  fragmenterbarhet_1_N = mkN "fragmenterbarhet" ; -- fragmenterbarhet..nn.1
  fragmentering_1_N = mkN "fragmentering" ; -- fragmentering..nn.1
  fragmentisera_1_V = mkV "fragmentiserar" ; -- fragmentisera..vb.1
  fragmentiserande_1_N = mkN "fragmentiserande" ; -- fragmentiserande..nn.1
  fragmentiserbar_1_A = mkA "fragmentiserbar" ; -- fragmentiserbar..av.1
  fragmentiserbarhet_1_N = mkN "fragmentiserbarhet" ; -- fragmentiserbarhet..nn.1
  fragmentisering_1_N = mkN "fragmentisering" ; -- fragmentisering..nn.1
  frakt_1_N = mkN "frakt" "frakter" ; -- frakt..nn.1
  frakta_1_V = mkV "fraktar" ; -- frakta..vb.1
  fraktal_1_A = mkA "fraktal" ; -- fraktal..av.1
  fraktande_1_N = mkN "fraktande" ; -- fraktande..nn.1
  fraktavtal_1_N = mkN "fraktavtal" neutrum  ; -- fraktavtal..nn.1
  fraktbolag_1_N = mkN "fraktbolag" neutrum  ; -- fraktbolag..nn.1
  fraktfirma_1_N = mkN "fraktfirma" ; -- fraktfirma..nn.1
  fraktfri_1_A = mkA "fraktfri" "fraktfritt" ; -- fraktfri..av.1
  fraktgods_1_N = mkN "fraktgods" neutrum  ; -- fraktgods..nn.1
  fraktion_1_N = mkN "fraktion" ; -- fraktion..nn.1
  fraktionera_1_V = mkV "fraktionerar" ; -- fraktionera..vb.1
  fraktionerande_1_N = mkN "fraktionerande" ; -- fraktionerande..nn.1
  fraktionerbar_1_A = mkA "fraktionerbar" ; -- fraktionerbar..av.1
  fraktionerbarhet_1_N = mkN "fraktionerbarhet" ; -- fraktionerbarhet..nn.1
  fraktionering_1_N = mkN "fraktionering" ; -- fraktionering..nn.1
  fraktionism_1_N = mkN "fraktionism" ; -- fraktionism..nn.1
  fraktjätte_1_N = mkN "fraktjätte" utrum  ; -- fraktjätte..nn.1
  fraktkostnad_1_N = mkN "fraktkostnad" "fraktkostnader" ; -- fraktkostnad..nn.1
  fraktsats_1_N = mkN "fraktsats" "fraktsatser" ; -- fraktsats..nn.1
  fraktsedel_1_N = mkN "fraktsedel" ; -- fraktsedel..nn.1
  fraktterminal_1_N = mkN "fraktterminal" "fraktterminaler" ; -- fraktterminal..nn.1
  fraktur_1_N = mkN "fraktur" ; -- fraktur..nn.1
  fraktur_2_N = mkN "fraktur" "frakturer" ; -- fraktur..nn.2
  frakturstil_1_N = mkN "frakturstil" ; -- frakturstil..nn.1
  fralla_1_N = mkN "fralla" ; -- fralla..nn.1
  framavla_1_V = mkV "framavlar" ; -- framavla..vb.1
  framavlande_1_N = mkN "framavlande" ; -- framavlande..nn.1
  framaxel_1_N = mkN "framaxel" ; -- framaxel..nn.1
  framben_1_N = mkN "framben" neutrum  ; -- framben..nn.1
  frambesvärja_1_V = mkV "frambesvära" "frambesvär" "frambesvärj" "frambesvärjde" "frambesvärjt" "frambesvuren" ; -- frambesvärja..vb.1
  frambesvärjande_1_N = mkN "frambesvärjande" ; -- frambesvärjande..nn.1
  frambesvärjning_1_N = mkN "frambesvärjning" ; -- frambesvärjning..nn.1
  frambringa_1_V = mkV "frambringar" ; -- frambringa..vb.1
  frambringande_1_N = mkN "frambringande" ; -- frambringande..nn.1
  frambringare_1_N = mkN "frambringare" utrum  ; -- frambringare..nn.1
  frambryta_1_V = mkV "frambryta" "frambröt" "frambrutit" ; -- frambryta..vb.1
  frambrytande_1_N = mkN "frambrytande" ; -- frambrytande..nn.1
  frambära_1_V = mkV "frambära" "frambar" "framburit" ; -- frambära..vb.1
  frambärande_1_N = mkN "frambärande" ; -- frambärande..nn.1
  framdel_1_N = mkN "framdel" "framdelen" "framdelar" "framdelarna" ; -- framdel..nn.1
  framdeles_1_Adv = mkAdv "framdeles" ; -- framdeles..ab.1
  framdragning_1_N = mkN "framdragning" ; -- framdragning..nn.1
  framdriva_1_V = mkV "framdriva" "framdrev" "framdrivit" ; -- framdriva..vb.1
  framdrivande_1_N = mkN "framdrivande" ; -- framdrivande..nn.1
  framdrivning_1_N = mkN "framdrivning" ; -- framdrivning..nn.1
  framextremitet_1_N = mkN "framextremitet" "framextremiteter" ; -- framextremitet..nn.1
  framfall_1_N = mkN "framfall" neutrum  ; -- framfall..nn.1
  framfara_1_V = mkV "framfara" "framfor" "framfarit" ; -- framfara..vb.1
  framfarande_1_N = mkN "framfarande" ; -- framfarande..nn.1
  framfaren_1_A = mkA "framfaren" ; -- framfaren..av.1
  framfart_1_N = mkN "framfart" ; -- framfart..nn.1
  framficka_1_N = mkN "framficka" ; -- framficka..nn.1
  framflytta_1_V = mkV "framflyttar" ; -- framflytta..vb.1
  framflyttande_1_N = mkN "framflyttande" ; -- framflyttande..nn.1
  framflyttning_1_N = mkN "framflyttning" ; -- framflyttning..nn.1
  framforsling_1_N = mkN "framforsling" ; -- framforsling..nn.1
  framfot_1_N = mkN "framfot" "framfötter" ; -- framfot..nn.1
  framfusig_1_A = mkA "framfusig" ; -- framfusig..av.1
  framfusighet_1_N = mkN "framfusighet" ; -- framfusighet..nn.1
  framfärd_1_N = mkN "framfärd" "framfärder" ; -- framfärd..nn.1
  framföda_1_V = mkV "framföda" "framfödde" "framfött" ; -- framföda..vb.1
  framfödande_1_N = mkN "framfödande" ; -- framfödande..nn.1
  framföra_1_V = mkV "framföra" "framförde" "framfört" ; -- framföra..vb.1
  framförallt_1_Adv = mkAdv "framförallt" ; -- framförallt..ab.1
  framförande_1_N = mkN "framförande" ; -- framförande..nn.1
  framförhandla_1_V = mkV "framförhandlar" ; -- framförhandla..vb.1
  framförhandlande_1_N = mkN "framförhandlande" ; -- framförhandlande..nn.1
  framförhandling_1_N = mkN "framförhandling" ; -- framförhandling..nn.1
  framförhållning_1_N = mkN "framförhållning" ; -- framförhållning..nn.1
  framförsittande_1_A = mkA "framförsittande" ; -- framförsittande..av.1
  framförvarande_1_A = mkA "framförvarande" ; -- framförvarande..av.1
  framgaffel_1_N = mkN "framgaffel" ; -- framgaffel..nn.1
  framgent_1_Adv = mkAdv "framgent" ; -- framgent..ab.1
  framglidning_1_N = mkN "framglidning" ; -- framglidning..nn.1
  framgå_1_V = mkV "framgå" "framgår" "framgå" "framgick" "framgått" "framgången" ; -- framgå..vb.1
  framgående_1_N = mkN "framgående" ; -- framgående..nn.1
  framgång_1_N = mkN "framgång" ; -- framgång..nn.1
  framgångsevangelist_1_N = mkN "framgångsevangelist" "framgångsevangelister" ; -- framgångsevangelist..nn.1
  framgångshets_1_N = mkN "framgångshets" ; -- framgångshets..nn.1
  framgångshistoria_1_N = mkN "framgångshistoria" "framgångshistorian" "framgångshistorier" "framgångshistorierna" ; -- framgångshistoria..nn.1
  framgångskoncept_1_N = mkN "framgångskoncept" neutrum  ; -- framgångskoncept..nn.1
  framgångsrecept_1_N = mkN "framgångsrecept" neutrum  ; -- framgångsrecept..nn.1
  framgångsrik_1_A = mkA "framgångsrik" ; -- framgångsrik..av.1
  framgångsrikhet_1_N = mkN "framgångsrikhet" ; -- framgångsrikhet..nn.1
  framgångssaga_1_N = mkN "framgångssaga" ; -- framgångssaga..nn.1
  framgångsteologi_1_N = mkN "framgångsteologi" ; -- framgångsteologi..nn.1
  framgångsvind_1_N = mkN "framgångsvind" ; -- framgångsvind..nn.1
  framhjul_1_N = mkN "framhjul" neutrum  ; -- framhjul..nn.1
  framhjulsdriven_1_A = mkA "framhjulsdriven" ; -- framhjulsdriven..av.1
  framhov_1_N = mkN "framhov" ; -- framhov..nn.1
  framhämtning_1_N = mkN "framhämtning" ; -- framhämtning..nn.1
  framhärda_1_V = mkV "framhärdar" ; -- framhärda..vb.1
  framhärdande_1_N = mkN "framhärdande" ; -- framhärdande..nn.1
  framhäva_1_V = mkV "framhäver" ; -- framhäva..vb.1
  framhävande_1_N = mkN "framhävande" ; -- framhävande..nn.1
  framhålla_1_V = mkV "framhålla" "framhöll" "framhållit" ; -- framhålla..vb.1
  framhållande_1_N = mkN "framhållande" ; -- framhållande..nn.1
  framifrån_1_Adv = mkAdv "framifrån" ; -- framifrån..ab.1
  framimproviserad_1_A = mkA "framimproviserad" ; -- framimproviserad..av.1
  framkalla_1_V = mkV "framkallar" ; -- framkalla..vb.1
  framkallande_1_N = mkN "framkallande" ; -- framkallande..nn.1
  framkallare_1_N = mkN "framkallare" utrum  ; -- framkallare..nn.1
  framkallning_1_N = mkN "framkallning" ; -- framkallning..nn.1
  framkallningsapparat_1_N = mkN "framkallningsapparat" "framkallningsapparater" ; -- framkallningsapparat..nn.1
  framkant_1_N = mkN "framkant" "framkanter" ; -- framkant..nn.1
  framkasta_1_V = mkV "framkastar" ; -- framkasta..vb.1
  framkastande_1_N = mkN "framkastande" ; -- framkastande..nn.1
  framkläckning_1_N = mkN "framkläckning" ; -- framkläckning..nn.1
  framknuffning_1_N = mkN "framknuffning" ; -- framknuffning..nn.1
  framkomlig_1_A = mkA "framkomlig" ; -- framkomlig..av.1
  framkomlighet_1_N = mkN "framkomlighet" "framkomligheter" ; -- framkomlighet..nn.1
  framkomma_1_V = mkV "framkomma" "framkom" "framkommit" ; -- framkomma..vb.1
  framkommande_1_N = mkN "framkommande" ; -- framkommande..nn.1
  framkomst_1_N = mkN "framkomst" ; -- framkomst..nn.1
  framkonstruering_1_N = mkN "framkonstruering" ; -- framkonstruering..nn.1
  framkropp_1_N = mkN "framkropp" ; -- framkropp..nn.1
  framkrystning_1_N = mkN "framkrystning" ; -- framkrystning..nn.1
  framkörning_1_N = mkN "framkörning" ; -- framkörning..nn.1
  framladdare_1_N = mkN "framladdare" utrum  ; -- framladdare..nn.1
  framladdning_1_N = mkN "framladdning" ; -- framladdning..nn.1
  framleva_1_V = mkV "framlever" ; -- framleva..vb.1
  framlevande_1_N = mkN "framlevande" ; -- framlevande..nn.1
  framlida_1_V = mkV "framlida" "framled" "framlidit" ; -- framlida..vb.1
  framlidande_1_N = mkN "framlidande" ; -- framlidande..nn.1
  framliden_1_A = mkA "framliden" ; -- framliden..av.1
  framlob_1_N = mkN "framlob" "framlober" ; -- framlob..nn.1
  framlockning_1_N = mkN "framlockning" ; -- framlockning..nn.1
  framlägga_1_V = mkV "framlägga" "framla" "framlagt" ; -- framlägga..vb.1
  framläggande_1_N = mkN "framläggande" ; -- framläggande..nn.1
  framläggning_1_N = mkN "framläggning" ; -- framläggning..nn.1
  framlämning_1_N = mkN "framlämning" ; -- framlämning..nn.1
  framläspning_1_N = mkN "framläspning" ; -- framläspning..nn.1
  frammana_1_V = mkV "frammanar" ; -- frammana..vb.1
  frammanande_1_N = mkN "frammanande" ; -- frammanande..nn.1
  frammaning_1_N = mkN "frammaning" ; -- frammaning..nn.1
  frammarsch_1_N = mkN "frammarsch" "frammarscher" ; -- frammarsch..nn.1
  frammata_1_V = mkV "frammatar" ; -- frammata..vb.1
  frammatande_1_N = mkN "frammatande" ; -- frammatande..nn.1
  frammatning_1_N = mkN "frammatning" ; -- frammatning..nn.1
  framme_1_Adv = mkAdv "framme" ; -- framme..ab.1
  frammumla_1_V = mkV "frammumlar" ; -- frammumla..vb.1
  frammumlande_1_N = mkN "frammumlande" ; -- frammumlande..nn.1
  frammumling_1_N = mkN "frammumling" ; -- frammumling..nn.1
  framorkestrerad_1_A = mkA "framorkestrerad" ; -- framorkestrerad..av.1
  framplockning_1_N = mkN "framplockning" ; -- framplockning..nn.1
  frampressa_1_V = mkV "frampressar" ; -- frampressa..vb.1
  frampressning_1_N = mkN "frampressning" ; -- frampressning..nn.1
  frampå_1_Adv = mkAdv "frampå" ; -- frampå..ab.1
  framropning_1_N = mkN "framropning" ; -- framropning..nn.1
  framrusande_1_A = mkA "framrusande" ; -- framrusande..av.1
  framryckning_1_N = mkN "framryckning" ; -- framryckning..nn.1
  framräckning_1_N = mkN "framräckning" ; -- framräckning..nn.1
  framröstad_1_A = mkA "framröstad" ; -- framröstad..av.1
  framsida_1_N = mkN "framsida" ; -- framsida..nn.1
  framsippring_1_N = mkN "framsippring" ; -- framsippring..nn.1
  framskaffning_1_N = mkN "framskaffning" ; -- framskaffning..nn.1
  framskina_1_V = mkV "framskina" "framsken" "framskinit" ; -- framskina..vb.1
  framskinande_1_N = mkN "framskinande" ; -- framskinande..nn.1
  framskjuta_1_V = mkV "framskjuta" "framsköt" "framskjutit" ; -- framskjuta..vb.1
  framskjutande_1_A = mkA "framskjutande" ; -- framskjutande..av.1
  framskjutande_1_N = mkN "framskjutande" ; -- framskjutande..nn.1
  framskjuten_1_A = mkA "framskjuten" ; -- framskjuten..av.1
  framskjutning_1_N = mkN "framskjutning" ; -- framskjutning..nn.1
  framskrida_1_V = mkV "framskrida" "framskred" "framskridit" ; -- framskrida..vb.1
  framskridande_1_N = mkN "framskridande" ; -- framskridande..nn.1
  framskriden_1_A = mkA "framskriden" ; -- framskriden..av.1
  framskuffning_1_N = mkN "framskuffning" ; -- framskuffning..nn.1
  framskymta_1_V = mkV "framskymtar" ; -- framskymta..vb.1
  framskymtande_1_N = mkN "framskymtande" ; -- framskymtande..nn.1
  framslungning_1_N = mkN "framslungning" ; -- framslungning..nn.1
  framsläpning_1_N = mkN "framsläpning" ; -- framsläpning..nn.1
  framsläppning_1_N = mkN "framsläppning" ; -- framsläppning..nn.1
  framsnyftning_1_N = mkN "framsnyftning" ; -- framsnyftning..nn.1
  framsparkning_1_N = mkN "framsparkning" ; -- framsparkning..nn.1
  framspelad_1_A = mkA "framspelad" ; -- framspelad..av.1
  framspelare_1_N = mkN "framspelare" utrum  ; -- framspelare..nn.1
  framspelning_1_N = mkN "framspelning" ; -- framspelning..nn.1
  framspringande_1_A = mkA "framspringande" ; -- framspringande..av.1
  framstam_1_N = mkN "framstam" "framstammen" "framstammar" "framstammarna" ; -- framstam..nn.1
  framstamning_1_N = mkN "framstamning" ; -- framstamning..nn.1
  framsteg_1_N = mkN "framsteg" neutrum  ; -- framsteg..nn.1
  framstegsanda_1_N = mkN "framstegsanda" ; -- framstegsanda..nn.1
  framstegsman_1_N = mkN "framstegsman" "framstegsmannen" "framstegsmannar" "framstegsmannarna" ; -- framstegsman..nn.1
  framstegsoptimism_1_N = mkN "framstegsoptimism" "framstegsoptimismer" ; -- framstegsoptimism..nn.1
  framstegsparti_1_N = mkN "framstegsparti" "framstegspartiet" "framstegspartier" "framstegspartierna" ; -- framstegsparti..nn.1
  framstegstro_1_N = mkN "framstegstro" ; -- framstegstro..nn.1
  framstegsvänlig_1_A = mkA "framstegsvänlig" ; -- framstegsvänlig..av.1
  framstegsvänlighet_1_N = mkN "framstegsvänlighet" ; -- framstegsvänlighet..nn.1
  framstjärt_1_N = mkN "framstjärt" ; -- framstjärt..nn.1
  framstycke_1_N = mkN "framstycke" ; -- framstycke..nn.1
  framställa_1_V = mkV "framställer" ; -- framställa..vb.1
  framställan_1_N = mkN "framställan" "framställan" "framställningar" "framställningarna" ; -- framställan..nn.1
  framställande_1_N = mkN "framställande" ; -- framställande..nn.1
  framställning_1_N = mkN "framställning" ; -- framställning..nn.1
  framställningsförmåga_1_N = mkN "framställningsförmåga" ; -- framställningsförmåga..nn.1
  framställningskonst_1_N = mkN "framställningskonst" ; -- framställningskonst..nn.1
  framställningssätt_1_N = mkN "framställningssätt" neutrum  ; -- framställningssätt..nn.1
  framstå_1_V = mkV "framstå" "framstod" "framstått" ; -- framstå..vb.1
  framstående_1_A = mkA "framstående" ; -- framstående..av.1
  framstående_1_N = mkN "framstående" ; -- framstående..nn.1
  framstörtning_1_N = mkN "framstörtning" ; -- framstörtning..nn.1
  framstöt_1_N = mkN "framstöt" ; -- framstöt..nn.1
  framstötning_1_N = mkN "framstötning" ; -- framstötning..nn.1
  framsynt_1_A = mkA "framsynt" "framsynt" ; -- framsynt..av.1
  framsynthet_1_N = mkN "framsynthet" ; -- framsynthet..nn.1
  framsäga_1_V = mkV "framsäga" "framsade" "framsagt" ; -- framsäga..vb.1
  framsägande_1_N = mkN "framsägande" ; -- framsägande..nn.1
  framsägning_1_N = mkN "framsägning" ; -- framsägning..nn.1
  framsäte_1_N = mkN "framsäte" ; -- framsäte..nn.1
  framsättning_1_N = mkN "framsättning" ; -- framsättning..nn.1
  framtagning_1_N = mkN "framtagning" ; -- framtagning..nn.1
  framtand_1_N = mkN "framtand" "framtänder" ; -- framtand..nn.1
  framtass_1_N = mkN "framtass" ; -- framtass..nn.1
  framtid_1_N = mkN "framtid" "framtider" ; -- framtid..nn.1
  framtida_1_A = mkA "framtida" ; -- framtida..av.1
  framtidsbild_1_N = mkN "framtidsbild" "framtidsbilder" ; -- framtidsbild..nn.1
  framtidsbransch_1_N = mkN "framtidsbransch" "framtidsbranscher" ; -- framtidsbransch..nn.1
  framtidsdröm_1_N = mkN "framtidsdröm" "framtidsdrömmen" "framtidsdrömmar" "framtidsdrömmarna" ; -- framtidsdröm..nn.1
  framtidsforskare_1_N = mkN "framtidsforskare" utrum  ; -- framtidsforskare..nn.1
  framtidsforskning_1_N = mkN "framtidsforskning" ; -- framtidsforskning..nn.1
  framtidsfråga_1_N = mkN "framtidsfråga" ; -- framtidsfråga..nn.1
  framtidsförutsägelse_1_N = mkN "framtidsförutsägelse" "framtidsförutsägelser" ; -- framtidsförutsägelse..nn.1
  framtidsinriktad_1_A = mkA "framtidsinriktad" ; -- framtidsinriktad..av.1
  framtidskalkyl_1_N = mkN "framtidskalkyl" "framtidskalkyler" ; -- framtidskalkyl..nn.1
  framtidsland_1_N = mkN "framtidsland" "framtidslandet" "framtidsländer" "framtidsländerna" ; -- framtidsland..nn.1
  framtidslöfte_1_N = mkN "framtidslöfte" ; -- framtidslöfte..nn.1
  framtidsman_1_N = mkN "framtidsman" "framtidsmannen" "framtidsmän" "framtidsmännen" ; -- framtidsman..nn.1
  framtidsmål_1_N = mkN "framtidsmål" neutrum  ; -- framtidsmål..nn.1
  framtidsorienterad_1_A = mkA "framtidsorienterad" ; -- framtidsorienterad..av.1
  framtidsplan_1_N = mkN "framtidsplan" "framtidsplaner" ; -- framtidsplan..nn.1
  framtidssatsning_1_N = mkN "framtidssatsning" ; -- framtidssatsning..nn.1
  framtidsscenario_1_N = mkN "framtidsscenario" "framtidsscenariot" "framtidsscenarier" "framtidsscenarierna" ; -- framtidsscenario..nn.1
  framtidsspaning_1_N = mkN "framtidsspaning" ; -- framtidsspaning..nn.1
  framtidssyn_1_N = mkN "framtidssyn" "framtidssyner" ; -- framtidssyn..nn.1
  framtidstanke_1_N = mkN "framtidstanke" utrum  ; -- framtidstanke..nn.1
  framtidstro_1_N = mkN "framtidstro" ; -- framtidstro..nn.1
  framtidsutsikt_1_N = mkN "framtidsutsikt" "framtidsutsikter" ; -- framtidsutsikt..nn.1
  framtidsversion_1_N = mkN "framtidsversion" ; -- framtidsversion..nn.1
  framtidsvision_1_N = mkN "framtidsvision" ; -- framtidsvision..nn.1
  framtidsvy_1_N = mkN "framtidsvy" "framtidsvyer" ; -- framtidsvy..nn.1
  framtill_1_Adv = mkAdv "framtill" ; -- framtill..ab.1
  framtona_1_V = mkV "framtonar" ; -- framtona..vb.1
  framtonande_1_N = mkN "framtonande" ; -- framtonande..nn.1
  framtoning_1_N = mkN "framtoning" ; -- framtoning..nn.1
  framtrollning_1_N = mkN "framtrollning" ; -- framtrollning..nn.1
  framträda_1_V = mkV "framträda" "framträdde" "framträtt" ; -- framträda..vb.1
  framträdande_1_A = mkA "framträdande" ; -- framträdande..av.1
  framträdande_1_N = mkN "framträdande" ; -- framträdande..nn.1
  framtränga_1_V = mkV "framtränger" ; -- framtränga..vb.1
  framträngande_1_A = mkA "framträngande" ; -- framträngande..av.1
  framträngande_1_N = mkN "framträngande" ; -- framträngande..nn.1
  framtung_1_A = mkA "framtung" ; -- framtung..av.1
  framtunghet_1_N = mkN "framtunghet" ; -- framtunghet..nn.1
  framtvinga_1_V = mkV "framtvingar" ; -- framtvinga..vb.1
  framtvingande_1_N = mkN "framtvingande" ; -- framtvingande..nn.1
  framvagn_1_N = mkN "framvagn" ; -- framvagn..nn.1
  framvinge_1_N = mkN "framvinge" utrum  ; -- framvinge..nn.1
  framvisa_1_V = mkV "framvisar" ; -- framvisa..vb.1
  framvisande_1_N = mkN "framvisande" ; -- framvisande..nn.1
  framviskning_1_N = mkN "framviskning" ; -- framviskning..nn.1
  framvisning_1_N = mkN "framvisning" ; -- framvisning..nn.1
  framvältring_1_N = mkN "framvältring" ; -- framvältring..nn.1
  framväxa_1_V = mkV "framväxa" "framväxer" "framväxa" "framväxte" "framväxt" "framvuxen" ; -- framväxa..vb.1
  framväxande_1_N = mkN "framväxande" ; -- framväxande..nn.1
  framväxt_1_N = mkN "framväxt" ; -- framväxt..nn.1
  framända_1_N = mkN "framända" ; -- framända..nn.1
  framände_1_N = mkN "framände" utrum  ; -- framände..nn.1
  framåtanda_1_N = mkN "framåtanda" ; -- framåtanda..nn.1
  framåtblickande_1_A = mkA "framåtblickande" ; -- framåtblickande..av.1
  framåtböjd_1_A = mkA "framåtböjd" "framåtböjt" ; -- framåtböjd..av.1
  framåtlutad_1_A = mkA "framåtlutad" ; -- framåtlutad..av.1
  framåtriktad_1_A = mkA "framåtriktad" ; -- framåtriktad..av.1
  framåtskridande_1_N = mkN "framåtskridande" ; -- framåtskridande..nn.1
  framåtsträvande_1_A = mkA "framåtsträvande" ; -- framåtsträvande..av.1
  framåtsyftande_1_A = mkA "framåtsyftande" ; -- framåtsyftande..av.1
  framöver_1_Adv = mkAdv "framöver" ; -- framöver..ab.1
  franc_1_N = mkN "franc" "francen" "francs" "francsen" ; -- franc..nn.1
  franchising_1_N = mkN "franchising" ; -- franchising..nn.1
  franciskan_1_N = mkN "franciskan" "franciskaner" ; -- franciskan..nn.1
  franciskanerkloster_1_N = mkN "franciskanerkloster" neutrum  ; -- franciskanerkloster..nn.1
  franciskanermunk_1_N = mkN "franciskanermunk" ; -- franciskanermunk..nn.1
  franciskanerorden_1_N = mkN "franciskanerorden" ; -- franciskanerorden..nn.1
  franciskankloster_1_N = mkN "franciskankloster" neutrum  ; -- franciskankloster..nn.1
  franciskanorden_1_N = mkN "franciskanorden" ; -- franciskanorden..nn.1
  francium_1_N = mkN "francium" neutrum  ; -- francium..nn.1
  frangulabark_1_N = mkN "frangulabark" ; -- frangulabark..nn.1
  frank_1_A = mkA "frank" ; -- frank..av.1
  frank_1_N = mkN "frank" "franker" ; -- frank..nn.1
  frankenstein_1_N = mkN "frankenstein" ; -- frankenstein..nn.1
  frankera_1_V = mkV "frankerar" ; -- frankera..vb.1
  frankerande_1_N = mkN "frankerande" ; -- frankerande..nn.1
  frankerbar_1_A = mkA "frankerbar" ; -- frankerbar..av.1
  frankerbarhet_1_N = mkN "frankerbarhet" ; -- frankerbarhet..nn.1
  frankering_1_N = mkN "frankering" ; -- frankering..nn.1
  frankhet_1_N = mkN "frankhet" ; -- frankhet..nn.1
  frankisk_1_A = mkA "frankisk" ; -- frankisk..av.1
  frankist_1_N = mkN "frankist" "frankister" ; -- frankist..nn.1
  frankostämpel_1_N = mkN "frankostämpel" ; -- frankostämpel..nn.1
  frankotecken_1_N = mkN "frankotecken" "frankotecknet" "frankotecken" "frankotecknen" ; -- frankotecken..nn.1
  frans_1_N = mkN "frans" ; -- frans..nn.1
  fransa_1_V = mkV "fransar" ; -- fransa..vb.1
  fransad_1_A = mkA "fransad" ; -- fransad..av.1
  fransande_1_N = mkN "fransande" ; -- fransande..nn.1
  fransförsedd_1_A = mkA "fransförsedd" ; -- fransförsedd..av.1
  fransig_1_A = mkA "fransig" ; -- fransig..av.1
  fransighet_1_N = mkN "fransighet" ; -- fransighet..nn.1
  fransk_1_A = mkA "fransk" ; -- fransk..av.1
  franska_1_N = mkN "franska" ; -- franska..nn.1
  franska_2_N = mkN "franska" ; -- franska..nn.2
  franskakurs_1_N = mkN "franskakurs" "franskakurser" ; -- franskakurs..nn.1
  franskalektion_1_N = mkN "franskalektion" ; -- franskalektion..nn.1
  franskalärare_1_N = mkN "franskalärare" utrum  ; -- franskalärare..nn.1
  franskbröd_1_N = mkN "franskbröd" neutrum  ; -- franskbröd..nn.1
  franskfödd_1_A = mkA "franskfödd" ; -- franskfödd..av.1
  franskhet_1_N = mkN "franskhet" ; -- franskhet..nn.1
  franskklassicism_1_N = mkN "franskklassicism" "franskklassicismer" ; -- franskklassicism..nn.1
  franskklassicistisk_1_A = mkA "franskklassicistisk" ; -- franskklassicistisk..av.1
  franskklassisk_1_A = mkA "franskklassisk" ; -- franskklassisk..av.1
  franskkurs_1_N = mkN "franskkurs" "franskkurser" ; -- franskkurs..nn.1
  fransklektion_1_N = mkN "fransklektion" ; -- fransklektion..nn.1
  fransklärare_1_N = mkN "fransklärare" utrum  ; -- fransklärare..nn.1
  franskspråkig_1_A = mkA "franskspråkig" ; -- franskspråkig..av.1
  franskspråkighet_1_N = mkN "franskspråkighet" ; -- franskspråkighet..nn.1
  franskstyrd_1_A = mkA "franskstyrd" "franskstyrt" ; -- franskstyrd..av.1
  fransktalande_1_A = mkA "fransktalande" ; -- fransktalande..av.1
  franskundervisning_1_N = mkN "franskundervisning" ; -- franskundervisning..nn.1
  fransman_1_N = mkN "fransman" "fransmannen" "fransmän" "fransmännen" ; -- fransman..nn.1
  fransos_1_N = mkN "fransos" "fransoser" ; -- fransos..nn.1
  fransyska_1_N = mkN "fransyska" ; -- fransyska..nn.1
  fransäs_1_N = mkN "fransäs" "fransäser" ; -- fransäs..nn.1
  frappant_1_A = mkA "frappant" "frappant" ; -- frappant..av.1
  frappera_1_V = mkV "frapperar" ; -- frappera..vb.1
  frapperande_1_A = mkA "frapperande" ; -- frapperande..av.1
  frapperande_1_N = mkN "frapperande" ; -- frapperande..nn.1
  frappering_1_N = mkN "frappering" ; -- frappering..nn.1
  fras_1_N = mkN "fras" "fraser" ; -- fras..nn.1
  fras_2_N = mkN "fras" neutrum  ; -- fras..nn.2
  frasa_1_V = mkV "frasar" ; -- frasa..vb.1
  frasande_1_N = mkN "frasande" ; -- frasande..nn.1
  fraseologi_1_N = mkN "fraseologi" ; -- fraseologi..nn.1
  fraseologisk_1_A = mkA "fraseologisk" ; -- fraseologisk..av.1
  frasera_1_V = mkV "fraserar" ; -- frasera..vb.1
  fraserande_1_N = mkN "fraserande" ; -- fraserande..nn.1
  fraserbar_1_A = mkA "fraserbar" ; -- fraserbar..av.1
  fraserbarhet_1_N = mkN "fraserbarhet" ; -- fraserbarhet..nn.1
  frasering_1_N = mkN "frasering" ; -- frasering..nn.1
  frasig_1_A = mkA "frasig" ; -- frasig..av.1
  frasliberal_1_A = mkA "frasliberal" ; -- frasliberal..av.1
  frasliberal_1_N = mkN "frasliberal" "frasliberaler" ; -- frasliberal..nn.1
  frasmakare_1_N = mkN "frasmakare" utrum  ; -- frasmakare..nn.1
  frasmakeri_1_N = mkN "frasmakeri" "frasmakeriet" "frasmakerier" "frasmakerierna" ; -- frasmakeri..nn.1
  frasnät_1_N = mkN "frasnät" neutrum  ; -- frasnät..nn.1
  frasradikal_1_A = mkA "frasradikal" ; -- frasradikal..av.1
  frasradikal_1_N = mkN "frasradikal" "frasradikaler" ; -- frasradikal..nn.1
  frasridå_1_N = mkN "frasridå" "frasridåer" ; -- frasridå..nn.1
  frasvåffla_1_N = mkN "frasvåffla" ; -- frasvåffla..nn.1
  frat_1_N = mkN "frat" neutrum  ; -- frat..nn.1
  fraternisera_1_V = mkV "fraterniserar" ; -- fraternisera..vb.1
  fraterniserande_1_N = mkN "fraterniserande" ; -- fraterniserande..nn.1
  fraternisering_1_N = mkN "fraternisering" ; -- fraternisering..nn.1
  freak_1_N = mkN "freak" ; -- freak..nn.1
  fred_1_N = mkN "fred" "freder" ; -- fred..nn.1
  freda_1_V = mkV "fredar" ; -- freda..vb.1
  fredag_1_N = mkN "fredag" ; -- fredag..nn.1
  fredageftermiddag_1_N = mkN "fredageftermiddag" ; -- fredageftermiddag..nn.1
  fredagkväll_1_N = mkN "fredagkväll" ; -- fredagkväll..nn.1
  fredagmorgon_1_N = mkN "fredagmorgon" "fredagmorgonen" "fredagmornar" "fredagmornarna" ; -- fredagmorgon..nn.1
  fredagsbilaga_1_N = mkN "fredagsbilaga" ; -- fredagsbilaga..nn.1
  fredagsbön_1_N = mkN "fredagsbön" "fredagsböner" ; -- fredagsbön..nn.1
  fredagsbörs_1_N = mkN "fredagsbörs" "fredagsbörser" ; -- fredagsbörs..nn.1
  fredagseftermiddag_1_N = mkN "fredagseftermiddag" ; -- fredagseftermiddag..nn.1
  fredagskväll_1_N = mkN "fredagskväll" ; -- fredagskväll..nn.1
  fredagsmiddag_1_N = mkN "fredagsmiddag" ; -- fredagsmiddag..nn.1
  fredagsmorgon_1_N = mkN "fredagsmorgon" "fredagsmorgonen" "fredagsmornar" "fredagsmornarna" ; -- fredagsmorgon..nn.1
  fredagsmys_1_N = mkN "fredagsmys" neutrum  ; -- fredagsmys..nn.1
  fredagsöl_1_N = mkN "fredagsöl" neutrum  ; -- fredagsöl..nn.1
  fredande_1_N = mkN "fredande" ; -- fredande..nn.1
  fredframtvingande_1_A = mkA "fredframtvingande" ; -- fredframtvingande..av.1
  fredlig_1_A = mkA "fredlig" ; -- fredlig..av.1
  fredlighet_1_N = mkN "fredlighet" ; -- fredlighet..nn.1
  fredlös_1_A = mkA "fredlös" ; -- fredlös..av.1
  fredlöshet_1_N = mkN "fredlöshet" ; -- fredlöshet..nn.1
  fredsaktivist_1_N = mkN "fredsaktivist" "fredsaktivister" ; -- fredsaktivist..nn.1
  fredsavtal_1_N = mkN "fredsavtal" neutrum  ; -- fredsavtal..nn.1
  fredsbefrämjande_1_A = mkA "fredsbefrämjande" ; -- fredsbefrämjande..av.1
  fredsbevarande_1_A = mkA "fredsbevarande" ; -- fredsbevarande..av.1
  fredsbrott_1_N = mkN "fredsbrott" neutrum  ; -- fredsbrott..nn.1
  fredsdomare_1_N = mkN "fredsdomare" utrum  ; -- fredsdomare..nn.1
  fredsdomstol_1_N = mkN "fredsdomstol" ; -- fredsdomstol..nn.1
  fredsduva_1_N = mkN "fredsduva" ; -- fredsduva..nn.1
  fredsflagga_1_N = mkN "fredsflagga" ; -- fredsflagga..nn.1
  fredsforskning_1_N = mkN "fredsforskning" ; -- fredsforskning..nn.1
  fredsfrämjande_1_A = mkA "fredsfrämjande" ; -- fredsfrämjande..av.1
  fredsfördrag_1_N = mkN "fredsfördrag" neutrum  ; -- fredsfördrag..nn.1
  fredsförening_1_N = mkN "fredsförening" ; -- fredsförening..nn.1
  fredsförhandlare_1_N = mkN "fredsförhandlare" utrum  ; -- fredsförhandlare..nn.1
  fredsförhandling_1_N = mkN "fredsförhandling" ; -- fredsförhandling..nn.1
  fredsförslag_1_N = mkN "fredsförslag" neutrum  ; -- fredsförslag..nn.1
  fredskonferens_1_N = mkN "fredskonferens" "fredskonferenser" ; -- fredskonferens..nn.1
  fredskongress_1_N = mkN "fredskongress" "fredskongresser" ; -- fredskongress..nn.1
  fredskår_1_N = mkN "fredskår" "fredskårer" ; -- fredskår..nn.1
  fredsmäklare_1_N = mkN "fredsmäklare" utrum  ; -- fredsmäklare..nn.1
  fredsmäkling_1_N = mkN "fredsmäkling" ; -- fredsmäkling..nn.1
  fredspipa_1_N = mkN "fredspipa" ; -- fredspipa..nn.1
  fredsplikt_1_N = mkN "fredsplikt" ; -- fredsplikt..nn.1
  fredspris_1_N = mkN "fredspris" neutrum  ; -- fredspris..nn.1
  fredspristagare_1_N = mkN "fredspristagare" utrum  ; -- fredspristagare..nn.1
  fredspristagarfavorit_1_N = mkN "fredspristagarfavorit" "fredspristagarfavoriter" ; -- fredspristagarfavorit..nn.1
  fredsprisval_1_N = mkN "fredsprisval" neutrum  ; -- fredsprisval..nn.1
  fredsprocess_1_N = mkN "fredsprocess" "fredsprocesser" ; -- fredsprocess..nn.1
  fredsrörelse_1_N = mkN "fredsrörelse" "fredsrörelser" ; -- fredsrörelse..nn.1
  fredssamtal_1_N = mkN "fredssamtal" neutrum  ; -- fredssamtal..nn.1
  fredsskapande_1_A = mkA "fredsskapande" ; -- fredsskapande..av.1
  fredsslut_1_N = mkN "fredsslut" neutrum  ; -- fredsslut..nn.1
  fredsstiftare_1_N = mkN "fredsstiftare" utrum  ; -- fredsstiftare..nn.1
  fredssträvande_1_N = mkN "fredssträvande" ; -- fredssträvande..nn.1
  fredsstyrka_1_N = mkN "fredsstyrka" ; -- fredsstyrka..nn.1
  fredstid_1_N = mkN "fredstid" "fredstider" ; -- fredstid..nn.1
  fredstida_1_A = mkA "fredstida" ; -- fredstida..av.1
  fredstraktat_1_N = mkN "fredstraktat" "fredstraktater" ; -- fredstraktat..nn.1
  fredsuppdrag_1_N = mkN "fredsuppdrag" neutrum  ; -- fredsuppdrag..nn.1
  fredsvillkor_1_N = mkN "fredsvillkor" neutrum  ; -- fredsvillkor..nn.1
  fredsvän_1_N = mkN "fredsvän" "fredsvännen" "fredsvänner" "fredsvännerna" ; -- fredsvän..nn.1
  fredsvänlig_1_A = mkA "fredsvänlig" ; -- fredsvänlig..av.1
  fredsvänlighet_1_N = mkN "fredsvänlighet" ; -- fredsvänlighet..nn.1
  fredsälskande_1_A = mkA "fredsälskande" ; -- fredsälskande..av.1
  fredsängel_1_N = mkN "fredsängel" ; -- fredsängel..nn.1
  fredsår_1_N = mkN "fredsår" neutrum  ; -- fredsår..nn.1
  fredsöverenskommelse_1_N = mkN "fredsöverenskommelse" "fredsöverenskommelser" ; -- fredsöverenskommelse..nn.1
  free_style_1_N = mkN "free-style" "free-stylen" "free-styles" "free-stylesarna" ; -- free-style..nn.1
  freestyle_1_N = mkN "freestyle" "freestylen" "freestyles" "freestylesarna" ; -- freestyle..nn.1
  fregatt_1_N = mkN "fregatt" "fregatter" ; -- fregatt..nn.1
  fregattfågel_1_N = mkN "fregattfågel" ; -- fregattfågel..nn.1
  frejd_1_N = mkN "frejd" ; -- frejd..nn.1
  frejdad_1_A = mkA "frejdad" ; -- frejdad..av.1
  frejdig_1_A = mkA "frejdig" ; -- frejdig..av.1
  frejdighet_1_N = mkN "frejdighet" ; -- frejdighet..nn.1
  frekvens_1_N = mkN "frekvens" "frekvenser" ; -- frekvens..nn.1
  frekvensband_1_N = mkN "frekvensband" neutrum  ; -- frekvensband..nn.1
  frekvensmodulera_1_V = mkV "frekvensmodulerar" ; -- frekvensmodulera..vb.1
  frekvensmodulerande_1_N = mkN "frekvensmodulerande" ; -- frekvensmodulerande..nn.1
  frekvensmodulerbar_1_A = mkA "frekvensmodulerbar" ; -- frekvensmodulerbar..av.1
  frekvensmodulerbarhet_1_N = mkN "frekvensmodulerbarhet" ; -- frekvensmodulerbarhet..nn.1
  frekvensmodulering_1_N = mkN "frekvensmodulering" ; -- frekvensmodulering..nn.1
  frekvensområde_1_N = mkN "frekvensområde" ; -- frekvensområde..nn.1
  frekvenspolygon_1_N = mkN "frekvenspolygon" "frekvenspolygoner" ; -- frekvenspolygon..nn.1
  frekvent_1_A = mkA "frekvent" "frekvent" ; -- frekvent..av.1
  frekventera_1_V = mkV "frekventerar" ; -- frekventera..vb.1
  frekventerande_1_N = mkN "frekventerande" ; -- frekventerande..nn.1
  frekventerbar_1_A = mkA "frekventerbar" ; -- frekventerbar..av.1
  frekventerbarhet_1_N = mkN "frekventerbarhet" ; -- frekventerbarhet..nn.1
  frekventering_1_N = mkN "frekventering" ; -- frekventering..nn.1
  frenesi_1_N = mkN "frenesi" ; -- frenesi..nn.1
  frenetisk_1_A = mkA "frenetisk" ; -- frenetisk..av.1
  frenolog_1_N = mkN "frenolog" "frenologer" ; -- frenolog..nn.1
  frenologi_1_N = mkN "frenologi" ; -- frenologi..nn.1
  frenologisk_1_A = mkA "frenologisk" ; -- frenologisk..av.1
  freon_1_N = mkN "freon" "freoner" ; -- freon..nn.1
  fresia_1_N = mkN "fresia" ; -- fresia..nn.1
  fresk_1_N = mkN "fresk" "fresker" ; -- fresk..nn.1
  freskomålare_1_N = mkN "freskomålare" utrum  ; -- freskomålare..nn.1
  freskomålning_1_N = mkN "freskomålning" ; -- freskomålning..nn.1
  fresta_1_V = mkV "frestar" ; -- fresta..vb.1
  frestad_1_A = mkA "frestad" ; -- frestad..av.1
  frestande_1_A = mkA "frestande" ; -- frestande..av.1
  frestande_1_N = mkN "frestande" ; -- frestande..nn.1
  frestare_1_N = mkN "frestare" utrum  ; -- frestare..nn.1
  frestelse_1_N = mkN "frestelse" "frestelser" ; -- frestelse..nn.1
  freudiansk_1_A = mkA "freudiansk" ; -- freudiansk..av.1
  fri_1_A = mkA "fri" "fritt" ; -- fri..av.1
  fria_1_V = mkV "friar" ; -- fria..vb.1
  friande_1_N = mkN "friande" ; -- friande..nn.1
  friarbrev_1_N = mkN "friarbrev" neutrum  ; -- friarbrev..nn.1
  friare_1_N = mkN "friare" utrum  ; -- friare..nn.1
  friarfärd_1_N = mkN "friarfärd" "friarfärder" ; -- friarfärd..nn.1
  fribiljett_1_N = mkN "fribiljett" "fribiljetter" ; -- fribiljett..nn.1
  fribladig_1_A = mkA "fribladig" ; -- fribladig..av.1
  fribonde_1_N = mkN "fribonde" "fribönder" ; -- fribonde..nn.1
  fribord_1_N = mkN "fribord" neutrum  ; -- fribord..nn.1
  friboren_1_A = mkA "friboren" ; -- friboren..av.1
  fribrev_1_N = mkN "fribrev" neutrum  ; -- fribrev..nn.1
  fribrottare_1_N = mkN "fribrottare" utrum  ; -- fribrottare..nn.1
  fribrottning_1_N = mkN "fribrottning" ; -- fribrottning..nn.1
  fribytare_1_N = mkN "fribytare" utrum  ; -- fribytare..nn.1
  fribytarskara_1_N = mkN "fribytarskara" ; -- fribytarskara..nn.1
  fribyteri_1_N = mkN "fribyteri" neutrum  ; -- fribyteri..nn.1
  fribärande_1_A = mkA "fribärande" ; -- fribärande..av.1
  frid_1_N = mkN "frid" "frider" ; -- frid..nn.1
  fridag_1_N = mkN "fridag" ; -- fridag..nn.1
  fridfull_1_A = mkA "fridfull" ; -- fridfull..av.1
  fridfullhet_1_N = mkN "fridfullhet" ; -- fridfullhet..nn.1
  fridlysa_1_V = mkV "fridlyser" ; -- fridlysa..vb.1
  fridlysande_1_N = mkN "fridlysande" ; -- fridlysande..nn.1
  fridlysning_1_N = mkN "fridlysning" ; -- fridlysning..nn.1
  fridlös_1_A = mkA "fridlös" ; -- fridlös..av.1
  fridlöshet_1_N = mkN "fridlöshet" ; -- fridlöshet..nn.1
  fridsam_1_A = mkA "fridsam" "fridsamt" "fridsamma" "fridsamma" "fridsammare" "fridsammast" "fridsammaste" ; -- fridsam..av.1
  fridsamhet_1_N = mkN "fridsamhet" ; -- fridsamhet..nn.1
  fridskränkning_1_N = mkN "fridskränkning" ; -- fridskränkning..nn.1
  fridstörande_1_A = mkA "fridstörande" ; -- fridstörande..av.1
  fridstörare_1_N = mkN "fridstörare" utrum  ; -- fridstörare..nn.1
  frieri_1_N = mkN "frieri" "frieriet" "frierier" "frierierna" ; -- frieri..nn.1
  friexemplar_1_N = mkN "friexemplar" neutrum  ; -- friexemplar..nn.1
  frifräsare_1_N = mkN "frifräsare" utrum  ; -- frifräsare..nn.1
  frifräsig_1_A = mkA "frifräsig" ; -- frifräsig..av.1
  frifräsighet_1_N = mkN "frifräsighet" ; -- frifräsighet..nn.1
  friförsamling_1_N = mkN "friförsamling" ; -- friförsamling..nn.1
  frige_1_V = mkV "frigiva" "frigav" "frigivit" ; -- frige..vb.1
  friggebod_1_N = mkN "friggebod" ; -- friggebod..nn.1
  frigid_1_A = mkA "frigid" ; -- frigid..av.1
  frigiditet_1_N = mkN "frigiditet" "frigiditeter" ; -- frigiditet..nn.1
  frigivande_1_N = mkN "frigivande" ; -- frigivande..nn.1
  frigivning_1_N = mkN "frigivning" ; -- frigivning..nn.1
  frigivningsnämnd_1_N = mkN "frigivningsnämnd" "frigivningsnämnder" ; -- frigivningsnämnd..nn.1
  frigivningsvillkor_1_N = mkN "frigivningsvillkor" neutrum  ; -- frigivningsvillkor..nn.1
  frigjord_1_A = mkA "frigjord" "frigjort" ; -- frigjord..av.1
  frigjordhet_1_N = mkN "frigjordhet" "frigjordheter" ; -- frigjordhet..nn.1
  frigående_1_A = mkA "frigående" ; -- frigående..av.1
  frigång_1_N = mkN "frigång" ; -- frigång..nn.1
  frigöra_1_V = mkV "frigöra" "frigjorde" "frigjort" ; -- frigöra..vb.1
  frigörande_1_N = mkN "frigörande" ; -- frigörande..nn.1
  frigörare_1_N = mkN "frigörare" utrum  ; -- frigörare..nn.1
  frigörelse_1_N = mkN "frigörelse" utrum  ; -- frigörelse..nn.1
  frihamn_1_N = mkN "frihamn" ; -- frihamn..nn.1
  frihandel_1_N = mkN "frihandel" ; -- frihandel..nn.1
  frihandelsfördrag_1_N = mkN "frihandelsfördrag" neutrum  ; -- frihandelsfördrag..nn.1
  frihandelsförhandling_1_N = mkN "frihandelsförhandling" ; -- frihandelsförhandling..nn.1
  frihandelsområde_1_N = mkN "frihandelsområde" ; -- frihandelsområde..nn.1
  frihandelsvänlig_1_A = mkA "frihandelsvänlig" ; -- frihandelsvänlig..av.1
  frihandelszon_1_N = mkN "frihandelszon" "frihandelszoner" ; -- frihandelszon..nn.1
  frihandsteckning_1_N = mkN "frihandsteckning" ; -- frihandsteckning..nn.1
  friherre_1_N = mkN "friherre" utrum  ; -- friherre..nn.1
  friherrlig_1_A = mkA "friherrlig" ; -- friherrlig..av.1
  frihet_1_N = mkN "frihet" "friheter" ; -- frihet..nn.1
  frihetlig_1_A = mkA "frihetlig" ; -- frihetlig..av.1
  frihetlighet_1_N = mkN "frihetlighet" ; -- frihetlighet..nn.1
  frihetsanda_1_N = mkN "frihetsanda" ; -- frihetsanda..nn.1
  frihetsapostel_1_N = mkN "frihetsapostel" ; -- frihetsapostel..nn.1
  frihetsbegär_1_N = mkN "frihetsbegär" neutrum  ; -- frihetsbegär..nn.1
  frihetsberöva_1_V = mkV "frihetsberövar" ; -- frihetsberöva..vb.1
  frihetsberövande_1_N = mkN "frihetsberövande" ; -- frihetsberövande..nn.1
  frihetsberövning_1_N = mkN "frihetsberövning" ; -- frihetsberövning..nn.1
  frihetsbrev_1_N = mkN "frihetsbrev" neutrum  ; -- frihetsbrev..nn.1
  frihetsfientlig_1_A = mkA "frihetsfientlig" ; -- frihetsfientlig..av.1
  frihetsförkvävande_1_A = mkA "frihetsförkvävande" ; -- frihetsförkvävande..av.1
  frihetsförlust_1_N = mkN "frihetsförlust" "frihetsförluster" ; -- frihetsförlust..nn.1
  frihetsgrad_1_N = mkN "frihetsgrad" "frihetsgrader" ; -- frihetsgrad..nn.1
  frihetshjälte_1_N = mkN "frihetshjälte" utrum  ; -- frihetshjälte..nn.1
  frihetskamp_1_N = mkN "frihetskamp" "frihetskamper" ; -- frihetskamp..nn.1
  frihetskrig_1_N = mkN "frihetskrig" neutrum  ; -- frihetskrig..nn.1
  frihetskämpe_1_N = mkN "frihetskämpe" utrum  ; -- frihetskämpe..nn.1
  frihetslängtande_1_A = mkA "frihetslängtande" ; -- frihetslängtande..av.1
  frihetsstraff_1_N = mkN "frihetsstraff" neutrum  ; -- frihetsstraff..nn.1
  frihetsstrid_1_N = mkN "frihetsstrid" "frihetsstrider" ; -- frihetsstrid..nn.1
  frihetssträvande_1_N = mkN "frihetssträvande" ; -- frihetssträvande..nn.1
  frihetssymbol_1_N = mkN "frihetssymbol" "frihetssymboler" ; -- frihetssymbol..nn.1
  frihetstid_1_N = mkN "frihetstid" ; -- frihetstid..nn.1
  frihetsälskande_1_A = mkA "frihetsälskande" ; -- frihetsälskande..av.1
  frihjul_1_N = mkN "frihjul" neutrum  ; -- frihjul..nn.1
  friholt_1_N = mkN "friholt" ; -- friholt..nn.1
  frihult_1_N = mkN "frihult" ; -- frihult..nn.1
  friidrott_1_N = mkN "friidrott" "friidrotter" ; -- friidrott..nn.1
  friidrottare_1_N = mkN "friidrottare" utrum  ; -- friidrottare..nn.1
  friidrottsförbund_1_N = mkN "friidrottsförbund" neutrum  ; -- friidrottsförbund..nn.1
  friidrottslandslag_1_N = mkN "friidrottslandslag" neutrum  ; -- friidrottslandslag..nn.1
  frikadell_1_N = mkN "frikadell" "frikadeller" ; -- frikadell..nn.1
  frikalla_1_V = mkV "frikallar" ; -- frikalla..vb.1
  frikallande_1_N = mkN "frikallande" ; -- frikallande..nn.1
  frikallelse_1_N = mkN "frikallelse" "frikallelser" ; -- frikallelse..nn.1
  frikassé_1_N = mkN "frikassé" "frikasséer" ; -- frikassé..nn.1
  frikast_1_N = mkN "frikast" neutrum  ; -- frikast..nn.1
  frikativ_1_A = mkA "frikativ" ; -- frikativ..av.1
  frikativa_1_N = mkN "frikativa" ; -- frikativa..nn.1
  frikoppla_1_V = mkV "frikopplar" ; -- frikoppla..vb.1
  frikopplande_1_N = mkN "frikopplande" ; -- frikopplande..nn.1
  frikoppling_1_N = mkN "frikoppling" ; -- frikoppling..nn.1
  frikort_1_N = mkN "frikort" neutrum  ; -- frikort..nn.1
  frikostig_1_A = mkA "frikostig" ; -- frikostig..av.1
  frikostighet_1_N = mkN "frikostighet" ; -- frikostighet..nn.1
  frikrets_1_N = mkN "frikrets" ; -- frikrets..nn.1
  friktion_1_N = mkN "friktion" ; -- friktion..nn.1
  friktionsfri_1_A = mkA "friktionsfri" "friktionsfritt" ; -- friktionsfri..av.1
  friktionskoefficient_1_N = mkN "friktionskoefficient" "friktionskoefficienter" ; -- friktionskoefficient..nn.1
  friktionstal_1_N = mkN "friktionstal" neutrum  ; -- friktionstal..nn.1
  friktionsvärme_1_N = mkN "friktionsvärme" ; -- friktionsvärme..nn.1
  friktionsväxling_1_N = mkN "friktionsväxling" ; -- friktionsväxling..nn.1
  frikyrka_1_N = mkN "frikyrka" ; -- frikyrka..nn.1
  frikyrklig_1_A = mkA "frikyrklig" ; -- frikyrklig..av.1
  frikyrklighet_1_N = mkN "frikyrklighet" "frikyrkligheter" ; -- frikyrklighet..nn.1
  frikyrkoförsamling_1_N = mkN "frikyrkoförsamling" ; -- frikyrkoförsamling..nn.1
  frikyrkopastor_1_N = mkN "frikyrkopastor" "frikyrkopastorer" ; -- frikyrkopastor..nn.1
  frikyrkorörelse_1_N = mkN "frikyrkorörelse" "frikyrkorörelser" ; -- frikyrkorörelse..nn.1
  frikänna_1_V = mkV "frikänna" "frikände" "frikänt" ; -- frikänna..vb.1
  frikännande_1_N = mkN "frikännande" ; -- frikännande..nn.1
  frikännelse_1_N = mkN "frikännelse" "frikännelser" ; -- frikännelse..nn.1
  frikår_1_N = mkN "frikår" "frikårer" ; -- frikår..nn.1
  friköp_1_N = mkN "friköp" neutrum  ; -- friköp..nn.1
  friköpa_1_V = mkV "friköper" ; -- friköpa..vb.1
  friköpande_1_N = mkN "friköpande" ; -- friköpande..nn.1
  friköpning_1_N = mkN "friköpning" ; -- friköpning..nn.1
  friland_1_N = mkN "friland" neutrum  ; -- friland..nn.1
  frilans_1_N = mkN "frilans" ; -- frilans..nn.1
  frilansa_1_V = mkV "frilansar" ; -- frilansa..vb.1
  frilansande_1_N = mkN "frilansande" ; -- frilansande..nn.1
  frilansare_1_N = mkN "frilansare" utrum  ; -- frilansare..nn.1
  frilansjournalist_1_N = mkN "frilansjournalist" "frilansjournalister" ; -- frilansjournalist..nn.1
  frilansskribent_1_N = mkN "frilansskribent" "frilansskribenter" ; -- frilansskribent..nn.1
  frilansskådespelare_1_N = mkN "frilansskådespelare" utrum  ; -- frilansskådespelare..nn.1
  frilanstillvaro_1_N = mkN "frilanstillvaro" ; -- frilanstillvaro..nn.1
  frilansvillkor_1_N = mkN "frilansvillkor" neutrum  ; -- frilansvillkor..nn.1
  frilevande_1_A = mkA "frilevande" ; -- frilevande..av.1
  friliggande_1_A = mkA "friliggande" ; -- friliggande..av.1
  frilista_1_N = mkN "frilista" ; -- frilista..nn.1
  frilista_1_V = mkV "frilistar" ; -- frilista..vb.1
  frilistande_1_N = mkN "frilistande" ; -- frilistande..nn.1
  frilla_1_N = mkN "frilla" ; -- frilla..nn.1
  friluftsbad_1_N = mkN "friluftsbad" neutrum  ; -- friluftsbad..nn.1
  friluftsdag_1_N = mkN "friluftsdag" ; -- friluftsdag..nn.1
  friluftshåll_1_N = mkN "friluftshåll" neutrum  ; -- friluftshåll..nn.1
  friluftsintresse_1_N = mkN "friluftsintresse" ; -- friluftsintresse..nn.1
  friluftsliv_1_N = mkN "friluftsliv" neutrum  ; -- friluftsliv..nn.1
  friluftsmiljö_1_N = mkN "friluftsmiljö" "friluftsmiljön" "friluftsmiljöer" "friluftsmiljöerna" ; -- friluftsmiljö..nn.1
  friluftsmuseum_1_N = mkN "friluftsmuseum" "friluftsmuseet" "friluftsmuseer" "friluftsmuseerna" ; -- friluftsmuseum..nn.1
  friluftsområde_1_N = mkN "friluftsområde" ; -- friluftsområde..nn.1
  friluftsskog_1_N = mkN "friluftsskog" ; -- friluftsskog..nn.1
  friluftsvana_1_N = mkN "friluftsvana" ; -- friluftsvana..nn.1
  friluftsändamål_1_N = mkN "friluftsändamål" neutrum  ; -- friluftsändamål..nn.1
  friläge_1_N = mkN "friläge" ; -- friläge..nn.1
  frilägga_1_V = mkV "frilägga" "frila" "frilagt" ; -- frilägga..vb.1
  friläggande_1_N = mkN "friläggande" ; -- friläggande..nn.1
  frimickel_1_N = mkN "frimickel" ; -- frimickel..nn.1
  frimodig_1_A = mkA "frimodig" ; -- frimodig..av.1
  frimodighet_1_N = mkN "frimodighet" ; -- frimodighet..nn.1
  frimurare_1_N = mkN "frimurare" utrum  ; -- frimurare..nn.1
  frimurareorden_1_N = mkN "frimurareorden" ; -- frimurareorden..nn.1
  frimurarloge_1_N = mkN "frimurarloge" "frimurarloger" ; -- frimurarloge..nn.1
  frimurarorden_1_N = mkN "frimurarorden" ; -- frimurarorden..nn.1
  frimurartecken_1_N = mkN "frimurartecken" "frimurartecknet" "frimurartecken" "frimurartecknen" ; -- frimurartecken..nn.1
  frimureri_1_N = mkN "frimureri" neutrum  ; -- frimureri..nn.1
  frimärka_1_V = mkV "frimärker" ; -- frimärka..vb.1
  frimärkande_1_N = mkN "frimärkande" ; -- frimärkande..nn.1
  frimärke_1_N = mkN "frimärke" ; -- frimärke..nn.1
  frimärkssamlare_1_N = mkN "frimärkssamlare" utrum  ; -- frimärkssamlare..nn.1
  frimärkssamling_1_N = mkN "frimärkssamling" ; -- frimärkssamling..nn.1
  fripass_1_N = mkN "fripass" neutrum  ; -- fripass..nn.1
  fripassagerare_1_N = mkN "fripassagerare" utrum  ; -- fripassagerare..nn.1
  friplats_1_N = mkN "friplats" "friplatser" ; -- friplats..nn.1
  friplåt_1_N = mkN "friplåt" ; -- friplåt..nn.1
  frireligiös_1_A = mkA "frireligiös" ; -- frireligiös..av.1
  fris_1_N = mkN "fris" "friser" ; -- fris..nn.1
  fris_2_N = mkN "fris" ; -- fris..nn.2
  fris_2_1_N = mkN "fris" "friser" ; -- fris_2..nn.1
  frisbee_1_N = mkN "frisbee" "frisbeen" "frisbees" "frisbeearna" ; -- frisbee..nn.1
  frisedel_1_N = mkN "frisedel" ; -- frisedel..nn.1
  frisera_1_V = mkV "friserar" ; -- frisera..vb.1
  frisera_2_V = mkV "friserar" ; -- frisera..vb.2
  friserande_1_N = mkN "friserande" ; -- friserande..nn.1
  friserbar_1_A = mkA "friserbar" ; -- friserbar..av.1
  friserbarhet_1_N = mkN "friserbarhet" ; -- friserbarhet..nn.1
  frisering_1_N = mkN "frisering" ; -- frisering..nn.1
  frisersalong_1_N = mkN "frisersalong" "frisersalonger" ; -- frisersalong..nn.1
  frisinnad_1_A = mkA "frisinnad" ; -- frisinnad..av.1
  frisinne_1_N = mkN "frisinne" ; -- frisinne..nn.1
  frisint_1_A = mkA "frisint" "frisint" ; -- frisint..av.1
  frisinthet_1_N = mkN "frisinthet" ; -- frisinthet..nn.1
  frisisk_1_A = mkA "frisisk" ; -- frisisk..av.1
  frisiska_1_N = mkN "frisiska" ; -- frisiska..nn.1
  frisiska_2_N = mkN "frisiska" ; -- frisiska..nn.2
  frisk_1_A = mkA "frisk" ; -- frisk..av.1
  friska_1_V = mkV "friskar" ; -- friska..vb.1
  friskande_1_N = mkN "friskande" ; -- friskande..nn.1
  friskanmäla_1_V = mkV "friskanmäler" ; -- friskanmäla..vb.1
  friskanmälande_1_N = mkN "friskanmälande" ; -- friskanmälande..nn.1
  friskara_1_N = mkN "friskara" ; -- friskara..nn.1
  friskförklara_1_V = mkV "friskförklarar" ; -- friskförklara..vb.1
  friskförklarande_1_N = mkN "friskförklarande" ; -- friskförklarande..nn.1
  friskhet_1_N = mkN "friskhet" ; -- friskhet..nn.1
  friskintyg_1_N = mkN "friskintyg" neutrum  ; -- friskintyg..nn.1
  friskluft_1_N = mkN "friskluft" ; -- friskluft..nn.1
  friskluftsintag_1_N = mkN "friskluftsintag" neutrum  ; -- friskluftsintag..nn.1
  friskluftsventilation_1_N = mkN "friskluftsventilation" ; -- friskluftsventilation..nn.1
  friskola_1_N = mkN "friskola" ; -- friskola..nn.1
  friskrapportera_1_V = mkV "friskrapporterar" ; -- friskrapportera..vb.1
  friskrapporterande_1_N = mkN "friskrapporterande" ; -- friskrapporterande..nn.1
  friskrapportering_1_N = mkN "friskrapportering" ; -- friskrapportering..nn.1
  friskriven_1_A = mkA "friskriven" ; -- friskriven..av.1
  friskrivning_1_N = mkN "friskrivning" ; -- friskrivning..nn.1
  friskskriva_1_V = mkV "friskskriva" "friskskrev" "friskskrivit" ; -- friskskriva..vb.1
  friskskrivande_1_N = mkN "friskskrivande" ; -- friskskrivande..nn.1
  frisksport_1_N = mkN "frisksport" ; -- frisksport..nn.1
  frisksporta_1_V = mkV "frisksportar" ; -- frisksporta..vb.1
  frisksportande_1_N = mkN "frisksportande" ; -- frisksportande..nn.1
  frisksportare_1_N = mkN "frisksportare" utrum  ; -- frisksportare..nn.1
  friskus_1_N = mkN "friskus" ; -- friskus..nn.1
  friskvård_1_N = mkN "friskvård" ; -- friskvård..nn.1
  friskytt_1_N = mkN "friskytt" ; -- friskytt..nn.1
  frislag_1_N = mkN "frislag" neutrum  ; -- frislag..nn.1
  frisläppa_1_V = mkV "frisläpper" ; -- frisläppa..vb.1
  frisläppande_1_N = mkN "frisläppande" ; -- frisläppande..nn.1
  frispark_1_N = mkN "frispark" ; -- frispark..nn.1
  frispel_1_N = mkN "frispel" "frispelet" "frispel" "frispelen" ; -- frispel..nn.1
  frispela_1_V = mkV "frispelar" ; -- frispela..vb.1
  frispelande_1_N = mkN "frispelande" ; -- frispelande..nn.1
  frispråkig_1_A = mkA "frispråkig" ; -- frispråkig..av.1
  frispråkighet_1_N = mkN "frispråkighet" "frispråkigheter" ; -- frispråkighet..nn.1
  frissa_1_N = mkN "frissa" ; -- frissa..nn.1
  frist_1_N = mkN "frist" "frister" ; -- frist..nn.1
  fristad_1_N = mkN "fristad" "fristäder" ; -- fristad..nn.1
  fristat_1_N = mkN "fristat" "fristater" ; -- fristat..nn.1
  fristil_1_N = mkN "fristil" ; -- fristil..nn.1
  friställa_1_V = mkV "friställer" ; -- friställa..vb.1
  friställande_1_N = mkN "friställande" ; -- friställande..nn.1
  fristående_1_A = mkA "fristående" ; -- fristående..av.1
  frisyr_1_N = mkN "frisyr" "frisyrer" ; -- frisyr..nn.1
  frisyrgelé_1_N = mkN "frisyrgelé" "frisyrgeléer" ; -- frisyrgelé..nn.1
  frisäga_1_V = mkV "frisäga" "frisade" "frisagt" ; -- frisäga..vb.1
  frisägande_1_N = mkN "frisägande" ; -- frisägande..nn.1
  frisägelse_1_N = mkN "frisägelse" "frisägelser" ; -- frisägelse..nn.1
  frisätta_1_V = mkV "frisätta" "frisätter" "frisätt" "frisatte" "frisatt" "frisatt" ; -- frisätta..vb.1
  frisättande_1_N = mkN "frisättande" ; -- frisättande..nn.1
  frisör_1_N = mkN "frisör" "frisörer" ; -- frisör..nn.1
  frisörelev_1_N = mkN "frisörelev" "frisörelever" ; -- frisörelev..nn.1
  frisörsalong_1_N = mkN "frisörsalong" "frisörsalonger" ; -- frisörsalong..nn.1
  frisörska_1_N = mkN "frisörska" ; -- frisörska..nn.1
  frisörstol_1_N = mkN "frisörstol" ; -- frisörstol..nn.1
  frita_1_V = mkV "fritaga" "fritog" "fritagit" ; -- frita..vb.1
  fritagande_1_N = mkN "fritagande" ; -- fritagande..nn.1
  fritagen_1_A = mkA "fritagen" ; -- fritagen..av.1
  fritagning_1_N = mkN "fritagning" ; -- fritagning..nn.1
  fritagningsförsök_1_N = mkN "fritagningsförsök" neutrum  ; -- fritagningsförsök..nn.1
  fritera_1_V = mkV "friterar" ; -- fritera..vb.1
  friterande_1_N = mkN "friterande" ; -- friterande..nn.1
  friterbar_1_A = mkA "friterbar" ; -- friterbar..av.1
  friterbarhet_1_N = mkN "friterbarhet" ; -- friterbarhet..nn.1
  fritering_1_N = mkN "fritering" ; -- fritering..nn.1
  friteringsfett_1_N = mkN "friteringsfett" neutrum  ; -- friteringsfett..nn.1
  fritid_1_N = mkN "fritid" ; -- fritid..nn.1
  fritidsaktivitet_1_N = mkN "fritidsaktivitet" "fritidsaktiviteter" ; -- fritidsaktivitet..nn.1
  fritidsbebyggelse_1_N = mkN "fritidsbebyggelse" "fritidsbebyggelser" ; -- fritidsbebyggelse..nn.1
  fritidsby_1_N = mkN "fritidsby" "fritidsbyn" "fritidsbyar" "fritidsbyarna" ; -- fritidsby..nn.1
  fritidsbåt_1_N = mkN "fritidsbåt" ; -- fritidsbåt..nn.1
  fritidsförvaltning_1_N = mkN "fritidsförvaltning" ; -- fritidsförvaltning..nn.1
  fritidsgård_1_N = mkN "fritidsgård" ; -- fritidsgård..nn.1
  fritidshem_1_N = mkN "fritidshem" "fritidshemmet" "fritidshem" "fritidshemmen" ; -- fritidshem..nn.1
  fritidshus_1_N = mkN "fritidshus" neutrum  ; -- fritidshus..nn.1
  fritidshusägare_1_N = mkN "fritidshusägare" utrum  ; -- fritidshusägare..nn.1
  fritidsklädsel_1_N = mkN "fritidsklädsel" ; -- fritidsklädsel..nn.1
  fritidsledare_1_N = mkN "fritidsledare" utrum  ; -- fritidsledare..nn.1
  fritidslokal_1_N = mkN "fritidslokal" "fritidslokaler" ; -- fritidslokal..nn.1
  fritidsnämnd_1_N = mkN "fritidsnämnd" "fritidsnämnder" ; -- fritidsnämnd..nn.1
  fritidsområde_1_N = mkN "fritidsområde" ; -- fritidsområde..nn.1
  fritidspedagog_1_N = mkN "fritidspedagog" "fritidspedagoger" ; -- fritidspedagog..nn.1
  fritidspolitik_1_N = mkN "fritidspolitik" ; -- fritidspolitik..nn.1
  fritidspolitiker_1_N = mkN "fritidspolitiker" "fritidspolitikern" "fritidspolitiker" "fritidspolitikerna" ; -- fritidspolitiker..nn.1
  fritidspolitisk_1_A = mkA "fritidspolitisk" ; -- fritidspolitisk..av.1
  fritidsproblem_1_N = mkN "fritidsproblem" neutrum  ; -- fritidsproblem..nn.1
  fritidsstuga_1_N = mkN "fritidsstuga" ; -- fritidsstuga..nn.1
  fritidssysselsättning_1_N = mkN "fritidssysselsättning" ; -- fritidssysselsättning..nn.1
  fritis_1_N = mkN "fritis" neutrum  ; -- fritis..nn.1
  frityr_1_N = mkN "frityr" "frityrer" ; -- frityr..nn.1
  frityrdeg_1_N = mkN "frityrdeg" ; -- frityrdeg..nn.1
  fritänkande_1_A = mkA "fritänkande" ; -- fritänkande..av.1
  fritänkare_1_N = mkN "fritänkare" utrum  ; -- fritänkare..nn.1
  fritänkeri_1_N = mkN "fritänkeri" neutrum  ; -- fritänkeri..nn.1
  frivakt_1_N = mkN "frivakt" "frivakter" ; -- frivakt..nn.1
  frivecka_1_N = mkN "frivecka" ; -- frivecka..nn.1
  frivillig_1_A = mkA "frivillig" ; -- frivillig..av.1
  frivillighet_1_N = mkN "frivillighet" "frivilligheter" ; -- frivillighet..nn.1
  frivilligorganisation_1_N = mkN "frivilligorganisation" ; -- frivilligorganisation..nn.1
  frivilligtjänst_1_N = mkN "frivilligtjänst" ; -- frivilligtjänst..nn.1
  frivol_1_A = mkA "frivol" ; -- frivol..av.1
  frivolitet_1_N = mkN "frivolitet" "frivoliteter" ; -- frivolitet..nn.1
  frivolt_1_N = mkN "frivolt" "frivolter" ; -- frivolt..nn.1
  frivård_1_N = mkN "frivård" ; -- frivård..nn.1
  frizon_1_N = mkN "frizon" "frizoner" ; -- frizon..nn.1
  friåkning_1_N = mkN "friåkning" ; -- friåkning..nn.1
  friår_1_N = mkN "friår" neutrum  ; -- friår..nn.1
  frodig_1_A = mkA "frodig" ; -- frodig..av.1
  frodighet_1_N = mkN "frodighet" ; -- frodighet..nn.1
  from_1_A = mkA "from" "fromt" "fromma" "fromma" "frommare" "frommast" "frommaste" ; -- from..av.1
  fromage_1_N = mkN "fromage" "fromager" ; -- fromage..nn.1
  fromhet_1_N = mkN "fromhet" "fromheter" ; -- fromhet..nn.1
  fromhet_2_N = mkN "fromhet" ; -- fromhet..nn.2
  fromhetsiver_1_N = mkN "fromhetsiver" ; -- fromhetsiver..nn.1
  fromla_1_V = mkV "fromlar" ; -- fromla..vb.1
  fromlande_1_N = mkN "fromlande" ; -- fromlande..nn.1
  fromleri_1_N = mkN "fromleri" neutrum  ; -- fromleri..nn.1
  fromsint_1_A = mkA "fromsint" "fromsint" ; -- fromsint..av.1
  fromsinthet_1_N = mkN "fromsinthet" ; -- fromsinthet..nn.1
  frondera_1_V = mkV "fronderar" ; -- frondera..vb.1
  fronderande_1_N = mkN "fronderande" ; -- fronderande..nn.1
  fronderbar_1_A = mkA "fronderbar" ; -- fronderbar..av.1
  fronderbarhet_1_N = mkN "fronderbarhet" ; -- fronderbarhet..nn.1
  frondering_1_N = mkN "frondering" ; -- frondering..nn.1
  frondör_1_N = mkN "frondör" "frondörer" ; -- frondör..nn.1
  front_1_N = mkN "front" "fronter" ; -- front..nn.1
  fronta_1_V = mkV "frontar" ; -- fronta..vb.1
  frontal_1_A = mkA "frontal" ; -- frontal..av.1
  frontalangrepp_1_N = mkN "frontalangrepp" neutrum  ; -- frontalangrepp..nn.1
  frontalkrock_1_N = mkN "frontalkrock" ; -- frontalkrock..nn.1
  frontalkrocka_1_V = mkV "frontalkrockar" ; -- frontalkrocka..vb.1
  frontalkrockande_1_N = mkN "frontalkrockande" ; -- frontalkrockande..nn.1
  frontallob_1_N = mkN "frontallob" "frontallober" ; -- frontallob..nn.1
  frontallobsstörning_1_N = mkN "frontallobsstörning" ; -- frontallobsstörning..nn.1
  frontande_1_N = mkN "frontande" ; -- frontande..nn.1
  frontanfall_1_N = mkN "frontanfall" neutrum  ; -- frontanfall..nn.1
  frontavsnitt_1_N = mkN "frontavsnitt" neutrum  ; -- frontavsnitt..nn.1
  frontbildning_1_N = mkN "frontbildning" ; -- frontbildning..nn.1
  frontespis_1_N = mkN "frontespis" "frontespiser" ; -- frontespis..nn.1
  frontfigur_1_N = mkN "frontfigur" "frontfigurer" ; -- frontfigur..nn.1
  frontförbindelse_1_N = mkN "frontförbindelse" "frontförbindelser" ; -- frontförbindelse..nn.1
  frontkommendering_1_N = mkN "frontkommendering" ; -- frontkommendering..nn.1
  frontlinje_1_N = mkN "frontlinje" "frontlinjer" ; -- frontlinje..nn.1
  frontmatad_1_A = mkA "frontmatad" ; -- frontmatad..av.1
  frontmonterad_1_A = mkA "frontmonterad" ; -- frontmonterad..av.1
  frontnederbörd_1_N = mkN "frontnederbörd" ; -- frontnederbörd..nn.1
  fronton_1_N = mkN "fronton" "frontoner" ; -- fronton..nn.1
  frontong_1_N = mkN "frontong" "frontonger" ; -- frontong..nn.1
  frontsoldat_1_N = mkN "frontsoldat" "frontsoldater" ; -- frontsoldat..nn.1
  fronttjänst_1_N = mkN "fronttjänst" ; -- fronttjänst..nn.1
  fronttjänstgöring_1_N = mkN "fronttjänstgöring" ; -- fronttjänstgöring..nn.1
  frontzon_1_N = mkN "frontzon" "frontzoner" ; -- frontzon..nn.1
  frosch_1_N = mkN "frosch" "froscher" ; -- frosch..nn.1
  frossa_1_N = mkN "frossa" ; -- frossa..nn.1
  frossa_1_V = mkV "frossar" ; -- frossa..vb.1
  frossande_1_N = mkN "frossande" ; -- frossande..nn.1
  frossanfall_1_N = mkN "frossanfall" neutrum  ; -- frossanfall..nn.1
  frossare_1_N = mkN "frossare" utrum  ; -- frossare..nn.1
  frossbrytning_1_N = mkN "frossbrytning" ; -- frossbrytning..nn.1
  frosseri_1_N = mkN "frosseri" neutrum  ; -- frosseri..nn.1
  frossfeber_1_N = mkN "frossfeber" ; -- frossfeber..nn.1
  frosskakning_1_N = mkN "frosskakning" ; -- frosskakning..nn.1
  frosskänning_1_N = mkN "frosskänning" ; -- frosskänning..nn.1
  frost_1_N = mkN "frost" ; -- frost..nn.1
  frosta_1_V = mkV "frostar" ; -- frosta..vb.1
  frostande_1_N = mkN "frostande" ; -- frostande..nn.1
  frostbiten_1_A = mkA "frostbiten" ; -- frostbiten..av.1
  frostdimma_1_N = mkN "frostdimma" ; -- frostdimma..nn.1
  frostfjäril_1_N = mkN "frostfjäril" ; -- frostfjäril..nn.1
  frostfri_1_A = mkA "frostfri" "frostfritt" ; -- frostfri..av.1
  frosthärdig_1_A = mkA "frosthärdig" ; -- frosthärdig..av.1
  frosthärdighet_1_N = mkN "frosthärdighet" "frosthärdigheter" ; -- frosthärdighet..nn.1
  frostig_1_A = mkA "frostig" ; -- frostig..av.1
  frostighet_1_N = mkN "frostighet" ; -- frostighet..nn.1
  frostkänslig_1_A = mkA "frostkänslig" ; -- frostkänslig..av.1
  frostkänslighet_1_N = mkN "frostkänslighet" "frostkänsligheter" ; -- frostkänslighet..nn.1
  frostnatt_1_N = mkN "frostnatt" "frostnätter" ; -- frostnatt..nn.1
  frostning_1_N = mkN "frostning" ; -- frostning..nn.1
  frostskada_1_N = mkN "frostskada" ; -- frostskada..nn.1
  frostskadad_1_A = mkA "frostskadad" ; -- frostskadad..av.1
  frostskyddsvätska_1_N = mkN "frostskyddsvätska" ; -- frostskyddsvätska..nn.1
  frostsprängning_1_N = mkN "frostsprängning" ; -- frostsprängning..nn.1
  frosttålig_1_A = mkA "frosttålig" ; -- frosttålig..av.1
  frosttålighet_1_N = mkN "frosttålighet" ; -- frosttålighet..nn.1
  frottera_1_V = mkV "frotterar" ; -- frottera..vb.1
  frotterande_1_N = mkN "frotterande" ; -- frotterande..nn.1
  frotterbar_1_A = mkA "frotterbar" ; -- frotterbar..av.1
  frotterbarhet_1_N = mkN "frotterbarhet" ; -- frotterbarhet..nn.1
  frottering_1_N = mkN "frottering" ; -- frottering..nn.1
  frotté_1_N = mkN "frotté" "frottéer" ; -- frotté..nn.1
  frottéhandduk_1_N = mkN "frottéhandduk" ; -- frottéhandduk..nn.1
  frottérock_1_N = mkN "frottérock" ; -- frottérock..nn.1
  frottör_1_N = mkN "frottör" "frottörn" "frottörer" "frottörerna" ; -- frottör..nn.1
  fru_1_N = mkN "fru" ; -- fru..nn.1
  fruga_1_N = mkN "fruga" ; -- fruga..nn.1
  frugal_1_A = mkA "frugal" ; -- frugal..av.1
  frugalitet_1_N = mkN "frugalitet" "frugaliteter" ; -- frugalitet..nn.1
  frukost_1_N = mkN "frukost" ; -- frukost..nn.1
  frukostbord_1_N = mkN "frukostbord" neutrum  ; -- frukostbord..nn.1
  frukostbricka_1_N = mkN "frukostbricka" ; -- frukostbricka..nn.1
  frukostbuffé_1_N = mkN "frukostbuffé" "frukostbufféer" ; -- frukostbuffé..nn.1
  frukostdags_1_N = mkN "frukostdags" ; -- frukostdags..nn.1
  frukostera_1_V = mkV "frukosterar" ; -- frukostera..vb.1
  frukosterande_1_N = mkN "frukosterande" ; -- frukosterande..nn.1
  frukostering_1_N = mkN "frukostering" ; -- frukostering..nn.1
  frukostmeny_1_N = mkN "frukostmeny" "frukostmenyer" ; -- frukostmeny..nn.1
  frukostmiddag_1_N = mkN "frukostmiddag" ; -- frukostmiddag..nn.1
  frukostrast_1_N = mkN "frukostrast" "frukostraster" ; -- frukostrast..nn.1
  frukostvärdinna_1_N = mkN "frukostvärdinna" ; -- frukostvärdinna..nn.1
  frukostägg_1_N = mkN "frukostägg" neutrum  ; -- frukostägg..nn.1
  frukostätare_1_N = mkN "frukostätare" utrum  ; -- frukostätare..nn.1
  frukt_1_N = mkN "frukt" "frukter" ; -- frukt..nn.1
  frukta_1_V = mkV "fruktar" ; -- frukta..vb.1
  fruktaffär_1_N = mkN "fruktaffär" "fruktaffärer" ; -- fruktaffär..nn.1
  fruktande_1_N = mkN "fruktande" ; -- fruktande..nn.1
  fruktansvärd_1_A = mkA "fruktansvärd" "fruktansvärt" ; -- fruktansvärd..av.1
  fruktansvärdhet_1_N = mkN "fruktansvärdhet" ; -- fruktansvärdhet..nn.1
  fruktansvärt_1_Adv = mkAdv "fruktansvärt" ; -- fruktansvärt..ab.1
  fruktbar_1_A = mkA "fruktbar" ; -- fruktbar..av.1
  fruktbarhet_1_N = mkN "fruktbarhet" "fruktbarheter" ; -- fruktbarhet..nn.1
  fruktbarhetsgud_1_N = mkN "fruktbarhetsgud" ; -- fruktbarhetsgud..nn.1
  fruktbildning_1_N = mkN "fruktbildning" ; -- fruktbildning..nn.1
  fruktbringande_1_A = mkA "fruktbringande" ; -- fruktbringande..av.1
  fruktbärande_1_A = mkA "fruktbärande" ; -- fruktbärande..av.1
  frukthandlare_1_N = mkN "frukthandlare" utrum  ; -- frukthandlare..nn.1
  fruktig_1_A = mkA "fruktig" ; -- fruktig..av.1
  fruktighet_1_N = mkN "fruktighet" ; -- fruktighet..nn.1
  fruktkaka_1_N = mkN "fruktkaka" ; -- fruktkaka..nn.1
  fruktkniv_1_N = mkN "fruktkniv" ; -- fruktkniv..nn.1
  fruktkompott_1_N = mkN "fruktkompott" "fruktkompotter" ; -- fruktkompott..nn.1
  fruktkorg_1_N = mkN "fruktkorg" ; -- fruktkorg..nn.1
  fruktkärna_1_N = mkN "fruktkärna" ; -- fruktkärna..nn.1
  fruktkött_1_N = mkN "fruktkött" neutrum  ; -- fruktkött..nn.1
  fruktliknande_1_A = mkA "fruktliknande" ; -- fruktliknande..av.1
  fruktlös_1_A = mkA "fruktlös" ; -- fruktlös..av.1
  fruktlöshet_1_N = mkN "fruktlöshet" ; -- fruktlöshet..nn.1
  fruktodlare_1_N = mkN "fruktodlare" utrum  ; -- fruktodlare..nn.1
  fruktodling_1_N = mkN "fruktodling" ; -- fruktodling..nn.1
  fruktos_1_N = mkN "fruktos" ; -- fruktos..nn.1
  fruktplockare_1_N = mkN "fruktplockare" utrum  ; -- fruktplockare..nn.1
  fruktpåse_1_N = mkN "fruktpåse" utrum  ; -- fruktpåse..nn.1
  fruktsaft_1_N = mkN "fruktsaft" "fruktsafter" ; -- fruktsaft..nn.1
  fruktsallad_1_N = mkN "fruktsallad" "fruktsallader" ; -- fruktsallad..nn.1
  fruktsalt_1_N = mkN "fruktsalt" neutrum  ; -- fruktsalt..nn.1
  fruktsam_1_A = mkA "fruktsam" "fruktsamt" "fruktsamma" "fruktsamma" "fruktsammare" "fruktsammast" "fruktsammaste" ; -- fruktsam..av.1
  fruktsamhet_1_N = mkN "fruktsamhet" ; -- fruktsamhet..nn.1
  fruktskorv_1_N = mkN "fruktskorv" ; -- fruktskorv..nn.1
  fruktskål_1_N = mkN "fruktskål" ; -- fruktskål..nn.1
  fruktskörd_1_N = mkN "fruktskörd" ; -- fruktskörd..nn.1
  fruktsmak_1_N = mkN "fruktsmak" "fruktsmaker" ; -- fruktsmak..nn.1
  fruktsocker_1_N = mkN "fruktsocker" neutrum  ; -- fruktsocker..nn.1
  fruktsoppa_1_N = mkN "fruktsoppa" ; -- fruktsoppa..nn.1
  fruktsort_1_N = mkN "fruktsort" "fruktsorter" ; -- fruktsort..nn.1
  fruktsporre_1_N = mkN "fruktsporre" utrum  ; -- fruktsporre..nn.1
  fruktsättning_1_N = mkN "fruktsättning" ; -- fruktsättning..nn.1
  fruktsås_1_N = mkN "fruktsås" "fruktsåser" ; -- fruktsås..nn.1
  frukttallrik_1_N = mkN "frukttallrik" ; -- frukttallrik..nn.1
  fruktträd_1_N = mkN "fruktträd" neutrum  ; -- fruktträd..nn.1
  fruktträdgård_1_N = mkN "fruktträdgård" ; -- fruktträdgård..nn.1
  fruktved_1_N = mkN "fruktved" ; -- fruktved..nn.1
  fruktvin_1_N = mkN "fruktvin" "fruktvinet" "fruktviner" "fruktvinerna" ; -- fruktvin..nn.1
  fruktvägg_1_N = mkN "fruktvägg" ; -- fruktvägg..nn.1
  fruktämne_1_N = mkN "fruktämne" ; -- fruktämne..nn.1
  frunch_1_N = mkN "frunch" "fruncher" ; -- frunch..nn.1
  fruntimmer_1_N = mkN "fruntimmer" neutrum  ; -- fruntimmer..nn.1
  fruntimmerskarl_1_N = mkN "fruntimmerskarl" ; -- fruntimmerskarl..nn.1
  fruntimmersvecka_1_N = mkN "fruntimmersvecka" ; -- fruntimmersvecka..nn.1
  frusa_1_V = mkV "frusar" ; -- frusa..vb.1
  frusande_1_N = mkN "frusande" ; -- frusande..nn.1
  frusen_1_A = mkA "frusen" ; -- frusen..av.1
  frusenhet_1_N = mkN "frusenhet" ; -- frusenhet..nn.1
  frusning_1_N = mkN "frusning" ; -- frusning..nn.1
  frusta_1_V = mkV "frustar" ; -- frusta..vb.1
  frustande_1_N = mkN "frustande" ; -- frustande..nn.1
  frustning_1_N = mkN "frustning" ; -- frustning..nn.1
  frustration_1_N = mkN "frustration" ; -- frustration..nn.1
  frustrera_1_V = mkV "frustrerar" ; -- frustrera..vb.1
  frustrerad_1_A = mkA "frustrerad" ; -- frustrerad..av.1
  frustrerande_1_N = mkN "frustrerande" ; -- frustrerande..nn.1
  frustrerbar_1_A = mkA "frustrerbar" ; -- frustrerbar..av.1
  frustrerbarhet_1_N = mkN "frustrerbarhet" ; -- frustrerbarhet..nn.1
  frustrering_1_N = mkN "frustrering" ; -- frustrering..nn.1
  fryna_1_V = mkV "fryna" "frynte" "frynt" ; -- fryna..vb.1
  frynande_1_N = mkN "frynande" ; -- frynande..nn.1
  fryntlig_1_A = mkA "fryntlig" ; -- fryntlig..av.1
  fryntlighet_1_N = mkN "fryntlighet" "fryntligheter" ; -- fryntlighet..nn.1
  frys_1_N = mkN "frys" ; -- frys..nn.1
  frysande_1_N = mkN "frysande" ; -- frysande..nn.1
  frysbox_1_N = mkN "frysbox" ; -- frysbox..nn.1
  frysdisk_1_N = mkN "frysdisk" ; -- frysdisk..nn.1
  fryseri_1_N = mkN "fryseri" "fryseriet" "fryserier" "fryserierna" ; -- fryseri..nn.1
  frysfack_1_N = mkN "frysfack" neutrum  ; -- frysfack..nn.1
  frysförpackning_1_N = mkN "frysförpackning" ; -- frysförpackning..nn.1
  frysförsök_1_N = mkN "frysförsök" neutrum  ; -- frysförsök..nn.1
  frysloppa_1_N = mkN "frysloppa" ; -- frysloppa..nn.1
  frysning_1_N = mkN "frysning" ; -- frysning..nn.1
  fryspunkt_1_N = mkN "fryspunkt" "fryspunkter" ; -- fryspunkt..nn.1
  frysrum_1_N = mkN "frysrum" "frysrummet" "frysrum" "frysrummen" ; -- frysrum..nn.1
  fryst_1_A = mkA "fryst" "fryst" ; -- fryst..av.1
  frystejp_1_N = mkN "frystejp" ; -- frystejp..nn.1
  frystest_1_N = mkN "frystest" neutrum  ; -- frystest..nn.1
  frystesta_1_V = mkV "frystestar" ; -- frystesta..vb.1
  frystestande_1_N = mkN "frystestande" ; -- frystestande..nn.1
  frystorka_1_V = mkV "frystorkar" ; -- frystorka..vb.1
  frystorkande_1_N = mkN "frystorkande" ; -- frystorkande..nn.1
  frystålig_1_A = mkA "frystålig" ; -- frystålig..av.1
  frystålighet_1_N = mkN "frystålighet" ; -- frystålighet..nn.1
  fräck_1_A = mkA "fräck" ; -- fräck..av.1
  fräckhet_1_N = mkN "fräckhet" "fräckheter" ; -- fräckhet..nn.1
  fräckis_1_N = mkN "fräckis" ; -- fräckis..nn.1
  fräken_1_N = mkN "fräken" "fräkenn" "fräknar" "fräknarna" ; -- fräken..nn.1
  fräkne_1_N = mkN "fräkne" utrum  ; -- fräkne..nn.1
  fräknig_1_A = mkA "fräknig" ; -- fräknig..av.1
  fräknighet_1_N = mkN "fräknighet" ; -- fräknighet..nn.1
  frälsa_1_V = mkV "frälser" ; -- frälsa..vb.1
  frälsande_1_N = mkN "frälsande" ; -- frälsande..nn.1
  frälsare_1_N = mkN "frälsare" utrum  ; -- frälsare..nn.1
  frälsarkrans_1_N = mkN "frälsarkrans" ; -- frälsarkrans..nn.1
  frälse_1_A = mkA "frälse" ; -- frälse..av.1
  frälse_1_N = mkN "frälse" ; -- frälse..nn.1
  frälsebonde_1_N = mkN "frälsebonde" "frälsebönder" ; -- frälsebonde..nn.1
  frälsegods_1_N = mkN "frälsegods" neutrum  ; -- frälsegods..nn.1
  frälsehemman_1_N = mkN "frälsehemman" neutrum  ; -- frälsehemman..nn.1
  frälsejord_1_N = mkN "frälsejord" ; -- frälsejord..nn.1
  frälseman_1_N = mkN "frälseman" "frälsemannen" "frälsemän" "frälsemännen" ; -- frälseman..nn.1
  frälsning_1_N = mkN "frälsning" ; -- frälsning..nn.1
  frälsningsmöte_1_N = mkN "frälsningsmöte" ; -- frälsningsmöte..nn.1
  frälsningssoldat_1_N = mkN "frälsningssoldat" "frälsningssoldater" ; -- frälsningssoldat..nn.1
  frälsningsupplevelse_1_N = mkN "frälsningsupplevelse" "frälsningsupplevelser" ; -- frälsningsupplevelse..nn.1
  frälst_1_A = mkA "frälst" "frälst" ; -- frälst..av.1
  frälsthet_1_N = mkN "frälsthet" ; -- frälsthet..nn.1
  främja_1_V = mkV "främjar" ; -- främja..vb.1
  främjande_1_N = mkN "främjande" ; -- främjande..nn.1
  främjare_1_N = mkN "främjare" utrum  ; -- främjare..nn.1
  främling_1_N = mkN "främling" ; -- främling..nn.1
  främlingsfientlig_1_A = mkA "främlingsfientlig" ; -- främlingsfientlig..av.1
  främlingsfientlighet_1_N = mkN "främlingsfientlighet" ; -- främlingsfientlighet..nn.1
  främlingshat_1_N = mkN "främlingshat" neutrum  ; -- främlingshat..nn.1
  främlingskap_1_N = mkN "främlingskap" neutrum  ; -- främlingskap..nn.1
  främlingslegion_1_N = mkN "främlingslegion" ; -- främlingslegion..nn.1
  främlingslegionär_1_N = mkN "främlingslegionär" "främlingslegionärer" ; -- främlingslegionär..nn.1
  främlingspass_1_N = mkN "främlingspass" neutrum  ; -- främlingspass..nn.1
  främmande_1_A = mkA "främmande" ; -- främmande..av.1
  främmande_1_N = mkN "främmande" ; -- främmande..nn.1
  främmat_1_A = mkA "främmat" ; -- främmat..av.1
  främre_1_A = mkA "främre" ; -- främre..av.1
  främst_1_Adv = mkAdv "främst" ; -- främst..ab.1
  frän_1_A = mkA "frän" ; -- frän..av.1
  frände_1_N = mkN "frände" "fränder" ; -- frände..nn.1
  frändskap_1_N = mkN "frändskap" "frändskaper" ; -- frändskap..nn.1
  fränhet_1_N = mkN "fränhet" ; -- fränhet..nn.1
  fränka_1_N = mkN "fränka" ; -- fränka..nn.1
  fräs_1_N = mkN "fräs" ; -- fräs..nn.1
  fräs_2_N = mkN "fräs" neutrum  ; -- fräs..nn.2
  fräsa_1_V = mkV "fräser" ; -- fräsa..vb.1
  fräsa_2_V = mkV "fräser" ; -- fräsa..vb.2
  fräsande_1_N = mkN "fräsande" ; -- fräsande..nn.1
  fräsch_1_A = mkA "fräsch" ; -- fräsch..av.1
  fräschhet_1_N = mkN "fräschhet" ; -- fräschhet..nn.1
  fräschör_1_N = mkN "fräschör" ; -- fräschör..nn.1
  fräsig_1_A = mkA "fräsig" ; -- fräsig..av.1
  fräsmaskin_1_N = mkN "fräsmaskin" "fräsmaskiner" ; -- fräsmaskin..nn.1
  fräsning_1_N = mkN "fräsning" ; -- fräsning..nn.1
  frässtål_1_N = mkN "frässtål" neutrum  ; -- frässtål..nn.1
  fräta_1_N = mkN "fräta" ; -- fräta..nn.1
  fräta_1_V = mkV "fräter" ; -- fräta..vb.1
  frätande_1_A = mkA "frätande" ; -- frätande..av.1
  frätande_1_N = mkN "frätande" ; -- frätande..nn.1
  frätning_1_N = mkN "frätning" ; -- frätning..nn.1
  frätskada_1_N = mkN "frätskada" ; -- frätskada..nn.1
  fråga_1_N = mkN "fråga" ; -- fråga..nn.1
  fråga_1_V = mkV "frågar" ; -- fråga..vb.1
  fråga_2_V = mkV "frågar" ; -- fråga..vb.2
  frågande_1_N = mkN "frågande" ; -- frågande..nn.1
  frågeform_1_N = mkN "frågeform" "frågeformer" ; -- frågeform..nn.1
  frågeformulär_1_N = mkN "frågeformulär" neutrum  ; -- frågeformulär..nn.1
  frågementalitet_1_N = mkN "frågementalitet" "frågementaliteter" ; -- frågementalitet..nn.1
  frågeord_1_N = mkN "frågeord" neutrum  ; -- frågeord..nn.1
  frågesats_1_N = mkN "frågesats" "frågesatser" ; -- frågesats..nn.1
  frågespalt_1_N = mkN "frågespalt" "frågespalter" ; -- frågespalt..nn.1
  frågesport_1_N = mkN "frågesport" "frågesporter" ; -- frågesport..nn.1
  frågestund_1_N = mkN "frågestund" "frågestunder" ; -- frågestund..nn.1
  frågeställare_1_N = mkN "frågeställare" utrum  ; -- frågeställare..nn.1
  frågeställning_1_N = mkN "frågeställning" ; -- frågeställning..nn.1
  frågetecken_1_N = mkN "frågetecken" "frågetecknet" "frågetecken" "frågetecknen" ; -- frågetecken..nn.1
  frågetest_1_N = mkN "frågetest" neutrum  ; -- frågetest..nn.1
  frågeton_1_N = mkN "frågeton" "frågetoner" ; -- frågeton..nn.1
  frågetävling_1_N = mkN "frågetävling" ; -- frågetävling..nn.1
  frågvis_1_A = mkA "frågvis" ; -- frågvis..av.1
  frågvishet_1_N = mkN "frågvishet" ; -- frågvishet..nn.1
  fråndockning_1_N = mkN "fråndockning" ; -- fråndockning..nn.1
  fråndragning_1_N = mkN "fråndragning" ; -- fråndragning..nn.1
  fråndöma_1_V = mkV "fråndömer" ; -- fråndöma..vb.1
  fråndömande_1_N = mkN "fråndömande" ; -- fråndömande..nn.1
  frånfälle_1_N = mkN "frånfälle" ; -- frånfälle..nn.1
  frångå_1_V = mkV "frångå" "frångick" "frångått" ; -- frångå..vb.1
  frångående_1_N = mkN "frångående" ; -- frångående..nn.1
  frånkoppling_1_N = mkN "frånkoppling" ; -- frånkoppling..nn.1
  frånkänna_1_V = mkV "frånkänna" "frånkände" "frånkänt" ; -- frånkänna..vb.1
  frånkännande_1_N = mkN "frånkännande" ; -- frånkännande..nn.1
  frånkörd_1_A = mkA "frånkörd" "frånkört" ; -- frånkörd..av.1
  frånlandsvind_1_N = mkN "frånlandsvind" ; -- frånlandsvind..nn.1
  frånräkna_1_V = mkV "frånräknar" ; -- frånräkna..vb.1
  frånräknande_1_N = mkN "frånräknande" ; -- frånräknande..nn.1
  frånräkning_1_N = mkN "frånräkning" ; -- frånräkning..nn.1
  frånse_1_V = mkV "frånse" "frånsåg" "frånsett" ; -- frånse..vb.1
  frånseende_1_N = mkN "frånseende" ; -- frånseende..nn.1
  frånsida_1_N = mkN "frånsida" ; -- frånsida..nn.1
  frånsilning_1_N = mkN "frånsilning" ; -- frånsilning..nn.1
  frånskilja_1_V = mkV "frånskilja" "frånskilde" "frånskilt" ; -- frånskilja..vb.1
  frånskiljande_1_N = mkN "frånskiljande" ; -- frånskiljande..nn.1
  frånskiljare_1_N = mkN "frånskiljare" utrum  ; -- frånskiljare..nn.1
  frånskiljbar_1_A = mkA "frånskiljbar" ; -- frånskiljbar..av.1
  frånskiljbarhet_1_N = mkN "frånskiljbarhet" ; -- frånskiljbarhet..nn.1
  frånskiljning_1_N = mkN "frånskiljning" ; -- frånskiljning..nn.1
  frånskruvning_1_N = mkN "frånskruvning" ; -- frånskruvning..nn.1
  frånslitning_1_N = mkN "frånslitning" ; -- frånslitning..nn.1
  frånspela_1_V = mkV "frånspelar" ; -- frånspela..vb.1
  frånspelande_1_N = mkN "frånspelande" ; -- frånspelande..nn.1
  frånspännande_1_N = mkN "frånspännande" ; -- frånspännande..nn.1
  frånspänning_1_N = mkN "frånspänning" ; -- frånspänning..nn.1
  frånstötande_1_A = mkA "frånstötande" ; -- frånstötande..av.1
  frånta_1_V = mkV "fråntaga" "fråntog" "fråntagit" ; -- frånta..vb.1
  fråntagande_1_N = mkN "fråntagande" ; -- fråntagande..nn.1
  frånträda_1_V = mkV "frånträda" "frånträdde" "frånträtt" ; -- frånträda..vb.1
  frånträdande_1_N = mkN "frånträdande" ; -- frånträdande..nn.1
  frånträde_1_N = mkN "frånträde" ; -- frånträde..nn.1
  frånvarande_1_A = mkA "frånvarande" ; -- frånvarande..av.1
  frånvaro_1_N = mkN "frånvaro" ; -- frånvaro..nn.1
  frånvarodag_1_N = mkN "frånvarodag" ; -- frånvarodag..nn.1
  frånvänd_1_A = mkA "frånvänd" ; -- frånvänd..av.1
  frånåkt_1_A = mkA "frånåkt" "frånåkt" ; -- frånåkt..av.1
  frö_1_N = mkN "frö" "fröt" "frön" "fröen" ; -- frö..nn.1
  fröa_1_V = mkV "fröar" ; -- fröa..vb.1
  fröande_1_N = mkN "fröande" ; -- fröande..nn.1
  fröfäste_1_N = mkN "fröfäste" ; -- fröfäste..nn.1
  frögömme_1_N = mkN "frögömme" ; -- frögömme..nn.1
  fröhus_1_N = mkN "fröhus" neutrum  ; -- fröhus..nn.1
  fröhylsa_1_N = mkN "fröhylsa" ; -- fröhylsa..nn.1
  fröjd_1_N = mkN "fröjd" "fröjder" ; -- fröjd..nn.1
  fröjda_1_V = mkV "fröjdar" ; -- fröjda..vb.1
  fröjdande_1_N = mkN "fröjdande" ; -- fröjdande..nn.1
  fröjdefull_1_A = mkA "fröjdefull" ; -- fröjdefull..av.1
  fröjdefullhet_1_N = mkN "fröjdefullhet" ; -- fröjdefullhet..nn.1
  fröjderik_1_A = mkA "fröjderik" ; -- fröjderik..av.1
  frökapsel_1_N = mkN "frökapsel" ; -- frökapsel..nn.1
  fröken_1_N = mkN "fröken" ; -- fröken..nn.1
  frömjöl_1_N = mkN "frömjöl" neutrum  ; -- frömjöl..nn.1
  fröodling_1_N = mkN "fröodling" ; -- fröodling..nn.1
  fröparti_1_N = mkN "fröparti" "fröpartiet" "fröpartier" "fröpartierna" ; -- fröparti..nn.1
  fröplanta_1_N = mkN "fröplanta" ; -- fröplanta..nn.1
  fröplantage_1_N = mkN "fröplantage" "fröplantager" ; -- fröplantage..nn.1
  fröskal_1_N = mkN "fröskal" neutrum  ; -- fröskal..nn.1
  fröskida_1_N = mkN "fröskida" ; -- fröskida..nn.1
  frösort_1_N = mkN "frösort" "frösorter" ; -- frösort..nn.1
  frötall_1_N = mkN "frötall" ; -- frötall..nn.1
  fröträd_1_N = mkN "fröträd" neutrum  ; -- fröträd..nn.1
  frövita_1_N = mkN "frövita" ; -- frövita..nn.1
  fröväxt_1_N = mkN "fröväxt" "fröväxter" ; -- fröväxt..nn.1
  fröämne_1_N = mkN "fröämne" ; -- fröämne..nn.1
  ftalat_1_N = mkN "ftalat" "ftalater" ; -- ftalat..nn.1
  ftalsyra_1_N = mkN "ftalsyra" ; -- ftalsyra..nn.1
  fubb_1_N = mkN "fubb" neutrum  ; -- fubb..nn.1
  fuchsia_1_N = mkN "fuchsia" ; -- fuchsia..nn.1
  fuffens_1_N = mkN "fuffens" neutrum  ; -- fuffens..nn.1
  fuga_1_N = mkN "fuga" ; -- fuga..nn.1
  fugerad_1_A = mkA "fugerad" ; -- fugerad..av.1
  fugu_1_N = mkN "fugu" ; -- fugu..nn.1
  fuksin_1_N = mkN "fuksin" ; -- fuksin..nn.1
  fukt_1_N = mkN "fukt" ; -- fukt..nn.1
  fukta_1_V = mkV "fuktar" ; -- fukta..vb.1
  fuktande_1_N = mkN "fuktande" ; -- fuktande..nn.1
  fuktfläck_1_N = mkN "fuktfläck" ; -- fuktfläck..nn.1
  fuktfri_1_A = mkA "fuktfri" "fuktfritt" ; -- fuktfri..av.1
  fuktgivande_1_A = mkA "fuktgivande" ; -- fuktgivande..av.1
  fukthal_1_A = mkA "fukthal" ; -- fukthal..av.1
  fuktig_1_A = mkA "fuktig" ; -- fuktig..av.1
  fuktighet_1_N = mkN "fuktighet" "fuktigheter" ; -- fuktighet..nn.1
  fuktning_1_N = mkN "fuktning" ; -- fuktning..nn.1
  fuktskada_1_N = mkN "fuktskada" ; -- fuktskada..nn.1
  fuktskadad_1_A = mkA "fuktskadad" ; -- fuktskadad..av.1
  fukttekniker_1_N = mkN "fukttekniker" "fuktteknikern" "fukttekniker" "fuktteknikerna" ; -- fukttekniker..nn.1
  ful_1_A = mkA "ful" ; -- ful..av.1
  ful_1_N = mkN "ful" ; -- ful..nn.1
  fulhet_1_N = mkN "fulhet" "fulheter" ; -- fulhet..nn.1
  fuling_1_N = mkN "fuling" ; -- fuling..nn.1
  fulkultur_1_N = mkN "fulkultur" "fulkulturer" ; -- fulkultur..nn.1
  full_1_A = mkA "full" ; -- full..av.1
  fulladdad_1_A = mkA "fulladdad" ; -- fulladdad..av.1
  fullastad_1_A = mkA "fullastad" ; -- fullastad..av.1
  fullbelagd_1_A = mkA "fullbelagd" "fullbelagt" ; -- fullbelagd..av.1
  fullbetald_1_A = mkA "fullbetald" "fullbetalt" ; -- fullbetald..av.1
  fullbildad_1_A = mkA "fullbildad" ; -- fullbildad..av.1
  fullblod_1_N = mkN "fullblod" neutrum  ; -- fullblod..nn.1
  fullblodig_1_A = mkA "fullblodig" ; -- fullblodig..av.1
  fullblodighet_1_N = mkN "fullblodighet" ; -- fullblodighet..nn.1
  fullblodsaristokrat_1_N = mkN "fullblodsaristokrat" "fullblodsaristokrater" ; -- fullblodsaristokrat..nn.1
  fullblodshäst_1_N = mkN "fullblodshäst" ; -- fullblodshäst..nn.1
  fullblodsindian_1_N = mkN "fullblodsindian" "fullblodsindianer" ; -- fullblodsindian..nn.1
  fullblodsproffs_1_N = mkN "fullblodsproffs" neutrum  ; -- fullblodsproffs..nn.1
  fullbokad_1_A = mkA "fullbokad" ; -- fullbokad..av.1
  fullborda_1_V = mkV "fullbordar" ; -- fullborda..vb.1
  fullbordande_1_N = mkN "fullbordande" ; -- fullbordande..nn.1
  fullbordare_1_N = mkN "fullbordare" utrum  ; -- fullbordare..nn.1
  fulleren_1_N = mkN "fulleren" "fullerener" ; -- fulleren..nn.1
  fullfjädrad_1_A = mkA "fullfjädrad" ; -- fullfjädrad..av.1
  fullfärdig_1_A = mkA "fullfärdig" ; -- fullfärdig..av.1
  fullfölja_1_V = mkV "fullfölja" "fullföljde" "fullföljt" ; -- fullfölja..vb.1
  fullföljande_1_N = mkN "fullföljande" ; -- fullföljande..nn.1
  fullföljd_1_N = mkN "fullföljd" ; -- fullföljd..nn.1
  fullgod_1_A = mkA "fullgod" "fullgott" ; -- fullgod..av.1
  fullgodhet_1_N = mkN "fullgodhet" ; -- fullgodhet..nn.1
  fullgången_1_A = mkA "fullgången" ; -- fullgången..av.1
  fullgångenhet_1_N = mkN "fullgångenhet" ; -- fullgångenhet..nn.1
  fullgöra_1_V = mkV "fullgöra" "fullgjorde" "fullgjort" ; -- fullgöra..vb.1
  fullgörande_1_N = mkN "fullgörande" ; -- fullgörande..nn.1
  fullgörare_1_N = mkN "fullgörare" utrum  ; -- fullgörare..nn.1
  fullhet_1_N = mkN "fullhet" ; -- fullhet..nn.1
  fullklistrad_1_A = mkA "fullklistrad" ; -- fullklistrad..av.1
  fullklottrad_1_A = mkA "fullklottrad" ; -- fullklottrad..av.1
  fullkomlig_1_A = mkA "fullkomlig" ; -- fullkomlig..av.1
  fullkomligen_1_Adv = mkAdv "fullkomligen" ; -- fullkomligen..ab.1
  fullkomlighet_1_N = mkN "fullkomlighet" "fullkomligheter" ; -- fullkomlighet..nn.1
  fullkomna_1_V = mkV "fullkomnar" ; -- fullkomna..vb.1
  fullkomnande_1_N = mkN "fullkomnande" ; -- fullkomnande..nn.1
  fullkomning_1_N = mkN "fullkomning" ; -- fullkomning..nn.1
  fullkorn_1_N = mkN "fullkorn" neutrum  ; -- fullkorn..nn.1
  fullkornsbröd_1_N = mkN "fullkornsbröd" neutrum  ; -- fullkornsbröd..nn.1
  fullkornsmjöl_1_N = mkN "fullkornsmjöl" neutrum  ; -- fullkornsmjöl..nn.1
  fullmakt_1_N = mkN "fullmakt" "fullmakter" ; -- fullmakt..nn.1
  fullmaktslag_1_N = mkN "fullmaktslag" ; -- fullmaktslag..nn.1
  fullmatad_1_A = mkA "fullmatad" ; -- fullmatad..av.1
  fullmogen_1_A = mkA "fullmogen" ; -- fullmogen..av.1
  fullmogenhet_1_N = mkN "fullmogenhet" ; -- fullmogenhet..nn.1
  fullmyndig_1_A = mkA "fullmyndig" ; -- fullmyndig..av.1
  fullmäktig_1_N = mkN "fullmäktig" "fullmäktigen" "fullmäktige" "fullmäktigena" ; -- fullmäktig..nn.1
  fullmäktigskap_1_N = mkN "fullmäktigskap" neutrum  ; -- fullmäktigskap..nn.1
  fullmåne_1_N = mkN "fullmåne" utrum  ; -- fullmåne..nn.1
  fullpackad_1_A = mkA "fullpackad" ; -- fullpackad..av.1
  fullproppa_1_V = mkV "fullproppar" ; -- fullproppa..vb.1
  fullproppad_1_A = mkA "fullproppad" ; -- fullproppad..av.1
  fullproppande_1_N = mkN "fullproppande" ; -- fullproppande..nn.1
  fullproppning_1_N = mkN "fullproppning" ; -- fullproppning..nn.1
  fullriggad_1_A = mkA "fullriggad" ; -- fullriggad..av.1
  fullriggare_1_N = mkN "fullriggare" utrum  ; -- fullriggare..nn.1
  fullsatt_1_A = mkA "fullsatt" ; -- fullsatt..av.1
  fullskalig_1_A = mkA "fullskalig" ; -- fullskalig..av.1
  fullskalighet_1_N = mkN "fullskalighet" ; -- fullskalighet..nn.1
  fullsmockad_1_A = mkA "fullsmockad" ; -- fullsmockad..av.1
  fullspikad_1_A = mkA "fullspikad" ; -- fullspikad..av.1
  fullspäckad_1_A = mkA "fullspäckad" ; -- fullspäckad..av.1
  fullstaplad_1_A = mkA "fullstaplad" ; -- fullstaplad..av.1
  fullstor_1_A = mkA "fullstor" ; -- fullstor..av.1
  fullstämmig_1_A = mkA "fullstämmig" ; -- fullstämmig..av.1
  fullstämmighet_1_N = mkN "fullstämmighet" ; -- fullstämmighet..nn.1
  fullständig_1_A = mkA "fullständig" ; -- fullständig..av.1
  fullständiga_1_V = mkV "fullständigar" ; -- fullständiga..vb.1
  fullständigande_1_N = mkN "fullständigande" ; -- fullständigande..nn.1
  fullständighet_1_N = mkN "fullständighet" "fullständigheter" ; -- fullständighet..nn.1
  fulltalig_1_A = mkA "fulltalig" ; -- fulltalig..av.1
  fulltalighet_1_N = mkN "fulltalighet" ; -- fulltalighet..nn.1
  fulltankad_1_A = mkA "fulltankad" ; -- fulltankad..av.1
  fulltecknad_1_A = mkA "fulltecknad" ; -- fulltecknad..av.1
  fulltonig_1_A = mkA "fulltonig" ; -- fulltonig..av.1
  fulltonighet_1_N = mkN "fulltonighet" ; -- fulltonighet..nn.1
  fullträff_1_N = mkN "fullträff" ; -- fullträff..nn.1
  fulltränad_1_A = mkA "fulltränad" ; -- fulltränad..av.1
  fullviktig_1_A = mkA "fullviktig" ; -- fullviktig..av.1
  fullvuxen_1_A = mkA "fullvuxen" ; -- fullvuxen..av.1
  fullvuxenhet_1_N = mkN "fullvuxenhet" ; -- fullvuxenhet..nn.1
  fullväpnad_1_A = mkA "fullväpnad" ; -- fullväpnad..av.1
  fullvärdesförsäkring_1_N = mkN "fullvärdesförsäkring" ; -- fullvärdesförsäkring..nn.1
  fullvärdig_1_A = mkA "fullvärdig" ; -- fullvärdig..av.1
  fullvärdighet_1_N = mkN "fullvärdighet" ; -- fullvärdighet..nn.1
  fullväxt_1_A = mkA "fullväxt" "fullväxt" ; -- fullväxt..av.1
  fullända_1_V = mkV "fulländar" ; -- fullända..vb.1
  fulländad_1_A = mkA "fulländad" ; -- fulländad..av.1
  fulländande_1_N = mkN "fulländande" ; -- fulländande..nn.1
  fulländare_1_N = mkN "fulländare" utrum  ; -- fulländare..nn.1
  fulländning_1_N = mkN "fulländning" ; -- fulländning..nn.1
  fullärd_1_A = mkA "fullärd" "fullärt" ; -- fullärd..av.1
  fullödig_1_A = mkA "fullödig" ; -- fullödig..av.1
  fullödighet_1_N = mkN "fullödighet" "fullödigheter" ; -- fullödighet..nn.1
  fulsnygg_1_A = mkA "fulsnygg" ; -- fulsnygg..av.1
  fulsnygghet_1_N = mkN "fulsnygghet" ; -- fulsnygghet..nn.1
  fulvinkla_1_V = mkV "fulvinklar" ; -- fulvinkla..vb.1
  fulvinklande_1_N = mkN "fulvinklande" ; -- fulvinklande..nn.1
  fulvinkling_1_N = mkN "fulvinkling" ; -- fulvinkling..nn.1
  fumla_1_V = mkV "fumlar" ; -- fumla..vb.1
  fumlande_1_N = mkN "fumlande" ; -- fumlande..nn.1
  fumlig_1_A = mkA "fumlig" ; -- fumlig..av.1
  fumlighet_1_N = mkN "fumlighet" "fumligheter" ; -- fumlighet..nn.1
  fundament_1_N = mkN "fundament" neutrum  ; -- fundament..nn.1
  fundamental_1_A = mkA "fundamental" ; -- fundamental..av.1
  fundamentalism_1_N = mkN "fundamentalism" "fundamentalismer" ; -- fundamentalism..nn.1
  fundamentalist_1_N = mkN "fundamentalist" "fundamentalister" ; -- fundamentalist..nn.1
  fundamentalistisk_1_A = mkA "fundamentalistisk" ; -- fundamentalistisk..av.1
  fundamentalsats_1_N = mkN "fundamentalsats" "fundamentalsatser" ; -- fundamentalsats..nn.1
  fundera_1_V = mkV "funderar" ; -- fundera..vb.1
  funderande_1_N = mkN "funderande" ; -- funderande..nn.1
  funderare_1_N = mkN "funderare" utrum  ; -- funderare..nn.1
  fundering_1_N = mkN "fundering" ; -- fundering..nn.1
  fundersam_1_A = mkA "fundersam" "fundersamt" "fundersamma" "fundersamma" "fundersammare" "fundersammast" "fundersammaste" ; -- fundersam..av.1
  fundersamhet_1_N = mkN "fundersamhet" ; -- fundersamhet..nn.1
  fungera_1_V = mkV "fungerar" ; -- fungera..vb.1
  fungerande_1_N = mkN "fungerande" ; -- fungerande..nn.1
  funk_1_N = mkN "funk" ; -- funk..nn.1
  funka_1_V = mkV "funkar" ; -- funka..vb.1
  funkande_1_N = mkN "funkande" ; -- funkande..nn.1
  funkig_1_A = mkA "funkig" ; -- funkig..av.1
  funkis_1_N = mkN "funkis" ; -- funkis..nn.1
  funktion_1_N = mkN "funktion" ; -- funktion..nn.1
  funktionalism_1_N = mkN "funktionalism" "funktionalismer" ; -- funktionalism..nn.1
  funktionalist_1_N = mkN "funktionalist" "funktionalister" ; -- funktionalist..nn.1
  funktionalistisk_1_A = mkA "funktionalistisk" ; -- funktionalistisk..av.1
  funktionalitet_1_N = mkN "funktionalitet" "funktionaliteter" ; -- funktionalitet..nn.1
  funktionell_1_A = mkA "funktionell" ; -- funktionell..av.1
  funktionera_1_V = mkV "funktionerar" ; -- funktionera..vb.1
  funktionerande_1_N = mkN "funktionerande" ; -- funktionerande..nn.1
  funktionering_1_N = mkN "funktionering" ; -- funktionering..nn.1
  funktionsduglig_1_A = mkA "funktionsduglig" ; -- funktionsduglig..av.1
  funktionsduglighet_1_N = mkN "funktionsduglighet" ; -- funktionsduglighet..nn.1
  funktionshinder_1_N = mkN "funktionshinder" neutrum  ; -- funktionshinder..nn.1
  funktionshindrad_1_A = mkA "funktionshindrad" ; -- funktionshindrad..av.1
  funktionsmässig_1_A = mkA "funktionsmässig" ; -- funktionsmässig..av.1
  funktionsnedsättning_1_N = mkN "funktionsnedsättning" ; -- funktionsnedsättning..nn.1
  funktionsoduglig_1_A = mkA "funktionsoduglig" ; -- funktionsoduglig..av.1
  funktionsoduglighet_1_N = mkN "funktionsoduglighet" ; -- funktionsoduglighet..nn.1
  funktionssätt_1_N = mkN "funktionssätt" neutrum  ; -- funktionssätt..nn.1
  funktionsvärde_1_N = mkN "funktionsvärde" ; -- funktionsvärde..nn.1
  funktionär_1_N = mkN "funktionär" "funktionärer" ; -- funktionär..nn.1
  funtad_1_A = mkA "funtad" ; -- funtad..av.1
  fur_1_N = mkN "fur" ; -- fur..nn.1
  fura_1_N = mkN "fura" ; -- fura..nn.1
  furage_1_N = mkN "furage" ; -- furage..nn.1
  furan_1_N = mkN "furan" neutrum  ; -- furan..nn.1
  furie_1_N = mkN "furie" "furier" ; -- furie..nn.1
  furioso_1_N = mkN "furioso" "furiosot" "furioson" "furiosona" ; -- furioso..nn.1
  furir_1_N = mkN "furir" "furirer" ; -- furir..nn.1
  furiös_1_A = mkA "furiös" ; -- furiös..av.1
  furnera_1_V = mkV "furnerar" ; -- furnera..vb.1
  furnerande_1_N = mkN "furnerande" ; -- furnerande..nn.1
  furnerbar_1_A = mkA "furnerbar" ; -- furnerbar..av.1
  furnerbarhet_1_N = mkN "furnerbarhet" ; -- furnerbarhet..nn.1
  furnering_1_N = mkN "furnering" ; -- furnering..nn.1
  furnissör_1_N = mkN "furnissör" "furnissörer" ; -- furnissör..nn.1
  furong_1_N = mkN "furong" ; -- furong..nn.1
  furor_1_N = mkN "furor" ; -- furor..nn.1
  furore_1_N = mkN "furore" utrum  ; -- furore..nn.1
  furst_1_N = mkN "furst" ; -- furst..nn.1
  furstbiskop_1_N = mkN "furstbiskop" ; -- furstbiskop..nn.1
  furste_1_N = mkN "furste" utrum  ; -- furste..nn.1
  furstehus_1_N = mkN "furstehus" neutrum  ; -- furstehus..nn.1
  furstekrona_1_N = mkN "furstekrona" ; -- furstekrona..nn.1
  furstendöme_1_N = mkN "furstendöme" ; -- furstendöme..nn.1
  fursteätt_1_N = mkN "fursteätt" "fursteätter" ; -- fursteätt..nn.1
  furstlig_1_A = mkA "furstlig" ; -- furstlig..av.1
  furstlighet_1_N = mkN "furstlighet" "furstligheter" ; -- furstlighet..nn.1
  furu_1_N = mkN "furu" ; -- furu..nn.1
  furugolv_1_N = mkN "furugolv" neutrum  ; -- furugolv..nn.1
  furunkel_1_N = mkN "furunkel" ; -- furunkel..nn.1
  furuplanka_1_N = mkN "furuplanka" ; -- furuplanka..nn.1
  furutrappa_1_N = mkN "furutrappa" ; -- furutrappa..nn.1
  furuträ_1_N = mkN "furuträ" neutrum  ; -- furuträ..nn.1
  fusion_1_N = mkN "fusion" ; -- fusion..nn.1
  fusion_2_N = mkN "fusion" ; -- fusion..nn.2
  fusionera_1_V = mkV "fusionerar" ; -- fusionera..vb.1
  fusionerande_1_N = mkN "fusionerande" ; -- fusionerande..nn.1
  fusionerbar_1_A = mkA "fusionerbar" ; -- fusionerbar..av.1
  fusionerbarhet_1_N = mkN "fusionerbarhet" ; -- fusionerbarhet..nn.1
  fusionering_1_N = mkN "fusionering" ; -- fusionering..nn.1
  fusionsplan_1_N = mkN "fusionsplan" "fusionsplaner" ; -- fusionsplan..nn.1
  fusk_1_N = mkN "fusk" neutrum  ; -- fusk..nn.1
  fuska_1_V = mkV "fuskar" ; -- fuska..vb.1
  fuskande_1_N = mkN "fuskande" ; -- fuskande..nn.1
  fuskanklagelse_1_N = mkN "fuskanklagelse" "fuskanklagelser" ; -- fuskanklagelse..nn.1
  fuskare_1_N = mkN "fuskare" utrum  ; -- fuskare..nn.1
  fuskbyggare_1_N = mkN "fuskbyggare" utrum  ; -- fuskbyggare..nn.1
  fuskbygge_1_N = mkN "fuskbygge" ; -- fuskbygge..nn.1
  fuskeri_1_N = mkN "fuskeri" neutrum  ; -- fuskeri..nn.1
  fuskflygning_1_N = mkN "fuskflygning" ; -- fuskflygning..nn.1
  fusklapp_1_N = mkN "fusklapp" ; -- fusklapp..nn.1
  fuskpäls_1_N = mkN "fuskpäls" ; -- fuskpäls..nn.1
  fuskverk_1_N = mkN "fuskverk" neutrum  ; -- fuskverk..nn.1
  futhark_1_N = mkN "futhark" "futharker" ; -- futhark..nn.1
  futil_1_A = mkA "futil" ; -- futil..av.1
  futilitet_1_N = mkN "futilitet" "futiliteter" ; -- futilitet..nn.1
  futt_1_N = mkN "futt" ; -- futt..nn.1
  futt_2_N = mkN "futt" ; -- futt..nn.2
  futta_1_V = mkV "futtar" ; -- futta..vb.1
  futtande_1_N = mkN "futtande" ; -- futtande..nn.1
  futtig_1_A = mkA "futtig" ; -- futtig..av.1
  futtighet_1_N = mkN "futtighet" "futtigheter" ; -- futtighet..nn.1
  futural_1_A = mkA "futural" ; -- futural..av.1
  futurism_1_N = mkN "futurism" "futurismer" ; -- futurism..nn.1
  futurist_1_N = mkN "futurist" "futurister" ; -- futurist..nn.1
  futuristisk_1_A = mkA "futuristisk" ; -- futuristisk..av.1
  futurolog_1_N = mkN "futurolog" "futurologer" ; -- futurolog..nn.1
  futurologi_1_N = mkN "futurologi" ; -- futurologi..nn.1
  futurologisk_1_A = mkA "futurologisk" ; -- futurologisk..av.1
  futurum_1_N = mkN "futurum" "futurumet" "futurer" "futurerna" ; -- futurum..nn.1
  fux_1_N = mkN "fux" ; -- fux..nn.1
  fylgia_1_N = mkN "fylgia" ; -- fylgia..nn.1
  fylgja_1_N = mkN "fylgja" ; -- fylgja..nn.1
  fylka_1_V = mkV "fylkar" ; -- fylka..vb.1
  fylkande_1_N = mkN "fylkande" ; -- fylkande..nn.1
  fylke_1_N = mkN "fylke" ; -- fylke..nn.1
  fylking_1_N = mkN "fylking" ; -- fylking..nn.1
  fylla_1_N = mkN "fylla" ; -- fylla..nn.1
  fylla_1_V = mkV "fyller" ; -- fylla..vb.1
  fyllande_1_N = mkN "fyllande" ; -- fyllande..nn.1
  fyllbult_1_N = mkN "fyllbult" ; -- fyllbult..nn.1
  fylld_1_A = mkA "fylld" "fyllt" ; -- fylld..av.1
  fylldille_1_N = mkN "fylldille" ; -- fylldille..nn.1
  fyllebråk_1_N = mkN "fyllebråk" neutrum  ; -- fyllebråk..nn.1
  fylleri_1_N = mkN "fylleri" neutrum  ; -- fylleri..nn.1
  fylleriförseelse_1_N = mkN "fylleriförseelse" "fylleriförseelser" ; -- fylleriförseelse..nn.1
  fyllerist_1_N = mkN "fyllerist" "fyllerister" ; -- fyllerist..nn.1
  fylleslag_1_N = mkN "fylleslag" neutrum  ; -- fylleslag..nn.1
  fyllesnack_1_N = mkN "fyllesnack" neutrum  ; -- fyllesnack..nn.1
  fylletratt_1_N = mkN "fylletratt" ; -- fylletratt..nn.1
  fyllhund_1_N = mkN "fyllhund" ; -- fyllhund..nn.1
  fyllig_1_A = mkA "fyllig" ; -- fyllig..av.1
  fyllighet_1_N = mkN "fyllighet" ; -- fyllighet..nn.1
  fyllis_1_N = mkN "fyllis" ; -- fyllis..nn.1
  fyllkaja_1_N = mkN "fyllkaja" ; -- fyllkaja..nn.1
  fyllna_1_V = mkV "fyllnar" ; -- fyllna..vb.1
  fyllnad_1_N = mkN "fyllnad" "fyllnader" ; -- fyllnad..nn.1
  fyllnadsarbete_1_N = mkN "fyllnadsarbete" ; -- fyllnadsarbete..nn.1
  fyllnadsbelopp_1_N = mkN "fyllnadsbelopp" neutrum  ; -- fyllnadsbelopp..nn.1
  fyllnadsgods_1_N = mkN "fyllnadsgods" neutrum  ; -- fyllnadsgods..nn.1
  fyllnadsgrus_1_N = mkN "fyllnadsgrus" neutrum  ; -- fyllnadsgrus..nn.1
  fyllnadsjord_1_N = mkN "fyllnadsjord" ; -- fyllnadsjord..nn.1
  fyllnadslast_1_N = mkN "fyllnadslast" "fyllnadslaster" ; -- fyllnadslast..nn.1
  fyllnadsmassa_1_N = mkN "fyllnadsmassa" ; -- fyllnadsmassa..nn.1
  fyllnadspension_1_N = mkN "fyllnadspension" ; -- fyllnadspension..nn.1
  fyllnadstjänstgöring_1_N = mkN "fyllnadstjänstgöring" ; -- fyllnadstjänstgöring..nn.1
  fyllnadsval_1_N = mkN "fyllnadsval" neutrum  ; -- fyllnadsval..nn.1
  fyllnadsämne_1_N = mkN "fyllnadsämne" ; -- fyllnadsämne..nn.1
  fyllnande_1_N = mkN "fyllnande" ; -- fyllnande..nn.1
  fyllning_1_N = mkN "fyllning" ; -- fyllning..nn.1
  fyllningsgrus_1_N = mkN "fyllningsgrus" neutrum  ; -- fyllningsgrus..nn.1
  fyllningsjord_1_N = mkN "fyllningsjord" ; -- fyllningsjord..nn.1
  fyllningsmassa_1_N = mkN "fyllningsmassa" ; -- fyllningsmassa..nn.1
  fyllo_1_N = mkN "fyllo" "fyllot" "fyllon" "fyllona" ; -- fyllo..nn.1
  fylltratt_1_N = mkN "fylltratt" ; -- fylltratt..nn.1
  fylogenetisk_1_A = mkA "fylogenetisk" ; -- fylogenetisk..av.1
  fylogeni_1_N = mkN "fylogeni" ; -- fylogeni..nn.1
  fynd_1_N = mkN "fynd" neutrum  ; -- fynd..nn.1
  fynda_1_V = mkV "fyndar" ; -- fynda..vb.1
  fyndande_1_N = mkN "fyndande" ; -- fyndande..nn.1
  fyndgruva_1_N = mkN "fyndgruva" ; -- fyndgruva..nn.1
  fyndig_1_A = mkA "fyndig" ; -- fyndig..av.1
  fyndighet_1_N = mkN "fyndighet" "fyndigheter" ; -- fyndighet..nn.1
  fyndjakt_1_N = mkN "fyndjakt" ; -- fyndjakt..nn.1
  fyndomständighet_1_N = mkN "fyndomständighet" "fyndomständigheter" ; -- fyndomständighet..nn.1
  fyndort_1_N = mkN "fyndort" "fyndorter" ; -- fyndort..nn.1
  fyndplats_1_N = mkN "fyndplats" "fyndplatser" ; -- fyndplats..nn.1
  fyndpris_1_N = mkN "fyndpris" neutrum  ; -- fyndpris..nn.1
  fyr_1_N = mkN "fyr" ; -- fyr..nn.1
  fyra_1_N = mkN "fyra" ; -- fyra..nn.1
  fyrahundratal_1_N = mkN "fyrahundratal" neutrum  ; -- fyrahundratal..nn.1
  fyraprocentsspärr_1_N = mkN "fyraprocentsspärr" ; -- fyraprocentsspärr..nn.1
  fyrarummare_1_N = mkN "fyrarummare" utrum  ; -- fyrarummare..nn.1
  fyrarumslägenhet_1_N = mkN "fyrarumslägenhet" "fyrarumslägenheter" ; -- fyrarumslägenhet..nn.1
  fyratimmarsflygning_1_N = mkN "fyratimmarsflygning" ; -- fyratimmarsflygning..nn.1
  fyratåg_1_N = mkN "fyratåg" neutrum  ; -- fyratåg..nn.1
  fyravåningshus_1_N = mkN "fyravåningshus" neutrum  ; -- fyravåningshus..nn.1
  fyraårig_1_A = mkA "fyraårig" ; -- fyraårig..av.1
  fyraåring_1_N = mkN "fyraåring" ; -- fyraåring..nn.1
  fyrbackslinje_1_N = mkN "fyrbackslinje" "fyrbackslinjer" ; -- fyrbackslinje..nn.1
  fyrbening_1_N = mkN "fyrbening" ; -- fyrbening..nn.1
  fyrbent_1_A = mkA "fyrbent" "fyrbent" ; -- fyrbent..av.1
  fyrbåk_1_N = mkN "fyrbåk" ; -- fyrbåk..nn.1
  fyrcylindrig_1_A = mkA "fyrcylindrig" ; -- fyrcylindrig..av.1
  fyrdela_1_V = mkV "fyrdelar" ; -- fyrdela..vb.1
  fyrdelad_1_A = mkA "fyrdelad" ; -- fyrdelad..av.1
  fyrdelande_1_N = mkN "fyrdelande" ; -- fyrdelande..nn.1
  fyrdelning_1_N = mkN "fyrdelning" ; -- fyrdelning..nn.1
  fyrdimensionell_1_A = mkA "fyrdimensionell" ; -- fyrdimensionell..av.1
  fyrdubbel_1_A = mkA "fyrdubbel" ; -- fyrdubbel..av.1
  fyrdubbla_1_V = mkV "fyrdubblar" ; -- fyrdubbla..vb.1
  fyrdubblande_1_N = mkN "fyrdubblande" ; -- fyrdubblande..nn.1
  fyrdubbling_1_N = mkN "fyrdubbling" ; -- fyrdubbling..nn.1
  fyrfaldig_1_A = mkA "fyrfaldig" ; -- fyrfaldig..av.1
  fyrfaldiga_1_V = mkV "fyrfaldigar" ; -- fyrfaldiga..vb.1
  fyrfaldigande_1_N = mkN "fyrfaldigande" ; -- fyrfaldigande..nn.1
  fyrfat_1_N = mkN "fyrfat" neutrum  ; -- fyrfat..nn.1
  fyrfilig_1_A = mkA "fyrfilig" ; -- fyrfilig..av.1
  fyrfilighet_1_N = mkN "fyrfilighet" ; -- fyrfilighet..nn.1
  fyrfota_1_A = mkA "fyrfota" ; -- fyrfota..av.1
  fyrfotad_1_A = mkA "fyrfotad" ; -- fyrfotad..av.1
  fyrfotadjur_1_N = mkN "fyrfotadjur" neutrum  ; -- fyrfotadjur..nn.1
  fyrfoting_1_N = mkN "fyrfoting" ; -- fyrfoting..nn.1
  fyrfärgad_1_A = mkA "fyrfärgad" ; -- fyrfärgad..av.1
  fyrfärgstryck_1_N = mkN "fyrfärgstryck" neutrum  ; -- fyrfärgstryck..nn.1
  fyrgradig_1_A = mkA "fyrgradig" ; -- fyrgradig..av.1
  fyrgradighet_1_N = mkN "fyrgradighet" ; -- fyrgradighet..nn.1
  fyrhandssättning_1_N = mkN "fyrhandssättning" ; -- fyrhandssättning..nn.1
  fyrhjulig_1_A = mkA "fyrhjulig" ; -- fyrhjulig..av.1
  fyrhjulighet_1_N = mkN "fyrhjulighet" ; -- fyrhjulighet..nn.1
  fyrhjuling_1_N = mkN "fyrhjuling" ; -- fyrhjuling..nn.1
  fyrhjulingsförare_1_N = mkN "fyrhjulingsförare" utrum  ; -- fyrhjulingsförare..nn.1
  fyrhjulsdriven_1_A = mkA "fyrhjulsdriven" ; -- fyrhjulsdriven..av.1
  fyrhändig_1_A = mkA "fyrhändig" ; -- fyrhändig..av.1
  fyrhänt_1_A = mkA "fyrhänt" "fyrhänt" ; -- fyrhänt..av.1
  fyrhörning_1_N = mkN "fyrhörning" ; -- fyrhörning..nn.1
  fyrk_1_N = mkN "fyrk" ; -- fyrk..nn.1
  fyrkant_1_N = mkN "fyrkant" "fyrkanter" ; -- fyrkant..nn.1
  fyrkantig_1_A = mkA "fyrkantig" ; -- fyrkantig..av.1
  fyrkantig_2_A = mkA "fyrkantig" ; -- fyrkantig..av.2
  fyrkantighet_1_N = mkN "fyrkantighet" "fyrkantigheter" ; -- fyrkantighet..nn.1
  fyrkaraktär_1_N = mkN "fyrkaraktär" "fyrkaraktärer" ; -- fyrkaraktär..nn.1
  fyrkluven_1_A = mkA "fyrkluven" ; -- fyrkluven..av.1
  fyrklöver_1_N = mkN "fyrklöver" ; -- fyrklöver..nn.1
  fyrling_1_N = mkN "fyrling" ; -- fyrling..nn.1
  fyrljus_1_N = mkN "fyrljus" neutrum  ; -- fyrljus..nn.1
  fyrmotorig_1_A = mkA "fyrmotorig" ; -- fyrmotorig..av.1
  fyrmänning_1_N = mkN "fyrmänning" ; -- fyrmänning..nn.1
  fyrmästare_1_N = mkN "fyrmästare" utrum  ; -- fyrmästare..nn.1
  fyrop_1_N = mkN "fyrop" neutrum  ; -- fyrop..nn.1
  fyrradig_1_A = mkA "fyrradig" ; -- fyrradig..av.1
  fyrradskorn_1_N = mkN "fyrradskorn" neutrum  ; -- fyrradskorn..nn.1
  fyrrummare_1_N = mkN "fyrrummare" utrum  ; -- fyrrummare..nn.1
  fyrrumslägenhet_1_N = mkN "fyrrumslägenhet" "fyrrumslägenheter" ; -- fyrrumslägenhet..nn.1
  fyrsidig_1_A = mkA "fyrsidig" ; -- fyrsidig..av.1
  fyrsiding_1_N = mkN "fyrsiding" ; -- fyrsiding..nn.1
  fyrsiffrig_1_A = mkA "fyrsiffrig" ; -- fyrsiffrig..av.1
  fyrsitsig_1_A = mkA "fyrsitsig" ; -- fyrsitsig..av.1
  fyrskaft_1_N = mkN "fyrskaft" ; -- fyrskaft..nn.1
  fyrskaftad_1_A = mkA "fyrskaftad" ; -- fyrskaftad..av.1
  fyrskepp_1_N = mkN "fyrskepp" neutrum  ; -- fyrskepp..nn.1
  fyrspann_1_N = mkN "fyrspann" neutrum  ; -- fyrspann..nn.1
  fyrsprång_1_N = mkN "fyrsprång" ; -- fyrsprång..nn.1
  fyrstavig_1_A = mkA "fyrstavig" ; -- fyrstavig..av.1
  fyrstjärnig_1_A = mkA "fyrstjärnig" ; -- fyrstjärnig..av.1
  fyrstruken_1_A = mkA "fyrstruken" ; -- fyrstruken..av.1
  fyrstämmig_1_A = mkA "fyrstämmig" ; -- fyrstämmig..av.1
  fyrtakt_1_N = mkN "fyrtakt" "fyrtakter" ; -- fyrtakt..nn.1
  fyrtaktare_1_N = mkN "fyrtaktare" utrum  ; -- fyrtaktare..nn.1
  fyrtaktsmotor_1_N = mkN "fyrtaktsmotor" "fyrtaktsmotorer" ; -- fyrtaktsmotor..nn.1
  fyrtal_1_N = mkN "fyrtal" neutrum  ; -- fyrtal..nn.1
  fyrtalig_1_A = mkA "fyrtalig" ; -- fyrtalig..av.1
  fyrtionde_1_A = mkA "fyrtionde" ; -- fyrtionde..av.1
  fyrtiotal_1_N = mkN "fyrtiotal" neutrum  ; -- fyrtiotal..nn.1
  fyrtiotalism_1_N = mkN "fyrtiotalism" "fyrtiotalismer" ; -- fyrtiotalism..nn.1
  fyrtiotalist_1_N = mkN "fyrtiotalist" "fyrtiotalister" ; -- fyrtiotalist..nn.1
  fyrtiotalistisk_1_A = mkA "fyrtiotalistisk" ; -- fyrtiotalistisk..av.1
  fyrtiotimmarsvecka_1_N = mkN "fyrtiotimmarsvecka" ; -- fyrtiotimmarsvecka..nn.1
  fyrtioåring_1_N = mkN "fyrtioåring" ; -- fyrtioåring..nn.1
  fyrtioårskris_1_N = mkN "fyrtioårskris" "fyrtioårskriser" ; -- fyrtioårskris..nn.1
  fyrtital_1_N = mkN "fyrtital" neutrum  ; -- fyrtital..nn.1
  fyrtitalism_1_N = mkN "fyrtitalism" "fyrtitalismer" ; -- fyrtitalism..nn.1
  fyrtitalist_1_N = mkN "fyrtitalist" "fyrtitalister" ; -- fyrtitalist..nn.1
  fyrtitimmarsvecka_1_N = mkN "fyrtitimmarsvecka" ; -- fyrtitimmarsvecka..nn.1
  fyrtiåring_1_N = mkN "fyrtiåring" ; -- fyrtiåring..nn.1
  fyrtiårskris_1_N = mkN "fyrtiårskris" "fyrtiårskriser" ; -- fyrtiårskris..nn.1
  fyrtorn_1_N = mkN "fyrtorn" neutrum  ; -- fyrtorn..nn.1
  fyrtumsspik_1_N = mkN "fyrtumsspik" ; -- fyrtumsspik..nn.1
  fyrvaktare_1_N = mkN "fyrvaktare" utrum  ; -- fyrvaktare..nn.1
  fyrverkare_1_N = mkN "fyrverkare" utrum  ; -- fyrverkare..nn.1
  fyrverkeri_1_N = mkN "fyrverkeri" "fyrverkeriet" "fyrverkerier" "fyrverkerierna" ; -- fyrverkeri..nn.1
  fyrverkeripjäs_1_N = mkN "fyrverkeripjäs" "fyrverkeripjäser" ; -- fyrverkeripjäs..nn.1
  fyrväldig_1_A = mkA "fyrväldig" ; -- fyrväldig..av.1
  fyrväppling_1_N = mkN "fyrväppling" ; -- fyrväppling..nn.1
  fyrväsen_1_N = mkN "fyrväsen" neutrum  ; -- fyrväsen..nn.1
  fyrväxlad_1_A = mkA "fyrväxlad" ; -- fyrväxlad..av.1
  fysik_1_N = mkN "fysik" ; -- fysik..nn.1
  fysikalisk_1_A = mkA "fysikalisk" ; -- fysikalisk..av.1
  fysikbok_1_N = mkN "fysikbok" "fysikböcker" ; -- fysikbok..nn.1
  fysiker_1_N = mkN "fysiker" "fysikern" "fysiker" "fysikerna" ; -- fysiker..nn.1
  fysikforskare_1_N = mkN "fysikforskare" utrum  ; -- fysikforskare..nn.1
  fysikforskning_1_N = mkN "fysikforskning" ; -- fysikforskning..nn.1
  fysiklärare_1_N = mkN "fysiklärare" utrum  ; -- fysiklärare..nn.1
  fysikprofessor_1_N = mkN "fysikprofessor" "fysikprofessorer" ; -- fysikprofessor..nn.1
  fysikvetenskap_1_N = mkN "fysikvetenskap" "fysikvetenskaper" ; -- fysikvetenskap..nn.1
  fysiljera_1_V = mkV "fysiljerar" ; -- fysiljera..vb.1
  fysiljerande_1_N = mkN "fysiljerande" ; -- fysiljerande..nn.1
  fysiljerbar_1_A = mkA "fysiljerbar" ; -- fysiljerbar..av.1
  fysiljerbarhet_1_N = mkN "fysiljerbarhet" ; -- fysiljerbarhet..nn.1
  fysiljering_1_N = mkN "fysiljering" ; -- fysiljering..nn.1
  fysiokrat_1_N = mkN "fysiokrat" "fysiokrater" ; -- fysiokrat..nn.1
  fysiokratisk_1_A = mkA "fysiokratisk" ; -- fysiokratisk..av.1
  fysiokratism_1_N = mkN "fysiokratism" "fysiokratismer" ; -- fysiokratism..nn.1
  fysiolog_1_N = mkN "fysiolog" "fysiologer" ; -- fysiolog..nn.1
  fysiologi_1_N = mkN "fysiologi" ; -- fysiologi..nn.1
  fysiologisk_1_A = mkA "fysiologisk" ; -- fysiologisk..av.1
  fysionomi_1_N = mkN "fysionomi" "fysionomier" ; -- fysionomi..nn.1
  fysioterapeut_1_N = mkN "fysioterapeut" "fysioterapeuter" ; -- fysioterapeut..nn.1
  fysioterapi_1_N = mkN "fysioterapi" ; -- fysioterapi..nn.1
  fysisk_1_A = mkA "fysisk" ; -- fysisk..av.1
  fytotron_1_N = mkN "fytotron" "fytotroner" ; -- fytotron..nn.1
  fä_1_N = mkN "fä" "fät" "fän" "fäna" ; -- fä..nn.1
  fäaktig_1_A = mkA "fäaktig" ; -- fäaktig..av.1
  fäaktighet_1_N = mkN "fäaktighet" ; -- fäaktighet..nn.1
  fäbless_1_N = mkN "fäbless" "fäblesser" ; -- fäbless..nn.1
  fäbod_1_N = mkN "fäbod" ; -- fäbod..nn.1
  fäbodstinta_1_N = mkN "fäbodstinta" ; -- fäbodstinta..nn.1
  fäbodställe_1_N = mkN "fäbodställe" ; -- fäbodställe..nn.1
  fäbodvall_1_N = mkN "fäbodvall" ; -- fäbodvall..nn.1
  fäderne_1_N = mkN "fäderne" ; -- fäderne..nn.1
  fädernearv_1_N = mkN "fädernearv" neutrum  ; -- fädernearv..nn.1
  fädernegård_1_N = mkN "fädernegård" ; -- fädernegård..nn.1
  fädernehem_1_N = mkN "fädernehem" "fädernehemmet" "fädernehem" "fädernehemmen" ; -- fädernehem..nn.1
  fädernejord_1_N = mkN "fädernejord" ; -- fädernejord..nn.1
  fädernesida_1_N = mkN "fädernesida" ; -- fädernesida..nn.1
  fädernesland_1_N = mkN "fädernesland" "fäderneslandet" "fädernesländer" "fädernesländerna" ; -- fädernesland..nn.1
  fädernesläkt_1_N = mkN "fädernesläkt" "fädernesläkter" ; -- fädernesläkt..nn.1
  fädernestad_1_N = mkN "fädernestad" "fädernestäder" ; -- fädernestad..nn.1
  fägata_1_N = mkN "fägata" ; -- fägata..nn.1
  fägna_1_V = mkV "fägnar" ; -- fägna..vb.1
  fägnad_1_N = mkN "fägnad" "fägnader" ; -- fägnad..nn.1
  fägnande_1_N = mkN "fägnande" ; -- fägnande..nn.1
  fägnesam_1_A = mkA "fägnesam" "fägnesamt" "fägnesamma" "fägnesamma" "fägnesammare" "fägnesammast" "fägnesammaste" ; -- fägnesam..av.1
  fägring_1_N = mkN "fägring" ; -- fägring..nn.1
  fähund_1_N = mkN "fähund" ; -- fähund..nn.1
  fähus_1_N = mkN "fähus" neutrum  ; -- fähus..nn.1
  fäkta_1_V = mkV "fäktar" ; -- fäkta..vb.1
  fäktande_1_N = mkN "fäktande" ; -- fäktande..nn.1
  fäktare_1_N = mkN "fäktare" utrum  ; -- fäktare..nn.1
  fäktkonst_1_N = mkN "fäktkonst" "fäktkonster" ; -- fäktkonst..nn.1
  fäktmästare_1_N = mkN "fäktmästare" utrum  ; -- fäktmästare..nn.1
  fäktning_1_N = mkN "fäktning" ; -- fäktning..nn.1
  fäktningsmatch_1_N = mkN "fäktningsmatch" "fäktningsmatcher" ; -- fäktningsmatch..nn.1
  fälb_1_N = mkN "fälb" ; -- fälb..nn.1
  fälg_1_N = mkN "fälg" ; -- fälg..nn.1
  fälgborste_1_N = mkN "fälgborste" utrum  ; -- fälgborste..nn.1
  fälgkors_1_N = mkN "fälgkors" neutrum  ; -- fälgkors..nn.1
  fälgrengöring_1_N = mkN "fälgrengöring" ; -- fälgrengöring..nn.1
  fälgtvätt_1_N = mkN "fälgtvätt" ; -- fälgtvätt..nn.1
  fäll_1_N = mkN "fäll" ; -- fäll..nn.1
  fälla_1_N = mkN "fälla" ; -- fälla..nn.1
  fälla_1_V = mkV "fäller" ; -- fälla..vb.1
  fällande_1_N = mkN "fällande" ; -- fällande..nn.1
  fällbar_1_A = mkA "fällbar" ; -- fällbar..av.1
  fällbarhet_1_N = mkN "fällbarhet" ; -- fällbarhet..nn.1
  fällbom_1_N = mkN "fällbom" "fällbommen" "fällbommar" "fällbommarna" ; -- fällbom..nn.1
  fällbord_1_N = mkN "fällbord" neutrum  ; -- fällbord..nn.1
  fällkil_1_N = mkN "fällkil" ; -- fällkil..nn.1
  fällkniv_1_N = mkN "fällkniv" ; -- fällkniv..nn.1
  fällköl_1_N = mkN "fällköl" ; -- fällköl..nn.1
  fällning_1_N = mkN "fällning" ; -- fällning..nn.1
  fällstol_1_N = mkN "fällstol" ; -- fällstol..nn.1
  fält_1_N = mkN "fält" neutrum  ; -- fält..nn.1
  fältarbete_1_N = mkN "fältarbete" ; -- fältarbete..nn.1
  fältarmé_1_N = mkN "fältarmé" "fältarméer" ; -- fältarmé..nn.1
  fältartilleri_1_N = mkN "fältartilleri" neutrum  ; -- fältartilleri..nn.1
  fältassistent_1_N = mkN "fältassistent" "fältassistenter" ; -- fältassistent..nn.1
  fältbegravning_1_N = mkN "fältbegravning" ; -- fältbegravning..nn.1
  fältbiolog_1_N = mkN "fältbiolog" "fältbiologer" ; -- fältbiolog..nn.1
  fältbiologi_1_N = mkN "fältbiologi" ; -- fältbiologi..nn.1
  fältflaska_1_N = mkN "fältflaska" ; -- fältflaska..nn.1
  fältflygare_1_N = mkN "fältflygare" utrum  ; -- fältflygare..nn.1
  fältförsök_1_N = mkN "fältförsök" neutrum  ; -- fältförsök..nn.1
  fältgrå_1_A = mkA "fältgrå" "fältgrått" ; -- fältgrå..av.1
  fälthare_1_N = mkN "fälthare" "fältharar" ; -- fälthare..nn.1
  fältherre_1_N = mkN "fältherre" utrum  ; -- fältherre..nn.1
  fältherreblick_1_N = mkN "fältherreblick" ; -- fältherreblick..nn.1
  fälthöns_1_N = mkN "fälthöns" neutrum  ; -- fälthöns..nn.1
  fältjägare_1_N = mkN "fältjägare" utrum  ; -- fältjägare..nn.1
  fältjägarkår_1_N = mkN "fältjägarkår" "fältjägarkårer" ; -- fältjägarkår..nn.1
  fältkikare_1_N = mkN "fältkikare" utrum  ; -- fältkikare..nn.1
  fältkirurg_1_N = mkN "fältkirurg" "fältkirurger" ; -- fältkirurg..nn.1
  fältkök_1_N = mkN "fältkök" neutrum  ; -- fältkök..nn.1
  fältmarsch_1_N = mkN "fältmarsch" "fältmarscher" ; -- fältmarsch..nn.1
  fältmarskalk_1_N = mkN "fältmarskalk" ; -- fältmarskalk..nn.1
  fältmarskalkinna_1_N = mkN "fältmarskalkinna" ; -- fältmarskalkinna..nn.1
  fältmässig_1_A = mkA "fältmässig" ; -- fältmässig..av.1
  fältmässighet_1_N = mkN "fältmässighet" ; -- fältmässighet..nn.1
  fältmätning_1_N = mkN "fältmätning" ; -- fältmätning..nn.1
  fältpost_1_N = mkN "fältpost" ; -- fältpost..nn.1
  fältpostcensur_1_N = mkN "fältpostcensur" ; -- fältpostcensur..nn.1
  fältpostkort_1_N = mkN "fältpostkort" neutrum  ; -- fältpostkort..nn.1
  fältpräst_1_N = mkN "fältpräst" "fältpräster" ; -- fältpräst..nn.1
  fältrop_1_N = mkN "fältrop" neutrum  ; -- fältrop..nn.1
  fältsjukhus_1_N = mkN "fältsjukhus" neutrum  ; -- fältsjukhus..nn.1
  fältskytte_1_N = mkN "fältskytte" ; -- fältskytte..nn.1
  fältskär_1_N = mkN "fältskär" "fältskärer" ; -- fältskär..nn.1
  fältslag_1_N = mkN "fältslag" neutrum  ; -- fältslag..nn.1
  fältspat_1_N = mkN "fältspat" "fältspater" ; -- fältspat..nn.1
  fältstudium_1_N = mkN "fältstudium" "fältstudiet" "fältstudier" "fältstudierna" ; -- fältstudium..nn.1
  fältstyrka_1_N = mkN "fältstyrka" ; -- fältstyrka..nn.1
  fälttecken_1_N = mkN "fälttecken" "fälttecknet" "fälttecken" "fälttecknen" ; -- fälttecken..nn.1
  fälttjänst_1_N = mkN "fälttjänst" ; -- fälttjänst..nn.1
  fälttjänstgöring_1_N = mkN "fälttjänstgöring" ; -- fälttjänstgöring..nn.1
  fälttjänstövning_1_N = mkN "fälttjänstövning" ; -- fälttjänstövning..nn.1
  fälttävlan_1_N = mkN "fälttävlan" "fälttävlan" "fälttävlningar" "fälttävlningarna" ; -- fälttävlan..nn.1
  fälttåg_1_N = mkN "fälttåg" neutrum  ; -- fälttåg..nn.1
  fälttågsplan_1_N = mkN "fälttågsplan" "fälttågsplaner" ; -- fälttågsplan..nn.1
  fältuniform_1_N = mkN "fältuniform" "fältuniformer" ; -- fältuniform..nn.1
  fänad_1_N = mkN "fänad" "fänader" ; -- fänad..nn.1
  fängelse_1_N = mkN "fängelse" "fängelset" "fängelser" "fängelserna" ; -- fängelse..nn.1
  fängelsecell_1_N = mkN "fängelsecell" "fängelseceller" ; -- fängelsecell..nn.1
  fängelsechef_1_N = mkN "fängelsechef" "fängelsechefer" ; -- fängelsechef..nn.1
  fängelsedirektör_1_N = mkN "fängelsedirektör" "fängelsedirektörer" ; -- fängelsedirektör..nn.1
  fängelsedom_1_N = mkN "fängelsedom" ; -- fängelsedom..nn.1
  fängelsedömd_1_A = mkA "fängelsedömd" "fängelsedömt" ; -- fängelsedömd..av.1
  fängelseförhållande_1_N = mkN "fängelseförhållande" ; -- fängelseförhållande..nn.1
  fängelsegaller_1_N = mkN "fängelsegaller" neutrum  ; -- fängelsegaller..nn.1
  fängelsegård_1_N = mkN "fängelsegård" ; -- fängelsegård..nn.1
  fängelsehåla_1_N = mkN "fängelsehåla" ; -- fängelsehåla..nn.1
  fängelsekund_1_N = mkN "fängelsekund" "fängelsekunder" ; -- fängelsekund..nn.1
  fängelseläger_1_N = mkN "fängelseläger" neutrum  ; -- fängelseläger..nn.1
  fängelsestraff_1_N = mkN "fängelsestraff" neutrum  ; -- fängelsestraff..nn.1
  fängelsetak_1_N = mkN "fängelsetak" neutrum  ; -- fängelsetak..nn.1
  fängelsetatuering_1_N = mkN "fängelsetatuering" ; -- fängelsetatuering..nn.1
  fängelseteater_1_N = mkN "fängelseteater" ; -- fängelseteater..nn.1
  fänghål_1_N = mkN "fänghål" neutrum  ; -- fänghål..nn.1
  fängsel_1_N = mkN "fängsel" neutrum  ; -- fängsel..nn.1
  fängsla_1_V = mkV "fängslar" ; -- fängsla..vb.1
  fängslande_1_A = mkA "fängslande" ; -- fängslande..av.1
  fängslande_1_N = mkN "fängslande" ; -- fängslande..nn.1
  fängslig_1_A = mkA "fängslig" ; -- fängslig..av.1
  fängsling_1_N = mkN "fängsling" ; -- fängsling..nn.1
  fänkål_1_N = mkN "fänkål" ; -- fänkål..nn.1
  fänrik_1_N = mkN "fänrik" ; -- fänrik..nn.1
  färd_1_N = mkN "färd" "färder" ; -- färd..nn.1
  färdbevis_1_N = mkN "färdbevis" neutrum  ; -- färdbevis..nn.1
  färdbiljett_1_N = mkN "färdbiljett" "färdbiljetter" ; -- färdbiljett..nn.1
  färdig_1_A = mkA "färdig" ; -- färdig..av.1
  färdigbehandlad_1_A = mkA "färdigbehandlad" ; -- färdigbehandlad..av.1
  färdigbildad_1_A = mkA "färdigbildad" ; -- färdigbildad..av.1
  färdigblandad_1_A = mkA "färdigblandad" ; -- färdigblandad..av.1
  färdigbygga_1_V = mkV "färdigbygger" ; -- färdigbygga..vb.1
  färdigbyggande_1_N = mkN "färdigbyggande" ; -- färdigbyggande..nn.1
  färdighet_1_N = mkN "färdighet" "färdigheter" ; -- färdighet..nn.1
  färdighetsträning_1_N = mkN "färdighetsträning" ; -- färdighetsträning..nn.1
  färdighetsämne_1_N = mkN "färdighetsämne" ; -- färdighetsämne..nn.1
  färdigjäsa_1_V = mkV "färdigjäser" ; -- färdigjäsa..vb.1
  färdigjäsande_1_N = mkN "färdigjäsande" ; -- färdigjäsande..nn.1
  färdigjäsning_1_N = mkN "färdigjäsning" ; -- färdigjäsning..nn.1
  färdigkokt_1_A = mkA "färdigkokt" "färdigkokt" ; -- färdigkokt..av.1
  färdigkämpad_1_A = mkA "färdigkämpad" ; -- färdigkämpad..av.1
  färdiglagad_1_A = mkA "färdiglagad" ; -- färdiglagad..av.1
  färdigmat_1_N = mkN "färdigmat" ; -- färdigmat..nn.1
  färdigpackad_1_A = mkA "färdigpackad" ; -- färdigpackad..av.1
  färdigskivad_1_A = mkA "färdigskivad" ; -- färdigskivad..av.1
  färdigskriven_1_A = mkA "färdigskriven" ; -- färdigskriven..av.1
  färdigskulpterad_1_A = mkA "färdigskulpterad" ; -- färdigskulpterad..av.1
  färdigskämtad_1_A = mkA "färdigskämtad" ; -- färdigskämtad..av.1
  färdigställa_1_V = mkV "färdigställer" ; -- färdigställa..vb.1
  färdigställande_1_N = mkN "färdigställande" ; -- färdigställande..nn.1
  färdigutbildad_1_A = mkA "färdigutbildad" ; -- färdigutbildad..av.1
  färdigutvecklad_1_A = mkA "färdigutvecklad" ; -- färdigutvecklad..av.1
  färdknäpp_1_N = mkN "färdknäpp" ; -- färdknäpp..nn.1
  färdkost_1_N = mkN "färdkost" ; -- färdkost..nn.1
  färdled_1_N = mkN "färdled" "färdleder" ; -- färdled..nn.1
  färdledare_1_N = mkN "färdledare" utrum  ; -- färdledare..nn.1
  färdmedel_1_N = mkN "färdmedel" neutrum  ; -- färdmedel..nn.1
  färdriktning_1_N = mkN "färdriktning" ; -- färdriktning..nn.1
  färdskrivare_1_N = mkN "färdskrivare" utrum  ; -- färdskrivare..nn.1
  färdsup_1_N = mkN "färdsup" ; -- färdsup..nn.1
  färdsätt_1_N = mkN "färdsätt" "färdsätter" ; -- färdsätt..nn.1
  färdtjänst_1_N = mkN "färdtjänst" ; -- färdtjänst..nn.1
  färdväg_1_N = mkN "färdväg" ; -- färdväg..nn.1
  färg_1_N = mkN "färg" "färger" ; -- färg..nn.1
  färg_2_N = mkN "färg" ; -- färg..nn.2
  färga_1_V = mkV "färgar" ; -- färga..vb.1
  färgad_1_A = mkA "färgad" ; -- färgad..av.1
  färgande_1_N = mkN "färgande" ; -- färgande..nn.1
  färgare_1_N = mkN "färgare" utrum  ; -- färgare..nn.1
  färgbad_1_N = mkN "färgbad" neutrum  ; -- färgbad..nn.1
  färgband_1_N = mkN "färgband" neutrum  ; -- färgband..nn.1
  färgbehandling_1_N = mkN "färgbehandling" ; -- färgbehandling..nn.1
  färgbeständig_1_A = mkA "färgbeständig" ; -- färgbeständig..av.1
  färgbeständighet_1_N = mkN "färgbeständighet" ; -- färgbeständighet..nn.1
  färgbild_1_N = mkN "färgbild" "färgbilder" ; -- färgbild..nn.1
  färgblandning_1_N = mkN "färgblandning" ; -- färgblandning..nn.1
  färgblind_1_A = mkA "färgblind" ; -- färgblind..av.1
  färgblindhet_1_N = mkN "färgblindhet" ; -- färgblindhet..nn.1
  färgborttagning_1_N = mkN "färgborttagning" ; -- färgborttagning..nn.1
  färgbrytning_1_N = mkN "färgbrytning" ; -- färgbrytning..nn.1
  färgdelad_1_A = mkA "färgdelad" ; -- färgdelad..av.1
  färgeri_1_N = mkN "färgeri" "färgeriet" "färgerier" "färgerierna" ; -- färgeri..nn.1
  färgfilm_1_N = mkN "färgfilm" "färgfilmer" ; -- färgfilm..nn.1
  färgfilter_1_N = mkN "färgfilter" neutrum  ; -- färgfilter..nn.1
  färgflagnande_1_A = mkA "färgflagnande" ; -- färgflagnande..av.1
  färgfläck_1_N = mkN "färgfläck" ; -- färgfläck..nn.1
  färgförändring_1_N = mkN "färgförändring" ; -- färgförändring..nn.1
  färgglad_1_A = mkA "färgglad" "färgglatt" ; -- färgglad..av.1
  färgglans_1_N = mkN "färgglans" ; -- färgglans..nn.1
  färggrann_1_A = mkA "färggrann" "färggrant" ; -- färggrann..av.1
  färggrannhet_1_N = mkN "färggrannhet" ; -- färggrannhet..nn.1
  färghandel_1_N = mkN "färghandel" ; -- färghandel..nn.1
  färgharmoni_1_N = mkN "färgharmoni" "färgharmonier" ; -- färgharmoni..nn.1
  färgig_1_A = mkA "färgig" ; -- färgig..av.1
  färgillustration_1_N = mkN "färgillustration" ; -- färgillustration..nn.1
  färgklick_1_N = mkN "färgklick" ; -- färgklick..nn.1
  färgkonstans_1_N = mkN "färgkonstans" ; -- färgkonstans..nn.1
  färgkontrast_1_N = mkN "färgkontrast" "färgkontraster" ; -- färgkontrast..nn.1
  färgkrita_1_N = mkN "färgkrita" ; -- färgkrita..nn.1
  färgkänslig_1_A = mkA "färgkänslig" ; -- färgkänslig..av.1
  färgkänslighet_1_N = mkN "färgkänslighet" "färgkänsligheter" ; -- färgkänslighet..nn.1
  färglitografi_1_N = mkN "färglitografi" "färglitografier" ; -- färglitografi..nn.1
  färglägga_1_V = mkV "färglägga" "färgla" "färglagt" ; -- färglägga..vb.1
  färgläggande_1_N = mkN "färgläggande" ; -- färgläggande..nn.1
  färgläggning_1_N = mkN "färgläggning" ; -- färgläggning..nn.1
  färglära_1_N = mkN "färglära" ; -- färglära..nn.1
  färglåda_1_N = mkN "färglåda" ; -- färglåda..nn.1
  färglös_1_A = mkA "färglös" ; -- färglös..av.1
  färglöshet_1_N = mkN "färglöshet" ; -- färglöshet..nn.1
  färgmässig_1_A = mkA "färgmässig" ; -- färgmässig..av.1
  färgmättad_1_A = mkA "färgmättad" ; -- färgmättad..av.1
  färgmönster_1_N = mkN "färgmönster" neutrum  ; -- färgmönster..nn.1
  färgning_1_N = mkN "färgning" ; -- färgning..nn.1
  färgnyans_1_N = mkN "färgnyans" "färgnyanser" ; -- färgnyans..nn.1
  färgpenna_1_N = mkN "färgpenna" ; -- färgpenna..nn.1
  färgpigment_1_N = mkN "färgpigment" neutrum  ; -- färgpigment..nn.1
  färgprakt_1_N = mkN "färgprakt" ; -- färgprakt..nn.1
  färgreproduktion_1_N = mkN "färgreproduktion" ; -- färgreproduktion..nn.1
  färgrik_1_A = mkA "färgrik" ; -- färgrik..av.1
  färgrikedom_1_N = mkN "färgrikedom" ; -- färgrikedom..nn.1
  färgrikhet_1_N = mkN "färgrikhet" ; -- färgrikhet..nn.1
  färgrivning_1_N = mkN "färgrivning" ; -- färgrivning..nn.1
  färgsammansättning_1_N = mkN "färgsammansättning" ; -- färgsammansättning..nn.1
  färgseende_1_N = mkN "färgseende" ; -- färgseende..nn.1
  färgsinne_1_N = mkN "färgsinne" ; -- färgsinne..nn.1
  färgskala_1_N = mkN "färgskala" ; -- färgskala..nn.1
  färgskalle_1_N = mkN "färgskalle" utrum  ; -- färgskalle..nn.1
  färgskiftning_1_N = mkN "färgskiftning" ; -- färgskiftning..nn.1
  färgskrapa_1_N = mkN "färgskrapa" ; -- färgskrapa..nn.1
  färgspektrum_1_N = mkN "färgspektrum" neutrum  ; -- färgspektrum..nn.1
  färgspel_1_N = mkN "färgspel" "färgspelet" "färgspel" "färgspelen" ; -- färgspel..nn.1
  färgsprakande_1_A = mkA "färgsprakande" ; -- färgsprakande..av.1
  färgspridning_1_N = mkN "färgspridning" ; -- färgspridning..nn.1
  färgspruta_1_N = mkN "färgspruta" ; -- färgspruta..nn.1
  färgsprutning_1_N = mkN "färgsprutning" ; -- färgsprutning..nn.1
  färgsprutpistol_1_N = mkN "färgsprutpistol" "färgsprutpistoler" ; -- färgsprutpistol..nn.1
  färgstark_1_A = mkA "färgstark" ; -- färgstark..av.1
  färgstarkhet_1_N = mkN "färgstarkhet" ; -- färgstarkhet..nn.1
  färgstege_1_N = mkN "färgstege" utrum  ; -- färgstege..nn.1
  färgstoff_1_N = mkN "färgstoff" "färgstoffer" ; -- färgstoff..nn.1
  färgsättning_1_N = mkN "färgsättning" ; -- färgsättning..nn.1
  färgtemperatur_1_N = mkN "färgtemperatur" "färgtemperaturer" ; -- färgtemperatur..nn.1
  färgteve_1_N = mkN "färgteve" "färgteven" "färgtevear" "färgtevearna" ; -- färgteve..nn.1
  färgton_1_N = mkN "färgton" "färgtoner" ; -- färgton..nn.1
  färgtryck_1_N = mkN "färgtryck" neutrum  ; -- färgtryck..nn.1
  färgval_1_N = mkN "färgval" neutrum  ; -- färgval..nn.1
  färgväxling_1_N = mkN "färgväxling" ; -- färgväxling..nn.1
  färgäkta_1_A = mkA "färgäkta" ; -- färgäkta..av.1
  färgämne_1_N = mkN "färgämne" ; -- färgämne..nn.1
  färing_1_N = mkN "färing" ; -- färing..nn.1
  färja_1_N = mkN "färja" ; -- färja..nn.1
  färja_1_V = mkV "färjar" ; -- färja..vb.1
  färjande_1_N = mkN "färjande" ; -- färjande..nn.1
  färjeankomst_1_N = mkN "färjeankomst" "färjeankomster" ; -- färjeankomst..nn.1
  färjeavgång_1_N = mkN "färjeavgång" ; -- färjeavgång..nn.1
  färjeläge_1_N = mkN "färjeläge" ; -- färjeläge..nn.1
  färjelägenhet_1_N = mkN "färjelägenhet" "färjelägenheter" ; -- färjelägenhet..nn.1
  färjeolycka_1_N = mkN "färjeolycka" ; -- färjeolycka..nn.1
  färjepassagerare_1_N = mkN "färjepassagerare" utrum  ; -- färjepassagerare..nn.1
  färjeterminal_1_N = mkN "färjeterminal" "färjeterminaler" ; -- färjeterminal..nn.1
  färjetidtabell_1_N = mkN "färjetidtabell" "färjetidtabeller" ; -- färjetidtabell..nn.1
  färjetrafik_1_N = mkN "färjetrafik" ; -- färjetrafik..nn.1
  färjetransport_1_N = mkN "färjetransport" "färjetransporter" ; -- färjetransport..nn.1
  färjetur_1_N = mkN "färjetur" "färjeturer" ; -- färjetur..nn.1
  färjkarl_1_N = mkN "färjkarl" ; -- färjkarl..nn.1
  färla_1_N = mkN "färla" ; -- färla..nn.1
  färm_1_A = mkA "färm" ; -- färm..av.1
  färmitet_1_N = mkN "färmitet" "färmiteter" ; -- färmitet..nn.1
  färna_1_N = mkN "färna" ; -- färna..nn.1
  färnbock_1_N = mkN "färnbock" ; -- färnbock..nn.1
  färs_1_N = mkN "färs" "färser" ; -- färs..nn.1
  färsera_1_V = mkV "färserar" ; -- färsera..vb.1
  färserande_1_N = mkN "färserande" ; -- färserande..nn.1
  färserbar_1_A = mkA "färserbar" ; -- färserbar..av.1
  färserbarhet_1_N = mkN "färserbarhet" ; -- färserbarhet..nn.1
  färsering_1_N = mkN "färsering" ; -- färsering..nn.1
  färsk_1_A = mkA "färsk" ; -- färsk..av.1
  färska_1_V = mkV "färskar" ; -- färska..vb.1
  färskande_1_N = mkN "färskande" ; -- färskande..nn.1
  färskhet_1_N = mkN "färskhet" ; -- färskhet..nn.1
  färsking_1_N = mkN "färsking" ; -- färsking..nn.1
  färskmalm_1_N = mkN "färskmalm" "färskmalmer" ; -- färskmalm..nn.1
  färskmat_1_N = mkN "färskmat" ; -- färskmat..nn.1
  färskning_1_N = mkN "färskning" ; -- färskning..nn.1
  färskost_1_N = mkN "färskost" ; -- färskost..nn.1
  färskpotatis_1_N = mkN "färskpotatis" ; -- färskpotatis..nn.1
  färskpressad_1_A = mkA "färskpressad" ; -- färskpressad..av.1
  färsksmide_1_N = mkN "färsksmide" ; -- färsksmide..nn.1
  färskvara_1_N = mkN "färskvara" ; -- färskvara..nn.1
  färskvarudisk_1_N = mkN "färskvarudisk" ; -- färskvarudisk..nn.1
  färskvatten_1_N = mkN "färskvatten" "färskvattnet" "färskvatten" "färskvattnen" ; -- färskvatten..nn.1
  färsköl_1_N = mkN "färsköl" neutrum  ; -- färsköl..nn.1
  färöing_1_N = mkN "färöing" ; -- färöing..nn.1
  färöisk_1_A = mkA "färöisk" ; -- färöisk..av.1
  färöiska_1_N = mkN "färöiska" ; -- färöiska..nn.1
  färöiska_2_N = mkN "färöiska" ; -- färöiska..nn.2
  fäst_1_A = mkA "fäst" "fäst" ; -- fäst..av.1
  fästa_1_V = mkV "fästa" "fäster" "fäst" "fäste" "fäst" "fäst" ; -- fästa..vb.1
  fästad_1_A = mkA "fästad" ; -- fästad..av.1
  fästande_1_N = mkN "fästande" ; -- fästande..nn.1
  fästanordning_1_N = mkN "fästanordning" ; -- fästanordning..nn.1
  fäste_1_N = mkN "fäste" ; -- fäste..nn.1
  fästefolk_1_N = mkN "fästefolk" neutrum  ; -- fästefolk..nn.1
  fästfolk_1_N = mkN "fästfolk" neutrum  ; -- fästfolk..nn.1
  fästing_1_N = mkN "fästing" ; -- fästing..nn.1
  fästingburen_1_A = mkA "fästingburen" ; -- fästingburen..av.1
  fästingfeber_1_N = mkN "fästingfeber" ; -- fästingfeber..nn.1
  fästingvirus_1_N = mkN "fästingvirus" neutrum  ; -- fästingvirus..nn.1
  fästjärn_1_N = mkN "fästjärn" neutrum  ; -- fästjärn..nn.1
  fästkrok_1_N = mkN "fästkrok" ; -- fästkrok..nn.1
  fästman_1_N = mkN "fästman" "fästmannen" "fästmän" "fästmännen" ; -- fästman..nn.1
  fästmanssoffa_1_N = mkN "fästmanssoffa" ; -- fästmanssoffa..nn.1
  fästmö_1_N = mkN "fästmö" "fästmön" "fästmör" "fästmörna" ; -- fästmö..nn.1
  fästning_1_N = mkN "fästning" ; -- fästning..nn.1
  fästningsfånge_1_N = mkN "fästningsfånge" utrum  ; -- fästningsfånge..nn.1
  fästningsgrav_1_N = mkN "fästningsgrav" ; -- fästningsgrav..nn.1
  fästningskommendant_1_N = mkN "fästningskommendant" "fästningskommendanter" ; -- fästningskommendant..nn.1
  fästningsliknande_1_A = mkA "fästningsliknande" ; -- fästningsliknande..av.1
  fästningsmur_1_N = mkN "fästningsmur" ; -- fästningsmur..nn.1
  fästningsstraff_1_N = mkN "fästningsstraff" neutrum  ; -- fästningsstraff..nn.1
  fästningsvall_1_N = mkN "fästningsvall" ; -- fästningsvall..nn.1
  fästplatta_1_N = mkN "fästplatta" ; -- fästplatta..nn.1
  fästpunkt_1_N = mkN "fästpunkt" "fästpunkter" ; -- fästpunkt..nn.1
  fästskruv_1_N = mkN "fästskruv" ; -- fästskruv..nn.1
  fäsör_1_N = mkN "fäsör" "fäsörer" ; -- fäsör..nn.1
  få_1_A = mkA "få" "få" "få" "färre" "färst" ; -- få..av.1
  få_1_V = mkV "få" "fick" "fått" ; -- få..vb.1
  fående_1_N = mkN "fående" ; -- fående..nn.1
  fåfäng_1_A = mkA "fåfäng" ; -- fåfäng..av.1
  fåfänga_1_N = mkN "fåfänga" ; -- fåfänga..nn.1
  fåfänghet_1_N = mkN "fåfänghet" ; -- fåfänghet..nn.1
  fåfänglig_1_A = mkA "fåfänglig" ; -- fåfänglig..av.1
  fåfänglighet_1_N = mkN "fåfänglighet" "fåfängligheter" ; -- fåfänglighet..nn.1
  fågel_1_N = mkN "fågel" ; -- fågel..nn.1
  fågel_2_N = mkN "fågel" ; -- fågel..nn.2
  fågelart_1_N = mkN "fågelart" "fågelarter" ; -- fågelart..nn.1
  fågelbad_1_N = mkN "fågelbad" neutrum  ; -- fågelbad..nn.1
  fågelbo_1_N = mkN "fågelbo" "fågelboet" "fågelbon" "fågelbona" ; -- fågelbo..nn.1
  fågelbord_1_N = mkN "fågelbord" neutrum  ; -- fågelbord..nn.1
  fågelbur_1_N = mkN "fågelbur" ; -- fågelbur..nn.1
  fågelbär_1_N = mkN "fågelbär" neutrum  ; -- fågelbär..nn.1
  fågelbössa_1_N = mkN "fågelbössa" ; -- fågelbössa..nn.1
  fågeldans_1_N = mkN "fågeldans" "fågeldanser" ; -- fågeldans..nn.1
  fågeldun_1_N = mkN "fågeldun" neutrum  ; -- fågeldun..nn.1
  fågelfjäder_1_N = mkN "fågelfjäder" ; -- fågelfjäder..nn.1
  fågelfot_1_N = mkN "fågelfot" "fågelfötter" ; -- fågelfot..nn.1
  fågelfri_1_A = mkA "fågelfri" "fågelfritt" ; -- fågelfri..av.1
  fågelfänge_1_N = mkN "fågelfänge" ; -- fågelfänge..nn.1
  fågelhagel_1_N = mkN "fågelhagel" neutrum  ; -- fågelhagel..nn.1
  fågelholk_1_N = mkN "fågelholk" ; -- fågelholk..nn.1
  fågelhund_1_N = mkN "fågelhund" ; -- fågelhund..nn.1
  fågelinfluensa_1_N = mkN "fågelinfluensa" ; -- fågelinfluensa..nn.1
  fågelinventerare_1_N = mkN "fågelinventerare" utrum  ; -- fågelinventerare..nn.1
  fågeljakt_1_N = mkN "fågeljakt" "fågeljakter" ; -- fågeljakt..nn.1
  fågelkam_1_N = mkN "fågelkam" "fågelkammen" "fågelkammar" "fågelkammarna" ; -- fågelkam..nn.1
  fågelkunnig_1_A = mkA "fågelkunnig" ; -- fågelkunnig..av.1
  fågelkunnighet_1_N = mkN "fågelkunnighet" ; -- fågelkunnighet..nn.1
  fågelkvitter_1_N = mkN "fågelkvitter" neutrum  ; -- fågelkvitter..nn.1
  fågelmat_1_N = mkN "fågelmat" ; -- fågelmat..nn.1
  fågelmatare_1_N = mkN "fågelmatare" utrum  ; -- fågelmatare..nn.1
  fågelperspektiv_1_N = mkN "fågelperspektiv" neutrum  ; -- fågelperspektiv..nn.1
  fågelpopulation_1_N = mkN "fågelpopulation" ; -- fågelpopulation..nn.1
  fågelskrämma_1_N = mkN "fågelskrämma" ; -- fågelskrämma..nn.1
  fågelskytt_1_N = mkN "fågelskytt" ; -- fågelskytt..nn.1
  fågelskytte_1_N = mkN "fågelskytte" ; -- fågelskytte..nn.1
  fågelskådare_1_N = mkN "fågelskådare" utrum  ; -- fågelskådare..nn.1
  fågelskådning_1_N = mkN "fågelskådning" ; -- fågelskådning..nn.1
  fågelsnara_1_N = mkN "fågelsnara" ; -- fågelsnara..nn.1
  fågelsträck_1_N = mkN "fågelsträck" neutrum  ; -- fågelsträck..nn.1
  fågelsång_1_N = mkN "fågelsång" ; -- fågelsång..nn.1
  fågeltom_1_A = mkA "fågeltom" "fågeltomt" "fågeltomma" "fågeltomma" "fågeltommare" "fågeltommast" "fågeltommaste" ; -- fågeltom..av.1
  fågelträck_1_N = mkN "fågelträck" ; -- fågelträck..nn.1
  fågelunge_1_N = mkN "fågelunge" utrum  ; -- fågelunge..nn.1
  fågelvinge_1_N = mkN "fågelvinge" utrum  ; -- fågelvinge..nn.1
  fågelvurm_1_N = mkN "fågelvurm" ; -- fågelvurm..nn.1
  fågelägg_1_N = mkN "fågelägg" neutrum  ; -- fågelägg..nn.1
  fågelö_1_N = mkN "fågelö" ; -- fågelö..nn.1
  fåglalåt_1_N = mkN "fåglalåt" ; -- fåglalåt..nn.1
  fåkunnig_1_A = mkA "fåkunnig" ; -- fåkunnig..av.1
  fåkunnighet_1_N = mkN "fåkunnighet" ; -- fåkunnighet..nn.1
  fåle_1_N = mkN "fåle" utrum  ; -- fåle..nn.1
  fåll_1_N = mkN "fåll" ; -- fåll..nn.1
  fålla_1_N = mkN "fålla" ; -- fålla..nn.1
  fålla_1_V = mkV "fållar" ; -- fålla..vb.1
  fållande_1_N = mkN "fållande" ; -- fållande..nn.1
  fållbänk_1_N = mkN "fållbänk" ; -- fållbänk..nn.1
  fållning_1_N = mkN "fållning" ; -- fållning..nn.1
  fåmannavälde_1_N = mkN "fåmannavälde" ; -- fåmannavälde..nn.1
  fåmansföretag_1_N = mkN "fåmansföretag" neutrum  ; -- fåmansföretag..nn.1
  fåmäld_1_A = mkA "fåmäld" "fåmält" ; -- fåmäld..av.1
  fåmäldhet_1_N = mkN "fåmäldhet" ; -- fåmäldhet..nn.1
  fåmält_1_A = mkA "fåmält" "fåmält" ; -- fåmält..av.1
  fån_1_N = mkN "fån" neutrum  ; -- fån..nn.1
  fåne_1_N = mkN "fåne" utrum  ; -- fåne..nn.1
  fåneri_1_N = mkN "fåneri" "fåneriet" "fånerier" "fånerierna" ; -- fåneri..nn.1
  fång_1_N = mkN "fång" neutrum  ; -- fång..nn.1
  fång_2_N = mkN "fång" ; -- fång..nn.2
  fånga_1_V = mkV "fångar" ; -- fånga..vb.1
  fånga_2_V = mkV "fångar" ; -- fånga..vb.2
  fångande_1_N = mkN "fångande" ; -- fångande..nn.1
  fångbevakning_1_N = mkN "fångbevakning" ; -- fångbevakning..nn.1
  fångdräkt_1_N = mkN "fångdräkt" "fångdräkter" ; -- fångdräkt..nn.1
  fånge_1_N = mkN "fånge" utrum  ; -- fånge..nn.1
  fången_1_A = mkA "fången" ; -- fången..av.1
  fångenskap_1_N = mkN "fångenskap" ; -- fångenskap..nn.1
  fångeshandling_1_N = mkN "fångeshandling" ; -- fångeshandling..nn.1
  fångesman_1_N = mkN "fångesman" "fångesmannen" "fångesmän" "fångesmännen" ; -- fångesman..nn.1
  fånggård_1_N = mkN "fånggård" ; -- fånggård..nn.1
  fånglina_1_N = mkN "fånglina" ; -- fånglina..nn.1
  fångläger_1_N = mkN "fångläger" neutrum  ; -- fångläger..nn.1
  fångst_1_N = mkN "fångst" "fångster" ; -- fångst..nn.1
  fångstanordning_1_N = mkN "fångstanordning" ; -- fångstanordning..nn.1
  fångstfartyg_1_N = mkN "fångstfartyg" neutrum  ; -- fångstfartyg..nn.1
  fångstfolk_1_N = mkN "fångstfolk" neutrum  ; -- fångstfolk..nn.1
  fångstgrop_1_N = mkN "fångstgrop" ; -- fångstgrop..nn.1
  fångstkrok_1_N = mkN "fångstkrok" ; -- fångstkrok..nn.1
  fångstkultur_1_N = mkN "fångstkultur" "fångstkulturer" ; -- fångstkultur..nn.1
  fångstplats_1_N = mkN "fångstplats" "fångstplatser" ; -- fångstplats..nn.1
  fångstredskap_1_N = mkN "fångstredskap" neutrum  ; -- fångstredskap..nn.1
  fångstsamhälle_1_N = mkN "fångstsamhälle" ; -- fångstsamhälle..nn.1
  fångstsätt_1_N = mkN "fångstsätt" neutrum  ; -- fångstsätt..nn.1
  fångtransport_1_N = mkN "fångtransport" "fångtransporter" ; -- fångtransport..nn.1
  fånguppror_1_N = mkN "fånguppror" neutrum  ; -- fånguppror..nn.1
  fångutväxling_1_N = mkN "fångutväxling" ; -- fångutväxling..nn.1
  fångvaktare_1_N = mkN "fångvaktare" utrum  ; -- fångvaktare..nn.1
  fångvård_1_N = mkN "fångvård" ; -- fångvård..nn.1
  fångvårdsanstalt_1_N = mkN "fångvårdsanstalt" "fångvårdsanstalter" ; -- fångvårdsanstalt..nn.1
  fånig_1_A = mkA "fånig" ; -- fånig..av.1
  fånighet_1_N = mkN "fånighet" "fånigheter" ; -- fånighet..nn.1
  fånskratt_1_N = mkN "fånskratt" neutrum  ; -- fånskratt..nn.1
  fånskratta_1_V = mkV "fånskrattar" ; -- fånskratta..vb.1
  fånskrattande_1_N = mkN "fånskrattande" ; -- fånskrattande..nn.1
  fåntratt_1_N = mkN "fåntratt" ; -- fåntratt..nn.1
  fåntratta_1_V = mkV "fåntrattar" ; -- fåntratta..vb.1
  fåordig_1_A = mkA "fåordig" ; -- fåordig..av.1
  fåordighet_1_N = mkN "fåordighet" ; -- fåordighet..nn.1
  får_1_N = mkN "får" neutrum  ; -- får..nn.1
  fåra_1_N = mkN "fåra" ; -- fåra..nn.1
  fåra_1_V = mkV "fårar" ; -- fåra..vb.1
  fårahage_1_N = mkN "fårahage" utrum  ; -- fårahage..nn.1
  fåraherde_1_N = mkN "fåraherde" utrum  ; -- fåraherde..nn.1
  fårahjord_1_N = mkN "fårahjord" ; -- fårahjord..nn.1
  fåraktig_1_A = mkA "fåraktig" ; -- fåraktig..av.1
  fåraktighet_1_N = mkN "fåraktighet" ; -- fåraktighet..nn.1
  fårande_1_N = mkN "fårande" ; -- fårande..nn.1
  fåravel_1_N = mkN "fåravel" ; -- fåravel..nn.1
  fårbete_1_N = mkN "fårbete" ; -- fårbete..nn.1
  fårbogsärm_1_N = mkN "fårbogsärm" ; -- fårbogsärm..nn.1
  fårbonde_1_N = mkN "fårbonde" "fårbönder" ; -- fårbonde..nn.1
  fårfarmare_1_N = mkN "fårfarmare" utrum  ; -- fårfarmare..nn.1
  fårfiol_1_N = mkN "fårfiol" "fårfioler" ; -- fårfiol..nn.1
  fårfålla_1_N = mkN "fårfålla" ; -- fårfålla..nn.1
  fårhjord_1_N = mkN "fårhjord" ; -- fårhjord..nn.1
  fårhund_1_N = mkN "fårhund" ; -- fårhund..nn.1
  fårhus_1_N = mkN "fårhus" neutrum  ; -- fårhus..nn.1
  fårhuvud_1_N = mkN "fårhuvud" "fårhuvudet" "fårhuvud" "fårhuvudena" ; -- fårhuvud..nn.1
  fårkätte_1_N = mkN "fårkätte" utrum  ; -- fårkätte..nn.1
  fårkött_1_N = mkN "fårkött" neutrum  ; -- fårkött..nn.1
  fårmjölk_1_N = mkN "fårmjölk" ; -- fårmjölk..nn.1
  fårost_1_N = mkN "fårost" ; -- fårost..nn.1
  fårsex_1_N = mkN "fårsex" neutrum  ; -- fårsex..nn.1
  fårskalle_1_N = mkN "fårskalle" utrum  ; -- fårskalle..nn.1
  fårskinn_1_N = mkN "fårskinn" neutrum  ; -- fårskinn..nn.1
  fårskötsel_1_N = mkN "fårskötsel" ; -- fårskötsel..nn.1
  fårsvingel_1_N = mkN "fårsvingel" ; -- fårsvingel..nn.1
  fårtarm_1_N = mkN "fårtarm" ; -- fårtarm..nn.1
  fårticka_1_N = mkN "fårticka" ; -- fårticka..nn.1
  fårull_1_N = mkN "fårull" ; -- fårull..nn.1
  fåt_1_N = mkN "fåt" "fåter" ; -- fåt..nn.1
  fåtal_1_N = mkN "fåtal" neutrum  ; -- fåtal..nn.1
  fåtalig_1_A = mkA "fåtalig" ; -- fåtalig..av.1
  fåtalighet_1_N = mkN "fåtalighet" ; -- fåtalighet..nn.1
  fåtölj_1_N = mkN "fåtölj" "fåtöljer" ; -- fåtölj..nn.1
  fåvitsk_1_A = mkA "fåvitsk" ; -- fåvitsk..av.1
  fåvitskhet_1_N = mkN "fåvitskhet" ; -- fåvitskhet..nn.1
  föda_1_N = mkN "föda" ; -- föda..nn.1
  föda_1_V = mkV "föda" "födde" "fött" ; -- föda..vb.1
  födande_1_N = mkN "födande" ; -- födande..nn.1
  född_1_A = mkA "född" ; -- född..av.1
  födelse_1_N = mkN "födelse" "födelser" ; -- födelse..nn.1
  födelseattest_1_N = mkN "födelseattest" "födelseattester" ; -- födelseattest..nn.1
  födelsebygd_1_N = mkN "födelsebygd" "födelsebygder" ; -- födelsebygd..nn.1
  födelsedag_1_N = mkN "födelsedag" ; -- födelsedag..nn.1
  födelsedagsbarn_1_N = mkN "födelsedagsbarn" neutrum  ; -- födelsedagsbarn..nn.1
  födelsedagsfest_1_N = mkN "födelsedagsfest" "födelsedagsfester" ; -- födelsedagsfest..nn.1
  födelsedagsgåva_1_N = mkN "födelsedagsgåva" ; -- födelsedagsgåva..nn.1
  födelsedagskalas_1_N = mkN "födelsedagskalas" neutrum  ; -- födelsedagskalas..nn.1
  födelsedagsmiddag_1_N = mkN "födelsedagsmiddag" ; -- födelsedagsmiddag..nn.1
  födelsedagspresent_1_N = mkN "födelsedagspresent" "födelsedagspresenter" ; -- födelsedagspresent..nn.1
  födelsedagsstress_1_N = mkN "födelsedagsstress" ; -- födelsedagsstress..nn.1
  födelsedagstårta_1_N = mkN "födelsedagstårta" ; -- födelsedagstårta..nn.1
  födelsedatum_1_N = mkN "födelsedatum" ; -- födelsedatum..nn.1
  födelsehem_1_N = mkN "födelsehem" "födelsehemmet" "födelsehem" "födelsehemmen" ; -- födelsehem..nn.1
  födelsekalas_1_N = mkN "födelsekalas" neutrum  ; -- födelsekalas..nn.1
  födelsekontroll_1_N = mkN "födelsekontroll" "födelsekontroller" ; -- födelsekontroll..nn.1
  födelsemärke_1_N = mkN "födelsemärke" ; -- födelsemärke..nn.1
  födelsenummer_1_N = mkN "födelsenummer" neutrum  ; -- födelsenummer..nn.1
  födelseort_1_N = mkN "födelseort" "födelseorter" ; -- födelseort..nn.1
  födelsestad_1_N = mkN "födelsestad" "födelsestäder" ; -- födelsestad..nn.1
  födelsetal_1_N = mkN "födelsetal" neutrum  ; -- födelsetal..nn.1
  födelsetimme_1_N = mkN "födelsetimme" utrum  ; -- födelsetimme..nn.1
  födelseår_1_N = mkN "födelseår" neutrum  ; -- födelseår..nn.1
  födgeni_1_N = mkN "födgeni" "födgeniet" "födgenier" "födgenierna" ; -- födgeni..nn.1
  födkrok_1_N = mkN "födkrok" ; -- födkrok..nn.1
  födoorganism_1_N = mkN "födoorganism" "födoorganismer" ; -- födoorganism..nn.1
  födopartikel_1_N = mkN "födopartikel" ; -- födopartikel..nn.1
  födoråd_1_N = mkN "födoråd" neutrum  ; -- födoråd..nn.1
  födoämne_1_N = mkN "födoämne" ; -- födoämne..nn.1
  födsel_1_N = mkN "födsel" ; -- födsel..nn.1
  födseltal_1_N = mkN "födseltal" neutrum  ; -- födseltal..nn.1
  födslorätt_1_N = mkN "födslorätt" "födslorätter" ; -- födslorätt..nn.1
  födsloskri_1_N = mkN "födsloskri" "födsloskriet" "födsloskrin" "födsloskrina" ; -- födsloskri..nn.1
  födslostund_1_N = mkN "födslostund" "födslostunder" ; -- födslostund..nn.1
  födslotal_1_N = mkN "födslotal" neutrum  ; -- födslotal..nn.1
  födslovärk_1_N = mkN "födslovärk" ; -- födslovärk..nn.1
  födslovånda_1_N = mkN "födslovånda" ; -- födslovånda..nn.1
  föga_1_Adv = mkAdv "föga" ; -- föga..ab.1
  föga_1_A = mkA "föga" ; -- föga..av.1
  fögderi_1_N = mkN "fögderi" "fögderiet" "fögderier" "fögderierna" ; -- fögderi..nn.1
  fögderiförvaltning_1_N = mkN "fögderiförvaltning" ; -- fögderiförvaltning..nn.1
  föhn_1_N = mkN "föhn" ; -- föhn..nn.1
  föl_1_N = mkN "föl" neutrum  ; -- föl..nn.1
  föla_1_V = mkV "fölar" ; -- föla..vb.1
  fölande_1_N = mkN "fölande" ; -- fölande..nn.1
  följa_1_V = mkV "följa" "följde" "följt" ; -- följa..vb.1
  följaktig_1_A = mkA "följaktig" ; -- följaktig..av.1
  följaktligen_1_Adv = mkAdv "följaktligen" ; -- följaktligen..ab.1
  följande_1_A = mkA "följande" ; -- följande..av.1
  följande_1_N = mkN "följande" ; -- följande..nn.1
  följd_1_N = mkN "följd" "följder" ; -- följd..nn.1
  följdenlig_1_A = mkA "följdenlig" ; -- följdenlig..av.1
  följdenlighet_1_N = mkN "följdenlighet" ; -- följdenlighet..nn.1
  följdfråga_1_N = mkN "följdfråga" ; -- följdfråga..nn.1
  följdproblem_1_N = mkN "följdproblem" neutrum  ; -- följdproblem..nn.1
  följdriktig_1_A = mkA "följdriktig" ; -- följdriktig..av.1
  följdriktighet_1_N = mkN "följdriktighet" ; -- följdriktighet..nn.1
  följdsats_1_N = mkN "följdsats" "följdsatser" ; -- följdsats..nn.1
  följdsjukdom_1_N = mkN "följdsjukdom" ; -- följdsjukdom..nn.1
  följdverkning_1_N = mkN "följdverkning" ; -- följdverkning..nn.1
  följe_1_N = mkN "följe" ; -- följe..nn.1
  följebil_1_N = mkN "följebil" ; -- följebil..nn.1
  följebrev_1_N = mkN "följebrev" neutrum  ; -- följebrev..nn.1
  följesedel_1_N = mkN "följesedel" ; -- följesedel..nn.1
  följeslagare_1_N = mkN "följeslagare" utrum  ; -- följeslagare..nn.1
  följeslagarinna_1_N = mkN "följeslagarinna" ; -- följeslagarinna..nn.1
  följetong_1_N = mkN "följetong" "följetonger" ; -- följetong..nn.1
  följetongsmässig_1_A = mkA "följetongsmässig" ; -- följetongsmässig..av.1
  följsam_1_A = mkA "följsam" "följsamt" "följsamma" "följsamma" "följsammare" "följsammast" "följsammaste" ; -- följsam..av.1
  följsamhet_1_N = mkN "följsamhet" "följsamheter" ; -- följsamhet..nn.1
  fölning_1_N = mkN "fölning" ; -- fölning..nn.1
  fölsto_1_N = mkN "fölsto" "fölstot" "fölston" "fölstona" ; -- fölsto..nn.1
  fölunge_1_N = mkN "fölunge" utrum  ; -- fölunge..nn.1
  fön_1_N = mkN "fön" ; -- fön..nn.1
  fön_2_N = mkN "fön" ; -- fön..nn.2
  föna_1_V = mkV "fönar" ; -- föna..vb.1
  fönande_1_N = mkN "fönande" ; -- fönande..nn.1
  fönster_1_N = mkN "fönster" neutrum  ; -- fönster..nn.1
  fönsterbeslag_1_N = mkN "fönsterbeslag" neutrum  ; -- fönsterbeslag..nn.1
  fönsterbleck_1_N = mkN "fönsterbleck" neutrum  ; -- fönsterbleck..nn.1
  fönsterbord_1_N = mkN "fönsterbord" neutrum  ; -- fönsterbord..nn.1
  fönsterbräda_1_N = mkN "fönsterbräda" ; -- fönsterbräda..nn.1
  fönsterbräde_1_N = mkN "fönsterbräde" ; -- fönsterbräde..nn.1
  fönsterbänk_1_N = mkN "fönsterbänk" ; -- fönsterbänk..nn.1
  fönsterbåge_1_N = mkN "fönsterbåge" utrum  ; -- fönsterbåge..nn.1
  fönsterdraperi_1_N = mkN "fönsterdraperi" "fönsterdraperiet" "fönsterdraperier" "fönsterdraperierna" ; -- fönsterdraperi..nn.1
  fönsterfärg_1_N = mkN "fönsterfärg" "fönsterfärger" ; -- fönsterfärg..nn.1
  fönstergaller_1_N = mkN "fönstergaller" neutrum  ; -- fönstergaller..nn.1
  fönsterglas_1_N = mkN "fönsterglas" neutrum  ; -- fönsterglas..nn.1
  fönsterglugg_1_N = mkN "fönsterglugg" ; -- fönsterglugg..nn.1
  fönsterhake_1_N = mkN "fönsterhake" utrum  ; -- fönsterhake..nn.1
  fönsterhasp_1_N = mkN "fönsterhasp" ; -- fönsterhasp..nn.1
  fönsterkarm_1_N = mkN "fönsterkarm" ; -- fönsterkarm..nn.1
  fönsterkitt_1_N = mkN "fönsterkitt" neutrum  ; -- fönsterkitt..nn.1
  fönsterkuvert_1_N = mkN "fönsterkuvert" neutrum  ; -- fönsterkuvert..nn.1
  fönsterlav_1_N = mkN "fönsterlav" ; -- fönsterlav..nn.1
  fönsterlucka_1_N = mkN "fönsterlucka" ; -- fönsterlucka..nn.1
  fönsterluft_1_N = mkN "fönsterluft" "fönsterlufter" ; -- fönsterluft..nn.1
  fönsterlös_1_A = mkA "fönsterlös" ; -- fönsterlös..av.1
  fönsternisch_1_N = mkN "fönsternisch" "fönsternischer" ; -- fönsternisch..nn.1
  fönsterplats_1_N = mkN "fönsterplats" "fönsterplatser" ; -- fönsterplats..nn.1
  fönsterpost_1_N = mkN "fönsterpost" "fönsterposter" ; -- fönsterpost..nn.1
  fönsterputs_1_N = mkN "fönsterputs" ; -- fönsterputs..nn.1
  fönsterputs_2_N = mkN "fönsterputs" ; -- fönsterputs..nn.2
  fönsterputsare_1_N = mkN "fönsterputsare" utrum  ; -- fönsterputsare..nn.1
  fönsterputsduk_1_N = mkN "fönsterputsduk" ; -- fönsterputsduk..nn.1
  fönsterputsning_1_N = mkN "fönsterputsning" ; -- fönsterputsning..nn.1
  fönsterputsvätska_1_N = mkN "fönsterputsvätska" ; -- fönsterputsvätska..nn.1
  fönsterrektangel_1_N = mkN "fönsterrektangel" ; -- fönsterrektangel..nn.1
  fönsterruta_1_N = mkN "fönsterruta" ; -- fönsterruta..nn.1
  fönstershoppa_1_V = mkV "fönstershoppar" ; -- fönstershoppa..vb.1
  fönstershoppande_1_N = mkN "fönstershoppande" ; -- fönstershoppande..nn.1
  fönstershopping_1_N = mkN "fönstershopping" ; -- fönstershopping..nn.1
  fönstershoppning_1_N = mkN "fönstershoppning" ; -- fönstershoppning..nn.1
  fönstersmyg_1_N = mkN "fönstersmyg" ; -- fönstersmyg..nn.1
  fönsterspringa_1_N = mkN "fönsterspringa" ; -- fönsterspringa..nn.1
  fönsterstolpe_1_N = mkN "fönsterstolpe" utrum  ; -- fönsterstolpe..nn.1
  fönstertittare_1_N = mkN "fönstertittare" utrum  ; -- fönstertittare..nn.1
  fönsteröppning_1_N = mkN "fönsteröppning" ; -- fönsteröppning..nn.1
  för_1_Adv = mkAdv "för" ; -- för..ab.1
  för_1_N = mkN "för" ; -- för..nn.1
  föra_1_V = mkV "föra" "förde" "fört" ; -- föra..vb.1
  förakt_1_N = mkN "förakt" neutrum  ; -- förakt..nn.1
  förakta_1_V = mkV "föraktar" ; -- förakta..vb.1
  föraktande_1_N = mkN "föraktande" ; -- föraktande..nn.1
  föraktfull_1_A = mkA "föraktfull" ; -- föraktfull..av.1
  föraktfullhet_1_N = mkN "föraktfullhet" "föraktfullheter" ; -- föraktfullhet..nn.1
  föraktlig_1_A = mkA "föraktlig" ; -- föraktlig..av.1
  föraktlighet_1_N = mkN "föraktlighet" "föraktligheter" ; -- föraktlighet..nn.1
  föralldel_1_Adv = mkAdv "föralldel" ; -- föralldel..ab.1
  förallmänliga_1_V = mkV "förallmänligar" ; -- förallmänliga..vb.1
  förallmänligande_1_N = mkN "förallmänligande" ; -- förallmänligande..nn.1
  förande_1_N = mkN "förande" ; -- förande..nn.1
  förandliga_1_V = mkV "förandligar" ; -- förandliga..vb.1
  förandligad_1_A = mkA "förandligad" ; -- förandligad..av.1
  förandligande_1_N = mkN "förandligande" ; -- förandligande..nn.1
  föraning_1_N = mkN "föraning" ; -- föraning..nn.1
  förankra_1_V = mkV "förankrar" ; -- förankra..vb.1
  förankrande_1_N = mkN "förankrande" ; -- förankrande..nn.1
  förankring_1_N = mkN "förankring" ; -- förankring..nn.1
  föranleda_1_V = mkV "föranleda" "föranledde" "föranlett" ; -- föranleda..vb.1
  föranledande_1_N = mkN "föranledande" ; -- föranledande..nn.1
  föranledning_1_N = mkN "föranledning" ; -- föranledning..nn.1
  föranlåta_1_V = mkV "föranlåta" "föranlät" "föranlåtit" ; -- föranlåta..vb.1
  föranlåten_1_A = mkA "föranlåten" ; -- föranlåten..av.1
  föranmäla_1_V = mkV "föranmäler" ; -- föranmäla..vb.1
  föranmälande_1_N = mkN "föranmälande" ; -- föranmälande..nn.1
  föranmälning_1_N = mkN "föranmälning" ; -- föranmälning..nn.1
  förannonsera_1_V = mkV "förannonserar" ; -- förannonsera..vb.1
  förannonserande_1_N = mkN "förannonserande" ; -- förannonserande..nn.1
  förannonserbar_1_A = mkA "förannonserbar" ; -- förannonserbar..av.1
  förannonserbarhet_1_N = mkN "förannonserbarhet" ; -- förannonserbarhet..nn.1
  förannonsering_1_N = mkN "förannonsering" ; -- förannonsering..nn.1
  föranstalta_1_V = mkV "föranstaltar" ; -- föranstalta..vb.1
  föranstaltande_1_N = mkN "föranstaltande" ; -- föranstaltande..nn.1
  föranstaltning_1_N = mkN "föranstaltning" ; -- föranstaltning..nn.1
  förarbeta_1_V = mkV "förarbetar" ; -- förarbeta..vb.1
  förarbetande_1_N = mkN "förarbetande" ; -- förarbetande..nn.1
  förarbete_1_N = mkN "förarbete" ; -- förarbete..nn.1
  förarbetning_1_N = mkN "förarbetning" ; -- förarbetning..nn.1
  förare_1_N = mkN "förare" utrum  ; -- förare..nn.1
  förarga_1_V = mkV "förargar" ; -- förarga..vb.1
  förargad_1_A = mkA "förargad" ; -- förargad..av.1
  förargande_1_N = mkN "förargande" ; -- förargande..nn.1
  förargelse_1_N = mkN "förargelse" utrum  ; -- förargelse..nn.1
  förargelseklippa_1_N = mkN "förargelseklippa" ; -- förargelseklippa..nn.1
  förargelseväckande_1_A = mkA "förargelseväckande" ; -- förargelseväckande..av.1
  förarglig_1_A = mkA "förarglig" ; -- förarglig..av.1
  förarglighet_1_N = mkN "förarglighet" "förargligheter" ; -- förarglighet..nn.1
  förarhytt_1_N = mkN "förarhytt" "förarhytter" ; -- förarhytt..nn.1
  förarkabin_1_N = mkN "förarkabin" "förarkabiner" ; -- förarkabin..nn.1
  förarlös_1_A = mkA "förarlös" ; -- förarlös..av.1
  förarplats_1_N = mkN "förarplats" "förarplatser" ; -- förarplats..nn.1
  förarruta_1_N = mkN "förarruta" ; -- förarruta..nn.1
  förarsits_1_N = mkN "förarsits" ; -- förarsits..nn.1
  förband_1_N = mkN "förband" neutrum  ; -- förband..nn.1
  förband_2_1_N = mkN "förband" neutrum  ; -- förband_2..nn.1
  förbandsartikel_1_N = mkN "förbandsartikel" ; -- förbandsartikel..nn.1
  förbandslåda_1_N = mkN "förbandslåda" ; -- förbandslåda..nn.1
  förbandsplats_1_N = mkN "förbandsplats" "förbandsplatser" ; -- förbandsplats..nn.1
  förbandsteknik_1_N = mkN "förbandsteknik" "förbandstekniker" ; -- förbandsteknik..nn.1
  förbanna_1_V = mkV "förbannar" ; -- förbanna..vb.1
  förbannad_1_A = mkA "förbannad" ; -- förbannad..av.1
  förbannande_1_N = mkN "förbannande" ; -- förbannande..nn.1
  förbannelse_1_N = mkN "förbannelse" "förbannelser" ; -- förbannelse..nn.1
  förbarmande_1_N = mkN "förbarmande" ; -- förbarmande..nn.1
  förbaskad_1_A = mkA "förbaskad" ; -- förbaskad..av.1
  förbehandling_1_N = mkN "förbehandling" ; -- förbehandling..nn.1
  förbehåll_1_N = mkN "förbehåll" neutrum  ; -- förbehåll..nn.1
  förbehålla_1_V = mkV "förbehålla" "förbehöll" "förbehållit" ; -- förbehålla..vb.1
  förbehållande_1_N = mkN "förbehållande" ; -- förbehållande..nn.1
  förbehållsam_1_A = mkA "förbehållsam" "förbehållsamt" "förbehållsamma" "förbehållsamma" "förbehållsammare" "förbehållsammast" "förbehållsammaste" ; -- förbehållsam..av.1
  förbehållsamhet_1_N = mkN "förbehållsamhet" "förbehållsamheter" ; -- förbehållsamhet..nn.1
  förbehållslös_1_A = mkA "förbehållslös" ; -- förbehållslös..av.1
  förbehållslöshet_1_N = mkN "förbehållslöshet" ; -- förbehållslöshet..nn.1
  förbemälde_1_A = mkA "förbemälde" ; -- förbemälde..av.1
  förbenad_1_A = mkA "förbenad" ; -- förbenad..av.1
  förbereda_1_V = mkV "förbereda" "förberedde" "förberett" ; -- förbereda..vb.1
  förberedande_1_A = mkA "förberedande" ; -- förberedande..av.1
  förberedande_1_N = mkN "förberedande" ; -- förberedande..nn.1
  förberedd_1_A = mkA "förberedd" ; -- förberedd..av.1
  förberedelse_1_N = mkN "förberedelse" "förberedelser" ; -- förberedelse..nn.1
  förberedelsearbete_1_N = mkN "förberedelsearbete" ; -- förberedelsearbete..nn.1
  förberedelsetid_1_N = mkN "förberedelsetid" "förberedelsetider" ; -- förberedelsetid..nn.1
  förberg_1_N = mkN "förberg" neutrum  ; -- förberg..nn.1
  förbeställa_1_V = mkV "förbeställer" ; -- förbeställa..vb.1
  förbeställande_1_N = mkN "förbeställande" ; -- förbeställande..nn.1
  förbeställning_1_N = mkN "förbeställning" ; -- förbeställning..nn.1
  förbi_1_A = mkA "förbi" ; -- förbi..av.1
  förbida_1_V = mkV "förbidar" ; -- förbida..vb.1
  förbidande_1_N = mkN "förbidande" ; -- förbidande..nn.1
  förbifart_1_N = mkN "förbifart" "förbifarter" ; -- förbifart..nn.1
  förbifartsled_1_N = mkN "förbifartsled" "förbifartsleder" ; -- förbifartsled..nn.1
  förbigå_1_V = mkV "förbigå" "förbigår" "förbigå" "förbigick" "förbigått" "förbigången" ; -- förbigå..vb.1
  förbigående_1_N = mkN "förbigående" ; -- förbigående..nn.1
  förbigången_1_A = mkA "förbigången" ; -- förbigången..av.1
  förbiilande_1_A = mkA "förbiilande" ; -- förbiilande..av.1
  förbilliga_1_V = mkV "förbilligar" ; -- förbilliga..vb.1
  förbilligande_1_N = mkN "förbilligande" ; -- förbilligande..nn.1
  förbinda_1_V = mkV "förbinda" "förband" "förbundit" ; -- förbinda..vb.1
  förbindande_1_N = mkN "förbindande" ; -- förbindande..nn.1
  förbindelse_1_N = mkN "förbindelse" "förbindelser" ; -- förbindelse..nn.1
  förbindelsearbete_1_N = mkN "förbindelsearbete" ; -- förbindelsearbete..nn.1
  förbindelsegrav_1_N = mkN "förbindelsegrav" ; -- förbindelsegrav..nn.1
  förbindelsegång_1_N = mkN "förbindelsegång" ; -- förbindelsegång..nn.1
  förbindelseled_1_N = mkN "förbindelseled" "förbindelseleder" ; -- förbindelseled..nn.1
  förbindelselinje_1_N = mkN "förbindelselinje" "förbindelselinjer" ; -- förbindelselinje..nn.1
  förbindelselänk_1_N = mkN "förbindelselänk" ; -- förbindelselänk..nn.1
  förbindelsemedel_1_N = mkN "förbindelsemedel" neutrum  ; -- förbindelsemedel..nn.1
  förbindelseofficer_1_N = mkN "förbindelseofficer" "förbindelseofficeren" "förbindelseofficerare" "förbindelseofficerarna" ; -- förbindelseofficer..nn.1
  förbindlig_1_A = mkA "förbindlig" ; -- förbindlig..av.1
  förbindlighet_1_N = mkN "förbindlighet" ; -- förbindlighet..nn.1
  förbindning_1_N = mkN "förbindning" ; -- förbindning..nn.1
  förbipasserande_1_A = mkA "förbipasserande" ; -- förbipasserande..av.1
  förbise_1_V = mkV "förbise" "förbisåg" "förbisett" ; -- förbise..vb.1
  förbisedd_1_A = mkA "förbisedd" ; -- förbisedd..av.1
  förbiseende_1_N = mkN "förbiseende" ; -- förbiseende..nn.1
  förbiskyndande_1_A = mkA "förbiskyndande" ; -- förbiskyndande..av.1
  förbistrad_1_A = mkA "förbistrad" ; -- förbistrad..av.1
  förbistring_1_N = mkN "förbistring" ; -- förbistring..nn.1
  förbisvepande_1_A = mkA "förbisvepande" ; -- förbisvepande..av.1
  förbisvischande_1_A = mkA "förbisvischande" ; -- förbisvischande..av.1
  förbittra_1_V = mkV "förbittrar" ; -- förbittra..vb.1
  förbittrad_1_A = mkA "förbittrad" ; -- förbittrad..av.1
  förbittrande_1_N = mkN "förbittrande" ; -- förbittrande..nn.1
  förbittring_1_N = mkN "förbittring" ; -- förbittring..nn.1
  förbjuda_1_V = mkV "förbjuda" "förbjöd" "förbjudit" ; -- förbjuda..vb.1
  förbjudande_1_N = mkN "förbjudande" ; -- förbjudande..nn.1
  förbjuden_1_A = mkA "förbjuden" ; -- förbjuden..av.1
  förbjudenhet_1_N = mkN "förbjudenhet" ; -- förbjudenhet..nn.1
  förblanda_1_V = mkV "förblandar" ; -- förblanda..vb.1
  förblandande_1_N = mkN "förblandande" ; -- förblandande..nn.1
  förblandning_1_N = mkN "förblandning" ; -- förblandning..nn.1
  förblekna_1_V = mkV "förbleknar" ; -- förblekna..vb.1
  förbleknande_1_N = mkN "förbleknande" ; -- förbleknande..nn.1
  förbli_1_V = mkV "förbliva" "förblev" "förblivit" ; -- förbli..vb.1
  förblinda_1_V = mkV "förblindar" ; -- förblinda..vb.1
  förblindande_1_N = mkN "förblindande" ; -- förblindande..nn.1
  förblivande_1_A = mkA "förblivande" ; -- förblivande..av.1
  förblivande_1_N = mkN "förblivande" ; -- förblivande..nn.1
  förblommerad_1_A = mkA "förblommerad" ; -- förblommerad..av.1
  förbluffa_1_V = mkV "förbluffar" ; -- förbluffa..vb.1
  förbluffad_1_A = mkA "förbluffad" ; -- förbluffad..av.1
  förbluffande_1_A = mkA "förbluffande" ; -- förbluffande..av.1
  förbluffande_1_N = mkN "förbluffande" ; -- förbluffande..nn.1
  förblöda_1_V = mkV "förblöda" "förblödde" "förblött" ; -- förblöda..vb.1
  förblödande_1_N = mkN "förblödande" ; -- förblödande..nn.1
  förblödning_1_N = mkN "förblödning" ; -- förblödning..nn.1
  förbommad_1_A = mkA "förbommad" ; -- förbommad..av.1
  förborga_1_V = mkV "förborgar" ; -- förborga..vb.1
  förborgande_1_N = mkN "förborgande" ; -- förborgande..nn.1
  förborgerliga_1_V = mkV "förborgerligar" ; -- förborgerliga..vb.1
  förborgerligande_1_N = mkN "förborgerligande" ; -- förborgerligande..nn.1
  förbrinna_1_V = mkV "förbrinna" "förbrann" "förbrunnit" ; -- förbrinna..vb.1
  förbrinnande_1_N = mkN "förbrinnande" ; -- förbrinnande..nn.1
  förbruka_1_V = mkV "förbrukar" ; -- förbruka..vb.1
  förbrukande_1_N = mkN "förbrukande" ; -- förbrukande..nn.1
  förbrukare_1_N = mkN "förbrukare" utrum  ; -- förbrukare..nn.1
  förbrukning_1_N = mkN "förbrukning" ; -- förbrukning..nn.1
  förbrukningsartikel_1_N = mkN "förbrukningsartikel" ; -- förbrukningsartikel..nn.1
  förbrukningsmaterial_1_N = mkN "förbrukningsmaterial" neutrum  ; -- förbrukningsmaterial..nn.1
  förbrylla_1_V = mkV "förbryllar" ; -- förbrylla..vb.1
  förbryllande_1_N = mkN "förbryllande" ; -- förbryllande..nn.1
  förbrytarband_1_N = mkN "förbrytarband" neutrum  ; -- förbrytarband..nn.1
  förbrytare_1_N = mkN "förbrytare" utrum  ; -- förbrytare..nn.1
  förbrytelse_1_N = mkN "förbrytelse" "förbrytelser" ; -- förbrytelse..nn.1
  förbränna_1_V = mkV "förbränna" "förbrände" "förbränt" ; -- förbränna..vb.1
  förbrännande_1_N = mkN "förbrännande" ; -- förbrännande..nn.1
  förbränning_1_N = mkN "förbränning" ; -- förbränning..nn.1
  förbränningsmotor_1_N = mkN "förbränningsmotor" "förbränningsmotorer" ; -- förbränningsmotor..nn.1
  förbränningsprodukt_1_N = mkN "förbränningsprodukt" "förbränningsprodukter" ; -- förbränningsprodukt..nn.1
  förbrödra_1_V = mkV "förbrödrar" ; -- förbrödra..vb.1
  förbrödrande_1_N = mkN "förbrödrande" ; -- förbrödrande..nn.1
  förbrödring_1_N = mkN "förbrödring" ; -- förbrödring..nn.1
  förbrödringsfest_1_N = mkN "förbrödringsfest" "förbrödringsfester" ; -- förbrödringsfest..nn.1
  förbud_1_N = mkN "förbud" neutrum  ; -- förbud..nn.1
  förbudslag_1_N = mkN "förbudslag" ; -- förbudslag..nn.1
  förbudslagstiftning_1_N = mkN "förbudslagstiftning" ; -- förbudslagstiftning..nn.1
  förbudslinje_1_N = mkN "förbudslinje" utrum  ; -- förbudslinje..nn.1
  förbund_1_N = mkN "förbund" neutrum  ; -- förbund..nn.1
  förbunden_1_A = mkA "förbunden" ; -- förbunden..av.1
  förbundenhet_1_N = mkN "förbundenhet" ; -- förbundenhet..nn.1
  förbundsark_1_N = mkN "förbundsark" ; -- förbundsark..nn.1
  förbundsbrev_1_N = mkN "förbundsbrev" neutrum  ; -- förbundsbrev..nn.1
  förbundsdag_1_N = mkN "förbundsdag" ; -- förbundsdag..nn.1
  förbundskansler_1_N = mkN "förbundskansler" ; -- förbundskansler..nn.1
  förbundskapten_1_N = mkN "förbundskapten" "förbundskaptener" ; -- förbundskapten..nn.1
  förbundspresident_1_N = mkN "förbundspresident" "förbundspresidenter" ; -- förbundspresident..nn.1
  förbundsregering_1_N = mkN "förbundsregering" ; -- förbundsregering..nn.1
  förbundsrepublik_1_N = mkN "förbundsrepublik" "förbundsrepubliker" ; -- förbundsrepublik..nn.1
  förbundsstat_1_N = mkN "förbundsstat" "förbundsstater" ; -- förbundsstat..nn.1
  förbundsstyrelse_1_N = mkN "förbundsstyrelse" "förbundsstyrelser" ; -- förbundsstyrelse..nn.1
  förbundsvis_1_Adv = mkAdv "förbundsvis" ; -- förbundsvis..ab.1
  förbundsvis_1_A = mkA "förbundsvis" ; -- förbundsvis..av.1
  förbuska_1_V = mkV "förbuskar" ; -- förbuska..vb.1
  förbuskande_1_N = mkN "förbuskande" ; -- förbuskande..nn.1
  förbygga_1_V = mkV "förbygger" ; -- förbygga..vb.1
  förbyggande_1_N = mkN "förbyggande" ; -- förbyggande..nn.1
  förbyggnad_1_N = mkN "förbyggnad" "förbyggnader" ; -- förbyggnad..nn.1
  förbyta_1_V = mkV "förbyter" ; -- förbyta..vb.1
  förbytande_1_N = mkN "förbytande" ; -- förbytande..nn.1
  förbytning_1_N = mkN "förbytning" ; -- förbytning..nn.1
  förbätterlig_1_A = mkA "förbätterlig" ; -- förbätterlig..av.1
  förbätterlighet_1_N = mkN "förbätterlighet" ; -- förbätterlighet..nn.1
  förbättra_1_V = mkV "förbättrar" ; -- förbättra..vb.1
  förbättrande_1_N = mkN "förbättrande" ; -- förbättrande..nn.1
  förbättring_1_N = mkN "förbättring" ; -- förbättring..nn.1
  förbättringsarbete_1_N = mkN "förbättringsarbete" ; -- förbättringsarbete..nn.1
  förbättringslån_1_N = mkN "förbättringslån" neutrum  ; -- förbättringslån..nn.1
  förbättringspotential_1_N = mkN "förbättringspotential" "förbättringspotentialer" ; -- förbättringspotential..nn.1
  förbön_1_N = mkN "förbön" "förböner" ; -- förbön..nn.1
  förcolumbiansk_1_A = mkA "förcolumbiansk" ; -- förcolumbiansk..av.1
  förcolumbisk_1_A = mkA "förcolumbisk" ; -- förcolumbisk..av.1
  fördel_1_N = mkN "fördel" "fördelen" "fördelar" "fördelarna" ; -- fördel..nn.1
  fördela_1_V = mkV "fördelar" ; -- fördela..vb.1
  fördelaktig_1_A = mkA "fördelaktig" ; -- fördelaktig..av.1
  fördelaktighet_1_N = mkN "fördelaktighet" ; -- fördelaktighet..nn.1
  fördelande_1_N = mkN "fördelande" ; -- fördelande..nn.1
  fördelare_1_N = mkN "fördelare" utrum  ; -- fördelare..nn.1
  fördelning_1_N = mkN "fördelning" ; -- fördelning..nn.1
  fördelningsmässig_1_A = mkA "fördelningsmässig" ; -- fördelningsmässig..av.1
  fördelningspolitik_1_N = mkN "fördelningspolitik" ; -- fördelningspolitik..nn.1
  fördelningspolitisk_1_A = mkA "fördelningspolitisk" ; -- fördelningspolitisk..av.1
  fördendelen_1_Adv = mkAdv "fördendelen" ; -- fördendelen..ab.1
  fördenskull_1_Adv = mkAdv "fördenskull" ; -- fördenskull..ab.1
  fördetta_1_A = mkA "fördetta" ; -- fördetta..av.1
  fördetting_1_N = mkN "fördetting" ; -- fördetting..nn.1
  fördevind_1_N = mkN "fördevind" ; -- fördevind..nn.1
  fördjupa_1_V = mkV "fördjupar" ; -- fördjupa..vb.1
  fördjupande_1_N = mkN "fördjupande" ; -- fördjupande..nn.1
  fördjupning_1_N = mkN "fördjupning" ; -- fördjupning..nn.1
  fördjupningskurs_1_N = mkN "fördjupningskurs" "fördjupningskurser" ; -- fördjupningskurs..nn.1
  fördjupningsreportage_1_N = mkN "fördjupningsreportage" "fördjupningsreportaget" "fördjupningsreportage" "fördjupningsreportagen" ; -- fördjupningsreportage..nn.1
  fördold_1_A = mkA "fördold" "fördolt" ; -- fördold..av.1
  fördoldhet_1_N = mkN "fördoldhet" ; -- fördoldhet..nn.1
  fördom_1_N = mkN "fördom" ; -- fördom..nn.1
  fördomsalstrande_1_A = mkA "fördomsalstrande" ; -- fördomsalstrande..av.1
  fördomsfri_1_A = mkA "fördomsfri" "fördomsfritt" ; -- fördomsfri..av.1
  fördomsfrihet_1_N = mkN "fördomsfrihet" ; -- fördomsfrihet..nn.1
  fördomsfull_1_A = mkA "fördomsfull" ; -- fördomsfull..av.1
  fördomsfullhet_1_N = mkN "fördomsfullhet" "fördomsfullheter" ; -- fördomsfullhet..nn.1
  fördra_1_V = mkV "fördraga" "fördrog" "fördragit" ; -- fördra..vb.1
  fördrag_1_N = mkN "fördrag" neutrum  ; -- fördrag..nn.1
  fördragande_1_N = mkN "fördragande" ; -- fördragande..nn.1
  fördragen_1_A = mkA "fördragen" ; -- fördragen..av.1
  fördragenhet_1_N = mkN "fördragenhet" ; -- fördragenhet..nn.1
  fördragsam_1_A = mkA "fördragsam" "fördragsamt" "fördragsamma" "fördragsamma" "fördragsammare" "fördragsammast" "fördragsammaste" ; -- fördragsam..av.1
  fördragsamhet_1_N = mkN "fördragsamhet" "fördragsamheter" ; -- fördragsamhet..nn.1
  fördragsbrott_1_N = mkN "fördragsbrott" neutrum  ; -- fördragsbrott..nn.1
  fördragsenlig_1_A = mkA "fördragsenlig" ; -- fördragsenlig..av.1
  fördragsmässig_1_A = mkA "fördragsmässig" ; -- fördragsmässig..av.1
  fördragsslutande_1_A = mkA "fördragsslutande" ; -- fördragsslutande..av.1
  fördragsvidrig_1_A = mkA "fördragsvidrig" ; -- fördragsvidrig..av.1
  fördriva_1_V = mkV "fördriva" "fördrev" "fördrivit" ; -- fördriva..vb.1
  fördrivande_1_N = mkN "fördrivande" ; -- fördrivande..nn.1
  fördrivning_1_N = mkN "fördrivning" ; -- fördrivning..nn.1
  fördröja_1_V = mkV "fördröja" "fördröjde" "fördröjt" ; -- fördröja..vb.1
  fördröjande_1_N = mkN "fördröjande" ; -- fördröjande..nn.1
  fördröjning_1_N = mkN "fördröjning" ; -- fördröjning..nn.1
  fördröjningsaktion_1_N = mkN "fördröjningsaktion" ; -- fördröjningsaktion..nn.1
  fördröjningstaktik_1_N = mkN "fördröjningstaktik" "fördröjningstaktiker" ; -- fördröjningstaktik..nn.1
  fördrömd_1_A = mkA "fördrömd" "fördrömt" ; -- fördrömd..av.1
  fördubbla_1_V = mkV "fördubblar" ; -- fördubbla..vb.1
  fördubblande_1_N = mkN "fördubblande" ; -- fördubblande..nn.1
  fördubbling_1_N = mkN "fördubbling" ; -- fördubbling..nn.1
  fördumma_1_V = mkV "fördummar" ; -- fördumma..vb.1
  fördummande_1_N = mkN "fördummande" ; -- fördummande..nn.1
  fördunkla_1_V = mkV "fördunklar" ; -- fördunkla..vb.1
  fördunklande_1_N = mkN "fördunklande" ; -- fördunklande..nn.1
  fördunkling_1_N = mkN "fördunkling" ; -- fördunkling..nn.1
  fördunsta_1_V = mkV "fördunstar" ; -- fördunsta..vb.1
  fördunstande_1_N = mkN "fördunstande" ; -- fördunstande..nn.1
  fördunstning_1_N = mkN "fördunstning" ; -- fördunstning..nn.1
  fördyra_1_V = mkV "fördyrar" ; -- fördyra..vb.1
  fördyrande_1_N = mkN "fördyrande" ; -- fördyrande..nn.1
  fördyring_1_N = mkN "fördyring" ; -- fördyring..nn.1
  fördystra_1_V = mkV "fördystrar" ; -- fördystra..vb.1
  fördystrande_1_N = mkN "fördystrande" ; -- fördystrande..nn.1
  fördäck_1_N = mkN "fördäck" neutrum  ; -- fördäck..nn.1
  fördämma_1_V = mkV "fördämmer" ; -- fördämma..vb.1
  fördämmande_1_N = mkN "fördämmande" ; -- fördämmande..nn.1
  fördämning_1_N = mkN "fördämning" ; -- fördämning..nn.1
  fördärv_1_N = mkN "fördärv" neutrum  ; -- fördärv..nn.1
  fördärva_1_V = mkV "fördärvar" ; -- fördärva..vb.1
  fördärvande_1_N = mkN "fördärvande" ; -- fördärvande..nn.1
  fördärvare_1_N = mkN "fördärvare" utrum  ; -- fördärvare..nn.1
  fördärvbringande_1_A = mkA "fördärvbringande" ; -- fördärvbringande..av.1
  fördärvlig_1_A = mkA "fördärvlig" ; -- fördärvlig..av.1
  fördärvlighet_1_N = mkN "fördärvlighet" ; -- fördärvlighet..nn.1
  fördölja_1_V = mkV "fördölja" "fördolde" "fördolt" ; -- fördölja..vb.1
  fördöljande_1_N = mkN "fördöljande" ; -- fördöljande..nn.1
  fördöma_1_V = mkV "fördömer" ; -- fördöma..vb.1
  fördömande_1_N = mkN "fördömande" ; -- fördömande..nn.1
  fördömd_1_A = mkA "fördömd" "fördömt" ; -- fördömd..av.1
  fördömdhet_1_N = mkN "fördömdhet" ; -- fördömdhet..nn.1
  fördömelse_1_N = mkN "fördömelse" utrum  ; -- fördömelse..nn.1
  fördömlig_1_A = mkA "fördömlig" ; -- fördömlig..av.1
  fördömlighet_1_N = mkN "fördömlighet" ; -- fördömlighet..nn.1
  före_1_N = mkN "före" ; -- före..nn.1
  förebild_1_N = mkN "förebild" "förebilder" ; -- förebild..nn.1
  förebildlig_1_A = mkA "förebildlig" ; -- förebildlig..av.1
  förebildlighet_1_N = mkN "förebildlighet" ; -- förebildlighet..nn.1
  förebrå_1_V = mkV "förebrår" ; -- förebrå..vb.1
  förebråelse_1_N = mkN "förebråelse" "förebråelser" ; -- förebråelse..nn.1
  förebrående_1_N = mkN "förebrående" ; -- förebrående..nn.1
  förebud_1_N = mkN "förebud" neutrum  ; -- förebud..nn.1
  förebygga_1_V = mkV "förebygger" ; -- förebygga..vb.1
  förebyggande_1_N = mkN "förebyggande" ; -- förebyggande..nn.1
  förebära_1_V = mkV "förebära" "förebar" "föreburit" ; -- förebära..vb.1
  förebärande_1_N = mkN "förebärande" ; -- förebärande..nn.1
  förebåda_1_V = mkV "förebådar" ; -- förebåda..vb.1
  förebådande_1_N = mkN "förebådande" ; -- förebådande..nn.1
  förebådare_1_N = mkN "förebådare" utrum  ; -- förebådare..nn.1
  föredra_1_V = mkV "föredraga" "föredrog" "föredragit" ; -- föredra..vb.1
  föredrag_1_N = mkN "föredrag" neutrum  ; -- föredrag..nn.1
  föredragande_1_N = mkN "föredragande" "föredraganden" "föredraganden" "föredragandena" ; -- föredragande..nn.1
  föredragande_2_N = mkN "föredragande" ; -- föredragande..nn.2
  föredragning_1_N = mkN "föredragning" ; -- föredragning..nn.1
  föredragningslista_1_N = mkN "föredragningslista" ; -- föredragningslista..nn.1
  föredragshållare_1_N = mkN "föredragshållare" utrum  ; -- föredragshållare..nn.1
  föredöme_1_N = mkN "föredöme" ; -- föredöme..nn.1
  föredömlig_1_A = mkA "föredömlig" ; -- föredömlig..av.1
  föredömlighet_1_N = mkN "föredömlighet" ; -- föredömlighet..nn.1
  förefalla_1_V = mkV "förefalla" "föreföll" "förefallit" ; -- förefalla..vb.1
  förefallande_1_N = mkN "förefallande" ; -- förefallande..nn.1
  förefintlig_1_A = mkA "förefintlig" ; -- förefintlig..av.1
  förefintlighet_1_N = mkN "förefintlighet" ; -- förefintlighet..nn.1
  förege_1_V = mkV "föregiva" "föregav" "föregivit" ; -- förege..vb.1
  föregivande_1_N = mkN "föregivande" ; -- föregivande..nn.1
  föregiven_1_A = mkA "föregiven" ; -- föregiven..av.1
  föregripa_1_V = mkV "föregripa" "föregrep" "föregripit" ; -- föregripa..vb.1
  föregripande_1_N = mkN "föregripande" ; -- föregripande..nn.1
  föregå_1_V = mkV "föregå" "föregår" "föregå" "föregick" "föregått" "föregången" ; -- föregå..vb.1
  föregående_1_A = mkA "föregående" ; -- föregående..av.1
  föregående_1_N = mkN "föregående" ; -- föregående..nn.1
  föregående_2_N = mkN "föregående" ; -- föregående..nn.2
  föregångare_1_N = mkN "föregångare" utrum  ; -- föregångare..nn.1
  föregångsexempel_1_N = mkN "föregångsexempel" neutrum  ; -- föregångsexempel..nn.1
  föregångsman_1_N = mkN "föregångsman" "föregångsmannen" "föregångsmän" "föregångsmännen" ; -- föregångsman..nn.1
  förehavande_1_N = mkN "förehavande" ; -- förehavande..nn.1
  förehålla_1_V = mkV "förehålla" "förehöll" "förehållit" ; -- förehålla..vb.1
  förehållande_1_N = mkN "förehållande" ; -- förehållande..nn.1
  förekomma_1_V = mkV "förekomma" "förekom" "förekommit" ; -- förekomma..vb.1
  förekommande_1_A = mkA "förekommande" ; -- förekommande..av.1
  förekommande_1_N = mkN "förekommande" ; -- förekommande..nn.1
  förekomst_1_N = mkN "förekomst" "förekomster" ; -- förekomst..nn.1
  föreligga_1_V = mkV "föreligga" "förelåg" "förelegat" ; -- föreligga..vb.1
  föreliggande_1_N = mkN "föreliggande" ; -- föreliggande..nn.1
  förelägga_1_V = mkV "förelägga" "förela" "förelagt" ; -- förelägga..vb.1
  föreläggande_1_N = mkN "föreläggande" ; -- föreläggande..nn.1
  föreläsa_1_V = mkV "föreläser" ; -- föreläsa..vb.1
  föreläsande_1_N = mkN "föreläsande" ; -- föreläsande..nn.1
  föreläsare_1_N = mkN "föreläsare" utrum  ; -- föreläsare..nn.1
  föreläsning_1_N = mkN "föreläsning" ; -- föreläsning..nn.1
  föreläsningssal_1_N = mkN "föreläsningssal" ; -- föreläsningssal..nn.1
  förelöpare_1_N = mkN "förelöpare" utrum  ; -- förelöpare..nn.1
  föremål_1_N = mkN "föremål" neutrum  ; -- föremål..nn.1
  förena_1_V = mkV "förenar" ; -- förena..vb.1
  förenande_1_N = mkN "förenande" ; -- förenande..nn.1
  förening_1_N = mkN "förening" ; -- förening..nn.1
  föreningsband_1_N = mkN "föreningsband" neutrum  ; -- föreningsband..nn.1
  föreningsbank_1_N = mkN "föreningsbank" "föreningsbanker" ; -- föreningsbank..nn.1
  föreningsfrihet_1_N = mkN "föreningsfrihet" "föreningsfriheter" ; -- föreningsfrihet..nn.1
  föreningsliv_1_N = mkN "föreningsliv" neutrum  ; -- föreningsliv..nn.1
  föreningslokal_1_N = mkN "föreningslokal" "föreningslokaler" ; -- föreningslokal..nn.1
  föreningslänk_1_N = mkN "föreningslänk" ; -- föreningslänk..nn.1
  föreningsmängd_1_N = mkN "föreningsmängd" "föreningsmängder" ; -- föreningsmängd..nn.1
  föreningsmässig_1_A = mkA "föreningsmässig" ; -- föreningsmässig..av.1
  föreningspunkt_1_N = mkN "föreningspunkt" "föreningspunkter" ; -- föreningspunkt..nn.1
  föreningsrätt_1_N = mkN "föreningsrätt" ; -- föreningsrätt..nn.1
  föreningsrörelse_1_N = mkN "föreningsrörelse" "föreningsrörelser" ; -- föreningsrörelse..nn.1
  föreningsväsen_1_N = mkN "föreningsväsen" neutrum  ; -- föreningsväsen..nn.1
  förenkla_1_V = mkV "förenklar" ; -- förenkla..vb.1
  förenklande_1_N = mkN "förenklande" ; -- förenklande..nn.1
  förenkling_1_N = mkN "förenkling" ; -- förenkling..nn.1
  förenlig_1_A = mkA "förenlig" ; -- förenlig..av.1
  förenlighet_1_N = mkN "förenlighet" "förenligheter" ; -- förenlighet..nn.1
  föresats_1_N = mkN "föresats" "föresatser" ; -- föresats..nn.1
  föreskrift_1_N = mkN "föreskrift" "föreskrifter" ; -- föreskrift..nn.1
  föreskriftsenlig_1_A = mkA "föreskriftsenlig" ; -- föreskriftsenlig..av.1
  föreskriftsmässig_1_A = mkA "föreskriftsmässig" ; -- föreskriftsmässig..av.1
  föreskriva_1_V = mkV "föreskriva" "föreskrev" "föreskrivit" ; -- föreskriva..vb.1
  föreskrivande_1_N = mkN "föreskrivande" ; -- föreskrivande..nn.1
  föreslå_1_V = mkV "föreslå" "föreslog" "föreslagit" ; -- föreslå..vb.1
  föreslående_1_N = mkN "föreslående" ; -- föreslående..nn.1
  förespegla_1_V = mkV "förespeglar" ; -- förespegla..vb.1
  förespeglande_1_N = mkN "förespeglande" ; -- förespeglande..nn.1
  förespegling_1_N = mkN "förespegling" ; -- förespegling..nn.1
  förespråka_1_V = mkV "förespråkar" ; -- förespråka..vb.1
  förespråkande_1_N = mkN "förespråkande" ; -- förespråkande..nn.1
  förespråkare_1_N = mkN "förespråkare" utrum  ; -- förespråkare..nn.1
  förespå_1_V = mkV "förespår" ; -- förespå..vb.1
  förespående_1_N = mkN "förespående" ; -- förespående..nn.1
  förestava_1_V = mkV "förestavar" ; -- förestava..vb.1
  förestavande_1_N = mkN "förestavande" ; -- förestavande..nn.1
  förestavning_1_N = mkN "förestavning" ; -- förestavning..nn.1
  föreställa_1_V = mkV "föreställer" ; -- föreställa..vb.1
  föreställande_1_A = mkA "föreställande" ; -- föreställande..av.1
  föreställande_1_N = mkN "föreställande" ; -- föreställande..nn.1
  föreställare_1_N = mkN "föreställare" utrum  ; -- föreställare..nn.1
  föreställning_1_N = mkN "föreställning" ; -- föreställning..nn.1
  föreställningsförmåga_1_N = mkN "föreställningsförmåga" ; -- föreställningsförmåga..nn.1
  föreställningskategori_1_N = mkN "föreställningskategori" "föreställningskategorier" ; -- föreställningskategori..nn.1
  föreställningsrepertoar_1_N = mkN "föreställningsrepertoar" "föreställningsrepertoarer" ; -- föreställningsrepertoar..nn.1
  föreställningssätt_1_N = mkN "föreställningssätt" neutrum  ; -- föreställningssätt..nn.1
  föreställningsvärld_1_N = mkN "föreställningsvärld" ; -- föreställningsvärld..nn.1
  förestå_1_V = mkV "förestå" "förestod" "förestått" ; -- förestå..vb.1
  förestående_1_A = mkA "förestående" ; -- förestående..av.1
  förestående_1_N = mkN "förestående" ; -- förestående..nn.1
  föreståndare_1_N = mkN "föreståndare" utrum  ; -- föreståndare..nn.1
  föreståndarinna_1_N = mkN "föreståndarinna" ; -- föreståndarinna..nn.1
  föresväva_1_V = mkV "föresvävar" ; -- föresväva..vb.1
  föresvävande_1_N = mkN "föresvävande" ; -- föresvävande..nn.1
  företa_1_V = mkV "företaga" "företog" "företagit" ; -- företa..vb.1
  företag_1_N = mkN "företag" neutrum  ; -- företag..nn.1
  företagande_1_N = mkN "företagande" ; -- företagande..nn.1
  företagaranda_1_N = mkN "företagaranda" ; -- företagaranda..nn.1
  företagare_1_N = mkN "företagare" utrum  ; -- företagare..nn.1
  företagsam_1_A = mkA "företagsam" "företagsamt" "företagsamma" "företagsamma" "företagsammare" "företagsammast" "företagsammaste" ; -- företagsam..av.1
  företagsamhet_1_N = mkN "företagsamhet" "företagsamheter" ; -- företagsamhet..nn.1
  företagsbot_1_N = mkN "företagsbot" ; -- företagsbot..nn.1
  företagschef_1_N = mkN "företagschef" "företagschefer" ; -- företagschef..nn.1
  företagsdemokrati_1_N = mkN "företagsdemokrati" ; -- företagsdemokrati..nn.1
  företagsekonom_1_N = mkN "företagsekonom" "företagsekonomer" ; -- företagsekonom..nn.1
  företagsekonomi_1_N = mkN "företagsekonomi" ; -- företagsekonomi..nn.1
  företagsekonomisk_1_A = mkA "företagsekonomisk" ; -- företagsekonomisk..av.1
  företagsfiasko_1_N = mkN "företagsfiasko" "företagsfiaskot" "företagsfiaskon" "företagsfiaskona" ; -- företagsfiasko..nn.1
  företagsfilial_1_N = mkN "företagsfilial" "företagsfilialer" ; -- företagsfilial..nn.1
  företagsgrupp_1_N = mkN "företagsgrupp" "företagsgrupper" ; -- företagsgrupp..nn.1
  företagshälsovård_1_N = mkN "företagshälsovård" ; -- företagshälsovård..nn.1
  företagsledare_1_N = mkN "företagsledare" utrum  ; -- företagsledare..nn.1
  företagsledning_1_N = mkN "företagsledning" ; -- företagsledning..nn.1
  företagsmässig_1_A = mkA "företagsmässig" ; -- företagsmässig..av.1
  företagsnämnd_1_N = mkN "företagsnämnd" "företagsnämnder" ; -- företagsnämnd..nn.1
  företagsstyrelse_1_N = mkN "företagsstyrelse" "företagsstyrelser" ; -- företagsstyrelse..nn.1
  företagstät_1_A = mkA "företagstät" ; -- företagstät..av.1
  företagstäthet_1_N = mkN "företagstäthet" ; -- företagstäthet..nn.1
  företagsvinst_1_N = mkN "företagsvinst" "företagsvinster" ; -- företagsvinst..nn.1
  företagsvärld_1_N = mkN "företagsvärld" ; -- företagsvärld..nn.1
  företal_1_N = mkN "företal" neutrum  ; -- företal..nn.1
  förete_1_V = mkV "förete" "företedde" "företett" ; -- förete..vb.1
  företeelse_1_N = mkN "företeelse" "företeelser" ; -- företeelse..nn.1
  företeende_1_N = mkN "företeende" ; -- företeende..nn.1
  företräda_1_V = mkV "företräda" "företrädde" "företrätt" ; -- företräda..vb.1
  företrädande_1_N = mkN "företrädande" ; -- företrädande..nn.1
  företrädare_1_N = mkN "företrädare" utrum  ; -- företrädare..nn.1
  företräde_1_N = mkN "företräde" ; -- företräde..nn.1
  företrädesrätt_1_N = mkN "företrädesrätt" ; -- företrädesrätt..nn.1
  företrädesvis_1_Adv = mkAdv "företrädesvis" ; -- företrädesvis..ab.1
  förevara_1_V = mkV "förevara" "förevar" "förevarit" ; -- förevara..vb.1
  förevarande_1_A = mkA "förevarande" ; -- förevarande..av.1
  förevarande_1_N = mkN "förevarande" ; -- förevarande..nn.1
  föreviga_1_V = mkV "förevigar" ; -- föreviga..vb.1
  förevigande_1_N = mkN "förevigande" ; -- förevigande..nn.1
  förevisa_1_V = mkV "förevisar" ; -- förevisa..vb.1
  förevisande_1_N = mkN "förevisande" ; -- förevisande..nn.1
  förevisare_1_N = mkN "förevisare" utrum  ; -- förevisare..nn.1
  förevisning_1_N = mkN "förevisning" ; -- förevisning..nn.1
  förevita_1_V = mkV "förevitar" ; -- förevita..vb.1
  förevitande_1_N = mkN "förevitande" ; -- förevitande..nn.1
  förevändning_1_N = mkN "förevändning" ; -- förevändning..nn.1
  förfader_1_N = mkN "förfader" "förfadern" "förfäder" "förfäderna" ; -- förfader..nn.1
  förfall_1_N = mkN "förfall" neutrum  ; -- förfall..nn.1
  förfalla_1_V = mkV "förfalla" "förföll" "förfallit" ; -- förfalla..vb.1
  förfallande_1_N = mkN "förfallande" ; -- förfallande..nn.1
  förfallen_1_A = mkA "förfallen" ; -- förfallen..av.1
  förfallenhet_1_N = mkN "förfallenhet" ; -- förfallenhet..nn.1
  förfallodag_1_N = mkN "förfallodag" ; -- förfallodag..nn.1
  förfallotid_1_N = mkN "förfallotid" "förfallotider" ; -- förfallotid..nn.1
  förfallsperiod_1_N = mkN "förfallsperiod" "förfallsperioder" ; -- förfallsperiod..nn.1
  förfalska_1_V = mkV "förfalskar" ; -- förfalska..vb.1
  förfalskande_1_N = mkN "förfalskande" ; -- förfalskande..nn.1
  förfalskare_1_N = mkN "förfalskare" utrum  ; -- förfalskare..nn.1
  förfalskning_1_N = mkN "förfalskning" ; -- förfalskning..nn.1
  förfalskningsbrott_1_N = mkN "förfalskningsbrott" neutrum  ; -- förfalskningsbrott..nn.1
  förfara_1_V = mkV "förfara" "förfor" "förfarit" ; -- förfara..vb.1
  förfarande_1_N = mkN "förfarande" ; -- förfarande..nn.1
  förfaren_1_A = mkA "förfaren" ; -- förfaren..av.1
  förfarenhet_1_N = mkN "förfarenhet" ; -- förfarenhet..nn.1
  förfaringssätt_1_N = mkN "förfaringssätt" neutrum  ; -- förfaringssätt..nn.1
  författa_1_V = mkV "författar" ; -- författa..vb.1
  författande_1_N = mkN "författande" ; -- författande..nn.1
  författardröm_1_N = mkN "författardröm" "författardrömmen" "författardrömmar" "författardrömmarna" ; -- författardröm..nn.1
  författare_1_N = mkN "författare" utrum  ; -- författare..nn.1
  författargärning_1_N = mkN "författargärning" ; -- författargärning..nn.1
  författarinna_1_N = mkN "författarinna" ; -- författarinna..nn.1
  författarjag_1_N = mkN "författarjag" neutrum  ; -- författarjag..nn.1
  författarporträtt_1_N = mkN "författarporträtt" neutrum  ; -- författarporträtt..nn.1
  författarsignatur_1_N = mkN "författarsignatur" "författarsignaturer" ; -- författarsignatur..nn.1
  författarskap_1_N = mkN "författarskap" neutrum  ; -- författarskap..nn.1
  författarskildring_1_N = mkN "författarskildring" ; -- författarskildring..nn.1
  författarvän_1_N = mkN "författarvän" "författarvännen" "författarvänner" "författarvännerna" ; -- författarvän..nn.1
  författaryrke_1_N = mkN "författaryrke" ; -- författaryrke..nn.1
  författning_1_N = mkN "författning" ; -- författning..nn.1
  författningsdomstol_1_N = mkN "författningsdomstol" ; -- författningsdomstol..nn.1
  författningsenlig_1_A = mkA "författningsenlig" ; -- författningsenlig..av.1
  författningsenlighet_1_N = mkN "författningsenlighet" "författningsenligheter" ; -- författningsenlighet..nn.1
  författningsmässig_1_A = mkA "författningsmässig" ; -- författningsmässig..av.1
  författningsmässighet_1_N = mkN "författningsmässighet" "författningsmässigheter" ; -- författningsmässighet..nn.1
  författningsstridig_1_A = mkA "författningsstridig" ; -- författningsstridig..av.1
  författningsstridighet_1_N = mkN "författningsstridighet" "författningsstridigheter" ; -- författningsstridighet..nn.1
  författningsvidrig_1_A = mkA "författningsvidrig" ; -- författningsvidrig..av.1
  förfela_1_V = mkV "förfelar" ; -- förfela..vb.1
  förfelande_1_N = mkN "förfelande" ; -- förfelande..nn.1
  förfest_1_N = mkN "förfest" "förfester" ; -- förfest..nn.1
  förfesta_1_V = mkV "förfestar" ; -- förfesta..vb.1
  förfestande_1_N = mkN "förfestande" ; -- förfestande..nn.1
  förfina_1_V = mkV "förfinar" ; -- förfina..vb.1
  förfinad_1_A = mkA "förfinad" ; -- förfinad..av.1
  förfinande_1_N = mkN "förfinande" ; -- förfinande..nn.1
  förfining_1_N = mkN "förfining" ; -- förfining..nn.1
  förflacka_1_V = mkV "förflackar" ; -- förflacka..vb.1
  förflackande_1_N = mkN "förflackande" ; -- förflackande..nn.1
  förflackning_1_N = mkN "förflackning" ; -- förflackning..nn.1
  förflugen_1_A = mkA "förflugen" ; -- förflugen..av.1
  förflugenhet_1_N = mkN "förflugenhet" ; -- förflugenhet..nn.1
  förfluten_1_A = mkA "förfluten" ; -- förfluten..av.1
  förflyta_1_V = mkV "förflyta" "förflöt" "förflutit" ; -- förflyta..vb.1
  förflytande_1_N = mkN "förflytande" ; -- förflytande..nn.1
  förflytta_1_V = mkV "förflyttar" ; -- förflytta..vb.1
  förflyttande_1_N = mkN "förflyttande" ; -- förflyttande..nn.1
  förflyttning_1_N = mkN "förflyttning" ; -- förflyttning..nn.1
  förfoga_1_V = mkV "förfogar" ; -- förfoga..vb.1
  förfogande_1_N = mkN "förfogande" ; -- förfogande..nn.1
  förfogandelag_1_N = mkN "förfogandelag" ; -- förfogandelag..nn.1
  förfoganderätt_1_N = mkN "förfoganderätt" ; -- förfoganderätt..nn.1
  förfranska_1_V = mkV "förfranskar" ; -- förfranska..vb.1
  förfranskande_1_N = mkN "förfranskande" ; -- förfranskande..nn.1
  förfriskning_1_N = mkN "förfriskning" ; -- förfriskning..nn.1
  förfrusen_1_A = mkA "förfrusen" ; -- förfrusen..av.1
  förfrysande_1_N = mkN "förfrysande" ; -- förfrysande..nn.1
  förfrysning_1_N = mkN "förfrysning" ; -- förfrysning..nn.1
  förfrämliga_1_V = mkV "förfrämligar" ; -- förfrämliga..vb.1
  förfrämligande_1_N = mkN "förfrämligande" ; -- förfrämligande..nn.1
  förfrågning_1_N = mkN "förfrågning" ; -- förfrågning..nn.1
  förfula_1_V = mkV "förfular" ; -- förfula..vb.1
  förfulande_1_N = mkN "förfulande" ; -- förfulande..nn.1
  förfulning_1_N = mkN "förfulning" ; -- förfulning..nn.1
  förfuska_1_V = mkV "förfuskar" ; -- förfuska..vb.1
  förfuskande_1_N = mkN "förfuskande" ; -- förfuskande..nn.1
  förfuskning_1_N = mkN "förfuskning" ; -- förfuskning..nn.1
  förfäa_1_V = mkV "förfäar" ; -- förfäa..vb.1
  förfäande_1_N = mkN "förfäande" ; -- förfäande..nn.1
  förfäkta_1_V = mkV "förfäktar" ; -- förfäkta..vb.1
  förfäktande_1_N = mkN "förfäktande" ; -- förfäktande..nn.1
  förfäktare_1_N = mkN "förfäktare" utrum  ; -- förfäktare..nn.1
  förfära_1_V = mkV "förfärar" ; -- förfära..vb.1
  förfärande_1_N = mkN "förfärande" ; -- förfärande..nn.1
  förfärdiga_1_V = mkV "förfärdigar" ; -- förfärdiga..vb.1
  förfärdigande_1_N = mkN "förfärdigande" ; -- förfärdigande..nn.1
  förfärdigare_1_N = mkN "förfärdigare" utrum  ; -- förfärdigare..nn.1
  förfärlig_1_A = mkA "förfärlig" ; -- förfärlig..av.1
  förfärlighet_1_N = mkN "förfärlighet" "förfärligheter" ; -- förfärlighet..nn.1
  förfärligt_1_Adv = mkAdv "förfärligt" ; -- förfärligt..ab.1
  förfånga_1_V = mkV "förfångar" ; -- förfånga..vb.1
  förfångande_1_N = mkN "förfångande" ; -- förfångande..nn.1
  förfölja_1_V = mkV "förfölja" "förföljde" "förföljt" ; -- förfölja..vb.1
  förföljande_1_N = mkN "förföljande" ; -- förföljande..nn.1
  förföljare_1_N = mkN "förföljare" utrum  ; -- förföljare..nn.1
  förföljelse_1_N = mkN "förföljelse" "förföljelser" ; -- förföljelse..nn.1
  förföljelsemani_1_N = mkN "förföljelsemani" "förföljelsemanier" ; -- förföljelsemani..nn.1
  förföra_1_V = mkV "förföra" "förförde" "förfört" ; -- förföra..vb.1
  förförande_1_N = mkN "förförande" ; -- förförande..nn.1
  förförare_1_N = mkN "förförare" utrum  ; -- förförare..nn.1
  förfördela_1_V = mkV "förfördelar" ; -- förfördela..vb.1
  förfördelande_1_N = mkN "förfördelande" ; -- förfördelande..nn.1
  förförelse_1_N = mkN "förförelse" "förförelser" ; -- förförelse..nn.1
  förförelsekonst_1_N = mkN "förförelsekonst" "förförelsekonster" ; -- förförelsekonst..nn.1
  förförerska_1_N = mkN "förförerska" ; -- förförerska..nn.1
  förförisk_1_A = mkA "förförisk" ; -- förförisk..av.1
  förföriskhet_1_N = mkN "förföriskhet" ; -- förföriskhet..nn.1
  förförståelse_1_N = mkN "förförståelse" utrum  ; -- förförståelse..nn.1
  förgasa_1_V = mkV "förgasar" ; -- förgasa..vb.1
  förgasande_1_N = mkN "förgasande" ; -- förgasande..nn.1
  förgasare_1_N = mkN "förgasare" utrum  ; -- förgasare..nn.1
  förgasning_1_N = mkN "förgasning" ; -- förgasning..nn.1
  förgifta_1_V = mkV "förgiftar" ; -- förgifta..vb.1
  förgiftande_1_N = mkN "förgiftande" ; -- förgiftande..nn.1
  förgiftning_1_N = mkN "förgiftning" ; -- förgiftning..nn.1
  förgjord_1_A = mkA "förgjord" "förgjort" ; -- förgjord..av.1
  förglasa_1_V = mkV "förglasar" ; -- förglasa..vb.1
  förglasande_1_N = mkN "förglasande" ; -- förglasande..nn.1
  förglasning_1_N = mkN "förglasning" ; -- förglasning..nn.1
  förglömma_1_V = mkV "förglömmer" ; -- förglömma..vb.1
  förglömmande_1_N = mkN "förglömmande" ; -- förglömmande..nn.1
  förgrenad_1_A = mkA "förgrenad" ; -- förgrenad..av.1
  förgrening_1_N = mkN "förgrening" ; -- förgrening..nn.1
  förgripelse_1_N = mkN "förgripelse" "förgripelser" ; -- förgripelse..nn.1
  förgriplig_1_A = mkA "förgriplig" ; -- förgriplig..av.1
  förgriplighet_1_N = mkN "förgriplighet" "förgripligheter" ; -- förgriplighet..nn.1
  förgroning_1_N = mkN "förgroning" ; -- förgroning..nn.1
  förgrova_1_V = mkV "förgrovar" ; -- förgrova..vb.1
  förgrovande_1_N = mkN "förgrovande" ; -- förgrovande..nn.1
  förgrund_1_N = mkN "förgrund" "förgrunder" ; -- förgrund..nn.1
  förgrundsfigur_1_N = mkN "förgrundsfigur" "förgrundsfigurer" ; -- förgrundsfigur..nn.1
  förgrundsgestalt_1_N = mkN "förgrundsgestalt" "förgrundsgestalter" ; -- förgrundsgestalt..nn.1
  förgrymma_1_V = mkV "förgrymmar" ; -- förgrymma..vb.1
  förgrymmad_1_A = mkA "förgrymmad" ; -- förgrymmad..av.1
  förgrymmande_1_N = mkN "förgrymmande" ; -- förgrymmande..nn.1
  förgrädda_1_V = mkV "förgräddar" ; -- förgrädda..vb.1
  förgräddande_1_N = mkN "förgräddande" ; -- förgräddande..nn.1
  förgräddning_1_N = mkN "förgräddning" ; -- förgräddning..nn.1
  förgrämd_1_A = mkA "förgrämd" "förgrämt" ; -- förgrämd..av.1
  förgrämdhet_1_N = mkN "förgrämdhet" ; -- förgrämdhet..nn.1
  förgrämelse_1_N = mkN "förgrämelse" "förgrämelser" ; -- förgrämelse..nn.1
  förgråten_1_A = mkA "förgråten" ; -- förgråten..av.1
  förgråtenhet_1_N = mkN "förgråtenhet" ; -- förgråtenhet..nn.1
  förgubbning_1_N = mkN "förgubbning" ; -- förgubbning..nn.1
  förgudning_1_N = mkN "förgudning" ; -- förgudning..nn.1
  förgylla_1_V = mkV "förgyller" ; -- förgylla..vb.1
  förgyllande_1_N = mkN "förgyllande" ; -- förgyllande..nn.1
  förgyllare_1_N = mkN "förgyllare" utrum  ; -- förgyllare..nn.1
  förgyllning_1_N = mkN "förgyllning" ; -- förgyllning..nn.1
  förgängelse_1_N = mkN "förgängelse" utrum  ; -- förgängelse..nn.1
  förgänglig_1_A = mkA "förgänglig" ; -- förgänglig..av.1
  förgänglighet_1_N = mkN "förgänglighet" "förgängligheter" ; -- förgänglighet..nn.1
  förgäta_1_V = mkV "förgäta" "förgat" "förgätit" ; -- förgäta..vb.1
  förgätande_1_N = mkN "förgätande" ; -- förgätande..nn.1
  förgäten_1_A = mkA "förgäten" ; -- förgäten..av.1
  förgätmigej_1_N = mkN "förgätmigej" "förgätmigejen" "förgätmigej" "förgätmigejen" ; -- förgätmigej..nn.1
  förgäves_1_Adv = mkAdv "förgäves" ; -- förgäves..ab.1
  förgå_1_V = mkV "förgå" "förgår" "förgå" "förgick" "förgått" "förgången" ; -- förgå..vb.1
  förgående_1_N = mkN "förgående" ; -- förgående..nn.1
  förgången_1_A = mkA "förgången" ; -- förgången..av.1
  förgård_1_N = mkN "förgård" ; -- förgård..nn.1
  förgöra_1_V = mkV "förgöra" "förgjorde" "förgjort" ; -- förgöra..vb.1
  förgörande_1_N = mkN "förgörande" ; -- förgörande..nn.1
  förgörning_1_N = mkN "förgörning" ; -- förgörning..nn.1
  förhala_1_V = mkV "förhalar" ; -- förhala..vb.1
  förhalande_1_N = mkN "förhalande" ; -- förhalande..nn.1
  förhall_1_N = mkN "förhall" ; -- förhall..nn.1
  förhalning_1_N = mkN "förhalning" ; -- förhalning..nn.1
  förhalningsförsök_1_N = mkN "förhalningsförsök" neutrum  ; -- förhalningsförsök..nn.1
  förhalningstaktik_1_N = mkN "förhalningstaktik" "förhalningstaktiker" ; -- förhalningstaktik..nn.1
  förhand_1_N = mkN "förhand" "förhänder" ; -- förhand..nn.1
  förhanden_1_A = mkA "förhanden" ; -- förhanden..av.1
  förhandenvarande_1_A = mkA "förhandenvarande" ; -- förhandenvarande..av.1
  förhandenvaro_1_N = mkN "förhandenvaro" ; -- förhandenvaro..nn.1
  förhandla_1_V = mkV "förhandlar" ; -- förhandla..vb.1
  förhandlande_1_N = mkN "förhandlande" ; -- förhandlande..nn.1
  förhandlare_1_N = mkN "förhandlare" utrum  ; -- förhandlare..nn.1
  förhandling_1_N = mkN "förhandling" ; -- förhandling..nn.1
  förhandlingsbar_1_A = mkA "förhandlingsbar" ; -- förhandlingsbar..av.1
  förhandlingsbarhet_1_N = mkN "förhandlingsbarhet" ; -- förhandlingsbarhet..nn.1
  förhandlingsbord_1_N = mkN "förhandlingsbord" neutrum  ; -- förhandlingsbord..nn.1
  förhandlingsbricka_1_N = mkN "förhandlingsbricka" ; -- förhandlingsbricka..nn.1
  förhandlingsdelegation_1_N = mkN "förhandlingsdelegation" ; -- förhandlingsdelegation..nn.1
  förhandlingsfråga_1_N = mkN "förhandlingsfråga" ; -- förhandlingsfråga..nn.1
  förhandlingsläge_1_N = mkN "förhandlingsläge" ; -- förhandlingsläge..nn.1
  förhandlingsmetod_1_N = mkN "förhandlingsmetod" "förhandlingsmetoder" ; -- förhandlingsmetod..nn.1
  förhandlingsmodell_1_N = mkN "förhandlingsmodell" "förhandlingsmodeller" ; -- förhandlingsmodell..nn.1
  förhandlingsmässig_1_A = mkA "förhandlingsmässig" ; -- förhandlingsmässig..av.1
  förhandlingsrunda_1_N = mkN "förhandlingsrunda" ; -- förhandlingsrunda..nn.1
  förhandlingsrätt_1_N = mkN "förhandlingsrätt" ; -- förhandlingsrätt..nn.1
  förhandlingstrick_1_N = mkN "förhandlingstrick" neutrum  ; -- förhandlingstrick..nn.1
  förhandsbeställning_1_N = mkN "förhandsbeställning" ; -- förhandsbeställning..nn.1
  förhandsboka_1_V = mkV "förhandsbokar" ; -- förhandsboka..vb.1
  förhandsbokande_1_N = mkN "förhandsbokande" ; -- förhandsbokande..nn.1
  förhandsbokning_1_N = mkN "förhandsbokning" ; -- förhandsbokning..nn.1
  förhandsbukt_1_N = mkN "förhandsbukt" "förhandsbukter" ; -- förhandsbukt..nn.1
  förhandscensur_1_N = mkN "förhandscensur" ; -- förhandscensur..nn.1
  förhandsinformation_1_N = mkN "förhandsinformation" ; -- förhandsinformation..nn.1
  förhandskopia_1_N = mkN "förhandskopia" ; -- förhandskopia..nn.1
  förhandsskriven_1_A = mkA "förhandsskriven" ; -- förhandsskriven..av.1
  förhastad_1_A = mkA "förhastad" ; -- förhastad..av.1
  förhatlig_1_A = mkA "förhatlig" ; -- förhatlig..av.1
  förhatlighet_1_N = mkN "förhatlighet" "förhatligheter" ; -- förhatlighet..nn.1
  förhinder_1_N = mkN "förhinder" neutrum  ; -- förhinder..nn.1
  förhindra_1_V = mkV "förhindrar" ; -- förhindra..vb.1
  förhindrande_1_N = mkN "förhindrande" ; -- förhindrande..nn.1
  förhistoria_1_N = mkN "förhistoria" ; -- förhistoria..nn.1
  förhistorisk_1_A = mkA "förhistorisk" ; -- förhistorisk..av.1
  förhoppning_1_N = mkN "förhoppning" ; -- förhoppning..nn.1
  förhoppningsfull_1_A = mkA "förhoppningsfull" ; -- förhoppningsfull..av.1
  förhoppningsfullhet_1_N = mkN "förhoppningsfullhet" ; -- förhoppningsfullhet..nn.1
  förhoppningsvis_1_Adv = mkAdv "förhoppningsvis" ; -- förhoppningsvis..ab.1
  förhud_1_N = mkN "förhud" ; -- förhud..nn.1
  förhudsförträngning_1_N = mkN "förhudsförträngning" ; -- förhudsförträngning..nn.1
  förhuggning_1_N = mkN "förhuggning" ; -- förhuggning..nn.1
  förhyda_1_V = mkV "förhyda" "förhydde" "förhytt" ; -- förhyda..vb.1
  förhydande_1_N = mkN "förhydande" ; -- förhydande..nn.1
  förhydning_1_N = mkN "förhydning" ; -- förhydning..nn.1
  förhydningspapp_1_N = mkN "förhydningspapp" ; -- förhydningspapp..nn.1
  förhyra_1_V = mkV "förhyra" "förhyrde" "förhyrt" ; -- förhyra..vb.1
  förhyrande_1_N = mkN "förhyrande" ; -- förhyrande..nn.1
  förhyrning_1_N = mkN "förhyrning" ; -- förhyrning..nn.1
  förhänge_1_N = mkN "förhänge" ; -- förhänge..nn.1
  förhärda_1_V = mkV "förhärdar" ; -- förhärda..vb.1
  förhärdande_1_N = mkN "förhärdande" ; -- förhärdande..nn.1
  förhärdning_1_N = mkN "förhärdning" ; -- förhärdning..nn.1
  förhärja_1_V = mkV "förhärjar" ; -- förhärja..vb.1
  förhärjande_1_N = mkN "förhärjande" ; -- förhärjande..nn.1
  förhärjning_1_N = mkN "förhärjning" ; -- förhärjning..nn.1
  förhärliga_1_V = mkV "förhärligar" ; -- förhärliga..vb.1
  förhärligande_1_N = mkN "förhärligande" ; -- förhärligande..nn.1
  förhärska_1_V = mkV "förhärskar" ; -- förhärska..vb.1
  förhärskande_1_A = mkA "förhärskande" ; -- förhärskande..av.1
  förhärskande_1_N = mkN "förhärskande" ; -- förhärskande..nn.1
  förhävelse_1_N = mkN "förhävelse" "förhävelser" ; -- förhävelse..nn.1
  förhäxa_1_V = mkV "förhäxar" ; -- förhäxa..vb.1
  förhäxande_1_N = mkN "förhäxande" ; -- förhäxande..nn.1
  förhäxare_1_N = mkN "förhäxare" utrum  ; -- förhäxare..nn.1
  förhäxning_1_N = mkN "förhäxning" ; -- förhäxning..nn.1
  förhåll_1_N = mkN "förhåll" neutrum  ; -- förhåll..nn.1
  förhålla_1_V = mkV "förhålla" "förhöll" "förhållit" ; -- förhålla..vb.1
  förhållande_1_N = mkN "förhållande" ; -- förhållande..nn.1
  förhållandevis_1_Adv = mkAdv "förhållandevis" ; -- förhållandevis..ab.1
  förhållning_1_N = mkN "förhållning" ; -- förhållning..nn.1
  förhållningsorder_1_N = mkN "förhållningsorder" ; -- förhållningsorder..nn.1
  förhållningsregel_1_N = mkN "förhållningsregel" "förhållningsregeln" "förhållningsregler" "förhållningsreglerna" ; -- förhållningsregel..nn.1
  förhållningssätt_1_N = mkN "förhållningssätt" neutrum  ; -- förhållningssätt..nn.1
  förhåna_1_V = mkV "förhånar" ; -- förhåna..vb.1
  förhånande_1_N = mkN "förhånande" ; -- förhånande..nn.1
  förhåning_1_N = mkN "förhåning" ; -- förhåning..nn.1
  förhårdnad_1_N = mkN "förhårdnad" "förhårdnader" ; -- förhårdnad..nn.1
  förhårdning_1_N = mkN "förhårdning" ; -- förhårdning..nn.1
  förhöja_1_V = mkV "förhöja" "förhöjde" "förhöjt" ; -- förhöja..vb.1
  förhöjande_1_N = mkN "förhöjande" ; -- förhöjande..nn.1
  förhöjning_1_N = mkN "förhöjning" ; -- förhöjning..nn.1
  förhör_1_N = mkN "förhör" neutrum  ; -- förhör..nn.1
  förhöra_1_V = mkV "förhöra" "förhörde" "förhört" ; -- förhöra..vb.1
  förhörande_1_N = mkN "förhörande" ; -- förhörande..nn.1
  förhörsledare_1_N = mkN "förhörsledare" utrum  ; -- förhörsledare..nn.1
  förhörsprotokoll_1_N = mkN "förhörsprotokoll" neutrum  ; -- förhörsprotokoll..nn.1
  förhörsrum_1_N = mkN "förhörsrum" "förhörsrummet" "förhörsrum" "förhörsrummen" ; -- förhörsrum..nn.1
  förhörsrumssceneri_1_N = mkN "förhörsrumssceneri" "förhörsrumssceneriet" "förhörsrumsscenerier" "förhörsrumsscenerierna" ; -- förhörsrumssceneri..nn.1
  förhörsutskrift_1_N = mkN "förhörsutskrift" "förhörsutskrifter" ; -- förhörsutskrift..nn.1
  förhörsvittne_1_N = mkN "förhörsvittne" ; -- förhörsvittne..nn.1
  förhöst_1_N = mkN "förhöst" ; -- förhöst..nn.1
  förindustriell_1_A = mkA "förindustriell" ; -- förindustriell..av.1
  förinspelad_1_A = mkA "förinspelad" ; -- förinspelad..av.1
  förinta_1_V = mkV "förintar" ; -- förinta..vb.1
  förintande_1_A = mkA "förintande" ; -- förintande..av.1
  förintande_1_N = mkN "förintande" ; -- förintande..nn.1
  förintelse_1_N = mkN "förintelse" utrum  ; -- förintelse..nn.1
  förintelseförnekare_1_N = mkN "förintelseförnekare" utrum  ; -- förintelseförnekare..nn.1
  förintelsekrig_1_N = mkN "förintelsekrig" neutrum  ; -- förintelsekrig..nn.1
  förintelsemuseum_1_N = mkN "förintelsemuseum" "förintelsemuseet" "förintelsemuseer" "förintelsemuseerna" ; -- förintelsemuseum..nn.1
  förintelseverktyg_1_N = mkN "förintelseverktyg" neutrum  ; -- förintelseverktyg..nn.1
  förirrelse_1_N = mkN "förirrelse" "förirrelser" ; -- förirrelse..nn.1
  förirring_1_N = mkN "förirring" ; -- förirring..nn.1
  förivring_1_N = mkN "förivring" ; -- förivring..nn.1
  förjaga_1_V = mkV "förjagar" ; -- förjaga..vb.1
  förjagande_1_N = mkN "förjagande" ; -- förjagande..nn.1
  förkalkning_1_N = mkN "förkalkning" ; -- förkalkning..nn.1
  förkasta_1_V = mkV "förkastar" ; -- förkasta..vb.1
  förkastande_1_N = mkN "förkastande" ; -- förkastande..nn.1
  förkastelse_1_N = mkN "förkastelse" utrum  ; -- förkastelse..nn.1
  förkastelsedom_1_N = mkN "förkastelsedom" ; -- förkastelsedom..nn.1
  förkastlig_1_A = mkA "förkastlig" ; -- förkastlig..av.1
  förkastlighet_1_N = mkN "förkastlighet" ; -- förkastlighet..nn.1
  förkastning_1_N = mkN "förkastning" ; -- förkastning..nn.1
  förklara_1_V = mkV "förklarar" ; -- förklara..vb.1
  förklarad_1_A = mkA "förklarad" ; -- förklarad..av.1
  förklarande_1_N = mkN "förklarande" ; -- förklarande..nn.1
  förklaring_1_N = mkN "förklaring" ; -- förklaring..nn.1
  förklaringsgrund_1_N = mkN "förklaringsgrund" "förklaringsgrunder" ; -- förklaringsgrund..nn.1
  förklaringskraft_1_N = mkN "förklaringskraft" ; -- förklaringskraft..nn.1
  förklaringsmodell_1_N = mkN "förklaringsmodell" "förklaringsmodeller" ; -- förklaringsmodell..nn.1
  förklaringssätt_1_N = mkN "förklaringssätt" neutrum  ; -- förklaringssätt..nn.1
  förklarlig_1_A = mkA "förklarlig" ; -- förklarlig..av.1
  förklarlighet_1_N = mkN "förklarlighet" ; -- förklarlighet..nn.1
  förklenande_1_A = mkA "förklenande" ; -- förklenande..av.1
  förklinga_1_V = mkV "förklingar" ; -- förklinga..vb.1
  förklingande_1_N = mkN "förklingande" ; -- förklingande..nn.1
  förklistra_1_1_V = mkV "förklistrar" ; -- förklistra_1..vb.1
  förklistrande_1_N = mkN "förklistrande" ; -- förklistrande..nn.1
  förklistring_1_N = mkN "förklistring" ; -- förklistring..nn.1
  förklistring_2_1_N = mkN "förklistring" ; -- förklistring_2..nn.1
  förklyftning_1_N = mkN "förklyftning" ; -- förklyftning..nn.1
  förklä_1_N = mkN "förklä" "förklät" "förklän" "förkläna" ; -- förklä..nn.1
  förklädd_1_A = mkA "förklädd" ; -- förklädd..av.1
  förkläddhet_1_N = mkN "förkläddhet" ; -- förkläddhet..nn.1
  förkläde_1_N = mkN "förkläde" ; -- förkläde..nn.1
  förklädeskjol_1_N = mkN "förklädeskjol" ; -- förklädeskjol..nn.1
  förklädnad_1_N = mkN "förklädnad" "förklädnader" ; -- förklädnad..nn.1
  förknippa_1_V = mkV "förknippar" ; -- förknippa..vb.1
  förknippande_1_N = mkN "förknippande" ; -- förknippande..nn.1
  förknippning_1_N = mkN "förknippning" ; -- förknippning..nn.1
  förkolna_1_V = mkV "förkolnar" ; -- förkolna..vb.1
  förkolnande_1_N = mkN "förkolnande" ; -- förkolnande..nn.1
  förkolning_1_N = mkN "förkolning" ; -- förkolning..nn.1
  förkomma_1_V = mkV "förkomma" "förkom" "förkommit" ; -- förkomma..vb.1
  förkommande_1_N = mkN "förkommande" ; -- förkommande..nn.1
  förkommen_1_A = mkA "förkommen" "förkommet" "förkomna" "förkomna" "förkomnare" "förkomnast" "förkomnaste" ; -- förkommen..av.1
  förkommenhet_1_N = mkN "förkommenhet" ; -- förkommenhet..nn.1
  förkonstlad_1_A = mkA "förkonstlad" ; -- förkonstlad..av.1
  förkonstling_1_N = mkN "förkonstling" ; -- förkonstling..nn.1
  förkoppra_1_V = mkV "förkopprar" ; -- förkoppra..vb.1
  förkopprande_1_N = mkN "förkopprande" ; -- förkopprande..nn.1
  förkoppring_1_N = mkN "förkoppring" ; -- förkoppring..nn.1
  förkorta_1_V = mkV "förkortar" ; -- förkorta..vb.1
  förkortande_1_N = mkN "förkortande" ; -- förkortande..nn.1
  förkortning_1_N = mkN "förkortning" ; -- förkortning..nn.1
  förkovra_1_V = mkV "förkovrar" ; -- förkovra..vb.1
  förkovrande_1_N = mkN "förkovrande" ; -- förkovrande..nn.1
  förkrigstid_1_N = mkN "förkrigstid" "förkrigstider" ; -- förkrigstid..nn.1
  förkristen_1_A = mkA "förkristen" ; -- förkristen..av.1
  förkroma_1_V = mkV "förkromar" ; -- förkroma..vb.1
  förkromande_1_N = mkN "förkromande" ; -- förkromande..nn.1
  förkromning_1_N = mkN "förkromning" ; -- förkromning..nn.1
  förkroppning_1_N = mkN "förkroppning" ; -- förkroppning..nn.1
  förkroppsliga_1_V = mkV "förkroppsligar" ; -- förkroppsliga..vb.1
  förkroppsligande_1_N = mkN "förkroppsligande" ; -- förkroppsligande..nn.1
  förkrossa_1_V = mkV "förkrossar" ; -- förkrossa..vb.1
  förkrossad_1_A = mkA "förkrossad" ; -- förkrossad..av.1
  förkrossande_1_A = mkA "förkrossande" ; -- förkrossande..av.1
  förkrossande_1_N = mkN "förkrossande" ; -- förkrossande..nn.1
  förkrosselse_1_N = mkN "förkrosselse" utrum  ; -- förkrosselse..nn.1
  förkrossning_1_N = mkN "förkrossning" ; -- förkrossning..nn.1
  förkrympa_1_V = mkV "förkrymper" ; -- förkrympa..vb.1
  förkrympande_1_N = mkN "förkrympande" ; -- förkrympande..nn.1
  förkrympning_1_N = mkN "förkrympning" ; -- förkrympning..nn.1
  förkrympt_1_A = mkA "förkrympt" "förkrympt" ; -- förkrympt..av.1
  förkrympthet_1_N = mkN "förkrympthet" ; -- förkrympthet..nn.1
  förkråma_1_V = mkV "förkråmar" ; -- förkråma..vb.1
  förkråmande_1_N = mkN "förkråmande" ; -- förkråmande..nn.1
  förkunna_1_V = mkV "förkunnar" ; -- förkunna..vb.1
  förkunnande_1_N = mkN "förkunnande" ; -- förkunnande..nn.1
  förkunnare_1_N = mkN "förkunnare" utrum  ; -- förkunnare..nn.1
  förkunnelse_1_N = mkN "förkunnelse" "förkunnelser" ; -- förkunnelse..nn.1
  förkväva_1_V = mkV "förkväver" ; -- förkväva..vb.1
  förkvävande_1_N = mkN "förkvävande" ; -- förkvävande..nn.1
  förkvävning_1_N = mkN "förkvävning" ; -- förkvävning..nn.1
  förkyld_1_A = mkA "förkyld" "förkylt" ; -- förkyld..av.1
  förkyldhet_1_N = mkN "förkyldhet" ; -- förkyldhet..nn.1
  förkylning_1_N = mkN "förkylning" ; -- förkylning..nn.1
  förkämpe_1_N = mkN "förkämpe" utrum  ; -- förkämpe..nn.1
  förkänning_1_N = mkN "förkänning" ; -- förkänning..nn.1
  förkänsla_1_N = mkN "förkänsla" ; -- förkänsla..nn.1
  förkärlek_1_N = mkN "förkärlek" ; -- förkärlek..nn.1
  förkättrad_1_A = mkA "förkättrad" ; -- förkättrad..av.1
  förköp_1_N = mkN "förköp" neutrum  ; -- förköp..nn.1
  förköpsrätt_1_N = mkN "förköpsrätt" ; -- förköpsrätt..nn.1
  förkörsrätt_1_N = mkN "förkörsrätt" ; -- förkörsrätt..nn.1
  förladdning_1_N = mkN "förladdning" ; -- förladdning..nn.1
  förlag_1_N = mkN "förlag" neutrum  ; -- förlag..nn.1
  förlag_2_1_N = mkN "förlag" neutrum  ; -- förlag_2..nn.1
  förlaga_1_N = mkN "förlaga" ; -- förlaga..nn.1
  förlagsbevis_1_N = mkN "förlagsbevis" neutrum  ; -- förlagsbevis..nn.1
  förlagslån_1_N = mkN "förlagslån" neutrum  ; -- förlagslån..nn.1
  förlagsman_1_N = mkN "förlagsman" "förlagsmannen" "förlagsmän" "förlagsmännen" ; -- förlagsman..nn.1
  förlagsmässig_1_A = mkA "förlagsmässig" ; -- förlagsmässig..av.1
  förlagsverksamhet_1_N = mkN "förlagsverksamhet" "förlagsverksamheter" ; -- förlagsverksamhet..nn.1
  förlama_1_V = mkV "förlamar" ; -- förlama..vb.1
  förlamande_1_N = mkN "förlamande" ; -- förlamande..nn.1
  förlamning_1_N = mkN "förlamning" ; -- förlamning..nn.1
  förled_1_N = mkN "förled" neutrum  ; -- förled..nn.1
  förleda_1_V = mkV "förleda" "förledde" "förlett" ; -- förleda..vb.1
  förledande_1_A = mkA "förledande" ; -- förledande..av.1
  förledande_1_N = mkN "förledande" ; -- förledande..nn.1
  förledare_1_N = mkN "förledare" utrum  ; -- förledare..nn.1
  förlegad_1_A = mkA "förlegad" ; -- förlegad..av.1
  förlida_1_V = mkV "förlida" "förled" "förlidit" ; -- förlida..vb.1
  förlidande_1_N = mkN "förlidande" ; -- förlidande..nn.1
  förliden_1_A = mkA "förliden" ; -- förliden..av.1
  förlig_1_A = mkA "förlig" ; -- förlig..av.1
  förlika_1_V = mkV "förliker" ; -- förlika..vb.1
  förlikande_1_N = mkN "förlikande" ; -- förlikande..nn.1
  förlikning_1_N = mkN "förlikning" ; -- förlikning..nn.1
  förlikningsanbud_1_N = mkN "förlikningsanbud" neutrum  ; -- förlikningsanbud..nn.1
  förlikningskommission_1_N = mkN "förlikningskommission" ; -- förlikningskommission..nn.1
  förlikningsman_1_N = mkN "förlikningsman" "förlikningsmannen" "förlikningsmän" "förlikningsmännen" ; -- förlikningsman..nn.1
  förlisa_1_V = mkV "förliser" ; -- förlisa..vb.1
  förlisande_1_N = mkN "förlisande" ; -- förlisande..nn.1
  förlisning_1_N = mkN "förlisning" ; -- förlisning..nn.1
  förlist_1_A = mkA "förlist" "förlist" ; -- förlist..av.1
  förlitande_1_N = mkN "förlitande" ; -- förlitande..nn.1
  förljudande_1_N = mkN "förljudande" ; -- förljudande..nn.1
  förljugen_1_A = mkA "förljugen" ; -- förljugen..av.1
  förljugenhet_1_N = mkN "förljugenhet" ; -- förljugenhet..nn.1
  förljuva_1_V = mkV "förljuvar" ; -- förljuva..vb.1
  förljuvande_1_N = mkN "förljuvande" ; -- förljuvande..nn.1
  förlopp_1_N = mkN "förlopp" neutrum  ; -- förlopp..nn.1
  förlora_1_V = mkV "förlorar" ; -- förlora..vb.1
  förlorad_1_A = mkA "förlorad" ; -- förlorad..av.1
  förlorande_1_N = mkN "förlorande" ; -- förlorande..nn.1
  förlorare_1_N = mkN "förlorare" utrum  ; -- förlorare..nn.1
  förlorargäng_1_N = mkN "förlorargäng" neutrum  ; -- förlorargäng..nn.1
  förlossa_1_V = mkV "förlossar" ; -- förlossa..vb.1
  förlossande_1_N = mkN "förlossande" ; -- förlossande..nn.1
  förlossare_1_N = mkN "förlossare" utrum  ; -- förlossare..nn.1
  förlossning_1_N = mkN "förlossning" ; -- förlossning..nn.1
  förlossningsanstalt_1_N = mkN "förlossningsanstalt" "förlossningsanstalter" ; -- förlossningsanstalt..nn.1
  förlossningsarbete_1_N = mkN "förlossningsarbete" ; -- förlossningsarbete..nn.1
  förlossningsdepression_1_N = mkN "förlossningsdepression" ; -- förlossningsdepression..nn.1
  förlossningsklinik_1_N = mkN "förlossningsklinik" "förlossningskliniker" ; -- förlossningsklinik..nn.1
  förlossningsskada_1_N = mkN "förlossningsskada" ; -- förlossningsskada..nn.1
  förlossningstång_1_N = mkN "förlossningstång" "förlossningstänger" ; -- förlossningstång..nn.1
  förlovad_1_A = mkA "förlovad" ; -- förlovad..av.1
  förlovning_1_N = mkN "förlovning" ; -- förlovning..nn.1
  förlovningskort_1_N = mkN "förlovningskort" neutrum  ; -- förlovningskort..nn.1
  förlovningsring_1_N = mkN "förlovningsring" ; -- förlovningsring..nn.1
  förlupen_1_A = mkA "förlupen" ; -- förlupen..av.1
  förlust_1_N = mkN "förlust" "förluster" ; -- förlust..nn.1
  förlusta_1_V = mkV "förlustar" ; -- förlusta..vb.1
  förlustande_1_N = mkN "förlustande" ; -- förlustande..nn.1
  förlustbringande_1_A = mkA "förlustbringande" ; -- förlustbringande..av.1
  förlustelse_1_N = mkN "förlustelse" "förlustelser" ; -- förlustelse..nn.1
  förlustfri_1_A = mkA "förlustfri" "förlustfritt" ; -- förlustfri..av.1
  förlustig_1_A = mkA "förlustig" ; -- förlustig..av.1
  förlustighet_1_N = mkN "förlustighet" ; -- förlustighet..nn.1
  förlustrik_1_A = mkA "förlustrik" ; -- förlustrik..av.1
  förlustrikedom_1_N = mkN "förlustrikedom" ; -- förlustrikedom..nn.1
  förlusttyngd_1_A = mkA "förlusttyngd" "förlusttyngt" ; -- förlusttyngd..av.1
  förlustår_1_N = mkN "förlustår" neutrum  ; -- förlustår..nn.1
  förlägen_1_A = mkA "förlägen" ; -- förlägen..av.1
  förlägenhet_1_N = mkN "förlägenhet" "förlägenheter" ; -- förlägenhet..nn.1
  förlägga_1_V = mkV "förlägga" "förla" "förlagt" ; -- förlägga..vb.1
  förläggande_1_N = mkN "förläggande" ; -- förläggande..nn.1
  förläggare_1_N = mkN "förläggare" utrum  ; -- förläggare..nn.1
  förläggning_1_N = mkN "förläggning" ; -- förläggning..nn.1
  förläggningsort_1_N = mkN "förläggningsort" "förläggningsorter" ; -- förläggningsort..nn.1
  förläna_1_V = mkV "förlänar" ; -- förläna..vb.1
  förlänande_1_N = mkN "förlänande" ; -- förlänande..nn.1
  förlänare_1_N = mkN "förlänare" utrum  ; -- förlänare..nn.1
  förlänga_1_V = mkV "förlänger" ; -- förlänga..vb.1
  förlängande_1_N = mkN "förlängande" ; -- förlängande..nn.1
  förlängning_1_N = mkN "förlängning" ; -- förlängning..nn.1
  förlängningsrör_1_N = mkN "förlängningsrör" neutrum  ; -- förlängningsrör..nn.1
  förlängningsskaft_1_N = mkN "förlängningsskaft" neutrum  ; -- förlängningsskaft..nn.1
  förlängningssladd_1_N = mkN "förlängningssladd" ; -- förlängningssladd..nn.1
  förläning_1_N = mkN "förläning" ; -- förläning..nn.1
  förläst_1_A = mkA "förläst" "förläst" ; -- förläst..av.1
  förlästhet_1_N = mkN "förlästhet" ; -- förlästhet..nn.1
  förlåt_1_N = mkN "förlåt" "förlåter" ; -- förlåt..nn.1
  förlåta_1_V = mkV "förlåta" "förlät" "förlåtit" ; -- förlåta..vb.1
  förlåtande_1_N = mkN "förlåtande" ; -- förlåtande..nn.1
  förlåtelse_1_N = mkN "förlåtelse" utrum  ; -- förlåtelse..nn.1
  förlåtlig_1_A = mkA "förlåtlig" ; -- förlåtlig..av.1
  förlåtlighet_1_N = mkN "förlåtlighet" ; -- förlåtlighet..nn.1
  förlöjliga_1_V = mkV "förlöjligar" ; -- förlöjliga..vb.1
  förlöjligande_1_N = mkN "förlöjligande" ; -- förlöjligande..nn.1
  förlöpa_1_V = mkV "förlöper" ; -- förlöpa..vb.1
  förlöpa_2_V = mkV "förlöper" ; -- förlöpa..vb.2
  förlöpande_1_N = mkN "förlöpande" ; -- förlöpande..nn.1
  förlöpare_1_N = mkN "förlöpare" utrum  ; -- förlöpare..nn.1
  förlöpning_1_N = mkN "förlöpning" ; -- förlöpning..nn.1
  förlösa_1_V = mkV "förlöser" ; -- förlösa..vb.1
  förlösande_1_N = mkN "förlösande" ; -- förlösande..nn.1
  förlösare_1_N = mkN "förlösare" utrum  ; -- förlösare..nn.1
  förlösning_1_N = mkN "förlösning" ; -- förlösning..nn.1
  förmak_1_N = mkN "förmak" neutrum  ; -- förmak..nn.1
  förmaksflimmer_1_N = mkN "förmaksflimmer" neutrum  ; -- förmaksflimmer..nn.1
  förman_1_N = mkN "förman" "förmannen" "förmän" "förmännen" ; -- förman..nn.1
  förmana_1_V = mkV "förmanar" ; -- förmana..vb.1
  förmanande_1_N = mkN "förmanande" ; -- förmanande..nn.1
  förmaning_1_N = mkN "förmaning" ; -- förmaning..nn.1
  förmaningsord_1_N = mkN "förmaningsord" neutrum  ; -- förmaningsord..nn.1
  förmaningstal_1_N = mkN "förmaningstal" neutrum  ; -- förmaningstal..nn.1
  förmanskap_1_N = mkN "förmanskap" neutrum  ; -- förmanskap..nn.1
  förmatch_1_N = mkN "förmatch" "förmatcher" ; -- förmatch..nn.1
  förmedla_1_V = mkV "förmedlar" ; -- förmedla..vb.1
  förmedlande_1_A = mkA "förmedlande" ; -- förmedlande..av.1
  förmedlande_1_N = mkN "förmedlande" ; -- förmedlande..nn.1
  förmedlare_1_N = mkN "förmedlare" utrum  ; -- förmedlare..nn.1
  förmedling_1_N = mkN "förmedling" ; -- förmedling..nn.1
  förmedlingslänk_1_N = mkN "förmedlingslänk" ; -- förmedlingslänk..nn.1
  förmedveten_1_A = mkA "förmedveten" ; -- förmedveten..av.1
  förmedvetenhet_1_N = mkN "förmedvetenhet" ; -- förmedvetenhet..nn.1
  förmena_1_V = mkV "förmenar" ; -- förmena..vb.1
  förmena_2_V = mkV "förmenar" ; -- förmena..vb.2
  förmenande_1_N = mkN "förmenande" ; -- förmenande..nn.1
  förmenande_2_N = mkN "förmenande" ; -- förmenande..nn.2
  förment_1_A = mkA "förment" "förment" ; -- förment..av.1
  förmer_1_A = mkA "förmer" ; -- förmer..av.1
  förmera_1_A = mkA "förmera" ; -- förmera..av.1
  förmera_1_V = mkV "förmerar" ; -- förmera..vb.1
  förmerande_1_N = mkN "förmerande" ; -- förmerande..nn.1
  förmering_1_N = mkN "förmering" ; -- förmering..nn.1
  förmiddag_1_N = mkN "förmiddag" ; -- förmiddag..nn.1
  förmiddagskaffe_1_N = mkN "förmiddagskaffe" ; -- förmiddagskaffe..nn.1
  förmiddagspromenad_1_N = mkN "förmiddagspromenad" "förmiddagspromenader" ; -- förmiddagspromenad..nn.1
  förmildra_1_V = mkV "förmildrar" ; -- förmildra..vb.1
  förmildrande_1_A = mkA "förmildrande" ; -- förmildrande..av.1
  förmildrande_1_N = mkN "förmildrande" ; -- förmildrande..nn.1
  förminska_1_V = mkV "förminskar" ; -- förminska..vb.1
  förminskande_1_N = mkN "förminskande" ; -- förminskande..nn.1
  förminskning_1_N = mkN "förminskning" ; -- förminskning..nn.1
  förmoda_1_V = mkV "förmodar" ; -- förmoda..vb.1
  förmodande_1_N = mkN "förmodande" ; -- förmodande..nn.1
  förmodern_1_A = mkA "förmodern" ; -- förmodern..av.1
  förmodligen_1_Adv = mkAdv "förmodligen" ; -- förmodligen..ab.1
  förmultna_1_V = mkV "förmultnar" ; -- förmultna..vb.1
  förmultnande_1_N = mkN "förmultnande" ; -- förmultnande..nn.1
  förmultning_1_N = mkN "förmultning" ; -- förmultning..nn.1
  förmyndaraktig_1_A = mkA "förmyndaraktig" ; -- förmyndaraktig..av.1
  förmyndaraktighet_1_N = mkN "förmyndaraktighet" ; -- förmyndaraktighet..nn.1
  förmyndare_1_N = mkN "förmyndare" utrum  ; -- förmyndare..nn.1
  förmyndarregering_1_N = mkN "förmyndarregering" ; -- förmyndarregering..nn.1
  förmyndarskap_1_N = mkN "förmyndarskap" neutrum  ; -- förmyndarskap..nn.1
  förmyndarstyre_1_N = mkN "förmyndarstyre" ; -- förmyndarstyre..nn.1
  förmynderi_1_N = mkN "förmynderi" neutrum  ; -- förmynderi..nn.1
  förmynderskap_1_N = mkN "förmynderskap" neutrum  ; -- förmynderskap..nn.1
  förmäla_1_V = mkV "förmäler" ; -- förmäla..vb.1
  förmäla_2_V = mkV "förmäler" ; -- förmäla..vb.2
  förmälande_1_N = mkN "förmälande" ; -- förmälande..nn.1
  förmäld_1_A = mkA "förmäld" "förmält" ; -- förmäld..av.1
  förmälning_1_N = mkN "förmälning" ; -- förmälning..nn.1
  förmänniska_1_N = mkN "förmänniska" ; -- förmänniska..nn.1
  förmänskliga_1_V = mkV "förmänskligar" ; -- förmänskliga..vb.1
  förmänskligande_1_N = mkN "förmänskligande" ; -- förmänskligande..nn.1
  förmärka_1_V = mkV "förmärker" ; -- förmärka..vb.1
  förmärkande_1_N = mkN "förmärkande" ; -- förmärkande..nn.1
  förmäten_1_A = mkA "förmäten" ; -- förmäten..av.1
  förmätenhet_1_N = mkN "förmätenhet" ; -- förmätenhet..nn.1
  förmå_1_V = mkV "förmår" ; -- förmå..vb.1
  förmående_1_N = mkN "förmående" ; -- förmående..nn.1
  förmåga_1_N = mkN "förmåga" ; -- förmåga..nn.1
  förmån_1_N = mkN "förmån" "förmåner" ; -- förmån..nn.1
  förmånlig_1_A = mkA "förmånlig" ; -- förmånlig..av.1
  förmånlighet_1_N = mkN "förmånlighet" ; -- förmånlighet..nn.1
  förmånserbjudande_1_N = mkN "förmånserbjudande" ; -- förmånserbjudande..nn.1
  förmånsrätt_1_N = mkN "förmånsrätt" ; -- förmånsrätt..nn.1
  förmånstagare_1_N = mkN "förmånstagare" utrum  ; -- förmånstagare..nn.1
  förmögen_1_A = mkA "förmögen" ; -- förmögen..av.1
  förmögen_2_A = mkA "förmögen" ; -- förmögen..av.2
  förmögenhet_1_N = mkN "förmögenhet" "förmögenheter" ; -- förmögenhet..nn.1
  förmögenhetsbrott_1_N = mkN "förmögenhetsbrott" neutrum  ; -- förmögenhetsbrott..nn.1
  förmögenhetsrätt_1_N = mkN "förmögenhetsrätt" "förmögenhetsrätter" ; -- förmögenhetsrätt..nn.1
  förmögenhetsskatt_1_N = mkN "förmögenhetsskatt" "förmögenhetsskatter" ; -- förmögenhetsskatt..nn.1
  förmörka_1_V = mkV "förmörkar" ; -- förmörka..vb.1
  förmörkande_1_N = mkN "förmörkande" ; -- förmörkande..nn.1
  förmörkelse_1_N = mkN "förmörkelse" "förmörkelser" ; -- förmörkelse..nn.1
  förmörkelsevariabel_1_N = mkN "förmörkelsevariabel" "förmörkelsevariabeln" "förmörkelsevariabler" "förmörkelsevariablerna" ; -- förmörkelsevariabel..nn.1
  förmörkning_1_N = mkN "förmörkning" ; -- förmörkning..nn.1
  förna_1_N = mkN "förna" ; -- förna..nn.1
  förnagla_1_V = mkV "förnaglar" ; -- förnagla..vb.1
  förnaglande_1_N = mkN "förnaglande" ; -- förnaglande..nn.1
  förnagling_1_N = mkN "förnagling" ; -- förnagling..nn.1
  förnamn_1_N = mkN "förnamn" neutrum  ; -- förnamn..nn.1
  förnatt_1_N = mkN "förnatt" "förnätter" ; -- förnatt..nn.1
  förnedra_1_V = mkV "förnedrar" ; -- förnedra..vb.1
  förnedrande_1_N = mkN "förnedrande" ; -- förnedrande..nn.1
  förnedring_1_N = mkN "förnedring" ; -- förnedring..nn.1
  förnedringstillstånd_1_N = mkN "förnedringstillstånd" neutrum  ; -- förnedringstillstånd..nn.1
  förneka_1_V = mkV "förnekar" ; -- förneka..vb.1
  förnekande_1_N = mkN "förnekande" ; -- förnekande..nn.1
  förnekare_1_N = mkN "förnekare" utrum  ; -- förnekare..nn.1
  förnekelse_1_N = mkN "förnekelse" "förnekelser" ; -- förnekelse..nn.1
  förnekelsefas_1_N = mkN "förnekelsefas" "förnekelsefaser" ; -- förnekelsefas..nn.1
  förnickla_1_V = mkV "förnicklar" ; -- förnickla..vb.1
  förnicklande_1_N = mkN "förnicklande" ; -- förnicklande..nn.1
  förnickling_1_N = mkN "förnickling" ; -- förnickling..nn.1
  förnimbar_1_A = mkA "förnimbar" ; -- förnimbar..av.1
  förnimbarhet_1_N = mkN "förnimbarhet" "förnimbarheter" ; -- förnimbarhet..nn.1
  förnimma_1_V = mkV "förnimma" "förnam" "förnummit" ; -- förnimma..vb.1
  förnimmande_1_N = mkN "förnimmande" ; -- förnimmande..nn.1
  förnimmelse_1_N = mkN "förnimmelse" "förnimmelser" ; -- förnimmelse..nn.1
  förnimmelseförmåga_1_N = mkN "förnimmelseförmåga" ; -- förnimmelseförmåga..nn.1
  förning_1_N = mkN "förning" ; -- förning..nn.1
  förnuft_1_N = mkN "förnuft" neutrum  ; -- förnuft..nn.1
  förnuftig_1_A = mkA "förnuftig" ; -- förnuftig..av.1
  förnuftighet_1_N = mkN "förnuftighet" ; -- förnuftighet..nn.1
  förnuftsenlig_1_A = mkA "förnuftsenlig" ; -- förnuftsenlig..av.1
  förnuftsenlighet_1_N = mkN "förnuftsenlighet" ; -- förnuftsenlighet..nn.1
  förnuftslös_1_A = mkA "förnuftslös" ; -- förnuftslös..av.1
  förnuftslöshet_1_N = mkN "förnuftslöshet" "förnuftslösheter" ; -- förnuftslöshet..nn.1
  förnuftsmässig_1_A = mkA "förnuftsmässig" ; -- förnuftsmässig..av.1
  förnuftsskäl_1_N = mkN "förnuftsskäl" neutrum  ; -- förnuftsskäl..nn.1
  förnuftsstridig_1_A = mkA "förnuftsstridig" ; -- förnuftsstridig..av.1
  förnuftsstridighet_1_N = mkN "förnuftsstridighet" ; -- förnuftsstridighet..nn.1
  förnuftstro_1_N = mkN "förnuftstro" ; -- förnuftstro..nn.1
  förnuftsvidrig_1_A = mkA "förnuftsvidrig" ; -- förnuftsvidrig..av.1
  förnuftsvidrighet_1_N = mkN "förnuftsvidrighet" ; -- förnuftsvidrighet..nn.1
  förnumstig_1_A = mkA "förnumstig" ; -- förnumstig..av.1
  förnumstighet_1_N = mkN "förnumstighet" "förnumstigheter" ; -- förnumstighet..nn.1
  förnya_1_V = mkV "förnyar" ; -- förnya..vb.1
  förnyande_1_N = mkN "förnyande" ; -- förnyande..nn.1
  förnyare_1_N = mkN "förnyare" utrum  ; -- förnyare..nn.1
  förnybar_1_A = mkA "förnybar" ; -- förnybar..av.1
  förnybarhet_1_N = mkN "förnybarhet" ; -- förnybarhet..nn.1
  förnyelse_1_N = mkN "förnyelse" "förnyelser" ; -- förnyelse..nn.1
  förnyelsebar_1_A = mkA "förnyelsebar" ; -- förnyelsebar..av.1
  förnyelsebarhet_1_N = mkN "förnyelsebarhet" ; -- förnyelsebarhet..nn.1
  förnäm_1_A = mkA "förnäm" "förnämare" "förnämast" ; -- förnäm..av.1
  förnämhet_1_N = mkN "förnämhet" "förnämheter" ; -- förnämhet..nn.1
  förnämitet_1_N = mkN "förnämitet" "förnämiteter" ; -- förnämitet..nn.1
  förnämlig_1_A = mkA "förnämlig" ; -- förnämlig..av.1
  förnämligast_1_Adv = mkAdv "förnämligast" ; -- förnämligast..ab.1
  förnämligen_1_Adv = mkAdv "förnämligen" ; -- förnämligen..ab.1
  förnämlighet_1_N = mkN "förnämlighet" ; -- förnämlighet..nn.1
  förnär_1_Adv = mkAdv "förnär" ; -- förnär..ab.1
  förnärma_1_V = mkV "förnärmar" ; -- förnärma..vb.1
  förnärmad_1_A = mkA "förnärmad" ; -- förnärmad..av.1
  förnärmande_1_N = mkN "förnärmande" ; -- förnärmande..nn.1
  förnärmelse_1_N = mkN "förnärmelse" "förnärmelser" ; -- förnärmelse..nn.1
  förnödenhet_1_N = mkN "förnödenhet" "förnödenheter" ; -- förnödenhet..nn.1
  förnöja_1_V = mkV "förnöja" "förnöjde" "förnöjt" ; -- förnöja..vb.1
  förnöjande_1_N = mkN "förnöjande" ; -- förnöjande..nn.1
  förnöjd_1_A = mkA "förnöjd" "förnöjt" ; -- förnöjd..av.1
  förnöjdhet_1_N = mkN "förnöjdhet" ; -- förnöjdhet..nn.1
  förnöjelse_1_N = mkN "förnöjelse" "förnöjelser" ; -- förnöjelse..nn.1
  förnöjsam_1_A = mkA "förnöjsam" "förnöjsamt" "förnöjsamma" "förnöjsamma" "förnöjsammare" "förnöjsammast" "förnöjsammaste" ; -- förnöjsam..av.1
  förnöjsamhet_1_N = mkN "förnöjsamhet" ; -- förnöjsamhet..nn.1
  förnöta_1_V = mkV "förnöter" ; -- förnöta..vb.1
  förnötande_1_N = mkN "förnötande" ; -- förnötande..nn.1
  förolyckad_1_A = mkA "förolyckad" ; -- förolyckad..av.1
  förolämpa_1_V = mkV "förolämpar" ; -- förolämpa..vb.1
  förolämpad_1_A = mkA "förolämpad" ; -- förolämpad..av.1
  förolämpande_1_N = mkN "förolämpande" ; -- förolämpande..nn.1
  förolämpning_1_N = mkN "förolämpning" ; -- förolämpning..nn.1
  förord_1_N = mkN "förord" neutrum  ; -- förord..nn.1
  förorda_1_V = mkV "förordar" ; -- förorda..vb.1
  förordad_1_A = mkA "förordad" ; -- förordad..av.1
  förordande_1_N = mkN "förordande" ; -- förordande..nn.1
  förordna_1_V = mkV "förordnar" ; -- förordna..vb.1
  förordnande_1_N = mkN "förordnande" ; -- förordnande..nn.1
  förordning_1_N = mkN "förordning" ; -- förordning..nn.1
  förorena_1_V = mkV "förorenar" ; -- förorena..vb.1
  förorenande_1_N = mkN "förorenande" ; -- förorenande..nn.1
  förorening_1_N = mkN "förorening" ; -- förorening..nn.1
  föroreningsgrad_1_N = mkN "föroreningsgrad" "föroreningsgrader" ; -- föroreningsgrad..nn.1
  förorsaka_1_V = mkV "förorsakar" ; -- förorsaka..vb.1
  förorsakande_1_N = mkN "förorsakande" ; -- förorsakande..nn.1
  förort_1_N = mkN "förort" "förorter" ; -- förort..nn.1
  förortsbo_1_N = mkN "förortsbo" "förortsbor" ; -- förortsbo..nn.1
  förortslärarinna_1_N = mkN "förortslärarinna" ; -- förortslärarinna..nn.1
  förortsskola_1_N = mkN "förortsskola" ; -- förortsskola..nn.1
  förortsträdgård_1_N = mkN "förortsträdgård" ; -- förortsträdgård..nn.1
  förorätta_1_V = mkV "förorättar" ; -- förorätta..vb.1
  förorättad_1_A = mkA "förorättad" ; -- förorättad..av.1
  förorättande_1_N = mkN "förorättande" ; -- förorättande..nn.1
  förpacka_1_V = mkV "förpackar" ; -- förpacka..vb.1
  förpackande_1_N = mkN "förpackande" ; -- förpackande..nn.1
  förpackning_1_N = mkN "förpackning" ; -- förpackning..nn.1
  förpackningsindustri_1_N = mkN "förpackningsindustri" "förpackningsindustrier" ; -- förpackningsindustri..nn.1
  förpakta_1_V = mkV "förpaktar" ; -- förpakta..vb.1
  förpaktande_1_N = mkN "förpaktande" ; -- förpaktande..nn.1
  förpaktare_1_N = mkN "förpaktare" utrum  ; -- förpaktare..nn.1
  förpaktning_1_N = mkN "förpaktning" ; -- förpaktning..nn.1
  förpanta_1_V = mkV "förpantar" ; -- förpanta..vb.1
  förpantande_1_N = mkN "förpantande" ; -- förpantande..nn.1
  förpantning_1_N = mkN "förpantning" ; -- förpantning..nn.1
  förpassa_1_V = mkV "förpassar" ; -- förpassa..vb.1
  förpassande_1_N = mkN "förpassande" ; -- förpassande..nn.1
  förpassning_1_N = mkN "förpassning" ; -- förpassning..nn.1
  förpatrull_1_N = mkN "förpatrull" "förpatruller" ; -- förpatrull..nn.1
  förpesta_1_V = mkV "förpestar" ; -- förpesta..vb.1
  förpestande_1_N = mkN "förpestande" ; -- förpestande..nn.1
  förpestning_1_N = mkN "förpestning" ; -- förpestning..nn.1
  förpik_1_N = mkN "förpik" ; -- förpik..nn.1
  förplikta_1_V = mkV "förpliktar" ; -- förplikta..vb.1
  förpliktad_1_A = mkA "förpliktad" ; -- förpliktad..av.1
  förpliktande_1_A = mkA "förpliktande" ; -- förpliktande..av.1
  förpliktande_1_N = mkN "förpliktande" ; -- förpliktande..nn.1
  förpliktelse_1_N = mkN "förpliktelse" "förpliktelser" ; -- förpliktelse..nn.1
  förpliktiga_1_V = mkV "förpliktigar" ; -- förpliktiga..vb.1
  förpliktigad_1_A = mkA "förpliktigad" ; -- förpliktigad..av.1
  förpliktigande_1_N = mkN "förpliktigande" ; -- förpliktigande..nn.1
  förpläga_1_V = mkV "förplägar" ; -- förpläga..vb.1
  förplägande_1_N = mkN "förplägande" ; -- förplägande..nn.1
  förplägnad_1_N = mkN "förplägnad" "förplägnader" ; -- förplägnad..nn.1
  förplägning_1_N = mkN "förplägning" ; -- förplägning..nn.1
  förpost_1_N = mkN "förpost" "förposter" ; -- förpost..nn.1
  förpostfäktning_1_N = mkN "förpostfäktning" ; -- förpostfäktning..nn.1
  förpricka_1_V = mkV "förprickar" ; -- förpricka..vb.1
  förprickande_1_N = mkN "förprickande" ; -- förprickande..nn.1
  förprickning_1_N = mkN "förprickning" ; -- förprickning..nn.1
  förpubertet_1_N = mkN "förpubertet" "förpuberteter" ; -- förpubertet..nn.1
  förpuppning_1_N = mkN "förpuppning" ; -- förpuppning..nn.1
  förregling_1_N = mkN "förregling" ; -- förregling..nn.1
  förresten_1_Adv = mkAdv "förresten" ; -- förresten..ab.1
  förrförra_1_A = mkA "förrförra" ; -- förrförra..av.1
  förringa_1_V = mkV "förringar" ; -- förringa..vb.1
  förringande_1_N = mkN "förringande" ; -- förringande..nn.1
  förrinna_1_V = mkV "förrinna" "förrann" "förrunnit" ; -- förrinna..vb.1
  förrinnande_1_N = mkN "förrinnande" ; -- förrinnande..nn.1
  förromantik_1_N = mkN "förromantik" ; -- förromantik..nn.1
  förromantisk_1_A = mkA "förromantisk" ; -- förromantisk..av.1
  förromersk_1_A = mkA "förromersk" ; -- förromersk..av.1
  förrum_1_N = mkN "förrum" "förrummet" "förrum" "förrummen" ; -- förrum..nn.1
  förruttna_1_V = mkV "förruttnar" ; -- förruttna..vb.1
  förruttnande_1_N = mkN "förruttnande" ; -- förruttnande..nn.1
  förruttnelse_1_N = mkN "förruttnelse" utrum  ; -- förruttnelse..nn.1
  förruttnelsegas_1_N = mkN "förruttnelsegas" "förruttnelsegaser" ; -- förruttnelsegas..nn.1
  förruttnelseprocess_1_N = mkN "förruttnelseprocess" "förruttnelseprocesser" ; -- förruttnelseprocess..nn.1
  förrycka_1_V = mkV "förrycker" ; -- förrycka..vb.1
  förryckande_1_N = mkN "förryckande" ; -- förryckande..nn.1
  förryckning_1_N = mkN "förryckning" ; -- förryckning..nn.1
  förryckt_1_A = mkA "förryckt" "förryckt" ; -- förryckt..av.1
  förryckthet_1_N = mkN "förryckthet" ; -- förryckthet..nn.1
  förrymd_1_A = mkA "förrymd" "förrymt" ; -- förrymd..av.1
  förryska_1_V = mkV "förryskar" ; -- förryska..vb.1
  förryskande_1_N = mkN "förryskande" ; -- förryskande..nn.1
  förrädare_1_N = mkN "förrädare" utrum  ; -- förrädare..nn.1
  förräderi_1_N = mkN "förräderi" "förräderiet" "förräderier" "förräderierna" ; -- förräderi..nn.1
  förrädisk_1_A = mkA "förrädisk" ; -- förrädisk..av.1
  förrädiskhet_1_N = mkN "förrädiskhet" "förrädiskheter" ; -- förrädiskhet..nn.1
  förränta_1_V = mkV "förräntar" ; -- förränta..vb.1
  förräntande_1_N = mkN "förräntande" ; -- förräntande..nn.1
  förräntning_1_N = mkN "förräntning" ; -- förräntning..nn.1
  förrätt_1_N = mkN "förrätt" "förrätter" ; -- förrätt..nn.1
  förrätta_1_V = mkV "förrättar" ; -- förrätta..vb.1
  förrättande_1_N = mkN "förrättande" ; -- förrättande..nn.1
  förrättare_1_N = mkN "förrättare" utrum  ; -- förrättare..nn.1
  förrättning_1_N = mkN "förrättning" ; -- förrättning..nn.1
  förråa_1_V = mkV "förråar" ; -- förråa..vb.1
  förråande_1_N = mkN "förråande" ; -- förråande..nn.1
  förråd_1_N = mkN "förråd" neutrum  ; -- förråd..nn.1
  förråda_1_V = mkV "förråda" "förrådde" "förrått" ; -- förråda..vb.1
  förrådande_1_N = mkN "förrådande" ; -- förrådande..nn.1
  förrådshus_1_N = mkN "förrådshus" neutrum  ; -- förrådshus..nn.1
  förrådsrum_1_N = mkN "förrådsrum" "förrådsrummet" "förrådsrum" "förrådsrummen" ; -- förrådsrum..nn.1
  förrådsutrymme_1_N = mkN "förrådsutrymme" ; -- förrådsutrymme..nn.1
  försagd_1_A = mkA "försagd" "försagt" ; -- försagd..av.1
  försagdhet_1_N = mkN "försagdhet" ; -- försagdhet..nn.1
  försaka_1_V = mkV "försakar" ; -- försaka..vb.1
  försakande_1_N = mkN "försakande" ; -- försakande..nn.1
  försakelse_1_N = mkN "försakelse" "försakelser" ; -- försakelse..nn.1
  försakelsefull_1_A = mkA "försakelsefull" ; -- försakelsefull..av.1
  församla_1_V = mkV "församlar" ; -- församla..vb.1
  församlande_1_N = mkN "församlande" ; -- församlande..nn.1
  församling_1_N = mkN "församling" ; -- församling..nn.1
  församlingsassistent_1_N = mkN "församlingsassistent" "församlingsassistenter" ; -- församlingsassistent..nn.1
  församlingsbo_1_N = mkN "församlingsbo" "församlingsbor" ; -- församlingsbo..nn.1
  församlingsbok_1_N = mkN "församlingsbok" "församlingsböcker" ; -- församlingsbok..nn.1
  församlingsfrihet_1_N = mkN "församlingsfrihet" "församlingsfriheter" ; -- församlingsfrihet..nn.1
  församlingshem_1_N = mkN "församlingshem" "församlingshemmet" "församlingshem" "församlingshemmen" ; -- församlingshem..nn.1
  församlingshus_1_N = mkN "församlingshus" neutrum  ; -- församlingshus..nn.1
  församlingskyrka_1_N = mkN "församlingskyrka" ; -- församlingskyrka..nn.1
  församlingsliv_1_N = mkN "församlingsliv" neutrum  ; -- församlingsliv..nn.1
  församlingsmedlem_1_N = mkN "församlingsmedlem" "församlingsmedlemmen" "församlingsmedlemmar" "församlingsmedlemmarna" ; -- församlingsmedlem..nn.1
  församlingspräst_1_N = mkN "församlingspräst" "församlingspräster" ; -- församlingspräst..nn.1
  församlingsråd_1_N = mkN "församlingsråd" neutrum  ; -- församlingsråd..nn.1
  försanthållen_1_A = mkA "försanthållen" ; -- försanthållen..av.1
  försats_1_N = mkN "försats" "försatser" ; -- försats..nn.1
  förse_1_V = mkV "förse" "försedde" "försett" ; -- förse..vb.1
  försedd_1_A = mkA "försedd" ; -- försedd..av.1
  förseelse_1_N = mkN "förseelse" "förseelser" ; -- förseelse..nn.1
  förseende_1_N = mkN "förseende" ; -- förseende..nn.1
  försegel_1_N = mkN "försegel" neutrum  ; -- försegel..nn.1
  försegla_1_V = mkV "förseglar" ; -- försegla..vb.1
  förseglande_1_N = mkN "förseglande" ; -- förseglande..nn.1
  försegling_1_N = mkN "försegling" ; -- försegling..nn.1
  försena_1_V = mkV "försenar" ; -- försena..vb.1
  försenad_1_A = mkA "försenad" ; -- försenad..av.1
  försenande_1_N = mkN "försenande" ; -- försenande..nn.1
  försening_1_N = mkN "försening" ; -- försening..nn.1
  förseningskampanj_1_N = mkN "förseningskampanj" "förseningskampanjer" ; -- förseningskampanj..nn.1
  förseningstimme_1_N = mkN "förseningstimme" utrum  ; -- förseningstimme..nn.1
  försent_1_Adv = mkAdv "försent" ; -- försent..ab.1
  försiggå_1_V = mkV "försiggå" "försiggår" "försiggå" "försiggick" "försiggått" "försiggången" ; -- försiggå..vb.1
  försiggående_1_N = mkN "försiggående" ; -- försiggående..nn.1
  försigkommen_1_A = mkA "försigkommen" "försigkommet" "försigkomna" "försigkomna" "försigkomnare" "försigkomnast" "försigkomnaste" ; -- försigkommen..av.1
  försigkommenhet_1_N = mkN "försigkommenhet" ; -- försigkommenhet..nn.1
  försiktig_1_A = mkA "försiktig" ; -- försiktig..av.1
  försiktighet_1_N = mkN "försiktighet" "försiktigheter" ; -- försiktighet..nn.1
  försiktighetsmått_1_N = mkN "försiktighetsmått" neutrum  ; -- försiktighetsmått..nn.1
  försiktighetsprincip_1_N = mkN "försiktighetsprincip" "försiktighetsprinciper" ; -- försiktighetsprincip..nn.1
  försiktighetsvis_1_Adv = mkAdv "försiktighetsvis" ; -- försiktighetsvis..ab.1
  försiktighetsåtgärd_1_N = mkN "försiktighetsåtgärd" "försiktighetsåtgärder" ; -- försiktighetsåtgärd..nn.1
  försiktigtvis_1_Adv = mkAdv "försiktigtvis" ; -- försiktigtvis..ab.1
  försilvra_1_V = mkV "försilvrar" ; -- försilvra..vb.1
  försilvrande_1_N = mkN "försilvrande" ; -- försilvrande..nn.1
  försinka_1_V = mkV "försinkar" ; -- försinka..vb.1
  försinkande_1_N = mkN "försinkande" ; -- försinkande..nn.1
  försinkning_1_N = mkN "försinkning" ; -- försinkning..nn.1
  försitta_1_V = mkV "försitta" "försatt" "försuttit" ; -- försitta..vb.1
  försittande_1_N = mkN "försittande" ; -- försittande..nn.1
  försjunka_1_V = mkV "försjunka" "försjönk" "försjunkit" ; -- försjunka..vb.1
  försjunkande_1_N = mkN "försjunkande" ; -- försjunkande..nn.1
  försjunken_1_A = mkA "försjunken" ; -- försjunken..av.1
  försjunkenhet_1_N = mkN "försjunkenhet" ; -- försjunkenhet..nn.1
  försjunkning_1_N = mkN "försjunkning" ; -- försjunkning..nn.1
  förskaffa_1_V = mkV "förskaffar" ; -- förskaffa..vb.1
  förskaffande_1_N = mkN "förskaffande" ; -- förskaffande..nn.1
  förskansa_1_V = mkV "förskansar" ; -- förskansa..vb.1
  förskansande_1_N = mkN "förskansande" ; -- förskansande..nn.1
  förskansning_1_N = mkN "förskansning" ; -- förskansning..nn.1
  förskepp_1_N = mkN "förskepp" neutrum  ; -- förskepp..nn.1
  förskiffring_1_N = mkN "förskiffring" ; -- förskiffring..nn.1
  förskingra_1_V = mkV "förskingrar" ; -- förskingra..vb.1
  förskingrande_1_N = mkN "förskingrande" ; -- förskingrande..nn.1
  förskingrare_1_N = mkN "förskingrare" utrum  ; -- förskingrare..nn.1
  förskingring_1_N = mkN "förskingring" ; -- förskingring..nn.1
  förskinn_1_N = mkN "förskinn" neutrum  ; -- förskinn..nn.1
  förskjuta_1_V = mkV "förskjuta" "försköt" "förskjutit" ; -- förskjuta..vb.1
  förskjutande_1_N = mkN "förskjutande" ; -- förskjutande..nn.1
  förskjutning_1_N = mkN "förskjutning" ; -- förskjutning..nn.1
  förskola_1_N = mkN "förskola" ; -- förskola..nn.1
  förskolebarn_1_N = mkN "förskolebarn" neutrum  ; -- förskolebarn..nn.1
  förskolechef_1_N = mkN "förskolechef" "förskolechefer" ; -- förskolechef..nn.1
  förskolelärare_1_N = mkN "förskolelärare" utrum  ; -- förskolelärare..nn.1
  förskoleplats_1_N = mkN "förskoleplats" "förskoleplatser" ; -- förskoleplats..nn.1
  förskoleålder_1_N = mkN "förskoleålder" ; -- förskoleålder..nn.1
  förskollärare_1_N = mkN "förskollärare" utrum  ; -- förskollärare..nn.1
  förskona_1_V = mkV "förskonar" ; -- förskona..vb.1
  förskonande_1_N = mkN "förskonande" ; -- förskonande..nn.1
  förskoning_1_N = mkN "förskoning" ; -- förskoning..nn.1
  förskott_1_N = mkN "förskott" neutrum  ; -- förskott..nn.1
  förskottera_1_V = mkV "förskotterar" ; -- förskottera..vb.1
  förskotterande_1_N = mkN "förskotterande" ; -- förskotterande..nn.1
  förskotterbar_1_A = mkA "förskotterbar" ; -- förskotterbar..av.1
  förskotterbarhet_1_N = mkN "förskotterbarhet" ; -- förskotterbarhet..nn.1
  förskottering_1_N = mkN "förskottering" ; -- förskottering..nn.1
  förskriva_1_V = mkV "förskriva" "förskrev" "förskrivit" ; -- förskriva..vb.1
  förskrivande_1_N = mkN "förskrivande" ; -- förskrivande..nn.1
  förskrivning_1_N = mkN "förskrivning" ; -- förskrivning..nn.1
  förskräcka_1_V = mkV "förskräcker" ; -- förskräcka..vb.1
  förskräckande_1_N = mkN "förskräckande" ; -- förskräckande..nn.1
  förskräckelse_1_N = mkN "förskräckelse" "förskräckelser" ; -- förskräckelse..nn.1
  förskräcklig_1_A = mkA "förskräcklig" ; -- förskräcklig..av.1
  förskräcklighet_1_N = mkN "förskräcklighet" "förskräckligheter" ; -- förskräcklighet..nn.1
  förskräckt_1_A = mkA "förskräckt" "förskräckt" ; -- förskräckt..av.1
  förskräckthet_1_N = mkN "förskräckthet" ; -- förskräckthet..nn.1
  förskrämd_1_A = mkA "förskrämd" "förskrämt" ; -- förskrämd..av.1
  förskrämdhet_1_N = mkN "förskrämdhet" ; -- förskrämdhet..nn.1
  förskylla_1_V = mkV "förskyller" ; -- förskylla..vb.1
  förskyllande_1_N = mkN "förskyllande" ; -- förskyllande..nn.1
  förskämd_1_A = mkA "förskämd" "förskämt" ; -- förskämd..av.1
  förskämdhet_1_N = mkN "förskämdhet" ; -- förskämdhet..nn.1
  förskämning_1_N = mkN "förskämning" ; -- förskämning..nn.1
  förskära_1_V = mkV "förskära" "förskar" "förskurit" ; -- förskära..vb.1
  förskärande_1_N = mkN "förskärande" ; -- förskärande..nn.1
  förskärare_1_N = mkN "förskärare" utrum  ; -- förskärare..nn.1
  förskärargaffel_1_N = mkN "förskärargaffel" ; -- förskärargaffel..nn.1
  förskärarkniv_1_N = mkN "förskärarkniv" ; -- förskärarkniv..nn.1
  försköna_1_V = mkV "förskönar" ; -- försköna..vb.1
  förskönande_1_N = mkN "förskönande" ; -- förskönande..nn.1
  försköning_1_N = mkN "försköning" ; -- försköning..nn.1
  förslag_1_N = mkN "förslag" neutrum  ; -- förslag..nn.1
  förslag_2_1_N = mkN "förslag" neutrum  ; -- förslag_2..nn.1
  förslagen_1_A = mkA "förslagen" ; -- förslagen..av.1
  förslagenhet_1_N = mkN "förslagenhet" ; -- förslagenhet..nn.1
  förslagsrum_1_N = mkN "förslagsrum" "förslagsrummet" "förslagsrum" "förslagsrummen" ; -- förslagsrum..nn.1
  förslagsställare_1_N = mkN "förslagsställare" utrum  ; -- förslagsställare..nn.1
  förslagsvis_1_Adv = mkAdv "förslagsvis" ; -- förslagsvis..ab.1
  förslappa_1_V = mkV "förslappar" ; -- förslappa..vb.1
  förslappande_1_N = mkN "förslappande" ; -- förslappande..nn.1
  förslappning_1_N = mkN "förslappning" ; -- förslappning..nn.1
  förslava_1_V = mkV "förslavar" ; -- förslava..vb.1
  förslavande_1_N = mkN "förslavande" ; -- förslavande..nn.1
  förslavning_1_N = mkN "förslavning" ; -- förslavning..nn.1
  förslita_1_V = mkV "förslita" "förslet" "förslitit" ; -- förslita..vb.1
  förslitande_1_N = mkN "förslitande" ; -- förslitande..nn.1
  försliten_1_A = mkA "försliten" ; -- försliten..av.1
  förslitning_1_N = mkN "förslitning" ; -- förslitning..nn.1
  förslitningsskada_1_N = mkN "förslitningsskada" ; -- förslitningsskada..nn.1
  försluta_1_V = mkV "försluta" "förslöt" "förslutit" ; -- försluta..vb.1
  förslutande_1_N = mkN "förslutande" ; -- förslutande..nn.1
  förslutning_1_N = mkN "förslutning" ; -- förslutning..nn.1
  förslå_1_V = mkV "förslå" "förslog" "förslagit" ; -- förslå..vb.1
  förslående_1_N = mkN "förslående" ; -- förslående..nn.1
  förslöa_1_V = mkV "förslöar" ; -- förslöa..vb.1
  förslöande_1_N = mkN "förslöande" ; -- förslöande..nn.1
  förslösa_1_V = mkV "förslösar" ; -- förslösa..vb.1
  förslösande_1_N = mkN "förslösande" ; -- förslösande..nn.1
  förslösning_1_N = mkN "förslösning" ; -- förslösning..nn.1
  försmak_1_N = mkN "försmak" ; -- försmak..nn.1
  försmädlig_1_A = mkA "försmädlig" ; -- försmädlig..av.1
  försmädlighet_1_N = mkN "försmädlighet" ; -- försmädlighet..nn.1
  försmäkta_1_V = mkV "försmäktar" ; -- försmäkta..vb.1
  försmäktande_1_N = mkN "försmäktande" ; -- försmäktande..nn.1
  försmå_1_V = mkV "försmår" ; -- försmå..vb.1
  försmådd_1_A = mkA "försmådd" ; -- försmådd..av.1
  försmående_1_N = mkN "försmående" ; -- försmående..nn.1
  försnilla_1_V = mkV "försnillar" ; -- försnilla..vb.1
  försnillande_1_N = mkN "försnillande" ; -- försnillande..nn.1
  försnillning_1_N = mkN "försnillning" ; -- försnillning..nn.1
  försockring_1_N = mkN "försockring" ; -- försockring..nn.1
  försoffa_1_V = mkV "försoffar" ; -- försoffa..vb.1
  försoffande_1_N = mkN "försoffande" ; -- försoffande..nn.1
  försoffning_1_N = mkN "försoffning" ; -- försoffning..nn.1
  försommar_1_N = mkN "försommar" "försommaren" "försomrar" "försomrarna" ; -- försommar..nn.1
  försommarkväll_1_N = mkN "försommarkväll" ; -- försommarkväll..nn.1
  försona_1_V = mkV "försonar" ; -- försona..vb.1
  försonande_1_A = mkA "försonande" ; -- försonande..av.1
  försonande_1_N = mkN "försonande" ; -- försonande..nn.1
  försonare_1_N = mkN "försonare" utrum  ; -- försonare..nn.1
  försoning_1_N = mkN "försoning" ; -- försoning..nn.1
  försoningsdag_1_N = mkN "försoningsdag" ; -- försoningsdag..nn.1
  försoningsfest_1_N = mkN "försoningsfest" "försoningsfester" ; -- försoningsfest..nn.1
  försoningsgest_1_N = mkN "försoningsgest" "försoningsgester" ; -- försoningsgest..nn.1
  försoningsgärd_1_N = mkN "försoningsgärd" "försoningsgärder" ; -- försoningsgärd..nn.1
  försoningsgåva_1_N = mkN "försoningsgåva" ; -- försoningsgåva..nn.1
  försoningsknull_1_N = mkN "försoningsknull" neutrum  ; -- försoningsknull..nn.1
  försoningslära_1_N = mkN "försoningslära" ; -- försoningslära..nn.1
  försoningsoffer_1_N = mkN "försoningsoffer" neutrum  ; -- försoningsoffer..nn.1
  försonlig_1_A = mkA "försonlig" ; -- försonlig..av.1
  försonlighet_1_N = mkN "försonlighet" ; -- försonlighet..nn.1
  försorg_1_N = mkN "försorg" ; -- försorg..nn.1
  förspel_1_N = mkN "förspel" "förspelet" "förspel" "förspelen" ; -- förspel..nn.1
  förspilla_1_V = mkV "förspiller" ; -- förspilla..vb.1
  förspillande_1_N = mkN "förspillande" ; -- förspillande..nn.1
  försprång_1_N = mkN "försprång" neutrum  ; -- försprång..nn.1
  förspännande_1_N = mkN "förspännande" ; -- förspännande..nn.1
  förspänning_1_N = mkN "förspänning" ; -- förspänning..nn.1
  förspänning_2_N = mkN "förspänning" ; -- förspänning..nn.2
  förspörja_1_V = mkV "förspörja" "försporde" "försport" ; -- förspörja..vb.1
  förspörjande_1_N = mkN "förspörjande" ; -- förspörjande..nn.1
  förstad_1_N = mkN "förstad" "förstäder" ; -- förstad..nn.1
  förstadagsbrev_1_N = mkN "förstadagsbrev" neutrum  ; -- förstadagsbrev..nn.1
  förstadium_1_N = mkN "förstadium" "förstadiet" "förstadier" "förstadierna" ; -- förstadium..nn.1
  förstadsvilla_1_N = mkN "förstadsvilla" ; -- förstadsvilla..nn.1
  förstag_1_N = mkN "förstag" neutrum  ; -- förstag..nn.1
  förstagradsekvation_1_N = mkN "förstagradsekvation" ; -- förstagradsekvation..nn.1
  förstagångsbesökande_1_N = mkN "förstagångsbesökande" "förstagångsbesökanden" "förstagångsbesökanden" "förstagångsbesökandena" ; -- förstagångsbesökande..nn.1
  förstagångsköpare_1_N = mkN "förstagångsköpare" utrum  ; -- förstagångsköpare..nn.1
  förstagångsväljare_1_N = mkN "förstagångsväljare" utrum  ; -- förstagångsväljare..nn.1
  förstahandsalternativ_1_N = mkN "förstahandsalternativ" neutrum  ; -- förstahandsalternativ..nn.1
  förstahandserfarenhet_1_N = mkN "förstahandserfarenhet" "förstahandserfarenheter" ; -- förstahandserfarenhet..nn.1
  förstahandskälla_1_N = mkN "förstahandskälla" ; -- förstahandskälla..nn.1
  förstahandssökande_1_N = mkN "förstahandssökande" "förstahandssökanden" "förstahandssökanden" "förstahandssökandena" ; -- förstahandssökande..nn.1
  förstahandsuppgift_1_N = mkN "förstahandsuppgift" "förstahandsuppgifter" ; -- förstahandsuppgift..nn.1
  förstainstans_1_N = mkN "förstainstans" "förstainstanser" ; -- förstainstans..nn.1
  förstaklassbiljett_1_N = mkN "förstaklassbiljett" "förstaklassbiljetter" ; -- förstaklassbiljett..nn.1
  förstaklasshotell_1_N = mkN "förstaklasshotell" neutrum  ; -- förstaklasshotell..nn.1
  förstaklasshytt_1_N = mkN "förstaklasshytt" "förstaklasshytter" ; -- förstaklasshytt..nn.1
  förstamajblomma_1_N = mkN "förstamajblomma" ; -- förstamajblomma..nn.1
  förstamajtal_1_N = mkN "förstamajtal" neutrum  ; -- förstamajtal..nn.1
  förstamajtalare_1_N = mkN "förstamajtalare" utrum  ; -- förstamajtalare..nn.1
  förstamajtåg_1_N = mkN "förstamajtåg" neutrum  ; -- förstamajtåg..nn.1
  förstanamn_1_N = mkN "förstanamn" neutrum  ; -- förstanamn..nn.1
  förstaplats_1_N = mkN "förstaplats" "förstaplatser" ; -- förstaplats..nn.1
  förstaresa_1_N = mkN "förstaresa" ; -- förstaresa..nn.1
  förstaserve_1_N = mkN "förstaserve" utrum  ; -- förstaserve..nn.1
  förstasida_1_N = mkN "förstasida" ; -- förstasida..nn.1
  förstaslag_1_N = mkN "förstaslag" neutrum  ; -- förstaslag..nn.1
  förstaslagsförmåga_1_N = mkN "förstaslagsförmåga" ; -- förstaslagsförmåga..nn.1
  förstatliga_1_V = mkV "förstatligar" ; -- förstatliga..vb.1
  förstatligande_1_N = mkN "förstatligande" ; -- förstatligande..nn.1
  förstaupplaga_1_N = mkN "förstaupplaga" ; -- förstaupplaga..nn.1
  förstavelse_1_N = mkN "förstavelse" "förstavelser" ; -- förstavelse..nn.1
  förstaårsstudent_1_N = mkN "förstaårsstudent" "förstaårsstudenter" ; -- förstaårsstudent..nn.1
  förstbemälde_1_A = mkA "förstbemälde" ; -- förstbemälde..av.1
  försteg_1_N = mkN "försteg" neutrum  ; -- försteg..nn.1
  förstelna_1_V = mkV "förstelnar" ; -- förstelna..vb.1
  förstelnande_1_N = mkN "förstelnande" ; -- förstelnande..nn.1
  förstelning_1_N = mkN "förstelning" ; -- förstelning..nn.1
  försten_1_N = mkN "försten" ; -- försten..nn.1
  förstena_1_V = mkV "förstenar" ; -- förstena..vb.1
  förstenande_1_N = mkN "förstenande" ; -- förstenande..nn.1
  förstening_1_N = mkN "förstening" ; -- förstening..nn.1
  förstfödd_1_A = mkA "förstfödd" ; -- förstfödd..av.1
  förstföderska_1_N = mkN "förstföderska" ; -- förstföderska..nn.1
  förstfödslorätt_1_N = mkN "förstfödslorätt" ; -- förstfödslorätt..nn.1
  förstklassig_1_A = mkA "förstklassig" ; -- förstklassig..av.1
  förstklassighet_1_N = mkN "förstklassighet" ; -- förstklassighet..nn.1
  förstling_1_N = mkN "förstling" ; -- förstling..nn.1
  förstlingsarbete_1_N = mkN "förstlingsarbete" ; -- förstlingsarbete..nn.1
  förstnämnd_1_A = mkA "förstnämnd" ; -- förstnämnd..av.1
  förstocka_1_V = mkV "förstockar" ; -- förstocka..vb.1
  förstockad_1_A = mkA "förstockad" ; -- förstockad..av.1
  förstockande_1_N = mkN "förstockande" ; -- förstockande..nn.1
  förstockelse_1_N = mkN "förstockelse" utrum  ; -- förstockelse..nn.1
  förstoppa_1_V = mkV "förstoppar" ; -- förstoppa..vb.1
  förstoppande_1_N = mkN "förstoppande" ; -- förstoppande..nn.1
  förstoppning_1_N = mkN "förstoppning" ; -- förstoppning..nn.1
  förstoppningsbesvär_1_N = mkN "förstoppningsbesvär" neutrum  ; -- förstoppningsbesvär..nn.1
  förstora_1_V = mkV "förstorar" ; -- förstora..vb.1
  förstorande_1_N = mkN "förstorande" ; -- förstorande..nn.1
  förstoring_1_N = mkN "förstoring" ; -- förstoring..nn.1
  förstoringsapparat_1_N = mkN "förstoringsapparat" "förstoringsapparater" ; -- förstoringsapparat..nn.1
  förstoringsglas_1_N = mkN "förstoringsglas" neutrum  ; -- förstoringsglas..nn.1
  försträcka_1_V = mkV "försträcker" ; -- försträcka..vb.1
  försträckande_1_N = mkN "försträckande" ; -- försträckande..nn.1
  försträckning_1_N = mkN "försträckning" ; -- försträckning..nn.1
  försträva_1_V = mkV "försträvar" ; -- försträva..vb.1
  försträvande_1_N = mkN "försträvande" ; -- försträvande..nn.1
  förströ_1_V = mkV "förströr" ; -- förströ..vb.1
  förströdd_1_A = mkA "förströdd" ; -- förströdd..av.1
  förströddhet_1_N = mkN "förströddhet" ; -- förströddhet..nn.1
  förströelse_1_N = mkN "förströelse" "förströelser" ; -- förströelse..nn.1
  förströelselektyr_1_N = mkN "förströelselektyr" ; -- förströelselektyr..nn.1
  förströelselitteratur_1_N = mkN "förströelselitteratur" "förströelselitteraturer" ; -- förströelselitteratur..nn.1
  förströende_1_N = mkN "förströende" ; -- förströende..nn.1
  förstubro_1_N = mkN "förstubro" ; -- förstubro..nn.1
  förstucken_1_A = mkA "förstucken" ; -- förstucken..av.1
  förstuckenhet_1_N = mkN "förstuckenhet" ; -- förstuckenhet..nn.1
  förstudie_1_N = mkN "förstudie" "förstudier" ; -- förstudie..nn.1
  förstuga_1_N = mkN "förstuga" ; -- förstuga..nn.1
  förstugubro_1_N = mkN "förstugubro" ; -- förstugubro..nn.1
  förstugukvist_1_N = mkN "förstugukvist" ; -- förstugukvist..nn.1
  förstukvist_1_N = mkN "förstukvist" ; -- förstukvist..nn.1
  förstulen_1_A = mkA "förstulen" ; -- förstulen..av.1
  förstulenhet_1_N = mkN "förstulenhet" ; -- förstulenhet..nn.1
  förstumma_1_V = mkV "förstummar" ; -- förstumma..vb.1
  förstummande_1_N = mkN "förstummande" ; -- förstummande..nn.1
  förställa_1_V = mkV "förställer" ; -- förställa..vb.1
  förställande_1_N = mkN "förställande" ; -- förställande..nn.1
  förställning_1_N = mkN "förställning" ; -- förställning..nn.1
  förstämd_1_A = mkA "förstämd" "förstämt" ; -- förstämd..av.1
  förstämdhet_1_N = mkN "förstämdhet" ; -- förstämdhet..nn.1
  förstämma_1_V = mkV "förstämmer" ; -- förstämma..vb.1
  förstämmande_1_N = mkN "förstämmande" ; -- förstämmande..nn.1
  förstämning_1_N = mkN "förstämning" ; -- förstämning..nn.1
  förständiga_1_V = mkV "förständigar" ; -- förständiga..vb.1
  förständigande_1_N = mkN "förständigande" ; -- förständigande..nn.1
  förstärka_1_V = mkV "förstärker" ; -- förstärka..vb.1
  förstärkande_1_N = mkN "förstärkande" ; -- förstärkande..nn.1
  förstärkare_1_N = mkN "förstärkare" utrum  ; -- förstärkare..nn.1
  förstärkning_1_N = mkN "förstärkning" ; -- förstärkning..nn.1
  förstärkningsord_1_N = mkN "förstärkningsord" neutrum  ; -- förstärkningsord..nn.1
  förstäv_1_N = mkN "förstäv" ; -- förstäv..nn.1
  förstå_1_V = mkV "förstå" "förstod" "förstått" ; -- förstå..vb.1
  förstådd_1_A = mkA "förstådd" ; -- förstådd..av.1
  förståelig_1_A = mkA "förståelig" ; -- förståelig..av.1
  förståelighet_1_N = mkN "förståelighet" ; -- förståelighet..nn.1
  förståelse_1_N = mkN "förståelse" utrum  ; -- förståelse..nn.1
  förståelseram_1_N = mkN "förståelseram" ; -- förståelseram..nn.1
  förstående_1_A = mkA "förstående" ; -- förstående..av.1
  förstående_1_N = mkN "förstående" ; -- förstående..nn.1
  förstånd_1_N = mkN "förstånd" neutrum  ; -- förstånd..nn.1
  förståndig_1_A = mkA "förståndig" ; -- förståndig..av.1
  förståndighet_1_N = mkN "förståndighet" ; -- förståndighet..nn.1
  förståndshandikapp_1_N = mkN "förståndshandikapp" neutrum  ; -- förståndshandikapp..nn.1
  förståndshandikappad_1_A = mkA "förståndshandikappad" ; -- förståndshandikappad..av.1
  förståndsmässig_1_A = mkA "förståndsmässig" ; -- förståndsmässig..av.1
  förståndsutveckling_1_N = mkN "förståndsutveckling" ; -- förståndsutveckling..nn.1
  förstång_1_N = mkN "förstång" "förstänger" ; -- förstång..nn.1
  förstås_1_Adv = mkAdv "förstås" ; -- förstås..ab.1
  förståsigpåare_1_N = mkN "förståsigpåare" utrum  ; -- förståsigpåare..nn.1
  förstöra_1_V = mkV "förstöra" "förstörde" "förstört" ; -- förstöra..vb.1
  förstörande_1_N = mkN "förstörande" ; -- förstörande..nn.1
  förstörare_1_N = mkN "förstörare" utrum  ; -- förstörare..nn.1
  förstörd_1_A = mkA "förstörd" "förstört" ; -- förstörd..av.1
  förstördhet_1_N = mkN "förstördhet" ; -- förstördhet..nn.1
  förstörelse_1_N = mkN "förstörelse" "förstörelser" ; -- förstörelse..nn.1
  förstörelselusta_1_N = mkN "förstörelselusta" ; -- förstörelselusta..nn.1
  förstörelsevapen_1_N = mkN "förstörelsevapen" "förstörelsevapnet" "förstörelsevapen" "förstörelsevapnen" ; -- förstörelsevapen..nn.1
  förstörelseverk_1_N = mkN "förstörelseverk" neutrum  ; -- förstörelseverk..nn.1
  förstöring_1_N = mkN "förstöring" ; -- förstöring..nn.1
  försumbar_1_A = mkA "försumbar" ; -- försumbar..av.1
  försumbarhet_1_N = mkN "försumbarhet" ; -- försumbarhet..nn.1
  försumlig_1_A = mkA "försumlig" ; -- försumlig..av.1
  försumlighet_1_N = mkN "försumlighet" "försumligheter" ; -- försumlighet..nn.1
  försumma_1_V = mkV "försummar" ; -- försumma..vb.1
  försummande_1_N = mkN "försummande" ; -- försummande..nn.1
  försummelse_1_N = mkN "försummelse" "försummelser" ; -- försummelse..nn.1
  försumpning_1_N = mkN "försumpning" ; -- försumpning..nn.1
  försupen_1_A = mkA "försupen" ; -- försupen..av.1
  försupenhet_1_N = mkN "försupenhet" ; -- försupenhet..nn.1
  försura_1_V = mkV "försurar" ; -- försura..vb.1
  försurande_1_N = mkN "försurande" ; -- försurande..nn.1
  försurning_1_N = mkN "försurning" ; -- försurning..nn.1
  försutten_1_A = mkA "försutten" ; -- försutten..av.1
  försvaga_1_V = mkV "försvagar" ; -- försvaga..vb.1
  försvagande_1_N = mkN "försvagande" ; -- försvagande..nn.1
  försvagning_1_N = mkN "försvagning" ; -- försvagning..nn.1
  försvar_1_N = mkN "försvar" neutrum  ; -- försvar..nn.1
  försvara_1_V = mkV "försvarar" ; -- försvara..vb.1
  försvarande_1_N = mkN "försvarande" ; -- försvarande..nn.1
  försvarare_1_N = mkN "försvarare" utrum  ; -- försvarare..nn.1
  försvarbar_1_A = mkA "försvarbar" ; -- försvarbar..av.1
  försvarbarhet_1_N = mkN "försvarbarhet" ; -- försvarbarhet..nn.1
  försvarlig_1_A = mkA "försvarlig" ; -- försvarlig..av.1
  försvarlighet_1_N = mkN "försvarlighet" ; -- försvarlighet..nn.1
  försvarsadvokat_1_N = mkN "försvarsadvokat" "försvarsadvokater" ; -- försvarsadvokat..nn.1
  försvarsallians_1_N = mkN "försvarsallians" "försvarsallianser" ; -- försvarsallians..nn.1
  försvarsanläggning_1_N = mkN "försvarsanläggning" ; -- försvarsanläggning..nn.1
  försvarsattaché_1_N = mkN "försvarsattaché" "försvarsattachéer" ; -- försvarsattaché..nn.1
  försvarsberedskap_1_N = mkN "försvarsberedskap" ; -- försvarsberedskap..nn.1
  försvarsbeslut_1_N = mkN "försvarsbeslut" neutrum  ; -- försvarsbeslut..nn.1
  försvarsdator_1_N = mkN "försvarsdator" "försvarsdatorer" ; -- försvarsdator..nn.1
  försvarsdepartement_1_N = mkN "försvarsdepartement" neutrum  ; -- försvarsdepartement..nn.1
  försvarsduglig_1_A = mkA "försvarsduglig" ; -- försvarsduglig..av.1
  försvarsfunktion_1_N = mkN "försvarsfunktion" ; -- försvarsfunktion..nn.1
  försvarsgren_1_N = mkN "försvarsgren" "försvarsgrenen" "försvarsgrenar" "försvarsgrenarna" ; -- försvarsgren..nn.1
  försvarsgrenschef_1_N = mkN "försvarsgrenschef" "försvarsgrenschefer" ; -- försvarsgrenschef..nn.1
  försvarshemlighet_1_N = mkN "försvarshemlighet" "försvarshemligheter" ; -- försvarshemlighet..nn.1
  försvarshögskola_1_N = mkN "försvarshögskola" ; -- försvarshögskola..nn.1
  försvarsinlaga_1_N = mkN "försvarsinlaga" ; -- försvarsinlaga..nn.1
  försvarskostnad_1_N = mkN "försvarskostnad" "försvarskostnader" ; -- försvarskostnad..nn.1
  försvarskraft_1_N = mkN "försvarskraft" "försvarskrafter" ; -- försvarskraft..nn.1
  försvarskrig_1_N = mkN "försvarskrig" neutrum  ; -- försvarskrig..nn.1
  försvarslinje_1_N = mkN "försvarslinje" "försvarslinjer" ; -- försvarslinje..nn.1
  försvarslös_1_A = mkA "försvarslös" ; -- försvarslös..av.1
  försvarslöshet_1_N = mkN "försvarslöshet" ; -- försvarslöshet..nn.1
  försvarsmakt_1_N = mkN "försvarsmakt" ; -- försvarsmakt..nn.1
  försvarsmekanism_1_N = mkN "försvarsmekanism" "försvarsmekanismer" ; -- försvarsmekanism..nn.1
  försvarsminister_1_N = mkN "försvarsminister" ; -- försvarsminister..nn.1
  försvarsmässig_1_A = mkA "försvarsmässig" ; -- försvarsmässig..av.1
  försvarsnedläggning_1_N = mkN "försvarsnedläggning" ; -- försvarsnedläggning..nn.1
  försvarsnedskärning_1_N = mkN "försvarsnedskärning" ; -- försvarsnedskärning..nn.1
  försvarsområde_1_N = mkN "försvarsområde" ; -- försvarsområde..nn.1
  försvarsplanering_1_N = mkN "försvarsplanering" ; -- försvarsplanering..nn.1
  försvarspolitik_1_N = mkN "försvarspolitik" ; -- försvarspolitik..nn.1
  försvarspolitisk_1_A = mkA "försvarspolitisk" ; -- försvarspolitisk..av.1
  försvarsraster_1_N = mkN "försvarsraster" neutrum  ; -- försvarsraster..nn.1
  försvarsskrift_1_N = mkN "försvarsskrift" "försvarsskrifter" ; -- försvarsskrift..nn.1
  försvarsspel_1_N = mkN "försvarsspel" "försvarsspelet" "försvarsspel" "försvarsspelen" ; -- försvarsspel..nn.1
  försvarsspelare_1_N = mkN "försvarsspelare" utrum  ; -- försvarsspelare..nn.1
  försvarsstab_1_N = mkN "försvarsstab" "försvarsstaber" ; -- försvarsstab..nn.1
  försvarsstrategi_1_N = mkN "försvarsstrategi" "försvarsstrategier" ; -- försvarsstrategi..nn.1
  försvarsställning_1_N = mkN "försvarsställning" ; -- försvarsställning..nn.1
  försvarstal_1_N = mkN "försvarstal" neutrum  ; -- försvarstal..nn.1
  försvarstänkande_1_N = mkN "försvarstänkande" ; -- försvarstänkande..nn.1
  försvarsutskott_1_N = mkN "försvarsutskott" neutrum  ; -- försvarsutskott..nn.1
  försvarsvapen_1_N = mkN "försvarsvapen" "försvarsvapnet" "försvarsvapen" "försvarsvapnen" ; -- försvarsvapen..nn.1
  försvarsverk_1_N = mkN "försvarsverk" neutrum  ; -- försvarsverk..nn.1
  försvarsväsen_1_N = mkN "försvarsväsen" neutrum  ; -- försvarsväsen..nn.1
  försvarsåtagande_1_N = mkN "försvarsåtagande" ; -- försvarsåtagande..nn.1
  försvenska_1_V = mkV "försvenskar" ; -- försvenska..vb.1
  försvenskande_1_N = mkN "försvenskande" ; -- försvenskande..nn.1
  försvinna_1_V = mkV "försvinna" "försvann" "försvunnit" ; -- försvinna..vb.1
  försvinnande_1_N = mkN "försvinnande" ; -- försvinnande..nn.1
  försvurenhet_1_N = mkN "försvurenhet" ; -- försvurenhet..nn.1
  försvärja_1_V = mkV "försvära" "försvär" "försvärj" "försvärjde" "försvärjt" "försvuren" ; -- försvärja..vb.1
  försvärjande_1_N = mkN "försvärjande" ; -- försvärjande..nn.1
  försvåra_1_V = mkV "försvårar" ; -- försvåra..vb.1
  försvårande_1_A = mkA "försvårande" ; -- försvårande..av.1
  försvårande_1_N = mkN "försvårande" ; -- försvårande..nn.1
  försyn_1_N = mkN "försyn" ; -- försyn..nn.1
  försyndelse_1_N = mkN "försyndelse" "försyndelser" ; -- försyndelse..nn.1
  försynt_1_A = mkA "försynt" "försynt" ; -- försynt..av.1
  försynthet_1_N = mkN "försynthet" ; -- försynthet..nn.1
  försägning_1_N = mkN "försägning" ; -- försägning..nn.1
  försäkra_1_V = mkV "försäkrar" ; -- försäkra..vb.1
  försäkran_1_N = mkN "försäkran" "försäkran" "försäkringar" "försäkringarna" ; -- försäkran..nn.1
  försäkrande_1_N = mkN "försäkrande" ; -- försäkrande..nn.1
  försäkring_1_N = mkN "försäkring" ; -- försäkring..nn.1
  försäkringsagent_1_N = mkN "försäkringsagent" "försäkringsagenter" ; -- försäkringsagent..nn.1
  försäkringsbedrägeri_1_N = mkN "försäkringsbedrägeri" "försäkringsbedrägeriet" "försäkringsbedrägerier" "försäkringsbedrägerierna" ; -- försäkringsbedrägeri..nn.1
  försäkringsbelopp_1_N = mkN "försäkringsbelopp" neutrum  ; -- försäkringsbelopp..nn.1
  försäkringsbesked_1_N = mkN "försäkringsbesked" neutrum  ; -- försäkringsbesked..nn.1
  försäkringsbolag_1_N = mkN "försäkringsbolag" neutrum  ; -- försäkringsbolag..nn.1
  försäkringsbolagskontor_1_N = mkN "försäkringsbolagskontor" neutrum  ; -- försäkringsbolagskontor..nn.1
  försäkringsbolagskontorist_1_N = mkN "försäkringsbolagskontorist" "försäkringsbolagskontorister" ; -- försäkringsbolagskontorist..nn.1
  försäkringsbransch_1_N = mkN "försäkringsbransch" ; -- försäkringsbransch..nn.1
  försäkringsbrev_1_N = mkN "försäkringsbrev" neutrum  ; -- försäkringsbrev..nn.1
  försäkringsfråga_1_N = mkN "försäkringsfråga" ; -- försäkringsfråga..nn.1
  försäkringsgivare_1_N = mkN "försäkringsgivare" utrum  ; -- försäkringsgivare..nn.1
  försäkringsinslag_1_N = mkN "försäkringsinslag" neutrum  ; -- försäkringsinslag..nn.1
  försäkringskassa_1_N = mkN "försäkringskassa" ; -- försäkringskassa..nn.1
  försäkringsmarknad_1_N = mkN "försäkringsmarknad" "försäkringsmarknader" ; -- försäkringsmarknad..nn.1
  försäkringsmässig_1_A = mkA "försäkringsmässig" ; -- försäkringsmässig..av.1
  försäkringspeng_1_N = mkN "försäkringspeng" ; -- försäkringspeng..nn.1
  försäkringspolis_1_N = mkN "försäkringspolis" "försäkringspoliser" ; -- försäkringspolis..nn.1
  försäkringspremie_1_N = mkN "försäkringspremie" "försäkringspremier" ; -- försäkringspremie..nn.1
  försäkringsskada_1_N = mkN "försäkringsskada" ; -- försäkringsskada..nn.1
  försäkringsskydd_1_N = mkN "försäkringsskydd" neutrum  ; -- försäkringsskydd..nn.1
  försäkringssystem_1_N = mkN "försäkringssystem" neutrum  ; -- försäkringssystem..nn.1
  försäkringstagare_1_N = mkN "försäkringstagare" utrum  ; -- försäkringstagare..nn.1
  försäkringsvillkor_1_N = mkN "försäkringsvillkor" neutrum  ; -- försäkringsvillkor..nn.1
  försäkringsvärde_1_N = mkN "försäkringsvärde" ; -- försäkringsvärde..nn.1
  försälja_1_V = mkV "försälja" "försålde" "försålt" ; -- försälja..vb.1
  försäljande_1_N = mkN "försäljande" ; -- försäljande..nn.1
  försäljare_1_N = mkN "försäljare" utrum  ; -- försäljare..nn.1
  försäljerska_1_N = mkN "försäljerska" ; -- försäljerska..nn.1
  försäljning_1_N = mkN "försäljning" ; -- försäljning..nn.1
  försäljningsbransch_1_N = mkN "försäljningsbransch" "försäljningsbranscher" ; -- försäljningsbransch..nn.1
  försäljningschef_1_N = mkN "försäljningschef" "försäljningschefer" ; -- försäljningschef..nn.1
  försäljningsdag_1_N = mkN "försäljningsdag" ; -- försäljningsdag..nn.1
  försäljningsdisk_1_N = mkN "försäljningsdisk" ; -- försäljningsdisk..nn.1
  försäljningsled_1_N = mkN "försäljningsled" neutrum  ; -- försäljningsled..nn.1
  försäljningsmässig_1_A = mkA "försäljningsmässig" ; -- försäljningsmässig..av.1
  försäljningsort_1_N = mkN "försäljningsort" "försäljningsorter" ; -- försäljningsort..nn.1
  försäljningspris_1_N = mkN "försäljningspris" neutrum  ; -- försäljningspris..nn.1
  försäljningsstopp_1_N = mkN "försäljningsstopp" neutrum  ; -- försäljningsstopp..nn.1
  försäljningsstånd_1_N = mkN "försäljningsstånd" neutrum  ; -- försäljningsstånd..nn.1
  försäljningssuccé_1_N = mkN "försäljningssuccé" "försäljningssuccéer" ; -- försäljningssuccé..nn.1
  försäljningsvana_1_N = mkN "försäljningsvana" ; -- försäljningsvana..nn.1
  försäljningsvinst_1_N = mkN "försäljningsvinst" "försäljningsvinster" ; -- försäljningsvinst..nn.1
  försäljningsvolym_1_N = mkN "försäljningsvolym" "försäljningsvolymer" ; -- försäljningsvolym..nn.1
  försämra_1_V = mkV "försämrar" ; -- försämra..vb.1
  försämrande_1_N = mkN "försämrande" ; -- försämrande..nn.1
  försämring_1_N = mkN "försämring" ; -- försämring..nn.1
  försända_1_V = mkV "försänder" ; -- försända..vb.1
  försändande_1_N = mkN "försändande" ; -- försändande..nn.1
  försändelse_1_N = mkN "försändelse" "försändelser" ; -- försändelse..nn.1
  försändning_1_N = mkN "försändning" ; -- försändning..nn.1
  försänka_1_V = mkV "försänker" ; -- försänka..vb.1
  försänkande_1_N = mkN "försänkande" ; -- försänkande..nn.1
  försänkare_1_N = mkN "försänkare" utrum  ; -- försänkare..nn.1
  försänkning_1_N = mkN "försänkning" ; -- försänkning..nn.1
  försätta_1_V = mkV "försätta" "försätter" "försätt" "försatte" "försatt" "försatt" ; -- försätta..vb.1
  försättande_1_N = mkN "försättande" ; -- försättande..nn.1
  försättning_1_N = mkN "försättning" ; -- försättning..nn.1
  försättsblad_1_N = mkN "försättsblad" neutrum  ; -- försättsblad..nn.1
  försättslins_1_N = mkN "försättslins" "försättslinser" ; -- försättslins..nn.1
  försåpning_1_N = mkN "försåpning" ; -- försåpning..nn.1
  försåt_1_N = mkN "försåt" neutrum  ; -- försåt..nn.1
  försåtlig_1_A = mkA "försåtlig" ; -- försåtlig..av.1
  försåtlighet_1_N = mkN "försåtlighet" "försåtligheter" ; -- försåtlighet..nn.1
  försök_1_N = mkN "försök" neutrum  ; -- försök..nn.1
  försöka_1_V = mkV "försöker" ; -- försöka..vb.1
  försökande_1_N = mkN "försökande" ; -- försökande..nn.1
  försöksballong_1_N = mkN "försöksballong" "försöksballonger" ; -- försöksballong..nn.1
  försöksdamm_1_N = mkN "försöksdamm" ; -- försöksdamm..nn.1
  försöksdjur_1_N = mkN "försöksdjur" neutrum  ; -- försöksdjur..nn.1
  försöksgymnasium_1_N = mkN "försöksgymnasium" "försöksgymnasiet" "försöksgymnasier" "försöksgymnasierna" ; -- försöksgymnasium..nn.1
  försöksheat_1_N = mkN "försöksheat" neutrum  ; -- försöksheat..nn.1
  försökskanin_1_N = mkN "försökskanin" "försökskaniner" ; -- försökskanin..nn.1
  försöksledare_1_N = mkN "försöksledare" utrum  ; -- försöksledare..nn.1
  försöksmetod_1_N = mkN "försöksmetod" "försöksmetoder" ; -- försöksmetod..nn.1
  försöksobjekt_1_N = mkN "försöksobjekt" neutrum  ; -- försöksobjekt..nn.1
  försöksperson_1_N = mkN "försöksperson" "försökspersoner" ; -- försöksperson..nn.1
  försöksverksamhet_1_N = mkN "försöksverksamhet" "försöksverksamheter" ; -- försöksverksamhet..nn.1
  försöksvis_1_Adv = mkAdv "försöksvis" ; -- försöksvis..ab.1
  försörja_1_V = mkV "försörja" "försörjde" "försörjt" ; -- försörja..vb.1
  försörjande_1_N = mkN "försörjande" ; -- försörjande..nn.1
  försörjare_1_N = mkN "försörjare" utrum  ; -- försörjare..nn.1
  försörjning_1_N = mkN "försörjning" ; -- försörjning..nn.1
  försörjningsanstalt_1_N = mkN "försörjningsanstalt" "försörjningsanstalter" ; -- försörjningsanstalt..nn.1
  försörjningsbalans_1_N = mkN "försörjningsbalans" ; -- försörjningsbalans..nn.1
  försörjningsbörda_1_N = mkN "försörjningsbörda" ; -- försörjningsbörda..nn.1
  försörjningsinrättning_1_N = mkN "försörjningsinrättning" ; -- försörjningsinrättning..nn.1
  försörjningsläge_1_N = mkN "försörjningsläge" ; -- försörjningsläge..nn.1
  försörjningsmässig_1_A = mkA "försörjningsmässig" ; -- försörjningsmässig..av.1
  försörjningspolitik_1_N = mkN "försörjningspolitik" ; -- försörjningspolitik..nn.1
  försörjningspolitisk_1_A = mkA "försörjningspolitisk" ; -- försörjningspolitisk..av.1
  försörjningsprojekt_1_N = mkN "försörjningsprojekt" neutrum  ; -- försörjningsprojekt..nn.1
  försörjningsskyldighet_1_N = mkN "försörjningsskyldighet" "försörjningsskyldigheter" ; -- försörjningsskyldighet..nn.1
  försörjningsstöd_1_N = mkN "försörjningsstöd" neutrum  ; -- försörjningsstöd..nn.1
  förta_1_V = mkV "förtaga" "förtog" "förtagit" ; -- förta..vb.1
  förtagande_1_N = mkN "förtagande" ; -- förtagande..nn.1
  förtal_1_N = mkN "förtal" neutrum  ; -- förtal..nn.1
  förtala_1_V = mkV "förtalar" ; -- förtala..vb.1
  förtalande_1_N = mkN "förtalande" ; -- förtalande..nn.1
  förtalare_1_N = mkN "förtalare" utrum  ; -- förtalare..nn.1
  förtalskampanj_1_N = mkN "förtalskampanj" "förtalskampanjer" ; -- förtalskampanj..nn.1
  förtalsmål_1_N = mkN "förtalsmål" neutrum  ; -- förtalsmål..nn.1
  förtappad_1_A = mkA "förtappad" ; -- förtappad..av.1
  förtappelse_1_N = mkN "förtappelse" utrum  ; -- förtappelse..nn.1
  förtecken_1_N = mkN "förtecken" "förtecknet" "förtecken" "förtecknen" ; -- förtecken..nn.1
  förteckna_1_V = mkV "förtecknar" ; -- förteckna..vb.1
  förtecknande_1_N = mkN "förtecknande" ; -- förtecknande..nn.1
  förteckning_1_N = mkN "förteckning" ; -- förteckning..nn.1
  förtegen_1_A = mkA "förtegen" ; -- förtegen..av.1
  förtegenhet_1_N = mkN "förtegenhet" ; -- förtegenhet..nn.1
  förteknisk_1_A = mkA "förteknisk" ; -- förteknisk..av.1
  förtenna_1_V = mkV "förtennar" ; -- förtenna..vb.1
  förtennande_1_N = mkN "förtennande" ; -- förtennande..nn.1
  förtenning_1_N = mkN "förtenning" ; -- förtenning..nn.1
  förtent_1_A = mkA "förtent" "förtent" ; -- förtent..av.1
  förtida_1_A = mkA "förtida" ; -- förtida..av.1
  förtidig_1_A = mkA "förtidig" ; -- förtidig..av.1
  förtidsbörd_1_N = mkN "förtidsbörd" "förtidsbörder" ; -- förtidsbörd..nn.1
  förtidspension_1_N = mkN "förtidspension" ; -- förtidspension..nn.1
  förtidspensionera_1_V = mkV "förtidspensionerar" ; -- förtidspensionera..vb.1
  förtidspensionerande_1_N = mkN "förtidspensionerande" ; -- förtidspensionerande..nn.1
  förtidspensionerbar_1_A = mkA "förtidspensionerbar" ; -- förtidspensionerbar..av.1
  förtidspensionerbarhet_1_N = mkN "förtidspensionerbarhet" ; -- förtidspensionerbarhet..nn.1
  förtidspensionering_1_N = mkN "förtidspensionering" ; -- förtidspensionering..nn.1
  förtidsrösta_1_V = mkV "förtidsröstar" ; -- förtidsrösta..vb.1
  förtidsröstande_1_N = mkN "förtidsröstande" ; -- förtidsröstande..nn.1
  förtidsröstning_1_N = mkN "förtidsröstning" ; -- förtidsröstning..nn.1
  förtiga_1_V = mkV "förtiga" "förteg" "förtigit" ; -- förtiga..vb.1
  förtigande_1_N = mkN "förtigande" ; -- förtigande..nn.1
  förtimring_1_N = mkN "förtimring" ; -- förtimring..nn.1
  förtingligande_1_N = mkN "förtingligande" ; -- förtingligande..nn.1
  förtjocka_1_V = mkV "förtjockar" ; -- förtjocka..vb.1
  förtjockande_1_N = mkN "förtjockande" ; -- förtjockande..nn.1
  förtjocknad_1_A = mkA "förtjocknad" ; -- förtjocknad..av.1
  förtjockning_1_N = mkN "förtjockning" ; -- förtjockning..nn.1
  förtjusa_1_V = mkV "förtjuser" ; -- förtjusa..vb.1
  förtjusande_1_A = mkA "förtjusande" ; -- förtjusande..av.1
  förtjusande_1_N = mkN "förtjusande" ; -- förtjusande..nn.1
  förtjusare_1_N = mkN "förtjusare" utrum  ; -- förtjusare..nn.1
  förtjusning_1_N = mkN "förtjusning" ; -- förtjusning..nn.1
  förtjust_1_A = mkA "förtjust" "förtjust" ; -- förtjust..av.1
  förtjäna_1_V = mkV "förtjänar" ; -- förtjäna..vb.1
  förtjänande_1_N = mkN "förtjänande" ; -- förtjänande..nn.1
  förtjänst_1_N = mkN "förtjänst" "förtjänster" ; -- förtjänst..nn.1
  förtjänstfull_1_A = mkA "förtjänstfull" ; -- förtjänstfull..av.1
  förtjänstfullhet_1_N = mkN "förtjänstfullhet" ; -- förtjänstfullhet..nn.1
  förtjänsttecken_1_N = mkN "förtjänsttecken" "förtjänsttecknet" "förtjänsttecken" "förtjänsttecknen" ; -- förtjänsttecken..nn.1
  förtjänt_1_A = mkA "förtjänt" "förtjänt" ; -- förtjänt..av.1
  förtona_1_V = mkV "förtonar" ; -- förtona..vb.1
  förtonande_1_N = mkN "förtonande" ; -- förtonande..nn.1
  förtoning_1_N = mkN "förtoning" ; -- förtoning..nn.1
  förtorka_1_V = mkV "förtorkar" ; -- förtorka..vb.1
  förtorkande_1_N = mkN "förtorkande" ; -- förtorkande..nn.1
  förtorkning_1_N = mkN "förtorkning" ; -- förtorkning..nn.1
  förtrampa_1_V = mkV "förtrampar" ; -- förtrampa..vb.1
  förtrampande_1_N = mkN "förtrampande" ; -- förtrampande..nn.1
  förtrampning_1_N = mkN "förtrampning" ; -- förtrampning..nn.1
  förtret_1_N = mkN "förtret" ; -- förtret..nn.1
  förtreta_1_V = mkV "förtretar" ; -- förtreta..vb.1
  förtretande_1_N = mkN "förtretande" ; -- förtretande..nn.1
  förtretlig_1_A = mkA "förtretlig" ; -- förtretlig..av.1
  förtretlighet_1_N = mkN "förtretlighet" "förtretligheter" ; -- förtretlighet..nn.1
  förtro_1_V = mkV "förtror" ; -- förtro..vb.1
  förtroende_1_N = mkN "förtroende" ; -- förtroende..nn.1
  förtroendearbetstid_1_N = mkN "förtroendearbetstid" ; -- förtroendearbetstid..nn.1
  förtroendefråga_1_N = mkN "förtroendefråga" ; -- förtroendefråga..nn.1
  förtroendefull_1_A = mkA "förtroendefull" ; -- förtroendefull..av.1
  förtroendefullhet_1_N = mkN "förtroendefullhet" ; -- förtroendefullhet..nn.1
  förtroendeglapp_1_N = mkN "förtroendeglapp" neutrum  ; -- förtroendeglapp..nn.1
  förtroendeingivande_1_A = mkA "förtroendeingivande" ; -- förtroendeingivande..av.1
  förtroendeklyfta_1_N = mkN "förtroendeklyfta" ; -- förtroendeklyfta..nn.1
  förtroendekris_1_N = mkN "förtroendekris" "förtroendekriser" ; -- förtroendekris..nn.1
  förtroendeman_1_N = mkN "förtroendeman" "förtroendemannen" "förtroendemän" "förtroendemännen" ; -- förtroendeman..nn.1
  förtroendemässig_1_A = mkA "förtroendemässig" ; -- förtroendemässig..av.1
  förtroendemätning_1_N = mkN "förtroendemätning" ; -- förtroendemätning..nn.1
  förtroendeomröstning_1_N = mkN "förtroendeomröstning" ; -- förtroendeomröstning..nn.1
  förtroendepost_1_N = mkN "förtroendepost" "förtroendeposter" ; -- förtroendepost..nn.1
  förtroenderåd_1_N = mkN "förtroenderåd" neutrum  ; -- förtroenderåd..nn.1
  förtroendeskapande_1_A = mkA "förtroendeskapande" ; -- förtroendeskapande..av.1
  förtroendeuppdrag_1_N = mkN "förtroendeuppdrag" neutrum  ; -- förtroendeuppdrag..nn.1
  förtroendevald_1_A = mkA "förtroendevald" "förtroendevalt" ; -- förtroendevald..av.1
  förtroendevotum_1_N = mkN "förtroendevotum" neutrum  ; -- förtroendevotum..nn.1
  förtroendeväckande_1_A = mkA "förtroendeväckande" ; -- förtroendeväckande..av.1
  förtrogen_1_A = mkA "förtrogen" ; -- förtrogen..av.1
  förtrogenhet_1_N = mkN "förtrogenhet" "förtrogenheter" ; -- förtrogenhet..nn.1
  förtrolig_1_A = mkA "förtrolig" ; -- förtrolig..av.1
  förtrolighet_1_N = mkN "förtrolighet" "förtroligheter" ; -- förtrolighet..nn.1
  förtrolla_1_V = mkV "förtrollar" ; -- förtrolla..vb.1
  förtrollande_1_A = mkA "förtrollande" ; -- förtrollande..av.1
  förtrollande_1_N = mkN "förtrollande" ; -- förtrollande..nn.1
  förtrollare_1_N = mkN "förtrollare" utrum  ; -- förtrollare..nn.1
  förtrollerska_1_N = mkN "förtrollerska" ; -- förtrollerska..nn.1
  förtrollning_1_N = mkN "förtrollning" ; -- förtrollning..nn.1
  förtrupp_1_N = mkN "förtrupp" "förtrupper" ; -- förtrupp..nn.1
  förtrusta_1_V = mkV "förtrustar" ; -- förtrusta..vb.1
  förtrustande_1_N = mkN "förtrustande" ; -- förtrustande..nn.1
  förtryck_1_N = mkN "förtryck" neutrum  ; -- förtryck..nn.1
  förtrycka_1_V = mkV "förtrycker" ; -- förtrycka..vb.1
  förtryckande_1_N = mkN "förtryckande" ; -- förtryckande..nn.1
  förtryckare_1_N = mkN "förtryckare" utrum  ; -- förtryckare..nn.1
  förtryckning_1_N = mkN "förtryckning" ; -- förtryckning..nn.1
  förtryckt_1_A = mkA "förtryckt" "förtryckt" ; -- förtryckt..av.1
  förtryta_1_V = mkV "förtryta" "förtröt" "förtrutit" ; -- förtryta..vb.1
  förtrytande_1_N = mkN "förtrytande" ; -- förtrytande..nn.1
  förtrytelse_1_N = mkN "förtrytelse" utrum  ; -- förtrytelse..nn.1
  förtrytsam_1_A = mkA "förtrytsam" "förtrytsamt" "förtrytsamma" "förtrytsamma" "förtrytsammare" "förtrytsammast" "förtrytsammaste" ; -- förtrytsam..av.1
  förtrytsamhet_1_N = mkN "förtrytsamhet" ; -- förtrytsamhet..nn.1
  förträfflig_1_A = mkA "förträfflig" ; -- förträfflig..av.1
  förträfflighet_1_N = mkN "förträfflighet" "förträffligheter" ; -- förträfflighet..nn.1
  förtränga_1_V = mkV "förtränger" ; -- förtränga..vb.1
  förträngande_1_N = mkN "förträngande" ; -- förträngande..nn.1
  förträngning_1_N = mkN "förträngning" ; -- förträngning..nn.1
  förträngningsmekanism_1_N = mkN "förträngningsmekanism" "förträngningsmekanismer" ; -- förträngningsmekanism..nn.1
  förtrösta_1_V = mkV "förtröstar" ; -- förtrösta..vb.1
  förtröstande_1_N = mkN "förtröstande" ; -- förtröstande..nn.1
  förtröstansfull_1_A = mkA "förtröstansfull" ; -- förtröstansfull..av.1
  förtulla_1_V = mkV "förtullar" ; -- förtulla..vb.1
  förtullande_1_N = mkN "förtullande" ; -- förtullande..nn.1
  förtullning_1_N = mkN "förtullning" ; -- förtullning..nn.1
  förtunna_1_V = mkV "förtunnar" ; -- förtunna..vb.1
  förtunnande_1_N = mkN "förtunnande" ; -- förtunnande..nn.1
  förtunning_1_N = mkN "förtunning" ; -- förtunning..nn.1
  förtur_1_N = mkN "förtur" ; -- förtur..nn.1
  förtvina_1_V = mkV "förtvinar" ; -- förtvina..vb.1
  förtvinande_1_N = mkN "förtvinande" ; -- förtvinande..nn.1
  förtvining_1_N = mkN "förtvining" ; -- förtvining..nn.1
  förtvivla_1_V = mkV "förtvivlar" ; -- förtvivla..vb.1
  förtvivlad_1_A = mkA "förtvivlad" ; -- förtvivlad..av.1
  förtvivlande_1_N = mkN "förtvivlande" ; -- förtvivlande..nn.1
  förtvätt_1_N = mkN "förtvätt" ; -- förtvätt..nn.1
  förtvåla_1_V = mkV "förtvålar" ; -- förtvåla..vb.1
  förtvålande_1_N = mkN "förtvålande" ; -- förtvålande..nn.1
  förtvålning_1_N = mkN "förtvålning" ; -- förtvålning..nn.1
  förtycka_1_V = mkV "förtycker" ; -- förtycka..vb.1
  förtyckande_1_N = mkN "förtyckande" ; -- förtyckande..nn.1
  förtydliga_1_V = mkV "förtydligar" ; -- förtydliga..vb.1
  förtydligande_1_N = mkN "förtydligande" ; -- förtydligande..nn.1
  förtyska_1_V = mkV "förtyskar" ; -- förtyska..vb.1
  förtyskande_1_N = mkN "förtyskande" ; -- förtyskande..nn.1
  förtäckt_1_A = mkA "förtäckt" "förtäckt" ; -- förtäckt..av.1
  förtälja_1_V = mkV "förtälja" "förtäljer" "förtälj" "förtalde" "förtalt" "förtäljd" ; -- förtälja..vb.1
  förtäljande_1_N = mkN "förtäljande" ; -- förtäljande..nn.1
  förtändning_1_N = mkN "förtändning" ; -- förtändning..nn.1
  förtänka_1_V = mkV "förtänker" ; -- förtänka..vb.1
  förtänkande_1_N = mkN "förtänkande" ; -- förtänkande..nn.1
  förtänksam_1_A = mkA "förtänksam" "förtänksamt" "förtänksamma" "förtänksamma" "förtänksammare" "förtänksammast" "förtänksammaste" ; -- förtänksam..av.1
  förtänksamhet_1_N = mkN "förtänksamhet" ; -- förtänksamhet..nn.1
  förtära_1_V = mkV "förtära" "förtärde" "förtärt" ; -- förtära..vb.1
  förtärande_1_N = mkN "förtärande" ; -- förtärande..nn.1
  förtäring_1_N = mkN "förtäring" ; -- förtäring..nn.1
  förtäta_1_V = mkV "förtätar" ; -- förtäta..vb.1
  förtätande_1_N = mkN "förtätande" ; -- förtätande..nn.1
  förtätning_1_N = mkN "förtätning" ; -- förtätning..nn.1
  förtöja_1_V = mkV "förtöja" "förtöjde" "förtöjt" ; -- förtöja..vb.1
  förtöjande_1_N = mkN "förtöjande" ; -- förtöjande..nn.1
  förtöjning_1_N = mkN "förtöjning" ; -- förtöjning..nn.1
  förtöjningslina_1_N = mkN "förtöjningslina" ; -- förtöjningslina..nn.1
  förtöjningsring_1_N = mkN "förtöjningsring" ; -- förtöjningsring..nn.1
  förtörnad_1_A = mkA "förtörnad" ; -- förtörnad..av.1
  förtörnelse_1_N = mkN "förtörnelse" "förtörnelser" ; -- förtörnelse..nn.1
  förunderlig_1_A = mkA "förunderlig" ; -- förunderlig..av.1
  förunderlighet_1_N = mkN "förunderlighet" "förunderligheter" ; -- förunderlighet..nn.1
  förundersöka_1_V = mkV "förundersöker" ; -- förundersöka..vb.1
  förundersökande_1_N = mkN "förundersökande" ; -- förundersökande..nn.1
  förundersökning_1_N = mkN "förundersökning" ; -- förundersökning..nn.1
  förundersökningsledare_1_N = mkN "förundersökningsledare" utrum  ; -- förundersökningsledare..nn.1
  förundersökningsprotokoll_1_N = mkN "förundersökningsprotokoll" neutrum  ; -- förundersökningsprotokoll..nn.1
  förundersökningssekretess_1_N = mkN "förundersökningssekretess" ; -- förundersökningssekretess..nn.1
  förundra_1_V = mkV "förundrar" ; -- förundra..vb.1
  förundrande_1_N = mkN "förundrande" ; -- förundrande..nn.1
  förundransvärd_1_A = mkA "förundransvärd" "förundransvärt" ; -- förundransvärd..av.1
  förundransvärdhet_1_N = mkN "förundransvärdhet" ; -- förundransvärdhet..nn.1
  förunna_1_V = mkV "förunnar" ; -- förunna..vb.1
  förunnande_1_N = mkN "förunnande" ; -- förunnande..nn.1
  förunt_1_A = mkA "förunt" "förunt" ; -- förunt..av.1
  förut_2_1_Adv = mkAdv "förut" ; -- förut_2..ab.1
  förutbestämd_1_A = mkA "förutbestämd" "förutbestämt" ; -- förutbestämd..av.1
  förutbestämdhet_1_N = mkN "förutbestämdhet" ; -- förutbestämdhet..nn.1
  förutbestämma_1_V = mkV "förutbestämmer" ; -- förutbestämma..vb.1
  förutbestämmande_1_N = mkN "förutbestämmande" ; -- förutbestämmande..nn.1
  förutbestämmelse_1_N = mkN "förutbestämmelse" "förutbestämmelser" ; -- förutbestämmelse..nn.1
  förutfattad_1_A = mkA "förutfattad" ; -- förutfattad..av.1
  förutse_1_V = mkV "förutse" "förutsåg" "förutsett" ; -- förutse..vb.1
  förutsebar_1_A = mkA "förutsebar" ; -- förutsebar..av.1
  förutseende_1_A = mkA "förutseende" ; -- förutseende..av.1
  förutseende_1_N = mkN "förutseende" ; -- förutseende..nn.1
  förutskicka_1_V = mkV "förutskickar" ; -- förutskicka..vb.1
  förutskickande_1_N = mkN "förutskickande" ; -- förutskickande..nn.1
  förutspå_1_V = mkV "förutspår" ; -- förutspå..vb.1
  förutspående_1_N = mkN "förutspående" ; -- förutspående..nn.1
  förutsäga_1_V = mkV "förutsäga" "förutsade" "förutsagt" ; -- förutsäga..vb.1
  förutsägande_1_N = mkN "förutsägande" ; -- förutsägande..nn.1
  förutsägbar_1_A = mkA "förutsägbar" ; -- förutsägbar..av.1
  förutsägbarhet_1_N = mkN "förutsägbarhet" ; -- förutsägbarhet..nn.1
  förutsägelse_1_N = mkN "förutsägelse" "förutsägelser" ; -- förutsägelse..nn.1
  förutsägelsekraft_1_N = mkN "förutsägelsekraft" ; -- förutsägelsekraft..nn.1
  förutsätta_1_V = mkV "förutsätta" "förutsätter" "förutsätt" "förutsatte" "förutsatt" "förutsatt" ; -- förutsätta..vb.1
  förutsättande_1_N = mkN "förutsättande" ; -- förutsättande..nn.1
  förutsättning_1_N = mkN "förutsättning" ; -- förutsättning..nn.1
  förutsättningslös_1_A = mkA "förutsättningslös" ; -- förutsättningslös..av.1
  förutsättningslöshet_1_N = mkN "förutsättningslöshet" ; -- förutsättningslöshet..nn.1
  förutvarande_1_A = mkA "förutvarande" ; -- förutvarande..av.1
  förvalta_1_V = mkV "förvaltar" ; -- förvalta..vb.1
  förvaltande_1_N = mkN "förvaltande" ; -- förvaltande..nn.1
  förvaltare_1_N = mkN "förvaltare" utrum  ; -- förvaltare..nn.1
  förvaltarskap_1_N = mkN "förvaltarskap" neutrum  ; -- förvaltarskap..nn.1
  förvaltarskapsområde_1_N = mkN "förvaltarskapsområde" ; -- förvaltarskapsområde..nn.1
  förvaltning_1_N = mkN "förvaltning" ; -- förvaltning..nn.1
  förvaltningsberättelse_1_N = mkN "förvaltningsberättelse" "förvaltningsberättelser" ; -- förvaltningsberättelse..nn.1
  förvaltningsbeslut_1_N = mkN "förvaltningsbeslut" neutrum  ; -- förvaltningsbeslut..nn.1
  förvaltningsbolag_1_N = mkN "förvaltningsbolag" neutrum  ; -- förvaltningsbolag..nn.1
  förvaltningsbyggnad_1_N = mkN "förvaltningsbyggnad" "förvaltningsbyggnader" ; -- förvaltningsbyggnad..nn.1
  förvaltningsmyndighet_1_N = mkN "förvaltningsmyndighet" "förvaltningsmyndigheter" ; -- förvaltningsmyndighet..nn.1
  förvaltningsmässig_1_A = mkA "förvaltningsmässig" ; -- förvaltningsmässig..av.1
  förvaltningsrätt_1_N = mkN "förvaltningsrätt" "förvaltningsrätter" ; -- förvaltningsrätt..nn.1
  förvaltningsutskott_1_N = mkN "förvaltningsutskott" neutrum  ; -- förvaltningsutskott..nn.1
  förvandla_1_V = mkV "förvandlar" ; -- förvandla..vb.1
  förvandlande_1_N = mkN "förvandlande" ; -- förvandlande..nn.1
  förvandling_1_N = mkN "förvandling" ; -- förvandling..nn.1
  förvandlingskonstnär_1_N = mkN "förvandlingskonstnär" "förvandlingskonstnärer" ; -- förvandlingskonstnär..nn.1
  förvandlingsnummer_1_N = mkN "förvandlingsnummer" neutrum  ; -- förvandlingsnummer..nn.1
  förvandlingsprocess_1_N = mkN "förvandlingsprocess" "förvandlingsprocesser" ; -- förvandlingsprocess..nn.1
  förvandlingsstraff_1_N = mkN "förvandlingsstraff" neutrum  ; -- förvandlingsstraff..nn.1
  förvanska_1_V = mkV "förvanskar" ; -- förvanska..vb.1
  förvanskande_1_N = mkN "förvanskande" ; -- förvanskande..nn.1
  förvanskning_1_N = mkN "förvanskning" ; -- förvanskning..nn.1
  förvar_1_N = mkN "förvar" neutrum  ; -- förvar..nn.1
  förvara_1_V = mkV "förvarar" ; -- förvara..vb.1
  förvarande_1_N = mkN "förvarande" ; -- förvarande..nn.1
  förvaring_1_N = mkN "förvaring" ; -- förvaring..nn.1
  förvaringsask_1_N = mkN "förvaringsask" ; -- förvaringsask..nn.1
  förvaringsback_1_N = mkN "förvaringsback" ; -- förvaringsback..nn.1
  förvaringsbox_1_N = mkN "förvaringsbox" ; -- förvaringsbox..nn.1
  förvaringshall_1_N = mkN "förvaringshall" ; -- förvaringshall..nn.1
  förvaringskorg_1_N = mkN "förvaringskorg" ; -- förvaringskorg..nn.1
  förvaringskärl_1_N = mkN "förvaringskärl" neutrum  ; -- förvaringskärl..nn.1
  förvaringsmöjlighet_1_N = mkN "förvaringsmöjlighet" "förvaringsmöjligheter" ; -- förvaringsmöjlighet..nn.1
  förvaringsplats_1_N = mkN "förvaringsplats" "förvaringsplatser" ; -- förvaringsplats..nn.1
  förvaringsrum_1_N = mkN "förvaringsrum" "förvaringsrummet" "förvaringsrum" "förvaringsrummen" ; -- förvaringsrum..nn.1
  förvaringsskärl_1_N = mkN "förvaringsskärl" neutrum  ; -- förvaringsskärl..nn.1
  förvaringsskåp_1_N = mkN "förvaringsskåp" neutrum  ; -- förvaringsskåp..nn.1
  förvaringsställe_1_N = mkN "förvaringsställe" ; -- förvaringsställe..nn.1
  förvaringsutrymme_1_N = mkN "förvaringsutrymme" ; -- förvaringsutrymme..nn.1
  förvaringsvalv_1_N = mkN "förvaringsvalv" neutrum  ; -- förvaringsvalv..nn.1
  förvarna_1_V = mkV "förvarnar" ; -- förvarna..vb.1
  förvarnande_1_N = mkN "förvarnande" ; -- förvarnande..nn.1
  förvarning_1_N = mkN "förvarning" ; -- förvarning..nn.1
  förveckling_1_N = mkN "förveckling" ; -- förveckling..nn.1
  förveda_1_V = mkV "förvedar" ; -- förveda..vb.1
  förvedande_1_N = mkN "förvedande" ; -- förvedande..nn.1
  förvedning_1_N = mkN "förvedning" ; -- förvedning..nn.1
  förvekliga_1_V = mkV "förvekligar" ; -- förvekliga..vb.1
  förvekligande_1_N = mkN "förvekligande" ; -- förvekligande..nn.1
  förverka_1_V = mkV "förverkar" ; -- förverka..vb.1
  förverkande_1_N = mkN "förverkande" ; -- förverkande..nn.1
  förverkliga_1_V = mkV "förverkligar" ; -- förverkliga..vb.1
  förverkligande_1_N = mkN "förverkligande" ; -- förverkligande..nn.1
  förveten_1_A = mkA "förveten" ; -- förveten..av.1
  förvetenhet_1_N = mkN "förvetenhet" ; -- förvetenhet..nn.1
  förvikingatida_1_A = mkA "förvikingatida" ; -- förvikingatida..av.1
  förvildad_1_A = mkA "förvildad" ; -- förvildad..av.1
  förvildning_1_N = mkN "förvildning" ; -- förvildning..nn.1
  förvilla_1_V = mkV "förvillar" ; -- förvilla..vb.1
  förvillande_1_N = mkN "förvillande" ; -- förvillande..nn.1
  förvillare_1_N = mkN "förvillare" utrum  ; -- förvillare..nn.1
  förvillelse_1_N = mkN "förvillelse" "förvillelser" ; -- förvillelse..nn.1
  förvinter_1_N = mkN "förvinter" ; -- förvinter..nn.1
  förvirra_1_V = mkV "förvirrar" ; -- förvirra..vb.1
  förvirrad_1_A = mkA "förvirrad" ; -- förvirrad..av.1
  förvirrande_1_A = mkA "förvirrande" ; -- förvirrande..av.1
  förvirrande_1_N = mkN "förvirrande" ; -- förvirrande..nn.1
  förvirring_1_N = mkN "förvirring" ; -- förvirring..nn.1
  förvisa_1_V = mkV "förvisar" ; -- förvisa..vb.1
  förvisande_1_N = mkN "förvisande" ; -- förvisande..nn.1
  förvisning_1_N = mkN "förvisning" ; -- förvisning..nn.1
  förvisningsort_1_N = mkN "förvisningsort" "förvisningsorter" ; -- förvisningsort..nn.1
  förvissa_1_V = mkV "förvissar" ; -- förvissa..vb.1
  förvissande_1_N = mkN "förvissande" ; -- förvissande..nn.1
  förvissna_1_V = mkV "förvissnar" ; -- förvissna..vb.1
  förvissnande_1_N = mkN "förvissnande" ; -- förvissnande..nn.1
  förvissning_1_N = mkN "förvissning" ; -- förvissning..nn.1
  förvisso_1_Adv = mkAdv "förvisso" ; -- förvisso..ab.1
  förvittra_1_V = mkV "förvittrar" ; -- förvittra..vb.1
  förvittrande_1_N = mkN "förvittrande" ; -- förvittrande..nn.1
  förvittring_1_N = mkN "förvittring" ; -- förvittring..nn.1
  förvrida_1_V = mkV "förvrida" "förvred" "förvridit" ; -- förvrida..vb.1
  förvridande_1_N = mkN "förvridande" ; -- förvridande..nn.1
  förvriden_1_A = mkA "förvriden" ; -- förvriden..av.1
  förvridning_1_N = mkN "förvridning" ; -- förvridning..nn.1
  förvränga_1_V = mkV "förvränger" ; -- förvränga..vb.1
  förvrängande_1_N = mkN "förvrängande" ; -- förvrängande..nn.1
  förvrängning_1_N = mkN "förvrängning" ; -- förvrängning..nn.1
  förvunnen_1_A = mkA "förvunnen" "förvunnet" "förvunna" "förvunna" "förvunnare" "förvunnast" "förvunnaste" ; -- förvunnen..av.1
  förvuxen_1_A = mkA "förvuxen" ; -- förvuxen..av.1
  förvuxenhet_1_N = mkN "förvuxenhet" ; -- förvuxenhet..nn.1
  förvägen_1_A = mkA "förvägen" ; -- förvägen..av.1
  förvägenhet_1_N = mkN "förvägenhet" ; -- förvägenhet..nn.1
  förvägra_1_V = mkV "förvägrar" ; -- förvägra..vb.1
  förvägrande_1_N = mkN "förvägrande" ; -- förvägrande..nn.1
  förväljare_1_N = mkN "förväljare" utrum  ; -- förväljare..nn.1
  förvälla_1_V = mkV "förväller" ; -- förvälla..vb.1
  förvällande_1_N = mkN "förvällande" ; -- förvällande..nn.1
  förvällning_1_N = mkN "förvällning" ; -- förvällning..nn.1
  förvänd_1_A = mkA "förvänd" ; -- förvänd..av.1
  förvända_1_V = mkV "förvänder" ; -- förvända..vb.1
  förvändande_1_N = mkN "förvändande" ; -- förvändande..nn.1
  förvändhet_1_N = mkN "förvändhet" ; -- förvändhet..nn.1
  förvändning_1_N = mkN "förvändning" ; -- förvändning..nn.1
  förvänta_1_V = mkV "förväntar" ; -- förvänta..vb.1
  förväntad_1_A = mkA "förväntad" ; -- förväntad..av.1
  förväntande_1_N = mkN "förväntande" ; -- förväntande..nn.1
  förväntansfull_1_A = mkA "förväntansfull" ; -- förväntansfull..av.1
  förväntansfullhet_1_N = mkN "förväntansfullhet" ; -- förväntansfullhet..nn.1
  förväntning_1_N = mkN "förväntning" ; -- förväntning..nn.1
  förväntningsfull_1_A = mkA "förväntningsfull" ; -- förväntningsfull..av.1
  förvärk_1_N = mkN "förvärk" ; -- förvärk..nn.1
  förvärldsliga_1_V = mkV "förvärldsligar" ; -- förvärldsliga..vb.1
  förvärldsligande_1_N = mkN "förvärldsligande" ; -- förvärldsligande..nn.1
  förvärmare_1_N = mkN "förvärmare" utrum  ; -- förvärmare..nn.1
  förvärra_1_V = mkV "förvärrar" ; -- förvärra..vb.1
  förvärrande_1_N = mkN "förvärrande" ; -- förvärrande..nn.1
  förvärring_1_N = mkN "förvärring" ; -- förvärring..nn.1
  förvärv_1_N = mkN "förvärv" neutrum  ; -- förvärv..nn.1
  förvärva_1_V = mkV "förvärvar" ; -- förvärva..vb.1
  förvärvande_1_N = mkN "förvärvande" ; -- förvärvande..nn.1
  förvärvsarbeta_1_V = mkV "förvärvsarbetar" ; -- förvärvsarbeta..vb.1
  förvärvsarbetande_1_N = mkN "förvärvsarbetande" ; -- förvärvsarbetande..nn.1
  förvärvsarbete_1_N = mkN "förvärvsarbete" ; -- förvärvsarbete..nn.1
  förvärvsavdrag_1_N = mkN "förvärvsavdrag" neutrum  ; -- förvärvsavdrag..nn.1
  förvärvskälla_1_N = mkN "förvärvskälla" ; -- förvärvskälla..nn.1
  förvärvsliv_1_N = mkN "förvärvsliv" neutrum  ; -- förvärvsliv..nn.1
  förvärvslysten_1_A = mkA "förvärvslysten" ; -- förvärvslysten..av.1
  förvärvslystenhet_1_N = mkN "förvärvslystenhet" ; -- förvärvslystenhet..nn.1
  förvärvslystnad_1_N = mkN "förvärvslystnad" ; -- förvärvslystnad..nn.1
  förvärvsmässig_1_A = mkA "förvärvsmässig" ; -- förvärvsmässig..av.1
  förvärvsverksamhet_1_N = mkN "förvärvsverksamhet" "förvärvsverksamheter" ; -- förvärvsverksamhet..nn.1
  förväxla_1_V = mkV "förväxlar" ; -- förväxla..vb.1
  förväxlande_1_N = mkN "förväxlande" ; -- förväxlande..nn.1
  förväxling_1_N = mkN "förväxling" ; -- förväxling..nn.1
  förväxlingskomedi_1_N = mkN "förväxlingskomedi" "förväxlingskomedier" ; -- förväxlingskomedi..nn.1
  förväxlingslek_1_N = mkN "förväxlingslek" ; -- förväxlingslek..nn.1
  förväxt_1_A = mkA "förväxt" "förväxt" ; -- förväxt..av.1
  förvålla_1_V = mkV "förvållar" ; -- förvålla..vb.1
  förvållande_1_N = mkN "förvållande" ; -- förvållande..nn.1
  förvåna_1_V = mkV "förvånar" ; -- förvåna..vb.1
  förvånad_1_A = mkA "förvånad" ; -- förvånad..av.1
  förvånande_1_N = mkN "förvånande" ; -- förvånande..nn.1
  förvånansvärd_1_A = mkA "förvånansvärd" "förvånansvärt" ; -- förvånansvärd..av.1
  förvåning_1_N = mkN "förvåning" ; -- förvåning..nn.1
  föryngra_1_V = mkV "föryngrar" ; -- föryngra..vb.1
  föryngrande_1_N = mkN "föryngrande" ; -- föryngrande..nn.1
  föryngring_1_N = mkN "föryngring" ; -- föryngring..nn.1
  föryngringsbeskära_1_V = mkV "föryngringsbeskära" "föryngringsbeskar" "föryngringsbeskurit" ; -- föryngringsbeskära..vb.1
  föryngringsbeskärande_1_N = mkN "föryngringsbeskärande" ; -- föryngringsbeskärande..nn.1
  föryngringsbeskäring_1_N = mkN "föryngringsbeskäring" ; -- föryngringsbeskäring..nn.1
  föryngringsyta_1_N = mkN "föryngringsyta" ; -- föryngringsyta..nn.1
  förzinka_1_V = mkV "förzinkar" ; -- förzinka..vb.1
  förzinkande_1_N = mkN "förzinkande" ; -- förzinkande..nn.1
  förzinkning_1_N = mkN "förzinkning" ; -- förzinkning..nn.1
  förädla_1_V = mkV "förädlar" ; -- förädla..vb.1
  förädlande_1_N = mkN "förädlande" ; -- förädlande..nn.1
  förädling_1_N = mkN "förädling" ; -- förädling..nn.1
  förädlingsarbete_1_N = mkN "förädlingsarbete" ; -- förädlingsarbete..nn.1
  föräktenskaplig_1_A = mkA "föräktenskaplig" ; -- föräktenskaplig..av.1
  föräktenskaplighet_1_N = mkN "föräktenskaplighet" ; -- föräktenskaplighet..nn.1
  förälder_1_N = mkN "förälder" ; -- förälder..nn.1
  förälderlig_1_A = mkA "förälderlig" ; -- förälderlig..av.1
  föräldraansvar_1_N = mkN "föräldraansvar" neutrum  ; -- föräldraansvar..nn.1
  föräldrabalk_1_N = mkN "föräldrabalk" ; -- föräldrabalk..nn.1
  föräldrabesök_1_N = mkN "föräldrabesök" neutrum  ; -- föräldrabesök..nn.1
  föräldradag_1_N = mkN "föräldradag" ; -- föräldradag..nn.1
  föräldrafri_1_A = mkA "föräldrafri" "föräldrafritt" ; -- föräldrafri..av.1
  föräldraförmån_1_N = mkN "föräldraförmån" "föräldraförmåner" ; -- föräldraförmån..nn.1
  föräldraförsäkring_1_N = mkN "föräldraförsäkring" ; -- föräldraförsäkring..nn.1
  föräldrahem_1_N = mkN "föräldrahem" "föräldrahemmet" "föräldrahem" "föräldrahemmen" ; -- föräldrahem..nn.1
  föräldrakollektiv_1_N = mkN "föräldrakollektiv" neutrum  ; -- föräldrakollektiv..nn.1
  föräldrakreativitet_1_N = mkN "föräldrakreativitet" "föräldrakreativiteter" ; -- föräldrakreativitet..nn.1
  föräldrakärlek_1_N = mkN "föräldrakärlek" ; -- föräldrakärlek..nn.1
  föräldraledig_1_A = mkA "föräldraledig" ; -- föräldraledig..av.1
  föräldraledighet_1_N = mkN "föräldraledighet" "föräldraledigheter" ; -- föräldraledighet..nn.1
  föräldralös_1_A = mkA "föräldralös" ; -- föräldralös..av.1
  föräldralöshet_1_N = mkN "föräldralöshet" ; -- föräldralöshet..nn.1
  föräldramakt_1_N = mkN "föräldramakt" ; -- föräldramakt..nn.1
  föräldramöte_1_N = mkN "föräldramöte" ; -- föräldramöte..nn.1
  föräldrapenning_1_N = mkN "föräldrapenning" ; -- föräldrapenning..nn.1
  föräldraskap_1_N = mkN "föräldraskap" neutrum  ; -- föräldraskap..nn.1
  föräldraträd_1_N = mkN "föräldraträd" neutrum  ; -- föräldraträd..nn.1
  förälskad_1_A = mkA "förälskad" ; -- förälskad..av.1
  förälskelse_1_N = mkN "förälskelse" "förälskelser" ; -- förälskelse..nn.1
  föränderlig_1_A = mkA "föränderlig" ; -- föränderlig..av.1
  föränderlighet_1_N = mkN "föränderlighet" ; -- föränderlighet..nn.1
  förändra_1_V = mkV "förändrar" ; -- förändra..vb.1
  förändrande_1_N = mkN "förändrande" ; -- förändrande..nn.1
  förändring_1_N = mkN "förändring" ; -- förändring..nn.1
  förändringsarbete_1_N = mkN "förändringsarbete" ; -- förändringsarbete..nn.1
  förändringsprocess_1_N = mkN "förändringsprocess" "förändringsprocesser" ; -- förändringsprocess..nn.1
  förändringstakt_1_N = mkN "förändringstakt" "förändringstakter" ; -- förändringstakt..nn.1
  förändringstryck_1_N = mkN "förändringstryck" neutrum  ; -- förändringstryck..nn.1
  förära_1_V = mkV "förärar" ; -- förära..vb.1
  förärande_1_N = mkN "förärande" ; -- förärande..nn.1
  förätning_1_N = mkN "förätning" ; -- förätning..nn.1
  föråldrad_1_A = mkA "föråldrad" ; -- föråldrad..av.1
  föråldring_1_N = mkN "föråldring" ; -- föråldring..nn.1
  förånga_1_V = mkV "förångar" ; -- förånga..vb.1
  förångande_1_N = mkN "förångande" ; -- förångande..nn.1
  förångning_1_N = mkN "förångning" ; -- förångning..nn.1
  föröda_1_V = mkV "föröda" "förödde" "förött" ; -- föröda..vb.1
  förödande_1_A = mkA "förödande" ; -- förödande..av.1
  förödande_1_N = mkN "förödande" ; -- förödande..nn.1
  förödelse_1_N = mkN "förödelse" "förödelser" ; -- förödelse..nn.1
  förödmjuka_1_V = mkV "förödmjukar" ; -- förödmjuka..vb.1
  förödmjukande_1_N = mkN "förödmjukande" ; -- förödmjukande..nn.1
  förödmjukelse_1_N = mkN "förödmjukelse" "förödmjukelser" ; -- förödmjukelse..nn.1
  föröka_1_V = mkV "förökar" ; -- föröka..vb.1
  förökande_1_N = mkN "förökande" ; -- förökande..nn.1
  förökning_1_N = mkN "förökning" ; -- förökning..nn.1
  föröva_1_V = mkV "förövar" ; -- föröva..vb.1
  förövande_1_N = mkN "förövande" ; -- förövande..nn.1
  förövare_1_N = mkN "förövare" utrum  ; -- förövare..nn.1
  föröver_1_Adv = mkAdv "föröver" ; -- föröver..ab.1
  förövning_1_N = mkN "förövning" ; -- förövning..nn.1
  fösa_1_V = mkV "föser" ; -- fösa..vb.1
  fösande_1_N = mkN "fösande" ; -- fösande..nn.1
  fösning_1_N = mkN "fösning" ; -- fösning..nn.1
  g_dräkt_1_N = mkN "g-dräkt" "g-dräkter" ; -- g-dräkt..nn.1
  g_klav_1_N = mkN "g-klav" "g-klaver" ; -- g-klav..nn.1
  g_kraft_1_N = mkN "g-kraft" "g-krafter" ; -- g-kraft..nn.1
  g_punkt_1_N = mkN "g-punkt" "g-punkter" ; -- g-punkt..nn.1
  gabardin_1_N = mkN "gabardin" ; -- gabardin..nn.1
  gabbro_1_N = mkN "gabbro" ; -- gabbro..nn.1
  gabon_1_N = mkN "gabon" ; -- gabon..nn.1
  gabon_2_N = mkN "gabon" "gaboner" ; -- gabon..nn.2
  gabondörr_1_N = mkN "gabondörr" ; -- gabondörr..nn.1
  gabones_1_N = mkN "gabones" "gaboneser" ; -- gabones..nn.1
  gabonesisk_1_A = mkA "gabonesisk" ; -- gabonesisk..av.1
  gabonesiska_1_N = mkN "gabonesiska" ; -- gabonesiska..nn.1
  gabonhuggorm_1_N = mkN "gabonhuggorm" ; -- gabonhuggorm..nn.1
  gadd_1_N = mkN "gadd" ; -- gadd..nn.1
  gadda_1_V = mkV "gaddar" ; -- gadda..vb.1
  gaddande_1_N = mkN "gaddande" ; -- gaddande..nn.1
  gaddlös_1_A = mkA "gaddlös" ; -- gaddlös..av.1
  gaddlöshet_1_N = mkN "gaddlöshet" ; -- gaddlöshet..nn.1
  gaddning_1_N = mkN "gaddning" ; -- gaddning..nn.1
  gaddstekel_1_N = mkN "gaddstekel" ; -- gaddstekel..nn.1
  gadolinium_1_N = mkN "gadolinium" neutrum  ; -- gadolinium..nn.1
  gael_1_N = mkN "gael" "gaeler" ; -- gael..nn.1
  gaelisk_1_A = mkA "gaelisk" ; -- gaelisk..av.1
  gaeliska_1_N = mkN "gaeliska" ; -- gaeliska..nn.1
  gaeliska_2_N = mkN "gaeliska" ; -- gaeliska..nn.2
  gaff_1_N = mkN "gaff" ; -- gaff..nn.1
  gaffel_1_N = mkN "gaffel" ; -- gaffel..nn.1
  gaffelankare_1_N = mkN "gaffelankare" "gaffelankaret" "gaffelankaren" "gaffelankarna" ; -- gaffelankare..nn.1
  gaffelantilop_1_N = mkN "gaffelantilop" "gaffelantiloper" ; -- gaffelantilop..nn.1
  gaffelapa_1_N = mkN "gaffelapa" ; -- gaffelapa..nn.1
  gaffelbit_1_N = mkN "gaffelbit" ; -- gaffelbit..nn.1
  gaffelbock_1_N = mkN "gaffelbock" ; -- gaffelbock..nn.1
  gaffelfibbla_1_N = mkN "gaffelfibbla" ; -- gaffelfibbla..nn.1
  gaffelformig_1_A = mkA "gaffelformig" ; -- gaffelformig..av.1
  gaffelhjort_1_N = mkN "gaffelhjort" ; -- gaffelhjort..nn.1
  gaffelklo_1_N = mkN "gaffelklo" "gaffelklor" ; -- gaffelklo..nn.1
  gaffellyft_1_N = mkN "gaffellyft" ; -- gaffellyft..nn.1
  gaffellängd_1_N = mkN "gaffellängd" "gaffellängder" ; -- gaffellängd..nn.1
  gaffelrigg_1_N = mkN "gaffelrigg" ; -- gaffelrigg..nn.1
  gaffelsegel_1_N = mkN "gaffelsegel" neutrum  ; -- gaffelsegel..nn.1
  gaffeltruck_1_N = mkN "gaffeltruck" ; -- gaffeltruck..nn.1
  gaffla_1_V = mkV "gafflar" ; -- gaffla..vb.1
  gafflande_1_N = mkN "gafflande" ; -- gafflande..nn.1
  gag_1_N = mkN "gag" neutrum  ; -- gag..nn.1
  gagat_1_N = mkN "gagat" "gagater" ; -- gagat..nn.1
  gagatsvart_1_A = mkA "gagatsvart" "gagatsvart" ; -- gagatsvart..av.1
  gage_1_N = mkN "gage" "gaget" "gager" "gagerna" ; -- gage..nn.1
  gagg_1_N = mkN "gagg" neutrum  ; -- gagg..nn.1
  gagga_1_V = mkV "gaggar" ; -- gagga..vb.1
  gaggande_1_N = mkN "gaggande" ; -- gaggande..nn.1
  gaggig_1_A = mkA "gaggig" ; -- gaggig..av.1
  gaggighet_1_N = mkN "gaggighet" ; -- gaggighet..nn.1
  gagn_1_N = mkN "gagn" neutrum  ; -- gagn..nn.1
  gagna_1_V = mkV "gagnar" ; -- gagna..vb.1
  gagnande_1_N = mkN "gagnande" ; -- gagnande..nn.1
  gagnelig_1_A = mkA "gagnelig" ; -- gagnelig..av.1
  gagnelighet_1_N = mkN "gagnelighet" "gagneligheter" ; -- gagnelighet..nn.1
  gagnerik_1_A = mkA "gagnerik" ; -- gagnerik..av.1
  gagnerikhet_1_N = mkN "gagnerikhet" ; -- gagnerikhet..nn.1
  gagnlös_1_A = mkA "gagnlös" ; -- gagnlös..av.1
  gagnlöshet_1_N = mkN "gagnlöshet" ; -- gagnlöshet..nn.1
  gagnrik_1_A = mkA "gagnrik" ; -- gagnrik..av.1
  gagnrikhet_1_N = mkN "gagnrikhet" ; -- gagnrikhet..nn.1
  gagnvirke_1_N = mkN "gagnvirke" ; -- gagnvirke..nn.1
  gagnväxt_1_N = mkN "gagnväxt" "gagnväxter" ; -- gagnväxt..nn.1
  gaillarde_1_N = mkN "gaillarde" "gaillarder" ; -- gaillarde..nn.1
  gaj_1_N = mkN "gaj" ; -- gaj..nn.1
  gala_1_N = mkN "gala" ; -- gala..nn.1
  gala_2_N = mkN "gala" ; -- gala..nn.2
  galadräkt_1_N = mkN "galadräkt" "galadräkter" ; -- galadräkt..nn.1
  galaföreställning_1_N = mkN "galaföreställning" ; -- galaföreställning..nn.1
  galaklädd_1_A = mkA "galaklädd" ; -- galaklädd..av.1
  galaktisk_1_A = mkA "galaktisk" ; -- galaktisk..av.1
  galaktos_1_N = mkN "galaktos" ; -- galaktos..nn.1
  galalit_1_N = mkN "galalit" ; -- galalit..nn.1
  galamiddag_1_N = mkN "galamiddag" ; -- galamiddag..nn.1
  galande_1_N = mkN "galande" ; -- galande..nn.1
  galant_1_A = mkA "galant" "galant" ; -- galant..av.1
  galanteri_1_N = mkN "galanteri" "galanteriet" "galanterier" "galanterierna" ; -- galanteri..nn.1
  galapremiär_1_N = mkN "galapremiär" "galapremiärer" ; -- galapremiär..nn.1
  galat_1_N = mkN "galat" "galater" ; -- galat..nn.1
  galauniform_1_N = mkN "galauniform" "galauniformer" ; -- galauniform..nn.1
  galavagn_1_N = mkN "galavagn" ; -- galavagn..nn.1
  galax_1_N = mkN "galax" "galaxer" ; -- galax..nn.1
  galaxbildning_1_N = mkN "galaxbildning" ; -- galaxbildning..nn.1
  galaxcentrum_1_N = mkN "galaxcentrum" neutrum  ; -- galaxcentrum..nn.1
  galaxhop_1_N = mkN "galaxhop" ; -- galaxhop..nn.1
  galaxspektrum_1_N = mkN "galaxspektrum" neutrum  ; -- galaxspektrum..nn.1
  galaxvärld_1_N = mkN "galaxvärld" ; -- galaxvärld..nn.1
  galder_1_N = mkN "galder" ; -- galder..nn.1
  galeas_1_N = mkN "galeas" "galeaser" ; -- galeas..nn.1
  galej_1_N = mkN "galej" neutrum  ; -- galej..nn.1
  galeja_1_N = mkN "galeja" ; -- galeja..nn.1
  galen_1_A = mkA "galen" ; -- galen..av.1
  galenhet_1_N = mkN "galenhet" ; -- galenhet..nn.1
  galenpanna_1_N = mkN "galenpanna" ; -- galenpanna..nn.1
  galenskap_1_N = mkN "galenskap" "galenskaper" ; -- galenskap..nn.1
  galgbacke_1_N = mkN "galgbacke" utrum  ; -- galgbacke..nn.1
  galge_1_N = mkN "galge" utrum  ; -- galge..nn.1
  galgenfrist_1_N = mkN "galgenfrist" ; -- galgenfrist..nn.1
  galgfrist_1_N = mkN "galgfrist" ; -- galgfrist..nn.1
  galgfågel_1_N = mkN "galgfågel" ; -- galgfågel..nn.1
  galghumoristisk_1_A = mkA "galghumoristisk" ; -- galghumoristisk..av.1
  galgrep_1_N = mkN "galgrep" neutrum  ; -- galgrep..nn.1
  galicisk_1_A = mkA "galicisk" ; -- galicisk..av.1
  galilé_1_N = mkN "galilé" "galiléer" ; -- galilé..nn.1
  galjon_1_N = mkN "galjon" "galjoner" ; -- galjon..nn.1
  galjonsbild_1_N = mkN "galjonsbild" "galjonsbilder" ; -- galjonsbild..nn.1
  galjonsfigur_1_N = mkN "galjonsfigur" "galjonsfigurer" ; -- galjonsfigur..nn.1
  gall_1_A = mkA "gall" ; -- gall..av.1
  gall_1_N = mkN "gall" "galler" ; -- gall..nn.1
  galla_1_N = mkN "galla" ; -- galla..nn.1
  galla_2_N = mkN "galla" ; -- galla..nn.2
  gallbildning_1_N = mkN "gallbildning" ; -- gallbildning..nn.1
  gallblomma_1_N = mkN "gallblomma" ; -- gallblomma..nn.1
  gallblåsa_1_N = mkN "gallblåsa" ; -- gallblåsa..nn.1
  galldrivande_1_A = mkA "galldrivande" ; -- galldrivande..av.1
  galler_1_N = mkN "galler" neutrum  ; -- galler..nn.1
  galler_2_N = mkN "galler" "gallern" "galler" "gallerna" ; -- galler..nn.2
  gallerdurk_1_N = mkN "gallerdurk" ; -- gallerdurk..nn.1
  gallerdörr_1_N = mkN "gallerdörr" ; -- gallerdörr..nn.1
  gallerformig_1_A = mkA "gallerformig" ; -- gallerformig..av.1
  gallerfönster_1_N = mkN "gallerfönster" neutrum  ; -- gallerfönster..nn.1
  gallerförsedd_1_A = mkA "gallerförsedd" ; -- gallerförsedd..av.1
  gallergrind_1_N = mkN "gallergrind" ; -- gallergrind..nn.1
  galleri_1_N = mkN "galleri" "galleriet" "gallerier" "gallerierna" ; -- galleri..nn.1
  galleria_1_N = mkN "galleria" ; -- galleria..nn.1
  galleriskog_1_N = mkN "galleriskog" ; -- galleriskog..nn.1
  gallerist_1_N = mkN "gallerist" "gallerister" ; -- gallerist..nn.1
  gallerport_1_N = mkN "gallerport" ; -- gallerport..nn.1
  gallerstaket_1_N = mkN "gallerstaket" neutrum  ; -- gallerstaket..nn.1
  gallerverk_1_N = mkN "gallerverk" neutrum  ; -- gallerverk..nn.1
  gallfeber_1_N = mkN "gallfeber" ; -- gallfeber..nn.1
  gallgång_1_N = mkN "gallgång" ; -- gallgång..nn.1
  gallicism_1_N = mkN "gallicism" "gallicismer" ; -- gallicism..nn.1
  gallier_1_N = mkN "gallier" "galliern" "gallier" "gallierna" ; -- gallier..nn.1
  gallimatias_1_N = mkN "gallimatias" ; -- gallimatias..nn.1
  gallimattias_1_N = mkN "gallimattias" ; -- gallimattias..nn.1
  gallion_1_N = mkN "gallion" ; -- gallion..nn.1
  gallisera_1_V = mkV "galliserar" ; -- gallisera..vb.1
  galliserande_1_N = mkN "galliserande" ; -- galliserande..nn.1
  galliserbar_1_A = mkA "galliserbar" ; -- galliserbar..av.1
  galliserbarhet_1_N = mkN "galliserbarhet" ; -- galliserbarhet..nn.1
  gallisering_1_N = mkN "gallisering" ; -- gallisering..nn.1
  gallisering_2_N = mkN "gallisering" ; -- gallisering..nn.2
  gallisk_1_A = mkA "gallisk" ; -- gallisk..av.1
  gallium_1_N = mkN "gallium" neutrum  ; -- gallium..nn.1
  gallko_1_N = mkN "gallko" "gallkor" ; -- gallko..nn.1
  gallkvalster_1_N = mkN "gallkvalster" neutrum  ; -- gallkvalster..nn.1
  gallmygga_1_N = mkN "gallmygga" ; -- gallmygga..nn.1
  gallon_1_N = mkN "gallon" "gallonen" "gallons" "gallonsen" ; -- gallon..nn.1
  gallra_1_V = mkV "gallrar" ; -- gallra..vb.1
  gallrande_1_N = mkN "gallrande" ; -- gallrande..nn.1
  gallring_1_N = mkN "gallring" ; -- gallring..nn.1
  gallsjuk_1_A = mkA "gallsjuk" ; -- gallsjuk..av.1
  gallsjuka_1_N = mkN "gallsjuka" ; -- gallsjuka..nn.1
  gallsjukhet_1_N = mkN "gallsjukhet" ; -- gallsjukhet..nn.1
  gallskrik_1_N = mkN "gallskrik" neutrum  ; -- gallskrik..nn.1
  gallskrika_1_V = mkV "gallskrika" "gallskrek" "gallskrikit" ; -- gallskrika..vb.1
  gallskrikande_1_N = mkN "gallskrikande" ; -- gallskrikande..nn.1
  gallsprängd_1_A = mkA "gallsprängd" "gallsprängt" ; -- gallsprängd..av.1
  gallsprängdhet_1_N = mkN "gallsprängdhet" ; -- gallsprängdhet..nn.1
  gallstekel_1_N = mkN "gallstekel" ; -- gallstekel..nn.1
  gallsten_1_N = mkN "gallsten" "gallstenen" "gallstenar" "gallstenarna" ; -- gallsten..nn.1
  gallsyra_1_N = mkN "gallsyra" ; -- gallsyra..nn.1
  galltjut_1_N = mkN "galltjut" neutrum  ; -- galltjut..nn.1
  galltjuta_1_V = mkV "galltjuta" "galltjöt" "galltjutit" ; -- galltjuta..vb.1
  galltjutande_1_N = mkN "galltjutande" ; -- galltjutande..nn.1
  gallup_1_N = mkN "gallup" ; -- gallup..nn.1
  gallupmätning_1_N = mkN "gallupmätning" ; -- gallupmätning..nn.1
  gallussyra_1_N = mkN "gallussyra" ; -- gallussyra..nn.1
  galläpple_1_N = mkN "galläpple" ; -- galläpple..nn.1
  galmeja_1_N = mkN "galmeja" ; -- galmeja..nn.1
  galning_1_N = mkN "galning" ; -- galning..nn.1
  galon_1_N = mkN "galon" ; -- galon..nn.1
  galon_2_N = mkN "galon" "galoner" ; -- galon..nn.2
  galonbyxa_1_N = mkN "galonbyxa" ; -- galonbyxa..nn.1
  galonerad_1_A = mkA "galonerad" ; -- galonerad..av.1
  galopp_1_N = mkN "galopp" "galopper" ; -- galopp..nn.1
  galoppad_1_N = mkN "galoppad" "galoppader" ; -- galoppad..nn.1
  galoppera_1_V = mkV "galopperar" ; -- galoppera..vb.1
  galopperande_1_N = mkN "galopperande" ; -- galopperande..nn.1
  galoppering_1_N = mkN "galoppering" ; -- galoppering..nn.1
  galoppsport_1_N = mkN "galoppsport" ; -- galoppsport..nn.1
  galopptävling_1_N = mkN "galopptävling" ; -- galopptävling..nn.1
  galosch_1_N = mkN "galosch" "galoscher" ; -- galosch..nn.1
  galoschbett_1_N = mkN "galoschbett" neutrum  ; -- galoschbett..nn.1
  galoschera_1_V = mkV "galoscherar" ; -- galoschera..vb.1
  galoscherande_1_N = mkN "galoscherande" ; -- galoscherande..nn.1
  galoscherbar_1_A = mkA "galoscherbar" ; -- galoscherbar..av.1
  galoscherbarhet_1_N = mkN "galoscherbarhet" ; -- galoscherbarhet..nn.1
  galoschering_1_N = mkN "galoschering" ; -- galoschering..nn.1
  galoschhaka_1_N = mkN "galoschhaka" ; -- galoschhaka..nn.1
  galoschhylla_1_N = mkN "galoschhylla" ; -- galoschhylla..nn.1
  galt_1_N = mkN "galt" ; -- galt..nn.1
  galtlukt_1_N = mkN "galtlukt" ; -- galtlukt..nn.1
  galva_1_V = mkV "galvar" ; -- galva..vb.1
  galvande_1_N = mkN "galvande" ; -- galvande..nn.1
  galvanisera_1_V = mkV "galvaniserar" ; -- galvanisera..vb.1
  galvaniserande_1_N = mkN "galvaniserande" ; -- galvaniserande..nn.1
  galvaniserbar_1_A = mkA "galvaniserbar" ; -- galvaniserbar..av.1
  galvaniserbarhet_1_N = mkN "galvaniserbarhet" ; -- galvaniserbarhet..nn.1
  galvanisering_1_N = mkN "galvanisering" ; -- galvanisering..nn.1
  galvanisk_1_A = mkA "galvanisk" ; -- galvanisk..av.1
  galvanism_1_N = mkN "galvanism" "galvanismer" ; -- galvanism..nn.1
  galvanometer_1_N = mkN "galvanometer" ; -- galvanometer..nn.1
  galvanoplastik_1_N = mkN "galvanoplastik" ; -- galvanoplastik..nn.1
  galvanoskop_1_N = mkN "galvanoskop" neutrum  ; -- galvanoskop..nn.1
  galvanostegi_1_N = mkN "galvanostegi" ; -- galvanostegi..nn.1
  galvanoteknik_1_N = mkN "galvanoteknik" ; -- galvanoteknik..nn.1
  galvanotyp_1_N = mkN "galvanotyp" "galvanotyper" ; -- galvanotyp..nn.1
  galvanotypi_1_N = mkN "galvanotypi" ; -- galvanotypi..nn.1
  galär_1_N = mkN "galär" "galärer" ; -- galär..nn.1
  galärslav_1_N = mkN "galärslav" ; -- galärslav..nn.1
  gam_1_N = mkN "gam" ; -- gam..nn.1
  gama_1_V = mkV "gamar" ; -- gama..vb.1
  gamande_1_N = mkN "gamande" ; -- gamande..nn.1
  gamasch_1_N = mkN "gamasch" "gamascher" ; -- gamasch..nn.1
  gambier_1_N = mkN "gambier" "gambiern" "gambier" "gambierna" ; -- gambier..nn.1
  gambisk_1_A = mkA "gambisk" ; -- gambisk..av.1
  gambiska_1_N = mkN "gambiska" ; -- gambiska..nn.1
  gambit_1_N = mkN "gambit" ; -- gambit..nn.1
  game_1_N = mkN "game" "gamet" "game" "gamen" ; -- game..nn.1
  gamet_1_N = mkN "gamet" "gameter" ; -- gamet..nn.1
  gamling_1_N = mkN "gamling" ; -- gamling..nn.1
  gamma_1_N = mkN "gamma" "gammat" "gamman" "gammana" ; -- gamma..nn.1
  gammafly_1_N = mkN "gammafly" "gammaflyet" "gammaflyn" "gammaflyna" ; -- gammafly..nn.1
  gammaglobulin_1_N = mkN "gammaglobulin" "gammaglobuliner" ; -- gammaglobulin..nn.1
  gammakamera_1_N = mkN "gammakamera" ; -- gammakamera..nn.1
  gammal_1_A = mkA "gammal" "gammalt" "gamla" "äldre" "äldst" ; -- gammal..av.1
  gammaldags_1_A = mkA "gammaldags" ; -- gammaldags..av.1
  gammaldans_1_N = mkN "gammaldans" "gammaldanser" ; -- gammaldans..nn.1
  gammalhöger_1_N = mkN "gammalhöger" ; -- gammalhöger..nn.1
  gammalkommunist_1_N = mkN "gammalkommunist" "gammalkommunister" ; -- gammalkommunist..nn.1
  gammalkristen_1_A = mkA "gammalkristen" ; -- gammalkristen..av.1
  gammalkristenhet_1_N = mkN "gammalkristenhet" ; -- gammalkristenhet..nn.1
  gammalkyrklig_1_A = mkA "gammalkyrklig" ; -- gammalkyrklig..av.1
  gammalkyrklighet_1_N = mkN "gammalkyrklighet" ; -- gammalkyrklighet..nn.1
  gammalmodig_1_A = mkA "gammalmodig" ; -- gammalmodig..av.1
  gammalmodighet_1_N = mkN "gammalmodighet" ; -- gammalmodighet..nn.1
  gammalrosa_1_A = mkA "gammalrosa" ; -- gammalrosa..av.1
  gammalstavning_1_N = mkN "gammalstavning" ; -- gammalstavning..nn.1
  gammaltestamentlig_1_A = mkA "gammaltestamentlig" ; -- gammaltestamentlig..av.1
  gammaltestamentlighet_1_N = mkN "gammaltestamentlighet" ; -- gammaltestamentlighet..nn.1
  gammalvals_1_N = mkN "gammalvals" "gammalvalser" ; -- gammalvals..nn.1
  gamman_1_N = mkN "gamman" ; -- gamman..nn.1
  gammastråle_1_N = mkN "gammastråle" utrum  ; -- gammastråle..nn.1
  gammastrålning_1_N = mkN "gammastrålning" ; -- gammastrålning..nn.1
  gammeldans_1_N = mkN "gammeldans" "gammeldanser" ; -- gammeldans..nn.1
  gammelfeminist_1_N = mkN "gammelfeminist" "gammelfeminister" ; -- gammelfeminist..nn.1
  gammelkommunist_1_N = mkN "gammelkommunist" "gammelkommunister" ; -- gammelkommunist..nn.1
  gammelmedium_1_N = mkN "gammelmedium" "gammelmediet" "gammelmedia" "gammelmediana" ; -- gammelmedium..nn.1
  gammelmoderat_1_N = mkN "gammelmoderat" "gammelmoderater" ; -- gammelmoderat..nn.1
  gammeltantsgarderob_1_N = mkN "gammeltantsgarderob" "gammeltantsgarderober" ; -- gammeltantsgarderob..nn.1
  gammelvals_1_N = mkN "gammelvals" "gammelvalser" ; -- gammelvals..nn.1
  gamäng_1_N = mkN "gamäng" "gamänger" ; -- gamäng..nn.1
  gan_1_N = mkN "gan" ; -- gan..nn.1
  gana_1_V = mkV "ganar" ; -- gana..vb.1
  gana_2_V = mkV "ganar" ; -- gana..vb.2
  ganande_1_N = mkN "ganande" ; -- ganande..nn.1
  ganasch_1_N = mkN "ganasch" "ganascher" ; -- ganasch..nn.1
  gandhiskynke_1_N = mkN "gandhiskynke" ; -- gandhiskynke..nn.1
  ganglie_1_N = mkN "ganglie" "ganglier" ; -- ganglie..nn.1
  gangliecell_1_N = mkN "gangliecell" "ganglieceller" ; -- gangliecell..nn.1
  ganglion_1_N = mkN "ganglion" ; -- ganglion..nn.1
  gangrenös_1_A = mkA "gangrenös" ; -- gangrenös..av.1
  gangrän_1_N = mkN "gangrän" ; -- gangrän..nn.1
  gangster_1_N = mkN "gangster" ; -- gangster..nn.1
  gangsterism_1_N = mkN "gangsterism" "gangsterismer" ; -- gangsterism..nn.1
  gangsterpolare_1_N = mkN "gangsterpolare" utrum  ; -- gangsterpolare..nn.1
  gangsterromantik_1_N = mkN "gangsterromantik" ; -- gangsterromantik..nn.1
  gans_1_N = mkN "gans" "ganser" ; -- gans..nn.1
  ganska_1_Adv = mkAdv "ganska" ; -- ganska..ab.1
  ganymed_1_N = mkN "ganymed" "ganymeder" ; -- ganymed..nn.1
  gap_1_N = mkN "gap" neutrum  ; -- gap..nn.1
  gap_2_N = mkN "gap" neutrum  ; -- gap..nn.2
  gapa_1_V = mkV "gapar" ; -- gapa..vb.1
  gapande_1_N = mkN "gapande" ; -- gapande..nn.1
  gapflabb_1_N = mkN "gapflabb" neutrum  ; -- gapflabb..nn.1
  gapflabba_1_V = mkV "gapflabbar" ; -- gapflabba..vb.1
  gapflabbande_1_N = mkN "gapflabbande" ; -- gapflabbande..nn.1
  gaphals_1_N = mkN "gaphals" ; -- gaphals..nn.1
  gapig_1_A = mkA "gapig" ; -- gapig..av.1
  gapighet_1_N = mkN "gapighet" ; -- gapighet..nn.1
  gapning_1_N = mkN "gapning" ; -- gapning..nn.1
  gapsax_1_N = mkN "gapsax" ; -- gapsax..nn.1
  gapskratt_1_N = mkN "gapskratt" neutrum  ; -- gapskratt..nn.1
  gapskratta_1_V = mkV "gapskrattar" ; -- gapskratta..vb.1
  gapskrattande_1_N = mkN "gapskrattande" ; -- gapskrattande..nn.1
  gapstock_1_N = mkN "gapstock" ; -- gapstock..nn.1
  gara_1_V = mkV "garar" ; -- gara..vb.1
  garage_1_N = mkN "garage" "garaget" "garage" "garagen" ; -- garage..nn.1
  garagedomkraft_1_N = mkN "garagedomkraft" "garagedomkrafter" ; -- garagedomkraft..nn.1
  garagera_1_V = mkV "garagerar" ; -- garagera..vb.1
  garagerande_1_N = mkN "garagerande" ; -- garagerande..nn.1
  garagerbar_1_A = mkA "garagerbar" ; -- garagerbar..av.1
  garagerbarhet_1_N = mkN "garagerbarhet" ; -- garagerbarhet..nn.1
  garagering_1_N = mkN "garagering" ; -- garagering..nn.1
  garageuppfart_1_N = mkN "garageuppfart" "garageuppfarter" ; -- garageuppfart..nn.1
  garagevakt_1_N = mkN "garagevakt" "garagevakter" ; -- garagevakt..nn.1
  garande_1_N = mkN "garande" ; -- garande..nn.1
  garant_1_N = mkN "garant" "garanter" ; -- garant..nn.1
  garantera_1_V = mkV "garanterar" ; -- garantera..vb.1
  garanterande_1_N = mkN "garanterande" ; -- garanterande..nn.1
  garanterbar_1_A = mkA "garanterbar" ; -- garanterbar..av.1
  garanterbarhet_1_N = mkN "garanterbarhet" ; -- garanterbarhet..nn.1
  garantering_1_N = mkN "garantering" ; -- garantering..nn.1
  garanti_1_N = mkN "garanti" "garantier" ; -- garanti..nn.1
  garantibelopp_1_N = mkN "garantibelopp" neutrum  ; -- garantibelopp..nn.1
  garantibevis_1_N = mkN "garantibevis" neutrum  ; -- garantibevis..nn.1
  garantifond_1_N = mkN "garantifond" "garantifonder" ; -- garantifond..nn.1
  garantifördrag_1_N = mkN "garantifördrag" neutrum  ; -- garantifördrag..nn.1
  garantiförsäkring_1_N = mkN "garantiförsäkring" ; -- garantiförsäkring..nn.1
  garantilån_1_N = mkN "garantilån" neutrum  ; -- garantilån..nn.1
  garantisumma_1_N = mkN "garantisumma" ; -- garantisumma..nn.1
  gard_1_N = mkN "gard" "garder" ; -- gard..nn.1
  garde_1_N = mkN "garde" ; -- garde..nn.1
  gardenia_1_N = mkN "gardenia" ; -- gardenia..nn.1
  gardera_1_V = mkV "garderar" ; -- gardera..vb.1
  garderande_1_N = mkN "garderande" ; -- garderande..nn.1
  garderbar_1_A = mkA "garderbar" ; -- garderbar..av.1
  garderbarhet_1_N = mkN "garderbarhet" ; -- garderbarhet..nn.1
  gardering_1_N = mkN "gardering" ; -- gardering..nn.1
  garderob_1_N = mkN "garderob" "garderober" ; -- garderob..nn.1
  garderobiär_1_N = mkN "garderobiär" "garderobiärer" ; -- garderobiär..nn.1
  garderobié_1_N = mkN "garderobié" "garderobiéer" ; -- garderobié..nn.1
  garderobsbög_1_N = mkN "garderobsbög" ; -- garderobsbög..nn.1
  garderobsdörr_1_N = mkN "garderobsdörr" ; -- garderobsdörr..nn.1
  garderobsmässig_1_A = mkA "garderobsmässig" ; -- garderobsmässig..av.1
  garderobssorg_1_N = mkN "garderobssorg" ; -- garderobssorg..nn.1
  garderobsstång_1_N = mkN "garderobsstång" "garderobsstänger" ; -- garderobsstång..nn.1
  gardessoldat_1_N = mkN "gardessoldat" "gardessoldater" ; -- gardessoldat..nn.1
  gardian_1_N = mkN "gardian" "gardianer" ; -- gardian..nn.1
  gardin_1_N = mkN "gardin" "gardiner" ; -- gardin..nn.1
  gardinband_1_N = mkN "gardinband" neutrum  ; -- gardinband..nn.1
  gardinkappa_1_N = mkN "gardinkappa" ; -- gardinkappa..nn.1
  gardinkrok_1_N = mkN "gardinkrok" ; -- gardinkrok..nn.1
  gardinluft_1_N = mkN "gardinluft" "gardinlufter" ; -- gardinluft..nn.1
  gardinring_1_N = mkN "gardinring" ; -- gardinring..nn.1
  gardinspringa_1_N = mkN "gardinspringa" ; -- gardinspringa..nn.1
  gardinstång_1_N = mkN "gardinstång" "gardinstänger" ; -- gardinstång..nn.1
  gardist_1_N = mkN "gardist" "gardister" ; -- gardist..nn.1
  gardjärn_1_N = mkN "gardjärn" neutrum  ; -- gardjärn..nn.1
  gardställning_1_N = mkN "gardställning" ; -- gardställning..nn.1
  garfågel_1_N = mkN "garfågel" ; -- garfågel..nn.1
  garn_1_N = mkN "garn" neutrum  ; -- garn..nn.1
  garnbom_1_N = mkN "garnbom" "garnbommen" "garnbommar" "garnbommarna" ; -- garnbom..nn.1
  garndocka_1_N = mkN "garndocka" ; -- garndocka..nn.1
  garnera_1_V = mkV "garnerar" ; -- garnera..vb.1
  garnerande_1_N = mkN "garnerande" ; -- garnerande..nn.1
  garnerbar_1_A = mkA "garnerbar" ; -- garnerbar..av.1
  garnerbarhet_1_N = mkN "garnerbarhet" ; -- garnerbarhet..nn.1
  garnering_1_N = mkN "garnering" ; -- garnering..nn.1
  garnhank_1_N = mkN "garnhank" ; -- garnhank..nn.1
  garnhärva_1_N = mkN "garnhärva" ; -- garnhärva..nn.1
  garnison_1_N = mkN "garnison" "garnisoner" ; -- garnison..nn.1
  garnisonera_1_V = mkV "garnisonerar" ; -- garnisonera..vb.1
  garnisonerande_1_N = mkN "garnisonerande" ; -- garnisonerande..nn.1
  garnisonerbar_1_A = mkA "garnisonerbar" ; -- garnisonerbar..av.1
  garnisonerbarhet_1_N = mkN "garnisonerbarhet" ; -- garnisonerbarhet..nn.1
  garnisonering_1_N = mkN "garnisonering" ; -- garnisonering..nn.1
  garnisonspräst_1_N = mkN "garnisonspräst" "garnisonspräster" ; -- garnisonspräst..nn.1
  garnityr_1_N = mkN "garnityr" neutrum  ; -- garnityr..nn.1
  garnnystan_1_N = mkN "garnnystan" neutrum  ; -- garnnystan..nn.1
  garnspole_1_N = mkN "garnspole" utrum  ; -- garnspole..nn.1
  garrottera_1_V = mkV "garrotterar" ; -- garrottera..vb.1
  garrotterande_1_N = mkN "garrotterande" ; -- garrotterande..nn.1
  garrotterbar_1_A = mkA "garrotterbar" ; -- garrotterbar..av.1
  garrotterbarhet_1_N = mkN "garrotterbarhet" ; -- garrotterbarhet..nn.1
  garrottering_1_N = mkN "garrottering" ; -- garrottering..nn.1
  garsong_1_N = mkN "garsong" "garsonger" ; -- garsong..nn.1
  gartner_1_N = mkN "gartner" "gartnern" "gartner" "gartnerna" ; -- gartner..nn.1
  garv_1_N = mkN "garv" neutrum  ; -- garv..nn.1
  garva_1_V = mkV "garvar" ; -- garva..vb.1
  garvad_1_A = mkA "garvad" ; -- garvad..av.1
  garvande_1_N = mkN "garvande" ; -- garvande..nn.1
  garvare_1_N = mkN "garvare" utrum  ; -- garvare..nn.1
  garveri_1_N = mkN "garveri" "garveriet" "garverier" "garverierna" ; -- garveri..nn.1
  garvmedel_1_N = mkN "garvmedel" neutrum  ; -- garvmedel..nn.1
  garvning_1_N = mkN "garvning" ; -- garvning..nn.1
  garvsyra_1_N = mkN "garvsyra" ; -- garvsyra..nn.1
  garvämne_1_N = mkN "garvämne" ; -- garvämne..nn.1
  garçon_1_N = mkN "garçon" "garçoner" ; -- garçon..nn.1
  gas_1_N = mkN "gas" "gaser" ; -- gas..nn.1
  gas_2_N = mkN "gas" "gaser" ; -- gas..nn.2
  gasa_1_V = mkV "gasar" ; -- gasa..vb.1
  gasa_2_V = mkV "gasar" ; -- gasa..vb.2
  gasackumulator_1_N = mkN "gasackumulator" "gasackumulatorer" ; -- gasackumulator..nn.1
  gasande_1_N = mkN "gasande" ; -- gasande..nn.1
  gasartad_1_A = mkA "gasartad" ; -- gasartad..av.1
  gasbetong_1_N = mkN "gasbetong" ; -- gasbetong..nn.1
  gasbil_1_N = mkN "gasbil" ; -- gasbil..nn.1
  gasbilsförsäljning_1_N = mkN "gasbilsförsäljning" ; -- gasbilsförsäljning..nn.1
  gasbinda_1_N = mkN "gasbinda" ; -- gasbinda..nn.1
  gasblandning_1_N = mkN "gasblandning" ; -- gasblandning..nn.1
  gasbrand_1_N = mkN "gasbrand" ; -- gasbrand..nn.1
  gasbrist_1_N = mkN "gasbrist" ; -- gasbrist..nn.1
  gasbrännare_1_N = mkN "gasbrännare" utrum  ; -- gasbrännare..nn.1
  gasbubbla_1_N = mkN "gasbubbla" ; -- gasbubbla..nn.1
  gascognare_1_N = mkN "gascognare" utrum  ; -- gascognare..nn.1
  gasdriven_1_A = mkA "gasdriven" ; -- gasdriven..av.1
  gasdynamik_1_N = mkN "gasdynamik" ; -- gasdynamik..nn.1
  gasell_1_N = mkN "gasell" "gaseller" ; -- gasell..nn.1
  gaseruption_1_N = mkN "gaseruption" ; -- gaseruption..nn.1
  gasett_1_N = mkN "gasett" "gasetter" ; -- gasett..nn.1
  gasexplosion_1_N = mkN "gasexplosion" ; -- gasexplosion..nn.1
  gasform_1_N = mkN "gasform" ; -- gasform..nn.1
  gasformig_1_A = mkA "gasformig" ; -- gasformig..av.1
  gasförgiftning_1_N = mkN "gasförgiftning" ; -- gasförgiftning..nn.1
  gasgenerator_1_N = mkN "gasgenerator" "gasgeneratorer" ; -- gasgenerator..nn.1
  gashydrat_1_N = mkN "gashydrat" "gashydrater" ; -- gashydrat..nn.1
  gask_1_N = mkN "gask" ; -- gask..nn.1
  gaskammare_1_N = mkN "gaskammare" "gaskammaren" "gaskammare" "gaskamrarna" ; -- gaskammare..nn.1
  gaskatastrof_1_N = mkN "gaskatastrof" "gaskatastrofer" ; -- gaskatastrof..nn.1
  gasklocka_1_N = mkN "gasklocka" ; -- gasklocka..nn.1
  gasklot_1_N = mkN "gasklot" neutrum  ; -- gasklot..nn.1
  gaskran_1_N = mkN "gaskran" ; -- gaskran..nn.1
  gaskromatograf_1_N = mkN "gaskromatograf" "gaskromatografer" ; -- gaskromatograf..nn.1
  gaskromatografi_1_N = mkN "gaskromatografi" ; -- gaskromatografi..nn.1
  gaskropp_1_N = mkN "gaskropp" ; -- gaskropp..nn.1
  gaskök_1_N = mkN "gaskök" neutrum  ; -- gaskök..nn.1
  gaslampa_1_N = mkN "gaslampa" ; -- gaslampa..nn.1
  gasledning_1_N = mkN "gasledning" ; -- gasledning..nn.1
  gaslykta_1_N = mkN "gaslykta" ; -- gaslykta..nn.1
  gasläcka_1_N = mkN "gasläcka" ; -- gasläcka..nn.1
  gasläckage_1_N = mkN "gasläckage" "gasläckaget" "gasläckage" "gasläckagen" ; -- gasläckage..nn.1
  gaslära_1_N = mkN "gaslära" ; -- gaslära..nn.1
  gaslåga_1_N = mkN "gaslåga" ; -- gaslåga..nn.1
  gasmask_1_N = mkN "gasmask" "gasmasker" ; -- gasmask..nn.1
  gasmaskfodral_1_N = mkN "gasmaskfodral" neutrum  ; -- gasmaskfodral..nn.1
  gasmassa_1_N = mkN "gasmassa" ; -- gasmassa..nn.1
  gasmoln_1_N = mkN "gasmoln" neutrum  ; -- gasmoln..nn.1
  gasmotor_1_N = mkN "gasmotor" "gasmotorer" ; -- gasmotor..nn.1
  gasol_1_N = mkN "gasol" ; -- gasol..nn.1
  gasolgrill_1_N = mkN "gasolgrill" ; -- gasolgrill..nn.1
  gasolin_1_N = mkN "gasolin" ; -- gasolin..nn.1
  gasolkök_1_N = mkN "gasolkök" neutrum  ; -- gasolkök..nn.1
  gasoltub_1_N = mkN "gasoltub" "gasoltuber" ; -- gasoltub..nn.1
  gasometer_1_N = mkN "gasometer" ; -- gasometer..nn.1
  gaspedal_1_N = mkN "gaspedal" "gaspedaler" ; -- gaspedal..nn.1
  gaspollett_1_N = mkN "gaspollett" "gaspolletter" ; -- gaspollett..nn.1
  gasreglage_1_N = mkN "gasreglage" "gasreglaget" "gasreglage" "gasreglagen" ; -- gasreglage..nn.1
  gasrik_1_A = mkA "gasrik" ; -- gasrik..av.1
  gasrikedom_1_N = mkN "gasrikedom" ; -- gasrikedom..nn.1
  gasräkning_1_N = mkN "gasräkning" ; -- gasräkning..nn.1
  gass_1_N = mkN "gass" neutrum  ; -- gass..nn.1
  gassa_1_V = mkV "gassar" ; -- gassa..vb.1
  gassande_1_N = mkN "gassande" ; -- gassande..nn.1
  gassig_1_A = mkA "gassig" ; -- gassig..av.1
  gassighet_1_N = mkN "gassighet" ; -- gassighet..nn.1
  gasskiva_1_N = mkN "gasskiva" ; -- gasskiva..nn.1
  gasskydd_1_N = mkN "gasskydd" neutrum  ; -- gasskydd..nn.1
  gasspis_1_N = mkN "gasspis" ; -- gasspis..nn.1
  gasström_1_N = mkN "gasström" "gasströmmen" "gasströmmar" "gasströmmarna" ; -- gasström..nn.1
  gassvetsning_1_N = mkN "gassvetsning" ; -- gassvetsning..nn.1
  gast_1_N = mkN "gast" ; -- gast..nn.1
  gasta_1_V = mkV "gastar" ; -- gasta..vb.1
  gastande_1_N = mkN "gastande" ; -- gastande..nn.1
  gastera_1_V = mkV "gasterar" ; -- gastera..vb.1
  gasterande_1_N = mkN "gasterande" ; -- gasterande..nn.1
  gastering_1_N = mkN "gastering" ; -- gastering..nn.1
  gastkrama_1_V = mkV "gastkramar" ; -- gastkrama..vb.1
  gastkramande_1_N = mkN "gastkramande" ; -- gastkramande..nn.1
  gastkramning_1_N = mkN "gastkramning" ; -- gastkramning..nn.1
  gastrisk_1_A = mkA "gastrisk" ; -- gastrisk..av.1
  gastrit_1_N = mkN "gastrit" "gastriter" ; -- gastrit..nn.1
  gastrointestinal_1_A = mkA "gastrointestinal" ; -- gastrointestinal..av.1
  gastronom_1_N = mkN "gastronom" "gastronomer" ; -- gastronom..nn.1
  gastronomi_1_N = mkN "gastronomi" ; -- gastronomi..nn.1
  gastronomisk_1_A = mkA "gastronomisk" ; -- gastronomisk..av.1
  gastroskop_1_N = mkN "gastroskop" neutrum  ; -- gastroskop..nn.1
  gastroskopera_1_V = mkV "gastroskoperar" ; -- gastroskopera..vb.1
  gastroskoperande_1_N = mkN "gastroskoperande" ; -- gastroskoperande..nn.1
  gastroskoperbar_1_A = mkA "gastroskoperbar" ; -- gastroskoperbar..av.1
  gastroskoperbarhet_1_N = mkN "gastroskoperbarhet" ; -- gastroskoperbarhet..nn.1
  gastroskopering_1_N = mkN "gastroskopering" ; -- gastroskopering..nn.1
  gastroskopi_1_N = mkN "gastroskopi" "gastroskopier" ; -- gastroskopi..nn.1
  gastrulering_1_N = mkN "gastrulering" ; -- gastrulering..nn.1
  gastryck_1_N = mkN "gastryck" neutrum  ; -- gastryck..nn.1
  gastub_1_N = mkN "gastub" "gastuber" ; -- gastub..nn.1
  gasturbin_1_N = mkN "gasturbin" "gasturbiner" ; -- gasturbin..nn.1
  gasurladdning_1_N = mkN "gasurladdning" ; -- gasurladdning..nn.1
  gasutsläpp_1_N = mkN "gasutsläpp" neutrum  ; -- gasutsläpp..nn.1
  gasutveckling_1_N = mkN "gasutveckling" ; -- gasutveckling..nn.1
  gasventil_1_N = mkN "gasventil" "gasventiler" ; -- gasventil..nn.1
  gasverk_1_N = mkN "gasverk" neutrum  ; -- gasverk..nn.1
  gasväv_1_N = mkN "gasväv" ; -- gasväv..nn.1
  gata_1_N = mkN "gata" ; -- gata..nn.1
  gate_1_N = mkN "gate" "gater" ; -- gate..nn.1
  gatflicka_1_N = mkN "gatflicka" ; -- gatflicka..nn.1
  gathus_1_N = mkN "gathus" neutrum  ; -- gathus..nn.1
  gathörn_1_N = mkN "gathörn" neutrum  ; -- gathörn..nn.1
  gatlopp_1_N = mkN "gatlopp" neutrum  ; -- gatlopp..nn.1
  gatlykta_1_N = mkN "gatlykta" ; -- gatlykta..nn.1
  gatläggning_1_N = mkN "gatläggning" ; -- gatläggning..nn.1
  gatpojke_1_N = mkN "gatpojke" utrum  ; -- gatpojke..nn.1
  gatslinka_1_N = mkN "gatslinka" ; -- gatslinka..nn.1
  gatsmuts_1_N = mkN "gatsmuts" ; -- gatsmuts..nn.1
  gatsopare_1_N = mkN "gatsopare" utrum  ; -- gatsopare..nn.1
  gatsten_1_N = mkN "gatsten" "gatstenen" "gatstenar" "gatstenarna" ; -- gatsten..nn.1
  gatt_1_N = mkN "gatt" neutrum  ; -- gatt..nn.1
  gatubarn_1_N = mkN "gatubarn" neutrum  ; -- gatubarn..nn.1
  gatubelysning_1_N = mkN "gatubelysning" ; -- gatubelysning..nn.1
  gatubeläggning_1_N = mkN "gatubeläggning" ; -- gatubeläggning..nn.1
  gatubuller_1_N = mkN "gatubuller" neutrum  ; -- gatubuller..nn.1
  gatudemonstration_1_N = mkN "gatudemonstration" ; -- gatudemonstration..nn.1
  gatufred_1_N = mkN "gatufred" ; -- gatufred..nn.1
  gatufrid_1_N = mkN "gatufrid" ; -- gatufrid..nn.1
  gatuförsäljare_1_N = mkN "gatuförsäljare" utrum  ; -- gatuförsäljare..nn.1
  gatuhus_1_N = mkN "gatuhus" neutrum  ; -- gatuhus..nn.1
  gatukonst_1_N = mkN "gatukonst" ; -- gatukonst..nn.1
  gatukontor_1_N = mkN "gatukontor" neutrum  ; -- gatukontor..nn.1
  gatukors_1_N = mkN "gatukors" neutrum  ; -- gatukors..nn.1
  gatukorsning_1_N = mkN "gatukorsning" ; -- gatukorsning..nn.1
  gatukök_1_N = mkN "gatukök" neutrum  ; -- gatukök..nn.1
  gatuliv_1_N = mkN "gatuliv" neutrum  ; -- gatuliv..nn.1
  gatumanifestation_1_N = mkN "gatumanifestation" ; -- gatumanifestation..nn.1
  gatumusik_1_N = mkN "gatumusik" ; -- gatumusik..nn.1
  gatumusikant_1_N = mkN "gatumusikant" "gatumusikanter" ; -- gatumusikant..nn.1
  gatunamn_1_N = mkN "gatunamn" neutrum  ; -- gatunamn..nn.1
  gatunge_1_N = mkN "gatunge" utrum  ; -- gatunge..nn.1
  gatuparti_1_N = mkN "gatuparti" "gatupartiet" "gatupartier" "gatupartierna" ; -- gatuparti..nn.1
  gatuplan_1_N = mkN "gatuplan" neutrum  ; -- gatuplan..nn.1
  gatupoesi_1_N = mkN "gatupoesi" ; -- gatupoesi..nn.1
  gatupris_1_N = mkN "gatupris" neutrum  ; -- gatupris..nn.1
  gatuprostituerad_1_A = mkA "gatuprostituerad" ; -- gatuprostituerad..av.1
  gatuprotest_1_N = mkN "gatuprotest" "gatuprotester" ; -- gatuprotest..nn.1
  gatuscen_1_N = mkN "gatuscen" "gatuscener" ; -- gatuscen..nn.1
  gatusmuts_1_N = mkN "gatusmuts" ; -- gatusmuts..nn.1
  gatuspråk_1_N = mkN "gatuspråk" neutrum  ; -- gatuspråk..nn.1
  gatustånd_1_N = mkN "gatustånd" neutrum  ; -- gatustånd..nn.1
  gatuteater_1_N = mkN "gatuteater" ; -- gatuteater..nn.1
  gatuvimmel_1_N = mkN "gatuvimmel" neutrum  ; -- gatuvimmel..nn.1
  gatuvåld_1_N = mkN "gatuvåld" neutrum  ; -- gatuvåld..nn.1
  gatuvåldsbekämpning_1_N = mkN "gatuvåldsbekämpning" ; -- gatuvåldsbekämpning..nn.1
  gatuvåldsgrupp_1_N = mkN "gatuvåldsgrupp" "gatuvåldsgrupper" ; -- gatuvåldsgrupp..nn.1
  gaucho_1_N = mkN "gaucho" "gauchor" ; -- gaucho..nn.1
  gauffrera_1_V = mkV "gauffrerar" ; -- gauffrera..vb.1
  gauffrerande_1_N = mkN "gauffrerande" ; -- gauffrerande..nn.1
  gauffrerbar_1_A = mkA "gauffrerbar" ; -- gauffrerbar..av.1
  gauffrerbarhet_1_N = mkN "gauffrerbarhet" ; -- gauffrerbarhet..nn.1
  gauffrering_1_N = mkN "gauffrering" ; -- gauffrering..nn.1
  gauge_1_N = mkN "gauge" "gaugen" "gauge" "gaugena" ; -- gauge..nn.1
  gaullism_1_N = mkN "gaullism" "gaullismer" ; -- gaullism..nn.1
  gaullist_1_N = mkN "gaullist" "gaullister" ; -- gaullist..nn.1
  gaullistisk_1_A = mkA "gaullistisk" ; -- gaullistisk..av.1
  gaur_1_N = mkN "gaur" "gaurer" ; -- gaur..nn.1
  gauss_1_N = mkN "gauss" "gaussen" "gauss" "gaussen" ; -- gauss..nn.1
  gausskurva_1_N = mkN "gausskurva" ; -- gausskurva..nn.1
  gavel_1_N = mkN "gavel" ; -- gavel..nn.1
  gavelfält_1_N = mkN "gavelfält" neutrum  ; -- gavelfält..nn.1
  gavelhus_1_N = mkN "gavelhus" neutrum  ; -- gavelhus..nn.1
  gavelröst_1_N = mkN "gavelröst" neutrum  ; -- gavelröst..nn.1
  gavelröste_1_N = mkN "gavelröste" ; -- gavelröste..nn.1
  gavelspets_1_N = mkN "gavelspets" ; -- gavelspets..nn.1
  gavial_1_N = mkN "gavial" "gavialer" ; -- gavial..nn.1
  gavott_1_N = mkN "gavott" "gavotter" ; -- gavott..nn.1
  gay_1_A = mkA "gay" ; -- gay..av.1
  gayal_1_N = mkN "gayal" "gayaler" ; -- gayal..nn.1
  gayscout_1_N = mkN "gayscout" "gayscouter" ; -- gayscout..nn.1
  ge_1_V = mkV "giva" "gav" "givit" ; -- ge..vb.1
  gebit_1_N = mkN "gebit" neutrum  ; -- gebit..nn.1
  gecko_1_N = mkN "gecko" "geckor" ; -- gecko..nn.1
  geckoödla_1_N = mkN "geckoödla" ; -- geckoödla..nn.1
  gedigen_1_A = mkA "gedigen" ; -- gedigen..av.1
  gedigenhet_1_N = mkN "gedigenhet" ; -- gedigenhet..nn.1
  geende_1_N = mkN "geende" ; -- geende..nn.1
  geg_1_N = mkN "geg" "geger" ; -- geg..nn.1
  gegg_1_N = mkN "gegg" ; -- gegg..nn.1
  gegga_1_N = mkN "gegga" ; -- gegga..nn.1
  gegga_1_V = mkV "geggar" ; -- gegga..vb.1
  geggamoja_1_N = mkN "geggamoja" ; -- geggamoja..nn.1
  geggande_1_N = mkN "geggande" ; -- geggande..nn.1
  geggig_1_A = mkA "geggig" ; -- geggig..av.1
  geggighet_1_N = mkN "geggighet" ; -- geggighet..nn.1
  geheimeråd_1_N = mkN "geheimeråd" neutrum  ; -- geheimeråd..nn.1
  gehäng_1_N = mkN "gehäng" neutrum  ; -- gehäng..nn.1
  gehör_1_N = mkN "gehör" neutrum  ; -- gehör..nn.1
  geiger_müllerrör_1_N = mkN "geiger-müllerrör" neutrum  ; -- geiger-müllerrör..nn.1
  geigermätare_1_N = mkN "geigermätare" utrum  ; -- geigermätare..nn.1
  geisha_1_N = mkN "geisha" ; -- geisha..nn.1
  geist_1_N = mkN "geist" ; -- geist..nn.1
  gejd_1_N = mkN "gejd" "gejder" ; -- gejd..nn.1
  gejser_1_N = mkN "gejser" ; -- gejser..nn.1
  gel_1_N = mkN "gel" "gelet" "geler" "gelerna" ; -- gel..nn.1
  gelada_1_N = mkN "gelada" ; -- gelada..nn.1
  gelatin_1_N = mkN "gelatin" ; -- gelatin..nn.1
  gelatinera_1_V = mkV "gelatinerar" ; -- gelatinera..vb.1
  gelatinerande_1_N = mkN "gelatinerande" ; -- gelatinerande..nn.1
  gelatinerbar_1_A = mkA "gelatinerbar" ; -- gelatinerbar..av.1
  gelatinerbarhet_1_N = mkN "gelatinerbarhet" ; -- gelatinerbarhet..nn.1
  gelatinering_1_N = mkN "gelatinering" ; -- gelatinering..nn.1
  gelatinkapsel_1_N = mkN "gelatinkapsel" ; -- gelatinkapsel..nn.1
  gelatinös_1_A = mkA "gelatinös" ; -- gelatinös..av.1
  gelbgjutare_1_N = mkN "gelbgjutare" utrum  ; -- gelbgjutare..nn.1
  gelbgjuteri_1_N = mkN "gelbgjuteri" "gelbgjuteriet" "gelbgjuterier" "gelbgjuterierna" ; -- gelbgjuteri..nn.1
  gelcoat_1_N = mkN "gelcoat" ; -- gelcoat..nn.1
  gelea_1_V = mkV "gelear" ; -- gelea..vb.1
  geleande_1_N = mkN "geleande" ; -- geleande..nn.1
  geleig_1_A = mkA "geleig" ; -- geleig..av.1
  gelform_1_N = mkN "gelform" ; -- gelform..nn.1
  gelike_1_N = mkN "gelike" utrum  ; -- gelike..nn.1
  gelänk_1_N = mkN "gelänk" neutrum  ; -- gelänk..nn.1
  gelé_1_N = mkN "gelé" "geléer" ; -- gelé..nn.1
  geléaktig_1_A = mkA "geléaktig" ; -- geléaktig..av.1
  geléartad_1_A = mkA "geléartad" ; -- geléartad..av.1
  geléhallon_1_N = mkN "geléhallon" neutrum  ; -- geléhallon..nn.1
  geléklump_1_N = mkN "geléklump" ; -- geléklump..nn.1
  geléråtta_1_N = mkN "geléråtta" ; -- geléråtta..nn.1
  gelésvamp_1_N = mkN "gelésvamp" ; -- gelésvamp..nn.1
  gem_1_N = mkN "gem" "gemmen" "gemmer" "gemmerna" ; -- gem..nn.1
  gem_2_N = mkN "gem" neutrum  ; -- gem..nn.2
  gemak_1_N = mkN "gemak" neutrum  ; -- gemak..nn.1
  gematri_1_N = mkN "gematri" ; -- gematri..nn.1
  gemen_1_A = mkA "gemen" "gement" ; -- gemen..av.1
  gemenhet_1_N = mkN "gemenhet" "gemenheter" ; -- gemenhet..nn.1
  gemenligen_1_Adv = mkAdv "gemenligen" ; -- gemenligen..ab.1
  gemensam_1_A = mkA "gemensam" "gemensamt" "gemensamma" "gemensamma" "gemensammare" "gemensammast" "gemensammaste" ; -- gemensam..av.1
  gemensamhet_1_N = mkN "gemensamhet" "gemensamheter" ; -- gemensamhet..nn.1
  gemensamhetsgrav_1_N = mkN "gemensamhetsgrav" ; -- gemensamhetsgrav..nn.1
  gemensamhetskänsla_1_N = mkN "gemensamhetskänsla" ; -- gemensamhetskänsla..nn.1
  gemenskap_1_N = mkN "gemenskap" ; -- gemenskap..nn.1
  gemenskap_2_N = mkN "gemenskap" "gemenskaper" ; -- gemenskap..nn.2
  gemenskapsform_1_N = mkN "gemenskapsform" "gemenskapsformer" ; -- gemenskapsform..nn.1
  gemination_1_N = mkN "gemination" ; -- gemination..nn.1
  geminera_1_V = mkV "geminerar" ; -- geminera..vb.1
  geminerande_1_N = mkN "geminerande" ; -- geminerande..nn.1
  geminerbar_1_A = mkA "geminerbar" ; -- geminerbar..av.1
  geminerbarhet_1_N = mkN "geminerbarhet" ; -- geminerbarhet..nn.1
  geminering_1_N = mkN "geminering" ; -- geminering..nn.1
  gemmologi_1_N = mkN "gemmologi" ; -- gemmologi..nn.1
  gems_1_N = mkN "gems" "gemser" ; -- gems..nn.1
  gemyt_1_N = mkN "gemyt" neutrum  ; -- gemyt..nn.1
  gemytlig_1_A = mkA "gemytlig" ; -- gemytlig..av.1
  gemytlighet_1_N = mkN "gemytlighet" "gemytligheter" ; -- gemytlighet..nn.1
  gemål_1_N = mkN "gemål" "gemåler" ; -- gemål..nn.1
  gen_1_A = mkA "gen" ; -- gen..av.1
  gen_1_N = mkN "gen" "gener" ; -- gen..nn.1
  gena_1_V = mkV "genar" ; -- gena..vb.1
  genande_1_N = mkN "genande" ; -- genande..nn.1
  genans_1_N = mkN "genans" ; -- genans..nn.1
  genant_1_A = mkA "genant" "genant" ; -- genant..av.1
  genast_1_Adv = mkAdv "genast" ; -- genast..ab.1
  genbank_1_N = mkN "genbank" "genbanker" ; -- genbank..nn.1
  genbankning_1_N = mkN "genbankning" ; -- genbankning..nn.1
  gendarm_1_N = mkN "gendarm" "gendarmer" ; -- gendarm..nn.1
  gendarmeri_1_N = mkN "gendarmeri" neutrum  ; -- gendarmeri..nn.1
  gendriva_1_V = mkV "gendriva" "gendrev" "gendrivit" ; -- gendriva..vb.1
  gendrivande_1_N = mkN "gendrivande" ; -- gendrivande..nn.1
  gendrivning_1_N = mkN "gendrivning" ; -- gendrivning..nn.1
  genealog_1_N = mkN "genealog" "genealoger" ; -- genealog..nn.1
  genealogi_1_N = mkN "genealogi" "genealogier" ; -- genealogi..nn.1
  genealogisk_1_A = mkA "genealogisk" ; -- genealogisk..av.1
  genera_1_V = mkV "generar" ; -- genera..vb.1
  generad_1_A = mkA "generad" ; -- generad..av.1
  general_1_N = mkN "general" "generaler" ; -- general..nn.1
  generalagent_1_N = mkN "generalagent" "generalagenter" ; -- generalagent..nn.1
  generalangrepp_1_N = mkN "generalangrepp" neutrum  ; -- generalangrepp..nn.1
  generalbas_1_N = mkN "generalbas" ; -- generalbas..nn.1
  generalbefälhavare_1_N = mkN "generalbefälhavare" utrum  ; -- generalbefälhavare..nn.1
  generaldirektör_1_N = mkN "generaldirektör" "generaldirektörer" ; -- generaldirektör..nn.1
  generalfel_1_N = mkN "generalfel" "generalfelet" "generalfel" "generalfelen" ; -- generalfel..nn.1
  generalförsamling_1_N = mkN "generalförsamling" ; -- generalförsamling..nn.1
  generalguvernör_1_N = mkN "generalguvernör" "generalguvernörer" ; -- generalguvernör..nn.1
  generalisation_1_N = mkN "generalisation" ; -- generalisation..nn.1
  generalisera_1_V = mkV "generaliserar" ; -- generalisera..vb.1
  generaliserande_1_N = mkN "generaliserande" ; -- generaliserande..nn.1
  generaliserbar_1_A = mkA "generaliserbar" ; -- generaliserbar..av.1
  generaliserbarhet_1_N = mkN "generaliserbarhet" ; -- generaliserbarhet..nn.1
  generalisering_1_N = mkN "generalisering" ; -- generalisering..nn.1
  generaliseringsprocess_1_N = mkN "generaliseringsprocess" "generaliseringsprocesser" ; -- generaliseringsprocess..nn.1
  generalissimus_1_N = mkN "generalissimus" ; -- generalissimus..nn.1
  generalist_1_N = mkN "generalist" "generalister" ; -- generalist..nn.1
  generalitet_1_N = mkN "generalitet" neutrum  ; -- generalitet..nn.1
  generalitet_2_N = mkN "generalitet" "generaliteter" ; -- generalitet..nn.2
  generalkarta_1_N = mkN "generalkarta" ; -- generalkarta..nn.1
  generalkonsul_1_N = mkN "generalkonsul" "generalkonsuln" "generalkonsuler" "generalkonsulerna" ; -- generalkonsul..nn.1
  generalkonsulat_1_N = mkN "generalkonsulat" neutrum  ; -- generalkonsulat..nn.1
  generallöjtnant_1_N = mkN "generallöjtnant" "generallöjtnanter" ; -- generallöjtnant..nn.1
  generalmajor_1_N = mkN "generalmajor" "generalmajorer" ; -- generalmajor..nn.1
  generalmönstring_1_N = mkN "generalmönstring" ; -- generalmönstring..nn.1
  generalorder_1_N = mkN "generalorder" ; -- generalorder..nn.1
  generalpaus_1_N = mkN "generalpaus" "generalpauser" ; -- generalpaus..nn.1
  generalplan_1_N = mkN "generalplan" "generalplaner" ; -- generalplan..nn.1
  generalplanemässig_1_A = mkA "generalplanemässig" ; -- generalplanemässig..av.1
  generalpostdirektör_1_N = mkN "generalpostdirektör" "generalpostdirektörer" ; -- generalpostdirektör..nn.1
  generalprevention_1_N = mkN "generalprevention" ; -- generalprevention..nn.1
  generalrep_1_N = mkN "generalrep" neutrum  ; -- generalrep..nn.1
  generalrepetition_1_N = mkN "generalrepetition" ; -- generalrepetition..nn.1
  generalsekreterare_1_N = mkN "generalsekreterare" utrum  ; -- generalsekreterare..nn.1
  generalska_1_N = mkN "generalska" ; -- generalska..nn.1
  generalsperson_1_N = mkN "generalsperson" "generalspersoner" ; -- generalsperson..nn.1
  generalstab_1_N = mkN "generalstab" "generalstaber" ; -- generalstab..nn.1
  generalstabskarta_1_N = mkN "generalstabskarta" ; -- generalstabskarta..nn.1
  generalstabsnivå_1_N = mkN "generalstabsnivå" "generalstabsnivåer" ; -- generalstabsnivå..nn.1
  generalstrejk_1_N = mkN "generalstrejk" "generalstrejker" ; -- generalstrejk..nn.1
  generalöverste_1_N = mkN "generalöverste" utrum  ; -- generalöverste..nn.1
  generande_1_A = mkA "generande" ; -- generande..av.1
  generande_1_N = mkN "generande" ; -- generande..nn.1
  generation_1_N = mkN "generation" ; -- generation..nn.1
  generationskamrat_1_N = mkN "generationskamrat" "generationskamrater" ; -- generationskamrat..nn.1
  generationsklyfta_1_N = mkN "generationsklyfta" ; -- generationsklyfta..nn.1
  generationskonflikt_1_N = mkN "generationskonflikt" "generationskonflikter" ; -- generationskonflikt..nn.1
  generationsmässig_1_A = mkA "generationsmässig" ; -- generationsmässig..av.1
  generationsskifte_1_N = mkN "generationsskifte" ; -- generationsskifte..nn.1
  generationstid_1_N = mkN "generationstid" "generationstider" ; -- generationstid..nn.1
  generationsväxling_1_N = mkN "generationsväxling" ; -- generationsväxling..nn.1
  generationsöverskridande_1_A = mkA "generationsöverskridande" ; -- generationsöverskridande..av.1
  generativ_1_A = mkA "generativ" ; -- generativ..av.1
  generator_1_N = mkN "generator" "generatorer" ; -- generator..nn.1
  generatorgas_1_N = mkN "generatorgas" ; -- generatorgas..nn.1
  generatris_1_N = mkN "generatris" "generatriser" ; -- generatris..nn.1
  generbar_1_A = mkA "generbar" ; -- generbar..av.1
  generbarhet_1_N = mkN "generbarhet" ; -- generbarhet..nn.1
  generell_1_A = mkA "generell" ; -- generell..av.1
  generera_1_V = mkV "genererar" ; -- generera..vb.1
  genererande_1_N = mkN "genererande" ; -- genererande..nn.1
  genererbar_1_A = mkA "genererbar" ; -- genererbar..av.1
  genererbarhet_1_N = mkN "genererbarhet" ; -- genererbarhet..nn.1
  generering_1_N = mkN "generering" ; -- generering..nn.1
  genering_1_N = mkN "genering" ; -- genering..nn.1
  generisk_1_A = mkA "generisk" ; -- generisk..av.1
  generositet_1_N = mkN "generositet" "generositeter" ; -- generositet..nn.1
  generös_1_A = mkA "generös" ; -- generös..av.1
  genes_1_N = mkN "genes" ; -- genes..nn.1
  genetik_1_N = mkN "genetik" ; -- genetik..nn.1
  genetiker_1_N = mkN "genetiker" "genetikern" "genetiker" "genetikerna" ; -- genetiker..nn.1
  genetisk_1_A = mkA "genetisk" ; -- genetisk..av.1
  genett_1_N = mkN "genett" "genetter" ; -- genett..nn.1
  genever_1_N = mkN "genever" ; -- genever..nn.1
  genflöde_1_N = mkN "genflöde" ; -- genflöde..nn.1
  genfordran_1_N = mkN "genfordran" "genfordran" "genfordringar" "genfordringarna" ; -- genfordran..nn.1
  genfordring_1_N = mkN "genfordring" ; -- genfordring..nn.1
  genförändrad_1_A = mkA "genförändrad" ; -- genförändrad..av.1
  genförändring_1_N = mkN "genförändring" ; -- genförändring..nn.1
  gengas_1_N = mkN "gengas" ; -- gengas..nn.1
  gengälda_1_V = mkV "gengäldar" ; -- gengälda..vb.1
  gengäldande_1_N = mkN "gengäldande" ; -- gengäldande..nn.1
  gengångare_1_N = mkN "gengångare" utrum  ; -- gengångare..nn.1
  gengångarlik_1_A = mkA "gengångarlik" ; -- gengångarlik..av.1
  gengångarlikhet_1_N = mkN "gengångarlikhet" ; -- gengångarlikhet..nn.1
  gengåva_1_N = mkN "gengåva" ; -- gengåva..nn.1
  geni_1_N = mkN "geni" "geniet" "genier" "genierna" ; -- geni..nn.1
  genial_1_A = mkA "genial" ; -- genial..av.1
  genialisk_1_A = mkA "genialisk" ; -- genialisk..av.1
  genialitet_1_N = mkN "genialitet" "genialiteter" ; -- genialitet..nn.1
  genidrag_1_N = mkN "genidrag" neutrum  ; -- genidrag..nn.1
  genie_1_N = mkN "genie" "genier" ; -- genie..nn.1
  genital_1_A = mkA "genital" ; -- genital..av.1
  genitiv_1_N = mkN "genitiv" "genitiver" ; -- genitiv..nn.1
  genitivattribut_1_N = mkN "genitivattribut" neutrum  ; -- genitivattribut..nn.1
  genitivmetafor_1_N = mkN "genitivmetafor" "genitivmetaforen" "genitivmetaforer" "genitivmetaforerna" ; -- genitivmetafor..nn.1
  genitivändelse_1_N = mkN "genitivändelse" "genitivändelser" ; -- genitivändelse..nn.1
  genius_1_N = mkN "genius" ; -- genius..nn.1
  genklang_1_N = mkN "genklang" ; -- genklang..nn.1
  genkärande_1_N = mkN "genkärande" "genkäranden" "genkäranden" "genkärandena" ; -- genkärande..nn.1
  genljud_1_N = mkN "genljud" neutrum  ; -- genljud..nn.1
  genljuda_1_V = mkV "genljuda" "genljöd" "genljudit" ; -- genljuda..vb.1
  genljudande_1_N = mkN "genljudande" ; -- genljudande..nn.1
  genmanipulation_1_N = mkN "genmanipulation" ; -- genmanipulation..nn.1
  genmanipulationsteknik_1_N = mkN "genmanipulationsteknik" "genmanipulationstekniker" ; -- genmanipulationsteknik..nn.1
  genmanipulera_1_V = mkV "genmanipulerar" ; -- genmanipulera..vb.1
  genmanipulerande_1_N = mkN "genmanipulerande" ; -- genmanipulerande..nn.1
  genmanipulerbar_1_A = mkA "genmanipulerbar" ; -- genmanipulerbar..av.1
  genmanipulerbarhet_1_N = mkN "genmanipulerbarhet" ; -- genmanipulerbarhet..nn.1
  genmanipulering_1_N = mkN "genmanipulering" ; -- genmanipulering..nn.1
  genmodifiera_1_V = mkV "genmodifierar" ; -- genmodifiera..vb.1
  genmodifierad_1_A = mkA "genmodifierad" ; -- genmodifierad..av.1
  genmodifiering_1_N = mkN "genmodifiering" ; -- genmodifiering..nn.1
  genmäla_1_V = mkV "genmäler" ; -- genmäla..vb.1
  genmälande_1_N = mkN "genmälande" ; -- genmälande..nn.1
  genmäle_1_N = mkN "genmäle" ; -- genmäle..nn.1
  genocid_1_N = mkN "genocid" "genocider" ; -- genocid..nn.1
  genom_1_N = mkN "genom" neutrum  ; -- genom..nn.1
  genomarbeta_1_V = mkV "genomarbetar" ; -- genomarbeta..vb.1
  genomarbetande_1_N = mkN "genomarbetande" ; -- genomarbetande..nn.1
  genomarbetning_1_N = mkN "genomarbetning" ; -- genomarbetning..nn.1
  genombiten_1_A = mkA "genombiten" ; -- genombiten..av.1
  genomblicka_1_V = mkV "genomblickar" ; -- genomblicka..vb.1
  genomblickbar_1_A = mkA "genomblickbar" ; -- genomblickbar..av.1
  genombläddring_1_N = mkN "genombläddring" ; -- genombläddring..nn.1
  genomblödning_1_N = mkN "genomblödning" ; -- genomblödning..nn.1
  genomblöt_1_A = mkA "genomblöt" ; -- genomblöt..av.1
  genomborra_1_V = mkV "genomborrar" ; -- genomborra..vb.1
  genomborrande_1_N = mkN "genomborrande" ; -- genomborrande..nn.1
  genomborrning_1_N = mkN "genomborrning" ; -- genomborrning..nn.1
  genombrott_1_N = mkN "genombrott" neutrum  ; -- genombrott..nn.1
  genombrottsbok_1_N = mkN "genombrottsbok" "genombrottsböcker" ; -- genombrottsbok..nn.1
  genombruten_1_A = mkA "genombruten" ; -- genombruten..av.1
  genombryta_1_V = mkV "genombryta" "genombröt" "genombrutit" ; -- genombryta..vb.1
  genombrytande_1_N = mkN "genombrytande" ; -- genombrytande..nn.1
  genombrytning_1_N = mkN "genombrytning" ; -- genombrytning..nn.1
  genomdragning_1_N = mkN "genomdragning" ; -- genomdragning..nn.1
  genomdriva_1_V = mkV "genomdriva" "genomdrev" "genomdrivit" ; -- genomdriva..vb.1
  genomdrivande_1_N = mkN "genomdrivande" ; -- genomdrivande..nn.1
  genomdriven_1_A = mkA "genomdriven" ; -- genomdriven..av.1
  genomdränka_1_V = mkV "genomdränkar" ; -- genomdränka..vb.1
  genomdränkande_1_N = mkN "genomdränkande" ; -- genomdränkande..nn.1
  genomdränkning_1_N = mkN "genomdränkning" ; -- genomdränkning..nn.1
  genomdum_1_A = mkA "genomdum" "genomdumt" "genomdumma" "genomdumma" "genomdummare" "genomdummast" "genomdummaste" ; -- genomdum..av.1
  genomdumhet_1_N = mkN "genomdumhet" ; -- genomdumhet..nn.1
  genomelak_1_A = mkA "genomelak" ; -- genomelak..av.1
  genomfara_1_V = mkV "genomfara" "genomfor" "genomfarit" ; -- genomfara..vb.1
  genomfarande_1_N = mkN "genomfarande" ; -- genomfarande..nn.1
  genomfart_1_N = mkN "genomfart" "genomfarter" ; -- genomfart..nn.1
  genomfartsgata_1_N = mkN "genomfartsgata" ; -- genomfartsgata..nn.1
  genomfartsled_1_N = mkN "genomfartsled" "genomfartsleder" ; -- genomfartsled..nn.1
  genomfartsväg_1_N = mkN "genomfartsväg" ; -- genomfartsväg..nn.1
  genomforskning_1_N = mkN "genomforskning" ; -- genomforskning..nn.1
  genomfärd_1_N = mkN "genomfärd" ; -- genomfärd..nn.1
  genomföra_1_V = mkV "genomföra" "genomförde" "genomfört" ; -- genomföra..vb.1
  genomförande_1_N = mkN "genomförande" ; -- genomförande..nn.1
  genomförbar_1_A = mkA "genomförbar" ; -- genomförbar..av.1
  genomförbarhet_1_N = mkN "genomförbarhet" ; -- genomförbarhet..nn.1
  genomföring_1_N = mkN "genomföring" ; -- genomföring..nn.1
  genomförkyld_1_A = mkA "genomförkyld" "genomförkylt" ; -- genomförkyld..av.1
  genomförning_1_N = mkN "genomförning" ; -- genomförning..nn.1
  genomgod_1_A = mkA "genomgod" "genomgott" ; -- genomgod..av.1
  genomgripande_1_A = mkA "genomgripande" ; -- genomgripande..av.1
  genomgrädda_1_V = mkV "genomgräddar" ; -- genomgrädda..vb.1
  genomgräddning_1_N = mkN "genomgräddning" ; -- genomgräddning..nn.1
  genomgå_1_V = mkV "genomgå" "genomgår" "genomgå" "genomgick" "genomgått" "genomgången" ; -- genomgå..vb.1
  genomgående_1_A = mkA "genomgående" ; -- genomgående..av.1
  genomgående_1_N = mkN "genomgående" ; -- genomgående..nn.1
  genomgång_1_N = mkN "genomgång" ; -- genomgång..nn.1
  genomhederlig_1_A = mkA "genomhederlig" ; -- genomhederlig..av.1
  genomik_1_N = mkN "genomik" "genomiker" ; -- genomik..nn.1
  genomklappning_1_N = mkN "genomklappning" ; -- genomklappning..nn.1
  genomkoka_1_V = mkV "genomkoker" ; -- genomkoka..vb.1
  genomkokande_1_N = mkN "genomkokande" ; -- genomkokande..nn.1
  genomkokning_1_N = mkN "genomkokning" ; -- genomkokning..nn.1
  genomkomponerad_1_A = mkA "genomkomponerad" ; -- genomkomponerad..av.1
  genomkorsa_1_V = mkV "genomkorsar" ; -- genomkorsa..vb.1
  genomkorsande_1_N = mkN "genomkorsande" ; -- genomkorsande..nn.1
  genomkorsning_1_N = mkN "genomkorsning" ; -- genomkorsning..nn.1
  genomkylning_1_N = mkN "genomkylning" ; -- genomkylning..nn.1
  genomkörare_1_N = mkN "genomkörare" utrum  ; -- genomkörare..nn.1
  genomletning_1_N = mkN "genomletning" ; -- genomletning..nn.1
  genomleva_1_V = mkV "genomlever" ; -- genomleva..vb.1
  genomlevande_1_N = mkN "genomlevande" ; -- genomlevande..nn.1
  genomlida_1_V = mkV "genomlida" "genomled" "genomlidit" ; -- genomlida..vb.1
  genomlidande_1_N = mkN "genomlidande" ; -- genomlidande..nn.1
  genomlysa_1_V = mkV "genomlyser" ; -- genomlysa..vb.1
  genomlysande_1_A = mkA "genomlysande" ; -- genomlysande..av.1
  genomlysande_1_N = mkN "genomlysande" ; -- genomlysande..nn.1
  genomlysning_1_N = mkN "genomlysning" ; -- genomlysning..nn.1
  genomläsning_1_N = mkN "genomläsning" ; -- genomläsning..nn.1
  genomlöpa_1_V = mkV "genomlöper" ; -- genomlöpa..vb.1
  genomlöpande_1_N = mkN "genomlöpande" ; -- genomlöpande..nn.1
  genommarsch_1_N = mkN "genommarsch" "genommarscher" ; -- genommarsch..nn.1
  genommönstring_1_N = mkN "genommönstring" ; -- genommönstring..nn.1
  genomorganiserad_1_A = mkA "genomorganiserad" ; -- genomorganiserad..av.1
  genomresa_1_N = mkN "genomresa" ; -- genomresa..nn.1
  genomrostad_1_A = mkA "genomrostad" ; -- genomrostad..av.1
  genomräkning_1_N = mkN "genomräkning" ; -- genomräkning..nn.1
  genomseende_1_N = mkN "genomseende" ; -- genomseende..nn.1
  genomsippra_1_V = mkV "genomsipprar" ; -- genomsippra..vb.1
  genomsipprande_1_N = mkN "genomsipprande" ; -- genomsipprande..nn.1
  genomsippring_1_N = mkN "genomsippring" ; -- genomsippring..nn.1
  genomskinlig_1_A = mkA "genomskinlig" ; -- genomskinlig..av.1
  genomskinlighet_1_N = mkN "genomskinlighet" ; -- genomskinlighet..nn.1
  genomskärning_1_N = mkN "genomskärning" ; -- genomskärning..nn.1
  genomskärningsyta_1_N = mkN "genomskärningsyta" ; -- genomskärningsyta..nn.1
  genomskåda_1_V = mkV "genomskådar" ; -- genomskåda..vb.1
  genomskådande_1_N = mkN "genomskådande" ; -- genomskådande..nn.1
  genomskölja_1_V = mkV "genomskölja" "genomsköljde" "genomsköljt" ; -- genomskölja..vb.1
  genomsköljande_1_N = mkN "genomsköljande" ; -- genomsköljande..nn.1
  genomslag_1_N = mkN "genomslag" neutrum  ; -- genomslag..nn.1
  genomslagsförmåga_1_N = mkN "genomslagsförmåga" ; -- genomslagsförmåga..nn.1
  genomslagskopia_1_N = mkN "genomslagskopia" ; -- genomslagskopia..nn.1
  genomslagskraft_1_N = mkN "genomslagskraft" ; -- genomslagskraft..nn.1
  genomslagspapper_1_N = mkN "genomslagspapper" neutrum  ; -- genomslagspapper..nn.1
  genomsläpplig_1_A = mkA "genomsläpplig" ; -- genomsläpplig..av.1
  genomsläpplighet_1_N = mkN "genomsläpplighet" "genomsläppligheter" ; -- genomsläpplighet..nn.1
  genomsläppning_1_N = mkN "genomsläppning" ; -- genomsläppning..nn.1
  genomsnitt_1_N = mkN "genomsnitt" neutrum  ; -- genomsnitt..nn.1
  genomsnittlig_1_A = mkA "genomsnittlig" ; -- genomsnittlig..av.1
  genomsnittlighet_1_N = mkN "genomsnittlighet" ; -- genomsnittlighet..nn.1
  genomsnittsinkomst_1_N = mkN "genomsnittsinkomst" "genomsnittsinkomster" ; -- genomsnittsinkomst..nn.1
  genomsnittsmänniska_1_N = mkN "genomsnittsmänniska" ; -- genomsnittsmänniska..nn.1
  genomsnittsskatt_1_N = mkN "genomsnittsskatt" "genomsnittsskatter" ; -- genomsnittsskatt..nn.1
  genomsnittssvensk_1_N = mkN "genomsnittssvensk" ; -- genomsnittssvensk..nn.1
  genomsnittsvärde_1_N = mkN "genomsnittsvärde" ; -- genomsnittsvärde..nn.1
  genomsnokning_1_N = mkN "genomsnokning" ; -- genomsnokning..nn.1
  genomsnäll_1_A = mkA "genomsnäll" ; -- genomsnäll..av.1
  genomsteka_1_V = mkV "genomsteker" ; -- genomsteka..vb.1
  genomströmma_1_V = mkV "genomströmmar" ; -- genomströmma..vb.1
  genomströmmande_1_N = mkN "genomströmmande" ; -- genomströmmande..nn.1
  genomströmning_1_N = mkN "genomströmning" ; -- genomströmning..nn.1
  genomstucken_1_A = mkA "genomstucken" ; -- genomstucken..av.1
  genomsur_1_A = mkA "genomsur" ; -- genomsur..av.1
  genomsvettig_1_A = mkA "genomsvettig" ; -- genomsvettig..av.1
  genomsvettighet_1_N = mkN "genomsvettighet" ; -- genomsvettighet..nn.1
  genomsyra_1_V = mkV "genomsyrar" ; -- genomsyra..vb.1
  genomsyrande_1_N = mkN "genomsyrande" ; -- genomsyrande..nn.1
  genomsyrning_1_N = mkN "genomsyrning" ; -- genomsyrning..nn.1
  genomsöka_1_V = mkV "genomsöker" ; -- genomsöka..vb.1
  genomsökande_1_N = mkN "genomsökande" ; -- genomsökande..nn.1
  genomsökning_1_N = mkN "genomsökning" ; -- genomsökning..nn.1
  genomtrampning_1_N = mkN "genomtrampning" ; -- genomtrampning..nn.1
  genomtryckt_1_A = mkA "genomtryckt" "genomtryckt" ; -- genomtryckt..av.1
  genomtränga_1_V = mkV "genomtränger" ; -- genomtränga..vb.1
  genomträngande_1_A = mkA "genomträngande" ; -- genomträngande..av.1
  genomträngande_1_N = mkN "genomträngande" ; -- genomträngande..nn.1
  genomtränglig_1_A = mkA "genomtränglig" ; -- genomtränglig..av.1
  genomtränglighet_1_N = mkN "genomtränglighet" ; -- genomtränglighet..nn.1
  genomträngning_1_N = mkN "genomträngning" ; -- genomträngning..nn.1
  genomträngningsförmåga_1_N = mkN "genomträngningsförmåga" ; -- genomträngningsförmåga..nn.1
  genomtrött_1_A = mkA "genomtrött" ; -- genomtrött..av.1
  genomtänka_1_V = mkV "genomtänker" ; -- genomtänka..vb.1
  genomtänkande_1_N = mkN "genomtänkande" ; -- genomtänkande..nn.1
  genomtänkt_1_A = mkA "genomtänkt" "genomtänkt" ; -- genomtänkt..av.1
  genomtänkthet_1_N = mkN "genomtänkthet" ; -- genomtänkthet..nn.1
  genomtåg_1_N = mkN "genomtåg" neutrum  ; -- genomtåg..nn.1
  genomusel_1_A = mkA "genomusel" ; -- genomusel..av.1
  genomvarm_1_A = mkA "genomvarm" ; -- genomvarm..av.1
  genomvärma_1_V = mkV "genomvärmer" ; -- genomvärma..vb.1
  genomvärmning_1_N = mkN "genomvärmning" ; -- genomvärmning..nn.1
  genomvävd_1_A = mkA "genomvävd" "genomvävt" ; -- genomvävd..av.1
  genomvåt_1_A = mkA "genomvåt" ; -- genomvåt..av.1
  genomärlig_1_A = mkA "genomärlig" ; -- genomärlig..av.1
  genotyp_1_N = mkN "genotyp" "genotyper" ; -- genotyp..nn.1
  genpool_1_N = mkN "genpool" "genpooler" ; -- genpool..nn.1
  genre_1_N = mkN "genre" "genrer" ; -- genre..nn.1
  genremässig_1_A = mkA "genremässig" ; -- genremässig..av.1
  genremålare_1_N = mkN "genremålare" utrum  ; -- genremålare..nn.1
  genremålning_1_N = mkN "genremålning" ; -- genremålning..nn.1
  genremålning_2_N = mkN "genremålning" ; -- genremålning..nn.2
  genrep_1_N = mkN "genrep" neutrum  ; -- genrep..nn.1
  genrestycke_1_N = mkN "genrestycke" ; -- genrestycke..nn.1
  genretavla_1_N = mkN "genretavla" ; -- genretavla..nn.1
  genretänjande_1_A = mkA "genretänjande" ; -- genretänjande..av.1
  gensaga_1_N = mkN "gensaga" ; -- gensaga..nn.1
  gensare_1_N = mkN "gensare" utrum  ; -- gensare..nn.1
  genskjuta_1_V = mkV "genskjuta" "gensköt" "genskjutit" ; -- genskjuta..vb.1
  genskjutande_1_N = mkN "genskjutande" ; -- genskjutande..nn.1
  genskjutning_1_N = mkN "genskjutning" ; -- genskjutning..nn.1
  genstridig_1_A = mkA "genstridig" ; -- genstridig..av.1
  genstridighet_1_N = mkN "genstridighet" ; -- genstridighet..nn.1
  gensträvig_1_A = mkA "gensträvig" ; -- gensträvig..av.1
  gensträvighet_1_N = mkN "gensträvighet" ; -- gensträvighet..nn.1
  genstämning_1_N = mkN "genstämning" ; -- genstämning..nn.1
  genstörtig_1_A = mkA "genstörtig" ; -- genstörtig..av.1
  genstörtighet_1_N = mkN "genstörtighet" ; -- genstörtighet..nn.1
  gensvar_1_N = mkN "gensvar" neutrum  ; -- gensvar..nn.1
  gensägelse_1_N = mkN "gensägelse" "gensägelser" ; -- gensägelse..nn.1
  genta_1_V = mkV "gentaga" "gentog" "gentagit" ; -- genta..vb.1
  gentagande_1_N = mkN "gentagande" ; -- gentagande..nn.1
  genteknik_1_N = mkN "genteknik" ; -- genteknik..nn.1
  genterapi_1_N = mkN "genterapi" "genterapier" ; -- genterapi..nn.1
  genterapibehandling_1_N = mkN "genterapibehandling" ; -- genterapibehandling..nn.1
  gentiana_1_N = mkN "gentiana" ; -- gentiana..nn.1
  gentil_1_A = mkA "gentil" ; -- gentil..av.1
  gentiljess_1_N = mkN "gentiljess" ; -- gentiljess..nn.1
  gentjänst_1_N = mkN "gentjänst" "gentjänster" ; -- gentjänst..nn.1
  gentleman_1_N = mkN "gentleman" "gentlemannen" "gentlemän" "gentlemännen" ; -- gentleman..nn.1
  gentlemannabeslut_1_N = mkN "gentlemannabeslut" neutrum  ; -- gentlemannabeslut..nn.1
  gentlemannablod_1_N = mkN "gentlemannablod" neutrum  ; -- gentlemannablod..nn.1
  gentlemannalik_1_A = mkA "gentlemannalik" ; -- gentlemannalik..av.1
  gentlemannamässig_1_A = mkA "gentlemannamässig" ; -- gentlemannamässig..av.1
  genua_1_N = mkN "genua" ; -- genua..nn.1
  genuafock_1_N = mkN "genuafock" ; -- genuafock..nn.1
  genuin_1_A = mkA "genuin" ; -- genuin..av.1
  genus_1_N = mkN "genus" neutrum  ; -- genus..nn.1
  genusforskning_1_N = mkN "genusforskning" ; -- genusforskning..nn.1
  genusmässig_1_A = mkA "genusmässig" ; -- genusmässig..av.1
  genusperspektiv_1_N = mkN "genusperspektiv" neutrum  ; -- genusperspektiv..nn.1
  genusvetenskap_1_N = mkN "genusvetenskap" "genusvetenskaper" ; -- genusvetenskap..nn.1
  genväg_1_N = mkN "genväg" ; -- genväg..nn.1
  geocentrisk_1_A = mkA "geocentrisk" ; -- geocentrisk..av.1
  geodata_1_N = mkN "geodata" "geodatat" "geodata" "geodatana" ; -- geodata..nn.1
  geodesi_1_N = mkN "geodesi" ; -- geodesi..nn.1
  geodet_1_N = mkN "geodet" "geodeter" ; -- geodet..nn.1
  geodetisk_1_A = mkA "geodetisk" ; -- geodetisk..av.1
  geodimeter_1_N = mkN "geodimeter" ; -- geodimeter..nn.1
  geodynamik_1_N = mkN "geodynamik" ; -- geodynamik..nn.1
  geofon_1_N = mkN "geofon" "geofoner" ; -- geofon..nn.1
  geofysik_1_N = mkN "geofysik" ; -- geofysik..nn.1
  geofysisk_1_A = mkA "geofysisk" ; -- geofysisk..av.1
  geograf_1_N = mkN "geograf" "geografer" ; -- geograf..nn.1
  geografi_1_N = mkN "geografi" ; -- geografi..nn.1
  geografibok_1_N = mkN "geografibok" "geografiböcker" ; -- geografibok..nn.1
  geografisk_1_A = mkA "geografisk" ; -- geografisk..av.1
  geoid_1_N = mkN "geoid" ; -- geoid..nn.1
  geokemi_1_N = mkN "geokemi" ; -- geokemi..nn.1
  geokemisk_1_A = mkA "geokemisk" ; -- geokemisk..av.1
  geokronologi_1_N = mkN "geokronologi" ; -- geokronologi..nn.1
  geokronologisk_1_A = mkA "geokronologisk" ; -- geokronologisk..av.1
  geolog_1_N = mkN "geolog" "geologer" ; -- geolog..nn.1
  geologi_1_N = mkN "geologi" ; -- geologi..nn.1
  geologiprofessor_1_N = mkN "geologiprofessor" "geologiprofessorer" ; -- geologiprofessor..nn.1
  geologisk_1_A = mkA "geologisk" ; -- geologisk..av.1
  geometri_1_N = mkN "geometri" "geometrier" ; -- geometri..nn.1
  geometriker_1_N = mkN "geometriker" "geometrikern" "geometriker" "geometrikerna" ; -- geometriker..nn.1
  geometrisera_1_V = mkV "geometriserar" ; -- geometrisera..vb.1
  geometriserande_1_N = mkN "geometriserande" ; -- geometriserande..nn.1
  geometriserbar_1_A = mkA "geometriserbar" ; -- geometriserbar..av.1
  geometriserbarhet_1_N = mkN "geometriserbarhet" ; -- geometriserbarhet..nn.1
  geometrisering_1_N = mkN "geometrisering" ; -- geometrisering..nn.1
  geometrisk_1_A = mkA "geometrisk" ; -- geometrisk..av.1
  geomorfologi_1_N = mkN "geomorfologi" ; -- geomorfologi..nn.1
  geomorfologisk_1_A = mkA "geomorfologisk" ; -- geomorfologisk..av.1
  geopolitik_1_N = mkN "geopolitik" ; -- geopolitik..nn.1
  geopolitiker_1_N = mkN "geopolitiker" "geopolitikern" "geopolitiker" "geopolitikerna" ; -- geopolitiker..nn.1
  geopolitisk_1_A = mkA "geopolitisk" ; -- geopolitisk..av.1
  georgette_1_N = mkN "georgette" utrum  ; -- georgette..nn.1
  georgiansk_1_A = mkA "georgiansk" ; -- georgiansk..av.1
  georgianskhet_1_N = mkN "georgianskhet" ; -- georgianskhet..nn.1
  georgier_1_N = mkN "georgier" "georgiern" "georgier" "georgierna" ; -- georgier..nn.1
  georgisk_1_A = mkA "georgisk" ; -- georgisk..av.1
  georgiska_1_N = mkN "georgiska" ; -- georgiska..nn.1
  georgiska_2_N = mkN "georgiska" ; -- georgiska..nn.2
  georgskors_1_N = mkN "georgskors" neutrum  ; -- georgskors..nn.1
  geostationär_1_A = mkA "geostationär" ; -- geostationär..av.1
  geostrategisk_1_A = mkA "geostrategisk" ; -- geostrategisk..av.1
  geosynklinal_1_N = mkN "geosynklinal" "geosynklinaler" ; -- geosynklinal..nn.1
  geotagga_1_V = mkV "geotaggar" ; -- geotagga..vb.1
  geotaggande_1_N = mkN "geotaggande" ; -- geotaggande..nn.1
  geoteknik_1_N = mkN "geoteknik" ; -- geoteknik..nn.1
  geoteknisk_1_A = mkA "geoteknisk" ; -- geoteknisk..av.1
  geotermi_1_N = mkN "geotermi" ; -- geotermi..nn.1
  geotermisk_1_A = mkA "geotermisk" ; -- geotermisk..av.1
  geotropism_1_N = mkN "geotropism" "geotropismer" ; -- geotropism..nn.1
  geovetare_1_N = mkN "geovetare" utrum  ; -- geovetare..nn.1
  geovetenskap_1_N = mkN "geovetenskap" "geovetenskaper" ; -- geovetenskap..nn.1
  geovetenskaplig_1_A = mkA "geovetenskaplig" ; -- geovetenskaplig..av.1
  geovärme_1_N = mkN "geovärme" utrum  ; -- geovärme..nn.1
  gepard_1_N = mkN "gepard" "geparder" ; -- gepard..nn.1
  gepardunge_1_N = mkN "gepardunge" utrum  ; -- gepardunge..nn.1
  gepäck_1_N = mkN "gepäck" neutrum  ; -- gepäck..nn.1
  geranium_1_N = mkN "geranium" "geranien" "geranier" "geranierna" ; -- geranium..nn.1
  geriatri_1_N = mkN "geriatri" ; -- geriatri..nn.1
  geriatrik_1_N = mkN "geriatrik" ; -- geriatrik..nn.1
  geriatrisk_1_A = mkA "geriatrisk" ; -- geriatrisk..av.1
  geridon_1_N = mkN "geridon" "geridoner" ; -- geridon..nn.1
  geridong_1_N = mkN "geridong" "geridonger" ; -- geridong..nn.1
  gerilla_1_N = mkN "gerilla" ; -- gerilla..nn.1
  gerilladåd_1_N = mkN "gerilladåd" neutrum  ; -- gerilladåd..nn.1
  gerillakrig_1_N = mkN "gerillakrig" neutrum  ; -- gerillakrig..nn.1
  gerillakrigare_1_N = mkN "gerillakrigare" utrum  ; -- gerillakrigare..nn.1
  gerillaledare_1_N = mkN "gerillaledare" utrum  ; -- gerillaledare..nn.1
  gerillarörelse_1_N = mkN "gerillarörelse" "gerillarörelser" ; -- gerillarörelse..nn.1
  gerillaveteran_1_N = mkN "gerillaveteran" "gerillaveteraner" ; -- gerillaveteran..nn.1
  gering_1_N = mkN "gering" ; -- gering..nn.1
  geringslåda_1_N = mkN "geringslåda" ; -- geringslåda..nn.1
  geringssåg_1_N = mkN "geringssåg" ; -- geringssåg..nn.1
  german_1_N = mkN "german" "germaner" ; -- german..nn.1
  germanfolk_1_N = mkN "germanfolk" neutrum  ; -- germanfolk..nn.1
  germanisera_1_V = mkV "germaniserar" ; -- germanisera..vb.1
  germaniserande_1_N = mkN "germaniserande" ; -- germaniserande..nn.1
  germaniserbar_1_A = mkA "germaniserbar" ; -- germaniserbar..av.1
  germaniserbarhet_1_N = mkN "germaniserbarhet" ; -- germaniserbarhet..nn.1
  germanisering_1_N = mkN "germanisering" ; -- germanisering..nn.1
  germanism_1_N = mkN "germanism" "germanismer" ; -- germanism..nn.1
  germanist_1_N = mkN "germanist" "germanister" ; -- germanist..nn.1
  germanistik_1_N = mkN "germanistik" ; -- germanistik..nn.1
  germanistisk_1_A = mkA "germanistisk" ; -- germanistisk..av.1
  germanium_1_N = mkN "germanium" neutrum  ; -- germanium..nn.1
  germankrigare_1_N = mkN "germankrigare" utrum  ; -- germankrigare..nn.1
  germansk_1_A = mkA "germansk" ; -- germansk..av.1
  germanstam_1_N = mkN "germanstam" "germanstammen" "germanstammar" "germanstammarna" ; -- germanstam..nn.1
  gerontofil_1_N = mkN "gerontofil" "gerontofiler" ; -- gerontofil..nn.1
  gerontologi_1_N = mkN "gerontologi" ; -- gerontologi..nn.1
  gerontologisk_1_A = mkA "gerontologisk" ; -- gerontologisk..av.1
  gers_1_N = mkN "gers" ; -- gers..nn.1
  gerundium_1_N = mkN "gerundium" "gerundiumet" "gerundier" "gerundierna" ; -- gerundium..nn.1
  gerundivum_1_N = mkN "gerundivum" "gerundivumet" "gerundiver" "gerundiverna" ; -- gerundivum..nn.1
  gesant_1_N = mkN "gesant" "gesanter" ; -- gesant..nn.1
  geschvint_1_Adv = mkAdv "geschvint" ; -- geschvint..ab.1
  geschwint_1_Adv = mkAdv "geschwint" ; -- geschwint..ab.1
  geschäft_1_N = mkN "geschäft" neutrum  ; -- geschäft..nn.1
  gesims_1_N = mkN "gesims" "gesimser" ; -- gesims..nn.1
  gesimsbåge_1_N = mkN "gesimsbåge" utrum  ; -- gesimsbåge..nn.1
  gesimslist_1_N = mkN "gesimslist" "gesimslister" ; -- gesimslist..nn.1
  gest_1_N = mkN "gest" "gester" ; -- gest..nn.1
  gestalt_1_N = mkN "gestalt" "gestalter" ; -- gestalt..nn.1
  gestalta_1_V = mkV "gestaltar" ; -- gestalta..vb.1
  gestaltande_1_N = mkN "gestaltande" ; -- gestaltande..nn.1
  gestaltlös_1_A = mkA "gestaltlös" ; -- gestaltlös..av.1
  gestaltning_1_N = mkN "gestaltning" ; -- gestaltning..nn.1
  gestaltningsform_1_N = mkN "gestaltningsform" "gestaltningsformer" ; -- gestaltningsform..nn.1
  gestaltningsmässig_1_A = mkA "gestaltningsmässig" ; -- gestaltningsmässig..av.1
  gestaltpsykologi_1_N = mkN "gestaltpsykologi" ; -- gestaltpsykologi..nn.1
  gestik_1_N = mkN "gestik" ; -- gestik..nn.1
  gestikulation_1_N = mkN "gestikulation" ; -- gestikulation..nn.1
  gestikulera_1_V = mkV "gestikulerar" ; -- gestikulera..vb.1
  gestikulerande_1_N = mkN "gestikulerande" ; -- gestikulerande..nn.1
  gestikulering_1_N = mkN "gestikulering" ; -- gestikulering..nn.1
  gesvint_1_Adv = mkAdv "gesvint" ; -- gesvint..ab.1
  gesäll_1_N = mkN "gesäll" "gesäller" ; -- gesäll..nn.1
  gesällbrev_1_N = mkN "gesällbrev" neutrum  ; -- gesällbrev..nn.1
  gesällprov_1_N = mkN "gesällprov" neutrum  ; -- gesällprov..nn.1
  gesällvandring_1_N = mkN "gesällvandring" ; -- gesällvandring..nn.1
  get_1_N = mkN "get" "getter" ; -- get..nn.1
  getabock_1_N = mkN "getabock" ; -- getabock..nn.1
  getapel_1_N = mkN "getapel" ; -- getapel..nn.1
  getbjällra_1_N = mkN "getbjällra" ; -- getbjällra..nn.1
  getfot_1_N = mkN "getfot" ; -- getfot..nn.1
  geting_1_N = mkN "geting" ; -- geting..nn.1
  getingbilla_1_N = mkN "getingbilla" ; -- getingbilla..nn.1
  getingbo_1_N = mkN "getingbo" "getingboet" "getingbon" "getingbona" ; -- getingbo..nn.1
  getingmidja_1_N = mkN "getingmidja" ; -- getingmidja..nn.1
  getingstick_1_N = mkN "getingstick" neutrum  ; -- getingstick..nn.1
  getingsvärm_1_N = mkN "getingsvärm" ; -- getingsvärm..nn.1
  getmjölk_1_N = mkN "getmjölk" ; -- getmjölk..nn.1
  getmjölksost_1_N = mkN "getmjölksost" ; -- getmjölksost..nn.1
  getost_1_N = mkN "getost" ; -- getost..nn.1
  getpors_1_N = mkN "getpors" ; -- getpors..nn.1
  getrams_1_N = mkN "getrams" ; -- getrams..nn.1
  getskinn_1_N = mkN "getskinn" neutrum  ; -- getskinn..nn.1
  getskägg_1_N = mkN "getskägg" neutrum  ; -- getskägg..nn.1
  getto_1_N = mkN "getto" "gettot" "getton" "gettona" ; -- getto..nn.1
  gettofiering_1_N = mkN "gettofiering" ; -- gettofiering..nn.1
  getväppling_1_N = mkN "getväppling" ; -- getväppling..nn.1
  gevaldiger_1_N = mkN "gevaldiger" "gevaldigern" "gevaldiger" "gevaldigerna" ; -- gevaldiger..nn.1
  gevär_1_N = mkN "gevär" neutrum  ; -- gevär..nn.1
  gevärseld_1_N = mkN "gevärseld" ; -- gevärseld..nn.1
  gevärsfaktori_1_N = mkN "gevärsfaktori" "gevärsfaktoriet" "gevärsfaktorier" "gevärsfaktorierna" ; -- gevärsfaktori..nn.1
  gevärsgranat_1_N = mkN "gevärsgranat" "gevärsgranater" ; -- gevärsgranat..nn.1
  gevärskolv_1_N = mkN "gevärskolv" ; -- gevärskolv..nn.1
  gevärskompani_1_N = mkN "gevärskompani" "gevärskompaniet" "gevärskompanier" "gevärskompanierna" ; -- gevärskompani..nn.1
  gevärskula_1_N = mkN "gevärskula" ; -- gevärskula..nn.1
  gevärsmynning_1_N = mkN "gevärsmynning" ; -- gevärsmynning..nn.1
  gevärsolja_1_N = mkN "gevärsolja" ; -- gevärsolja..nn.1
  gevärspatron_1_N = mkN "gevärspatron" "gevärspatroner" ; -- gevärspatron..nn.1
  gevärspipa_1_N = mkN "gevärspipa" ; -- gevärspipa..nn.1
  gevärspost_1_N = mkN "gevärspost" "gevärsposter" ; -- gevärspost..nn.1
  gevärssalva_1_N = mkN "gevärssalva" ; -- gevärssalva..nn.1
  gevärssikte_1_N = mkN "gevärssikte" ; -- gevärssikte..nn.1
  gevärsskott_1_N = mkN "gevärsskott" neutrum  ; -- gevärsskott..nn.1
  gevärssmed_1_N = mkN "gevärssmed" "gevärssmeder" ; -- gevärssmed..nn.1
  gevärssmide_1_N = mkN "gevärssmide" ; -- gevärssmide..nn.1
  gevärsstock_1_N = mkN "gevärsstock" ; -- gevärsstock..nn.1
  gevärsväska_1_N = mkN "gevärsväska" ; -- gevärsväska..nn.1
  ghanan_1_N = mkN "ghanan" "ghananer" ; -- ghanan..nn.1
  ghanansk_1_A = mkA "ghanansk" ; -- ghanansk..av.1
  ghananska_1_N = mkN "ghananska" ; -- ghananska..nn.1
  ghanes_1_N = mkN "ghanes" "ghaneser" ; -- ghanes..nn.1
  ghanesisk_1_A = mkA "ghanesisk" ; -- ghanesisk..av.1
  ghasel_1_N = mkN "ghasel" "ghaseler" ; -- ghasel..nn.1
  ghetto_1_N = mkN "ghetto" "ghettot" "ghetton" "ghettona" ; -- ghetto..nn.1
  ghettofiering_1_N = mkN "ghettofiering" ; -- ghettofiering..nn.1
  ghost_writer_1_N = mkN "ghost-writer" "ghost-writern" "ghost-writers" "ghost-writersarna" ; -- ghost-writer..nn.1
  gibbon_1_N = mkN "gibbon" "gibboner" ; -- gibbon..nn.1
  giffel_1_N = mkN "giffel" ; -- giffel..nn.1
  gift_1_A = mkA "gift" "gift" ; -- gift..av.1
  gift_1_N = mkN "gift" "giftet" "gifter" "gifterna" ; -- gift..nn.1
  giftapparat_1_N = mkN "giftapparat" "giftapparater" ; -- giftapparat..nn.1
  giftaslysten_1_A = mkA "giftaslysten" ; -- giftaslysten..av.1
  giftasvuxen_1_A = mkA "giftasvuxen" ; -- giftasvuxen..av.1
  giftasvuxenhet_1_N = mkN "giftasvuxenhet" ; -- giftasvuxenhet..nn.1
  giftavdunstning_1_N = mkN "giftavdunstning" ; -- giftavdunstning..nn.1
  giftbetning_1_N = mkN "giftbetning" ; -- giftbetning..nn.1
  giftblandare_1_N = mkN "giftblandare" utrum  ; -- giftblandare..nn.1
  giftblandning_1_N = mkN "giftblandning" ; -- giftblandning..nn.1
  giftblandning_2_N = mkN "giftblandning" ; -- giftblandning..nn.2
  giftblåsa_1_N = mkN "giftblåsa" ; -- giftblåsa..nn.1
  giftbok_1_N = mkN "giftbok" "giftböcker" ; -- giftbok..nn.1
  giftbägare_1_N = mkN "giftbägare" utrum  ; -- giftbägare..nn.1
  giftdryck_1_N = mkN "giftdryck" "giftdrycker" ; -- giftdryck..nn.1
  gifte_1_N = mkN "gifte" ; -- gifte..nn.1
  giftermål_1_N = mkN "giftermål" neutrum  ; -- giftermål..nn.1
  giftermålsanbud_1_N = mkN "giftermålsanbud" neutrum  ; -- giftermålsanbud..nn.1
  giftermålsbalk_1_N = mkN "giftermålsbalk" ; -- giftermålsbalk..nn.1
  giftfri_1_A = mkA "giftfri" "giftfritt" ; -- giftfri..av.1
  giftgas_1_N = mkN "giftgas" "giftgaser" ; -- giftgas..nn.1
  giftgrön_1_A = mkA "giftgrön" ; -- giftgrön..av.1
  gifthalt_1_N = mkN "gifthalt" "gifthalter" ; -- gifthalt..nn.1
  giftig_1_A = mkA "giftig" ; -- giftig..av.1
  giftighet_1_N = mkN "giftighet" "giftigheter" ; -- giftighet..nn.1
  giftinformation_1_N = mkN "giftinformation" ; -- giftinformation..nn.1
  giftinformationscentral_1_N = mkN "giftinformationscentral" "giftinformationscentraler" ; -- giftinformationscentral..nn.1
  giftinjektion_1_N = mkN "giftinjektion" ; -- giftinjektion..nn.1
  giftkapsel_1_N = mkN "giftkapsel" ; -- giftkapsel..nn.1
  giftkörtel_1_N = mkN "giftkörtel" ; -- giftkörtel..nn.1
  giftlära_1_N = mkN "giftlära" ; -- giftlära..nn.1
  giftmoln_1_N = mkN "giftmoln" neutrum  ; -- giftmoln..nn.1
  giftmord_1_N = mkN "giftmord" neutrum  ; -- giftmord..nn.1
  giftmängd_1_N = mkN "giftmängd" "giftmängder" ; -- giftmängd..nn.1
  giftoman_1_N = mkN "giftoman" "giftomannen" "giftomän" "giftomännen" ; -- giftoman..nn.1
  giftorm_1_N = mkN "giftorm" ; -- giftorm..nn.1
  giftorätt_1_N = mkN "giftorätt" ; -- giftorätt..nn.1
  giftpiller_1_N = mkN "giftpiller" neutrum  ; -- giftpiller..nn.1
  giftregn_1_N = mkN "giftregn" neutrum  ; -- giftregn..nn.1
  giftspindel_1_N = mkN "giftspindel" ; -- giftspindel..nn.1
  giftspruta_1_N = mkN "giftspruta" ; -- giftspruta..nn.1
  giftstadga_1_N = mkN "giftstadga" ; -- giftstadga..nn.1
  gifttagg_1_N = mkN "gifttagg" ; -- gifttagg..nn.1
  gifttand_1_N = mkN "gifttand" "gifttänder" ; -- gifttand..nn.1
  gifttransport_1_N = mkN "gifttransport" "gifttransporter" ; -- gifttransport..nn.1
  giftutsläpp_1_N = mkN "giftutsläpp" neutrum  ; -- giftutsläpp..nn.1
  giftverkan_1_N = mkN "giftverkan" "giftverkan" "giftverkningar" "giftverkningarna" ; -- giftverkan..nn.1
  gig_1_N = mkN "gig" neutrum  ; -- gig..nn.1
  giga_1_N = mkN "giga" ; -- giga..nn.1
  giga_1_V = mkV "gigar" ; -- giga..vb.1
  gigabyte_1_N = mkN "gigabyte" "gigabyten" "gigabyte" "gigabytena" ; -- gigabyte..nn.1
  gigande_1_N = mkN "gigande" ; -- gigande..nn.1
  gigant_1_N = mkN "gigant" "giganter" ; -- gigant..nn.1
  gigantisk_1_A = mkA "gigantisk" ; -- gigantisk..av.1
  gigaton_1_N = mkN "gigaton" "gigatonnet" "gigaton" "gigatonnen" ; -- gigaton..nn.1
  gigawatt_1_N = mkN "gigawatt" "gigawatten" "gigawatt" "gigawatten" ; -- gigawatt..nn.1
  gigg_1_N = mkN "gigg" ; -- gigg..nn.1
  gigga_1_V = mkV "giggar" ; -- gigga..vb.1
  giggande_1_N = mkN "giggande" ; -- giggande..nn.1
  gigolo_1_N = mkN "gigolo" "gigolor" ; -- gigolo..nn.1
  gigue_1_N = mkN "gigue" "giguer" ; -- gigue..nn.1
  gikt_1_N = mkN "gikt" ; -- gikt..nn.1
  giktbruten_1_A = mkA "giktbruten" ; -- giktbruten..av.1
  giktbrutenhet_1_N = mkN "giktbrutenhet" ; -- giktbrutenhet..nn.1
  giktring_1_N = mkN "giktring" ; -- giktring..nn.1
  gilja_1_V = mkV "giljar" ; -- gilja..vb.1
  giljande_1_N = mkN "giljande" ; -- giljande..nn.1
  giljare_1_N = mkN "giljare" utrum  ; -- giljare..nn.1
  giljarfärd_1_N = mkN "giljarfärd" "giljarfärder" ; -- giljarfärd..nn.1
  giljarstråt_1_N = mkN "giljarstråt" ; -- giljarstråt..nn.1
  giljotin_1_N = mkN "giljotin" "giljotiner" ; -- giljotin..nn.1
  giljotinera_1_V = mkV "giljotinerar" ; -- giljotinera..vb.1
  giljotinerande_1_N = mkN "giljotinerande" ; -- giljotinerande..nn.1
  giljotinerbar_1_A = mkA "giljotinerbar" ; -- giljotinerbar..av.1
  giljotinerbarhet_1_N = mkN "giljotinerbarhet" ; -- giljotinerbarhet..nn.1
  giljotinering_1_N = mkN "giljotinering" ; -- giljotinering..nn.1
  gill_1_A = mkA "gill" ; -- gill..av.1
  gilla_1_V = mkV "gillar" ; -- gilla..vb.1
  gillande_1_N = mkN "gillande" ; -- gillande..nn.1
  gille_1_N = mkN "gille" ; -- gille..nn.1
  giller_1_N = mkN "giller" neutrum  ; -- giller..nn.1
  gillesbroder_1_N = mkN "gillesbroder" "gillesbrodern" "gillesbröder" "gillesbröderna" ; -- gillesbroder..nn.1
  gillessocialism_1_N = mkN "gillessocialism" "gillessocialismer" ; -- gillessocialism..nn.1
  gillesstuga_1_N = mkN "gillesstuga" ; -- gillesstuga..nn.1
  gillestuga_1_N = mkN "gillestuga" ; -- gillestuga..nn.1
  gillhet_1_N = mkN "gillhet" ; -- gillhet..nn.1
  gillra_1_V = mkV "gillrar" ; -- gillra..vb.1
  gillrande_1_N = mkN "gillrande" ; -- gillrande..nn.1
  giltig_1_A = mkA "giltig" ; -- giltig..av.1
  giltighet_1_N = mkN "giltighet" "giltigheter" ; -- giltighet..nn.1
  giltighetstid_1_N = mkN "giltighetstid" "giltighetstider" ; -- giltighetstid..nn.1
  gimmick_1_N = mkN "gimmick" ; -- gimmick..nn.1
  gin_1_A = mkA "gin" ; -- gin..av.1
  gin_1_N = mkN "gin" ; -- gin..nn.1
  gina_1_N = mkN "gina" ; -- gina..nn.1
  gina_1_V = mkV "ginar" ; -- gina..vb.1
  ginande_1_N = mkN "ginande" ; -- ginande..nn.1
  ginbalk_1_N = mkN "ginbalk" ; -- ginbalk..nn.1
  gindrink_1_N = mkN "gindrink" ; -- gindrink..nn.1
  gingham_1_N = mkN "gingham" ; -- gingham..nn.1
  ginnungagap_1_N = mkN "ginnungagap" neutrum  ; -- ginnungagap..nn.1
  ginseng_1_N = mkN "ginseng" ; -- ginseng..nn.1
  ginseng_2_N = mkN "ginseng" "ginsenger" ; -- ginseng..nn.2
  ginst_1_N = mkN "ginst" "ginster" ; -- ginst..nn.1
  ginstkatt_1_N = mkN "ginstkatt" "ginstkatter" ; -- ginstkatt..nn.1
  ginväg_1_N = mkN "ginväg" ; -- ginväg..nn.1
  gip_1_N = mkN "gip" ; -- gip..nn.1
  gipa_1_N = mkN "gipa" ; -- gipa..nn.1
  gipa_1_V = mkV "gipar" ; -- gipa..vb.1
  gipande_1_N = mkN "gipande" ; -- gipande..nn.1
  gipp_1_N = mkN "gipp" ; -- gipp..nn.1
  gippa_1_V = mkV "gippar" ; -- gippa..vb.1
  gippande_1_N = mkN "gippande" ; -- gippande..nn.1
  gips_1_N = mkN "gips" "gipser" ; -- gips..nn.1
  gipsa_1_V = mkV "gipsar" ; -- gipsa..vb.1
  gipsande_1_N = mkN "gipsande" ; -- gipsande..nn.1
  gipsavgjutning_1_N = mkN "gipsavgjutning" ; -- gipsavgjutning..nn.1
  gipsbruk_1_N = mkN "gipsbruk" neutrum  ; -- gipsbruk..nn.1
  gipsbyst_1_N = mkN "gipsbyst" "gipsbyster" ; -- gipsbyst..nn.1
  gipsfigur_1_N = mkN "gipsfigur" "gipsfigurer" ; -- gipsfigur..nn.1
  gipsform_1_N = mkN "gipsform" ; -- gipsform..nn.1
  gipsförband_1_N = mkN "gipsförband" neutrum  ; -- gipsförband..nn.1
  gipsklump_1_N = mkN "gipsklump" ; -- gipsklump..nn.1
  gipsmurbruk_1_N = mkN "gipsmurbruk" neutrum  ; -- gipsmurbruk..nn.1
  gipsornament_1_N = mkN "gipsornament" neutrum  ; -- gipsornament..nn.1
  gipsplatta_1_N = mkN "gipsplatta" ; -- gipsplatta..nn.1
  gipsputs_1_N = mkN "gipsputs" ; -- gipsputs..nn.1
  gipsskiva_1_N = mkN "gipsskiva" ; -- gipsskiva..nn.1
  gipstak_1_N = mkN "gipstak" neutrum  ; -- gipstak..nn.1
  gipsvägg_1_N = mkN "gipsvägg" ; -- gipsvägg..nn.1
  gipyr_1_N = mkN "gipyr" "gipyrer" ; -- gipyr..nn.1
  gir_1_N = mkN "gir" ; -- gir..nn.1
  gira_1_V = mkV "girar" ; -- gira..vb.1
  giraff_1_N = mkN "giraff" "giraffer" ; -- giraff..nn.1
  giraffliknande_1_A = mkA "giraffliknande" ; -- giraffliknande..av.1
  girande_1_N = mkN "girande" ; -- girande..nn.1
  girandole_1_N = mkN "girandole" "girandoler" ; -- girandole..nn.1
  girera_1_V = mkV "girerar" ; -- girera..vb.1
  girerande_1_N = mkN "girerande" ; -- girerande..nn.1
  girerbar_1_A = mkA "girerbar" ; -- girerbar..av.1
  girerbarhet_1_N = mkN "girerbarhet" ; -- girerbarhet..nn.1
  girering_1_N = mkN "girering" ; -- girering..nn.1
  girig_1_A = mkA "girig" ; -- girig..av.1
  girigbuk_1_N = mkN "girigbuk" ; -- girigbuk..nn.1
  girighet_1_N = mkN "girighet" "girigheter" ; -- girighet..nn.1
  girih_mönster_1_N = mkN "girih-mönster" neutrum  ; -- girih-mönster..nn.1
  girland_1_N = mkN "girland" "girlander" ; -- girland..nn.1
  girlang_1_N = mkN "girlang" "girlanger" ; -- girlang..nn.1
  girning_1_N = mkN "girning" ; -- girning..nn.1
  giro_1_N = mkN "giro" "girot" "giron" "girona" ; -- giro..nn.1
  girobesked_1_N = mkN "girobesked" neutrum  ; -- girobesked..nn.1
  girvuxen_1_A = mkA "girvuxen" ; -- girvuxen..av.1
  girväxt_1_A = mkA "girväxt" "girväxt" ; -- girväxt..av.1
  gissa_1_V = mkV "gissar" ; -- gissa..vb.1
  gissande_1_N = mkN "gissande" ; -- gissande..nn.1
  gissel_1_N = mkN "gissel" neutrum  ; -- gissel..nn.1
  gisseldjur_1_N = mkN "gisseldjur" neutrum  ; -- gisseldjur..nn.1
  gisselslag_1_N = mkN "gisselslag" neutrum  ; -- gisselslag..nn.1
  gissla_1_V = mkV "gisslar" ; -- gissla..vb.1
  gisslan_1_N = mkN "gisslan" ; -- gisslan..nn.1
  gisslande_1_N = mkN "gisslande" ; -- gisslande..nn.1
  gisslandrama_1_N = mkN "gisslandrama" "gisslandramat" "gisslandramer" "gisslandramerna" ; -- gisslandrama..nn.1
  gisslansituation_1_N = mkN "gisslansituation" ; -- gisslansituation..nn.1
  gisslantagande_1_N = mkN "gisslantagande" ; -- gisslantagande..nn.1
  gisslantagare_1_N = mkN "gisslantagare" utrum  ; -- gisslantagare..nn.1
  gisslare_1_N = mkN "gisslare" utrum  ; -- gisslare..nn.1
  gisslartåg_1_N = mkN "gisslartåg" neutrum  ; -- gisslartåg..nn.1
  gissling_1_N = mkN "gissling" ; -- gissling..nn.1
  gissning_1_N = mkN "gissning" ; -- gissning..nn.1
  gissningslek_1_N = mkN "gissningslek" ; -- gissningslek..nn.1
  gissningstävling_1_N = mkN "gissningstävling" ; -- gissningstävling..nn.1
  gissningsvis_1_Adv = mkAdv "gissningsvis" ; -- gissningsvis..ab.1
  gist_1_N = mkN "gist" ; -- gist..nn.1
  gista_1_V = mkV "gistar" ; -- gista..vb.1
  gistande_1_N = mkN "gistande" ; -- gistande..nn.1
  gisten_1_A = mkA "gisten" ; -- gisten..av.1
  gistenhet_1_N = mkN "gistenhet" ; -- gistenhet..nn.1
  gistgård_1_N = mkN "gistgård" ; -- gistgård..nn.1
  gistna_1_V = mkV "gistnar" ; -- gistna..vb.1
  gistnande_1_N = mkN "gistnande" ; -- gistnande..nn.1
  gitarr_1_N = mkN "gitarr" "gitarrer" ; -- gitarr..nn.1
  gitarrackompanjemang_1_N = mkN "gitarrackompanjemang" neutrum  ; -- gitarrackompanjemang..nn.1
  gitarrist_1_N = mkN "gitarrist" "gitarrister" ; -- gitarrist..nn.1
  gitarrmusik_1_N = mkN "gitarrmusik" ; -- gitarrmusik..nn.1
  gitarrsolo_1_N = mkN "gitarrsolo" "gitarrsolot" "gitarrsoli" "gitarrsolona" ; -- gitarrsolo..nn.1
  gitarrspel_1_N = mkN "gitarrspel" "gitarrspelet" "gitarrspel" "gitarrspelen" ; -- gitarrspel..nn.1
  gitarrspelare_1_N = mkN "gitarrspelare" utrum  ; -- gitarrspelare..nn.1
  gitarrsträng_1_N = mkN "gitarrsträng" ; -- gitarrsträng..nn.1
  gitta_1_V = mkV "gitta" "gitte" "gittat" ; -- gitta..vb.1
  gittande_1_N = mkN "gittande" ; -- gittande..nn.1
  gitter_1_N = mkN "gitter" neutrum  ; -- gitter..nn.1
  giv_1_N = mkN "giv" ; -- giv..nn.1
  givakt_1_N = mkN "givakt" "givakter" ; -- givakt..nn.1
  givande_1_A = mkA "givande" ; -- givande..av.1
  givande_1_N = mkN "givande" ; -- givande..nn.1
  givare_1_N = mkN "givare" utrum  ; -- givare..nn.1
  given_1_A = mkA "given" ; -- given..av.1
  givenhet_1_N = mkN "givenhet" ; -- givenhet..nn.1
  givetvis_1_Adv = mkAdv "givetvis" ; -- givetvis..ab.1
  givkort_1_N = mkN "givkort" neutrum  ; -- givkort..nn.1
  givmild_1_A = mkA "givmild" "givmilt" ; -- givmild..av.1
  givmildhet_1_N = mkN "givmildhet" "givmildheter" ; -- givmildhet..nn.1
  givning_1_N = mkN "givning" ; -- givning..nn.1
  gjord_1_N = mkN "gjord" ; -- gjord..nn.1
  gjorda_1_V = mkV "gjordar" ; -- gjorda..vb.1
  gjordande_1_N = mkN "gjordande" ; -- gjordande..nn.1
  gjuse_1_N = mkN "gjuse" utrum  ; -- gjuse..nn.1
  gjuta_1_V = mkV "gjuta" "göt" "gjutit" ; -- gjuta..vb.1
  gjutande_1_N = mkN "gjutande" ; -- gjutande..nn.1
  gjutare_1_N = mkN "gjutare" utrum  ; -- gjutare..nn.1
  gjutbar_1_A = mkA "gjutbar" ; -- gjutbar..av.1
  gjutbarhet_1_N = mkN "gjutbarhet" ; -- gjutbarhet..nn.1
  gjutbetong_1_N = mkN "gjutbetong" ; -- gjutbetong..nn.1
  gjuteri_1_N = mkN "gjuteri" "gjuteriet" "gjuterier" "gjuterierna" ; -- gjuteri..nn.1
  gjutflaska_1_N = mkN "gjutflaska" ; -- gjutflaska..nn.1
  gjutform_1_N = mkN "gjutform" ; -- gjutform..nn.1
  gjutgods_1_N = mkN "gjutgods" neutrum  ; -- gjutgods..nn.1
  gjutjärn_1_N = mkN "gjutjärn" neutrum  ; -- gjutjärn..nn.1
  gjutjärnsbro_1_N = mkN "gjutjärnsbro" ; -- gjutjärnsbro..nn.1
  gjutjärnsgryta_1_N = mkN "gjutjärnsgryta" ; -- gjutjärnsgryta..nn.1
  gjutjärnsspis_1_N = mkN "gjutjärnsspis" ; -- gjutjärnsspis..nn.1
  gjutmassa_1_N = mkN "gjutmassa" ; -- gjutmassa..nn.1
  gjutmodell_1_N = mkN "gjutmodell" "gjutmodeller" ; -- gjutmodell..nn.1
  gjutning_1_N = mkN "gjutning" ; -- gjutning..nn.1
  gjutrand_1_N = mkN "gjutrand" "gjutränder" ; -- gjutrand..nn.1
  gjutsand_1_N = mkN "gjutsand" ; -- gjutsand..nn.1
  gjutstål_1_N = mkN "gjutstål" neutrum  ; -- gjutstål..nn.1
  glace_1_N = mkN "glace" utrum  ; -- glace..nn.1
  glaci_1_N = mkN "glaci" "glacier" ; -- glaci..nn.1
  glacial_1_A = mkA "glacial" ; -- glacial..av.1
  glacialperiod_1_N = mkN "glacialperiod" "glacialperioder" ; -- glacialperiod..nn.1
  glacialräffla_1_N = mkN "glacialräffla" ; -- glacialräffla..nn.1
  glacifluvial_1_A = mkA "glacifluvial" ; -- glacifluvial..av.1
  glaciolog_1_N = mkN "glaciolog" "glaciologer" ; -- glaciolog..nn.1
  glaciologi_1_N = mkN "glaciologi" ; -- glaciologi..nn.1
  glaciologisk_1_A = mkA "glaciologisk" ; -- glaciologisk..av.1
  glaciär_1_N = mkN "glaciär" "glaciärer" ; -- glaciär..nn.1
  glaciärbrunn_1_N = mkN "glaciärbrunn" ; -- glaciärbrunn..nn.1
  glaciäris_1_N = mkN "glaciäris" ; -- glaciäris..nn.1
  glaciärnisch_1_N = mkN "glaciärnisch" "glaciärnischer" ; -- glaciärnisch..nn.1
  glaciärport_1_N = mkN "glaciärport" ; -- glaciärport..nn.1
  glaciärräffla_1_N = mkN "glaciärräffla" ; -- glaciärräffla..nn.1
  glaciärsmältning_1_N = mkN "glaciärsmältning" ; -- glaciärsmältning..nn.1
  glaciärälv_1_N = mkN "glaciärälv" ; -- glaciärälv..nn.1
  glacéhandske_1_N = mkN "glacéhandske" utrum  ; -- glacéhandske..nn.1
  glad_1_A = mkA "glad" "glatt" ; -- glad..av.1
  glad_1_N = mkN "glad" neutrum  ; -- glad..nn.1
  glada_1_N = mkN "glada" ; -- glada..nn.1
  gladelig_1_A = mkA "gladelig" ; -- gladelig..av.1
  gladeligen_1_Adv = mkAdv "gladeligen" ; -- gladeligen..ab.1
  gladhet_1_N = mkN "gladhet" ; -- gladhet..nn.1
  gladiator_1_N = mkN "gladiator" "gladiatorer" ; -- gladiator..nn.1
  gladiatorgrav_1_N = mkN "gladiatorgrav" ; -- gladiatorgrav..nn.1
  gladiatorskola_1_N = mkN "gladiatorskola" ; -- gladiatorskola..nn.1
  gladiatorspel_1_N = mkN "gladiatorspel" "gladiatorspelet" "gladiatorspel" "gladiatorspelen" ; -- gladiatorspel..nn.1
  gladiolus_1_N = mkN "gladiolus" ; -- gladiolus..nn.1
  gladlig_1_A = mkA "gladlig" ; -- gladlig..av.1
  gladligen_1_Adv = mkAdv "gladligen" ; -- gladligen..ab.1
  gladlynt_1_A = mkA "gladlynt" "gladlynt" ; -- gladlynt..av.1
  gladlynthet_1_N = mkN "gladlynthet" ; -- gladlynthet..nn.1
  gladporr_1_N = mkN "gladporr" ; -- gladporr..nn.1
  glagolitisk_1_A = mkA "glagolitisk" ; -- glagolitisk..av.1
  glamma_1_V = mkV "glammar" ; -- glamma..vb.1
  glammande_1_N = mkN "glammande" ; -- glammande..nn.1
  glammig_1_A = mkA "glammig" ; -- glammig..av.1
  glammighet_1_N = mkN "glammighet" ; -- glammighet..nn.1
  glamorisera_1_V = mkV "glamoriserar" ; -- glamorisera..vb.1
  glamoriserande_1_N = mkN "glamoriserande" ; -- glamoriserande..nn.1
  glamoriserbar_1_A = mkA "glamoriserbar" ; -- glamoriserbar..av.1
  glamoriserbarhet_1_N = mkN "glamoriserbarhet" ; -- glamoriserbarhet..nn.1
  glamorisering_1_N = mkN "glamorisering" ; -- glamorisering..nn.1
  glamorös_1_A = mkA "glamorös" ; -- glamorös..av.1
  glamour_1_N = mkN "glamour" ; -- glamour..nn.1
  glamourisera_1_V = mkV "glamouriserar" ; -- glamourisera..vb.1
  glamouriserande_1_N = mkN "glamouriserande" ; -- glamouriserande..nn.1
  glamouriserbar_1_A = mkA "glamouriserbar" ; -- glamouriserbar..av.1
  glamouriserbarhet_1_N = mkN "glamouriserbarhet" ; -- glamouriserbarhet..nn.1
  glamourisering_1_N = mkN "glamourisering" ; -- glamourisering..nn.1
  glamourös_1_A = mkA "glamourös" ; -- glamourös..av.1
  glana_1_V = mkV "glanar" ; -- glana..vb.1
  glanande_1_N = mkN "glanande" ; -- glanande..nn.1
  glandel_1_N = mkN "glandel" "glandeln" "glandler" "glandlerna" ; -- glandel..nn.1
  glandulös_1_A = mkA "glandulös" ; -- glandulös..av.1
  glans_1_N = mkN "glans" ; -- glans..nn.1
  glansa_1_V = mkV "glansar" ; -- glansa..vb.1
  glansande_1_N = mkN "glansande" ; -- glansande..nn.1
  glansbagge_1_N = mkN "glansbagge" utrum  ; -- glansbagge..nn.1
  glansfull_1_A = mkA "glansfull" ; -- glansfull..av.1
  glansfullhet_1_N = mkN "glansfullhet" ; -- glansfullhet..nn.1
  glansig_1_A = mkA "glansig" ; -- glansig..av.1
  glansighet_1_N = mkN "glansighet" ; -- glansighet..nn.1
  glansis_1_N = mkN "glansis" ; -- glansis..nn.1
  glansk_1_A = mkA "glansk" ; -- glansk..av.1
  glanska_1_V = mkV "glanskar" ; -- glanska..vb.1
  glanskande_1_N = mkN "glanskande" ; -- glanskande..nn.1
  glanskhet_1_N = mkN "glanskhet" ; -- glanskhet..nn.1
  glanskis_1_N = mkN "glanskis" ; -- glanskis..nn.1
  glanskning_1_N = mkN "glanskning" ; -- glanskning..nn.1
  glanslös_1_A = mkA "glanslös" ; -- glanslös..av.1
  glanslöshet_1_N = mkN "glanslöshet" ; -- glanslöshet..nn.1
  glansning_1_N = mkN "glansning" ; -- glansning..nn.1
  glansnummer_1_N = mkN "glansnummer" neutrum  ; -- glansnummer..nn.1
  glanspapper_1_N = mkN "glanspapper" neutrum  ; -- glanspapper..nn.1
  glansperiod_1_N = mkN "glansperiod" "glansperioder" ; -- glansperiod..nn.1
  glansroll_1_N = mkN "glansroll" "glansroller" ; -- glansroll..nn.1
  glanssot_1_N = mkN "glanssot" neutrum  ; -- glanssot..nn.1
  glanstid_1_N = mkN "glanstid" "glanstider" ; -- glanstid..nn.1
  glansull_1_N = mkN "glansull" ; -- glansull..nn.1
  glapp_1_A = mkA "glapp" ; -- glapp..av.1
  glapp_1_N = mkN "glapp" neutrum  ; -- glapp..nn.1
  glappa_1_V = mkV "glappar" ; -- glappa..vb.1
  glappande_1_N = mkN "glappande" ; -- glappande..nn.1
  glapphet_1_N = mkN "glapphet" ; -- glapphet..nn.1
  glappkontakt_1_N = mkN "glappkontakt" "glappkontakter" ; -- glappkontakt..nn.1
  glappning_1_N = mkN "glappning" ; -- glappning..nn.1
  glapprum_1_N = mkN "glapprum" "glapprummet" "glapprum" "glapprummen" ; -- glapprum..nn.1
  glarre_1_N = mkN "glarre" utrum  ; -- glarre..nn.1
  glas_1_N = mkN "glas" neutrum  ; -- glas..nn.1
  glasa_1_V = mkV "glasar" ; -- glasa..vb.1
  glasaktig_1_A = mkA "glasaktig" ; -- glasaktig..av.1
  glasande_1_N = mkN "glasande" ; -- glasande..nn.1
  glasartad_1_A = mkA "glasartad" ; -- glasartad..av.1
  glasberg_1_N = mkN "glasberg" neutrum  ; -- glasberg..nn.1
  glasbit_1_N = mkN "glasbit" ; -- glasbit..nn.1
  glasbjörk_1_N = mkN "glasbjörk" ; -- glasbjörk..nn.1
  glasblåsare_1_N = mkN "glasblåsare" utrum  ; -- glasblåsare..nn.1
  glasblåsarpipa_1_N = mkN "glasblåsarpipa" ; -- glasblåsarpipa..nn.1
  glasblåseri_1_N = mkN "glasblåseri" "glasblåseriet" "glasblåserier" "glasblåserierna" ; -- glasblåseri..nn.1
  glasblåsning_1_N = mkN "glasblåsning" ; -- glasblåsning..nn.1
  glasbruk_1_N = mkN "glasbruk" neutrum  ; -- glasbruk..nn.1
  glasbult_1_N = mkN "glasbult" ; -- glasbult..nn.1
  glasburk_1_N = mkN "glasburk" ; -- glasburk..nn.1
  glasdörr_1_N = mkN "glasdörr" ; -- glasdörr..nn.1
  glasera_1_V = mkV "glaserar" ; -- glasera..vb.1
  glaserande_1_N = mkN "glaserande" ; -- glaserande..nn.1
  glaserbar_1_A = mkA "glaserbar" ; -- glaserbar..av.1
  glaserbarhet_1_N = mkN "glaserbarhet" ; -- glaserbarhet..nn.1
  glasering_1_N = mkN "glasering" ; -- glasering..nn.1
  glasfiber_1_N = mkN "glasfiber" "glasfibern" "glasfibrer" "glasfibrerna" ; -- glasfiber..nn.1
  glasfiberarmera_1_V = mkV "glasfiberarmerar" ; -- glasfiberarmera..vb.1
  glasfiberarmerande_1_N = mkN "glasfiberarmerande" ; -- glasfiberarmerande..nn.1
  glasfiberarmering_1_N = mkN "glasfiberarmering" ; -- glasfiberarmering..nn.1
  glasfiberförstärkt_1_A = mkA "glasfiberförstärkt" "glasfiberförstärkt" ; -- glasfiberförstärkt..av.1
  glasfiberull_1_N = mkN "glasfiberull" ; -- glasfiberull..nn.1
  glasfiberväv_1_N = mkN "glasfiberväv" ; -- glasfiberväv..nn.1
  glasflaska_1_N = mkN "glasflaska" ; -- glasflaska..nn.1
  glasfluss_1_N = mkN "glasfluss" ; -- glasfluss..nn.1
  glasframställning_1_N = mkN "glasframställning" ; -- glasframställning..nn.1
  glasföremål_1_N = mkN "glasföremål" neutrum  ; -- glasföremål..nn.1
  glashal_1_A = mkA "glashal" ; -- glashal..av.1
  glashandduk_1_N = mkN "glashandduk" ; -- glashandduk..nn.1
  glasharmonika_1_N = mkN "glasharmonika" ; -- glasharmonika..nn.1
  glashus_1_N = mkN "glashus" neutrum  ; -- glashus..nn.1
  glashuv_1_N = mkN "glashuv" ; -- glashuv..nn.1
  glashylla_1_N = mkN "glashylla" ; -- glashylla..nn.1
  glashytta_1_N = mkN "glashytta" ; -- glashytta..nn.1
  glasig_1_A = mkA "glasig" ; -- glasig..av.1
  glasighet_1_N = mkN "glasighet" "glasigheter" ; -- glasighet..nn.1
  glasiglo_1_N = mkN "glasiglo" "glasiglon" "glasiglosar" "glasiglosarna" ; -- glasiglo..nn.1
  glasiologisk_1_A = mkA "glasiologisk" ; -- glasiologisk..av.1
  glaskanna_1_N = mkN "glaskanna" ; -- glaskanna..nn.1
  glaskaraff_1_N = mkN "glaskaraff" "glaskaraffer" ; -- glaskaraff..nn.1
  glasklar_1_A = mkA "glasklar" ; -- glasklar..av.1
  glasklocka_1_N = mkN "glasklocka" ; -- glasklocka..nn.1
  glasklot_1_N = mkN "glasklot" neutrum  ; -- glasklot..nn.1
  glaskolv_1_N = mkN "glaskolv" ; -- glaskolv..nn.1
  glaskropp_1_N = mkN "glaskropp" ; -- glaskropp..nn.1
  glaskub_1_N = mkN "glaskub" "glaskuber" ; -- glaskub..nn.1
  glaskula_1_N = mkN "glaskula" ; -- glaskula..nn.1
  glasmassa_1_N = mkN "glasmassa" ; -- glasmassa..nn.1
  glasmonter_1_N = mkN "glasmonter" ; -- glasmonter..nn.1
  glasmästardiamant_1_N = mkN "glasmästardiamant" "glasmästardiamanter" ; -- glasmästardiamant..nn.1
  glasmästare_1_N = mkN "glasmästare" utrum  ; -- glasmästare..nn.1
  glasmästarsill_1_N = mkN "glasmästarsill" ; -- glasmästarsill..nn.1
  glasmästeri_1_N = mkN "glasmästeri" "glasmästeriet" "glasmästerier" "glasmästerierna" ; -- glasmästeri..nn.1
  glasmålare_1_N = mkN "glasmålare" utrum  ; -- glasmålare..nn.1
  glasmåleri_1_N = mkN "glasmåleri" neutrum  ; -- glasmåleri..nn.1
  glasmålning_1_N = mkN "glasmålning" ; -- glasmålning..nn.1
  glasnost_1_N = mkN "glasnost" ; -- glasnost..nn.1
  glasplåt_1_N = mkN "glasplåt" ; -- glasplåt..nn.1
  glaspokal_1_N = mkN "glaspokal" "glaspokaler" ; -- glaspokal..nn.1
  glasprisma_1_N = mkN "glasprisma" ; -- glasprisma..nn.1
  glaspärla_1_N = mkN "glaspärla" ; -- glaspärla..nn.1
  glasrengöring_1_N = mkN "glasrengöring" ; -- glasrengöring..nn.1
  glasruta_1_N = mkN "glasruta" ; -- glasruta..nn.1
  glasrör_1_N = mkN "glasrör" neutrum  ; -- glasrör..nn.1
  glass_1_N = mkN "glass" ; -- glass..nn.1
  glassa_1_V = mkV "glassar" ; -- glassa..vb.1
  glassande_1_N = mkN "glassande" ; -- glassande..nn.1
  glassbil_1_N = mkN "glassbil" ; -- glassbil..nn.1
  glassbomb_1_N = mkN "glassbomb" "glassbomber" ; -- glassbomb..nn.1
  glassbägare_1_N = mkN "glassbägare" utrum  ; -- glassbägare..nn.1
  glassdessert_1_N = mkN "glassdessert" "glassdesserter" ; -- glassdessert..nn.1
  glassfabrik_1_N = mkN "glassfabrik" "glassfabriker" ; -- glassfabrik..nn.1
  glassförsäljning_1_N = mkN "glassförsäljning" ; -- glassförsäljning..nn.1
  glassig_1_A = mkA "glassig" ; -- glassig..av.1
  glassighet_1_N = mkN "glassighet" ; -- glassighet..nn.1
  glasskiva_1_N = mkN "glasskiva" ; -- glasskiva..nn.1
  glasskärardiamant_1_N = mkN "glasskärardiamant" "glasskärardiamanter" ; -- glasskärardiamant..nn.1
  glasskärare_1_N = mkN "glasskärare" utrum  ; -- glasskärare..nn.1
  glasskärva_1_N = mkN "glasskärva" ; -- glasskärva..nn.1
  glasskål_1_N = mkN "glasskål" ; -- glasskål..nn.1
  glasskåp_1_N = mkN "glasskåp" neutrum  ; -- glasskåp..nn.1
  glasslipare_1_N = mkN "glasslipare" utrum  ; -- glasslipare..nn.1
  glasslipning_1_N = mkN "glasslipning" ; -- glasslipning..nn.1
  glasslycka_1_N = mkN "glasslycka" ; -- glasslycka..nn.1
  glassmaskin_1_N = mkN "glassmaskin" "glassmaskiner" ; -- glassmaskin..nn.1
  glasspamp_1_N = mkN "glasspamp" ; -- glasspamp..nn.1
  glasspinne_1_N = mkN "glasspinne" utrum  ; -- glasspinne..nn.1
  glassplitter_1_N = mkN "glassplitter" neutrum  ; -- glassplitter..nn.1
  glassportion_1_N = mkN "glassportion" ; -- glassportion..nn.1
  glassrecept_1_N = mkN "glassrecept" neutrum  ; -- glassrecept..nn.1
  glasstrut_1_N = mkN "glasstrut" ; -- glasstrut..nn.1
  glasstårta_1_N = mkN "glasstårta" ; -- glasstårta..nn.1
  glassälskare_1_N = mkN "glassälskare" utrum  ; -- glassälskare..nn.1
  glastak_1_N = mkN "glastak" neutrum  ; -- glastak..nn.1
  glasull_1_N = mkN "glasull" ; -- glasull..nn.1
  glasvakt_1_N = mkN "glasvakt" "glasvakter" ; -- glasvakt..nn.1
  glasvar_1_N = mkN "glasvar" ; -- glasvar..nn.1
  glasveranda_1_N = mkN "glasveranda" ; -- glasveranda..nn.1
  glasvete_1_N = mkN "glasvete" ; -- glasvete..nn.1
  glasvingefjäril_1_N = mkN "glasvingefjäril" ; -- glasvingefjäril..nn.1
  glasvägg_1_N = mkN "glasvägg" ; -- glasvägg..nn.1
  glasvätska_1_N = mkN "glasvätska" ; -- glasvätska..nn.1
  glasyr_1_N = mkN "glasyr" "glasyrer" ; -- glasyr..nn.1
  glasäpple_1_N = mkN "glasäpple" ; -- glasäpple..nn.1
  glasål_1_N = mkN "glasål" ; -- glasål..nn.1
  glasöga_1_N = mkN "glasöga" "glasögat" "glasögon" "glasögonen" ; -- glasöga..nn.1
  glasögonbjörn_1_N = mkN "glasögonbjörn" ; -- glasögonbjörn..nn.1
  glasögonbåge_1_N = mkN "glasögonbåge" utrum  ; -- glasögonbåge..nn.1
  glasögonfodral_1_N = mkN "glasögonfodral" neutrum  ; -- glasögonfodral..nn.1
  glasögonorm_1_N = mkN "glasögonorm" ; -- glasögonorm..nn.1
  glasört_1_N = mkN "glasört" ; -- glasört..nn.1
  glatt_1_A = mkA "glatt" ; -- glatt..av.1
  glatta_1_V = mkV "glattar" ; -- glatta..vb.1
  glattande_1_N = mkN "glattande" ; -- glattande..nn.1
  glatthet_1_N = mkN "glatthet" ; -- glatthet..nn.1
  glattis_1_N = mkN "glattis" ; -- glattis..nn.1
  glattmask_1_N = mkN "glattmask" ; -- glattmask..nn.1
  glattning_1_N = mkN "glattning" ; -- glattning..nn.1
  glattpolera_1_V = mkV "glattpolerar" ; -- glattpolera..vb.1
  glattpolerande_1_N = mkN "glattpolerande" ; -- glattpolerande..nn.1
  glattpolering_1_N = mkN "glattpolering" ; -- glattpolering..nn.1
  glattslipa_1_V = mkV "glattslipar" ; -- glattslipa..vb.1
  glaubersalt_1_N = mkN "glaubersalt" neutrum  ; -- glaubersalt..nn.1
  glaukom_1_N = mkN "glaukom" neutrum  ; -- glaukom..nn.1
  glav_1_N = mkN "glav" ; -- glav..nn.1
  glencheck_1_N = mkN "glencheck" ; -- glencheck..nn.1
  gles_1_A = mkA "gles" ; -- gles..av.1
  glesa_1_V = mkV "glesar" ; -- glesa..vb.1
  glesande_1_N = mkN "glesande" ; -- glesande..nn.1
  glesbefolkad_1_A = mkA "glesbefolkad" ; -- glesbefolkad..av.1
  glesbladig_1_A = mkA "glesbladig" ; -- glesbladig..av.1
  glesbygd_1_N = mkN "glesbygd" "glesbygder" ; -- glesbygd..nn.1
  glesbygdsbo_1_N = mkN "glesbygdsbo" "glesbygdsbor" ; -- glesbygdsbo..nn.1
  gleshet_1_N = mkN "gleshet" ; -- gleshet..nn.1
  gleshårig_1_A = mkA "gleshårig" ; -- gleshårig..av.1
  glesläkt_1_N = mkN "glesläkt" ; -- glesläkt..nn.1
  glesna_1_V = mkV "glesnar" ; -- glesna..vb.1
  glesnande_1_N = mkN "glesnande" ; -- glesnande..nn.1
  glespanel_1_N = mkN "glespanel" "glespaneler" ; -- glespanel..nn.1
  glespanela_1_V = mkV "glespanelar" ; -- glespanela..vb.1
  glespanelande_1_N = mkN "glespanelande" ; -- glespanelande..nn.1
  glesregel_1_N = mkN "glesregel" ; -- glesregel..nn.1
  glete_1_N = mkN "glete" ; -- glete..nn.1
  gletscher_1_N = mkN "gletscher" ; -- gletscher..nn.1
  gli_1_N = mkN "gli" "gliet" "glin" "glina" ; -- gli..nn.1
  glia_1_N = mkN "glia" ; -- glia..nn.1
  glid_1_N = mkN "glid" neutrum  ; -- glid..nn.1
  glida_1_V = mkV "glida" "gled" "glidit" ; -- glida..vb.1
  glidande_1_N = mkN "glidande" ; -- glidande..nn.1
  glidarkille_1_N = mkN "glidarkille" utrum  ; -- glidarkille..nn.1
  glidflygning_1_N = mkN "glidflygning" ; -- glidflygning..nn.1
  glidflykt_1_N = mkN "glidflykt" ; -- glidflykt..nn.1
  glidfriktion_1_N = mkN "glidfriktion" ; -- glidfriktion..nn.1
  glidkontakt_1_N = mkN "glidkontakt" "glidkontakter" ; -- glidkontakt..nn.1
  glidkräm_1_N = mkN "glidkräm" "glidkrämer" ; -- glidkräm..nn.1
  glidlager_1_N = mkN "glidlager" neutrum  ; -- glidlager..nn.1
  glidljud_1_N = mkN "glidljud" neutrum  ; -- glidljud..nn.1
  glidmedel_1_N = mkN "glidmedel" neutrum  ; -- glidmedel..nn.1
  glidning_1_N = mkN "glidning" ; -- glidning..nn.1
  glidsalva_1_N = mkN "glidsalva" ; -- glidsalva..nn.1
  glidtackling_1_N = mkN "glidtackling" ; -- glidtackling..nn.1
  glim_1_N = mkN "glim" "glimmen" "glim" "glimmen" ; -- glim..nn.1
  glima_1_N = mkN "glima" ; -- glima..nn.1
  glimlampa_1_N = mkN "glimlampa" ; -- glimlampa..nn.1
  glimljus_1_N = mkN "glimljus" neutrum  ; -- glimljus..nn.1
  glimma_1_V = mkV "glimmar" ; -- glimma..vb.1
  glimmande_1_N = mkN "glimmande" ; -- glimmande..nn.1
  glimmer_2_N = mkN "glimmer" neutrum  ; -- glimmer..nn.2
  glimra_1_V = mkV "glimrar" ; -- glimra..vb.1
  glimrande_1_N = mkN "glimrande" ; -- glimrande..nn.1
  glimt_1_N = mkN "glimt" ; -- glimt..nn.1
  glimta_1_V = mkV "glimtar" ; -- glimta..vb.1
  glimtande_1_N = mkN "glimtande" ; -- glimtande..nn.1
  glimtvis_1_Adv = mkAdv "glimtvis" ; -- glimtvis..ab.1
  glimtändare_1_N = mkN "glimtändare" utrum  ; -- glimtändare..nn.1
  glinder_1_N = mkN "glinder" neutrum  ; -- glinder..nn.1
  glindra_1_V = mkV "glindrar" ; -- glindra..vb.1
  glindrande_1_N = mkN "glindrande" ; -- glindrande..nn.1
  gliom_1_N = mkN "gliom" neutrum  ; -- gliom..nn.1
  glipa_1_N = mkN "glipa" ; -- glipa..nn.1
  glipa_1_V = mkV "glipar" ; -- glipa..vb.1
  glipande_1_N = mkN "glipande" ; -- glipande..nn.1
  gliring_1_N = mkN "gliring" ; -- gliring..nn.1
  glis_1_N = mkN "glis" ; -- glis..nn.1
  glis_2_N = mkN "glis" ; -- glis..nn.2
  glisa_1_V = mkV "gliser" ; -- glisa..vb.1
  glisande_1_N = mkN "glisande" ; -- glisande..nn.1
  glissando_1_N = mkN "glissando" "glissandot" "glissandon" "glissandona" ; -- glissando..nn.1
  glisört_1_N = mkN "glisört" "glisörter" ; -- glisört..nn.1
  glitter_1_N = mkN "glitter" neutrum  ; -- glitter..nn.1
  glitterfin_1_A = mkA "glitterfin" ; -- glitterfin..av.1
  glittergirlang_1_N = mkN "glittergirlang" "glittergirlanger" ; -- glittergirlang..nn.1
  glitterglad_1_A = mkA "glitterglad" "glitterglatt" ; -- glitterglad..av.1
  glitterprydd_1_A = mkA "glitterprydd" ; -- glitterprydd..av.1
  glittertryck_1_N = mkN "glittertryck" neutrum  ; -- glittertryck..nn.1
  glittra_1_V = mkV "glittrar" ; -- glittra..vb.1
  glittrande_1_N = mkN "glittrande" ; -- glittrande..nn.1
  glittrig_1_A = mkA "glittrig" ; -- glittrig..av.1
  glittrighet_1_N = mkN "glittrighet" ; -- glittrighet..nn.1
  glo_1_V = mkV "glor" ; -- glo..vb.1
  glob_1_N = mkN "glob" "glober" ; -- glob..nn.1
  global_1_A = mkA "global" ; -- global..av.1
  globaliserad_1_A = mkA "globaliserad" ; -- globaliserad..av.1
  globalisering_1_N = mkN "globalisering" ; -- globalisering..nn.1
  globetrotter_1_N = mkN "globetrotter" ; -- globetrotter..nn.1
  globulin_1_N = mkN "globulin" "globuliner" ; -- globulin..nn.1
  gloende_1_N = mkN "gloende" ; -- gloende..nn.1
  glop_1_N = mkN "glop" ; -- glop..nn.1
  glopp_1_N = mkN "glopp" neutrum  ; -- glopp..nn.1
  gloria_1_N = mkN "gloria" ; -- gloria..nn.1
  glorifiera_1_V = mkV "glorifierar" ; -- glorifiera..vb.1
  glorifierande_1_N = mkN "glorifierande" ; -- glorifierande..nn.1
  glorifierbar_1_A = mkA "glorifierbar" ; -- glorifierbar..av.1
  glorifierbarhet_1_N = mkN "glorifierbarhet" ; -- glorifierbarhet..nn.1
  glorifiering_1_N = mkN "glorifiering" ; -- glorifiering..nn.1
  gloriös_1_A = mkA "gloriös" ; -- gloriös..av.1
  glosa_1_N = mkN "glosa" ; -- glosa..nn.1
  glosbok_1_N = mkN "glosbok" "glosböcker" ; -- glosbok..nn.1
  glosig_1_A = mkA "glosig" ; -- glosig..av.1
  glossa_1_N = mkN "glossa" ; -- glossa..nn.1
  glossar_1_N = mkN "glossar" neutrum  ; -- glossar..nn.1
  glossarium_1_N = mkN "glossarium" "glossariet" "glossarier" "glossarierna" ; -- glossarium..nn.1
  glossematik_1_N = mkN "glossematik" "glossematiker" ; -- glossematik..nn.1
  glossig_1_A = mkA "glossig" ; -- glossig..av.1
  glossolali_1_N = mkN "glossolali" "glossolalier" ; -- glossolali..nn.1
  glosögd_1_A = mkA "glosögd" "glosögt" ; -- glosögd..av.1
  glosögdhet_1_N = mkN "glosögdhet" ; -- glosögdhet..nn.1
  glottisstöt_1_N = mkN "glottisstöt" ; -- glottisstöt..nn.1
  glottokronologi_1_N = mkN "glottokronologi" ; -- glottokronologi..nn.1
  gloxinia_1_N = mkN "gloxinia" ; -- gloxinia..nn.1
  glugg_1_N = mkN "glugg" ; -- glugg..nn.1
  glukos_1_N = mkN "glukos" ; -- glukos..nn.1
  glunka_1_V = mkV "glunkar" ; -- glunka..vb.1
  glunkande_1_N = mkN "glunkande" ; -- glunkande..nn.1
  glunt_1_N = mkN "glunt" ; -- glunt..nn.1
  gluon_1_N = mkN "gluon" "gluoner" ; -- gluon..nn.1
  glupande_1_A = mkA "glupande" ; -- glupande..av.1
  glupsk_1_A = mkA "glupsk" ; -- glupsk..av.1
  glupskhet_1_N = mkN "glupskhet" ; -- glupskhet..nn.1
  glutamat_1_N = mkN "glutamat" neutrum  ; -- glutamat..nn.1
  glutaminsyra_1_N = mkN "glutaminsyra" ; -- glutaminsyra..nn.1
  gluten_1_A = mkA "gluten" ; -- gluten..av.1
  gluten_1_N = mkN "gluten" neutrum  ; -- gluten..nn.1
  glutenfri_1_A = mkA "glutenfri" "glutenfritt" ; -- glutenfri..av.1
  glutenintolerans_1_N = mkN "glutenintolerans" ; -- glutenintolerans..nn.1
  glutenintolerant_1_A = mkA "glutenintolerant" "glutenintolerant" ; -- glutenintolerant..av.1
  glutinös_1_A = mkA "glutinös" ; -- glutinös..av.1
  glutta_1_V = mkV "gluttar" ; -- glutta..vb.1
  gluttande_1_N = mkN "gluttande" ; -- gluttande..nn.1
  gluttare_1_N = mkN "gluttare" utrum  ; -- gluttare..nn.1
  gluttsnäppa_1_N = mkN "gluttsnäppa" ; -- gluttsnäppa..nn.1
  glycerid_1_N = mkN "glycerid" "glycerider" ; -- glycerid..nn.1
  glycerin_1_N = mkN "glycerin" ; -- glycerin..nn.1
  glycerintvål_1_N = mkN "glycerintvål" ; -- glycerintvål..nn.1
  glycerol_1_N = mkN "glycerol" ; -- glycerol..nn.1
  glycerylnitrat_1_N = mkN "glycerylnitrat" neutrum  ; -- glycerylnitrat..nn.1
  glycin_1_N = mkN "glycin" "glyciner" ; -- glycin..nn.1
  glykogen_1_N = mkN "glykogen" neutrum  ; -- glykogen..nn.1
  glykol_1_N = mkN "glykol" "glykoler" ; -- glykol..nn.1
  glykolys_1_N = mkN "glykolys" ; -- glykolys..nn.1
  glykopeptid_1_N = mkN "glykopeptid" "glykopeptider" ; -- glykopeptid..nn.1
  glykos_1_N = mkN "glykos" ; -- glykos..nn.1
  glykosid_1_N = mkN "glykosid" "glykosider" ; -- glykosid..nn.1
  glyptik_1_N = mkN "glyptik" ; -- glyptik..nn.1
  glyptotek_1_N = mkN "glyptotek" neutrum  ; -- glyptotek..nn.1
  glytt_1_N = mkN "glytt" ; -- glytt..nn.1
  glyttig_1_A = mkA "glyttig" ; -- glyttig..av.1
  glyttighet_1_N = mkN "glyttighet" ; -- glyttighet..nn.1
  glädjande_1_A = mkA "glädjande" ; -- glädjande..av.1
  glädjande_1_N = mkN "glädjande" ; -- glädjande..nn.1
  glädje_1_N = mkN "glädje" utrum  ; -- glädje..nn.1
  glädjebesked_1_N = mkN "glädjebesked" neutrum  ; -- glädjebesked..nn.1
  glädjebetyg_1_N = mkN "glädjebetyg" neutrum  ; -- glädjebetyg..nn.1
  glädjebetygelse_1_N = mkN "glädjebetygelse" "glädjebetygelser" ; -- glädjebetygelse..nn.1
  glädjebetygssättning_1_N = mkN "glädjebetygssättning" ; -- glädjebetygssättning..nn.1
  glädjebringande_1_A = mkA "glädjebringande" ; -- glädjebringande..av.1
  glädjebud_1_N = mkN "glädjebud" neutrum  ; -- glädjebud..nn.1
  glädjebudskap_1_N = mkN "glädjebudskap" neutrum  ; -- glädjebudskap..nn.1
  glädjedag_1_N = mkN "glädjedag" ; -- glädjedag..nn.1
  glädjedans_1_N = mkN "glädjedans" "glädjedanser" ; -- glädjedans..nn.1
  glädjedödare_1_N = mkN "glädjedödare" utrum  ; -- glädjedödare..nn.1
  glädjefattig_1_A = mkA "glädjefattig" ; -- glädjefattig..av.1
  glädjefest_1_N = mkN "glädjefest" "glädjefester" ; -- glädjefest..nn.1
  glädjeflicka_1_N = mkN "glädjeflicka" ; -- glädjeflicka..nn.1
  glädjefnatt_1_N = mkN "glädjefnatt" ; -- glädjefnatt..nn.1
  glädjefull_1_A = mkA "glädjefull" ; -- glädjefull..av.1
  glädjefylld_1_A = mkA "glädjefylld" "glädjefyllt" ; -- glädjefylld..av.1
  glädjefylldhet_1_N = mkN "glädjefylldhet" ; -- glädjefylldhet..nn.1
  glädjehopp_1_N = mkN "glädjehopp" neutrum  ; -- glädjehopp..nn.1
  glädjehus_1_N = mkN "glädjehus" neutrum  ; -- glädjehus..nn.1
  glädjehögtid_1_N = mkN "glädjehögtid" "glädjehögtider" ; -- glädjehögtid..nn.1
  glädjekalkyl_1_N = mkN "glädjekalkyl" "glädjekalkyler" ; -- glädjekalkyl..nn.1
  glädjekvarter_1_N = mkN "glädjekvarter" "glädjekvarteret" "glädjekvarter" "glädjekvarteren" ; -- glädjekvarter..nn.1
  glädjelös_1_A = mkA "glädjelös" ; -- glädjelös..av.1
  glädjemäta_1_V = mkV "glädjemäter" ; -- glädjemäta..vb.1
  glädjemätande_1_N = mkN "glädjemätande" ; -- glädjemätande..nn.1
  glädjemätning_1_N = mkN "glädjemätning" ; -- glädjemätning..nn.1
  glädjerik_1_A = mkA "glädjerik" ; -- glädjerik..av.1
  glädjerop_1_N = mkN "glädjerop" neutrum  ; -- glädjerop..nn.1
  glädjerus_1_N = mkN "glädjerus" neutrum  ; -- glädjerus..nn.1
  glädjerusig_1_A = mkA "glädjerusig" ; -- glädjerusig..av.1
  glädjerusighet_1_N = mkN "glädjerusighet" ; -- glädjerusighet..nn.1
  glädjeskri_1_N = mkN "glädjeskri" "glädjeskriet" "glädjeskrin" "glädjeskrina" ; -- glädjeskri..nn.1
  glädjespridare_1_N = mkN "glädjespridare" utrum  ; -- glädjespridare..nn.1
  glädjesprång_1_N = mkN "glädjesprång" neutrum  ; -- glädjesprång..nn.1
  glädjestrålande_1_A = mkA "glädjestrålande" ; -- glädjestrålande..av.1
  glädjetom_1_A = mkA "glädjetom" "glädjetomt" "glädjetomma" "glädjetomma" "glädjetommare" "glädjetommast" "glädjetommaste" ; -- glädjetom..av.1
  glädjetår_1_N = mkN "glädjetår" ; -- glädjetår..nn.1
  glädjeyra_1_N = mkN "glädjeyra" ; -- glädjeyra..nn.1
  glädjeyttring_1_N = mkN "glädjeyttring" ; -- glädjeyttring..nn.1
  glädjeämne_1_N = mkN "glädjeämne" ; -- glädjeämne..nn.1
  gläfs_1_N = mkN "gläfs" neutrum  ; -- gläfs..nn.1
  gläfsa_1_V = mkV "gläfser" ; -- gläfsa..vb.1
  gläfsande_1_N = mkN "gläfsande" ; -- gläfsande..nn.1
  gläfsning_1_N = mkN "gläfsning" ; -- gläfsning..nn.1
  glänsa_1_V = mkV "glänser" ; -- glänsa..vb.1
  glänsande_1_A = mkA "glänsande" ; -- glänsande..av.1
  glänsande_1_N = mkN "glänsande" ; -- glänsande..nn.1
  glänta_1_N = mkN "glänta" ; -- glänta..nn.1
  glänta_1_V = mkV "gläntar" ; -- glänta..vb.1
  gläntande_1_N = mkN "gläntande" ; -- gläntande..nn.1
  glätta_1_V = mkV "glättar" ; -- glätta..vb.1
  glättad_1_A = mkA "glättad" ; -- glättad..av.1
  glättande_1_N = mkN "glättande" ; -- glättande..nn.1
  glättig_1_A = mkA "glättig" ; -- glättig..av.1
  glättighet_1_N = mkN "glättighet" "glättigheter" ; -- glättighet..nn.1
  glättning_1_N = mkN "glättning" ; -- glättning..nn.1
  glättsten_1_N = mkN "glättsten" "glättstenen" "glättstenar" "glättstenarna" ; -- glättsten..nn.1
  glåmig_1_A = mkA "glåmig" ; -- glåmig..av.1
  glåmighet_1_N = mkN "glåmighet" "glåmigheter" ; -- glåmighet..nn.1
  glåpord_1_N = mkN "glåpord" neutrum  ; -- glåpord..nn.1
  glöd_1_N = mkN "glöd" ; -- glöd..nn.1
  glöda_1_V = mkV "glöda" "glödde" "glött" ; -- glöda..vb.1
  glödande_1_A = mkA "glödande" ; -- glödande..av.1
  glödande_1_N = mkN "glödande" ; -- glödande..nn.1
  glödbaka_1_V = mkV "glödbaker" ; -- glödbaka..vb.1
  glödbakande_1_N = mkN "glödbakande" ; -- glödbakande..nn.1
  glödbädd_1_N = mkN "glödbädd" ; -- glödbädd..nn.1
  glödeld_1_N = mkN "glödeld" ; -- glödeld..nn.1
  glödfat_1_N = mkN "glödfat" neutrum  ; -- glödfat..nn.1
  glödga_1_V = mkV "glödgar" ; -- glödga..vb.1
  glödgande_1_N = mkN "glödgande" ; -- glödgande..nn.1
  glödgning_1_N = mkN "glödgning" ; -- glödgning..nn.1
  glödhet_1_A = mkA "glödhet" ; -- glödhet..av.1
  glödhetta_1_N = mkN "glödhetta" ; -- glödhetta..nn.1
  glödhoppa_1_N = mkN "glödhoppa" ; -- glödhoppa..nn.1
  glödhög_1_N = mkN "glödhög" ; -- glödhög..nn.1
  glödkatod_1_N = mkN "glödkatod" "glödkatoder" ; -- glödkatod..nn.1
  glödkropp_1_N = mkN "glödkropp" ; -- glödkropp..nn.1
  glödlampa_1_N = mkN "glödlampa" ; -- glödlampa..nn.1
  glödlampsfabrik_1_N = mkN "glödlampsfabrik" "glödlampsfabriker" ; -- glödlampsfabrik..nn.1
  glödljus_1_N = mkN "glödljus" neutrum  ; -- glödljus..nn.1
  glödmjuk_1_A = mkA "glödmjuk" ; -- glödmjuk..av.1
  glödning_1_N = mkN "glödning" ; -- glödning..nn.1
  glödrita_1_V = mkV "glödritar" ; -- glödrita..vb.1
  glödritande_1_N = mkN "glödritande" ; -- glödritande..nn.1
  glödritning_1_N = mkN "glödritning" ; -- glödritning..nn.1
  glödsteka_1_V = mkV "glödsteker" ; -- glödsteka..vb.1
  glödstekande_1_N = mkN "glödstekande" ; -- glödstekande..nn.1
  glödstrumpa_1_N = mkN "glödstrumpa" ; -- glödstrumpa..nn.1
  glödström_1_N = mkN "glödström" "glödströmmen" "glödströmmar" "glödströmmarna" ; -- glödström..nn.1
  glödtråd_1_N = mkN "glödtråd" ; -- glödtråd..nn.1
  glödtända_1_V = mkV "glödtänder" ; -- glödtända..vb.1
  glödtändande_1_N = mkN "glödtändande" ; -- glödtändande..nn.1
  glödvarm_1_A = mkA "glödvarm" ; -- glödvarm..av.1
  glögg_1_N = mkN "glögg" ; -- glögg..nn.1
  glögga_1_V = mkV "glöggar" ; -- glögga..vb.1
  glöggande_1_N = mkN "glöggande" ; -- glöggande..nn.1
  glöggpanna_1_N = mkN "glöggpanna" ; -- glöggpanna..nn.1
  glöggryta_1_N = mkN "glöggryta" ; -- glöggryta..nn.1
  glöggsörpling_1_N = mkN "glöggsörpling" ; -- glöggsörpling..nn.1
  glöggtest_1_N = mkN "glöggtest" neutrum  ; -- glöggtest..nn.1
  glömma_1_V = mkV "glömmer" ; -- glömma..vb.1
  glömmande_1_N = mkN "glömmande" ; -- glömmande..nn.1
  glömsk_1_A = mkA "glömsk" ; -- glömsk..av.1
  glömska_1_N = mkN "glömska" ; -- glömska..nn.1
  glömskekurva_1_N = mkN "glömskekurva" ; -- glömskekurva..nn.1
  glömskhet_1_N = mkN "glömskhet" ; -- glömskhet..nn.1
  glöta_1_V = mkV "glötar" ; -- glöta..vb.1
  glötande_1_N = mkN "glötande" ; -- glötande..nn.1
  gnabb_1_N = mkN "gnabb" neutrum  ; -- gnabb..nn.1
  gnag_1_N = mkN "gnag" neutrum  ; -- gnag..nn.1
  gnaga_1_V = mkV "gnager" ; -- gnaga..vb.1
  gnagande_1_N = mkN "gnagande" ; -- gnagande..nn.1
  gnagare_1_N = mkN "gnagare" utrum  ; -- gnagare..nn.1
  gnagarliknande_1_A = mkA "gnagarliknande" ; -- gnagarliknande..av.1
  gnagning_1_N = mkN "gnagning" ; -- gnagning..nn.1
  gnagtand_1_N = mkN "gnagtand" "gnagtänder" ; -- gnagtand..nn.1
  gnat_1_N = mkN "gnat" neutrum  ; -- gnat..nn.1
  gnata_1_V = mkV "gnatar" ; -- gnata..vb.1
  gnatande_1_N = mkN "gnatande" ; -- gnatande..nn.1
  gnatig_1_A = mkA "gnatig" ; -- gnatig..av.1
  gnatighet_1_N = mkN "gnatighet" ; -- gnatighet..nn.1
  gnava_1_V = mkV "gnaver" ; -- gnava..vb.1
  gnavande_1_N = mkN "gnavande" ; -- gnavande..nn.1
  gnejs_1_N = mkN "gnejs" "gnejser" ; -- gnejs..nn.1
  gnet_1_N = mkN "gnet" "gnetter" ; -- gnet..nn.1
  gnet_2_N = mkN "gnet" ; -- gnet..nn.2
  gneta_1_V = mkV "gnetar" ; -- gneta..vb.1
  gnetande_1_N = mkN "gnetande" ; -- gnetande..nn.1
  gnetig_1_A = mkA "gnetig" ; -- gnetig..av.1
  gnetighet_1_N = mkN "gnetighet" ; -- gnetighet..nn.1
  gnida_1_V = mkV "gnida" "gned" "gnidit" ; -- gnida..vb.1
  gnidande_1_N = mkN "gnidande" ; -- gnidande..nn.1
  gnidare_1_N = mkN "gnidare" utrum  ; -- gnidare..nn.1
  gniden_1_A = mkA "gniden" ; -- gniden..av.1
  gnidenhet_1_N = mkN "gnidenhet" ; -- gnidenhet..nn.1
  gnideri_1_N = mkN "gnideri" neutrum  ; -- gnideri..nn.1
  gnidig_1_A = mkA "gnidig" ; -- gnidig..av.1
  gnidning_1_N = mkN "gnidning" ; -- gnidning..nn.1
  gnidningselektricitet_1_N = mkN "gnidningselektricitet" "gnidningselektriciteter" ; -- gnidningselektricitet..nn.1
  gnissel_1_N = mkN "gnissel" neutrum  ; -- gnissel..nn.1
  gnisselljud_1_N = mkN "gnisselljud" neutrum  ; -- gnisselljud..nn.1
  gnissla_1_V = mkV "gnisslar" ; -- gnissla..vb.1
  gnisslande_1_N = mkN "gnisslande" ; -- gnisslande..nn.1
  gnissling_1_N = mkN "gnissling" ; -- gnissling..nn.1
  gnist_1_N = mkN "gnist" ; -- gnist..nn.1
  gnista_1_N = mkN "gnista" ; -- gnista..nn.1
  gnista_2_N = mkN "gnista" ; -- gnista..nn.2
  gnista_1_V = mkV "gnistar" ; -- gnista..vb.1
  gnistande_1_N = mkN "gnistande" ; -- gnistande..nn.1
  gnistbildning_1_N = mkN "gnistbildning" ; -- gnistbildning..nn.1
  gnistfångare_1_N = mkN "gnistfångare" utrum  ; -- gnistfångare..nn.1
  gnistgaller_1_N = mkN "gnistgaller" neutrum  ; -- gnistgaller..nn.1
  gnistgap_1_N = mkN "gnistgap" neutrum  ; -- gnistgap..nn.1
  gnistinduktor_1_N = mkN "gnistinduktor" "gnistinduktorer" ; -- gnistinduktor..nn.1
  gnistkammare_1_N = mkN "gnistkammare" "gnistkammaren" "gnistkammare" "gnistkamrarna" ; -- gnistkammare..nn.1
  gnistra_1_V = mkV "gnistrar" ; -- gnistra..vb.1
  gnistrande_1_N = mkN "gnistrande" ; -- gnistrande..nn.1
  gnistregn_1_N = mkN "gnistregn" neutrum  ; -- gnistregn..nn.1
  gnistrig_1_A = mkA "gnistrig" ; -- gnistrig..av.1
  gnistrighet_1_N = mkN "gnistrighet" ; -- gnistrighet..nn.1
  gnistskydd_1_N = mkN "gnistskydd" neutrum  ; -- gnistskydd..nn.1
  gnistsläckare_1_N = mkN "gnistsläckare" utrum  ; -- gnistsläckare..nn.1
  gniststation_1_N = mkN "gniststation" ; -- gniststation..nn.1
  gniststräcka_1_N = mkN "gniststräcka" ; -- gniststräcka..nn.1
  gnistsändare_1_N = mkN "gnistsändare" utrum  ; -- gnistsändare..nn.1
  gnisttändning_1_N = mkN "gnisttändning" ; -- gnisttändning..nn.1
  gno_1_V = mkV "gnor" ; -- gno..vb.1
  gnoding_1_N = mkN "gnoding" ; -- gnoding..nn.1
  gnoende_1_N = mkN "gnoende" ; -- gnoende..nn.1
  gnola_1_V = mkV "gnolar" ; -- gnola..vb.1
  gnolande_1_N = mkN "gnolande" ; -- gnolande..nn.1
  gnom_1_N = mkN "gnom" "gnomer" ; -- gnom..nn.1
  gnomiker_1_N = mkN "gnomiker" "gnomikern" "gnomiker" "gnomikerna" ; -- gnomiker..nn.1
  gnomon_1_N = mkN "gnomon" "gnomoner" ; -- gnomon..nn.1
  gnosis_1_N = mkN "gnosis" ; -- gnosis..nn.1
  gnosticism_1_N = mkN "gnosticism" "gnosticismer" ; -- gnosticism..nn.1
  gnostiker_1_N = mkN "gnostiker" "gnostikern" "gnostiker" "gnostikerna" ; -- gnostiker..nn.1
  gnostisk_1_A = mkA "gnostisk" ; -- gnostisk..av.1
  gnu_1_N = mkN "gnu" "gnun" "gnuer" "gnuerna" ; -- gnu..nn.1
  gnugga_1_V = mkV "gnuggar" ; -- gnugga..vb.1
  gnuggande_1_N = mkN "gnuggande" ; -- gnuggande..nn.1
  gnuggbild_1_N = mkN "gnuggbild" "gnuggbilder" ; -- gnuggbild..nn.1
  gnuggning_1_N = mkN "gnuggning" ; -- gnuggning..nn.1
  gnuss_1_N = mkN "gnuss" ; -- gnuss..nn.1
  gnussa_1_V = mkV "gnussar" ; -- gnussa..vb.1
  gnussande_1_N = mkN "gnussande" ; -- gnussande..nn.1
  gnussare_1_N = mkN "gnussare" utrum  ; -- gnussare..nn.1
  gnutta_1_N = mkN "gnutta" ; -- gnutta..nn.1
  gny_1_N = mkN "gny" neutrum  ; -- gny..nn.1
  gny_1_V = mkV "gnyr" ; -- gny..vb.1
  gnyende_1_N = mkN "gnyende" ; -- gnyende..nn.1
  gnägg_1_N = mkN "gnägg" neutrum  ; -- gnägg..nn.1
  gnägga_1_V = mkV "gnäggar" ; -- gnägga..vb.1
  gnäggande_1_N = mkN "gnäggande" ; -- gnäggande..nn.1
  gnäggning_1_N = mkN "gnäggning" ; -- gnäggning..nn.1
  gnäll_1_N = mkN "gnäll" neutrum  ; -- gnäll..nn.1
  gnälla_1_V = mkV "gnäller" ; -- gnälla..vb.1
  gnällande_1_N = mkN "gnällande" ; -- gnällande..nn.1
  gnällig_1_A = mkA "gnällig" ; -- gnällig..av.1
  gnällighet_1_N = mkN "gnällighet" ; -- gnällighet..nn.1
  gnällmåns_1_N = mkN "gnällmåns" ; -- gnällmåns..nn.1
  gnällspik_1_N = mkN "gnällspik" ; -- gnällspik..nn.1
  gnöl_1_N = mkN "gnöl" neutrum  ; -- gnöl..nn.1
  gnöla_1_V = mkV "gnölar" ; -- gnöla..vb.1
  gnölande_1_N = mkN "gnölande" ; -- gnölande..nn.1
  go_cart_1_N = mkN "go-cart" "go-carten" "go-carts" "go-cartsarna" ; -- go-cart..nn.1
  go_go_flicka_1_N = mkN "go-go-flicka" ; -- go-go-flicka..nn.1
  go_1_N = mkN "go" ; -- go..nn.1
  go_2_N = mkN "go" ; -- go..nn.2
  gobeläng_1_N = mkN "gobeläng" "gobelänger" ; -- gobeläng..nn.1
  gobelängbroderi_1_N = mkN "gobelängbroderi" "gobelängbroderiet" "gobelängbroderier" "gobelängbroderierna" ; -- gobelängbroderi..nn.1
  gobelängklädd_1_A = mkA "gobelängklädd" ; -- gobelängklädd..av.1
  gobelängtyg_1_N = mkN "gobelängtyg" neutrum  ; -- gobelängtyg..nn.1
  god_1_A = mkA "god" "gott" ; -- god..av.1
  godartad_1_A = mkA "godartad" ; -- godartad..av.1
  godbit_1_N = mkN "godbit" ; -- godbit..nn.1
  goddagspilt_1_N = mkN "goddagspilt" ; -- goddagspilt..nn.1
  gode_1_N = mkN "gode" utrum  ; -- gode..nn.1
  godemanskap_1_N = mkN "godemanskap" neutrum  ; -- godemanskap..nn.1
  godhet_1_N = mkN "godhet" "godheter" ; -- godhet..nn.1
  godhetsfull_1_A = mkA "godhetsfull" ; -- godhetsfull..av.1
  godhetsfullhet_1_N = mkN "godhetsfullhet" ; -- godhetsfullhet..nn.1
  godhjärtad_1_A = mkA "godhjärtad" ; -- godhjärtad..av.1
  godhjärtenhet_1_N = mkN "godhjärtenhet" "godhjärtenheter" ; -- godhjärtenhet..nn.1
  godhällig_1_A = mkA "godhällig" ; -- godhällig..av.1
  godhällighet_1_N = mkN "godhällighet" ; -- godhällighet..nn.1
  goding_1_N = mkN "goding" ; -- goding..nn.1
  godis_1_N = mkN "godis" neutrum  ; -- godis..nn.1
  godis_2_N = mkN "godis" ; -- godis..nn.2
  godishjärta_1_N = mkN "godishjärta" "godishjärtat" "godishjärtan" "godishjärtana" ; -- godishjärta..nn.1
  godisjakt_1_N = mkN "godisjakt" ; -- godisjakt..nn.1
  godislycka_1_N = mkN "godislycka" ; -- godislycka..nn.1
  godispanik_1_N = mkN "godispanik" ; -- godispanik..nn.1
  godissugen_1_A = mkA "godissugen" ; -- godissugen..av.1
  godissugenhet_1_N = mkN "godissugenhet" ; -- godissugenhet..nn.1
  godkänd_1_A = mkA "godkänd" ; -- godkänd..av.1
  godkänna_1_V = mkV "godkänna" "godkände" "godkänt" ; -- godkänna..vb.1
  godkännande_1_N = mkN "godkännande" ; -- godkännande..nn.1
  godkännare_1_N = mkN "godkännare" utrum  ; -- godkännare..nn.1
  godlynt_1_A = mkA "godlynt" "godlynt" ; -- godlynt..av.1
  godlynthet_1_N = mkN "godlynthet" ; -- godlynthet..nn.1
  godmanskap_1_N = mkN "godmanskap" neutrum  ; -- godmanskap..nn.1
  godmodig_1_A = mkA "godmodig" ; -- godmodig..av.1
  godmodighet_1_N = mkN "godmodighet" ; -- godmodighet..nn.1
  godnattsaga_1_N = mkN "godnattsaga" ; -- godnattsaga..nn.1
  gods_1_N = mkN "gods" neutrum  ; -- gods..nn.1
  godsak_1_N = mkN "godsak" "godsaker" ; -- godsak..nn.1
  godsexpedition_1_N = mkN "godsexpedition" ; -- godsexpedition..nn.1
  godsfinka_1_N = mkN "godsfinka" ; -- godsfinka..nn.1
  godsherre_1_N = mkN "godsherre" utrum  ; -- godsherre..nn.1
  godsindragning_1_N = mkN "godsindragning" ; -- godsindragning..nn.1
  godsint_1_A = mkA "godsint" "godsint" ; -- godsint..av.1
  godsinthet_1_N = mkN "godsinthet" ; -- godsinthet..nn.1
  godsmagasin_1_N = mkN "godsmagasin" neutrum  ; -- godsmagasin..nn.1
  godsmottagning_1_N = mkN "godsmottagning" ; -- godsmottagning..nn.1
  godsstation_1_N = mkN "godsstation" ; -- godsstation..nn.1
  godsterminal_1_N = mkN "godsterminal" "godsterminaler" ; -- godsterminal..nn.1
  godstrafik_1_N = mkN "godstrafik" ; -- godstrafik..nn.1
  godstransport_1_N = mkN "godstransport" "godstransporter" ; -- godstransport..nn.1
  godståg_1_N = mkN "godståg" neutrum  ; -- godståg..nn.1
  godsvagn_1_N = mkN "godsvagn" ; -- godsvagn..nn.1
  godsägare_1_N = mkN "godsägare" utrum  ; -- godsägare..nn.1
  godsägarinna_1_N = mkN "godsägarinna" ; -- godsägarinna..nn.1
  godsägarstil_1_N = mkN "godsägarstil" ; -- godsägarstil..nn.1
  godta_1_V = mkV "godtaga" "godtog" "godtagit" ; -- godta..vb.1
  godtagande_1_N = mkN "godtagande" ; -- godtagande..nn.1
  godtagbar_1_A = mkA "godtagbar" ; -- godtagbar..av.1
  godtagbarhet_1_N = mkN "godtagbarhet" ; -- godtagbarhet..nn.1
  godtemplare_1_N = mkN "godtemplare" utrum  ; -- godtemplare..nn.1
  godtemplarorden_1_N = mkN "godtemplarorden" ; -- godtemplarorden..nn.1
  godtrogen_1_A = mkA "godtrogen" ; -- godtrogen..av.1
  godtrogenhet_1_N = mkN "godtrogenhet" ; -- godtrogenhet..nn.1
  godtrosförvärv_1_N = mkN "godtrosförvärv" neutrum  ; -- godtrosförvärv..nn.1
  godtycke_1_N = mkN "godtycke" ; -- godtycke..nn.1
  godtycklig_1_A = mkA "godtycklig" ; -- godtycklig..av.1
  godtycklighet_1_N = mkN "godtycklighet" "godtyckligheter" ; -- godtycklighet..nn.1
  godvikt_1_N = mkN "godvikt" "godvikter" ; -- godvikt..nn.1
  godvillig_1_A = mkA "godvillig" ; -- godvillig..av.1
  godvillighet_1_N = mkN "godvillighet" ; -- godvillighet..nn.1
  goffrera_1_V = mkV "goffrerar" ; -- goffrera..vb.1
  goffrerande_1_N = mkN "goffrerande" ; -- goffrerande..nn.1
  goffrerbar_1_A = mkA "goffrerbar" ; -- goffrerbar..av.1
  goffrerbarhet_1_N = mkN "goffrerbarhet" ; -- goffrerbarhet..nn.1
  goffrering_1_N = mkN "goffrering" ; -- goffrering..nn.1
  goja_1_N = mkN "goja" ; -- goja..nn.1
  goja_2_N = mkN "goja" ; -- goja..nn.2
  gola_1_V = mkV "golar" ; -- gola..vb.1
  gold_digger_1_N = mkN "gold-digger" "gold-diggern" "gold-diggers" "gold-diggersarna" ; -- gold-digger..nn.1
  golf_1_N = mkN "golf" ; -- golf..nn.1
  golf_2_N = mkN "golf" "golfer" ; -- golf..nn.2
  golfa_1_V = mkV "golfar" ; -- golfa..vb.1
  golfande_1_N = mkN "golfande" ; -- golfande..nn.1
  golfare_1_N = mkN "golfare" utrum  ; -- golfare..nn.1
  golfbana_1_N = mkN "golfbana" ; -- golfbana..nn.1
  golfboll_1_N = mkN "golfboll" ; -- golfboll..nn.1
  golfbyxa_1_N = mkN "golfbyxa" ; -- golfbyxa..nn.1
  golfklubb_1_N = mkN "golfklubb" ; -- golfklubb..nn.1
  golfklubba_1_N = mkN "golfklubba" ; -- golfklubba..nn.1
  golfmässig_1_A = mkA "golfmässig" ; -- golfmässig..av.1
  golfresa_1_N = mkN "golfresa" ; -- golfresa..nn.1
  golfrunda_1_N = mkN "golfrunda" ; -- golfrunda..nn.1
  golfskjorta_1_N = mkN "golfskjorta" ; -- golfskjorta..nn.1
  golfspel_1_N = mkN "golfspel" "golfspelet" "golfspel" "golfspelen" ; -- golfspel..nn.1
  golfspelare_1_N = mkN "golfspelare" utrum  ; -- golfspelare..nn.1
  golfstjärna_1_N = mkN "golfstjärna" ; -- golfstjärna..nn.1
  golfturnering_1_N = mkN "golfturnering" ; -- golfturnering..nn.1
  golgatavandring_1_N = mkN "golgatavandring" ; -- golgatavandring..nn.1
  golgiapparat_1_N = mkN "golgiapparat" "golgiapparater" ; -- golgiapparat..nn.1
  goltupp_1_N = mkN "goltupp" ; -- goltupp..nn.1
  golv_1_N = mkN "golv" neutrum  ; -- golv..nn.1
  golva_1_V = mkV "golvar" ; -- golva..vb.1
  golvande_1_N = mkN "golvande" ; -- golvande..nn.1
  golvbeläggning_1_N = mkN "golvbeläggning" ; -- golvbeläggning..nn.1
  golvbjälke_1_N = mkN "golvbjälke" utrum  ; -- golvbjälke..nn.1
  golvbrunn_1_N = mkN "golvbrunn" ; -- golvbrunn..nn.1
  golvbrunnssil_1_N = mkN "golvbrunnssil" ; -- golvbrunnssil..nn.1
  golvbräda_1_N = mkN "golvbräda" ; -- golvbräda..nn.1
  golvdrag_1_N = mkN "golvdrag" neutrum  ; -- golvdrag..nn.1
  golvfast_1_A = mkA "golvfast" "golvfast" ; -- golvfast..av.1
  golvfärg_1_N = mkN "golvfärg" "golvfärger" ; -- golvfärg..nn.1
  golvkall_1_A = mkA "golvkall" ; -- golvkall..av.1
  golvklocka_1_N = mkN "golvklocka" ; -- golvklocka..nn.1
  golvkonstruktion_1_N = mkN "golvkonstruktion" ; -- golvkonstruktion..nn.1
  golvlack_1_N = mkN "golvlack" "golvlacket" "golvlacker" "golvlackerna" ; -- golvlack..nn.1
  golvlampa_1_N = mkN "golvlampa" ; -- golvlampa..nn.1
  golvlist_1_N = mkN "golvlist" "golvlister" ; -- golvlist..nn.1
  golvläggare_1_N = mkN "golvläggare" utrum  ; -- golvläggare..nn.1
  golvläggning_1_N = mkN "golvläggning" ; -- golvläggning..nn.1
  golvmatta_1_N = mkN "golvmatta" ; -- golvmatta..nn.1
  golvmopp_1_N = mkN "golvmopp" ; -- golvmopp..nn.1
  golvramp_1_N = mkN "golvramp" "golvramper" ; -- golvramp..nn.1
  golvregel_1_N = mkN "golvregel" ; -- golvregel..nn.1
  golvsil_1_N = mkN "golvsil" ; -- golvsil..nn.1
  golvskyddspapper_1_N = mkN "golvskyddspapper" neutrum  ; -- golvskyddspapper..nn.1
  golvspackel_1_N = mkN "golvspackel" neutrum  ; -- golvspackel..nn.1
  golvspringa_1_N = mkN "golvspringa" ; -- golvspringa..nn.1
  golvtilja_1_N = mkN "golvtilja" ; -- golvtilja..nn.1
  golvtrasa_1_N = mkN "golvtrasa" ; -- golvtrasa..nn.1
  golvur_1_N = mkN "golvur" neutrum  ; -- golvur..nn.1
  golvvax_1_N = mkN "golvvax" "golvvaxet" "golvvaxer" "golvvaxerna" ; -- golvvax..nn.1
  golvvärme_1_N = mkN "golvvärme" utrum  ; -- golvvärme..nn.1
  golvväxel_1_N = mkN "golvväxel" ; -- golvväxel..nn.1
  golvvårdare_1_N = mkN "golvvårdare" utrum  ; -- golvvårdare..nn.1
  golvyta_1_N = mkN "golvyta" ; -- golvyta..nn.1
  gom_1_N = mkN "gom" "gommen" "gommar" "gommarna" ; -- gom..nn.1
  gomben_1_N = mkN "gomben" neutrum  ; -- gomben..nn.1
  gombåge_1_N = mkN "gombåge" utrum  ; -- gombåge..nn.1
  gomklyvning_1_N = mkN "gomklyvning" ; -- gomklyvning..nn.1
  gomljud_1_N = mkN "gomljud" neutrum  ; -- gomljud..nn.1
  gomsegel_1_N = mkN "gomsegel" neutrum  ; -- gomsegel..nn.1
  gomspalt_1_N = mkN "gomspalt" ; -- gomspalt..nn.1
  gomspene_1_N = mkN "gomspene" utrum  ; -- gomspene..nn.1
  gon_1_N = mkN "gon" "goner" ; -- gon..nn.1
  gonad_1_N = mkN "gonad" "gonader" ; -- gonad..nn.1
  gondol_1_N = mkN "gondol" "gondoler" ; -- gondol..nn.1
  gondolfärd_1_N = mkN "gondolfärd" "gondolfärder" ; -- gondolfärd..nn.1
  gondolförare_1_N = mkN "gondolförare" utrum  ; -- gondolförare..nn.1
  gondoljär_1_N = mkN "gondoljär" "gondoljärer" ; -- gondoljär..nn.1
  gonfaloniär_1_N = mkN "gonfaloniär" "gonfaloniärer" ; -- gonfaloniär..nn.1
  gonggong_1_N = mkN "gonggong" ; -- gonggong..nn.1
  gonggongslag_1_N = mkN "gonggongslag" neutrum  ; -- gonggongslag..nn.1
  goniometer_1_N = mkN "goniometer" ; -- goniometer..nn.1
  gonokock_1_N = mkN "gonokock" "gonokocker" ; -- gonokock..nn.1
  gonorré_1_N = mkN "gonorré" "gonorréer" ; -- gonorré..nn.1
  goodwill_1_N = mkN "goodwill" ; -- goodwill..nn.1
  googla_1_V = mkV "googlar" ; -- googla..vb.1
  googlande_1_N = mkN "googlande" ; -- googlande..nn.1
  googlebar_1_A = mkA "googlebar" ; -- googlebar..av.1
  googling_1_N = mkN "googling" ; -- googling..nn.1
  googlingsbar_1_A = mkA "googlingsbar" ; -- googlingsbar..av.1
  googlingsbarhet_1_N = mkN "googlingsbarhet" ; -- googlingsbarhet..nn.1
  gordonsetter_1_N = mkN "gordonsetter" ; -- gordonsetter..nn.1
  gorgon_1_N = mkN "gorgon" "gorgoner" ; -- gorgon..nn.1
  gorgonzola_1_N = mkN "gorgonzola" ; -- gorgonzola..nn.1
  gorilla_1_N = mkN "gorilla" ; -- gorilla..nn.1
  gorillaunge_1_N = mkN "gorillaunge" utrum  ; -- gorillaunge..nn.1
  gorma_1_V = mkV "gormar" ; -- gorma..vb.1
  gormande_1_N = mkN "gormande" ; -- gormande..nn.1
  gorr_1_N = mkN "gorr" neutrum  ; -- gorr..nn.1
  gorå_1_N = mkN "gorå" "goråt" "gorån" "goråna" ; -- gorå..nn.1
  gorån_1_N = mkN "gorån" neutrum  ; -- gorån..nn.1
  gosa_1_V = mkV "gosar" ; -- gosa..vb.1
  gosande_1_N = mkN "gosande" ; -- gosande..nn.1
  gosedjur_1_N = mkN "gosedjur" neutrum  ; -- gosedjur..nn.1
  gosig_1_A = mkA "gosig" ; -- gosig..av.1
  gosing_1_N = mkN "gosing" ; -- gosing..nn.1
  gospel_1_N = mkN "gospel" "gospeln" "gospels" "gospelsen" ; -- gospel..nn.1
  gossamer_1_N = mkN "gossamer" ; -- gossamer..nn.1
  gosse_1_N = mkN "gosse" utrum  ; -- gosse..nn.1
  gossebarn_1_N = mkN "gossebarn" neutrum  ; -- gossebarn..nn.1
  gossekonung_1_N = mkN "gossekonung" ; -- gossekonung..nn.1
  gosskör_1_N = mkN "gosskör" "gosskörer" ; -- gosskör..nn.1
  got_1_N = mkN "got" "goter" ; -- got..nn.1
  goticerande_1_A = mkA "goticerande" ; -- goticerande..av.1
  gotik_1_N = mkN "gotik" ; -- gotik..nn.1
  gotiserande_1_A = mkA "gotiserande" ; -- gotiserande..av.1
  gotisk_1_A = mkA "gotisk" ; -- gotisk..av.1
  gotiska_1_N = mkN "gotiska" ; -- gotiska..nn.1
  gotlandsruss_1_N = mkN "gotlandsruss" neutrum  ; -- gotlandsruss..nn.1
  gotländsk_1_A = mkA "gotländsk" ; -- gotländsk..av.1
  gotländska_1_N = mkN "gotländska" ; -- gotländska..nn.1
  gotländska_2_N = mkN "gotländska" ; -- gotländska..nn.2
  gotländskhet_1_N = mkN "gotländskhet" ; -- gotländskhet..nn.1
  gotlänning_1_N = mkN "gotlänning" ; -- gotlänning..nn.1
  gotsk_1_A = mkA "gotsk" ; -- gotsk..av.1
  gotskhet_1_N = mkN "gotskhet" ; -- gotskhet..nn.1
  gott_1_A = mkA "gott" ; -- gott..av.1
  gott_1_N = mkN "gott" "gottet" "gotter" "gotterna" ; -- gott..nn.1
  gottegris_1_N = mkN "gottegris" ; -- gottegris..nn.1
  gottfinnande_1_N = mkN "gottfinnande" ; -- gottfinnande..nn.1
  gottgöra_1_V = mkV "gottgöra" "gottgjorde" "gottgjort" ; -- gottgöra..vb.1
  gottgörande_1_N = mkN "gottgörande" ; -- gottgörande..nn.1
  gottgörelse_1_N = mkN "gottgörelse" "gottgörelser" ; -- gottgörelse..nn.1
  gottis_1_N = mkN "gottis" neutrum  ; -- gottis..nn.1
  gottköpsförklaring_1_N = mkN "gottköpsförklaring" ; -- gottköpsförklaring..nn.1
  gottköpsvara_1_N = mkN "gottköpsvara" ; -- gottköpsvara..nn.1
  gottskriva_1_V = mkV "gottskriva" "gottskrev" "gottskrivit" ; -- gottskriva..vb.1
  gottskrivande_1_N = mkN "gottskrivande" ; -- gottskrivande..nn.1
  gouache_1_N = mkN "gouache" "gouacher" ; -- gouache..nn.1
  gouachemålning_1_N = mkN "gouachemålning" ; -- gouachemålning..nn.1
  gouachemålning_2_N = mkN "gouachemålning" ; -- gouachemålning..nn.2
  gourmand_1_N = mkN "gourmand" "gourmander" ; -- gourmand..nn.1
  gourmet_1_N = mkN "gourmet" "gourmeter" ; -- gourmet..nn.1
  gourmetsalt_1_N = mkN "gourmetsalt" "gourmetsaltet" "gourmetsalter" "gourmetsalterna" ; -- gourmetsalt..nn.1
  gourmé_1_N = mkN "gourmé" "gourméer" ; -- gourmé..nn.1
  goutera_1_V = mkV "gouterar" ; -- goutera..vb.1
  gouterande_1_N = mkN "gouterande" ; -- gouterande..nn.1
  gouterbar_1_A = mkA "gouterbar" ; -- gouterbar..av.1
  gouterbarhet_1_N = mkN "gouterbarhet" ; -- gouterbarhet..nn.1
  goutering_1_N = mkN "goutering" ; -- goutering..nn.1
  gps_a_1_V = mkV "gps-ar" ; -- gps-a..vb.1
  gpsa_1_V = mkV "gpsar" ; -- gpsa..vb.1
  gpsa_2_V = mkV "gps:ar" ; -- gpsa..vb.2
  graal_1_N = mkN "graal" ; -- graal..nn.1
  grabb_1_N = mkN "grabb" ; -- grabb..nn.1
  grabba_1_V = mkV "grabbar" ; -- grabba..vb.1
  grabbande_1_N = mkN "grabbande" ; -- grabbande..nn.1
  grabbatag_1_N = mkN "grabbatag" neutrum  ; -- grabbatag..nn.1
  grabbig_1_A = mkA "grabbig" ; -- grabbig..av.1
  grabbnäve_1_N = mkN "grabbnäve" utrum  ; -- grabbnäve..nn.1
  grabbtag_1_N = mkN "grabbtag" neutrum  ; -- grabbtag..nn.1
  grace_1_N = mkN "grace" "gracer" ; -- grace..nn.1
  gracil_1_A = mkA "gracil" ; -- gracil..av.1
  graciös_1_A = mkA "graciös" ; -- graciös..av.1
  grad_1_A = mkA "grad" ; -- grad..av.1
  grad_1_N = mkN "grad" "grader" ; -- grad..nn.1
  grada_1_V = mkV "gradar" ; -- grada..vb.1
  gradande_1_N = mkN "gradande" ; -- gradande..nn.1
  gradation_1_N = mkN "gradation" ; -- gradation..nn.1
  gradbeteckning_1_N = mkN "gradbeteckning" ; -- gradbeteckning..nn.1
  gradböjning_1_N = mkN "gradböjning" ; -- gradböjning..nn.1
  gradera_1_V = mkV "graderar" ; -- gradera..vb.1
  graderande_1_N = mkN "graderande" ; -- graderande..nn.1
  graderbar_1_A = mkA "graderbar" ; -- graderbar..av.1
  graderbarhet_1_N = mkN "graderbarhet" ; -- graderbarhet..nn.1
  gradering_1_N = mkN "gradering" ; -- gradering..nn.1
  graderverk_1_N = mkN "graderverk" neutrum  ; -- graderverk..nn.1
  gradhet_1_N = mkN "gradhet" ; -- gradhet..nn.1
  gradient_1_N = mkN "gradient" "gradienter" ; -- gradient..nn.1
  gradlist_1_N = mkN "gradlist" "gradlister" ; -- gradlist..nn.1
  gradmejsel_1_N = mkN "gradmejsel" ; -- gradmejsel..nn.1
  gradmätare_1_N = mkN "gradmätare" utrum  ; -- gradmätare..nn.1
  gradmätning_1_N = mkN "gradmätning" ; -- gradmätning..nn.1
  gradnät_1_N = mkN "gradnät" neutrum  ; -- gradnät..nn.1
  gradskala_1_N = mkN "gradskala" ; -- gradskala..nn.1
  gradskillnad_1_N = mkN "gradskillnad" "gradskillnader" ; -- gradskillnad..nn.1
  gradskiva_1_N = mkN "gradskiva" ; -- gradskiva..nn.1
  gradstreck_1_N = mkN "gradstreck" neutrum  ; -- gradstreck..nn.1
  gradsåg_1_N = mkN "gradsåg" ; -- gradsåg..nn.1
  gradtal_1_N = mkN "gradtal" neutrum  ; -- gradtal..nn.1
  gradtapp_1_N = mkN "gradtapp" ; -- gradtapp..nn.1
  gradtecken_1_N = mkN "gradtecken" "gradtecknet" "gradtecken" "gradtecknen" ; -- gradtecken..nn.1
  gradualavhandling_1_N = mkN "gradualavhandling" ; -- gradualavhandling..nn.1
  gradualpsalm_1_N = mkN "gradualpsalm" "gradualpsalmer" ; -- gradualpsalm..nn.1
  graduell_1_A = mkA "graduell" ; -- graduell..av.1
  graduera_1_V = mkV "graduerar" ; -- graduera..vb.1
  graduerande_1_N = mkN "graduerande" ; -- graduerande..nn.1
  graduerbar_1_A = mkA "graduerbar" ; -- graduerbar..av.1
  graduerbarhet_1_N = mkN "graduerbarhet" ; -- graduerbarhet..nn.1
  graduering_1_N = mkN "graduering" ; -- graduering..nn.1
  gradvis_1_Adv = mkAdv "gradvis" ; -- gradvis..ab.1
  gradvis_1_A = mkA "gradvis" ; -- gradvis..av.1
  gradäng_1_N = mkN "gradäng" "gradänger" ; -- gradäng..nn.1
  graf_1_N = mkN "graf" "grafer" ; -- graf..nn.1
  grafem_1_N = mkN "grafem" neutrum  ; -- grafem..nn.1
  grafematisk_1_A = mkA "grafematisk" ; -- grafematisk..av.1
  grafen_1_N = mkN "grafen" "grafener" ; -- grafen..nn.1
  grafik_1_N = mkN "grafik" ; -- grafik..nn.1
  grafiker_1_N = mkN "grafiker" "grafikern" "grafiker" "grafikerna" ; -- grafiker..nn.1
  grafisk_1_A = mkA "grafisk" ; -- grafisk..av.1
  grafit_1_N = mkN "grafit" "grafiter" ; -- grafit..nn.1
  grafitdegel_1_N = mkN "grafitdegel" ; -- grafitdegel..nn.1
  grafitera_1_V = mkV "grafiterar" ; -- grafitera..vb.1
  grafiterande_1_N = mkN "grafiterande" ; -- grafiterande..nn.1
  grafiterbar_1_A = mkA "grafiterbar" ; -- grafiterbar..av.1
  grafiterbarhet_1_N = mkN "grafiterbarhet" ; -- grafiterbarhet..nn.1
  grafitering_1_N = mkN "grafitering" ; -- grafitering..nn.1
  grafitgrå_1_A = mkA "grafitgrå" "grafitgrått" ; -- grafitgrå..av.1
  grafolog_1_N = mkN "grafolog" "grafologer" ; -- grafolog..nn.1
  grafologi_1_N = mkN "grafologi" ; -- grafologi..nn.1
  grafonomi_1_N = mkN "grafonomi" ; -- grafonomi..nn.1
  grafonomisk_1_A = mkA "grafonomisk" ; -- grafonomisk..av.1
  grafteori_1_N = mkN "grafteori" "grafteorier" ; -- grafteori..nn.1
  grahamsbröd_1_N = mkN "grahamsbröd" neutrum  ; -- grahamsbröd..nn.1
  grahamsmjöl_1_N = mkN "grahamsmjöl" neutrum  ; -- grahamsmjöl..nn.1
  grain_1_N = mkN "grain" ; -- grain..nn.1
  gral_1_N = mkN "gral" ; -- gral..nn.1
  gralsökare_1_N = mkN "gralsökare" utrum  ; -- gralsökare..nn.1
  gram_1_N = mkN "gram" "grammet" "gram" "grammen" ; -- gram..nn.1
  gramkalori_1_N = mkN "gramkalori" "gramkalorier" ; -- gramkalori..nn.1
  grammatik_1_N = mkN "grammatik" "grammatiker" ; -- grammatik..nn.1
  grammatika_1_N = mkN "grammatika" ; -- grammatika..nn.1
  grammatikalisk_1_A = mkA "grammatikalisk" ; -- grammatikalisk..av.1
  grammatikbok_1_N = mkN "grammatikbok" "grammatikböcker" ; -- grammatikbok..nn.1
  grammatiker_1_N = mkN "grammatiker" "grammatikern" "grammatiker" "grammatikerna" ; -- grammatiker..nn.1
  grammatikregel_1_N = mkN "grammatikregel" "grammatikregeln" "grammatikregler" "grammatikreglerna" ; -- grammatikregel..nn.1
  grammatisk_1_A = mkA "grammatisk" ; -- grammatisk..av.1
  grammofon_1_N = mkN "grammofon" "grammofoner" ; -- grammofon..nn.1
  grammofonarkiv_1_N = mkN "grammofonarkiv" neutrum  ; -- grammofonarkiv..nn.1
  grammofonskiva_1_N = mkN "grammofonskiva" ; -- grammofonskiva..nn.1
  grammofonstift_1_N = mkN "grammofonstift" neutrum  ; -- grammofonstift..nn.1
  grammolekyl_1_N = mkN "grammolekyl" "grammolekyler" ; -- grammolekyl..nn.1
  gramse_1_A = mkA "gramse" ; -- gramse..av.1
  gran_1_N = mkN "gran" ; -- gran..nn.1
  gran_2_N = mkN "gran" neutrum  ; -- gran..nn.2
  granat_1_N = mkN "granat" "granater" ; -- granat..nn.1
  granatattack_1_N = mkN "granatattack" "granatattacker" ; -- granatattack..nn.1
  granatbeskjuta_1_V = mkV "granatbeskjuta" "granatbesköt" "granatbeskjutit" ; -- granatbeskjuta..vb.1
  granatbeskjutande_1_N = mkN "granatbeskjutande" ; -- granatbeskjutande..nn.1
  granatbeskjutning_1_N = mkN "granatbeskjutning" ; -- granatbeskjutning..nn.1
  granatchock_1_N = mkN "granatchock" "granatchocker" ; -- granatchock..nn.1
  granateld_1_N = mkN "granateld" ; -- granateld..nn.1
  granatgevär_1_N = mkN "granatgevär" neutrum  ; -- granatgevär..nn.1
  granatkartesch_1_N = mkN "granatkartesch" "granatkartescher" ; -- granatkartesch..nn.1
  granatkastare_1_N = mkN "granatkastare" utrum  ; -- granatkastare..nn.1
  granatskärva_1_N = mkN "granatskärva" ; -- granatskärva..nn.1
  granatsplitter_1_N = mkN "granatsplitter" neutrum  ; -- granatsplitter..nn.1
  granatspruta_1_N = mkN "granatspruta" ; -- granatspruta..nn.1
  granatträff_1_N = mkN "granatträff" ; -- granatträff..nn.1
  granatäppelkärna_1_N = mkN "granatäppelkärna" ; -- granatäppelkärna..nn.1
  granatäpple_1_N = mkN "granatäpple" ; -- granatäpple..nn.1
  granatäpplejuice_1_N = mkN "granatäpplejuice" "granatäpplejuicer" ; -- granatäpplejuice..nn.1
  granbark_1_N = mkN "granbark" ; -- granbark..nn.1
  granbarr_1_N = mkN "granbarr" neutrum  ; -- granbarr..nn.1
  granbarrlus_1_N = mkN "granbarrlus" "granbarrlusen" "granbarrlöss" "granbarrlössen" ; -- granbarrlus..nn.1
  grand_guignol_1_N = mkN "grand-guignol" ; -- grand-guignol..nn.1
  grand_1_N = mkN "grand" neutrum  ; -- grand..nn.1
  grand_2_N = mkN "grand" "grander" ; -- grand..nn.2
  grandezza_1_N = mkN "grandezza" ; -- grandezza..nn.1
  grandios_1_A = mkA "grandios" ; -- grandios..av.1
  grandioshet_1_N = mkN "grandioshet" ; -- grandioshet..nn.1
  grandseigneur_1_N = mkN "grandseigneur" "grandseigneurer" ; -- grandseigneur..nn.1
  grandunge_1_N = mkN "grandunge" utrum  ; -- grandunge..nn.1
  grangirlang_1_N = mkN "grangirlang" "grangirlanger" ; -- grangirlang..nn.1
  grangren_1_N = mkN "grangren" "grangrenen" "grangrenar" "grangrenarna" ; -- grangren..nn.1
  granhäck_1_N = mkN "granhäck" ; -- granhäck..nn.1
  granimitation_1_N = mkN "granimitation" ; -- granimitation..nn.1
  granit_1_N = mkN "granit" "graniter" ; -- granit..nn.1
  granitkeramik_1_N = mkN "granitkeramik" ; -- granitkeramik..nn.1
  granitkeramikskärare_1_N = mkN "granitkeramikskärare" utrum  ; -- granitkeramikskärare..nn.1
  grann_1_A = mkA "grann" "grant" ; -- grann..av.1
  grann_1_N = mkN "grann" neutrum  ; -- grann..nn.1
  grannbygd_1_N = mkN "grannbygd" "grannbygder" ; -- grannbygd..nn.1
  granne_1_N = mkN "granne" utrum  ; -- granne..nn.1
  grannelag_1_N = mkN "grannelag" neutrum  ; -- grannelag..nn.1
  granneligen_1_Adv = mkAdv "granneligen" ; -- granneligen..ab.1
  grannfastighet_1_N = mkN "grannfastighet" "grannfastigheter" ; -- grannfastighet..nn.1
  grannfejd_1_N = mkN "grannfejd" "grannfejder" ; -- grannfejd..nn.1
  grannhet_1_N = mkN "grannhet" ; -- grannhet..nn.1
  grannhus_1_N = mkN "grannhus" neutrum  ; -- grannhus..nn.1
  grannkung_1_N = mkN "grannkung" ; -- grannkung..nn.1
  grannlaga_1_A = mkA "grannlaga" ; -- grannlaga..av.1
  grannlagenhet_1_N = mkN "grannlagenhet" "grannlagenheter" ; -- grannlagenhet..nn.1
  grannland_1_N = mkN "grannland" "grannlandet" "grannländer" "grannländerna" ; -- grannland..nn.1
  grannlåt_1_N = mkN "grannlåt" "grannlåter" ; -- grannlåt..nn.1
  grannosämja_1_N = mkN "grannosämja" ; -- grannosämja..nn.1
  grannpojke_1_N = mkN "grannpojke" utrum  ; -- grannpojke..nn.1
  grannrike_1_N = mkN "grannrike" ; -- grannrike..nn.1
  grannräcke_1_N = mkN "grannräcke" ; -- grannräcke..nn.1
  grannskap_1_N = mkN "grannskap" neutrum  ; -- grannskap..nn.1
  grannsocken_1_N = mkN "grannsocken" ; -- grannsocken..nn.1
  grannstat_1_N = mkN "grannstat" "grannstater" ; -- grannstat..nn.1
  grannstjärna_1_N = mkN "grannstjärna" ; -- grannstjärna..nn.1
  grannstuga_1_N = mkN "grannstuga" ; -- grannstuga..nn.1
  grannsynt_1_A = mkA "grannsynt" "grannsynt" ; -- grannsynt..av.1
  grannsynthet_1_N = mkN "grannsynthet" ; -- grannsynthet..nn.1
  grannsämja_1_N = mkN "grannsämja" ; -- grannsämja..nn.1
  granntvist_1_N = mkN "granntvist" "granntvister" ; -- granntvist..nn.1
  granntyckt_1_A = mkA "granntyckt" "granntyckt" ; -- granntyckt..av.1
  granntyckthet_1_N = mkN "granntyckthet" ; -- granntyckthet..nn.1
  granplanta_1_N = mkN "granplanta" ; -- granplanta..nn.1
  granpollen_1_N = mkN "granpollen" neutrum  ; -- granpollen..nn.1
  granris_1_N = mkN "granris" neutrum  ; -- granris..nn.1
  granska_1_V = mkV "granskar" ; -- granska..vb.1
  granskande_1_N = mkN "granskande" ; -- granskande..nn.1
  granskare_1_N = mkN "granskare" utrum  ; -- granskare..nn.1
  granskning_1_N = mkN "granskning" ; -- granskning..nn.1
  granskningsexemplar_1_N = mkN "granskningsexemplar" neutrum  ; -- granskningsexemplar..nn.1
  granskningskommission_1_N = mkN "granskningskommission" ; -- granskningskommission..nn.1
  granskningsman_1_N = mkN "granskningsman" "granskningsmannen" "granskningsmän" "granskningsmännen" ; -- granskningsman..nn.1
  granskningsnämnd_1_N = mkN "granskningsnämnd" "granskningsnämnder" ; -- granskningsnämnd..nn.1
  granskog_1_N = mkN "granskog" ; -- granskog..nn.1
  gransort_1_N = mkN "gransort" "gransorter" ; -- gransort..nn.1
  granspira_1_N = mkN "granspira" ; -- granspira..nn.1
  granstam_1_N = mkN "granstam" "granstammen" "granstammar" "granstammarna" ; -- granstam..nn.1
  gransångare_1_N = mkN "gransångare" utrum  ; -- gransångare..nn.1
  granulat_1_N = mkN "granulat" neutrum  ; -- granulat..nn.1
  granulation_1_N = mkN "granulation" ; -- granulation..nn.1
  granulationsvävnad_1_N = mkN "granulationsvävnad" "granulationsvävnader" ; -- granulationsvävnad..nn.1
  granulera_1_V = mkV "granulerar" ; -- granulera..vb.1
  granulerande_1_N = mkN "granulerande" ; -- granulerande..nn.1
  granulerbar_1_A = mkA "granulerbar" ; -- granulerbar..av.1
  granulerbarhet_1_N = mkN "granulerbarhet" ; -- granulerbarhet..nn.1
  granulering_1_N = mkN "granulering" ; -- granulering..nn.1
  granulom_1_N = mkN "granulom" neutrum  ; -- granulom..nn.1
  granulum_1_N = mkN "granulum" "granulumet" "granula" "granulana" ; -- granulum..nn.1
  granved_1_N = mkN "granved" ; -- granved..nn.1
  grapefrukt_1_N = mkN "grapefrukt" "grapefrukter" ; -- grapefrukt..nn.1
  grapefruktjuice_1_N = mkN "grapefruktjuice" "grapefruktjuicer" ; -- grapefruktjuice..nn.1
  grassera_1_V = mkV "grasserar" ; -- grassera..vb.1
  grasserande_1_N = mkN "grasserande" ; -- grasserande..nn.1
  grassering_1_N = mkN "grassering" ; -- grassering..nn.1
  gratial_1_N = mkN "gratial" "gratialer" ; -- gratial..nn.1
  gratialist_1_N = mkN "gratialist" "gratialister" ; -- gratialist..nn.1
  gratie_1_N = mkN "gratie" "gratier" ; -- gratie..nn.1
  gratifikation_1_N = mkN "gratifikation" ; -- gratifikation..nn.1
  gratin_1_N = mkN "gratin" "gratiner" ; -- gratin..nn.1
  gratinera_1_V = mkV "gratinerar" ; -- gratinera..vb.1
  gratinerande_1_N = mkN "gratinerande" ; -- gratinerande..nn.1
  gratinerbar_1_A = mkA "gratinerbar" ; -- gratinerbar..av.1
  gratinerbarhet_1_N = mkN "gratinerbarhet" ; -- gratinerbarhet..nn.1
  gratinering_1_N = mkN "gratinering" ; -- gratinering..nn.1
  gratis_1_A = mkA "gratis" ; -- gratis..av.1
  gratisaktie_1_N = mkN "gratisaktie" "gratisaktier" ; -- gratisaktie..nn.1
  gratisnöje_1_N = mkN "gratisnöje" ; -- gratisnöje..nn.1
  gratispassagerare_1_N = mkN "gratispassagerare" utrum  ; -- gratispassagerare..nn.1
  gratisplats_1_N = mkN "gratisplats" "gratisplatser" ; -- gratisplats..nn.1
  gratisprogram_1_N = mkN "gratisprogram" "gratisprogrammet" "gratisprogram" "gratisprogrammen" ; -- gratisprogram..nn.1
  gratisskjut_1_N = mkN "gratisskjut" neutrum  ; -- gratisskjut..nn.1
  gratisskjuts_1_N = mkN "gratisskjuts" ; -- gratisskjuts..nn.1
  gratisspel_1_N = mkN "gratisspel" "gratisspelet" "gratisspel" "gratisspelen" ; -- gratisspel..nn.1
  gratistidning_1_N = mkN "gratistidning" ; -- gratistidning..nn.1
  gratta_1_V = mkV "grattar" ; -- gratta..vb.1
  grattande_1_N = mkN "grattande" ; -- grattande..nn.1
  gratulant_1_N = mkN "gratulant" "gratulanter" ; -- gratulant..nn.1
  gratulation_1_N = mkN "gratulation" ; -- gratulation..nn.1
  gratulationsbrev_1_N = mkN "gratulationsbrev" neutrum  ; -- gratulationsbrev..nn.1
  gratulationskort_1_N = mkN "gratulationskort" neutrum  ; -- gratulationskort..nn.1
  gratulera_1_V = mkV "gratulerar" ; -- gratulera..vb.1
  gratulerande_1_N = mkN "gratulerande" ; -- gratulerande..nn.1
  gratulerbar_1_A = mkA "gratulerbar" ; -- gratulerbar..av.1
  gratulerbarhet_1_N = mkN "gratulerbarhet" ; -- gratulerbarhet..nn.1
  gratulering_1_N = mkN "gratulering" ; -- gratulering..nn.1
  gratäng_1_N = mkN "gratäng" "gratänger" ; -- gratäng..nn.1
  grav_1_A = mkA "grav" ; -- grav..av.1
  grav_1_N = mkN "grav" ; -- grav..nn.1
  grava_1_V = mkV "gravar" ; -- grava..vb.1
  gravallvar_1_N = mkN "gravallvar" neutrum  ; -- gravallvar..nn.1
  gravallvarlig_1_A = mkA "gravallvarlig" ; -- gravallvarlig..av.1
  gravallvarlighet_1_N = mkN "gravallvarlighet" ; -- gravallvarlighet..nn.1
  gravamen_1_N = mkN "gravamen" "gravamina" ; -- gravamen..nn.1
  gravand_1_N = mkN "gravand" "gravänder" ; -- gravand..nn.1
  gravande_1_N = mkN "gravande" ; -- gravande..nn.1
  gravation_1_N = mkN "gravation" ; -- gravation..nn.1
  gravationsbevis_1_N = mkN "gravationsbevis" neutrum  ; -- gravationsbevis..nn.1
  gravbrev_1_N = mkN "gravbrev" neutrum  ; -- gravbrev..nn.1
  gravbyggnad_1_N = mkN "gravbyggnad" "gravbyggnader" ; -- gravbyggnad..nn.1
  gravdikt_1_N = mkN "gravdikt" "gravdikter" ; -- gravdikt..nn.1
  gravenstein_1_N = mkN "gravenstein" "gravensteiner" ; -- gravenstein..nn.1
  gravensteiner_1_N = mkN "gravensteiner" "gravensteinern" "gravensteiner" "gravensteinerna" ; -- gravensteiner..nn.1
  gravera_1_V = mkV "graverar" ; -- gravera..vb.1
  graverande_1_A = mkA "graverande" ; -- graverande..av.1
  graverande_1_N = mkN "graverande" ; -- graverande..nn.1
  graverbar_1_A = mkA "graverbar" ; -- graverbar..av.1
  graverbarhet_1_N = mkN "graverbarhet" ; -- graverbarhet..nn.1
  gravering_1_N = mkN "gravering" ; -- gravering..nn.1
  graverstål_1_N = mkN "graverstål" neutrum  ; -- graverstål..nn.1
  gravfynd_1_N = mkN "gravfynd" neutrum  ; -- gravfynd..nn.1
  gravfält_1_N = mkN "gravfält" neutrum  ; -- gravfält..nn.1
  gravgods_1_N = mkN "gravgods" neutrum  ; -- gravgods..nn.1
  gravgås_1_N = mkN "gravgås" "gravgåsen" "gravgäss" "gravgässen" ; -- gravgås..nn.1
  gravgåva_1_N = mkN "gravgåva" ; -- gravgåva..nn.1
  gravhet_1_N = mkN "gravhet" ; -- gravhet..nn.1
  gravhäll_1_N = mkN "gravhäll" ; -- gravhäll..nn.1
  gravhög_1_N = mkN "gravhög" ; -- gravhög..nn.1
  gravid_1_A = mkA "gravid" ; -- gravid..av.1
  graviditet_1_N = mkN "graviditet" "graviditeter" ; -- graviditet..nn.1
  graviditetsdagbok_1_N = mkN "graviditetsdagbok" "graviditetsdagböcker" ; -- graviditetsdagbok..nn.1
  graviditetskilo_1_N = mkN "graviditetskilo" "graviditetskilot" "graviditetskilon" "graviditetskilona" ; -- graviditetskilo..nn.1
  graviditetstest_1_N = mkN "graviditetstest" neutrum  ; -- graviditetstest..nn.1
  graviditetsvecka_1_N = mkN "graviditetsvecka" ; -- graviditetsvecka..nn.1
  gravidmage_1_N = mkN "gravidmage" utrum  ; -- gravidmage..nn.1
  gravimeter_1_N = mkN "gravimeter" ; -- gravimeter..nn.1
  gravis_1_N = mkN "gravis" ; -- gravis..nn.1
  gravitation_1_N = mkN "gravitation" ; -- gravitation..nn.1
  gravitationell_1_A = mkA "gravitationell" ; -- gravitationell..av.1
  gravitationskollaps_1_N = mkN "gravitationskollaps" "gravitationskollapser" ; -- gravitationskollaps..nn.1
  gravitationskonstant_1_N = mkN "gravitationskonstant" "gravitationskonstanter" ; -- gravitationskonstant..nn.1
  gravitationskraft_1_N = mkN "gravitationskraft" "gravitationskrafter" ; -- gravitationskraft..nn.1
  gravitationslag_1_N = mkN "gravitationslag" ; -- gravitationslag..nn.1
  gravitationsstrålning_1_N = mkN "gravitationsstrålning" ; -- gravitationsstrålning..nn.1
  gravitationsvåg_1_N = mkN "gravitationsvåg" "gravitationsvågor" ; -- gravitationsvåg..nn.1
  gravitera_1_V = mkV "graviterar" ; -- gravitera..vb.1
  graviterande_1_N = mkN "graviterande" ; -- graviterande..nn.1
  gravitering_1_N = mkN "gravitering" ; -- gravitering..nn.1
  gravitet_1_N = mkN "gravitet" "graviteter" ; -- gravitet..nn.1
  gravitetisk_1_A = mkA "gravitetisk" ; -- gravitetisk..av.1
  graviton_1_N = mkN "graviton" "gravitoner" ; -- graviton..nn.1
  gravkammare_1_N = mkN "gravkammare" "gravkammaren" "gravkammare" "gravkamrarna" ; -- gravkammare..nn.1
  gravkapell_1_N = mkN "gravkapell" neutrum  ; -- gravkapell..nn.1
  gravkista_1_N = mkN "gravkista" ; -- gravkista..nn.1
  gravkor_1_N = mkN "gravkor" neutrum  ; -- gravkor..nn.1
  gravkummel_1_N = mkN "gravkummel" neutrum  ; -- gravkummel..nn.1
  gravkyrka_1_N = mkN "gravkyrka" ; -- gravkyrka..nn.1
  gravlax_1_N = mkN "gravlax" ; -- gravlax..nn.1
  gravlik_1_A = mkA "gravlik" ; -- gravlik..av.1
  gravlikhet_1_N = mkN "gravlikhet" ; -- gravlikhet..nn.1
  gravlägga_1_V = mkV "gravlägga" "gravla" "gravlagt" ; -- gravlägga..vb.1
  gravläggande_1_N = mkN "gravläggande" ; -- gravläggande..nn.1
  gravmaterial_1_N = mkN "gravmaterial" neutrum  ; -- gravmaterial..nn.1
  gravmonument_1_N = mkN "gravmonument" neutrum  ; -- gravmonument..nn.1
  gravor_1_N = mkN "gravor" ; -- gravor..nn.1
  gravplats_1_N = mkN "gravplats" "gravplatser" ; -- gravplats..nn.1
  gravplundrare_1_N = mkN "gravplundrare" utrum  ; -- gravplundrare..nn.1
  gravplundring_1_N = mkN "gravplundring" ; -- gravplundring..nn.1
  gravrelief_1_N = mkN "gravrelief" "gravreliefer" ; -- gravrelief..nn.1
  gravrost_1_N = mkN "gravrost" ; -- gravrost..nn.1
  gravrös_1_N = mkN "gravrös" neutrum  ; -- gravrös..nn.1
  gravröse_1_N = mkN "gravröse" ; -- gravröse..nn.1
  gravsed_1_N = mkN "gravsed" "gravseder" ; -- gravsed..nn.1
  gravskick_1_N = mkN "gravskick" neutrum  ; -- gravskick..nn.1
  gravskändning_1_N = mkN "gravskändning" ; -- gravskändning..nn.1
  gravsten_1_N = mkN "gravsten" "gravstenen" "gravstenar" "gravstenarna" ; -- gravsten..nn.1
  gravstickel_1_N = mkN "gravstickel" ; -- gravstickel..nn.1
  gravsvepning_1_N = mkN "gravsvepning" ; -- gravsvepning..nn.1
  gravsänka_1_N = mkN "gravsänka" ; -- gravsänka..nn.1
  gravsätta_1_V = mkV "gravsätta" "gravsätter" "gravsätt" "gravsatte" "gravsatt" "gravsatt" ; -- gravsätta..vb.1
  gravsättande_1_N = mkN "gravsättande" ; -- gravsättande..nn.1
  gravsättning_1_N = mkN "gravsättning" ; -- gravsättning..nn.1
  gravtal_1_N = mkN "gravtal" neutrum  ; -- gravtal..nn.1
  gravtest_1_N = mkN "gravtest" neutrum  ; -- gravtest..nn.1
  gravurna_1_N = mkN "gravurna" ; -- gravurna..nn.1
  gravvalv_1_N = mkN "gravvalv" neutrum  ; -- gravvalv..nn.1
  gravvård_1_N = mkN "gravvård" ; -- gravvård..nn.1
  gravyr_1_N = mkN "gravyr" "gravyrer" ; -- gravyr..nn.1
  gravyrkonst_1_N = mkN "gravyrkonst" ; -- gravyrkonst..nn.1
  gravyrmaskin_1_N = mkN "gravyrmaskin" "gravyrmaskiner" ; -- gravyrmaskin..nn.1
  gravöl_1_N = mkN "gravöl" neutrum  ; -- gravöl..nn.1
  gravöppning_1_N = mkN "gravöppning" ; -- gravöppning..nn.1
  gravör_1_N = mkN "gravör" "gravörer" ; -- gravör..nn.1
  gray_1_N = mkN "gray" "grayen" "gray" "grayen" ; -- gray..nn.1
  grecism_1_N = mkN "grecism" "grecismer" ; -- grecism..nn.1
  gredelin_1_A = mkA "gredelin" ; -- gredelin..av.1
  green_1_N = mkN "green" "greener" ; -- green..nn.1
  gregoriansk_1_A = mkA "gregoriansk" ; -- gregoriansk..av.1
  grej_1_N = mkN "grej" "grejor" ; -- grej..nn.1
  greja_1_N = mkN "greja" ; -- greja..nn.1
  greja_1_V = mkV "grejar" ; -- greja..vb.1
  greja_2_V = mkV "grejar" ; -- greja..vb.2
  grejande_1_N = mkN "grejande" ; -- grejande..nn.1
  grejs_1_N = mkN "grejs" neutrum  ; -- grejs..nn.1
  grejsimojs_1_N = mkN "grejsimojs" ; -- grejsimojs..nn.1
  grek_1_N = mkN "grek" "greker" ; -- grek..nn.1
  grekcypriot_1_N = mkN "grekcypriot" "grekcyprioter" ; -- grekcypriot..nn.1
  grekcypriotisk_1_A = mkA "grekcypriotisk" ; -- grekcypriotisk..av.1
  grekinna_1_N = mkN "grekinna" ; -- grekinna..nn.1
  grekisk_katolsk_1_A = mkA "grekisk-katolsk" ; -- grekisk-katolsk..av.1
  grekisk_ortodox_1_A = mkA "grekisk-ortodox" ; -- grekisk-ortodox..av.1
  grekisk_romersk_1_A = mkA "grekisk-romersk" ; -- grekisk-romersk..av.1
  grekisk_1_A = mkA "grekisk" ; -- grekisk..av.1
  grekiska_1_N = mkN "grekiska" ; -- grekiska..nn.1
  grekiska_2_N = mkN "grekiska" ; -- grekiska..nn.2
  grekisktalande_1_A = mkA "grekisktalande" ; -- grekisktalande..av.1
  gren_1_N = mkN "gren" "grenen" "grenar" "grenarna" ; -- gren..nn.1
  grenad_1_A = mkA "grenad" ; -- grenad..av.1
  grenadier_1_N = mkN "grenadier" "grenadiern" "grenadier" "grenadierna" ; -- grenadier..nn.1
  grenadin_1_N = mkN "grenadin" "grenadiner" ; -- grenadin..nn.1
  grenadisk_1_A = mkA "grenadisk" ; -- grenadisk..av.1
  grenadiska_1_N = mkN "grenadiska" ; -- grenadiska..nn.1
  grenadjär_1_N = mkN "grenadjär" "grenadjärer" ; -- grenadjär..nn.1
  grenadjärregemente_1_N = mkN "grenadjärregemente" ; -- grenadjärregemente..nn.1
  grenbildning_1_N = mkN "grenbildning" ; -- grenbildning..nn.1
  grenhopp_1_N = mkN "grenhopp" neutrum  ; -- grenhopp..nn.1
  grenig_1_A = mkA "grenig" ; -- grenig..av.1
  grenighet_1_N = mkN "grenighet" ; -- grenighet..nn.1
  grenklyka_1_N = mkN "grenklyka" ; -- grenklyka..nn.1
  grenledning_1_N = mkN "grenledning" ; -- grenledning..nn.1
  grenljus_1_N = mkN "grenljus" neutrum  ; -- grenljus..nn.1
  grenrik_1_A = mkA "grenrik" ; -- grenrik..av.1
  grenskott_1_N = mkN "grenskott" neutrum  ; -- grenskott..nn.1
  grensla_1_V = mkV "grenslar" ; -- grensla..vb.1
  grenslande_1_N = mkN "grenslande" ; -- grenslande..nn.1
  grenspets_1_N = mkN "grenspets" ; -- grenspets..nn.1
  grenstående_1_A = mkA "grenstående" ; -- grenstående..av.1
  grenuttag_1_N = mkN "grenuttag" neutrum  ; -- grenuttag..nn.1
  grenveck_1_N = mkN "grenveck" neutrum  ; -- grenveck..nn.1
  grenverk_1_N = mkN "grenverk" neutrum  ; -- grenverk..nn.1
  grenvinkel_1_N = mkN "grenvinkel" ; -- grenvinkel..nn.1
  grepe_1_N = mkN "grepe" utrum  ; -- grepe..nn.1
  grepe_2_N = mkN "grep" ; -- grepe..nn.2
  grepp_1_N = mkN "grepp" neutrum  ; -- grepp..nn.1
  greppa_1_V = mkV "greppar" ; -- greppa..vb.1
  greppande_1_N = mkN "greppande" ; -- greppande..nn.1
  greppbar_1_A = mkA "greppbar" ; -- greppbar..av.1
  greppbar_2_A = mkA "greppbar" ; -- greppbar..av.2
  greppbarhet_1_N = mkN "greppbarhet" ; -- greppbarhet..nn.1
  greppbarhet_2_N = mkN "greppbarhet" "greppbarheter" ; -- greppbarhet..nn.2
  greppbräde_1_N = mkN "greppbräde" ; -- greppbräde..nn.1
  greppmatta_1_N = mkN "greppmatta" ; -- greppmatta..nn.1
  greppriktig_1_A = mkA "greppriktig" ; -- greppriktig..av.1
  greppriktighet_1_N = mkN "greppriktighet" ; -- greppriktighet..nn.1
  greppvänlig_1_A = mkA "greppvänlig" ; -- greppvänlig..av.1
  greppvänlighet_1_N = mkN "greppvänlighet" ; -- greppvänlighet..nn.1
  greppyta_1_N = mkN "greppyta" ; -- greppyta..nn.1
  greve_1_N = mkN "greve" utrum  ; -- greve..nn.1
  grevekrona_1_N = mkN "grevekrona" ; -- grevekrona..nn.1
  grevetitel_1_N = mkN "grevetitel" ; -- grevetitel..nn.1
  grevinna_1_N = mkN "grevinna" ; -- grevinna..nn.1
  grevlig_1_A = mkA "grevlig" ; -- grevlig..av.1
  grevlighet_1_N = mkN "grevlighet" ; -- grevlighet..nn.1
  grevskap_1_N = mkN "grevskap" neutrum  ; -- grevskap..nn.1
  grevysebra_1_N = mkN "grevysebra" ; -- grevysebra..nn.1
  grevyzebra_1_N = mkN "grevyzebra" ; -- grevyzebra..nn.1
  greyhound_1_N = mkN "greyhound" "greyhounden" "greyhounds" "greyhoundsarna" ; -- greyhound..nn.1
  griffel_1_N = mkN "griffel" ; -- griffel..nn.1
  griffeltavla_1_N = mkN "griffeltavla" ; -- griffeltavla..nn.1
  grift_1_N = mkN "grift" "grifter" ; -- grift..nn.1
  griftefrid_1_N = mkN "griftefrid" ; -- griftefrid..nn.1
  griftetal_1_N = mkN "griftetal" neutrum  ; -- griftetal..nn.1
  griljera_1_V = mkV "griljerar" ; -- griljera..vb.1
  griljerande_1_N = mkN "griljerande" ; -- griljerande..nn.1
  griljerbar_1_A = mkA "griljerbar" ; -- griljerbar..av.1
  griljerbarhet_1_N = mkN "griljerbarhet" ; -- griljerbarhet..nn.1
  griljering_1_N = mkN "griljering" ; -- griljering..nn.1
  grill_1_N = mkN "grill" ; -- grill..nn.1
  grilla_1_V = mkV "grillar" ; -- grilla..vb.1
  grillande_1_N = mkN "grillande" ; -- grillande..nn.1
  grillbar_1_N = mkN "grillbar" "grillbarer" ; -- grillbar..nn.1
  grillfängeri_1_N = mkN "grillfängeri" "grillfängeriet" "grillfängerier" "grillfängerierna" ; -- grillfängeri..nn.1
  grilljanne_1_N = mkN "grilljanne" utrum  ; -- grilljanne..nn.1
  grillkol_1_N = mkN "grillkol" neutrum  ; -- grillkol..nn.1
  grillning_1_N = mkN "grillning" ; -- grillning..nn.1
  grillning_2_N = mkN "grillning" ; -- grillning..nn.2
  grillspett_1_N = mkN "grillspett" neutrum  ; -- grillspett..nn.1
  grimas_1_N = mkN "grimas" "grimaser" ; -- grimas..nn.1
  grimasera_1_V = mkV "grimaserar" ; -- grimasera..vb.1
  grimaserande_1_N = mkN "grimaserande" ; -- grimaserande..nn.1
  grimasering_1_N = mkN "grimasering" ; -- grimasering..nn.1
  grimera_1_V = mkV "grimerar" ; -- grimera..vb.1
  grimerande_1_N = mkN "grimerande" ; -- grimerande..nn.1
  grimerbar_1_A = mkA "grimerbar" ; -- grimerbar..av.1
  grimerbarhet_1_N = mkN "grimerbarhet" ; -- grimerbarhet..nn.1
  grimering_1_N = mkN "grimering" ; -- grimering..nn.1
  grimma_1_N = mkN "grimma" ; -- grimma..nn.1
  grimskaft_1_N = mkN "grimskaft" neutrum  ; -- grimskaft..nn.1
  grin_1_N = mkN "grin" neutrum  ; -- grin..nn.1
  grina_1_V = mkV "grinar" ; -- grina..vb.1
  grinande_1_N = mkN "grinande" ; -- grinande..nn.1
  grinare_1_N = mkN "grinare" utrum  ; -- grinare..nn.1
  grind_1_N = mkN "grind" ; -- grind..nn.1
  grindbeslag_1_N = mkN "grindbeslag" neutrum  ; -- grindbeslag..nn.1
  grindslant_1_N = mkN "grindslant" ; -- grindslant..nn.1
  grindstuga_1_N = mkN "grindstuga" ; -- grindstuga..nn.1
  grindval_1_N = mkN "grindval" ; -- grindval..nn.1
  grindöppning_1_N = mkN "grindöppning" ; -- grindöppning..nn.1
  gringo_1_N = mkN "gringo" "gringor" ; -- gringo..nn.1
  grinig_1_A = mkA "grinig" ; -- grinig..av.1
  grinighet_1_N = mkN "grinighet" "grinigheter" ; -- grinighet..nn.1
  grinolle_1_N = mkN "grinolle" utrum  ; -- grinolle..nn.1
  grip_1_N = mkN "grip" ; -- grip..nn.1
  gripa_1_V = mkV "gripa" "grep" "gripit" ; -- gripa..vb.1
  gripande_1_A = mkA "gripande" ; -- gripande..av.1
  gripande_1_N = mkN "gripande" ; -- gripande..nn.1
  gripbar_1_A = mkA "gripbar" ; -- gripbar..av.1
  gripbarhet_1_N = mkN "gripbarhet" ; -- gripbarhet..nn.1
  gripen_1_A = mkA "gripen" ; -- gripen..av.1
  gripenhet_1_N = mkN "gripenhet" ; -- gripenhet..nn.1
  gripfot_1_N = mkN "gripfot" "gripfötter" ; -- gripfot..nn.1
  gripreflex_1_N = mkN "gripreflex" ; -- gripreflex..nn.1
  gris_1_N = mkN "gris" ; -- gris..nn.1
  grisa_1_V = mkV "grisar" ; -- grisa..vb.1
  grisaille_1_N = mkN "grisaille" "grisailler" ; -- grisaille..nn.1
  grisande_1_N = mkN "grisande" ; -- grisande..nn.1
  grisbonde_1_N = mkN "grisbonde" "grisbönder" ; -- grisbonde..nn.1
  griseri_1_N = mkN "griseri" "griseriet" "griserier" "griserierna" ; -- griseri..nn.1
  grisett_1_N = mkN "grisett" "grisetter" ; -- grisett..nn.1
  grisfest_1_N = mkN "grisfest" "grisfester" ; -- grisfest..nn.1
  grisfösare_1_N = mkN "grisfösare" utrum  ; -- grisfösare..nn.1
  grishandlare_1_N = mkN "grishandlare" utrum  ; -- grishandlare..nn.1
  grisig_1_A = mkA "grisig" ; -- grisig..av.1
  grisinsulin_1_N = mkN "grisinsulin" "grisinsuliner" ; -- grisinsulin..nn.1
  griskastrering_1_N = mkN "griskastrering" ; -- griskastrering..nn.1
  griskulting_1_N = mkN "griskulting" ; -- griskulting..nn.1
  griskött_1_N = mkN "griskött" neutrum  ; -- griskött..nn.1
  grismat_1_N = mkN "grismat" ; -- grismat..nn.1
  grisning_1_N = mkN "grisning" ; -- grisning..nn.1
  grisningsbo_1_N = mkN "grisningsbo" "grisningsboet" "grisningsbon" "grisningsbona" ; -- grisningsbo..nn.1
  grisplågeri_1_N = mkN "grisplågeri" "grisplågeriet" "grisplågerier" "grisplågerierna" ; -- grisplågeri..nn.1
  grissel_1_N = mkN "grissel" ; -- grissel..nn.1
  grisskandal_1_N = mkN "grisskandal" "grisskandaler" ; -- grisskandal..nn.1
  grisskär_1_A = mkA "grisskär" ; -- grisskär..av.1
  grissla_1_N = mkN "grissla" ; -- grissla..nn.1
  grissvans_1_N = mkN "grissvans" ; -- grissvans..nn.1
  grisunge_1_N = mkN "grisunge" utrum  ; -- grisunge..nn.1
  grisuppfödning_1_N = mkN "grisuppfödning" ; -- grisuppfödning..nn.1
  grisöga_1_N = mkN "grisöga" "grisögat" "grisögon" "grisögonen" ; -- grisöga..nn.1
  grizzlybjörn_1_N = mkN "grizzlybjörn" ; -- grizzlybjörn..nn.1
  gro_1_V = mkV "gror" ; -- gro..vb.1
  grobar_1_A = mkA "grobar" ; -- grobar..av.1
  grobarhet_1_N = mkN "grobarhet" ; -- grobarhet..nn.1
  grobian_1_N = mkN "grobian" "grobianer" ; -- grobian..nn.1
  grobianfason_1_N = mkN "grobianfason" "grobianfasoner" ; -- grobianfason..nn.1
  groblad_1_N = mkN "groblad" neutrum  ; -- groblad..nn.1
  groda_1_N = mkN "groda" ; -- groda..nn.1
  grodd_1_N = mkN "grodd" ; -- grodd..nn.1
  grodda_1_V = mkV "groddar" ; -- grodda..vb.1
  groddande_1_N = mkN "groddande" ; -- groddande..nn.1
  groddblad_1_N = mkN "groddblad" neutrum  ; -- groddblad..nn.1
  groddjur_1_N = mkN "groddjur" neutrum  ; -- groddjur..nn.1
  groddknopp_1_N = mkN "groddknopp" ; -- groddknopp..nn.1
  groddplanta_1_N = mkN "groddplanta" ; -- groddplanta..nn.1
  grodfisk_1_N = mkN "grodfisk" ; -- grodfisk..nn.1
  grodlår_1_N = mkN "grodlår" neutrum  ; -- grodlår..nn.1
  grodman_1_N = mkN "grodman" "grodmannen" "grodmän" "grodmännen" ; -- grodman..nn.1
  grodnate_1_N = mkN "grodnate" utrum  ; -- grodnate..nn.1
  grodperspektiv_1_N = mkN "grodperspektiv" neutrum  ; -- grodperspektiv..nn.1
  grodspott_1_N = mkN "grodspott" neutrum  ; -- grodspott..nn.1
  grodyngel_1_N = mkN "grodyngel" neutrum  ; -- grodyngel..nn.1
  grodägg_1_N = mkN "grodägg" neutrum  ; -- grodägg..nn.1
  groende_1_N = mkN "groende" ; -- groende..nn.1
  grogg_1_N = mkN "grogg" ; -- grogg..nn.1
  grogga_1_V = mkV "groggar" ; -- grogga..vb.1
  groggande_1_N = mkN "groggande" ; -- groggande..nn.1
  groggvirke_1_N = mkN "groggvirke" ; -- groggvirke..nn.1
  groggy_1_A = mkA "groggy" ; -- groggy..av.1
  grogrund_1_N = mkN "grogrund" "grogrunder" ; -- grogrund..nn.1
  groll_1_N = mkN "groll" neutrum  ; -- groll..nn.1
  gromning_1_N = mkN "gromning" ; -- gromning..nn.1
  groning_1_N = mkN "groning" ; -- groning..nn.1
  groningstid_1_N = mkN "groningstid" "groningstider" ; -- groningstid..nn.1
  grooming_1_N = mkN "grooming" ; -- grooming..nn.1
  grop_1_N = mkN "grop" ; -- grop..nn.1
  gropemalj_1_N = mkN "gropemalj" ; -- gropemalj..nn.1
  gropig_1_A = mkA "gropig" ; -- gropig..av.1
  gropighet_1_N = mkN "gropighet" ; -- gropighet..nn.1
  groplöja_1_N = mkN "groplöja" ; -- groplöja..nn.1
  groschen_1_N = mkN "groschen" "groschenen" "groschen" "groschenen" ; -- groschen..nn.1
  gross_1_N = mkN "gross" neutrum  ; -- gross..nn.1
  grossess_1_N = mkN "grossess" "grossesser" ; -- grossess..nn.1
  grosshandel_1_N = mkN "grosshandel" ; -- grosshandel..nn.1
  grosshandelsfirma_1_N = mkN "grosshandelsfirma" ; -- grosshandelsfirma..nn.1
  grosshandlare_1_N = mkN "grosshandlare" utrum  ; -- grosshandlare..nn.1
  grossist_1_N = mkN "grossist" "grossister" ; -- grossist..nn.1
  grossistpris_1_N = mkN "grossistpris" neutrum  ; -- grossistpris..nn.1
  grossör_1_N = mkN "grossör" "grossörer" ; -- grossör..nn.1
  grotesk_1_A = mkA "grotesk" ; -- grotesk..av.1
  grotesk_1_N = mkN "grotesk" "grotesker" ; -- grotesk..nn.1
  groteskeri_1_N = mkN "groteskeri" "groteskeriet" "groteskerier" "groteskerierna" ; -- groteskeri..nn.1
  grotta_1_N = mkN "grotta" ; -- grotta..nn.1
  grottbjörn_1_N = mkN "grottbjörn" ; -- grottbjörn..nn.1
  grottekvarn_1_N = mkN "grottekvarn" ; -- grottekvarn..nn.1
  grottforskare_1_N = mkN "grottforskare" utrum  ; -- grottforskare..nn.1
  grottforskning_1_N = mkN "grottforskning" ; -- grottforskning..nn.1
  grottgång_1_N = mkN "grottgång" ; -- grottgång..nn.1
  grottingång_1_N = mkN "grottingång" ; -- grottingång..nn.1
  grottinnevånare_1_N = mkN "grottinnevånare" utrum  ; -- grottinnevånare..nn.1
  grottinvånare_1_N = mkN "grottinvånare" utrum  ; -- grottinvånare..nn.1
  grottmynning_1_N = mkN "grottmynning" ; -- grottmynning..nn.1
  grottmänniska_1_N = mkN "grottmänniska" ; -- grottmänniska..nn.1
  grottmålning_1_N = mkN "grottmålning" ; -- grottmålning..nn.1
  grottskreva_1_N = mkN "grottskreva" ; -- grottskreva..nn.1
  groupie_1_N = mkN "groupie" "groupien" "groupies" "groupiesarna" ; -- groupie..nn.1
  grov_1_A = mkA "grov" "grövre" "grövst" ; -- grov..av.1
  grovarbetare_1_N = mkN "grovarbetare" utrum  ; -- grovarbetare..nn.1
  grovarbete_1_N = mkN "grovarbete" ; -- grovarbete..nn.1
  grovbruk_1_N = mkN "grovbruk" neutrum  ; -- grovbruk..nn.1
  grovfoder_1_N = mkN "grovfoder" neutrum  ; -- grovfoder..nn.1
  grovhacka_1_V = mkV "grovhackar" ; -- grovhacka..vb.1
  grovhackande_1_N = mkN "grovhackande" ; -- grovhackande..nn.1
  grovhackning_1_N = mkN "grovhackning" ; -- grovhackning..nn.1
  grovhet_1_N = mkN "grovhet" "grovheter" ; -- grovhet..nn.1
  grovhugga_1_V = mkV "grovhugga" "grovhögg" "grovhuggit" ; -- grovhugga..vb.1
  grovhuggande_1_N = mkN "grovhuggande" ; -- grovhuggande..nn.1
  grovhuggen_1_A = mkA "grovhuggen" ; -- grovhuggen..av.1
  grovhuggenhet_1_N = mkN "grovhuggenhet" ; -- grovhuggenhet..nn.1
  grovhuggning_1_N = mkN "grovhuggning" ; -- grovhuggning..nn.1
  grovhyad_1_A = mkA "grovhyad" ; -- grovhyad..av.1
  grovhyvla_1_V = mkV "grovhyvlar" ; -- grovhyvla..vb.1
  grovhyvlad_1_A = mkA "grovhyvlad" ; -- grovhyvlad..av.1
  grovhyvlande_1_N = mkN "grovhyvlande" ; -- grovhyvlande..nn.1
  grovhyvling_1_N = mkN "grovhyvling" ; -- grovhyvling..nn.1
  grovhångla_1_V = mkV "grovhånglar" ; -- grovhångla..vb.1
  grovhånglande_1_N = mkN "grovhånglande" ; -- grovhånglande..nn.1
  grovhångling_1_N = mkN "grovhångling" ; -- grovhångling..nn.1
  grovkalibrig_1_A = mkA "grovkalibrig" ; -- grovkalibrig..av.1
  grovkalibrighet_1_N = mkN "grovkalibrighet" ; -- grovkalibrighet..nn.1
  grovkornig_1_A = mkA "grovkornig" ; -- grovkornig..av.1
  grovkornighet_1_N = mkN "grovkornighet" ; -- grovkornighet..nn.1
  grovkornighet_2_N = mkN "grovkornighet" "grovkornigheter" ; -- grovkornighet..nn.2
  grovkök_1_N = mkN "grovkök" neutrum  ; -- grovkök..nn.1
  grovlek_1_N = mkN "grovlek" ; -- grovlek..nn.1
  grovlemmad_1_A = mkA "grovlemmad" ; -- grovlemmad..av.1
  grovmala_1_V = mkV "grovmaler" ; -- grovmala..vb.1
  grovmalande_1_N = mkN "grovmalande" ; -- grovmalande..nn.1
  grovmalning_1_N = mkN "grovmalning" ; -- grovmalning..nn.1
  grovna_1_V = mkV "grovnar" ; -- grovna..vb.1
  grovnande_1_N = mkN "grovnande" ; -- grovnande..nn.1
  grovplanera_1_V = mkV "grovplanerar" ; -- grovplanera..vb.1
  grovplanerande_1_N = mkN "grovplanerande" ; -- grovplanerande..nn.1
  grovplanerbar_1_A = mkA "grovplanerbar" ; -- grovplanerbar..av.1
  grovplanerbarhet_1_N = mkN "grovplanerbarhet" ; -- grovplanerbarhet..nn.1
  grovplanering_1_N = mkN "grovplanering" ; -- grovplanering..nn.1
  grovriven_1_A = mkA "grovriven" ; -- grovriven..av.1
  grovsalt_1_N = mkN "grovsalt" neutrum  ; -- grovsalt..nn.1
  grovsikt_1_N = mkN "grovsikt" ; -- grovsikt..nn.1
  grovsikta_1_V = mkV "grovsiktar" ; -- grovsikta..vb.1
  grovsiktande_1_N = mkN "grovsiktande" ; -- grovsiktande..nn.1
  grovsiktning_1_N = mkN "grovsiktning" ; -- grovsiktning..nn.1
  grovsmed_1_N = mkN "grovsmed" "grovsmeder" ; -- grovsmed..nn.1
  grovsmide_1_N = mkN "grovsmide" ; -- grovsmide..nn.1
  grovsortera_1_V = mkV "grovsorterar" ; -- grovsortera..vb.1
  grovsorterande_1_N = mkN "grovsorterande" ; -- grovsorterande..nn.1
  grovsorterbar_1_A = mkA "grovsorterbar" ; -- grovsorterbar..av.1
  grovsorterbarhet_1_N = mkN "grovsorterbarhet" ; -- grovsorterbarhet..nn.1
  grovsortering_1_N = mkN "grovsortering" ; -- grovsortering..nn.1
  grovspackel_1_N = mkN "grovspackel" neutrum  ; -- grovspackel..nn.1
  grovsyssla_1_N = mkN "grovsyssla" ; -- grovsyssla..nn.1
  grovtarm_1_N = mkN "grovtarm" ; -- grovtarm..nn.1
  grovtrådig_1_A = mkA "grovtrådig" ; -- grovtrådig..av.1
  grovyxad_1_A = mkA "grovyxad" ; -- grovyxad..av.1
  grubba_1_N = mkN "grubba" ; -- grubba..nn.1
  grubbel_1_N = mkN "grubbel" neutrum  ; -- grubbel..nn.1
  grubbla_1_V = mkV "grubblar" ; -- grubbla..vb.1
  grubblande_1_N = mkN "grubblande" ; -- grubblande..nn.1
  grubblare_1_N = mkN "grubblare" utrum  ; -- grubblare..nn.1
  grubbleri_1_N = mkN "grubbleri" "grubbleriet" "grubblerier" "grubblerierna" ; -- grubbleri..nn.1
  gruff_1_N = mkN "gruff" neutrum  ; -- gruff..nn.1
  gruffa_1_V = mkV "gruffar" ; -- gruffa..vb.1
  gruffande_1_N = mkN "gruffande" ; -- gruffande..nn.1
  grumla_1_V = mkV "grumlar" ; -- grumla..vb.1
  grumlande_1_N = mkN "grumlande" ; -- grumlande..nn.1
  grumlig_1_A = mkA "grumlig" ; -- grumlig..av.1
  grumlighet_1_N = mkN "grumlighet" "grumligheter" ; -- grumlighet..nn.1
  grumling_1_N = mkN "grumling" ; -- grumling..nn.1
  grummel_1_N = mkN "grummel" neutrum  ; -- grummel..nn.1
  grums_1_N = mkN "grums" neutrum  ; -- grums..nn.1
  grumsa_1_V = mkV "grumsar" ; -- grumsa..vb.1
  grumsande_1_N = mkN "grumsande" ; -- grumsande..nn.1
  grumsig_1_A = mkA "grumsig" ; -- grumsig..av.1
  grumsighet_1_N = mkN "grumsighet" ; -- grumsighet..nn.1
  grund_1_A = mkA "grund" ; -- grund..av.1
  grund_1_N = mkN "grund" "grunder" ; -- grund..nn.1
  grund_2_N = mkN "grund" neutrum  ; -- grund..nn.2
  grunda_1_V = mkV "grundar" ; -- grunda..vb.1
  grunda_2_V = mkV "grundar" ; -- grunda..vb.2
  grundackord_1_N = mkN "grundackord" neutrum  ; -- grundackord..nn.1
  grundad_1_A = mkA "grundad" ; -- grundad..av.1
  grundande_1_N = mkN "grundande" ; -- grundande..nn.1
  grundantagande_1_N = mkN "grundantagande" ; -- grundantagande..nn.1
  grundarduo_1_N = mkN "grundarduo" "grundarduor" ; -- grundarduo..nn.1
  grundare_1_N = mkN "grundare" utrum  ; -- grundare..nn.1
  grundavdrag_1_N = mkN "grundavdrag" neutrum  ; -- grundavdrag..nn.1
  grundavgift_1_N = mkN "grundavgift" "grundavgifter" ; -- grundavgift..nn.1
  grundbegrepp_1_N = mkN "grundbegrepp" neutrum  ; -- grundbegrepp..nn.1
  grundbehandla_1_V = mkV "grundbehandlar" ; -- grundbehandla..vb.1
  grundbehandlande_1_N = mkN "grundbehandlande" ; -- grundbehandlande..nn.1
  grundbelopp_1_N = mkN "grundbelopp" neutrum  ; -- grundbelopp..nn.1
  grundbeståndsdel_1_N = mkN "grundbeståndsdel" "grundbeståndsdelen" "grundbeståndsdelar" "grundbeståndsdelarna" ; -- grundbeståndsdel..nn.1
  grundbetydelse_1_N = mkN "grundbetydelse" "grundbetydelser" ; -- grundbetydelse..nn.1
  grundbok_1_N = mkN "grundbok" "grundböcker" ; -- grundbok..nn.1
  grundbrott_1_N = mkN "grundbrott" neutrum  ; -- grundbrott..nn.1
  grundbult_1_N = mkN "grundbult" ; -- grundbult..nn.1
  grunddrag_1_N = mkN "grunddrag" neutrum  ; -- grunddrag..nn.1
  grundegenskap_1_N = mkN "grundegenskap" "grundegenskaper" ; -- grundegenskap..nn.1
  grundelement_1_N = mkN "grundelement" neutrum  ; -- grundelement..nn.1
  grundenhet_1_N = mkN "grundenhet" "grundenheter" ; -- grundenhet..nn.1
  grundera_1_V = mkV "grunderar" ; -- grundera..vb.1
  grunderande_1_N = mkN "grunderande" ; -- grunderande..nn.1
  grunderbar_1_A = mkA "grunderbar" ; -- grunderbar..av.1
  grunderbarhet_1_N = mkN "grunderbarhet" ; -- grunderbarhet..nn.1
  grundering_1_N = mkN "grundering" ; -- grundering..nn.1
  grundfalsk_1_A = mkA "grundfalsk" ; -- grundfalsk..av.1
  grundfel_1_N = mkN "grundfel" "grundfelet" "grundfel" "grundfelen" ; -- grundfel..nn.1
  grundflås_1_N = mkN "grundflås" neutrum  ; -- grundflås..nn.1
  grundfond_1_N = mkN "grundfond" "grundfonder" ; -- grundfond..nn.1
  grundform_1_N = mkN "grundform" "grundformer" ; -- grundform..nn.1
  grundforskning_1_N = mkN "grundforskning" ; -- grundforskning..nn.1
  grundfärg_1_N = mkN "grundfärg" "grundfärger" ; -- grundfärg..nn.1
  grundförbättring_1_N = mkN "grundförbättring" ; -- grundförbättring..nn.1
  grundförsörjning_1_N = mkN "grundförsörjning" ; -- grundförsörjning..nn.1
  grundgrävning_1_N = mkN "grundgrävning" ; -- grundgrävning..nn.1
  grundgående_1_A = mkA "grundgående" ; -- grundgående..av.1
  grundhav_1_N = mkN "grundhav" neutrum  ; -- grundhav..nn.1
  grundhet_1_N = mkN "grundhet" ; -- grundhet..nn.1
  grundhyra_1_N = mkN "grundhyra" ; -- grundhyra..nn.1
  grundidé_1_N = mkN "grundidé" "grundidéer" ; -- grundidé..nn.1
  grundkapital_1_N = mkN "grundkapital" neutrum  ; -- grundkapital..nn.1
  grundkaraktär_1_N = mkN "grundkaraktär" "grundkaraktärer" ; -- grundkaraktär..nn.1
  grundkraft_1_N = mkN "grundkraft" "grundkrafter" ; -- grundkraft..nn.1
  grundkunskap_1_N = mkN "grundkunskap" "grundkunskaper" ; -- grundkunskap..nn.1
  grundkurs_1_N = mkN "grundkurs" "grundkurser" ; -- grundkurs..nn.1
  grundkänning_1_N = mkN "grundkänning" ; -- grundkänning..nn.1
  grundlag_1_N = mkN "grundlag" ; -- grundlag..nn.1
  grundlag_2_N = mkN "grundlag" neutrum  ; -- grundlag..nn.2
  grundlagsbestämmelse_1_N = mkN "grundlagsbestämmelse" "grundlagsbestämmelser" ; -- grundlagsbestämmelse..nn.1
  grundlagsbrott_1_N = mkN "grundlagsbrott" neutrum  ; -- grundlagsbrott..nn.1
  grundlagsenlig_1_A = mkA "grundlagsenlig" ; -- grundlagsenlig..av.1
  grundlagsenlighet_1_N = mkN "grundlagsenlighet" ; -- grundlagsenlighet..nn.1
  grundlagsfäst_1_A = mkA "grundlagsfäst" "grundlagsfäst" ; -- grundlagsfäst..av.1
  grundlagsmässig_1_A = mkA "grundlagsmässig" ; -- grundlagsmässig..av.1
  grundlagsrevision_1_N = mkN "grundlagsrevision" ; -- grundlagsrevision..nn.1
  grundlagsskyddad_1_A = mkA "grundlagsskyddad" ; -- grundlagsskyddad..av.1
  grundlagsstridig_1_A = mkA "grundlagsstridig" ; -- grundlagsstridig..av.1
  grundlagsstridighet_1_N = mkN "grundlagsstridighet" "grundlagsstridigheter" ; -- grundlagsstridighet..nn.1
  grundlagstolkning_1_N = mkN "grundlagstolkning" ; -- grundlagstolkning..nn.1
  grundlagsvidrig_1_A = mkA "grundlagsvidrig" ; -- grundlagsvidrig..av.1
  grundlagsvidrighet_1_N = mkN "grundlagsvidrighet" "grundlagsvidrigheter" ; -- grundlagsvidrighet..nn.1
  grundlagsändring_1_N = mkN "grundlagsändring" ; -- grundlagsändring..nn.1
  grundlig_1_A = mkA "grundlig" ; -- grundlig..av.1
  grundligen_1_Adv = mkAdv "grundligen" ; -- grundligen..ab.1
  grundlighet_1_N = mkN "grundlighet" "grundligheter" ; -- grundlighet..nn.1
  grundlinje_1_N = mkN "grundlinje" "grundlinjer" ; -- grundlinje..nn.1
  grundlura_1_V = mkV "grundlurar" ; -- grundlura..vb.1
  grundlurande_1_N = mkN "grundlurande" ; -- grundlurande..nn.1
  grundlägga_1_V = mkV "grundlägga" "grundla" "grundlagt" ; -- grundlägga..vb.1
  grundläggande_1_A = mkA "grundläggande" ; -- grundläggande..av.1
  grundläggande_1_N = mkN "grundläggande" ; -- grundläggande..nn.1
  grundläggare_1_N = mkN "grundläggare" utrum  ; -- grundläggare..nn.1
  grundläggning_1_N = mkN "grundläggning" ; -- grundläggning..nn.1
  grundlärd_1_A = mkA "grundlärd" "grundlärt" ; -- grundlärd..av.1
  grundlön_1_N = mkN "grundlön" "grundlöner" ; -- grundlön..nn.1
  grundlös_1_A = mkA "grundlös" ; -- grundlös..av.1
  grundlöshet_1_N = mkN "grundlöshet" ; -- grundlöshet..nn.1
  grundmur_1_N = mkN "grundmur" ; -- grundmur..nn.1
  grundmurad_1_A = mkA "grundmurad" ; -- grundmurad..av.1
  grundmurning_1_N = mkN "grundmurning" ; -- grundmurning..nn.1
  grundmåla_1_V = mkV "grundmålar" ; -- grundmåla..vb.1
  grundmålande_1_N = mkN "grundmålande" ; -- grundmålande..nn.1
  grundmålning_1_N = mkN "grundmålning" ; -- grundmålning..nn.1
  grundmått_1_N = mkN "grundmått" neutrum  ; -- grundmått..nn.1
  grundning_1_N = mkN "grundning" ; -- grundning..nn.1
  grundord_1_N = mkN "grundord" neutrum  ; -- grundord..nn.1
  grundorsak_1_N = mkN "grundorsak" "grundorsaker" ; -- grundorsak..nn.1
  grundpelare_1_N = mkN "grundpelare" utrum  ; -- grundpelare..nn.1
  grundperiod_1_N = mkN "grundperiod" "grundperioder" ; -- grundperiod..nn.1
  grundplan_1_N = mkN "grundplan" "grundplaner" ; -- grundplan..nn.1
  grundplåt_1_N = mkN "grundplåt" ; -- grundplåt..nn.1
  grundregel_1_N = mkN "grundregel" "grundregeln" "grundregler" "grundreglerna" ; -- grundregel..nn.1
  grundritning_1_N = mkN "grundritning" ; -- grundritning..nn.1
  grundsanning_1_N = mkN "grundsanning" ; -- grundsanning..nn.1
  grundsats_1_N = mkN "grundsats" "grundsatser" ; -- grundsats..nn.1
  grundskatt_1_N = mkN "grundskatt" "grundskatter" ; -- grundskatt..nn.1
  grundskola_1_N = mkN "grundskola" ; -- grundskola..nn.1
  grundskolebarn_1_N = mkN "grundskolebarn" neutrum  ; -- grundskolebarn..nn.1
  grundskolelärare_1_N = mkN "grundskolelärare" utrum  ; -- grundskolelärare..nn.1
  grundskott_1_N = mkN "grundskott" neutrum  ; -- grundskott..nn.1
  grundspråk_1_N = mkN "grundspråk" neutrum  ; -- grundspråk..nn.1
  grundstam_1_N = mkN "grundstam" "grundstammen" "grundstammar" "grundstammarna" ; -- grundstam..nn.1
  grundsten_1_N = mkN "grundsten" "grundstenen" "grundstenar" "grundstenarna" ; -- grundsten..nn.1
  grundstomme_1_N = mkN "grundstomme" utrum  ; -- grundstomme..nn.1
  grundstreck_1_N = mkN "grundstreck" neutrum  ; -- grundstreck..nn.1
  grundstryka_1_V = mkV "grundstryka" "grundströk" "grundstrukit" ; -- grundstryka..vb.1
  grundstrykande_1_N = mkN "grundstrykande" ; -- grundstrykande..nn.1
  grundstrykning_1_N = mkN "grundstrykning" ; -- grundstrykning..nn.1
  grundställning_1_N = mkN "grundställning" ; -- grundställning..nn.1
  grundstämma_1_N = mkN "grundstämma" ; -- grundstämma..nn.1
  grundstämning_1_N = mkN "grundstämning" ; -- grundstämning..nn.1
  grundstöta_1_V = mkV "grundstöter" ; -- grundstöta..vb.1
  grundstötande_1_N = mkN "grundstötande" ; -- grundstötande..nn.1
  grundstötning_1_N = mkN "grundstötning" ; -- grundstötning..nn.1
  grundstött_1_A = mkA "grundstött" ; -- grundstött..av.1
  grundsyn_1_N = mkN "grundsyn" ; -- grundsyn..nn.1
  grundsärskola_1_N = mkN "grundsärskola" ; -- grundsärskola..nn.1
  grundtal_1_N = mkN "grundtal" neutrum  ; -- grundtal..nn.1
  grundtanke_1_N = mkN "grundtanke" utrum  ; -- grundtanke..nn.1
  grundteori_1_N = mkN "grundteori" "grundteorier" ; -- grundteori..nn.1
  grundtes_1_N = mkN "grundtes" "grundteser" ; -- grundtes..nn.1
  grundtext_1_N = mkN "grundtext" "grundtexter" ; -- grundtext..nn.1
  grundtillstånd_1_N = mkN "grundtillstånd" neutrum  ; -- grundtillstånd..nn.1
  grundton_1_N = mkN "grundton" "grundtoner" ; -- grundton..nn.1
  grundtvigianism_1_N = mkN "grundtvigianism" ; -- grundtvigianism..nn.1
  grundutbildning_1_N = mkN "grundutbildning" ; -- grundutbildning..nn.1
  grundval_1_N = mkN "grundval" ; -- grundval..nn.1
  grundvatten_1_N = mkN "grundvatten" "grundvattnet" "grundvatten" "grundvattnen" ; -- grundvatten..nn.1
  grundvillkor_1_N = mkN "grundvillkor" neutrum  ; -- grundvillkor..nn.1
  grundyta_1_N = mkN "grundyta" ; -- grundyta..nn.1
  grundämne_1_N = mkN "grundämne" ; -- grundämne..nn.1
  grundåskådning_1_N = mkN "grundåskådning" ; -- grundåskådning..nn.1
  grunge_1_N = mkN "grunge" utrum  ; -- grunge..nn.1
  grunka_1_N = mkN "grunka" ; -- grunka..nn.1
  grunna_1_V = mkV "grunnar" ; -- grunna..vb.1
  grunnande_1_N = mkN "grunnande" ; -- grunnande..nn.1
  grupp_1_N = mkN "grupp" "grupper" ; -- grupp..nn.1
  grupparbete_1_N = mkN "grupparbete" ; -- grupparbete..nn.1
  gruppbild_1_N = mkN "gruppbild" "gruppbilder" ; -- gruppbild..nn.1
  gruppboende_1_N = mkN "gruppboende" ; -- gruppboende..nn.1
  gruppchef_1_N = mkN "gruppchef" "gruppchefer" ; -- gruppchef..nn.1
  gruppdynamik_1_N = mkN "gruppdynamik" ; -- gruppdynamik..nn.1
  gruppdynamisk_1_A = mkA "gruppdynamisk" ; -- gruppdynamisk..av.1
  gruppera_1_V = mkV "grupperar" ; -- gruppera..vb.1
  grupperande_1_N = mkN "grupperande" ; -- grupperande..nn.1
  grupperbar_1_A = mkA "grupperbar" ; -- grupperbar..av.1
  grupperbarhet_1_N = mkN "grupperbarhet" ; -- grupperbarhet..nn.1
  gruppering_1_N = mkN "gruppering" ; -- gruppering..nn.1
  gruppförsäkring_1_N = mkN "gruppförsäkring" ; -- gruppförsäkring..nn.1
  gruppgenitiv_1_N = mkN "gruppgenitiv" "gruppgenitiver" ; -- gruppgenitiv..nn.1
  grupphus_1_N = mkN "grupphus" neutrum  ; -- grupphus..nn.1
  gruppidentitet_1_N = mkN "gruppidentitet" "gruppidentiteter" ; -- gruppidentitet..nn.1
  gruppkorsband_1_N = mkN "gruppkorsband" neutrum  ; -- gruppkorsband..nn.1
  gruppledare_1_N = mkN "gruppledare" utrum  ; -- gruppledare..nn.1
  gruppresa_1_N = mkN "gruppresa" ; -- gruppresa..nn.1
  gruppsamtal_1_N = mkN "gruppsamtal" neutrum  ; -- gruppsamtal..nn.1
  gruppsex_1_N = mkN "gruppsex" neutrum  ; -- gruppsex..nn.1
  gruppsmörjning_1_N = mkN "gruppsmörjning" ; -- gruppsmörjning..nn.1
  gruppsykologi_1_N = mkN "gruppsykologi" ; -- gruppsykologi..nn.1
  gruppså_1_V = mkV "gruppsår" ; -- gruppså..vb.1
  gruppsående_1_N = mkN "gruppsående" ; -- gruppsående..nn.1
  gruppterapi_1_N = mkN "gruppterapi" "gruppterapier" ; -- gruppterapi..nn.1
  grupptest_1_N = mkN "grupptest" neutrum  ; -- grupptest..nn.1
  grupptillhörighet_1_N = mkN "grupptillhörighet" ; -- grupptillhörighet..nn.1
  grupptryck_1_N = mkN "grupptryck" neutrum  ; -- grupptryck..nn.1
  gruppvis_1_Adv = mkAdv "gruppvis" ; -- gruppvis..ab.1
  gruppvis_1_A = mkA "gruppvis" ; -- gruppvis..av.1
  grus_1_N = mkN "grus" neutrum  ; -- grus..nn.1
  grusa_1_V = mkV "grusar" ; -- grusa..vb.1
  grusande_1_N = mkN "grusande" ; -- grusande..nn.1
  grusgrop_1_N = mkN "grusgrop" ; -- grusgrop..nn.1
  grusgång_1_N = mkN "grusgång" ; -- grusgång..nn.1
  grusig_1_A = mkA "grusig" ; -- grusig..av.1
  grusplan_1_N = mkN "grusplan" "grusplaner" ; -- grusplan..nn.1
  grustag_1_N = mkN "grustag" neutrum  ; -- grustag..nn.1
  grustäkt_1_N = mkN "grustäkt" "grustäkter" ; -- grustäkt..nn.1
  grusväg_1_N = mkN "grusväg" ; -- grusväg..nn.1
  grusås_1_N = mkN "grusås" ; -- grusås..nn.1
  gruva_1_N = mkN "gruva" ; -- gruva..nn.1
  gruvarbetardotter_1_N = mkN "gruvarbetardotter" "gruvarbetardottern" "gruvarbetardöttrar" "gruvarbetardöttrarna" ; -- gruvarbetardotter..nn.1
  gruvarbetare_1_N = mkN "gruvarbetare" utrum  ; -- gruvarbetare..nn.1
  gruvarbetarstövel_1_N = mkN "gruvarbetarstövel" ; -- gruvarbetarstövel..nn.1
  gruvbolag_1_N = mkN "gruvbolag" neutrum  ; -- gruvbolag..nn.1
  gruvbrytning_1_N = mkN "gruvbrytning" ; -- gruvbrytning..nn.1
  gruvdrama_1_N = mkN "gruvdrama" "gruvdramat" "gruvdramer" "gruvdramerna" ; -- gruvdrama..nn.1
  gruvdrift_1_N = mkN "gruvdrift" "gruvdrifter" ; -- gruvdrift..nn.1
  gruvexplosion_1_N = mkN "gruvexplosion" ; -- gruvexplosion..nn.1
  gruvfogde_1_N = mkN "gruvfogde" utrum  ; -- gruvfogde..nn.1
  gruvfält_1_N = mkN "gruvfält" neutrum  ; -- gruvfält..nn.1
  gruvgas_1_N = mkN "gruvgas" ; -- gruvgas..nn.1
  gruvgång_1_N = mkN "gruvgång" ; -- gruvgång..nn.1
  gruvhund_1_N = mkN "gruvhund" ; -- gruvhund..nn.1
  gruvhål_1_N = mkN "gruvhål" neutrum  ; -- gruvhål..nn.1
  gruvkompass_1_N = mkN "gruvkompass" "gruvkompasser" ; -- gruvkompass..nn.1
  gruvlave_1_N = mkN "gruvlave" utrum  ; -- gruvlave..nn.1
  gruvlig_1_A = mkA "gruvlig" ; -- gruvlig..av.1
  gruvligen_1_Adv = mkAdv "gruvligen" ; -- gruvligen..ab.1
  gruvlighet_1_N = mkN "gruvlighet" "gruvligheter" ; -- gruvlighet..nn.1
  gruvoffer_1_N = mkN "gruvoffer" neutrum  ; -- gruvoffer..nn.1
  gruvolycka_1_N = mkN "gruvolycka" ; -- gruvolycka..nn.1
  gruvras_1_N = mkN "gruvras" neutrum  ; -- gruvras..nn.1
  gruvrå_1_N = mkN "gruvrå" "gruvrån" "gruvrån" "gruvråna" ; -- gruvrå..nn.1
  gruvsam_1_A = mkA "gruvsam" "gruvsamt" "gruvsamma" "gruvsamma" "gruvsammare" "gruvsammast" "gruvsammaste" ; -- gruvsam..av.1
  gruvsamhet_1_N = mkN "gruvsamhet" ; -- gruvsamhet..nn.1
  gruvschakt_1_N = mkN "gruvschakt" neutrum  ; -- gruvschakt..nn.1
  gruvstigare_1_N = mkN "gruvstigare" utrum  ; -- gruvstigare..nn.1
  gruvstrejk_1_N = mkN "gruvstrejk" "gruvstrejker" ; -- gruvstrejk..nn.1
  gruvstötta_1_N = mkN "gruvstötta" ; -- gruvstötta..nn.1
  gruvöppning_1_N = mkN "gruvöppning" ; -- gruvöppning..nn.1
  gruyere_1_N = mkN "gruyere" utrum  ; -- gruyere..nn.1
  gry_1_N = mkN "gry" neutrum  ; -- gry..nn.1
  gry_1_V = mkV "gryr" ; -- gry..vb.1
  gryende_1_N = mkN "gryende" ; -- gryende..nn.1
  grym_1_A = mkA "grym" "grymt" "grymma" "grymma" "grymmare" "grymmast" "grymmaste" ; -- grym..av.1
  grymhet_1_N = mkN "grymhet" "grymheter" ; -- grymhet..nn.1
  grymhet_2_N = mkN "grymhet" ; -- grymhet..nn.2
  grymt_1_Adv = mkAdv "grymt" ; -- grymt..ab.1
  grymt_1_N = mkN "grymt" neutrum  ; -- grymt..nn.1
  grymta_1_V = mkV "grymtar" ; -- grymta..vb.1
  grymtande_1_N = mkN "grymtande" ; -- grymtande..nn.1
  grymthastighet_1_N = mkN "grymthastighet" "grymthastigheter" ; -- grymthastighet..nn.1
  grymtning_1_N = mkN "grymtning" ; -- grymtning..nn.1
  grymtoxe_1_N = mkN "grymtoxe" utrum  ; -- grymtoxe..nn.1
  gryn_1_N = mkN "gryn" neutrum  ; -- gryn..nn.1
  gryna_1_V = mkV "grynar" ; -- gryna..vb.1
  grynande_1_N = mkN "grynande" ; -- grynande..nn.1
  gryne_1_N = mkN "gryne" ; -- gryne..nn.1
  grynig_1_A = mkA "grynig" ; -- grynig..av.1
  grynighet_1_N = mkN "grynighet" "grynigheter" ; -- grynighet..nn.1
  gryning_1_N = mkN "gryning" ; -- gryning..nn.1
  gryningsgroggy_1_A = mkA "gryningsgroggy" ; -- gryningsgroggy..av.1
  gryningsljus_1_N = mkN "gryningsljus" neutrum  ; -- gryningsljus..nn.1
  gryningsstrimma_1_N = mkN "gryningsstrimma" ; -- gryningsstrimma..nn.1
  gryningstid_1_N = mkN "gryningstid" "gryningstider" ; -- gryningstid..nn.1
  gryningstimme_1_N = mkN "gryningstimme" utrum  ; -- gryningstimme..nn.1
  grynkorv_1_N = mkN "grynkorv" ; -- grynkorv..nn.1
  grynna_1_N = mkN "grynna" ; -- grynna..nn.1
  grynpipig_1_A = mkA "grynpipig" ; -- grynpipig..av.1
  grynvälling_1_N = mkN "grynvälling" ; -- grynvälling..nn.1
  gryt_1_N = mkN "gryt" neutrum  ; -- gryt..nn.1
  gryta_1_N = mkN "gryta" ; -- gryta..nn.1
  grytfot_1_N = mkN "grytfot" ; -- grytfot..nn.1
  grythund_1_N = mkN "grythund" ; -- grythund..nn.1
  grytlapp_1_N = mkN "grytlapp" ; -- grytlapp..nn.1
  grytlock_1_N = mkN "grytlock" neutrum  ; -- grytlock..nn.1
  grytskåp_1_N = mkN "grytskåp" neutrum  ; -- grytskåp..nn.1
  grytstek_1_N = mkN "grytstek" ; -- grytstek..nn.1
  grytvante_1_N = mkN "grytvante" utrum  ; -- grytvante..nn.1
  gräbba_1_N = mkN "gräbba" ; -- gräbba..nn.1
  grädda_1_N = mkN "grädda" ; -- grädda..nn.1
  grädda_1_V = mkV "gräddar" ; -- grädda..vb.1
  gräddad_1_A = mkA "gräddad" ; -- gräddad..av.1
  gräddande_1_N = mkN "gräddande" ; -- gräddande..nn.1
  gräddbakelse_1_N = mkN "gräddbakelse" "gräddbakelser" ; -- gräddbakelse..nn.1
  grädde_1_N = mkN "grädde" utrum  ; -- grädde..nn.1
  gräddfil_1_N = mkN "gräddfil" ; -- gräddfil..nn.1
  gräddfil_2_N = mkN "gräddfil" "gräddfiler" ; -- gräddfil..nn.2
  gräddfärgad_1_A = mkA "gräddfärgad" ; -- gräddfärgad..av.1
  gräddgul_1_A = mkA "gräddgul" ; -- gräddgul..av.1
  gräddhalt_1_N = mkN "gräddhalt" "gräddhalter" ; -- gräddhalt..nn.1
  gräddhylla_1_N = mkN "gräddhylla" ; -- gräddhylla..nn.1
  gräddig_1_A = mkA "gräddig" ; -- gräddig..av.1
  gräddighet_1_N = mkN "gräddighet" ; -- gräddighet..nn.1
  gräddmätare_1_N = mkN "gräddmätare" utrum  ; -- gräddmätare..nn.1
  gräddning_1_N = mkN "gräddning" ; -- gräddning..nn.1
  gräddsnipa_1_N = mkN "gräddsnipa" ; -- gräddsnipa..nn.1
  gräddsättning_1_N = mkN "gräddsättning" ; -- gräddsättning..nn.1
  gräddtårta_1_N = mkN "gräddtårta" ; -- gräddtårta..nn.1
  gräddvisp_1_N = mkN "gräddvisp" ; -- gräddvisp..nn.1
  gräddvisp_2_N = mkN "gräddvisp" neutrum  ; -- gräddvisp..nn.2
  gräddvit_1_A = mkA "gräddvit" ; -- gräddvit..av.1
  gräfta_1_N = mkN "gräfta" ; -- gräfta..nn.1
  gräfta_1_V = mkV "gräftar" ; -- gräfta..vb.1
  gräftande_1_N = mkN "gräftande" ; -- gräftande..nn.1
  gräl_1_N = mkN "gräl" neutrum  ; -- gräl..nn.1
  gräla_1_V = mkV "grälar" ; -- gräla..vb.1
  grälaktig_1_A = mkA "grälaktig" ; -- grälaktig..av.1
  grälaktighet_1_N = mkN "grälaktighet" ; -- grälaktighet..nn.1
  grälande_1_N = mkN "grälande" ; -- grälande..nn.1
  grälig_1_A = mkA "grälig" ; -- grälig..av.1
  grälighet_1_N = mkN "grälighet" ; -- grälighet..nn.1
  gräll_1_A = mkA "gräll" ; -- gräll..av.1
  grällhet_1_N = mkN "grällhet" ; -- grällhet..nn.1
  grälmakare_1_N = mkN "grälmakare" utrum  ; -- grälmakare..nn.1
  grälmåns_1_N = mkN "grälmåns" ; -- grälmåns..nn.1
  grälsjuk_1_A = mkA "grälsjuk" ; -- grälsjuk..av.1
  grälsjuka_1_N = mkN "grälsjuka" ; -- grälsjuka..nn.1
  grälsjukhet_1_N = mkN "grälsjukhet" ; -- grälsjukhet..nn.1
  gräma_1_V = mkV "grämer" ; -- gräma..vb.1
  grämande_1_N = mkN "grämande" ; -- grämande..nn.1
  grämelse_1_N = mkN "grämelse" "grämelser" ; -- grämelse..nn.1
  grän_1_N = mkN "grän" neutrum  ; -- grän..nn.1
  gränd_1_N = mkN "gränd" "gränder" ; -- gränd..nn.1
  grändhus_1_N = mkN "grändhus" neutrum  ; -- grändhus..nn.1
  gräng_1_N = mkN "gräng" ; -- gräng..nn.1
  gräns_1_N = mkN "gräns" "gränser" ; -- gräns..nn.1
  gränsa_1_V = mkV "gränsar" ; -- gränsa..vb.1
  gränsbastion_1_N = mkN "gränsbastion" ; -- gränsbastion..nn.1
  gränsbefolkning_1_N = mkN "gränsbefolkning" ; -- gränsbefolkning..nn.1
  gränsbevakning_1_N = mkN "gränsbevakning" ; -- gränsbevakning..nn.1
  gränsbo_1_N = mkN "gränsbo" "gränsbor" ; -- gränsbo..nn.1
  gränsbråk_1_N = mkN "gränsbråk" neutrum  ; -- gränsbråk..nn.1
  gränsdistrikt_1_N = mkN "gränsdistrikt" neutrum  ; -- gränsdistrikt..nn.1
  gränsdragning_1_N = mkN "gränsdragning" ; -- gränsdragning..nn.1
  gränsdragningsfråga_1_N = mkN "gränsdragningsfråga" ; -- gränsdragningsfråga..nn.1
  gränsfall_1_N = mkN "gränsfall" neutrum  ; -- gränsfall..nn.1
  gränsintäkt_1_N = mkN "gränsintäkt" "gränsintäkter" ; -- gränsintäkt..nn.1
  gränsjägare_1_N = mkN "gränsjägare" utrum  ; -- gränsjägare..nn.1
  gränskontroll_1_N = mkN "gränskontroll" "gränskontroller" ; -- gränskontroll..nn.1
  gränskostnad_1_N = mkN "gränskostnad" "gränskostnader" ; -- gränskostnad..nn.1
  gränsla_1_V = mkV "gränslar" ; -- gränsla..vb.1
  gränslande_1_N = mkN "gränslande" ; -- gränslande..nn.1
  gränslinje_1_N = mkN "gränslinje" "gränslinjer" ; -- gränslinje..nn.1
  gränslös_1_A = mkA "gränslös" ; -- gränslös..av.1
  gränslöshet_1_N = mkN "gränslöshet" ; -- gränslöshet..nn.1
  gränsmarkering_1_N = mkN "gränsmarkering" ; -- gränsmarkering..nn.1
  gränsmur_1_N = mkN "gränsmur" ; -- gränsmur..nn.1
  gränsmärke_1_N = mkN "gränsmärke" ; -- gränsmärke..nn.1
  gränsnytta_1_N = mkN "gränsnytta" ; -- gränsnytta..nn.1
  gränsområde_1_N = mkN "gränsområde" ; -- gränsområde..nn.1
  gränspolis_1_N = mkN "gränspolis" ; -- gränspolis..nn.1
  gränspolis_2_N = mkN "gränspolis" "gränspoliser" ; -- gränspolis..nn.2
  gränspostering_1_N = mkN "gränspostering" ; -- gränspostering..nn.1
  gränspåle_1_N = mkN "gränspåle" utrum  ; -- gränspåle..nn.1
  gränsskikt_1_N = mkN "gränsskikt" neutrum  ; -- gränsskikt..nn.1
  gränssnitt_1_N = mkN "gränssnitt" neutrum  ; -- gränssnitt..nn.1
  gränssnittsdokumentation_1_N = mkN "gränssnittsdokumentation" ; -- gränssnittsdokumentation..nn.1
  gränsstad_1_N = mkN "gränsstad" "gränsstäder" ; -- gränsstad..nn.1
  gränssten_1_N = mkN "gränssten" "gränsstenen" "gränsstenar" "gränsstenarna" ; -- gränssten..nn.1
  gränssättning_1_N = mkN "gränssättning" ; -- gränssättning..nn.1
  gränstrakt_1_N = mkN "gränstrakt" "gränstrakter" ; -- gränstrakt..nn.1
  gränstänjande_1_A = mkA "gränstänjande" ; -- gränstänjande..av.1
  gränsvakt_1_N = mkN "gränsvakt" "gränsvakter" ; -- gränsvakt..nn.1
  gränsvärde_1_N = mkN "gränsvärde" ; -- gränsvärde..nn.1
  gränsvåg_1_N = mkN "gränsvåg" ; -- gränsvåg..nn.1
  gränsöverskridande_1_A = mkA "gränsöverskridande" ; -- gränsöverskridande..av.1
  gränsöverskridande_1_N = mkN "gränsöverskridande" ; -- gränsöverskridande..nn.1
  gräs_1_N = mkN "gräs" neutrum  ; -- gräs..nn.1
  gräsa_1_V = mkV "gräsar" ; -- gräsa..vb.1
  gräsad_1_A = mkA "gräsad" ; -- gräsad..av.1
  gräsand_1_N = mkN "gräsand" "gräsänder" ; -- gräsand..nn.1
  gräsande_1_N = mkN "gräsande" ; -- gräsande..nn.1
  gräsbetäckt_1_A = mkA "gräsbetäckt" "gräsbetäckt" ; -- gräsbetäckt..av.1
  gräsbevuxen_1_A = mkA "gräsbevuxen" ; -- gräsbevuxen..av.1
  gräsbrand_1_N = mkN "gräsbrand" "gräsbränder" ; -- gräsbrand..nn.1
  gräsbrandseffekt_1_N = mkN "gräsbrandseffekt" "gräsbrandseffekter" ; -- gräsbrandseffekt..nn.1
  gräsfjäril_1_N = mkN "gräsfjäril" ; -- gräsfjäril..nn.1
  gräsfly_1_N = mkN "gräsfly" "gräsflyet" "gräsflyn" "gräsflyna" ; -- gräsfly..nn.1
  gräsfläck_1_N = mkN "gräsfläck" ; -- gräsfläck..nn.1
  gräsfläcksfobi_1_N = mkN "gräsfläcksfobi" "gräsfläcksfobier" ; -- gräsfläcksfobi..nn.1
  gräsgrön_1_A = mkA "gräsgrön" ; -- gräsgrön..av.1
  gräshalm_1_N = mkN "gräshalm" ; -- gräshalm..nn.1
  gräshoppa_1_N = mkN "gräshoppa" ; -- gräshoppa..nn.1
  gräshoppeliknande_1_A = mkA "gräshoppeliknande" ; -- gräshoppeliknande..av.1
  gräshoppssvärm_1_N = mkN "gräshoppssvärm" ; -- gräshoppssvärm..nn.1
  gräsklippare_1_N = mkN "gräsklippare" utrum  ; -- gräsklippare..nn.1
  gräsklippning_1_N = mkN "gräsklippning" ; -- gräsklippning..nn.1
  gräsklippningsmaskin_1_N = mkN "gräsklippningsmaskin" "gräsklippningsmaskiner" ; -- gräsklippningsmaskin..nn.1
  gräslig_1_A = mkA "gräslig" ; -- gräslig..av.1
  gräslighet_1_N = mkN "gräslighet" "gräsligheter" ; -- gräslighet..nn.1
  gräslik_1_A = mkA "gräslik" ; -- gräslik..av.1
  gräsliknande_1_A = mkA "gräsliknande" ; -- gräsliknande..av.1
  gräslök_1_N = mkN "gräslök" ; -- gräslök..nn.1
  gräsmask_1_N = mkN "gräsmask" ; -- gräsmask..nn.1
  gräsmatta_1_N = mkN "gräsmatta" ; -- gräsmatta..nn.1
  gräsmånad_1_N = mkN "gräsmånad" "gräsmånader" ; -- gräsmånad..nn.1
  gräsnejlika_1_N = mkN "gräsnejlika" ; -- gräsnejlika..nn.1
  gräsplan_1_N = mkN "gräsplan" "gräsplaner" ; -- gräsplan..nn.1
  gräsplätt_1_N = mkN "gräsplätt" ; -- gräsplätt..nn.1
  gräsrot_1_N = mkN "gräsrot" "gräsrötter" ; -- gräsrot..nn.1
  gräsrotskampanj_1_N = mkN "gräsrotskampanj" "gräsrotskampanjer" ; -- gräsrotskampanj..nn.1
  gräsrotsnivå_1_N = mkN "gräsrotsnivå" ; -- gräsrotsnivå..nn.1
  gräsrotsrörelse_1_N = mkN "gräsrotsrörelse" "gräsrotsrörelser" ; -- gräsrotsrörelse..nn.1
  grässträng_1_N = mkN "grässträng" ; -- grässträng..nn.1
  grässtrå_1_N = mkN "grässtrå" "grässtråt" "grässtrån" "grässtråna" ; -- grässtrå..nn.1
  grässvål_1_N = mkN "grässvål" ; -- grässvål..nn.1
  grästorv_1_N = mkN "grästorv" ; -- grästorv..nn.1
  grästorva_1_N = mkN "grästorva" ; -- grästorva..nn.1
  grästrimmer_1_N = mkN "grästrimmer" "grästrimmern" "grästrimrar" "grästrimrarna" ; -- grästrimmer..nn.1
  grästuva_1_N = mkN "grästuva" ; -- grästuva..nn.1
  gräsvall_1_N = mkN "gräsvall" ; -- gräsvall..nn.1
  gräsväxt_1_N = mkN "gräsväxt" "gräsväxter" ; -- gräsväxt..nn.1
  gräsväxt_2_N = mkN "gräsväxt" ; -- gräsväxt..nn.2
  gräsänka_1_N = mkN "gräsänka" ; -- gräsänka..nn.1
  gräsänkling_1_N = mkN "gräsänkling" ; -- gräsänkling..nn.1
  gräsätande_1_A = mkA "gräsätande" ; -- gräsätande..av.1
  gräsätare_1_N = mkN "gräsätare" utrum  ; -- gräsätare..nn.1
  grätten_1_A = mkA "grätten" ; -- grätten..av.1
  grättenhet_1_N = mkN "grättenhet" ; -- grättenhet..nn.1
  gräva_1_V = mkV "gräver" ; -- gräva..vb.1
  gräva_2_V = mkV "gräver" ; -- gräva..vb.2
  grävande_1_N = mkN "grävande" ; -- grävande..nn.1
  grävare_1_N = mkN "grävare" utrum  ; -- grävare..nn.1
  grävargeneration_1_N = mkN "grävargeneration" ; -- grävargeneration..nn.1
  grävarjournalist_1_N = mkN "grävarjournalist" "grävarjournalister" ; -- grävarjournalist..nn.1
  grävarjournalistik_1_N = mkN "grävarjournalistik" ; -- grävarjournalistik..nn.1
  grävblogg_1_N = mkN "grävblogg" ; -- grävblogg..nn.1
  grävgrupp_1_N = mkN "grävgrupp" "grävgrupper" ; -- grävgrupp..nn.1
  grävjournalistik_1_N = mkN "grävjournalistik" ; -- grävjournalistik..nn.1
  grävling_1_N = mkN "grävling" ; -- grävling..nn.1
  grävlingsgryt_1_N = mkN "grävlingsgryt" neutrum  ; -- grävlingsgryt..nn.1
  grävlingshund_1_N = mkN "grävlingshund" ; -- grävlingshund..nn.1
  grävlingshår_1_N = mkN "grävlingshår" neutrum  ; -- grävlingshår..nn.1
  grävlingsjakt_1_N = mkN "grävlingsjakt" ; -- grävlingsjakt..nn.1
  grävmaskin_1_N = mkN "grävmaskin" "grävmaskiner" ; -- grävmaskin..nn.1
  grävning_1_N = mkN "grävning" ; -- grävning..nn.1
  grävschakt_1_N = mkN "grävschakt" neutrum  ; -- grävschakt..nn.1
  grävskopa_1_N = mkN "grävskopa" ; -- grävskopa..nn.1
  grävsvin_1_N = mkN "grävsvin" neutrum  ; -- grävsvin..nn.1
  grå_1_A = mkA "grå" "grått" ; -- grå..av.1
  gråaktig_1_A = mkA "gråaktig" ; -- gråaktig..av.1
  gråaktighet_1_N = mkN "gråaktighet" ; -- gråaktighet..nn.1
  gråal_1_N = mkN "gråal" ; -- gråal..nn.1
  gråben_1_N = mkN "gråben" ; -- gråben..nn.1
  gråberg_1_N = mkN "gråberg" neutrum  ; -- gråberg..nn.1
  gråblek_1_A = mkA "gråblek" ; -- gråblek..av.1
  gråblekhet_1_N = mkN "gråblekhet" ; -- gråblekhet..nn.1
  gråblå_1_A = mkA "gråblå" "gråblått" ; -- gråblå..av.1
  gråbo_1_N = mkN "gråbo" "gråbor" ; -- gråbo..nn.1
  gråbroder_1_N = mkN "gråbroder" "gråbrodern" "gråbröder" "gråbröderna" ; -- gråbroder..nn.1
  gråbrun_1_A = mkA "gråbrun" ; -- gråbrun..av.1
  gråbrödrakonvent_1_N = mkN "gråbrödrakonvent" neutrum  ; -- gråbrödrakonvent..nn.1
  grådask_1_N = mkN "grådask" neutrum  ; -- grådask..nn.1
  grådaskig_1_A = mkA "grådaskig" ; -- grådaskig..av.1
  grådaskighet_1_N = mkN "grådaskighet" ; -- grådaskighet..nn.1
  gråfläckig_1_A = mkA "gråfläckig" ; -- gråfläckig..av.1
  grågosse_1_N = mkN "grågosse" utrum  ; -- grågosse..nn.1
  grågrön_1_A = mkA "grågrön" ; -- grågrön..av.1
  grågul_1_A = mkA "grågul" ; -- grågul..av.1
  grågyllen_1_N = mkN "grågyllen" "grågyllen" "grågyllen" "grågyllena" ; -- grågyllen..nn.1
  grågås_1_N = mkN "grågås" "grågåsen" "grågäss" "grågässen" ; -- grågås..nn.1
  gråhund_1_N = mkN "gråhund" ; -- gråhund..nn.1
  gråhäger_1_N = mkN "gråhäger" ; -- gråhäger..nn.1
  gråhårig_1_A = mkA "gråhårig" ; -- gråhårig..av.1
  gråhårighet_1_N = mkN "gråhårighet" ; -- gråhårighet..nn.1
  gråhårsman_1_N = mkN "gråhårsman" "gråhårsmannen" "gråhårsmän" "gråhårsmännen" ; -- gråhårsman..nn.1
  gråkall_1_A = mkA "gråkall" ; -- gråkall..av.1
  gråkallhet_1_N = mkN "gråkallhet" ; -- gråkallhet..nn.1
  gråkil_1_N = mkN "gråkil" ; -- gråkil..nn.1
  grålax_1_N = mkN "grålax" ; -- grålax..nn.1
  grålla_1_N = mkN "grålla" ; -- grålla..nn.1
  grålle_1_N = mkN "grålle" utrum  ; -- grålle..nn.1
  gråmes_1_N = mkN "gråmes" ; -- gråmes..nn.1
  gråmunk_1_N = mkN "gråmunk" ; -- gråmunk..nn.1
  gråmurrig_1_A = mkA "gråmurrig" ; -- gråmurrig..av.1
  gråmurrighet_1_N = mkN "gråmurrighet" ; -- gråmurrighet..nn.1
  gråmålad_1_A = mkA "gråmålad" ; -- gråmålad..av.1
  gråna_1_V = mkV "grånar" ; -- gråna..vb.1
  grånad_1_N = mkN "grånad" "grånader" ; -- grånad..nn.1
  grånande_1_N = mkN "grånande" ; -- grånande..nn.1
  gråpapper_1_N = mkN "gråpapper" neutrum  ; -- gråpapper..nn.1
  gråpäron_1_N = mkN "gråpäron" neutrum  ; -- gråpäron..nn.1
  gråregnig_1_A = mkA "gråregnig" ; -- gråregnig..av.1
  gråregnighet_1_N = mkN "gråregnighet" ; -- gråregnighet..nn.1
  gråsalva_1_N = mkN "gråsalva" ; -- gråsalva..nn.1
  gråsej_1_N = mkN "gråsej" ; -- gråsej..nn.1
  gråsida_1_N = mkN "gråsida" ; -- gråsida..nn.1
  gråsiska_1_N = mkN "gråsiska" ; -- gråsiska..nn.1
  gråskala_1_N = mkN "gråskala" ; -- gråskala..nn.1
  gråskimlig_1_A = mkA "gråskimlig" ; -- gråskimlig..av.1
  gråskimlighet_1_N = mkN "gråskimlighet" ; -- gråskimlighet..nn.1
  gråskimmel_1_N = mkN "gråskimmel" "gråskimmeln" "gråskimmlar" "gråskimmlarna" ; -- gråskimmel..nn.1
  gråskäckig_1_A = mkA "gråskäckig" ; -- gråskäckig..av.1
  gråskägg_1_N = mkN "gråskägg" neutrum  ; -- gråskägg..nn.1
  gråskäggig_1_A = mkA "gråskäggig" ; -- gråskäggig..av.1
  gråsosse_1_N = mkN "gråsosse" utrum  ; -- gråsosse..nn.1
  gråsossefalang_1_N = mkN "gråsossefalang" "gråsossefalanger" ; -- gråsossefalang..nn.1
  gråsparv_1_N = mkN "gråsparv" ; -- gråsparv..nn.1
  gråspett_1_N = mkN "gråspett" ; -- gråspett..nn.1
  gråsprängd_1_A = mkA "gråsprängd" "gråsprängt" ; -- gråsprängd..av.1
  gråsprängdhet_1_N = mkN "gråsprängdhet" ; -- gråsprängdhet..nn.1
  gråstarr_1_N = mkN "gråstarr" ; -- gråstarr..nn.1
  gråsten_1_N = mkN "gråsten" "gråstenen" "gråstenar" "gråstenarna" ; -- gråsten..nn.1
  gråstrimmig_1_A = mkA "gråstrimmig" ; -- gråstrimmig..av.1
  gråsugga_1_N = mkN "gråsugga" ; -- gråsugga..nn.1
  gråsvart_1_A = mkA "gråsvart" "gråsvart" ; -- gråsvart..av.1
  gråsäl_1_N = mkN "gråsäl" ; -- gråsäl..nn.1
  gråt_1_N = mkN "gråt" ; -- gråt..nn.1
  gråta_1_V = mkV "gråta" "grät" "gråtit" ; -- gråta..vb.1
  gråtande_1_N = mkN "gråtande" ; -- gråtande..nn.1
  gråtattack_1_N = mkN "gråtattack" "gråtattacker" ; -- gråtattack..nn.1
  gråterska_1_N = mkN "gråterska" ; -- gråterska..nn.1
  gråtfärdig_1_A = mkA "gråtfärdig" ; -- gråtfärdig..av.1
  gråtfärdighet_1_N = mkN "gråtfärdighet" ; -- gråtfärdighet..nn.1
  gråthickande_1_N = mkN "gråthickande" ; -- gråthickande..nn.1
  gråtlabil_1_A = mkA "gråtlabil" ; -- gråtlabil..av.1
  gråtmild_1_A = mkA "gråtmild" "gråtmilt" ; -- gråtmild..av.1
  gråtmildhet_1_N = mkN "gråtmildhet" ; -- gråtmildhet..nn.1
  gråton_1_N = mkN "gråton" "gråtoner" ; -- gråton..nn.1
  gråtonsskala_1_N = mkN "gråtonsskala" ; -- gråtonsskala..nn.1
  gråtparoxysm_1_N = mkN "gråtparoxysm" "gråtparoxysmer" ; -- gråtparoxysm..nn.1
  gråtrut_1_N = mkN "gråtrut" ; -- gråtrut..nn.1
  gråvacka_1_N = mkN "gråvacka" ; -- gråvacka..nn.1
  gråval_1_N = mkN "gråval" ; -- gråval..nn.1
  gråverk_1_N = mkN "gråverk" neutrum  ; -- gråverk..nn.1
  gråvide_1_N = mkN "gråvide" ; -- gråvide..nn.1
  gråvit_1_A = mkA "gråvit" ; -- gråvit..av.1
  gråväder_1_N = mkN "gråväder" neutrum  ; -- gråväder..nn.1
  gråvädersmoln_1_N = mkN "gråvädersmoln" neutrum  ; -- gråvädersmoln..nn.1
  gråzon_1_N = mkN "gråzon" "gråzoner" ; -- gråzon..nn.1
  gråärt_1_N = mkN "gråärt" ; -- gråärt..nn.1
  gröda_1_N = mkN "gröda" ; -- gröda..nn.1
  gröe_1_N = mkN "gröe" utrum  ; -- gröe..nn.1
  grön_1_A = mkA "grön" ; -- grön..av.1
  grönaktig_1_A = mkA "grönaktig" ; -- grönaktig..av.1
  grönaktighet_1_N = mkN "grönaktighet" ; -- grönaktighet..nn.1
  grönalg_1_N = mkN "grönalg" "grönalger" ; -- grönalg..nn.1
  grönavågare_1_N = mkN "grönavågare" utrum  ; -- grönavågare..nn.1
  grönbena_1_N = mkN "grönbena" ; -- grönbena..nn.1
  grönbete_1_N = mkN "grönbete" ; -- grönbete..nn.1
  grönblek_1_A = mkA "grönblek" ; -- grönblek..av.1
  grönblekhet_1_N = mkN "grönblekhet" ; -- grönblekhet..nn.1
  grönblind_1_A = mkA "grönblind" ; -- grönblind..av.1
  grönblindhet_1_N = mkN "grönblindhet" ; -- grönblindhet..nn.1
  grönfink_1_N = mkN "grönfink" ; -- grönfink..nn.1
  grönfoder_1_N = mkN "grönfoder" neutrum  ; -- grönfoder..nn.1
  gröngräs_1_N = mkN "gröngräs" neutrum  ; -- gröngräs..nn.1
  gröngul_1_A = mkA "gröngul" ; -- gröngul..av.1
  gröngödsla_1_V = mkV "gröngödslar" ; -- gröngödsla..vb.1
  gröngödslande_1_N = mkN "gröngödslande" ; -- gröngödslande..nn.1
  gröngödsling_1_N = mkN "gröngödsling" ; -- gröngödsling..nn.1
  gröngöling_1_N = mkN "gröngöling" ; -- gröngöling..nn.1
  grönhet_1_N = mkN "grönhet" ; -- grönhet..nn.1
  gröning_1_N = mkN "gröning" ; -- gröning..nn.1
  grönklädd_1_A = mkA "grönklädd" ; -- grönklädd..av.1
  grönkulla_1_N = mkN "grönkulla" ; -- grönkulla..nn.1
  grönkål_1_N = mkN "grönkål" ; -- grönkål..nn.1
  grönköping_1_N = mkN "grönköping" ; -- grönköping..nn.1
  grönköpingsmässig_1_A = mkA "grönköpingsmässig" ; -- grönköpingsmässig..av.1
  grönköpingsmässighet_1_N = mkN "grönköpingsmässighet" ; -- grönköpingsmässighet..nn.1
  grönlandsval_1_N = mkN "grönlandsval" ; -- grönlandsval..nn.1
  grönling_1_N = mkN "grönling" ; -- grönling..nn.1
  grönländare_1_N = mkN "grönländare" utrum  ; -- grönländare..nn.1
  grönländsk_1_A = mkA "grönländsk" ; -- grönländsk..av.1
  grönländska_1_N = mkN "grönländska" ; -- grönländska..nn.1
  grönländska_2_N = mkN "grönländska" ; -- grönländska..nn.2
  grönmalt_1_N = mkN "grönmalt" ; -- grönmalt..nn.1
  grönmogen_1_A = mkA "grönmogen" ; -- grönmogen..av.1
  grönmognad_1_N = mkN "grönmognad" "grönmognader" ; -- grönmognad..nn.1
  grönmålad_1_A = mkA "grönmålad" ; -- grönmålad..av.1
  grönmögel_1_N = mkN "grönmögel" neutrum  ; -- grönmögel..nn.1
  grönmögelost_1_N = mkN "grönmögelost" ; -- grönmögelost..nn.1
  grönmörk_1_A = mkA "grönmörk" ; -- grönmörk..av.1
  grönområde_1_N = mkN "grönområde" ; -- grönområde..nn.1
  grönrätt_1_N = mkN "grönrätt" "grönrätter" ; -- grönrätt..nn.1
  grönsak_1_N = mkN "grönsak" "grönsaker" ; -- grönsak..nn.1
  grönsaksblandning_1_N = mkN "grönsaksblandning" ; -- grönsaksblandning..nn.1
  grönsaksfrö_1_N = mkN "grönsaksfrö" "grönsaksfröt" "grönsaksfrön" "grönsaksfröen" ; -- grönsaksfrö..nn.1
  grönsaksodling_1_N = mkN "grönsaksodling" ; -- grönsaksodling..nn.1
  grönsaksröra_1_N = mkN "grönsaksröra" ; -- grönsaksröra..nn.1
  grönsakssoppa_1_N = mkN "grönsakssoppa" ; -- grönsakssoppa..nn.1
  grönsaksstånd_1_N = mkN "grönsaksstånd" neutrum  ; -- grönsaksstånd..nn.1
  grönsakstallrik_1_N = mkN "grönsakstallrik" ; -- grönsakstallrik..nn.1
  grönsallad_1_N = mkN "grönsallad" "grönsallader" ; -- grönsallad..nn.1
  grönsiska_1_N = mkN "grönsiska" ; -- grönsiska..nn.1
  grönska_1_N = mkN "grönska" ; -- grönska..nn.1
  grönska_1_V = mkV "grönskar" ; -- grönska..vb.1
  grönskande_1_N = mkN "grönskande" ; -- grönskande..nn.1
  grönskimrande_1_A = mkA "grönskimrande" ; -- grönskimrande..av.1
  grönsoppa_1_N = mkN "grönsoppa" ; -- grönsoppa..nn.1
  grönspett_1_N = mkN "grönspett" ; -- grönspett..nn.1
  grönstarr_1_N = mkN "grönstarr" ; -- grönstarr..nn.1
  grönsvart_1_A = mkA "grönsvart" "grönsvart" ; -- grönsvart..av.1
  grönvit_1_A = mkA "grönvit" ; -- grönvit..av.1
  grönyta_1_N = mkN "grönyta" ; -- grönyta..nn.1
  grönådrig_1_A = mkA "grönådrig" ; -- grönådrig..av.1
  grönådrighet_1_N = mkN "grönådrighet" ; -- grönådrighet..nn.1
  gröpa_1_V = mkV "gröpar" ; -- gröpa..vb.1
  gröpande_1_N = mkN "gröpande" ; -- gröpande..nn.1
  gröpe_1_N = mkN "gröpe" ; -- gröpe..nn.1
  gröpning_1_N = mkN "gröpning" ; -- gröpning..nn.1
  gröt_1_N = mkN "gröt" ; -- gröt..nn.1
  gröta_1_V = mkV "grötar" ; -- gröta..vb.1
  grötande_1_N = mkN "grötande" ; -- grötande..nn.1
  grötfrukost_1_N = mkN "grötfrukost" ; -- grötfrukost..nn.1
  grötig_1_A = mkA "grötig" ; -- grötig..av.1
  grötighet_1_N = mkN "grötighet" ; -- grötighet..nn.1
  grötlunk_1_N = mkN "grötlunk" ; -- grötlunk..nn.1
  grötmyndig_1_A = mkA "grötmyndig" ; -- grötmyndig..av.1
  grötmyndighet_1_N = mkN "grötmyndighet" ; -- grötmyndighet..nn.1
  grötomslag_1_N = mkN "grötomslag" neutrum  ; -- grötomslag..nn.1
  grötrim_1_N = mkN "grötrim" "grötrimmet" "grötrim" "grötrimmen" ; -- grötrim..nn.1
  grötrock_1_N = mkN "grötrock" ; -- grötrock..nn.1
  guadalup_1_N = mkN "guadalup" ; -- guadalup..nn.1
  guanin_1_N = mkN "guanin" "guaninet" "guaniner" "guaninerna" ; -- guanin..nn.1
  guano_1_N = mkN "guano" ; -- guano..nn.1
  guarani_1_N = mkN "guarani" ; -- guarani..nn.1
  guarani_2_N = mkN "guarani" ; -- guarani..nn.2
  guatemalan_1_N = mkN "guatemalan" "guatemalaner" ; -- guatemalan..nn.1
  guatemalansk_1_A = mkA "guatemalansk" ; -- guatemalansk..av.1
  guatemalanska_1_N = mkN "guatemalanska" ; -- guatemalanska..nn.1
  guatemaltek_1_N = mkN "guatemaltek" "guatemalteker" ; -- guatemaltek..nn.1
  guatemaltekisk_1_A = mkA "guatemaltekisk" ; -- guatemaltekisk..av.1
  guayanan_1_N = mkN "guayanan" "guayananer" ; -- guayanan..nn.1
  guayansk_1_A = mkA "guayansk" ; -- guayansk..av.1
  gubbe_1_N = mkN "gubbe" utrum  ; -- gubbe..nn.1
  gubbhus_1_N = mkN "gubbhus" neutrum  ; -- gubbhus..nn.1
  gubbig_1_A = mkA "gubbig" ; -- gubbig..av.1
  gubbighet_1_N = mkN "gubbighet" ; -- gubbighet..nn.1
  gubbjävel_1_N = mkN "gubbjävel" ; -- gubbjävel..nn.1
  gubbknarrighet_1_N = mkN "gubbknarrighet" ; -- gubbknarrighet..nn.1
  gubbsjuk_1_A = mkA "gubbsjuk" ; -- gubbsjuk..av.1
  gubbsjuka_1_N = mkN "gubbsjuka" ; -- gubbsjuka..nn.1
  gubbsjukhet_1_N = mkN "gubbsjukhet" ; -- gubbsjukhet..nn.1
  gubbskägg_1_N = mkN "gubbskägg" neutrum  ; -- gubbskägg..nn.1
  gubbslem_1_N = mkN "gubbslem" "gubbslemmet" "gubbslem" "gubbslemmen" ; -- gubbslem..nn.1
  gubbstackare_1_N = mkN "gubbstackare" utrum  ; -- gubbstackare..nn.1
  gubbstrutt_1_N = mkN "gubbstrutt" ; -- gubbstrutt..nn.1
  gubbträsk_1_N = mkN "gubbträsk" neutrum  ; -- gubbträsk..nn.1
  gubbvälde_1_N = mkN "gubbvälde" ; -- gubbvälde..nn.1
  guckusko_1_N = mkN "guckusko" "guckuskor" ; -- guckusko..nn.1
  gud_1_N = mkN "gud" ; -- gud..nn.1
  gudabeläte_1_N = mkN "gudabeläte" ; -- gudabeläte..nn.1
  gudabenådad_1_A = mkA "gudabenådad" ; -- gudabenådad..av.1
  gudabild_1_N = mkN "gudabild" "gudabilder" ; -- gudabild..nn.1
  gudadryck_1_N = mkN "gudadryck" "gudadrycker" ; -- gudadryck..nn.1
  gudagiven_1_A = mkA "gudagiven" ; -- gudagiven..av.1
  gudagåva_1_N = mkN "gudagåva" ; -- gudagåva..nn.1
  gudaktig_1_A = mkA "gudaktig" ; -- gudaktig..av.1
  gudaktighet_1_N = mkN "gudaktighet" ; -- gudaktighet..nn.1
  gudalik_1_A = mkA "gudalik" ; -- gudalik..av.1
  gudaliknande_1_A = mkA "gudaliknande" ; -- gudaliknande..av.1
  gudalära_1_N = mkN "gudalära" ; -- gudalära..nn.1
  gudamakt_1_N = mkN "gudamakt" ; -- gudamakt..nn.1
  gudasaga_1_N = mkN "gudasaga" ; -- gudasaga..nn.1
  gudaskymning_1_N = mkN "gudaskymning" ; -- gudaskymning..nn.1
  gudasänd_1_A = mkA "gudasänd" ; -- gudasänd..av.1
  gudbarn_1_N = mkN "gudbarn" neutrum  ; -- gudbarn..nn.1
  guddotter_1_N = mkN "guddotter" "guddottern" "guddöttrar" "guddöttrarna" ; -- guddotter..nn.1
  gudelig_1_A = mkA "gudelig" ; -- gudelig..av.1
  gudelighet_1_N = mkN "gudelighet" ; -- gudelighet..nn.1
  gudfar_1_N = mkN "gudfader" "gudfadern" "gudfäder" "gudfäderna" ; -- gudfar..nn.1
  gudfruktig_1_A = mkA "gudfruktig" ; -- gudfruktig..av.1
  gudfruktighet_1_N = mkN "gudfruktighet" ; -- gudfruktighet..nn.1
  guding_1_N = mkN "guding" ; -- guding..nn.1
  gudinna_1_N = mkN "gudinna" ; -- gudinna..nn.1
  gudlig_1_A = mkA "gudlig" ; -- gudlig..av.1
  gudlighet_1_N = mkN "gudlighet" ; -- gudlighet..nn.1
  gudlös_1_A = mkA "gudlös" ; -- gudlös..av.1
  gudlöshet_1_N = mkN "gudlöshet" ; -- gudlöshet..nn.1
  gudmor_1_N = mkN "gudmor" "gudmodern" "gudmödrar" "gudmödrarna" ; -- gudmor..nn.1
  gudom_1_N = mkN "gudom" ; -- gudom..nn.1
  gudomlig_1_A = mkA "gudomlig" ; -- gudomlig..av.1
  gudomliggöra_1_V = mkV "gudomliggöra" "gudomliggjorde" "gudomliggjort" ; -- gudomliggöra..vb.1
  gudomliggörande_1_N = mkN "gudomliggörande" ; -- gudomliggörande..nn.1
  gudomliggörelse_1_N = mkN "gudomliggörelse" "gudomliggörelser" ; -- gudomliggörelse..nn.1
  gudomliggöring_1_N = mkN "gudomliggöring" ; -- gudomliggöring..nn.1
  gudomlighet_1_N = mkN "gudomlighet" "gudomligheter" ; -- gudomlighet..nn.1
  gudsbevis_1_N = mkN "gudsbevis" neutrum  ; -- gudsbevis..nn.1
  gudsbild_1_N = mkN "gudsbild" "gudsbilder" ; -- gudsbild..nn.1
  gudsdom_1_N = mkN "gudsdom" ; -- gudsdom..nn.1
  gudsfred_1_N = mkN "gudsfred" ; -- gudsfred..nn.1
  gudsförgäten_1_A = mkA "gudsförgäten" ; -- gudsförgäten..av.1
  gudsförgätenhet_1_N = mkN "gudsförgätenhet" ; -- gudsförgätenhet..nn.1
  gudsförnekare_1_N = mkN "gudsförnekare" utrum  ; -- gudsförnekare..nn.1
  gudsförnekelse_1_N = mkN "gudsförnekelse" "gudsförnekelser" ; -- gudsförnekelse..nn.1
  gudslån_1_N = mkN "gudslån" neutrum  ; -- gudslån..nn.1
  gudsman_1_N = mkN "gudsman" "gudsmannen" "gudsmän" "gudsmännen" ; -- gudsman..nn.1
  gudsnådelig_1_A = mkA "gudsnådelig" ; -- gudsnådelig..av.1
  gudsnådelighet_1_N = mkN "gudsnådelighet" ; -- gudsnådelighet..nn.1
  gudsnådlig_1_A = mkA "gudsnådlig" ; -- gudsnådlig..av.1
  gudsnådlighet_1_N = mkN "gudsnådlighet" ; -- gudsnådlighet..nn.1
  gudson_1_N = mkN "gudson" "gudsöner" ; -- gudson..nn.1
  gudsord_1_N = mkN "gudsord" neutrum  ; -- gudsord..nn.1
  gudstjänst_1_N = mkN "gudstjänst" "gudstjänster" ; -- gudstjänst..nn.1
  gudstjänstbesökare_1_N = mkN "gudstjänstbesökare" utrum  ; -- gudstjänstbesökare..nn.1
  gudstjänstdag_1_N = mkN "gudstjänstdag" ; -- gudstjänstdag..nn.1
  gudstjänstform_1_N = mkN "gudstjänstform" "gudstjänstformer" ; -- gudstjänstform..nn.1
  gudstjänstfrekvens_1_N = mkN "gudstjänstfrekvens" "gudstjänstfrekvenser" ; -- gudstjänstfrekvens..nn.1
  gudstjänstlig_1_A = mkA "gudstjänstlig" ; -- gudstjänstlig..av.1
  gudstjänstlokal_1_N = mkN "gudstjänstlokal" "gudstjänstlokaler" ; -- gudstjänstlokal..nn.1
  gudstjänstordning_1_N = mkN "gudstjänstordning" ; -- gudstjänstordning..nn.1
  gudstjänstritual_1_N = mkN "gudstjänstritual" neutrum  ; -- gudstjänstritual..nn.1
  gudstjänsttid_1_N = mkN "gudstjänsttid" "gudstjänsttider" ; -- gudstjänsttid..nn.1
  gudstro_1_N = mkN "gudstro" ; -- gudstro..nn.1
  gudstroende_1_A = mkA "gudstroende" ; -- gudstroende..av.1
  gudsupplevelse_1_N = mkN "gudsupplevelse" "gudsupplevelser" ; -- gudsupplevelse..nn.1
  gudunge_1_N = mkN "gudunge" utrum  ; -- gudunge..nn.1
  guida_1_V = mkV "guidar" ; -- guida..vb.1
  guidande_1_N = mkN "guidande" ; -- guidande..nn.1
  guide_1_N = mkN "guide" "guider" ; -- guide..nn.1
  guinea_1_N = mkN "guinea" "guinean" "guineas" "guineasarna" ; -- guinea..nn.1
  guinean_1_N = mkN "guinean" "guineaner" ; -- guinean..nn.1
  guineansk_1_A = mkA "guineansk" ; -- guineansk..av.1
  guineanska_1_N = mkN "guineanska" ; -- guineanska..nn.1
  gujarati_1_N = mkN "gujarati" ; -- gujarati..nn.1
  gul_1_A = mkA "gul" ; -- gul..av.1
  gula_1_N = mkN "gula" ; -- gula..nn.1
  gulaktig_1_A = mkA "gulaktig" ; -- gulaktig..av.1
  gulaktighet_1_N = mkN "gulaktighet" ; -- gulaktighet..nn.1
  gulasch_1_N = mkN "gulasch" ; -- gulasch..nn.1
  gulasch_2_N = mkN "gulasch" "gulascher" ; -- gulasch..nn.2
  gulaschbaron_1_N = mkN "gulaschbaron" "gulaschbaroner" ; -- gulaschbaron..nn.1
  gulblek_1_A = mkA "gulblek" ; -- gulblek..av.1
  gulblekhet_1_N = mkN "gulblekhet" ; -- gulblekhet..nn.1
  gulblommig_1_A = mkA "gulblommig" ; -- gulblommig..av.1
  gulblåsa_1_N = mkN "gulblåsa" ; -- gulblåsa..nn.1
  gulbrun_1_A = mkA "gulbrun" ; -- gulbrun..av.1
  guld_1_N = mkN "guld" neutrum  ; -- guld..nn.1
  guld_2_N = mkN "guld" neutrum  ; -- guld..nn.2
  guldbagge_1_N = mkN "guldbagge" utrum  ; -- guldbagge..nn.1
  guldbaggegala_1_N = mkN "guldbaggegala" ; -- guldbaggegala..nn.1
  guldbarr_1_N = mkN "guldbarr" "guldbarrer" ; -- guldbarr..nn.1
  guldberlock_1_N = mkN "guldberlock" "guldberlocker" ; -- guldberlock..nn.1
  guldbesatt_1_A = mkA "guldbesatt" ; -- guldbesatt..av.1
  guldbrokad_1_N = mkN "guldbrokad" "guldbrokader" ; -- guldbrokad..nn.1
  guldbrun_1_A = mkA "guldbrun" ; -- guldbrun..av.1
  guldbröllop_1_N = mkN "guldbröllop" neutrum  ; -- guldbröllop..nn.1
  guldbär_1_N = mkN "guldbär" neutrum  ; -- guldbär..nn.1
  guldbågad_1_A = mkA "guldbågad" ; -- guldbågad..av.1
  gulddekor_1_N = mkN "gulddekor" "gulddekoren" "gulddekorer" "gulddekorerna" ; -- gulddekor..nn.1
  gulddrageri_1_N = mkN "gulddrageri" "gulddrageriet" "gulddragerier" "gulddragerierna" ; -- gulddrageri..nn.1
  gulddukat_1_N = mkN "gulddukat" "gulddukater" ; -- gulddukat..nn.1
  gulden_1_N = mkN "gulden" "guldenen" "gulden" "guldenen" ; -- gulden..nn.1
  guldfasan_1_N = mkN "guldfasan" "guldfasaner" ; -- guldfasan..nn.1
  guldfeber_1_N = mkN "guldfeber" ; -- guldfeber..nn.1
  guldfestong_1_N = mkN "guldfestong" "guldfestonger" ; -- guldfestong..nn.1
  guldfisk_1_N = mkN "guldfisk" ; -- guldfisk..nn.1
  guldfux_1_N = mkN "guldfux" ; -- guldfux..nn.1
  guldfynd_1_N = mkN "guldfynd" neutrum  ; -- guldfynd..nn.1
  guldfärgad_1_A = mkA "guldfärgad" ; -- guldfärgad..av.1
  guldförande_1_A = mkA "guldförande" ; -- guldförande..av.1
  guldföremål_1_N = mkN "guldföremål" neutrum  ; -- guldföremål..nn.1
  guldgalon_1_N = mkN "guldgalon" "guldgaloner" ; -- guldgalon..nn.1
  guldglans_1_N = mkN "guldglans" ; -- guldglans..nn.1
  guldglänsande_1_A = mkA "guldglänsande" ; -- guldglänsande..av.1
  guldgruva_1_N = mkN "guldgruva" ; -- guldgruva..nn.1
  guldgrävare_1_N = mkN "guldgrävare" utrum  ; -- guldgrävare..nn.1
  guldgul_1_A = mkA "guldgul" ; -- guldgul..av.1
  guldhalt_1_N = mkN "guldhalt" "guldhalter" ; -- guldhalt..nn.1
  guldhaltig_1_A = mkA "guldhaltig" ; -- guldhaltig..av.1
  guldhårig_1_A = mkA "guldhårig" ; -- guldhårig..av.1
  guldhöna_1_N = mkN "guldhöna" ; -- guldhöna..nn.1
  guldkalv_1_N = mkN "guldkalv" ; -- guldkalv..nn.1
  guldkant_1_N = mkN "guldkant" "guldkanter" ; -- guldkant..nn.1
  guldkantad_1_A = mkA "guldkantad" ; -- guldkantad..av.1
  guldkedja_1_N = mkN "guldkedja" ; -- guldkedja..nn.1
  guldklimp_1_N = mkN "guldklimp" ; -- guldklimp..nn.1
  guldklocka_1_N = mkN "guldklocka" ; -- guldklocka..nn.1
  guldkorn_1_N = mkN "guldkorn" neutrum  ; -- guldkorn..nn.1
  guldkran_1_N = mkN "guldkran" ; -- guldkran..nn.1
  guldkrog_1_N = mkN "guldkrog" ; -- guldkrog..nn.1
  guldkrona_1_N = mkN "guldkrona" ; -- guldkrona..nn.1
  guldlegering_1_N = mkN "guldlegering" ; -- guldlegering..nn.1
  guldliknande_1_A = mkA "guldliknande" ; -- guldliknande..av.1
  guldlockig_1_A = mkA "guldlockig" ; -- guldlockig..av.1
  guldmakare_1_N = mkN "guldmakare" utrum  ; -- guldmakare..nn.1
  guldmakeri_1_N = mkN "guldmakeri" "guldmakeriet" "guldmakerier" "guldmakerierna" ; -- guldmakeri..nn.1
  guldmakrill_1_N = mkN "guldmakrill" ; -- guldmakrill..nn.1
  guldmedalj_1_N = mkN "guldmedalj" "guldmedaljer" ; -- guldmedalj..nn.1
  guldmedaljör_1_N = mkN "guldmedaljör" "guldmedaljörer" ; -- guldmedaljör..nn.1
  guldmynt_1_N = mkN "guldmynt" neutrum  ; -- guldmynt..nn.1
  guldmyntfot_1_N = mkN "guldmyntfot" ; -- guldmyntfot..nn.1
  guldpeng_1_N = mkN "guldpeng" ; -- guldpeng..nn.1
  guldpenna_1_N = mkN "guldpenna" ; -- guldpenna..nn.1
  guldpenning_1_N = mkN "guldpenning" ; -- guldpenning..nn.1
  guldplants_1_N = mkN "guldplants" ; -- guldplants..nn.1
  guldpressning_1_N = mkN "guldpressning" ; -- guldpressning..nn.1
  guldpris_1_N = mkN "guldpris" neutrum  ; -- guldpris..nn.1
  guldprov_1_N = mkN "guldprov" neutrum  ; -- guldprov..nn.1
  guldpunkt_1_N = mkN "guldpunkt" ; -- guldpunkt..nn.1
  guldpärla_1_N = mkN "guldpärla" ; -- guldpärla..nn.1
  guldregn_1_N = mkN "guldregn" neutrum  ; -- guldregn..nn.1
  guldreserv_1_N = mkN "guldreserv" "guldreserver" ; -- guldreserv..nn.1
  guldrusch_1_N = mkN "guldrusch" "guldruscher" ; -- guldrusch..nn.1
  guldrush_1_N = mkN "guldrush" "guldrusher" ; -- guldrush..nn.1
  guldsand_1_N = mkN "guldsand" ; -- guldsand..nn.1
  guldskimrande_1_A = mkA "guldskimrande" ; -- guldskimrande..av.1
  guldslagare_1_N = mkN "guldslagare" utrum  ; -- guldslagare..nn.1
  guldslageri_1_N = mkN "guldslageri" "guldslageriet" "guldslagerier" "guldslagerierna" ; -- guldslageri..nn.1
  guldsmed_1_N = mkN "guldsmed" "guldsmeder" ; -- guldsmed..nn.1
  guldsmidd_1_A = mkA "guldsmidd" ; -- guldsmidd..av.1
  guldsmide_1_N = mkN "guldsmide" ; -- guldsmide..nn.1
  guldsnitt_1_N = mkN "guldsnitt" neutrum  ; -- guldsnitt..nn.1
  guldspade_1_N = mkN "guldspade" utrum  ; -- guldspade..nn.1
  guldspadejury_1_N = mkN "guldspadejury" "guldspadejuryer" ; -- guldspadejury..nn.1
  guldstandard_1_N = mkN "guldstandard" "guldstandarder" ; -- guldstandard..nn.1
  guldstekel_1_N = mkN "guldstekel" ; -- guldstekel..nn.1
  guldstickad_1_A = mkA "guldstickad" ; -- guldstickad..av.1
  guldstrid_1_N = mkN "guldstrid" "guldstrider" ; -- guldstrid..nn.1
  guldstämpel_1_N = mkN "guldstämpel" ; -- guldstämpel..nn.1
  guldtacka_1_N = mkN "guldtacka" ; -- guldtacka..nn.1
  guldtand_1_N = mkN "guldtand" "guldtänder" ; -- guldtand..nn.1
  guldtråd_1_N = mkN "guldtråd" ; -- guldtråd..nn.1
  guldtäckning_1_N = mkN "guldtäckning" ; -- guldtäckning..nn.1
  guldtändare_1_N = mkN "guldtändare" utrum  ; -- guldtändare..nn.1
  guldtörst_1_N = mkN "guldtörst" ; -- guldtörst..nn.1
  guldvaskning_1_N = mkN "guldvaskning" ; -- guldvaskning..nn.1
  guldvittring_1_N = mkN "guldvittring" ; -- guldvittring..nn.1
  guldvåg_1_N = mkN "guldvåg" ; -- guldvåg..nn.1
  guldäpple_1_N = mkN "guldäpple" ; -- guldäpple..nn.1
  guldålder_1_N = mkN "guldålder" ; -- guldålder..nn.1
  guldörhänge_1_N = mkN "guldörhänge" ; -- guldörhänge..nn.1
  gulesäck_1_N = mkN "gulesäck" ; -- gulesäck..nn.1
  gulfilter_1_N = mkN "gulfilter" neutrum  ; -- gulfilter..nn.1
  gulfärga_1_V = mkV "gulfärgar" ; -- gulfärga..vb.1
  gulfärgad_1_A = mkA "gulfärgad" ; -- gulfärgad..av.1
  gulfärgande_1_N = mkN "gulfärgande" ; -- gulfärgande..nn.1
  gulfärgning_1_N = mkN "gulfärgning" ; -- gulfärgning..nn.1
  gulgrå_1_A = mkA "gulgrå" "gulgrått" ; -- gulgrå..av.1
  gulgrön_1_A = mkA "gulgrön" ; -- gulgrön..av.1
  guling_1_N = mkN "guling" ; -- guling..nn.1
  gulkropp_1_N = mkN "gulkropp" ; -- gulkropp..nn.1
  gull_1_N = mkN "gull" neutrum  ; -- gull..nn.1
  gulla_1_V = mkV "gullar" ; -- gulla..vb.1
  gullande_1_N = mkN "gullande" ; -- gullande..nn.1
  gullebrand_1_N = mkN "gullebrand" ; -- gullebrand..nn.1
  gullegris_1_N = mkN "gullegris" ; -- gullegris..nn.1
  gulleplutt_1_N = mkN "gulleplutt" ; -- gulleplutt..nn.1
  gullgosse_1_N = mkN "gullgosse" utrum  ; -- gullgosse..nn.1
  gullgris_1_N = mkN "gullgris" ; -- gullgris..nn.1
  gullhöna_1_N = mkN "gullhöna" ; -- gullhöna..nn.1
  gullig_1_A = mkA "gullig" ; -- gullig..av.1
  gullighet_1_N = mkN "gullighet" "gulligheter" ; -- gullighet..nn.1
  gullpudra_1_N = mkN "gullpudra" ; -- gullpudra..nn.1
  gullregn_1_N = mkN "gullregn" neutrum  ; -- gullregn..nn.1
  gullris_1_N = mkN "gullris" neutrum  ; -- gullris..nn.1
  gulltrav_1_N = mkN "gulltrav" ; -- gulltrav..nn.1
  gullviva_1_N = mkN "gullviva" ; -- gullviva..nn.1
  gulmetall_1_N = mkN "gulmetall" ; -- gulmetall..nn.1
  gulmålad_1_A = mkA "gulmålad" ; -- gulmålad..av.1
  gulmåra_1_N = mkN "gulmåra" ; -- gulmåra..nn.1
  gulna_1_V = mkV "gulnar" ; -- gulna..vb.1
  gulnad_1_N = mkN "gulnad" "gulnader" ; -- gulnad..nn.1
  gulnande_1_N = mkN "gulnande" ; -- gulnande..nn.1
  gulning_1_N = mkN "gulning" ; -- gulning..nn.1
  gulockra_1_N = mkN "gulockra" ; -- gulockra..nn.1
  gulorange_1_A = mkA "gulorange" "guloranget" ; -- gulorange..av.1
  gulrutig_1_A = mkA "gulrutig" ; -- gulrutig..av.1
  gulröd_1_A = mkA "gulröd" "gulrött" ; -- gulröd..av.1
  gulsiktig_1_A = mkA "gulsiktig" ; -- gulsiktig..av.1
  gulsiktighet_1_N = mkN "gulsiktighet" ; -- gulsiktighet..nn.1
  gulsippa_1_N = mkN "gulsippa" ; -- gulsippa..nn.1
  gulskiva_1_N = mkN "gulskiva" ; -- gulskiva..nn.1
  gulsot_1_N = mkN "gulsot" ; -- gulsot..nn.1
  gulsparv_1_N = mkN "gulsparv" ; -- gulsparv..nn.1
  gulsporre_1_N = mkN "gulsporre" utrum  ; -- gulsporre..nn.1
  gulsvart_1_A = mkA "gulsvart" "gulsvart" ; -- gulsvart..av.1
  gulsäck_1_N = mkN "gulsäck" ; -- gulsäck..nn.1
  gultörne_1_N = mkN "gultörne" ; -- gultörne..nn.1
  gulvial_1_N = mkN "gulvial" ; -- gulvial..nn.1
  gulvit_1_A = mkA "gulvit" ; -- gulvit..av.1
  gulärla_1_N = mkN "gulärla" ; -- gulärla..nn.1
  gumma_1_N = mkN "gumma" ; -- gumma..nn.1
  gummera_1_V = mkV "gummerar" ; -- gummera..vb.1
  gummerande_1_N = mkN "gummerande" ; -- gummerande..nn.1
  gummerbar_1_A = mkA "gummerbar" ; -- gummerbar..av.1
  gummerbarhet_1_N = mkN "gummerbarhet" ; -- gummerbarhet..nn.1
  gummering_1_N = mkN "gummering" ; -- gummering..nn.1
  gummi_1_N = mkN "gummi" "gummit" "gummin" "gummina" ; -- gummi..nn.1
  gummiasfalt_1_N = mkN "gummiasfalt" ; -- gummiasfalt..nn.1
  gummiband_1_N = mkN "gummiband" neutrum  ; -- gummiband..nn.1
  gummibeklädd_1_A = mkA "gummibeklädd" ; -- gummibeklädd..av.1
  gummiboll_1_N = mkN "gummiboll" ; -- gummiboll..nn.1
  gummibåt_1_N = mkN "gummibåt" ; -- gummibåt..nn.1
  gummidäck_1_N = mkN "gummidäck" neutrum  ; -- gummidäck..nn.1
  gummigutta_1_N = mkN "gummigutta" ; -- gummigutta..nn.1
  gummihandske_1_N = mkN "gummihandske" utrum  ; -- gummihandske..nn.1
  gummiharts_1_N = mkN "gummiharts" "gummihartset" "gummihartser" "gummihartserna" ; -- gummiharts..nn.1
  gummihjul_1_N = mkN "gummihjul" neutrum  ; -- gummihjul..nn.1
  gummikabel_1_N = mkN "gummikabel" ; -- gummikabel..nn.1
  gummilag_1_N = mkN "gummilag" ; -- gummilag..nn.1
  gummilist_1_N = mkN "gummilist" "gummilister" ; -- gummilist..nn.1
  gummimaterial_1_N = mkN "gummimaterial" neutrum  ; -- gummimaterial..nn.1
  gummiparagraf_1_N = mkN "gummiparagraf" "gummiparagrafer" ; -- gummiparagraf..nn.1
  gummipigg_1_N = mkN "gummipigg" ; -- gummipigg..nn.1
  gummiplantage_1_N = mkN "gummiplantage" "gummiplantager" ; -- gummiplantage..nn.1
  gummiplatta_1_N = mkN "gummiplatta" ; -- gummiplatta..nn.1
  gummipropp_1_N = mkN "gummipropp" ; -- gummipropp..nn.1
  gummiräfflad_1_A = mkA "gummiräfflad" ; -- gummiräfflad..av.1
  gummiskydd_1_N = mkN "gummiskydd" neutrum  ; -- gummiskydd..nn.1
  gummislang_1_N = mkN "gummislang" ; -- gummislang..nn.1
  gummislägga_1_N = mkN "gummislägga" ; -- gummislägga..nn.1
  gummisnodd_1_N = mkN "gummisnodd" ; -- gummisnodd..nn.1
  gummistövel_1_N = mkN "gummistövel" ; -- gummistövel..nn.1
  gummiträd_1_N = mkN "gummiträd" neutrum  ; -- gummiträd..nn.1
  gummös_1_A = mkA "gummös" ; -- gummös..av.1
  gump_1_N = mkN "gump" ; -- gump..nn.1
  gumpa_1_V = mkV "gumpar" ; -- gumpa..vb.1
  gumpande_1_N = mkN "gumpande" ; -- gumpande..nn.1
  gumphöna_1_N = mkN "gumphöna" ; -- gumphöna..nn.1
  gumpkörtel_1_N = mkN "gumpkörtel" ; -- gumpkörtel..nn.1
  gumse_1_N = mkN "gumse" utrum  ; -- gumse..nn.1
  gung_1_N = mkN "gung" neutrum  ; -- gung..nn.1
  gunga_1_N = mkN "gunga" ; -- gunga..nn.1
  gunga_1_V = mkV "gungar" ; -- gunga..vb.1
  gunga_2_V = mkV "gungar" ; -- gunga..vb.2
  gungande_1_N = mkN "gungande" ; -- gungande..nn.1
  gungbräda_1_N = mkN "gungbräda" ; -- gungbräda..nn.1
  gungbräde_1_N = mkN "gungbräde" ; -- gungbräde..nn.1
  gungfly_1_N = mkN "gungfly" "gungflyet" "gungflyn" "gungflyna" ; -- gungfly..nn.1
  gunghäst_1_N = mkN "gunghäst" ; -- gunghäst..nn.1
  gungig_1_A = mkA "gungig" ; -- gungig..av.1
  gungighet_1_N = mkN "gungighet" ; -- gungighet..nn.1
  gungning_1_N = mkN "gungning" ; -- gungning..nn.1
  gungstol_1_N = mkN "gungstol" ; -- gungstol..nn.1
  gungställning_1_N = mkN "gungställning" ; -- gungställning..nn.1
  gunrum_1_N = mkN "gunrum" "gunrummet" "gunrum" "gunrummen" ; -- gunrum..nn.1
  gunst_1_N = mkN "gunst" "gunster" ; -- gunst..nn.1
  gunstbenägen_1_A = mkA "gunstbenägen" ; -- gunstbenägen..av.1
  gunstbenägenhet_1_N = mkN "gunstbenägenhet" ; -- gunstbenägenhet..nn.1
  gunstbevis_1_N = mkN "gunstbevis" neutrum  ; -- gunstbevis..nn.1
  gunstig_1_A = mkA "gunstig" ; -- gunstig..av.1
  gunstighet_1_N = mkN "gunstighet" ; -- gunstighet..nn.1
  gunstling_1_N = mkN "gunstling" ; -- gunstling..nn.1
  gunstlingssystem_1_N = mkN "gunstlingssystem" neutrum  ; -- gunstlingssystem..nn.1
  gupp_1_N = mkN "gupp" neutrum  ; -- gupp..nn.1
  guppa_1_V = mkV "guppar" ; -- guppa..vb.1
  guppande_1_N = mkN "guppande" ; -- guppande..nn.1
  guppig_1_A = mkA "guppig" ; -- guppig..av.1
  guppighet_1_N = mkN "guppighet" ; -- guppighet..nn.1
  guppning_1_N = mkN "guppning" ; -- guppning..nn.1
  guppy_1_N = mkN "guppy" "guppyn" "guppysar" "guppysarna" ; -- guppy..nn.1
  gura_1_N = mkN "gura" ; -- gura..nn.1
  gurami_1_N = mkN "gurami" "guramin" "guramier" "guramierna" ; -- gurami..nn.1
  gurgel_1_N = mkN "gurgel" neutrum  ; -- gurgel..nn.1
  gurgelvatten_1_N = mkN "gurgelvatten" "gurgelvattnet" "gurgelvatten" "gurgelvattnen" ; -- gurgelvatten..nn.1
  gurgla_1_V = mkV "gurglar" ; -- gurgla..vb.1
  gurgla_2_V = mkV "gurglar" ; -- gurgla..vb.2
  gurglande_1_N = mkN "gurglande" ; -- gurglande..nn.1
  gurgling_1_N = mkN "gurgling" ; -- gurgling..nn.1
  gurka_1_N = mkN "gurka" ; -- gurka..nn.1
  gurkha_1_N = mkN "gurkha" ; -- gurkha..nn.1
  gurklist_1_N = mkN "gurklist" "gurklister" ; -- gurklist..nn.1
  gurkmeja_1_N = mkN "gurkmeja" ; -- gurkmeja..nn.1
  gurkmejpapper_1_N = mkN "gurkmejpapper" neutrum  ; -- gurkmejpapper..nn.1
  gurkskiva_1_N = mkN "gurkskiva" ; -- gurkskiva..nn.1
  gurkstav_1_N = mkN "gurkstav" ; -- gurkstav..nn.1
  gurkväxt_1_N = mkN "gurkväxt" "gurkväxter" ; -- gurkväxt..nn.1
  guru_1_N = mkN "guru" "gurun" "gurus" "gurusarna" ; -- guru..nn.1
  guska_1_V = mkV "guskar" ; -- guska..vb.1
  guskande_1_N = mkN "guskande" ; -- guskande..nn.1
  guss_1_N = mkN "guss" ; -- guss..nn.1
  gustavadolfsbakelse_1_N = mkN "gustavadolfsbakelse" "gustavadolfsbakelser" ; -- gustavadolfsbakelse..nn.1
  gustavian_1_N = mkN "gustavian" "gustavianer" ; -- gustavian..nn.1
  gustaviansk_1_A = mkA "gustaviansk" ; -- gustaviansk..av.1
  gut_1_N = mkN "gut" ; -- gut..nn.1
  gute_1_N = mkN "gute" utrum  ; -- gute..nn.1
  gutera_1_V = mkV "guterar" ; -- gutera..vb.1
  guterande_1_N = mkN "guterande" ; -- guterande..nn.1
  guterbar_1_A = mkA "guterbar" ; -- guterbar..av.1
  guterbarhet_1_N = mkN "guterbarhet" ; -- guterbarhet..nn.1
  gutering_1_N = mkN "gutering" ; -- gutering..nn.1
  gutnisk_1_A = mkA "gutnisk" ; -- gutnisk..av.1
  gutniska_1_N = mkN "gutniska" ; -- gutniska..nn.1
  gutt_1_N = mkN "gutt" ; -- gutt..nn.1
  guttaperka_1_N = mkN "guttaperka" ; -- guttaperka..nn.1
  guttural_1_A = mkA "guttural" ; -- guttural..av.1
  guttural_1_N = mkN "guttural" "gutturaler" ; -- guttural..nn.1
  guvernant_1_N = mkN "guvernant" "guvernanter" ; -- guvernant..nn.1
  guvernement_1_N = mkN "guvernement" neutrum  ; -- guvernement..nn.1
  guvernör_1_N = mkN "guvernör" "guvernörer" ; -- guvernör..nn.1
  guvernörsval_1_N = mkN "guvernörsval" neutrum  ; -- guvernörsval..nn.1
  guyanan_1_N = mkN "guyanan" "guyananer" ; -- guyanan..nn.1
  guyanansk_1_A = mkA "guyanansk" ; -- guyanansk..av.1
  guyananska_1_N = mkN "guyananska" ; -- guyananska..nn.1
  guzz_1_N = mkN "guzz" ; -- guzz..nn.1
  gyckel_1_N = mkN "gyckel" neutrum  ; -- gyckel..nn.1
  gyckelbild_1_N = mkN "gyckelbild" "gyckelbilder" ; -- gyckelbild..nn.1
  gyckelspel_1_N = mkN "gyckelspel" "gyckelspelet" "gyckelspel" "gyckelspelen" ; -- gyckelspel..nn.1
  gyckla_1_V = mkV "gycklar" ; -- gyckla..vb.1
  gycklande_1_N = mkN "gycklande" ; -- gycklande..nn.1
  gycklare_1_N = mkN "gycklare" utrum  ; -- gycklare..nn.1
  gyckleri_1_N = mkN "gyckleri" "gyckleriet" "gycklerier" "gycklerierna" ; -- gyckleri..nn.1
  gydja_1_N = mkN "gydja" ; -- gydja..nn.1
  gylf_1_N = mkN "gylf" ; -- gylf..nn.1
  gylfputande_1_A = mkA "gylfputande" ; -- gylfputande..av.1
  gyllen_1_N = mkN "gyllen" neutrum  ; -- gyllen..nn.1
  gyllen_2_N = mkN "gyllen" "gyllenen" "gyllen" "gyllenen" ; -- gyllen..nn.2
  gyllen_3_N = mkN "gyllen" "gyllen" "gyllen" "gyllena" ; -- gyllen..nn.3
  gyllenbrun_1_A = mkA "gyllenbrun" ; -- gyllenbrun..av.1
  gyllenduk_1_N = mkN "gyllenduk" ; -- gyllenduk..nn.1
  gyllene_1_A = mkA "gyllene" ; -- gyllene..av.1
  gyllenglänsande_1_A = mkA "gyllenglänsande" ; -- gyllenglänsande..av.1
  gyllengul_1_A = mkA "gyllengul" ; -- gyllengul..av.1
  gyllenkläde_1_N = mkN "gyllenkläde" ; -- gyllenkläde..nn.1
  gyllenlack_1_N = mkN "gyllenlack" ; -- gyllenlack..nn.1
  gyllenläder_1_N = mkN "gyllenläder" neutrum  ; -- gyllenläder..nn.1
  gyllental_1_N = mkN "gyllental" neutrum  ; -- gyllental..nn.1
  gylling_1_N = mkN "gylling" ; -- gylling..nn.1
  gyllne_1_A = mkA "gyllne" ; -- gyllne..av.1
  gylta_1_N = mkN "gylta" ; -- gylta..nn.1
  gym_1_N = mkN "gym" neutrum  ; -- gym..nn.1
  gymkort_1_N = mkN "gymkort" neutrum  ; -- gymkort..nn.1
  gymm_1_N = mkN "gymm" neutrum  ; -- gymm..nn.1
  gymnasial_1_A = mkA "gymnasial" ; -- gymnasial..av.1
  gymnasieekonom_1_N = mkN "gymnasieekonom" "gymnasieekonomer" ; -- gymnasieekonom..nn.1
  gymnasieingenjör_1_N = mkN "gymnasieingenjör" "gymnasieingenjörer" ; -- gymnasieingenjör..nn.1
  gymnasieinspektör_1_N = mkN "gymnasieinspektör" "gymnasieinspektörer" ; -- gymnasieinspektör..nn.1
  gymnasielinje_1_N = mkN "gymnasielinje" "gymnasielinjer" ; -- gymnasielinje..nn.1
  gymnasielärare_1_N = mkN "gymnasielärare" utrum  ; -- gymnasielärare..nn.1
  gymnasieskola_1_N = mkN "gymnasieskola" ; -- gymnasieskola..nn.1
  gymnasieutbildning_1_N = mkN "gymnasieutbildning" ; -- gymnasieutbildning..nn.1
  gymnasieval_1_N = mkN "gymnasieval" neutrum  ; -- gymnasieval..nn.1
  gymnasist_1_N = mkN "gymnasist" "gymnasister" ; -- gymnasist..nn.1
  gymnasium_1_N = mkN "gymnasium" "gymnasiet" "gymnasier" "gymnasierna" ; -- gymnasium..nn.1
  gymnast_1_N = mkN "gymnast" "gymnaster" ; -- gymnast..nn.1
  gymnastik_1_N = mkN "gymnastik" ; -- gymnastik..nn.1
  gymnastikdirektör_1_N = mkN "gymnastikdirektör" "gymnastikdirektörer" ; -- gymnastikdirektör..nn.1
  gymnastikdräkt_1_N = mkN "gymnastikdräkt" "gymnastikdräkter" ; -- gymnastikdräkt..nn.1
  gymnastikhopp_1_N = mkN "gymnastikhopp" neutrum  ; -- gymnastikhopp..nn.1
  gymnastikhus_1_N = mkN "gymnastikhus" neutrum  ; -- gymnastikhus..nn.1
  gymnastiklektion_1_N = mkN "gymnastiklektion" ; -- gymnastiklektion..nn.1
  gymnastikredskap_1_N = mkN "gymnastikredskap" neutrum  ; -- gymnastikredskap..nn.1
  gymnastiksal_1_N = mkN "gymnastiksal" ; -- gymnastiksal..nn.1
  gymnastiksko_1_N = mkN "gymnastiksko" "gymnastikskor" ; -- gymnastiksko..nn.1
  gymnastiktimme_1_N = mkN "gymnastiktimme" utrum  ; -- gymnastiktimme..nn.1
  gymnastisera_1_V = mkV "gymnastiserar" ; -- gymnastisera..vb.1
  gymnastiserad_1_A = mkA "gymnastiserad" ; -- gymnastiserad..av.1
  gymnastiserande_1_N = mkN "gymnastiserande" ; -- gymnastiserande..nn.1
  gymnastiserbar_1_A = mkA "gymnastiserbar" ; -- gymnastiserbar..av.1
  gymnastiserbarhet_1_N = mkN "gymnastiserbarhet" ; -- gymnastiserbarhet..nn.1
  gymnastisering_1_N = mkN "gymnastisering" ; -- gymnastisering..nn.1
  gymnastisk_1_A = mkA "gymnastisk" ; -- gymnastisk..av.1
  gymnisk_1_A = mkA "gymnisk" ; -- gymnisk..av.1
  gymnosperm_1_N = mkN "gymnosperm" "gymnospermer" ; -- gymnosperm..nn.1
  gympa_1_N = mkN "gympa" ; -- gympa..nn.1
  gympa_1_V = mkV "gympar" ; -- gympa..vb.1
  gympande_1_N = mkN "gympande" ; -- gympande..nn.1
  gympapåse_1_N = mkN "gympapåse" utrum  ; -- gympapåse..nn.1
  gympasko_1_N = mkN "gympasko" "gympaskor" ; -- gympasko..nn.1
  gymping_1_N = mkN "gymping" ; -- gymping..nn.1
  gynekolog_1_N = mkN "gynekolog" "gynekologer" ; -- gynekolog..nn.1
  gynekologi_1_N = mkN "gynekologi" ; -- gynekologi..nn.1
  gynekologisk_1_A = mkA "gynekologisk" ; -- gynekologisk..av.1
  gynna_1_V = mkV "gynnar" ; -- gynna..vb.1
  gynnande_1_N = mkN "gynnande" ; -- gynnande..nn.1
  gynnare_1_N = mkN "gynnare" utrum  ; -- gynnare..nn.1
  gynnsam_1_A = mkA "gynnsam" "gynnsamt" "gynnsamma" "gynnsamma" "gynnsammare" "gynnsammast" "gynnsammaste" ; -- gynnsam..av.1
  gynnsamhet_1_N = mkN "gynnsamhet" ; -- gynnsamhet..nn.1
  gyro_1_N = mkN "gyro" "gyrot" "gyron" "gyrona" ; -- gyro..nn.1
  gyrohorisont_1_N = mkN "gyrohorisont" "gyrohorisonter" ; -- gyrohorisont..nn.1
  gyrokompass_1_N = mkN "gyrokompass" "gyrokompasser" ; -- gyrokompass..nn.1
  gyroprincip_1_N = mkN "gyroprincip" ; -- gyroprincip..nn.1
  gyroskop_1_N = mkN "gyroskop" neutrum  ; -- gyroskop..nn.1
  gyroskopkompass_1_N = mkN "gyroskopkompass" "gyroskopkompasser" ; -- gyroskopkompass..nn.1
  gyrostabilisator_1_N = mkN "gyrostabilisator" "gyrostabilisatorer" ; -- gyrostabilisator..nn.1
  gytter_1_N = mkN "gytter" neutrum  ; -- gytter..nn.1
  gyttja_1_N = mkN "gyttja" ; -- gyttja..nn.1
  gyttjebad_1_N = mkN "gyttjebad" neutrum  ; -- gyttjebad..nn.1
  gyttjig_1_A = mkA "gyttjig" ; -- gyttjig..av.1
  gyttjighet_1_N = mkN "gyttjighet" ; -- gyttjighet..nn.1
  gyttra_1_V = mkV "gyttrar" ; -- gyttra..vb.1
  gyttrande_1_N = mkN "gyttrande" ; -- gyttrande..nn.1
  gyttrig_1_A = mkA "gyttrig" ; -- gyttrig..av.1
  gyttrighet_1_N = mkN "gyttrighet" ; -- gyttrighet..nn.1
  gyttring_1_N = mkN "gyttring" ; -- gyttring..nn.1
  gäcka_1_V = mkV "gäckar" ; -- gäcka..vb.1
  gäckande_1_N = mkN "gäckande" ; -- gäckande..nn.1
  gäckeri_1_N = mkN "gäckeri" "gäckeriet" "gäckerier" "gäckerierna" ; -- gäckeri..nn.1
  gäckmast_1_N = mkN "gäckmast" "gäckmaster" ; -- gäckmast..nn.1
  gäcksam_1_A = mkA "gäcksam" "gäcksamt" "gäcksamma" "gäcksamma" "gäcksammare" "gäcksammast" "gäcksammaste" ; -- gäcksam..av.1
  gäcksamhet_1_N = mkN "gäcksamhet" ; -- gäcksamhet..nn.1
  gädda_1_N = mkN "gädda" ; -- gädda..nn.1
  gäddhäng_1_N = mkN "gäddhäng" neutrum  ; -- gäddhäng..nn.1
  gäddnate_1_N = mkN "gäddnate" utrum  ; -- gäddnate..nn.1
  gäddsax_1_N = mkN "gäddsax" ; -- gäddsax..nn.1
  gäl_1_N = mkN "gäl" ; -- gäl..nn.1
  gäl_2_N = mkN "gäl" "gäler" ; -- gäl..nn.2
  gäla_1_V = mkV "gälar" ; -- gäla..vb.1
  gälande_1_N = mkN "gälande" ; -- gälande..nn.1
  gälbgjutare_1_N = mkN "gälbgjutare" utrum  ; -- gälbgjutare..nn.1
  gälbgjuteri_1_N = mkN "gälbgjuteri" "gälbgjuteriet" "gälbgjuterier" "gälbgjuterierna" ; -- gälbgjuteri..nn.1
  gälblad_1_N = mkN "gälblad" neutrum  ; -- gälblad..nn.1
  gälbåge_1_N = mkN "gälbåge" utrum  ; -- gälbåge..nn.1
  gäld_1_N = mkN "gäld" ; -- gäld..nn.1
  gälda_1_V = mkV "gäldar" ; -- gälda..vb.1
  gäldande_1_N = mkN "gäldande" ; -- gäldande..nn.1
  gäldbunden_1_A = mkA "gäldbunden" ; -- gäldbunden..av.1
  gäldenär_1_N = mkN "gäldenär" "gäldenärer" ; -- gäldenär..nn.1
  gäldfri_1_A = mkA "gäldfri" "gäldfritt" ; -- gäldfri..av.1
  gäldstuga_1_N = mkN "gäldstuga" ; -- gäldstuga..nn.1
  gälisk_1_A = mkA "gälisk" ; -- gälisk..av.1
  gäliska_1_N = mkN "gäliska" ; -- gäliska..nn.1
  gäliska_2_N = mkN "gäliska" ; -- gäliska..nn.2
  gäll_1_A = mkA "gäll" ; -- gäll..av.1
  gälla_1_V = mkV "gäller" ; -- gälla..vb.1
  gälla_2_V = mkV "gäller" ; -- gälla..vb.2
  gällande_1_N = mkN "gällande" ; -- gällande..nn.1
  gällen_1_A = mkA "gällen" ; -- gällen..av.1
  gällenhet_1_N = mkN "gällenhet" ; -- gällenhet..nn.1
  gällhet_1_N = mkN "gällhet" ; -- gällhet..nn.1
  gällivarehäng_1_N = mkN "gällivarehäng" neutrum  ; -- gällivarehäng..nn.1
  gälspringa_1_N = mkN "gälspringa" ; -- gälspringa..nn.1
  gäms_1_N = mkN "gäms" "gämser" ; -- gäms..nn.1
  gäng_1_N = mkN "gäng" neutrum  ; -- gäng..nn.1
  gänga_1_N = mkN "gänga" ; -- gänga..nn.1
  gänga_1_V = mkV "gängar" ; -- gänga..vb.1
  gängad_1_A = mkA "gängad" ; -- gängad..av.1
  gängande_1_N = mkN "gängande" ; -- gängande..nn.1
  gängback_1_N = mkN "gängback" ; -- gängback..nn.1
  gänge_1_N = mkN "gänge" ; -- gänge..nn.1
  gänginsats_1_N = mkN "gänginsats" "gänginsatser" ; -- gänginsats..nn.1
  gängkloppa_1_N = mkN "gängkloppa" ; -- gängkloppa..nn.1
  gängkrig_1_N = mkN "gängkrig" neutrum  ; -- gängkrig..nn.1
  gängledare_1_N = mkN "gängledare" utrum  ; -- gängledare..nn.1
  gänglig_1_A = mkA "gänglig" ; -- gänglig..av.1
  gänglighet_1_N = mkN "gänglighet" ; -- gänglighet..nn.1
  gängmedlem_1_N = mkN "gängmedlem" "gängmedlemmen" "gängmedlemmar" "gängmedlemmarna" ; -- gängmedlem..nn.1
  gängning_1_N = mkN "gängning" ; -- gängning..nn.1
  gängse_1_A = mkA "gängse" ; -- gängse..av.1
  gängstål_1_N = mkN "gängstål" neutrum  ; -- gängstål..nn.1
  gängtapp_1_N = mkN "gängtapp" ; -- gängtapp..nn.1
  gängtappshållare_1_N = mkN "gängtappshållare" utrum  ; -- gängtappshållare..nn.1
  gängtatuering_1_N = mkN "gängtatuering" ; -- gängtatuering..nn.1
  gängtolk_1_N = mkN "gängtolk" ; -- gängtolk..nn.1
  gängverktyg_1_N = mkN "gängverktyg" neutrum  ; -- gängverktyg..nn.1
  gängverktygssats_1_N = mkN "gängverktygssats" "gängverktygssatser" ; -- gängverktygssats..nn.1
  gärd_1_N = mkN "gärd" "gärder" ; -- gärd..nn.1
  gärda_1_V = mkV "gärdar" ; -- gärda..vb.1
  gärdande_1_N = mkN "gärdande" ; -- gärdande..nn.1
  gärde_1_N = mkN "gärde" ; -- gärde..nn.1
  gärdesgård_1_N = mkN "gärdesgård" ; -- gärdesgård..nn.1
  gärdning_1_N = mkN "gärdning" ; -- gärdning..nn.1
  gärdsel_1_N = mkN "gärdsel" neutrum  ; -- gärdsel..nn.1
  gärdsgård_1_N = mkN "gärdsgård" ; -- gärdsgård..nn.1
  gärdsgårdsstör_1_N = mkN "gärdsgårdsstör" ; -- gärdsgårdsstör..nn.1
  gärdsla_1_V = mkV "gärdslar" ; -- gärdsla..vb.1
  gärdslande_1_N = mkN "gärdslande" ; -- gärdslande..nn.1
  gärdsle_1_N = mkN "gärdsle" ; -- gärdsle..nn.1
  gärdsmyg_1_N = mkN "gärdsmyg" ; -- gärdsmyg..nn.1
  gärna_1_Adv = mkAdv "gärna" ; -- gärna..ab.1
  gärning_1_N = mkN "gärning" ; -- gärning..nn.1
  gärningslära_1_N = mkN "gärningslära" ; -- gärningslära..nn.1
  gärningsman_1_N = mkN "gärningsman" "gärningsmannen" "gärningsmän" "gärningsmännen" ; -- gärningsman..nn.1
  gärningsmannaprofil_1_N = mkN "gärningsmannaprofil" "gärningsmannaprofiler" ; -- gärningsmannaprofil..nn.1
  gärningsmannaprofilgrupp_1_N = mkN "gärningsmannaprofilgrupp" "gärningsmannaprofilgrupper" ; -- gärningsmannaprofilgrupp..nn.1
  gärningsort_1_N = mkN "gärningsort" "gärningsorter" ; -- gärningsort..nn.1
  gärningsperson_1_N = mkN "gärningsperson" "gärningspersoner" ; -- gärningsperson..nn.1
  gärs_1_N = mkN "gärs" ; -- gärs..nn.1
  gäsp_1_N = mkN "gäsp" neutrum  ; -- gäsp..nn.1
  gäspa_1_V = mkV "gäspar" ; -- gäspa..vb.1
  gäspande_1_N = mkN "gäspande" ; -- gäspande..nn.1
  gäspig_1_A = mkA "gäspig" ; -- gäspig..av.1
  gäspighet_1_N = mkN "gäspighet" ; -- gäspighet..nn.1
  gäspning_1_N = mkN "gäspning" ; -- gäspning..nn.1
  gässling_1_N = mkN "gässling" ; -- gässling..nn.1
  gäst_1_N = mkN "gäst" "gäster" ; -- gäst..nn.1
  gästa_1_V = mkV "gästar" ; -- gästa..vb.1
  gästabud_1_N = mkN "gästabud" neutrum  ; -- gästabud..nn.1
  gästande_1_N = mkN "gästande" ; -- gästande..nn.1
  gästarbetare_1_N = mkN "gästarbetare" utrum  ; -- gästarbetare..nn.1
  gästatom_1_N = mkN "gästatom" "gästatomer" ; -- gästatom..nn.1
  gästblogga_1_V = mkV "gästbloggar" ; -- gästblogga..vb.1
  gästbloggande_1_N = mkN "gästbloggande" ; -- gästbloggande..nn.1
  gästbloggare_1_N = mkN "gästbloggare" utrum  ; -- gästbloggare..nn.1
  gästbloggning_1_N = mkN "gästbloggning" ; -- gästbloggning..nn.1
  gästbok_1_N = mkN "gästbok" "gästböcker" ; -- gästbok..nn.1
  gästflagga_1_N = mkN "gästflagga" ; -- gästflagga..nn.1
  gästforskare_1_N = mkN "gästforskare" utrum  ; -- gästforskare..nn.1
  gästfri_1_A = mkA "gästfri" "gästfritt" ; -- gästfri..av.1
  gästfrihet_1_N = mkN "gästfrihet" ; -- gästfrihet..nn.1
  gästfrihetsstrategi_1_N = mkN "gästfrihetsstrategi" "gästfrihetsstrategier" ; -- gästfrihetsstrategi..nn.1
  gästgivare_1_N = mkN "gästgivare" utrum  ; -- gästgivare..nn.1
  gästgivargård_1_N = mkN "gästgivargård" ; -- gästgivargård..nn.1
  gästgiveri_1_N = mkN "gästgiveri" "gästgiveriet" "gästgiverier" "gästgiverierna" ; -- gästgiveri..nn.1
  gästhandduk_1_N = mkN "gästhandduk" ; -- gästhandduk..nn.1
  gästkrönika_1_N = mkN "gästkrönika" ; -- gästkrönika..nn.1
  gästlista_1_N = mkN "gästlista" ; -- gästlista..nn.1
  gästmolekyl_1_N = mkN "gästmolekyl" "gästmolekyler" ; -- gästmolekyl..nn.1
  gästnatt_1_N = mkN "gästnatt" "gästnätter" ; -- gästnatt..nn.1
  gästning_1_N = mkN "gästning" ; -- gästning..nn.1
  gästrike_1_N = mkN "gästrike" utrum  ; -- gästrike..nn.1
  gästriking_1_N = mkN "gästriking" ; -- gästriking..nn.1
  gästrikländsk_1_A = mkA "gästrikländsk" ; -- gästrikländsk..av.1
  gästrikländska_1_N = mkN "gästrikländska" ; -- gästrikländska..nn.1
  gästriklänning_1_N = mkN "gästriklänning" ; -- gästriklänning..nn.1
  gästrikska_1_N = mkN "gästrikska" ; -- gästrikska..nn.1
  gästring_1_N = mkN "gästring" ; -- gästring..nn.1
  gästrisk_1_A = mkA "gästrisk" ; -- gästrisk..av.1
  gästroll_1_N = mkN "gästroll" "gästroller" ; -- gästroll..nn.1
  gästrum_1_N = mkN "gästrum" "gästrummet" "gästrum" "gästrummen" ; -- gästrum..nn.1
  gästrumsdörr_1_N = mkN "gästrumsdörr" ; -- gästrumsdörr..nn.1
  gästspel_1_N = mkN "gästspel" "gästspelet" "gästspel" "gästspelen" ; -- gästspel..nn.1
  gästspela_1_V = mkV "gästspelar" ; -- gästspela..vb.1
  gästspelande_1_N = mkN "gästspelande" ; -- gästspelande..nn.1
  gästvänlig_1_A = mkA "gästvänlig" ; -- gästvänlig..av.1
  gästvänlighet_1_N = mkN "gästvänlighet" ; -- gästvänlighet..nn.1
  gästvänskap_1_N = mkN "gästvänskap" ; -- gästvänskap..nn.1
  gävlebo_1_N = mkN "gävlebo" "gävlebor" ; -- gävlebo..nn.1
  gå_1_V = mkV "gå" "går" "gå" "gick" "gått" "gången" ; -- gå..vb.1
  gåbock_1_N = mkN "gåbock" ; -- gåbock..nn.1
  gåbortskostym_1_N = mkN "gåbortskostym" "gåbortskostymer" ; -- gåbortskostym..nn.1
  gående_1_N = mkN "gående" ; -- gående..nn.1
  gågata_1_N = mkN "gågata" ; -- gågata..nn.1
  gågosse_1_N = mkN "gågosse" utrum  ; -- gågosse..nn.1
  gåhjälpmedel_1_N = mkN "gåhjälpmedel" neutrum  ; -- gåhjälpmedel..nn.1
  gång_1_N = mkN "gång" ; -- gång..nn.1
  gång_2_N = mkN "gång" "gånger" ; -- gång..nn.2
  gång_3_N = mkN "gång" ; -- gång..nn.3
  gånga_1_V = mkV "gångar" ; -- gånga..vb.1
  gångande_1_N = mkN "gångande" ; -- gångande..nn.1
  gångare_1_N = mkN "gångare" utrum  ; -- gångare..nn.1
  gångart_1_N = mkN "gångart" "gångarter" ; -- gångart..nn.1
  gångavstånd_1_N = mkN "gångavstånd" neutrum  ; -- gångavstånd..nn.1
  gångbana_1_N = mkN "gångbana" ; -- gångbana..nn.1
  gångbar_1_A = mkA "gångbar" ; -- gångbar..av.1
  gångbarhet_1_N = mkN "gångbarhet" ; -- gångbarhet..nn.1
  gångbergart_1_N = mkN "gångbergart" "gångbergarter" ; -- gångbergart..nn.1
  gångbock_1_N = mkN "gångbock" ; -- gångbock..nn.1
  gångbord_1_N = mkN "gångbord" neutrum  ; -- gångbord..nn.1
  gångbro_1_N = mkN "gångbro" ; -- gångbro..nn.1
  gångfot_1_N = mkN "gångfot" "gångfötter" ; -- gångfot..nn.1
  gånggata_1_N = mkN "gånggata" ; -- gånggata..nn.1
  gånggrift_1_N = mkN "gånggrift" "gånggrifter" ; -- gånggrift..nn.1
  gånghjälpmedel_1_N = mkN "gånghjälpmedel" neutrum  ; -- gånghjälpmedel..nn.1
  gångjärn_1_N = mkN "gångjärn" neutrum  ; -- gångjärn..nn.1
  gångjärnsförsedd_1_A = mkA "gångjärnsförsedd" ; -- gångjärnsförsedd..av.1
  gångjärnshake_1_N = mkN "gångjärnshake" utrum  ; -- gångjärnshake..nn.1
  gångjärnsled_1_N = mkN "gångjärnsled" "gångjärnsleder" ; -- gångjärnsled..nn.1
  gångled_1_N = mkN "gångled" "gångleder" ; -- gångled..nn.1
  gånglåt_1_N = mkN "gånglåt" ; -- gånglåt..nn.1
  gångra_1_V = mkV "gångrar" ; -- gångra..vb.1
  gångrande_1_N = mkN "gångrande" ; -- gångrande..nn.1
  gångspel_1_N = mkN "gångspel" "gångspelet" "gångspel" "gångspelen" ; -- gångspel..nn.1
  gångsport_1_N = mkN "gångsport" ; -- gångsport..nn.1
  gångstig_1_N = mkN "gångstig" ; -- gångstig..nn.1
  gångstol_1_N = mkN "gångstol" ; -- gångstol..nn.1
  gångtrafikant_1_N = mkN "gångtrafikant" "gångtrafikanter" ; -- gångtrafikant..nn.1
  gångtunnel_1_N = mkN "gångtunnel" ; -- gångtunnel..nn.1
  gångtävling_1_N = mkN "gångtävling" ; -- gångtävling..nn.1
  gångväg_1_N = mkN "gångväg" ; -- gångväg..nn.1
  gåpåare_1_N = mkN "gåpåare" utrum  ; -- gåpåare..nn.1
  gåpåig_1_A = mkA "gåpåig" ; -- gåpåig..av.1
  gåpåighet_1_N = mkN "gåpåighet" ; -- gåpåighet..nn.1
  gård_1_N = mkN "gård" ; -- gård..nn.1
  gård_2_N = mkN "gård" ; -- gård..nn.2
  gårdag_1_N = mkN "gårdag" ; -- gårdag..nn.1
  gårdagskväll_1_N = mkN "gårdagskväll" ; -- gårdagskväll..nn.1
  gårdfarihandel_1_N = mkN "gårdfarihandel" ; -- gårdfarihandel..nn.1
  gårdfarihandlande_1_N = mkN "gårdfarihandlande" "gårdfarihandlanden" "gårdfarihandlanden" "gårdfarihandlandena" ; -- gårdfarihandlande..nn.1
  gårdfarihandlare_1_N = mkN "gårdfarihandlare" utrum  ; -- gårdfarihandlare..nn.1
  gårding_1_N = mkN "gårding" ; -- gårding..nn.1
  gårdsfolk_1_N = mkN "gårdsfolk" neutrum  ; -- gårdsfolk..nn.1
  gårdsförsäljning_1_N = mkN "gårdsförsäljning" ; -- gårdsförsäljning..nn.1
  gårdshus_1_N = mkN "gårdshus" neutrum  ; -- gårdshus..nn.1
  gårdskarl_1_N = mkN "gårdskarl" ; -- gårdskarl..nn.1
  gårdskulle_1_N = mkN "gårdskulle" utrum  ; -- gårdskulle..nn.1
  gårdslykta_1_N = mkN "gårdslykta" ; -- gårdslykta..nn.1
  gårdsmusikant_1_N = mkN "gårdsmusikant" "gårdsmusikanter" ; -- gårdsmusikant..nn.1
  gårdsområde_1_N = mkN "gårdsområde" ; -- gårdsområde..nn.1
  gårdsplan_1_N = mkN "gårdsplan" "gårdsplaner" ; -- gårdsplan..nn.1
  gårdsplats_1_N = mkN "gårdsplats" "gårdsplatser" ; -- gårdsplats..nn.1
  gårdsrum_1_N = mkN "gårdsrum" "gårdsrummet" "gårdsrum" "gårdsrummen" ; -- gårdsrum..nn.1
  gårdsstädning_1_N = mkN "gårdsstädning" ; -- gårdsstädning..nn.1
  gårdstomt_1_N = mkN "gårdstomt" "gårdstomter" ; -- gårdstomt..nn.1
  gårdsträd_1_N = mkN "gårdsträd" neutrum  ; -- gårdsträd..nn.1
  gårdvar_1_N = mkN "gårdvar" ; -- gårdvar..nn.1
  gås_1_N = mkN "gås" "gåsen" "gäss" "gässen" ; -- gås..nn.1
  gåsbröst_1_N = mkN "gåsbröst" neutrum  ; -- gåsbröst..nn.1
  gåse_1_N = mkN "gåse" utrum  ; -- gåse..nn.1
  gåsfjäder_1_N = mkN "gåsfjäder" ; -- gåsfjäder..nn.1
  gåsfot_1_N = mkN "gåsfot" "gåsfötter" ; -- gåsfot..nn.1
  gåshud_1_N = mkN "gåshud" ; -- gåshud..nn.1
  gåskarl_1_N = mkN "gåskarl" ; -- gåskarl..nn.1
  gåslever_1_N = mkN "gåslever" ; -- gåslever..nn.1
  gåsmarsch_1_N = mkN "gåsmarsch" ; -- gåsmarsch..nn.1
  gåspenna_1_N = mkN "gåspenna" ; -- gåspenna..nn.1
  gåstav_1_N = mkN "gåstav" ; -- gåstav..nn.1
  gåstol_1_N = mkN "gåstol" ; -- gåstol..nn.1
  gåsunge_1_N = mkN "gåsunge" utrum  ; -- gåsunge..nn.1
  gåsägg_1_N = mkN "gåsägg" neutrum  ; -- gåsägg..nn.1
  gåsört_1_N = mkN "gåsört" ; -- gåsört..nn.1
  gåt_1_N = mkN "gåt" ; -- gåt..nn.1
  gåta_1_N = mkN "gåta" ; -- gåta..nn.1
  gåtfull_1_A = mkA "gåtfull" ; -- gåtfull..av.1
  gåtfullhet_1_N = mkN "gåtfullhet" "gåtfullheter" ; -- gåtfullhet..nn.1
  gåva_1_N = mkN "gåva" ; -- gåva..nn.1
  gåvoavtal_1_N = mkN "gåvoavtal" neutrum  ; -- gåvoavtal..nn.1
  gåvobrev_1_N = mkN "gåvobrev" neutrum  ; -- gåvobrev..nn.1
  gåvodiplomati_1_N = mkN "gåvodiplomati" ; -- gåvodiplomati..nn.1
  gåvohandling_1_N = mkN "gåvohandling" ; -- gåvohandling..nn.1
  gåvoskatt_1_N = mkN "gåvoskatt" "gåvoskatter" ; -- gåvoskatt..nn.1
  gôtt_1_A = mkA "gôtt" ; -- gôtt..av.1
  göda_1_V = mkV "göda" "gödde" "gött" ; -- göda..vb.1
  gödande_1_N = mkN "gödande" ; -- gödande..nn.1
  gödboskap_1_N = mkN "gödboskap" ; -- gödboskap..nn.1
  gödd_1_A = mkA "gödd" ; -- gödd..av.1
  göddjur_1_N = mkN "göddjur" neutrum  ; -- göddjur..nn.1
  gödkyckling_1_N = mkN "gödkyckling" ; -- gödkyckling..nn.1
  gödning_1_N = mkN "gödning" ; -- gödning..nn.1
  gödningsmedel_1_N = mkN "gödningsmedel" neutrum  ; -- gödningsmedel..nn.1
  gödsel_1_N = mkN "gödsel" ; -- gödsel..nn.1
  gödselmedel_1_N = mkN "gödselmedel" neutrum  ; -- gödselmedel..nn.1
  gödselränna_1_N = mkN "gödselränna" ; -- gödselränna..nn.1
  gödselspridare_1_N = mkN "gödselspridare" utrum  ; -- gödselspridare..nn.1
  gödselstack_1_N = mkN "gödselstack" ; -- gödselstack..nn.1
  gödselstad_1_N = mkN "gödselstad" "gödselstäder" ; -- gödselstad..nn.1
  gödsla_1_V = mkV "gödslar" ; -- gödsla..vb.1
  gödslande_1_N = mkN "gödslande" ; -- gödslande..nn.1
  gödsling_1_N = mkN "gödsling" ; -- gödsling..nn.1
  göjemånad_1_N = mkN "göjemånad" "göjemånader" ; -- göjemånad..nn.1
  gök_1_N = mkN "gök" ; -- gök..nn.1
  göka_1_V = mkV "gökar" ; -- göka..vb.1
  gökande_1_N = mkN "gökande" ; -- gökande..nn.1
  gökblomma_1_N = mkN "gökblomma" ; -- gökblomma..nn.1
  gökblomster_1_N = mkN "gökblomster" neutrum  ; -- gökblomster..nn.1
  gökklocka_1_N = mkN "gökklocka" ; -- gökklocka..nn.1
  gökmat_1_N = mkN "gökmat" ; -- gökmat..nn.1
  gökotta_1_N = mkN "gökotta" ; -- gökotta..nn.1
  göktyta_1_N = mkN "göktyta" ; -- göktyta..nn.1
  gökunge_1_N = mkN "gökunge" utrum  ; -- gökunge..nn.1
  gökur_1_N = mkN "gökur" neutrum  ; -- gökur..nn.1
  gökärt_1_N = mkN "gökärt" ; -- gökärt..nn.1
  göl_1_N = mkN "göl" ; -- göl..nn.1
  göling_1_N = mkN "göling" ; -- göling..nn.1
  gömfröig_1_A = mkA "gömfröig" ; -- gömfröig..av.1
  gömma_1_N = mkN "gömma" ; -- gömma..nn.1
  gömma_1_V = mkV "gömmer" ; -- gömma..vb.1
  gömmande_1_N = mkN "gömmande" ; -- gömmande..nn.1
  gömme_1_N = mkN "gömme" ; -- gömme..nn.1
  gömsle_1_N = mkN "gömsle" ; -- gömsle..nn.1
  gömställe_1_N = mkN "gömställe" ; -- gömställe..nn.1
  göpen_1_N = mkN "göpen" "göpenn" "göpnar" "göpnarna" ; -- göpen..nn.1
  göra_1_V = mkV "göra" "gjorde" "gjort" ; -- göra..vb.1
  görande_1_N = mkN "görande" ; -- görande..nn.1
  görare_1_N = mkN "görare" utrum  ; -- görare..nn.1
  görbar_1_A = mkA "görbar" ; -- görbar..av.1
  görbarhet_1_N = mkN "görbarhet" ; -- görbarhet..nn.1
  gördel_1_N = mkN "gördel" ; -- gördel..nn.1
  gördelbåge_1_N = mkN "gördelbåge" utrum  ; -- gördelbåge..nn.1
  gördeldäck_1_N = mkN "gördeldäck" neutrum  ; -- gördeldäck..nn.1
  gördelfästning_1_N = mkN "gördelfästning" ; -- gördelfästning..nn.1
  gördelmakare_1_N = mkN "gördelmakare" utrum  ; -- gördelmakare..nn.1
  gördla_1_V = mkV "gördlar" ; -- gördla..vb.1
  gördlande_1_N = mkN "gördlande" ; -- gördlande..nn.1
  görlig_1_A = mkA "görlig" ; -- görlig..av.1
  görlighet_1_N = mkN "görlighet" ; -- görlighet..nn.1
  göromål_1_N = mkN "göromål" neutrum  ; -- göromål..nn.1
  gös_1_N = mkN "gös" ; -- gös..nn.1
  gösstake_1_N = mkN "gösstake" utrum  ; -- gösstake..nn.1
  göt_1_N = mkN "göt" ; -- göt..nn.1
  göt_2_N = mkN "göt" neutrum  ; -- göt..nn.2
  göt_3_N = mkN "göt" "göter" ; -- göt..nn.3
  götamål_1_N = mkN "götamål" neutrum  ; -- götamål..nn.1
  göte_1_N = mkN "göte" ; -- göte..nn.1
  göteborgare_1_N = mkN "göteborgare" utrum  ; -- göteborgare..nn.1
  göteborgsbaserad_1_A = mkA "göteborgsbaserad" ; -- göteborgsbaserad..av.1
  göteborgsk_1_A = mkA "göteborgsk" ; -- göteborgsk..av.1
  göteborgska_1_N = mkN "göteborgska" ; -- göteborgska..nn.1
  göteborgska_2_N = mkN "göteborgska" ; -- göteborgska..nn.2
  göteborgsvits_1_N = mkN "göteborgsvits" ; -- göteborgsvits..nn.1
  göticism_1_N = mkN "göticism" "göticismer" ; -- göticism..nn.1
  göticistisk_1_A = mkA "göticistisk" ; -- göticistisk..av.1
  götisk_1_A = mkA "götisk" ; -- götisk..av.1
  götmetall_1_N = mkN "götmetall" ; -- götmetall..nn.1
  gött_1_A = mkA "gött" ; -- gött..av.1
  gött_1_N = mkN "gött" ; -- gött..nn.1
  gött_2_N = mkN "gött" "göttet" "götter" "götterna" ; -- gött..nn.2
  götterdämmerung_1_N = mkN "götterdämmerung" ; -- götterdämmerung..nn.1
  götvalsverk_1_N = mkN "götvalsverk" neutrum  ; -- götvalsverk..nn.1
  habegär_1_N = mkN "habegär" neutrum  ; -- habegär..nn.1
  habil_1_A = mkA "habil" ; -- habil..av.1
  habilitering_1_N = mkN "habilitering" ; -- habilitering..nn.1
  habilitet_1_N = mkN "habilitet" "habiliteter" ; -- habilitet..nn.1
  habit_1_N = mkN "habit" "habiter" ; -- habit..nn.1
  habituell_1_A = mkA "habituell" ; -- habituell..av.1
  habitus_1_N = mkN "habitus" ; -- habitus..nn.1
  habitué_1_N = mkN "habitué" "habituéer" ; -- habitué..nn.1
  habsburgsk_1_A = mkA "habsburgsk" ; -- habsburgsk..av.1
  hack_1_N = mkN "hack" neutrum  ; -- hack..nn.1
  hacka_1_N = mkN "hacka" ; -- hacka..nn.1
  hacka_2_N = mkN "hacka" ; -- hacka..nn.2
  hacka_1_V = mkV "hackar" ; -- hacka..vb.1
  hackande_1_N = mkN "hackande" ; -- hackande..nn.1
  hackare_1_N = mkN "hackare" utrum  ; -- hackare..nn.1
  hackbräde_1_N = mkN "hackbräde" ; -- hackbräde..nn.1
  hackelse_1_N = mkN "hackelse" utrum  ; -- hackelse..nn.1
  hacker_1_N = mkN "hacker" "hackern" "hackers" "hackersarna" ; -- hacker..nn.1
  hackhosta_1_N = mkN "hackhosta" ; -- hackhosta..nn.1
  hackig_1_A = mkA "hackig" ; -- hackig..av.1
  hackighet_1_N = mkN "hackighet" ; -- hackighet..nn.1
  hackkniv_1_N = mkN "hackkniv" ; -- hackkniv..nn.1
  hackkorv_1_N = mkN "hackkorv" ; -- hackkorv..nn.1
  hackkyckling_1_N = mkN "hackkyckling" ; -- hackkyckling..nn.1
  hackmat_1_N = mkN "hackmat" ; -- hackmat..nn.1
  hackning_1_N = mkN "hackning" ; -- hackning..nn.1
  hackningsförsök_1_N = mkN "hackningsförsök" neutrum  ; -- hackningsförsök..nn.1
  hackordning_1_N = mkN "hackordning" ; -- hackordning..nn.1
  hackspett_1_N = mkN "hackspett" ; -- hackspett..nn.1
  hadeikum_1_N = mkN "hadeikum" ; -- hadeikum..nn.1
  haff_1_N = mkN "haff" "haffer" ; -- haff..nn.1
  haffa_1_V = mkV "haffar" ; -- haffa..vb.1
  haffande_1_N = mkN "haffande" ; -- haffande..nn.1
  hafnium_1_N = mkN "hafnium" neutrum  ; -- hafnium..nn.1
  hafs_1_N = mkN "hafs" neutrum  ; -- hafs..nn.1
  hafsa_1_V = mkV "hafsar" ; -- hafsa..vb.1
  hafsande_1_N = mkN "hafsande" ; -- hafsande..nn.1
  hafsig_1_A = mkA "hafsig" ; -- hafsig..av.1
  hafsighet_1_N = mkN "hafsighet" ; -- hafsighet..nn.1
  hafsverk_1_N = mkN "hafsverk" neutrum  ; -- hafsverk..nn.1
  hagalen_1_A = mkA "hagalen" ; -- hagalen..av.1
  hagalenhet_1_N = mkN "hagalenhet" ; -- hagalenhet..nn.1
  hage_1_N = mkN "hage" utrum  ; -- hage..nn.1
  hagel_1_N = mkN "hagel" neutrum  ; -- hagel..nn.1
  hagelblandad_1_A = mkA "hagelblandad" ; -- hagelblandad..av.1
  hagelbössa_1_N = mkN "hagelbössa" ; -- hagelbössa..nn.1
  hagelbösseskott_1_N = mkN "hagelbösseskott" neutrum  ; -- hagelbösseskott..nn.1
  hagelgevär_1_N = mkN "hagelgevär" neutrum  ; -- hagelgevär..nn.1
  hagelkorn_1_N = mkN "hagelkorn" neutrum  ; -- hagelkorn..nn.1
  hagelskur_1_N = mkN "hagelskur" ; -- hagelskur..nn.1
  hagelstorm_1_N = mkN "hagelstorm" ; -- hagelstorm..nn.1
  hagelsvärm_1_N = mkN "hagelsvärm" ; -- hagelsvärm..nn.1
  hagga_1_N = mkN "hagga" ; -- hagga..nn.1
  hagiografisk_1_A = mkA "hagiografisk" ; -- hagiografisk..av.1
  hagla_1_V = mkV "haglar" ; -- hagla..vb.1
  haglande_1_N = mkN "haglande" ; -- haglande..nn.1
  hagmark_1_N = mkN "hagmark" "hagmarker" ; -- hagmark..nn.1
  hagtorn_1_N = mkN "hagtorn" ; -- hagtorn..nn.1
  hagtornshäck_1_N = mkN "hagtornshäck" ; -- hagtornshäck..nn.1
  haiku_1_N = mkN "haiku" "haikun" "haikuer" "haikuerna" ; -- haiku..nn.1
  haikuformat_1_N = mkN "haikuformat" neutrum  ; -- haikuformat..nn.1
  haitier_1_N = mkN "haitier" "haitiern" "haitier" "haitierna" ; -- haitier..nn.1
  haitisk_1_A = mkA "haitisk" ; -- haitisk..av.1
  haitiska_1_N = mkN "haitiska" ; -- haitiska..nn.1
  haitiska_2_N = mkN "haitiska" ; -- haitiska..nn.2
  haj_1_A = mkA "haj" ; -- haj..av.1
  haj_1_N = mkN "haj" ; -- haj..nn.1
  haja_1_V = mkV "hajar" ; -- haja..vb.1
  hajande_1_N = mkN "hajande" ; -- hajande..nn.1
  hajfena_1_N = mkN "hajfena" ; -- hajfena..nn.1
  hajfening_1_N = mkN "hajfening" ; -- hajfening..nn.1
  hajj_1_N = mkN "hajj" ; -- hajj..nn.1
  hajjakt_1_N = mkN "hajjakt" ; -- hajjakt..nn.1
  hajk_1_N = mkN "hajk" ; -- hajk..nn.1
  hajka_1_V = mkV "hajkar" ; -- hajka..vb.1
  hajkande_1_N = mkN "hajkande" ; -- hajkande..nn.1
  hajkännare_1_N = mkN "hajkännare" utrum  ; -- hajkännare..nn.1
  hajmal_1_N = mkN "hajmal" ; -- hajmal..nn.1
  hajp_1_N = mkN "hajp" ; -- hajp..nn.1
  hajpa_1_V = mkV "hajpar" ; -- hajpa..vb.1
  hajpande_1_N = mkN "hajpande" ; -- hajpande..nn.1
  hajpning_1_N = mkN "hajpning" ; -- hajpning..nn.1
  hak_1_N = mkN "hak" neutrum  ; -- hak..nn.1
  haka_1_N = mkN "haka" ; -- haka..nn.1
  haka_1_V = mkV "hakar" ; -- haka..vb.1
  hakande_1_N = mkN "hakande" ; -- hakande..nn.1
  hakband_1_N = mkN "hakband" neutrum  ; -- hakband..nn.1
  hake_1_N = mkN "hake" utrum  ; -- hake..nn.1
  hakebössa_1_N = mkN "hakebössa" ; -- hakebössa..nn.1
  hakkors_1_N = mkN "hakkors" neutrum  ; -- hakkors..nn.1
  hakkorsfana_1_N = mkN "hakkorsfana" ; -- hakkorsfana..nn.1
  hakkorsflagga_1_N = mkN "hakkorsflagga" ; -- hakkorsflagga..nn.1
  haklapp_1_N = mkN "haklapp" ; -- haklapp..nn.1
  hakmask_1_N = mkN "hakmask" ; -- hakmask..nn.1
  hakmaskinfektion_1_N = mkN "hakmaskinfektion" ; -- hakmaskinfektion..nn.1
  hakning_1_N = mkN "hakning" ; -- hakning..nn.1
  hakparentes_1_N = mkN "hakparentes" "hakparenteser" ; -- hakparentes..nn.1
  hakrem_1_N = mkN "hakrem" "hakremmen" "hakremmar" "hakremmarna" ; -- hakrem..nn.1
  hakskägg_1_N = mkN "hakskägg" neutrum  ; -- hakskägg..nn.1
  hakspets_1_N = mkN "hakspets" ; -- hakspets..nn.1
  hal_1_A = mkA "hal" ; -- hal..av.1
  hala_1_V = mkV "halar" ; -- hala..vb.1
  halal_1_A = mkA "halal" ; -- halal..av.1
  halande_1_N = mkN "halande" ; -- halande..nn.1
  halgatt_1_N = mkN "halgatt" neutrum  ; -- halgatt..nn.1
  halhet_1_N = mkN "halhet" ; -- halhet..nn.1
  halka_1_N = mkN "halka" ; -- halka..nn.1
  halka_1_V = mkV "halkar" ; -- halka..vb.1
  halkande_1_N = mkN "halkande" ; -- halkande..nn.1
  halkbana_1_N = mkN "halkbana" ; -- halkbana..nn.1
  halkfri_1_A = mkA "halkfri" "halkfritt" ; -- halkfri..av.1
  halkig_1_A = mkA "halkig" ; -- halkig..av.1
  halkighet_1_N = mkN "halkighet" ; -- halkighet..nn.1
  halkkrock_1_N = mkN "halkkrock" ; -- halkkrock..nn.1
  halkkörning_1_N = mkN "halkkörning" ; -- halkkörning..nn.1
  halkning_1_N = mkN "halkning" ; -- halkning..nn.1
  halkrisk_1_N = mkN "halkrisk" "halkrisker" ; -- halkrisk..nn.1
  halkskydd_1_N = mkN "halkskydd" neutrum  ; -- halkskydd..nn.1
  halkskyddstejp_1_N = mkN "halkskyddstejp" ; -- halkskyddstejp..nn.1
  halkvarning_1_N = mkN "halkvarning" ; -- halkvarning..nn.1
  hall_1_N = mkN "hall" ; -- hall..nn.1
  hallbygge_1_N = mkN "hallbygge" ; -- hallbygge..nn.1
  halleluja_1_N = mkN "halleluja" "hallelujat" "hallelujan" "hallelujana" ; -- halleluja..nn.1
  hallelujamöte_1_N = mkN "hallelujamöte" ; -- hallelujamöte..nn.1
  hallelujarop_1_N = mkN "hallelujarop" neutrum  ; -- hallelujarop..nn.1
  hallgolv_1_N = mkN "hallgolv" neutrum  ; -- hallgolv..nn.1
  hallick_1_N = mkN "hallick" ; -- hallick..nn.1
  halling_1_N = mkN "halling" ; -- halling..nn.1
  hallkyrka_1_N = mkN "hallkyrka" ; -- hallkyrka..nn.1
  hallmatta_1_N = mkN "hallmatta" ; -- hallmatta..nn.1
  hallon_1_N = mkN "hallon" neutrum  ; -- hallon..nn.1
  hallonbuske_1_N = mkN "hallonbuske" utrum  ; -- hallonbuske..nn.1
  hallongrotta_1_N = mkN "hallongrotta" ; -- hallongrotta..nn.1
  hallonmask_1_N = mkN "hallonmask" ; -- hallonmask..nn.1
  hallonsaft_1_N = mkN "hallonsaft" "hallonsafter" ; -- hallonsaft..nn.1
  hallonsylt_1_N = mkN "hallonsylt" "hallonsylter" ; -- hallonsylt..nn.1
  hallrätt_1_N = mkN "hallrätt" ; -- hallrätt..nn.1
  hallspegel_1_N = mkN "hallspegel" ; -- hallspegel..nn.1
  hallstämpel_1_N = mkN "hallstämpel" ; -- hallstämpel..nn.1
  hallstämpla_1_V = mkV "hallstämplar" ; -- hallstämpla..vb.1
  hallstämplande_1_N = mkN "hallstämplande" ; -- hallstämplande..nn.1
  halltelefon_1_N = mkN "halltelefon" "halltelefoner" ; -- halltelefon..nn.1
  hallucination_1_N = mkN "hallucination" ; -- hallucination..nn.1
  hallucinationstillstånd_1_N = mkN "hallucinationstillstånd" neutrum  ; -- hallucinationstillstånd..nn.1
  hallucinatorisk_1_A = mkA "hallucinatorisk" ; -- hallucinatorisk..av.1
  hallucinera_1_V = mkV "hallucinerar" ; -- hallucinera..vb.1
  hallucinerande_1_N = mkN "hallucinerande" ; -- hallucinerande..nn.1
  hallucinerbar_1_A = mkA "hallucinerbar" ; -- hallucinerbar..av.1
  hallucinerbarhet_1_N = mkN "hallucinerbarhet" ; -- hallucinerbarhet..nn.1
  hallucinering_1_N = mkN "hallucinering" ; -- hallucinering..nn.1
  hallucinogen_1_A = mkA "hallucinogen" "hallucinogent" ; -- hallucinogen..av.1
  hallucinogen_1_N = mkN "hallucinogen" "hallucinogener" ; -- hallucinogen..nn.1
  halländsk_1_A = mkA "halländsk" ; -- halländsk..av.1
  halländska_1_N = mkN "halländska" ; -- halländska..nn.1
  halländska_2_N = mkN "halländska" ; -- halländska..nn.2
  hallänning_1_N = mkN "hallänning" ; -- hallänning..nn.1
  hallå_1_N = mkN "hallå" neutrum  ; -- hallå..nn.1
  hallåa_1_N = mkN "hallåa" ; -- hallåa..nn.1
  hallåa_1_V = mkV "hallåar" ; -- hallåa..vb.1
  hallåande_1_N = mkN "hallåande" ; -- hallåande..nn.1
  hallåman_1_N = mkN "hallåman" "hallåmannen" "hallåmän" "hallåmännen" ; -- hallåman..nn.1
  halm_1_N = mkN "halm" ; -- halm..nn.1
  halma_1_N = mkN "halma" ; -- halma..nn.1
  halmfärgad_1_A = mkA "halmfärgad" ; -- halmfärgad..av.1
  halmgul_1_A = mkA "halmgul" ; -- halmgul..av.1
  halmhatt_1_N = mkN "halmhatt" ; -- halmhatt..nn.1
  halmhjärta_1_N = mkN "halmhjärta" "halmhjärtat" "halmhjärtan" "halmhjärtana" ; -- halmhjärta..nn.1
  halmhydda_1_N = mkN "halmhydda" ; -- halmhydda..nn.1
  halmmadrass_1_N = mkN "halmmadrass" "halmmadrasser" ; -- halmmadrass..nn.1
  halmplatta_1_N = mkN "halmplatta" ; -- halmplatta..nn.1
  halmskakare_1_N = mkN "halmskakare" utrum  ; -- halmskakare..nn.1
  halmstack_1_N = mkN "halmstack" ; -- halmstack..nn.1
  halmstoppad_1_A = mkA "halmstoppad" ; -- halmstoppad..av.1
  halmstrå_1_N = mkN "halmstrå" "halmstråt" "halmstrån" "halmstråna" ; -- halmstrå..nn.1
  halmtak_1_N = mkN "halmtak" neutrum  ; -- halmtak..nn.1
  halning_1_N = mkN "halning" ; -- halning..nn.1
  halo_1_N = mkN "halo" "halon" "haloer" "haloerna" ; -- halo..nn.1
  haloeffekt_1_N = mkN "haloeffekt" "haloeffekter" ; -- haloeffekt..nn.1
  halofenomen_1_N = mkN "halofenomen" neutrum  ; -- halofenomen..nn.1
  halogen_1_N = mkN "halogen" "halogener" ; -- halogen..nn.1
  halogenlampa_1_N = mkN "halogenlampa" ; -- halogenlampa..nn.1
  halogenstrålkastare_1_N = mkN "halogenstrålkastare" utrum  ; -- halogenstrålkastare..nn.1
  halogenstrålkastarset_1_N = mkN "halogenstrålkastarset" neutrum  ; -- halogenstrålkastarset..nn.1
  hals_1_N = mkN "hals" ; -- hals..nn.1
  halsa_1_V = mkV "halsar" ; -- halsa..vb.1
  halsande_1_N = mkN "halsande" ; -- halsande..nn.1
  halsband_1_N = mkN "halsband" neutrum  ; -- halsband..nn.1
  halsbloss_1_N = mkN "halsbloss" neutrum  ; -- halsbloss..nn.1
  halsbrytande_1_A = mkA "halsbrytande" ; -- halsbrytande..av.1
  halsbränna_1_N = mkN "halsbränna" ; -- halsbränna..nn.1
  halsböld_1_N = mkN "halsböld" "halsbölder" ; -- halsböld..nn.1
  halsduk_1_N = mkN "halsduk" ; -- halsduk..nn.1
  halsfluss_1_N = mkN "halsfluss" "halsflusser" ; -- halsfluss..nn.1
  halsgrop_1_N = mkN "halsgrop" ; -- halsgrop..nn.1
  halshugga_1_V = mkV "halshugga" "halshögg" "halshuggit" ; -- halshugga..vb.1
  halshuggande_1_N = mkN "halshuggande" ; -- halshuggande..nn.1
  halshuggning_1_N = mkN "halshuggning" ; -- halshuggning..nn.1
  halsjärn_1_N = mkN "halsjärn" neutrum  ; -- halsjärn..nn.1
  halskatarr_1_N = mkN "halskatarr" "halskatarrer" ; -- halskatarr..nn.1
  halskedja_1_N = mkN "halskedja" ; -- halskedja..nn.1
  halskota_1_N = mkN "halskota" ; -- halskota..nn.1
  halskrage_1_N = mkN "halskrage" utrum  ; -- halskrage..nn.1
  halskrås_1_N = mkN "halskrås" neutrum  ; -- halskrås..nn.1
  halsmandel_1_N = mkN "halsmandel" ; -- halsmandel..nn.1
  halsrem_1_N = mkN "halsrem" "halsremmen" "halsremmar" "halsremmarna" ; -- halsrem..nn.1
  halsring_1_N = mkN "halsring" ; -- halsring..nn.1
  halssmycke_1_N = mkN "halssmycke" ; -- halssmycke..nn.1
  halsstarrig_1_A = mkA "halsstarrig" ; -- halsstarrig..av.1
  halsstarrighet_1_N = mkN "halsstarrighet" ; -- halsstarrighet..nn.1
  halstablett_1_N = mkN "halstablett" "halstabletter" ; -- halstablett..nn.1
  halster_1_N = mkN "halster" neutrum  ; -- halster..nn.1
  halstorr_1_A = mkA "halstorr" ; -- halstorr..av.1
  halstorrhet_1_N = mkN "halstorrhet" ; -- halstorrhet..nn.1
  halstra_1_V = mkV "halstrar" ; -- halstra..vb.1
  halstrande_1_N = mkN "halstrande" ; -- halstrande..nn.1
  halt_1_A = mkA "halt" "halt" ; -- halt..av.1
  halt_1_N = mkN "halt" "halter" ; -- halt..nn.1
  halt_2_N = mkN "halt" ; -- halt..nn.2
  halta_1_V = mkV "haltar" ; -- halta..vb.1
  haltande_1_N = mkN "haltande" ; -- haltande..nn.1
  halthet_1_N = mkN "halthet" ; -- halthet..nn.1
  haltlös_1_A = mkA "haltlös" ; -- haltlös..av.1
  haltlöshet_1_N = mkN "haltlöshet" ; -- haltlöshet..nn.1
  haltning_1_N = mkN "haltning" ; -- haltning..nn.1
  halv_1_A = mkA "halv" ; -- halv..av.1
  halv_1_N = mkN "halv" ; -- halv..nn.1
  halva_1_N = mkN "halva" ; -- halva..nn.1
  halvankare_1_N = mkN "halvankare" utrum  ; -- halvankare..nn.1
  halvapa_1_N = mkN "halvapa" ; -- halvapa..nn.1
  halvautomatisk_1_A = mkA "halvautomatisk" ; -- halvautomatisk..av.1
  halvback_1_N = mkN "halvback" ; -- halvback..nn.1
  halvberusad_1_A = mkA "halvberusad" ; -- halvberusad..av.1
  halvbild_1_N = mkN "halvbild" "halvbilder" ; -- halvbild..nn.1
  halvbildad_1_A = mkA "halvbildad" ; -- halvbildad..av.1
  halvbildning_1_N = mkN "halvbildning" ; -- halvbildning..nn.1
  halvblank_1_A = mkA "halvblank" ; -- halvblank..av.1
  halvblind_1_A = mkA "halvblind" ; -- halvblind..av.1
  halvblindhet_1_N = mkN "halvblindhet" ; -- halvblindhet..nn.1
  halvblod_1_N = mkN "halvblod" neutrum  ; -- halvblod..nn.1
  halvblunda_1_V = mkV "halvblundar" ; -- halvblunda..vb.1
  halvblundande_1_N = mkN "halvblundande" ; -- halvblundande..nn.1
  halvblundning_1_N = mkN "halvblundning" ; -- halvblundning..nn.1
  halvbra_1_Adv = mkAdv "halvbra" ; -- halvbra..ab.1
  halvbra_1_A = mkA "halvbra" ; -- halvbra..av.1
  halvbror_1_N = mkN "halvbror" "halvbröder" ; -- halvbror..nn.1
  halvbuske_1_N = mkN "halvbuske" utrum  ; -- halvbuske..nn.1
  halvbutelj_1_N = mkN "halvbutelj" "halvbuteljer" ; -- halvbutelj..nn.1
  halvcirkel_1_N = mkN "halvcirkel" ; -- halvcirkel..nn.1
  halvcirkelformad_1_A = mkA "halvcirkelformad" ; -- halvcirkelformad..av.1
  halvcirkelformig_1_A = mkA "halvcirkelformig" ; -- halvcirkelformig..av.1
  halvciviliserad_1_A = mkA "halvciviliserad" ; -- halvciviliserad..av.1
  halvdager_1_N = mkN "halvdager" ; -- halvdager..nn.1
  halvdaglig_1_A = mkA "halvdaglig" ; -- halvdaglig..av.1
  halvdan_1_A = mkA "halvdan" ; -- halvdan..av.1
  halvdrucken_1_A = mkA "halvdrucken" ; -- halvdrucken..av.1
  halvdunkel_1_A = mkA "halvdunkel" ; -- halvdunkel..av.1
  halvdunkel_1_N = mkN "halvdunkel" neutrum  ; -- halvdunkel..nn.1
  halvdussin_1_N = mkN "halvdussin" neutrum  ; -- halvdussin..nn.1
  halvdvala_1_N = mkN "halvdvala" ; -- halvdvala..nn.1
  halvdäck_1_N = mkN "halvdäck" neutrum  ; -- halvdäck..nn.1
  halvdäckad_1_A = mkA "halvdäckad" ; -- halvdäckad..av.1
  halvdäckare_1_N = mkN "halvdäckare" utrum  ; -- halvdäckare..nn.1
  halvdöd_1_A = mkA "halvdöd" "halvdött" ; -- halvdöd..av.1
  halvdödhet_1_N = mkN "halvdödhet" ; -- halvdödhet..nn.1
  halvenskild_1_A = mkA "halvenskild" "halvenskilt" ; -- halvenskild..av.1
  halvera_1_V = mkV "halverar" ; -- halvera..vb.1
  halverande_1_N = mkN "halverande" ; -- halverande..nn.1
  halverbar_1_A = mkA "halverbar" ; -- halverbar..av.1
  halverbarhet_1_N = mkN "halverbarhet" ; -- halverbarhet..nn.1
  halverigerad_1_A = mkA "halverigerad" ; -- halverigerad..av.1
  halvering_1_N = mkN "halvering" ; -- halvering..nn.1
  halveringstid_1_N = mkN "halveringstid" ; -- halveringstid..nn.1
  halvfabrikat_1_N = mkN "halvfabrikat" neutrum  ; -- halvfabrikat..nn.1
  halvfet_1_A = mkA "halvfet" ; -- halvfet..av.1
  halvfigur_1_N = mkN "halvfigur" "halvfigurer" ; -- halvfigur..nn.1
  halvflaska_1_N = mkN "halvflaska" ; -- halvflaska..nn.1
  halvflytande_1_A = mkA "halvflytande" ; -- halvflytande..av.1
  halvfransk_1_A = mkA "halvfransk" ; -- halvfransk..av.1
  halvfull_1_A = mkA "halvfull" ; -- halvfull..av.1
  halvfylld_1_A = mkA "halvfylld" "halvfyllt" ; -- halvfylld..av.1
  halvfyratiden_1_N = mkN "halvfyratiden" ; -- halvfyratiden..nn.1
  halvfärdig_1_A = mkA "halvfärdig" ; -- halvfärdig..av.1
  halvfärdighet_1_N = mkN "halvfärdighet" "halvfärdigheter" ; -- halvfärdighet..nn.1
  halvgalen_1_A = mkA "halvgalen" ; -- halvgalen..av.1
  halvgenomskinlig_1_A = mkA "halvgenomskinlig" ; -- halvgenomskinlig..av.1
  halvgenomskinlighet_1_N = mkN "halvgenomskinlighet" ; -- halvgenomskinlighet..nn.1
  halvgräddad_1_A = mkA "halvgräddad" ; -- halvgräddad..av.1
  halvgräs_1_N = mkN "halvgräs" neutrum  ; -- halvgräs..nn.1
  halvgud_1_N = mkN "halvgud" ; -- halvgud..nn.1
  halvgången_1_A = mkA "halvgången" ; -- halvgången..av.1
  halvgångenhet_1_N = mkN "halvgångenhet" ; -- halvgångenhet..nn.1
  halvhet_1_N = mkN "halvhet" "halvheter" ; -- halvhet..nn.1
  halvhjärtad_1_A = mkA "halvhjärtad" ; -- halvhjärtad..av.1
  halvhyvlad_1_A = mkA "halvhyvlad" ; -- halvhyvlad..av.1
  halvhög_1_A = mkA "halvhög" ; -- halvhög..av.1
  halvklar_1_A = mkA "halvklar" ; -- halvklar..av.1
  halvklass_1_N = mkN "halvklass" "halvklasser" ; -- halvklass..nn.1
  halvklot_1_N = mkN "halvklot" neutrum  ; -- halvklot..nn.1
  halvklotformig_1_A = mkA "halvklotformig" ; -- halvklotformig..av.1
  halvklotformighet_1_N = mkN "halvklotformighet" ; -- halvklotformighet..nn.1
  halvklädd_1_A = mkA "halvklädd" ; -- halvklädd..av.1
  halvknop_1_N = mkN "halvknop" ; -- halvknop..nn.1
  halvkokt_1_A = mkA "halvkokt" "halvkokt" ; -- halvkokt..av.1
  halvkolonn_1_N = mkN "halvkolonn" "halvkolonner" ; -- halvkolonn..nn.1
  halvkonserv_1_N = mkN "halvkonserv" "halvkonserver" ; -- halvkonserv..nn.1
  halvkväden_1_A = mkA "halvkväden" ; -- halvkväden..av.1
  halvkvädenhet_1_N = mkN "halvkvädenhet" ; -- halvkvädenhet..nn.1
  halvkvävd_1_A = mkA "halvkvävd" "halvkvävt" ; -- halvkvävd..av.1
  halvledardiod_1_N = mkN "halvledardiod" "halvledardioder" ; -- halvledardiod..nn.1
  halvledare_1_N = mkN "halvledare" utrum  ; -- halvledare..nn.1
  halvlek_1_N = mkN "halvlek" ; -- halvlek..nn.1
  halvligga_1_V = mkV "halvligga" "halvlåg" "halvlegat" ; -- halvligga..vb.1
  halvliggande_1_N = mkN "halvliggande" ; -- halvliggande..nn.1
  halvlinne_1_N = mkN "halvlinne" ; -- halvlinne..nn.1
  halvliter_1_N = mkN "halvliter" "halvlitern" "halvliter" "halvliterna" ; -- halvliter..nn.1
  halvlitersbutelj_1_N = mkN "halvlitersbutelj" "halvlitersbuteljer" ; -- halvlitersbutelj..nn.1
  halvljus_1_N = mkN "halvljus" neutrum  ; -- halvljus..nn.1
  halvlång_1_A = mkA "halvlång" ; -- halvlång..av.1
  halvmara_1_N = mkN "halvmara" ; -- halvmara..nn.1
  halvmaraton_1_N = mkN "halvmaraton" neutrum  ; -- halvmaraton..nn.1
  halvmaratonlopp_1_N = mkN "halvmaratonlopp" neutrum  ; -- halvmaratonlopp..nn.1
  halvmesyr_1_N = mkN "halvmesyr" "halvmesyrer" ; -- halvmesyr..nn.1
  halvmetall_1_N = mkN "halvmetall" "halvmetaller" ; -- halvmetall..nn.1
  halvmetallisk_1_A = mkA "halvmetallisk" ; -- halvmetallisk..av.1
  halvmeter_1_N = mkN "halvmeter" ; -- halvmeter..nn.1
  halvmeterbred_1_A = mkA "halvmeterbred" "halvmeterbrett" ; -- halvmeterbred..av.1
  halvmeterhög_1_A = mkA "halvmeterhög" ; -- halvmeterhög..av.1
  halvmetershög_1_A = mkA "halvmetershög" ; -- halvmetershög..av.1
  halvmil_1_N = mkN "halvmil" "halvmilen" "halvmil" "halvmilen" ; -- halvmil..nn.1
  halvmilitär_1_A = mkA "halvmilitär" ; -- halvmilitär..av.1
  halvmodern_1_A = mkA "halvmodern" ; -- halvmodern..av.1
  halvmogen_1_A = mkA "halvmogen" ; -- halvmogen..av.1
  halvmulen_1_A = mkA "halvmulen" ; -- halvmulen..av.1
  halvmätt_1_A = mkA "halvmätt" ; -- halvmätt..av.1
  halvmåne_1_N = mkN "halvmåne" utrum  ; -- halvmåne..nn.1
  halvmånformad_1_A = mkA "halvmånformad" ; -- halvmånformad..av.1
  halvmånformig_1_A = mkA "halvmånformig" ; -- halvmånformig..av.1
  halvmörk_1_A = mkA "halvmörk" ; -- halvmörk..av.1
  halvmörker_1_N = mkN "halvmörker" neutrum  ; -- halvmörker..nn.1
  halvnaken_1_A = mkA "halvnaken" ; -- halvnaken..av.1
  halvnakenhet_1_N = mkN "halvnakenhet" ; -- halvnakenhet..nn.1
  halvnelson_1_N = mkN "halvnelson" ; -- halvnelson..nn.1
  halvnot_1_N = mkN "halvnot" "halvnoter" ; -- halvnot..nn.1
  halvnäck_1_A = mkA "halvnäck" ; -- halvnäck..av.1
  halvnäcka_1_V = mkV "halvnäckar" ; -- halvnäcka..vb.1
  halvofficiell_1_A = mkA "halvofficiell" ; -- halvofficiell..av.1
  halvpanna_1_N = mkN "halvpanna" ; -- halvpanna..nn.1
  halvpart_1_N = mkN "halvpart" "halvparter" ; -- halvpart..nn.1
  halvpension_1_N = mkN "halvpension" ; -- halvpension..nn.1
  halvprofil_1_N = mkN "halvprofil" "halvprofiler" ; -- halvprofil..nn.1
  halvrelief_1_N = mkN "halvrelief" "halvreliefer" ; -- halvrelief..nn.1
  halvrim_1_N = mkN "halvrim" "halvrimmet" "halvrim" "halvrimmen" ; -- halvrim..nn.1
  halvrund_1_A = mkA "halvrund" ; -- halvrund..av.1
  halvrutten_1_A = mkA "halvrutten" ; -- halvrutten..av.1
  halvruttenhet_1_N = mkN "halvruttenhet" ; -- halvruttenhet..nn.1
  halvsanning_1_N = mkN "halvsanning" ; -- halvsanning..nn.1
  halvsekel_1_N = mkN "halvsekel" neutrum  ; -- halvsekel..nn.1
  halvsiden_1_N = mkN "halvsiden" neutrum  ; -- halvsiden..nn.1
  halvskadad_1_A = mkA "halvskadad" ; -- halvskadad..av.1
  halvskugga_1_N = mkN "halvskugga" ; -- halvskugga..nn.1
  halvskyddad_1_A = mkA "halvskyddad" ; -- halvskyddad..av.1
  halvskymning_1_N = mkN "halvskymning" ; -- halvskymning..nn.1
  halvslag_1_N = mkN "halvslag" neutrum  ; -- halvslag..nn.1
  halvslumra_1_V = mkV "halvslumrar" ; -- halvslumra..vb.1
  halvslumrande_1_N = mkN "halvslumrande" ; -- halvslumrande..nn.1
  halvsluten_1_A = mkA "halvsluten" ; -- halvsluten..av.1
  halvslutenhet_1_N = mkN "halvslutenhet" ; -- halvslutenhet..nn.1
  halvsmält_1_A = mkA "halvsmält" "halvsmält" ; -- halvsmält..av.1
  halvsnagg_1_N = mkN "halvsnagg" ; -- halvsnagg..nn.1
  halvsova_1_V = mkV "halvsova" "halvsov" "halvsovit" ; -- halvsova..vb.1
  halvsovande_1_N = mkN "halvsovande" ; -- halvsovande..nn.1
  halvspringa_1_V = mkV "halvspringa" "halvsprang" "halvsprungit" ; -- halvspringa..vb.1
  halvspråkig_1_A = mkA "halvspråkig" ; -- halvspråkig..av.1
  halvspråkighet_1_N = mkN "halvspråkighet" ; -- halvspråkighet..nn.1
  halvstatlig_1_A = mkA "halvstatlig" ; -- halvstatlig..av.1
  halvstatlighet_1_N = mkN "halvstatlighet" ; -- halvstatlighet..nn.1
  halvstop_1_N = mkN "halvstop" neutrum  ; -- halvstop..nn.1
  halvstor_1_A = mkA "halvstor" ; -- halvstor..av.1
  halvstrumpa_1_N = mkN "halvstrumpa" ; -- halvstrumpa..nn.1
  halvstövel_1_N = mkN "halvstövel" ; -- halvstövel..nn.1
  halvsula_1_V = mkV "halvsular" ; -- halvsula..vb.1
  halvsulande_1_N = mkN "halvsulande" ; -- halvsulande..nn.1
  halvsur_1_A = mkA "halvsur" ; -- halvsur..av.1
  halvsvensk_1_A = mkA "halvsvensk" ; -- halvsvensk..av.1
  halvsyskon_1_N = mkN "halvsyskon" neutrum  ; -- halvsyskon..nn.1
  halvsyster_1_N = mkN "halvsyster" ; -- halvsyster..nn.1
  halvsömn_1_N = mkN "halvsömn" ; -- halvsömn..nn.1
  halvtaskig_1_A = mkA "halvtaskig" ; -- halvtaskig..av.1
  halvtid_1_N = mkN "halvtid" "halvtider" ; -- halvtid..nn.1
  halvtidsarbetande_1_A = mkA "halvtidsarbetande" ; -- halvtidsarbetande..av.1
  halvtidsfrigivning_1_N = mkN "halvtidsfrigivning" ; -- halvtidsfrigivning..nn.1
  halvtimma_1_N = mkN "halvtimma" ; -- halvtimma..nn.1
  halvtimme_1_N = mkN "halvtimme" utrum  ; -- halvtimme..nn.1
  halvtimmeslång_1_A = mkA "halvtimmeslång" ; -- halvtimmeslång..av.1
  halvtokig_1_A = mkA "halvtokig" ; -- halvtokig..av.1
  halvtom_1_A = mkA "halvtom" "halvtomt" "halvtomma" "halvtomma" "halvtommare" "halvtommast" "halvtommaste" ; -- halvtom..av.1
  halvton_1_N = mkN "halvton" "halvtoner" ; -- halvton..nn.1
  halvtorr_1_A = mkA "halvtorr" ; -- halvtorr..av.1
  halvtrappa_1_N = mkN "halvtrappa" ; -- halvtrappa..nn.1
  halvtrist_1_A = mkA "halvtrist" "halvtrist" ; -- halvtrist..av.1
  halvtum_1_N = mkN "halvtum" "halvtummen" "halvtum" "halvtummen" ; -- halvtum..nn.1
  halvtäckt_1_A = mkA "halvtäckt" "halvtäckt" ; -- halvtäckt..av.1
  halvvaken_1_A = mkA "halvvaken" ; -- halvvaken..av.1
  halvvante_1_N = mkN "halvvante" utrum  ; -- halvvante..nn.1
  halvvild_1_A = mkA "halvvild" "halvvilt" ; -- halvvild..av.1
  halvviska_1_V = mkV "halvviskar" ; -- halvviska..vb.1
  halvviskande_1_N = mkN "halvviskande" ; -- halvviskande..nn.1
  halvviskning_1_N = mkN "halvviskning" ; -- halvviskning..nn.1
  halvvokal_1_N = mkN "halvvokal" "halvvokaler" ; -- halvvokal..nn.1
  halvvuxen_1_A = mkA "halvvuxen" ; -- halvvuxen..av.1
  halvvuxenhet_1_N = mkN "halvvuxenhet" ; -- halvvuxenhet..nn.1
  halvvärld_1_N = mkN "halvvärld" ; -- halvvärld..nn.1
  halvylle_1_N = mkN "halvylle" ; -- halvylle..nn.1
  halvädel_1_A = mkA "halvädel" ; -- halvädel..av.1
  halvädelsten_1_N = mkN "halvädelsten" "halvädelstenen" "halvädelstenar" "halvädelstenarna" ; -- halvädelsten..nn.1
  halväkta_1_A = mkA "halväkta" ; -- halväkta..av.1
  halvår_1_N = mkN "halvår" neutrum  ; -- halvår..nn.1
  halvårslång_1_A = mkA "halvårslång" ; -- halvårslång..av.1
  halvårsskifte_1_N = mkN "halvårsskifte" ; -- halvårsskifte..nn.1
  halvårsvis_1_Adv = mkAdv "halvårsvis" ; -- halvårsvis..ab.1
  halvårsvis_1_A = mkA "halvårsvis" ; -- halvårsvis..av.1
  halvö_1_N = mkN "halvö" ; -- halvö..nn.1
  halvöppen_1_A = mkA "halvöppen" ; -- halvöppen..av.1
  halvöppenhet_1_N = mkN "halvöppenhet" ; -- halvöppenhet..nn.1
  hambo_1_N = mkN "hambo" "hambon" "hamboer" "hamboerna" ; -- hambo..nn.1
  hambostinta_1_N = mkN "hambostinta" ; -- hambostinta..nn.1
  hamburgarbar_1_N = mkN "hamburgarbar" "hamburgarbarer" ; -- hamburgarbar..nn.1
  hamburgare_1_N = mkN "hamburgare" utrum  ; -- hamburgare..nn.1
  hamburgarrestaurang_1_N = mkN "hamburgarrestaurang" "hamburgarrestauranger" ; -- hamburgarrestaurang..nn.1
  hamburgarställe_1_N = mkN "hamburgarställe" ; -- hamburgarställe..nn.1
  hamburgerbar_1_N = mkN "hamburgerbar" "hamburgerbarer" ; -- hamburgerbar..nn.1
  hamburgerkött_1_N = mkN "hamburgerkött" neutrum  ; -- hamburgerkött..nn.1
  hamburgerrestaurang_1_N = mkN "hamburgerrestaurang" "hamburgerrestauranger" ; -- hamburgerrestaurang..nn.1
  hamburgerställe_1_N = mkN "hamburgerställe" ; -- hamburgerställe..nn.1
  hamit_1_N = mkN "hamit" "hamiter" ; -- hamit..nn.1
  hamitisk_1_A = mkA "hamitisk" ; -- hamitisk..av.1
  hamla_1_V = mkV "hamlar" ; -- hamla..vb.1
  hamlande_1_N = mkN "hamlande" ; -- hamlande..nn.1
  hamling_1_N = mkN "hamling" ; -- hamling..nn.1
  hammarattack_1_N = mkN "hammarattack" "hammarattacker" ; -- hammarattack..nn.1
  hammarband_1_N = mkN "hammarband" neutrum  ; -- hammarband..nn.1
  hammare_1_N = mkN "hammare" "hammaren" "hammare" "hamrarna" ; -- hammare..nn.1
  hammarhaj_1_N = mkN "hammarhaj" ; -- hammarhaj..nn.1
  hammarslag_1_N = mkN "hammarslag" neutrum  ; -- hammarslag..nn.1
  hammel_1_N = mkN "hammel" "hammeln" "hammlar" "hammlarna" ; -- hammel..nn.1
  hammelsadel_1_N = mkN "hammelsadel" ; -- hammelsadel..nn.1
  hammerless_1_N = mkN "hammerless" "hammerlessen" "hammerless" "hammerlessen" ; -- hammerless..nn.1
  hammock_1_N = mkN "hammock" ; -- hammock..nn.1
  hammockgångjärn_1_N = mkN "hammockgångjärn" neutrum  ; -- hammockgångjärn..nn.1
  hammondorgel_1_N = mkN "hammondorgel" ; -- hammondorgel..nn.1
  hamn_1_N = mkN "hamn" ; -- hamn..nn.1
  hamna_1_V = mkV "hamnar" ; -- hamna..vb.1
  hamnande_1_N = mkN "hamnande" ; -- hamnande..nn.1
  hamnarbetare_1_N = mkN "hamnarbetare" utrum  ; -- hamnarbetare..nn.1
  hamnarbetarstrejk_1_N = mkN "hamnarbetarstrejk" "hamnarbetarstrejker" ; -- hamnarbetarstrejk..nn.1
  hamnbassäng_1_N = mkN "hamnbassäng" "hamnbassänger" ; -- hamnbassäng..nn.1
  hamnbuse_1_N = mkN "hamnbuse" utrum  ; -- hamnbuse..nn.1
  hamndirektion_1_N = mkN "hamndirektion" ; -- hamndirektion..nn.1
  hamnfogde_1_N = mkN "hamnfogde" utrum  ; -- hamnfogde..nn.1
  hamnförhållande_1_N = mkN "hamnförhållande" ; -- hamnförhållande..nn.1
  hamnkafé_1_N = mkN "hamnkafé" "hamnkaféet" "hamnkaféer" "hamnkaféerna" ; -- hamnkafé..nn.1
  hamnkapten_1_N = mkN "hamnkapten" "hamnkaptener" ; -- hamnkapten..nn.1
  hamnkontor_1_N = mkN "hamnkontor" neutrum  ; -- hamnkontor..nn.1
  hamnkvarter_1_N = mkN "hamnkvarter" "hamnkvarteret" "hamnkvarter" "hamnkvarteren" ; -- hamnkvarter..nn.1
  hamnstad_1_N = mkN "hamnstad" "hamnstäder" ; -- hamnstad..nn.1
  hamnstyrelse_1_N = mkN "hamnstyrelse" "hamnstyrelser" ; -- hamnstyrelse..nn.1
  hampa_1_N = mkN "hampa" ; -- hampa..nn.1
  hampdån_1_N = mkN "hampdån" ; -- hampdån..nn.1
  hampfrö_1_N = mkN "hampfrö" "hampfröet" "hampfrön" "hampfröna" ; -- hampfrö..nn.1
  hamra_1_V = mkV "hamrar" ; -- hamra..vb.1
  hamrande_1_N = mkN "hamrande" ; -- hamrande..nn.1
  hamster_1_N = mkN "hamster" ; -- hamster..nn.1
  hamstra_1_V = mkV "hamstrar" ; -- hamstra..vb.1
  hamstrande_1_N = mkN "hamstrande" ; -- hamstrande..nn.1
  hanbjälke_1_N = mkN "hanbjälke" utrum  ; -- hanbjälke..nn.1
  hanblomma_1_N = mkN "hanblomma" ; -- hanblomma..nn.1
  hand_1_N = mkN "hand" "händer" ; -- hand..nn.1
  handalfabet_1_N = mkN "handalfabet" neutrum  ; -- handalfabet..nn.1
  handarbeta_1_V = mkV "handarbetar" ; -- handarbeta..vb.1
  handarbetande_1_N = mkN "handarbetande" ; -- handarbetande..nn.1
  handarbete_1_N = mkN "handarbete" ; -- handarbete..nn.1
  handavtryck_1_N = mkN "handavtryck" neutrum  ; -- handavtryck..nn.1
  handbagage_1_N = mkN "handbagage" "handbagaget" "handbagage" "handbagagen" ; -- handbagage..nn.1
  handboja_1_N = mkN "handboja" ; -- handboja..nn.1
  handboja_1_V = mkV "handbojar" ; -- handboja..vb.1
  handbojande_1_N = mkN "handbojande" ; -- handbojande..nn.1
  handbojning_1_N = mkN "handbojning" ; -- handbojning..nn.1
  handbok_1_N = mkN "handbok" "handböcker" ; -- handbok..nn.1
  handboksmässig_1_A = mkA "handboksmässig" ; -- handboksmässig..av.1
  handboll_1_N = mkN "handboll" ; -- handboll..nn.1
  handboll_2_N = mkN "handboll" ; -- handboll..nn.2
  handbollsmatch_1_N = mkN "handbollsmatch" "handbollsmatcher" ; -- handbollsmatch..nn.1
  handbollsmässig_1_A = mkA "handbollsmässig" ; -- handbollsmässig..av.1
  handbollsspelare_1_N = mkN "handbollsspelare" utrum  ; -- handbollsspelare..nn.1
  handbrev_1_N = mkN "handbrev" neutrum  ; -- handbrev..nn.1
  handbroms_1_N = mkN "handbroms" ; -- handbroms..nn.1
  handdator_1_N = mkN "handdator" "handdatorer" ; -- handdator..nn.1
  handduk_1_N = mkN "handduk" ; -- handduk..nn.1
  handdukstork_1_N = mkN "handdukstork" ; -- handdukstork..nn.1
  handeksem_1_N = mkN "handeksem" neutrum  ; -- handeksem..nn.1
  handel_1_N = mkN "handel" ; -- handel..nn.1
  handel_2_N = mkN "handel" ; -- handel..nn.2
  handeldvapen_1_N = mkN "handeldvapen" "handeldvapnet" "handeldvapen" "handeldvapnen" ; -- handeldvapen..nn.1
  handelsanställd_1_A = mkA "handelsanställd" "handelsanställt" ; -- handelsanställd..av.1
  handelsavtal_1_N = mkN "handelsavtal" neutrum  ; -- handelsavtal..nn.1
  handelsbalans_1_N = mkN "handelsbalans" ; -- handelsbalans..nn.1
  handelsbank_1_N = mkN "handelsbank" "handelsbanker" ; -- handelsbank..nn.1
  handelsbod_1_N = mkN "handelsbod" ; -- handelsbod..nn.1
  handelsbolag_1_N = mkN "handelsbolag" neutrum  ; -- handelsbolag..nn.1
  handelsdepartement_1_N = mkN "handelsdepartement" neutrum  ; -- handelsdepartement..nn.1
  handelsfartyg_1_N = mkN "handelsfartyg" neutrum  ; -- handelsfartyg..nn.1
  handelsflotta_1_N = mkN "handelsflotta" ; -- handelsflotta..nn.1
  handelsförbindelse_1_N = mkN "handelsförbindelse" "handelsförbindelser" ; -- handelsförbindelse..nn.1
  handelsfördrag_1_N = mkN "handelsfördrag" neutrum  ; -- handelsfördrag..nn.1
  handelsföretag_1_N = mkN "handelsföretag" neutrum  ; -- handelsföretag..nn.1
  handelsgods_1_N = mkN "handelsgods" neutrum  ; -- handelsgods..nn.1
  handelsgymnasium_1_N = mkN "handelsgymnasium" "handelsgymnasiet" "handelsgymnasier" "handelsgymnasierna" ; -- handelsgymnasium..nn.1
  handelshinder_1_N = mkN "handelshinder" neutrum  ; -- handelshinder..nn.1
  handelshus_1_N = mkN "handelshus" neutrum  ; -- handelshus..nn.1
  handelshögskola_1_N = mkN "handelshögskola" ; -- handelshögskola..nn.1
  handelskammare_1_N = mkN "handelskammare" "handelskammaren" "handelskammare" "handelskamrarna" ; -- handelskammare..nn.1
  handelskompani_1_N = mkN "handelskompani" "handelskompaniet" "handelskompanier" "handelskompanierna" ; -- handelskompani..nn.1
  handelskontor_1_N = mkN "handelskontor" neutrum  ; -- handelskontor..nn.1
  handelsköp_1_N = mkN "handelsköp" neutrum  ; -- handelsköp..nn.1
  handelsled_1_N = mkN "handelsled" "handelsleder" ; -- handelsled..nn.1
  handelslänk_1_N = mkN "handelslänk" ; -- handelslänk..nn.1
  handelsman_1_N = mkN "handelsman" "handelsmannen" "handelsmän" "handelsmännen" ; -- handelsman..nn.1
  handelsminister_1_N = mkN "handelsminister" ; -- handelsminister..nn.1
  handelsmässig_1_A = mkA "handelsmässig" ; -- handelsmässig..av.1
  handelspartner_1_N = mkN "handelspartner" "handelspartnern" "handelspartners" "handelspartnersen" ; -- handelspartner..nn.1
  handelsplats_1_N = mkN "handelsplats" "handelsplatser" ; -- handelsplats..nn.1
  handelspolitik_1_N = mkN "handelspolitik" ; -- handelspolitik..nn.1
  handelspolitisk_1_A = mkA "handelspolitisk" ; -- handelspolitisk..av.1
  handelsregister_1_N = mkN "handelsregister" neutrum  ; -- handelsregister..nn.1
  handelsresa_1_N = mkN "handelsresa" ; -- handelsresa..nn.1
  handelsresande_1_N = mkN "handelsresande" "handelsresanden" "handelsresanden" "handelsresandena" ; -- handelsresande..nn.1
  handelsrätt_1_N = mkN "handelsrätt" ; -- handelsrätt..nn.1
  handelssanktion_1_N = mkN "handelssanktion" ; -- handelssanktion..nn.1
  handelsskola_1_N = mkN "handelsskola" ; -- handelsskola..nn.1
  handelsstad_1_N = mkN "handelsstad" "handelsstäder" ; -- handelsstad..nn.1
  handelsstation_1_N = mkN "handelsstation" ; -- handelsstation..nn.1
  handelstraktat_1_N = mkN "handelstraktat" "handelstraktater" ; -- handelstraktat..nn.1
  handelsträdgård_1_N = mkN "handelsträdgård" ; -- handelsträdgård..nn.1
  handelsutbyte_1_N = mkN "handelsutbyte" ; -- handelsutbyte..nn.1
  handelsvara_1_N = mkN "handelsvara" ; -- handelsvara..nn.1
  handenhet_1_N = mkN "handenhet" "handenheter" ; -- handenhet..nn.1
  handfallen_1_A = mkA "handfallen" ; -- handfallen..av.1
  handfallenhet_1_N = mkN "handfallenhet" "handfallenheter" ; -- handfallenhet..nn.1
  handfast_1_A = mkA "handfast" "handfast" ; -- handfast..av.1
  handfasthet_1_N = mkN "handfasthet" ; -- handfasthet..nn.1
  handfat_1_N = mkN "handfat" neutrum  ; -- handfat..nn.1
  handflata_1_N = mkN "handflata" ; -- handflata..nn.1
  handflikig_1_A = mkA "handflikig" ; -- handflikig..av.1
  handfri_1_A = mkA "handfri" "handfritt" ; -- handfri..av.1
  handfull_1_N = mkN "handfull" ; -- handfull..nn.1
  handgemäng_1_N = mkN "handgemäng" neutrum  ; -- handgemäng..nn.1
  handgjord_1_A = mkA "handgjord" "handgjort" ; -- handgjord..av.1
  handgranat_1_N = mkN "handgranat" "handgranater" ; -- handgranat..nn.1
  handgranatduell_1_N = mkN "handgranatduell" "handgranatdueller" ; -- handgranatduell..nn.1
  handgrepp_1_N = mkN "handgrepp" neutrum  ; -- handgrepp..nn.1
  handgriplig_1_A = mkA "handgriplig" ; -- handgriplig..av.1
  handgripligen_1_Adv = mkAdv "handgripligen" ; -- handgripligen..ab.1
  handgriplighet_1_N = mkN "handgriplighet" "handgripligheter" ; -- handgriplighet..nn.1
  handgriplighet_2_N = mkN "handgriplighet" ; -- handgriplighet..nn.2
  handgången_1_A = mkA "handgången" ; -- handgången..av.1
  handhavande_1_N = mkN "handhavande" ; -- handhavande..nn.1
  handhavare_1_N = mkN "handhavare" utrum  ; -- handhavare..nn.1
  handhållen_1_A = mkA "handhållen" ; -- handhållen..av.1
  handikapp_1_N = mkN "handikapp" neutrum  ; -- handikapp..nn.1
  handikappa_1_V = mkV "handikappar" ; -- handikappa..vb.1
  handikappad_1_A = mkA "handikappad" ; -- handikappad..av.1
  handikappande_1_N = mkN "handikappande" ; -- handikappande..nn.1
  handikappanpassad_1_A = mkA "handikappanpassad" ; -- handikappanpassad..av.1
  handikappfråga_1_N = mkN "handikappfråga" ; -- handikappfråga..nn.1
  handikappidrott_1_N = mkN "handikappidrott" "handikappidrotter" ; -- handikappidrott..nn.1
  handikappidrottare_1_N = mkN "handikappidrottare" utrum  ; -- handikappidrottare..nn.1
  handikappolitik_1_N = mkN "handikappolitik" ; -- handikappolitik..nn.1
  handikappolitisk_1_A = mkA "handikappolitisk" ; -- handikappolitisk..av.1
  handikapporganisation_1_N = mkN "handikapporganisation" ; -- handikapporganisation..nn.1
  handikappvänlig_1_A = mkA "handikappvänlig" ; -- handikappvänlig..av.1
  handikappvård_1_N = mkN "handikappvård" ; -- handikappvård..nn.1
  handjagare_1_N = mkN "handjagare" utrum  ; -- handjagare..nn.1
  handjur_1_N = mkN "handjur" neutrum  ; -- handjur..nn.1
  handkammare_1_N = mkN "handkammare" "handkammaren" "handkammare" "handkamrarna" ; -- handkammare..nn.1
  handkassa_1_N = mkN "handkassa" ; -- handkassa..nn.1
  handklappning_1_N = mkN "handklappning" ; -- handklappning..nn.1
  handklaver_1_N = mkN "handklaver" "handklaveret" "handklaver" "handklaveren" ; -- handklaver..nn.1
  handklove_1_N = mkN "handklove" utrum  ; -- handklove..nn.1
  handknackad_1_A = mkA "handknackad" ; -- handknackad..av.1
  handknyten_1_A = mkA "handknyten" ; -- handknyten..av.1
  handkontroll_1_N = mkN "handkontroll" "handkontroller" ; -- handkontroll..nn.1
  handkraft_1_N = mkN "handkraft" ; -- handkraft..nn.1
  handkräm_1_N = mkN "handkräm" "handkrämer" ; -- handkräm..nn.1
  handkvarn_1_N = mkN "handkvarn" ; -- handkvarn..nn.1
  handkyss_1_N = mkN "handkyss" ; -- handkyss..nn.1
  handkyssning_1_N = mkN "handkyssning" ; -- handkyssning..nn.1
  handla_1_V = mkV "handlar" ; -- handla..vb.1
  handla_2_V = mkV "handlar" ; -- handla..vb.2
  handlag_1_N = mkN "handlag" neutrum  ; -- handlag..nn.1
  handlampa_1_N = mkN "handlampa" ; -- handlampa..nn.1
  handlande_1_N = mkN "handlande" "handlanden" "handlanden" "handlandena" ; -- handlande..nn.1
  handlande_2_N = mkN "handlande" ; -- handlande..nn.2
  handlare_1_N = mkN "handlare" utrum  ; -- handlare..nn.1
  handled_1_N = mkN "handled" "handleder" ; -- handled..nn.1
  handleda_1_V = mkV "handleda" "handledde" "handlett" ; -- handleda..vb.1
  handledande_1_N = mkN "handledande" ; -- handledande..nn.1
  handledare_1_N = mkN "handledare" utrum  ; -- handledare..nn.1
  handledning_1_N = mkN "handledning" ; -- handledning..nn.1
  handledsstöd_1_N = mkN "handledsstöd" neutrum  ; -- handledsstöd..nn.1
  handlexikon_1_N = mkN "handlexikon" neutrum  ; -- handlexikon..nn.1
  handling_1_N = mkN "handling" ; -- handling..nn.1
  handlingsalternativ_1_N = mkN "handlingsalternativ" neutrum  ; -- handlingsalternativ..nn.1
  handlingsberedskap_1_N = mkN "handlingsberedskap" ; -- handlingsberedskap..nn.1
  handlingsfrihet_1_N = mkN "handlingsfrihet" "handlingsfriheter" ; -- handlingsfrihet..nn.1
  handlingsförlamad_1_A = mkA "handlingsförlamad" ; -- handlingsförlamad..av.1
  handlingsförlamning_1_N = mkN "handlingsförlamning" ; -- handlingsförlamning..nn.1
  handlingskraft_1_N = mkN "handlingskraft" ; -- handlingskraft..nn.1
  handlingskraftig_1_A = mkA "handlingskraftig" ; -- handlingskraftig..av.1
  handlingskraftighet_1_N = mkN "handlingskraftighet" ; -- handlingskraftighet..nn.1
  handlingsmänniska_1_N = mkN "handlingsmänniska" ; -- handlingsmänniska..nn.1
  handlingsmässig_1_A = mkA "handlingsmässig" ; -- handlingsmässig..av.1
  handlingsord_1_N = mkN "handlingsord" neutrum  ; -- handlingsord..nn.1
  handlingsplan_1_N = mkN "handlingsplan" "handlingsplaner" ; -- handlingsplan..nn.1
  handlingsprogram_1_N = mkN "handlingsprogram" "handlingsprogrammet" "handlingsprogram" "handlingsprogrammen" ; -- handlingsprogram..nn.1
  handlingsregel_1_N = mkN "handlingsregel" "handlingsregeln" "handlingsregler" "handlingsreglerna" ; -- handlingsregel..nn.1
  handlingssätt_1_N = mkN "handlingssätt" neutrum  ; -- handlingssätt..nn.1
  handljusstake_1_N = mkN "handljusstake" utrum  ; -- handljusstake..nn.1
  handlove_1_N = mkN "handlov" ; -- handlove..nn.1
  handlägga_1_V = mkV "handlägga" "handla" "handlagt" ; -- handlägga..vb.1
  handläggande_1_N = mkN "handläggande" ; -- handläggande..nn.1
  handläggare_1_N = mkN "handläggare" utrum  ; -- handläggare..nn.1
  handläggning_1_N = mkN "handläggning" ; -- handläggning..nn.1
  handlån_1_N = mkN "handlån" neutrum  ; -- handlån..nn.1
  handmålad_1_A = mkA "handmålad" ; -- handmålad..av.1
  handordbok_1_N = mkN "handordbok" "handordböcker" ; -- handordbok..nn.1
  handout_1_N = mkN "handout" "handouten" "handouts" "handoutsarna" ; -- handout..nn.1
  handpenning_1_N = mkN "handpenning" ; -- handpenning..nn.1
  handplocka_1_V = mkV "handplockar" ; -- handplocka..vb.1
  handplockande_1_N = mkN "handplockande" ; -- handplockande..nn.1
  handpump_1_N = mkN "handpump" ; -- handpump..nn.1
  handpåläggning_1_N = mkN "handpåläggning" ; -- handpåläggning..nn.1
  handrem_1_N = mkN "handrem" "handremmen" "handremmar" "handremmarna" ; -- handrem..nn.1
  handrygg_1_N = mkN "handrygg" ; -- handrygg..nn.1
  handräckning_1_N = mkN "handräckning" ; -- handräckning..nn.1
  handrörelse_1_N = mkN "handrörelse" "handrörelser" ; -- handrörelse..nn.1
  hands_1_N = mkN "hands" ; -- hands..nn.1
  handsbred_1_A = mkA "handsbred" "handsbrett" ; -- handsbred..av.1
  handsbredd_1_N = mkN "handsbredd" "handsbredder" ; -- handsbredd..nn.1
  handsekreterare_1_N = mkN "handsekreterare" utrum  ; -- handsekreterare..nn.1
  handsfree_1_N = mkN "handsfree" ; -- handsfree..nn.1
  handsing_1_N = mkN "handsing" ; -- handsing..nn.1
  handskakning_1_N = mkN "handskakning" ; -- handskakning..nn.1
  handskalad_1_A = mkA "handskalad" ; -- handskalad..av.1
  handskbeklädd_1_A = mkA "handskbeklädd" ; -- handskbeklädd..av.1
  handske_1_N = mkN "handske" utrum  ; -- handske..nn.1
  handskfack_1_N = mkN "handskfack" neutrum  ; -- handskfack..nn.1
  handskrift_1_N = mkN "handskrift" "handskrifter" ; -- handskrift..nn.1
  handskriftsavdelning_1_N = mkN "handskriftsavdelning" ; -- handskriftsavdelning..nn.1
  handskriftsrulle_1_N = mkN "handskriftsrulle" utrum  ; -- handskriftsrulle..nn.1
  handskriftssamling_1_N = mkN "handskriftssamling" ; -- handskriftssamling..nn.1
  handskriven_1_A = mkA "handskriven" ; -- handskriven..av.1
  handslag_1_N = mkN "handslag" neutrum  ; -- handslag..nn.1
  handspak_1_N = mkN "handspak" ; -- handspak..nn.1
  handspegel_1_N = mkN "handspegel" ; -- handspegel..nn.1
  handspruta_1_N = mkN "handspruta" ; -- handspruta..nn.1
  handstil_1_N = mkN "handstil" ; -- handstil..nn.1
  handstilsexpert_1_N = mkN "handstilsexpert" "handstilsexperter" ; -- handstilsexpert..nn.1
  handstilsspecialist_1_N = mkN "handstilsspecialist" "handstilsspecialister" ; -- handstilsspecialist..nn.1
  handsvett_1_N = mkN "handsvett" ; -- handsvett..nn.1
  handsydd_1_A = mkA "handsydd" ; -- handsydd..av.1
  handsåg_1_N = mkN "handsåg" ; -- handsåg..nn.1
  handtag_1_N = mkN "handtag" neutrum  ; -- handtag..nn.1
  handteckning_1_N = mkN "handteckning" ; -- handteckning..nn.1
  handtittare_1_N = mkN "handtittare" utrum  ; -- handtittare..nn.1
  handtralla_1_N = mkN "handtralla" ; -- handtralla..nn.1
  handtryckning_1_N = mkN "handtryckning" ; -- handtryckning..nn.1
  handtvagning_1_N = mkN "handtvagning" ; -- handtvagning..nn.1
  handtvätt_1_N = mkN "handtvätt" ; -- handtvätt..nn.1
  handtvätt_2_N = mkN "handtvätt" ; -- handtvätt..nn.2
  handuppräckning_1_N = mkN "handuppräckning" ; -- handuppräckning..nn.1
  handvapen_1_N = mkN "handvapen" "handvapnet" "handvapen" "handvapnen" ; -- handvapen..nn.1
  handvind_1_N = mkN "handvind" ; -- handvind..nn.1
  handvinsch_1_N = mkN "handvinsch" ; -- handvinsch..nn.1
  handvolt_1_N = mkN "handvolt" "handvolter" ; -- handvolt..nn.1
  handvärmare_1_N = mkN "handvärmare" utrum  ; -- handvärmare..nn.1
  handväska_1_N = mkN "handväska" ; -- handväska..nn.1
  handyxa_1_N = mkN "handyxa" ; -- handyxa..nn.1
  hane_1_N = mkN "hane" utrum  ; -- hane..nn.1
  hanegäll_1_N = mkN "hanegäll" neutrum  ; -- hanegäll..nn.1
  hanfot_1_N = mkN "hanfot" ; -- hanfot..nn.1
  hang_1_N = mkN "hang" neutrum  ; -- hang..nn.1
  hangar_1_N = mkN "hangar" "hangarer" ; -- hangar..nn.1
  hangarfartyg_1_N = mkN "hangarfartyg" neutrum  ; -- hangarfartyg..nn.1
  hangarfartygsflotta_1_N = mkN "hangarfartygsflotta" ; -- hangarfartygsflotta..nn.1
  hangarversion_1_N = mkN "hangarversion" ; -- hangarversion..nn.1
  hanglig_1_A = mkA "hanglig" ; -- hanglig..av.1
  hank_1_N = mkN "hank" ; -- hank..nn.1
  hanka_1_V = mkV "hankar" ; -- hanka..vb.1
  hankande_1_N = mkN "hankande" ; -- hankande..nn.1
  hankön_1_N = mkN "hankön" neutrum  ; -- hankön..nn.1
  hankönad_1_A = mkA "hankönad" ; -- hankönad..av.1
  hanlig_1_A = mkA "hanlig" ; -- hanlig..av.1
  hanne_1_N = mkN "hanne" utrum  ; -- hanne..nn.1
  hanorgan_1_N = mkN "hanorgan" neutrum  ; -- hanorgan..nn.1
  hanrej_1_N = mkN "hanrej" ; -- hanrej..nn.1
  hantel_1_N = mkN "hantel" ; -- hantel..nn.1
  hantera_1_V = mkV "hanterar" ; -- hantera..vb.1
  hanterande_1_N = mkN "hanterande" ; -- hanterande..nn.1
  hanterbar_1_A = mkA "hanterbar" ; -- hanterbar..av.1
  hanterbarhet_1_N = mkN "hanterbarhet" ; -- hanterbarhet..nn.1
  hantering_1_N = mkN "hantering" ; -- hantering..nn.1
  hanteringskostnad_1_N = mkN "hanteringskostnad" "hanteringskostnader" ; -- hanteringskostnad..nn.1
  hanteringsrisk_1_N = mkN "hanteringsrisk" "hanteringsrisker" ; -- hanteringsrisk..nn.1
  hanterlig_1_A = mkA "hanterlig" ; -- hanterlig..av.1
  hanterlighet_1_N = mkN "hanterlighet" ; -- hanterlighet..nn.1
  hantlangare_1_N = mkN "hantlangare" utrum  ; -- hantlangare..nn.1
  hantverk_1_N = mkN "hantverk" neutrum  ; -- hantverk..nn.1
  hantverkare_1_N = mkN "hantverkare" utrum  ; -- hantverkare..nn.1
  hantverkarsats_1_N = mkN "hantverkarsats" "hantverkarsatser" ; -- hantverkarsats..nn.1
  hantverksarbetare_1_N = mkN "hantverksarbetare" utrum  ; -- hantverksarbetare..nn.1
  hantverksförening_1_N = mkN "hantverksförening" ; -- hantverksförening..nn.1
  hantverksjobb_1_N = mkN "hantverksjobb" neutrum  ; -- hantverksjobb..nn.1
  hantverksmässig_1_A = mkA "hantverksmässig" ; -- hantverksmässig..av.1
  hantverksmässighet_1_N = mkN "hantverksmässighet" ; -- hantverksmässighet..nn.1
  hantverksskicklighet_1_N = mkN "hantverksskicklighet" "hantverksskickligheter" ; -- hantverksskicklighet..nn.1
  haploid_1_A = mkA "haploid" ; -- haploid..av.1
  happening_1_N = mkN "happening" ; -- happening..nn.1
  haptoglobin_1_N = mkN "haptoglobin" "haptoglobiner" ; -- haptoglobin..nn.1
  harang_1_N = mkN "harang" "haranger" ; -- harang..nn.1
  harangera_1_V = mkV "harangerar" ; -- harangera..vb.1
  harangerande_1_N = mkN "harangerande" ; -- harangerande..nn.1
  harangerbar_1_A = mkA "harangerbar" ; -- harangerbar..av.1
  harangerbarhet_1_N = mkN "harangerbarhet" ; -- harangerbarhet..nn.1
  harangering_1_N = mkN "harangering" ; -- harangering..nn.1
  hardangersöm_1_N = mkN "hardangersöm" "hardangersömmen" "hardangersömmar" "hardangersömmarna" ; -- hardangersöm..nn.1
  hardcore_1_N = mkN "hardcore" utrum  ; -- hardcore..nn.1
  hare_1_N = mkN "hare" "harar" ; -- hare..nn.1
  harem_1_N = mkN "harem" neutrum  ; -- harem..nn.1
  haremsdam_1_N = mkN "haremsdam" "haremsdamer" ; -- haremsdam..nn.1
  harhanne_1_N = mkN "harhanne" utrum  ; -- harhanne..nn.1
  harhjärta_1_N = mkN "harhjärta" "harhjärtat" "harhjärtan" "harhjärtana" ; -- harhjärta..nn.1
  harhjärtad_1_A = mkA "harhjärtad" ; -- harhjärtad..av.1
  harhona_1_N = mkN "harhona" ; -- harhona..nn.1
  harig_1_A = mkA "harig" ; -- harig..av.1
  harkla_1_V = mkV "harklar" ; -- harkla..vb.1
  harklande_1_N = mkN "harklande" ; -- harklande..nn.1
  harkling_1_N = mkN "harkling" ; -- harkling..nn.1
  harklöver_1_N = mkN "harklöver" ; -- harklöver..nn.1
  harkrank_1_N = mkN "harkrank" ; -- harkrank..nn.1
  harlekin_1_N = mkN "harlekin" "harlekiner" ; -- harlekin..nn.1
  harläpp_1_N = mkN "harläpp" ; -- harläpp..nn.1
  harm_1_N = mkN "harm" ; -- harm..nn.1
  harma_1_V = mkV "harmar" ; -- harma..vb.1
  harmageddonvarning_1_N = mkN "harmageddonvarning" ; -- harmageddonvarning..nn.1
  harmande_1_N = mkN "harmande" ; -- harmande..nn.1
  harmfull_1_A = mkA "harmfull" ; -- harmfull..av.1
  harmfullhet_1_N = mkN "harmfullhet" ; -- harmfullhet..nn.1
  harmfylld_1_A = mkA "harmfylld" "harmfyllt" ; -- harmfylld..av.1
  harmfylldhet_1_N = mkN "harmfylldhet" ; -- harmfylldhet..nn.1
  harmlig_1_A = mkA "harmlig" ; -- harmlig..av.1
  harmlighet_1_N = mkN "harmlighet" ; -- harmlighet..nn.1
  harmlös_1_A = mkA "harmlös" ; -- harmlös..av.1
  harmlöshet_1_N = mkN "harmlöshet" "harmlösheter" ; -- harmlöshet..nn.1
  harmoni_1_N = mkN "harmoni" "harmonier" ; -- harmoni..nn.1
  harmoniera_1_V = mkV "harmonierar" ; -- harmoniera..vb.1
  harmonierande_1_N = mkN "harmonierande" ; -- harmonierande..nn.1
  harmoniering_1_N = mkN "harmoniering" ; -- harmoniering..nn.1
  harmonik_1_N = mkN "harmonik" ; -- harmonik..nn.1
  harmonika_1_N = mkN "harmonika" ; -- harmonika..nn.1
  harmonilära_1_N = mkN "harmonilära" ; -- harmonilära..nn.1
  harmonisera_1_V = mkV "harmoniserar" ; -- harmonisera..vb.1
  harmoniserande_1_N = mkN "harmoniserande" ; -- harmoniserande..nn.1
  harmoniserbar_1_A = mkA "harmoniserbar" ; -- harmoniserbar..av.1
  harmoniserbarhet_1_N = mkN "harmoniserbarhet" ; -- harmoniserbarhet..nn.1
  harmonisering_1_N = mkN "harmonisering" ; -- harmonisering..nn.1
  harmonisk_1_A = mkA "harmonisk" ; -- harmonisk..av.1
  harmonium_1_N = mkN "harmonium" "harmoniet" "harmonier" "harmonierna" ; -- harmonium..nn.1
  harmsen_1_A = mkA "harmsen" ; -- harmsen..av.1
  harmsenhet_1_N = mkN "harmsenhet" ; -- harmsenhet..nn.1
  harmynt_1_A = mkA "harmynt" "harmynt" ; -- harmynt..av.1
  harmynthet_1_N = mkN "harmynthet" ; -- harmynthet..nn.1
  harnesk_1_N = mkN "harnesk" neutrum  ; -- harnesk..nn.1
  harpa_1_N = mkN "harpa" ; -- harpa..nn.1
  harpalt_1_N = mkN "harpalt" ; -- harpalt..nn.1
  harpest_1_N = mkN "harpest" ; -- harpest..nn.1
  harpist_1_N = mkN "harpist" "harpister" ; -- harpist..nn.1
  harpoton_1_N = mkN "harpoton" "harpotoner" ; -- harpoton..nn.1
  harpspel_1_N = mkN "harpspel" "harpspelet" "harpspel" "harpspelen" ; -- harpspel..nn.1
  harpun_1_N = mkN "harpun" "harpuner" ; -- harpun..nn.1
  harpunera_1_V = mkV "harpunerar" ; -- harpunera..vb.1
  harpunerande_1_N = mkN "harpunerande" ; -- harpunerande..nn.1
  harpunerbar_1_A = mkA "harpunerbar" ; -- harpunerbar..av.1
  harpunerbarhet_1_N = mkN "harpunerbarhet" ; -- harpunerbarhet..nn.1
  harpunering_1_N = mkN "harpunering" ; -- harpunering..nn.1
  harpunliknande_1_A = mkA "harpunliknande" ; -- harpunliknande..av.1
  harpya_1_N = mkN "harpya" ; -- harpya..nn.1
  harpyja_1_N = mkN "harpyja" ; -- harpyja..nn.1
  harr_1_N = mkN "harr" ; -- harr..nn.1
  harskla_1_V = mkV "harsklar" ; -- harskla..vb.1
  harsklande_1_N = mkN "harsklande" ; -- harsklande..nn.1
  harskramla_1_N = mkN "harskramla" ; -- harskramla..nn.1
  harspår_1_N = mkN "harspår" neutrum  ; -- harspår..nn.1
  harstig_1_N = mkN "harstig" ; -- harstig..nn.1
  harsyra_1_N = mkN "harsyra" ; -- harsyra..nn.1
  hartass_1_N = mkN "hartass" ; -- hartass..nn.1
  hartnär_1_Adv = mkAdv "hartnär" ; -- hartnär..ab.1
  harts_1_N = mkN "harts" "hartset" "hartser" "hartserna" ; -- harts..nn.1
  hartsa_1_V = mkV "hartsar" ; -- hartsa..vb.1
  hartsande_1_N = mkN "hartsande" ; -- hartsande..nn.1
  hartsfiol_1_N = mkN "hartsfiol" "hartsfioler" ; -- hartsfiol..nn.1
  hartsig_1_A = mkA "hartsig" ; -- hartsig..av.1
  hartsning_1_N = mkN "hartsning" ; -- hartsning..nn.1
  harv_1_N = mkN "harv" ; -- harv..nn.1
  harva_1_V = mkV "harvar" ; -- harva..vb.1
  harvande_1_N = mkN "harvande" ; -- harvande..nn.1
  has_1_N = mkN "has" ; -- has..nn.1
  hasa_1_V = mkV "hasar" ; -- hasa..vb.1
  hasa_2_V = mkV "hasar" ; -- hasa..vb.2
  hasande_1_N = mkN "hasande" ; -- hasande..nn.1
  hasard_1_N = mkN "hasard" ; -- hasard..nn.1
  hasardera_1_V = mkV "hasarderar" ; -- hasardera..vb.1
  hasarderande_1_N = mkN "hasarderande" ; -- hasarderande..nn.1
  hasarderbar_1_A = mkA "hasarderbar" ; -- hasarderbar..av.1
  hasarderbarhet_1_N = mkN "hasarderbarhet" ; -- hasarderbarhet..nn.1
  hasardering_1_N = mkN "hasardering" ; -- hasardering..nn.1
  hasardspel_1_N = mkN "hasardspel" "hasardspelet" "hasardspel" "hasardspelen" ; -- hasardspel..nn.1
  hasardspelare_1_N = mkN "hasardspelare" utrum  ; -- hasardspelare..nn.1
  hasch_1_N = mkN "hasch" ; -- hasch..nn.1
  haschcigarett_1_N = mkN "haschcigarett" "haschcigaretter" ; -- haschcigarett..nn.1
  haschhisch_1_N = mkN "haschhisch" ; -- haschhisch..nn.1
  haschhög_1_A = mkA "haschhög" ; -- haschhög..av.1
  haschisch_1_N = mkN "haschisch" ; -- haschisch..nn.1
  haschrökning_1_N = mkN "haschrökning" ; -- haschrökning..nn.1
  haschtomte_1_N = mkN "haschtomte" utrum  ; -- haschtomte..nn.1
  hashtag_1_N = mkN "hashtag" ; -- hashtag..nn.1
  hashtagg_1_N = mkN "hashtagg" ; -- hashtagg..nn.1
  hasp_1_N = mkN "hasp" ; -- hasp..nn.1
  haspa_1_V = mkV "haspar" ; -- haspa..vb.1
  haspande_1_N = mkN "haspande" ; -- haspande..nn.1
  haspel_1_N = mkN "haspel" ; -- haspel..nn.1
  haspelfiske_1_N = mkN "haspelfiske" ; -- haspelfiske..nn.1
  haspla_1_V = mkV "hasplar" ; -- haspla..vb.1
  hasplande_1_N = mkN "hasplande" ; -- hasplande..nn.1
  haspling_1_N = mkN "haspling" ; -- haspling..nn.1
  hassel_1_N = mkN "hassel" ; -- hassel..nn.1
  hasselmus_1_N = mkN "hasselmus" "hasselmusen" "hasselmöss" "hasselmössen" ; -- hasselmus..nn.1
  hasselnöt_1_N = mkN "hasselnöt" "hasselnötter" ; -- hasselnöt..nn.1
  hasselsnok_1_N = mkN "hasselsnok" ; -- hasselsnok..nn.1
  hast_1_N = mkN "hast" ; -- hast..nn.1
  hasta_1_V = mkV "hastar" ; -- hasta..vb.1
  hastande_1_N = mkN "hastande" ; -- hastande..nn.1
  hastig_1_A = mkA "hastig" ; -- hastig..av.1
  hastighet_1_N = mkN "hastighet" "hastigheter" ; -- hastighet..nn.1
  hastighetsgräns_1_N = mkN "hastighetsgräns" "hastighetsgränser" ; -- hastighetsgräns..nn.1
  hastighetskontroll_1_N = mkN "hastighetskontroll" "hastighetskontroller" ; -- hastighetskontroll..nn.1
  hastighetsmätare_1_N = mkN "hastighetsmätare" utrum  ; -- hastighetsmätare..nn.1
  hastighetsreglage_1_N = mkN "hastighetsreglage" "hastighetsreglaget" "hastighetsreglage" "hastighetsreglagen" ; -- hastighetsreglage..nn.1
  hastighetstävling_1_N = mkN "hastighetstävling" ; -- hastighetstävling..nn.1
  hastighetsåkning_1_N = mkN "hastighetsåkning" ; -- hastighetsåkning..nn.1
  hastverk_1_N = mkN "hastverk" neutrum  ; -- hastverk..nn.1
  hat_1_N = mkN "hat" neutrum  ; -- hat..nn.1
  hata_1_V = mkV "hatar" ; -- hata..vb.1
  hatande_1_N = mkN "hatande" ; -- hatande..nn.1
  hatare_1_N = mkN "hatare" utrum  ; -- hatare..nn.1
  hatbrev_1_N = mkN "hatbrev" neutrum  ; -- hatbrev..nn.1
  hatbrott_1_N = mkN "hatbrott" neutrum  ; -- hatbrott..nn.1
  hatfull_1_A = mkA "hatfull" ; -- hatfull..av.1
  hatfullhet_1_N = mkN "hatfullhet" ; -- hatfullhet..nn.1
  hatfylld_1_A = mkA "hatfylld" "hatfyllt" ; -- hatfylld..av.1
  hatfylldhet_1_N = mkN "hatfylldhet" ; -- hatfylldhet..nn.1
  hatgrupp_1_N = mkN "hatgrupp" "hatgrupper" ; -- hatgrupp..nn.1
  hatisk_1_A = mkA "hatisk" ; -- hatisk..av.1
  hatkänsla_1_N = mkN "hatkänsla" ; -- hatkänsla..nn.1
  hatkärlek_1_N = mkN "hatkärlek" ; -- hatkärlek..nn.1
  hatobjekt_1_N = mkN "hatobjekt" neutrum  ; -- hatobjekt..nn.1
  hatporträtt_1_N = mkN "hatporträtt" neutrum  ; -- hatporträtt..nn.1
  hatretorik_1_N = mkN "hatretorik" ; -- hatretorik..nn.1
  hatsajt_1_N = mkN "hatsajt" "hatsajter" ; -- hatsajt..nn.1
  hatsamtal_1_N = mkN "hatsamtal" neutrum  ; -- hatsamtal..nn.1
  hatstämning_1_N = mkN "hatstämning" ; -- hatstämning..nn.1
  hatt_1_N = mkN "hatt" ; -- hatt..nn.1
  hatta_1_V = mkV "hattar" ; -- hatta..vb.1
  hattande_1_N = mkN "hattande" ; -- hattande..nn.1
  hattask_1_N = mkN "hattask" ; -- hattask..nn.1
  hattavtagning_1_N = mkN "hattavtagning" ; -- hattavtagning..nn.1
  hatthylla_1_N = mkN "hatthylla" ; -- hatthylla..nn.1
  hattig_1_A = mkA "hattig" ; -- hattig..av.1
  hattighet_1_N = mkN "hattighet" ; -- hattighet..nn.1
  hattkulle_1_N = mkN "hattkulle" utrum  ; -- hattkulle..nn.1
  hattparti_1_N = mkN "hattparti" neutrum  ; -- hattparti..nn.1
  hattrick_1_N = mkN "hattrick" neutrum  ; -- hattrick..nn.1
  hattstock_1_N = mkN "hattstock" ; -- hattstock..nn.1
  hattsvamp_1_N = mkN "hattsvamp" ; -- hattsvamp..nn.1
  haubits_1_N = mkN "haubits" ; -- haubits..nn.1
  haubitz_1_N = mkN "haubitz" ; -- haubitz..nn.1
  hausa_1_N = mkN "hausa" ; -- hausa..nn.1
  hausa_2_N = mkN "hausa" ; -- hausa..nn.2
  haussa_1_V = mkV "haussar" ; -- haussa..vb.1
  haussande_1_N = mkN "haussande" ; -- haussande..nn.1
  hausse_1_N = mkN "hausse" "hausser" ; -- hausse..nn.1
  hav_1_N = mkN "hav" neutrum  ; -- hav..nn.1
  hav_2_N = mkN "hav" neutrum  ; -- hav..nn.2
  havande_1_A = mkA "havande" ; -- havande..av.1
  havande_1_N = mkN "havande" ; -- havande..nn.1
  havandeskap_1_N = mkN "havandeskap" neutrum  ; -- havandeskap..nn.1
  havandeskapsförgiftning_1_N = mkN "havandeskapsförgiftning" ; -- havandeskapsförgiftning..nn.1
  havanna_1_N = mkN "havanna" ; -- havanna..nn.1
  havannacigarr_1_N = mkN "havannacigarr" "havannacigarrer" ; -- havannacigarr..nn.1
  haverera_1_V = mkV "havererar" ; -- haverera..vb.1
  havererande_1_N = mkN "havererande" ; -- havererande..nn.1
  havererbar_1_A = mkA "havererbar" ; -- havererbar..av.1
  havererbarhet_1_N = mkN "havererbarhet" ; -- havererbarhet..nn.1
  haverering_1_N = mkN "haverering" ; -- haverering..nn.1
  haveri_1_N = mkN "haveri" "haveriet" "haverier" "haverierna" ; -- haveri..nn.1
  haverikommission_1_N = mkN "haverikommission" ; -- haverikommission..nn.1
  haverist_1_N = mkN "haverist" "haverister" ; -- haverist..nn.1
  haveriutredning_1_N = mkN "haveriutredning" ; -- haveriutredning..nn.1
  haverrot_1_N = mkN "haverrot" ; -- haverrot..nn.1
  havre_1_N = mkN "havre" utrum  ; -- havre..nn.1
  havreflarn_1_N = mkN "havreflarn" neutrum  ; -- havreflarn..nn.1
  havregryn_1_N = mkN "havregryn" neutrum  ; -- havregryn..nn.1
  havregrynsgröt_1_N = mkN "havregrynsgröt" ; -- havregrynsgröt..nn.1
  havrekaka_1_N = mkN "havrekaka" ; -- havrekaka..nn.1
  havrekorn_1_N = mkN "havrekorn" neutrum  ; -- havrekorn..nn.1
  havreliknande_1_A = mkA "havreliknande" ; -- havreliknande..av.1
  havremjöl_1_N = mkN "havremjöl" neutrum  ; -- havremjöl..nn.1
  havremust_1_N = mkN "havremust" ; -- havremust..nn.1
  havresoppa_1_N = mkN "havresoppa" ; -- havresoppa..nn.1
  havretraktor_1_N = mkN "havretraktor" "havretraktorer" ; -- havretraktor..nn.1
  havreåker_1_N = mkN "havreåker" ; -- havreåker..nn.1
  havsabborre_1_N = mkN "havsabborre" utrum  ; -- havsabborre..nn.1
  havsanemon_1_N = mkN "havsanemon" "havsanemoner" ; -- havsanemon..nn.1
  havsarm_1_N = mkN "havsarm" ; -- havsarm..nn.1
  havsbad_1_N = mkN "havsbad" neutrum  ; -- havsbad..nn.1
  havsband_1_N = mkN "havsband" neutrum  ; -- havsband..nn.1
  havsbaserad_1_A = mkA "havsbaserad" ; -- havsbaserad..av.1
  havsblå_1_A = mkA "havsblå" "havsblått" ; -- havsblå..av.1
  havsborstmask_1_N = mkN "havsborstmask" ; -- havsborstmask..nn.1
  havsbotten_1_N = mkN "havsbotten" ; -- havsbotten..nn.1
  havsbris_1_N = mkN "havsbris" ; -- havsbris..nn.1
  havsbrus_1_N = mkN "havsbrus" neutrum  ; -- havsbrus..nn.1
  havsbryn_1_N = mkN "havsbryn" neutrum  ; -- havsbryn..nn.1
  havsbukt_1_N = mkN "havsbukt" "havsbukter" ; -- havsbukt..nn.1
  havsdjup_1_N = mkN "havsdjup" neutrum  ; -- havsdjup..nn.1
  havsfiske_1_N = mkN "havsfiske" ; -- havsfiske..nn.1
  havsfru_1_N = mkN "havsfru" ; -- havsfru..nn.1
  havsfågel_1_N = mkN "havsfågel" ; -- havsfågel..nn.1
  havsförsurning_1_N = mkN "havsförsurning" ; -- havsförsurning..nn.1
  havsglitter_1_N = mkN "havsglitter" neutrum  ; -- havsglitter..nn.1
  havsgrön_1_A = mkA "havsgrön" ; -- havsgrön..av.1
  havsgud_1_N = mkN "havsgud" ; -- havsgud..nn.1
  havsgående_1_A = mkA "havsgående" ; -- havsgående..av.1
  havshorisont_1_N = mkN "havshorisont" "havshorisonter" ; -- havshorisont..nn.1
  havsis_1_N = mkN "havsis" ; -- havsis..nn.1
  havskajak_1_N = mkN "havskajak" "havskajaker" ; -- havskajak..nn.1
  havskappsegling_1_N = mkN "havskappsegling" ; -- havskappsegling..nn.1
  havskatt_1_N = mkN "havskatt" "havskatter" ; -- havskatt..nn.1
  havsklimat_1_N = mkN "havsklimat" neutrum  ; -- havsklimat..nn.1
  havskryssare_1_N = mkN "havskryssare" utrum  ; -- havskryssare..nn.1
  havskräfta_1_N = mkN "havskräfta" ; -- havskräfta..nn.1
  havskräftstjärt_1_N = mkN "havskräftstjärt" ; -- havskräftstjärt..nn.1
  havslax_1_N = mkN "havslax" ; -- havslax..nn.1
  havslevande_1_A = mkA "havslevande" ; -- havslevande..av.1
  havsluft_1_N = mkN "havsluft" ; -- havsluft..nn.1
  havsmonster_1_N = mkN "havsmonster" neutrum  ; -- havsmonster..nn.1
  havsmotiv_1_N = mkN "havsmotiv" neutrum  ; -- havsmotiv..nn.1
  havsmus_1_N = mkN "havsmus" ; -- havsmus..nn.1
  havsnivå_1_N = mkN "havsnivå" "havsnivåer" ; -- havsnivå..nn.1
  havsnivåhöjning_1_N = mkN "havsnivåhöjning" ; -- havsnivåhöjning..nn.1
  havsnymf_1_N = mkN "havsnymf" "havsnymfer" ; -- havsnymf..nn.1
  havsområde_1_N = mkN "havsområde" ; -- havsområde..nn.1
  havsorganism_1_N = mkN "havsorganism" "havsorganismer" ; -- havsorganism..nn.1
  havsrätt_1_N = mkN "havsrätt" ; -- havsrätt..nn.1
  havssalt_1_N = mkN "havssalt" neutrum  ; -- havssalt..nn.1
  havsstrand_1_N = mkN "havsstrand" "havsstränder" ; -- havsstrand..nn.1
  havsström_1_N = mkN "havsström" "havsströmmen" "havsströmmar" "havsströmmarna" ; -- havsström..nn.1
  havssula_1_N = mkN "havssula" ; -- havssula..nn.1
  havstrut_1_N = mkN "havstrut" ; -- havstrut..nn.1
  havstulpan_1_N = mkN "havstulpan" "havstulpaner" ; -- havstulpan..nn.1
  havsutsikt_1_N = mkN "havsutsikt" ; -- havsutsikt..nn.1
  havsutter_1_N = mkN "havsutter" ; -- havsutter..nn.1
  havsvatten_1_N = mkN "havsvatten" "havsvattnet" "havsvatten" "havsvattnen" ; -- havsvatten..nn.1
  havsvik_1_N = mkN "havsvik" ; -- havsvik..nn.1
  havsvind_1_N = mkN "havsvind" ; -- havsvind..nn.1
  havsväxt_1_N = mkN "havsväxt" "havsväxter" ; -- havsväxt..nn.1
  havsvåg_1_N = mkN "havsvåg" "havsvågor" ; -- havsvåg..nn.1
  havsyta_1_N = mkN "havsyta" ; -- havsyta..nn.1
  havsöra_1_N = mkN "havsöra" "havsörat" "havsöron" "havsöronen" ; -- havsöra..nn.1
  havsörn_1_N = mkN "havsörn" ; -- havsörn..nn.1
  havsörnspar_1_N = mkN "havsörnspar" neutrum  ; -- havsörnspar..nn.1
  havtorn_1_N = mkN "havtorn" ; -- havtorn..nn.1
  hawaiiansk_1_A = mkA "hawaiiansk" ; -- hawaiiansk..av.1
  hawaiisk_1_A = mkA "hawaiisk" ; -- hawaiisk..av.1
  hbt_certifiera_1_V = mkV "hbt-certifierar" ; -- hbt-certifiera..vb.1
  hbt_certifierad_1_A = mkA "hbt-certifierad" ; -- hbt-certifierad..av.1
  hbt_person_1_N = mkN "hbt-person" "hbt-personer" ; -- hbt-person..nn.1
  he_man_1_N = mkN "he-man" "he-mannen" "he-män" "he-männen" ; -- he-man..nn.1
  healing_1_N = mkN "healing" ; -- healing..nn.1
  hearing_1_N = mkN "hearing" ; -- hearing..nn.1
  heat_1_N = mkN "heat" neutrum  ; -- heat..nn.1
  hebreisk_1_A = mkA "hebreisk" ; -- hebreisk..av.1
  hebreiska_1_N = mkN "hebreiska" ; -- hebreiska..nn.1
  hebré_1_N = mkN "hebré" "hebréer" ; -- hebré..nn.1
  hed_1_N = mkN "hed" ; -- hed..nn.1
  heden_1_A = mkA "heden" ; -- heden..av.1
  hedendom_1_N = mkN "hedendom" ; -- hedendom..nn.1
  hedenhet_1_N = mkN "hedenhet" ; -- hedenhet..nn.1
  hedenhös_1_N = mkN "hedenhös" ; -- hedenhös..nn.1
  heder_1_N = mkN "heder" ; -- heder..nn.1
  hederlig_1_A = mkA "hederlig" ; -- hederlig..av.1
  hederlighet_1_N = mkN "hederlighet" ; -- hederlighet..nn.1
  hedersam_1_A = mkA "hedersam" "hedersamt" "hedersamma" "hedersamma" "hedersammare" "hedersammast" "hedersammaste" ; -- hedersam..av.1
  hedersamhet_1_N = mkN "hedersamhet" ; -- hedersamhet..nn.1
  hedersbegrepp_1_N = mkN "hedersbegrepp" neutrum  ; -- hedersbegrepp..nn.1
  hedersbetygelse_1_N = mkN "hedersbetygelse" "hedersbetygelser" ; -- hedersbetygelse..nn.1
  hedersbevisning_1_N = mkN "hedersbevisning" ; -- hedersbevisning..nn.1
  hedersborgare_1_N = mkN "hedersborgare" utrum  ; -- hedersborgare..nn.1
  hedersdoktor_1_N = mkN "hedersdoktor" "hedersdoktorer" ; -- hedersdoktor..nn.1
  hedersdomstol_1_N = mkN "hedersdomstol" ; -- hedersdomstol..nn.1
  hedersgäst_1_N = mkN "hedersgäst" "hedersgäster" ; -- hedersgäst..nn.1
  hedersgåva_1_N = mkN "hedersgåva" ; -- hedersgåva..nn.1
  hedersknyffel_1_N = mkN "hedersknyffel" ; -- hedersknyffel..nn.1
  hederskodex_1_N = mkN "hederskodex" ; -- hederskodex..nn.1
  hederskompani_1_N = mkN "hederskompani" "hederskompaniet" "hederskompanier" "hederskompanierna" ; -- hederskompani..nn.1
  hederskonflikt_1_N = mkN "hederskonflikt" "hederskonflikter" ; -- hederskonflikt..nn.1
  hederskultur_1_N = mkN "hederskultur" "hederskulturer" ; -- hederskultur..nn.1
  hederskänsla_1_N = mkN "hederskänsla" ; -- hederskänsla..nn.1
  hedersledamot_1_N = mkN "hedersledamot" "hedersledamöter" ; -- hedersledamot..nn.1
  hedersman_1_N = mkN "hedersman" "hedersmannen" "hedersmän" "hedersmännen" ; -- hedersman..nn.1
  hedersmantel_1_N = mkN "hedersmantel" ; -- hedersmantel..nn.1
  hedersmedalj_1_N = mkN "hedersmedalj" "hedersmedaljer" ; -- hedersmedalj..nn.1
  hedersmedlem_1_N = mkN "hedersmedlem" "hedersmedlemmen" "hedersmedlemmar" "hedersmedlemmarna" ; -- hedersmedlem..nn.1
  hedersmord_1_N = mkN "hedersmord" neutrum  ; -- hedersmord..nn.1
  hedersnamn_1_N = mkN "hedersnamn" neutrum  ; -- hedersnamn..nn.1
  hedersomnämnande_1_N = mkN "hedersomnämnande" ; -- hedersomnämnande..nn.1
  hedersord_1_N = mkN "hedersord" neutrum  ; -- hedersord..nn.1
  hedersordförande_1_N = mkN "hedersordförande" "hedersordföranden" "hedersordföranden" "hedersordförandena" ; -- hedersordförande..nn.1
  hederspascha_1_N = mkN "hederspascha" ; -- hederspascha..nn.1
  hedersplats_1_N = mkN "hedersplats" "hedersplatser" ; -- hedersplats..nn.1
  hederspost_1_N = mkN "hederspost" "hedersposter" ; -- hederspost..nn.1
  hederspris_1_N = mkN "hederspris" neutrum  ; -- hederspris..nn.1
  hedersrelaterad_1_A = mkA "hedersrelaterad" ; -- hedersrelaterad..av.1
  hederssak_1_N = mkN "hederssak" "hederssaker" ; -- hederssak..nn.1
  hedersskuld_1_N = mkN "hedersskuld" "hedersskulder" ; -- hedersskuld..nn.1
  hederstecken_1_N = mkN "hederstecken" "hederstecknet" "hederstecken" "hederstecknen" ; -- hederstecken..nn.1
  hederstitel_1_N = mkN "hederstitel" ; -- hederstitel..nn.1
  hedersutmärkelse_1_N = mkN "hedersutmärkelse" "hedersutmärkelser" ; -- hedersutmärkelse..nn.1
  hedersvakt_1_N = mkN "hedersvakt" "hedersvakter" ; -- hedersvakt..nn.1
  hedervärd_1_A = mkA "hedervärd" "hedervärt" ; -- hedervärd..av.1
  hedervärdhet_1_N = mkN "hedervärdhet" ; -- hedervärdhet..nn.1
  hedmark_1_N = mkN "hedmark" "hedmarker" ; -- hedmark..nn.1
  hednamission_1_N = mkN "hednamission" ; -- hednamission..nn.1
  hednatempel_1_N = mkN "hednatempel" neutrum  ; -- hednatempel..nn.1
  hednatid_1_N = mkN "hednatid" "hednatider" ; -- hednatid..nn.1
  hedning_1_N = mkN "hedning" ; -- hedning..nn.1
  hednisk_1_A = mkA "hednisk" ; -- hednisk..av.1
  hedonism_1_N = mkN "hedonism" "hedonismer" ; -- hedonism..nn.1
  hedonist_1_N = mkN "hedonist" "hedonister" ; -- hedonist..nn.1
  hedonistisk_1_A = mkA "hedonistisk" ; -- hedonistisk..av.1
  hedra_1_V = mkV "hedrar" ; -- hedra..vb.1
  hedrande_1_A = mkA "hedrande" ; -- hedrande..av.1
  hedrande_1_N = mkN "hedrande" ; -- hedrande..nn.1
  hegemoni_1_N = mkN "hegemoni" "hegemonier" ; -- hegemoni..nn.1
  hej_1_N = mkN "hej" neutrum  ; -- hej..nn.1
  heja_1_V = mkV "hejar" ; -- heja..vb.1
  hejaklack_1_N = mkN "hejaklack" ; -- hejaklack..nn.1
  hejande_1_N = mkN "hejande" ; -- hejande..nn.1
  hejaramsa_1_N = mkN "hejaramsa" ; -- hejaramsa..nn.1
  hejare_1_N = mkN "hejare" utrum  ; -- hejare..nn.1
  hejarklack_1_N = mkN "hejarklack" ; -- hejarklack..nn.1
  hejd_1_N = mkN "hejd" ; -- hejd..nn.1
  hejda_1_V = mkV "hejdar" ; -- hejda..vb.1
  hejdande_1_N = mkN "hejdande" ; -- hejdande..nn.1
  hejdlös_1_A = mkA "hejdlös" ; -- hejdlös..av.1
  hejdlöshet_1_N = mkN "hejdlöshet" "hejdlösheter" ; -- hejdlöshet..nn.1
  hejduk_1_N = mkN "hejduk" ; -- hejduk..nn.1
  hejdundrande_1_A = mkA "hejdundrande" ; -- hejdundrande..av.1
  hejig_1_A = mkA "hejig" ; -- hejig..av.1
  hejvild_1_A = mkA "hejvild" "hejvilt" ; -- hejvild..av.1
  hejvilt_1_Adv = mkAdv "hejvilt" ; -- hejvilt..ab.1
  hekatomb_1_N = mkN "hekatomb" "hekatomber" ; -- hekatomb..nn.1
  hekatomboffer_1_N = mkN "hekatomboffer" neutrum  ; -- hekatomboffer..nn.1
  hektar_1_N = mkN "hektar" neutrum  ; -- hektar..nn.1
  hektisk_1_A = mkA "hektisk" ; -- hektisk..av.1
  hekto_1_N = mkN "hekto" "hektot" "hekton" "hektona" ; -- hekto..nn.1
  hektograf_1_N = mkN "hektograf" "hektografer" ; -- hektograf..nn.1
  hektografera_1_V = mkV "hektograferar" ; -- hektografera..vb.1
  hektograferande_1_N = mkN "hektograferande" ; -- hektograferande..nn.1
  hektograferbar_1_A = mkA "hektograferbar" ; -- hektograferbar..av.1
  hektograferbarhet_1_N = mkN "hektograferbarhet" ; -- hektograferbarhet..nn.1
  hektografering_1_N = mkN "hektografering" ; -- hektografering..nn.1
  hektogram_1_N = mkN "hektogram" "hektogrammet" "hektogram" "hektogrammen" ; -- hektogram..nn.1
  hektoliter_1_N = mkN "hektoliter" "hektolitern" "hektoliter" "hektoliterna" ; -- hektoliter..nn.1
  hel_1_A = mkA "hel" ; -- hel..av.1
  hela_1_N = mkN "hela" ; -- hela..nn.1
  hela_1_V = mkV "helar" ; -- hela..vb.1
  helafton_1_N = mkN "helafton" "helaftonen" "helaftnar" "helaftnarna" ; -- helafton..nn.1
  helande_1_N = mkN "helande" ; -- helande..nn.1
  helautomatisk_1_A = mkA "helautomatisk" ; -- helautomatisk..av.1
  helbild_1_N = mkN "helbild" "helbilder" ; -- helbild..nn.1
  helblå_1_A = mkA "helblå" "helblått" ; -- helblå..av.1
  helbror_1_N = mkN "helbror" "helbröder" ; -- helbror..nn.1
  helbrägda_1_A = mkA "helbrägda" ; -- helbrägda..av.1
  helbrägdagörelse_1_N = mkN "helbrägdagörelse" "helbrägdagörelser" ; -- helbrägdagörelse..nn.1
  helbutelj_1_N = mkN "helbutelj" "helbuteljer" ; -- helbutelj..nn.1
  heldag_1_N = mkN "heldag" ; -- heldag..nn.1
  heldaglig_1_A = mkA "heldaglig" ; -- heldaglig..av.1
  heldragen_1_A = mkA "heldragen" ; -- heldragen..av.1
  heldäckad_1_A = mkA "heldäckad" ; -- heldäckad..av.1
  helfabrikat_1_N = mkN "helfabrikat" neutrum  ; -- helfabrikat..nn.1
  helfet_1_A = mkA "helfet" ; -- helfet..av.1
  helfigur_1_N = mkN "helfigur" "helfigurer" ; -- helfigur..nn.1
  helfransk_1_A = mkA "helfransk" ; -- helfransk..av.1
  helförlamad_1_A = mkA "helförlamad" ; -- helförlamad..av.1
  helförsäkra_1_V = mkV "helförsäkrar" ; -- helförsäkra..vb.1
  helförsäkrande_1_N = mkN "helförsäkrande" ; -- helförsäkrande..nn.1
  helförsäkring_1_N = mkN "helförsäkring" ; -- helförsäkring..nn.1
  helg_1_N = mkN "helg" "helger" ; -- helg..nn.1
  helga_1_V = mkV "helgar" ; -- helga..vb.1
  helgande_1_N = mkN "helgande" ; -- helgande..nn.1
  helgardera_1_V = mkV "helgarderar" ; -- helgardera..vb.1
  helgarderande_1_N = mkN "helgarderande" ; -- helgarderande..nn.1
  helgarderbar_1_A = mkA "helgarderbar" ; -- helgarderbar..av.1
  helgarderbarhet_1_N = mkN "helgarderbarhet" ; -- helgarderbarhet..nn.1
  helgardering_1_N = mkN "helgardering" ; -- helgardering..nn.1
  helgd_1_N = mkN "helgd" ; -- helgd..nn.1
  helgdag_1_N = mkN "helgdag" ; -- helgdag..nn.1
  helgdagsafton_1_N = mkN "helgdagsafton" "helgdagsaftonen" "helgdagsaftnar" "helgdagsaftnarna" ; -- helgdagsafton..nn.1
  helgedom_1_N = mkN "helgedom" ; -- helgedom..nn.1
  helgeflundra_1_N = mkN "helgeflundra" ; -- helgeflundra..nn.1
  helgelse_1_N = mkN "helgelse" utrum  ; -- helgelse..nn.1
  helgerån_1_N = mkN "helgerån" neutrum  ; -- helgerån..nn.1
  helgfri_1_A = mkA "helgfri" "helgfritt" ; -- helgfri..av.1
  helgjuten_1_A = mkA "helgjuten" ; -- helgjuten..av.1
  helgjuten_2_A = mkA "helgjuten" ; -- helgjuten..av.2
  helgjutenhet_1_N = mkN "helgjutenhet" ; -- helgjutenhet..nn.1
  helgledig_1_A = mkA "helgledig" ; -- helgledig..av.1
  helgmålsringning_1_N = mkN "helgmålsringning" ; -- helgmålsringning..nn.1
  helgon_1_N = mkN "helgon" neutrum  ; -- helgon..nn.1
  helgonbild_1_N = mkN "helgonbild" "helgonbilder" ; -- helgonbild..nn.1
  helgonförklara_1_V = mkV "helgonförklarar" ; -- helgonförklara..vb.1
  helgonförklarande_1_N = mkN "helgonförklarande" ; -- helgonförklarande..nn.1
  helgonförklaring_1_N = mkN "helgonförklaring" ; -- helgonförklaring..nn.1
  helgongloria_1_N = mkN "helgongloria" ; -- helgongloria..nn.1
  helgonkult_1_N = mkN "helgonkult" "helgonkulter" ; -- helgonkult..nn.1
  helgonlegend_1_N = mkN "helgonlegend" "helgonlegender" ; -- helgonlegend..nn.1
  helgonstaty_1_N = mkN "helgonstaty" "helgonstatyer" ; -- helgonstaty..nn.1
  helgsmål_1_N = mkN "helgsmål" ; -- helgsmål..nn.1
  helgsmålsringning_1_N = mkN "helgsmålsringning" ; -- helgsmålsringning..nn.1
  helgtrafik_1_N = mkN "helgtrafik" ; -- helgtrafik..nn.1
  helhet_1_N = mkN "helhet" "helheter" ; -- helhet..nn.1
  helhetsbild_1_N = mkN "helhetsbild" "helhetsbilder" ; -- helhetsbild..nn.1
  helhetsgrepp_1_N = mkN "helhetsgrepp" neutrum  ; -- helhetsgrepp..nn.1
  helhetsintryck_1_N = mkN "helhetsintryck" neutrum  ; -- helhetsintryck..nn.1
  helhetslösning_1_N = mkN "helhetslösning" ; -- helhetslösning..nn.1
  helhetssyn_1_N = mkN "helhetssyn" "helhetssyner" ; -- helhetssyn..nn.1
  helhjärtad_1_A = mkA "helhjärtad" ; -- helhjärtad..av.1
  helicobacter_1_N = mkN "helicobacter" ; -- helicobacter..nn.1
  helicobakter_1_N = mkN "helicobakter" ; -- helicobakter..nn.1
  helig_1_A = mkA "helig" ; -- helig..av.1
  helighet_1_N = mkN "helighet" "heligheter" ; -- helighet..nn.1
  helikobacter_1_N = mkN "helikobacter" ; -- helikobacter..nn.1
  helikobakter_1_N = mkN "helikobakter" ; -- helikobakter..nn.1
  helikon_1_N = mkN "helikon" neutrum  ; -- helikon..nn.1
  helikopter_1_N = mkN "helikopter" ; -- helikopter..nn.1
  helikopterbesättning_1_N = mkN "helikopterbesättning" ; -- helikopterbesättning..nn.1
  helikopterbuller_1_N = mkN "helikopterbuller" neutrum  ; -- helikopterbuller..nn.1
  helikopterburen_1_A = mkA "helikopterburen" ; -- helikopterburen..av.1
  helikopterfärd_1_N = mkN "helikopterfärd" "helikopterfärder" ; -- helikopterfärd..nn.1
  helikopterförare_1_N = mkN "helikopterförare" utrum  ; -- helikopterförare..nn.1
  helikopterkrasch_1_N = mkN "helikopterkrasch" "helikopterkrascher" ; -- helikopterkrasch..nn.1
  helikopterkupp_1_N = mkN "helikopterkupp" "helikopterkupper" ; -- helikopterkupp..nn.1
  helikopterpilot_1_N = mkN "helikopterpilot" "helikopterpiloter" ; -- helikopterpilot..nn.1
  helikopterplatta_1_N = mkN "helikopterplatta" ; -- helikopterplatta..nn.1
  helikopterrån_1_N = mkN "helikopterrån" neutrum  ; -- helikopterrån..nn.1
  helinackordera_1_V = mkV "helinackorderar" ; -- helinackordera..vb.1
  helinackorderande_1_N = mkN "helinackorderande" ; -- helinackorderande..nn.1
  helinackorderbar_1_A = mkA "helinackorderbar" ; -- helinackorderbar..av.1
  helinackorderbarhet_1_N = mkN "helinackorderbarhet" ; -- helinackorderbarhet..nn.1
  helinackordering_1_N = mkN "helinackordering" ; -- helinackordering..nn.1
  heliocentrisk_1_A = mkA "heliocentrisk" ; -- heliocentrisk..av.1
  heliofob_1_A = mkA "heliofob" ; -- heliofob..av.1
  heliograf_1_N = mkN "heliograf" "heliografer" ; -- heliograf..nn.1
  heliografi_1_N = mkN "heliografi" ; -- heliografi..nn.1
  heliostat_1_N = mkN "heliostat" "heliostater" ; -- heliostat..nn.1
  heliotrop_1_N = mkN "heliotrop" "heliotroper" ; -- heliotrop..nn.1
  helium_1_N = mkN "helium" neutrum  ; -- helium..nn.1
  heliumballong_1_N = mkN "heliumballong" "heliumballonger" ; -- heliumballong..nn.1
  heliumfylld_1_A = mkA "heliumfylld" "heliumfyllt" ; -- heliumfylld..av.1
  helkaklad_1_A = mkA "helkaklad" ; -- helkaklad..av.1
  helkonserv_1_N = mkN "helkonserv" "helkonserver" ; -- helkonserv..nn.1
  helkroppsdos_1_N = mkN "helkroppsdos" "helkroppsdoser" ; -- helkroppsdos..nn.1
  helkroppstatuering_1_N = mkN "helkroppstatuering" ; -- helkroppstatuering..nn.1
  helkväll_1_N = mkN "helkväll" ; -- helkväll..nn.1
  hellen_1_N = mkN "hellen" "hellener" ; -- hellen..nn.1
  hellenism_1_N = mkN "hellenism" "hellenismer" ; -- hellenism..nn.1
  hellenistisk_1_A = mkA "hellenistisk" ; -- hellenistisk..av.1
  hellensk_1_A = mkA "hellensk" ; -- hellensk..av.1
  heller_1_Adv = mkAdv "heller" ; -- heller..ab.1
  helljus_1_N = mkN "helljus" neutrum  ; -- helljus..nn.1
  helnot_1_N = mkN "helnot" "helnoter" ; -- helnot..nn.1
  helnykter_1_A = mkA "helnykter" ; -- helnykter..av.1
  helnykterhet_1_N = mkN "helnykterhet" ; -- helnykterhet..nn.1
  helnöjd_1_A = mkA "helnöjd" "helnöjt" ; -- helnöjd..av.1
  helomvändning_1_N = mkN "helomvändning" ; -- helomvändning..nn.1
  helpension_1_N = mkN "helpension" ; -- helpension..nn.1
  helrim_1_N = mkN "helrim" "helrimmet" "helrim" "helrimmen" ; -- helrim..nn.1
  helröd_1_A = mkA "helröd" "helrött" ; -- helröd..av.1
  helsida_1_N = mkN "helsida" ; -- helsida..nn.1
  helsiden_1_N = mkN "helsiden" neutrum  ; -- helsiden..nn.1
  helsidesannons_1_N = mkN "helsidesannons" "helsidesannonser" ; -- helsidesannons..nn.1
  helsike_1_N = mkN "helsike" ; -- helsike..nn.1
  helskinnad_1_A = mkA "helskinnad" ; -- helskinnad..av.1
  helskotta_1_N = mkN "helskotta" ; -- helskotta..nn.1
  helskugga_1_N = mkN "helskugga" ; -- helskugga..nn.1
  helskägg_1_N = mkN "helskägg" neutrum  ; -- helskägg..nn.1
  helskäggsluffare_1_N = mkN "helskäggsluffare" utrum  ; -- helskäggsluffare..nn.1
  helstatlig_1_A = mkA "helstatlig" ; -- helstatlig..av.1
  helstatlighet_1_N = mkN "helstatlighet" ; -- helstatlighet..nn.1
  helstekt_1_A = mkA "helstekt" "helstekt" ; -- helstekt..av.1
  helsvart_1_A = mkA "helsvart" "helsvart" ; -- helsvart..av.1
  helsvensk_1_A = mkA "helsvensk" ; -- helsvensk..av.1
  helsvetsad_1_A = mkA "helsvetsad" ; -- helsvetsad..av.1
  helsyskon_1_N = mkN "helsyskon" neutrum  ; -- helsyskon..nn.1
  helt_1_Adv = mkAdv "helt" ; -- helt..ab.1
  heltal_1_N = mkN "heltal" neutrum  ; -- heltal..nn.1
  heltid_1_N = mkN "heltid" "heltider" ; -- heltid..nn.1
  heltidsanställd_1_A = mkA "heltidsanställd" "heltidsanställt" ; -- heltidsanställd..av.1
  heltidsarbetande_1_A = mkA "heltidsarbetande" ; -- heltidsarbetande..av.1
  heltidsjobb_1_N = mkN "heltidsjobb" neutrum  ; -- heltidsjobb..nn.1
  heltidsjobbare_1_N = mkN "heltidsjobbare" utrum  ; -- heltidsjobbare..nn.1
  heltidslön_1_N = mkN "heltidslön" "heltidslöner" ; -- heltidslön..nn.1
  helton_1_N = mkN "helton" "heltoner" ; -- helton..nn.1
  heltäckande_1_A = mkA "heltäckande" ; -- heltäckande..av.1
  heltäckningsmatta_1_N = mkN "heltäckningsmatta" ; -- heltäckningsmatta..nn.1
  helvete_1_N = mkN "helvete" ; -- helvete..nn.1
  helvetes_1_A = mkA "helvetes" ; -- helvetes..av.1
  helveteseld_1_N = mkN "helveteseld" ; -- helveteseld..nn.1
  helveteskval_1_N = mkN "helveteskval" neutrum  ; -- helveteskval..nn.1
  helvetesmaskin_1_N = mkN "helvetesmaskin" "helvetesmaskiner" ; -- helvetesmaskin..nn.1
  helvetisk_1_A = mkA "helvetisk" ; -- helvetisk..av.1
  helvit_1_A = mkA "helvit" ; -- helvit..av.1
  helylle_1_N = mkN "helylle" ; -- helylle..nn.1
  helylletjej_1_N = mkN "helylletjej" "helylletjejer" ; -- helylletjej..nn.1
  helägd_1_A = mkA "helägd" "helägt" ; -- helägd..av.1
  helåkersbygd_1_N = mkN "helåkersbygd" "helåkersbygder" ; -- helåkersbygd..nn.1
  helår_1_N = mkN "helår" neutrum  ; -- helår..nn.1
  hem_1_N = mkN "hem" "hemmet" "hem" "hemmen" ; -- hem..nn.1
  hemarbetande_1_A = mkA "hemarbetande" ; -- hemarbetande..av.1
  hemarbete_1_N = mkN "hemarbete" ; -- hemarbete..nn.1
  hematit_1_N = mkN "hematit" "hematiter" ; -- hematit..nn.1
  hematologi_1_N = mkN "hematologi" ; -- hematologi..nn.1
  hematom_1_N = mkN "hematom" "hematomer" ; -- hematom..nn.1
  hembageri_1_N = mkN "hembageri" "hembageriet" "hembagerier" "hembagerierna" ; -- hembageri..nn.1
  hembakad_1_A = mkA "hembakad" ; -- hembakad..av.1
  hembakt_1_A = mkA "hembakt" "hembakt" ; -- hembakt..av.1
  hembesök_1_N = mkN "hembesök" neutrum  ; -- hembesök..nn.1
  hembiträde_1_N = mkN "hembiträde" ; -- hembiträde..nn.1
  hembjuda_1_V = mkV "hembjuda" "hembjöd" "hembjudit" ; -- hembjuda..vb.1
  hembjudande_1_N = mkN "hembjudande" ; -- hembjudande..nn.1
  hembjudning_1_N = mkN "hembjudning" ; -- hembjudning..nn.1
  hembryggd_1_A = mkA "hembryggd" "hembryggt" ; -- hembryggd..av.1
  hembryggning_1_N = mkN "hembryggning" ; -- hembryggning..nn.1
  hembränd_1_A = mkA "hembränd" ; -- hembränd..av.1
  hembrännare_1_N = mkN "hembrännare" utrum  ; -- hembrännare..nn.1
  hembränning_1_N = mkN "hembränning" ; -- hembränning..nn.1
  hembud_1_N = mkN "hembud" neutrum  ; -- hembud..nn.1
  hemburen_1_A = mkA "hemburen" ; -- hemburen..av.1
  hembygd_1_N = mkN "hembygd" "hembygder" ; -- hembygd..nn.1
  hembygdsforskare_1_N = mkN "hembygdsforskare" utrum  ; -- hembygdsforskare..nn.1
  hembygdsförening_1_N = mkN "hembygdsförening" ; -- hembygdsförening..nn.1
  hembygdsgård_1_N = mkN "hembygdsgård" ; -- hembygdsgård..nn.1
  hembygdsromantik_1_N = mkN "hembygdsromantik" ; -- hembygdsromantik..nn.1
  hembära_1_V = mkV "hembära" "hembar" "hemburit" ; -- hembära..vb.1
  hembärande_1_N = mkN "hembärande" ; -- hembärande..nn.1
  hemdator_1_N = mkN "hemdator" "hemdatorer" ; -- hemdator..nn.1
  hemdragande_1_A = mkA "hemdragande" ; -- hemdragande..av.1
  hemfalla_1_V = mkV "hemfalla" "hemföll" "hemfallit" ; -- hemfalla..vb.1
  hemfallande_1_N = mkN "hemfallande" ; -- hemfallande..nn.1
  hemfallen_1_A = mkA "hemfallen" ; -- hemfallen..av.1
  hemflugen_1_A = mkA "hemflugen" ; -- hemflugen..av.1
  hemfraktad_1_A = mkA "hemfraktad" ; -- hemfraktad..av.1
  hemfrid_1_N = mkN "hemfrid" ; -- hemfrid..nn.1
  hemfridsbrott_1_N = mkN "hemfridsbrott" neutrum  ; -- hemfridsbrott..nn.1
  hemföderska_1_N = mkN "hemföderska" ; -- hemföderska..nn.1
  hemföra_1_V = mkV "hemföra" "hemförde" "hemfört" ; -- hemföra..vb.1
  hemförande_1_N = mkN "hemförande" ; -- hemförande..nn.1
  hemförlossning_1_N = mkN "hemförlossning" ; -- hemförlossning..nn.1
  hemförlova_1_V = mkV "hemförlovar" ; -- hemförlova..vb.1
  hemförlovande_1_N = mkN "hemförlovande" ; -- hemförlovande..nn.1
  hemförlovning_1_N = mkN "hemförlovning" ; -- hemförlovning..nn.1
  hemförpassning_1_N = mkN "hemförpassning" ; -- hemförpassning..nn.1
  hemförsäkring_1_N = mkN "hemförsäkring" ; -- hemförsäkring..nn.1
  hemförsäljning_1_N = mkN "hemförsäljning" ; -- hemförsäljning..nn.1
  hemgalax_1_N = mkN "hemgalax" "hemgalaxer" ; -- hemgalax..nn.1
  hemgift_1_N = mkN "hemgift" "hemgifter" ; -- hemgift..nn.1
  hemgjord_1_A = mkA "hemgjord" "hemgjort" ; -- hemgjord..av.1
  hemgång_1_N = mkN "hemgång" ; -- hemgång..nn.1
  hemhjälp_1_N = mkN "hemhjälp" ; -- hemhjälp..nn.1
  hemhörig_1_A = mkA "hemhörig" ; -- hemhörig..av.1
  hemhörighet_1_N = mkN "hemhörighet" "hemhörigheter" ; -- hemhörighet..nn.1
  hemifrån_1_Adv = mkAdv "hemifrån" ; -- hemifrån..ab.1
  heminredning_1_N = mkN "heminredning" ; -- heminredning..nn.1
  hemisfär_1_N = mkN "hemisfär" "hemisfärer" ; -- hemisfär..nn.1
  hemkalla_1_V = mkV "hemkallar" ; -- hemkalla..vb.1
  hemkallande_1_N = mkN "hemkallande" ; -- hemkallande..nn.1
  hemkomst_1_N = mkN "hemkomst" ; -- hemkomst..nn.1
  hemkonsulent_1_N = mkN "hemkonsulent" "hemkonsulenter" ; -- hemkonsulent..nn.1
  hemkryddad_1_A = mkA "hemkryddad" ; -- hemkryddad..av.1
  hemkunskap_1_N = mkN "hemkunskap" ; -- hemkunskap..nn.1
  hemkänsla_1_N = mkN "hemkänsla" ; -- hemkänsla..nn.1
  hemkär_1_A = mkA "hemkär" ; -- hemkär..av.1
  hemkärnad_1_A = mkA "hemkärnad" ; -- hemkärnad..av.1
  hemkörd_1_A = mkA "hemkörd" "hemkört" ; -- hemkörd..av.1
  hemlagad_1_A = mkA "hemlagad" ; -- hemlagad..av.1
  hemland_1_N = mkN "hemland" "hemlandet" "hemländer" "hemländerna" ; -- hemland..nn.1
  hemlig_1_A = mkA "hemlig" ; -- hemlig..av.1
  hemligen_1_Adv = mkAdv "hemligen" ; -- hemligen..ab.1
  hemlighet_1_N = mkN "hemlighet" "hemligheter" ; -- hemlighet..nn.1
  hemlighetsfull_1_A = mkA "hemlighetsfull" ; -- hemlighetsfull..av.1
  hemlighetsfullhet_1_N = mkN "hemlighetsfullhet" ; -- hemlighetsfullhet..nn.1
  hemlighetsmakare_1_N = mkN "hemlighetsmakare" utrum  ; -- hemlighetsmakare..nn.1
  hemlighetsmakeri_1_N = mkN "hemlighetsmakeri" "hemlighetsmakeriet" "hemlighetsmakerier" "hemlighetsmakerierna" ; -- hemlighetsmakeri..nn.1
  hemlighus_1_N = mkN "hemlighus" neutrum  ; -- hemlighus..nn.1
  hemlighålla_1_V = mkV "hemlighålla" "hemlighöll" "hemlighållit" ; -- hemlighålla..vb.1
  hemlighållande_1_N = mkN "hemlighållande" ; -- hemlighållande..nn.1
  hemligstämpel_1_N = mkN "hemligstämpel" ; -- hemligstämpel..nn.1
  hemligstämpla_1_V = mkV "hemligstämplar" ; -- hemligstämpla..vb.1
  hemligstämplande_1_N = mkN "hemligstämplande" ; -- hemligstämplande..nn.1
  hemliv_1_N = mkN "hemliv" neutrum  ; -- hemliv..nn.1
  hemlock_1_N = mkN "hemlock" ; -- hemlock..nn.1
  hemläxa_1_N = mkN "hemläxa" ; -- hemläxa..nn.1
  hemlån_1_N = mkN "hemlån" neutrum  ; -- hemlån..nn.1
  hemlös_1_A = mkA "hemlös" ; -- hemlös..av.1
  hemlöshet_1_N = mkN "hemlöshet" ; -- hemlöshet..nn.1
  hemma_1_A = mkA "hemma" ; -- hemma..av.1
  hemmabakad_1_A = mkA "hemmabakad" ; -- hemmabakad..av.1
  hemmabakt_1_A = mkA "hemmabakt" "hemmabakt" ; -- hemmabakt..av.1
  hemmabas_1_N = mkN "hemmabas" "hemmabaser" ; -- hemmabas..nn.1
  hemmablind_1_A = mkA "hemmablind" ; -- hemmablind..av.1
  hemmablindhet_1_N = mkN "hemmablindhet" ; -- hemmablindhet..nn.1
  hemmaboende_1_A = mkA "hemmaboende" ; -- hemmaboende..av.1
  hemmabruk_1_N = mkN "hemmabruk" neutrum  ; -- hemmabruk..nn.1
  hemmabryggd_1_A = mkA "hemmabryggd" "hemmabryggt" ; -- hemmabryggd..av.1
  hemmabyggd_1_A = mkA "hemmabyggd" "hemmabyggt" ; -- hemmabyggd..av.1
  hemmadotter_1_N = mkN "hemmadotter" "hemmadottern" "hemmadöttrar" "hemmadöttrarna" ; -- hemmadotter..nn.1
  hemmafixare_1_N = mkN "hemmafixare" utrum  ; -- hemmafixare..nn.1
  hemmafront_1_N = mkN "hemmafront" ; -- hemmafront..nn.1
  hemmafru_1_N = mkN "hemmafru" ; -- hemmafru..nn.1
  hemmafruideal_1_N = mkN "hemmafruideal" neutrum  ; -- hemmafruideal..nn.1
  hemmaförlora_1_V = mkV "hemmaförlorar" ; -- hemmaförlora..vb.1
  hemmaförlust_1_N = mkN "hemmaförlust" "hemmaförluster" ; -- hemmaförlust..nn.1
  hemmagjord_1_A = mkA "hemmagjord" "hemmagjort" ; -- hemmagjord..av.1
  hemmahörande_1_A = mkA "hemmahörande" ; -- hemmahörande..av.1
  hemmahörig_1_A = mkA "hemmahörig" ; -- hemmahörig..av.1
  hemmahörighet_1_N = mkN "hemmahörighet" "hemmahörigheter" ; -- hemmahörighet..nn.1
  hemmakväll_1_N = mkN "hemmakväll" ; -- hemmakväll..nn.1
  hemmalag_1_N = mkN "hemmalag" neutrum  ; -- hemmalag..nn.1
  hemmalagad_1_A = mkA "hemmalagad" ; -- hemmalagad..av.1
  hemmaliv_1_N = mkN "hemmaliv" neutrum  ; -- hemmaliv..nn.1
  hemmaman_1_N = mkN "hemmaman" "hemmamannen" "hemmamän" "hemmamännen" ; -- hemmaman..nn.1
  hemmamarknad_1_N = mkN "hemmamarknad" "hemmamarknader" ; -- hemmamarknad..nn.1
  hemmamatch_1_N = mkN "hemmamatch" "hemmamatcher" ; -- hemmamatch..nn.1
  hemman_1_N = mkN "hemman" neutrum  ; -- hemman..nn.1
  hemmansklyvning_1_N = mkN "hemmansklyvning" ; -- hemmansklyvning..nn.1
  hemmansägare_1_N = mkN "hemmansägare" utrum  ; -- hemmansägare..nn.1
  hemmaopinion_1_N = mkN "hemmaopinion" ; -- hemmaopinion..nn.1
  hemmaplan_1_N = mkN "hemmaplan" "hemmaplaner" ; -- hemmaplan..nn.1
  hemmaproducerad_1_A = mkA "hemmaproducerad" ; -- hemmaproducerad..av.1
  hemmapublik_1_N = mkN "hemmapublik" "hemmapubliker" ; -- hemmapublik..nn.1
  hemmarock_1_N = mkN "hemmarock" ; -- hemmarock..nn.1
  hemmaseger_1_N = mkN "hemmaseger" ; -- hemmaseger..nn.1
  hemmasegra_1_V = mkV "hemmasegrar" ; -- hemmasegra..vb.1
  hemmasittande_1_A = mkA "hemmasittande" ; -- hemmasittande..av.1
  hemmasittare_1_N = mkN "hemmasittare" utrum  ; -- hemmasittare..nn.1
  hemmason_1_N = mkN "hemmason" "hemmasöner" ; -- hemmason..nn.1
  hemmaspelare_1_N = mkN "hemmaspelare" utrum  ; -- hemmaspelare..nn.1
  hemmastadd_1_A = mkA "hemmastadd" ; -- hemmastadd..av.1
  hemmastaddhet_1_N = mkN "hemmastaddhet" ; -- hemmastaddhet..nn.1
  hemmavarande_1_A = mkA "hemmavarande" ; -- hemmavarande..av.1
  hemmavid_1_Adv = mkAdv "hemmavid" ; -- hemmavid..ab.1
  hemmavinna_1_V = mkV "hemmavinna" "hemmavann" "hemmavunnit" ; -- hemmavinna..vb.1
  hemmavinst_1_N = mkN "hemmavinst" "hemmavinster" ; -- hemmavinst..nn.1
  hemmiljö_1_N = mkN "hemmiljö" "hemmiljön" "hemmiljöer" "hemmiljöerna" ; -- hemmiljö..nn.1
  hemnummer_1_N = mkN "hemnummer" neutrum  ; -- hemnummer..nn.1
  hemoglobin_1_N = mkN "hemoglobin" "hemoglobiner" ; -- hemoglobin..nn.1
  hemorrojd_1_N = mkN "hemorrojd" "hemorrojder" ; -- hemorrojd..nn.1
  hemort_1_N = mkN "hemort" "hemorter" ; -- hemort..nn.1
  hemortsrätt_1_N = mkN "hemortsrätt" ; -- hemortsrätt..nn.1
  hemproducerad_1_A = mkA "hemproducerad" ; -- hemproducerad..av.1
  hemresa_1_N = mkN "hemresa" ; -- hemresa..nn.1
  hemsamarit_1_N = mkN "hemsamarit" "hemsamariter" ; -- hemsamarit..nn.1
  hemsida_1_N = mkN "hemsida" ; -- hemsida..nn.1
  hemsjuk_1_A = mkA "hemsjuk" ; -- hemsjuk..av.1
  hemsjuka_1_N = mkN "hemsjuka" ; -- hemsjuka..nn.1
  hemsjukvård_1_N = mkN "hemsjukvård" ; -- hemsjukvård..nn.1
  hemsjukvårdsbidrag_1_N = mkN "hemsjukvårdsbidrag" neutrum  ; -- hemsjukvårdsbidrag..nn.1
  hemsk_1_A = mkA "hemsk" ; -- hemsk..av.1
  hemskhet_1_N = mkN "hemskhet" "hemskheter" ; -- hemskhet..nn.1
  hemskhet_2_N = mkN "hemskhet" ; -- hemskhet..nn.2
  hemskickad_1_A = mkA "hemskickad" ; -- hemskickad..av.1
  hemskillnad_1_N = mkN "hemskillnad" "hemskillnader" ; -- hemskillnad..nn.1
  hemskt_1_Adv = mkAdv "hemskt" ; -- hemskt..ab.1
  hemslöjd_1_N = mkN "hemslöjd" ; -- hemslöjd..nn.1
  hemslöjdare_1_N = mkN "hemslöjdare" utrum  ; -- hemslöjdare..nn.1
  hemsnickrad_1_A = mkA "hemsnickrad" ; -- hemsnickrad..av.1
  hemspråk_1_N = mkN "hemspråk" neutrum  ; -- hemspråk..nn.1
  hemstad_1_N = mkN "hemstad" "hemstäder" ; -- hemstad..nn.1
  hemstickad_1_A = mkA "hemstickad" ; -- hemstickad..av.1
  hemställa_1_V = mkV "hemställer" ; -- hemställa..vb.1
  hemställande_1_N = mkN "hemställande" ; -- hemställande..nn.1
  hemställning_1_N = mkN "hemställning" ; -- hemställning..nn.1
  hemsöka_1_V = mkV "hemsöker" ; -- hemsöka..vb.1
  hemsökande_1_N = mkN "hemsökande" ; -- hemsökande..nn.1
  hemsökelse_1_N = mkN "hemsökelse" "hemsökelser" ; -- hemsökelse..nn.1
  hemsökning_1_N = mkN "hemsökning" ; -- hemsökning..nn.1
  hemtam_1_A = mkA "hemtam" ; -- hemtam..av.1
  hemtamhet_1_N = mkN "hemtamhet" ; -- hemtamhet..nn.1
  hemtjänst_1_N = mkN "hemtjänst" "hemtjänster" ; -- hemtjänst..nn.1
  hemtrakt_1_N = mkN "hemtrakt" "hemtrakter" ; -- hemtrakt..nn.1
  hemtrevlig_1_A = mkA "hemtrevlig" ; -- hemtrevlig..av.1
  hemtrevlighet_1_N = mkN "hemtrevlighet" "hemtrevligheter" ; -- hemtrevlighet..nn.1
  hemtrevnad_1_N = mkN "hemtrevnad" ; -- hemtrevnad..nn.1
  hemtrevnad_2_N = mkN "hemtrevnad" "hemtrevnader" ; -- hemtrevnad..nn.2
  hemulsman_1_N = mkN "hemulsman" "hemulsmannen" "hemulsmän" "hemulsmännen" ; -- hemulsman..nn.1
  hemuppgift_1_N = mkN "hemuppgift" "hemuppgifter" ; -- hemuppgift..nn.1
  hemvan_1_A = mkA "hemvan" ; -- hemvan..av.1
  hemvist_1_N = mkN "hemvist" neutrum  ; -- hemvist..nn.1
  hemväg_1_N = mkN "hemväg" ; -- hemväg..nn.1
  hemvändande_1_A = mkA "hemvändande" ; -- hemvändande..av.1
  hemvändande_1_N = mkN "hemvändande" ; -- hemvändande..nn.1
  hemvärn_1_N = mkN "hemvärn" neutrum  ; -- hemvärn..nn.1
  hemvärnschef_1_N = mkN "hemvärnschef" "hemvärnschefer" ; -- hemvärnschef..nn.1
  hemvärnsgubbe_1_N = mkN "hemvärnsgubbe" utrum  ; -- hemvärnsgubbe..nn.1
  hemvärnsstyrka_1_N = mkN "hemvärnsstyrka" ; -- hemvärnsstyrka..nn.1
  hemvävd_1_A = mkA "hemvävd" "hemvävt" ; -- hemvävd..av.1
  hemvävdhet_1_N = mkN "hemvävdhet" ; -- hemvävdhet..nn.1
  hemvård_1_N = mkN "hemvård" ; -- hemvård..nn.1
  hen_1_N = mkN "hen" "henen" "henar" "henarna" ; -- hen..nn.1
  hena_1_V = mkV "henar" ; -- hena..vb.1
  henande_1_N = mkN "henande" ; -- henande..nn.1
  henna_1_N = mkN "henna" ; -- henna..nn.1
  henry_1_N = mkN "henry" "henryn" "henry" "henryna" ; -- henry..nn.1
  heparin_1_N = mkN "heparin" "hepariner" ; -- heparin..nn.1
  hepatit_1_N = mkN "hepatit" "hepatiter" ; -- hepatit..nn.1
  hepatomegali_1_N = mkN "hepatomegali" "hepatomegalier" ; -- hepatomegali..nn.1
  heraldik_1_N = mkN "heraldik" ; -- heraldik..nn.1
  heraldiker_1_N = mkN "heraldiker" "heraldikern" "heraldiker" "heraldikerna" ; -- heraldiker..nn.1
  heraldisk_1_A = mkA "heraldisk" ; -- heraldisk..av.1
  herbarium_1_N = mkN "herbarium" "herbariet" "herbarier" "herbarierna" ; -- herbarium..nn.1
  herbicid_1_N = mkN "herbicid" "herbicider" ; -- herbicid..nn.1
  herdabrev_1_N = mkN "herdabrev" neutrum  ; -- herdabrev..nn.1
  herdaminne_1_N = mkN "herdaminne" ; -- herdaminne..nn.1
  herde_1_N = mkN "herde" utrum  ; -- herde..nn.1
  herdedikt_1_N = mkN "herdedikt" "herdedikter" ; -- herdedikt..nn.1
  herdeflöjt_1_N = mkN "herdeflöjt" "herdeflöjter" ; -- herdeflöjt..nn.1
  herdefolk_1_N = mkN "herdefolk" neutrum  ; -- herdefolk..nn.1
  herdegosse_1_N = mkN "herdegosse" utrum  ; -- herdegosse..nn.1
  herdepipa_1_N = mkN "herdepipa" ; -- herdepipa..nn.1
  herdestund_1_N = mkN "herdestund" "herdestunder" ; -- herdestund..nn.1
  hereditär_1_A = mkA "hereditär" ; -- hereditär..av.1
  heresi_1_N = mkN "heresi" "heresier" ; -- heresi..nn.1
  heretiker_1_N = mkN "heretiker" "heretikern" "heretiker" "heretikerna" ; -- heretiker..nn.1
  heretisk_1_A = mkA "heretisk" ; -- heretisk..av.1
  herkulesarbete_1_N = mkN "herkulesarbete" ; -- herkulesarbete..nn.1
  herkulisk_1_A = mkA "herkulisk" ; -- herkulisk..av.1
  herm_1_N = mkN "herm" "hermer" ; -- herm..nn.1
  hermafrodit_1_N = mkN "hermafrodit" "hermafroditer" ; -- hermafrodit..nn.1
  hermafroditism_1_N = mkN "hermafroditism" "hermafroditismer" ; -- hermafroditism..nn.1
  hermelin_1_N = mkN "hermelin" "hermeliner" ; -- hermelin..nn.1
  hermelinpäls_1_N = mkN "hermelinpäls" ; -- hermelinpäls..nn.1
  hermelinsbesatt_1_A = mkA "hermelinsbesatt" ; -- hermelinsbesatt..av.1
  hermelinsmantel_1_N = mkN "hermelinsmantel" ; -- hermelinsmantel..nn.1
  hermeneutik_1_N = mkN "hermeneutik" ; -- hermeneutik..nn.1
  hermeneutiker_1_N = mkN "hermeneutiker" "hermeneutikern" "hermeneutiker" "hermeneutikerna" ; -- hermeneutiker..nn.1
  hermeneutisk_1_A = mkA "hermeneutisk" ; -- hermeneutisk..av.1
  hermetisk_1_A = mkA "hermetisk" ; -- hermetisk..av.1
  heroin_1_N = mkN "heroin" "heroiner" ; -- heroin..nn.1
  heroinabstinens_1_N = mkN "heroinabstinens" "heroinabstinenser" ; -- heroinabstinens..nn.1
  heroinbeslag_1_N = mkN "heroinbeslag" neutrum  ; -- heroinbeslag..nn.1
  heroinbranch_1_N = mkN "heroinbranch" ; -- heroinbranch..nn.1
  heroinhandel_1_N = mkN "heroinhandel" ; -- heroinhandel..nn.1
  heroinist_1_N = mkN "heroinist" "heroinister" ; -- heroinist..nn.1
  heroinkung_1_N = mkN "heroinkung" ; -- heroinkung..nn.1
  heroinparti_1_N = mkN "heroinparti" "heroinpartiet" "heroinpartier" "heroinpartierna" ; -- heroinparti..nn.1
  heroinproduktion_1_N = mkN "heroinproduktion" ; -- heroinproduktion..nn.1
  heroinrekord_1_N = mkN "heroinrekord" neutrum  ; -- heroinrekord..nn.1
  heroinsmugglare_1_N = mkN "heroinsmugglare" utrum  ; -- heroinsmugglare..nn.1
  heroinsmuggling_1_N = mkN "heroinsmuggling" ; -- heroinsmuggling..nn.1
  heroinvrak_1_N = mkN "heroinvrak" neutrum  ; -- heroinvrak..nn.1
  heroisera_1_V = mkV "heroiserar" ; -- heroisera..vb.1
  heroiserande_1_N = mkN "heroiserande" ; -- heroiserande..nn.1
  heroiserbar_1_A = mkA "heroiserbar" ; -- heroiserbar..av.1
  heroiserbarhet_1_N = mkN "heroiserbarhet" ; -- heroiserbarhet..nn.1
  heroisering_1_N = mkN "heroisering" ; -- heroisering..nn.1
  heroisk_1_A = mkA "heroisk" ; -- heroisk..av.1
  heroism_1_N = mkN "heroism" "heroismer" ; -- heroism..nn.1
  heros_1_N = mkN "heros" "heroser" ; -- heros..nn.1
  herostratisk_1_A = mkA "herostratisk" ; -- herostratisk..av.1
  herpes_1_N = mkN "herpes" ; -- herpes..nn.1
  herpessalva_1_N = mkN "herpessalva" ; -- herpessalva..nn.1
  herpetologi_1_N = mkN "herpetologi" ; -- herpetologi..nn.1
  herradöme_1_N = mkN "herradöme" ; -- herradöme..nn.1
  herravälde_1_N = mkN "herravälde" ; -- herravälde..nn.1
  herrbekant_1_N = mkN "herrbekant" "herrbekanten" "herrbekanta" "herrbekanterna" ; -- herrbekant..nn.1
  herrbyxa_1_N = mkN "herrbyxa" ; -- herrbyxa..nn.1
  herrcykel_1_N = mkN "herrcykel" ; -- herrcykel..nn.1
  herrdubbel_1_N = mkN "herrdubbel" ; -- herrdubbel..nn.1
  herre_1_N = mkN "herre" utrum  ; -- herre..nn.1
  herre_2_N = mkN "herre" utrum  ; -- herre..nn.2
  herredag_1_N = mkN "herredag" ; -- herredag..nn.1
  herrefolk_1_N = mkN "herrefolk" neutrum  ; -- herrefolk..nn.1
  herrekipering_1_N = mkN "herrekipering" ; -- herrekipering..nn.1
  herrelös_1_A = mkA "herrelös" ; -- herrelös..av.1
  herrelöshet_1_N = mkN "herrelöshet" ; -- herrelöshet..nn.1
  herreman_1_N = mkN "herreman" "herremannen" "herremän" "herremännen" ; -- herreman..nn.1
  herresäte_1_N = mkN "herresäte" ; -- herresäte..nn.1
  herrgård_1_N = mkN "herrgård" ; -- herrgård..nn.1
  herrgårdsallmoge_1_N = mkN "herrgårdsallmoge" utrum  ; -- herrgårdsallmoge..nn.1
  herrgårdsbyggnad_1_N = mkN "herrgårdsbyggnad" "herrgårdsbyggnader" ; -- herrgårdsbyggnad..nn.1
  herrgårdsdrift_1_N = mkN "herrgårdsdrift" ; -- herrgårdsdrift..nn.1
  herrgårdsliknande_1_A = mkA "herrgårdsliknande" ; -- herrgårdsliknande..av.1
  herrgårdsost_1_N = mkN "herrgårdsost" ; -- herrgårdsost..nn.1
  herrgårdsvagn_1_N = mkN "herrgårdsvagn" ; -- herrgårdsvagn..nn.1
  herrhatt_1_N = mkN "herrhatt" ; -- herrhatt..nn.1
  herrlandslag_1_N = mkN "herrlandslag" neutrum  ; -- herrlandslag..nn.1
  herrmode_1_N = mkN "herrmode" ; -- herrmode..nn.1
  herrnhutare_1_N = mkN "herrnhutare" utrum  ; -- herrnhutare..nn.1
  herrnhutisk_1_A = mkA "herrnhutisk" ; -- herrnhutisk..av.1
  herrnhutism_1_N = mkN "herrnhutism" "herrnhutismer" ; -- herrnhutism..nn.1
  herrnhutistisk_1_A = mkA "herrnhutistisk" ; -- herrnhutistisk..av.1
  herrsida_1_N = mkN "herrsida" ; -- herrsida..nn.1
  herrsingel_1_N = mkN "herrsingel" ; -- herrsingel..nn.1
  herrskap_1_N = mkN "herrskap" neutrum  ; -- herrskap..nn.1
  herrsko_1_N = mkN "herrsko" "herrskor" ; -- herrsko..nn.1
  herrstafett_1_N = mkN "herrstafett" "herrstafetter" ; -- herrstafett..nn.1
  herrtidning_1_N = mkN "herrtidning" ; -- herrtidning..nn.1
  herrtoalett_1_N = mkN "herrtoalett" "herrtoaletter" ; -- herrtoalett..nn.1
  hertig_1_N = mkN "hertig" ; -- hertig..nn.1
  hertigdöme_1_N = mkN "hertigdöme" ; -- hertigdöme..nn.1
  hertiginna_1_N = mkN "hertiginna" ; -- hertiginna..nn.1
  hertiglig_1_A = mkA "hertiglig" ; -- hertiglig..av.1
  hertz_1_N = mkN "hertz" "hertzen" "hertz" "hertzen" ; -- hertz..nn.1
  hes_1_A = mkA "hes" ; -- hes..av.1
  heshet_1_N = mkN "heshet" "hesheter" ; -- heshet..nn.1
  hesitera_1_V = mkV "hesiterar" ; -- hesitera..vb.1
  hesiterande_1_N = mkN "hesiterande" ; -- hesiterande..nn.1
  hesitering_1_N = mkN "hesitering" ; -- hesitering..nn.1
  hesna_1_V = mkV "hesnar" ; -- hesna..vb.1
  het_1_A = mkA "het" ; -- het..av.1
  heta_1_V = mkV "heta" "hette" "hetat" ; -- heta..vb.1
  hetande_1_N = mkN "hetande" ; -- hetande..nn.1
  hetero_1_A = mkA "hetero" ; -- hetero..av.1
  heterodox_1_A = mkA "heterodox" ; -- heterodox..av.1
  heterogen_1_A = mkA "heterogen" "heterogent" ; -- heterogen..av.1
  heterogenhet_1_N = mkN "heterogenhet" ; -- heterogenhet..nn.1
  heterogenitet_1_N = mkN "heterogenitet" ; -- heterogenitet..nn.1
  heteroklis_1_N = mkN "heteroklis" "heterokliser" ; -- heteroklis..nn.1
  heteroklitisk_1_A = mkA "heteroklitisk" ; -- heteroklitisk..av.1
  heteronorm_1_N = mkN "heteronorm" "heteronormer" ; -- heteronorm..nn.1
  heteronormativ_1_A = mkA "heteronormativ" ; -- heteronormativ..av.1
  heteronormativitet_1_N = mkN "heteronormativitet" "heteronormativiteter" ; -- heteronormativitet..nn.1
  heteropar_1_N = mkN "heteropar" neutrum  ; -- heteropar..nn.1
  heteroporr_1_N = mkN "heteroporr" ; -- heteroporr..nn.1
  heterosex_1_N = mkN "heterosex" neutrum  ; -- heterosex..nn.1
  heterosexualitet_1_N = mkN "heterosexualitet" ; -- heterosexualitet..nn.1
  heterosexuell_1_A = mkA "heterosexuell" ; -- heterosexuell..av.1
  heterotematisk_1_A = mkA "heterotematisk" ; -- heterotematisk..av.1
  heterozygot_1_A = mkA "heterozygot" "heterozygot" ; -- heterozygot..av.1
  heterozygot_1_N = mkN "heterozygot" "heterozygoter" ; -- heterozygot..nn.1
  hetlevrad_1_A = mkA "hetlevrad" ; -- hetlevrad..av.1
  hetluft_1_N = mkN "hetluft" ; -- hetluft..nn.1
  hetman_1_N = mkN "hetman" "hetmaner" ; -- hetman..nn.1
  hets_1_N = mkN "hets" ; -- hets..nn.1
  hetsa_1_V = mkV "hetsar" ; -- hetsa..vb.1
  hetsa_2_V = mkV "hetsar" ; -- hetsa..vb.2
  hetsande_1_N = mkN "hetsande" ; -- hetsande..nn.1
  hetsbrott_1_N = mkN "hetsbrott" neutrum  ; -- hetsbrott..nn.1
  hetsig_1_A = mkA "hetsig" ; -- hetsig..av.1
  hetsighet_1_N = mkN "hetsighet" "hetsigheter" ; -- hetsighet..nn.1
  hetsjakt_1_N = mkN "hetsjakt" "hetsjakter" ; -- hetsjakt..nn.1
  hetsning_1_N = mkN "hetsning" ; -- hetsning..nn.1
  hetspolitik_1_N = mkN "hetspolitik" ; -- hetspolitik..nn.1
  hetspolitisk_1_A = mkA "hetspolitisk" ; -- hetspolitisk..av.1
  hetsporre_1_N = mkN "hetsporre" utrum  ; -- hetsporre..nn.1
  hetsätning_1_N = mkN "hetsätning" ; -- hetsätning..nn.1
  hetta_1_N = mkN "hetta" ; -- hetta..nn.1
  hetta_1_V = mkV "hettar" ; -- hetta..vb.1
  hettande_1_N = mkN "hettande" ; -- hettande..nn.1
  hettit_1_N = mkN "hettit" "hettiter" ; -- hettit..nn.1
  hettitisk_1_A = mkA "hettitisk" ; -- hettitisk..av.1
  hettitiska_1_N = mkN "hettitiska" ; -- hettitiska..nn.1
  hetvatten_1_N = mkN "hetvatten" "hetvattnet" "hetvatten" "hetvattnen" ; -- hetvatten..nn.1
  hetvattentvätt_1_N = mkN "hetvattentvätt" ; -- hetvattentvätt..nn.1
  hetvin_1_N = mkN "hetvin" "hetvinet" "hetviner" "hetvinerna" ; -- hetvin..nn.1
  hetvägg_1_N = mkN "hetvägg" ; -- hetvägg..nn.1
  hetär_1_N = mkN "hetär" "hetärer" ; -- hetär..nn.1
  heuristik_1_N = mkN "heuristik" ; -- heuristik..nn.1
  heuristisk_1_A = mkA "heuristisk" ; -- heuristisk..av.1
  hexaeder_1_N = mkN "hexaeder" ; -- hexaeder..nn.1
  hexameter_1_N = mkN "hexameter" ; -- hexameter..nn.1
  hiatus_1_N = mkN "hiatus" ; -- hiatus..nn.1
  hibernation_1_N = mkN "hibernation" ; -- hibernation..nn.1
  hibernera_1_V = mkV "hibernerar" ; -- hibernera..vb.1
  hibernerande_1_N = mkN "hibernerande" ; -- hibernerande..nn.1
  hibernering_1_N = mkN "hibernering" ; -- hibernering..nn.1
  hibiskus_1_N = mkN "hibiskus" ; -- hibiskus..nn.1
  hicka_1_N = mkN "hicka" ; -- hicka..nn.1
  hicka_1_V = mkV "hickar" ; -- hicka..vb.1
  hickande_1_N = mkN "hickande" ; -- hickande..nn.1
  hickning_1_N = mkN "hickning" ; -- hickning..nn.1
  hierarki_1_N = mkN "hierarki" "hierarkier" ; -- hierarki..nn.1
  hierarkisk_1_A = mkA "hierarkisk" ; -- hierarkisk..av.1
  hieratisk_1_A = mkA "hieratisk" ; -- hieratisk..av.1
  hieroglyf_1_N = mkN "hieroglyf" "hieroglyfer" ; -- hieroglyf..nn.1
  hieroglyfinskrift_1_N = mkN "hieroglyfinskrift" "hieroglyfinskrifter" ; -- hieroglyfinskrift..nn.1
  hieroglyfisk_1_A = mkA "hieroglyfisk" ; -- hieroglyfisk..av.1
  higgsboson_1_N = mkN "higgsboson" "higgsbosoner" ; -- higgsboson..nn.1
  higgspartikel_1_N = mkN "higgspartikel" ; -- higgspartikel..nn.1
  high_tech_1_N = mkN "high-tech" ; -- high-tech..nn.1
  hillebard_1_N = mkN "hillebard" "hillebarder" ; -- hillebard..nn.1
  hillebardiär_1_N = mkN "hillebardiär" "hillebardiärer" ; -- hillebardiär..nn.1
  himla_1_Adv = mkAdv "himla" ; -- himla..ab.1
  himla_1_V = mkV "himlar" ; -- himla..vb.1
  himlaboren_1_A = mkA "himlaboren" ; -- himlaboren..av.1
  himladrottning_1_N = mkN "himladrottning" ; -- himladrottning..nn.1
  himlafader_1_N = mkN "himlafader" ; -- himlafader..nn.1
  himlafenomen_1_N = mkN "himlafenomen" neutrum  ; -- himlafenomen..nn.1
  himlakropp_1_N = mkN "himlakropp" ; -- himlakropp..nn.1
  himlande_1_N = mkN "himlande" ; -- himlande..nn.1
  himlapäll_1_N = mkN "himlapäll" ; -- himlapäll..nn.1
  himlarand_1_N = mkN "himlarand" ; -- himlarand..nn.1
  himlarund_1_N = mkN "himlarund" ; -- himlarund..nn.1
  himlarymd_1_N = mkN "himlarymd" "himlarymder" ; -- himlarymd..nn.1
  himlaskara_1_N = mkN "himlaskara" ; -- himlaskara..nn.1
  himlastege_1_N = mkN "himlastege" utrum  ; -- himlastege..nn.1
  himlastormande_1_A = mkA "himlastormande" ; -- himlastormande..av.1
  himlastormare_1_N = mkN "himlastormare" utrum  ; -- himlastormare..nn.1
  himlavalv_1_N = mkN "himlavalv" neutrum  ; -- himlavalv..nn.1
  himmel_1_N = mkN "himmel" ; -- himmel..nn.1
  himmelrike_1_N = mkN "himmelrike" ; -- himmelrike..nn.1
  himmelsblå_1_A = mkA "himmelsblå" "himmelsblått" ; -- himmelsblå..av.1
  himmelsfarare_1_N = mkN "himmelsfarare" utrum  ; -- himmelsfarare..nn.1
  himmelsfärd_1_N = mkN "himmelsfärd" "himmelsfärder" ; -- himmelsfärd..nn.1
  himmelsfärdsdag_1_N = mkN "himmelsfärdsdag" ; -- himmelsfärdsdag..nn.1
  himmelsglob_1_N = mkN "himmelsglob" "himmelsglober" ; -- himmelsglob..nn.1
  himmelshöjd_1_N = mkN "himmelshöjd" "himmelshöjder" ; -- himmelshöjd..nn.1
  himmelsk_1_A = mkA "himmelsk" ; -- himmelsk..av.1
  himmelsmekanik_1_N = mkN "himmelsmekanik" ; -- himmelsmekanik..nn.1
  himmelsobjekt_1_N = mkN "himmelsobjekt" neutrum  ; -- himmelsobjekt..nn.1
  himmelspol_1_N = mkN "himmelspol" "himmelspoler" ; -- himmelspol..nn.1
  himmelssfär_1_N = mkN "himmelssfär" "himmelssfärer" ; -- himmelssfär..nn.1
  himmelsskriande_1_A = mkA "himmelsskriande" ; -- himmelsskriande..av.1
  himmelssäng_1_N = mkN "himmelssäng" ; -- himmelssäng..nn.1
  himmelstecken_1_N = mkN "himmelstecken" "himmelstecknet" "himmelstecken" "himmelstecknen" ; -- himmelstecken..nn.1
  himmelsvid_1_A = mkA "himmelsvid" "himmelsvitt" ; -- himmelsvid..av.1
  hin_1_N = mkN "hin" ; -- hin..nn.1
  hind_1_N = mkN "hind" ; -- hind..nn.1
  hinder_1_N = mkN "hinder" neutrum  ; -- hinder..nn.1
  hinderbana_1_N = mkN "hinderbana" ; -- hinderbana..nn.1
  hinderbock_1_N = mkN "hinderbock" ; -- hinderbock..nn.1
  hinderlig_1_A = mkA "hinderlig" ; -- hinderlig..av.1
  hinderlöpare_1_N = mkN "hinderlöpare" utrum  ; -- hinderlöpare..nn.1
  hinderlöpning_1_N = mkN "hinderlöpning" ; -- hinderlöpning..nn.1
  hinderlös_1_A = mkA "hinderlös" ; -- hinderlös..av.1
  hinderlöshet_1_N = mkN "hinderlöshet" ; -- hinderlöshet..nn.1
  hinderritt_1_N = mkN "hinderritt" "hinderritter" ; -- hinderritt..nn.1
  hindersam_1_A = mkA "hindersam" "hindersamt" "hindersamma" "hindersamma" "hindersammare" "hindersammast" "hindersammaste" ; -- hindersam..av.1
  hindersamhet_1_N = mkN "hindersamhet" ; -- hindersamhet..nn.1
  hinderslös_1_A = mkA "hinderslös" ; -- hinderslös..av.1
  hinderslöshet_1_N = mkN "hinderslöshet" ; -- hinderslöshet..nn.1
  hindersprövning_1_N = mkN "hindersprövning" ; -- hindersprövning..nn.1
  hindertrick_1_N = mkN "hindertrick" neutrum  ; -- hindertrick..nn.1
  hindi_1_N = mkN "hindi" ; -- hindi..nn.1
  hindra_1_V = mkV "hindrar" ; -- hindra..vb.1
  hindrande_1_A = mkA "hindrande" ; -- hindrande..av.1
  hindrande_1_N = mkN "hindrande" ; -- hindrande..nn.1
  hindu_1_N = mkN "hindu" "hinduer" ; -- hindu..nn.1
  hinduisk_1_A = mkA "hinduisk" ; -- hinduisk..av.1
  hinduism_1_N = mkN "hinduism" "hinduismer" ; -- hinduism..nn.1
  hinduistisk_1_A = mkA "hinduistisk" ; -- hinduistisk..av.1
  hindutempel_1_N = mkN "hindutempel" neutrum  ; -- hindutempel..nn.1
  hingst_1_N = mkN "hingst" ; -- hingst..nn.1
  hink_1_N = mkN "hink" ; -- hink..nn.1
  hinka_1_V = mkV "hinkar" ; -- hinka..vb.1
  hinkande_1_N = mkN "hinkande" ; -- hinkande..nn.1
  hinkvis_1_Adv = mkAdv "hinkvis" ; -- hinkvis..ab.1
  hinna_1_N = mkN "hinna" ; -- hinna..nn.1
  hinna_1_V = mkV "hinna" "hann" "hunnit" ; -- hinna..vb.1
  hinnande_1_N = mkN "hinnande" ; -- hinnande..nn.1
  hinneliknande_1_A = mkA "hinneliknande" ; -- hinneliknande..av.1
  hinnkräfta_1_N = mkN "hinnkräfta" ; -- hinnkräfta..nn.1
  hinsida_1_N = mkN "hinsida" ; -- hinsida..nn.1
  hiphop_1_N = mkN "hiphop" ; -- hiphop..nn.1
  hiphopare_1_N = mkN "hiphopare" utrum  ; -- hiphopare..nn.1
  hiphopp_1_N = mkN "hiphopp" ; -- hiphopp..nn.1
  hiphoppare_1_N = mkN "hiphoppare" utrum  ; -- hiphoppare..nn.1
  hipp_1_A = mkA "hipp" ; -- hipp..av.1
  hippa_1_N = mkN "hippa" ; -- hippa..nn.1
  hipphet_1_N = mkN "hipphet" ; -- hipphet..nn.1
  hippie_1_N = mkN "hippie" "hippien" "hippies" "hippiesarna" ; -- hippie..nn.1
  hippieartad_1_A = mkA "hippieartad" ; -- hippieartad..av.1
  hippodrom_1_N = mkN "hippodrom" "hippodromer" ; -- hippodrom..nn.1
  hippolog_1_N = mkN "hippolog" "hippologer" ; -- hippolog..nn.1
  hippologi_1_N = mkN "hippologi" ; -- hippologi..nn.1
  hippologisk_1_A = mkA "hippologisk" ; -- hippologisk..av.1
  hipster_1_N = mkN "hipster" ; -- hipster..nn.1
  hird_1_N = mkN "hird" "hirder" ; -- hird..nn.1
  hirdman_1_N = mkN "hirdman" "hirdmannen" "hirdmän" "hirdmännen" ; -- hirdman..nn.1
  hirs_1_N = mkN "hirs" ; -- hirs..nn.1
  hiskelig_1_A = mkA "hiskelig" ; -- hiskelig..av.1
  hiskelighet_1_N = mkN "hiskelighet" "hiskeligheter" ; -- hiskelighet..nn.1
  hisklig_1_A = mkA "hisklig" ; -- hisklig..av.1
  hisklighet_1_N = mkN "hisklighet" "hiskligheter" ; -- hisklighet..nn.1
  hisna_1_V = mkV "hisnar" ; -- hisna..vb.1
  hisnande_1_N = mkN "hisnande" ; -- hisnande..nn.1
  hispa_1_N = mkN "hispa" ; -- hispa..nn.1
  hispig_1_A = mkA "hispig" ; -- hispig..av.1
  hispighet_1_N = mkN "hispighet" ; -- hispighet..nn.1
  hiss_1_N = mkN "hiss" ; -- hiss..nn.1
  hissa_1_V = mkV "hissar" ; -- hissa..vb.1
  hissande_1_N = mkN "hissande" ; -- hissande..nn.1
  hissdörr_1_N = mkN "hissdörr" ; -- hissdörr..nn.1
  hisshall_1_N = mkN "hisshall" ; -- hisshall..nn.1
  hissinstallation_1_N = mkN "hissinstallation" ; -- hissinstallation..nn.1
  hisskorg_1_N = mkN "hisskorg" ; -- hisskorg..nn.1
  hissna_1_V = mkV "hissnar" ; -- hissna..vb.1
  hissnande_1_N = mkN "hissnande" ; -- hissnande..nn.1
  hisstillverkare_1_N = mkN "hisstillverkare" utrum  ; -- hisstillverkare..nn.1
  histamin_1_N = mkN "histamin" "histaminet" "histaminer" "histaminerna" ; -- histamin..nn.1
  histogram_1_N = mkN "histogram" "histogrammet" "histogram" "histogrammen" ; -- histogram..nn.1
  histolog_1_N = mkN "histolog" "histologer" ; -- histolog..nn.1
  histologi_1_N = mkN "histologi" ; -- histologi..nn.1
  histologisk_1_A = mkA "histologisk" ; -- histologisk..av.1
  historia_1_N = mkN "historia" "historian" "historier" "historierna" ; -- historia..nn.1
  historicism_1_N = mkN "historicism" "historicismer" ; -- historicism..nn.1
  historicistisk_1_A = mkA "historicistisk" ; -- historicistisk..av.1
  historicitet_1_N = mkN "historicitet" ; -- historicitet..nn.1
  historieberättande_1_A = mkA "historieberättande" ; -- historieberättande..av.1
  historieberättande_1_N = mkN "historieberättande" ; -- historieberättande..nn.1
  historieblogg_1_N = mkN "historieblogg" ; -- historieblogg..nn.1
  historiebok_1_N = mkN "historiebok" "historieböcker" ; -- historiebok..nn.1
  historieforskare_1_N = mkN "historieforskare" utrum  ; -- historieforskare..nn.1
  historieförfalskning_1_N = mkN "historieförfalskning" ; -- historieförfalskning..nn.1
  historieförståelse_1_N = mkN "historieförståelse" utrum  ; -- historieförståelse..nn.1
  historieintresse_1_N = mkN "historieintresse" ; -- historieintresse..nn.1
  historielös_1_A = mkA "historielös" ; -- historielös..av.1
  historielöshet_1_N = mkN "historielöshet" ; -- historielöshet..nn.1
  historiemålare_1_N = mkN "historiemålare" utrum  ; -- historiemålare..nn.1
  historiemåleri_1_N = mkN "historiemåleri" neutrum  ; -- historiemåleri..nn.1
  historiemålning_1_N = mkN "historiemålning" ; -- historiemålning..nn.1
  historiera_1_V = mkV "historierar" ; -- historiera..vb.1
  historierande_1_N = mkN "historierande" ; -- historierande..nn.1
  historierbar_1_A = mkA "historierbar" ; -- historierbar..av.1
  historierbarhet_1_N = mkN "historierbarhet" ; -- historierbarhet..nn.1
  historierevisionism_1_N = mkN "historierevisionism" "historierevisionismer" ; -- historierevisionism..nn.1
  historierevisionist_1_N = mkN "historierevisionist" "historierevisionister" ; -- historierevisionist..nn.1
  historiering_1_N = mkN "historiering" ; -- historiering..nn.1
  historieskrivare_1_N = mkN "historieskrivare" utrum  ; -- historieskrivare..nn.1
  historieskrivning_1_N = mkN "historieskrivning" ; -- historieskrivning..nn.1
  historiett_1_N = mkN "historiett" "historietter" ; -- historiett..nn.1
  historieverk_1_N = mkN "historieverk" neutrum  ; -- historieverk..nn.1
  historievetenskap_1_N = mkN "historievetenskap" "historievetenskaper" ; -- historievetenskap..nn.1
  historik_1_N = mkN "historik" "historiker" ; -- historik..nn.1
  historiker_1_N = mkN "historiker" "historikern" "historiker" "historikerna" ; -- historiker..nn.1
  historiograf_1_N = mkN "historiograf" "historiografer" ; -- historiograf..nn.1
  historisera_1_V = mkV "historiserar" ; -- historisera..vb.1
  historiserande_1_N = mkN "historiserande" ; -- historiserande..nn.1
  historiserbar_1_A = mkA "historiserbar" ; -- historiserbar..av.1
  historiserbarhet_1_N = mkN "historiserbarhet" ; -- historiserbarhet..nn.1
  historisering_1_N = mkN "historisering" ; -- historisering..nn.1
  historisk_1_A = mkA "historisk" ; -- historisk..av.1
  historism_1_N = mkN "historism" "historismer" ; -- historism..nn.1
  histrion_1_N = mkN "histrion" ; -- histrion..nn.1
  hit_1_N = mkN "hit" "hiten" "hits" "hitsarna" ; -- hit..nn.1
  hiterst_1_Adv = mkAdv "hiterst" ; -- hiterst..ab.1
  hitflugen_1_A = mkA "hitflugen" ; -- hitflugen..av.1
  hitflyttning_1_N = mkN "hitflyttning" ; -- hitflyttning..nn.1
  hitfärd_1_N = mkN "hitfärd" ; -- hitfärd..nn.1
  hithörande_1_A = mkA "hithörande" ; -- hithörande..av.1
  hitkomst_1_N = mkN "hitkomst" ; -- hitkomst..nn.1
  hitlista_1_N = mkN "hitlista" ; -- hitlista..nn.1
  hitmakare_1_N = mkN "hitmakare" utrum  ; -- hitmakare..nn.1
  hitmässig_1_A = mkA "hitmässig" ; -- hitmässig..av.1
  hitresa_1_N = mkN "hitresa" ; -- hitresa..nn.1
  hitrest_1_A = mkA "hitrest" "hitrest" ; -- hitrest..av.1
  hitta_1_V = mkV "hittar" ; -- hitta..vb.1
  hittande_1_N = mkN "hittande" ; -- hittande..nn.1
  hittebarn_1_N = mkN "hittebarn" neutrum  ; -- hittebarn..nn.1
  hittegods_1_N = mkN "hittegods" neutrum  ; -- hittegods..nn.1
  hittelön_1_N = mkN "hittelön" "hittelöner" ; -- hittelön..nn.1
  hittilldags_1_Adv = mkAdv "hittilldags" ; -- hittilldags..ab.1
  hittillsvarande_1_A = mkA "hittillsvarande" ; -- hittillsvarande..av.1
  hiva_1_V = mkV "hivar" ; -- hiva..vb.1
  hivande_1_N = mkN "hivande" ; -- hivande..nn.1
  hivlagstiftning_1_N = mkN "hivlagstiftning" ; -- hivlagstiftning..nn.1
  hivning_1_N = mkN "hivning" ; -- hivning..nn.1
  hivpositiv_1_A = mkA "hivpositiv" ; -- hivpositiv..av.1
  hivsmittad_1_A = mkA "hivsmittad" ; -- hivsmittad..av.1
  hivstam_1_N = mkN "hivstam" "hivstammen" "hivstammar" "hivstammarna" ; -- hivstam..nn.1
  hivutbrott_1_N = mkN "hivutbrott" neutrum  ; -- hivutbrott..nn.1
  hjon_1_N = mkN "hjon" neutrum  ; -- hjon..nn.1
  hjonelag_1_N = mkN "hjonelag" neutrum  ; -- hjonelag..nn.1
  hjord_1_N = mkN "hjord" ; -- hjord..nn.1
  hjordinstinkt_1_N = mkN "hjordinstinkt" ; -- hjordinstinkt..nn.1
  hjort_1_N = mkN "hjort" ; -- hjort..nn.1
  hjortdjur_1_N = mkN "hjortdjur" neutrum  ; -- hjortdjur..nn.1
  hjorthornssalt_1_N = mkN "hjorthornssalt" neutrum  ; -- hjorthornssalt..nn.1
  hjortkalv_1_N = mkN "hjortkalv" ; -- hjortkalv..nn.1
  hjortron_1_N = mkN "hjortron" neutrum  ; -- hjortron..nn.1
  hjortronsylt_1_N = mkN "hjortronsylt" "hjortronsylter" ; -- hjortronsylt..nn.1
  hjortsadel_1_N = mkN "hjortsadel" ; -- hjortsadel..nn.1
  hjul_1_N = mkN "hjul" neutrum  ; -- hjul..nn.1
  hjula_1_V = mkV "hjular" ; -- hjula..vb.1
  hjulande_1_N = mkN "hjulande" ; -- hjulande..nn.1
  hjulaxel_1_N = mkN "hjulaxel" ; -- hjulaxel..nn.1
  hjulbas_1_N = mkN "hjulbas" "hjulbaser" ; -- hjulbas..nn.1
  hjulbent_1_A = mkA "hjulbent" "hjulbent" ; -- hjulbent..av.1
  hjulbenthet_1_N = mkN "hjulbenthet" ; -- hjulbenthet..nn.1
  hjuldjur_1_N = mkN "hjuldjur" neutrum  ; -- hjuldjur..nn.1
  hjuldolly_1_N = mkN "hjuldolly" "hjuldollyn" "hjuldollys" "hjuldollysarna" ; -- hjuldolly..nn.1
  hjulfjädring_1_N = mkN "hjulfjädring" ; -- hjulfjädring..nn.1
  hjulformig_1_A = mkA "hjulformig" ; -- hjulformig..av.1
  hjulfönster_1_N = mkN "hjulfönster" neutrum  ; -- hjulfönster..nn.1
  hjulhus_1_N = mkN "hjulhus" neutrum  ; -- hjulhus..nn.1
  hjulkors_1_N = mkN "hjulkors" neutrum  ; -- hjulkors..nn.1
  hjullager_1_N = mkN "hjullager" neutrum  ; -- hjullager..nn.1
  hjullastare_1_N = mkN "hjullastare" utrum  ; -- hjullastare..nn.1
  hjullås_1_N = mkN "hjullås" neutrum  ; -- hjullås..nn.1
  hjulmutter_1_N = mkN "hjulmutter" ; -- hjulmutter..nn.1
  hjulmutterdragare_1_N = mkN "hjulmutterdragare" utrum  ; -- hjulmutterdragare..nn.1
  hjulmutterhylsa_1_N = mkN "hjulmutterhylsa" ; -- hjulmutterhylsa..nn.1
  hjulnav_1_N = mkN "hjulnav" neutrum  ; -- hjulnav..nn.1
  hjulning_1_N = mkN "hjulning" ; -- hjulning..nn.1
  hjulsats_1_N = mkN "hjulsats" "hjulsatser" ; -- hjulsats..nn.1
  hjulsida_1_N = mkN "hjulsida" ; -- hjulsida..nn.1
  hjulspår_1_N = mkN "hjulspår" neutrum  ; -- hjulspår..nn.1
  hjulupphängning_1_N = mkN "hjulupphängning" ; -- hjulupphängning..nn.1
  hjulångare_1_N = mkN "hjulångare" utrum  ; -- hjulångare..nn.1
  hjälm_1_N = mkN "hjälm" ; -- hjälm..nn.1
  hjälmbuske_1_N = mkN "hjälmbuske" utrum  ; -- hjälmbuske..nn.1
  hjälmprydnad_1_N = mkN "hjälmprydnad" "hjälmprydnader" ; -- hjälmprydnad..nn.1
  hjälmpåse_1_N = mkN "hjälmpåse" utrum  ; -- hjälmpåse..nn.1
  hjälmtvång_1_N = mkN "hjälmtvång" neutrum  ; -- hjälmtvång..nn.1
  hjälp_1_N = mkN "hjälp" ; -- hjälp..nn.1
  hjälpa_1_V = mkV "hjälper" ; -- hjälpa..vb.1
  hjälpande_1_N = mkN "hjälpande" ; -- hjälpande..nn.1
  hjälparbetare_1_N = mkN "hjälparbetare" utrum  ; -- hjälparbetare..nn.1
  hjälpare_1_N = mkN "hjälpare" utrum  ; -- hjälpare..nn.1
  hjälpbehövande_1_A = mkA "hjälpbehövande" ; -- hjälpbehövande..av.1
  hjälpbåt_1_N = mkN "hjälpbåt" ; -- hjälpbåt..nn.1
  hjälpe_1_V = mkV "hjälpe" ; -- hjälpe..vb.1
  hjälpfartyg_1_N = mkN "hjälpfartyg" neutrum  ; -- hjälpfartyg..nn.1
  hjälpgumma_1_N = mkN "hjälpgumma" ; -- hjälpgumma..nn.1
  hjälpklass_1_N = mkN "hjälpklass" "hjälpklasser" ; -- hjälpklass..nn.1
  hjälpkryssare_1_N = mkN "hjälpkryssare" utrum  ; -- hjälpkryssare..nn.1
  hjälplig_1_A = mkA "hjälplig" ; -- hjälplig..av.1
  hjälplighet_1_N = mkN "hjälplighet" ; -- hjälplighet..nn.1
  hjälplinje_1_N = mkN "hjälplinje" "hjälplinjer" ; -- hjälplinje..nn.1
  hjälplärare_1_N = mkN "hjälplärare" utrum  ; -- hjälplärare..nn.1
  hjälplös_1_A = mkA "hjälplös" ; -- hjälplös..av.1
  hjälplöshet_1_N = mkN "hjälplöshet" ; -- hjälplöshet..nn.1
  hjälpmedel_1_N = mkN "hjälpmedel" neutrum  ; -- hjälpmedel..nn.1
  hjälpmotor_1_N = mkN "hjälpmotor" "hjälpmotorer" ; -- hjälpmotor..nn.1
  hjälporganisation_1_N = mkN "hjälporganisation" ; -- hjälporganisation..nn.1
  hjälpreda_1_N = mkN "hjälpreda" ; -- hjälpreda..nn.1
  hjälpsam_1_A = mkA "hjälpsam" "hjälpsamt" "hjälpsamma" "hjälpsamma" "hjälpsammare" "hjälpsammast" "hjälpsammaste" ; -- hjälpsam..av.1
  hjälpsamhet_1_N = mkN "hjälpsamhet" "hjälpsamheter" ; -- hjälpsamhet..nn.1
  hjälpspråk_1_N = mkN "hjälpspråk" neutrum  ; -- hjälpspråk..nn.1
  hjälpsändning_1_N = mkN "hjälpsändning" ; -- hjälpsändning..nn.1
  hjälpsökande_1_A = mkA "hjälpsökande" ; -- hjälpsökande..av.1
  hjälptrupp_1_N = mkN "hjälptrupp" "hjälptrupper" ; -- hjälptrupp..nn.1
  hjälpverb_1_N = mkN "hjälpverb" neutrum  ; -- hjälpverb..nn.1
  hjälpvetenskap_1_N = mkN "hjälpvetenskap" "hjälpvetenskaper" ; -- hjälpvetenskap..nn.1
  hjältbragd_1_N = mkN "hjältbragd" "hjältbragder" ; -- hjältbragd..nn.1
  hjälte_1_N = mkN "hjälte" utrum  ; -- hjälte..nn.1
  hjältebragd_1_N = mkN "hjältebragd" "hjältebragder" ; -- hjältebragd..nn.1
  hjältedikt_1_N = mkN "hjältedikt" "hjältedikter" ; -- hjältedikt..nn.1
  hjältedåd_1_N = mkN "hjältedåd" neutrum  ; -- hjältedåd..nn.1
  hjältedöd_1_N = mkN "hjältedöd" ; -- hjältedöd..nn.1
  hjältehund_1_N = mkN "hjältehund" ; -- hjältehund..nn.1
  hjältekista_1_N = mkN "hjältekista" ; -- hjältekista..nn.1
  hjältemod_1_N = mkN "hjältemod" neutrum  ; -- hjältemod..nn.1
  hjältemodig_1_A = mkA "hjältemodig" ; -- hjältemodig..av.1
  hjältemodighet_1_N = mkN "hjältemodighet" ; -- hjältemodighet..nn.1
  hjälteporträtt_1_N = mkN "hjälteporträtt" neutrum  ; -- hjälteporträtt..nn.1
  hjälteroll_1_N = mkN "hjälteroll" "hjälteroller" ; -- hjälteroll..nn.1
  hjältesaga_1_N = mkN "hjältesaga" ; -- hjältesaga..nn.1
  hjältestatus_1_N = mkN "hjältestatus" ; -- hjältestatus..nn.1
  hjältesång_1_N = mkN "hjältesång" "hjältesånger" ; -- hjältesång..nn.1
  hjältetenor_1_N = mkN "hjältetenor" "hjältetenoren" "hjältetenorer" "hjältetenorerna" ; -- hjältetenor..nn.1
  hjältinna_1_N = mkN "hjältinna" ; -- hjältinna..nn.1
  hjärna_1_N = mkN "hjärna" ; -- hjärna..nn.1
  hjärnaktivitet_1_N = mkN "hjärnaktivitet" "hjärnaktiviteter" ; -- hjärnaktivitet..nn.1
  hjärnatrofi_1_N = mkN "hjärnatrofi" "hjärnatrofier" ; -- hjärnatrofi..nn.1
  hjärnbalk_1_N = mkN "hjärnbalk" ; -- hjärnbalk..nn.1
  hjärnbark_1_N = mkN "hjärnbark" ; -- hjärnbark..nn.1
  hjärnbihang_1_N = mkN "hjärnbihang" neutrum  ; -- hjärnbihang..nn.1
  hjärnblödning_1_N = mkN "hjärnblödning" ; -- hjärnblödning..nn.1
  hjärnbyte_1_N = mkN "hjärnbyte" ; -- hjärnbyte..nn.1
  hjärncell_1_N = mkN "hjärncell" "hjärnceller" ; -- hjärncell..nn.1
  hjärndel_1_N = mkN "hjärndel" "hjärndelen" "hjärndelar" "hjärndelarna" ; -- hjärndel..nn.1
  hjärndöd_1_A = mkA "hjärndöd" "hjärndött" ; -- hjärndöd..av.1
  hjärndöd_1_N = mkN "hjärndöd" ; -- hjärndöd..nn.1
  hjärnfeber_1_N = mkN "hjärnfeber" ; -- hjärnfeber..nn.1
  hjärnforskning_1_N = mkN "hjärnforskning" ; -- hjärnforskning..nn.1
  hjärngymnastik_1_N = mkN "hjärngymnastik" ; -- hjärngymnastik..nn.1
  hjärngympa_1_N = mkN "hjärngympa" ; -- hjärngympa..nn.1
  hjärnhalva_1_N = mkN "hjärnhalva" ; -- hjärnhalva..nn.1
  hjärnhinna_1_N = mkN "hjärnhinna" ; -- hjärnhinna..nn.1
  hjärnhinneinflammation_1_N = mkN "hjärnhinneinflammation" ; -- hjärnhinneinflammation..nn.1
  hjärninfarkt_1_N = mkN "hjärninfarkt" "hjärninfarkter" ; -- hjärninfarkt..nn.1
  hjärninflammation_1_N = mkN "hjärninflammation" ; -- hjärninflammation..nn.1
  hjärnintresserad_1_A = mkA "hjärnintresserad" ; -- hjärnintresserad..av.1
  hjärnkamera_1_N = mkN "hjärnkamera" ; -- hjärnkamera..nn.1
  hjärnkontor_1_N = mkN "hjärnkontor" neutrum  ; -- hjärnkontor..nn.1
  hjärnoperation_1_N = mkN "hjärnoperation" ; -- hjärnoperation..nn.1
  hjärnsjukdom_1_N = mkN "hjärnsjukdom" ; -- hjärnsjukdom..nn.1
  hjärnskada_1_N = mkN "hjärnskada" ; -- hjärnskada..nn.1
  hjärnskadad_1_A = mkA "hjärnskadad" ; -- hjärnskadad..av.1
  hjärnskakning_1_N = mkN "hjärnskakning" ; -- hjärnskakning..nn.1
  hjärnskrynklare_1_N = mkN "hjärnskrynklare" utrum  ; -- hjärnskrynklare..nn.1
  hjärnskål_1_N = mkN "hjärnskål" ; -- hjärnskål..nn.1
  hjärnsläpp_1_N = mkN "hjärnsläpp" neutrum  ; -- hjärnsläpp..nn.1
  hjärnspöke_1_N = mkN "hjärnspöke" ; -- hjärnspöke..nn.1
  hjärnstam_1_N = mkN "hjärnstam" "hjärnstammen" "hjärnstammar" "hjärnstammarna" ; -- hjärnstam..nn.1
  hjärnstorm_1_N = mkN "hjärnstorm" ; -- hjärnstorm..nn.1
  hjärnsubstans_1_N = mkN "hjärnsubstans" ; -- hjärnsubstans..nn.1
  hjärntrust_1_N = mkN "hjärntrust" "hjärntruster" ; -- hjärntrust..nn.1
  hjärntumör_1_N = mkN "hjärntumör" "hjärntumörer" ; -- hjärntumör..nn.1
  hjärntvätt_1_N = mkN "hjärntvätt" ; -- hjärntvätt..nn.1
  hjärntvätta_1_V = mkV "hjärntvättar" ; -- hjärntvätta..vb.1
  hjärntvättande_1_N = mkN "hjärntvättande" ; -- hjärntvättande..nn.1
  hjärnuppmjukning_1_N = mkN "hjärnuppmjukning" ; -- hjärnuppmjukning..nn.1
  hjärnverksamhet_1_N = mkN "hjärnverksamhet" "hjärnverksamheter" ; -- hjärnverksamhet..nn.1
  hjärnvindling_1_N = mkN "hjärnvindling" ; -- hjärnvindling..nn.1
  hjärnvolym_1_N = mkN "hjärnvolym" "hjärnvolymer" ; -- hjärnvolym..nn.1
  hjärt_kärlsjukdom_1_N = mkN "hjärt-kärlsjukdom" ; -- hjärt-kärlsjukdom..nn.1
  hjärt_lungräddning_1_N = mkN "hjärt-lungräddning" ; -- hjärt-lungräddning..nn.1
  hjärta_1_N = mkN "hjärta" "hjärtat" "hjärtan" "hjärtana" ; -- hjärta..nn.1
  hjärtaktivitet_1_N = mkN "hjärtaktivitet" "hjärtaktiviteter" ; -- hjärtaktivitet..nn.1
  hjärtansfröjd_1_N = mkN "hjärtansfröjd" ; -- hjärtansfröjd..nn.1
  hjärtanskär_1_N = mkN "hjärtanskär" ; -- hjärtanskär..nn.1
  hjärtas_1_A = mkA "hjärtas" ; -- hjärtas..av.1
  hjärtattack_1_N = mkN "hjärtattack" "hjärtattacker" ; -- hjärtattack..nn.1
  hjärtbarn_1_N = mkN "hjärtbarn" neutrum  ; -- hjärtbarn..nn.1
  hjärtblad_1_N = mkN "hjärtblad" neutrum  ; -- hjärtblad..nn.1
  hjärtblod_1_N = mkN "hjärtblod" neutrum  ; -- hjärtblod..nn.1
  hjärteangelägenhet_1_N = mkN "hjärteangelägenhet" "hjärteangelägenheter" ; -- hjärteangelägenhet..nn.1
  hjärtebarn_1_N = mkN "hjärtebarn" neutrum  ; -- hjärtebarn..nn.1
  hjärteblod_1_N = mkN "hjärteblod" neutrum  ; -- hjärteblod..nn.1
  hjärtefråga_1_N = mkN "hjärtefråga" ; -- hjärtefråga..nn.1
  hjärtefröjd_1_N = mkN "hjärtefröjd" "hjärtefröjder" ; -- hjärtefröjd..nn.1
  hjärteglad_1_A = mkA "hjärteglad" ; -- hjärteglad..av.1
  hjärtegod_1_A = mkA "hjärtegod" "hjärtegott" ; -- hjärtegod..av.1
  hjärtegodhet_1_N = mkN "hjärtegodhet" ; -- hjärtegodhet..nn.1
  hjärtegryn_1_N = mkN "hjärtegryn" neutrum  ; -- hjärtegryn..nn.1
  hjärtegull_1_N = mkN "hjärtegull" neutrum  ; -- hjärtegull..nn.1
  hjärtekrossare_1_N = mkN "hjärtekrossare" utrum  ; -- hjärtekrossare..nn.1
  hjärtekval_1_N = mkN "hjärtekval" neutrum  ; -- hjärtekval..nn.1
  hjärtelag_1_N = mkN "hjärtelag" neutrum  ; -- hjärtelag..nn.1
  hjärtelag_2_N = mkN "hjärtelag" neutrum  ; -- hjärtelag..nn.2
  hjärter_1_N = mkN "hjärter" "hjärtern" "hjärter" "hjärterna" ; -- hjärter..nn.1
  hjärterot_1_N = mkN "hjärterot" "hjärterötter" ; -- hjärterot..nn.1
  hjärtesak_1_N = mkN "hjärtesak" "hjärtesaker" ; -- hjärtesak..nn.1
  hjärtesorg_1_N = mkN "hjärtesorg" "hjärtesorger" ; -- hjärtesorg..nn.1
  hjärtesuck_1_N = mkN "hjärtesuck" ; -- hjärtesuck..nn.1
  hjärtesår_1_N = mkN "hjärtesår" neutrum  ; -- hjärtesår..nn.1
  hjärtetrakt_1_N = mkN "hjärtetrakt" "hjärtetrakter" ; -- hjärtetrakt..nn.1
  hjärtevarm_1_A = mkA "hjärtevarm" ; -- hjärtevarm..av.1
  hjärtevrå_1_N = mkN "hjärtevrå" "hjärtevrån" "hjärtevrår" "hjärtevrårna" ; -- hjärtevrå..nn.1
  hjärtevän_1_N = mkN "hjärtevän" "hjärtevännen" "hjärtevänner" "hjärtevännerna" ; -- hjärtevän..nn.1
  hjärtfel_1_N = mkN "hjärtfel" "hjärtfelet" "hjärtfel" "hjärtfelen" ; -- hjärtfel..nn.1
  hjärtflimmer_1_N = mkN "hjärtflimmer" neutrum  ; -- hjärtflimmer..nn.1
  hjärtform_1_N = mkN "hjärtform" ; -- hjärtform..nn.1
  hjärtformad_1_A = mkA "hjärtformad" ; -- hjärtformad..av.1
  hjärtformig_1_A = mkA "hjärtformig" ; -- hjärtformig..av.1
  hjärtinfarkt_1_N = mkN "hjärtinfarkt" "hjärtinfarkter" ; -- hjärtinfarkt..nn.1
  hjärtinnerlig_1_A = mkA "hjärtinnerlig" ; -- hjärtinnerlig..av.1
  hjärtinnerlighet_1_N = mkN "hjärtinnerlighet" "hjärtinnerligheter" ; -- hjärtinnerlighet..nn.1
  hjärtinsufficiens_1_N = mkN "hjärtinsufficiens" ; -- hjärtinsufficiens..nn.1
  hjärtkammare_1_N = mkN "hjärtkammare" "hjärtkammaren" "hjärtkammare" "hjärtkamrarna" ; -- hjärtkammare..nn.1
  hjärtkirurg_1_N = mkN "hjärtkirurg" "hjärtkirurger" ; -- hjärtkirurg..nn.1
  hjärtklaff_1_N = mkN "hjärtklaff" ; -- hjärtklaff..nn.1
  hjärtklappning_1_N = mkN "hjärtklappning" ; -- hjärtklappning..nn.1
  hjärtknipande_1_A = mkA "hjärtknipande" ; -- hjärtknipande..av.1
  hjärtkramp_1_N = mkN "hjärtkramp" "hjärtkramper" ; -- hjärtkramp..nn.1
  hjärtlig_1_A = mkA "hjärtlig" ; -- hjärtlig..av.1
  hjärtligen_1_Adv = mkAdv "hjärtligen" ; -- hjärtligen..ab.1
  hjärtlighet_1_N = mkN "hjärtlighet" "hjärtligheter" ; -- hjärtlighet..nn.1
  hjärtljud_1_N = mkN "hjärtljud" neutrum  ; -- hjärtljud..nn.1
  hjärtlungmaskin_1_N = mkN "hjärtlungmaskin" "hjärtlungmaskiner" ; -- hjärtlungmaskin..nn.1
  hjärtlös_1_A = mkA "hjärtlös" ; -- hjärtlös..av.1
  hjärtlöshet_1_N = mkN "hjärtlöshet" "hjärtlösheter" ; -- hjärtlöshet..nn.1
  hjärtmassage_1_N = mkN "hjärtmassage" utrum  ; -- hjärtmassage..nn.1
  hjärtmuskel_1_N = mkN "hjärtmuskel" "hjärtmuskeln" "hjärtmuskler" "hjärtmusklerna" ; -- hjärtmuskel..nn.1
  hjärtmussla_1_N = mkN "hjärtmussla" ; -- hjärtmussla..nn.1
  hjärtnupen_1_A = mkA "hjärtnupen" ; -- hjärtnupen..av.1
  hjärtnupenhet_1_N = mkN "hjärtnupenhet" ; -- hjärtnupenhet..nn.1
  hjärtoperation_1_N = mkN "hjärtoperation" ; -- hjärtoperation..nn.1
  hjärtpunkt_1_N = mkN "hjärtpunkt" "hjärtpunkter" ; -- hjärtpunkt..nn.1
  hjärtrytm_1_N = mkN "hjärtrytm" "hjärtrytmer" ; -- hjärtrytm..nn.1
  hjärtsjuk_1_A = mkA "hjärtsjuk" ; -- hjärtsjuk..av.1
  hjärtsjukdom_1_N = mkN "hjärtsjukdom" ; -- hjärtsjukdom..nn.1
  hjärtskärande_1_A = mkA "hjärtskärande" ; -- hjärtskärande..av.1
  hjärtsköld_1_N = mkN "hjärtsköld" ; -- hjärtsköld..nn.1
  hjärtslag_1_N = mkN "hjärtslag" neutrum  ; -- hjärtslag..nn.1
  hjärtslitande_1_A = mkA "hjärtslitande" ; -- hjärtslitande..av.1
  hjärtstilla_1_N = mkN "hjärtstilla" ; -- hjärtstilla..nn.1
  hjärtstillande_1_A = mkA "hjärtstillande" ; -- hjärtstillande..av.1
  hjärtstillestånd_1_N = mkN "hjärtstillestånd" neutrum  ; -- hjärtstillestånd..nn.1
  hjärtstock_1_N = mkN "hjärtstock" ; -- hjärtstock..nn.1
  hjärtstopp_1_N = mkN "hjärtstopp" neutrum  ; -- hjärtstopp..nn.1
  hjärtsvikt_1_N = mkN "hjärtsvikt" ; -- hjärtsvikt..nn.1
  hjärtsäck_1_N = mkN "hjärtsäck" ; -- hjärtsäck..nn.1
  hjärttrakt_1_N = mkN "hjärttrakt" "hjärttrakter" ; -- hjärttrakt..nn.1
  hjärttransplantation_1_N = mkN "hjärttransplantation" ; -- hjärttransplantation..nn.1
  hjärtverksamhet_1_N = mkN "hjärtverksamhet" "hjärtverksamheter" ; -- hjärtverksamhet..nn.1
  hjärtängslig_1_A = mkA "hjärtängslig" ; -- hjärtängslig..av.1
  hjärtängslighet_1_N = mkN "hjärtängslighet" ; -- hjärtängslighet..nn.1
  hjässa_1_N = mkN "hjässa" ; -- hjässa..nn.1
  hjässben_1_N = mkN "hjässben" neutrum  ; -- hjässben..nn.1
  hjässbjudning_1_N = mkN "hjässbjudning" ; -- hjässbjudning..nn.1
  hmong_1_N = mkN "hmong" "hmonger" ; -- hmong..nn.1
  ho_1_N = mkN "ho" ; -- ho..nn.1
  hoa_1_V = mkV "hoar" ; -- hoa..vb.1
  hoande_1_N = mkN "hoande" ; -- hoande..nn.1
  hobby_1_N = mkN "hobby" "hobbyn" "hobbysar" "hobbysarna" ; -- hobby..nn.1
  hobbymässig_1_A = mkA "hobbymässig" ; -- hobbymässig..av.1
  hobbyutbildning_1_N = mkN "hobbyutbildning" ; -- hobbyutbildning..nn.1
  hockeybrons_1_N = mkN "hockeybrons" neutrum  ; -- hockeybrons..nn.1
  hockeyklubba_1_N = mkN "hockeyklubba" ; -- hockeyklubba..nn.1
  hockeymässig_1_A = mkA "hockeymässig" ; -- hockeymässig..av.1
  hockeyrör_1_N = mkN "hockeyrör" neutrum  ; -- hockeyrör..nn.1
  hockeyspelare_1_N = mkN "hockeyspelare" utrum  ; -- hockeyspelare..nn.1
  hockeytuta_1_N = mkN "hockeytuta" ; -- hockeytuta..nn.1
  hoj_1_N = mkN "hoj" ; -- hoj..nn.1
  hoja_1_V = mkV "hojar" ; -- hoja..vb.1
  hojande_1_N = mkN "hojande" ; -- hojande..nn.1
  hojta_1_V = mkV "hojtar" ; -- hojta..vb.1
  hojtande_1_N = mkN "hojtande" ; -- hojtande..nn.1
  hojtarolja_1_N = mkN "hojtarolja" ; -- hojtarolja..nn.1
  hojtning_1_N = mkN "hojtning" ; -- hojtning..nn.1
  hokus_pokusterapi_1_N = mkN "hokus-pokusterapi" "hokus-pokusterapier" ; -- hokus-pokusterapi..nn.1
  hokuspokus_1_N = mkN "hokuspokus" neutrum  ; -- hokuspokus..nn.1
  holdingbolag_1_N = mkN "holdingbolag" neutrum  ; -- holdingbolag..nn.1
  holism_1_N = mkN "holism" "holismer" ; -- holism..nn.1
  holistisk_1_A = mkA "holistisk" ; -- holistisk..av.1
  holk_1_N = mkN "holk" ; -- holk..nn.1
  hollandaise_1_N = mkN "hollandaise" utrum  ; -- hollandaise..nn.1
  holländare_1_N = mkN "holländare" utrum  ; -- holländare..nn.1
  holländsk_1_A = mkA "holländsk" ; -- holländsk..av.1
  holländska_1_N = mkN "holländska" ; -- holländska..nn.1
  holländska_2_N = mkN "holländska" ; -- holländska..nn.2
  holme_1_N = mkN "holme" utrum  ; -- holme..nn.1
  holmgång_1_N = mkN "holmgång" ; -- holmgång..nn.1
  holmium_1_N = mkN "holmium" neutrum  ; -- holmium..nn.1
  holocen_1_N = mkN "holocen" ; -- holocen..nn.1
  holografera_1_V = mkV "holograferar" ; -- holografera..vb.1
  holograferande_1_N = mkN "holograferande" ; -- holograferande..nn.1
  holograferbar_1_A = mkA "holograferbar" ; -- holograferbar..av.1
  holograferbarhet_1_N = mkN "holograferbarhet" ; -- holograferbarhet..nn.1
  holografering_1_N = mkN "holografering" ; -- holografering..nn.1
  holografi_1_N = mkN "holografi" ; -- holografi..nn.1
  hologram_1_N = mkN "hologram" "hologrammet" "hologram" "hologrammen" ; -- hologram..nn.1
  holonym_1_N = mkN "holonym" "holonymer" ; -- holonym..nn.1
  holonymi_1_N = mkN "holonymi" "holonymier" ; -- holonymi..nn.1
  holt_1_N = mkN "holt" neutrum  ; -- holt..nn.1
  homeopat_1_N = mkN "homeopat" "homeopater" ; -- homeopat..nn.1
  homeopati_1_N = mkN "homeopati" ; -- homeopati..nn.1
  homeopatisk_1_A = mkA "homeopatisk" ; -- homeopatisk..av.1
  homerisk_1_A = mkA "homerisk" ; -- homerisk..av.1
  homilet_1_N = mkN "homilet" "homileter" ; -- homilet..nn.1
  homiletik_1_N = mkN "homiletik" ; -- homiletik..nn.1
  homiletisk_1_A = mkA "homiletisk" ; -- homiletisk..av.1
  homma_1_N = mkN "homma" ; -- homma..nn.1
  hommage_1_N = mkN "hommage" "hommaget" "hommage" "hommagen" ; -- hommage..nn.1
  homo_1_A = mkA "homo" ; -- homo..av.1
  homo_1_N = mkN "homo" ; -- homo..nn.1
  homoerotisk_1_A = mkA "homoerotisk" ; -- homoerotisk..av.1
  homofil_1_N = mkN "homofil" "homofiler" ; -- homofil..nn.1
  homofob_1_A = mkA "homofob" ; -- homofob..av.1
  homofob_1_N = mkN "homofob" "homofober" ; -- homofob..nn.1
  homofobi_1_N = mkN "homofobi" "homofobier" ; -- homofobi..nn.1
  homofobisk_1_A = mkA "homofobisk" ; -- homofobisk..av.1
  homofon_1_A = mkA "homofon" ; -- homofon..av.1
  homofon_1_N = mkN "homofon" "homofoner" ; -- homofon..nn.1
  homofoni_1_N = mkN "homofoni" "homofonier" ; -- homofoni..nn.1
  homogen_1_A = mkA "homogen" "homogent" ; -- homogen..av.1
  homogenhet_1_N = mkN "homogenhet" ; -- homogenhet..nn.1
  homogenisera_1_V = mkV "homogeniserar" ; -- homogenisera..vb.1
  homogeniserande_1_N = mkN "homogeniserande" ; -- homogeniserande..nn.1
  homogeniserbar_1_A = mkA "homogeniserbar" ; -- homogeniserbar..av.1
  homogeniserbarhet_1_N = mkN "homogeniserbarhet" ; -- homogeniserbarhet..nn.1
  homogenisering_1_N = mkN "homogenisering" ; -- homogenisering..nn.1
  homogenitet_1_N = mkN "homogenitet" "homogeniteter" ; -- homogenitet..nn.1
  homograf_1_A = mkA "homograf" ; -- homograf..av.1
  homograf_1_N = mkN "homograf" "homografer" ; -- homograf..nn.1
  homokultur_1_N = mkN "homokultur" "homokulturer" ; -- homokultur..nn.1
  homolog_1_A = mkA "homolog" ; -- homolog..av.1
  homologi_1_N = mkN "homologi" "homologier" ; -- homologi..nn.1
  homonym_1_A = mkA "homonym" ; -- homonym..av.1
  homonym_1_N = mkN "homonym" "homonymer" ; -- homonym..nn.1
  homonymi_1_N = mkN "homonymi" "homonymier" ; -- homonymi..nn.1
  homopar_1_N = mkN "homopar" neutrum  ; -- homopar..nn.1
  homoporr_1_N = mkN "homoporr" ; -- homoporr..nn.1
  homosex_1_N = mkN "homosex" neutrum  ; -- homosex..nn.1
  homosexualitet_1_N = mkN "homosexualitet" "homosexualiteter" ; -- homosexualitet..nn.1
  homosexuell_1_A = mkA "homosexuell" ; -- homosexuell..av.1
  homovigsel_1_N = mkN "homovigsel" ; -- homovigsel..nn.1
  homozygot_1_A = mkA "homozygot" "homozygot" ; -- homozygot..av.1
  homozygot_1_N = mkN "homozygot" "homozygoter" ; -- homozygot..nn.1
  homoäktenskap_1_N = mkN "homoäktenskap" neutrum  ; -- homoäktenskap..nn.1
  hona_1_N = mkN "hona" ; -- hona..nn.1
  honblomma_1_N = mkN "honblomma" ; -- honblomma..nn.1
  hondjur_1_N = mkN "hondjur" neutrum  ; -- hondjur..nn.1
  honduran_1_N = mkN "honduran" "honduraner" ; -- honduran..nn.1
  honduransk_1_A = mkA "honduransk" ; -- honduransk..av.1
  honduranska_1_N = mkN "honduranska" ; -- honduranska..nn.1
  honkön_1_N = mkN "honkön" neutrum  ; -- honkön..nn.1
  honkönad_1_A = mkA "honkönad" ; -- honkönad..av.1
  honlig_1_A = mkA "honlig" ; -- honlig..av.1
  honnett_1_A = mkA "honnett" ; -- honnett..av.1
  honnör_1_N = mkN "honnör" "honnörer" ; -- honnör..nn.1
  honnörsbetyg_1_N = mkN "honnörsbetyg" neutrum  ; -- honnörsbetyg..nn.1
  honnörsbord_1_N = mkN "honnörsbord" neutrum  ; -- honnörsbord..nn.1
  honnörsord_1_N = mkN "honnörsord" neutrum  ; -- honnörsord..nn.1
  honnörspost_1_N = mkN "honnörspost" "honnörsposter" ; -- honnörspost..nn.1
  honorar_1_N = mkN "honorar" neutrum  ; -- honorar..nn.1
  honorera_1_V = mkV "honorerar" ; -- honorera..vb.1
  honorerande_1_N = mkN "honorerande" ; -- honorerande..nn.1
  honorerbar_1_A = mkA "honorerbar" ; -- honorerbar..av.1
  honorerbarhet_1_N = mkN "honorerbarhet" ; -- honorerbarhet..nn.1
  honorering_1_N = mkN "honorering" ; -- honorering..nn.1
  honorär_1_A = mkA "honorär" ; -- honorär..av.1
  honung_1_N = mkN "honung" ; -- honung..nn.1
  honungsbakad_1_A = mkA "honungsbakad" ; -- honungsbakad..av.1
  honungsfärgad_1_A = mkA "honungsfärgad" ; -- honungsfärgad..av.1
  honungsgul_1_A = mkA "honungsgul" ; -- honungsgul..av.1
  honungskaka_1_N = mkN "honungskaka" ; -- honungskaka..nn.1
  honungslen_1_A = mkA "honungslen" "honungslent" ; -- honungslen..av.1
  honungslenhet_1_N = mkN "honungslenhet" ; -- honungslenhet..nn.1
  honungsmelon_1_N = mkN "honungsmelon" "honungsmeloner" ; -- honungsmelon..nn.1
  honungsproducent_1_N = mkN "honungsproducent" "honungsproducenter" ; -- honungsproducent..nn.1
  honungsskivling_1_N = mkN "honungsskivling" ; -- honungsskivling..nn.1
  honungssöt_1_A = mkA "honungssöt" ; -- honungssöt..av.1
  hop_1_N = mkN "hop" ; -- hop..nn.1
  hopa_1_V = mkV "hopar" ; -- hopa..vb.1
  hopande_1_N = mkN "hopande" ; -- hopande..nn.1
  hopbinda_1_V = mkV "hopbinda" "hopband" "hopbundit" ; -- hopbinda..vb.1
  hopbindning_1_N = mkN "hopbindning" ; -- hopbindning..nn.1
  hopbiten_1_A = mkA "hopbiten" ; -- hopbiten..av.1
  hopbitenhet_1_N = mkN "hopbitenhet" ; -- hopbitenhet..nn.1
  hopblandning_1_N = mkN "hopblandning" ; -- hopblandning..nn.1
  hopbringa_1_V = mkV "hopbringar" ; -- hopbringa..vb.1
  hopbringande_1_N = mkN "hopbringande" ; -- hopbringande..nn.1
  hopbringning_1_N = mkN "hopbringning" ; -- hopbringning..nn.1
  hopbunta_1_V = mkV "hopbuntar" ; -- hopbunta..vb.1
  hopbuntande_1_N = mkN "hopbuntande" ; -- hopbuntande..nn.1
  hopbyggd_1_A = mkA "hopbyggd" "hopbyggt" ; -- hopbyggd..av.1
  hopdikta_1_V = mkV "hopdiktar" ; -- hopdikta..vb.1
  hopdiktande_1_N = mkN "hopdiktande" ; -- hopdiktande..nn.1
  hopdragning_1_N = mkN "hopdragning" ; -- hopdragning..nn.1
  hopdrivning_1_N = mkN "hopdrivning" ; -- hopdrivning..nn.1
  hoper_1_N = mkN "hoper" ; -- hoper..nn.1
  hopfallande_1_N = mkN "hopfallande" ; -- hopfallande..nn.1
  hopfantiserad_1_A = mkA "hopfantiserad" ; -- hopfantiserad..av.1
  hopflätning_1_N = mkN "hopflätning" ; -- hopflätning..nn.1
  hopfoga_1_V = mkV "hopfogar" ; -- hopfoga..vb.1
  hopfogande_1_N = mkN "hopfogande" ; -- hopfogande..nn.1
  hopfogning_1_N = mkN "hopfogning" ; -- hopfogning..nn.1
  hopfrusen_1_A = mkA "hopfrusen" ; -- hopfrusen..av.1
  hopfällbar_1_A = mkA "hopfällbar" ; -- hopfällbar..av.1
  hopfällbarhet_1_N = mkN "hopfällbarhet" ; -- hopfällbarhet..nn.1
  hopfälld_1_A = mkA "hopfälld" "hopfällt" ; -- hopfälld..av.1
  hopfällning_1_N = mkN "hopfällning" ; -- hopfällning..nn.1
  hopfästning_1_N = mkN "hopfästning" ; -- hopfästning..nn.1
  hopgjutning_1_N = mkN "hopgjutning" ; -- hopgjutning..nn.1
  hopgyttrad_1_A = mkA "hopgyttrad" ; -- hopgyttrad..av.1
  hopgyttring_1_N = mkN "hopgyttring" ; -- hopgyttring..nn.1
  hophållen_1_A = mkA "hophållen" ; -- hophållen..av.1
  hopjämkning_1_N = mkN "hopjämkning" ; -- hopjämkning..nn.1
  hopklistring_1_N = mkN "hopklistring" ; -- hopklistring..nn.1
  hopklumpning_1_N = mkN "hopklumpning" ; -- hopklumpning..nn.1
  hopklumpningstillstånd_1_N = mkN "hopklumpningstillstånd" neutrum  ; -- hopklumpningstillstånd..nn.1
  hopklämning_1_N = mkN "hopklämning" ; -- hopklämning..nn.1
  hopknipen_1_A = mkA "hopknipen" ; -- hopknipen..av.1
  hopknipning_1_N = mkN "hopknipning" ; -- hopknipning..nn.1
  hopknyckla_1_V = mkV "hopknycklar" ; -- hopknyckla..vb.1
  hopknycklande_1_N = mkN "hopknycklande" ; -- hopknycklande..nn.1
  hopknyta_1_V = mkV "hopknyta" "hopknöt" "hopknutit" ; -- hopknyta..vb.1
  hopknytning_1_N = mkN "hopknytning" ; -- hopknytning..nn.1
  hopknäppning_1_N = mkN "hopknäppning" ; -- hopknäppning..nn.1
  hopknäppt_1_A = mkA "hopknäppt" "hopknäppt" ; -- hopknäppt..av.1
  hopknåpad_1_A = mkA "hopknåpad" ; -- hopknåpad..av.1
  hopknölad_1_A = mkA "hopknölad" ; -- hopknölad..av.1
  hopkok_1_N = mkN "hopkok" neutrum  ; -- hopkok..nn.1
  hopkokning_1_N = mkN "hopkokning" ; -- hopkokning..nn.1
  hopkommen_1_A = mkA "hopkommen" "hopkommet" "hopkomna" "hopkomna" "hopkomnare" "hopkomnast" "hopkomnaste" ; -- hopkommen..av.1
  hopkoppla_1_V = mkV "hopkopplar" ; -- hopkoppla..vb.1
  hopkopplande_1_N = mkN "hopkopplande" ; -- hopkopplande..nn.1
  hopkoppling_1_N = mkN "hopkoppling" ; -- hopkoppling..nn.1
  hopkrupen_1_A = mkA "hopkrupen" ; -- hopkrupen..av.1
  hopkrympning_1_N = mkN "hopkrympning" ; -- hopkrympning..nn.1
  hopkurad_1_A = mkA "hopkurad" ; -- hopkurad..av.1
  hoplappa_1_V = mkV "hoplappar" ; -- hoplappa..vb.1
  hoplappande_1_N = mkN "hoplappande" ; -- hoplappande..nn.1
  hoplappning_1_N = mkN "hoplappning" ; -- hoplappning..nn.1
  hoplimning_1_N = mkN "hoplimning" ; -- hoplimning..nn.1
  hoplit_1_N = mkN "hoplit" "hopliter" ; -- hoplit..nn.1
  hopläggning_1_N = mkN "hopläggning" ; -- hopläggning..nn.1
  hoplödning_1_N = mkN "hoplödning" ; -- hoplödning..nn.1
  hopning_1_N = mkN "hopning" ; -- hopning..nn.1
  hopp_i_landkalle_1_N = mkN "hopp-i-landkalle" utrum  ; -- hopp-i-landkalle..nn.1
  hopp_1_N = mkN "hopp" neutrum  ; -- hopp..nn.1
  hoppa_1_V = mkV "hoppar" ; -- hoppa..vb.1
  hoppacka_1_V = mkV "hoppackar" ; -- hoppacka..vb.1
  hoppackande_1_N = mkN "hoppackande" ; -- hoppackande..nn.1
  hoppackning_1_N = mkN "hoppackning" ; -- hoppackning..nn.1
  hoppande_1_N = mkN "hoppande" ; -- hoppande..nn.1
  hoppare_1_N = mkN "hoppare" utrum  ; -- hoppare..nn.1
  hoppassning_1_N = mkN "hoppassning" ; -- hoppassning..nn.1
  hoppbacke_1_N = mkN "hoppbacke" utrum  ; -- hoppbacke..nn.1
  hoppeligen_1_Adv = mkAdv "hoppeligen" ; -- hoppeligen..ab.1
  hoppetossa_1_N = mkN "hoppetossa" ; -- hoppetossa..nn.1
  hoppfull_1_A = mkA "hoppfull" ; -- hoppfull..av.1
  hoppfullhet_1_N = mkN "hoppfullhet" "hoppfullheter" ; -- hoppfullhet..nn.1
  hoppförsök_1_N = mkN "hoppförsök" neutrum  ; -- hoppförsök..nn.1
  hoppig_1_A = mkA "hoppig" ; -- hoppig..av.1
  hoppighet_1_N = mkN "hoppighet" ; -- hoppighet..nn.1
  hoppingivande_1_A = mkA "hoppingivande" ; -- hoppingivande..av.1
  hoppjerka_1_N = mkN "hoppjerka" ; -- hoppjerka..nn.1
  hoppledare_1_N = mkN "hoppledare" utrum  ; -- hoppledare..nn.1
  hopplock_1_N = mkN "hopplock" neutrum  ; -- hopplock..nn.1
  hopplockad_1_A = mkA "hopplockad" ; -- hopplockad..av.1
  hopplockning_1_N = mkN "hopplockning" ; -- hopplockning..nn.1
  hopplös_1_A = mkA "hopplös" ; -- hopplös..av.1
  hopplöshet_1_N = mkN "hopplöshet" "hopplösheter" ; -- hopplöshet..nn.1
  hopprep_1_N = mkN "hopprep" neutrum  ; -- hopprep..nn.1
  hoppressning_1_N = mkN "hoppressning" ; -- hoppressning..nn.1
  hoppsnurrspark_1_N = mkN "hoppsnurrspark" ; -- hoppsnurrspark..nn.1
  hoppstjärt_1_N = mkN "hoppstjärt" ; -- hoppstjärt..nn.1
  hoppställning_1_N = mkN "hoppställning" ; -- hoppställning..nn.1
  hopptorn_1_N = mkN "hopptorn" neutrum  ; -- hopptorn..nn.1
  hoppträning_1_N = mkN "hoppträning" ; -- hoppträning..nn.1
  hopptävling_1_N = mkN "hopptävling" ; -- hopptävling..nn.1
  hoprafsa_1_V = mkV "hoprafsar" ; -- hoprafsa..vb.1
  hoprafsande_1_N = mkN "hoprafsande" ; -- hoprafsande..nn.1
  hoprasad_1_A = mkA "hoprasad" ; -- hoprasad..av.1
  hoprullad_1_A = mkA "hoprullad" ; -- hoprullad..av.1
  hoprullande_1_N = mkN "hoprullande" ; -- hoprullande..nn.1
  hoprullning_1_N = mkN "hoprullning" ; -- hoprullning..nn.1
  hopsamling_1_N = mkN "hopsamling" ; -- hopsamling..nn.1
  hopsjunken_1_A = mkA "hopsjunken" ; -- hopsjunken..av.1
  hopsjunkning_1_N = mkN "hopsjunkning" ; -- hopsjunkning..nn.1
  hopskarvning_1_N = mkN "hopskarvning" ; -- hopskarvning..nn.1
  hopskjuta_1_V = mkV "hopskjuta" "hopsköt" "hopskjutit" ; -- hopskjuta..vb.1
  hopskjutande_1_N = mkN "hopskjutande" ; -- hopskjutande..nn.1
  hopskjutbar_1_A = mkA "hopskjutbar" ; -- hopskjutbar..av.1
  hopskrynklad_1_A = mkA "hopskrynklad" ; -- hopskrynklad..av.1
  hopslagen_1_A = mkA "hopslagen" ; -- hopslagen..av.1
  hopslagning_1_N = mkN "hopslagning" ; -- hopslagning..nn.1
  hopsmältning_1_N = mkN "hopsmältning" ; -- hopsmältning..nn.1
  hopsmältning_2_N = mkN "hopsmältning" ; -- hopsmältning..nn.2
  hopsnodd_1_A = mkA "hopsnodd" ; -- hopsnodd..av.1
  hopsnörd_1_A = mkA "hopsnörd" "hopsnört" ; -- hopsnörd..av.1
  hopsnörpt_1_A = mkA "hopsnörpt" "hopsnörpt" ; -- hopsnörpt..av.1
  hopstötning_1_N = mkN "hopstötning" ; -- hopstötning..nn.1
  hopsummering_1_N = mkN "hopsummering" ; -- hopsummering..nn.1
  hopsvetsad_1_A = mkA "hopsvetsad" ; -- hopsvetsad..av.1
  hopsvetsning_1_N = mkN "hopsvetsning" ; -- hopsvetsning..nn.1
  hopsättning_1_N = mkN "hopsättning" ; -- hopsättning..nn.1
  hoptorkad_1_A = mkA "hoptorkad" ; -- hoptorkad..av.1
  hoptorkning_1_N = mkN "hoptorkning" ; -- hoptorkning..nn.1
  hoptovad_1_A = mkA "hoptovad" ; -- hoptovad..av.1
  hoptovning_1_N = mkN "hoptovning" ; -- hoptovning..nn.1
  hoptrasslad_1_A = mkA "hoptrasslad" ; -- hoptrasslad..av.1
  hoptrassling_1_N = mkN "hoptrassling" ; -- hoptrassling..nn.1
  hoptryckbar_1_A = mkA "hoptryckbar" ; -- hoptryckbar..av.1
  hoptryckbarhet_1_N = mkN "hoptryckbarhet" ; -- hoptryckbarhet..nn.1
  hoptryckning_1_N = mkN "hoptryckning" ; -- hoptryckning..nn.1
  hopträngning_1_N = mkN "hopträngning" ; -- hopträngning..nn.1
  hoptråckling_1_N = mkN "hoptråckling" ; -- hoptråckling..nn.1
  hoptvinnad_1_A = mkA "hoptvinnad" ; -- hoptvinnad..av.1
  hopveckling_1_N = mkN "hopveckling" ; -- hopveckling..nn.1
  hopvika_1_V = mkV "hopvika" "hopviker" "hopvik" "hopvek" "hopvikt" "hopviken" ; -- hopvika..vb.1
  hopvikande_1_N = mkN "hopvikande" ; -- hopvikande..nn.1
  hopvikning_1_N = mkN "hopvikning" ; -- hopvikning..nn.1
  hopvridning_1_N = mkN "hopvridning" ; -- hopvridning..nn.1
  hopvuxen_1_A = mkA "hopvuxen" ; -- hopvuxen..av.1
  hopväxning_1_N = mkN "hopväxning" ; -- hopväxning..nn.1
  hopväxt_1_A = mkA "hopväxt" "hopväxt" ; -- hopväxt..av.1
  hor_1_N = mkN "hor" neutrum  ; -- hor..nn.1
  hora_1_N = mkN "hora" ; -- hora..nn.1
  hora_1_V = mkV "horar" ; -- hora..vb.1
  horande_1_N = mkN "horande" ; -- horande..nn.1
  horbock_1_N = mkN "horbock" ; -- horbock..nn.1
  hord_1_N = mkN "hord" "horder" ; -- hord..nn.1
  horhus_1_N = mkN "horhus" neutrum  ; -- horhus..nn.1
  horisont_1_N = mkN "horisont" "horisonter" ; -- horisont..nn.1
  horisontal_1_A = mkA "horisontal" ; -- horisontal..av.1
  horisontalaxlad_1_A = mkA "horisontalaxlad" ; -- horisontalaxlad..av.1
  horisontallinje_1_N = mkN "horisontallinje" "horisontallinjer" ; -- horisontallinje..nn.1
  horisontalläge_1_N = mkN "horisontalläge" ; -- horisontalläge..nn.1
  horisontalplan_1_N = mkN "horisontalplan" neutrum  ; -- horisontalplan..nn.1
  horisontell_1_A = mkA "horisontell" ; -- horisontell..av.1
  horisontlinje_1_N = mkN "horisontlinje" "horisontlinjer" ; -- horisontlinje..nn.1
  horisontproblem_1_N = mkN "horisontproblem" neutrum  ; -- horisontproblem..nn.1
  horkarl_1_N = mkN "horkarl" ; -- horkarl..nn.1
  hormon_1_N = mkN "hormon" neutrum  ; -- hormon..nn.1
  hormonbalans_1_N = mkN "hormonbalans" "hormonbalanser" ; -- hormonbalans..nn.1
  hormonbehandlad_1_A = mkA "hormonbehandlad" ; -- hormonbehandlad..av.1
  hormonell_1_A = mkA "hormonell" ; -- hormonell..av.1
  hormonfunktion_1_N = mkN "hormonfunktion" ; -- hormonfunktion..nn.1
  hormonhalt_1_N = mkN "hormonhalt" "hormonhalter" ; -- hormonhalt..nn.1
  hormonproduktion_1_N = mkN "hormonproduktion" ; -- hormonproduktion..nn.1
  hormonrubbning_1_N = mkN "hormonrubbning" ; -- hormonrubbning..nn.1
  hormonstörande_1_A = mkA "hormonstörande" ; -- hormonstörande..av.1
  hormonsvall_1_N = mkN "hormonsvall" neutrum  ; -- hormonsvall..nn.1
  hormonsystem_1_N = mkN "hormonsystem" neutrum  ; -- hormonsystem..nn.1
  hormoslyr_1_N = mkN "hormoslyr" neutrum  ; -- hormoslyr..nn.1
  horn_1_N = mkN "horn" neutrum  ; -- horn..nn.1
  hornartad_1_A = mkA "hornartad" ; -- hornartad..av.1
  hornblände_1_N = mkN "hornblände" ; -- hornblände..nn.1
  hornboskap_1_N = mkN "hornboskap" ; -- hornboskap..nn.1
  hornbågad_1_A = mkA "hornbågad" ; -- hornbågad..av.1
  hornbåge_1_N = mkN "hornbåge" utrum  ; -- hornbåge..nn.1
  hornform_1_N = mkN "hornform" "hornformer" ; -- hornform..nn.1
  hornformig_1_A = mkA "hornformig" ; -- hornformig..av.1
  horngädda_1_N = mkN "horngädda" ; -- horngädda..nn.1
  hornhinna_1_N = mkN "hornhinna" ; -- hornhinna..nn.1
  hornhud_1_N = mkN "hornhud" ; -- hornhud..nn.1
  hornist_1_N = mkN "hornist" "hornister" ; -- hornist..nn.1
  hornkrona_1_N = mkN "hornkrona" ; -- hornkrona..nn.1
  hornlager_1_N = mkN "hornlager" neutrum  ; -- hornlager..nn.1
  hornliknande_1_A = mkA "hornliknande" ; -- hornliknande..av.1
  hornlös_1_A = mkA "hornlös" ; -- hornlös..av.1
  hornlöshet_1_N = mkN "hornlöshet" ; -- hornlöshet..nn.1
  hornmusik_1_N = mkN "hornmusik" ; -- hornmusik..nn.1
  hornsignal_1_N = mkN "hornsignal" "hornsignaler" ; -- hornsignal..nn.1
  hornstöt_1_N = mkN "hornstöt" ; -- hornstöt..nn.1
  hornsugga_1_N = mkN "hornsugga" ; -- hornsugga..nn.1
  hornuggla_1_N = mkN "hornuggla" ; -- hornuggla..nn.1
  hornämne_1_N = mkN "hornämne" ; -- hornämne..nn.1
  horologium_1_N = mkN "horologium" "horologiet" "horologier" "horologierna" ; -- horologium..nn.1
  horoskop_1_N = mkN "horoskop" neutrum  ; -- horoskop..nn.1
  horribel_1_A = mkA "horribel" ; -- horribel..av.1
  horrör_1_N = mkN "horrör" "horrörer" ; -- horrör..nn.1
  horsgök_1_N = mkN "horsgök" ; -- horsgök..nn.1
  horst_1_N = mkN "horst" ; -- horst..nn.1
  hortensia_1_N = mkN "hortensia" ; -- hortensia..nn.1
  hortikultur_1_N = mkN "hortikultur" ; -- hortikultur..nn.1
  hortonom_1_N = mkN "hortonom" "hortonomer" ; -- hortonom..nn.1
  horunge_1_N = mkN "horunge" utrum  ; -- horunge..nn.1
  hosianna_1_N = mkN "hosianna" "hosiannat" "hosiannan" "hosiannana" ; -- hosianna..nn.1
  hosiannarop_1_N = mkN "hosiannarop" neutrum  ; -- hosiannarop..nn.1
  hospice_1_N = mkN "hospice" "hospicet" "hospice" "hospicen" ; -- hospice..nn.1
  hospis_1_N = mkN "hospis" neutrum  ; -- hospis..nn.1
  hospital_1_N = mkN "hospital" neutrum  ; -- hospital..nn.1
  hospitalisera_1_V = mkV "hospitaliserar" ; -- hospitalisera..vb.1
  hospitaliserande_1_N = mkN "hospitaliserande" ; -- hospitaliserande..nn.1
  hospitaliserbar_1_A = mkA "hospitaliserbar" ; -- hospitaliserbar..av.1
  hospitaliserbarhet_1_N = mkN "hospitaliserbarhet" ; -- hospitaliserbarhet..nn.1
  hospitalisering_1_N = mkN "hospitalisering" ; -- hospitalisering..nn.1
  hospitaliseringseffekt_1_N = mkN "hospitaliseringseffekt" ; -- hospitaliseringseffekt..nn.1
  hospits_1_N = mkN "hospits" neutrum  ; -- hospits..nn.1
  host_1_N = mkN "host" ; -- host..nn.1
  host_2_N = mkN "host" neutrum  ; -- host..nn.2
  hosta_1_N = mkN "hosta" ; -- hosta..nn.1
  hosta_1_V = mkV "hostar" ; -- hosta..vb.1
  hosta_2_V = mkV "hostar" ; -- hosta..vb.2
  hostande_1_N = mkN "hostande" ; -- hostande..nn.1
  hostanfall_1_N = mkN "hostanfall" neutrum  ; -- hostanfall..nn.1
  hostattack_1_N = mkN "hostattack" "hostattacker" ; -- hostattack..nn.1
  hostia_1_N = mkN "hostia" ; -- hostia..nn.1
  hostig_1_A = mkA "hostig" ; -- hostig..av.1
  hostighet_1_N = mkN "hostighet" ; -- hostighet..nn.1
  hostning_1_N = mkN "hostning" ; -- hostning..nn.1
  hot_1_N = mkN "hot" neutrum  ; -- hot..nn.1
  hot_2_N = mkN "hot" ; -- hot..nn.2
  hota_1_V = mkV "hotar" ; -- hota..vb.1
  hotande_1_N = mkN "hotande" ; -- hotande..nn.1
  hotbild_1_N = mkN "hotbild" "hotbilder" ; -- hotbild..nn.1
  hotchpotchsoppa_1_N = mkN "hotchpotchsoppa" ; -- hotchpotchsoppa..nn.1
  hotell_1_N = mkN "hotell" neutrum  ; -- hotell..nn.1
  hotellbrand_1_N = mkN "hotellbrand" "hotellbränder" ; -- hotellbrand..nn.1
  hotellfoajé_1_N = mkN "hotellfoajé" "hotellfoajéer" ; -- hotellfoajé..nn.1
  hotellgäst_1_N = mkN "hotellgäst" "hotellgäster" ; -- hotellgäst..nn.1
  hotellkomplex_1_N = mkN "hotellkomplex" neutrum  ; -- hotellkomplex..nn.1
  hotellmatsal_1_N = mkN "hotellmatsal" ; -- hotellmatsal..nn.1
  hotellmatta_1_N = mkN "hotellmatta" ; -- hotellmatta..nn.1
  hotellobby_1_N = mkN "hotellobby" "hotellobbyer" ; -- hotellobby..nn.1
  hotellpojke_1_N = mkN "hotellpojke" utrum  ; -- hotellpojke..nn.1
  hotellrum_1_N = mkN "hotellrum" "hotellrummet" "hotellrum" "hotellrummen" ; -- hotellrum..nn.1
  hotellstäderska_1_N = mkN "hotellstäderska" ; -- hotellstäderska..nn.1
  hotellvärd_1_N = mkN "hotellvärd" ; -- hotellvärd..nn.1
  hotellägare_1_N = mkN "hotellägare" utrum  ; -- hotellägare..nn.1
  hotelse_1_N = mkN "hotelse" "hotelser" ; -- hotelse..nn.1
  hotelsebrev_1_N = mkN "hotelsebrev" neutrum  ; -- hotelsebrev..nn.1
  hotfull_1_A = mkA "hotfull" ; -- hotfull..av.1
  hotfullhet_1_N = mkN "hotfullhet" "hotfullheter" ; -- hotfullhet..nn.1
  hotnivå_1_N = mkN "hotnivå" "hotnivåer" ; -- hotnivå..nn.1
  hotta_1_V = mkV "hottar" ; -- hotta..vb.1
  hottande_1_N = mkN "hottande" ; -- hottande..nn.1
  hottentotsk_1_A = mkA "hottentotsk" ; -- hottentotsk..av.1
  hottentotska_1_N = mkN "hottentotska" ; -- hottentotska..nn.1
  hottentotska_2_N = mkN "hottentotska" ; -- hottentotska..nn.2
  hottentott_1_N = mkN "hottentott" "hottentotter" ; -- hottentott..nn.1
  hottentottsk_1_A = mkA "hottentottsk" ; -- hottentottsk..av.1
  hottentottska_1_N = mkN "hottentottska" ; -- hottentottska..nn.1
  hottentottska_2_N = mkN "hottentottska" ; -- hottentottska..nn.2
  hottning_1_N = mkN "hottning" ; -- hottning..nn.1
  house_1_N = mkN "house" utrum  ; -- house..nn.1
  hov_1_N = mkN "hov" ; -- hov..nn.1
  hov_2_N = mkN "hov" neutrum  ; -- hov..nn.2
  hovbal_1_N = mkN "hovbal" "hovbaler" ; -- hovbal..nn.1
  hovbeslag_1_N = mkN "hovbeslag" neutrum  ; -- hovbeslag..nn.1
  hovbetjänt_1_N = mkN "hovbetjänt" "hovbetjänter" ; -- hovbetjänt..nn.1
  hovdam_1_N = mkN "hovdam" "hovdamer" ; -- hovdam..nn.1
  hovdignitär_1_N = mkN "hovdignitär" "hovdignitärer" ; -- hovdignitär..nn.1
  hovdjur_1_N = mkN "hovdjur" neutrum  ; -- hovdjur..nn.1
  hovetikett_1_N = mkN "hovetikett" "hovetiketter" ; -- hovetikett..nn.1
  hovförsamling_1_N = mkN "hovförsamling" ; -- hovförsamling..nn.1
  hovintrig_1_N = mkN "hovintrig" "hovintriger" ; -- hovintrig..nn.1
  hovkapell_1_N = mkN "hovkapell" neutrum  ; -- hovkapell..nn.1
  hovlakej_1_N = mkN "hovlakej" "hovlakejer" ; -- hovlakej..nn.1
  hovleverantör_1_N = mkN "hovleverantör" "hovleverantörer" ; -- hovleverantör..nn.1
  hovman_1_N = mkN "hovman" "hovmannen" "hovmän" "hovmännen" ; -- hovman..nn.1
  hovmannamässig_1_A = mkA "hovmannamässig" ; -- hovmannamässig..av.1
  hovmarskalk_1_N = mkN "hovmarskalk" ; -- hovmarskalk..nn.1
  hovmästare_1_N = mkN "hovmästare" utrum  ; -- hovmästare..nn.1
  hovnarr_1_N = mkN "hovnarr" ; -- hovnarr..nn.1
  hovnarrstämpel_1_N = mkN "hovnarrstämpel" ; -- hovnarrstämpel..nn.1
  hovniga_1_V = mkV "hovniga" "hovneg" "hovnigit" ; -- hovniga..vb.1
  hovnigande_1_N = mkN "hovnigande" ; -- hovnigande..nn.1
  hovnigning_1_N = mkN "hovnigning" ; -- hovnigning..nn.1
  hovpredikant_1_N = mkN "hovpredikant" "hovpredikanter" ; -- hovpredikant..nn.1
  hovra_1_V = mkV "hovrar" ; -- hovra..vb.1
  hovrande_1_N = mkN "hovrande" ; -- hovrande..nn.1
  hovreporter_1_N = mkN "hovreporter" ; -- hovreporter..nn.1
  hovrätt_1_N = mkN "hovrätt" "hovrätter" ; -- hovrätt..nn.1
  hovrättsassessor_1_N = mkN "hovrättsassessor" "hovrättsassessorer" ; -- hovrättsassessor..nn.1
  hovrättsexamen_1_N = mkN "hovrättsexamen" "hovrättsexamen" "hovrättsexamina" "hovrättsexamina" ; -- hovrättsexamen..nn.1
  hovrättspresident_1_N = mkN "hovrättspresident" "hovrättspresidenter" ; -- hovrättspresident..nn.1
  hovrättsråd_1_N = mkN "hovrättsråd" neutrum  ; -- hovrättsråd..nn.1
  hovsam_1_A = mkA "hovsam" "hovsamt" "hovsamma" "hovsamma" "hovsammare" "hovsammast" "hovsammaste" ; -- hovsam..av.1
  hovsamhet_1_N = mkN "hovsamhet" ; -- hovsamhet..nn.1
  hovslag_1_N = mkN "hovslag" neutrum  ; -- hovslag..nn.1
  hovslagare_1_N = mkN "hovslagare" utrum  ; -- hovslagare..nn.1
  hovstat_1_N = mkN "hovstat" "hovstater" ; -- hovstat..nn.1
  hovtång_1_N = mkN "hovtång" "hovtänger" ; -- hovtång..nn.1
  hryvnja_1_N = mkN "hryvnja" "hryvnjan" "hryvnja" "hryvnjana" ; -- hryvnja..nn.1
  huckle_1_N = mkN "huckle" ; -- huckle..nn.1
  hud_1_N = mkN "hud" ; -- hud..nn.1
  hudbehandling_1_N = mkN "hudbehandling" ; -- hudbehandling..nn.1
  hudcancer_1_N = mkN "hudcancer" ; -- hudcancer..nn.1
  hudcancerform_1_N = mkN "hudcancerform" "hudcancerformer" ; -- hudcancerform..nn.1
  hudcell_1_N = mkN "hudcell" "hudceller" ; -- hudcell..nn.1
  hudficka_1_N = mkN "hudficka" ; -- hudficka..nn.1
  hudflaga_1_N = mkN "hudflaga" ; -- hudflaga..nn.1
  hudflik_1_N = mkN "hudflik" ; -- hudflik..nn.1
  hudflora_1_N = mkN "hudflora" ; -- hudflora..nn.1
  hudfläck_1_N = mkN "hudfläck" ; -- hudfläck..nn.1
  hudflänga_1_V = mkV "hudflänger" ; -- hudflänga..vb.1
  hudflängande_1_N = mkN "hudflängande" ; -- hudflängande..nn.1
  hudflängning_1_N = mkN "hudflängning" ; -- hudflängning..nn.1
  hudfärg_1_N = mkN "hudfärg" "hudfärger" ; -- hudfärg..nn.1
  hudfärgad_1_A = mkA "hudfärgad" ; -- hudfärgad..av.1
  hudförändring_1_N = mkN "hudförändring" ; -- hudförändring..nn.1
  hudhorn_1_N = mkN "hudhorn" neutrum  ; -- hudhorn..nn.1
  hudinflammation_1_N = mkN "hudinflammation" ; -- hudinflammation..nn.1
  hudkräm_1_N = mkN "hudkräm" "hudkrämer" ; -- hudkräm..nn.1
  hudlager_1_N = mkN "hudlager" neutrum  ; -- hudlager..nn.1
  hudlös_1_A = mkA "hudlös" ; -- hudlös..av.1
  hudlöshet_1_N = mkN "hudlöshet" ; -- hudlöshet..nn.1
  hudmedel_1_N = mkN "hudmedel" neutrum  ; -- hudmedel..nn.1
  hudmissfärgning_1_N = mkN "hudmissfärgning" ; -- hudmissfärgning..nn.1
  hudnära_1_A = mkA "hudnära" ; -- hudnära..av.1
  hudolja_1_N = mkN "hudolja" ; -- hudolja..nn.1
  hudsalva_1_N = mkN "hudsalva" ; -- hudsalva..nn.1
  hudsjukdom_1_N = mkN "hudsjukdom" ; -- hudsjukdom..nn.1
  hudspecialist_1_N = mkN "hudspecialist" "hudspecialister" ; -- hudspecialist..nn.1
  hudspricka_1_N = mkN "hudspricka" ; -- hudspricka..nn.1
  hudterapeut_1_N = mkN "hudterapeut" "hudterapeuter" ; -- hudterapeut..nn.1
  hudtransplantation_1_N = mkN "hudtransplantation" ; -- hudtransplantation..nn.1
  hudtumör_1_N = mkN "hudtumör" "hudtumörer" ; -- hudtumör..nn.1
  hudutslag_1_N = mkN "hudutslag" neutrum  ; -- hudutslag..nn.1
  hudveck_1_N = mkN "hudveck" neutrum  ; -- hudveck..nn.1
  hudvänlig_1_A = mkA "hudvänlig" ; -- hudvänlig..av.1
  hudvänlighet_1_N = mkN "hudvänlighet" ; -- hudvänlighet..nn.1
  hudömsning_1_N = mkN "hudömsning" ; -- hudömsning..nn.1
  hug_1_N = mkN "hug" ; -- hug..nn.1
  hugad_1_A = mkA "hugad" ; -- hugad..av.1
  hugenott_1_N = mkN "hugenott" "hugenotter" ; -- hugenott..nn.1
  hugfästa_1_V = mkV "hugfästa" "hugfäster" "hugfäst" "hugfäste" "hugfäst" "hugfäst" ; -- hugfästa..vb.1
  hugfästande_1_N = mkN "hugfästande" ; -- hugfästande..nn.1
  hugg_1_N = mkN "hugg" neutrum  ; -- hugg..nn.1
  hugga_1_V = mkV "hugga" "högg" "huggit" ; -- hugga..vb.1
  hugga_2_V = mkV "hugga" "högg" "huggit" ; -- hugga..vb.2
  huggande_1_N = mkN "huggande" ; -- huggande..nn.1
  huggare_1_N = mkN "huggare" utrum  ; -- huggare..nn.1
  huggjärn_1_N = mkN "huggjärn" neutrum  ; -- huggjärn..nn.1
  huggkniv_1_N = mkN "huggkniv" ; -- huggkniv..nn.1
  huggkrok_1_N = mkN "huggkrok" ; -- huggkrok..nn.1
  huggkubbe_1_N = mkN "huggkubb" ; -- huggkubbe..nn.1
  huggmejsel_1_N = mkN "huggmejsel" ; -- huggmejsel..nn.1
  huggning_1_N = mkN "huggning" ; -- huggning..nn.1
  huggorm_1_N = mkN "huggorm" ; -- huggorm..nn.1
  huggsexa_1_N = mkN "huggsexa" ; -- huggsexa..nn.1
  huggsvärd_1_N = mkN "huggsvärd" neutrum  ; -- huggsvärd..nn.1
  huggsår_1_N = mkN "huggsår" neutrum  ; -- huggsår..nn.1
  huggtand_1_N = mkN "huggtand" "huggtänder" ; -- huggtand..nn.1
  huggvapen_1_N = mkN "huggvapen" "huggvapnet" "huggvapen" "huggvapnen" ; -- huggvapen..nn.1
  huggvärja_1_N = mkN "huggvärja" ; -- huggvärja..nn.1
  huggyxa_1_N = mkN "huggyxa" ; -- huggyxa..nn.1
  hugna_1_V = mkV "hugnar" ; -- hugna..vb.1
  hugnad_1_N = mkN "hugnad" "hugnader" ; -- hugnad..nn.1
  hugnande_1_N = mkN "hugnande" ; -- hugnande..nn.1
  hugnesam_1_A = mkA "hugnesam" "hugnesamt" "hugnesamma" "hugnesamma" "hugnesammare" "hugnesammast" "hugnesammaste" ; -- hugnesam..av.1
  hugnesamhet_1_N = mkN "hugnesamhet" ; -- hugnesamhet..nn.1
  hugskott_1_N = mkN "hugskott" neutrum  ; -- hugskott..nn.1
  hugsvala_1_V = mkV "hugsvalar" ; -- hugsvala..vb.1
  hugsvalande_1_N = mkN "hugsvalande" ; -- hugsvalande..nn.1
  hugsvalare_1_N = mkN "hugsvalare" utrum  ; -- hugsvalare..nn.1
  hukning_1_N = mkN "hukning" ; -- hukning..nn.1
  hula_hula_1_N = mkN "hula-hula" ; -- hula-hula..nn.1
  huld_1_A = mkA "huld" "hult" ; -- huld..av.1
  huldhet_1_N = mkN "huldhet" ; -- huldhet..nn.1
  huldra_1_N = mkN "huldra" ; -- huldra..nn.1
  huligan_1_N = mkN "huligan" "huliganer" ; -- huligan..nn.1
  hulk_1_N = mkN "hulk" ; -- hulk..nn.1
  hulka_1_V = mkV "hulkar" ; -- hulka..vb.1
  hulkande_1_N = mkN "hulkande" ; -- hulkande..nn.1
  hull_1_N = mkN "hull" neutrum  ; -- hull..nn.1
  hulling_1_N = mkN "hulling" ; -- hulling..nn.1
  hullingförsedd_1_A = mkA "hullingförsedd" ; -- hullingförsedd..av.1
  hult_1_N = mkN "hult" ; -- hult..nn.1
  hum_1_N = mkN "hum" ; -- hum..nn.1
  human_1_A = mkA "human" ; -- human..av.1
  humanekologi_1_N = mkN "humanekologi" ; -- humanekologi..nn.1
  humanekologisk_1_A = mkA "humanekologisk" ; -- humanekologisk..av.1
  humaniora_1_N = mkN "humaniora" "humanioran" "humaniora" "humaniorana" ; -- humaniora..nn.1
  humanisera_1_V = mkV "humaniserar" ; -- humanisera..vb.1
  humaniserande_1_N = mkN "humaniserande" ; -- humaniserande..nn.1
  humaniserbar_1_A = mkA "humaniserbar" ; -- humaniserbar..av.1
  humaniserbarhet_1_N = mkN "humaniserbarhet" ; -- humaniserbarhet..nn.1
  humanisering_1_N = mkN "humanisering" ; -- humanisering..nn.1
  humanism_1_N = mkN "humanism" "humanismer" ; -- humanism..nn.1
  humanist_1_N = mkN "humanist" "humanister" ; -- humanist..nn.1
  humanistisk_1_A = mkA "humanistisk" ; -- humanistisk..av.1
  humanitet_1_N = mkN "humanitet" "humaniteter" ; -- humanitet..nn.1
  humanitetsskäl_1_N = mkN "humanitetsskäl" neutrum  ; -- humanitetsskäl..nn.1
  humanitär_1_A = mkA "humanitär" ; -- humanitär..av.1
  humanvetenskap_1_N = mkN "humanvetenskap" "humanvetenskaper" ; -- humanvetenskap..nn.1
  humbug_1_N = mkN "humbug" ; -- humbug..nn.1
  humid_1_A = mkA "humid" ; -- humid..av.1
  humifiering_1_N = mkN "humifiering" ; -- humifiering..nn.1
  humla_1_N = mkN "humla" ; -- humla..nn.1
  humle_1_N = mkN "humle" ; -- humle..nn.1
  humleblomma_1_N = mkN "humleblomma" ; -- humleblomma..nn.1
  humleblomster_1_N = mkN "humleblomster" neutrum  ; -- humleblomster..nn.1
  humleplockare_1_N = mkN "humleplockare" utrum  ; -- humleplockare..nn.1
  humlesurr_1_N = mkN "humlesurr" neutrum  ; -- humlesurr..nn.1
  humma_1_V = mkV "hummar" ; -- humma..vb.1
  hummande_1_N = mkN "hummande" ; -- hummande..nn.1
  hummer_1_N = mkN "hummer" "hummern" "humrar" "humrarna" ; -- hummer..nn.1
  hummersås_1_N = mkN "hummersås" "hummersåser" ; -- hummersås..nn.1
  hummertina_1_N = mkN "hummertina" ; -- hummertina..nn.1
  hummus_1_N = mkN "hummus" ; -- hummus..nn.1
  humorduo_1_N = mkN "humorduo" "humorduor" ; -- humorduo..nn.1
  humoresk_1_N = mkN "humoresk" "humoresker" ; -- humoresk..nn.1
  humorist_1_N = mkN "humorist" "humorister" ; -- humorist..nn.1
  humoristisk_1_A = mkA "humoristisk" ; -- humoristisk..av.1
  humus_1_N = mkN "humus" ; -- humus..nn.1
  humusbunden_1_A = mkA "humusbunden" ; -- humusbunden..av.1
  humusbundenhet_1_N = mkN "humusbundenhet" ; -- humusbundenhet..nn.1
  humusförening_1_N = mkN "humusförening" ; -- humusförening..nn.1
  humushalt_1_N = mkN "humushalt" "humushalter" ; -- humushalt..nn.1
  humushaltig_1_A = mkA "humushaltig" ; -- humushaltig..av.1
  humuskomponent_1_N = mkN "humuskomponent" "humuskomponenter" ; -- humuskomponent..nn.1
  humuskoncentration_1_N = mkN "humuskoncentration" ; -- humuskoncentration..nn.1
  humussubstans_1_N = mkN "humussubstans" "humussubstanser" ; -- humussubstans..nn.1
  humussyra_1_N = mkN "humussyra" ; -- humussyra..nn.1
  humusvatten_1_N = mkN "humusvatten" "humusvattnet" "humusvatten" "humusvattnen" ; -- humusvatten..nn.1
  humusämne_1_N = mkN "humusämne" ; -- humusämne..nn.1
  humör_1_N = mkN "humör" neutrum  ; -- humör..nn.1
  humörmänniska_1_N = mkN "humörmänniska" ; -- humörmänniska..nn.1
  humörmässig_1_A = mkA "humörmässig" ; -- humörmässig..av.1
  humörspelare_1_N = mkN "humörspelare" utrum  ; -- humörspelare..nn.1
  hund_1_N = mkN "hund" ; -- hund..nn.1
  hundallergi_1_N = mkN "hundallergi" "hundallergier" ; -- hundallergi..nn.1
  hundan_1_N = mkN "hundan" ; -- hundan..nn.1
  hundapa_1_N = mkN "hundapa" ; -- hundapa..nn.1
  hundare_1_N = mkN "hundare" ; -- hundare..nn.1
  hundbajs_1_N = mkN "hundbajs" neutrum  ; -- hundbajs..nn.1
  hundben_1_N = mkN "hundben" neutrum  ; -- hundben..nn.1
  hundblick_1_N = mkN "hundblick" ; -- hundblick..nn.1
  hunddjur_1_N = mkN "hunddjur" neutrum  ; -- hunddjur..nn.1
  hunddressyr_1_N = mkN "hunddressyr" "hunddressyrer" ; -- hunddressyr..nn.1
  hundförare_1_N = mkN "hundförare" utrum  ; -- hundförare..nn.1
  hundgård_1_N = mkN "hundgård" ; -- hundgård..nn.1
  hundhalsband_1_N = mkN "hundhalsband" neutrum  ; -- hundhalsband..nn.1
  hundhetsning_1_N = mkN "hundhetsning" ; -- hundhetsning..nn.1
  hundhuvud_1_N = mkN "hundhuvud" "hundhuvudet" "hundhuvud" "hundhuvudena" ; -- hundhuvud..nn.1
  hundhår_1_N = mkN "hundhår" neutrum  ; -- hundhår..nn.1
  hundhövdad_1_A = mkA "hundhövdad" ; -- hundhövdad..av.1
  hundkapplöpning_1_N = mkN "hundkapplöpning" ; -- hundkapplöpning..nn.1
  hundkex_1_N = mkN "hundkex" neutrum  ; -- hundkex..nn.1
  hundkoja_1_N = mkN "hundkoja" ; -- hundkoja..nn.1
  hundkurs_1_N = mkN "hundkurs" "hundkurser" ; -- hundkurs..nn.1
  hundkäx_2_N = mkN "hundkäx" neutrum  ; -- hundkäx..nn.2
  hundlik_1_A = mkA "hundlik" ; -- hundlik..av.1
  hundlik_1_N = mkN "hundlik" neutrum  ; -- hundlik..nn.1
  hundliv_1_N = mkN "hundliv" neutrum  ; -- hundliv..nn.1
  hundloka_1_N = mkN "hundloka" ; -- hundloka..nn.1
  hundlort_1_N = mkN "hundlort" ; -- hundlort..nn.1
  hundmat_1_N = mkN "hundmat" ; -- hundmat..nn.1
  hundpatrull_1_N = mkN "hundpatrull" "hundpatruller" ; -- hundpatrull..nn.1
  hundpensionat_1_N = mkN "hundpensionat" neutrum  ; -- hundpensionat..nn.1
  hundra_1_A = mkA "hundra" ; -- hundra..av.1
  hundracka_1_N = mkN "hundracka" ; -- hundracka..nn.1
  hundrade_1_A = mkA "hundrade" ; -- hundrade..av.1
  hundrade_1_N = mkN "hundrade" ; -- hundrade..nn.1
  hundradedel_1_N = mkN "hundradedel" "hundradedelen" "hundradedelar" "hundradedelarna" ; -- hundradedel..nn.1
  hundradel_1_N = mkN "hundradel" "hundradelen" "hundradelar" "hundradelarna" ; -- hundradel..nn.1
  hundrafalt_1_Adv = mkAdv "hundrafalt" ; -- hundrafalt..ab.1
  hundrakronorssedel_1_N = mkN "hundrakronorssedel" ; -- hundrakronorssedel..nn.1
  hundralapp_1_N = mkN "hundralapp" ; -- hundralapp..nn.1
  hundraprocentig_1_A = mkA "hundraprocentig" ; -- hundraprocentig..av.1
  hundras_1_N = mkN "hundras" "hundraser" ; -- hundras..nn.1
  hundratal_1_N = mkN "hundratal" neutrum  ; -- hundratal..nn.1
  hundratusental_1_N = mkN "hundratusental" neutrum  ; -- hundratusental..nn.1
  hundratusentonnare_1_N = mkN "hundratusentonnare" utrum  ; -- hundratusentonnare..nn.1
  hundraårig_1_A = mkA "hundraårig" ; -- hundraårig..av.1
  hundraåring_1_N = mkN "hundraåring" ; -- hundraåring..nn.1
  hundraårsjubileum_1_N = mkN "hundraårsjubileum" "hundraårsjubileet" "hundraårsjubileer" "hundraårsjubileerna" ; -- hundraårsjubileum..nn.1
  hundraårsminne_1_N = mkN "hundraårsminne" ; -- hundraårsminne..nn.1
  hundraårsperiod_1_N = mkN "hundraårsperiod" "hundraårsperioder" ; -- hundraårsperiod..nn.1
  hundring_1_N = mkN "hundring" ; -- hundring..nn.1
  hundrova_1_N = mkN "hundrova" ; -- hundrova..nn.1
  hundrädd_1_A = mkA "hundrädd" ; -- hundrädd..av.1
  hundsa_1_V = mkV "hundsar" ; -- hundsa..vb.1
  hundsande_1_N = mkN "hundsande" ; -- hundsande..nn.1
  hundsfottera_1_V = mkV "hundsfotterar" ; -- hundsfottera..vb.1
  hundsfotterande_1_N = mkN "hundsfotterande" ; -- hundsfotterande..nn.1
  hundsfotterbar_1_A = mkA "hundsfotterbar" ; -- hundsfotterbar..av.1
  hundsfotterbarhet_1_N = mkN "hundsfotterbarhet" ; -- hundsfotterbarhet..nn.1
  hundsfottering_1_N = mkN "hundsfottering" ; -- hundsfottering..nn.1
  hundskall_1_N = mkN "hundskall" neutrum  ; -- hundskall..nn.1
  hundskatt_1_N = mkN "hundskatt" "hundskatter" ; -- hundskatt..nn.1
  hundskit_1_N = mkN "hundskit" ; -- hundskit..nn.1
  hundskulptur_1_N = mkN "hundskulptur" "hundskulpturer" ; -- hundskulptur..nn.1
  hundslagsmål_1_N = mkN "hundslagsmål" neutrum  ; -- hundslagsmål..nn.1
  hundsläde_1_N = mkN "hundsläde" utrum  ; -- hundsläde..nn.1
  hundvakt_1_N = mkN "hundvakt" "hundvakter" ; -- hundvakt..nn.1
  hundvalp_1_N = mkN "hundvalp" ; -- hundvalp..nn.1
  hundväder_1_N = mkN "hundväder" neutrum  ; -- hundväder..nn.1
  hundägare_1_N = mkN "hundägare" utrum  ; -- hundägare..nn.1
  hundäxing_1_N = mkN "hundäxing" ; -- hundäxing..nn.1
  hundår_1_N = mkN "hundår" neutrum  ; -- hundår..nn.1
  hundöra_1_N = mkN "hundöra" "hundörat" "hundöron" "hundöronen" ; -- hundöra..nn.1
  hundörad_1_A = mkA "hundörad" ; -- hundörad..av.1
  hunger_1_N = mkN "hunger" ; -- hunger..nn.1
  hungersdöd_1_N = mkN "hungersdöd" ; -- hungersdöd..nn.1
  hungersnöd_1_N = mkN "hungersnöd" ; -- hungersnöd..nn.1
  hungerstrejk_1_N = mkN "hungerstrejk" "hungerstrejker" ; -- hungerstrejk..nn.1
  hungerstrejka_1_V = mkV "hungerstrejkar" ; -- hungerstrejka..vb.1
  hungerstrejkande_1_N = mkN "hungerstrejkande" ; -- hungerstrejkande..nn.1
  hungerupplopp_1_N = mkN "hungerupplopp" neutrum  ; -- hungerupplopp..nn.1
  hungerår_1_N = mkN "hungerår" neutrum  ; -- hungerår..nn.1
  hungra_1_V = mkV "hungrar" ; -- hungra..vb.1
  hungrande_1_N = mkN "hungrande" ; -- hungrande..nn.1
  hungrig_1_A = mkA "hungrig" ; -- hungrig..av.1
  hungrighet_1_N = mkN "hungrighet" ; -- hungrighet..nn.1
  hunk_1_N = mkN "hunk" ; -- hunk..nn.1
  hunka_1_N = mkN "hunka" ; -- hunka..nn.1
  hunn_1_N = mkN "hunn" "hunner" ; -- hunn..nn.1
  hunner_1_N = mkN "hunner" "hunnern" "hunner" "hunnerna" ; -- hunner..nn.1
  hunsa_1_V = mkV "hunsar" ; -- hunsa..vb.1
  hunsande_1_N = mkN "hunsande" ; -- hunsande..nn.1
  hur_1_Adv = mkAdv "hur" ; -- hur..ab.1
  hurdags_1_Adv = mkAdv "hurdags" ; -- hurdags..ab.1
  hurdå_1_Adv = mkAdv "hurdå" ; -- hurdå..ab.1
  hurpass_1_Adv = mkAdv "hurpass" ; -- hurpass..ab.1
  hurra_1_N = mkN "hurra" "hurrat" "hurran" "hurrana" ; -- hurra..nn.1
  hurra_1_V = mkV "hurrar" ; -- hurra..vb.1
  hurrande_1_N = mkN "hurrande" ; -- hurrande..nn.1
  hurrarop_1_N = mkN "hurrarop" neutrum  ; -- hurrarop..nn.1
  hurril_1_N = mkN "hurril" ; -- hurril..nn.1
  hursarregemente_1_N = mkN "hursarregemente" ; -- hursarregemente..nn.1
  hursomhaver_1_Adv = mkAdv "hursomhaver" ; -- hursomhaver..ab.1
  hursomhelst_1_Adv = mkAdv "hursomhelst" ; -- hursomhelst..ab.1
  hurså_1_Adv = mkAdv "hurså" ; -- hurså..ab.1
  hurtbulle_1_N = mkN "hurtbulle" utrum  ; -- hurtbulle..nn.1
  hurtfrisk_1_A = mkA "hurtfrisk" ; -- hurtfrisk..av.1
  hurtig_1_A = mkA "hurtig" ; -- hurtig..av.1
  hurtighet_1_N = mkN "hurtighet" ; -- hurtighet..nn.1
  hurts_1_N = mkN "hurts" ; -- hurts..nn.1
  huruledes_1_Adv = mkAdv "huruledes" ; -- huruledes..ab.1
  hus_1_N = mkN "hus" neutrum  ; -- hus..nn.1
  husa_1_N = mkN "husa" ; -- husa..nn.1
  husaga_1_N = mkN "husaga" ; -- husaga..nn.1
  husandakt_1_N = mkN "husandakt" "husandakter" ; -- husandakt..nn.1
  husapotek_1_N = mkN "husapotek" neutrum  ; -- husapotek..nn.1
  husar_1_N = mkN "husar" "husarer" ; -- husar..nn.1
  husarlöjtnant_1_N = mkN "husarlöjtnant" "husarlöjtnanter" ; -- husarlöjtnant..nn.1
  husarrest_1_N = mkN "husarrest" ; -- husarrest..nn.1
  husbehov_1_N = mkN "husbehov" neutrum  ; -- husbehov..nn.1
  husbehovsbränning_1_N = mkN "husbehovsbränning" ; -- husbehovsbränning..nn.1
  husbil_1_N = mkN "husbil" ; -- husbil..nn.1
  husbloss_1_N = mkN "husbloss" neutrum  ; -- husbloss..nn.1
  husbock_1_N = mkN "husbock" ; -- husbock..nn.1
  husbonde_1_N = mkN "husbonde" "husbönder" ; -- husbonde..nn.1
  husbondfolk_1_N = mkN "husbondfolk" neutrum  ; -- husbondfolk..nn.1
  husbygge_1_N = mkN "husbygge" ; -- husbygge..nn.1
  husbyggnad_1_N = mkN "husbyggnad" "husbyggnader" ; -- husbyggnad..nn.1
  husbåt_1_N = mkN "husbåt" ; -- husbåt..nn.1
  husdjur_1_N = mkN "husdjur" neutrum  ; -- husdjur..nn.1
  husdjursartikel_1_N = mkN "husdjursartikel" ; -- husdjursartikel..nn.1
  husdjursavel_1_N = mkN "husdjursavel" ; -- husdjursavel..nn.1
  husdjursskötsel_1_N = mkN "husdjursskötsel" ; -- husdjursskötsel..nn.1
  husdoktor_1_N = mkN "husdoktor" "husdoktorer" ; -- husdoktor..nn.1
  husera_1_V = mkV "huserar" ; -- husera..vb.1
  husera_2_V = mkV "huserar" ; -- husera..vb.2
  huserande_1_N = mkN "huserande" ; -- huserande..nn.1
  huserbar_1_A = mkA "huserbar" ; -- huserbar..av.1
  huserbarhet_1_N = mkN "huserbarhet" ; -- huserbarhet..nn.1
  husering_1_N = mkN "husering" ; -- husering..nn.1
  husesyn_1_N = mkN "husesyn" "husesyner" ; -- husesyn..nn.1
  husfar_1_N = mkN "husfader" "husfadern" "husfäder" "husfäderna" ; -- husfar..nn.1
  husfasad_1_N = mkN "husfasad" "husfasader" ; -- husfasad..nn.1
  husfluga_1_N = mkN "husfluga" ; -- husfluga..nn.1
  husfolk_1_N = mkN "husfolk" neutrum  ; -- husfolk..nn.1
  husfrid_1_N = mkN "husfrid" ; -- husfrid..nn.1
  husfridsknull_1_N = mkN "husfridsknull" neutrum  ; -- husfridsknull..nn.1
  husfru_1_N = mkN "husfru" ; -- husfru..nn.1
  husföreståndarinna_1_N = mkN "husföreståndarinna" ; -- husföreståndarinna..nn.1
  husförhör_1_N = mkN "husförhör" neutrum  ; -- husförhör..nn.1
  husförvärv_1_N = mkN "husförvärv" neutrum  ; -- husförvärv..nn.1
  husgavel_1_N = mkN "husgavel" ; -- husgavel..nn.1
  husgeråd_1_N = mkN "husgeråd" neutrum  ; -- husgeråd..nn.1
  husgrund_1_N = mkN "husgrund" "husgrunder" ; -- husgrund..nn.1
  husgud_1_N = mkN "husgud" ; -- husgud..nn.1
  hushåll_1_N = mkN "hushåll" neutrum  ; -- hushåll..nn.1
  hushålla_1_V = mkV "hushållar" ; -- hushålla..vb.1
  hushållande_1_N = mkN "hushållande" ; -- hushållande..nn.1
  hushållare_1_N = mkN "hushållare" utrum  ; -- hushållare..nn.1
  hushållerska_1_N = mkN "hushållerska" ; -- hushållerska..nn.1
  hushållning_1_N = mkN "hushållning" ; -- hushållning..nn.1
  hushållningssällskap_1_N = mkN "hushållningssällskap" neutrum  ; -- hushållningssällskap..nn.1
  hushållsarbete_1_N = mkN "hushållsarbete" ; -- hushållsarbete..nn.1
  hushållsartikel_1_N = mkN "hushållsartikel" ; -- hushållsartikel..nn.1
  hushållsassistent_1_N = mkN "hushållsassistent" "hushållsassistenter" ; -- hushållsassistent..nn.1
  hushållsbok_1_N = mkN "hushållsbok" "hushållsböcker" ; -- hushållsbok..nn.1
  hushållsgris_1_N = mkN "hushållsgris" ; -- hushållsgris..nn.1
  hushållskassa_1_N = mkN "hushållskassa" ; -- hushållskassa..nn.1
  hushållsnära_1_A = mkA "hushållsnära" ; -- hushållsnära..av.1
  hushållsost_1_N = mkN "hushållsost" ; -- hushållsost..nn.1
  hushållspapper_1_N = mkN "hushållspapper" neutrum  ; -- hushållspapper..nn.1
  hushållsrulle_1_N = mkN "hushållsrulle" utrum  ; -- hushållsrulle..nn.1
  hushållssyssla_1_N = mkN "hushållssyssla" ; -- hushållssyssla..nn.1
  hushållsvåg_1_N = mkN "hushållsvåg" ; -- hushållsvåg..nn.1
  husknut_1_N = mkN "husknut" ; -- husknut..nn.1
  huskors_1_N = mkN "huskors" neutrum  ; -- huskors..nn.1
  huskropp_1_N = mkN "huskropp" ; -- huskropp..nn.1
  huskur_1_N = mkN "huskur" "huskurer" ; -- huskur..nn.1
  husköp_1_N = mkN "husköp" neutrum  ; -- husköp..nn.1
  huslig_1_A = mkA "huslig" ; -- huslig..av.1
  huslighet_1_N = mkN "huslighet" ; -- huslighet..nn.1
  husläkare_1_N = mkN "husläkare" utrum  ; -- husläkare..nn.1
  husläkekonst_1_N = mkN "husläkekonst" ; -- husläkekonst..nn.1
  huslänga_1_N = mkN "huslänga" ; -- huslänga..nn.1
  husman_1_N = mkN "husman" ; -- husman..nn.1
  husmansfolk_1_N = mkN "husmansfolk" neutrum  ; -- husmansfolk..nn.1
  husmanskost_1_N = mkN "husmanskost" ; -- husmanskost..nn.1
  husmoderlig_1_A = mkA "husmoderlig" ; -- husmoderlig..av.1
  husmor_1_N = mkN "husmor" "husmodern" "husmödrar" "husmödrarna" ; -- husmor..nn.1
  husmorsförening_1_N = mkN "husmorsförening" ; -- husmorsförening..nn.1
  husmorssemester_1_N = mkN "husmorssemester" ; -- husmorssemester..nn.1
  husnummer_1_N = mkN "husnummer" neutrum  ; -- husnummer..nn.1
  husnyckel_1_N = mkN "husnyckel" ; -- husnyckel..nn.1
  husorgan_1_N = mkN "husorgan" neutrum  ; -- husorgan..nn.1
  huspredikant_1_N = mkN "huspredikant" "huspredikanter" ; -- huspredikant..nn.1
  husrad_1_N = mkN "husrad" "husrader" ; -- husrad..nn.1
  husrannsakning_1_N = mkN "husrannsakning" ; -- husrannsakning..nn.1
  husras_1_N = mkN "husras" neutrum  ; -- husras..nn.1
  husse_1_N = mkN "husse" utrum  ; -- husse..nn.1
  hussvala_1_N = mkN "hussvala" ; -- hussvala..nn.1
  hustak_1_N = mkN "hustak" neutrum  ; -- hustak..nn.1
  hustimmer_1_N = mkN "hustimmer" neutrum  ; -- hustimmer..nn.1
  hustomt_1_N = mkN "hustomt" "hustomter" ; -- hustomt..nn.1
  hustomte_1_N = mkN "hustomte" utrum  ; -- hustomte..nn.1
  hustru_1_N = mkN "hustru" "hustrun" "hustrur" "hustrurna" ; -- hustru..nn.1
  hustruersättare_1_N = mkN "hustruersättare" utrum  ; -- hustruersättare..nn.1
  hustrumisshandel_1_N = mkN "hustrumisshandel" ; -- hustrumisshandel..nn.1
  hustrumisshandlare_1_N = mkN "hustrumisshandlare" utrum  ; -- hustrumisshandlare..nn.1
  hustrutillägg_1_N = mkN "hustrutillägg" neutrum  ; -- hustrutillägg..nn.1
  hustyrann_1_N = mkN "hustyrann" "hustyranner" ; -- hustyrann..nn.1
  husundersökning_1_N = mkN "husundersökning" ; -- husundersökning..nn.1
  husvagn_1_N = mkN "husvagn" ; -- husvagn..nn.1
  husvill_1_A = mkA "husvill" ; -- husvill..av.1
  husvillhet_1_N = mkN "husvillhet" ; -- husvillhet..nn.1
  husvägg_1_N = mkN "husvägg" ; -- husvägg..nn.1
  husvärd_1_N = mkN "husvärd" ; -- husvärd..nn.1
  husägare_1_N = mkN "husägare" utrum  ; -- husägare..nn.1
  hut_1_N = mkN "hut" ; -- hut..nn.1
  huta_1_V = mkV "hutar" ; -- huta..vb.1
  hutande_1_N = mkN "hutande" ; -- hutande..nn.1
  hutch_1_N = mkN "hutch" ; -- hutch..nn.1
  hutlös_1_A = mkA "hutlös" ; -- hutlös..av.1
  hutlöshet_1_N = mkN "hutlöshet" "hutlösheter" ; -- hutlöshet..nn.1
  hutt_1_N = mkN "hutt" ; -- hutt..nn.1
  huttel_1_N = mkN "huttel" neutrum  ; -- huttel..nn.1
  huttla_1_V = mkV "huttlar" ; -- huttla..vb.1
  huttlande_1_N = mkN "huttlande" ; -- huttlande..nn.1
  huttleri_1_N = mkN "huttleri" neutrum  ; -- huttleri..nn.1
  huttra_1_V = mkV "huttrar" ; -- huttra..vb.1
  huttrande_1_N = mkN "huttrande" ; -- huttrande..nn.1
  huv_1_N = mkN "huv" ; -- huv..nn.1
  huva_1_N = mkN "huva" ; -- huva..nn.1
  huve_1_N = mkN "huve" ; -- huve..nn.1
  huvud_1_N = mkN "huvud" "huvudet" "huvud" "huvudena" ; -- huvud..nn.1
  huvudanförande_1_N = mkN "huvudanförande" ; -- huvudanförande..nn.1
  huvudanstalt_1_N = mkN "huvudanstalt" "huvudanstalter" ; -- huvudanstalt..nn.1
  huvudansvar_1_N = mkN "huvudansvar" neutrum  ; -- huvudansvar..nn.1
  huvudansvarig_1_A = mkA "huvudansvarig" ; -- huvudansvarig..av.1
  huvudavtal_1_N = mkN "huvudavtal" neutrum  ; -- huvudavtal..nn.1
  huvudaxel_1_N = mkN "huvudaxel" ; -- huvudaxel..nn.1
  huvudbindel_1_N = mkN "huvudbindel" ; -- huvudbindel..nn.1
  huvudbjudning_1_N = mkN "huvudbjudning" ; -- huvudbjudning..nn.1
  huvudbok_1_N = mkN "huvudbok" "huvudböcker" ; -- huvudbok..nn.1
  huvudbonad_1_N = mkN "huvudbonad" "huvudbonader" ; -- huvudbonad..nn.1
  huvudbry_1_N = mkN "huvudbry" neutrum  ; -- huvudbry..nn.1
  huvudbudskap_1_N = mkN "huvudbudskap" neutrum  ; -- huvudbudskap..nn.1
  huvudbyggnad_1_N = mkN "huvudbyggnad" "huvudbyggnader" ; -- huvudbyggnad..nn.1
  huvuddel_1_N = mkN "huvuddel" "huvuddelen" "huvuddelar" "huvuddelarna" ; -- huvuddel..nn.1
  huvuddrag_1_N = mkN "huvuddrag" neutrum  ; -- huvuddrag..nn.1
  huvudduk_1_N = mkN "huvudduk" ; -- huvudduk..nn.1
  huvudentré_1_N = mkN "huvudentré" "huvudentréer" ; -- huvudentré..nn.1
  huvudfasad_1_N = mkN "huvudfasad" "huvudfasader" ; -- huvudfasad..nn.1
  huvudfigur_1_N = mkN "huvudfigur" "huvudfigurer" ; -- huvudfigur..nn.1
  huvudfokus_1_N = mkN "huvudfokus" ; -- huvudfokus..nn.1
  huvudform_1_N = mkN "huvudform" "huvudformer" ; -- huvudform..nn.1
  huvudfråga_1_N = mkN "huvudfråga" ; -- huvudfråga..nn.1
  huvudfunktion_1_N = mkN "huvudfunktion" ; -- huvudfunktion..nn.1
  huvudfåra_1_N = mkN "huvudfåra" ; -- huvudfåra..nn.1
  huvudföda_1_N = mkN "huvudföda" ; -- huvudföda..nn.1
  huvudförhandling_1_N = mkN "huvudförhandling" ; -- huvudförhandling..nn.1
  huvudgata_1_N = mkN "huvudgata" ; -- huvudgata..nn.1
  huvudgärd_1_N = mkN "huvudgärd" "huvudgärder" ; -- huvudgärd..nn.1
  huvudgård_1_N = mkN "huvudgård" ; -- huvudgård..nn.1
  huvudhår_1_N = mkN "huvudhår" neutrum  ; -- huvudhår..nn.1
  huvudideologi_1_N = mkN "huvudideologi" "huvudideologier" ; -- huvudideologi..nn.1
  huvudingång_1_N = mkN "huvudingång" ; -- huvudingång..nn.1
  huvudinkomst_1_N = mkN "huvudinkomst" "huvudinkomster" ; -- huvudinkomst..nn.1
  huvudinnehåll_1_N = mkN "huvudinnehåll" neutrum  ; -- huvudinnehåll..nn.1
  huvudinspiratör_1_N = mkN "huvudinspiratör" "huvudinspiratörer" ; -- huvudinspiratör..nn.1
  huvudintresse_1_N = mkN "huvudintresse" ; -- huvudintresse..nn.1
  huvudjakt_1_N = mkN "huvudjakt" ; -- huvudjakt..nn.1
  huvudjägare_1_N = mkN "huvudjägare" utrum  ; -- huvudjägare..nn.1
  huvudknopp_1_N = mkN "huvudknopp" ; -- huvudknopp..nn.1
  huvudkontor_1_N = mkN "huvudkontor" neutrum  ; -- huvudkontor..nn.1
  huvudkontrast_1_N = mkN "huvudkontrast" "huvudkontraster" ; -- huvudkontrast..nn.1
  huvudkudde_1_N = mkN "huvudkudde" utrum  ; -- huvudkudde..nn.1
  huvudkvarter_1_N = mkN "huvudkvarter" "huvudkvarteret" "huvudkvarter" "huvudkvarteren" ; -- huvudkvarter..nn.1
  huvudlag_1_N = mkN "huvudlag" neutrum  ; -- huvudlag..nn.1
  huvudled_1_N = mkN "huvudled" "huvudleder" ; -- huvudled..nn.1
  huvudledning_1_N = mkN "huvudledning" ; -- huvudledning..nn.1
  huvudlinje_1_N = mkN "huvudlinje" "huvudlinjer" ; -- huvudlinje..nn.1
  huvudlus_1_N = mkN "huvudlus" "huvudlusen" "huvudlöss" "huvudlössen" ; -- huvudlus..nn.1
  huvudlärare_1_N = mkN "huvudlärare" utrum  ; -- huvudlärare..nn.1
  huvudlös_1_A = mkA "huvudlös" ; -- huvudlös..av.1
  huvudlöshet_1_N = mkN "huvudlöshet" "huvudlösheter" ; -- huvudlöshet..nn.1
  huvudman_1_N = mkN "huvudman" "huvudmannen" "huvudmän" "huvudmännen" ; -- huvudman..nn.1
  huvudmannaskap_1_N = mkN "huvudmannaskap" neutrum  ; -- huvudmannaskap..nn.1
  huvudmassa_1_N = mkN "huvudmassa" ; -- huvudmassa..nn.1
  huvudmisstänkt_1_A = mkA "huvudmisstänkt" "huvudmisstänkt" ; -- huvudmisstänkt..av.1
  huvudmoment_1_N = mkN "huvudmoment" neutrum  ; -- huvudmoment..nn.1
  huvudmotiv_1_N = mkN "huvudmotiv" neutrum  ; -- huvudmotiv..nn.1
  huvudmotor_1_N = mkN "huvudmotor" "huvudmotorer" ; -- huvudmotor..nn.1
  huvudmotståndare_1_N = mkN "huvudmotståndare" utrum  ; -- huvudmotståndare..nn.1
  huvudnyckel_1_N = mkN "huvudnyckel" ; -- huvudnyckel..nn.1
  huvudnäring_1_N = mkN "huvudnäring" ; -- huvudnäring..nn.1
  huvudord_1_N = mkN "huvudord" neutrum  ; -- huvudord..nn.1
  huvudorsak_1_N = mkN "huvudorsak" "huvudorsaker" ; -- huvudorsak..nn.1
  huvudort_1_N = mkN "huvudort" "huvudorter" ; -- huvudort..nn.1
  huvudpart_1_N = mkN "huvudpart" ; -- huvudpart..nn.1
  huvudperson_1_N = mkN "huvudperson" "huvudpersoner" ; -- huvudperson..nn.1
  huvudpunkt_1_N = mkN "huvudpunkt" "huvudpunkter" ; -- huvudpunkt..nn.1
  huvudregel_1_N = mkN "huvudregel" "huvudregeln" "huvudregler" "huvudreglerna" ; -- huvudregel..nn.1
  huvudroll_1_N = mkN "huvudroll" "huvudroller" ; -- huvudroll..nn.1
  huvudrollsinnehavare_1_N = mkN "huvudrollsinnehavare" utrum  ; -- huvudrollsinnehavare..nn.1
  huvudrollsinnehaverska_1_N = mkN "huvudrollsinnehaverska" ; -- huvudrollsinnehaverska..nn.1
  huvudräkning_1_N = mkN "huvudräkning" ; -- huvudräkning..nn.1
  huvudrätt_1_N = mkN "huvudrätt" "huvudrätter" ; -- huvudrätt..nn.1
  huvudrörelse_1_N = mkN "huvudrörelse" "huvudrörelser" ; -- huvudrörelse..nn.1
  huvudsak_1_N = mkN "huvudsak" "huvudsaker" ; -- huvudsak..nn.1
  huvudsaklig_1_A = mkA "huvudsaklig" ; -- huvudsaklig..av.1
  huvudsakligen_1_Adv = mkAdv "huvudsakligen" ; -- huvudsakligen..ab.1
  huvudsats_1_N = mkN "huvudsats" "huvudsatser" ; -- huvudsats..nn.1
  huvudskakning_1_N = mkN "huvudskakning" ; -- huvudskakning..nn.1
  huvudskydd_1_N = mkN "huvudskydd" neutrum  ; -- huvudskydd..nn.1
  huvudskyddsombud_1_N = mkN "huvudskyddsombud" neutrum  ; -- huvudskyddsombud..nn.1
  huvudskäl_1_N = mkN "huvudskäl" neutrum  ; -- huvudskäl..nn.1
  huvudskål_1_N = mkN "huvudskål" ; -- huvudskål..nn.1
  huvudstad_1_N = mkN "huvudstad" "huvudstäder" ; -- huvudstad..nn.1
  huvudstol_1_N = mkN "huvudstol" ; -- huvudstol..nn.1
  huvudstråk_1_N = mkN "huvudstråk" neutrum  ; -- huvudstråk..nn.1
  huvudströmbrytare_1_N = mkN "huvudströmbrytare" utrum  ; -- huvudströmbrytare..nn.1
  huvudstycke_1_N = mkN "huvudstycke" ; -- huvudstycke..nn.1
  huvudstyrka_1_N = mkN "huvudstyrka" ; -- huvudstyrka..nn.1
  huvudsvål_1_N = mkN "huvudsvål" ; -- huvudsvål..nn.1
  huvudsynpunkt_1_N = mkN "huvudsynpunkt" "huvudsynpunkter" ; -- huvudsynpunkt..nn.1
  huvudsäte_1_N = mkN "huvudsäte" ; -- huvudsäte..nn.1
  huvudtanke_1_N = mkN "huvudtanke" utrum  ; -- huvudtanke..nn.1
  huvudtema_1_N = mkN "huvudtema" "huvudtemat" "huvudtemata" "huvudtematana" ; -- huvudtema..nn.1
  huvudtitel_1_N = mkN "huvudtitel" ; -- huvudtitel..nn.1
  huvudton_1_N = mkN "huvudton" "huvudtoner" ; -- huvudton..nn.1
  huvudtrakt_1_N = mkN "huvudtrakt" "huvudtrakter" ; -- huvudtrakt..nn.1
  huvudtryck_1_N = mkN "huvudtryck" neutrum  ; -- huvudtryck..nn.1
  huvuduppgift_1_N = mkN "huvuduppgift" "huvuduppgifter" ; -- huvuduppgift..nn.1
  huvudutmanare_1_N = mkN "huvudutmanare" utrum  ; -- huvudutmanare..nn.1
  huvudvattenledning_1_N = mkN "huvudvattenledning" ; -- huvudvattenledning..nn.1
  huvudverb_1_N = mkN "huvudverb" neutrum  ; -- huvudverb..nn.1
  huvudvikt_1_N = mkN "huvudvikt" ; -- huvudvikt..nn.1
  huvudvillkor_1_N = mkN "huvudvillkor" neutrum  ; -- huvudvillkor..nn.1
  huvudvittne_1_N = mkN "huvudvittne" ; -- huvudvittne..nn.1
  huvudvridning_1_N = mkN "huvudvridning" ; -- huvudvridning..nn.1
  huvudväg_1_N = mkN "huvudväg" ; -- huvudväg..nn.1
  huvudvärk_1_N = mkN "huvudvärk" ; -- huvudvärk..nn.1
  huvudvärkstablett_1_N = mkN "huvudvärkstablett" "huvudvärkstabletter" ; -- huvudvärkstablett..nn.1
  huvudägare_1_N = mkN "huvudägare" utrum  ; -- huvudägare..nn.1
  huvudämne_1_N = mkN "huvudämne" ; -- huvudämne..nn.1
  hyacint_1_N = mkN "hyacint" "hyacinter" ; -- hyacint..nn.1
  hyaluronsyra_1_N = mkN "hyaluronsyra" ; -- hyaluronsyra..nn.1
  hybble_1_N = mkN "hybble" ; -- hybble..nn.1
  hybrid_1_A = mkA "hybrid" ; -- hybrid..av.1
  hybrid_1_N = mkN "hybrid" "hybrider" ; -- hybrid..nn.1
  hybridbil_1_N = mkN "hybridbil" ; -- hybridbil..nn.1
  hybridisera_1_V = mkV "hybridiserar" ; -- hybridisera..vb.1
  hybridiserande_1_N = mkN "hybridiserande" ; -- hybridiserande..nn.1
  hybridiserbar_1_A = mkA "hybridiserbar" ; -- hybridiserbar..av.1
  hybridiserbarhet_1_N = mkN "hybridiserbarhet" ; -- hybridiserbarhet..nn.1
  hybridisering_1_N = mkN "hybridisering" ; -- hybridisering..nn.1
  hybriditet_1_N = mkN "hybriditet" ; -- hybriditet..nn.1
  hybris_1_N = mkN "hybris" ; -- hybris..nn.1
  hyckel_1_N = mkN "hyckel" neutrum  ; -- hyckel..nn.1
  hyckla_1_V = mkV "hycklar" ; -- hyckla..vb.1
  hycklande_1_A = mkA "hycklande" ; -- hycklande..av.1
  hycklande_1_N = mkN "hycklande" ; -- hycklande..nn.1
  hycklare_1_N = mkN "hycklare" utrum  ; -- hycklare..nn.1
  hyckleri_1_N = mkN "hyckleri" "hyckleriet" "hycklerier" "hycklerierna" ; -- hyckleri..nn.1
  hydda_1_N = mkN "hydda" ; -- hydda..nn.1
  hydra_1_N = mkN "hydra" ; -- hydra..nn.1
  hydrat_1_N = mkN "hydrat" neutrum  ; -- hydrat..nn.1
  hydratiserad_1_A = mkA "hydratiserad" ; -- hydratiserad..av.1
  hydratisering_1_N = mkN "hydratisering" ; -- hydratisering..nn.1
  hydraulik_1_N = mkN "hydraulik" ; -- hydraulik..nn.1
  hydraulisk_1_A = mkA "hydraulisk" ; -- hydraulisk..av.1
  hydraullyft_1_N = mkN "hydraullyft" ; -- hydraullyft..nn.1
  hydraulolja_1_N = mkN "hydraulolja" ; -- hydraulolja..nn.1
  hydrera_1_V = mkV "hydrerar" ; -- hydrera..vb.1
  hydrerande_1_N = mkN "hydrerande" ; -- hydrerande..nn.1
  hydrerbar_1_A = mkA "hydrerbar" ; -- hydrerbar..av.1
  hydrerbarhet_1_N = mkN "hydrerbarhet" ; -- hydrerbarhet..nn.1
  hydrering_1_N = mkN "hydrering" ; -- hydrering..nn.1
  hydrodynamik_1_N = mkN "hydrodynamik" ; -- hydrodynamik..nn.1
  hydrodynamisk_1_A = mkA "hydrodynamisk" ; -- hydrodynamisk..av.1
  hydrofob_1_A = mkA "hydrofob" ; -- hydrofob..av.1
  hydrofon_1_N = mkN "hydrofon" "hydrofoner" ; -- hydrofon..nn.1
  hydrofor_1_N = mkN "hydrofor" "hydroforen" "hydroforer" "hydroforerna" ; -- hydrofor..nn.1
  hydroforpump_1_N = mkN "hydroforpump" ; -- hydroforpump..nn.1
  hydrofyt_1_N = mkN "hydrofyt" "hydrofyter" ; -- hydrofyt..nn.1
  hydrograf_1_N = mkN "hydrograf" "hydrografer" ; -- hydrograf..nn.1
  hydrografi_1_N = mkN "hydrografi" ; -- hydrografi..nn.1
  hydrografisk_1_A = mkA "hydrografisk" ; -- hydrografisk..av.1
  hydrokinon_1_N = mkN "hydrokinon" ; -- hydrokinon..nn.1
  hydrokopter_1_N = mkN "hydrokopter" ; -- hydrokopter..nn.1
  hydrokultur_1_N = mkN "hydrokultur" "hydrokulturer" ; -- hydrokultur..nn.1
  hydrolog_1_N = mkN "hydrolog" "hydrologer" ; -- hydrolog..nn.1
  hydrologi_1_N = mkN "hydrologi" ; -- hydrologi..nn.1
  hydrologisk_1_A = mkA "hydrologisk" ; -- hydrologisk..av.1
  hydrolys_1_N = mkN "hydrolys" "hydrolyser" ; -- hydrolys..nn.1
  hydroplan_1_N = mkN "hydroplan" neutrum  ; -- hydroplan..nn.1
  hydroponisk_1_A = mkA "hydroponisk" ; -- hydroponisk..av.1
  hydrosfär_1_N = mkN "hydrosfär" ; -- hydrosfär..nn.1
  hydrostatik_1_N = mkN "hydrostatik" ; -- hydrostatik..nn.1
  hydrostatisk_1_A = mkA "hydrostatisk" ; -- hydrostatisk..av.1
  hydroteknik_1_N = mkN "hydroteknik" ; -- hydroteknik..nn.1
  hydroteknisk_1_A = mkA "hydroteknisk" ; -- hydroteknisk..av.1
  hydroxid_1_N = mkN "hydroxid" "hydroxider" ; -- hydroxid..nn.1
  hydroxidjon_1_N = mkN "hydroxidjon" "hydroxidjoner" ; -- hydroxidjon..nn.1
  hyena_1_N = mkN "hyena" ; -- hyena..nn.1
  hyende_1_N = mkN "hyende" ; -- hyende..nn.1
  hyf_1_N = mkN "hyf" "hyfer" ; -- hyf..nn.1
  hyfs_1_N = mkN "hyfs" ; -- hyfs..nn.1
  hyfsa_1_V = mkV "hyfsar" ; -- hyfsa..vb.1
  hyfsad_1_A = mkA "hyfsad" ; -- hyfsad..av.1
  hyfsande_1_N = mkN "hyfsande" ; -- hyfsande..nn.1
  hyfsning_1_N = mkN "hyfsning" ; -- hyfsning..nn.1
  hygge_1_N = mkN "hygge" ; -- hygge..nn.1
  hyggesbränning_1_N = mkN "hyggesbränning" ; -- hyggesbränning..nn.1
  hygglig_1_A = mkA "hygglig" ; -- hygglig..av.1
  hygglighet_1_N = mkN "hygglighet" "hyggligheter" ; -- hygglighet..nn.1
  hygglo_1_N = mkN "hygglo" "hygglot" "hygglon" "hygglona" ; -- hygglo..nn.1
  hygienfråga_1_N = mkN "hygienfråga" ; -- hygienfråga..nn.1
  hygienisk_1_A = mkA "hygienisk" ; -- hygienisk..av.1
  hygienist_1_N = mkN "hygienist" "hygienister" ; -- hygienist..nn.1
  hygienkampanj_1_N = mkN "hygienkampanj" "hygienkampanjer" ; -- hygienkampanj..nn.1
  hygrograf_1_N = mkN "hygrograf" "hygrografer" ; -- hygrograf..nn.1
  hygrometer_1_N = mkN "hygrometer" ; -- hygrometer..nn.1
  hygrometri_1_N = mkN "hygrometri" ; -- hygrometri..nn.1
  hygroskop_1_N = mkN "hygroskop" neutrum  ; -- hygroskop..nn.1
  hygroskopisk_1_A = mkA "hygroskopisk" ; -- hygroskopisk..av.1
  hyla_1_V = mkV "hylar" ; -- hyla..vb.1
  hylande_1_N = mkN "hylande" ; -- hylande..nn.1
  hylla_1_N = mkN "hylla" ; -- hylla..nn.1
  hylla_1_V = mkV "hyllar" ; -- hylla..vb.1
  hyllande_1_N = mkN "hyllande" ; -- hyllande..nn.1
  hylle_1_N = mkN "hylle" ; -- hylle..nn.1
  hyllformad_1_A = mkA "hyllformad" ; -- hyllformad..av.1
  hyllmeter_1_N = mkN "hyllmeter" ; -- hyllmeter..nn.1
  hyllning_1_N = mkN "hyllning" ; -- hyllning..nn.1
  hyllningsceremoni_1_N = mkN "hyllningsceremoni" "hyllningsceremonier" ; -- hyllningsceremoni..nn.1
  hyllningsdikt_1_N = mkN "hyllningsdikt" "hyllningsdikter" ; -- hyllningsdikt..nn.1
  hyllningssång_1_N = mkN "hyllningssång" "hyllningssånger" ; -- hyllningssång..nn.1
  hylsa_1_N = mkN "hylsa" ; -- hylsa..nn.1
  hylsformad_1_A = mkA "hylsformad" ; -- hylsformad..av.1
  hylsnyckel_1_N = mkN "hylsnyckel" ; -- hylsnyckel..nn.1
  hylsnyckelsats_1_N = mkN "hylsnyckelsats" "hylsnyckelsatser" ; -- hylsnyckelsats..nn.1
  hylssats_1_N = mkN "hylssats" "hylssatser" ; -- hylssats..nn.1
  hymla_1_V = mkV "hymlar" ; -- hymla..vb.1
  hymlande_1_N = mkN "hymlande" ; -- hymlande..nn.1
  hymn_1_N = mkN "hymn" "hymner" ; -- hymn..nn.1
  hymnologi_1_N = mkN "hymnologi" ; -- hymnologi..nn.1
  hynda_1_N = mkN "hynda" ; -- hynda..nn.1
  hypa_1_V = mkV "hypar" ; -- hypa..vb.1
  hypande_1_N = mkN "hypande" ; -- hypande..nn.1
  hype_1_N = mkN "hype" ; -- hype..nn.1
  hyperaktiv_1_A = mkA "hyperaktiv" ; -- hyperaktiv..av.1
  hyperbel_1_N = mkN "hyperbel" "hyperbeln" "hyperbler" "hyperblerna" ; -- hyperbel..nn.1
  hyperbol_1_N = mkN "hyperbol" "hyperboler" ; -- hyperbol..nn.1
  hyperbolisk_1_A = mkA "hyperbolisk" ; -- hyperbolisk..av.1
  hyperboré_1_N = mkN "hyperboré" "hyperboréer" ; -- hyperboré..nn.1
  hyperelegant_1_A = mkA "hyperelegant" "hyperelegant" ; -- hyperelegant..av.1
  hyperinflation_1_N = mkN "hyperinflation" ; -- hyperinflation..nn.1
  hyperit_1_N = mkN "hyperit" "hyperiter" ; -- hyperit..nn.1
  hyperkatalektisk_1_A = mkA "hyperkatalektisk" ; -- hyperkatalektisk..av.1
  hyperkinesi_1_N = mkN "hyperkinesi" "hyperkinesier" ; -- hyperkinesi..nn.1
  hyperkorrekt_1_A = mkA "hyperkorrekt" "hyperkorrekt" ; -- hyperkorrekt..av.1
  hyperkorrekthet_1_N = mkN "hyperkorrekthet" ; -- hyperkorrekthet..nn.1
  hyperkub_1_N = mkN "hyperkub" "hyperkuber" ; -- hyperkub..nn.1
  hyperkänslig_1_A = mkA "hyperkänslig" ; -- hyperkänslig..av.1
  hyperkänslighet_1_N = mkN "hyperkänslighet" ; -- hyperkänslighet..nn.1
  hyperlänk_1_N = mkN "hyperlänk" ; -- hyperlänk..nn.1
  hypermodern_1_A = mkA "hypermodern" ; -- hypermodern..av.1
  hypermodernhet_1_N = mkN "hypermodernhet" ; -- hypermodernhet..nn.1
  hypernym_1_N = mkN "hypernym" "hypernymer" ; -- hypernym..nn.1
  hypernymi_1_N = mkN "hypernymi" "hypernymier" ; -- hypernymi..nn.1
  hyperonym_1_N = mkN "hyperonym" "hyperonymer" ; -- hyperonym..nn.1
  hyperonymi_1_N = mkN "hyperonymi" "hyperonymier" ; -- hyperonymi..nn.1
  hyperstjärna_1_N = mkN "hyperstjärna" ; -- hyperstjärna..nn.1
  hypersvecism_1_N = mkN "hypersvecism" "hypersvecismer" ; -- hypersvecism..nn.1
  hypertext_1_N = mkN "hypertext" "hypertexter" ; -- hypertext..nn.1
  hypertoni_1_N = mkN "hypertoni" ; -- hypertoni..nn.1
  hypertrofi_1_N = mkN "hypertrofi" "hypertrofier" ; -- hypertrofi..nn.1
  hyperventilera_1_V = mkV "hyperventilerar" ; -- hyperventilera..vb.1
  hyperventilerande_1_N = mkN "hyperventilerande" ; -- hyperventilerande..nn.1
  hyperventilering_1_N = mkN "hyperventilering" ; -- hyperventilering..nn.1
  hypning_1_N = mkN "hypning" ; -- hypning..nn.1
  hypnos_1_N = mkN "hypnos" "hypnoser" ; -- hypnos..nn.1
  hypnoskurs_1_N = mkN "hypnoskurs" "hypnoskurser" ; -- hypnoskurs..nn.1
  hypnotisera_1_V = mkV "hypnotiserar" ; -- hypnotisera..vb.1
  hypnotiserande_1_N = mkN "hypnotiserande" ; -- hypnotiserande..nn.1
  hypnotiserbar_1_A = mkA "hypnotiserbar" ; -- hypnotiserbar..av.1
  hypnotiserbarhet_1_N = mkN "hypnotiserbarhet" ; -- hypnotiserbarhet..nn.1
  hypnotisering_1_N = mkN "hypnotisering" ; -- hypnotisering..nn.1
  hypnotisk_1_A = mkA "hypnotisk" ; -- hypnotisk..av.1
  hypnotism_1_N = mkN "hypnotism" "hypnotismer" ; -- hypnotism..nn.1
  hypnotisör_1_N = mkN "hypnotisör" "hypnotisörer" ; -- hypnotisör..nn.1
  hypofys_1_N = mkN "hypofys" "hypofyser" ; -- hypofys..nn.1
  hypofyshormon_1_N = mkN "hypofyshormon" neutrum  ; -- hypofyshormon..nn.1
  hypokonder_1_N = mkN "hypokonder" "hypokondern" "hypokondrer" "hypokondrerna" ; -- hypokonder..nn.1
  hypokondri_1_N = mkN "hypokondri" "hypokondrier" ; -- hypokondri..nn.1
  hypokondriker_1_N = mkN "hypokondriker" "hypokondrikern" "hypokondriker" "hypokondrikerna" ; -- hypokondriker..nn.1
  hypokondrisk_1_A = mkA "hypokondrisk" ; -- hypokondrisk..av.1
  hypokrit_1_N = mkN "hypokrit" "hypokriter" ; -- hypokrit..nn.1
  hypokritisk_1_A = mkA "hypokritisk" ; -- hypokritisk..av.1
  hypomani_1_N = mkN "hypomani" "hypomanier" ; -- hypomani..nn.1
  hypomanisk_1_A = mkA "hypomanisk" ; -- hypomanisk..av.1
  hyponym_1_N = mkN "hyponym" "hyponymer" ; -- hyponym..nn.1
  hyponymi_1_N = mkN "hyponymi" "hyponymier" ; -- hyponymi..nn.1
  hypotaktisk_1_A = mkA "hypotaktisk" ; -- hypotaktisk..av.1
  hypotalamus_1_N = mkN "hypotalamus" ; -- hypotalamus..nn.1
  hypotax_1_N = mkN "hypotax" ; -- hypotax..nn.1
  hypotek_1_N = mkN "hypotek" neutrum  ; -- hypotek..nn.1
  hypoteksförening_1_N = mkN "hypoteksförening" ; -- hypoteksförening..nn.1
  hypotekslån_1_N = mkN "hypotekslån" neutrum  ; -- hypotekslån..nn.1
  hypoteksränta_1_N = mkN "hypoteksränta" ; -- hypoteksränta..nn.1
  hypotenusa_1_N = mkN "hypotenusa" ; -- hypotenusa..nn.1
  hypotes_1_N = mkN "hypotes" "hypoteser" ; -- hypotes..nn.1
  hypotetisk_1_A = mkA "hypotetisk" ; -- hypotetisk..av.1
  hypotisera_1_V = mkV "hypotiserar" ; -- hypotisera..vb.1
  hypotiserande_1_N = mkN "hypotiserande" ; -- hypotiserande..nn.1
  hypotiserbar_1_A = mkA "hypotiserbar" ; -- hypotiserbar..av.1
  hypotiserbarhet_1_N = mkN "hypotiserbarhet" ; -- hypotiserbarhet..nn.1
  hypotisering_1_N = mkN "hypotisering" ; -- hypotisering..nn.1
  hypsometer_1_N = mkN "hypsometer" ; -- hypsometer..nn.1
  hyra_1_N = mkN "hyra" ; -- hyra..nn.1
  hyra_1_V = mkV "hyra" "hyrde" "hyrt" ; -- hyra..vb.1
  hyrande_1_N = mkN "hyrande" ; -- hyrande..nn.1
  hyrbil_1_N = mkN "hyrbil" ; -- hyrbil..nn.1
  hyresavtal_1_N = mkN "hyresavtal" neutrum  ; -- hyresavtal..nn.1
  hyresbelopp_1_N = mkN "hyresbelopp" neutrum  ; -- hyresbelopp..nn.1
  hyresbetalning_1_N = mkN "hyresbetalning" ; -- hyresbetalning..nn.1
  hyresbostad_1_N = mkN "hyresbostad" "hyresbostäder" ; -- hyresbostad..nn.1
  hyresfri_1_A = mkA "hyresfri" "hyresfritt" ; -- hyresfri..av.1
  hyresgäst_1_N = mkN "hyresgäst" "hyresgäster" ; -- hyresgäst..nn.1
  hyresgästförening_1_N = mkN "hyresgästförening" ; -- hyresgästförening..nn.1
  hyreshaj_1_N = mkN "hyreshaj" ; -- hyreshaj..nn.1
  hyreshus_1_N = mkN "hyreshus" neutrum  ; -- hyreshus..nn.1
  hyreskasern_1_N = mkN "hyreskasern" "hyreskaserner" ; -- hyreskasern..nn.1
  hyreskontrakt_1_N = mkN "hyreskontrakt" neutrum  ; -- hyreskontrakt..nn.1
  hyreslag_1_N = mkN "hyreslag" ; -- hyreslag..nn.1
  hyreslägenhet_1_N = mkN "hyreslägenhet" "hyreslägenheter" ; -- hyreslägenhet..nn.1
  hyresmarknad_1_N = mkN "hyresmarknad" "hyresmarknader" ; -- hyresmarknad..nn.1
  hyresnämnd_1_N = mkN "hyresnämnd" "hyresnämnder" ; -- hyresnämnd..nn.1
  hyresreglera_1_V = mkV "hyresreglerar" ; -- hyresreglera..vb.1
  hyresreglerande_1_N = mkN "hyresreglerande" ; -- hyresreglerande..nn.1
  hyresreglering_1_N = mkN "hyresreglering" ; -- hyresreglering..nn.1
  hyresrätt_1_N = mkN "hyresrätt" "hyresrätter" ; -- hyresrätt..nn.1
  hyresstrejk_1_N = mkN "hyresstrejk" "hyresstrejker" ; -- hyresstrejk..nn.1
  hyressättning_1_N = mkN "hyressättning" ; -- hyressättning..nn.1
  hyrestillägg_1_N = mkN "hyrestillägg" neutrum  ; -- hyrestillägg..nn.1
  hyrestvist_1_N = mkN "hyrestvist" "hyrestvister" ; -- hyrestvist..nn.1
  hyrestvåa_1_N = mkN "hyrestvåa" ; -- hyrestvåa..nn.1
  hyresvillkor_1_N = mkN "hyresvillkor" neutrum  ; -- hyresvillkor..nn.1
  hyresvärd_1_N = mkN "hyresvärd" ; -- hyresvärd..nn.1
  hyrläkare_1_N = mkN "hyrläkare" utrum  ; -- hyrläkare..nn.1
  hysa_1_V = mkV "hyser" ; -- hysa..vb.1
  hysande_1_N = mkN "hysande" ; -- hysande..nn.1
  hysbar_1_A = mkA "hysbar" ; -- hysbar..av.1
  hysbarhet_1_N = mkN "hysbarhet" ; -- hysbarhet..nn.1
  hysch_hysch_1_N = mkN "hysch-hysch" neutrum  ; -- hysch-hysch..nn.1
  hyska_1_N = mkN "hyska" ; -- hyska..nn.1
  hyss_1_N = mkN "hyss" neutrum  ; -- hyss..nn.1
  hyssja_1_V = mkV "hyssjar" ; -- hyssja..vb.1
  hyssjande_1_N = mkN "hyssjande" ; -- hyssjande..nn.1
  hyssjning_1_N = mkN "hyssjning" ; -- hyssjning..nn.1
  hysta_1_V = mkV "hystar" ; -- hysta..vb.1
  hystande_1_N = mkN "hystande" ; -- hystande..nn.1
  hysteri_1_N = mkN "hysteri" ; -- hysteri..nn.1
  hysterika_1_N = mkN "hysterika" ; -- hysterika..nn.1
  hysteriker_1_N = mkN "hysteriker" "hysterikern" "hysteriker" "hysterikerna" ; -- hysteriker..nn.1
  hysterisk_1_A = mkA "hysterisk" ; -- hysterisk..av.1
  hytt_1_N = mkN "hytt" "hytter" ; -- hytt..nn.1
  hytta_1_N = mkN "hytta" ; -- hytta..nn.1
  hytta_1_V = mkV "hytta" "hytte" "hyttat" ; -- hytta..vb.1
  hyttande_1_N = mkN "hyttande" ; -- hyttande..nn.1
  hyttutrymme_1_N = mkN "hyttutrymme" ; -- hyttutrymme..nn.1
  hyva_1_V = mkV "hyvar" ; -- hyva..vb.1
  hyvande_1_N = mkN "hyvande" ; -- hyvande..nn.1
  hyvel_1_N = mkN "hyvel" ; -- hyvel..nn.1
  hyvelbredd_1_N = mkN "hyvelbredd" "hyvelbredder" ; -- hyvelbredd..nn.1
  hyvelbänk_1_N = mkN "hyvelbänk" ; -- hyvelbänk..nn.1
  hyveljärn_1_N = mkN "hyveljärn" neutrum  ; -- hyveljärn..nn.1
  hyvelspån_1_N = mkN "hyvelspån" neutrum  ; -- hyvelspån..nn.1
  hyvelstål_1_N = mkN "hyvelstål" neutrum  ; -- hyvelstål..nn.1
  hyveltandad_1_A = mkA "hyveltandad" ; -- hyveltandad..av.1
  hyvens_1_A = mkA "hyvens" ; -- hyvens..av.1
  hyvla_1_V = mkV "hyvlar" ; -- hyvla..vb.1
  hyvlande_1_N = mkN "hyvlande" ; -- hyvlande..nn.1
  hyvlare_1_N = mkN "hyvlare" utrum  ; -- hyvlare..nn.1
  hyvning_1_N = mkN "hyvning" ; -- hyvning..nn.1
  häck_1_N = mkN "häck" ; -- häck..nn.1
  häcka_1_V = mkV "häckar" ; -- häcka..vb.1
  häckande_1_N = mkN "häckande" ; -- häckande..nn.1
  häckfågel_1_N = mkN "häckfågel" ; -- häckfågel..nn.1
  häckla_1_N = mkN "häckla" ; -- häckla..nn.1
  häckla_1_V = mkV "häcklar" ; -- häckla..vb.1
  häcklande_1_N = mkN "häcklande" ; -- häcklande..nn.1
  häcklare_1_N = mkN "häcklare" utrum  ; -- häcklare..nn.1
  häckling_1_N = mkN "häckling" ; -- häckling..nn.1
  häcklopp_1_N = mkN "häcklopp" neutrum  ; -- häcklopp..nn.1
  häcklöpare_1_N = mkN "häcklöpare" utrum  ; -- häcklöpare..nn.1
  häcklöperska_1_N = mkN "häcklöperska" ; -- häcklöperska..nn.1
  häcklöpning_1_N = mkN "häcklöpning" ; -- häcklöpning..nn.1
  häckning_1_N = mkN "häckning" ; -- häckning..nn.1
  häckningsplats_1_N = mkN "häckningsplats" "häckningsplatser" ; -- häckningsplats..nn.1
  häckningsritual_1_N = mkN "häckningsritual" "häckningsritualer" ; -- häckningsritual..nn.1
  häckplats_1_N = mkN "häckplats" "häckplatser" ; -- häckplats..nn.1
  häcksax_1_N = mkN "häcksax" ; -- häcksax..nn.1
  häda_1_V = mkV "hädar" ; -- häda..vb.1
  hädande_1_N = mkN "hädande" ; -- hädande..nn.1
  hädanefter_1_Adv = mkAdv "hädanefter" ; -- hädanefter..ab.1
  hädanfärd_1_N = mkN "hädanfärd" "hädanfärder" ; -- hädanfärd..nn.1
  hädangången_1_A = mkA "hädangången" ; -- hädangången..av.1
  hädankalla_1_V = mkV "hädankallar" ; -- hädankalla..vb.1
  hädankallande_1_N = mkN "hädankallande" ; -- hädankallande..nn.1
  hädare_1_N = mkN "hädare" utrum  ; -- hädare..nn.1
  hädelse_1_N = mkN "hädelse" "hädelser" ; -- hädelse..nn.1
  hädelseåtal_1_N = mkN "hädelseåtal" neutrum  ; -- hädelseåtal..nn.1
  hädisk_1_A = mkA "hädisk" ; -- hädisk..av.1
  hädiskhet_1_N = mkN "hädiskhet" ; -- hädiskhet..nn.1
  häfta_1_N = mkN "häfta" ; -- häfta..nn.1
  häfta_1_V = mkV "häftar" ; -- häfta..vb.1
  häftad_1_A = mkA "häftad" ; -- häftad..av.1
  häftande_1_N = mkN "häftande" ; -- häftande..nn.1
  häftapparat_1_N = mkN "häftapparat" "häftapparater" ; -- häftapparat..nn.1
  häfte_1_N = mkN "häfte" ; -- häfte..nn.1
  häftig_1_A = mkA "häftig" ; -- häftig..av.1
  häftighet_1_N = mkN "häftighet" ; -- häftighet..nn.1
  häftklammer_1_N = mkN "häftklammer" "häftklammern" "häftklamrar" "häftklamrarna" ; -- häftklammer..nn.1
  häftning_1_N = mkN "häftning" ; -- häftning..nn.1
  häftpistol_1_N = mkN "häftpistol" "häftpistoler" ; -- häftpistol..nn.1
  häftplåster_1_N = mkN "häftplåster" neutrum  ; -- häftplåster..nn.1
  häftstift_1_N = mkN "häftstift" neutrum  ; -- häftstift..nn.1
  häger_1_N = mkN "häger" ; -- häger..nn.1
  hägg_1_N = mkN "hägg" ; -- hägg..nn.1
  häggblomning_1_N = mkN "häggblomning" ; -- häggblomning..nn.1
  hägn_1_N = mkN "hägn" neutrum  ; -- hägn..nn.1
  hägna_1_V = mkV "hägnar" ; -- hägna..vb.1
  hägnad_1_N = mkN "hägnad" "hägnader" ; -- hägnad..nn.1
  hägnande_1_N = mkN "hägnande" ; -- hägnande..nn.1
  hägra_1_V = mkV "hägrar" ; -- hägra..vb.1
  hägrande_1_N = mkN "hägrande" ; -- hägrande..nn.1
  hägring_1_N = mkN "hägring" ; -- hägring..nn.1
  häkta_1_N = mkN "häkta" ; -- häkta..nn.1
  häkta_1_V = mkV "häktar" ; -- häkta..vb.1
  häktande_1_N = mkN "häktande" ; -- häktande..nn.1
  häkte_1_N = mkN "häkte" ; -- häkte..nn.1
  häktesdöd_1_A = mkA "häktesdöd" "häktesdött" ; -- häktesdöd..av.1
  häktesvakt_1_N = mkN "häktesvakt" "häktesvakter" ; -- häktesvakt..nn.1
  häktning_1_N = mkN "häktning" ; -- häktning..nn.1
  häktningsbeslut_1_N = mkN "häktningsbeslut" neutrum  ; -- häktningsbeslut..nn.1
  häktningsframställan_1_N = mkN "häktningsframställan" "häktningsframställan" "häktningsframställningar" "häktningsframställningarna" ; -- häktningsframställan..nn.1
  häktningsförhandling_1_N = mkN "häktningsförhandling" ; -- häktningsförhandling..nn.1
  häktningstid_1_N = mkN "häktningstid" "häktningstider" ; -- häktningstid..nn.1
  häl_1_N = mkN "häl" ; -- häl..nn.1
  hälare_1_N = mkN "hälare" utrum  ; -- hälare..nn.1
  hälben_1_N = mkN "hälben" neutrum  ; -- hälben..nn.1
  häleri_1_N = mkN "häleri" "häleriet" "hälerier" "hälerierna" ; -- häleri..nn.1
  hälft_1_N = mkN "hälft" "hälfter" ; -- hälft..nn.1
  hälftenbruk_1_N = mkN "hälftenbruk" neutrum  ; -- hälftenbruk..nn.1
  hälgångare_1_N = mkN "hälgångare" utrum  ; -- hälgångare..nn.1
  häll_1_N = mkN "häll" ; -- häll..nn.1
  hälla_1_N = mkN "hälla" ; -- hälla..nn.1
  hälla_1_V = mkV "häller" ; -- hälla..vb.1
  hällande_1_N = mkN "hällande" ; -- hällande..nn.1
  hälleberg_1_N = mkN "hälleberg" neutrum  ; -- hälleberg..nn.1
  hälleflinta_1_N = mkN "hälleflinta" ; -- hälleflinta..nn.1
  hälleflundra_1_N = mkN "hälleflundra" ; -- hälleflundra..nn.1
  hällkista_1_N = mkN "hällkista" ; -- hällkista..nn.1
  hällkonst_1_N = mkN "hällkonst" "hällkonster" ; -- hällkonst..nn.1
  hällmark_1_N = mkN "hällmark" "hällmarker" ; -- hällmark..nn.1
  hällning_1_N = mkN "hällning" ; -- hällning..nn.1
  hällregn_1_N = mkN "hällregn" neutrum  ; -- hällregn..nn.1
  hällregna_1_V = mkV "hällregnar" ; -- hällregna..vb.1
  hällregnande_1_N = mkN "hällregnande" ; -- hällregnande..nn.1
  hällristning_1_N = mkN "hällristning" ; -- hällristning..nn.1
  hälsa_1_N = mkN "hälsa" ; -- hälsa..nn.1
  hälsa_1_V = mkV "hälsar" ; -- hälsa..vb.1
  hälsande_1_N = mkN "hälsande" ; -- hälsande..nn.1
  hälsena_1_N = mkN "hälsena" ; -- hälsena..nn.1
  hälsing_1_N = mkN "hälsing" ; -- hälsing..nn.1
  hälsingsk_1_A = mkA "hälsingsk" ; -- hälsingsk..av.1
  hälsingska_1_N = mkN "hälsingska" ; -- hälsingska..nn.1
  hälsingska_2_N = mkN "hälsingska" ; -- hälsingska..nn.2
  hälsning_1_N = mkN "hälsning" ; -- hälsning..nn.1
  hälsningsanförande_1_N = mkN "hälsningsanförande" ; -- hälsningsanförande..nn.1
  hälsningsceremoni_1_N = mkN "hälsningsceremoni" "hälsningsceremonier" ; -- hälsningsceremoni..nn.1
  hälsningsfras_1_N = mkN "hälsningsfras" "hälsningsfraser" ; -- hälsningsfras..nn.1
  hälsningsförfarande_1_N = mkN "hälsningsförfarande" ; -- hälsningsförfarande..nn.1
  hälsningsritual_1_N = mkN "hälsningsritual" neutrum  ; -- hälsningsritual..nn.1
  hälsningstal_1_N = mkN "hälsningstal" neutrum  ; -- hälsningstal..nn.1
  hälsobefrämjande_1_A = mkA "hälsobefrämjande" ; -- hälsobefrämjande..av.1
  hälsobringande_1_A = mkA "hälsobringande" ; -- hälsobringande..av.1
  hälsobrunn_1_N = mkN "hälsobrunn" ; -- hälsobrunn..nn.1
  hälsocenter_1_N = mkN "hälsocenter" "hälsocentret" "hälsocentrer" "hälsocentrerna" ; -- hälsocenter..nn.1
  hälsodryck_1_N = mkN "hälsodryck" "hälsodrycker" ; -- hälsodryck..nn.1
  hälsoeffekt_1_N = mkN "hälsoeffekt" "hälsoeffekter" ; -- hälsoeffekt..nn.1
  hälsofantast_1_N = mkN "hälsofantast" "hälsofantaster" ; -- hälsofantast..nn.1
  hälsofara_1_N = mkN "hälsofara" ; -- hälsofara..nn.1
  hälsofarlig_1_A = mkA "hälsofarlig" ; -- hälsofarlig..av.1
  hälsofarlighet_1_N = mkN "hälsofarlighet" "hälsofarligheter" ; -- hälsofarlighet..nn.1
  hälsofrämjande_1_A = mkA "hälsofrämjande" ; -- hälsofrämjande..av.1
  hälsofördel_1_N = mkN "hälsofördel" "hälsofördelen" "hälsofördelar" "hälsofördelarna" ; -- hälsofördel..nn.1
  hälsogym_1_N = mkN "hälsogym" "hälsogymmet" "hälsogym" "hälsogymmen" ; -- hälsogym..nn.1
  hälsokontroll_1_N = mkN "hälsokontroll" "hälsokontroller" ; -- hälsokontroll..nn.1
  hälsokort_1_N = mkN "hälsokort" neutrum  ; -- hälsokort..nn.1
  hälsokost_1_N = mkN "hälsokost" ; -- hälsokost..nn.1
  hälsokälla_1_N = mkN "hälsokälla" ; -- hälsokälla..nn.1
  hälsoläge_1_N = mkN "hälsoläge" ; -- hälsoläge..nn.1
  hälsolära_1_N = mkN "hälsolära" ; -- hälsolära..nn.1
  hälsomedveten_1_A = mkA "hälsomedveten" ; -- hälsomedveten..av.1
  hälsomedvetenhet_1_N = mkN "hälsomedvetenhet" ; -- hälsomedvetenhet..nn.1
  hälsomässig_1_A = mkA "hälsomässig" ; -- hälsomässig..av.1
  hälsopolitik_1_N = mkN "hälsopolitik" ; -- hälsopolitik..nn.1
  hälsopolitisk_1_A = mkA "hälsopolitisk" ; -- hälsopolitisk..av.1
  hälsoproblem_1_N = mkN "hälsoproblem" neutrum  ; -- hälsoproblem..nn.1
  hälsorisk_1_N = mkN "hälsorisk" "hälsorisker" ; -- hälsorisk..nn.1
  hälsorådgivning_1_N = mkN "hälsorådgivning" ; -- hälsorådgivning..nn.1
  hälsosam_1_A = mkA "hälsosam" "hälsosamt" "hälsosamma" "hälsosamma" "hälsosammare" "hälsosammast" "hälsosammaste" ; -- hälsosam..av.1
  hälsosamhet_1_N = mkN "hälsosamhet" ; -- hälsosamhet..nn.1
  hälsoskydd_1_N = mkN "hälsoskydd" neutrum  ; -- hälsoskydd..nn.1
  hälsoskäl_1_N = mkN "hälsoskäl" neutrum  ; -- hälsoskäl..nn.1
  hälsotecken_1_N = mkN "hälsotecken" "hälsotecknet" "hälsotecken" "hälsotecknen" ; -- hälsotecken..nn.1
  hälsotek_1_N = mkN "hälsotek" neutrum  ; -- hälsotek..nn.1
  hälsotillstånd_1_N = mkN "hälsotillstånd" neutrum  ; -- hälsotillstånd..nn.1
  hälsovatten_1_N = mkN "hälsovatten" "hälsovattnet" "hälsovatten" "hälsovattnen" ; -- hälsovatten..nn.1
  hälsovådlig_1_A = mkA "hälsovådlig" ; -- hälsovådlig..av.1
  hälsovådlighet_1_N = mkN "hälsovådlighet" "hälsovådligheter" ; -- hälsovådlighet..nn.1
  hälsovård_1_N = mkN "hälsovård" ; -- hälsovård..nn.1
  hälsovårdskostnad_1_N = mkN "hälsovårdskostnad" "hälsovårdskostnader" ; -- hälsovårdskostnad..nn.1
  hälsovårdsnämnd_1_N = mkN "hälsovårdsnämnd" "hälsovårdsnämnder" ; -- hälsovårdsnämnd..nn.1
  hälta_1_N = mkN "hälta" ; -- hälta..nn.1
  hämma_1_V = mkV "hämmar" ; -- hämma..vb.1
  hämmad_1_A = mkA "hämmad" ; -- hämmad..av.1
  hämmande_1_N = mkN "hämmande" ; -- hämmande..nn.1
  hämna_1_V = mkV "hämnar" ; -- hämna..vb.1
  hämnande_1_N = mkN "hämnande" ; -- hämnande..nn.1
  hämnare_1_N = mkN "hämnare" utrum  ; -- hämnare..nn.1
  hämnd_1_N = mkN "hämnd" ; -- hämnd..nn.1
  hämndaktion_1_N = mkN "hämndaktion" ; -- hämndaktion..nn.1
  hämndattack_1_N = mkN "hämndattack" "hämndattacker" ; -- hämndattack..nn.1
  hämndbegär_1_N = mkN "hämndbegär" neutrum  ; -- hämndbegär..nn.1
  hämndeaktion_1_N = mkN "hämndeaktion" ; -- hämndeaktion..nn.1
  hämndeande_1_N = mkN "hämndeande" utrum  ; -- hämndeande..nn.1
  hämndgirig_1_A = mkA "hämndgirig" ; -- hämndgirig..av.1
  hämndgirighet_1_N = mkN "hämndgirighet" ; -- hämndgirighet..nn.1
  hämndgudinna_1_N = mkN "hämndgudinna" ; -- hämndgudinna..nn.1
  hämndlysten_1_A = mkA "hämndlysten" ; -- hämndlysten..av.1
  hämndlystenhet_1_N = mkN "hämndlystenhet" ; -- hämndlystenhet..nn.1
  hämndlystnad_1_N = mkN "hämndlystnad" ; -- hämndlystnad..nn.1
  hämndrekyl_1_N = mkN "hämndrekyl" "hämndrekyler" ; -- hämndrekyl..nn.1
  hämndtörst_1_N = mkN "hämndtörst" ; -- hämndtörst..nn.1
  hämndtörstande_1_A = mkA "hämndtörstande" ; -- hämndtörstande..av.1
  hämndtörstig_1_A = mkA "hämndtörstig" ; -- hämndtörstig..av.1
  hämning_1_N = mkN "hämning" ; -- hämning..nn.1
  hämningslös_1_A = mkA "hämningslös" ; -- hämningslös..av.1
  hämningslöshet_1_N = mkN "hämningslöshet" "hämningslösheter" ; -- hämningslöshet..nn.1
  hämpling_1_N = mkN "hämpling" ; -- hämpling..nn.1
  hämsko_1_N = mkN "hämsko" "hämskor" ; -- hämsko..nn.1
  hämta_1_V = mkV "hämtar" ; -- hämta..vb.1
  hämtande_1_N = mkN "hämtande" ; -- hämtande..nn.1
  hämtare_1_N = mkN "hämtare" utrum  ; -- hämtare..nn.1
  hämtmat_1_N = mkN "hämtmat" ; -- hämtmat..nn.1
  hämtning_1_N = mkN "hämtning" ; -- hämtning..nn.1
  hämtpizza_1_N = mkN "hämtpizza" ; -- hämtpizza..nn.1
  hämtpris_1_N = mkN "hämtpris" neutrum  ; -- hämtpris..nn.1
  hända_1_V = mkV "händer" ; -- hända..vb.1
  händelse_1_N = mkN "händelse" "händelser" ; -- händelse..nn.1
  händelsediger_1_A = mkA "händelsediger" ; -- händelsediger..av.1
  händelsefattig_1_A = mkA "händelsefattig" ; -- händelsefattig..av.1
  händelsefattighet_1_N = mkN "händelsefattighet" ; -- händelsefattighet..nn.1
  händelseförlopp_1_N = mkN "händelseförlopp" neutrum  ; -- händelseförlopp..nn.1
  händelsehorisont_1_N = mkN "händelsehorisont" "händelsehorisonter" ; -- händelsehorisont..nn.1
  händelselös_1_A = mkA "händelselös" ; -- händelselös..av.1
  händelselöshet_1_N = mkN "händelselöshet" ; -- händelselöshet..nn.1
  händelserik_1_A = mkA "händelserik" ; -- händelserik..av.1
  händelserikhet_1_N = mkN "händelserikhet" ; -- händelserikhet..nn.1
  händelseutveckling_1_N = mkN "händelseutveckling" ; -- händelseutveckling..nn.1
  händelsevis_1_Adv = mkAdv "händelsevis" ; -- händelsevis..ab.1
  händig_1_A = mkA "händig" ; -- händig..av.1
  händighet_1_N = mkN "händighet" ; -- händighet..nn.1
  hänföra_1_V = mkV "hänföra" "hänförde" "hänfört" ; -- hänföra..vb.1
  hänförande_1_A = mkA "hänförande" ; -- hänförande..av.1
  hänförande_1_N = mkN "hänförande" ; -- hänförande..nn.1
  hänförd_1_A = mkA "hänförd" "hänfört" ; -- hänförd..av.1
  hänfördhet_1_N = mkN "hänfördhet" ; -- hänfördhet..nn.1
  hänförelse_1_N = mkN "hänförelse" utrum  ; -- hänförelse..nn.1
  hänförlig_1_A = mkA "hänförlig" ; -- hänförlig..av.1
  häng_1_N = mkN "häng" neutrum  ; -- häng..nn.1
  hänga_1_V = mkV "hänger" ; -- hänga..vb.1
  hänga_2_V = mkV "hänger" ; -- hänga..vb.2
  hängande_1_N = mkN "hängande" ; -- hängande..nn.1
  hängare_1_N = mkN "hängare" utrum  ; -- hängare..nn.1
  hängavtal_1_N = mkN "hängavtal" neutrum  ; -- hängavtal..nn.1
  hängbana_1_N = mkN "hängbana" ; -- hängbana..nn.1
  hängbjörk_1_N = mkN "hängbjörk" ; -- hängbjörk..nn.1
  hängbro_1_N = mkN "hängbro" ; -- hängbro..nn.1
  hängbrobygge_1_N = mkN "hängbrobygge" ; -- hängbrobygge..nn.1
  hängbröst_1_N = mkN "hängbröst" neutrum  ; -- hängbröst..nn.1
  hängbuk_1_N = mkN "hängbuk" ; -- hängbuk..nn.1
  hängdal_1_N = mkN "hängdal" ; -- hängdal..nn.1
  hänge_1_N = mkN "hänge" ; -- hänge..nn.1
  hängfärdig_1_A = mkA "hängfärdig" ; -- hängfärdig..av.1
  hängig_1_A = mkA "hängig" ; -- hängig..av.1
  hängighet_1_N = mkN "hängighet" ; -- hängighet..nn.1
  hängivelse_1_N = mkN "hängivelse" utrum  ; -- hängivelse..nn.1
  hängiven_1_A = mkA "hängiven" ; -- hängiven..av.1
  hängivenhet_1_N = mkN "hängivenhet" ; -- hängivenhet..nn.1
  hängkoj_1_N = mkN "hängkoj" "hängkojer" ; -- hängkoj..nn.1
  hänglås_1_N = mkN "hänglås" neutrum  ; -- hänglås..nn.1
  hängmage_1_N = mkN "hängmage" utrum  ; -- hängmage..nn.1
  hängmatta_1_N = mkN "hängmatta" ; -- hängmatta..nn.1
  hängning_1_N = mkN "hängning" ; -- hängning..nn.1
  hängningsstraff_1_N = mkN "hängningsstraff" neutrum  ; -- hängningsstraff..nn.1
  hängparti_1_N = mkN "hängparti" "hängpartiet" "hängpartier" "hängpartierna" ; -- hängparti..nn.1
  hängränna_1_N = mkN "hängränna" ; -- hängränna..nn.1
  hängselbyxa_1_N = mkN "hängselbyxa" ; -- hängselbyxa..nn.1
  hängselkjol_1_N = mkN "hängselkjol" ; -- hängselkjol..nn.1
  hängselstropp_1_N = mkN "hängselstropp" ; -- hängselstropp..nn.1
  hängsjuk_1_A = mkA "hängsjuk" ; -- hängsjuk..av.1
  hängsle_1_N = mkN "hängsle" ; -- hängsle..nn.1
  hängsmycke_1_N = mkN "hängsmycke" ; -- hängsmycke..nn.1
  hängväxt_1_N = mkN "hängväxt" "hängväxter" ; -- hängväxt..nn.1
  hänrycka_1_V = mkV "hänrycker" ; -- hänrycka..vb.1
  hänryckande_1_N = mkN "hänryckande" ; -- hänryckande..nn.1
  hänryckning_1_N = mkN "hänryckning" ; -- hänryckning..nn.1
  hänryckt_1_A = mkA "hänryckt" "hänryckt" ; -- hänryckt..av.1
  hänryckthet_1_N = mkN "hänryckthet" ; -- hänryckthet..nn.1
  hänseende_1_N = mkN "hänseende" ; -- hänseende..nn.1
  hänsjunken_1_A = mkA "hänsjunken" ; -- hänsjunken..av.1
  hänsjunkenhet_1_N = mkN "hänsjunkenhet" ; -- hänsjunkenhet..nn.1
  hänskjuta_1_V = mkV "hänskjuta" "hänsköt" "hänskjutit" ; -- hänskjuta..vb.1
  hänskjutande_1_N = mkN "hänskjutande" ; -- hänskjutande..nn.1
  hänskjutning_1_N = mkN "hänskjutning" ; -- hänskjutning..nn.1
  hänsoven_1_A = mkA "hänsoven" ; -- hänsoven..av.1
  hänsyfta_1_V = mkV "hänsyftar" ; -- hänsyfta..vb.1
  hänsyftande_1_N = mkN "hänsyftande" ; -- hänsyftande..nn.1
  hänsyftning_1_N = mkN "hänsyftning" ; -- hänsyftning..nn.1
  hänsyn_1_N = mkN "hänsyn" "hänsynen" "hänsyn" "hänsynen" ; -- hänsyn..nn.1
  hänsynsfull_1_A = mkA "hänsynsfull" ; -- hänsynsfull..av.1
  hänsynsfullhet_1_N = mkN "hänsynsfullhet" "hänsynsfullheter" ; -- hänsynsfullhet..nn.1
  hänsynslös_1_A = mkA "hänsynslös" ; -- hänsynslös..av.1
  hänsynslöshet_1_N = mkN "hänsynslöshet" "hänsynslösheter" ; -- hänsynslöshet..nn.1
  hänsynstagande_1_N = mkN "hänsynstagande" ; -- hänsynstagande..nn.1
  hänthet_1_N = mkN "hänthet" "häntheter" ; -- hänthet..nn.1
  häntyda_1_V = mkV "häntyda" "häntydde" "häntytt" ; -- häntyda..vb.1
  häntydande_1_N = mkN "häntydande" ; -- häntydande..nn.1
  häntydning_1_N = mkN "häntydning" ; -- häntydning..nn.1
  hänvisa_1_V = mkV "hänvisar" ; -- hänvisa..vb.1
  hänvisande_1_N = mkN "hänvisande" ; -- hänvisande..nn.1
  hänvisning_1_N = mkN "hänvisning" ; -- hänvisning..nn.1
  hänvändelse_1_N = mkN "hänvändelse" "hänvändelser" ; -- hänvändelse..nn.1
  hänvändning_1_N = mkN "hänvändning" ; -- hänvändning..nn.1
  häpen_1_A = mkA "häpen" ; -- häpen..av.1
  häpenhet_1_N = mkN "häpenhet" ; -- häpenhet..nn.1
  häpna_1_V = mkV "häpnar" ; -- häpna..vb.1
  häpnad_1_N = mkN "häpnad" "häpnader" ; -- häpnad..nn.1
  häpnadsväckande_1_A = mkA "häpnadsväckande" ; -- häpnadsväckande..av.1
  häpnande_1_N = mkN "häpnande" ; -- häpnande..nn.1
  här_1_N = mkN "här" ; -- här..nn.1
  härad_1_N = mkN "härad" "häradet" "häraden" "häraderna" ; -- härad..nn.1
  häradsdomare_1_N = mkN "häradsdomare" utrum  ; -- häradsdomare..nn.1
  häradshövding_1_N = mkN "häradshövding" ; -- häradshövding..nn.1
  häradsrätt_1_N = mkN "häradsrätt" "häradsrätter" ; -- häradsrätt..nn.1
  häradsskrivare_1_N = mkN "häradsskrivare" utrum  ; -- häradsskrivare..nn.1
  häradsting_1_N = mkN "häradsting" neutrum  ; -- häradsting..nn.1
  härav_1_Adv = mkAdv "härav" ; -- härav..ab.1
  härbre_1_N = mkN "härbre" ; -- härbre..nn.1
  härbärge_1_N = mkN "härbärge" ; -- härbärge..nn.1
  härbärgera_1_V = mkV "härbärgerar" ; -- härbärgera..vb.1
  härbärgerande_1_N = mkN "härbärgerande" ; -- härbärgerande..nn.1
  härbärgerbar_1_A = mkA "härbärgerbar" ; -- härbärgerbar..av.1
  härbärgerbarhet_1_N = mkN "härbärgerbarhet" ; -- härbärgerbarhet..nn.1
  härbärgering_1_N = mkN "härbärgering" ; -- härbärgering..nn.1
  härd_1_N = mkN "härd" ; -- härd..nn.1
  härda_1_V = mkV "härdar" ; -- härda..vb.1
  härdande_1_N = mkN "härdande" ; -- härdande..nn.1
  härdig_1_A = mkA "härdig" ; -- härdig..av.1
  härdighet_1_N = mkN "härdighet" "härdigheter" ; -- härdighet..nn.1
  härdighetskrav_1_N = mkN "härdighetskrav" neutrum  ; -- härdighetskrav..nn.1
  härdlack_1_N = mkN "härdlack" "härdlacker" ; -- härdlack..nn.1
  härdning_1_N = mkN "härdning" ; -- härdning..nn.1
  härdningstid_1_N = mkN "härdningstid" "härdningstider" ; -- härdningstid..nn.1
  härdplast_1_N = mkN "härdplast" "härdplaster" ; -- härdplast..nn.1
  härdsmälta_1_N = mkN "härdsmälta" ; -- härdsmälta..nn.1
  härdtid_1_N = mkN "härdtid" "härdtider" ; -- härdtid..nn.1
  härefter_1_Adv = mkAdv "härefter" ; -- härefter..ab.1
  härflyta_1_V = mkV "härflyta" "härflöt" "härflutit" ; -- härflyta..vb.1
  härflytande_1_N = mkN "härflytande" ; -- härflytande..nn.1
  härfågel_1_N = mkN "härfågel" ; -- härfågel..nn.1
  härför_1_Adv = mkAdv "härför" ; -- härför..ab.1
  härförare_1_N = mkN "härförare" utrum  ; -- härförare..nn.1
  häri_1_Adv = mkAdv "häri" ; -- häri..ab.1
  härifrån_1_Adv = mkAdv "härifrån" ; -- härifrån..ab.1
  härigenom_1_Adv = mkAdv "härigenom" ; -- härigenom..ab.1
  härinne_1_Adv = mkAdv "härinne" ; -- härinne..ab.1
  härintill_1_Adv = mkAdv "härintill" ; -- härintill..ab.1
  härja_1_V = mkV "härjar" ; -- härja..vb.1
  härjad_1_A = mkA "härjad" ; -- härjad..av.1
  härjande_1_N = mkN "härjande" ; -- härjande..nn.1
  härjare_1_N = mkN "härjare" utrum  ; -- härjare..nn.1
  härjedaling_1_N = mkN "härjedaling" ; -- härjedaling..nn.1
  härjedalsk_1_A = mkA "härjedalsk" ; -- härjedalsk..av.1
  härjedalska_1_N = mkN "härjedalska" ; -- härjedalska..nn.1
  härjedalska_2_N = mkN "härjedalska" ; -- härjedalska..nn.2
  härjning_1_N = mkN "härjning" ; -- härjning..nn.1
  härjningståg_1_N = mkN "härjningståg" neutrum  ; -- härjningståg..nn.1
  härk_1_N = mkN "härk" ; -- härk..nn.1
  härkomst_1_N = mkN "härkomst" ; -- härkomst..nn.1
  härkomstort_1_N = mkN "härkomstort" "härkomstorter" ; -- härkomstort..nn.1
  härleda_1_V = mkV "härleda" "härledde" "härlett" ; -- härleda..vb.1
  härledande_1_N = mkN "härledande" ; -- härledande..nn.1
  härledd_1_A = mkA "härledd" ; -- härledd..av.1
  härledning_1_N = mkN "härledning" ; -- härledning..nn.1
  härlig_1_A = mkA "härlig" ; -- härlig..av.1
  härlighet_1_N = mkN "härlighet" "härligheter" ; -- härlighet..nn.1
  härlighet_2_N = mkN "härlighet" ; -- härlighet..nn.2
  härma_1_V = mkV "härmar" ; -- härma..vb.1
  härmande_1_N = mkN "härmande" ; -- härmande..nn.1
  härmapa_1_N = mkN "härmapa" ; -- härmapa..nn.1
  härmare_1_N = mkN "härmare" utrum  ; -- härmare..nn.1
  härmask_1_N = mkN "härmask" ; -- härmask..nn.1
  härmed_1_Adv = mkAdv "härmed" ; -- härmed..ab.1
  härmfågel_1_N = mkN "härmfågel" ; -- härmfågel..nn.1
  härmning_1_N = mkN "härmning" ; -- härmning..nn.1
  härmönstring_1_N = mkN "härmönstring" ; -- härmönstring..nn.1
  härnad_1_N = mkN "härnad" "härnader" ; -- härnad..nn.1
  härnadsfärd_1_N = mkN "härnadsfärd" "härnadsfärder" ; -- härnadsfärd..nn.1
  härnadståg_1_N = mkN "härnadståg" neutrum  ; -- härnadståg..nn.1
  härnere_1_Adv = mkAdv "härnere" ; -- härnere..ab.1
  härold_1_N = mkN "härold" "härolder" ; -- härold..nn.1
  härom_1_Adv = mkAdv "härom" ; -- härom..ab.1
  häromdagen_1_Adv = mkAdv "häromdagen" ; -- häromdagen..ab.1
  häromdan_1_Adv = mkAdv "häromdan" ; -- häromdan..ab.1
  häromkring_1_Adv = mkAdv "häromkring" ; -- häromkring..ab.1
  häromkvällen_1_Adv = mkAdv "häromkvällen" ; -- häromkvällen..ab.1
  härommånaden_1_Adv = mkAdv "härommånaden" ; -- härommånaden..ab.1
  häromnatten_1_Adv = mkAdv "häromnatten" ; -- häromnatten..ab.1
  häromsistens_1_Adv = mkAdv "häromsistens" ; -- häromsistens..ab.1
  häromveckan_1_Adv = mkAdv "häromveckan" ; -- häromveckan..ab.1
  häromåret_1_Adv = mkAdv "häromåret" ; -- häromåret..ab.1
  härordning_1_N = mkN "härordning" ; -- härordning..nn.1
  härproducerad_1_A = mkA "härproducerad" ; -- härproducerad..av.1
  härpå_1_Adv = mkAdv "härpå" ; -- härpå..ab.1
  härröra_1_V = mkV "härröra" "härrörde" "härrört" ; -- härröra..vb.1
  härrörande_1_N = mkN "härrörande" ; -- härrörande..nn.1
  härska_1_V = mkV "härskar" ; -- härska..vb.1
  härskande_1_N = mkN "härskande" ; -- härskande..nn.1
  härskara_1_N = mkN "härskara" ; -- härskara..nn.1
  härskare_1_N = mkN "härskare" utrum  ; -- härskare..nn.1
  härskarfamilj_1_N = mkN "härskarfamilj" "härskarfamiljer" ; -- härskarfamilj..nn.1
  härskarinna_1_N = mkN "härskarinna" ; -- härskarinna..nn.1
  härskarklass_1_N = mkN "härskarklass" "härskarklasser" ; -- härskarklass..nn.1
  härskarmakt_1_N = mkN "härskarmakt" ; -- härskarmakt..nn.1
  härskarnatur_1_N = mkN "härskarnatur" "härskarnaturer" ; -- härskarnatur..nn.1
  härskarpar_1_N = mkN "härskarpar" neutrum  ; -- härskarpar..nn.1
  härskarteknik_1_N = mkN "härskarteknik" "härskartekniker" ; -- härskarteknik..nn.1
  härsken_1_A = mkA "härsken" ; -- härsken..av.1
  härskenhet_1_N = mkN "härskenhet" ; -- härskenhet..nn.1
  härsklysten_1_A = mkA "härsklysten" ; -- härsklysten..av.1
  härsklystenhet_1_N = mkN "härsklystenhet" ; -- härsklystenhet..nn.1
  härsklystnad_1_N = mkN "härsklystnad" ; -- härsklystnad..nn.1
  härskna_1_V = mkV "härsknar" ; -- härskna..vb.1
  härsknande_1_N = mkN "härsknande" ; -- härsknande..nn.1
  härskning_1_N = mkN "härskning" ; -- härskning..nn.1
  härskri_1_N = mkN "härskri" "härskriet" "härskrin" "härskrina" ; -- härskri..nn.1
  härstamma_1_V = mkV "härstammar" ; -- härstamma..vb.1
  härstammande_1_N = mkN "härstammande" ; -- härstammande..nn.1
  härstamning_1_N = mkN "härstamning" ; -- härstamning..nn.1
  härtagen_1_A = mkA "härtagen" ; -- härtagen..av.1
  härtappad_1_A = mkA "härtappad" ; -- härtappad..av.1
  härtill_1_Adv = mkAdv "härtill" ; -- härtill..ab.1
  härtåg_1_N = mkN "härtåg" neutrum  ; -- härtåg..nn.1
  härunder_1_Adv = mkAdv "härunder" ; -- härunder..ab.1
  häruppe_1_Adv = mkAdv "häruppe" ; -- häruppe..ab.1
  härutanför_1_Adv = mkAdv "härutanför" ; -- härutanför..ab.1
  härute_1_Adv = mkAdv "härute" ; -- härute..ab.1
  härutinnan_1_Adv = mkAdv "härutinnan" ; -- härutinnan..ab.1
  härutöver_1_Adv = mkAdv "härutöver" ; -- härutöver..ab.1
  härva_1_N = mkN "härva" ; -- härva..nn.1
  härvarande_1_A = mkA "härvarande" ; -- härvarande..av.1
  härvel_1_N = mkN "härvel" ; -- härvel..nn.1
  härvid_1_Adv = mkAdv "härvid" ; -- härvid..ab.1
  härvidlag_1_Adv = mkAdv "härvidlag" ; -- härvidlag..ab.1
  häråt_1_Adv = mkAdv "häråt" ; -- häråt..ab.1
  hässja_1_N = mkN "hässja" ; -- hässja..nn.1
  hässja_1_V = mkV "hässjar" ; -- hässja..vb.1
  hässjande_1_N = mkN "hässjande" ; -- hässjande..nn.1
  hässjestör_1_N = mkN "hässjestör" ; -- hässjestör..nn.1
  hässjning_1_N = mkN "hässjning" ; -- hässjning..nn.1
  häst_1_N = mkN "häst" ; -- häst..nn.1
  hästansikte_1_N = mkN "hästansikte" ; -- hästansikte..nn.1
  hästbajs_1_N = mkN "hästbajs" neutrum  ; -- hästbajs..nn.1
  hästben_1_N = mkN "hästben" neutrum  ; -- hästben..nn.1
  hästbonde_1_N = mkN "hästbonde" "hästbönder" ; -- hästbonde..nn.1
  hästdjur_1_N = mkN "hästdjur" neutrum  ; -- hästdjur..nn.1
  hästdragen_1_A = mkA "hästdragen" ; -- hästdragen..av.1
  hästdressyr_1_N = mkN "hästdressyr" "hästdressyrer" ; -- hästdressyr..nn.1
  hästgrimma_1_N = mkN "hästgrimma" ; -- hästgrimma..nn.1
  hästhov_1_N = mkN "hästhov" ; -- hästhov..nn.1
  hästhovsört_1_N = mkN "hästhovsört" "hästhovsörter" ; -- hästhovsört..nn.1
  hästhuvud_1_N = mkN "hästhuvud" "hästhuvudet" "hästhuvud" "hästhuvudena" ; -- hästhuvud..nn.1
  hästintresserad_1_A = mkA "hästintresserad" ; -- hästintresserad..av.1
  hästkapplöpning_1_N = mkN "hästkapplöpning" ; -- hästkapplöpning..nn.1
  hästkapplöpningsbana_1_N = mkN "hästkapplöpningsbana" ; -- hästkapplöpningsbana..nn.1
  hästkastanj_1_N = mkN "hästkastanj" "hästkastanjer" ; -- hästkastanj..nn.1
  hästkraft_1_N = mkN "hästkraft" "hästkrafter" ; -- hästkraft..nn.1
  hästkrake_1_N = mkN "hästkrake" utrum  ; -- hästkrake..nn.1
  hästkur_1_N = mkN "hästkur" "hästkurer" ; -- hästkur..nn.1
  hästkärra_1_N = mkN "hästkärra" ; -- hästkärra..nn.1
  hästlass_1_N = mkN "hästlass" neutrum  ; -- hästlass..nn.1
  hästliknande_1_A = mkA "hästliknande" ; -- hästliknande..av.1
  hästlängd_1_N = mkN "hästlängd" "hästlängder" ; -- hästlängd..nn.1
  hästminne_1_N = mkN "hästminne" ; -- hästminne..nn.1
  hästpolo_1_N = mkN "hästpolo" ; -- hästpolo..nn.1
  hästras_1_N = mkN "hästras" "hästraser" ; -- hästras..nn.1
  hästrygg_1_N = mkN "hästrygg" ; -- hästrygg..nn.1
  hästräfsa_1_N = mkN "hästräfsa" ; -- hästräfsa..nn.1
  hästskjuts_1_N = mkN "hästskjuts" ; -- hästskjuts..nn.1
  hästsko_1_N = mkN "hästsko" "hästskor" ; -- hästsko..nn.1
  hästskobåge_1_N = mkN "hästskobåge" utrum  ; -- hästskobåge..nn.1
  hästskoformig_1_A = mkA "hästskoformig" ; -- hästskoformig..av.1
  hästskojare_1_N = mkN "hästskojare" utrum  ; -- hästskojare..nn.1
  hästskomagnet_1_N = mkN "hästskomagnet" "hästskomagneter" ; -- hästskomagnet..nn.1
  hästskosöm_1_N = mkN "hästskosöm" "hästskosömmen" "hästskosöm" "hästskosömmen" ; -- hästskosöm..nn.1
  hästskötare_1_N = mkN "hästskötare" utrum  ; -- hästskötare..nn.1
  hästskötsel_1_N = mkN "hästskötsel" ; -- hästskötsel..nn.1
  hästsova_1_V = mkV "hästsova" "hästsov" "hästsovit" ; -- hästsova..vb.1
  hästspann_1_N = mkN "hästspann" neutrum  ; -- hästspann..nn.1
  hästspillning_1_N = mkN "hästspillning" ; -- hästspillning..nn.1
  häststaty_1_N = mkN "häststaty" "häststatyer" ; -- häststaty..nn.1
  häststyng_1_N = mkN "häststyng" neutrum  ; -- häststyng..nn.1
  hästsvans_1_N = mkN "hästsvans" ; -- hästsvans..nn.1
  hästtjej_1_N = mkN "hästtjej" "hästtjejer" ; -- hästtjej..nn.1
  hästtjuv_1_N = mkN "hästtjuv" ; -- hästtjuv..nn.1
  hästtämjande_1_N = mkN "hästtämjande" ; -- hästtämjande..nn.1
  hästtämjare_1_N = mkN "hästtämjare" utrum  ; -- hästtämjare..nn.1
  hästvagn_1_N = mkN "hästvagn" ; -- hästvagn..nn.1
  hästvandring_1_N = mkN "hästvandring" ; -- hästvandring..nn.1
  hästvind_1_N = mkN "hästvind" ; -- hästvind..nn.1
  hätsk_1_A = mkA "hätsk" ; -- hätsk..av.1
  hätskhet_1_N = mkN "hätskhet" "hätskheter" ; -- hätskhet..nn.1
  hätta_1_N = mkN "hätta" ; -- hätta..nn.1
  häva_1_V = mkV "häver" ; -- häva..vb.1
  hävande_1_N = mkN "hävande" ; -- hävande..nn.1
  hävarm_1_N = mkN "hävarm" ; -- hävarm..nn.1
  hävarmslyft_1_N = mkN "hävarmslyft" ; -- hävarmslyft..nn.1
  hävd_1_N = mkN "hävd" "hävder" ; -- hävd..nn.1
  hävda_1_V = mkV "hävdar" ; -- hävda..vb.1
  hävdande_1_N = mkN "hävdande" ; -- hävdande..nn.1
  hävdatecknare_1_N = mkN "hävdatecknare" utrum  ; -- hävdatecknare..nn.1
  hävdateckning_1_N = mkN "hävdateckning" ; -- hävdateckning..nn.1
  hävdelse_1_N = mkN "hävdelse" utrum  ; -- hävdelse..nn.1
  hävdvunnen_1_A = mkA "hävdvunnen" "hävdvunnet" "hävdvunna" "hävdvunna" "hävdvunnare" "hävdvunnast" "hävdvunnaste" ; -- hävdvunnen..av.1
  hävdvunnenhet_1_N = mkN "hävdvunnenhet" ; -- hävdvunnenhet..nn.1
  hävel_1_N = mkN "hävel" ; -- hävel..nn.1
  hävert_1_N = mkN "hävert" ; -- hävert..nn.1
  hävning_1_N = mkN "hävning" ; -- hävning..nn.1
  hävstång_1_N = mkN "hävstång" "hävstänger" ; -- hävstång..nn.1
  hävstångsarm_1_N = mkN "hävstångsarm" ; -- hävstångsarm..nn.1
  häxa_1_N = mkN "häxa" ; -- häxa..nn.1
  häxbål_1_N = mkN "häxbål" neutrum  ; -- häxbål..nn.1
  häxdans_1_N = mkN "häxdans" "häxdanser" ; -- häxdans..nn.1
  häxeri_1_N = mkN "häxeri" "häxeriet" "häxerier" "häxerierna" ; -- häxeri..nn.1
  häxförföljelse_1_N = mkN "häxförföljelse" "häxförföljelser" ; -- häxförföljelse..nn.1
  häxjakt_1_N = mkN "häxjakt" "häxjakter" ; -- häxjakt..nn.1
  häxjägare_1_N = mkN "häxjägare" utrum  ; -- häxjägare..nn.1
  häxkittel_1_N = mkN "häxkittel" ; -- häxkittel..nn.1
  häxkonspiration_1_N = mkN "häxkonspiration" ; -- häxkonspiration..nn.1
  häxkonst_1_N = mkN "häxkonst" "häxkonster" ; -- häxkonst..nn.1
  häxkraft_1_N = mkN "häxkraft" "häxkrafter" ; -- häxkraft..nn.1
  häxmästare_1_N = mkN "häxmästare" utrum  ; -- häxmästare..nn.1
  häxprocess_1_N = mkN "häxprocess" "häxprocesser" ; -- häxprocess..nn.1
  häxring_1_N = mkN "häxring" ; -- häxring..nn.1
  häxritt_1_N = mkN "häxritt" "häxritter" ; -- häxritt..nn.1
  häxsabbat_1_N = mkN "häxsabbat" "häxsabbater" ; -- häxsabbat..nn.1
  håbrand_1_N = mkN "håbrand" ; -- håbrand..nn.1
  håg_1_N = mkN "håg" ; -- håg..nn.1
  hågad_1_A = mkA "hågad" ; -- hågad..av.1
  hågkommelse_1_N = mkN "hågkommelse" "hågkommelser" ; -- hågkommelse..nn.1
  hågkomst_1_N = mkN "hågkomst" "hågkomster" ; -- hågkomst..nn.1
  håglös_1_A = mkA "håglös" ; -- håglös..av.1
  håglöshet_1_N = mkN "håglöshet" ; -- håglöshet..nn.1
  håkäring_1_N = mkN "håkäring" ; -- håkäring..nn.1
  hål_1_N = mkN "hål" neutrum  ; -- hål..nn.1
  håla_1_N = mkN "håla" ; -- håla..nn.1
  håla_1_V = mkV "hålar" ; -- håla..vb.1
  hålande_1_N = mkN "hålande" ; -- hålande..nn.1
  hålfot_1_N = mkN "hålfot" "hålfötter" ; -- hålfot..nn.1
  hålfotsinlägg_1_N = mkN "hålfotsinlägg" neutrum  ; -- hålfotsinlägg..nn.1
  hålig_1_A = mkA "hålig" ; -- hålig..av.1
  hålighet_1_N = mkN "hålighet" "håligheter" ; -- hålighet..nn.1
  håljärn_1_N = mkN "håljärn" neutrum  ; -- håljärn..nn.1
  hålkindad_1_A = mkA "hålkindad" ; -- hålkindad..av.1
  hålkort_1_N = mkN "hålkort" neutrum  ; -- hålkort..nn.1
  hålkäl_1_N = mkN "hålkäl" ; -- hålkäl..nn.1
  hålkälslist_1_N = mkN "hålkälslist" "hålkälslister" ; -- hålkälslist..nn.1
  håll_1_N = mkN "håll" neutrum  ; -- håll..nn.1
  hålla_1_V = mkV "hålla" "höll" "hållit" ; -- hålla..vb.1
  hållande_1_N = mkN "hållande" ; -- hållande..nn.1
  hållare_1_N = mkN "hållare" utrum  ; -- hållare..nn.1
  hållbar_1_A = mkA "hållbar" ; -- hållbar..av.1
  hållbarhet_1_N = mkN "hållbarhet" "hållbarheter" ; -- hållbarhet..nn.1
  hållbarhetsdag_1_N = mkN "hållbarhetsdag" ; -- hållbarhetsdag..nn.1
  hålldam_1_N = mkN "hålldam" "hålldamer" ; -- hålldam..nn.1
  hålldamm_1_N = mkN "hålldamm" ; -- hålldamm..nn.1
  hållen_1_A = mkA "hållen" ; -- hållen..av.1
  hållfast_1_A = mkA "hållfast" "hållfast" ; -- hållfast..av.1
  hållfasthet_1_N = mkN "hållfasthet" "hållfastheter" ; -- hållfasthet..nn.1
  hållfasthetsberäkning_1_N = mkN "hållfasthetsberäkning" ; -- hållfasthetsberäkning..nn.1
  hållfasthetslära_1_N = mkN "hållfasthetslära" ; -- hållfasthetslära..nn.1
  hållhake_1_N = mkN "hållhake" utrum  ; -- hållhake..nn.1
  hålligång_1_N = mkN "hålligång" neutrum  ; -- hålligång..nn.1
  hållning_1_N = mkN "hållning" ; -- hållning..nn.1
  hållningslös_1_A = mkA "hållningslös" ; -- hållningslös..av.1
  hållningslöshet_1_N = mkN "hållningslöshet" ; -- hållningslöshet..nn.1
  hållningssätt_1_N = mkN "hållningssätt" neutrum  ; -- hållningssätt..nn.1
  hållplats_1_N = mkN "hållplats" "hållplatser" ; -- hållplats..nn.1
  hållpunkt_1_N = mkN "hållpunkt" "hållpunkter" ; -- hållpunkt..nn.1
  hålltid_1_N = mkN "hålltid" "hålltider" ; -- hålltid..nn.1
  hålmönster_1_N = mkN "hålmönster" neutrum  ; -- hålmönster..nn.1
  hålning_1_N = mkN "hålning" ; -- hålning..nn.1
  hålremsa_1_N = mkN "hålremsa" ; -- hålremsa..nn.1
  hålrum_1_N = mkN "hålrum" "hålrummet" "hålrum" "hålrummen" ; -- hålrum..nn.1
  hålslag_1_N = mkN "hålslag" neutrum  ; -- hålslag..nn.1
  hålslagning_1_N = mkN "hålslagning" ; -- hålslagning..nn.1
  hålslev_1_N = mkN "hålslev" ; -- hålslev..nn.1
  hålslå_1_V = mkV "hålslå" "hålslog" "hålslagit" ; -- hålslå..vb.1
  hålslående_1_N = mkN "hålslående" ; -- hålslående..nn.1
  hålspetsammunition_1_N = mkN "hålspetsammunition" ; -- hålspetsammunition..nn.1
  hålspetskula_1_N = mkN "hålspetskula" ; -- hålspetskula..nn.1
  hålspikband_1_N = mkN "hålspikband" neutrum  ; -- hålspikband..nn.1
  håltegel_1_N = mkN "håltegel" neutrum  ; -- håltegel..nn.1
  håltimma_1_N = mkN "håltimma" ; -- håltimma..nn.1
  håltimme_1_N = mkN "håltimme" utrum  ; -- håltimme..nn.1
  hålven_1_N = mkN "hålven" "hålvener" ; -- hålven..nn.1
  hålväg_1_N = mkN "hålväg" ; -- hålväg..nn.1
  hålögd_1_A = mkA "hålögd" "hålögt" ; -- hålögd..av.1
  hålögdhet_1_N = mkN "hålögdhet" ; -- hålögdhet..nn.1
  hån_1_N = mkN "hån" neutrum  ; -- hån..nn.1
  håna_1_V = mkV "hånar" ; -- håna..vb.1
  hånande_1_N = mkN "hånande" ; -- hånande..nn.1
  hånflin_1_N = mkN "hånflin" neutrum  ; -- hånflin..nn.1
  hånflina_1_V = mkV "hånflinar" ; -- hånflina..vb.1
  hånflinande_1_N = mkN "hånflinande" ; -- hånflinande..nn.1
  hånfull_1_A = mkA "hånfull" ; -- hånfull..av.1
  hånfullhet_1_N = mkN "hånfullhet" "hånfullheter" ; -- hånfullhet..nn.1
  hångel_1_N = mkN "hångel" neutrum  ; -- hångel..nn.1
  hångelhörn_1_N = mkN "hångelhörn" neutrum  ; -- hångelhörn..nn.1
  hångelpar_1_N = mkN "hångelpar" neutrum  ; -- hångelpar..nn.1
  hångla_1_V = mkV "hånglar" ; -- hångla..vb.1
  hånglande_1_N = mkN "hånglande" ; -- hånglande..nn.1
  hångrin_1_N = mkN "hångrin" neutrum  ; -- hångrin..nn.1
  hångrina_1_V = mkV "hångrinar" ; -- hångrina..vb.1
  hångrinande_1_N = mkN "hångrinande" ; -- hångrinande..nn.1
  hånle_1_V = mkV "hånle" "hånlog" "hånlett" ; -- hånle..vb.1
  hånleende_1_N = mkN "hånleende" ; -- hånleende..nn.1
  hånskratt_1_N = mkN "hånskratt" neutrum  ; -- hånskratt..nn.1
  hånskratta_1_V = mkV "hånskrattar" ; -- hånskratta..vb.1
  hånskrattande_1_N = mkN "hånskrattande" ; -- hånskrattande..nn.1
  hår_1_N = mkN "hår" neutrum  ; -- hår..nn.1
  hår_2_N = mkN "hår" neutrum  ; -- hår..nn.2
  håravfall_1_N = mkN "håravfall" neutrum  ; -- håravfall..nn.1
  hårband_1_N = mkN "hårband" neutrum  ; -- hårband..nn.1
  hårbeklädnad_1_N = mkN "hårbeklädnad" "hårbeklädnader" ; -- hårbeklädnad..nn.1
  hårbevuxen_1_A = mkA "hårbevuxen" ; -- hårbevuxen..av.1
  hårbevuxenhet_1_N = mkN "hårbevuxenhet" ; -- hårbevuxenhet..nn.1
  hårbeväxt_1_A = mkA "hårbeväxt" "hårbeväxt" ; -- hårbeväxt..av.1
  hårborste_1_N = mkN "hårborste" utrum  ; -- hårborste..nn.1
  hårbotten_1_N = mkN "hårbotten" ; -- hårbotten..nn.1
  hårburr_1_N = mkN "hårburr" neutrum  ; -- hårburr..nn.1
  hård_1_A = mkA "hård" "hårt" ; -- hård..av.1
  hårdag_1_N = mkN "hårdag" ; -- hårdag..nn.1
  hårdbevakad_1_A = mkA "hårdbevakad" ; -- hårdbevakad..av.1
  hårdbly_1_N = mkN "hårdbly" neutrum  ; -- hårdbly..nn.1
  hårdblykula_1_N = mkN "hårdblykula" ; -- hårdblykula..nn.1
  hårddata_1_N = mkN "hårddata" "hårddatat" "hårddata" "hårddatana" ; -- hårddata..nn.1
  hårddisk_1_N = mkN "hårddisk" ; -- hårddisk..nn.1
  hårddra_1_V = mkV "hårddraga" "hårddrog" "hårddragit" ; -- hårddra..vb.1
  hårdfjällad_1_A = mkA "hårdfjällad" ; -- hårdfjällad..av.1
  hårdflirtad_1_A = mkA "hårdflirtad" ; -- hårdflirtad..av.1
  hårdflörtad_1_A = mkA "hårdflörtad" ; -- hårdflörtad..av.1
  hårdfrusen_1_A = mkA "hårdfrusen" ; -- hårdfrusen..av.1
  hårdför_1_A = mkA "hårdför" ; -- hårdför..av.1
  hårdförhet_1_N = mkN "hårdförhet" ; -- hårdförhet..nn.1
  hårdgranska_1_V = mkV "hårdgranskar" ; -- hårdgranska..vb.1
  hårdhandske_1_N = mkN "hårdhandske" utrum  ; -- hårdhandske..nn.1
  hårdhet_1_N = mkN "hårdhet" ; -- hårdhet..nn.1
  hårdhet_2_N = mkN "hårdhet" "hårdheter" ; -- hårdhet..nn.2
  hårdhjärtad_1_A = mkA "hårdhjärtad" ; -- hårdhjärtad..av.1
  hårdhjärtenhet_1_N = mkN "hårdhjärtenhet" ; -- hårdhjärtenhet..nn.1
  hårdhudad_1_A = mkA "hårdhudad" ; -- hårdhudad..av.1
  hårdhänt_1_A = mkA "hårdhänt" "hårdhänt" ; -- hårdhänt..av.1
  hårdhänthet_1_N = mkN "hårdhänthet" ; -- hårdhänthet..nn.1
  hårding_1_N = mkN "hårding" ; -- hårding..nn.1
  hårdkoka_1_V = mkV "hårdkokar" ; -- hårdkoka..vb.1
  hårdkokande_1_N = mkN "hårdkokande" ; -- hårdkokande..nn.1
  hårdkokning_1_N = mkN "hårdkokning" ; -- hårdkokning..nn.1
  hårdkokt_1_A = mkA "hårdkokt" "hårdkokt" ; -- hårdkokt..av.1
  hårdkokthet_1_N = mkN "hårdkokthet" ; -- hårdkokthet..nn.1
  hårdkorv_1_N = mkN "hårdkorv" ; -- hårdkorv..nn.1
  hårdlod_1_N = mkN "hårdlod" neutrum  ; -- hårdlod..nn.1
  hårdlöda_1_V = mkV "hårdlöda" "hårdlödde" "hårdlött" ; -- hårdlöda..vb.1
  hårdlödande_1_N = mkN "hårdlödande" ; -- hårdlödande..nn.1
  hårdlödning_1_N = mkN "hårdlödning" ; -- hårdlödning..nn.1
  hårdmetall_1_N = mkN "hårdmetall" "hårdmetaller" ; -- hårdmetall..nn.1
  hårdna_1_V = mkV "hårdnar" ; -- hårdna..vb.1
  hårdnackad_1_A = mkA "hårdnackad" ; -- hårdnackad..av.1
  hårdnackenhet_1_N = mkN "hårdnackenhet" ; -- hårdnackenhet..nn.1
  hårdnad_1_N = mkN "hårdnad" "hårdnader" ; -- hårdnad..nn.1
  hårdnande_1_N = mkN "hårdnande" ; -- hårdnande..nn.1
  hårdost_1_N = mkN "hårdost" ; -- hårdost..nn.1
  hårdplast_1_N = mkN "hårdplast" "hårdplaster" ; -- hårdplast..nn.1
  hårdporr_1_N = mkN "hårdporr" ; -- hårdporr..nn.1
  hårdra_1_V = mkV "hårdraga" "hårdrog" "hårdragit" ; -- hårdra..vb.1
  hårdragande_1_N = mkN "hårdragande" ; -- hårdragande..nn.1
  hårdragen_1_A = mkA "hårdragen" ; -- hårdragen..av.1
  hårdrock_1_N = mkN "hårdrock" ; -- hårdrock..nn.1
  hårdrockare_1_N = mkN "hårdrockare" utrum  ; -- hårdrockare..nn.1
  hårdsatsande_1_A = mkA "hårdsatsande" ; -- hårdsatsande..av.1
  hårdsinnad_1_A = mkA "hårdsinnad" ; -- hårdsinnad..av.1
  hårdsint_1_A = mkA "hårdsint" "hårdsint" ; -- hårdsint..av.1
  hårdsinthet_1_N = mkN "hårdsinthet" ; -- hårdsinthet..nn.1
  hårdsmält_1_A = mkA "hårdsmält" "hårdsmält" ; -- hårdsmält..av.1
  hårdsmälthet_1_N = mkN "hårdsmälthet" ; -- hårdsmälthet..nn.1
  hårdträna_1_V = mkV "hårdtränar" ; -- hårdträna..vb.1
  hårdtränande_1_N = mkN "hårdtränande" ; -- hårdtränande..nn.1
  hårdträning_1_N = mkN "hårdträning" ; -- hårdträning..nn.1
  hårdtvinnad_1_A = mkA "hårdtvinnad" ; -- hårdtvinnad..av.1
  hårdvaluta_1_N = mkN "hårdvaluta" ; -- hårdvaluta..nn.1
  hårdvara_1_N = mkN "hårdvara" ; -- hårdvara..nn.1
  hårdvarufel_1_N = mkN "hårdvarufel" "hårdvarufelet" "hårdvarufel" "hårdvarufelen" ; -- hårdvarufel..nn.1
  hårdvarumässig_1_A = mkA "hårdvarumässig" ; -- hårdvarumässig..av.1
  hårfin_1_A = mkA "hårfin" ; -- hårfin..av.1
  hårfrissa_1_N = mkN "hårfrissa" ; -- hårfrissa..nn.1
  hårfrisör_1_N = mkN "hårfrisör" "hårfrisörer" ; -- hårfrisör..nn.1
  hårfrisörska_1_N = mkN "hårfrisörska" ; -- hårfrisörska..nn.1
  hårfällning_1_N = mkN "hårfällning" ; -- hårfällning..nn.1
  hårfärg_1_N = mkN "hårfärg" "hårfärger" ; -- hårfärg..nn.1
  hårfärgning_1_N = mkN "hårfärgning" ; -- hårfärgning..nn.1
  hårfärgningsmedel_1_N = mkN "hårfärgningsmedel" neutrum  ; -- hårfärgningsmedel..nn.1
  hårfärgsbyte_1_N = mkN "hårfärgsbyte" ; -- hårfärgsbyte..nn.1
  hårfäste_1_N = mkN "hårfäste" ; -- hårfäste..nn.1
  hårfön_1_N = mkN "hårfön" ; -- hårfön..nn.1
  hårginst_1_N = mkN "hårginst" ; -- hårginst..nn.1
  hårig_1_A = mkA "hårig" ; -- hårig..av.1
  hårighet_1_N = mkN "hårighet" ; -- hårighet..nn.1
  hårinpackning_1_N = mkN "hårinpackning" ; -- hårinpackning..nn.1
  hårklyvare_1_N = mkN "hårklyvare" utrum  ; -- hårklyvare..nn.1
  hårklyveri_1_N = mkN "hårklyveri" "hårklyveriet" "hårklyverier" "hårklyverierna" ; -- hårklyveri..nn.1
  hårknut_1_N = mkN "hårknut" ; -- hårknut..nn.1
  hårkors_1_N = mkN "hårkors" neutrum  ; -- hårkors..nn.1
  hårlag_1_N = mkN "hårlag" neutrum  ; -- hårlag..nn.1
  hårliknande_1_A = mkA "hårliknande" ; -- hårliknande..av.1
  hårlock_1_N = mkN "hårlock" ; -- hårlock..nn.1
  hårlus_1_N = mkN "hårlus" "hårlusen" "hårlöss" "hårlössen" ; -- hårlus..nn.1
  hårläggning_1_N = mkN "hårläggning" ; -- hårläggning..nn.1
  hårlös_1_A = mkA "hårlös" ; -- hårlös..av.1
  hårlöshet_1_N = mkN "hårlöshet" ; -- hårlöshet..nn.1
  hårmode_1_N = mkN "hårmode" ; -- hårmode..nn.1
  hårnål_1_N = mkN "hårnål" ; -- hårnål..nn.1
  hårnålskurva_1_N = mkN "hårnålskurva" ; -- hårnålskurva..nn.1
  hårolja_1_N = mkN "hårolja" ; -- hårolja..nn.1
  hårpensel_1_N = mkN "hårpensel" ; -- hårpensel..nn.1
  hårpiska_1_N = mkN "hårpiska" ; -- hårpiska..nn.1
  hårplattång_1_N = mkN "hårplattång" "hårplattänger" ; -- hårplattång..nn.1
  hårrem_1_N = mkN "hårrem" "hårremmen" "hårremmar" "hårremmarna" ; -- hårrem..nn.1
  hårresande_1_A = mkA "hårresande" ; -- hårresande..av.1
  hårrulle_1_N = mkN "hårrulle" utrum  ; -- hårrulle..nn.1
  hårrör_1_N = mkN "hårrör" neutrum  ; -- hårrör..nn.1
  hårrörskraft_1_N = mkN "hårrörskraft" ; -- hårrörskraft..nn.1
  hårrörskärl_1_N = mkN "hårrörskärl" neutrum  ; -- hårrörskärl..nn.1
  hårsbredd_1_N = mkN "hårsbredd" "hårsbredder" ; -- hårsbredd..nn.1
  hårschampo_1_N = mkN "hårschampo" "hårschampot" "hårschampon" "hårschampona" ; -- hårschampo..nn.1
  hårsida_1_N = mkN "hårsida" ; -- hårsida..nn.1
  hårslinga_1_N = mkN "hårslinga" ; -- hårslinga..nn.1
  hårsmån_1_N = mkN "hårsmån" ; -- hårsmån..nn.1
  hårspänne_1_N = mkN "hårspänne" ; -- hårspänne..nn.1
  hårstreck_1_N = mkN "hårstreck" neutrum  ; -- hårstreck..nn.1
  hårstrå_1_N = mkN "hårstrå" "hårstråt" "hårstrån" "hårstråna" ; -- hårstrå..nn.1
  hårsvall_1_N = mkN "hårsvall" neutrum  ; -- hårsvall..nn.1
  hårsäck_1_N = mkN "hårsäck" ; -- hårsäck..nn.1
  hårtest_1_N = mkN "hårtest" ; -- hårtest..nn.1
  hårtofs_1_N = mkN "hårtofs" ; -- hårtofs..nn.1
  hårtork_1_N = mkN "hårtork" ; -- hårtork..nn.1
  hårtott_1_N = mkN "hårtott" ; -- hårtott..nn.1
  hårtuss_1_N = mkN "hårtuss" ; -- hårtuss..nn.1
  hårtvätt_1_N = mkN "hårtvätt" ; -- hårtvätt..nn.1
  hårtång_1_N = mkN "hårtång" "hårtänger" ; -- hårtång..nn.1
  håruppsättning_1_N = mkN "håruppsättning" ; -- håruppsättning..nn.1
  hårvatten_1_N = mkN "hårvatten" "hårvattnet" "hårvatten" "hårvattnen" ; -- hårvatten..nn.1
  hårvegetation_1_N = mkN "hårvegetation" ; -- hårvegetation..nn.1
  hårväxt_1_N = mkN "hårväxt" ; -- hårväxt..nn.1
  hårvård_1_N = mkN "hårvård" ; -- hårvård..nn.1
  håröm_1_A = mkA "håröm" "hårömt" "hårömma" "hårömma" "hårömmare" "hårömmast" "hårömmaste" ; -- håröm..av.1
  håv_1_N = mkN "håv" ; -- håv..nn.1
  håva_1_V = mkV "håvar" ; -- håva..vb.1
  håvande_1_N = mkN "håvande" ; -- håvande..nn.1
  håvning_1_N = mkN "håvning" ; -- håvning..nn.1
  hö_1_N = mkN "hö" neutrum  ; -- hö..nn.1
  höbärgning_1_N = mkN "höbärgning" ; -- höbärgning..nn.1
  höfeber_1_N = mkN "höfeber" ; -- höfeber..nn.1
  höft_1_N = mkN "höft" "höfter" ; -- höft..nn.1
  höftben_1_N = mkN "höftben" neutrum  ; -- höftben..nn.1
  höftfäste_1_N = mkN "höftfäste" ; -- höftfäste..nn.1
  höfthållare_1_N = mkN "höfthållare" utrum  ; -- höfthållare..nn.1
  höftkurva_1_N = mkN "höftkurva" ; -- höftkurva..nn.1
  höftled_1_N = mkN "höftled" "höftleder" ; -- höftled..nn.1
  höftledsoperation_1_N = mkN "höftledsoperation" ; -- höftledsoperation..nn.1
  höftlinje_1_N = mkN "höftlinje" "höftlinjer" ; -- höftlinje..nn.1
  höftmått_1_N = mkN "höftmått" neutrum  ; -- höftmått..nn.1
  höftparti_1_N = mkN "höftparti" "höftpartiet" "höftpartier" "höftpartierna" ; -- höftparti..nn.1
  höftskynke_1_N = mkN "höftskynke" ; -- höftskynke..nn.1
  höftvrickning_1_N = mkN "höftvrickning" ; -- höftvrickning..nn.1
  höftvärk_1_N = mkN "höftvärk" ; -- höftvärk..nn.1
  hög_1_A = mkA "hög" "högre" "högst" ; -- hög..av.1
  hög_1_N = mkN "hög" ; -- hög..nn.1
  högadel_1_N = mkN "högadel" ; -- högadel..nn.1
  högadlig_1_A = mkA "högadlig" ; -- högadlig..av.1
  högaffel_1_N = mkN "högaffel" ; -- högaffel..nn.1
  högakta_1_V = mkV "högaktar" ; -- högakta..vb.1
  högaktande_1_N = mkN "högaktande" ; -- högaktande..nn.1
  högaktiv_1_A = mkA "högaktiv" ; -- högaktiv..av.1
  högaktning_1_N = mkN "högaktning" ; -- högaktning..nn.1
  högaktningsfull_1_A = mkA "högaktningsfull" ; -- högaktningsfull..av.1
  högaktningsfullhet_1_N = mkN "högaktningsfullhet" ; -- högaktningsfullhet..nn.1
  högaktuell_1_A = mkA "högaktuell" ; -- högaktuell..av.1
  högaltare_1_N = mkN "högaltare" "högaltaret" "högaltaren" "högaltarna" ; -- högaltare..nn.1
  höganrikad_1_A = mkA "höganrikad" ; -- höganrikad..av.1
  högavlönad_1_A = mkA "högavlönad" ; -- högavlönad..av.1
  högbana_1_N = mkN "högbana" ; -- högbana..nn.1
  högben_1_N = mkN "högben" neutrum  ; -- högben..nn.1
  högblad_1_N = mkN "högblad" neutrum  ; -- högblad..nn.1
  högblå_1_A = mkA "högblå" "högblått" ; -- högblå..av.1
  högboren_1_A = mkA "högboren" ; -- högboren..av.1
  högborenhet_1_N = mkN "högborenhet" ; -- högborenhet..nn.1
  högborg_1_N = mkN "högborg" ; -- högborg..nn.1
  högborgerlig_1_A = mkA "högborgerlig" ; -- högborgerlig..av.1
  högborgerlighet_1_N = mkN "högborgerlighet" ; -- högborgerlighet..nn.1
  högburen_1_A = mkA "högburen" ; -- högburen..av.1
  högbänk_1_N = mkN "högbänk" ; -- högbänk..nn.1
  högbåtsman_1_N = mkN "högbåtsman" "högbåtsmannen" "högbåtsmän" "högbåtsmännen" ; -- högbåtsman..nn.1
  högdjur_1_N = mkN "högdjur" neutrum  ; -- högdjur..nn.1
  högdragen_1_A = mkA "högdragen" ; -- högdragen..av.1
  högdragenhet_1_N = mkN "högdragenhet" ; -- högdragenhet..nn.1
  högeffektiv_1_A = mkA "högeffektiv" ; -- högeffektiv..av.1
  högeligen_1_Adv = mkAdv "högeligen" ; -- högeligen..ab.1
  högenergi_1_N = mkN "högenergi" ; -- högenergi..nn.1
  högenergikollision_1_N = mkN "högenergikollision" ; -- högenergikollision..nn.1
  högenergipartikel_1_N = mkN "högenergipartikel" ; -- högenergipartikel..nn.1
  höger_1_N = mkN "höger" ; -- höger..nn.1
  höger_2_N = mkN "höger" ; -- höger..nn.2
  högerarm_1_N = mkN "högerarm" ; -- högerarm..nn.1
  högerben_1_N = mkN "högerben" neutrum  ; -- högerben..nn.1
  högerextrem_1_A = mkA "högerextrem" ; -- högerextrem..av.1
  högerextremism_1_N = mkN "högerextremism" ; -- högerextremism..nn.1
  högerextremistisk_1_A = mkA "högerextremistisk" ; -- högerextremistisk..av.1
  högerflygel_1_N = mkN "högerflygel" ; -- högerflygel..nn.1
  högerfot_1_N = mkN "högerfot" "högerfötter" ; -- högerfot..nn.1
  högergir_1_N = mkN "högergir" ; -- högergir..nn.1
  högergängad_1_A = mkA "högergängad" ; -- högergängad..av.1
  högerhand_1_N = mkN "högerhand" "högerhänder" ; -- högerhand..nn.1
  högerhänt_1_A = mkA "högerhänt" "högerhänt" ; -- högerhänt..av.1
  högerhänthet_1_N = mkN "högerhänthet" ; -- högerhänthet..nn.1
  högerkant_1_N = mkN "högerkant" "högerkanter" ; -- högerkant..nn.1
  högerklick_1_N = mkN "högerklick" neutrum  ; -- högerklick..nn.1
  högerklicka_1_V = mkV "högerklickar" ; -- högerklicka..vb.1
  högerklickande_1_N = mkN "högerklickande" ; -- högerklickande..nn.1
  högerklickning_1_N = mkN "högerklickning" ; -- högerklickning..nn.1
  högerknapp_1_N = mkN "högerknapp" ; -- högerknapp..nn.1
  högerkoalition_1_N = mkN "högerkoalition" ; -- högerkoalition..nn.1
  högerkristen_1_A = mkA "högerkristen" ; -- högerkristen..av.1
  högerkristenhet_1_N = mkN "högerkristenhet" ; -- högerkristenhet..nn.1
  högerkrok_1_N = mkN "högerkrok" ; -- högerkrok..nn.1
  högerkurva_1_N = mkN "högerkurva" ; -- högerkurva..nn.1
  högerledare_1_N = mkN "högerledare" utrum  ; -- högerledare..nn.1
  högermajoritet_1_N = mkN "högermajoritet" "högermajoriteter" ; -- högermajoritet..nn.1
  högerman_1_N = mkN "högerman" "högermannen" "högermän" "högermännen" ; -- högerman..nn.1
  högermyt_1_N = mkN "högermyt" "högermyter" ; -- högermyt..nn.1
  högernationalistisk_1_A = mkA "högernationalistisk" ; -- högernationalistisk..av.1
  högerparti_1_N = mkN "högerparti" "högerpartiet" "högerpartier" "högerpartierna" ; -- högerparti..nn.1
  högerpolitik_1_N = mkN "högerpolitik" ; -- högerpolitik..nn.1
  högerpolitiker_1_N = mkN "högerpolitiker" "högerpolitikern" "högerpolitiker" "högerpolitikerna" ; -- högerpolitiker..nn.1
  högerpolitisk_1_A = mkA "högerpolitisk" ; -- högerpolitisk..av.1
  högerpopulism_1_N = mkN "högerpopulism" ; -- högerpopulism..nn.1
  högerpopulist_1_N = mkN "högerpopulist" "högerpopulister" ; -- högerpopulist..nn.1
  högerpopulistisk_1_A = mkA "högerpopulistisk" ; -- högerpopulistisk..av.1
  högerradikal_1_A = mkA "högerradikal" ; -- högerradikal..av.1
  högerregel_1_N = mkN "högerregel" ; -- högerregel..nn.1
  högerregering_1_N = mkN "högerregering" ; -- högerregering..nn.1
  högersväng_1_N = mkN "högersväng" ; -- högersväng..nn.1
  högertrafik_1_N = mkN "högertrafik" ; -- högertrafik..nn.1
  högervante_1_N = mkN "högervante" utrum  ; -- högervante..nn.1
  högervind_1_N = mkN "högervind" ; -- högervind..nn.1
  högervindsindividualist_1_N = mkN "högervindsindividualist" "högervindsindividualister" ; -- högervindsindividualist..nn.1
  högervriden_1_A = mkA "högervriden" ; -- högervriden..av.1
  högervridning_1_N = mkN "högervridning" ; -- högervridning..nn.1
  högervåg_1_N = mkN "högervåg" "högervågor" ; -- högervåg..nn.1
  högeråra_1_N = mkN "högeråra" ; -- högeråra..nn.1
  högeröga_1_N = mkN "högeröga" "högerögat" "högerögon" "högerögonen" ; -- högeröga..nn.1
  högeröra_1_N = mkN "högeröra" "högerörat" "högeröron" "högeröronen" ; -- högeröra..nn.1
  högexplosiv_1_A = mkA "högexplosiv" ; -- högexplosiv..av.1
  högfjäll_1_N = mkN "högfjäll" neutrum  ; -- högfjäll..nn.1
  högfjällsområde_1_N = mkN "högfjällsområde" ; -- högfjällsområde..nn.1
  högfjällsterräng_1_N = mkN "högfjällsterräng" ; -- högfjällsterräng..nn.1
  högflod_1_N = mkN "högflod" ; -- högflod..nn.1
  högflor_1_N = mkN "högflor" ; -- högflor..nn.1
  högform_1_N = mkN "högform" ; -- högform..nn.1
  högform_2_N = mkN "högform" "högformer" ; -- högform..nn.2
  högfrekvens_1_N = mkN "högfrekvens" "högfrekvenser" ; -- högfrekvens..nn.1
  högfrekvent_1_A = mkA "högfrekvent" "högfrekvent" ; -- högfrekvent..av.1
  högfärd_1_N = mkN "högfärd" ; -- högfärd..nn.1
  högfärdig_1_A = mkA "högfärdig" ; -- högfärdig..av.1
  högfärdighet_1_N = mkN "högfärdighet" ; -- högfärdighet..nn.1
  högfärdsblåsa_1_N = mkN "högfärdsblåsa" ; -- högfärdsblåsa..nn.1
  högfärdsdjävul_1_N = mkN "högfärdsdjävul" ; -- högfärdsdjävul..nn.1
  högfärdsgalen_1_A = mkA "högfärdsgalen" ; -- högfärdsgalen..av.1
  högförnäm_1_A = mkA "högförnäm" ; -- högförnäm..av.1
  högförnämhet_1_N = mkN "högförnämhet" ; -- högförnämhet..nn.1
  högförrädare_1_N = mkN "högförrädare" utrum  ; -- högförrädare..nn.1
  högförräderi_1_N = mkN "högförräderi" "högförräderiet" "högförräderier" "högförräderierna" ; -- högförräderi..nn.1
  högförrädisk_1_A = mkA "högförrädisk" ; -- högförrädisk..av.1
  högglans_1_N = mkN "högglans" ; -- högglans..nn.1
  högglansvax_1_N = mkN "högglansvax" "högglansvaxet" "högglansvaxer" "högglansvaxerna" ; -- högglansvax..nn.1
  höggradig_1_A = mkA "höggradig" ; -- höggradig..av.1
  höggravid_1_A = mkA "höggravid" ; -- höggravid..av.1
  höghalsad_1_A = mkA "höghalsad" ; -- höghalsad..av.1
  höghastighetsbana_1_N = mkN "höghastighetsbana" ; -- höghastighetsbana..nn.1
  höghastighetshandel_1_N = mkN "höghastighetshandel" ; -- höghastighetshandel..nn.1
  höghastighetsjärnväg_1_N = mkN "höghastighetsjärnväg" ; -- höghastighetsjärnväg..nn.1
  höghastighetskamera_1_N = mkN "höghastighetskamera" ; -- höghastighetskamera..nn.1
  höghastighetslinje_1_N = mkN "höghastighetslinje" "höghastighetslinjer" ; -- höghastighetslinje..nn.1
  höghastighetstunnel_1_N = mkN "höghastighetstunnel" ; -- höghastighetstunnel..nn.1
  höghastighetståg_1_N = mkN "höghastighetståg" neutrum  ; -- höghastighetståg..nn.1
  höghet_1_N = mkN "höghet" "högheter" ; -- höghet..nn.1
  höghus_1_N = mkN "höghus" neutrum  ; -- höghus..nn.1
  höghöjdsläger_1_N = mkN "höghöjdsläger" neutrum  ; -- höghöjdsläger..nn.1
  höginkomsttagare_1_N = mkN "höginkomsttagare" utrum  ; -- höginkomsttagare..nn.1
  högintressant_1_A = mkA "högintressant" "högintressant" ; -- högintressant..av.1
  högkinesiska_1_N = mkN "högkinesiska" ; -- högkinesiska..nn.1
  högklackad_1_A = mkA "högklackad" ; -- högklackad..av.1
  högklassig_1_A = mkA "högklassig" ; -- högklassig..av.1
  högklassighet_1_N = mkN "högklassighet" ; -- högklassighet..nn.1
  högkonjunktur_1_N = mkN "högkonjunktur" "högkonjunkturer" ; -- högkonjunktur..nn.1
  högkor_1_N = mkN "högkor" neutrum  ; -- högkor..nn.1
  högkragad_1_A = mkA "högkragad" ; -- högkragad..av.1
  högkultur_1_N = mkN "högkultur" "högkulturer" ; -- högkultur..nn.1
  högkultur_2_N = mkN "högkultur" ; -- högkultur..nn.2
  högkvalitativ_1_A = mkA "högkvalitativ" ; -- högkvalitativ..av.1
  högkvarter_1_N = mkN "högkvarter" "högkvarteret" "högkvarter" "högkvarteren" ; -- högkvarter..nn.1
  högkyrklig_1_A = mkA "högkyrklig" ; -- högkyrklig..av.1
  högkyrklighet_1_N = mkN "högkyrklighet" ; -- högkyrklighet..nn.1
  höglager_1_N = mkN "höglager" neutrum  ; -- höglager..nn.1
  högland_1_N = mkN "högland" "höglandet" "högländer" "högländerna" ; -- högland..nn.1
  högljudd_1_A = mkA "högljudd" ; -- högljudd..av.1
  högljuddhet_1_N = mkN "högljuddhet" ; -- högljuddhet..nn.1
  högläge_1_N = mkN "högläge" ; -- högläge..nn.1
  högländare_1_N = mkN "högländare" utrum  ; -- högländare..nn.1
  högländsk_1_A = mkA "högländsk" ; -- högländsk..av.1
  höglänt_1_A = mkA "höglänt" "höglänt" ; -- höglänt..av.1
  höglänthet_1_N = mkN "höglänthet" ; -- höglänthet..nn.1
  högläsning_1_N = mkN "högläsning" ; -- högläsning..nn.1
  höglönejobb_1_N = mkN "höglönejobb" neutrum  ; -- höglönejobb..nn.1
  högmedeltid_1_N = mkN "högmedeltid" ; -- högmedeltid..nn.1
  högmod_1_N = mkN "högmod" neutrum  ; -- högmod..nn.1
  högmodig_1_A = mkA "högmodig" ; -- högmodig..av.1
  högmodighet_1_N = mkN "högmodighet" ; -- högmodighet..nn.1
  högmolekylär_1_A = mkA "högmolekylär" ; -- högmolekylär..av.1
  högmässa_1_N = mkN "högmässa" ; -- högmässa..nn.1
  högmålsbrott_1_N = mkN "högmålsbrott" neutrum  ; -- högmålsbrott..nn.1
  högmålsprocess_1_N = mkN "högmålsprocess" "högmålsprocesser" ; -- högmålsprocess..nn.1
  högnivåmöte_1_N = mkN "högnivåmöte" ; -- högnivåmöte..nn.1
  högoddsare_1_N = mkN "högoddsare" utrum  ; -- högoddsare..nn.1
  högoktanig_1_A = mkA "högoktanig" ; -- högoktanig..av.1
  högpatriotisk_1_A = mkA "högpatriotisk" ; -- högpatriotisk..av.1
  högplatå_1_N = mkN "högplatå" "högplatåer" ; -- högplatå..nn.1
  högpresterande_1_A = mkA "högpresterande" ; -- högpresterande..av.1
  högprioritera_1_V = mkV "högprioriterar" ; -- högprioritera..vb.1
  högproduktiv_1_A = mkA "högproduktiv" ; -- högproduktiv..av.1
  högprosa_1_N = mkN "högprosa" ; -- högprosa..nn.1
  högrelief_1_N = mkN "högrelief" "högreliefer" ; -- högrelief..nn.1
  högrest_1_A = mkA "högrest" "högrest" ; -- högrest..av.1
  högresthet_1_N = mkN "högresthet" ; -- högresthet..nn.1
  högreståndsdam_1_N = mkN "högreståndsdam" "högreståndsdamer" ; -- högreståndsdam..nn.1
  högreståndskrets_1_N = mkN "högreståndskrets" ; -- högreståndskrets..nn.1
  högreståndskultur_1_N = mkN "högreståndskultur" "högreståndskulturer" ; -- högreståndskultur..nn.1
  högreståndsmässig_1_A = mkA "högreståndsmässig" ; -- högreståndsmässig..av.1
  högrev_1_N = mkN "högrev" neutrum  ; -- högrev..nn.1
  högriskbeteende_1_N = mkN "högriskbeteende" ; -- högriskbeteende..nn.1
  högriskfond_1_N = mkN "högriskfond" "högriskfonder" ; -- högriskfond..nn.1
  högriskförlossning_1_N = mkN "högriskförlossning" ; -- högriskförlossning..nn.1
  högriskmatch_1_N = mkN "högriskmatch" "högriskmatcher" ; -- högriskmatch..nn.1
  högriskprojekt_1_N = mkN "högriskprojekt" neutrum  ; -- högriskprojekt..nn.1
  högromantisk_1_A = mkA "högromantisk" ; -- högromantisk..av.1
  högröd_1_A = mkA "högröd" "högrött" ; -- högröd..av.1
  högröstad_1_A = mkA "högröstad" ; -- högröstad..av.1
  högsinnad_1_A = mkA "högsinnad" ; -- högsinnad..av.1
  högsint_1_A = mkA "högsint" "högsint" ; -- högsint..av.1
  högsinthet_1_N = mkN "högsinthet" ; -- högsinthet..nn.1
  högsjöflotta_1_N = mkN "högsjöflotta" ; -- högsjöflotta..nn.1
  högskaftad_1_A = mkA "högskaftad" ; -- högskaftad..av.1
  högskola_1_N = mkN "högskola" ; -- högskola..nn.1
  högskoleadjunkt_1_N = mkN "högskoleadjunkt" "högskoleadjunkter" ; -- högskoleadjunkt..nn.1
  högskoleexamen_1_N = mkN "högskoleexamen" "högskoleexamen" "högskoleexamina" "högskoleexamina" ; -- högskoleexamen..nn.1
  högskoleförberedande_1_A = mkA "högskoleförberedande" ; -- högskoleförberedande..av.1
  högskoleguide_1_N = mkN "högskoleguide" "högskoleguider" ; -- högskoleguide..nn.1
  högskolelektor_1_N = mkN "högskolelektor" "högskolelektorer" ; -- högskolelektor..nn.1
  högskolemässig_1_A = mkA "högskolemässig" ; -- högskolemässig..av.1
  högskoleplats_1_N = mkN "högskoleplats" "högskoleplatser" ; -- högskoleplats..nn.1
  högskoleprov_1_N = mkN "högskoleprov" neutrum  ; -- högskoleprov..nn.1
  högskolestatus_1_N = mkN "högskolestatus" ; -- högskolestatus..nn.1
  högskolestudium_1_N = mkN "högskolestudium" "högskolestudiet" "högskolestudier" "högskolestudierna" ; -- högskolestudium..nn.1
  högskoleutbildad_1_A = mkA "högskoleutbildad" ; -- högskoleutbildad..av.1
  högskoleutbildning_1_N = mkN "högskoleutbildning" ; -- högskoleutbildning..nn.1
  högslätt_1_N = mkN "högslätt" "högslätter" ; -- högslätt..nn.1
  högsommar_1_N = mkN "högsommar" "högsommaren" "högsomrar" "högsomrarna" ; -- högsommar..nn.1
  högsommarljus_1_N = mkN "högsommarljus" neutrum  ; -- högsommarljus..nn.1
  högspecialiserad_1_A = mkA "högspecialiserad" ; -- högspecialiserad..av.1
  högspråk_1_N = mkN "högspråk" neutrum  ; -- högspråk..nn.1
  högspänd_1_A = mkA "högspänd" ; -- högspänd..av.1
  högspänning_1_N = mkN "högspänning" ; -- högspänning..nn.1
  högspänningsledning_1_N = mkN "högspänningsledning" ; -- högspänningsledning..nn.1
  högstadielärare_1_N = mkN "högstadielärare" utrum  ; -- högstadielärare..nn.1
  högstadieunge_1_N = mkN "högstadieunge" utrum  ; -- högstadieunge..nn.1
  högstadium_1_N = mkN "högstadium" "högstadiet" "högstadier" "högstadierna" ; -- högstadium..nn.1
  högstatus_1_N = mkN "högstatus" ; -- högstatus..nn.1
  högstbjudande_1_A = mkA "högstbjudande" ; -- högstbjudande..av.1
  högsträvande_1_A = mkA "högsträvande" ; -- högsträvande..av.1
  högstämd_1_A = mkA "högstämd" "högstämt" ; -- högstämd..av.1
  högstämdhet_1_N = mkN "högstämdhet" ; -- högstämdhet..nn.1
  högsäkerhetssjukhus_1_N = mkN "högsäkerhetssjukhus" neutrum  ; -- högsäkerhetssjukhus..nn.1
  högsäsong_1_N = mkN "högsäsong" "högsäsonger" ; -- högsäsong..nn.1
  högsäte_1_N = mkN "högsäte" ; -- högsäte..nn.1
  högtalaranläggning_1_N = mkN "högtalaranläggning" ; -- högtalaranläggning..nn.1
  högtalare_1_N = mkN "högtalare" utrum  ; -- högtalare..nn.1
  högtalarröst_1_N = mkN "högtalarröst" "högtalarröster" ; -- högtalarröst..nn.1
  högtalarsystem_1_N = mkN "högtalarsystem" neutrum  ; -- högtalarsystem..nn.1
  högteknologi_1_N = mkN "högteknologi" "högteknologier" ; -- högteknologi..nn.1
  högteknologisk_1_A = mkA "högteknologisk" ; -- högteknologisk..av.1
  högtemperatursupraledning_1_N = mkN "högtemperatursupraledning" ; -- högtemperatursupraledning..nn.1
  högtflygande_1_A = mkA "högtflygande" ; -- högtflygande..av.1
  högtid_1_N = mkN "högtid" "högtider" ; -- högtid..nn.1
  högtidlig_1_A = mkA "högtidlig" ; -- högtidlig..av.1
  högtidligen_1_Adv = mkAdv "högtidligen" ; -- högtidligen..ab.1
  högtidlighet_1_N = mkN "högtidlighet" "högtidligheter" ; -- högtidlighet..nn.1
  högtidlighålla_1_V = mkV "högtidlighålla" "högtidlighöll" "högtidlighållit" ; -- högtidlighålla..vb.1
  högtidlighållande_1_N = mkN "högtidlighållande" ; -- högtidlighållande..nn.1
  högtidsdag_1_N = mkN "högtidsdag" ; -- högtidsdag..nn.1
  högtidsdräkt_1_N = mkN "högtidsdräkt" "högtidsdräkter" ; -- högtidsdräkt..nn.1
  högtidsklädd_1_A = mkA "högtidsklädd" ; -- högtidsklädd..av.1
  högtidskväll_1_N = mkN "högtidskväll" ; -- högtidskväll..nn.1
  högtidsstund_1_N = mkN "högtidsstund" "högtidsstunder" ; -- högtidsstund..nn.1
  högtidsstämning_1_N = mkN "högtidsstämning" ; -- högtidsstämning..nn.1
  högtidstal_1_N = mkN "högtidstal" neutrum  ; -- högtidstal..nn.1
  högtidsår_1_N = mkN "högtidsår" neutrum  ; -- högtidsår..nn.1
  högtrafik_1_N = mkN "högtrafik" ; -- högtrafik..nn.1
  högtravande_1_A = mkA "högtravande" ; -- högtravande..av.1
  högtryck_1_N = mkN "högtryck" neutrum  ; -- högtryck..nn.1
  högtryckskabel_1_N = mkN "högtryckskabel" ; -- högtryckskabel..nn.1
  högtrycksområde_1_N = mkN "högtrycksområde" ; -- högtrycksområde..nn.1
  högtrycksrygg_1_N = mkN "högtrycksrygg" ; -- högtrycksrygg..nn.1
  högtryckstvätt_1_N = mkN "högtryckstvätt" ; -- högtryckstvätt..nn.1
  högtsträvande_1_A = mkA "högtsträvande" ; -- högtsträvande..av.1
  högtstående_1_A = mkA "högtstående" ; -- högtstående..av.1
  högtysk_1_A = mkA "högtysk" ; -- högtysk..av.1
  högtyska_1_N = mkN "högtyska" ; -- högtyska..nn.1
  högtäckande_1_A = mkA "högtäckande" ; -- högtäckande..av.1
  högutbildad_1_A = mkA "högutbildad" ; -- högutbildad..av.1
  högvakt_1_N = mkN "högvakt" "högvakter" ; -- högvakt..nn.1
  högvall_1_N = mkN "högvall" ; -- högvall..nn.1
  högvallsklöver_1_N = mkN "högvallsklöver" "högvallsklövern" "högvallsklöver" "högvallsklöverna" ; -- högvallsklöver..nn.1
  högvarv_1_N = mkN "högvarv" neutrum  ; -- högvarv..nn.1
  högvatten_1_N = mkN "högvatten" "högvattnet" "högvatten" "högvattnen" ; -- högvatten..nn.1
  högvilt_1_N = mkN "högvilt" neutrum  ; -- högvilt..nn.1
  högvis_1_Adv = mkAdv "högvis" ; -- högvis..ab.1
  högvuxen_1_A = mkA "högvuxen" ; -- högvuxen..av.1
  högvuxenhet_1_N = mkN "högvuxenhet" ; -- högvuxenhet..nn.1
  högvälboren_1_A = mkA "högvälboren" ; -- högvälboren..av.1
  högvälborenhet_1_N = mkN "högvälborenhet" ; -- högvälborenhet..nn.1
  högvärdig_1_A = mkA "högvärdig" ; -- högvärdig..av.1
  högvärdighet_1_N = mkN "högvärdighet" ; -- högvärdighet..nn.1
  högväxt_1_A = mkA "högväxt" "högväxt" ; -- högväxt..av.1
  högväxthet_1_N = mkN "högväxthet" ; -- högväxthet..nn.1
  högvördig_1_A = mkA "högvördig" ; -- högvördig..av.1
  högvördighet_1_N = mkN "högvördighet" "högvördigheter" ; -- högvördighet..nn.1
  högättad_1_A = mkA "högättad" ; -- högättad..av.1
  högönsklig_1_A = mkA "högönsklig" ; -- högönsklig..av.1
  höja_1_V = mkV "höja" "höjde" "höjt" ; -- höja..vb.1
  höjande_1_N = mkN "höjande" ; -- höjande..nn.1
  höjd_1_N = mkN "höjd" "höjder" ; -- höjd..nn.1
  höjdare_1_N = mkN "höjdare" utrum  ; -- höjdare..nn.1
  höjdbestämning_1_N = mkN "höjdbestämning" ; -- höjdbestämning..nn.1
  höjdgrad_1_N = mkN "höjdgrad" "höjdgrader" ; -- höjdgrad..nn.1
  höjdhopp_1_N = mkN "höjdhopp" neutrum  ; -- höjdhopp..nn.1
  höjdhoppare_1_N = mkN "höjdhoppare" utrum  ; -- höjdhoppare..nn.1
  höjdhoppstävling_1_N = mkN "höjdhoppstävling" ; -- höjdhoppstävling..nn.1
  höjdinställning_1_N = mkN "höjdinställning" ; -- höjdinställning..nn.1
  höjdkarta_1_N = mkN "höjdkarta" ; -- höjdkarta..nn.1
  höjdkurva_1_N = mkN "höjdkurva" ; -- höjdkurva..nn.1
  höjdled_1_N = mkN "höjdled" ; -- höjdled..nn.1
  höjdläge_1_N = mkN "höjdläge" ; -- höjdläge..nn.1
  höjdmässig_1_A = mkA "höjdmässig" ; -- höjdmässig..av.1
  höjdmätare_1_N = mkN "höjdmätare" utrum  ; -- höjdmätare..nn.1
  höjdmätning_1_N = mkN "höjdmätning" ; -- höjdmätning..nn.1
  höjdpunkt_1_N = mkN "höjdpunkt" "höjdpunkter" ; -- höjdpunkt..nn.1
  höjdrygg_1_N = mkN "höjdrygg" ; -- höjdrygg..nn.1
  höjdrädd_1_A = mkA "höjdrädd" ; -- höjdrädd..av.1
  höjdskillnad_1_N = mkN "höjdskillnad" "höjdskillnader" ; -- höjdskillnad..nn.1
  höjdsträckning_1_N = mkN "höjdsträckning" ; -- höjdsträckning..nn.1
  höjning_1_N = mkN "höjning" ; -- höjning..nn.1
  hök_1_N = mkN "hök" ; -- hök..nn.1
  hökaktig_1_A = mkA "hökaktig" ; -- hökaktig..av.1
  hökaktighet_1_N = mkN "hökaktighet" ; -- hökaktighet..nn.1
  hökare_1_N = mkN "hökare" utrum  ; -- hökare..nn.1
  hökeri_1_N = mkN "hökeri" "hökeriet" "hökerier" "hökerierna" ; -- hökeri..nn.1
  höknatt_1_N = mkN "höknatt" "höknätter" ; -- höknatt..nn.1
  hökpolitik_1_N = mkN "hökpolitik" ; -- hökpolitik..nn.1
  hökuggla_1_N = mkN "hökuggla" ; -- hökuggla..nn.1
  hölja_1_N = mkN "hölja" ; -- hölja..nn.1
  hölja_1_V = mkV "hölja" "höljde" "höljt" ; -- hölja..vb.1
  höljande_1_N = mkN "höljande" ; -- höljande..nn.1
  hölje_1_N = mkN "hölje" ; -- hölje..nn.1
  höljning_1_N = mkN "höljning" ; -- höljning..nn.1
  hölster_1_N = mkN "hölster" neutrum  ; -- hölster..nn.1
  höna_1_N = mkN "höna" ; -- höna..nn.1
  höns_1_N = mkN "höns" neutrum  ; -- höns..nn.1
  hönsarve_1_N = mkN "hönsarv" ; -- hönsarve..nn.1
  hönsbuljong_1_N = mkN "hönsbuljong" "hönsbuljonger" ; -- hönsbuljong..nn.1
  hönsbur_1_N = mkN "hönsbur" ; -- hönsbur..nn.1
  hönsbär_1_N = mkN "hönsbär" neutrum  ; -- hönsbär..nn.1
  hönseri_1_N = mkN "hönseri" "hönseriet" "hönserier" "hönserierna" ; -- hönseri..nn.1
  hönsfågel_1_N = mkN "hönsfågel" ; -- hönsfågel..nn.1
  hönsgryta_1_N = mkN "hönsgryta" ; -- hönsgryta..nn.1
  hönsgård_1_N = mkN "hönsgård" ; -- hönsgård..nn.1
  hönshjärna_1_N = mkN "hönshjärna" ; -- hönshjärna..nn.1
  hönshus_1_N = mkN "hönshus" neutrum  ; -- hönshus..nn.1
  hönsig_1_A = mkA "hönsig" ; -- hönsig..av.1
  hönsighet_1_N = mkN "hönsighet" ; -- hönsighet..nn.1
  hönsminne_1_N = mkN "hönsminne" ; -- hönsminne..nn.1
  hönsnät_1_N = mkN "hönsnät" neutrum  ; -- hönsnät..nn.1
  hönsägg_1_N = mkN "hönsägg" neutrum  ; -- hönsägg..nn.1
  höra_1_V = mkV "höra" "hörde" "hört" ; -- höra..vb.1
  hörande_1_N = mkN "hörande" ; -- hörande..nn.1
  hörapparat_1_N = mkN "hörapparat" "hörapparater" ; -- hörapparat..nn.1
  hörare_1_N = mkN "hörare" utrum  ; -- hörare..nn.1
  hörbar_1_A = mkA "hörbar" ; -- hörbar..av.1
  hörbarhet_1_N = mkN "hörbarhet" "hörbarheter" ; -- hörbarhet..nn.1
  hörbarhetströskel_1_N = mkN "hörbarhetströskel" ; -- hörbarhetströskel..nn.1
  hörbarligen_1_Adv = mkAdv "hörbarligen" ; -- hörbarligen..ab.1
  hörhåll_1_N = mkN "hörhåll" ; -- hörhåll..nn.1
  hörlur_1_N = mkN "hörlur" ; -- hörlur..nn.1
  hörn_1_N = mkN "hörn" neutrum  ; -- hörn..nn.1
  hörna_1_N = mkN "hörna" ; -- hörna..nn.1
  hörnflagga_1_N = mkN "hörnflagga" ; -- hörnflagga..nn.1
  hörnhus_1_N = mkN "hörnhus" neutrum  ; -- hörnhus..nn.1
  hörnlampa_1_N = mkN "hörnlampa" ; -- hörnlampa..nn.1
  hörnpelare_1_N = mkN "hörnpelare" utrum  ; -- hörnpelare..nn.1
  hörnskåp_1_N = mkN "hörnskåp" neutrum  ; -- hörnskåp..nn.1
  hörnsoffa_1_N = mkN "hörnsoffa" ; -- hörnsoffa..nn.1
  hörnsten_1_N = mkN "hörnsten" "hörnstenen" "hörnstenar" "hörnstenarna" ; -- hörnsten..nn.1
  hörnstolpe_1_N = mkN "hörnstolpe" utrum  ; -- hörnstolpe..nn.1
  hörntand_1_N = mkN "hörntand" "hörntänder" ; -- hörntand..nn.1
  hörntorn_1_N = mkN "hörntorn" neutrum  ; -- hörntorn..nn.1
  hörsaga_1_N = mkN "hörsaga" ; -- hörsaga..nn.1
  hörsal_1_N = mkN "hörsal" ; -- hörsal..nn.1
  hörsam_1_A = mkA "hörsam" "hörsamt" "hörsamma" "hörsamma" "hörsammare" "hörsammast" "hörsammaste" ; -- hörsam..av.1
  hörsamhet_1_N = mkN "hörsamhet" ; -- hörsamhet..nn.1
  hörsamma_1_V = mkV "hörsammar" ; -- hörsamma..vb.1
  hörsammande_1_N = mkN "hörsammande" ; -- hörsammande..nn.1
  hörsel_1_N = mkN "hörsel" ; -- hörsel..nn.1
  hörselben_1_N = mkN "hörselben" neutrum  ; -- hörselben..nn.1
  hörselgång_1_N = mkN "hörselgång" ; -- hörselgång..nn.1
  hörselhallucination_1_N = mkN "hörselhallucination" ; -- hörselhallucination..nn.1
  hörselklass_1_N = mkN "hörselklass" "hörselklasser" ; -- hörselklass..nn.1
  hörselkåpa_1_N = mkN "hörselkåpa" ; -- hörselkåpa..nn.1
  hörselorgan_1_N = mkN "hörselorgan" neutrum  ; -- hörselorgan..nn.1
  hörselsinne_1_N = mkN "hörselsinne" ; -- hörselsinne..nn.1
  hörselskada_1_N = mkN "hörselskada" ; -- hörselskada..nn.1
  hörselskadad_1_A = mkA "hörselskadad" ; -- hörselskadad..av.1
  hörselskydd_1_N = mkN "hörselskydd" neutrum  ; -- hörselskydd..nn.1
  hörselsnäcka_1_N = mkN "hörselsnäcka" ; -- hörselsnäcka..nn.1
  hörselvilla_1_N = mkN "hörselvilla" ; -- hörselvilla..nn.1
  hörsnäcka_1_N = mkN "hörsnäcka" ; -- hörsnäcka..nn.1
  hörspel_1_N = mkN "hörspel" "hörspelet" "hörspel" "hörspelen" ; -- hörspel..nn.1
  hörsägen_1_N = mkN "hörsägen" "hörsägenn" "hörsägner" "hörsägnerna" ; -- hörsägen..nn.1
  hörtelefon_1_N = mkN "hörtelefon" "hörtelefoner" ; -- hörtelefon..nn.1
  höskulle_1_N = mkN "höskulle" utrum  ; -- höskulle..nn.1
  hösnuva_1_N = mkN "hösnuva" ; -- hösnuva..nn.1
  höst_1_N = mkN "höst" ; -- höst..nn.1
  hösta_1_V = mkV "höstar" ; -- hösta..vb.1
  höstack_1_N = mkN "höstack" ; -- höstack..nn.1
  höstande_1_N = mkN "höstande" ; -- höstande..nn.1
  höstbruk_1_N = mkN "höstbruk" neutrum  ; -- höstbruk..nn.1
  höstdag_1_N = mkN "höstdag" ; -- höstdag..nn.1
  höstdagjämning_1_N = mkN "höstdagjämning" ; -- höstdagjämning..nn.1
  höstfrost_1_N = mkN "höstfrost" ; -- höstfrost..nn.1
  höstgryta_1_N = mkN "höstgryta" ; -- höstgryta..nn.1
  höstgyttja_1_N = mkN "höstgyttja" ; -- höstgyttja..nn.1
  höstkant_1_N = mkN "höstkant" ; -- höstkant..nn.1
  höstkantarell_1_N = mkN "höstkantarell" "höstkantareller" ; -- höstkantarell..nn.1
  höstkyla_1_N = mkN "höstkyla" ; -- höstkyla..nn.1
  höstlig_1_A = mkA "höstlig" ; -- höstlig..av.1
  höstlik_1_A = mkA "höstlik" ; -- höstlik..av.1
  höstlov_1_N = mkN "höstlov" neutrum  ; -- höstlov..nn.1
  höstlöv_1_N = mkN "höstlöv" neutrum  ; -- höstlöv..nn.1
  höstlövsgul_1_A = mkA "höstlövsgul" ; -- höstlövsgul..av.1
  höstmånad_1_N = mkN "höstmånad" "höstmånader" ; -- höstmånad..nn.1
  höstmörker_1_N = mkN "höstmörker" neutrum  ; -- höstmörker..nn.1
  höstorientering_1_N = mkN "höstorientering" ; -- höstorientering..nn.1
  höstplöja_1_V = mkV "höstplöja" "höstplöjde" "höstplöjt" ; -- höstplöja..vb.1
  höstplöjning_1_N = mkN "höstplöjning" ; -- höstplöjning..nn.1
  höstregn_1_N = mkN "höstregn" neutrum  ; -- höstregn..nn.1
  höstrusk_1_N = mkN "höstrusk" neutrum  ; -- höstrusk..nn.1
  höstsida_1_N = mkN "höstsida" ; -- höstsida..nn.1
  höstslakt_1_N = mkN "höstslakt" "höstslakter" ; -- höstslakt..nn.1
  höstsol_1_N = mkN "höstsol" ; -- höstsol..nn.1
  höststorm_1_N = mkN "höststorm" ; -- höststorm..nn.1
  höststormig_1_A = mkA "höststormig" ; -- höststormig..av.1
  höstsäd_1_N = mkN "höstsäd" ; -- höstsäd..nn.1
  höstsäsong_1_N = mkN "höstsäsong" "höstsäsonger" ; -- höstsäsong..nn.1
  höstsådd_1_N = mkN "höstsådd" ; -- höstsådd..nn.1
  hösttermin_1_N = mkN "hösttermin" "höstterminer" ; -- hösttermin..nn.1
  höstvete_1_N = mkN "höstvete" ; -- höstvete..nn.1
  höstväder_1_N = mkN "höstväder" neutrum  ; -- höstväder..nn.1
  hösäck_1_N = mkN "hösäck" ; -- hösäck..nn.1
  hösåte_1_N = mkN "hösåte" utrum  ; -- hösåte..nn.1
  höta_1_V = mkV "höter" ; -- höta..vb.1
  hötande_1_N = mkN "hötande" ; -- hötande..nn.1
  hötapp_1_N = mkN "hötapp" ; -- hötapp..nn.1
  hötjuga_1_N = mkN "hötjuga" ; -- hötjuga..nn.1
  hötorgskonst_1_N = mkN "hötorgskonst" ; -- hötorgskonst..nn.1
  hötorgsmålning_1_N = mkN "hötorgsmålning" ; -- hötorgsmålning..nn.1
  hötork_1_N = mkN "hötork" ; -- hötork..nn.1
  hötta_1_V = mkV "hötta" "hötte" "höttat" ; -- hötta..vb.1
  höttande_1_N = mkN "höttande" ; -- höttande..nn.1
  hövding_1_N = mkN "hövding" ; -- hövding..nn.1
  hövdingadöme_1_N = mkN "hövdingadöme" ; -- hövdingadöme..nn.1
  hövdingasamhälle_1_N = mkN "hövdingasamhälle" ; -- hövdingasamhälle..nn.1
  hövdingedöme_1_N = mkN "hövdingedöme" ; -- hövdingedöme..nn.1
  hövisk_1_A = mkA "hövisk" ; -- hövisk..av.1
  höviskhet_1_N = mkN "höviskhet" "höviskheter" ; -- höviskhet..nn.1
  hövitsman_1_N = mkN "hövitsman" "hövitsmannen" "hövitsmän" "hövitsmännen" ; -- hövitsman..nn.1
  hövlig_1_A = mkA "hövlig" ; -- hövlig..av.1
  hövlighet_1_N = mkN "hövlighet" "hövligheter" ; -- hövlighet..nn.1
  hövlighetsfras_1_N = mkN "hövlighetsfras" "hövlighetsfraser" ; -- hövlighetsfras..nn.1
  hövlighetsvisit_1_N = mkN "hövlighetsvisit" "hövlighetsvisiter" ; -- hövlighetsvisit..nn.1
  hövolm_1_N = mkN "hövolm" ; -- hövolm..nn.1
  hövändare_1_N = mkN "hövändare" utrum  ; -- hövändare..nn.1
  hövålm_1_N = mkN "hövålm" ; -- hövålm..nn.1
  i_land_1_N = mkN "i-land" "i-landet" "i-länder" "i-länderna" ; -- i-land..nn.1
  i_1_N = mkN "i" neutrum  ; -- i..nn.1
  iPhone_1_N = mkN "iPhone" utrum  ; -- iPhone..nn.1
  iaktta_1_V = mkV "iakttaga" "iakttog" "iakttagit" ; -- iaktta..vb.1
  iakttagande_1_N = mkN "iakttagande" ; -- iakttagande..nn.1
  iakttagare_1_N = mkN "iakttagare" utrum  ; -- iakttagare..nn.1
  iakttagelse_1_N = mkN "iakttagelse" "iakttagelser" ; -- iakttagelse..nn.1
  iakttagelseförmåga_1_N = mkN "iakttagelseförmåga" ; -- iakttagelseförmåga..nn.1
  iallafall_1_Adv = mkAdv "iallafall" ; -- iallafall..ab.1
  iberisk_1_A = mkA "iberisk" ; -- iberisk..av.1
  ibero_amerikansk_1_A = mkA "ibero-amerikansk" ; -- ibero-amerikansk..av.1
  ibis_1_N = mkN "ibis" ; -- ibis..nn.1
  ibisfågel_1_N = mkN "ibisfågel" ; -- ibisfågel..nn.1
  ibisros_1_N = mkN "ibisros" "ibisrosor" ; -- ibisros..nn.1
  ibland_1_Adv = mkAdv "ibland" ; -- ibland..ab.1
  iblandning_1_N = mkN "iblandning" ; -- iblandning..nn.1
  ichtyolog_1_N = mkN "ichtyolog" "ichtyologer" ; -- ichtyolog..nn.1
  ichtyologi_1_N = mkN "ichtyologi" ; -- ichtyologi..nn.1
  ichtyologisk_1_A = mkA "ichtyologisk" ; -- ichtyologisk..av.1
  icing_1_N = mkN "icing" ; -- icing..nn.1
  icke_angreppspakt_1_N = mkN "icke-angreppspakt" "icke-angreppspakter" ; -- icke-angreppspakt..nn.1
  icke_darwinistisk_1_A = mkA "icke-darwinistisk" ; -- icke-darwinistisk..av.1
  icke_euklidisk_1_A = mkA "icke-euklidisk" ; -- icke-euklidisk..av.1
  icke_existerande_1_A = mkA "icke-existerande" ; -- icke-existerande..av.1
  icke_händelse_1_N = mkN "icke-händelse" "icke-händelser" ; -- icke-händelse..nn.1
  icke_individuell_1_A = mkA "icke-individuell" ; -- icke-individuell..av.1
  icke_kristen_1_A = mkA "icke-kristen" ; -- icke-kristen..av.1
  icke_kvinnlig_1_A = mkA "icke-kvinnlig" ; -- icke-kvinnlig..av.1
  icke_linjär_1_A = mkA "icke-linjär" ; -- icke-linjär..av.1
  icke_manlig_1_A = mkA "icke-manlig" ; -- icke-manlig..av.1
  icke_metall_1_N = mkN "icke-metall" "icke-metaller" ; -- icke-metall..nn.1
  icke_muslim_1_N = mkN "icke-muslim" "icke-muslimer" ; -- icke-muslim..nn.1
  icke_mänsklig_1_A = mkA "icke-mänsklig" ; -- icke-mänsklig..av.1
  icke_periodisk_1_A = mkA "icke-periodisk" ; -- icke-periodisk..av.1
  icke_politisk_1_A = mkA "icke-politisk" ; -- icke-politisk..av.1
  icke_religiös_1_A = mkA "icke-religiös" ; -- icke-religiös..av.1
  icke_rökare_1_N = mkN "icke-rökare" utrum  ; -- icke-rökare..nn.1
  icke_specialist_1_N = mkN "icke-specialist" "icke-specialister" ; -- icke-specialist..nn.1
  icke_spridningsavtal_1_N = mkN "icke-spridningsavtal" neutrum  ; -- icke-spridningsavtal..nn.1
  icke_svensk_1_A = mkA "icke-svensk" ; -- icke-svensk..av.1
  icke_symmetrisk_1_A = mkA "icke-symmetrisk" ; -- icke-symmetrisk..av.1
  icke_teknisk_1_A = mkA "icke-teknisk" ; -- icke-teknisk..av.1
  icke_verbal_1_A = mkA "icke-verbal" ; -- icke-verbal..av.1
  icke_våld_1_N = mkN "icke-våld" neutrum  ; -- icke-våld..nn.1
  ickedarwinistisk_1_A = mkA "ickedarwinistisk" ; -- ickedarwinistisk..av.1
  ickeeuklidisk_1_A = mkA "ickeeuklidisk" ; -- ickeeuklidisk..av.1
  ickeexisterande_1_A = mkA "ickeexisterande" ; -- ickeexisterande..av.1
  ickehändelse_1_N = mkN "ickehändelse" "ickehändelser" ; -- ickehändelse..nn.1
  ickeindividuell_1_A = mkA "ickeindividuell" ; -- ickeindividuell..av.1
  ickekristen_1_A = mkA "ickekristen" ; -- ickekristen..av.1
  ickekvinnlig_1_A = mkA "ickekvinnlig" ; -- ickekvinnlig..av.1
  ickelinjär_1_A = mkA "ickelinjär" ; -- ickelinjär..av.1
  ickemanlig_1_A = mkA "ickemanlig" ; -- ickemanlig..av.1
  ickemetall_1_N = mkN "ickemetall" "ickemetaller" ; -- ickemetall..nn.1
  ickemuslim_1_N = mkN "ickemuslim" "ickemuslimer" ; -- ickemuslim..nn.1
  ickemuslimsk_1_A = mkA "ickemuslimsk" ; -- ickemuslimsk..av.1
  ickemänsklig_1_A = mkA "ickemänsklig" ; -- ickemänsklig..av.1
  ickeperiodisk_1_A = mkA "ickeperiodisk" ; -- ickeperiodisk..av.1
  ickepolitisk_1_A = mkA "ickepolitisk" ; -- ickepolitisk..av.1
  ickereligiös_1_A = mkA "ickereligiös" ; -- ickereligiös..av.1
  ickerökare_1_N = mkN "ickerökare" utrum  ; -- ickerökare..nn.1
  ickespecialist_1_N = mkN "ickespecialist" "ickespecialister" ; -- ickespecialist..nn.1
  ickesvensk_1_A = mkA "ickesvensk" ; -- ickesvensk..av.1
  ickesymmetrisk_1_A = mkA "ickesymmetrisk" ; -- ickesymmetrisk..av.1
  icketeknisk_1_A = mkA "icketeknisk" ; -- icketeknisk..av.1
  ickeverbal_1_A = mkA "ickeverbal" ; -- ickeverbal..av.1
  ickevåld_1_N = mkN "ickevåld" neutrum  ; -- ickevåld..nn.1
  ickevåldsentusiast_1_N = mkN "ickevåldsentusiast" "ickevåldsentusiaster" ; -- ickevåldsentusiast..nn.1
  id_bricka_1_N = mkN "id-bricka" ; -- id-bricka..nn.1
  id_kort_1_N = mkN "id-kort" neutrum  ; -- id-kort..nn.1
  id_1_N = mkN "id" ; -- id..nn.1
  id_2_N = mkN "id" ; -- id..nn.2
  id_3_N = mkN "id" ; -- id..nn.3
  idag_1_Adv = mkAdv "idag" ; -- idag..ab.1
  ide_1_N = mkN "ide" ; -- ide..nn.1
  ideal_1_A = mkA "ideal" ; -- ideal..av.1
  ideal_1_N = mkN "ideal" neutrum  ; -- ideal..nn.1
  idealbild_1_N = mkN "idealbild" "idealbilder" ; -- idealbild..nn.1
  idealisera_1_V = mkV "idealiserar" ; -- idealisera..vb.1
  idealiserande_1_N = mkN "idealiserande" ; -- idealiserande..nn.1
  idealiserbar_1_A = mkA "idealiserbar" ; -- idealiserbar..av.1
  idealiserbarhet_1_N = mkN "idealiserbarhet" ; -- idealiserbarhet..nn.1
  idealisering_1_N = mkN "idealisering" ; -- idealisering..nn.1
  idealisk_1_A = mkA "idealisk" ; -- idealisk..av.1
  idealism_1_N = mkN "idealism" "idealismer" ; -- idealism..nn.1
  idealist_1_N = mkN "idealist" "idealister" ; -- idealist..nn.1
  idealistisk_1_A = mkA "idealistisk" ; -- idealistisk..av.1
  idealitet_1_N = mkN "idealitet" "idealiteter" ; -- idealitet..nn.1
  idealmänniska_1_N = mkN "idealmänniska" ; -- idealmänniska..nn.1
  idealsamhälle_1_N = mkN "idealsamhälle" ; -- idealsamhälle..nn.1
  idealstat_1_N = mkN "idealstat" "idealstater" ; -- idealstat..nn.1
  idealvärld_1_N = mkN "idealvärld" ; -- idealvärld..nn.1
  ideell_1_A = mkA "ideell" ; -- ideell..av.1
  idegran_1_N = mkN "idegran" ; -- idegran..nn.1
  idel_1_Adv = mkAdv "idel" ; -- idel..ab.1
  idelig_1_A = mkA "idelig" ; -- idelig..av.1
  ideligen_1_Adv = mkAdv "ideligen" ; -- ideligen..ab.1
  idelighet_1_N = mkN "idelighet" ; -- idelighet..nn.1
  identifiera_1_V = mkV "identifierar" ; -- identifiera..vb.1
  identifierande_1_N = mkN "identifierande" ; -- identifierande..nn.1
  identifierbar_1_A = mkA "identifierbar" ; -- identifierbar..av.1
  identifierbarhet_1_N = mkN "identifierbarhet" ; -- identifierbarhet..nn.1
  identifiering_1_N = mkN "identifiering" ; -- identifiering..nn.1
  identifikation_1_N = mkN "identifikation" ; -- identifikation..nn.1
  identifikationsprocess_1_N = mkN "identifikationsprocess" "identifikationsprocesser" ; -- identifikationsprocess..nn.1
  identifikatorisk_1_A = mkA "identifikatorisk" ; -- identifikatorisk..av.1
  identisk_1_A = mkA "identisk" ; -- identisk..av.1
  identitet_1_N = mkN "identitet" "identiteter" ; -- identitet..nn.1
  identitetsbricka_1_N = mkN "identitetsbricka" ; -- identitetsbricka..nn.1
  identitetsbyggare_1_N = mkN "identitetsbyggare" utrum  ; -- identitetsbyggare..nn.1
  identitetskort_1_N = mkN "identitetskort" neutrum  ; -- identitetskort..nn.1
  identitetskris_1_N = mkN "identitetskris" "identitetskriser" ; -- identitetskris..nn.1
  identitetsmässig_1_A = mkA "identitetsmässig" ; -- identitetsmässig..av.1
  identitetsskapande_1_A = mkA "identitetsskapande" ; -- identitetsskapande..av.1
  identitetssökande_1_A = mkA "identitetssökande" ; -- identitetssökande..av.1
  identitetssökande_1_N = mkN "identitetssökande" "identitetssökanden" "identitetssökanden" "identitetssökandena" ; -- identitetssökande..nn.1
  ideografi_1_N = mkN "ideografi" ; -- ideografi..nn.1
  ideografisk_1_A = mkA "ideografisk" ; -- ideografisk..av.1
  ideogram_1_N = mkN "ideogram" "ideogrammet" "ideogram" "ideogrammen" ; -- ideogram..nn.1
  ideolog_1_N = mkN "ideolog" "ideologer" ; -- ideolog..nn.1
  ideologi_1_N = mkN "ideologi" "ideologier" ; -- ideologi..nn.1
  ideologisk_1_A = mkA "ideologisk" ; -- ideologisk..av.1
  idiolekt_1_N = mkN "idiolekt" "idiolekter" ; -- idiolekt..nn.1
  idiom_1_N = mkN "idiom" neutrum  ; -- idiom..nn.1
  idiomatisk_1_A = mkA "idiomatisk" ; -- idiomatisk..av.1
  idiopati_1_N = mkN "idiopati" ; -- idiopati..nn.1
  idiopatisk_1_A = mkA "idiopatisk" ; -- idiopatisk..av.1
  idiosynkrasi_1_N = mkN "idiosynkrasi" "idiosynkrasier" ; -- idiosynkrasi..nn.1
  idiosynkratisk_1_A = mkA "idiosynkratisk" ; -- idiosynkratisk..av.1
  idiot_1_N = mkN "idiot" "idioter" ; -- idiot..nn.1
  idiotförklara_1_V = mkV "idiotförklarar" ; -- idiotförklara..vb.1
  idiotförklarande_1_N = mkN "idiotförklarande" ; -- idiotförklarande..nn.1
  idioti_1_N = mkN "idioti" "idiotier" ; -- idioti..nn.1
  idiotisk_1_A = mkA "idiotisk" ; -- idiotisk..av.1
  idiotsäker_1_A = mkA "idiotsäker" ; -- idiotsäker..av.1
  idiotsäkerhet_1_N = mkN "idiotsäkerhet" ; -- idiotsäkerhet..nn.1
  idissla_1_V = mkV "idisslar" ; -- idissla..vb.1
  idisslande_1_N = mkN "idisslande" ; -- idisslande..nn.1
  idisslare_1_N = mkN "idisslare" utrum  ; -- idisslare..nn.1
  idissling_1_N = mkN "idissling" ; -- idissling..nn.1
  idka_1_V = mkV "idkar" ; -- idka..vb.1
  idkande_1_N = mkN "idkande" ; -- idkande..nn.1
  idkare_1_N = mkN "idkare" utrum  ; -- idkare..nn.1
  ido_1_N = mkN "ido" ; -- ido..nn.1
  idog_1_A = mkA "idog" ; -- idog..av.1
  idoghet_1_N = mkN "idoghet" ; -- idoghet..nn.1
  idol_1_N = mkN "idol" "idoler" ; -- idol..nn.1
  idolporträtt_1_N = mkN "idolporträtt" neutrum  ; -- idolporträtt..nn.1
  idolskap_1_N = mkN "idolskap" neutrum  ; -- idolskap..nn.1
  idrott_1_N = mkN "idrott" "idrotter" ; -- idrott..nn.1
  idrotta_1_V = mkV "idrottar" ; -- idrotta..vb.1
  idrottande_1_N = mkN "idrottande" ; -- idrottande..nn.1
  idrottare_1_N = mkN "idrottare" utrum  ; -- idrottare..nn.1
  idrottsarena_1_N = mkN "idrottsarena" ; -- idrottsarena..nn.1
  idrottsbragd_1_N = mkN "idrottsbragd" "idrottsbragder" ; -- idrottsbragd..nn.1
  idrottsbröl_1_N = mkN "idrottsbröl" neutrum  ; -- idrottsbröl..nn.1
  idrottsdag_1_N = mkN "idrottsdag" ; -- idrottsdag..nn.1
  idrottsdräkt_1_N = mkN "idrottsdräkt" "idrottsdräkter" ; -- idrottsdräkt..nn.1
  idrottsförening_1_N = mkN "idrottsförening" ; -- idrottsförening..nn.1
  idrottsgren_1_N = mkN "idrottsgren" "idrottsgrenen" "idrottsgrenar" "idrottsgrenarna" ; -- idrottsgren..nn.1
  idrottsgymnasium_1_N = mkN "idrottsgymnasium" "idrottsgymnasiet" "idrottsgymnasier" "idrottsgymnasierna" ; -- idrottsgymnasium..nn.1
  idrottsgymnastik_1_N = mkN "idrottsgymnastik" ; -- idrottsgymnastik..nn.1
  idrottshall_1_N = mkN "idrottshall" ; -- idrottshall..nn.1
  idrottsintresserad_1_A = mkA "idrottsintresserad" ; -- idrottsintresserad..av.1
  idrottsklubb_1_N = mkN "idrottsklubb" ; -- idrottsklubb..nn.1
  idrottskompani_1_N = mkN "idrottskompani" "idrottskompaniet" "idrottskompanier" "idrottskompanierna" ; -- idrottskompani..nn.1
  idrottskvinna_1_N = mkN "idrottskvinna" ; -- idrottskvinna..nn.1
  idrottslag_1_N = mkN "idrottslag" neutrum  ; -- idrottslag..nn.1
  idrottsledare_1_N = mkN "idrottsledare" utrum  ; -- idrottsledare..nn.1
  idrottslig_1_A = mkA "idrottslig" ; -- idrottslig..av.1
  idrottslighet_1_N = mkN "idrottslighet" ; -- idrottslighet..nn.1
  idrottsläkare_1_N = mkN "idrottsläkare" utrum  ; -- idrottsläkare..nn.1
  idrottsman_1_N = mkN "idrottsman" "idrottsmannen" "idrottsmän" "idrottsmännen" ; -- idrottsman..nn.1
  idrottsmedicin_1_N = mkN "idrottsmedicin" ; -- idrottsmedicin..nn.1
  idrottsmässig_1_A = mkA "idrottsmässig" ; -- idrottsmässig..av.1
  idrottspark_1_N = mkN "idrottspark" "idrottsparker" ; -- idrottspark..nn.1
  idrottsplan_1_N = mkN "idrottsplan" "idrottsplaner" ; -- idrottsplan..nn.1
  idrottsplats_1_N = mkN "idrottsplats" "idrottsplatser" ; -- idrottsplats..nn.1
  idrottsprestation_1_N = mkN "idrottsprestation" ; -- idrottsprestation..nn.1
  idrottsreferat_1_N = mkN "idrottsreferat" neutrum  ; -- idrottsreferat..nn.1
  idrottsrörelse_1_N = mkN "idrottsrörelse" "idrottsrörelser" ; -- idrottsrörelse..nn.1
  idrottssko_1_N = mkN "idrottssko" "idrottsskor" ; -- idrottssko..nn.1
  idrottsstjärna_1_N = mkN "idrottsstjärna" ; -- idrottsstjärna..nn.1
  idrottstävling_1_N = mkN "idrottstävling" ; -- idrottstävling..nn.1
  idunsäpple_1_N = mkN "idunsäpple" ; -- idunsäpple..nn.1
  idyll_1_N = mkN "idyll" "idyller" ; -- idyll..nn.1
  idylliker_1_N = mkN "idylliker" "idyllikern" "idylliker" "idyllikerna" ; -- idylliker..nn.1
  idyllisk_1_A = mkA "idyllisk" ; -- idyllisk..av.1
  idé_1_N = mkN "idé" "idéer" ; -- idé..nn.1
  idéassociation_1_N = mkN "idéassociation" ; -- idéassociation..nn.1
  idébank_1_N = mkN "idébank" "idébanker" ; -- idébank..nn.1
  idédrama_1_N = mkN "idédrama" "idédramat" "idédramer" "idédramerna" ; -- idédrama..nn.1
  idéfattig_1_A = mkA "idéfattig" ; -- idéfattig..av.1
  idéfattigdom_1_N = mkN "idéfattigdom" ; -- idéfattigdom..nn.1
  idéfattighet_1_N = mkN "idéfattighet" ; -- idéfattighet..nn.1
  idéflykt_1_N = mkN "idéflykt" ; -- idéflykt..nn.1
  idégivare_1_N = mkN "idégivare" utrum  ; -- idégivare..nn.1
  idéhistoria_1_N = mkN "idéhistoria" ; -- idéhistoria..nn.1
  idéhistorisk_1_A = mkA "idéhistorisk" ; -- idéhistorisk..av.1
  idékläckning_1_N = mkN "idékläckning" ; -- idékläckning..nn.1
  idélära_1_N = mkN "idélära" ; -- idélära..nn.1
  idélära_2_N = mkN "idélära" ; -- idélära..nn.2
  idémässig_1_A = mkA "idémässig" ; -- idémässig..av.1
  idémöte_1_N = mkN "idémöte" ; -- idémöte..nn.1
  idérik_1_A = mkA "idérik" ; -- idérik..av.1
  idérikedom_1_N = mkN "idérikedom" ; -- idérikedom..nn.1
  idérikhet_1_N = mkN "idérikhet" ; -- idérikhet..nn.1
  idéspektrum_1_N = mkN "idéspektrum" neutrum  ; -- idéspektrum..nn.1
  idéspruta_1_N = mkN "idéspruta" ; -- idéspruta..nn.1
  idétorka_1_N = mkN "idétorka" ; -- idétorka..nn.1
  idévärld_1_N = mkN "idévärld" ; -- idévärld..nn.1
  ifatt_1_Adv = mkAdv "ifatt" ; -- ifatt..ab.1
  ifattsprungen_1_A = mkA "ifattsprungen" ; -- ifattsprungen..av.1
  ifrågakomma_1_V = mkV "ifrågakomma" "ifrågakom" "ifrågakommit" ; -- ifrågakomma..vb.1
  ifrågakommande_1_N = mkN "ifrågakommande" ; -- ifrågakommande..nn.1
  ifrågasätta_1_V = mkV "ifrågasätta" "ifrågasätter" "ifrågasätt" "ifrågasatte" "ifrågasatt" "ifrågasatt" ; -- ifrågasätta..vb.1
  ifrågasättande_1_N = mkN "ifrågasättande" ; -- ifrågasättande..nn.1
  ifrågavarande_1_A = mkA "ifrågavarande" ; -- ifrågavarande..av.1
  ifrånsprungen_1_A = mkA "ifrånsprungen" ; -- ifrånsprungen..av.1
  ifyllnadsprov_1_N = mkN "ifyllnadsprov" neutrum  ; -- ifyllnadsprov..nn.1
  ifyllning_1_N = mkN "ifyllning" ; -- ifyllning..nn.1
  ifärd_1_A = mkA "ifärd" ; -- ifärd..av.1
  iförd_1_A = mkA "iförd" "ifört" ; -- iförd..av.1
  igel_1_N = mkN "igel" ; -- igel..nn.1
  igelkott_1_N = mkN "igelkott" ; -- igelkott..nn.1
  igelkottsförsvar_1_N = mkN "igelkottsförsvar" neutrum  ; -- igelkottsförsvar..nn.1
  igen_1_Adv = mkAdv "igen" ; -- igen..ab.1
  igenbommad_1_A = mkA "igenbommad" ; -- igenbommad..av.1
  igenfyllning_1_N = mkN "igenfyllning" ; -- igenfyllning..nn.1
  igengrodd_1_A = mkA "igengrodd" ; -- igengrodd..av.1
  igenkorkad_1_A = mkA "igenkorkad" ; -- igenkorkad..av.1
  igenkänna_1_V = mkV "igenkänna" "igenkände" "igenkänt" ; -- igenkänna..vb.1
  igenkännande_1_A = mkA "igenkännande" ; -- igenkännande..av.1
  igenkännande_1_N = mkN "igenkännande" ; -- igenkännande..nn.1
  igenkännbar_1_A = mkA "igenkännbar" ; -- igenkännbar..av.1
  igenkänning_1_N = mkN "igenkänning" ; -- igenkänning..nn.1
  igenkänningsfaktor_1_N = mkN "igenkänningsfaktor" "igenkänningsfaktorer" ; -- igenkänningsfaktor..nn.1
  igenkänningssignal_1_N = mkN "igenkänningssignal" "igenkänningssignaler" ; -- igenkänningssignal..nn.1
  igenkänningstecken_1_N = mkN "igenkänningstecken" "igenkänningstecknet" "igenkänningstecken" "igenkänningstecknen" ; -- igenkänningstecken..nn.1
  igenkännlig_1_A = mkA "igenkännlig" ; -- igenkännlig..av.1
  igenkännlighet_1_N = mkN "igenkännlighet" ; -- igenkännlighet..nn.1
  igenmulen_1_A = mkA "igenmulen" ; -- igenmulen..av.1
  igenmurad_1_A = mkA "igenmurad" ; -- igenmurad..av.1
  igenmurning_1_N = mkN "igenmurning" ; -- igenmurning..nn.1
  igensnöad_1_A = mkA "igensnöad" ; -- igensnöad..av.1
  igenstoppning_1_N = mkN "igenstoppning" ; -- igenstoppning..nn.1
  igenstängning_1_N = mkN "igenstängning" ; -- igenstängning..nn.1
  igensätta_1_V = mkV "igensätta" "igensätter" "igensätt" "igensatte" "igensatt" "igensatt" ; -- igensätta..vb.1
  igensättande_1_N = mkN "igensättande" ; -- igensättande..nn.1
  igensättning_1_N = mkN "igensättning" ; -- igensättning..nn.1
  igentäppning_1_N = mkN "igentäppning" ; -- igentäppning..nn.1
  igenvuxen_1_A = mkA "igenvuxen" ; -- igenvuxen..av.1
  igenväxt_1_A = mkA "igenväxt" "igenväxt" ; -- igenväxt..av.1
  iglo_1_N = mkN "iglo" "iglon" "iglosar" "iglosarna" ; -- iglo..nn.1
  igloo_1_N = mkN "igloo" "igloon" "igloosar" "igloosarna" ; -- igloo..nn.1
  ignorans_1_N = mkN "ignorans" ; -- ignorans..nn.1
  ignorant_1_A = mkA "ignorant" "ignorant" ; -- ignorant..av.1
  ignorant_1_N = mkN "ignorant" "ignoranter" ; -- ignorant..nn.1
  ignorera_1_V = mkV "ignorerar" ; -- ignorera..vb.1
  ignorerande_1_N = mkN "ignorerande" ; -- ignorerande..nn.1
  ignorerbar_1_A = mkA "ignorerbar" ; -- ignorerbar..av.1
  ignorerbarhet_1_N = mkN "ignorerbarhet" ; -- ignorerbarhet..nn.1
  ignorering_1_N = mkN "ignorering" ; -- ignorering..nn.1
  igångsätta_1_V = mkV "igångsätta" "igångsätter" "igångsätt" "igångsatte" "igångsatt" "igångsatt" ; -- igångsätta..vb.1
  igångsättande_1_N = mkN "igångsättande" ; -- igångsättande..nn.1
  igångsättning_1_N = mkN "igångsättning" ; -- igångsättning..nn.1
  igår_1_Adv = mkAdv "igår" ; -- igår..ab.1
  ihjälskjuten_1_A = mkA "ihjälskjuten" ; -- ihjälskjuten..av.1
  ihjälskrämd_1_A = mkA "ihjälskrämd" "ihjälskrämt" ; -- ihjälskrämd..av.1
  ihjälslagen_1_A = mkA "ihjälslagen" ; -- ihjälslagen..av.1
  ihjältrampad_1_A = mkA "ihjältrampad" ; -- ihjältrampad..av.1
  ihopbuntande_1_N = mkN "ihopbuntande" ; -- ihopbuntande..nn.1
  ihopfällbar_1_A = mkA "ihopfällbar" ; -- ihopfällbar..av.1
  ihopfällbarhet_1_N = mkN "ihopfällbarhet" ; -- ihopfällbarhet..nn.1
  ihopfälld_1_A = mkA "ihopfälld" "ihopfällt" ; -- ihopfälld..av.1
  ihopklistrad_1_A = mkA "ihopklistrad" ; -- ihopklistrad..av.1
  ihopknycklande_1_N = mkN "ihopknycklande" ; -- ihopknycklande..nn.1
  ihopkopplande_1_N = mkN "ihopkopplande" ; -- ihopkopplande..nn.1
  ihopkrupen_1_A = mkA "ihopkrupen" ; -- ihopkrupen..av.1
  ihopkurad_1_A = mkA "ihopkurad" ; -- ihopkurad..av.1
  ihoplagd_1_A = mkA "ihoplagd" "ihoplagt" ; -- ihoplagd..av.1
  ihoppackande_1_N = mkN "ihoppackande" ; -- ihoppackande..nn.1
  ihopskjutande_1_N = mkN "ihopskjutande" ; -- ihopskjutande..nn.1
  ihärdig_1_A = mkA "ihärdig" ; -- ihärdig..av.1
  ihärdighet_1_N = mkN "ihärdighet" ; -- ihärdighet..nn.1
  ihågkomma_1_V = mkV "ihågkomma" "ihågkom" "ihågkommit" ; -- ihågkomma..vb.1
  ihågkommande_1_N = mkN "ihågkommande" ; -- ihågkommande..nn.1
  ihågkomst_1_N = mkN "ihågkomst" "ihågkomster" ; -- ihågkomst..nn.1
  ihålig_1_A = mkA "ihålig" ; -- ihålig..av.1
  ihålighet_1_N = mkN "ihålighet" "ihåligheter" ; -- ihålighet..nn.1
  ihållande_1_A = mkA "ihållande" ; -- ihållande..av.1
  ihållig_1_A = mkA "ihållig" ; -- ihållig..av.1
  ihållighet_1_N = mkN "ihållighet" ; -- ihållighet..nn.1
  ikat_1_N = mkN "ikat" ; -- ikat..nn.1
  iklä_1_V = mkV "iklä" "iklädde" "iklätt" ; -- iklä..vb.1
  iklädande_1_N = mkN "iklädande" ; -- iklädande..nn.1
  ikon_1_N = mkN "ikon" "ikoner" ; -- ikon..nn.1
  ikonisk_1_A = mkA "ikonisk" ; -- ikonisk..av.1
  ikonografi_1_N = mkN "ikonografi" ; -- ikonografi..nn.1
  ikonostas_1_N = mkN "ikonostas" "ikonostaser" ; -- ikonostas..nn.1
  ikosaeder_1_N = mkN "ikosaeder" ; -- ikosaeder..nn.1
  iktus_1_N = mkN "iktus" "iktus" "iktus" "iktusen" ; -- iktus..nn.1
  iktyolog_1_N = mkN "iktyolog" "iktyologer" ; -- iktyolog..nn.1
  iktyologi_1_N = mkN "iktyologi" ; -- iktyologi..nn.1
  iktyologisk_1_A = mkA "iktyologisk" ; -- iktyologisk..av.1
  il_1_N = mkN "il" ; -- il..nn.1
  ila_1_V = mkV "ilar" ; -- ila..vb.1
  ilande_1_N = mkN "ilande" ; -- ilande..nn.1
  ilandfluten_1_A = mkA "ilandfluten" ; -- ilandfluten..av.1
  ilandsätta_1_V = mkV "ilandsätta" "ilandsätter" "ilandsätt" "ilandsatte" "ilandsatt" "ilandsatt" ; -- ilandsätta..vb.1
  ilandsättande_1_N = mkN "ilandsättande" ; -- ilandsättande..nn.1
  ilastning_1_N = mkN "ilastning" ; -- ilastning..nn.1
  ilbud_1_N = mkN "ilbud" neutrum  ; -- ilbud..nn.1
  ilex_1_N = mkN "ilex" ; -- ilex..nn.1
  ilfart_1_N = mkN "ilfart" ; -- ilfart..nn.1
  ilgods_1_N = mkN "ilgods" neutrum  ; -- ilgods..nn.1
  ilig_1_A = mkA "ilig" ; -- ilig..av.1
  illa_1_Adv = mkAdv "illa" ; -- illa..ab.1
  illaluktande_1_A = mkA "illaluktande" ; -- illaluktande..av.1
  illamående_1_A = mkA "illamående" ; -- illamående..av.1
  illamående_1_N = mkN "illamående" ; -- illamående..nn.1
  illasinnad_1_A = mkA "illasinnad" ; -- illasinnad..av.1
  illasittande_1_A = mkA "illasittande" ; -- illasittande..av.1
  illasmakande_1_A = mkA "illasmakande" ; -- illasmakande..av.1
  illavarslande_1_A = mkA "illavarslande" ; -- illavarslande..av.1
  illavulen_1_A = mkA "illavulen" ; -- illavulen..av.1
  illavulenhet_1_N = mkN "illavulenhet" ; -- illavulenhet..nn.1
  illbatting_1_N = mkN "illbatting" ; -- illbatting..nn.1
  illdåd_1_N = mkN "illdåd" neutrum  ; -- illdåd..nn.1
  illegal_1_A = mkA "illegal" ; -- illegal..av.1
  illegalitet_1_N = mkN "illegalitet" "illegaliteter" ; -- illegalitet..nn.1
  illegitim_1_A = mkA "illegitim" ; -- illegitim..av.1
  illegitimitet_1_N = mkN "illegitimitet" "illegitimiteter" ; -- illegitimitet..nn.1
  iller_1_N = mkN "iller" ; -- iller..nn.1
  illfundig_1_A = mkA "illfundig" ; -- illfundig..av.1
  illfundighet_1_N = mkN "illfundighet" ; -- illfundighet..nn.1
  illgul_1_A = mkA "illgul" ; -- illgul..av.1
  illgärning_1_N = mkN "illgärning" ; -- illgärning..nn.1
  illgärningsman_1_N = mkN "illgärningsman" "illgärningsmannen" "illgärningsmän" "illgärningsmännen" ; -- illgärningsman..nn.1
  illistig_1_A = mkA "illistig" ; -- illistig..av.1
  illistighet_1_N = mkN "illistighet" ; -- illistighet..nn.1
  illitterat_1_A = mkA "illitterat" "illitterat" ; -- illitterat..av.1
  illmarig_1_A = mkA "illmarig" ; -- illmarig..av.1
  illmarighet_1_N = mkN "illmarighet" ; -- illmarighet..nn.1
  illojal_1_A = mkA "illojal" ; -- illojal..av.1
  illojalitet_1_N = mkN "illojalitet" "illojaliteter" ; -- illojalitet..nn.1
  illparig_1_A = mkA "illparig" ; -- illparig..av.1
  illparighet_1_N = mkN "illparighet" ; -- illparighet..nn.1
  illröd_1_A = mkA "illröd" "illrött" ; -- illröd..av.1
  illslug_1_A = mkA "illslug" ; -- illslug..av.1
  illslughet_1_N = mkN "illslughet" "illslugheter" ; -- illslughet..nn.1
  illtjut_1_N = mkN "illtjut" neutrum  ; -- illtjut..nn.1
  illtjuta_1_V = mkV "illtjuta" "illtjöt" "illtjutit" ; -- illtjuta..vb.1
  illtjutande_1_N = mkN "illtjutande" ; -- illtjutande..nn.1
  illudera_1_V = mkV "illuderar" ; -- illudera..vb.1
  illuderande_1_N = mkN "illuderande" ; -- illuderande..nn.1
  illudering_1_N = mkN "illudering" ; -- illudering..nn.1
  illumination_1_N = mkN "illumination" ; -- illumination..nn.1
  illuminera_1_V = mkV "illuminerar" ; -- illuminera..vb.1
  illuminerande_1_N = mkN "illuminerande" ; -- illuminerande..nn.1
  illuminerbar_1_A = mkA "illuminerbar" ; -- illuminerbar..av.1
  illuminerbarhet_1_N = mkN "illuminerbarhet" ; -- illuminerbarhet..nn.1
  illuminering_1_N = mkN "illuminering" ; -- illuminering..nn.1
  illusion_1_N = mkN "illusion" ; -- illusion..nn.1
  illusionist_1_N = mkN "illusionist" "illusionister" ; -- illusionist..nn.1
  illusionsfri_1_A = mkA "illusionsfri" "illusionsfritt" ; -- illusionsfri..av.1
  illusionslös_1_A = mkA "illusionslös" ; -- illusionslös..av.1
  illusionslöshet_1_N = mkN "illusionslöshet" "illusionslösheter" ; -- illusionslöshet..nn.1
  illusionsnummer_1_N = mkN "illusionsnummer" neutrum  ; -- illusionsnummer..nn.1
  illusorisk_1_A = mkA "illusorisk" ; -- illusorisk..av.1
  illuster_1_A = mkA "illuster" ; -- illuster..av.1
  illustration_1_N = mkN "illustration" ; -- illustration..nn.1
  illustrativ_1_A = mkA "illustrativ" ; -- illustrativ..av.1
  illustratör_1_N = mkN "illustratör" "illustratörer" ; -- illustratör..nn.1
  illustrera_1_V = mkV "illustrerar" ; -- illustrera..vb.1
  illustrerande_1_N = mkN "illustrerande" ; -- illustrerande..nn.1
  illustrerbar_1_A = mkA "illustrerbar" ; -- illustrerbar..av.1
  illustrerbarhet_1_N = mkN "illustrerbarhet" ; -- illustrerbarhet..nn.1
  illustrering_1_N = mkN "illustrering" ; -- illustrering..nn.1
  illvilja_1_N = mkN "illvilja" ; -- illvilja..nn.1
  illvillig_1_A = mkA "illvillig" ; -- illvillig..av.1
  illvillighet_1_N = mkN "illvillighet" "illvilligheter" ; -- illvillighet..nn.1
  illvrål_1_N = mkN "illvrål" neutrum  ; -- illvrål..nn.1
  illvråla_1_V = mkV "illvrålar" ; -- illvråla..vb.1
  illvrålande_1_N = mkN "illvrålande" ; -- illvrålande..nn.1
  illyr_1_N = mkN "illyr" "illyrer" ; -- illyr..nn.1
  illyrisk_1_A = mkA "illyrisk" ; -- illyrisk..av.1
  ilmarsch_1_N = mkN "ilmarsch" "ilmarscher" ; -- ilmarsch..nn.1
  ilning_1_N = mkN "ilning" ; -- ilning..nn.1
  ilsamtal_1_N = mkN "ilsamtal" neutrum  ; -- ilsamtal..nn.1
  ilsk_1_A = mkA "ilsk" ; -- ilsk..av.1
  ilska_1_N = mkN "ilska" ; -- ilska..nn.1
  ilsken_1_A = mkA "ilsken" ; -- ilsken..av.1
  ilskenhet_1_N = mkN "ilskenhet" ; -- ilskenhet..nn.1
  ilskhet_1_N = mkN "ilskhet" ; -- ilskhet..nn.1
  iläggssula_1_N = mkN "iläggssula" ; -- iläggssula..nn.1
  image_1_N = mkN "image" utrum  ; -- image..nn.1
  imagemässig_1_A = mkA "imagemässig" ; -- imagemässig..av.1
  imaginär_1_A = mkA "imaginär" ; -- imaginär..av.1
  imam_1_N = mkN "imam" "imamer" ; -- imam..nn.1
  imbecill_1_A = mkA "imbecill" ; -- imbecill..av.1
  imbecillhet_1_N = mkN "imbecillhet" ; -- imbecillhet..nn.1
  imitation_1_N = mkN "imitation" ; -- imitation..nn.1
  imitativ_1_A = mkA "imitativ" ; -- imitativ..av.1
  imitatör_1_N = mkN "imitatör" "imitatörer" ; -- imitatör..nn.1
  imitera_1_V = mkV "imiterar" ; -- imitera..vb.1
  imiterande_1_N = mkN "imiterande" ; -- imiterande..nn.1
  imiterbar_1_A = mkA "imiterbar" ; -- imiterbar..av.1
  imiterbarhet_1_N = mkN "imiterbarhet" ; -- imiterbarhet..nn.1
  imitering_1_N = mkN "imitering" ; -- imitering..nn.1
  imma_1_N = mkN "imma" ; -- imma..nn.1
  imma_1_V = mkV "immar" ; -- imma..vb.1
  immande_1_N = mkN "immande" ; -- immande..nn.1
  immanens_1_N = mkN "immanens" ; -- immanens..nn.1
  immanent_1_A = mkA "immanent" "immanent" ; -- immanent..av.1
  immaterialitet_1_N = mkN "immaterialitet" ; -- immaterialitet..nn.1
  immaterialrätt_1_N = mkN "immaterialrätt" ; -- immaterialrätt..nn.1
  immateriell_1_A = mkA "immateriell" ; -- immateriell..av.1
  immatrikulation_1_N = mkN "immatrikulation" ; -- immatrikulation..nn.1
  immatrikulera_1_V = mkV "immatrikulerar" ; -- immatrikulera..vb.1
  immatrikulerande_1_N = mkN "immatrikulerande" ; -- immatrikulerande..nn.1
  immatrikulerbar_1_A = mkA "immatrikulerbar" ; -- immatrikulerbar..av.1
  immatrikulerbarhet_1_N = mkN "immatrikulerbarhet" ; -- immatrikulerbarhet..nn.1
  immatrikulering_1_N = mkN "immatrikulering" ; -- immatrikulering..nn.1
  immig_1_A = mkA "immig" ; -- immig..av.1
  immighet_1_N = mkN "immighet" ; -- immighet..nn.1
  immigrant_1_N = mkN "immigrant" "immigranter" ; -- immigrant..nn.1
  immigration_1_N = mkN "immigration" ; -- immigration..nn.1
  immigrera_1_V = mkV "immigrerar" ; -- immigrera..vb.1
  immigrerande_1_N = mkN "immigrerande" ; -- immigrerande..nn.1
  immigrerbar_1_A = mkA "immigrerbar" ; -- immigrerbar..av.1
  immigrerbarhet_1_N = mkN "immigrerbarhet" ; -- immigrerbarhet..nn.1
  immigrering_1_N = mkN "immigrering" ; -- immigrering..nn.1
  immission_1_N = mkN "immission" ; -- immission..nn.1
  immobil_1_A = mkA "immobil" ; -- immobil..av.1
  immun_1_A = mkA "immun" ; -- immun..av.1
  immunbrist_1_N = mkN "immunbrist" "immunbrister" ; -- immunbrist..nn.1
  immunbristsjukdom_1_N = mkN "immunbristsjukdom" ; -- immunbristsjukdom..nn.1
  immunförsvar_1_N = mkN "immunförsvar" neutrum  ; -- immunförsvar..nn.1
  immunisera_1_V = mkV "immuniserar" ; -- immunisera..vb.1
  immuniserande_1_N = mkN "immuniserande" ; -- immuniserande..nn.1
  immuniserbar_1_A = mkA "immuniserbar" ; -- immuniserbar..av.1
  immuniserbarhet_1_N = mkN "immuniserbarhet" ; -- immuniserbarhet..nn.1
  immunisering_1_N = mkN "immunisering" ; -- immunisering..nn.1
  immunitet_1_N = mkN "immunitet" "immuniteter" ; -- immunitet..nn.1
  immunolog_1_N = mkN "immunolog" "immunologer" ; -- immunolog..nn.1
  immunologi_1_N = mkN "immunologi" ; -- immunologi..nn.1
  immunologisk_1_A = mkA "immunologisk" ; -- immunologisk..av.1
  immunsystem_1_N = mkN "immunsystem" neutrum  ; -- immunsystem..nn.1
  immunsystemrubbning_1_N = mkN "immunsystemrubbning" ; -- immunsystemrubbning..nn.1
  imorgon_1_Adv = mkAdv "imorgon" ; -- imorgon..ab.1
  imorse_1_Adv = mkAdv "imorse" ; -- imorse..ab.1
  impa_1_V = mkV "impar" ; -- impa..vb.1
  impande_1_N = mkN "impande" ; -- impande..nn.1
  impedans_1_N = mkN "impedans" ; -- impedans..nn.1
  impediment_1_N = mkN "impediment" neutrum  ; -- impediment..nn.1
  imperativ_1_N = mkN "imperativ" "imperativer" ; -- imperativ..nn.1
  imperativ_2_N = mkN "imperativ" neutrum  ; -- imperativ..nn.2
  imperativisk_1_A = mkA "imperativisk" ; -- imperativisk..av.1
  imperator_1_N = mkN "imperator" "imperatorer" ; -- imperator..nn.1
  imperatorisk_1_A = mkA "imperatorisk" ; -- imperatorisk..av.1
  imperfektum_1_N = mkN "imperfektum" "imperfektum" "imperfekter" "imperfekterna" ; -- imperfektum..nn.1
  imperialformat_1_N = mkN "imperialformat" neutrum  ; -- imperialformat..nn.1
  imperialism_1_N = mkN "imperialism" "imperialismer" ; -- imperialism..nn.1
  imperialist_1_N = mkN "imperialist" "imperialister" ; -- imperialist..nn.1
  imperialistisk_1_A = mkA "imperialistisk" ; -- imperialistisk..av.1
  imperialoktav_1_N = mkN "imperialoktav" "imperialoktaver" ; -- imperialoktav..nn.1
  imperialsäng_1_N = mkN "imperialsäng" ; -- imperialsäng..nn.1
  imperiekrig_1_N = mkN "imperiekrig" neutrum  ; -- imperiekrig..nn.1
  imperium_1_N = mkN "imperium" "imperiet" "imperier" "imperierna" ; -- imperium..nn.1
  impertinens_1_N = mkN "impertinens" "impertinenser" ; -- impertinens..nn.1
  impertinent_1_A = mkA "impertinent" "impertinent" ; -- impertinent..av.1
  impetigo_1_N = mkN "impetigo" ; -- impetigo..nn.1
  implantat_1_N = mkN "implantat" neutrum  ; -- implantat..nn.1
  implantera_1_V = mkV "implanterar" ; -- implantera..vb.1
  implanterande_1_N = mkN "implanterande" ; -- implanterande..nn.1
  implanterbar_1_A = mkA "implanterbar" ; -- implanterbar..av.1
  implanterbarhet_1_N = mkN "implanterbarhet" ; -- implanterbarhet..nn.1
  implementera_1_V = mkV "implementerar" ; -- implementera..vb.1
  implementerande_1_N = mkN "implementerande" ; -- implementerande..nn.1
  implementerbar_1_A = mkA "implementerbar" ; -- implementerbar..av.1
  implementerbarhet_1_N = mkN "implementerbarhet" ; -- implementerbarhet..nn.1
  implementering_1_N = mkN "implementering" ; -- implementering..nn.1
  implicera_1_V = mkV "implicerar" ; -- implicera..vb.1
  implicerande_1_N = mkN "implicerande" ; -- implicerande..nn.1
  implicerbar_1_A = mkA "implicerbar" ; -- implicerbar..av.1
  implicerbarhet_1_N = mkN "implicerbarhet" ; -- implicerbarhet..nn.1
  implicering_1_N = mkN "implicering" ; -- implicering..nn.1
  implicit_1_A = mkA "implicit" "implicit" ; -- implicit..av.1
  implicithet_1_N = mkN "implicithet" ; -- implicithet..nn.1
  implikation_1_N = mkN "implikation" ; -- implikation..nn.1
  implodera_1_V = mkV "imploderar" ; -- implodera..vb.1
  imploderande_1_N = mkN "imploderande" ; -- imploderande..nn.1
  imploderbar_1_A = mkA "imploderbar" ; -- imploderbar..av.1
  imploderbarhet_1_N = mkN "imploderbarhet" ; -- imploderbarhet..nn.1
  implodering_1_N = mkN "implodering" ; -- implodering..nn.1
  implosion_1_N = mkN "implosion" ; -- implosion..nn.1
  imponera_1_V = mkV "imponerar" ; -- imponera..vb.1
  imponerande_1_A = mkA "imponerande" ; -- imponerande..av.1
  imponerande_1_N = mkN "imponerande" ; -- imponerande..nn.1
  imponerbar_1_A = mkA "imponerbar" ; -- imponerbar..av.1
  imponerbarhet_1_N = mkN "imponerbarhet" ; -- imponerbarhet..nn.1
  imponering_1_N = mkN "imponering" ; -- imponering..nn.1
  impopularitet_1_N = mkN "impopularitet" "impopulariteter" ; -- impopularitet..nn.1
  impopulär_1_A = mkA "impopulär" ; -- impopulär..av.1
  import_1_N = mkN "import" "importer" ; -- import..nn.1
  importavgift_1_N = mkN "importavgift" "importavgifter" ; -- importavgift..nn.1
  importera_1_V = mkV "importerar" ; -- importera..vb.1
  importerande_1_N = mkN "importerande" ; -- importerande..nn.1
  importerbar_1_A = mkA "importerbar" ; -- importerbar..av.1
  importerbarhet_1_N = mkN "importerbarhet" ; -- importerbarhet..nn.1
  importering_1_N = mkN "importering" ; -- importering..nn.1
  importfirma_1_N = mkN "importfirma" ; -- importfirma..nn.1
  importförbud_1_N = mkN "importförbud" neutrum  ; -- importförbud..nn.1
  importkvot_1_N = mkN "importkvot" "importkvoter" ; -- importkvot..nn.1
  importstopp_1_N = mkN "importstopp" neutrum  ; -- importstopp..nn.1
  importör_1_N = mkN "importör" "importörer" ; -- importör..nn.1
  imposant_1_A = mkA "imposant" "imposant" ; -- imposant..av.1
  impost_1_N = mkN "impost" "imposter" ; -- impost..nn.1
  imposttull_1_N = mkN "imposttull" ; -- imposttull..nn.1
  impotens_1_N = mkN "impotens" ; -- impotens..nn.1
  impotent_1_A = mkA "impotent" "impotent" ; -- impotent..av.1
  impregnera_1_V = mkV "impregnerar" ; -- impregnera..vb.1
  impregnerande_1_N = mkN "impregnerande" ; -- impregnerande..nn.1
  impregnerbar_1_A = mkA "impregnerbar" ; -- impregnerbar..av.1
  impregnerbarhet_1_N = mkN "impregnerbarhet" ; -- impregnerbarhet..nn.1
  impregnering_1_N = mkN "impregnering" ; -- impregnering..nn.1
  impressario_1_N = mkN "impressario" "impressarion" "impressarier" "impressarierna" ; -- impressario..nn.1
  impressionism_1_N = mkN "impressionism" "impressionismer" ; -- impressionism..nn.1
  impressionist_1_N = mkN "impressionist" "impressionister" ; -- impressionist..nn.1
  impressionistisk_1_A = mkA "impressionistisk" ; -- impressionistisk..av.1
  imprimatur_1_N = mkN "imprimatur" ; -- imprimatur..nn.1
  improduktiv_1_A = mkA "improduktiv" ; -- improduktiv..av.1
  improduktivitet_1_N = mkN "improduktivitet" ; -- improduktivitet..nn.1
  impromptu_1_N = mkN "impromptu" "impromptut" "impromptun" "impromptuna" ; -- impromptu..nn.1
  improvisation_1_N = mkN "improvisation" ; -- improvisation..nn.1
  improvisationsförmåga_1_N = mkN "improvisationsförmåga" ; -- improvisationsförmåga..nn.1
  improvisationsteknik_1_N = mkN "improvisationsteknik" "improvisationstekniker" ; -- improvisationsteknik..nn.1
  improvisatorisk_1_A = mkA "improvisatorisk" ; -- improvisatorisk..av.1
  improvisatör_1_N = mkN "improvisatör" "improvisatörer" ; -- improvisatör..nn.1
  improvisera_1_V = mkV "improviserar" ; -- improvisera..vb.1
  improviserande_1_N = mkN "improviserande" ; -- improviserande..nn.1
  improviserbar_1_A = mkA "improviserbar" ; -- improviserbar..av.1
  improviserbarhet_1_N = mkN "improviserbarhet" ; -- improviserbarhet..nn.1
  improvisering_1_N = mkN "improvisering" ; -- improvisering..nn.1
  impuls_1_N = mkN "impuls" "impulser" ; -- impuls..nn.1
  impulsiv_1_A = mkA "impulsiv" ; -- impulsiv..av.1
  impulsivitet_1_N = mkN "impulsivitet" "impulsiviteter" ; -- impulsivitet..nn.1
  impulskontroll_1_N = mkN "impulskontroll" ; -- impulskontroll..nn.1
  impulsköp_1_N = mkN "impulsköp" neutrum  ; -- impulsköp..nn.1
  impulsstyrd_1_A = mkA "impulsstyrd" "impulsstyrt" ; -- impulsstyrd..av.1
  imruta_1_N = mkN "imruta" ; -- imruta..nn.1
  imrör_1_N = mkN "imrör" neutrum  ; -- imrör..nn.1
  imskydd_1_N = mkN "imskydd" neutrum  ; -- imskydd..nn.1
  inackordera_1_V = mkV "inackorderar" ; -- inackordera..vb.1
  inackorderande_1_N = mkN "inackorderande" ; -- inackorderande..nn.1
  inackorderbar_1_A = mkA "inackorderbar" ; -- inackorderbar..av.1
  inackorderbarhet_1_N = mkN "inackorderbarhet" ; -- inackorderbarhet..nn.1
  inackordering_1_N = mkN "inackordering" ; -- inackordering..nn.1
  inackorderingshem_1_N = mkN "inackorderingshem" "inackorderingshemmet" "inackorderingshem" "inackorderingshemmen" ; -- inackorderingshem..nn.1
  inadekvat_1_A = mkA "inadekvat" "inadekvat" ; -- inadekvat..av.1
  inadvertens_1_N = mkN "inadvertens" "inadvertenser" ; -- inadvertens..nn.1
  inaktiv_1_A = mkA "inaktiv" ; -- inaktiv..av.1
  inaktivera_1_V = mkV "inaktiverar" ; -- inaktivera..vb.1
  inaktiverande_1_N = mkN "inaktiverande" ; -- inaktiverande..nn.1
  inaktiverbar_1_A = mkA "inaktiverbar" ; -- inaktiverbar..av.1
  inaktiverbarhet_1_N = mkN "inaktiverbarhet" ; -- inaktiverbarhet..nn.1
  inaktivering_1_N = mkN "inaktivering" ; -- inaktivering..nn.1
  inaktivitet_1_N = mkN "inaktivitet" "inaktiviteter" ; -- inaktivitet..nn.1
  inaktuell_1_A = mkA "inaktuell" ; -- inaktuell..av.1
  inalles_1_Adv = mkAdv "inalles" ; -- inalles..ab.1
  inandning_1_N = mkN "inandning" ; -- inandning..nn.1
  inarbeta_1_V = mkV "inarbetar" ; -- inarbeta..vb.1
  inarbetande_1_N = mkN "inarbetande" ; -- inarbetande..nn.1
  inaskad_1_A = mkA "inaskad" ; -- inaskad..av.1
  inatt_1_Adv = mkAdv "inatt" ; -- inatt..ab.1
  inauguration_1_N = mkN "inauguration" ; -- inauguration..nn.1
  inaugurera_1_V = mkV "inaugurerar" ; -- inaugurera..vb.1
  inaugurerande_1_N = mkN "inaugurerande" ; -- inaugurerande..nn.1
  inaugurerbar_1_A = mkA "inaugurerbar" ; -- inaugurerbar..av.1
  inaugurerbarhet_1_N = mkN "inaugurerbarhet" ; -- inaugurerbarhet..nn.1
  inaugurering_1_N = mkN "inaugurering" ; -- inaugurering..nn.1
  inavel_1_N = mkN "inavel" ; -- inavel..nn.1
  inbaka_1_V = mkV "inbakar" ; -- inbaka..vb.1
  inbakad_1_A = mkA "inbakad" ; -- inbakad..av.1
  inbakande_1_N = mkN "inbakande" ; -- inbakande..nn.1
  inbegrepp_1_N = mkN "inbegrepp" neutrum  ; -- inbegrepp..nn.1
  inbegripa_1_V = mkV "inbegripa" "inbegrep" "inbegripit" ; -- inbegripa..vb.1
  inbegripande_1_N = mkN "inbegripande" ; -- inbegripande..nn.1
  inbegripen_1_A = mkA "inbegripen" ; -- inbegripen..av.1
  inberäkna_1_V = mkV "inberäknar" ; -- inberäkna..vb.1
  inberäknande_1_N = mkN "inberäknande" ; -- inberäknande..nn.1
  inberäkning_1_N = mkN "inberäkning" ; -- inberäkning..nn.1
  inbespara_1_V = mkV "inbesparar" ; -- inbespara..vb.1
  inbesparande_1_N = mkN "inbesparande" ; -- inbesparande..nn.1
  inbesparing_1_N = mkN "inbesparing" ; -- inbesparing..nn.1
  inbetala_1_V = mkV "inbetalar" ; -- inbetala..vb.1
  inbetalande_1_N = mkN "inbetalande" ; -- inbetalande..nn.1
  inbetalning_1_N = mkN "inbetalning" ; -- inbetalning..nn.1
  inbetalningskort_1_N = mkN "inbetalningskort" neutrum  ; -- inbetalningskort..nn.1
  inbilla_1_V = mkV "inbillar" ; -- inbilla..vb.1
  inbillande_1_N = mkN "inbillande" ; -- inbillande..nn.1
  inbillning_1_N = mkN "inbillning" ; -- inbillning..nn.1
  inbillningsfoster_1_N = mkN "inbillningsfoster" neutrum  ; -- inbillningsfoster..nn.1
  inbillningssjuk_1_A = mkA "inbillningssjuk" ; -- inbillningssjuk..av.1
  inbillningssjuka_1_N = mkN "inbillningssjuka" ; -- inbillningssjuka..nn.1
  inbillningssjukhet_1_N = mkN "inbillningssjukhet" ; -- inbillningssjukhet..nn.1
  inbilsk_1_A = mkA "inbilsk" ; -- inbilsk..av.1
  inbilskhet_1_N = mkN "inbilskhet" "inbilskheter" ; -- inbilskhet..nn.1
  inbindning_1_N = mkN "inbindning" ; -- inbindning..nn.1
  inbiten_1_A = mkA "inbiten" ; -- inbiten..av.1
  inbitenhet_1_N = mkN "inbitenhet" ; -- inbitenhet..nn.1
  inbjuda_1_V = mkV "inbjuda" "inbjöd" "inbjudit" ; -- inbjuda..vb.1
  inbjudande_1_A = mkA "inbjudande" ; -- inbjudande..av.1
  inbjudare_1_N = mkN "inbjudare" utrum  ; -- inbjudare..nn.1
  inbjudning_1_N = mkN "inbjudning" ; -- inbjudning..nn.1
  inbjudningskort_1_N = mkN "inbjudningskort" neutrum  ; -- inbjudningskort..nn.1
  inbjudningsskrift_1_N = mkN "inbjudningsskrift" "inbjudningsskrifter" ; -- inbjudningsskrift..nn.1
  inblanda_1_V = mkV "inblandar" ; -- inblanda..vb.1
  inblandad_1_A = mkA "inblandad" ; -- inblandad..av.1
  inblandning_1_N = mkN "inblandning" ; -- inblandning..nn.1
  inblick_1_N = mkN "inblick" ; -- inblick..nn.1
  inblåsning_1_N = mkN "inblåsning" ; -- inblåsning..nn.1
  inbogsering_1_N = mkN "inbogsering" ; -- inbogsering..nn.1
  inbokad_1_A = mkA "inbokad" ; -- inbokad..av.1
  inbokning_1_N = mkN "inbokning" ; -- inbokning..nn.1
  inbringa_1_V = mkV "inbringar" ; -- inbringa..vb.1
  inbringande_1_A = mkA "inbringande" ; -- inbringande..av.1
  inbringande_1_N = mkN "inbringande" ; -- inbringande..nn.1
  inbromsning_1_N = mkN "inbromsning" ; -- inbromsning..nn.1
  inbrott_1_N = mkN "inbrott" neutrum  ; -- inbrott..nn.1
  inbrottstjuv_1_N = mkN "inbrottstjuv" ; -- inbrottstjuv..nn.1
  inbrytning_1_N = mkN "inbrytning" ; -- inbrytning..nn.1
  inbuktning_1_N = mkN "inbuktning" ; -- inbuktning..nn.1
  inbunden_1_A = mkA "inbunden" ; -- inbunden..av.1
  inbundenhet_1_N = mkN "inbundenhet" ; -- inbundenhet..nn.1
  inburning_1_N = mkN "inburning" ; -- inburning..nn.1
  inbygga_1_V = mkV "inbygger" ; -- inbygga..vb.1
  inbyggande_1_N = mkN "inbyggande" ; -- inbyggande..nn.1
  inbyggare_1_N = mkN "inbyggare" utrum  ; -- inbyggare..nn.1
  inbyggd_1_A = mkA "inbyggd" "inbyggt" ; -- inbyggd..av.1
  inbyte_1_N = mkN "inbyte" ; -- inbyte..nn.1
  inbäddad_1_A = mkA "inbäddad" ; -- inbäddad..av.1
  inbäddning_1_N = mkN "inbäddning" ; -- inbäddning..nn.1
  inbördes_1_A = mkA "inbördes" ; -- inbördes..av.1
  inbördeskrig_1_N = mkN "inbördeskrig" neutrum  ; -- inbördeskrig..nn.1
  incabär_1_N = mkN "incabär" neutrum  ; -- incabär..nn.1
  incest_1_N = mkN "incest" ; -- incest..nn.1
  incestuös_1_A = mkA "incestuös" ; -- incestuös..av.1
  incheckning_1_N = mkN "incheckning" ; -- incheckning..nn.1
  incheckningsdisk_1_N = mkN "incheckningsdisk" ; -- incheckningsdisk..nn.1
  incident_1_N = mkN "incident" "incidenter" ; -- incident..nn.1
  incidentberedskap_1_N = mkN "incidentberedskap" ; -- incidentberedskap..nn.1
  incitament_1_N = mkN "incitament" neutrum  ; -- incitament..nn.1
  indefinit_1_A = mkA "indefinit" "indefinit" ; -- indefinit..av.1
  indefinithet_1_N = mkN "indefinithet" ; -- indefinithet..nn.1
  indela_1_V = mkV "indelar" ; -- indela..vb.1
  indelande_1_N = mkN "indelande" ; -- indelande..nn.1
  indelning_1_N = mkN "indelning" ; -- indelning..nn.1
  indelningsgrund_1_N = mkN "indelningsgrund" "indelningsgrunder" ; -- indelningsgrund..nn.1
  indelningsprincip_1_N = mkN "indelningsprincip" "indelningsprinciper" ; -- indelningsprincip..nn.1
  indelningsverk_1_N = mkN "indelningsverk" neutrum  ; -- indelningsverk..nn.1
  indelt_1_A = mkA "indelt" "indelt" ; -- indelt..av.1
  independent_1_N = mkN "independent" "independenter" ; -- independent..nn.1
  indeterminism_1_N = mkN "indeterminism" ; -- indeterminism..nn.1
  indeterminist_1_N = mkN "indeterminist" "indeterminister" ; -- indeterminist..nn.1
  indeterministisk_1_A = mkA "indeterministisk" ; -- indeterministisk..av.1
  index_1_N = mkN "index" neutrum  ; -- index..nn.1
  indexavtal_1_N = mkN "indexavtal" neutrum  ; -- indexavtal..nn.1
  indexera_1_V = mkV "indexerar" ; -- indexera..vb.1
  indexerande_1_N = mkN "indexerande" ; -- indexerande..nn.1
  indexerbar_1_A = mkA "indexerbar" ; -- indexerbar..av.1
  indexerbarhet_1_N = mkN "indexerbarhet" ; -- indexerbarhet..nn.1
  indexering_1_N = mkN "indexering" ; -- indexering..nn.1
  indexreglera_1_V = mkV "indexreglerar" ; -- indexreglera..vb.1
  indexreglerande_1_N = mkN "indexreglerande" ; -- indexreglerande..nn.1
  indexreglerbar_1_A = mkA "indexreglerbar" ; -- indexreglerbar..av.1
  indexreglerbarhet_1_N = mkN "indexreglerbarhet" ; -- indexreglerbarhet..nn.1
  indexreglering_1_N = mkN "indexreglering" ; -- indexreglering..nn.1
  indexsiffra_1_N = mkN "indexsiffra" ; -- indexsiffra..nn.1
  indian_1_N = mkN "indian" "indianer" ; -- indian..nn.1
  indianbok_1_N = mkN "indianbok" "indianböcker" ; -- indianbok..nn.1
  indianfolk_1_N = mkN "indianfolk" neutrum  ; -- indianfolk..nn.1
  indianhydda_1_N = mkN "indianhydda" ; -- indianhydda..nn.1
  indianhövding_1_N = mkN "indianhövding" ; -- indianhövding..nn.1
  indiankvinna_1_N = mkN "indiankvinna" ; -- indiankvinna..nn.1
  indianliknande_1_A = mkA "indianliknande" ; -- indianliknande..av.1
  indianliv_1_N = mkN "indianliv" neutrum  ; -- indianliv..nn.1
  indianreservat_1_N = mkN "indianreservat" neutrum  ; -- indianreservat..nn.1
  indiansk_1_A = mkA "indiansk" ; -- indiansk..av.1
  indianska_1_N = mkN "indianska" ; -- indianska..nn.1
  indiansommar_1_N = mkN "indiansommar" "indiansommaren" "indiansomrar" "indiansomrarna" ; -- indiansommar..nn.1
  indianstam_1_N = mkN "indianstam" "indianstammen" "indianstammar" "indianstammarna" ; -- indianstam..nn.1
  indiantjut_1_N = mkN "indiantjut" neutrum  ; -- indiantjut..nn.1
  indicera_1_V = mkV "indicerar" ; -- indicera..vb.1
  indicerande_1_N = mkN "indicerande" ; -- indicerande..nn.1
  indicerbar_1_A = mkA "indicerbar" ; -- indicerbar..av.1
  indicerbarhet_1_N = mkN "indicerbarhet" ; -- indicerbarhet..nn.1
  indicering_1_N = mkN "indicering" ; -- indicering..nn.1
  indicium_1_N = mkN "indicium" "indiciet" "indicier" "indicierna" ; -- indicium..nn.1
  indiemusik_1_N = mkN "indiemusik" ; -- indiemusik..nn.1
  indier_1_N = mkN "indier" "indiern" "indier" "indierna" ; -- indier..nn.1
  indierock_1_N = mkN "indierock" ; -- indierock..nn.1
  indifferens_1_N = mkN "indifferens" ; -- indifferens..nn.1
  indifferent_1_A = mkA "indifferent" "indifferent" ; -- indifferent..av.1
  indifferentism_1_N = mkN "indifferentism" "indifferentismer" ; -- indifferentism..nn.1
  indigenatsrätt_1_N = mkN "indigenatsrätt" ; -- indigenatsrätt..nn.1
  indigestion_1_N = mkN "indigestion" ; -- indigestion..nn.1
  indignation_1_N = mkN "indignation" ; -- indignation..nn.1
  indignationslitteratur_1_N = mkN "indignationslitteratur" ; -- indignationslitteratur..nn.1
  indignerad_1_A = mkA "indignerad" ; -- indignerad..av.1
  indigo_1_N = mkN "indigo" ; -- indigo..nn.1
  indigoblå_1_A = mkA "indigoblå" "indigoblått" ; -- indigoblå..av.1
  indigofärg_1_N = mkN "indigofärg" "indigofärger" ; -- indigofärg..nn.1
  indigokarmin_1_N = mkN "indigokarmin" ; -- indigokarmin..nn.1
  indikation_1_N = mkN "indikation" ; -- indikation..nn.1
  indikativ_1_A = mkA "indikativ" ; -- indikativ..av.1
  indikativ_1_N = mkN "indikativ" "indikativer" ; -- indikativ..nn.1
  indikativform_1_N = mkN "indikativform" "indikativformer" ; -- indikativform..nn.1
  indikator_1_N = mkN "indikator" "indikatorer" ; -- indikator..nn.1
  indikatorlampa_1_N = mkN "indikatorlampa" ; -- indikatorlampa..nn.1
  indikera_1_V = mkV "indikerar" ; -- indikera..vb.1
  indikerande_1_N = mkN "indikerande" ; -- indikerande..nn.1
  indikerbar_1_A = mkA "indikerbar" ; -- indikerbar..av.1
  indikerbarhet_1_N = mkN "indikerbarhet" ; -- indikerbarhet..nn.1
  indikering_1_N = mkN "indikering" ; -- indikering..nn.1
  indirekt_1_A = mkA "indirekt" "indirekt" ; -- indirekt..av.1
  indirekthet_1_N = mkN "indirekthet" ; -- indirekthet..nn.1
  indisk_1_A = mkA "indisk" ; -- indisk..av.1
  indiska_1_N = mkN "indiska" ; -- indiska..nn.1
  indiskret_1_A = mkA "indiskret" "indiskret" ; -- indiskret..av.1
  indiskrethet_1_N = mkN "indiskrethet" ; -- indiskrethet..nn.1
  indiskretion_1_N = mkN "indiskretion" ; -- indiskretion..nn.1
  indisponerad_1_A = mkA "indisponerad" ; -- indisponerad..av.1
  indisponibel_1_A = mkA "indisponibel" ; -- indisponibel..av.1
  indisposition_1_N = mkN "indisposition" ; -- indisposition..nn.1
  indisputabel_1_A = mkA "indisputabel" "indisputabelt" ; -- indisputabel..av.1
  indium_1_N = mkN "indium" neutrum  ; -- indium..nn.1
  individ_1_N = mkN "individ" neutrum  ; -- individ..nn.1
  individakt_1_N = mkN "individakt" "individakter" ; -- individakt..nn.1
  individanpassad_1_A = mkA "individanpassad" ; -- individanpassad..av.1
  individcentrerad_1_A = mkA "individcentrerad" ; -- individcentrerad..av.1
  individrelaterad_1_A = mkA "individrelaterad" ; -- individrelaterad..av.1
  individualisera_1_V = mkV "individualiserar" ; -- individualisera..vb.1
  individualiserande_1_N = mkN "individualiserande" ; -- individualiserande..nn.1
  individualiserbar_1_A = mkA "individualiserbar" ; -- individualiserbar..av.1
  individualiserbarhet_1_N = mkN "individualiserbarhet" ; -- individualiserbarhet..nn.1
  individualisering_1_N = mkN "individualisering" ; -- individualisering..nn.1
  individualism_1_N = mkN "individualism" "individualismer" ; -- individualism..nn.1
  individualist_1_N = mkN "individualist" "individualister" ; -- individualist..nn.1
  individualistisk_1_A = mkA "individualistisk" ; -- individualistisk..av.1
  individualitet_1_N = mkN "individualitet" "individualiteter" ; -- individualitet..nn.1
  individualprevention_1_N = mkN "individualprevention" ; -- individualprevention..nn.1
  individualpsykologi_1_N = mkN "individualpsykologi" ; -- individualpsykologi..nn.1
  individuell_1_A = mkA "individuell" ; -- individuell..av.1
  indoarisk_1_A = mkA "indoarisk" ; -- indoarisk..av.1
  indoeuropeisk_1_A = mkA "indoeuropeisk" ; -- indoeuropeisk..av.1
  indoeuropé_1_N = mkN "indoeuropé" "indoeuropéer" ; -- indoeuropé..nn.1
  indokinesisk_1_A = mkA "indokinesisk" ; -- indokinesisk..av.1
  indoktrinera_1_V = mkV "indoktrinerar" ; -- indoktrinera..vb.1
  indoktrinerande_1_N = mkN "indoktrinerande" ; -- indoktrinerande..nn.1
  indoktrinerbar_1_A = mkA "indoktrinerbar" ; -- indoktrinerbar..av.1
  indoktrinerbarhet_1_N = mkN "indoktrinerbarhet" ; -- indoktrinerbarhet..nn.1
  indoktrinering_1_N = mkN "indoktrinering" ; -- indoktrinering..nn.1
  indoktrineringskurs_1_N = mkN "indoktrineringskurs" "indoktrineringskurser" ; -- indoktrineringskurs..nn.1
  indolens_1_N = mkN "indolens" ; -- indolens..nn.1
  indolent_1_A = mkA "indolent" "indolent" ; -- indolent..av.1
  indolog_1_N = mkN "indolog" "indologer" ; -- indolog..nn.1
  indologi_1_N = mkN "indologi" ; -- indologi..nn.1
  indones_1_N = mkN "indones" "indoneser" ; -- indones..nn.1
  indonesisk_1_A = mkA "indonesisk" ; -- indonesisk..av.1
  indonesiska_1_N = mkN "indonesiska" ; -- indonesiska..nn.1
  indonesiska_2_N = mkN "indonesiska" ; -- indonesiska..nn.2
  indra_1_V = mkV "indraga" "indrog" "indragit" ; -- indra..vb.1
  indrag_1_N = mkN "indrag" neutrum  ; -- indrag..nn.1
  indragande_1_N = mkN "indragande" ; -- indragande..nn.1
  indragen_1_A = mkA "indragen" ; -- indragen..av.1
  indragenhet_1_N = mkN "indragenhet" ; -- indragenhet..nn.1
  indragning_1_N = mkN "indragning" ; -- indragning..nn.1
  indriva_1_V = mkV "indriva" "indrev" "indrivit" ; -- indriva..vb.1
  indrivande_1_N = mkN "indrivande" ; -- indrivande..nn.1
  indrivning_1_N = mkN "indrivning" ; -- indrivning..nn.1
  indräktig_1_A = mkA "indräktig" ; -- indräktig..av.1
  indräktighet_1_N = mkN "indräktighet" ; -- indräktighet..nn.1
  indränka_1_V = mkV "indränker" ; -- indränka..vb.1
  indränkande_1_N = mkN "indränkande" ; -- indränkande..nn.1
  indränkning_1_N = mkN "indränkning" ; -- indränkning..nn.1
  inducera_1_V = mkV "inducerar" ; -- inducera..vb.1
  inducerande_1_N = mkN "inducerande" ; -- inducerande..nn.1
  inducerbar_1_A = mkA "inducerbar" ; -- inducerbar..av.1
  inducerbarhet_1_N = mkN "inducerbarhet" ; -- inducerbarhet..nn.1
  inducering_1_N = mkN "inducering" ; -- inducering..nn.1
  induktans_1_N = mkN "induktans" ; -- induktans..nn.1
  induktion_1_N = mkN "induktion" ; -- induktion..nn.1
  induktionsapparat_1_N = mkN "induktionsapparat" "induktionsapparater" ; -- induktionsapparat..nn.1
  induktionsbevis_1_N = mkN "induktionsbevis" neutrum  ; -- induktionsbevis..nn.1
  induktionsmotor_1_N = mkN "induktionsmotor" "induktionsmotorer" ; -- induktionsmotor..nn.1
  induktionsspole_1_N = mkN "induktionsspole" utrum  ; -- induktionsspole..nn.1
  induktiv_1_A = mkA "induktiv" ; -- induktiv..av.1
  induktor_1_N = mkN "induktor" "induktorer" ; -- induktor..nn.1
  indunsta_1_V = mkV "indunstar" ; -- indunsta..vb.1
  indunstande_1_N = mkN "indunstande" ; -- indunstande..nn.1
  indunstning_1_N = mkN "indunstning" ; -- indunstning..nn.1
  industri_1_N = mkN "industri" "industrier" ; -- industri..nn.1
  industriaktie_1_N = mkN "industriaktie" "industriaktier" ; -- industriaktie..nn.1
  industrialisera_1_V = mkV "industrialiserar" ; -- industrialisera..vb.1
  industrialiserande_1_N = mkN "industrialiserande" ; -- industrialiserande..nn.1
  industrialiserbar_1_A = mkA "industrialiserbar" ; -- industrialiserbar..av.1
  industrialiserbarhet_1_N = mkN "industrialiserbarhet" ; -- industrialiserbarhet..nn.1
  industrialisering_1_N = mkN "industrialisering" ; -- industrialisering..nn.1
  industrialism_1_N = mkN "industrialism" "industrialismer" ; -- industrialism..nn.1
  industrialistisk_1_A = mkA "industrialistisk" ; -- industrialistisk..av.1
  industriarbetare_1_N = mkN "industriarbetare" utrum  ; -- industriarbetare..nn.1
  industridiamant_1_N = mkN "industridiamant" "industridiamanter" ; -- industridiamant..nn.1
  industridöd_1_N = mkN "industridöd" ; -- industridöd..nn.1
  industriell_1_A = mkA "industriell" ; -- industriell..av.1
  industriförbund_1_N = mkN "industriförbund" neutrum  ; -- industriförbund..nn.1
  industriföretag_1_N = mkN "industriföretag" neutrum  ; -- industriföretag..nn.1
  industriland_1_N = mkN "industriland" "industrilandet" "industriländer" "industriländerna" ; -- industriland..nn.1
  industrilokal_1_N = mkN "industrilokal" "industrilokaler" ; -- industrilokal..nn.1
  industriminister_1_N = mkN "industriminister" ; -- industriminister..nn.1
  industrimässig_1_A = mkA "industrimässig" ; -- industrimässig..av.1
  industriolja_1_N = mkN "industriolja" ; -- industriolja..nn.1
  industriolycka_1_N = mkN "industriolycka" ; -- industriolycka..nn.1
  industriområde_1_N = mkN "industriområde" ; -- industriområde..nn.1
  industripolitik_1_N = mkN "industripolitik" ; -- industripolitik..nn.1
  industripolitisk_1_A = mkA "industripolitisk" ; -- industripolitisk..av.1
  industriprodukt_1_N = mkN "industriprodukt" "industriprodukter" ; -- industriprodukt..nn.1
  industriregion_1_N = mkN "industriregion" ; -- industriregion..nn.1
  industrirobot_1_N = mkN "industrirobot" ; -- industrirobot..nn.1
  industrisamhälle_1_N = mkN "industrisamhälle" ; -- industrisamhälle..nn.1
  industrisemester_1_N = mkN "industrisemester" ; -- industrisemester..nn.1
  industrispionage_1_N = mkN "industrispionage" ; -- industrispionage..nn.1
  industrizon_1_N = mkN "industrizon" "industrizoner" ; -- industrizon..nn.1
  ineffektiv_1_A = mkA "ineffektiv" ; -- ineffektiv..av.1
  inert_1_A = mkA "inert" "inert" ; -- inert..av.1
  inessiv_1_N = mkN "inessiv" "inessiver" ; -- inessiv..nn.1
  inexakt_1_A = mkA "inexakt" "inexakt" ; -- inexakt..av.1
  inexakthet_1_N = mkN "inexakthet" ; -- inexakthet..nn.1
  infall_1_N = mkN "infall" neutrum  ; -- infall..nn.1
  infalla_1_V = mkV "infalla" "inföll" "infallit" ; -- infalla..vb.1
  infallande_1_N = mkN "infallande" ; -- infallande..nn.1
  infallen_1_A = mkA "infallen" ; -- infallen..av.1
  infallsrik_1_A = mkA "infallsrik" ; -- infallsrik..av.1
  infallsrikhet_1_N = mkN "infallsrikhet" ; -- infallsrikhet..nn.1
  infallsvinkel_1_N = mkN "infallsvinkel" ; -- infallsvinkel..nn.1
  infam_1_A = mkA "infam" ; -- infam..av.1
  infami_1_N = mkN "infami" "infamier" ; -- infami..nn.1
  infant_1_N = mkN "infant" "infanter" ; -- infant..nn.1
  infanteri_1_N = mkN "infanteri" neutrum  ; -- infanteri..nn.1
  infanterikompani_1_N = mkN "infanterikompani" "infanterikompaniet" "infanterikompanier" "infanterikompanierna" ; -- infanterikompani..nn.1
  infanterimarsch_1_N = mkN "infanterimarsch" "infanterimarscher" ; -- infanterimarsch..nn.1
  infanterispade_1_N = mkN "infanterispade" utrum  ; -- infanterispade..nn.1
  infanterist_1_N = mkN "infanterist" "infanterister" ; -- infanterist..nn.1
  infantil_1_A = mkA "infantil" ; -- infantil..av.1
  infantilisera_1_V = mkV "infantiliserar" ; -- infantilisera..vb.1
  infantiliserande_1_N = mkN "infantiliserande" ; -- infantiliserande..nn.1
  infantiliserbar_1_A = mkA "infantiliserbar" ; -- infantiliserbar..av.1
  infantiliserbarhet_1_N = mkN "infantiliserbarhet" ; -- infantiliserbarhet..nn.1
  infantilisering_1_N = mkN "infantilisering" ; -- infantilisering..nn.1
  infantilism_1_N = mkN "infantilism" "infantilismer" ; -- infantilism..nn.1
  infantinna_1_N = mkN "infantinna" ; -- infantinna..nn.1
  infarkt_1_N = mkN "infarkt" "infarkter" ; -- infarkt..nn.1
  infart_1_N = mkN "infart" "infarter" ; -- infart..nn.1
  infartsled_1_N = mkN "infartsled" "infartsleder" ; -- infartsled..nn.1
  infartsport_1_N = mkN "infartsport" ; -- infartsport..nn.1
  infartsränna_1_N = mkN "infartsränna" ; -- infartsränna..nn.1
  infartsväg_1_N = mkN "infartsväg" ; -- infartsväg..nn.1
  infatta_1_V = mkV "infattar" ; -- infatta..vb.1
  infattande_1_N = mkN "infattande" ; -- infattande..nn.1
  infattning_1_N = mkN "infattning" ; -- infattning..nn.1
  infektera_1_V = mkV "infekterar" ; -- infektera..vb.1
  infekterande_1_N = mkN "infekterande" ; -- infekterande..nn.1
  infekterbar_1_A = mkA "infekterbar" ; -- infekterbar..av.1
  infekterbarhet_1_N = mkN "infekterbarhet" ; -- infekterbarhet..nn.1
  infektering_1_N = mkN "infektering" ; -- infektering..nn.1
  infektion_1_N = mkN "infektion" ; -- infektion..nn.1
  infektionshärd_1_N = mkN "infektionshärd" ; -- infektionshärd..nn.1
  infektionssjukdom_1_N = mkN "infektionssjukdom" ; -- infektionssjukdom..nn.1
  infektiös_1_A = mkA "infektiös" ; -- infektiös..av.1
  infernalisk_1_A = mkA "infernalisk" ; -- infernalisk..av.1
  inferno_1_N = mkN "inferno" "infernot" "infernon" "infernona" ; -- inferno..nn.1
  infernokris_1_N = mkN "infernokris" ; -- infernokris..nn.1
  infertil_1_A = mkA "infertil" ; -- infertil..av.1
  infertilitet_1_N = mkN "infertilitet" ; -- infertilitet..nn.1
  infetta_1_V = mkV "infettar" ; -- infetta..vb.1
  infettande_1_N = mkN "infettande" ; -- infettande..nn.1
  infiltration_1_N = mkN "infiltration" ; -- infiltration..nn.1
  infiltratör_1_N = mkN "infiltratör" "infiltratörer" ; -- infiltratör..nn.1
  infiltrera_1_V = mkV "infiltrerar" ; -- infiltrera..vb.1
  infiltrerande_1_N = mkN "infiltrerande" ; -- infiltrerande..nn.1
  infiltrerbar_1_A = mkA "infiltrerbar" ; -- infiltrerbar..av.1
  infiltrerbarhet_1_N = mkN "infiltrerbarhet" ; -- infiltrerbarhet..nn.1
  infiltrering_1_N = mkN "infiltrering" ; -- infiltrering..nn.1
  infinit_1_A = mkA "infinit" "infinit" ; -- infinit..av.1
  infinithet_1_N = mkN "infinithet" ; -- infinithet..nn.1
  infinitiv_1_N = mkN "infinitiv" "infinitiver" ; -- infinitiv..nn.1
  infinitivmärke_1_N = mkN "infinitivmärke" ; -- infinitivmärke..nn.1
  infix_1_N = mkN "infix" neutrum  ; -- infix..nn.1
  inflammation_1_N = mkN "inflammation" ; -- inflammation..nn.1
  inflammationshärd_1_N = mkN "inflammationshärd" ; -- inflammationshärd..nn.1
  inflammatorisk_1_A = mkA "inflammatorisk" ; -- inflammatorisk..av.1
  inflammera_1_V = mkV "inflammerar" ; -- inflammera..vb.1
  inflammerad_1_A = mkA "inflammerad" ; -- inflammerad..av.1
  inflammerande_1_N = mkN "inflammerande" ; -- inflammerande..nn.1
  inflammerbar_1_A = mkA "inflammerbar" ; -- inflammerbar..av.1
  inflammerbarhet_1_N = mkN "inflammerbarhet" ; -- inflammerbarhet..nn.1
  inflammering_1_N = mkN "inflammering" ; -- inflammering..nn.1
  inflation_1_N = mkN "inflation" ; -- inflation..nn.1
  inflationistisk_1_A = mkA "inflationistisk" ; -- inflationistisk..av.1
  inflationsdrivande_1_A = mkA "inflationsdrivande" ; -- inflationsdrivande..av.1
  inflationsfas_1_N = mkN "inflationsfas" "inflationsfaser" ; -- inflationsfas..nn.1
  inflationshot_1_N = mkN "inflationshot" neutrum  ; -- inflationshot..nn.1
  inflationsmodell_1_N = mkN "inflationsmodell" "inflationsmodeller" ; -- inflationsmodell..nn.1
  inflationsmål_1_N = mkN "inflationsmål" neutrum  ; -- inflationsmål..nn.1
  inflationsskydd_1_N = mkN "inflationsskydd" neutrum  ; -- inflationsskydd..nn.1
  inflationsspiral_1_N = mkN "inflationsspiral" "inflationsspiraler" ; -- inflationsspiral..nn.1
  inflationstakt_1_N = mkN "inflationstakt" "inflationstakter" ; -- inflationstakt..nn.1
  inflationsteori_1_N = mkN "inflationsteori" "inflationsteorier" ; -- inflationsteori..nn.1
  inflatorisk_1_A = mkA "inflatorisk" ; -- inflatorisk..av.1
  inflicka_1_V = mkV "inflickar" ; -- inflicka..vb.1
  inflickande_1_N = mkN "inflickande" ; -- inflickande..nn.1
  inflickning_1_N = mkN "inflickning" ; -- inflickning..nn.1
  inflika_1_V = mkV "inflikar" ; -- inflika..vb.1
  inflikande_1_N = mkN "inflikande" ; -- inflikande..nn.1
  influens_1_N = mkN "influens" "influenser" ; -- influens..nn.1
  influensa_1_N = mkN "influensa" ; -- influensa..nn.1
  influensadödsfall_1_N = mkN "influensadödsfall" neutrum  ; -- influensadödsfall..nn.1
  influensafall_1_N = mkN "influensafall" neutrum  ; -- influensafall..nn.1
  influensaliknande_1_A = mkA "influensaliknande" ; -- influensaliknande..av.1
  influensamedicin_1_N = mkN "influensamedicin" "influensamediciner" ; -- influensamedicin..nn.1
  influensmaskin_1_N = mkN "influensmaskin" "influensmaskiner" ; -- influensmaskin..nn.1
  influera_1_V = mkV "influerar" ; -- influera..vb.1
  influerande_1_N = mkN "influerande" ; -- influerande..nn.1
  influerbar_1_A = mkA "influerbar" ; -- influerbar..av.1
  influerbarhet_1_N = mkN "influerbarhet" ; -- influerbarhet..nn.1
  influering_1_N = mkN "influering" ; -- influering..nn.1
  inflygning_1_N = mkN "inflygning" ; -- inflygning..nn.1
  inflyta_1_V = mkV "inflyta" "inflöt" "influtit" ; -- inflyta..vb.1
  inflytande_1_N = mkN "inflytande" ; -- inflytande..nn.1
  inflytelse_1_N = mkN "inflytelse" "inflytelser" ; -- inflytelse..nn.1
  inflytelserik_1_A = mkA "inflytelserik" ; -- inflytelserik..av.1
  inflytelserikhet_1_N = mkN "inflytelserikhet" ; -- inflytelserikhet..nn.1
  inflytta_1_V = mkV "inflyttar" ; -- inflytta..vb.1
  inflyttande_1_N = mkN "inflyttande" ; -- inflyttande..nn.1
  inflyttning_1_N = mkN "inflyttning" ; -- inflyttning..nn.1
  inflyttningsklar_1_A = mkA "inflyttningsklar" ; -- inflyttningsklar..av.1
  infläta_1_V = mkV "inflätar" ; -- infläta..vb.1
  inflätande_1_N = mkN "inflätande" ; -- inflätande..nn.1
  inflätning_1_N = mkN "inflätning" ; -- inflätning..nn.1
  inflöde_1_N = mkN "inflöde" ; -- inflöde..nn.1
  info_1_N = mkN "info" ; -- info..nn.1
  infodra_1_V = mkV "infodrar" ; -- infodra..vb.1
  infodrande_1_N = mkN "infodrande" ; -- infodrande..nn.1
  infoga_1_V = mkV "infogar" ; -- infoga..vb.1
  infogande_1_N = mkN "infogande" ; -- infogande..nn.1
  infogning_1_N = mkN "infogning" ; -- infogning..nn.1
  infordra_1_V = mkV "infordrar" ; -- infordra..vb.1
  infordrande_1_N = mkN "infordrande" ; -- infordrande..nn.1
  infordring_1_N = mkN "infordring" ; -- infordring..nn.1
  informant_1_N = mkN "informant" "informanter" ; -- informant..nn.1
  information_1_N = mkN "information" ; -- information..nn.1
  informationsansvarig_1_A = mkA "informationsansvarig" ; -- informationsansvarig..av.1
  informationsbehandling_1_N = mkN "informationsbehandling" ; -- informationsbehandling..nn.1
  informationsbehandlingssystem_1_N = mkN "informationsbehandlingssystem" neutrum  ; -- informationsbehandlingssystem..nn.1
  informationsbrist_1_N = mkN "informationsbrist" "informationsbrister" ; -- informationsbrist..nn.1
  informationsbroschyr_1_N = mkN "informationsbroschyr" "informationsbroschyrer" ; -- informationsbroschyr..nn.1
  informationsbyrå_1_N = mkN "informationsbyrå" "informationsbyråer" ; -- informationsbyrå..nn.1
  informationschef_1_N = mkN "informationschef" "informationschefer" ; -- informationschef..nn.1
  informationsdirektör_1_N = mkN "informationsdirektör" "informationsdirektörer" ; -- informationsdirektör..nn.1
  informationsdisk_1_N = mkN "informationsdisk" ; -- informationsdisk..nn.1
  informationsflöde_1_N = mkN "informationsflöde" ; -- informationsflöde..nn.1
  informationsföreläggande_1_N = mkN "informationsföreläggande" ; -- informationsföreläggande..nn.1
  informationskrigföring_1_N = mkN "informationskrigföring" ; -- informationskrigföring..nn.1
  informationsmässig_1_A = mkA "informationsmässig" ; -- informationsmässig..av.1
  informationsmöte_1_N = mkN "informationsmöte" ; -- informationsmöte..nn.1
  informationsorgan_1_N = mkN "informationsorgan" neutrum  ; -- informationsorgan..nn.1
  informationsplikt_1_N = mkN "informationsplikt" ; -- informationsplikt..nn.1
  informationsrik_1_A = mkA "informationsrik" ; -- informationsrik..av.1
  informationsrikhet_1_N = mkN "informationsrikhet" ; -- informationsrikhet..nn.1
  informationssamhälle_1_N = mkN "informationssamhälle" ; -- informationssamhälle..nn.1
  informationsstress_1_N = mkN "informationsstress" ; -- informationsstress..nn.1
  informationssökning_1_N = mkN "informationssökning" ; -- informationssökning..nn.1
  informationsteknik_1_N = mkN "informationsteknik" ; -- informationsteknik..nn.1
  informationsteknologi_1_N = mkN "informationsteknologi" "informationsteknologier" ; -- informationsteknologi..nn.1
  informationsteknologisk_1_A = mkA "informationsteknologisk" ; -- informationsteknologisk..av.1
  informationsteori_1_N = mkN "informationsteori" ; -- informationsteori..nn.1
  informationsutbyte_1_N = mkN "informationsutbyte" ; -- informationsutbyte..nn.1
  informationsöverflöd_1_N = mkN "informationsöverflöd" neutrum  ; -- informationsöverflöd..nn.1
  informativ_1_A = mkA "informativ" ; -- informativ..av.1
  informator_1_N = mkN "informator" "informatorer" ; -- informator..nn.1
  informatör_1_N = mkN "informatör" "informatörer" ; -- informatör..nn.1
  informell_1_A = mkA "informell" ; -- informell..av.1
  informera_1_V = mkV "informerar" ; -- informera..vb.1
  informerande_1_N = mkN "informerande" ; -- informerande..nn.1
  informerbar_1_A = mkA "informerbar" ; -- informerbar..av.1
  informerbarhet_1_N = mkN "informerbarhet" ; -- informerbarhet..nn.1
  informering_1_N = mkN "informering" ; -- informering..nn.1
  inforsling_1_N = mkN "inforsling" ; -- inforsling..nn.1
  infragrill_1_N = mkN "infragrill" ; -- infragrill..nn.1
  infraljud_1_N = mkN "infraljud" neutrum  ; -- infraljud..nn.1
  infraröd_1_A = mkA "infraröd" "infrarött" ; -- infraröd..av.1
  infrastruktur_1_N = mkN "infrastruktur" "infrastrukturer" ; -- infrastruktur..nn.1
  infrastrukturalitet_1_N = mkN "infrastrukturalitet" ; -- infrastrukturalitet..nn.1
  infrastrukturell_1_A = mkA "infrastrukturell" ; -- infrastrukturell..av.1
  infrastrukturminister_1_N = mkN "infrastrukturminister" ; -- infrastrukturminister..nn.1
  infrastruktursatsning_1_N = mkN "infrastruktursatsning" ; -- infrastruktursatsning..nn.1
  infravärme_1_N = mkN "infravärme" ; -- infravärme..nn.1
  infria_1_V = mkV "infriar" ; -- infria..vb.1
  infriande_1_N = mkN "infriande" ; -- infriande..nn.1
  infrusen_1_A = mkA "infrusen" ; -- infrusen..av.1
  infrysning_1_N = mkN "infrysning" ; -- infrysning..nn.1
  infusion_1_N = mkN "infusion" ; -- infusion..nn.1
  infusionsdjur_1_N = mkN "infusionsdjur" neutrum  ; -- infusionsdjur..nn.1
  infälld_1_A = mkA "infälld" "infällt" ; -- infälld..av.1
  infällning_1_N = mkN "infällning" ; -- infällning..nn.1
  infällning_2_N = mkN "infällning" ; -- infällning..nn.2
  infästning_1_N = mkN "infästning" ; -- infästning..nn.1
  infånga_1_V = mkV "infångar" ; -- infånga..vb.1
  infångande_1_N = mkN "infångande" ; -- infångande..nn.1
  infödd_1_A = mkA "infödd" ; -- infödd..av.1
  inföddhet_1_N = mkN "inföddhet" ; -- inföddhet..nn.1
  inföding_1_N = mkN "inföding" ; -- inföding..nn.1
  införa_1_V = mkV "införa" "införde" "infört" ; -- införa..vb.1
  införande_1_N = mkN "införande" ; -- införande..nn.1
  införliva_1_V = mkV "införlivar" ; -- införliva..vb.1
  införlivande_1_N = mkN "införlivande" ; -- införlivande..nn.1
  införlivning_1_N = mkN "införlivning" ; -- införlivning..nn.1
  införpassning_1_N = mkN "införpassning" ; -- införpassning..nn.1
  införsel_1_N = mkN "införsel" ; -- införsel..nn.1
  införskaffa_1_V = mkV "införskaffar" ; -- införskaffa..vb.1
  införskaffande_1_N = mkN "införskaffande" ; -- införskaffande..nn.1
  införstådd_1_A = mkA "införstådd" ; -- införstådd..av.1
  införståddhet_1_N = mkN "införståddhet" ; -- införståddhet..nn.1
  ingalunda_1_Adv = mkAdv "ingalunda" ; -- ingalunda..ab.1
  inge_1_V = mkV "ingiva" "ingav" "ingivit" ; -- inge..vb.1
  ingefära_1_N = mkN "ingefära" ; -- ingefära..nn.1
  ingefärsdricka_1_N = mkN "ingefärsdricka" ; -- ingefärsdricka..nn.1
  ingefärspäron_1_N = mkN "ingefärspäron" neutrum  ; -- ingefärspäron..nn.1
  ingefärsväxt_1_N = mkN "ingefärsväxt" "ingefärsväxter" ; -- ingefärsväxt..nn.1
  ingenium_1_N = mkN "ingenium" "ingeniet" "ingenier" "ingenierna" ; -- ingenium..nn.1
  ingenjör_1_N = mkN "ingenjör" "ingenjörer" ; -- ingenjör..nn.1
  ingenjörsmässig_1_A = mkA "ingenjörsmässig" ; -- ingenjörsmässig..av.1
  ingenjörsstudent_1_N = mkN "ingenjörsstudent" "ingenjörsstudenter" ; -- ingenjörsstudent..nn.1
  ingenjörstrupp_1_N = mkN "ingenjörstrupp" "ingenjörstrupper" ; -- ingenjörstrupp..nn.1
  ingenjörsutbildning_1_N = mkN "ingenjörsutbildning" ; -- ingenjörsutbildning..nn.1
  ingenjörsvetenskap_1_N = mkN "ingenjörsvetenskap" "ingenjörsvetenskaper" ; -- ingenjörsvetenskap..nn.1
  ingenjörsvetenskapsakademi_1_N = mkN "ingenjörsvetenskapsakademi" "ingenjörsvetenskapsakademier" ; -- ingenjörsvetenskapsakademi..nn.1
  ingenmansland_1_N = mkN "ingenmansland" neutrum  ; -- ingenmansland..nn.1
  ingenstans_1_Adv = mkAdv "ingenstans" ; -- ingenstans..ab.1
  ingenstädes_1_Adv = mkAdv "ingenstädes" ; -- ingenstädes..ab.1
  ingenvart_1_Adv = mkAdv "ingenvart" ; -- ingenvart..ab.1
  ingeny_1_N = mkN "ingeny" "ingenyer" ; -- ingeny..nn.1
  ingift_1_A = mkA "ingift" "ingift" ; -- ingift..av.1
  ingifte_1_N = mkN "ingifte" ; -- ingifte..nn.1
  ingivande_1_N = mkN "ingivande" ; -- ingivande..nn.1
  ingivelse_1_N = mkN "ingivelse" "ingivelser" ; -- ingivelse..nn.1
  ingjuta_1_V = mkV "ingjuta" "ingöt" "ingjutit" ; -- ingjuta..vb.1
  ingjutande_1_N = mkN "ingjutande" ; -- ingjutande..nn.1
  ingjutning_1_N = mkN "ingjutning" ; -- ingjutning..nn.1
  inglasad_1_A = mkA "inglasad" ; -- inglasad..av.1
  ingnidning_1_N = mkN "ingnidning" ; -- ingnidning..nn.1
  ingravera_1_V = mkV "ingraverar" ; -- ingravera..vb.1
  ingraverande_1_N = mkN "ingraverande" ; -- ingraverande..nn.1
  ingraverbar_1_A = mkA "ingraverbar" ; -- ingraverbar..av.1
  ingraverbarhet_1_N = mkN "ingraverbarhet" ; -- ingraverbarhet..nn.1
  ingravering_1_N = mkN "ingravering" ; -- ingravering..nn.1
  ingrediens_1_N = mkN "ingrediens" "ingredienser" ; -- ingrediens..nn.1
  ingredierande_1_A = mkA "ingredierande" ; -- ingredierande..av.1
  ingrepp_1_N = mkN "ingrepp" neutrum  ; -- ingrepp..nn.1
  ingress_1_N = mkN "ingress" "ingresser" ; -- ingress..nn.1
  ingripa_1_V = mkV "ingripa" "ingrep" "ingripit" ; -- ingripa..vb.1
  ingripande_1_N = mkN "ingripande" ; -- ingripande..nn.1
  ingrodd_1_A = mkA "ingrodd" ; -- ingrodd..av.1
  ingroddhet_1_N = mkN "ingroddhet" ; -- ingroddhet..nn.1
  ingäld_1_N = mkN "ingäld" "ingälder" ; -- ingäld..nn.1
  ingärda_1_V = mkV "ingärdar" ; -- ingärda..vb.1
  ingärdning_1_N = mkN "ingärdning" ; -- ingärdning..nn.1
  ingå_1_V = mkV "ingå" "ingick" "ingått" ; -- ingå..vb.1
  ingå_2_V = mkV "ingå" "ingår" "ingå" "ingick" "ingått" "ingången" ; -- ingå..vb.2
  ingående_1_A = mkA "ingående" ; -- ingående..av.1
  ingående_1_N = mkN "ingående" ; -- ingående..nn.1
  ingång_1_N = mkN "ingång" ; -- ingång..nn.1
  ingångsdörr_1_N = mkN "ingångsdörr" ; -- ingångsdörr..nn.1
  ingångslön_1_N = mkN "ingångslön" "ingångslöner" ; -- ingångslön..nn.1
  ingångsmarsch_1_N = mkN "ingångsmarsch" "ingångsmarscher" ; -- ingångsmarsch..nn.1
  ingångspsalm_1_N = mkN "ingångspsalm" "ingångspsalmer" ; -- ingångspsalm..nn.1
  ingångsspänning_1_N = mkN "ingångsspänning" ; -- ingångsspänning..nn.1
  ingångsväg_1_N = mkN "ingångsväg" ; -- ingångsväg..nn.1
  ingöt_1_N = mkN "ingöt" neutrum  ; -- ingöt..nn.1
  ingöte_1_N = mkN "ingöte" ; -- ingöte..nn.1
  inhalation_1_N = mkN "inhalation" ; -- inhalation..nn.1
  inhalator_1_N = mkN "inhalator" "inhalatorer" ; -- inhalator..nn.1
  inhalera_1_V = mkV "inhalerar" ; -- inhalera..vb.1
  inhalerande_1_N = mkN "inhalerande" ; -- inhalerande..nn.1
  inhalerbar_1_A = mkA "inhalerbar" ; -- inhalerbar..av.1
  inhalerbarhet_1_N = mkN "inhalerbarhet" ; -- inhalerbarhet..nn.1
  inhalering_1_N = mkN "inhalering" ; -- inhalering..nn.1
  inhamn_1_N = mkN "inhamn" ; -- inhamn..nn.1
  inhandla_1_V = mkV "inhandlar" ; -- inhandla..vb.1
  inhandlande_1_N = mkN "inhandlande" ; -- inhandlande..nn.1
  inhav_1_N = mkN "inhav" neutrum  ; -- inhav..nn.1
  inhemsk_1_A = mkA "inhemsk" ; -- inhemsk..av.1
  inherent_1_A = mkA "inherent" "inherent" ; -- inherent..av.1
  inhibera_1_V = mkV "inhiberar" ; -- inhibera..vb.1
  inhiberande_1_N = mkN "inhiberande" ; -- inhiberande..nn.1
  inhiberbar_1_A = mkA "inhiberbar" ; -- inhiberbar..av.1
  inhiberbarhet_1_N = mkN "inhiberbarhet" ; -- inhiberbarhet..nn.1
  inhibering_1_N = mkN "inhibering" ; -- inhibering..nn.1
  inhibitera_1_V = mkV "inhibiterar" ; -- inhibitera..vb.1
  inhibiterande_1_N = mkN "inhibiterande" ; -- inhibiterande..nn.1
  inhibiterbar_1_A = mkA "inhibiterbar" ; -- inhibiterbar..av.1
  inhibiterbarhet_1_N = mkN "inhibiterbarhet" ; -- inhibiterbarhet..nn.1
  inhibitering_1_N = mkN "inhibitering" ; -- inhibitering..nn.1
  inhibitor_1_N = mkN "inhibitor" "inhibitorer" ; -- inhibitor..nn.1
  inhopp_1_N = mkN "inhopp" neutrum  ; -- inhopp..nn.1
  inhoppare_1_N = mkN "inhoppare" utrum  ; -- inhoppare..nn.1
  inhuggning_1_N = mkN "inhuggning" ; -- inhuggning..nn.1
  inhuman_1_A = mkA "inhuman" ; -- inhuman..av.1
  inhysa_1_V = mkV "inhyser" ; -- inhysa..vb.1
  inhysande_1_N = mkN "inhysande" ; -- inhysande..nn.1
  inhyseshjon_1_N = mkN "inhyseshjon" "inhyseshjoner" ; -- inhyseshjon..nn.1
  inhysing_1_N = mkN "inhysing" ; -- inhysing..nn.1
  inhysning_1_N = mkN "inhysning" ; -- inhysning..nn.1
  inhäftning_1_N = mkN "inhäftning" ; -- inhäftning..nn.1
  inhägna_1_V = mkV "inhägnar" ; -- inhägna..vb.1
  inhägnad_1_N = mkN "inhägnad" "inhägnader" ; -- inhägnad..nn.1
  inhägnande_1_N = mkN "inhägnande" ; -- inhägnande..nn.1
  inhämta_1_V = mkV "inhämtar" ; -- inhämta..vb.1
  inhämtande_1_N = mkN "inhämtande" ; -- inhämtande..nn.1
  inhämtning_1_N = mkN "inhämtning" ; -- inhämtning..nn.1
  inhölja_1_V = mkV "inhölja" "inhöljde" "inhöljt" ; -- inhölja..vb.1
  inhöljande_1_N = mkN "inhöljande" ; -- inhöljande..nn.1
  inhöljning_1_N = mkN "inhöljning" ; -- inhöljning..nn.1
  inhösta_1_V = mkV "inhöstar" ; -- inhösta..vb.1
  inhöstande_1_N = mkN "inhöstande" ; -- inhöstande..nn.1
  inhöstning_1_N = mkN "inhöstning" ; -- inhöstning..nn.1
  inifrån_1_Adv = mkAdv "inifrån" ; -- inifrån..ab.1
  initial_1_A = mkA "initial" ; -- initial..av.1
  initial_1_N = mkN "initial" "initialer" ; -- initial..nn.1
  initialhastighet_1_N = mkN "initialhastighet" ; -- initialhastighet..nn.1
  initialord_1_N = mkN "initialord" neutrum  ; -- initialord..nn.1
  initialsvårighet_1_N = mkN "initialsvårighet" "initialsvårigheter" ; -- initialsvårighet..nn.1
  initiation_1_N = mkN "initiation" ; -- initiation..nn.1
  initiationsrit_1_N = mkN "initiationsrit" "initiationsriter" ; -- initiationsrit..nn.1
  initiativ_1_N = mkN "initiativ" neutrum  ; -- initiativ..nn.1
  initiativförmåga_1_N = mkN "initiativförmåga" ; -- initiativförmåga..nn.1
  initiativkraft_1_N = mkN "initiativkraft" ; -- initiativkraft..nn.1
  initiativrik_1_A = mkA "initiativrik" ; -- initiativrik..av.1
  initiativrikhet_1_N = mkN "initiativrikhet" ; -- initiativrikhet..nn.1
  initiativtagare_1_N = mkN "initiativtagare" utrum  ; -- initiativtagare..nn.1
  initiera_1_V = mkV "initierar" ; -- initiera..vb.1
  initierad_1_A = mkA "initierad" ; -- initierad..av.1
  initierande_1_N = mkN "initierande" ; -- initierande..nn.1
  initierbar_1_A = mkA "initierbar" ; -- initierbar..av.1
  initierbarhet_1_N = mkN "initierbarhet" ; -- initierbarhet..nn.1
  initiering_1_N = mkN "initiering" ; -- initiering..nn.1
  injaga_1_V = mkV "injagar" ; -- injaga..vb.1
  injagande_1_N = mkN "injagande" ; -- injagande..nn.1
  injektera_1_V = mkV "injekterar" ; -- injektera..vb.1
  injekterande_1_N = mkN "injekterande" ; -- injekterande..nn.1
  injekterbar_1_A = mkA "injekterbar" ; -- injekterbar..av.1
  injekterbarhet_1_N = mkN "injekterbarhet" ; -- injekterbarhet..nn.1
  injektering_1_N = mkN "injektering" ; -- injektering..nn.1
  injektion_1_N = mkN "injektion" ; -- injektion..nn.1
  injektionsmissbrukare_1_N = mkN "injektionsmissbrukare" utrum  ; -- injektionsmissbrukare..nn.1
  injektionsnål_1_N = mkN "injektionsnål" ; -- injektionsnål..nn.1
  injektionsspruta_1_N = mkN "injektionsspruta" ; -- injektionsspruta..nn.1
  injektionsställe_1_N = mkN "injektionsställe" ; -- injektionsställe..nn.1
  injektor_1_N = mkN "injektor" "injektorer" ; -- injektor..nn.1
  injicera_1_V = mkV "injicerar" ; -- injicera..vb.1
  injicerande_1_N = mkN "injicerande" ; -- injicerande..nn.1
  injicerbar_1_A = mkA "injicerbar" ; -- injicerbar..av.1
  injicerbarhet_1_N = mkN "injicerbarhet" ; -- injicerbarhet..nn.1
  injicering_1_N = mkN "injicering" ; -- injicering..nn.1
  injurie_1_N = mkN "injurie" "injurier" ; -- injurie..nn.1
  ink_1_N = mkN "ink" ; -- ink..nn.1
  inka_1_N = mkN "inka" ; -- inka..nn.1
  inkabär_1_N = mkN "inkabär" neutrum  ; -- inkabär..nn.1
  inkafolk_1_N = mkN "inkafolk" neutrum  ; -- inkafolk..nn.1
  inkaindian_1_N = mkN "inkaindian" "inkaindianer" ; -- inkaindian..nn.1
  inkalla_1_V = mkV "inkallar" ; -- inkalla..vb.1
  inkallad_1_A = mkA "inkallad" ; -- inkallad..av.1
  inkallande_1_N = mkN "inkallande" ; -- inkallande..nn.1
  inkallelse_1_N = mkN "inkallelse" "inkallelser" ; -- inkallelse..nn.1
  inkallelsebrev_1_N = mkN "inkallelsebrev" neutrum  ; -- inkallelsebrev..nn.1
  inkallelseorder_1_N = mkN "inkallelseorder" ; -- inkallelseorder..nn.1
  inkapabel_1_A = mkA "inkapabel" ; -- inkapabel..av.1
  inkapsla_1_V = mkV "inkapslar" ; -- inkapsla..vb.1
  inkapslande_1_N = mkN "inkapslande" ; -- inkapslande..nn.1
  inkapsling_1_N = mkN "inkapsling" ; -- inkapsling..nn.1
  inkarnation_1_N = mkN "inkarnation" ; -- inkarnation..nn.1
  inkarnera_1_V = mkV "inkarnerar" ; -- inkarnera..vb.1
  inkarnerande_1_N = mkN "inkarnerande" ; -- inkarnerande..nn.1
  inkarnerbar_1_A = mkA "inkarnerbar" ; -- inkarnerbar..av.1
  inkarnerbarhet_1_N = mkN "inkarnerbarhet" ; -- inkarnerbarhet..nn.1
  inkarnering_1_N = mkN "inkarnering" ; -- inkarnering..nn.1
  inkassera_1_V = mkV "inkasserar" ; -- inkassera..vb.1
  inkasserande_1_N = mkN "inkasserande" ; -- inkasserande..nn.1
  inkasserbar_1_A = mkA "inkasserbar" ; -- inkasserbar..av.1
  inkasserbarhet_1_N = mkN "inkasserbarhet" ; -- inkasserbarhet..nn.1
  inkassering_1_N = mkN "inkassering" ; -- inkassering..nn.1
  inkassobrev_1_N = mkN "inkassobrev" neutrum  ; -- inkassobrev..nn.1
  inkassolag_1_N = mkN "inkassolag" ; -- inkassolag..nn.1
  inkast_1_N = mkN "inkast" neutrum  ; -- inkast..nn.1
  inkastning_1_N = mkN "inkastning" ; -- inkastning..nn.1
  inkiett_1_A = mkA "inkiett" ; -- inkiett..av.1
  inkilad_1_A = mkA "inkilad" ; -- inkilad..av.1
  inklarera_1_V = mkV "inklarerar" ; -- inklarera..vb.1
  inklarerande_1_N = mkN "inklarerande" ; -- inklarerande..nn.1
  inklarerbar_1_A = mkA "inklarerbar" ; -- inklarerbar..av.1
  inklarerbarhet_1_N = mkN "inklarerbarhet" ; -- inklarerbarhet..nn.1
  inklarering_1_N = mkN "inklarering" ; -- inklarering..nn.1
  inklination_1_N = mkN "inklination" ; -- inklination..nn.1
  inklinationsnål_1_N = mkN "inklinationsnål" ; -- inklinationsnål..nn.1
  inkludera_1_V = mkV "inkluderar" ; -- inkludera..vb.1
  inkluderande_1_N = mkN "inkluderande" ; -- inkluderande..nn.1
  inkluderbar_1_A = mkA "inkluderbar" ; -- inkluderbar..av.1
  inkluderbarhet_1_N = mkN "inkluderbarhet" ; -- inkluderbarhet..nn.1
  inkludering_1_N = mkN "inkludering" ; -- inkludering..nn.1
  inknappning_1_N = mkN "inknappning" ; -- inknappning..nn.1
  inkoativ_1_A = mkA "inkoativ" ; -- inkoativ..av.1
  inkoka_1_V = mkV "inkoker" ; -- inkoka..vb.1
  inkokande_1_N = mkN "inkokande" ; -- inkokande..nn.1
  inkomma_1_V = mkV "inkomma" "inkom" "inkommit" ; -- inkomma..vb.1
  inkommande_1_N = mkN "inkommande" ; -- inkommande..nn.1
  inkommensurabel_1_A = mkA "inkommensurabel" ; -- inkommensurabel..av.1
  inkommensurabilitet_1_N = mkN "inkommensurabilitet" "inkommensurabiliteter" ; -- inkommensurabilitet..nn.1
  inkompatibel_1_A = mkA "inkompatibel" ; -- inkompatibel..av.1
  inkompatibilitet_1_N = mkN "inkompatibilitet" "inkompatibiliteter" ; -- inkompatibilitet..nn.1
  inkompetens_1_N = mkN "inkompetens" ; -- inkompetens..nn.1
  inkompetensförklara_1_V = mkV "inkompetensförklarar" ; -- inkompetensförklara..vb.1
  inkompetent_1_A = mkA "inkompetent" "inkompetent" ; -- inkompetent..av.1
  inkomst_1_N = mkN "inkomst" "inkomster" ; -- inkomst..nn.1
  inkomstbegrepp_1_N = mkN "inkomstbegrepp" neutrum  ; -- inkomstbegrepp..nn.1
  inkomstbelopp_1_N = mkN "inkomstbelopp" neutrum  ; -- inkomstbelopp..nn.1
  inkomstberoende_1_A = mkA "inkomstberoende" ; -- inkomstberoende..av.1
  inkomstbeskattning_1_N = mkN "inkomstbeskattning" ; -- inkomstbeskattning..nn.1
  inkomstbortfall_1_N = mkN "inkomstbortfall" neutrum  ; -- inkomstbortfall..nn.1
  inkomstbringande_1_A = mkA "inkomstbringande" ; -- inkomstbringande..av.1
  inkomstgaranti_1_N = mkN "inkomstgaranti" "inkomstgarantier" ; -- inkomstgaranti..nn.1
  inkomstgivande_1_A = mkA "inkomstgivande" ; -- inkomstgivande..av.1
  inkomstgrundad_1_A = mkA "inkomstgrundad" ; -- inkomstgrundad..av.1
  inkomstintervall_1_N = mkN "inkomstintervall" neutrum  ; -- inkomstintervall..nn.1
  inkomstklyfta_1_N = mkN "inkomstklyfta" ; -- inkomstklyfta..nn.1
  inkomstkort_1_N = mkN "inkomstkort" neutrum  ; -- inkomstkort..nn.1
  inkomstkälla_1_N = mkN "inkomstkälla" ; -- inkomstkälla..nn.1
  inkomstmässig_1_A = mkA "inkomstmässig" ; -- inkomstmässig..av.1
  inkomstmått_1_N = mkN "inkomstmått" neutrum  ; -- inkomstmått..nn.1
  inkomstpost_1_N = mkN "inkomstpost" "inkomstposter" ; -- inkomstpost..nn.1
  inkomstpröva_1_V = mkV "inkomstprövar" ; -- inkomstpröva..vb.1
  inkomstprövande_1_N = mkN "inkomstprövande" ; -- inkomstprövande..nn.1
  inkomstprövning_1_N = mkN "inkomstprövning" ; -- inkomstprövning..nn.1
  inkomstrelaterad_1_A = mkA "inkomstrelaterad" ; -- inkomstrelaterad..av.1
  inkomstsida_1_N = mkN "inkomstsida" ; -- inkomstsida..nn.1
  inkomstskatt_1_N = mkN "inkomstskatt" "inkomstskatter" ; -- inkomstskatt..nn.1
  inkomstskattesänkning_1_N = mkN "inkomstskattesänkning" ; -- inkomstskattesänkning..nn.1
  inkomstskillnad_1_N = mkN "inkomstskillnad" "inkomstskillnader" ; -- inkomstskillnad..nn.1
  inkomstslag_1_N = mkN "inkomstslag" neutrum  ; -- inkomstslag..nn.1
  inkomstsumma_1_N = mkN "inkomstsumma" ; -- inkomstsumma..nn.1
  inkomstsvag_1_A = mkA "inkomstsvag" ; -- inkomstsvag..av.1
  inkomsttagare_1_N = mkN "inkomsttagare" utrum  ; -- inkomsttagare..nn.1
  inkomsttaxera_1_V = mkV "inkomsttaxerar" ; -- inkomsttaxera..vb.1
  inkomsttaxerande_1_N = mkN "inkomsttaxerande" ; -- inkomsttaxerande..nn.1
  inkomsttaxerbar_1_A = mkA "inkomsttaxerbar" ; -- inkomsttaxerbar..av.1
  inkomsttaxerbarhet_1_N = mkN "inkomsttaxerbarhet" ; -- inkomsttaxerbarhet..nn.1
  inkomsttaxering_1_N = mkN "inkomsttaxering" ; -- inkomsttaxering..nn.1
  inkomstökning_1_N = mkN "inkomstökning" ; -- inkomstökning..nn.1
  inkongruens_1_N = mkN "inkongruens" "inkongruenser" ; -- inkongruens..nn.1
  inkongruent_1_A = mkA "inkongruent" "inkongruent" ; -- inkongruent..av.1
  inkonsekvens_1_N = mkN "inkonsekvens" "inkonsekvenser" ; -- inkonsekvens..nn.1
  inkonsekvent_1_A = mkA "inkonsekvent" "inkonsekvent" ; -- inkonsekvent..av.1
  inkonstant_1_A = mkA "inkonstant" "inkonstant" ; -- inkonstant..av.1
  inkontinens_1_N = mkN "inkontinens" ; -- inkontinens..nn.1
  inkontinent_1_A = mkA "inkontinent" "inkontinent" ; -- inkontinent..av.1
  inkoppla_1_V = mkV "inkopplar" ; -- inkoppla..vb.1
  inkopplande_1_N = mkN "inkopplande" ; -- inkopplande..nn.1
  inkoppling_1_N = mkN "inkoppling" ; -- inkoppling..nn.1
  inkorg_1_N = mkN "inkorg" ; -- inkorg..nn.1
  inkorporera_1_V = mkV "inkorporerar" ; -- inkorporera..vb.1
  inkorporerande_1_N = mkN "inkorporerande" ; -- inkorporerande..nn.1
  inkorporerbar_1_A = mkA "inkorporerbar" ; -- inkorporerbar..av.1
  inkorporerbarhet_1_N = mkN "inkorporerbarhet" ; -- inkorporerbarhet..nn.1
  inkorporering_1_N = mkN "inkorporering" ; -- inkorporering..nn.1
  inkorrekt_1_A = mkA "inkorrekt" "inkorrekt" ; -- inkorrekt..av.1
  inkorrekthet_1_N = mkN "inkorrekthet" ; -- inkorrekthet..nn.1
  inkrustation_1_N = mkN "inkrustation" ; -- inkrustation..nn.1
  inkrustera_1_V = mkV "inkrusterar" ; -- inkrustera..vb.1
  inkrusterande_1_N = mkN "inkrusterande" ; -- inkrusterande..nn.1
  inkrustering_1_N = mkN "inkrustering" ; -- inkrustering..nn.1
  inkräkta_1_V = mkV "inkräktar" ; -- inkräkta..vb.1
  inkräktande_1_N = mkN "inkräktande" ; -- inkräktande..nn.1
  inkräktare_1_N = mkN "inkräktare" utrum  ; -- inkräktare..nn.1
  inkräktning_1_N = mkN "inkräktning" ; -- inkräktning..nn.1
  inkräva_1_V = mkV "inkräver" ; -- inkräva..vb.1
  inkrävande_1_N = mkN "inkrävande" ; -- inkrävande..nn.1
  inkråm_1_N = mkN "inkråm" neutrum  ; -- inkråm..nn.1
  inkrökt_1_A = mkA "inkrökt" "inkrökt" ; -- inkrökt..av.1
  inkrökthet_1_N = mkN "inkrökthet" ; -- inkrökthet..nn.1
  inkubation_1_N = mkN "inkubation" ; -- inkubation..nn.1
  inkubationstid_1_N = mkN "inkubationstid" "inkubationstider" ; -- inkubationstid..nn.1
  inkubator_1_N = mkN "inkubator" "inkubatorer" ; -- inkubator..nn.1
  inkunabel_1_N = mkN "inkunabel" "inkunabeln" "inkunabler" "inkunablerna" ; -- inkunabel..nn.1
  inkurabel_1_A = mkA "inkuraben" ; -- inkurabel..av.1
  inkurant_1_A = mkA "inkurant" "inkurant" ; -- inkurant..av.1
  inkvartera_1_V = mkV "inkvarterar" ; -- inkvartera..vb.1
  inkvarterande_1_N = mkN "inkvarterande" ; -- inkvarterande..nn.1
  inkvarterbar_1_A = mkA "inkvarterbar" ; -- inkvarterbar..av.1
  inkvarterbarhet_1_N = mkN "inkvarterbarhet" ; -- inkvarterbarhet..nn.1
  inkvartering_1_N = mkN "inkvartering" ; -- inkvartering..nn.1
  inkvisition_1_N = mkN "inkvisition" ; -- inkvisition..nn.1
  inkvisitionsdomstol_1_N = mkN "inkvisitionsdomstol" ; -- inkvisitionsdomstol..nn.1
  inkvisitor_1_N = mkN "inkvisitor" "inkvisitorer" ; -- inkvisitor..nn.1
  inkvisitorisk_1_A = mkA "inkvisitorisk" ; -- inkvisitorisk..av.1
  inkännande_1_A = mkA "inkännande" ; -- inkännande..av.1
  inkännande_1_N = mkN "inkännande" ; -- inkännande..nn.1
  inköp_1_N = mkN "inköp" neutrum  ; -- inköp..nn.1
  inköpa_1_V = mkV "inköper" ; -- inköpa..vb.1
  inköpande_1_N = mkN "inköpande" ; -- inköpande..nn.1
  inköpare_1_N = mkN "inköpare" utrum  ; -- inköpare..nn.1
  inköpsavdelning_1_N = mkN "inköpsavdelning" ; -- inköpsavdelning..nn.1
  inköpslista_1_N = mkN "inköpslista" ; -- inköpslista..nn.1
  inköpspris_1_N = mkN "inköpspris" neutrum  ; -- inköpspris..nn.1
  inkörd_1_A = mkA "inkörd" "inkört" ; -- inkörd..av.1
  inkörning_1_N = mkN "inkörning" ; -- inkörning..nn.1
  inkörningsperiod_1_N = mkN "inkörningsperiod" "inkörningsperioder" ; -- inkörningsperiod..nn.1
  inkörsport_1_N = mkN "inkörsport" ; -- inkörsport..nn.1
  inkörsväg_1_N = mkN "inkörsväg" ; -- inkörsväg..nn.1
  inlaga_1_N = mkN "inlaga" ; -- inlaga..nn.1
  inlagd_1_A = mkA "inlagd" "inlagt" ; -- inlagd..av.1
  inland_1_N = mkN "inland" neutrum  ; -- inland..nn.1
  inlandsbana_1_N = mkN "inlandsbana" ; -- inlandsbana..nn.1
  inlandsis_1_N = mkN "inlandsis" ; -- inlandsis..nn.1
  inlandsklimat_1_N = mkN "inlandsklimat" neutrum  ; -- inlandsklimat..nn.1
  inlasande_1_N = mkN "inlasande" ; -- inlasande..nn.1
  inlasning_1_N = mkN "inlasning" ; -- inlasning..nn.1
  inlastare_1_N = mkN "inlastare" utrum  ; -- inlastare..nn.1
  inlastning_1_N = mkN "inlastning" ; -- inlastning..nn.1
  inleda_1_V = mkV "inleda" "inledde" "inlett" ; -- inleda..vb.1
  inledande_1_A = mkA "inledande" ; -- inledande..av.1
  inledande_1_N = mkN "inledande" ; -- inledande..nn.1
  inledare_1_N = mkN "inledare" utrum  ; -- inledare..nn.1
  inledning_1_N = mkN "inledning" ; -- inledning..nn.1
  inledningsrad_1_N = mkN "inledningsrad" "inledningsrader" ; -- inledningsrad..nn.1
  inledningsskede_1_N = mkN "inledningsskede" ; -- inledningsskede..nn.1
  inledningstal_1_N = mkN "inledningstal" neutrum  ; -- inledningstal..nn.1
  inledningstala_1_V = mkV "inledningstalar" ; -- inledningstala..vb.1
  inledningstalande_1_N = mkN "inledningstalande" ; -- inledningstalande..nn.1
  inledningsvis_1_Adv = mkAdv "inledningsvis" ; -- inledningsvis..ab.1
  inlemma_1_V = mkV "inlemmar" ; -- inlemma..vb.1
  inlemmande_1_N = mkN "inlemmande" ; -- inlemmande..nn.1
  inlevelse_1_N = mkN "inlevelse" utrum  ; -- inlevelse..nn.1
  inlevelsefull_1_A = mkA "inlevelsefull" ; -- inlevelsefull..av.1
  inlevelseförmåga_1_N = mkN "inlevelseförmåga" ; -- inlevelseförmåga..nn.1
  inleverera_1_V = mkV "inlevererar" ; -- inleverera..vb.1
  inlinda_1_V = mkV "inlindar" ; -- inlinda..vb.1
  inlindande_1_N = mkN "inlindande" ; -- inlindande..nn.1
  inlindning_1_N = mkN "inlindning" ; -- inlindning..nn.1
  inljud_1_N = mkN "inljud" neutrum  ; -- inljud..nn.1
  inloggning_1_N = mkN "inloggning" ; -- inloggning..nn.1
  inloggningsuppgift_1_N = mkN "inloggningsuppgift" "inloggningsuppgifter" ; -- inloggningsuppgift..nn.1
  inlopp_1_N = mkN "inlopp" neutrum  ; -- inlopp..nn.1
  inloppsränna_1_N = mkN "inloppsränna" ; -- inloppsränna..nn.1
  inlotsning_1_N = mkN "inlotsning" ; -- inlotsning..nn.1
  inlägg_1_N = mkN "inlägg" neutrum  ; -- inlägg..nn.1
  inlägga_1_V = mkV "inlägga" "inla" "inlagt" ; -- inlägga..vb.1
  inläggande_1_N = mkN "inläggande" ; -- inläggande..nn.1
  inläggning_1_N = mkN "inläggning" ; -- inläggning..nn.1
  inläggningsgurka_1_N = mkN "inläggningsgurka" ; -- inläggningsgurka..nn.1
  inlämna_1_V = mkV "inlämnar" ; -- inlämna..vb.1
  inlämnande_1_N = mkN "inlämnande" ; -- inlämnande..nn.1
  inlämning_1_N = mkN "inlämning" ; -- inlämning..nn.1
  inlämningsdag_1_N = mkN "inlämningsdag" ; -- inlämningsdag..nn.1
  inländsk_1_A = mkA "inländsk" ; -- inländsk..av.1
  inlära_1_V = mkV "inlära" "inlärde" "inlärt" ; -- inlära..vb.1
  inlärande_1_N = mkN "inlärande" ; -- inlärande..nn.1
  inlärd_1_A = mkA "inlärd" "inlärt" ; -- inlärd..av.1
  inlärning_1_N = mkN "inlärning" ; -- inlärning..nn.1
  inlärningsmässig_1_A = mkA "inlärningsmässig" ; -- inlärningsmässig..av.1
  inlärningsplatå_1_N = mkN "inlärningsplatå" "inlärningsplatåer" ; -- inlärningsplatå..nn.1
  inlärningsresultat_1_N = mkN "inlärningsresultat" neutrum  ; -- inlärningsresultat..nn.1
  inlärningsstudio_1_N = mkN "inlärningsstudio" "inlärningsstudior" ; -- inlärningsstudio..nn.1
  inlärningssvårighet_1_N = mkN "inlärningssvårighet" ; -- inlärningssvårighet..nn.1
  inläsning_1_N = mkN "inläsning" ; -- inläsning..nn.1
  inläst_1_A = mkA "inläst" "inläst" ; -- inläst..av.1
  inlåna_1_V = mkV "inlånar" ; -- inlåna..vb.1
  inlånande_1_N = mkN "inlånande" ; -- inlånande..nn.1
  inlåning_1_N = mkN "inlåning" ; -- inlåning..nn.1
  inlåningsränta_1_N = mkN "inlåningsränta" ; -- inlåningsränta..nn.1
  inlåningsrörelse_1_N = mkN "inlåningsrörelse" "inlåningsrörelser" ; -- inlåningsrörelse..nn.1
  inlåsning_1_N = mkN "inlåsning" ; -- inlåsning..nn.1
  inlöpa_1_V = mkV "inlöper" ; -- inlöpa..vb.1
  inlöpande_1_N = mkN "inlöpande" ; -- inlöpande..nn.1
  inlöpning_1_N = mkN "inlöpning" ; -- inlöpning..nn.1
  inlösa_1_V = mkV "inlöser" ; -- inlösa..vb.1
  inlösande_1_N = mkN "inlösande" ; -- inlösande..nn.1
  inlösen_1_N = mkN "inlösen" ; -- inlösen..nn.1
  inlösning_1_N = mkN "inlösning" ; -- inlösning..nn.1
  inmarsch_1_N = mkN "inmarsch" "inmarscher" ; -- inmarsch..nn.1
  inmata_1_V = mkV "inmatar" ; -- inmata..vb.1
  inmatande_1_N = mkN "inmatande" ; -- inmatande..nn.1
  inmatning_1_N = mkN "inmatning" ; -- inmatning..nn.1
  inmatningsbredd_1_N = mkN "inmatningsbredd" "inmatningsbredder" ; -- inmatningsbredd..nn.1
  inmundiga_1_V = mkV "inmundigar" ; -- inmundiga..vb.1
  inmundigande_1_N = mkN "inmundigande" ; -- inmundigande..nn.1
  inmurning_1_N = mkN "inmurning" ; -- inmurning..nn.1
  inmuta_1_V = mkV "inmutar" ; -- inmuta..vb.1
  inmutande_1_N = mkN "inmutande" ; -- inmutande..nn.1
  inmutare_1_N = mkN "inmutare" utrum  ; -- inmutare..nn.1
  inmutning_1_N = mkN "inmutning" ; -- inmutning..nn.1
  inmänga_1_V = mkV "inmänger" ; -- inmänga..vb.1
  inmängande_1_N = mkN "inmängande" ; -- inmängande..nn.1
  inmängning_1_N = mkN "inmängning" ; -- inmängning..nn.1
  inmätning_1_N = mkN "inmätning" ; -- inmätning..nn.1
  inmålad_1_A = mkA "inmålad" ; -- inmålad..av.1
  inmönstra_1_V = mkV "inmönstrar" ; -- inmönstra..vb.1
  inmönstrande_1_N = mkN "inmönstrande" ; -- inmönstrande..nn.1
  inmönstring_1_N = mkN "inmönstring" ; -- inmönstring..nn.1
  innan_1_Adv = mkAdv "innan" ; -- innan..ab.1
  innandöme_1_N = mkN "innandöme" ; -- innandöme..nn.1
  innanfönster_1_N = mkN "innanfönster" neutrum  ; -- innanfönster..nn.1
  innanför_1_Adv = mkAdv "innanför" ; -- innanför..ab.1
  innanhav_1_N = mkN "innanhav" neutrum  ; -- innanhav..nn.1
  innanläsning_1_N = mkN "innanläsning" ; -- innanläsning..nn.1
  innanlår_1_N = mkN "innanlår" neutrum  ; -- innanlår..nn.1
  innanmäte_1_N = mkN "innanmäte" ; -- innanmäte..nn.1
  innanverk_1_N = mkN "innanverk" neutrum  ; -- innanverk..nn.1
  inne_1_A = mkA "inne" ; -- inne..av.1
  innebandyspelande_1_A = mkA "innebandyspelande" ; -- innebandyspelande..av.1
  inneboende_1_A = mkA "inneboende" ; -- inneboende..av.1
  innebruk_1_N = mkN "innebruk" neutrum  ; -- innebruk..nn.1
  innebyggare_1_N = mkN "innebyggare" utrum  ; -- innebyggare..nn.1
  innebära_1_V = mkV "innebära" "innebar" "inneburit" ; -- innebära..vb.1
  innebärande_1_N = mkN "innebärande" ; -- innebärande..nn.1
  innebörd_1_N = mkN "innebörd" "innebörder" ; -- innebörd..nn.1
  innefatta_1_V = mkV "innefattar" ; -- innefatta..vb.1
  innefattande_1_N = mkN "innefattande" ; -- innefattande..nn.1
  innegrej_1_N = mkN "innegrej" "innegrejer" ; -- innegrej..nn.1
  innehav_1_N = mkN "innehav" neutrum  ; -- innehav..nn.1
  innehavande_1_N = mkN "innehavande" ; -- innehavande..nn.1
  innehavare_1_N = mkN "innehavare" utrum  ; -- innehavare..nn.1
  innehavarpapper_1_N = mkN "innehavarpapper" neutrum  ; -- innehavarpapper..nn.1
  innehåll_1_N = mkN "innehåll" neutrum  ; -- innehåll..nn.1
  innehålla_1_V = mkV "innehålla" "innehöll" "innehållit" ; -- innehålla..vb.1
  innehållande_1_N = mkN "innehållande" ; -- innehållande..nn.1
  innehållning_1_N = mkN "innehållning" ; -- innehållning..nn.1
  innehållsanalys_1_N = mkN "innehållsanalys" "innehållsanalyser" ; -- innehållsanalys..nn.1
  innehållsdeklaration_1_N = mkN "innehållsdeklaration" ; -- innehållsdeklaration..nn.1
  innehållsfattig_1_A = mkA "innehållsfattig" ; -- innehållsfattig..av.1
  innehållsförteckning_1_N = mkN "innehållsförteckning" ; -- innehållsförteckning..nn.1
  innehållslig_1_A = mkA "innehållslig" ; -- innehållslig..av.1
  innehållslighet_1_N = mkN "innehållslighet" ; -- innehållslighet..nn.1
  innehållslös_1_A = mkA "innehållslös" ; -- innehållslös..av.1
  innehållslöshet_1_N = mkN "innehållslöshet" ; -- innehållslöshet..nn.1
  innehållsmässig_1_A = mkA "innehållsmässig" ; -- innehållsmässig..av.1
  innehållsmässighet_1_N = mkN "innehållsmässighet" ; -- innehållsmässighet..nn.1
  innehållsobjekt_1_N = mkN "innehållsobjekt" neutrum  ; -- innehållsobjekt..nn.1
  innehållsord_1_N = mkN "innehållsord" neutrum  ; -- innehållsord..nn.1
  innehållsrelaterad_1_A = mkA "innehållsrelaterad" ; -- innehållsrelaterad..av.1
  innehållsrik_1_A = mkA "innehållsrik" ; -- innehållsrik..av.1
  innehållsrikhet_1_N = mkN "innehållsrikhet" ; -- innehållsrikhet..nn.1
  innehållstom_1_A = mkA "innehållstom" "innehållstomt" "innehållstomma" "innehållstomma" "innehållstommare" "innehållstommast" "innehållstommaste" ; -- innehållstom..av.1
  innehållstomhet_1_N = mkN "innehållstomhet" ; -- innehållstomhet..nn.1
  innehållsöversikt_1_N = mkN "innehållsöversikt" "innehållsöversikter" ; -- innehållsöversikt..nn.1
  innekrog_1_N = mkN "innekrog" ; -- innekrog..nn.1
  inneliggande_1_A = mkA "inneliggande" ; -- inneliggande..av.1
  inner_1_N = mkN "inner" ; -- inner..nn.1
  innerbana_1_N = mkN "innerbana" ; -- innerbana..nn.1
  innerdörr_1_N = mkN "innerdörr" ; -- innerdörr..nn.1
  innerdörrhandtag_1_N = mkN "innerdörrhandtag" neutrum  ; -- innerdörrhandtag..nn.1
  innerficka_1_N = mkN "innerficka" ; -- innerficka..nn.1
  innerhand_1_N = mkN "innerhand" ; -- innerhand..nn.1
  innerkurva_1_N = mkN "innerkurva" ; -- innerkurva..nn.1
  innerlig_1_A = mkA "innerlig" ; -- innerlig..av.1
  innerligen_1_Adv = mkAdv "innerligen" ; -- innerligen..ab.1
  innerlighet_1_N = mkN "innerlighet" ; -- innerlighet..nn.1
  innersida_1_N = mkN "innersida" ; -- innersida..nn.1
  innerskär_1_N = mkN "innerskär" neutrum  ; -- innerskär..nn.1
  innerslang_1_N = mkN "innerslang" ; -- innerslang..nn.1
  innerst_1_Adv = mkAdv "innerst" ; -- innerst..ab.1
  innerstad_1_N = mkN "innerstad" "innerstäder" ; -- innerstad..nn.1
  innerstadsmässig_1_A = mkA "innerstadsmässig" ; -- innerstadsmässig..av.1
  innersula_1_N = mkN "innersula" ; -- innersula..nn.1
  innertak_1_N = mkN "innertak" neutrum  ; -- innertak..nn.1
  innervation_1_N = mkN "innervation" ; -- innervation..nn.1
  innervera_1_V = mkV "innerverar" ; -- innervera..vb.1
  innerverande_1_N = mkN "innerverande" ; -- innerverande..nn.1
  innerverbar_1_A = mkA "innerverbar" ; -- innerverbar..av.1
  innerverbarhet_1_N = mkN "innerverbarhet" ; -- innerverbarhet..nn.1
  innervering_1_N = mkN "innervering" ; -- innervering..nn.1
  innervägg_1_N = mkN "innervägg" ; -- innervägg..nn.1
  inneröra_1_N = mkN "inneröra" "innerörat" "inneröron" "inneröronen" ; -- inneröra..nn.1
  innesittare_1_N = mkN "innesittare" utrum  ; -- innesittare..nn.1
  innesko_1_N = mkN "innesko" "inneskor" ; -- innesko..nn.1
  innesluta_1_V = mkV "innesluta" "inneslöt" "inneslutit" ; -- innesluta..vb.1
  inneslutande_1_N = mkN "inneslutande" ; -- inneslutande..nn.1
  inneslutning_1_N = mkN "inneslutning" ; -- inneslutning..nn.1
  innestänga_1_V = mkV "innestänger" ; -- innestänga..vb.1
  innestängande_1_N = mkN "innestängande" ; -- innestängande..nn.1
  innestående_1_A = mkA "innestående" ; -- innestående..av.1
  innevarande_1_A = mkA "innevarande" ; -- innevarande..av.1
  innevånare_1_N = mkN "innevånare" utrum  ; -- innevånare..nn.1
  innovation_1_N = mkN "innovation" ; -- innovation..nn.1
  innovationskaskad_1_N = mkN "innovationskaskad" "innovationskaskader" ; -- innovationskaskad..nn.1
  innovativ_1_A = mkA "innovativ" ; -- innovativ..av.1
  innovatör_1_N = mkN "innovatör" "innovatörer" ; -- innovatör..nn.1
  innötning_1_N = mkN "innötning" ; -- innötning..nn.1
  inofficiell_1_A = mkA "inofficiell" ; -- inofficiell..av.1
  inokulation_1_N = mkN "inokulation" ; -- inokulation..nn.1
  inokulera_1_V = mkV "inokulerar" ; -- inokulera..vb.1
  inokulerande_1_N = mkN "inokulerande" ; -- inokulerande..nn.1
  inokulerbar_1_A = mkA "inokulerbar" ; -- inokulerbar..av.1
  inokulerbarhet_1_N = mkN "inokulerbarhet" ; -- inokulerbarhet..nn.1
  inokulering_1_N = mkN "inokulering" ; -- inokulering..nn.1
  inolja_1_V = mkV "inoljar" ; -- inolja..vb.1
  inoljande_1_N = mkN "inoljande" ; -- inoljande..nn.1
  inoljning_1_N = mkN "inoljning" ; -- inoljning..nn.1
  inombordare_1_N = mkN "inombordare" utrum  ; -- inombordare..nn.1
  inombordsmotor_1_N = mkN "inombordsmotor" "inombordsmotorer" ; -- inombordsmotor..nn.1
  inomhusbad_1_N = mkN "inomhusbad" neutrum  ; -- inomhusbad..nn.1
  inomhusbadande_1_A = mkA "inomhusbadande" ; -- inomhusbadande..av.1
  inomhusbadande_1_N = mkN "inomhusbadande" ; -- inomhusbadande..nn.1
  inomhusbelysning_1_N = mkN "inomhusbelysning" ; -- inomhusbelysning..nn.1
  inomhusbruk_1_N = mkN "inomhusbruk" neutrum  ; -- inomhusbruk..nn.1
  inomhusforskning_1_N = mkN "inomhusforskning" ; -- inomhusforskning..nn.1
  inomhusgolv_1_N = mkN "inomhusgolv" neutrum  ; -- inomhusgolv..nn.1
  inomhusidrott_1_N = mkN "inomhusidrott" "inomhusidrotter" ; -- inomhusidrott..nn.1
  inomhusluft_1_N = mkN "inomhusluft" ; -- inomhusluft..nn.1
  inomhuslöpslinga_1_N = mkN "inomhuslöpslinga" ; -- inomhuslöpslinga..nn.1
  inomhusvistelse_1_N = mkN "inomhusvistelse" "inomhusvistelser" ; -- inomhusvistelse..nn.1
  inomkatolsk_1_A = mkA "inomkatolsk" ; -- inomkatolsk..av.1
  inomvetenskaplig_1_A = mkA "inomvetenskaplig" ; -- inomvetenskaplig..av.1
  inomvetenskaplighet_1_N = mkN "inomvetenskaplighet" ; -- inomvetenskaplighet..nn.1
  inoperabel_1_A = mkA "inoperabel" ; -- inoperabel..av.1
  inoperera_1_V = mkV "inopererar" ; -- inoperera..vb.1
  inopererad_1_A = mkA "inopererad" ; -- inopererad..av.1
  inopportun_1_A = mkA "inopportun" ; -- inopportun..av.1
  inordna_1_V = mkV "inordnar" ; -- inordna..vb.1
  inordnande_1_N = mkN "inordnande" ; -- inordnande..nn.1
  inpackning_1_N = mkN "inpackning" ; -- inpackning..nn.1
  inpass_1_N = mkN "inpass" neutrum  ; -- inpass..nn.1
  inpassa_1_V = mkV "inpassar" ; -- inpassa..vb.1
  inpassande_1_N = mkN "inpassande" ; -- inpassande..nn.1
  inpassning_1_N = mkN "inpassning" ; -- inpassning..nn.1
  inpetad_1_A = mkA "inpetad" ; -- inpetad..av.1
  inpetning_1_N = mkN "inpetning" ; -- inpetning..nn.1
  inpiskad_1_A = mkA "inpiskad" ; -- inpiskad..av.1
  inpiskare_1_N = mkN "inpiskare" utrum  ; -- inpiskare..nn.1
  inplanerad_1_A = mkA "inplanerad" ; -- inplanerad..av.1
  inplanta_1_V = mkV "inplantar" ; -- inplanta..vb.1
  inplantande_1_N = mkN "inplantande" ; -- inplantande..nn.1
  inplantera_1_V = mkV "inplanterar" ; -- inplantera..vb.1
  inplanterande_1_N = mkN "inplanterande" ; -- inplanterande..nn.1
  inplanterbar_1_A = mkA "inplanterbar" ; -- inplanterbar..av.1
  inplanterbarhet_1_N = mkN "inplanterbarhet" ; -- inplanterbarhet..nn.1
  inplantering_1_N = mkN "inplantering" ; -- inplantering..nn.1
  inplantning_1_N = mkN "inplantning" ; -- inplantning..nn.1
  inplastad_1_A = mkA "inplastad" ; -- inplastad..av.1
  inpluggning_1_N = mkN "inpluggning" ; -- inpluggning..nn.1
  inpressa_1_V = mkV "inpressar" ; -- inpressa..vb.1
  inpressande_1_N = mkN "inpressande" ; -- inpressande..nn.1
  inpressning_1_N = mkN "inpressning" ; -- inpressning..nn.1
  inpricka_1_V = mkV "inprickar" ; -- inpricka..vb.1
  inprickande_1_N = mkN "inprickande" ; -- inprickande..nn.1
  inprogrammera_1_V = mkV "inprogrammerar" ; -- inprogrammera..vb.1
  inprogrammerande_1_N = mkN "inprogrammerande" ; -- inprogrammerande..nn.1
  inprogrammering_1_N = mkN "inprogrammering" ; -- inprogrammering..nn.1
  inprägla_1_V = mkV "inpräglar" ; -- inprägla..vb.1
  inpräglande_1_N = mkN "inpräglande" ; -- inpräglande..nn.1
  inprägling_1_N = mkN "inprägling" ; -- inprägling..nn.1
  inpränta_1_V = mkV "inpräntar" ; -- inpränta..vb.1
  inpräntande_1_N = mkN "inpräntande" ; -- inpräntande..nn.1
  inpräntning_1_N = mkN "inpräntning" ; -- inpräntning..nn.1
  input_1_N = mkN "input" ; -- input..nn.1
  inpyrd_1_A = mkA "inpyrd" "inpyrt" ; -- inpyrd..av.1
  inpyrdhet_1_N = mkN "inpyrdhet" ; -- inpyrdhet..nn.1
  inrama_1_V = mkV "inramar" ; -- inrama..vb.1
  inramande_1_N = mkN "inramande" ; -- inramande..nn.1
  inramning_1_N = mkN "inramning" ; -- inramning..nn.1
  inrangera_1_V = mkV "inrangerar" ; -- inrangera..vb.1
  inrangerande_1_N = mkN "inrangerande" ; -- inrangerande..nn.1
  inrangerbar_1_A = mkA "inrangerbar" ; -- inrangerbar..av.1
  inrangerbarhet_1_N = mkN "inrangerbarhet" ; -- inrangerbarhet..nn.1
  inrangering_1_N = mkN "inrangering" ; -- inrangering..nn.1
  inrapportera_1_V = mkV "inrapporterar" ; -- inrapportera..vb.1
  inrapporterande_1_N = mkN "inrapporterande" ; -- inrapporterande..nn.1
  inrapporterbar_1_A = mkA "inrapporterbar" ; -- inrapporterbar..av.1
  inrapporterbarhet_1_N = mkN "inrapporterbarhet" ; -- inrapporterbarhet..nn.1
  inrapportering_1_N = mkN "inrapportering" ; -- inrapportering..nn.1
  inreda_1_V = mkV "inreda" "inredde" "inrett" ; -- inreda..vb.1
  inredande_1_N = mkN "inredande" ; -- inredande..nn.1
  inredning_1_N = mkN "inredning" ; -- inredning..nn.1
  inredningsarkitekt_1_N = mkN "inredningsarkitekt" "inredningsarkitekter" ; -- inredningsarkitekt..nn.1
  inredningsdetalj_1_N = mkN "inredningsdetalj" "inredningsdetaljer" ; -- inredningsdetalj..nn.1
  inredningsfynd_1_N = mkN "inredningsfynd" neutrum  ; -- inredningsfynd..nn.1
  inredningsgenialitet_1_N = mkN "inredningsgenialitet" "inredningsgenialiteter" ; -- inredningsgenialitet..nn.1
  inredningsintresserad_1_A = mkA "inredningsintresserad" ; -- inredningsintresserad..av.1
  inredningsmässig_1_A = mkA "inredningsmässig" ; -- inredningsmässig..av.1
  inregistrera_1_V = mkV "inregistrerar" ; -- inregistrera..vb.1
  inregistrerande_1_N = mkN "inregistrerande" ; -- inregistrerande..nn.1
  inregistrerbar_1_A = mkA "inregistrerbar" ; -- inregistrerbar..av.1
  inregistrerbarhet_1_N = mkN "inregistrerbarhet" ; -- inregistrerbarhet..nn.1
  inregistrering_1_N = mkN "inregistrering" ; -- inregistrering..nn.1
  inremedicinsk_1_A = mkA "inremedicinsk" ; -- inremedicinsk..av.1
  inremission_1_N = mkN "inremission" ; -- inremission..nn.1
  inresa_1_N = mkN "inresa" ; -- inresa..nn.1
  inresa_1_V = mkV "inreser" ; -- inresa..vb.1
  inresande_1_N = mkN "inresande" ; -- inresande..nn.1
  inreseförbud_1_N = mkN "inreseförbud" neutrum  ; -- inreseförbud..nn.1
  inresekretorisk_1_A = mkA "inresekretorisk" ; -- inresekretorisk..av.1
  inresetillstånd_1_N = mkN "inresetillstånd" neutrum  ; -- inresetillstånd..nn.1
  inresevisum_1_N = mkN "inresevisum" neutrum  ; -- inresevisum..nn.1
  inridning_1_N = mkN "inridning" ; -- inridning..nn.1
  inriggad_1_A = mkA "inriggad" ; -- inriggad..av.1
  inriggare_1_N = mkN "inriggare" utrum  ; -- inriggare..nn.1
  inrikes_1_A = mkA "inrikes" ; -- inrikes..av.1
  inrikesavgång_1_N = mkN "inrikesavgång" ; -- inrikesavgång..nn.1
  inrikesdepartement_1_N = mkN "inrikesdepartement" neutrum  ; -- inrikesdepartement..nn.1
  inrikesflyg_1_N = mkN "inrikesflyg" neutrum  ; -- inrikesflyg..nn.1
  inrikesminister_1_N = mkN "inrikesminister" ; -- inrikesminister..nn.1
  inrikesministerium_1_N = mkN "inrikesministerium" "inrikesministeriet" "inrikesministerier" "inrikesministerierna" ; -- inrikesministerium..nn.1
  inrikespolitik_1_N = mkN "inrikespolitik" ; -- inrikespolitik..nn.1
  inrikespolitisk_1_A = mkA "inrikespolitisk" ; -- inrikespolitisk..av.1
  inrikestrafik_1_N = mkN "inrikestrafik" ; -- inrikestrafik..nn.1
  inrikta_1_V = mkV "inriktar" ; -- inrikta..vb.1
  inriktande_1_N = mkN "inriktande" ; -- inriktande..nn.1
  inriktning_1_N = mkN "inriktning" ; -- inriktning..nn.1
  inrim_1_N = mkN "inrim" "inrimmet" "inrim" "inrimmen" ; -- inrim..nn.1
  inringa_1_V = mkV "inringar" ; -- inringa..vb.1
  inringande_1_N = mkN "inringande" ; -- inringande..nn.1
  inringning_1_N = mkN "inringning" ; -- inringning..nn.1
  inrista_1_V = mkV "inristar" ; -- inrista..vb.1
  inristande_1_N = mkN "inristande" ; -- inristande..nn.1
  inristning_1_N = mkN "inristning" ; -- inristning..nn.1
  inritad_1_A = mkA "inritad" ; -- inritad..av.1
  inritning_1_N = mkN "inritning" ; -- inritning..nn.1
  inrop_1_N = mkN "inrop" neutrum  ; -- inrop..nn.1
  inropa_1_V = mkV "inropar" ; -- inropa..vb.1
  inropande_1_N = mkN "inropande" ; -- inropande..nn.1
  inropare_1_N = mkN "inropare" utrum  ; -- inropare..nn.1
  inropning_1_N = mkN "inropning" ; -- inropning..nn.1
  inrotad_1_A = mkA "inrotad" ; -- inrotad..av.1
  inrusande_1_N = mkN "inrusande" ; -- inrusande..nn.1
  inrusning_1_N = mkN "inrusning" ; -- inrusning..nn.1
  inrutad_1_A = mkA "inrutad" ; -- inrutad..av.1
  inryckning_1_N = mkN "inryckning" ; -- inryckning..nn.1
  inrymma_1_V = mkV "inrymmer" ; -- inrymma..vb.1
  inrymmande_1_N = mkN "inrymmande" ; -- inrymmande..nn.1
  inrymning_1_N = mkN "inrymning" ; -- inrymning..nn.1
  inräkna_1_V = mkV "inräknar" ; -- inräkna..vb.1
  inräknad_1_A = mkA "inräknad" ; -- inräknad..av.1
  inräknande_1_N = mkN "inräknande" ; -- inräknande..nn.1
  inräkning_1_N = mkN "inräkning" ; -- inräkning..nn.1
  inrätta_1_V = mkV "inrättar" ; -- inrätta..vb.1
  inrättad_1_A = mkA "inrättad" ; -- inrättad..av.1
  inrättande_1_N = mkN "inrättande" ; -- inrättande..nn.1
  inrättning_1_N = mkN "inrättning" ; -- inrättning..nn.1
  inrättning_2_N = mkN "inrättning" ; -- inrättning..nn.2
  inröstning_1_N = mkN "inröstning" ; -- inröstning..nn.1
  insaltning_1_N = mkN "insaltning" ; -- insaltning..nn.1
  insamla_1_V = mkV "insamlar" ; -- insamla..vb.1
  insamlande_1_N = mkN "insamlande" ; -- insamlande..nn.1
  insamlare_1_N = mkN "insamlare" utrum  ; -- insamlare..nn.1
  insamling_1_N = mkN "insamling" ; -- insamling..nn.1
  insats_1_N = mkN "insats" "insatser" ; -- insats..nn.1
  insatsfordon_1_N = mkN "insatsfordon" neutrum  ; -- insatsfordon..nn.1
  insatsförsvar_1_N = mkN "insatsförsvar" neutrum  ; -- insatsförsvar..nn.1
  insatsledare_1_N = mkN "insatsledare" utrum  ; -- insatsledare..nn.1
  insatslägenhet_1_N = mkN "insatslägenhet" "insatslägenheter" ; -- insatslägenhet..nn.1
  insatsstyrka_1_N = mkN "insatsstyrka" ; -- insatsstyrka..nn.1
  insatt_1_A = mkA "insatt" ; -- insatt..av.1
  inscenera_1_V = mkV "inscenerar" ; -- inscenera..vb.1
  inscenerande_1_N = mkN "inscenerande" ; -- inscenerande..nn.1
  inscenerbar_1_A = mkA "inscenerbar" ; -- inscenerbar..av.1
  inscenerbarhet_1_N = mkN "inscenerbarhet" ; -- inscenerbarhet..nn.1
  inscenering_1_N = mkN "inscenering" ; -- inscenering..nn.1
  inse_1_V = mkV "inse" "insåg" "insett" ; -- inse..vb.1
  inseende_1_N = mkN "inseende" ; -- inseende..nn.1
  insegel_1_N = mkN "insegel" neutrum  ; -- insegel..nn.1
  insegla_1_V = mkV "inseglar" ; -- insegla..vb.1
  inseglande_1_N = mkN "inseglande" ; -- inseglande..nn.1
  insegling_1_N = mkN "insegling" ; -- insegling..nn.1
  inseglingsfyr_1_N = mkN "inseglingsfyr" ; -- inseglingsfyr..nn.1
  inseglingsränna_1_N = mkN "inseglingsränna" ; -- inseglingsränna..nn.1
  insekt_1_N = mkN "insekt" "insekter" ; -- insekt..nn.1
  insekticid_1_N = mkN "insekticid" "insekticider" ; -- insekticid..nn.1
  insektsangrepp_1_N = mkN "insektsangrepp" neutrum  ; -- insektsangrepp..nn.1
  insektsbefruktning_1_N = mkN "insektsbefruktning" ; -- insektsbefruktning..nn.1
  insektsbett_1_N = mkN "insektsbett" neutrum  ; -- insektsbett..nn.1
  insektsblomma_1_N = mkN "insektsblomma" ; -- insektsblomma..nn.1
  insektsborttagare_1_N = mkN "insektsborttagare" utrum  ; -- insektsborttagare..nn.1
  insektsgift_1_N = mkN "insektsgift" "insektsgiftet" "insektsgifter" "insektsgifterna" ; -- insektsgift..nn.1
  insektskunnig_1_A = mkA "insektskunnig" ; -- insektskunnig..av.1
  insektskunnighet_1_N = mkN "insektskunnighet" ; -- insektskunnighet..nn.1
  insektsmedel_1_N = mkN "insektsmedel" neutrum  ; -- insektsmedel..nn.1
  insektsnål_1_N = mkN "insektsnål" ; -- insektsnål..nn.1
  insektsprotein_1_N = mkN "insektsprotein" "insektsproteinet" "insektsproteiner" "insektsproteinerna" ; -- insektsprotein..nn.1
  insektsrike_1_N = mkN "insektsrike" ; -- insektsrike..nn.1
  insektssamling_1_N = mkN "insektssamling" ; -- insektssamling..nn.1
  insektssax_1_N = mkN "insektssax" ; -- insektssax..nn.1
  insektsätande_1_A = mkA "insektsätande" ; -- insektsätande..av.1
  insektsätare_1_N = mkN "insektsätare" utrum  ; -- insektsätare..nn.1
  insemination_1_N = mkN "insemination" ; -- insemination..nn.1
  inseminera_1_V = mkV "inseminerar" ; -- inseminera..vb.1
  inseminerande_1_N = mkN "inseminerande" ; -- inseminerande..nn.1
  inseminerbar_1_A = mkA "inseminerbar" ; -- inseminerbar..av.1
  inseminerbarhet_1_N = mkN "inseminerbarhet" ; -- inseminerbarhet..nn.1
  inseminering_1_N = mkN "inseminering" ; -- inseminering..nn.1
  insida_1_N = mkN "insida" ; -- insida..nn.1
  insider_1_N = mkN "insider" ; -- insider..nn.1
  insidermål_1_N = mkN "insidermål" neutrum  ; -- insidermål..nn.1
  insideråtal_1_N = mkN "insideråtal" neutrum  ; -- insideråtal..nn.1
  insides_1_A = mkA "insides" ; -- insides..av.1
  insikt_1_N = mkN "insikt" "insikter" ; -- insikt..nn.1
  insiktsfull_1_A = mkA "insiktsfull" ; -- insiktsfull..av.1
  insiktsfullhet_1_N = mkN "insiktsfullhet" ; -- insiktsfullhet..nn.1
  insinuant_1_A = mkA "insinuant" "insinuant" ; -- insinuant..av.1
  insinuation_1_N = mkN "insinuation" ; -- insinuation..nn.1
  insinuationstung_1_A = mkA "insinuationstung" ; -- insinuationstung..av.1
  insinuera_1_V = mkV "insinuerar" ; -- insinuera..vb.1
  insinuerande_1_N = mkN "insinuerande" ; -- insinuerande..nn.1
  insinuerbar_1_A = mkA "insinuerbar" ; -- insinuerbar..av.1
  insinuerbarhet_1_N = mkN "insinuerbarhet" ; -- insinuerbarhet..nn.1
  insinuering_1_N = mkN "insinuering" ; -- insinuering..nn.1
  insistera_1_V = mkV "insisterar" ; -- insistera..vb.1
  insisterande_1_N = mkN "insisterande" ; -- insisterande..nn.1
  insistering_1_N = mkN "insistering" ; -- insistering..nn.1
  insjukna_1_V = mkV "insjuknar" ; -- insjukna..vb.1
  insjuknande_1_N = mkN "insjuknande" ; -- insjuknande..nn.1
  insjungning_1_N = mkN "insjungning" ; -- insjungning..nn.1
  insjunken_1_A = mkA "insjunken" ; -- insjunken..av.1
  insjö_1_N = mkN "insjö" ; -- insjö..nn.1
  insjöfisk_1_N = mkN "insjöfisk" ; -- insjöfisk..nn.1
  insjöfiske_1_N = mkN "insjöfiske" ; -- insjöfiske..nn.1
  inskaffa_1_V = mkV "inskaffar" ; -- inskaffa..vb.1
  inskeppa_1_V = mkV "inskeppar" ; -- inskeppa..vb.1
  inskeppande_1_N = mkN "inskeppande" ; -- inskeppande..nn.1
  inskeppning_1_N = mkN "inskeppning" ; -- inskeppning..nn.1
  inskickning_1_N = mkN "inskickning" ; -- inskickning..nn.1
  inskjuta_1_V = mkV "inskjuta" "insköt" "inskjutit" ; -- inskjuta..vb.1
  inskjutande_1_N = mkN "inskjutande" ; -- inskjutande..nn.1
  inskjutning_1_N = mkN "inskjutning" ; -- inskjutning..nn.1
  inskola_1_V = mkV "inskolar" ; -- inskola..vb.1
  inskolande_1_N = mkN "inskolande" ; -- inskolande..nn.1
  inskolning_1_N = mkN "inskolning" ; -- inskolning..nn.1
  inskolningsprocess_1_N = mkN "inskolningsprocess" "inskolningsprocesser" ; -- inskolningsprocess..nn.1
  inskott_1_N = mkN "inskott" neutrum  ; -- inskott..nn.1
  inskottsvokal_1_N = mkN "inskottsvokal" "inskottsvokaler" ; -- inskottsvokal..nn.1
  inskrida_1_V = mkV "inskrida" "inskred" "inskridit" ; -- inskrida..vb.1
  inskridande_1_N = mkN "inskridande" ; -- inskridande..nn.1
  inskrift_1_N = mkN "inskrift" "inskrifter" ; -- inskrift..nn.1
  inskription_1_N = mkN "inskription" ; -- inskription..nn.1
  inskriva_1_V = mkV "inskriva" "inskrev" "inskrivit" ; -- inskriva..vb.1
  inskrivande_1_N = mkN "inskrivande" ; -- inskrivande..nn.1
  inskrivning_1_N = mkN "inskrivning" ; -- inskrivning..nn.1
  inskrivningsbok_1_N = mkN "inskrivningsbok" "inskrivningsböcker" ; -- inskrivningsbok..nn.1
  inskrivningsdag_1_N = mkN "inskrivningsdag" ; -- inskrivningsdag..nn.1
  inskrivningsdomare_1_N = mkN "inskrivningsdomare" utrum  ; -- inskrivningsdomare..nn.1
  inskruvning_1_N = mkN "inskruvning" ; -- inskruvning..nn.1
  inskränka_1_V = mkV "inskränker" ; -- inskränka..vb.1
  inskränkande_1_N = mkN "inskränkande" ; -- inskränkande..nn.1
  inskränkning_1_N = mkN "inskränkning" ; -- inskränkning..nn.1
  inskränkt_1_A = mkA "inskränkt" "inskränkt" ; -- inskränkt..av.1
  inskränkthet_1_N = mkN "inskränkthet" "inskränktheter" ; -- inskränkthet..nn.1
  inskärning_1_N = mkN "inskärning" ; -- inskärning..nn.1
  inskärpa_1_V = mkV "inskärper" ; -- inskärpa..vb.1
  inskärpande_1_N = mkN "inskärpande" ; -- inskärpande..nn.1
  inskärpning_1_N = mkN "inskärpning" ; -- inskärpning..nn.1
  inslag_1_N = mkN "inslag" neutrum  ; -- inslag..nn.1
  inslagen_1_A = mkA "inslagen" ; -- inslagen..av.1
  inslagning_1_N = mkN "inslagning" ; -- inslagning..nn.1
  inslussad_1_A = mkA "inslussad" ; -- inslussad..av.1
  insläpad_1_A = mkA "insläpad" ; -- insläpad..av.1
  insläpp_1_N = mkN "insläpp" neutrum  ; -- insläpp..nn.1
  insläppning_1_N = mkN "insläppning" ; -- insläppning..nn.1
  inslående_1_N = mkN "inslående" ; -- inslående..nn.1
  insmickrande_1_A = mkA "insmickrande" ; -- insmickrande..av.1
  insmugglad_1_A = mkA "insmugglad" ; -- insmugglad..av.1
  insmuggling_1_N = mkN "insmuggling" ; -- insmuggling..nn.1
  insmyga_1_V = mkV "insmyga" "insmög" "insmugit" ; -- insmyga..vb.1
  insmygande_1_N = mkN "insmygande" ; -- insmygande..nn.1
  insmygning_1_N = mkN "insmygning" ; -- insmygning..nn.1
  insmälta_1_V = mkV "insmälta" "insmälter" "insmält" "insmälte" "insmält" "insmält" ; -- insmälta..vb.1
  insmältande_1_N = mkN "insmältande" ; -- insmältande..nn.1
  insmörjning_1_N = mkN "insmörjning" ; -- insmörjning..nn.1
  insnitt_1_N = mkN "insnitt" neutrum  ; -- insnitt..nn.1
  insnodd_1_A = mkA "insnodd" ; -- insnodd..av.1
  insnärjd_1_A = mkA "insnärjd" "insnärjt" ; -- insnärjd..av.1
  insnärjning_1_N = mkN "insnärjning" ; -- insnärjning..nn.1
  insnöad_1_A = mkA "insnöad" ; -- insnöad..av.1
  insnörd_1_A = mkA "insnörd" "insnört" ; -- insnörd..av.1
  insnörning_1_N = mkN "insnörning" ; -- insnörning..nn.1
  insolation_1_N = mkN "insolation" ; -- insolation..nn.1
  insolvens_1_N = mkN "insolvens" ; -- insolvens..nn.1
  insolvent_1_A = mkA "insolvent" "insolvent" ; -- insolvent..av.1
  insomna_1_V = mkV "insomnar" ; -- insomna..vb.1
  insomnande_1_N = mkN "insomnande" ; -- insomnande..nn.1
  insomningsdröm_1_N = mkN "insomningsdröm" "insomningsdrömmen" "insomningsdrömmar" "insomningsdrömmarna" ; -- insomningsdröm..nn.1
  inspark_1_N = mkN "inspark" ; -- inspark..nn.1
  inspektera_1_V = mkV "inspekterar" ; -- inspektera..vb.1
  inspekterande_1_N = mkN "inspekterande" ; -- inspekterande..nn.1
  inspekterbar_1_A = mkA "inspekterbar" ; -- inspekterbar..av.1
  inspekterbarhet_1_N = mkN "inspekterbarhet" ; -- inspekterbarhet..nn.1
  inspektering_1_N = mkN "inspektering" ; -- inspektering..nn.1
  inspektion_1_N = mkN "inspektion" ; -- inspektion..nn.1
  inspektor_1_N = mkN "inspektor" "inspektorer" ; -- inspektor..nn.1
  inspektör_1_N = mkN "inspektör" "inspektörer" ; -- inspektör..nn.1
  inspela_1_V = mkV "inspelar" ; -- inspela..vb.1
  inspelande_1_N = mkN "inspelande" ; -- inspelande..nn.1
  inspelning_1_N = mkN "inspelning" ; -- inspelning..nn.1
  inspelningsknapp_1_N = mkN "inspelningsknapp" ; -- inspelningsknapp..nn.1
  inspelningsplats_1_N = mkN "inspelningsplats" "inspelningsplatser" ; -- inspelningsplats..nn.1
  inspelningsstudio_1_N = mkN "inspelningsstudio" "inspelningsstudior" ; -- inspelningsstudio..nn.1
  inspicient_1_N = mkN "inspicient" "inspicienter" ; -- inspicient..nn.1
  inspiration_1_N = mkN "inspiration" ; -- inspiration..nn.1
  inspirationskälla_1_N = mkN "inspirationskälla" ; -- inspirationskälla..nn.1
  inspirationsmässig_1_A = mkA "inspirationsmässig" ; -- inspirationsmässig..av.1
  inspiratör_1_N = mkN "inspiratör" "inspiratörer" ; -- inspiratör..nn.1
  inspirera_1_V = mkV "inspirerar" ; -- inspirera..vb.1
  inspirerad_1_A = mkA "inspirerad" ; -- inspirerad..av.1
  inspirerande_1_N = mkN "inspirerande" ; -- inspirerande..nn.1
  inspirerbar_1_A = mkA "inspirerbar" ; -- inspirerbar..av.1
  inspirerbarhet_1_N = mkN "inspirerbarhet" ; -- inspirerbarhet..nn.1
  inspirering_1_N = mkN "inspirering" ; -- inspirering..nn.1
  insprutning_1_N = mkN "insprutning" ; -- insprutning..nn.1
  insprutningsmotor_1_N = mkN "insprutningsmotor" "insprutningsmotorer" ; -- insprutningsmotor..nn.1
  insprutningsmunstycke_1_N = mkN "insprutningsmunstycke" ; -- insprutningsmunstycke..nn.1
  insprängd_1_A = mkA "insprängd" "insprängt" ; -- insprängd..av.1
  inspärra_1_V = mkV "inspärrar" ; -- inspärra..vb.1
  inspärrande_1_N = mkN "inspärrande" ; -- inspärrande..nn.1
  inspärrning_1_N = mkN "inspärrning" ; -- inspärrning..nn.1
  instabil_1_A = mkA "instabil" ; -- instabil..av.1
  instabilitet_1_N = mkN "instabilitet" "instabiliteter" ; -- instabilitet..nn.1
  installand_1_N = mkN "installand" "installander" ; -- installand..nn.1
  installation_1_N = mkN "installation" ; -- installation..nn.1
  installationsföreläsning_1_N = mkN "installationsföreläsning" ; -- installationsföreläsning..nn.1
  installationskabel_1_N = mkN "installationskabel" ; -- installationskabel..nn.1
  installationstal_1_N = mkN "installationstal" neutrum  ; -- installationstal..nn.1
  installator_1_N = mkN "installator" "installatorer" ; -- installator..nn.1
  installatör_1_N = mkN "installatör" "installatörer" ; -- installatör..nn.1
  installera_1_V = mkV "installerar" ; -- installera..vb.1
  installerande_1_N = mkN "installerande" ; -- installerande..nn.1
  installerbar_1_A = mkA "installerbar" ; -- installerbar..av.1
  installerbarhet_1_N = mkN "installerbarhet" ; -- installerbarhet..nn.1
  installering_1_N = mkN "installering" ; -- installering..nn.1
  instans_1_N = mkN "instans" "instanser" ; -- instans..nn.1
  insteg_1_N = mkN "insteg" ; -- insteg..nn.1
  instegsjobb_1_N = mkN "instegsjobb" neutrum  ; -- instegsjobb..nn.1
  instifta_1_V = mkV "instiftar" ; -- instifta..vb.1
  instiftande_1_N = mkN "instiftande" ; -- instiftande..nn.1
  instiftare_1_N = mkN "instiftare" utrum  ; -- instiftare..nn.1
  instiftelse_1_N = mkN "instiftelse" "instiftelser" ; -- instiftelse..nn.1
  instiftning_1_N = mkN "instiftning" ; -- instiftning..nn.1
  instinkt_1_N = mkN "instinkt" "instinkter" ; -- instinkt..nn.1
  instinktiv_1_A = mkA "instinktiv" ; -- instinktiv..av.1
  instinktliv_1_N = mkN "instinktliv" neutrum  ; -- instinktliv..nn.1
  instinktmässig_1_A = mkA "instinktmässig" ; -- instinktmässig..av.1
  institut_1_N = mkN "institut" neutrum  ; -- institut..nn.1
  institution_1_N = mkN "institution" ; -- institution..nn.1
  institutionalisera_1_V = mkV "institutionaliserar" ; -- institutionalisera..vb.1
  institutionaliserande_1_N = mkN "institutionaliserande" ; -- institutionaliserande..nn.1
  institutionaliserbar_1_A = mkA "institutionaliserbar" ; -- institutionaliserbar..av.1
  institutionaliserbarhet_1_N = mkN "institutionaliserbarhet" ; -- institutionaliserbarhet..nn.1
  institutionalisering_1_N = mkN "institutionalisering" ; -- institutionalisering..nn.1
  institutionell_1_A = mkA "institutionell" ; -- institutionell..av.1
  institutionsskada_1_N = mkN "institutionsskada" ; -- institutionsskada..nn.1
  institutionsskadad_1_A = mkA "institutionsskadad" ; -- institutionsskadad..av.1
  institutionsteater_1_N = mkN "institutionsteater" ; -- institutionsteater..nn.1
  instoppning_1_N = mkN "instoppning" ; -- instoppning..nn.1
  instroduktionsföreläsning_1_N = mkN "instroduktionsföreläsning" ; -- instroduktionsföreläsning..nn.1
  instruera_1_V = mkV "instruerar" ; -- instruera..vb.1
  instruerande_1_N = mkN "instruerande" ; -- instruerande..nn.1
  instruerbar_1_A = mkA "instruerbar" ; -- instruerbar..av.1
  instruerbarhet_1_N = mkN "instruerbarhet" ; -- instruerbarhet..nn.1
  instruering_1_N = mkN "instruering" ; -- instruering..nn.1
  instruktion_1_N = mkN "instruktion" ; -- instruktion..nn.1
  instruktionsmanual_1_N = mkN "instruktionsmanual" "instruktionsmanualer" ; -- instruktionsmanual..nn.1
  instruktiv_1_A = mkA "instruktiv" ; -- instruktiv..av.1
  instruktör_1_N = mkN "instruktör" "instruktörer" ; -- instruktör..nn.1
  instrument_1_N = mkN "instrument" neutrum  ; -- instrument..nn.1
  instrumental_1_A = mkA "instrumental" ; -- instrumental..av.1
  instrumentalis_1_N = mkN "instrumentalis" ; -- instrumentalis..nn.1
  instrumentalist_1_N = mkN "instrumentalist" "instrumentalister" ; -- instrumentalist..nn.1
  instrumentalmusik_1_N = mkN "instrumentalmusik" ; -- instrumentalmusik..nn.1
  instrumentarium_1_N = mkN "instrumentarium" "instrumentariet" "instrumentarier" "instrumentarierna" ; -- instrumentarium..nn.1
  instrumentation_1_N = mkN "instrumentation" ; -- instrumentation..nn.1
  instrumentbelysning_1_N = mkN "instrumentbelysning" ; -- instrumentbelysning..nn.1
  instrumentbräda_1_N = mkN "instrumentbräda" ; -- instrumentbräda..nn.1
  instrumentbräde_1_N = mkN "instrumentbräde" ; -- instrumentbräde..nn.1
  instrumentell_1_A = mkA "instrumentell" ; -- instrumentell..av.1
  instrumentera_1_V = mkV "instrumenterar" ; -- instrumentera..vb.1
  instrumenterande_1_N = mkN "instrumenterande" ; -- instrumenterande..nn.1
  instrumenterbar_1_A = mkA "instrumenterbar" ; -- instrumenterbar..av.1
  instrumenterbarhet_1_N = mkN "instrumenterbarhet" ; -- instrumenterbarhet..nn.1
  instrumentering_1_N = mkN "instrumentering" ; -- instrumentering..nn.1
  instrumentflygning_1_N = mkN "instrumentflygning" ; -- instrumentflygning..nn.1
  instrumentlåda_1_N = mkN "instrumentlåda" ; -- instrumentlåda..nn.1
  instrumentmakare_1_N = mkN "instrumentmakare" utrum  ; -- instrumentmakare..nn.1
  instrumentpanel_1_N = mkN "instrumentpanel" "instrumentpaneler" ; -- instrumentpanel..nn.1
  instrumentväska_1_N = mkN "instrumentväska" ; -- instrumentväska..nn.1
  instråla_1_V = mkV "instrålar" ; -- instråla..vb.1
  instrålande_1_N = mkN "instrålande" ; -- instrålande..nn.1
  instrålning_1_N = mkN "instrålning" ; -- instrålning..nn.1
  inström_1_N = mkN "inström" "inströmmen" "inströmmar" "inströmmarna" ; -- inström..nn.1
  inströmning_1_N = mkN "inströmning" ; -- inströmning..nn.1
  instudera_1_V = mkV "instuderar" ; -- instudera..vb.1
  instuderande_1_N = mkN "instuderande" ; -- instuderande..nn.1
  instuderbar_1_A = mkA "instuderbar" ; -- instuderbar..av.1
  instuderbarhet_1_N = mkN "instuderbarhet" ; -- instuderbarhet..nn.1
  instudering_1_N = mkN "instudering" ; -- instudering..nn.1
  instunda_1_V = mkV "instundar" ; -- instunda..vb.1
  instundande_1_N = mkN "instundande" ; -- instundande..nn.1
  instuvning_1_N = mkN "instuvning" ; -- instuvning..nn.1
  inställa_1_V = mkV "inställer" ; -- inställa..vb.1
  inställande_1_N = mkN "inställande" ; -- inställande..nn.1
  inställbar_1_A = mkA "inställbar" ; -- inställbar..av.1
  inställbarhet_1_N = mkN "inställbarhet" ; -- inställbarhet..nn.1
  inställd_1_A = mkA "inställd" "inställt" ; -- inställd..av.1
  inställelse_1_N = mkN "inställelse" "inställelser" ; -- inställelse..nn.1
  inställelsedag_1_N = mkN "inställelsedag" ; -- inställelsedag..nn.1
  inställning_1_N = mkN "inställning" ; -- inställning..nn.1
  inställningsbar_1_A = mkA "inställningsbar" ; -- inställningsbar..av.1
  inställningsbarhet_1_N = mkN "inställningsbarhet" ; -- inställningsbarhet..nn.1
  inställningsskruv_1_N = mkN "inställningsskruv" ; -- inställningsskruv..nn.1
  inställsam_1_A = mkA "inställsam" "inställsamt" "inställsamma" "inställsamma" "inställsammare" "inställsammast" "inställsammaste" ; -- inställsam..av.1
  inställsamhet_1_N = mkN "inställsamhet" "inställsamheter" ; -- inställsamhet..nn.1
  instämma_1_V = mkV "instämmer" ; -- instämma..vb.1
  instämma_2_V = mkV "instämmer" ; -- instämma..vb.2
  instämmande_1_N = mkN "instämmande" ; -- instämmande..nn.1
  instämning_1_N = mkN "instämning" ; -- instämning..nn.1
  instänga_1_V = mkV "instänger" ; -- instänga..vb.1
  instängande_1_N = mkN "instängande" ; -- instängande..nn.1
  instängd_1_A = mkA "instängd" "instängt" ; -- instängd..av.1
  instängdhet_1_N = mkN "instängdhet" ; -- instängdhet..nn.1
  instängning_1_N = mkN "instängning" ; -- instängning..nn.1
  instörtning_1_N = mkN "instörtning" ; -- instörtning..nn.1
  insubordination_1_N = mkN "insubordination" ; -- insubordination..nn.1
  insufficiens_1_N = mkN "insufficiens" "insufficienser" ; -- insufficiens..nn.1
  insuga_1_V = mkV "insuga" "insög" "insugit" ; -- insuga..vb.1
  insugande_1_N = mkN "insugande" ; -- insugande..nn.1
  insugning_1_N = mkN "insugning" ; -- insugning..nn.1
  insugningsventil_1_N = mkN "insugningsventil" "insugningsventiler" ; -- insugningsventil..nn.1
  insulin_1_N = mkN "insulin" "insuliner" ; -- insulin..nn.1
  insulinchock_1_N = mkN "insulinchock" "insulinchocker" ; -- insulinchock..nn.1
  insulinproducerande_1_A = mkA "insulinproducerande" ; -- insulinproducerande..av.1
  insulär_1_A = mkA "insulär" ; -- insulär..av.1
  insupa_1_V = mkV "insupa" "insöp" "insupit" ; -- insupa..vb.1
  insupande_1_N = mkN "insupande" ; -- insupande..nn.1
  insupning_1_N = mkN "insupning" ; -- insupning..nn.1
  insurgent_1_N = mkN "insurgent" "insurgenter" ; -- insurgent..nn.1
  insutten_1_A = mkA "insutten" ; -- insutten..av.1
  insvepa_1_V = mkV "insveper" ; -- insvepa..vb.1
  insvepande_1_N = mkN "insvepande" ; -- insvepande..nn.1
  insvepning_1_N = mkN "insvepning" ; -- insvepning..nn.1
  insvängd_1_A = mkA "insvängd" "insvängt" ; -- insvängd..av.1
  insvängning_1_N = mkN "insvängning" ; -- insvängning..nn.1
  insydd_1_A = mkA "insydd" ; -- insydd..av.1
  insyltad_1_A = mkA "insyltad" ; -- insyltad..av.1
  insyltning_1_N = mkN "insyltning" ; -- insyltning..nn.1
  insyn_1_N = mkN "insyn" ; -- insyn..nn.1
  insända_1_V = mkV "insänder" ; -- insända..vb.1
  insändande_1_N = mkN "insändande" ; -- insändande..nn.1
  insändare_1_N = mkN "insändare" utrum  ; -- insändare..nn.1
  insändarskribent_1_N = mkN "insändarskribent" "insändarskribenter" ; -- insändarskribent..nn.1
  insändning_1_N = mkN "insändning" ; -- insändning..nn.1
  insätta_1_V = mkV "insätta" "insätter" "insätt" "insatte" "insatt" "insatt" ; -- insätta..vb.1
  insättande_1_N = mkN "insättande" ; -- insättande..nn.1
  insättning_1_N = mkN "insättning" ; -- insättning..nn.1
  insättningsgaranti_1_N = mkN "insättningsgaranti" "insättningsgarantier" ; -- insättningsgaranti..nn.1
  insöndra_1_V = mkV "insöndrar" ; -- insöndra..vb.1
  insöndrande_1_N = mkN "insöndrande" ; -- insöndrande..nn.1
  insöndring_1_N = mkN "insöndring" ; -- insöndring..nn.1
  inta_1_V = mkV "intaga" "intog" "intagit" ; -- inta..vb.1
  intag_1_N = mkN "intag" neutrum  ; -- intag..nn.1
  intagande_1_A = mkA "intagande" ; -- intagande..av.1
  intagande_1_N = mkN "intagande" ; -- intagande..nn.1
  intagen_1_A = mkA "intagen" ; -- intagen..av.1
  intagning_1_N = mkN "intagning" ; -- intagning..nn.1
  intagningshandling_1_N = mkN "intagningshandling" ; -- intagningshandling..nn.1
  intagsdamm_1_N = mkN "intagsdamm" ; -- intagsdamm..nn.1
  intagsluft_1_N = mkN "intagsluft" ; -- intagsluft..nn.1
  intakt_1_A = mkA "intakt" "intakt" ; -- intakt..av.1
  intala_1_V = mkV "intalar" ; -- intala..vb.1
  intalan_1_N = mkN "intalan" "intalan" "intalanden" "intalandena" ; -- intalan..nn.1
  intalande_1_N = mkN "intalande" ; -- intalande..nn.1
  intalning_1_N = mkN "intalning" ; -- intalning..nn.1
  intarsia_1_N = mkN "intarsia" ; -- intarsia..nn.1
  inte_1_Adv = mkAdv "inte" ; -- inte..ab.1
  inteckna_1_V = mkV "intecknar" ; -- inteckna..vb.1
  intecknande_1_N = mkN "intecknande" ; -- intecknande..nn.1
  inteckning_1_N = mkN "inteckning" ; -- inteckning..nn.1
  inteckningslån_1_N = mkN "inteckningslån" neutrum  ; -- inteckningslån..nn.1
  integral_1_N = mkN "integral" "integraler" ; -- integral..nn.1
  integralhjälm_1_N = mkN "integralhjälm" ; -- integralhjälm..nn.1
  integralkalkyl_1_N = mkN "integralkalkyl" "integralkalkyler" ; -- integralkalkyl..nn.1
  integrand_1_N = mkN "integrand" "integrander" ; -- integrand..nn.1
  integration_1_N = mkN "integration" ; -- integration..nn.1
  integrationsdebatt_1_N = mkN "integrationsdebatt" "integrationsdebatter" ; -- integrationsdebatt..nn.1
  integrationspolitik_1_N = mkN "integrationspolitik" ; -- integrationspolitik..nn.1
  integrationspolitisk_1_A = mkA "integrationspolitisk" ; -- integrationspolitisk..av.1
  integrera_1_V = mkV "integrerar" ; -- integrera..vb.1
  integrerande_1_A = mkA "integrerande" ; -- integrerande..av.1
  integrerande_1_N = mkN "integrerande" ; -- integrerande..nn.1
  integrerbar_1_A = mkA "integrerbar" ; -- integrerbar..av.1
  integrerbarhet_1_N = mkN "integrerbarhet" ; -- integrerbarhet..nn.1
  integrering_1_N = mkN "integrering" ; -- integrering..nn.1
  integritet_1_N = mkN "integritet" "integriteter" ; -- integritet..nn.1
  integritetskränkande_1_A = mkA "integritetskränkande" ; -- integritetskränkande..av.1
  integritetskänslig_1_A = mkA "integritetskänslig" ; -- integritetskänslig..av.1
  integritetsmässig_1_A = mkA "integritetsmässig" ; -- integritetsmässig..av.1
  integritetsskydd_1_N = mkN "integritetsskydd" neutrum  ; -- integritetsskydd..nn.1
  integritetsöverskridande_1_A = mkA "integritetsöverskridande" ; -- integritetsöverskridande..av.1
  intellekt_1_N = mkN "intellekt" neutrum  ; -- intellekt..nn.1
  intellektualisera_1_V = mkV "intellektualiserar" ; -- intellektualisera..vb.1
  intellektualiserande_1_N = mkN "intellektualiserande" ; -- intellektualiserande..nn.1
  intellektualiserbar_1_A = mkA "intellektualiserbar" ; -- intellektualiserbar..av.1
  intellektualiserbarhet_1_N = mkN "intellektualiserbarhet" ; -- intellektualiserbarhet..nn.1
  intellektualisering_1_N = mkN "intellektualisering" ; -- intellektualisering..nn.1
  intellektualism_1_N = mkN "intellektualism" "intellektualismer" ; -- intellektualism..nn.1
  intellektualist_1_N = mkN "intellektualist" "intellektualister" ; -- intellektualist..nn.1
  intellektualistisk_1_A = mkA "intellektualistisk" ; -- intellektualistisk..av.1
  intellektuell_1_A = mkA "intellektuell" ; -- intellektuell..av.1
  intelligens_1_N = mkN "intelligens" "intelligenser" ; -- intelligens..nn.1
  intelligensaristokrat_1_N = mkN "intelligensaristokrat" "intelligensaristokrater" ; -- intelligensaristokrat..nn.1
  intelligenskvot_1_N = mkN "intelligenskvot" "intelligenskvoter" ; -- intelligenskvot..nn.1
  intelligensmässig_1_A = mkA "intelligensmässig" ; -- intelligensmässig..av.1
  intelligensmätning_1_N = mkN "intelligensmätning" ; -- intelligensmätning..nn.1
  intelligenstest_1_N = mkN "intelligenstest" neutrum  ; -- intelligenstest..nn.1
  intelligensålder_1_N = mkN "intelligensålder" ; -- intelligensålder..nn.1
  intelligent_1_A = mkA "intelligent" "intelligent" ; -- intelligent..av.1
  intelligentia_1_N = mkN "intelligentia" ; -- intelligentia..nn.1
  intelligentsia_1_N = mkN "intelligentsia" ; -- intelligentsia..nn.1
  intendent_1_N = mkN "intendent" "intendenter" ; -- intendent..nn.1
  intendentur_1_N = mkN "intendentur" "intendenturer" ; -- intendentur..nn.1
  intendenturtjänst_1_N = mkN "intendenturtjänst" "intendenturtjänster" ; -- intendenturtjänst..nn.1
  intensifiera_1_V = mkV "intensifierar" ; -- intensifiera..vb.1
  intensifierande_1_N = mkN "intensifierande" ; -- intensifierande..nn.1
  intensifierbar_1_A = mkA "intensifierbar" ; -- intensifierbar..av.1
  intensifierbarhet_1_N = mkN "intensifierbarhet" ; -- intensifierbarhet..nn.1
  intensifiering_1_N = mkN "intensifiering" ; -- intensifiering..nn.1
  intension_1_N = mkN "intension" ; -- intension..nn.1
  intensitet_1_N = mkN "intensitet" "intensiteter" ; -- intensitet..nn.1
  intensiv_1_A = mkA "intensiv" ; -- intensiv..av.1
  intensiv_1_N = mkN "intensiv" "intensiver" ; -- intensiv..nn.1
  intensivera_1_V = mkV "intensiverar" ; -- intensivera..vb.1
  intensiverande_1_N = mkN "intensiverande" ; -- intensiverande..nn.1
  intensiverbar_1_A = mkA "intensiverbar" ; -- intensiverbar..av.1
  intensiverbarhet_1_N = mkN "intensiverbarhet" ; -- intensiverbarhet..nn.1
  intensivering_1_N = mkN "intensivering" ; -- intensivering..nn.1
  intensivundersökning_1_N = mkN "intensivundersökning" ; -- intensivundersökning..nn.1
  intensivvård_1_N = mkN "intensivvård" ; -- intensivvård..nn.1
  intensivvårdsavdelning_1_N = mkN "intensivvårdsavdelning" ; -- intensivvårdsavdelning..nn.1
  intensivvårdssäng_1_N = mkN "intensivvårdssäng" ; -- intensivvårdssäng..nn.1
  intensivvårdsutrustning_1_N = mkN "intensivvårdsutrustning" ; -- intensivvårdsutrustning..nn.1
  intention_1_N = mkN "intention" ; -- intention..nn.1
  intentionsdjup_1_N = mkN "intentionsdjup" neutrum  ; -- intentionsdjup..nn.1
  interagera_1_V = mkV "interagerar" ; -- interagera..vb.1
  interagerande_1_N = mkN "interagerande" ; -- interagerande..nn.1
  interagering_1_N = mkN "interagering" ; -- interagering..nn.1
  interaktion_1_N = mkN "interaktion" ; -- interaktion..nn.1
  interaktiv_1_A = mkA "interaktiv" ; -- interaktiv..av.1
  intercitytåg_1_N = mkN "intercitytåg" neutrum  ; -- intercitytåg..nn.1
  interdental_1_A = mkA "interdental" ; -- interdental..av.1
  interdental_1_N = mkN "interdental" "interdentaler" ; -- interdental..nn.1
  interdikt_1_N = mkN "interdikt" neutrum  ; -- interdikt..nn.1
  interetnisk_1_A = mkA "interetnisk" ; -- interetnisk..av.1
  interferens_1_N = mkN "interferens" "interferenser" ; -- interferens..nn.1
  interferens_2_N = mkN "interferens" ; -- interferens..nn.2
  interferensmönster_1_N = mkN "interferensmönster" neutrum  ; -- interferensmönster..nn.1
  interferera_1_V = mkV "interfererar" ; -- interferera..vb.1
  interfererande_1_N = mkN "interfererande" ; -- interfererande..nn.1
  interferering_1_N = mkN "interferering" ; -- interferering..nn.1
  interferon_1_N = mkN "interferon" neutrum  ; -- interferon..nn.1
  interfix_1_N = mkN "interfix" neutrum  ; -- interfix..nn.1
  interfoliera_1_V = mkV "interfolierar" ; -- interfoliera..vb.1
  interfolierande_1_N = mkN "interfolierande" ; -- interfolierande..nn.1
  interfolierbar_1_A = mkA "interfolierbar" ; -- interfolierbar..av.1
  interfolierbarhet_1_N = mkN "interfolierbarhet" ; -- interfolierbarhet..nn.1
  interfoliering_1_N = mkN "interfoliering" ; -- interfoliering..nn.1
  interglacial_1_A = mkA "interglacial" ; -- interglacial..av.1
  interglacial_1_N = mkN "interglacial" "interglacialer" ; -- interglacial..nn.1
  interglacialtid_1_N = mkN "interglacialtid" "interglacialtider" ; -- interglacialtid..nn.1
  interimistisk_1_A = mkA "interimistisk" ; -- interimistisk..av.1
  interimsbestämmelse_1_N = mkN "interimsbestämmelse" "interimsbestämmelser" ; -- interimsbestämmelse..nn.1
  interimsbevis_1_N = mkN "interimsbevis" neutrum  ; -- interimsbevis..nn.1
  interimsregering_1_N = mkN "interimsregering" ; -- interimsregering..nn.1
  interimsstyrelse_1_N = mkN "interimsstyrelse" "interimsstyrelser" ; -- interimsstyrelse..nn.1
  interinstitutionell_1_A = mkA "interinstitutionell" ; -- interinstitutionell..av.1
  interiör_1_N = mkN "interiör" "interiörer" ; -- interiör..nn.1
  interiörbelysning_1_N = mkN "interiörbelysning" ; -- interiörbelysning..nn.1
  interjektion_1_N = mkN "interjektion" ; -- interjektion..nn.1
  interkommunal_1_A = mkA "interkommunal" ; -- interkommunal..av.1
  interkontinental_1_A = mkA "interkontinental" ; -- interkontinental..av.1
  interkulturell_1_A = mkA "interkulturell" ; -- interkulturell..av.1
  interlokutör_1_N = mkN "interlokutör" "interlokutörer" ; -- interlokutör..nn.1
  interludium_1_N = mkN "interludium" "interludiet" "interludier" "interludierna" ; -- interludium..nn.1
  intermezzo_1_N = mkN "intermezzo" "intermezzot" "intermezzon" "intermezzona" ; -- intermezzo..nn.1
  intermittens_1_N = mkN "intermittens" ; -- intermittens..nn.1
  intermittent_1_A = mkA "intermittent" "intermittent" ; -- intermittent..av.1
  intern_1_A = mkA "intern" ; -- intern..av.1
  intern_1_N = mkN "intern" "interner" ; -- intern..nn.1
  internalisera_1_V = mkV "internaliserar" ; -- internalisera..vb.1
  internaliserande_1_N = mkN "internaliserande" ; -- internaliserande..nn.1
  internaliserbar_1_A = mkA "internaliserbar" ; -- internaliserbar..av.1
  internaliserbarhet_1_N = mkN "internaliserbarhet" ; -- internaliserbarhet..nn.1
  internalisering_1_N = mkN "internalisering" ; -- internalisering..nn.1
  internat_1_N = mkN "internat" neutrum  ; -- internat..nn.1
  international_1_N = mkN "international" "internationaler" ; -- international..nn.1
  internationalisera_1_V = mkV "internationaliserar" ; -- internationalisera..vb.1
  internationaliserande_1_N = mkN "internationaliserande" ; -- internationaliserande..nn.1
  internationaliserbar_1_A = mkA "internationaliserbar" ; -- internationaliserbar..av.1
  internationaliserbarhet_1_N = mkN "internationaliserbarhet" ; -- internationaliserbarhet..nn.1
  internationalisering_1_N = mkN "internationalisering" ; -- internationalisering..nn.1
  internationalism_1_N = mkN "internationalism" "internationalismer" ; -- internationalism..nn.1
  internationalist_1_N = mkN "internationalist" "internationalister" ; -- internationalist..nn.1
  internationalistisk_1_A = mkA "internationalistisk" ; -- internationalistisk..av.1
  internationell_1_A = mkA "internationell" ; -- internationell..av.1
  internatskola_1_N = mkN "internatskola" ; -- internatskola..nn.1
  internera_1_V = mkV "internerar" ; -- internera..vb.1
  internerande_1_N = mkN "internerande" ; -- internerande..nn.1
  internerbar_1_A = mkA "internerbar" ; -- internerbar..av.1
  internerbarhet_1_N = mkN "internerbarhet" ; -- internerbarhet..nn.1
  internering_1_N = mkN "internering" ; -- internering..nn.1
  interneringsläger_1_N = mkN "interneringsläger" neutrum  ; -- interneringsläger..nn.1
  internet_1_N = mkN "internet" ; -- internet..nn.1
  internetanvändare_1_N = mkN "internetanvändare" utrum  ; -- internetanvändare..nn.1
  internetartikel_1_N = mkN "internetartikel" ; -- internetartikel..nn.1
  internetbank_1_N = mkN "internetbank" "internetbanker" ; -- internetbank..nn.1
  internetbaserad_1_A = mkA "internetbaserad" ; -- internetbaserad..av.1
  internetdiskussion_1_N = mkN "internetdiskussion" ; -- internetdiskussion..nn.1
  internetforum_1_N = mkN "internetforum" neutrum  ; -- internetforum..nn.1
  internetoperatör_1_N = mkN "internetoperatör" "internetoperatörer" ; -- internetoperatör..nn.1
  internetrelaterad_1_A = mkA "internetrelaterad" ; -- internetrelaterad..av.1
  internetsajt_1_N = mkN "internetsajt" "internetsajter" ; -- internetsajt..nn.1
  internetsida_1_N = mkN "internetsida" ; -- internetsida..nn.1
  internetskepticism_1_N = mkN "internetskepticism" "internetskepticismer" ; -- internetskepticism..nn.1
  internettroll_1_N = mkN "internettroll" neutrum  ; -- internettroll..nn.1
  internist_1_N = mkN "internist" "internister" ; -- internist..nn.1
  internordisk_1_A = mkA "internordisk" ; -- internordisk..av.1
  internutbildning_1_N = mkN "internutbildning" ; -- internutbildning..nn.1
  internutredning_1_N = mkN "internutredning" ; -- internutredning..nn.1
  internutredningsgrupp_1_N = mkN "internutredningsgrupp" "internutredningsgrupper" ; -- internutredningsgrupp..nn.1
  interorganisatorisk_1_A = mkA "interorganisatorisk" ; -- interorganisatorisk..av.1
  interparlamentarisk_1_A = mkA "interparlamentarisk" ; -- interparlamentarisk..av.1
  interpellant_1_N = mkN "interpellant" "interpellanter" ; -- interpellant..nn.1
  interpellation_1_N = mkN "interpellation" ; -- interpellation..nn.1
  interpellationsdebatt_1_N = mkN "interpellationsdebatt" "interpellationsdebatter" ; -- interpellationsdebatt..nn.1
  interpellera_1_V = mkV "interpellerar" ; -- interpellera..vb.1
  interpellerande_1_N = mkN "interpellerande" ; -- interpellerande..nn.1
  interpellerbar_1_A = mkA "interpellerbar" ; -- interpellerbar..av.1
  interpellerbarhet_1_N = mkN "interpellerbarhet" ; -- interpellerbarhet..nn.1
  interpellering_1_N = mkN "interpellering" ; -- interpellering..nn.1
  interplanetarisk_1_A = mkA "interplanetarisk" ; -- interplanetarisk..av.1
  interpolation_1_N = mkN "interpolation" ; -- interpolation..nn.1
  interpolera_1_V = mkV "interpolerar" ; -- interpolera..vb.1
  interpolerande_1_N = mkN "interpolerande" ; -- interpolerande..nn.1
  interpolerbar_1_A = mkA "interpolerbar" ; -- interpolerbar..av.1
  interpolerbarhet_1_N = mkN "interpolerbarhet" ; -- interpolerbarhet..nn.1
  interpolering_1_N = mkN "interpolering" ; -- interpolering..nn.1
  interpret_1_N = mkN "interpret" "interpreter" ; -- interpret..nn.1
  interpretation_1_N = mkN "interpretation" ; -- interpretation..nn.1
  interpretera_1_V = mkV "interpreterar" ; -- interpretera..vb.1
  interpreterande_1_N = mkN "interpreterande" ; -- interpreterande..nn.1
  interpreterbar_1_A = mkA "interpreterbar" ; -- interpreterbar..av.1
  interpreterbarhet_1_N = mkN "interpreterbarhet" ; -- interpreterbarhet..nn.1
  interpretering_1_N = mkN "interpretering" ; -- interpretering..nn.1
  interpunktera_1_V = mkV "interpunkterar" ; -- interpunktera..vb.1
  interpunkterande_1_N = mkN "interpunkterande" ; -- interpunkterande..nn.1
  interpunkterbar_1_A = mkA "interpunkterbar" ; -- interpunkterbar..av.1
  interpunkterbarhet_1_N = mkN "interpunkterbarhet" ; -- interpunkterbarhet..nn.1
  interpunktering_1_N = mkN "interpunktering" ; -- interpunktering..nn.1
  interpunktion_1_N = mkN "interpunktion" ; -- interpunktion..nn.1
  interregional_1_A = mkA "interregional" ; -- interregional..av.1
  interregnum_1_N = mkN "interregnum" neutrum  ; -- interregnum..nn.1
  interrimspresident_1_N = mkN "interrimspresident" "interrimspresidenter" ; -- interrimspresident..nn.1
  interrogativ_1_A = mkA "interrogativ" ; -- interrogativ..av.1
  interrogativpronomen_1_N = mkN "interrogativpronomen" neutrum  ; -- interrogativpronomen..nn.1
  interstellär_1_A = mkA "interstellär" ; -- interstellär..av.1
  intertextualitet_1_N = mkN "intertextualitet" ; -- intertextualitet..nn.1
  intertextuell_1_A = mkA "intertextuell" ; -- intertextuell..av.1
  interurban_1_A = mkA "interurban" ; -- interurban..av.1
  intervall_1_N = mkN "intervall" neutrum  ; -- intervall..nn.1
  intervallskala_1_N = mkN "intervallskala" ; -- intervallskala..nn.1
  intervenera_1_V = mkV "intervenerar" ; -- intervenera..vb.1
  intervenerande_1_N = mkN "intervenerande" ; -- intervenerande..nn.1
  intervenerbar_1_A = mkA "intervenerbar" ; -- intervenerbar..av.1
  intervenerbarhet_1_N = mkN "intervenerbarhet" ; -- intervenerbarhet..nn.1
  intervenering_1_N = mkN "intervenering" ; -- intervenering..nn.1
  intervention_1_N = mkN "intervention" ; -- intervention..nn.1
  intervju_1_N = mkN "intervju" "intervjun" "intervjuer" "intervjuerna" ; -- intervju..nn.1
  intervjua_1_V = mkV "intervjuar" ; -- intervjua..vb.1
  intervjuande_1_N = mkN "intervjuande" ; -- intervjuande..nn.1
  intervjuare_1_N = mkN "intervjuare" utrum  ; -- intervjuare..nn.1
  intervjufråga_1_N = mkN "intervjufråga" ; -- intervjufråga..nn.1
  intervjuobjekt_1_N = mkN "intervjuobjekt" neutrum  ; -- intervjuobjekt..nn.1
  intervjuoffer_1_N = mkN "intervjuoffer" neutrum  ; -- intervjuoffer..nn.1
  intervjuperson_1_N = mkN "intervjuperson" "intervjupersoner" ; -- intervjuperson..nn.1
  intervjuundersökning_1_N = mkN "intervjuundersökning" ; -- intervjuundersökning..nn.1
  intervokalisk_1_A = mkA "intervokalisk" ; -- intervokalisk..av.1
  intestatarv_1_N = mkN "intestatarv" neutrum  ; -- intestatarv..nn.1
  intet_1_N = mkN "intet" ; -- intet..nn.1
  intetsägande_1_A = mkA "intetsägande" ; -- intetsägande..av.1
  intig_1_A = mkA "intig" ; -- intig..av.1
  intighet_1_N = mkN "intighet" "intigheter" ; -- intighet..nn.1
  intilliggande_1_A = mkA "intilliggande" ; -- intilliggande..av.1
  intim_1_A = mkA "intim" ; -- intim..av.1
  intimisera_1_V = mkV "intimiserar" ; -- intimisera..vb.1
  intimiserande_1_N = mkN "intimiserande" ; -- intimiserande..nn.1
  intimisering_1_N = mkN "intimisering" ; -- intimisering..nn.1
  intimist_1_N = mkN "intimist" "intimister" ; -- intimist..nn.1
  intimitet_1_N = mkN "intimitet" "intimiteter" ; -- intimitet..nn.1
  intimitetsstörning_1_N = mkN "intimitetsstörning" ; -- intimitetsstörning..nn.1
  intimrakning_1_N = mkN "intimrakning" ; -- intimrakning..nn.1
  intimsfär_1_N = mkN "intimsfär" ; -- intimsfär..nn.1
  intjack_1_N = mkN "intjack" neutrum  ; -- intjack..nn.1
  intjänad_1_A = mkA "intjänad" ; -- intjänad..av.1
  intjänandetid_1_N = mkN "intjänandetid" "intjänandetider" ; -- intjänandetid..nn.1
  intolerabel_1_A = mkA "intolerabel" ; -- intolerabel..av.1
  intolerans_1_N = mkN "intolerans" ; -- intolerans..nn.1
  intolerant_1_A = mkA "intolerant" "intolerant" ; -- intolerant..av.1
  intolka_1_V = mkV "intolkar" ; -- intolka..vb.1
  intolkande_1_N = mkN "intolkande" ; -- intolkande..nn.1
  intonation_1_N = mkN "intonation" ; -- intonation..nn.1
  intonera_1_V = mkV "intonerar" ; -- intonera..vb.1
  intonerande_1_N = mkN "intonerande" ; -- intonerande..nn.1
  intonerbar_1_A = mkA "intonerbar" ; -- intonerbar..av.1
  intonerbarhet_1_N = mkN "intonerbarhet" ; -- intonerbarhet..nn.1
  intonering_1_N = mkN "intonering" ; -- intonering..nn.1
  intorkning_1_N = mkN "intorkning" ; -- intorkning..nn.1
  intoxikation_1_N = mkN "intoxikation" ; -- intoxikation..nn.1
  intracellulär_1_A = mkA "intracellulär" ; -- intracellulär..av.1
  intransigent_1_A = mkA "intransigent" "intransigent" ; -- intransigent..av.1
  intransitiv_1_A = mkA "intransitiv" ; -- intransitiv..av.1
  intranät_1_N = mkN "intranät" neutrum  ; -- intranät..nn.1
  intrasslad_1_A = mkA "intrasslad" ; -- intrasslad..av.1
  intrassling_1_N = mkN "intrassling" ; -- intrassling..nn.1
  intravenös_1_A = mkA "intravenös" ; -- intravenös..av.1
  intressant_1_A = mkA "intressant" "intressant" ; -- intressant..av.1
  intresse_1_N = mkN "intresse" ; -- intresse..nn.1
  intressefokus_1_N = mkN "intressefokus" ; -- intressefokus..nn.1
  intressegemenskap_1_N = mkN "intressegemenskap" "intressegemenskaper" ; -- intressegemenskap..nn.1
  intressegrupp_1_N = mkN "intressegrupp" "intressegrupper" ; -- intressegrupp..nn.1
  intressekonflikt_1_N = mkN "intressekonflikt" "intressekonflikter" ; -- intressekonflikt..nn.1
  intresselös_1_A = mkA "intresselös" ; -- intresselös..av.1
  intresselöshet_1_N = mkN "intresselöshet" ; -- intresselöshet..nn.1
  intressemotsättning_1_N = mkN "intressemotsättning" ; -- intressemotsättning..nn.1
  intressemässig_1_A = mkA "intressemässig" ; -- intressemässig..av.1
  intressent_1_N = mkN "intressent" "intressenter" ; -- intressent..nn.1
  intresseområde_1_N = mkN "intresseområde" ; -- intresseområde..nn.1
  intresseorganisation_1_N = mkN "intresseorganisation" ; -- intresseorganisation..nn.1
  intressera_1_V = mkV "intresserar" ; -- intressera..vb.1
  intresserad_1_A = mkA "intresserad" ; -- intresserad..av.1
  intresserande_1_N = mkN "intresserande" ; -- intresserande..nn.1
  intresserbar_1_A = mkA "intresserbar" ; -- intresserbar..av.1
  intresserbarhet_1_N = mkN "intresserbarhet" ; -- intresserbarhet..nn.1
  intressering_1_N = mkN "intressering" ; -- intressering..nn.1
  intressesfär_1_N = mkN "intressesfär" "intressesfärer" ; -- intressesfär..nn.1
  intresseväckande_1_A = mkA "intresseväckande" ; -- intresseväckande..av.1
  intrig_1_N = mkN "intrig" "intriger" ; -- intrig..nn.1
  intrigant_1_A = mkA "intrigant" "intrigant" ; -- intrigant..av.1
  intrigant_1_N = mkN "intrigant" "intriganter" ; -- intrigant..nn.1
  intrigera_1_V = mkV "intrigerar" ; -- intrigera..vb.1
  intrigerande_1_N = mkN "intrigerande" ; -- intrigerande..nn.1
  intrigering_1_N = mkN "intrigering" ; -- intrigering..nn.1
  intrigflätande_1_A = mkA "intrigflätande" ; -- intrigflätande..av.1
  intrigmakare_1_N = mkN "intrigmakare" utrum  ; -- intrigmakare..nn.1
  intrigmässig_1_A = mkA "intrigmässig" ; -- intrigmässig..av.1
  intrigspel_1_N = mkN "intrigspel" "intrigspelet" "intrigspel" "intrigspelen" ; -- intrigspel..nn.1
  intrigör_1_N = mkN "intrigör" "intrigörer" ; -- intrigör..nn.1
  intrikat_1_A = mkA "intrikat" "intrikat" ; -- intrikat..av.1
  intrimning_1_N = mkN "intrimning" ; -- intrimning..nn.1
  intrinsisk_1_A = mkA "intrinsisk" ; -- intrinsisk..av.1
  introducera_1_V = mkV "introducerar" ; -- introducera..vb.1
  introducerande_1_N = mkN "introducerande" ; -- introducerande..nn.1
  introducerbar_1_A = mkA "introducerbar" ; -- introducerbar..av.1
  introducerbarhet_1_N = mkN "introducerbarhet" ; -- introducerbarhet..nn.1
  introducering_1_N = mkN "introducering" ; -- introducering..nn.1
  introduktion_1_N = mkN "introduktion" ; -- introduktion..nn.1
  introduktionsbrev_1_N = mkN "introduktionsbrev" neutrum  ; -- introduktionsbrev..nn.1
  introduktionserbjudande_1_N = mkN "introduktionserbjudande" ; -- introduktionserbjudande..nn.1
  introduktionskurs_1_N = mkN "introduktionskurs" "introduktionskurser" ; -- introduktionskurs..nn.1
  introduktionsprogram_1_N = mkN "introduktionsprogram" "introduktionsprogrammet" "introduktionsprogram" "introduktionsprogrammen" ; -- introduktionsprogram..nn.1
  introduktör_1_N = mkN "introduktör" "introduktörer" ; -- introduktör..nn.1
  introspektion_1_N = mkN "introspektion" ; -- introspektion..nn.1
  introspektiv_1_A = mkA "introspektiv" ; -- introspektiv..av.1
  introversion_1_N = mkN "introversion" ; -- introversion..nn.1
  introvert_1_A = mkA "introvert" "introvert" ; -- introvert..av.1
  introverthet_1_N = mkN "introverthet" ; -- introverthet..nn.1
  intrumfa_1_V = mkV "intrumfar" ; -- intrumfa..vb.1
  intrumfande_1_N = mkN "intrumfande" ; -- intrumfande..nn.1
  intryck_1_N = mkN "intryck" neutrum  ; -- intryck..nn.1
  intryckning_1_N = mkN "intryckning" ; -- intryckning..nn.1
  intryckt_1_A = mkA "intryckt" "intryckt" ; -- intryckt..av.1
  inträda_1_V = mkV "inträda" "inträdde" "inträtt" ; -- inträda..vb.1
  inträdande_1_N = mkN "inträdande" ; -- inträdande..nn.1
  inträde_1_N = mkN "inträde" ; -- inträde..nn.1
  inträdesavgift_1_N = mkN "inträdesavgift" "inträdesavgifter" ; -- inträdesavgift..nn.1
  inträdeskrav_1_N = mkN "inträdeskrav" neutrum  ; -- inträdeskrav..nn.1
  inträdesprov_1_N = mkN "inträdesprov" neutrum  ; -- inträdesprov..nn.1
  inträdestal_1_N = mkN "inträdestal" neutrum  ; -- inträdestal..nn.1
  inträffa_1_V = mkV "inträffar" ; -- inträffa..vb.1
  inträffande_1_N = mkN "inträffande" ; -- inträffande..nn.1
  intränad_1_A = mkA "intränad" ; -- intränad..av.1
  intränga_1_V = mkV "intränger" ; -- intränga..vb.1
  inträngande_1_A = mkA "inträngande" ; -- inträngande..av.1
  inträngande_1_N = mkN "inträngande" ; -- inträngande..nn.1
  inträngling_1_N = mkN "inträngling" ; -- inträngling..nn.1
  intrång_1_N = mkN "intrång" neutrum  ; -- intrång..nn.1
  intubation_1_N = mkN "intubation" ; -- intubation..nn.1
  intuition_1_N = mkN "intuition" ; -- intuition..nn.1
  intuitiv_1_A = mkA "intuitiv" ; -- intuitiv..av.1
  intumning_1_N = mkN "intumning" ; -- intumning..nn.1
  intvålning_1_N = mkN "intvålning" ; -- intvålning..nn.1
  intyg_1_N = mkN "intyg" neutrum  ; -- intyg..nn.1
  intyga_1_V = mkV "intygar" ; -- intyga..vb.1
  intygande_1_N = mkN "intygande" ; -- intygande..nn.1
  intäkt_1_N = mkN "intäkt" "intäkter" ; -- intäkt..nn.1
  intäktschablon_1_N = mkN "intäktschablon" "intäktschabloner" ; -- intäktschablon..nn.1
  intäktsmöjlighet_1_N = mkN "intäktsmöjlighet" "intäktsmöjligheter" ; -- intäktsmöjlighet..nn.1
  intäktssida_1_N = mkN "intäktssida" ; -- intäktssida..nn.1
  intåg_1_N = mkN "intåg" neutrum  ; -- intåg..nn.1
  intåga_1_V = mkV "intågar" ; -- intåga..vb.1
  intågande_1_N = mkN "intågande" ; -- intågande..nn.1
  inuit_1_N = mkN "inuit" "inuiter" ; -- inuit..nn.1
  inuti_1_Adv = mkAdv "inuti" ; -- inuti..ab.1
  invadera_1_V = mkV "invaderar" ; -- invadera..vb.1
  invaderande_1_N = mkN "invaderande" ; -- invaderande..nn.1
  invaderbar_1_A = mkA "invaderbar" ; -- invaderbar..av.1
  invaderbarhet_1_N = mkN "invaderbarhet" ; -- invaderbarhet..nn.1
  invadering_1_N = mkN "invadering" ; -- invadering..nn.1
  invagga_1_V = mkV "invaggar" ; -- invagga..vb.1
  invaggande_1_N = mkN "invaggande" ; -- invaggande..nn.1
  inval_1_N = mkN "inval" neutrum  ; -- inval..nn.1
  invalid_1_N = mkN "invalid" "invalider" ; -- invalid..nn.1
  invalidisera_1_V = mkV "invalidiserar" ; -- invalidisera..vb.1
  invalidiserande_1_N = mkN "invalidiserande" ; -- invalidiserande..nn.1
  invalidiserbar_1_A = mkA "invalidiserbar" ; -- invalidiserbar..av.1
  invalidiserbarhet_1_N = mkN "invalidiserbarhet" ; -- invalidiserbarhet..nn.1
  invalidisering_1_N = mkN "invalidisering" ; -- invalidisering..nn.1
  invaliditet_1_N = mkN "invaliditet" "invaliditeter" ; -- invaliditet..nn.1
  invallning_1_N = mkN "invallning" ; -- invallning..nn.1
  invand_1_A = mkA "invand" ; -- invand..av.1
  invandhet_1_N = mkN "invandhet" ; -- invandhet..nn.1
  invandra_1_V = mkV "invandrar" ; -- invandra..vb.1
  invandrande_1_N = mkN "invandrande" ; -- invandrande..nn.1
  invandrarbefolkning_1_N = mkN "invandrarbefolkning" ; -- invandrarbefolkning..nn.1
  invandrarbröllop_1_N = mkN "invandrarbröllop" neutrum  ; -- invandrarbröllop..nn.1
  invandrare_1_N = mkN "invandrare" utrum  ; -- invandrare..nn.1
  invandrarfientlig_1_A = mkA "invandrarfientlig" ; -- invandrarfientlig..av.1
  invandrarfientlighet_1_N = mkN "invandrarfientlighet" ; -- invandrarfientlighet..nn.1
  invandrargrupp_1_N = mkN "invandrargrupp" "invandrargrupper" ; -- invandrargrupp..nn.1
  invandrarklass_1_N = mkN "invandrarklass" "invandrarklasser" ; -- invandrarklass..nn.1
  invandrarpolitik_1_N = mkN "invandrarpolitik" ; -- invandrarpolitik..nn.1
  invandrarpolitiker_1_N = mkN "invandrarpolitiker" "invandrarpolitikern" "invandrarpolitiker" "invandrarpolitikerna" ; -- invandrarpolitiker..nn.1
  invandrarpolitisk_1_A = mkA "invandrarpolitisk" ; -- invandrarpolitisk..av.1
  invandrarteater_1_N = mkN "invandrarteater" ; -- invandrarteater..nn.1
  invandrarteatergrupp_1_N = mkN "invandrarteatergrupp" "invandrarteatergrupper" ; -- invandrarteatergrupp..nn.1
  invandrartät_1_A = mkA "invandrartät" ; -- invandrartät..av.1
  invandrartäthet_1_N = mkN "invandrartäthet" ; -- invandrartäthet..nn.1
  invandrarundervisning_1_N = mkN "invandrarundervisning" ; -- invandrarundervisning..nn.1
  invandrarverk_1_N = mkN "invandrarverk" neutrum  ; -- invandrarverk..nn.1
  invandring_1_N = mkN "invandring" ; -- invandring..nn.1
  invandringskritisk_1_A = mkA "invandringskritisk" ; -- invandringskritisk..av.1
  invandringskvot_1_N = mkN "invandringskvot" "invandringskvoter" ; -- invandringskvot..nn.1
  invandringspolitik_1_N = mkN "invandringspolitik" ; -- invandringspolitik..nn.1
  invandringspolitisk_1_A = mkA "invandringspolitisk" ; -- invandringspolitisk..av.1
  invandringsväg_1_N = mkN "invandringsväg" ; -- invandringsväg..nn.1
  invandringsvåg_1_N = mkN "invandringsvåg" "invandringsvågor" ; -- invandringsvåg..nn.1
  invariabel_1_A = mkA "invariabel" ; -- invariabel..av.1
  invariant_1_A = mkA "invariant" "invariant" ; -- invariant..av.1
  invasion_1_N = mkN "invasion" ; -- invasion..nn.1
  invasionsarmé_1_N = mkN "invasionsarmé" "invasionsarméer" ; -- invasionsarmé..nn.1
  invasionsförsvar_1_N = mkN "invasionsförsvar" neutrum  ; -- invasionsförsvar..nn.1
  invasionsplan_1_N = mkN "invasionsplan" "invasionsplaner" ; -- invasionsplan..nn.1
  invasiv_1_A = mkA "invasiv" ; -- invasiv..av.1
  inveckla_1_V = mkV "invecklar" ; -- inveckla..vb.1
  invecklad_1_A = mkA "invecklad" ; -- invecklad..av.1
  invecklande_1_N = mkN "invecklande" ; -- invecklande..nn.1
  invektiv_1_N = mkN "invektiv" neutrum  ; -- invektiv..nn.1
  inventariebok_1_N = mkN "inventariebok" "inventarieböcker" ; -- inventariebok..nn.1
  inventarieförteckning_1_N = mkN "inventarieförteckning" ; -- inventarieförteckning..nn.1
  inventarielista_1_N = mkN "inventarielista" ; -- inventarielista..nn.1
  inventarium_1_N = mkN "inventarium" "inventariet" "inventarier" "inventarierna" ; -- inventarium..nn.1
  inventera_1_V = mkV "inventerar" ; -- inventera..vb.1
  inventerande_1_N = mkN "inventerande" ; -- inventerande..nn.1
  inventerare_1_N = mkN "inventerare" utrum  ; -- inventerare..nn.1
  inventerbar_1_A = mkA "inventerbar" ; -- inventerbar..av.1
  inventerbarhet_1_N = mkN "inventerbarhet" ; -- inventerbarhet..nn.1
  inventering_1_N = mkN "inventering" ; -- inventering..nn.1
  inventiös_1_A = mkA "inventiös" ; -- inventiös..av.1
  inverka_1_V = mkV "inverkar" ; -- inverka..vb.1
  inverkande_1_N = mkN "inverkande" ; -- inverkande..nn.1
  inverkning_1_N = mkN "inverkning" ; -- inverkning..nn.1
  invers_1_N = mkN "invers" "inverser" ; -- invers..nn.1
  inversion_1_N = mkN "inversion" ; -- inversion..nn.1
  invertebrat_1_N = mkN "invertebrat" "invertebrater" ; -- invertebrat..nn.1
  invertera_1_V = mkV "inverterar" ; -- invertera..vb.1
  inverterande_1_N = mkN "inverterande" ; -- inverterande..nn.1
  inverterbar_1_A = mkA "inverterbar" ; -- inverterbar..av.1
  inverterbarhet_1_N = mkN "inverterbarhet" ; -- inverterbarhet..nn.1
  inverterelverk_1_N = mkN "inverterelverk" neutrum  ; -- inverterelverk..nn.1
  invertering_1_N = mkN "invertering" ; -- invertering..nn.1
  invertsocker_1_N = mkN "invertsocker" neutrum  ; -- invertsocker..nn.1
  invertsåpa_1_N = mkN "invertsåpa" ; -- invertsåpa..nn.1
  investera_1_V = mkV "investerar" ; -- investera..vb.1
  investerande_1_N = mkN "investerande" ; -- investerande..nn.1
  investerare_1_N = mkN "investerare" utrum  ; -- investerare..nn.1
  investerbar_1_A = mkA "investerbar" ; -- investerbar..av.1
  investerbarhet_1_N = mkN "investerbarhet" ; -- investerbarhet..nn.1
  investering_1_N = mkN "investering" ; -- investering..nn.1
  investeringsbank_1_N = mkN "investeringsbank" "investeringsbanker" ; -- investeringsbank..nn.1
  investeringsfond_1_N = mkN "investeringsfond" "investeringsfonder" ; -- investeringsfond..nn.1
  investeringsform_1_N = mkN "investeringsform" "investeringsformer" ; -- investeringsform..nn.1
  investeringspolitik_1_N = mkN "investeringspolitik" ; -- investeringspolitik..nn.1
  investitur_1_N = mkN "investitur" ; -- investitur..nn.1
  investmentbank_1_N = mkN "investmentbank" "investmentbanker" ; -- investmentbank..nn.1
  investmentbolag_1_N = mkN "investmentbolag" neutrum  ; -- investmentbolag..nn.1
  inviga_1_V = mkV "inviger" ; -- inviga..vb.1
  invigande_1_N = mkN "invigande" ; -- invigande..nn.1
  invigning_1_N = mkN "invigning" ; -- invigning..nn.1
  invigningsfest_1_N = mkN "invigningsfest" "invigningsfester" ; -- invigningsfest..nn.1
  invikt_1_A = mkA "invikt" "invikt" ; -- invikt..av.1
  invintra_1_V = mkV "invintrar" ; -- invintra..vb.1
  invintrande_1_N = mkN "invintrande" ; -- invintrande..nn.1
  invintring_1_N = mkN "invintring" ; -- invintring..nn.1
  invintringsprocess_1_N = mkN "invintringsprocess" "invintringsprocesser" ; -- invintringsprocess..nn.1
  invit_1_N = mkN "invit" "inviter" ; -- invit..nn.1
  invitation_1_N = mkN "invitation" ; -- invitation..nn.1
  invitera_1_V = mkV "inviterar" ; -- invitera..vb.1
  inviterande_1_N = mkN "inviterande" ; -- inviterande..nn.1
  inviterbar_1_A = mkA "inviterbar" ; -- inviterbar..av.1
  inviterbarhet_1_N = mkN "inviterbarhet" ; -- inviterbarhet..nn.1
  invitering_1_N = mkN "invitering" ; -- invitering..nn.1
  invokation_1_N = mkN "invokation" ; -- invokation..nn.1
  involvera_1_V = mkV "involverar" ; -- involvera..vb.1
  involverande_1_N = mkN "involverande" ; -- involverande..nn.1
  involverbar_1_A = mkA "involverbar" ; -- involverbar..av.1
  involverbarhet_1_N = mkN "involverbarhet" ; -- involverbarhet..nn.1
  involvering_1_N = mkN "involvering" ; -- involvering..nn.1
  invägning_1_N = mkN "invägning" ; -- invägning..nn.1
  invälja_1_V = mkV "invälja" "invalde" "invalt" ; -- invälja..vb.1
  inväljande_1_N = mkN "inväljande" ; -- inväljande..nn.1
  invända_1_V = mkV "invänder" ; -- invända..vb.1
  invändande_1_N = mkN "invändande" ; -- invändande..nn.1
  invändig_1_A = mkA "invändig" ; -- invändig..av.1
  invändning_1_N = mkN "invändning" ; -- invändning..nn.1
  invändningsfri_1_A = mkA "invändningsfri" "invändningsfritt" ; -- invändningsfri..av.1
  invänta_1_V = mkV "inväntar" ; -- invänta..vb.1
  inväntande_1_N = mkN "inväntande" ; -- inväntande..nn.1
  inväntning_1_N = mkN "inväntning" ; -- inväntning..nn.1
  invärtes_1_A = mkA "invärtes" ; -- invärtes..av.1
  inväva_1_V = mkV "inväver" ; -- inväva..vb.1
  invävande_1_N = mkN "invävande" ; -- invävande..nn.1
  invävning_1_N = mkN "invävning" ; -- invävning..nn.1
  inväxling_1_N = mkN "inväxling" ; -- inväxling..nn.1
  invånarantal_1_N = mkN "invånarantal" neutrum  ; -- invånarantal..nn.1
  invånare_1_N = mkN "invånare" utrum  ; -- invånare..nn.1
  inympa_1_V = mkV "inympar" ; -- inympa..vb.1
  inympande_1_N = mkN "inympande" ; -- inympande..nn.1
  inympning_1_N = mkN "inympning" ; -- inympning..nn.1
  inäga_1_N = mkN "inäga" ; -- inäga..nn.1
  inälvskorv_1_N = mkN "inälvskorv" ; -- inälvskorv..nn.1
  inälvsmask_1_N = mkN "inälvsmask" ; -- inälvsmask..nn.1
  inåkande_1_A = mkA "inåkande" ; -- inåkande..av.1
  inåtböjd_1_A = mkA "inåtböjd" "inåtböjt" ; -- inåtböjd..av.1
  inåtvänd_1_A = mkA "inåtvänd" ; -- inåtvänd..av.1
  inåtvändhet_1_N = mkN "inåtvändhet" ; -- inåtvändhet..nn.1
  inöva_1_V = mkV "inövar" ; -- inöva..vb.1
  inövande_1_N = mkN "inövande" ; -- inövande..nn.1
  inövning_1_N = mkN "inövning" ; -- inövning..nn.1
  iordningställa_1_V = mkV "iordningställer" ; -- iordningställa..vb.1
  iordningställande_1_N = mkN "iordningställande" ; -- iordningställande..nn.1
  iota_1_N = mkN "iota" "iotat" "iotan" "iotana" ; -- iota..nn.1
  ip_nummer_1_N = mkN "ip-nummer" neutrum  ; -- ip-nummer..nn.1
  irakier_1_N = mkN "irakier" "irakiern" "irakier" "irakierna" ; -- irakier..nn.1
  irakisk_1_A = mkA "irakisk" ; -- irakisk..av.1
  irakiska_1_N = mkN "irakiska" ; -- irakiska..nn.1
  iranier_1_N = mkN "iranier" "iraniern" "iranier" "iranierna" ; -- iranier..nn.1
  iransk_1_A = mkA "iransk" ; -- iransk..av.1
  iranska_1_N = mkN "iranska" ; -- iranska..nn.1
  iranska_2_N = mkN "iranska" ; -- iranska..nn.2
  irer_1_N = mkN "irer" "irern" "irer" "irerna" ; -- irer..nn.1
  iridium_1_N = mkN "iridium" neutrum  ; -- iridium..nn.1
  iridiumlager_1_N = mkN "iridiumlager" neutrum  ; -- iridiumlager..nn.1
  iris_1_N = mkN "iris" ; -- iris..nn.1
  irisbländare_1_N = mkN "irisbländare" utrum  ; -- irisbländare..nn.1
  irisera_1_V = mkV "iriserar" ; -- irisera..vb.1
  iriserande_1_N = mkN "iriserande" ; -- iriserande..nn.1
  irisering_1_N = mkN "irisering" ; -- irisering..nn.1
  irisk_1_A = mkA "irisk" ; -- irisk..av.1
  iriska_1_N = mkN "iriska" ; -- iriska..nn.1
  iriska_2_N = mkN "iriska" ; -- iriska..nn.2
  irländare_1_N = mkN "irländare" utrum  ; -- irländare..nn.1
  irländsk_1_A = mkA "irländsk" ; -- irländsk..av.1
  irländska_1_N = mkN "irländska" ; -- irländska..nn.1
  irländska_2_N = mkN "irländska" ; -- irländska..nn.2
  ironi_1_N = mkN "ironi" "ironier" ; -- ironi..nn.1
  ironiker_1_N = mkN "ironiker" "ironikern" "ironiker" "ironikerna" ; -- ironiker..nn.1
  ironisera_1_V = mkV "ironiserar" ; -- ironisera..vb.1
  ironiserande_1_N = mkN "ironiserande" ; -- ironiserande..nn.1
  ironisering_1_N = mkN "ironisering" ; -- ironisering..nn.1
  ironisk_1_A = mkA "ironisk" ; -- ironisk..av.1
  irra_1_V = mkV "irrar" ; -- irra..vb.1
  irrande_1_N = mkN "irrande" ; -- irrande..nn.1
  irrationalism_1_N = mkN "irrationalism" ; -- irrationalism..nn.1
  irrationell_1_A = mkA "irrationell" ; -- irrationell..av.1
  irrbloss_1_N = mkN "irrbloss" neutrum  ; -- irrbloss..nn.1
  irreal_1_A = mkA "irreal" ; -- irreal..av.1
  irredentism_1_N = mkN "irredentism" "irredentismer" ; -- irredentism..nn.1
  irreell_1_A = mkA "irreell" ; -- irreell..av.1
  irregularitet_1_N = mkN "irregularitet" "irregulariteter" ; -- irregularitet..nn.1
  irreguljär_1_A = mkA "irreguljär" ; -- irreguljär..av.1
  irrelevans_1_N = mkN "irrelevans" ; -- irrelevans..nn.1
  irrelevant_1_A = mkA "irrelevant" "irrelevant" ; -- irrelevant..av.1
  irreligiositet_1_N = mkN "irreligiositet" "irreligiositeter" ; -- irreligiositet..nn.1
  irreligiös_1_A = mkA "irreligiös" ; -- irreligiös..av.1
  irreparabel_1_A = mkA "irreparabel" ; -- irreparabel..av.1
  irreversibel_1_A = mkA "irreversibel" ; -- irreversibel..av.1
  irrfärd_1_N = mkN "irrfärd" "irrfärder" ; -- irrfärd..nn.1
  irrgång_1_N = mkN "irrgång" ; -- irrgång..nn.1
  irrigation_1_N = mkN "irrigation" ; -- irrigation..nn.1
  irritabel_1_A = mkA "irritabel" ; -- irritabel..av.1
  irritament_1_N = mkN "irritament" neutrum  ; -- irritament..nn.1
  irritation_1_N = mkN "irritation" ; -- irritation..nn.1
  irritationsmoment_1_N = mkN "irritationsmoment" neutrum  ; -- irritationsmoment..nn.1
  irritationsobjekt_1_N = mkN "irritationsobjekt" neutrum  ; -- irritationsobjekt..nn.1
  irritera_1_V = mkV "irriterar" ; -- irritera..vb.1
  irriterad_1_A = mkA "irriterad" ; -- irriterad..av.1
  irriterande_1_N = mkN "irriterande" ; -- irriterande..nn.1
  irriterbar_1_A = mkA "irriterbar" ; -- irriterbar..av.1
  irriterbarhet_1_N = mkN "irriterbarhet" ; -- irriterbarhet..nn.1
  irritering_1_N = mkN "irritering" ; -- irritering..nn.1
  irrlära_1_N = mkN "irrlära" ; -- irrlära..nn.1
  irrlärig_1_A = mkA "irrlärig" ; -- irrlärig..av.1
  irrlärighet_1_N = mkN "irrlärighet" ; -- irrlärighet..nn.1
  irrväg_1_N = mkN "irrväg" ; -- irrväg..nn.1
  is_1_N = mkN "is" ; -- is..nn.1
  isa_1_V = mkV "isar" ; -- isa..vb.1
  isabellafärg_1_N = mkN "isabellafärg" ; -- isabellafärg..nn.1
  isagogik_1_N = mkN "isagogik" ; -- isagogik..nn.1
  isagogisk_1_A = mkA "isagogisk" ; -- isagogisk..av.1
  isande_1_N = mkN "isande" ; -- isande..nn.1
  isbad_1_N = mkN "isbad" neutrum  ; -- isbad..nn.1
  isbalett_1_N = mkN "isbalett" "isbaletter" ; -- isbalett..nn.1
  isbana_1_N = mkN "isbana" ; -- isbana..nn.1
  isbark_1_N = mkN "isbark" ; -- isbark..nn.1
  isbelägga_1_V = mkV "isbelägga" "isbela" "isbelagt" ; -- isbelägga..vb.1
  isberg_1_N = mkN "isberg" neutrum  ; -- isberg..nn.1
  isbergssallad_1_N = mkN "isbergssallad" ; -- isbergssallad..nn.1
  isbildning_1_N = mkN "isbildning" ; -- isbildning..nn.1
  isbill_1_N = mkN "isbill" ; -- isbill..nn.1
  isbit_1_N = mkN "isbit" ; -- isbit..nn.1
  isbjörn_1_N = mkN "isbjörn" ; -- isbjörn..nn.1
  isbjörnshona_1_N = mkN "isbjörnshona" ; -- isbjörnshona..nn.1
  isbjörnsunge_1_N = mkN "isbjörnsunge" utrum  ; -- isbjörnsunge..nn.1
  isblandad_1_A = mkA "isblandad" ; -- isblandad..av.1
  isblock_1_N = mkN "isblock" neutrum  ; -- isblock..nn.1
  isblomma_1_N = mkN "isblomma" ; -- isblomma..nn.1
  isblå_1_A = mkA "isblå" "isblått" ; -- isblå..av.1
  isblåsa_1_N = mkN "isblåsa" ; -- isblåsa..nn.1
  isboj_1_N = mkN "isboj" ; -- isboj..nn.1
  isborttagare_1_N = mkN "isborttagare" utrum  ; -- isborttagare..nn.1
  isbrodd_1_N = mkN "isbrodd" ; -- isbrodd..nn.1
  isbrytarassistans_1_N = mkN "isbrytarassistans" "isbrytarassistanser" ; -- isbrytarassistans..nn.1
  isbrytare_1_N = mkN "isbrytare" utrum  ; -- isbrytare..nn.1
  isbrytaregenskap_1_N = mkN "isbrytaregenskap" "isbrytaregenskaper" ; -- isbrytaregenskap..nn.1
  isbrytning_1_N = mkN "isbrytning" ; -- isbrytning..nn.1
  isbränna_1_N = mkN "isbränna" ; -- isbränna..nn.1
  isbälte_1_N = mkN "isbälte" ; -- isbälte..nn.1
  iscensätta_1_V = mkV "iscensätta" "iscensätter" "iscensätt" "iscensatte" "iscensatt" "iscensatt" ; -- iscensätta..vb.1
  iscensättande_1_N = mkN "iscensättande" ; -- iscensättande..nn.1
  iscensättning_1_N = mkN "iscensättning" ; -- iscensättning..nn.1
  ischias_1_N = mkN "ischias" ; -- ischias..nn.1
  ischiasnerv_1_N = mkN "ischiasnerv" "ischiasnerver" ; -- ischiasnerv..nn.1
  ischoklad_1_N = mkN "ischoklad" ; -- ischoklad..nn.1
  ischuri_1_N = mkN "ischuri" "ischurier" ; -- ischuri..nn.1
  isdans_1_N = mkN "isdans" ; -- isdans..nn.1
  isdrabbad_1_A = mkA "isdrabbad" ; -- isdrabbad..av.1
  isdubb_1_N = mkN "isdubb" ; -- isdubb..nn.1
  isfiske_1_N = mkN "isfiske" ; -- isfiske..nn.1
  isflak_1_N = mkN "isflak" neutrum  ; -- isflak..nn.1
  isfri_1_A = mkA "isfri" "isfritt" ; -- isfri..av.1
  isfront_1_N = mkN "isfront" "isfronter" ; -- isfront..nn.1
  isfågel_1_N = mkN "isfågel" ; -- isfågel..nn.1
  isförhållande_1_N = mkN "isförhållande" ; -- isförhållande..nn.1
  isgata_1_N = mkN "isgata" ; -- isgata..nn.1
  isglass_1_N = mkN "isglass" ; -- isglass..nn.1
  ishal_1_A = mkA "ishal" ; -- ishal..av.1
  ishalka_1_N = mkN "ishalka" ; -- ishalka..nn.1
  ishall_1_N = mkN "ishall" ; -- ishall..nn.1
  ishav_1_N = mkN "ishav" neutrum  ; -- ishav..nn.1
  ishavsdimma_1_N = mkN "ishavsdimma" ; -- ishavsdimma..nn.1
  ishink_1_N = mkN "ishink" ; -- ishink..nn.1
  ishockeyklubba_1_N = mkN "ishockeyklubba" ; -- ishockeyklubba..nn.1
  ishockeymässig_1_A = mkA "ishockeymässig" ; -- ishockeymässig..av.1
  ishockeyrör_1_N = mkN "ishockeyrör" neutrum  ; -- ishockeyrör..nn.1
  ishockeyspelare_1_N = mkN "ishockeyspelare" utrum  ; -- ishockeyspelare..nn.1
  isig_1_A = mkA "isig" ; -- isig..av.1
  isjakt_1_N = mkN "isjakt" "isjakter" ; -- isjakt..nn.1
  iskall_1_A = mkA "iskall" ; -- iskall..av.1
  iskana_1_N = mkN "iskana" ; -- iskana..nn.1
  iskant_1_N = mkN "iskant" "iskanter" ; -- iskant..nn.1
  isklump_1_N = mkN "isklump" ; -- isklump..nn.1
  iskonvalj_1_N = mkN "iskonvalj" "iskonvaljer" ; -- iskonvalj..nn.1
  iskonvalje_1_N = mkN "iskonvalje" "iskonvaljer" ; -- iskonvalje..nn.1
  iskorn_1_N = mkN "iskorn" neutrum  ; -- iskorn..nn.1
  iskravning_1_N = mkN "iskravning" ; -- iskravning..nn.1
  iskristall_1_N = mkN "iskristall" "iskristaller" ; -- iskristall..nn.1
  iskyla_1_N = mkN "iskyla" ; -- iskyla..nn.1
  iskyld_1_A = mkA "iskyld" "iskylt" ; -- iskyld..av.1
  iskällare_1_N = mkN "iskällare" utrum  ; -- iskällare..nn.1
  iskänkning_1_N = mkN "iskänkning" ; -- iskänkning..nn.1
  islam_1_N = mkN "islam" ; -- islam..nn.1
  islamisera_1_V = mkV "islamiserar" ; -- islamisera..vb.1
  islamiserande_1_N = mkN "islamiserande" ; -- islamiserande..nn.1
  islamiserbar_1_A = mkA "islamiserbar" ; -- islamiserbar..av.1
  islamiserbarhet_1_N = mkN "islamiserbarhet" ; -- islamiserbarhet..nn.1
  islamisering_1_N = mkN "islamisering" ; -- islamisering..nn.1
  islamisk_1_A = mkA "islamisk" ; -- islamisk..av.1
  islamism_1_N = mkN "islamism" "islamismer" ; -- islamism..nn.1
  islamist_1_N = mkN "islamist" "islamister" ; -- islamist..nn.1
  islamistisk_1_A = mkA "islamistisk" ; -- islamistisk..av.1
  islamitisk_1_A = mkA "islamitisk" ; -- islamitisk..av.1
  islamofob_1_A = mkA "islamofob" ; -- islamofob..av.1
  islamofob_1_N = mkN "islamofob" "islamofober" ; -- islamofob..nn.1
  islamofobi_1_N = mkN "islamofobi" "islamofobier" ; -- islamofobi..nn.1
  islamsk_1_A = mkA "islamsk" ; -- islamsk..av.1
  islamtal_1_N = mkN "islamtal" neutrum  ; -- islamtal..nn.1
  islandshäst_1_N = mkN "islandshäst" ; -- islandshäst..nn.1
  islandslav_1_N = mkN "islandslav" ; -- islandslav..nn.1
  islandssill_1_N = mkN "islandssill" ; -- islandssill..nn.1
  islandströja_1_N = mkN "islandströja" ; -- islandströja..nn.1
  islossning_1_N = mkN "islossning" ; -- islossning..nn.1
  isläge_1_N = mkN "isläge" ; -- isläge..nn.1
  islägga_1_V = mkV "islägga" "isla" "islagt" ; -- islägga..vb.1
  isländare_1_N = mkN "isländare" utrum  ; -- isländare..nn.1
  isländsk_1_A = mkA "isländsk" ; -- isländsk..av.1
  isländska_1_N = mkN "isländska" ; -- isländska..nn.1
  isländska_2_N = mkN "isländska" ; -- isländska..nn.2
  islänning_1_N = mkN "islänning" ; -- islänning..nn.1
  ism_1_N = mkN "ism" "ismer" ; -- ism..nn.1
  ismassa_1_N = mkN "ismassa" ; -- ismassa..nn.1
  isobar_1_N = mkN "isobar" "isobarer" ; -- isobar..nn.1
  isogloss_1_N = mkN "isogloss" "isoglosser" ; -- isogloss..nn.1
  isogon_1_N = mkN "isogon" "isogoner" ; -- isogon..nn.1
  isolat_1_N = mkN "isolat" neutrum  ; -- isolat..nn.1
  isolation_1_N = mkN "isolation" ; -- isolation..nn.1
  isolationism_1_N = mkN "isolationism" "isolationismer" ; -- isolationism..nn.1
  isolationistisk_1_A = mkA "isolationistisk" ; -- isolationistisk..av.1
  isolator_1_N = mkN "isolator" "isolatorer" ; -- isolator..nn.1
  isolera_1_V = mkV "isolerar" ; -- isolera..vb.1
  isolerad_1_A = mkA "isolerad" ; -- isolerad..av.1
  isolerande_1_N = mkN "isolerande" ; -- isolerande..nn.1
  isolerband_1_N = mkN "isolerband" neutrum  ; -- isolerband..nn.1
  isolerbar_1_A = mkA "isolerbar" ; -- isolerbar..av.1
  isolerbarhet_1_N = mkN "isolerbarhet" ; -- isolerbarhet..nn.1
  isolerglas_1_N = mkN "isolerglas" neutrum  ; -- isolerglas..nn.1
  isolering_1_N = mkN "isolering" ; -- isolering..nn.1
  isoleringsavdelning_1_N = mkN "isoleringsavdelning" ; -- isoleringsavdelning..nn.1
  isoleringsband_1_N = mkN "isoleringsband" neutrum  ; -- isoleringsband..nn.1
  isoleringscell_1_N = mkN "isoleringscell" "isoleringsceller" ; -- isoleringscell..nn.1
  isoleringsklass_1_N = mkN "isoleringsklass" "isoleringsklasser" ; -- isoleringsklass..nn.1
  isoleringsmaterial_1_N = mkN "isoleringsmaterial" neutrum  ; -- isoleringsmaterial..nn.1
  isoleringsruta_1_N = mkN "isoleringsruta" ; -- isoleringsruta..nn.1
  isomer_1_A = mkA "isomer" "isomert" ; -- isomer..av.1
  isomer_1_N = mkN "isomer" "isomerer" ; -- isomer..nn.1
  isomeri_1_N = mkN "isomeri" "isomerier" ; -- isomeri..nn.1
  isomorf_1_A = mkA "isomorf" ; -- isomorf..av.1
  isomorfi_1_N = mkN "isomorfi" "isomorfier" ; -- isomorfi..nn.1
  isomorfism_1_N = mkN "isomorfism" "isomorfismer" ; -- isomorfism..nn.1
  isooktan_1_N = mkN "isooktan" neutrum  ; -- isooktan..nn.1
  isop_1_N = mkN "isop" ; -- isop..nn.1
  isoterm_1_N = mkN "isoterm" "isotermer" ; -- isoterm..nn.1
  isotop_1_N = mkN "isotop" "isotoper" ; -- isotop..nn.1
  isotopmätning_1_N = mkN "isotopmätning" ; -- isotopmätning..nn.1
  isperiod_1_N = mkN "isperiod" "isperioder" ; -- isperiod..nn.1
  ispigg_1_N = mkN "ispigg" ; -- ispigg..nn.1
  ispik_1_N = mkN "ispik" ; -- ispik..nn.1
  isprinsessa_1_N = mkN "isprinsessa" ; -- isprinsessa..nn.1
  ispropp_1_N = mkN "ispropp" ; -- ispropp..nn.1
  isracing_1_N = mkN "isracing" ; -- isracing..nn.1
  israel_1_N = mkN "israel" "israeler" ; -- israel..nn.1
  israelisk_1_A = mkA "israelisk" ; -- israelisk..av.1
  israeliska_1_N = mkN "israeliska" ; -- israeliska..nn.1
  israelit_1_N = mkN "israelit" "israeliter" ; -- israelit..nn.1
  israelitisk_1_A = mkA "israelitisk" ; -- israelitisk..av.1
  isrand_1_N = mkN "isrand" "isränder" ; -- isrand..nn.1
  isranunkel_1_N = mkN "isranunkel" ; -- isranunkel..nn.1
  israpport_1_N = mkN "israpport" "israpporter" ; -- israpport..nn.1
  isrevy_1_N = mkN "isrevy" "isrevyer" ; -- isrevy..nn.1
  isräffla_1_N = mkN "isräffla" ; -- isräffla..nn.1
  isränna_1_N = mkN "isränna" ; -- isränna..nn.1
  issjö_1_N = mkN "issjö" ; -- issjö..nn.1
  isskimrande_1_A = mkA "isskimrande" ; -- isskimrande..av.1
  isskrapa_1_N = mkN "isskrapa" ; -- isskrapa..nn.1
  isskruvning_1_N = mkN "isskruvning" ; -- isskruvning..nn.1
  isskåp_1_N = mkN "isskåp" neutrum  ; -- isskåp..nn.1
  issmältning_1_N = mkN "issmältning" ; -- issmältning..nn.1
  issörja_1_N = mkN "issörja" ; -- issörja..nn.1
  istadarätt_1_N = mkN "istadarätt" ; -- istadarätt..nn.1
  istadig_1_A = mkA "istadig" ; -- istadig..av.1
  istadighet_1_N = mkN "istadighet" ; -- istadighet..nn.1
  istapp_1_N = mkN "istapp" ; -- istapp..nn.1
  ister_1_N = mkN "ister" neutrum  ; -- ister..nn.1
  isterband_1_N = mkN "isterband" neutrum  ; -- isterband..nn.1
  isterbuk_1_N = mkN "isterbuk" ; -- isterbuk..nn.1
  isterflott_1_N = mkN "isterflott" neutrum  ; -- isterflott..nn.1
  isterhaka_1_N = mkN "isterhaka" ; -- isterhaka..nn.1
  istid_1_N = mkN "istid" "istider" ; -- istid..nn.1
  istidsforskare_1_N = mkN "istidsforskare" utrum  ; -- istidsforskare..nn.1
  istryck_1_N = mkN "istryck" neutrum  ; -- istryck..nn.1
  istäcke_1_N = mkN "istäcke" ; -- istäcke..nn.1
  istäckt_1_A = mkA "istäckt" "istäckt" ; -- istäckt..av.1
  istället_1_Adv = mkAdv "istället" ; -- istället..ab.1
  istånd_1_A = mkA "istånd" ; -- istånd..av.1
  iståndsätta_1_V = mkV "iståndsätta" "iståndsätter" "iståndsätt" "iståndsatte" "iståndsatt" "iståndsatt" ; -- iståndsätta..vb.1
  iståndsättande_1_N = mkN "iståndsättande" ; -- iståndsättande..nn.1
  iståndsättning_1_N = mkN "iståndsättning" ; -- iståndsättning..nn.1
  isvak_1_N = mkN "isvak" ; -- isvak..nn.1
  isvarning_1_N = mkN "isvarning" ; -- isvarning..nn.1
  isvidd_1_N = mkN "isvidd" "isvidder" ; -- isvidd..nn.1
  isvind_1_N = mkN "isvind" ; -- isvind..nn.1
  isyxa_1_N = mkN "isyxa" ; -- isyxa..nn.1
  isälv_1_N = mkN "isälv" ; -- isälv..nn.1
  isättning_1_N = mkN "isättning" ; -- isättning..nn.1
  it_företag_1_N = mkN "it-företag" neutrum  ; -- it-företag..nn.1
  it_jätte_1_N = mkN "it-jätte" utrum  ; -- it-jätte..nn.1
  italer_1_N = mkN "italer" "italern" "italer" "italerna" ; -- italer..nn.1
  italienare_1_N = mkN "italienare" utrum  ; -- italienare..nn.1
  italiensk_1_A = mkA "italiensk" ; -- italiensk..av.1
  italienska_1_N = mkN "italienska" ; -- italienska..nn.1
  italienska_2_N = mkN "italienska" ; -- italienska..nn.2
  italiker_1_N = mkN "italiker" "italikern" "italiker" "italikerna" ; -- italiker..nn.1
  italisk_1_A = mkA "italisk" ; -- italisk..av.1
  item_1_N = mkN "item" ; -- item..nn.1
  iteration_1_N = mkN "iteration" ; -- iteration..nn.1
  iterativ_1_A = mkA "iterativ" ; -- iterativ..av.1
  iterera_1_V = mkV "itererar" ; -- iterera..vb.1
  itererande_1_N = mkN "itererande" ; -- itererande..nn.1
  itererbar_1_A = mkA "itererbar" ; -- itererbar..av.1
  itererbarhet_1_N = mkN "itererbarhet" ; -- itererbarhet..nn.1
  iterering_1_N = mkN "iterering" ; -- iterering..nn.1
  itudelad_1_A = mkA "itudelad" ; -- itudelad..av.1
  ituta_1_V = mkV "itutar" ; -- ituta..vb.1
  itutande_1_N = mkN "itutande" ; -- itutande..nn.1
  iver_1_N = mkN "iver" ; -- iver..nn.1
  ivorian_1_N = mkN "ivorian" "ivorianer" ; -- ivorian..nn.1
  ivoriansk_1_A = mkA "ivoriansk" ; -- ivoriansk..av.1
  ivorianska_1_N = mkN "ivorianska" ; -- ivorianska..nn.1
  ivra_1_V = mkV "ivrar" ; -- ivra..vb.1
  ivrande_1_N = mkN "ivrande" ; -- ivrande..nn.1
  ivrare_1_N = mkN "ivrare" utrum  ; -- ivrare..nn.1
  ivrig_1_A = mkA "ivrig" ; -- ivrig..av.1
  ivrighet_1_N = mkN "ivrighet" ; -- ivrighet..nn.1
  ivägskicka_1_V = mkV "ivägskickar" ; -- ivägskicka..vb.1
  ivägskickande_1_N = mkN "ivägskickande" ; -- ivägskickande..nn.1
  ivägsläpad_1_A = mkA "ivägsläpad" ; -- ivägsläpad..av.1
  iögonenfallande_1_A = mkA "iögonenfallande" ; -- iögonenfallande..av.1
  iögonfallande_1_A = mkA "iögonfallande" ; -- iögonfallande..av.1
  ja_1_N = mkN "ja" "jat" "ja" "jana" ; -- ja..nn.1
  jab_1_N = mkN "jab" ; -- jab..nn.1
  jabb_1_N = mkN "jabb" ; -- jabb..nn.1
  jabba_1_V = mkV "jabbar" ; -- jabba..vb.1
  jabbande_1_N = mkN "jabbande" ; -- jabbande..nn.1
  jabirustork_1_N = mkN "jabirustork" ; -- jabirustork..nn.1
  jabot_1_N = mkN "jabot" "jaboter" ; -- jabot..nn.1
  jack_1_N = mkN "jack" neutrum  ; -- jack..nn.1
  jack_2_N = mkN "jack" ; -- jack..nn.2
  jacka_1_N = mkN "jacka" ; -- jacka..nn.1
  jacketkrona_1_N = mkN "jacketkrona" ; -- jacketkrona..nn.1
  jackett_1_N = mkN "jackett" "jacketter" ; -- jackett..nn.1
  jackettbyxa_1_N = mkN "jackettbyxa" ; -- jackettbyxa..nn.1
  jackficka_1_N = mkN "jackficka" ; -- jackficka..nn.1
  jackig_1_A = mkA "jackig" ; -- jackig..av.1
  jackighet_1_N = mkN "jackighet" ; -- jackighet..nn.1
  jackpot_1_N = mkN "jackpot" ; -- jackpot..nn.1
  jackpropp_1_N = mkN "jackpropp" ; -- jackpropp..nn.1
  jackuttag_1_N = mkN "jackuttag" neutrum  ; -- jackuttag..nn.1
  jacquard_1_N = mkN "jacquard" ; -- jacquard..nn.1
  jacuzzi_1_N = mkN "jacuzzi" "jacuzzin" "jacuzzis" "jacuzzisarna" ; -- jacuzzi..nn.1
  jade_1_N = mkN "jade" utrum  ; -- jade..nn.1
  jadegrön_1_A = mkA "jadegrön" ; -- jadegrön..av.1
  jadeit_1_N = mkN "jadeit" ; -- jadeit..nn.1
  jag_1_N = mkN "jag" neutrum  ; -- jag..nn.1
  jaga_1_V = mkV "jagar" ; -- jaga..vb.1
  jagande_1_N = mkN "jagande" ; -- jagande..nn.1
  jagare_1_N = mkN "jagare" utrum  ; -- jagare..nn.1
  jagdrift_1_N = mkN "jagdrift" ; -- jagdrift..nn.1
  jagform_1_N = mkN "jagform" ; -- jagform..nn.1
  jagföreställning_1_N = mkN "jagföreställning" ; -- jagföreställning..nn.1
  jaggernaut_1_N = mkN "jaggernaut" ; -- jaggernaut..nn.1
  jagillusion_1_N = mkN "jagillusion" ; -- jagillusion..nn.1
  jagisk_1_A = mkA "jagisk" ; -- jagisk..av.1
  jagkänsla_1_N = mkN "jagkänsla" ; -- jagkänsla..nn.1
  jaglina_1_N = mkN "jaglina" ; -- jaglina..nn.1
  jagmodell_1_N = mkN "jagmodell" "jagmodeller" ; -- jagmodell..nn.1
  jagsvaghet_1_N = mkN "jagsvaghet" "jagsvagheter" ; -- jagsvaghet..nn.1
  jaguar_1_N = mkN "jaguar" "jaguarer" ; -- jaguar..nn.1
  jagupplevelse_1_N = mkN "jagupplevelse" "jagupplevelser" ; -- jagupplevelse..nn.1
  jagupplösning_1_N = mkN "jagupplösning" ; -- jagupplösning..nn.1
  jaha_upplevelse_1_N = mkN "jaha-upplevelse" "jaha-upplevelser" ; -- jaha-upplevelse..nn.1
  jahaupplevelse_1_N = mkN "jahaupplevelse" "jahaupplevelser" ; -- jahaupplevelse..nn.1
  jainism_1_N = mkN "jainism" "jainismer" ; -- jainism..nn.1
  jainistisk_1_A = mkA "jainistisk" ; -- jainistisk..av.1
  jak_1_N = mkN "jak" ; -- jak..nn.1
  jaka_1_V = mkV "jakar" ; -- jaka..vb.1
  jakande_1_A = mkA "jakande" ; -- jakande..av.1
  jakande_1_N = mkN "jakande" ; -- jakande..nn.1
  jakaranda_1_N = mkN "jakaranda" ; -- jakaranda..nn.1
  jakobin_1_N = mkN "jakobin" "jakobiner" ; -- jakobin..nn.1
  jakobinism_1_N = mkN "jakobinism" ; -- jakobinism..nn.1
  jakobinmössa_1_N = mkN "jakobinmössa" ; -- jakobinmössa..nn.1
  jakobinsk_1_A = mkA "jakobinsk" ; -- jakobinsk..av.1
  jakobskamp_1_N = mkN "jakobskamp" "jakobskamper" ; -- jakobskamp..nn.1
  jakobsstege_1_N = mkN "jakobsstege" utrum  ; -- jakobsstege..nn.1
  jakt_1_N = mkN "jakt" "jakter" ; -- jakt..nn.1
  jaktavgift_1_N = mkN "jaktavgift" "jaktavgifter" ; -- jaktavgift..nn.1
  jaktbar_1_A = mkA "jaktbar" ; -- jaktbar..av.1
  jaktbarhet_1_N = mkN "jaktbarhet" ; -- jaktbarhet..nn.1
  jaktbrott_1_N = mkN "jaktbrott" neutrum  ; -- jaktbrott..nn.1
  jaktbyte_1_N = mkN "jaktbyte" ; -- jaktbyte..nn.1
  jaktexpedition_1_N = mkN "jaktexpedition" ; -- jaktexpedition..nn.1
  jaktfalk_1_N = mkN "jaktfalk" ; -- jaktfalk..nn.1
  jaktflyg_1_N = mkN "jaktflyg" neutrum  ; -- jaktflyg..nn.1
  jaktförordning_1_N = mkN "jaktförordning" ; -- jaktförordning..nn.1
  jaktgevär_1_N = mkN "jaktgevär" neutrum  ; -- jaktgevär..nn.1
  jakthistoria_1_N = mkN "jakthistoria" "jakthistorian" "jakthistorier" "jakthistorierna" ; -- jakthistoria..nn.1
  jakthorn_1_N = mkN "jakthorn" neutrum  ; -- jakthorn..nn.1
  jakthund_1_N = mkN "jakthund" ; -- jakthund..nn.1
  jaktkniv_1_N = mkN "jaktkniv" ; -- jaktkniv..nn.1
  jaktkort_1_N = mkN "jaktkort" neutrum  ; -- jaktkort..nn.1
  jaktlag_1_N = mkN "jaktlag" neutrum  ; -- jaktlag..nn.1
  jaktleopard_1_N = mkN "jaktleopard" "jaktleoparder" ; -- jaktleopard..nn.1
  jaktlig_1_A = mkA "jaktlig" ; -- jaktlig..av.1
  jaktlopp_1_N = mkN "jaktlopp" neutrum  ; -- jaktlopp..nn.1
  jaktlycka_1_N = mkN "jaktlycka" ; -- jaktlycka..nn.1
  jaktmark_1_N = mkN "jaktmark" "jaktmarker" ; -- jaktmark..nn.1
  jaktplan_1_N = mkN "jaktplan" neutrum  ; -- jaktplan..nn.1
  jaktprov_1_N = mkN "jaktprov" neutrum  ; -- jaktprov..nn.1
  jaktresa_1_N = mkN "jaktresa" ; -- jaktresa..nn.1
  jaktridning_1_N = mkN "jaktridning" ; -- jaktridning..nn.1
  jaktrobot_1_N = mkN "jaktrobot" ; -- jaktrobot..nn.1
  jakträtt_1_N = mkN "jakträtt" ; -- jakträtt..nn.1
  jakträttsinnehavare_1_N = mkN "jakträttsinnehavare" utrum  ; -- jakträttsinnehavare..nn.1
  jaktsignal_1_N = mkN "jaktsignal" "jaktsignaler" ; -- jaktsignal..nn.1
  jaktskytte_1_N = mkN "jaktskytte" ; -- jaktskytte..nn.1
  jaktslott_1_N = mkN "jaktslott" neutrum  ; -- jaktslott..nn.1
  jaktspindel_1_N = mkN "jaktspindel" ; -- jaktspindel..nn.1
  jaktspår_1_N = mkN "jaktspår" neutrum  ; -- jaktspår..nn.1
  jakttabell_1_N = mkN "jakttabell" "jakttabeller" ; -- jakttabell..nn.1
  jakttid_1_N = mkN "jakttid" "jakttider" ; -- jakttid..nn.1
  jakttillfälle_1_N = mkN "jakttillfälle" ; -- jakttillfälle..nn.1
  jakttrofé_1_N = mkN "jakttrofé" "jakttroféer" ; -- jakttrofé..nn.1
  jaktvapen_1_N = mkN "jaktvapen" "jaktvapnet" "jaktvapen" "jaktvapnen" ; -- jaktvapen..nn.1
  jaktväska_1_N = mkN "jaktväska" ; -- jaktväska..nn.1
  jaktvård_1_N = mkN "jaktvård" ; -- jaktvård..nn.1
  jalu_1_A = mkA "jalu" ; -- jalu..av.1
  jalusi_1_N = mkN "jalusi" "jalusier" ; -- jalusi..nn.1
  jam_1_N = mkN "jam" neutrum  ; -- jam..nn.1
  jama_1_V = mkV "jamar" ; -- jama..vb.1
  jamaican_1_N = mkN "jamaican" "jamaicaner" ; -- jamaican..nn.1
  jamaicansk_1_A = mkA "jamaicansk" ; -- jamaicansk..av.1
  jamaicanska_1_N = mkN "jamaicanska" ; -- jamaicanska..nn.1
  jamaikan_1_N = mkN "jamaikan" "jamaikaner" ; -- jamaikan..nn.1
  jamaikansk_1_A = mkA "jamaikansk" ; -- jamaikansk..av.1
  jamande_1_N = mkN "jamande" ; -- jamande..nn.1
  jamare_1_N = mkN "jamare" utrum  ; -- jamare..nn.1
  jamb_1_N = mkN "jamb" "jamber" ; -- jamb..nn.1
  jambisk_1_A = mkA "jambisk" ; -- jambisk..av.1
  jamboree_1_N = mkN "jamboree" "jamboreer" ; -- jamboree..nn.1
  jamma_1_V = mkV "jammar" ; -- jamma..vb.1
  jammande_1_N = mkN "jammande" ; -- jammande..nn.1
  jamning_1_N = mkN "jamning" ; -- jamning..nn.1
  jams_1_N = mkN "jams" ; -- jams..nn.1
  jamsa_1_V = mkV "jamsar" ; -- jamsa..vb.1
  jamsande_1_N = mkN "jamsande" ; -- jamsande..nn.1
  jamsrot_1_N = mkN "jamsrot" ; -- jamsrot..nn.1
  jan_1_N = mkN "jan" ; -- jan..nn.1
  janitsjar_1_N = mkN "janitsjar" "janitsjarer" ; -- janitsjar..nn.1
  janitsjarmusik_1_N = mkN "janitsjarmusik" ; -- janitsjarmusik..nn.1
  jansenism_1_N = mkN "jansenism" "jansenismer" ; -- jansenism..nn.1
  jansenistisk_1_A = mkA "jansenistisk" ; -- jansenistisk..av.1
  jantelag_1_N = mkN "jantelag" ; -- jantelag..nn.1
  januari_1_N = mkN "januari" ; -- januari..nn.1
  januarikyla_1_N = mkN "januarikyla" ; -- januarikyla..nn.1
  janusanlete_1_N = mkN "janusanlete" ; -- janusanlete..nn.1
  janusansikte_1_N = mkN "janusansikte" ; -- janusansikte..nn.1
  japan_1_N = mkN "japan" "japaner" ; -- japan..nn.1
  japanes_1_N = mkN "japanes" "japaneser" ; -- japanes..nn.1
  japansk_1_A = mkA "japansk" ; -- japansk..av.1
  japanska_1_N = mkN "japanska" ; -- japanska..nn.1
  japanska_2_N = mkN "japanska" ; -- japanska..nn.2
  japanskinspirerad_1_A = mkA "japanskinspirerad" ; -- japanskinspirerad..av.1
  japroposition_1_N = mkN "japroposition" ; -- japroposition..nn.1
  jardinjär_1_N = mkN "jardinjär" "jardinjärer" ; -- jardinjär..nn.1
  jargong_1_N = mkN "jargong" "jargonger" ; -- jargong..nn.1
  jargongmässig_1_A = mkA "jargongmässig" ; -- jargongmässig..av.1
  jarl_1_N = mkN "jarl" ; -- jarl..nn.1
  jarop_1_N = mkN "jarop" neutrum  ; -- jarop..nn.1
  jaröst_1_N = mkN "jaröst" "jaröster" ; -- jaröst..nn.1
  jasmin_1_N = mkN "jasmin" "jasminer" ; -- jasmin..nn.1
  jaspis_1_N = mkN "jaspis" ; -- jaspis..nn.1
  jass_1_N = mkN "jass" ; -- jass..nn.1
  jassa_1_V = mkV "jassar" ; -- jassa..vb.1
  jassande_1_N = mkN "jassande" ; -- jassande..nn.1
  jasägare_1_N = mkN "jasägare" utrum  ; -- jasägare..nn.1
  java_1_N = mkN "java" ; -- java..nn.1
  javan_1_N = mkN "javan" "javaner" ; -- javan..nn.1
  javanes_1_N = mkN "javanes" "javaneser" ; -- javanes..nn.1
  javanesisk_1_A = mkA "javanesisk" ; -- javanesisk..av.1
  javansk_1_A = mkA "javansk" ; -- javansk..av.1
  jazz_1_N = mkN "jazz" ; -- jazz..nn.1
  jazza_1_V = mkV "jazzar" ; -- jazza..vb.1
  jazzande_1_N = mkN "jazzande" ; -- jazzande..nn.1
  jazzbalett_1_N = mkN "jazzbalett" "jazzbaletter" ; -- jazzbalett..nn.1
  jazzband_1_N = mkN "jazzband" neutrum  ; -- jazzband..nn.1
  jazzifiera_1_V = mkV "jazzifierar" ; -- jazzifiera..vb.1
  jazzifierande_1_N = mkN "jazzifierande" ; -- jazzifierande..nn.1
  jazzifierbar_1_A = mkA "jazzifierbar" ; -- jazzifierbar..av.1
  jazzifierbarhet_1_N = mkN "jazzifierbarhet" ; -- jazzifierbarhet..nn.1
  jazzifiering_1_N = mkN "jazzifiering" ; -- jazzifiering..nn.1
  jazzig_1_A = mkA "jazzig" ; -- jazzig..av.1
  jazzighet_1_N = mkN "jazzighet" ; -- jazzighet..nn.1
  jazzintresserad_1_A = mkA "jazzintresserad" ; -- jazzintresserad..av.1
  jazzkonsert_1_N = mkN "jazzkonsert" "jazzkonserter" ; -- jazzkonsert..nn.1
  jazzlåt_1_N = mkN "jazzlåt" ; -- jazzlåt..nn.1
  jazzmusiker_1_N = mkN "jazzmusiker" "jazzmusikern" "jazzmusiker" "jazzmusikerna" ; -- jazzmusiker..nn.1
  jazzmässig_1_A = mkA "jazzmässig" ; -- jazzmässig..av.1
  jazzorkester_1_N = mkN "jazzorkester" ; -- jazzorkester..nn.1
  jazzschlager_1_N = mkN "jazzschlager" ; -- jazzschlager..nn.1
  jeansficka_1_N = mkN "jeansficka" ; -- jeansficka..nn.1
  jeansjacka_1_N = mkN "jeansjacka" ; -- jeansjacka..nn.1
  jeanstyg_1_N = mkN "jeanstyg" neutrum  ; -- jeanstyg..nn.1
  jeep_1_N = mkN "jeep" ; -- jeep..nn.1
  jemenit_1_N = mkN "jemenit" "jemeniter" ; -- jemenit..nn.1
  jemenitisk_1_A = mkA "jemenitisk" ; -- jemenitisk..av.1
  jemenitiska_1_N = mkN "jemenitiska" ; -- jemenitiska..nn.1
  jenka_1_N = mkN "jenka" ; -- jenka..nn.1
  jeppe_1_N = mkN "jeppe" utrum  ; -- jeppe..nn.1
  jeremiad_1_N = mkN "jeremiad" "jeremiader" ; -- jeremiad..nn.1
  jerikoros_1_N = mkN "jerikoros" ; -- jerikoros..nn.1
  jerseyko_1_N = mkN "jerseyko" "jerseykor" ; -- jerseyko..nn.1
  jesuit_1_N = mkN "jesuit" "jesuiter" ; -- jesuit..nn.1
  jesuitgeneral_1_N = mkN "jesuitgeneral" "jesuitgeneraler" ; -- jesuitgeneral..nn.1
  jesuitisk_1_A = mkA "jesuitisk" ; -- jesuitisk..av.1
  jesuitism_1_N = mkN "jesuitism" ; -- jesuitism..nn.1
  jesuitorden_1_N = mkN "jesuitorden" ; -- jesuitorden..nn.1
  jesusbarn_1_N = mkN "jesusbarn" neutrum  ; -- jesusbarn..nn.1
  jesuslegend_1_N = mkN "jesuslegend" "jesuslegender" ; -- jesuslegend..nn.1
  jet_lag_1_N = mkN "jet-lag" ; -- jet-lag..nn.1
  jet_lagg_1_N = mkN "jet-lagg" ; -- jet-lagg..nn.1
  jet_1_N = mkN "jet" ; -- jet..nn.1
  jetdrift_1_N = mkN "jetdrift" ; -- jetdrift..nn.1
  jetflygplan_1_N = mkN "jetflygplan" neutrum  ; -- jetflygplan..nn.1
  jethjälm_1_N = mkN "jethjälm" ; -- jethjälm..nn.1
  jetlag_1_N = mkN "jetlag" ; -- jetlag..nn.1
  jetlagg_1_N = mkN "jetlagg" ; -- jetlagg..nn.1
  jetlaggad_1_A = mkA "jetlaggad" ; -- jetlaggad..av.1
  jetmotor_1_N = mkN "jetmotor" "jetmotorer" ; -- jetmotor..nn.1
  jetong_1_N = mkN "jetong" "jetonger" ; -- jetong..nn.1
  jetplan_1_N = mkN "jetplan" neutrum  ; -- jetplan..nn.1
  jetset_1_N = mkN "jetset" neutrum  ; -- jetset..nn.1
  jetsettare_1_N = mkN "jetsettare" utrum  ; -- jetsettare..nn.1
  jetslinga_1_N = mkN "jetslinga" ; -- jetslinga..nn.1
  jetström_1_N = mkN "jetström" "jetströmmen" "jetströmmar" "jetströmmarna" ; -- jetström..nn.1
  jetålder_1_N = mkN "jetålder" ; -- jetålder..nn.1
  jidder_1_N = mkN "jidder" neutrum  ; -- jidder..nn.1
  jiddisch_1_N = mkN "jiddisch" ; -- jiddisch..nn.1
  jiddra_1_V = mkV "jiddrar" ; -- jiddra..vb.1
  jig_1_N = mkN "jig" ; -- jig..nn.1
  jigg_1_N = mkN "jigg" ; -- jigg..nn.1
  jihad_1_N = mkN "jihad" "jihader" ; -- jihad..nn.1
  jingoism_1_N = mkN "jingoism" "jingoismer" ; -- jingoism..nn.1
  jippo_1_N = mkN "jippo" "jippot" "jippon" "jippona" ; -- jippo..nn.1
  jiujitsu_1_N = mkN "jiujitsu" ; -- jiujitsu..nn.1
  jo_jo_banta_1_V = mkV "jo-jo-bantar" ; -- jo-jo-banta..vb.1
  jo_jo_bantande_1_N = mkN "jo-jo-bantande" ; -- jo-jo-bantande..nn.1
  jo_jo_bantning_1_N = mkN "jo-jo-bantning" ; -- jo-jo-bantning..nn.1
  jo_jo_beteende_1_N = mkN "jo-jo-beteende" ; -- jo-jo-beteende..nn.1
  jo_jo_väder_1_N = mkN "jo-jo-väder" neutrum  ; -- jo-jo-väder..nn.1
  jo_jo_1_N = mkN "jo-jo" ; -- jo-jo..nn.1
  jobb_1_N = mkN "jobb" neutrum  ; -- jobb..nn.1
  jobba_1_V = mkV "jobbar" ; -- jobba..vb.1
  jobbande_1_N = mkN "jobbande" ; -- jobbande..nn.1
  jobbare_1_N = mkN "jobbare" utrum  ; -- jobbare..nn.1
  jobbarkompis_1_N = mkN "jobbarkompis" ; -- jobbarkompis..nn.1
  jobbcoach_1_N = mkN "jobbcoach" ; -- jobbcoach..nn.1
  jobbcoachning_1_N = mkN "jobbcoachning" ; -- jobbcoachning..nn.1
  jobbcoachningsföretag_1_N = mkN "jobbcoachningsföretag" neutrum  ; -- jobbcoachningsföretag..nn.1
  jobberi_1_N = mkN "jobberi" "jobberiet" "jobberier" "jobberierna" ; -- jobberi..nn.1
  jobbig_1_A = mkA "jobbig" ; -- jobbig..av.1
  jobbighet_1_N = mkN "jobbighet" ; -- jobbighet..nn.1
  jobbighet_2_N = mkN "jobbighet" "jobbigheter" ; -- jobbighet..nn.2
  jobbintervju_1_N = mkN "jobbintervju" "jobbintervjun" "jobbintervjuer" "jobbintervjuerna" ; -- jobbintervju..nn.1
  jobbkök_1_N = mkN "jobbkök" neutrum  ; -- jobbkök..nn.1
  jobbprognos_1_N = mkN "jobbprognos" "jobbprognoser" ; -- jobbprognos..nn.1
  jobbras_1_N = mkN "jobbras" "jobbraser" ; -- jobbras..nn.1
  jobbrelaterad_1_A = mkA "jobbrelaterad" ; -- jobbrelaterad..av.1
  jobbskapande_1_A = mkA "jobbskapande" ; -- jobbskapande..av.1
  jobbskatteavdrag_1_N = mkN "jobbskatteavdrag" neutrum  ; -- jobbskatteavdrag..nn.1
  jobbskattesänkning_1_N = mkN "jobbskattesänkning" ; -- jobbskattesänkning..nn.1
  jobbsökande_1_N = mkN "jobbsökande" "jobbsökanden" "jobbsökanden" "jobbsökandena" ; -- jobbsökande..nn.1
  jobbsökaraktivitet_1_N = mkN "jobbsökaraktivitet" "jobbsökaraktiviteter" ; -- jobbsökaraktivitet..nn.1
  jobbsökare_1_N = mkN "jobbsökare" utrum  ; -- jobbsökare..nn.1
  jobbyte_1_N = mkN "jobbyte" ; -- jobbyte..nn.1
  jobspost_1_N = mkN "jobspost" "jobsposter" ; -- jobspost..nn.1
  jockej_1_N = mkN "jockej" "jockejer" ; -- jockej..nn.1
  jockey_1_N = mkN "jockey" ; -- jockey..nn.1
  jockeymössa_1_N = mkN "jockeymössa" ; -- jockeymössa..nn.1
  jod_1_N = mkN "jod" ; -- jod..nn.1
  joddel_1_N = mkN "joddel" neutrum  ; -- joddel..nn.1
  joddla_1_V = mkV "joddlar" ; -- joddla..vb.1
  joddlande_1_N = mkN "joddlande" ; -- joddlande..nn.1
  joddling_1_N = mkN "joddling" ; -- joddling..nn.1
  jodera_1_V = mkV "joderar" ; -- jodera..vb.1
  joderande_1_N = mkN "joderande" ; -- joderande..nn.1
  joderbar_1_A = mkA "joderbar" ; -- joderbar..av.1
  joderbarhet_1_N = mkN "joderbarhet" ; -- joderbarhet..nn.1
  jodering_1_N = mkN "jodering" ; -- jodering..nn.1
  jodoform_1_N = mkN "jodoform" ; -- jodoform..nn.1
  jodsprit_1_N = mkN "jodsprit" ; -- jodsprit..nn.1
  jodtablett_1_N = mkN "jodtablett" "jodtabletter" ; -- jodtablett..nn.1
  jodtinktur_1_N = mkN "jodtinktur" ; -- jodtinktur..nn.1
  jogga_1_V = mkV "joggar" ; -- jogga..vb.1
  joggande_1_N = mkN "joggande" ; -- joggande..nn.1
  joggare_1_N = mkN "joggare" utrum  ; -- joggare..nn.1
  jogging_1_N = mkN "jogging" ; -- jogging..nn.1
  joggingrunda_1_N = mkN "joggingrunda" ; -- joggingrunda..nn.1
  joggingsko_1_N = mkN "joggingsko" "joggingskor" ; -- joggingsko..nn.1
  joggingtur_1_N = mkN "joggingtur" "joggingturer" ; -- joggingtur..nn.1
  joggling_1_N = mkN "joggling" ; -- joggling..nn.1
  joggning_1_N = mkN "joggning" ; -- joggning..nn.1
  johannesbröd_1_N = mkN "johannesbröd" neutrum  ; -- johannesbröd..nn.1
  johannesbrödträd_1_N = mkN "johannesbrödträd" neutrum  ; -- johannesbrödträd..nn.1
  johannesört_1_N = mkN "johannesört" "johannesörter" ; -- johannesört..nn.1
  johannit_1_N = mkN "johannit" "johanniter" ; -- johannit..nn.1
  johanniterkors_1_N = mkN "johanniterkors" neutrum  ; -- johanniterkors..nn.1
  johanniterorden_1_N = mkN "johanniterorden" ; -- johanniterorden..nn.1
  johannitkors_1_N = mkN "johannitkors" neutrum  ; -- johannitkors..nn.1
  johannitorden_1_N = mkN "johannitorden" ; -- johannitorden..nn.1
  joint_1_N = mkN "joint" "jointer" ; -- joint..nn.1
  jojk_1_N = mkN "jojk" ; -- jojk..nn.1
  jojka_1_V = mkV "jojkar" ; -- jojka..vb.1
  jojkande_1_N = mkN "jojkande" ; -- jojkande..nn.1
  jojo_banta_1_V = mkV "jojo-bantar" ; -- jojo-banta..vb.1
  jojo_bantande_1_N = mkN "jojo-bantande" ; -- jojo-bantande..nn.1
  jojo_bantning_1_N = mkN "jojo-bantning" ; -- jojo-bantning..nn.1
  jojo_beteende_1_N = mkN "jojo-beteende" ; -- jojo-beteende..nn.1
  jojo_väder_1_N = mkN "jojo-väder" neutrum  ; -- jojo-väder..nn.1
  jojo_1_N = mkN "jojo" ; -- jojo..nn.1
  jojobanta_1_V = mkV "jojobantar" ; -- jojobanta..vb.1
  jojobantande_1_N = mkN "jojobantande" ; -- jojobantande..nn.1
  jojobantning_1_N = mkN "jojobantning" ; -- jojobantning..nn.1
  jojobeteende_1_N = mkN "jojobeteende" ; -- jojobeteende..nn.1
  jojoväder_1_N = mkN "jojoväder" neutrum  ; -- jojoväder..nn.1
  joker_1_N = mkN "joker" ; -- joker..nn.1
  jokk_1_N = mkN "jokk" ; -- jokk..nn.1
  jolle_1_N = mkN "jolle" utrum  ; -- jolle..nn.1
  joller_1_N = mkN "joller" neutrum  ; -- joller..nn.1
  jollra_1_V = mkV "jollrar" ; -- jollra..vb.1
  jollrande_1_N = mkN "jollrande" ; -- jollrande..nn.1
  jolmig_1_A = mkA "jolmig" ; -- jolmig..av.1
  jolmighet_1_N = mkN "jolmighet" ; -- jolmighet..nn.1
  jolster_1_N = mkN "jolster" ; -- jolster..nn.1
  jolta_1_V = mkV "joltar" ; -- jolta..vb.1
  joltande_1_N = mkN "joltande" ; -- joltande..nn.1
  jon_1_N = mkN "jon" "joner" ; -- jon..nn.1
  jonbildning_1_N = mkN "jonbildning" ; -- jonbildning..nn.1
  jonbindning_1_N = mkN "jonbindning" ; -- jonbindning..nn.1
  jonbytare_1_N = mkN "jonbytare" utrum  ; -- jonbytare..nn.1
  joner_1_N = mkN "joner" "jonern" "joner" "jonerna" ; -- joner..nn.1
  jonfläck_1_N = mkN "jonfläck" ; -- jonfläck..nn.1
  jonfälla_1_N = mkN "jonfälla" ; -- jonfälla..nn.1
  jonförening_1_N = mkN "jonförening" ; -- jonförening..nn.1
  jongitter_1_N = mkN "jongitter" neutrum  ; -- jongitter..nn.1
  jonglera_1_V = mkV "jonglerar" ; -- jonglera..vb.1
  jonglerande_1_N = mkN "jonglerande" ; -- jonglerande..nn.1
  jonglerbar_1_A = mkA "jonglerbar" ; -- jonglerbar..av.1
  jonglerbarhet_1_N = mkN "jonglerbarhet" ; -- jonglerbarhet..nn.1
  jonglering_1_N = mkN "jonglering" ; -- jonglering..nn.1
  jonglör_1_N = mkN "jonglör" "jonglörer" ; -- jonglör..nn.1
  jonglörkonst_1_N = mkN "jonglörkonst" "jonglörkonster" ; -- jonglörkonst..nn.1
  jonglörskonst_1_N = mkN "jonglörskonst" "jonglörskonster" ; -- jonglörskonst..nn.1
  jonier_1_N = mkN "jonier" "joniern" "jonier" "jonierna" ; -- jonier..nn.1
  jonisation_1_N = mkN "jonisation" ; -- jonisation..nn.1
  jonisera_1_V = mkV "joniserar" ; -- jonisera..vb.1
  joniserande_1_N = mkN "joniserande" ; -- joniserande..nn.1
  joniserbar_1_A = mkA "joniserbar" ; -- joniserbar..av.1
  joniserbarhet_1_N = mkN "joniserbarhet" ; -- joniserbarhet..nn.1
  jonisering_1_N = mkN "jonisering" ; -- jonisering..nn.1
  joniseringsenergi_1_N = mkN "joniseringsenergi" "joniseringsenergier" ; -- joniseringsenergi..nn.1
  joniseringstendens_1_N = mkN "joniseringstendens" "joniseringstendenser" ; -- joniseringstendens..nn.1
  jonisk_1_A = mkA "jonisk" ; -- jonisk..av.1
  jonkanal_1_N = mkN "jonkanal" "jonkanaler" ; -- jonkanal..nn.1
  jonkill_1_N = mkN "jonkill" "jonkiller" ; -- jonkill..nn.1
  jonkvill_1_N = mkN "jonkvill" "jonkviller" ; -- jonkvill..nn.1
  jonkälla_1_N = mkN "jonkälla" ; -- jonkälla..nn.1
  jonosfär_1_N = mkN "jonosfär" ; -- jonosfär..nn.1
  jonstråle_1_N = mkN "jonstråle" utrum  ; -- jonstråle..nn.1
  jord_1_N = mkN "jord" ; -- jord..nn.1
  jorda_1_V = mkV "jordar" ; -- jorda..vb.1
  jordabalk_1_N = mkN "jordabalk" ; -- jordabalk..nn.1
  jordafärd_1_N = mkN "jordafärd" "jordafärder" ; -- jordafärd..nn.1
  jordagods_1_N = mkN "jordagods" neutrum  ; -- jordagods..nn.1
  jordanalys_1_N = mkN "jordanalys" "jordanalyser" ; -- jordanalys..nn.1
  jordande_1_N = mkN "jordande" utrum  ; -- jordande..nn.1
  jordande_2_N = mkN "jordande" ; -- jordande..nn.2
  jordanier_1_N = mkN "jordanier" "jordaniern" "jordanier" "jordanierna" ; -- jordanier..nn.1
  jordansk_1_A = mkA "jordansk" ; -- jordansk..av.1
  jordanska_1_N = mkN "jordanska" ; -- jordanska..nn.1
  jordart_1_N = mkN "jordart" "jordarter" ; -- jordart..nn.1
  jordartsmetall_1_N = mkN "jordartsmetall" "jordartsmetaller" ; -- jordartsmetall..nn.1
  jordatmosfär_1_N = mkN "jordatmosfär" "jordatmosfärer" ; -- jordatmosfär..nn.1
  jordavsöndring_1_N = mkN "jordavsöndring" ; -- jordavsöndring..nn.1
  jordaxel_1_N = mkN "jordaxel" ; -- jordaxel..nn.1
  jordbana_1_N = mkN "jordbana" ; -- jordbana..nn.1
  jordbeck_1_N = mkN "jordbeck" neutrum  ; -- jordbeck..nn.1
  jordbegravning_1_N = mkN "jordbegravning" ; -- jordbegravning..nn.1
  jordbi_1_N = mkN "jordbi" "jordbiet" "jordbin" "jordbina" ; -- jordbi..nn.1
  jordblad_1_N = mkN "jordblad" neutrum  ; -- jordblad..nn.1
  jordbo_1_N = mkN "jordbo" "jordbor" ; -- jordbo..nn.1
  jordborr_1_N = mkN "jordborr" ; -- jordborr..nn.1
  jordbruk_1_N = mkN "jordbruk" neutrum  ; -- jordbruk..nn.1
  jordbrukande_1_A = mkA "jordbrukande" ; -- jordbrukande..av.1
  jordbrukare_1_N = mkN "jordbrukare" utrum  ; -- jordbrukare..nn.1
  jordbrukarsamhälle_1_N = mkN "jordbrukarsamhälle" ; -- jordbrukarsamhälle..nn.1
  jordbruksbebyggelse_1_N = mkN "jordbruksbebyggelse" "jordbruksbebyggelser" ; -- jordbruksbebyggelse..nn.1
  jordbruksbefolkning_1_N = mkN "jordbruksbefolkning" ; -- jordbruksbefolkning..nn.1
  jordbruksbygd_1_N = mkN "jordbruksbygd" "jordbruksbygder" ; -- jordbruksbygd..nn.1
  jordbruksdepartement_1_N = mkN "jordbruksdepartement" neutrum  ; -- jordbruksdepartement..nn.1
  jordbruksforskning_1_N = mkN "jordbruksforskning" ; -- jordbruksforskning..nn.1
  jordbrukslandskap_1_N = mkN "jordbrukslandskap" neutrum  ; -- jordbrukslandskap..nn.1
  jordbruksmark_1_N = mkN "jordbruksmark" "jordbruksmarker" ; -- jordbruksmark..nn.1
  jordbruksmaskin_1_N = mkN "jordbruksmaskin" "jordbruksmaskiner" ; -- jordbruksmaskin..nn.1
  jordbruksminister_1_N = mkN "jordbruksminister" ; -- jordbruksminister..nn.1
  jordbruksmässig_1_A = mkA "jordbruksmässig" ; -- jordbruksmässig..av.1
  jordbruksnämnd_1_N = mkN "jordbruksnämnd" "jordbruksnämnder" ; -- jordbruksnämnd..nn.1
  jordbrukspolitik_1_N = mkN "jordbrukspolitik" ; -- jordbrukspolitik..nn.1
  jordbrukspolitisk_1_A = mkA "jordbrukspolitisk" ; -- jordbrukspolitisk..av.1
  jordbruksprodukt_1_N = mkN "jordbruksprodukt" "jordbruksprodukter" ; -- jordbruksprodukt..nn.1
  jordbruksredskap_1_N = mkN "jordbruksredskap" neutrum  ; -- jordbruksredskap..nn.1
  jordbruksreform_1_N = mkN "jordbruksreform" "jordbruksreformer" ; -- jordbruksreform..nn.1
  jordbunden_1_A = mkA "jordbunden" ; -- jordbunden..av.1
  jordbundenhet_1_N = mkN "jordbundenhet" ; -- jordbundenhet..nn.1
  jordbävning_1_N = mkN "jordbävning" ; -- jordbävning..nn.1
  jordbävningsdrabbad_1_A = mkA "jordbävningsdrabbad" ; -- jordbävningsdrabbad..av.1
  jordbävningssäker_1_A = mkA "jordbävningssäker" ; -- jordbävningssäker..av.1
  jordbävningssäkerhet_1_N = mkN "jordbävningssäkerhet" ; -- jordbävningssäkerhet..nn.1
  jorddelning_1_N = mkN "jorddelning" ; -- jorddelning..nn.1
  jorddrott_1_N = mkN "jorddrott" ; -- jorddrott..nn.1
  jordebok_1_N = mkN "jordebok" "jordeböcker" ; -- jordebok..nn.1
  jordegendom_1_N = mkN "jordegendom" ; -- jordegendom..nn.1
  jordekorre_1_N = mkN "jordekorre" utrum  ; -- jordekorre..nn.1
  jordeliv_1_N = mkN "jordeliv" neutrum  ; -- jordeliv..nn.1
  jordemoder_1_N = mkN "jordemoder" ; -- jordemoder..nn.1
  jorden_runt_seglare_1_N = mkN "jorden-runt-seglare" utrum  ; -- jorden-runt-seglare..nn.1
  jordens_1_A = mkA "jordens" ; -- jordens..av.1
  jorderund_1_N = mkN "jorderund" ; -- jorderund..nn.1
  jordfast_1_A = mkA "jordfast" "jordfast" ; -- jordfast..av.1
  jordfly_1_N = mkN "jordfly" "jordflyet" "jordflyn" "jordflyna" ; -- jordfly..nn.1
  jordflykt_1_N = mkN "jordflykt" ; -- jordflykt..nn.1
  jordflytning_1_N = mkN "jordflytning" ; -- jordflytning..nn.1
  jordfräs_1_N = mkN "jordfräs" ; -- jordfräs..nn.1
  jordfynd_1_N = mkN "jordfynd" neutrum  ; -- jordfynd..nn.1
  jordfärg_1_N = mkN "jordfärg" "jordfärger" ; -- jordfärg..nn.1
  jordfärgad_1_A = mkA "jordfärgad" ; -- jordfärgad..av.1
  jordfärgämne_1_N = mkN "jordfärgämne" ; -- jordfärgämne..nn.1
  jordfästa_1_V = mkV "jordfästa" "jordfäster" "jordfäst" "jordfäste" "jordfäst" "jordfäst" ; -- jordfästa..vb.1
  jordfästande_1_N = mkN "jordfästande" ; -- jordfästande..nn.1
  jordfästning_1_N = mkN "jordfästning" ; -- jordfästning..nn.1
  jordförbättring_1_N = mkN "jordförbättring" ; -- jordförbättring..nn.1
  jordförstöring_1_N = mkN "jordförstöring" ; -- jordförstöring..nn.1
  jordgeting_1_N = mkN "jordgeting" ; -- jordgeting..nn.1
  jordglob_1_N = mkN "jordglob" "jordglober" ; -- jordglob..nn.1
  jordgolv_1_N = mkN "jordgolv" neutrum  ; -- jordgolv..nn.1
  jordgubb_1_N = mkN "jordgubb" ; -- jordgubb..nn.1
  jordgubbe_1_N = mkN "jordgubbe" utrum  ; -- jordgubbe..nn.1
  jordgubbssaft_1_N = mkN "jordgubbssaft" "jordgubbssafter" ; -- jordgubbssaft..nn.1
  jordgubbsskörd_1_N = mkN "jordgubbsskörd" ; -- jordgubbsskörd..nn.1
  jordgubbssmak_1_N = mkN "jordgubbssmak" ; -- jordgubbssmak..nn.1
  jordgubbssylt_1_N = mkN "jordgubbssylt" "jordgubbssylter" ; -- jordgubbssylt..nn.1
  jordhacka_1_N = mkN "jordhacka" ; -- jordhacka..nn.1
  jordhåla_1_N = mkN "jordhåla" ; -- jordhåla..nn.1
  jordig_1_A = mkA "jordig" ; -- jordig..av.1
  jordighet_1_N = mkN "jordighet" ; -- jordighet..nn.1
  jordisk_1_A = mkA "jordisk" ; -- jordisk..av.1
  jordkabel_1_N = mkN "jordkabel" ; -- jordkabel..nn.1
  jordklot_1_N = mkN "jordklot" neutrum  ; -- jordklot..nn.1
  jordkula_1_N = mkN "jordkula" ; -- jordkula..nn.1
  jordkällare_1_N = mkN "jordkällare" utrum  ; -- jordkällare..nn.1
  jordkärna_1_N = mkN "jordkärna" ; -- jordkärna..nn.1
  jordlager_1_N = mkN "jordlager" neutrum  ; -- jordlager..nn.1
  jordledning_1_N = mkN "jordledning" ; -- jordledning..nn.1
  jordlega_1_N = mkN "jordlega" ; -- jordlega..nn.1
  jordlik_1_A = mkA "jordlik" ; -- jordlik..av.1
  jordlikhet_1_N = mkN "jordlikhet" ; -- jordlikhet..nn.1
  jordloppa_1_N = mkN "jordloppa" ; -- jordloppa..nn.1
  jordlott_1_N = mkN "jordlott" "jordlotter" ; -- jordlott..nn.1
  jordlöpare_1_N = mkN "jordlöpare" utrum  ; -- jordlöpare..nn.1
  jordlös_1_A = mkA "jordlös" ; -- jordlös..av.1
  jordmagnetism_1_N = mkN "jordmagnetism" "jordmagnetismer" ; -- jordmagnetism..nn.1
  jordmantel_1_N = mkN "jordmantel" ; -- jordmantel..nn.1
  jordmateria_1_N = mkN "jordmateria" "jordmaterian" "jordmaterier" "jordmaterierna" ; -- jordmateria..nn.1
  jordmaterial_1_N = mkN "jordmaterial" neutrum  ; -- jordmaterial..nn.1
  jordmetall_1_N = mkN "jordmetall" "jordmetaller" ; -- jordmetall..nn.1
  jordmån_1_N = mkN "jordmån" ; -- jordmån..nn.1
  jordnära_1_A = mkA "jordnära" ; -- jordnära..av.1
  jordnöt_1_N = mkN "jordnöt" "jordnötter" ; -- jordnöt..nn.1
  jordnötssmör_1_N = mkN "jordnötssmör" neutrum  ; -- jordnötssmör..nn.1
  jordområde_1_N = mkN "jordområde" ; -- jordområde..nn.1
  jordpartikel_1_N = mkN "jordpartikel" ; -- jordpartikel..nn.1
  jordpåse_1_N = mkN "jordpåse" utrum  ; -- jordpåse..nn.1
  jordreform_1_N = mkN "jordreform" "jordreformer" ; -- jordreform..nn.1
  jordregister_1_N = mkN "jordregister" neutrum  ; -- jordregister..nn.1
  jordremsa_1_N = mkN "jordremsa" ; -- jordremsa..nn.1
  jordrotation_1_N = mkN "jordrotation" ; -- jordrotation..nn.1
  jordränta_1_N = mkN "jordränta" ; -- jordränta..nn.1
  jordrök_1_N = mkN "jordrök" ; -- jordrök..nn.1
  jordskalv_1_N = mkN "jordskalv" neutrum  ; -- jordskalv..nn.1
  jordskalvsaktivist_1_N = mkN "jordskalvsaktivist" "jordskalvsaktivister" ; -- jordskalvsaktivist..nn.1
  jordsken_1_N = mkN "jordsken" neutrum  ; -- jordsken..nn.1
  jordskorpa_1_N = mkN "jordskorpa" ; -- jordskorpa..nn.1
  jordskott_1_N = mkN "jordskott" neutrum  ; -- jordskott..nn.1
  jordskred_1_N = mkN "jordskred" neutrum  ; -- jordskred..nn.1
  jordskredsseger_1_N = mkN "jordskredsseger" ; -- jordskredsseger..nn.1
  jordskugga_1_N = mkN "jordskugga" ; -- jordskugga..nn.1
  jordskyld_1_N = mkN "jordskyld" "jordskylder" ; -- jordskyld..nn.1
  jordslag_1_N = mkN "jordslag" neutrum  ; -- jordslag..nn.1
  jordslå_1_V = mkV "jordslå" "jordslog" "jordslagit" ; -- jordslå..vb.1
  jordslående_1_N = mkN "jordslående" ; -- jordslående..nn.1
  jordspjut_1_N = mkN "jordspjut" neutrum  ; -- jordspjut..nn.1
  jordstam_1_N = mkN "jordstam" "jordstammen" "jordstammar" "jordstammarna" ; -- jordstam..nn.1
  jordstjärna_1_N = mkN "jordstjärna" ; -- jordstjärna..nn.1
  jordström_1_N = mkN "jordström" "jordströmmen" "jordströmmar" "jordströmmarna" ; -- jordström..nn.1
  jordstöt_1_N = mkN "jordstöt" ; -- jordstöt..nn.1
  jordsvin_1_N = mkN "jordsvin" neutrum  ; -- jordsvin..nn.1
  jordtag_1_N = mkN "jordtag" neutrum  ; -- jordtag..nn.1
  jordtrötthet_1_N = mkN "jordtrötthet" "jordtröttheter" ; -- jordtrötthet..nn.1
  jordtyp_1_N = mkN "jordtyp" "jordtyper" ; -- jordtyp..nn.1
  jordtäkt_1_N = mkN "jordtäkt" "jordtäkter" ; -- jordtäkt..nn.1
  jorduggla_1_N = mkN "jorduggla" ; -- jorduggla..nn.1
  jordutdelning_1_N = mkN "jordutdelning" ; -- jordutdelning..nn.1
  jordvall_1_N = mkN "jordvall" ; -- jordvall..nn.1
  jordvax_1_N = mkN "jordvax" neutrum  ; -- jordvax..nn.1
  jordvärde_1_N = mkN "jordvärde" ; -- jordvärde..nn.1
  jordvärdestegring_1_N = mkN "jordvärdestegring" ; -- jordvärdestegring..nn.1
  jordvärme_1_N = mkN "jordvärme" utrum  ; -- jordvärme..nn.1
  jordyta_1_N = mkN "jordyta" ; -- jordyta..nn.1
  jordägande_1_A = mkA "jordägande" ; -- jordägande..av.1
  jordägande_1_N = mkN "jordägande" ; -- jordägande..nn.1
  jordägare_1_N = mkN "jordägare" utrum  ; -- jordägare..nn.1
  jordärtskocka_1_N = mkN "jordärtskocka" ; -- jordärtskocka..nn.1
  jorsskalvsaktivist_1_N = mkN "jorsskalvsaktivist" "jorsskalvsaktivister" ; -- jorsskalvsaktivist..nn.1
  jos_1_N = mkN "jos" "joser" ; -- jos..nn.1
  jota_1_N = mkN "jota" "jotat" "jotan" "jotana" ; -- jota..nn.1
  jota_2_N = mkN "jota" ; -- jota..nn.2
  joule_1_N = mkN "joule" "joulen" "joule" "joulena" ; -- joule..nn.1
  jour_1_N = mkN "jour" "jourer" ; -- jour..nn.1
  jourbutik_1_N = mkN "jourbutik" "jourbutiker" ; -- jourbutik..nn.1
  jourhavande_1_A = mkA "jourhavande" ; -- jourhavande..av.1
  jourhavande_1_N = mkN "jourhavande" "jourhavanden" "jourhavanden" "jourhavandena" ; -- jourhavande..nn.1
  journal_1_N = mkN "journal" "journaler" ; -- journal..nn.1
  journalfilm_1_N = mkN "journalfilm" "journalfilmer" ; -- journalfilm..nn.1
  journalist_1_N = mkN "journalist" "journalister" ; -- journalist..nn.1
  journalistik_1_N = mkN "journalistik" ; -- journalistik..nn.1
  journalistisk_1_A = mkA "journalistisk" ; -- journalistisk..av.1
  jourtjänst_1_N = mkN "jourtjänst" ; -- jourtjänst..nn.1
  jovial_1_A = mkA "jovial" ; -- jovial..av.1
  jovialisk_1_A = mkA "jovialisk" ; -- jovialisk..av.1
  jovialitet_1_N = mkN "jovialitet" "jovialiteter" ; -- jovialitet..nn.1
  jox_1_N = mkN "jox" neutrum  ; -- jox..nn.1
  joxa_1_V = mkV "joxar" ; -- joxa..vb.1
  joxande_1_N = mkN "joxande" ; -- joxande..nn.1
  joxig_1_A = mkA "joxig" ; -- joxig..av.1
  ju_1_Adv = mkAdv "ju" ; -- ju..ab.1
  jubel_1_N = mkN "jubel" neutrum  ; -- jubel..nn.1
  jubeldag_1_N = mkN "jubeldag" ; -- jubeldag..nn.1
  jubeldoktor_1_N = mkN "jubeldoktor" "jubeldoktorer" ; -- jubeldoktor..nn.1
  jubelfest_1_N = mkN "jubelfest" "jubelfester" ; -- jubelfest..nn.1
  jubelidiot_1_N = mkN "jubelidiot" "jubelidioter" ; -- jubelidiot..nn.1
  jubelrop_1_N = mkN "jubelrop" neutrum  ; -- jubelrop..nn.1
  jubelsång_1_N = mkN "jubelsång" "jubelsånger" ; -- jubelsång..nn.1
  jubelår_1_N = mkN "jubelår" neutrum  ; -- jubelår..nn.1
  jubelåsna_1_N = mkN "jubelåsna" ; -- jubelåsna..nn.1
  jubilar_1_N = mkN "jubilar" "jubilarer" ; -- jubilar..nn.1
  jubilera_1_V = mkV "jubilerar" ; -- jubilera..vb.1
  jubilerande_1_N = mkN "jubilerande" ; -- jubilerande..nn.1
  jubilering_1_N = mkN "jubilering" ; -- jubilering..nn.1
  jubileum_1_N = mkN "jubileum" "jubileet" "jubileer" "jubileerna" ; -- jubileum..nn.1
  jubileumsmynt_1_N = mkN "jubileumsmynt" neutrum  ; -- jubileumsmynt..nn.1
  jubileumsår_1_N = mkN "jubileumsår" neutrum  ; -- jubileumsår..nn.1
  jubla_1_V = mkV "jublar" ; -- jubla..vb.1
  jublande_1_A = mkA "jublande" ; -- jublande..av.1
  jublande_1_N = mkN "jublande" ; -- jublande..nn.1
  jucka_1_V = mkV "juckar" ; -- jucka..vb.1
  juckande_1_N = mkN "juckande" ; -- juckande..nn.1
  judafolk_1_N = mkN "judafolk" neutrum  ; -- judafolk..nn.1
  judasgärning_1_N = mkN "judasgärning" ; -- judasgärning..nn.1
  judaskyss_1_N = mkN "judaskyss" ; -- judaskyss..nn.1
  judaspeng_1_N = mkN "judaspeng" ; -- judaspeng..nn.1
  jude_1_N = mkN "jude" utrum  ; -- jude..nn.1
  judebröd_1_N = mkN "judebröd" neutrum  ; -- judebröd..nn.1
  judedeportation_1_N = mkN "judedeportation" ; -- judedeportation..nn.1
  judeförföljelse_1_N = mkN "judeförföljelse" "judeförföljelser" ; -- judeförföljelse..nn.1
  judehat_1_N = mkN "judehat" neutrum  ; -- judehat..nn.1
  judekristen_1_A = mkA "judekristen" ; -- judekristen..av.1
  judekristenhet_1_N = mkN "judekristenhet" ; -- judekristenhet..nn.1
  judendom_1_N = mkN "judendom" ; -- judendom..nn.1
  judenhet_1_N = mkN "judenhet" "judenheter" ; -- judenhet..nn.1
  judetyska_1_N = mkN "judetyska" ; -- judetyska..nn.1
  judeutrotning_1_N = mkN "judeutrotning" ; -- judeutrotning..nn.1
  judiciell_1_A = mkA "judiciell" ; -- judiciell..av.1
  judinna_1_N = mkN "judinna" ; -- judinna..nn.1
  judisk_1_A = mkA "judisk" ; -- judisk..av.1
  judo_1_N = mkN "judo" ; -- judo..nn.1
  juft_1_N = mkN "juft" ; -- juft..nn.1
  jugend_1_N = mkN "jugend" ; -- jugend..nn.1
  jugendband_1_N = mkN "jugendband" neutrum  ; -- jugendband..nn.1
  jugendslott_1_N = mkN "jugendslott" neutrum  ; -- jugendslott..nn.1
  jugendstil_1_N = mkN "jugendstil" ; -- jugendstil..nn.1
  juggemaffia_1_N = mkN "juggemaffia" ; -- juggemaffia..nn.1
  jugoslav_1_N = mkN "jugoslav" "jugoslaver" ; -- jugoslav..nn.1
  jugoslavisk_1_A = mkA "jugoslavisk" ; -- jugoslavisk..av.1
  jugoslaviska_1_N = mkN "jugoslaviska" ; -- jugoslaviska..nn.1
  juice_1_N = mkN "juice" "juicer" ; -- juice..nn.1
  jujutsu_1_N = mkN "jujutsu" ; -- jujutsu..nn.1
  jukebox_1_N = mkN "jukebox" ; -- jukebox..nn.1
  jul_1_N = mkN "jul" ; -- jul..nn.1
  jula_1_V = mkV "jular" ; -- jula..vb.1
  julafton_1_N = mkN "julafton" "julaftonen" "julaftnar" "julaftnarna" ; -- julafton..nn.1
  julande_1_N = mkN "julande" ; -- julande..nn.1
  julbelysning_1_N = mkN "julbelysning" ; -- julbelysning..nn.1
  julbock_1_N = mkN "julbock" ; -- julbock..nn.1
  julbord_1_N = mkN "julbord" neutrum  ; -- julbord..nn.1
  julbön_1_N = mkN "julbön" "julböner" ; -- julbön..nn.1
  juldag_1_N = mkN "juldag" ; -- juldag..nn.1
  juldagsmorgon_1_N = mkN "juldagsmorgon" "juldagsmorgonen" "juldagsmornar" "juldagsmornarna" ; -- juldagsmorgon..nn.1
  juldekor_1_N = mkN "juldekor" "juldekoren" "juldekorer" "juldekorerna" ; -- juldekor..nn.1
  juldekoration_1_N = mkN "juldekoration" ; -- juldekoration..nn.1
  juleljus_1_N = mkN "juleljus" neutrum  ; -- juleljus..nn.1
  juletid_1_N = mkN "juletid" "juletider" ; -- juletid..nn.1
  julevangelium_1_N = mkN "julevangelium" "julevangeliet" "julevangelier" "julevangelierna" ; -- julevangelium..nn.1
  julfemma_1_N = mkN "julfemma" ; -- julfemma..nn.1
  julfest_1_N = mkN "julfest" "julfester" ; -- julfest..nn.1
  julfilm_1_N = mkN "julfilm" "julfilmer" ; -- julfilm..nn.1
  julfirande_1_A = mkA "julfirande" ; -- julfirande..av.1
  julfirande_1_N = mkN "julfirande" ; -- julfirande..nn.1
  julförsäljning_1_N = mkN "julförsäljning" ; -- julförsäljning..nn.1
  julgran_1_N = mkN "julgran" ; -- julgran..nn.1
  julgransbelysning_1_N = mkN "julgransbelysning" ; -- julgransbelysning..nn.1
  julgransfot_1_N = mkN "julgransfot" "julgransfötter" ; -- julgransfot..nn.1
  julgranskaramell_1_N = mkN "julgranskaramell" "julgranskarameller" ; -- julgranskaramell..nn.1
  julgranskula_1_N = mkN "julgranskula" ; -- julgranskula..nn.1
  julgransljus_1_N = mkN "julgransljus" neutrum  ; -- julgransljus..nn.1
  julgransmatta_1_N = mkN "julgransmatta" ; -- julgransmatta..nn.1
  julgransplundring_1_N = mkN "julgransplundring" ; -- julgransplundring..nn.1
  julgransprydnad_1_N = mkN "julgransprydnad" "julgransprydnader" ; -- julgransprydnad..nn.1
  julgris_1_N = mkN "julgris" ; -- julgris..nn.1
  julgrupp_1_N = mkN "julgrupp" "julgrupper" ; -- julgrupp..nn.1
  julgåva_1_N = mkN "julgåva" ; -- julgåva..nn.1
  julhandel_1_N = mkN "julhandel" ; -- julhandel..nn.1
  julhandla_1_V = mkV "julhandlar" ; -- julhandla..vb.1
  julhandlande_1_N = mkN "julhandlande" ; -- julhandlande..nn.1
  julhelg_1_N = mkN "julhelg" "julhelger" ; -- julhelg..nn.1
  julhysteri_1_N = mkN "julhysteri" "julhysteriet" "julhysterier" "julhysterierna" ; -- julhysteri..nn.1
  juli_1_N = mkN "juli" ; -- juli..nn.1
  juliansk_1_A = mkA "juliansk" ; -- juliansk..av.1
  juliförmiddag_1_N = mkN "juliförmiddag" ; -- juliförmiddag..nn.1
  juligrönska_1_N = mkN "juligrönska" ; -- juligrönska..nn.1
  julinspirerad_1_A = mkA "julinspirerad" ; -- julinspirerad..av.1
  julkaktus_1_N = mkN "julkaktus" ; -- julkaktus..nn.1
  julkalender_1_N = mkN "julkalender" ; -- julkalender..nn.1
  julkasse_1_N = mkN "julkasse" utrum  ; -- julkasse..nn.1
  julklapp_1_N = mkN "julklapp" ; -- julklapp..nn.1
  julklappsrim_1_N = mkN "julklappsrim" "julklappsrimmet" "julklappsrim" "julklappsrimmen" ; -- julklappsrim..nn.1
  julklappstips_1_N = mkN "julklappstips" neutrum  ; -- julklappstips..nn.1
  julkort_1_N = mkN "julkort" neutrum  ; -- julkort..nn.1
  julkrubba_1_N = mkN "julkrubba" ; -- julkrubba..nn.1
  julkärve_1_N = mkN "julkärve" utrum  ; -- julkärve..nn.1
  julle_1_N = mkN "julle" utrum  ; -- julle..nn.1
  julledig_1_A = mkA "julledig" ; -- julledig..av.1
  julledighet_1_N = mkN "julledighet" ; -- julledighet..nn.1
  julljus_1_N = mkN "julljus" neutrum  ; -- julljus..nn.1
  jullov_1_N = mkN "jullov" neutrum  ; -- jullov..nn.1
  jullåt_1_N = mkN "jullåt" ; -- jullåt..nn.1
  julmarknad_1_N = mkN "julmarknad" "julmarknader" ; -- julmarknad..nn.1
  julmat_1_N = mkN "julmat" ; -- julmat..nn.1
  julmotiv_1_N = mkN "julmotiv" neutrum  ; -- julmotiv..nn.1
  julmust_1_N = mkN "julmust" ; -- julmust..nn.1
  julmys_1_N = mkN "julmys" neutrum  ; -- julmys..nn.1
  julmånad_1_N = mkN "julmånad" "julmånader" ; -- julmånad..nn.1
  julotta_1_N = mkN "julotta" ; -- julotta..nn.1
  julp_1_N = mkN "julp" ; -- julp..nn.1
  julpynt_1_N = mkN "julpynt" neutrum  ; -- julpynt..nn.1
  julpynta_1_V = mkV "julpyntar" ; -- julpynta..vb.1
  julpyntande_1_N = mkN "julpyntande" ; -- julpyntande..nn.1
  julpyntning_1_N = mkN "julpyntning" ; -- julpyntning..nn.1
  julpyssel_1_N = mkN "julpyssel" neutrum  ; -- julpyssel..nn.1
  julrecept_1_N = mkN "julrecept" neutrum  ; -- julrecept..nn.1
  julros_1_N = mkN "julros" "julrosor" ; -- julros..nn.1
  julshow_1_N = mkN "julshow" "julshower" ; -- julshow..nn.1
  julskinka_1_N = mkN "julskinka" ; -- julskinka..nn.1
  julskyltning_1_N = mkN "julskyltning" ; -- julskyltning..nn.1
  julstjärna_1_N = mkN "julstjärna" ; -- julstjärna..nn.1
  julstrumpa_1_N = mkN "julstrumpa" ; -- julstrumpa..nn.1
  julstämning_1_N = mkN "julstämning" ; -- julstämning..nn.1
  julsång_1_N = mkN "julsång" "julsånger" ; -- julsång..nn.1
  jultallrik_1_N = mkN "jultallrik" ; -- jultallrik..nn.1
  jultidning_1_N = mkN "jultidning" ; -- jultidning..nn.1
  jultomte_1_N = mkN "jultomte" utrum  ; -- jultomte..nn.1
  jultrafik_1_N = mkN "jultrafik" ; -- jultrafik..nn.1
  jultårta_1_N = mkN "jultårta" ; -- jultårta..nn.1
  julöl_1_N = mkN "julöl" "julölet" "julöler" "julölerna" ; -- julöl..nn.1
  jumbo_1_N = mkN "jumbo" "jumbor" ; -- jumbo..nn.1
  jumbojet_1_N = mkN "jumbojet" ; -- jumbojet..nn.1
  jumpa_1_N = mkN "jumpa" ; -- jumpa..nn.1
  jumpa_1_V = mkV "jumpar" ; -- jumpa..vb.1
  jumpande_1_N = mkN "jumpande" ; -- jumpande..nn.1
  jumper_1_N = mkN "jumper" ; -- jumper..nn.1
  jungfru_1_N = mkN "jungfru" "jungfrun" "jungfrur" "jungfrurna" ; -- jungfru..nn.1
  jungfrualstring_1_N = mkN "jungfrualstring" ; -- jungfrualstring..nn.1
  jungfruben_1_N = mkN "jungfruben" neutrum  ; -- jungfruben..nn.1
  jungfrubröst_1_N = mkN "jungfrubröst" neutrum  ; -- jungfrubröst..nn.1
  jungfrubur_1_N = mkN "jungfrubur" ; -- jungfrubur..nn.1
  jungfrubörd_1_N = mkN "jungfrubörd" "jungfrubörder" ; -- jungfrubörd..nn.1
  jungfrudom_1_N = mkN "jungfrudom" ; -- jungfrudom..nn.1
  jungfrufödsel_1_N = mkN "jungfrufödsel" ; -- jungfrufödsel..nn.1
  jungfrukammare_1_N = mkN "jungfrukammare" "jungfrukammaren" "jungfrukammare" "jungfrukamrarna" ; -- jungfrukammare..nn.1
  jungfrulig_1_A = mkA "jungfrulig" ; -- jungfrulig..av.1
  jungfrulighet_1_N = mkN "jungfrulighet" ; -- jungfrulighet..nn.1
  jungfrulin_1_N = mkN "jungfrulin" neutrum  ; -- jungfrulin..nn.1
  jungfruolja_1_N = mkN "jungfruolja" ; -- jungfruolja..nn.1
  jungfruresa_1_N = mkN "jungfruresa" ; -- jungfruresa..nn.1
  jungfruslända_1_N = mkN "jungfruslända" ; -- jungfruslända..nn.1
  jungfrustift_1_N = mkN "jungfrustift" neutrum  ; -- jungfrustift..nn.1
  jungfrustånd_1_N = mkN "jungfrustånd" neutrum  ; -- jungfrustånd..nn.1
  jungfrusvärm_1_N = mkN "jungfrusvärm" ; -- jungfrusvärm..nn.1
  jungfrutal_1_N = mkN "jungfrutal" neutrum  ; -- jungfrutal..nn.1
  jungfruvax_1_N = mkN "jungfruvax" neutrum  ; -- jungfruvax..nn.1
  jungman_1_N = mkN "jungman" "jungmannen" "jungmän" "jungmännen" ; -- jungman..nn.1
  juni_1_N = mkN "juni" ; -- juni..nn.1
  junior_1_A = mkA "junior" ; -- junior..av.1
  junior_1_N = mkN "junior" "junioren" "juniorer" "juniorerna" ; -- junior..nn.1
  juniorlag_1_N = mkN "juniorlag" neutrum  ; -- juniorlag..nn.1
  juniormässig_1_A = mkA "juniormässig" ; -- juniormässig..av.1
  junker_1_N = mkN "junker" ; -- junker..nn.1
  junonisk_1_A = mkA "junonisk" ; -- junonisk..av.1
  junta_1_N = mkN "junta" ; -- junta..nn.1
  jura_1_N = mkN "jura" ; -- jura..nn.1
  juridik_1_N = mkN "juridik" ; -- juridik..nn.1
  juridisk_1_A = mkA "juridisk" ; -- juridisk..av.1
  juris_1_A = mkA "juris" ; -- juris..av.1
  jurisdiktion_1_N = mkN "jurisdiktion" ; -- jurisdiktion..nn.1
  jurisprudens_1_N = mkN "jurisprudens" ; -- jurisprudens..nn.1
  jurist_1_N = mkN "jurist" "jurister" ; -- jurist..nn.1
  juristexamen_1_N = mkN "juristexamen" "juristexamen" "juristexamina" "juristexamina" ; -- juristexamen..nn.1
  jurt_1_N = mkN "jurt" neutrum  ; -- jurt..nn.1
  jurta_1_N = mkN "jurta" ; -- jurta..nn.1
  jury_1_N = mkN "jury" "juryer" ; -- jury..nn.1
  jus_1_N = mkN "jus" "juser" ; -- jus..nn.1
  just_1_Adv = mkAdv "just" ; -- just..ab.1
  just_1_A = mkA "just" "just" ; -- just..av.1
  juste_1_A = mkA "juste" ; -- juste..av.1
  justehet_1_N = mkN "justehet" ; -- justehet..nn.1
  justera_1_V = mkV "justerar" ; -- justera..vb.1
  justerande_1_N = mkN "justerande" ; -- justerande..nn.1
  justerare_1_N = mkN "justerare" utrum  ; -- justerare..nn.1
  justerarm_1_N = mkN "justerarm" ; -- justerarm..nn.1
  justerbar_1_A = mkA "justerbar" ; -- justerbar..av.1
  justering_1_N = mkN "justering" ; -- justering..nn.1
  justeringsman_1_N = mkN "justeringsman" "justeringsmannen" "justeringsmän" "justeringsmännen" ; -- justeringsman..nn.1
  justeringsmöjlighet_1_N = mkN "justeringsmöjlighet" "justeringsmöjligheter" ; -- justeringsmöjlighet..nn.1
  justess_1_N = mkN "justess" ; -- justess..nn.1
  justhet_1_N = mkN "justhet" ; -- justhet..nn.1
  justis_1_N = mkN "justis" ; -- justis..nn.1
  justitieborgmästare_1_N = mkN "justitieborgmästare" utrum  ; -- justitieborgmästare..nn.1
  justitiedepartement_1_N = mkN "justitiedepartement" neutrum  ; -- justitiedepartement..nn.1
  justitiekansler_1_N = mkN "justitiekansler" ; -- justitiekansler..nn.1
  justitieminister_1_N = mkN "justitieminister" ; -- justitieminister..nn.1
  justitiemord_1_N = mkN "justitiemord" neutrum  ; -- justitiemord..nn.1
  justitieombudsman_1_N = mkN "justitieombudsman" "justitieombudsmannen" "justitieombudsmän" "justitieombudsmännen" ; -- justitieombudsman..nn.1
  justitieråd_1_N = mkN "justitieråd" neutrum  ; -- justitieråd..nn.1
  justitiesekreterare_1_N = mkN "justitiesekreterare" utrum  ; -- justitiesekreterare..nn.1
  justitieutskott_1_N = mkN "justitieutskott" neutrum  ; -- justitieutskott..nn.1
  jute_1_N = mkN "jute" ; -- jute..nn.1
  jute_2_N = mkN "jute" utrum  ; -- jute..nn.2
  jutespinneri_1_N = mkN "jutespinneri" "jutespinneriet" "jutespinnerier" "jutespinnerierna" ; -- jutespinneri..nn.1
  jutetyg_1_N = mkN "jutetyg" neutrum  ; -- jutetyg..nn.1
  jutländsk_1_A = mkA "jutländsk" ; -- jutländsk..av.1
  jutsk_1_A = mkA "jutsk" ; -- jutsk..av.1
  jutskhet_1_N = mkN "jutskhet" ; -- jutskhet..nn.1
  juvel_1_N = mkN "juvel" "juveler" ; -- juvel..nn.1
  juveleraraffär_1_N = mkN "juveleraraffär" "juveleraraffärer" ; -- juveleraraffär..nn.1
  juvelerarbutik_1_N = mkN "juvelerarbutik" "juvelerarbutiker" ; -- juvelerarbutik..nn.1
  juvelerare_1_N = mkN "juvelerare" utrum  ; -- juvelerare..nn.1
  juvelerarfönster_1_N = mkN "juvelerarfönster" neutrum  ; -- juvelerarfönster..nn.1
  juvelornamentik_1_N = mkN "juvelornamentik" ; -- juvelornamentik..nn.1
  juvelprydd_1_A = mkA "juvelprydd" ; -- juvelprydd..av.1
  juvenil_1_A = mkA "juvenil" ; -- juvenil..av.1
  juvenil_2_A = mkA "juvenil" ; -- juvenil..av.2
  juver_1_N = mkN "juver" neutrum  ; -- juver..nn.1
  juverinflammation_1_N = mkN "juverinflammation" ; -- juverinflammation..nn.1
  juvermassage_1_N = mkN "juvermassage" utrum  ; -- juvermassage..nn.1
  juvervävnad_1_N = mkN "juvervävnad" "juvervävnader" ; -- juvervävnad..nn.1
  juxtaposition_1_N = mkN "juxtaposition" ; -- juxtaposition..nn.1
  jycke_1_N = mkN "jycke" utrum  ; -- jycke..nn.1
  jylländsk_1_A = mkA "jylländsk" ; -- jylländsk..av.1
  jylländska_1_N = mkN "jylländska" ; -- jylländska..nn.1
  jylländska_2_N = mkN "jylländska" ; -- jylländska..nn.2
  jyllänning_1_N = mkN "jyllänning" ; -- jyllänning..nn.1
  jympa_1_N = mkN "jympa" ; -- jympa..nn.1
  jympa_1_V = mkV "jympar" ; -- jympa..vb.1
  jympande_1_N = mkN "jympande" ; -- jympande..nn.1
  jymping_1_N = mkN "jymping" ; -- jymping..nn.1
  jädra_1_A = mkA "jädra" ; -- jädra..av.1
  jädrans_1_A = mkA "jädrans" ; -- jädrans..av.1
  jädrig_1_A = mkA "jädrig" ; -- jädrig..av.1
  jägarbataljon_1_N = mkN "jägarbataljon" "jägarbataljoner" ; -- jägarbataljon..nn.1
  jägarbefolkning_1_N = mkN "jägarbefolkning" ; -- jägarbefolkning..nn.1
  jägarbiff_1_N = mkN "jägarbiff" ; -- jägarbiff..nn.1
  jägare_1_N = mkN "jägare" utrum  ; -- jägare..nn.1
  jägarfolk_1_N = mkN "jägarfolk" neutrum  ; -- jägarfolk..nn.1
  jägarförband_1_N = mkN "jägarförband" neutrum  ; -- jägarförband..nn.1
  jägarhatt_1_N = mkN "jägarhatt" ; -- jägarhatt..nn.1
  jägarhorn_1_N = mkN "jägarhorn" neutrum  ; -- jägarhorn..nn.1
  jägarkompani_1_N = mkN "jägarkompani" "jägarkompaniet" "jägarkompanier" "jägarkompanierna" ; -- jägarkompani..nn.1
  jägarkår_1_N = mkN "jägarkår" ; -- jägarkår..nn.1
  jägarkår_2_N = mkN "jägarkår" "jägarkårer" ; -- jägarkår..nn.2
  jägarlöjtnant_1_N = mkN "jägarlöjtnant" "jägarlöjtnanter" ; -- jägarlöjtnant..nn.1
  jägarstenålder_1_N = mkN "jägarstenålder" ; -- jägarstenålder..nn.1
  jägmästare_1_N = mkN "jägmästare" utrum  ; -- jägmästare..nn.1
  jäkel_1_N = mkN "jäkel" ; -- jäkel..nn.1
  jäkelskap_1_N = mkN "jäkelskap" "jäkelskaper" ; -- jäkelskap..nn.1
  jäkla_1_A = mkA "jäkla" ; -- jäkla..av.1
  jäklig_1_A = mkA "jäklig" ; -- jäklig..av.1
  jäklighet_1_N = mkN "jäklighet" "jäkligheter" ; -- jäklighet..nn.1
  jäkt_1_N = mkN "jäkt" neutrum  ; -- jäkt..nn.1
  jäkta_1_V = mkV "jäktar" ; -- jäkta..vb.1
  jäktad_1_A = mkA "jäktad" ; -- jäktad..av.1
  jäktande_1_N = mkN "jäktande" ; -- jäktande..nn.1
  jäktig_1_A = mkA "jäktig" ; -- jäktig..av.1
  jäktighet_1_N = mkN "jäktighet" ; -- jäktighet..nn.1
  jämbred_1_A = mkA "jämbred" "jämbrett" ; -- jämbred..av.1
  jämbördig_1_A = mkA "jämbördig" ; -- jämbördig..av.1
  jämbördighet_1_N = mkN "jämbördighet" ; -- jämbördighet..nn.1
  jämföra_1_V = mkV "jämföra" "jämförde" "jämfört" ; -- jämföra..vb.1
  jämförande_1_A = mkA "jämförande" ; -- jämförande..av.1
  jämförande_1_N = mkN "jämförande" ; -- jämförande..nn.1
  jämförbar_1_A = mkA "jämförbar" ; -- jämförbar..av.1
  jämförbarhet_1_N = mkN "jämförbarhet" ; -- jämförbarhet..nn.1
  jämförelse_1_N = mkN "jämförelse" "jämförelser" ; -- jämförelse..nn.1
  jämförelsepunkt_1_N = mkN "jämförelsepunkt" "jämförelsepunkter" ; -- jämförelsepunkt..nn.1
  jämförelsetal_1_N = mkN "jämförelsetal" neutrum  ; -- jämförelsetal..nn.1
  jämförelsetjänst_1_N = mkN "jämförelsetjänst" "jämförelsetjänster" ; -- jämförelsetjänst..nn.1
  jämförelsevis_1_Adv = mkAdv "jämförelsevis" ; -- jämförelsevis..ab.1
  jämförlig_1_A = mkA "jämförlig" ; -- jämförlig..av.1
  jämförlighet_1_N = mkN "jämförlighet" ; -- jämförlighet..nn.1
  jämförpris_1_N = mkN "jämförpris" neutrum  ; -- jämförpris..nn.1
  jämgod_1_A = mkA "jämgod" "jämgott" ; -- jämgod..av.1
  jämgodhet_1_N = mkN "jämgodhet" ; -- jämgodhet..nn.1
  jämka_1_V = mkV "jämkar" ; -- jämka..vb.1
  jämkande_1_N = mkN "jämkande" ; -- jämkande..nn.1
  jämkning_1_N = mkN "jämkning" ; -- jämkning..nn.1
  jämkningsförslag_1_N = mkN "jämkningsförslag" neutrum  ; -- jämkningsförslag..nn.1
  jämkningsmån_1_N = mkN "jämkningsmån" ; -- jämkningsmån..nn.1
  jämlik_1_A = mkA "jämlik" ; -- jämlik..av.1
  jämlike_1_N = mkN "jämlike" utrum  ; -- jämlike..nn.1
  jämlikhet_1_N = mkN "jämlikhet" "jämlikheter" ; -- jämlikhet..nn.1
  jämlång_1_A = mkA "jämlång" ; -- jämlång..av.1
  jämmerdal_1_N = mkN "jämmerdal" ; -- jämmerdal..nn.1
  jämmerfull_1_A = mkA "jämmerfull" ; -- jämmerfull..av.1
  jämmerlig_1_A = mkA "jämmerlig" ; -- jämmerlig..av.1
  jämmerlighet_1_N = mkN "jämmerlighet" "jämmerligheter" ; -- jämmerlighet..nn.1
  jämmerlåt_1_N = mkN "jämmerlåt" ; -- jämmerlåt..nn.1
  jämmerrop_1_N = mkN "jämmerrop" neutrum  ; -- jämmerrop..nn.1
  jämmerskri_1_N = mkN "jämmerskri" "jämmerskriet" "jämmerskrin" "jämmerskrina" ; -- jämmerskri..nn.1
  jämmervisa_1_N = mkN "jämmervisa" ; -- jämmervisa..nn.1
  jämn_1_A = mkA "jämn" ; -- jämn..av.1
  jämn_2_A = mkA "jämn" ; -- jämn..av.2
  jämna_1_V = mkV "jämnar" ; -- jämna..vb.1
  jämnande_1_N = mkN "jämnande" ; -- jämnande..nn.1
  jämnbred_1_A = mkA "jämnbred" "jämnbrett" ; -- jämnbred..av.1
  jämnbördig_1_A = mkA "jämnbördig" ; -- jämnbördig..av.1
  jämngod_1_A = mkA "jämngod" "jämngott" ; -- jämngod..av.1
  jämngodhet_1_N = mkN "jämngodhet" ; -- jämngodhet..nn.1
  jämngrå_1_A = mkA "jämngrå" "jämngrått" ; -- jämngrå..av.1
  jämnhet_1_N = mkN "jämnhet" ; -- jämnhet..nn.1
  jämnhög_1_A = mkA "jämnhög" ; -- jämnhög..av.1
  jämnlång_1_A = mkA "jämnlång" ; -- jämnlång..av.1
  jämnmod_1_N = mkN "jämnmod" neutrum  ; -- jämnmod..nn.1
  jämnskuren_1_A = mkA "jämnskuren" ; -- jämnskuren..av.1
  jämnslipad_1_A = mkA "jämnslipad" ; -- jämnslipad..av.1
  jämnstark_1_A = mkA "jämnstark" ; -- jämnstark..av.1
  jämnstarkhet_1_N = mkN "jämnstarkhet" ; -- jämnstarkhet..nn.1
  jämnstor_1_A = mkA "jämnstor" ; -- jämnstor..av.1
  jämnstorhet_1_N = mkN "jämnstorhet" ; -- jämnstorhet..nn.1
  jämnstruken_1_A = mkA "jämnstruken" ; -- jämnstruken..av.1
  jämnstrukenhet_1_N = mkN "jämnstrukenhet" ; -- jämnstrukenhet..nn.1
  jämntjock_1_A = mkA "jämntjock" ; -- jämntjock..av.1
  jämntjockhet_1_N = mkN "jämntjockhet" ; -- jämntjockhet..nn.1
  jämnvarm_1_A = mkA "jämnvarm" ; -- jämnvarm..av.1
  jämnvarmhet_1_N = mkN "jämnvarmhet" ; -- jämnvarmhet..nn.1
  jämnvikt_1_N = mkN "jämnvikt" ; -- jämnvikt..nn.1
  jämnviktig_1_A = mkA "jämnviktig" ; -- jämnviktig..av.1
  jämnviktsläge_1_N = mkN "jämnviktsläge" ; -- jämnviktsläge..nn.1
  jämnviktsorgan_1_N = mkN "jämnviktsorgan" neutrum  ; -- jämnviktsorgan..nn.1
  jämnårig_1_A = mkA "jämnårig" ; -- jämnårig..av.1
  jämnårighet_1_N = mkN "jämnårighet" ; -- jämnårighet..nn.1
  jämrans_1_A = mkA "jämrans" ; -- jämrans..av.1
  jämsidig_1_A = mkA "jämsidig" ; -- jämsidig..av.1
  jämspelt_1_A = mkA "jämspelt" "jämspelt" ; -- jämspelt..av.1
  jämspelthet_1_N = mkN "jämspelthet" ; -- jämspelthet..nn.1
  jämstark_1_A = mkA "jämstark" ; -- jämstark..av.1
  jämstarkhet_1_N = mkN "jämstarkhet" ; -- jämstarkhet..nn.1
  jämstor_1_A = mkA "jämstor" ; -- jämstor..av.1
  jämstorhet_1_N = mkN "jämstorhet" ; -- jämstorhet..nn.1
  jämställa_1_V = mkV "jämställer" ; -- jämställa..vb.1
  jämställande_1_N = mkN "jämställande" ; -- jämställande..nn.1
  jämställd_1_A = mkA "jämställd" "jämställt" ; -- jämställd..av.1
  jämställdhet_1_N = mkN "jämställdhet" "jämställdheter" ; -- jämställdhet..nn.1
  jämställdhetsbonus_1_N = mkN "jämställdhetsbonus" ; -- jämställdhetsbonus..nn.1
  jämställdhetsdiskussion_1_N = mkN "jämställdhetsdiskussion" ; -- jämställdhetsdiskussion..nn.1
  jämställdhetsfråga_1_N = mkN "jämställdhetsfråga" ; -- jämställdhetsfråga..nn.1
  jämställdhetshänseende_1_N = mkN "jämställdhetshänseende" ; -- jämställdhetshänseende..nn.1
  jämställdhetsintegrerad_1_A = mkA "jämställdhetsintegrerad" ; -- jämställdhetsintegrerad..av.1
  jämställdhetspolitik_1_N = mkN "jämställdhetspolitik" ; -- jämställdhetspolitik..nn.1
  jämställdhetspolitisk_1_A = mkA "jämställdhetspolitisk" ; -- jämställdhetspolitisk..av.1
  jämställdhetsskilsmässa_1_N = mkN "jämställdhetsskilsmässa" ; -- jämställdhetsskilsmässa..nn.1
  jämt_1_Adv = mkAdv "jämt" ; -- jämt..ab.1
  jämte_1_N = mkN "jämte" utrum  ; -- jämte..nn.1
  jämthund_1_N = mkN "jämthund" ; -- jämthund..nn.1
  jämtjock_1_A = mkA "jämtjock" ; -- jämtjock..av.1
  jämtjockhet_1_N = mkN "jämtjockhet" ; -- jämtjockhet..nn.1
  jämtländsk_1_A = mkA "jämtländsk" ; -- jämtländsk..av.1
  jämtländska_1_N = mkN "jämtländska" ; -- jämtländska..nn.1
  jämtländska_2_N = mkN "jämtländska" ; -- jämtländska..nn.2
  jämtlänning_1_N = mkN "jämtlänning" ; -- jämtlänning..nn.1
  jämtsk_1_A = mkA "jämtsk" ; -- jämtsk..av.1
  jämtska_1_N = mkN "jämtska" ; -- jämtska..nn.1
  jämtska_2_N = mkN "jämtska" ; -- jämtska..nn.2
  jämtskhet_1_N = mkN "jämtskhet" ; -- jämtskhet..nn.1
  jämvikt_1_N = mkN "jämvikt" ; -- jämvikt..nn.1
  jämviktig_1_A = mkA "jämviktig" ; -- jämviktig..av.1
  jämviktsläge_1_N = mkN "jämviktsläge" ; -- jämviktsläge..nn.1
  jämviktsorgan_1_N = mkN "jämviktsorgan" neutrum  ; -- jämviktsorgan..nn.1
  jänkare_1_N = mkN "jänkare" utrum  ; -- jänkare..nn.1
  jänta_1_N = mkN "jänta" ; -- jänta..nn.1
  järn_1_N = mkN "järn" neutrum  ; -- järn..nn.1
  järnaffär_1_N = mkN "järnaffär" "järnaffärer" ; -- järnaffär..nn.1
  järnbakterie_1_N = mkN "järnbakterie" "järnbakterier" ; -- järnbakterie..nn.1
  järnbalk_1_N = mkN "järnbalk" ; -- järnbalk..nn.1
  järnbana_1_N = mkN "järnbana" ; -- järnbana..nn.1
  järnbeslag_1_N = mkN "järnbeslag" neutrum  ; -- järnbeslag..nn.1
  järnbetong_1_N = mkN "järnbetong" ; -- järnbetong..nn.1
  järnblad_1_N = mkN "järnblad" neutrum  ; -- järnblad..nn.1
  järnbrist_1_N = mkN "järnbrist" ; -- järnbrist..nn.1
  järnbruk_1_N = mkN "järnbruk" neutrum  ; -- järnbruk..nn.1
  järnbröllop_1_N = mkN "järnbröllop" neutrum  ; -- järnbröllop..nn.1
  järnbörd_1_N = mkN "järnbörd" ; -- järnbörd..nn.1
  järndörr_1_N = mkN "järndörr" ; -- järndörr..nn.1
  järnek_1_N = mkN "järnek" ; -- järnek..nn.1
  järnekkrans_1_N = mkN "järnekkrans" ; -- järnekkrans..nn.1
  järnframställning_1_N = mkN "järnframställning" ; -- järnframställning..nn.1
  järnframställningsplats_1_N = mkN "järnframställningsplats" "järnframställningsplatser" ; -- järnframställningsplats..nn.1
  järnfysik_1_N = mkN "järnfysik" ; -- järnfysik..nn.1
  järnföremål_1_N = mkN "järnföremål" neutrum  ; -- järnföremål..nn.1
  järnglans_1_N = mkN "järnglans" ; -- järnglans..nn.1
  järngrepp_1_N = mkN "järngrepp" neutrum  ; -- järngrepp..nn.1
  järngrind_1_N = mkN "järngrind" ; -- järngrind..nn.1
  järnhake_1_N = mkN "järnhake" utrum  ; -- järnhake..nn.1
  järnhaltig_1_A = mkA "järnhaltig" ; -- järnhaltig..av.1
  järnhand_1_N = mkN "järnhand" "järnhänder" ; -- järnhand..nn.1
  järnhandel_1_N = mkN "järnhandel" ; -- järnhandel..nn.1
  järnhantering_1_N = mkN "järnhantering" ; -- järnhantering..nn.1
  järnhäll_1_N = mkN "järnhäll" ; -- järnhäll..nn.1
  järnhälsa_1_N = mkN "järnhälsa" ; -- järnhälsa..nn.1
  järnhård_1_A = mkA "järnhård" "järnhårt" ; -- järnhård..av.1
  järnhårdhet_1_N = mkN "järnhårdhet" ; -- järnhårdhet..nn.1
  järnindustri_1_N = mkN "järnindustri" "järnindustrier" ; -- järnindustri..nn.1
  järnjungfru_1_N = mkN "järnjungfru" "järnjungfrun" "järnjungfrur" "järnjungfrurna" ; -- järnjungfru..nn.1
  järnkatastrof_1_N = mkN "järnkatastrof" "järnkatastrofer" ; -- järnkatastrof..nn.1
  järnkitt_1_N = mkN "järnkitt" neutrum  ; -- järnkitt..nn.1
  järnklump_1_N = mkN "järnklump" ; -- järnklump..nn.1
  järnkoll_1_N = mkN "järnkoll" ; -- järnkoll..nn.1
  järnkors_1_N = mkN "järnkors" neutrum  ; -- järnkors..nn.1
  järnkärna_1_N = mkN "järnkärna" ; -- järnkärna..nn.1
  järnlegering_1_N = mkN "järnlegering" ; -- järnlegering..nn.1
  järnlunga_1_N = mkN "järnlunga" ; -- järnlunga..nn.1
  järnmalm_1_N = mkN "järnmalm" "järnmalmer" ; -- järnmalm..nn.1
  järnmanufaktur_1_N = mkN "järnmanufaktur" "järnmanufakturer" ; -- järnmanufaktur..nn.1
  järnmetallurgi_1_N = mkN "järnmetallurgi" ; -- järnmetallurgi..nn.1
  järnnatt_1_N = mkN "järnnatt" "järnnätter" ; -- järnnatt..nn.1
  järnockra_1_N = mkN "järnockra" ; -- järnockra..nn.1
  järnoxid_1_N = mkN "järnoxid" "järnoxider" ; -- järnoxid..nn.1
  järnpinne_1_N = mkN "järnpinne" utrum  ; -- järnpinne..nn.1
  järnplåt_1_N = mkN "järnplåt" ; -- järnplåt..nn.1
  järnproduktion_1_N = mkN "järnproduktion" ; -- järnproduktion..nn.1
  järnpulver_1_N = mkN "järnpulver" neutrum  ; -- järnpulver..nn.1
  järnredskap_1_N = mkN "järnredskap" neutrum  ; -- järnredskap..nn.1
  järnridå_1_N = mkN "järnridå" "järnridåer" ; -- järnridå..nn.1
  järnrik_1_A = mkA "järnrik" ; -- järnrik..av.1
  järnrikhet_1_N = mkN "järnrikhet" ; -- järnrikhet..nn.1
  järnring_1_N = mkN "järnring" ; -- järnring..nn.1
  järnräcke_1_N = mkN "järnräcke" ; -- järnräcke..nn.1
  järnrör_1_N = mkN "järnrör" neutrum  ; -- järnrör..nn.1
  järnsalt_1_N = mkN "järnsalt" "järnsaltet" "järnsalter" "järnsalterna" ; -- järnsalt..nn.1
  järnsko_1_V = mkV "järnskor" ; -- järnsko..vb.1
  järnskoende_1_N = mkN "järnskoende" ; -- järnskoende..nn.1
  järnskrot_1_N = mkN "järnskrot" neutrum  ; -- järnskrot..nn.1
  järnsmälta_1_N = mkN "järnsmälta" ; -- järnsmälta..nn.1
  järnsparv_1_N = mkN "järnsparv" ; -- järnsparv..nn.1
  järnspat_1_N = mkN "järnspat" ; -- järnspat..nn.1
  järnspett_1_N = mkN "järnspett" neutrum  ; -- järnspett..nn.1
  järnspis_1_N = mkN "järnspis" ; -- järnspis..nn.1
  järnstag_1_N = mkN "järnstag" neutrum  ; -- järnstag..nn.1
  järnstaket_1_N = mkN "järnstaket" neutrum  ; -- järnstaket..nn.1
  järnstycke_1_N = mkN "järnstycke" ; -- järnstycke..nn.1
  järnstång_1_N = mkN "järnstång" "järnstänger" ; -- järnstång..nn.1
  järnsulfid_1_N = mkN "järnsulfid" "järnsulfider" ; -- järnsulfid..nn.1
  järnsvamp_1_N = mkN "järnsvamp" ; -- järnsvamp..nn.1
  järnsäng_1_N = mkN "järnsäng" ; -- järnsäng..nn.1
  järntacka_1_N = mkN "järntacka" ; -- järntacka..nn.1
  järntillverkning_1_N = mkN "järntillverkning" ; -- järntillverkning..nn.1
  järntråd_1_N = mkN "järntråd" ; -- järntråd..nn.1
  järnvapen_1_N = mkN "järnvapen" "järnvapnet" "järnvapen" "järnvapnen" ; -- järnvapen..nn.1
  järnvara_1_N = mkN "järnvara" ; -- järnvara..nn.1
  järnvaruaffär_1_N = mkN "järnvaruaffär" "järnvaruaffärer" ; -- järnvaruaffär..nn.1
  järnvaruhandel_1_N = mkN "järnvaruhandel" ; -- järnvaruhandel..nn.1
  järnverk_1_N = mkN "järnverk" neutrum  ; -- järnverk..nn.1
  järnvilja_1_N = mkN "järnvilja" ; -- järnvilja..nn.1
  järnvitriol_1_N = mkN "järnvitriol" ; -- järnvitriol..nn.1
  järnväg_1_N = mkN "järnväg" ; -- järnväg..nn.1
  järnvägare_1_N = mkN "järnvägare" utrum  ; -- järnvägare..nn.1
  järnvägsbiljett_1_N = mkN "järnvägsbiljett" "järnvägsbiljetter" ; -- järnvägsbiljett..nn.1
  järnvägsbro_1_N = mkN "järnvägsbro" ; -- järnvägsbro..nn.1
  järnvägsbygge_1_N = mkN "järnvägsbygge" ; -- järnvägsbygge..nn.1
  järnvägsinvestering_1_N = mkN "järnvägsinvestering" ; -- järnvägsinvestering..nn.1
  järnvägsknut_1_N = mkN "järnvägsknut" ; -- järnvägsknut..nn.1
  järnvägskorsning_1_N = mkN "järnvägskorsning" ; -- järnvägskorsning..nn.1
  järnvägslinje_1_N = mkN "järnvägslinje" "järnvägslinjer" ; -- järnvägslinje..nn.1
  järnvägsnät_1_N = mkN "järnvägsnät" neutrum  ; -- järnvägsnät..nn.1
  järnvägspolitik_1_N = mkN "järnvägspolitik" ; -- järnvägspolitik..nn.1
  järnvägsräls_1_N = mkN "järnvägsräls" ; -- järnvägsräls..nn.1
  järnvägssignal_1_N = mkN "järnvägssignal" "järnvägssignaler" ; -- järnvägssignal..nn.1
  järnvägsskena_1_N = mkN "järnvägsskena" ; -- järnvägsskena..nn.1
  järnvägsspår_1_N = mkN "järnvägsspår" neutrum  ; -- järnvägsspår..nn.1
  järnvägsstation_1_N = mkN "järnvägsstation" ; -- järnvägsstation..nn.1
  järnvägsstrejk_1_N = mkN "järnvägsstrejk" "järnvägsstrejker" ; -- järnvägsstrejk..nn.1
  järnvägsstängsel_1_N = mkN "järnvägsstängsel" neutrum  ; -- järnvägsstängsel..nn.1
  järnvägstjänsteman_1_N = mkN "järnvägstjänsteman" "järnvägstjänstemannen" "järnvägstjänstemän" "järnvägstjänstemännen" ; -- järnvägstjänsteman..nn.1
  järnvägstrafik_1_N = mkN "järnvägstrafik" ; -- järnvägstrafik..nn.1
  järnvägståg_1_N = mkN "järnvägståg" neutrum  ; -- järnvägståg..nn.1
  järnvägsvagn_1_N = mkN "järnvägsvagn" ; -- järnvägsvagn..nn.1
  järnvägsviadukt_1_N = mkN "järnvägsviadukt" "järnvägsviadukter" ; -- järnvägsviadukt..nn.1
  järnvägsövergång_1_N = mkN "järnvägsövergång" ; -- järnvägsövergång..nn.1
  järnyxa_1_N = mkN "järnyxa" ; -- järnyxa..nn.1
  järnålder_1_N = mkN "järnålder" ; -- järnålder..nn.1
  järnåldersbonde_1_N = mkN "järnåldersbonde" "järnåldersbönder" ; -- järnåldersbonde..nn.1
  järnåldersbygd_1_N = mkN "järnåldersbygd" "järnåldersbygder" ; -- järnåldersbygd..nn.1
  järnåldersfiskare_1_N = mkN "järnåldersfiskare" utrum  ; -- järnåldersfiskare..nn.1
  järnår_1_N = mkN "järnår" neutrum  ; -- järnår..nn.1
  järnört_1_N = mkN "järnört" "järnörter" ; -- järnört..nn.1
  järpe_1_N = mkN "järpe" utrum  ; -- järpe..nn.1
  järtecken_1_N = mkN "järtecken" "järtecknet" "järtecken" "järtecknen" ; -- järtecken..nn.1
  järv_1_N = mkN "järv" ; -- järv..nn.1
  järvunge_1_N = mkN "järvunge" utrum  ; -- järvunge..nn.1
  jäsa_1_V = mkV "jäser" ; -- jäsa..vb.1
  jäsande_1_N = mkN "jäsande" ; -- jäsande..nn.1
  jäsfoder_1_N = mkN "jäsfoder" neutrum  ; -- jäsfoder..nn.1
  jäsig_1_A = mkA "jäsig" ; -- jäsig..av.1
  jäsning_1_N = mkN "jäsning" ; -- jäsning..nn.1
  jäsningsprocess_1_N = mkN "jäsningsprocess" "jäsningsprocesser" ; -- jäsningsprocess..nn.1
  jäst_1_N = mkN "jäst" ; -- jäst..nn.1
  jästextrakt_1_N = mkN "jästextrakt" neutrum  ; -- jästextrakt..nn.1
  jästgrums_1_N = mkN "jästgrums" neutrum  ; -- jästgrums..nn.1
  jästsvamp_1_N = mkN "jästsvamp" ; -- jästsvamp..nn.1
  jätte_1_N = mkN "jätte" utrum  ; -- jätte..nn.1
  jättearg_1_A = mkA "jättearg" ; -- jättearg..av.1
  jätteavtal_1_N = mkN "jätteavtal" neutrum  ; -- jätteavtal..nn.1
  jättebeslag_1_N = mkN "jättebeslag" neutrum  ; -- jättebeslag..nn.1
  jättebra_1_A = mkA "jättebra" ; -- jättebra..av.1
  jättebubbla_1_N = mkN "jättebubbla" ; -- jättebubbla..nn.1
  jätteduktig_1_A = mkA "jätteduktig" ; -- jätteduktig..av.1
  jättedum_1_A = mkA "jättedum" "jättedumt" "jättedumma" "jättedumma" "jättedummare" "jättedummast" "jättedummaste" ; -- jättedum..av.1
  jättedumhet_1_N = mkN "jättedumhet" ; -- jättedumhet..nn.1
  jättedyr_1_A = mkA "jättedyr" ; -- jättedyr..av.1
  jättedålig_1_A = mkA "jättedålig" ; -- jättedålig..av.1
  jätteexperiment_1_N = mkN "jätteexperiment" neutrum  ; -- jätteexperiment..nn.1
  jättefiasko_1_N = mkN "jättefiasko" "jättefiaskot" "jättefiaskon" "jättefiaskona" ; -- jättefiasko..nn.1
  jättefin_1_A = mkA "jättefin" ; -- jättefin..av.1
  jätteflopp_1_N = mkN "jätteflopp" ; -- jätteflopp..nn.1
  jätteföretag_1_N = mkN "jätteföretag" neutrum  ; -- jätteföretag..nn.1
  jätteförvånad_1_A = mkA "jätteförvånad" ; -- jätteförvånad..av.1
  jättegalt_1_N = mkN "jättegalt" ; -- jättegalt..nn.1
  jätteglad_1_A = mkA "jätteglad" "jätteglatt" ; -- jätteglad..av.1
  jättegod_1_A = mkA "jättegod" "jättegott" ; -- jättegod..av.1
  jättegryta_1_N = mkN "jättegryta" ; -- jättegryta..nn.1
  jättegärna_1_Adv = mkAdv "jättegärna" ; -- jättegärna..ab.1
  jättehäftig_1_A = mkA "jättehäftig" ; -- jättehäftig..av.1
  jättehål_1_N = mkN "jättehål" neutrum  ; -- jättehål..nn.1
  jätteintressant_1_A = mkA "jätteintressant" "jätteintressant" ; -- jätteintressant..av.1
  jätteintresserad_1_A = mkA "jätteintresserad" ; -- jätteintresserad..av.1
  jätteisberg_1_N = mkN "jätteisberg" neutrum  ; -- jätteisberg..nn.1
  jättejobbig_1_A = mkA "jättejobbig" ; -- jättejobbig..av.1
  jättekast_1_N = mkN "jättekast" neutrum  ; -- jättekast..nn.1
  jättekliv_1_N = mkN "jättekliv" neutrum  ; -- jättekliv..nn.1
  jätteklot_1_N = mkN "jätteklot" neutrum  ; -- jätteklot..nn.1
  jättekonstig_1_A = mkA "jättekonstig" ; -- jättekonstig..av.1
  jättekul_1_A = mkA "jättekul" ; -- jättekul..av.1
  jättekvinna_1_N = mkN "jättekvinna" ; -- jättekvinna..nn.1
  jättekär_1_A = mkA "jättekär" ; -- jättekär..av.1
  jättelarvig_1_A = mkA "jättelarvig" ; -- jättelarvig..av.1
  jätteledsen_1_A = mkA "jätteledsen" ; -- jätteledsen..av.1
  jättelik_1_A = mkA "jättelik" ; -- jättelik..av.1
  jättelyckad_1_A = mkA "jättelyckad" ; -- jättelyckad..av.1
  jättelycklig_1_A = mkA "jättelycklig" ; -- jättelycklig..av.1
  jättelänge_1_Adv = mkAdv "jättelänge" ; -- jättelänge..ab.1
  jättelång_1_A = mkA "jättelång" ; -- jättelång..av.1
  jättemisstag_1_N = mkN "jättemisstag" neutrum  ; -- jättemisstag..nn.1
  jättemoln_1_N = mkN "jättemoln" neutrum  ; -- jättemoln..nn.1
  jättemycket_1_Adv = mkAdv "jättemycket" ; -- jättemycket..ab.1
  jättenervös_1_A = mkA "jättenervös" ; -- jättenervös..av.1
  jättenära_1_Adv = mkAdv "jättenära" ; -- jättenära..ab.1
  jättenöjd_1_A = mkA "jättenöjd" "jättenöjt" ; -- jättenöjd..av.1
  jätteofta_1_Adv = mkAdv "jätteofta" ; -- jätteofta..ab.1
  jätteorm_1_N = mkN "jätteorm" ; -- jätteorm..nn.1
  jätteplask_1_N = mkN "jätteplask" neutrum  ; -- jätteplask..nn.1
  jätterolig_1_A = mkA "jätterolig" ; -- jätterolig..av.1
  jätteryck_1_N = mkN "jätteryck" ; -- jätteryck..nn.1
  jätteräd_1_N = mkN "jätteräd" "jätteräder" ; -- jätteräd..nn.1
  jätterädd_1_A = mkA "jätterädd" ; -- jätterädd..av.1
  jätteschyst_1_A = mkA "jätteschyst" "jätteschyst" ; -- jätteschyst..av.1
  jätteskoj_1_N = mkN "jätteskoj" neutrum  ; -- jätteskoj..nn.1
  jätteskojig_1_A = mkA "jätteskojig" ; -- jätteskojig..av.1
  jätteskräll_1_N = mkN "jätteskräll" ; -- jätteskräll..nn.1
  jätteskön_1_A = mkA "jätteskön" ; -- jätteskön..av.1
  jätteslagsmål_1_N = mkN "jätteslagsmål" neutrum  ; -- jätteslagsmål..nn.1
  jättesnygg_1_A = mkA "jättesnygg" ; -- jättesnygg..av.1
  jättesnygghet_1_N = mkN "jättesnygghet" ; -- jättesnygghet..nn.1
  jättesnäll_1_A = mkA "jättesnäll" ; -- jättesnäll..av.1
  jättesnällhet_1_N = mkN "jättesnällhet" ; -- jättesnällhet..nn.1
  jättesockerbit_1_N = mkN "jättesockerbit" ; -- jättesockerbit..nn.1
  jättespindel_1_N = mkN "jättespindel" ; -- jättespindel..nn.1
  jättespännande_1_A = mkA "jättespännande" ; -- jättespännande..av.1
  jättesteg_1_N = mkN "jättesteg" neutrum  ; -- jättesteg..nn.1
  jättestjärna_1_N = mkN "jättestjärna" ; -- jättestjärna..nn.1
  jättestolt_1_A = mkA "jättestolt" "jättestolt" ; -- jättestolt..av.1
  jättestor_1_A = mkA "jättestor" ; -- jättestor..av.1
  jättestorhet_1_N = mkN "jättestorhet" ; -- jättestorhet..nn.1
  jättestressad_1_A = mkA "jättestressad" ; -- jättestressad..av.1
  jättesugen_1_A = mkA "jättesugen" ; -- jättesugen..av.1
  jättesvår_1_A = mkA "jättesvår" ; -- jättesvår..av.1
  jättesällan_1_Adv = mkAdv "jättesällan" ; -- jättesällan..ab.1
  jättesöt_1_A = mkA "jättesöt" ; -- jättesöt..av.1
  jättetaggad_1_A = mkA "jättetaggad" ; -- jättetaggad..av.1
  jättetrevlig_1_A = mkA "jättetrevlig" ; -- jättetrevlig..av.1
  jättetråkig_1_A = mkA "jättetråkig" ; -- jättetråkig..av.1
  jättetrött_1_A = mkA "jättetrött" ; -- jättetrött..av.1
  jättetydlig_1_A = mkA "jättetydlig" ; -- jättetydlig..av.1
  jättetyfon_1_N = mkN "jättetyfon" "jättetyfoner" ; -- jättetyfon..nn.1
  jätteval_1_N = mkN "jätteval" ; -- jätteval..nn.1
  jätteviktig_1_A = mkA "jätteviktig" ; -- jätteviktig..av.1
  jätteväxt_1_N = mkN "jätteväxt" ; -- jätteväxt..nn.1
  jätteödla_1_N = mkN "jätteödla" ; -- jätteödla..nn.1
  jättinna_1_N = mkN "jättinna" ; -- jättinna..nn.1
  jäv_1_N = mkN "jäv" neutrum  ; -- jäv..nn.1
  jäva_1_V = mkV "jävar" ; -- jäva..vb.1
  jävande_1_N = mkN "jävande" ; -- jävande..nn.1
  jävel_1_N = mkN "jävel" ; -- jävel..nn.1
  jävelsk_1_A = mkA "jävelsk" ; -- jävelsk..av.1
  jävelskap_1_N = mkN "jävelskap" neutrum  ; -- jävelskap..nn.1
  jävelstyg_1_N = mkN "jävelstyg" neutrum  ; -- jävelstyg..nn.1
  jävig_1_A = mkA "jävig" ; -- jävig..av.1
  jävighet_1_N = mkN "jävighet" ; -- jävighet..nn.1
  jävla_1_A = mkA "jävla" ; -- jävla..av.1
  jävlig_1_A = mkA "jävlig" ; -- jävlig..av.1
  jävlighet_1_N = mkN "jävlighet" "jävligheter" ; -- jävlighet..nn.1
  jävligt_1_Adv = mkAdv "jävligt" ; -- jävligt..ab.1
  jävsfråga_1_N = mkN "jävsfråga" ; -- jävsfråga..nn.1
  jävulsk_1_A = mkA "jävulsk" ; -- jävulsk..av.1
  jävulskap_1_N = mkN "jävulskap" neutrum  ; -- jävulskap..nn.1
  jävulstyg_1_N = mkN "jävulstyg" neutrum  ; -- jävulstyg..nn.1
  jåkk_1_N = mkN "jåkk" ; -- jåkk..nn.1
  jökel_1_N = mkN "jökel" ; -- jökel..nn.1
  jökelis_1_N = mkN "jökelis" ; -- jökelis..nn.1
  jökelport_1_N = mkN "jökelport" ; -- jökelport..nn.1
  jökelälv_1_N = mkN "jökelälv" ; -- jökelälv..nn.1
  jöns_1_N = mkN "jöns" ; -- jöns..nn.1
  jönsande_1_N = mkN "jönsande" ; -- jönsande..nn.1
  jönseri_1_N = mkN "jönseri" "jönseriet" "jönserier" "jönserierna" ; -- jönseri..nn.1
  jönsig_1_A = mkA "jönsig" ; -- jönsig..av.1
  jönsighet_1_N = mkN "jönsighet" ; -- jönsighet..nn.1
  jösse_1_N = mkN "jösse" utrum  ; -- jösse..nn.1
  k_märka_1_V = mkV "k-märker" ; -- k-märka..vb.1
  k_märkande_1_N = mkN "k-märkande" ; -- k-märkande..nn.1
  k_pist_1_N = mkN "k-pist" ; -- k-pist..nn.1
  kabal_1_N = mkN "kabal" "kabaler" ; -- kabal..nn.1
  kabaret_1_N = mkN "kabaret" "kabareter" ; -- kabaret..nn.1
  kabaretföreställning_1_N = mkN "kabaretföreställning" ; -- kabaretföreställning..nn.1
  kabaretorkester_1_N = mkN "kabaretorkester" ; -- kabaretorkester..nn.1
  kabaretsångare_1_N = mkN "kabaretsångare" utrum  ; -- kabaretsångare..nn.1
  kabaré_1_N = mkN "kabaré" "kabaréer" ; -- kabaré..nn.1
  kabaréföreställning_1_N = mkN "kabaréföreställning" ; -- kabaréföreställning..nn.1
  kabaréorkester_1_N = mkN "kabaréorkester" ; -- kabaréorkester..nn.1
  kabarésångare_1_N = mkN "kabarésångare" utrum  ; -- kabarésångare..nn.1
  kabbala_1_N = mkN "kabbala" ; -- kabbala..nn.1
  kabbalism_1_N = mkN "kabbalism" "kabbalismer" ; -- kabbalism..nn.1
  kabbalist_1_N = mkN "kabbalist" "kabbalister" ; -- kabbalist..nn.1
  kabbalistisk_1_A = mkA "kabbalistisk" ; -- kabbalistisk..av.1
  kabbeleka_1_N = mkN "kabbeleka" ; -- kabbeleka..nn.1
  kabbleka_1_N = mkN "kabbleka" ; -- kabbleka..nn.1
  kabel_teve_1_N = mkN "kabel-teve" ; -- kabel-teve..nn.1
  kabel_1_N = mkN "kabel" ; -- kabel..nn.1
  kabelbro_1_N = mkN "kabelbro" ; -- kabelbro..nn.1
  kabelbrunn_1_N = mkN "kabelbrunn" ; -- kabelbrunn..nn.1
  kabelfäste_1_N = mkN "kabelfäste" ; -- kabelfäste..nn.1
  kabelgatt_1_N = mkN "kabelgatt" neutrum  ; -- kabelgatt..nn.1
  kabelgenomföring_1_N = mkN "kabelgenomföring" ; -- kabelgenomföring..nn.1
  kabelhölje_1_N = mkN "kabelhölje" ; -- kabelhölje..nn.1
  kabeljo_1_N = mkN "kabeljo" ; -- kabeljo..nn.1
  kabellängd_1_N = mkN "kabellängd" "kabellängder" ; -- kabellängd..nn.1
  kabelsko_1_N = mkN "kabelsko" "kabelskor" ; -- kabelsko..nn.1
  kabelskotång_1_N = mkN "kabelskotång" "kabelskotänger" ; -- kabelskotång..nn.1
  kabelskåp_1_N = mkN "kabelskåp" neutrum  ; -- kabelskåp..nn.1
  kabelslagen_1_A = mkA "kabelslagen" ; -- kabelslagen..av.1
  kabelteve_1_N = mkN "kabelteve" ; -- kabelteve..nn.1
  kabelvinda_1_N = mkN "kabelvinda" ; -- kabelvinda..nn.1
  kabin_1_N = mkN "kabin" "kabiner" ; -- kabin..nn.1
  kabinanställd_1_A = mkA "kabinanställd" "kabinanställt" ; -- kabinanställd..av.1
  kabinbåt_1_N = mkN "kabinbåt" ; -- kabinbåt..nn.1
  kabinett_1_N = mkN "kabinett" neutrum  ; -- kabinett..nn.1
  kabinettsformat_1_N = mkN "kabinettsformat" neutrum  ; -- kabinettsformat..nn.1
  kabinettsfråga_1_N = mkN "kabinettsfråga" ; -- kabinettsfråga..nn.1
  kabinettskort_1_N = mkN "kabinettskort" neutrum  ; -- kabinettskort..nn.1
  kabinettsorder_1_N = mkN "kabinettsorder" ; -- kabinettsorder..nn.1
  kabinettspass_1_N = mkN "kabinettspass" neutrum  ; -- kabinettspass..nn.1
  kabinettspolitik_1_N = mkN "kabinettspolitik" ; -- kabinettspolitik..nn.1
  kabinettssekreterare_1_N = mkN "kabinettssekreterare" utrum  ; -- kabinettssekreterare..nn.1
  kabinpersonal_1_N = mkN "kabinpersonal" ; -- kabinpersonal..nn.1
  kabintryck_1_N = mkN "kabintryck" neutrum  ; -- kabintryck..nn.1
  kabinväska_1_N = mkN "kabinväska" ; -- kabinväska..nn.1
  kabla_1_V = mkV "kablar" ; -- kabla..vb.1
  kablande_1_N = mkN "kablande" ; -- kablande..nn.1
  kabyl_1_N = mkN "kabyl" "kabyler" ; -- kabyl..nn.1
  kabylisk_1_A = mkA "kabylisk" ; -- kabylisk..av.1
  kabyss_1_N = mkN "kabyss" "kabysser" ; -- kabyss..nn.1
  kacka_1_V = mkV "kackar" ; -- kacka..vb.1
  kackalorum_1_N = mkN "kackalorum" neutrum  ; -- kackalorum..nn.1
  kackande_1_N = mkN "kackande" ; -- kackande..nn.1
  kackel_1_N = mkN "kackel" neutrum  ; -- kackel..nn.1
  kackerlacka_1_N = mkN "kackerlacka" ; -- kackerlacka..nn.1
  kackla_1_V = mkV "kacklar" ; -- kackla..vb.1
  kacklande_1_N = mkN "kacklande" ; -- kacklande..nn.1
  kackling_1_N = mkN "kackling" ; -- kackling..nn.1
  kadaver_1_N = mkN "kadaver" neutrum  ; -- kadaver..nn.1
  kadaverdisciplin_1_N = mkN "kadaverdisciplin" ; -- kadaverdisciplin..nn.1
  kadaverlukt_1_N = mkN "kadaverlukt" ; -- kadaverlukt..nn.1
  kadaverlydnad_1_N = mkN "kadaverlydnad" "kadaverlydnader" ; -- kadaverlydnad..nn.1
  kadens_1_N = mkN "kadens" "kadenser" ; -- kadens..nn.1
  kader_1_N = mkN "kader" ; -- kader..nn.1
  kadersystem_1_N = mkN "kadersystem" neutrum  ; -- kadersystem..nn.1
  kaderövning_1_N = mkN "kaderövning" ; -- kaderövning..nn.1
  kadett_1_N = mkN "kadett" "kadetter" ; -- kadett..nn.1
  kadettfartyg_1_N = mkN "kadettfartyg" neutrum  ; -- kadettfartyg..nn.1
  kadettkår_1_N = mkN "kadettkår" "kadettkårer" ; -- kadettkår..nn.1
  kadettskola_1_N = mkN "kadettskola" ; -- kadettskola..nn.1
  kadettyg_1_N = mkN "kadettyg" neutrum  ; -- kadettyg..nn.1
  kadi_1_N = mkN "kadi" "kadin" "kadier" "kadierna" ; -- kadi..nn.1
  kadmium_1_N = mkN "kadmium" neutrum  ; -- kadmium..nn.1
  kadmiumgul_1_A = mkA "kadmiumgul" ; -- kadmiumgul..av.1
  kadmiumgult_1_N = mkN "kadmiumgult" ; -- kadmiumgult..nn.1
  kadmiumjon_1_N = mkN "kadmiumjon" "kadmiumjoner" ; -- kadmiumjon..nn.1
  kadmiumrött_1_N = mkN "kadmiumrött" ; -- kadmiumrött..nn.1
  kadrilj_1_N = mkN "kadrilj" "kadriljer" ; -- kadrilj..nn.1
  kafe_1_N = mkN "kafe" "kafeet" "kafeer" "kafeerna" ; -- kafe..nn.1
  kafeteria_1_N = mkN "kafeteria" ; -- kafeteria..nn.1
  kaffe_1_N = mkN "kaffe" ; -- kaffe..nn.1
  kaffe_2_N = mkN "kaffe" "kaffe" ; -- kaffe..nn.2
  kaffeautomat_1_N = mkN "kaffeautomat" "kaffeautomater" ; -- kaffeautomat..nn.1
  kaffebal_1_N = mkN "kaffebal" ; -- kaffebal..nn.1
  kaffebar_1_N = mkN "kaffebar" "kaffebarer" ; -- kaffebar..nn.1
  kaffebjudning_1_N = mkN "kaffebjudning" ; -- kaffebjudning..nn.1
  kaffebord_1_N = mkN "kaffebord" neutrum  ; -- kaffebord..nn.1
  kaffebricka_1_N = mkN "kaffebricka" ; -- kaffebricka..nn.1
  kaffebrun_1_A = mkA "kaffebrun" ; -- kaffebrun..av.1
  kaffebryggare_1_N = mkN "kaffebryggare" utrum  ; -- kaffebryggare..nn.1
  kaffebröd_1_N = mkN "kaffebröd" neutrum  ; -- kaffebröd..nn.1
  kaffebuske_1_N = mkN "kaffebuske" utrum  ; -- kaffebuske..nn.1
  kaffeböna_1_N = mkN "kaffeböna" ; -- kaffeböna..nn.1
  kaffedags_1_N = mkN "kaffedags" ; -- kaffedags..nn.1
  kaffedopp_1_N = mkN "kaffedopp" neutrum  ; -- kaffedopp..nn.1
  kaffedrickande_1_N = mkN "kaffedrickande" ; -- kaffedrickande..nn.1
  kaffeduk_1_N = mkN "kaffeduk" ; -- kaffeduk..nn.1
  kaffeersättning_1_N = mkN "kaffeersättning" ; -- kaffeersättning..nn.1
  kaffefat_1_N = mkN "kaffefat" neutrum  ; -- kaffefat..nn.1
  kaffefilter_1_N = mkN "kaffefilter" neutrum  ; -- kaffefilter..nn.1
  kaffefläck_1_N = mkN "kaffefläck" ; -- kaffefläck..nn.1
  kaffegrädde_1_N = mkN "kaffegrädde" utrum  ; -- kaffegrädde..nn.1
  kaffegök_1_N = mkN "kaffegök" ; -- kaffegök..nn.1
  kaffehalva_1_N = mkN "kaffehalva" ; -- kaffehalva..nn.1
  kaffehurra_1_N = mkN "kaffehurra" ; -- kaffehurra..nn.1
  kaffehus_1_N = mkN "kaffehus" neutrum  ; -- kaffehus..nn.1
  kaffekalas_1_N = mkN "kaffekalas" neutrum  ; -- kaffekalas..nn.1
  kaffekanna_1_N = mkN "kaffekanna" ; -- kaffekanna..nn.1
  kaffekask_1_N = mkN "kaffekask" ; -- kaffekask..nn.1
  kaffekittel_1_N = mkN "kaffekittel" ; -- kaffekittel..nn.1
  kaffekokare_1_N = mkN "kaffekokare" utrum  ; -- kaffekokare..nn.1
  kaffekokning_1_N = mkN "kaffekokning" ; -- kaffekokning..nn.1
  kaffekopp_1_N = mkN "kaffekopp" ; -- kaffekopp..nn.1
  kaffekvarn_1_N = mkN "kaffekvarn" ; -- kaffekvarn..nn.1
  kaffemoster_1_N = mkN "kaffemoster" ; -- kaffemoster..nn.1
  kaffepanna_1_N = mkN "kaffepanna" ; -- kaffepanna..nn.1
  kaffepetter_1_N = mkN "kaffepetter" ; -- kaffepetter..nn.1
  kaffepulver_1_N = mkN "kaffepulver" neutrum  ; -- kaffepulver..nn.1
  kaffer_1_N = mkN "kaffer" "kaffern" "kaffrer" "kaffrerna" ; -- kaffer..nn.1
  kafferast_1_N = mkN "kafferast" "kafferaster" ; -- kafferast..nn.1
  kafferastämne_1_N = mkN "kafferastämne" ; -- kafferastämne..nn.1
  kafferbuffel_1_N = mkN "kafferbuffel" ; -- kafferbuffel..nn.1
  kafferep_1_N = mkN "kafferep" neutrum  ; -- kafferep..nn.1
  kafferkorn_1_N = mkN "kafferkorn" neutrum  ; -- kafferkorn..nn.1
  kafferosteri_1_N = mkN "kafferosteri" "kafferosteriet" "kafferosterier" "kafferosterierna" ; -- kafferosteri..nn.1
  kafferspjut_1_N = mkN "kafferspjut" neutrum  ; -- kafferspjut..nn.1
  kafferspråk_1_N = mkN "kafferspråk" neutrum  ; -- kafferspråk..nn.1
  kaffeservering_1_N = mkN "kaffeservering" ; -- kaffeservering..nn.1
  kaffesked_1_N = mkN "kaffesked" ; -- kaffesked..nn.1
  kaffestånd_1_N = mkN "kaffestånd" neutrum  ; -- kaffestånd..nn.1
  kaffesugen_1_A = mkA "kaffesugen" ; -- kaffesugen..av.1
  kaffesugenhet_1_N = mkN "kaffesugenhet" ; -- kaffesugenhet..nn.1
  kaffesump_1_N = mkN "kaffesump" ; -- kaffesump..nn.1
  kaffetant_1_N = mkN "kaffetant" "kaffetanter" ; -- kaffetant..nn.1
  kaffeträd_1_N = mkN "kaffeträd" neutrum  ; -- kaffeträd..nn.1
  kaffetår_1_N = mkN "kaffetår" ; -- kaffetår..nn.1
  kaffeved_1_N = mkN "kaffeved" ; -- kaffeved..nn.1
  kafkaartad_1_A = mkA "kafkaartad" ; -- kafkaartad..av.1
  kafkaesk_1_A = mkA "kafkaesk" ; -- kafkaesk..av.1
  kafkalik_1_A = mkA "kafkalik" ; -- kafkalik..av.1
  kafkastämning_1_N = mkN "kafkastämning" ; -- kafkastämning..nn.1
  kaftan_1_N = mkN "kaftan" "kaftaner" ; -- kaftan..nn.1
  kafé_1_N = mkN "kafé" "kaféet" "kaféer" "kaféerna" ; -- kafé..nn.1
  kafébord_1_N = mkN "kafébord" neutrum  ; -- kafébord..nn.1
  kaférörelse_1_N = mkN "kaférörelse" "kaférörelser" ; -- kaférörelse..nn.1
  kafévagn_1_N = mkN "kafévagn" ; -- kafévagn..nn.1
  kafévärd_1_N = mkN "kafévärd" ; -- kafévärd..nn.1
  kagge_1_N = mkN "kagge" utrum  ; -- kagge..nn.1
  kainsmärke_1_N = mkN "kainsmärke" ; -- kainsmärke..nn.1
  kairotal_1_N = mkN "kairotal" neutrum  ; -- kairotal..nn.1
  kaj_1_N = mkN "kaj" "kajer" ; -- kaj..nn.1
  kaja_1_N = mkN "kaja" ; -- kaja..nn.1
  kajak_1_N = mkN "kajak" "kajaker" ; -- kajak..nn.1
  kajakpaddling_1_N = mkN "kajakpaddling" ; -- kajakpaddling..nn.1
  kajal_1_N = mkN "kajal" "kajaler" ; -- kajal..nn.1
  kajalpenna_1_N = mkN "kajalpenna" ; -- kajalpenna..nn.1
  kajavgift_1_N = mkN "kajavgift" "kajavgifter" ; -- kajavgift..nn.1
  kajdjup_1_N = mkN "kajdjup" neutrum  ; -- kajdjup..nn.1
  kajka_1_V = mkV "kajkar" ; -- kajka..vb.1
  kajkande_1_N = mkN "kajkande" ; -- kajkande..nn.1
  kajman_1_N = mkN "kajman" "kajmaner" ; -- kajman..nn.1
  kajplats_1_N = mkN "kajplats" "kajplatser" ; -- kajplats..nn.1
  kajskoning_1_N = mkN "kajskoning" ; -- kajskoning..nn.1
  kajsvärm_1_N = mkN "kajsvärm" ; -- kajsvärm..nn.1
  kajuta_1_N = mkN "kajuta" ; -- kajuta..nn.1
  kajutdäck_1_N = mkN "kajutdäck" neutrum  ; -- kajutdäck..nn.1
  kajutpost_1_N = mkN "kajutpost" "kajutposter" ; -- kajutpost..nn.1
  kaka_1_N = mkN "kaka" ; -- kaka..nn.1
  kakadua_1_N = mkN "kakadua" ; -- kakadua..nn.1
  kakafoni_1_N = mkN "kakafoni" "kakafonier" ; -- kakafoni..nn.1
  kakafonisk_1_A = mkA "kakafonisk" ; -- kakafonisk..av.1
  kakao_1_N = mkN "kakao" ; -- kakao..nn.1
  kakaoböna_1_N = mkN "kakaoböna" ; -- kakaoböna..nn.1
  kakaofett_1_N = mkN "kakaofett" neutrum  ; -- kakaofett..nn.1
  kakaolikör_1_N = mkN "kakaolikör" "kakaolikörer" ; -- kakaolikör..nn.1
  kakaopulver_1_N = mkN "kakaopulver" neutrum  ; -- kakaopulver..nn.1
  kakaosmör_1_N = mkN "kakaosmör" neutrum  ; -- kakaosmör..nn.1
  kakaoträd_1_N = mkN "kakaoträd" neutrum  ; -- kakaoträd..nn.1
  kakbak_1_N = mkN "kakbak" neutrum  ; -- kakbak..nn.1
  kakburk_1_N = mkN "kakburk" ; -- kakburk..nn.1
  kakdoppande_1_A = mkA "kakdoppande" ; -- kakdoppande..av.1
  kakdoppande_1_N = mkN "kakdoppande" ; -- kakdoppande..nn.1
  kakel_1_N = mkN "kakel" neutrum  ; -- kakel..nn.1
  kakelfix_1_N = mkN "kakelfix" neutrum  ; -- kakelfix..nn.1
  kakelmaskin_1_N = mkN "kakelmaskin" "kakelmaskiner" ; -- kakelmaskin..nn.1
  kakelplatta_1_N = mkN "kakelplatta" ; -- kakelplatta..nn.1
  kakelskärare_1_N = mkN "kakelskärare" utrum  ; -- kakelskärare..nn.1
  kakelugn_1_N = mkN "kakelugn" ; -- kakelugn..nn.1
  kakelugnseldning_1_N = mkN "kakelugnseldning" ; -- kakelugnseldning..nn.1
  kakelugnslucka_1_N = mkN "kakelugnslucka" ; -- kakelugnslucka..nn.1
  kakelugnsmakare_1_N = mkN "kakelugnsmakare" utrum  ; -- kakelugnsmakare..nn.1
  kakelugnsnisch_1_N = mkN "kakelugnsnisch" "kakelugnsnischer" ; -- kakelugnsnisch..nn.1
  kakelugnssättare_1_N = mkN "kakelugnssättare" utrum  ; -- kakelugnssättare..nn.1
  kakelugnsventil_1_N = mkN "kakelugnsventil" "kakelugnsventiler" ; -- kakelugnsventil..nn.1
  kakelverktyg_1_N = mkN "kakelverktyg" neutrum  ; -- kakelverktyg..nn.1
  kakfat_1_N = mkN "kakfat" neutrum  ; -- kakfat..nn.1
  kakform_1_N = mkN "kakform" ; -- kakform..nn.1
  kakifärgad_1_A = mkA "kakifärgad" ; -- kakifärgad..av.1
  kakiuniform_1_N = mkN "kakiuniform" "kakiuniformer" ; -- kakiuniform..nn.1
  kakla_1_V = mkV "kaklar" ; -- kakla..vb.1
  kaklande_1_N = mkN "kaklande" ; -- kaklande..nn.1
  kakmix_1_N = mkN "kakmix" ; -- kakmix..nn.1
  kakmått_1_N = mkN "kakmått" neutrum  ; -- kakmått..nn.1
  kakofoni_1_N = mkN "kakofoni" "kakofonier" ; -- kakofoni..nn.1
  kakofonisk_1_A = mkA "kakofonisk" ; -- kakofonisk..av.1
  kaksmet_1_N = mkN "kaksmet" "kaksmeter" ; -- kaksmet..nn.1
  kaktus_1_N = mkN "kaktus" ; -- kaktus..nn.1
  kaktusfikon_1_N = mkN "kaktusfikon" neutrum  ; -- kaktusfikon..nn.1
  kaktång_1_N = mkN "kaktång" "kaktänger" ; -- kaktång..nn.1
  kakté_1_N = mkN "kakté" "kaktéer" ; -- kakté..nn.1
  kakuminal_1_A = mkA "kakuminal" ; -- kakuminal..av.1
  kakuminal_1_N = mkN "kakuminal" "kakuminaler" ; -- kakuminal..nn.1
  kal_1_A = mkA "kal" ; -- kal..av.1
  kalabalik_1_N = mkN "kalabalik" "kalabaliker" ; -- kalabalik..nn.1
  kalabass_1_N = mkN "kalabass" "kalabasser" ; -- kalabass..nn.1
  kalabasspumpa_1_N = mkN "kalabasspumpa" ; -- kalabasspumpa..nn.1
  kalamitet_1_N = mkN "kalamitet" "kalamiteter" ; -- kalamitet..nn.1
  kalander_1_N = mkN "kalander" ; -- kalander..nn.1
  kalandrera_1_V = mkV "kalandrerar" ; -- kalandrera..vb.1
  kalandrerande_1_N = mkN "kalandrerande" ; -- kalandrerande..nn.1
  kalandrerbar_1_A = mkA "kalandrerbar" ; -- kalandrerbar..av.1
  kalandrerbarhet_1_N = mkN "kalandrerbarhet" ; -- kalandrerbarhet..nn.1
  kalandrering_1_N = mkN "kalandrering" ; -- kalandrering..nn.1
  kalas_1_N = mkN "kalas" neutrum  ; -- kalas..nn.1
  kalasa_1_V = mkV "kalasar" ; -- kalasa..vb.1
  kalasande_1_N = mkN "kalasande" ; -- kalasande..nn.1
  kalasbra_1_Adv = mkAdv "kalasbra" ; -- kalasbra..ab.1
  kalasbra_1_A = mkA "kalasbra" ; -- kalasbra..av.1
  kalasbyxa_1_N = mkN "kalasbyxa" ; -- kalasbyxa..nn.1
  kalaskula_1_N = mkN "kalaskula" ; -- kalaskula..nn.1
  kalasmat_1_N = mkN "kalasmat" ; -- kalasmat..nn.1
  kalaspingla_1_N = mkN "kalaspingla" ; -- kalaspingla..nn.1
  kalavverka_1_V = mkV "kalavverkar" ; -- kalavverka..vb.1
  kalavverkande_1_N = mkN "kalavverkande" ; -- kalavverkande..nn.1
  kalcedon_1_N = mkN "kalcedon" "kalcedoner" ; -- kalcedon..nn.1
  kalcinera_1_V = mkV "kalcinerar" ; -- kalcinera..vb.1
  kalcinerande_1_N = mkN "kalcinerande" ; -- kalcinerande..nn.1
  kalcinerbar_1_A = mkA "kalcinerbar" ; -- kalcinerbar..av.1
  kalcinerbarhet_1_N = mkN "kalcinerbarhet" ; -- kalcinerbarhet..nn.1
  kalcinering_1_N = mkN "kalcinering" ; -- kalcinering..nn.1
  kalcium_1_N = mkN "kalcium" neutrum  ; -- kalcium..nn.1
  kalciumfosfat_1_N = mkN "kalciumfosfat" neutrum  ; -- kalciumfosfat..nn.1
  kalciumhydroxid_1_N = mkN "kalciumhydroxid" "kalciumhydroxider" ; -- kalciumhydroxid..nn.1
  kalciumkarbonat_1_N = mkN "kalciumkarbonat" neutrum  ; -- kalciumkarbonat..nn.1
  kalciumklorid_1_N = mkN "kalciumklorid" ; -- kalciumklorid..nn.1
  kalciumoxid_1_N = mkN "kalciumoxid" "kalciumoxider" ; -- kalciumoxid..nn.1
  kalciumsilikat_1_N = mkN "kalciumsilikat" "kalciumsilikater" ; -- kalciumsilikat..nn.1
  kalciumsulfat_1_N = mkN "kalciumsulfat" ; -- kalciumsulfat..nn.1
  kaldera_1_N = mkN "kaldera" ; -- kaldera..nn.1
  kaldé_1_N = mkN "kaldé" "kaldéer" ; -- kaldé..nn.1
  kalebass_1_N = mkN "kalebass" "kalebasser" ; -- kalebass..nn.1
  kalebasspumpa_1_N = mkN "kalebasspumpa" ; -- kalebasspumpa..nn.1
  kaledonisk_1_A = mkA "kaledonisk" ; -- kaledonisk..av.1
  kaleidoskop_1_N = mkN "kaleidoskop" neutrum  ; -- kaleidoskop..nn.1
  kaleidoskopbild_1_N = mkN "kaleidoskopbild" "kaleidoskopbilder" ; -- kaleidoskopbild..nn.1
  kaleidoskopisk_1_A = mkA "kaleidoskopisk" ; -- kaleidoskopisk..av.1
  kalejdoskop_1_N = mkN "kalejdoskop" neutrum  ; -- kalejdoskop..nn.1
  kalejdoskopbild_1_N = mkN "kalejdoskopbild" "kalejdoskopbilder" ; -- kalejdoskopbild..nn.1
  kalejdoskopisk_1_A = mkA "kalejdoskopisk" ; -- kalejdoskopisk..av.1
  kalendarisk_1_A = mkA "kalendarisk" ; -- kalendarisk..av.1
  kalendarium_1_N = mkN "kalendarium" "kalendariet" "kalendarier" "kalendarierna" ; -- kalendarium..nn.1
  kalender_1_N = mkN "kalender" ; -- kalender..nn.1
  kalenderbitare_1_N = mkN "kalenderbitare" utrum  ; -- kalenderbitare..nn.1
  kalenderbiteri_1_N = mkN "kalenderbiteri" "kalenderbiteriet" "kalenderbiterier" "kalenderbiterierna" ; -- kalenderbiteri..nn.1
  kalenderdygn_1_N = mkN "kalenderdygn" neutrum  ; -- kalenderdygn..nn.1
  kalenderfotografering_1_N = mkN "kalenderfotografering" ; -- kalenderfotografering..nn.1
  kalendermånad_1_N = mkN "kalendermånad" "kalendermånader" ; -- kalendermånad..nn.1
  kalenderstav_1_N = mkN "kalenderstav" ; -- kalenderstav..nn.1
  kalendervecka_1_N = mkN "kalendervecka" ; -- kalendervecka..nn.1
  kalenderår_1_N = mkN "kalenderår" neutrum  ; -- kalenderår..nn.1
  kalesch_1_N = mkN "kalesch" "kalescher" ; -- kalesch..nn.1
  kalfaktor_1_N = mkN "kalfaktor" "kalfaktorer" ; -- kalfaktor..nn.1
  kalfatra_1_V = mkV "kalfatrar" ; -- kalfatra..vb.1
  kalfatrande_1_N = mkN "kalfatrande" ; -- kalfatrande..nn.1
  kalfatring_1_N = mkN "kalfatring" ; -- kalfatring..nn.1
  kalfjäll_1_N = mkN "kalfjäll" neutrum  ; -- kalfjäll..nn.1
  kalhet_1_N = mkN "kalhet" ; -- kalhet..nn.1
  kalhugga_1_V = mkV "kalhugga" "kalhögg" "kalhuggit" ; -- kalhugga..vb.1
  kalhuggande_1_N = mkN "kalhuggande" ; -- kalhuggande..nn.1
  kalhuggning_1_N = mkN "kalhuggning" ; -- kalhuggning..nn.1
  kalhygge_1_N = mkN "kalhygge" ; -- kalhygge..nn.1
  kalhyggesbruk_1_N = mkN "kalhyggesbruk" neutrum  ; -- kalhyggesbruk..nn.1
  kaliber_1_N = mkN "kaliber" ; -- kaliber..nn.1
  kaliberborr_1_N = mkN "kaliberborr" ; -- kaliberborr..nn.1
  kalibertolk_1_N = mkN "kalibertolk" ; -- kalibertolk..nn.1
  kalibrera_1_V = mkV "kalibrerar" ; -- kalibrera..vb.1
  kalibrerande_1_N = mkN "kalibrerande" ; -- kalibrerande..nn.1
  kalibrerbar_1_A = mkA "kalibrerbar" ; -- kalibrerbar..av.1
  kalibrerbarhet_1_N = mkN "kalibrerbarhet" ; -- kalibrerbarhet..nn.1
  kalibrering_1_N = mkN "kalibrering" ; -- kalibrering..nn.1
  kalibreringsknapp_1_N = mkN "kalibreringsknapp" ; -- kalibreringsknapp..nn.1
  kalif_1_N = mkN "kalif" "kalifer" ; -- kalif..nn.1
  kalifat_1_N = mkN "kalifat" neutrum  ; -- kalifat..nn.1
  kalifornisk_1_A = mkA "kalifornisk" ; -- kalifornisk..av.1
  kaliforniskhet_1_N = mkN "kaliforniskhet" ; -- kaliforniskhet..nn.1
  kalihunger_1_N = mkN "kalihunger" ; -- kalihunger..nn.1
  kalikå_1_N = mkN "kalikå" ; -- kalikå..nn.1
  kalilut_1_N = mkN "kalilut" ; -- kalilut..nn.1
  kalisalpeter_1_N = mkN "kalisalpeter" ; -- kalisalpeter..nn.1
  kalisalt_1_N = mkN "kalisalt" "kalisaltet" "kalisalter" "kalisalterna" ; -- kalisalt..nn.1
  kalium_1_N = mkN "kalium" neutrum  ; -- kalium..nn.1
  kaliumhydroxid_1_N = mkN "kaliumhydroxid" "kaliumhydroxider" ; -- kaliumhydroxid..nn.1
  kaliumjon_1_N = mkN "kaliumjon" "kaliumjoner" ; -- kaliumjon..nn.1
  kaliumkarbonat_1_N = mkN "kaliumkarbonat" neutrum  ; -- kaliumkarbonat..nn.1
  kaliumklorid_1_N = mkN "kaliumklorid" ; -- kaliumklorid..nn.1
  kaliumnitrat_1_N = mkN "kaliumnitrat" neutrum  ; -- kaliumnitrat..nn.1
  kaliumpermanganat_1_N = mkN "kaliumpermanganat" neutrum  ; -- kaliumpermanganat..nn.1
  kaliumsulfat_1_N = mkN "kaliumsulfat" ; -- kaliumsulfat..nn.1
  kalk_1_N = mkN "kalk" "kalker" ; -- kalk..nn.1
  kalk_2_N = mkN "kalk" ; -- kalk..nn.2
  kalka_1_V = mkV "kalkar" ; -- kalka..vb.1
  kalkad_1_A = mkA "kalkad" ; -- kalkad..av.1
  kalkalg_1_N = mkN "kalkalg" "kalkalger" ; -- kalkalg..nn.1
  kalkande_1_N = mkN "kalkande" ; -- kalkande..nn.1
  kalkanhopning_1_N = mkN "kalkanhopning" ; -- kalkanhopning..nn.1
  kalkbrott_1_N = mkN "kalkbrott" neutrum  ; -- kalkbrott..nn.1
  kalkbruk_1_N = mkN "kalkbruk" neutrum  ; -- kalkbruk..nn.1
  kalkbränneri_1_N = mkN "kalkbränneri" "kalkbränneriet" "kalkbrännerier" "kalkbrännerierna" ; -- kalkbränneri..nn.1
  kalkera_1_V = mkV "kalkerar" ; -- kalkera..vb.1
  kalkerande_1_N = mkN "kalkerande" ; -- kalkerande..nn.1
  kalkerbar_1_A = mkA "kalkerbar" ; -- kalkerbar..av.1
  kalkerbarhet_1_N = mkN "kalkerbarhet" ; -- kalkerbarhet..nn.1
  kalkering_1_N = mkN "kalkering" ; -- kalkering..nn.1
  kalkerlärft_1_N = mkN "kalkerlärft" ; -- kalkerlärft..nn.1
  kalkerpapper_1_N = mkN "kalkerpapper" neutrum  ; -- kalkerpapper..nn.1
  kalkfattig_1_A = mkA "kalkfattig" ; -- kalkfattig..av.1
  kalkfattighet_1_N = mkN "kalkfattighet" ; -- kalkfattighet..nn.1
  kalkformation_1_N = mkN "kalkformation" ; -- kalkformation..nn.1
  kalkfärg_1_N = mkN "kalkfärg" "kalkfärger" ; -- kalkfärg..nn.1
  kalkgrund_1_N = mkN "kalkgrund" "kalkgrunder" ; -- kalkgrund..nn.1
  kalkgrå_1_A = mkA "kalkgrå" "kalkgrått" ; -- kalkgrå..av.1
  kalkhalt_1_N = mkN "kalkhalt" "kalkhalter" ; -- kalkhalt..nn.1
  kalkhaltig_1_A = mkA "kalkhaltig" ; -- kalkhaltig..av.1
  kalkjon_1_N = mkN "kalkjon" "kalkjoner" ; -- kalkjon..nn.1
  kalkkväve_1_N = mkN "kalkkväve" ; -- kalkkväve..nn.1
  kalkliknande_1_A = mkA "kalkliknande" ; -- kalkliknande..av.1
  kalklippt_1_A = mkA "kalklippt" "kalklippt" ; -- kalklippt..av.1
  kalkljus_1_N = mkN "kalkljus" neutrum  ; -- kalkljus..nn.1
  kalkmjöl_1_N = mkN "kalkmjöl" neutrum  ; -- kalkmjöl..nn.1
  kalkmjölk_1_N = mkN "kalkmjölk" ; -- kalkmjölk..nn.1
  kalkmålning_1_N = mkN "kalkmålning" ; -- kalkmålning..nn.1
  kalkomani_1_N = mkN "kalkomani" "kalkomanier" ; -- kalkomani..nn.1
  kalkon_1_N = mkN "kalkon" "kalkoner" ; -- kalkon..nn.1
  kalkonkött_1_N = mkN "kalkonkött" neutrum  ; -- kalkonkött..nn.1
  kalkonmässig_1_A = mkA "kalkonmässig" ; -- kalkonmässig..av.1
  kalkonrulle_1_N = mkN "kalkonrulle" utrum  ; -- kalkonrulle..nn.1
  kalkonsmörgås_1_N = mkN "kalkonsmörgås" ; -- kalkonsmörgås..nn.1
  kalkputs_1_N = mkN "kalkputs" ; -- kalkputs..nn.1
  kalkrest_1_N = mkN "kalkrest" "kalkrester" ; -- kalkrest..nn.1
  kalkrik_1_A = mkA "kalkrik" ; -- kalkrik..av.1
  kalkrikhet_1_N = mkN "kalkrikhet" ; -- kalkrikhet..nn.1
  kalksediment_1_N = mkN "kalksediment" neutrum  ; -- kalksediment..nn.1
  kalkskal_1_N = mkN "kalkskal" neutrum  ; -- kalkskal..nn.1
  kalkslå_1_V = mkV "kalkslå" "kalkslog" "kalkslagit" ; -- kalkslå..vb.1
  kalkslående_1_N = mkN "kalkslående" ; -- kalkslående..nn.1
  kalkspat_1_N = mkN "kalkspat" ; -- kalkspat..nn.1
  kalkstenshäll_1_N = mkN "kalkstenshäll" ; -- kalkstenshäll..nn.1
  kalkstenskåk_1_N = mkN "kalkstenskåk" ; -- kalkstenskåk..nn.1
  kalkstensplatta_1_N = mkN "kalkstensplatta" ; -- kalkstensplatta..nn.1
  kalkstensvägg_1_N = mkN "kalkstensvägg" ; -- kalkstensvägg..nn.1
  kalkströ_1_N = mkN "kalkströ" neutrum  ; -- kalkströ..nn.1
  kalktuff_1_N = mkN "kalktuff" "kalktuffer" ; -- kalktuff..nn.1
  kalkugn_1_N = mkN "kalkugn" ; -- kalkugn..nn.1
  kalkvattenbeständig_1_A = mkA "kalkvattenbeständig" ; -- kalkvattenbeständig..av.1
  kalkvit_1_A = mkA "kalkvit" ; -- kalkvit..av.1
  kalkyl_1_N = mkN "kalkyl" "kalkyler" ; -- kalkyl..nn.1
  kalkylark_1_N = mkN "kalkylark" neutrum  ; -- kalkylark..nn.1
  kalkylator_1_N = mkN "kalkylator" "kalkylatorer" ; -- kalkylator..nn.1
  kalkylera_1_V = mkV "kalkylerar" ; -- kalkylera..vb.1
  kalkylerande_1_N = mkN "kalkylerande" ; -- kalkylerande..nn.1
  kalkylerbar_1_A = mkA "kalkylerbar" ; -- kalkylerbar..av.1
  kalkylerbarhet_1_N = mkN "kalkylerbarhet" ; -- kalkylerbarhet..nn.1
  kalkylering_1_N = mkN "kalkylering" ; -- kalkylering..nn.1
  kalkylmässig_1_A = mkA "kalkylmässig" ; -- kalkylmässig..av.1
  kall_1_A = mkA "kall" ; -- kall..av.1
  kall_1_N = mkN "kall" neutrum  ; -- kall..nn.1
  kalla_1_N = mkN "kalla" ; -- kalla..nn.1
  kalla_1_V = mkV "kallar" ; -- kalla..vb.1
  kallande_1_N = mkN "kallande" ; -- kallande..nn.1
  kallarbeta_1_V = mkV "kallarbetar" ; -- kallarbeta..vb.1
  kallarbetande_1_N = mkN "kallarbetande" ; -- kallarbetande..nn.1
  kallavfettning_1_N = mkN "kallavfettning" ; -- kallavfettning..nn.1
  kallbad_1_N = mkN "kallbad" neutrum  ; -- kallbad..nn.1
  kallbadhus_1_N = mkN "kallbadhus" neutrum  ; -- kallbadhus..nn.1
  kallbearbeta_1_V = mkV "kallbearbetar" ; -- kallbearbeta..vb.1
  kallbearbetande_1_N = mkN "kallbearbetande" ; -- kallbearbetande..nn.1
  kallblod_1_N = mkN "kallblod" neutrum  ; -- kallblod..nn.1
  kallblodig_1_A = mkA "kallblodig" ; -- kallblodig..av.1
  kallblodighet_1_N = mkN "kallblodighet" "kallblodigheter" ; -- kallblodighet..nn.1
  kallbocka_1_V = mkV "kallbockar" ; -- kallbocka..vb.1
  kallbockande_1_N = mkN "kallbockande" ; -- kallbockande..nn.1
  kallbrand_1_N = mkN "kallbrand" ; -- kallbrand..nn.1
  kallbräcka_1_N = mkN "kallbräcka" ; -- kallbräcka..nn.1
  kallbänk_1_N = mkN "kallbänk" ; -- kallbänk..nn.1
  kalldra_1_V = mkV "kalldraga" "kalldrog" "kalldragit" ; -- kalldra..vb.1
  kalldragande_1_N = mkN "kalldragande" ; -- kalldragande..nn.1
  kalldusch_1_N = mkN "kalldusch" ; -- kalldusch..nn.1
  kallelse_1_N = mkN "kallelse" "kallelser" ; -- kallelse..nn.1
  kallelsebeslut_1_N = mkN "kallelsebeslut" neutrum  ; -- kallelsebeslut..nn.1
  kallelsebrev_1_N = mkN "kallelsebrev" neutrum  ; -- kallelsebrev..nn.1
  kallelseförslag_1_N = mkN "kallelseförslag" neutrum  ; -- kallelseförslag..nn.1
  kallelsegärning_1_N = mkN "kallelsegärning" ; -- kallelsegärning..nn.1
  kallelselista_1_N = mkN "kallelselista" ; -- kallelselista..nn.1
  kallelserätt_1_N = mkN "kallelserätt" ; -- kallelserätt..nn.1
  kallelsetid_1_N = mkN "kallelsetid" "kallelsetider" ; -- kallelsetid..nn.1
  kallflytande_1_A = mkA "kallflytande" ; -- kallflytande..av.1
  kallfront_1_N = mkN "kallfront" "kallfronter" ; -- kallfront..nn.1
  kallgarage_1_N = mkN "kallgarage" "kallgaraget" "kallgarage" "kallgaragen" ; -- kallgarage..nn.1
  kallgrin_1_N = mkN "kallgrin" neutrum  ; -- kallgrin..nn.1
  kallgrina_1_V = mkV "kallgrinar" ; -- kallgrina..vb.1
  kallgrinande_1_N = mkN "kallgrinande" ; -- kallgrinande..nn.1
  kallhamra_1_V = mkV "kallhamrar" ; -- kallhamra..vb.1
  kallhamrad_1_A = mkA "kallhamrad" ; -- kallhamrad..av.1
  kallhamrande_1_N = mkN "kallhamrande" ; -- kallhamrande..nn.1
  kallhus_1_N = mkN "kallhus" neutrum  ; -- kallhus..nn.1
  kallhyra_1_N = mkN "kallhyra" ; -- kallhyra..nn.1
  kalligraf_1_N = mkN "kalligraf" "kalligrafer" ; -- kalligraf..nn.1
  kalligrafi_1_N = mkN "kalligrafi" ; -- kalligrafi..nn.1
  kalligrafisk_1_A = mkA "kalligrafisk" ; -- kalligrafisk..av.1
  kalling_1_N = mkN "kalling" ; -- kalling..nn.1
  kalljord_1_N = mkN "kalljord" ; -- kalljord..nn.1
  kallkälla_1_N = mkN "kallkälla" ; -- kallkälla..nn.1
  kallkällare_1_N = mkN "kallkällare" utrum  ; -- kallkällare..nn.1
  kallmangel_1_N = mkN "kallmangel" ; -- kallmangel..nn.1
  kallmangla_1_V = mkV "kallmanglar" ; -- kallmangla..vb.1
  kallmanglande_1_N = mkN "kallmanglande" ; -- kallmanglande..nn.1
  kallmur_1_N = mkN "kallmur" ; -- kallmur..nn.1
  kallna_1_V = mkV "kallnar" ; -- kallna..vb.1
  kallnande_1_N = mkN "kallnande" ; -- kallnande..nn.1
  kallnål_1_N = mkN "kallnål" ; -- kallnål..nn.1
  kallortstillägg_1_N = mkN "kallortstillägg" neutrum  ; -- kallortstillägg..nn.1
  kallpermanent_1_N = mkN "kallpermanent" ; -- kallpermanent..nn.1
  kallprat_1_N = mkN "kallprat" neutrum  ; -- kallprat..nn.1
  kallprata_1_V = mkV "kallpratar" ; -- kallprata..vb.1
  kallpratande_1_N = mkN "kallpratande" ; -- kallpratande..nn.1
  kallpressa_1_V = mkV "kallpressar" ; -- kallpressa..vb.1
  kallpressande_1_N = mkN "kallpressande" ; -- kallpressande..nn.1
  kallpunkt_1_N = mkN "kallpunkt" "kallpunkter" ; -- kallpunkt..nn.1
  kallras_1_N = mkN "kallras" neutrum  ; -- kallras..nn.1
  kallröka_1_V = mkV "kallröker" ; -- kallröka..vb.1
  kallrökande_1_N = mkN "kallrökande" ; -- kallrökande..nn.1
  kallröra_1_V = mkV "kallröra" "kallrörde" "kallrört" ; -- kallröra..vb.1
  kallrörande_1_N = mkN "kallrörande" ; -- kallrörande..nn.1
  kallsinne_1_N = mkN "kallsinne" ; -- kallsinne..nn.1
  kallsinnig_1_A = mkA "kallsinnig" ; -- kallsinnig..av.1
  kallsinnighet_1_N = mkN "kallsinnighet" ; -- kallsinnighet..nn.1
  kallskuren_1_A = mkA "kallskuren" ; -- kallskuren..av.1
  kallskuret_1_N = mkN "kallskuret" ; -- kallskuret..nn.1
  kallskänk_1_N = mkN "kallskänk" ; -- kallskänk..nn.1
  kallskänka_1_N = mkN "kallskänka" ; -- kallskänka..nn.1
  kallskål_1_N = mkN "kallskål" ; -- kallskål..nn.1
  kallsmida_1_V = mkV "kallsmida" "kallsmidde" "kallsmitt" ; -- kallsmida..vb.1
  kallsmidande_1_N = mkN "kallsmidande" ; -- kallsmidande..nn.1
  kallstart_1_N = mkN "kallstart" "kallstarter" ; -- kallstart..nn.1
  kallstarta_1_V = mkV "kallstartar" ; -- kallstarta..vb.1
  kallsup_1_N = mkN "kallsup" ; -- kallsup..nn.1
  kallsvett_1_N = mkN "kallsvett" ; -- kallsvett..nn.1
  kallsvettig_1_A = mkA "kallsvettig" ; -- kallsvettig..av.1
  kallsåg_1_N = mkN "kallsåg" ; -- kallsåg..nn.1
  kalluft_1_N = mkN "kalluft" ; -- kalluft..nn.1
  kalluftsfläkt_1_N = mkN "kalluftsfläkt" ; -- kalluftsfläkt..nn.1
  kalluftsläge_1_N = mkN "kalluftsläge" ; -- kalluftsläge..nn.1
  kallvalsa_1_V = mkV "kallvalsar" ; -- kallvalsa..vb.1
  kallvalsande_1_N = mkN "kallvalsande" ; -- kallvalsande..nn.1
  kallvatten_1_N = mkN "kallvatten" "kallvattnet" "kallvatten" "kallvattnen" ; -- kallvatten..nn.1
  kallvattenräka_1_N = mkN "kallvattenräka" ; -- kallvattenräka..nn.1
  kallvåt_1_A = mkA "kallvåt" ; -- kallvåt..av.1
  kalmarbo_1_N = mkN "kalmarbo" "kalmarbor" ; -- kalmarbo..nn.1
  kalmark_1_N = mkN "kalmark" "kalmarker" ; -- kalmark..nn.1
  kalmera_1_V = mkV "kalmerar" ; -- kalmera..vb.1
  kalmerande_1_N = mkN "kalmerande" ; -- kalmerande..nn.1
  kalmerbar_1_A = mkA "kalmerbar" ; -- kalmerbar..av.1
  kalmerbarhet_1_N = mkN "kalmerbarhet" ; -- kalmerbarhet..nn.1
  kalmering_1_N = mkN "kalmering" ; -- kalmering..nn.1
  kalmuck_1_N = mkN "kalmuck" "kalmucker" ; -- kalmuck..nn.1
  kalmuckisk_1_A = mkA "kalmuckisk" ; -- kalmuckisk..av.1
  kalmus_1_N = mkN "kalmus" ; -- kalmus..nn.1
  kalna_1_V = mkV "kalnar" ; -- kalna..vb.1
  kalnande_1_N = mkN "kalnande" ; -- kalnande..nn.1
  kalops_1_N = mkN "kalops" ; -- kalops..nn.1
  kalori_1_N = mkN "kalori" "kalorier" ; -- kalori..nn.1
  kaloribehov_1_N = mkN "kaloribehov" neutrum  ; -- kaloribehov..nn.1
  kaloribomb_1_N = mkN "kaloribomb" "kaloribomber" ; -- kaloribomb..nn.1
  kalorifattig_1_A = mkA "kalorifattig" ; -- kalorifattig..av.1
  kalorifattighet_1_N = mkN "kalorifattighet" ; -- kalorifattighet..nn.1
  kaloriintag_1_N = mkN "kaloriintag" neutrum  ; -- kaloriintag..nn.1
  kalorijakt_1_N = mkN "kalorijakt" "kalorijakter" ; -- kalorijakt..nn.1
  kalorimeter_1_N = mkN "kalorimeter" ; -- kalorimeter..nn.1
  kaloririk_1_A = mkA "kaloririk" ; -- kaloririk..av.1
  kaloririkhet_1_N = mkN "kaloririkhet" ; -- kaloririkhet..nn.1
  kaloritabell_1_N = mkN "kaloritabell" "kaloritabeller" ; -- kaloritabell..nn.1
  kalorivärde_1_N = mkN "kalorivärde" ; -- kalorivärde..nn.1
  kalott_1_N = mkN "kalott" "kalotter" ; -- kalott..nn.1
  kalspolad_1_A = mkA "kalspolad" ; -- kalspolad..av.1
  kalstammig_1_A = mkA "kalstammig" ; -- kalstammig..av.1
  kalufs_1_N = mkN "kalufs" "kalufser" ; -- kalufs..nn.1
  kaluv_1_N = mkN "kaluv" ; -- kaluv..nn.1
  kalv_1_N = mkN "kalv" ; -- kalv..nn.1
  kalva_1_V = mkV "kalvar" ; -- kalva..vb.1
  kalvande_1_N = mkN "kalvande" ; -- kalvande..nn.1
  kalvbräss_1_N = mkN "kalvbräss" ; -- kalvbräss..nn.1
  kalvbräss_2_N = mkN "kalvbräss" ; -- kalvbräss..nn.2
  kalvdans_1_N = mkN "kalvdans" ; -- kalvdans..nn.1
  kalvfrikassé_1_N = mkN "kalvfrikassé" "kalvfrikasséer" ; -- kalvfrikassé..nn.1
  kalvfärdig_1_A = mkA "kalvfärdig" ; -- kalvfärdig..av.1
  kalvhage_1_N = mkN "kalvhage" utrum  ; -- kalvhage..nn.1
  kalvill_1_N = mkN "kalvill" "kalviller" ; -- kalvill..nn.1
  kalvinism_1_N = mkN "kalvinism" "kalvinismer" ; -- kalvinism..nn.1
  kalvinist_1_N = mkN "kalvinist" "kalvinister" ; -- kalvinist..nn.1
  kalvinistisk_1_A = mkA "kalvinistisk" ; -- kalvinistisk..av.1
  kalvinsk_1_A = mkA "kalvinsk" ; -- kalvinsk..av.1
  kalvjärpe_1_N = mkN "kalvjärpe" utrum  ; -- kalvjärpe..nn.1
  kalvko_1_N = mkN "kalvko" "kalvkor" ; -- kalvko..nn.1
  kalvkyckling_1_N = mkN "kalvkyckling" ; -- kalvkyckling..nn.1
  kalvkyl_1_N = mkN "kalvkyl" ; -- kalvkyl..nn.1
  kalvkätte_1_N = mkN "kalvkätte" utrum  ; -- kalvkätte..nn.1
  kalvkött_1_N = mkN "kalvkött" neutrum  ; -- kalvkött..nn.1
  kalvlägg_1_N = mkN "kalvlägg" ; -- kalvlägg..nn.1
  kalvläggsgryta_1_N = mkN "kalvläggsgryta" ; -- kalvläggsgryta..nn.1
  kalvning_1_N = mkN "kalvning" ; -- kalvning..nn.1
  kalvningsfeber_1_N = mkN "kalvningsfeber" ; -- kalvningsfeber..nn.1
  kalvningstid_1_N = mkN "kalvningstid" "kalvningstider" ; -- kalvningstid..nn.1
  kalvnjure_1_N = mkN "kalvnjure" utrum  ; -- kalvnjure..nn.1
  kalvost_1_N = mkN "kalvost" ; -- kalvost..nn.1
  kalvrulad_1_N = mkN "kalvrulad" "kalvrulader" ; -- kalvrulad..nn.1
  kalvrullad_1_N = mkN "kalvrullad" "kalvrullader" ; -- kalvrullad..nn.1
  kalvskinn_1_N = mkN "kalvskinn" neutrum  ; -- kalvskinn..nn.1
  kalvskinnsband_1_N = mkN "kalvskinnsband" neutrum  ; -- kalvskinnsband..nn.1
  kalvstek_1_N = mkN "kalvstek" ; -- kalvstek..nn.1
  kalvställning_1_N = mkN "kalvställning" ; -- kalvställning..nn.1
  kalvsylta_1_N = mkN "kalvsylta" ; -- kalvsylta..nn.1
  kaläta_1_V = mkV "kaläta" "kalåt" "kalätit" ; -- kaläta..vb.1
  kalätande_1_N = mkN "kalätande" ; -- kalätande..nn.1
  kam_1_N = mkN "kam" "kammen" "kammar" "kammarna" ; -- kam..nn.1
  kamaraderi_1_N = mkN "kamaraderi" neutrum  ; -- kamaraderi..nn.1
  kamarilla_1_N = mkN "kamarilla" ; -- kamarilla..nn.1
  kamaxel_1_N = mkN "kamaxel" ; -- kamaxel..nn.1
  kambodjan_1_N = mkN "kambodjan" "kambodjaner" ; -- kambodjan..nn.1
  kambodjansk_1_A = mkA "kambodjansk" ; -- kambodjansk..av.1
  kambodjanska_1_N = mkN "kambodjanska" ; -- kambodjanska..nn.1
  kambrik_1_N = mkN "kambrik" ; -- kambrik..nn.1
  kambrisk_1_A = mkA "kambrisk" ; -- kambrisk..av.1
  kambrium_1_N = mkN "kambrium" ; -- kambrium..nn.1
  kambrosilur_1_N = mkN "kambrosilur" ; -- kambrosilur..nn.1
  kamel_1_N = mkN "kamel" "kameler" ; -- kamel..nn.1
  kameldjur_1_N = mkN "kameldjur" neutrum  ; -- kameldjur..nn.1
  kameleont_1_N = mkN "kameleont" "kameleonter" ; -- kameleont..nn.1
  kameleontartad_1_A = mkA "kameleontartad" ; -- kameleontartad..av.1
  kameleontisk_1_A = mkA "kameleontisk" ; -- kameleontisk..av.1
  kameleontiskhet_1_N = mkN "kameleontiskhet" ; -- kameleontiskhet..nn.1
  kamelforskare_1_N = mkN "kamelforskare" utrum  ; -- kamelforskare..nn.1
  kamelforskning_1_N = mkN "kamelforskning" ; -- kamelforskning..nn.1
  kamelforskningsprojekt_1_N = mkN "kamelforskningsprojekt" neutrum  ; -- kamelforskningsprojekt..nn.1
  kamelgarn_1_N = mkN "kamelgarn" neutrum  ; -- kamelgarn..nn.1
  kamelherde_1_N = mkN "kamelherde" utrum  ; -- kamelherde..nn.1
  kamelhjord_1_N = mkN "kamelhjord" ; -- kamelhjord..nn.1
  kamelhår_1_N = mkN "kamelhår" neutrum  ; -- kamelhår..nn.1
  kamelhårsfärgad_1_A = mkA "kamelhårsfärgad" ; -- kamelhårsfärgad..av.1
  kamelia_1_N = mkN "kamelia" ; -- kamelia..nn.1
  kamelklocka_1_N = mkN "kamelklocka" ; -- kamelklocka..nn.1
  kamelmedicin_1_N = mkN "kamelmedicin" "kamelmediciner" ; -- kamelmedicin..nn.1
  kamelmjölk_1_N = mkN "kamelmjölk" ; -- kamelmjölk..nn.1
  kamelopard_1_N = mkN "kamelopard" "kameloparder" ; -- kamelopard..nn.1
  kamelpoesi_1_N = mkN "kamelpoesi" "kamelpoesier" ; -- kamelpoesi..nn.1
  kamelritt_1_N = mkN "kamelritt" "kamelritter" ; -- kamelritt..nn.1
  kamelsadel_1_N = mkN "kamelsadel" ; -- kamelsadel..nn.1
  kamelskötsel_1_N = mkN "kamelskötsel" ; -- kamelskötsel..nn.1
  kamelsäck_1_N = mkN "kamelsäck" ; -- kamelsäck..nn.1
  kameltå_1_N = mkN "kameltå" "kameltån" "kameltår" "kameltårna" ; -- kameltå..nn.1
  kamelull_1_N = mkN "kamelull" ; -- kamelull..nn.1
  kamera_1_N = mkN "kamera" ; -- kamera..nn.1
  kamerajakt_1_N = mkN "kamerajakt" "kamerajakter" ; -- kamerajakt..nn.1
  kameral_1_A = mkA "kameral" ; -- kameral..av.1
  kameraman_1_N = mkN "kameraman" "kameramannen" "kameramän" "kameramännen" ; -- kameraman..nn.1
  kameraobjektiv_1_N = mkN "kameraobjektiv" neutrum  ; -- kameraobjektiv..nn.1
  kamerastativ_1_N = mkN "kamerastativ" neutrum  ; -- kamerastativ..nn.1
  kameravinkel_1_N = mkN "kameravinkel" ; -- kameravinkel..nn.1
  kameraövervaka_1_V = mkV "kameraövervakar" ; -- kameraövervaka..vb.1
  kameraövervakande_1_N = mkN "kameraövervakande" ; -- kameraövervakande..nn.1
  kameraövervakning_1_N = mkN "kameraövervakning" ; -- kameraövervakning..nn.1
  kamerunare_1_N = mkN "kamerunare" utrum  ; -- kamerunare..nn.1
  kamerunsk_1_A = mkA "kamerunsk" ; -- kamerunsk..av.1
  kamerunska_1_N = mkN "kamerunska" ; -- kamerunska..nn.1
  kamfer_1_N = mkN "kamfer" ; -- kamfer..nn.1
  kamferdoftande_1_A = mkA "kamferdoftande" ; -- kamferdoftande..av.1
  kamferliniment_1_N = mkN "kamferliniment" neutrum  ; -- kamferliniment..nn.1
  kamgarn_1_N = mkN "kamgarn" neutrum  ; -- kamgarn..nn.1
  kamikazeuppdrag_1_N = mkN "kamikazeuppdrag" neutrum  ; -- kamikazeuppdrag..nn.1
  kamin_1_N = mkN "kamin" "kaminer" ; -- kamin..nn.1
  kamkofta_1_N = mkN "kamkofta" ; -- kamkofta..nn.1
  kamlott_1_N = mkN "kamlott" ; -- kamlott..nn.1
  kamma_1_V = mkV "kammar" ; -- kamma..vb.1
  kammande_1_N = mkN "kammande" ; -- kammande..nn.1
  kammanet_1_N = mkN "kammanet" "kammaneter" ; -- kammanet..nn.1
  kammarammunition_1_N = mkN "kammarammunition" ; -- kammarammunition..nn.1
  kammardressyr_1_N = mkN "kammardressyr" "kammardressyrer" ; -- kammardressyr..nn.1
  kammarduk_1_N = mkN "kammarduk" ; -- kammarduk..nn.1
  kammare_1_N = mkN "kammare" "kammaren" "kammare" "kamrarna" ; -- kammare..nn.1
  kammarfru_1_N = mkN "kammarfru" ; -- kammarfru..nn.1
  kammarherre_1_N = mkN "kammarherre" utrum  ; -- kammarherre..nn.1
  kammarjungfru_1_N = mkN "kammarjungfru" "kammarjungfrun" "kammarjungfrur" "kammarjungfrurna" ; -- kammarjungfru..nn.1
  kammarjunkare_1_N = mkN "kammarjunkare" utrum  ; -- kammarjunkare..nn.1
  kammarlärd_1_A = mkA "kammarlärd" "kammarlärt" ; -- kammarlärd..av.1
  kammarmusik_1_N = mkN "kammarmusik" ; -- kammarmusik..nn.1
  kammarmusikalisk_1_A = mkA "kammarmusikalisk" ; -- kammarmusikalisk..av.1
  kammarmusiker_1_N = mkN "kammarmusiker" "kammarmusikern" "kammarmusiker" "kammarmusikerna" ; -- kammarmusiker..nn.1
  kammarorkester_1_N = mkN "kammarorkester" ; -- kammarorkester..nn.1
  kammarpiano_1_N = mkN "kammarpiano" "kammarpianot" "kammarpianon" "kammarpianona" ; -- kammarpiano..nn.1
  kammarrätt_1_N = mkN "kammarrätt" "kammarrätter" ; -- kammarrätt..nn.1
  kammarskjutning_1_N = mkN "kammarskjutning" ; -- kammarskjutning..nn.1
  kammarskrivare_1_N = mkN "kammarskrivare" utrum  ; -- kammarskrivare..nn.1
  kammarskruv_1_N = mkN "kammarskruv" ; -- kammarskruv..nn.1
  kammarspel_1_N = mkN "kammarspel" "kammarspelet" "kammarspel" "kammarspelen" ; -- kammarspel..nn.1
  kammartjänare_1_N = mkN "kammartjänare" utrum  ; -- kammartjänare..nn.1
  kammaråklagare_1_N = mkN "kammaråklagare" utrum  ; -- kammaråklagare..nn.1
  kammussla_1_N = mkN "kammussla" ; -- kammussla..nn.1
  kamning_1_N = mkN "kamning" ; -- kamning..nn.1
  kamomill_1_N = mkN "kamomill" "kamomiller" ; -- kamomill..nn.1
  kamomillte_1_N = mkN "kamomillte" "kamomillteet" "kamomillteer" "kamomillteerna" ; -- kamomillte..nn.1
  kamouflage_1_N = mkN "kamouflage" ; -- kamouflage..nn.1
  kamouflagefärgad_1_A = mkA "kamouflagefärgad" ; -- kamouflagefärgad..av.1
  kamouflagegrå_1_A = mkA "kamouflagegrå" "kamouflagegrått" ; -- kamouflagegrå..av.1
  kamouflageinlägg_1_N = mkN "kamouflageinlägg" neutrum  ; -- kamouflageinlägg..nn.1
  kamouflera_1_V = mkV "kamouflerar" ; -- kamouflera..vb.1
  kamouflerande_1_N = mkN "kamouflerande" ; -- kamouflerande..nn.1
  kamouflerbar_1_A = mkA "kamouflerbar" ; -- kamouflerbar..av.1
  kamouflerbarhet_1_N = mkN "kamouflerbarhet" ; -- kamouflerbarhet..nn.1
  kamouflering_1_N = mkN "kamouflering" ; -- kamouflering..nn.1
  kamp_1_N = mkN "kamp" "kamper" ; -- kamp..nn.1
  kamp_2_N = mkN "kamp" ; -- kamp..nn.2
  kampa_1_V = mkV "kampar" ; -- kampa..vb.1
  kampande_1_N = mkN "kampande" ; -- kampande..nn.1
  kampanil_1_N = mkN "kampanil" "kampaniler" ; -- kampanil..nn.1
  kampanj_1_N = mkN "kampanj" "kampanjer" ; -- kampanj..nn.1
  kampanja_1_V = mkV "kampanjar" ; -- kampanja..vb.1
  kampanjande_1_N = mkN "kampanjande" ; -- kampanjande..nn.1
  kampanjjournalistik_1_N = mkN "kampanjjournalistik" ; -- kampanjjournalistik..nn.1
  kampanjning_1_N = mkN "kampanjning" ; -- kampanjning..nn.1
  kampanjräkning_1_N = mkN "kampanjräkning" ; -- kampanjräkning..nn.1
  kampanjrådgivare_1_N = mkN "kampanjrådgivare" utrum  ; -- kampanjrådgivare..nn.1
  kampanjstab_1_N = mkN "kampanjstab" "kampanjstaber" ; -- kampanjstab..nn.1
  kampanjvinnare_1_N = mkN "kampanjvinnare" utrum  ; -- kampanjvinnare..nn.1
  kampare_1_N = mkN "kampare" utrum  ; -- kampare..nn.1
  kampegräs_1_N = mkN "kampegräs" neutrum  ; -- kampegräs..nn.1
  kampera_1_V = mkV "kamperar" ; -- kampera..vb.1
  kamperande_1_N = mkN "kamperande" ; -- kamperande..nn.1
  kampering_1_N = mkN "kampering" ; -- kampering..nn.1
  kampesch_1_N = mkN "kampesch" ; -- kampesch..nn.1
  kampeschträd_1_N = mkN "kampeschträd" neutrum  ; -- kampeschträd..nn.1
  kamphund_1_N = mkN "kamphund" ; -- kamphund..nn.1
  kampintresserad_1_A = mkA "kampintresserad" ; -- kampintresserad..av.1
  kampkonst_1_N = mkN "kampkonst" "kampkonster" ; -- kampkonst..nn.1
  kampkonstkrets_1_N = mkN "kampkonstkrets" ; -- kampkonstkrets..nn.1
  kampkonstnärlighet_1_N = mkN "kampkonstnärlighet" ; -- kampkonstnärlighet..nn.1
  kampoduglighet_1_N = mkN "kampoduglighet" ; -- kampoduglighet..nn.1
  kamporganisation_1_N = mkN "kamporganisation" ; -- kamporganisation..nn.1
  kamprydd_1_A = mkA "kamprydd" ; -- kamprydd..av.1
  kampsport_1_N = mkN "kampsport" "kampsporter" ; -- kampsport..nn.1
  kampsportare_1_N = mkN "kampsportare" utrum  ; -- kampsportare..nn.1
  kampsportsvärld_1_N = mkN "kampsportsvärld" ; -- kampsportsvärld..nn.1
  kampsång_1_N = mkN "kampsång" "kampsånger" ; -- kampsång..nn.1
  kampuchean_1_N = mkN "kampuchean" "kampucheaner" ; -- kampuchean..nn.1
  kampucheansk_1_A = mkA "kampucheansk" ; -- kampucheansk..av.1
  kampvilja_1_N = mkN "kampvilja" ; -- kampvilja..nn.1
  kamrat_1_N = mkN "kamrat" "kamrater" ; -- kamrat..nn.1
  kamratanda_1_N = mkN "kamratanda" ; -- kamratanda..nn.1
  kamratkrets_1_N = mkN "kamratkrets" ; -- kamratkrets..nn.1
  kamratkänsla_1_N = mkN "kamratkänsla" ; -- kamratkänsla..nn.1
  kamratlig_1_A = mkA "kamratlig" ; -- kamratlig..av.1
  kamratlighet_1_N = mkN "kamratlighet" "kamratligheter" ; -- kamratlighet..nn.1
  kamratliv_1_N = mkN "kamratliv" neutrum  ; -- kamratliv..nn.1
  kamratpåverkning_1_N = mkN "kamratpåverkning" ; -- kamratpåverkning..nn.1
  kamratskap_1_N = mkN "kamratskap" neutrum  ; -- kamratskap..nn.1
  kamrer_1_N = mkN "kamrer" "kamrerer" ; -- kamrer..nn.1
  kamrerare_1_N = mkN "kamrerare" utrum  ; -- kamrerare..nn.1
  kamrermässig_1_A = mkA "kamrermässig" ; -- kamrermässig..av.1
  kams_1_N = mkN "kams" ; -- kams..nn.1
  kamtsjadal_1_N = mkN "kamtsjadal" "kamtsjadaler" ; -- kamtsjadal..nn.1
  kamull_1_N = mkN "kamull" ; -- kamull..nn.1
  kamé_1_N = mkN "kamé" "kaméer" ; -- kamé..nn.1
  kan_1_N = mkN "kan" "kaner" ; -- kan..nn.1
  kana_1_N = mkN "kana" ; -- kana..nn.1
  kana_1_V = mkV "kanar" ; -- kana..vb.1
  kanadagås_1_N = mkN "kanadagås" "kanadagåsen" "kanadagäss" "kanadagässen" ; -- kanadagås..nn.1
  kanadensare_1_N = mkN "kanadensare" utrum  ; -- kanadensare..nn.1
  kanadensisk_1_A = mkA "kanadensisk" ; -- kanadensisk..av.1
  kanadensiska_1_N = mkN "kanadensiska" ; -- kanadensiska..nn.1
  kanadick_1_N = mkN "kanadick" "kanadicker" ; -- kanadick..nn.1
  kanak_1_N = mkN "kanak" "kanaker" ; -- kanak..nn.1
  kanal_1_N = mkN "kanal" "kanaler" ; -- kanal..nn.1
  kanalbygge_1_N = mkN "kanalbygge" ; -- kanalbygge..nn.1
  kanalbåt_1_N = mkN "kanalbåt" ; -- kanalbåt..nn.1
  kanalchef_1_N = mkN "kanalchef" "kanalchefer" ; -- kanalchef..nn.1
  kanalisera_1_V = mkV "kanaliserar" ; -- kanalisera..vb.1
  kanaliserande_1_N = mkN "kanaliserande" ; -- kanaliserande..nn.1
  kanaliserbar_1_A = mkA "kanaliserbar" ; -- kanaliserbar..av.1
  kanaliserbarhet_1_N = mkN "kanaliserbarhet" ; -- kanaliserbarhet..nn.1
  kanalisering_1_N = mkN "kanalisering" ; -- kanalisering..nn.1
  kanalje_1_N = mkN "kanalje" "kanaljer" ; -- kanalje..nn.1
  kanaljeri_1_N = mkN "kanaljeri" "kanaljeriet" "kanaljerier" "kanaljerierna" ; -- kanaljeri..nn.1
  kanalkrock_1_N = mkN "kanalkrock" ; -- kanalkrock..nn.1
  kanalljus_1_N = mkN "kanalljus" neutrum  ; -- kanalljus..nn.1
  kanalsystem_1_N = mkN "kanalsystem" neutrum  ; -- kanalsystem..nn.1
  kanalutbud_1_N = mkN "kanalutbud" neutrum  ; -- kanalutbud..nn.1
  kanalväljare_1_N = mkN "kanalväljare" utrum  ; -- kanalväljare..nn.1
  kanalångare_1_N = mkN "kanalångare" utrum  ; -- kanalångare..nn.1
  kanande_1_N = mkN "kanande" ; -- kanande..nn.1
  kanané_1_N = mkN "kanané" "kananéer" ; -- kanané..nn.1
  kanapé_1_N = mkN "kanapé" "kanapéer" ; -- kanapé..nn.1
  kanariefrö_1_N = mkN "kanariefrö" "kanariefröet" "kanariefrön" "kanariefröna" ; -- kanariefrö..nn.1
  kanariefågel_1_N = mkN "kanariefågel" ; -- kanariefågel..nn.1
  kanariegräs_1_N = mkN "kanariegräs" neutrum  ; -- kanariegräs..nn.1
  kanariegul_1_A = mkA "kanariegul" ; -- kanariegul..av.1
  kanat_1_N = mkN "kanat" neutrum  ; -- kanat..nn.1
  kandar_1_N = mkN "kandar" neutrum  ; -- kandar..nn.1
  kandelaber_1_N = mkN "kandelaber" ; -- kandelaber..nn.1
  kandera_1_V = mkV "kanderar" ; -- kandera..vb.1
  kanderande_1_N = mkN "kanderande" ; -- kanderande..nn.1
  kanderbar_1_A = mkA "kanderbar" ; -- kanderbar..av.1
  kanderbarhet_1_N = mkN "kanderbarhet" ; -- kanderbarhet..nn.1
  kandering_1_N = mkN "kandering" ; -- kandering..nn.1
  kandidat_1_N = mkN "kandidat" "kandidater" ; -- kandidat..nn.1
  kandidatexamen_1_N = mkN "kandidatexamen" "kandidatexamen" "kandidatexamina" "kandidatexamina" ; -- kandidatexamen..nn.1
  kandidatland_1_N = mkN "kandidatland" "kandidatlandet" "kandidatländer" "kandidatländerna" ; -- kandidatland..nn.1
  kandidatlista_1_N = mkN "kandidatlista" ; -- kandidatlista..nn.1
  kandidatur_1_N = mkN "kandidatur" "kandidaturer" ; -- kandidatur..nn.1
  kandidera_1_V = mkV "kandiderar" ; -- kandidera..vb.1
  kandiderande_1_N = mkN "kandiderande" ; -- kandiderande..nn.1
  kandiderbar_1_A = mkA "kandiderbar" ; -- kandiderbar..av.1
  kandiderbarhet_1_N = mkN "kandiderbarhet" ; -- kandiderbarhet..nn.1
  kandidering_1_N = mkN "kandidering" ; -- kandidering..nn.1
  kandisocker_1_N = mkN "kandisocker" neutrum  ; -- kandisocker..nn.1
  kanelbrun_1_A = mkA "kanelbrun" ; -- kanelbrun..av.1
  kanelbulla_1_N = mkN "kanelbulla" ; -- kanelbulla..nn.1
  kanelbulle_1_N = mkN "kanelbulle" utrum  ; -- kanelbulle..nn.1
  kanelbullsdoft_1_N = mkN "kanelbullsdoft" ; -- kanelbullsdoft..nn.1
  kanelfläta_1_N = mkN "kanelfläta" ; -- kanelfläta..nn.1
  kanellängd_1_N = mkN "kanellängd" "kanellängder" ; -- kanellängd..nn.1
  kanelstång_1_N = mkN "kanelstång" "kanelstänger" ; -- kanelstång..nn.1
  kanfas_1_N = mkN "kanfas" "kanfaser" ; -- kanfas..nn.1
  kangas_1_N = mkN "kangas" ; -- kangas..nn.1
  kanik_1_N = mkN "kanik" "kaniker" ; -- kanik..nn.1
  kanin_1_N = mkN "kanin" "kaniner" ; -- kanin..nn.1
  kanindräkt_1_N = mkN "kanindräkt" "kanindräkter" ; -- kanindräkt..nn.1
  kaninhål_1_N = mkN "kaninhål" neutrum  ; -- kaninhål..nn.1
  kaninhåla_1_N = mkN "kaninhåla" ; -- kaninhåla..nn.1
  kaninpuls_1_N = mkN "kaninpuls" ; -- kaninpuls..nn.1
  kaninstor_1_A = mkA "kaninstor" ; -- kaninstor..av.1
  kanister_1_N = mkN "kanister" ; -- kanister..nn.1
  kanjon_1_N = mkN "kanjon" "kanjoner" ; -- kanjon..nn.1
  kanna_1_N = mkN "kanna" ; -- kanna..nn.1
  kannbrosk_1_N = mkN "kannbrosk" neutrum  ; -- kannbrosk..nn.1
  kannelera_1_V = mkV "kannelerar" ; -- kannelera..vb.1
  kannelerande_1_N = mkN "kannelerande" ; -- kannelerande..nn.1
  kannelerbar_1_A = mkA "kannelerbar" ; -- kannelerbar..av.1
  kannelerbarhet_1_N = mkN "kannelerbarhet" ; -- kannelerbarhet..nn.1
  kannelering_1_N = mkN "kannelering" ; -- kannelering..nn.1
  kannelyr_1_N = mkN "kannelyr" "kannelyrer" ; -- kannelyr..nn.1
  kannibal_1_N = mkN "kannibal" "kannibaler" ; -- kannibal..nn.1
  kannibalgryta_1_N = mkN "kannibalgryta" ; -- kannibalgryta..nn.1
  kannibalisk_1_A = mkA "kannibalisk" ; -- kannibalisk..av.1
  kannibalism_1_N = mkN "kannibalism" "kannibalismer" ; -- kannibalism..nn.1
  kannibalistisk_1_A = mkA "kannibalistisk" ; -- kannibalistisk..av.1
  kannlock_1_N = mkN "kannlock" neutrum  ; -- kannlock..nn.1
  kannstöpare_1_N = mkN "kannstöpare" utrum  ; -- kannstöpare..nn.1
  kannstöperi_1_N = mkN "kannstöperi" "kannstöperiet" "kannstöperier" "kannstöperierna" ; -- kannstöperi..nn.1
  kanon_1_A = mkA "kanon" ; -- kanon..av.1
  kanon_1_N = mkN "kanon" "kanon" "kanon" "kanonerna" ; -- kanon..nn.1
  kanon_2_N = mkN "kanon" "kanoner" ; -- kanon..nn.2
  kanonad_1_N = mkN "kanonad" "kanonader" ; -- kanonad..nn.1
  kanonaffär_1_N = mkN "kanonaffär" "kanonaffärer" ; -- kanonaffär..nn.1
  kanonbra_1_Adv = mkAdv "kanonbra" ; -- kanonbra..ab.1
  kanonbra_1_A = mkA "kanonbra" ; -- kanonbra..av.1
  kanonbåt_1_N = mkN "kanonbåt" ; -- kanonbåt..nn.1
  kanonbåtsdiplomati_1_N = mkN "kanonbåtsdiplomati" ; -- kanonbåtsdiplomati..nn.1
  kanondån_1_N = mkN "kanondån" neutrum  ; -- kanondån..nn.1
  kanoneld_1_N = mkN "kanoneld" ; -- kanoneld..nn.1
  kanonerbjudande_1_N = mkN "kanonerbjudande" ; -- kanonerbjudande..nn.1
  kanonfotograf_1_N = mkN "kanonfotograf" "kanonfotografer" ; -- kanonfotograf..nn.1
  kanonföda_1_N = mkN "kanonföda" ; -- kanonföda..nn.1
  kanongjuteri_1_N = mkN "kanongjuteri" "kanongjuteriet" "kanongjuterier" "kanongjuterierna" ; -- kanongjuteri..nn.1
  kanongod_1_A = mkA "kanongod" ; -- kanongod..av.1
  kanonisation_1_N = mkN "kanonisation" ; -- kanonisation..nn.1
  kanonisationsprocess_1_N = mkN "kanonisationsprocess" "kanonisationsprocesser" ; -- kanonisationsprocess..nn.1
  kanonisera_1_V = mkV "kanoniserar" ; -- kanonisera..vb.1
  kanoniserande_1_N = mkN "kanoniserande" ; -- kanoniserande..nn.1
  kanoniserbar_1_A = mkA "kanoniserbar" ; -- kanoniserbar..av.1
  kanoniserbarhet_1_N = mkN "kanoniserbarhet" ; -- kanoniserbarhet..nn.1
  kanonisering_1_N = mkN "kanonisering" ; -- kanonisering..nn.1
  kanoniseringsprocess_1_N = mkN "kanoniseringsprocess" "kanoniseringsprocesser" ; -- kanoniseringsprocess..nn.1
  kanonisk_1_A = mkA "kanonisk" ; -- kanonisk..av.1
  kanoniär_1_N = mkN "kanoniär" "kanoniärer" ; -- kanoniär..nn.1
  kanonjär_1_N = mkN "kanonjär" "kanonjärer" ; -- kanonjär..nn.1
  kanonkula_1_N = mkN "kanonkula" ; -- kanonkula..nn.1
  kanonköp_1_N = mkN "kanonköp" neutrum  ; -- kanonköp..nn.1
  kanonlavett_1_N = mkN "kanonlavett" "kanonlavetter" ; -- kanonlavett..nn.1
  kanonlock_1_N = mkN "kanonlock" ; -- kanonlock..nn.1
  kanonlopp_1_N = mkN "kanonlopp" neutrum  ; -- kanonlopp..nn.1
  kanonlucka_1_N = mkN "kanonlucka" ; -- kanonlucka..nn.1
  kanonmat_1_N = mkN "kanonmat" ; -- kanonmat..nn.1
  kanonport_1_N = mkN "kanonport" ; -- kanonport..nn.1
  kanonsalut_1_N = mkN "kanonsalut" "kanonsaluter" ; -- kanonsalut..nn.1
  kanonsalva_1_N = mkN "kanonsalva" ; -- kanonsalva..nn.1
  kanonset_1_N = mkN "kanonset" neutrum  ; -- kanonset..nn.1
  kanontorn_1_N = mkN "kanontorn" neutrum  ; -- kanontorn..nn.1
  kanonväder_1_N = mkN "kanonväder" neutrum  ; -- kanonväder..nn.1
  kanot_1_N = mkN "kanot" "kanoter" ; -- kanot..nn.1
  kanota_1_V = mkV "kanotar" ; -- kanota..vb.1
  kanotande_1_N = mkN "kanotande" ; -- kanotande..nn.1
  kanotist_1_N = mkN "kanotist" "kanotister" ; -- kanotist..nn.1
  kanotklubb_1_N = mkN "kanotklubb" ; -- kanotklubb..nn.1
  kanotläger_1_N = mkN "kanotläger" neutrum  ; -- kanotläger..nn.1
  kanotpaddling_1_N = mkN "kanotpaddling" ; -- kanotpaddling..nn.1
  kanotresa_1_N = mkN "kanotresa" ; -- kanotresa..nn.1
  kanske_1_Adv = mkAdv "kanske" ; -- kanske..ab.1
  kansler_1_N = mkN "kansler" ; -- kansler..nn.1
  kansli_1_N = mkN "kansli" "kansliet" "kanslier" "kanslierna" ; -- kansli..nn.1
  kanslichef_1_N = mkN "kanslichef" "kanslichefer" ; -- kanslichef..nn.1
  kansliexamen_1_N = mkN "kansliexamen" "kansliexamen" "kansliexamina" "kansliexamina" ; -- kansliexamen..nn.1
  kanslihus_1_N = mkN "kanslihus" neutrum  ; -- kanslihus..nn.1
  kanslimässig_1_A = mkA "kanslimässig" ; -- kanslimässig..av.1
  kansliråd_1_N = mkN "kansliråd" neutrum  ; -- kansliråd..nn.1
  kanslisekreterare_1_N = mkN "kanslisekreterare" utrum  ; -- kanslisekreterare..nn.1
  kanslispråk_1_N = mkN "kanslispråk" neutrum  ; -- kanslispråk..nn.1
  kanslist_1_N = mkN "kanslist" "kanslister" ; -- kanslist..nn.1
  kanslistil_1_N = mkN "kanslistil" ; -- kanslistil..nn.1
  kanslisvenska_1_N = mkN "kanslisvenska" ; -- kanslisvenska..nn.1
  kant_1_N = mkN "kant" "kanter" ; -- kant..nn.1
  kanta_1_V = mkV "kantar" ; -- kanta..vb.1
  kantabel_1_A = mkA "kantabel" ; -- kantabel..av.1
  kantande_1_N = mkN "kantande" ; -- kantande..nn.1
  kantarell_1_N = mkN "kantarell" "kantareller" ; -- kantarell..nn.1
  kantarellsmörgås_1_N = mkN "kantarellsmörgås" ; -- kantarellsmörgås..nn.1
  kantarellstuvning_1_N = mkN "kantarellstuvning" ; -- kantarellstuvning..nn.1
  kantarellsås_1_N = mkN "kantarellsås" "kantarellsåser" ; -- kantarellsås..nn.1
  kantat_1_N = mkN "kantat" "kantater" ; -- kantat..nn.1
  kantband_1_N = mkN "kantband" neutrum  ; -- kantband..nn.1
  kantbeslag_1_N = mkN "kantbeslag" neutrum  ; -- kantbeslag..nn.1
  kantblomma_1_N = mkN "kantblomma" ; -- kantblomma..nn.1
  kantele_1_N = mkN "kantele" "kanteler" ; -- kantele..nn.1
  kanthugga_1_V = mkV "kanthugga" "kanthögg" "kanthuggit" ; -- kanthugga..vb.1
  kanthuggande_1_N = mkN "kanthuggande" ; -- kanthuggande..nn.1
  kanthuggning_1_N = mkN "kanthuggning" ; -- kanthuggning..nn.1
  kanthyvel_1_N = mkN "kanthyvel" ; -- kanthyvel..nn.1
  kanthyvla_1_V = mkV "kanthyvlar" ; -- kanthyvla..vb.1
  kanthyvlande_1_N = mkN "kanthyvlande" ; -- kanthyvlande..nn.1
  kanthyvling_1_N = mkN "kanthyvling" ; -- kanthyvling..nn.1
  kantig_1_A = mkA "kantig" ; -- kantig..av.1
  kantighet_1_N = mkN "kantighet" ; -- kantighet..nn.1
  kantighet_2_N = mkN "kantighet" "kantigheter" ; -- kantighet..nn.2
  kantilena_1_N = mkN "kantilena" ; -- kantilena..nn.1
  kantin_1_N = mkN "kantin" "kantiner" ; -- kantin..nn.1
  kantklippa_1_V = mkV "kantklipper" ; -- kantklippa..vb.1
  kantklippande_1_N = mkN "kantklippande" ; -- kantklippande..nn.1
  kantklippning_1_N = mkN "kantklippning" ; -- kantklippning..nn.1
  kantlist_1_N = mkN "kantlist" "kantlister" ; -- kantlist..nn.1
  kantning_1_N = mkN "kantning" ; -- kantning..nn.1
  kantnål_1_N = mkN "kantnål" ; -- kantnål..nn.1
  kanton_1_N = mkN "kanton" "kantoner" ; -- kanton..nn.1
  kantonesisk_1_A = mkA "kantonesisk" ; -- kantonesisk..av.1
  kantor_1_N = mkN "kantor" "kantorer" ; -- kantor..nn.1
  kantra_1_V = mkV "kantrar" ; -- kantra..vb.1
  kantrad_1_N = mkN "kantrad" "kantrader" ; -- kantrad..nn.1
  kantrande_1_N = mkN "kantrande" ; -- kantrande..nn.1
  kantrep_1_N = mkN "kantrep" neutrum  ; -- kantrep..nn.1
  kantsten_1_N = mkN "kantsten" "kantstenen" "kantstenar" "kantstenarna" ; -- kantsten..nn.1
  kantstött_1_A = mkA "kantstött" ; -- kantstött..av.1
  kantstötthet_1_N = mkN "kantstötthet" ; -- kantstötthet..nn.1
  kantsöm_1_N = mkN "kantsöm" "kantsömmen" "kantsömmar" "kantsömmarna" ; -- kantsöm..nn.1
  kantvax_1_N = mkN "kantvax" neutrum  ; -- kantvax..nn.1
  kantväxt_1_N = mkN "kantväxt" "kantväxter" ; -- kantväxt..nn.1
  kanvas_1_N = mkN "kanvas" ; -- kanvas..nn.1
  kanvasband_1_N = mkN "kanvasband" neutrum  ; -- kanvasband..nn.1
  kanvasduk_1_N = mkN "kanvasduk" ; -- kanvasduk..nn.1
  kanyl_1_N = mkN "kanyl" "kanyler" ; -- kanyl..nn.1
  kanzon_1_N = mkN "kanzon" "kanzoner" ; -- kanzon..nn.1
  kanzonett_1_N = mkN "kanzonett" "kanzonetter" ; -- kanzonett..nn.1
  kaolin_1_N = mkN "kaolin" ; -- kaolin..nn.1
  kaos_1_N = mkN "kaos" neutrum  ; -- kaos..nn.1
  kaosartad_1_A = mkA "kaosartad" ; -- kaosartad..av.1
  kaosperiod_1_N = mkN "kaosperiod" "kaosperioder" ; -- kaosperiod..nn.1
  kaosteori_1_N = mkN "kaosteori" ; -- kaosteori..nn.1
  kaosväder_1_N = mkN "kaosväder" neutrum  ; -- kaosväder..nn.1
  kaotisk_1_A = mkA "kaotisk" ; -- kaotisk..av.1
  kap_1_N = mkN "kap" ; -- kap..nn.1
  kap_2_N = mkN "kap" neutrum  ; -- kap..nn.2
  kapa_1_V = mkV "kapar" ; -- kapa..vb.1
  kapabel_1_A = mkA "kapabel" ; -- kapabel..av.1
  kapacitans_1_N = mkN "kapacitans" ; -- kapacitans..nn.1
  kapacitet_1_N = mkN "kapacitet" "kapaciteter" ; -- kapacitet..nn.1
  kapacitetsbrist_1_N = mkN "kapacitetsbrist" "kapacitetsbrister" ; -- kapacitetsbrist..nn.1
  kapacitetshöjning_1_N = mkN "kapacitetshöjning" ; -- kapacitetshöjning..nn.1
  kapacitetsutnyttjande_1_N = mkN "kapacitetsutnyttjande" ; -- kapacitetsutnyttjande..nn.1
  kapacitetsökning_1_N = mkN "kapacitetsökning" ; -- kapacitetsökning..nn.1
  kapande_1_N = mkN "kapande" ; -- kapande..nn.1
  kaparbrev_1_N = mkN "kaparbrev" neutrum  ; -- kaparbrev..nn.1
  kapardrama_1_N = mkN "kapardrama" "kapardramat" "kapardramer" "kapardramerna" ; -- kapardrama..nn.1
  kapare_1_N = mkN "kapare" utrum  ; -- kapare..nn.1
  kaparfartyg_1_N = mkN "kaparfartyg" neutrum  ; -- kaparfartyg..nn.1
  kaparkapten_1_N = mkN "kaparkapten" "kaparkaptener" ; -- kaparkapten..nn.1
  kapduva_1_N = mkN "kapduva" ; -- kapduva..nn.1
  kapell_1_N = mkN "kapell" neutrum  ; -- kapell..nn.1
  kapellmästare_1_N = mkN "kapellmästare" utrum  ; -- kapellmästare..nn.1
  kaperi_1_N = mkN "kaperi" "kaperiet" "kaperier" "kaperierna" ; -- kaperi..nn.1
  kapfår_1_N = mkN "kapfår" neutrum  ; -- kapfår..nn.1
  kapillaritet_1_N = mkN "kapillaritet" "kapillariteter" ; -- kapillaritet..nn.1
  kapillarkärl_1_N = mkN "kapillarkärl" neutrum  ; -- kapillarkärl..nn.1
  kapillarrör_1_N = mkN "kapillarrör" neutrum  ; -- kapillarrör..nn.1
  kapillär_1_A = mkA "kapillär" ; -- kapillär..av.1
  kapillär_1_N = mkN "kapillär" "kapillärer" ; -- kapillär..nn.1
  kapillärkraft_1_N = mkN "kapillärkraft" ; -- kapillärkraft..nn.1
  kapillärrör_1_N = mkN "kapillärrör" neutrum  ; -- kapillärrör..nn.1
  kapital_1_A = mkA "kapital" ; -- kapital..av.1
  kapital_1_N = mkN "kapital" neutrum  ; -- kapital..nn.1
  kapitalavkastning_1_N = mkN "kapitalavkastning" ; -- kapitalavkastning..nn.1
  kapitalbehållning_1_N = mkN "kapitalbehållning" ; -- kapitalbehållning..nn.1
  kapitalbeskattning_1_N = mkN "kapitalbeskattning" ; -- kapitalbeskattning..nn.1
  kapitalbildning_1_N = mkN "kapitalbildning" ; -- kapitalbildning..nn.1
  kapitalbudget_1_N = mkN "kapitalbudget" ; -- kapitalbudget..nn.1
  kapitalexport_1_N = mkN "kapitalexport" ; -- kapitalexport..nn.1
  kapitalflykt_1_N = mkN "kapitalflykt" ; -- kapitalflykt..nn.1
  kapitalförlust_1_N = mkN "kapitalförlust" "kapitalförluster" ; -- kapitalförlust..nn.1
  kapitalförstöring_1_N = mkN "kapitalförstöring" ; -- kapitalförstöring..nn.1
  kapitalförsäkring_1_N = mkN "kapitalförsäkring" ; -- kapitalförsäkring..nn.1
  kapitalinkomst_1_N = mkN "kapitalinkomst" "kapitalinkomster" ; -- kapitalinkomst..nn.1
  kapitalinkomstbeskattning_1_N = mkN "kapitalinkomstbeskattning" ; -- kapitalinkomstbeskattning..nn.1
  kapitalintensiv_1_A = mkA "kapitalintensiv" ; -- kapitalintensiv..av.1
  kapitalinvestering_1_N = mkN "kapitalinvestering" ; -- kapitalinvestering..nn.1
  kapitalisera_1_V = mkV "kapitaliserar" ; -- kapitalisera..vb.1
  kapitaliserande_1_N = mkN "kapitaliserande" ; -- kapitaliserande..nn.1
  kapitaliserbar_1_A = mkA "kapitaliserbar" ; -- kapitaliserbar..av.1
  kapitaliserbarhet_1_N = mkN "kapitaliserbarhet" ; -- kapitaliserbarhet..nn.1
  kapitalisering_1_N = mkN "kapitalisering" ; -- kapitalisering..nn.1
  kapitalism_1_N = mkN "kapitalism" "kapitalismer" ; -- kapitalism..nn.1
  kapitalist_1_N = mkN "kapitalist" "kapitalister" ; -- kapitalist..nn.1
  kapitalistisk_1_A = mkA "kapitalistisk" ; -- kapitalistisk..av.1
  kapitalistkarikatyr_1_N = mkN "kapitalistkarikatyr" "kapitalistkarikatyrer" ; -- kapitalistkarikatyr..nn.1
  kapitalistklass_1_N = mkN "kapitalistklass" "kapitalistklasser" ; -- kapitalistklass..nn.1
  kapitaliststat_1_N = mkN "kapitaliststat" "kapitaliststater" ; -- kapitaliststat..nn.1
  kapitalkonto_1_N = mkN "kapitalkonto" "kapitalkontot" "kapitalkonton" "kapitalkontona" ; -- kapitalkonto..nn.1
  kapitalmarknad_1_N = mkN "kapitalmarknad" "kapitalmarknader" ; -- kapitalmarknad..nn.1
  kapitalmässig_1_A = mkA "kapitalmässig" ; -- kapitalmässig..av.1
  kapitalplacering_1_N = mkN "kapitalplacering" ; -- kapitalplacering..nn.1
  kapitalstark_1_A = mkA "kapitalstark" ; -- kapitalstark..av.1
  kapitalstinn_1_A = mkA "kapitalstinn" "kapitalstint" ; -- kapitalstinn..av.1
  kapitalstinnhet_1_N = mkN "kapitalstinnhet" ; -- kapitalstinnhet..nn.1
  kapitalvara_1_N = mkN "kapitalvara" ; -- kapitalvara..nn.1
  kapitalvinst_1_N = mkN "kapitalvinst" "kapitalvinster" ; -- kapitalvinst..nn.1
  kapitalvärde_1_N = mkN "kapitalvärde" ; -- kapitalvärde..nn.1
  kapitel_1_N = mkN "kapitel" neutrum  ; -- kapitel..nn.1
  kapitelindelning_1_N = mkN "kapitelindelning" ; -- kapitelindelning..nn.1
  kapitelsal_1_N = mkN "kapitelsal" ; -- kapitelsal..nn.1
  kapitelvis_1_Adv = mkAdv "kapitelvis" ; -- kapitelvis..ab.1
  kapitulation_1_N = mkN "kapitulation" ; -- kapitulation..nn.1
  kapitulera_1_V = mkV "kapitulerar" ; -- kapitulera..vb.1
  kapitulerande_1_N = mkN "kapitulerande" ; -- kapitulerande..nn.1
  kapitulering_1_N = mkN "kapitulering" ; -- kapitulering..nn.1
  kapitäl_1_N = mkN "kapitäl" neutrum  ; -- kapitäl..nn.1
  kapitäl_2_N = mkN "kapitäl" "kapitäler" ; -- kapitäl..nn.2
  kapkrusbär_1_N = mkN "kapkrusbär" neutrum  ; -- kapkrusbär..nn.1
  kaplan_1_N = mkN "kaplan" "kaplaner" ; -- kaplan..nn.1
  kapmaskin_1_N = mkN "kapmaskin" "kapmaskiner" ; -- kapmaskin..nn.1
  kapning_1_N = mkN "kapning" ; -- kapning..nn.1
  kapningsförsök_1_N = mkN "kapningsförsök" neutrum  ; -- kapningsförsök..nn.1
  kapock_1_N = mkN "kapock" ; -- kapock..nn.1
  kapott_1_N = mkN "kapott" "kapotter" ; -- kapott..nn.1
  kapp_1_N = mkN "kapp" ; -- kapp..nn.1
  kappa_1_N = mkN "kappa" ; -- kappa..nn.1
  kappa_2_N = mkN "kappa" "kappat" "kappan" "kappana" ; -- kappa..nn.2
  kappe_1_N = mkN "kappe" utrum  ; -- kappe..nn.1
  kapphylla_1_N = mkN "kapphylla" ; -- kapphylla..nn.1
  kappköra_1_V = mkV "kappköra" "kappkörde" "kappkört" ; -- kappköra..vb.1
  kappkörande_1_N = mkN "kappkörande" ; -- kappkörande..nn.1
  kappkörning_1_N = mkN "kappkörning" ; -- kappkörning..nn.1
  kapplöpare_1_N = mkN "kapplöpare" utrum  ; -- kapplöpare..nn.1
  kapplöpning_1_N = mkN "kapplöpning" ; -- kapplöpning..nn.1
  kapplöpningsbana_1_N = mkN "kapplöpningsbana" ; -- kapplöpningsbana..nn.1
  kapplöpningshäst_1_N = mkN "kapplöpningshäst" ; -- kapplöpningshäst..nn.1
  kapprak_1_A = mkA "kapprak" ; -- kapprak..av.1
  kapprakhet_1_N = mkN "kapprakhet" ; -- kapprakhet..nn.1
  kappridning_1_N = mkN "kappridning" ; -- kappridning..nn.1
  kapprock_1_N = mkN "kapprock" ; -- kapprock..nn.1
  kapprodd_1_N = mkN "kapprodd" ; -- kapprodd..nn.1
  kapproddare_1_N = mkN "kapproddare" utrum  ; -- kapproddare..nn.1
  kapproddbåt_1_N = mkN "kapproddbåt" ; -- kapproddbåt..nn.1
  kapprum_1_N = mkN "kapprum" "kapprummet" "kapprum" "kapprummen" ; -- kapprum..nn.1
  kapprusta_1_V = mkV "kapprustar" ; -- kapprusta..vb.1
  kapprustande_1_N = mkN "kapprustande" ; -- kapprustande..nn.1
  kapprustning_1_N = mkN "kapprustning" ; -- kapprustning..nn.1
  kappsegla_1_V = mkV "kappseglar" ; -- kappsegla..vb.1
  kappseglande_1_N = mkN "kappseglande" ; -- kappseglande..nn.1
  kappseglare_1_N = mkN "kappseglare" utrum  ; -- kappseglare..nn.1
  kappsegling_1_N = mkN "kappsegling" ; -- kappsegling..nn.1
  kappseglingsbåt_1_N = mkN "kappseglingsbåt" ; -- kappseglingsbåt..nn.1
  kappsimning_1_N = mkN "kappsimning" ; -- kappsimning..nn.1
  kappsäck_1_N = mkN "kappsäck" ; -- kappsäck..nn.1
  kappvändning_1_N = mkN "kappvändning" ; -- kappvändning..nn.1
  kappåkning_1_N = mkN "kappåkning" ; -- kappåkning..nn.1
  kapriciös_1_A = mkA "kapriciös" ; -- kapriciös..av.1
  kaprifol_1_N = mkN "kaprifol" "kaprifoler" ; -- kaprifol..nn.1
  kaprifolium_1_N = mkN "kaprifolium" "kaprifolien" "kaprifolier" "kaprifolierna" ; -- kaprifolium..nn.1
  kapriol_1_N = mkN "kapriol" "kaprioler" ; -- kapriol..nn.1
  kapris_1_N = mkN "kapris" "kapriser" ; -- kapris..nn.1
  kapris_2_N = mkN "kapris" ; -- kapris..nn.2
  kapsejsa_1_V = mkV "kapsejsar" ; -- kapsejsa..vb.1
  kapsejsande_1_N = mkN "kapsejsande" ; -- kapsejsande..nn.1
  kapsel_1_N = mkN "kapsel" ; -- kapsel..nn.1
  kapselformig_1_A = mkA "kapselformig" ; -- kapselformig..av.1
  kapskiva_1_N = mkN "kapskiva" ; -- kapskiva..nn.1
  kapsla_1_V = mkV "kapslar" ; -- kapsla..vb.1
  kapslande_1_N = mkN "kapslande" ; -- kapslande..nn.1
  kapsling_1_N = mkN "kapsling" ; -- kapsling..nn.1
  kapson_1_N = mkN "kapson" "kapsoner" ; -- kapson..nn.1
  kapsyl_1_N = mkN "kapsyl" "kapsyler" ; -- kapsyl..nn.1
  kapsylöppnare_1_N = mkN "kapsylöppnare" utrum  ; -- kapsylöppnare..nn.1
  kapsåg_1_N = mkN "kapsåg" ; -- kapsåg..nn.1
  kapten_1_N = mkN "kapten" "kaptener" ; -- kapten..nn.1
  kaptenlöjtnant_1_N = mkN "kaptenlöjtnant" ; -- kaptenlöjtnant..nn.1
  kapucin_1_N = mkN "kapucin" "kapuciner" ; -- kapucin..nn.1
  kapucinapa_1_N = mkN "kapucinapa" ; -- kapucinapa..nn.1
  kapucinerkloster_1_N = mkN "kapucinerkloster" neutrum  ; -- kapucinerkloster..nn.1
  kapucinerorden_1_N = mkN "kapucinerorden" ; -- kapucinerorden..nn.1
  kapucinkloster_1_N = mkN "kapucinkloster" neutrum  ; -- kapucinkloster..nn.1
  kapucinorden_1_N = mkN "kapucinorden" ; -- kapucinorden..nn.1
  kapun_1_N = mkN "kapun" "kapuner" ; -- kapun..nn.1
  kapuschong_1_N = mkN "kapuschong" "kapuschonger" ; -- kapuschong..nn.1
  kaputt_1_A = mkA "kaputt" ; -- kaputt..av.1
  kapverdier_1_N = mkN "kapverdier" "kapverdiern" "kapverdier" "kapverdierna" ; -- kapverdier..nn.1
  kapverdisk_1_A = mkA "kapverdisk" ; -- kapverdisk..av.1
  kapverdiska_1_N = mkN "kapverdiska" ; -- kapverdiska..nn.1
  kapybar_1_N = mkN "kapybar" "kapybarer" ; -- kapybar..nn.1
  kapybara_1_N = mkN "kapybara" ; -- kapybara..nn.1
  kar_1_N = mkN "kar" neutrum  ; -- kar..nn.1
  kara_1_N = mkN "kara" ; -- kara..nn.1
  kara_1_V = mkV "karar" ; -- kara..vb.1
  karabinjär_1_N = mkN "karabinjär" "karabinjärer" ; -- karabinjär..nn.1
  karaff_1_N = mkN "karaff" "karaffer" ; -- karaff..nn.1
  karaffin_1_N = mkN "karaffin" "karaffiner" ; -- karaffin..nn.1
  karakolering_1_N = mkN "karakolering" ; -- karakolering..nn.1
  karakterisera_1_V = mkV "karakteriserar" ; -- karakterisera..vb.1
  karakteriserande_1_N = mkN "karakteriserande" ; -- karakteriserande..nn.1
  karakteriserbar_1_A = mkA "karakteriserbar" ; -- karakteriserbar..av.1
  karakteriserbarhet_1_N = mkN "karakteriserbarhet" ; -- karakteriserbarhet..nn.1
  karakterisering_1_N = mkN "karakterisering" ; -- karakterisering..nn.1
  karakteristik_1_N = mkN "karakteristik" "karakteristiker" ; -- karakteristik..nn.1
  karakteristika_1_N = mkN "karakteristika" ; -- karakteristika..nn.1
  karakteristika_2_N = mkN "karakteristika" "karakteristikat" "karakteristika" "karakteristikana" ; -- karakteristika..nn.2
  karakteristisk_1_A = mkA "karakteristisk" ; -- karakteristisk..av.1
  karakterologi_1_N = mkN "karakterologi" ; -- karakterologi..nn.1
  karaktär_1_N = mkN "karaktär" "karaktärer" ; -- karaktär..nn.1
  karaktär_2_N = mkN "karaktär" ; -- karaktär..nn.2
  karaktärisera_1_V = mkV "karaktäriserar" ; -- karaktärisera..vb.1
  karaktäriserande_1_N = mkN "karaktäriserande" ; -- karaktäriserande..nn.1
  karaktäriserbar_1_A = mkA "karaktäriserbar" ; -- karaktäriserbar..av.1
  karaktäriserbarhet_1_N = mkN "karaktäriserbarhet" ; -- karaktäriserbarhet..nn.1
  karaktärisering_1_N = mkN "karaktärisering" ; -- karaktärisering..nn.1
  karaktäristik_1_N = mkN "karaktäristik" "karaktäristiker" ; -- karaktäristik..nn.1
  karaktäristika_1_N = mkN "karaktäristika" ; -- karaktäristika..nn.1
  karaktäristika_2_N = mkN "karaktäristika" "karaktäristikat" "karaktäristika" "karaktäristikana" ; -- karaktäristika..nn.2
  karaktäristisk_1_A = mkA "karaktäristisk" ; -- karaktäristisk..av.1
  karaktärologi_1_N = mkN "karaktärologi" ; -- karaktärologi..nn.1
  karaktärsart_1_N = mkN "karaktärsart" "karaktärsarter" ; -- karaktärsart..nn.1
  karaktärsbrist_1_N = mkN "karaktärsbrist" "karaktärsbrister" ; -- karaktärsbrist..nn.1
  karaktärsdrag_1_N = mkN "karaktärsdrag" neutrum  ; -- karaktärsdrag..nn.1
  karaktärsdrama_1_N = mkN "karaktärsdrama" "karaktärsdramat" "karaktärsdramer" "karaktärsdramerna" ; -- karaktärsdrama..nn.1
  karaktärsfast_1_A = mkA "karaktärsfast" "karaktärsfast" ; -- karaktärsfast..av.1
  karaktärsfasthet_1_N = mkN "karaktärsfasthet" ; -- karaktärsfasthet..nn.1
  karaktärsfel_1_N = mkN "karaktärsfel" "karaktärsfelet" "karaktärsfel" "karaktärsfelen" ; -- karaktärsfel..nn.1
  karaktärsfördjupning_1_N = mkN "karaktärsfördjupning" ; -- karaktärsfördjupning..nn.1
  karaktärslös_1_A = mkA "karaktärslös" "karaktärslöt" ; -- karaktärslös..av.1
  karaktärslöshet_1_N = mkN "karaktärslöshet" ; -- karaktärslöshet..nn.1
  karaktärsmord_1_N = mkN "karaktärsmord" neutrum  ; -- karaktärsmord..nn.1
  karaktärsmässig_1_A = mkA "karaktärsmässig" ; -- karaktärsmässig..av.1
  karaktärsroll_1_N = mkN "karaktärsroll" "karaktärsroller" ; -- karaktärsroll..nn.1
  karaktärsskildring_1_N = mkN "karaktärsskildring" ; -- karaktärsskildring..nn.1
  karaktärsskådespelare_1_N = mkN "karaktärsskådespelare" utrum  ; -- karaktärsskådespelare..nn.1
  karaktärsstark_1_A = mkA "karaktärsstark" ; -- karaktärsstark..av.1
  karaktärsstyrka_1_N = mkN "karaktärsstyrka" ; -- karaktärsstyrka..nn.1
  karaktärssvag_1_A = mkA "karaktärssvag" ; -- karaktärssvag..av.1
  karaktärssvaghet_1_N = mkN "karaktärssvaghet" "karaktärssvagheter" ; -- karaktärssvaghet..nn.1
  karaktärsteckning_1_N = mkN "karaktärsteckning" ; -- karaktärsteckning..nn.1
  karaktärstyp_1_N = mkN "karaktärstyp" "karaktärstyper" ; -- karaktärstyp..nn.1
  karaktärsvittne_1_N = mkN "karaktärsvittne" ; -- karaktärsvittne..nn.1
  karambolage_1_N = mkN "karambolage" ; -- karambolage..nn.1
  karambolera_1_V = mkV "karambolerar" ; -- karambolera..vb.1
  karambolerande_1_N = mkN "karambolerande" ; -- karambolerande..nn.1
  karambolerbar_1_A = mkA "karambolerbar" ; -- karambolerbar..av.1
  karambolerbarhet_1_N = mkN "karambolerbarhet" ; -- karambolerbarhet..nn.1
  karambolering_1_N = mkN "karambolering" ; -- karambolering..nn.1
  karamboll_1_N = mkN "karamboll" ; -- karamboll..nn.1
  karamell_1_N = mkN "karamell" "karameller" ; -- karamell..nn.1
  karamellfabrik_1_N = mkN "karamellfabrik" "karamellfabriker" ; -- karamellfabrik..nn.1
  karamellfärg_1_N = mkN "karamellfärg" "karamellfärger" ; -- karamellfärg..nn.1
  karamellfärgad_1_A = mkA "karamellfärgad" ; -- karamellfärgad..av.1
  karamellpapper_1_N = mkN "karamellpapper" neutrum  ; -- karamellpapper..nn.1
  karamellpudding_1_N = mkN "karamellpudding" ; -- karamellpudding..nn.1
  karamellsås_1_N = mkN "karamellsås" "karamellsåser" ; -- karamellsås..nn.1
  karande_1_N = mkN "karande" ; -- karande..nn.1
  karantän_1_N = mkN "karantän" "karantäner" ; -- karantän..nn.1
  karantänsflagg_1_N = mkN "karantänsflagg" ; -- karantänsflagg..nn.1
  karaoke_1_N = mkN "karaoke" utrum  ; -- karaoke..nn.1
  karat_1_N = mkN "karat" neutrum  ; -- karat..nn.1
  karate_1_N = mkN "karate" utrum  ; -- karate..nn.1
  karaterad_1_A = mkA "karaterad" ; -- karaterad..av.1
  karatering_1_N = mkN "karatering" ; -- karatering..nn.1
  karatespark_1_N = mkN "karatespark" ; -- karatespark..nn.1
  karateteknisk_1_A = mkA "karateteknisk" ; -- karateteknisk..av.1
  karathalt_1_N = mkN "karathalt" "karathalter" ; -- karathalt..nn.1
  karatstämpel_1_N = mkN "karatstämpel" ; -- karatstämpel..nn.1
  karavan_1_N = mkN "karavan" "karavaner" ; -- karavan..nn.1
  karavanhandel_1_N = mkN "karavanhandel" ; -- karavanhandel..nn.1
  karavanled_1_N = mkN "karavanled" "karavanleder" ; -- karavanled..nn.1
  karavanseraj_1_N = mkN "karavanseraj" "karavanserajer" ; -- karavanseraj..nn.1
  karavanväg_1_N = mkN "karavanväg" ; -- karavanväg..nn.1
  karavell_1_N = mkN "karavell" "karaveller" ; -- karavell..nn.1
  karbad_1_N = mkN "karbad" neutrum  ; -- karbad..nn.1
  karbamid_1_N = mkN "karbamid" "karbamider" ; -- karbamid..nn.1
  karbas_1_N = mkN "karbas" "karbaser" ; -- karbas..nn.1
  karbid_1_N = mkN "karbid" "karbider" ; -- karbid..nn.1
  karbidlampa_1_N = mkN "karbidlampa" ; -- karbidlampa..nn.1
  karbin_1_N = mkN "karbin" "karbiner" ; -- karbin..nn.1
  karbinhake_1_N = mkN "karbinhake" utrum  ; -- karbinhake..nn.1
  karbol_1_N = mkN "karbol" ; -- karbol..nn.1
  karbolsyra_1_N = mkN "karbolsyra" ; -- karbolsyra..nn.1
  karbon_1_N = mkN "karbon" ; -- karbon..nn.1
  karbonat_1_N = mkN "karbonat" neutrum  ; -- karbonat..nn.1
  karbonatjon_1_N = mkN "karbonatjon" "karbonatjoner" ; -- karbonatjon..nn.1
  karbonatsmältecell_1_N = mkN "karbonatsmältecell" "karbonatsmälteceller" ; -- karbonatsmältecell..nn.1
  karbonisera_1_V = mkV "karboniserar" ; -- karbonisera..vb.1
  karboniserande_1_N = mkN "karboniserande" ; -- karboniserande..nn.1
  karboniserbar_1_A = mkA "karboniserbar" ; -- karboniserbar..av.1
  karboniserbarhet_1_N = mkN "karboniserbarhet" ; -- karboniserbarhet..nn.1
  karbonisering_1_N = mkN "karbonisering" ; -- karbonisering..nn.1
  karbonkopia_1_N = mkN "karbonkopia" ; -- karbonkopia..nn.1
  karbonpapper_1_N = mkN "karbonpapper" neutrum  ; -- karbonpapper..nn.1
  karbonsyra_1_N = mkN "karbonsyra" ; -- karbonsyra..nn.1
  karbonsystem_1_N = mkN "karbonsystem" neutrum  ; -- karbonsystem..nn.1
  karborundum_1_N = mkN "karborundum" neutrum  ; -- karborundum..nn.1
  karborundumduk_1_N = mkN "karborundumduk" ; -- karborundumduk..nn.1
  karboxylsyra_1_N = mkN "karboxylsyra" ; -- karboxylsyra..nn.1
  karbunkel_1_N = mkN "karbunkel" ; -- karbunkel..nn.1
  karburator_1_N = mkN "karburator" "karburatorer" ; -- karburator..nn.1
  karburatorsprit_1_N = mkN "karburatorsprit" ; -- karburatorsprit..nn.1
  karcinogen_1_A = mkA "karcinogen" "karcinogent" ; -- karcinogen..av.1
  karcinogen_1_N = mkN "karcinogen" "karcinogener" ; -- karcinogen..nn.1
  karcinom_1_N = mkN "karcinom" neutrum  ; -- karcinom..nn.1
  karda_1_N = mkN "karda" ; -- karda..nn.1
  karda_1_V = mkV "kardar" ; -- karda..vb.1
  kardan_1_N = mkN "kardan" "kardaner" ; -- kardan..nn.1
  kardanaxel_1_N = mkN "kardanaxel" ; -- kardanaxel..nn.1
  kardande_1_N = mkN "kardande" ; -- kardande..nn.1
  kardanknut_1_N = mkN "kardanknut" ; -- kardanknut..nn.1
  kardansk_1_A = mkA "kardansk" ; -- kardansk..av.1
  kardanupphängning_1_N = mkN "kardanupphängning" ; -- kardanupphängning..nn.1
  kardborrband_1_N = mkN "kardborrband" neutrum  ; -- kardborrband..nn.1
  kardborre_1_N = mkN "kardborre" utrum  ; -- kardborre..nn.1
  kardborreband_1_N = mkN "kardborreband" neutrum  ; -- kardborreband..nn.1
  kardborreknäppning_1_N = mkN "kardborreknäppning" ; -- kardborreknäppning..nn.1
  kardborrfäste_1_N = mkN "kardborrfäste" ; -- kardborrfäste..nn.1
  kardborrliknande_1_A = mkA "kardborrliknande" ; -- kardborrliknande..av.1
  kardel_1_N = mkN "kardel" "kardeler" ; -- kardel..nn.1
  kardemumma_1_N = mkN "kardemumma" ; -- kardemumma..nn.1
  kardgarn_1_N = mkN "kardgarn" neutrum  ; -- kardgarn..nn.1
  kardinal_1_N = mkN "kardinal" "kardinaler" ; -- kardinal..nn.1
  kardinalbiskop_1_N = mkN "kardinalbiskop" ; -- kardinalbiskop..nn.1
  kardinaldygd_1_N = mkN "kardinaldygd" "kardinaldygder" ; -- kardinaldygd..nn.1
  kardinalfel_1_N = mkN "kardinalfel" "kardinalfelet" "kardinalfel" "kardinalfelen" ; -- kardinalfel..nn.1
  kardinalsats_1_N = mkN "kardinalsats" "kardinalsatser" ; -- kardinalsats..nn.1
  kardinalstreck_1_N = mkN "kardinalstreck" neutrum  ; -- kardinalstreck..nn.1
  kardinalsynd_1_N = mkN "kardinalsynd" "kardinalsynder" ; -- kardinalsynd..nn.1
  kardinaltal_1_N = mkN "kardinaltal" neutrum  ; -- kardinaltal..nn.1
  kardiograf_1_N = mkN "kardiograf" "kardiografer" ; -- kardiograf..nn.1
  kardiogram_1_N = mkN "kardiogram" "kardiogrammet" "kardiogram" "kardiogrammen" ; -- kardiogram..nn.1
  kardiolog_1_N = mkN "kardiolog" "kardiologer" ; -- kardiolog..nn.1
  kardiologi_1_N = mkN "kardiologi" ; -- kardiologi..nn.1
  kardiomyopati_1_N = mkN "kardiomyopati" "kardiomyopatier" ; -- kardiomyopati..nn.1
  kardiovaskulär_1_A = mkA "kardiovaskulär" ; -- kardiovaskulär..av.1
  kardnubb_1_N = mkN "kardnubb" ; -- kardnubb..nn.1
  karduan_1_N = mkN "karduan" ; -- karduan..nn.1
  kardull_1_N = mkN "kardull" ; -- kardull..nn.1
  kardus_1_N = mkN "kardus" "karduser" ; -- kardus..nn.1
  karel_1_N = mkN "karel" "kareler" ; -- karel..nn.1
  karelare_1_N = mkN "karelare" utrum  ; -- karelare..nn.1
  karelsk_1_A = mkA "karelsk" ; -- karelsk..av.1
  karelska_1_N = mkN "karelska" ; -- karelska..nn.1
  karelska_2_N = mkN "karelska" ; -- karelska..nn.2
  karens_1_N = mkN "karens" ; -- karens..nn.1
  karensdag_1_N = mkN "karensdag" ; -- karensdag..nn.1
  karenstid_1_N = mkN "karenstid" ; -- karenstid..nn.1
  karess_1_N = mkN "karess" "karesser" ; -- karess..nn.1
  karet_1_N = mkN "karet" "kareter" ; -- karet..nn.1
  kareta_1_N = mkN "kareta" ; -- kareta..nn.1
  karg_1_A = mkA "karg" ; -- karg..av.1
  karghet_1_N = mkN "karghet" ; -- karghet..nn.1
  karibisk_1_A = mkA "karibisk" ; -- karibisk..av.1
  karies_1_N = mkN "karies" ; -- karies..nn.1
  karikatyr_1_N = mkN "karikatyr" "karikatyrer" ; -- karikatyr..nn.1
  karikatyrartad_1_A = mkA "karikatyrartad" ; -- karikatyrartad..av.1
  karikatyrbild_1_N = mkN "karikatyrbild" "karikatyrbilder" ; -- karikatyrbild..nn.1
  karikatyrmässig_1_A = mkA "karikatyrmässig" ; -- karikatyrmässig..av.1
  karikatyrmålning_1_N = mkN "karikatyrmålning" ; -- karikatyrmålning..nn.1
  karikatyrtecknare_1_N = mkN "karikatyrtecknare" utrum  ; -- karikatyrtecknare..nn.1
  karikatyrteckning_1_N = mkN "karikatyrteckning" ; -- karikatyrteckning..nn.1
  karikera_1_V = mkV "karikerar" ; -- karikera..vb.1
  karikerande_1_N = mkN "karikerande" ; -- karikerande..nn.1
  karikerbar_1_A = mkA "karikerbar" ; -- karikerbar..av.1
  karikerbarhet_1_N = mkN "karikerbarhet" ; -- karikerbarhet..nn.1
  karikering_1_N = mkN "karikering" ; -- karikering..nn.1
  karisma_1_N = mkN "karisma" "karisman" "karismer" "karismerna" ; -- karisma..nn.1
  karismasignal_1_N = mkN "karismasignal" "karismasignaler" ; -- karismasignal..nn.1
  karismatisk_1_A = mkA "karismatisk" ; -- karismatisk..av.1
  karkas_1_N = mkN "karkas" "karkaser" ; -- karkas..nn.1
  karl_1_N = mkN "karl" ; -- karl..nn.1
  karlakarl_1_N = mkN "karlakarl" ; -- karlakarl..nn.1
  karlaktig_1_A = mkA "karlaktig" ; -- karlaktig..av.1
  karlaktighet_1_N = mkN "karlaktighet" ; -- karlaktighet..nn.1
  karlansikte_1_N = mkN "karlansikte" ; -- karlansikte..nn.1
  karlatag_1_N = mkN "karlatag" neutrum  ; -- karlatag..nn.1
  karlavulen_1_A = mkA "karlavulen" ; -- karlavulen..av.1
  karlavulenhet_1_N = mkN "karlavulenhet" ; -- karlavulenhet..nn.1
  karldagsverke_1_N = mkN "karldagsverke" ; -- karldagsverke..nn.1
  karled_1_N = mkN "karled" "karleder" ; -- karled..nn.1
  karlgalen_1_A = mkA "karlgalen" ; -- karlgalen..av.1
  karlgalenhet_1_N = mkN "karlgalenhet" ; -- karlgalenhet..nn.1
  karljohan_1_N = mkN "karljohan" ; -- karljohan..nn.1
  karljohanssoffa_1_N = mkN "karljohanssoffa" ; -- karljohanssoffa..nn.1
  karljohansstil_1_N = mkN "karljohansstil" ; -- karljohansstil..nn.1
  karljohanssvamp_1_N = mkN "karljohanssvamp" ; -- karljohanssvamp..nn.1
  karlsbaderbröd_1_N = mkN "karlsbaderbröd" neutrum  ; -- karlsbaderbröd..nn.1
  karlsbadersalt_1_N = mkN "karlsbadersalt" neutrum  ; -- karlsbadersalt..nn.1
  karlslok_1_N = mkN "karlslok" ; -- karlslok..nn.1
  karlstadsbo_1_N = mkN "karlstadsbo" "karlstadsbor" ; -- karlstadsbo..nn.1
  karltokig_1_A = mkA "karltokig" ; -- karltokig..av.1
  karltokighet_1_N = mkN "karltokighet" ; -- karltokighet..nn.1
  karltorka_1_N = mkN "karltorka" ; -- karltorka..nn.1
  karltycke_1_N = mkN "karltycke" ; -- karltycke..nn.1
  karm_1_N = mkN "karm" ; -- karm..nn.1
  karmelit_1_N = mkN "karmelit" "karmeliter" ; -- karmelit..nn.1
  karmeliterorden_1_N = mkN "karmeliterorden" ; -- karmeliterorden..nn.1
  karmelitorden_1_N = mkN "karmelitorden" ; -- karmelitorden..nn.1
  karmin_1_N = mkN "karmin" ; -- karmin..nn.1
  karminröd_1_A = mkA "karminröd" "karminrött" ; -- karminröd..av.1
  karminsyra_1_N = mkN "karminsyra" ; -- karminsyra..nn.1
  karmosin_1_N = mkN "karmosin" ; -- karmosin..nn.1
  karmosinröd_1_A = mkA "karmosinröd" "karmosinrött" ; -- karmosinröd..av.1
  karmskruv_1_N = mkN "karmskruv" ; -- karmskruv..nn.1
  karmstol_1_N = mkN "karmstol" ; -- karmstol..nn.1
  karnap_1_N = mkN "karnap" neutrum  ; -- karnap..nn.1
  karnapp_1_N = mkN "karnapp" neutrum  ; -- karnapp..nn.1
  karnation_1_N = mkN "karnation" ; -- karnation..nn.1
  karneol_1_N = mkN "karneol" "karneoler" ; -- karneol..nn.1
  karneval_1_N = mkN "karneval" "karnevaler" ; -- karneval..nn.1
  karnis_1_N = mkN "karnis" "karniser" ; -- karnis..nn.1
  karnivor_1_N = mkN "karnivor" "karnivoren" "karnivorer" "karnivorerna" ; -- karnivor..nn.1
  karolin_1_N = mkN "karolin" "karoliner" ; -- karolin..nn.1
  karoling_1_N = mkN "karoling" "karolinger" ; -- karoling..nn.1
  karolingisk_1_A = mkA "karolingisk" ; -- karolingisk..av.1
  karolinsk_1_A = mkA "karolinsk" ; -- karolinsk..av.1
  kaross_1_N = mkN "kaross" "karosser" ; -- kaross..nn.1
  karosseri_1_N = mkN "karosseri" "karosseriet" "karosserier" "karosserierna" ; -- karosseri..nn.1
  karotin_1_N = mkN "karotin" "karotinet" "karotiner" "karotinerna" ; -- karotin..nn.1
  karott_1_N = mkN "karott" "karotter" ; -- karott..nn.1
  karottunderlägg_1_N = mkN "karottunderlägg" neutrum  ; -- karottunderlägg..nn.1
  karp_1_N = mkN "karp" ; -- karp..nn.1
  karpaltunnelsyndrom_1_N = mkN "karpaltunnelsyndrom" neutrum  ; -- karpaltunnelsyndrom..nn.1
  karpfisk_1_N = mkN "karpfisk" ; -- karpfisk..nn.1
  karriär_1_N = mkN "karriär" "karriärer" ; -- karriär..nn.1
  karriärdiplomat_1_N = mkN "karriärdiplomat" "karriärdiplomater" ; -- karriärdiplomat..nn.1
  karriärförsäkring_1_N = mkN "karriärförsäkring" ; -- karriärförsäkring..nn.1
  karriärism_1_N = mkN "karriärism" "karriärismer" ; -- karriärism..nn.1
  karriärist_1_N = mkN "karriärist" "karriärister" ; -- karriärist..nn.1
  karriäristisk_1_A = mkA "karriäristisk" ; -- karriäristisk..av.1
  karriärlysten_1_A = mkA "karriärlysten" ; -- karriärlysten..av.1
  karriärlystenhet_1_N = mkN "karriärlystenhet" ; -- karriärlystenhet..nn.1
  karriärlystnad_1_N = mkN "karriärlystnad" ; -- karriärlystnad..nn.1
  karriärmässig_1_A = mkA "karriärmässig" ; -- karriärmässig..av.1
  karriärplanering_1_N = mkN "karriärplanering" ; -- karriärplanering..nn.1
  karriärstege_1_N = mkN "karriärstege" utrum  ; -- karriärstege..nn.1
  karriärtips_1_N = mkN "karriärtips" neutrum  ; -- karriärtips..nn.1
  karriärväg_1_N = mkN "karriärväg" ; -- karriärväg..nn.1
  karriärväxla_1_V = mkV "karriärväxlar" ; -- karriärväxla..vb.1
  karriärväxlande_1_N = mkN "karriärväxlande" ; -- karriärväxlande..nn.1
  karriärväxling_1_N = mkN "karriärväxling" ; -- karriärväxling..nn.1
  karronad_1_N = mkN "karronad" "karronader" ; -- karronad..nn.1
  karré_1_N = mkN "karré" "karréer" ; -- karré..nn.1
  karsk_1_A = mkA "karsk" ; -- karsk..av.1
  karskhet_1_N = mkN "karskhet" ; -- karskhet..nn.1
  karst_1_N = mkN "karst" "karster" ; -- karst..nn.1
  karstbildning_1_N = mkN "karstbildning" ; -- karstbildning..nn.1
  kart_1_N = mkN "kart" ; -- kart..nn.1
  karta_1_N = mkN "karta" ; -- karta..nn.1
  kartagisk_1_A = mkA "kartagisk" ; -- kartagisk..av.1
  kartanteckning_1_N = mkN "kartanteckning" ; -- kartanteckning..nn.1
  kartbild_1_N = mkN "kartbild" "kartbilder" ; -- kartbild..nn.1
  kartbok_1_N = mkN "kartbok" "kartböcker" ; -- kartbok..nn.1
  kartell_1_N = mkN "kartell" "karteller" ; -- kartell..nn.1
  kartellbildning_1_N = mkN "kartellbildning" ; -- kartellbildning..nn.1
  kartellmässig_1_A = mkA "kartellmässig" ; -- kartellmässig..av.1
  kartera_1_V = mkV "karterar" ; -- kartera..vb.1
  karterande_1_N = mkN "karterande" ; -- karterande..nn.1
  karterbar_1_A = mkA "karterbar" ; -- karterbar..av.1
  karterbarhet_1_N = mkN "karterbarhet" ; -- karterbarhet..nn.1
  kartering_1_N = mkN "kartering" ; -- kartering..nn.1
  kartesch_1_N = mkN "kartesch" "kartescher" ; -- kartesch..nn.1
  karteschkula_1_N = mkN "karteschkula" ; -- karteschkula..nn.1
  kartig_1_A = mkA "kartig" ; -- kartig..av.1
  kartighet_1_N = mkN "kartighet" ; -- kartighet..nn.1
  kartlampa_1_N = mkN "kartlampa" ; -- kartlampa..nn.1
  kartlägga_1_V = mkV "kartlägga" "kartla" "kartlagt" ; -- kartlägga..vb.1
  kartläggande_1_N = mkN "kartläggande" ; -- kartläggande..nn.1
  kartläggning_1_N = mkN "kartläggning" ; -- kartläggning..nn.1
  kartläsare_1_N = mkN "kartläsare" utrum  ; -- kartläsare..nn.1
  kartläsarlampa_1_N = mkN "kartläsarlampa" ; -- kartläsarlampa..nn.1
  kartläsning_1_N = mkN "kartläsning" ; -- kartläsning..nn.1
  kartmätare_1_N = mkN "kartmätare" utrum  ; -- kartmätare..nn.1
  kartnagel_1_N = mkN "kartnagel" ; -- kartnagel..nn.1
  kartograf_1_N = mkN "kartograf" "kartografer" ; -- kartograf..nn.1
  kartografi_1_N = mkN "kartografi" ; -- kartografi..nn.1
  kartografisk_1_A = mkA "kartografisk" ; -- kartografisk..av.1
  kartong_1_N = mkN "kartong" "kartonger" ; -- kartong..nn.1
  kartong_2_N = mkN "kartong" ; -- kartong..nn.2
  kartongblad_1_N = mkN "kartongblad" neutrum  ; -- kartongblad..nn.1
  kartongbruk_1_N = mkN "kartongbruk" neutrum  ; -- kartongbruk..nn.1
  kartonist_1_N = mkN "kartonist" "kartonister" ; -- kartonist..nn.1
  kartonnage_1_N = mkN "kartonnage" ; -- kartonnage..nn.1
  kartonnera_1_V = mkV "kartonnerar" ; -- kartonnera..vb.1
  kartonnerande_1_N = mkN "kartonnerande" ; -- kartonnerande..nn.1
  kartonnerbar_1_A = mkA "kartonnerbar" ; -- kartonnerbar..av.1
  kartonnerbarhet_1_N = mkN "kartonnerbarhet" ; -- kartonnerbarhet..nn.1
  kartonnering_1_N = mkN "kartonnering" ; -- kartonnering..nn.1
  kartotek_1_N = mkN "kartotek" neutrum  ; -- kartotek..nn.1
  kartotekslåda_1_N = mkN "kartotekslåda" ; -- kartotekslåda..nn.1
  kartprojektion_1_N = mkN "kartprojektion" ; -- kartprojektion..nn.1
  kartritare_1_N = mkN "kartritare" utrum  ; -- kartritare..nn.1
  kartritartradition_1_N = mkN "kartritartradition" ; -- kartritartradition..nn.1
  kartspecial_1_N = mkN "kartspecial" "kartspecialer" ; -- kartspecial..nn.1
  karttecken_1_N = mkN "karttecken" "karttecknet" "karttecken" "karttecknen" ; -- karttecken..nn.1
  kartusch_1_N = mkN "kartusch" "kartuscher" ; -- kartusch..nn.1
  kartusian_1_N = mkN "kartusian" "kartusianer" ; -- kartusian..nn.1
  kartusianerorden_1_N = mkN "kartusianerorden" ; -- kartusianerorden..nn.1
  kartusianorden_1_N = mkN "kartusianorden" ; -- kartusianorden..nn.1
  karusell_1_N = mkN "karusell" "karuseller" ; -- karusell..nn.1
  karusellhäst_1_N = mkN "karusellhäst" ; -- karusellhäst..nn.1
  karusellåkning_1_N = mkN "karusellåkning" ; -- karusellåkning..nn.1
  karva_1_V = mkV "karvar" ; -- karva..vb.1
  karvande_1_N = mkN "karvande" ; -- karvande..nn.1
  karvsnitt_1_N = mkN "karvsnitt" neutrum  ; -- karvsnitt..nn.1
  karvstock_1_N = mkN "karvstock" ; -- karvstock..nn.1
  karyatid_1_N = mkN "karyatid" "karyatider" ; -- karyatid..nn.1
  kasa_1_V = mkV "kasar" ; -- kasa..vb.1
  kasack_1_N = mkN "kasack" "kasacker" ; -- kasack..nn.1
  kasande_1_N = mkN "kasande" ; -- kasande..nn.1
  kaschmir_1_N = mkN "kaschmir" ; -- kaschmir..nn.1
  kaschmirsjal_1_N = mkN "kaschmirsjal" ; -- kaschmirsjal..nn.1
  kaschmirtröja_1_N = mkN "kaschmirtröja" ; -- kaschmirtröja..nn.1
  kase_1_N = mkN "kas" ; -- kase..nn.1
  kasein_1_N = mkN "kasein" "kaseiner" ; -- kasein..nn.1
  kasematt_1_N = mkN "kasematt" "kasematter" ; -- kasematt..nn.1
  kasern_1_N = mkN "kasern" "kaserner" ; -- kasern..nn.1
  kasernförbud_1_N = mkN "kasernförbud" neutrum  ; -- kasernförbud..nn.1
  kaserngård_1_N = mkN "kaserngård" ; -- kaserngård..nn.1
  kashmir_1_N = mkN "kashmir" "kashmirer" ; -- kashmir..nn.1
  kashmirsjal_1_N = mkN "kashmirsjal" ; -- kashmirsjal..nn.1
  kashmirtröja_1_N = mkN "kashmirtröja" ; -- kashmirtröja..nn.1
  kasino_1_N = mkN "kasino" "kasinot" "kasinon" "kasinona" ; -- kasino..nn.1
  kasjub_1_N = mkN "kasjub" "kasjuber" ; -- kasjub..nn.1
  kasjunöt_1_N = mkN "kasjunöt" "kasjunötter" ; -- kasjunöt..nn.1
  kask_1_N = mkN "kask" ; -- kask..nn.1
  kaskad_1_N = mkN "kaskad" "kaskader" ; -- kaskad..nn.1
  kaskadkoppla_1_V = mkV "kaskadkopplar" ; -- kaskadkoppla..vb.1
  kaskadkopplande_1_N = mkN "kaskadkopplande" ; -- kaskadkopplande..nn.1
  kaskadkoppling_1_N = mkN "kaskadkoppling" ; -- kaskadkoppling..nn.1
  kaskelot_1_N = mkN "kaskelot" "kaskeloter" ; -- kaskelot..nn.1
  kaskelott_1_N = mkN "kaskelott" "kaskelotter" ; -- kaskelott..nn.1
  kaskett_1_N = mkN "kaskett" "kasketter" ; -- kaskett..nn.1
  kasko_1_N = mkN "kasko" "kaskot" "kaskon" "kaskona" ; -- kasko..nn.1
  kaskoförsäkring_1_N = mkN "kaskoförsäkring" ; -- kaskoförsäkring..nn.1
  kasper_1_N = mkN "kasper" ; -- kasper..nn.1
  kasperdocka_1_N = mkN "kasperdocka" ; -- kasperdocka..nn.1
  kasperteater_1_N = mkN "kasperteater" ; -- kasperteater..nn.1
  kass_1_A = mkA "kass" ; -- kass..av.1
  kassa_1_N = mkN "kassa" ; -- kassa..nn.1
  kassa_2_N = mkN "kassa" ; -- kassa..nn.2
  kassaaffär_1_N = mkN "kassaaffär" "kassaaffärer" ; -- kassaaffär..nn.1
  kassaapparat_1_N = mkN "kassaapparat" "kassaapparater" ; -- kassaapparat..nn.1
  kassabalans_1_N = mkN "kassabalans" ; -- kassabalans..nn.1
  kassabehållning_1_N = mkN "kassabehållning" ; -- kassabehållning..nn.1
  kassabel_1_A = mkA "kassabel" ; -- kassabel..av.1
  kassabok_1_N = mkN "kassabok" "kassaböcker" ; -- kassabok..nn.1
  kassabrist_1_N = mkN "kassabrist" "kassabrister" ; -- kassabrist..nn.1
  kassadirektör_1_N = mkN "kassadirektör" "kassadirektörer" ; -- kassadirektör..nn.1
  kassaförvaltare_1_N = mkN "kassaförvaltare" utrum  ; -- kassaförvaltare..nn.1
  kassakista_1_N = mkN "kassakista" ; -- kassakista..nn.1
  kassaklirr_1_N = mkN "kassaklirr" neutrum  ; -- kassaklirr..nn.1
  kassako_1_N = mkN "kassako" "kassakor" ; -- kassako..nn.1
  kassakontor_1_N = mkN "kassakontor" neutrum  ; -- kassakontor..nn.1
  kassakontrollapparat_1_N = mkN "kassakontrollapparat" "kassakontrollapparater" ; -- kassakontrollapparat..nn.1
  kassakreditiv_1_N = mkN "kassakreditiv" neutrum  ; -- kassakreditiv..nn.1
  kassakvitto_1_N = mkN "kassakvitto" "kassakvittot" "kassakvitton" "kassakvittona" ; -- kassakvitto..nn.1
  kassakö_1_N = mkN "kassakö" "kassakön" "kassaköer" "kassaköerna" ; -- kassakö..nn.1
  kassaköp_1_N = mkN "kassaköp" neutrum  ; -- kassaköp..nn.1
  kassalåda_1_N = mkN "kassalåda" ; -- kassalåda..nn.1
  kassamässig_1_A = mkA "kassamässig" ; -- kassamässig..av.1
  kassandrarop_1_N = mkN "kassandrarop" neutrum  ; -- kassandrarop..nn.1
  kassapjäs_1_N = mkN "kassapjäs" "kassapjäser" ; -- kassapjäs..nn.1
  kassarabatt_1_N = mkN "kassarabatt" "kassarabatter" ; -- kassarabatt..nn.1
  kassareserv_1_N = mkN "kassareserv" "kassareserver" ; -- kassareserv..nn.1
  kassaskrin_1_N = mkN "kassaskrin" neutrum  ; -- kassaskrin..nn.1
  kassaskåp_1_N = mkN "kassaskåp" neutrum  ; -- kassaskåp..nn.1
  kassaskåpssprängare_1_N = mkN "kassaskåpssprängare" utrum  ; -- kassaskåpssprängare..nn.1
  kassation_1_N = mkN "kassation" ; -- kassation..nn.1
  kassationsdomstol_1_N = mkN "kassationsdomstol" ; -- kassationsdomstol..nn.1
  kassava_1_N = mkN "kassava" ; -- kassava..nn.1
  kassavalv_1_N = mkN "kassavalv" neutrum  ; -- kassavalv..nn.1
  kasse_1_N = mkN "kasse" utrum  ; -- kasse..nn.1
  kasseler_1_N = mkN "kasseler" ; -- kasseler..nn.1
  kassera_1_V = mkV "kasserar" ; -- kassera..vb.1
  kasserande_1_N = mkN "kasserande" ; -- kasserande..nn.1
  kasserbar_1_A = mkA "kasserbar" ; -- kasserbar..av.1
  kasserbarhet_1_N = mkN "kasserbarhet" ; -- kasserbarhet..nn.1
  kassering_1_N = mkN "kassering" ; -- kassering..nn.1
  kassett_1_N = mkN "kassett" "kassetter" ; -- kassett..nn.1
  kassettband_1_N = mkN "kassettband" neutrum  ; -- kassettband..nn.1
  kassettbandspelare_1_N = mkN "kassettbandspelare" utrum  ; -- kassettbandspelare..nn.1
  kassettdäck_1_N = mkN "kassettdäck" neutrum  ; -- kassettdäck..nn.1
  kassettradio_1_N = mkN "kassettradio" ; -- kassettradio..nn.1
  kasshet_1_N = mkN "kasshet" ; -- kasshet..nn.1
  kassler_1_N = mkN "kassler" ; -- kassler..nn.1
  kassun_1_N = mkN "kassun" "kassuner" ; -- kassun..nn.1
  kassunsjuka_1_N = mkN "kassunsjuka" ; -- kassunsjuka..nn.1
  kassör_1_N = mkN "kassör" "kassörer" ; -- kassör..nn.1
  kassörska_1_N = mkN "kassörska" ; -- kassörska..nn.1
  kast_1_N = mkN "kast" "kaster" ; -- kast..nn.1
  kast_2_N = mkN "kast" neutrum  ; -- kast..nn.2
  kasta_1_V = mkV "kastar" ; -- kasta..vb.1
  kasta_2_V = mkV "kastar" ; -- kasta..vb.2
  kastal_1_N = mkN "kastal" "kastaler" ; -- kastal..nn.1
  kastande_1_N = mkN "kastande" ; -- kastande..nn.1
  kastanj_1_N = mkN "kastanj" "kastanjer" ; -- kastanj..nn.1
  kastanjbrun_1_A = mkA "kastanjbrun" ; -- kastanjbrun..av.1
  kastanje_1_N = mkN "kastanje" "kastanjer" ; -- kastanje..nn.1
  kastanjebrun_1_A = mkA "kastanjebrun" ; -- kastanjebrun..av.1
  kastanjeträd_1_N = mkN "kastanjeträd" neutrum  ; -- kastanjeträd..nn.1
  kastanjett_1_N = mkN "kastanjett" "kastanjetter" ; -- kastanjett..nn.1
  kastbana_1_N = mkN "kastbana" ; -- kastbana..nn.1
  kastblock_1_N = mkN "kastblock" neutrum  ; -- kastblock..nn.1
  kastby_1_N = mkN "kastby" "kastbyn" "kastbyar" "kastbyarna" ; -- kastby..nn.1
  kastbyte_1_N = mkN "kastbyte" ; -- kastbyte..nn.1
  kasteld_1_N = mkN "kasteld" ; -- kasteld..nn.1
  kastell_1_N = mkN "kastell" neutrum  ; -- kastell..nn.1
  kastellan_1_N = mkN "kastellan" "kastellaner" ; -- kastellan..nn.1
  kastilian_1_N = mkN "kastilian" "kastilianer" ; -- kastilian..nn.1
  kastilianare_1_N = mkN "kastilianare" utrum  ; -- kastilianare..nn.1
  kastiliansk_1_A = mkA "kastiliansk" ; -- kastiliansk..av.1
  kastilianska_1_N = mkN "kastilianska" ; -- kastilianska..nn.1
  kastilianska_2_N = mkN "kastilianska" ; -- kastilianska..nn.2
  kastiljanska_1_N = mkN "kastiljanska" ; -- kastiljanska..nn.1
  kastindelning_1_N = mkN "kastindelning" ; -- kastindelning..nn.1
  kastlös_1_A = mkA "kastlös" ; -- kastlös..av.1
  kastlöshet_1_N = mkN "kastlöshet" ; -- kastlöshet..nn.1
  kastmaskin_1_N = mkN "kastmaskin" "kastmaskiner" ; -- kastmaskin..nn.1
  kastmärke_1_N = mkN "kastmärke" ; -- kastmärke..nn.1
  kastning_1_N = mkN "kastning" ; -- kastning..nn.1
  kastor_1_N = mkN "kastor" ; -- kastor..nn.1
  kastpjäs_1_N = mkN "kastpjäs" "kastpjäser" ; -- kastpjäs..nn.1
  kastrat_1_N = mkN "kastrat" "kastrater" ; -- kastrat..nn.1
  kastratsång_1_N = mkN "kastratsång" ; -- kastratsång..nn.1
  kastratsångare_1_N = mkN "kastratsångare" utrum  ; -- kastratsångare..nn.1
  kastrera_1_V = mkV "kastrerar" ; -- kastrera..vb.1
  kastrerande_1_N = mkN "kastrerande" ; -- kastrerande..nn.1
  kastrerbar_1_A = mkA "kastrerbar" ; -- kastrerbar..av.1
  kastrerbarhet_1_N = mkN "kastrerbarhet" ; -- kastrerbarhet..nn.1
  kastrering_1_N = mkN "kastrering" ; -- kastrering..nn.1
  kastrull_1_N = mkN "kastrull" "kastruller" ; -- kastrull..nn.1
  kastsjuka_1_N = mkN "kastsjuka" ; -- kastsjuka..nn.1
  kastskydd_1_N = mkN "kastskydd" neutrum  ; -- kastskydd..nn.1
  kastspjut_1_N = mkN "kastspjut" neutrum  ; -- kastspjut..nn.1
  kastspö_1_N = mkN "kastspö" "kastspöt" "kastspön" "kastspöna" ; -- kastspö..nn.1
  kaststygn_1_N = mkN "kaststygn" neutrum  ; -- kaststygn..nn.1
  kastsystem_1_N = mkN "kastsystem" neutrum  ; -- kastsystem..nn.1
  kastsöm_1_N = mkN "kastsöm" "kastsömmen" "kastsömmar" "kastsömmarna" ; -- kastsöm..nn.1
  kastträ_1_N = mkN "kastträ" "kastträt" "kastträn" "kastträna" ; -- kastträ..nn.1
  kastvapen_1_N = mkN "kastvapen" "kastvapnet" "kastvapen" "kastvapnen" ; -- kastvapen..nn.1
  kastvind_1_N = mkN "kastvind" ; -- kastvind..nn.1
  kastväsen_1_N = mkN "kastväsen" neutrum  ; -- kastväsen..nn.1
  kasuar_1_N = mkN "kasuar" "kasuarer" ; -- kasuar..nn.1
  kasuell_1_A = mkA "kasuell" ; -- kasuell..av.1
  kasuistik_1_N = mkN "kasuistik" ; -- kasuistik..nn.1
  kasun_1_N = mkN "kasun" "kasuner" ; -- kasun..nn.1
  kasunsjuka_1_N = mkN "kasunsjuka" ; -- kasunsjuka..nn.1
  kasus_1_N = mkN "kasus" neutrum  ; -- kasus..nn.1
  kasus_2_N = mkN "kasus" "kasus" "kasus" "kasusen" ; -- kasus..nn.2
  kasusanvändning_1_N = mkN "kasusanvändning" ; -- kasusanvändning..nn.1
  kasuslära_1_N = mkN "kasuslära" ; -- kasuslära..nn.1
  kasusspråk_1_N = mkN "kasusspråk" neutrum  ; -- kasusspråk..nn.1
  kat_1_N = mkN "kat" ; -- kat..nn.1
  katabatisk_1_A = mkA "katabatisk" ; -- katabatisk..av.1
  katadrom_1_A = mkA "katadrom" ; -- katadrom..av.1
  katafalk_1_N = mkN "katafalk" "katafalker" ; -- katafalk..nn.1
  kataforisk_1_A = mkA "kataforisk" ; -- kataforisk..av.1
  katakomb_1_N = mkN "katakomb" "katakomber" ; -- katakomb..nn.1
  katakres_1_N = mkN "katakres" "katakreser" ; -- katakres..nn.1
  katalan_1_N = mkN "katalan" "katalaner" ; -- katalan..nn.1
  katalansk_1_A = mkA "katalansk" ; -- katalansk..av.1
  katalanska_1_N = mkN "katalanska" ; -- katalanska..nn.1
  katalanska_2_N = mkN "katalanska" ; -- katalanska..nn.2
  katalektisk_1_A = mkA "katalektisk" ; -- katalektisk..av.1
  katalepsi_1_N = mkN "katalepsi" "katalepsier" ; -- katalepsi..nn.1
  kataleptisk_1_A = mkA "kataleptisk" ; -- kataleptisk..av.1
  katalog_1_N = mkN "katalog" "kataloger" ; -- katalog..nn.1
  katalogföretag_1_N = mkN "katalogföretag" neutrum  ; -- katalogföretag..nn.1
  katalogisera_1_V = mkV "katalogiserar" ; -- katalogisera..vb.1
  katalogiserande_1_N = mkN "katalogiserande" ; -- katalogiserande..nn.1
  katalogiserbar_1_A = mkA "katalogiserbar" ; -- katalogiserbar..av.1
  katalogiserbarhet_1_N = mkN "katalogiserbarhet" ; -- katalogiserbarhet..nn.1
  katalogisering_1_N = mkN "katalogisering" ; -- katalogisering..nn.1
  kataloglåda_1_N = mkN "kataloglåda" ; -- kataloglåda..nn.1
  katalognummer_1_N = mkN "katalognummer" neutrum  ; -- katalognummer..nn.1
  katalogpris_1_N = mkN "katalogpris" neutrum  ; -- katalogpris..nn.1
  katalys_1_N = mkN "katalys" ; -- katalys..nn.1
  katalysator_1_N = mkN "katalysator" "katalysatorer" ; -- katalysator..nn.1
  katalysera_1_V = mkV "katalyserar" ; -- katalysera..vb.1
  katalyserande_1_N = mkN "katalyserande" ; -- katalyserande..nn.1
  katalyserbar_1_A = mkA "katalyserbar" ; -- katalyserbar..av.1
  katalyserbarhet_1_N = mkN "katalyserbarhet" ; -- katalyserbarhet..nn.1
  katalysering_1_N = mkN "katalysering" ; -- katalysering..nn.1
  katalytisk_1_A = mkA "katalytisk" ; -- katalytisk..av.1
  katamaran_1_N = mkN "katamaran" "katamaraner" ; -- katamaran..nn.1
  katapult_1_N = mkN "katapult" "katapulter" ; -- katapult..nn.1
  katapultstol_1_N = mkN "katapultstol" ; -- katapultstol..nn.1
  katarakt_1_N = mkN "katarakt" "katarakter" ; -- katarakt..nn.1
  katarr_1_N = mkN "katarr" "katarrer" ; -- katarr..nn.1
  katastrof_1_N = mkN "katastrof" "katastrofer" ; -- katastrof..nn.1
  katastrofal_1_A = mkA "katastrofal" ; -- katastrofal..av.1
  katastrofdrabbad_1_A = mkA "katastrofdrabbad" ; -- katastrofdrabbad..av.1
  katastroffilm_1_N = mkN "katastroffilm" "katastroffilmer" ; -- katastroffilm..nn.1
  katastrofhantering_1_N = mkN "katastrofhantering" ; -- katastrofhantering..nn.1
  katastrofhanteringsmyndighet_1_N = mkN "katastrofhanteringsmyndighet" "katastrofhanteringsmyndigheter" ; -- katastrofhanteringsmyndighet..nn.1
  katastrofkänsla_1_N = mkN "katastrofkänsla" ; -- katastrofkänsla..nn.1
  katastroflarm_1_N = mkN "katastroflarm" neutrum  ; -- katastroflarm..nn.1
  katastrofläge_1_N = mkN "katastrofläge" ; -- katastrofläge..nn.1
  katastrofsceneri_1_N = mkN "katastrofsceneri" "katastrofsceneriet" "katastrofscenerier" "katastrofscenerierna" ; -- katastrofsceneri..nn.1
  katastrofsiffra_1_N = mkN "katastrofsiffra" ; -- katastrofsiffra..nn.1
  katastrofsituation_1_N = mkN "katastrofsituation" ; -- katastrofsituation..nn.1
  katastrofteori_1_N = mkN "katastrofteori" "katastrofteorier" ; -- katastrofteori..nn.1
  katastroftillstånd_1_N = mkN "katastroftillstånd" neutrum  ; -- katastroftillstånd..nn.1
  katastrofval_1_N = mkN "katastrofval" neutrum  ; -- katastrofval..nn.1
  katastrofvarning_1_N = mkN "katastrofvarning" ; -- katastrofvarning..nn.1
  katatoni_1_N = mkN "katatoni" ; -- katatoni..nn.1
  kateder_1_N = mkN "kateder" ; -- kateder..nn.1
  katedersocialism_1_N = mkN "katedersocialism" "katedersocialismer" ; -- katedersocialism..nn.1
  katedersocialistisk_1_A = mkA "katedersocialistisk" ; -- katedersocialistisk..av.1
  katederundervisning_1_N = mkN "katederundervisning" ; -- katederundervisning..nn.1
  katedral_1_N = mkN "katedral" "katedraler" ; -- katedral..nn.1
  katedralbygge_1_N = mkN "katedralbygge" ; -- katedralbygge..nn.1
  katedralsklocka_1_N = mkN "katedralsklocka" ; -- katedralsklocka..nn.1
  katedralskola_1_N = mkN "katedralskola" ; -- katedralskola..nn.1
  kategori_1_N = mkN "kategori" "kategorier" ; -- kategori..nn.1
  kategoriklyvning_1_N = mkN "kategoriklyvning" ; -- kategoriklyvning..nn.1
  kategorisera_1_V = mkV "kategoriserar" ; -- kategorisera..vb.1
  kategoriserande_1_N = mkN "kategoriserande" ; -- kategoriserande..nn.1
  kategoriserbar_1_A = mkA "kategoriserbar" ; -- kategoriserbar..av.1
  kategoriserbarhet_1_N = mkN "kategoriserbarhet" ; -- kategoriserbarhet..nn.1
  kategorisering_1_N = mkN "kategorisering" ; -- kategorisering..nn.1
  kategoriseringsarbete_1_N = mkN "kategoriseringsarbete" ; -- kategoriseringsarbete..nn.1
  kategorisk_1_A = mkA "kategorisk" ; -- kategorisk..av.1
  katekes_1_N = mkN "katekes" "katekeser" ; -- katekes..nn.1
  katekesstycke_1_N = mkN "katekesstycke" ; -- katekesstycke..nn.1
  kateket_1_N = mkN "kateket" "kateketer" ; -- kateket..nn.1
  kateketisk_1_A = mkA "kateketisk" ; -- kateketisk..av.1
  katet_1_N = mkN "katet" "kateter" ; -- katet..nn.1
  kateter_1_N = mkN "kateter" ; -- kateter..nn.1
  kateterisera_1_V = mkV "kateteriserar" ; -- kateterisera..vb.1
  kateteriserande_1_N = mkN "kateteriserande" ; -- kateteriserande..nn.1
  kateteriserbar_1_A = mkA "kateteriserbar" ; -- kateteriserbar..av.1
  kateteriserbarhet_1_N = mkN "kateteriserbarhet" ; -- kateteriserbarhet..nn.1
  kateterisering_1_N = mkN "kateterisering" ; -- kateterisering..nn.1
  katetrisera_1_V = mkV "katetriserar" ; -- katetrisera..vb.1
  katetriserande_1_N = mkN "katetriserande" ; -- katetriserande..nn.1
  katetriserbar_1_A = mkA "katetriserbar" ; -- katetriserbar..av.1
  katetriserbarhet_1_N = mkN "katetriserbarhet" ; -- katetriserbarhet..nn.1
  katetrisering_1_N = mkN "katetrisering" ; -- katetrisering..nn.1
  katgut_1_N = mkN "katgut" ; -- katgut..nn.1
  katharsis_1_N = mkN "katharsis" ; -- katharsis..nn.1
  katharsiseffekt_1_N = mkN "katharsiseffekt" "katharsiseffekter" ; -- katharsiseffekt..nn.1
  katig_1_A = mkA "katig" ; -- katig..av.1
  katighet_1_N = mkN "katighet" ; -- katighet..nn.1
  katjon_1_N = mkN "katjon" "katjoner" ; -- katjon..nn.1
  katod_1_N = mkN "katod" "katoder" ; -- katod..nn.1
  katodstråle_1_N = mkN "katodstråle" utrum  ; -- katodstråle..nn.1
  katodstrålerör_1_N = mkN "katodstrålerör" neutrum  ; -- katodstrålerör..nn.1
  katolicism_1_N = mkN "katolicism" "katolicismer" ; -- katolicism..nn.1
  katolik_1_N = mkN "katolik" "katoliker" ; -- katolik..nn.1
  katolsk_1_A = mkA "katolsk" ; -- katolsk..av.1
  katrinplommon_1_N = mkN "katrinplommon" neutrum  ; -- katrinplommon..nn.1
  katsa_1_N = mkN "katsa" ; -- katsa..nn.1
  katse_1_N = mkN "katse" utrum  ; -- katse..nn.1
  katt_1_N = mkN "katt" "katter" ; -- katt..nn.1
  katt_2_N = mkN "katt" ; -- katt..nn.2
  katta_1_N = mkN "katta" ; -- katta..nn.1
  katta_1_V = mkV "kattar" ; -- katta..vb.1
  kattaktig_1_A = mkA "kattaktig" ; -- kattaktig..av.1
  kattaktighet_1_N = mkN "kattaktighet" ; -- kattaktighet..nn.1
  kattande_1_N = mkN "kattande" ; -- kattande..nn.1
  kattass_1_N = mkN "kattass" ; -- kattass..nn.1
  kattblick_1_N = mkN "kattblick" ; -- kattblick..nn.1
  kattdjur_1_N = mkN "kattdjur" neutrum  ; -- kattdjur..nn.1
  kattfisk_1_N = mkN "kattfisk" ; -- kattfisk..nn.1
  kattfot_1_N = mkN "kattfot" ; -- kattfot..nn.1
  kattgina_1_N = mkN "kattgina" ; -- kattgina..nn.1
  kattguld_1_N = mkN "kattguld" neutrum  ; -- kattguld..nn.1
  katthår_1_N = mkN "katthår" neutrum  ; -- katthår..nn.1
  kattlik_1_A = mkA "kattlik" ; -- kattlik..av.1
  kattlik_1_N = mkN "kattlik" neutrum  ; -- kattlik..nn.1
  kattlucka_1_N = mkN "kattlucka" ; -- kattlucka..nn.1
  kattmat_1_N = mkN "kattmat" ; -- kattmat..nn.1
  kattmynta_1_N = mkN "kattmynta" ; -- kattmynta..nn.1
  kattoalett_1_N = mkN "kattoalett" "kattoaletter" ; -- kattoalett..nn.1
  kattost_1_N = mkN "kattost" ; -- kattost..nn.1
  kattpensionat_1_N = mkN "kattpensionat" neutrum  ; -- kattpensionat..nn.1
  kattpest_1_N = mkN "kattpest" ; -- kattpest..nn.1
  kattrakande_1_N = mkN "kattrakande" ; -- kattrakande..nn.1
  kattras_1_N = mkN "kattras" "kattraser" ; -- kattras..nn.1
  kattrygg_1_N = mkN "kattrygg" ; -- kattrygg..nn.1
  kattsand_1_N = mkN "kattsand" ; -- kattsand..nn.1
  kattsilver_1_N = mkN "kattsilver" neutrum  ; -- kattsilver..nn.1
  kattskit_1_N = mkN "kattskit" ; -- kattskit..nn.1
  kattuggla_1_N = mkN "kattuggla" ; -- kattuggla..nn.1
  kattun_1_N = mkN "kattun" "kattuner" ; -- kattun..nn.1
  kattunge_1_N = mkN "kattunge" utrum  ; -- kattunge..nn.1
  kattvind_1_N = mkN "kattvind" ; -- kattvind..nn.1
  kattöga_1_N = mkN "kattöga" "kattögat" "kattögon" "kattögonen" ; -- kattöga..nn.1
  kaukasier_1_N = mkN "kaukasier" "kaukasiern" "kaukasier" "kaukasierna" ; -- kaukasier..nn.1
  kaukasisk_1_A = mkA "kaukasisk" ; -- kaukasisk..av.1
  kaukasiska_1_N = mkN "kaukasiska" ; -- kaukasiska..nn.1
  kauri_1_N = mkN "kauri" "kaurin" "kaurier" "kaurierna" ; -- kauri..nn.1
  kaus_1_N = mkN "kaus" "kauser" ; -- kaus..nn.1
  kausal_1_A = mkA "kausal" ; -- kausal..av.1
  kausalförhållande_1_N = mkN "kausalförhållande" ; -- kausalförhållande..nn.1
  kausalitet_1_N = mkN "kausalitet" "kausaliteter" ; -- kausalitet..nn.1
  kausalsammanhang_1_N = mkN "kausalsammanhang" neutrum  ; -- kausalsammanhang..nn.1
  kausalsats_1_N = mkN "kausalsats" "kausalsatser" ; -- kausalsats..nn.1
  kausativ_1_A = mkA "kausativ" ; -- kausativ..av.1
  kaustik_1_A = mkA "kaustik" ; -- kaustik..av.1
  kaustika_1_N = mkN "kaustika" ; -- kaustika..nn.1
  kauterisera_1_V = mkV "kauteriserar" ; -- kauterisera..vb.1
  kauteriserande_1_N = mkN "kauteriserande" ; -- kauteriserande..nn.1
  kauteriserbar_1_A = mkA "kauteriserbar" ; -- kauteriserbar..av.1
  kauteriserbarhet_1_N = mkN "kauteriserbarhet" ; -- kauteriserbarhet..nn.1
  kauterisering_1_N = mkN "kauterisering" ; -- kauterisering..nn.1
  kaution_1_N = mkN "kaution" ; -- kaution..nn.1
  kautschuk_1_N = mkN "kautschuk" ; -- kautschuk..nn.1
  kautschukparagraf_1_N = mkN "kautschukparagraf" "kautschukparagrafer" ; -- kautschukparagraf..nn.1
  kautschukträd_1_N = mkN "kautschukträd" neutrum  ; -- kautschukträd..nn.1
  kava_1_V = mkV "kavar" ; -- kava..vb.1
  kavaj_1_N = mkN "kavaj" "kavajer" ; -- kavaj..nn.1
  kavajficka_1_N = mkN "kavajficka" ; -- kavajficka..nn.1
  kavajkrage_1_N = mkN "kavajkrage" utrum  ; -- kavajkrage..nn.1
  kavajslag_1_N = mkN "kavajslag" neutrum  ; -- kavajslag..nn.1
  kavalett_1_N = mkN "kavalett" "kavaletter" ; -- kavalett..nn.1
  kavaljer_1_N = mkN "kavaljer" "kavaljerer" ; -- kavaljer..nn.1
  kavaljersflygel_1_N = mkN "kavaljersflygel" ; -- kavaljersflygel..nn.1
  kavalkad_1_N = mkN "kavalkad" "kavalkader" ; -- kavalkad..nn.1
  kavall_1_N = mkN "kavall" "kavaller" ; -- kavall..nn.1
  kavalleri_1_N = mkN "kavalleri" "kavalleriet" "kavallerier" "kavallerierna" ; -- kavalleri..nn.1
  kavallerianfall_1_N = mkN "kavallerianfall" neutrum  ; -- kavallerianfall..nn.1
  kavalleribyxa_1_N = mkN "kavalleribyxa" ; -- kavalleribyxa..nn.1
  kavallerichock_1_N = mkN "kavallerichock" "kavallerichocker" ; -- kavallerichock..nn.1
  kavalleriofficer_1_N = mkN "kavalleriofficer" "kavalleriofficeren" "kavalleriofficerare" "kavalleriofficerarna" ; -- kavalleriofficer..nn.1
  kavallerist_1_N = mkN "kavallerist" "kavallerister" ; -- kavallerist..nn.1
  kavalleritrupp_1_N = mkN "kavalleritrupp" "kavalleritrupper" ; -- kavalleritrupp..nn.1
  kavande_1_N = mkN "kavande" ; -- kavande..nn.1
  kavat_1_A = mkA "kavat" "kavat" ; -- kavat..av.1
  kavel_1_N = mkN "kavel" ; -- kavel..nn.1
  kavelbro_1_N = mkN "kavelbro" ; -- kavelbro..nn.1
  kaveldun_1_N = mkN "kaveldun" neutrum  ; -- kaveldun..nn.1
  kavern_1_N = mkN "kavern" "kaverner" ; -- kavern..nn.1
  kaviar_1_N = mkN "kaviar" ; -- kaviar..nn.1
  kavitation_1_N = mkN "kavitation" ; -- kavitation..nn.1
  kavitet_1_N = mkN "kavitet" "kaviteter" ; -- kavitet..nn.1
  kavitetsdjur_1_N = mkN "kavitetsdjur" neutrum  ; -- kavitetsdjur..nn.1
  kavla_1_V = mkV "kavlar" ; -- kavla..vb.1
  kavlande_1_N = mkN "kavlande" ; -- kavlande..nn.1
  kavle_1_N = mkN "kavle" utrum  ; -- kavle..nn.1
  kavling_1_N = mkN "kavling" ; -- kavling..nn.1
  kavring_1_N = mkN "kavring" ; -- kavring..nn.1
  kaxe_1_N = mkN "kaxe" utrum  ; -- kaxe..nn.1
  kaxig_1_A = mkA "kaxig" ; -- kaxig..av.1
  kaxighet_1_N = mkN "kaxighet" ; -- kaxighet..nn.1
  kazak_1_N = mkN "kazak" "kazaker" ; -- kazak..nn.1
  kazakisk_1_A = mkA "kazakisk" ; -- kazakisk..av.1
  kazakiska_1_N = mkN "kazakiska" ; -- kazakiska..nn.1
  kazakiska_2_N = mkN "kazakiska" ; -- kazakiska..nn.2
  kazoo_1_N = mkN "kazoo" "kazoon" "kazooer" "kazooerna" ; -- kazoo..nn.1
  kebab_1_N = mkN "kebab" "kebaber" ; -- kebab..nn.1
  kebabstånd_1_N = mkN "kebabstånd" neutrum  ; -- kebabstånd..nn.1
  ked_1_N = mkN "ked" "keder" ; -- ked..nn.1
  kediv_1_N = mkN "kediv" "kediver" ; -- kediv..nn.1
  kedja_1_N = mkN "kedja" ; -- kedja..nn.1
  kedja_1_V = mkV "kedjar" ; -- kedja..vb.1
  kedjande_1_N = mkN "kedjande" ; -- kedjande..nn.1
  kedjeblock_1_N = mkN "kedjeblock" neutrum  ; -- kedjeblock..nn.1
  kedjebrev_1_N = mkN "kedjebrev" neutrum  ; -- kedjebrev..nn.1
  kedjebroms_1_N = mkN "kedjebroms" ; -- kedjebroms..nn.1
  kedjebråk_1_N = mkN "kedjebråk" neutrum  ; -- kedjebråk..nn.1
  kedjeformad_1_A = mkA "kedjeformad" ; -- kedjeformad..av.1
  kedjeföring_1_N = mkN "kedjeföring" ; -- kedjeföring..nn.1
  kedjehastighet_1_N = mkN "kedjehastighet" ; -- kedjehastighet..nn.1
  kedjehjul_1_N = mkN "kedjehjul" neutrum  ; -- kedjehjul..nn.1
  kedjehus_1_N = mkN "kedjehus" neutrum  ; -- kedjehus..nn.1
  kedjelyftblock_1_N = mkN "kedjelyftblock" neutrum  ; -- kedjelyftblock..nn.1
  kedjemolekyl_1_N = mkN "kedjemolekyl" "kedjemolekyler" ; -- kedjemolekyl..nn.1
  kedjereaktion_1_N = mkN "kedjereaktion" ; -- kedjereaktion..nn.1
  kedjeröka_1_V = mkV "kedjeröker" ; -- kedjeröka..vb.1
  kedjerökande_1_N = mkN "kedjerökande" ; -- kedjerökande..nn.1
  kedjeskydd_1_N = mkN "kedjeskydd" neutrum  ; -- kedjeskydd..nn.1
  kedjespänning_1_N = mkN "kedjespänning" ; -- kedjespänning..nn.1
  kedjestygn_1_N = mkN "kedjestygn" neutrum  ; -- kedjestygn..nn.1
  kedjesåg_1_N = mkN "kedjesåg" ; -- kedjesåg..nn.1
  kedjesöm_1_N = mkN "kedjesöm" "kedjesömmen" "kedjesömmar" "kedjesömmarna" ; -- kedjesöm..nn.1
  kedjeväxel_1_N = mkN "kedjeväxel" ; -- kedjeväxel..nn.1
  keff_1_A = mkA "keff" ; -- keff..av.1
  kefir_1_N = mkN "kefir" ; -- kefir..nn.1
  kejsar_1_N = mkN "kejsar" ; -- kejsar..nn.1
  kejsardöme_1_N = mkN "kejsardöme" ; -- kejsardöme..nn.1
  kejsare_1_N = mkN "kejsare" utrum  ; -- kejsare..nn.1
  kejsarhär_1_N = mkN "kejsarhär" ; -- kejsarhär..nn.1
  kejsarinna_1_N = mkN "kejsarinna" ; -- kejsarinna..nn.1
  kejsarkrona_1_N = mkN "kejsarkrona" ; -- kejsarkrona..nn.1
  kejsarlik_1_A = mkA "kejsarlik" ; -- kejsarlik..av.1
  kejsarlikhet_1_N = mkN "kejsarlikhet" ; -- kejsarlikhet..nn.1
  kejsarpingvin_1_N = mkN "kejsarpingvin" "kejsarpingviner" ; -- kejsarpingvin..nn.1
  kejsarsnitt_1_N = mkN "kejsarsnitt" neutrum  ; -- kejsarsnitt..nn.1
  kejsarstil_1_N = mkN "kejsarstil" ; -- kejsarstil..nn.1
  kejsartron_1_N = mkN "kejsartron" "kejsartroner" ; -- kejsartron..nn.1
  kejsarörn_1_N = mkN "kejsarörn" ; -- kejsarörn..nn.1
  kejserlig_1_A = mkA "kejserlig" ; -- kejserlig..av.1
  kejserlighet_1_N = mkN "kejserlighet" ; -- kejserlighet..nn.1
  kel_1_N = mkN "kel" neutrum  ; -- kel..nn.1
  kela_1_V = mkV "kelar" ; -- kela..vb.1
  kelande_1_N = mkN "kelande" ; -- kelande..nn.1
  kelen_1_A = mkA "kelen" ; -- kelen..av.1
  kelenhet_1_N = mkN "kelenhet" ; -- kelenhet..nn.1
  kelgris_1_N = mkN "kelgris" ; -- kelgris..nn.1
  kelig_1_A = mkA "kelig" ; -- kelig..av.1
  kelighet_1_N = mkN "kelighet" ; -- kelighet..nn.1
  kelim_1_N = mkN "kelim" "kelimer" ; -- kelim..nn.1
  kelp_1_N = mkN "kelp" ; -- kelp..nn.1
  kelsjuk_1_A = mkA "kelsjuk" ; -- kelsjuk..av.1
  kelsjukhet_1_N = mkN "kelsjukhet" ; -- kelsjukhet..nn.1
  kelt_1_N = mkN "kelt" "kelter" ; -- kelt..nn.1
  keltisk_1_A = mkA "keltisk" ; -- keltisk..av.1
  keltiska_1_N = mkN "keltiska" ; -- keltiska..nn.1
  keltiska_2_N = mkN "keltiska" ; -- keltiska..nn.2
  kelvin_1_N = mkN "kelvin" "kelvinen" "kelvin" "kelvinen" ; -- kelvin..nn.1
  kem_1_N = mkN "kem" ; -- kem..nn.1
  kemi_1_N = mkN "kemi" ; -- kemi..nn.1
  kemibok_1_N = mkN "kemibok" "kemiböcker" ; -- kemibok..nn.1
  kemigrafi_1_N = mkN "kemigrafi" ; -- kemigrafi..nn.1
  kemiindustri_1_N = mkN "kemiindustri" "kemiindustrier" ; -- kemiindustri..nn.1
  kemikalie_1_N = mkN "kemikalie" "kemikalier" ; -- kemikalie..nn.1
  kemikum_1_N = mkN "kemikum" ; -- kemikum..nn.1
  kemilärare_1_N = mkN "kemilärare" utrum  ; -- kemilärare..nn.1
  kemiprofessor_1_N = mkN "kemiprofessor" "kemiprofessorer" ; -- kemiprofessor..nn.1
  kemisamhälle_1_N = mkN "kemisamhälle" ; -- kemisamhälle..nn.1
  kemisk_1_A = mkA "kemisk" ; -- kemisk..av.1
  kemist_1_N = mkN "kemist" "kemister" ; -- kemist..nn.1
  kemiteknik_1_N = mkN "kemiteknik" ; -- kemiteknik..nn.1
  kemomat_1_N = mkN "kemomat" "kemomater" ; -- kemomat..nn.1
  kemoterapi_1_N = mkN "kemoterapi" "kemoterapier" ; -- kemoterapi..nn.1
  kemtvätt_1_N = mkN "kemtvätt" ; -- kemtvätt..nn.1
  kendo_1_N = mkN "kendo" ; -- kendo..nn.1
  kennel_1_N = mkN "kennel" ; -- kennel..nn.1
  kenning_1_N = mkN "kenning" ; -- kenning..nn.1
  kenozoikum_1_N = mkN "kenozoikum" ; -- kenozoikum..nn.1
  kentaur_1_N = mkN "kentaur" "kentaurer" ; -- kentaur..nn.1
  kenyan_1_N = mkN "kenyan" "kenyaner" ; -- kenyan..nn.1
  kenyansk_1_A = mkA "kenyansk" ; -- kenyansk..av.1
  kenyanska_1_N = mkN "kenyanska" ; -- kenyanska..nn.1
  keps_1_N = mkN "keps" ; -- keps..nn.1
  keram_1_N = mkN "keram" "keramer" ; -- keram..nn.1
  keramik_1_N = mkN "keramik" ; -- keramik..nn.1
  keramiker_1_N = mkN "keramiker" "keramikern" "keramiker" "keramikerna" ; -- keramiker..nn.1
  keramikform_1_N = mkN "keramikform" ; -- keramikform..nn.1
  keramikkruka_1_N = mkN "keramikkruka" ; -- keramikkruka..nn.1
  keramiklampa_1_N = mkN "keramiklampa" ; -- keramiklampa..nn.1
  keramikskärva_1_N = mkN "keramikskärva" ; -- keramikskärva..nn.1
  keramiktomte_1_N = mkN "keramiktomte" utrum  ; -- keramiktomte..nn.1
  keramisk_1_A = mkA "keramisk" ; -- keramisk..av.1
  keratin_1_N = mkN "keratin" "keratiner" ; -- keratin..nn.1
  kerub_1_N = mkN "kerub" "keruber" ; -- kerub..nn.1
  kerubansikte_1_N = mkN "kerubansikte" ; -- kerubansikte..nn.1
  kesa_1_V = mkV "kesar" ; -- kesa..vb.1
  kesande_1_N = mkN "kesande" ; -- kesande..nn.1
  kesella_1_N = mkN "kesella" ; -- kesella..nn.1
  kesning_1_N = mkN "kesning" ; -- kesning..nn.1
  keso_1_N = mkN "keso" ; -- keso..nn.1
  ketch_1_N = mkN "ketch" "ketcher" ; -- ketch..nn.1
  ketchup_1_N = mkN "ketchup" ; -- ketchup..nn.1
  kevlar_1_N = mkN "kevlar" ; -- kevlar..nn.1
  kex_1_N = mkN "kex" neutrum  ; -- kex..nn.1
  khakifärgad_1_A = mkA "khakifärgad" ; -- khakifärgad..av.1
  khakigrön_1_A = mkA "khakigrön" ; -- khakigrön..av.1
  khan_1_N = mkN "khan" "khaner" ; -- khan..nn.1
  khanat_1_N = mkN "khanat" neutrum  ; -- khanat..nn.1
  khmer_1_N = mkN "khmer" "khmerer" ; -- khmer..nn.1
  kiasm_1_N = mkN "kiasm" "kiasmer" ; -- kiasm..nn.1
  kibbutz_1_N = mkN "kibbutz" "kibbutzer" ; -- kibbutz..nn.1
  kick_off_1_N = mkN "kick-off" ; -- kick-off..nn.1
  kick_1_N = mkN "kick" ; -- kick..nn.1
  kicka_1_N = mkN "kicka" ; -- kicka..nn.1
  kicka_1_V = mkV "kickar" ; -- kicka..vb.1
  kickande_1_N = mkN "kickande" ; -- kickande..nn.1
  kickstart_1_N = mkN "kickstart" "kickstarter" ; -- kickstart..nn.1
  kid_1_N = mkN "kid" neutrum  ; -- kid..nn.1
  kidnappa_1_V = mkV "kidnappar" ; -- kidnappa..vb.1
  kidnappande_1_N = mkN "kidnappande" ; -- kidnappande..nn.1
  kidnappare_1_N = mkN "kidnappare" utrum  ; -- kidnappare..nn.1
  kidnappning_1_N = mkN "kidnappning" ; -- kidnappning..nn.1
  kidnappningsförsök_1_N = mkN "kidnappningsförsök" neutrum  ; -- kidnappningsförsök..nn.1
  kidnappningshistoria_1_N = mkN "kidnappningshistoria" "kidnappningshistorian" "kidnappningshistorier" "kidnappningshistorierna" ; -- kidnappningshistoria..nn.1
  kika_1_V = mkV "kikar" ; -- kika..vb.1
  kikande_1_N = mkN "kikande" ; -- kikande..nn.1
  kikare_1_N = mkN "kikare" utrum  ; -- kikare..nn.1
  kikarlins_1_N = mkN "kikarlins" "kikarlinser" ; -- kikarlins..nn.1
  kikarsikte_1_N = mkN "kikarsikte" ; -- kikarsikte..nn.1
  kikhosta_1_N = mkN "kikhosta" ; -- kikhosta..nn.1
  kikhål_1_N = mkN "kikhål" neutrum  ; -- kikhål..nn.1
  kikkran_1_N = mkN "kikkran" ; -- kikkran..nn.1
  kikna_1_V = mkV "kiknar" ; -- kikna..vb.1
  kiknande_1_N = mkN "kiknande" ; -- kiknande..nn.1
  kikärt_1_N = mkN "kikärt" "kikärter" ; -- kikärt..nn.1
  kikärtsbulle_1_N = mkN "kikärtsbulle" utrum  ; -- kikärtsbulle..nn.1
  kil_1_N = mkN "kil" ; -- kil..nn.1
  kila_1_V = mkV "kilar" ; -- kila..vb.1
  kila_2_V = mkV "kilar" ; -- kila..vb.2
  kilande_1_N = mkN "kilande" ; -- kilande..nn.1
  kilben_1_N = mkN "kilben" neutrum  ; -- kilben..nn.1
  kilformig_1_A = mkA "kilformig" ; -- kilformig..av.1
  kilhäl_1_N = mkN "kilhäl" ; -- kilhäl..nn.1
  kiliasm_1_N = mkN "kiliasm" ; -- kiliasm..nn.1
  kilklack_1_N = mkN "kilklack" ; -- kilklack..nn.1
  kilklacksko_1_N = mkN "kilklacksko" "kilklackskor" ; -- kilklacksko..nn.1
  killa_1_V = mkV "killar" ; -- killa..vb.1
  killande_1_N = mkN "killande" ; -- killande..nn.1
  kille_1_N = mkN "kille" utrum  ; -- kille..nn.1
  kille_2_N = mkN "kille" utrum  ; -- kille..nn.2
  killerinstinkt_1_N = mkN "killerinstinkt" ; -- killerinstinkt..nn.1
  killespel_1_N = mkN "killespel" "killespelet" "killespel" "killespelen" ; -- killespel..nn.1
  killig_1_A = mkA "killig" ; -- killig..av.1
  killighet_1_N = mkN "killighet" ; -- killighet..nn.1
  killing_1_N = mkN "killing" ; -- killing..nn.1
  killkompis_1_N = mkN "killkompis" ; -- killkompis..nn.1
  killkärlek_1_N = mkN "killkärlek" ; -- killkärlek..nn.1
  kilo_1_N = mkN "kilo" "kilot" "kilon" "kilona" ; -- kilo..nn.1
  kilobyte_1_N = mkN "kilobyte" "kilobyten" "kilobyte" "kilobytena" ; -- kilobyte..nn.1
  kilogram_1_N = mkN "kilogram" "kilogrammet" "kilogram" "kilogrammen" ; -- kilogram..nn.1
  kilogrammeter_1_N = mkN "kilogrammeter" ; -- kilogrammeter..nn.1
  kilometer_1_N = mkN "kilometer" ; -- kilometer..nn.1
  kilometerhög_1_A = mkA "kilometerhög" ; -- kilometerhög..av.1
  kilometerlång_1_A = mkA "kilometerlång" ; -- kilometerlång..av.1
  kilometerskatt_1_N = mkN "kilometerskatt" "kilometerskatter" ; -- kilometerskatt..nn.1
  kilometerstor_1_A = mkA "kilometerstor" ; -- kilometerstor..av.1
  kilometertjock_1_A = mkA "kilometertjock" ; -- kilometertjock..av.1
  kilometervis_1_Adv = mkAdv "kilometervis" ; -- kilometervis..ab.1
  kilopond_1_N = mkN "kilopond" neutrum  ; -- kilopond..nn.1
  kilopondmeter_1_N = mkN "kilopondmeter" "kilopondmetern" "kilopondmeter" "kilopondmeterna" ; -- kilopondmeter..nn.1
  kilopris_1_N = mkN "kilopris" neutrum  ; -- kilopris..nn.1
  kiloton_1_N = mkN "kiloton" "kilotonnet" "kiloton" "kilotonnen" ; -- kiloton..nn.1
  kilovis_1_Adv = mkAdv "kilovis" ; -- kilovis..ab.1
  kilowatt_1_N = mkN "kilowatt" "kilowatten" "kilowatt" "kilowatten" ; -- kilowatt..nn.1
  kilram_1_N = mkN "kilram" ; -- kilram..nn.1
  kilrem_1_N = mkN "kilrem" "kilremmen" "kilremmar" "kilremmarna" ; -- kilrem..nn.1
  kilremsskiva_1_N = mkN "kilremsskiva" ; -- kilremsskiva..nn.1
  kilskrift_1_N = mkN "kilskrift" ; -- kilskrift..nn.1
  kilspärr_1_N = mkN "kilspärr" ; -- kilspärr..nn.1
  kilspår_1_N = mkN "kilspår" neutrum  ; -- kilspår..nn.1
  kilt_1_N = mkN "kilt" ; -- kilt..nn.1
  kimma_1_V = mkV "kimmar" ; -- kimma..vb.1
  kimmande_1_N = mkN "kimmande" ; -- kimmande..nn.1
  kimono_1_N = mkN "kimono" "kimonor" ; -- kimono..nn.1
  kimrök_1_N = mkN "kimrök" ; -- kimrök..nn.1
  kina_1_N = mkN "kina" ; -- kina..nn.1
  kinaalkaloid_1_N = mkN "kinaalkaloid" "kinaalkaloider" ; -- kinaalkaloid..nn.1
  kinabark_1_N = mkN "kinabark" ; -- kinabark..nn.1
  kinainspirerad_1_A = mkA "kinainspirerad" ; -- kinainspirerad..av.1
  kinamat_1_N = mkN "kinamat" ; -- kinamat..nn.1
  kinarestaurang_1_N = mkN "kinarestaurang" "kinarestauranger" ; -- kinarestaurang..nn.1
  kinaschack_1_N = mkN "kinaschack" neutrum  ; -- kinaschack..nn.1
  kind_1_N = mkN "kind" "kinder" ; -- kind..nn.1
  kindben_1_N = mkN "kindben" neutrum  ; -- kindben..nn.1
  kindergarten_1_N = mkN "kindergarten" ; -- kindergarten..nn.1
  kindkedja_1_N = mkN "kindkedja" ; -- kindkedja..nn.1
  kindknota_1_N = mkN "kindknota" ; -- kindknota..nn.1
  kindkota_1_N = mkN "kindkota" ; -- kindkota..nn.1
  kindpuss_1_N = mkN "kindpuss" ; -- kindpuss..nn.1
  kindpussa_1_V = mkV "kindpussar" ; -- kindpussa..vb.1
  kindpussande_1_N = mkN "kindpussande" ; -- kindpussande..nn.1
  kindpust_1_N = mkN "kindpust" ; -- kindpust..nn.1
  kindpåse_1_N = mkN "kindpåse" utrum  ; -- kindpåse..nn.1
  kindtand_1_N = mkN "kindtand" "kindtänder" ; -- kindtand..nn.1
  kinematik_1_N = mkN "kinematik" ; -- kinematik..nn.1
  kinematograf_1_N = mkN "kinematograf" "kinematografer" ; -- kinematograf..nn.1
  kines_1_N = mkN "kines" "kineser" ; -- kines..nn.1
  kinesa_1_V = mkV "kinesar" ; -- kinesa..vb.1
  kinesande_1_N = mkN "kinesande" ; -- kinesande..nn.1
  kineseri_1_N = mkN "kineseri" "kineseriet" "kineserier" "kineserierna" ; -- kineseri..nn.1
  kinesisk_1_A = mkA "kinesisk" ; -- kinesisk..av.1
  kinesiska_1_N = mkN "kinesiska" ; -- kinesiska..nn.1
  kinesiska_2_N = mkN "kinesiska" ; -- kinesiska..nn.2
  kinestetisk_1_A = mkA "kinestetisk" ; -- kinestetisk..av.1
  kinetik_1_N = mkN "kinetik" ; -- kinetik..nn.1
  kinetisk_1_A = mkA "kinetisk" ; -- kinetisk..av.1
  king_size_1_A = mkA "king-size" ; -- king-size..av.1
  kinin_1_N = mkN "kinin" ; -- kinin..nn.1
  kink_1_N = mkN "kink" ; -- kink..nn.1
  kink_2_N = mkN "kink" neutrum  ; -- kink..nn.2
  kinka_1_V = mkV "kinkar" ; -- kinka..vb.1
  kinkande_1_N = mkN "kinkande" ; -- kinkande..nn.1
  kinkig_1_A = mkA "kinkig" ; -- kinkig..av.1
  kinkighet_1_N = mkN "kinkighet" ; -- kinkighet..nn.1
  kiosk_1_N = mkN "kiosk" "kiosker" ; -- kiosk..nn.1
  kiosklitteratur_1_N = mkN "kiosklitteratur" ; -- kiosklitteratur..nn.1
  kioskvältare_1_N = mkN "kioskvältare" utrum  ; -- kioskvältare..nn.1
  kip_1_N = mkN "kip" ; -- kip..nn.1
  kippa_1_N = mkN "kippa" ; -- kippa..nn.1
  kippa_1_V = mkV "kippar" ; -- kippa..vb.1
  kippande_1_N = mkN "kippande" ; -- kippande..nn.1
  kippsko_1_N = mkN "kippsko" "kippskor" ; -- kippsko..nn.1
  kippskodd_1_A = mkA "kippskodd" ; -- kippskodd..av.1
  kirgis_1_N = mkN "kirgis" "kirgiser" ; -- kirgis..nn.1
  kirgisier_1_N = mkN "kirgisier" "kirgisiern" "kirgisier" "kirgisierna" ; -- kirgisier..nn.1
  kirgisiska_1_N = mkN "kirgisiska" ; -- kirgisiska..nn.1
  kirgisiska_2_N = mkN "kirgisiska" ; -- kirgisiska..nn.2
  kirgiz_1_N = mkN "kirgiz" "kirgizer" ; -- kirgiz..nn.1
  kirgiziska_1_N = mkN "kirgiziska" ; -- kirgiziska..nn.1
  kirgiziska_2_N = mkN "kirgiziska" ; -- kirgiziska..nn.2
  kiribatier_1_N = mkN "kiribatier" "kiribatiern" "kiribatier" "kiribatierna" ; -- kiribatier..nn.1
  kiribatisk_1_A = mkA "kiribatisk" ; -- kiribatisk..av.1
  kiribatiska_1_N = mkN "kiribatiska" ; -- kiribatiska..nn.1
  kiromanti_1_N = mkN "kiromanti" ; -- kiromanti..nn.1
  kiropraktik_1_N = mkN "kiropraktik" ; -- kiropraktik..nn.1
  kiropraktiker_1_N = mkN "kiropraktiker" "kiropraktikern" "kiropraktiker" "kiropraktikerna" ; -- kiropraktiker..nn.1
  kiropraktor_1_N = mkN "kiropraktor" "kiropraktorer" ; -- kiropraktor..nn.1
  kirra_1_V = mkV "kirrar" ; -- kirra..vb.1
  kirrande_1_N = mkN "kirrande" ; -- kirrande..nn.1
  kirskål_1_N = mkN "kirskål" ; -- kirskål..nn.1
  kirurg_1_N = mkN "kirurg" "kirurger" ; -- kirurg..nn.1
  kirurgi_1_N = mkN "kirurgi" ; -- kirurgi..nn.1
  kirurgisk_1_A = mkA "kirurgisk" ; -- kirurgisk..av.1
  kirurgmask_1_N = mkN "kirurgmask" "kirurgmasker" ; -- kirurgmask..nn.1
  kirurgtång_1_N = mkN "kirurgtång" "kirurgtänger" ; -- kirurgtång..nn.1
  kis_1_N = mkN "kis" "kiser" ; -- kis..nn.1
  kis_2_N = mkN "kis" ; -- kis..nn.2
  kisa_1_V = mkV "kisar" ; -- kisa..vb.1
  kisande_1_N = mkN "kisande" ; -- kisande..nn.1
  kisel_1_N = mkN "kisel" ; -- kisel..nn.1
  kiselalg_1_N = mkN "kiselalg" "kiselalger" ; -- kiselalg..nn.1
  kiseldamm_1_N = mkN "kiseldamm" neutrum  ; -- kiseldamm..nn.1
  kiselförening_1_N = mkN "kiselförening" ; -- kiselförening..nn.1
  kiselgur_1_N = mkN "kiselgur" ; -- kiselgur..nn.1
  kiselkarbid_1_N = mkN "kiselkarbid" ; -- kiselkarbid..nn.1
  kiselkristall_1_N = mkN "kiselkristall" "kiselkristaller" ; -- kiselkristall..nn.1
  kiselplatta_1_N = mkN "kiselplatta" ; -- kiselplatta..nn.1
  kiselsmedja_1_N = mkN "kiselsmedja" ; -- kiselsmedja..nn.1
  kiselsten_1_N = mkN "kiselsten" "kiselstenen" "kiselstenar" "kiselstenarna" ; -- kiselsten..nn.1
  kiselsyra_1_N = mkN "kiselsyra" ; -- kiselsyra..nn.1
  kiss_1_N = mkN "kiss" neutrum  ; -- kiss..nn.1
  kissa_1_V = mkV "kissar" ; -- kissa..vb.1
  kissande_1_N = mkN "kissande" ; -- kissande..nn.1
  kisse_1_N = mkN "kisse" utrum  ; -- kisse..nn.1
  kissekatt_1_N = mkN "kissekatt" "kissekatter" ; -- kissekatt..nn.1
  kissemiss_1_N = mkN "kissemiss" ; -- kissemiss..nn.1
  kissnödig_1_A = mkA "kissnödig" ; -- kissnödig..av.1
  kissnödighet_1_N = mkN "kissnödighet" ; -- kissnödighet..nn.1
  kista_1_N = mkN "kista" ; -- kista..nn.1
  kistbrev_1_N = mkN "kistbrev" neutrum  ; -- kistbrev..nn.1
  kistbärare_1_N = mkN "kistbärare" utrum  ; -- kistbärare..nn.1
  kistebrev_1_N = mkN "kistebrev" neutrum  ; -- kistebrev..nn.1
  kisögdhet_1_N = mkN "kisögdhet" ; -- kisögdhet..nn.1
  kit_1_N = mkN "kit" neutrum  ; -- kit..nn.1
  kitin_1_N = mkN "kitin" ; -- kitin..nn.1
  kiton_1_N = mkN "kiton" "kitoner" ; -- kiton..nn.1
  kitsch_1_N = mkN "kitsch" ; -- kitsch..nn.1
  kitschig_1_A = mkA "kitschig" ; -- kitschig..av.1
  kitslig_1_A = mkA "kitslig" ; -- kitslig..av.1
  kitslighet_1_N = mkN "kitslighet" "kitsligheter" ; -- kitslighet..nn.1
  kitt_1_N = mkN "kitt" neutrum  ; -- kitt..nn.1
  kitta_1_V = mkV "kittar" ; -- kitta..vb.1
  kittande_1_N = mkN "kittande" ; -- kittande..nn.1
  kittel_1_N = mkN "kittel" ; -- kittel..nn.1
  kitteldal_1_N = mkN "kitteldal" ; -- kitteldal..nn.1
  kittelflickare_1_N = mkN "kittelflickare" utrum  ; -- kittelflickare..nn.1
  kittla_1_V = mkV "kittlar" ; -- kittla..vb.1
  kittlande_1_N = mkN "kittlande" ; -- kittlande..nn.1
  kittlare_1_N = mkN "kittlare" utrum  ; -- kittlare..nn.1
  kittlig_1_A = mkA "kittlig" ; -- kittlig..av.1
  kittlighet_1_N = mkN "kittlighet" ; -- kittlighet..nn.1
  kittling_1_N = mkN "kittling" ; -- kittling..nn.1
  kittning_1_N = mkN "kittning" ; -- kittning..nn.1
  kittost_1_N = mkN "kittost" ; -- kittost..nn.1
  kiv_1_N = mkN "kiv" neutrum  ; -- kiv..nn.1
  kivi_1_N = mkN "kivi" "kivin" "kivier" "kivierna" ; -- kivi..nn.1
  kiwi_1_N = mkN "kiwi" "kiwin" "kiwier" "kiwierna" ; -- kiwi..nn.1
  kjol_1_N = mkN "kjol" ; -- kjol..nn.1
  kjolfåll_1_N = mkN "kjolfåll" ; -- kjolfåll..nn.1
  kjollängd_1_N = mkN "kjollängd" "kjollängder" ; -- kjollängd..nn.1
  kjollös_1_A = mkA "kjollös" ; -- kjollös..av.1
  kjollöshet_1_N = mkN "kjollöshet" ; -- kjollöshet..nn.1
  kjoltyg_1_N = mkN "kjoltyg" neutrum  ; -- kjoltyg..nn.1
  kjortel_1_N = mkN "kjortel" ; -- kjortel..nn.1
  kjusa_1_N = mkN "kjusa" ; -- kjusa..nn.1
  klabb_1_N = mkN "klabb" ; -- klabb..nn.1
  klabb_2_N = mkN "klabb" neutrum  ; -- klabb..nn.2
  klabba_1_V = mkV "klabbar" ; -- klabba..vb.1
  klabbande_1_N = mkN "klabbande" ; -- klabbande..nn.1
  klabbe_1_N = mkN "klabb" ; -- klabbe..nn.1
  klabbsköt_1_N = mkN "klabbsköt" ; -- klabbsköt..nn.1
  klabbsköte_1_N = mkN "klabbsköte" utrum  ; -- klabbsköte..nn.1
  klabbströmming_1_N = mkN "klabbströmming" ; -- klabbströmming..nn.1
  klack_1_N = mkN "klack" ; -- klack..nn.1
  klacka_1_V = mkV "klackar" ; -- klacka..vb.1
  klackande_1_N = mkN "klackande" ; -- klackande..nn.1
  klackbar_1_N = mkN "klackbar" "klackbarer" ; -- klackbar..nn.1
  klackjärn_1_N = mkN "klackjärn" neutrum  ; -- klackjärn..nn.1
  klackring_1_N = mkN "klackring" ; -- klackring..nn.1
  klackspark_1_N = mkN "klackspark" ; -- klackspark..nn.1
  klackstövel_1_N = mkN "klackstövel" ; -- klackstövel..nn.1
  klad_1_N = mkN "klad" "klader" ; -- klad..nn.1
  kladd_1_N = mkN "kladd" ; -- kladd..nn.1
  kladd_2_N = mkN "kladd" neutrum  ; -- kladd..nn.2
  kladda_1_V = mkV "kladdar" ; -- kladda..vb.1
  kladdande_1_N = mkN "kladdande" ; -- kladdande..nn.1
  kladdig_1_A = mkA "kladdig" ; -- kladdig..av.1
  kladdighet_1_N = mkN "kladdighet" ; -- kladdighet..nn.1
  kladdkaka_1_N = mkN "kladdkaka" ; -- kladdkaka..nn.1
  kladistik_1_N = mkN "kladistik" ; -- kladistik..nn.1
  klaff_1_N = mkN "klaff" ; -- klaff..nn.1
  klaffa_1_V = mkV "klaffar" ; -- klaffa..vb.1
  klaffande_1_N = mkN "klaffande" ; -- klaffande..nn.1
  klaffbord_1_N = mkN "klaffbord" neutrum  ; -- klaffbord..nn.1
  klaffbro_1_N = mkN "klaffbro" ; -- klaffbro..nn.1
  klaffel_1_N = mkN "klaffel" "klaffelet" "klaffel" "klaffelen" ; -- klaffel..nn.1
  klafs_1_N = mkN "klafs" neutrum  ; -- klafs..nn.1
  klafsa_1_V = mkV "klafsar" ; -- klafsa..vb.1
  klafsande_1_N = mkN "klafsande" ; -- klafsande..nn.1
  klaga_1_V = mkV "klagar" ; -- klaga..vb.1
  klagande_1_N = mkN "klagande" "klaganden" "klaganden" "klagandena" ; -- klagande..nn.1
  klagodikt_1_N = mkN "klagodikt" "klagodikter" ; -- klagodikt..nn.1
  klagokör_1_N = mkN "klagokör" "klagokörer" ; -- klagokör..nn.1
  klagoljud_1_N = mkN "klagoljud" neutrum  ; -- klagoljud..nn.1
  klagolåt_1_N = mkN "klagolåt" ; -- klagolåt..nn.1
  klagomur_1_N = mkN "klagomur" ; -- klagomur..nn.1
  klagomål_1_N = mkN "klagomål" neutrum  ; -- klagomål..nn.1
  klagorop_1_N = mkN "klagorop" neutrum  ; -- klagorop..nn.1
  klagoskri_1_N = mkN "klagoskri" "klagoskriet" "klagoskrin" "klagoskrina" ; -- klagoskri..nn.1
  klagoskrift_1_N = mkN "klagoskrift" "klagoskrifter" ; -- klagoskrift..nn.1
  klagosång_1_N = mkN "klagosång" "klagosånger" ; -- klagosång..nn.1
  klagotid_1_N = mkN "klagotid" "klagotider" ; -- klagotid..nn.1
  klagotjut_1_N = mkN "klagotjut" neutrum  ; -- klagotjut..nn.1
  klagoton_1_N = mkN "klagoton" "klagotoner" ; -- klagoton..nn.1
  klagovisa_1_N = mkN "klagovisa" ; -- klagovisa..nn.1
  klam_1_N = mkN "klam" "klammen" "klammar" "klammarna" ; -- klam..nn.1
  klammer_1_N = mkN "klammer" "klammern" "klamrar" "klamrarna" ; -- klammer..nn.1
  klammeri_1_N = mkN "klammeri" "klammeriet" "klammerier" "klammerierna" ; -- klammeri..nn.1
  klammerpistol_1_N = mkN "klammerpistol" "klammerpistoler" ; -- klammerpistol..nn.1
  klamp_1_N = mkN "klamp" ; -- klamp..nn.1
  klamp_2_N = mkN "klamp" neutrum  ; -- klamp..nn.2
  klampa_1_V = mkV "klampar" ; -- klampa..vb.1
  klampa_2_V = mkV "klampar" ; -- klampa..vb.2
  klampande_1_N = mkN "klampande" ; -- klampande..nn.1
  klamra_1_V = mkV "klamrar" ; -- klamra..vb.1
  klamrande_1_N = mkN "klamrande" ; -- klamrande..nn.1
  klamydia_1_N = mkN "klamydia" ; -- klamydia..nn.1
  klamydiavaccin_1_N = mkN "klamydiavaccin" "klamydiavacciner" ; -- klamydiavaccin..nn.1
  klan_1_N = mkN "klan" "klaner" ; -- klan..nn.1
  klander_1_N = mkN "klander" neutrum  ; -- klander..nn.1
  klanderfri_1_A = mkA "klanderfri" "klanderfritt" ; -- klanderfri..av.1
  klandervärd_1_A = mkA "klandervärd" "klandervärt" ; -- klandervärd..av.1
  klandervärdhet_1_N = mkN "klandervärdhet" ; -- klandervärdhet..nn.1
  klandra_1_V = mkV "klandrar" ; -- klandra..vb.1
  klandrande_1_N = mkN "klandrande" ; -- klandrande..nn.1
  klandrare_1_N = mkN "klandrare" utrum  ; -- klandrare..nn.1
  klang_1_N = mkN "klang" "klanger" ; -- klang..nn.1
  klangbotten_1_N = mkN "klangbotten" ; -- klangbotten..nn.1
  klangfattig_1_A = mkA "klangfattig" ; -- klangfattig..av.1
  klangfattigdom_1_N = mkN "klangfattigdom" ; -- klangfattigdom..nn.1
  klangfull_1_A = mkA "klangfull" ; -- klangfull..av.1
  klangfullhet_1_N = mkN "klangfullhet" ; -- klangfullhet..nn.1
  klangfärg_1_N = mkN "klangfärg" "klangfärger" ; -- klangfärg..nn.1
  klanglig_1_A = mkA "klanglig" ; -- klanglig..av.1
  klanglös_1_A = mkA "klanglös" ; -- klanglös..av.1
  klanglöshet_1_N = mkN "klanglöshet" ; -- klanglöshet..nn.1
  klangmässig_1_A = mkA "klangmässig" ; -- klangmässig..av.1
  klangrik_1_A = mkA "klangrik" ; -- klangrik..av.1
  klanhövding_1_N = mkN "klanhövding" ; -- klanhövding..nn.1
  klank_1_N = mkN "klank" neutrum  ; -- klank..nn.1
  klanka_1_V = mkV "klankar" ; -- klanka..vb.1
  klankande_1_N = mkN "klankande" ; -- klankande..nn.1
  klanledare_1_N = mkN "klanledare" utrum  ; -- klanledare..nn.1
  klanmassaker_1_N = mkN "klanmassaker" "klanmassakern" "klanmassakrer" "klanmassakrerna" ; -- klanmassaker..nn.1
  klanmässig_1_A = mkA "klanmässig" ; -- klanmässig..av.1
  klansoldat_1_N = mkN "klansoldat" "klansoldater" ; -- klansoldat..nn.1
  klanstrid_1_N = mkN "klanstrid" "klanstrider" ; -- klanstrid..nn.1
  klant_1_N = mkN "klant" ; -- klant..nn.1
  klanteri_1_N = mkN "klanteri" "klanteriet" "klanterier" "klanterierna" ; -- klanteri..nn.1
  klantig_1_A = mkA "klantig" ; -- klantig..av.1
  klantighet_1_N = mkN "klantighet" "klantigheter" ; -- klantighet..nn.1
  klantskalle_1_N = mkN "klantskalle" utrum  ; -- klantskalle..nn.1
  klapp_1_N = mkN "klapp" ; -- klapp..nn.1
  klappa_1_N = mkN "klappa" ; -- klappa..nn.1
  klappa_1_V = mkV "klappar" ; -- klappa..vb.1
  klappa_2_V = mkV "klappar" ; -- klappa..vb.2
  klappande_1_N = mkN "klappande" ; -- klappande..nn.1
  klappbrygga_1_N = mkN "klappbrygga" ; -- klappbrygga..nn.1
  klappbräda_1_N = mkN "klappbräda" ; -- klappbräda..nn.1
  klappbräde_1_N = mkN "klappbräde" ; -- klappbräde..nn.1
  klapper_1_N = mkN "klapper" neutrum  ; -- klapper..nn.1
  klapper_2_N = mkN "klapper" ; -- klapper..nn.2
  klappersten_1_N = mkN "klappersten" "klapperstenen" "klapperstenar" "klapperstenarna" ; -- klappersten..nn.1
  klapperstenstrand_1_N = mkN "klapperstenstrand" "klapperstenstränder" ; -- klapperstenstrand..nn.1
  klappgröt_1_N = mkN "klappgröt" ; -- klappgröt..nn.1
  klappjakt_1_N = mkN "klappjakt" "klappjakter" ; -- klappjakt..nn.1
  klappkanon_1_A = mkA "klappkanon" ; -- klappkanon..av.1
  klappning_1_N = mkN "klappning" ; -- klappning..nn.1
  klappra_1_V = mkV "klapprar" ; -- klappra..vb.1
  klapprande_1_N = mkN "klapprande" ; -- klapprande..nn.1
  klappshopping_1_N = mkN "klappshopping" ; -- klappshopping..nn.1
  klappträ_1_N = mkN "klappträ" "klappträt" "klappträn" "klappträna" ; -- klappträ..nn.1
  klar_1_A = mkA "klar" ; -- klar..av.1
  klara_1_V = mkV "klarar" ; -- klara..vb.1
  klara_2_V = mkV "klarar" ; -- klara..vb.2
  klarande_1_N = mkN "klarande" ; -- klarande..nn.1
  klarblå_1_A = mkA "klarblå" "klarblått" ; -- klarblå..av.1
  klarbär_1_N = mkN "klarbär" neutrum  ; -- klarbär..nn.1
  klarera_1_V = mkV "klarerar" ; -- klarera..vb.1
  klarerande_1_N = mkN "klarerande" ; -- klarerande..nn.1
  klarerbar_1_A = mkA "klarerbar" ; -- klarerbar..av.1
  klarerbarhet_1_N = mkN "klarerbarhet" ; -- klarerbarhet..nn.1
  klarering_1_N = mkN "klarering" ; -- klarering..nn.1
  klargul_1_A = mkA "klargul" ; -- klargul..av.1
  klargöra_1_V = mkV "klargöra" "klargjorde" "klargjort" ; -- klargöra..vb.1
  klargörande_1_N = mkN "klargörande" ; -- klargörande..nn.1
  klarhet_1_N = mkN "klarhet" "klarheter" ; -- klarhet..nn.1
  klarinett_1_N = mkN "klarinett" "klarinetter" ; -- klarinett..nn.1
  klarinettist_1_N = mkN "klarinettist" "klarinettister" ; -- klarinettist..nn.1
  klarlack_1_N = mkN "klarlack" "klarlacket" "klarlacker" "klarlackerna" ; -- klarlack..nn.1
  klarligen_1_Adv = mkAdv "klarligen" ; -- klarligen..ab.1
  klarlägga_1_V = mkV "klarlägga" "klarla" "klarlagt" ; -- klarlägga..vb.1
  klarläggande_1_N = mkN "klarläggande" ; -- klarläggande..nn.1
  klarmedel_1_N = mkN "klarmedel" neutrum  ; -- klarmedel..nn.1
  klarna_1_V = mkV "klarnar" ; -- klarna..vb.1
  klarnande_1_N = mkN "klarnande" ; -- klarnande..nn.1
  klarning_1_N = mkN "klarning" ; -- klarning..nn.1
  klarröd_1_A = mkA "klarröd" "klarrött" ; -- klarröd..av.1
  klarseende_1_A = mkA "klarseende" ; -- klarseende..av.1
  klarsignal_1_N = mkN "klarsignal" "klarsignaler" ; -- klarsignal..nn.1
  klarskinn_1_N = mkN "klarskinn" neutrum  ; -- klarskinn..nn.1
  klarspråk_1_N = mkN "klarspråk" neutrum  ; -- klarspråk..nn.1
  klarsyn_1_N = mkN "klarsyn" ; -- klarsyn..nn.1
  klarsynt_1_A = mkA "klarsynt" "klarsynt" ; -- klarsynt..av.1
  klarsynthet_1_N = mkN "klarsynthet" ; -- klarsynthet..nn.1
  klartecken_1_N = mkN "klartecken" "klartecknet" "klartecken" "klartecknen" ; -- klartecken..nn.1
  klartext_1_N = mkN "klartext" ; -- klartext..nn.1
  klartänkt_1_A = mkA "klartänkt" "klartänkt" ; -- klartänkt..av.1
  klartänkthet_1_N = mkN "klartänkthet" ; -- klartänkthet..nn.1
  klarvaken_1_A = mkA "klarvaken" ; -- klarvaken..av.1
  klarvakenhet_1_N = mkN "klarvakenhet" ; -- klarvakenhet..nn.1
  klarögd_1_A = mkA "klarögd" "klarögt" ; -- klarögd..av.1
  klarögdhet_1_N = mkN "klarögdhet" ; -- klarögdhet..nn.1
  klase_1_N = mkN "klase" utrum  ; -- klase..nn.1
  klasformig_1_A = mkA "klasformig" ; -- klasformig..av.1
  klass_1_N = mkN "klass" "klasser" ; -- klass..nn.1
  klassa_1_V = mkV "klassar" ; -- klassa..vb.1
  klassamhälle_1_N = mkN "klassamhälle" ; -- klassamhälle..nn.1
  klassande_1_N = mkN "klassande" ; -- klassande..nn.1
  klassbok_1_N = mkN "klassbok" "klassböcker" ; -- klassbok..nn.1
  klassbredd_1_N = mkN "klassbredd" "klassbredder" ; -- klassbredd..nn.1
  klassförakt_1_N = mkN "klassförakt" neutrum  ; -- klassförakt..nn.1
  klassfördom_1_N = mkN "klassfördom" ; -- klassfördom..nn.1
  klassföreståndare_1_N = mkN "klassföreståndare" utrum  ; -- klassföreståndare..nn.1
  klassförrädare_1_N = mkN "klassförrädare" utrum  ; -- klassförrädare..nn.1
  klassgräns_1_N = mkN "klassgräns" "klassgränser" ; -- klassgräns..nn.1
  klasshat_1_N = mkN "klasshat" neutrum  ; -- klasshat..nn.1
  klassicism_1_N = mkN "klassicism" "klassicismer" ; -- klassicism..nn.1
  klassicistisk_1_A = mkA "klassicistisk" ; -- klassicistisk..av.1
  klassicitet_1_N = mkN "klassicitet" "klassiciteter" ; -- klassicitet..nn.1
  klassificera_1_V = mkV "klassificerar" ; -- klassificera..vb.1
  klassificerande_1_N = mkN "klassificerande" ; -- klassificerande..nn.1
  klassificerbar_1_A = mkA "klassificerbar" ; -- klassificerbar..av.1
  klassificerbarhet_1_N = mkN "klassificerbarhet" ; -- klassificerbarhet..nn.1
  klassificering_1_N = mkN "klassificering" ; -- klassificering..nn.1
  klassifikation_1_N = mkN "klassifikation" ; -- klassifikation..nn.1
  klassik_1_N = mkN "klassik" "klassiker" ; -- klassik..nn.1
  klassiker_1_N = mkN "klassiker" "klassikern" "klassiker" "klassikerna" ; -- klassiker..nn.1
  klassindelning_1_N = mkN "klassindelning" ; -- klassindelning..nn.1
  klassiserande_1_A = mkA "klassiserande" ; -- klassiserande..av.1
  klassisk_1_A = mkA "klassisk" ; -- klassisk..av.1
  klasskamp_1_N = mkN "klasskamp" "klasskamper" ; -- klasskamp..nn.1
  klasskamrat_1_N = mkN "klasskamrat" "klasskamrater" ; -- klasskamrat..nn.1
  klasskillnad_1_N = mkN "klasskillnad" "klasskillnader" ; -- klasskillnad..nn.1
  klassklyfta_1_N = mkN "klassklyfta" ; -- klassklyfta..nn.1
  klasskompis_1_N = mkN "klasskompis" ; -- klasskompis..nn.1
  klasskonferens_1_N = mkN "klasskonferens" "klasskonferenser" ; -- klasskonferens..nn.1
  klasslag_1_N = mkN "klasslag" ; -- klasslag..nn.1
  klasslag_2_N = mkN "klasslag" neutrum  ; -- klasslag..nn.2
  klasslista_1_N = mkN "klasslista" ; -- klasslista..nn.1
  klasslärare_1_N = mkN "klasslärare" utrum  ; -- klasslärare..nn.1
  klasslös_1_A = mkA "klasslös" ; -- klasslös..av.1
  klasslöshet_1_N = mkN "klasslöshet" ; -- klasslöshet..nn.1
  klassmamma_1_N = mkN "klassmamma" ; -- klassmamma..nn.1
  klassmarkör_1_N = mkN "klassmarkör" "klassmarkörer" ; -- klassmarkör..nn.1
  klassmedvetande_1_N = mkN "klassmedvetande" ; -- klassmedvetande..nn.1
  klassmedveten_1_A = mkA "klassmedveten" ; -- klassmedveten..av.1
  klassmedvetenhet_1_N = mkN "klassmedvetenhet" ; -- klassmedvetenhet..nn.1
  klassmitt_1_N = mkN "klassmitt" ; -- klassmitt..nn.1
  klassmotsättning_1_N = mkN "klassmotsättning" ; -- klassmotsättning..nn.1
  klassmärke_1_N = mkN "klassmärke" ; -- klassmärke..nn.1
  klassmässig_1_A = mkA "klassmässig" ; -- klassmässig..av.1
  klassmörj_1_N = mkN "klassmörj" neutrum  ; -- klassmörj..nn.1
  klasspappa_1_N = mkN "klasspappa" ; -- klasspappa..nn.1
  klassperspektiv_1_N = mkN "klassperspektiv" neutrum  ; -- klassperspektiv..nn.1
  klassresa_1_N = mkN "klassresa" ; -- klassresa..nn.1
  klassresedröm_1_N = mkN "klassresedröm" "klassresedrömmen" "klassresedrömmar" "klassresedrömmarna" ; -- klassresedröm..nn.1
  klassresenär_1_N = mkN "klassresenär" "klassresenärer" ; -- klassresenär..nn.1
  klassrum_1_N = mkN "klassrum" "klassrummet" "klassrum" "klassrummen" ; -- klassrum..nn.1
  klasstillhörighet_1_N = mkN "klasstillhörighet" ; -- klasstillhörighet..nn.1
  klasstruktur_1_N = mkN "klasstruktur" "klasstrukturer" ; -- klasstruktur..nn.1
  klasstryk_1_N = mkN "klasstryk" neutrum  ; -- klasstryk..nn.1
  klassundervisning_1_N = mkN "klassundervisning" ; -- klassundervisning..nn.1
  klassvis_1_Adv = mkAdv "klassvis" ; -- klassvis..ab.1
  klassvis_1_A = mkA "klassvis" ; -- klassvis..av.1
  klassväsen_1_N = mkN "klassväsen" neutrum  ; -- klassväsen..nn.1
  klatrat_1_N = mkN "klatrat" "klatrater" ; -- klatrat..nn.1
  klatrathydrat_1_N = mkN "klatrathydrat" "klatrathydrater" ; -- klatrathydrat..nn.1
  klatratkomplex_1_N = mkN "klatratkomplex" neutrum  ; -- klatratkomplex..nn.1
  klatsch_1_N = mkN "klatsch" ; -- klatsch..nn.1
  klatscha_1_V = mkV "klatschar" ; -- klatscha..vb.1
  klatschande_1_N = mkN "klatschande" ; -- klatschande..nn.1
  klatschig_1_A = mkA "klatschig" ; -- klatschig..av.1
  klatschighet_1_N = mkN "klatschighet" ; -- klatschighet..nn.1
  klatschning_1_N = mkN "klatschning" ; -- klatschning..nn.1
  klaustrofobi_1_N = mkN "klaustrofobi" ; -- klaustrofobi..nn.1
  klaustrofobisk_1_A = mkA "klaustrofobisk" ; -- klaustrofobisk..av.1
  klausul_1_N = mkN "klausul" "klausuler" ; -- klausul..nn.1
  klav_1_N = mkN "klav" ; -- klav..nn.1
  klavbinda_1_V = mkV "klavbinda" "klavband" "klavbundit" ; -- klavbinda..vb.1
  klavbindande_1_N = mkN "klavbindande" ; -- klavbindande..nn.1
  klave_1_N = mkN "klave" utrum  ; -- klave..nn.1
  klavecin_1_N = mkN "klavecin" "klaveciner" ; -- klavecin..nn.1
  klaver_1_N = mkN "klaver" "klaveret" "klaver" "klaveren" ; -- klaver..nn.1
  klavertramp_1_N = mkN "klavertramp" neutrum  ; -- klavertramp..nn.1
  klaverutdrag_1_N = mkN "klaverutdrag" neutrum  ; -- klaverutdrag..nn.1
  klaviatur_1_N = mkN "klaviatur" "klaviaturer" ; -- klaviatur..nn.1
  klavikord_1_N = mkN "klavikord" neutrum  ; -- klavikord..nn.1
  klegg_1_N = mkN "klegg" neutrum  ; -- klegg..nn.1
  klema_1_V = mkV "klemar" ; -- klema..vb.1
  klemande_1_N = mkN "klemande" ; -- klemande..nn.1
  klematis_1_N = mkN "klematis" ; -- klematis..nn.1
  klementin_1_N = mkN "klementin" "klementiner" ; -- klementin..nn.1
  klemig_1_A = mkA "klemig" ; -- klemig..av.1
  klemighet_1_N = mkN "klemighet" ; -- klemighet..nn.1
  klen_1_A = mkA "klen" ; -- klen..av.1
  klena_1_V = mkV "klenar" ; -- klena..vb.1
  klenande_1_N = mkN "klenande" ; -- klenande..nn.1
  klenhet_1_N = mkN "klenhet" ; -- klenhet..nn.1
  klenhus_1_N = mkN "klenhus" neutrum  ; -- klenhus..nn.1
  klenmod_1_N = mkN "klenmod" neutrum  ; -- klenmod..nn.1
  klenmodig_1_A = mkA "klenmodig" ; -- klenmodig..av.1
  klenmodighet_1_N = mkN "klenmodighet" ; -- klenmodighet..nn.1
  klenod_1_N = mkN "klenod" "klenoder" ; -- klenod..nn.1
  klensmed_1_N = mkN "klensmed" "klensmeder" ; -- klensmed..nn.1
  klensmide_1_N = mkN "klensmide" ; -- klensmide..nn.1
  klenspänning_1_N = mkN "klenspänning" ; -- klenspänning..nn.1
  klentro_1_N = mkN "klentro" ; -- klentro..nn.1
  klentrogen_1_A = mkA "klentrogen" ; -- klentrogen..av.1
  klentrogenhet_1_N = mkN "klentrogenhet" ; -- klentrogenhet..nn.1
  klenvuxen_1_A = mkA "klenvuxen" ; -- klenvuxen..av.1
  klenvuxenhet_1_N = mkN "klenvuxenhet" ; -- klenvuxenhet..nn.1
  klenät_1_N = mkN "klenät" "klenäter" ; -- klenät..nn.1
  kleptoman_1_N = mkN "kleptoman" "kleptomaner" ; -- kleptoman..nn.1
  kleptomani_1_N = mkN "kleptomani" ; -- kleptomani..nn.1
  kleresi_1_N = mkN "kleresi" neutrum  ; -- kleresi..nn.1
  klerikal_1_A = mkA "klerikal" ; -- klerikal..av.1
  klerikalism_1_N = mkN "klerikalism" "klerikalismer" ; -- klerikalism..nn.1
  klerikofascistisk_1_A = mkA "klerikofascistisk" ; -- klerikofascistisk..av.1
  klerk_1_N = mkN "klerk" "klerker" ; -- klerk..nn.1
  klerus_1_N = mkN "klerus" ; -- klerus..nn.1
  klet_1_N = mkN "klet" neutrum  ; -- klet..nn.1
  kleta_1_V = mkV "kletar" ; -- kleta..vb.1
  kletande_1_N = mkN "kletande" ; -- kletande..nn.1
  kletig_1_A = mkA "kletig" ; -- kletig..av.1
  kletighet_1_N = mkN "kletighet" "kletigheter" ; -- kletighet..nn.1
  klev_1_N = mkN "klev" neutrum  ; -- klev..nn.1
  kli_1_N = mkN "kli" neutrum  ; -- kli..nn.1
  klia_1_V = mkV "kliar" ; -- klia..vb.1
  klia_2_V = mkV "kliar" ; -- klia..vb.2
  kliande_1_N = mkN "kliande" ; -- kliande..nn.1
  klibb_1_N = mkN "klibb" neutrum  ; -- klibb..nn.1
  klibba_1_V = mkV "klibbar" ; -- klibba..vb.1
  klibbal_1_N = mkN "klibbal" ; -- klibbal..nn.1
  klibbande_1_N = mkN "klibbande" ; -- klibbande..nn.1
  klibbig_1_A = mkA "klibbig" ; -- klibbig..av.1
  klibbighet_1_N = mkN "klibbighet" ; -- klibbighet..nn.1
  kliché_1_N = mkN "kliché" "klichéer" ; -- kliché..nn.1
  klichémässig_1_A = mkA "klichémässig" ; -- klichémässig..av.1
  klick_1_N = mkN "klick" ; -- klick..nn.1
  klick_2_N = mkN "klick" neutrum  ; -- klick..nn.2
  klicka_1_V = mkV "klickar" ; -- klicka..vb.1
  klicka_2_V = mkV "klickar" ; -- klicka..vb.2
  klickande_1_N = mkN "klickande" ; -- klickande..nn.1
  klickbar_1_A = mkA "klickbar" ; -- klickbar..av.1
  klickfiska_1_V = mkV "klickfiskar" ; -- klickfiska..vb.1
  klickfiskande_1_N = mkN "klickfiskande" ; -- klickfiskande..nn.1
  klickfiskare_1_N = mkN "klickfiskare" utrum  ; -- klickfiskare..nn.1
  klickfiske_1_N = mkN "klickfiske" ; -- klickfiske..nn.1
  klickfiskning_1_N = mkN "klickfiskning" ; -- klickfiskning..nn.1
  klickljud_1_N = mkN "klickljud" neutrum  ; -- klickljud..nn.1
  klicklås_1_N = mkN "klicklås" neutrum  ; -- klicklås..nn.1
  klickning_1_N = mkN "klickning" ; -- klickning..nn.1
  klickvis_1_Adv = mkAdv "klickvis" ; -- klickvis..ab.1
  klient_1_N = mkN "klient" "klienter" ; -- klient..nn.1
  klientel_1_N = mkN "klientel" "klientelet" "klientel" "klientelen" ; -- klientel..nn.1
  klientskap_1_N = mkN "klientskap" neutrum  ; -- klientskap..nn.1
  klifs_1_N = mkN "klifs" neutrum  ; -- klifs..nn.1
  klimakteriehäxa_1_N = mkN "klimakteriehäxa" ; -- klimakteriehäxa..nn.1
  klimakteriesvallning_1_N = mkN "klimakteriesvallning" ; -- klimakteriesvallning..nn.1
  klimat_1_N = mkN "klimat" neutrum  ; -- klimat..nn.1
  klimataktivist_1_N = mkN "klimataktivist" "klimataktivister" ; -- klimataktivist..nn.1
  klimatalarm_1_N = mkN "klimatalarm" neutrum  ; -- klimatalarm..nn.1
  klimatalarmism_1_N = mkN "klimatalarmism" ; -- klimatalarmism..nn.1
  klimatalarmist_1_N = mkN "klimatalarmist" "klimatalarmister" ; -- klimatalarmist..nn.1
  klimatanläggning_1_N = mkN "klimatanläggning" ; -- klimatanläggning..nn.1
  klimatavtal_1_N = mkN "klimatavtal" neutrum  ; -- klimatavtal..nn.1
  klimatavtryck_1_N = mkN "klimatavtryck" neutrum  ; -- klimatavtryck..nn.1
  klimatdebatt_1_N = mkN "klimatdebatt" "klimatdebatter" ; -- klimatdebatt..nn.1
  klimatforskare_1_N = mkN "klimatforskare" utrum  ; -- klimatforskare..nn.1
  klimatforskning_1_N = mkN "klimatforskning" ; -- klimatforskning..nn.1
  klimatfråga_1_N = mkN "klimatfråga" ; -- klimatfråga..nn.1
  klimatförbättrande_1_A = mkA "klimatförbättrande" ; -- klimatförbättrande..av.1
  klimatförnekare_1_N = mkN "klimatförnekare" utrum  ; -- klimatförnekare..nn.1
  klimatförsämring_1_N = mkN "klimatförsämring" ; -- klimatförsämring..nn.1
  klimatförändring_1_N = mkN "klimatförändring" ; -- klimatförändring..nn.1
  klimatförändringsskeptiker_1_N = mkN "klimatförändringsskeptiker" "klimatförändringsskeptikern" "klimatförändringsskeptiker" "klimatförändringsskeptikerna" ; -- klimatförändringsskeptiker..nn.1
  klimatgräns_1_N = mkN "klimatgräns" "klimatgränser" ; -- klimatgräns..nn.1
  klimathot_1_N = mkN "klimathot" neutrum  ; -- klimathot..nn.1
  klimathysteri_1_N = mkN "klimathysteri" ; -- klimathysteri..nn.1
  klimatisk_1_A = mkA "klimatisk" ; -- klimatisk..av.1
  klimatkammare_1_N = mkN "klimatkammare" "klimatkammaren" "klimatkammare" "klimatkamrarna" ; -- klimatkammare..nn.1
  klimatkonferens_1_N = mkN "klimatkonferens" "klimatkonferenser" ; -- klimatkonferens..nn.1
  klimatkris_1_N = mkN "klimatkris" "klimatkriser" ; -- klimatkris..nn.1
  klimatlära_1_N = mkN "klimatlära" ; -- klimatlära..nn.1
  klimatmedveten_1_A = mkA "klimatmedveten" ; -- klimatmedveten..av.1
  klimatmedvetenhet_1_N = mkN "klimatmedvetenhet" "klimatmedvetenheter" ; -- klimatmedvetenhet..nn.1
  klimatmodell_1_N = mkN "klimatmodell" "klimatmodeller" ; -- klimatmodell..nn.1
  klimatmässig_1_A = mkA "klimatmässig" ; -- klimatmässig..av.1
  klimatologi_1_N = mkN "klimatologi" ; -- klimatologi..nn.1
  klimatologisk_1_A = mkA "klimatologisk" ; -- klimatologisk..av.1
  klimatombyte_1_N = mkN "klimatombyte" ; -- klimatombyte..nn.1
  klimatoterapi_1_N = mkN "klimatoterapi" ; -- klimatoterapi..nn.1
  klimatpanel_1_N = mkN "klimatpanel" "klimatpaneler" ; -- klimatpanel..nn.1
  klimatpåverkande_1_A = mkA "klimatpåverkande" ; -- klimatpåverkande..av.1
  klimatreglerad_1_A = mkA "klimatreglerad" ; -- klimatreglerad..av.1
  klimatskeptiker_1_N = mkN "klimatskeptiker" "klimatskeptikern" "klimatskeptiker" "klimatskeptikerna" ; -- klimatskeptiker..nn.1
  klimatskäl_1_N = mkN "klimatskäl" neutrum  ; -- klimatskäl..nn.1
  klimatsmart_1_A = mkA "klimatsmart" "klimatsmart" ; -- klimatsmart..av.1
  klimatsmarthet_1_N = mkN "klimatsmarthet" "klimatsmartheter" ; -- klimatsmarthet..nn.1
  klimatstatistik_1_N = mkN "klimatstatistik" ; -- klimatstatistik..nn.1
  klimatstrategi_1_N = mkN "klimatstrategi" "klimatstrategier" ; -- klimatstrategi..nn.1
  klimatsvängning_1_N = mkN "klimatsvängning" ; -- klimatsvängning..nn.1
  klimatsystem_1_N = mkN "klimatsystem" neutrum  ; -- klimatsystem..nn.1
  klimattoppmöte_1_N = mkN "klimattoppmöte" ; -- klimattoppmöte..nn.1
  klimattroende_1_A = mkA "klimattroende" ; -- klimattroende..av.1
  klimatvariation_1_N = mkN "klimatvariation" ; -- klimatvariation..nn.1
  klimatvärsting_1_N = mkN "klimatvärsting" ; -- klimatvärsting..nn.1
  klimatväxling_1_N = mkN "klimatväxling" ; -- klimatväxling..nn.1
  klimatzon_1_N = mkN "klimatzon" "klimatzoner" ; -- klimatzon..nn.1
  klimatändring_1_N = mkN "klimatändring" ; -- klimatändring..nn.1
  klimatångest_1_N = mkN "klimatångest" ; -- klimatångest..nn.1
  klimatåtgärd_1_N = mkN "klimatåtgärd" "klimatåtgärder" ; -- klimatåtgärd..nn.1
  klimax_1_N = mkN "klimax" ; -- klimax..nn.1
  klimp_1_N = mkN "klimp" ; -- klimp..nn.1
  klimpa_1_V = mkV "klimpar" ; -- klimpa..vb.1
  klimpande_1_N = mkN "klimpande" ; -- klimpande..nn.1
  klimpig_1_A = mkA "klimpig" ; -- klimpig..av.1
  klimpighet_1_N = mkN "klimpighet" ; -- klimpighet..nn.1
  kling_1_N = mkN "kling" neutrum  ; -- kling..nn.1
  klinga_1_N = mkN "klinga" ; -- klinga..nn.1
  klinga_1_V = mkV "klingar" ; -- klinga..vb.1
  klingande_1_N = mkN "klingande" ; -- klingande..nn.1
  klingon_1_N = mkN "klingon" ; -- klingon..nn.1
  klinhus_1_N = mkN "klinhus" neutrum  ; -- klinhus..nn.1
  klinik_1_N = mkN "klinik" "kliniker" ; -- klinik..nn.1
  kliniker_1_N = mkN "kliniker" "klinikern" "kliniker" "klinikerna" ; -- kliniker..nn.1
  klinisk_1_A = mkA "klinisk" ; -- klinisk..av.1
  klink_1_N = mkN "klink" ; -- klink..nn.1
  klink_2_N = mkN "klink" neutrum  ; -- klink..nn.2
  klinka_1_N = mkN "klinka" ; -- klinka..nn.1
  klinka_1_V = mkV "klinkar" ; -- klinka..vb.1
  klinkande_1_N = mkN "klinkande" ; -- klinkande..nn.1
  klinkbyggd_1_A = mkA "klinkbyggd" "klinkbyggt" ; -- klinkbyggd..av.1
  klinker_1_N = mkN "klinker" "klinkern" "klinker" "klinkerna" ; -- klinker..nn.1
  klinkerskärare_1_N = mkN "klinkerskärare" utrum  ; -- klinkerskärare..nn.1
  klint_1_N = mkN "klint" ; -- klint..nn.1
  klipp_1_N = mkN "klipp" neutrum  ; -- klipp..nn.1
  klippa_1_N = mkN "klippa" ; -- klippa..nn.1
  klippa_1_V = mkV "klipper" ; -- klippa..vb.1
  klippande_1_N = mkN "klippande" ; -- klippande..nn.1
  klippare_1_N = mkN "klippare" utrum  ; -- klippare..nn.1
  klippblock_1_N = mkN "klippblock" neutrum  ; -- klippblock..nn.1
  klippbredd_1_N = mkN "klippbredd" "klippbredder" ; -- klippbredd..nn.1
  klippdass_1_N = mkN "klippdass" ; -- klippdass..nn.1
  klippdocka_1_N = mkN "klippdocka" ; -- klippdocka..nn.1
  klipper_1_N = mkN "klipper" ; -- klipper..nn.1
  klipperskepp_1_N = mkN "klipperskepp" neutrum  ; -- klipperskepp..nn.1
  klipperstäv_1_N = mkN "klipperstäv" ; -- klipperstäv..nn.1
  klippfisk_1_N = mkN "klippfisk" ; -- klippfisk..nn.1
  klippformation_1_N = mkN "klippformation" ; -- klippformation..nn.1
  klippfyr_1_N = mkN "klippfyr" ; -- klippfyr..nn.1
  klippgrav_1_N = mkN "klippgrav" ; -- klippgrav..nn.1
  klippgrund_1_N = mkN "klippgrund" ; -- klippgrund..nn.1
  klippgrund_2_N = mkN "klippgrund" neutrum  ; -- klippgrund..nn.2
  klipphuvud_1_N = mkN "klipphuvud" "klipphuvudet" "klipphuvud" "klipphuvudena" ; -- klipphuvud..nn.1
  klipphåla_1_N = mkN "klipphåla" ; -- klipphåla..nn.1
  klipphöjd_1_N = mkN "klipphöjd" "klipphöjder" ; -- klipphöjd..nn.1
  klippig_1_A = mkA "klippig" ; -- klippig..av.1
  klippighet_1_N = mkN "klippighet" ; -- klippighet..nn.1
  klipping_1_N = mkN "klipping" ; -- klipping..nn.1
  klippkort_1_N = mkN "klippkort" neutrum  ; -- klippkort..nn.1
  klippljus_1_N = mkN "klippljus" neutrum  ; -- klippljus..nn.1
  klippmassiv_1_N = mkN "klippmassiv" neutrum  ; -- klippmassiv..nn.1
  klippmålning_1_N = mkN "klippmålning" ; -- klippmålning..nn.1
  klippning_1_N = mkN "klippning" ; -- klippning..nn.1
  klippotek_1_N = mkN "klippotek" neutrum  ; -- klippotek..nn.1
  klipprum_1_N = mkN "klipprum" "klipprummet" "klipprum" "klipprummen" ; -- klipprum..nn.1
  klippskreva_1_N = mkN "klippskreva" ; -- klippskreva..nn.1
  klippspets_1_N = mkN "klippspets" ; -- klippspets..nn.1
  klippspik_1_N = mkN "klippspik" ; -- klippspik..nn.1
  klippstuga_1_N = mkN "klippstuga" ; -- klippstuga..nn.1
  klippstup_1_N = mkN "klippstup" neutrum  ; -- klippstup..nn.1
  klippstycke_1_N = mkN "klippstycke" ; -- klippstycke..nn.1
  klipptempel_1_N = mkN "klipptempel" neutrum  ; -- klipptempel..nn.1
  klipptång_1_N = mkN "klipptång" "klipptänger" ; -- klipptång..nn.1
  klippvägg_1_N = mkN "klippvägg" ; -- klippvägg..nn.1
  klipsk_1_A = mkA "klipsk" ; -- klipsk..av.1
  klipskhet_1_N = mkN "klipskhet" "klipskheter" ; -- klipskhet..nn.1
  klipulver_1_N = mkN "klipulver" neutrum  ; -- klipulver..nn.1
  klira_1_V = mkV "klirar" ; -- klira..vb.1
  klirande_1_N = mkN "klirande" ; -- klirande..nn.1
  klirr_1_N = mkN "klirr" neutrum  ; -- klirr..nn.1
  klirra_1_V = mkV "klirrar" ; -- klirra..vb.1
  klirrande_1_N = mkN "klirrande" ; -- klirrande..nn.1
  klister_1_N = mkN "klister" neutrum  ; -- klister..nn.1
  klisterföre_1_N = mkN "klisterföre" ; -- klisterföre..nn.1
  klistermärke_1_N = mkN "klistermärke" ; -- klistermärke..nn.1
  klisterremsa_1_N = mkN "klisterremsa" ; -- klisterremsa..nn.1
  klistervalla_1_N = mkN "klistervalla" ; -- klistervalla..nn.1
  klistra_1_V = mkV "klistrar" ; -- klistra..vb.1
  klistrande_1_N = mkN "klistrande" ; -- klistrande..nn.1
  klistrig_1_A = mkA "klistrig" ; -- klistrig..av.1
  klistrighet_1_N = mkN "klistrighet" ; -- klistrighet..nn.1
  klitoris_1_N = mkN "klitoris" ; -- klitoris..nn.1
  klitta_1_N = mkN "klitta" ; -- klitta..nn.1
  klitta_1_V = mkV "klittar" ; -- klitta..vb.1
  kliv_1_N = mkN "kliv" neutrum  ; -- kliv..nn.1
  kliva_1_V = mkV "kliva" "klev" "klivit" ; -- kliva..vb.1
  klivande_1_N = mkN "klivande" ; -- klivande..nn.1
  klivning_1_N = mkN "klivning" ; -- klivning..nn.1
  klivstätta_1_N = mkN "klivstätta" ; -- klivstätta..nn.1
  klo_1_N = mkN "klo" "klor" ; -- klo..nn.1
  klo_2_N = mkN "klo" ; -- klo..nn.2
  kloak_1_N = mkN "kloak" "kloaker" ; -- kloak..nn.1
  kloakbrunn_1_N = mkN "kloakbrunn" ; -- kloakbrunn..nn.1
  kloakdjur_1_N = mkN "kloakdjur" neutrum  ; -- kloakdjur..nn.1
  kloakledning_1_N = mkN "kloakledning" ; -- kloakledning..nn.1
  kloakrör_1_N = mkN "kloakrör" neutrum  ; -- kloakrör..nn.1
  kloasongvägg_1_N = mkN "kloasongvägg" ; -- kloasongvägg..nn.1
  klocka_1_N = mkN "klocka" ; -- klocka..nn.1
  klocka_1_V = mkV "klockar" ; -- klocka..vb.1
  klockad_1_A = mkA "klockad" ; -- klockad..av.1
  klockande_1_N = mkN "klockande" ; -- klockande..nn.1
  klockare_1_N = mkN "klockare" utrum  ; -- klockare..nn.1
  klockarfar_1_N = mkN "klockarfar" ; -- klockarfar..nn.1
  klockarkärlek_1_N = mkN "klockarkärlek" ; -- klockarkärlek..nn.1
  klockarmband_1_N = mkN "klockarmband" neutrum  ; -- klockarmband..nn.1
  klockboj_1_N = mkN "klockboj" ; -- klockboj..nn.1
  klockficka_1_N = mkN "klockficka" ; -- klockficka..nn.1
  klockfodral_1_N = mkN "klockfodral" neutrum  ; -- klockfodral..nn.1
  klockform_1_N = mkN "klockform" ; -- klockform..nn.1
  klockformad_1_A = mkA "klockformad" ; -- klockformad..av.1
  klockformig_1_A = mkA "klockformig" ; -- klockformig..av.1
  klockgroda_1_N = mkN "klockgroda" ; -- klockgroda..nn.1
  klockkedja_1_N = mkN "klockkedja" ; -- klockkedja..nn.1
  klockklang_1_N = mkN "klockklang" "klockklanger" ; -- klockklang..nn.1
  klockkläpp_1_N = mkN "klockkläpp" ; -- klockkläpp..nn.1
  klockljung_1_N = mkN "klockljung" ; -- klockljung..nn.1
  klockradio_1_N = mkN "klockradio" ; -- klockradio..nn.1
  klockren_1_A = mkA "klockren" "klockrent" ; -- klockren..av.1
  klockrenhet_1_N = mkN "klockrenhet" ; -- klockrenhet..nn.1
  klockrent_1_Adv = mkAdv "klockrent" ; -- klockrent..ab.1
  klockringning_1_N = mkN "klockringning" ; -- klockringning..nn.1
  klocksignal_1_N = mkN "klocksignal" "klocksignaler" ; -- klocksignal..nn.1
  klockslag_1_N = mkN "klockslag" neutrum  ; -- klockslag..nn.1
  klockspel_1_N = mkN "klockspel" "klockspelet" "klockspel" "klockspelen" ; -- klockspel..nn.1
  klockstapel_1_N = mkN "klockstapel" ; -- klockstapel..nn.1
  klocksträng_1_N = mkN "klocksträng" ; -- klocksträng..nn.1
  klocktid_1_N = mkN "klocktid" "klocktider" ; -- klocktid..nn.1
  klocktorn_1_N = mkN "klocktorn" neutrum  ; -- klocktorn..nn.1
  klok_1_A = mkA "klok" ; -- klok..av.1
  klokhet_1_N = mkN "klokhet" "klokheter" ; -- klokhet..nn.1
  klokhuvud_1_N = mkN "klokhuvud" "klokhuvudet" "klokhuvud" "klokhuvudena" ; -- klokhuvud..nn.1
  klokskap_1_N = mkN "klokskap" neutrum  ; -- klokskap..nn.1
  klon_1_N = mkN "klon" "kloner" ; -- klon..nn.1
  klona_1_V = mkV "klonar" ; -- klona..vb.1
  klonande_1_N = mkN "klonande" ; -- klonande..nn.1
  klonering_1_N = mkN "klonering" ; -- klonering..nn.1
  kloning_1_N = mkN "kloning" ; -- kloning..nn.1
  klor_1_N = mkN "klor" ; -- klor..nn.1
  klorat_1_N = mkN "klorat" neutrum  ; -- klorat..nn.1
  kloratom_1_N = mkN "kloratom" "kloratomer" ; -- kloratom..nn.1
  klorera_1_V = mkV "klorerar" ; -- klorera..vb.1
  klorerande_1_N = mkN "klorerande" ; -- klorerande..nn.1
  klorerbar_1_A = mkA "klorerbar" ; -- klorerbar..av.1
  klorerbarhet_1_N = mkN "klorerbarhet" ; -- klorerbarhet..nn.1
  klorering_1_N = mkN "klorering" ; -- klorering..nn.1
  klorex_1_N = mkN "klorex" ; -- klorex..nn.1
  klorfenol_1_N = mkN "klorfenol" "klorfenoler" ; -- klorfenol..nn.1
  klorid_1_N = mkN "klorid" "klorider" ; -- klorid..nn.1
  klorkalk_1_N = mkN "klorkalk" ; -- klorkalk..nn.1
  klorkolväte_1_N = mkN "klorkolväte" ; -- klorkolväte..nn.1
  klorläcka_1_N = mkN "klorläcka" ; -- klorläcka..nn.1
  kloroform_1_N = mkN "kloroform" ; -- kloroform..nn.1
  kloroformera_1_V = mkV "kloroformerar" ; -- kloroformera..vb.1
  kloroformerande_1_N = mkN "kloroformerande" ; -- kloroformerande..nn.1
  kloroformering_1_N = mkN "kloroformering" ; -- kloroformering..nn.1
  klorofyll_1_N = mkN "klorofyll" ; -- klorofyll..nn.1
  kloroplast_1_N = mkN "kloroplast" "kloroplaster" ; -- kloroplast..nn.1
  klorsyra_1_N = mkN "klorsyra" ; -- klorsyra..nn.1
  klorväte_1_N = mkN "klorväte" ; -- klorväte..nn.1
  klorvätesyra_1_N = mkN "klorvätesyra" ; -- klorvätesyra..nn.1
  klosett_1_N = mkN "klosett" "klosetter" ; -- klosett..nn.1
  kloss_1_N = mkN "kloss" ; -- kloss..nn.1
  klossig_1_A = mkA "klossig" ; -- klossig..av.1
  klossighet_1_N = mkN "klossighet" ; -- klossighet..nn.1
  kloster_1_N = mkN "kloster" neutrum  ; -- kloster..nn.1
  klosterbroder_1_N = mkN "klosterbroder" "klosterbrodern" "klosterbröder" "klosterbröderna" ; -- klosterbroder..nn.1
  klostercell_1_N = mkN "klostercell" "klosterceller" ; -- klostercell..nn.1
  klostergård_1_N = mkN "klostergård" ; -- klostergård..nn.1
  klosterkyrka_1_N = mkN "klosterkyrka" ; -- klosterkyrka..nn.1
  klosterlig_1_A = mkA "klosterlig" ; -- klosterlig..av.1
  klosterlikör_1_N = mkN "klosterlikör" "klosterlikörer" ; -- klosterlikör..nn.1
  klosterliv_1_N = mkN "klosterliv" neutrum  ; -- klosterliv..nn.1
  klosterlöfte_1_N = mkN "klosterlöfte" ; -- klosterlöfte..nn.1
  klostermur_1_N = mkN "klostermur" ; -- klostermur..nn.1
  klosterorden_1_N = mkN "klosterorden" ; -- klosterorden..nn.1
  klosterregel_1_N = mkN "klosterregel" "klosterregeln" "klosterregler" "klosterreglerna" ; -- klosterregel..nn.1
  klosterruin_1_N = mkN "klosterruin" "klosterruiner" ; -- klosterruin..nn.1
  klosterskola_1_N = mkN "klosterskola" ; -- klosterskola..nn.1
  klostersyster_1_N = mkN "klostersyster" ; -- klostersyster..nn.1
  klosterträdgård_1_N = mkN "klosterträdgård" ; -- klosterträdgård..nn.1
  klot_1_N = mkN "klot" neutrum  ; -- klot..nn.1
  klot_2_N = mkN "klot" ; -- klot..nn.2
  klotblixt_1_N = mkN "klotblixt" ; -- klotblixt..nn.1
  klotformad_1_A = mkA "klotformad" ; -- klotformad..av.1
  klotformig_1_A = mkA "klotformig" ; -- klotformig..av.1
  klotgrill_1_N = mkN "klotgrill" ; -- klotgrill..nn.1
  klotlik_1_A = mkA "klotlik" ; -- klotlik..av.1
  klotrund_1_A = mkA "klotrund" ; -- klotrund..av.1
  klotrundhet_1_N = mkN "klotrundhet" ; -- klotrundhet..nn.1
  klots_1_N = mkN "klots" ; -- klots..nn.1
  klotsporig_1_A = mkA "klotsporig" ; -- klotsporig..av.1
  klotsporighet_1_N = mkN "klotsporighet" ; -- klotsporighet..nn.1
  klotter_1_N = mkN "klotter" neutrum  ; -- klotter..nn.1
  klotterplank_1_N = mkN "klotterplank" neutrum  ; -- klotterplank..nn.1
  klotterutredning_1_N = mkN "klotterutredning" ; -- klotterutredning..nn.1
  klottra_1_V = mkV "klottrar" ; -- klottra..vb.1
  klottrande_1_N = mkN "klottrande" ; -- klottrande..nn.1
  klottrare_1_N = mkN "klottrare" utrum  ; -- klottrare..nn.1
  klottrig_1_A = mkA "klottrig" ; -- klottrig..av.1
  klottrighet_1_N = mkN "klottrighet" ; -- klottrighet..nn.1
  klotyta_1_N = mkN "klotyta" ; -- klotyta..nn.1
  klotång_1_N = mkN "klotång" "klotänger" ; -- klotång..nn.1
  klove_1_N = mkN "klove" utrum  ; -- klove..nn.1
  klubb_1_N = mkN "klubb" ; -- klubb..nn.1
  klubba_1_N = mkN "klubba" ; -- klubba..nn.1
  klubba_1_V = mkV "klubbar" ; -- klubba..vb.1
  klubbafton_1_N = mkN "klubbafton" "klubbaftonen" "klubbaftnar" "klubbaftnarna" ; -- klubbafton..nn.1
  klubbande_1_N = mkN "klubbande" ; -- klubbande..nn.1
  klubbjacka_1_N = mkN "klubbjacka" ; -- klubbjacka..nn.1
  klubbliv_1_N = mkN "klubbliv" neutrum  ; -- klubbliv..nn.1
  klubblokal_1_N = mkN "klubblokal" "klubblokaler" ; -- klubblokal..nn.1
  klubblängd_1_N = mkN "klubblängd" "klubblängder" ; -- klubblängd..nn.1
  klubblös_1_A = mkA "klubblös" ; -- klubblös..av.1
  klubbmedlem_1_N = mkN "klubbmedlem" "klubbmedlemmen" "klubbmedlemmar" "klubbmedlemmarna" ; -- klubbmedlem..nn.1
  klubbmärke_1_N = mkN "klubbmärke" ; -- klubbmärke..nn.1
  klubbmästare_1_N = mkN "klubbmästare" utrum  ; -- klubbmästare..nn.1
  klubbsandwich_1_N = mkN "klubbsandwich" ; -- klubbsandwich..nn.1
  klubbslag_1_N = mkN "klubbslag" neutrum  ; -- klubbslag..nn.1
  kluck_1_N = mkN "kluck" neutrum  ; -- kluck..nn.1
  klucka_1_V = mkV "kluckar" ; -- klucka..vb.1
  kluckande_1_N = mkN "kluckande" ; -- kluckande..nn.1
  kluckning_1_N = mkN "kluckning" ; -- kluckning..nn.1
  kludd_1_N = mkN "kludd" neutrum  ; -- kludd..nn.1
  kludd_2_N = mkN "kludd" ; -- kludd..nn.2
  kludda_1_V = mkV "kluddar" ; -- kludda..vb.1
  kluddande_1_N = mkN "kluddande" ; -- kluddande..nn.1
  kluddare_1_N = mkN "kluddare" utrum  ; -- kluddare..nn.1
  kludder_1_N = mkN "kludder" neutrum  ; -- kludder..nn.1
  kludderi_1_N = mkN "kludderi" neutrum  ; -- kludderi..nn.1
  klump_1_N = mkN "klump" ; -- klump..nn.1
  klumpackord_1_N = mkN "klumpackord" neutrum  ; -- klumpackord..nn.1
  klumpedump_1_N = mkN "klumpedump" ; -- klumpedump..nn.1
  klumpeduns_1_N = mkN "klumpeduns" ; -- klumpeduns..nn.1
  klumpfisk_1_N = mkN "klumpfisk" ; -- klumpfisk..nn.1
  klumpfot_1_N = mkN "klumpfot" ; -- klumpfot..nn.1
  klumpfotad_1_A = mkA "klumpfotad" ; -- klumpfotad..av.1
  klumpig_1_A = mkA "klumpig" ; -- klumpig..av.1
  klumpighet_1_N = mkN "klumpighet" "klumpigheter" ; -- klumpighet..nn.1
  klumpsumma_1_N = mkN "klumpsumma" ; -- klumpsumma..nn.1
  klumpsöm_1_N = mkN "klumpsöm" "klumpsömmen" "klumpsömmar" "klumpsömmarna" ; -- klumpsöm..nn.1
  klumpvis_1_Adv = mkAdv "klumpvis" ; -- klumpvis..ab.1
  klunga_1_N = mkN "klunga" ; -- klunga..nn.1
  klungvis_1_Adv = mkAdv "klungvis" ; -- klungvis..ab.1
  klunk_1_N = mkN "klunk" ; -- klunk..nn.1
  klunka_1_V = mkV "klunkar" ; -- klunka..vb.1
  klunkande_1_N = mkN "klunkande" ; -- klunkande..nn.1
  klunkning_1_N = mkN "klunkning" ; -- klunkning..nn.1
  kluns_1_N = mkN "kluns" ; -- kluns..nn.1
  klunsig_1_A = mkA "klunsig" ; -- klunsig..av.1
  klunsighet_1_N = mkN "klunsighet" ; -- klunsighet..nn.1
  klurig_1_A = mkA "klurig" ; -- klurig..av.1
  klurighet_1_N = mkN "klurighet" "klurigheter" ; -- klurighet..nn.1
  kluring_1_N = mkN "kluring" ; -- kluring..nn.1
  klusil_1_N = mkN "klusil" "klusiler" ; -- klusil..nn.1
  kluster_1_N = mkN "kluster" neutrum  ; -- kluster..nn.1
  klusterbomb_1_N = mkN "klusterbomb" "klusterbomber" ; -- klusterbomb..nn.1
  klustervapen_1_N = mkN "klustervapen" "klustervapnet" "klustervapen" "klustervapnen" ; -- klustervapen..nn.1
  klustra_1_V = mkV "klustrar" ; -- klustra..vb.1
  klustrande_1_N = mkN "klustrande" ; -- klustrande..nn.1
  klustring_1_N = mkN "klustring" ; -- klustring..nn.1
  klut_1_N = mkN "klut" ; -- klut..nn.1
  kluven_1_A = mkA "kluven" ; -- kluven..av.1
  kluvenhet_1_N = mkN "kluvenhet" "kluvenheter" ; -- kluvenhet..nn.1
  klyft_1_N = mkN "klyft" "klyfter" ; -- klyft..nn.1
  klyfta_1_N = mkN "klyfta" ; -- klyfta..nn.1
  klyfta_1_V = mkV "klyftar" ; -- klyfta..vb.1
  klyftande_1_N = mkN "klyftande" ; -- klyftande..nn.1
  klyftig_1_A = mkA "klyftig" ; -- klyftig..av.1
  klyftighet_1_N = mkN "klyftighet" ; -- klyftighet..nn.1
  klyftpotatis_1_N = mkN "klyftpotatis" ; -- klyftpotatis..nn.1
  klyka_1_N = mkN "klyka" ; -- klyka..nn.1
  klys_1_N = mkN "klys" neutrum  ; -- klys..nn.1
  klyscha_1_N = mkN "klyscha" ; -- klyscha..nn.1
  klyschig_1_A = mkA "klyschig" ; -- klyschig..av.1
  klyschighet_1_N = mkN "klyschighet" ; -- klyschighet..nn.1
  klyv_1_N = mkN "klyv" ; -- klyv..nn.1
  klyva_1_V = mkV "klyva" "klyver" "klyv" "klöv" "klyvt" "kluven" ; -- klyva..vb.1
  klyvande_1_N = mkN "klyvande" ; -- klyvande..nn.1
  klyvarbom_1_N = mkN "klyvarbom" "klyvarbommen" "klyvarbommar" "klyvarbommarna" ; -- klyvarbom..nn.1
  klyvare_1_N = mkN "klyvare" utrum  ; -- klyvare..nn.1
  klyvbar_1_A = mkA "klyvbar" ; -- klyvbar..av.1
  klyvbarhet_1_N = mkN "klyvbarhet" ; -- klyvbarhet..nn.1
  klyvning_1_N = mkN "klyvning" ; -- klyvning..nn.1
  klyvningsreaktion_1_N = mkN "klyvningsreaktion" ; -- klyvningsreaktion..nn.1
  klyvsåg_1_N = mkN "klyvsåg" ; -- klyvsåg..nn.1
  klyvyxa_1_N = mkN "klyvyxa" ; -- klyvyxa..nn.1
  klyvöppning_1_N = mkN "klyvöppning" ; -- klyvöppning..nn.1
  klä_1_V = mkV "klä" "klädde" "klätt" ; -- klä..vb.1
  kläcka_1_V = mkV "kläcker" ; -- kläcka..vb.1
  kläckande_1_N = mkN "kläckande" ; -- kläckande..nn.1
  kläckning_1_N = mkN "kläckning" ; -- kläckning..nn.1
  klädande_1_N = mkN "klädande" ; -- klädande..nn.1
  klädborste_1_N = mkN "klädborste" utrum  ; -- klädborste..nn.1
  klädbyte_1_N = mkN "klädbyte" ; -- klädbyte..nn.1
  klädd_1_A = mkA "klädd" ; -- klädd..av.1
  kläde_1_N = mkN "kläde" ; -- kläde..nn.1
  klädedräkt_1_N = mkN "klädedräkt" "klädedräkter" ; -- klädedräkt..nn.1
  klädesfabrik_1_N = mkN "klädesfabrik" "klädesfabriker" ; -- klädesfabrik..nn.1
  klädesmal_1_N = mkN "klädesmal" ; -- klädesmal..nn.1
  klädesmässig_1_A = mkA "klädesmässig" ; -- klädesmässig..av.1
  klädespersedel_1_N = mkN "klädespersedel" ; -- klädespersedel..nn.1
  klädesplagg_1_N = mkN "klädesplagg" neutrum  ; -- klädesplagg..nn.1
  klädgalen_1_A = mkA "klädgalen" ; -- klädgalen..av.1
  klädgalenhet_1_N = mkN "klädgalenhet" ; -- klädgalenhet..nn.1
  klädhängare_1_N = mkN "klädhängare" utrum  ; -- klädhängare..nn.1
  klädhög_1_N = mkN "klädhög" ; -- klädhög..nn.1
  klädjätte_1_N = mkN "klädjätte" utrum  ; -- klädjätte..nn.1
  klädkammare_1_N = mkN "klädkammare" "klädkammaren" "klädkammare" "klädkamrarna" ; -- klädkammare..nn.1
  klädkedja_1_N = mkN "klädkedja" ; -- klädkedja..nn.1
  klädkod_1_N = mkN "klädkod" "klädkoder" ; -- klädkod..nn.1
  klädkorg_1_N = mkN "klädkorg" ; -- klädkorg..nn.1
  klädlus_1_N = mkN "klädlus" "klädlusen" "klädlöss" "klädlössen" ; -- klädlus..nn.1
  klädmal_1_N = mkN "klädmal" ; -- klädmal..nn.1
  klädnad_1_N = mkN "klädnad" "klädnader" ; -- klädnad..nn.1
  klädning_1_N = mkN "klädning" ; -- klädning..nn.1
  klädnypa_1_N = mkN "klädnypa" ; -- klädnypa..nn.1
  klädpoker_1_N = mkN "klädpoker" ; -- klädpoker..nn.1
  klädsam_1_A = mkA "klädsam" "klädsamt" "klädsamma" "klädsamma" "klädsammare" "klädsammast" "klädsammaste" ; -- klädsam..av.1
  klädsamhet_1_N = mkN "klädsamhet" ; -- klädsamhet..nn.1
  klädsel_1_N = mkN "klädsel" ; -- klädsel..nn.1
  klädseltvätt_1_N = mkN "klädseltvätt" ; -- klädseltvätt..nn.1
  klädskåp_1_N = mkN "klädskåp" neutrum  ; -- klädskåp..nn.1
  klädsmak_1_N = mkN "klädsmak" "klädsmaker" ; -- klädsmak..nn.1
  klädspänne_1_N = mkN "klädspänne" ; -- klädspänne..nn.1
  klädstorlek_1_N = mkN "klädstorlek" ; -- klädstorlek..nn.1
  klädstreck_1_N = mkN "klädstreck" neutrum  ; -- klädstreck..nn.1
  klädsömnad_1_N = mkN "klädsömnad" ; -- klädsömnad..nn.1
  klädtrasa_1_N = mkN "klädtrasa" ; -- klädtrasa..nn.1
  klädtvätt_1_N = mkN "klädtvätt" ; -- klädtvätt..nn.1
  kläende_1_N = mkN "kläende" ; -- kläende..nn.1
  klägg_1_N = mkN "klägg" neutrum  ; -- klägg..nn.1
  kläm_1_N = mkN "kläm" "klämmen" "klämmar" "klämmarna" ; -- kläm..nn.1
  klämdag_1_N = mkN "klämdag" ; -- klämdag..nn.1
  klämkäck_1_A = mkA "klämkäck" ; -- klämkäck..av.1
  klämkäckhet_1_N = mkN "klämkäckhet" neutrum  ; -- klämkäckhet..nn.1
  klämma_1_N = mkN "klämma" ; -- klämma..nn.1
  klämma_1_V = mkV "klämmer" ; -- klämma..vb.1
  klämmande_1_N = mkN "klämmande" ; -- klämmande..nn.1
  klämmare_1_N = mkN "klämmare" utrum  ; -- klämmare..nn.1
  klämmig_1_A = mkA "klämmig" ; -- klämmig..av.1
  klämmighet_1_N = mkN "klämmighet" ; -- klämmighet..nn.1
  klämning_1_N = mkN "klämning" ; -- klämning..nn.1
  klämskruv_1_N = mkN "klämskruv" ; -- klämskruv..nn.1
  klämta_1_V = mkV "klämtar" ; -- klämta..vb.1
  klämtande_1_N = mkN "klämtande" ; -- klämtande..nn.1
  klämtare_1_N = mkN "klämtare" utrum  ; -- klämtare..nn.1
  klämtning_1_N = mkN "klämtning" ; -- klämtning..nn.1
  klänga_1_V = mkV "klänger" ; -- klänga..vb.1
  klänga_2_V = mkV "klänger" ; -- klänga..vb.2
  klängande_1_N = mkN "klängande" ; -- klängande..nn.1
  klänge_1_N = mkN "klänge" ; -- klänge..nn.1
  klängig_1_A = mkA "klängig" ; -- klängig..av.1
  klängighet_1_N = mkN "klängighet" ; -- klängighet..nn.1
  klängning_1_N = mkN "klängning" ; -- klängning..nn.1
  klängranka_1_N = mkN "klängranka" ; -- klängranka..nn.1
  klängväxt_1_N = mkN "klängväxt" "klängväxter" ; -- klängväxt..nn.1
  klänning_1_N = mkN "klänning" ; -- klänning..nn.1
  klänningsliv_1_N = mkN "klänningsliv" neutrum  ; -- klänningsliv..nn.1
  kläpp_1_N = mkN "kläpp" ; -- kläpp..nn.1
  kläppslag_1_N = mkN "kläppslag" neutrum  ; -- kläppslag..nn.1
  klärobskyr_1_N = mkN "klärobskyr" "klärobskyrer" ; -- klärobskyr..nn.1
  klärvoajans_1_N = mkN "klärvoajans" ; -- klärvoajans..nn.1
  klärvoajant_1_A = mkA "klärvoajant" "klärvoajant" ; -- klärvoajant..av.1
  klätt_1_N = mkN "klätt" ; -- klätt..nn.1
  klätterfot_1_N = mkN "klätterfot" "klätterfötter" ; -- klätterfot..nn.1
  klätterfågel_1_N = mkN "klätterfågel" ; -- klätterfågel..nn.1
  klätterjärn_1_N = mkN "klätterjärn" neutrum  ; -- klätterjärn..nn.1
  klätterolycka_1_N = mkN "klätterolycka" ; -- klätterolycka..nn.1
  klätterrep_1_N = mkN "klätterrep" neutrum  ; -- klätterrep..nn.1
  klätterros_1_N = mkN "klätterros" "klätterrosor" ; -- klätterros..nn.1
  klättersko_1_N = mkN "klättersko" "klätterskor" ; -- klättersko..nn.1
  klätterställning_1_N = mkN "klätterställning" ; -- klätterställning..nn.1
  klätterträd_1_N = mkN "klätterträd" neutrum  ; -- klätterträd..nn.1
  klätterväxt_1_N = mkN "klätterväxt" "klätterväxter" ; -- klätterväxt..nn.1
  klättra_1_V = mkV "klättrar" ; -- klättra..vb.1
  klättrande_1_N = mkN "klättrande" ; -- klättrande..nn.1
  klättrare_1_N = mkN "klättrare" utrum  ; -- klättrare..nn.1
  klättring_1_N = mkN "klättring" ; -- klättring..nn.1
  klå_1_V = mkV "klår" ; -- klå..vb.1
  klåda_1_N = mkN "klåda" ; -- klåda..nn.1
  klående_1_N = mkN "klående" ; -- klående..nn.1
  klåfingrig_1_A = mkA "klåfingrig" ; -- klåfingrig..av.1
  klåfingrighet_1_N = mkN "klåfingrighet" ; -- klåfingrighet..nn.1
  klåpa_1_V = mkV "klåpar" ; -- klåpa..vb.1
  klåpande_1_N = mkN "klåpande" ; -- klåpande..nn.1
  klåpare_1_N = mkN "klåpare" utrum  ; -- klåpare..nn.1
  klåperi_1_N = mkN "klåperi" neutrum  ; -- klåperi..nn.1
  klös_1_N = mkN "klös" neutrum  ; -- klös..nn.1
  klösa_1_V = mkV "klöser" ; -- klösa..vb.1
  klösande_1_N = mkN "klösande" ; -- klösande..nn.1
  klösmärke_1_N = mkN "klösmärke" ; -- klösmärke..nn.1
  klösning_1_N = mkN "klösning" ; -- klösning..nn.1
  klöv_1_N = mkN "klöv" ; -- klöv..nn.1
  klövad_1_A = mkA "klövad" ; -- klövad..av.1
  klövdjur_1_N = mkN "klövdjur" neutrum  ; -- klövdjur..nn.1
  klöver_1_N = mkN "klöver" "klövern" "klöver" "klöverna" ; -- klöver..nn.1
  klöverblad_1_N = mkN "klöverblad" neutrum  ; -- klöverblad..nn.1
  klöverformad_1_A = mkA "klöverformad" ; -- klöverformad..av.1
  klöverliknande_1_A = mkA "klöverliknande" ; -- klöverliknande..av.1
  klöversnärja_1_N = mkN "klöversnärja" ; -- klöversnärja..nn.1
  klövertrött_1_A = mkA "klövertrött" ; -- klövertrött..av.1
  klövertrötthet_1_N = mkN "klövertrötthet" ; -- klövertrötthet..nn.1
  klövja_1_V = mkV "klövjar" ; -- klövja..vb.1
  klövjande_1_N = mkN "klövjande" ; -- klövjande..nn.1
  klövjeren_1_N = mkN "klövjeren" "klövjerenen" "klövjerenar" "klövjerenarna" ; -- klövjeren..nn.1
  klövjesadel_1_N = mkN "klövjesadel" ; -- klövjesadel..nn.1
  klövsadel_1_N = mkN "klövsadel" ; -- klövsadel..nn.1
  klövsadelbyggnad_1_N = mkN "klövsadelbyggnad" "klövsadelbyggnader" ; -- klövsadelbyggnad..nn.1
  klövsadelkyrka_1_N = mkN "klövsadelkyrka" ; -- klövsadelkyrka..nn.1
  klövsadelsbyggnad_1_N = mkN "klövsadelsbyggnad" "klövsadelsbyggnader" ; -- klövsadelsbyggnad..nn.1
  klövsadelskyrka_1_N = mkN "klövsadelskyrka" ; -- klövsadelskyrka..nn.1
  knack_1_N = mkN "knack" neutrum  ; -- knack..nn.1
  knack_2_N = mkN "knack" ; -- knack..nn.2
  knacka_1_V = mkV "knackar" ; -- knacka..vb.1
  knackande_1_N = mkN "knackande" ; -- knackande..nn.1
  knackig_1_A = mkA "knackig" ; -- knackig..av.1
  knackighet_1_N = mkN "knackighet" ; -- knackighet..nn.1
  knackkorv_1_N = mkN "knackkorv" ; -- knackkorv..nn.1
  knackning_1_N = mkN "knackning" ; -- knackning..nn.1
  knackvurst_1_N = mkN "knackvurst" ; -- knackvurst..nn.1
  knagge_1_N = mkN "knagg" ; -- knagge..nn.1
  knaggla_1_V = mkV "knagglar" ; -- knaggla..vb.1
  knagglande_1_N = mkN "knagglande" ; -- knagglande..nn.1
  knagglig_1_A = mkA "knagglig" ; -- knagglig..av.1
  knagglighet_1_N = mkN "knagglighet" "knaggligheter" ; -- knagglighet..nn.1
  knak_1_N = mkN "knak" neutrum  ; -- knak..nn.1
  knaka_1_V = mkV "knakar" ; -- knaka..vb.1
  knakande_1_N = mkN "knakande" ; -- knakande..nn.1
  knakning_1_N = mkN "knakning" ; -- knakning..nn.1
  knal_1_A = mkA "knal" ; -- knal..av.1
  knalhet_1_N = mkN "knalhet" ; -- knalhet..nn.1
  knall_1_A = mkA "knall" "knall" ; -- knall..av.1
  knall_1_N = mkN "knall" ; -- knall..nn.1
  knalla_1_V = mkV "knallar" ; -- knalla..vb.1
  knallande_1_N = mkN "knallande" ; -- knallande..nn.1
  knallblå_1_A = mkA "knallblå" "knallblått" ; -- knallblå..av.1
  knalldosa_1_N = mkN "knalldosa" ; -- knalldosa..nn.1
  knalle_1_N = mkN "knalle" utrum  ; -- knalle..nn.1
  knalleffekt_1_N = mkN "knalleffekt" "knalleffekter" ; -- knalleffekt..nn.1
  knallgas_1_N = mkN "knallgas" ; -- knallgas..nn.1
  knallgrön_1_A = mkA "knallgrön" ; -- knallgrön..av.1
  knallhatt_1_N = mkN "knallhatt" ; -- knallhatt..nn.1
  knallhet_1_N = mkN "knallhet" ; -- knallhet..nn.1
  knallhård_1_A = mkA "knallhård" "knallhårt" ; -- knallhård..av.1
  knallkvicksilver_1_N = mkN "knallkvicksilver" neutrum  ; -- knallkvicksilver..nn.1
  knallorange_1_A = mkA "knallorange" "knalloranget" ; -- knallorange..av.1
  knallpulver_1_N = mkN "knallpulver" neutrum  ; -- knallpulver..nn.1
  knallröd_1_A = mkA "knallröd" "knallrött" ; -- knallröd..av.1
  knallskott_1_N = mkN "knallskott" neutrum  ; -- knallskott..nn.1
  knalltransport_1_N = mkN "knalltransport" "knalltransporter" ; -- knalltransport..nn.1
  knap_1_N = mkN "knap" ; -- knap..nn.1
  knapadel_1_N = mkN "knapadel" ; -- knapadel..nn.1
  knape_1_N = mkN "knape" utrum  ; -- knape..nn.1
  knaper_1_A = mkA "knaper" ; -- knaper..av.1
  knapp_1_A = mkA "knapp" ; -- knapp..av.1
  knapp_1_N = mkN "knapp" ; -- knapp..nn.1
  knapphet_1_N = mkN "knapphet" "knappheter" ; -- knapphet..nn.1
  knapphändig_1_A = mkA "knapphändig" ; -- knapphändig..av.1
  knapphändighet_1_N = mkN "knapphändighet" ; -- knapphändighet..nn.1
  knapphål_1_N = mkN "knapphål" neutrum  ; -- knapphål..nn.1
  knapphålsblomma_1_N = mkN "knapphålsblomma" ; -- knapphålsblomma..nn.1
  knappnål_1_N = mkN "knappnål" ; -- knappnål..nn.1
  knappnålshuvud_1_N = mkN "knappnålshuvud" "knappnålshuvudet" "knappnålshuvud" "knappnålshuvudena" ; -- knappnålshuvud..nn.1
  knappologi_1_N = mkN "knappologi" ; -- knappologi..nn.1
  knapptelefon_1_N = mkN "knapptelefon" "knapptelefoner" ; -- knapptelefon..nn.1
  knapptryck_1_N = mkN "knapptryck" neutrum  ; -- knapptryck..nn.1
  knapptryckande_1_A = mkA "knapptryckande" ; -- knapptryckande..av.1
  knapptryckande_1_N = mkN "knapptryckande" ; -- knapptryckande..nn.1
  knapptryckning_1_N = mkN "knapptryckning" ; -- knapptryckning..nn.1
  knapra_1_V = mkV "knaprar" ; -- knapra..vb.1
  knaprande_1_N = mkN "knaprande" ; -- knaprande..nn.1
  knaprig_1_A = mkA "knaprig" ; -- knaprig..av.1
  knaprighet_1_N = mkN "knaprighet" ; -- knaprighet..nn.1
  knark_1_N = mkN "knark" neutrum  ; -- knark..nn.1
  knarka_1_V = mkV "knarkar" ; -- knarka..vb.1
  knarkande_1_N = mkN "knarkande" ; -- knarkande..nn.1
  knarkarbrud_1_N = mkN "knarkarbrud" ; -- knarkarbrud..nn.1
  knarkare_1_N = mkN "knarkare" utrum  ; -- knarkare..nn.1
  knarkarkvart_1_N = mkN "knarkarkvart" ; -- knarkarkvart..nn.1
  knarkbaron_1_N = mkN "knarkbaron" "knarkbaroner" ; -- knarkbaron..nn.1
  knarkbekämpare_1_N = mkN "knarkbekämpare" utrum  ; -- knarkbekämpare..nn.1
  knarkbekämpning_1_N = mkN "knarkbekämpning" ; -- knarkbekämpning..nn.1
  knarkhandel_1_N = mkN "knarkhandel" ; -- knarkhandel..nn.1
  knarkhandlare_1_N = mkN "knarkhandlare" utrum  ; -- knarkhandlare..nn.1
  knarkhandlartid_1_N = mkN "knarkhandlartid" ; -- knarkhandlartid..nn.1
  knarkhistoria_1_N = mkN "knarkhistoria" "knarkhistorian" "knarkhistorier" "knarkhistorierna" ; -- knarkhistoria..nn.1
  knarkhund_1_N = mkN "knarkhund" ; -- knarkhund..nn.1
  knarkhärva_1_N = mkN "knarkhärva" ; -- knarkhärva..nn.1
  knarkkartell_1_N = mkN "knarkkartell" "knarkkarteller" ; -- knarkkartell..nn.1
  knarkkrig_1_N = mkN "knarkkrig" neutrum  ; -- knarkkrig..nn.1
  knarkkurir_1_N = mkN "knarkkurir" "knarkkurirer" ; -- knarkkurir..nn.1
  knarklangare_1_N = mkN "knarklangare" utrum  ; -- knarklangare..nn.1
  knarklangning_1_N = mkN "knarklangning" ; -- knarklangning..nn.1
  knarkliga_1_N = mkN "knarkliga" ; -- knarkliga..nn.1
  knarkning_1_N = mkN "knarkning" ; -- knarkning..nn.1
  knarksmugglare_1_N = mkN "knarksmugglare" utrum  ; -- knarksmugglare..nn.1
  knarksmuggling_1_N = mkN "knarksmuggling" ; -- knarksmuggling..nn.1
  knarr_1_N = mkN "knarr" neutrum  ; -- knarr..nn.1
  knarr_2_N = mkN "knarr" ; -- knarr..nn.2
  knarra_1_V = mkV "knarrar" ; -- knarra..vb.1
  knarrande_1_N = mkN "knarrande" ; -- knarrande..nn.1
  knarrig_1_A = mkA "knarrig" ; -- knarrig..av.1
  knarrighet_1_N = mkN "knarrighet" ; -- knarrighet..nn.1
  knarrning_1_N = mkN "knarrning" ; -- knarrning..nn.1
  knasboll_1_N = mkN "knasboll" ; -- knasboll..nn.1
  knasig_1_A = mkA "knasig" ; -- knasig..av.1
  knasighet_1_N = mkN "knasighet" "knasigheter" ; -- knasighet..nn.1
  knasprig_1_A = mkA "knasprig" ; -- knasprig..av.1
  knasprighet_1_N = mkN "knasprighet" ; -- knasprighet..nn.1
  knast_1_N = mkN "knast" ; -- knast..nn.1
  knaster_1_N = mkN "knaster" neutrum  ; -- knaster..nn.1
  knaster_2_N = mkN "knaster" ; -- knaster..nn.2
  knastertorr_1_A = mkA "knastertorr" ; -- knastertorr..av.1
  knastra_1_V = mkV "knastrar" ; -- knastra..vb.1
  knastrande_1_N = mkN "knastrande" ; -- knastrande..nn.1
  knastrig_1_A = mkA "knastrig" ; -- knastrig..av.1
  knastrighet_1_N = mkN "knastrighet" ; -- knastrighet..nn.1
  knata_1_V = mkV "knatar" ; -- knata..vb.1
  knatande_1_N = mkN "knatande" ; -- knatande..nn.1
  knatte_1_N = mkN "knatte" utrum  ; -- knatte..nn.1
  knatter_1_N = mkN "knatter" neutrum  ; -- knatter..nn.1
  knatting_1_N = mkN "knatting" ; -- knatting..nn.1
  knattra_1_V = mkV "knattrar" ; -- knattra..vb.1
  knattrande_1_N = mkN "knattrande" ; -- knattrande..nn.1
  kneg_1_N = mkN "kneg" neutrum  ; -- kneg..nn.1
  knega_1_V = mkV "knegar" ; -- knega..vb.1
  knegande_1_N = mkN "knegande" ; -- knegande..nn.1
  knegare_1_N = mkN "knegare" utrum  ; -- knegare..nn.1
  kneippkur_1_N = mkN "kneippkur" "kneippkurer" ; -- kneippkur..nn.1
  knejpkur_1_N = mkN "knejpkur" "knejpkurer" ; -- knejpkur..nn.1
  knekt_1_N = mkN "knekt" ; -- knekt..nn.1
  knektmentalitet_1_N = mkN "knektmentalitet" "knektmentaliteter" ; -- knektmentalitet..nn.1
  knep_1_N = mkN "knep" neutrum  ; -- knep..nn.1
  knepig_1_A = mkA "knepig" ; -- knepig..av.1
  knepighet_1_N = mkN "knepighet" "knepigheter" ; -- knepighet..nn.1
  knick_1_N = mkN "knick" ; -- knick..nn.1
  knip_1_N = mkN "knip" neutrum  ; -- knip..nn.1
  knipa_1_N = mkN "knipa" ; -- knipa..nn.1
  knipa_1_V = mkV "knipa" "knep" "knipit" ; -- knipa..vb.1
  knipande_1_N = mkN "knipande" ; -- knipande..nn.1
  knipning_1_N = mkN "knipning" ; -- knipning..nn.1
  knippa_1_N = mkN "knippa" ; -- knippa..nn.1
  knippe_1_N = mkN "knippe" ; -- knippe..nn.1
  knipsa_1_V = mkV "knipsar" ; -- knipsa..vb.1
  knipsande_1_N = mkN "knipsande" ; -- knipsande..nn.1
  knipslug_1_A = mkA "knipslug" ; -- knipslug..av.1
  knipslughet_1_N = mkN "knipslughet" ; -- knipslughet..nn.1
  kniptång_1_N = mkN "kniptång" "kniptänger" ; -- kniptång..nn.1
  kniptångsmanöver_1_N = mkN "kniptångsmanöver" ; -- kniptångsmanöver..nn.1
  knirk_1_N = mkN "knirk" neutrum  ; -- knirk..nn.1
  knirka_1_V = mkV "knirkar" ; -- knirka..vb.1
  knirkande_1_N = mkN "knirkande" ; -- knirkande..nn.1
  knirr_1_N = mkN "knirr" neutrum  ; -- knirr..nn.1
  knirra_1_V = mkV "knirrar" ; -- knirra..vb.1
  knirrande_1_N = mkN "knirrande" ; -- knirrande..nn.1
  knistra_1_V = mkV "knistrar" ; -- knistra..vb.1
  knistrande_1_N = mkN "knistrande" ; -- knistrande..nn.1
  knittel_1_N = mkN "knittel" ; -- knittel..nn.1
  knittelvers_1_N = mkN "knittelvers" ; -- knittelvers..nn.1
  knitter_1_N = mkN "knitter" neutrum  ; -- knitter..nn.1
  knittra_1_V = mkV "knittrar" ; -- knittra..vb.1
  knittrande_1_N = mkN "knittrande" ; -- knittrande..nn.1
  kniv_1_N = mkN "kniv" ; -- kniv..nn.1
  kniva_1_V = mkV "knivar" ; -- kniva..vb.1
  knivande_1_N = mkN "knivande" ; -- knivande..nn.1
  knivavstånd_1_N = mkN "knivavstånd" neutrum  ; -- knivavstånd..nn.1
  knivbeväpnad_1_A = mkA "knivbeväpnad" ; -- knivbeväpnad..av.1
  knivblad_1_N = mkN "knivblad" neutrum  ; -- knivblad..nn.1
  knivbladslik_1_A = mkA "knivbladslik" ; -- knivbladslik..av.1
  knivbroms_1_N = mkN "knivbroms" ; -- knivbroms..nn.1
  knivdöda_1_V = mkV "knivdödar" ; -- knivdöda..vb.1
  knivdödande_1_N = mkN "knivdödande" ; -- knivdödande..nn.1
  knivhugg_1_N = mkN "knivhugg" neutrum  ; -- knivhugg..nn.1
  knivhugga_1_V = mkV "knivhugga" "knivhögg" "knivhuggit" ; -- knivhugga..vb.1
  knivig_1_A = mkA "knivig" ; -- knivig..av.1
  knivighet_1_N = mkN "knivighet" "knivigheter" ; -- knivighet..nn.1
  knivkastning_1_N = mkN "knivkastning" ; -- knivkastning..nn.1
  knivkontakt_1_N = mkN "knivkontakt" "knivkontakter" ; -- knivkontakt..nn.1
  knivläggare_1_N = mkN "knivläggare" utrum  ; -- knivläggare..nn.1
  knivlåda_1_N = mkN "knivlåda" ; -- knivlåda..nn.1
  knivman_1_N = mkN "knivman" "knivmannen" "knivmän" "knivmännen" ; -- knivman..nn.1
  knivmord_1_N = mkN "knivmord" neutrum  ; -- knivmord..nn.1
  knivmörda_1_V = mkV "knivmördar" ; -- knivmörda..vb.1
  knivmördande_1_N = mkN "knivmördande" ; -- knivmördande..nn.1
  knivrygg_1_N = mkN "knivrygg" ; -- knivrygg..nn.1
  knivrörelse_1_N = mkN "knivrörelse" "knivrörelser" ; -- knivrörelse..nn.1
  knivsegg_1_N = mkN "knivsegg" ; -- knivsegg..nn.1
  knivskaft_1_N = mkN "knivskaft" neutrum  ; -- knivskaft..nn.1
  knivskarp_1_A = mkA "knivskarp" ; -- knivskarp..av.1
  knivskarphet_1_N = mkN "knivskarphet" ; -- knivskarphet..nn.1
  knivskuren_1_A = mkA "knivskuren" ; -- knivskuren..av.1
  knivskära_1_V = mkV "knivskära" "knivskar" "knivskurit" ; -- knivskära..vb.1
  knivslida_1_N = mkN "knivslida" ; -- knivslida..nn.1
  knivsrygg_1_N = mkN "knivsrygg" ; -- knivsrygg..nn.1
  knivsudd_1_N = mkN "knivsudd" ; -- knivsudd..nn.1
  knivsår_1_N = mkN "knivsår" neutrum  ; -- knivsår..nn.1
  knix_1_N = mkN "knix" ; -- knix..nn.1
  knixa_1_V = mkV "knixar" ; -- knixa..vb.1
  knixande_1_N = mkN "knixande" ; -- knixande..nn.1
  knixning_1_N = mkN "knixning" ; -- knixning..nn.1
  knocka_1_V = mkV "knockar" ; -- knocka..vb.1
  knockande_1_N = mkN "knockande" ; -- knockande..nn.1
  knockdown_1_N = mkN "knockdown" "knockdowner" ; -- knockdown..nn.1
  knockout_1_N = mkN "knockout" "knockouter" ; -- knockout..nn.1
  knodd_1_N = mkN "knodd" ; -- knodd..nn.1
  knoddän_1_A = mkA "knoddän" ; -- knoddän..av.1
  knog_1_N = mkN "knog" neutrum  ; -- knog..nn.1
  knoga_1_V = mkV "knogar" ; -- knoga..vb.1
  knogande_1_N = mkN "knogande" ; -- knogande..nn.1
  knogare_1_N = mkN "knogare" utrum  ; -- knogare..nn.1
  knoge_1_N = mkN "knoge" utrum  ; -- knoge..nn.1
  knogig_1_A = mkA "knogig" ; -- knogig..av.1
  knogjärn_1_N = mkN "knogjärn" neutrum  ; -- knogjärn..nn.1
  knollra_1_V = mkV "knollrar" ; -- knollra..vb.1
  knollrande_1_N = mkN "knollrande" ; -- knollrande..nn.1
  knollrig_1_A = mkA "knollrig" ; -- knollrig..av.1
  knollrighet_1_N = mkN "knollrighet" "knollrigheter" ; -- knollrighet..nn.1
  knop_1_N = mkN "knop" ; -- knop..nn.1
  knop_2_N = mkN "knop" "knopen" "knop" "knopen" ; -- knop..nn.2
  knopa_1_V = mkV "knopar" ; -- knopa..vb.1
  knopande_1_N = mkN "knopande" ; -- knopande..nn.1
  knopp_1_N = mkN "knopp" ; -- knopp..nn.1
  knoppig_1_A = mkA "knoppig" ; -- knoppig..av.1
  knoppighet_1_N = mkN "knoppighet" ; -- knoppighet..nn.1
  knoppning_1_N = mkN "knoppning" ; -- knoppning..nn.1
  knoppningstid_1_N = mkN "knoppningstid" "knoppningstider" ; -- knoppningstid..nn.1
  knoppsprickning_1_N = mkN "knoppsprickning" ; -- knoppsprickning..nn.1
  knoppsättning_1_N = mkN "knoppsättning" ; -- knoppsättning..nn.1
  knorr_1_N = mkN "knorr" ; -- knorr..nn.1
  knorr_2_N = mkN "knorr" neutrum  ; -- knorr..nn.2
  knorra_1_V = mkV "knorrar" ; -- knorra..vb.1
  knorra_2_V = mkV "knorrar" ; -- knorra..vb.2
  knorrande_1_N = mkN "knorrande" ; -- knorrande..nn.1
  knorrhane_1_N = mkN "knorrhane" utrum  ; -- knorrhane..nn.1
  knorva_1_V = mkV "knorvar" ; -- knorva..vb.1
  knorvande_1_N = mkN "knorvande" ; -- knorvande..nn.1
  knoster_1_N = mkN "knoster" neutrum  ; -- knoster..nn.1
  knot_1_N = mkN "knot" ; -- knot..nn.1
  knot_2_N = mkN "knot" neutrum  ; -- knot..nn.2
  knota_1_N = mkN "knota" ; -- knota..nn.1
  knota_1_V = mkV "knotar" ; -- knota..vb.1
  knotande_1_N = mkN "knotande" ; -- knotande..nn.1
  knotig_1_A = mkA "knotig" ; -- knotig..av.1
  knotighet_1_N = mkN "knotighet" "knotigheter" ; -- knotighet..nn.1
  knott_1_N = mkN "knott" neutrum  ; -- knott..nn.1
  knotter_1_N = mkN "knotter" neutrum  ; -- knotter..nn.1
  knottra_1_N = mkN "knottra" ; -- knottra..nn.1
  knottra_1_V = mkV "knottrar" ; -- knottra..vb.1
  knottrande_1_N = mkN "knottrande" ; -- knottrande..nn.1
  knottrig_1_A = mkA "knottrig" ; -- knottrig..av.1
  knottrighet_1_N = mkN "knottrighet" ; -- knottrighet..nn.1
  know_how_1_N = mkN "know-how" neutrum  ; -- know-how..nn.1
  knubbig_1_A = mkA "knubbig" ; -- knubbig..av.1
  knubbighet_1_N = mkN "knubbighet" ; -- knubbighet..nn.1
  knubbsäl_1_N = mkN "knubbsäl" ; -- knubbsäl..nn.1
  knuff_1_N = mkN "knuff" ; -- knuff..nn.1
  knuffa_1_V = mkV "knuffar" ; -- knuffa..vb.1
  knuffande_1_N = mkN "knuffande" ; -- knuffande..nn.1
  knuffning_1_N = mkN "knuffning" ; -- knuffning..nn.1
  knull_1_N = mkN "knull" neutrum  ; -- knull..nn.1
  knulla_1_V = mkV "knullar" ; -- knulla..vb.1
  knullande_1_N = mkN "knullande" ; -- knullande..nn.1
  knullrufs_1_N = mkN "knullrufs" neutrum  ; -- knullrufs..nn.1
  knussel_1_N = mkN "knussel" neutrum  ; -- knussel..nn.1
  knussla_1_V = mkV "knusslar" ; -- knussla..vb.1
  knusslande_1_N = mkN "knusslande" ; -- knusslande..nn.1
  knusslig_1_A = mkA "knusslig" ; -- knusslig..av.1
  knusslighet_1_N = mkN "knusslighet" "knussligheter" ; -- knusslighet..nn.1
  knut_1_N = mkN "knut" ; -- knut..nn.1
  knuta_1_N = mkN "knuta" ; -- knuta..nn.1
  knutbroderi_1_N = mkN "knutbroderi" "knutbroderiet" "knutbroderier" "knutbroderierna" ; -- knutbroderi..nn.1
  knuten_1_A = mkA "knuten" ; -- knuten..av.1
  knutig_1_A = mkA "knutig" ; -- knutig..av.1
  knutlampa_1_N = mkN "knutlampa" ; -- knutlampa..nn.1
  knutpiska_1_N = mkN "knutpiska" ; -- knutpiska..nn.1
  knutpunkt_1_N = mkN "knutpunkt" "knutpunkter" ; -- knutpunkt..nn.1
  knutte_1_N = mkN "knutte" utrum  ; -- knutte..nn.1
  knuttimra_1_V = mkV "knuttimrar" ; -- knuttimra..vb.1
  knuttimrande_1_N = mkN "knuttimrande" ; -- knuttimrande..nn.1
  knyck_1_N = mkN "knyck" ; -- knyck..nn.1
  knyck_2_N = mkN "knyck" "knycken" "knyck" "knycken" ; -- knyck..nn.2
  knycka_1_V = mkV "knycker" ; -- knycka..vb.1
  knyckande_1_N = mkN "knyckande" ; -- knyckande..nn.1
  knyckig_1_A = mkA "knyckig" ; -- knyckig..av.1
  knyckighet_1_N = mkN "knyckighet" ; -- knyckighet..nn.1
  knyckla_1_V = mkV "knycklar" ; -- knyckla..vb.1
  knycklande_1_N = mkN "knycklande" ; -- knycklande..nn.1
  knyckning_1_N = mkN "knyckning" ; -- knyckning..nn.1
  knylhavre_1_N = mkN "knylhavre" utrum  ; -- knylhavre..nn.1
  knyppeldyna_1_N = mkN "knyppeldyna" ; -- knyppeldyna..nn.1
  knyppla_1_V = mkV "knypplar" ; -- knyppla..vb.1
  knypplande_1_N = mkN "knypplande" ; -- knypplande..nn.1
  knyppling_1_N = mkN "knyppling" ; -- knyppling..nn.1
  knypplingskurs_1_N = mkN "knypplingskurs" "knypplingskurser" ; -- knypplingskurs..nn.1
  knyst_1_N = mkN "knyst" neutrum  ; -- knyst..nn.1
  knysta_1_V = mkV "knystar" ; -- knysta..vb.1
  knystande_1_N = mkN "knystande" ; -- knystande..nn.1
  knyta_1_V = mkV "knyta" "knöt" "knutit" ; -- knyta..vb.1
  knytande_1_N = mkN "knytande" ; -- knytande..nn.1
  knytblus_1_N = mkN "knytblus" ; -- knytblus..nn.1
  knyte_1_N = mkN "knyte" ; -- knyte..nn.1
  knytkalas_1_N = mkN "knytkalas" neutrum  ; -- knytkalas..nn.1
  knytning_1_N = mkN "knytning" ; -- knytning..nn.1
  knytnäve_1_N = mkN "knytnäve" utrum  ; -- knytnäve..nn.1
  knytnävsslag_1_N = mkN "knytnävsslag" neutrum  ; -- knytnävsslag..nn.1
  knytskärp_1_N = mkN "knytskärp" neutrum  ; -- knytskärp..nn.1
  knä_1_N = mkN "knä" "knät" "knän" "knäna" ; -- knä..nn.1
  knäa_1_V = mkV "knäar" ; -- knäa..vb.1
  knäa_2_V = mkV "knäar" ; -- knäa..vb.2
  knäande_1_N = mkN "knäande" ; -- knäande..nn.1
  knäbyxa_1_N = mkN "knäbyxa" ; -- knäbyxa..nn.1
  knäböja_1_V = mkV "knäböja" "knäböjde" "knäböjt" ; -- knäböja..vb.1
  knäböjande_1_N = mkN "knäböjande" ; -- knäböjande..nn.1
  knäböjning_1_N = mkN "knäböjning" ; -- knäböjning..nn.1
  knäck_1_N = mkN "knäck" ; -- knäck..nn.1
  knäck_2_N = mkN "knäck" neutrum  ; -- knäck..nn.2
  knäcka_1_V = mkV "knäcker" ; -- knäcka..vb.1
  knäckande_1_N = mkN "knäckande" ; -- knäckande..nn.1
  knäckebröd_1_N = mkN "knäckebröd" neutrum  ; -- knäckebröd..nn.1
  knäckepil_1_N = mkN "knäckepil" ; -- knäckepil..nn.1
  knäckform_1_N = mkN "knäckform" ; -- knäckform..nn.1
  knäckfråga_1_N = mkN "knäckfråga" ; -- knäckfråga..nn.1
  knäckning_1_N = mkN "knäckning" ; -- knäckning..nn.1
  knäckt_1_A = mkA "knäckt" "knäckt" ; -- knäckt..av.1
  knäckthet_1_N = mkN "knäckthet" ; -- knäckthet..nn.1
  knäfall_1_N = mkN "knäfall" neutrum  ; -- knäfall..nn.1
  knäfalla_1_V = mkV "knäfalla" "knäföll" "knäfallit" ; -- knäfalla..vb.1
  knäfallande_1_N = mkN "knäfallande" ; -- knäfallande..nn.1
  knähund_1_N = mkN "knähund" ; -- knähund..nn.1
  knähög_1_A = mkA "knähög" ; -- knähög..av.1
  knähöjd_1_N = mkN "knähöjd" ; -- knähöjd..nn.1
  knäkort_1_A = mkA "knäkort" "knäkort" ; -- knäkort..av.1
  knäled_1_N = mkN "knäled" "knäleder" ; -- knäled..nn.1
  knälång_1_A = mkA "knälång" ; -- knälång..av.1
  knäoperation_1_N = mkN "knäoperation" ; -- knäoperation..nn.1
  knäpp_1_A = mkA "knäpp" ; -- knäpp..av.1
  knäpp_1_N = mkN "knäpp" ; -- knäpp..nn.1
  knäppa_1_V = mkV "knäpper" ; -- knäppa..vb.1
  knäppa_2_V = mkV "knäpper" ; -- knäppa..vb.2
  knäppande_1_N = mkN "knäppande" ; -- knäppande..nn.1
  knäppare_1_N = mkN "knäppare" utrum  ; -- knäppare..nn.1
  knäppbagge_1_N = mkN "knäppbagge" utrum  ; -- knäppbagge..nn.1
  knäppe_1_N = mkN "knäppe" ; -- knäppe..nn.1
  knäppfamilj_1_N = mkN "knäppfamilj" "knäppfamiljer" ; -- knäppfamilj..nn.1
  knäppgök_1_N = mkN "knäppgök" ; -- knäppgök..nn.1
  knäpphet_1_N = mkN "knäpphet" ; -- knäpphet..nn.1
  knäppkänga_1_N = mkN "knäppkänga" ; -- knäppkänga..nn.1
  knäppning_1_N = mkN "knäppning" ; -- knäppning..nn.1
  knäppskalle_1_N = mkN "knäppskalle" utrum  ; -- knäppskalle..nn.1
  knäpptyst_1_A = mkA "knäpptyst" "knäpptyst" ; -- knäpptyst..av.1
  knärör_1_N = mkN "knärör" neutrum  ; -- knärör..nn.1
  knäsittning_1_N = mkN "knäsittning" ; -- knäsittning..nn.1
  knäskada_1_N = mkN "knäskada" ; -- knäskada..nn.1
  knäskadad_1_A = mkA "knäskadad" ; -- knäskadad..av.1
  knäskura_1_V = mkV "knäskurar" ; -- knäskura..vb.1
  knäskurande_1_N = mkN "knäskurande" ; -- knäskurande..nn.1
  knäskurning_1_N = mkN "knäskurning" ; -- knäskurning..nn.1
  knäskydd_1_N = mkN "knäskydd" neutrum  ; -- knäskydd..nn.1
  knäskål_1_N = mkN "knäskål" ; -- knäskål..nn.1
  knäslut_1_N = mkN "knäslut" neutrum  ; -- knäslut..nn.1
  knästrumpa_1_N = mkN "knästrumpa" ; -- knästrumpa..nn.1
  knästående_1_N = mkN "knästående" ; -- knästående..nn.1
  knäsvag_1_A = mkA "knäsvag" ; -- knäsvag..av.1
  knäsvaghet_1_N = mkN "knäsvaghet" ; -- knäsvaghet..nn.1
  knäsätta_1_V = mkV "knäsätta" "knäsätter" "knäsätt" "knäsatte" "knäsatt" "knäsatt" ; -- knäsätta..vb.1
  knäsättande_1_N = mkN "knäsättande" ; -- knäsättande..nn.1
  knätofs_1_N = mkN "knätofs" ; -- knätofs..nn.1
  knätrakt_1_N = mkN "knätrakt" "knätrakter" ; -- knätrakt..nn.1
  knäveck_1_N = mkN "knäveck" neutrum  ; -- knäveck..nn.1
  knävelborr_1_N = mkN "knävelborr" ; -- knävelborr..nn.1
  knävring_1_N = mkN "knävring" ; -- knävring..nn.1
  knävärmare_1_N = mkN "knävärmare" utrum  ; -- knävärmare..nn.1
  knåda_1_V = mkV "knådar" ; -- knåda..vb.1
  knådande_1_N = mkN "knådande" ; -- knådande..nn.1
  knådbar_1_A = mkA "knådbar" ; -- knådbar..av.1
  knådbarhet_1_N = mkN "knådbarhet" ; -- knådbarhet..nn.1
  knådning_1_N = mkN "knådning" ; -- knådning..nn.1
  knåp_1_N = mkN "knåp" neutrum  ; -- knåp..nn.1
  knåpa_1_V = mkV "knåpar" ; -- knåpa..vb.1
  knåpande_1_N = mkN "knåpande" ; -- knåpande..nn.1
  knödel_1_N = mkN "knödel" ; -- knödel..nn.1
  knöka_1_V = mkV "knökar" ; -- knöka..vb.1
  knökande_1_N = mkN "knökande" ; -- knökande..nn.1
  knökfull_1_A = mkA "knökfull" ; -- knökfull..av.1
  knökfullhet_1_N = mkN "knökfullhet" ; -- knökfullhet..nn.1
  knöl_1_N = mkN "knöl" ; -- knöl..nn.1
  knöla_1_V = mkV "knölar" ; -- knöla..vb.1
  knölaktig_1_A = mkA "knölaktig" ; -- knölaktig..av.1
  knölaktighet_1_N = mkN "knölaktighet" ; -- knölaktighet..nn.1
  knölande_1_N = mkN "knölande" ; -- knölande..nn.1
  knölig_1_A = mkA "knölig" ; -- knölig..av.1
  knölighet_1_N = mkN "knölighet" "knöligheter" ; -- knölighet..nn.1
  knölpåk_1_N = mkN "knölpåk" ; -- knölpåk..nn.1
  knölros_1_N = mkN "knölros" ; -- knölros..nn.1
  knölrot_1_N = mkN "knölrot" "knölrötter" ; -- knölrot..nn.1
  knölstam_1_N = mkN "knölstam" "knölstammen" "knölstammar" "knölstammarna" ; -- knölstam..nn.1
  knölsvan_1_N = mkN "knölsvan" ; -- knölsvan..nn.1
  knös_1_N = mkN "knös" ; -- knös..nn.1
  ko_1_N = mkN "ko" "kor" ; -- ko..nn.1
  koaffera_1_V = mkV "koafferar" ; -- koaffera..vb.1
  koafferande_1_N = mkN "koafferande" ; -- koafferande..nn.1
  koafferbar_1_A = mkA "koafferbar" ; -- koafferbar..av.1
  koafferbarhet_1_N = mkN "koafferbarhet" ; -- koafferbarhet..nn.1
  koaffering_1_N = mkN "koaffering" ; -- koaffering..nn.1
  koaffyr_1_N = mkN "koaffyr" "koaffyrer" ; -- koaffyr..nn.1
  koafför_1_N = mkN "koafför" "koafförer" ; -- koafför..nn.1
  koagulation_1_N = mkN "koagulation" ; -- koagulation..nn.1
  koagulera_1_V = mkV "koagulerar" ; -- koagulera..vb.1
  koagulerande_1_N = mkN "koagulerande" ; -- koagulerande..nn.1
  koagulerbar_1_A = mkA "koagulerbar" ; -- koagulerbar..av.1
  koagulerbarhet_1_N = mkN "koagulerbarhet" ; -- koagulerbarhet..nn.1
  koagulering_1_N = mkN "koagulering" ; -- koagulering..nn.1
  koala_1_N = mkN "koala" ; -- koala..nn.1
  koalition_1_N = mkN "koalition" ; -- koalition..nn.1
  koalitionsregering_1_N = mkN "koalitionsregering" ; -- koalitionsregering..nn.1
  koarktation_1_N = mkN "koarktation" ; -- koarktation..nn.1
  koarsel_1_N = mkN "koarsel" ; -- koarsel..nn.1
  koarsle_1_N = mkN "koarsle" ; -- koarsle..nn.1
  koaxialkabel_1_N = mkN "koaxialkabel" ; -- koaxialkabel..nn.1
  kobbe_1_N = mkN "kobbe" utrum  ; -- kobbe..nn.1
  kobbel_1_N = mkN "kobbel" ; -- kobbel..nn.1
  kobent_1_A = mkA "kobent" "kobent" ; -- kobent..av.1
  kobenthet_1_N = mkN "kobenthet" ; -- kobenthet..nn.1
  kobingo_1_N = mkN "kobingo" ; -- kobingo..nn.1
  kobolt_1_N = mkN "kobolt" ; -- kobolt..nn.1
  koboltblå_1_A = mkA "koboltblå" "koboltblått" ; -- koboltblå..av.1
  koboltblått_1_N = mkN "koboltblått" ; -- koboltblått..nn.1
  koboltglans_1_N = mkN "koboltglans" ; -- koboltglans..nn.1
  kobolthalt_1_N = mkN "kobolthalt" "kobolthalter" ; -- kobolthalt..nn.1
  kobolthaltig_1_A = mkA "kobolthaltig" ; -- kobolthaltig..av.1
  koboltjon_1_N = mkN "koboltjon" "koboltjoner" ; -- koboltjon..nn.1
  koboltkanon_1_N = mkN "koboltkanon" "koboltkanoner" ; -- koboltkanon..nn.1
  kobra_1_N = mkN "kobra" ; -- kobra..nn.1
  kobrygga_1_N = mkN "kobrygga" ; -- kobrygga..nn.1
  kobärsa_1_N = mkN "kobärsa" ; -- kobärsa..nn.1
  kock_1_N = mkN "kock" ; -- kock..nn.1
  kock_2_N = mkN "kock" "kocker" ; -- kock..nn.2
  kocka_1_N = mkN "kocka" ; -- kocka..nn.1
  kocka_1_V = mkV "kockar" ; -- kocka..vb.1
  kockande_1_N = mkN "kockande" ; -- kockande..nn.1
  kockmössa_1_N = mkN "kockmössa" ; -- kockmössa..nn.1
  kocko_1_A = mkA "kocko" ; -- kocko..av.1
  kod_1_N = mkN "kod" "koder" ; -- kod..nn.1
  kod_2_N = mkN "kod" ; -- kod..nn.2
  koda_1_V = mkV "kodar" ; -- koda..vb.1
  kodande_1_N = mkN "kodande" ; -- kodande..nn.1
  kodein_1_N = mkN "kodein" ; -- kodein..nn.1
  kodex_1_N = mkN "kodex" ; -- kodex..nn.1
  kodicill_1_N = mkN "kodicill" "kodiciller" ; -- kodicill..nn.1
  kodifiera_1_V = mkV "kodifierar" ; -- kodifiera..vb.1
  kodifierande_1_N = mkN "kodifierande" ; -- kodifierande..nn.1
  kodifierbar_1_A = mkA "kodifierbar" ; -- kodifierbar..av.1
  kodifierbarhet_1_N = mkN "kodifierbarhet" ; -- kodifierbarhet..nn.1
  kodifiering_1_N = mkN "kodifiering" ; -- kodifiering..nn.1
  kodifikation_1_N = mkN "kodifikation" ; -- kodifikation..nn.1
  kodilj_1_N = mkN "kodilj" ; -- kodilj..nn.1
  kodlås_1_N = mkN "kodlås" neutrum  ; -- kodlås..nn.1
  kodressör_1_N = mkN "kodressör" "kodressörer" ; -- kodressör..nn.1
  kodspråk_1_N = mkN "kodspråk" neutrum  ; -- kodspråk..nn.1
  kodväxla_1_V = mkV "kodväxlar" ; -- kodväxla..vb.1
  kodväxlande_1_N = mkN "kodväxlande" ; -- kodväxlande..nn.1
  kodväxling_1_N = mkN "kodväxling" ; -- kodväxling..nn.1
  koefficient_1_N = mkN "koefficient" "koefficienter" ; -- koefficient..nn.1
  koexistens_1_N = mkN "koexistens" ; -- koexistens..nn.1
  koff_1_N = mkN "koff" ; -- koff..nn.1
  koffein_1_N = mkN "koffein" ; -- koffein..nn.1
  kofferdamm_1_N = mkN "kofferdamm" ; -- kofferdamm..nn.1
  kofferdiflotta_1_N = mkN "kofferdiflotta" ; -- kofferdiflotta..nn.1
  kofferdist_1_N = mkN "kofferdist" "kofferdister" ; -- kofferdist..nn.1
  koffernagel_1_N = mkN "koffernagel" ; -- koffernagel..nn.1
  koffert_1_N = mkN "koffert" ; -- koffert..nn.1
  koffertfisk_1_N = mkN "koffertfisk" ; -- koffertfisk..nn.1
  koflock_1_N = mkN "koflock" ; -- koflock..nn.1
  kofot_1_N = mkN "kofot" ; -- kofot..nn.1
  kofta_1_N = mkN "kofta" ; -- kofta..nn.1
  koftgrå_1_A = mkA "koftgrå" "koftgrått" ; -- koftgrå..av.1
  kofångare_1_N = mkN "kofångare" utrum  ; -- kofångare..nn.1
  koger_1_N = mkN "koger" neutrum  ; -- koger..nn.1
  kogg_1_N = mkN "kogg" ; -- kogg..nn.1
  kognat_1_N = mkN "kognat" "kognater" ; -- kognat..nn.1
  kognatisk_1_A = mkA "kognatisk" ; -- kognatisk..av.1
  kognition_1_N = mkN "kognition" ; -- kognition..nn.1
  kognitiv_1_A = mkA "kognitiv" ; -- kognitiv..av.1
  kohage_1_N = mkN "kohage" utrum  ; -- kohage..nn.1
  kohandel_1_N = mkN "kohandel" ; -- kohandel..nn.1
  kohandla_1_V = mkV "kohandlar" ; -- kohandla..vb.1
  kohandlande_1_N = mkN "kohandlande" ; -- kohandlande..nn.1
  koherens_1_N = mkN "koherens" ; -- koherens..nn.1
  koherent_1_A = mkA "koherent" "koherent" ; -- koherent..av.1
  kohesion_1_N = mkN "kohesion" ; -- kohesion..nn.1
  kohesionskraft_1_N = mkN "kohesionskraft" "kohesionskrafter" ; -- kohesionskraft..nn.1
  kohesiv_1_A = mkA "kohesiv" ; -- kohesiv..av.1
  kohl_1_N = mkN "kohl" ; -- kohl..nn.1
  kohort_1_N = mkN "kohort" "kohorter" ; -- kohort..nn.1
  kohud_1_N = mkN "kohud" ; -- kohud..nn.1
  koine_1_N = mkN "koine" ; -- koine..nn.1
  koineisering_1_N = mkN "koineisering" ; -- koineisering..nn.1
  koj_1_N = mkN "koj" "kojer" ; -- koj..nn.1
  koja_1_N = mkN "koja" ; -- koja..nn.1
  koja_1_V = mkV "kojar" ; -- koja..vb.1
  kojande_1_N = mkN "kojande" ; -- kojande..nn.1
  kojplats_1_N = mkN "kojplats" "kojplatser" ; -- kojplats..nn.1
  kojsa_1_V = mkV "kojsar" ; -- kojsa..vb.1
  kojsande_1_N = mkN "kojsande" ; -- kojsande..nn.1
  kok_1_N = mkN "kok" neutrum  ; -- kok..nn.1
  koka_1_N = mkN "koka" ; -- koka..nn.1
  koka_2_N = mkN "koka" ; -- koka..nn.2
  koka_1_V = mkV "koker" ; -- koka..vb.1
  koka_2_V = mkV "kokar" ; -- koka..vb.2
  kokain_1_N = mkN "kokain" ; -- kokain..nn.1
  kokainhandel_1_N = mkN "kokainhandel" ; -- kokainhandel..nn.1
  kokainism_1_N = mkN "kokainism" "kokainismer" ; -- kokainism..nn.1
  kokainist_1_N = mkN "kokainist" "kokainister" ; -- kokainist..nn.1
  kokainliga_1_N = mkN "kokainliga" ; -- kokainliga..nn.1
  kokakola_1_N = mkN "kokakola" ; -- kokakola..nn.1
  kokalv_1_N = mkN "kokalv" ; -- kokalv..nn.1
  kokande_1_N = mkN "kokande" ; -- kokande..nn.1
  kokapparat_1_N = mkN "kokapparat" "kokapparater" ; -- kokapparat..nn.1
  kokard_1_N = mkN "kokard" "kokarder" ; -- kokard..nn.1
  kokare_1_N = mkN "kokare" utrum  ; -- kokare..nn.1
  kokarreaktor_1_N = mkN "kokarreaktor" "kokarreaktorer" ; -- kokarreaktor..nn.1
  kokbarometer_1_N = mkN "kokbarometer" ; -- kokbarometer..nn.1
  kokbok_1_N = mkN "kokbok" "kokböcker" ; -- kokbok..nn.1
  kokboksstöld_1_N = mkN "kokboksstöld" "kokboksstölder" ; -- kokboksstöld..nn.1
  kokeri_1_N = mkN "kokeri" "kokeriet" "kokerier" "kokerierna" ; -- kokeri..nn.1
  kokerska_1_N = mkN "kokerska" ; -- kokerska..nn.1
  kokett_1_A = mkA "kokett" ; -- kokett..av.1
  kokett_1_N = mkN "kokett" "koketter" ; -- kokett..nn.1
  kokettera_1_V = mkV "koketterar" ; -- kokettera..vb.1
  koketterande_1_N = mkN "koketterande" ; -- koketterande..nn.1
  koketteri_1_N = mkN "koketteri" "koketteriet" "koketterier" "koketterierna" ; -- koketteri..nn.1
  kokettering_1_N = mkN "kokettering" ; -- kokettering..nn.1
  koketthet_1_N = mkN "koketthet" ; -- koketthet..nn.1
  kokgrop_1_N = mkN "kokgrop" ; -- kokgrop..nn.1
  kokhet_1_A = mkA "kokhet" ; -- kokhet..av.1
  kokill_1_N = mkN "kokill" "kokiller" ; -- kokill..nn.1
  kokkaffe_1_N = mkN "kokkaffe" ; -- kokkaffe..nn.1
  kokkonst_1_N = mkN "kokkonst" ; -- kokkonst..nn.1
  kokkorv_1_N = mkN "kokkorv" ; -- kokkorv..nn.1
  kokkärl_1_N = mkN "kokkärl" neutrum  ; -- kokkärl..nn.1
  kokkött_1_N = mkN "kokkött" neutrum  ; -- kokkött..nn.1
  koklåda_1_N = mkN "koklåda" ; -- koklåda..nn.1
  koklåga_1_N = mkN "koklåga" ; -- koklåga..nn.1
  kokmald_1_A = mkA "kokmald" "kokmalt" ; -- kokmald..av.1
  kokning_1_N = mkN "kokning" ; -- kokning..nn.1
  koko_1_A = mkA "koko" ; -- koko..av.1
  kokong_1_N = mkN "kokong" "kokonger" ; -- kokong..nn.1
  kokos_1_N = mkN "kokos" ; -- kokos..nn.1
  kokosboll_1_N = mkN "kokosboll" ; -- kokosboll..nn.1
  kokosfett_1_N = mkN "kokosfett" neutrum  ; -- kokosfett..nn.1
  kokosfiber_1_N = mkN "kokosfiber" "kokosfibern" "kokosfibrer" "kokosfibrerna" ; -- kokosfiber..nn.1
  kokoshår_1_N = mkN "kokoshår" neutrum  ; -- kokoshår..nn.1
  kokoskaka_1_N = mkN "kokoskaka" ; -- kokoskaka..nn.1
  kokosmatta_1_N = mkN "kokosmatta" ; -- kokosmatta..nn.1
  kokosmjölk_1_N = mkN "kokosmjölk" ; -- kokosmjölk..nn.1
  kokosnöt_1_N = mkN "kokosnöt" "kokosnötter" ; -- kokosnöt..nn.1
  kokospalm_1_N = mkN "kokospalm" "kokospalmer" ; -- kokospalm..nn.1
  kokott_1_N = mkN "kokott" "kokotter" ; -- kokott..nn.1
  kokplatta_1_N = mkN "kokplatta" ; -- kokplatta..nn.1
  kokpunkt_1_N = mkN "kokpunkt" "kokpunkter" ; -- kokpunkt..nn.1
  koks_1_N = mkN "koks" ; -- koks..nn.1
  koksa_1_V = mkV "koksar" ; -- koksa..vb.1
  koksalt_1_N = mkN "koksalt" neutrum  ; -- koksalt..nn.1
  koksande_1_N = mkN "koksande" ; -- koksande..nn.1
  koksgrå_1_A = mkA "koksgrå" "koksgrått" ; -- koksgrå..av.1
  koksning_1_N = mkN "koksning" ; -- koksning..nn.1
  kokt_1_A = mkA "kokt" "kokt" ; -- kokt..av.1
  koktid_1_N = mkN "koktid" "koktider" ; -- koktid..nn.1
  kokvagn_1_N = mkN "kokvagn" ; -- kokvagn..nn.1
  kokvrå_1_N = mkN "kokvrå" "kokvrån" "kokvrår" "kokvrårna" ; -- kokvrå..nn.1
  kol_14_laboratorium_1_N = mkN "kol-14-laboratorium" "kol-14-laboratoriet" "kol-14-laboratorier" "kol-14-laboratorierna" ; -- kol-14-laboratorium..nn.1
  kol_14_metod_1_N = mkN "kol-14-metod" ; -- kol-14-metod..nn.1
  kol_1_N = mkN "kol" neutrum  ; -- kol..nn.1
  kola_1_N = mkN "kola" ; -- kola..nn.1
  kola_2_N = mkN "kola" ; -- kola..nn.2
  kola_1_V = mkV "kolar" ; -- kola..vb.1
  kola_2_1_V = mkV "kolar" ; -- kola_2..vb.1
  kolande_1_N = mkN "kolande" ; -- kolande..nn.1
  kolare_1_N = mkN "kolare" utrum  ; -- kolare..nn.1
  kolarkoja_1_N = mkN "kolarkoja" ; -- kolarkoja..nn.1
  kolartro_1_N = mkN "kolartro" ; -- kolartro..nn.1
  kolatom_1_N = mkN "kolatom" "kolatomer" ; -- kolatom..nn.1
  kolaträd_1_N = mkN "kolaträd" neutrum  ; -- kolaträd..nn.1
  kolbit_1_N = mkN "kolbit" ; -- kolbit..nn.1
  kolboll_1_N = mkN "kolboll" ; -- kolboll..nn.1
  kolborste_1_N = mkN "kolborste" utrum  ; -- kolborste..nn.1
  kolbotten_1_N = mkN "kolbotten" ; -- kolbotten..nn.1
  kolbox_1_N = mkN "kolbox" ; -- kolbox..nn.1
  kolbrikett_1_N = mkN "kolbrikett" "kolbriketter" ; -- kolbrikett..nn.1
  kolbulle_1_N = mkN "kolbulle" utrum  ; -- kolbulle..nn.1
  kolbärare_1_N = mkN "kolbärare" utrum  ; -- kolbärare..nn.1
  kolchos_1_N = mkN "kolchos" "kolchoser" ; -- kolchos..nn.1
  koldammslunga_1_N = mkN "koldammslunga" ; -- koldammslunga..nn.1
  koldioxid_1_N = mkN "koldioxid" "koldioxider" ; -- koldioxid..nn.1
  koldioxidavskiljning_1_N = mkN "koldioxidavskiljning" ; -- koldioxidavskiljning..nn.1
  koldioxidfri_1_A = mkA "koldioxidfri" "koldioxidfritt" ; -- koldioxidfri..av.1
  koldioxidförorenande_1_A = mkA "koldioxidförorenande" ; -- koldioxidförorenande..av.1
  koldioxidhalt_1_N = mkN "koldioxidhalt" "koldioxidhalter" ; -- koldioxidhalt..nn.1
  koldioxidkanal_1_N = mkN "koldioxidkanal" "koldioxidkanaler" ; -- koldioxidkanal..nn.1
  koldioxidlagring_1_N = mkN "koldioxidlagring" ; -- koldioxidlagring..nn.1
  koldioxidmolekyl_1_N = mkN "koldioxidmolekyl" "koldioxidmolekyler" ; -- koldioxidmolekyl..nn.1
  koldioxidutsläpp_1_N = mkN "koldioxidutsläpp" neutrum  ; -- koldioxidutsläpp..nn.1
  koldisulfid_1_N = mkN "koldisulfid" ; -- koldisulfid..nn.1
  koleld_1_N = mkN "koleld" ; -- koleld..nn.1
  kolera_1_N = mkN "kolera" ; -- kolera..nn.1
  kolerabakterie_1_N = mkN "kolerabakterie" "kolerabakterier" ; -- kolerabakterie..nn.1
  koleraepidemi_1_N = mkN "koleraepidemi" "koleraepidemier" ; -- koleraepidemi..nn.1
  koleraflagga_1_N = mkN "koleraflagga" ; -- koleraflagga..nn.1
  kolerakyrkogård_1_N = mkN "kolerakyrkogård" ; -- kolerakyrkogård..nn.1
  koleriker_1_N = mkN "koleriker" "kolerikern" "koleriker" "kolerikerna" ; -- koleriker..nn.1
  kolerisk_1_A = mkA "kolerisk" ; -- kolerisk..av.1
  kolesterol_1_N = mkN "kolesterol" ; -- kolesterol..nn.1
  kolesterolsänkande_1_A = mkA "kolesterolsänkande" ; -- kolesterolsänkande..av.1
  kolfilter_1_N = mkN "kolfilter" neutrum  ; -- kolfilter..nn.1
  kolflöts_1_N = mkN "kolflöts" "kolflötser" ; -- kolflöts..nn.1
  kolförening_1_N = mkN "kolförening" ; -- kolförening..nn.1
  kolgruva_1_N = mkN "kolgruva" ; -- kolgruva..nn.1
  kolgruveolycka_1_N = mkN "kolgruveolycka" ; -- kolgruveolycka..nn.1
  kolhalt_1_N = mkN "kolhalt" "kolhalter" ; -- kolhalt..nn.1
  kolhaltig_1_A = mkA "kolhaltig" ; -- kolhaltig..av.1
  kolhydrat_1_N = mkN "kolhydrat" neutrum  ; -- kolhydrat..nn.1
  kolhämtare_1_N = mkN "kolhämtare" utrum  ; -- kolhämtare..nn.1
  kolhög_1_N = mkN "kolhög" ; -- kolhög..nn.1
  kolibakterie_1_N = mkN "kolibakterie" "kolibakterier" ; -- kolibakterie..nn.1
  kolibri_1_N = mkN "kolibri" "kolibrin" "kolibrier" "kolibrierna" ; -- kolibri..nn.1
  kolifej_1_N = mkN "kolifej" neutrum  ; -- kolifej..nn.1
  kolik_1_N = mkN "kolik" ; -- kolik..nn.1
  kolikanfall_1_N = mkN "kolikanfall" neutrum  ; -- kolikanfall..nn.1
  koling_1_N = mkN "koling" ; -- koling..nn.1
  kolisotop_1_N = mkN "kolisotop" "kolisotoper" ; -- kolisotop..nn.1
  kolit_1_N = mkN "kolit" ; -- kolit..nn.1
  kolja_1_N = mkN "kolja" ; -- kolja..nn.1
  koljé_1_N = mkN "koljé" "koljéer" ; -- koljé..nn.1
  kolka_1_V = mkV "kolkar" ; -- kolka..vb.1
  kolkande_1_N = mkN "kolkande" ; -- kolkande..nn.1
  kolkraftverk_1_N = mkN "kolkraftverk" neutrum  ; -- kolkraftverk..nn.1
  koll_1_N = mkN "koll" ; -- koll..nn.1
  koll_2_N = mkN "koll" ; -- koll..nn.2
  kolla_1_V = mkV "kollar" ; -- kolla..vb.1
  kolla_2_V = mkV "kollar" ; -- kolla..vb.2
  kollabera_1_V = mkV "kollaberar" ; -- kollabera..vb.1
  kollaberande_1_N = mkN "kollaberande" ; -- kollaberande..nn.1
  kollabering_1_N = mkN "kollabering" ; -- kollabering..nn.1
  kollaboratör_1_N = mkN "kollaboratör" "kollaboratörer" ; -- kollaboratör..nn.1
  kollaborera_1_V = mkV "kollaborerar" ; -- kollaborera..vb.1
  kollaborerande_1_N = mkN "kollaborerande" ; -- kollaborerande..nn.1
  kollaborering_1_N = mkN "kollaborering" ; -- kollaborering..nn.1
  kollage_1_N = mkN "kollage" "kollaget" "kollage" "kollagen" ; -- kollage..nn.1
  kollande_1_N = mkN "kollande" ; -- kollande..nn.1
  kollaps_1_N = mkN "kollaps" "kollapser" ; -- kollaps..nn.1
  kollapsa_1_V = mkV "kollapsar" ; -- kollapsa..vb.1
  kollapsande_1_N = mkN "kollapsande" ; -- kollapsande..nn.1
  kollast_1_N = mkN "kollast" "kollaster" ; -- kollast..nn.1
  kollastkapacitet_1_N = mkN "kollastkapacitet" ; -- kollastkapacitet..nn.1
  kollation_1_N = mkN "kollation" ; -- kollation..nn.1
  kollationera_1_V = mkV "kollationerar" ; -- kollationera..vb.1
  kollationerande_1_N = mkN "kollationerande" ; -- kollationerande..nn.1
  kollationerbar_1_A = mkA "kollationerbar" ; -- kollationerbar..av.1
  kollationerbarhet_1_N = mkN "kollationerbarhet" ; -- kollationerbarhet..nn.1
  kollationering_1_N = mkN "kollationering" ; -- kollationering..nn.1
  kollega_1_N = mkN "kollega" ; -- kollega..nn.1
  kollegial_1_A = mkA "kollegial" ; -- kollegial..av.1
  kollegialitet_1_N = mkN "kollegialitet" "kollegialiteter" ; -- kollegialitet..nn.1
  kollegieblock_1_N = mkN "kollegieblock" neutrum  ; -- kollegieblock..nn.1
  kollegium_1_N = mkN "kollegium" "kollegiet" "kollegier" "kollegierna" ; -- kollegium..nn.1
  kollekt_1_N = mkN "kollekt" "kollekter" ; -- kollekt..nn.1
  kollekta_1_N = mkN "kollekta" ; -- kollekta..nn.1
  kollektbössa_1_N = mkN "kollektbössa" ; -- kollektbössa..nn.1
  kollekthåv_1_N = mkN "kollekthåv" ; -- kollekthåv..nn.1
  kollektion_1_N = mkN "kollektion" ; -- kollektion..nn.1
  kollektiv_1_A = mkA "kollektiv" ; -- kollektiv..av.1
  kollektiv_1_N = mkN "kollektiv" neutrum  ; -- kollektiv..nn.1
  kollektivanslutning_1_N = mkN "kollektivanslutning" ; -- kollektivanslutning..nn.1
  kollektivanställd_1_A = mkA "kollektivanställd" "kollektivanställt" ; -- kollektivanställd..av.1
  kollektivanställning_1_N = mkN "kollektivanställning" ; -- kollektivanställning..nn.1
  kollektivavtal_1_N = mkN "kollektivavtal" neutrum  ; -- kollektivavtal..nn.1
  kollektivfil_1_N = mkN "kollektivfil" "kollektivfiler" ; -- kollektivfil..nn.1
  kollektivförsäkring_1_N = mkN "kollektivförsäkring" ; -- kollektivförsäkring..nn.1
  kollektivhus_1_N = mkN "kollektivhus" neutrum  ; -- kollektivhus..nn.1
  kollektivisera_1_V = mkV "kollektiviserar" ; -- kollektivisera..vb.1
  kollektiviserande_1_N = mkN "kollektiviserande" ; -- kollektiviserande..nn.1
  kollektiviserbar_1_A = mkA "kollektiviserbar" ; -- kollektiviserbar..av.1
  kollektiviserbarhet_1_N = mkN "kollektiviserbarhet" ; -- kollektiviserbarhet..nn.1
  kollektivisering_1_N = mkN "kollektivisering" ; -- kollektivisering..nn.1
  kollektivism_1_N = mkN "kollektivism" "kollektivismer" ; -- kollektivism..nn.1
  kollektivist_1_N = mkN "kollektivist" "kollektivister" ; -- kollektivist..nn.1
  kollektivistisk_1_A = mkA "kollektivistisk" ; -- kollektivistisk..av.1
  kollektivjordbruk_1_N = mkN "kollektivjordbruk" neutrum  ; -- kollektivjordbruk..nn.1
  kollektivnot_1_N = mkN "kollektivnot" "kollektivnoter" ; -- kollektivnot..nn.1
  kollektivtrafik_1_N = mkN "kollektivtrafik" ; -- kollektivtrafik..nn.1
  kollektivtänkande_1_N = mkN "kollektivtänkande" ; -- kollektivtänkande..nn.1
  kollektor_1_N = mkN "kollektor" "kollektorer" ; -- kollektor..nn.1
  koller_1_N = mkN "koller" ; -- koller..nn.1
  kolli_1_N = mkN "kolli" "kollit" "kollin" "kollina" ; -- kolli..nn.1
  kollidera_1_V = mkV "kolliderar" ; -- kollidera..vb.1
  kolliderande_1_N = mkN "kolliderande" ; -- kolliderande..nn.1
  kollidering_1_N = mkN "kollidering" ; -- kollidering..nn.1
  kollision_1_N = mkN "kollision" ; -- kollision..nn.1
  kollisionsenergi_1_N = mkN "kollisionsenergi" ; -- kollisionsenergi..nn.1
  kollisionskurs_1_N = mkN "kollisionskurs" "kollisionskurser" ; -- kollisionskurs..nn.1
  kollisionsskott_1_N = mkN "kollisionsskott" neutrum  ; -- kollisionsskott..nn.1
  kollo_1_N = mkN "kollo" "kollot" "kollon" "kollona" ; -- kollo..nn.1
  kollodium_1_N = mkN "kollodium" "kollodiet" "kollodier" "kollodierna" ; -- kollodium..nn.1
  kolloid_1_N = mkN "kolloid" "kolloider" ; -- kolloid..nn.1
  kolloidal_1_A = mkA "kolloidal" ; -- kolloidal..av.1
  kollokat_1_N = mkN "kollokat" neutrum  ; -- kollokat..nn.1
  kollokation_1_N = mkN "kollokation" ; -- kollokation..nn.1
  kollokvium_1_N = mkN "kollokvium" "kollokviet" "kollokvier" "kollokvierna" ; -- kollokvium..nn.1
  kollrig_1_A = mkA "kollrig" ; -- kollrig..av.1
  kollrighet_1_N = mkN "kollrighet" ; -- kollrighet..nn.1
  kollusion_1_N = mkN "kollusion" ; -- kollusion..nn.1
  kolm_1_N = mkN "kolm" ; -- kolm..nn.1
  kolmila_1_N = mkN "kolmila" ; -- kolmila..nn.1
  kolmilning_1_N = mkN "kolmilning" ; -- kolmilning..nn.1
  kolmonoxid_1_N = mkN "kolmonoxid" ; -- kolmonoxid..nn.1
  kolmonoxidförgiftning_1_N = mkN "kolmonoxidförgiftning" ; -- kolmonoxidförgiftning..nn.1
  kolmörk_1_A = mkA "kolmörk" ; -- kolmörk..av.1
  kolmörker_1_N = mkN "kolmörker" neutrum  ; -- kolmörker..nn.1
  kolnanorör_1_N = mkN "kolnanorör" neutrum  ; -- kolnanorör..nn.1
  kolning_1_N = mkN "kolning" ; -- kolning..nn.1
  kolofon_1_N = mkN "kolofon" "kolofoner" ; -- kolofon..nn.1
  kolokvint_1_N = mkN "kolokvint" "kolokvinter" ; -- kolokvint..nn.1
  kolon_1_N = mkN "kolon" neutrum  ; -- kolon..nn.1
  kolon_2_N = mkN "kolon" ; -- kolon..nn.2
  kolonat_1_N = mkN "kolonat" neutrum  ; -- kolonat..nn.1
  koloni_1_N = mkN "koloni" "kolonier" ; -- koloni..nn.1
  kolonial_1_A = mkA "kolonial" ; -- kolonial..av.1
  kolonialarmé_1_N = mkN "kolonialarmé" "kolonialarméer" ; -- kolonialarmé..nn.1
  kolonialexpansion_1_N = mkN "kolonialexpansion" ; -- kolonialexpansion..nn.1
  kolonialiseringsprocess_1_N = mkN "kolonialiseringsprocess" "kolonialiseringsprocesser" ; -- kolonialiseringsprocess..nn.1
  kolonialism_1_N = mkN "kolonialism" "kolonialismer" ; -- kolonialism..nn.1
  kolonialistisk_1_A = mkA "kolonialistisk" ; -- kolonialistisk..av.1
  kolonialkrig_1_N = mkN "kolonialkrig" neutrum  ; -- kolonialkrig..nn.1
  kolonialmakt_1_N = mkN "kolonialmakt" "kolonialmakter" ; -- kolonialmakt..nn.1
  kolonialpolitik_1_N = mkN "kolonialpolitik" ; -- kolonialpolitik..nn.1
  kolonialstil_1_N = mkN "kolonialstil" ; -- kolonialstil..nn.1
  kolonialtid_1_N = mkN "kolonialtid" ; -- kolonialtid..nn.1
  kolonialvara_1_N = mkN "kolonialvara" ; -- kolonialvara..nn.1
  kolonialvälde_1_N = mkN "kolonialvälde" ; -- kolonialvälde..nn.1
  koloniland_1_N = mkN "koloniland" neutrum  ; -- koloniland..nn.1
  kolonilott_1_N = mkN "kolonilott" "kolonilotter" ; -- kolonilott..nn.1
  kolonilottsodlare_1_N = mkN "kolonilottsodlare" utrum  ; -- kolonilottsodlare..nn.1
  kolonisation_1_N = mkN "kolonisation" ; -- kolonisation..nn.1
  kolonisationsförsök_1_N = mkN "kolonisationsförsök" neutrum  ; -- kolonisationsförsök..nn.1
  kolonisationstid_1_N = mkN "kolonisationstid" "kolonisationstider" ; -- kolonisationstid..nn.1
  kolonisatör_1_N = mkN "kolonisatör" "kolonisatörer" ; -- kolonisatör..nn.1
  kolonisera_1_V = mkV "koloniserar" ; -- kolonisera..vb.1
  koloniserande_1_N = mkN "koloniserande" ; -- koloniserande..nn.1
  koloniserbar_1_A = mkA "koloniserbar" ; -- koloniserbar..av.1
  koloniserbarhet_1_N = mkN "koloniserbarhet" ; -- koloniserbarhet..nn.1
  kolonisering_1_N = mkN "kolonisering" ; -- kolonisering..nn.1
  kolonist_1_N = mkN "kolonist" "kolonister" ; -- kolonist..nn.1
  kolonistuga_1_N = mkN "kolonistuga" ; -- kolonistuga..nn.1
  kolonn_1_N = mkN "kolonn" "kolonner" ; -- kolonn..nn.1
  kolonnad_1_N = mkN "kolonnad" "kolonnader" ; -- kolonnad..nn.1
  kolonnett_1_N = mkN "kolonnett" "kolonnetter" ; -- kolonnett..nn.1
  kolonnomgärdad_1_A = mkA "kolonnomgärdad" ; -- kolonnomgärdad..av.1
  kolonnordning_1_N = mkN "kolonnordning" ; -- kolonnordning..nn.1
  koloradoskalbagge_1_N = mkN "koloradoskalbagge" utrum  ; -- koloradoskalbagge..nn.1
  koloratur_1_N = mkN "koloratur" "koloraturer" ; -- koloratur..nn.1
  koloraturaria_1_N = mkN "koloraturaria" ; -- koloraturaria..nn.1
  koloratursopran_1_N = mkN "koloratursopran" "koloratursopraner" ; -- koloratursopran..nn.1
  koloratursångerska_1_N = mkN "koloratursångerska" ; -- koloratursångerska..nn.1
  kolorera_1_V = mkV "kolorerar" ; -- kolorera..vb.1
  kolorerande_1_N = mkN "kolorerande" ; -- kolorerande..nn.1
  kolorerbar_1_A = mkA "kolorerbar" ; -- kolorerbar..av.1
  kolorerbarhet_1_N = mkN "kolorerbarhet" ; -- kolorerbarhet..nn.1
  kolorering_1_N = mkN "kolorering" ; -- kolorering..nn.1
  kolorism_1_N = mkN "kolorism" "kolorismer" ; -- kolorism..nn.1
  kolorist_1_N = mkN "kolorist" "kolorister" ; -- kolorist..nn.1
  koloristisk_1_A = mkA "koloristisk" ; -- koloristisk..av.1
  kolorit_1_N = mkN "kolorit" "koloriter" ; -- kolorit..nn.1
  kolos_1_N = mkN "kolos" neutrum  ; -- kolos..nn.1
  kolosförgiftning_1_N = mkN "kolosförgiftning" ; -- kolosförgiftning..nn.1
  koloskopi_1_N = mkN "koloskopi" "koloskopier" ; -- koloskopi..nn.1
  koloss_1_N = mkN "koloss" "kolosser" ; -- koloss..nn.1
  kolossal_1_A = mkA "kolossal" ; -- kolossal..av.1
  kolossalformat_1_N = mkN "kolossalformat" neutrum  ; -- kolossalformat..nn.1
  koloxid_1_N = mkN "koloxid" ; -- koloxid..nn.1
  koloxidförgiftning_1_N = mkN "koloxidförgiftning" ; -- koloxidförgiftning..nn.1
  kolportage_1_N = mkN "kolportage" ; -- kolportage..nn.1
  kolportagehäfte_1_N = mkN "kolportagehäfte" ; -- kolportagehäfte..nn.1
  kolportagemässig_1_A = mkA "kolportagemässig" ; -- kolportagemässig..av.1
  kolportagemässighet_1_N = mkN "kolportagemässighet" ; -- kolportagemässighet..nn.1
  kolportera_1_V = mkV "kolporterar" ; -- kolportera..vb.1
  kolporterande_1_N = mkN "kolporterande" ; -- kolporterande..nn.1
  kolporterbar_1_A = mkA "kolporterbar" ; -- kolporterbar..av.1
  kolporterbarhet_1_N = mkN "kolporterbarhet" ; -- kolporterbarhet..nn.1
  kolportering_1_N = mkN "kolportering" ; -- kolportering..nn.1
  kolportör_1_N = mkN "kolportör" "kolportörer" ; -- kolportör..nn.1
  kolryss_1_N = mkN "kolryss" ; -- kolryss..nn.1
  kolrök_1_N = mkN "kolrök" ; -- kolrök..nn.1
  kolrör_1_N = mkN "kolrör" neutrum  ; -- kolrör..nn.1
  kolskiss_1_N = mkN "kolskiss" "kolskisser" ; -- kolskiss..nn.1
  kolstift_1_N = mkN "kolstift" neutrum  ; -- kolstift..nn.1
  kolstybb_1_N = mkN "kolstybb" ; -- kolstybb..nn.1
  kolstybbsbana_1_N = mkN "kolstybbsbana" ; -- kolstybbsbana..nn.1
  kolstål_1_N = mkN "kolstål" neutrum  ; -- kolstål..nn.1
  kolsvart_1_A = mkA "kolsvart" "kolsvart" ; -- kolsvart..av.1
  kolsvavla_1_N = mkN "kolsvavla" ; -- kolsvavla..nn.1
  kolsyra_1_N = mkN "kolsyra" ; -- kolsyra..nn.1
  kolsyraassimilation_1_N = mkN "kolsyraassimilation" ; -- kolsyraassimilation..nn.1
  kolsyrad_1_A = mkA "kolsyrad" ; -- kolsyrad..av.1
  kolsyregevär_1_N = mkN "kolsyregevär" neutrum  ; -- kolsyregevär..nn.1
  kolsyremaskin_1_N = mkN "kolsyremaskin" "kolsyremaskiner" ; -- kolsyremaskin..nn.1
  kolsyrepatron_1_N = mkN "kolsyrepatron" "kolsyrepatroner" ; -- kolsyrepatron..nn.1
  kolsyrepistol_1_N = mkN "kolsyrepistol" "kolsyrepistoler" ; -- kolsyrepistol..nn.1
  kolsyresnö_1_N = mkN "kolsyresnö" ; -- kolsyresnö..nn.1
  kolsänka_1_N = mkN "kolsänka" ; -- kolsänka..nn.1
  kolt_1_N = mkN "kolt" ; -- kolt..nn.1
  koltablett_1_N = mkN "koltablett" "koltabletter" ; -- koltablett..nn.1
  koltavdelning_1_N = mkN "koltavdelning" ; -- koltavdelning..nn.1
  koltbarn_1_N = mkN "koltbarn" neutrum  ; -- koltbarn..nn.1
  kolteckning_1_N = mkN "kolteckning" ; -- kolteckning..nn.1
  koltetraklorid_1_N = mkN "koltetraklorid" ; -- koltetraklorid..nn.1
  koltrast_1_N = mkN "koltrast" ; -- koltrast..nn.1
  koltråd_1_N = mkN "koltråd" ; -- koltråd..nn.1
  koltålder_1_N = mkN "koltålder" ; -- koltålder..nn.1
  kolugn_1_A = mkA "kolugn" ; -- kolugn..av.1
  kolumbarium_1_N = mkN "kolumbarium" "kolumbariet" "kolumbarier" "kolumbarierna" ; -- kolumbarium..nn.1
  kolumn_1_N = mkN "kolumn" "kolumner" ; -- kolumn..nn.1
  kolumnist_1_N = mkN "kolumnist" "kolumnister" ; -- kolumnist..nn.1
  kolumntitel_1_N = mkN "kolumntitel" ; -- kolumntitel..nn.1
  kolumnutrymme_1_N = mkN "kolumnutrymme" ; -- kolumnutrymme..nn.1
  kolv_1_N = mkN "kolv" ; -- kolv..nn.1
  kolvhals_1_N = mkN "kolvhals" ; -- kolvhals..nn.1
  kolvmotor_1_N = mkN "kolvmotor" "kolvmotorer" ; -- kolvmotor..nn.1
  kolväte_1_N = mkN "kolväte" ; -- kolväte..nn.1
  koma_1_N = mkN "koma" ; -- koma..nn.1
  komatös_1_A = mkA "komatös" ; -- komatös..av.1
  kombattant_1_N = mkN "kombattant" "kombattanter" ; -- kombattant..nn.1
  kombibil_1_N = mkN "kombibil" ; -- kombibil..nn.1
  kombinabilitet_1_N = mkN "kombinabilitet" ; -- kombinabilitet..nn.1
  kombinat_1_N = mkN "kombinat" neutrum  ; -- kombinat..nn.1
  kombination_1_N = mkN "kombination" ; -- kombination..nn.1
  kombinationsförmåga_1_N = mkN "kombinationsförmåga" ; -- kombinationsförmåga..nn.1
  kombinationslås_1_N = mkN "kombinationslås" neutrum  ; -- kombinationslås..nn.1
  kombinationsmåttsats_1_N = mkN "kombinationsmåttsats" "kombinationsmåttsatser" ; -- kombinationsmåttsats..nn.1
  kombinationstävling_1_N = mkN "kombinationstävling" ; -- kombinationstävling..nn.1
  kombinatorisk_1_A = mkA "kombinatorisk" ; -- kombinatorisk..av.1
  kombinera_1_V = mkV "kombinerar" ; -- kombinera..vb.1
  kombinerande_1_N = mkN "kombinerande" ; -- kombinerande..nn.1
  kombinerbar_1_A = mkA "kombinerbar" ; -- kombinerbar..av.1
  kombinerbarhet_1_N = mkN "kombinerbarhet" ; -- kombinerbarhet..nn.1
  kombinering_1_N = mkN "kombinering" ; -- kombinering..nn.1
  kombo_1_N = mkN "kombo" "kombot" "kombo" "kombon" ; -- kombo..nn.1
  komedi_1_N = mkN "komedi" "komedier" ; -- komedi..nn.1
  komediant_1_N = mkN "komediant" "komedianter" ; -- komediant..nn.1
  komedienn_1_N = mkN "komedienn" "komedienner" ; -- komedienn..nn.1
  komediförfattare_1_N = mkN "komediförfattare" utrum  ; -- komediförfattare..nn.1
  komet_1_N = mkN "komet" "kometer" ; -- komet..nn.1
  kometmoln_1_N = mkN "kometmoln" neutrum  ; -- kometmoln..nn.1
  komfort_1_N = mkN "komfort" ; -- komfort..nn.1
  komfortabel_1_A = mkA "komfortabel" ; -- komfortabel..av.1
  komihåg_1_N = mkN "komihåg" neutrum  ; -- komihåg..nn.1
  komik_1_N = mkN "komik" ; -- komik..nn.1
  komiker_1_N = mkN "komiker" "komikern" "komiker" "komikerna" ; -- komiker..nn.1
  komisk_1_A = mkA "komisk" ; -- komisk..av.1
  komissbröd_1_N = mkN "komissbröd" neutrum  ; -- komissbröd..nn.1
  komissmantel_1_N = mkN "komissmantel" ; -- komissmantel..nn.1
  komitativ_1_N = mkN "komitativ" "komitativer" ; -- komitativ..nn.1
  komjölk_1_N = mkN "komjölk" ; -- komjölk..nn.1
  komma_1_N = mkN "komma" "kommat" "komman" "kommana" ; -- komma..nn.1
  komma_1_V = mkV "komma" "kom" "kommit" ; -- komma..vb.1
  kommabacill_1_N = mkN "kommabacill" "kommabaciller" ; -- kommabacill..nn.1
  kommafel_1_N = mkN "kommafel" "kommafelet" "kommafel" "kommafelen" ; -- kommafel..nn.1
  kommande_1_A = mkA "kommande" ; -- kommande..av.1
  kommande_1_N = mkN "kommande" ; -- kommande..nn.1
  kommanditbolag_1_N = mkN "kommanditbolag" neutrum  ; -- kommanditbolag..nn.1
  kommanditdelägare_1_N = mkN "kommanditdelägare" utrum  ; -- kommanditdelägare..nn.1
  kommando_1_N = mkN "kommando" "kommandot" "kommandon" "kommandona" ; -- kommando..nn.1
  kommandobrygga_1_N = mkN "kommandobrygga" ; -- kommandobrygga..nn.1
  kommandocentral_1_N = mkN "kommandocentral" "kommandocentraler" ; -- kommandocentral..nn.1
  kommandomål_1_N = mkN "kommandomål" neutrum  ; -- kommandomål..nn.1
  kommandoord_1_N = mkN "kommandoord" neutrum  ; -- kommandoord..nn.1
  kommandorop_1_N = mkN "kommandorop" neutrum  ; -- kommandorop..nn.1
  kommandoröst_1_N = mkN "kommandoröst" "kommandoröster" ; -- kommandoröst..nn.1
  kommandoton_1_N = mkN "kommandoton" ; -- kommandoton..nn.1
  kommatecken_1_N = mkN "kommatecken" "kommatecknet" "kommatecken" "kommatecknen" ; -- kommatecken..nn.1
  kommatera_1_V = mkV "kommaterar" ; -- kommatera..vb.1
  kommaterande_1_N = mkN "kommaterande" ; -- kommaterande..nn.1
  kommaterbar_1_A = mkA "kommaterbar" ; -- kommaterbar..av.1
  kommaterbarhet_1_N = mkN "kommaterbarhet" ; -- kommaterbarhet..nn.1
  kommatering_1_N = mkN "kommatering" ; -- kommatering..nn.1
  kommendant_1_N = mkN "kommendant" "kommendanter" ; -- kommendant..nn.1
  kommendantur_1_N = mkN "kommendantur" "kommendanturer" ; -- kommendantur..nn.1
  kommendera_1_V = mkV "kommenderar" ; -- kommendera..vb.1
  kommenderande_1_N = mkN "kommenderande" ; -- kommenderande..nn.1
  kommenderbar_1_A = mkA "kommenderbar" ; -- kommenderbar..av.1
  kommenderbarhet_1_N = mkN "kommenderbarhet" ; -- kommenderbarhet..nn.1
  kommendering_1_N = mkN "kommendering" ; -- kommendering..nn.1
  kommendör_1_N = mkN "kommendör" "kommendörer" ; -- kommendör..nn.1
  kommendörkapten_1_N = mkN "kommendörkapten" "kommendörkaptener" ; -- kommendörkapten..nn.1
  kommensurabel_1_A = mkA "kommensurabel" ; -- kommensurabel..av.1
  kommensurabilitet_1_N = mkN "kommensurabilitet" "kommensurabiliteter" ; -- kommensurabilitet..nn.1
  kommentar_1_N = mkN "kommentar" "kommentarer" ; -- kommentar..nn.1
  kommentarsfält_1_N = mkN "kommentarsfält" neutrum  ; -- kommentarsfält..nn.1
  kommentator_1_N = mkN "kommentator" "kommentatorer" ; -- kommentator..nn.1
  kommentatorsfunktion_1_N = mkN "kommentatorsfunktion" ; -- kommentatorsfunktion..nn.1
  kommentatorshytt_1_N = mkN "kommentatorshytt" "kommentatorshytter" ; -- kommentatorshytt..nn.1
  kommentera_1_V = mkV "kommenterar" ; -- kommentera..vb.1
  kommenterande_1_N = mkN "kommenterande" ; -- kommenterande..nn.1
  kommenterbar_1_A = mkA "kommenterbar" ; -- kommenterbar..av.1
  kommenterbarhet_1_N = mkN "kommenterbarhet" ; -- kommenterbarhet..nn.1
  kommentering_1_N = mkN "kommentering" ; -- kommentering..nn.1
  kommers_1_N = mkN "kommers" "kommerser" ; -- kommers..nn.1
  kommersa_1_V = mkV "kommersar" ; -- kommersa..vb.1
  kommersande_1_N = mkN "kommersande" ; -- kommersande..nn.1
  kommerseråd_1_N = mkN "kommerseråd" neutrum  ; -- kommerseråd..nn.1
  kommersialisera_1_V = mkV "kommersialiserar" ; -- kommersialisera..vb.1
  kommersialiserande_1_N = mkN "kommersialiserande" ; -- kommersialiserande..nn.1
  kommersialiserbar_1_A = mkA "kommersialiserbar" ; -- kommersialiserbar..av.1
  kommersialiserbarhet_1_N = mkN "kommersialiserbarhet" ; -- kommersialiserbarhet..nn.1
  kommersialisering_1_N = mkN "kommersialisering" ; -- kommersialisering..nn.1
  kommersiell_1_A = mkA "kommersiell" ; -- kommersiell..av.1
  kommerskollegium_1_N = mkN "kommerskollegium" "kommerskollegiet" "kommerskollegier" "kommerskollegierna" ; -- kommerskollegium..nn.1
  komminister_1_N = mkN "komminister" ; -- komminister..nn.1
  kommiss_1_N = mkN "kommiss" ; -- kommiss..nn.1
  kommissariat_1_N = mkN "kommissariat" neutrum  ; -- kommissariat..nn.1
  kommissarie_1_N = mkN "kommissarie" "kommissarier" ; -- kommissarie..nn.1
  kommission_1_N = mkN "kommission" ; -- kommission..nn.1
  kommissionär_1_N = mkN "kommissionär" "kommissionärer" ; -- kommissionär..nn.1
  kommitterad_1_A = mkA "kommitterad" ; -- kommitterad..av.1
  kommitté_1_N = mkN "kommitté" "kommittéer" ; -- kommitté..nn.1
  kommittéförordning_1_N = mkN "kommittéförordning" ; -- kommittéförordning..nn.1
  kommod_1_N = mkN "kommod" "kommoder" ; -- kommod..nn.1
  kommodifiera_1_V = mkV "kommodifierar" ; -- kommodifiera..vb.1
  kommodifierande_1_N = mkN "kommodifierande" ; -- kommodifierande..nn.1
  kommodifiering_1_N = mkN "kommodifiering" ; -- kommodifiering..nn.1
  kommun_1_N = mkN "kommun" "kommuner" ; -- kommun..nn.1
  kommunal_1_A = mkA "kommunal" ; -- kommunal..av.1
  kommunalekonomisk_1_A = mkA "kommunalekonomisk" ; -- kommunalekonomisk..av.1
  kommunalfullmäktig_1_N = mkN "kommunalfullmäktig" "kommunalfullmäktigen" "kommunalfullmäktige" "kommunalfullmäktigena" ; -- kommunalfullmäktig..nn.1
  kommunalförvaltning_1_N = mkN "kommunalförvaltning" ; -- kommunalförvaltning..nn.1
  kommunalhus_1_N = mkN "kommunalhus" neutrum  ; -- kommunalhus..nn.1
  kommunalisera_1_V = mkV "kommunaliserar" ; -- kommunalisera..vb.1
  kommunaliserande_1_N = mkN "kommunaliserande" ; -- kommunaliserande..nn.1
  kommunaliserbar_1_A = mkA "kommunaliserbar" ; -- kommunaliserbar..av.1
  kommunaliserbarhet_1_N = mkN "kommunaliserbarhet" ; -- kommunaliserbarhet..nn.1
  kommunalisering_1_N = mkN "kommunalisering" ; -- kommunalisering..nn.1
  kommunallag_1_N = mkN "kommunallag" ; -- kommunallag..nn.1
  kommunalman_1_N = mkN "kommunalman" "kommunalmannen" "kommunalmän" "kommunalmännen" ; -- kommunalman..nn.1
  kommunalnivå_1_N = mkN "kommunalnivå" "kommunalnivåer" ; -- kommunalnivå..nn.1
  kommunalnämnd_1_N = mkN "kommunalnämnd" "kommunalnämnder" ; -- kommunalnämnd..nn.1
  kommunalnämndsordförande_1_N = mkN "kommunalnämndsordförande" "kommunalnämndsordföranden" "kommunalnämndsordföranden" "kommunalnämndsordförandena" ; -- kommunalnämndsordförande..nn.1
  kommunalordförande_1_N = mkN "kommunalordförande" "kommunalordföranden" "kommunalordföranden" "kommunalordförandena" ; -- kommunalordförande..nn.1
  kommunalpolitiker_1_N = mkN "kommunalpolitiker" "kommunalpolitikern" "kommunalpolitiker" "kommunalpolitikerna" ; -- kommunalpolitiker..nn.1
  kommunalpolitisk_1_A = mkA "kommunalpolitisk" ; -- kommunalpolitisk..av.1
  kommunalråd_1_N = mkN "kommunalråd" neutrum  ; -- kommunalråd..nn.1
  kommunalskatt_1_N = mkN "kommunalskatt" "kommunalskatter" ; -- kommunalskatt..nn.1
  kommunalstyrelse_1_N = mkN "kommunalstyrelse" "kommunalstyrelser" ; -- kommunalstyrelse..nn.1
  kommunalval_1_N = mkN "kommunalval" neutrum  ; -- kommunalval..nn.1
  kommunalväsen_1_N = mkN "kommunalväsen" neutrum  ; -- kommunalväsen..nn.1
  kommunanställd_1_A = mkA "kommunanställd" "kommunanställt" ; -- kommunanställd..av.1
  kommunard_1_N = mkN "kommunard" "kommunarder" ; -- kommunard..nn.1
  kommunblock_1_N = mkN "kommunblock" neutrum  ; -- kommunblock..nn.1
  kommundel_1_N = mkN "kommundel" "kommundelen" "kommundelar" "kommundelarna" ; -- kommundel..nn.1
  kommundelsråd_1_N = mkN "kommundelsråd" neutrum  ; -- kommundelsråd..nn.1
  kommundirektör_1_N = mkN "kommundirektör" "kommundirektörer" ; -- kommundirektör..nn.1
  kommunfullmäktig_1_N = mkN "kommunfullmäktig" "kommunfullmäktigen" "kommunfullmäktige" "kommunfullmäktigena" ; -- kommunfullmäktig..nn.1
  kommunfullmäktige_1_N = mkN "kommunfullmäktige" ; -- kommunfullmäktige..nn.1
  kommunförbund_1_N = mkN "kommunförbund" neutrum  ; -- kommunförbund..nn.1
  kommunhus_1_N = mkN "kommunhus" neutrum  ; -- kommunhus..nn.1
  kommunicera_1_V = mkV "kommunicerar" ; -- kommunicera..vb.1
  kommunicera_2_V = mkV "kommunicerar" ; -- kommunicera..vb.2
  kommunicerande_1_N = mkN "kommunicerande" ; -- kommunicerande..nn.1
  kommunicerbar_1_A = mkA "kommunicerbar" ; -- kommunicerbar..av.1
  kommunicerbarhet_1_N = mkN "kommunicerbarhet" ; -- kommunicerbarhet..nn.1
  kommunicering_1_N = mkN "kommunicering" ; -- kommunicering..nn.1
  kommunikant_1_N = mkN "kommunikant" "kommunikanter" ; -- kommunikant..nn.1
  kommunikation_1_N = mkN "kommunikation" ; -- kommunikation..nn.1
  kommunikationsakt_1_N = mkN "kommunikationsakt" "kommunikationsakter" ; -- kommunikationsakt..nn.1
  kommunikationsansvarig_1_A = mkA "kommunikationsansvarig" ; -- kommunikationsansvarig..av.1
  kommunikationscentral_1_A = mkA "kommunikationscentral" ; -- kommunikationscentral..av.1
  kommunikationschef_1_N = mkN "kommunikationschef" "kommunikationschefer" ; -- kommunikationschef..nn.1
  kommunikationsdepartement_1_N = mkN "kommunikationsdepartement" neutrum  ; -- kommunikationsdepartement..nn.1
  kommunikationskanal_1_N = mkN "kommunikationskanal" "kommunikationskanaler" ; -- kommunikationskanal..nn.1
  kommunikationsled_1_N = mkN "kommunikationsled" "kommunikationsleder" ; -- kommunikationsled..nn.1
  kommunikationsmedel_1_N = mkN "kommunikationsmedel" neutrum  ; -- kommunikationsmedel..nn.1
  kommunikationsminister_1_N = mkN "kommunikationsminister" ; -- kommunikationsminister..nn.1
  kommunikationsmässig_1_A = mkA "kommunikationsmässig" ; -- kommunikationsmässig..av.1
  kommunikationsnät_1_N = mkN "kommunikationsnät" neutrum  ; -- kommunikationsnät..nn.1
  kommunikationsproblem_1_N = mkN "kommunikationsproblem" neutrum  ; -- kommunikationsproblem..nn.1
  kommunikationsradio_1_N = mkN "kommunikationsradio" "kommunikationsradior" ; -- kommunikationsradio..nn.1
  kommunikationssatellit_1_N = mkN "kommunikationssatellit" "kommunikationssatelliter" ; -- kommunikationssatellit..nn.1
  kommunikationstabell_1_N = mkN "kommunikationstabell" "kommunikationstabeller" ; -- kommunikationstabell..nn.1
  kommunikationsteori_1_N = mkN "kommunikationsteori" ; -- kommunikationsteori..nn.1
  kommunikativ_1_A = mkA "kommunikativ" ; -- kommunikativ..av.1
  kommunikator_1_N = mkN "kommunikator" "kommunikatorer" ; -- kommunikator..nn.1
  kommunikatör_1_N = mkN "kommunikatör" "kommunikatörer" ; -- kommunikatör..nn.1
  kommuniké_1_N = mkN "kommuniké" "kommunikéer" ; -- kommuniké..nn.1
  kommuninnevånare_1_N = mkN "kommuninnevånare" utrum  ; -- kommuninnevånare..nn.1
  kommuninvånare_1_N = mkN "kommuninvånare" utrum  ; -- kommuninvånare..nn.1
  kommunion_1_N = mkN "kommunion" ; -- kommunion..nn.1
  kommunism_1_N = mkN "kommunism" "kommunismer" ; -- kommunism..nn.1
  kommunist_1_N = mkN "kommunist" "kommunister" ; -- kommunist..nn.1
  kommunistdiktatur_1_N = mkN "kommunistdiktatur" "kommunistdiktaturer" ; -- kommunistdiktatur..nn.1
  kommunistgerilla_1_N = mkN "kommunistgerilla" ; -- kommunistgerilla..nn.1
  kommunistisk_1_A = mkA "kommunistisk" ; -- kommunistisk..av.1
  kommunistland_1_N = mkN "kommunistland" "kommunistlandet" "kommunistländer" "kommunistländerna" ; -- kommunistland..nn.1
  kommunistparti_1_N = mkN "kommunistparti" "kommunistpartiet" "kommunistpartier" "kommunistpartierna" ; -- kommunistparti..nn.1
  kommunistregim_1_N = mkN "kommunistregim" "kommunistregimer" ; -- kommunistregim..nn.1
  kommuniststämpel_1_N = mkN "kommuniststämpel" ; -- kommuniststämpel..nn.1
  kommunistsympatisör_1_N = mkN "kommunistsympatisör" "kommunistsympatisörer" ; -- kommunistsympatisör..nn.1
  kommunistvärld_1_N = mkN "kommunistvärld" ; -- kommunistvärld..nn.1
  kommunledning_1_N = mkN "kommunledning" ; -- kommunledning..nn.1
  kommunnivå_1_N = mkN "kommunnivå" "kommunnivåer" ; -- kommunnivå..nn.1
  kommunpolitiker_1_N = mkN "kommunpolitiker" "kommunpolitikern" "kommunpolitiker" "kommunpolitikerna" ; -- kommunpolitiker..nn.1
  kommunreform_1_N = mkN "kommunreform" "kommunreformer" ; -- kommunreform..nn.1
  kommunsammanslagning_1_N = mkN "kommunsammanslagning" ; -- kommunsammanslagning..nn.1
  kommunstyrelse_1_N = mkN "kommunstyrelse" "kommunstyrelser" ; -- kommunstyrelse..nn.1
  kommunvis_1_Adv = mkAdv "kommunvis" ; -- kommunvis..ab.1
  kommunvis_1_A = mkA "kommunvis" ; -- kommunvis..av.1
  kommunägd_1_A = mkA "kommunägd" "kommunägt" ; -- kommunägd..av.1
  kommutativ_1_A = mkA "kommutativ" ; -- kommutativ..av.1
  kommutator_1_N = mkN "kommutator" "kommutatorer" ; -- kommutator..nn.1
  kommutera_1_V = mkV "kommuterar" ; -- kommutera..vb.1
  kommuterande_1_N = mkN "kommuterande" ; -- kommuterande..nn.1
  kommuterbar_1_A = mkA "kommuterbar" ; -- kommuterbar..av.1
  kommuterbarhet_1_N = mkN "kommuterbarhet" ; -- kommuterbarhet..nn.1
  kommutering_1_N = mkN "kommutering" ; -- kommutering..nn.1
  komocka_1_N = mkN "komocka" ; -- komocka..nn.1
  komorier_1_N = mkN "komorier" "komoriern" "komorier" "komorierna" ; -- komorier..nn.1
  komorisk_1_A = mkA "komorisk" ; -- komorisk..av.1
  komoriska_1_N = mkN "komoriska" ; -- komoriska..nn.1
  komp_1_N = mkN "komp" neutrum  ; -- komp..nn.1
  kompa_1_V = mkV "kompar" ; -- kompa..vb.1
  kompakt_1_A = mkA "kompakt" "kompakt" ; -- kompakt..av.1
  kompakthet_1_N = mkN "kompakthet" ; -- kompakthet..nn.1
  kompaktkamera_1_N = mkN "kompaktkamera" ; -- kompaktkamera..nn.1
  kompaktskiva_1_N = mkN "kompaktskiva" ; -- kompaktskiva..nn.1
  kompande_1_N = mkN "kompande" ; -- kompande..nn.1
  kompani_1_N = mkN "kompani" "kompaniet" "kompanier" "kompanierna" ; -- kompani..nn.1
  kompaniadjutant_1_N = mkN "kompaniadjutant" "kompaniadjutanter" ; -- kompaniadjutant..nn.1
  kompanichef_1_N = mkN "kompanichef" "kompanichefer" ; -- kompanichef..nn.1
  kompaniofficer_1_N = mkN "kompaniofficer" "kompaniofficeren" "kompaniofficerare" "kompaniofficerarna" ; -- kompaniofficer..nn.1
  kompaniorder_1_N = mkN "kompaniorder" ; -- kompaniorder..nn.1
  kompanjon_1_N = mkN "kompanjon" "kompanjoner" ; -- kompanjon..nn.1
  kompanjonskap_1_N = mkN "kompanjonskap" ; -- kompanjonskap..nn.1
  komparabel_1_A = mkA "komparabel" ; -- komparabel..av.1
  komparation_1_N = mkN "komparation" ; -- komparation..nn.1
  komparativ_1_A = mkA "komparativ" ; -- komparativ..av.1
  komparativ_1_N = mkN "komparativ" "komparativer" ; -- komparativ..nn.1
  komparativsats_1_N = mkN "komparativsats" "komparativsatser" ; -- komparativsats..nn.1
  komparera_1_V = mkV "komparerar" ; -- komparera..vb.1
  komparerande_1_N = mkN "komparerande" ; -- komparerande..nn.1
  komparerbar_1_A = mkA "komparerbar" ; -- komparerbar..av.1
  komparerbarhet_1_N = mkN "komparerbarhet" ; -- komparerbarhet..nn.1
  komparering_1_N = mkN "komparering" ; -- komparering..nn.1
  kompars_1_N = mkN "kompars" "komparser" ; -- kompars..nn.1
  kompass_1_N = mkN "kompass" "kompasser" ; -- kompass..nn.1
  kompasshus_1_N = mkN "kompasshus" neutrum  ; -- kompasshus..nn.1
  kompasskurs_1_N = mkN "kompasskurs" "kompasskurser" ; -- kompasskurs..nn.1
  kompassnål_1_N = mkN "kompassnål" ; -- kompassnål..nn.1
  kompassriktning_1_N = mkN "kompassriktning" ; -- kompassriktning..nn.1
  kompassros_1_N = mkN "kompassros" "kompassrosor" ; -- kompassros..nn.1
  kompasstreck_1_N = mkN "kompasstreck" neutrum  ; -- kompasstreck..nn.1
  kompatibel_1_A = mkA "kompatibel" ; -- kompatibel..av.1
  kompatibilitet_1_N = mkN "kompatibilitet" "kompatibiliteter" ; -- kompatibilitet..nn.1
  kompendium_1_N = mkN "kompendium" "kompendiet" "kompendier" "kompendierna" ; -- kompendium..nn.1
  kompensation_1_N = mkN "kompensation" ; -- kompensation..nn.1
  kompensator_1_N = mkN "kompensator" "kompensatorer" ; -- kompensator..nn.1
  kompensatorisk_1_A = mkA "kompensatorisk" ; -- kompensatorisk..av.1
  kompensera_1_V = mkV "kompenserar" ; -- kompensera..vb.1
  kompenserande_1_N = mkN "kompenserande" ; -- kompenserande..nn.1
  kompenserbar_1_A = mkA "kompenserbar" ; -- kompenserbar..av.1
  kompenserbarhet_1_N = mkN "kompenserbarhet" ; -- kompenserbarhet..nn.1
  kompensering_1_N = mkN "kompensering" ; -- kompensering..nn.1
  kompetens_1_N = mkN "kompetens" "kompetenser" ; -- kompetens..nn.1
  kompetensförklara_1_V = mkV "kompetensförklarar" ; -- kompetensförklara..vb.1
  kompetensförklarande_1_N = mkN "kompetensförklarande" ; -- kompetensförklarande..nn.1
  kompetensförklaring_1_N = mkN "kompetensförklaring" ; -- kompetensförklaring..nn.1
  kompetenshöjande_1_A = mkA "kompetenshöjande" ; -- kompetenshöjande..av.1
  kompetenskrav_1_N = mkN "kompetenskrav" neutrum  ; -- kompetenskrav..nn.1
  kompetensmässig_1_A = mkA "kompetensmässig" ; -- kompetensmässig..av.1
  kompetensområde_1_N = mkN "kompetensområde" ; -- kompetensområde..nn.1
  kompetensprövning_1_N = mkN "kompetensprövning" ; -- kompetensprövning..nn.1
  kompetensutveckling_1_N = mkN "kompetensutveckling" ; -- kompetensutveckling..nn.1
  kompetent_1_A = mkA "kompetent" "kompetent" ; -- kompetent..av.1
  kompilat_1_N = mkN "kompilat" neutrum  ; -- kompilat..nn.1
  kompilation_1_N = mkN "kompilation" ; -- kompilation..nn.1
  kompilator_1_N = mkN "kompilator" "kompilatorer" ; -- kompilator..nn.1
  kompilatör_1_N = mkN "kompilatör" "kompilatörer" ; -- kompilatör..nn.1
  kompilera_1_V = mkV "kompilerar" ; -- kompilera..vb.1
  kompilerande_1_N = mkN "kompilerande" ; -- kompilerande..nn.1
  kompilerbar_1_A = mkA "kompilerbar" ; -- kompilerbar..av.1
  kompilerbarhet_1_N = mkN "kompilerbarhet" ; -- kompilerbarhet..nn.1
  kompilering_1_N = mkN "kompilering" ; -- kompilering..nn.1
  kompis_1_N = mkN "kompis" ; -- kompis..nn.1
  kompisgäng_1_N = mkN "kompisgäng" neutrum  ; -- kompisgäng..nn.1
  kompledig_1_A = mkA "kompledig" ; -- kompledig..av.1
  kompledighet_1_N = mkN "kompledighet" ; -- kompledighet..nn.1
  komplement_1_N = mkN "komplement" neutrum  ; -- komplement..nn.1
  komplementfärg_1_N = mkN "komplementfärg" "komplementfärger" ; -- komplementfärg..nn.1
  komplementmängd_1_N = mkN "komplementmängd" "komplementmängder" ; -- komplementmängd..nn.1
  komplementsystem_1_N = mkN "komplementsystem" neutrum  ; -- komplementsystem..nn.1
  komplementvinkel_1_N = mkN "komplementvinkel" ; -- komplementvinkel..nn.1
  komplementär_1_A = mkA "komplementär" ; -- komplementär..av.1
  komplementär_1_N = mkN "komplementär" "komplementärer" ; -- komplementär..nn.1
  komplett_1_A = mkA "komplett" ; -- komplett..av.1
  komplettera_1_V = mkV "kompletterar" ; -- komplettera..vb.1
  kompletterande_1_N = mkN "kompletterande" ; -- kompletterande..nn.1
  kompletterbar_1_A = mkA "kompletterbar" ; -- kompletterbar..av.1
  kompletterbarhet_1_N = mkN "kompletterbarhet" ; -- kompletterbarhet..nn.1
  komplettering_1_N = mkN "komplettering" ; -- komplettering..nn.1
  kompletteringsproposition_1_N = mkN "kompletteringsproposition" ; -- kompletteringsproposition..nn.1
  kompletteringstest_1_N = mkN "kompletteringstest" neutrum  ; -- kompletteringstest..nn.1
  kompletthet_1_N = mkN "kompletthet" ; -- kompletthet..nn.1
  komplex_1_A = mkA "komplex" ; -- komplex..av.1
  komplex_1_N = mkN "komplex" neutrum  ; -- komplex..nn.1
  komplexhet_1_N = mkN "komplexhet" ; -- komplexhet..nn.1
  komplexig_1_A = mkA "komplexig" ; -- komplexig..av.1
  komplexitet_1_N = mkN "komplexitet" "komplexiteter" ; -- komplexitet..nn.1
  komplicera_1_V = mkV "komplicerar" ; -- komplicera..vb.1
  komplicerad_1_A = mkA "komplicerad" ; -- komplicerad..av.1
  komplicerande_1_N = mkN "komplicerande" ; -- komplicerande..nn.1
  komplicerbar_1_A = mkA "komplicerbar" ; -- komplicerbar..av.1
  komplicerbarhet_1_N = mkN "komplicerbarhet" ; -- komplicerbarhet..nn.1
  komplicering_1_N = mkN "komplicering" ; -- komplicering..nn.1
  komplikation_1_N = mkN "komplikation" ; -- komplikation..nn.1
  komplikationsfri_1_A = mkA "komplikationsfri" "komplikationsfritt" ; -- komplikationsfri..av.1
  komplimang_1_N = mkN "komplimang" "komplimanger" ; -- komplimang..nn.1
  komplimentera_1_V = mkV "komplimenterar" ; -- komplimentera..vb.1
  komplimenterande_1_N = mkN "komplimenterande" ; -- komplimenterande..nn.1
  komplimenterbar_1_A = mkA "komplimenterbar" ; -- komplimenterbar..av.1
  komplimenterbarhet_1_N = mkN "komplimenterbarhet" ; -- komplimenterbarhet..nn.1
  komplimentering_1_N = mkN "komplimentering" ; -- komplimentering..nn.1
  komplott_1_N = mkN "komplott" "komplotter" ; -- komplott..nn.1
  komponent_1_N = mkN "komponent" "komponenter" ; -- komponent..nn.1
  komponera_1_V = mkV "komponerar" ; -- komponera..vb.1
  komponerande_1_N = mkN "komponerande" ; -- komponerande..nn.1
  komponerbar_1_A = mkA "komponerbar" ; -- komponerbar..av.1
  komponerbarhet_1_N = mkN "komponerbarhet" ; -- komponerbarhet..nn.1
  komponering_1_N = mkN "komponering" ; -- komponering..nn.1
  komponist_1_N = mkN "komponist" "komponister" ; -- komponist..nn.1
  komposant_1_N = mkN "komposant" "komposanter" ; -- komposant..nn.1
  komposit_1_N = mkN "komposit" "kompositer" ; -- komposit..nn.1
  komposition_1_N = mkN "komposition" ; -- komposition..nn.1
  kompositionslära_1_N = mkN "kompositionslära" ; -- kompositionslära..nn.1
  kompositmaterial_1_N = mkN "kompositmaterial" neutrum  ; -- kompositmaterial..nn.1
  kompositstock_1_N = mkN "kompositstock" ; -- kompositstock..nn.1
  kompositum_1_N = mkN "kompositum" "kompositet" "kompositer" "kompositerna" ; -- kompositum..nn.1
  kompositör_1_N = mkN "kompositör" "kompositörer" ; -- kompositör..nn.1
  kompost_1_N = mkN "kompost" "komposter" ; -- kompost..nn.1
  kompostera_1_V = mkV "komposterar" ; -- kompostera..vb.1
  komposterande_1_N = mkN "komposterande" ; -- komposterande..nn.1
  komposterbar_1_A = mkA "komposterbar" ; -- komposterbar..av.1
  komposterbarhet_1_N = mkN "komposterbarhet" ; -- komposterbarhet..nn.1
  kompostering_1_N = mkN "kompostering" ; -- kompostering..nn.1
  komposteringsbar_1_A = mkA "komposteringsbar" ; -- komposteringsbar..av.1
  komposteringsbarhet_1_N = mkN "komposteringsbarhet" ; -- komposteringsbarhet..nn.1
  kompostkvarn_1_N = mkN "kompostkvarn" ; -- kompostkvarn..nn.1
  kompott_1_N = mkN "kompott" "kompotter" ; -- kompott..nn.1
  kompoundkärna_1_N = mkN "kompoundkärna" ; -- kompoundkärna..nn.1
  kompress_1_N = mkN "kompress" "kompresser" ; -- kompress..nn.1
  kompression_1_N = mkN "kompression" ; -- kompression..nn.1
  kompressor_1_N = mkN "kompressor" "kompressorer" ; -- kompressor..nn.1
  komprimator_1_N = mkN "komprimator" "komprimatorer" ; -- komprimator..nn.1
  komprimera_1_V = mkV "komprimerar" ; -- komprimera..vb.1
  komprimerande_1_N = mkN "komprimerande" ; -- komprimerande..nn.1
  komprimerbar_1_A = mkA "komprimerbar" ; -- komprimerbar..av.1
  komprimerbarhet_1_N = mkN "komprimerbarhet" ; -- komprimerbarhet..nn.1
  komprimering_1_N = mkN "komprimering" ; -- komprimering..nn.1
  kompromettera_1_V = mkV "komprometterar" ; -- kompromettera..vb.1
  komprometterande_1_N = mkN "komprometterande" ; -- komprometterande..nn.1
  komprometterbar_1_A = mkA "komprometterbar" ; -- komprometterbar..av.1
  komprometterbarhet_1_N = mkN "komprometterbarhet" ; -- komprometterbarhet..nn.1
  kompromettering_1_N = mkN "kompromettering" ; -- kompromettering..nn.1
  kompromiss_1_N = mkN "kompromiss" "kompromisser" ; -- kompromiss..nn.1
  kompromissa_1_V = mkV "kompromissar" ; -- kompromissa..vb.1
  kompromissande_1_N = mkN "kompromissande" ; -- kompromissande..nn.1
  kompromisslös_1_A = mkA "kompromisslös" ; -- kompromisslös..av.1
  kompromisslöshet_1_N = mkN "kompromisslöshet" ; -- kompromisslöshet..nn.1
  kompromissvilja_1_N = mkN "kompromissvilja" ; -- kompromissvilja..nn.1
  kompromissvillig_1_A = mkA "kompromissvillig" ; -- kompromissvillig..av.1
  kompulsiv_1_A = mkA "kompulsiv" ; -- kompulsiv..av.1
  komputationell_1_A = mkA "komputationell" ; -- komputationell..av.1
  kon_1_N = mkN "kon" "koner" ; -- kon..nn.1
  kona_1_N = mkN "kona" ; -- kona..nn.1
  koncentrat_1_N = mkN "koncentrat" neutrum  ; -- koncentrat..nn.1
  koncentration_1_N = mkN "koncentration" ; -- koncentration..nn.1
  koncentrationsdag_1_N = mkN "koncentrationsdag" ; -- koncentrationsdag..nn.1
  koncentrationsförmåga_1_N = mkN "koncentrationsförmåga" ; -- koncentrationsförmåga..nn.1
  koncentrationsläger_1_N = mkN "koncentrationsläger" neutrum  ; -- koncentrationsläger..nn.1
  koncentrationsläsning_1_N = mkN "koncentrationsläsning" ; -- koncentrationsläsning..nn.1
  koncentrationsstörning_1_N = mkN "koncentrationsstörning" ; -- koncentrationsstörning..nn.1
  koncentrationssvårighet_1_N = mkN "koncentrationssvårighet" "koncentrationssvårigheter" ; -- koncentrationssvårighet..nn.1
  koncentrera_1_V = mkV "koncentrerar" ; -- koncentrera..vb.1
  koncentrerande_1_N = mkN "koncentrerande" ; -- koncentrerande..nn.1
  koncentrerbar_1_A = mkA "koncentrerbar" ; -- koncentrerbar..av.1
  koncentrerbarhet_1_N = mkN "koncentrerbarhet" ; -- koncentrerbarhet..nn.1
  koncentrering_1_N = mkN "koncentrering" ; -- koncentrering..nn.1
  koncentricitet_1_N = mkN "koncentricitet" ; -- koncentricitet..nn.1
  koncentrisk_1_A = mkA "koncentrisk" ; -- koncentrisk..av.1
  koncept_1_N = mkN "koncept" neutrum  ; -- koncept..nn.1
  koncept_2_N = mkN "koncept" neutrum  ; -- koncept..nn.2
  konception_1_N = mkN "konception" ; -- konception..nn.1
  konceptiv_1_A = mkA "konceptiv" ; -- konceptiv..av.1
  konceptpapper_1_N = mkN "konceptpapper" neutrum  ; -- konceptpapper..nn.1
  konceptuell_1_A = mkA "konceptuell" ; -- konceptuell..av.1
  koncern_1_N = mkN "koncern" "koncerner" ; -- koncern..nn.1
  koncernchef_1_N = mkN "koncernchef" "koncernchefer" ; -- koncernchef..nn.1
  koncernledning_1_N = mkN "koncernledning" ; -- koncernledning..nn.1
  koncernmässig_1_A = mkA "koncernmässig" ; -- koncernmässig..av.1
  koncession_1_N = mkN "koncession" ; -- koncession..nn.1
  koncessionera_1_V = mkV "koncessionerar" ; -- koncessionera..vb.1
  koncessionerande_1_N = mkN "koncessionerande" ; -- koncessionerande..nn.1
  koncessionerbar_1_A = mkA "koncessionerbar" ; -- koncessionerbar..av.1
  koncessionerbarhet_1_N = mkN "koncessionerbarhet" ; -- koncessionerbarhet..nn.1
  koncessionering_1_N = mkN "koncessionering" ; -- koncessionering..nn.1
  koncessionsavgift_1_N = mkN "koncessionsavgift" "koncessionsavgifter" ; -- koncessionsavgift..nn.1
  koncessiv_1_A = mkA "koncessiv" ; -- koncessiv..av.1
  koncessivsats_1_N = mkN "koncessivsats" "koncessivsatser" ; -- koncessivsats..nn.1
  koncilians_1_N = mkN "koncilians" ; -- koncilians..nn.1
  konciliant_1_A = mkA "konciliant" "konciliant" ; -- konciliant..av.1
  koncipiera_1_V = mkV "koncipierar" ; -- koncipiera..vb.1
  koncipierande_1_N = mkN "koncipierande" ; -- koncipierande..nn.1
  koncipierbar_1_A = mkA "koncipierbar" ; -- koncipierbar..av.1
  koncipierbarhet_1_N = mkN "koncipierbarhet" ; -- koncipierbarhet..nn.1
  koncipiering_1_N = mkN "koncipiering" ; -- koncipiering..nn.1
  koncis_1_A = mkA "koncis" ; -- koncis..av.1
  koncishet_1_N = mkN "koncishet" ; -- koncishet..nn.1
  kondemnera_1_V = mkV "kondemnerar" ; -- kondemnera..vb.1
  kondemnerande_1_N = mkN "kondemnerande" ; -- kondemnerande..nn.1
  kondemnerbar_1_A = mkA "kondemnerbar" ; -- kondemnerbar..av.1
  kondemnerbarhet_1_N = mkN "kondemnerbarhet" ; -- kondemnerbarhet..nn.1
  kondemnering_1_N = mkN "kondemnering" ; -- kondemnering..nn.1
  kondens_1_N = mkN "kondens" ; -- kondens..nn.1
  kondensat_1_N = mkN "kondensat" neutrum  ; -- kondensat..nn.1
  kondensation_1_N = mkN "kondensation" ; -- kondensation..nn.1
  kondensationskärna_1_N = mkN "kondensationskärna" ; -- kondensationskärna..nn.1
  kondensator_1_N = mkN "kondensator" "kondensatorer" ; -- kondensator..nn.1
  kondensera_1_V = mkV "kondenserar" ; -- kondensera..vb.1
  kondenserande_1_N = mkN "kondenserande" ; -- kondenserande..nn.1
  kondenserbar_1_A = mkA "kondenserbar" ; -- kondenserbar..av.1
  kondenserbarhet_1_N = mkN "kondenserbarhet" ; -- kondenserbarhet..nn.1
  kondensering_1_N = mkN "kondensering" ; -- kondensering..nn.1
  kondensor_1_N = mkN "kondensor" "kondensorer" ; -- kondensor..nn.1
  kondensspår_1_N = mkN "kondensspår" neutrum  ; -- kondensspår..nn.1
  kondensstrimma_1_N = mkN "kondensstrimma" ; -- kondensstrimma..nn.1
  kondis_1_N = mkN "kondis" neutrum  ; -- kondis..nn.1
  kondis_2_N = mkN "kondis" ; -- kondis..nn.2
  kondition_1_N = mkN "kondition" ; -- kondition..nn.1
  konditional_1_A = mkA "konditional" ; -- konditional..av.1
  konditionalsats_1_N = mkN "konditionalsats" "konditionalsatser" ; -- konditionalsats..nn.1
  konditionera_1_V = mkV "konditionerar" ; -- konditionera..vb.1
  konditionerad_1_A = mkA "konditionerad" ; -- konditionerad..av.1
  konditionerande_1_N = mkN "konditionerande" ; -- konditionerande..nn.1
  konditionerbar_1_A = mkA "konditionerbar" ; -- konditionerbar..av.1
  konditionerbarhet_1_N = mkN "konditionerbarhet" ; -- konditionerbarhet..nn.1
  konditionering_1_N = mkN "konditionering" ; -- konditionering..nn.1
  konditionsmässig_1_A = mkA "konditionsmässig" ; -- konditionsmässig..av.1
  konditor_1_N = mkN "konditor" "konditorer" ; -- konditor..nn.1
  konditori_1_N = mkN "konditori" "konditoriet" "konditorier" "konditorierna" ; -- konditori..nn.1
  kondoleans_1_N = mkN "kondoleans" "kondoleanser" ; -- kondoleans..nn.1
  kondolera_1_V = mkV "kondolerar" ; -- kondolera..vb.1
  kondolerande_1_N = mkN "kondolerande" ; -- kondolerande..nn.1
  kondolerbar_1_A = mkA "kondolerbar" ; -- kondolerbar..av.1
  kondolerbarhet_1_N = mkN "kondolerbarhet" ; -- kondolerbarhet..nn.1
  kondolering_1_N = mkN "kondolering" ; -- kondolering..nn.1
  kondom_1_N = mkN "kondom" "kondomer" ; -- kondom..nn.1
  kondor_1_N = mkN "kondor" "kondoren" "kondorer" "kondorerna" ; -- kondor..nn.1
  kondottiär_1_N = mkN "kondottiär" "kondottiärer" ; -- kondottiär..nn.1
  konduktans_1_N = mkN "konduktans" ; -- konduktans..nn.1
  konduktivitet_1_N = mkN "konduktivitet" "konduktiviteter" ; -- konduktivitet..nn.1
  konduktor_1_N = mkN "konduktor" "konduktorer" ; -- konduktor..nn.1
  konduktör_1_N = mkN "konduktör" "konduktörer" ; -- konduktör..nn.1
  konfederal_1_A = mkA "konfederal" ; -- konfederal..av.1
  konfederation_1_N = mkN "konfederation" ; -- konfederation..nn.1
  konfedererad_1_A = mkA "konfedererad" ; -- konfedererad..av.1
  konfekt_1_N = mkN "konfekt" ; -- konfekt..nn.1
  konfektbit_1_N = mkN "konfektbit" ; -- konfektbit..nn.1
  konfektion_1_N = mkN "konfektion" ; -- konfektion..nn.1
  konfektionsmässig_1_A = mkA "konfektionsmässig" ; -- konfektionsmässig..av.1
  konfektskål_1_N = mkN "konfektskål" ; -- konfektskål..nn.1
  konfektyrbutik_1_N = mkN "konfektyrbutik" "konfektyrbutiker" ; -- konfektyrbutik..nn.1
  konferencier_1_N = mkN "konferencier" "konferencierer" ; -- konferencier..nn.1
  konferenciär_1_N = mkN "konferenciär" "konferenciärer" ; -- konferenciär..nn.1
  konferens_1_N = mkN "konferens" "konferenser" ; -- konferens..nn.1
  konferensrum_1_N = mkN "konferensrum" "konferensrummet" "konferensrum" "konferensrummen" ; -- konferensrum..nn.1
  konferenstolk_1_N = mkN "konferenstolk" ; -- konferenstolk..nn.1
  konferera_1_V = mkV "konfererar" ; -- konferera..vb.1
  konfererande_1_N = mkN "konfererande" ; -- konfererande..nn.1
  konferering_1_N = mkN "konferering" ; -- konferering..nn.1
  konfession_1_N = mkN "konfession" ; -- konfession..nn.1
  konfessionalism_1_N = mkN "konfessionalism" "konfessionalismer" ; -- konfessionalism..nn.1
  konfessionarie_1_N = mkN "konfessionarie" "konfessionarier" ; -- konfessionarie..nn.1
  konfessionell_1_A = mkA "konfessionell" ; -- konfessionell..av.1
  konfessionslös_1_A = mkA "konfessionslös" ; -- konfessionslös..av.1
  konfessionslöshet_1_N = mkN "konfessionslöshet" ; -- konfessionslöshet..nn.1
  konfidentiell_1_A = mkA "konfidentiell" ; -- konfidentiell..av.1
  konfiguration_1_N = mkN "konfiguration" ; -- konfiguration..nn.1
  konfigurera_1_V = mkV "konfigurerar" ; -- konfigurera..vb.1
  konfigurerande_1_N = mkN "konfigurerande" ; -- konfigurerande..nn.1
  konfigurerbar_1_A = mkA "konfigurerbar" ; -- konfigurerbar..av.1
  konfigurerbarhet_1_N = mkN "konfigurerbarhet" ; -- konfigurerbarhet..nn.1
  konfigurering_1_N = mkN "konfigurering" ; -- konfigurering..nn.1
  konfirmand_1_N = mkN "konfirmand" "konfirmander" ; -- konfirmand..nn.1
  konfirmandklass_1_N = mkN "konfirmandklass" "konfirmandklasser" ; -- konfirmandklass..nn.1
  konfirmandresa_1_N = mkN "konfirmandresa" ; -- konfirmandresa..nn.1
  konfirmandundervisning_1_N = mkN "konfirmandundervisning" ; -- konfirmandundervisning..nn.1
  konfirmation_1_N = mkN "konfirmation" ; -- konfirmation..nn.1
  konfirmationsbibel_1_N = mkN "konfirmationsbibel" ; -- konfirmationsbibel..nn.1
  konfirmationsgåva_1_N = mkN "konfirmationsgåva" ; -- konfirmationsgåva..nn.1
  konfirmationsklänning_1_N = mkN "konfirmationsklänning" ; -- konfirmationsklänning..nn.1
  konfirmationskostym_1_N = mkN "konfirmationskostym" "konfirmationskostymer" ; -- konfirmationskostym..nn.1
  konfirmationspräst_1_N = mkN "konfirmationspräst" "konfirmationspräster" ; -- konfirmationspräst..nn.1
  konfirmationsundervisning_1_N = mkN "konfirmationsundervisning" ; -- konfirmationsundervisning..nn.1
  konfirmationsålder_1_N = mkN "konfirmationsålder" ; -- konfirmationsålder..nn.1
  konfirmera_1_V = mkV "konfirmerar" ; -- konfirmera..vb.1
  konfirmerande_1_N = mkN "konfirmerande" ; -- konfirmerande..nn.1
  konfirmerbar_1_A = mkA "konfirmerbar" ; -- konfirmerbar..av.1
  konfirmerbarhet_1_N = mkN "konfirmerbarhet" ; -- konfirmerbarhet..nn.1
  konfirmering_1_N = mkN "konfirmering" ; -- konfirmering..nn.1
  konfiskation_1_N = mkN "konfiskation" ; -- konfiskation..nn.1
  konfiskatorisk_1_A = mkA "konfiskatorisk" ; -- konfiskatorisk..av.1
  konfiskera_1_V = mkV "konfiskerar" ; -- konfiskera..vb.1
  konfiskerande_1_N = mkN "konfiskerande" ; -- konfiskerande..nn.1
  konfiskerbar_1_A = mkA "konfiskerbar" ; -- konfiskerbar..av.1
  konfiskerbarhet_1_N = mkN "konfiskerbarhet" ; -- konfiskerbarhet..nn.1
  konfiskering_1_N = mkN "konfiskering" ; -- konfiskering..nn.1
  konflikt_1_N = mkN "konflikt" "konflikter" ; -- konflikt..nn.1
  konfliktdiamant_1_N = mkN "konfliktdiamant" "konfliktdiamanter" ; -- konfliktdiamant..nn.1
  konfliktdrabbad_1_A = mkA "konfliktdrabbad" ; -- konfliktdrabbad..av.1
  konfliktfylld_1_A = mkA "konfliktfylld" "konfliktfyllt" ; -- konfliktfylld..av.1
  konfliktförebyggande_1_A = mkA "konfliktförebyggande" ; -- konfliktförebyggande..av.1
  konflikthärd_1_N = mkN "konflikthärd" ; -- konflikthärd..nn.1
  konfliktlösning_1_N = mkN "konfliktlösning" ; -- konfliktlösning..nn.1
  konfliktmetall_1_N = mkN "konfliktmetall" "konfliktmetaller" ; -- konfliktmetall..nn.1
  konfliktmineral_1_N = mkN "konfliktmineral" "konfliktmineralet" "konfliktmineralier" "konfliktmineralierna" ; -- konfliktmineral..nn.1
  konfliktmönster_1_N = mkN "konfliktmönster" neutrum  ; -- konfliktmönster..nn.1
  konfliktregion_1_N = mkN "konfliktregion" ; -- konfliktregion..nn.1
  konflikträdd_1_A = mkA "konflikträdd" ; -- konflikträdd..av.1
  konflikträdsla_1_N = mkN "konflikträdsla" ; -- konflikträdsla..nn.1
  konfliktsituation_1_N = mkN "konfliktsituation" ; -- konfliktsituation..nn.1
  konfliktskygghet_1_N = mkN "konfliktskygghet" ; -- konfliktskygghet..nn.1
  konfliktstörd_1_A = mkA "konfliktstörd" "konfliktstört" ; -- konfliktstörd..av.1
  konfliktvarsel_1_N = mkN "konfliktvarsel" neutrum  ; -- konfliktvarsel..nn.1
  konfliktzon_1_N = mkN "konfliktzon" "konfliktzoner" ; -- konfliktzon..nn.1
  konform_1_A = mkA "konform" ; -- konform..av.1
  konformad_1_A = mkA "konformad" ; -- konformad..av.1
  konformera_1_V = mkV "konformerar" ; -- konformera..vb.1
  konformig_1_A = mkA "konformig" ; -- konformig..av.1
  konformism_1_N = mkN "konformism" "konformismer" ; -- konformism..nn.1
  konformist_1_N = mkN "konformist" "konformister" ; -- konformist..nn.1
  konformistisk_1_A = mkA "konformistisk" ; -- konformistisk..av.1
  konformitet_1_N = mkN "konformitet" "konformiteter" ; -- konformitet..nn.1
  konfrontation_1_N = mkN "konfrontation" ; -- konfrontation..nn.1
  konfrontativ_1_A = mkA "konfrontativ" ; -- konfrontativ..av.1
  konfrontatorisk_1_A = mkA "konfrontatorisk" ; -- konfrontatorisk..av.1
  konfrontera_1_V = mkV "konfronterar" ; -- konfrontera..vb.1
  konfronterande_1_N = mkN "konfronterande" ; -- konfronterande..nn.1
  konfronterbar_1_A = mkA "konfronterbar" ; -- konfronterbar..av.1
  konfronterbarhet_1_N = mkN "konfronterbarhet" ; -- konfronterbarhet..nn.1
  konfrontering_1_N = mkN "konfrontering" ; -- konfrontering..nn.1
  konfucianism_1_N = mkN "konfucianism" "konfucianismer" ; -- konfucianism..nn.1
  konfucianistisk_1_A = mkA "konfucianistisk" ; -- konfucianistisk..av.1
  konfuciansk_1_A = mkA "konfuciansk" ; -- konfuciansk..av.1
  konfundera_1_V = mkV "konfunderar" ; -- konfundera..vb.1
  konfunderande_1_N = mkN "konfunderande" ; -- konfunderande..nn.1
  konfunderbar_1_A = mkA "konfunderbar" ; -- konfunderbar..av.1
  konfunderbarhet_1_N = mkN "konfunderbarhet" ; -- konfunderbarhet..nn.1
  konfundering_1_N = mkN "konfundering" ; -- konfundering..nn.1
  konfusion_1_N = mkN "konfusion" ; -- konfusion..nn.1
  konfys_1_A = mkA "konfys" ; -- konfys..av.1
  kongenial_1_A = mkA "kongenial" ; -- kongenial..av.1
  kongenital_1_A = mkA "kongenital" ; -- kongenital..av.1
  konglomerat_1_N = mkN "konglomerat" neutrum  ; -- konglomerat..nn.1
  kongoles_1_N = mkN "kongoles" "kongoleser" ; -- kongoles..nn.1
  kongolesisk_1_A = mkA "kongolesisk" ; -- kongolesisk..av.1
  kongolesiska_1_N = mkN "kongolesiska" ; -- kongolesiska..nn.1
  kongregation_1_N = mkN "kongregation" ; -- kongregation..nn.1
  kongress_1_N = mkN "kongress" "kongresser" ; -- kongress..nn.1
  kongressa_1_V = mkV "kongressar" ; -- kongressa..vb.1
  kongressande_1_N = mkN "kongressande" ; -- kongressande..nn.1
  kongressdatum_1_N = mkN "kongressdatum" ; -- kongressdatum..nn.1
  kongressdeltagare_1_N = mkN "kongressdeltagare" utrum  ; -- kongressdeltagare..nn.1
  kongressman_1_N = mkN "kongressman" "kongressmannen" "kongressmän" "kongressmännen" ; -- kongressman..nn.1
  kongressombud_1_N = mkN "kongressombud" neutrum  ; -- kongressombud..nn.1
  kongressplats_1_N = mkN "kongressplats" "kongressplatser" ; -- kongressplats..nn.1
  kongruens_1_N = mkN "kongruens" "kongruenser" ; -- kongruens..nn.1
  kongruensböjning_1_N = mkN "kongruensböjning" ; -- kongruensböjning..nn.1
  kongruensfall_1_N = mkN "kongruensfall" neutrum  ; -- kongruensfall..nn.1
  kongruent_1_A = mkA "kongruent" "kongruent" ; -- kongruent..av.1
  kongruenthet_1_N = mkN "kongruenthet" ; -- kongruenthet..nn.1
  kongruera_1_V = mkV "kongruerar" ; -- kongruera..vb.1
  kongruerande_1_N = mkN "kongruerande" ; -- kongruerande..nn.1
  kongruerbar_1_A = mkA "kongruerbar" ; -- kongruerbar..av.1
  kongruerbarhet_1_N = mkN "kongruerbarhet" ; -- kongruerbarhet..nn.1
  kongruering_1_N = mkN "kongruering" ; -- kongruering..nn.1
  konicitet_1_N = mkN "konicitet" "koniciteter" ; -- konicitet..nn.1
  konisk_1_A = mkA "konisk" ; -- konisk..av.1
  konjak_1_N = mkN "konjak" "konjaker" ; -- konjak..nn.1
  konjakskrans_1_N = mkN "konjakskrans" ; -- konjakskrans..nn.1
  konjakskupa_1_N = mkN "konjakskupa" ; -- konjakskupa..nn.1
  konjektur_1_N = mkN "konjektur" "konjekturer" ; -- konjektur..nn.1
  konjugation_1_N = mkN "konjugation" ; -- konjugation..nn.1
  konjugera_1_V = mkV "konjugerar" ; -- konjugera..vb.1
  konjugerande_1_N = mkN "konjugerande" ; -- konjugerande..nn.1
  konjugerbar_1_A = mkA "konjugerbar" ; -- konjugerbar..av.1
  konjugerbarhet_1_N = mkN "konjugerbarhet" ; -- konjugerbarhet..nn.1
  konjugering_1_N = mkN "konjugering" ; -- konjugering..nn.1
  konjunktion_1_N = mkN "konjunktion" ; -- konjunktion..nn.1
  konjunktionssats_1_N = mkN "konjunktionssats" "konjunktionssatser" ; -- konjunktionssats..nn.1
  konjunktiv_1_N = mkN "konjunktiv" "konjunktiver" ; -- konjunktiv..nn.1
  konjunktivisk_1_A = mkA "konjunktivisk" ; -- konjunktivisk..av.1
  konjunktivit_1_N = mkN "konjunktivit" ; -- konjunktivit..nn.1
  konjunktur_1_N = mkN "konjunktur" "konjunkturer" ; -- konjunktur..nn.1
  konjunkturförbättring_1_N = mkN "konjunkturförbättring" ; -- konjunkturförbättring..nn.1
  konjunkturinstitut_1_N = mkN "konjunkturinstitut" neutrum  ; -- konjunkturinstitut..nn.1
  konjunkturkurva_1_N = mkN "konjunkturkurva" ; -- konjunkturkurva..nn.1
  konjunkturkänslig_1_A = mkA "konjunkturkänslig" ; -- konjunkturkänslig..av.1
  konjunkturkänslighet_1_N = mkN "konjunkturkänslighet" "konjunkturkänsligheter" ; -- konjunkturkänslighet..nn.1
  konjunkturmässig_1_A = mkA "konjunkturmässig" ; -- konjunkturmässig..av.1
  konjunkturnedgång_1_N = mkN "konjunkturnedgång" ; -- konjunkturnedgång..nn.1
  konjunkturomslag_1_N = mkN "konjunkturomslag" neutrum  ; -- konjunkturomslag..nn.1
  konjunkturpolitik_1_N = mkN "konjunkturpolitik" ; -- konjunkturpolitik..nn.1
  konjunkturpolitisk_1_A = mkA "konjunkturpolitisk" ; -- konjunkturpolitisk..av.1
  konjunkturrapport_1_N = mkN "konjunkturrapport" "konjunkturrapporter" ; -- konjunkturrapport..nn.1
  konjunkturråd_1_N = mkN "konjunkturråd" neutrum  ; -- konjunkturråd..nn.1
  konjunkturstöd_1_N = mkN "konjunkturstöd" neutrum  ; -- konjunkturstöd..nn.1
  konka_1_V = mkV "konkar" ; -- konka..vb.1
  konkande_1_N = mkN "konkande" ; -- konkande..nn.1
  konkav_1_A = mkA "konkav" ; -- konkav..av.1
  konkavitet_1_N = mkN "konkavitet" "konkaviteter" ; -- konkavitet..nn.1
  konkavkonvex_1_A = mkA "konkavkonvex" ; -- konkavkonvex..av.1
  konklav_1_N = mkN "konklav" "konklaver" ; -- konklav..nn.1
  konkludera_1_V = mkV "konkluderar" ; -- konkludera..vb.1
  konkluderande_1_N = mkN "konkluderande" ; -- konkluderande..nn.1
  konkluderbar_1_A = mkA "konkluderbar" ; -- konkluderbar..av.1
  konkluderbarhet_1_N = mkN "konkluderbarhet" ; -- konkluderbarhet..nn.1
  konkludering_1_N = mkN "konkludering" ; -- konkludering..nn.1
  konklusion_1_N = mkN "konklusion" ; -- konklusion..nn.1
  konklusiv_1_A = mkA "konklusiv" ; -- konklusiv..av.1
  konkning_1_N = mkN "konkning" ; -- konkning..nn.1
  konkordans_1_N = mkN "konkordans" "konkordanser" ; -- konkordans..nn.1
  konkordat_1_N = mkN "konkordat" neutrum  ; -- konkordat..nn.1
  konkrement_1_N = mkN "konkrement" neutrum  ; -- konkrement..nn.1
  konkret_1_A = mkA "konkret" "konkret" ; -- konkret..av.1
  konkrethet_1_N = mkN "konkrethet" ; -- konkrethet..nn.1
  konkretion_1_N = mkN "konkretion" ; -- konkretion..nn.1
  konkretisera_1_V = mkV "konkretiserar" ; -- konkretisera..vb.1
  konkretiserande_1_N = mkN "konkretiserande" ; -- konkretiserande..nn.1
  konkretiserbar_1_A = mkA "konkretiserbar" ; -- konkretiserbar..av.1
  konkretiserbarhet_1_N = mkN "konkretiserbarhet" ; -- konkretiserbarhet..nn.1
  konkretisering_1_N = mkN "konkretisering" ; -- konkretisering..nn.1
  konkretism_1_N = mkN "konkretism" "konkretismer" ; -- konkretism..nn.1
  konkretistisk_1_A = mkA "konkretistisk" ; -- konkretistisk..av.1
  konkubin_1_N = mkN "konkubin" "konkubiner" ; -- konkubin..nn.1
  konkurrens_1_N = mkN "konkurrens" ; -- konkurrens..nn.1
  konkurrensbegränsande_1_A = mkA "konkurrensbegränsande" ; -- konkurrensbegränsande..av.1
  konkurrensduglig_1_A = mkA "konkurrensduglig" ; -- konkurrensduglig..av.1
  konkurrensfördel_1_N = mkN "konkurrensfördel" "konkurrensfördelen" "konkurrensfördelar" "konkurrensfördelarna" ; -- konkurrensfördel..nn.1
  konkurrensförmåga_1_N = mkN "konkurrensförmåga" ; -- konkurrensförmåga..nn.1
  konkurrenshämmande_1_A = mkA "konkurrenshämmande" ; -- konkurrenshämmande..av.1
  konkurrenskraft_1_N = mkN "konkurrenskraft" ; -- konkurrenskraft..nn.1
  konkurrenskraftig_1_A = mkA "konkurrenskraftig" ; -- konkurrenskraftig..av.1
  konkurrensmarknad_1_N = mkN "konkurrensmarknad" "konkurrensmarknader" ; -- konkurrensmarknad..nn.1
  konkurrensmedel_1_N = mkN "konkurrensmedel" neutrum  ; -- konkurrensmedel..nn.1
  konkurrensmässig_1_A = mkA "konkurrensmässig" ; -- konkurrensmässig..av.1
  konkurrenssamhälle_1_N = mkN "konkurrenssamhälle" ; -- konkurrenssamhälle..nn.1
  konkurrensutsatt_1_A = mkA "konkurrensutsatt" ; -- konkurrensutsatt..av.1
  konkurrensutsatthet_1_N = mkN "konkurrensutsatthet" ; -- konkurrensutsatthet..nn.1
  konkurrensutsätta_1_V = mkV "konkurrensutsätta" "konkurrensutsätter" "konkurrensutsätt" "konkurrensutsatte" "konkurrensutsatt" "konkurrensutsatt" ; -- konkurrensutsätta..vb.1
  konkurrensutsättande_1_N = mkN "konkurrensutsättande" ; -- konkurrensutsättande..nn.1
  konkurrensutsättning_1_N = mkN "konkurrensutsättning" ; -- konkurrensutsättning..nn.1
  konkurrensverk_1_N = mkN "konkurrensverk" neutrum  ; -- konkurrensverk..nn.1
  konkurrent_1_N = mkN "konkurrent" "konkurrenter" ; -- konkurrent..nn.1
  konkurrera_1_V = mkV "konkurrerar" ; -- konkurrera..vb.1
  konkurrerande_1_N = mkN "konkurrerande" ; -- konkurrerande..nn.1
  konkurrering_1_N = mkN "konkurrering" ; -- konkurrering..nn.1
  konkurs_1_N = mkN "konkurs" "konkurser" ; -- konkurs..nn.1
  konkursbevakning_1_N = mkN "konkursbevakning" ; -- konkursbevakning..nn.1
  konkursbo_1_N = mkN "konkursbo" "konkursboet" "konkursbon" "konkursbona" ; -- konkursbo..nn.1
  konkursdividend_1_N = mkN "konkursdividend" "konkursdividender" ; -- konkursdividend..nn.1
  konkursfärdig_1_A = mkA "konkursfärdig" ; -- konkursfärdig..av.1
  konkursförvaltare_1_N = mkN "konkursförvaltare" utrum  ; -- konkursförvaltare..nn.1
  konkursmassa_1_N = mkN "konkursmassa" ; -- konkursmassa..nn.1
  konkursmässig_1_A = mkA "konkursmässig" ; -- konkursmässig..av.1
  konkursmässighet_1_N = mkN "konkursmässighet" ; -- konkursmässighet..nn.1
  konkursrealisation_1_N = mkN "konkursrealisation" ; -- konkursrealisation..nn.1
  konnotation_1_N = mkN "konnotation" ; -- konnotation..nn.1
  konnotativ_1_A = mkA "konnotativ" ; -- konnotativ..av.1
  konnässans_1_N = mkN "konnässans" "konnässanser" ; -- konnässans..nn.1
  konnässör_1_N = mkN "konnässör" "konnässörer" ; -- konnässör..nn.1
  konossement_1_N = mkN "konossement" neutrum  ; -- konossement..nn.1
  konprick_1_N = mkN "konprick" ; -- konprick..nn.1
  konsekutiv_1_A = mkA "konsekutiv" ; -- konsekutiv..av.1
  konsekutivsats_1_N = mkN "konsekutivsats" "konsekutivsatser" ; -- konsekutivsats..nn.1
  konsekvens_1_N = mkN "konsekvens" "konsekvenser" ; -- konsekvens..nn.1
  konsekvensanalys_1_N = mkN "konsekvensanalys" "konsekvensanalyser" ; -- konsekvensanalys..nn.1
  konsekvent_1_A = mkA "konsekvent" "konsekvent" ; -- konsekvent..av.1
  konsekventhet_1_N = mkN "konsekventhet" ; -- konsekventhet..nn.1
  konselj_1_N = mkN "konselj" "konseljer" ; -- konselj..nn.1
  konseljpresident_1_N = mkN "konseljpresident" "konseljpresidenter" ; -- konseljpresident..nn.1
  konsensus_1_N = mkN "konsensus" ; -- konsensus..nn.1
  konsensuskultur_1_N = mkN "konsensuskultur" "konsensuskulturer" ; -- konsensuskultur..nn.1
  konsert_1_N = mkN "konsert" "konserter" ; -- konsert..nn.1
  konsertaffisch_1_N = mkN "konsertaffisch" "konsertaffischer" ; -- konsertaffisch..nn.1
  konsertera_1_V = mkV "konserterar" ; -- konsertera..vb.1
  konserterande_1_N = mkN "konserterande" ; -- konserterande..nn.1
  konsertering_1_N = mkN "konsertering" ; -- konsertering..nn.1
  konserthall_1_N = mkN "konserthall" ; -- konserthall..nn.1
  konserthus_1_N = mkN "konserthus" neutrum  ; -- konserthus..nn.1
  konsertmästare_1_N = mkN "konsertmästare" utrum  ; -- konsertmästare..nn.1
  konsertstycke_1_N = mkN "konsertstycke" ; -- konsertstycke..nn.1
  konsertsångare_1_N = mkN "konsertsångare" utrum  ; -- konsertsångare..nn.1
  konsertturné_1_N = mkN "konsertturné" "konsertturnéer" ; -- konsertturné..nn.1
  konserv_1_N = mkN "konserv" "konserver" ; -- konserv..nn.1
  konservatism_1_N = mkN "konservatism" "konservatismer" ; -- konservatism..nn.1
  konservativ_1_A = mkA "konservativ" ; -- konservativ..av.1
  konservator_1_N = mkN "konservator" "konservatorer" ; -- konservator..nn.1
  konservatorium_1_N = mkN "konservatorium" "konservatoriet" "konservatorier" "konservatorierna" ; -- konservatorium..nn.1
  konservburk_1_N = mkN "konservburk" ; -- konservburk..nn.1
  konservera_1_V = mkV "konserverar" ; -- konservera..vb.1
  konserverande_1_N = mkN "konserverande" ; -- konserverande..nn.1
  konserverbar_1_A = mkA "konserverbar" ; -- konserverbar..av.1
  konserverbarhet_1_N = mkN "konserverbarhet" ; -- konserverbarhet..nn.1
  konservering_1_N = mkN "konservering" ; -- konservering..nn.1
  konserveringsapparat_1_N = mkN "konserveringsapparat" "konserveringsapparater" ; -- konserveringsapparat..nn.1
  konserveringsmedel_1_N = mkN "konserveringsmedel" neutrum  ; -- konserveringsmedel..nn.1
  konservfabrik_1_N = mkN "konservfabrik" "konservfabriker" ; -- konservfabrik..nn.1
  konservöppnare_1_N = mkN "konservöppnare" utrum  ; -- konservöppnare..nn.1
  konsideration_1_N = mkN "konsideration" ; -- konsideration..nn.1
  konsignation_1_N = mkN "konsignation" ; -- konsignation..nn.1
  konsignera_1_V = mkV "konsignerar" ; -- konsignera..vb.1
  konsignerande_1_N = mkN "konsignerande" ; -- konsignerande..nn.1
  konsignerbar_1_A = mkA "konsignerbar" ; -- konsignerbar..av.1
  konsignerbarhet_1_N = mkN "konsignerbarhet" ; -- konsignerbarhet..nn.1
  konsignering_1_N = mkN "konsignering" ; -- konsignering..nn.1
  konsilians_1_N = mkN "konsilians" "konsilianser" ; -- konsilians..nn.1
  konsiliant_1_A = mkA "konsiliant" "konsiliant" ; -- konsiliant..av.1
  konsilium_1_N = mkN "konsilium" "konsiliet" "konsilier" "konsilierna" ; -- konsilium..nn.1
  konsistens_1_N = mkN "konsistens" "konsistenser" ; -- konsistens..nn.1
  konsistensfett_1_N = mkN "konsistensfett" neutrum  ; -- konsistensfett..nn.1
  konsistensgivare_1_N = mkN "konsistensgivare" utrum  ; -- konsistensgivare..nn.1
  konsistorial_1_A = mkA "konsistorial" ; -- konsistorial..av.1
  konsistorium_1_N = mkN "konsistorium" "konsistoriet" "konsistorier" "konsistorierna" ; -- konsistorium..nn.1
  konsol_1_N = mkN "konsol" "konsoler" ; -- konsol..nn.1
  konsolidation_1_N = mkN "konsolidation" ; -- konsolidation..nn.1
  konsolidera_1_V = mkV "konsoliderar" ; -- konsolidera..vb.1
  konsoliderande_1_N = mkN "konsoliderande" ; -- konsoliderande..nn.1
  konsoliderbar_1_A = mkA "konsoliderbar" ; -- konsoliderbar..av.1
  konsoliderbarhet_1_N = mkN "konsoliderbarhet" ; -- konsoliderbarhet..nn.1
  konsolidering_1_N = mkN "konsolidering" ; -- konsolidering..nn.1
  konsommé_1_N = mkN "konsommé" "konsomméer" ; -- konsommé..nn.1
  konsonans_1_N = mkN "konsonans" "konsonanser" ; -- konsonans..nn.1
  konsonant_1_A = mkA "konsonant" "konsonant" ; -- konsonant..av.1
  konsonant_1_N = mkN "konsonant" "konsonanter" ; -- konsonant..nn.1
  konsonantisk_1_A = mkA "konsonantisk" ; -- konsonantisk..av.1
  konsonantstam_1_N = mkN "konsonantstam" "konsonantstammen" "konsonantstammar" "konsonantstammarna" ; -- konsonantstam..nn.1
  konsonantsystem_1_N = mkN "konsonantsystem" neutrum  ; -- konsonantsystem..nn.1
  konsortium_1_N = mkN "konsortium" "konsortiet" "konsortier" "konsortierna" ; -- konsortium..nn.1
  konspiration_1_N = mkN "konspiration" ; -- konspiration..nn.1
  konspirationsteoretiker_1_N = mkN "konspirationsteoretiker" "konspirationsteoretikern" "konspirationsteoretiker" "konspirationsteoretikerna" ; -- konspirationsteoretiker..nn.1
  konspirationsteoretisk_1_A = mkA "konspirationsteoretisk" ; -- konspirationsteoretisk..av.1
  konspirationsteori_1_N = mkN "konspirationsteori" "konspirationsteorier" ; -- konspirationsteori..nn.1
  konspirativ_1_A = mkA "konspirativ" ; -- konspirativ..av.1
  konspiratorisk_1_A = mkA "konspiratorisk" ; -- konspiratorisk..av.1
  konspiratör_1_N = mkN "konspiratör" "konspiratörer" ; -- konspiratör..nn.1
  konspirera_1_V = mkV "konspirerar" ; -- konspirera..vb.1
  konspirerande_1_N = mkN "konspirerande" ; -- konspirerande..nn.1
  konspirering_1_N = mkN "konspirering" ; -- konspirering..nn.1
  konst_1_N = mkN "konst" "konster" ; -- konst..nn.1
  konstakademi_1_N = mkN "konstakademi" "konstakademier" ; -- konstakademi..nn.1
  konstans_1_N = mkN "konstans" ; -- konstans..nn.1
  konstansfenomen_1_N = mkN "konstansfenomen" neutrum  ; -- konstansfenomen..nn.1
  konstant_1_A = mkA "konstant" "konstant" ; -- konstant..av.1
  konstant_1_N = mkN "konstant" "konstanter" ; -- konstant..nn.1
  konstapel_1_N = mkN "konstapel" ; -- konstapel..nn.1
  konstart_1_N = mkN "konstart" "konstarter" ; -- konstart..nn.1
  konstatera_1_V = mkV "konstaterar" ; -- konstatera..vb.1
  konstaterande_1_N = mkN "konstaterande" ; -- konstaterande..nn.1
  konstaterbar_1_A = mkA "konstaterbar" ; -- konstaterbar..av.1
  konstaterbarhet_1_N = mkN "konstaterbarhet" ; -- konstaterbarhet..nn.1
  konstatering_1_N = mkN "konstatering" ; -- konstatering..nn.1
  konstbefrukta_1_V = mkV "konstbefruktar" ; -- konstbefrukta..vb.1
  konstbefruktande_1_N = mkN "konstbefruktande" ; -- konstbefruktande..nn.1
  konstberidare_1_N = mkN "konstberidare" utrum  ; -- konstberidare..nn.1
  konstbevattna_1_V = mkV "konstbevattnar" ; -- konstbevattna..vb.1
  konstbevattnande_1_N = mkN "konstbevattnande" ; -- konstbevattnande..nn.1
  konstbevattning_1_N = mkN "konstbevattning" ; -- konstbevattning..nn.1
  konstellation_1_N = mkN "konstellation" ; -- konstellation..nn.1
  konsternation_1_N = mkN "konsternation" ; -- konsternation..nn.1
  konsternera_1_V = mkV "konsternerar" ; -- konsternera..vb.1
  konsternerande_1_N = mkN "konsternerande" ; -- konsternerande..nn.1
  konsternerbar_1_A = mkA "konsternerbar" ; -- konsternerbar..av.1
  konsternerbarhet_1_N = mkN "konsternerbarhet" ; -- konsternerbarhet..nn.1
  konsternering_1_N = mkN "konsternering" ; -- konsternering..nn.1
  konstfiber_1_N = mkN "konstfiber" "konstfibern" "konstfibrer" "konstfibrerna" ; -- konstfiber..nn.1
  konstfiberkudde_1_N = mkN "konstfiberkudde" utrum  ; -- konstfiberkudde..nn.1
  konstfibermöbel_1_N = mkN "konstfibermöbel" "konstfibermöbeln" "konstfibermöbler" "konstfibermöblerna" ; -- konstfibermöbel..nn.1
  konstflit_1_N = mkN "konstflit" ; -- konstflit..nn.1
  konstflygning_1_N = mkN "konstflygning" ; -- konstflygning..nn.1
  konstform_1_N = mkN "konstform" "konstformer" ; -- konstform..nn.1
  konstfrusen_1_A = mkA "konstfrusen" ; -- konstfrusen..av.1
  konstfull_1_A = mkA "konstfull" ; -- konstfull..av.1
  konstfullhet_1_N = mkN "konstfullhet" "konstfullheter" ; -- konstfullhet..nn.1
  konstfärdig_1_A = mkA "konstfärdig" ; -- konstfärdig..av.1
  konstfärdighet_1_N = mkN "konstfärdighet" "konstfärdigheter" ; -- konstfärdighet..nn.1
  konstföreläsning_1_N = mkN "konstföreläsning" ; -- konstföreläsning..nn.1
  konstförening_1_N = mkN "konstförening" ; -- konstförening..nn.1
  konstförfalskare_1_N = mkN "konstförfalskare" utrum  ; -- konstförfalskare..nn.1
  konstförfaren_1_A = mkA "konstförfaren" ; -- konstförfaren..av.1
  konstförfarenhet_1_N = mkN "konstförfarenhet" ; -- konstförfarenhet..nn.1
  konstförvant_1_N = mkN "konstförvant" "konstförvanter" ; -- konstförvant..nn.1
  konstgalleri_1_N = mkN "konstgalleri" "konstgalleriet" "konstgallerier" "konstgallerierna" ; -- konstgalleri..nn.1
  konstgjord_1_A = mkA "konstgjord" "konstgjort" ; -- konstgjord..av.1
  konstgjordhet_1_N = mkN "konstgjordhet" ; -- konstgjordhet..nn.1
  konstglas_1_N = mkN "konstglas" neutrum  ; -- konstglas..nn.1
  konstgrepp_1_N = mkN "konstgrepp" neutrum  ; -- konstgrepp..nn.1
  konstgräs_1_N = mkN "konstgräs" neutrum  ; -- konstgräs..nn.1
  konstgödning_1_N = mkN "konstgödning" ; -- konstgödning..nn.1
  konstgödsel_1_N = mkN "konstgödsel" ; -- konstgödsel..nn.1
  konsthall_1_N = mkN "konsthall" ; -- konsthall..nn.1
  konsthandlare_1_N = mkN "konsthandlare" utrum  ; -- konsthandlare..nn.1
  konsthantverk_1_N = mkN "konsthantverk" neutrum  ; -- konsthantverk..nn.1
  konsthantverksmässig_1_A = mkA "konsthantverksmässig" ; -- konsthantverksmässig..av.1
  konstharts_1_N = mkN "konstharts" "konsthartset" "konsthartser" "konsthartserna" ; -- konstharts..nn.1
  konsthistoria_1_N = mkN "konsthistoria" ; -- konsthistoria..nn.1
  konsthistorisk_1_A = mkA "konsthistorisk" ; -- konsthistorisk..av.1
  konstifik_1_A = mkA "konstifik" ; -- konstifik..av.1
  konstig_1_A = mkA "konstig" ; -- konstig..av.1
  konstighet_1_N = mkN "konstighet" "konstigheter" ; -- konstighet..nn.1
  konstindustri_1_N = mkN "konstindustri" "konstindustrier" ; -- konstindustri..nn.1
  konstindustriell_1_A = mkA "konstindustriell" ; -- konstindustriell..av.1
  konstintresserad_1_A = mkA "konstintresserad" ; -- konstintresserad..av.1
  konstituent_1_N = mkN "konstituent" "konstituenter" ; -- konstituent..nn.1
  konstituera_1_V = mkV "konstituerar" ; -- konstituera..vb.1
  konstituerande_1_N = mkN "konstituerande" ; -- konstituerande..nn.1
  konstituerbar_1_A = mkA "konstituerbar" ; -- konstituerbar..av.1
  konstituerbarhet_1_N = mkN "konstituerbarhet" ; -- konstituerbarhet..nn.1
  konstituering_1_N = mkN "konstituering" ; -- konstituering..nn.1
  konstitution_1_N = mkN "konstitution" ; -- konstitution..nn.1
  konstitutionell_1_A = mkA "konstitutionell" ; -- konstitutionell..av.1
  konstitutionsutskott_1_N = mkN "konstitutionsutskott" neutrum  ; -- konstitutionsutskott..nn.1
  konstitutiv_1_A = mkA "konstitutiv" ; -- konstitutiv..av.1
  konstitutorial_1_N = mkN "konstitutorial" neutrum  ; -- konstitutorial..nn.1
  konstklotter_1_N = mkN "konstklotter" neutrum  ; -- konstklotter..nn.1
  konstkritik_1_N = mkN "konstkritik" ; -- konstkritik..nn.1
  konstkritiker_1_N = mkN "konstkritiker" "konstkritikern" "konstkritiker" "konstkritikerna" ; -- konstkritiker..nn.1
  konstkännare_1_N = mkN "konstkännare" utrum  ; -- konstkännare..nn.1
  konstlad_1_A = mkA "konstlad" ; -- konstlad..av.1
  konstliga_1_N = mkN "konstliga" ; -- konstliga..nn.1
  konstliv_1_N = mkN "konstliv" neutrum  ; -- konstliv..nn.1
  konstläder_1_N = mkN "konstläder" neutrum  ; -- konstläder..nn.1
  konstläderförstärkning_1_N = mkN "konstläderförstärkning" ; -- konstläderförstärkning..nn.1
  konstlös_1_A = mkA "konstlös" ; -- konstlös..av.1
  konstlöshet_1_N = mkN "konstlöshet" "konstlösheter" ; -- konstlöshet..nn.1
  konstmassa_1_N = mkN "konstmassa" ; -- konstmassa..nn.1
  konstmuseum_1_N = mkN "konstmuseum" "konstmuseet" "konstmuseer" "konstmuseerna" ; -- konstmuseum..nn.1
  konstmusik_1_N = mkN "konstmusik" ; -- konstmusik..nn.1
  konstmusikalisk_1_A = mkA "konstmusikalisk" ; -- konstmusikalisk..av.1
  konstmässig_1_A = mkA "konstmässig" ; -- konstmässig..av.1
  konstmässighet_1_N = mkN "konstmässighet" ; -- konstmässighet..nn.1
  konstmålare_1_N = mkN "konstmålare" utrum  ; -- konstmålare..nn.1
  konstmålning_1_N = mkN "konstmålning" ; -- konstmålning..nn.1
  konstnär_1_N = mkN "konstnär" "konstnärer" ; -- konstnär..nn.1
  konstnärlig_1_A = mkA "konstnärlig" ; -- konstnärlig..av.1
  konstnärlighet_1_N = mkN "konstnärlighet" ; -- konstnärlighet..nn.1
  konstnärsblick_1_N = mkN "konstnärsblick" ; -- konstnärsblick..nn.1
  konstnärskap_1_N = mkN "konstnärskap" neutrum  ; -- konstnärskap..nn.1
  konstnärskollektiv_1_N = mkN "konstnärskollektiv" neutrum  ; -- konstnärskollektiv..nn.1
  konstnärskrets_1_N = mkN "konstnärskrets" ; -- konstnärskrets..nn.1
  konstnärslägenhet_1_N = mkN "konstnärslägenhet" "konstnärslägenheter" ; -- konstnärslägenhet..nn.1
  konstnärssjäl_1_N = mkN "konstnärssjäl" ; -- konstnärssjäl..nn.1
  konstnärstät_1_A = mkA "konstnärstät" ; -- konstnärstät..av.1
  konstnärstäthet_1_N = mkN "konstnärstäthet" ; -- konstnärstäthet..nn.1
  konstpaus_1_N = mkN "konstpaus" "konstpauser" ; -- konstpaus..nn.1
  konstra_1_V = mkV "konstrar" ; -- konstra..vb.1
  konstrande_1_N = mkN "konstrande" ; -- konstrande..nn.1
  konstridning_1_N = mkN "konstridning" ; -- konstridning..nn.1
  konstrik_1_A = mkA "konstrik" ; -- konstrik..av.1
  konstrikhet_1_N = mkN "konstrikhet" ; -- konstrikhet..nn.1
  konstriktning_1_N = mkN "konstriktning" ; -- konstriktning..nn.1
  konstruera_1_V = mkV "konstruerar" ; -- konstruera..vb.1
  konstruerad_1_A = mkA "konstruerad" ; -- konstruerad..av.1
  konstruerande_1_N = mkN "konstruerande" ; -- konstruerande..nn.1
  konstruerbar_1_A = mkA "konstruerbar" ; -- konstruerbar..av.1
  konstruerbarhet_1_N = mkN "konstruerbarhet" ; -- konstruerbarhet..nn.1
  konstruering_1_N = mkN "konstruering" ; -- konstruering..nn.1
  konstruktikon_1_N = mkN "konstruktikon" neutrum  ; -- konstruktikon..nn.1
  konstruktion_1_N = mkN "konstruktion" ; -- konstruktion..nn.1
  konstruktionsdetalj_1_N = mkN "konstruktionsdetalj" "konstruktionsdetaljer" ; -- konstruktionsdetalj..nn.1
  konstruktionsfel_1_N = mkN "konstruktionsfel" "konstruktionsfelet" "konstruktionsfel" "konstruktionsfelen" ; -- konstruktionsfel..nn.1
  konstruktionsgrammatik_1_N = mkN "konstruktionsgrammatik" "konstruktionsgrammatiker" ; -- konstruktionsgrammatik..nn.1
  konstruktionslexikon_1_N = mkN "konstruktionslexikon" neutrum  ; -- konstruktionslexikon..nn.1
  konstruktionslim_1_N = mkN "konstruktionslim" "konstruktionslimmet" "konstruktionslimmer" "konstruktionslimmerna" ; -- konstruktionslim..nn.1
  konstruktionsmaterial_1_N = mkN "konstruktionsmaterial" neutrum  ; -- konstruktionsmaterial..nn.1
  konstruktionsmässig_1_A = mkA "konstruktionsmässig" ; -- konstruktionsmässig..av.1
  konstruktionsritning_1_N = mkN "konstruktionsritning" ; -- konstruktionsritning..nn.1
  konstruktiv_1_A = mkA "konstruktiv" ; -- konstruktiv..av.1
  konstruktör_1_N = mkN "konstruktör" "konstruktörer" ; -- konstruktör..nn.1
  konstryttare_1_N = mkN "konstryttare" utrum  ; -- konstryttare..nn.1
  konstsalong_1_N = mkN "konstsalong" "konstsalonger" ; -- konstsalong..nn.1
  konstsamlare_1_N = mkN "konstsamlare" utrum  ; -- konstsamlare..nn.1
  konstsamling_1_N = mkN "konstsamling" ; -- konstsamling..nn.1
  konstsatsning_1_N = mkN "konstsatsning" ; -- konstsatsning..nn.1
  konstsiden_1_N = mkN "konstsiden" neutrum  ; -- konstsiden..nn.1
  konstsilke_1_N = mkN "konstsilke" ; -- konstsilke..nn.1
  konstskicklig_1_A = mkA "konstskicklig" ; -- konstskicklig..av.1
  konstskicklighet_1_N = mkN "konstskicklighet" ; -- konstskicklighet..nn.1
  konstskojare_1_N = mkN "konstskojare" utrum  ; -- konstskojare..nn.1
  konstskola_1_N = mkN "konstskola" ; -- konstskola..nn.1
  konstslöjd_1_N = mkN "konstslöjd" ; -- konstslöjd..nn.1
  konstsmed_1_N = mkN "konstsmed" "konstsmeder" ; -- konstsmed..nn.1
  konstsmide_1_N = mkN "konstsmide" ; -- konstsmide..nn.1
  konstspråk_1_N = mkN "konstspråk" neutrum  ; -- konstspråk..nn.1
  konststil_1_N = mkN "konststil" ; -- konststil..nn.1
  konststoppa_1_V = mkV "konststoppar" ; -- konststoppa..vb.1
  konststoppande_1_N = mkN "konststoppande" ; -- konststoppande..nn.1
  konststycke_1_N = mkN "konststycke" ; -- konststycke..nn.1
  konstteoretisk_1_A = mkA "konstteoretisk" ; -- konstteoretisk..av.1
  konstteori_1_N = mkN "konstteori" ; -- konstteori..nn.1
  konstterm_1_N = mkN "konstterm" "konsttermer" ; -- konstterm..nn.1
  konstutställning_1_N = mkN "konstutställning" ; -- konstutställning..nn.1
  konstverk_1_N = mkN "konstverk" neutrum  ; -- konstverk..nn.1
  konstvetenskap_1_N = mkN "konstvetenskap" "konstvetenskaper" ; -- konstvetenskap..nn.1
  konstvetenskaplig_1_A = mkA "konstvetenskaplig" ; -- konstvetenskaplig..av.1
  konstvävd_1_A = mkA "konstvävd" "konstvävt" ; -- konstvävd..av.1
  konstälskande_1_A = mkA "konstälskande" ; -- konstälskande..av.1
  konstälskare_1_N = mkN "konstälskare" utrum  ; -- konstälskare..nn.1
  konståkare_1_N = mkN "konståkare" utrum  ; -- konståkare..nn.1
  konståkning_1_N = mkN "konståkning" ; -- konståkning..nn.1
  konsul_1_N = mkN "konsul" "konsuln" "konsuler" "konsulerna" ; -- konsul..nn.1
  konsularjurisdiktion_1_N = mkN "konsularjurisdiktion" ; -- konsularjurisdiktion..nn.1
  konsulat_1_N = mkN "konsulat" neutrum  ; -- konsulat..nn.1
  konsulent_1_N = mkN "konsulent" "konsulenter" ; -- konsulent..nn.1
  konsulinna_1_N = mkN "konsulinna" ; -- konsulinna..nn.1
  konsulsval_1_N = mkN "konsulsval" neutrum  ; -- konsulsval..nn.1
  konsult_1_N = mkN "konsult" "konsulter" ; -- konsult..nn.1
  konsultation_1_N = mkN "konsultation" ; -- konsultation..nn.1
  konsultativ_1_A = mkA "konsultativ" ; -- konsultativ..av.1
  konsultera_1_V = mkV "konsulterar" ; -- konsultera..vb.1
  konsulterande_1_A = mkA "konsulterande" ; -- konsulterande..av.1
  konsulterande_1_N = mkN "konsulterande" ; -- konsulterande..nn.1
  konsulterbar_1_A = mkA "konsulterbar" ; -- konsulterbar..av.1
  konsulterbarhet_1_N = mkN "konsulterbarhet" ; -- konsulterbarhet..nn.1
  konsultering_1_N = mkN "konsultering" ; -- konsultering..nn.1
  konsultföretag_1_N = mkN "konsultföretag" neutrum  ; -- konsultföretag..nn.1
  konsulär_1_A = mkA "konsulär" ; -- konsulär..av.1
  konsum_1_N = mkN "konsum" neutrum  ; -- konsum..nn.1
  konsument_1_N = mkN "konsument" "konsumenter" ; -- konsument..nn.1
  konsumentfråga_1_N = mkN "konsumentfråga" ; -- konsumentfråga..nn.1
  konsumentförening_1_N = mkN "konsumentförening" ; -- konsumentförening..nn.1
  konsumentkooperation_1_N = mkN "konsumentkooperation" ; -- konsumentkooperation..nn.1
  konsumentombudsman_1_N = mkN "konsumentombudsman" "konsumentombudsmannen" "konsumentombudsmän" "konsumentombudsmännen" ; -- konsumentombudsman..nn.1
  konsumentpolitik_1_N = mkN "konsumentpolitik" ; -- konsumentpolitik..nn.1
  konsumentpolitisk_1_A = mkA "konsumentpolitisk" ; -- konsumentpolitisk..av.1
  konsumentpris_1_N = mkN "konsumentpris" neutrum  ; -- konsumentpris..nn.1
  konsumentprisindex_1_N = mkN "konsumentprisindex" neutrum  ; -- konsumentprisindex..nn.1
  konsumentupplysning_1_N = mkN "konsumentupplysning" ; -- konsumentupplysning..nn.1
  konsumentverk_1_N = mkN "konsumentverk" neutrum  ; -- konsumentverk..nn.1
  konsumera_1_V = mkV "konsumerar" ; -- konsumera..vb.1
  konsumerande_1_N = mkN "konsumerande" ; -- konsumerande..nn.1
  konsumerbar_1_A = mkA "konsumerbar" ; -- konsumerbar..av.1
  konsumerbarhet_1_N = mkN "konsumerbarhet" ; -- konsumerbarhet..nn.1
  konsumering_1_N = mkN "konsumering" ; -- konsumering..nn.1
  konsumism_1_N = mkN "konsumism" "konsumismer" ; -- konsumism..nn.1
  konsumist_1_N = mkN "konsumist" "konsumister" ; -- konsumist..nn.1
  konsumtion_1_N = mkN "konsumtion" ; -- konsumtion..nn.1
  konsumtionsfixerad_1_A = mkA "konsumtionsfixerad" ; -- konsumtionsfixerad..av.1
  konsumtionsfrosseri_1_N = mkN "konsumtionsfrosseri" neutrum  ; -- konsumtionsfrosseri..nn.1
  konsumtionsmöjlighet_1_N = mkN "konsumtionsmöjlighet" "konsumtionsmöjligheter" ; -- konsumtionsmöjlighet..nn.1
  konsumtionsmönster_1_N = mkN "konsumtionsmönster" neutrum  ; -- konsumtionsmönster..nn.1
  konsumtionssamhälle_1_N = mkN "konsumtionssamhälle" ; -- konsumtionssamhälle..nn.1
  konsumtionsskatt_1_N = mkN "konsumtionsskatt" "konsumtionsskatter" ; -- konsumtionsskatt..nn.1
  konsumtionsskillnad_1_N = mkN "konsumtionsskillnad" "konsumtionsskillnader" ; -- konsumtionsskillnad..nn.1
  konsumtionsstimulerande_1_A = mkA "konsumtionsstimulerande" ; -- konsumtionsstimulerande..av.1
  konsumtionsvara_1_N = mkN "konsumtionsvara" ; -- konsumtionsvara..nn.1
  kont_1_N = mkN "kont" ; -- kont..nn.1
  kontagiös_1_A = mkA "kontagiös" ; -- kontagiös..av.1
  kontakt_1_N = mkN "kontakt" "kontakter" ; -- kontakt..nn.1
  kontakta_1_V = mkV "kontaktar" ; -- kontakta..vb.1
  kontaktande_1_N = mkN "kontaktande" ; -- kontaktande..nn.1
  kontaktannons_1_N = mkN "kontaktannons" "kontaktannonser" ; -- kontaktannons..nn.1
  kontaktbar_1_A = mkA "kontaktbar" ; -- kontaktbar..av.1
  kontaktbehov_1_N = mkN "kontaktbehov" neutrum  ; -- kontaktbehov..nn.1
  kontaktborste_1_N = mkN "kontaktborste" utrum  ; -- kontaktborste..nn.1
  kontaktinfektion_1_N = mkN "kontaktinfektion" ; -- kontaktinfektion..nn.1
  kontaktkopia_1_N = mkN "kontaktkopia" ; -- kontaktkopia..nn.1
  kontaktledning_1_N = mkN "kontaktledning" ; -- kontaktledning..nn.1
  kontaktlins_1_N = mkN "kontaktlins" "kontaktlinser" ; -- kontaktlins..nn.1
  kontaktman_1_N = mkN "kontaktman" "kontaktmannen" "kontaktmän" "kontaktmännen" ; -- kontaktman..nn.1
  kontaktnät_1_N = mkN "kontaktnät" neutrum  ; -- kontaktnät..nn.1
  kontaktperson_1_N = mkN "kontaktperson" "kontaktpersoner" ; -- kontaktperson..nn.1
  kontaktskapande_1_A = mkA "kontaktskapande" ; -- kontaktskapande..av.1
  kontaktskapande_1_N = mkN "kontaktskapande" ; -- kontaktskapande..nn.1
  kontaktsökande_1_A = mkA "kontaktsökande" ; -- kontaktsökande..av.1
  kontamination_1_N = mkN "kontamination" ; -- kontamination..nn.1
  kontaminationsögonblick_1_N = mkN "kontaminationsögonblick" neutrum  ; -- kontaminationsögonblick..nn.1
  kontaminera_1_V = mkV "kontaminerar" ; -- kontaminera..vb.1
  kontaminerande_1_N = mkN "kontaminerande" ; -- kontaminerande..nn.1
  kontaminerbar_1_A = mkA "kontaminerbar" ; -- kontaminerbar..av.1
  kontaminerbarhet_1_N = mkN "kontaminerbarhet" ; -- kontaminerbarhet..nn.1
  kontaminering_1_N = mkN "kontaminering" ; -- kontaminering..nn.1
  kontant_1_A = mkA "kontant" "kontant" ; -- kontant..av.1
  kontantkort_1_N = mkN "kontantkort" neutrum  ; -- kontantkort..nn.1
  kontemplation_1_N = mkN "kontemplation" ; -- kontemplation..nn.1
  kontemplativ_1_A = mkA "kontemplativ" ; -- kontemplativ..av.1
  kontenans_1_N = mkN "kontenans" ; -- kontenans..nn.1
  kontenta_1_N = mkN "kontenta" ; -- kontenta..nn.1
  kontera_1_V = mkV "konterar" ; -- kontera..vb.1
  konteramiral_1_N = mkN "konteramiral" "konteramiraler" ; -- konteramiral..nn.1
  konterande_1_N = mkN "konterande" ; -- konterande..nn.1
  konterbar_1_A = mkA "konterbar" ; -- konterbar..av.1
  konterbarhet_1_N = mkN "konterbarhet" ; -- konterbarhet..nn.1
  konterfej_1_N = mkN "konterfej" neutrum  ; -- konterfej..nn.1
  kontering_1_N = mkN "kontering" ; -- kontering..nn.1
  kontext_1_N = mkN "kontext" "kontexter" ; -- kontext..nn.1
  kontinent_1_N = mkN "kontinent" "kontinenter" ; -- kontinent..nn.1
  kontinental_1_A = mkA "kontinental" ; -- kontinental..av.1
  kontinentaldrift_1_N = mkN "kontinentaldrift" ; -- kontinentaldrift..nn.1
  kontinentalklimat_1_N = mkN "kontinentalklimat" neutrum  ; -- kontinentalklimat..nn.1
  kontinentalplatå_1_N = mkN "kontinentalplatå" "kontinentalplatåer" ; -- kontinentalplatå..nn.1
  kontinentalsockel_1_N = mkN "kontinentalsockel" ; -- kontinentalsockel..nn.1
  kontingent_1_N = mkN "kontingent" "kontingenter" ; -- kontingent..nn.1
  kontingentera_1_V = mkV "kontingenterar" ; -- kontingentera..vb.1
  kontingenterande_1_N = mkN "kontingenterande" ; -- kontingenterande..nn.1
  kontingenterbar_1_A = mkA "kontingenterbar" ; -- kontingenterbar..av.1
  kontingenterbarhet_1_N = mkN "kontingenterbarhet" ; -- kontingenterbarhet..nn.1
  kontingentering_1_N = mkN "kontingentering" ; -- kontingentering..nn.1
  kontinuerlig_1_A = mkA "kontinuerlig" ; -- kontinuerlig..av.1
  kontinuerlighet_1_N = mkN "kontinuerlighet" ; -- kontinuerlighet..nn.1
  kontinuitet_1_N = mkN "kontinuitet" "kontinuiteter" ; -- kontinuitet..nn.1
  kontinuitetsskogsbruk_1_N = mkN "kontinuitetsskogsbruk" neutrum  ; -- kontinuitetsskogsbruk..nn.1
  kontinuum_1_N = mkN "kontinuum" neutrum  ; -- kontinuum..nn.1
  konto_1_N = mkN "konto" "kontot" "konton" "kontona" ; -- konto..nn.1
  kontoinnehavare_1_N = mkN "kontoinnehavare" utrum  ; -- kontoinnehavare..nn.1
  kontokort_1_N = mkN "kontokort" neutrum  ; -- kontokort..nn.1
  kontokurant_1_N = mkN "kontokurant" "kontokuranter" ; -- kontokurant..nn.1
  kontonummer_1_N = mkN "kontonummer" neutrum  ; -- kontonummer..nn.1
  kontor_1_N = mkN "kontor" neutrum  ; -- kontor..nn.1
  kontorisera_1_V = mkV "kontoriserar" ; -- kontorisera..vb.1
  kontoriserande_1_N = mkN "kontoriserande" ; -- kontoriserande..nn.1
  kontoriserbar_1_A = mkA "kontoriserbar" ; -- kontoriserbar..av.1
  kontoriserbarhet_1_N = mkN "kontoriserbarhet" ; -- kontoriserbarhet..nn.1
  kontorisering_1_N = mkN "kontorisering" ; -- kontorisering..nn.1
  kontorist_1_N = mkN "kontorist" "kontorister" ; -- kontorist..nn.1
  kontorsanställd_1_A = mkA "kontorsanställd" "kontorsanställt" ; -- kontorsanställd..av.1
  kontorsarbete_1_N = mkN "kontorsarbete" ; -- kontorsarbete..nn.1
  kontorsbiträde_1_N = mkN "kontorsbiträde" ; -- kontorsbiträde..nn.1
  kontorsbud_1_N = mkN "kontorsbud" neutrum  ; -- kontorsbud..nn.1
  kontorsbyggnad_1_N = mkN "kontorsbyggnad" "kontorsbyggnader" ; -- kontorsbyggnad..nn.1
  kontorschef_1_N = mkN "kontorschef" "kontorschefer" ; -- kontorschef..nn.1
  kontorsdörr_1_N = mkN "kontorsdörr" ; -- kontorsdörr..nn.1
  kontorsflicka_1_N = mkN "kontorsflicka" ; -- kontorsflicka..nn.1
  kontorshus_1_N = mkN "kontorshus" neutrum  ; -- kontorshus..nn.1
  kontorslandskap_1_N = mkN "kontorslandskap" neutrum  ; -- kontorslandskap..nn.1
  kontorsmässig_1_A = mkA "kontorsmässig" ; -- kontorsmässig..av.1
  kontorsplats_1_N = mkN "kontorsplats" "kontorsplatser" ; -- kontorsplats..nn.1
  kontorspulpet_1_N = mkN "kontorspulpet" "kontorspulpeter" ; -- kontorspulpet..nn.1
  kontorsrum_1_N = mkN "kontorsrum" "kontorsrummet" "kontorsrum" "kontorsrummen" ; -- kontorsrum..nn.1
  kontorsråtta_1_N = mkN "kontorsråtta" ; -- kontorsråtta..nn.1
  kontorsslav_1_N = mkN "kontorsslav" ; -- kontorsslav..nn.1
  kontorsstol_1_N = mkN "kontorsstol" ; -- kontorsstol..nn.1
  kontorstid_1_N = mkN "kontorstid" "kontorstider" ; -- kontorstid..nn.1
  kontorsutrymme_1_N = mkN "kontorsutrymme" ; -- kontorsutrymme..nn.1
  kontorsvana_1_N = mkN "kontorsvana" ; -- kontorsvana..nn.1
  kontoställning_1_N = mkN "kontoställning" ; -- kontoställning..nn.1
  kontostöld_1_N = mkN "kontostöld" "kontostölder" ; -- kontostöld..nn.1
  kontotömning_1_N = mkN "kontotömning" ; -- kontotömning..nn.1
  kontoutdrag_1_N = mkN "kontoutdrag" neutrum  ; -- kontoutdrag..nn.1
  kontra_1_V = mkV "kontrar" ; -- kontra..vb.1
  kontraalt_1_N = mkN "kontraalt" ; -- kontraalt..nn.1
  kontraband_1_N = mkN "kontraband" neutrum  ; -- kontraband..nn.1
  kontrabas_1_N = mkN "kontrabas" ; -- kontrabas..nn.1
  kontrabok_1_N = mkN "kontrabok" "kontraböcker" ; -- kontrabok..nn.1
  kontradans_1_N = mkN "kontradans" "kontradanser" ; -- kontradans..nn.1
  kontradiktion_1_N = mkN "kontradiktion" ; -- kontradiktion..nn.1
  kontradiktorisk_1_A = mkA "kontradiktorisk" ; -- kontradiktorisk..av.1
  kontrafagott_1_N = mkN "kontrafagott" "kontrafagotter" ; -- kontrafagott..nn.1
  kontrafaktisk_1_A = mkA "kontrafaktisk" ; -- kontrafaktisk..av.1
  kontrahent_1_N = mkN "kontrahent" "kontrahenter" ; -- kontrahent..nn.1
  kontrahera_1_V = mkV "kontraherar" ; -- kontrahera..vb.1
  kontraherande_1_N = mkN "kontraherande" ; -- kontraherande..nn.1
  kontraherbar_1_A = mkA "kontraherbar" ; -- kontraherbar..av.1
  kontraherbarhet_1_N = mkN "kontraherbarhet" ; -- kontraherbarhet..nn.1
  kontrahering_1_N = mkN "kontrahering" ; -- kontrahering..nn.1
  kontraindikation_1_N = mkN "kontraindikation" ; -- kontraindikation..nn.1
  kontrakt_1_N = mkN "kontrakt" neutrum  ; -- kontrakt..nn.1
  kontraktera_1_V = mkV "kontrakterar" ; -- kontraktera..vb.1
  kontrakterande_1_N = mkN "kontrakterande" ; -- kontrakterande..nn.1
  kontrakterbar_1_A = mkA "kontrakterbar" ; -- kontrakterbar..av.1
  kontrakterbarhet_1_N = mkN "kontrakterbarhet" ; -- kontrakterbarhet..nn.1
  kontraktering_1_N = mkN "kontraktering" ; -- kontraktering..nn.1
  kontraktil_1_A = mkA "kontraktil" ; -- kontraktil..av.1
  kontraktion_1_N = mkN "kontraktion" ; -- kontraktion..nn.1
  kontraktsanställd_1_A = mkA "kontraktsanställd" "kontraktsanställt" ; -- kontraktsanställd..av.1
  kontraktsarbetskraft_1_N = mkN "kontraktsarbetskraft" ; -- kontraktsarbetskraft..nn.1
  kontraktsbridge_1_N = mkN "kontraktsbridge" utrum  ; -- kontraktsbridge..nn.1
  kontraktsbrott_1_N = mkN "kontraktsbrott" neutrum  ; -- kontraktsbrott..nn.1
  kontraktsenlig_1_A = mkA "kontraktsenlig" ; -- kontraktsenlig..av.1
  kontraktsenlighet_1_N = mkN "kontraktsenlighet" ; -- kontraktsenlighet..nn.1
  kontraktsförhandling_1_N = mkN "kontraktsförhandling" ; -- kontraktsförhandling..nn.1
  kontraktslös_1_A = mkA "kontraktslös" ; -- kontraktslös..av.1
  kontraktsmässig_1_A = mkA "kontraktsmässig" ; -- kontraktsmässig..av.1
  kontraktsprost_1_N = mkN "kontraktsprost" ; -- kontraktsprost..nn.1
  kontraktstid_1_N = mkN "kontraktstid" "kontraktstider" ; -- kontraktstid..nn.1
  kontraktsvidrig_1_A = mkA "kontraktsvidrig" ; -- kontraktsvidrig..av.1
  kontraktsvidrighet_1_N = mkN "kontraktsvidrighet" ; -- kontraktsvidrighet..nn.1
  kontramandera_1_V = mkV "kontramanderar" ; -- kontramandera..vb.1
  kontramanderande_1_N = mkN "kontramanderande" ; -- kontramanderande..nn.1
  kontramanderbar_1_A = mkA "kontramanderbar" ; -- kontramanderbar..av.1
  kontramanderbarhet_1_N = mkN "kontramanderbarhet" ; -- kontramanderbarhet..nn.1
  kontramandering_1_N = mkN "kontramandering" ; -- kontramandering..nn.1
  kontramärke_1_N = mkN "kontramärke" ; -- kontramärke..nn.1
  kontrande_1_N = mkN "kontrande" ; -- kontrande..nn.1
  kontraoktav_1_N = mkN "kontraoktav" ; -- kontraoktav..nn.1
  kontraorder_1_N = mkN "kontraorder" ; -- kontraorder..nn.1
  kontraproduktiv_1_A = mkA "kontraproduktiv" ; -- kontraproduktiv..av.1
  kontraproposition_1_N = mkN "kontraproposition" ; -- kontraproposition..nn.1
  kontrapunkt_1_N = mkN "kontrapunkt" ; -- kontrapunkt..nn.1
  kontrapunktisk_1_A = mkA "kontrapunktisk" ; -- kontrapunktisk..av.1
  kontrarevolution_1_N = mkN "kontrarevolution" ; -- kontrarevolution..nn.1
  kontrarevolutionär_1_N = mkN "kontrarevolutionär" "kontrarevolutionärer" ; -- kontrarevolutionär..nn.1
  kontrasignera_1_V = mkV "kontrasignerar" ; -- kontrasignera..vb.1
  kontrasignerande_1_N = mkN "kontrasignerande" ; -- kontrasignerande..nn.1
  kontrasignerbar_1_A = mkA "kontrasignerbar" ; -- kontrasignerbar..av.1
  kontrasignerbarhet_1_N = mkN "kontrasignerbarhet" ; -- kontrasignerbarhet..nn.1
  kontrasignering_1_N = mkN "kontrasignering" ; -- kontrasignering..nn.1
  kontraspionage_1_N = mkN "kontraspionage" ; -- kontraspionage..nn.1
  kontrast_1_N = mkN "kontrast" "kontraster" ; -- kontrast..nn.1
  kontrastera_1_V = mkV "kontrasterar" ; -- kontrastera..vb.1
  kontrasterande_1_N = mkN "kontrasterande" ; -- kontrasterande..nn.1
  kontrasterbar_1_A = mkA "kontrasterbar" ; -- kontrasterbar..av.1
  kontrasterbarhet_1_N = mkN "kontrasterbarhet" ; -- kontrasterbarhet..nn.1
  kontrastering_1_N = mkN "kontrastering" ; -- kontrastering..nn.1
  kontrastmedel_1_N = mkN "kontrastmedel" neutrum  ; -- kontrastmedel..nn.1
  kontribuera_1_V = mkV "kontribuerar" ; -- kontribuera..vb.1
  kontribuerande_1_N = mkN "kontribuerande" ; -- kontribuerande..nn.1
  kontribuerbar_1_A = mkA "kontribuerbar" ; -- kontribuerbar..av.1
  kontribuerbarhet_1_N = mkN "kontribuerbarhet" ; -- kontribuerbarhet..nn.1
  kontribuering_1_N = mkN "kontribuering" ; -- kontribuering..nn.1
  kontribution_1_N = mkN "kontribution" ; -- kontribution..nn.1
  kontring_1_N = mkN "kontring" ; -- kontring..nn.1
  kontroll_1_N = mkN "kontroll" ; -- kontroll..nn.1
  kontroll_2_N = mkN "kontroll" "kontroller" ; -- kontroll..nn.2
  kontrollant_1_N = mkN "kontrollant" "kontrollanter" ; -- kontrollant..nn.1
  kontrollavgift_1_N = mkN "kontrollavgift" "kontrollavgifter" ; -- kontrollavgift..nn.1
  kontrollbehov_1_N = mkN "kontrollbehov" neutrum  ; -- kontrollbehov..nn.1
  kontrollbesiktning_1_N = mkN "kontrollbesiktning" ; -- kontrollbesiktning..nn.1
  kontrollbord_1_N = mkN "kontrollbord" neutrum  ; -- kontrollbord..nn.1
  kontrollera_1_V = mkV "kontrollerar" ; -- kontrollera..vb.1
  kontrollerande_1_N = mkN "kontrollerande" ; -- kontrollerande..nn.1
  kontrollerbar_1_A = mkA "kontrollerbar" ; -- kontrollerbar..av.1
  kontrollerbarhet_1_N = mkN "kontrollerbarhet" ; -- kontrollerbarhet..nn.1
  kontrollering_1_N = mkN "kontrollering" ; -- kontrollering..nn.1
  kontrollfreak_1_N = mkN "kontrollfreak" ; -- kontrollfreak..nn.1
  kontrollgenomsyrad_1_A = mkA "kontrollgenomsyrad" ; -- kontrollgenomsyrad..av.1
  kontrollgrupp_1_N = mkN "kontrollgrupp" "kontrollgrupper" ; -- kontrollgrupp..nn.1
  kontrollikon_1_N = mkN "kontrollikon" "kontrollikoner" ; -- kontrollikon..nn.1
  kontrollinstrument_1_N = mkN "kontrollinstrument" neutrum  ; -- kontrollinstrument..nn.1
  kontrollmekanism_1_N = mkN "kontrollmekanism" "kontrollmekanismer" ; -- kontrollmekanism..nn.1
  kontrollmärke_1_N = mkN "kontrollmärke" ; -- kontrollmärke..nn.1
  kontrollmäta_1_V = mkV "kontrollmäter" ; -- kontrollmäta..vb.1
  kontrollmätande_1_N = mkN "kontrollmätande" ; -- kontrollmätande..nn.1
  kontrollmätning_1_N = mkN "kontrollmätning" ; -- kontrollmätning..nn.1
  kontrollnummer_1_N = mkN "kontrollnummer" neutrum  ; -- kontrollnummer..nn.1
  kontrollorgan_1_N = mkN "kontrollorgan" neutrum  ; -- kontrollorgan..nn.1
  kontrollrum_1_N = mkN "kontrollrum" "kontrollrummet" "kontrollrum" "kontrollrummen" ; -- kontrollrum..nn.1
  kontrollrutin_1_N = mkN "kontrollrutin" "kontrollrutiner" ; -- kontrollrutin..nn.1
  kontrollsamhälle_1_N = mkN "kontrollsamhälle" ; -- kontrollsamhälle..nn.1
  kontrollstation_1_N = mkN "kontrollstation" ; -- kontrollstation..nn.1
  kontrollstämpel_1_N = mkN "kontrollstämpel" ; -- kontrollstämpel..nn.1
  kontrollstämpla_1_V = mkV "kontrollstämplar" ; -- kontrollstämpla..vb.1
  kontrollstämplande_1_N = mkN "kontrollstämplande" ; -- kontrollstämplande..nn.1
  kontrolltorn_1_N = mkN "kontrolltorn" neutrum  ; -- kontrolltorn..nn.1
  kontrollundersökning_1_N = mkN "kontrollundersökning" ; -- kontrollundersökning..nn.1
  kontrolluppgift_1_N = mkN "kontrolluppgift" "kontrolluppgifter" ; -- kontrolluppgift..nn.1
  kontrollväga_1_V = mkV "kontrollväger" ; -- kontrollväga..vb.1
  kontrollvägande_1_N = mkN "kontrollvägande" ; -- kontrollvägande..nn.1
  kontrollvägning_1_N = mkN "kontrollvägning" ; -- kontrollvägning..nn.1
  kontrolläsa_1_V = mkV "kontrolläser" ; -- kontrolläsa..vb.1
  kontrollör_1_N = mkN "kontrollör" "kontrollörer" ; -- kontrollör..nn.1
  kontrovers_1_N = mkN "kontrovers" "kontroverser" ; -- kontrovers..nn.1
  kontroversiell_1_A = mkA "kontroversiell" ; -- kontroversiell..av.1
  konträr_1_A = mkA "konträr" ; -- konträr..av.1
  kontumaciedom_1_N = mkN "kontumaciedom" ; -- kontumaciedom..nn.1
  kontur_1_N = mkN "kontur" "konturer" ; -- kontur..nn.1
  konturera_1_V = mkV "konturerar" ; -- konturera..vb.1
  konturerande_1_N = mkN "konturerande" ; -- konturerande..nn.1
  konturerbar_1_A = mkA "konturerbar" ; -- konturerbar..av.1
  konturerbarhet_1_N = mkN "konturerbarhet" ; -- konturerbarhet..nn.1
  konturering_1_N = mkN "konturering" ; -- konturering..nn.1
  konturlinje_1_N = mkN "konturlinje" "konturlinjer" ; -- konturlinje..nn.1
  konturlös_1_A = mkA "konturlös" ; -- konturlös..av.1
  konturlöshet_1_N = mkN "konturlöshet" ; -- konturlöshet..nn.1
  konturskarp_1_A = mkA "konturskarp" ; -- konturskarp..av.1
  konturskarphet_1_N = mkN "konturskarphet" ; -- konturskarphet..nn.1
  kontursåg_1_N = mkN "kontursåg" ; -- kontursåg..nn.1
  konturteckning_1_N = mkN "konturteckning" ; -- konturteckning..nn.1
  kontusion_1_N = mkN "kontusion" ; -- kontusion..nn.1
  konung_1_N = mkN "konung" ; -- konung..nn.1
  konungabok_1_N = mkN "konungabok" "konungaböcker" ; -- konungabok..nn.1
  konungadöme_1_N = mkN "konungadöme" ; -- konungadöme..nn.1
  konungaed_1_N = mkN "konungaed" "konungaeder" ; -- konungaed..nn.1
  konungahus_1_N = mkN "konungahus" neutrum  ; -- konungahus..nn.1
  konungakrona_1_N = mkN "konungakrona" ; -- konungakrona..nn.1
  konungalängd_1_N = mkN "konungalängd" "konungalängder" ; -- konungalängd..nn.1
  konungamakt_1_N = mkN "konungamakt" ; -- konungamakt..nn.1
  konungamord_1_N = mkN "konungamord" neutrum  ; -- konungamord..nn.1
  konungamördare_1_N = mkN "konungamördare" utrum  ; -- konungamördare..nn.1
  konungarike_1_N = mkN "konungarike" ; -- konungarike..nn.1
  konungasäte_1_N = mkN "konungasäte" ; -- konungasäte..nn.1
  konungatitel_1_N = mkN "konungatitel" ; -- konungatitel..nn.1
  konungatron_1_N = mkN "konungatron" "konungatroner" ; -- konungatron..nn.1
  konungaval_1_N = mkN "konungaval" neutrum  ; -- konungaval..nn.1
  konungaätt_1_N = mkN "konungaätt" "konungaätter" ; -- konungaätt..nn.1
  konungsk_1_A = mkA "konungsk" ; -- konungsk..av.1
  konungslig_1_A = mkA "konungslig" ; -- konungslig..av.1
  konungslighet_1_N = mkN "konungslighet" ; -- konungslighet..nn.1
  konvalescens_1_N = mkN "konvalescens" ; -- konvalescens..nn.1
  konvalescenstid_1_N = mkN "konvalescenstid" "konvalescenstider" ; -- konvalescenstid..nn.1
  konvalescent_1_A = mkA "konvalescent" "konvalescent" ; -- konvalescent..av.1
  konvalescent_1_N = mkN "konvalescent" "konvalescenter" ; -- konvalescent..nn.1
  konvalescenthem_1_N = mkN "konvalescenthem" "konvalescenthemmet" "konvalescenthem" "konvalescenthemmen" ; -- konvalescenthem..nn.1
  konvalescera_1_V = mkV "konvalescerar" ; -- konvalescera..vb.1
  konvalescerande_1_N = mkN "konvalescerande" ; -- konvalescerande..nn.1
  konvalj_1_N = mkN "konvalj" "konvaljer" ; -- konvalj..nn.1
  konvalje_1_N = mkN "konvalje" "konvaljer" ; -- konvalje..nn.1
  konvektion_1_N = mkN "konvektion" ; -- konvektion..nn.1
  konvektionszon_1_N = mkN "konvektionszon" "konvektionszoner" ; -- konvektionszon..nn.1
  konvenans_1_N = mkN "konvenans" ; -- konvenans..nn.1
  konvenansparti_1_N = mkN "konvenansparti" "konvenanspartiet" "konvenanspartier" "konvenanspartierna" ; -- konvenansparti..nn.1
  konvent_1_N = mkN "konvent" neutrum  ; -- konvent..nn.1
  konventikel_1_N = mkN "konventikel" ; -- konventikel..nn.1
  konvention_1_N = mkN "konvention" ; -- konvention..nn.1
  konventionalism_1_N = mkN "konventionalism" "konventionalismer" ; -- konventionalism..nn.1
  konventionell_1_A = mkA "konventionell" ; -- konventionell..av.1
  konventionsbrott_1_N = mkN "konventionsbrott" neutrum  ; -- konventionsbrott..nn.1
  konvergens_1_N = mkN "konvergens" ; -- konvergens..nn.1
  konvergenspunkt_1_N = mkN "konvergenspunkt" "konvergenspunkter" ; -- konvergenspunkt..nn.1
  konvergent_1_A = mkA "konvergent" "konvergent" ; -- konvergent..av.1
  konvergera_1_V = mkV "konvergerar" ; -- konvergera..vb.1
  konvergerande_1_N = mkN "konvergerande" ; -- konvergerande..nn.1
  konvergerbar_1_A = mkA "konvergerbar" ; -- konvergerbar..av.1
  konvergerbarhet_1_N = mkN "konvergerbarhet" ; -- konvergerbarhet..nn.1
  konvergering_1_N = mkN "konvergering" ; -- konvergering..nn.1
  konversabel_1_A = mkA "konversabel" ; -- konversabel..av.1
  konversation_1_N = mkN "konversation" ; -- konversation..nn.1
  konversationslexikon_1_N = mkN "konversationslexikon" neutrum  ; -- konversationslexikon..nn.1
  konversationsstycke_1_N = mkN "konversationsstycke" ; -- konversationsstycke..nn.1
  konversera_1_V = mkV "konverserar" ; -- konversera..vb.1
  konverserande_1_N = mkN "konverserande" ; -- konverserande..nn.1
  konverserbar_1_A = mkA "konverserbar" ; -- konverserbar..av.1
  konverserbarhet_1_N = mkN "konverserbarhet" ; -- konverserbarhet..nn.1
  konversering_1_N = mkN "konversering" ; -- konversering..nn.1
  konversion_1_N = mkN "konversion" ; -- konversion..nn.1
  konversionsförhållande_1_N = mkN "konversionsförhållande" ; -- konversionsförhållande..nn.1
  konversiv_1_A = mkA "konversiv" ; -- konversiv..av.1
  konverter_1_N = mkN "konverter" ; -- konverter..nn.1
  konvertera_1_V = mkV "konverterar" ; -- konvertera..vb.1
  konvertera_2_V = mkV "konverterar" ; -- konvertera..vb.2
  konverterande_1_N = mkN "konverterande" ; -- konverterande..nn.1
  konverterbar_1_A = mkA "konverterbar" ; -- konverterbar..av.1
  konverterbarhet_1_N = mkN "konverterbarhet" ; -- konverterbarhet..nn.1
  konvertering_1_N = mkN "konvertering" ; -- konvertering..nn.1
  konverteringskit_1_N = mkN "konverteringskit" neutrum  ; -- konverteringskit..nn.1
  konvertibel_1_A = mkA "konvertibel" ; -- konvertibel..av.1
  konvertit_1_N = mkN "konvertit" "konvertiter" ; -- konvertit..nn.1
  konvex_1_A = mkA "konvex" ; -- konvex..av.1
  konvexitet_1_N = mkN "konvexitet" "konvexiteter" ; -- konvexitet..nn.1
  konvexkonkav_1_A = mkA "konvexkonkav" ; -- konvexkonkav..av.1
  konviktorium_1_N = mkN "konviktorium" "konviktoriet" "konviktorier" "konviktorierna" ; -- konviktorium..nn.1
  konvoj_1_N = mkN "konvoj" "konvojer" ; -- konvoj..nn.1
  konvojattack_1_N = mkN "konvojattack" "konvojattacker" ; -- konvojattack..nn.1
  konvojera_1_V = mkV "konvojerar" ; -- konvojera..vb.1
  konvojerande_1_N = mkN "konvojerande" ; -- konvojerande..nn.1
  konvojerbar_1_A = mkA "konvojerbar" ; -- konvojerbar..av.1
  konvojerbarhet_1_N = mkN "konvojerbarhet" ; -- konvojerbarhet..nn.1
  konvojering_1_N = mkN "konvojering" ; -- konvojering..nn.1
  konvolut_1_N = mkN "konvolut" neutrum  ; -- konvolut..nn.1
  konvulsion_1_N = mkN "konvulsion" ; -- konvulsion..nn.1
  konvulsivisk_1_A = mkA "konvulsivisk" ; -- konvulsivisk..av.1
  kooperation_1_N = mkN "kooperation" ; -- kooperation..nn.1
  kooperativ_1_A = mkA "kooperativ" ; -- kooperativ..av.1
  kooperativ_1_N = mkN "kooperativ" neutrum  ; -- kooperativ..nn.1
  kooperatör_1_N = mkN "kooperatör" "kooperatörer" ; -- kooperatör..nn.1
  kooperera_1_V = mkV "koopererar" ; -- kooperera..vb.1
  koopererande_1_N = mkN "koopererande" ; -- koopererande..nn.1
  kooperering_1_N = mkN "kooperering" ; -- kooperering..nn.1
  koordinat_1_N = mkN "koordinat" "koordinater" ; -- koordinat..nn.1
  koordinataxel_1_N = mkN "koordinataxel" ; -- koordinataxel..nn.1
  koordination_1_N = mkN "koordination" ; -- koordination..nn.1
  koordinator_1_N = mkN "koordinator" "koordinatorer" ; -- koordinator..nn.1
  koordinatsystem_1_N = mkN "koordinatsystem" neutrum  ; -- koordinatsystem..nn.1
  koordinera_1_V = mkV "koordinerar" ; -- koordinera..vb.1
  koordinerande_1_N = mkN "koordinerande" ; -- koordinerande..nn.1
  koordinerbar_1_A = mkA "koordinerbar" ; -- koordinerbar..av.1
  koordinerbarhet_1_N = mkN "koordinerbarhet" ; -- koordinerbarhet..nn.1
  koordinering_1_N = mkN "koordinering" ; -- koordinering..nn.1
  kopek_1_N = mkN "kopek" "kopeken" "kopek" "kopeken" ; -- kopek..nn.1
  kopernikansk_1_A = mkA "kopernikansk" ; -- kopernikansk..av.1
  kopia_1_N = mkN "kopia" ; -- kopia..nn.1
  kopiator_1_N = mkN "kopiator" "kopiatorer" ; -- kopiator..nn.1
  kopiepapper_1_N = mkN "kopiepapper" neutrum  ; -- kopiepapper..nn.1
  kopiera_1_V = mkV "kopierar" ; -- kopiera..vb.1
  kopierande_1_N = mkN "kopierande" ; -- kopierande..nn.1
  kopierbar_1_A = mkA "kopierbar" ; -- kopierbar..av.1
  kopierbarhet_1_N = mkN "kopierbarhet" ; -- kopierbarhet..nn.1
  kopiering_1_N = mkN "kopiering" ; -- kopiering..nn.1
  kopieringsapparat_1_N = mkN "kopieringsapparat" "kopieringsapparater" ; -- kopieringsapparat..nn.1
  kopieringsmaskin_1_N = mkN "kopieringsmaskin" "kopieringsmaskiner" ; -- kopieringsmaskin..nn.1
  kopiesvarv_1_N = mkN "kopiesvarv" ; -- kopiesvarv..nn.1
  kopist_1_N = mkN "kopist" "kopister" ; -- kopist..nn.1
  kopiös_1_A = mkA "kopiös" ; -- kopiös..av.1
  kopp_1_N = mkN "kopp" ; -- kopp..nn.1
  koppa_1_N = mkN "koppa" ; -- koppa..nn.1
  koppa_1_V = mkV "koppar" ; -- koppa..vb.1
  koppande_1_N = mkN "koppande" ; -- koppande..nn.1
  koppar_1_N = mkN "koppar" ; -- koppar..nn.1
  kopparbrun_1_A = mkA "kopparbrun" ; -- kopparbrun..av.1
  kopparbröllop_1_N = mkN "kopparbröllop" neutrum  ; -- kopparbröllop..nn.1
  kopparfyndighet_1_N = mkN "kopparfyndighet" "kopparfyndigheter" ; -- kopparfyndighet..nn.1
  kopparfärgad_1_A = mkA "kopparfärgad" ; -- kopparfärgad..av.1
  kopparglans_1_N = mkN "kopparglans" ; -- kopparglans..nn.1
  koppargruva_1_N = mkN "koppargruva" ; -- koppargruva..nn.1
  kopparhaltig_1_A = mkA "kopparhaltig" ; -- kopparhaltig..av.1
  kopparkis_1_N = mkN "kopparkis" ; -- kopparkis..nn.1
  kopparledning_1_N = mkN "kopparledning" ; -- kopparledning..nn.1
  kopparmalm_1_N = mkN "kopparmalm" "kopparmalmer" ; -- kopparmalm..nn.1
  kopparmynt_1_N = mkN "kopparmynt" neutrum  ; -- kopparmynt..nn.1
  kopparorm_1_N = mkN "kopparorm" ; -- kopparorm..nn.1
  kopparplåt_1_N = mkN "kopparplåt" ; -- kopparplåt..nn.1
  kopparröd_1_A = mkA "kopparröd" "kopparrött" ; -- kopparröd..av.1
  kopparslagare_1_N = mkN "kopparslagare" utrum  ; -- kopparslagare..nn.1
  kopparspiral_1_N = mkN "kopparspiral" "kopparspiraler" ; -- kopparspiral..nn.1
  kopparstick_1_N = mkN "kopparstick" neutrum  ; -- kopparstick..nn.1
  kopparsulfat_1_N = mkN "kopparsulfat" "kopparsulfater" ; -- kopparsulfat..nn.1
  koppartak_1_N = mkN "koppartak" neutrum  ; -- koppartak..nn.1
  koppartryck_1_N = mkN "koppartryck" neutrum  ; -- koppartryck..nn.1
  kopparärg_1_N = mkN "kopparärg" ; -- kopparärg..nn.1
  kopparålder_1_N = mkN "kopparålder" ; -- kopparålder..nn.1
  kopparödla_1_N = mkN "kopparödla" ; -- kopparödla..nn.1
  koppel_1_N = mkN "koppel" neutrum  ; -- koppel..nn.1
  koppelvan_1_A = mkA "koppelvan" ; -- koppelvan..av.1
  koppla_1_V = mkV "kopplar" ; -- koppla..vb.1
  kopplande_1_N = mkN "kopplande" ; -- kopplande..nn.1
  kopplare_1_N = mkN "kopplare" utrum  ; -- kopplare..nn.1
  koppleri_1_N = mkN "koppleri" "koppleriet" "kopplerier" "kopplerierna" ; -- koppleri..nn.1
  kopplerianklagad_1_A = mkA "kopplerianklagad" ; -- kopplerianklagad..av.1
  kopplerimisstanke_1_N = mkN "kopplerimisstanke" utrum  ; -- kopplerimisstanke..nn.1
  kopplerimisstänkt_1_A = mkA "kopplerimisstänkt" "kopplerimisstänkt" ; -- kopplerimisstänkt..av.1
  kopplerimål_1_N = mkN "kopplerimål" neutrum  ; -- kopplerimål..nn.1
  koppleriåtalad_1_A = mkA "koppleriåtalad" ; -- koppleriåtalad..av.1
  koppling_1_N = mkN "koppling" ; -- koppling..nn.1
  kopplingspedal_1_N = mkN "kopplingspedal" "kopplingspedaler" ; -- kopplingspedal..nn.1
  kopplingsschema_1_N = mkN "kopplingsschema" "kopplingsschemat" "kopplingsscheman" "kopplingsschemana" ; -- kopplingsschema..nn.1
  kopplingsstycke_1_N = mkN "kopplingsstycke" ; -- kopplingsstycke..nn.1
  kopplingston_1_N = mkN "kopplingston" "kopplingstoner" ; -- kopplingston..nn.1
  koppympning_1_N = mkN "koppympning" ; -- koppympning..nn.1
  koppärr_1_N = mkN "koppärr" neutrum  ; -- koppärr..nn.1
  koppärrig_1_A = mkA "koppärrig" ; -- koppärrig..av.1
  koppärrighet_1_N = mkN "koppärrighet" ; -- koppärrighet..nn.1
  kopra_1_N = mkN "kopra" ; -- kopra..nn.1
  kopt_1_N = mkN "kopt" "kopter" ; -- kopt..nn.1
  kopter_1_N = mkN "kopter" "koptern" "kopter" "kopterna" ; -- kopter..nn.1
  koptisk_1_A = mkA "koptisk" ; -- koptisk..av.1
  koptiska_1_N = mkN "koptiska" ; -- koptiska..nn.1
  kopula_1_N = mkN "kopula" ; -- kopula..nn.1
  kopulation_1_N = mkN "kopulation" ; -- kopulation..nn.1
  kopulativ_1_A = mkA "kopulativ" ; -- kopulativ..av.1
  kopulera_1_V = mkV "kopulerar" ; -- kopulera..vb.1
  kopulerande_1_N = mkN "kopulerande" ; -- kopulerande..nn.1
  kopulering_1_N = mkN "kopulering" ; -- kopulering..nn.1
  kor_1_N = mkN "kor" neutrum  ; -- kor..nn.1
  kora_1_V = mkV "korar" ; -- kora..vb.1
  koral_1_N = mkN "koral" "koraler" ; -- koral..nn.1
  koralbok_1_N = mkN "koralbok" "koralböcker" ; -- koralbok..nn.1
  korall_1_N = mkN "korall" "koraller" ; -- korall..nn.1
  koralldjur_1_N = mkN "koralldjur" neutrum  ; -- koralldjur..nn.1
  korallhalsband_1_N = mkN "korallhalsband" neutrum  ; -- korallhalsband..nn.1
  koralliknande_1_A = mkA "koralliknande" ; -- koralliknande..av.1
  korallinspirerad_1_A = mkA "korallinspirerad" ; -- korallinspirerad..av.1
  korallorm_1_N = mkN "korallorm" ; -- korallorm..nn.1
  korallrev_1_N = mkN "korallrev" neutrum  ; -- korallrev..nn.1
  korallröd_1_A = mkA "korallröd" "korallrött" ; -- korallröd..av.1
  korallö_1_N = mkN "korallö" ; -- korallö..nn.1
  koran_1_N = mkN "koran" ; -- koran..nn.1
  korande_1_N = mkN "korande" ; -- korande..nn.1
  koravslutning_1_N = mkN "koravslutning" ; -- koravslutning..nn.1
  kord_1_N = mkN "kord" ; -- kord..nn.1
  korda_1_N = mkN "korda" ; -- korda..nn.1
  korderoj_1_N = mkN "korderoj" ; -- korderoj..nn.1
  kordial_1_A = mkA "kordial" ; -- kordial..av.1
  kordialitet_1_N = mkN "kordialitet" "kordialiteter" ; -- kordialitet..nn.1
  kordong_1_N = mkN "kordong" "kordonger" ; -- kordong..nn.1
  kordongskruv_1_N = mkN "kordongskruv" ; -- kordongskruv..nn.1
  kordräkt_1_N = mkN "kordräkt" "kordräkter" ; -- kordräkt..nn.1
  korean_1_N = mkN "korean" "koreaner" ; -- korean..nn.1
  koreansk_1_A = mkA "koreansk" ; -- koreansk..av.1
  koreanska_1_N = mkN "koreanska" ; -- koreanska..nn.1
  koreanska_2_N = mkN "koreanska" ; -- koreanska..nn.2
  koreograf_1_N = mkN "koreograf" "koreografer" ; -- koreograf..nn.1
  koreografera_1_V = mkV "koreograferar" ; -- koreografera..vb.1
  koreograferande_1_N = mkN "koreograferande" ; -- koreograferande..nn.1
  koreograferbar_1_A = mkA "koreograferbar" ; -- koreograferbar..av.1
  koreograferbarhet_1_N = mkN "koreograferbarhet" ; -- koreograferbarhet..nn.1
  koreografering_1_N = mkN "koreografering" ; -- koreografering..nn.1
  koreografi_1_N = mkN "koreografi" ; -- koreografi..nn.1
  koreografisk_1_A = mkA "koreografisk" ; -- koreografisk..av.1
  korfönster_1_N = mkN "korfönster" neutrum  ; -- korfönster..nn.1
  korg_1_N = mkN "korg" ; -- korg..nn.1
  korgblommig_1_A = mkA "korgblommig" ; -- korgblommig..av.1
  korgboll_1_N = mkN "korgboll" ; -- korgboll..nn.1
  korgboll_2_N = mkN "korgboll" ; -- korgboll..nn.2
  korgmakare_1_N = mkN "korgmakare" utrum  ; -- korgmakare..nn.1
  korgmålare_1_N = mkN "korgmålare" utrum  ; -- korgmålare..nn.1
  korgmåleri_1_N = mkN "korgmåleri" neutrum  ; -- korgmåleri..nn.1
  korgosse_1_N = mkN "korgosse" utrum  ; -- korgosse..nn.1
  korgstol_1_N = mkN "korgstol" ; -- korgstol..nn.1
  korgvis_1_Adv = mkAdv "korgvis" ; -- korgvis..ab.1
  koriander_1_N = mkN "koriander" ; -- koriander..nn.1
  korint_1_N = mkN "korint" "korinter" ; -- korint..nn.1
  korinter_1_N = mkN "korinter" "korintern" "korinter" "korinterna" ; -- korinter..nn.1
  korintisk_1_A = mkA "korintisk" ; -- korintisk..av.1
  korist_1_N = mkN "korist" "korister" ; -- korist..nn.1
  kork_1_N = mkN "kork" ; -- kork..nn.1
  korka_1_V = mkV "korkar" ; -- korka..vb.1
  korkad_1_A = mkA "korkad" ; -- korkad..av.1
  korkande_1_N = mkN "korkande" ; -- korkande..nn.1
  korkapparat_1_N = mkN "korkapparat" "korkapparater" ; -- korkapparat..nn.1
  korkbössa_1_N = mkN "korkbössa" ; -- korkbössa..nn.1
  korkcell_1_N = mkN "korkcell" "korkceller" ; -- korkcell..nn.1
  korkek_1_N = mkN "korkek" ; -- korkek..nn.1
  korkgolv_1_N = mkN "korkgolv" neutrum  ; -- korkgolv..nn.1
  korklager_1_N = mkN "korklager" neutrum  ; -- korklager..nn.1
  korkmaskin_1_N = mkN "korkmaskin" "korkmaskiner" ; -- korkmaskin..nn.1
  korkmassa_1_N = mkN "korkmassa" ; -- korkmassa..nn.1
  korkmatta_1_N = mkN "korkmatta" ; -- korkmatta..nn.1
  korkning_1_N = mkN "korkning" ; -- korkning..nn.1
  korkpistol_1_N = mkN "korkpistol" "korkpistoler" ; -- korkpistol..nn.1
  korkskruv_1_N = mkN "korkskruv" ; -- korkskruv..nn.1
  korkskruvslock_1_N = mkN "korkskruvslock" ; -- korkskruvslock..nn.1
  korkskörd_1_N = mkN "korkskörd" ; -- korkskörd..nn.1
  korksmak_1_N = mkN "korksmak" "korksmaker" ; -- korksmak..nn.1
  korksmakande_1_A = mkA "korksmakande" ; -- korksmakande..av.1
  korksula_1_N = mkN "korksula" ; -- korksula..nn.1
  korkvävnad_1_N = mkN "korkvävnad" "korkvävnader" ; -- korkvävnad..nn.1
  kormoran_1_N = mkN "kormoran" "kormoraner" ; -- kormoran..nn.1
  kormästare_1_N = mkN "kormästare" utrum  ; -- kormästare..nn.1
  korn_1_N = mkN "korn" neutrum  ; -- korn..nn.1
  kornblixt_1_N = mkN "kornblixt" ; -- kornblixt..nn.1
  kornblå_1_A = mkA "kornblå" "kornblått" ; -- kornblå..av.1
  kornbod_1_N = mkN "kornbod" ; -- kornbod..nn.1
  kornbröd_1_N = mkN "kornbröd" neutrum  ; -- kornbröd..nn.1
  korndräll_1_N = mkN "korndräll" ; -- korndräll..nn.1
  kornett_1_N = mkN "kornett" "kornetter" ; -- kornett..nn.1
  kornettist_1_N = mkN "kornettist" "kornettister" ; -- kornettist..nn.1
  korngryn_1_N = mkN "korngryn" neutrum  ; -- korngryn..nn.1
  korngrynsvälling_1_N = mkN "korngrynsvälling" ; -- korngrynsvälling..nn.1
  korngul_1_A = mkA "korngul" ; -- korngul..av.1
  kornig_1_A = mkA "kornig" ; -- kornig..av.1
  kornighet_1_N = mkN "kornighet" ; -- kornighet..nn.1
  kornisch_1_N = mkN "kornisch" "kornischer" ; -- kornisch..nn.1
  korniska_1_N = mkN "korniska" ; -- korniska..nn.1
  kornknarr_1_N = mkN "kornknarr" ; -- kornknarr..nn.1
  kornsnö_1_N = mkN "kornsnö" ; -- kornsnö..nn.1
  kornåker_1_N = mkN "kornåker" ; -- kornåker..nn.1
  korollarium_1_N = mkN "korollarium" "korollariet" "korollarier" "korollarierna" ; -- korollarium..nn.1
  korona_1_N = mkN "korona" ; -- korona..nn.1
  koronarskleros_1_N = mkN "koronarskleros" ; -- koronarskleros..nn.1
  korp_1_N = mkN "korp" ; -- korp..nn.1
  korpa_1_V = mkV "korpar" ; -- korpa..vb.1
  korpande_1_N = mkN "korpande" ; -- korpande..nn.1
  korpande_2_N = mkN "korpande" ; -- korpande..nn.2
  korpglugg_1_N = mkN "korpglugg" ; -- korpglugg..nn.1
  korplåt_1_N = mkN "korplåt" ; -- korplåt..nn.1
  korpning_1_N = mkN "korpning" ; -- korpning..nn.1
  korpning_2_N = mkN "korpning" ; -- korpning..nn.2
  korponaut_1_N = mkN "korponaut" "korponauter" ; -- korponaut..nn.1
  korporation_1_N = mkN "korporation" ; -- korporation..nn.1
  korporationsidrott_1_N = mkN "korporationsidrott" ; -- korporationsidrott..nn.1
  korporatism_1_N = mkN "korporatism" "korporatismer" ; -- korporatism..nn.1
  korporatistisk_1_A = mkA "korporatistisk" ; -- korporatistisk..av.1
  korporativ_1_A = mkA "korporativ" ; -- korporativ..av.1
  korporativism_1_N = mkN "korporativism" "korporativismer" ; -- korporativism..nn.1
  korporativistisk_1_A = mkA "korporativistisk" ; -- korporativistisk..av.1
  korpral_1_N = mkN "korpral" "korpraler" ; -- korpral..nn.1
  korpsvart_1_A = mkA "korpsvart" "korpsvart" ; -- korpsvart..av.1
  korpulens_1_N = mkN "korpulens" ; -- korpulens..nn.1
  korpulent_1_A = mkA "korpulent" "korpulent" ; -- korpulent..av.1
  korpus_1_N = mkN "korpus" ; -- korpus..nn.1
  korpuskel_1_N = mkN "korpuskel" "korpuskeln" "korpuskler" "korpusklerna" ; -- korpuskel..nn.1
  korpuslingvistik_1_N = mkN "korpuslingvistik" ; -- korpuslingvistik..nn.1
  korpussökning_1_N = mkN "korpussökning" ; -- korpussökning..nn.1
  korpvinge_1_N = mkN "korpvinge" utrum  ; -- korpvinge..nn.1
  korr_1_N = mkN "korr" neutrum  ; -- korr..nn.1
  korrasion_1_N = mkN "korrasion" ; -- korrasion..nn.1
  korre_1_N = mkN "korre" utrum  ; -- korre..nn.1
  korrekt_1_A = mkA "korrekt" "korrekt" ; -- korrekt..av.1
  korrekthet_1_N = mkN "korrekthet" ; -- korrekthet..nn.1
  korrektion_1_N = mkN "korrektion" ; -- korrektion..nn.1
  korrektionsanstalt_1_N = mkN "korrektionsanstalt" "korrektionsanstalter" ; -- korrektionsanstalt..nn.1
  korrektiv_1_N = mkN "korrektiv" neutrum  ; -- korrektiv..nn.1
  korrektur_1_N = mkN "korrektur" neutrum  ; -- korrektur..nn.1
  korrekturfel_1_N = mkN "korrekturfel" "korrekturfelet" "korrekturfel" "korrekturfelen" ; -- korrekturfel..nn.1
  korrekturläsa_1_V = mkV "korrekturläser" ; -- korrekturläsa..vb.1
  korrekturläsande_1_N = mkN "korrekturläsande" ; -- korrekturläsande..nn.1
  korrekturläsning_1_N = mkN "korrekturläsning" ; -- korrekturläsning..nn.1
  korrekturtecken_1_N = mkN "korrekturtecken" "korrekturtecknet" "korrekturtecken" "korrekturtecknen" ; -- korrekturtecken..nn.1
  korrelat_1_N = mkN "korrelat" neutrum  ; -- korrelat..nn.1
  korrelation_1_N = mkN "korrelation" ; -- korrelation..nn.1
  korrelativ_1_A = mkA "korrelativ" ; -- korrelativ..av.1
  korrelatord_1_N = mkN "korrelatord" neutrum  ; -- korrelatord..nn.1
  korrelera_1_V = mkV "korrelerar" ; -- korrelera..vb.1
  korrelerande_1_N = mkN "korrelerande" ; -- korrelerande..nn.1
  korrelerbar_1_A = mkA "korrelerbar" ; -- korrelerbar..av.1
  korrelerbarhet_1_N = mkN "korrelerbarhet" ; -- korrelerbarhet..nn.1
  korrelering_1_N = mkN "korrelering" ; -- korrelering..nn.1
  korrespondens_1_N = mkN "korrespondens" "korrespondenser" ; -- korrespondens..nn.1
  korrespondenskort_1_N = mkN "korrespondenskort" neutrum  ; -- korrespondenskort..nn.1
  korrespondenskurs_1_N = mkN "korrespondenskurs" "korrespondenskurser" ; -- korrespondenskurs..nn.1
  korrespondensundervisning_1_N = mkN "korrespondensundervisning" ; -- korrespondensundervisning..nn.1
  korrespondent_1_N = mkN "korrespondent" "korrespondenter" ; -- korrespondent..nn.1
  korrespondera_1_V = mkV "korresponderar" ; -- korrespondera..vb.1
  korresponderande_1_N = mkN "korresponderande" ; -- korresponderande..nn.1
  korrespondering_1_N = mkN "korrespondering" ; -- korrespondering..nn.1
  korridor_1_N = mkN "korridor" "korridoren" "korridorer" "korridorerna" ; -- korridor..nn.1
  korridorpolitik_1_N = mkN "korridorpolitik" ; -- korridorpolitik..nn.1
  korridorsnack_1_N = mkN "korridorsnack" neutrum  ; -- korridorsnack..nn.1
  korridorsystem_1_N = mkN "korridorsystem" neutrum  ; -- korridorsystem..nn.1
  korrigera_1_V = mkV "korrigerar" ; -- korrigera..vb.1
  korrigerande_1_N = mkN "korrigerande" ; -- korrigerande..nn.1
  korrigerbar_1_A = mkA "korrigerbar" ; -- korrigerbar..av.1
  korrigerbarhet_1_N = mkN "korrigerbarhet" ; -- korrigerbarhet..nn.1
  korrigering_1_N = mkN "korrigering" ; -- korrigering..nn.1
  korrodera_1_V = mkV "korroderar" ; -- korrodera..vb.1
  korroderande_1_N = mkN "korroderande" ; -- korroderande..nn.1
  korroderbar_1_A = mkA "korroderbar" ; -- korroderbar..av.1
  korroderbarhet_1_N = mkN "korroderbarhet" ; -- korroderbarhet..nn.1
  korrodering_1_N = mkN "korrodering" ; -- korrodering..nn.1
  korrosion_1_N = mkN "korrosion" ; -- korrosion..nn.1
  korrosionsinhibitor_1_N = mkN "korrosionsinhibitor" "korrosionsinhibitorer" ; -- korrosionsinhibitor..nn.1
  korrosionsskydd_1_N = mkN "korrosionsskydd" neutrum  ; -- korrosionsskydd..nn.1
  korrosionsskyddande_1_A = mkA "korrosionsskyddande" ; -- korrosionsskyddande..av.1
  korrugera_1_V = mkV "korrugerar" ; -- korrugera..vb.1
  korrugerande_1_N = mkN "korrugerande" ; -- korrugerande..nn.1
  korrugerbar_1_A = mkA "korrugerbar" ; -- korrugerbar..av.1
  korrugerbarhet_1_N = mkN "korrugerbarhet" ; -- korrugerbarhet..nn.1
  korrugering_1_N = mkN "korrugering" ; -- korrugering..nn.1
  korrumpera_1_V = mkV "korrumperar" ; -- korrumpera..vb.1
  korrumperande_1_N = mkN "korrumperande" ; -- korrumperande..nn.1
  korrumperbar_1_A = mkA "korrumperbar" ; -- korrumperbar..av.1
  korrumperbarhet_1_N = mkN "korrumperbarhet" ; -- korrumperbarhet..nn.1
  korrumpering_1_N = mkN "korrumpering" ; -- korrumpering..nn.1
  korrupt_1_A = mkA "korrupt" "korrupt" ; -- korrupt..av.1
  korrupthet_1_N = mkN "korrupthet" ; -- korrupthet..nn.1
  korruption_1_N = mkN "korruption" ; -- korruption..nn.1
  korruptionsanklagad_1_A = mkA "korruptionsanklagad" ; -- korruptionsanklagad..av.1
  korruptionsbekämpning_1_N = mkN "korruptionsbekämpning" ; -- korruptionsbekämpning..nn.1
  korruptionsbrott_1_N = mkN "korruptionsbrott" neutrum  ; -- korruptionsbrott..nn.1
  korruptionsforskare_1_N = mkN "korruptionsforskare" utrum  ; -- korruptionsforskare..nn.1
  korruptionshärva_1_N = mkN "korruptionshärva" ; -- korruptionshärva..nn.1
  korruptionskamp_1_N = mkN "korruptionskamp" ; -- korruptionskamp..nn.1
  korruptionsmisstanke_1_N = mkN "korruptionsmisstanke" utrum  ; -- korruptionsmisstanke..nn.1
  korruptionsnivå_1_N = mkN "korruptionsnivå" "korruptionsnivåer" ; -- korruptionsnivå..nn.1
  korruptionsrättegång_1_N = mkN "korruptionsrättegång" ; -- korruptionsrättegång..nn.1
  korruptionsskandal_1_N = mkN "korruptionsskandal" "korruptionsskandaler" ; -- korruptionsskandal..nn.1
  korruptionsåtal_1_N = mkN "korruptionsåtal" neutrum  ; -- korruptionsåtal..nn.1
  kors_1_N = mkN "kors" neutrum  ; -- kors..nn.1
  korsa_1_V = mkV "korsar" ; -- korsa..vb.1
  korsande_1_N = mkN "korsande" ; -- korsande..nn.1
  korsar_1_N = mkN "korsar" "korsarer" ; -- korsar..nn.1
  korsband_1_N = mkN "korsband" neutrum  ; -- korsband..nn.1
  korsbefrukta_1_V = mkV "korsbefruktar" ; -- korsbefrukta..vb.1
  korsbefruktande_1_N = mkN "korsbefruktande" ; -- korsbefruktande..nn.1
  korsbefruktning_1_N = mkN "korsbefruktning" ; -- korsbefruktning..nn.1
  korsben_1_N = mkN "korsben" neutrum  ; -- korsben..nn.1
  korsbensfläta_1_N = mkN "korsbensfläta" ; -- korsbensfläta..nn.1
  korsblommig_1_A = mkA "korsblommig" ; -- korsblommig..av.1
  korsdrag_1_N = mkN "korsdrag" neutrum  ; -- korsdrag..nn.1
  korseld_1_N = mkN "korseld" ; -- korseld..nn.1
  korselett_1_N = mkN "korselett" "korseletter" ; -- korselett..nn.1
  korsett_1_N = mkN "korsett" "korsetter" ; -- korsett..nn.1
  korsettera_1_V = mkV "korsetterar" ; -- korsettera..vb.1
  korsetterande_1_N = mkN "korsetterande" ; -- korsetterande..nn.1
  korsetterbar_1_A = mkA "korsetterbar" ; -- korsetterbar..av.1
  korsetterbarhet_1_N = mkN "korsetterbarhet" ; -- korsetterbarhet..nn.1
  korsettering_1_N = mkN "korsettering" ; -- korsettering..nn.1
  korsettfjäder_1_N = mkN "korsettfjäder" ; -- korsettfjäder..nn.1
  korsfarararmé_1_N = mkN "korsfarararmé" "korsfarararméer" ; -- korsfarararmé..nn.1
  korsfarare_1_N = mkN "korsfarare" utrum  ; -- korsfarare..nn.1
  korsfararstat_1_N = mkN "korsfararstat" "korsfararstater" ; -- korsfararstat..nn.1
  korsform_1_N = mkN "korsform" ; -- korsform..nn.1
  korsformad_1_A = mkA "korsformad" ; -- korsformad..av.1
  korsfästa_1_V = mkV "korsfästa" "korsfäster" "korsfäst" "korsfäste" "korsfäst" "korsfäst" ; -- korsfästa..vb.1
  korsfästande_1_N = mkN "korsfästande" ; -- korsfästande..nn.1
  korsfästelse_1_N = mkN "korsfästelse" "korsfästelser" ; -- korsfästelse..nn.1
  korsförhör_1_N = mkN "korsförhör" neutrum  ; -- korsförhör..nn.1
  korsförhöra_1_V = mkV "korsförhöra" "korsförhörde" "korsförhört" ; -- korsförhöra..vb.1
  korsförhörande_1_N = mkN "korsförhörande" ; -- korsförhörande..nn.1
  korsgång_1_N = mkN "korsgång" ; -- korsgång..nn.1
  korshänvisning_1_N = mkN "korshänvisning" ; -- korshänvisning..nn.1
  korsikan_1_N = mkN "korsikan" "korsikaner" ; -- korsikan..nn.1
  korsikanare_1_N = mkN "korsikanare" utrum  ; -- korsikanare..nn.1
  korsikansk_1_A = mkA "korsikansk" ; -- korsikansk..av.1
  korsikanska_1_N = mkN "korsikanska" ; -- korsikanska..nn.1
  korsikanska_2_N = mkN "korsikanska" ; -- korsikanska..nn.2
  korskota_1_N = mkN "korskota" ; -- korskota..nn.1
  korskrank_1_N = mkN "korskrank" neutrum  ; -- korskrank..nn.1
  korskyrka_1_N = mkN "korskyrka" ; -- korskyrka..nn.1
  korslägga_1_V = mkV "korslägga" "korsla" "korslagt" ; -- korslägga..vb.1
  korsning_1_N = mkN "korsning" ; -- korsning..nn.1
  korsnäbb_1_N = mkN "korsnäbb" ; -- korsnäbb..nn.1
  korso_1_N = mkN "korso" "korson" "korsoer" "korsoerna" ; -- korso..nn.1
  korsord_1_N = mkN "korsord" neutrum  ; -- korsord..nn.1
  korsordskonstruktör_1_N = mkN "korsordskonstruktör" "korsordskonstruktörer" ; -- korsordskonstruktör..nn.1
  korsordsmässig_1_A = mkA "korsordsmässig" ; -- korsordsmässig..av.1
  korsordstidning_1_N = mkN "korsordstidning" ; -- korsordstidning..nn.1
  korspollination_1_N = mkN "korspollination" ; -- korspollination..nn.1
  korsreferens_1_N = mkN "korsreferens" "korsreferenser" ; -- korsreferens..nn.1
  korsriddare_1_N = mkN "korsriddare" utrum  ; -- korsriddare..nn.1
  korsrygg_1_N = mkN "korsrygg" ; -- korsrygg..nn.1
  korsspindel_1_N = mkN "korsspindel" ; -- korsspindel..nn.1
  korsstygn_1_N = mkN "korsstygn" neutrum  ; -- korsstygn..nn.1
  korstecken_1_N = mkN "korstecken" "korstecknet" "korstecken" "korstecknen" ; -- korstecken..nn.1
  korstol_1_N = mkN "korstol" ; -- korstol..nn.1
  korståg_1_N = mkN "korståg" neutrum  ; -- korståg..nn.1
  korstågskrönikör_1_N = mkN "korstågskrönikör" "korstågskrönikörer" ; -- korstågskrönikör..nn.1
  korsvalv_1_N = mkN "korsvalv" neutrum  ; -- korsvalv..nn.1
  korsvimpel_1_N = mkN "korsvimpel" ; -- korsvimpel..nn.1
  korsvirkeshus_1_N = mkN "korsvirkeshus" neutrum  ; -- korsvirkeshus..nn.1
  korsvis_1_Adv = mkAdv "korsvis" ; -- korsvis..ab.1
  korsvis_1_A = mkA "korsvis" ; -- korsvis..av.1
  korsvisare_1_N = mkN "korsvisare" utrum  ; -- korsvisare..nn.1
  korsvädra_1_V = mkV "korsvädrar" ; -- korsvädra..vb.1
  korsvädrande_1_N = mkN "korsvädrande" ; -- korsvädrande..nn.1
  korsvädring_1_N = mkN "korsvädring" ; -- korsvädring..nn.1
  korsväg_1_N = mkN "korsväg" ; -- korsväg..nn.1
  korsägande_1_N = mkN "korsägande" ; -- korsägande..nn.1
  kort_1_Adv = mkAdv "kort" ; -- kort..ab.1
  kort_1_A = mkA "kort" "kort" ; -- kort..av.1
  kort_1_N = mkN "kort" neutrum  ; -- kort..nn.1
  korta_1_V = mkV "kortar" ; -- korta..vb.1
  kortande_1_N = mkN "kortande" ; -- kortande..nn.1
  kortbedrägeri_1_N = mkN "kortbedrägeri" "kortbedrägeriet" "kortbedrägerier" "kortbedrägerierna" ; -- kortbedrägeri..nn.1
  kortbent_1_A = mkA "kortbent" "kortbent" ; -- kortbent..av.1
  kortbenthet_1_N = mkN "kortbenthet" ; -- kortbenthet..nn.1
  kortbyxa_1_N = mkN "kortbyxa" ; -- kortbyxa..nn.1
  kortdistans_1_N = mkN "kortdistans" "kortdistanser" ; -- kortdistans..nn.1
  kortdistanslöpare_1_N = mkN "kortdistanslöpare" utrum  ; -- kortdistanslöpare..nn.1
  kortege_1_N = mkN "kortege" "korteger" ; -- kortege..nn.1
  kortegebil_1_N = mkN "kortegebil" ; -- kortegebil..nn.1
  kortegeväg_1_N = mkN "kortegeväg" ; -- kortegeväg..nn.1
  korteligen_1_Adv = mkAdv "korteligen" ; -- korteligen..ab.1
  kortfattad_1_A = mkA "kortfattad" ; -- kortfattad..av.1
  kortfibrig_1_A = mkA "kortfibrig" ; -- kortfibrig..av.1
  kortfilm_1_N = mkN "kortfilm" "kortfilmer" ; -- kortfilm..nn.1
  kortform_1_N = mkN "kortform" "kortformer" ; -- kortform..nn.1
  kortfristig_1_A = mkA "kortfristig" ; -- kortfristig..av.1
  kortfristighet_1_N = mkN "kortfristighet" ; -- kortfristighet..nn.1
  korthet_1_N = mkN "korthet" "kortheter" ; -- korthet..nn.1
  korthuggen_1_A = mkA "korthuggen" ; -- korthuggen..av.1
  korthuggenhet_1_N = mkN "korthuggenhet" ; -- korthuggenhet..nn.1
  korthus_1_N = mkN "korthus" neutrum  ; -- korthus..nn.1
  korthål_1_N = mkN "korthål" neutrum  ; -- korthål..nn.1
  korthålsbana_1_N = mkN "korthålsbana" ; -- korthålsbana..nn.1
  korthårig_1_A = mkA "korthårig" ; -- korthårig..av.1
  korthårighet_1_N = mkN "korthårighet" ; -- korthårighet..nn.1
  kortinnehavare_1_N = mkN "kortinnehavare" utrum  ; -- kortinnehavare..nn.1
  kortisol_1_N = mkN "kortisol" "kortisoler" ; -- kortisol..nn.1
  kortison_1_N = mkN "kortison" "kortisoner" ; -- kortison..nn.1
  kortisonbehandling_1_N = mkN "kortisonbehandling" ; -- kortisonbehandling..nn.1
  kortkatalog_1_N = mkN "kortkatalog" "kortkataloger" ; -- kortkatalog..nn.1
  kortklippa_1_V = mkV "kortklipper" ; -- kortklippa..vb.1
  kortklippande_1_N = mkN "kortklippande" ; -- kortklippande..nn.1
  kortklippning_1_N = mkN "kortklippning" ; -- kortklippning..nn.1
  kortklippt_1_A = mkA "kortklippt" "kortklippt" ; -- kortklippt..av.1
  kortklippthet_1_N = mkN "kortklippthet" ; -- kortklippthet..nn.1
  kortkonst_1_N = mkN "kortkonst" "kortkonster" ; -- kortkonst..nn.1
  kortkort_1_A = mkA "kortkort" "kortkort" ; -- kortkort..av.1
  kortla_1_V = mkV "kortlar" ; -- kortla..vb.1
  kortlande_1_N = mkN "kortlande" ; -- kortlande..nn.1
  kortlek_1_N = mkN "kortlek" ; -- kortlek..nn.1
  kortling_1_N = mkN "kortling" ; -- kortling..nn.1
  kortlivad_1_A = mkA "kortlivad" ; -- kortlivad..av.1
  kortläsare_1_N = mkN "kortläsare" utrum  ; -- kortläsare..nn.1
  kortlåda_1_N = mkN "kortlåda" ; -- kortlåda..nn.1
  kortoxe_1_N = mkN "kortoxe" utrum  ; -- kortoxe..nn.1
  kortpassa_1_V = mkV "kortpassar" ; -- kortpassa..vb.1
  kortpassande_1_N = mkN "kortpassande" ; -- kortpassande..nn.1
  kortpassning_1_N = mkN "kortpassning" ; -- kortpassning..nn.1
  kortpipig_1_A = mkA "kortpipig" ; -- kortpipig..av.1
  kortprosa_1_N = mkN "kortprosa" ; -- kortprosa..nn.1
  kortregister_1_N = mkN "kortregister" neutrum  ; -- kortregister..nn.1
  kortroman_1_N = mkN "kortroman" "kortromaner" ; -- kortroman..nn.1
  kortrunda_1_N = mkN "kortrunda" ; -- kortrunda..nn.1
  kortsida_1_N = mkN "kortsida" ; -- kortsida..nn.1
  kortsiktig_1_A = mkA "kortsiktig" ; -- kortsiktig..av.1
  kortsiktighet_1_N = mkN "kortsiktighet" ; -- kortsiktighet..nn.1
  kortskallig_1_A = mkA "kortskallig" ; -- kortskallig..av.1
  kortskallighet_1_N = mkN "kortskallighet" ; -- kortskallighet..nn.1
  kortsluta_1_V = mkV "kortsluta" "kortslöt" "kortslutit" ; -- kortsluta..vb.1
  kortslutande_1_N = mkN "kortslutande" ; -- kortslutande..nn.1
  kortslutning_1_N = mkN "kortslutning" ; -- kortslutning..nn.1
  kortslutningsskydd_1_N = mkN "kortslutningsskydd" neutrum  ; -- kortslutningsskydd..nn.1
  kortsnaggad_1_A = mkA "kortsnaggad" ; -- kortsnaggad..av.1
  kortspel_1_N = mkN "kortspel" "kortspelet" "kortspel" "kortspelen" ; -- kortspel..nn.1
  kortspelare_1_N = mkN "kortspelare" utrum  ; -- kortspelare..nn.1
  kortstöld_1_N = mkN "kortstöld" "kortstölder" ; -- kortstöld..nn.1
  kortsynt_1_A = mkA "kortsynt" "kortsynt" ; -- kortsynt..av.1
  kortsynthet_1_N = mkN "kortsynthet" ; -- kortsynthet..nn.1
  korttidsförvaring_1_N = mkN "korttidsförvaring" ; -- korttidsförvaring..nn.1
  korttidsminne_1_N = mkN "korttidsminne" ; -- korttidsminne..nn.1
  korttidsparkering_1_N = mkN "korttidsparkering" ; -- korttidsparkering..nn.1
  korttidssovare_1_N = mkN "korttidssovare" utrum  ; -- korttidssovare..nn.1
  korttidsvecka_1_N = mkN "korttidsvecka" ; -- korttidsvecka..nn.1
  korttidsvikarie_1_N = mkN "korttidsvikarie" "korttidsvikarier" ; -- korttidsvikarie..nn.1
  korttänkt_1_A = mkA "korttänkt" "korttänkt" ; -- korttänkt..av.1
  korttänkthet_1_N = mkN "korttänkthet" ; -- korttänkthet..nn.1
  kortvara_1_N = mkN "kortvara" ; -- kortvara..nn.1
  kortvarig_1_A = mkA "kortvarig" ; -- kortvarig..av.1
  kortvarighet_1_N = mkN "kortvarighet" ; -- kortvarighet..nn.1
  kortvuxen_1_A = mkA "kortvuxen" ; -- kortvuxen..av.1
  kortvuxenhet_1_N = mkN "kortvuxenhet" ; -- kortvuxenhet..nn.1
  kortvägg_1_N = mkN "kortvägg" ; -- kortvägg..nn.1
  kortväxt_1_A = mkA "kortväxt" "kortväxt" ; -- kortväxt..av.1
  kortväxthet_1_N = mkN "kortväxthet" ; -- kortväxthet..nn.1
  kortvåg_1_N = mkN "kortvåg" "kortvågor" ; -- kortvåg..nn.1
  kortvågsbehandling_1_N = mkN "kortvågsbehandling" ; -- kortvågsbehandling..nn.1
  kortvågsradio_1_N = mkN "kortvågsradio" "kortvågsradior" ; -- kortvågsradio..nn.1
  kortända_1_N = mkN "kortända" ; -- kortända..nn.1
  kortände_1_N = mkN "kortände" utrum  ; -- kortände..nn.1
  kortärmad_1_A = mkA "kortärmad" ; -- kortärmad..av.1
  korum_1_N = mkN "korum" neutrum  ; -- korum..nn.1
  korund_1_N = mkN "korund" "korunder" ; -- korund..nn.1
  korus_1_N = mkN "korus" neutrum  ; -- korus..nn.1
  korv_1_N = mkN "korv" ; -- korv..nn.1
  korvett_1_N = mkN "korvett" "korvetter" ; -- korvett..nn.1
  korvfabrik_1_N = mkN "korvfabrik" "korvfabriker" ; -- korvfabrik..nn.1
  korvfabrikör_1_N = mkN "korvfabrikör" "korvfabrikörer" ; -- korvfabrikör..nn.1
  korvgryta_1_N = mkN "korvgryta" ; -- korvgryta..nn.1
  korvgubbe_1_N = mkN "korvgubbe" utrum  ; -- korvgubbe..nn.1
  korvig_1_A = mkA "korvig" ; -- korvig..av.1
  korvighet_1_N = mkN "korvighet" ; -- korvighet..nn.1
  korvjobb_1_N = mkN "korvjobb" neutrum  ; -- korvjobb..nn.1
  korvkaka_1_N = mkN "korvkaka" ; -- korvkaka..nn.1
  korvkiosk_1_N = mkN "korvkiosk" "korvkiosker" ; -- korvkiosk..nn.1
  korvmacka_1_N = mkN "korvmacka" ; -- korvmacka..nn.1
  korvmaskin_1_N = mkN "korvmaskin" "korvmaskiner" ; -- korvmaskin..nn.1
  korvmoj_1_N = mkN "korvmoj" ; -- korvmoj..nn.1
  korvsjö_1_N = mkN "korvsjö" ; -- korvsjö..nn.1
  korvskinn_1_N = mkN "korvskinn" neutrum  ; -- korvskinn..nn.1
  korvskiva_1_N = mkN "korvskiva" ; -- korvskiva..nn.1
  korvsmörgås_1_N = mkN "korvsmörgås" ; -- korvsmörgås..nn.1
  korvstoppning_1_N = mkN "korvstoppning" ; -- korvstoppning..nn.1
  korvstånd_1_N = mkN "korvstånd" neutrum  ; -- korvstånd..nn.1
  korvtillverkning_1_N = mkN "korvtillverkning" ; -- korvtillverkning..nn.1
  korvälskare_1_N = mkN "korvälskare" utrum  ; -- korvälskare..nn.1
  koryfé_1_N = mkN "koryfé" "koryféer" ; -- koryfé..nn.1
  kos_1_N = mkN "kos" ; -- kos..nn.1
  kosa_1_N = mkN "kosa" ; -- kosa..nn.1
  kosa_2_N = mkN "kosa" ; -- kosa..nn.2
  kosack_1_N = mkN "kosack" "kosacker" ; -- kosack..nn.1
  kosackdans_1_N = mkN "kosackdans" "kosackdanser" ; -- kosackdans..nn.1
  kosackhetman_1_N = mkN "kosackhetman" "kosackhetmaner" ; -- kosackhetman..nn.1
  koschenill_1_N = mkN "koschenill" ; -- koschenill..nn.1
  koschenillfärg_1_N = mkN "koschenillfärg" "koschenillfärger" ; -- koschenillfärg..nn.1
  koscher_1_A = mkA "koscher" ; -- koscher..av.1
  kosing_1_N = mkN "kosing" ; -- kosing..nn.1
  koskit_1_N = mkN "koskit" ; -- koskit..nn.1
  koskälla_1_N = mkN "koskälla" ; -- koskälla..nn.1
  kosmetik_1_N = mkN "kosmetik" ; -- kosmetik..nn.1
  kosmetika_1_N = mkN "kosmetika" ; -- kosmetika..nn.1
  kosmetikaaffär_1_N = mkN "kosmetikaaffär" "kosmetikaaffärer" ; -- kosmetikaaffär..nn.1
  kosmetikaföretag_1_N = mkN "kosmetikaföretag" neutrum  ; -- kosmetikaföretag..nn.1
  kosmetisk_1_A = mkA "kosmetisk" ; -- kosmetisk..av.1
  kosmetolog_1_N = mkN "kosmetolog" "kosmetologer" ; -- kosmetolog..nn.1
  kosmisk_1_A = mkA "kosmisk" ; -- kosmisk..av.1
  kosmodrom_1_N = mkN "kosmodrom" "kosmodromer" ; -- kosmodrom..nn.1
  kosmogoni_1_N = mkN "kosmogoni" "kosmogonier" ; -- kosmogoni..nn.1
  kosmolog_1_N = mkN "kosmolog" "kosmologer" ; -- kosmolog..nn.1
  kosmologi_1_N = mkN "kosmologi" "kosmologier" ; -- kosmologi..nn.1
  kosmologisk_1_A = mkA "kosmologisk" ; -- kosmologisk..av.1
  kosmonaut_1_N = mkN "kosmonaut" "kosmonauter" ; -- kosmonaut..nn.1
  kosmopolit_1_N = mkN "kosmopolit" "kosmopoliter" ; -- kosmopolit..nn.1
  kosmopolitisk_1_A = mkA "kosmopolitisk" ; -- kosmopolitisk..av.1
  kosmos_1_N = mkN "kosmos" neutrum  ; -- kosmos..nn.1
  kosovansk_1_A = mkA "kosovansk" ; -- kosovansk..av.1
  kosovanska_1_N = mkN "kosovanska" ; -- kosovanska..nn.1
  kosovar_1_N = mkN "kosovar" "kosovarer" ; -- kosovar..nn.1
  kosovoalbansk_1_A = mkA "kosovoalbansk" ; -- kosovoalbansk..av.1
  kossa_1_N = mkN "kossa" ; -- kossa..nn.1
  kost_1_N = mkN "kost" ; -- kost..nn.1
  kosta_1_V = mkV "kostar" ; -- kosta..vb.1
  kostande_1_N = mkN "kostande" ; -- kostande..nn.1
  kostbar_1_A = mkA "kostbar" ; -- kostbar..av.1
  kostbarhet_1_N = mkN "kostbarhet" "kostbarheter" ; -- kostbarhet..nn.1
  koster_1_N = mkN "koster" ; -- koster..nn.1
  kosterbåt_1_N = mkN "kosterbåt" ; -- kosterbåt..nn.1
  kostfiber_1_N = mkN "kostfiber" "kostfibern" "kostfibrer" "kostfibrerna" ; -- kostfiber..nn.1
  kosthåll_1_N = mkN "kosthåll" neutrum  ; -- kosthåll..nn.1
  kosthållning_1_N = mkN "kosthållning" ; -- kosthållning..nn.1
  kostig_1_N = mkN "kostig" ; -- kostig..nn.1
  kostlig_1_A = mkA "kostlig" ; -- kostlig..av.1
  kostlighet_1_N = mkN "kostlighet" ; -- kostlighet..nn.1
  kostnad_1_N = mkN "kostnad" "kostnader" ; -- kostnad..nn.1
  kostnadsberäkna_1_V = mkV "kostnadsberäknar" ; -- kostnadsberäkna..vb.1
  kostnadsberäknande_1_N = mkN "kostnadsberäknande" ; -- kostnadsberäknande..nn.1
  kostnadsberäkning_1_N = mkN "kostnadsberäkning" ; -- kostnadsberäkning..nn.1
  kostnadsbesparing_1_N = mkN "kostnadsbesparing" ; -- kostnadsbesparing..nn.1
  kostnadseffektiv_1_A = mkA "kostnadseffektiv" ; -- kostnadseffektiv..av.1
  kostnadsersättning_1_N = mkN "kostnadsersättning" ; -- kostnadsersättning..nn.1
  kostnadsfri_1_A = mkA "kostnadsfri" "kostnadsfritt" ; -- kostnadsfri..av.1
  kostnadsförslag_1_N = mkN "kostnadsförslag" neutrum  ; -- kostnadsförslag..nn.1
  kostnadskrävande_1_A = mkA "kostnadskrävande" ; -- kostnadskrävande..av.1
  kostnadsmässig_1_A = mkA "kostnadsmässig" ; -- kostnadsmässig..av.1
  kostnadsram_1_N = mkN "kostnadsram" ; -- kostnadsram..nn.1
  kostnadsskäl_1_N = mkN "kostnadsskäl" neutrum  ; -- kostnadsskäl..nn.1
  kostnadssänkande_1_A = mkA "kostnadssänkande" ; -- kostnadssänkande..av.1
  kostnadstak_1_N = mkN "kostnadstak" neutrum  ; -- kostnadstak..nn.1
  kostnadsutveckling_1_N = mkN "kostnadsutveckling" ; -- kostnadsutveckling..nn.1
  kostnadsvall_1_N = mkN "kostnadsvall" neutrum  ; -- kostnadsvall..nn.1
  kostnadsökning_1_N = mkN "kostnadsökning" ; -- kostnadsökning..nn.1
  kostråd_1_N = mkN "kostråd" neutrum  ; -- kostråd..nn.1
  kostsam_1_A = mkA "kostsam" "kostsamt" "kostsamma" "kostsamma" "kostsammare" "kostsammast" "kostsammaste" ; -- kostsam..av.1
  kostsamhet_1_N = mkN "kostsamhet" ; -- kostsamhet..nn.1
  kostschema_1_N = mkN "kostschema" "kostschemat" "kostscheman" "kostschemana" ; -- kostschema..nn.1
  kosttillskott_1_N = mkN "kosttillskott" neutrum  ; -- kosttillskott..nn.1
  kostvana_1_N = mkN "kostvana" ; -- kostvana..nn.1
  kostym_1_N = mkN "kostym" "kostymer" ; -- kostym..nn.1
  kostymbal_1_N = mkN "kostymbal" "kostymbaler" ; -- kostymbal..nn.1
  kostymbyxa_1_N = mkN "kostymbyxa" ; -- kostymbyxa..nn.1
  kostymera_1_V = mkV "kostymerar" ; -- kostymera..vb.1
  kostymerande_1_N = mkN "kostymerande" ; -- kostymerande..nn.1
  kostymerbar_1_A = mkA "kostymerbar" ; -- kostymerbar..av.1
  kostymerbarhet_1_N = mkN "kostymerbarhet" ; -- kostymerbarhet..nn.1
  kostymering_1_N = mkN "kostymering" ; -- kostymering..nn.1
  kostymfest_1_N = mkN "kostymfest" "kostymfester" ; -- kostymfest..nn.1
  kostymklädd_1_A = mkA "kostymklädd" ; -- kostymklädd..av.1
  kostympjäs_1_N = mkN "kostympjäs" "kostympjäser" ; -- kostympjäs..nn.1
  kosvans_1_N = mkN "kosvans" ; -- kosvans..nn.1
  kota_1_N = mkN "kota" ; -- kota..nn.1
  kotben_1_N = mkN "kotben" neutrum  ; -- kotben..nn.1
  kotiljong_1_N = mkN "kotiljong" "kotiljonger" ; -- kotiljong..nn.1
  kotknackare_1_N = mkN "kotknackare" utrum  ; -- kotknackare..nn.1
  kotknackning_1_N = mkN "kotknackning" ; -- kotknackning..nn.1
  kotled_1_N = mkN "kotled" "kotleder" ; -- kotled..nn.1
  kotlett_1_N = mkN "kotlett" "kotletter" ; -- kotlett..nn.1
  kotlettfisk_1_N = mkN "kotlettfisk" ; -- kotlettfisk..nn.1
  kotlettrad_1_N = mkN "kotlettrad" "kotlettrader" ; -- kotlettrad..nn.1
  kotpelare_1_N = mkN "kotpelare" utrum  ; -- kotpelare..nn.1
  kotte_1_N = mkN "kotte" utrum  ; -- kotte..nn.1
  kotteri_1_N = mkN "kotteri" "kotteriet" "kotterier" "kotterierna" ; -- kotteri..nn.1
  kottla_1_V = mkV "kottlar" ; -- kottla..vb.1
  kottlande_1_N = mkN "kottlande" ; -- kottlande..nn.1
  kottling_1_N = mkN "kottling" ; -- kottling..nn.1
  koturn_1_N = mkN "koturn" "koturner" ; -- koturn..nn.1
  kova_1_N = mkN "kova" ; -- kova..nn.1
  kovalent_1_A = mkA "kovalent" "kovalent" ; -- kovalent..av.1
  kovall_1_N = mkN "kovall" "kovaller" ; -- kovall..nn.1
  kovert_1_A = mkA "kovert" "kovert" ; -- kovert..av.1
  kovända_1_V = mkV "kovänder" ; -- kovända..vb.1
  kovändande_1_N = mkN "kovändande" ; -- kovändande..nn.1
  kovändning_1_N = mkN "kovändning" ; -- kovändning..nn.1
  kox_1_N = mkN "kox" ; -- kox..nn.1
  koxa_1_V = mkV "koxar" ; -- koxa..vb.1
  koxande_1_N = mkN "koxande" ; -- koxande..nn.1
  koxning_1_N = mkN "koxning" ; -- koxning..nn.1
  koyot_1_N = mkN "koyot" "koyoter" ; -- koyot..nn.1
  koöga_1_N = mkN "koöga" "koögat" "koögon" "koögonen" ; -- koöga..nn.1
  koögd_1_A = mkA "koögd" "koögt" ; -- koögd..av.1
  koögdhet_1_N = mkN "koögdhet" ; -- koögdhet..nn.1
  kpist_1_N = mkN "kpist" ; -- kpist..nn.1
  kraal_1_N = mkN "kraal" "kraaler" ; -- kraal..nn.1
  krabat_1_N = mkN "krabat" "krabater" ; -- krabat..nn.1
  krabb_1_A = mkA "krabb" ; -- krabb..av.1
  krabba_1_N = mkN "krabba" ; -- krabba..nn.1
  krabbasnår_1_N = mkN "krabbasnår" neutrum  ; -- krabbasnår..nn.1
  krabbhet_1_N = mkN "krabbhet" ; -- krabbhet..nn.1
  krabbtaska_1_N = mkN "krabbtaska" ; -- krabbtaska..nn.1
  kracka_1_V = mkV "krackar" ; -- kracka..vb.1
  krackande_1_N = mkN "krackande" ; -- krackande..nn.1
  krackelera_1_V = mkV "krackelerar" ; -- krackelera..vb.1
  krackelerande_1_N = mkN "krackelerande" ; -- krackelerande..nn.1
  krackelerbar_1_A = mkA "krackelerbar" ; -- krackelerbar..av.1
  krackelerbarhet_1_N = mkN "krackelerbarhet" ; -- krackelerbarhet..nn.1
  krackelering_1_N = mkN "krackelering" ; -- krackelering..nn.1
  krackelyr_1_N = mkN "krackelyr" ; -- krackelyr..nn.1
  krackning_1_N = mkN "krackning" ; -- krackning..nn.1
  krafs_1_N = mkN "krafs" neutrum  ; -- krafs..nn.1
  krafsa_1_V = mkV "krafsar" ; -- krafsa..vb.1
  krafsande_1_N = mkN "krafsande" ; -- krafsande..nn.1
  krafsig_1_A = mkA "krafsig" ; -- krafsig..av.1
  krafsighet_1_N = mkN "krafsighet" ; -- krafsighet..nn.1
  krafsning_1_N = mkN "krafsning" ; -- krafsning..nn.1
  kraft_1_N = mkN "kraft" "krafter" ; -- kraft..nn.1
  kraftaggregat_1_N = mkN "kraftaggregat" neutrum  ; -- kraftaggregat..nn.1
  kraftansträngning_1_N = mkN "kraftansträngning" ; -- kraftansträngning..nn.1
  kraftbehov_1_N = mkN "kraftbehov" neutrum  ; -- kraftbehov..nn.1
  kraftbolag_1_N = mkN "kraftbolag" neutrum  ; -- kraftbolag..nn.1
  kraftbärare_1_N = mkN "kraftbärare" utrum  ; -- kraftbärare..nn.1
  kraftcentral_1_N = mkN "kraftcentral" "kraftcentraler" ; -- kraftcentral..nn.1
  kraftcentrum_1_N = mkN "kraftcentrum" neutrum  ; -- kraftcentrum..nn.1
  kraftekvation_1_N = mkN "kraftekvation" ; -- kraftekvation..nn.1
  kraftfoder_1_N = mkN "kraftfoder" neutrum  ; -- kraftfoder..nn.1
  kraftfull_1_A = mkA "kraftfull" ; -- kraftfull..av.1
  kraftfullhet_1_N = mkN "kraftfullhet" ; -- kraftfullhet..nn.1
  kraftfält_1_N = mkN "kraftfält" neutrum  ; -- kraftfält..nn.1
  kraftförbrukning_1_N = mkN "kraftförbrukning" ; -- kraftförbrukning..nn.1
  kraftföretag_1_N = mkN "kraftföretag" neutrum  ; -- kraftföretag..nn.1
  kraftförlust_1_N = mkN "kraftförlust" "kraftförluster" ; -- kraftförlust..nn.1
  kraftförsörjning_1_N = mkN "kraftförsörjning" ; -- kraftförsörjning..nn.1
  kraftig_1_A = mkA "kraftig" ; -- kraftig..av.1
  kraftighet_1_N = mkN "kraftighet" ; -- kraftighet..nn.1
  kraftkarl_1_N = mkN "kraftkarl" ; -- kraftkarl..nn.1
  kraftkonsument_1_N = mkN "kraftkonsument" "kraftkonsumenter" ; -- kraftkonsument..nn.1
  kraftkrävande_1_A = mkA "kraftkrävande" ; -- kraftkrävande..av.1
  kraftkälla_1_N = mkN "kraftkälla" ; -- kraftkälla..nn.1
  kraftledning_1_N = mkN "kraftledning" ; -- kraftledning..nn.1
  kraftlinje_1_N = mkN "kraftlinje" "kraftlinjer" ; -- kraftlinje..nn.1
  kraftlös_1_A = mkA "kraftlös" ; -- kraftlös..av.1
  kraftlöshet_1_N = mkN "kraftlöshet" "kraftlösheter" ; -- kraftlöshet..nn.1
  kraftmedel_1_N = mkN "kraftmedel" neutrum  ; -- kraftmedel..nn.1
  kraftmejsel_1_N = mkN "kraftmejsel" ; -- kraftmejsel..nn.1
  kraftmätning_1_N = mkN "kraftmätning" ; -- kraftmätning..nn.1
  kraftnedsättning_1_N = mkN "kraftnedsättning" ; -- kraftnedsättning..nn.1
  kraftnät_1_N = mkN "kraftnät" neutrum  ; -- kraftnät..nn.1
  kraftord_1_N = mkN "kraftord" neutrum  ; -- kraftord..nn.1
  kraftpaket_1_N = mkN "kraftpaket" neutrum  ; -- kraftpaket..nn.1
  kraftpapper_1_N = mkN "kraftpapper" neutrum  ; -- kraftpapper..nn.1
  kraftparallellogram_1_N = mkN "kraftparallellogram" "kraftparallellogrammen" "kraftparallellogrammer" "kraftparallellogrammerna" ; -- kraftparallellogram..nn.1
  kraftpartikel_1_N = mkN "kraftpartikel" ; -- kraftpartikel..nn.1
  kraftprov_1_N = mkN "kraftprov" neutrum  ; -- kraftprov..nn.1
  kraftsamla_1_V = mkV "kraftsamlar" ; -- kraftsamla..vb.1
  kraftsamling_1_N = mkN "kraftsamling" ; -- kraftsamling..nn.1
  kraftspel_1_N = mkN "kraftspel" "kraftspelet" "kraftspel" "kraftspelen" ; -- kraftspel..nn.1
  kraftsport_1_N = mkN "kraftsport" "kraftsporter" ; -- kraftsport..nn.1
  kraftspråk_1_N = mkN "kraftspråk" neutrum  ; -- kraftspråk..nn.1
  kraftstation_1_N = mkN "kraftstation" ; -- kraftstation..nn.1
  krafttag_1_N = mkN "krafttag" neutrum  ; -- krafttag..nn.1
  kraftuttryck_1_N = mkN "kraftuttryck" neutrum  ; -- kraftuttryck..nn.1
  kraftutveckling_1_N = mkN "kraftutveckling" ; -- kraftutveckling..nn.1
  kraftverk_1_N = mkN "kraftverk" neutrum  ; -- kraftverk..nn.1
  kraftverksbygge_1_N = mkN "kraftverksbygge" ; -- kraftverksbygge..nn.1
  kraftverksdamm_1_N = mkN "kraftverksdamm" ; -- kraftverksdamm..nn.1
  kraftvunnen_1_A = mkA "kraftvunnen" "kraftvunnet" "kraftvunna" "kraftvunna" "kraftvunnare" "kraftvunnast" "kraftvunnaste" ; -- kraftvunnen..av.1
  kraftvärmeverk_1_N = mkN "kraftvärmeverk" neutrum  ; -- kraftvärmeverk..nn.1
  kraftyttring_1_N = mkN "kraftyttring" ; -- kraftyttring..nn.1
  kraftåtgärd_1_N = mkN "kraftåtgärd" "kraftåtgärder" ; -- kraftåtgärd..nn.1
  kraftöverföring_1_N = mkN "kraftöverföring" ; -- kraftöverföring..nn.1
  krage_1_N = mkN "krage" utrum  ; -- krage..nn.1
  kraghandske_1_N = mkN "kraghandske" utrum  ; -- kraghandske..nn.1
  kragknapp_1_N = mkN "kragknapp" ; -- kragknapp..nn.1
  kraglös_1_A = mkA "kraglös" ; -- kraglös..av.1
  kraglöshet_1_N = mkN "kraglöshet" ; -- kraglöshet..nn.1
  kragsnibb_1_N = mkN "kragsnibb" ; -- kragsnibb..nn.1
  kragsten_1_N = mkN "kragsten" "kragstenen" "kragstenar" "kragstenarna" ; -- kragsten..nn.1
  kragstövel_1_N = mkN "kragstövel" ; -- kragstövel..nn.1
  krake_1_N = mkN "krake" utrum  ; -- krake..nn.1
  krakel_1_N = mkN "krakel" neutrum  ; -- krakel..nn.1
  krakmandel_1_N = mkN "krakmandel" ; -- krakmandel..nn.1
  kral_1_N = mkN "kral" "kraler" ; -- kral..nn.1
  kram_1_A = mkA "kram" ; -- kram..av.1
  kram_1_N = mkN "kram" ; -- kram..nn.1
  kram_2_N = mkN "kram" neutrum  ; -- kram..nn.2
  krama_1_V = mkV "kramar" ; -- krama..vb.1
  kramande_1_N = mkN "kramande" ; -- kramande..nn.1
  kramhet_1_N = mkN "kramhet" ; -- kramhet..nn.1
  kramla_1_N = mkN "kramla" ; -- kramla..nn.1
  kramning_1_N = mkN "kramning" ; -- kramning..nn.1
  kramp_1_N = mkN "kramp" "kramper" ; -- kramp..nn.1
  krampa_1_N = mkN "krampa" ; -- krampa..nn.1
  krampa_1_V = mkV "krampar" ; -- krampa..vb.1
  krampaktig_1_A = mkA "krampaktig" ; -- krampaktig..av.1
  krampaktighet_1_N = mkN "krampaktighet" ; -- krampaktighet..nn.1
  krampande_1_N = mkN "krampande" ; -- krampande..nn.1
  krampanfall_1_N = mkN "krampanfall" neutrum  ; -- krampanfall..nn.1
  kramplösande_1_A = mkA "kramplösande" ; -- kramplösande..av.1
  krampryckning_1_N = mkN "krampryckning" ; -- krampryckning..nn.1
  krampstillande_1_A = mkA "krampstillande" ; -- krampstillande..av.1
  krams_1_N = mkN "krams" neutrum  ; -- krams..nn.1
  kramsfågel_1_N = mkN "kramsfågel" ; -- kramsfågel..nn.1
  kramsnö_1_N = mkN "kramsnö" ; -- kramsnö..nn.1
  kran_1_N = mkN "kran" ; -- kran..nn.1
  kranarm_1_N = mkN "kranarm" ; -- kranarm..nn.1
  kranbalk_1_N = mkN "kranbalk" ; -- kranbalk..nn.1
  kranbalksvis_1_Adv = mkAdv "kranbalksvis" ; -- kranbalksvis..ab.1
  kranium_1_N = mkN "kranium" "kraniet" "kranier" "kranierna" ; -- kranium..nn.1
  krank_1_A = mkA "krank" ; -- krank..av.1
  krankhet_1_N = mkN "krankhet" ; -- krankhet..nn.1
  krankik_1_N = mkN "krankik" ; -- krankik..nn.1
  krans_1_N = mkN "krans" ; -- krans..nn.1
  kransa_1_V = mkV "kransar" ; -- kransa..vb.1
  kransande_1_N = mkN "kransande" ; -- kransande..nn.1
  kransartär_1_N = mkN "kransartär" "kransartärer" ; -- kransartär..nn.1
  kransband_1_N = mkN "kransband" neutrum  ; -- kransband..nn.1
  kransblommig_1_A = mkA "kransblommig" ; -- kransblommig..av.1
  kransformig_1_A = mkA "kransformig" ; -- kransformig..av.1
  kranskommun_1_N = mkN "kranskommun" "kranskommuner" ; -- kranskommun..nn.1
  kranskulla_1_N = mkN "kranskulla" ; -- kranskulla..nn.1
  kranskärl_1_N = mkN "kranskärl" neutrum  ; -- kranskärl..nn.1
  kransnedläggning_1_N = mkN "kransnedläggning" ; -- kransnedläggning..nn.1
  kransregion_1_N = mkN "kransregion" ; -- kransregion..nn.1
  kranvatten_1_N = mkN "kranvatten" "kranvattnet" "kranvatten" "kranvattnen" ; -- kranvatten..nn.1
  krapp_1_N = mkN "krapp" ; -- krapp..nn.1
  kras_1_N = mkN "kras" neutrum  ; -- kras..nn.1
  krasa_1_V = mkV "krasar" ; -- krasa..vb.1
  krasande_1_N = mkN "krasande" ; -- krasande..nn.1
  krasch_1_N = mkN "krasch" ; -- krasch..nn.1
  krasch_2_N = mkN "krasch" "krascher" ; -- krasch..nn.2
  krascha_1_V = mkV "kraschar" ; -- krascha..vb.1
  krascha_2_V = mkV "kraschar" ; -- krascha..vb.2
  kraschan_1_N = mkN "kraschan" "kraschaner" ; -- kraschan..nn.1
  kraschande_1_N = mkN "kraschande" ; -- kraschande..nn.1
  kraschlanda_1_V = mkV "kraschlandar" ; -- kraschlanda..vb.1
  kraschlandande_1_N = mkN "kraschlandande" ; -- kraschlandande..nn.1
  krass_1_A = mkA "krass" ; -- krass..av.1
  krasse_1_N = mkN "krasse" utrum  ; -- krasse..nn.1
  krasshet_1_N = mkN "krasshet" ; -- krasshet..nn.1
  krasslig_1_A = mkA "krasslig" ; -- krasslig..av.1
  krasslighet_1_N = mkN "krasslighet" "krassligheter" ; -- krasslighet..nn.1
  krater_1_N = mkN "krater" ; -- krater..nn.1
  kraterberg_1_N = mkN "kraterberg" neutrum  ; -- kraterberg..nn.1
  kraterbotten_1_N = mkN "kraterbotten" ; -- kraterbotten..nn.1
  kratersjö_1_N = mkN "kratersjö" ; -- kratersjö..nn.1
  kratervägg_1_N = mkN "kratervägg" ; -- kratervägg..nn.1
  krateröppning_1_N = mkN "krateröppning" ; -- krateröppning..nn.1
  krats_1_N = mkN "krats" ; -- krats..nn.1
  kratsa_1_V = mkV "kratsar" ; -- kratsa..vb.1
  kratsande_1_N = mkN "kratsande" ; -- kratsande..nn.1
  kratta_1_N = mkN "kratta" ; -- kratta..nn.1
  kratta_1_V = mkV "krattar" ; -- kratta..vb.1
  krattande_1_N = mkN "krattande" ; -- krattande..nn.1
  krav_1_N = mkN "krav" neutrum  ; -- krav..nn.1
  kravall_1_N = mkN "kravall" "kravaller" ; -- kravall..nn.1
  kravallpolis_1_N = mkN "kravallpolis" ; -- kravallpolis..nn.1
  kravallpolis_2_N = mkN "kravallpolis" "kravallpoliser" ; -- kravallpolis..nn.2
  kravallsköld_1_N = mkN "kravallsköld" ; -- kravallsköld..nn.1
  kravallstaket_1_N = mkN "kravallstaket" neutrum  ; -- kravallstaket..nn.1
  kravallutrustad_1_A = mkA "kravallutrustad" ; -- kravallutrustad..av.1
  kravatt_1_N = mkN "kravatt" "kravatter" ; -- kravatt..nn.1
  kravattnål_1_N = mkN "kravattnål" ; -- kravattnål..nn.1
  kravbrev_1_N = mkN "kravbrev" neutrum  ; -- kravbrev..nn.1
  kravell_1_N = mkN "kravell" "kraveller" ; -- kravell..nn.1
  kravla_1_V = mkV "kravlar" ; -- kravla..vb.1
  kravlande_1_N = mkN "kravlande" ; -- kravlande..nn.1
  kravlös_1_A = mkA "kravlös" ; -- kravlös..av.1
  kravlöshet_1_N = mkN "kravlöshet" ; -- kravlöshet..nn.1
  kravmaskin_1_N = mkN "kravmaskin" "kravmaskiner" ; -- kravmaskin..nn.1
  kravmärka_1_V = mkV "kravmärker" ; -- kravmärka..vb.1
  kravmärkande_1_N = mkN "kravmärkande" ; -- kravmärkande..nn.1
  kravmärkning_1_N = mkN "kravmärkning" ; -- kravmärkning..nn.1
  kravretorik_1_N = mkN "kravretorik" ; -- kravretorik..nn.1
  kravspecifikation_1_N = mkN "kravspecifikation" ; -- kravspecifikation..nn.1
  krax_1_N = mkN "krax" neutrum  ; -- krax..nn.1
  kraxa_1_V = mkV "kraxar" ; -- kraxa..vb.1
  kraxande_1_N = mkN "kraxande" ; -- kraxande..nn.1
  kraxning_1_N = mkN "kraxning" ; -- kraxning..nn.1
  kreation_1_N = mkN "kreation" ; -- kreation..nn.1
  kreationism_1_N = mkN "kreationism" ; -- kreationism..nn.1
  kreationistisk_1_A = mkA "kreationistisk" ; -- kreationistisk..av.1
  kreativ_1_A = mkA "kreativ" ; -- kreativ..av.1
  kreativitet_1_N = mkN "kreativitet" "kreativiteter" ; -- kreativitet..nn.1
  kreatur_1_N = mkN "kreatur" neutrum  ; -- kreatur..nn.1
  kreatursbesättning_1_N = mkN "kreatursbesättning" ; -- kreatursbesättning..nn.1
  kreaturslös_1_A = mkA "kreaturslös" ; -- kreaturslös..av.1
  kreaturslöshet_1_N = mkN "kreaturslöshet" ; -- kreaturslöshet..nn.1
  kreaturssjukdom_1_N = mkN "kreaturssjukdom" ; -- kreaturssjukdom..nn.1
  kreatursskötsel_1_N = mkN "kreatursskötsel" ; -- kreatursskötsel..nn.1
  kredd_1_N = mkN "kredd" ; -- kredd..nn.1
  kreddig_1_A = mkA "kreddig" ; -- kreddig..av.1
  kreddighet_1_N = mkN "kreddighet" ; -- kreddighet..nn.1
  kredensa_1_V = mkV "kredensar" ; -- kredensa..vb.1
  kredensande_1_N = mkN "kredensande" ; -- kredensande..nn.1
  kredensning_1_N = mkN "kredensning" ; -- kredensning..nn.1
  kredit_1_N = mkN "kredit" "krediter" ; -- kredit..nn.1
  kredit_2_N = mkN "kredit" ; -- kredit..nn.2
  kreditanstalt_1_N = mkN "kreditanstalt" "kreditanstalter" ; -- kreditanstalt..nn.1
  kreditbetyg_1_N = mkN "kreditbetyg" neutrum  ; -- kreditbetyg..nn.1
  kreditbrev_1_N = mkN "kreditbrev" neutrum  ; -- kreditbrev..nn.1
  kreditderivat_1_N = mkN "kreditderivat" neutrum  ; -- kreditderivat..nn.1
  kreditera_1_V = mkV "krediterar" ; -- kreditera..vb.1
  krediterande_1_N = mkN "krediterande" ; -- krediterande..nn.1
  krediterbar_1_A = mkA "krediterbar" ; -- krediterbar..av.1
  krediterbarhet_1_N = mkN "krediterbarhet" ; -- krediterbarhet..nn.1
  kreditering_1_N = mkN "kreditering" ; -- kreditering..nn.1
  kreditförlust_1_N = mkN "kreditförlust" "kreditförluster" ; -- kreditförlust..nn.1
  kreditgivare_1_N = mkN "kreditgivare" utrum  ; -- kreditgivare..nn.1
  kreditgivning_1_N = mkN "kreditgivning" ; -- kreditgivning..nn.1
  kreditinstitut_1_N = mkN "kreditinstitut" neutrum  ; -- kreditinstitut..nn.1
  kreditiv_1_N = mkN "kreditiv" neutrum  ; -- kreditiv..nn.1
  kreditivbrev_1_N = mkN "kreditivbrev" neutrum  ; -- kreditivbrev..nn.1
  kreditkort_1_N = mkN "kreditkort" neutrum  ; -- kreditkort..nn.1
  kreditkortsanvändande_1_A = mkA "kreditkortsanvändande" ; -- kreditkortsanvändande..av.1
  kreditkortsanvändande_1_N = mkN "kreditkortsanvändande" ; -- kreditkortsanvändande..nn.1
  kreditkortsföretag_1_N = mkN "kreditkortsföretag" neutrum  ; -- kreditkortsföretag..nn.1
  kreditmarknad_1_N = mkN "kreditmarknad" "kreditmarknader" ; -- kreditmarknad..nn.1
  kreditor_1_N = mkN "kreditor" "kreditorer" ; -- kreditor..nn.1
  kreditoro_1_N = mkN "kreditoro" ; -- kreditoro..nn.1
  kreditupplysning_1_N = mkN "kreditupplysning" ; -- kreditupplysning..nn.1
  kreditupplysningslag_1_N = mkN "kreditupplysningslag" ; -- kreditupplysningslag..nn.1
  kreditvillkor_1_N = mkN "kreditvillkor" neutrum  ; -- kreditvillkor..nn.1
  kreditvärderare_1_N = mkN "kreditvärderare" utrum  ; -- kreditvärderare..nn.1
  kreditvärdering_1_N = mkN "kreditvärdering" ; -- kreditvärdering..nn.1
  kreditvärderingsbetyg_1_N = mkN "kreditvärderingsbetyg" neutrum  ; -- kreditvärderingsbetyg..nn.1
  kreditvärderingsinstitut_1_N = mkN "kreditvärderingsinstitut" neutrum  ; -- kreditvärderingsinstitut..nn.1
  kreditväsen_1_N = mkN "kreditväsen" neutrum  ; -- kreditväsen..nn.1
  kreditåtstramning_1_N = mkN "kreditåtstramning" ; -- kreditåtstramning..nn.1
  kreera_1_V = mkV "kreerar" ; -- kreera..vb.1
  kreerande_1_N = mkN "kreerande" ; -- kreerande..nn.1
  kreerbar_1_A = mkA "kreerbar" ; -- kreerbar..av.1
  kreerbarhet_1_N = mkN "kreerbarhet" ; -- kreerbarhet..nn.1
  kreering_1_N = mkN "kreering" ; -- kreering..nn.1
  krematorium_1_N = mkN "krematorium" "krematoriet" "krematorier" "krematorierna" ; -- krematorium..nn.1
  kremera_1_V = mkV "kremerar" ; -- kremera..vb.1
  kremerande_1_N = mkN "kremerande" ; -- kremerande..nn.1
  kremerbar_1_A = mkA "kremerbar" ; -- kremerbar..av.1
  kremerbarhet_1_N = mkN "kremerbarhet" ; -- kremerbarhet..nn.1
  kremering_1_N = mkN "kremering" ; -- kremering..nn.1
  kremla_1_N = mkN "kremla" ; -- kremla..nn.1
  kremlolog_1_N = mkN "kremlolog" "kremlologer" ; -- kremlolog..nn.1
  kremlvänlig_1_A = mkA "kremlvänlig" ; -- kremlvänlig..av.1
  kremlvänlighet_1_N = mkN "kremlvänlighet" ; -- kremlvänlighet..nn.1
  kremservitt_1_N = mkN "kremservitt" ; -- kremservitt..nn.1
  krenelerad_1_A = mkA "krenelerad" ; -- krenelerad..av.1
  krenelering_1_N = mkN "krenelering" ; -- krenelering..nn.1
  kreol_1_N = mkN "kreol" "kreoler" ; -- kreol..nn.1
  kreolinslag_1_N = mkN "kreolinslag" neutrum  ; -- kreolinslag..nn.1
  kreolisera_1_V = mkV "kreoliserar" ; -- kreolisera..vb.1
  kreoliserande_1_N = mkN "kreoliserande" ; -- kreoliserande..nn.1
  kreolisering_1_N = mkN "kreolisering" ; -- kreolisering..nn.1
  kreoliseringsforskning_1_N = mkN "kreoliseringsforskning" ; -- kreoliseringsforskning..nn.1
  kreoliseringsstudie_1_N = mkN "kreoliseringsstudie" "kreoliseringsstudier" ; -- kreoliseringsstudie..nn.1
  kreolitet_1_N = mkN "kreolitet" ; -- kreolitet..nn.1
  kreolkultur_1_N = mkN "kreolkultur" "kreolkulturer" ; -- kreolkultur..nn.1
  kreolsk_1_A = mkA "kreolsk" ; -- kreolsk..av.1
  kreolska_1_N = mkN "kreolska" ; -- kreolska..nn.1
  kreolska_2_N = mkN "kreolska" ; -- kreolska..nn.2
  kreolspråk_1_N = mkN "kreolspråk" neutrum  ; -- kreolspråk..nn.1
  kreosotolja_1_N = mkN "kreosotolja" ; -- kreosotolja..nn.1
  krepera_1_V = mkV "kreperar" ; -- krepera..vb.1
  kreperande_1_N = mkN "kreperande" ; -- kreperande..nn.1
  kreperbar_1_A = mkA "kreperbar" ; -- kreperbar..av.1
  kreperbarhet_1_N = mkN "kreperbarhet" ; -- kreperbarhet..nn.1
  krepering_1_N = mkN "krepering" ; -- krepering..nn.1
  krestomati_1_N = mkN "krestomati" "krestomatier" ; -- krestomati..nn.1
  kreta_1_V = mkV "kretar" ; -- kreta..vb.1
  kretande_1_N = mkN "kretande" ; -- kretande..nn.1
  kretensare_1_N = mkN "kretensare" utrum  ; -- kretensare..nn.1
  kretensisk_1_A = mkA "kretensisk" ; -- kretensisk..av.1
  kreter_1_N = mkN "kreter" "kretern" "kreter" "kreterna" ; -- kreter..nn.1
  kretin_1_N = mkN "kretin" "kretiner" ; -- kretin..nn.1
  kretinism_1_N = mkN "kretinism" "kretinismer" ; -- kretinism..nn.1
  kretisk_1_A = mkA "kretisk" ; -- kretisk..av.1
  kretong_1_N = mkN "kretong" "kretonger" ; -- kretong..nn.1
  krets_1_N = mkN "krets" ; -- krets..nn.1
  kretsa_1_V = mkV "kretsar" ; -- kretsa..vb.1
  kretsande_1_N = mkN "kretsande" ; -- kretsande..nn.1
  kretsgång_1_N = mkN "kretsgång" ; -- kretsgång..nn.1
  kretsindelning_1_N = mkN "kretsindelning" ; -- kretsindelning..nn.1
  kretskort_1_N = mkN "kretskort" neutrum  ; -- kretskort..nn.1
  kretslopp_1_N = mkN "kretslopp" neutrum  ; -- kretslopp..nn.1
  kretsloppssamhälle_1_N = mkN "kretsloppssamhälle" ; -- kretsloppssamhälle..nn.1
  kretsloppstänkande_1_N = mkN "kretsloppstänkande" ; -- kretsloppstänkande..nn.1
  kretsning_1_N = mkN "kretsning" ; -- kretsning..nn.1
  krevad_1_N = mkN "krevad" "krevader" ; -- krevad..nn.1
  krevadblixt_1_N = mkN "krevadblixt" ; -- krevadblixt..nn.1
  krevadmoln_1_N = mkN "krevadmoln" neutrum  ; -- krevadmoln..nn.1
  krevera_1_V = mkV "kreverar" ; -- krevera..vb.1
  kreverande_1_N = mkN "kreverande" ; -- kreverande..nn.1
  kreverbar_1_A = mkA "kreverbar" ; -- kreverbar..av.1
  kreverbarhet_1_N = mkN "kreverbarhet" ; -- kreverbarhet..nn.1
  krevering_1_N = mkN "krevering" ; -- krevering..nn.1
  kria_1_N = mkN "kria" ; -- kria..nn.1
  kricka_1_N = mkN "kricka" ; -- kricka..nn.1
  kricket_1_N = mkN "kricket" ; -- kricket..nn.1
  krig_1_N = mkN "krig" neutrum  ; -- krig..nn.1
  kriga_1_V = mkV "krigar" ; -- kriga..vb.1
  krigande_1_N = mkN "krigande" ; -- krigande..nn.1
  krigaradel_1_N = mkN "krigaradel" ; -- krigaradel..nn.1
  krigaranda_1_N = mkN "krigaranda" ; -- krigaranda..nn.1
  krigare_1_N = mkN "krigare" utrum  ; -- krigare..nn.1
  krigargrav_1_N = mkN "krigargrav" ; -- krigargrav..nn.1
  krigarideal_1_N = mkN "krigarideal" neutrum  ; -- krigarideal..nn.1
  krigarkast_1_N = mkN "krigarkast" ; -- krigarkast..nn.1
  krigförande_1_A = mkA "krigförande" ; -- krigförande..av.1
  krigföring_1_N = mkN "krigföring" ; -- krigföring..nn.1
  krigisk_1_A = mkA "krigisk" ; -- krigisk..av.1
  krigsanhängare_1_N = mkN "krigsanhängare" utrum  ; -- krigsanhängare..nn.1
  krigsbarn_1_N = mkN "krigsbarn" neutrum  ; -- krigsbarn..nn.1
  krigsberedskap_1_N = mkN "krigsberedskap" "krigsberedskaper" ; -- krigsberedskap..nn.1
  krigsbrott_1_N = mkN "krigsbrott" neutrum  ; -- krigsbrott..nn.1
  krigsbrottstribunal_1_N = mkN "krigsbrottstribunal" "krigsbrottstribunaler" ; -- krigsbrottstribunal..nn.1
  krigsbuss_1_N = mkN "krigsbuss" ; -- krigsbuss..nn.1
  krigsbyte_1_N = mkN "krigsbyte" ; -- krigsbyte..nn.1
  krigsdagbok_1_N = mkN "krigsdagbok" "krigsdagböcker" ; -- krigsdagbok..nn.1
  krigsdans_1_N = mkN "krigsdans" "krigsdanser" ; -- krigsdans..nn.1
  krigsdekoration_1_N = mkN "krigsdekoration" ; -- krigsdekoration..nn.1
  krigsdiamant_1_N = mkN "krigsdiamant" "krigsdiamanter" ; -- krigsdiamant..nn.1
  krigsfartyg_1_N = mkN "krigsfartyg" neutrum  ; -- krigsfartyg..nn.1
  krigsflotta_1_N = mkN "krigsflotta" ; -- krigsflotta..nn.1
  krigsfot_1_N = mkN "krigsfot" ; -- krigsfot..nn.1
  krigsfotograf_1_N = mkN "krigsfotograf" "krigsfotografer" ; -- krigsfotograf..nn.1
  krigsfånge_1_N = mkN "krigsfånge" utrum  ; -- krigsfånge..nn.1
  krigsfångenskap_1_N = mkN "krigsfångenskap" ; -- krigsfångenskap..nn.1
  krigsförbrytare_1_N = mkN "krigsförbrytare" utrum  ; -- krigsförbrytare..nn.1
  krigsförbrytarmål_1_N = mkN "krigsförbrytarmål" neutrum  ; -- krigsförbrytarmål..nn.1
  krigsförbrytartribunal_1_N = mkN "krigsförbrytartribunal" "krigsförbrytartribunaler" ; -- krigsförbrytartribunal..nn.1
  krigsförbrytelse_1_N = mkN "krigsförbrytelse" "krigsförbrytelser" ; -- krigsförbrytelse..nn.1
  krigsförespråkare_1_N = mkN "krigsförespråkare" utrum  ; -- krigsförespråkare..nn.1
  krigsförklaring_1_N = mkN "krigsförklaring" ; -- krigsförklaring..nn.1
  krigsgud_1_N = mkN "krigsgud" ; -- krigsgud..nn.1
  krigsgudinna_1_N = mkN "krigsgudinna" ; -- krigsgudinna..nn.1
  krigsherre_1_N = mkN "krigsherre" utrum  ; -- krigsherre..nn.1
  krigshetsande_1_A = mkA "krigshetsande" ; -- krigshetsande..av.1
  krigshetsande_1_N = mkN "krigshetsande" ; -- krigshetsande..nn.1
  krigshetsare_1_N = mkN "krigshetsare" utrum  ; -- krigshetsare..nn.1
  krigshierarki_1_N = mkN "krigshierarki" "krigshierarkier" ; -- krigshierarki..nn.1
  krigshistoria_1_N = mkN "krigshistoria" "krigshistorian" "krigshistorier" "krigshistorierna" ; -- krigshistoria..nn.1
  krigshjälte_1_N = mkN "krigshjälte" utrum  ; -- krigshjälte..nn.1
  krigshärd_1_N = mkN "krigshärd" ; -- krigshärd..nn.1
  krigshärjad_1_A = mkA "krigshärjad" ; -- krigshärjad..av.1
  krigsindustri_1_N = mkN "krigsindustri" "krigsindustrier" ; -- krigsindustri..nn.1
  krigsinkallad_1_A = mkA "krigsinkallad" ; -- krigsinkallad..av.1
  krigsinsats_1_N = mkN "krigsinsats" "krigsinsatser" ; -- krigsinsats..nn.1
  krigsiver_1_N = mkN "krigsiver" ; -- krigsiver..nn.1
  krigsivrare_1_N = mkN "krigsivrare" utrum  ; -- krigsivrare..nn.1
  krigskolportör_1_N = mkN "krigskolportör" "krigskolportörer" ; -- krigskolportör..nn.1
  krigskonst_1_N = mkN "krigskonst" ; -- krigskonst..nn.1
  krigskontraband_1_N = mkN "krigskontraband" neutrum  ; -- krigskontraband..nn.1
  krigskorrespondent_1_N = mkN "krigskorrespondent" "krigskorrespondenter" ; -- krigskorrespondent..nn.1
  krigskredit_1_N = mkN "krigskredit" "krigskrediter" ; -- krigskredit..nn.1
  krigslik_1_A = mkA "krigslik" ; -- krigslik..av.1
  krigsliknande_1_A = mkA "krigsliknande" ; -- krigsliknande..av.1
  krigslist_1_N = mkN "krigslist" ; -- krigslist..nn.1
  krigslycka_1_N = mkN "krigslycka" ; -- krigslycka..nn.1
  krigsmakt_1_N = mkN "krigsmakt" "krigsmakter" ; -- krigsmakt..nn.1
  krigsman_1_N = mkN "krigsman" "krigsmannen" "krigsmän" "krigsmännen" ; -- krigsman..nn.1
  krigsmiljö_1_N = mkN "krigsmiljö" "krigsmiljön" "krigsmiljöer" "krigsmiljöerna" ; -- krigsmiljö..nn.1
  krigsminne_1_N = mkN "krigsminne" ; -- krigsminne..nn.1
  krigsmonument_1_N = mkN "krigsmonument" neutrum  ; -- krigsmonument..nn.1
  krigsmotståndare_1_N = mkN "krigsmotståndare" utrum  ; -- krigsmotståndare..nn.1
  krigsmässig_1_A = mkA "krigsmässig" ; -- krigsmässig..av.1
  krigsmålning_1_N = mkN "krigsmålning" ; -- krigsmålning..nn.1
  krigsovillig_1_A = mkA "krigsovillig" ; -- krigsovillig..av.1
  krigsplacera_1_V = mkV "krigsplacerar" ; -- krigsplacera..vb.1
  krigsplacerande_1_N = mkN "krigsplacerande" ; -- krigsplacerande..nn.1
  krigsplacerbar_1_A = mkA "krigsplacerbar" ; -- krigsplacerbar..av.1
  krigsplacerbarhet_1_N = mkN "krigsplacerbarhet" ; -- krigsplacerbarhet..nn.1
  krigsplacering_1_N = mkN "krigsplacering" ; -- krigsplacering..nn.1
  krigsprofitör_1_N = mkN "krigsprofitör" "krigsprofitörer" ; -- krigsprofitör..nn.1
  krigspropaganda_1_N = mkN "krigspropaganda" ; -- krigspropaganda..nn.1
  krigsreportage_1_N = mkN "krigsreportage" "krigsreportaget" "krigsreportage" "krigsreportagen" ; -- krigsreportage..nn.1
  krigsrisk_1_N = mkN "krigsrisk" "krigsrisker" ; -- krigsrisk..nn.1
  krigsroman_1_N = mkN "krigsroman" "krigsromaner" ; -- krigsroman..nn.1
  krigsrädd_1_A = mkA "krigsrädd" ; -- krigsrädd..av.1
  krigsrätt_1_N = mkN "krigsrätt" ; -- krigsrätt..nn.1
  krigsråd_1_N = mkN "krigsråd" neutrum  ; -- krigsråd..nn.1
  krigssjuksköterska_1_N = mkN "krigssjuksköterska" ; -- krigssjuksköterska..nn.1
  krigsskada_1_N = mkN "krigsskada" ; -- krigsskada..nn.1
  krigsskadestånd_1_N = mkN "krigsskadestånd" neutrum  ; -- krigsskadestånd..nn.1
  krigsskepp_1_N = mkN "krigsskepp" neutrum  ; -- krigsskepp..nn.1
  krigsskildring_1_N = mkN "krigsskildring" ; -- krigsskildring..nn.1
  krigsskådeplats_1_N = mkN "krigsskådeplats" "krigsskådeplatser" ; -- krigsskådeplats..nn.1
  krigsslut_1_N = mkN "krigsslut" neutrum  ; -- krigsslut..nn.1
  krigsspel_1_N = mkN "krigsspel" "krigsspelet" "krigsspel" "krigsspelen" ; -- krigsspel..nn.1
  krigstid_1_N = mkN "krigstid" "krigstider" ; -- krigstid..nn.1
  krigstida_1_A = mkA "krigstida" ; -- krigstida..av.1
  krigstillstånd_1_N = mkN "krigstillstånd" neutrum  ; -- krigstillstånd..nn.1
  krigstjänst_1_N = mkN "krigstjänst" ; -- krigstjänst..nn.1
  krigstjänstgöring_1_N = mkN "krigstjänstgöring" ; -- krigstjänstgöring..nn.1
  krigstrött_1_A = mkA "krigstrött" ; -- krigstrött..av.1
  krigströtthet_1_N = mkN "krigströtthet" ; -- krigströtthet..nn.1
  krigståg_1_N = mkN "krigståg" neutrum  ; -- krigståg..nn.1
  krigsutbrott_1_N = mkN "krigsutbrott" neutrum  ; -- krigsutbrott..nn.1
  krigsveteran_1_N = mkN "krigsveteran" "krigsveteraner" ; -- krigsveteran..nn.1
  krigsväsen_1_N = mkN "krigsväsen" neutrum  ; -- krigsväsen..nn.1
  krigszon_1_N = mkN "krigszon" "krigszoner" ; -- krigszon..nn.1
  krigsäventyr_1_N = mkN "krigsäventyr" neutrum  ; -- krigsäventyr..nn.1
  krigsår_1_N = mkN "krigsår" neutrum  ; -- krigsår..nn.1
  krikon_1_N = mkN "krikon" neutrum  ; -- krikon..nn.1
  krill_1_N = mkN "krill" ; -- krill..nn.1
  krillfiske_1_N = mkN "krillfiske" ; -- krillfiske..nn.1
  krillstim_1_N = mkN "krillstim" "krillstimmet" "krillstim" "krillstimmen" ; -- krillstim..nn.1
  krillätare_1_N = mkN "krillätare" utrum  ; -- krillätare..nn.1
  kriminalare_1_N = mkN "kriminalare" utrum  ; -- kriminalare..nn.1
  kriminaldåre_1_N = mkN "kriminaldåre" utrum  ; -- kriminaldåre..nn.1
  kriminalfall_1_N = mkN "kriminalfall" neutrum  ; -- kriminalfall..nn.1
  kriminalinspektör_1_N = mkN "kriminalinspektör" "kriminalinspektörer" ; -- kriminalinspektör..nn.1
  kriminalisera_1_V = mkV "kriminaliserar" ; -- kriminalisera..vb.1
  kriminaliserande_1_N = mkN "kriminaliserande" ; -- kriminaliserande..nn.1
  kriminaliserbar_1_A = mkA "kriminaliserbar" ; -- kriminaliserbar..av.1
  kriminaliserbarhet_1_N = mkN "kriminaliserbarhet" ; -- kriminaliserbarhet..nn.1
  kriminalisering_1_N = mkN "kriminalisering" ; -- kriminalisering..nn.1
  kriminalistik_1_N = mkN "kriminalistik" ; -- kriminalistik..nn.1
  kriminalitet_1_N = mkN "kriminalitet" "kriminaliteter" ; -- kriminalitet..nn.1
  kriminaljournalist_1_N = mkN "kriminaljournalist" "kriminaljournalister" ; -- kriminaljournalist..nn.1
  kriminaljournalistik_1_N = mkN "kriminaljournalistik" ; -- kriminaljournalistik..nn.1
  kriminalkommissarie_1_N = mkN "kriminalkommissarie" "kriminalkommissarier" ; -- kriminalkommissarie..nn.1
  kriminalpolis_1_N = mkN "kriminalpolis" ; -- kriminalpolis..nn.1
  kriminalpolis_2_N = mkN "kriminalpolis" "kriminalpoliser" ; -- kriminalpolis..nn.2
  kriminalpolitik_1_N = mkN "kriminalpolitik" ; -- kriminalpolitik..nn.1
  kriminalpolitisk_1_A = mkA "kriminalpolitisk" ; -- kriminalpolitisk..av.1
  kriminalregister_1_N = mkN "kriminalregister" neutrum  ; -- kriminalregister..nn.1
  kriminalroman_1_N = mkN "kriminalroman" "kriminalromaner" ; -- kriminalroman..nn.1
  kriminalteknik_1_N = mkN "kriminalteknik" ; -- kriminalteknik..nn.1
  kriminalteknisk_1_A = mkA "kriminalteknisk" ; -- kriminalteknisk..av.1
  kriminalvård_1_N = mkN "kriminalvård" ; -- kriminalvård..nn.1
  kriminell_1_A = mkA "kriminell" ; -- kriminell..av.1
  kriminolog_1_N = mkN "kriminolog" "kriminologer" ; -- kriminolog..nn.1
  kriminologi_1_N = mkN "kriminologi" ; -- kriminologi..nn.1
  kriminologisk_1_A = mkA "kriminologisk" ; -- kriminologisk..av.1
  krimskrams_1_N = mkN "krimskrams" neutrum  ; -- krimskrams..nn.1
  kringboende_1_A = mkA "kringboende" ; -- kringboende..av.1
  kringbyggd_1_A = mkA "kringbyggd" "kringbyggt" ; -- kringbyggd..av.1
  kringdrivande_1_A = mkA "kringdrivande" ; -- kringdrivande..av.1
  kringelikrokig_1_A = mkA "kringelikrokig" ; -- kringelikrokig..av.1
  kringelikrokighet_1_N = mkN "kringelikrokighet" "kringelikrokigheter" ; -- kringelikrokighet..nn.1
  kringelkrokig_1_A = mkA "kringelkrokig" ; -- kringelkrokig..av.1
  kringelkrokighet_1_N = mkN "kringelkrokighet" "kringelkrokigheter" ; -- kringelkrokighet..nn.1
  kringfarande_1_A = mkA "kringfarande" ; -- kringfarande..av.1
  kringflackande_1_A = mkA "kringflackande" ; -- kringflackande..av.1
  kringfluten_1_A = mkA "kringfluten" ; -- kringfluten..av.1
  kringgärda_1_V = mkV "kringgärdar" ; -- kringgärda..vb.1
  kringgärdande_1_N = mkN "kringgärdande" ; -- kringgärdande..nn.1
  kringgärdning_1_N = mkN "kringgärdning" ; -- kringgärdning..nn.1
  kringgå_1_V = mkV "kringgå" "kringgår" "kringgå" "kringgick" "kringgått" "kringgången" ; -- kringgå..vb.1
  kringgående_1_N = mkN "kringgående" ; -- kringgående..nn.1
  kringinformation_1_N = mkN "kringinformation" ; -- kringinformation..nn.1
  kringirrande_1_A = mkA "kringirrande" ; -- kringirrande..av.1
  kringkuskande_1_N = mkN "kringkuskande" ; -- kringkuskande..nn.1
  kringla_1_N = mkN "kringla" ; -- kringla..nn.1
  kringliggande_1_A = mkA "kringliggande" ; -- kringliggande..av.1
  kringresande_1_A = mkA "kringresande" ; -- kringresande..av.1
  kringränna_1_V = mkV "kringränna" "kringrände" "kringränt" ; -- kringränna..vb.1
  kringrännande_1_N = mkN "kringrännande" ; -- kringrännande..nn.1
  kringränning_1_N = mkN "kringränning" ; -- kringränning..nn.1
  kringsegling_1_N = mkN "kringsegling" ; -- kringsegling..nn.1
  kringsimmande_1_A = mkA "kringsimmande" ; -- kringsimmande..av.1
  kringsimmande_1_N = mkN "kringsimmande" ; -- kringsimmande..nn.1
  kringsjuk_1_A = mkA "kringsjuk" ; -- kringsjuk..av.1
  kringsjuka_1_N = mkN "kringsjuka" ; -- kringsjuka..nn.1
  kringskansa_1_V = mkV "kringskansar" ; -- kringskansa..vb.1
  kringskansande_1_N = mkN "kringskansande" ; -- kringskansande..nn.1
  kringskansning_1_N = mkN "kringskansning" ; -- kringskansning..nn.1
  kringskickning_1_N = mkN "kringskickning" ; -- kringskickning..nn.1
  kringskära_1_V = mkV "kringskära" "kringskar" "kringskurit" ; -- kringskära..vb.1
  kringskärande_1_N = mkN "kringskärande" ; -- kringskärande..nn.1
  kringskärning_1_N = mkN "kringskärning" ; -- kringskärning..nn.1
  kringsnack_1_N = mkN "kringsnack" neutrum  ; -- kringsnack..nn.1
  kringspridning_1_N = mkN "kringspridning" ; -- kringspridning..nn.1
  kringspringande_1_A = mkA "kringspringande" ; -- kringspringande..av.1
  kringstrykande_1_A = mkA "kringstrykande" ; -- kringstrykande..av.1
  kringstrykare_1_N = mkN "kringstrykare" utrum  ; -- kringstrykare..nn.1
  kringströ_1_V = mkV "kringströr" ; -- kringströ..vb.1
  kringströvande_1_A = mkA "kringströvande" ; -- kringströvande..av.1
  kringströvande_1_N = mkN "kringströvande" ; -- kringströvande..nn.1
  kringstående_1_A = mkA "kringstående" ; -- kringstående..av.1
  kringsvirrande_1_A = mkA "kringsvirrande" ; -- kringsvirrande..av.1
  kringsvirrande_1_N = mkN "kringsvirrande" ; -- kringsvirrande..nn.1
  kringsyn_1_N = mkN "kringsyn" ; -- kringsyn..nn.1
  kringsynt_1_A = mkA "kringsynt" "kringsynt" ; -- kringsynt..av.1
  kringsynthet_1_N = mkN "kringsynthet" ; -- kringsynthet..nn.1
  kringsändning_1_N = mkN "kringsändning" ; -- kringsändning..nn.1
  kringutrustning_1_N = mkN "kringutrustning" ; -- kringutrustning..nn.1
  kringvandrande_1_A = mkA "kringvandrande" ; -- kringvandrande..av.1
  kringvandring_1_N = mkN "kringvandring" ; -- kringvandring..nn.1
  kringväg_1_N = mkN "kringväg" ; -- kringväg..nn.1
  kringvärvd_1_A = mkA "kringvärvd" "kringvärvt" ; -- kringvärvd..av.1
  krinolin_1_N = mkN "krinolin" "krinoliner" ; -- krinolin..nn.1
  kris_1_N = mkN "kris" "kriser" ; -- kris..nn.1
  kris_2_N = mkN "kris" ; -- kris..nn.2
  krisa_1_V = mkV "krisar" ; -- krisa..vb.1
  krisande_1_N = mkN "krisande" ; -- krisande..nn.1
  krisartad_1_A = mkA "krisartad" ; -- krisartad..av.1
  krisdrabbad_1_A = mkA "krisdrabbad" ; -- krisdrabbad..av.1
  krisfond_1_N = mkN "krisfond" "krisfonder" ; -- krisfond..nn.1
  krisgrupp_1_N = mkN "krisgrupp" "krisgrupper" ; -- krisgrupp..nn.1
  krisgrå_1_A = mkA "krisgrå" "krisgrått" ; -- krisgrå..av.1
  krishanterare_1_N = mkN "krishanterare" utrum  ; -- krishanterare..nn.1
  krishantering_1_N = mkN "krishantering" ; -- krishantering..nn.1
  krishanteringsforskare_1_N = mkN "krishanteringsforskare" utrum  ; -- krishanteringsforskare..nn.1
  krishanteringsrecept_1_N = mkN "krishanteringsrecept" neutrum  ; -- krishanteringsrecept..nn.1
  krishanteringsråd_1_N = mkN "krishanteringsråd" neutrum  ; -- krishanteringsråd..nn.1
  krishjälp_1_N = mkN "krishjälp" ; -- krishjälp..nn.1
  krishushållning_1_N = mkN "krishushållning" ; -- krishushållning..nn.1
  krishärd_1_N = mkN "krishärd" ; -- krishärd..nn.1
  krisjour_1_N = mkN "krisjour" "krisjourer" ; -- krisjour..nn.1
  krismedel_1_N = mkN "krismedel" neutrum  ; -- krismedel..nn.1
  krismedvetande_1_N = mkN "krismedvetande" ; -- krismedvetande..nn.1
  krismedveten_1_A = mkA "krismedveten" ; -- krismedveten..av.1
  krismedvetenhet_1_N = mkN "krismedvetenhet" ; -- krismedvetenhet..nn.1
  krismöte_1_N = mkN "krismöte" ; -- krismöte..nn.1
  krispaket_1_N = mkN "krispaket" neutrum  ; -- krispaket..nn.1
  krispig_1_A = mkA "krispig" ; -- krispig..av.1
  krispighet_1_N = mkN "krispighet" ; -- krispighet..nn.1
  krispolitik_1_N = mkN "krispolitik" ; -- krispolitik..nn.1
  krisrykte_1_N = mkN "krisrykte" ; -- krisrykte..nn.1
  krissituation_1_N = mkN "krissituation" ; -- krissituation..nn.1
  krisstämning_1_N = mkN "krisstämning" ; -- krisstämning..nn.1
  krisstöd_1_N = mkN "krisstöd" neutrum  ; -- krisstöd..nn.1
  kristall_1_N = mkN "kristall" "kristaller" ; -- kristall..nn.1
  kristallaxel_1_N = mkN "kristallaxel" ; -- kristallaxel..nn.1
  kristallform_1_N = mkN "kristallform" "kristallformer" ; -- kristallform..nn.1
  kristallglas_1_N = mkN "kristallglas" neutrum  ; -- kristallglas..nn.1
  kristallin_1_A = mkA "kristallin" ; -- kristallin..av.1
  kristallinisk_1_A = mkA "kristallinisk" ; -- kristallinisk..av.1
  kristallins_1_N = mkN "kristallins" "kristallinser" ; -- kristallins..nn.1
  kristallisation_1_N = mkN "kristallisation" ; -- kristallisation..nn.1
  kristallisera_1_V = mkV "kristalliserar" ; -- kristallisera..vb.1
  kristalliserande_1_N = mkN "kristalliserande" ; -- kristalliserande..nn.1
  kristalliserbar_1_A = mkA "kristalliserbar" ; -- kristalliserbar..av.1
  kristalliserbarhet_1_N = mkN "kristalliserbarhet" ; -- kristalliserbarhet..nn.1
  kristallisering_1_N = mkN "kristallisering" ; -- kristallisering..nn.1
  kristallisk_1_A = mkA "kristallisk" ; -- kristallisk..av.1
  kristallklar_1_A = mkA "kristallklar" ; -- kristallklar..av.1
  kristallkrona_1_N = mkN "kristallkrona" ; -- kristallkrona..nn.1
  kristallkula_1_N = mkN "kristallkula" ; -- kristallkula..nn.1
  kristallkuletolkare_1_N = mkN "kristallkuletolkare" utrum  ; -- kristallkuletolkare..nn.1
  kristallmottagare_1_N = mkN "kristallmottagare" utrum  ; -- kristallmottagare..nn.1
  kristallmönster_1_N = mkN "kristallmönster" neutrum  ; -- kristallmönster..nn.1
  kristallografi_1_N = mkN "kristallografi" ; -- kristallografi..nn.1
  kristallografisk_1_A = mkA "kristallografisk" ; -- kristallografisk..av.1
  kristallolja_1_N = mkN "kristallolja" ; -- kristallolja..nn.1
  kristallos_1_N = mkN "kristallos" ; -- kristallos..nn.1
  kristallskål_1_N = mkN "kristallskål" ; -- kristallskål..nn.1
  kristallsystem_1_N = mkN "kristallsystem" neutrum  ; -- kristallsystem..nn.1
  kristdemokrat_1_N = mkN "kristdemokrat" "kristdemokrater" ; -- kristdemokrat..nn.1
  kristdemokratisk_1_A = mkA "kristdemokratisk" ; -- kristdemokratisk..av.1
  kristelefon_1_N = mkN "kristelefon" "kristelefoner" ; -- kristelefon..nn.1
  kristen_1_A = mkA "kristen" ; -- kristen..av.1
  kristendom_1_N = mkN "kristendom" ; -- kristendom..nn.1
  kristendomstolkning_1_N = mkN "kristendomstolkning" ; -- kristendomstolkning..nn.1
  kristendomsundervisning_1_N = mkN "kristendomsundervisning" ; -- kristendomsundervisning..nn.1
  kristenhet_1_N = mkN "kristenhet" "kristenheter" ; -- kristenhet..nn.1
  kristid_1_N = mkN "kristid" "kristider" ; -- kristid..nn.1
  kristidsföretag_1_N = mkN "kristidsföretag" neutrum  ; -- kristidsföretag..nn.1
  kristlig_1_A = mkA "kristlig" ; -- kristlig..av.1
  kristlighet_1_N = mkN "kristlighet" ; -- kristlighet..nn.1
  kristna_1_V = mkV "kristnar" ; -- kristna..vb.1
  kristnande_1_N = mkN "kristnande" ; -- kristnande..nn.1
  kristning_1_N = mkN "kristning" ; -- kristning..nn.1
  kristologi_1_N = mkN "kristologi" ; -- kristologi..nn.1
  kristologisk_1_A = mkA "kristologisk" ; -- kristologisk..av.1
  kristtorn_1_N = mkN "kristtorn" ; -- kristtorn..nn.1
  kristtrogen_1_A = mkA "kristtrogen" ; -- kristtrogen..av.1
  kristtrogenhet_1_N = mkN "kristtrogenhet" ; -- kristtrogenhet..nn.1
  kristusmonogram_1_N = mkN "kristusmonogram" "kristusmonogrammet" "kristusmonogram" "kristusmonogrammen" ; -- kristusmonogram..nn.1
  kristyr_1_N = mkN "kristyr" ; -- kristyr..nn.1
  krisåtgärd_1_N = mkN "krisåtgärd" "krisåtgärder" ; -- krisåtgärd..nn.1
  krita_1_N = mkN "krita" ; -- krita..nn.1
  krita_2_N = mkN "krita" ; -- krita..nn.2
  krita_1_V = mkV "kritar" ; -- krita..vb.1
  kritande_1_N = mkN "kritande" ; -- kritande..nn.1
  kriterium_1_N = mkN "kriterium" "kriteriet" "kriterier" "kriterierna" ; -- kriterium..nn.1
  kriticism_1_N = mkN "kriticism" "kriticismer" ; -- kriticism..nn.1
  kriticitet_1_N = mkN "kriticitet" ; -- kriticitet..nn.1
  kritig_1_A = mkA "kritig" ; -- kritig..av.1
  kritik_1_N = mkN "kritik" "kritiker" ; -- kritik..nn.1
  kritiker_1_N = mkN "kritiker" "kritikern" "kritiker" "kritikerna" ; -- kritiker..nn.1
  kritikermässig_1_A = mkA "kritikermässig" ; -- kritikermässig..av.1
  kritikerrosad_1_A = mkA "kritikerrosad" ; -- kritikerrosad..av.1
  kritiklust_1_N = mkN "kritiklust" ; -- kritiklust..nn.1
  kritiklös_1_A = mkA "kritiklös" ; -- kritiklös..av.1
  kritiklöshet_1_N = mkN "kritiklöshet" ; -- kritiklöshet..nn.1
  kritikstorm_1_N = mkN "kritikstorm" ; -- kritikstorm..nn.1
  kritisera_1_V = mkV "kritiserar" ; -- kritisera..vb.1
  kritiserande_1_N = mkN "kritiserande" ; -- kritiserande..nn.1
  kritiserbar_1_A = mkA "kritiserbar" ; -- kritiserbar..av.1
  kritiserbarhet_1_N = mkN "kritiserbarhet" ; -- kritiserbarhet..nn.1
  kritisering_1_N = mkN "kritisering" ; -- kritisering..nn.1
  kritisk_1_A = mkA "kritisk" ; -- kritisk..av.1
  kritpipa_1_N = mkN "kritpipa" ; -- kritpipa..nn.1
  kritstreck_1_N = mkN "kritstreck" neutrum  ; -- kritstreck..nn.1
  kritstrecksrandig_1_A = mkA "kritstrecksrandig" ; -- kritstrecksrandig..av.1
  kritteckning_1_N = mkN "kritteckning" ; -- kritteckning..nn.1
  kritter_1_N = mkN "kritter" neutrum  ; -- kritter..nn.1
  krittid_1_N = mkN "krittid" ; -- krittid..nn.1
  kritvit_1_A = mkA "kritvit" ; -- kritvit..av.1
  kroat_1_N = mkN "kroat" "kroater" ; -- kroat..nn.1
  kroatisk_1_A = mkA "kroatisk" ; -- kroatisk..av.1
  kroatiska_1_N = mkN "kroatiska" ; -- kroatiska..nn.1
  kroatiska_2_N = mkN "kroatiska" ; -- kroatiska..nn.2
  krock_1_N = mkN "krock" ; -- krock..nn.1
  krocka_1_V = mkV "krockar" ; -- krocka..vb.1
  krockande_1_N = mkN "krockande" ; -- krockande..nn.1
  krocket_1_N = mkN "krocket" ; -- krocket..nn.1
  krockkudde_1_N = mkN "krockkudde" utrum  ; -- krockkudde..nn.1
  krockskadad_1_A = mkA "krockskadad" ; -- krockskadad..av.1
  krog_1_N = mkN "krog" ; -- krog..nn.1
  krogbesök_1_N = mkN "krogbesök" neutrum  ; -- krogbesök..nn.1
  krogkund_1_N = mkN "krogkund" "krogkunder" ; -- krogkund..nn.1
  krogliv_1_N = mkN "krogliv" neutrum  ; -- krogliv..nn.1
  krogrecension_1_N = mkN "krogrecension" ; -- krogrecension..nn.1
  krogrond_1_N = mkN "krogrond" "krogronder" ; -- krogrond..nn.1
  krogronda_1_N = mkN "krogronda" ; -- krogronda..nn.1
  krogrunda_1_N = mkN "krogrunda" ; -- krogrunda..nn.1
  krogsamtal_1_N = mkN "krogsamtal" neutrum  ; -- krogsamtal..nn.1
  krogshow_1_N = mkN "krogshow" "krogshower" ; -- krogshow..nn.1
  krogsorl_1_N = mkN "krogsorl" neutrum  ; -- krogsorl..nn.1
  krogsväng_1_N = mkN "krogsväng" ; -- krogsväng..nn.1
  krogvakt_1_N = mkN "krogvakt" "krogvakter" ; -- krogvakt..nn.1
  krok_1_N = mkN "krok" ; -- krok..nn.1
  kroka_1_V = mkV "krokar" ; -- kroka..vb.1
  krokan_1_N = mkN "krokan" "krokaner" ; -- krokan..nn.1
  krokande_1_N = mkN "krokande" ; -- krokande..nn.1
  krokant_1_N = mkN "krokant" ; -- krokant..nn.1
  krokanutsirad_1_A = mkA "krokanutsirad" ; -- krokanutsirad..av.1
  krokbent_1_A = mkA "krokbent" "krokbent" ; -- krokbent..av.1
  krokett_1_N = mkN "krokett" "kroketter" ; -- krokett..nn.1
  kroki_1_N = mkN "kroki" "krokier" ; -- kroki..nn.1
  krokig_1_A = mkA "krokig" ; -- krokig..av.1
  krokighet_1_N = mkN "krokighet" "krokigheter" ; -- krokighet..nn.1
  kroklinje_1_N = mkN "kroklinje" "kroklinjer" ; -- kroklinje..nn.1
  krokna_1_V = mkV "kroknar" ; -- krokna..vb.1
  kroknande_1_N = mkN "kroknande" ; -- kroknande..nn.1
  kroknäsa_1_N = mkN "kroknäsa" ; -- kroknäsa..nn.1
  kroknäst_1_A = mkA "kroknäst" "kroknäst" ; -- kroknäst..av.1
  kroknästhet_1_N = mkN "kroknästhet" ; -- kroknästhet..nn.1
  krokodil_1_N = mkN "krokodil" "krokodiler" ; -- krokodil..nn.1
  krokodilmönstrad_1_A = mkA "krokodilmönstrad" ; -- krokodilmönstrad..av.1
  krokodilskinn_1_N = mkN "krokodilskinn" neutrum  ; -- krokodilskinn..nn.1
  krokryggig_1_A = mkA "krokryggig" ; -- krokryggig..av.1
  krokryggighet_1_N = mkN "krokryggighet" ; -- krokryggighet..nn.1
  kroksabel_1_N = mkN "kroksabel" ; -- kroksabel..nn.1
  krokus_1_N = mkN "krokus" ; -- krokus..nn.1
  krokvuxen_1_A = mkA "krokvuxen" ; -- krokvuxen..av.1
  krokvuxenhet_1_N = mkN "krokvuxenhet" ; -- krokvuxenhet..nn.1
  krokväg_1_N = mkN "krokväg" ; -- krokväg..nn.1
  krollsplint_1_N = mkN "krollsplint" ; -- krollsplint..nn.1
  krom_1_N = mkN "krom" ; -- krom..nn.1
  kroma_1_V = mkV "kromar" ; -- kroma..vb.1
  kromande_1_N = mkN "kromande" ; -- kromande..nn.1
  kromat_1_N = mkN "kromat" neutrum  ; -- kromat..nn.1
  kromatik_1_N = mkN "kromatik" ; -- kromatik..nn.1
  kromatisk_1_A = mkA "kromatisk" ; -- kromatisk..av.1
  kromdetalj_1_N = mkN "kromdetalj" "kromdetaljer" ; -- kromdetalj..nn.1
  kromgarva_1_V = mkV "kromgarvar" ; -- kromgarva..vb.1
  kromgarvande_1_N = mkN "kromgarvande" ; -- kromgarvande..nn.1
  kromgult_1_N = mkN "kromgult" ; -- kromgult..nn.1
  kromlist_1_N = mkN "kromlist" "kromlister" ; -- kromlist..nn.1
  kromläder_1_N = mkN "kromläder" neutrum  ; -- kromläder..nn.1
  kromning_1_N = mkN "kromning" ; -- kromning..nn.1
  kromolitografi_1_N = mkN "kromolitografi" "kromolitografier" ; -- kromolitografi..nn.1
  kromosom_1_N = mkN "kromosom" "kromosomer" ; -- kromosom..nn.1
  kromosomavvikelse_1_N = mkN "kromosomavvikelse" "kromosomavvikelser" ; -- kromosomavvikelse..nn.1
  kromosompar_1_N = mkN "kromosompar" neutrum  ; -- kromosompar..nn.1
  kromosomuppsättning_1_N = mkN "kromosomuppsättning" ; -- kromosomuppsättning..nn.1
  kromsyra_1_N = mkN "kromsyra" ; -- kromsyra..nn.1
  krona_1_N = mkN "krona" ; -- krona..nn.1
  kronbjudning_1_N = mkN "kronbjudning" ; -- kronbjudning..nn.1
  kronblad_1_N = mkN "kronblad" neutrum  ; -- kronblad..nn.1
  kronbrud_1_N = mkN "kronbrud" ; -- kronbrud..nn.1
  krondike_1_N = mkN "krondike" ; -- krondike..nn.1
  kronhjort_1_N = mkN "kronhjort" ; -- kronhjort..nn.1
  kronhäst_1_N = mkN "kronhäst" ; -- kronhäst..nn.1
  kroniker_1_N = mkN "kroniker" "kronikern" "kroniker" "kronikerna" ; -- kroniker..nn.1
  kronikerhem_1_N = mkN "kronikerhem" "kronikerhemmet" "kronikerhem" "kronikerhemmen" ; -- kronikerhem..nn.1
  kronisk_1_A = mkA "kronisk" ; -- kronisk..av.1
  kronjurist_1_N = mkN "kronjurist" "kronjurister" ; -- kronjurist..nn.1
  kronjuvel_1_N = mkN "kronjuvel" "kronjuveler" ; -- kronjuvel..nn.1
  kronkoloni_1_N = mkN "kronkoloni" "kronkolonier" ; -- kronkoloni..nn.1
  kronljus_1_N = mkN "kronljus" neutrum  ; -- kronljus..nn.1
  kronmutter_1_N = mkN "kronmutter" ; -- kronmutter..nn.1
  kronoarrendator_1_N = mkN "kronoarrendator" "kronoarrendatorer" ; -- kronoarrendator..nn.1
  kronobonde_1_N = mkN "kronobonde" "kronobönder" ; -- kronobonde..nn.1
  kronofogde_1_N = mkN "kronofogde" utrum  ; -- kronofogde..nn.1
  kronofogdemyndighet_1_N = mkN "kronofogdemyndighet" "kronofogdemyndigheter" ; -- kronofogdemyndighet..nn.1
  kronohemman_1_N = mkN "kronohemman" neutrum  ; -- kronohemman..nn.1
  kronojord_1_N = mkN "kronojord" ; -- kronojord..nn.1
  kronojägare_1_N = mkN "kronojägare" utrum  ; -- kronojägare..nn.1
  kronologi_1_N = mkN "kronologi" "kronologier" ; -- kronologi..nn.1
  kronologisk_1_A = mkA "kronologisk" ; -- kronologisk..av.1
  kronometer_1_N = mkN "kronometer" ; -- kronometer..nn.1
  kronopark_1_N = mkN "kronopark" "kronoparker" ; -- kronopark..nn.1
  kronoutskyld_1_N = mkN "kronoutskyld" "kronoutskylder" ; -- kronoutskyld..nn.1
  kronprins_1_N = mkN "kronprins" ; -- kronprins..nn.1
  kronprinsessa_1_N = mkN "kronprinsessa" ; -- kronprinsessa..nn.1
  kronprinsessbröllop_1_N = mkN "kronprinsessbröllop" neutrum  ; -- kronprinsessbröllop..nn.1
  krontal_1_N = mkN "krontal" neutrum  ; -- krontal..nn.1
  kronvittne_1_N = mkN "kronvittne" ; -- kronvittne..nn.1
  kronvrak_1_N = mkN "kronvrak" neutrum  ; -- kronvrak..nn.1
  kronärtskocka_1_N = mkN "kronärtskocka" ; -- kronärtskocka..nn.1
  kronärtskocksbotten_1_N = mkN "kronärtskocksbotten" ; -- kronärtskocksbotten..nn.1
  kropp_1_N = mkN "kropp" ; -- kropp..nn.1
  kroppkaka_1_N = mkN "kroppkaka" ; -- kroppkaka..nn.1
  kroppsaga_1_N = mkN "kroppsaga" ; -- kroppsaga..nn.1
  kroppsarbeta_1_V = mkV "kroppsarbetar" ; -- kroppsarbeta..vb.1
  kroppsarbetande_1_N = mkN "kroppsarbetande" ; -- kroppsarbetande..nn.1
  kroppsarbetare_1_N = mkN "kroppsarbetare" utrum  ; -- kroppsarbetare..nn.1
  kroppsarbete_1_N = mkN "kroppsarbete" ; -- kroppsarbete..nn.1
  kroppsbehåring_1_N = mkN "kroppsbehåring" ; -- kroppsbehåring..nn.1
  kroppsbeskaffenhet_1_N = mkN "kroppsbeskaffenhet" "kroppsbeskaffenheter" ; -- kroppsbeskaffenhet..nn.1
  kroppsbild_1_N = mkN "kroppsbild" "kroppsbilder" ; -- kroppsbild..nn.1
  kroppsbildning_1_N = mkN "kroppsbildning" ; -- kroppsbildning..nn.1
  kroppsbomb_1_N = mkN "kroppsbomb" "kroppsbomber" ; -- kroppsbomb..nn.1
  kroppsbyggande_1_N = mkN "kroppsbyggande" ; -- kroppsbyggande..nn.1
  kroppsbyggare_1_N = mkN "kroppsbyggare" utrum  ; -- kroppsbyggare..nn.1
  kroppsbyggnad_1_N = mkN "kroppsbyggnad" "kroppsbyggnader" ; -- kroppsbyggnad..nn.1
  kroppscell_1_N = mkN "kroppscell" "kroppsceller" ; -- kroppscell..nn.1
  kroppsdel_1_N = mkN "kroppsdel" "kroppsdelen" "kroppsdelar" "kroppsdelarna" ; -- kroppsdel..nn.1
  kroppsegen_1_A = mkA "kroppsegen" ; -- kroppsegen..av.1
  kroppsfett_1_N = mkN "kroppsfett" "kroppsfettet" "kroppsfetter" "kroppsfetterna" ; -- kroppsfett..nn.1
  kroppsfixerad_1_A = mkA "kroppsfixerad" ; -- kroppsfixerad..av.1
  kroppsfixering_1_N = mkN "kroppsfixering" ; -- kroppsfixering..nn.1
  kroppsform_1_N = mkN "kroppsform" "kroppsformer" ; -- kroppsform..nn.1
  kroppsfunktion_1_N = mkN "kroppsfunktion" ; -- kroppsfunktion..nn.1
  kroppsfynd_1_N = mkN "kroppsfynd" neutrum  ; -- kroppsfynd..nn.1
  kroppsförakt_1_N = mkN "kroppsförakt" neutrum  ; -- kroppsförakt..nn.1
  kroppshydda_1_N = mkN "kroppshydda" ; -- kroppshydda..nn.1
  kroppshår_1_N = mkN "kroppshår" neutrum  ; -- kroppshår..nn.1
  kroppshår_2_N = mkN "kroppshår" neutrum  ; -- kroppshår..nn.2
  kroppskanal_1_N = mkN "kroppskanal" "kroppskanaler" ; -- kroppskanal..nn.1
  kroppskonstitution_1_N = mkN "kroppskonstitution" ; -- kroppskonstitution..nn.1
  kroppskontakt_1_N = mkN "kroppskontakt" ; -- kroppskontakt..nn.1
  kroppskontroll_1_N = mkN "kroppskontroll" ; -- kroppskontroll..nn.1
  kroppskraft_1_N = mkN "kroppskraft" "kroppskrafter" ; -- kroppskraft..nn.1
  kroppskultur_1_N = mkN "kroppskultur" ; -- kroppskultur..nn.1
  kroppslig_1_A = mkA "kroppslig" ; -- kroppslig..av.1
  kroppsligen_1_Adv = mkAdv "kroppsligen" ; -- kroppsligen..ab.1
  kroppslighet_1_N = mkN "kroppslighet" "kroppsligheter" ; -- kroppslighet..nn.1
  kroppslighet_2_N = mkN "kroppslighet" ; -- kroppslighet..nn.2
  kroppslukt_1_N = mkN "kroppslukt" ; -- kroppslukt..nn.1
  kroppslus_1_N = mkN "kroppslus" "kroppslusen" "kroppslöss" "kroppslössen" ; -- kroppslus..nn.1
  kroppslängd_1_N = mkN "kroppslängd" "kroppslängder" ; -- kroppslängd..nn.1
  kroppsminne_1_N = mkN "kroppsminne" ; -- kroppsminne..nn.1
  kroppsmodifikation_1_N = mkN "kroppsmodifikation" ; -- kroppsmodifikation..nn.1
  kroppsmodifikationsmässa_1_N = mkN "kroppsmodifikationsmässa" ; -- kroppsmodifikationsmässa..nn.1
  kroppsnära_1_A = mkA "kroppsnära" ; -- kroppsnära..av.1
  kroppsorgan_1_N = mkN "kroppsorgan" neutrum  ; -- kroppsorgan..nn.1
  kroppspulsåder_1_N = mkN "kroppspulsåder" ; -- kroppspulsåder..nn.1
  kroppsrörelse_1_N = mkN "kroppsrörelse" "kroppsrörelser" ; -- kroppsrörelse..nn.1
  kroppsskada_1_N = mkN "kroppsskada" ; -- kroppsskada..nn.1
  kroppsskanner_1_N = mkN "kroppsskanner" ; -- kroppsskanner..nn.1
  kroppsspråk_1_N = mkN "kroppsspråk" neutrum  ; -- kroppsspråk..nn.1
  kroppsspråksexpert_1_N = mkN "kroppsspråksexpert" "kroppsspråksexperter" ; -- kroppsspråksexpert..nn.1
  kroppsstorlek_1_N = mkN "kroppsstorlek" ; -- kroppsstorlek..nn.1
  kroppsstraff_1_N = mkN "kroppsstraff" neutrum  ; -- kroppsstraff..nn.1
  kroppsstrumpa_1_N = mkN "kroppsstrumpa" ; -- kroppsstrumpa..nn.1
  kroppsstyrka_1_N = mkN "kroppsstyrka" ; -- kroppsstyrka..nn.1
  kroppsställning_1_N = mkN "kroppsställning" ; -- kroppsställning..nn.1
  kroppstemperatur_1_N = mkN "kroppstemperatur" "kroppstemperaturer" ; -- kroppstemperatur..nn.1
  kroppstyngd_1_N = mkN "kroppstyngd" ; -- kroppstyngd..nn.1
  kroppsvikt_1_N = mkN "kroppsvikt" "kroppsvikter" ; -- kroppsvikt..nn.1
  kroppsvisitation_1_N = mkN "kroppsvisitation" ; -- kroppsvisitation..nn.1
  kroppsvisitera_1_V = mkV "kroppsvisiterar" ; -- kroppsvisitera..vb.1
  kroppsvisiterande_1_N = mkN "kroppsvisiterande" ; -- kroppsvisiterande..nn.1
  kroppsvisiterbar_1_A = mkA "kroppsvisiterbar" ; -- kroppsvisiterbar..av.1
  kroppsvisiterbarhet_1_N = mkN "kroppsvisiterbarhet" ; -- kroppsvisiterbarhet..nn.1
  kroppsvisitering_1_N = mkN "kroppsvisitering" ; -- kroppsvisitering..nn.1
  kroppsvärme_1_N = mkN "kroppsvärme" utrum  ; -- kroppsvärme..nn.1
  kroppsvätska_1_N = mkN "kroppsvätska" ; -- kroppsvätska..nn.1
  kroppsvävnad_1_N = mkN "kroppsvävnad" "kroppsvävnader" ; -- kroppsvävnad..nn.1
  kroppsöppning_1_N = mkN "kroppsöppning" ; -- kroppsöppning..nn.1
  kroppsövning_1_N = mkN "kroppsövning" ; -- kroppsövning..nn.1
  kroppås_1_N = mkN "kroppås" ; -- kroppås..nn.1
  kross_1_N = mkN "kross" ; -- kross..nn.1
  kross_2_N = mkN "kross" neutrum  ; -- kross..nn.2
  krossa_1_V = mkV "krossar" ; -- krossa..vb.1
  krossande_1_N = mkN "krossande" ; -- krossande..nn.1
  krossfri_1_A = mkA "krossfri" "krossfritt" ; -- krossfri..av.1
  krosskada_1_N = mkN "krosskada" ; -- krosskada..nn.1
  krossmaskin_1_N = mkN "krossmaskin" "krossmaskiner" ; -- krossmaskin..nn.1
  krossning_1_N = mkN "krossning" ; -- krossning..nn.1
  krossår_1_N = mkN "krossår" neutrum  ; -- krossår..nn.1
  krubb_1_N = mkN "krubb" neutrum  ; -- krubb..nn.1
  krubba_1_N = mkN "krubba" ; -- krubba..nn.1
  krubba_1_V = mkV "krubbar" ; -- krubba..vb.1
  krubbande_1_N = mkN "krubbande" ; -- krubbande..nn.1
  krubbitare_1_N = mkN "krubbitare" utrum  ; -- krubbitare..nn.1
  krucifix_1_N = mkN "krucifix" neutrum  ; -- krucifix..nn.1
  kruka_1_N = mkN "kruka" ; -- kruka..nn.1
  krukgods_1_N = mkN "krukgods" neutrum  ; -- krukgods..nn.1
  krukmakare_1_N = mkN "krukmakare" utrum  ; -- krukmakare..nn.1
  krukmakeri_1_N = mkN "krukmakeri" "krukmakeriet" "krukmakerier" "krukmakerierna" ; -- krukmakeri..nn.1
  krukskärva_1_N = mkN "krukskärva" ; -- krukskärva..nn.1
  krukväxt_1_N = mkN "krukväxt" "krukväxter" ; -- krukväxt..nn.1
  krull_1_N = mkN "krull" neutrum  ; -- krull..nn.1
  krulla_1_V = mkV "krullar" ; -- krulla..vb.1
  krullande_1_N = mkN "krullande" ; -- krullande..nn.1
  krullhår_1_N = mkN "krullhår" neutrum  ; -- krullhår..nn.1
  krullhårig_1_A = mkA "krullhårig" ; -- krullhårig..av.1
  krullhårighet_1_N = mkN "krullhårighet" ; -- krullhårighet..nn.1
  krullig_1_A = mkA "krullig" ; -- krullig..av.1
  krullighet_1_N = mkN "krullighet" ; -- krullighet..nn.1
  krum_1_A = mkA "krum" "krumt" "krumma" "krumma" "krummare" "krummast" "krummaste" ; -- krum..av.1
  krumbukt_1_N = mkN "krumbukt" "krumbukter" ; -- krumbukt..nn.1
  krumbukta_1_V = mkV "krumbuktar" ; -- krumbukta..vb.1
  krumbuktande_1_N = mkN "krumbuktande" ; -- krumbuktande..nn.1
  krumelur_1_N = mkN "krumelur" "krumelurer" ; -- krumelur..nn.1
  krumhet_1_N = mkN "krumhet" ; -- krumhet..nn.1
  krumhorn_1_N = mkN "krumhorn" neutrum  ; -- krumhorn..nn.1
  krumpen_1_A = mkA "krumpen" ; -- krumpen..av.1
  krumpenhet_1_N = mkN "krumpenhet" ; -- krumpenhet..nn.1
  krumsprång_1_N = mkN "krumsprång" neutrum  ; -- krumsprång..nn.1
  krumstav_1_N = mkN "krumstav" ; -- krumstav..nn.1
  krupp_1_N = mkN "krupp" ; -- krupp..nn.1
  krus_1_N = mkN "krus" neutrum  ; -- krus..nn.1
  krus_2_N = mkN "krus" neutrum  ; -- krus..nn.2
  krusa_1_V = mkV "krusar" ; -- krusa..vb.1
  krusande_1_N = mkN "krusande" ; -- krusande..nn.1
  krusbär_1_N = mkN "krusbär" neutrum  ; -- krusbär..nn.1
  krusbärsbuske_1_N = mkN "krusbärsbuske" utrum  ; -- krusbärsbuske..nn.1
  kruserlig_1_A = mkA "kruserlig" ; -- kruserlig..av.1
  kruserlighet_1_N = mkN "kruserlighet" ; -- kruserlighet..nn.1
  krushårig_1_A = mkA "krushårig" ; -- krushårig..av.1
  krushårighet_1_N = mkN "krushårighet" ; -- krushårighet..nn.1
  krusidull_1_N = mkN "krusidull" "krusiduller" ; -- krusidull..nn.1
  krusidullig_1_A = mkA "krusidullig" ; -- krusidullig..av.1
  krusidullighet_1_N = mkN "krusidullighet" ; -- krusidullighet..nn.1
  krusig_1_A = mkA "krusig" ; -- krusig..av.1
  kruska_1_N = mkN "kruska" ; -- kruska..nn.1
  kruskål_1_N = mkN "kruskål" ; -- kruskål..nn.1
  krusmynta_1_N = mkN "krusmynta" ; -- krusmynta..nn.1
  krusning_1_N = mkN "krusning" ; -- krusning..nn.1
  kruspersilja_1_N = mkN "kruspersilja" ; -- kruspersilja..nn.1
  krusta_1_N = mkN "krusta" ; -- krusta..nn.1
  krustad_1_N = mkN "krustad" "krustader" ; -- krustad..nn.1
  krustång_1_N = mkN "krustång" "krustänger" ; -- krustång..nn.1
  kruståtel_1_N = mkN "kruståtel" ; -- kruståtel..nn.1
  krut_1_N = mkN "krut" neutrum  ; -- krut..nn.1
  krutdurk_1_N = mkN "krutdurk" ; -- krutdurk..nn.1
  krutgas_1_N = mkN "krutgas" "krutgaser" ; -- krutgas..nn.1
  krutgubbe_1_N = mkN "krutgubbe" utrum  ; -- krutgubbe..nn.1
  krutgumma_1_N = mkN "krutgumma" ; -- krutgumma..nn.1
  kruthorn_1_N = mkN "kruthorn" neutrum  ; -- kruthorn..nn.1
  krutkorn_1_N = mkN "krutkorn" neutrum  ; -- krutkorn..nn.1
  krutkäring_1_N = mkN "krutkäring" ; -- krutkäring..nn.1
  krutkärring_1_N = mkN "krutkärring" ; -- krutkärring..nn.1
  krutmotor_1_N = mkN "krutmotor" "krutmotorer" ; -- krutmotor..nn.1
  krutong_1_N = mkN "krutong" "krutonger" ; -- krutong..nn.1
  krutrök_1_N = mkN "krutrök" ; -- krutrök..nn.1
  krutsort_1_N = mkN "krutsort" "krutsorter" ; -- krutsort..nn.1
  krutstänk_1_N = mkN "krutstänk" neutrum  ; -- krutstänk..nn.1
  krutstänkt_1_A = mkA "krutstänkt" "krutstänkt" ; -- krutstänkt..av.1
  krutsvärtad_1_A = mkA "krutsvärtad" ; -- krutsvärtad..av.1
  kruttorr_1_A = mkA "kruttorr" ; -- kruttorr..av.1
  kruttorrhet_1_N = mkN "kruttorrhet" ; -- kruttorrhet..nn.1
  krux_1_N = mkN "krux" neutrum  ; -- krux..nn.1
  kry_1_A = mkA "kry" "krytt" ; -- kry..av.1
  krycka_1_N = mkN "krycka" ; -- krycka..nn.1
  kryckeståt_1_N = mkN "kryckeståt" ; -- kryckeståt..nn.1
  kryckig_1_A = mkA "kryckig" ; -- kryckig..av.1
  kryckighet_1_N = mkN "kryckighet" ; -- kryckighet..nn.1
  krydda_1_N = mkN "krydda" ; -- krydda..nn.1
  krydda_2_N = mkN "krydda" ; -- krydda..nn.2
  krydda_1_V = mkV "kryddar" ; -- krydda..vb.1
  kryddande_1_N = mkN "kryddande" ; -- kryddande..nn.1
  kryddbod_1_N = mkN "kryddbod" ; -- kryddbod..nn.1
  kryddbrun_1_A = mkA "kryddbrun" ; -- kryddbrun..av.1
  kryddbukett_1_N = mkN "kryddbukett" "kryddbuketter" ; -- kryddbukett..nn.1
  kryddgrönsak_1_N = mkN "kryddgrönsak" "kryddgrönsaker" ; -- kryddgrönsak..nn.1
  kryddgrönt_1_N = mkN "kryddgrönt" ; -- kryddgrönt..nn.1
  kryddig_1_A = mkA "kryddig" ; -- kryddig..av.1
  kryddkrasse_1_N = mkN "kryddkrasse" utrum  ; -- kryddkrasse..nn.1
  kryddnejlika_1_N = mkN "kryddnejlika" ; -- kryddnejlika..nn.1
  kryddning_1_N = mkN "kryddning" ; -- kryddning..nn.1
  kryddsalt_1_N = mkN "kryddsalt" neutrum  ; -- kryddsalt..nn.1
  kryddsmak_1_N = mkN "kryddsmak" "kryddsmaker" ; -- kryddsmak..nn.1
  kryddstark_1_A = mkA "kryddstark" ; -- kryddstark..av.1
  kryddsås_1_N = mkN "kryddsås" "kryddsåser" ; -- kryddsås..nn.1
  kryddväxt_1_N = mkN "kryddväxt" "kryddväxter" ; -- kryddväxt..nn.1
  kryddört_1_N = mkN "kryddört" "kryddörter" ; -- kryddört..nn.1
  kryhet_1_N = mkN "kryhet" ; -- kryhet..nn.1
  krylla_1_V = mkV "kryllar" ; -- krylla..vb.1
  kryllande_1_N = mkN "kryllande" ; -- kryllande..nn.1
  krympa_1_V = mkV "krymper" ; -- krympa..vb.1
  krympande_1_N = mkN "krympande" ; -- krympande..nn.1
  krympbehandlad_1_A = mkA "krympbehandlad" ; -- krympbehandlad..av.1
  krympfilm_1_N = mkN "krympfilm" "krympfilmer" ; -- krympfilm..nn.1
  krympfri_1_A = mkA "krympfri" "krympfritt" ; -- krympfri..av.1
  krympling_1_N = mkN "krympling" ; -- krympling..nn.1
  krympmån_1_N = mkN "krympmån" "krympmåner" ; -- krympmån..nn.1
  krympning_1_N = mkN "krympning" ; -- krympning..nn.1
  kryogen_1_A = mkA "kryogen" "kryogent" ; -- kryogen..av.1
  kryolit_1_N = mkN "kryolit" ; -- kryolit..nn.1
  kryostat_1_N = mkN "kryostat" "kryostater" ; -- kryostat..nn.1
  kryoteknik_1_N = mkN "kryoteknik" "kryotekniker" ; -- kryoteknik..nn.1
  kryp_1_N = mkN "kryp" neutrum  ; -- kryp..nn.1
  krypa_1_V = mkV "krypa" "kröp" "krupit" ; -- krypa..vb.1
  krypande_1_N = mkN "krypande" ; -- krypande..nn.1
  krypare_1_N = mkN "krypare" utrum  ; -- krypare..nn.1
  kryperi_1_N = mkN "kryperi" "kryperiet" "kryperier" "kryperierna" ; -- kryperi..nn.1
  krypfil_1_N = mkN "krypfil" "krypfiler" ; -- krypfil..nn.1
  kryphål_1_N = mkN "kryphål" neutrum  ; -- kryphål..nn.1
  kryphållfasthet_1_N = mkN "kryphållfasthet" "kryphållfastheter" ; -- kryphållfasthet..nn.1
  krypin_1_N = mkN "krypin" neutrum  ; -- krypin..nn.1
  krypköra_1_V = mkV "krypköra" "krypkörde" "krypkört" ; -- krypköra..vb.1
  krypkörande_1_N = mkN "krypkörande" ; -- krypkörande..nn.1
  krypskytt_1_N = mkN "krypskytt" ; -- krypskytt..nn.1
  krypskytte_1_N = mkN "krypskytte" ; -- krypskytte..nn.1
  krypta_1_N = mkN "krypta" ; -- krypta..nn.1
  kryptera_1_V = mkV "krypterar" ; -- kryptera..vb.1
  krypterande_1_N = mkN "krypterande" ; -- krypterande..nn.1
  krypterbar_1_A = mkA "krypterbar" ; -- krypterbar..av.1
  krypterbarhet_1_N = mkN "krypterbarhet" ; -- krypterbarhet..nn.1
  kryptering_1_N = mkN "kryptering" ; -- kryptering..nn.1
  kryptisk_1_A = mkA "kryptisk" ; -- kryptisk..av.1
  krypto_1_N = mkN "krypto" "kryptot" "krypton" "kryptona" ; -- krypto..nn.1
  kryptofascist_1_N = mkN "kryptofascist" "kryptofascister" ; -- kryptofascist..nn.1
  kryptogam_1_A = mkA "kryptogam" ; -- kryptogam..av.1
  kryptogam_1_N = mkN "kryptogam" "kryptogamer" ; -- kryptogam..nn.1
  kryptogamflora_1_N = mkN "kryptogamflora" ; -- kryptogamflora..nn.1
  kryptografi_1_N = mkN "kryptografi" ; -- kryptografi..nn.1
  kryptografisk_1_A = mkA "kryptografisk" ; -- kryptografisk..av.1
  kryptogram_1_N = mkN "kryptogram" "kryptogrammet" "kryptogram" "kryptogrammen" ; -- kryptogram..nn.1
  krypton_1_N = mkN "krypton" ; -- krypton..nn.1
  kryptonazist_1_N = mkN "kryptonazist" "kryptonazister" ; -- kryptonazist..nn.1
  krysantem_1_N = mkN "krysantem" "krysantemer" ; -- krysantem..nn.1
  krysantemum_1_N = mkN "krysantemum" ; -- krysantemum..nn.1
  krysantemumplanta_1_N = mkN "krysantemumplanta" ; -- krysantemumplanta..nn.1
  krysolit_1_N = mkN "krysolit" "krysoliter" ; -- krysolit..nn.1
  krysopras_1_N = mkN "krysopras" "krysopraser" ; -- krysopras..nn.1
  kryss_1_N = mkN "kryss" neutrum  ; -- kryss..nn.1
  kryss_2_N = mkN "kryss" ; -- kryss..nn.2
  kryssa_1_V = mkV "kryssar" ; -- kryssa..vb.1
  kryssa_2_V = mkV "kryssar" ; -- kryssa..vb.2
  kryssande_1_N = mkN "kryssande" ; -- kryssande..nn.1
  kryssare_1_N = mkN "kryssare" utrum  ; -- kryssare..nn.1
  kryssförband_1_N = mkN "kryssförband" neutrum  ; -- kryssförband..nn.1
  krysshult_1_N = mkN "krysshult" ; -- krysshult..nn.1
  kryssmast_1_N = mkN "kryssmast" "kryssmaster" ; -- kryssmast..nn.1
  kryssmejsel_1_N = mkN "kryssmejsel" ; -- kryssmejsel..nn.1
  kryssmässig_1_A = mkA "kryssmässig" ; -- kryssmässig..av.1
  kryssning_1_N = mkN "kryssning" ; -- kryssning..nn.1
  kryssningsdestination_1_N = mkN "kryssningsdestination" ; -- kryssningsdestination..nn.1
  kryssningsfartyg_1_N = mkN "kryssningsfartyg" neutrum  ; -- kryssningsfartyg..nn.1
  kryssningsmissil_1_N = mkN "kryssningsmissil" "kryssningsmissiler" ; -- kryssningsmissil..nn.1
  kryssningsraket_1_N = mkN "kryssningsraket" "kryssningsraketer" ; -- kryssningsraket..nn.1
  kryssningsrobot_1_N = mkN "kryssningsrobot" ; -- kryssningsrobot..nn.1
  kryssröst_1_N = mkN "kryssröst" "kryssröster" ; -- kryssröst..nn.1
  kryssröstning_1_N = mkN "kryssröstning" ; -- kryssröstning..nn.1
  krysstag_1_N = mkN "krysstag" neutrum  ; -- krysstag..nn.1
  kryssvalv_1_N = mkN "kryssvalv" neutrum  ; -- kryssvalv..nn.1
  krysta_1_V = mkV "krystar" ; -- krysta..vb.1
  krystad_1_A = mkA "krystad" ; -- krystad..av.1
  krystande_1_N = mkN "krystande" ; -- krystande..nn.1
  krystning_1_N = mkN "krystning" ; -- krystning..nn.1
  krystvärk_1_N = mkN "krystvärk" ; -- krystvärk..nn.1
  kräckla_1_N = mkN "kräckla" ; -- kräckla..nn.1
  kräfta_1_N = mkN "kräfta" ; -- kräfta..nn.1
  kräfta_2_N = mkN "kräfta" ; -- kräfta..nn.2
  kräftbur_1_N = mkN "kräftbur" ; -- kräftbur..nn.1
  kräftdjur_1_N = mkN "kräftdjur" neutrum  ; -- kräftdjur..nn.1
  kräftfångst_1_N = mkN "kräftfångst" "kräftfångster" ; -- kräftfångst..nn.1
  kräftgång_1_N = mkN "kräftgång" ; -- kräftgång..nn.1
  kräftkalas_1_N = mkN "kräftkalas" neutrum  ; -- kräftkalas..nn.1
  kräftpest_1_N = mkN "kräftpest" ; -- kräftpest..nn.1
  kräftpremiär_1_N = mkN "kräftpremiär" "kräftpremiärer" ; -- kräftpremiär..nn.1
  kräftskiva_1_N = mkN "kräftskiva" ; -- kräftskiva..nn.1
  kräftsmör_1_N = mkN "kräftsmör" neutrum  ; -- kräftsmör..nn.1
  kräftstjärt_1_N = mkN "kräftstjärt" ; -- kräftstjärt..nn.1
  kräftsvulst_1_N = mkN "kräftsvulst" "kräftsvulster" ; -- kräftsvulst..nn.1
  kräftsäsong_1_N = mkN "kräftsäsong" "kräftsäsonger" ; -- kräftsäsong..nn.1
  kräk_1_N = mkN "kräk" neutrum  ; -- kräk..nn.1
  kräkfärdig_1_A = mkA "kräkfärdig" ; -- kräkfärdig..av.1
  kräkfärdighet_1_N = mkN "kräkfärdighet" ; -- kräkfärdighet..nn.1
  kräkla_1_N = mkN "kräkla" ; -- kräkla..nn.1
  kräklatjuv_1_N = mkN "kräklatjuv" ; -- kräklatjuv..nn.1
  kräkmedel_1_N = mkN "kräkmedel" neutrum  ; -- kräkmedel..nn.1
  kräkning_1_N = mkN "kräkning" ; -- kräkning..nn.1
  kräks_1_N = mkN "kräks" neutrum  ; -- kräks..nn.1
  kräktrött_1_A = mkA "kräktrött" ; -- kräktrött..av.1
  kräla_1_V = mkV "krälar" ; -- kräla..vb.1
  krälande_1_N = mkN "krälande" ; -- krälande..nn.1
  kräldjur_1_N = mkN "kräldjur" neutrum  ; -- kräldjur..nn.1
  kräldjurstyp_1_N = mkN "kräldjurstyp" "kräldjurstyper" ; -- kräldjurstyp..nn.1
  kräm_1_N = mkN "kräm" "krämer" ; -- kräm..nn.1
  kräm_2_N = mkN "kräm" ; -- kräm..nn.2
  krämare_1_N = mkN "krämare" utrum  ; -- krämare..nn.1
  krämfärgad_1_A = mkA "krämfärgad" ; -- krämfärgad..av.1
  krämig_1_A = mkA "krämig" ; -- krämig..av.1
  krämla_1_N = mkN "krämla" ; -- krämla..nn.1
  krämpa_1_N = mkN "krämpa" ; -- krämpa..nn.1
  krämta_1_V = mkV "krämtar" ; -- krämta..vb.1
  krämtande_1_N = mkN "krämtande" ; -- krämtande..nn.1
  kränga_1_V = mkV "kränger" ; -- kränga..vb.1
  kränga_2_V = mkV "kränger" ; -- kränga..vb.2
  krängande_1_N = mkN "krängande" ; -- krängande..nn.1
  krängning_1_N = mkN "krängning" ; -- krängning..nn.1
  krängningshämmare_1_N = mkN "krängningshämmare" utrum  ; -- krängningshämmare..nn.1
  krängningsprov_1_N = mkN "krängningsprov" neutrum  ; -- krängningsprov..nn.1
  kränka_1_V = mkV "kränker" ; -- kränka..vb.1
  kränkande_1_A = mkA "kränkande" ; -- kränkande..av.1
  kränkande_1_N = mkN "kränkande" ; -- kränkande..nn.1
  kränkning_1_N = mkN "kränkning" ; -- kränkning..nn.1
  kränkningskänslig_1_A = mkA "kränkningskänslig" ; -- kränkningskänslig..av.1
  kränkningskänslighet_1_N = mkN "kränkningskänslighet" "kränkningskänsligheter" ; -- kränkningskänslighet..nn.1
  kräpp_1_N = mkN "kräpp" ; -- kräpp..nn.1
  kräppa_1_V = mkV "kräppar" ; -- kräppa..vb.1
  kräppande_1_N = mkN "kräppande" ; -- kräppande..nn.1
  kräppnylon_1_N = mkN "kräppnylon" ; -- kräppnylon..nn.1
  kräsen_1_A = mkA "kräsen" ; -- kräsen..av.1
  kräsenhet_1_N = mkN "kräsenhet" ; -- kräsenhet..nn.1
  kräslig_1_A = mkA "kräslig" ; -- kräslig..av.1
  kräsligen_1_Adv = mkAdv "kräsligen" ; -- kräsligen..ab.1
  kräslighet_1_N = mkN "kräslighet" ; -- kräslighet..nn.1
  kräsmagad_1_A = mkA "kräsmagad" ; -- kräsmagad..av.1
  kräsmagenhet_1_N = mkN "kräsmagenhet" ; -- kräsmagenhet..nn.1
  kräva_1_N = mkN "kräva" ; -- kräva..nn.1
  kräva_1_V = mkV "kräver" ; -- kräva..vb.1
  krävande_1_A = mkA "krävande" ; -- krävande..av.1
  krävande_1_N = mkN "krävande" ; -- krävande..nn.1
  kråka_1_N = mkN "kråka" ; -- kråka..nn.1
  kråkbär_1_N = mkN "kråkbär" neutrum  ; -- kråkbär..nn.1
  kråkfågel_1_N = mkN "kråkfågel" ; -- kråkfågel..nn.1
  kråkliknande_1_A = mkA "kråkliknande" ; -- kråkliknande..av.1
  kråkslott_1_N = mkN "kråkslott" neutrum  ; -- kråkslott..nn.1
  kråkspark_1_N = mkN "kråkspark" ; -- kråkspark..nn.1
  kråksyra_1_N = mkN "kråksyra" ; -- kråksyra..nn.1
  kråksång_1_N = mkN "kråksång" ; -- kråksång..nn.1
  kråkvicker_1_N = mkN "kråkvicker" ; -- kråkvicker..nn.1
  kråkvinkel_1_N = mkN "kråkvinkel" ; -- kråkvinkel..nn.1
  kråma_1_V = mkV "kråmar" ; -- kråma..vb.1
  kråma_2_V = mkV "kråmar" ; -- kråma..vb.2
  kråmande_1_N = mkN "kråmande" ; -- kråmande..nn.1
  kråmning_1_N = mkN "kråmning" ; -- kråmning..nn.1
  krångel_1_N = mkN "krångel" neutrum  ; -- krångel..nn.1
  krångelmakare_1_N = mkN "krångelmakare" utrum  ; -- krångelmakare..nn.1
  krångla_1_V = mkV "krånglar" ; -- krångla..vb.1
  krånglande_1_N = mkN "krånglande" ; -- krånglande..nn.1
  krånglare_1_N = mkN "krånglare" utrum  ; -- krånglare..nn.1
  krånglig_1_A = mkA "krånglig" ; -- krånglig..av.1
  krånglighet_1_N = mkN "krånglighet" "krångligheter" ; -- krånglighet..nn.1
  krås_1_N = mkN "krås" neutrum  ; -- krås..nn.1
  krås_2_N = mkN "krås" neutrum  ; -- krås..nn.2
  kråsnål_1_N = mkN "kråsnål" ; -- kråsnål..nn.1
  krögare_1_N = mkN "krögare" utrum  ; -- krögare..nn.1
  krök_1_N = mkN "krök" ; -- krök..nn.1
  kröka_1_V = mkV "kröker" ; -- kröka..vb.1
  kröka_2_V = mkV "krökar" ; -- kröka..vb.2
  krökande_1_N = mkN "krökande" ; -- krökande..nn.1
  kröken_1_N = mkN "kröken" ; -- kröken..nn.1
  krökning_1_N = mkN "krökning" ; -- krökning..nn.1
  krökt_1_A = mkA "krökt" "krökt" ; -- krökt..av.1
  krökthet_1_N = mkN "krökthet" ; -- krökthet..nn.1
  krön_1_N = mkN "krön" neutrum  ; -- krön..nn.1
  kröna_1_V = mkV "kröna" "kröner" "krön" "krönte" "krönt" "krönt" ; -- kröna..vb.1
  krönande_1_N = mkN "krönande" ; -- krönande..nn.1
  krönare_1_N = mkN "krönare" utrum  ; -- krönare..nn.1
  kröneri_1_N = mkN "kröneri" neutrum  ; -- kröneri..nn.1
  krönika_1_N = mkN "krönika" ; -- krönika..nn.1
  krönikebok_1_N = mkN "krönikebok" "krönikeböcker" ; -- krönikebok..nn.1
  krönikeförfattare_1_N = mkN "krönikeförfattare" utrum  ; -- krönikeförfattare..nn.1
  krönikespel_1_N = mkN "krönikespel" "krönikespelet" "krönikespel" "krönikespelen" ; -- krönikespel..nn.1
  krönikör_1_N = mkN "krönikör" "krönikörer" ; -- krönikör..nn.1
  kröning_1_N = mkN "kröning" ; -- kröning..nn.1
  kröningsceremoni_1_N = mkN "kröningsceremoni" "kröningsceremonier" ; -- kröningsceremoni..nn.1
  krösamos_1_N = mkN "krösamos" neutrum  ; -- krösamos..nn.1
  kröson_1_N = mkN "kröson" neutrum  ; -- kröson..nn.1
  krösus_1_N = mkN "krösus" ; -- krösus..nn.1
  kub_1_N = mkN "kub" "kuber" ; -- kub..nn.1
  kuban_1_N = mkN "kuban" "kubaner" ; -- kuban..nn.1
  kubansk_1_A = mkA "kubansk" ; -- kubansk..av.1
  kubanska_1_N = mkN "kubanska" ; -- kubanska..nn.1
  kubb_1_N = mkN "kubb" ; -- kubb..nn.1
  kubbe_1_N = mkN "kubb" ; -- kubbe..nn.1
  kubera_1_V = mkV "kuberar" ; -- kubera..vb.1
  kuberande_1_N = mkN "kuberande" ; -- kuberande..nn.1
  kuberbar_1_A = mkA "kuberbar" ; -- kuberbar..av.1
  kuberbarhet_1_N = mkN "kuberbarhet" ; -- kuberbarhet..nn.1
  kubering_1_N = mkN "kubering" ; -- kubering..nn.1
  kubik_1_N = mkN "kubik" "kubiken" "kubik" "kubiken" ; -- kubik..nn.1
  kubikdecimeter_1_N = mkN "kubikdecimeter" ; -- kubikdecimeter..nn.1
  kubikmeter_1_N = mkN "kubikmeter" ; -- kubikmeter..nn.1
  kubikmillimeter_1_N = mkN "kubikmillimeter" ; -- kubikmillimeter..nn.1
  kubikmått_1_N = mkN "kubikmått" neutrum  ; -- kubikmått..nn.1
  kubikrot_1_N = mkN "kubikrot" "kubikrötter" ; -- kubikrot..nn.1
  kubisk_1_A = mkA "kubisk" ; -- kubisk..av.1
  kubism_1_N = mkN "kubism" "kubismer" ; -- kubism..nn.1
  kubist_1_N = mkN "kubist" "kubister" ; -- kubist..nn.1
  kubistisk_1_A = mkA "kubistisk" ; -- kubistisk..av.1
  kuckel_1_N = mkN "kuckel" neutrum  ; -- kuckel..nn.1
  kuckeliku_1_N = mkN "kuckeliku" neutrum  ; -- kuckeliku..nn.1
  kuckelura_1_V = mkV "kuckelurar" ; -- kuckelura..vb.1
  kuckelurande_1_N = mkN "kuckelurande" ; -- kuckelurande..nn.1
  kuckilura_1_V = mkV "kuckilurar" ; -- kuckilura..vb.1
  kuckilurande_1_N = mkN "kuckilurande" ; -- kuckilurande..nn.1
  kuckla_1_V = mkV "kucklar" ; -- kuckla..vb.1
  kucklande_1_N = mkN "kucklande" ; -- kucklande..nn.1
  kucku_1_N = mkN "kucku" neutrum  ; -- kucku..nn.1
  kudde_1_N = mkN "kudde" utrum  ; -- kudde..nn.1
  kuddkrig_1_N = mkN "kuddkrig" neutrum  ; -- kuddkrig..nn.1
  kuddvar_1_N = mkN "kuddvar" neutrum  ; -- kuddvar..nn.1
  kuf_1_N = mkN "kuf" ; -- kuf..nn.1
  kufisk_1_A = mkA "kufisk" ; -- kufisk..av.1
  kugga_1_V = mkV "kuggar" ; -- kugga..vb.1
  kuggande_1_N = mkN "kuggande" ; -- kuggande..nn.1
  kugge_1_N = mkN "kugg" ; -- kugge..nn.1
  kuggfråga_1_N = mkN "kuggfråga" ; -- kuggfråga..nn.1
  kugghjul_1_N = mkN "kugghjul" neutrum  ; -- kugghjul..nn.1
  kuggning_1_N = mkN "kuggning" ; -- kuggning..nn.1
  kuggstång_1_N = mkN "kuggstång" "kuggstänger" ; -- kuggstång..nn.1
  kuggväxel_1_N = mkN "kuggväxel" ; -- kuggväxel..nn.1
  kujon_1_N = mkN "kujon" "kujoner" ; -- kujon..nn.1
  kujonera_1_V = mkV "kujonerar" ; -- kujonera..vb.1
  kujonerande_1_N = mkN "kujonerande" ; -- kujonerande..nn.1
  kujonerbar_1_A = mkA "kujonerbar" ; -- kujonerbar..av.1
  kujonerbarhet_1_N = mkN "kujonerbarhet" ; -- kujonerbarhet..nn.1
  kujonering_1_N = mkN "kujonering" ; -- kujonering..nn.1
  kuk_1_N = mkN "kuk" ; -- kuk..nn.1
  kukhuvud_1_N = mkN "kukhuvud" "kukhuvudet" "kukhuvud" "kukhuvudena" ; -- kukhuvud..nn.1
  kukring_1_N = mkN "kukring" ; -- kukring..nn.1
  kukrot_1_N = mkN "kukrot" "kukrötter" ; -- kukrot..nn.1
  kuktrakt_1_N = mkN "kuktrakt" "kuktrakter" ; -- kuktrakt..nn.1
  kul_1_A = mkA "kul" ; -- kul..av.1
  kula_1_N = mkN "kula" ; -- kula..nn.1
  kulak_1_N = mkN "kulak" "kulaker" ; -- kulak..nn.1
  kulbana_1_N = mkN "kulbana" ; -- kulbana..nn.1
  kulblixt_1_N = mkN "kulblixt" ; -- kulblixt..nn.1
  kulen_1_A = mkA "kulen" ; -- kulen..av.1
  kulenhet_1_N = mkN "kulenhet" ; -- kulenhet..nn.1
  kulform_1_N = mkN "kulform" ; -- kulform..nn.1
  kulformig_1_A = mkA "kulformig" ; -- kulformig..av.1
  kulfång_1_N = mkN "kulfång" neutrum  ; -- kulfång..nn.1
  kulgevär_1_N = mkN "kulgevär" neutrum  ; -- kulgevär..nn.1
  kulhål_1_N = mkN "kulhål" neutrum  ; -- kulhål..nn.1
  kuli_1_N = mkN "kuli" "kulin" "kulier" "kulierna" ; -- kuli..nn.1
  kulig_1_A = mkA "kulig" ; -- kulig..av.1
  kulighet_1_N = mkN "kulighet" "kuligheter" ; -- kulighet..nn.1
  kulinarisk_1_A = mkA "kulinarisk" ; -- kulinarisk..av.1
  kuling_1_N = mkN "kuling" ; -- kuling..nn.1
  kuliss_1_N = mkN "kuliss" "kulisser" ; -- kuliss..nn.1
  kulknapp_1_N = mkN "kulknapp" ; -- kulknapp..nn.1
  kulkvarn_1_N = mkN "kulkvarn" ; -- kulkvarn..nn.1
  kulkärve_1_N = mkN "kulkärve" utrum  ; -- kulkärve..nn.1
  kull_1_N = mkN "kull" ; -- kull..nn.1
  kull_2_N = mkN "kull" ; -- kull..nn.2
  kulla_1_N = mkN "kulla" ; -- kulla..nn.1
  kulla_1_V = mkV "kullar" ; -- kulla..vb.1
  kullager_1_N = mkN "kullager" neutrum  ; -- kullager..nn.1
  kullagrad_1_A = mkA "kullagrad" ; -- kullagrad..av.1
  kullande_1_N = mkN "kullande" ; -- kullande..nn.1
  kullblåsning_1_N = mkN "kullblåsning" ; -- kullblåsning..nn.1
  kullbyttera_1_V = mkV "kullbytterar" ; -- kullbyttera..vb.1
  kullbytterande_1_N = mkN "kullbytterande" ; -- kullbytterande..nn.1
  kullbyttering_1_N = mkN "kullbyttering" ; -- kullbyttering..nn.1
  kulle_1_N = mkN "kulle" utrum  ; -- kulle..nn.1
  kulle_2_N = mkN "kull" ; -- kulle..nn.2
  kulled_1_N = mkN "kulled" "kulleder" ; -- kulled..nn.1
  kullerbytta_1_N = mkN "kullerbytta" ; -- kullerbytta..nn.1
  kullersten_1_N = mkN "kullersten" "kullerstenen" "kullerstenar" "kullerstenarna" ; -- kullersten..nn.1
  kullerstenspassage_1_N = mkN "kullerstenspassage" "kullerstenspassager" ; -- kullerstenspassage..nn.1
  kullerstenstorg_1_N = mkN "kullerstenstorg" neutrum  ; -- kullerstenstorg..nn.1
  kullfallen_1_A = mkA "kullfallen" ; -- kullfallen..av.1
  kullig_1_A = mkA "kullig" ; -- kullig..av.1
  kullighet_1_N = mkN "kullighet" ; -- kullighet..nn.1
  kullkamrat_1_N = mkN "kullkamrat" "kullkamrater" ; -- kullkamrat..nn.1
  kullkasta_1_V = mkV "kullkastar" ; -- kullkasta..vb.1
  kullkastande_1_N = mkN "kullkastande" ; -- kullkastande..nn.1
  kullkastning_1_N = mkN "kullkastning" ; -- kullkastning..nn.1
  kullko_1_N = mkN "kullko" "kullkor" ; -- kullko..nn.1
  kullkörning_1_N = mkN "kullkörning" ; -- kullkörning..nn.1
  kullprata_1_V = mkV "kullpratar" ; -- kullprata..vb.1
  kullpratande_1_N = mkN "kullpratande" ; -- kullpratande..nn.1
  kullra_1_V = mkV "kullrar" ; -- kullra..vb.1
  kullrande_1_N = mkN "kullrande" ; -- kullrande..nn.1
  kullridning_1_N = mkN "kullridning" ; -- kullridning..nn.1
  kullrig_1_A = mkA "kullrig" ; -- kullrig..av.1
  kullrighet_1_N = mkN "kullrighet" ; -- kullrighet..nn.1
  kullsegling_1_N = mkN "kullsegling" ; -- kullsegling..nn.1
  kullslå_1_V = mkV "kullslå" "kullslog" "kullslagit" ; -- kullslå..vb.1
  kullslående_1_N = mkN "kullslående" ; -- kullslående..nn.1
  kullstjälpning_1_N = mkN "kullstjälpning" ; -- kullstjälpning..nn.1
  kullstörtning_1_N = mkN "kullstörtning" ; -- kullstörtning..nn.1
  kullstötning_1_N = mkN "kullstötning" ; -- kullstötning..nn.1
  kullsyskon_1_N = mkN "kullsyskon" neutrum  ; -- kullsyskon..nn.1
  kullvräkning_1_N = mkN "kullvräkning" ; -- kullvräkning..nn.1
  kullvältning_1_N = mkN "kullvältning" ; -- kullvältning..nn.1
  kulmage_1_N = mkN "kulmage" utrum  ; -- kulmage..nn.1
  kulmination_1_N = mkN "kulmination" ; -- kulmination..nn.1
  kulminera_1_V = mkV "kulminerar" ; -- kulminera..vb.1
  kulminerande_1_N = mkN "kulminerande" ; -- kulminerande..nn.1
  kulminering_1_N = mkN "kulminering" ; -- kulminering..nn.1
  kulna_1_V = mkV "kulnar" ; -- kulna..vb.1
  kulnande_1_N = mkN "kulnande" ; -- kulnande..nn.1
  kulpenna_1_N = mkN "kulpenna" ; -- kulpenna..nn.1
  kulram_1_N = mkN "kulram" ; -- kulram..nn.1
  kulregn_1_N = mkN "kulregn" neutrum  ; -- kulregn..nn.1
  kulsinter_1_N = mkN "kulsinter" ; -- kulsinter..nn.1
  kulskrivmaskin_1_N = mkN "kulskrivmaskin" "kulskrivmaskiner" ; -- kulskrivmaskin..nn.1
  kulspel_1_N = mkN "kulspel" "kulspelet" "kulspel" "kulspelen" ; -- kulspel..nn.1
  kulspetspenna_1_N = mkN "kulspetspenna" ; -- kulspetspenna..nn.1
  kulspruta_1_N = mkN "kulspruta" ; -- kulspruta..nn.1
  kulsprutavdelning_1_N = mkN "kulsprutavdelning" ; -- kulsprutavdelning..nn.1
  kulsprutebataljon_1_N = mkN "kulsprutebataljon" "kulsprutebataljoner" ; -- kulsprutebataljon..nn.1
  kulsprutegevär_1_N = mkN "kulsprutegevär" neutrum  ; -- kulsprutegevär..nn.1
  kulsprutenäste_1_N = mkN "kulsprutenäste" ; -- kulsprutenäste..nn.1
  kulsprutepistol_1_N = mkN "kulsprutepistol" "kulsprutepistoler" ; -- kulsprutepistol..nn.1
  kulspruteskytt_1_N = mkN "kulspruteskytt" ; -- kulspruteskytt..nn.1
  kulspår_1_N = mkN "kulspår" neutrum  ; -- kulspår..nn.1
  kulstötare_1_N = mkN "kulstötare" utrum  ; -- kulstötare..nn.1
  kulstötning_1_N = mkN "kulstötning" ; -- kulstötning..nn.1
  kult_1_N = mkN "kult" "kulter" ; -- kult..nn.1
  kult_2_N = mkN "kult" ; -- kult..nn.2
  kultföremål_1_N = mkN "kultföremål" neutrum  ; -- kultföremål..nn.1
  kultförklarad_1_A = mkA "kultförklarad" ; -- kultförklarad..av.1
  kulthandling_1_N = mkN "kulthandling" ; -- kulthandling..nn.1
  kulting_1_N = mkN "kulting" ; -- kulting..nn.1
  kultis_1_N = mkN "kultis" ; -- kultis..nn.1
  kultisk_1_A = mkA "kultisk" ; -- kultisk..av.1
  kultivator_1_N = mkN "kultivator" "kultivatorer" ; -- kultivator..nn.1
  kultivera_1_V = mkV "kultiverar" ; -- kultivera..vb.1
  kultiverad_1_A = mkA "kultiverad" ; -- kultiverad..av.1
  kultiverande_1_N = mkN "kultiverande" ; -- kultiverande..nn.1
  kultiverbar_1_A = mkA "kultiverbar" ; -- kultiverbar..av.1
  kultiverbarhet_1_N = mkN "kultiverbarhet" ; -- kultiverbarhet..nn.1
  kultivering_1_N = mkN "kultivering" ; -- kultivering..nn.1
  kultje_1_N = mkN "kultje" utrum  ; -- kultje..nn.1
  kultplats_1_N = mkN "kultplats" "kultplatser" ; -- kultplats..nn.1
  kultryck_1_N = mkN "kultryck" neutrum  ; -- kultryck..nn.1
  kultur_1_N = mkN "kultur" "kulturer" ; -- kultur..nn.1
  kulturaktivitet_1_N = mkN "kulturaktivitet" "kulturaktiviteter" ; -- kulturaktivitet..nn.1
  kulturarbetare_1_N = mkN "kulturarbetare" utrum  ; -- kulturarbetare..nn.1
  kulturarbete_1_N = mkN "kulturarbete" ; -- kulturarbete..nn.1
  kulturarrogans_1_N = mkN "kulturarrogans" ; -- kulturarrogans..nn.1
  kulturartikel_1_N = mkN "kulturartikel" ; -- kulturartikel..nn.1
  kulturarv_1_N = mkN "kulturarv" neutrum  ; -- kulturarv..nn.1
  kulturattaché_1_N = mkN "kulturattaché" "kulturattachéer" ; -- kulturattaché..nn.1
  kulturbygd_1_N = mkN "kulturbygd" "kulturbygder" ; -- kulturbygd..nn.1
  kulturbärande_1_A = mkA "kulturbärande" ; -- kulturbärande..av.1
  kulturbärare_1_N = mkN "kulturbärare" utrum  ; -- kulturbärare..nn.1
  kulturcentrum_1_N = mkN "kulturcentrum" neutrum  ; -- kulturcentrum..nn.1
  kulturchef_1_N = mkN "kulturchef" "kulturchefer" ; -- kulturchef..nn.1
  kulturchock_1_N = mkN "kulturchock" "kulturchocker" ; -- kulturchock..nn.1
  kulturdebatt_1_N = mkN "kulturdebatt" "kulturdebatter" ; -- kulturdebatt..nn.1
  kulturdel_1_N = mkN "kulturdel" "kulturdelen" "kulturdelar" "kulturdelarna" ; -- kulturdel..nn.1
  kulturekonom_1_N = mkN "kulturekonom" "kulturekonomer" ; -- kulturekonom..nn.1
  kulturelit_1_N = mkN "kulturelit" "kultureliter" ; -- kulturelit..nn.1
  kulturell_1_A = mkA "kulturell" ; -- kulturell..av.1
  kulturevenemang_1_N = mkN "kulturevenemang" neutrum  ; -- kulturevenemang..nn.1
  kulturfientlig_1_A = mkA "kulturfientlig" ; -- kulturfientlig..av.1
  kulturfientlighet_1_N = mkN "kulturfientlighet" ; -- kulturfientlighet..nn.1
  kulturfolk_1_N = mkN "kulturfolk" neutrum  ; -- kulturfolk..nn.1
  kulturform_1_N = mkN "kulturform" "kulturformer" ; -- kulturform..nn.1
  kulturförakt_1_N = mkN "kulturförakt" neutrum  ; -- kulturförakt..nn.1
  kulturgeografi_1_N = mkN "kulturgeografi" ; -- kulturgeografi..nn.1
  kulturgärning_1_N = mkN "kulturgärning" ; -- kulturgärning..nn.1
  kulturhistoria_1_N = mkN "kulturhistoria" ; -- kulturhistoria..nn.1
  kulturhistorisk_1_A = mkA "kulturhistorisk" ; -- kulturhistorisk..av.1
  kulturhus_1_N = mkN "kulturhus" neutrum  ; -- kulturhus..nn.1
  kulturinstitut_1_N = mkN "kulturinstitut" neutrum  ; -- kulturinstitut..nn.1
  kulturinstitution_1_N = mkN "kulturinstitution" ; -- kulturinstitution..nn.1
  kulturintresserad_1_A = mkA "kulturintresserad" ; -- kulturintresserad..av.1
  kulturjournalistik_1_N = mkN "kulturjournalistik" ; -- kulturjournalistik..nn.1
  kulturkamp_1_N = mkN "kulturkamp" "kulturkamper" ; -- kulturkamp..nn.1
  kulturknutte_1_N = mkN "kulturknutte" utrum  ; -- kulturknutte..nn.1
  kulturkollision_1_N = mkN "kulturkollision" ; -- kulturkollision..nn.1
  kulturkrets_1_N = mkN "kulturkrets" ; -- kulturkrets..nn.1
  kulturkrock_1_N = mkN "kulturkrock" ; -- kulturkrock..nn.1
  kulturlager_1_N = mkN "kulturlager" neutrum  ; -- kulturlager..nn.1
  kulturland_1_N = mkN "kulturland" "kulturlandet" "kulturländer" "kulturländerna" ; -- kulturland..nn.1
  kulturlandskap_1_N = mkN "kulturlandskap" neutrum  ; -- kulturlandskap..nn.1
  kulturliv_1_N = mkN "kulturliv" neutrum  ; -- kulturliv..nn.1
  kulturmarxism_1_N = mkN "kulturmarxism" "kulturmarxismer" ; -- kulturmarxism..nn.1
  kulturmarxist_1_N = mkN "kulturmarxist" "kulturmarxister" ; -- kulturmarxist..nn.1
  kulturminister_1_N = mkN "kulturminister" ; -- kulturminister..nn.1
  kulturminne_1_N = mkN "kulturminne" ; -- kulturminne..nn.1
  kulturminnesmärka_1_V = mkV "kulturminnesmärker" ; -- kulturminnesmärka..vb.1
  kulturminnesmärkande_1_N = mkN "kulturminnesmärkande" ; -- kulturminnesmärkande..nn.1
  kulturminnesmärke_1_N = mkN "kulturminnesmärke" ; -- kulturminnesmärke..nn.1
  kulturminnesvård_1_N = mkN "kulturminnesvård" ; -- kulturminnesvård..nn.1
  kulturmänniska_1_N = mkN "kulturmänniska" ; -- kulturmänniska..nn.1
  kulturmönster_1_N = mkN "kulturmönster" neutrum  ; -- kulturmönster..nn.1
  kulturomik_1_N = mkN "kulturomik" "kulturomiker" ; -- kulturomik..nn.1
  kulturområde_1_N = mkN "kulturområde" ; -- kulturområde..nn.1
  kulturperson_1_N = mkN "kulturperson" "kulturpersoner" ; -- kulturperson..nn.1
  kulturpersonlighet_1_N = mkN "kulturpersonlighet" "kulturpersonligheter" ; -- kulturpersonlighet..nn.1
  kulturpolitik_1_N = mkN "kulturpolitik" ; -- kulturpolitik..nn.1
  kulturpolitisk_1_A = mkA "kulturpolitisk" ; -- kulturpolitisk..av.1
  kulturpris_1_N = mkN "kulturpris" neutrum  ; -- kulturpris..nn.1
  kulturradikal_1_N = mkN "kulturradikal" "kulturradikaler" ; -- kulturradikal..nn.1
  kulturredaktion_1_N = mkN "kulturredaktion" ; -- kulturredaktion..nn.1
  kulturrelativism_1_N = mkN "kulturrelativism" "kulturrelativismer" ; -- kulturrelativism..nn.1
  kulturreservat_1_N = mkN "kulturreservat" neutrum  ; -- kulturreservat..nn.1
  kulturrevolution_1_N = mkN "kulturrevolution" ; -- kulturrevolution..nn.1
  kulturråd_1_N = mkN "kulturråd" neutrum  ; -- kulturråd..nn.1
  kultursektion_1_N = mkN "kultursektion" ; -- kultursektion..nn.1
  kultursida_1_N = mkN "kultursida" ; -- kultursida..nn.1
  kulturskapande_1_A = mkA "kulturskapande" ; -- kulturskapande..av.1
  kulturskede_1_N = mkN "kulturskede" ; -- kulturskede..nn.1
  kulturskillnad_1_N = mkN "kulturskillnad" "kulturskillnader" ; -- kulturskillnad..nn.1
  kulturskribent_1_N = mkN "kulturskribent" "kulturskribenter" ; -- kulturskribent..nn.1
  kulturskymning_1_N = mkN "kulturskymning" ; -- kulturskymning..nn.1
  kultursnobb_1_N = mkN "kultursnobb" ; -- kultursnobb..nn.1
  kultursponsring_1_N = mkN "kultursponsring" ; -- kultursponsring..nn.1
  kulturspråk_1_N = mkN "kulturspråk" neutrum  ; -- kulturspråk..nn.1
  kulturstat_1_N = mkN "kulturstat" "kulturstater" ; -- kulturstat..nn.1
  kulturströmning_1_N = mkN "kulturströmning" ; -- kulturströmning..nn.1
  kulturstudie_1_N = mkN "kulturstudie" "kulturstudier" ; -- kulturstudie..nn.1
  kultursväng_1_N = mkN "kultursväng" ; -- kultursväng..nn.1
  kulturtänkare_1_N = mkN "kulturtänkare" utrum  ; -- kulturtänkare..nn.1
  kulturutbyte_1_N = mkN "kulturutbyte" ; -- kulturutbyte..nn.1
  kulturväxt_1_N = mkN "kulturväxt" "kulturväxter" ; -- kulturväxt..nn.1
  kulturyttring_1_N = mkN "kulturyttring" ; -- kulturyttring..nn.1
  kulventil_1_N = mkN "kulventil" "kulventiler" ; -- kulventil..nn.1
  kulvert_1_N = mkN "kulvert" ; -- kulvert..nn.1
  kulör_1_N = mkN "kulör" "kulörer" ; -- kulör..nn.1
  kulört_1_A = mkA "kulört" "kulört" ; -- kulört..av.1
  kulörthet_1_N = mkN "kulörthet" ; -- kulörthet..nn.1
  kulörttvätt_1_N = mkN "kulörttvätt" ; -- kulörttvätt..nn.1
  kulörtvätt_1_N = mkN "kulörtvätt" ; -- kulörtvätt..nn.1
  kummel_1_N = mkN "kummel" neutrum  ; -- kummel..nn.1
  kummel_2_N = mkN "kummel" "kummeln" "kummlar" "kummlarna" ; -- kummel..nn.2
  kummin_1_N = mkN "kummin" ; -- kummin..nn.1
  kumminjärpe_1_N = mkN "kumminjärpe" utrum  ; -- kumminjärpe..nn.1
  kumpan_1_N = mkN "kumpan" "kumpaner" ; -- kumpan..nn.1
  kumulation_1_N = mkN "kumulation" ; -- kumulation..nn.1
  kumulativ_1_A = mkA "kumulativ" ; -- kumulativ..av.1
  kumulera_1_V = mkV "kumulerar" ; -- kumulera..vb.1
  kumulerande_1_N = mkN "kumulerande" ; -- kumulerande..nn.1
  kumulerbar_1_A = mkA "kumulerbar" ; -- kumulerbar..av.1
  kumulerbarhet_1_N = mkN "kumulerbarhet" ; -- kumulerbarhet..nn.1
  kumulering_1_N = mkN "kumulering" ; -- kumulering..nn.1
  kumys_1_N = mkN "kumys" ; -- kumys..nn.1
  kund_1_N = mkN "kund" "kunder" ; -- kund..nn.1
  kundcentrerad_1_A = mkA "kundcentrerad" ; -- kundcentrerad..av.1
  kundkontakt_1_N = mkN "kundkontakt" "kundkontakter" ; -- kundkontakt..nn.1
  kundkrets_1_N = mkN "kundkrets" ; -- kundkrets..nn.1
  kundnära_1_Adv = mkAdv "kundnära" ; -- kundnära..ab.1
  kundnöjdhet_1_N = mkN "kundnöjdhet" ; -- kundnöjdhet..nn.1
  kundnöjdhetsenkät_1_N = mkN "kundnöjdhetsenkät" "kundnöjdhetsenkäter" ; -- kundnöjdhetsenkät..nn.1
  kundnöjdhetsindex_1_N = mkN "kundnöjdhetsindex" neutrum  ; -- kundnöjdhetsindex..nn.1
  kundorder_1_N = mkN "kundorder" ; -- kundorder..nn.1
  kundsekretess_1_N = mkN "kundsekretess" ; -- kundsekretess..nn.1
  kundservice_1_N = mkN "kundservice" utrum  ; -- kundservice..nn.1
  kundservicechef_1_N = mkN "kundservicechef" "kundservicechefer" ; -- kundservicechef..nn.1
  kundtjänst_1_N = mkN "kundtjänst" ; -- kundtjänst..nn.1
  kundunderlag_1_N = mkN "kundunderlag" neutrum  ; -- kundunderlag..nn.1
  kundvagn_1_N = mkN "kundvagn" ; -- kundvagn..nn.1
  kundvärvning_1_N = mkN "kundvärvning" ; -- kundvärvning..nn.1
  kundönskemål_1_N = mkN "kundönskemål" neutrum  ; -- kundönskemål..nn.1
  kung_1_N = mkN "kung" ; -- kung..nn.1
  kungabrev_1_N = mkN "kungabrev" neutrum  ; -- kungabrev..nn.1
  kungadöme_1_N = mkN "kungadöme" ; -- kungadöme..nn.1
  kungaed_1_N = mkN "kungaed" "kungaeder" ; -- kungaed..nn.1
  kungafamilj_1_N = mkN "kungafamilj" "kungafamiljer" ; -- kungafamilj..nn.1
  kungaförhärligande_1_N = mkN "kungaförhärligande" ; -- kungaförhärligande..nn.1
  kungaglans_1_N = mkN "kungaglans" ; -- kungaglans..nn.1
  kungahus_1_N = mkN "kungahus" neutrum  ; -- kungahus..nn.1
  kungakrona_1_N = mkN "kungakrona" ; -- kungakrona..nn.1
  kungalängd_1_N = mkN "kungalängd" "kungalängder" ; -- kungalängd..nn.1
  kungamakare_1_N = mkN "kungamakare" utrum  ; -- kungamakare..nn.1
  kungamakt_1_N = mkN "kungamakt" ; -- kungamakt..nn.1
  kungamord_1_N = mkN "kungamord" neutrum  ; -- kungamord..nn.1
  kungamördare_1_N = mkN "kungamördare" utrum  ; -- kungamördare..nn.1
  kungapalats_1_N = mkN "kungapalats" neutrum  ; -- kungapalats..nn.1
  kungapar_1_N = mkN "kungapar" neutrum  ; -- kungapar..nn.1
  kungaresidens_1_N = mkN "kungaresidens" neutrum  ; -- kungaresidens..nn.1
  kungarike_1_N = mkN "kungarike" ; -- kungarike..nn.1
  kungaskriveri_1_N = mkN "kungaskriveri" "kungaskriveriet" "kungaskriverier" "kungaskriverierna" ; -- kungaskriveri..nn.1
  kungason_1_N = mkN "kungason" "kungasöner" ; -- kungason..nn.1
  kungasäte_1_N = mkN "kungasäte" ; -- kungasäte..nn.1
  kungatitel_1_N = mkN "kungatitel" ; -- kungatitel..nn.1
  kungatron_1_N = mkN "kungatron" "kungatroner" ; -- kungatron..nn.1
  kungaval_1_N = mkN "kungaval" neutrum  ; -- kungaval..nn.1
  kungaätt_1_N = mkN "kungaätt" "kungaätter" ; -- kungaätt..nn.1
  kunglig_1_A = mkA "kunglig" ; -- kunglig..av.1
  kunglighet_1_N = mkN "kunglighet" "kungligheter" ; -- kunglighet..nn.1
  kunglighetsvurm_1_N = mkN "kunglighetsvurm" ; -- kunglighetsvurm..nn.1
  kungsblå_1_A = mkA "kungsblå" "kungsblått" ; -- kungsblå..av.1
  kungsbonde_1_N = mkN "kungsbonde" "kungsbönder" ; -- kungsbonde..nn.1
  kungsfiskare_1_N = mkN "kungsfiskare" utrum  ; -- kungsfiskare..nn.1
  kungsfågel_1_N = mkN "kungsfågel" ; -- kungsfågel..nn.1
  kungsgambit_1_N = mkN "kungsgambit" ; -- kungsgambit..nn.1
  kungsgård_1_N = mkN "kungsgård" ; -- kungsgård..nn.1
  kungshög_1_N = mkN "kungshög" ; -- kungshög..nn.1
  kungskrabba_1_N = mkN "kungskrabba" ; -- kungskrabba..nn.1
  kungsljus_1_N = mkN "kungsljus" neutrum  ; -- kungsljus..nn.1
  kungsord_1_N = mkN "kungsord" neutrum  ; -- kungsord..nn.1
  kungstanke_1_N = mkN "kungstanke" utrum  ; -- kungstanke..nn.1
  kungstiger_1_N = mkN "kungstiger" ; -- kungstiger..nn.1
  kungsväg_1_N = mkN "kungsväg" ; -- kungsväg..nn.1
  kungsängslilja_1_N = mkN "kungsängslilja" ; -- kungsängslilja..nn.1
  kungsådra_1_N = mkN "kungsådra" ; -- kungsådra..nn.1
  kungsörn_1_N = mkN "kungsörn" ; -- kungsörn..nn.1
  kungöra_1_V = mkV "kungöra" "kungjorde" "kungjort" ; -- kungöra..vb.1
  kungörande_1_N = mkN "kungörande" ; -- kungörande..nn.1
  kungörelse_1_N = mkN "kungörelse" "kungörelser" ; -- kungörelse..nn.1
  kunnande_1_N = mkN "kunnande" ; -- kunnande..nn.1
  kunnig_1_A = mkA "kunnig" ; -- kunnig..av.1
  kunnighet_1_N = mkN "kunnighet" ; -- kunnighet..nn.1
  kunskap_1_N = mkN "kunskap" "kunskaper" ; -- kunskap..nn.1
  kunskapa_1_V = mkV "kunskapar" ; -- kunskapa..vb.1
  kunskapande_1_N = mkN "kunskapande" ; -- kunskapande..nn.1
  kunskapare_1_N = mkN "kunskapare" utrum  ; -- kunskapare..nn.1
  kunskapsbaserad_1_A = mkA "kunskapsbaserad" ; -- kunskapsbaserad..av.1
  kunskapsbegär_1_N = mkN "kunskapsbegär" neutrum  ; -- kunskapsbegär..nn.1
  kunskapshunger_1_N = mkN "kunskapshunger" ; -- kunskapshunger..nn.1
  kunskapsinhämtning_1_N = mkN "kunskapsinhämtning" ; -- kunskapsinhämtning..nn.1
  kunskapsintensiv_1_A = mkA "kunskapsintensiv" ; -- kunskapsintensiv..av.1
  kunskapskontroll_1_N = mkN "kunskapskontroll" "kunskapskontroller" ; -- kunskapskontroll..nn.1
  kunskapskälla_1_N = mkN "kunskapskälla" ; -- kunskapskälla..nn.1
  kunskapslidelse_1_N = mkN "kunskapslidelse" utrum  ; -- kunskapslidelse..nn.1
  kunskapslyft_1_N = mkN "kunskapslyft" ; -- kunskapslyft..nn.1
  kunskapsläge_1_N = mkN "kunskapsläge" ; -- kunskapsläge..nn.1
  kunskapsmaskin_1_N = mkN "kunskapsmaskin" "kunskapsmaskiner" ; -- kunskapsmaskin..nn.1
  kunskapsmässig_1_A = mkA "kunskapsmässig" ; -- kunskapsmässig..av.1
  kunskapsnivå_1_N = mkN "kunskapsnivå" "kunskapsnivåer" ; -- kunskapsnivå..nn.1
  kunskapsprov_1_N = mkN "kunskapsprov" neutrum  ; -- kunskapsprov..nn.1
  kunskapsras_1_N = mkN "kunskapsras" "kunskapsraser" ; -- kunskapsras..nn.1
  kunskapsrik_1_A = mkA "kunskapsrik" ; -- kunskapsrik..av.1
  kunskapsstoff_1_N = mkN "kunskapsstoff" neutrum  ; -- kunskapsstoff..nn.1
  kunskapssyn_1_N = mkN "kunskapssyn" "kunskapssyner" ; -- kunskapssyn..nn.1
  kunskapssökande_1_A = mkA "kunskapssökande" ; -- kunskapssökande..av.1
  kunskapssökande_1_N = mkN "kunskapssökande" ; -- kunskapssökande..nn.1
  kunskapsteoretisk_1_A = mkA "kunskapsteoretisk" ; -- kunskapsteoretisk..av.1
  kunskapsteori_1_N = mkN "kunskapsteori" ; -- kunskapsteori..nn.1
  kunskapstörst_1_N = mkN "kunskapstörst" ; -- kunskapstörst..nn.1
  kunskapstörstande_1_A = mkA "kunskapstörstande" ; -- kunskapstörstande..av.1
  kunskapsunderlag_1_N = mkN "kunskapsunderlag" neutrum  ; -- kunskapsunderlag..nn.1
  kupa_1_N = mkN "kupa" ; -- kupa..nn.1
  kupa_1_V = mkV "kupar" ; -- kupa..vb.1
  kupande_1_N = mkN "kupande" ; -- kupande..nn.1
  kupera_1_V = mkV "kuperar" ; -- kupera..vb.1
  kuperad_1_A = mkA "kuperad" ; -- kuperad..av.1
  kuperande_1_N = mkN "kuperande" ; -- kuperande..nn.1
  kuperbar_1_A = mkA "kuperbar" ; -- kuperbar..av.1
  kuperbarhet_1_N = mkN "kuperbarhet" ; -- kuperbarhet..nn.1
  kupering_1_N = mkN "kupering" ; -- kupering..nn.1
  kupidon_1_N = mkN "kupidon" "kupidoner" ; -- kupidon..nn.1
  kupig_1_A = mkA "kupig" ; -- kupig..av.1
  kupighet_1_N = mkN "kupighet" ; -- kupighet..nn.1
  kuplett_1_N = mkN "kuplett" "kupletter" ; -- kuplett..nn.1
  kuplettsångare_1_N = mkN "kuplettsångare" utrum  ; -- kuplettsångare..nn.1
  kupol_1_N = mkN "kupol" "kupoler" ; -- kupol..nn.1
  kupolformig_1_A = mkA "kupolformig" ; -- kupolformig..av.1
  kupolformighet_1_N = mkN "kupolformighet" ; -- kupolformighet..nn.1
  kupolförsedd_1_A = mkA "kupolförsedd" ; -- kupolförsedd..av.1
  kupolgrav_1_N = mkN "kupolgrav" ; -- kupolgrav..nn.1
  kupoltak_1_N = mkN "kupoltak" neutrum  ; -- kupoltak..nn.1
  kupolvalv_1_N = mkN "kupolvalv" neutrum  ; -- kupolvalv..nn.1
  kupong_1_N = mkN "kupong" "kuponger" ; -- kupong..nn.1
  kupongklippare_1_N = mkN "kupongklippare" utrum  ; -- kupongklippare..nn.1
  kupp_1_N = mkN "kupp" "kupper" ; -- kupp..nn.1
  kuppa_1_V = mkV "kuppar" ; -- kuppa..vb.1
  kuppande_1_N = mkN "kuppande" ; -- kuppande..nn.1
  kuppartad_1_A = mkA "kuppartad" ; -- kuppartad..av.1
  kuppberedskap_1_N = mkN "kuppberedskap" ; -- kuppberedskap..nn.1
  kuppförsök_1_N = mkN "kuppförsök" neutrum  ; -- kuppförsök..nn.1
  kupplan_1_N = mkN "kupplan" "kupplaner" ; -- kupplan..nn.1
  kupé_1_N = mkN "kupé" "kupéer" ; -- kupé..nn.1
  kupédörr_1_N = mkN "kupédörr" ; -- kupédörr..nn.1
  kupéfönster_1_N = mkN "kupéfönster" neutrum  ; -- kupéfönster..nn.1
  kupévärmare_1_N = mkN "kupévärmare" utrum  ; -- kupévärmare..nn.1
  kur_1_N = mkN "kur" "kurer" ; -- kur..nn.1
  kur_2_N = mkN "kur" ; -- kur..nn.2
  kura_1_V = mkV "kurar" ; -- kura..vb.1
  kurage_1_N = mkN "kurage" ; -- kurage..nn.1
  kurande_1_N = mkN "kurande" ; -- kurande..nn.1
  kuranstalt_1_N = mkN "kuranstalt" "kuranstalter" ; -- kuranstalt..nn.1
  kurant_1_A = mkA "kurant" "kurant" ; -- kurant..av.1
  kurare_1_N = mkN "kurare" ; -- kurare..nn.1
  kuratel_1_N = mkN "kuratel" "kuratelet" "kuratel" "kuratelen" ; -- kuratel..nn.1
  kuratera_1_V = mkV "kuraterar" ; -- kuratera..vb.1
  kuraterande_1_N = mkN "kuraterande" ; -- kuraterande..nn.1
  kuraterbar_1_A = mkA "kuraterbar" ; -- kuraterbar..av.1
  kuraterbarhet_1_N = mkN "kuraterbarhet" ; -- kuraterbarhet..nn.1
  kurativ_1_A = mkA "kurativ" ; -- kurativ..av.1
  kurator_1_N = mkN "kurator" "kuratorer" ; -- kurator..nn.1
  kurbits_1_N = mkN "kurbits" ; -- kurbits..nn.1
  kurd_1_N = mkN "kurd" "kurder" ; -- kurd..nn.1
  kurder_1_N = mkN "kurder" "kurdern" "kurder" "kurderna" ; -- kurder..nn.1
  kurdisk_1_A = mkA "kurdisk" ; -- kurdisk..av.1
  kurdiska_1_N = mkN "kurdiska" ; -- kurdiska..nn.1
  kurdiska_2_N = mkN "kurdiska" ; -- kurdiska..nn.2
  kurera_1_V = mkV "kurerar" ; -- kurera..vb.1
  kurerande_1_N = mkN "kurerande" ; -- kurerande..nn.1
  kurerbar_1_A = mkA "kurerbar" ; -- kurerbar..av.1
  kurerbarhet_1_N = mkN "kurerbarhet" ; -- kurerbarhet..nn.1
  kurering_1_N = mkN "kurering" ; -- kurering..nn.1
  kurfurste_1_N = mkN "kurfurste" utrum  ; -- kurfurste..nn.1
  kurfurstendöme_1_N = mkN "kurfurstendöme" ; -- kurfurstendöme..nn.1
  kurgan_1_N = mkN "kurgan" "kurganer" ; -- kurgan..nn.1
  kurhus_1_N = mkN "kurhus" neutrum  ; -- kurhus..nn.1
  kuria_1_N = mkN "kuria" ; -- kuria..nn.1
  kurialstil_1_N = mkN "kurialstil" ; -- kurialstil..nn.1
  kuriosaspalt_1_N = mkN "kuriosaspalt" "kuriosaspalter" ; -- kuriosaspalt..nn.1
  kuriositet_1_N = mkN "kuriositet" "kuriositeter" ; -- kuriositet..nn.1
  kuriosum_1_N = mkN "kuriosum" "kuriosumet" "kuriosa" "kuriosana" ; -- kuriosum..nn.1
  kurir_1_N = mkN "kurir" "kurirer" ; -- kurir..nn.1
  kurirpass_1_N = mkN "kurirpass" neutrum  ; -- kurirpass..nn.1
  kurirresa_1_N = mkN "kurirresa" ; -- kurirresa..nn.1
  kurirsäck_1_N = mkN "kurirsäck" ; -- kurirsäck..nn.1
  kuriös_1_A = mkA "kuriös" ; -- kuriös..av.1
  kurort_1_N = mkN "kurort" "kurorter" ; -- kurort..nn.1
  kurr_1_N = mkN "kurr" neutrum  ; -- kurr..nn.1
  kurr_2_N = mkN "kurr" neutrum  ; -- kurr..nn.2
  kurra_1_N = mkN "kurra" ; -- kurra..nn.1
  kurra_1_V = mkV "kurrar" ; -- kurra..vb.1
  kurragömma_1_N = mkN "kurragömma" ; -- kurragömma..nn.1
  kurragömmajakt_1_N = mkN "kurragömmajakt" "kurragömmajakter" ; -- kurragömmajakt..nn.1
  kurragömmalek_1_N = mkN "kurragömmalek" ; -- kurragömmalek..nn.1
  kurrande_1_N = mkN "kurrande" ; -- kurrande..nn.1
  kurre_1_N = mkN "kurre" utrum  ; -- kurre..nn.1
  kurrning_1_N = mkN "kurrning" ; -- kurrning..nn.1
  kurs_1_N = mkN "kurs" "kurser" ; -- kurs..nn.1
  kursa_1_V = mkV "kursar" ; -- kursa..vb.1
  kursa_2_V = mkV "kursar" ; -- kursa..vb.2
  kursande_1_N = mkN "kursande" ; -- kursande..nn.1
  kursare_1_N = mkN "kursare" utrum  ; -- kursare..nn.1
  kursbeskrivning_1_N = mkN "kursbeskrivning" ; -- kursbeskrivning..nn.1
  kursdeltagare_1_N = mkN "kursdeltagare" utrum  ; -- kursdeltagare..nn.1
  kursera_1_V = mkV "kurserar" ; -- kursera..vb.1
  kurserande_1_N = mkN "kurserande" ; -- kurserande..nn.1
  kursering_1_N = mkN "kursering" ; -- kursering..nn.1
  kursfall_1_N = mkN "kursfall" neutrum  ; -- kursfall..nn.1
  kursiv_1_A = mkA "kursiv" ; -- kursiv..av.1
  kursiv_1_N = mkN "kursiv" "kursiver" ; -- kursiv..nn.1
  kursivera_1_V = mkV "kursiverar" ; -- kursivera..vb.1
  kursiverande_1_N = mkN "kursiverande" ; -- kursiverande..nn.1
  kursiverbar_1_A = mkA "kursiverbar" ; -- kursiverbar..av.1
  kursiverbarhet_1_N = mkN "kursiverbarhet" ; -- kursiverbarhet..nn.1
  kursivering_1_N = mkN "kursivering" ; -- kursivering..nn.1
  kursivläsning_1_N = mkN "kursivläsning" ; -- kursivläsning..nn.1
  kursivstil_1_N = mkN "kursivstil" ; -- kursivstil..nn.1
  kurskamrat_1_N = mkN "kurskamrat" "kurskamrater" ; -- kurskamrat..nn.1
  kurslitteratur_1_N = mkN "kurslitteratur" "kurslitteraturer" ; -- kurslitteratur..nn.1
  kursläsning_1_N = mkN "kursläsning" ; -- kursläsning..nn.1
  kursmässig_1_A = mkA "kursmässig" ; -- kursmässig..av.1
  kursnotering_1_N = mkN "kursnotering" ; -- kursnotering..nn.1
  kursor_1_N = mkN "kursor" "kursorer" ; -- kursor..nn.1
  kursorisk_1_A = mkA "kursorisk" ; -- kursorisk..av.1
  kursplan_1_N = mkN "kursplan" "kursplaner" ; -- kursplan..nn.1
  kursrörelse_1_N = mkN "kursrörelse" "kursrörelser" ; -- kursrörelse..nn.1
  kursstegring_1_N = mkN "kursstegring" ; -- kursstegring..nn.1
  kursutveckling_1_N = mkN "kursutveckling" ; -- kursutveckling..nn.1
  kursändring_1_N = mkN "kursändring" ; -- kursändring..nn.1
  kurtage_1_N = mkN "kurtage" "kurtaget" "kurtage" "kurtagen" ; -- kurtage..nn.1
  kurtis_1_N = mkN "kurtis" "kurtiser" ; -- kurtis..nn.1
  kurtisan_1_N = mkN "kurtisan" "kurtisaner" ; -- kurtisan..nn.1
  kurtisera_1_V = mkV "kurtiserar" ; -- kurtisera..vb.1
  kurtiserande_1_N = mkN "kurtiserande" ; -- kurtiserande..nn.1
  kurtiserbar_1_A = mkA "kurtiserbar" ; -- kurtiserbar..av.1
  kurtiserbarhet_1_N = mkN "kurtiserbarhet" ; -- kurtiserbarhet..nn.1
  kurtisering_1_N = mkN "kurtisering" ; -- kurtisering..nn.1
  kurtisör_1_N = mkN "kurtisör" "kurtisörer" ; -- kurtisör..nn.1
  kurva_1_N = mkN "kurva" ; -- kurva..nn.1
  kurvatur_1_N = mkN "kurvatur" "kurvaturer" ; -- kurvatur..nn.1
  kurvig_1_A = mkA "kurvig" ; -- kurvig..av.1
  kurvighet_1_N = mkN "kurvighet" ; -- kurvighet..nn.1
  kurvmall_1_N = mkN "kurvmall" ; -- kurvmall..nn.1
  kurvstabil_1_A = mkA "kurvstabil" ; -- kurvstabil..av.1
  kurvtagning_1_N = mkN "kurvtagning" ; -- kurvtagning..nn.1
  kurvteknik_1_N = mkN "kurvteknik" ; -- kurvteknik..nn.1
  kuscha_1_V = mkV "kuschar" ; -- kuscha..vb.1
  kuschande_1_N = mkN "kuschande" ; -- kuschande..nn.1
  kuse_1_N = mkN "kuse" utrum  ; -- kuse..nn.1
  kusin_1_N = mkN "kusin" "kusiner" ; -- kusin..nn.1
  kusingifte_1_N = mkN "kusingifte" ; -- kusingifte..nn.1
  kusinäktenskap_1_N = mkN "kusinäktenskap" neutrum  ; -- kusinäktenskap..nn.1
  kusk_1_N = mkN "kusk" ; -- kusk..nn.1
  kuska_1_V = mkV "kuskar" ; -- kuska..vb.1
  kuskande_1_N = mkN "kuskande" ; -- kuskande..nn.1
  kuskbock_1_N = mkN "kuskbock" ; -- kuskbock..nn.1
  kuslig_1_A = mkA "kuslig" ; -- kuslig..av.1
  kuslighet_1_N = mkN "kuslighet" "kusligheter" ; -- kuslighet..nn.1
  kust_1_N = mkN "kust" "kuster" ; -- kust..nn.1
  kustartilleri_1_N = mkN "kustartilleri" neutrum  ; -- kustartilleri..nn.1
  kustband_1_N = mkN "kustband" neutrum  ; -- kustband..nn.1
  kustbevakning_1_N = mkN "kustbevakning" ; -- kustbevakning..nn.1
  kustbevakningsfartyg_1_N = mkN "kustbevakningsfartyg" neutrum  ; -- kustbevakningsfartyg..nn.1
  kustbo_1_N = mkN "kustbo" "kustbor" ; -- kustbo..nn.1
  kustbygd_1_N = mkN "kustbygd" "kustbygder" ; -- kustbygd..nn.1
  kustfart_1_N = mkN "kustfart" ; -- kustfart..nn.1
  kustfisk_1_N = mkN "kustfisk" ; -- kustfisk..nn.1
  kustflotta_1_N = mkN "kustflotta" ; -- kustflotta..nn.1
  kustjägare_1_N = mkN "kustjägare" utrum  ; -- kustjägare..nn.1
  kustklimat_1_N = mkN "kustklimat" neutrum  ; -- kustklimat..nn.1
  kustlagun_1_N = mkN "kustlagun" "kustlaguner" ; -- kustlagun..nn.1
  kustland_1_N = mkN "kustland" neutrum  ; -- kustland..nn.1
  kustlinje_1_N = mkN "kustlinje" "kustlinjer" ; -- kustlinje..nn.1
  kustnära_1_Adv = mkAdv "kustnära" ; -- kustnära..ab.1
  kustod_1_N = mkN "kustod" "kustoder" ; -- kustod..nn.1
  kustområde_1_N = mkN "kustområde" ; -- kustområde..nn.1
  kustort_1_N = mkN "kustort" "kustorter" ; -- kustort..nn.1
  kustpipare_1_N = mkN "kustpipare" utrum  ; -- kustpipare..nn.1
  kustradio_1_N = mkN "kustradio" ; -- kustradio..nn.1
  kustremsa_1_N = mkN "kustremsa" ; -- kustremsa..nn.1
  kustslätt_1_N = mkN "kustslätt" "kustslätter" ; -- kustslätt..nn.1
  kustsnäppa_1_N = mkN "kustsnäppa" ; -- kustsnäppa..nn.1
  kuststad_1_N = mkN "kuststad" "kuststäder" ; -- kuststad..nn.1
  kuststräcka_1_N = mkN "kuststräcka" ; -- kuststräcka..nn.1
  kusttrafik_1_N = mkN "kusttrafik" ; -- kusttrafik..nn.1
  kustvind_1_N = mkN "kustvind" ; -- kustvind..nn.1
  kut_1_N = mkN "kut" ; -- kut..nn.1
  kuta_1_V = mkV "kutar" ; -- kuta..vb.1
  kutande_1_N = mkN "kutande" ; -- kutande..nn.1
  kutig_1_A = mkA "kutig" ; -- kutig..av.1
  kutrygg_1_N = mkN "kutrygg" ; -- kutrygg..nn.1
  kutryggig_1_A = mkA "kutryggig" ; -- kutryggig..av.1
  kutryggighet_1_N = mkN "kutryggighet" ; -- kutryggighet..nn.1
  kuts_1_N = mkN "kuts" ; -- kuts..nn.1
  kutter_1_N = mkN "kutter" neutrum  ; -- kutter..nn.1
  kutter_2_N = mkN "kutter" ; -- kutter..nn.2
  kuttersmycke_1_N = mkN "kuttersmycke" ; -- kuttersmycke..nn.1
  kutting_1_N = mkN "kutting" ; -- kutting..nn.1
  kuttra_1_V = mkV "kuttrar" ; -- kuttra..vb.1
  kuttrande_1_N = mkN "kuttrande" ; -- kuttrande..nn.1
  kuttrasju_1_N = mkN "kuttrasju" "kuttrasjut" "kuttrasjun" "kuttrasjuna" ; -- kuttrasju..nn.1
  kutym_1_N = mkN "kutym" "kutymer" ; -- kutym..nn.1
  kuva_1_V = mkV "kuvar" ; -- kuva..vb.1
  kuvande_1_N = mkN "kuvande" ; -- kuvande..nn.1
  kuvert_1_N = mkN "kuvert" neutrum  ; -- kuvert..nn.1
  kuvertavgift_1_N = mkN "kuvertavgift" "kuvertavgifter" ; -- kuvertavgift..nn.1
  kuvertbröd_1_N = mkN "kuvertbröd" neutrum  ; -- kuvertbröd..nn.1
  kuvertera_1_V = mkV "kuverterar" ; -- kuvertera..vb.1
  kuverterande_1_N = mkN "kuverterande" ; -- kuverterande..nn.1
  kuverterbar_1_A = mkA "kuverterbar" ; -- kuverterbar..av.1
  kuverterbarhet_1_N = mkN "kuverterbarhet" ; -- kuverterbarhet..nn.1
  kuvertering_1_N = mkN "kuvertering" ; -- kuvertering..nn.1
  kuvertväska_1_N = mkN "kuvertväska" ; -- kuvertväska..nn.1
  kuvös_1_N = mkN "kuvös" "kuvöser" ; -- kuvös..nn.1
  kuwaitier_1_N = mkN "kuwaitier" "kuwaitiern" "kuwaitier" "kuwaitierna" ; -- kuwaitier..nn.1
  kuwaitisk_1_A = mkA "kuwaitisk" ; -- kuwaitisk..av.1
  kuwaitiska_1_N = mkN "kuwaitiska" ; -- kuwaitiska..nn.1
  kvack_1_N = mkN "kvack" neutrum  ; -- kvack..nn.1
  kvacka_1_V = mkV "kvackar" ; -- kvacka..vb.1
  kvackande_1_N = mkN "kvackande" ; -- kvackande..nn.1
  kvackare_1_N = mkN "kvackare" utrum  ; -- kvackare..nn.1
  kvacksalva_1_V = mkV "kvacksalvar" ; -- kvacksalva..vb.1
  kvacksalvande_1_N = mkN "kvacksalvande" ; -- kvacksalvande..nn.1
  kvacksalvare_1_N = mkN "kvacksalvare" utrum  ; -- kvacksalvare..nn.1
  kvacksalveri_1_N = mkN "kvacksalveri" "kvacksalveriet" "kvacksalverier" "kvacksalverierna" ; -- kvacksalveri..nn.1
  kvacksalverilagstiftning_1_N = mkN "kvacksalverilagstiftning" ; -- kvacksalverilagstiftning..nn.1
  kvadda_1_V = mkV "kvaddar" ; -- kvadda..vb.1
  kvaddande_1_N = mkN "kvaddande" ; -- kvaddande..nn.1
  kvader_1_N = mkN "kvader" ; -- kvader..nn.1
  kvadersten_1_N = mkN "kvadersten" "kvaderstenen" "kvaderstenar" "kvaderstenarna" ; -- kvadersten..nn.1
  kvadrant_1_N = mkN "kvadrant" "kvadranter" ; -- kvadrant..nn.1
  kvadrat_1_N = mkN "kvadrat" "kvadrater" ; -- kvadrat..nn.1
  kvadratcentimeter_1_N = mkN "kvadratcentimeter" ; -- kvadratcentimeter..nn.1
  kvadratisk_1_A = mkA "kvadratisk" ; -- kvadratisk..av.1
  kvadratkilometer_1_N = mkN "kvadratkilometer" ; -- kvadratkilometer..nn.1
  kvadratmeter_1_N = mkN "kvadratmeter" ; -- kvadratmeter..nn.1
  kvadratmeterpris_1_N = mkN "kvadratmeterpris" neutrum  ; -- kvadratmeterpris..nn.1
  kvadratmått_1_N = mkN "kvadratmått" neutrum  ; -- kvadratmått..nn.1
  kvadratrot_1_N = mkN "kvadratrot" "kvadratrötter" ; -- kvadratrot..nn.1
  kvadratur_1_N = mkN "kvadratur" ; -- kvadratur..nn.1
  kvadrera_1_V = mkV "kvadrerar" ; -- kvadrera..vb.1
  kvadrerande_1_N = mkN "kvadrerande" ; -- kvadrerande..nn.1
  kvadrerbar_1_A = mkA "kvadrerbar" ; -- kvadrerbar..av.1
  kvadrerbarhet_1_N = mkN "kvadrerbarhet" ; -- kvadrerbarhet..nn.1
  kvadrering_1_N = mkN "kvadrering" ; -- kvadrering..nn.1
  kvadriljon_1_N = mkN "kvadriljon" "kvadriljoner" ; -- kvadriljon..nn.1
  kvadrillion_1_N = mkN "kvadrillion" ; -- kvadrillion..nn.1
  kvadrupelallians_1_N = mkN "kvadrupelallians" "kvadrupelallianser" ; -- kvadrupelallians..nn.1
  kvagga_1_N = mkN "kvagga" ; -- kvagga..nn.1
  kval_1_N = mkN "kval" neutrum  ; -- kval..nn.1
  kvala_1_V = mkV "kvalar" ; -- kvala..vb.1
  kvalande_1_N = mkN "kvalande" ; -- kvalande..nn.1
  kvalfri_1_A = mkA "kvalfri" "kvalfritt" ; -- kvalfri..av.1
  kvalfull_1_A = mkA "kvalfull" ; -- kvalfull..av.1
  kvalfullhet_1_N = mkN "kvalfullhet" ; -- kvalfullhet..nn.1
  kvalfylld_1_A = mkA "kvalfylld" "kvalfyllt" ; -- kvalfylld..av.1
  kvalfylldhet_1_N = mkN "kvalfylldhet" ; -- kvalfylldhet..nn.1
  kvalificera_1_V = mkV "kvalificerar" ; -- kvalificera..vb.1
  kvalificerad_1_A = mkA "kvalificerad" ; -- kvalificerad..av.1
  kvalificerande_1_N = mkN "kvalificerande" ; -- kvalificerande..nn.1
  kvalificerbar_1_A = mkA "kvalificerbar" ; -- kvalificerbar..av.1
  kvalificerbarhet_1_N = mkN "kvalificerbarhet" ; -- kvalificerbarhet..nn.1
  kvalificering_1_N = mkN "kvalificering" ; -- kvalificering..nn.1
  kvalifikation_1_N = mkN "kvalifikation" ; -- kvalifikation..nn.1
  kvalifikationsår_1_N = mkN "kvalifikationsår" neutrum  ; -- kvalifikationsår..nn.1
  kvalitativ_1_A = mkA "kvalitativ" ; -- kvalitativ..av.1
  kvalitet_1_N = mkN "kvalitet" "kvaliteter" ; -- kvalitet..nn.1
  kvalitetsarbete_1_N = mkN "kvalitetsarbete" ; -- kvalitetsarbete..nn.1
  kvalitetsauktion_1_N = mkN "kvalitetsauktion" ; -- kvalitetsauktion..nn.1
  kvalitetsförbättring_1_N = mkN "kvalitetsförbättring" ; -- kvalitetsförbättring..nn.1
  kvalitetsgranska_1_V = mkV "kvalitetsgranskar" ; -- kvalitetsgranska..vb.1
  kvalitetsgranskande_1_N = mkN "kvalitetsgranskande" ; -- kvalitetsgranskande..nn.1
  kvalitetsgranskning_1_N = mkN "kvalitetsgranskning" ; -- kvalitetsgranskning..nn.1
  kvalitetshöjande_1_A = mkA "kvalitetshöjande" ; -- kvalitetshöjande..av.1
  kvalitetsjournalistik_1_N = mkN "kvalitetsjournalistik" "kvalitetsjournalistiker" ; -- kvalitetsjournalistik..nn.1
  kvalitetskontroll_1_N = mkN "kvalitetskontroll" "kvalitetskontroller" ; -- kvalitetskontroll..nn.1
  kvalitetskontrollerad_1_A = mkA "kvalitetskontrollerad" ; -- kvalitetskontrollerad..av.1
  kvalitetskrav_1_N = mkN "kvalitetskrav" neutrum  ; -- kvalitetskrav..nn.1
  kvalitetsmässig_1_A = mkA "kvalitetsmässig" ; -- kvalitetsmässig..av.1
  kvalitetsnorm_1_N = mkN "kvalitetsnorm" "kvalitetsnormer" ; -- kvalitetsnorm..nn.1
  kvalitetsprodukt_1_N = mkN "kvalitetsprodukt" "kvalitetsprodukter" ; -- kvalitetsprodukt..nn.1
  kvalitetssäkra_1_V = mkV "kvalitetssäkrar" ; -- kvalitetssäkra..vb.1
  kvalitetssäkrande_1_N = mkN "kvalitetssäkrande" ; -- kvalitetssäkrande..nn.1
  kvalitetssäkring_1_N = mkN "kvalitetssäkring" ; -- kvalitetssäkring..nn.1
  kvalitetstid_1_N = mkN "kvalitetstid" ; -- kvalitetstid..nn.1
  kvalité_1_N = mkN "kvalité" "kvalitéer" ; -- kvalité..nn.1
  kvalm_1_N = mkN "kvalm" neutrum  ; -- kvalm..nn.1
  kvalmig_1_A = mkA "kvalmig" ; -- kvalmig..av.1
  kvalmighet_1_N = mkN "kvalmighet" "kvalmigheter" ; -- kvalmighet..nn.1
  kvalserie_1_N = mkN "kvalserie" "kvalserier" ; -- kvalserie..nn.1
  kvalster_1_N = mkN "kvalster" neutrum  ; -- kvalster..nn.1
  kvanne_1_N = mkN "kvanne" utrum  ; -- kvanne..nn.1
  kvantelektrodynamik_1_N = mkN "kvantelektrodynamik" ; -- kvantelektrodynamik..nn.1
  kvantfysik_1_N = mkN "kvantfysik" ; -- kvantfysik..nn.1
  kvantifiera_1_V = mkV "kvantifierar" ; -- kvantifiera..vb.1
  kvantifierande_1_N = mkN "kvantifierande" ; -- kvantifierande..nn.1
  kvantifierbar_1_A = mkA "kvantifierbar" ; -- kvantifierbar..av.1
  kvantifierbarhet_1_N = mkN "kvantifierbarhet" ; -- kvantifierbarhet..nn.1
  kvantifiering_1_N = mkN "kvantifiering" ; -- kvantifiering..nn.1
  kvantitativ_1_A = mkA "kvantitativ" ; -- kvantitativ..av.1
  kvantitet_1_N = mkN "kvantitet" "kvantiteter" ; -- kvantitet..nn.1
  kvantitetsteori_1_N = mkN "kvantitetsteori" ; -- kvantitetsteori..nn.1
  kvantmekanik_1_N = mkN "kvantmekanik" ; -- kvantmekanik..nn.1
  kvantmekanisk_1_A = mkA "kvantmekanisk" ; -- kvantmekanisk..av.1
  kvanttal_1_N = mkN "kvanttal" neutrum  ; -- kvanttal..nn.1
  kvantteori_1_N = mkN "kvantteori" ; -- kvantteori..nn.1
  kvantum_1_N = mkN "kvantum" neutrum  ; -- kvantum..nn.1
  kvarbli_1_V = mkV "kvarbliva" "kvarblev" "kvarblivit" ; -- kvarbli..vb.1
  kvarblivande_1_N = mkN "kvarblivande" ; -- kvarblivande..nn.1
  kvardröja_1_V = mkV "kvardröja" "kvardröjde" "kvardröjt" ; -- kvardröja..vb.1
  kvardröjande_1_N = mkN "kvardröjande" ; -- kvardröjande..nn.1
  kvarg_1_N = mkN "kvarg" ; -- kvarg..nn.1
  kvarglömd_1_A = mkA "kvarglömd" "kvarglömt" ; -- kvarglömd..av.1
  kvarhängande_1_A = mkA "kvarhängande" ; -- kvarhängande..av.1
  kvarhålla_1_V = mkV "kvarhålla" "kvarhöll" "kvarhållit" ; -- kvarhålla..vb.1
  kvarhållande_1_N = mkN "kvarhållande" ; -- kvarhållande..nn.1
  kvark_1_N = mkN "kvark" ; -- kvark..nn.1
  kvark_2_N = mkN "kvark" ; -- kvark..nn.2
  kvarka_1_N = mkN "kvarka" ; -- kvarka..nn.1
  kvarkklimp_1_N = mkN "kvarkklimp" ; -- kvarkklimp..nn.1
  kvarleva_1_N = mkN "kvarleva" ; -- kvarleva..nn.1
  kvarlevande_1_A = mkA "kvarlevande" ; -- kvarlevande..av.1
  kvarlämna_1_V = mkV "kvarlämnar" ; -- kvarlämna..vb.1
  kvarlämnande_1_N = mkN "kvarlämnande" ; -- kvarlämnande..nn.1
  kvarlåtenskap_1_N = mkN "kvarlåtenskap" ; -- kvarlåtenskap..nn.1
  kvarn_1_N = mkN "kvarn" ; -- kvarn..nn.1
  kvarndamm_1_N = mkN "kvarndamm" ; -- kvarndamm..nn.1
  kvarnhjul_1_N = mkN "kvarnhjul" neutrum  ; -- kvarnhjul..nn.1
  kvarnränna_1_N = mkN "kvarnränna" ; -- kvarnränna..nn.1
  kvarnsten_1_N = mkN "kvarnsten" "kvarnstenen" "kvarnstenar" "kvarnstenarna" ; -- kvarnsten..nn.1
  kvarntorpare_1_N = mkN "kvarntorpare" utrum  ; -- kvarntorpare..nn.1
  kvarnvinge_1_N = mkN "kvarnvinge" utrum  ; -- kvarnvinge..nn.1
  kvarsittare_1_N = mkN "kvarsittare" utrum  ; -- kvarsittare..nn.1
  kvarsittning_1_N = mkN "kvarsittning" ; -- kvarsittning..nn.1
  kvarskatt_1_N = mkN "kvarskatt" "kvarskatter" ; -- kvarskatt..nn.1
  kvarstad_1_N = mkN "kvarstad" "kvarstader" ; -- kvarstad..nn.1
  kvarstanna_1_V = mkV "kvarstannar" ; -- kvarstanna..vb.1
  kvarstannande_1_N = mkN "kvarstannande" ; -- kvarstannande..nn.1
  kvarstå_1_V = mkV "kvarstå" "kvarstod" "kvarstått" ; -- kvarstå..vb.1
  kvarstående_1_N = mkN "kvarstående" ; -- kvarstående..nn.1
  kvart_1_N = mkN "kvart" ; -- kvart..nn.1
  kvart_2_N = mkN "kvart" "kvarter" ; -- kvart..nn.2
  kvart_3_N = mkN "kvart" ; -- kvart..nn.3
  kvarta_1_V = mkV "kvartar" ; -- kvarta..vb.1
  kvartal_1_N = mkN "kvartal" neutrum  ; -- kvartal..nn.1
  kvartalsrapport_1_N = mkN "kvartalsrapport" "kvartalsrapporter" ; -- kvartalsrapport..nn.1
  kvartalsvis_1_Adv = mkAdv "kvartalsvis" ; -- kvartalsvis..ab.1
  kvartalsvis_1_A = mkA "kvartalsvis" ; -- kvartalsvis..av.1
  kvartande_1_N = mkN "kvartande" ; -- kvartande..nn.1
  kvarter_1_N = mkN "kvarter" "kvarteret" "kvarter" "kvarteren" ; -- kvarter..nn.1
  kvartermästare_1_N = mkN "kvartermästare" utrum  ; -- kvartermästare..nn.1
  kvarterspolis_1_N = mkN "kvarterspolis" "kvarterspoliser" ; -- kvarterspolis..nn.1
  kvartersvis_1_Adv = mkAdv "kvartersvis" ; -- kvartersvis..ab.1
  kvartersvis_1_A = mkA "kvartersvis" ; -- kvartersvis..av.1
  kvartett_1_N = mkN "kvartett" "kvartetter" ; -- kvartett..nn.1
  kvartil_1_N = mkN "kvartil" "kvartiler" ; -- kvartil..nn.1
  kvarting_1_N = mkN "kvarting" ; -- kvarting..nn.1
  kvarto_1_N = mkN "kvarto" ; -- kvarto..nn.1
  kvarts_1_N = mkN "kvarts" "kvartser" ; -- kvarts..nn.1
  kvartsback_1_N = mkN "kvartsback" ; -- kvartsback..nn.1
  kvartsbutelj_1_N = mkN "kvartsbutelj" "kvartsbuteljer" ; -- kvartsbutelj..nn.1
  kvartsdollar_1_N = mkN "kvartsdollar" "kvartsdollarn" "kvartsdollar" "kvartsdollarna" ; -- kvartsdollar..nn.1
  kvartsekellång_1_A = mkA "kvartsekellång" ; -- kvartsekellång..av.1
  kvartsfigur_1_N = mkN "kvartsfigur" "kvartsfigurer" ; -- kvartsfigur..nn.1
  kvartsfinal_1_N = mkN "kvartsfinal" "kvartsfinaler" ; -- kvartsfinal..nn.1
  kvartsit_1_N = mkN "kvartsit" "kvartsiter" ; -- kvartsit..nn.1
  kvartskristall_1_N = mkN "kvartskristall" "kvartskristaller" ; -- kvartskristall..nn.1
  kvartslampa_1_N = mkN "kvartslampa" ; -- kvartslampa..nn.1
  kvartslivskris_1_N = mkN "kvartslivskris" "kvartslivskriser" ; -- kvartslivskris..nn.1
  kvartssamtal_1_N = mkN "kvartssamtal" neutrum  ; -- kvartssamtal..nn.1
  kvartssekel_1_N = mkN "kvartssekel" neutrum  ; -- kvartssekel..nn.1
  kvartston_1_N = mkN "kvartston" "kvartstoner" ; -- kvartston..nn.1
  kvartsur_1_N = mkN "kvartsur" neutrum  ; -- kvartsur..nn.1
  kvartär_1_N = mkN "kvartär" ; -- kvartär..nn.1
  kvarvara_1_V = mkV "kvarvarar" ; -- kvarvara..vb.1
  kvarvarad_1_A = mkA "kvarvarad" ; -- kvarvarad..av.1
  kvarvarande_1_A = mkA "kvarvarande" ; -- kvarvarande..av.1
  kvarvarande_1_N = mkN "kvarvarande" ; -- kvarvarande..nn.1
  kvasar_1_N = mkN "kvasar" "kvasarer" ; -- kvasar..nn.1
  kvasifilosofisk_1_A = mkA "kvasifilosofisk" ; -- kvasifilosofisk..av.1
  kvasiintellektuell_1_A = mkA "kvasiintellektuell" ; -- kvasiintellektuell..av.1
  kvasikontrakt_1_N = mkN "kvasikontrakt" neutrum  ; -- kvasikontrakt..nn.1
  kvasikristall_1_N = mkN "kvasikristall" "kvasikristaller" ; -- kvasikristall..nn.1
  kvasiliberal_1_A = mkA "kvasiliberal" ; -- kvasiliberal..av.1
  kvasivetenskaplig_1_A = mkA "kvasivetenskaplig" ; -- kvasivetenskaplig..av.1
  kvass_1_N = mkN "kvass" ; -- kvass..nn.1
  kvass_2_N = mkN "kvass" ; -- kvass..nn.2
  kvassia_1_N = mkN "kvassia" ; -- kvassia..nn.1
  kvast_1_N = mkN "kvast" ; -- kvast..nn.1
  kvastfening_1_N = mkN "kvastfening" ; -- kvastfening..nn.1
  kvastformig_1_A = mkA "kvastformig" ; -- kvastformig..av.1
  kvastprick_1_N = mkN "kvastprick" ; -- kvastprick..nn.1
  kvastskaft_1_N = mkN "kvastskaft" neutrum  ; -- kvastskaft..nn.1
  kvastvårta_1_N = mkN "kvastvårta" ; -- kvastvårta..nn.1
  kvav_1_A = mkA "kvav" ; -- kvav..av.1
  kvavhet_1_N = mkN "kvavhet" ; -- kvavhet..nn.1
  kved_1_N = mkN "kved" ; -- kved..nn.1
  kverulans_1_N = mkN "kverulans" ; -- kverulans..nn.1
  kverulant_1_N = mkN "kverulant" "kverulanter" ; -- kverulant..nn.1
  kverulantisk_1_A = mkA "kverulantisk" ; -- kverulantisk..av.1
  kverulera_1_V = mkV "kverulerar" ; -- kverulera..vb.1
  kverulerande_1_N = mkN "kverulerande" ; -- kverulerande..nn.1
  kverulering_1_N = mkN "kverulering" ; -- kverulering..nn.1
  kvick_1_A = mkA "kvick" ; -- kvick..av.1
  kvicka_1_V = mkV "kvickar" ; -- kvicka..vb.1
  kvickande_1_N = mkN "kvickande" ; -- kvickande..nn.1
  kvickdrag_1_N = mkN "kvickdrag" neutrum  ; -- kvickdrag..nn.1
  kvickfotad_1_A = mkA "kvickfotad" ; -- kvickfotad..av.1
  kvickhet_1_N = mkN "kvickhet" "kvickheter" ; -- kvickhet..nn.1
  kvickhuvud_1_N = mkN "kvickhuvud" "kvickhuvudet" "kvickhuvud" "kvickhuvudena" ; -- kvickhuvud..nn.1
  kvickrot_1_N = mkN "kvickrot" ; -- kvickrot..nn.1
  kvicksand_1_N = mkN "kvicksand" ; -- kvicksand..nn.1
  kvicksilver_1_N = mkN "kvicksilver" neutrum  ; -- kvicksilver..nn.1
  kvicksilverbeta_1_V = mkV "kvicksilverbetar" ; -- kvicksilverbeta..vb.1
  kvicksilverbetande_1_N = mkN "kvicksilverbetande" ; -- kvicksilverbetande..nn.1
  kvicksilverförening_1_N = mkN "kvicksilverförening" ; -- kvicksilverförening..nn.1
  kvicksilverförgiftning_1_N = mkN "kvicksilverförgiftning" ; -- kvicksilverförgiftning..nn.1
  kvicksilvergruva_1_N = mkN "kvicksilvergruva" ; -- kvicksilvergruva..nn.1
  kvicksilverlampa_1_N = mkN "kvicksilverlampa" ; -- kvicksilverlampa..nn.1
  kvicksilverpelare_1_N = mkN "kvicksilverpelare" utrum  ; -- kvicksilverpelare..nn.1
  kvicksilvertermometer_1_N = mkN "kvicksilvertermometer" ; -- kvicksilvertermometer..nn.1
  kvicktänkt_1_A = mkA "kvicktänkt" "kvicktänkt" ; -- kvicktänkt..av.1
  kvicktänkthet_1_N = mkN "kvicktänkthet" ; -- kvicktänkthet..nn.1
  kvickögd_1_A = mkA "kvickögd" "kvickögt" ; -- kvickögd..av.1
  kvickögdhet_1_N = mkN "kvickögdhet" ; -- kvickögdhet..nn.1
  kvida_1_V = mkV "kvida" "kvidade" "kvidit" ; -- kvida..vb.1
  kvidande_1_N = mkN "kvidande" ; -- kvidande..nn.1
  kvidd_1_N = mkN "kvidd" "kvidder" ; -- kvidd..nn.1
  kvietism_1_N = mkN "kvietism" "kvietismer" ; -- kvietism..nn.1
  kvietistisk_1_A = mkA "kvietistisk" ; -- kvietistisk..av.1
  kviga_1_N = mkN "kviga" ; -- kviga..nn.1
  kvigkalv_1_N = mkN "kvigkalv" ; -- kvigkalv..nn.1
  kvillajabark_1_N = mkN "kvillajabark" ; -- kvillajabark..nn.1
  kvillra_1_V = mkV "kvillrar" ; -- kvillra..vb.1
  kvillrande_1_N = mkN "kvillrande" ; -- kvillrande..nn.1
  kvilta_1_V = mkV "kviltar" ; -- kvilta..vb.1
  kviltande_1_N = mkN "kviltande" ; -- kviltande..nn.1
  kvinna_1_N = mkN "kvinna" ; -- kvinna..nn.1
  kvinnfolk_1_N = mkN "kvinnfolk" neutrum  ; -- kvinnfolk..nn.1
  kvinnlig_1_A = mkA "kvinnlig" ; -- kvinnlig..av.1
  kvinnlig_2_A = mkA "kvinnlig" ; -- kvinnlig..av.2
  kvinnlighet_1_N = mkN "kvinnlighet" ; -- kvinnlighet..nn.1
  kvinnoaffär_1_N = mkN "kvinnoaffär" "kvinnoaffärer" ; -- kvinnoaffär..nn.1
  kvinnoarbete_1_N = mkN "kvinnoarbete" ; -- kvinnoarbete..nn.1
  kvinnoben_1_N = mkN "kvinnoben" neutrum  ; -- kvinnoben..nn.1
  kvinnobild_1_N = mkN "kvinnobild" "kvinnobilder" ; -- kvinnobild..nn.1
  kvinnobröst_1_N = mkN "kvinnobröst" neutrum  ; -- kvinnobröst..nn.1
  kvinnoburen_1_A = mkA "kvinnoburen" ; -- kvinnoburen..av.1
  kvinnodag_1_N = mkN "kvinnodag" ; -- kvinnodag..nn.1
  kvinnodominerad_1_A = mkA "kvinnodominerad" ; -- kvinnodominerad..av.1
  kvinnodräkt_1_N = mkN "kvinnodräkt" "kvinnodräkter" ; -- kvinnodräkt..nn.1
  kvinnoemancipation_1_N = mkN "kvinnoemancipation" ; -- kvinnoemancipation..nn.1
  kvinnofientlig_1_A = mkA "kvinnofientlig" ; -- kvinnofientlig..av.1
  kvinnofientlighet_1_N = mkN "kvinnofientlighet" ; -- kvinnofientlighet..nn.1
  kvinnofrid_1_N = mkN "kvinnofrid" ; -- kvinnofrid..nn.1
  kvinnofridskränkning_1_N = mkN "kvinnofridskränkning" ; -- kvinnofridskränkning..nn.1
  kvinnofrisyr_1_N = mkN "kvinnofrisyr" "kvinnofrisyrer" ; -- kvinnofrisyr..nn.1
  kvinnofråga_1_N = mkN "kvinnofråga" ; -- kvinnofråga..nn.1
  kvinnofälla_1_N = mkN "kvinnofälla" ; -- kvinnofälla..nn.1
  kvinnofängelse_1_N = mkN "kvinnofängelse" "kvinnofängelset" "kvinnofängelser" "kvinnofängelserna" ; -- kvinnofängelse..nn.1
  kvinnoförakt_1_N = mkN "kvinnoförakt" neutrum  ; -- kvinnoförakt..nn.1
  kvinnoförförare_1_N = mkN "kvinnoförförare" utrum  ; -- kvinnoförförare..nn.1
  kvinnoförnedrande_1_A = mkA "kvinnoförnedrande" ; -- kvinnoförnedrande..av.1
  kvinnoförnedring_1_N = mkN "kvinnoförnedring" ; -- kvinnoförnedring..nn.1
  kvinnoförtryck_1_N = mkN "kvinnoförtryck" neutrum  ; -- kvinnoförtryck..nn.1
  kvinnoförtryckande_1_A = mkA "kvinnoförtryckande" ; -- kvinnoförtryckande..av.1
  kvinnogestalt_1_N = mkN "kvinnogestalt" "kvinnogestalter" ; -- kvinnogestalt..nn.1
  kvinnograv_1_N = mkN "kvinnograv" ; -- kvinnograv..nn.1
  kvinnohandel_1_N = mkN "kvinnohandel" ; -- kvinnohandel..nn.1
  kvinnohat_1_N = mkN "kvinnohat" neutrum  ; -- kvinnohat..nn.1
  kvinnohatare_1_N = mkN "kvinnohatare" utrum  ; -- kvinnohatare..nn.1
  kvinnohus_1_N = mkN "kvinnohus" neutrum  ; -- kvinnohus..nn.1
  kvinnoideal_1_N = mkN "kvinnoideal" neutrum  ; -- kvinnoideal..nn.1
  kvinnojour_1_N = mkN "kvinnojour" "kvinnojourer" ; -- kvinnojour..nn.1
  kvinnokamp_1_N = mkN "kvinnokamp" ; -- kvinnokamp..nn.1
  kvinnoklinik_1_N = mkN "kvinnoklinik" "kvinnokliniker" ; -- kvinnoklinik..nn.1
  kvinnokön_1_N = mkN "kvinnokön" neutrum  ; -- kvinnokön..nn.1
  kvinnokör_1_N = mkN "kvinnokör" "kvinnokörer" ; -- kvinnokör..nn.1
  kvinnolinje_1_N = mkN "kvinnolinje" "kvinnolinjer" ; -- kvinnolinje..nn.1
  kvinnoläger_1_N = mkN "kvinnoläger" neutrum  ; -- kvinnoläger..nn.1
  kvinnoläkare_1_N = mkN "kvinnoläkare" utrum  ; -- kvinnoläkare..nn.1
  kvinnomisshandel_1_N = mkN "kvinnomisshandel" ; -- kvinnomisshandel..nn.1
  kvinnomisshandlare_1_N = mkN "kvinnomisshandlare" utrum  ; -- kvinnomisshandlare..nn.1
  kvinnonamn_1_N = mkN "kvinnonamn" neutrum  ; -- kvinnonamn..nn.1
  kvinnonatur_1_N = mkN "kvinnonatur" "kvinnonaturer" ; -- kvinnonatur..nn.1
  kvinnoplagg_1_N = mkN "kvinnoplagg" neutrum  ; -- kvinnoplagg..nn.1
  kvinnopolitik_1_N = mkN "kvinnopolitik" ; -- kvinnopolitik..nn.1
  kvinnopolitisk_1_A = mkA "kvinnopolitisk" ; -- kvinnopolitisk..av.1
  kvinnopräst_1_N = mkN "kvinnopräst" "kvinnopräster" ; -- kvinnopräst..nn.1
  kvinnoroll_1_N = mkN "kvinnoroll" "kvinnoroller" ; -- kvinnoroll..nn.1
  kvinnorov_1_N = mkN "kvinnorov" neutrum  ; -- kvinnorov..nn.1
  kvinnorättsaktivist_1_N = mkN "kvinnorättsaktivist" "kvinnorättsaktivister" ; -- kvinnorättsaktivist..nn.1
  kvinnorörelse_1_N = mkN "kvinnorörelse" "kvinnorörelser" ; -- kvinnorörelse..nn.1
  kvinnoröst_1_N = mkN "kvinnoröst" "kvinnoröster" ; -- kvinnoröst..nn.1
  kvinnosak_1_N = mkN "kvinnosak" ; -- kvinnosak..nn.1
  kvinnosakskvinna_1_N = mkN "kvinnosakskvinna" ; -- kvinnosakskvinna..nn.1
  kvinnosida_1_N = mkN "kvinnosida" ; -- kvinnosida..nn.1
  kvinnosjukdom_1_N = mkN "kvinnosjukdom" ; -- kvinnosjukdom..nn.1
  kvinnoskratt_1_N = mkN "kvinnoskratt" neutrum  ; -- kvinnoskratt..nn.1
  kvinnoskulptur_1_N = mkN "kvinnoskulptur" "kvinnoskulpturer" ; -- kvinnoskulptur..nn.1
  kvinnosmycke_1_N = mkN "kvinnosmycke" ; -- kvinnosmycke..nn.1
  kvinnospråk_1_N = mkN "kvinnospråk" neutrum  ; -- kvinnospråk..nn.1
  kvinnostudie_1_N = mkN "kvinnostudie" "kvinnostudier" ; -- kvinnostudie..nn.1
  kvinnosyn_1_N = mkN "kvinnosyn" ; -- kvinnosyn..nn.1
  kvinnotjusare_1_N = mkN "kvinnotjusare" utrum  ; -- kvinnotjusare..nn.1
  kvinnotycke_1_N = mkN "kvinnotycke" ; -- kvinnotycke..nn.1
  kvinnoutbrott_1_N = mkN "kvinnoutbrott" neutrum  ; -- kvinnoutbrott..nn.1
  kvinnovåld_1_N = mkN "kvinnovåld" neutrum  ; -- kvinnovåld..nn.1
  kvinnoöde_1_N = mkN "kvinnoöde" ; -- kvinnoöde..nn.1
  kvinnoövergrepp_1_N = mkN "kvinnoövergrepp" neutrum  ; -- kvinnoövergrepp..nn.1
  kvinns_1_N = mkN "kvinns" neutrum  ; -- kvinns..nn.1
  kvinnsperson_1_N = mkN "kvinnsperson" "kvinnspersoner" ; -- kvinnsperson..nn.1
  kvint_1_N = mkN "kvint" "kvinter" ; -- kvint..nn.1
  kvintessens_1_N = mkN "kvintessens" ; -- kvintessens..nn.1
  kvintett_1_N = mkN "kvintett" "kvintetter" ; -- kvintett..nn.1
  kvintilera_1_V = mkV "kvintilerar" ; -- kvintilera..vb.1
  kvintilerande_1_N = mkN "kvintilerande" ; -- kvintilerande..nn.1
  kvintilering_1_N = mkN "kvintilering" ; -- kvintilering..nn.1
  kvirra_1_V = mkV "kvirrar" ; -- kvirra..vb.1
  kvirrande_1_N = mkN "kvirrande" ; -- kvirrande..nn.1
  kviss_1_N = mkN "kviss" ; -- kviss..nn.1
  kvissa_1_V = mkV "kvissar" ; -- kvissa..vb.1
  kvissande_1_N = mkN "kvissande" ; -- kvissande..nn.1
  kvissla_1_N = mkN "kvissla" ; -- kvissla..nn.1
  kvisslig_1_A = mkA "kvisslig" ; -- kvisslig..av.1
  kvisslighet_1_N = mkN "kvisslighet" ; -- kvisslighet..nn.1
  kvist_1_N = mkN "kvist" ; -- kvist..nn.1
  kvista_1_V = mkV "kvistar" ; -- kvista..vb.1
  kvistande_1_N = mkN "kvistande" ; -- kvistande..nn.1
  kvistfri_1_A = mkA "kvistfri" "kvistfritt" ; -- kvistfri..av.1
  kvisthål_1_N = mkN "kvisthål" neutrum  ; -- kvisthål..nn.1
  kvistig_1_A = mkA "kvistig" ; -- kvistig..av.1
  kvistighet_1_N = mkN "kvistighet" ; -- kvistighet..nn.1
  kvistliknande_1_A = mkA "kvistliknande" ; -- kvistliknande..av.1
  kvistlös_1_A = mkA "kvistlös" ; -- kvistlös..av.1
  kvistlöshet_1_N = mkN "kvistlöshet" ; -- kvistlöshet..nn.1
  kvistning_1_N = mkN "kvistning" ; -- kvistning..nn.1
  kvistruna_1_N = mkN "kvistruna" ; -- kvistruna..nn.1
  kvitt_1_A = mkA "kvitt" ; -- kvitt..av.1
  kvitta_1_V = mkV "kvittar" ; -- kvitta..vb.1
  kvitta_2_V = mkV "kvittar" ; -- kvitta..vb.2
  kvittande_1_N = mkN "kvittande" ; -- kvittande..nn.1
  kvitten_1_N = mkN "kvitten" "kvitten" "kvitten" "kvittena" ; -- kvitten..nn.1
  kvittens_1_N = mkN "kvittens" "kvittenser" ; -- kvittens..nn.1
  kvittensbok_1_N = mkN "kvittensbok" "kvittensböcker" ; -- kvittensbok..nn.1
  kvittenträd_1_N = mkN "kvittenträd" neutrum  ; -- kvittenträd..nn.1
  kvitter_1_N = mkN "kvitter" neutrum  ; -- kvitter..nn.1
  kvittera_1_V = mkV "kvitterar" ; -- kvittera..vb.1
  kvitterande_1_N = mkN "kvitterande" ; -- kvitterande..nn.1
  kvitterbar_1_A = mkA "kvitterbar" ; -- kvitterbar..av.1
  kvitterbarhet_1_N = mkN "kvitterbarhet" ; -- kvitterbarhet..nn.1
  kvittering_1_N = mkN "kvittering" ; -- kvittering..nn.1
  kvitteringsmål_1_N = mkN "kvitteringsmål" neutrum  ; -- kvitteringsmål..nn.1
  kvittning_1_N = mkN "kvittning" ; -- kvittning..nn.1
  kvitto_1_N = mkN "kvitto" "kvittot" "kvitton" "kvittona" ; -- kvitto..nn.1
  kvittra_1_V = mkV "kvittrar" ; -- kvittra..vb.1
  kvittrande_1_N = mkN "kvittrande" ; -- kvittrande..nn.1
  kvittrig_1_A = mkA "kvittrig" ; -- kvittrig..av.1
  kvittrighet_1_N = mkN "kvittrighet" ; -- kvittrighet..nn.1
  kvot_1_N = mkN "kvot" "kvoter" ; -- kvot..nn.1
  kvotera_1_V = mkV "kvoterar" ; -- kvotera..vb.1
  kvoterande_1_N = mkN "kvoterande" ; -- kvoterande..nn.1
  kvoterbar_1_A = mkA "kvoterbar" ; -- kvoterbar..av.1
  kvoterbarhet_1_N = mkN "kvoterbarhet" ; -- kvoterbarhet..nn.1
  kvotering_1_N = mkN "kvotering" ; -- kvotering..nn.1
  kvotflykting_1_N = mkN "kvotflykting" ; -- kvotflykting..nn.1
  kvotskala_1_N = mkN "kvotskala" ; -- kvotskala..nn.1
  kväda_1_V = mkV "kväda" "kvädde" "kvädit" ; -- kväda..vb.1
  kvädande_1_N = mkN "kvädande" ; -- kvädande..nn.1
  kväde_1_N = mkN "kväde" ; -- kväde..nn.1
  kväka_1_V = mkV "kväker" ; -- kväka..vb.1
  kväkande_1_N = mkN "kväkande" ; -- kväkande..nn.1
  kväkare_1_N = mkN "kväkare" utrum  ; -- kväkare..nn.1
  kvälja_1_V = mkV "kvälja" "kvalde" "kvalt" ; -- kvälja..vb.1
  kväljande_1_N = mkN "kväljande" ; -- kväljande..nn.1
  kväljning_1_N = mkN "kväljning" ; -- kväljning..nn.1
  kväll_1_N = mkN "kväll" ; -- kväll..nn.1
  kvälla_1_V = mkV "kväller" ; -- kvälla..vb.1
  kvällande_1_N = mkN "kvällande" ; -- kvällande..nn.1
  kvällning_1_N = mkN "kvällning" ; -- kvällning..nn.1
  kvällsbris_1_N = mkN "kvällsbris" ; -- kvällsbris..nn.1
  kvällsdimma_1_N = mkN "kvällsdimma" ; -- kvällsdimma..nn.1
  kvällsfärja_1_N = mkN "kvällsfärja" ; -- kvällsfärja..nn.1
  kvällsföreläsning_1_N = mkN "kvällsföreläsning" ; -- kvällsföreläsning..nn.1
  kvällsignal_1_N = mkN "kvällsignal" "kvällsignaler" ; -- kvällsignal..nn.1
  kvällskurs_1_N = mkN "kvällskurs" "kvällskurser" ; -- kvällskurs..nn.1
  kvällskyla_1_N = mkN "kvällskyla" ; -- kvällskyla..nn.1
  kvällslig_1_A = mkA "kvällslig" ; -- kvällslig..av.1
  kvällslighet_1_N = mkN "kvällslighet" ; -- kvällslighet..nn.1
  kvällsluft_1_N = mkN "kvällsluft" ; -- kvällsluft..nn.1
  kvällsmat_1_N = mkN "kvällsmat" ; -- kvällsmat..nn.1
  kvällsmänniska_1_N = mkN "kvällsmänniska" ; -- kvällsmänniska..nn.1
  kvällsmål_1_N = mkN "kvällsmål" neutrum  ; -- kvällsmål..nn.1
  kvällsmåltid_1_N = mkN "kvällsmåltid" "kvällsmåltider" ; -- kvällsmåltid..nn.1
  kvällspinka_1_V = mkV "kvällspinkar" ; -- kvällspinka..vb.1
  kvällspinkande_1_N = mkN "kvällspinkande" ; -- kvällspinkande..nn.1
  kvällspinkning_1_N = mkN "kvällspinkning" ; -- kvällspinkning..nn.1
  kvällspress_1_N = mkN "kvällspress" ; -- kvällspress..nn.1
  kvällspromenad_1_N = mkN "kvällspromenad" "kvällspromenader" ; -- kvällspromenad..nn.1
  kvällssammankomst_1_N = mkN "kvällssammankomst" "kvällssammankomster" ; -- kvällssammankomst..nn.1
  kvällsskift_1_N = mkN "kvällsskift" neutrum  ; -- kvällsskift..nn.1
  kvällssol_1_N = mkN "kvällssol" ; -- kvällssol..nn.1
  kvällstidning_1_N = mkN "kvällstidning" ; -- kvällstidning..nn.1
  kvällstidningsmässig_1_A = mkA "kvällstidningsmässig" ; -- kvällstidningsmässig..av.1
  kvällstidningsrubrik_1_N = mkN "kvällstidningsrubrik" "kvällstidningsrubriker" ; -- kvällstidningsrubrik..nn.1
  kvällsunderhållning_1_N = mkN "kvällsunderhållning" ; -- kvällsunderhållning..nn.1
  kvällsvard_1_N = mkN "kvällsvard" "kvällsvarder" ; -- kvällsvard..nn.1
  kvällsöppen_1_A = mkA "kvällsöppen" ; -- kvällsöppen..av.1
  kvän_1_N = mkN "kvän" "kväner" ; -- kvän..nn.1
  kväsa_1_V = mkV "kväser" ; -- kväsa..vb.1
  kväsande_1_N = mkN "kväsande" ; -- kväsande..nn.1
  kväsning_1_N = mkN "kväsning" ; -- kväsning..nn.1
  kväva_1_V = mkV "kväver" ; -- kväva..vb.1
  kvävande_1_A = mkA "kvävande" ; -- kvävande..av.1
  kvävande_1_N = mkN "kvävande" ; -- kvävande..nn.1
  kväve_1_N = mkN "kväve" ; -- kväve..nn.1
  kvävebalans_1_N = mkN "kvävebalans" ; -- kvävebalans..nn.1
  kvävegödselmedel_1_N = mkN "kvävegödselmedel" neutrum  ; -- kvävegödselmedel..nn.1
  kväveoxid_1_N = mkN "kväveoxid" "kväveoxider" ; -- kväveoxid..nn.1
  kvävgas_1_N = mkN "kvävgas" ; -- kvävgas..nn.1
  kvävning_1_N = mkN "kvävning" ; -- kvävning..nn.1
  kvävningsanfall_1_N = mkN "kvävningsanfall" neutrum  ; -- kvävningsanfall..nn.1
  kvävningsskada_1_N = mkN "kvävningsskada" ; -- kvävningsskada..nn.1
  kybernetik_1_N = mkN "kybernetik" "kybernetiker" ; -- kybernetik..nn.1
  kybernetisk_1_A = mkA "kybernetisk" ; -- kybernetisk..av.1
  kyckling_1_N = mkN "kyckling" ; -- kyckling..nn.1
  kycklingbröst_1_N = mkN "kycklingbröst" neutrum  ; -- kycklingbröst..nn.1
  kycklingfilé_1_N = mkN "kycklingfilé" "kycklingfiléer" ; -- kycklingfilé..nn.1
  kycklingmoder_1_N = mkN "kycklingmoder" "kycklingmodern" "kycklingmödrar" "kycklingmödrarna" ; -- kycklingmoder..nn.1
  kycklingsallad_1_N = mkN "kycklingsallad" "kycklingsallader" ; -- kycklingsallad..nn.1
  kyffa_1_V = mkV "kyffar" ; -- kyffa..vb.1
  kyffande_1_N = mkN "kyffande" ; -- kyffande..nn.1
  kyffe_1_N = mkN "kyffe" ; -- kyffe..nn.1
  kyffig_1_A = mkA "kyffig" ; -- kyffig..av.1
  kyffighet_1_N = mkN "kyffighet" ; -- kyffighet..nn.1
  kyl_1_N = mkN "kyl" ; -- kyl..nn.1
  kyla_1_N = mkN "kyla" ; -- kyla..nn.1
  kyla_1_V = mkV "kyler" ; -- kyla..vb.1
  kylande_1_N = mkN "kylande" ; -- kylande..nn.1
  kylapparat_1_N = mkN "kylapparat" "kylapparater" ; -- kylapparat..nn.1
  kylare_1_N = mkN "kylare" utrum  ; -- kylare..nn.1
  kylargaller_1_N = mkN "kylargaller" neutrum  ; -- kylargaller..nn.1
  kylargardin_1_N = mkN "kylargardin" "kylargardiner" ; -- kylargardin..nn.1
  kylarglykol_1_N = mkN "kylarglykol" "kylarglykoler" ; -- kylarglykol..nn.1
  kylarvätska_1_N = mkN "kylarvätska" ; -- kylarvätska..nn.1
  kylbox_1_N = mkN "kylbox" ; -- kylbox..nn.1
  kyldisk_1_N = mkN "kyldisk" ; -- kyldisk..nn.1
  kylfack_1_N = mkN "kylfack" neutrum  ; -- kylfack..nn.1
  kylfläck_1_N = mkN "kylfläck" ; -- kylfläck..nn.1
  kylfläkt_1_N = mkN "kylfläkt" ; -- kylfläkt..nn.1
  kylhus_1_N = mkN "kylhus" neutrum  ; -- kylhus..nn.1
  kylig_1_A = mkA "kylig" ; -- kylig..av.1
  kylighet_1_N = mkN "kylighet" ; -- kylighet..nn.1
  kylighet_2_N = mkN "kylighet" "kyligheter" ; -- kylighet..nn.2
  kylklamp_1_N = mkN "kylklamp" ; -- kylklamp..nn.1
  kylkonserv_1_N = mkN "kylkonserv" "kylkonserver" ; -- kylkonserv..nn.1
  kyllagra_1_V = mkV "kyllagrar" ; -- kyllagra..vb.1
  kyllagrande_1_N = mkN "kyllagrande" ; -- kyllagrande..nn.1
  kylledning_1_N = mkN "kylledning" ; -- kylledning..nn.1
  kyller_1_N = mkN "kyller" neutrum  ; -- kyller..nn.1
  kylna_1_V = mkV "kylnar" ; -- kylna..vb.1
  kylnande_1_N = mkN "kylnande" ; -- kylnande..nn.1
  kylning_1_N = mkN "kylning" ; -- kylning..nn.1
  kylrum_1_N = mkN "kylrum" "kylrummet" "kylrum" "kylrummen" ; -- kylrum..nn.1
  kylrör_1_N = mkN "kylrör" neutrum  ; -- kylrör..nn.1
  kylsig_1_A = mkA "kylsig" ; -- kylsig..av.1
  kylsighet_1_N = mkN "kylsighet" ; -- kylsighet..nn.1
  kylskada_1_N = mkN "kylskada" ; -- kylskada..nn.1
  kylskåp_1_N = mkN "kylskåp" neutrum  ; -- kylskåp..nn.1
  kylskåpsdörr_1_N = mkN "kylskåpsdörr" ; -- kylskåpsdörr..nn.1
  kylskåpsgaller_1_N = mkN "kylskåpsgaller" neutrum  ; -- kylskåpsgaller..nn.1
  kylskåpsmagnet_1_N = mkN "kylskåpsmagnet" "kylskåpsmagneter" ; -- kylskåpsmagnet..nn.1
  kylskåpspoesi_1_N = mkN "kylskåpspoesi" ; -- kylskåpspoesi..nn.1
  kylslagen_1_A = mkA "kylslagen" ; -- kylslagen..av.1
  kylslagenhet_1_N = mkN "kylslagenhet" ; -- kylslagenhet..nn.1
  kylvagn_1_N = mkN "kylvagn" ; -- kylvagn..nn.1
  kylväska_1_N = mkN "kylväska" ; -- kylväska..nn.1
  kymation_1_N = mkN "kymatium" "kymatiet" "kymatier" "kymatierna" ; -- kymation..nn.1
  kymig_1_A = mkA "kymig" ; -- kymig..av.1
  kymograf_1_N = mkN "kymograf" "kymografer" ; -- kymograf..nn.1
  kymrer_1_N = mkN "kymrer" "kymrern" "kymrer" "kymrerna" ; -- kymrer..nn.1
  kymriska_1_N = mkN "kymriska" ; -- kymriska..nn.1
  kyndel_1_N = mkN "kyndel" ; -- kyndel..nn.1
  kyndelsmässa_1_N = mkN "kyndelsmässa" ; -- kyndelsmässa..nn.1
  kyniker_1_N = mkN "kyniker" "kynikern" "kyniker" "kynikerna" ; -- kyniker..nn.1
  kynisk_1_A = mkA "kynisk" ; -- kynisk..av.1
  kynne_1_N = mkN "kynne" ; -- kynne..nn.1
  kynokephal_1_A = mkA "kynokephal" ; -- kynokephal..av.1
  kynolog_1_N = mkN "kynolog" "kynologer" ; -- kynolog..nn.1
  kynologi_1_N = mkN "kynologi" ; -- kynologi..nn.1
  kyp_1_N = mkN "kyp" ; -- kyp..nn.1
  kypare_1_N = mkN "kypare" utrum  ; -- kypare..nn.1
  kypert_1_N = mkN "kypert" ; -- kypert..nn.1
  kypra_1_V = mkV "kyprar" ; -- kypra..vb.1
  kyprande_1_N = mkN "kyprande" ; -- kyprande..nn.1
  kyrass_1_N = mkN "kyrass" "kyrasser" ; -- kyrass..nn.1
  kyrassiär_1_N = mkN "kyrassiär" "kyrassiärer" ; -- kyrassiär..nn.1
  kyrassjär_1_N = mkN "kyrassjär" "kyrassjärer" ; -- kyrassjär..nn.1
  kyrillisk_1_A = mkA "kyrillisk" ; -- kyrillisk..av.1
  kyrka_1_N = mkN "kyrka" ; -- kyrka..nn.1
  kyrkbacke_1_N = mkN "kyrkbacke" utrum  ; -- kyrkbacke..nn.1
  kyrkbesök_1_N = mkN "kyrkbesök" neutrum  ; -- kyrkbesök..nn.1
  kyrkbibel_1_N = mkN "kyrkbibel" ; -- kyrkbibel..nn.1
  kyrkbok_1_N = mkN "kyrkbok" "kyrkböcker" ; -- kyrkbok..nn.1
  kyrkbokföra_1_V = mkV "kyrkbokföra" "kyrkbokförde" "kyrkbokfört" ; -- kyrkbokföra..vb.1
  kyrkbokförande_1_N = mkN "kyrkbokförande" ; -- kyrkbokförande..nn.1
  kyrkbokföring_1_N = mkN "kyrkbokföring" ; -- kyrkbokföring..nn.1
  kyrkbröllop_1_N = mkN "kyrkbröllop" neutrum  ; -- kyrkbröllop..nn.1
  kyrkby_1_N = mkN "kyrkby" "kyrkbyn" "kyrkbyar" "kyrkbyarna" ; -- kyrkby..nn.1
  kyrkbygge_1_N = mkN "kyrkbygge" ; -- kyrkbygge..nn.1
  kyrkbyggnad_1_N = mkN "kyrkbyggnad" "kyrkbyggnader" ; -- kyrkbyggnad..nn.1
  kyrkbänk_1_N = mkN "kyrkbänk" ; -- kyrkbänk..nn.1
  kyrkbåt_1_N = mkN "kyrkbåt" ; -- kyrkbåt..nn.1
  kyrkfönster_1_N = mkN "kyrkfönster" neutrum  ; -- kyrkfönster..nn.1
  kyrkkaffe_1_N = mkN "kyrkkaffe" ; -- kyrkkaffe..nn.1
  kyrkklocka_1_N = mkN "kyrkklocka" ; -- kyrkklocka..nn.1
  kyrklig_1_A = mkA "kyrklig" ; -- kyrklig..av.1
  kyrklighet_1_N = mkN "kyrklighet" ; -- kyrklighet..nn.1
  kyrkmur_1_N = mkN "kyrkmur" ; -- kyrkmur..nn.1
  kyrkoadjunkt_1_N = mkN "kyrkoadjunkt" "kyrkoadjunkter" ; -- kyrkoadjunkt..nn.1
  kyrkoavgift_1_N = mkN "kyrkoavgift" "kyrkoavgifter" ; -- kyrkoavgift..nn.1
  kyrkobalk_1_N = mkN "kyrkobalk" ; -- kyrkobalk..nn.1
  kyrkobesök_1_N = mkN "kyrkobesök" neutrum  ; -- kyrkobesök..nn.1
  kyrkobesökare_1_N = mkN "kyrkobesökare" utrum  ; -- kyrkobesökare..nn.1
  kyrkobibel_1_N = mkN "kyrkobibel" ; -- kyrkobibel..nn.1
  kyrkobok_1_N = mkN "kyrkobok" "kyrkoböcker" ; -- kyrkobok..nn.1
  kyrkobokföra_1_V = mkV "kyrkobokföra" "kyrkobokförde" "kyrkobokfört" ; -- kyrkobokföra..vb.1
  kyrkobokförande_1_N = mkN "kyrkobokförande" ; -- kyrkobokförande..nn.1
  kyrkobokföring_1_N = mkN "kyrkobokföring" ; -- kyrkobokföring..nn.1
  kyrkobroder_1_N = mkN "kyrkobroder" "kyrkobrodern" "kyrkobröder" "kyrkobröderna" ; -- kyrkobroder..nn.1
  kyrkobruk_1_N = mkN "kyrkobruk" neutrum  ; -- kyrkobruk..nn.1
  kyrkobyggande_1_N = mkN "kyrkobyggande" ; -- kyrkobyggande..nn.1
  kyrkobyggnad_1_N = mkN "kyrkobyggnad" "kyrkobyggnader" ; -- kyrkobyggnad..nn.1
  kyrkofader_1_N = mkN "kyrkofader" "kyrkofadern" "kyrkofäder" "kyrkofäderna" ; -- kyrkofader..nn.1
  kyrkofrid_1_N = mkN "kyrkofrid" ; -- kyrkofrid..nn.1
  kyrkofullmäktig_1_N = mkN "kyrkofullmäktig" "kyrkofullmäktigen" "kyrkofullmäktige" "kyrkofullmäktigena" ; -- kyrkofullmäktig..nn.1
  kyrkogång_1_N = mkN "kyrkogång" ; -- kyrkogång..nn.1
  kyrkogård_1_N = mkN "kyrkogård" ; -- kyrkogård..nn.1
  kyrkogårdsförvaltning_1_N = mkN "kyrkogårdsförvaltning" ; -- kyrkogårdsförvaltning..nn.1
  kyrkohandbok_1_N = mkN "kyrkohandbok" "kyrkohandböcker" ; -- kyrkohandbok..nn.1
  kyrkoherde_1_N = mkN "kyrkoherde" utrum  ; -- kyrkoherde..nn.1
  kyrkohistoria_1_N = mkN "kyrkohistoria" ; -- kyrkohistoria..nn.1
  kyrkohistorisk_1_A = mkA "kyrkohistorisk" ; -- kyrkohistorisk..av.1
  kyrkohäll_1_N = mkN "kyrkohäll" ; -- kyrkohäll..nn.1
  kyrkokonsert_1_N = mkN "kyrkokonsert" "kyrkokonserter" ; -- kyrkokonsert..nn.1
  kyrkolag_1_N = mkN "kyrkolag" ; -- kyrkolag..nn.1
  kyrkolatin_1_N = mkN "kyrkolatin" neutrum  ; -- kyrkolatin..nn.1
  kyrkoledning_1_N = mkN "kyrkoledning" ; -- kyrkoledning..nn.1
  kyrkolärare_1_N = mkN "kyrkolärare" utrum  ; -- kyrkolärare..nn.1
  kyrkoman_1_N = mkN "kyrkoman" "kyrkomannen" "kyrkomän" "kyrkomännen" ; -- kyrkoman..nn.1
  kyrkomusik_1_N = mkN "kyrkomusik" ; -- kyrkomusik..nn.1
  kyrkomusiker_1_N = mkN "kyrkomusiker" "kyrkomusikern" "kyrkomusiker" "kyrkomusikerna" ; -- kyrkomusiker..nn.1
  kyrkomöte_1_N = mkN "kyrkomöte" ; -- kyrkomöte..nn.1
  kyrkoordning_1_N = mkN "kyrkoordning" ; -- kyrkoordning..nn.1
  kyrkopolitik_1_N = mkN "kyrkopolitik" ; -- kyrkopolitik..nn.1
  kyrkopolitisk_1_A = mkA "kyrkopolitisk" ; -- kyrkopolitisk..av.1
  kyrkoruin_1_N = mkN "kyrkoruin" "kyrkoruiner" ; -- kyrkoruin..nn.1
  kyrkorum_1_N = mkN "kyrkorum" "kyrkorummet" "kyrkorum" "kyrkorummen" ; -- kyrkorum..nn.1
  kyrkoråd_1_N = mkN "kyrkoråd" neutrum  ; -- kyrkoråd..nn.1
  kyrkosamfund_1_N = mkN "kyrkosamfund" neutrum  ; -- kyrkosamfund..nn.1
  kyrkospråk_1_N = mkN "kyrkospråk" neutrum  ; -- kyrkospråk..nn.1
  kyrkostadga_1_N = mkN "kyrkostadga" ; -- kyrkostadga..nn.1
  kyrkostat_1_N = mkN "kyrkostat" ; -- kyrkostat..nn.1
  kyrkostrid_1_N = mkN "kyrkostrid" "kyrkostrider" ; -- kyrkostrid..nn.1
  kyrkostämma_1_N = mkN "kyrkostämma" ; -- kyrkostämma..nn.1
  kyrkosång_1_N = mkN "kyrkosång" "kyrkosånger" ; -- kyrkosång..nn.1
  kyrkotagning_1_N = mkN "kyrkotagning" ; -- kyrkotagning..nn.1
  kyrkoton_1_N = mkN "kyrkoton" "kyrkotoner" ; -- kyrkoton..nn.1
  kyrkotonart_1_N = mkN "kyrkotonart" "kyrkotonarter" ; -- kyrkotonart..nn.1
  kyrkotukt_1_N = mkN "kyrkotukt" ; -- kyrkotukt..nn.1
  kyrkovalv_1_N = mkN "kyrkovalv" neutrum  ; -- kyrkovalv..nn.1
  kyrkoverksamhet_1_N = mkN "kyrkoverksamhet" "kyrkoverksamheter" ; -- kyrkoverksamhet..nn.1
  kyrkoår_1_N = mkN "kyrkoår" neutrum  ; -- kyrkoår..nn.1
  kyrksal_1_N = mkN "kyrksal" ; -- kyrksal..nn.1
  kyrksam_1_A = mkA "kyrksam" "kyrksamt" "kyrksamma" "kyrksamma" "kyrksammare" "kyrksammast" "kyrksammaste" ; -- kyrksam..av.1
  kyrksamhet_1_N = mkN "kyrksamhet" ; -- kyrksamhet..nn.1
  kyrksilver_1_N = mkN "kyrksilver" neutrum  ; -- kyrksilver..nn.1
  kyrkskriva_1_V = mkV "kyrkskriva" "kyrkskrev" "kyrkskrivit" ; -- kyrkskriva..vb.1
  kyrkskrivande_1_N = mkN "kyrkskrivande" ; -- kyrkskrivande..nn.1
  kyrkslaviska_1_N = mkN "kyrkslaviska" ; -- kyrkslaviska..nn.1
  kyrksocken_1_N = mkN "kyrksocken" "kyrksockenn" "kyrksocknar" "kyrksocknarna" ; -- kyrksocken..nn.1
  kyrkspira_1_N = mkN "kyrkspira" ; -- kyrkspira..nn.1
  kyrkstad_1_N = mkN "kyrkstad" "kyrkstäder" ; -- kyrkstad..nn.1
  kyrkstöt_1_N = mkN "kyrkstöt" ; -- kyrkstöt..nn.1
  kyrktagning_1_N = mkN "kyrktagning" ; -- kyrktagning..nn.1
  kyrktak_1_N = mkN "kyrktak" neutrum  ; -- kyrktak..nn.1
  kyrktorn_1_N = mkN "kyrktorn" neutrum  ; -- kyrktorn..nn.1
  kyrktrogen_1_A = mkA "kyrktrogen" ; -- kyrktrogen..av.1
  kyrktupp_1_N = mkN "kyrktupp" ; -- kyrktupp..nn.1
  kyrkvaktmästare_1_N = mkN "kyrkvaktmästare" utrum  ; -- kyrkvaktmästare..nn.1
  kyrkvärd_1_N = mkN "kyrkvärd" ; -- kyrkvärd..nn.1
  kysk_1_A = mkA "kysk" ; -- kysk..av.1
  kyskhet_1_N = mkN "kyskhet" "kyskheter" ; -- kyskhet..nn.1
  kyskhetsbälte_1_N = mkN "kyskhetsbälte" ; -- kyskhetsbälte..nn.1
  kyskhetslås_1_N = mkN "kyskhetslås" neutrum  ; -- kyskhetslås..nn.1
  kyskhetslöfte_1_N = mkN "kyskhetslöfte" ; -- kyskhetslöfte..nn.1
  kyskhetsnorm_1_N = mkN "kyskhetsnorm" "kyskhetsnormer" ; -- kyskhetsnorm..nn.1
  kyss_1_N = mkN "kyss" ; -- kyss..nn.1
  kyssa_1_V = mkV "kysser" ; -- kyssa..vb.1
  kyssande_1_N = mkN "kyssande" ; -- kyssande..nn.1
  kyssning_1_N = mkN "kyssning" ; -- kyssning..nn.1
  kysstäck_1_A = mkA "kysstäck" ; -- kysstäck..av.1
  kysstäckhet_1_N = mkN "kysstäckhet" ; -- kysstäckhet..nn.1
  kyssäker_1_A = mkA "kyssäker" ; -- kyssäker..av.1
  kyssäkerhet_1_N = mkN "kyssäkerhet" ; -- kyssäkerhet..nn.1
  kyssäkta_1_A = mkA "kyssäkta" ; -- kyssäkta..av.1
  kytt_1_N = mkN "kytt" neutrum  ; -- kytt..nn.1
  käbbel_1_N = mkN "käbbel" neutrum  ; -- käbbel..nn.1
  käbbla_1_V = mkV "käbblar" ; -- käbbla..vb.1
  käbblande_1_N = mkN "käbblande" ; -- käbblande..nn.1
  käbblare_1_N = mkN "käbblare" utrum  ; -- käbblare..nn.1
  käbbleri_1_N = mkN "käbbleri" neutrum  ; -- käbbleri..nn.1
  käck_1_A = mkA "käck" ; -- käck..av.1
  käckhet_1_N = mkN "käckhet" "käckheter" ; -- käckhet..nn.1
  käft_1_N = mkN "käft" ; -- käft..nn.1
  käfta_1_V = mkV "käftar" ; -- käfta..vb.1
  käftande_1_N = mkN "käftande" ; -- käftande..nn.1
  käftsmäll_1_N = mkN "käftsmäll" ; -- käftsmäll..nn.1
  kägel_1_N = mkN "kägel" ; -- kägel..nn.1
  kägelbana_1_N = mkN "kägelbana" ; -- kägelbana..nn.1
  kägelformig_1_A = mkA "kägelformig" ; -- kägelformig..av.1
  kägelformighet_1_N = mkN "kägelformighet" ; -- kägelformighet..nn.1
  kägelsnitt_1_N = mkN "kägelsnitt" neutrum  ; -- kägelsnitt..nn.1
  kägelspelare_1_N = mkN "kägelspelare" utrum  ; -- kägelspelare..nn.1
  kägla_1_N = mkN "kägla" ; -- kägla..nn.1
  käk_1_N = mkN "käk" neutrum  ; -- käk..nn.1
  käka_1_V = mkV "käkar" ; -- käka..vb.1
  käkande_1_N = mkN "käkande" ; -- käkande..nn.1
  käkben_1_N = mkN "käkben" neutrum  ; -- käkben..nn.1
  käke_1_N = mkN "käke" utrum  ; -- käke..nn.1
  käkhåla_1_N = mkN "käkhåla" ; -- käkhåla..nn.1
  käkled_1_N = mkN "käkled" "käkleder" ; -- käkled..nn.1
  käkparti_1_N = mkN "käkparti" "käkpartiet" "käkpartier" "käkpartierna" ; -- käkparti..nn.1
  käkrem_1_N = mkN "käkrem" "käkremmen" "käkremmar" "käkremmarna" ; -- käkrem..nn.1
  käl_1_N = mkN "käl" ; -- käl..nn.1
  käla_1_V = mkV "kälar" ; -- käla..vb.1
  kälande_1_N = mkN "kälande" ; -- kälande..nn.1
  kälhyvel_1_N = mkN "kälhyvel" ; -- kälhyvel..nn.1
  kälkbacke_1_N = mkN "kälkbacke" utrum  ; -- kälkbacke..nn.1
  kälkborgare_1_N = mkN "kälkborgare" utrum  ; -- kälkborgare..nn.1
  kälkborgerlig_1_A = mkA "kälkborgerlig" ; -- kälkborgerlig..av.1
  kälkborgerlighet_1_N = mkN "kälkborgerlighet" ; -- kälkborgerlighet..nn.1
  kälke_1_N = mkN "kälke" utrum  ; -- kälke..nn.1
  källa_1_N = mkN "källa" ; -- källa..nn.1
  källare_1_N = mkN "källare" utrum  ; -- källare..nn.1
  källarhals_1_N = mkN "källarhals" ; -- källarhals..nn.1
  källarlokal_1_N = mkN "källarlokal" "källarlokaler" ; -- källarlokal..nn.1
  källarluft_1_N = mkN "källarluft" ; -- källarluft..nn.1
  källarmästare_1_N = mkN "källarmästare" utrum  ; -- källarmästare..nn.1
  källartrappa_1_N = mkN "källartrappa" ; -- källartrappa..nn.1
  källarvalv_1_N = mkN "källarvalv" neutrum  ; -- källarvalv..nn.1
  källarvåning_1_N = mkN "källarvåning" ; -- källarvåning..nn.1
  källdrag_1_N = mkN "källdrag" neutrum  ; -- källdrag..nn.1
  källflöde_1_N = mkN "källflöde" ; -- källflöde..nn.1
  källforskning_1_N = mkN "källforskning" ; -- källforskning..nn.1
  källfrisk_1_A = mkA "källfrisk" ; -- källfrisk..av.1
  källförteckning_1_N = mkN "källförteckning" ; -- källförteckning..nn.1
  källhänvisning_1_N = mkN "källhänvisning" ; -- källhänvisning..nn.1
  källing_1_N = mkN "källing" ; -- källing..nn.1
  källist_1_N = mkN "källist" "källister" ; -- källist..nn.1
  källkod_1_N = mkN "källkod" ; -- källkod..nn.1
  källkritik_1_N = mkN "källkritik" ; -- källkritik..nn.1
  källkritisk_1_A = mkA "källkritisk" ; -- källkritisk..av.1
  källmaterial_1_N = mkN "källmaterial" neutrum  ; -- källmaterial..nn.1
  källsjö_1_N = mkN "källsjö" ; -- källsjö..nn.1
  källskatt_1_N = mkN "källskatt" "källskatter" ; -- källskatt..nn.1
  källskrift_1_N = mkN "källskrift" "källskrifter" ; -- källskrift..nn.1
  källsortera_1_V = mkV "källsorterar" ; -- källsortera..vb.1
  källsorterande_1_N = mkN "källsorterande" ; -- källsorterande..nn.1
  källsorterbar_1_A = mkA "källsorterbar" ; -- källsorterbar..av.1
  källsorterbarhet_1_N = mkN "källsorterbarhet" ; -- källsorterbarhet..nn.1
  källsortering_1_N = mkN "källsortering" ; -- källsortering..nn.1
  källsprång_1_N = mkN "källsprång" neutrum  ; -- källsprång..nn.1
  källstudium_1_N = mkN "källstudium" "källstudiet" "källstudier" "källstudierna" ; -- källstudium..nn.1
  källvatten_1_N = mkN "källvatten" "källvattnet" "källvatten" "källvattnen" ; -- källvatten..nn.1
  källåder_1_N = mkN "källådra" ; -- källåder..nn.1
  kälning_1_N = mkN "kälning" ; -- kälning..nn.1
  kält_1_N = mkN "kält" neutrum  ; -- kält..nn.1
  kälta_1_V = mkV "kältar" ; -- kälta..vb.1
  kältande_1_N = mkN "kältande" ; -- kältande..nn.1
  kämnärsrätt_1_N = mkN "kämnärsrätt" "kämnärsrätter" ; -- kämnärsrätt..nn.1
  kämpa_1_V = mkV "kämpar" ; -- kämpa..vb.1
  kämpaglöd_1_N = mkN "kämpaglöd" "kämpaglöder" ; -- kämpaglöd..nn.1
  kämpagrav_1_N = mkN "kämpagrav" ; -- kämpagrav..nn.1
  kämpahumör_1_N = mkN "kämpahumör" neutrum  ; -- kämpahumör..nn.1
  kämpalek_1_N = mkN "kämpalek" ; -- kämpalek..nn.1
  kämpalik_1_A = mkA "kämpalik" ; -- kämpalik..av.1
  kämpamässig_1_A = mkA "kämpamässig" ; -- kämpamässig..av.1
  kämpande_1_N = mkN "kämpande" ; -- kämpande..nn.1
  kämpatag_1_N = mkN "kämpatag" neutrum  ; -- kämpatag..nn.1
  kämpe_1_N = mkN "kämpe" utrum  ; -- kämpe..nn.1
  kämpig_1_A = mkA "kämpig" ; -- kämpig..av.1
  kämpighet_1_N = mkN "kämpighet" ; -- kämpighet..nn.1
  känd_1_A = mkA "känd" ; -- känd..av.1
  kändhet_1_N = mkN "kändhet" ; -- kändhet..nn.1
  kändis_1_N = mkN "kändis" ; -- kändis..nn.1
  kändisblogg_1_N = mkN "kändisblogg" ; -- kändisblogg..nn.1
  kändiseri_1_N = mkN "kändiseri" "kändiseriet" "kändiserier" "kändiserierna" ; -- kändiseri..nn.1
  kändiskåt_1_A = mkA "kändiskåt" ; -- kändiskåt..av.1
  kändismassör_1_N = mkN "kändismassör" "kändismassörer" ; -- kändismassör..nn.1
  kändispryl_1_N = mkN "kändispryl" ; -- kändispryl..nn.1
  kändisskap_1_N = mkN "kändisskap" neutrum  ; -- kändisskap..nn.1
  käng_1_N = mkN "käng" "känger" ; -- käng..nn.1
  käng_2_N = mkN "käng" ; -- käng..nn.2
  känga_1_N = mkN "känga" ; -- känga..nn.1
  känguru_1_N = mkN "känguru" "kängurun" "känguruer" "känguruerna" ; -- känguru..nn.1
  kängurupung_1_N = mkN "kängurupung" ; -- kängurupung..nn.1
  känna_1_V = mkV "känna" "kände" "känt" ; -- känna..vb.1
  känna_2_V = mkV "känna" "känne" "känt" ; -- känna..vb.2
  kännande_1_N = mkN "kännande" ; -- kännande..nn.1
  kännarblick_1_N = mkN "kännarblick" ; -- kännarblick..nn.1
  kännare_1_N = mkN "kännare" utrum  ; -- kännare..nn.1
  kännarmin_1_N = mkN "kännarmin" ; -- kännarmin..nn.1
  kännbar_1_A = mkA "kännbar" ; -- kännbar..av.1
  kännbarhet_1_N = mkN "kännbarhet" ; -- kännbarhet..nn.1
  kännedom_1_N = mkN "kännedom" ; -- kännedom..nn.1
  kännemärke_1_N = mkN "kännemärke" ; -- kännemärke..nn.1
  kännetecken_1_N = mkN "kännetecken" "kännetecknet" "kännetecken" "kännetecknen" ; -- kännetecken..nn.1
  känneteckna_1_V = mkV "kännetecknar" ; -- känneteckna..vb.1
  kännetecknande_1_N = mkN "kännetecknande" ; -- kännetecknande..nn.1
  känning_1_N = mkN "känning" ; -- känning..nn.1
  känsel_1_N = mkN "känsel" ; -- känsel..nn.1
  känselhår_1_N = mkN "känselhår" neutrum  ; -- känselhår..nn.1
  känselnerv_1_N = mkN "känselnerv" "känselnerver" ; -- känselnerv..nn.1
  känselorgan_1_N = mkN "känselorgan" neutrum  ; -- känselorgan..nn.1
  känselsensation_1_N = mkN "känselsensation" ; -- känselsensation..nn.1
  känselsinne_1_N = mkN "känselsinne" ; -- känselsinne..nn.1
  känselspröt_1_N = mkN "känselspröt" neutrum  ; -- känselspröt..nn.1
  känsla_1_N = mkN "känsla" ; -- känsla..nn.1
  känslig_1_A = mkA "känslig" ; -- känslig..av.1
  känslighet_1_N = mkN "känslighet" "känsligheter" ; -- känslighet..nn.1
  känsloagitation_1_N = mkN "känsloagitation" ; -- känsloagitation..nn.1
  känsloengagemang_1_N = mkN "känsloengagemang" neutrum  ; -- känsloengagemang..nn.1
  känslofylld_1_A = mkA "känslofylld" "känslofyllt" ; -- känslofylld..av.1
  känslofylldhet_1_N = mkN "känslofylldhet" ; -- känslofylldhet..nn.1
  känsloförmåga_1_N = mkN "känsloförmåga" ; -- känsloförmåga..nn.1
  känsloglöd_1_N = mkN "känsloglöd" ; -- känsloglöd..nn.1
  känsloikon_1_N = mkN "känsloikon" "känsloikoner" ; -- känsloikon..nn.1
  känslokall_1_A = mkA "känslokall" ; -- känslokall..av.1
  känslokyla_1_N = mkN "känslokyla" ; -- känslokyla..nn.1
  känsloladdad_1_A = mkA "känsloladdad" ; -- känsloladdad..av.1
  känsloliv_1_N = mkN "känsloliv" neutrum  ; -- känsloliv..nn.1
  känsloläge_1_N = mkN "känsloläge" ; -- känsloläge..nn.1
  känslolös_1_A = mkA "känslolös" ; -- känslolös..av.1
  känslolöshet_1_N = mkN "känslolöshet" "känslolösheter" ; -- känslolöshet..nn.1
  känslolöshet_2_N = mkN "känslolöshet" ; -- känslolöshet..nn.2
  känslomänniska_1_N = mkN "känslomänniska" ; -- känslomänniska..nn.1
  känslomässig_1_A = mkA "känslomässig" ; -- känslomässig..av.1
  känslomässighet_1_N = mkN "känslomässighet" ; -- känslomässighet..nn.1
  känslopjunk_1_N = mkN "känslopjunk" neutrum  ; -- känslopjunk..nn.1
  känslorik_1_A = mkA "känslorik" ; -- känslorik..av.1
  känslosam_1_A = mkA "känslosam" "känslosamt" "känslosamma" "känslosamma" "känslosammare" "känslosammast" "känslosammaste" ; -- känslosam..av.1
  känslosamhet_1_N = mkN "känslosamhet" "känslosamheter" ; -- känslosamhet..nn.1
  känslospänd_1_A = mkA "känslospänd" ; -- känslospänd..av.1
  känslostorm_1_N = mkN "känslostorm" ; -- känslostorm..nn.1
  känslosträng_1_N = mkN "känslosträng" ; -- känslosträng..nn.1
  känslostämning_1_N = mkN "känslostämning" ; -- känslostämning..nn.1
  känslosvall_1_N = mkN "känslosvall" neutrum  ; -- känslosvall..nn.1
  känslotänkande_1_N = mkN "känslotänkande" ; -- känslotänkande..nn.1
  känsloutbrott_1_N = mkN "känsloutbrott" neutrum  ; -- känsloutbrott..nn.1
  känslouttryck_1_N = mkN "känslouttryck" neutrum  ; -- känslouttryck..nn.1
  känslovärld_1_N = mkN "känslovärld" ; -- känslovärld..nn.1
  känslovåg_1_N = mkN "känslovåg" "känslovågor" ; -- känslovåg..nn.1
  käpp_1_N = mkN "käpp" ; -- käpp..nn.1
  käpphäst_1_N = mkN "käpphäst" ; -- käpphäst..nn.1
  käppkrycka_1_N = mkN "käppkrycka" ; -- käppkrycka..nn.1
  käpprak_1_A = mkA "käpprak" ; -- käpprak..av.1
  käpprätt_1_Adv = mkAdv "käpprätt" ; -- käpprätt..ab.1
  käppslag_1_N = mkN "käppslag" neutrum  ; -- käppslag..nn.1
  kär_1_A = mkA "kär" ; -- kär..av.1
  kära_1_V = mkV "kärar" ; -- kära..vb.1
  kära_2_V = mkV "kärar" ; -- kära..vb.2
  kärande_1_N = mkN "kärande" "käranden" "käranden" "kärandena" ; -- kärande..nn.1
  kärande_2_N = mkN "kärande" ; -- kärande..nn.2
  kärandepart_1_N = mkN "kärandepart" "kärandeparter" ; -- kärandepart..nn.1
  kärandesida_1_N = mkN "kärandesida" ; -- kärandesida..nn.1
  käraste_1_N = mkN "käraste" utrum  ; -- käraste..nn.1
  käresta_1_N = mkN "käresta" ; -- käresta..nn.1
  kärhet_1_N = mkN "kärhet" ; -- kärhet..nn.1
  käril_1_N = mkN "käril" neutrum  ; -- käril..nn.1
  käring_1_N = mkN "käring" ; -- käring..nn.1
  käringknop_1_N = mkN "käringknop" ; -- käringknop..nn.1
  käringknut_1_N = mkN "käringknut" ; -- käringknut..nn.1
  käringnål_1_N = mkN "käringnål" ; -- käringnål..nn.1
  käringprat_1_N = mkN "käringprat" neutrum  ; -- käringprat..nn.1
  käringskvaller_1_N = mkN "käringskvaller" neutrum  ; -- käringskvaller..nn.1
  käringsnack_1_N = mkN "käringsnack" neutrum  ; -- käringsnack..nn.1
  käringtand_1_N = mkN "käringtand" ; -- käringtand..nn.1
  kärkommen_1_A = mkA "kärkommen" "kärkommet" "kärkomna" "kärkomna" "kärkomnare" "kärkomnast" "kärkomnaste" ; -- kärkommen..av.1
  kärkommenhet_1_N = mkN "kärkommenhet" ; -- kärkommenhet..nn.1
  kärl_1_N = mkN "kärl" neutrum  ; -- kärl..nn.1
  kärlek_1_N = mkN "kärlek" ; -- kärlek..nn.1
  kärleksaffär_1_N = mkN "kärleksaffär" "kärleksaffärer" ; -- kärleksaffär..nn.1
  kärleksakt_1_N = mkN "kärleksakt" "kärleksakter" ; -- kärleksakt..nn.1
  kärleksbard_1_N = mkN "kärleksbard" "kärleksbarder" ; -- kärleksbard..nn.1
  kärleksbarn_1_N = mkN "kärleksbarn" neutrum  ; -- kärleksbarn..nn.1
  kärleksberedd_1_A = mkA "kärleksberedd" ; -- kärleksberedd..av.1
  kärleksbesvikelse_1_N = mkN "kärleksbesvikelse" "kärleksbesvikelser" ; -- kärleksbesvikelse..nn.1
  kärleksbetygelse_1_N = mkN "kärleksbetygelse" "kärleksbetygelser" ; -- kärleksbetygelse..nn.1
  kärleksbrev_1_N = mkN "kärleksbrev" neutrum  ; -- kärleksbrev..nn.1
  kärleksbud_1_N = mkN "kärleksbud" neutrum  ; -- kärleksbud..nn.1
  kärleksbudskap_1_N = mkN "kärleksbudskap" neutrum  ; -- kärleksbudskap..nn.1
  kärleksdikt_1_N = mkN "kärleksdikt" "kärleksdikter" ; -- kärleksdikt..nn.1
  kärleksdryck_1_N = mkN "kärleksdryck" "kärleksdrycker" ; -- kärleksdryck..nn.1
  kärleksfull_1_A = mkA "kärleksfull" ; -- kärleksfull..av.1
  kärleksfullhet_1_N = mkN "kärleksfullhet" ; -- kärleksfullhet..nn.1
  kärleksförbindelse_1_N = mkN "kärleksförbindelse" "kärleksförbindelser" ; -- kärleksförbindelse..nn.1
  kärleksförhållande_1_N = mkN "kärleksförhållande" ; -- kärleksförhållande..nn.1
  kärleksförklaring_1_N = mkN "kärleksförklaring" ; -- kärleksförklaring..nn.1
  kärleksglöd_1_N = mkN "kärleksglöd" ; -- kärleksglöd..nn.1
  kärleksgnabb_1_N = mkN "kärleksgnabb" neutrum  ; -- kärleksgnabb..nn.1
  kärleksgud_1_N = mkN "kärleksgud" ; -- kärleksgud..nn.1
  kärleksgudinna_1_N = mkN "kärleksgudinna" ; -- kärleksgudinna..nn.1
  kärleksgärning_1_N = mkN "kärleksgärning" ; -- kärleksgärning..nn.1
  kärlekshistoria_1_N = mkN "kärlekshistoria" "kärlekshistorian" "kärlekshistorier" "kärlekshistorierna" ; -- kärlekshistoria..nn.1
  kärleksknep_1_N = mkN "kärleksknep" neutrum  ; -- kärleksknep..nn.1
  kärlekskonflikt_1_N = mkN "kärlekskonflikt" "kärlekskonflikter" ; -- kärlekskonflikt..nn.1
  kärlekskrank_1_A = mkA "kärlekskrank" ; -- kärlekskrank..av.1
  kärlekskrankhet_1_N = mkN "kärlekskrankhet" ; -- kärlekskrankhet..nn.1
  kärlekskris_1_N = mkN "kärlekskris" "kärlekskriser" ; -- kärlekskris..nn.1
  kärlekskval_1_N = mkN "kärlekskval" neutrum  ; -- kärlekskval..nn.1
  kärleksliv_1_N = mkN "kärleksliv" neutrum  ; -- kärleksliv..nn.1
  kärlekslycka_1_N = mkN "kärlekslycka" ; -- kärlekslycka..nn.1
  kärlekslyrik_1_N = mkN "kärlekslyrik" ; -- kärlekslyrik..nn.1
  kärlekslåga_1_N = mkN "kärlekslåga" ; -- kärlekslåga..nn.1
  kärlekslås_1_N = mkN "kärlekslås" neutrum  ; -- kärlekslås..nn.1
  kärlekslös_1_A = mkA "kärlekslös" ; -- kärlekslös..av.1
  kärlekslöshet_1_N = mkN "kärlekslöshet" ; -- kärlekslöshet..nn.1
  kärleksmelankoli_1_N = mkN "kärleksmelankoli" ; -- kärleksmelankoli..nn.1
  kärleksmums_1_N = mkN "kärleksmums" neutrum  ; -- kärleksmums..nn.1
  kärleksmåltid_1_N = mkN "kärleksmåltid" "kärleksmåltider" ; -- kärleksmåltid..nn.1
  kärleksmöte_1_N = mkN "kärleksmöte" ; -- kärleksmöte..nn.1
  kärleksnatt_1_N = mkN "kärleksnatt" "kärleksnätter" ; -- kärleksnatt..nn.1
  kärleksnovell_1_N = mkN "kärleksnovell" "kärleksnoveller" ; -- kärleksnovell..nn.1
  kärleksord_1_N = mkN "kärleksord" neutrum  ; -- kärleksord..nn.1
  kärlekspar_1_N = mkN "kärlekspar" neutrum  ; -- kärlekspar..nn.1
  kärleksrelation_1_N = mkN "kärleksrelation" ; -- kärleksrelation..nn.1
  kärleksrival_1_N = mkN "kärleksrival" "kärleksrivaler" ; -- kärleksrival..nn.1
  kärleksroman_1_N = mkN "kärleksroman" "kärleksromaner" ; -- kärleksroman..nn.1
  kärleksrus_1_N = mkN "kärleksrus" neutrum  ; -- kärleksrus..nn.1
  kärleksrykte_1_N = mkN "kärleksrykte" ; -- kärleksrykte..nn.1
  kärlekssaga_1_N = mkN "kärlekssaga" ; -- kärlekssaga..nn.1
  kärlekssorg_1_N = mkN "kärlekssorg" "kärlekssorger" ; -- kärlekssorg..nn.1
  kärleksstrejk_1_N = mkN "kärleksstrejk" "kärleksstrejker" ; -- kärleksstrejk..nn.1
  kärlekssång_1_N = mkN "kärlekssång" "kärlekssånger" ; -- kärlekssång..nn.1
  kärlekstunnel_1_N = mkN "kärlekstunnel" ; -- kärlekstunnel..nn.1
  kärlekstörstande_1_A = mkA "kärlekstörstande" ; -- kärlekstörstande..av.1
  kärleksval_1_N = mkN "kärleksval" neutrum  ; -- kärleksval..nn.1
  kärleksvisa_1_N = mkN "kärleksvisa" ; -- kärleksvisa..nn.1
  kärleksäventyr_1_N = mkN "kärleksäventyr" neutrum  ; -- kärleksäventyr..nn.1
  kärleksört_1_N = mkN "kärleksört" ; -- kärleksört..nn.1
  kärlig_1_A = mkA "kärlig" ; -- kärlig..av.1
  kärligen_1_Adv = mkAdv "kärligen" ; -- kärligen..ab.1
  kärlighet_1_N = mkN "kärlighet" ; -- kärlighet..nn.1
  kärlkramp_1_N = mkN "kärlkramp" ; -- kärlkramp..nn.1
  kärlsjukdom_1_N = mkN "kärlsjukdom" ; -- kärlsjukdom..nn.1
  kärlsvulst_1_N = mkN "kärlsvulst" "kärlsvulster" ; -- kärlsvulst..nn.1
  kärlsystem_1_N = mkN "kärlsystem" neutrum  ; -- kärlsystem..nn.1
  kärlvävnad_1_N = mkN "kärlvävnad" "kärlvävnader" ; -- kärlvävnad..nn.1
  kärna_1_N = mkN "kärna" ; -- kärna..nn.1
  kärna_1_V = mkV "kärnar" ; -- kärna..vb.1
  kärnande_1_N = mkN "kärnande" ; -- kärnande..nn.1
  kärnavfallsförvaring_1_N = mkN "kärnavfallsförvaring" ; -- kärnavfallsförvaring..nn.1
  kärnbränsle_1_N = mkN "kärnbränsle" ; -- kärnbränsle..nn.1
  kärnbränsleavfall_1_N = mkN "kärnbränsleavfall" neutrum  ; -- kärnbränsleavfall..nn.1
  kärnbränslehantering_1_N = mkN "kärnbränslehantering" ; -- kärnbränslehantering..nn.1
  kärnenergi_1_N = mkN "kärnenergi" ; -- kärnenergi..nn.1
  kärnfamilj_1_N = mkN "kärnfamilj" "kärnfamiljer" ; -- kärnfamilj..nn.1
  kärnforskning_1_N = mkN "kärnforskning" ; -- kärnforskning..nn.1
  kärnfri_1_A = mkA "kärnfri" "kärnfritt" ; -- kärnfri..av.1
  kärnfrisk_1_A = mkA "kärnfrisk" ; -- kärnfrisk..av.1
  kärnfrukt_1_N = mkN "kärnfrukt" "kärnfrukter" ; -- kärnfrukt..nn.1
  kärnfråga_1_N = mkN "kärnfråga" ; -- kärnfråga..nn.1
  kärnfull_1_A = mkA "kärnfull" ; -- kärnfull..av.1
  kärnfullhet_1_N = mkN "kärnfullhet" "kärnfullheter" ; -- kärnfullhet..nn.1
  kärnfur_1_N = mkN "kärnfur" ; -- kärnfur..nn.1
  kärnfysik_1_N = mkN "kärnfysik" ; -- kärnfysik..nn.1
  kärnförande_1_A = mkA "kärnförande" ; -- kärnförande..av.1
  kärngubbe_1_N = mkN "kärngubbe" utrum  ; -- kärngubbe..nn.1
  kärngumma_1_N = mkN "kärngumma" ; -- kärngumma..nn.1
  kärnhus_1_N = mkN "kärnhus" neutrum  ; -- kärnhus..nn.1
  kärnis_1_N = mkN "kärnis" ; -- kärnis..nn.1
  kärnkemi_1_N = mkN "kärnkemi" ; -- kärnkemi..nn.1
  kärnklyvning_1_N = mkN "kärnklyvning" ; -- kärnklyvning..nn.1
  kärnkraft_1_N = mkN "kärnkraft" ; -- kärnkraft..nn.1
  kärnkraftinspektion_1_N = mkN "kärnkraftinspektion" ; -- kärnkraftinspektion..nn.1
  kärnkraftsavfall_1_N = mkN "kärnkraftsavfall" neutrum  ; -- kärnkraftsavfall..nn.1
  kärnkraftshaveri_1_N = mkN "kärnkraftshaveri" "kärnkraftshaveriet" "kärnkraftshaverier" "kärnkraftshaverierna" ; -- kärnkraftshaveri..nn.1
  kärnkraftskapacitet_1_N = mkN "kärnkraftskapacitet" ; -- kärnkraftskapacitet..nn.1
  kärnkraftskramare_1_N = mkN "kärnkraftskramare" utrum  ; -- kärnkraftskramare..nn.1
  kärnkraftsmotstånd_1_N = mkN "kärnkraftsmotstånd" neutrum  ; -- kärnkraftsmotstånd..nn.1
  kärnkraftsmotståndare_1_N = mkN "kärnkraftsmotståndare" utrum  ; -- kärnkraftsmotståndare..nn.1
  kärnkraftsnedläggning_1_N = mkN "kärnkraftsnedläggning" ; -- kärnkraftsnedläggning..nn.1
  kärnkraftsolycka_1_N = mkN "kärnkraftsolycka" ; -- kärnkraftsolycka..nn.1
  kärnkraftsoperatör_1_N = mkN "kärnkraftsoperatör" "kärnkraftsoperatörer" ; -- kärnkraftsoperatör..nn.1
  kärnkraftsutbyggnad_1_N = mkN "kärnkraftsutbyggnad" ; -- kärnkraftsutbyggnad..nn.1
  kärnkraftsverk_1_N = mkN "kärnkraftsverk" neutrum  ; -- kärnkraftsverk..nn.1
  kärnkraftsäkerhet_1_N = mkN "kärnkraftsäkerhet" "kärnkraftsäkerheter" ; -- kärnkraftsäkerhet..nn.1
  kärnkraftverk_1_N = mkN "kärnkraftverk" neutrum  ; -- kärnkraftverk..nn.1
  kärnkrftsnedläggning_1_N = mkN "kärnkrftsnedläggning" ; -- kärnkrftsnedläggning..nn.1
  kärnladdning_1_N = mkN "kärnladdning" ; -- kärnladdning..nn.1
  kärnland_1_N = mkN "kärnland" neutrum  ; -- kärnland..nn.1
  kärnlinje_1_N = mkN "kärnlinje" "kärnlinjer" ; -- kärnlinje..nn.1
  kärnminne_1_N = mkN "kärnminne" ; -- kärnminne..nn.1
  kärnmjölk_1_N = mkN "kärnmjölk" ; -- kärnmjölk..nn.1
  kärnpartikel_1_N = mkN "kärnpartikel" ; -- kärnpartikel..nn.1
  kärnpunkt_1_N = mkN "kärnpunkt" "kärnpunkter" ; -- kärnpunkt..nn.1
  kärnreaktion_1_N = mkN "kärnreaktion" ; -- kärnreaktion..nn.1
  kärnreaktor_1_N = mkN "kärnreaktor" "kärnreaktorer" ; -- kärnreaktor..nn.1
  kärnreaktorbygge_1_N = mkN "kärnreaktorbygge" ; -- kärnreaktorbygge..nn.1
  kärnrike_1_N = mkN "kärnrike" ; -- kärnrike..nn.1
  kärnskugga_1_N = mkN "kärnskugga" ; -- kärnskugga..nn.1
  kärnstridsspets_1_N = mkN "kärnstridsspets" ; -- kärnstridsspets..nn.1
  kärnsönderfall_1_N = mkN "kärnsönderfall" neutrum  ; -- kärnsönderfall..nn.1
  kärnteknik_1_N = mkN "kärnteknik" ; -- kärnteknik..nn.1
  kärnteknisk_1_A = mkA "kärnteknisk" ; -- kärnteknisk..av.1
  kärnteknologi_1_N = mkN "kärnteknologi" "kärnteknologier" ; -- kärnteknologi..nn.1
  kärntimmer_1_N = mkN "kärntimmer" neutrum  ; -- kärntimmer..nn.1
  kärntrupp_1_N = mkN "kärntrupp" "kärntrupper" ; -- kärntrupp..nn.1
  kärnvapen_1_N = mkN "kärnvapen" "kärnvapnet" "kärnvapen" "kärnvapnen" ; -- kärnvapen..nn.1
  kärnvapenarsenal_1_N = mkN "kärnvapenarsenal" "kärnvapenarsenaler" ; -- kärnvapenarsenal..nn.1
  kärnvapenbegränsning_1_N = mkN "kärnvapenbegränsning" ; -- kärnvapenbegränsning..nn.1
  kärnvapenbestyckad_1_A = mkA "kärnvapenbestyckad" ; -- kärnvapenbestyckad..av.1
  kärnvapenbärande_1_A = mkA "kärnvapenbärande" ; -- kärnvapenbärande..av.1
  kärnvapenexplosion_1_N = mkN "kärnvapenexplosion" ; -- kärnvapenexplosion..nn.1
  kärnvapenfri_1_A = mkA "kärnvapenfri" "kärnvapenfritt" ; -- kärnvapenfri..av.1
  kärnvapenhot_1_N = mkN "kärnvapenhot" neutrum  ; -- kärnvapenhot..nn.1
  kärnvapeninnehav_1_N = mkN "kärnvapeninnehav" neutrum  ; -- kärnvapeninnehav..nn.1
  kärnvapenkod_1_N = mkN "kärnvapenkod" ; -- kärnvapenkod..nn.1
  kärnvapenkrig_1_N = mkN "kärnvapenkrig" neutrum  ; -- kärnvapenkrig..nn.1
  kärnvapenlager_1_N = mkN "kärnvapenlager" neutrum  ; -- kärnvapenlager..nn.1
  kärnvapenmakt_1_N = mkN "kärnvapenmakt" "kärnvapenmakter" ; -- kärnvapenmakt..nn.1
  kärnvapenmässig_1_A = mkA "kärnvapenmässig" ; -- kärnvapenmässig..av.1
  kärnvapenparaply_1_N = mkN "kärnvapenparaply" "kärnvapenparaplyn" "kärnvapenparaplyn" "kärnvapenparaplyna" ; -- kärnvapenparaply..nn.1
  kärnvapenprov_1_N = mkN "kärnvapenprov" neutrum  ; -- kärnvapenprov..nn.1
  kärnvapenprovsprängning_1_N = mkN "kärnvapenprovsprängning" ; -- kärnvapenprovsprängning..nn.1
  kärnvapenstrategi_1_N = mkN "kärnvapenstrategi" "kärnvapenstrategier" ; -- kärnvapenstrategi..nn.1
  kärnved_1_N = mkN "kärnved" ; -- kärnved..nn.1
  kärnverksamhet_1_N = mkN "kärnverksamhet" "kärnverksamheter" ; -- kärnverksamhet..nn.1
  kärnvetemjöl_1_N = mkN "kärnvetemjöl" neutrum  ; -- kärnvetemjöl..nn.1
  kärnvirke_1_N = mkN "kärnvirke" ; -- kärnvirke..nn.1
  kärnväljare_1_N = mkN "kärnväljare" utrum  ; -- kärnväljare..nn.1
  käromål_1_N = mkN "käromål" neutrum  ; -- käromål..nn.1
  kärr_1_N = mkN "kärr" neutrum  ; -- kärr..nn.1
  kärra_1_N = mkN "kärra" ; -- kärra..nn.1
  kärrhjul_1_N = mkN "kärrhjul" neutrum  ; -- kärrhjul..nn.1
  kärrhök_1_N = mkN "kärrhök" ; -- kärrhök..nn.1
  kärrig_1_A = mkA "kärrig" ; -- kärrig..av.1
  kärring_1_N = mkN "kärring" ; -- kärring..nn.1
  kärrmark_1_N = mkN "kärrmark" "kärrmarker" ; -- kärrmark..nn.1
  kärrsnäppa_1_N = mkN "kärrsnäppa" ; -- kärrsnäppa..nn.1
  kärrvial_1_N = mkN "kärrvial" "kärrvialer" ; -- kärrvial..nn.1
  kärrväxt_1_N = mkN "kärrväxt" "kärrväxter" ; -- kärrväxt..nn.1
  kärräng_1_N = mkN "kärräng" ; -- kärräng..nn.1
  kärv_1_A = mkA "kärv" ; -- kärv..av.1
  kärva_1_V = mkV "kärvar" ; -- kärva..vb.1
  kärvande_1_N = mkN "kärvande" ; -- kärvande..nn.1
  kärve_1_N = mkN "kärve" utrum  ; -- kärve..nn.1
  kärvhet_1_N = mkN "kärvhet" ; -- kärvhet..nn.1
  kärvänlig_1_A = mkA "kärvänlig" ; -- kärvänlig..av.1
  kärvänlighet_1_N = mkN "kärvänlighet" "kärvänligheter" ; -- kärvänlighet..nn.1
  kärälskelig_1_A = mkA "kärälskelig" ; -- kärälskelig..av.1
  kärälskelighet_1_N = mkN "kärälskelighet" ; -- kärälskelighet..nn.1
  kärälsklig_1_A = mkA "kärälsklig" ; -- kärälsklig..av.1
  kärälsklighet_1_N = mkN "kärälsklighet" ; -- kärälsklighet..nn.1
  kättarbål_1_N = mkN "kättarbål" neutrum  ; -- kättarbål..nn.1
  kättare_1_N = mkN "kättare" utrum  ; -- kättare..nn.1
  kätte_1_N = mkN "kätte" utrum  ; -- kätte..nn.1
  kätteri_1_N = mkN "kätteri" "kätteriet" "kätterier" "kätterierna" ; -- kätteri..nn.1
  kättersk_1_A = mkA "kättersk" ; -- kättersk..av.1
  kätting_1_N = mkN "kätting" ; -- kätting..nn.1
  kättingdiameter_1_N = mkN "kättingdiameter" ; -- kättingdiameter..nn.1
  kättingspännare_1_N = mkN "kättingspännare" utrum  ; -- kättingspännare..nn.1
  kättja_1_N = mkN "kättja" ; -- kättja..nn.1
  kättjefull_1_A = mkA "kättjefull" ; -- kättjefull..av.1
  kättjefullhet_1_N = mkN "kättjefullhet" ; -- kättjefullhet..nn.1
  käx_1_N = mkN "käx" neutrum  ; -- käx..nn.1
  käx_2_N = mkN "käx" neutrum  ; -- käx..nn.2
  käxa_1_V = mkV "käxar" ; -- käxa..vb.1
  käxande_1_N = mkN "käxande" ; -- käxande..nn.1
  kåda_1_N = mkN "kåda" ; -- kåda..nn.1
  kådig_1_A = mkA "kådig" ; -- kådig..av.1
  kådrik_1_A = mkA "kådrik" ; -- kådrik..av.1
  kådrikhet_1_N = mkN "kådrikhet" ; -- kådrikhet..nn.1
  kåk_1_N = mkN "kåk" ; -- kåk..nn.1
  kåkfarare_1_N = mkN "kåkfarare" utrum  ; -- kåkfarare..nn.1
  kåkstad_1_N = mkN "kåkstad" "kåkstäder" ; -- kåkstad..nn.1
  kåkstrykning_1_N = mkN "kåkstrykning" ; -- kåkstrykning..nn.1
  kål_1_N = mkN "kål" ; -- kål..nn.1
  kåldolma_1_N = mkN "kåldolma" "kåldolman" "kåldolmar" "kåldolmarna" ; -- kåldolma..nn.1
  kåldolme_1_N = mkN "kåldolme" utrum  ; -- kåldolme..nn.1
  kålfjäril_1_N = mkN "kålfjäril" ; -- kålfjäril..nn.1
  kålhuvud_1_N = mkN "kålhuvud" "kålhuvudet" "kålhuvud" "kålhuvudena" ; -- kålhuvud..nn.1
  kållapp_1_N = mkN "kållapp" ; -- kållapp..nn.1
  kålmask_1_N = mkN "kålmask" ; -- kålmask..nn.1
  kålrot_1_N = mkN "kålrot" "kålrötter" ; -- kålrot..nn.1
  kålsoppa_1_N = mkN "kålsoppa" ; -- kålsoppa..nn.1
  kålsuperi_1_N = mkN "kålsuperi" neutrum  ; -- kålsuperi..nn.1
  kånka_1_V = mkV "kånkar" ; -- kånka..vb.1
  kånkande_1_N = mkN "kånkande" ; -- kånkande..nn.1
  kåpa_1_N = mkN "kåpa" ; -- kåpa..nn.1
  kår_1_N = mkN "kår" "kårer" ; -- kår..nn.1
  kåra_1_V = mkV "kårar" ; -- kåra..vb.1
  kåra_2_V = mkV "kårar" ; -- kåra..vb.2
  kåranda_1_N = mkN "kåranda" ; -- kåranda..nn.1
  kårande_1_N = mkN "kårande" ; -- kårande..nn.1
  kåre_1_N = mkN "kåre" utrum  ; -- kåre..nn.1
  kårhus_1_N = mkN "kårhus" neutrum  ; -- kårhus..nn.1
  kårknutte_1_N = mkN "kårknutte" utrum  ; -- kårknutte..nn.1
  kårobligatorium_1_N = mkN "kårobligatorium" "kårobligatoriet" "kårobligatorier" "kårobligatorierna" ; -- kårobligatorium..nn.1
  kårordförande_1_N = mkN "kårordförande" "kårordföranden" "kårordföranden" "kårordförandena" ; -- kårordförande..nn.1
  kårpamp_1_N = mkN "kårpamp" ; -- kårpamp..nn.1
  kåsa_1_N = mkN "kåsa" ; -- kåsa..nn.1
  kåsera_1_V = mkV "kåserar" ; -- kåsera..vb.1
  kåserande_1_N = mkN "kåserande" ; -- kåserande..nn.1
  kåseri_1_N = mkN "kåseri" "kåseriet" "kåserier" "kåserierna" ; -- kåseri..nn.1
  kåseriartad_1_A = mkA "kåseriartad" ; -- kåseriartad..av.1
  kåsering_1_N = mkN "kåsering" ; -- kåsering..nn.1
  kåseristil_1_N = mkN "kåseristil" ; -- kåseristil..nn.1
  kåsör_1_N = mkN "kåsör" "kåsörer" ; -- kåsör..nn.1
  kåsörprosa_1_N = mkN "kåsörprosa" ; -- kåsörprosa..nn.1
  kåt_1_A = mkA "kåt" ; -- kåt..av.1
  kåta_1_N = mkN "kåta" ; -- kåta..nn.1
  kåtbock_1_N = mkN "kåtbock" ; -- kåtbock..nn.1
  kåthet_1_N = mkN "kåthet" ; -- kåthet..nn.1
  kåtma_1_N = mkN "kåtma" ; -- kåtma..nn.1
  kåtslag_1_N = mkN "kåtslag" neutrum  ; -- kåtslag..nn.1
  kö_1_N = mkN "kö" "kön" "köer" "köerna" ; -- kö..nn.1
  köa_1_V = mkV "köar" ; -- köa..vb.1
  köande_1_N = mkN "köande" ; -- köande..nn.1
  köbildning_1_N = mkN "köbildning" ; -- köbildning..nn.1
  köbricka_1_N = mkN "köbricka" ; -- köbricka..nn.1
  köckenmödding_1_N = mkN "köckenmödding" ; -- köckenmödding..nn.1
  kök_1_N = mkN "kök" neutrum  ; -- kök..nn.1
  kökkenmödding_1_N = mkN "kökkenmödding" ; -- kökkenmödding..nn.1
  köksa_1_N = mkN "köksa" ; -- köksa..nn.1
  köksavfall_1_N = mkN "köksavfall" neutrum  ; -- köksavfall..nn.1
  köksbord_1_N = mkN "köksbord" neutrum  ; -- köksbord..nn.1
  köksbordssamtal_1_N = mkN "köksbordssamtal" neutrum  ; -- köksbordssamtal..nn.1
  köksbordsturné_1_N = mkN "köksbordsturné" "köksbordsturnéer" ; -- köksbordsturné..nn.1
  köksdörr_1_N = mkN "köksdörr" ; -- köksdörr..nn.1
  köksfläkt_1_N = mkN "köksfläkt" ; -- köksfläkt..nn.1
  köksfönster_1_N = mkN "köksfönster" neutrum  ; -- köksfönster..nn.1
  köksförkläde_1_N = mkN "köksförkläde" ; -- köksförkläde..nn.1
  kökshandduk_1_N = mkN "kökshandduk" ; -- kökshandduk..nn.1
  kökshus_1_N = mkN "kökshus" neutrum  ; -- kökshus..nn.1
  kökshydda_1_N = mkN "kökshydda" ; -- kökshydda..nn.1
  köksingång_1_N = mkN "köksingång" ; -- köksingång..nn.1
  kökskniv_1_N = mkN "kökskniv" neutrum  ; -- kökskniv..nn.1
  kökslatin_1_N = mkN "kökslatin" neutrum  ; -- kökslatin..nn.1
  köksmaskin_1_N = mkN "köksmaskin" "köksmaskiner" ; -- köksmaskin..nn.1
  köksmästare_1_N = mkN "köksmästare" utrum  ; -- köksmästare..nn.1
  köksrulle_1_N = mkN "köksrulle" utrum  ; -- köksrulle..nn.1
  kökssax_1_N = mkN "kökssax" ; -- kökssax..nn.1
  köksskjul_1_N = mkN "köksskjul" neutrum  ; -- köksskjul..nn.1
  kökssoffa_1_N = mkN "kökssoffa" ; -- kökssoffa..nn.1
  köksspis_1_N = mkN "köksspis" ; -- köksspis..nn.1
  köksstol_1_N = mkN "köksstol" ; -- köksstol..nn.1
  kökssvamp_1_N = mkN "kökssvamp" ; -- kökssvamp..nn.1
  kökstak_1_N = mkN "kökstak" neutrum  ; -- kökstak..nn.1
  köksträdgård_1_N = mkN "köksträdgård" ; -- köksträdgård..nn.1
  kökstält_1_N = mkN "kökstält" neutrum  ; -- kökstält..nn.1
  köksväxt_1_N = mkN "köksväxt" "köksväxter" ; -- köksväxt..nn.1
  köksö_1_N = mkN "köksö" ; -- köksö..nn.1
  köl_1_N = mkN "köl" ; -- köl..nn.1
  kölad_1_A = mkA "kölad" ; -- kölad..av.1
  kölapp_1_N = mkN "kölapp" ; -- kölapp..nn.1
  kölbult_1_N = mkN "kölbult" ; -- kölbult..nn.1
  kölbåt_1_N = mkN "kölbåt" ; -- kölbåt..nn.1
  köld_1_N = mkN "köld" ; -- köld..nn.1
  köldbeständig_1_A = mkA "köldbeständig" ; -- köldbeständig..av.1
  köldbeständighet_1_N = mkN "köldbeständighet" ; -- köldbeständighet..nn.1
  köldblandning_1_N = mkN "köldblandning" ; -- köldblandning..nn.1
  köldgrad_1_N = mkN "köldgrad" "köldgrader" ; -- köldgrad..nn.1
  köldhärdig_1_A = mkA "köldhärdig" ; -- köldhärdig..av.1
  köldhärdighet_1_N = mkN "köldhärdighet" ; -- köldhärdighet..nn.1
  köldknäpp_1_N = mkN "köldknäpp" ; -- köldknäpp..nn.1
  köldpol_1_N = mkN "köldpol" "köldpoler" ; -- köldpol..nn.1
  köldpunkt_1_N = mkN "köldpunkt" "köldpunkter" ; -- köldpunkt..nn.1
  köldskada_1_N = mkN "köldskada" ; -- köldskada..nn.1
  köldskadad_1_A = mkA "köldskadad" ; -- köldskadad..av.1
  köldväder_1_N = mkN "köldväder" neutrum  ; -- köldväder..nn.1
  kölfena_1_N = mkN "kölfena" ; -- kölfena..nn.1
  kölhala_1_V = mkV "kölhalar" ; -- kölhala..vb.1
  kölhala_2_V = mkV "kölhalar" ; -- kölhala..vb.2
  kölhalande_1_N = mkN "kölhalande" ; -- kölhalande..nn.1
  kölhalning_1_N = mkN "kölhalning" ; -- kölhalning..nn.1
  kölna_1_N = mkN "kölna" ; -- kölna..nn.1
  kölskena_1_N = mkN "kölskena" ; -- kölskena..nn.1
  kölsträckning_1_N = mkN "kölsträckning" ; -- kölsträckning..nn.1
  kölsvin_1_N = mkN "kölsvin" neutrum  ; -- kölsvin..nn.1
  kön_1_N = mkN "kön" neutrum  ; -- kön..nn.1
  köna_1_V = mkV "könar" ; -- köna..vb.1
  könande_1_N = mkN "könande" ; -- könande..nn.1
  könlig_1_A = mkA "könlig" ; -- könlig..av.1
  könlighet_1_N = mkN "könlighet" ; -- könlighet..nn.1
  könlös_1_A = mkA "könlös" ; -- könlös..av.1
  könlöshet_1_N = mkN "könlöshet" ; -- könlöshet..nn.1
  könsakt_1_N = mkN "könsakt" "könsakter" ; -- könsakt..nn.1
  könsapartheid_1_N = mkN "könsapartheid" ; -- könsapartheid..nn.1
  könsbehåring_1_N = mkN "könsbehåring" ; -- könsbehåring..nn.1
  könsbunden_1_A = mkA "könsbunden" ; -- könsbunden..av.1
  könsbundenhet_1_N = mkN "könsbundenhet" ; -- könsbundenhet..nn.1
  könsbyte_1_N = mkN "könsbyte" ; -- könsbyte..nn.1
  könscell_1_N = mkN "könscell" "könsceller" ; -- könscell..nn.1
  könsdiskriminera_1_V = mkV "könsdiskriminerar" ; -- könsdiskriminera..vb.1
  könsdiskriminerande_1_N = mkN "könsdiskriminerande" ; -- könsdiskriminerande..nn.1
  könsdiskriminerbar_1_A = mkA "könsdiskriminerbar" ; -- könsdiskriminerbar..av.1
  könsdiskriminerbarhet_1_N = mkN "könsdiskriminerbarhet" ; -- könsdiskriminerbarhet..nn.1
  könsdiskriminering_1_N = mkN "könsdiskriminering" ; -- könsdiskriminering..nn.1
  könsdrift_1_N = mkN "könsdrift" ; -- könsdrift..nn.1
  könsfördelning_1_N = mkN "könsfördelning" ; -- könsfördelning..nn.1
  könshormon_1_N = mkN "könshormon" neutrum  ; -- könshormon..nn.1
  könshår_1_N = mkN "könshår" neutrum  ; -- könshår..nn.1
  könshår_2_N = mkN "könshår" neutrum  ; -- könshår..nn.2
  könsidentitet_1_N = mkN "könsidentitet" "könsidentiteter" ; -- könsidentitet..nn.1
  könskaraktär_1_N = mkN "könskaraktär" "könskaraktärer" ; -- könskaraktär..nn.1
  könskvotera_1_V = mkV "könskvoterar" ; -- könskvotera..vb.1
  könskvoterande_1_N = mkN "könskvoterande" ; -- könskvoterande..nn.1
  könskvoterbar_1_A = mkA "könskvoterbar" ; -- könskvoterbar..av.1
  könskvoterbarhet_1_N = mkN "könskvoterbarhet" ; -- könskvoterbarhet..nn.1
  könskvotering_1_N = mkN "könskvotering" ; -- könskvotering..nn.1
  könskyla_1_N = mkN "könskyla" ; -- könskyla..nn.1
  könskörtel_1_N = mkN "könskörtel" ; -- könskörtel..nn.1
  könslig_1_A = mkA "könslig" ; -- könslig..av.1
  könslighet_1_N = mkN "könslighet" ; -- könslighet..nn.1
  könsliv_1_N = mkN "könsliv" neutrum  ; -- könsliv..nn.1
  könsmakt_1_N = mkN "könsmakt" ; -- könsmakt..nn.1
  könsmaktsordning_1_N = mkN "könsmaktsordning" ; -- könsmaktsordning..nn.1
  könsmogen_1_A = mkA "könsmogen" ; -- könsmogen..av.1
  könsmogenhet_1_N = mkN "könsmogenhet" ; -- könsmogenhet..nn.1
  könsmognad_1_N = mkN "könsmognad" "könsmognader" ; -- könsmognad..nn.1
  könsmässig_1_A = mkA "könsmässig" ; -- könsmässig..av.1
  könsneutral_1_A = mkA "könsneutral" ; -- könsneutral..av.1
  könsord_1_N = mkN "könsord" neutrum  ; -- könsord..nn.1
  könsorgan_1_N = mkN "könsorgan" neutrum  ; -- könsorgan..nn.1
  könspanik_1_N = mkN "könspanik" ; -- könspanik..nn.1
  könsrelaterad_1_A = mkA "könsrelaterad" ; -- könsrelaterad..av.1
  könsroll_1_N = mkN "könsroll" "könsroller" ; -- könsroll..nn.1
  könsrollsmönster_1_N = mkN "könsrollsmönster" neutrum  ; -- könsrollsmönster..nn.1
  könssegregering_1_N = mkN "könssegregering" ; -- könssegregering..nn.1
  könssjukdom_1_N = mkN "könssjukdom" ; -- könssjukdom..nn.1
  könsskillnad_1_N = mkN "könsskillnad" "könsskillnader" ; -- könsskillnad..nn.1
  könsskämt_1_N = mkN "könsskämt" neutrum  ; -- könsskämt..nn.1
  könsspecifik_1_A = mkA "könsspecifik" ; -- könsspecifik..av.1
  könsstympning_1_N = mkN "könsstympning" ; -- könsstympning..nn.1
  könsumgänge_1_N = mkN "könsumgänge" ; -- könsumgänge..nn.1
  könsuppdelad_1_A = mkA "könsuppdelad" ; -- könsuppdelad..av.1
  könsutjämning_1_N = mkN "könsutjämning" ; -- könsutjämning..nn.1
  könsvarelse_1_N = mkN "könsvarelse" "könsvarelser" ; -- könsvarelse..nn.1
  könsöverskridande_1_A = mkA "könsöverskridande" ; -- könsöverskridande..av.1
  köp_slit_och_släng_1_N = mkN "köp-slit-och-släng" ; -- köp-slit-och-släng..nn.1
  köp_1_N = mkN "köp" neutrum  ; -- köp..nn.1
  köpa_1_V = mkV "köper" ; -- köpa..vb.1
  köpa_2_V = mkV "köper" ; -- köpa..vb.2
  köpande_1_N = mkN "köpande" ; -- köpande..nn.1
  köpare_1_N = mkN "köpare" utrum  ; -- köpare..nn.1
  köpbeteende_1_N = mkN "köpbeteende" ; -- köpbeteende..nn.1
  köpcentrum_1_N = mkN "köpcentrum" neutrum  ; -- köpcentrum..nn.1
  köpeavtal_1_N = mkN "köpeavtal" neutrum  ; -- köpeavtal..nn.1
  köpebrev_1_N = mkN "köpebrev" neutrum  ; -- köpebrev..nn.1
  köpebröd_1_N = mkN "köpebröd" neutrum  ; -- köpebröd..nn.1
  köpehandling_1_N = mkN "köpehandling" ; -- köpehandling..nn.1
  köpekontrakt_1_N = mkN "köpekontrakt" neutrum  ; -- köpekontrakt..nn.1
  köpenickiad_1_N = mkN "köpenickiad" "köpenickiader" ; -- köpenickiad..nn.1
  köpenskap_1_N = mkN "köpenskap" "köpenskaper" ; -- köpenskap..nn.1
  köpeskilling_1_N = mkN "köpeskilling" ; -- köpeskilling..nn.1
  köpesumma_1_N = mkN "köpesumma" ; -- köpesumma..nn.1
  köpgalen_1_A = mkA "köpgalen" ; -- köpgalen..av.1
  köphets_1_N = mkN "köphets" ; -- köphets..nn.1
  köping_1_N = mkN "köping" ; -- köping..nn.1
  köpkort_1_N = mkN "köpkort" neutrum  ; -- köpkort..nn.1
  köpkraft_1_N = mkN "köpkraft" ; -- köpkraft..nn.1
  köpkraftstark_1_A = mkA "köpkraftstark" ; -- köpkraftstark..av.1
  köpkurs_1_N = mkN "köpkurs" "köpkurser" ; -- köpkurs..nn.1
  köplada_1_N = mkN "köplada" ; -- köplada..nn.1
  köplust_1_N = mkN "köplust" ; -- köplust..nn.1
  köplysten_1_A = mkA "köplysten" ; -- köplysten..av.1
  köpman_1_N = mkN "köpman" "köpmannen" "köpmän" "köpmännen" ; -- köpman..nn.1
  köprond_1_N = mkN "köprond" "köpronder" ; -- köprond..nn.1
  köpslagning_1_N = mkN "köpslagning" ; -- köpslagning..nn.1
  köpslut_1_N = mkN "köpslut" neutrum  ; -- köpslut..nn.1
  köpslå_1_V = mkV "köpslå" "köpslog" "köpslagit" ; -- köpslå..vb.1
  köpslående_1_N = mkN "köpslående" ; -- köpslående..nn.1
  köpstad_1_N = mkN "köpstad" "köpstäder" ; -- köpstad..nn.1
  köpstark_1_A = mkA "köpstark" ; -- köpstark..av.1
  köpvana_1_N = mkN "köpvana" ; -- köpvana..nn.1
  köpvillkor_1_N = mkN "köpvillkor" neutrum  ; -- köpvillkor..nn.1
  köpvärd_1_A = mkA "köpvärd" "köpvärt" ; -- köpvärd..av.1
  kör_1_N = mkN "kör" "körer" ; -- kör..nn.1
  köra_1_V = mkV "köra" "körde" "kört" ; -- köra..vb.1
  körande_1_N = mkN "körande" ; -- körande..nn.1
  körare_1_N = mkN "körare" utrum  ; -- körare..nn.1
  körbana_1_N = mkN "körbana" ; -- körbana..nn.1
  körbar_1_A = mkA "körbar" ; -- körbar..av.1
  körbarhet_1_N = mkN "körbarhet" ; -- körbarhet..nn.1
  körd_1_A = mkA "körd" "kört" ; -- körd..av.1
  kördhet_1_N = mkN "kördhet" ; -- kördhet..nn.1
  köregenskap_1_N = mkN "köregenskap" "köregenskaper" ; -- köregenskap..nn.1
  körfält_1_N = mkN "körfält" neutrum  ; -- körfält..nn.1
  körförbud_1_N = mkN "körförbud" neutrum  ; -- körförbud..nn.1
  körig_1_A = mkA "körig" ; -- körig..av.1
  körkarl_1_N = mkN "körkarl" ; -- körkarl..nn.1
  körklar_1_A = mkA "körklar" ; -- körklar..av.1
  körkort_1_N = mkN "körkort" neutrum  ; -- körkort..nn.1
  körkortsinnehavare_1_N = mkN "körkortsinnehavare" utrum  ; -- körkortsinnehavare..nn.1
  körkortsprov_1_N = mkN "körkortsprov" neutrum  ; -- körkortsprov..nn.1
  körkortssökande_1_N = mkN "körkortssökande" "körkortssökanden" "körkortssökanden" "körkortssökandena" ; -- körkortssökande..nn.1
  körkortstillstånd_1_N = mkN "körkortstillstånd" neutrum  ; -- körkortstillstånd..nn.1
  körkortsålder_1_N = mkN "körkortsålder" ; -- körkortsålder..nn.1
  körledare_1_N = mkN "körledare" utrum  ; -- körledare..nn.1
  körlektion_1_N = mkN "körlektion" ; -- körlektion..nn.1
  körna_1_V = mkV "körnar" ; -- körna..vb.1
  körnande_1_N = mkN "körnande" ; -- körnande..nn.1
  körnare_1_N = mkN "körnare" utrum  ; -- körnare..nn.1
  körning_1_N = mkN "körning" ; -- körning..nn.1
  körriktningsvisare_1_N = mkN "körriktningsvisare" utrum  ; -- körriktningsvisare..nn.1
  körsbär_1_N = mkN "körsbär" neutrum  ; -- körsbär..nn.1
  körsbärsfaner_1_N = mkN "körsbärsfaner" "körsbärsfaneret" "körsbärsfaner" "körsbärsfaneren" ; -- körsbärsfaner..nn.1
  körsbärsfanerad_1_A = mkA "körsbärsfanerad" ; -- körsbärsfanerad..av.1
  körsbärsfanér_1_N = mkN "körsbärsfanér" neutrum  ; -- körsbärsfanér..nn.1
  körsbärsfärgad_1_A = mkA "körsbärsfärgad" ; -- körsbärsfärgad..av.1
  körsbärskärna_1_N = mkN "körsbärskärna" ; -- körsbärskärna..nn.1
  körsbärsröd_1_A = mkA "körsbärsröd" "körsbärsrött" ; -- körsbärsröd..av.1
  körsbärsträ_1_N = mkN "körsbärsträ" neutrum  ; -- körsbärsträ..nn.1
  körsbärsträd_1_N = mkN "körsbärsträd" neutrum  ; -- körsbärsträd..nn.1
  körsel_1_N = mkN "körsel" ; -- körsel..nn.1
  körsla_1_N = mkN "körsla" ; -- körsla..nn.1
  körsnär_1_N = mkN "körsnär" "körsnärer" ; -- körsnär..nn.1
  körsträcka_1_N = mkN "körsträcka" ; -- körsträcka..nn.1
  körsven_1_N = mkN "körsven" "körsvennen" "körsvenner" "körsvennerna" ; -- körsven..nn.1
  körsång_1_N = mkN "körsång" ; -- körsång..nn.1
  körsångare_1_N = mkN "körsångare" utrum  ; -- körsångare..nn.1
  körtel_1_N = mkN "körtel" ; -- körtel..nn.1
  körtelcell_1_N = mkN "körtelcell" "körtelceller" ; -- körtelcell..nn.1
  körtelöppning_1_N = mkN "körtelöppning" ; -- körtelöppning..nn.1
  körtid_1_N = mkN "körtid" "körtider" ; -- körtid..nn.1
  körvel_1_N = mkN "körvel" ; -- körvel..nn.1
  körvisa_1_N = mkN "körvisa" ; -- körvisa..nn.1
  körväg_1_N = mkN "körväg" ; -- körväg..nn.1
  köställ_1_N = mkN "köställ" neutrum  ; -- köställ..nn.1
  kött_1_N = mkN "kött" neutrum  ; -- kött..nn.1
  köttben_1_N = mkN "köttben" neutrum  ; -- köttben..nn.1
  köttben_2_N = mkN "köttben" neutrum  ; -- köttben..nn.2
  köttberg_1_N = mkN "köttberg" neutrum  ; -- köttberg..nn.1
  köttbit_1_N = mkN "köttbit" ; -- köttbit..nn.1
  köttbonde_1_N = mkN "köttbonde" "köttbönder" ; -- köttbonde..nn.1
  köttboskap_1_N = mkN "köttboskap" ; -- köttboskap..nn.1
  köttbulle_1_N = mkN "köttbulle" utrum  ; -- köttbulle..nn.1
  köttbullssmörgås_1_N = mkN "köttbullssmörgås" ; -- köttbullssmörgås..nn.1
  köttbullsälskare_1_N = mkN "köttbullsälskare" utrum  ; -- köttbullsälskare..nn.1
  köttdisk_1_N = mkN "köttdisk" ; -- köttdisk..nn.1
  kötted_1_N = mkN "kötted" "kötteder" ; -- kötted..nn.1
  köttfluga_1_N = mkN "köttfluga" ; -- köttfluga..nn.1
  köttfärgad_1_A = mkA "köttfärgad" ; -- köttfärgad..av.1
  köttfärs_1_N = mkN "köttfärs" ; -- köttfärs..nn.1
  köttfärslimpa_1_N = mkN "köttfärslimpa" ; -- köttfärslimpa..nn.1
  köttfärsskandal_1_N = mkN "köttfärsskandal" "köttfärsskandaler" ; -- köttfärsskandal..nn.1
  köttgryta_1_N = mkN "köttgryta" ; -- köttgryta..nn.1
  köttig_1_A = mkA "köttig" ; -- köttig..av.1
  köttighet_1_N = mkN "köttighet" ; -- köttighet..nn.1
  köttklister_1_N = mkN "köttklister" neutrum  ; -- köttklister..nn.1
  köttko_1_N = mkN "köttko" "köttkor" ; -- köttko..nn.1
  köttkonnässör_1_N = mkN "köttkonnässör" "köttkonnässörer" ; -- köttkonnässör..nn.1
  köttkvarn_1_N = mkN "köttkvarn" ; -- köttkvarn..nn.1
  köttlös_1_A = mkA "köttlös" ; -- köttlös..av.1
  köttmarknad_1_N = mkN "köttmarknad" "köttmarknader" ; -- köttmarknad..nn.1
  köttodling_1_N = mkN "köttodling" ; -- köttodling..nn.1
  köttproduktion_1_N = mkN "köttproduktion" ; -- köttproduktion..nn.1
  köttrymd_1_N = mkN "köttrymd" ; -- köttrymd..nn.1
  kötträtt_1_N = mkN "kötträtt" "kötträtter" ; -- kötträtt..nn.1
  köttsaft_1_N = mkN "köttsaft" "köttsafter" ; -- köttsaft..nn.1
  köttsida_1_N = mkN "köttsida" ; -- köttsida..nn.1
  köttskada_1_N = mkN "köttskada" ; -- köttskada..nn.1
  köttskiva_1_N = mkN "köttskiva" ; -- köttskiva..nn.1
  köttslamsa_1_N = mkN "köttslamsa" ; -- köttslamsa..nn.1
  köttslig_1_A = mkA "köttslig" ; -- köttslig..av.1
  köttslighet_1_N = mkN "köttslighet" ; -- köttslighet..nn.1
  köttsoppa_1_N = mkN "köttsoppa" ; -- köttsoppa..nn.1
  köttstycke_1_N = mkN "köttstycke" ; -- köttstycke..nn.1
  köttsåg_1_N = mkN "köttsåg" ; -- köttsåg..nn.1
  köttsår_1_N = mkN "köttsår" neutrum  ; -- köttsår..nn.1
  köttvilt_1_N = mkN "köttvilt" neutrum  ; -- köttvilt..nn.1
  köttvin_1_N = mkN "köttvin" "köttvinet" "köttviner" "köttvinerna" ; -- köttvin..nn.1
  köttyxa_1_N = mkN "köttyxa" ; -- köttyxa..nn.1
  köttätande_1_A = mkA "köttätande" ; -- köttätande..av.1
  köttätare_1_N = mkN "köttätare" utrum  ; -- köttätare..nn.1
  köva_1_V = mkV "köver" ; -- köva..vb.1
  kövande_1_N = mkN "kövande" ; -- kövande..nn.1
  l_1_N = mkN "l" neutrum  ; -- l..nn.1
  la_1_Adv = mkAdv "la" ; -- la..ab.1
  lab_1_N = mkN "lab" ; -- lab..nn.1
  lab_2_N = mkN "lab" neutrum  ; -- lab..nn.2
  labb_1_N = mkN "labb" ; -- labb..nn.1
  labb_2_N = mkN "labb" neutrum  ; -- labb..nn.2
  labbe_1_N = mkN "labb" ; -- labbe..nn.1
  laber_1_A = mkA "laber" ; -- laber..av.1
  labial_1_A = mkA "labial" ; -- labial..av.1
  labial_1_N = mkN "labial" "labialer" ; -- labial..nn.1
  labialisera_1_V = mkV "labialiserar" ; -- labialisera..vb.1
  labialiserad_1_A = mkA "labialiserad" ; -- labialiserad..av.1
  labialiserande_1_N = mkN "labialiserande" ; -- labialiserande..nn.1
  labialiserbar_1_A = mkA "labialiserbar" ; -- labialiserbar..av.1
  labialiserbarhet_1_N = mkN "labialiserbarhet" ; -- labialiserbarhet..nn.1
  labialisering_1_N = mkN "labialisering" ; -- labialisering..nn.1
  labialpipa_1_N = mkN "labialpipa" ; -- labialpipa..nn.1
  labialstämma_1_N = mkN "labialstämma" ; -- labialstämma..nn.1
  labil_1_A = mkA "labil" ; -- labil..av.1
  labilitet_1_N = mkN "labilitet" "labiliteter" ; -- labilitet..nn.1
  labiodental_1_A = mkA "labiodental" ; -- labiodental..av.1
  labiodental_1_N = mkN "labiodental" "labiodentaler" ; -- labiodental..nn.1
  labiologi_1_N = mkN "labiologi" ; -- labiologi..nn.1
  laborant_1_N = mkN "laborant" "laboranter" ; -- laborant..nn.1
  laboration_1_N = mkN "laboration" ; -- laboration..nn.1
  laborativ_1_A = mkA "laborativ" ; -- laborativ..av.1
  laborator_1_N = mkN "laborator" "laboratorer" ; -- laborator..nn.1
  laboratorieassistent_1_N = mkN "laboratorieassistent" "laboratorieassistenter" ; -- laboratorieassistent..nn.1
  laboratorieexperiment_1_N = mkN "laboratorieexperiment" neutrum  ; -- laboratorieexperiment..nn.1
  laboratoriekuriosa_1_N = mkN "laboratoriekuriosa" ; -- laboratoriekuriosa..nn.1
  laboratoriemässig_1_A = mkA "laboratoriemässig" ; -- laboratoriemässig..av.1
  laboratorieresultat_1_N = mkN "laboratorieresultat" neutrum  ; -- laboratorieresultat..nn.1
  laboratorierock_1_N = mkN "laboratorierock" ; -- laboratorierock..nn.1
  laboratorieråtta_1_N = mkN "laboratorieråtta" ; -- laboratorieråtta..nn.1
  laboratorium_1_N = mkN "laboratorium" "laboratoriet" "laboratorier" "laboratorierna" ; -- laboratorium..nn.1
  laborera_1_V = mkV "laborerar" ; -- laborera..vb.1
  laborerande_1_N = mkN "laborerande" ; -- laborerande..nn.1
  laborering_1_N = mkN "laborering" ; -- laborering..nn.1
  labour_1_N = mkN "labour" ; -- labour..nn.1
  labourregering_1_N = mkN "labourregering" ; -- labourregering..nn.1
  labrador_1_N = mkN "labrador" "labradoren" "labradorer" "labradorerna" ; -- labrador..nn.1
  labrador_2_N = mkN "labrador" ; -- labrador..nn.2
  labradorhanne_1_N = mkN "labradorhanne" utrum  ; -- labradorhanne..nn.1
  labyrint_1_N = mkN "labyrint" "labyrinter" ; -- labyrint..nn.1
  labyrintisk_1_A = mkA "labyrintisk" ; -- labyrintisk..av.1
  lack_1_A = mkA "lack" ; -- lack..av.1
  lack_1_N = mkN "lack" neutrum  ; -- lack..nn.1
  lack_2_N = mkN "lack" ; -- lack..nn.2
  lacka_1_V = mkV "lackar" ; -- lacka..vb.1
  lacka_2_V = mkV "lackar" ; -- lacka..vb.2
  lackande_1_N = mkN "lackande" ; -- lackande..nn.1
  lackera_1_V = mkV "lackerar" ; -- lackera..vb.1
  lackerande_1_N = mkN "lackerande" ; -- lackerande..nn.1
  lackerbar_1_A = mkA "lackerbar" ; -- lackerbar..av.1
  lackerbarhet_1_N = mkN "lackerbarhet" ; -- lackerbarhet..nn.1
  lackering_1_N = mkN "lackering" ; -- lackering..nn.1
  lackfärg_1_N = mkN "lackfärg" "lackfärger" ; -- lackfärg..nn.1
  lackmus_1_N = mkN "lackmus" ; -- lackmus..nn.1
  lackmuspapper_1_N = mkN "lackmuspapper" neutrum  ; -- lackmuspapper..nn.1
  lackmustest_1_N = mkN "lackmustest" neutrum  ; -- lackmustest..nn.1
  lacknafta_1_N = mkN "lacknafta" ; -- lacknafta..nn.1
  lackning_1_N = mkN "lackning" ; -- lackning..nn.1
  lackpensel_1_N = mkN "lackpensel" ; -- lackpensel..nn.1
  lackroller_1_N = mkN "lackroller" ; -- lackroller..nn.1
  lackrulle_1_N = mkN "lackrulle" utrum  ; -- lackrulle..nn.1
  lacksko_1_N = mkN "lacksko" "lackskor" ; -- lacksko..nn.1
  lackskärp_1_N = mkN "lackskärp" neutrum  ; -- lackskärp..nn.1
  lacksköldlus_1_N = mkN "lacksköldlus" "lacksköldlusen" "lacksköldlöss" "lacksköldlössen" ; -- lacksköldlus..nn.1
  lackviol_1_N = mkN "lackviol" "lackvioler" ; -- lackviol..nn.1
  lad_1_N = mkN "lad" neutrum  ; -- lad..nn.1
  lada_1_N = mkN "lada" ; -- lada..nn.1
  ladda_1_V = mkV "laddar" ; -- ladda..vb.1
  laddad_1_A = mkA "laddad" ; -- laddad..av.1
  laddande_1_N = mkN "laddande" ; -- laddande..nn.1
  laddare_1_N = mkN "laddare" utrum  ; -- laddare..nn.1
  laddindicering_1_N = mkN "laddindicering" ; -- laddindicering..nn.1
  laddindikering_1_N = mkN "laddindikering" ; -- laddindikering..nn.1
  laddning_1_N = mkN "laddning" ; -- laddning..nn.1
  laddningsregulator_1_N = mkN "laddningsregulator" "laddningsregulatorer" ; -- laddningsregulator..nn.1
  laddningsstolpe_1_N = mkN "laddningsstolpe" utrum  ; -- laddningsstolpe..nn.1
  laddningsström_1_N = mkN "laddningsström" "laddningsströmmen" "laddningsströmmar" "laddningsströmmarna" ; -- laddningsström..nn.1
  laddningstid_1_N = mkN "laddningstid" "laddningstider" ; -- laddningstid..nn.1
  laddram_1_N = mkN "laddram" ; -- laddram..nn.1
  laddstock_1_N = mkN "laddstock" ; -- laddstock..nn.1
  laddstolpe_1_N = mkN "laddstolpe" utrum  ; -- laddstolpe..nn.1
  laddström_1_N = mkN "laddström" "laddströmmen" "laddströmmar" "laddströmmarna" ; -- laddström..nn.1
  ladugård_1_N = mkN "ladugård" ; -- ladugård..nn.1
  ladugårdstak_1_N = mkN "ladugårdstak" neutrum  ; -- ladugårdstak..nn.1
  ladusvala_1_N = mkN "ladusvala" ; -- ladusvala..nn.1
  lady_1_N = mkN "lady" "ladyn" "ladies" "ladiesarna" ; -- lady..nn.1
  ladylik_1_A = mkA "ladylik" ; -- ladylik..av.1
  ladylikhet_1_N = mkN "ladylikhet" ; -- ladylikhet..nn.1
  laestadian_1_N = mkN "laestadian" "laestadianer" ; -- laestadian..nn.1
  laestadianism_1_N = mkN "laestadianism" "laestadianismer" ; -- laestadianism..nn.1
  lafs_1_N = mkN "lafs" neutrum  ; -- lafs..nn.1
  lafsa_1_V = mkV "lafsar" ; -- lafsa..vb.1
  lafsande_1_N = mkN "lafsande" ; -- lafsande..nn.1
  lafsig_1_A = mkA "lafsig" ; -- lafsig..av.1
  lafsighet_1_N = mkN "lafsighet" ; -- lafsighet..nn.1
  lag_1_N = mkN "lag" ; -- lag..nn.1
  lag_2_N = mkN "lag" neutrum  ; -- lag..nn.2
  lag_3_N = mkN "lag" ; -- lag..nn.3
  laga_1_A = mkA "laga" ; -- laga..av.1
  laga_1_V = mkV "lagar" ; -- laga..vb.1
  lagad_1_A = mkA "lagad" ; -- lagad..av.1
  laganda_1_N = mkN "laganda" ; -- laganda..nn.1
  lagande_1_N = mkN "lagande" ; -- lagande..nn.1
  lagarbete_1_N = mkN "lagarbete" ; -- lagarbete..nn.1
  lagbalk_1_N = mkN "lagbalk" ; -- lagbalk..nn.1
  lagberedning_1_N = mkN "lagberedning" ; -- lagberedning..nn.1
  lagbestämmelse_1_N = mkN "lagbestämmelse" "lagbestämmelser" ; -- lagbestämmelse..nn.1
  lagbok_1_N = mkN "lagbok" "lagböcker" ; -- lagbok..nn.1
  lagbrott_1_N = mkN "lagbrott" neutrum  ; -- lagbrott..nn.1
  lagbrytare_1_N = mkN "lagbrytare" utrum  ; -- lagbrytare..nn.1
  lagbud_1_N = mkN "lagbud" neutrum  ; -- lagbud..nn.1
  lagbunden_1_A = mkA "lagbunden" ; -- lagbunden..av.1
  lagbundenhet_1_N = mkN "lagbundenhet" "lagbundenheter" ; -- lagbundenhet..nn.1
  lagbygge_1_N = mkN "lagbygge" ; -- lagbygge..nn.1
  lagd_1_A = mkA "lagd" "lagt" ; -- lagd..av.1
  lagenlig_1_A = mkA "lagenlig" ; -- lagenlig..av.1
  lagenlighet_1_N = mkN "lagenlighet" ; -- lagenlighet..nn.1
  lager_1_N = mkN "lager" neutrum  ; -- lager..nn.1
  lager_2_N = mkN "lager" ; -- lager..nn.2
  lager_3_N = mkN "lager" ; -- lager..nn.3
  lagerblad_1_N = mkN "lagerblad" neutrum  ; -- lagerblad..nn.1
  lagerbok_1_N = mkN "lagerbok" "lagerböcker" ; -- lagerbok..nn.1
  lagerbox_1_N = mkN "lagerbox" ; -- lagerbox..nn.1
  lagerbärsblad_1_N = mkN "lagerbärsblad" neutrum  ; -- lagerbärsblad..nn.1
  lagerföljd_1_N = mkN "lagerföljd" "lagerföljder" ; -- lagerföljd..nn.1
  lagerföra_1_V = mkV "lagerföra" "lagerförde" "lagerfört" ; -- lagerföra..vb.1
  lagerförande_1_N = mkN "lagerförande" ; -- lagerförande..nn.1
  lagergång_1_N = mkN "lagergång" ; -- lagergång..nn.1
  lagerkona_1_N = mkN "lagerkona" ; -- lagerkona..nn.1
  lagerkostnad_1_N = mkN "lagerkostnad" "lagerkostnader" ; -- lagerkostnad..nn.1
  lagerkrans_1_N = mkN "lagerkrans" ; -- lagerkrans..nn.1
  lagerkransa_1_V = mkV "lagerkransar" ; -- lagerkransa..vb.1
  lagerkransande_1_N = mkN "lagerkransande" ; -- lagerkransande..nn.1
  lagerkröna_1_V = mkV "lagerkröna" "lagerkröner" "lagerkrön" "lagerkrönte" "lagerkrönt" "lagerkrönt" ; -- lagerkröna..vb.1
  lagerkrönande_1_N = mkN "lagerkrönande" ; -- lagerkrönande..nn.1
  lagerkröning_1_N = mkN "lagerkröning" ; -- lagerkröning..nn.1
  lagerkörs_1_N = mkN "lagerkörs" ; -- lagerkörs..nn.1
  lagerlokal_1_N = mkN "lagerlokal" "lagerlokaler" ; -- lagerlokal..nn.1
  lagerserie_1_N = mkN "lagerserie" "lagerserier" ; -- lagerserie..nn.1
  lagersmatt_1_N = mkN "lagersmatt" ; -- lagersmatt..nn.1
  lageröl_1_N = mkN "lageröl" neutrum  ; -- lageröl..nn.1
  lagfara_1_V = mkV "lagfara" "lagfor" "lagfarit" ; -- lagfara..vb.1
  lagfarande_1_N = mkN "lagfarande" ; -- lagfarande..nn.1
  lagfaren_1_A = mkA "lagfaren" ; -- lagfaren..av.1
  lagfarenhet_1_N = mkN "lagfarenhet" ; -- lagfarenhet..nn.1
  lagfart_1_N = mkN "lagfart" "lagfarter" ; -- lagfart..nn.1
  lagfartsbevis_1_N = mkN "lagfartsbevis" neutrum  ; -- lagfartsbevis..nn.1
  lagfartsprotokoll_1_N = mkN "lagfartsprotokoll" neutrum  ; -- lagfartsprotokoll..nn.1
  lagfästa_1_V = mkV "lagfästa" "lagfäster" "lagfäst" "lagfäste" "lagfäst" "lagfäst" ; -- lagfästa..vb.1
  lagfästande_1_N = mkN "lagfästande" ; -- lagfästande..nn.1
  lagfästning_1_N = mkN "lagfästning" ; -- lagfästning..nn.1
  lagfången_1_A = mkA "lagfången" ; -- lagfången..av.1
  lagföra_1_V = mkV "lagföra" "lagförde" "lagfört" ; -- lagföra..vb.1
  lagförande_1_N = mkN "lagförande" ; -- lagförande..nn.1
  lagföring_1_N = mkN "lagföring" ; -- lagföring..nn.1
  lagförslag_1_N = mkN "lagförslag" neutrum  ; -- lagförslag..nn.1
  lagg_1_N = mkN "lagg" ; -- lagg..nn.1
  lagga_1_V = mkV "laggar" ; -- lagga..vb.1
  laggande_1_N = mkN "laggande" ; -- laggande..nn.1
  laggband_1_N = mkN "laggband" neutrum  ; -- laggband..nn.1
  laggdike_1_N = mkN "laggdike" ; -- laggdike..nn.1
  laggiltighet_1_N = mkN "laggiltighet" ; -- laggiltighet..nn.1
  laggkärl_1_N = mkN "laggkärl" neutrum  ; -- laggkärl..nn.1
  lagisk_1_A = mkA "lagisk" ; -- lagisk..av.1
  lagiskhet_1_N = mkN "lagiskhet" ; -- lagiskhet..nn.1
  lagkamrat_1_N = mkN "lagkamrat" "lagkamrater" ; -- lagkamrat..nn.1
  lagkapp_1_N = mkN "lagkapp" "lagkapper" ; -- lagkapp..nn.1
  lagkappsimning_1_N = mkN "lagkappsimning" ; -- lagkappsimning..nn.1
  lagkapten_1_N = mkN "lagkapten" "lagkaptener" ; -- lagkapten..nn.1
  lagkarl_1_N = mkN "lagkarl" ; -- lagkarl..nn.1
  lagklok_1_A = mkA "lagklok" ; -- lagklok..av.1
  lagklokhet_1_N = mkN "lagklokhet" ; -- lagklokhet..nn.1
  lagkunnig_1_A = mkA "lagkunnig" ; -- lagkunnig..av.1
  lagkunnighet_1_N = mkN "lagkunnighet" ; -- lagkunnighet..nn.1
  lagkunskap_1_N = mkN "lagkunskap" ; -- lagkunskap..nn.1
  lagledare_1_N = mkN "lagledare" utrum  ; -- lagledare..nn.1
  laglig_1_A = mkA "laglig" ; -- laglig..av.1
  lagligen_1_Adv = mkAdv "lagligen" ; -- lagligen..ab.1
  laglighet_1_N = mkN "laglighet" "lagligheter" ; -- laglighet..nn.1
  laglott_1_N = mkN "laglott" "laglotter" ; -- laglott..nn.1
  laglydig_1_A = mkA "laglydig" ; -- laglydig..av.1
  laglydighet_1_N = mkN "laglydighet" ; -- laglydighet..nn.1
  laglydnad_1_N = mkN "laglydnad" ; -- laglydnad..nn.1
  laglös_1_A = mkA "laglös" ; -- laglös..av.1
  laglöshet_1_N = mkN "laglöshet" "laglösheter" ; -- laglöshet..nn.1
  lagman_1_N = mkN "lagman" "lagmannen" "lagmän" "lagmännen" ; -- lagman..nn.1
  lagmässig_1_A = mkA "lagmässig" ; -- lagmässig..av.1
  lagn_1_N = mkN "lagn" neutrum  ; -- lagn..nn.1
  lagning_1_N = mkN "lagning" ; -- lagning..nn.1
  lagom_1_Adv = mkAdv "lagom" ; -- lagom..ab.1
  lagom_1_A = mkA "lagom" ; -- lagom..av.1
  lagomhet_1_N = mkN "lagomhet" ; -- lagomhet..nn.1
  lagområde_1_N = mkN "lagområde" ; -- lagområde..nn.1
  lagparagraf_1_N = mkN "lagparagraf" "lagparagrafer" ; -- lagparagraf..nn.1
  lagra_1_V = mkV "lagrar" ; -- lagra..vb.1
  lagrande_1_N = mkN "lagrande" ; -- lagrande..nn.1
  lagring_1_N = mkN "lagring" ; -- lagring..nn.1
  lagringsförlust_1_N = mkN "lagringsförlust" "lagringsförluster" ; -- lagringsförlust..nn.1
  lagringskostnad_1_N = mkN "lagringskostnad" "lagringskostnader" ; -- lagringskostnad..nn.1
  lagrum_1_N = mkN "lagrum" "lagrummet" "lagrum" "lagrummen" ; -- lagrum..nn.1
  lagråd_1_N = mkN "lagråd" neutrum  ; -- lagråd..nn.1
  lagsaga_1_N = mkN "lagsaga" ; -- lagsaga..nn.1
  lagskipning_1_N = mkN "lagskipning" ; -- lagskipning..nn.1
  lagskärpning_1_N = mkN "lagskärpning" ; -- lagskärpning..nn.1
  lagspel_1_N = mkN "lagspel" "lagspelet" "lagspel" "lagspelen" ; -- lagspel..nn.1
  lagsport_1_N = mkN "lagsport" "lagsporter" ; -- lagsport..nn.1
  lagspråk_1_N = mkN "lagspråk" neutrum  ; -- lagspråk..nn.1
  lagstadga_1_V = mkV "lagstadgar" ; -- lagstadga..vb.1
  lagstadgad_1_A = mkA "lagstadgad" ; -- lagstadgad..av.1
  lagstadgande_1_N = mkN "lagstadgande" ; -- lagstadgande..nn.1
  lagstifta_1_V = mkV "lagstiftar" ; -- lagstifta..vb.1
  lagstiftande_1_N = mkN "lagstiftande" ; -- lagstiftande..nn.1
  lagstiftare_1_N = mkN "lagstiftare" utrum  ; -- lagstiftare..nn.1
  lagstiftning_1_N = mkN "lagstiftning" ; -- lagstiftning..nn.1
  lagstiftningsmässig_1_A = mkA "lagstiftningsmässig" ; -- lagstiftningsmässig..av.1
  lagstil_1_N = mkN "lagstil" ; -- lagstil..nn.1
  lagstridig_1_A = mkA "lagstridig" ; -- lagstridig..av.1
  lagstridighet_1_N = mkN "lagstridighet" ; -- lagstridighet..nn.1
  lagsöka_1_V = mkV "lagsöker" ; -- lagsöka..vb.1
  lagsökande_1_N = mkN "lagsökande" ; -- lagsökande..nn.1
  lagsökning_1_N = mkN "lagsökning" ; -- lagsökning..nn.1
  lagtempo_1_N = mkN "lagtempo" "lagtempot" "lagtempon" "lagtempona" ; -- lagtempo..nn.1
  lagtempolopp_1_N = mkN "lagtempolopp" neutrum  ; -- lagtempolopp..nn.1
  lagterm_1_N = mkN "lagterm" "lagtermer" ; -- lagterm..nn.1
  lagtext_1_N = mkN "lagtext" "lagtexter" ; -- lagtext..nn.1
  lagtillämpning_1_N = mkN "lagtillämpning" ; -- lagtillämpning..nn.1
  lagtima_1_A = mkA "lagtima" ; -- lagtima..av.1
  lagtolkning_1_N = mkN "lagtolkning" ; -- lagtolkning..nn.1
  lagtränare_1_N = mkN "lagtränare" utrum  ; -- lagtränare..nn.1
  lagun_1_N = mkN "lagun" "laguner" ; -- lagun..nn.1
  lagunsjö_1_N = mkN "lagunsjö" ; -- lagunsjö..nn.1
  laguppställning_1_N = mkN "laguppställning" ; -- laguppställning..nn.1
  lagutskott_1_N = mkN "lagutskott" neutrum  ; -- lagutskott..nn.1
  laguttagning_1_N = mkN "laguttagning" ; -- laguttagning..nn.1
  lagvidrig_1_A = mkA "lagvidrig" ; -- lagvidrig..av.1
  lagvigd_1_A = mkA "lagvigd" "lagvigt" ; -- lagvigd..av.1
  lagvrängare_1_N = mkN "lagvrängare" utrum  ; -- lagvrängare..nn.1
  lagvrängeri_1_N = mkN "lagvrängeri" "lagvrängeriet" "lagvrängerier" "lagvrängerierna" ; -- lagvrängeri..nn.1
  lagvrängning_1_N = mkN "lagvrängning" ; -- lagvrängning..nn.1
  lagvunnen_1_A = mkA "lagvunnen" "lagvunnet" "lagvunna" "lagvunna" "lagvunnare" "lagvunnast" "lagvunnaste" ; -- lagvunnen..av.1
  lagväsen_1_N = mkN "lagväsen" neutrum  ; -- lagväsen..nn.1
  lagändring_1_N = mkN "lagändring" ; -- lagändring..nn.1
  lagård_1_N = mkN "lagård" ; -- lagård..nn.1
  lagårdsbacke_1_N = mkN "lagårdsbacke" utrum  ; -- lagårdsbacke..nn.1
  lagöverträdelse_1_N = mkN "lagöverträdelse" "lagöverträdelser" ; -- lagöverträdelse..nn.1
  laissez_faire_1_N = mkN "laissez-faire" ; -- laissez-faire..nn.1
  lakan_1_N = mkN "lakan" neutrum  ; -- lakan..nn.1
  lakanspåse_1_N = mkN "lakanspåse" utrum  ; -- lakanspåse..nn.1
  lakansremsa_1_N = mkN "lakansremsa" ; -- lakansremsa..nn.1
  lakansspets_1_N = mkN "lakansspets" ; -- lakansspets..nn.1
  lake_1_N = mkN "lake" utrum  ; -- lake..nn.1
  lakej_1_N = mkN "lakej" "lakejer" ; -- lakej..nn.1
  lakka_1_N = mkN "lakka" ; -- lakka..nn.1
  lakonisk_1_A = mkA "lakonisk" ; -- lakonisk..av.1
  lakonism_1_N = mkN "lakonism" "lakonismer" ; -- lakonism..nn.1
  lakrits_1_N = mkN "lakrits" ; -- lakrits..nn.1
  lakritsrot_1_N = mkN "lakritsrot" "lakritsrötter" ; -- lakritsrot..nn.1
  laktalbumin_1_N = mkN "laktalbumin" "laktalbuminer" ; -- laktalbumin..nn.1
  laktation_1_N = mkN "laktation" ; -- laktation..nn.1
  laktos_1_A = mkA "laktos" ; -- laktos..av.1
  laktos_1_N = mkN "laktos" ; -- laktos..nn.1
  laktosfri_1_A = mkA "laktosfri" "laktosfritt" ; -- laktosfri..av.1
  laktosintolerans_1_N = mkN "laktosintolerans" ; -- laktosintolerans..nn.1
  laktosintolerant_1_A = mkA "laktosintolerant" "laktosintolerant" ; -- laktosintolerant..av.1
  laktovegetarian_1_N = mkN "laktovegetarian" "laktovegetarianer" ; -- laktovegetarian..nn.1
  lakun_1_N = mkN "lakun" "lakuner" ; -- lakun..nn.1
  lalla_1_V = mkV "lallar" ; -- lalla..vb.1
  lallande_1_N = mkN "lallande" ; -- lallande..nn.1
  lallning_1_N = mkN "lallning" ; -- lallning..nn.1
  lam_1_A = mkA "lam" ; -- lam..av.1
  lama_1_N = mkN "lama" ; -- lama..nn.1
  lama_2_N = mkN "lama" ; -- lama..nn.2
  lama_3_N = mkN "lama" ; -- lama..nn.3
  lamadjur_1_N = mkN "lamadjur" neutrum  ; -- lamadjur..nn.1
  lamaism_1_N = mkN "lamaism" "lamaismer" ; -- lamaism..nn.1
  lamaistisk_1_A = mkA "lamaistisk" ; -- lamaistisk..av.1
  lambada_1_N = mkN "lambada" ; -- lambada..nn.1
  lambda_1_N = mkN "lambda" "lambdat" "lambdan" "lambdana" ; -- lambda..nn.1
  lamell_1_N = mkN "lamell" "lameller" ; -- lamell..nn.1
  lamellhus_1_N = mkN "lamellhus" neutrum  ; -- lamellhus..nn.1
  lamellkontakt_1_N = mkN "lamellkontakt" "lamellkontakter" ; -- lamellkontakt..nn.1
  lamellkoppling_1_N = mkN "lamellkoppling" ; -- lamellkoppling..nn.1
  lamellträ_1_N = mkN "lamellträ" neutrum  ; -- lamellträ..nn.1
  lamentation_1_N = mkN "lamentation" ; -- lamentation..nn.1
  lamentera_1_V = mkV "lamenterar" ; -- lamentera..vb.1
  lamenterande_1_N = mkN "lamenterande" ; -- lamenterande..nn.1
  lamenterbar_1_A = mkA "lamenterbar" ; -- lamenterbar..av.1
  lamenterbarhet_1_N = mkN "lamenterbarhet" ; -- lamenterbarhet..nn.1
  lamentering_1_N = mkN "lamentering" ; -- lamentering..nn.1
  lamhet_1_N = mkN "lamhet" ; -- lamhet..nn.1
  laminat_1_N = mkN "laminat" neutrum  ; -- laminat..nn.1
  laminera_1_V = mkV "laminerar" ; -- laminera..vb.1
  laminerande_1_N = mkN "laminerande" ; -- laminerande..nn.1
  laminerbar_1_A = mkA "laminerbar" ; -- laminerbar..av.1
  laminerbarhet_1_N = mkN "laminerbarhet" ; -- laminerbarhet..nn.1
  laminering_1_N = mkN "laminering" ; -- laminering..nn.1
  laminär_1_A = mkA "laminär" ; -- laminär..av.1
  lamm_1_N = mkN "lamm" neutrum  ; -- lamm..nn.1
  lamm_2_N = mkN "lamm" neutrum  ; -- lamm..nn.2
  lamma_1_V = mkV "lammar" ; -- lamma..vb.1
  lammande_1_N = mkN "lammande" ; -- lammande..nn.1
  lammfärs_1_N = mkN "lammfärs" "lammfärser" ; -- lammfärs..nn.1
  lammkorv_1_N = mkN "lammkorv" ; -- lammkorv..nn.1
  lammkött_1_N = mkN "lammkött" neutrum  ; -- lammkött..nn.1
  lammsadel_1_N = mkN "lammsadel" ; -- lammsadel..nn.1
  lammskinn_1_N = mkN "lammskinn" neutrum  ; -- lammskinn..nn.1
  lammspett_1_N = mkN "lammspett" neutrum  ; -- lammspett..nn.1
  lammstek_1_N = mkN "lammstek" ; -- lammstek..nn.1
  lammunge_1_N = mkN "lammunge" utrum  ; -- lammunge..nn.1
  lamning_1_N = mkN "lamning" ; -- lamning..nn.1
  lampa_1_N = mkN "lampa" ; -- lampa..nn.1
  lampanordning_1_N = mkN "lampanordning" ; -- lampanordning..nn.1
  lampett_1_N = mkN "lampett" "lampetter" ; -- lampett..nn.1
  lampfabrik_1_N = mkN "lampfabrik" "lampfabriker" ; -- lampfabrik..nn.1
  lampfot_1_N = mkN "lampfot" "lampfötter" ; -- lampfot..nn.1
  lamphållare_1_N = mkN "lamphållare" utrum  ; -- lamphållare..nn.1
  lampkupa_1_N = mkN "lampkupa" ; -- lampkupa..nn.1
  lampolja_1_N = mkN "lampolja" ; -- lampolja..nn.1
  lampsken_1_N = mkN "lampsken" neutrum  ; -- lampsken..nn.1
  lampskärm_1_N = mkN "lampskärm" ; -- lampskärm..nn.1
  lampsvart_1_A = mkA "lampsvart" "lampsvart" ; -- lampsvart..av.1
  lamslå_1_V = mkV "lamslå" "lamslog" "lamslagit" ; -- lamslå..vb.1
  lamslående_1_N = mkN "lamslående" ; -- lamslående..nn.1
  lamé_1_N = mkN "lamé" "laméer" ; -- lamé..nn.1
  lan_1_N = mkN "lan" "laner" ; -- lan..nn.1
  lana_1_N = mkN "lana" ; -- lana..nn.1
  land_1_N = mkN "land" "landet" "länder" "länderna" ; -- land..nn.1
  land_2_N = mkN "land" neutrum  ; -- land..nn.2
  land_3_N = mkN "land" neutrum  ; -- land..nn.3
  landa_1_V = mkV "landar" ; -- landa..vb.1
  landa_2_V = mkV "landar" ; -- landa..vb.2
  landamäre_1_N = mkN "landamäre" ; -- landamäre..nn.1
  landande_1_N = mkN "landande" ; -- landande..nn.1
  landavträdelse_1_N = mkN "landavträdelse" "landavträdelser" ; -- landavträdelse..nn.1
  landbaserad_1_A = mkA "landbaserad" ; -- landbaserad..av.1
  landbo_1_N = mkN "landbo" "landbor" ; -- landbo..nn.1
  landborg_1_N = mkN "landborg" ; -- landborg..nn.1
  landbris_1_N = mkN "landbris" ; -- landbris..nn.1
  landbrygga_1_N = mkN "landbrygga" ; -- landbrygga..nn.1
  landdriven_1_A = mkA "landdriven" ; -- landdriven..av.1
  landfast_1_A = mkA "landfast" "landfast" ; -- landfast..av.1
  landfäste_1_N = mkN "landfäste" ; -- landfäste..nn.1
  landgång_1_N = mkN "landgång" ; -- landgång..nn.1
  landhöjning_1_N = mkN "landhöjning" ; -- landhöjning..nn.1
  landis_1_N = mkN "landis" ; -- landis..nn.1
  landkrabba_1_N = mkN "landkrabba" ; -- landkrabba..nn.1
  landkänning_1_N = mkN "landkänning" ; -- landkänning..nn.1
  landledes_1_Adv = mkAdv "landledes" ; -- landledes..ab.1
  landlevande_1_A = mkA "landlevande" ; -- landlevande..av.1
  landlös_1_A = mkA "landlös" ; -- landlös..av.1
  landmassa_1_N = mkN "landmassa" ; -- landmassa..nn.1
  landmil_1_N = mkN "landmil" "landmilen" "landmil" "landmilen" ; -- landmil..nn.1
  landmina_1_N = mkN "landmina" ; -- landmina..nn.1
  landmärke_1_N = mkN "landmärke" ; -- landmärke..nn.1
  landning_1_N = mkN "landning" ; -- landning..nn.1
  landningsbana_1_N = mkN "landningsbana" ; -- landningsbana..nn.1
  landningsfarkost_1_N = mkN "landningsfarkost" "landningsfarkoster" ; -- landningsfarkost..nn.1
  landningsförbud_1_N = mkN "landningsförbud" neutrum  ; -- landningsförbud..nn.1
  landningshjul_1_N = mkN "landningshjul" neutrum  ; -- landningshjul..nn.1
  landningsmärke_1_N = mkN "landningsmärke" ; -- landningsmärke..nn.1
  landningsplats_1_N = mkN "landningsplats" "landningsplatser" ; -- landningsplats..nn.1
  landningsställ_1_N = mkN "landningsställ" neutrum  ; -- landningsställ..nn.1
  landningszon_1_N = mkN "landningszon" "landningszoner" ; -- landningszon..nn.1
  landningsögonblick_1_N = mkN "landningsögonblick" neutrum  ; -- landningsögonblick..nn.1
  landnot_1_N = mkN "landnot" ; -- landnot..nn.1
  landområde_1_N = mkN "landområde" ; -- landområde..nn.1
  landpermission_1_N = mkN "landpermission" ; -- landpermission..nn.1
  landremsa_1_N = mkN "landremsa" ; -- landremsa..nn.1
  landrygg_1_N = mkN "landrygg" ; -- landrygg..nn.1
  landsantikvarie_1_N = mkN "landsantikvarie" "landsantikvarier" ; -- landsantikvarie..nn.1
  landsarkiv_1_N = mkN "landsarkiv" neutrum  ; -- landsarkiv..nn.1
  landsarkivarie_1_N = mkN "landsarkivarie" "landsarkivarier" ; -- landsarkivarie..nn.1
  landsbo_1_N = mkN "landsbo" "landsbor" ; -- landsbo..nn.1
  landsbygd_1_N = mkN "landsbygd" ; -- landsbygd..nn.1
  landsbygdsbefolkning_1_N = mkN "landsbygdsbefolkning" ; -- landsbygdsbefolkning..nn.1
  landsbygdsbo_1_N = mkN "landsbygdsbo" "landsbygdsbor" ; -- landsbygdsbo..nn.1
  landsbygdsorienterad_1_A = mkA "landsbygdsorienterad" ; -- landsbygdsorienterad..av.1
  landsbygdsromantik_1_N = mkN "landsbygdsromantik" ; -- landsbygdsromantik..nn.1
  landsbygdsutveckling_1_N = mkN "landsbygdsutveckling" ; -- landsbygdsutveckling..nn.1
  landsdel_1_N = mkN "landsdel" "landsdelen" "landsdelar" "landsdelarna" ; -- landsdel..nn.1
  landsfader_1_N = mkN "landsfader" "landsfadern" "landsfäder" "landsfäderna" ; -- landsfader..nn.1
  landsfaderlig_1_A = mkA "landsfaderlig" ; -- landsfaderlig..av.1
  landsfiskal_1_N = mkN "landsfiskal" "landsfiskaler" ; -- landsfiskal..nn.1
  landsflykt_1_N = mkN "landsflykt" ; -- landsflykt..nn.1
  landsflyktig_1_A = mkA "landsflyktig" ; -- landsflyktig..av.1
  landsflykting_1_N = mkN "landsflykting" ; -- landsflykting..nn.1
  landsfogde_1_N = mkN "landsfogde" utrum  ; -- landsfogde..nn.1
  landsförrädare_1_N = mkN "landsförrädare" utrum  ; -- landsförrädare..nn.1
  landsförräderi_1_N = mkN "landsförräderi" "landsförräderiet" "landsförräderier" "landsförräderierna" ; -- landsförräderi..nn.1
  landsförrädisk_1_A = mkA "landsförrädisk" ; -- landsförrädisk..av.1
  landsförrädiskhet_1_N = mkN "landsförrädiskhet" ; -- landsförrädiskhet..nn.1
  landsförvisa_1_V = mkV "landsförvisar" ; -- landsförvisa..vb.1
  landsförvisande_1_N = mkN "landsförvisande" ; -- landsförvisande..nn.1
  landsförvisning_1_N = mkN "landsförvisning" ; -- landsförvisning..nn.1
  landsförvist_1_A = mkA "landsförvist" "landsförvist" ; -- landsförvist..av.1
  landsgagnelig_1_A = mkA "landsgagnelig" ; -- landsgagnelig..av.1
  landshövding_1_N = mkN "landshövding" ; -- landshövding..nn.1
  landshövdingehus_1_N = mkN "landshövdingehus" neutrum  ; -- landshövdingehus..nn.1
  landshövdingeämbete_1_N = mkN "landshövdingeämbete" ; -- landshövdingeämbete..nn.1
  landsida_1_N = mkN "landsida" ; -- landsida..nn.1
  landskamp_1_N = mkN "landskamp" "landskamper" ; -- landskamp..nn.1
  landskansli_1_N = mkN "landskansli" "landskansliet" "landskanslier" "landskanslierna" ; -- landskansli..nn.1
  landskap_1_N = mkN "landskap" neutrum  ; -- landskap..nn.1
  landskapsblomma_1_N = mkN "landskapsblomma" ; -- landskapsblomma..nn.1
  landskapslag_1_N = mkN "landskapslag" ; -- landskapslag..nn.1
  landskapsmässig_1_A = mkA "landskapsmässig" ; -- landskapsmässig..av.1
  landskapsmålare_1_N = mkN "landskapsmålare" utrum  ; -- landskapsmålare..nn.1
  landskapsmålning_1_N = mkN "landskapsmålning" ; -- landskapsmålning..nn.1
  landskapsskildring_1_N = mkN "landskapsskildring" ; -- landskapsskildring..nn.1
  landskapsvapen_1_N = mkN "landskapsvapen" "landskapsvapnet" "landskapsvapen" "landskapsvapnen" ; -- landskapsvapen..nn.1
  landskapsvis_1_Adv = mkAdv "landskapsvis" ; -- landskapsvis..ab.1
  landskapsvis_1_A = mkA "landskapsvis" ; -- landskapsvis..av.1
  landsknekt_1_N = mkN "landsknekt" ; -- landsknekt..nn.1
  landskommun_1_N = mkN "landskommun" "landskommuner" ; -- landskommun..nn.1
  landslag_1_N = mkN "landslag" neutrum  ; -- landslag..nn.1
  landslag_2_N = mkN "landslag" ; -- landslag..nn.2
  landslagsaktuell_1_A = mkA "landslagsaktuell" ; -- landslagsaktuell..av.1
  landslagsmeriterad_1_A = mkA "landslagsmeriterad" ; -- landslagsmeriterad..av.1
  landslagsmässig_1_A = mkA "landslagsmässig" ; -- landslagsmässig..av.1
  landslagsspelare_1_N = mkN "landslagsspelare" utrum  ; -- landslagsspelare..nn.1
  landslagsträning_1_N = mkN "landslagsträning" ; -- landslagsträning..nn.1
  landsman_1_N = mkN "landsman" "landsmannen" "landsmän" "landsmännen" ; -- landsman..nn.1
  landsmaninna_1_N = mkN "landsmaninna" ; -- landsmaninna..nn.1
  landsmål_1_N = mkN "landsmål" neutrum  ; -- landsmål..nn.1
  landsmålsalfabet_1_N = mkN "landsmålsalfabet" neutrum  ; -- landsmålsalfabet..nn.1
  landsnummer_1_N = mkN "landsnummer" neutrum  ; -- landsnummer..nn.1
  landsnäcka_1_N = mkN "landsnäcka" ; -- landsnäcka..nn.1
  landsomfattande_1_A = mkA "landsomfattande" ; -- landsomfattande..av.1
  landsort_1_N = mkN "landsort" ; -- landsort..nn.1
  landsortsbo_1_N = mkN "landsortsbo" "landsortsboet" "landsortsbon" "landsortsbona" ; -- landsortsbo..nn.1
  landsortsmässig_1_A = mkA "landsortsmässig" ; -- landsortsmässig..av.1
  landsortsmässighet_1_N = mkN "landsortsmässighet" ; -- landsortsmässighet..nn.1
  landsortspress_1_N = mkN "landsortspress" ; -- landsortspress..nn.1
  landsortsstad_1_N = mkN "landsortsstad" "landsortsstäder" ; -- landsortsstad..nn.1
  landsplåga_1_N = mkN "landsplåga" ; -- landsplåga..nn.1
  landsrätt_1_N = mkN "landsrätt" ; -- landsrätt..nn.1
  landssekretariat_1_N = mkN "landssekretariat" neutrum  ; -- landssekretariat..nn.1
  landssekreterare_1_N = mkN "landssekreterare" utrum  ; -- landssekreterare..nn.1
  landssorg_1_N = mkN "landssorg" ; -- landssorg..nn.1
  landstiga_1_V = mkV "landstiga" "landsteg" "landstigit" ; -- landstiga..vb.1
  landstigande_1_N = mkN "landstigande" ; -- landstigande..nn.1
  landstigning_1_N = mkN "landstigning" ; -- landstigning..nn.1
  landstigningsbåt_1_N = mkN "landstigningsbåt" ; -- landstigningsbåt..nn.1
  landsting_1_N = mkN "landsting" neutrum  ; -- landsting..nn.1
  landstingsanställd_1_A = mkA "landstingsanställd" "landstingsanställt" ; -- landstingsanställd..av.1
  landstingsdirektör_1_N = mkN "landstingsdirektör" "landstingsdirektörer" ; -- landstingsdirektör..nn.1
  landstingsförbund_1_N = mkN "landstingsförbund" neutrum  ; -- landstingsförbund..nn.1
  landstingskatalog_1_N = mkN "landstingskatalog" "landstingskataloger" ; -- landstingskatalog..nn.1
  landstingskommun_1_N = mkN "landstingskommun" "landstingskommuner" ; -- landstingskommun..nn.1
  landstingskommunal_1_A = mkA "landstingskommunal" ; -- landstingskommunal..av.1
  landstingsman_1_N = mkN "landstingsman" "landstingsmannen" "landstingsmän" "landstingsmännen" ; -- landstingsman..nn.1
  landstingsråd_1_N = mkN "landstingsråd" neutrum  ; -- landstingsråd..nn.1
  landstorm_1_N = mkN "landstorm" ; -- landstorm..nn.1
  landstrykare_1_N = mkN "landstrykare" utrum  ; -- landstrykare..nn.1
  landsträcka_1_N = mkN "landsträcka" ; -- landsträcka..nn.1
  landställe_1_N = mkN "landställe" ; -- landställe..nn.1
  landsväg_1_N = mkN "landsväg" ; -- landsväg..nn.1
  landsvägsbuss_1_N = mkN "landsvägsbuss" ; -- landsvägsbuss..nn.1
  landsvägsriddare_1_N = mkN "landsvägsriddare" utrum  ; -- landsvägsriddare..nn.1
  landsvägsövergång_1_N = mkN "landsvägsövergång" ; -- landsvägsövergång..nn.1
  landsända_1_N = mkN "landsända" ; -- landsända..nn.1
  landsände_1_N = mkN "landsände" utrum  ; -- landsände..nn.1
  landsätta_1_V = mkV "landsätta" "landsätter" "landsätt" "landsatte" "landsatt" "landsatt" ; -- landsätta..vb.1
  landsättande_1_N = mkN "landsättande" ; -- landsättande..nn.1
  landsättning_1_N = mkN "landsättning" ; -- landsättning..nn.1
  landtransport_1_N = mkN "landtransport" "landtransporter" ; -- landtransport..nn.1
  landtunga_1_N = mkN "landtunga" ; -- landtunga..nn.1
  landvad_1_N = mkN "landvad" ; -- landvad..nn.1
  landvind_1_N = mkN "landvind" ; -- landvind..nn.1
  landvinning_1_N = mkN "landvinning" ; -- landvinning..nn.1
  landå_1_N = mkN "landå" "landåer" ; -- landå..nn.1
  langa_1_V = mkV "langar" ; -- langa..vb.1
  langande_1_N = mkN "langande" ; -- langande..nn.1
  langare_1_N = mkN "langare" utrum  ; -- langare..nn.1
  langarn_1_N = mkN "langarn" "langarnet" "langarner" "langarnerna" ; -- langarn..nn.1
  langett_1_N = mkN "langett" "langetter" ; -- langett..nn.1
  langettera_1_V = mkV "langetterar" ; -- langettera..vb.1
  langetterande_1_N = mkN "langetterande" ; -- langetterande..nn.1
  langetterbar_1_A = mkA "langetterbar" ; -- langetterbar..av.1
  langetterbarhet_1_N = mkN "langetterbarhet" ; -- langetterbarhet..nn.1
  langettering_1_N = mkN "langettering" ; -- langettering..nn.1
  langettstygn_1_N = mkN "langettstygn" neutrum  ; -- langettstygn..nn.1
  langning_1_N = mkN "langning" ; -- langning..nn.1
  langobard_1_N = mkN "langobard" "langobarder" ; -- langobard..nn.1
  langos_1_N = mkN "langos" ; -- langos..nn.1
  langust_1_N = mkN "langust" "languster" ; -- langust..nn.1
  lank_1_N = mkN "lank" ; -- lank..nn.1
  lanka_1_N = mkN "lanka" ; -- lanka..nn.1
  lankes_1_N = mkN "lankes" "lankeser" ; -- lankes..nn.1
  lankesisk_1_A = mkA "lankesisk" ; -- lankesisk..av.1
  lankesiska_1_N = mkN "lankesiska" ; -- lankesiska..nn.1
  lann_1_N = mkN "lann" ; -- lann..nn.1
  lanolin_1_N = mkN "lanolin" ; -- lanolin..nn.1
  lans_1_N = mkN "lans" ; -- lans..nn.1
  lansbrytning_1_N = mkN "lansbrytning" ; -- lansbrytning..nn.1
  lansera_1_V = mkV "lanserar" ; -- lansera..vb.1
  lanserande_1_N = mkN "lanserande" ; -- lanserande..nn.1
  lanserbar_1_A = mkA "lanserbar" ; -- lanserbar..av.1
  lanserbarhet_1_N = mkN "lanserbarhet" ; -- lanserbarhet..nn.1
  lansering_1_N = mkN "lansering" ; -- lansering..nn.1
  lansett_1_N = mkN "lansett" "lansetter" ; -- lansett..nn.1
  lansettfisk_1_N = mkN "lansettfisk" ; -- lansettfisk..nn.1
  lansettlik_1_A = mkA "lansettlik" ; -- lansettlik..av.1
  lansiär_1_N = mkN "lansiär" "lansiärer" ; -- lansiär..nn.1
  lantan_1_N = mkN "lantan" ; -- lantan..nn.1
  lantarbetare_1_N = mkN "lantarbetare" utrum  ; -- lantarbetare..nn.1
  lantarbetarhustru_1_N = mkN "lantarbetarhustru" "lantarbetarhustrun" "lantarbetarhustrur" "lantarbetarhustrurna" ; -- lantarbetarhustru..nn.1
  lantbo_1_N = mkN "lantbo" "lantbor" ; -- lantbo..nn.1
  lantbrevbärare_1_N = mkN "lantbrevbärare" utrum  ; -- lantbrevbärare..nn.1
  lantbruk_1_N = mkN "lantbruk" neutrum  ; -- lantbruk..nn.1
  lantbrukare_1_N = mkN "lantbrukare" utrum  ; -- lantbrukare..nn.1
  lantbrukarpar_1_N = mkN "lantbrukarpar" neutrum  ; -- lantbrukarpar..nn.1
  lantbruksdirektör_1_N = mkN "lantbruksdirektör" "lantbruksdirektörer" ; -- lantbruksdirektör..nn.1
  lantbruksförbund_1_N = mkN "lantbruksförbund" neutrum  ; -- lantbruksförbund..nn.1
  lantbrukskonsulent_1_N = mkN "lantbrukskonsulent" "lantbrukskonsulenter" ; -- lantbrukskonsulent..nn.1
  lantbrukskunnande_1_N = mkN "lantbrukskunnande" ; -- lantbrukskunnande..nn.1
  lantbruksnämnd_1_N = mkN "lantbruksnämnd" "lantbruksnämnder" ; -- lantbruksnämnd..nn.1
  lantbruksstyrelse_1_N = mkN "lantbruksstyrelse" "lantbruksstyrelser" ; -- lantbruksstyrelse..nn.1
  lantbruksuniversitet_1_N = mkN "lantbruksuniversitet" neutrum  ; -- lantbruksuniversitet..nn.1
  lantdag_1_N = mkN "lantdag" ; -- lantdag..nn.1
  lantdjur_1_N = mkN "lantdjur" neutrum  ; -- lantdjur..nn.1
  lantegendom_1_N = mkN "lantegendom" ; -- lantegendom..nn.1
  lanterna_1_N = mkN "lanterna" ; -- lanterna..nn.1
  lanternin_1_N = mkN "lanternin" "lanterniner" ; -- lanternin..nn.1
  lantgods_1_N = mkN "lantgods" neutrum  ; -- lantgods..nn.1
  lantgreve_1_N = mkN "lantgreve" utrum  ; -- lantgreve..nn.1
  lantgård_1_N = mkN "lantgård" ; -- lantgård..nn.1
  lanthandel_1_N = mkN "lanthandel" ; -- lanthandel..nn.1
  lanthushållning_1_N = mkN "lanthushållning" ; -- lanthushållning..nn.1
  lantis_1_N = mkN "lantis" ; -- lantis..nn.1
  lantjunkare_1_N = mkN "lantjunkare" utrum  ; -- lantjunkare..nn.1
  lantlig_1_A = mkA "lantlig" ; -- lantlig..av.1
  lantlighet_1_N = mkN "lantlighet" ; -- lantlighet..nn.1
  lantliv_1_N = mkN "lantliv" neutrum  ; -- lantliv..nn.1
  lantlolla_1_N = mkN "lantlolla" ; -- lantlolla..nn.1
  lantluft_1_N = mkN "lantluft" ; -- lantluft..nn.1
  lantman_1_N = mkN "lantman" "lantmannen" "lantmän" "lantmännen" ; -- lantman..nn.1
  lantmannaparti_1_N = mkN "lantmannaparti" neutrum  ; -- lantmannaparti..nn.1
  lantmarskalk_1_N = mkN "lantmarskalk" ; -- lantmarskalk..nn.1
  lantmässig_1_A = mkA "lantmässig" ; -- lantmässig..av.1
  lantmästare_1_N = mkN "lantmästare" utrum  ; -- lantmästare..nn.1
  lantmätare_1_N = mkN "lantmätare" utrum  ; -- lantmätare..nn.1
  lantmäteri_1_N = mkN "lantmäteri" "lantmäteriet" "lantmäterier" "lantmäterierna" ; -- lantmäteri..nn.1
  lantras_1_N = mkN "lantras" "lantraser" ; -- lantras..nn.1
  lantrasgris_1_N = mkN "lantrasgris" ; -- lantrasgris..nn.1
  lantsmör_1_N = mkN "lantsmör" neutrum  ; -- lantsmör..nn.1
  lantställe_1_N = mkN "lantställe" ; -- lantställe..nn.1
  lantvin_1_N = mkN "lantvin" "lantvinet" "lantviner" "lantvinerna" ; -- lantvin..nn.1
  lantvärn_1_N = mkN "lantvärn" neutrum  ; -- lantvärn..nn.1
  laotier_1_N = mkN "laotier" "laotiern" "laotier" "laotierna" ; -- laotier..nn.1
  laotisk_1_A = mkA "laotisk" ; -- laotisk..av.1
  laotiska_1_N = mkN "laotiska" ; -- laotiska..nn.1
  laotiska_2_N = mkN "laotiska" ; -- laotiska..nn.2
  lapa_1_V = mkV "lapar" ; -- lapa..vb.1
  lapande_1_N = mkN "lapande" ; -- lapande..nn.1
  laparoskopi_1_N = mkN "laparoskopi" ; -- laparoskopi..nn.1
  laparoskopisk_1_A = mkA "laparoskopisk" ; -- laparoskopisk..av.1
  lapidarisk_1_A = mkA "lapidarisk" ; -- lapidarisk..av.1
  lapidarstil_1_N = mkN "lapidarstil" ; -- lapidarstil..nn.1
  lapis_1_N = mkN "lapis" ; -- lapis..nn.1
  lapisera_1_V = mkV "lapiserar" ; -- lapisera..vb.1
  lapiserande_1_N = mkN "lapiserande" ; -- lapiserande..nn.1
  lapiserbar_1_A = mkA "lapiserbar" ; -- lapiserbar..av.1
  lapiserbarhet_1_N = mkN "lapiserbarhet" ; -- lapiserbarhet..nn.1
  lapisering_1_N = mkN "lapisering" ; -- lapisering..nn.1
  lapkojs_1_N = mkN "lapkojs" ; -- lapkojs..nn.1
  lapp_1_N = mkN "lapp" ; -- lapp..nn.1
  lappa_1_V = mkV "lappar" ; -- lappa..vb.1
  lappande_1_N = mkN "lappande" ; -- lappande..nn.1
  lapphund_1_N = mkN "lapphund" ; -- lapphund..nn.1
  lappkast_1_N = mkN "lappkast" neutrum  ; -- lappkast..nn.1
  lappkojs_1_N = mkN "lappkojs" ; -- lappkojs..nn.1
  lapplandsgran_1_N = mkN "lapplandsgran" ; -- lapplandsgran..nn.1
  lapplisa_1_N = mkN "lapplisa" ; -- lapplisa..nn.1
  lappländsk_1_A = mkA "lappländsk" ; -- lappländsk..av.1
  lappländska_1_N = mkN "lappländska" ; -- lappländska..nn.1
  lapplänning_1_N = mkN "lapplänning" ; -- lapplänning..nn.1
  lappning_1_N = mkN "lappning" ; -- lappning..nn.1
  lappsjuka_1_N = mkN "lappsjuka" ; -- lappsjuka..nn.1
  lappskojs_1_N = mkN "lappskojs" ; -- lappskojs..nn.1
  lappskrivning_1_N = mkN "lappskrivning" ; -- lappskrivning..nn.1
  lappsparv_1_N = mkN "lappsparv" ; -- lappsparv..nn.1
  lappsökare_1_N = mkN "lappsökare" utrum  ; -- lappsökare..nn.1
  lapptäcke_1_N = mkN "lapptäcke" ; -- lapptäcke..nn.1
  lappvante_1_N = mkN "lappvante" utrum  ; -- lappvante..nn.1
  lappverk_1_N = mkN "lappverk" neutrum  ; -- lappverk..nn.1
  lapsk_1_A = mkA "lapsk" ; -- lapsk..av.1
  lapska_1_N = mkN "lapska" ; -- lapska..nn.1
  lapska_2_N = mkN "lapska" ; -- lapska..nn.2
  lapskhet_1_N = mkN "lapskhet" ; -- lapskhet..nn.1
  lapskojs_1_N = mkN "lapskojs" ; -- lapskojs..nn.1
  lapsus_1_N = mkN "lapsus" ; -- lapsus..nn.1
  laptop_1_N = mkN "laptop" ; -- laptop..nn.1
  laptopp_1_N = mkN "laptopp" ; -- laptopp..nn.1
  largetto_1_N = mkN "largetto" "largettot" "largetton" "largettona" ; -- largetto..nn.1
  largo_1_N = mkN "largo" "largot" "largon" "largona" ; -- largo..nn.1
  larm_1_N = mkN "larm" neutrum  ; -- larm..nn.1
  larma_1_V = mkV "larmar" ; -- larma..vb.1
  larma_2_V = mkV "larmar" ; -- larma..vb.2
  larmande_1_N = mkN "larmande" ; -- larmande..nn.1
  larmberedskap_1_N = mkN "larmberedskap" ; -- larmberedskap..nn.1
  larmbåge_1_N = mkN "larmbåge" utrum  ; -- larmbåge..nn.1
  larmförläggning_1_N = mkN "larmförläggning" ; -- larmförläggning..nn.1
  larmklocka_1_N = mkN "larmklocka" ; -- larmklocka..nn.1
  larmminering_1_N = mkN "larmminering" ; -- larmminering..nn.1
  larmnummer_1_N = mkN "larmnummer" neutrum  ; -- larmnummer..nn.1
  larmrapport_1_N = mkN "larmrapport" "larmrapporter" ; -- larmrapport..nn.1
  larmsignal_1_N = mkN "larmsignal" "larmsignaler" ; -- larmsignal..nn.1
  larv_1_N = mkN "larv" "larver" ; -- larv..nn.1
  larv_2_N = mkN "larv" neutrum  ; -- larv..nn.2
  larva_1_N = mkN "larva" ; -- larva..nn.1
  larva_1_V = mkV "larvar" ; -- larva..vb.1
  larvande_1_N = mkN "larvande" ; -- larvande..nn.1
  larvband_1_N = mkN "larvband" neutrum  ; -- larvband..nn.1
  larver_1_N = mkN "larver" ; -- larver..nn.1
  larvig_1_A = mkA "larvig" ; -- larvig..av.1
  larvighet_1_N = mkN "larvighet" ; -- larvighet..nn.1
  larvtraktor_1_N = mkN "larvtraktor" "larvtraktorer" ; -- larvtraktor..nn.1
  laryngal_1_A = mkA "laryngal" ; -- laryngal..av.1
  laryngal_1_N = mkN "laryngal" "laryngaler" ; -- laryngal..nn.1
  laryngit_1_N = mkN "laryngit" "laryngiter" ; -- laryngit..nn.1
  laryngolog_1_N = mkN "laryngolog" "laryngologer" ; -- laryngolog..nn.1
  laryngologi_1_N = mkN "laryngologi" ; -- laryngologi..nn.1
  laryngoskop_1_N = mkN "laryngoskop" neutrum  ; -- laryngoskop..nn.1
  laryngoskopi_1_N = mkN "laryngoskopi" "laryngoskopier" ; -- laryngoskopi..nn.1
  lasad_1_A = mkA "lasad" ; -- lasad..av.1
  lasagne_1_N = mkN "lasagne" utrum  ; -- lasagne..nn.1
  lasarett_1_N = mkN "lasarett" neutrum  ; -- lasarett..nn.1
  lasaron_1_N = mkN "lasaron" "lasaroner" ; -- lasaron..nn.1
  lasciv_1_A = mkA "lasciv" ; -- lasciv..av.1
  laser_1_N = mkN "laser" ; -- laser..nn.1
  lasera_1_V = mkV "laserar" ; -- lasera..vb.1
  laserande_1_N = mkN "laserande" ; -- laserande..nn.1
  laserbar_1_A = mkA "laserbar" ; -- laserbar..av.1
  laserbarhet_1_N = mkN "laserbarhet" ; -- laserbarhet..nn.1
  laserfärg_1_N = mkN "laserfärg" "laserfärger" ; -- laserfärg..nn.1
  lasering_1_N = mkN "lasering" ; -- lasering..nn.1
  laserkanon_1_N = mkN "laserkanon" "laserkanoner" ; -- laserkanon..nn.1
  laserpekande_1_N = mkN "laserpekande" ; -- laserpekande..nn.1
  laserpekare_1_N = mkN "laserpekare" utrum  ; -- laserpekare..nn.1
  lasersikte_1_N = mkN "lasersikte" ; -- lasersikte..nn.1
  laserskiva_1_N = mkN "laserskiva" ; -- laserskiva..nn.1
  laserstrålning_1_N = mkN "laserstrålning" ; -- laserstrålning..nn.1
  laserstyrd_1_A = mkA "laserstyrd" "laserstyrt" ; -- laserstyrd..av.1
  laserteknik_1_N = mkN "laserteknik" "lasertekniker" ; -- laserteknik..nn.1
  lask_1_N = mkN "lask" ; -- lask..nn.1
  laska_1_V = mkV "laskar" ; -- laska..vb.1
  laskande_1_N = mkN "laskande" ; -- laskande..nn.1
  laskning_1_N = mkN "laskning" ; -- laskning..nn.1
  lass_1_N = mkN "lass" neutrum  ; -- lass..nn.1
  lassa_1_V = mkV "lassar" ; -- lassa..vb.1
  lassande_1_N = mkN "lassande" ; -- lassande..nn.1
  lassning_1_N = mkN "lassning" ; -- lassning..nn.1
  lasso_1_N = mkN "lasso" "lassot" "lasson" "lassona" ; -- lasso..nn.1
  lassokast_1_N = mkN "lassokast" neutrum  ; -- lassokast..nn.1
  lassvis_1_Adv = mkAdv "lassvis" ; -- lassvis..ab.1
  last_1_N = mkN "last" "laster" ; -- last..nn.1
  lasta_1_V = mkV "lastar" ; -- lasta..vb.1
  lastageplats_1_N = mkN "lastageplats" "lastageplatser" ; -- lastageplats..nn.1
  lastande_1_N = mkN "lastande" ; -- lastande..nn.1
  lastare_1_N = mkN "lastare" utrum  ; -- lastare..nn.1
  lastbar_1_A = mkA "lastbar" ; -- lastbar..av.1
  lastbarhet_1_N = mkN "lastbarhet" "lastbarheter" ; -- lastbarhet..nn.1
  lastbil_1_N = mkN "lastbil" ; -- lastbil..nn.1
  lastbilsbar_1_N = mkN "lastbilsbar" "lastbilsbarer" ; -- lastbilsbar..nn.1
  lastbilschaufför_1_N = mkN "lastbilschaufför" "lastbilschaufförer" ; -- lastbilschaufför..nn.1
  lastbilsflak_1_N = mkN "lastbilsflak" neutrum  ; -- lastbilsflak..nn.1
  lastbilsförare_1_N = mkN "lastbilsförare" utrum  ; -- lastbilsförare..nn.1
  lastbilskrock_1_N = mkN "lastbilskrock" ; -- lastbilskrock..nn.1
  lastbilslass_1_N = mkN "lastbilslass" neutrum  ; -- lastbilslass..nn.1
  lastbilssläp_1_N = mkN "lastbilssläp" neutrum  ; -- lastbilssläp..nn.1
  lastbilstransport_1_N = mkN "lastbilstransport" "lastbilstransporter" ; -- lastbilstransport..nn.1
  lastbrygga_1_N = mkN "lastbrygga" ; -- lastbrygga..nn.1
  lastdjur_1_N = mkN "lastdjur" neutrum  ; -- lastdjur..nn.1
  lastdryg_1_A = mkA "lastdryg" ; -- lastdryg..av.1
  lastelig_1_A = mkA "lastelig" ; -- lastelig..av.1
  lastelighet_1_N = mkN "lastelighet" ; -- lastelighet..nn.1
  lastfartyg_1_N = mkN "lastfartyg" neutrum  ; -- lastfartyg..nn.1
  lastflak_1_N = mkN "lastflak" neutrum  ; -- lastflak..nn.1
  lastfull_1_A = mkA "lastfull" ; -- lastfull..av.1
  lastfullhet_1_N = mkN "lastfullhet" ; -- lastfullhet..nn.1
  lastförskjutning_1_N = mkN "lastförskjutning" ; -- lastförskjutning..nn.1
  lastgaller_1_N = mkN "lastgaller" neutrum  ; -- lastgaller..nn.1
  lasthållare_1_N = mkN "lasthållare" utrum  ; -- lasthållare..nn.1
  lasting_1_N = mkN "lasting" ; -- lasting..nn.1
  lastkaj_1_N = mkN "lastkaj" "lastkajer" ; -- lastkaj..nn.1
  lastklar_1_A = mkA "lastklar" ; -- lastklar..av.1
  lastkran_1_N = mkN "lastkran" ; -- lastkran..nn.1
  lastlinje_1_N = mkN "lastlinje" "lastlinjer" ; -- lastlinje..nn.1
  lastlucka_1_N = mkN "lastlucka" ; -- lastlucka..nn.1
  lastmaskin_1_N = mkN "lastmaskin" "lastmaskiner" ; -- lastmaskin..nn.1
  lastning_1_N = mkN "lastning" ; -- lastning..nn.1
  lastnät_1_N = mkN "lastnät" neutrum  ; -- lastnät..nn.1
  lastpall_1_N = mkN "lastpall" ; -- lastpall..nn.1
  lastplatta_1_N = mkN "lastplatta" ; -- lastplatta..nn.1
  lastport_1_N = mkN "lastport" ; -- lastport..nn.1
  lastprofil_1_N = mkN "lastprofil" "lastprofiler" ; -- lastprofil..nn.1
  lastrum_1_N = mkN "lastrum" "lastrummet" "lastrum" "lastrummen" ; -- lastrum..nn.1
  lastutrymme_1_N = mkN "lastutrymme" ; -- lastutrymme..nn.1
  lastvagn_1_N = mkN "lastvagn" ; -- lastvagn..nn.1
  lastvattenlinje_1_N = mkN "lastvattenlinje" "lastvattenlinjer" ; -- lastvattenlinje..nn.1
  lastyta_1_N = mkN "lastyta" ; -- lastyta..nn.1
  lastzon_1_N = mkN "lastzon" "lastzoner" ; -- lastzon..nn.1
  laståsna_1_N = mkN "laståsna" ; -- laståsna..nn.1
  lasur_1_N = mkN "lasur" "lasurer" ; -- lasur..nn.1
  lasurblå_1_A = mkA "lasurblå" "lasurblått" ; -- lasurblå..av.1
  lasyr_1_N = mkN "lasyr" "lasyrer" ; -- lasyr..nn.1
  lat_1_A = mkA "lat" ; -- lat..av.1
  latens_1_N = mkN "latens" ; -- latens..nn.1
  latenstid_1_N = mkN "latenstid" "latenstider" ; -- latenstid..nn.1
  latent_1_A = mkA "latent" "latent" ; -- latent..av.1
  latenthet_1_N = mkN "latenthet" ; -- latenthet..nn.1
  lateral_1_A = mkA "lateral" ; -- lateral..av.1
  lateral_1_N = mkN "lateral" "lateraler" ; -- lateral..nn.1
  latex_1_N = mkN "latex" ; -- latex..nn.1
  latexmålning_1_N = mkN "latexmålning" ; -- latexmålning..nn.1
  lathet_1_N = mkN "lathet" ; -- lathet..nn.1
  lathund_1_N = mkN "lathund" ; -- lathund..nn.1
  latin_amerikansk_1_A = mkA "latin-amerikansk" ; -- latin-amerikansk..av.1
  latin_1_N = mkN "latin" neutrum  ; -- latin..nn.1
  latinamerikan_1_N = mkN "latinamerikan" "latinamerikaner" ; -- latinamerikan..nn.1
  latinamerikansk_1_A = mkA "latinamerikansk" ; -- latinamerikansk..av.1
  latinamerikanska_1_N = mkN "latinamerikanska" ; -- latinamerikanska..nn.1
  latinare_1_N = mkN "latinare" utrum  ; -- latinare..nn.1
  latinisera_1_V = mkV "latiniserar" ; -- latinisera..vb.1
  latiniserande_1_N = mkN "latiniserande" ; -- latiniserande..nn.1
  latiniserbar_1_A = mkA "latiniserbar" ; -- latiniserbar..av.1
  latiniserbarhet_1_N = mkN "latiniserbarhet" ; -- latiniserbarhet..nn.1
  latinisering_1_N = mkN "latinisering" ; -- latinisering..nn.1
  latinism_1_N = mkN "latinism" "latinismer" ; -- latinism..nn.1
  latinkunnig_1_A = mkA "latinkunnig" ; -- latinkunnig..av.1
  latinkunnighet_1_N = mkN "latinkunnighet" ; -- latinkunnighet..nn.1
  latinlektor_1_N = mkN "latinlektor" "latinlektorer" ; -- latinlektor..nn.1
  latinlinje_1_N = mkN "latinlinje" "latinlinjer" ; -- latinlinje..nn.1
  latinläroverk_1_N = mkN "latinläroverk" neutrum  ; -- latinläroverk..nn.1
  latinsegel_1_N = mkN "latinsegel" neutrum  ; -- latinsegel..nn.1
  latinsk_1_A = mkA "latinsk" ; -- latinsk..av.1
  latintalande_1_A = mkA "latintalande" ; -- latintalande..av.1
  latinvälde_1_N = mkN "latinvälde" ; -- latinvälde..nn.1
  latitud_1_N = mkN "latitud" "latituder" ; -- latitud..nn.1
  latitudgrad_1_N = mkN "latitudgrad" "latitudgrader" ; -- latitudgrad..nn.1
  lativ_1_N = mkN "lativ" "lativer" ; -- lativ..nn.1
  latmaja_1_N = mkN "latmaja" ; -- latmaja..nn.1
  latmansliv_1_N = mkN "latmansliv" neutrum  ; -- latmansliv..nn.1
  latmask_1_N = mkN "latmask" ; -- latmask..nn.1
  latmasktillvaro_1_N = mkN "latmasktillvaro" ; -- latmasktillvaro..nn.1
  latoxe_1_N = mkN "latoxe" utrum  ; -- latoxe..nn.1
  latrin_1_N = mkN "latrin" "latriner" ; -- latrin..nn.1
  latrin_2_N = mkN "latrin" ; -- latrin..nn.2
  latta_1_N = mkN "latta" ; -- latta..nn.1
  latte_1_N = mkN "latte" utrum  ; -- latte..nn.1
  lattebar_1_N = mkN "lattebar" "lattebarer" ; -- lattebar..nn.1
  lattedrickande_1_A = mkA "lattedrickande" ; -- lattedrickande..av.1
  lattedrickande_1_N = mkN "lattedrickande" ; -- lattedrickande..nn.1
  lattemamma_1_N = mkN "lattemamma" ; -- lattemamma..nn.1
  lattepappa_1_N = mkN "lattepappa" ; -- lattepappa..nn.1
  lattja_1_V = mkV "lattjar" ; -- lattja..vb.1
  lattjande_1_N = mkN "lattjande" ; -- lattjande..nn.1
  lattjo_1_A = mkA "lattjo" ; -- lattjo..av.1
  laudatur_1_N = mkN "laudatur" neutrum  ; -- laudatur..nn.1
  laura_1_N = mkN "laura" ; -- laura..nn.1
  laurentium_1_N = mkN "laurentium" neutrum  ; -- laurentium..nn.1
  lav_1_N = mkN "lav" ; -- lav..nn.1
  lava_1_N = mkN "lava" ; -- lava..nn.1
  lavaflöde_1_N = mkN "lavaflöde" ; -- lavaflöde..nn.1
  lavafält_1_N = mkN "lavafält" neutrum  ; -- lavafält..nn.1
  lavasjö_1_N = mkN "lavasjö" ; -- lavasjö..nn.1
  lave_1_N = mkN "lave" utrum  ; -- lave..nn.1
  lavemang_1_N = mkN "lavemang" neutrum  ; -- lavemang..nn.1
  lavendel_1_N = mkN "lavendel" ; -- lavendel..nn.1
  lavendelblå_1_A = mkA "lavendelblå" "lavendelblått" ; -- lavendelblå..av.1
  lavendeldoft_1_N = mkN "lavendeldoft" "lavendeldofter" ; -- lavendeldoft..nn.1
  lavendeldoftande_1_A = mkA "lavendeldoftande" ; -- lavendeldoftande..av.1
  lavendelfärgad_1_A = mkA "lavendelfärgad" ; -- lavendelfärgad..av.1
  lavendeltvål_1_N = mkN "lavendeltvål" ; -- lavendeltvål..nn.1
  lavera_1_V = mkV "laverar" ; -- lavera..vb.1
  laverande_1_N = mkN "laverande" ; -- laverande..nn.1
  laverbar_1_A = mkA "laverbar" ; -- laverbar..av.1
  laverbarhet_1_N = mkN "laverbarhet" ; -- laverbarhet..nn.1
  lavering_1_N = mkN "lavering" ; -- lavering..nn.1
  lavett_1_N = mkN "lavett" "lavetter" ; -- lavett..nn.1
  lavin_1_N = mkN "lavin" "laviner" ; -- lavin..nn.1
  lavinartad_1_A = mkA "lavinartad" ; -- lavinartad..av.1
  lavinfara_1_N = mkN "lavinfara" ; -- lavinfara..nn.1
  lavinhund_1_N = mkN "lavinhund" ; -- lavinhund..nn.1
  lavinrisk_1_N = mkN "lavinrisk" ; -- lavinrisk..nn.1
  lavoar_1_N = mkN "lavoar" "lavoarer" ; -- lavoar..nn.1
  lavregion_1_N = mkN "lavregion" ; -- lavregion..nn.1
  lavskrika_1_N = mkN "lavskrika" ; -- lavskrika..nn.1
  lavyr_1_N = mkN "lavyr" "lavyrer" ; -- lavyr..nn.1
  lax_1_N = mkN "lax" ; -- lax..nn.1
  laxa_1_V = mkV "laxar" ; -- laxa..vb.1
  laxande_1_N = mkN "laxande" ; -- laxande..nn.1
  laxativ_1_N = mkN "laxativ" neutrum  ; -- laxativ..nn.1
  laxera_1_V = mkV "laxerar" ; -- laxera..vb.1
  laxerande_1_N = mkN "laxerande" ; -- laxerande..nn.1
  laxering_1_N = mkN "laxering" ; -- laxering..nn.1
  laxermedel_1_N = mkN "laxermedel" neutrum  ; -- laxermedel..nn.1
  laxerpiller_1_N = mkN "laxerpiller" neutrum  ; -- laxerpiller..nn.1
  laxfile_1_N = mkN "laxfile" "laxfileer" ; -- laxfile..nn.1
  laxfilé_1_N = mkN "laxfilé" "laxfiléer" ; -- laxfilé..nn.1
  laxfisk_1_N = mkN "laxfisk" ; -- laxfisk..nn.1
  laxfiske_1_N = mkN "laxfiske" ; -- laxfiske..nn.1
  laxfiskerättighet_1_N = mkN "laxfiskerättighet" "laxfiskerättigheter" ; -- laxfiskerättighet..nn.1
  laxfärg_1_N = mkN "laxfärg" "laxfärger" ; -- laxfärg..nn.1
  laxfärgad_1_A = mkA "laxfärgad" ; -- laxfärgad..av.1
  laxgård_1_N = mkN "laxgård" ; -- laxgård..nn.1
  laxkar_1_N = mkN "laxkar" neutrum  ; -- laxkar..nn.1
  laxkista_1_N = mkN "laxkista" ; -- laxkista..nn.1
  laxkotlett_1_N = mkN "laxkotlett" "laxkotletter" ; -- laxkotlett..nn.1
  laxlus_1_N = mkN "laxlus" "laxlusen" "laxlöss" "laxlössen" ; -- laxlus..nn.1
  laxning_1_N = mkN "laxning" ; -- laxning..nn.1
  laxränna_1_N = mkN "laxränna" ; -- laxränna..nn.1
  laxsida_1_N = mkN "laxsida" ; -- laxsida..nn.1
  laxstjärt_1_N = mkN "laxstjärt" ; -- laxstjärt..nn.1
  laxtrappa_1_N = mkN "laxtrappa" ; -- laxtrappa..nn.1
  laxyngel_1_N = mkN "laxyngel" neutrum  ; -- laxyngel..nn.1
  laxöring_1_N = mkN "laxöring" ; -- laxöring..nn.1
  layout_1_N = mkN "layout" "layouter" ; -- layout..nn.1
  layoutchef_1_N = mkN "layoutchef" "layoutchefer" ; -- layoutchef..nn.1
  layoutmässig_1_A = mkA "layoutmässig" ; -- layoutmässig..av.1
  lazzaron_1_N = mkN "lazzaron" "lazzaroner" ; -- lazzaron..nn.1
  lcd_skärm_1_N = mkN "lcd-skärm" ; -- lcd-skärm..nn.1
  lcd_teve_1_N = mkN "lcd-teve" "lcd-teven" "lcd-tevear" "lcd-tevearna" ; -- lcd-teve..nn.1
  le_1_A = mkA "le" "lett" ; -- le..av.1
  le_1_V = mkV "le" "log" "lett" ; -- le..vb.1
  lealös_1_A = mkA "lealös" ; -- lealös..av.1
  lealöshet_1_N = mkN "lealöshet" ; -- lealöshet..nn.1
  leasa_1_V = mkV "leasar" ; -- leasa..vb.1
  leasande_1_N = mkN "leasande" ; -- leasande..nn.1
  leasing_1_N = mkN "leasing" ; -- leasing..nn.1
  lebb_1_N = mkN "lebb" ; -- lebb..nn.1
  lebba_1_N = mkN "lebba" ; -- lebba..nn.1
  lebbporr_1_N = mkN "lebbporr" ; -- lebbporr..nn.1
  lebeman_1_N = mkN "lebeman" "lebemannen" "lebemän" "lebemännen" ; -- lebeman..nn.1
  lecitin_1_N = mkN "lecitin" "lecitiner" ; -- lecitin..nn.1
  led_1_A = mkA "led" "lett" ; -- led..av.1
  led_1_N = mkN "led" "leder" ; -- led..nn.1
  led_2_N = mkN "led" neutrum  ; -- led..nn.2
  led_3_N = mkN "led" neutrum  ; -- led..nn.3
  leda_1_N = mkN "leda" ; -- leda..nn.1
  leda_1_V = mkV "leda" "ledde" "lett" ; -- leda..vb.1
  leda_2_V = mkV "ledar" ; -- leda..vb.2
  ledad_1_A = mkA "ledad" ; -- ledad..av.1
  ledamot_1_N = mkN "ledamot" "ledamöter" ; -- ledamot..nn.1
  ledande_1_N = mkN "ledande" ; -- ledande..nn.1
  ledarbegåvning_1_N = mkN "ledarbegåvning" ; -- ledarbegåvning..nn.1
  ledare_1_N = mkN "ledare" utrum  ; -- ledare..nn.1
  ledarhund_1_N = mkN "ledarhund" ; -- ledarhund..nn.1
  ledarkult_1_N = mkN "ledarkult" "ledarkulter" ; -- ledarkult..nn.1
  ledarpar_1_N = mkN "ledarpar" neutrum  ; -- ledarpar..nn.1
  ledarplats_1_N = mkN "ledarplats" "ledarplatser" ; -- ledarplats..nn.1
  ledarredaktion_1_N = mkN "ledarredaktion" ; -- ledarredaktion..nn.1
  ledarroll_1_N = mkN "ledarroll" "ledarroller" ; -- ledarroll..nn.1
  ledarsida_1_N = mkN "ledarsida" ; -- ledarsida..nn.1
  ledarskap_1_N = mkN "ledarskap" neutrum  ; -- ledarskap..nn.1
  ledarskapskris_1_N = mkN "ledarskapskris" "ledarskapskriser" ; -- ledarskapskris..nn.1
  ledarskapsmässig_1_A = mkA "ledarskapsmässig" ; -- ledarskapsmässig..av.1
  ledarskifte_1_N = mkN "ledarskifte" ; -- ledarskifte..nn.1
  ledarskikt_1_N = mkN "ledarskikt" neutrum  ; -- ledarskikt..nn.1
  ledarskribent_1_N = mkN "ledarskribent" "ledarskribenter" ; -- ledarskribent..nn.1
  ledarstick_1_N = mkN "ledarstick" neutrum  ; -- ledarstick..nn.1
  ledarstil_1_N = mkN "ledarstil" ; -- ledarstil..nn.1
  ledartext_1_N = mkN "ledartext" "ledartexter" ; -- ledartext..nn.1
  ledband_1_N = mkN "ledband" neutrum  ; -- ledband..nn.1
  ledbrosk_1_N = mkN "ledbrosk" neutrum  ; -- ledbrosk..nn.1
  ledbruten_1_A = mkA "ledbruten" ; -- ledbruten..av.1
  ledbrutenhet_1_N = mkN "ledbrutenhet" ; -- ledbrutenhet..nn.1
  ledd_1_N = mkN "ledd" "ledder" ; -- ledd..nn.1
  leddjur_1_N = mkN "leddjur" neutrum  ; -- leddjur..nn.1
  leddocka_1_N = mkN "leddocka" ; -- leddocka..nn.1
  ledfogning_1_N = mkN "ledfogning" ; -- ledfogning..nn.1
  ledfyr_1_N = mkN "ledfyr" ; -- ledfyr..nn.1
  ledförslitning_1_N = mkN "ledförslitning" ; -- ledförslitning..nn.1
  ledgång_1_N = mkN "ledgång" ; -- ledgång..nn.1
  ledgång_2_N = mkN "ledgång" ; -- ledgång..nn.2
  ledgångsreumatism_1_N = mkN "ledgångsreumatism" "ledgångsreumatismer" ; -- ledgångsreumatism..nn.1
  ledhet_1_N = mkN "ledhet" ; -- ledhet..nn.1
  ledhuvud_1_N = mkN "ledhuvud" "ledhuvudet" "ledhuvud" "ledhuvudena" ; -- ledhuvud..nn.1
  ledig_1_A = mkA "ledig" ; -- ledig..av.1
  ledigförklara_1_V = mkV "ledigförklarar" ; -- ledigförklara..vb.1
  ledigförklarande_1_N = mkN "ledigförklarande" ; -- ledigförklarande..nn.1
  ledighet_1_N = mkN "ledighet" "ledigheter" ; -- ledighet..nn.1
  ledighetskommitté_1_N = mkN "ledighetskommitté" "ledighetskommittéer" ; -- ledighetskommitté..nn.1
  ledinflammation_1_N = mkN "ledinflammation" ; -- ledinflammation..nn.1
  ledkapsel_1_N = mkN "ledkapsel" ; -- ledkapsel..nn.1
  ledkort_1_N = mkN "ledkort" neutrum  ; -- ledkort..nn.1
  ledkramp_1_N = mkN "ledkramp" "ledkramper" ; -- ledkramp..nn.1
  ledlampa_1_N = mkN "ledlampa" ; -- ledlampa..nn.1
  ledmotiv_1_N = mkN "ledmotiv" neutrum  ; -- ledmotiv..nn.1
  ledning_1_N = mkN "ledning" ; -- ledning..nn.1
  ledning_2_N = mkN "ledning" ; -- ledning..nn.2
  ledningsförmåga_1_N = mkN "ledningsförmåga" ; -- ledningsförmåga..nn.1
  ledningsgrupp_1_N = mkN "ledningsgrupp" "ledningsgrupper" ; -- ledningsgrupp..nn.1
  ledningskapacitet_1_N = mkN "ledningskapacitet" "ledningskapaciteter" ; -- ledningskapacitet..nn.1
  ledningsmotstånd_1_N = mkN "ledningsmotstånd" neutrum  ; -- ledningsmotstånd..nn.1
  ledningsmässig_1_A = mkA "ledningsmässig" ; -- ledningsmässig..av.1
  ledningsmål_1_N = mkN "ledningsmål" neutrum  ; -- ledningsmål..nn.1
  ledningsorgan_1_N = mkN "ledningsorgan" neutrum  ; -- ledningsorgan..nn.1
  ledningsstolpe_1_N = mkN "ledningsstolpe" utrum  ; -- ledningsstolpe..nn.1
  ledningstråd_1_N = mkN "ledningstråd" ; -- ledningstråd..nn.1
  ledningsvävnad_1_N = mkN "ledningsvävnad" "ledningsvävnader" ; -- ledningsvävnad..nn.1
  ledord_1_N = mkN "ledord" neutrum  ; -- ledord..nn.1
  leds_1_A = mkA "leds" ; -- leds..av.1
  ledsaga_1_V = mkV "ledsagar" ; -- ledsaga..vb.1
  ledsagande_1_N = mkN "ledsagande" ; -- ledsagande..nn.1
  ledsagare_1_N = mkN "ledsagare" utrum  ; -- ledsagare..nn.1
  ledsagarinna_1_N = mkN "ledsagarinna" ; -- ledsagarinna..nn.1
  ledsam_1_A = mkA "ledsam" "ledsamt" "ledsamma" "ledsamma" "ledsammare" "ledsammast" "ledsammaste" ; -- ledsam..av.1
  ledsamhet_1_N = mkN "ledsamhet" "ledsamheter" ; -- ledsamhet..nn.1
  ledsegel_1_N = mkN "ledsegel" neutrum  ; -- ledsegel..nn.1
  ledsen_1_A = mkA "ledsen" ; -- ledsen..av.1
  ledsenhet_1_N = mkN "ledsenhet" "ledsenheter" ; -- ledsenhet..nn.1
  ledskål_1_N = mkN "ledskål" ; -- ledskål..nn.1
  ledsna_1_V = mkV "ledsnar" ; -- ledsna..vb.1
  ledsnad_1_N = mkN "ledsnad" "ledsnader" ; -- ledsnad..nn.1
  ledsnande_1_N = mkN "ledsnande" ; -- ledsnande..nn.1
  ledstjärna_1_N = mkN "ledstjärna" ; -- ledstjärna..nn.1
  ledstyv_1_A = mkA "ledstyv" ; -- ledstyv..av.1
  ledstång_1_N = mkN "ledstång" "ledstänger" ; -- ledstång..nn.1
  ledsyn_1_N = mkN "ledsyn" ; -- ledsyn..nn.1
  ledtråd_1_N = mkN "ledtråd" ; -- ledtråd..nn.1
  ledung_1_N = mkN "ledung" ; -- ledung..nn.1
  ledungsskepp_1_N = mkN "ledungsskepp" neutrum  ; -- ledungsskepp..nn.1
  ledutrymme_1_N = mkN "ledutrymme" ; -- ledutrymme..nn.1
  ledvärk_1_N = mkN "ledvärk" ; -- ledvärk..nn.1
  ledvätska_1_N = mkN "ledvätska" ; -- ledvätska..nn.1
  ledyta_1_N = mkN "ledyta" ; -- ledyta..nn.1
  leende_1_N = mkN "leende" ; -- leende..nn.1
  leg_1_N = mkN "leg" neutrum  ; -- leg..nn.1
  lega_1_N = mkN "lega" ; -- lega..nn.1
  legal_1_A = mkA "legal" ; -- legal..av.1
  legalisation_1_N = mkN "legalisation" ; -- legalisation..nn.1
  legalisera_1_V = mkV "legaliserar" ; -- legalisera..vb.1
  legaliserande_1_N = mkN "legaliserande" ; -- legaliserande..nn.1
  legaliserbar_1_A = mkA "legaliserbar" ; -- legaliserbar..av.1
  legaliserbarhet_1_N = mkN "legaliserbarhet" ; -- legaliserbarhet..nn.1
  legalisering_1_N = mkN "legalisering" ; -- legalisering..nn.1
  legaliter_1_Adv = mkAdv "legaliter" ; -- legaliter..ab.1
  legalitet_1_N = mkN "legalitet" "legaliteter" ; -- legalitet..nn.1
  legat_1_N = mkN "legat" "legater" ; -- legat..nn.1
  legat_2_N = mkN "legat" neutrum  ; -- legat..nn.2
  legatarie_1_N = mkN "legatarie" "legatarier" ; -- legatarie..nn.1
  legation_1_N = mkN "legation" ; -- legation..nn.1
  legato_1_N = mkN "legato" "legatot" "legaton" "legatona" ; -- legato..nn.1
  legend_1_N = mkN "legend" "legender" ; -- legend..nn.1
  legendar_1_N = mkN "legendar" "legendarer" ; -- legendar..nn.1
  legendarisk_1_A = mkA "legendarisk" ; -- legendarisk..av.1
  legendarium_1_N = mkN "legendarium" "legendariet" "legendarier" "legendarierna" ; -- legendarium..nn.1
  legendartad_1_A = mkA "legendartad" ; -- legendartad..av.1
  legendomspunnen_1_A = mkA "legendomspunnen" "legendomspunnet" "legendomspunna" "legendomspunna" "legendomspunnare" "legendomspunnast" "legendomspunnaste" ; -- legendomspunnen..av.1
  legendomsusad_1_A = mkA "legendomsusad" ; -- legendomsusad..av.1
  legera_1_V = mkV "legerar" ; -- legera..vb.1
  legerande_1_N = mkN "legerande" ; -- legerande..nn.1
  legerbar_1_A = mkA "legerbar" ; -- legerbar..av.1
  legerbarhet_1_N = mkN "legerbarhet" ; -- legerbarhet..nn.1
  legering_1_N = mkN "legering" ; -- legering..nn.1
  legg_1_N = mkN "legg" neutrum  ; -- legg..nn.1
  legio_1_A = mkA "legio" ; -- legio..av.1
  legion_1_N = mkN "legion" ; -- legion..nn.1
  legionella_1_N = mkN "legionella" ; -- legionella..nn.1
  legionär_1_N = mkN "legionär" "legionärer" ; -- legionär..nn.1
  legionärssjuka_1_N = mkN "legionärssjuka" ; -- legionärssjuka..nn.1
  legislativ_1_A = mkA "legislativ" ; -- legislativ..av.1
  legislatur_1_N = mkN "legislatur" "legislaturer" ; -- legislatur..nn.1
  legitim_1_A = mkA "legitim" ; -- legitim..av.1
  legitimation_1_N = mkN "legitimation" ; -- legitimation..nn.1
  legitimera_1_V = mkV "legitimerar" ; -- legitimera..vb.1
  legitimerande_1_N = mkN "legitimerande" ; -- legitimerande..nn.1
  legitimerbar_1_A = mkA "legitimerbar" ; -- legitimerbar..av.1
  legitimerbarhet_1_N = mkN "legitimerbarhet" ; -- legitimerbarhet..nn.1
  legitimering_1_N = mkN "legitimering" ; -- legitimering..nn.1
  legitimist_1_N = mkN "legitimist" "legitimister" ; -- legitimist..nn.1
  legitimitet_1_N = mkN "legitimitet" "legitimiteter" ; -- legitimitet..nn.1
  legitimitetsprincip_1_N = mkN "legitimitetsprincip" ; -- legitimitetsprincip..nn.1
  legitimitetsproblem_1_N = mkN "legitimitetsproblem" neutrum  ; -- legitimitetsproblem..nn.1
  lego_1_N = mkN "lego" "legot" "legon" "legona" ; -- lego..nn.1
  legoavtal_1_N = mkN "legoavtal" neutrum  ; -- legoavtal..nn.1
  legobit_1_N = mkN "legobit" ; -- legobit..nn.1
  legohjon_1_N = mkN "legohjon" neutrum  ; -- legohjon..nn.1
  legoknekt_1_N = mkN "legoknekt" ; -- legoknekt..nn.1
  legosoldat_1_N = mkN "legosoldat" "legosoldater" ; -- legosoldat..nn.1
  legotillverkning_1_N = mkN "legotillverkning" ; -- legotillverkning..nn.1
  legotrupp_1_N = mkN "legotrupp" "legotrupper" ; -- legotrupp..nn.1
  leguan_1_N = mkN "leguan" "leguaner" ; -- leguan..nn.1
  legymsallad_1_N = mkN "legymsallad" "legymsallader" ; -- legymsallad..nn.1
  legär_1_A = mkA "legär" ; -- legär..av.1
  lehet_1_N = mkN "lehet" ; -- lehet..nn.1
  leidenflaska_1_N = mkN "leidenflaska" ; -- leidenflaska..nn.1
  leidnerflaska_1_N = mkN "leidnerflaska" ; -- leidnerflaska..nn.1
  leja_1_V = mkV "leja" "lejde" "lejt" ; -- leja..vb.1
  lejande_1_N = mkN "lejande" ; -- lejande..nn.1
  lejd_1_N = mkN "lejd" ; -- lejd..nn.1
  lejdare_1_N = mkN "lejdare" utrum  ; -- lejdare..nn.1
  lejdbåt_1_N = mkN "lejdbåt" ; -- lejdbåt..nn.1
  lejdebrev_1_N = mkN "lejdebrev" neutrum  ; -- lejdebrev..nn.1
  lejdra_1_V = mkV "lejdrar" ; -- lejdra..vb.1
  lejdrande_1_N = mkN "lejdrande" ; -- lejdrande..nn.1
  lejdtrafik_1_N = mkN "lejdtrafik" ; -- lejdtrafik..nn.1
  lejning_1_N = mkN "lejning" ; -- lejning..nn.1
  lejon_1_N = mkN "lejon" neutrum  ; -- lejon..nn.1
  lejonfot_1_N = mkN "lejonfot" "lejonfötter" ; -- lejonfot..nn.1
  lejongap_1_N = mkN "lejongap" neutrum  ; -- lejongap..nn.1
  lejongrop_1_N = mkN "lejongrop" ; -- lejongrop..nn.1
  lejoninna_1_N = mkN "lejoninna" ; -- lejoninna..nn.1
  lejonjakt_1_N = mkN "lejonjakt" "lejonjakter" ; -- lejonjakt..nn.1
  lejonkula_1_N = mkN "lejonkula" ; -- lejonkula..nn.1
  lejonpart_1_N = mkN "lejonpart" ; -- lejonpart..nn.1
  lejonskinn_1_N = mkN "lejonskinn" neutrum  ; -- lejonskinn..nn.1
  lejontämjare_1_N = mkN "lejontämjare" utrum  ; -- lejontämjare..nn.1
  lek_1_A = mkA "lek" ; -- lek..av.1
  lek_1_N = mkN "lek" ; -- lek..nn.1
  leka_1_V = mkV "leker" ; -- leka..vb.1
  lekamlig_1_A = mkA "lekamlig" ; -- lekamlig..av.1
  lekamligen_1_Adv = mkAdv "lekamligen" ; -- lekamligen..ab.1
  lekamlighet_1_N = mkN "lekamlighet" ; -- lekamlighet..nn.1
  lekande_1_N = mkN "lekande" ; -- lekande..nn.1
  lekare_1_N = mkN "lekare" utrum  ; -- lekare..nn.1
  lekatt_1_N = mkN "lekatt" "lekatter" ; -- lekatt..nn.1
  lekattfälla_1_N = mkN "lekattfälla" ; -- lekattfälla..nn.1
  lekboll_1_N = mkN "lekboll" ; -- lekboll..nn.1
  lekdamm_1_N = mkN "lekdamm" ; -- lekdamm..nn.1
  lekdräkt_1_N = mkN "lekdräkt" "lekdräkter" ; -- lekdräkt..nn.1
  lekfisk_1_N = mkN "lekfisk" ; -- lekfisk..nn.1
  lekfiske_1_N = mkN "lekfiske" ; -- lekfiske..nn.1
  lekfull_1_A = mkA "lekfull" ; -- lekfull..av.1
  lekfullhet_1_N = mkN "lekfullhet" "lekfullheter" ; -- lekfullhet..nn.1
  lekfärdig_1_A = mkA "lekfärdig" ; -- lekfärdig..av.1
  lekfärdighet_1_N = mkN "lekfärdighet" ; -- lekfärdighet..nn.1
  lekkamrat_1_N = mkN "lekkamrat" "lekkamrater" ; -- lekkamrat..nn.1
  lekledare_1_N = mkN "lekledare" utrum  ; -- lekledare..nn.1
  leklynne_1_N = mkN "leklynne" ; -- leklynne..nn.1
  leklysten_1_A = mkA "leklysten" ; -- leklysten..av.1
  leklystenhet_1_N = mkN "leklystenhet" ; -- leklystenhet..nn.1
  leklystnad_1_N = mkN "leklystnad" ; -- leklystnad..nn.1
  lekman_1_N = mkN "lekman" "lekmannen" "lekmän" "lekmännen" ; -- lekman..nn.1
  lekmannabroder_1_N = mkN "lekmannabroder" "lekmannabrodern" "lekmannabröder" "lekmannabröderna" ; -- lekmannabroder..nn.1
  lekmannaförstånd_1_N = mkN "lekmannaförstånd" neutrum  ; -- lekmannaförstånd..nn.1
  lekmannamässig_1_A = mkA "lekmannamässig" ; -- lekmannamässig..av.1
  lekmannaorganisation_1_N = mkN "lekmannaorganisation" ; -- lekmannaorganisation..nn.1
  lekmannaövervakare_1_N = mkN "lekmannaövervakare" utrum  ; -- lekmannaövervakare..nn.1
  lekotek_1_N = mkN "lekotek" neutrum  ; -- lekotek..nn.1
  lekpark_1_N = mkN "lekpark" "lekparker" ; -- lekpark..nn.1
  lekplats_1_N = mkN "lekplats" "lekplatser" ; -- lekplats..nn.1
  leksak_1_N = mkN "leksak" "leksaker" ; -- leksak..nn.1
  leksaksbil_1_N = mkN "leksaksbil" ; -- leksaksbil..nn.1
  leksaksbjörn_1_N = mkN "leksaksbjörn" ; -- leksaksbjörn..nn.1
  leksaksbåt_1_N = mkN "leksaksbåt" ; -- leksaksbåt..nn.1
  leksaksbössa_1_N = mkN "leksaksbössa" ; -- leksaksbössa..nn.1
  leksaksdjur_1_N = mkN "leksaksdjur" neutrum  ; -- leksaksdjur..nn.1
  leksaksfigur_1_N = mkN "leksaksfigur" "leksaksfigurer" ; -- leksaksfigur..nn.1
  leksakshäst_1_N = mkN "leksakshäst" ; -- leksakshäst..nn.1
  leksakspistol_1_N = mkN "leksakspistol" "leksakspistoler" ; -- leksakspistol..nn.1
  leksakstrumpet_1_N = mkN "leksakstrumpet" "leksakstrumpeter" ; -- leksakstrumpet..nn.1
  lekskola_1_N = mkN "lekskola" ; -- lekskola..nn.1
  lekstuga_1_N = mkN "lekstuga" ; -- lekstuga..nn.1
  lekt_1_A = mkA "lekt" ; -- lekt..av.1
  lektid_1_N = mkN "lektid" "lektider" ; -- lektid..nn.1
  lektion_1_N = mkN "lektion" ; -- lektion..nn.1
  lektionstimma_1_N = mkN "lektionstimma" ; -- lektionstimma..nn.1
  lektionstimme_1_N = mkN "lektionstimme" utrum  ; -- lektionstimme..nn.1
  lektor_1_N = mkN "lektor" "lektorer" ; -- lektor..nn.1
  lektorat_1_N = mkN "lektorat" neutrum  ; -- lektorat..nn.1
  lektorstjänst_1_N = mkN "lektorstjänst" "lektorstjänster" ; -- lektorstjänst..nn.1
  lektris_1_N = mkN "lektris" "lektriser" ; -- lektris..nn.1
  lektyr_1_N = mkN "lektyr" ; -- lektyr..nn.1
  lektör_1_N = mkN "lektör" "lektörer" ; -- lektör..nn.1
  lekvandring_1_N = mkN "lekvandring" ; -- lekvandring..nn.1
  lekverk_1_N = mkN "lekverk" neutrum  ; -- lekverk..nn.1
  lem_1_N = mkN "lem" "lemmen" "lemmar" "lemmarna" ; -- lem..nn.1
  lemgram_1_N = mkN "lemgram" "lemgrammet" "lemgram" "lemgrammen" ; -- lemgram..nn.1
  lemlästa_1_V = mkV "lemlästar" ; -- lemlästa..vb.1
  lemlästande_1_N = mkN "lemlästande" ; -- lemlästande..nn.1
  lemlästning_1_N = mkN "lemlästning" ; -- lemlästning..nn.1
  lemma_1_N = mkN "lemma" "lemmat" "lemman" "lemmana" ; -- lemma..nn.1
  lemmalytt_1_A = mkA "lemmalytt" ; -- lemmalytt..av.1
  lemmalytthet_1_N = mkN "lemmalytthet" ; -- lemmalytthet..nn.1
  lemonad_1_N = mkN "lemonad" "lemonader" ; -- lemonad..nn.1
  lemur_1_N = mkN "lemur" "lemurer" ; -- lemur..nn.1
  len_1_A = mkA "len" ; -- len..av.1
  lena_1_V = mkV "lenar" ; -- lena..vb.1
  lenande_1_N = mkN "lenande" ; -- lenande..nn.1
  lenhet_1_N = mkN "lenhet" ; -- lenhet..nn.1
  leninism_1_N = mkN "leninism" "leninismer" ; -- leninism..nn.1
  leninistisk_1_A = mkA "leninistisk" ; -- leninistisk..av.1
  lenis_1_A = mkA "lenis" ; -- lenis..av.1
  leopard_1_N = mkN "leopard" "leoparder" ; -- leopard..nn.1
  leopardmönstrad_1_A = mkA "leopardmönstrad" ; -- leopardmönstrad..av.1
  leopardskinn_1_N = mkN "leopardskinn" neutrum  ; -- leopardskinn..nn.1
  lepra_1_N = mkN "lepra" ; -- lepra..nn.1
  leprös_1_A = mkA "leprös" ; -- leprös..av.1
  leptit_1_N = mkN "leptit" ; -- leptit..nn.1
  leptosom_1_A = mkA "leptosom" ; -- leptosom..av.1
  lera_1_N = mkN "lera" ; -- lera..nn.1
  lerbotten_1_N = mkN "lerbotten" ; -- lerbotten..nn.1
  lercylinder_1_N = mkN "lercylinder" ; -- lercylinder..nn.1
  lerduva_1_N = mkN "lerduva" ; -- lerduva..nn.1
  lerduveskytte_1_N = mkN "lerduveskytte" ; -- lerduveskytte..nn.1
  lerfat_1_N = mkN "lerfat" neutrum  ; -- lerfat..nn.1
  lergods_1_N = mkN "lergods" neutrum  ; -- lergods..nn.1
  lergök_1_N = mkN "lergök" ; -- lergök..nn.1
  lergöksröst_1_N = mkN "lergöksröst" "lergöksröster" ; -- lergöksröst..nn.1
  lerhalt_1_N = mkN "lerhalt" "lerhalter" ; -- lerhalt..nn.1
  lerhaltig_1_A = mkA "lerhaltig" ; -- lerhaltig..av.1
  lerhus_1_N = mkN "lerhus" neutrum  ; -- lerhus..nn.1
  lerhärd_1_N = mkN "lerhärd" ; -- lerhärd..nn.1
  lerig_1_A = mkA "lerig" ; -- lerig..av.1
  lerjord_1_N = mkN "lerjord" ; -- lerjord..nn.1
  lerklining_1_N = mkN "lerklining" ; -- lerklining..nn.1
  lerkruka_1_N = mkN "lerkruka" ; -- lerkruka..nn.1
  lerkrus_1_N = mkN "lerkrus" neutrum  ; -- lerkrus..nn.1
  lerkärl_1_N = mkN "lerkärl" neutrum  ; -- lerkärl..nn.1
  lerras_1_N = mkN "lerras" neutrum  ; -- lerras..nn.1
  lerskiffer_1_N = mkN "lerskiffer" ; -- lerskiffer..nn.1
  lerskärva_1_N = mkN "lerskärva" ; -- lerskärva..nn.1
  lerslätt_1_N = mkN "lerslätt" "lerslätter" ; -- lerslätt..nn.1
  lersten_1_N = mkN "lersten" "lerstenen" "lerstenar" "lerstenarna" ; -- lersten..nn.1
  lervägg_1_N = mkN "lervägg" ; -- lervägg..nn.1
  lervälling_1_N = mkN "lervälling" ; -- lervälling..nn.1
  leråker_1_N = mkN "leråker" ; -- leråker..nn.1
  lesbisk_1_A = mkA "lesbisk" ; -- lesbisk..av.1
  lesion_1_N = mkN "lesion" ; -- lesion..nn.1
  lesothier_1_N = mkN "lesothier" "lesothiern" "lesothier" "lesothierna" ; -- lesothier..nn.1
  lesothisk_1_A = mkA "lesothisk" ; -- lesothisk..av.1
  lesothiska_1_N = mkN "lesothiska" ; -- lesothiska..nn.1
  less_1_A = mkA "less" ; -- less..av.1
  lessen_1_A = mkA "lessen" ; -- lessen..av.1
  lessenhet_1_N = mkN "lessenhet" "lessenheter" ; -- lessenhet..nn.1
  lessna_1_V = mkV "lessnar" ; -- lessna..vb.1
  lessnad_1_N = mkN "lessnad" "lessnader" ; -- lessnad..nn.1
  lessnande_1_N = mkN "lessnande" ; -- lessnande..nn.1
  lestadian_1_N = mkN "lestadian" "lestadianer" ; -- lestadian..nn.1
  lestadianism_1_N = mkN "lestadianism" "lestadianismer" ; -- lestadianism..nn.1
  leta_1_V = mkV "letar" ; -- leta..vb.1
  letal_1_A = mkA "letal" ; -- letal..av.1
  letande_1_N = mkN "letande" ; -- letande..nn.1
  letargi_1_N = mkN "letargi" ; -- letargi..nn.1
  letargisk_1_A = mkA "letargisk" ; -- letargisk..av.1
  letning_1_N = mkN "letning" ; -- letning..nn.1
  lett_1_N = mkN "lett" "letter" ; -- lett..nn.1
  lettisk_1_A = mkA "lettisk" ; -- lettisk..av.1
  lettiska_1_N = mkN "lettiska" ; -- lettiska..nn.1
  lettiska_2_N = mkN "lettiska" ; -- lettiska..nn.2
  lettländare_1_N = mkN "lettländare" utrum  ; -- lettländare..nn.1
  lettländska_1_N = mkN "lettländska" ; -- lettländska..nn.1
  lettländska_2_N = mkN "lettländska" ; -- lettländska..nn.2
  lettra_1_V = mkV "lettrar" ; -- lettra..vb.1
  lettrande_1_N = mkN "lettrande" ; -- lettrande..nn.1
  leukemi_1_N = mkN "leukemi" "leukemier" ; -- leukemi..nn.1
  leukocyt_1_N = mkN "leukocyt" "leukocyter" ; -- leukocyt..nn.1
  lev_1_N = mkN "lev" ; -- lev..nn.1
  leva_1_N = mkN "leva" "levan" "leva" "levana" ; -- leva..nn.1
  leva_1_V = mkV "lever" ; -- leva..vb.1
  levande_1_A = mkA "levande" ; -- levande..av.1
  levande_1_N = mkN "levande" ; -- levande..nn.1
  levandegöra_1_V = mkV "levandegöra" "levandegjorde" "levandegjort" ; -- levandegöra..vb.1
  levandegörande_1_N = mkN "levandegörande" ; -- levandegörande..nn.1
  levang_1_N = mkN "levang" "levanger" ; -- levang..nn.1
  levantin_1_N = mkN "levantin" "levantiner" ; -- levantin..nn.1
  leve_1_N = mkN "leve" ; -- leve..nn.1
  levebröd_1_N = mkN "levebröd" neutrum  ; -- levebröd..nn.1
  lever_1_N = mkN "lever" ; -- lever..nn.1
  leverabel_1_N = mkN "leverabel" "leverabeln" "leverabler" "leverablerna" ; -- leverabel..nn.1
  leverans_1_N = mkN "leverans" "leveranser" ; -- leverans..nn.1
  leveransavtal_1_N = mkN "leveransavtal" neutrum  ; -- leveransavtal..nn.1
  leveransklar_1_A = mkA "leveransklar" ; -- leveransklar..av.1
  leveranssäkerhet_1_N = mkN "leveranssäkerhet" ; -- leveranssäkerhet..nn.1
  leveranstid_1_N = mkN "leveranstid" "leveranstider" ; -- leveranstid..nn.1
  leverantör_1_N = mkN "leverantör" "leverantörer" ; -- leverantör..nn.1
  leverbrun_1_A = mkA "leverbrun" ; -- leverbrun..av.1
  levercell_1_N = mkN "levercell" "leverceller" ; -- levercell..nn.1
  levercirros_1_N = mkN "levercirros" "levercirroser" ; -- levercirros..nn.1
  leverera_1_V = mkV "levererar" ; -- leverera..vb.1
  levererande_1_N = mkN "levererande" ; -- levererande..nn.1
  levererbar_1_A = mkA "levererbar" ; -- levererbar..av.1
  levererbarhet_1_N = mkN "levererbarhet" ; -- levererbarhet..nn.1
  leverering_1_N = mkN "leverering" ; -- leverering..nn.1
  leverfläck_1_N = mkN "leverfläck" ; -- leverfläck..nn.1
  leverförstoring_1_N = mkN "leverförstoring" ; -- leverförstoring..nn.1
  levermossa_1_N = mkN "levermossa" ; -- levermossa..nn.1
  leverne_1_N = mkN "leverne" ; -- leverne..nn.1
  leverop_1_N = mkN "leverop" neutrum  ; -- leverop..nn.1
  leverpastej_1_N = mkN "leverpastej" "leverpastejer" ; -- leverpastej..nn.1
  leverpastejmacka_1_N = mkN "leverpastejmacka" ; -- leverpastejmacka..nn.1
  leverpastejsmörgås_1_N = mkN "leverpastejsmörgås" ; -- leverpastejsmörgås..nn.1
  leverprov_1_N = mkN "leverprov" neutrum  ; -- leverprov..nn.1
  leverskrumpning_1_N = mkN "leverskrumpning" ; -- leverskrumpning..nn.1
  levertran_1_N = mkN "levertran" ; -- levertran..nn.1
  levervärde_1_N = mkN "levervärde" ; -- levervärde..nn.1
  levit_1_N = mkN "levit" "leviter" ; -- levit..nn.1
  levitisk_1_A = mkA "levitisk" ; -- levitisk..av.1
  levnad_1_N = mkN "levnad" "levnader" ; -- levnad..nn.1
  levnadsafton_1_N = mkN "levnadsafton" ; -- levnadsafton..nn.1
  levnadsbana_1_N = mkN "levnadsbana" ; -- levnadsbana..nn.1
  levnadsbeskrivning_1_N = mkN "levnadsbeskrivning" ; -- levnadsbeskrivning..nn.1
  levnadsdag_1_N = mkN "levnadsdag" ; -- levnadsdag..nn.1
  levnadsförhållande_1_N = mkN "levnadsförhållande" ; -- levnadsförhållande..nn.1
  levnadsföring_1_N = mkN "levnadsföring" ; -- levnadsföring..nn.1
  levnadsglad_1_A = mkA "levnadsglad" "levnadsglatt" ; -- levnadsglad..av.1
  levnadsglädje_1_N = mkN "levnadsglädje" utrum  ; -- levnadsglädje..nn.1
  levnadshändelse_1_N = mkN "levnadshändelse" "levnadshändelser" ; -- levnadshändelse..nn.1
  levnadskonst_1_N = mkN "levnadskonst" ; -- levnadskonst..nn.1
  levnadskonstnär_1_N = mkN "levnadskonstnär" "levnadskonstnärer" ; -- levnadskonstnär..nn.1
  levnadskostnad_1_N = mkN "levnadskostnad" "levnadskostnader" ; -- levnadskostnad..nn.1
  levnadslopp_1_N = mkN "levnadslopp" neutrum  ; -- levnadslopp..nn.1
  levnadslust_1_N = mkN "levnadslust" ; -- levnadslust..nn.1
  levnadsmönster_1_N = mkN "levnadsmönster" neutrum  ; -- levnadsmönster..nn.1
  levnadsnivå_1_N = mkN "levnadsnivå" "levnadsnivåer" ; -- levnadsnivå..nn.1
  levnadsomständighet_1_N = mkN "levnadsomständighet" "levnadsomständigheter" ; -- levnadsomständighet..nn.1
  levnadsregel_1_N = mkN "levnadsregel" "levnadsregeln" "levnadsregler" "levnadsreglerna" ; -- levnadsregel..nn.1
  levnadssaga_1_N = mkN "levnadssaga" ; -- levnadssaga..nn.1
  levnadsstandard_1_N = mkN "levnadsstandard" ; -- levnadsstandard..nn.1
  levnadssätt_1_N = mkN "levnadssätt" neutrum  ; -- levnadssätt..nn.1
  levnadstecknare_1_N = mkN "levnadstecknare" utrum  ; -- levnadstecknare..nn.1
  levnadsteckning_1_N = mkN "levnadsteckning" ; -- levnadsteckning..nn.1
  levnadstrött_1_A = mkA "levnadstrött" ; -- levnadstrött..av.1
  levnadströtthet_1_N = mkN "levnadströtthet" ; -- levnadströtthet..nn.1
  levnadsvana_1_N = mkN "levnadsvana" ; -- levnadsvana..nn.1
  levnadsvett_1_N = mkN "levnadsvett" neutrum  ; -- levnadsvett..nn.1
  levnadsvillkor_1_N = mkN "levnadsvillkor" neutrum  ; -- levnadsvillkor..nn.1
  levnadsvisdom_1_N = mkN "levnadsvisdom" ; -- levnadsvisdom..nn.1
  levnadsålder_1_N = mkN "levnadsålder" ; -- levnadsålder..nn.1
  levnadsår_1_N = mkN "levnadsår" neutrum  ; -- levnadsår..nn.1
  levnadsöde_1_N = mkN "levnadsöde" ; -- levnadsöde..nn.1
  levrad_1_A = mkA "levrad" ; -- levrad..av.1
  lex_1_N = mkN "lex" ; -- lex..nn.1
  lexem_1_N = mkN "lexem" neutrum  ; -- lexem..nn.1
  lexfras_1_N = mkN "lexfras" "lexfraser" ; -- lexfras..nn.1
  lexikal_1_A = mkA "lexikal" ; -- lexikal..av.1
  lexikalisk_1_A = mkA "lexikalisk" ; -- lexikalisk..av.1
  lexikograf_1_N = mkN "lexikograf" "lexikografer" ; -- lexikograf..nn.1
  lexikografi_1_N = mkN "lexikografi" ; -- lexikografi..nn.1
  lexikografisk_1_A = mkA "lexikografisk" ; -- lexikografisk..av.1
  lexikolog_1_N = mkN "lexikolog" "lexikologer" ; -- lexikolog..nn.1
  lexikologi_1_N = mkN "lexikologi" ; -- lexikologi..nn.1
  lexikologisk_1_A = mkA "lexikologisk" ; -- lexikologisk..av.1
  lexikon_1_N = mkN "lexikon" neutrum  ; -- lexikon..nn.1
  lexikonprojekt_1_N = mkN "lexikonprojekt" neutrum  ; -- lexikonprojekt..nn.1
  lexikonresurs_1_N = mkN "lexikonresurs" "lexikonresurser" ; -- lexikonresurs..nn.1
  lexikostatistik_1_N = mkN "lexikostatistik" ; -- lexikostatistik..nn.1
  lexikostatistisk_1_A = mkA "lexikostatistisk" ; -- lexikostatistisk..av.1
  lian_1_N = mkN "lian" "lianer" ; -- lian..nn.1
  lias_1_N = mkN "lias" ; -- lias..nn.1
  libanes_1_N = mkN "libanes" "libaneser" ; -- libanes..nn.1
  libanesisk_1_A = mkA "libanesisk" ; -- libanesisk..av.1
  libanesiska_1_N = mkN "libanesiska" ; -- libanesiska..nn.1
  libation_1_N = mkN "libation" ; -- libation..nn.1
  libbsticka_1_N = mkN "libbsticka" ; -- libbsticka..nn.1
  libell_1_N = mkN "libell" "libeller" ; -- libell..nn.1
  liberal_1_A = mkA "liberal" ; -- liberal..av.1
  liberal_1_N = mkN "liberal" "liberaler" ; -- liberal..nn.1
  liberaldemokratisk_1_A = mkA "liberaldemokratisk" ; -- liberaldemokratisk..av.1
  liberalisera_1_V = mkV "liberaliserar" ; -- liberalisera..vb.1
  liberaliserande_1_N = mkN "liberaliserande" ; -- liberaliserande..nn.1
  liberaliserbar_1_A = mkA "liberaliserbar" ; -- liberaliserbar..av.1
  liberaliserbarhet_1_N = mkN "liberaliserbarhet" ; -- liberaliserbarhet..nn.1
  liberalisering_1_N = mkN "liberalisering" ; -- liberalisering..nn.1
  liberalism_1_N = mkN "liberalism" "liberalismer" ; -- liberalism..nn.1
  liberalistisk_1_A = mkA "liberalistisk" ; -- liberalistisk..av.1
  liberalitet_1_N = mkN "liberalitet" ; -- liberalitet..nn.1
  liberian_1_N = mkN "liberian" "liberianer" ; -- liberian..nn.1
  liberiansk_1_A = mkA "liberiansk" ; -- liberiansk..av.1
  liberianska_1_N = mkN "liberianska" ; -- liberianska..nn.1
  liberier_1_N = mkN "liberier" "liberiern" "liberier" "liberierna" ; -- liberier..nn.1
  liberisk_1_A = mkA "liberisk" ; -- liberisk..av.1
  libero_1_N = mkN "libero" "liberon" "liberoer" "liberoerna" ; -- libero..nn.1
  libertin_1_N = mkN "libertin" "libertiner" ; -- libertin..nn.1
  libertinism_1_N = mkN "libertinism" "libertinismer" ; -- libertinism..nn.1
  libido_1_N = mkN "libido" "libidot" "libidon" "libidona" ; -- libido..nn.1
  libration_1_N = mkN "libration" ; -- libration..nn.1
  librettist_1_N = mkN "librettist" "librettister" ; -- librettist..nn.1
  libretto_1_N = mkN "libretto" "librettot" "libretton" "librettona" ; -- libretto..nn.1
  libsticka_1_N = mkN "libsticka" ; -- libsticka..nn.1
  libyer_1_N = mkN "libyer" "libyern" "libyer" "libyerna" ; -- libyer..nn.1
  libysk_1_A = mkA "libysk" ; -- libysk..av.1
  libyska_1_N = mkN "libyska" ; -- libyska..nn.1
  licens_1_N = mkN "licens" "licenser" ; -- licens..nn.1
  licensbelägga_1_V = mkV "licensbelägga" "licensbela" "licensbelagt" ; -- licensbelägga..vb.1
  licensbeläggande_1_N = mkN "licensbeläggande" ; -- licensbeläggande..nn.1
  licensera_1_V = mkV "licenserar" ; -- licensera..vb.1
  licenserande_1_N = mkN "licenserande" ; -- licenserande..nn.1
  licenserbar_1_A = mkA "licenserbar" ; -- licenserbar..av.1
  licenserbarhet_1_N = mkN "licenserbarhet" ; -- licenserbarhet..nn.1
  licensering_1_N = mkN "licensering" ; -- licensering..nn.1
  licensfri_1_A = mkA "licensfri" "licensfritt" ; -- licensfri..av.1
  licensgivare_1_N = mkN "licensgivare" utrum  ; -- licensgivare..nn.1
  licensiera_1_V = mkV "licensierar" ; -- licensiera..vb.1
  licensierande_1_N = mkN "licensierande" ; -- licensierande..nn.1
  licensierbar_1_A = mkA "licensierbar" ; -- licensierbar..av.1
  licensierbarhet_1_N = mkN "licensierbarhet" ; -- licensierbarhet..nn.1
  licensiering_1_N = mkN "licensiering" ; -- licensiering..nn.1
  licensinnehavare_1_N = mkN "licensinnehavare" utrum  ; -- licensinnehavare..nn.1
  licensjakt_1_N = mkN "licensjakt" ; -- licensjakt..nn.1
  licenstagare_1_N = mkN "licenstagare" utrum  ; -- licenstagare..nn.1
  licentiat_1_N = mkN "licentiat" "licentiater" ; -- licentiat..nn.1
  licentiatexamen_1_N = mkN "licentiatexamen" "licentiatexamen" "licentiatexamina" "licentiatexamina" ; -- licentiatexamen..nn.1
  licentiera_1_V = mkV "licentierar" ; -- licentiera..vb.1
  licentierande_1_N = mkN "licentierande" ; -- licentierande..nn.1
  licentierbar_1_A = mkA "licentierbar" ; -- licentierbar..av.1
  licentierbarhet_1_N = mkN "licentierbarhet" ; -- licentierbarhet..nn.1
  licentiering_1_N = mkN "licentiering" ; -- licentiering..nn.1
  lid_1_N = mkN "lid" "lider" ; -- lid..nn.1
  lida_1_V = mkV "lida" "led" "lidit" ; -- lida..vb.1
  lidande_1_A = mkA "lidande" ; -- lidande..av.1
  lidande_1_N = mkN "lidande" ; -- lidande..nn.1
  lidandeshistoria_1_N = mkN "lidandeshistoria" "lidandeshistorian" "lidandeshistorier" "lidandeshistorierna" ; -- lidandeshistoria..nn.1
  lidelse_1_N = mkN "lidelse" "lidelser" ; -- lidelse..nn.1
  lidelsefri_1_A = mkA "lidelsefri" "lidelsefritt" ; -- lidelsefri..av.1
  lidelsefrihet_1_N = mkN "lidelsefrihet" ; -- lidelsefrihet..nn.1
  lidelsefull_1_A = mkA "lidelsefull" ; -- lidelsefull..av.1
  lidelsefullhet_1_N = mkN "lidelsefullhet" "lidelsefullheter" ; -- lidelsefullhet..nn.1
  lider_1_N = mkN "lider" neutrum  ; -- lider..nn.1
  liderlig_1_A = mkA "liderlig" ; -- liderlig..av.1
  liderlighet_1_N = mkN "liderlighet" "liderligheter" ; -- liderlighet..nn.1
  lie_1_N = mkN "lie" utrum  ; -- lie..nn.1
  liechtensteinare_1_N = mkN "liechtensteinare" utrum  ; -- liechtensteinare..nn.1
  liechtensteinsk_1_A = mkA "liechtensteinsk" ; -- liechtensteinsk..av.1
  liechtensteinska_1_N = mkN "liechtensteinska" ; -- liechtensteinska..nn.1
  lieknagg_1_N = mkN "lieknagg" ; -- lieknagg..nn.1
  liera_1_V = mkV "lierar" ; -- liera..vb.1
  lierande_1_N = mkN "lierande" ; -- lierande..nn.1
  lierbar_1_A = mkA "lierbar" ; -- lierbar..av.1
  lierbarhet_1_N = mkN "lierbarhet" ; -- lierbarhet..nn.1
  liering_1_N = mkN "liering" ; -- liering..nn.1
  lieskaft_1_N = mkN "lieskaft" neutrum  ; -- lieskaft..nn.1
  lift_1_N = mkN "lift" ; -- lift..nn.1
  lifta_1_V = mkV "liftar" ; -- lifta..vb.1
  liftande_1_N = mkN "liftande" ; -- liftande..nn.1
  liftare_1_N = mkN "liftare" utrum  ; -- liftare..nn.1
  liftkort_1_N = mkN "liftkort" neutrum  ; -- liftkort..nn.1
  liftkö_1_N = mkN "liftkö" "liftkön" "liftköer" "liftköerna" ; -- liftkö..nn.1
  liga_1_N = mkN "liga" ; -- liga..nn.1
  ligamatch_1_N = mkN "ligamatch" "ligamatcher" ; -- ligamatch..nn.1
  ligament_1_N = mkN "ligament" neutrum  ; -- ligament..nn.1
  ligatur_1_N = mkN "ligatur" "ligaturer" ; -- ligatur..nn.1
  ligg_1_N = mkN "ligg" neutrum  ; -- ligg..nn.1
  ligga_1_V = mkV "ligga" "låg" "legat" ; -- ligga..vb.1
  liggande_1_N = mkN "liggande" ; -- liggande..nn.1
  liggare_1_N = mkN "liggare" utrum  ; -- liggare..nn.1
  liggdags_1_N = mkN "liggdags" ; -- liggdags..nn.1
  liggegods_1_N = mkN "liggegods" neutrum  ; -- liggegods..nn.1
  liggetid_1_N = mkN "liggetid" "liggetider" ; -- liggetid..nn.1
  ligghöna_1_N = mkN "ligghöna" ; -- ligghöna..nn.1
  liggning_1_N = mkN "liggning" ; -- liggning..nn.1
  liggplats_1_N = mkN "liggplats" "liggplatser" ; -- liggplats..nn.1
  liggriktig_1_A = mkA "liggriktig" ; -- liggriktig..av.1
  liggriktighet_1_N = mkN "liggriktighet" ; -- liggriktighet..nn.1
  liggsjuk_1_A = mkA "liggsjuk" ; -- liggsjuk..av.1
  liggsoffa_1_N = mkN "liggsoffa" ; -- liggsoffa..nn.1
  liggsäd_1_N = mkN "liggsäd" ; -- liggsäd..nn.1
  liggsår_1_N = mkN "liggsår" neutrum  ; -- liggsår..nn.1
  liggunderlag_1_N = mkN "liggunderlag" neutrum  ; -- liggunderlag..nn.1
  liggvagn_1_N = mkN "liggvagn" ; -- liggvagn..nn.1
  liggvirke_1_N = mkN "liggvirke" ; -- liggvirke..nn.1
  light_1_A = mkA "light" ; -- light..av.1
  ligist_1_N = mkN "ligist" "ligister" ; -- ligist..nn.1
  ligistisk_1_A = mkA "ligistisk" ; -- ligistisk..av.1
  lignin_1_N = mkN "lignin" "ligniner" ; -- lignin..nn.1
  ligur_1_N = mkN "ligur" "ligurer" ; -- ligur..nn.1
  ligurisk_1_A = mkA "ligurisk" ; -- ligurisk..av.1
  liguster_1_N = mkN "liguster" ; -- liguster..nn.1
  ligusterfjäril_1_N = mkN "ligusterfjäril" ; -- ligusterfjäril..nn.1
  ligustersvärmare_1_N = mkN "ligustersvärmare" utrum  ; -- ligustersvärmare..nn.1
  lik_1_A = mkA "lik" ; -- lik..av.1
  lik_1_N = mkN "lik" neutrum  ; -- lik..nn.1
  lika_1_A = mkA "lika" ; -- lika..av.1
  lika_1_V = mkV "likar" ; -- lika..vb.1
  likabehandling_1_N = mkN "likabehandling" ; -- likabehandling..nn.1
  likaberättigad_1_A = mkA "likaberättigad" ; -- likaberättigad..av.1
  likaberättigande_1_N = mkN "likaberättigande" ; -- likaberättigande..nn.1
  likadan_1_A = mkA "likadan" ; -- likadan..av.1
  likaledes_1_Adv = mkAdv "likaledes" ; -- likaledes..ab.1
  likalydande_1_A = mkA "likalydande" ; -- likalydande..av.1
  likalön_1_N = mkN "likalön" "likalöner" ; -- likalön..nn.1
  likande_1_N = mkN "likande" ; -- likande..nn.1
  likare_1_N = mkN "likare" utrum  ; -- likare..nn.1
  likartad_1_A = mkA "likartad" ; -- likartad..av.1
  likasinnad_1_A = mkA "likasinnad" ; -- likasinnad..av.1
  likasom_1_Adv = mkAdv "likasom" ; -- likasom..ab.1
  likaså_1_Adv = mkAdv "likaså" ; -- likaså..ab.1
  likasåväl_1_Adv = mkAdv "likasåväl" ; -- likasåväl..ab.1
  likaväl_1_Adv = mkAdv "likaväl" ; -- likaväl..ab.1
  likbent_1_A = mkA "likbent" "likbent" ; -- likbent..av.1
  likbenthet_1_N = mkN "likbenthet" ; -- likbenthet..nn.1
  likbesiktning_1_N = mkN "likbesiktning" ; -- likbesiktning..nn.1
  likbetydande_1_A = mkA "likbetydande" ; -- likbetydande..av.1
  likbjudarmin_1_N = mkN "likbjudarmin" "likbjudarminer" ; -- likbjudarmin..nn.1
  likblek_1_A = mkA "likblek" ; -- likblek..av.1
  likblekhet_1_N = mkN "likblekhet" ; -- likblekhet..nn.1
  likblånad_1_N = mkN "likblånad" "likblånader" ; -- likblånad..nn.1
  likbränning_1_N = mkN "likbränning" ; -- likbränning..nn.1
  likbål_1_N = mkN "likbål" neutrum  ; -- likbål..nn.1
  like_1_N = mkN "like" utrum  ; -- like..nn.1
  likfläck_1_N = mkN "likfläck" ; -- likfläck..nn.1
  likformig_1_A = mkA "likformig" ; -- likformig..av.1
  likformighet_1_N = mkN "likformighet" "likformigheter" ; -- likformighet..nn.1
  likfynd_1_N = mkN "likfynd" neutrum  ; -- likfynd..nn.1
  likfärd_1_N = mkN "likfärd" "likfärder" ; -- likfärd..nn.1
  likförbannat_1_Adv = mkAdv "likförbannat" ; -- likförbannat..ab.1
  likförgiftning_1_N = mkN "likförgiftning" ; -- likförgiftning..nn.1
  likgift_1_N = mkN "likgift" "likgiftet" "likgifter" "likgifterna" ; -- likgift..nn.1
  likgiltig_1_A = mkA "likgiltig" ; -- likgiltig..av.1
  likgiltighet_1_N = mkN "likgiltighet" "likgiltigheter" ; -- likgiltighet..nn.1
  likhet_1_N = mkN "likhet" "likheter" ; -- likhet..nn.1
  likhetstecken_1_N = mkN "likhetstecken" "likhetstecknet" "likhetstecken" "likhetstecknen" ; -- likhetstecken..nn.1
  likhög_1_N = mkN "likhög" ; -- likhög..nn.1
  likkista_1_N = mkN "likkista" ; -- likkista..nn.1
  likljudande_1_A = mkA "likljudande" ; -- likljudande..av.1
  liklukt_1_N = mkN "liklukt" ; -- liklukt..nn.1
  likmask_1_N = mkN "likmask" ; -- likmask..nn.1
  likna_1_V = mkV "liknar" ; -- likna..vb.1
  liknande_1_A = mkA "liknande" ; -- liknande..av.1
  liknande_1_N = mkN "liknande" ; -- liknande..nn.1
  liknelse_1_N = mkN "liknelse" "liknelser" ; -- liknelse..nn.1
  liknämnig_1_A = mkA "liknämnig" ; -- liknämnig..av.1
  liknöjd_1_A = mkA "liknöjd" "liknöjt" ; -- liknöjd..av.1
  liknöjdhet_1_N = mkN "liknöjdhet" ; -- liknöjdhet..nn.1
  likplundrare_1_N = mkN "likplundrare" utrum  ; -- likplundrare..nn.1
  likplundring_1_N = mkN "likplundring" ; -- likplundring..nn.1
  likrikta_1_V = mkV "likriktar" ; -- likrikta..vb.1
  likriktad_1_A = mkA "likriktad" ; -- likriktad..av.1
  likriktande_1_N = mkN "likriktande" ; -- likriktande..nn.1
  likriktare_1_N = mkN "likriktare" utrum  ; -- likriktare..nn.1
  likriktning_1_N = mkN "likriktning" ; -- likriktning..nn.1
  liksidig_1_A = mkA "liksidig" ; -- liksidig..av.1
  liksidighet_1_N = mkN "liksidighet" ; -- liksidighet..nn.1
  liksiding_1_N = mkN "liksiding" ; -- liksiding..nn.1
  likskändare_1_N = mkN "likskändare" utrum  ; -- likskändare..nn.1
  likskändning_1_N = mkN "likskändning" ; -- likskändning..nn.1
  liksom_1_Adv = mkAdv "liksom" ; -- liksom..ab.1
  likspänning_1_N = mkN "likspänning" ; -- likspänning..nn.1
  likstelhet_1_N = mkN "likstelhet" "likstelheter" ; -- likstelhet..nn.1
  likström_1_N = mkN "likström" "likströmmen" "likströmmar" "likströmmarna" ; -- likström..nn.1
  likstyckning_1_N = mkN "likstyckning" ; -- likstyckning..nn.1
  likställa_1_V = mkV "likställer" ; -- likställa..vb.1
  likställande_1_N = mkN "likställande" ; -- likställande..nn.1
  likställdhet_1_N = mkN "likställdhet" ; -- likställdhet..nn.1
  likställig_1_A = mkA "likställig" ; -- likställig..av.1
  likställighet_1_N = mkN "likställighet" "likställigheter" ; -- likställighet..nn.1
  likstämmig_1_A = mkA "likstämmig" ; -- likstämmig..av.1
  likstämmighet_1_N = mkN "likstämmighet" "likstämmigheter" ; -- likstämmighet..nn.1
  liksvamp_1_N = mkN "liksvamp" ; -- liksvamp..nn.1
  liksvepning_1_N = mkN "liksvepning" ; -- liksvepning..nn.1
  liksvävande_1_A = mkA "liksvävande" ; -- liksvävande..av.1
  liksäck_1_N = mkN "liksäck" ; -- liksäck..nn.1
  liktor_1_N = mkN "liktor" "liktorer" ; -- liktor..nn.1
  liktorn_1_N = mkN "liktorn" ; -- liktorn..nn.1
  liktydig_1_A = mkA "liktydig" ; -- liktydig..av.1
  liktydighet_1_N = mkN "liktydighet" ; -- liktydighet..nn.1
  liktyding_1_N = mkN "liktyding" ; -- liktyding..nn.1
  liktänkande_1_A = mkA "liktänkande" ; -- liktänkande..av.1
  likvagn_1_N = mkN "likvagn" ; -- likvagn..nn.1
  likvaka_1_N = mkN "likvaka" ; -- likvaka..nn.1
  likvax_1_N = mkN "likvax" "likvaxet" "likvaxer" "likvaxerna" ; -- likvax..nn.1
  likvid_1_A = mkA "likvid" ; -- likvid..av.1
  likvid_1_N = mkN "likvid" "likvider" ; -- likvid..nn.1
  likvida_1_N = mkN "likvida" ; -- likvida..nn.1
  likvidation_1_N = mkN "likvidation" ; -- likvidation..nn.1
  likvidator_1_N = mkN "likvidator" "likvidatorer" ; -- likvidator..nn.1
  likvidera_1_V = mkV "likviderar" ; -- likvidera..vb.1
  likviderande_1_N = mkN "likviderande" ; -- likviderande..nn.1
  likviderbar_1_A = mkA "likviderbar" ; -- likviderbar..av.1
  likviderbarhet_1_N = mkN "likviderbarhet" ; -- likviderbarhet..nn.1
  likvidering_1_N = mkN "likvidering" ; -- likvidering..nn.1
  likviditet_1_N = mkN "likviditet" "likviditeter" ; -- likviditet..nn.1
  likviditetsbehov_1_N = mkN "likviditetsbehov" neutrum  ; -- likviditetsbehov..nn.1
  likväl_1_Adv = mkAdv "likväl" ; -- likväl..ab.1
  likvärd_1_A = mkA "likvärd" "likvärt" ; -- likvärd..av.1
  likvärdhet_1_N = mkN "likvärdhet" ; -- likvärdhet..nn.1
  likvärdig_1_A = mkA "likvärdig" ; -- likvärdig..av.1
  likvärdighet_1_N = mkN "likvärdighet" ; -- likvärdighet..nn.1
  liköppning_1_N = mkN "liköppning" ; -- liköppning..nn.1
  likör_1_N = mkN "likör" "likörer" ; -- likör..nn.1
  likörglas_1_N = mkN "likörglas" neutrum  ; -- likörglas..nn.1
  liköverströdd_1_A = mkA "liköverströdd" ; -- liköverströdd..av.1
  lila_1_A = mkA "lila" ; -- lila..av.1
  lila_1_N = mkN "lila" ; -- lila..nn.1
  lilafärgad_1_A = mkA "lilafärgad" ; -- lilafärgad..av.1
  lilja_1_N = mkN "lilja" ; -- lilja..nn.1
  liljekonvalj_1_N = mkN "liljekonvalj" "liljekonvaljer" ; -- liljekonvalj..nn.1
  liljekonvalje_1_N = mkN "liljekonvalje" "liljekonvaljer" ; -- liljekonvalje..nn.1
  liljekulle_1_N = mkN "liljekulle" utrum  ; -- liljekulle..nn.1
  liljemönster_1_N = mkN "liljemönster" neutrum  ; -- liljemönster..nn.1
  liljevit_1_A = mkA "liljevit" ; -- liljevit..av.1
  liljeväxt_1_N = mkN "liljeväxt" "liljeväxter" ; -- liljeväxt..nn.1
  lillasyrra_1_N = mkN "lillasyrra" ; -- lillasyrra..nn.1
  lillasyskon_1_N = mkN "lillasyskon" neutrum  ; -- lillasyskon..nn.1
  lillasyster_1_N = mkN "lillasyster" ; -- lillasyster..nn.1
  lillaxel_1_N = mkN "lillaxel" ; -- lillaxel..nn.1
  lillbrorsa_1_N = mkN "lillbrorsa" ; -- lillbrorsa..nn.1
  lillebror_1_N = mkN "lillebror" ; -- lillebror..nn.1
  lillebrorsa_1_N = mkN "lillebrorsa" ; -- lillebrorsa..nn.1
  lillefar_1_N = mkN "lillefar" ; -- lillefar..nn.1
  lilleputt_1_N = mkN "lilleputt" ; -- lilleputt..nn.1
  lillfinger_1_N = mkN "lillfinger" ; -- lillfinger..nn.1
  lillfingertopp_1_N = mkN "lillfingertopp" ; -- lillfingertopp..nn.1
  lillflicka_1_N = mkN "lillflicka" ; -- lillflicka..nn.1
  lillhjärna_1_N = mkN "lillhjärna" ; -- lillhjärna..nn.1
  lillpojke_1_N = mkN "lillpojke" utrum  ; -- lillpojke..nn.1
  lillprins_1_N = mkN "lillprins" ; -- lillprins..nn.1
  lillprinsessa_1_N = mkN "lillprinsessa" ; -- lillprinsessa..nn.1
  lillsemester_1_N = mkN "lillsemester" ; -- lillsemester..nn.1
  lillsessa_1_N = mkN "lillsessa" ; -- lillsessa..nn.1
  lillslam_1_N = mkN "lillslam" "lillslammen" "lillslammar" "lillslammarna" ; -- lillslam..nn.1
  lillstuga_1_N = mkN "lillstuga" ; -- lillstuga..nn.1
  lillsyrra_1_N = mkN "lillsyrra" ; -- lillsyrra..nn.1
  lillsyskon_1_N = mkN "lillsyskon" neutrum  ; -- lillsyskon..nn.1
  lilltå_1_N = mkN "lilltå" "lilltån" "lilltår" "lilltårna" ; -- lilltå..nn.1
  lillvärdinna_1_N = mkN "lillvärdinna" ; -- lillvärdinna..nn.1
  lillända_1_N = mkN "lillända" ; -- lillända..nn.1
  lillände_1_N = mkN "lillände" utrum  ; -- lillände..nn.1
  lim_1_N = mkN "lim" "limmet" "limmer" "limmerna" ; -- lim..nn.1
  limaböna_1_N = mkN "limaböna" ; -- limaböna..nn.1
  limborste_1_N = mkN "limborste" utrum  ; -- limborste..nn.1
  lime_1_N = mkN "lime" "limer" ; -- lime..nn.1
  limefrukt_1_N = mkN "limefrukt" "limefrukter" ; -- limefrukt..nn.1
  limerick_1_N = mkN "limerick" ; -- limerick..nn.1
  limes_1_N = mkN "limes" ; -- limes..nn.1
  limfärg_1_N = mkN "limfärg" "limfärger" ; -- limfärg..nn.1
  limgördel_1_N = mkN "limgördel" ; -- limgördel..nn.1
  limit_1_N = mkN "limit" "limiter" ; -- limit..nn.1
  limitation_1_N = mkN "limitation" ; -- limitation..nn.1
  limitativ_1_A = mkA "limitativ" ; -- limitativ..av.1
  limiterad_1_A = mkA "limiterad" ; -- limiterad..av.1
  limklämma_1_N = mkN "limklämma" ; -- limklämma..nn.1
  limkokeri_1_N = mkN "limkokeri" "limkokeriet" "limkokerier" "limkokerierna" ; -- limkokeri..nn.1
  limma_1_V = mkV "limmar" ; -- limma..vb.1
  limmande_1_N = mkN "limmande" ; -- limmande..nn.1
  limning_1_N = mkN "limning" ; -- limning..nn.1
  limningsmaskin_1_N = mkN "limningsmaskin" "limningsmaskiner" ; -- limningsmaskin..nn.1
  limnisk_1_A = mkA "limnisk" ; -- limnisk..av.1
  limnograf_1_N = mkN "limnograf" "limnografer" ; -- limnograf..nn.1
  limnologi_1_N = mkN "limnologi" ; -- limnologi..nn.1
  limnologisk_1_A = mkA "limnologisk" ; -- limnologisk..av.1
  limonit_1_N = mkN "limonit" ; -- limonit..nn.1
  limousin_1_N = mkN "limousin" "limousiner" ; -- limousin..nn.1
  limousine_1_N = mkN "limousine" "limousiner" ; -- limousine..nn.1
  limpa_1_N = mkN "limpa" ; -- limpa..nn.1
  limpinne_1_N = mkN "limpinne" utrum  ; -- limpinne..nn.1
  limpåstrykning_1_N = mkN "limpåstrykning" ; -- limpåstrykning..nn.1
  limring_1_N = mkN "limring" ; -- limring..nn.1
  limsticka_1_N = mkN "limsticka" ; -- limsticka..nn.1
  limtillverkning_1_N = mkN "limtillverkning" ; -- limtillverkning..nn.1
  limämne_1_N = mkN "limämne" ; -- limämne..nn.1
  lin_1_N = mkN "lin" neutrum  ; -- lin..nn.1
  lina_1_N = mkN "lina" ; -- lina..nn.1
  linbana_1_N = mkN "linbana" ; -- linbana..nn.1
  linbråkning_1_N = mkN "linbråkning" ; -- linbråkning..nn.1
  lind_1_N = mkN "lind" ; -- lind..nn.1
  linda_1_N = mkN "linda" ; -- linda..nn.1
  linda_1_V = mkV "lindar" ; -- linda..vb.1
  lindande_1_N = mkN "lindande" ; -- lindande..nn.1
  lindans_1_N = mkN "lindans" ; -- lindans..nn.1
  lindansare_1_N = mkN "lindansare" utrum  ; -- lindansare..nn.1
  lindare_1_N = mkN "lindare" utrum  ; -- lindare..nn.1
  lindblomma_1_N = mkN "lindblomma" ; -- lindblomma..nn.1
  lindblomste_1_N = mkN "lindblomste" ; -- lindblomste..nn.1
  linddrag_1_N = mkN "linddrag" neutrum  ; -- linddrag..nn.1
  lindebarn_1_N = mkN "lindebarn" neutrum  ; -- lindebarn..nn.1
  lindlöv_1_N = mkN "lindlöv" neutrum  ; -- lindlöv..nn.1
  lindning_1_N = mkN "lindning" ; -- lindning..nn.1
  lindorm_1_N = mkN "lindorm" ; -- lindorm..nn.1
  lindra_1_V = mkV "lindrar" ; -- lindra..vb.1
  lindrande_1_N = mkN "lindrande" ; -- lindrande..nn.1
  lindrig_1_A = mkA "lindrig" ; -- lindrig..av.1
  lindrighet_1_N = mkN "lindrighet" ; -- lindrighet..nn.1
  lindring_1_N = mkN "lindring" ; -- lindring..nn.1
  linearritning_1_N = mkN "linearritning" ; -- linearritning..nn.1
  lineär_1_A = mkA "lineär" ; -- lineär..av.1
  linfrö_1_N = mkN "linfrö" "linfröet" "linfrön" "linfröna" ; -- linfrö..nn.1
  linfärgad_1_A = mkA "linfärgad" ; -- linfärgad..av.1
  lingarn_1_N = mkN "lingarn" neutrum  ; -- lingarn..nn.1
  lingeri_1_N = mkN "lingeri" "lingeriet" "lingerier" "lingerierna" ; -- lingeri..nn.1
  lingon_1_N = mkN "lingon" neutrum  ; -- lingon..nn.1
  lingonbuske_1_N = mkN "lingonbuske" utrum  ; -- lingonbuske..nn.1
  lingondricka_1_N = mkN "lingondricka" ; -- lingondricka..nn.1
  lingonmos_1_N = mkN "lingonmos" ; -- lingonmos..nn.1
  lingonplockare_1_N = mkN "lingonplockare" utrum  ; -- lingonplockare..nn.1
  lingonpäron_1_N = mkN "lingonpäron" neutrum  ; -- lingonpäron..nn.1
  lingonris_1_N = mkN "lingonris" neutrum  ; -- lingonris..nn.1
  lingonristuva_1_N = mkN "lingonristuva" ; -- lingonristuva..nn.1
  lingonruta_1_N = mkN "lingonruta" ; -- lingonruta..nn.1
  lingonröd_1_A = mkA "lingonröd" "lingonrött" ; -- lingonröd..av.1
  lingonsaft_1_N = mkN "lingonsaft" "lingonsafter" ; -- lingonsaft..nn.1
  lingonsylt_1_N = mkN "lingonsylt" "lingonsylter" ; -- lingonsylt..nn.1
  lingrävare_1_N = mkN "lingrävare" utrum  ; -- lingrävare..nn.1
  lingul_1_A = mkA "lingul" ; -- lingul..av.1
  lingvist_1_N = mkN "lingvist" "lingvister" ; -- lingvist..nn.1
  lingvistik_1_N = mkN "lingvistik" ; -- lingvistik..nn.1
  lingvistisk_1_A = mkA "lingvistisk" ; -- lingvistisk..av.1
  linhårig_1_A = mkA "linhårig" ; -- linhårig..av.1
  linhårighet_1_N = mkN "linhårighet" ; -- linhårighet..nn.1
  liniment_1_N = mkN "liniment" neutrum  ; -- liniment..nn.1
  linjal_1_N = mkN "linjal" "linjaler" ; -- linjal..nn.1
  linje_1_N = mkN "linje" "linjer" ; -- linje..nn.1
  linjearbete_1_N = mkN "linjearbete" ; -- linjearbete..nn.1
  linjeblockering_1_N = mkN "linjeblockering" ; -- linjeblockering..nn.1
  linjedomare_1_N = mkN "linjedomare" utrum  ; -- linjedomare..nn.1
  linjefart_1_N = mkN "linjefart" ; -- linjefart..nn.1
  linjeflyg_1_N = mkN "linjeflyg" neutrum  ; -- linjeflyg..nn.1
  linjeföring_1_N = mkN "linjeföring" ; -- linjeföring..nn.1
  linjelopp_1_N = mkN "linjelopp" neutrum  ; -- linjelopp..nn.1
  linjeman_1_N = mkN "linjeman" "linjemannen" "linjemän" "linjemännen" ; -- linjeman..nn.1
  linjenämnd_1_N = mkN "linjenämnd" "linjenämnder" ; -- linjenämnd..nn.1
  linjeperspektiv_1_N = mkN "linjeperspektiv" neutrum  ; -- linjeperspektiv..nn.1
  linjera_1_V = mkV "linjerar" ; -- linjera..vb.1
  linjerande_1_N = mkN "linjerande" ; -- linjerande..nn.1
  linjerare_1_N = mkN "linjerare" utrum  ; -- linjerare..nn.1
  linjerbar_1_A = mkA "linjerbar" ; -- linjerbar..av.1
  linjerbarhet_1_N = mkN "linjerbarhet" ; -- linjerbarhet..nn.1
  linjeren_1_A = mkA "linjeren" "linjerent" ; -- linjeren..av.1
  linjerenhet_1_N = mkN "linjerenhet" ; -- linjerenhet..nn.1
  linjering_1_N = mkN "linjering" ; -- linjering..nn.1
  linjeskepp_1_N = mkN "linjeskepp" neutrum  ; -- linjeskepp..nn.1
  linjespektrum_1_N = mkN "linjespektrum" neutrum  ; -- linjespektrum..nn.1
  linjespel_1_N = mkN "linjespel" "linjespelet" "linjespel" "linjespelen" ; -- linjespel..nn.1
  linjetrafik_1_N = mkN "linjetrafik" ; -- linjetrafik..nn.1
  linjeväljare_1_N = mkN "linjeväljare" utrum  ; -- linjeväljare..nn.1
  linjär_1_A = mkA "linjär" ; -- linjär..av.1
  linjär_1_N = mkN "linjär" "linjärer" ; -- linjär..nn.1
  linka_1_V = mkV "linkar" ; -- linka..vb.1
  linkande_1_N = mkN "linkande" ; -- linkande..nn.1
  linköpingsbo_1_N = mkN "linköpingsbo" "linköpingsbor" ; -- linköpingsbo..nn.1
  linlugg_1_N = mkN "linlugg" ; -- linlugg..nn.1
  linne_1_N = mkN "linne" ; -- linne..nn.1
  linne_2_N = mkN "linne" ; -- linne..nn.2
  linnea_1_N = mkN "linnea" ; -- linnea..nn.1
  linnedamast_1_N = mkN "linnedamast" "linnedamaster" ; -- linnedamast..nn.1
  linnedräkt_1_N = mkN "linnedräkt" "linnedräkter" ; -- linnedräkt..nn.1
  linneduk_1_N = mkN "linneduk" ; -- linneduk..nn.1
  linnefiber_1_N = mkN "linnefiber" "linnefibern" "linnefibrer" "linnefibrerna" ; -- linnefiber..nn.1
  linneklänning_1_N = mkN "linneklänning" ; -- linneklänning..nn.1
  linnerock_1_N = mkN "linnerock" ; -- linnerock..nn.1
  linneskåp_1_N = mkN "linneskåp" neutrum  ; -- linneskåp..nn.1
  linning_1_N = mkN "linning" ; -- linning..nn.1
  linolensyra_1_N = mkN "linolensyra" ; -- linolensyra..nn.1
  linoleum_1_N = mkN "linoleum" ; -- linoleum..nn.1
  linoleummatta_1_N = mkN "linoleummatta" ; -- linoleummatta..nn.1
  linoleumsnitt_1_N = mkN "linoleumsnitt" neutrum  ; -- linoleumsnitt..nn.1
  linolja_1_N = mkN "linolja" ; -- linolja..nn.1
  linoljebaserad_1_A = mkA "linoljebaserad" ; -- linoljebaserad..av.1
  linoljefärg_1_N = mkN "linoljefärg" "linoljefärger" ; -- linoljefärg..nn.1
  linolsyra_1_N = mkN "linolsyra" ; -- linolsyra..nn.1
  linong_1_N = mkN "linong" ; -- linong..nn.1
  lins_1_N = mkN "lins" "linser" ; -- lins..nn.1
  linsdiameter_1_N = mkN "linsdiameter" ; -- linsdiameter..nn.1
  linsfel_1_N = mkN "linsfel" "linsfelet" "linsfel" "linsfelen" ; -- linsfel..nn.1
  linsformad_1_A = mkA "linsformad" ; -- linsformad..av.1
  linsformig_1_A = mkA "linsformig" ; -- linsformig..av.1
  linskiva_1_N = mkN "linskiva" ; -- linskiva..nn.1
  linslus_1_N = mkN "linslus" "linslusen" "linslöss" "linslössen" ; -- linslus..nn.1
  linspinneri_1_N = mkN "linspinneri" "linspinneriet" "linspinnerier" "linspinnerierna" ; -- linspinneri..nn.1
  linssoppa_1_N = mkN "linssoppa" ; -- linssoppa..nn.1
  linssystem_1_N = mkN "linssystem" neutrum  ; -- linssystem..nn.1
  lintott_1_N = mkN "lintott" ; -- lintott..nn.1
  linvit_1_A = mkA "linvit" ; -- linvit..av.1
  linåker_1_N = mkN "linåker" ; -- linåker..nn.1
  lipa_1_V = mkV "lipar" ; -- lipa..vb.1
  lipande_1_N = mkN "lipande" ; -- lipande..nn.1
  lipas_1_N = mkN "lipas" "lipaser" ; -- lipas..nn.1
  lipid_1_N = mkN "lipid" "lipider" ; -- lipid..nn.1
  lipig_1_A = mkA "lipig" ; -- lipig..av.1
  lipom_1_N = mkN "lipom" neutrum  ; -- lipom..nn.1
  lipsill_1_N = mkN "lipsill" ; -- lipsill..nn.1
  lir_1_N = mkN "lir" neutrum  ; -- lir..nn.1
  lira_1_N = mkN "lira" ; -- lira..nn.1
  lira_1_V = mkV "lirar" ; -- lira..vb.1
  lirande_1_N = mkN "lirande" ; -- lirande..nn.1
  lirare_1_N = mkN "lirare" utrum  ; -- lirare..nn.1
  lire_1_N = mkN "lire" "liren" "lire" "lirena" ; -- lire..nn.1
  lirka_1_V = mkV "lirkar" ; -- lirka..vb.1
  lirkande_1_N = mkN "lirkande" ; -- lirkande..nn.1
  lirkning_1_N = mkN "lirkning" ; -- lirkning..nn.1
  lisa_1_N = mkN "lisa" ; -- lisa..nn.1
  lisen_1_N = mkN "lisen" "lisener" ; -- lisen..nn.1
  lisma_1_V = mkV "lismar" ; -- lisma..vb.1
  lismande_1_A = mkA "lismande" ; -- lismande..av.1
  lismande_1_N = mkN "lismande" ; -- lismande..nn.1
  lismare_1_N = mkN "lismare" utrum  ; -- lismare..nn.1
  lismeri_1_N = mkN "lismeri" neutrum  ; -- lismeri..nn.1
  lispund_1_N = mkN "lispund" neutrum  ; -- lispund..nn.1
  lissera_1_V = mkV "lisserar" ; -- lissera..vb.1
  lisserande_1_N = mkN "lisserande" ; -- lisserande..nn.1
  lisserbar_1_A = mkA "lisserbar" ; -- lisserbar..av.1
  lisserbarhet_1_N = mkN "lisserbarhet" ; -- lisserbarhet..nn.1
  lissering_1_N = mkN "lissering" ; -- lissering..nn.1
  list_1_N = mkN "list" "lister" ; -- list..nn.1
  lista_1_N = mkN "lista" ; -- lista..nn.1
  lista_1_V = mkV "listar" ; -- lista..vb.1
  listande_1_N = mkN "listande" ; -- listande..nn.1
  listetta_1_N = mkN "listetta" ; -- listetta..nn.1
  listig_1_A = mkA "listig" ; -- listig..av.1
  listighet_1_N = mkN "listighet" ; -- listighet..nn.1
  listornament_1_N = mkN "listornament" neutrum  ; -- listornament..nn.1
  listprofil_1_N = mkN "listprofil" "listprofiler" ; -- listprofil..nn.1
  listverk_1_N = mkN "listverk" neutrum  ; -- listverk..nn.1
  lisös_1_N = mkN "lisös" "lisöser" ; -- lisös..nn.1
  lita_1_V = mkV "litar" ; -- lita..vb.1
  litande_1_N = mkN "litande" ; -- litande..nn.1
  litania_1_N = mkN "litania" ; -- litania..nn.1
  litauer_1_N = mkN "litauer" "litauern" "litauer" "litauerna" ; -- litauer..nn.1
  litauisk_1_A = mkA "litauisk" ; -- litauisk..av.1
  litauiska_1_N = mkN "litauiska" ; -- litauiska..nn.1
  litauiska_2_N = mkN "litauiska" ; -- litauiska..nn.2
  lite_1_Adv = mkAdv "lite" ; -- lite..ab.1
  liten_1_A = mkA "liten" "litet" "lilla" "små" "mindre" "minst" "minsta" ; -- liten..av.1
  litenhet_1_N = mkN "litenhet" "litenheter" ; -- litenhet..nn.1
  liter_1_N = mkN "liter" ; -- liter..nn.1
  liter_2_N = mkN "liter" ; -- liter..nn.2
  litermått_1_N = mkN "litermått" neutrum  ; -- litermått..nn.1
  litervikt_1_N = mkN "litervikt" ; -- litervikt..nn.1
  litervis_1_Adv = mkAdv "litervis" ; -- litervis..ab.1
  litet_1_Adv = mkAdv "litet" ; -- litet..ab.1
  litium_1_N = mkN "litium" neutrum  ; -- litium..nn.1
  litiumbatteri_1_N = mkN "litiumbatteri" "litiumbatteriet" "litiumbatterier" "litiumbatterierna" ; -- litiumbatteri..nn.1
  litograf_1_N = mkN "litograf" "litografer" ; -- litograf..nn.1
  litografera_1_V = mkV "litograferar" ; -- litografera..vb.1
  litograferande_1_N = mkN "litograferande" ; -- litograferande..nn.1
  litograferbar_1_A = mkA "litograferbar" ; -- litograferbar..av.1
  litograferbarhet_1_N = mkN "litograferbarhet" ; -- litograferbarhet..nn.1
  litografering_1_N = mkN "litografering" ; -- litografering..nn.1
  litografi_1_N = mkN "litografi" "litografier" ; -- litografi..nn.1
  litografisk_1_A = mkA "litografisk" ; -- litografisk..av.1
  litoral_1_A = mkA "litoral" ; -- litoral..av.1
  litosfär_1_N = mkN "litosfär" ; -- litosfär..nn.1
  litotes_1_N = mkN "litotes" "litoteser" ; -- litotes..nn.1
  litsa_1_V = mkV "litsar" ; -- litsa..vb.1
  litsande_1_N = mkN "litsande" ; -- litsande..nn.1
  littera_1_N = mkN "littera" ; -- littera..nn.1
  litterat_1_A = mkA "litterat" "litterat" ; -- litterat..av.1
  litteratur_1_N = mkN "litteratur" "litteraturer" ; -- litteratur..nn.1
  litteraturanmälan_1_N = mkN "litteraturanmälan" "litteraturanmälan" "litteraturanmälningar" "litteraturanmälningarna" ; -- litteraturanmälan..nn.1
  litteraturanvisning_1_N = mkN "litteraturanvisning" ; -- litteraturanvisning..nn.1
  litteraturforskare_1_N = mkN "litteraturforskare" utrum  ; -- litteraturforskare..nn.1
  litteraturförteckning_1_N = mkN "litteraturförteckning" ; -- litteraturförteckning..nn.1
  litteraturgenre_1_N = mkN "litteraturgenre" "litteraturgenrer" ; -- litteraturgenre..nn.1
  litteraturhistoria_1_N = mkN "litteraturhistoria" ; -- litteraturhistoria..nn.1
  litteraturhistorisk_1_A = mkA "litteraturhistorisk" ; -- litteraturhistorisk..av.1
  litteraturhänvisning_1_N = mkN "litteraturhänvisning" ; -- litteraturhänvisning..nn.1
  litteraturingenjör_1_N = mkN "litteraturingenjör" "litteraturingenjörer" ; -- litteraturingenjör..nn.1
  litteraturintresserad_1_A = mkA "litteraturintresserad" ; -- litteraturintresserad..av.1
  litteraturkanon_1_N = mkN "litteraturkanon" "litteraturkanon" "litteraturkanon" "litteraturkanonerna" ; -- litteraturkanon..nn.1
  litteraturkritik_1_N = mkN "litteraturkritik" ; -- litteraturkritik..nn.1
  litteraturkritiker_1_N = mkN "litteraturkritiker" "litteraturkritikern" "litteraturkritiker" "litteraturkritikerna" ; -- litteraturkritiker..nn.1
  litteraturkännedom_1_N = mkN "litteraturkännedom" ; -- litteraturkännedom..nn.1
  litteraturprofessor_1_N = mkN "litteraturprofessor" "litteraturprofessorer" ; -- litteraturprofessor..nn.1
  litteratursociologi_1_N = mkN "litteratursociologi" ; -- litteratursociologi..nn.1
  litteraturspråk_1_N = mkN "litteraturspråk" neutrum  ; -- litteraturspråk..nn.1
  litteratursyn_1_N = mkN "litteratursyn" "litteratursyner" ; -- litteratursyn..nn.1
  litteratursökning_1_N = mkN "litteratursökning" ; -- litteratursökning..nn.1
  litteraturvetenskap_1_N = mkN "litteraturvetenskap" ; -- litteraturvetenskap..nn.1
  litteraturvetenskaplig_1_A = mkA "litteraturvetenskaplig" ; -- litteraturvetenskaplig..av.1
  litteratör_1_N = mkN "litteratör" "litteratörer" ; -- litteratör..nn.1
  litterär_1_A = mkA "litterär" ; -- litterär..av.1
  liturg_1_N = mkN "liturg" "liturger" ; -- liturg..nn.1
  liturgi_1_N = mkN "liturgi" "liturgier" ; -- liturgi..nn.1
  liturgireform_1_N = mkN "liturgireform" "liturgireformer" ; -- liturgireform..nn.1
  liturgisk_1_A = mkA "liturgisk" ; -- liturgisk..av.1
  liv_1_N = mkN "liv" neutrum  ; -- liv..nn.1
  liva_1_V = mkV "livar" ; -- liva..vb.1
  livad_1_A = mkA "livad" ; -- livad..av.1
  livaktig_1_A = mkA "livaktig" ; -- livaktig..av.1
  livaktighet_1_N = mkN "livaktighet" ; -- livaktighet..nn.1
  livande_1_N = mkN "livande" ; -- livande..nn.1
  livboj_1_N = mkN "livboj" ; -- livboj..nn.1
  livbojsort_1_N = mkN "livbojsort" "livbojsorter" ; -- livbojsort..nn.1
  livbälte_1_N = mkN "livbälte" ; -- livbälte..nn.1
  livbåt_1_N = mkN "livbåt" ; -- livbåt..nn.1
  livdjur_1_N = mkN "livdjur" neutrum  ; -- livdjur..nn.1
  livdrabant_1_N = mkN "livdrabant" "livdrabanter" ; -- livdrabant..nn.1
  livdömd_1_A = mkA "livdömd" "livdömt" ; -- livdömd..av.1
  live_show_1_N = mkN "live-show" "live-shower" ; -- live-show..nn.1
  live_1_A = mkA "live" ; -- live..av.1
  livegen_1_A = mkA "livegen" ; -- livegen..av.1
  livegenhet_1_N = mkN "livegenhet" ; -- livegenhet..nn.1
  livegenskap_1_N = mkN "livegenskap" ; -- livegenskap..nn.1
  livfull_1_A = mkA "livfull" ; -- livfull..av.1
  livfullhet_1_N = mkN "livfullhet" ; -- livfullhet..nn.1
  livförsäkra_1_V = mkV "livförsäkrar" ; -- livförsäkra..vb.1
  livförsäkrande_1_N = mkN "livförsäkrande" ; -- livförsäkrande..nn.1
  livförsäkring_1_N = mkN "livförsäkring" ; -- livförsäkring..nn.1
  livgarde_1_N = mkN "livgarde" ; -- livgarde..nn.1
  livgivande_1_A = mkA "livgivande" ; -- livgivande..av.1
  livhank_1_N = mkN "livhank" ; -- livhank..nn.1
  livklädnad_1_N = mkN "livklädnad" "livklädnader" ; -- livklädnad..nn.1
  livlig_1_A = mkA "livlig" ; -- livlig..av.1
  livlighet_1_N = mkN "livlighet" "livligheter" ; -- livlighet..nn.1
  livlina_1_N = mkN "livlina" ; -- livlina..nn.1
  livländsk_1_A = mkA "livländsk" ; -- livländsk..av.1
  livlös_1_A = mkA "livlös" ; -- livlös..av.1
  livlöshet_1_N = mkN "livlöshet" ; -- livlöshet..nn.1
  livmedikus_1_N = mkN "livmedikus" "livmedikusen" "livmedici" "livmedicina" ; -- livmedikus..nn.1
  livmoder_1_N = mkN "livmoder" "livmodern" "livmödrar" "livmödrarna" ; -- livmoder..nn.1
  livmoderframfall_1_N = mkN "livmoderframfall" neutrum  ; -- livmoderframfall..nn.1
  livmoderhals_1_N = mkN "livmoderhals" ; -- livmoderhals..nn.1
  livmoderhåla_1_N = mkN "livmoderhåla" ; -- livmoderhåla..nn.1
  livmodermun_1_N = mkN "livmodermun" "livmodermunnen" "livmodermunnar" "livmodermunnarna" ; -- livmodermun..nn.1
  livmodersslemhinna_1_N = mkN "livmodersslemhinna" ; -- livmodersslemhinna..nn.1
  livmodertapp_1_N = mkN "livmodertapp" ; -- livmodertapp..nn.1
  livnära_1_V = mkV "livnära" "livnärde" "livnärt" ; -- livnära..vb.1
  livnärande_1_N = mkN "livnärande" ; -- livnärande..nn.1
  livregemente_1_N = mkN "livregemente" ; -- livregemente..nn.1
  livrem_1_N = mkN "livrem" "livremmen" "livremmar" "livremmarna" ; -- livrem..nn.1
  livrustkammare_1_N = mkN "livrustkammare" "livrustkammaren" "livrustkammare" "livrustkamrarna" ; -- livrustkammare..nn.1
  livrädd_1_A = mkA "livrädd" ; -- livrädd..av.1
  livräddande_1_A = mkA "livräddande" ; -- livräddande..av.1
  livräddare_1_N = mkN "livräddare" utrum  ; -- livräddare..nn.1
  livräddning_1_N = mkN "livräddning" ; -- livräddning..nn.1
  livräddningsbåt_1_N = mkN "livräddningsbåt" ; -- livräddningsbåt..nn.1
  livräddningsdräkt_1_N = mkN "livräddningsdräkt" "livräddningsdräkter" ; -- livräddningsdräkt..nn.1
  livränta_1_N = mkN "livränta" ; -- livränta..nn.1
  livrätt_1_N = mkN "livrätt" "livrätter" ; -- livrätt..nn.1
  livré_1_N = mkN "livré" "livréet" "livréer" "livréerna" ; -- livré..nn.1
  livréklädd_1_A = mkA "livréklädd" ; -- livréklädd..av.1
  livs_1_A = mkA "livs" ; -- livs..av.1
  livs_1_N = mkN "livs" ; -- livs..nn.1
  livsande_1_N = mkN "livsande" utrum  ; -- livsande..nn.1
  livsarvinge_1_N = mkN "livsarvinge" utrum  ; -- livsarvinge..nn.1
  livsavgörande_1_A = mkA "livsavgörande" ; -- livsavgörande..av.1
  livsbefrämjande_1_A = mkA "livsbefrämjande" ; -- livsbefrämjande..av.1
  livsbejakande_1_A = mkA "livsbejakande" ; -- livsbejakande..av.1
  livsbejakare_1_N = mkN "livsbejakare" utrum  ; -- livsbejakare..nn.1
  livsbejakelse_1_N = mkN "livsbejakelse" utrum  ; -- livsbejakelse..nn.1
  livsbetingelse_1_N = mkN "livsbetingelse" "livsbetingelser" ; -- livsbetingelse..nn.1
  livscykel_1_N = mkN "livscykel" ; -- livscykel..nn.1
  livsduglig_1_A = mkA "livsduglig" ; -- livsduglig..av.1
  livsduglighet_1_N = mkN "livsduglighet" ; -- livsduglighet..nn.1
  livselixir_1_N = mkN "livselixir" neutrum  ; -- livselixir..nn.1
  livsenergi_1_N = mkN "livsenergi" ; -- livsenergi..nn.1
  livserfarenhet_1_N = mkN "livserfarenhet" "livserfarenheter" ; -- livserfarenhet..nn.1
  livsfara_1_N = mkN "livsfara" ; -- livsfara..nn.1
  livsfarlig_1_A = mkA "livsfarlig" ; -- livsfarlig..av.1
  livsfarlighet_1_N = mkN "livsfarlighet" "livsfarligheter" ; -- livsfarlighet..nn.1
  livsform_1_N = mkN "livsform" "livsformer" ; -- livsform..nn.1
  livsfrukt_1_N = mkN "livsfrukt" "livsfrukter" ; -- livsfrukt..nn.1
  livsfråga_1_N = mkN "livsfråga" ; -- livsfråga..nn.1
  livsfunktion_1_N = mkN "livsfunktion" ; -- livsfunktion..nn.1
  livsföring_1_N = mkN "livsföring" ; -- livsföring..nn.1
  livsförnekelse_1_N = mkN "livsförnekelse" "livsförnekelser" ; -- livsförnekelse..nn.1
  livsglädje_1_N = mkN "livsglädje" utrum  ; -- livsglädje..nn.1
  livsgnista_1_N = mkN "livsgnista" ; -- livsgnista..nn.1
  livsgärning_1_N = mkN "livsgärning" ; -- livsgärning..nn.1
  livshistoria_1_N = mkN "livshistoria" "livshistorian" "livshistorier" "livshistorierna" ; -- livshistoria..nn.1
  livshotande_1_A = mkA "livshotande" ; -- livshotande..av.1
  livshållning_1_N = mkN "livshållning" ; -- livshållning..nn.1
  livskamrat_1_N = mkN "livskamrat" "livskamrater" ; -- livskamrat..nn.1
  livskraft_1_N = mkN "livskraft" ; -- livskraft..nn.1
  livskraftig_1_A = mkA "livskraftig" ; -- livskraftig..av.1
  livskraftighet_1_N = mkN "livskraftighet" ; -- livskraftighet..nn.1
  livskris_1_N = mkN "livskris" "livskriser" ; -- livskris..nn.1
  livskvalitet_1_N = mkN "livskvalitet" "livskvaliteter" ; -- livskvalitet..nn.1
  livskänsla_1_N = mkN "livskänsla" ; -- livskänsla..nn.1
  livslag_1_N = mkN "livslag" ; -- livslag..nn.1
  livsleda_1_N = mkN "livsleda" ; -- livsleda..nn.1
  livslevande_1_A = mkA "livslevande" ; -- livslevande..av.1
  livslinje_1_N = mkN "livslinje" "livslinjer" ; -- livslinje..nn.1
  livslott_1_N = mkN "livslott" "livslotter" ; -- livslott..nn.1
  livsluft_1_N = mkN "livsluft" ; -- livsluft..nn.1
  livslust_1_N = mkN "livslust" ; -- livslust..nn.1
  livslängd_1_N = mkN "livslängd" "livslängder" ; -- livslängd..nn.1
  livslåga_1_N = mkN "livslåga" ; -- livslåga..nn.1
  livslång_1_A = mkA "livslång" ; -- livslång..av.1
  livslögn_1_N = mkN "livslögn" "livslögner" ; -- livslögn..nn.1
  livsmedel_1_N = mkN "livsmedel" neutrum  ; -- livsmedel..nn.1
  livsmedelsaffär_1_N = mkN "livsmedelsaffär" "livsmedelsaffärer" ; -- livsmedelsaffär..nn.1
  livsmedelsavfall_1_N = mkN "livsmedelsavfall" neutrum  ; -- livsmedelsavfall..nn.1
  livsmedelsbrist_1_N = mkN "livsmedelsbrist" ; -- livsmedelsbrist..nn.1
  livsmedelsbutik_1_N = mkN "livsmedelsbutik" "livsmedelsbutiker" ; -- livsmedelsbutik..nn.1
  livsmedelsfärg_1_N = mkN "livsmedelsfärg" "livsmedelsfärger" ; -- livsmedelsfärg..nn.1
  livsmedelsförpackning_1_N = mkN "livsmedelsförpackning" ; -- livsmedelsförpackning..nn.1
  livsmedelsförsörjning_1_N = mkN "livsmedelsförsörjning" ; -- livsmedelsförsörjning..nn.1
  livsmedelsindustri_1_N = mkN "livsmedelsindustri" "livsmedelsindustrier" ; -- livsmedelsindustri..nn.1
  livsmedelsjätte_1_N = mkN "livsmedelsjätte" utrum  ; -- livsmedelsjätte..nn.1
  livsmedelskedja_1_N = mkN "livsmedelskedja" ; -- livsmedelskedja..nn.1
  livsmedelskemi_1_N = mkN "livsmedelskemi" ; -- livsmedelskemi..nn.1
  livsmedelskontroll_1_N = mkN "livsmedelskontroll" "livsmedelskontroller" ; -- livsmedelskontroll..nn.1
  livsmedelskonvoj_1_N = mkN "livsmedelskonvoj" "livsmedelskonvojer" ; -- livsmedelskonvoj..nn.1
  livsmedelslag_1_N = mkN "livsmedelslag" ; -- livsmedelslag..nn.1
  livsmedelspolitik_1_N = mkN "livsmedelspolitik" ; -- livsmedelspolitik..nn.1
  livsmedelsproducent_1_N = mkN "livsmedelsproducent" "livsmedelsproducenter" ; -- livsmedelsproducent..nn.1
  livsmedelsproduktion_1_N = mkN "livsmedelsproduktion" ; -- livsmedelsproduktion..nn.1
  livsmedelstillsats_1_N = mkN "livsmedelstillsats" "livsmedelstillsatser" ; -- livsmedelstillsats..nn.1
  livsmedelsverk_1_N = mkN "livsmedelsverk" neutrum  ; -- livsmedelsverk..nn.1
  livsmiljö_1_N = mkN "livsmiljö" "livsmiljön" "livsmiljöer" "livsmiljöerna" ; -- livsmiljö..nn.1
  livsmod_1_N = mkN "livsmod" neutrum  ; -- livsmod..nn.1
  livsnatur_1_N = mkN "livsnatur" "livsnaturer" ; -- livsnatur..nn.1
  livsnerv_1_N = mkN "livsnerv" "livsnerver" ; -- livsnerv..nn.1
  livsnjutare_1_N = mkN "livsnjutare" utrum  ; -- livsnjutare..nn.1
  livsnjutartillvaro_1_N = mkN "livsnjutartillvaro" ; -- livsnjutartillvaro..nn.1
  livsnödvändig_1_A = mkA "livsnödvändig" ; -- livsnödvändig..av.1
  livsnödvändighet_1_N = mkN "livsnödvändighet" ; -- livsnödvändighet..nn.1
  livsprincip_1_N = mkN "livsprincip" "livsprinciper" ; -- livsprincip..nn.1
  livsproblem_1_N = mkN "livsproblem" neutrum  ; -- livsproblem..nn.1
  livsprocess_1_N = mkN "livsprocess" "livsprocesser" ; -- livsprocess..nn.1
  livspussel_1_N = mkN "livspussel" neutrum  ; -- livspussel..nn.1
  livsreaktion_1_N = mkN "livsreaktion" ; -- livsreaktion..nn.1
  livssituation_1_N = mkN "livssituation" ; -- livssituation..nn.1
  livsslut_1_N = mkN "livsslut" neutrum  ; -- livsslut..nn.1
  livsspann_1_N = mkN "livsspann" neutrum  ; -- livsspann..nn.1
  livsstil_1_N = mkN "livsstil" ; -- livsstil..nn.1
  livsstilsfaktor_1_N = mkN "livsstilsfaktor" "livsstilsfaktorer" ; -- livsstilsfaktor..nn.1
  livsstilsfenomen_1_N = mkN "livsstilsfenomen" neutrum  ; -- livsstilsfenomen..nn.1
  livsstilsförändring_1_N = mkN "livsstilsförändring" ; -- livsstilsförändring..nn.1
  livsstilskriminell_1_A = mkA "livsstilskriminell" ; -- livsstilskriminell..av.1
  livsstilsoas_1_N = mkN "livsstilsoas" "livsstilsoaser" ; -- livsstilsoas..nn.1
  livsstilsrelaterad_1_A = mkA "livsstilsrelaterad" ; -- livsstilsrelaterad..av.1
  livsstilssjukdom_1_N = mkN "livsstilssjukdom" ; -- livsstilssjukdom..nn.1
  livssyn_1_N = mkN "livssyn" "livssyner" ; -- livssyn..nn.1
  livstecken_1_N = mkN "livstecken" "livstecknet" "livstecken" "livstecknen" ; -- livstecken..nn.1
  livstid_1_N = mkN "livstid" ; -- livstid..nn.1
  livstidsdom_1_N = mkN "livstidsdom" ; -- livstidsdom..nn.1
  livstidsdömd_1_A = mkA "livstidsdömd" "livstidsdömt" ; -- livstidsdömd..av.1
  livstidsfängelse_1_N = mkN "livstidsfängelse" "livstidsfängelset" "livstidsfängelser" "livstidsfängelserna" ; -- livstidsfängelse..nn.1
  livstidsfånge_1_N = mkN "livstidsfånge" utrum  ; -- livstidsfånge..nn.1
  livstidsmedlem_1_N = mkN "livstidsmedlem" "livstidsmedlemmen" "livstidsmedlemmar" "livstidsmedlemmarna" ; -- livstidsmedlem..nn.1
  livstidsstraff_1_N = mkN "livstidsstraff" neutrum  ; -- livstidsstraff..nn.1
  livstro_1_N = mkN "livstro" ; -- livstro..nn.1
  livsträd_1_N = mkN "livsträd" neutrum  ; -- livsträd..nn.1
  livstråd_1_N = mkN "livstråd" ; -- livstråd..nn.1
  livstycke_1_N = mkN "livstycke" ; -- livstycke..nn.1
  livsuppehälle_1_N = mkN "livsuppehälle" ; -- livsuppehälle..nn.1
  livsuppehållande_1_A = mkA "livsuppehållande" ; -- livsuppehållande..av.1
  livsuppgift_1_N = mkN "livsuppgift" "livsuppgifter" ; -- livsuppgift..nn.1
  livsutveckling_1_N = mkN "livsutveckling" ; -- livsutveckling..nn.1
  livsval_1_N = mkN "livsval" neutrum  ; -- livsval..nn.1
  livsverk_1_N = mkN "livsverk" neutrum  ; -- livsverk..nn.1
  livsvetenskap_1_N = mkN "livsvetenskap" "livsvetenskaper" ; -- livsvetenskap..nn.1
  livsviktig_1_A = mkA "livsviktig" ; -- livsviktig..av.1
  livsviktighet_1_N = mkN "livsviktighet" ; -- livsviktighet..nn.1
  livsvilja_1_N = mkN "livsvilja" ; -- livsvilja..nn.1
  livsvillkor_1_N = mkN "livsvillkor" neutrum  ; -- livsvillkor..nn.1
  livsvänlig_1_A = mkA "livsvänlig" ; -- livsvänlig..av.1
  livsvänlighet_1_N = mkN "livsvänlighet" ; -- livsvänlighet..nn.1
  livsyttring_1_N = mkN "livsyttring" ; -- livsyttring..nn.1
  livsåskådning_1_N = mkN "livsåskådning" ; -- livsåskådning..nn.1
  livsåskådningsmässig_1_A = mkA "livsåskådningsmässig" ; -- livsåskådningsmässig..av.1
  livtag_1_N = mkN "livtag" neutrum  ; -- livtag..nn.1
  livtjänare_1_N = mkN "livtjänare" utrum  ; -- livtjänare..nn.1
  livvakt_1_N = mkN "livvakt" "livvakter" ; -- livvakt..nn.1
  livvaktschef_1_N = mkN "livvaktschef" "livvaktschefer" ; -- livvaktschef..nn.1
  lix_1_N = mkN "lix" neutrum  ; -- lix..nn.1
  ljud_1_N = mkN "ljud" neutrum  ; -- ljud..nn.1
  ljuda_1_V = mkV "ljuda" "ljöd" "ljudit" ; -- ljuda..vb.1
  ljuda_2_V = mkV "ljudar" ; -- ljuda..vb.2
  ljudande_1_A = mkA "ljudande" ; -- ljudande..av.1
  ljudande_1_N = mkN "ljudande" ; -- ljudande..nn.1
  ljudband_1_N = mkN "ljudband" neutrum  ; -- ljudband..nn.1
  ljudbang_1_N = mkN "ljudbang" ; -- ljudbang..nn.1
  ljudbild_1_N = mkN "ljudbild" "ljudbilder" ; -- ljudbild..nn.1
  ljudbildband_1_N = mkN "ljudbildband" neutrum  ; -- ljudbildband..nn.1
  ljudboj_1_N = mkN "ljudboj" ; -- ljudboj..nn.1
  ljudbok_1_N = mkN "ljudbok" "ljudböcker" ; -- ljudbok..nn.1
  ljudbrev_1_N = mkN "ljudbrev" neutrum  ; -- ljudbrev..nn.1
  ljuddämpande_1_A = mkA "ljuddämpande" ; -- ljuddämpande..av.1
  ljuddämpare_1_N = mkN "ljuddämpare" utrum  ; -- ljuddämpare..nn.1
  ljuddämpning_1_N = mkN "ljuddämpning" ; -- ljuddämpning..nn.1
  ljudeffekt_1_N = mkN "ljudeffekt" "ljudeffekter" ; -- ljudeffekt..nn.1
  ljudenlig_1_A = mkA "ljudenlig" ; -- ljudenlig..av.1
  ljudenlighet_1_N = mkN "ljudenlighet" ; -- ljudenlighet..nn.1
  ljudfilm_1_N = mkN "ljudfilm" "ljudfilmer" ; -- ljudfilm..nn.1
  ljudfrekvens_1_N = mkN "ljudfrekvens" "ljudfrekvenser" ; -- ljudfrekvens..nn.1
  ljudförbindelse_1_N = mkN "ljudförbindelse" "ljudförbindelser" ; -- ljudförbindelse..nn.1
  ljudförändring_1_N = mkN "ljudförändring" ; -- ljudförändring..nn.1
  ljudhastighet_1_N = mkN "ljudhastighet" "ljudhastigheter" ; -- ljudhastighet..nn.1
  ljudhärmande_1_A = mkA "ljudhärmande" ; -- ljudhärmande..av.1
  ljudhål_1_N = mkN "ljudhål" neutrum  ; -- ljudhål..nn.1
  ljudinspelare_1_N = mkN "ljudinspelare" utrum  ; -- ljudinspelare..nn.1
  ljudinspelning_1_N = mkN "ljudinspelning" ; -- ljudinspelning..nn.1
  ljudintryck_1_N = mkN "ljudintryck" neutrum  ; -- ljudintryck..nn.1
  ljudisolera_1_V = mkV "ljudisolerar" ; -- ljudisolera..vb.1
  ljudisolerande_1_N = mkN "ljudisolerande" ; -- ljudisolerande..nn.1
  ljudisolerbar_1_A = mkA "ljudisolerbar" ; -- ljudisolerbar..av.1
  ljudisolerbarhet_1_N = mkN "ljudisolerbarhet" ; -- ljudisolerbarhet..nn.1
  ljudisolering_1_N = mkN "ljudisolering" ; -- ljudisolering..nn.1
  ljudkuliss_1_N = mkN "ljudkuliss" "ljudkulisser" ; -- ljudkuliss..nn.1
  ljudkvalitet_1_N = mkN "ljudkvalitet" "ljudkvaliteter" ; -- ljudkvalitet..nn.1
  ljudkälla_1_N = mkN "ljudkälla" ; -- ljudkälla..nn.1
  ljudlag_1_N = mkN "ljudlag" ; -- ljudlag..nn.1
  ljudlig_1_A = mkA "ljudlig" ; -- ljudlig..av.1
  ljudlighet_1_N = mkN "ljudlighet" ; -- ljudlighet..nn.1
  ljudlära_1_N = mkN "ljudlära" ; -- ljudlära..nn.1
  ljudlös_1_A = mkA "ljudlös" ; -- ljudlös..av.1
  ljudlöshet_1_N = mkN "ljudlöshet" ; -- ljudlöshet..nn.1
  ljudmässig_1_A = mkA "ljudmässig" ; -- ljudmässig..av.1
  ljudnivå_1_N = mkN "ljudnivå" "ljudnivåer" ; -- ljudnivå..nn.1
  ljudradio_1_N = mkN "ljudradio" ; -- ljudradio..nn.1
  ljudresultat_1_N = mkN "ljudresultat" neutrum  ; -- ljudresultat..nn.1
  ljudsignal_1_N = mkN "ljudsignal" "ljudsignaler" ; -- ljudsignal..nn.1
  ljudskridning_1_N = mkN "ljudskridning" ; -- ljudskridning..nn.1
  ljudskrift_1_N = mkN "ljudskrift" "ljudskrifter" ; -- ljudskrift..nn.1
  ljudslinga_1_N = mkN "ljudslinga" ; -- ljudslinga..nn.1
  ljudspringa_1_N = mkN "ljudspringa" ; -- ljudspringa..nn.1
  ljudstyrka_1_N = mkN "ljudstyrka" ; -- ljudstyrka..nn.1
  ljudstöt_1_N = mkN "ljudstöt" ; -- ljudstöt..nn.1
  ljudsvag_1_A = mkA "ljudsvag" ; -- ljudsvag..av.1
  ljudsvaghet_1_N = mkN "ljudsvaghet" ; -- ljudsvaghet..nn.1
  ljudsymbolik_1_N = mkN "ljudsymbolik" ; -- ljudsymbolik..nn.1
  ljudsystem_1_N = mkN "ljudsystem" neutrum  ; -- ljudsystem..nn.1
  ljudsätta_1_V = mkV "ljudsätta" "ljudsätter" "ljudsätt" "ljudsatte" "ljudsatt" "ljudsatt" ; -- ljudsätta..vb.1
  ljudsättande_1_N = mkN "ljudsättande" ; -- ljudsättande..nn.1
  ljudtekniker_1_N = mkN "ljudtekniker" "ljudteknikern" "ljudtekniker" "ljudteknikerna" ; -- ljudtekniker..nn.1
  ljudupprepning_1_N = mkN "ljudupprepning" ; -- ljudupprepning..nn.1
  ljudupptagning_1_N = mkN "ljudupptagning" ; -- ljudupptagning..nn.1
  ljudvall_1_N = mkN "ljudvall" ; -- ljudvall..nn.1
  ljudvåg_1_N = mkN "ljudvåg" "ljudvågor" ; -- ljudvåg..nn.1
  ljudåtergivning_1_N = mkN "ljudåtergivning" ; -- ljudåtergivning..nn.1
  ljudöverföring_1_N = mkN "ljudöverföring" ; -- ljudöverföring..nn.1
  ljug_1_N = mkN "ljug" neutrum  ; -- ljug..nn.1
  ljuga_1_V = mkV "ljuga" "ljög" "ljugit" ; -- ljuga..vb.1
  ljugande_1_N = mkN "ljugande" ; -- ljugande..nn.1
  ljugarbänk_1_N = mkN "ljugarbänk" ; -- ljugarbänk..nn.1
  ljugare_1_N = mkN "ljugare" utrum  ; -- ljugare..nn.1
  ljum_1_A = mkA "ljum" "ljumt" "ljumma" "ljumma" "ljummare" "ljummast" "ljummaste" ; -- ljum..av.1
  ljumhet_1_N = mkN "ljumhet" "ljumheter" ; -- ljumhet..nn.1
  ljumhet_2_N = mkN "ljumhet" ; -- ljumhet..nn.2
  ljumma_1_V = mkV "ljummar" ; -- ljumma..vb.1
  ljummande_1_N = mkN "ljummande" ; -- ljummande..nn.1
  ljummen_1_A = mkA "ljummen" "ljummet" "ljumna" "ljumna" "ljumnare" "ljumnast" "ljumnaste" ; -- ljummen..av.1
  ljummenhet_1_N = mkN "ljummenhet" ; -- ljummenhet..nn.1
  ljumskbråck_1_N = mkN "ljumskbråck" neutrum  ; -- ljumskbråck..nn.1
  ljumske_1_N = mkN "ljumske" utrum  ; -- ljumske..nn.1
  ljumsktrakt_1_N = mkN "ljumsktrakt" "ljumsktrakter" ; -- ljumsktrakt..nn.1
  ljung_1_N = mkN "ljung" ; -- ljung..nn.1
  ljunga_1_V = mkV "ljungar" ; -- ljunga..vb.1
  ljungande_1_N = mkN "ljungande" ; -- ljungande..nn.1
  ljungeld_1_N = mkN "ljungeld" ; -- ljungeld..nn.1
  ljungpipare_1_N = mkN "ljungpipare" utrum  ; -- ljungpipare..nn.1
  ljungväxt_1_N = mkN "ljungväxt" "ljungväxter" ; -- ljungväxt..nn.1
  ljus_1_A = mkA "ljus" ; -- ljus..av.1
  ljus_1_N = mkN "ljus" neutrum  ; -- ljus..nn.1
  ljusalf_1_N = mkN "ljusalf" "ljusalfer" ; -- ljusalf..nn.1
  ljusalv_1_N = mkN "ljusalv" "ljusalver" ; -- ljusalv..nn.1
  ljusbehandling_1_N = mkN "ljusbehandling" ; -- ljusbehandling..nn.1
  ljusbeständig_1_A = mkA "ljusbeständig" ; -- ljusbeständig..av.1
  ljusbeständighet_1_N = mkN "ljusbeständighet" ; -- ljusbeständighet..nn.1
  ljusbild_1_N = mkN "ljusbild" "ljusbilder" ; -- ljusbild..nn.1
  ljusblind_1_A = mkA "ljusblind" ; -- ljusblind..av.1
  ljusblindhet_1_N = mkN "ljusblindhet" ; -- ljusblindhet..nn.1
  ljusblixt_1_N = mkN "ljusblixt" ; -- ljusblixt..nn.1
  ljusblå_1_A = mkA "ljusblå" "ljusblått" ; -- ljusblå..av.1
  ljusbrist_1_N = mkN "ljusbrist" ; -- ljusbrist..nn.1
  ljusbrun_1_A = mkA "ljusbrun" ; -- ljusbrun..av.1
  ljusbrunn_1_N = mkN "ljusbrunn" ; -- ljusbrunn..nn.1
  ljusbrytning_1_N = mkN "ljusbrytning" ; -- ljusbrytning..nn.1
  ljusbåge_1_N = mkN "ljusbåge" utrum  ; -- ljusbåge..nn.1
  ljusdränkt_1_A = mkA "ljusdränkt" "ljusdränkt" ; -- ljusdränkt..av.1
  ljusdunkel_1_N = mkN "ljusdunkel" neutrum  ; -- ljusdunkel..nn.1
  ljuseffekt_1_N = mkN "ljuseffekt" "ljuseffekter" ; -- ljuseffekt..nn.1
  ljusenergi_1_N = mkN "ljusenergi" ; -- ljusenergi..nn.1
  ljusfenomen_1_N = mkN "ljusfenomen" neutrum  ; -- ljusfenomen..nn.1
  ljusfilter_1_N = mkN "ljusfilter" neutrum  ; -- ljusfilter..nn.1
  ljusflod_1_N = mkN "ljusflod" "ljusfloder" ; -- ljusflod..nn.1
  ljusfläck_1_N = mkN "ljusfläck" ; -- ljusfläck..nn.1
  ljusfläckad_1_A = mkA "ljusfläckad" ; -- ljusfläckad..av.1
  ljusflöde_1_N = mkN "ljusflöde" ; -- ljusflöde..nn.1
  ljusfördelning_1_N = mkN "ljusfördelning" ; -- ljusfördelning..nn.1
  ljusförhållande_1_N = mkN "ljusförhållande" ; -- ljusförhållande..nn.1
  ljusföring_1_N = mkN "ljusföring" ; -- ljusföring..nn.1
  ljusgestalt_1_N = mkN "ljusgestalt" "ljusgestalter" ; -- ljusgestalt..nn.1
  ljusglimt_1_N = mkN "ljusglimt" ; -- ljusglimt..nn.1
  ljusglitter_1_N = mkN "ljusglitter" neutrum  ; -- ljusglitter..nn.1
  ljusgrå_1_A = mkA "ljusgrå" "ljusgrått" ; -- ljusgrå..av.1
  ljusgrön_1_A = mkA "ljusgrön" ; -- ljusgrön..av.1
  ljusgul_1_A = mkA "ljusgul" ; -- ljusgul..av.1
  ljusgård_1_N = mkN "ljusgård" ; -- ljusgård..nn.1
  ljushastighet_1_N = mkN "ljushastighet" "ljushastigheter" ; -- ljushastighet..nn.1
  ljushet_1_N = mkN "ljushet" ; -- ljushet..nn.1
  ljushuggning_1_N = mkN "ljushuggning" ; -- ljushuggning..nn.1
  ljushuvud_1_N = mkN "ljushuvud" "ljushuvudet" "ljushuvud" "ljushuvudena" ; -- ljushuvud..nn.1
  ljushyad_1_A = mkA "ljushyad" ; -- ljushyad..av.1
  ljushyllt_1_A = mkA "ljushyllt" "ljushyllt" ; -- ljushyllt..av.1
  ljushyllthet_1_N = mkN "ljushyllthet" ; -- ljushyllthet..nn.1
  ljushållare_1_N = mkN "ljushållare" utrum  ; -- ljushållare..nn.1
  ljushårig_1_A = mkA "ljushårig" ; -- ljushårig..av.1
  ljushårighet_1_N = mkN "ljushårighet" ; -- ljushårighet..nn.1
  ljusknippe_1_N = mkN "ljusknippe" ; -- ljusknippe..nn.1
  ljuskopiera_1_V = mkV "ljuskopierar" ; -- ljuskopiera..vb.1
  ljuskopierande_1_N = mkN "ljuskopierande" ; -- ljuskopierande..nn.1
  ljuskopierbar_1_A = mkA "ljuskopierbar" ; -- ljuskopierbar..av.1
  ljuskopierbarhet_1_N = mkN "ljuskopierbarhet" ; -- ljuskopierbarhet..nn.1
  ljuskopiering_1_N = mkN "ljuskopiering" ; -- ljuskopiering..nn.1
  ljuskrans_1_N = mkN "ljuskrans" ; -- ljuskrans..nn.1
  ljuskrets_1_N = mkN "ljuskrets" ; -- ljuskrets..nn.1
  ljuskrona_1_N = mkN "ljuskrona" ; -- ljuskrona..nn.1
  ljuskrävande_1_A = mkA "ljuskrävande" ; -- ljuskrävande..av.1
  ljuskvantum_1_N = mkN "ljuskvantum" neutrum  ; -- ljuskvantum..nn.1
  ljuskägla_1_N = mkN "ljuskägla" ; -- ljuskägla..nn.1
  ljuskälla_1_N = mkN "ljuskälla" ; -- ljuskälla..nn.1
  ljuskänslig_1_A = mkA "ljuskänslig" ; -- ljuskänslig..av.1
  ljuskänslighet_1_N = mkN "ljuskänslighet" "ljuskänsligheter" ; -- ljuskänslighet..nn.1
  ljuslagd_1_A = mkA "ljuslagd" "ljuslagt" ; -- ljuslagd..av.1
  ljuslagdhet_1_N = mkN "ljuslagdhet" ; -- ljuslagdhet..nn.1
  ljuslist_1_N = mkN "ljuslist" "ljuslister" ; -- ljuslist..nn.1
  ljuslockig_1_A = mkA "ljuslockig" ; -- ljuslockig..av.1
  ljuslockighet_1_N = mkN "ljuslockighet" ; -- ljuslockighet..nn.1
  ljuslykta_1_N = mkN "ljuslykta" ; -- ljuslykta..nn.1
  ljuslätt_1_A = mkA "ljuslätt" ; -- ljuslätt..av.1
  ljuslätthet_1_N = mkN "ljuslätthet" ; -- ljuslätthet..nn.1
  ljuslåga_1_N = mkN "ljuslåga" ; -- ljuslåga..nn.1
  ljusmanifestation_1_N = mkN "ljusmanifestation" ; -- ljusmanifestation..nn.1
  ljusmikroskop_1_N = mkN "ljusmikroskop" neutrum  ; -- ljusmikroskop..nn.1
  ljusmässig_1_A = mkA "ljusmässig" ; -- ljusmässig..av.1
  ljusna_1_V = mkV "ljusnar" ; -- ljusna..vb.1
  ljusnande_1_N = mkN "ljusnande" ; -- ljusnande..nn.1
  ljusning_1_N = mkN "ljusning" ; -- ljusning..nn.1
  ljusnät_1_N = mkN "ljusnät" neutrum  ; -- ljusnät..nn.1
  ljusorgel_1_N = mkN "ljusorgel" ; -- ljusorgel..nn.1
  ljuspartikel_1_N = mkN "ljuspartikel" ; -- ljuspartikel..nn.1
  ljuspenna_1_N = mkN "ljuspenna" ; -- ljuspenna..nn.1
  ljuspunkt_1_N = mkN "ljuspunkt" "ljuspunkter" ; -- ljuspunkt..nn.1
  ljusramp_1_N = mkN "ljusramp" "ljusramper" ; -- ljusramp..nn.1
  ljusreflekterande_1_A = mkA "ljusreflekterande" ; -- ljusreflekterande..av.1
  ljusreflex_1_N = mkN "ljusreflex" "ljusreflexer" ; -- ljusreflex..nn.1
  ljusreklam_1_N = mkN "ljusreklam" ; -- ljusreklam..nn.1
  ljusrektangel_1_N = mkN "ljusrektangel" ; -- ljusrektangel..nn.1
  ljusrosa_1_A = mkA "ljusrosa" ; -- ljusrosa..av.1
  ljusröd_1_A = mkA "ljusröd" "ljusrött" ; -- ljusröd..av.1
  ljussamlande_1_A = mkA "ljussamlande" ; -- ljussamlande..av.1
  ljussignal_1_N = mkN "ljussignal" "ljussignaler" ; -- ljussignal..nn.1
  ljussken_1_N = mkN "ljussken" neutrum  ; -- ljussken..nn.1
  ljusskimmer_1_N = mkN "ljusskimmer" neutrum  ; -- ljusskimmer..nn.1
  ljusskygg_1_A = mkA "ljusskygg" ; -- ljusskygg..av.1
  ljusskygghet_1_N = mkN "ljusskygghet" "ljusskyggheter" ; -- ljusskygghet..nn.1
  ljusslinga_1_N = mkN "ljusslinga" ; -- ljusslinga..nn.1
  ljussläckare_1_N = mkN "ljussläckare" utrum  ; -- ljussläckare..nn.1
  ljusstake_1_N = mkN "ljusstake" utrum  ; -- ljusstake..nn.1
  ljusstark_1_A = mkA "ljusstark" ; -- ljusstark..av.1
  ljusstrimma_1_N = mkN "ljusstrimma" ; -- ljusstrimma..nn.1
  ljusstråle_1_N = mkN "ljusstråle" utrum  ; -- ljusstråle..nn.1
  ljusstrålning_1_N = mkN "ljusstrålning" ; -- ljusstrålning..nn.1
  ljusstyrka_1_N = mkN "ljusstyrka" ; -- ljusstyrka..nn.1
  ljussvag_1_A = mkA "ljussvag" ; -- ljussvag..av.1
  ljussvaghet_1_N = mkN "ljussvaghet" ; -- ljussvaghet..nn.1
  ljussättning_1_N = mkN "ljussättning" ; -- ljussättning..nn.1
  ljuster_1_N = mkN "ljuster" neutrum  ; -- ljuster..nn.1
  ljusterapi_1_N = mkN "ljusterapi" ; -- ljusterapi..nn.1
  ljusterapilampa_1_N = mkN "ljusterapilampa" ; -- ljusterapilampa..nn.1
  ljustra_1_V = mkV "ljustrar" ; -- ljustra..vb.1
  ljustrande_1_N = mkN "ljustrande" ; -- ljustrande..nn.1
  ljustryck_1_N = mkN "ljustryck" neutrum  ; -- ljustryck..nn.1
  ljustuta_1_N = mkN "ljustuta" ; -- ljustuta..nn.1
  ljusutstrålning_1_N = mkN "ljusutstrålning" ; -- ljusutstrålning..nn.1
  ljusvall_1_N = mkN "ljusvall" ; -- ljusvall..nn.1
  ljusvåg_1_N = mkN "ljusvåg" "ljusvågor" ; -- ljusvåg..nn.1
  ljusäkta_1_A = mkA "ljusäkta" ; -- ljusäkta..av.1
  ljusälskande_1_A = mkA "ljusälskande" ; -- ljusälskande..av.1
  ljusår_1_N = mkN "ljusår" neutrum  ; -- ljusår..nn.1
  ljusöppning_1_N = mkN "ljusöppning" ; -- ljusöppning..nn.1
  ljuv_1_A = mkA "ljuv" ; -- ljuv..av.1
  ljuvhet_1_N = mkN "ljuvhet" "ljuvheter" ; -- ljuvhet..nn.1
  ljuvlig_1_A = mkA "ljuvlig" ; -- ljuvlig..av.1
  ljuvlighet_1_N = mkN "ljuvlighet" "ljuvligheter" ; -- ljuvlighet..nn.1
  llandovery_1_N = mkN "llandovery" ; -- llandovery..nn.1
  lo_1_N = mkN "lo" ; -- lo..nn.1
  loafer_1_N = mkN "loafer" "loafern" "loafers" "loafersarna" ; -- loafer..nn.1
  lob_1_N = mkN "lob" "lober" ; -- lob..nn.1
  lobb_1_N = mkN "lobb" ; -- lobb..nn.1
  lobba_1_V = mkV "lobbar" ; -- lobba..vb.1
  lobba_2_V = mkV "lobbar" ; -- lobba..vb.2
  lobbande_1_N = mkN "lobbande" ; -- lobbande..nn.1
  lobby_1_N = mkN "lobby" "lobbyer" ; -- lobby..nn.1
  lobbyinsats_1_N = mkN "lobbyinsats" "lobbyinsatser" ; -- lobbyinsats..nn.1
  lobbyverksamhet_1_N = mkN "lobbyverksamhet" "lobbyverksamheter" ; -- lobbyverksamhet..nn.1
  lobelia_1_N = mkN "lobelia" ; -- lobelia..nn.1
  lobotomi_1_N = mkN "lobotomi" "lobotomier" ; -- lobotomi..nn.1
  lock_1_N = mkN "lock" ; -- lock..nn.1
  lock_2_N = mkN "lock" neutrum  ; -- lock..nn.2
  locka_1_V = mkV "lockar" ; -- locka..vb.1
  lockande_1_A = mkA "lockande" ; -- lockande..av.1
  lockande_1_N = mkN "lockande" ; -- lockande..nn.1
  lockbete_1_N = mkN "lockbete" ; -- lockbete..nn.1
  lockdjur_1_N = mkN "lockdjur" neutrum  ; -- lockdjur..nn.1
  lockelse_1_N = mkN "lockelse" "lockelser" ; -- lockelse..nn.1
  lockfärg_1_N = mkN "lockfärg" "lockfärger" ; -- lockfärg..nn.1
  lockfågel_1_N = mkN "lockfågel" ; -- lockfågel..nn.1
  lockig_1_A = mkA "lockig" ; -- lockig..av.1
  lockighet_1_N = mkN "lockighet" ; -- lockighet..nn.1
  lockning_1_N = mkN "lockning" ; -- lockning..nn.1
  lockout_1_N = mkN "lockout" "lockouter" ; -- lockout..nn.1
  lockouta_1_V = mkV "lockoutar" ; -- lockouta..vb.1
  lockoutande_1_N = mkN "lockoutande" ; -- lockoutande..nn.1
  lockpris_1_N = mkN "lockpris" neutrum  ; -- lockpris..nn.1
  lockrop_1_N = mkN "lockrop" neutrum  ; -- lockrop..nn.1
  lockton_1_N = mkN "lockton" "locktoner" ; -- lockton..nn.1
  locktång_1_N = mkN "locktång" "locktänger" ; -- locktång..nn.1
  lod_1_N = mkN "lod" neutrum  ; -- lod..nn.1
  loda_1_V = mkV "lodar" ; -- loda..vb.1
  loda_2_V = mkV "lodar" ; -- loda..vb.2
  lodande_1_N = mkN "lodande" ; -- lodande..nn.1
  lodare_1_N = mkN "lodare" utrum  ; -- lodare..nn.1
  lodbar_1_A = mkA "lodbar" ; -- lodbar..av.1
  lodbarhet_1_N = mkN "lodbarhet" ; -- lodbarhet..nn.1
  lodbössa_1_N = mkN "lodbössa" ; -- lodbössa..nn.1
  loden_1_N = mkN "loden" neutrum  ; -- loden..nn.1
  lodenrock_1_N = mkN "lodenrock" ; -- lodenrock..nn.1
  lodis_1_N = mkN "lodis" ; -- lodis..nn.1
  lodjur_1_N = mkN "lodjur" neutrum  ; -- lodjur..nn.1
  lodjurspäls_1_N = mkN "lodjurspäls" ; -- lodjurspäls..nn.1
  lodled_1_N = mkN "lodled" ; -- lodled..nn.1
  lodlina_1_N = mkN "lodlina" ; -- lodlina..nn.1
  lodlinje_1_N = mkN "lodlinje" "lodlinjer" ; -- lodlinje..nn.1
  lodning_1_N = mkN "lodning" ; -- lodning..nn.1
  lodplan_1_N = mkN "lodplan" neutrum  ; -- lodplan..nn.1
  lodrät_1_A = mkA "lodrät" ; -- lodrät..av.1
  lodräthet_1_N = mkN "lodräthet" ; -- lodräthet..nn.1
  lodskott_1_N = mkN "lodskott" neutrum  ; -- lodskott..nn.1
  lodstreck_1_N = mkN "lodstreck" neutrum  ; -- lodstreck..nn.1
  loft_1_N = mkN "loft" neutrum  ; -- loft..nn.1
  loftbod_1_N = mkN "loftbod" ; -- loftbod..nn.1
  loftgång_1_N = mkN "loftgång" ; -- loftgång..nn.1
  logaritm_1_N = mkN "logaritm" "logaritmer" ; -- logaritm..nn.1
  logaritmisk_1_A = mkA "logaritmisk" ; -- logaritmisk..av.1
  logaritmsystem_1_N = mkN "logaritmsystem" neutrum  ; -- logaritmsystem..nn.1
  logdörr_1_N = mkN "logdörr" ; -- logdörr..nn.1
  loge_1_N = mkN "loge" utrum  ; -- loge..nn.1
  loge_2_N = mkN "loge" "loger" ; -- loge..nn.2
  logement_1_N = mkN "logement" neutrum  ; -- logement..nn.1
  logementsfartyg_1_N = mkN "logementsfartyg" neutrum  ; -- logementsfartyg..nn.1
  logera_1_V = mkV "logerar" ; -- logera..vb.1
  logerande_1_N = mkN "logerande" ; -- logerande..nn.1
  logerare_1_N = mkN "logerare" utrum  ; -- logerare..nn.1
  logerbar_1_A = mkA "logerbar" ; -- logerbar..av.1
  logerbarhet_1_N = mkN "logerbarhet" ; -- logerbarhet..nn.1
  logering_1_N = mkN "logering" ; -- logering..nn.1
  logg_1_N = mkN "logg" ; -- logg..nn.1
  logga_1_N = mkN "logga" ; -- logga..nn.1
  logga_1_V = mkV "loggar" ; -- logga..vb.1
  loggande_1_N = mkN "loggande" ; -- loggande..nn.1
  loggbok_1_N = mkN "loggbok" "loggböcker" ; -- loggbok..nn.1
  loggert_1_N = mkN "loggert" ; -- loggert..nn.1
  loggertsegel_1_N = mkN "loggertsegel" neutrum  ; -- loggertsegel..nn.1
  loggia_1_N = mkN "loggia" ; -- loggia..nn.1
  logglas_1_N = mkN "logglas" neutrum  ; -- logglas..nn.1
  loggskädda_1_N = mkN "loggskädda" ; -- loggskädda..nn.1
  logi_1_N = mkN "logi" "logit" "login" "logina" ; -- logi..nn.1
  logik_1_N = mkN "logik" ; -- logik..nn.1
  logiker_1_N = mkN "logiker" "logikern" "logiker" "logikerna" ; -- logiker..nn.1
  logisk_1_A = mkA "logisk" ; -- logisk..av.1
  logistik_1_N = mkN "logistik" ; -- logistik..nn.1
  logistisk_1_A = mkA "logistisk" ; -- logistisk..av.1
  logografisk_1_A = mkA "logografisk" ; -- logografisk..av.1
  logogram_1_N = mkN "logogram" "logogrammet" "logogram" "logogrammen" ; -- logogram..nn.1
  logoped_1_N = mkN "logoped" "logopeder" ; -- logoped..nn.1
  logopedi_1_N = mkN "logopedi" ; -- logopedi..nn.1
  logopedisk_1_A = mkA "logopedisk" ; -- logopedisk..av.1
  logotyp_1_N = mkN "logotyp" "logotyper" ; -- logotyp..nn.1
  loj_1_A = mkA "loj" ; -- loj..av.1
  lojal_1_A = mkA "lojal" ; -- lojal..av.1
  lojalitet_1_N = mkN "lojalitet" "lojaliteter" ; -- lojalitet..nn.1
  lojalitetsband_1_N = mkN "lojalitetsband" neutrum  ; -- lojalitetsband..nn.1
  lojalitetsförklaring_1_N = mkN "lojalitetsförklaring" ; -- lojalitetsförklaring..nn.1
  lojhet_1_N = mkN "lojhet" ; -- lojhet..nn.1
  lok_1_N = mkN "lok" neutrum  ; -- lok..nn.1
  loka_1_N = mkN "loka" ; -- loka..nn.1
  lokal_1_A = mkA "lokal" ; -- lokal..av.1
  lokal_1_N = mkN "lokal" "lokaler" ; -- lokal..nn.1
  lokalanställd_1_A = mkA "lokalanställd" "lokalanställt" ; -- lokalanställd..av.1
  lokalavdelning_1_N = mkN "lokalavdelning" ; -- lokalavdelning..nn.1
  lokalbedöva_1_V = mkV "lokalbedövar" ; -- lokalbedöva..vb.1
  lokalbedövande_1_N = mkN "lokalbedövande" ; -- lokalbedövande..nn.1
  lokalbedövning_1_N = mkN "lokalbedövning" ; -- lokalbedövning..nn.1
  lokalbefolkning_1_N = mkN "lokalbefolkning" ; -- lokalbefolkning..nn.1
  lokalchef_1_N = mkN "lokalchef" "lokalchefer" ; -- lokalchef..nn.1
  lokalfärg_1_N = mkN "lokalfärg" "lokalfärger" ; -- lokalfärg..nn.1
  lokalförsvar_1_N = mkN "lokalförsvar" neutrum  ; -- lokalförsvar..nn.1
  lokalintresse_1_N = mkN "lokalintresse" ; -- lokalintresse..nn.1
  lokalisera_1_V = mkV "lokaliserar" ; -- lokalisera..vb.1
  lokaliserande_1_N = mkN "lokaliserande" ; -- lokaliserande..nn.1
  lokaliserbar_1_A = mkA "lokaliserbar" ; -- lokaliserbar..av.1
  lokaliserbarhet_1_N = mkN "lokaliserbarhet" ; -- lokaliserbarhet..nn.1
  lokalisering_1_N = mkN "lokalisering" ; -- lokalisering..nn.1
  lokaliseringspolitik_1_N = mkN "lokaliseringspolitik" ; -- lokaliseringspolitik..nn.1
  lokaliseringspolitisk_1_A = mkA "lokaliseringspolitisk" ; -- lokaliseringspolitisk..av.1
  lokaliseringsstöd_1_N = mkN "lokaliseringsstöd" neutrum  ; -- lokaliseringsstöd..nn.1
  lokalitet_1_N = mkN "lokalitet" "lokaliteter" ; -- lokalitet..nn.1
  lokalkontor_1_N = mkN "lokalkontor" neutrum  ; -- lokalkontor..nn.1
  lokalkännedom_1_N = mkN "lokalkännedom" ; -- lokalkännedom..nn.1
  lokalmässig_1_A = mkA "lokalmässig" ; -- lokalmässig..av.1
  lokalombud_1_N = mkN "lokalombud" neutrum  ; -- lokalombud..nn.1
  lokalpatriot_1_N = mkN "lokalpatriot" "lokalpatrioter" ; -- lokalpatriot..nn.1
  lokalpatriotisk_1_A = mkA "lokalpatriotisk" ; -- lokalpatriotisk..av.1
  lokalpatriotism_1_N = mkN "lokalpatriotism" ; -- lokalpatriotism..nn.1
  lokalpolitik_1_N = mkN "lokalpolitik" ; -- lokalpolitik..nn.1
  lokalpolitiker_1_N = mkN "lokalpolitiker" "lokalpolitikern" "lokalpolitiker" "lokalpolitikerna" ; -- lokalpolitiker..nn.1
  lokalpolitisk_1_A = mkA "lokalpolitisk" ; -- lokalpolitisk..av.1
  lokalpress_1_N = mkN "lokalpress" ; -- lokalpress..nn.1
  lokalradio_1_N = mkN "lokalradio" ; -- lokalradio..nn.1
  lokalredaktör_1_N = mkN "lokalredaktör" "lokalredaktörer" ; -- lokalredaktör..nn.1
  lokalsamhälle_1_N = mkN "lokalsamhälle" ; -- lokalsamhälle..nn.1
  lokalsamtal_1_N = mkN "lokalsamtal" neutrum  ; -- lokalsamtal..nn.1
  lokalsinne_1_N = mkN "lokalsinne" ; -- lokalsinne..nn.1
  lokaltelefon_1_N = mkN "lokaltelefon" "lokaltelefoner" ; -- lokaltelefon..nn.1
  lokaltid_1_N = mkN "lokaltid" "lokaltider" ; -- lokaltid..nn.1
  lokaltidning_1_N = mkN "lokaltidning" ; -- lokaltidning..nn.1
  lokaltrafik_1_N = mkN "lokaltrafik" ; -- lokaltrafik..nn.1
  lokaltåg_1_N = mkN "lokaltåg" neutrum  ; -- lokaltåg..nn.1
  lokalvård_1_N = mkN "lokalvård" ; -- lokalvård..nn.1
  lokalvårdare_1_N = mkN "lokalvårdare" utrum  ; -- lokalvårdare..nn.1
  lokativ_1_N = mkN "lokativ" "lokativer" ; -- lokativ..nn.1
  lokatt_1_N = mkN "lokatt" "lokatter" ; -- lokatt..nn.1
  lokförare_1_N = mkN "lokförare" utrum  ; -- lokförare..nn.1
  lokomobil_1_N = mkN "lokomobil" "lokomobiler" ; -- lokomobil..nn.1
  lokomotiv_1_N = mkN "lokomotiv" neutrum  ; -- lokomotiv..nn.1
  lokomotor_1_N = mkN "lokomotor" "lokomotorer" ; -- lokomotor..nn.1
  lokus_1_N = mkN "lokus" neutrum  ; -- lokus..nn.1
  lolla_1_N = mkN "lolla" ; -- lolla..nn.1
  lom_1_N = mkN "lom" "lommen" "lommar" "lommarna" ; -- lom..nn.1
  loma_1_V = mkV "lomar" ; -- loma..vb.1
  lomande_1_N = mkN "lomande" ; -- lomande..nn.1
  lomhörd_1_A = mkA "lomhörd" "lomhört" ; -- lomhörd..av.1
  lomhördhet_1_N = mkN "lomhördhet" ; -- lomhördhet..nn.1
  lomma_1_V = mkV "lommar" ; -- lomma..vb.1
  lommande_1_N = mkN "lommande" ; -- lommande..nn.1
  lomme_1_N = mkN "lomme" utrum  ; -- lomme..nn.1
  longitud_1_N = mkN "longitud" "longituder" ; -- longitud..nn.1
  longitudgrad_1_N = mkN "longitudgrad" "longitudgrader" ; -- longitudgrad..nn.1
  longitudinal_1_A = mkA "longitudinal" ; -- longitudinal..av.1
  longitudinell_1_A = mkA "longitudinell" ; -- longitudinell..av.1
  longör_1_N = mkN "longör" "longörer" ; -- longör..nn.1
  look_1_N = mkN "look" ; -- look..nn.1
  loop_1_N = mkN "loop" ; -- loop..nn.1
  looping_1_N = mkN "looping" ; -- looping..nn.1
  loping_1_N = mkN "loping" ; -- loping..nn.1
  lopp_1_N = mkN "lopp" neutrum  ; -- lopp..nn.1
  loppa_1_N = mkN "loppa" ; -- loppa..nn.1
  loppa_1_V = mkV "loppar" ; -- loppa..vb.1
  loppande_1_N = mkN "loppande" ; -- loppande..nn.1
  loppcirkus_1_N = mkN "loppcirkus" ; -- loppcirkus..nn.1
  loppforskare_1_N = mkN "loppforskare" utrum  ; -- loppforskare..nn.1
  loppig_1_A = mkA "loppig" ; -- loppig..av.1
  loppis_1_N = mkN "loppis" ; -- loppis..nn.1
  loppisfynd_1_N = mkN "loppisfynd" neutrum  ; -- loppisfynd..nn.1
  loppmarknad_1_N = mkN "loppmarknad" "loppmarknader" ; -- loppmarknad..nn.1
  loppspel_1_N = mkN "loppspel" "loppspelet" "loppspel" "loppspelen" ; -- loppspel..nn.1
  loran_1_N = mkN "loran" ; -- loran..nn.1
  lord_1_N = mkN "lord" "lorder" ; -- lord..nn.1
  lordkansler_1_N = mkN "lordkansler" ; -- lordkansler..nn.1
  lornjett_1_N = mkN "lornjett" "lornjetter" ; -- lornjett..nn.1
  lort_1_N = mkN "lort" ; -- lort..nn.1
  lortig_1_A = mkA "lortig" ; -- lortig..av.1
  lortighet_1_N = mkN "lortighet" ; -- lortighet..nn.1
  loser_1_N = mkN "loser" "losern" "losers" "losersarna" ; -- loser..nn.1
  loserstil_1_N = mkN "loserstil" ; -- loserstil..nn.1
  loservärld_1_N = mkN "loservärld" ; -- loservärld..nn.1
  loska_1_N = mkN "loska" ; -- loska..nn.1
  loska_1_V = mkV "loskar" ; -- loska..vb.1
  loskande_1_N = mkN "loskande" ; -- loskande..nn.1
  loss_1_A = mkA "loss" ; -- loss..av.1
  lossa_1_V = mkV "lossar" ; -- lossa..vb.1
  lossande_1_N = mkN "lossande" ; -- lossande..nn.1
  losskastning_1_N = mkN "losskastning" ; -- losskastning..nn.1
  lossliten_1_A = mkA "lossliten" ; -- lossliten..av.1
  lossna_1_V = mkV "lossnar" ; -- lossna..vb.1
  lossnande_1_N = mkN "lossnande" ; -- lossnande..nn.1
  lossning_1_N = mkN "lossning" ; -- lossning..nn.1
  lossningskaj_1_N = mkN "lossningskaj" "lossningskajer" ; -- lossningskaj..nn.1
  lossningsplats_1_N = mkN "lossningsplats" "lossningsplatser" ; -- lossningsplats..nn.1
  losta_1_N = mkN "losta" ; -- losta..nn.1
  lots_1_N = mkN "lots" ; -- lots..nn.1
  lotsa_1_V = mkV "lotsar" ; -- lotsa..vb.1
  lotsande_1_N = mkN "lotsande" ; -- lotsande..nn.1
  lotsbåt_1_N = mkN "lotsbåt" ; -- lotsbåt..nn.1
  lotsdistrikt_1_N = mkN "lotsdistrikt" neutrum  ; -- lotsdistrikt..nn.1
  lotsfartyg_1_N = mkN "lotsfartyg" neutrum  ; -- lotsfartyg..nn.1
  lotshjälp_1_N = mkN "lotshjälp" ; -- lotshjälp..nn.1
  lotsled_1_N = mkN "lotsled" "lotsleder" ; -- lotsled..nn.1
  lotsning_1_N = mkN "lotsning" ; -- lotsning..nn.1
  lotsplats_1_N = mkN "lotsplats" "lotsplatser" ; -- lotsplats..nn.1
  lotsplikt_1_N = mkN "lotsplikt" ; -- lotsplikt..nn.1
  lotssignal_1_N = mkN "lotssignal" "lotssignaler" ; -- lotssignal..nn.1
  lott_1_N = mkN "lott" "lotter" ; -- lott..nn.1
  lotta_1_N = mkN "lotta" ; -- lotta..nn.1
  lotta_1_V = mkV "lottar" ; -- lotta..vb.1
  lottad_1_A = mkA "lottad" ; -- lottad..av.1
  lottakår_1_N = mkN "lottakår" "lottakårer" ; -- lottakår..nn.1
  lottande_1_N = mkN "lottande" ; -- lottande..nn.1
  lottarörelse_1_N = mkN "lottarörelse" "lottarörelser" ; -- lottarörelse..nn.1
  lottdragning_1_N = mkN "lottdragning" ; -- lottdragning..nn.1
  lotteri_1_N = mkN "lotteri" "lotteriet" "lotterier" "lotterierna" ; -- lotteri..nn.1
  lotterivinnare_1_N = mkN "lotterivinnare" utrum  ; -- lotterivinnare..nn.1
  lottlös_1_A = mkA "lottlös" ; -- lottlös..av.1
  lottlöshet_1_N = mkN "lottlöshet" ; -- lottlöshet..nn.1
  lottning_1_N = mkN "lottning" ; -- lottning..nn.1
  lottovinst_1_N = mkN "lottovinst" "lottovinster" ; -- lottovinst..nn.1
  lottsedel_1_N = mkN "lottsedel" ; -- lottsedel..nn.1
  lotus_1_N = mkN "lotus" ; -- lotus..nn.1
  lotusställning_1_N = mkN "lotusställning" ; -- lotusställning..nn.1
  lotusätare_1_N = mkN "lotusätare" utrum  ; -- lotusätare..nn.1
  lounge_1_N = mkN "lounge" "lounger" ; -- lounge..nn.1
  lov_1_N = mkN "lov" ; -- lov..nn.1
  lov_2_N = mkN "lov" ; -- lov..nn.2
  lov_3_N = mkN "lov" neutrum  ; -- lov..nn.3
  lov_4_N = mkN "lov" neutrum  ; -- lov..nn.4
  lova_1_V = mkV "lovar" ; -- lova..vb.1
  lova_2_V = mkV "lovar" ; -- lova..vb.2
  lovande_1_A = mkA "lovande" ; -- lovande..av.1
  lovande_1_N = mkN "lovande" ; -- lovande..nn.1
  lovart_1_N = mkN "lovart" ; -- lovart..nn.1
  lovartsida_1_N = mkN "lovartsida" ; -- lovartsida..nn.1
  lovdag_1_N = mkN "lovdag" ; -- lovdag..nn.1
  love_1_N = mkN "love" utrum  ; -- love..nn.1
  lovgirig_1_A = mkA "lovgirig" ; -- lovgirig..av.1
  lovgirighet_1_N = mkN "lovgirighet" ; -- lovgirighet..nn.1
  lovlig_1_A = mkA "lovlig" ; -- lovlig..av.1
  lovlighet_1_N = mkN "lovlighet" ; -- lovlighet..nn.1
  lovning_1_N = mkN "lovning" ; -- lovning..nn.1
  lovord_1_N = mkN "lovord" neutrum  ; -- lovord..nn.1
  lovorda_1_V = mkV "lovordar" ; -- lovorda..vb.1
  lovordande_1_N = mkN "lovordande" ; -- lovordande..nn.1
  lovprisa_1_V = mkV "lovprisar" ; -- lovprisa..vb.1
  lovprisande_1_N = mkN "lovprisande" ; -- lovprisande..nn.1
  lovpsalm_1_N = mkN "lovpsalm" "lovpsalmer" ; -- lovpsalm..nn.1
  lovsjunga_1_V = mkV "lovsjunga" "lovsjöng" "lovsjungit" ; -- lovsjunga..vb.1
  lovsjungande_1_N = mkN "lovsjungande" ; -- lovsjungande..nn.1
  lovsång_1_N = mkN "lovsång" "lovsånger" ; -- lovsång..nn.1
  lovtal_1_N = mkN "lovtal" neutrum  ; -- lovtal..nn.1
  lovtid_1_N = mkN "lovtid" "lovtider" ; -- lovtid..nn.1
  lovvärd_1_A = mkA "lovvärd" "lovvärt" ; -- lovvärd..av.1
  lovvärdhet_1_N = mkN "lovvärdhet" ; -- lovvärdhet..nn.1
  loxodrom_1_N = mkN "loxodrom" "loxodromer" ; -- loxodrom..nn.1
  lubb_1_N = mkN "lubb" ; -- lubb..nn.1
  lubba_1_V = mkV "lubbar" ; -- lubba..vb.1
  lubbande_1_N = mkN "lubbande" ; -- lubbande..nn.1
  lubrikator_1_N = mkN "lubrikator" "lubrikatorer" ; -- lubrikator..nn.1
  lucia_1_N = mkN "lucia" ; -- lucia..nn.1
  lucia_2_N = mkN "lucia" ; -- lucia..nn.2
  luciafest_1_N = mkN "luciafest" "luciafester" ; -- luciafest..nn.1
  luciakrans_1_N = mkN "luciakrans" ; -- luciakrans..nn.1
  luciakrona_1_N = mkN "luciakrona" ; -- luciakrona..nn.1
  luciamorgon_1_N = mkN "luciamorgon" "luciamorgonen" "luciamornar" "luciamornarna" ; -- luciamorgon..nn.1
  luciasång_1_N = mkN "luciasång" "luciasånger" ; -- luciasång..nn.1
  luciatåg_1_N = mkN "luciatåg" neutrum  ; -- luciatåg..nn.1
  lucka_1_N = mkN "lucka" ; -- lucka..nn.1
  lucker_1_A = mkA "lucker" ; -- lucker..av.1
  luckerhet_1_N = mkN "luckerhet" ; -- luckerhet..nn.1
  luckra_1_V = mkV "luckrar" ; -- luckra..vb.1
  luckrande_1_N = mkN "luckrande" ; -- luckrande..nn.1
  lucköppning_1_N = mkN "lucköppning" ; -- lucköppning..nn.1
  ludd_1_N = mkN "ludd" ; -- ludd..nn.1
  ludda_1_V = mkV "luddar" ; -- ludda..vb.1
  luddande_1_N = mkN "luddande" ; -- luddande..nn.1
  luddbråk_1_N = mkN "luddbråk" neutrum  ; -- luddbråk..nn.1
  luddfri_1_A = mkA "luddfri" "luddfritt" ; -- luddfri..av.1
  luddig_1_A = mkA "luddig" ; -- luddig..av.1
  luddighet_1_N = mkN "luddighet" "luddigheter" ; -- luddighet..nn.1
  luden_1_A = mkA "luden" ; -- luden..av.1
  ludenhet_1_N = mkN "ludenhet" ; -- ludenhet..nn.1
  luder_1_N = mkN "luder" neutrum  ; -- luder..nn.1
  ludlow_1_N = mkN "ludlow" ; -- ludlow..nn.1
  lues_1_N = mkN "lues" ; -- lues..nn.1
  luetisk_1_A = mkA "luetisk" ; -- luetisk..av.1
  luff_1_N = mkN "luff" ; -- luff..nn.1
  luffa_1_V = mkV "luffar" ; -- luffa..vb.1
  luffa_2_V = mkV "luffar" ; -- luffa..vb.2
  luffande_1_N = mkN "luffande" ; -- luffande..nn.1
  luffaransikte_1_N = mkN "luffaransikte" ; -- luffaransikte..nn.1
  luffare_1_N = mkN "luffare" utrum  ; -- luffare..nn.1
  luffarschack_1_N = mkN "luffarschack" neutrum  ; -- luffarschack..nn.1
  lufsa_1_V = mkV "lufsar" ; -- lufsa..vb.1
  lufsande_1_N = mkN "lufsande" ; -- lufsande..nn.1
  lufsig_1_A = mkA "lufsig" ; -- lufsig..av.1
  lufsighet_1_N = mkN "lufsighet" ; -- lufsighet..nn.1
  luft_1_N = mkN "luft" ; -- luft..nn.1
  luft_2_N = mkN "luft" "lufter" ; -- luft..nn.2
  lufta_1_V = mkV "luftar" ; -- lufta..vb.1
  luftaffär_1_N = mkN "luftaffär" "luftaffärer" ; -- luftaffär..nn.1
  luftakrobat_1_N = mkN "luftakrobat" "luftakrobater" ; -- luftakrobat..nn.1
  luftande_1_N = mkN "luftande" utrum  ; -- luftande..nn.1
  luftande_2_N = mkN "luftande" ; -- luftande..nn.2
  luftanfall_1_N = mkN "luftanfall" neutrum  ; -- luftanfall..nn.1
  luftattack_1_N = mkN "luftattack" "luftattacker" ; -- luftattack..nn.1
  luftballong_1_N = mkN "luftballong" "luftballonger" ; -- luftballong..nn.1
  luftbevakning_1_N = mkN "luftbevakning" ; -- luftbevakning..nn.1
  luftblåsa_1_N = mkN "luftblåsa" ; -- luftblåsa..nn.1
  luftboll_1_N = mkN "luftboll" ; -- luftboll..nn.1
  luftbro_1_N = mkN "luftbro" ; -- luftbro..nn.1
  luftbubbla_1_N = mkN "luftbubbla" ; -- luftbubbla..nn.1
  luftburen_1_A = mkA "luftburen" ; -- luftburen..av.1
  luftbössa_1_N = mkN "luftbössa" ; -- luftbössa..nn.1
  luftdrag_1_N = mkN "luftdrag" neutrum  ; -- luftdrag..nn.1
  luftemboli_1_N = mkN "luftemboli" "luftembolier" ; -- luftemboli..nn.1
  luftfarande_1_A = mkA "luftfarande" ; -- luftfarande..av.1
  luftfarkost_1_N = mkN "luftfarkost" "luftfarkoster" ; -- luftfarkost..nn.1
  luftfart_1_N = mkN "luftfart" ; -- luftfart..nn.1
  luftfartsmyndighet_1_N = mkN "luftfartsmyndighet" "luftfartsmyndigheter" ; -- luftfartsmyndighet..nn.1
  luftfartssabotage_1_N = mkN "luftfartssabotage" "luftfartssabotaget" "luftfartssabotage" "luftfartssabotagen" ; -- luftfartssabotage..nn.1
  luftfartyg_1_N = mkN "luftfartyg" neutrum  ; -- luftfartyg..nn.1
  luftfilter_1_N = mkN "luftfilter" neutrum  ; -- luftfilter..nn.1
  luftfjädring_1_N = mkN "luftfjädring" ; -- luftfjädring..nn.1
  luftflotta_1_N = mkN "luftflotta" ; -- luftflotta..nn.1
  luftfuktare_1_N = mkN "luftfuktare" utrum  ; -- luftfuktare..nn.1
  luftfuktighet_1_N = mkN "luftfuktighet" "luftfuktigheter" ; -- luftfuktighet..nn.1
  luftfärd_1_N = mkN "luftfärd" "luftfärder" ; -- luftfärd..nn.1
  luftförorening_1_N = mkN "luftförorening" ; -- luftförorening..nn.1
  luftförsvar_1_N = mkN "luftförsvar" neutrum  ; -- luftförsvar..nn.1
  luftgap_1_N = mkN "luftgap" neutrum  ; -- luftgap..nn.1
  luftgevär_1_N = mkN "luftgevär" neutrum  ; -- luftgevär..nn.1
  luftgevärsskjutning_1_N = mkN "luftgevärsskjutning" ; -- luftgevärsskjutning..nn.1
  luftgrop_1_N = mkN "luftgrop" ; -- luftgrop..nn.1
  luftgummihjul_1_N = mkN "luftgummihjul" neutrum  ; -- luftgummihjul..nn.1
  lufthav_1_N = mkN "lufthav" neutrum  ; -- lufthav..nn.1
  luftherravälde_1_N = mkN "luftherravälde" ; -- luftherravälde..nn.1
  lufthärdande_1_A = mkA "lufthärdande" ; -- lufthärdande..av.1
  lufthål_1_N = mkN "lufthål" neutrum  ; -- lufthål..nn.1
  luftig_1_A = mkA "luftig" ; -- luftig..av.1
  luftighet_1_N = mkN "luftighet" "luftigheter" ; -- luftighet..nn.1
  luftkompressor_1_N = mkN "luftkompressor" "luftkompressorer" ; -- luftkompressor..nn.1
  luftkonditionerad_1_A = mkA "luftkonditionerad" ; -- luftkonditionerad..av.1
  luftkonditionering_1_N = mkN "luftkonditionering" ; -- luftkonditionering..nn.1
  luftkonditioneringsapparat_1_N = mkN "luftkonditioneringsapparat" "luftkonditioneringsapparater" ; -- luftkonditioneringsapparat..nn.1
  luftkonditioneringssystem_1_N = mkN "luftkonditioneringssystem" neutrum  ; -- luftkonditioneringssystem..nn.1
  luftkub_1_N = mkN "luftkub" "luftkuber" ; -- luftkub..nn.1
  luftkudde_1_N = mkN "luftkudde" utrum  ; -- luftkudde..nn.1
  luftkuddefarkost_1_N = mkN "luftkuddefarkost" "luftkuddefarkoster" ; -- luftkuddefarkost..nn.1
  luftkvalitet_1_N = mkN "luftkvalitet" "luftkvaliteter" ; -- luftkvalitet..nn.1
  luftkyld_1_A = mkA "luftkyld" "luftkylt" ; -- luftkyld..av.1
  luftlager_1_N = mkN "luftlager" neutrum  ; -- luftlager..nn.1
  luftlandsätta_1_V = mkV "luftlandsätta" "luftlandsätter" "luftlandsätt" "luftlandsatte" "luftlandsatt" "luftlandsatt" ; -- luftlandsätta..vb.1
  luftlandsättande_1_N = mkN "luftlandsättande" ; -- luftlandsättande..nn.1
  luftled_1_N = mkN "luftled" "luftleder" ; -- luftled..nn.1
  luftledes_1_Adv = mkAdv "luftledes" ; -- luftledes..ab.1
  luftledning_1_N = mkN "luftledning" ; -- luftledning..nn.1
  luftmadrass_1_N = mkN "luftmadrass" "luftmadrasser" ; -- luftmadrass..nn.1
  luftmaska_1_N = mkN "luftmaska" ; -- luftmaska..nn.1
  luftmassa_1_N = mkN "luftmassa" ; -- luftmassa..nn.1
  luftmast_1_N = mkN "luftmast" "luftmaster" ; -- luftmast..nn.1
  luftmotstånd_1_N = mkN "luftmotstånd" neutrum  ; -- luftmotstånd..nn.1
  luftmängd_1_N = mkN "luftmängd" "luftmängder" ; -- luftmängd..nn.1
  luftning_1_N = mkN "luftning" ; -- luftning..nn.1
  luftombyte_1_N = mkN "luftombyte" ; -- luftombyte..nn.1
  luftperspektiv_1_N = mkN "luftperspektiv" neutrum  ; -- luftperspektiv..nn.1
  luftpistol_1_N = mkN "luftpistol" "luftpistoler" ; -- luftpistol..nn.1
  luftpistolset_1_N = mkN "luftpistolset" neutrum  ; -- luftpistolset..nn.1
  luftpistolsset_1_N = mkN "luftpistolsset" neutrum  ; -- luftpistolsset..nn.1
  luftpost_1_N = mkN "luftpost" ; -- luftpost..nn.1
  luftpropeller_1_N = mkN "luftpropeller" ; -- luftpropeller..nn.1
  luftpump_1_N = mkN "luftpump" ; -- luftpump..nn.1
  luftpuss_1_N = mkN "luftpuss" ; -- luftpuss..nn.1
  luftrenare_1_N = mkN "luftrenare" utrum  ; -- luftrenare..nn.1
  luftrot_1_N = mkN "luftrot" "luftrötter" ; -- luftrot..nn.1
  luftrum_1_N = mkN "luftrum" "luftrummet" "luftrum" "luftrummen" ; -- luftrum..nn.1
  luftrumsring_1_N = mkN "luftrumsring" ; -- luftrumsring..nn.1
  luftrör_1_N = mkN "luftrör" neutrum  ; -- luftrör..nn.1
  luftrörskatarr_1_N = mkN "luftrörskatarr" "luftrörskatarrer" ; -- luftrörskatarr..nn.1
  luftsabotage_1_N = mkN "luftsabotage" "luftsabotaget" "luftsabotage" "luftsabotagen" ; -- luftsabotage..nn.1
  luftskalle_1_N = mkN "luftskalle" utrum  ; -- luftskalle..nn.1
  luftskepp_1_N = mkN "luftskepp" neutrum  ; -- luftskepp..nn.1
  luftskikt_1_N = mkN "luftskikt" neutrum  ; -- luftskikt..nn.1
  luftskytte_1_N = mkN "luftskytte" ; -- luftskytte..nn.1
  luftslott_1_N = mkN "luftslott" neutrum  ; -- luftslott..nn.1
  luftsluss_1_N = mkN "luftsluss" ; -- luftsluss..nn.1
  luftsmörjare_1_N = mkN "luftsmörjare" utrum  ; -- luftsmörjare..nn.1
  luftspärr_1_N = mkN "luftspärr" ; -- luftspärr..nn.1
  luftstreck_1_N = mkN "luftstreck" neutrum  ; -- luftstreck..nn.1
  luftstrupe_1_N = mkN "luftstrupe" utrum  ; -- luftstrupe..nn.1
  luftström_1_N = mkN "luftström" "luftströmmen" "luftströmmar" "luftströmmarna" ; -- luftström..nn.1
  luftsäck_1_N = mkN "luftsäck" ; -- luftsäck..nn.1
  lufttemperatur_1_N = mkN "lufttemperatur" "lufttemperaturer" ; -- lufttemperatur..nn.1
  lufttillförsel_1_N = mkN "lufttillförsel" ; -- lufttillförsel..nn.1
  lufttom_1_A = mkA "lufttom" "lufttomt" "lufttomma" "lufttomma" "lufttommare" "lufttommast" "lufttommaste" ; -- lufttom..av.1
  lufttomhet_1_N = mkN "lufttomhet" ; -- lufttomhet..nn.1
  lufttorka_1_V = mkV "lufttorkar" ; -- lufttorka..vb.1
  lufttorkande_1_N = mkN "lufttorkande" ; -- lufttorkande..nn.1
  lufttransport_1_N = mkN "lufttransport" "lufttransporter" ; -- lufttransport..nn.1
  lufttrumma_1_N = mkN "lufttrumma" ; -- lufttrumma..nn.1
  lufttryck_1_N = mkN "lufttryck" neutrum  ; -- lufttryck..nn.1
  lufttrycksförändring_1_N = mkN "lufttrycksförändring" ; -- lufttrycksförändring..nn.1
  lufttrycksmätare_1_N = mkN "lufttrycksmätare" utrum  ; -- lufttrycksmätare..nn.1
  lufttät_1_A = mkA "lufttät" ; -- lufttät..av.1
  lufttäthet_1_N = mkN "lufttäthet" ; -- lufttäthet..nn.1
  luftvapen_1_N = mkN "luftvapen" "luftvapnet" "luftvapen" "luftvapnen" ; -- luftvapen..nn.1
  luftvapenkula_1_N = mkN "luftvapenkula" ; -- luftvapenkula..nn.1
  luftventil_1_N = mkN "luftventil" "luftventiler" ; -- luftventil..nn.1
  luftväg_1_N = mkN "luftväg" ; -- luftväg..nn.1
  luftvägsinfektion_1_N = mkN "luftvägsinfektion" ; -- luftvägsinfektion..nn.1
  luftvärmepump_1_N = mkN "luftvärmepump" ; -- luftvärmepump..nn.1
  luftvärn_1_N = mkN "luftvärn" neutrum  ; -- luftvärn..nn.1
  luftvärnseld_1_N = mkN "luftvärnseld" ; -- luftvärnseld..nn.1
  luftvärnskanon_1_N = mkN "luftvärnskanon" "luftvärnskanoner" ; -- luftvärnskanon..nn.1
  luftvärnsrobot_1_N = mkN "luftvärnsrobot" ; -- luftvärnsrobot..nn.1
  luftväxling_1_N = mkN "luftväxling" ; -- luftväxling..nn.1
  luftvåg_1_N = mkN "luftvåg" "luftvågor" ; -- luftvåg..nn.1
  lugg_1_N = mkN "lugg" ; -- lugg..nn.1
  lugg_2_N = mkN "lugg" ; -- lugg..nn.2
  lugga_1_V = mkV "luggar" ; -- lugga..vb.1
  luggande_1_N = mkN "luggande" ; -- luggande..nn.1
  luggig_1_A = mkA "luggig" ; -- luggig..av.1
  luggighet_1_N = mkN "luggighet" ; -- luggighet..nn.1
  luggsliten_1_A = mkA "luggsliten" ; -- luggsliten..av.1
  luggslitenhet_1_N = mkN "luggslitenhet" ; -- luggslitenhet..nn.1
  lugn_1_A = mkA "lugn" ; -- lugn..av.1
  lugn_1_N = mkN "lugn" neutrum  ; -- lugn..nn.1
  lugna_1_V = mkV "lugnar" ; -- lugna..vb.1
  lugnande_1_A = mkA "lugnande" ; -- lugnande..av.1
  lugnande_1_N = mkN "lugnande" ; -- lugnande..nn.1
  lugnhet_1_N = mkN "lugnhet" ; -- lugnhet..nn.1
  lugnvatten_1_N = mkN "lugnvatten" "lugnvattnet" "lugnvatten" "lugnvattnen" ; -- lugnvatten..nn.1
  lugnväder_1_N = mkN "lugnväder" neutrum  ; -- lugnväder..nn.1
  luguber_1_A = mkA "luguber" ; -- luguber..av.1
  lukrativ_1_A = mkA "lukrativ" ; -- lukrativ..av.1
  lukt_1_N = mkN "lukt" "lukter" ; -- lukt..nn.1
  lukta_1_V = mkV "luktar" ; -- lukta..vb.1
  lukta_2_V = mkV "luktar" ; -- lukta..vb.2
  luktande_1_N = mkN "luktande" ; -- luktande..nn.1
  luktborttagare_1_N = mkN "luktborttagare" utrum  ; -- luktborttagare..nn.1
  luktflaska_1_N = mkN "luktflaska" ; -- luktflaska..nn.1
  luktfri_1_A = mkA "luktfri" "luktfritt" ; -- luktfri..av.1
  luktfrihet_1_N = mkN "luktfrihet" ; -- luktfrihet..nn.1
  luktlös_1_A = mkA "luktlös" ; -- luktlös..av.1
  luktlöshet_1_N = mkN "luktlöshet" ; -- luktlöshet..nn.1
  luktnerv_1_N = mkN "luktnerv" "luktnerver" ; -- luktnerv..nn.1
  luktorgan_1_N = mkN "luktorgan" neutrum  ; -- luktorgan..nn.1
  luktsalt_1_N = mkN "luktsalt" neutrum  ; -- luktsalt..nn.1
  luktsinne_1_N = mkN "luktsinne" ; -- luktsinne..nn.1
  luktsvag_1_A = mkA "luktsvag" ; -- luktsvag..av.1
  luktsvaghet_1_N = mkN "luktsvaghet" ; -- luktsvaghet..nn.1
  luktvatten_1_N = mkN "luktvatten" "luktvattnet" "luktvatten" "luktvattnen" ; -- luktvatten..nn.1
  luktvial_1_N = mkN "luktvial" "luktvialer" ; -- luktvial..nn.1
  luktviol_1_N = mkN "luktviol" "luktvioler" ; -- luktviol..nn.1
  luktärt_1_N = mkN "luktärt" "luktärter" ; -- luktärt..nn.1
  lukullisk_1_A = mkA "lukullisk" ; -- lukullisk..av.1
  lulebo_1_N = mkN "lulebo" "lulebor" ; -- lulebo..nn.1
  luleåbo_1_N = mkN "luleåbo" "luleåbor" ; -- luleåbo..nn.1
  lulla_1_V = mkV "lullar" ; -- lulla..vb.1
  lulla_2_V = mkV "lullar" ; -- lulla..vb.2
  lullande_1_N = mkN "lullande" ; -- lullande..nn.1
  lullig_1_A = mkA "lullig" ; -- lullig..av.1
  lullighet_1_N = mkN "lullighet" ; -- lullighet..nn.1
  lullull_1_N = mkN "lullull" neutrum  ; -- lullull..nn.1
  luma_1_N = mkN "luma" ; -- luma..nn.1
  lumbago_1_N = mkN "lumbago" ; -- lumbago..nn.1
  lumbal_1_A = mkA "lumbal" ; -- lumbal..av.1
  lumbalbedövning_1_N = mkN "lumbalbedövning" ; -- lumbalbedövning..nn.1
  lumbalpunktion_1_N = mkN "lumbalpunktion" ; -- lumbalpunktion..nn.1
  lumberjacka_1_N = mkN "lumberjacka" ; -- lumberjacka..nn.1
  lumen_1_N = mkN "lumen" "lumenen" "lumen" "lumenen" ; -- lumen..nn.1
  lumen_2_N = mkN "lumen" neutrum  ; -- lumen..nn.2
  luminiscens_1_N = mkN "luminiscens" ; -- luminiscens..nn.1
  luminös_1_A = mkA "luminös" ; -- luminös..av.1
  lummerväxt_1_N = mkN "lummerväxt" "lummerväxter" ; -- lummerväxt..nn.1
  lummig_1_A = mkA "lummig" ; -- lummig..av.1
  lummighet_1_N = mkN "lummighet" ; -- lummighet..nn.1
  lump_1_N = mkN "lump" "lumpor" ; -- lump..nn.1
  lump_2_N = mkN "lump" ; -- lump..nn.2
  lumpa_1_V = mkV "lumpar" ; -- lumpa..vb.1
  lumpande_1_N = mkN "lumpande" ; -- lumpande..nn.1
  lumparkompis_1_N = mkN "lumparkompis" ; -- lumparkompis..nn.1
  lumpbod_1_N = mkN "lumpbod" ; -- lumpbod..nn.1
  lumpen_1_A = mkA "lumpen" ; -- lumpen..av.1
  lumpenhet_1_N = mkN "lumpenhet" ; -- lumpenhet..nn.1
  lumpfisk_1_N = mkN "lumpfisk" ; -- lumpfisk..nn.1
  lumpig_1_A = mkA "lumpig" ; -- lumpig..av.1
  lumpighet_1_N = mkN "lumpighet" ; -- lumpighet..nn.1
  lumppapper_1_N = mkN "lumppapper" neutrum  ; -- lumppapper..nn.1
  lumpull_1_N = mkN "lumpull" ; -- lumpull..nn.1
  lunar_1_A = mkA "lunar" ; -- lunar..av.1
  lunarisk_1_A = mkA "lunarisk" ; -- lunarisk..av.1
  lunation_1_N = mkN "lunation" ; -- lunation..nn.1
  lunch_1_N = mkN "lunch" "luncher" ; -- lunch..nn.1
  luncha_1_V = mkV "lunchar" ; -- luncha..vb.1
  lunchande_1_N = mkN "lunchande" ; -- lunchande..nn.1
  lunchare_1_N = mkN "lunchare" utrum  ; -- lunchare..nn.1
  lunchbord_1_N = mkN "lunchbord" neutrum  ; -- lunchbord..nn.1
  lunchbuffé_1_N = mkN "lunchbuffé" "lunchbufféer" ; -- lunchbuffé..nn.1
  lunchdags_1_N = mkN "lunchdags" ; -- lunchdags..nn.1
  lunchkaffe_1_N = mkN "lunchkaffe" ; -- lunchkaffe..nn.1
  lunchlåda_1_N = mkN "lunchlåda" ; -- lunchlåda..nn.1
  lunchmatsal_1_N = mkN "lunchmatsal" ; -- lunchmatsal..nn.1
  lunchrast_1_N = mkN "lunchrast" "lunchraster" ; -- lunchrast..nn.1
  lunchrestaurang_1_N = mkN "lunchrestaurang" "lunchrestauranger" ; -- lunchrestaurang..nn.1
  lunchrum_1_N = mkN "lunchrum" "lunchrummet" "lunchrum" "lunchrummen" ; -- lunchrum..nn.1
  lunchrusning_1_N = mkN "lunchrusning" ; -- lunchrusning..nn.1
  lunchställe_1_N = mkN "lunchställe" ; -- lunchställe..nn.1
  lunchtid_1_N = mkN "lunchtid" "lunchtider" ; -- lunchtid..nn.1
  lunchtimme_1_N = mkN "lunchtimme" utrum  ; -- lunchtimme..nn.1
  lunchuppehåll_1_N = mkN "lunchuppehåll" neutrum  ; -- lunchuppehåll..nn.1
  lunchvana_1_N = mkN "lunchvana" ; -- lunchvana..nn.1
  lund_1_N = mkN "lund" ; -- lund..nn.1
  lundensisk_1_A = mkA "lundensisk" ; -- lundensisk..av.1
  lunett_1_N = mkN "lunett" "lunetter" ; -- lunett..nn.1
  lunga_1_N = mkN "lunga" ; -- lunga..nn.1
  lungandande_1_A = mkA "lungandande" ; -- lungandande..av.1
  lungblåsa_1_N = mkN "lungblåsa" ; -- lungblåsa..nn.1
  lungbrand_1_N = mkN "lungbrand" ; -- lungbrand..nn.1
  lungbyte_1_N = mkN "lungbyte" ; -- lungbyte..nn.1
  lungcancer_1_N = mkN "lungcancer" ; -- lungcancer..nn.1
  lungemboli_1_N = mkN "lungemboli" "lungembolier" ; -- lungemboli..nn.1
  lungfisk_1_N = mkN "lungfisk" ; -- lungfisk..nn.1
  lunginflammation_1_N = mkN "lunginflammation" ; -- lunginflammation..nn.1
  lungkatarr_1_N = mkN "lungkatarr" "lungkatarrer" ; -- lungkatarr..nn.1
  lungkollaps_1_N = mkN "lungkollaps" "lungkollapser" ; -- lungkollaps..nn.1
  lunglob_1_N = mkN "lunglob" "lunglober" ; -- lunglob..nn.1
  lungmos_1_N = mkN "lungmos" neutrum  ; -- lungmos..nn.1
  lungpaj_1_N = mkN "lungpaj" ; -- lungpaj..nn.1
  lungpulsåder_1_N = mkN "lungpulsådra" ; -- lungpulsåder..nn.1
  lungrot_1_N = mkN "lungrot" "lungrötter" ; -- lungrot..nn.1
  lungröta_1_N = mkN "lungröta" ; -- lungröta..nn.1
  lungsiktig_1_A = mkA "lungsiktig" ; -- lungsiktig..av.1
  lungsjuk_1_A = mkA "lungsjuk" ; -- lungsjuk..av.1
  lungsjuka_1_N = mkN "lungsjuka" ; -- lungsjuka..nn.1
  lungsjukdom_1_N = mkN "lungsjukdom" ; -- lungsjukdom..nn.1
  lungsjukhet_1_N = mkN "lungsjukhet" ; -- lungsjukhet..nn.1
  lungskott_1_N = mkN "lungskott" neutrum  ; -- lungskott..nn.1
  lungsnäcka_1_N = mkN "lungsnäcka" ; -- lungsnäcka..nn.1
  lungsot_1_N = mkN "lungsot" ; -- lungsot..nn.1
  lungsäck_1_N = mkN "lungsäck" ; -- lungsäck..nn.1
  lungsäcksinflammation_1_N = mkN "lungsäcksinflammation" ; -- lungsäcksinflammation..nn.1
  lungtuberkulos_1_N = mkN "lungtuberkulos" ; -- lungtuberkulos..nn.1
  lungvävnad_1_N = mkN "lungvävnad" "lungvävnader" ; -- lungvävnad..nn.1
  lungödem_1_N = mkN "lungödem" neutrum  ; -- lungödem..nn.1
  lungört_1_N = mkN "lungört" "lungörter" ; -- lungört..nn.1
  lunk_1_N = mkN "lunk" ; -- lunk..nn.1
  lunka_1_V = mkV "lunkar" ; -- lunka..vb.1
  lunkande_1_N = mkN "lunkande" ; -- lunkande..nn.1
  lunna_1_V = mkV "lunnar" ; -- lunna..vb.1
  lunnande_1_N = mkN "lunnande" ; -- lunnande..nn.1
  lunne_1_N = mkN "lunne" utrum  ; -- lunne..nn.1
  lunnefågel_1_N = mkN "lunnefågel" ; -- lunnefågel..nn.1
  lunnkälke_1_N = mkN "lunnkälke" utrum  ; -- lunnkälke..nn.1
  luns_1_N = mkN "luns" ; -- luns..nn.1
  lunsig_1_A = mkA "lunsig" ; -- lunsig..av.1
  lunsighet_1_N = mkN "lunsighet" ; -- lunsighet..nn.1
  lunta_1_N = mkN "lunta" ; -- lunta..nn.1
  lunta_1_V = mkV "luntar" ; -- lunta..vb.1
  luntande_1_N = mkN "luntande" ; -- luntande..nn.1
  luntlås_1_N = mkN "luntlås" neutrum  ; -- luntlås..nn.1
  lupin_1_N = mkN "lupin" "lupiner" ; -- lupin..nn.1
  lupp_1_N = mkN "lupp" "lupper" ; -- lupp..nn.1
  lupus_1_N = mkN "lupus" ; -- lupus..nn.1
  lur_1_N = mkN "lur" ; -- lur..nn.1
  lura_1_V = mkV "lurar" ; -- lura..vb.1
  lura_2_V = mkV "lurar" ; -- lura..vb.2
  lurande_1_N = mkN "lurande" ; -- lurande..nn.1
  lurendreja_1_V = mkV "lurendrejar" ; -- lurendreja..vb.1
  lurendrejande_1_N = mkN "lurendrejande" ; -- lurendrejande..nn.1
  lurendrejare_1_N = mkN "lurendrejare" utrum  ; -- lurendrejare..nn.1
  lurendrejeri_1_N = mkN "lurendrejeri" "lurendrejeriet" "lurendrejerier" "lurendrejerierna" ; -- lurendrejeri..nn.1
  lurendrejeritrend_1_N = mkN "lurendrejeritrend" "lurendrejeritrender" ; -- lurendrejeritrend..nn.1
  lurifax_1_N = mkN "lurifax" ; -- lurifax..nn.1
  lurifaxeri_1_N = mkN "lurifaxeri" neutrum  ; -- lurifaxeri..nn.1
  lurig_1_A = mkA "lurig" ; -- lurig..av.1
  lurighet_1_N = mkN "lurighet" "lurigheter" ; -- lurighet..nn.1
  lurk_1_N = mkN "lurk" ; -- lurk..nn.1
  lurpassa_1_V = mkV "lurpassar" ; -- lurpassa..vb.1
  lurpassande_1_N = mkN "lurpassande" ; -- lurpassande..nn.1
  lurpassning_1_N = mkN "lurpassning" ; -- lurpassning..nn.1
  lurvig_1_A = mkA "lurvig" ; -- lurvig..av.1
  lurvighet_1_N = mkN "lurvighet" ; -- lurvighet..nn.1
  lus_1_N = mkN "lus" "lusen" "löss" "lössen" ; -- lus..nn.1
  lusa_1_V = mkV "lusar" ; -- lusa..vb.1
  lusande_1_N = mkN "lusande" ; -- lusande..nn.1
  lusekofta_1_N = mkN "lusekofta" ; -- lusekofta..nn.1
  lusern_1_N = mkN "lusern" ; -- lusern..nn.1
  luserngrönmjöl_1_N = mkN "luserngrönmjöl" neutrum  ; -- luserngrönmjöl..nn.1
  lusfattig_1_A = mkA "lusfattig" ; -- lusfattig..av.1
  lushund_1_N = mkN "lushund" ; -- lushund..nn.1
  lusig_1_A = mkA "lusig" ; -- lusig..av.1
  luska_1_V = mkV "luskar" ; -- luska..vb.1
  luskande_1_N = mkN "luskande" ; -- luskande..nn.1
  luskung_1_N = mkN "luskung" ; -- luskung..nn.1
  lusläsa_1_V = mkV "lusläser" ; -- lusläsa..vb.1
  lusläsande_1_N = mkN "lusläsande" ; -- lusläsande..nn.1
  luspank_1_A = mkA "luspank" ; -- luspank..av.1
  luspankhet_1_N = mkN "luspankhet" ; -- luspankhet..nn.1
  luspudel_1_N = mkN "luspudel" ; -- luspudel..nn.1
  lussa_1_V = mkV "lussar" ; -- lussa..vb.1
  lussande_1_N = mkN "lussande" ; -- lussande..nn.1
  lusse_1_N = mkN "lusse" ; -- lusse..nn.1
  lussebulla_1_N = mkN "lussebulla" ; -- lussebulla..nn.1
  lussebulle_1_N = mkN "lussebulle" utrum  ; -- lussebulle..nn.1
  lussefest_1_N = mkN "lussefest" "lussefester" ; -- lussefest..nn.1
  lussekatt_1_N = mkN "lussekatt" "lussekatter" ; -- lussekatt..nn.1
  lust_1_N = mkN "lust" ; -- lust..nn.1
  lusta_1_N = mkN "lusta" ; -- lusta..nn.1
  lustbarhet_1_N = mkN "lustbarhet" "lustbarheter" ; -- lustbarhet..nn.1
  lustbehov_1_N = mkN "lustbehov" neutrum  ; -- lustbehov..nn.1
  lustbetonad_1_A = mkA "lustbetonad" ; -- lustbetonad..av.1
  lustcentrum_1_N = mkN "lustcentrum" neutrum  ; -- lustcentrum..nn.1
  lustelig_1_A = mkA "lustelig" ; -- lustelig..av.1
  lustelighet_1_N = mkN "lustelighet" ; -- lustelighet..nn.1
  lustfylld_1_A = mkA "lustfylld" "lustfyllt" ; -- lustfylld..av.1
  lustfylldhet_1_N = mkN "lustfylldhet" ; -- lustfylldhet..nn.1
  lustfärd_1_N = mkN "lustfärd" "lustfärder" ; -- lustfärd..nn.1
  lustgas_1_N = mkN "lustgas" "lustgaser" ; -- lustgas..nn.1
  lustgård_1_N = mkN "lustgård" ; -- lustgård..nn.1
  lusthus_1_N = mkN "lusthus" neutrum  ; -- lusthus..nn.1
  lustig_1_A = mkA "lustig" ; -- lustig..av.1
  lustighet_1_N = mkN "lustighet" "lustigheter" ; -- lustighet..nn.1
  lustigkurre_1_N = mkN "lustigkurre" utrum  ; -- lustigkurre..nn.1
  lustimpuls_1_N = mkN "lustimpuls" "lustimpulser" ; -- lustimpuls..nn.1
  lustjakt_1_N = mkN "lustjakt" "lustjakter" ; -- lustjakt..nn.1
  lustkänsla_1_N = mkN "lustkänsla" ; -- lustkänsla..nn.1
  lustlögnare_1_N = mkN "lustlögnare" utrum  ; -- lustlögnare..nn.1
  lustmord_1_N = mkN "lustmord" neutrum  ; -- lustmord..nn.1
  lustmördare_1_N = mkN "lustmördare" utrum  ; -- lustmördare..nn.1
  lustpark_1_N = mkN "lustpark" "lustparker" ; -- lustpark..nn.1
  lustslott_1_N = mkN "lustslott" neutrum  ; -- lustslott..nn.1
  lustspel_1_N = mkN "lustspel" "lustspelet" "lustspel" "lustspelen" ; -- lustspel..nn.1
  lustspelsförfattare_1_N = mkN "lustspelsförfattare" utrum  ; -- lustspelsförfattare..nn.1
  lusttur_1_N = mkN "lusttur" "lustturer" ; -- lusttur..nn.1
  lustupplevelse_1_N = mkN "lustupplevelse" "lustupplevelser" ; -- lustupplevelse..nn.1
  lustvandra_1_V = mkV "lustvandrar" ; -- lustvandra..vb.1
  lustvandrande_1_N = mkN "lustvandrande" ; -- lustvandrande..nn.1
  lustvandrare_1_N = mkN "lustvandrare" utrum  ; -- lustvandrare..nn.1
  lustvandring_1_N = mkN "lustvandring" ; -- lustvandring..nn.1
  lut_1_N = mkN "lut" ; -- lut..nn.1
  lut_2_N = mkN "lut" neutrum  ; -- lut..nn.2
  luta_1_N = mkN "luta" ; -- luta..nn.1
  luta_1_V = mkV "lutar" ; -- luta..vb.1
  luta_2_V = mkV "lutar" ; -- luta..vb.2
  lutande_1_N = mkN "lutande" ; -- lutande..nn.1
  luteinisera_1_V = mkV "luteiniserar" ; -- luteinisera..vb.1
  luteiniserande_1_N = mkN "luteiniserande" ; -- luteiniserande..nn.1
  luteiniserbar_1_A = mkA "luteiniserbar" ; -- luteiniserbar..av.1
  luteiniserbarhet_1_N = mkN "luteiniserbarhet" ; -- luteiniserbarhet..nn.1
  luteinisering_1_N = mkN "luteinisering" ; -- luteinisering..nn.1
  lutetium_1_N = mkN "lutetium" neutrum  ; -- lutetium..nn.1
  lutfisk_1_N = mkN "lutfisk" ; -- lutfisk..nn.1
  lutheran_1_N = mkN "lutheran" "lutheraner" ; -- lutheran..nn.1
  lutheranism_1_N = mkN "lutheranism" "lutheranismer" ; -- lutheranism..nn.1
  lutheransk_1_A = mkA "lutheransk" ; -- lutheransk..av.1
  lutherdom_1_N = mkN "lutherdom" ; -- lutherdom..nn.1
  luthersk_1_A = mkA "luthersk" ; -- luthersk..av.1
  lutning_1_N = mkN "lutning" ; -- lutning..nn.1
  lutningsmätare_1_N = mkN "lutningsmätare" utrum  ; -- lutningsmätare..nn.1
  lutningsstreck_1_N = mkN "lutningsstreck" neutrum  ; -- lutningsstreck..nn.1
  lutningsvariation_1_N = mkN "lutningsvariation" ; -- lutningsvariation..nn.1
  lutningsvinkel_1_N = mkN "lutningsvinkel" ; -- lutningsvinkel..nn.1
  lutspel_1_N = mkN "lutspel" "lutspelet" "lutspel" "lutspelen" ; -- lutspel..nn.1
  lutspelare_1_N = mkN "lutspelare" utrum  ; -- lutspelare..nn.1
  lutsångare_1_N = mkN "lutsångare" utrum  ; -- lutsångare..nn.1
  lutter_1_A = mkA "lutter" ; -- lutter..av.1
  luttra_1_V = mkV "luttrar" ; -- luttra..vb.1
  luttrad_1_A = mkA "luttrad" ; -- luttrad..av.1
  luttrande_1_N = mkN "luttrande" ; -- luttrande..nn.1
  luv_1_N = mkN "luv" ; -- luv..nn.1
  luva_1_N = mkN "luva" ; -- luva..nn.1
  lux_1_N = mkN "lux" "luxen" "lux" "luxen" ; -- lux..nn.1
  luxation_1_N = mkN "luxation" ; -- luxation..nn.1
  luxemburgare_1_N = mkN "luxemburgare" utrum  ; -- luxemburgare..nn.1
  luxemburgsk_1_A = mkA "luxemburgsk" ; -- luxemburgsk..av.1
  luxemburgska_1_N = mkN "luxemburgska" ; -- luxemburgska..nn.1
  luxmeter_1_N = mkN "luxmeter" ; -- luxmeter..nn.1
  luxuös_1_A = mkA "luxuös" ; -- luxuös..av.1
  ly_1_N = mkN "ly" neutrum  ; -- ly..nn.1
  lya_1_N = mkN "lya" ; -- lya..nn.1
  lyceum_1_N = mkN "lyceum" "lyceet" "lyceer" "lyceerna" ; -- lyceum..nn.1
  lycka_1_N = mkN "lycka" ; -- lycka..nn.1
  lycka_2_N = mkN "lycka" ; -- lycka..nn.2
  lyckad_1_A = mkA "lyckad" ; -- lyckad..av.1
  lycklig_1_A = mkA "lycklig" ; -- lycklig..av.1
  lyckligen_1_Adv = mkAdv "lyckligen" ; -- lyckligen..ab.1
  lyckliggöra_1_V = mkV "lyckliggöra" "lyckliggjorde" "lyckliggjort" ; -- lyckliggöra..vb.1
  lyckliggörande_1_N = mkN "lyckliggörande" ; -- lyckliggörande..nn.1
  lycklighet_1_N = mkN "lycklighet" "lyckligheter" ; -- lycklighet..nn.1
  lyckligtvis_1_Adv = mkAdv "lyckligtvis" ; -- lyckligtvis..ab.1
  lyckobringande_1_A = mkA "lyckobringande" ; -- lyckobringande..av.1
  lyckodag_1_N = mkN "lyckodag" ; -- lyckodag..nn.1
  lyckoentreprenör_1_N = mkN "lyckoentreprenör" "lyckoentreprenörer" ; -- lyckoentreprenör..nn.1
  lyckohjul_1_N = mkN "lyckohjul" neutrum  ; -- lyckohjul..nn.1
  lyckokast_1_N = mkN "lyckokast" neutrum  ; -- lyckokast..nn.1
  lyckoklöver_1_N = mkN "lyckoklöver" "lyckoklövern" "lyckoklöver" "lyckoklöverna" ; -- lyckoklöver..nn.1
  lyckokänsla_1_N = mkN "lyckokänsla" ; -- lyckokänsla..nn.1
  lyckopiller_1_N = mkN "lyckopiller" neutrum  ; -- lyckopiller..nn.1
  lyckorecept_1_N = mkN "lyckorecept" neutrum  ; -- lyckorecept..nn.1
  lyckorike_1_N = mkN "lyckorike" ; -- lyckorike..nn.1
  lyckorus_1_N = mkN "lyckorus" neutrum  ; -- lyckorus..nn.1
  lyckosam_1_A = mkA "lyckosam" "lyckosamt" "lyckosamma" "lyckosamma" "lyckosammare" "lyckosammast" "lyckosammaste" ; -- lyckosam..av.1
  lyckosamhet_1_N = mkN "lyckosamhet" ; -- lyckosamhet..nn.1
  lyckoslant_1_N = mkN "lyckoslant" ; -- lyckoslant..nn.1
  lyckost_1_N = mkN "lyckost" ; -- lyckost..nn.1
  lyckostjärna_1_N = mkN "lyckostjärna" ; -- lyckostjärna..nn.1
  lyckotal_1_N = mkN "lyckotal" neutrum  ; -- lyckotal..nn.1
  lyckotripp_1_N = mkN "lyckotripp" ; -- lyckotripp..nn.1
  lyckoår_1_N = mkN "lyckoår" neutrum  ; -- lyckoår..nn.1
  lycksalig_1_A = mkA "lycksalig" ; -- lycksalig..av.1
  lycksaliggöra_1_V = mkV "lycksaliggöra" "lycksaliggjorde" "lycksaliggjort" ; -- lycksaliggöra..vb.1
  lycksaliggörande_1_N = mkN "lycksaliggörande" ; -- lycksaliggörande..nn.1
  lycksalighet_1_N = mkN "lycksalighet" ; -- lycksalighet..nn.1
  lyckskott_1_N = mkN "lyckskott" neutrum  ; -- lyckskott..nn.1
  lycksökare_1_N = mkN "lycksökare" utrum  ; -- lycksökare..nn.1
  lycksökeri_1_N = mkN "lycksökeri" neutrum  ; -- lycksökeri..nn.1
  lyckträff_1_N = mkN "lyckträff" ; -- lyckträff..nn.1
  lyckönska_1_V = mkV "lyckönskar" ; -- lyckönska..vb.1
  lyckönskande_1_N = mkN "lyckönskande" ; -- lyckönskande..nn.1
  lyckönskning_1_N = mkN "lyckönskning" ; -- lyckönskning..nn.1
  lyda_1_V = mkV "lyda" "löd" "lytt" ; -- lyda..vb.1
  lydaktig_1_A = mkA "lydaktig" ; -- lydaktig..av.1
  lydaktighet_1_N = mkN "lydaktighet" ; -- lydaktighet..nn.1
  lydande_1_N = mkN "lydande" ; -- lydande..nn.1
  lydelse_1_N = mkN "lydelse" "lydelser" ; -- lydelse..nn.1
  lydfolk_1_N = mkN "lydfolk" neutrum  ; -- lydfolk..nn.1
  lydfurste_1_N = mkN "lydfurste" utrum  ; -- lydfurste..nn.1
  lydig_1_A = mkA "lydig" ; -- lydig..av.1
  lydkonung_1_N = mkN "lydkonung" ; -- lydkonung..nn.1
  lydkung_1_N = mkN "lydkung" ; -- lydkung..nn.1
  lydnad_1_N = mkN "lydnad" ; -- lydnad..nn.1
  lydnadsbrott_1_N = mkN "lydnadsbrott" neutrum  ; -- lydnadsbrott..nn.1
  lydrike_1_N = mkN "lydrike" ; -- lydrike..nn.1
  lydstat_1_N = mkN "lydstat" "lydstater" ; -- lydstat..nn.1
  lyft_1_N = mkN "lyft" neutrum  ; -- lyft..nn.1
  lyfta_1_V = mkV "lyfta" "lyfter" "lyft" "lyfte" "lyft" "lyft" ; -- lyfta..vb.1
  lyftande_1_N = mkN "lyftande" ; -- lyftande..nn.1
  lyftanordning_1_N = mkN "lyftanordning" ; -- lyftanordning..nn.1
  lyftarm_1_N = mkN "lyftarm" ; -- lyftarm..nn.1
  lyftblock_1_N = mkN "lyftblock" neutrum  ; -- lyftblock..nn.1
  lyftbro_1_N = mkN "lyftbro" ; -- lyftbro..nn.1
  lyfthöjd_1_N = mkN "lyfthöjd" "lyfthöjder" ; -- lyfthöjd..nn.1
  lyftkapacitet_1_N = mkN "lyftkapacitet" "lyftkapaciteter" ; -- lyftkapacitet..nn.1
  lyftkraft_1_N = mkN "lyftkraft" "lyftkrafter" ; -- lyftkraft..nn.1
  lyftkran_1_N = mkN "lyftkran" ; -- lyftkran..nn.1
  lyftkrok_1_N = mkN "lyftkrok" ; -- lyftkrok..nn.1
  lyftmuskel_1_N = mkN "lyftmuskel" "lyftmuskeln" "lyftmuskler" "lyftmusklerna" ; -- lyftmuskel..nn.1
  lyftning_1_N = mkN "lyftning" ; -- lyftning..nn.1
  lyftpunkt_1_N = mkN "lyftpunkt" "lyftpunkter" ; -- lyftpunkt..nn.1
  lyftsax_1_N = mkN "lyftsax" ; -- lyftsax..nn.1
  lyftskydd_1_N = mkN "lyftskydd" neutrum  ; -- lyftskydd..nn.1
  lyftverk_1_N = mkN "lyftverk" neutrum  ; -- lyftverk..nn.1
  lyhörd_1_A = mkA "lyhörd" "lyhört" ; -- lyhörd..av.1
  lyhördhet_1_N = mkN "lyhördhet" ; -- lyhördhet..nn.1
  lykta_1_N = mkN "lykta" ; -- lykta..nn.1
  lykta_1_V = mkV "lyktar" ; -- lykta..vb.1
  lyktande_1_N = mkN "lyktande" ; -- lyktande..nn.1
  lyktbär_1_N = mkN "lyktbär" neutrum  ; -- lyktbär..nn.1
  lyktbärare_1_N = mkN "lyktbärare" utrum  ; -- lyktbärare..nn.1
  lyktglas_1_N = mkN "lyktglas" neutrum  ; -- lyktglas..nn.1
  lyktgubbe_1_N = mkN "lyktgubbe" utrum  ; -- lyktgubbe..nn.1
  lyktrad_1_N = mkN "lyktrad" "lyktrader" ; -- lyktrad..nn.1
  lyktstolpe_1_N = mkN "lyktstolpe" utrum  ; -- lyktstolpe..nn.1
  lymfa_1_N = mkN "lymfa" ; -- lymfa..nn.1
  lymfatisk_1_A = mkA "lymfatisk" ; -- lymfatisk..av.1
  lymfkärl_1_N = mkN "lymfkärl" neutrum  ; -- lymfkärl..nn.1
  lymfkörtel_1_N = mkN "lymfkörtel" ; -- lymfkörtel..nn.1
  lymfliknande_1_A = mkA "lymfliknande" ; -- lymfliknande..av.1
  lymfocyt_1_N = mkN "lymfocyt" "lymfocyter" ; -- lymfocyt..nn.1
  lymfödem_1_N = mkN "lymfödem" neutrum  ; -- lymfödem..nn.1
  lymmel_1_N = mkN "lymmel" "lymmeln" "lymmlar" "lymmlarna" ; -- lymmel..nn.1
  lymmelaktig_1_A = mkA "lymmelaktig" ; -- lymmelaktig..av.1
  lymmelaktighet_1_N = mkN "lymmelaktighet" ; -- lymmelaktighet..nn.1
  lyncha_1_V = mkV "lynchar" ; -- lyncha..vb.1
  lynchande_1_N = mkN "lynchande" ; -- lynchande..nn.1
  lynchmobb_1_N = mkN "lynchmobb" ; -- lynchmobb..nn.1
  lynchning_1_N = mkN "lynchning" ; -- lynchning..nn.1
  lynchstämning_1_N = mkN "lynchstämning" ; -- lynchstämning..nn.1
  lynett_1_N = mkN "lynett" "lynetter" ; -- lynett..nn.1
  lynne_1_N = mkN "lynne" ; -- lynne..nn.1
  lynnesutbrott_1_N = mkN "lynnesutbrott" neutrum  ; -- lynnesutbrott..nn.1
  lynnig_1_A = mkA "lynnig" ; -- lynnig..av.1
  lynnighet_1_N = mkN "lynnighet" ; -- lynnighet..nn.1
  lypsyl_1_N = mkN "lypsyl" "lypsyler" ; -- lypsyl..nn.1
  lyra_1_N = mkN "lyra" ; -- lyra..nn.1
  lyra_1_V = mkV "lyrar" ; -- lyra..vb.1
  lyrande_1_N = mkN "lyrande" ; -- lyrande..nn.1
  lyrformad_1_A = mkA "lyrformad" ; -- lyrformad..av.1
  lyrfågel_1_N = mkN "lyrfågel" ; -- lyrfågel..nn.1
  lyrik_1_N = mkN "lyrik" ; -- lyrik..nn.1
  lyriker_1_N = mkN "lyriker" "lyrikern" "lyriker" "lyrikerna" ; -- lyriker..nn.1
  lyrikpris_1_N = mkN "lyrikpris" neutrum  ; -- lyrikpris..nn.1
  lyrikälskare_1_N = mkN "lyrikälskare" utrum  ; -- lyrikälskare..nn.1
  lyrisk_1_A = mkA "lyrisk" ; -- lyrisk..av.1
  lyrism_1_N = mkN "lyrism" ; -- lyrism..nn.1
  lyrtorsk_1_N = mkN "lyrtorsk" ; -- lyrtorsk..nn.1
  lysa_1_V = mkV "lyser" ; -- lysa..vb.1
  lysa_2_V = mkV "lyser" ; -- lysa..vb.2
  lysande_1_A = mkA "lysande" ; -- lysande..av.1
  lysande_1_N = mkN "lysande" ; -- lysande..nn.1
  lysboj_1_N = mkN "lysboj" ; -- lysboj..nn.1
  lysbomb_1_N = mkN "lysbomb" "lysbomber" ; -- lysbomb..nn.1
  lysdiod_1_N = mkN "lysdiod" "lysdioder" ; -- lysdiod..nn.1
  lysdiodlampa_1_N = mkN "lysdiodlampa" ; -- lysdiodlampa..nn.1
  lysdiodslampa_1_N = mkN "lysdiodslampa" ; -- lysdiodslampa..nn.1
  lyse_1_N = mkN "lyse" ; -- lyse..nn.1
  lysgas_1_N = mkN "lysgas" "lysgaser" ; -- lysgas..nn.1
  lysin_1_N = mkN "lysin" "lysinet" "lysiner" "lysinerna" ; -- lysin..nn.1
  lysing_1_N = mkN "lysing" ; -- lysing..nn.1
  lysknapp_1_N = mkN "lysknapp" ; -- lysknapp..nn.1
  lyskraft_1_N = mkN "lyskraft" ; -- lyskraft..nn.1
  lysmask_1_N = mkN "lysmask" ; -- lysmask..nn.1
  lysning_1_N = mkN "lysning" ; -- lysning..nn.1
  lysningsmottagning_1_N = mkN "lysningsmottagning" ; -- lysningsmottagning..nn.1
  lysol_1_N = mkN "lysol" ; -- lysol..nn.1
  lysosom_1_N = mkN "lysosom" "lysosomer" ; -- lysosom..nn.1
  lysozym_1_N = mkN "lysozym" neutrum  ; -- lysozym..nn.1
  lyspatron_1_N = mkN "lyspatron" "lyspatroner" ; -- lyspatron..nn.1
  lyspistol_1_N = mkN "lyspistol" "lyspistoler" ; -- lyspistol..nn.1
  lysraket_1_N = mkN "lysraket" "lysraketer" ; -- lysraket..nn.1
  lysräka_1_N = mkN "lysräka" ; -- lysräka..nn.1
  lysrör_1_N = mkN "lysrör" neutrum  ; -- lysrör..nn.1
  lysrörsarmatur_1_N = mkN "lysrörsarmatur" "lysrörsarmaturer" ; -- lysrörsarmatur..nn.1
  lysrörslampa_1_N = mkN "lysrörslampa" ; -- lysrörslampa..nn.1
  lyssats_1_N = mkN "lyssats" "lyssatser" ; -- lyssats..nn.1
  lyssna_1_V = mkV "lyssnar" ; -- lyssna..vb.1
  lyssnande_1_N = mkN "lyssnande" ; -- lyssnande..nn.1
  lyssnarapparat_1_N = mkN "lyssnarapparat" "lyssnarapparater" ; -- lyssnarapparat..nn.1
  lyssnare_1_N = mkN "lyssnare" utrum  ; -- lyssnare..nn.1
  lyssnarpost_1_N = mkN "lyssnarpost" "lyssnarposter" ; -- lyssnarpost..nn.1
  lyssnarskara_1_N = mkN "lyssnarskara" ; -- lyssnarskara..nn.1
  lysten_1_A = mkA "lysten" ; -- lysten..av.1
  lystenhet_1_N = mkN "lystenhet" ; -- lystenhet..nn.1
  lyster_1_N = mkN "lyster" ; -- lyster..nn.1
  lyster_1_V = mkV "lyster" ; -- lyster..vb.1
  lysterfärg_1_N = mkN "lysterfärg" "lysterfärger" ; -- lysterfärg..nn.1
  lystergarn_1_N = mkN "lystergarn" neutrum  ; -- lystergarn..nn.1
  lystmäte_1_N = mkN "lystmäte" ; -- lystmäte..nn.1
  lystnad_1_N = mkN "lystnad" "lystnader" ; -- lystnad..nn.1
  lystra_1_V = mkV "lystrar" ; -- lystra..vb.1
  lystrande_1_N = mkN "lystrande" ; -- lystrande..nn.1
  lystring_1_N = mkN "lystring" ; -- lystring..nn.1
  lysved_1_N = mkN "lysved" ; -- lysved..nn.1
  lysämne_1_N = mkN "lysämne" ; -- lysämne..nn.1
  lyte_1_N = mkN "lyte" ; -- lyte..nn.1
  lyteskomik_1_N = mkN "lyteskomik" ; -- lyteskomik..nn.1
  lytt_1_A = mkA "lytt" ; -- lytt..av.1
  lytt_2_A = mkA "lytt" ; -- lytt..av.2
  lytthet_1_N = mkN "lytthet" ; -- lytthet..nn.1
  lyx_1_N = mkN "lyx" ; -- lyx..nn.1
  lyxa_1_V = mkV "lyxar" ; -- lyxa..vb.1
  lyxande_1_N = mkN "lyxande" ; -- lyxande..nn.1
  lyxartikel_1_N = mkN "lyxartikel" ; -- lyxartikel..nn.1
  lyxbil_1_N = mkN "lyxbil" ; -- lyxbil..nn.1
  lyxbutik_1_N = mkN "lyxbutik" "lyxbutiker" ; -- lyxbutik..nn.1
  lyxfälla_1_N = mkN "lyxfälla" ; -- lyxfälla..nn.1
  lyxföremål_1_N = mkN "lyxföremål" neutrum  ; -- lyxföremål..nn.1
  lyxförpackning_1_N = mkN "lyxförpackning" ; -- lyxförpackning..nn.1
  lyxgård_1_N = mkN "lyxgård" ; -- lyxgård..nn.1
  lyxhotell_1_N = mkN "lyxhotell" neutrum  ; -- lyxhotell..nn.1
  lyxhustru_1_N = mkN "lyxhustru" "lyxhustrun" "lyxhustrur" "lyxhustrurna" ; -- lyxhustru..nn.1
  lyxig_1_A = mkA "lyxig" ; -- lyxig..av.1
  lyxighet_1_N = mkN "lyxighet" "lyxigheter" ; -- lyxighet..nn.1
  lyxklass_1_N = mkN "lyxklass" "lyxklasser" ; -- lyxklass..nn.1
  lyxkonsumera_1_V = mkV "lyxkonsumerar" ; -- lyxkonsumera..vb.1
  lyxkonsumerande_1_N = mkN "lyxkonsumerande" ; -- lyxkonsumerande..nn.1
  lyxkonsumering_1_N = mkN "lyxkonsumering" ; -- lyxkonsumering..nn.1
  lyxkonsumtion_1_N = mkN "lyxkonsumtion" ; -- lyxkonsumtion..nn.1
  lyxkryssare_1_N = mkN "lyxkryssare" utrum  ; -- lyxkryssare..nn.1
  lyxkryssning_1_N = mkN "lyxkryssning" ; -- lyxkryssning..nn.1
  lyxköp_1_N = mkN "lyxköp" neutrum  ; -- lyxköp..nn.1
  lyxliv_1_N = mkN "lyxliv" neutrum  ; -- lyxliv..nn.1
  lyxlya_1_N = mkN "lyxlya" ; -- lyxlya..nn.1
  lyxlägenhet_1_N = mkN "lyxlägenhet" "lyxlägenheter" ; -- lyxlägenhet..nn.1
  lyxmat_1_N = mkN "lyxmat" ; -- lyxmat..nn.1
  lyxproblem_1_N = mkN "lyxproblem" neutrum  ; -- lyxproblem..nn.1
  lyxprostituerad_1_A = mkA "lyxprostituerad" ; -- lyxprostituerad..av.1
  lyxpryl_1_N = mkN "lyxpryl" ; -- lyxpryl..nn.1
  lyxrenovera_1_V = mkV "lyxrenoverar" ; -- lyxrenovera..vb.1
  lyxrenoverande_1_N = mkN "lyxrenoverande" ; -- lyxrenoverande..nn.1
  lyxrenoverbar_1_A = mkA "lyxrenoverbar" ; -- lyxrenoverbar..av.1
  lyxrenoverbarhet_1_N = mkN "lyxrenoverbarhet" ; -- lyxrenoverbarhet..nn.1
  lyxrenovering_1_N = mkN "lyxrenovering" ; -- lyxrenovering..nn.1
  lyxskatt_1_N = mkN "lyxskatt" "lyxskatter" ; -- lyxskatt..nn.1
  lyxskinka_1_N = mkN "lyxskinka" ; -- lyxskinka..nn.1
  lyxsmörgås_1_N = mkN "lyxsmörgås" ; -- lyxsmörgås..nn.1
  lyxtelegram_1_N = mkN "lyxtelegram" "lyxtelegrammet" "lyxtelegram" "lyxtelegrammen" ; -- lyxtelegram..nn.1
  lyxvara_1_N = mkN "lyxvara" ; -- lyxvara..nn.1
  lyxvilla_1_N = mkN "lyxvilla" ; -- lyxvilla..nn.1
  lyxvåning_1_N = mkN "lyxvåning" ; -- lyxvåning..nn.1
  lángos_1_N = mkN "lángos" ; -- lángos..nn.1
  lä_1_N = mkN "lä" ; -- lä..nn.1
  läa_1_V = mkV "läar" ; -- läa..vb.1
  läande_1_N = mkN "läande" ; -- läande..nn.1
  läbb_1_N = mkN "läbb" ; -- läbb..nn.1
  läbba_1_N = mkN "läbba" ; -- läbba..nn.1
  läbbig_1_A = mkA "läbbig" ; -- läbbig..av.1
  läbbighet_1_N = mkN "läbbighet" "läbbigheter" ; -- läbbighet..nn.1
  läbbporr_1_N = mkN "läbbporr" ; -- läbbporr..nn.1
  läbord_1_N = mkN "läbord" neutrum  ; -- läbord..nn.1
  läck_1_A = mkA "läck" ; -- läck..av.1
  läcka_1_N = mkN "läcka" ; -- läcka..nn.1
  läcka_1_V = mkV "läcker" ; -- läcka..vb.1
  läckage_1_N = mkN "läckage" "läckaget" "läckage" "läckagen" ; -- läckage..nn.1
  läckageproblem_1_N = mkN "läckageproblem" neutrum  ; -- läckageproblem..nn.1
  läckande_1_N = mkN "läckande" ; -- läckande..nn.1
  läcker_1_A = mkA "läcker" ; -- läcker..av.1
  läckerbit_1_N = mkN "läckerbit" ; -- läckerbit..nn.1
  läckergom_1_N = mkN "läckergom" "läckergommen" "läckergommar" "läckergommarna" ; -- läckergom..nn.1
  läckerhet_1_N = mkN "läckerhet" "läckerheter" ; -- läckerhet..nn.1
  läder_1_N = mkN "läder" neutrum  ; -- läder..nn.1
  lädera_1_V = mkV "läderar" ; -- lädera..vb.1
  läderande_1_N = mkN "läderande" ; -- läderande..nn.1
  läderartad_1_A = mkA "läderartad" ; -- läderartad..av.1
  läderbar_1_A = mkA "läderbar" ; -- läderbar..av.1
  läderbarhet_1_N = mkN "läderbarhet" ; -- läderbarhet..nn.1
  läderbrun_1_A = mkA "läderbrun" ; -- läderbrun..av.1
  läderfodral_1_N = mkN "läderfodral" neutrum  ; -- läderfodral..nn.1
  läderhud_1_N = mkN "läderhud" ; -- läderhud..nn.1
  läderinbunden_1_A = mkA "läderinbunden" ; -- läderinbunden..av.1
  lädering_1_N = mkN "lädering" ; -- lädering..nn.1
  läderjacka_1_N = mkN "läderjacka" ; -- läderjacka..nn.1
  läderkula_1_N = mkN "läderkula" ; -- läderkula..nn.1
  läderlapp_1_N = mkN "läderlapp" ; -- läderlapp..nn.1
  läderslida_1_N = mkN "läderslida" ; -- läderslida..nn.1
  lädertyg_1_N = mkN "lädertyg" neutrum  ; -- lädertyg..nn.1
  lägda_1_N = mkN "lägda" ; -- lägda..nn.1
  läge_1_N = mkN "läge" ; -- läge..nn.1
  lägel_1_N = mkN "lägel" ; -- lägel..nn.1
  lägenhet_1_N = mkN "lägenhet" "lägenheter" ; -- lägenhet..nn.1
  lägenhetsbrand_1_N = mkN "lägenhetsbrand" "lägenhetsbränder" ; -- lägenhetsbrand..nn.1
  lägenhetsbråk_1_N = mkN "lägenhetsbråk" neutrum  ; -- lägenhetsbråk..nn.1
  lägenhetsbyte_1_N = mkN "lägenhetsbyte" ; -- lägenhetsbyte..nn.1
  lägenhetshotell_1_N = mkN "lägenhetshotell" neutrum  ; -- lägenhetshotell..nn.1
  lägenhetsinnehavare_1_N = mkN "lägenhetsinnehavare" utrum  ; -- lägenhetsinnehavare..nn.1
  lägenhetsvisning_1_N = mkN "lägenhetsvisning" ; -- lägenhetsvisning..nn.1
  läger_1_N = mkN "läger" neutrum  ; -- läger..nn.1
  lägerbål_1_N = mkN "lägerbål" neutrum  ; -- lägerbål..nn.1
  lägerbödel_1_N = mkN "lägerbödel" ; -- lägerbödel..nn.1
  lägereld_1_N = mkN "lägereld" ; -- lägereld..nn.1
  lägerliv_1_N = mkN "lägerliv" neutrum  ; -- lägerliv..nn.1
  lägerskola_1_N = mkN "lägerskola" ; -- lägerskola..nn.1
  lägesanalys_1_N = mkN "lägesanalys" "lägesanalyser" ; -- lägesanalys..nn.1
  lägesbeskrivning_1_N = mkN "lägesbeskrivning" ; -- lägesbeskrivning..nn.1
  lägesbestämning_1_N = mkN "lägesbestämning" ; -- lägesbestämning..nn.1
  lägesenergi_1_N = mkN "lägesenergi" ; -- lägesenergi..nn.1
  lägesförändring_1_N = mkN "lägesförändring" ; -- lägesförändring..nn.1
  lägesrapport_1_N = mkN "lägesrapport" "lägesrapporter" ; -- lägesrapport..nn.1
  lägessinne_1_N = mkN "lägessinne" ; -- lägessinne..nn.1
  lägessummering_1_N = mkN "lägessummering" ; -- lägessummering..nn.1
  lägg_1_N = mkN "lägg" neutrum  ; -- lägg..nn.1
  lägg_2_N = mkN "lägg" ; -- lägg..nn.2
  lägga_1_V = mkV "lägga" "la" "lagt" ; -- lägga..vb.1
  läggande_1_N = mkN "läggande" ; -- läggande..nn.1
  läggdags_1_N = mkN "läggdags" ; -- läggdags..nn.1
  läggmatch_1_N = mkN "läggmatch" "läggmatcher" ; -- läggmatch..nn.1
  läggning_1_N = mkN "läggning" ; -- läggning..nn.1
  läggspel_1_N = mkN "läggspel" "läggspelet" "läggspel" "läggspelen" ; -- läggspel..nn.1
  läglig_1_A = mkA "läglig" ; -- läglig..av.1
  läglighet_1_N = mkN "läglighet" ; -- läglighet..nn.1
  lägra_1_V = mkV "lägrar" ; -- lägra..vb.1
  lägrande_1_N = mkN "lägrande" ; -- lägrande..nn.1
  lägrestående_1_A = mkA "lägrestående" ; -- lägrestående..av.1
  lägstanivå_1_N = mkN "lägstanivå" "lägstanivåer" ; -- lägstanivå..nn.1
  läka_1_V = mkV "läker" ; -- läka..vb.1
  läkande_1_N = mkN "läkande" ; -- läkande..nn.1
  läkarbesök_1_N = mkN "läkarbesök" neutrum  ; -- läkarbesök..nn.1
  läkarbok_1_N = mkN "läkarbok" "läkarböcker" ; -- läkarbok..nn.1
  läkarcentral_1_N = mkN "läkarcentral" "läkarcentraler" ; -- läkarcentral..nn.1
  läkardotter_1_N = mkN "läkardotter" "läkardottern" "läkardöttrar" "läkardöttrarna" ; -- läkardotter..nn.1
  läkare_1_N = mkN "läkare" utrum  ; -- läkare..nn.1
  läkarhjälp_1_N = mkN "läkarhjälp" ; -- läkarhjälp..nn.1
  läkarhus_1_N = mkN "läkarhus" neutrum  ; -- läkarhus..nn.1
  läkarintyg_1_N = mkN "läkarintyg" neutrum  ; -- läkarintyg..nn.1
  läkarkår_1_N = mkN "läkarkår" "läkarkårer" ; -- läkarkår..nn.1
  läkarlegitimation_1_N = mkN "läkarlegitimation" ; -- läkarlegitimation..nn.1
  läkarmottagning_1_N = mkN "läkarmottagning" ; -- läkarmottagning..nn.1
  läkarordination_1_N = mkN "läkarordination" ; -- läkarordination..nn.1
  läkarpraktik_1_N = mkN "läkarpraktik" "läkarpraktiker" ; -- läkarpraktik..nn.1
  läkarrecept_1_N = mkN "läkarrecept" neutrum  ; -- läkarrecept..nn.1
  läkarrock_1_N = mkN "läkarrock" ; -- läkarrock..nn.1
  läkarsekreterare_1_N = mkN "läkarsekreterare" utrum  ; -- läkarsekreterare..nn.1
  läkarslarv_1_N = mkN "läkarslarv" neutrum  ; -- läkarslarv..nn.1
  läkarundersöka_1_V = mkV "läkarundersöker" ; -- läkarundersöka..vb.1
  läkarundersökande_1_N = mkN "läkarundersökande" ; -- läkarundersökande..nn.1
  läkarundersökning_1_N = mkN "läkarundersökning" ; -- läkarundersökning..nn.1
  läkarvetenskap_1_N = mkN "läkarvetenskap" ; -- läkarvetenskap..nn.1
  läkarvård_1_N = mkN "läkarvård" ; -- läkarvård..nn.1
  läkbar_1_A = mkA "läkbar" ; -- läkbar..av.1
  läkbarhet_1_N = mkN "läkbarhet" ; -- läkbarhet..nn.1
  läkedom_1_N = mkN "läkedom" ; -- läkedom..nn.1
  läkekonst_1_N = mkN "läkekonst" ; -- läkekonst..nn.1
  läkekraft_1_N = mkN "läkekraft" ; -- läkekraft..nn.1
  läkemedel_1_N = mkN "läkemedel" neutrum  ; -- läkemedel..nn.1
  läkemedelsbolag_1_N = mkN "läkemedelsbolag" neutrum  ; -- läkemedelsbolag..nn.1
  läkemedelsföretag_1_N = mkN "läkemedelsföretag" neutrum  ; -- läkemedelsföretag..nn.1
  läkemedelsindustri_1_N = mkN "läkemedelsindustri" "läkemedelsindustrier" ; -- läkemedelsindustri..nn.1
  läkemedelsjätte_1_N = mkN "läkemedelsjätte" utrum  ; -- läkemedelsjätte..nn.1
  läkemedelskontroll_1_N = mkN "läkemedelskontroll" "läkemedelskontroller" ; -- läkemedelskontroll..nn.1
  läkemedelslag_1_N = mkN "läkemedelslag" ; -- läkemedelslag..nn.1
  läkemedelsmarknad_1_A = mkA "läkemedelsmarknad" ; -- läkemedelsmarknad..av.1
  läkepedagogik_1_N = mkN "läkepedagogik" ; -- läkepedagogik..nn.1
  läkeväxt_1_N = mkN "läkeväxt" "läkeväxter" ; -- läkeväxt..nn.1
  läkkött_1_N = mkN "läkkött" neutrum  ; -- läkkött..nn.1
  läkning_1_N = mkN "läkning" ; -- läkning..nn.1
  läkt_1_N = mkN "läkt" "läkter" ; -- läkt..nn.1
  läktare_1_N = mkN "läktare" utrum  ; -- läktare..nn.1
  läktarvåld_1_N = mkN "läktarvåld" neutrum  ; -- läktarvåld..nn.1
  läktra_1_V = mkV "läktrar" ; -- läktra..vb.1
  läktrande_1_N = mkN "läktrande" ; -- läktrande..nn.1
  läktverk_1_N = mkN "läktverk" neutrum  ; -- läktverk..nn.1
  läm_1_N = mkN "läm" "lämmen" "lämmar" "lämmarna" ; -- läm..nn.1
  lämmel_1_N = mkN "lämmel" "lämmeln" "lämmlar" "lämmlarna" ; -- lämmel..nn.1
  lämmeltåg_1_N = mkN "lämmeltåg" neutrum  ; -- lämmeltåg..nn.1
  lämmelår_1_N = mkN "lämmelår" neutrum  ; -- lämmelår..nn.1
  lämna_1_V = mkV "lämnar" ; -- lämna..vb.1
  lämnande_1_N = mkN "lämnande" ; -- lämnande..nn.1
  lämning_1_N = mkN "lämning" ; -- lämning..nn.1
  lämpa_1_V = mkV "lämpar" ; -- lämpa..vb.1
  lämpad_1_A = mkA "lämpad" ; -- lämpad..av.1
  lämpande_1_N = mkN "lämpande" ; -- lämpande..nn.1
  lämpare_1_N = mkN "lämpare" utrum  ; -- lämpare..nn.1
  lämplig_1_A = mkA "lämplig" ; -- lämplig..av.1
  lämpligen_1_Adv = mkAdv "lämpligen" ; -- lämpligen..ab.1
  lämplighet_1_N = mkN "lämplighet" "lämpligheter" ; -- lämplighet..nn.1
  lämplighetsintyg_1_N = mkN "lämplighetsintyg" neutrum  ; -- lämplighetsintyg..nn.1
  lämplighetsprövning_1_N = mkN "lämplighetsprövning" ; -- lämplighetsprövning..nn.1
  län_1_N = mkN "län" neutrum  ; -- län..nn.1
  länd_1_N = mkN "länd" "länder" ; -- länd..nn.1
  lända_1_V = mkV "länder" ; -- lända..vb.1
  ländande_1_N = mkN "ländande" ; -- ländande..nn.1
  ländergrupp_1_N = mkN "ländergrupp" "ländergrupper" ; -- ländergrupp..nn.1
  länderval_1_N = mkN "länderval" neutrum  ; -- länderval..nn.1
  ländfläta_1_N = mkN "ländfläta" ; -- ländfläta..nn.1
  ländkläde_1_N = mkN "ländkläde" ; -- ländkläde..nn.1
  ländkota_1_N = mkN "ländkota" ; -- ländkota..nn.1
  ländstycke_1_N = mkN "ländstycke" ; -- ländstycke..nn.1
  länga_1_N = mkN "länga" ; -- länga..nn.1
  länga_1_V = mkV "länger" ; -- länga..vb.1
  längande_1_N = mkN "längande" ; -- längande..nn.1
  längd_1_N = mkN "längd" "längder" ; -- längd..nn.1
  längdaxel_1_N = mkN "längdaxel" ; -- längdaxel..nn.1
  längdenhet_1_N = mkN "längdenhet" "längdenheter" ; -- längdenhet..nn.1
  längdgrad_1_N = mkN "längdgrad" "längdgrader" ; -- längdgrad..nn.1
  längdhopp_1_N = mkN "längdhopp" neutrum  ; -- längdhopp..nn.1
  längdhoppare_1_N = mkN "längdhoppare" utrum  ; -- längdhoppare..nn.1
  längdlöpning_1_N = mkN "längdlöpning" ; -- längdlöpning..nn.1
  längdmarkering_1_N = mkN "längdmarkering" ; -- längdmarkering..nn.1
  längdmeter_1_N = mkN "längdmeter" "längdmetern" "längdmeter" "längdmeterna" ; -- längdmeter..nn.1
  längdmått_1_N = mkN "längdmått" neutrum  ; -- längdmått..nn.1
  längdprofil_1_N = mkN "längdprofil" "längdprofiler" ; -- längdprofil..nn.1
  längdriktning_1_N = mkN "längdriktning" ; -- längdriktning..nn.1
  längdskidåkare_1_N = mkN "längdskidåkare" utrum  ; -- längdskidåkare..nn.1
  längdsnitt_1_N = mkN "längdsnitt" neutrum  ; -- längdsnitt..nn.1
  längdspricka_1_N = mkN "längdspricka" ; -- längdspricka..nn.1
  längdstreck_1_N = mkN "längdstreck" neutrum  ; -- längdstreck..nn.1
  längdtecken_1_N = mkN "längdtecken" "längdtecknet" "längdtecken" "längdtecknen" ; -- längdtecken..nn.1
  längdutvidgning_1_N = mkN "längdutvidgning" ; -- längdutvidgning..nn.1
  längdåkning_1_N = mkN "längdåkning" ; -- längdåkning..nn.1
  länge_1_Adv = mkAdv "länge" ; -- länge..ab.1
  längesedan_1_Adv = mkAdv "längesedan" ; -- längesedan..ab.1
  längesen_1_Adv = mkAdv "längesen" ; -- längesen..ab.1
  längre_1_Adv = mkAdv "längre" ; -- längre..ab.1
  längsdal_1_N = mkN "längsdal" ; -- längsdal..nn.1
  längsgående_1_A = mkA "längsgående" ; -- längsgående..av.1
  längst_1_Adv = mkAdv "längst" ; -- längst..ab.1
  längstförfluten_1_A = mkA "längstförfluten" ; -- längstförfluten..av.1
  längta_1_V = mkV "längtar" ; -- längta..vb.1
  längtande_1_N = mkN "längtande" ; -- längtande..nn.1
  längtansfull_1_A = mkA "längtansfull" ; -- längtansfull..av.1
  längtansfullhet_1_N = mkN "längtansfullhet" ; -- längtansfullhet..nn.1
  länk_1_N = mkN "länk" ; -- länk..nn.1
  länka_1_V = mkV "länkar" ; -- länka..vb.1
  länkande_1_N = mkN "länkande" ; -- länkande..nn.1
  länkhjul_1_N = mkN "länkhjul" neutrum  ; -- länkhjul..nn.1
  länkrörelse_1_N = mkN "länkrörelse" "länkrörelser" ; -- länkrörelse..nn.1
  länkröta_1_N = mkN "länkröta" ; -- länkröta..nn.1
  länkstation_1_N = mkN "länkstation" ; -- länkstation..nn.1
  läns_1_A = mkA "läns" ; -- läns..av.1
  läns_1_N = mkN "läns" ; -- läns..nn.1
  läns_2_N = mkN "läns" ; -- läns..nn.2
  länsa_1_N = mkN "länsa" ; -- länsa..nn.1
  länsa_1_V = mkV "länsar" ; -- länsa..vb.1
  länsande_1_N = mkN "länsande" ; -- länsande..nn.1
  länsarbetsdirektör_1_N = mkN "länsarbetsdirektör" "länsarbetsdirektörer" ; -- länsarbetsdirektör..nn.1
  länsarbetsnämnd_1_N = mkN "länsarbetsnämnd" "länsarbetsnämnder" ; -- länsarbetsnämnd..nn.1
  länsarkitekt_1_N = mkN "länsarkitekt" "länsarkitekter" ; -- länsarkitekt..nn.1
  länsbeteckning_1_N = mkN "länsbeteckning" ; -- länsbeteckning..nn.1
  länsbokstav_1_N = mkN "länsbokstav" "länsbokstäver" ; -- länsbokstav..nn.1
  länsherre_1_N = mkN "länsherre" utrum  ; -- länsherre..nn.1
  länskod_1_N = mkN "länskod" "länskoder" ; -- länskod..nn.1
  länskommunikationscentral_1_N = mkN "länskommunikationscentral" "länskommunikationscentraler" ; -- länskommunikationscentral..nn.1
  länskriminal_1_N = mkN "länskriminal" ; -- länskriminal..nn.1
  länskriminalpolis_1_N = mkN "länskriminalpolis" "länskriminalpoliser" ; -- länskriminalpolis..nn.1
  länslasarett_1_N = mkN "länslasarett" neutrum  ; -- länslasarett..nn.1
  länsman_1_N = mkN "länsman" "länsmannen" "länsmän" "länsmännen" ; -- länsman..nn.1
  länsning_1_N = mkN "länsning" ; -- länsning..nn.1
  länspolis_1_N = mkN "länspolis" ; -- länspolis..nn.1
  länspolismästare_1_N = mkN "länspolismästare" utrum  ; -- länspolismästare..nn.1
  länspump_1_N = mkN "länspump" ; -- länspump..nn.1
  länspumpa_1_V = mkV "länspumpar" ; -- länspumpa..vb.1
  länspumpande_1_N = mkN "länspumpande" ; -- länspumpande..nn.1
  länspumpning_1_N = mkN "länspumpning" ; -- länspumpning..nn.1
  länsresidens_1_N = mkN "länsresidens" neutrum  ; -- länsresidens..nn.1
  länsrätt_1_N = mkN "länsrätt" "länsrätter" ; -- länsrätt..nn.1
  länsråd_1_N = mkN "länsråd" neutrum  ; -- länsråd..nn.1
  länsskatterätt_1_N = mkN "länsskatterätt" "länsskatterätter" ; -- länsskatterätt..nn.1
  länsskolnämnd_1_N = mkN "länsskolnämnd" "länsskolnämnder" ; -- länsskolnämnd..nn.1
  länsstolslingvist_1_N = mkN "länsstolslingvist" "länsstolslingvister" ; -- länsstolslingvist..nn.1
  länsstyrelse_1_N = mkN "länsstyrelse" "länsstyrelser" ; -- länsstyrelse..nn.1
  länstol_1_N = mkN "länstol" ; -- länstol..nn.1
  länsvakthavande_1_N = mkN "länsvakthavande" "länsvakthavanden" "länsvakthavanden" "länsvakthavandena" ; -- länsvakthavande..nn.1
  länsvis_1_Adv = mkAdv "länsvis" ; -- länsvis..ab.1
  länsväg_1_N = mkN "länsväg" ; -- länsväg..nn.1
  länsväsen_1_N = mkN "länsväsen" neutrum  ; -- länsväsen..nn.1
  länsåklagare_1_N = mkN "länsåklagare" utrum  ; -- länsåklagare..nn.1
  läntagare_1_N = mkN "läntagare" utrum  ; -- läntagare..nn.1
  läpp_1_N = mkN "läpp" ; -- läpp..nn.1
  läppavläsning_1_N = mkN "läppavläsning" ; -- läppavläsning..nn.1
  läppglans_1_N = mkN "läppglans" ; -- läppglans..nn.1
  läppja_1_V = mkV "läppjar" ; -- läppja..vb.1
  läppjande_1_N = mkN "läppjande" ; -- läppjande..nn.1
  läppljud_1_N = mkN "läppljud" neutrum  ; -- läppljud..nn.1
  läpprörelse_1_N = mkN "läpprörelse" "läpprörelser" ; -- läpprörelse..nn.1
  läppsmink_1_N = mkN "läppsmink" "läppsminket" "läppsminker" "läppsminkerna" ; -- läppsmink..nn.1
  läppsnus_1_N = mkN "läppsnus" "läppsnuset" "läppsnuser" "läppsnuserna" ; -- läppsnus..nn.1
  läppstift_1_N = mkN "läppstift" neutrum  ; -- läppstift..nn.1
  lär_1_V = mkV "lär" ; -- lär..vb.1
  lära_1_N = mkN "lära" ; -- lära..nn.1
  lära_1_V = mkV "lära" "lärde" "lärt" ; -- lära..vb.1
  läraktig_1_A = mkA "läraktig" ; -- läraktig..av.1
  läraktighet_1_N = mkN "läraktighet" ; -- läraktighet..nn.1
  lärande_1_N = mkN "lärande" ; -- lärande..nn.1
  lärandemål_1_N = mkN "lärandemål" neutrum  ; -- lärandemål..nn.1
  lärare_1_N = mkN "lärare" utrum  ; -- lärare..nn.1
  lärarfortbildning_1_N = mkN "lärarfortbildning" ; -- lärarfortbildning..nn.1
  lärarhögskola_1_N = mkN "lärarhögskola" ; -- lärarhögskola..nn.1
  lärarinna_1_N = mkN "lärarinna" ; -- lärarinna..nn.1
  lärarinneröst_1_N = mkN "lärarinneröst" "lärarinneröster" ; -- lärarinneröst..nn.1
  lärarkandidat_1_N = mkN "lärarkandidat" "lärarkandidater" ; -- lärarkandidat..nn.1
  lärarkollegium_1_N = mkN "lärarkollegium" "lärarkollegiet" "lärarkollegier" "lärarkollegierna" ; -- lärarkollegium..nn.1
  lärarkår_1_N = mkN "lärarkår" "lärarkårer" ; -- lärarkår..nn.1
  lärarledd_1_A = mkA "lärarledd" ; -- lärarledd..av.1
  lärarleg_1_N = mkN "lärarleg" neutrum  ; -- lärarleg..nn.1
  lärarlegg_1_N = mkN "lärarlegg" neutrum  ; -- lärarlegg..nn.1
  lärarlegitimation_1_N = mkN "lärarlegitimation" ; -- lärarlegitimation..nn.1
  lärarlinje_1_N = mkN "lärarlinje" "lärarlinjer" ; -- lärarlinje..nn.1
  lärarlös_1_A = mkA "lärarlös" ; -- lärarlös..av.1
  lärarlöshet_1_N = mkN "lärarlöshet" ; -- lärarlöshet..nn.1
  lärarroll_1_N = mkN "lärarroll" "lärarroller" ; -- lärarroll..nn.1
  lärarrum_1_N = mkN "lärarrum" "lärarrummet" "lärarrum" "lärarrummen" ; -- lärarrum..nn.1
  lärartäthet_1_N = mkN "lärartäthet" "lärartätheter" ; -- lärartäthet..nn.1
  lärarutbildning_1_N = mkN "lärarutbildning" ; -- lärarutbildning..nn.1
  lärd_1_A = mkA "lärd" "lärt" ; -- lärd..av.1
  lärdhet_1_N = mkN "lärdhet" ; -- lärdhet..nn.1
  lärdom_1_N = mkN "lärdom" ; -- lärdom..nn.1
  lärdomsgigant_1_N = mkN "lärdomsgigant" "lärdomsgiganter" ; -- lärdomsgigant..nn.1
  lärdomshistoria_1_N = mkN "lärdomshistoria" ; -- lärdomshistoria..nn.1
  lärdomsprov_1_N = mkN "lärdomsprov" neutrum  ; -- lärdomsprov..nn.1
  lärdomsskola_1_N = mkN "lärdomsskola" ; -- lärdomsskola..nn.1
  lärdomsstad_1_N = mkN "lärdomsstad" "lärdomsstäder" ; -- lärdomsstad..nn.1
  lärft_1_N = mkN "lärft" "lärfter" ; -- lärft..nn.1
  lärftbindning_1_N = mkN "lärftbindning" ; -- lärftbindning..nn.1
  lärjungaskap_1_N = mkN "lärjungaskap" neutrum  ; -- lärjungaskap..nn.1
  lärjunge_1_N = mkN "lärjunge" utrum  ; -- lärjunge..nn.1
  lärk_1_N = mkN "lärk" ; -- lärk..nn.1
  lärka_1_N = mkN "lärka" ; -- lärka..nn.1
  lärkbo_1_N = mkN "lärkbo" "lärkboet" "lärkbon" "lärkbona" ; -- lärkbo..nn.1
  lärkfalk_1_N = mkN "lärkfalk" ; -- lärkfalk..nn.1
  lärkträ_1_N = mkN "lärkträ" neutrum  ; -- lärkträ..nn.1
  lärkträd_1_N = mkN "lärkträd" neutrum  ; -- lärkträd..nn.1
  lärkträtrall_1_N = mkN "lärkträtrall" ; -- lärkträtrall..nn.1
  lärkvinge_1_N = mkN "lärkvinge" utrum  ; -- lärkvinge..nn.1
  lärling_1_N = mkN "lärling" ; -- lärling..nn.1
  lärlingssystem_1_N = mkN "lärlingssystem" neutrum  ; -- lärlingssystem..nn.1
  lärlingstid_1_N = mkN "lärlingstid" ; -- lärlingstid..nn.1
  lärlingsutbildning_1_N = mkN "lärlingsutbildning" ; -- lärlingsutbildning..nn.1
  lärlingsår_1_N = mkN "lärlingsår" neutrum  ; -- lärlingsår..nn.1
  läroanstalt_1_N = mkN "läroanstalt" "läroanstalter" ; -- läroanstalt..nn.1
  lärobok_1_N = mkN "lärobok" "läroböcker" ; -- lärobok..nn.1
  läroboksaktig_1_A = mkA "läroboksaktig" ; -- läroboksaktig..av.1
  läroboksaktighet_1_N = mkN "läroboksaktighet" ; -- läroboksaktighet..nn.1
  läroboksmässig_1_A = mkA "läroboksmässig" ; -- läroboksmässig..av.1
  läroboksnämnd_1_N = mkN "läroboksnämnd" "läroboksnämnder" ; -- läroboksnämnd..nn.1
  lärobokssats_1_N = mkN "lärobokssats" "lärobokssatser" ; -- lärobokssats..nn.1
  lärobyggnad_1_N = mkN "lärobyggnad" "lärobyggnader" ; -- lärobyggnad..nn.1
  lärodikt_1_N = mkN "lärodikt" "lärodikter" ; -- lärodikt..nn.1
  lärofader_1_N = mkN "lärofader" "lärofadern" "lärofäder" "lärofäderna" ; -- lärofader..nn.1
  läromedel_1_N = mkN "läromedel" neutrum  ; -- läromedel..nn.1
  läromedelspaket_1_N = mkN "läromedelspaket" neutrum  ; -- läromedelspaket..nn.1
  läromässig_1_A = mkA "läromässig" ; -- läromässig..av.1
  läromästare_1_N = mkN "läromästare" utrum  ; -- läromästare..nn.1
  läroplan_1_N = mkN "läroplan" "läroplaner" ; -- läroplan..nn.1
  lärorik_1_A = mkA "lärorik" ; -- lärorik..av.1
  lärorikhet_1_N = mkN "lärorikhet" ; -- lärorikhet..nn.1
  lärosal_1_N = mkN "lärosal" ; -- lärosal..nn.1
  lärosats_1_N = mkN "lärosats" "lärosatser" ; -- lärosats..nn.1
  lärospån_1_N = mkN "lärospån" neutrum  ; -- lärospån..nn.1
  lärostol_1_N = mkN "lärostol" ; -- lärostol..nn.1
  lärostycke_1_N = mkN "lärostycke" ; -- lärostycke..nn.1
  lärosäte_1_N = mkN "lärosäte" ; -- lärosäte..nn.1
  lärotid_1_N = mkN "lärotid" ; -- lärotid..nn.1
  läroverk_1_N = mkN "läroverk" neutrum  ; -- läroverk..nn.1
  läroverksungdom_1_N = mkN "läroverksungdom" ; -- läroverksungdom..nn.1
  läroämne_1_N = mkN "läroämne" ; -- läroämne..nn.1
  läroår_1_N = mkN "läroår" neutrum  ; -- läroår..nn.1
  lärpeng_1_N = mkN "lärpeng" ; -- lärpeng..nn.1
  lärpojke_1_N = mkN "lärpojke" utrum  ; -- lärpojke..nn.1
  läsa_1_V = mkV "läser" ; -- läsa..vb.1
  läsande_1_N = mkN "läsande" ; -- läsande..nn.1
  läsapparat_1_N = mkN "läsapparat" "läsapparater" ; -- läsapparat..nn.1
  läsare_1_N = mkN "läsare" utrum  ; -- läsare..nn.1
  läsarskara_1_N = mkN "läsarskara" ; -- läsarskara..nn.1
  läsarstorm_1_N = mkN "läsarstorm" ; -- läsarstorm..nn.1
  läsart_1_N = mkN "läsart" "läsarter" ; -- läsart..nn.1
  läsbar_1_A = mkA "läsbar" ; -- läsbar..av.1
  läsbarhet_1_N = mkN "läsbarhet" "läsbarheter" ; -- läsbarhet..nn.1
  läsbarhetsindex_1_N = mkN "läsbarhetsindex" neutrum  ; -- läsbarhetsindex..nn.1
  läsbarn_1_N = mkN "läsbarn" neutrum  ; -- läsbarn..nn.1
  läsbegåvad_1_A = mkA "läsbegåvad" ; -- läsbegåvad..av.1
  läsbegåvning_1_N = mkN "läsbegåvning" ; -- läsbegåvning..nn.1
  läsdag_1_N = mkN "läsdag" ; -- läsdag..nn.1
  läsdrama_1_N = mkN "läsdrama" "läsdramat" "läsdramer" "läsdramerna" ; -- läsdrama..nn.1
  läsebok_1_N = mkN "läsebok" "läseböcker" ; -- läsebok..nn.1
  läsecirkel_1_N = mkN "läsecirkel" ; -- läsecirkel..nn.1
  läsefrukt_1_N = mkN "läsefrukt" "läsefrukter" ; -- läsefrukt..nn.1
  läsekrets_1_N = mkN "läsekrets" ; -- läsekrets..nn.1
  läseri_1_N = mkN "läseri" neutrum  ; -- läseri..nn.1
  läsesal_1_N = mkN "läsesal" ; -- läsesal..nn.1
  läsesalong_1_N = mkN "läsesalong" "läsesalonger" ; -- läsesalong..nn.1
  läsfrämjande_1_A = mkA "läsfrämjande" ; -- läsfrämjande..av.1
  läsfärdighet_1_N = mkN "läsfärdighet" "läsfärdigheter" ; -- läsfärdighet..nn.1
  läsförmåga_1_N = mkN "läsförmåga" ; -- läsförmåga..nn.1
  läsförståelse_1_N = mkN "läsförståelse" utrum  ; -- läsförståelse..nn.1
  läsglas_1_N = mkN "läsglas" neutrum  ; -- läsglas..nn.1
  läshuvud_1_N = mkN "läshuvud" "läshuvudet" "läshuvud" "läshuvudena" ; -- läshuvud..nn.1
  läshörna_1_N = mkN "läshörna" ; -- läshörna..nn.1
  läsida_1_N = mkN "läsida" ; -- läsida..nn.1
  läsion_1_N = mkN "läsion" ; -- läsion..nn.1
  läsk_1_N = mkN "läsk" "läsken" "läsk" "läsken" ; -- läsk..nn.1
  läska_1_V = mkV "läskar" ; -- läska..vb.1
  läskamrat_1_N = mkN "läskamrat" "läskamrater" ; -- läskamrat..nn.1
  läskande_1_N = mkN "läskande" ; -- läskande..nn.1
  läskeblask_1_N = mkN "läskeblask" neutrum  ; -- läskeblask..nn.1
  läskeblask_2_N = mkN "läskeblask" "läskeblasken" "läskeblask" "läskeblasken" ; -- läskeblask..nn.2
  läskedryck_1_N = mkN "läskedryck" "läskedrycker" ; -- läskedryck..nn.1
  läskedrycksannons_1_N = mkN "läskedrycksannons" "läskedrycksannonser" ; -- läskedrycksannons..nn.1
  läskedrycksproducent_1_N = mkN "läskedrycksproducent" "läskedrycksproducenter" ; -- läskedrycksproducent..nn.1
  läskig_1_A = mkA "läskig" ; -- läskig..av.1
  läskighet_1_N = mkN "läskighet" "läskigheter" ; -- läskighet..nn.1
  läskjätte_1_N = mkN "läskjätte" utrum  ; -- läskjätte..nn.1
  läsklager_1_N = mkN "läsklager" neutrum  ; -- läsklager..nn.1
  läsklass_1_N = mkN "läsklass" "läsklasser" ; -- läsklass..nn.1
  läsklinik_1_N = mkN "läsklinik" "läskliniker" ; -- läsklinik..nn.1
  läskpapper_1_N = mkN "läskpapper" neutrum  ; -- läskpapper..nn.1
  läskstång_1_N = mkN "läskstång" "läskstänger" ; -- läskstång..nn.1
  läskunnig_1_A = mkA "läskunnig" ; -- läskunnig..av.1
  läskunnighet_1_N = mkN "läskunnighet" "läskunnigheter" ; -- läskunnighet..nn.1
  läskända_1_N = mkN "läskända" ; -- läskända..nn.1
  läskände_1_N = mkN "läskände" utrum  ; -- läskände..nn.1
  läslampa_1_N = mkN "läslampa" ; -- läslampa..nn.1
  läslig_1_A = mkA "läslig" ; -- läslig..av.1
  läslighet_1_N = mkN "läslighet" ; -- läslighet..nn.1
  läslust_1_N = mkN "läslust" ; -- läslust..nn.1
  läsning_1_N = mkN "läsning" ; -- läsning..nn.1
  läsordning_1_N = mkN "läsordning" ; -- läsordning..nn.1
  läspa_1_V = mkV "läspar" ; -- läspa..vb.1
  läspande_1_N = mkN "läspande" ; -- läspande..nn.1
  läspenna_1_N = mkN "läspenna" ; -- läspenna..nn.1
  läsplatta_1_N = mkN "läsplatta" ; -- läsplatta..nn.1
  läspljud_1_N = mkN "läspljud" neutrum  ; -- läspljud..nn.1
  läspning_1_N = mkN "läspning" ; -- läspning..nn.1
  läspräst_1_N = mkN "läspräst" "läspräster" ; -- läspräst..nn.1
  läsrum_1_N = mkN "läsrum" "läsrummet" "läsrum" "läsrummen" ; -- läsrum..nn.1
  läss_1_N = mkN "läss" neutrum  ; -- läss..nn.1
  lässvag_1_A = mkA "lässvag" ; -- lässvag..av.1
  lässvaghet_1_N = mkN "lässvaghet" ; -- lässvaghet..nn.1
  lässvårighet_1_N = mkN "lässvårighet" "lässvårigheter" ; -- lässvårighet..nn.1
  läst_1_N = mkN "läst" "läster" ; -- läst..nn.1
  lästadian_1_N = mkN "lästadian" "lästadianer" ; -- lästadian..nn.1
  lästadianism_1_N = mkN "lästadianism" "lästadianismer" ; -- lästadianism..nn.1
  lästblock_1_N = mkN "lästblock" neutrum  ; -- lästblock..nn.1
  läsupplevelse_1_N = mkN "läsupplevelse" "läsupplevelser" ; -- läsupplevelse..nn.1
  läsuttal_1_N = mkN "läsuttal" neutrum  ; -- läsuttal..nn.1
  läsvana_1_N = mkN "läsvana" ; -- läsvana..nn.1
  läsvänlig_1_A = mkA "läsvänlig" ; -- läsvänlig..av.1
  läsvänlighet_1_N = mkN "läsvänlighet" ; -- läsvänlighet..nn.1
  läsvärd_1_A = mkA "läsvärd" "läsvärt" ; -- läsvärd..av.1
  läsvärde_1_N = mkN "läsvärde" ; -- läsvärde..nn.1
  läsvärdhet_1_N = mkN "läsvärdhet" "läsvärdheter" ; -- läsvärdhet..nn.1
  läsämne_1_N = mkN "läsämne" ; -- läsämne..nn.1
  läsår_1_N = mkN "läsår" neutrum  ; -- läsår..nn.1
  läsövning_1_N = mkN "läsövning" ; -- läsövning..nn.1
  läte_1_N = mkN "läte" ; -- läte..nn.1
  lätt_1_A = mkA "lätt" ; -- lätt..av.1
  lätta_1_V = mkV "lättar" ; -- lätta..vb.1
  lätta_2_V = mkV "lättar" ; -- lätta..vb.2
  lättad_1_A = mkA "lättad" ; -- lättad..av.1
  lättande_1_N = mkN "lättande" ; -- lättande..nn.1
  lättantändlig_1_A = mkA "lättantändlig" ; -- lättantändlig..av.1
  lättantändlighet_1_N = mkN "lättantändlighet" ; -- lättantändlighet..nn.1
  lättarbetad_1_A = mkA "lättarbetad" ; -- lättarbetad..av.1
  lättbegriplig_1_A = mkA "lättbegriplig" ; -- lättbegriplig..av.1
  lättbegriplighet_1_N = mkN "lättbegriplighet" ; -- lättbegriplighet..nn.1
  lättbetong_1_N = mkN "lättbetong" ; -- lättbetong..nn.1
  lättbeväpnad_1_A = mkA "lättbeväpnad" ; -- lättbeväpnad..av.1
  lättbruk_1_N = mkN "lättbruk" neutrum  ; -- lättbruk..nn.1
  lättbrukad_1_A = mkA "lättbrukad" ; -- lättbrukad..av.1
  lättböjd_1_A = mkA "lättböjd" "lättböjt" ; -- lättböjd..av.1
  lättböjdhet_1_N = mkN "lättböjdhet" ; -- lättböjdhet..nn.1
  lättdrucken_1_A = mkA "lättdrucken" ; -- lättdrucken..av.1
  lätteligen_1_Adv = mkAdv "lätteligen" ; -- lätteligen..ab.1
  lättfattlig_1_A = mkA "lättfattlig" ; -- lättfattlig..av.1
  lättfattlighet_1_N = mkN "lättfattlighet" ; -- lättfattlighet..nn.1
  lättfil_1_N = mkN "lättfil" ; -- lättfil..nn.1
  lättfixad_1_A = mkA "lättfixad" ; -- lättfixad..av.1
  lättflyktig_1_A = mkA "lättflyktig" ; -- lättflyktig..av.1
  lättflyktighet_1_N = mkN "lättflyktighet" ; -- lättflyktighet..nn.1
  lättflytande_1_A = mkA "lättflytande" ; -- lättflytande..av.1
  lättfotad_1_A = mkA "lättfotad" ; -- lättfotad..av.1
  lättframkomlig_1_A = mkA "lättframkomlig" ; -- lättframkomlig..av.1
  lättframkomlighet_1_N = mkN "lättframkomlighet" ; -- lättframkomlighet..nn.1
  lättfunnen_1_A = mkA "lättfunnen" "lättfunnet" "lättfunna" "lättfunna" "lättfunnare" "lättfunnast" "lättfunnaste" ; -- lättfunnen..av.1
  lättfärdig_1_A = mkA "lättfärdig" ; -- lättfärdig..av.1
  lättfärdighet_1_N = mkN "lättfärdighet" "lättfärdigheter" ; -- lättfärdighet..nn.1
  lättfångad_1_A = mkA "lättfångad" ; -- lättfångad..av.1
  lättfången_1_A = mkA "lättfången" ; -- lättfången..av.1
  lättförklarlig_1_A = mkA "lättförklarlig" ; -- lättförklarlig..av.1
  lättförklarlighet_1_N = mkN "lättförklarlighet" ; -- lättförklarlighet..nn.1
  lättförståelig_1_A = mkA "lättförståelig" ; -- lättförståelig..av.1
  lättförståelighet_1_N = mkN "lättförståelighet" ; -- lättförståelighet..nn.1
  lättförsvarad_1_A = mkA "lättförsvarad" ; -- lättförsvarad..av.1
  lättförtjänt_1_A = mkA "lättförtjänt" "lättförtjänt" ; -- lättförtjänt..av.1
  lättgrogg_1_N = mkN "lättgrogg" ; -- lättgrogg..nn.1
  lätthanterlig_1_A = mkA "lätthanterlig" ; -- lätthanterlig..av.1
  lätthanterlighet_1_N = mkN "lätthanterlighet" ; -- lätthanterlighet..nn.1
  lätthet_1_N = mkN "lätthet" ; -- lätthet..nn.1
  lättillgänglig_1_A = mkA "lättillgänglig" ; -- lättillgänglig..av.1
  lättillgänglighet_1_N = mkN "lättillgänglighet" ; -- lättillgänglighet..nn.1
  lätting_1_N = mkN "lätting" ; -- lätting..nn.1
  lättirriterad_1_A = mkA "lättirriterad" ; -- lättirriterad..av.1
  lättja_1_N = mkN "lättja" ; -- lättja..nn.1
  lättjefull_1_A = mkA "lättjefull" ; -- lättjefull..av.1
  lättjefullhet_1_N = mkN "lättjefullhet" ; -- lättjefullhet..nn.1
  lättjord_1_N = mkN "lättjord" ; -- lättjord..nn.1
  lättklädd_1_A = mkA "lättklädd" ; -- lättklädd..av.1
  lättkläddhet_1_N = mkN "lättkläddhet" ; -- lättkläddhet..nn.1
  lättklöv_1_N = mkN "lättklöv" ; -- lättklöv..nn.1
  lättkokt_1_A = mkA "lättkokt" "lättkokt" ; -- lättkokt..av.1
  lättkokthet_1_N = mkN "lättkokthet" ; -- lättkokthet..nn.1
  lättkränkt_1_A = mkA "lättkränkt" "lättkränkt" ; -- lättkränkt..av.1
  lättköpt_1_A = mkA "lättköpt" "lättköpt" ; -- lättköpt..av.1
  lättköpthet_1_N = mkN "lättköpthet" ; -- lättköpthet..nn.1
  lättkörd_1_A = mkA "lättkörd" "lättkört" ; -- lättkörd..av.1
  lättlagad_1_A = mkA "lättlagad" ; -- lättlagad..av.1
  lättledd_1_A = mkA "lättledd" ; -- lättledd..av.1
  lättleddhet_1_N = mkN "lättleddhet" ; -- lättleddhet..nn.1
  lättlurad_1_A = mkA "lättlurad" ; -- lättlurad..av.1
  lättlyssnad_1_A = mkA "lättlyssnad" ; -- lättlyssnad..av.1
  lättläst_1_A = mkA "lättläst" "lättläst" ; -- lättläst..av.1
  lättlästhet_1_N = mkN "lättlästhet" ; -- lättlästhet..nn.1
  lättlöslig_1_A = mkA "lättlöslig" ; -- lättlöslig..av.1
  lättlöslighet_1_N = mkN "lättlöslighet" ; -- lättlöslighet..nn.1
  lättlöst_1_A = mkA "lättlöst" "lättlöst" ; -- lättlöst..av.1
  lättlösthet_1_N = mkN "lättlösthet" ; -- lättlösthet..nn.1
  lättmanövrerad_1_A = mkA "lättmanövrerad" ; -- lättmanövrerad..av.1
  lättmargarin_1_N = mkN "lättmargarin" "lättmargarinet" "lättmargariner" "lättmargarinerna" ; -- lättmargarin..nn.1
  lättmatros_1_N = mkN "lättmatros" "lättmatroser" ; -- lättmatros..nn.1
  lättmetall_1_N = mkN "lättmetall" "lättmetaller" ; -- lättmetall..nn.1
  lättmjölk_1_N = mkN "lättmjölk" ; -- lättmjölk..nn.1
  lättna_1_V = mkV "lättnar" ; -- lättna..vb.1
  lättnad_1_N = mkN "lättnad" "lättnader" ; -- lättnad..nn.1
  lättnande_1_N = mkN "lättnande" ; -- lättnande..nn.1
  lättnarrad_1_A = mkA "lättnarrad" ; -- lättnarrad..av.1
  lättodlad_1_A = mkA "lättodlad" ; -- lättodlad..av.1
  lättpratad_1_A = mkA "lättpratad" ; -- lättpratad..av.1
  lättpåverkad_1_A = mkA "lättpåverkad" ; -- lättpåverkad..av.1
  lättra_1_V = mkV "lättrar" ; -- lättra..vb.1
  lättrande_1_N = mkN "lättrande" ; -- lättrande..nn.1
  lättretad_1_A = mkA "lättretad" ; -- lättretad..av.1
  lättretlig_1_A = mkA "lättretlig" ; -- lättretlig..av.1
  lättretlighet_1_N = mkN "lättretlighet" ; -- lättretlighet..nn.1
  lättrimmad_1_A = mkA "lättrimmad" ; -- lättrimmad..av.1
  lättroad_1_A = mkA "lättroad" ; -- lättroad..av.1
  lättrogen_1_A = mkA "lättrogen" ; -- lättrogen..av.1
  lättrogenhet_1_N = mkN "lättrogenhet" ; -- lättrogenhet..nn.1
  lättrullad_1_A = mkA "lättrullad" ; -- lättrullad..av.1
  lätträknad_1_A = mkA "lätträknad" ; -- lätträknad..av.1
  lättrökt_1_A = mkA "lättrökt" "lättrökt" ; -- lättrökt..av.1
  lättrörd_1_A = mkA "lättrörd" "lättrört" ; -- lättrörd..av.1
  lättrördhet_1_N = mkN "lättrördhet" ; -- lättrördhet..nn.1
  lättrörlig_1_A = mkA "lättrörlig" ; -- lättrörlig..av.1
  lättrörlighet_1_N = mkN "lättrörlighet" ; -- lättrörlighet..nn.1
  lättsaltad_1_A = mkA "lättsaltad" ; -- lättsaltad..av.1
  lättsam_1_A = mkA "lättsam" "lättsamt" "lättsamma" "lättsamma" "lättsammare" "lättsammast" "lättsammaste" ; -- lättsam..av.1
  lättsamhet_1_N = mkN "lättsamhet" "lättsamheter" ; -- lättsamhet..nn.1
  lättsinne_1_N = mkN "lättsinne" ; -- lättsinne..nn.1
  lättsinnig_1_A = mkA "lättsinnig" ; -- lättsinnig..av.1
  lättsinnighet_1_N = mkN "lättsinnighet" "lättsinnigheter" ; -- lättsinnighet..nn.1
  lättsjungen_1_A = mkA "lättsjungen" ; -- lättsjungen..av.1
  lättskrämd_1_A = mkA "lättskrämd" "lättskrämt" ; -- lättskrämd..av.1
  lättskrämdhet_1_N = mkN "lättskrämdhet" ; -- lättskrämdhet..nn.1
  lättskött_1_A = mkA "lättskött" ; -- lättskött..av.1
  lättskötthet_1_N = mkN "lättskötthet" ; -- lättskötthet..nn.1
  lättsmickrad_1_A = mkA "lättsmickrad" ; -- lättsmickrad..av.1
  lättsmält_1_A = mkA "lättsmält" "lättsmält" ; -- lättsmält..av.1
  lättsmälthet_1_N = mkN "lättsmälthet" ; -- lättsmälthet..nn.1
  lättspackel_1_N = mkN "lättspackel" neutrum  ; -- lättspackel..nn.1
  lättstekt_1_A = mkA "lättstekt" "lättstekt" ; -- lättstekt..av.1
  lättstekthet_1_N = mkN "lättstekthet" ; -- lättstekthet..nn.1
  lättstruken_1_A = mkA "lättstruken" ; -- lättstruken..av.1
  lättstyrd_1_A = mkA "lättstyrd" "lättstyrt" ; -- lättstyrd..av.1
  lättstött_1_A = mkA "lättstött" ; -- lättstött..av.1
  lättstötthet_1_N = mkN "lättstötthet" ; -- lättstötthet..nn.1
  lättuttalad_1_A = mkA "lättuttalad" ; -- lättuttalad..av.1
  lättvariant_1_N = mkN "lättvariant" "lättvarianter" ; -- lättvariant..nn.1
  lättvattenreaktor_1_N = mkN "lättvattenreaktor" "lättvattenreaktorer" ; -- lättvattenreaktor..nn.1
  lättvikt_1_A = mkA "lättvikt" "lättvikt" ; -- lättvikt..av.1
  lättvikt_1_N = mkN "lättvikt" ; -- lättvikt..nn.1
  lättviktare_1_N = mkN "lättviktare" utrum  ; -- lättviktare..nn.1
  lättviktig_1_A = mkA "lättviktig" ; -- lättviktig..av.1
  lättviktighet_1_N = mkN "lättviktighet" ; -- lättviktighet..nn.1
  lättviktsmotorcykel_1_N = mkN "lättviktsmotorcykel" ; -- lättviktsmotorcykel..nn.1
  lättvin_1_N = mkN "lättvin" "lättvinet" "lättviner" "lättvinerna" ; -- lättvin..nn.1
  lättvindig_1_A = mkA "lättvindig" ; -- lättvindig..av.1
  lättvindighet_1_N = mkN "lättvindighet" ; -- lättvindighet..nn.1
  lättvindighet_2_N = mkN "lättvindighet" "lättvindigheter" ; -- lättvindighet..nn.2
  lättvispad_1_A = mkA "lättvispad" ; -- lättvispad..av.1
  lättvunnen_1_A = mkA "lättvunnen" "lättvunnet" "lättvunna" "lättvunna" "lättvunnare" "lättvunnast" "lättvunnaste" ; -- lättvunnen..av.1
  lättäten_1_A = mkA "lättäten" ; -- lättäten..av.1
  lättåtkomlig_1_A = mkA "lättåtkomlig" ; -- lättåtkomlig..av.1
  lättöl_1_N = mkN "lättöl" neutrum  ; -- lättöl..nn.1
  lättömd_1_A = mkA "lättömd" "lättömt" ; -- lättömd..av.1
  lättömdhet_1_N = mkN "lättömdhet" ; -- lättömdhet..nn.1
  lättöversatt_1_A = mkA "lättöversatt" ; -- lättöversatt..av.1
  lättöverskådlig_1_A = mkA "lättöverskådlig" ; -- lättöverskådlig..av.1
  lättöverskådlighet_1_N = mkN "lättöverskådlighet" ; -- lättöverskådlighet..nn.1
  läxa_1_N = mkN "läxa" ; -- läxa..nn.1
  läxförhör_1_N = mkN "läxförhör" neutrum  ; -- läxförhör..nn.1
  läxhjälp_1_N = mkN "läxhjälp" ; -- läxhjälp..nn.1
  läxläsning_1_N = mkN "läxläsning" ; -- läxläsning..nn.1
  läxprov_1_N = mkN "läxprov" neutrum  ; -- läxprov..nn.1
  låda_1_N = mkN "låda" ; -- låda..nn.1
  lådagram_1_N = mkN "lådagram" "lådagrammet" "lådagram" "lådagrammen" ; -- lådagram..nn.1
  låddiagram_1_N = mkN "låddiagram" "låddiagrammet" "låddiagram" "låddiagrammen" ; -- låddiagram..nn.1
  lådfack_1_N = mkN "lådfack" neutrum  ; -- lådfack..nn.1
  lådkamera_1_N = mkN "lådkamera" ; -- lådkamera..nn.1
  lådliknande_1_A = mkA "lådliknande" ; -- lådliknande..av.1
  lådspik_1_N = mkN "lådspik" ; -- lådspik..nn.1
  lådvin_1_N = mkN "lådvin" "lådvinet" "lådviner" "lådvinerna" ; -- lådvin..nn.1
  lådvis_1_Adv = mkAdv "lådvis" ; -- lådvis..ab.1
  lådämne_1_N = mkN "lådämne" ; -- lådämne..nn.1
  låg_1_A = mkA "låg" "lägre" "lägst" ; -- låg..av.1
  låga_1_N = mkN "låga" ; -- låga..nn.1
  låga_1_V = mkV "lågar" ; -- låga..vb.1
  lågadel_1_N = mkN "lågadel" ; -- lågadel..nn.1
  lågadlig_1_A = mkA "lågadlig" ; -- lågadlig..av.1
  lågande_1_N = mkN "lågande" ; -- lågande..nn.1
  låganrikad_1_A = mkA "låganrikad" ; -- låganrikad..av.1
  lågavlönad_1_A = mkA "lågavlönad" ; -- lågavlönad..av.1
  lågblad_1_N = mkN "lågblad" neutrum  ; -- lågblad..nn.1
  lågbudgetdokusåpa_1_N = mkN "lågbudgetdokusåpa" ; -- lågbudgetdokusåpa..nn.1
  lågbudgetresa_1_N = mkN "lågbudgetresa" ; -- lågbudgetresa..nn.1
  lågbudgetturism_1_N = mkN "lågbudgetturism" ; -- lågbudgetturism..nn.1
  lågbudgetturist_1_N = mkN "lågbudgetturist" "lågbudgetturister" ; -- lågbudgetturist..nn.1
  lågenergilampa_1_N = mkN "lågenergilampa" ; -- lågenergilampa..nn.1
  lågfjäll_1_N = mkN "lågfjäll" neutrum  ; -- lågfjäll..nn.1
  lågflyga_1_V = mkV "lågflyga" "lågflög" "lågflugit" ; -- lågflyga..vb.1
  lågflygande_1_N = mkN "lågflygande" ; -- lågflygande..nn.1
  lågfrekvens_1_N = mkN "lågfrekvens" "lågfrekvenser" ; -- lågfrekvens..nn.1
  lågfrekvent_1_A = mkA "lågfrekvent" "lågfrekvent" ; -- lågfrekvent..av.1
  lågfärg_1_N = mkN "lågfärg" "lågfärger" ; -- lågfärg..nn.1
  låghalt_1_A = mkA "låghalt" "låghalt" ; -- låghalt..av.1
  låghet_1_N = mkN "låghet" "lågheter" ; -- låghet..nn.1
  låghjulig_1_A = mkA "låghjulig" ; -- låghjulig..av.1
  låghjulighet_1_N = mkN "låghjulighet" ; -- låghjulighet..nn.1
  låghjuling_1_N = mkN "låghjuling" ; -- låghjuling..nn.1
  låghus_1_N = mkN "låghus" neutrum  ; -- låghus..nn.1
  låghydratisk_1_A = mkA "låghydratisk" ; -- låghydratisk..av.1
  låghydratkost_1_N = mkN "låghydratkost" ; -- låghydratkost..nn.1
  låginkomsttagare_1_N = mkN "låginkomsttagare" utrum  ; -- låginkomsttagare..nn.1
  låginkomstutredning_1_N = mkN "låginkomstutredning" ; -- låginkomstutredning..nn.1
  lågintensiv_1_A = mkA "lågintensiv" ; -- lågintensiv..av.1
  lågkastad_1_A = mkA "lågkastad" ; -- lågkastad..av.1
  lågklackad_1_A = mkA "lågklackad" ; -- lågklackad..av.1
  lågkonjunktur_1_N = mkN "lågkonjunktur" "lågkonjunkturer" ; -- lågkonjunktur..nn.1
  lågkvalitativ_1_A = mkA "lågkvalitativ" ; -- lågkvalitativ..av.1
  lågkyrklig_1_A = mkA "lågkyrklig" ; -- lågkyrklig..av.1
  lågkyrklighet_1_N = mkN "lågkyrklighet" ; -- lågkyrklighet..nn.1
  lågland_1_N = mkN "lågland" neutrum  ; -- lågland..nn.1
  låglandsboskap_1_N = mkN "låglandsboskap" ; -- låglandsboskap..nn.1
  låglandsras_1_N = mkN "låglandsras" "låglandsraser" ; -- låglandsras..nn.1
  lågländare_1_N = mkN "lågländare" utrum  ; -- lågländare..nn.1
  lågländsk_1_A = mkA "lågländsk" ; -- lågländsk..av.1
  låglänt_1_A = mkA "låglänt" "låglänt" ; -- låglänt..av.1
  låglänthet_1_N = mkN "låglänthet" ; -- låglänthet..nn.1
  låglöneprofil_1_N = mkN "låglöneprofil" "låglöneprofiler" ; -- låglöneprofil..nn.1
  låglönepåslag_1_N = mkN "låglönepåslag" neutrum  ; -- låglönepåslag..nn.1
  lågmosse_1_N = mkN "lågmosse" utrum  ; -- lågmosse..nn.1
  lågmäld_1_A = mkA "lågmäld" "lågmält" ; -- lågmäld..av.1
  lågmäldhet_1_N = mkN "lågmäldhet" ; -- lågmäldhet..nn.1
  lågoddsare_1_N = mkN "lågoddsare" utrum  ; -- lågoddsare..nn.1
  lågpresterande_1_A = mkA "lågpresterande" ; -- lågpresterande..av.1
  lågprioritera_1_V = mkV "lågprioriterar" ; -- lågprioritera..vb.1
  lågprioriterande_1_N = mkN "lågprioriterande" ; -- lågprioriterande..nn.1
  lågprioriterbar_1_A = mkA "lågprioriterbar" ; -- lågprioriterbar..av.1
  lågprioriterbarhet_1_N = mkN "lågprioriterbarhet" ; -- lågprioriterbarhet..nn.1
  lågpris_1_N = mkN "lågpris" neutrum  ; -- lågpris..nn.1
  lågprisbolag_1_N = mkN "lågprisbolag" neutrum  ; -- lågprisbolag..nn.1
  lågprisflygbolag_1_N = mkN "lågprisflygbolag" neutrum  ; -- lågprisflygbolag..nn.1
  lågpriskaffe_1_N = mkN "lågpriskaffe" ; -- lågpriskaffe..nn.1
  lågpriskonkurrens_1_N = mkN "lågpriskonkurrens" ; -- lågpriskonkurrens..nn.1
  lågpriskort_1_N = mkN "lågpriskort" neutrum  ; -- lågpriskort..nn.1
  lågproduktiv_1_A = mkA "lågproduktiv" ; -- lågproduktiv..av.1
  lågprosa_1_N = mkN "lågprosa" ; -- lågprosa..nn.1
  lågrelief_1_N = mkN "lågrelief" "lågreliefer" ; -- lågrelief..nn.1
  lågsinnad_1_A = mkA "lågsinnad" ; -- lågsinnad..av.1
  lågsint_1_A = mkA "lågsint" "lågsint" ; -- lågsint..av.1
  lågsinthet_1_N = mkN "lågsinthet" ; -- lågsinthet..nn.1
  lågsko_1_N = mkN "lågsko" "lågskor" ; -- lågsko..nn.1
  lågslätt_1_N = mkN "lågslätt" "lågslätter" ; -- lågslätt..nn.1
  lågsniff_1_N = mkN "lågsniff" ; -- lågsniff..nn.1
  lågspänd_1_A = mkA "lågspänd" ; -- lågspänd..av.1
  lågspänning_1_N = mkN "lågspänning" ; -- lågspänning..nn.1
  lågstadiebarn_1_N = mkN "lågstadiebarn" neutrum  ; -- lågstadiebarn..nn.1
  lågstadielärare_1_N = mkN "lågstadielärare" utrum  ; -- lågstadielärare..nn.1
  lågstadium_1_N = mkN "lågstadium" "lågstadiet" "lågstadier" "lågstadierna" ; -- lågstadium..nn.1
  lågstammig_1_A = mkA "lågstammig" ; -- lågstammig..av.1
  lågstatus_1_N = mkN "lågstatus" ; -- lågstatus..nn.1
  lågsvavlig_1_A = mkA "lågsvavlig" ; -- lågsvavlig..av.1
  lågsvavlighet_1_N = mkN "lågsvavlighet" ; -- lågsvavlighet..nn.1
  lågsäsong_1_N = mkN "lågsäsong" "lågsäsonger" ; -- lågsäsong..nn.1
  lågsäsongssömnig_1_A = mkA "lågsäsongssömnig" ; -- lågsäsongssömnig..av.1
  lågtryck_1_N = mkN "lågtryck" neutrum  ; -- lågtryck..nn.1
  lågtrycksområde_1_N = mkN "lågtrycksområde" ; -- lågtrycksområde..nn.1
  lågtstående_1_A = mkA "lågtstående" ; -- lågtstående..av.1
  lågtysk_1_A = mkA "lågtysk" ; -- lågtysk..av.1
  lågtyska_1_N = mkN "lågtyska" ; -- lågtyska..nn.1
  lågutbildad_1_A = mkA "lågutbildad" ; -- lågutbildad..av.1
  lågvarv_1_N = mkN "lågvarv" neutrum  ; -- lågvarv..nn.1
  lågvatten_1_N = mkN "lågvatten" "lågvattnet" "lågvatten" "lågvattnen" ; -- lågvatten..nn.1
  lågvattenmärke_1_N = mkN "lågvattenmärke" ; -- lågvattenmärke..nn.1
  lågvuxen_1_A = mkA "lågvuxen" ; -- lågvuxen..av.1
  lågvuxenhet_1_N = mkN "lågvuxenhet" ; -- lågvuxenhet..nn.1
  lågvärdig_1_A = mkA "lågvärdig" ; -- lågvärdig..av.1
  lågvärdighet_1_N = mkN "lågvärdighet" ; -- lågvärdighet..nn.1
  lågväxt_1_A = mkA "lågväxt" "lågväxt" ; -- lågväxt..av.1
  lågväxthet_1_N = mkN "lågväxthet" ; -- lågväxthet..nn.1
  lågättad_1_A = mkA "lågättad" ; -- lågättad..av.1
  lån_1_N = mkN "lån" neutrum  ; -- lån..nn.1
  låna_1_V = mkV "lånar" ; -- låna..vb.1
  lånande_1_N = mkN "lånande" ; -- lånande..nn.1
  låneanstalt_1_N = mkN "låneanstalt" "låneanstalter" ; -- låneanstalt..nn.1
  låneansökning_1_N = mkN "låneansökning" ; -- låneansökning..nn.1
  lånebibliotek_1_N = mkN "lånebibliotek" neutrum  ; -- lånebibliotek..nn.1
  låneexpedition_1_N = mkN "låneexpedition" ; -- låneexpedition..nn.1
  lånefest_1_N = mkN "lånefest" "lånefester" ; -- lånefest..nn.1
  låneform_1_N = mkN "låneform" "låneformer" ; -- låneform..nn.1
  lånegaranti_1_N = mkN "lånegaranti" "lånegarantier" ; -- lånegaranti..nn.1
  lånekontor_1_N = mkN "lånekontor" neutrum  ; -- lånekontor..nn.1
  lånekort_1_N = mkN "lånekort" neutrum  ; -- lånekort..nn.1
  lånekö_1_N = mkN "lånekö" "lånekön" "låneköer" "låneköerna" ; -- lånekö..nn.1
  låneköp_1_N = mkN "låneköp" neutrum  ; -- låneköp..nn.1
  lånelöfte_1_N = mkN "lånelöfte" ; -- lånelöfte..nn.1
  lånetak_1_N = mkN "lånetak" neutrum  ; -- lånetak..nn.1
  lånfången_1_A = mkA "lånfången" ; -- lånfången..av.1
  lång_1_A = mkA "lång" "längre" "längst" ; -- lång..av.1
  långa_1_N = mkN "långa" ; -- långa..nn.1
  långbent_1_A = mkA "långbent" "långbent" ; -- långbent..av.1
  långbenthet_1_N = mkN "långbenthet" ; -- långbenthet..nn.1
  långboll_1_N = mkN "långboll" ; -- långboll..nn.1
  långbord_1_N = mkN "långbord" neutrum  ; -- långbord..nn.1
  långbyxa_1_N = mkN "långbyxa" ; -- långbyxa..nn.1
  långbänk_1_N = mkN "långbänk" ; -- långbänk..nn.1
  långbåge_1_N = mkN "långbåge" utrum  ; -- långbåge..nn.1
  långdans_1_N = mkN "långdans" "långdanser" ; -- långdans..nn.1
  långdistans_1_N = mkN "långdistans" "långdistanser" ; -- långdistans..nn.1
  långdistanslöpning_1_N = mkN "långdistanslöpning" ; -- långdistanslöpning..nn.1
  långdistansraket_1_N = mkN "långdistansraket" "långdistansraketer" ; -- långdistansraket..nn.1
  långdragen_1_A = mkA "långdragen" ; -- långdragen..av.1
  långdragenhet_1_N = mkN "långdragenhet" ; -- långdragenhet..nn.1
  långduk_1_N = mkN "långduk" ; -- långduk..nn.1
  långduscha_1_V = mkV "långduschar" ; -- långduscha..vb.1
  långduschande_1_N = mkN "långduschande" ; -- långduschande..nn.1
  långduschning_1_N = mkN "långduschning" ; -- långduschning..nn.1
  långeman_1_N = mkN "långeman" "långemannen" "långemän" "långemännen" ; -- långeman..nn.1
  långfarare_1_N = mkN "långfarare" utrum  ; -- långfarare..nn.1
  långfibrig_1_A = mkA "långfibrig" ; -- långfibrig..av.1
  långfilm_1_N = mkN "långfilm" "långfilmer" ; -- långfilm..nn.1
  långfinger_1_N = mkN "långfinger" ; -- långfinger..nn.1
  långfingrad_1_A = mkA "långfingrad" ; -- långfingrad..av.1
  långfranska_1_N = mkN "långfranska" ; -- långfranska..nn.1
  långfredag_1_N = mkN "långfredag" ; -- långfredag..nn.1
  långfristig_1_A = mkA "långfristig" ; -- långfristig..av.1
  långfristighet_1_N = mkN "långfristighet" ; -- långfristighet..nn.1
  långfärd_1_N = mkN "långfärd" "långfärder" ; -- långfärd..nn.1
  långfärdsbuss_1_N = mkN "långfärdsbuss" ; -- långfärdsbuss..nn.1
  långgardin_1_N = mkN "långgardin" "långgardiner" ; -- långgardin..nn.1
  långgrogg_1_N = mkN "långgrogg" ; -- långgrogg..nn.1
  långgrund_1_A = mkA "långgrund" ; -- långgrund..av.1
  långgrundhet_1_N = mkN "långgrundhet" ; -- långgrundhet..nn.1
  långhelg_1_N = mkN "långhelg" "långhelger" ; -- långhelg..nn.1
  långhornig_1_A = mkA "långhornig" ; -- långhornig..av.1
  långhus_1_N = mkN "långhus" neutrum  ; -- långhus..nn.1
  långhårig_1_A = mkA "långhårig" ; -- långhårig..av.1
  långhårighet_1_N = mkN "långhårighet" ; -- långhårighet..nn.1
  långivande_1_A = mkA "långivande" ; -- långivande..av.1
  långivare_1_N = mkN "långivare" utrum  ; -- långivare..nn.1
  långkalsongsdebut_1_N = mkN "långkalsongsdebut" "långkalsongsdebuter" ; -- långkalsongsdebut..nn.1
  långkatekes_1_N = mkN "långkatekes" ; -- långkatekes..nn.1
  långklänning_1_N = mkN "långklänning" ; -- långklänning..nn.1
  långkok_1_N = mkN "långkok" neutrum  ; -- långkok..nn.1
  långkörare_1_N = mkN "långkörare" utrum  ; -- långkörare..nn.1
  långledig_1_A = mkA "långledig" ; -- långledig..av.1
  långledighet_1_N = mkN "långledighet" "långledigheter" ; -- långledighet..nn.1
  långlig_1_A = mkA "långlig" ; -- långlig..av.1
  långliggare_1_N = mkN "långliggare" utrum  ; -- långliggare..nn.1
  långlighet_1_N = mkN "långlighet" ; -- långlighet..nn.1
  långlivad_1_A = mkA "långlivad" ; -- långlivad..av.1
  långlopp_1_N = mkN "långlopp" neutrum  ; -- långlopp..nn.1
  långlotsning_1_N = mkN "långlotsning" ; -- långlotsning..nn.1
  långlördag_1_N = mkN "långlördag" ; -- långlördag..nn.1
  långmarsch_1_N = mkN "långmarsch" "långmarscher" ; -- långmarsch..nn.1
  långmjölk_1_N = mkN "långmjölk" ; -- långmjölk..nn.1
  långmod_1_N = mkN "långmod" neutrum  ; -- långmod..nn.1
  långmodig_1_A = mkA "långmodig" ; -- långmodig..av.1
  långmodighet_1_N = mkN "långmodighet" ; -- långmodighet..nn.1
  långnäbb_1_N = mkN "långnäbb" ; -- långnäbb..nn.1
  långnäst_1_A = mkA "långnäst" "långnäst" ; -- långnäst..av.1
  långnästhet_1_N = mkN "långnästhet" ; -- långnästhet..nn.1
  långods_1_N = mkN "långods" neutrum  ; -- långods..nn.1
  långpanna_1_N = mkN "långpanna" ; -- långpanna..nn.1
  långpass_1_N = mkN "långpass" neutrum  ; -- långpass..nn.1
  långperiodisk_1_A = mkA "långperiodisk" ; -- långperiodisk..av.1
  långpolska_1_N = mkN "långpolska" ; -- långpolska..nn.1
  långpromenad_1_N = mkN "långpromenad" "långpromenader" ; -- långpromenad..nn.1
  långprosa_1_N = mkN "långprosa" ; -- långprosa..nn.1
  långrandig_1_A = mkA "långrandig" ; -- långrandig..av.1
  långrandighet_1_N = mkN "långrandighet" ; -- långrandighet..nn.1
  långresa_1_N = mkN "långresa" ; -- långresa..nn.1
  långrev_1_N = mkN "långrev" ; -- långrev..nn.1
  långrock_1_N = mkN "långrock" ; -- långrock..nn.1
  långsalning_1_N = mkN "långsalning" ; -- långsalning..nn.1
  långsam_1_A = mkA "långsam" "långsamt" "långsamma" "långsamma" "långsammare" "långsammast" "långsammaste" ; -- långsam..av.1
  långsamhet_1_N = mkN "långsamhet" ; -- långsamhet..nn.1
  långschal_1_N = mkN "långschal" ; -- långschal..nn.1
  långsida_1_N = mkN "långsida" ; -- långsida..nn.1
  långsiktig_1_A = mkA "långsiktig" ; -- långsiktig..av.1
  långsiktighet_1_N = mkN "långsiktighet" ; -- långsiktighet..nn.1
  långsint_1_A = mkA "långsint" "långsint" ; -- långsint..av.1
  långsinthet_1_N = mkN "långsinthet" ; -- långsinthet..nn.1
  långsjal_1_N = mkN "långsjal" ; -- långsjal..nn.1
  långskaftad_1_A = mkA "långskaftad" ; -- långskaftad..av.1
  långskalle_1_N = mkN "långskalle" utrum  ; -- långskalle..nn.1
  långskallig_1_A = mkA "långskallig" ; -- långskallig..av.1
  långskallighet_1_N = mkN "långskallighet" ; -- långskallighet..nn.1
  långskepp_1_N = mkN "långskepp" neutrum  ; -- långskepp..nn.1
  långskott_1_N = mkN "långskott" neutrum  ; -- långskott..nn.1
  långsluttande_1_A = mkA "långsluttande" ; -- långsluttande..av.1
  långsmal_1_A = mkA "långsmal" ; -- långsmal..av.1
  långspant_1_N = mkN "långspant" neutrum  ; -- långspant..nn.1
  långspel_1_N = mkN "långspel" "långspelet" "långspel" "långspelen" ; -- långspel..nn.1
  långstrumpa_1_N = mkN "långstrumpa" ; -- långstrumpa..nn.1
  långsträckt_1_A = mkA "långsträckt" "långsträckt" ; -- långsträckt..av.1
  långsvansad_1_A = mkA "långsvansad" ; -- långsvansad..av.1
  långsynt_1_A = mkA "långsynt" "långsynt" ; -- långsynt..av.1
  långsynthet_1_N = mkN "långsynthet" "långsyntheter" ; -- långsynthet..nn.1
  långsökt_1_A = mkA "långsökt" "långsökt" ; -- långsökt..av.1
  långsökthet_1_N = mkN "långsökthet" ; -- långsökthet..nn.1
  långtandad_1_A = mkA "långtandad" ; -- långtandad..av.1
  långtborta_1_Adv = mkAdv "långtborta" ; -- långtborta..ab.1
  långtbortifrån_1_Adv = mkAdv "långtbortifrån" ; -- långtbortifrån..ab.1
  långtgående_1_A = mkA "långtgående" ; -- långtgående..av.1
  långtidsarbetslös_1_A = mkA "långtidsarbetslös" ; -- långtidsarbetslös..av.1
  långtidsbehandling_1_N = mkN "långtidsbehandling" ; -- långtidsbehandling..nn.1
  långtidsförvaring_1_N = mkN "långtidsförvaring" ; -- långtidsförvaring..nn.1
  långtidsminne_1_N = mkN "långtidsminne" ; -- långtidsminne..nn.1
  långtidsparkera_1_V = mkV "långtidsparkerar" ; -- långtidsparkera..vb.1
  långtidsparkerande_1_N = mkN "långtidsparkerande" ; -- långtidsparkerande..nn.1
  långtidsparkerbar_1_A = mkA "långtidsparkerbar" ; -- långtidsparkerbar..av.1
  långtidsparkerbarhet_1_N = mkN "långtidsparkerbarhet" ; -- långtidsparkerbarhet..nn.1
  långtidsparkering_1_N = mkN "långtidsparkering" ; -- långtidsparkering..nn.1
  långtidsprognos_1_N = mkN "långtidsprognos" "långtidsprognoser" ; -- långtidsprognos..nn.1
  långtidssjuk_1_A = mkA "långtidssjuk" ; -- långtidssjuk..av.1
  långtidssjukfrånvaro_1_N = mkN "långtidssjukfrånvaro" ; -- långtidssjukfrånvaro..nn.1
  långtidssjukhet_1_N = mkN "långtidssjukhet" ; -- långtidssjukhet..nn.1
  långtidssjukskriven_1_A = mkA "långtidssjukskriven" ; -- långtidssjukskriven..av.1
  långtidsskadad_1_A = mkA "långtidsskadad" ; -- långtidsskadad..av.1
  långtidsskydd_1_N = mkN "långtidsskydd" neutrum  ; -- långtidsskydd..nn.1
  långtidssovare_1_N = mkN "långtidssovare" utrum  ; -- långtidssovare..nn.1
  långtidsverkande_1_A = mkA "långtidsverkande" ; -- långtidsverkande..av.1
  långtidsvikariat_1_N = mkN "långtidsvikariat" neutrum  ; -- långtidsvikariat..nn.1
  långtifrån_1_Adv = mkAdv "långtifrån" ; -- långtifrån..ab.1
  långtradarchaufför_1_N = mkN "långtradarchaufför" "långtradarchaufförer" ; -- långtradarchaufför..nn.1
  långtradare_1_N = mkN "långtradare" utrum  ; -- långtradare..nn.1
  långtradarmotor_1_N = mkN "långtradarmotor" "långtradarmotorer" ; -- långtradarmotor..nn.1
  långtradig_1_A = mkA "långtradig" ; -- långtradig..av.1
  långtradighet_1_N = mkN "långtradighet" ; -- långtradighet..nn.1
  långtrådig_1_A = mkA "långtrådig" ; -- långtrådig..av.1
  långtrådighet_1_N = mkN "långtrådighet" ; -- långtrådighet..nn.1
  långtråkig_1_A = mkA "långtråkig" ; -- långtråkig..av.1
  långtråkighet_1_N = mkN "långtråkighet" ; -- långtråkighet..nn.1
  långtur_1_N = mkN "långtur" "långturer" ; -- långtur..nn.1
  långvarig_1_A = mkA "långvarig" ; -- långvarig..av.1
  långvarighet_1_N = mkN "långvarighet" ; -- långvarighet..nn.1
  långved_1_N = mkN "långved" ; -- långved..nn.1
  långvirke_1_N = mkN "långvirke" ; -- långvirke..nn.1
  långväga_1_A = mkA "långväga" ; -- långväga..av.1
  långvägg_1_N = mkN "långvägg" ; -- långvägg..nn.1
  långvåg_1_N = mkN "långvåg" "långvågor" ; -- långvåg..nn.1
  långvågig_1_A = mkA "långvågig" ; -- långvågig..av.1
  långvård_1_N = mkN "långvård" ; -- långvård..nn.1
  långärmad_1_A = mkA "långärmad" ; -- långärmad..av.1
  långörad_1_A = mkA "långörad" ; -- långörad..av.1
  lånord_1_N = mkN "lånord" neutrum  ; -- lånord..nn.1
  lånspara_1_V = mkV "lånsparar" ; -- lånspara..vb.1
  lånsparande_1_N = mkN "lånsparande" ; -- lånsparande..nn.1
  lånsökande_1_N = mkN "lånsökande" "lånsökanden" "lånsökanden" "lånsökandena" ; -- lånsökande..nn.1
  lånt_1_A = mkA "lånt" "lånt" ; -- lånt..av.1
  låntagande_1_A = mkA "låntagande" ; -- låntagande..av.1
  låntagare_1_N = mkN "låntagare" utrum  ; -- låntagare..nn.1
  lår_1_N = mkN "lår" neutrum  ; -- lår..nn.1
  lår_2_N = mkN "lår" ; -- lår..nn.2
  lårben_1_N = mkN "lårben" neutrum  ; -- lårben..nn.1
  lårbensbrott_1_N = mkN "lårbensbrott" neutrum  ; -- lårbensbrott..nn.1
  lårbensfraktur_1_N = mkN "lårbensfraktur" "lårbensfrakturer" ; -- lårbensfraktur..nn.1
  lårbenshals_1_N = mkN "lårbenshals" ; -- lårbenshals..nn.1
  lårding_1_N = mkN "lårding" ; -- lårding..nn.1
  lårhög_1_A = mkA "lårhög" ; -- lårhög..av.1
  låring_1_N = mkN "låring" ; -- låring..nn.1
  låringsvind_1_N = mkN "låringsvind" ; -- låringsvind..nn.1
  låringsvis_1_Adv = mkAdv "låringsvis" ; -- låringsvis..ab.1
  lårkaka_1_N = mkN "lårkaka" ; -- lårkaka..nn.1
  lårmuskel_1_N = mkN "lårmuskel" "lårmuskeln" "lårmuskler" "lårmusklerna" ; -- lårmuskel..nn.1
  lårstycke_1_N = mkN "lårstycke" ; -- lårstycke..nn.1
  lås_1_N = mkN "lås" ; -- lås..nn.1
  låsa_1_V = mkV "låser" ; -- låsa..vb.1
  låsande_1_N = mkN "låsande" ; -- låsande..nn.1
  låsanordning_1_N = mkN "låsanordning" ; -- låsanordning..nn.1
  låsbar_1_A = mkA "låsbar" ; -- låsbar..av.1
  låsbarhet_1_N = mkN "låsbarhet" ; -- låsbarhet..nn.1
  låsbeslag_1_N = mkN "låsbeslag" neutrum  ; -- låsbeslag..nn.1
  låsbricka_1_N = mkN "låsbricka" ; -- låsbricka..nn.1
  låsfirma_1_N = mkN "låsfirma" ; -- låsfirma..nn.1
  låshylsa_1_N = mkN "låshylsa" ; -- låshylsa..nn.1
  låskolv_1_N = mkN "låskolv" ; -- låskolv..nn.1
  låsmutter_1_N = mkN "låsmutter" ; -- låsmutter..nn.1
  låsning_1_N = mkN "låsning" ; -- låsning..nn.1
  låsningsfri_1_A = mkA "låsningsfri" "låsningsfritt" ; -- låsningsfri..av.1
  låsolja_1_N = mkN "låsolja" ; -- låsolja..nn.1
  låssa_1_V = mkV "låssar" ; -- låssa..vb.1
  låssande_1_N = mkN "låssande" ; -- låssande..nn.1
  låssaskaka_1_N = mkN "låssaskaka" ; -- låssaskaka..nn.1
  låssaslek_1_N = mkN "låssaslek" ; -- låssaslek..nn.1
  låssasvärld_1_N = mkN "låssasvärld" ; -- låssasvärld..nn.1
  låsskruv_1_N = mkN "låsskruv" ; -- låsskruv..nn.1
  låsslunga_1_N = mkN "låsslunga" ; -- låsslunga..nn.1
  låssmed_1_N = mkN "låssmed" "låssmeder" ; -- låssmed..nn.1
  låssprint_1_N = mkN "låssprint" ; -- låssprint..nn.1
  låsvred_1_N = mkN "låsvred" neutrum  ; -- låsvred..nn.1
  låt_1_N = mkN "låt" ; -- låt..nn.1
  låt_2_N = mkN "låt" ; -- låt..nn.2
  låta_1_V = mkV "låta" "lät" "låtit" ; -- låta..vb.1
  låtande_1_N = mkN "låtande" ; -- låtande..nn.1
  låtgåpolitik_1_N = mkN "låtgåpolitik" ; -- låtgåpolitik..nn.1
  låtgåsystem_1_N = mkN "låtgåsystem" neutrum  ; -- låtgåsystem..nn.1
  låtmässig_1_A = mkA "låtmässig" ; -- låtmässig..av.1
  låtsa_1_V = mkV "låtsar" ; -- låtsa..vb.1
  låtsande_1_N = mkN "låtsande" ; -- låtsande..nn.1
  låtsasbrottning_1_N = mkN "låtsasbrottning" ; -- låtsasbrottning..nn.1
  låtsascigarett_1_N = mkN "låtsascigarett" "låtsascigaretter" ; -- låtsascigarett..nn.1
  låtsasdemokrati_1_N = mkN "låtsasdemokrati" ; -- låtsasdemokrati..nn.1
  låtsasfigur_1_N = mkN "låtsasfigur" "låtsasfigurer" ; -- låtsasfigur..nn.1
  låtsaskaka_1_N = mkN "låtsaskaka" ; -- låtsaskaka..nn.1
  låtsaskamrat_1_N = mkN "låtsaskamrat" "låtsaskamrater" ; -- låtsaskamrat..nn.1
  låtsasland_1_N = mkN "låtsasland" "låtsaslandet" "låtsasländer" "låtsasländerna" ; -- låtsasland..nn.1
  låtsaslek_1_N = mkN "låtsaslek" ; -- låtsaslek..nn.1
  låtsasvärld_1_N = mkN "låtsasvärld" ; -- låtsasvärld..nn.1
  låtskrivande_1_A = mkA "låtskrivande" ; -- låtskrivande..av.1
  låtskrivande_1_N = mkN "låtskrivande" ; -- låtskrivande..nn.1
  låtskrivare_1_N = mkN "låtskrivare" utrum  ; -- låtskrivare..nn.1
  låtstöld_1_N = mkN "låtstöld" "låtstölder" ; -- låtstöld..nn.1
  låttext_1_N = mkN "låttext" "låttexter" ; -- låttext..nn.1
  læstadian_1_N = mkN "læstadian" "læstadianer" ; -- læstadian..nn.1
  læstadianism_1_N = mkN "læstadianism" "læstadianismer" ; -- læstadianism..nn.1
  löd_1_N = mkN "löd" neutrum  ; -- löd..nn.1
  löda_1_V = mkV "löda" "lödde" "lött" ; -- löda..vb.1
  lödande_1_N = mkN "lödande" ; -- lödande..nn.1
  lödder_1_N = mkN "lödder" neutrum  ; -- lödder..nn.1
  löddra_1_N = mkN "löddra" ; -- löddra..nn.1
  löddra_1_V = mkV "löddrar" ; -- löddra..vb.1
  löddrande_1_N = mkN "löddrande" ; -- löddrande..nn.1
  löddrig_1_A = mkA "löddrig" ; -- löddrig..av.1
  löddrighet_1_N = mkN "löddrighet" ; -- löddrighet..nn.1
  lödfog_1_N = mkN "lödfog" ; -- lödfog..nn.1
  lödig_1_A = mkA "lödig" ; -- lödig..av.1
  lödighet_1_N = mkN "lödighet" ; -- lödighet..nn.1
  lödkolv_1_N = mkN "lödkolv" ; -- lödkolv..nn.1
  lödmetall_1_N = mkN "lödmetall" "lödmetaller" ; -- lödmetall..nn.1
  lödning_1_N = mkN "lödning" ; -- lödning..nn.1
  lödpenna_1_N = mkN "lödpenna" ; -- lödpenna..nn.1
  lödverktyg_1_N = mkN "lödverktyg" neutrum  ; -- lödverktyg..nn.1
  löfte_1_N = mkN "löfte" ; -- löfte..nn.1
  löftesbrott_1_N = mkN "löftesbrott" neutrum  ; -- löftesbrott..nn.1
  löftesbrytare_1_N = mkN "löftesbrytare" utrum  ; -- löftesbrytare..nn.1
  löftesman_1_N = mkN "löftesman" "löftesmannen" "löftesmän" "löftesmännen" ; -- löftesman..nn.1
  löftesrik_1_A = mkA "löftesrik" ; -- löftesrik..av.1
  löftesrikhet_1_N = mkN "löftesrikhet" ; -- löftesrikhet..nn.1
  löftesskrift_1_N = mkN "löftesskrift" "löftesskrifter" ; -- löftesskrift..nn.1
  löga_1_V = mkV "lögar" ; -- löga..vb.1
  lögande_1_N = mkN "lögande" ; -- lögande..nn.1
  lögn_1_N = mkN "lögn" "lögner" ; -- lögn..nn.1
  lögnaktig_1_A = mkA "lögnaktig" ; -- lögnaktig..av.1
  lögnaktighet_1_N = mkN "lögnaktighet" "lögnaktigheter" ; -- lögnaktighet..nn.1
  lögnare_1_N = mkN "lögnare" utrum  ; -- lögnare..nn.1
  lögndetektor_1_N = mkN "lögndetektor" "lögndetektorer" ; -- lögndetektor..nn.1
  lögnhals_1_N = mkN "lögnhals" ; -- lögnhals..nn.1
  lögnhistoria_1_N = mkN "lögnhistoria" "lögnhistorian" "lögnhistorier" "lögnhistorierna" ; -- lögnhistoria..nn.1
  lögning_1_N = mkN "lögning" ; -- lögning..nn.1
  lögnkampanj_1_N = mkN "lögnkampanj" "lögnkampanjer" ; -- lögnkampanj..nn.1
  löja_1_N = mkN "löja" ; -- löja..nn.1
  löje_1_N = mkN "löje" ; -- löje..nn.1
  löjeväckande_1_A = mkA "löjeväckande" ; -- löjeväckande..av.1
  löjlig_1_A = mkA "löjlig" ; -- löjlig..av.1
  löjlighet_1_N = mkN "löjlighet" "löjligheter" ; -- löjlighet..nn.1
  löjtnant_1_N = mkN "löjtnant" "löjtnanter" ; -- löjtnant..nn.1
  löjtnantshjärta_1_N = mkN "löjtnantshjärta" "löjtnantshjärtat" "löjtnantshjärtan" "löjtnantshjärtana" ; -- löjtnantshjärta..nn.1
  lök_1_N = mkN "lök" ; -- lök..nn.1
  lökfjäll_1_N = mkN "lökfjäll" neutrum  ; -- lökfjäll..nn.1
  lökformig_1_A = mkA "lökformig" ; -- lökformig..av.1
  lökig_1_A = mkA "lökig" ; -- lökig..av.1
  lökighet_1_N = mkN "lökighet" "lökigheter" ; -- lökighet..nn.1
  lökknopp_1_N = mkN "lökknopp" ; -- lökknopp..nn.1
  lökkupol_1_N = mkN "lökkupol" "lökkupoler" ; -- lökkupol..nn.1
  löksill_1_N = mkN "löksill" ; -- löksill..nn.1
  lökstam_1_N = mkN "lökstam" "lökstammen" "lökstammar" "lökstammarna" ; -- lökstam..nn.1
  löksås_1_N = mkN "löksås" "löksåser" ; -- löksås..nn.1
  lökväxt_1_N = mkN "lökväxt" "lökväxter" ; -- lökväxt..nn.1
  lömsk_1_A = mkA "lömsk" ; -- lömsk..av.1
  lömskhet_1_N = mkN "lömskhet" ; -- lömskhet..nn.1
  lömskna_1_V = mkV "lömsknar" ; -- lömskna..vb.1
  lömsknande_1_N = mkN "lömsknande" ; -- lömsknande..nn.1
  lön_1_N = mkN "lön" "löner" ; -- lön..nn.1
  löna_1_V = mkV "lönar" ; -- löna..vb.1
  lönande_1_A = mkA "lönande" ; -- lönande..av.1
  lönande_1_N = mkN "lönande" ; -- lönande..nn.1
  löneanspråk_1_N = mkN "löneanspråk" neutrum  ; -- löneanspråk..nn.1
  lönearbetare_1_N = mkN "lönearbetare" utrum  ; -- lönearbetare..nn.1
  löneavdrag_1_N = mkN "löneavdrag" neutrum  ; -- löneavdrag..nn.1
  löneavtal_1_N = mkN "löneavtal" neutrum  ; -- löneavtal..nn.1
  lönebesked_1_N = mkN "lönebesked" neutrum  ; -- lönebesked..nn.1
  lönebidrag_1_N = mkN "lönebidrag" neutrum  ; -- lönebidrag..nn.1
  lönebildning_1_N = mkN "lönebildning" ; -- lönebildning..nn.1
  lönecheck_1_N = mkN "lönecheck" ; -- lönecheck..nn.1
  lönedumpning_1_N = mkN "lönedumpning" ; -- lönedumpning..nn.1
  lönedumpningspolitik_1_N = mkN "lönedumpningspolitik" ; -- lönedumpningspolitik..nn.1
  lönefil_1_N = mkN "lönefil" "lönefiler" ; -- lönefil..nn.1
  löneförhandling_1_N = mkN "löneförhandling" ; -- löneförhandling..nn.1
  löneförhöjning_1_N = mkN "löneförhöjning" ; -- löneförhöjning..nn.1
  löneförmån_1_N = mkN "löneförmån" "löneförmåner" ; -- löneförmån..nn.1
  lönegap_1_N = mkN "lönegap" neutrum  ; -- lönegap..nn.1
  lönegaranti_1_N = mkN "lönegaranti" "lönegarantier" ; -- lönegaranti..nn.1
  löneglidning_1_N = mkN "löneglidning" ; -- löneglidning..nn.1
  lönegrad_1_N = mkN "lönegrad" "lönegrader" ; -- lönegrad..nn.1
  lönehöjning_1_N = mkN "lönehöjning" ; -- lönehöjning..nn.1
  löneklass_1_N = mkN "löneklass" "löneklasser" ; -- löneklass..nn.1
  löneklipp_1_N = mkN "löneklipp" neutrum  ; -- löneklipp..nn.1
  löneklyfta_1_N = mkN "löneklyfta" ; -- löneklyfta..nn.1
  lönekostnad_1_N = mkN "lönekostnad" "lönekostnader" ; -- lönekostnad..nn.1
  lönekuvert_1_N = mkN "lönekuvert" neutrum  ; -- lönekuvert..nn.1
  lönelyft_1_N = mkN "lönelyft" neutrum  ; -- lönelyft..nn.1
  löneläge_1_N = mkN "löneläge" ; -- löneläge..nn.1
  lönemässig_1_A = mkA "lönemässig" ; -- lönemässig..av.1
  lönenivå_1_N = mkN "lönenivå" "lönenivåer" ; -- lönenivå..nn.1
  löneplan_1_N = mkN "löneplan" "löneplaner" ; -- löneplan..nn.1
  lönepolitik_1_N = mkN "lönepolitik" ; -- lönepolitik..nn.1
  lönepolitisk_1_A = mkA "lönepolitisk" ; -- lönepolitisk..av.1
  löneprotest_1_N = mkN "löneprotest" "löneprotester" ; -- löneprotest..nn.1
  lönepåslag_1_N = mkN "lönepåslag" neutrum  ; -- lönepåslag..nn.1
  lönerutin_1_N = mkN "lönerutin" "lönerutiner" ; -- lönerutin..nn.1
  lönerättvisa_1_N = mkN "lönerättvisa" ; -- lönerättvisa..nn.1
  lönerörelse_1_N = mkN "lönerörelse" "lönerörelser" ; -- lönerörelse..nn.1
  löneskillnad_1_N = mkN "löneskillnad" "löneskillnader" ; -- löneskillnad..nn.1
  löneslav_1_N = mkN "löneslav" ; -- löneslav..nn.1
  lönestopp_1_N = mkN "lönestopp" neutrum  ; -- lönestopp..nn.1
  lönesystem_1_N = mkN "lönesystem" neutrum  ; -- lönesystem..nn.1
  lönesättning_1_N = mkN "lönesättning" ; -- lönesättning..nn.1
  lönetak_1_N = mkN "lönetak" neutrum  ; -- lönetak..nn.1
  lönetillägg_1_N = mkN "lönetillägg" neutrum  ; -- lönetillägg..nn.1
  löneuppgift_1_N = mkN "löneuppgift" "löneuppgifter" ; -- löneuppgift..nn.1
  löneutveckling_1_N = mkN "löneutveckling" ; -- löneutveckling..nn.1
  löneökning_1_N = mkN "löneökning" ; -- löneökning..nn.1
  löning_1_N = mkN "löning" ; -- löning..nn.1
  lönlös_1_A = mkA "lönlös" ; -- lönlös..av.1
  lönlöshet_1_N = mkN "lönlöshet" ; -- lönlöshet..nn.1
  lönn_1_N = mkN "lönn" ; -- lönn..nn.1
  lönnbränneri_1_N = mkN "lönnbränneri" "lönnbränneriet" "lönnbrännerier" "lönnbrännerierna" ; -- lönnbränneri..nn.1
  lönnbränning_1_N = mkN "lönnbränning" ; -- lönnbränning..nn.1
  lönndörr_1_N = mkN "lönndörr" ; -- lönndörr..nn.1
  lönnfack_1_N = mkN "lönnfack" neutrum  ; -- lönnfack..nn.1
  lönnfet_1_A = mkA "lönnfet" ; -- lönnfet..av.1
  lönngång_1_N = mkN "lönngång" ; -- lönngång..nn.1
  lönnkrog_1_N = mkN "lönnkrog" ; -- lönnkrog..nn.1
  lönnlig_1_A = mkA "lönnlig" ; -- lönnlig..av.1
  lönnligen_1_Adv = mkAdv "lönnligen" ; -- lönnligen..ab.1
  lönnlighet_1_N = mkN "lönnlighet" ; -- lönnlighet..nn.1
  lönnlöv_1_N = mkN "lönnlöv" neutrum  ; -- lönnlöv..nn.1
  lönnmord_1_N = mkN "lönnmord" neutrum  ; -- lönnmord..nn.1
  lönnmörda_1_V = mkV "lönnmördar" ; -- lönnmörda..vb.1
  lönnmördande_1_N = mkN "lönnmördande" ; -- lönnmördande..nn.1
  lönnmördare_1_N = mkN "lönnmördare" utrum  ; -- lönnmördare..nn.1
  lönnrum_1_N = mkN "lönnrum" "lönnrummet" "lönnrum" "lönnrummen" ; -- lönnrum..nn.1
  lönnruna_1_N = mkN "lönnruna" ; -- lönnruna..nn.1
  lönnskrift_1_N = mkN "lönnskrift" ; -- lönnskrift..nn.1
  lönntrappa_1_N = mkN "lönntrappa" ; -- lönntrappa..nn.1
  lönsam_1_A = mkA "lönsam" "lönsamt" "lönsamma" "lönsamma" "lönsammare" "lönsammast" "lönsammaste" ; -- lönsam..av.1
  lönsamhet_1_N = mkN "lönsamhet" "lönsamheter" ; -- lönsamhet..nn.1
  lönskaläge_1_N = mkN "lönskaläge" ; -- lönskaläge..nn.1
  lönskaläger_1_N = mkN "lönskaläger" neutrum  ; -- lönskaläger..nn.1
  lönspara_1_V = mkV "lönsparar" ; -- lönspara..vb.1
  lönsparande_1_N = mkN "lönsparande" ; -- lönsparande..nn.1
  lönt_1_A = mkA "lönt" ; -- lönt..av.1
  löntagare_1_N = mkN "löntagare" utrum  ; -- löntagare..nn.1
  löntagarfond_1_N = mkN "löntagarfond" "löntagarfonder" ; -- löntagarfond..nn.1
  löp_1_N = mkN "löp" neutrum  ; -- löp..nn.1
  löpa_1_N = mkN "löpa" ; -- löpa..nn.1
  löpa_1_V = mkV "löper" ; -- löpa..vb.1
  löpa_2_V = mkV "löper" ; -- löpa..vb.2
  löpande_1_A = mkA "löpande" ; -- löpande..av.1
  löpande_1_N = mkN "löpande" ; -- löpande..nn.1
  löparbana_1_N = mkN "löparbana" ; -- löparbana..nn.1
  löpare_1_N = mkN "löpare" utrum  ; -- löpare..nn.1
  löparsten_1_N = mkN "löparsten" "löparstenen" "löparstenar" "löparstenarna" ; -- löparsten..nn.1
  löpband_1_N = mkN "löpband" neutrum  ; -- löpband..nn.1
  löpe_1_N = mkN "löpe" ; -- löpe..nn.1
  löpeld_1_N = mkN "löpeld" ; -- löpeld..nn.1
  löpeost_1_N = mkN "löpeost" ; -- löpeost..nn.1
  löpgrav_1_N = mkN "löpgrav" ; -- löpgrav..nn.1
  löphjul_1_N = mkN "löphjul" neutrum  ; -- löphjul..nn.1
  löpknut_1_N = mkN "löpknut" ; -- löpknut..nn.1
  löplina_1_N = mkN "löplina" ; -- löplina..nn.1
  löpmage_1_N = mkN "löpmage" utrum  ; -- löpmage..nn.1
  löpmaska_1_N = mkN "löpmaska" ; -- löpmaska..nn.1
  löpmeter_1_N = mkN "löpmeter" "löpmetern" "löpmeter" "löpmeterna" ; -- löpmeter..nn.1
  löpmässig_1_A = mkA "löpmässig" ; -- löpmässig..av.1
  löpna_1_V = mkV "löpnar" ; -- löpna..vb.1
  löpnande_1_N = mkN "löpnande" ; -- löpnande..nn.1
  löpning_1_N = mkN "löpning" ; -- löpning..nn.1
  löpord_1_N = mkN "löpord" neutrum  ; -- löpord..nn.1
  löpost_1_N = mkN "löpost" ; -- löpost..nn.1
  löpring_1_N = mkN "löpring" ; -- löpring..nn.1
  löpsedel_1_N = mkN "löpsedel" ; -- löpsedel..nn.1
  löpsedelsresa_1_N = mkN "löpsedelsresa" ; -- löpsedelsresa..nn.1
  löpsedelsspråk_1_N = mkN "löpsedelsspråk" neutrum  ; -- löpsedelsspråk..nn.1
  löpsk_1_A = mkA "löpsk" ; -- löpsk..av.1
  löpskhet_1_N = mkN "löpskhet" ; -- löpskhet..nn.1
  löpskift_1_N = mkN "löpskift" neutrum  ; -- löpskift..nn.1
  löpslinga_1_N = mkN "löpslinga" ; -- löpslinga..nn.1
  löpsnara_1_N = mkN "löpsnara" ; -- löpsnara..nn.1
  löpsteg_1_N = mkN "löpsteg" neutrum  ; -- löpsteg..nn.1
  löpsten_1_N = mkN "löpsten" "löpstenen" "löpstenar" "löpstenarna" ; -- löpsten..nn.1
  löpteknik_1_N = mkN "löpteknik" "löptekniker" ; -- löpteknik..nn.1
  löptid_1_N = mkN "löptid" "löptider" ; -- löptid..nn.1
  löptik_1_N = mkN "löptik" ; -- löptik..nn.1
  löpträning_1_N = mkN "löpträning" ; -- löpträning..nn.1
  löpvagn_1_N = mkN "löpvagn" ; -- löpvagn..nn.1
  löpvikt_1_N = mkN "löpvikt" "löpvikter" ; -- löpvikt..nn.1
  lördag_1_N = mkN "lördag" ; -- lördag..nn.1
  lördageftermiddag_1_N = mkN "lördageftermiddag" ; -- lördageftermiddag..nn.1
  lördagkväll_1_N = mkN "lördagkväll" ; -- lördagkväll..nn.1
  lördagmorgon_1_N = mkN "lördagmorgon" "lördagmorgonen" "lördagmornar" "lördagmornarna" ; -- lördagmorgon..nn.1
  lördagsbilaga_1_N = mkN "lördagsbilaga" ; -- lördagsbilaga..nn.1
  lördagseftermiddag_1_N = mkN "lördagseftermiddag" ; -- lördagseftermiddag..nn.1
  lördagsförmiddag_1_N = mkN "lördagsförmiddag" ; -- lördagsförmiddag..nn.1
  lördagsgodis_1_N = mkN "lördagsgodis" neutrum  ; -- lördagsgodis..nn.1
  lördagshippa_1_N = mkN "lördagshippa" ; -- lördagshippa..nn.1
  lördagskväll_1_N = mkN "lördagskväll" ; -- lördagskväll..nn.1
  lördagsmorgon_1_N = mkN "lördagsmorgon" "lördagsmorgonen" "lördagsmornar" "lördagsmornarna" ; -- lördagsmorgon..nn.1
  lördagsstängd_1_A = mkA "lördagsstängd" "lördagsstängt" ; -- lördagsstängd..av.1
  lördagstrafik_1_N = mkN "lördagstrafik" ; -- lördagstrafik..nn.1
  lördagsöppen_1_A = mkA "lördagsöppen" ; -- lördagsöppen..av.1
  lös_1_A = mkA "lös" ; -- lös..av.1
  lös_2_A = mkA "lös" ; -- lös..av.2
  lösa_1_V = mkV "löser" ; -- lösa..vb.1
  lösaktig_1_A = mkA "lösaktig" ; -- lösaktig..av.1
  lösaktighet_1_N = mkN "lösaktighet" ; -- lösaktighet..nn.1
  lösan_1_A = mkA "lösan" ; -- lösan..av.1
  lösande_1_A = mkA "lösande" ; -- lösande..av.1
  lösande_1_N = mkN "lösande" ; -- lösande..nn.1
  lösbar_1_A = mkA "lösbar" ; -- lösbar..av.1
  lösbarhet_1_N = mkN "lösbarhet" ; -- lösbarhet..nn.1
  lösbladssystem_1_N = mkN "lösbladssystem" neutrum  ; -- lösbladssystem..nn.1
  lösbruten_1_A = mkA "lösbruten" ; -- lösbruten..av.1
  lösbrytning_1_N = mkN "lösbrytning" ; -- lösbrytning..nn.1
  lösdrift_1_N = mkN "lösdrift" ; -- lösdrift..nn.1
  lösdrivare_1_N = mkN "lösdrivare" utrum  ; -- lösdrivare..nn.1
  lösdriveri_1_N = mkN "lösdriveri" neutrum  ; -- lösdriveri..nn.1
  lösebelopp_1_N = mkN "lösebelopp" neutrum  ; -- lösebelopp..nn.1
  lösegendom_1_N = mkN "lösegendom" ; -- lösegendom..nn.1
  lösenbelopp_1_N = mkN "lösenbelopp" neutrum  ; -- lösenbelopp..nn.1
  lösenfånge_1_N = mkN "lösenfånge" utrum  ; -- lösenfånge..nn.1
  lösenord_1_N = mkN "lösenord" neutrum  ; -- lösenord..nn.1
  lösenordskrav_1_N = mkN "lösenordskrav" neutrum  ; -- lösenordskrav..nn.1
  lösenordsskyddad_1_A = mkA "lösenordsskyddad" ; -- lösenordsskyddad..av.1
  lösenpenning_1_N = mkN "lösenpenning" ; -- lösenpenning..nn.1
  lösenskilling_1_N = mkN "lösenskilling" ; -- lösenskilling..nn.1
  lösensumma_1_N = mkN "lösensumma" ; -- lösensumma..nn.1
  lösepenning_1_N = mkN "lösepenning" ; -- lösepenning..nn.1
  löseskilling_1_N = mkN "löseskilling" ; -- löseskilling..nn.1
  lösesumma_1_N = mkN "lösesumma" ; -- lösesumma..nn.1
  lösfynd_1_N = mkN "lösfynd" neutrum  ; -- lösfynd..nn.1
  lösge_1_V = mkV "lösgiva" "lösgav" "lösgivit" ; -- lösge..vb.1
  lösgivande_1_N = mkN "lösgivande" ; -- lösgivande..nn.1
  lösgivning_1_N = mkN "lösgivning" ; -- lösgivning..nn.1
  lösgodis_1_N = mkN "lösgodis" neutrum  ; -- lösgodis..nn.1
  lösgom_1_N = mkN "lösgom" "lösgommen" "lösgommar" "lösgommarna" ; -- lösgom..nn.1
  lösgående_1_A = mkA "lösgående" ; -- lösgående..av.1
  lösgöra_1_V = mkV "lösgöra" "lösgjorde" "lösgjort" ; -- lösgöra..vb.1
  lösgörande_1_N = mkN "lösgörande" ; -- lösgörande..nn.1
  löshet_1_N = mkN "löshet" ; -- löshet..nn.1
  löshäst_1_N = mkN "löshäst" ; -- löshäst..nn.1
  löshår_1_N = mkN "löshår" neutrum  ; -- löshår..nn.1
  löskekarl_1_N = mkN "löskekarl" ; -- löskekarl..nn.1
  löskerkarl_1_N = mkN "löskerkarl" ; -- löskerkarl..nn.1
  löskoka_1_V = mkV "löskokar" ; -- löskoka..vb.1
  löskokt_1_A = mkA "löskokt" "löskokt" ; -- löskokt..av.1
  löskoppling_1_N = mkN "löskoppling" ; -- löskoppling..nn.1
  löskrage_1_N = mkN "löskrage" utrum  ; -- löskrage..nn.1
  löslig_1_A = mkA "löslig" ; -- löslig..av.1
  löslighet_1_N = mkN "löslighet" ; -- löslighet..nn.1
  löslighet_2_N = mkN "löslighet" "lösligheter" ; -- löslighet..nn.2
  lösmage_1_N = mkN "lösmage" utrum  ; -- lösmage..nn.1
  lösmynt_1_A = mkA "lösmynt" "lösmynt" ; -- lösmynt..av.1
  lösmynthet_1_N = mkN "lösmynthet" ; -- lösmynthet..nn.1
  lösning_1_N = mkN "lösning" ; -- lösning..nn.1
  lösningsegenskap_1_N = mkN "lösningsegenskap" "lösningsegenskaper" ; -- lösningsegenskap..nn.1
  lösningsmedel_1_N = mkN "lösningsmedel" neutrum  ; -- lösningsmedel..nn.1
  lösningsmedelsbaserad_1_A = mkA "lösningsmedelsbaserad" ; -- lösningsmedelsbaserad..av.1
  lösningsrätt_1_N = mkN "lösningsrätt" ; -- lösningsrätt..nn.1
  lösnummer_1_N = mkN "lösnummer" neutrum  ; -- lösnummer..nn.1
  lösnummerförsäljning_1_N = mkN "lösnummerförsäljning" ; -- lösnummerförsäljning..nn.1
  lösnäsa_1_N = mkN "lösnäsa" ; -- lösnäsa..nn.1
  lösrivning_1_N = mkN "lösrivning" ; -- lösrivning..nn.1
  lösryckning_1_N = mkN "lösryckning" ; -- lösryckning..nn.1
  lösryckt_1_A = mkA "lösryckt" "lösryckt" ; -- lösryckt..av.1
  lösryckthet_1_N = mkN "lösryckthet" ; -- lösryckthet..nn.1
  lösrygg_1_N = mkN "lösrygg" ; -- lösrygg..nn.1
  löss_1_N = mkN "löss" ; -- löss..nn.1
  löss_2_N = mkN "löss" neutrum  ; -- löss..nn.2
  lössjord_1_N = mkN "lössjord" ; -- lössjord..nn.1
  lösskägg_1_N = mkN "lösskägg" neutrum  ; -- lösskägg..nn.1
  lösslitning_1_N = mkN "lösslitning" ; -- lösslitning..nn.1
  lössläppning_1_N = mkN "lössläppning" ; -- lössläppning..nn.1
  lössläppt_1_A = mkA "lössläppt" "lössläppt" ; -- lössläppt..av.1
  lössläppthet_1_N = mkN "lössläppthet" ; -- lössläppthet..nn.1
  lössnö_1_N = mkN "lössnö" ; -- lössnö..nn.1
  lösspringande_1_A = mkA "lösspringande" ; -- lösspringande..av.1
  löstagbar_1_A = mkA "löstagbar" ; -- löstagbar..av.1
  löstagbarhet_1_N = mkN "löstagbarhet" ; -- löstagbarhet..nn.1
  lösögonfrans_1_N = mkN "lösögonfrans" ; -- lösögonfrans..nn.1
  lösöre_1_N = mkN "lösöre" ; -- lösöre..nn.1
  lösöreköp_1_N = mkN "lösöreköp" neutrum  ; -- lösöreköp..nn.1
  löt_1_N = mkN "löt" ; -- löt..nn.1
  löv_1_N = mkN "löv" neutrum  ; -- löv..nn.1
  löva_1_V = mkV "lövar" ; -- löva..vb.1
  lövande_1_N = mkN "lövande" ; -- lövande..nn.1
  lövbiff_1_N = mkN "lövbiff" ; -- lövbiff..nn.1
  lövblandskog_1_N = mkN "lövblandskog" ; -- lövblandskog..nn.1
  lövblås_1_N = mkN "lövblås" ; -- lövblås..nn.1
  lövfoder_1_N = mkN "lövfoder" neutrum  ; -- lövfoder..nn.1
  lövfällande_1_A = mkA "lövfällande" ; -- lövfällande..av.1
  lövfällning_1_N = mkN "lövfällning" ; -- lövfällning..nn.1
  lövgroda_1_N = mkN "lövgroda" ; -- lövgroda..nn.1
  lövhyddohögtid_1_N = mkN "lövhyddohögtid" "lövhyddohögtider" ; -- lövhyddohögtid..nn.1
  lövhög_1_N = mkN "lövhög" ; -- lövhög..nn.1
  lövig_1_A = mkA "lövig" ; -- lövig..av.1
  lövjord_1_N = mkN "lövjord" ; -- lövjord..nn.1
  lövkasse_1_N = mkN "lövkasse" utrum  ; -- lövkasse..nn.1
  lövklädd_1_A = mkA "lövklädd" ; -- lövklädd..av.1
  lövkoja_1_N = mkN "lövkoja" ; -- lövkoja..nn.1
  lövmask_1_N = mkN "lövmask" ; -- lövmask..nn.1
  lövmossa_1_N = mkN "lövmossa" ; -- lövmossa..nn.1
  lövrik_1_A = mkA "lövrik" ; -- lövrik..av.1
  lövrikedom_1_N = mkN "lövrikedom" ; -- lövrikedom..nn.1
  lövruska_1_N = mkN "lövruska" ; -- lövruska..nn.1
  lövsal_1_N = mkN "lövsal" ; -- lövsal..nn.1
  lövskog_1_N = mkN "lövskog" ; -- lövskog..nn.1
  lövsly_1_N = mkN "lövsly" neutrum  ; -- lövsly..nn.1
  lövsmyg_1_N = mkN "lövsmyg" ; -- lövsmyg..nn.1
  lövsprickning_1_N = mkN "lövsprickning" ; -- lövsprickning..nn.1
  lövsug_1_N = mkN "lövsug" ; -- lövsug..nn.1
  lövsåg_1_N = mkN "lövsåg" ; -- lövsåg..nn.1
  lövsågning_1_N = mkN "lövsågning" ; -- lövsågning..nn.1
  lövsångare_1_N = mkN "lövsångare" utrum  ; -- lövsångare..nn.1
  lövträ_1_N = mkN "lövträ" neutrum  ; -- lövträ..nn.1
  lövträd_1_N = mkN "lövträd" neutrum  ; -- lövträd..nn.1
  lövträdsglänta_1_N = mkN "lövträdsglänta" ; -- lövträdsglänta..nn.1
  lövtunn_1_A = mkA "lövtunn" "lövtunt" ; -- lövtunn..av.1
  lövtunnhet_1_N = mkN "lövtunnhet" ; -- lövtunnhet..nn.1
  lövtäkt_1_N = mkN "lövtäkt" "lövtäkter" ; -- lövtäkt..nn.1
  lövuppsamlare_1_N = mkN "lövuppsamlare" utrum  ; -- lövuppsamlare..nn.1
  lövverk_1_N = mkN "lövverk" neutrum  ; -- lövverk..nn.1
  löväng_1_N = mkN "löväng" ; -- löväng..nn.1
  m_1_N = mkN "m" neutrum  ; -- m..nn.1
  macchiato_1_N = mkN "macchiato" ; -- macchiato..nn.1
  macchiavellisk_1_A = mkA "macchiavellisk" ; -- macchiavellisk..av.1
  macchiavellism_1_N = mkN "macchiavellism" "macchiavellismer" ; -- macchiavellism..nn.1
  macchiavellistisk_1_A = mkA "macchiavellistisk" ; -- macchiavellistisk..av.1
  macedonisk_1_A = mkA "macedonisk" ; -- macedonisk..av.1
  macedonsk_1_A = mkA "macedonsk" ; -- macedonsk..av.1
  macedonska_1_N = mkN "macedonska" ; -- macedonska..nn.1
  macedonska_2_N = mkN "macedonska" ; -- macedonska..nn.2
  mach_1_N = mkN "mach" "machen" "mach" "machen" ; -- mach..nn.1
  machete_1_N = mkN "machete" "macheter" ; -- machete..nn.1
  machiavellisk_1_A = mkA "machiavellisk" ; -- machiavellisk..av.1
  machiavellism_1_N = mkN "machiavellism" "machiavellismer" ; -- machiavellism..nn.1
  machiavellistisk_1_A = mkA "machiavellistisk" ; -- machiavellistisk..av.1
  macho_1_A = mkA "macho" ; -- macho..av.1
  machogubbe_1_N = mkN "machogubbe" utrum  ; -- machogubbe..nn.1
  machoideal_1_N = mkN "machoideal" neutrum  ; -- machoideal..nn.1
  macholiv_1_N = mkN "macholiv" neutrum  ; -- macholiv..nn.1
  machomyt_1_N = mkN "machomyt" "machomyter" ; -- machomyt..nn.1
  machtal_1_N = mkN "machtal" neutrum  ; -- machtal..nn.1
  machverk_1_N = mkN "machverk" neutrum  ; -- machverk..nn.1
  mack_1_N = mkN "mack" ; -- mack..nn.1
  macka_1_N = mkN "macka" ; -- macka..nn.1
  mackapär_1_N = mkN "mackapär" "mackapärer" ; -- mackapär..nn.1
  mackbesök_1_N = mkN "mackbesök" neutrum  ; -- mackbesök..nn.1
  mackel_1_N = mkN "mackel" neutrum  ; -- mackel..nn.1
  mackla_1_V = mkV "macklar" ; -- mackla..vb.1
  macklande_1_N = mkN "macklande" ; -- macklande..nn.1
  mad_1_N = mkN "mad" "mader" ; -- mad..nn.1
  madagask_1_N = mkN "madagask" "madagasker" ; -- madagask..nn.1
  madagaskisk_1_A = mkA "madagaskisk" ; -- madagaskisk..av.1
  madagaskiska_1_N = mkN "madagaskiska" ; -- madagaskiska..nn.1
  madam_1_N = mkN "madam" "madammen" "madammer" "madammerna" ; -- madam..nn.1
  madame_1_N = mkN "madame" "madamer" ; -- madame..nn.1
  madapolam_1_N = mkN "madapolam" "madapolamer" ; -- madapolam..nn.1
  madeira_1_N = mkN "madeira" ; -- madeira..nn.1
  madeleinekaka_1_N = mkN "madeleinekaka" ; -- madeleinekaka..nn.1
  madonna_1_N = mkN "madonna" ; -- madonna..nn.1
  madonnalik_1_A = mkA "madonnalik" ; -- madonnalik..av.1
  madra_1_N = mkN "madra" ; -- madra..nn.1
  madrass_1_N = mkN "madrass" "madrasser" ; -- madrass..nn.1
  madrassera_1_V = mkV "madrasserar" ; -- madrassera..vb.1
  madrasserande_1_N = mkN "madrasserande" ; -- madrasserande..nn.1
  madrasserbar_1_A = mkA "madrasserbar" ; -- madrasserbar..av.1
  madrasserbarhet_1_N = mkN "madrasserbarhet" ; -- madrasserbarhet..nn.1
  madrassering_1_N = mkN "madrassering" ; -- madrassering..nn.1
  madrassfabrik_1_N = mkN "madrassfabrik" "madrassfabriker" ; -- madrassfabrik..nn.1
  madrassnål_1_N = mkN "madrassnål" ; -- madrassnål..nn.1
  madrigal_1_N = mkN "madrigal" "madrigaler" ; -- madrigal..nn.1
  maduska_1_N = mkN "maduska" ; -- maduska..nn.1
  maestro_1_N = mkN "maestro" ; -- maestro..nn.1
  maffia_1_N = mkN "maffia" ; -- maffia..nn.1
  maffiaavslöjare_1_N = mkN "maffiaavslöjare" utrum  ; -- maffiaavslöjare..nn.1
  maffiaboss_1_N = mkN "maffiaboss" ; -- maffiaboss..nn.1
  maffiafilm_1_N = mkN "maffiafilm" "maffiafilmer" ; -- maffiafilm..nn.1
  maffialiga_1_N = mkN "maffialiga" ; -- maffialiga..nn.1
  maffialiknande_1_A = mkA "maffialiknande" ; -- maffialiknande..av.1
  maffiamässig_1_A = mkA "maffiamässig" ; -- maffiamässig..av.1
  maffig_1_A = mkA "maffig" ; -- maffig..av.1
  maffighet_1_N = mkN "maffighet" ; -- maffighet..nn.1
  magasin_1_N = mkN "magasin" neutrum  ; -- magasin..nn.1
  magasinera_1_V = mkV "magasinerar" ; -- magasinera..vb.1
  magasinerande_1_N = mkN "magasinerande" ; -- magasinerande..nn.1
  magasinerbar_1_A = mkA "magasinerbar" ; -- magasinerbar..av.1
  magasinerbarhet_1_N = mkN "magasinerbarhet" ; -- magasinerbarhet..nn.1
  magasinering_1_N = mkN "magasinering" ; -- magasinering..nn.1
  magasinkärra_1_N = mkN "magasinkärra" ; -- magasinkärra..nn.1
  magbesvär_1_N = mkN "magbesvär" neutrum  ; -- magbesvär..nn.1
  magblödning_1_N = mkN "magblödning" ; -- magblödning..nn.1
  magborstare_1_N = mkN "magborstare" utrum  ; -- magborstare..nn.1
  magdans_1_N = mkN "magdans" "magdanser" ; -- magdans..nn.1
  magdansande_1_A = mkA "magdansande" ; -- magdansande..av.1
  magdansös_1_N = mkN "magdansös" "magdansöser" ; -- magdansös..nn.1
  mage_1_N = mkN "mage" utrum  ; -- mage..nn.1
  magenta_1_N = mkN "magenta" ; -- magenta..nn.1
  magentafärgad_1_A = mkA "magentafärgad" ; -- magentafärgad..av.1
  mager_1_A = mkA "mager" ; -- mager..av.1
  mager_1_N = mkN "mager" "magern" "mager" "magerna" ; -- mager..nn.1
  magerhet_1_N = mkN "magerhet" ; -- magerhet..nn.1
  magerlagd_1_A = mkA "magerlagd" "magerlagt" ; -- magerlagd..av.1
  magerlagdhet_1_N = mkN "magerlagdhet" ; -- magerlagdhet..nn.1
  magflora_1_N = mkN "magflora" ; -- magflora..nn.1
  maggrop_1_N = mkN "maggrop" ; -- maggrop..nn.1
  maggördel_1_N = mkN "maggördel" ; -- maggördel..nn.1
  magi_1_N = mkN "magi" ; -- magi..nn.1
  magier_1_N = mkN "magier" "magiern" "magier" "magierna" ; -- magier..nn.1
  magiker_1_N = mkN "magiker" "magikern" "magiker" "magikerna" ; -- magiker..nn.1
  maginflammation_1_N = mkN "maginflammation" ; -- maginflammation..nn.1
  maginfluensa_1_N = mkN "maginfluensa" ; -- maginfluensa..nn.1
  maginnehåll_1_N = mkN "maginnehåll" neutrum  ; -- maginnehåll..nn.1
  magisk_1_A = mkA "magisk" ; -- magisk..av.1
  magister_1_N = mkN "magister" ; -- magister..nn.1
  magisterexamen_1_N = mkN "magisterexamen" "magisterexamen" "magisterexamina" "magisterexamina" ; -- magisterexamen..nn.1
  magistral_1_A = mkA "magistral" ; -- magistral..av.1
  magistrat_1_N = mkN "magistrat" "magistrater" ; -- magistrat..nn.1
  magkatarr_1_N = mkN "magkatarr" "magkatarrer" ; -- magkatarr..nn.1
  magknip_1_N = mkN "magknip" neutrum  ; -- magknip..nn.1
  magkänsla_1_N = mkN "magkänsla" ; -- magkänsla..nn.1
  maglev_1_N = mkN "maglev" ; -- maglev..nn.1
  magma_1_N = mkN "magma" ; -- magma..nn.1
  magmabergart_1_N = mkN "magmabergart" "magmabergarter" ; -- magmabergart..nn.1
  magmaexplosion_1_N = mkN "magmaexplosion" ; -- magmaexplosion..nn.1
  magmakammare_1_N = mkN "magmakammare" "magmakammaren" "magmakammare" "magmakamrarna" ; -- magmakammare..nn.1
  magmatisk_1_A = mkA "magmatisk" ; -- magmatisk..av.1
  magmedicin_1_N = mkN "magmedicin" "magmediciner" ; -- magmedicin..nn.1
  magmun_1_N = mkN "magmun" "magmunnen" "magmunnar" "magmunnarna" ; -- magmun..nn.1
  magmuskel_1_N = mkN "magmuskel" "magmuskeln" "magmuskler" "magmusklerna" ; -- magmuskel..nn.1
  magnat_1_N = mkN "magnat" "magnater" ; -- magnat..nn.1
  magnecyl_1_N = mkN "magnecyl" "magnecylen" "magnecyl" "magnecylen" ; -- magnecyl..nn.1
  magnesit_1_N = mkN "magnesit" ; -- magnesit..nn.1
  magnesium_1_N = mkN "magnesium" neutrum  ; -- magnesium..nn.1
  magnesiumhus_1_N = mkN "magnesiumhus" neutrum  ; -- magnesiumhus..nn.1
  magnesiumlegering_1_N = mkN "magnesiumlegering" ; -- magnesiumlegering..nn.1
  magnesiumsulfat_1_N = mkN "magnesiumsulfat" "magnesiumsulfater" ; -- magnesiumsulfat..nn.1
  magnet_1_N = mkN "magnet" "magneter" ; -- magnet..nn.1
  magnetapparat_1_N = mkN "magnetapparat" "magnetapparater" ; -- magnetapparat..nn.1
  magnetband_1_N = mkN "magnetband" neutrum  ; -- magnetband..nn.1
  magnetfält_1_N = mkN "magnetfält" neutrum  ; -- magnetfält..nn.1
  magnetisera_1_V = mkV "magnetiserar" ; -- magnetisera..vb.1
  magnetiserande_1_N = mkN "magnetiserande" ; -- magnetiserande..nn.1
  magnetiserbar_1_A = mkA "magnetiserbar" ; -- magnetiserbar..av.1
  magnetiserbarhet_1_N = mkN "magnetiserbarhet" ; -- magnetiserbarhet..nn.1
  magnetisering_1_N = mkN "magnetisering" ; -- magnetisering..nn.1
  magnetisk_1_A = mkA "magnetisk" ; -- magnetisk..av.1
  magnetism_1_N = mkN "magnetism" "magnetismer" ; -- magnetism..nn.1
  magnetisör_1_N = mkN "magnetisör" "magnetisörer" ; -- magnetisör..nn.1
  magnetit_1_N = mkN "magnetit" ; -- magnetit..nn.1
  magnetkamera_1_N = mkN "magnetkamera" ; -- magnetkamera..nn.1
  magnetkompass_1_N = mkN "magnetkompass" "magnetkompasser" ; -- magnetkompass..nn.1
  magnetkort_1_N = mkN "magnetkort" neutrum  ; -- magnetkort..nn.1
  magnetmina_1_N = mkN "magnetmina" ; -- magnetmina..nn.1
  magnetnål_1_N = mkN "magnetnål" ; -- magnetnål..nn.1
  magnetofon_1_N = mkN "magnetofon" "magnetofoner" ; -- magnetofon..nn.1
  magnetpol_1_N = mkN "magnetpol" "magnetpoler" ; -- magnetpol..nn.1
  magnetremsa_1_N = mkN "magnetremsa" ; -- magnetremsa..nn.1
  magnetron_1_N = mkN "magnetron" "magnetroner" ; -- magnetron..nn.1
  magnetröntgenkamera_1_N = mkN "magnetröntgenkamera" ; -- magnetröntgenkamera..nn.1
  magnettändning_1_N = mkN "magnettändning" ; -- magnettändning..nn.1
  magnificens_1_N = mkN "magnificens" ; -- magnificens..nn.1
  magnificus_1_A = mkA "magnificus" ; -- magnificus..av.1
  magnifik_1_A = mkA "magnifik" ; -- magnifik..av.1
  magnitud_1_N = mkN "magnitud" "magnituder" ; -- magnitud..nn.1
  magnolia_1_N = mkN "magnolia" ; -- magnolia..nn.1
  magnum_1_A = mkA "magnum" ; -- magnum..av.1
  magnumbutelj_1_N = mkN "magnumbutelj" "magnumbuteljer" ; -- magnumbutelj..nn.1
  magplask_1_N = mkN "magplask" neutrum  ; -- magplask..nn.1
  magpumpa_1_V = mkV "magpumpar" ; -- magpumpa..vb.1
  magpumpande_1_N = mkN "magpumpande" ; -- magpumpande..nn.1
  magra_1_V = mkV "magrar" ; -- magra..vb.1
  magrande_1_N = mkN "magrande" ; -- magrande..nn.1
  magruta_1_N = mkN "magruta" ; -- magruta..nn.1
  magsaft_1_N = mkN "magsaft" "magsafter" ; -- magsaft..nn.1
  magsjuk_1_A = mkA "magsjuk" ; -- magsjuk..av.1
  magsjuka_1_N = mkN "magsjuka" ; -- magsjuka..nn.1
  magsjukdom_1_N = mkN "magsjukdom" ; -- magsjukdom..nn.1
  magsmitta_1_N = mkN "magsmitta" ; -- magsmitta..nn.1
  magsmärta_1_N = mkN "magsmärta" ; -- magsmärta..nn.1
  magstark_1_A = mkA "magstark" ; -- magstark..av.1
  magstarkhet_1_N = mkN "magstarkhet" ; -- magstarkhet..nn.1
  magsur_1_A = mkA "magsur" ; -- magsur..av.1
  magsurhet_1_N = mkN "magsurhet" ; -- magsurhet..nn.1
  magsyra_1_N = mkN "magsyra" ; -- magsyra..nn.1
  magsäck_1_N = mkN "magsäck" ; -- magsäck..nn.1
  magsår_1_N = mkN "magsår" neutrum  ; -- magsår..nn.1
  magsårsbakterie_1_N = mkN "magsårsbakterie" "magsårsbakterier" ; -- magsårsbakterie..nn.1
  magtrakt_1_N = mkN "magtrakt" "magtrakter" ; -- magtrakt..nn.1
  magyar_1_N = mkN "magyar" "magyarer" ; -- magyar..nn.1
  magövning_1_N = mkN "magövning" ; -- magövning..nn.1
  maharadja_1_N = mkN "maharadja" ; -- maharadja..nn.1
  mahatma_1_N = mkN "mahatma" ; -- mahatma..nn.1
  mahjong_1_N = mkN "mahjong" ; -- mahjong..nn.1
  mahognyfaner_1_N = mkN "mahognyfaner" "mahognyfaneret" "mahognyfaner" "mahognyfaneren" ; -- mahognyfaner..nn.1
  mahognyfanerad_1_A = mkA "mahognyfanerad" ; -- mahognyfanerad..av.1
  mahognyfanér_1_N = mkN "mahognyfanér" neutrum  ; -- mahognyfanér..nn.1
  mahognylaminat_1_N = mkN "mahognylaminat" neutrum  ; -- mahognylaminat..nn.1
  mahognylaminatdörr_1_N = mkN "mahognylaminatdörr" ; -- mahognylaminatdörr..nn.1
  mahognyliknande_1_A = mkA "mahognyliknande" ; -- mahognyliknande..av.1
  mahognymotorjakt_1_N = mkN "mahognymotorjakt" "mahognymotorjakter" ; -- mahognymotorjakt..nn.1
  mahognystock_1_N = mkN "mahognystock" ; -- mahognystock..nn.1
  mahognyyta_1_N = mkN "mahognyyta" ; -- mahognyyta..nn.1
  mahonia_1_N = mkN "mahonia" ; -- mahonia..nn.1
  mail_1_N = mkN "mail" ; -- mail..nn.1
  mail_2_N = mkN "mail" neutrum  ; -- mail..nn.2
  maila_1_V = mkV "mailar" ; -- maila..vb.1
  mailande_1_N = mkN "mailande" ; -- mailande..nn.1
  mailare_1_N = mkN "mailare" utrum  ; -- mailare..nn.1
  mailledes_1_Adv = mkAdv "mailledes" ; -- mailledes..ab.1
  mainstream_1_N = mkN "mainstream" "mainstreamer" ; -- mainstream..nn.1
  mainstreama_1_V = mkV "mainstreamar" ; -- mainstreama..vb.1
  maj_1_N = mkN "maj" ; -- maj..nn.1
  maj_2_N = mkN "maj" ; -- maj..nn.2
  maja_1_V = mkV "majar" ; -- maja..vb.1
  majande_1_N = mkN "majande" ; -- majande..nn.1
  majbagge_1_N = mkN "majbagge" utrum  ; -- majbagge..nn.1
  majblomma_1_N = mkN "majblomma" ; -- majblomma..nn.1
  majbrud_1_N = mkN "majbrud" ; -- majbrud..nn.1
  majdag_1_N = mkN "majdag" ; -- majdag..nn.1
  majestät_1_N = mkN "majestät" neutrum  ; -- majestät..nn.1
  majestätisk_1_A = mkA "majestätisk" ; -- majestätisk..av.1
  majestätlig_1_A = mkA "majestätlig" ; -- majestätlig..av.1
  majestätlighet_1_N = mkN "majestätlighet" ; -- majestätlighet..nn.1
  majestätsbrott_1_N = mkN "majestätsbrott" neutrum  ; -- majestätsbrott..nn.1
  majestätsförbrytelse_1_N = mkN "majestätsförbrytelse" "majestätsförbrytelser" ; -- majestätsförbrytelse..nn.1
  majje_1_N = mkN "majje" utrum  ; -- majje..nn.1
  majmorgon_1_N = mkN "majmorgon" "majmorgonen" "majmornar" "majmornarna" ; -- majmorgon..nn.1
  majmorgonhimmel_1_N = mkN "majmorgonhimmel" ; -- majmorgonhimmel..nn.1
  majolika_1_N = mkN "majolika" ; -- majolika..nn.1
  majonnäs_1_N = mkN "majonnäs" "majonnäser" ; -- majonnäs..nn.1
  majonnässås_1_N = mkN "majonnässås" "majonnässåser" ; -- majonnässås..nn.1
  major_1_N = mkN "major" "majorer" ; -- major..nn.1
  majoritet_1_N = mkN "majoritet" "majoriteter" ; -- majoritet..nn.1
  majoritetsbeslut_1_N = mkN "majoritetsbeslut" neutrum  ; -- majoritetsbeslut..nn.1
  majoritetsförtryck_1_N = mkN "majoritetsförtryck" neutrum  ; -- majoritetsförtryck..nn.1
  majoritetskoalition_1_N = mkN "majoritetskoalition" ; -- majoritetskoalition..nn.1
  majoritetsregering_1_N = mkN "majoritetsregering" ; -- majoritetsregering..nn.1
  majoritetssamhälle_1_N = mkN "majoritetssamhälle" ; -- majoritetssamhälle..nn.1
  majoritetsval_1_N = mkN "majoritetsval" neutrum  ; -- majoritetsval..nn.1
  majoritetsäga_1_V = mkV "majoritetsäger" ; -- majoritetsäga..vb.1
  majoritetsägande_1_N = mkN "majoritetsägande" ; -- majoritetsägande..nn.1
  majs_1_N = mkN "majs" ; -- majs..nn.1
  majsena_1_N = mkN "majsena" ; -- majsena..nn.1
  majsflinga_1_N = mkN "majsflinga" ; -- majsflinga..nn.1
  majsgröt_1_N = mkN "majsgröt" ; -- majsgröt..nn.1
  majshylsa_1_N = mkN "majshylsa" ; -- majshylsa..nn.1
  majsjuka_1_N = mkN "majsjuka" ; -- majsjuka..nn.1
  majskolv_1_N = mkN "majskolv" ; -- majskolv..nn.1
  majskorn_1_N = mkN "majskorn" neutrum  ; -- majskorn..nn.1
  majsmjöl_1_N = mkN "majsmjöl" neutrum  ; -- majsmjöl..nn.1
  majsol_1_N = mkN "majsol" ; -- majsol..nn.1
  majstång_1_N = mkN "majstång" "majstänger" ; -- majstång..nn.1
  majsöl_1_N = mkN "majsöl" neutrum  ; -- majsöl..nn.1
  majsölsberusad_1_A = mkA "majsölsberusad" ; -- majsölsberusad..av.1
  majuskel_1_N = mkN "majuskel" "majuskeln" "majuskler" "majusklerna" ; -- majuskel..nn.1
  majuskelskrift_1_N = mkN "majuskelskrift" ; -- majuskelskrift..nn.1
  maka_1_A = mkA "maka" ; -- maka..av.1
  maka_1_N = mkN "maka" ; -- maka..nn.1
  maka_1_V = mkV "makar" ; -- maka..vb.1
  makaber_1_A = mkA "makaber" ; -- makaber..av.1
  makaberhet_1_N = mkN "makaberhet" ; -- makaberhet..nn.1
  makadam_1_N = mkN "makadam" ; -- makadam..nn.1
  makalös_1_A = mkA "makalös" ; -- makalös..av.1
  makalöshet_1_N = mkN "makalöshet" ; -- makalöshet..nn.1
  makalöshet_2_N = mkN "makalöshet" "makalösheter" ; -- makalöshet..nn.2
  makande_1_N = mkN "makande" ; -- makande..nn.1
  makassarolja_1_N = mkN "makassarolja" ; -- makassarolja..nn.1
  make_1_N = mkN "make" utrum  ; -- make..nn.1
  makedonier_1_N = mkN "makedonier" "makedoniern" "makedonier" "makedonierna" ; -- makedonier..nn.1
  makedonisk_1_A = mkA "makedonisk" ; -- makedonisk..av.1
  makedoniska_1_N = mkN "makedoniska" ; -- makedoniska..nn.1
  makedoniska_2_N = mkN "makedoniska" ; -- makedoniska..nn.2
  makedonsk_1_A = mkA "makedonsk" ; -- makedonsk..av.1
  makedonska_1_N = mkN "makedonska" ; -- makedonska..nn.1
  makedonska_2_N = mkN "makedonska" ; -- makedonska..nn.2
  maklig_1_A = mkA "maklig" ; -- maklig..av.1
  maklighet_1_N = mkN "maklighet" ; -- maklighet..nn.1
  mako_1_N = mkN "mako" ; -- mako..nn.1
  makrill_1_N = mkN "makrill" ; -- makrill..nn.1
  makroklimat_1_N = mkN "makroklimat" neutrum  ; -- makroklimat..nn.1
  makrokosmos_1_N = mkN "makrokosmos" ; -- makrokosmos..nn.1
  makron_1_N = mkN "makron" "makroner" ; -- makron..nn.1
  makroskopisk_1_A = mkA "makroskopisk" ; -- makroskopisk..av.1
  makt_1_N = mkN "makt" ; -- makt..nn.1
  makt_2_N = mkN "makt" "makter" ; -- makt..nn.2
  maktanspråk_1_N = mkN "maktanspråk" neutrum  ; -- maktanspråk..nn.1
  maktarrogans_1_N = mkN "maktarrogans" ; -- maktarrogans..nn.1
  maktbalans_1_N = mkN "maktbalans" "maktbalanser" ; -- maktbalans..nn.1
  maktbas_1_N = mkN "maktbas" "maktbaser" ; -- maktbas..nn.1
  maktbefogenhet_1_N = mkN "maktbefogenhet" "maktbefogenheter" ; -- maktbefogenhet..nn.1
  maktbegär_1_N = mkN "maktbegär" neutrum  ; -- maktbegär..nn.1
  maktblock_1_N = mkN "maktblock" neutrum  ; -- maktblock..nn.1
  maktcentrum_1_N = mkN "maktcentrum" neutrum  ; -- maktcentrum..nn.1
  maktfaktor_1_N = mkN "maktfaktor" "maktfaktorer" ; -- maktfaktor..nn.1
  maktfilosofi_1_N = mkN "maktfilosofi" ; -- maktfilosofi..nn.1
  maktfråga_1_N = mkN "maktfråga" ; -- maktfråga..nn.1
  maktfullkomlig_1_A = mkA "maktfullkomlig" ; -- maktfullkomlig..av.1
  maktfullkomlighet_1_N = mkN "maktfullkomlighet" ; -- maktfullkomlighet..nn.1
  maktfördelning_1_N = mkN "maktfördelning" ; -- maktfördelning..nn.1
  maktförskjutning_1_N = mkN "maktförskjutning" ; -- maktförskjutning..nn.1
  makthavande_1_A = mkA "makthavande" ; -- makthavande..av.1
  makthavare_1_N = mkN "makthavare" utrum  ; -- makthavare..nn.1
  makthunger_1_N = mkN "makthunger" ; -- makthunger..nn.1
  maktinnehav_1_N = mkN "maktinnehav" neutrum  ; -- maktinnehav..nn.1
  maktkamp_1_N = mkN "maktkamp" "maktkamper" ; -- maktkamp..nn.1
  maktkoncentration_1_N = mkN "maktkoncentration" ; -- maktkoncentration..nn.1
  maktkrets_1_N = mkN "maktkrets" ; -- maktkrets..nn.1
  maktlek_1_N = mkN "maktlek" ; -- maktlek..nn.1
  maktlysten_1_A = mkA "maktlysten" ; -- maktlysten..av.1
  maktlystenhet_1_N = mkN "maktlystenhet" ; -- maktlystenhet..nn.1
  maktlystnad_1_N = mkN "maktlystnad" ; -- maktlystnad..nn.1
  maktlös_1_A = mkA "maktlös" ; -- maktlös..av.1
  maktlöshet_1_N = mkN "maktlöshet" ; -- maktlöshet..nn.1
  maktmanifestation_1_N = mkN "maktmanifestation" ; -- maktmanifestation..nn.1
  maktmedel_1_N = mkN "maktmedel" neutrum  ; -- maktmedel..nn.1
  maktmissbruk_1_N = mkN "maktmissbruk" neutrum  ; -- maktmissbruk..nn.1
  maktmänniska_1_N = mkN "maktmänniska" ; -- maktmänniska..nn.1
  maktmässig_1_A = mkA "maktmässig" ; -- maktmässig..av.1
  maktpolitik_1_N = mkN "maktpolitik" ; -- maktpolitik..nn.1
  maktpolitisk_1_A = mkA "maktpolitisk" ; -- maktpolitisk..av.1
  maktposition_1_N = mkN "maktposition" ; -- maktposition..nn.1
  maktpåliggande_1_A = mkA "maktpåliggande" ; -- maktpåliggande..av.1
  maktsfär_1_N = mkN "maktsfär" "maktsfärer" ; -- maktsfär..nn.1
  maktskifte_1_N = mkN "maktskifte" ; -- maktskifte..nn.1
  maktspel_1_N = mkN "maktspel" "maktspelet" "maktspel" "maktspelen" ; -- maktspel..nn.1
  maktspråk_1_N = mkN "maktspråk" neutrum  ; -- maktspråk..nn.1
  maktstinn_1_A = mkA "maktstinn" "maktstint" ; -- maktstinn..av.1
  maktstinnhet_1_N = mkN "maktstinnhet" ; -- maktstinnhet..nn.1
  maktstrid_1_N = mkN "maktstrid" "maktstrider" ; -- maktstrid..nn.1
  maktställning_1_N = mkN "maktställning" ; -- maktställning..nn.1
  maktsymbol_1_N = mkN "maktsymbol" "maktsymboler" ; -- maktsymbol..nn.1
  maktunderläge_1_N = mkN "maktunderläge" ; -- maktunderläge..nn.1
  maktutövande_1_N = mkN "maktutövande" ; -- maktutövande..nn.1
  maktutövare_1_N = mkN "maktutövare" utrum  ; -- maktutövare..nn.1
  maktutövning_1_N = mkN "maktutövning" ; -- maktutövning..nn.1
  maktvacuum_1_N = mkN "maktvacuum" neutrum  ; -- maktvacuum..nn.1
  maktvakuum_1_N = mkN "maktvakuum" neutrum  ; -- maktvakuum..nn.1
  maktövergrepp_1_N = mkN "maktövergrepp" neutrum  ; -- maktövergrepp..nn.1
  maktövertagande_1_N = mkN "maktövertagande" ; -- maktövertagande..nn.1
  makulatur_1_N = mkN "makulatur" ; -- makulatur..nn.1
  makulera_1_V = mkV "makulerar" ; -- makulera..vb.1
  makulerande_1_N = mkN "makulerande" ; -- makulerande..nn.1
  makulerbar_1_A = mkA "makulerbar" ; -- makulerbar..av.1
  makulerbarhet_1_N = mkN "makulerbarhet" ; -- makulerbarhet..nn.1
  makulering_1_N = mkN "makulering" ; -- makulering..nn.1
  mal_1_N = mkN "mal" ; -- mal..nn.1
  mal_2_N = mkN "mal" ; -- mal..nn.2
  mala_1_V = mkV "mala" "malde" "malt" ; -- mala..vb.1
  malaga_1_N = mkN "malaga" ; -- malaga..nn.1
  malaj_1_N = mkN "malaj" "malajer" ; -- malaj..nn.1
  malajisk_1_A = mkA "malajisk" ; -- malajisk..av.1
  malajiska_1_N = mkN "malajiska" ; -- malajiska..nn.1
  malajiska_2_N = mkN "malajiska" ; -- malajiska..nn.2
  malakit_1_N = mkN "malakit" "malakiter" ; -- malakit..nn.1
  malakitgrönt_1_N = mkN "malakitgrönt" ; -- malakitgrönt..nn.1
  malande_1_N = mkN "malande" ; -- malande..nn.1
  malaria_1_N = mkN "malaria" ; -- malaria..nn.1
  malariamygga_1_N = mkN "malariamygga" ; -- malariamygga..nn.1
  malariaparasit_1_N = mkN "malariaparasit" "malariaparasiter" ; -- malariaparasit..nn.1
  malariavaccin_1_N = mkN "malariavaccin" "malariavacciner" ; -- malariavaccin..nn.1
  malawier_1_N = mkN "malawier" "malawiern" "malawier" "malawierna" ; -- malawier..nn.1
  malawisk_1_A = mkA "malawisk" ; -- malawisk..av.1
  malawiska_1_N = mkN "malawiska" ; -- malawiska..nn.1
  malaysier_1_N = mkN "malaysier" "malaysiern" "malaysier" "malaysierna" ; -- malaysier..nn.1
  malaysisk_1_A = mkA "malaysisk" ; -- malaysisk..av.1
  malaysiska_1_N = mkN "malaysiska" ; -- malaysiska..nn.1
  maldiver_1_N = mkN "maldiver" "maldivern" "maldiver" "maldiverna" ; -- maldiver..nn.1
  maldivier_1_N = mkN "maldivier" "maldiviern" "maldivier" "maldivierna" ; -- maldivier..nn.1
  maldivisk_1_A = mkA "maldivisk" ; -- maldivisk..av.1
  maldiviska_1_N = mkN "maldiviska" ; -- maldiviska..nn.1
  maldiviska_2_N = mkN "maldiviska" ; -- maldiviska..nn.2
  malfobera_1_V = mkV "malfoberar" ; -- malfobera..vb.1
  malfoberande_1_N = mkN "malfoberande" ; -- malfoberande..nn.1
  malfoberbar_1_A = mkA "malfoberbar" ; -- malfoberbar..av.1
  malfoberbarhet_1_N = mkN "malfoberbarhet" ; -- malfoberbarhet..nn.1
  malfobering_1_N = mkN "malfobering" ; -- malfobering..nn.1
  maliciös_1_A = mkA "maliciös" ; -- maliciös..av.1
  malier_1_N = mkN "malier" "maliern" "malier" "malierna" ; -- malier..nn.1
  malign_1_A = mkA "malign" ; -- malign..av.1
  malis_1_N = mkN "malis" ; -- malis..nn.1
  malisk_1_A = mkA "malisk" ; -- malisk..av.1
  maliska_1_N = mkN "maliska" ; -- maliska..nn.1
  malja_1_N = mkN "malja" ; -- malja..nn.1
  mall_1_N = mkN "mall" ; -- mall..nn.1
  mallgroda_1_N = mkN "mallgroda" ; -- mallgroda..nn.1
  mallig_1_A = mkA "mallig" ; -- mallig..av.1
  mallighet_1_N = mkN "mallighet" ; -- mallighet..nn.1
  malm_1_N = mkN "malm" ; -- malm..nn.1
  malm_2_N = mkN "malm" "malmer" ; -- malm..nn.2
  malma_1_V = mkV "malmar" ; -- malma..vb.1
  malmande_1_N = mkN "malmande" ; -- malmande..nn.1
  malmedel_1_N = mkN "malmedel" neutrum  ; -- malmedel..nn.1
  malmficka_1_N = mkN "malmficka" ; -- malmficka..nn.1
  malmfyndig_1_A = mkA "malmfyndig" ; -- malmfyndig..av.1
  malmfyndighet_1_N = mkN "malmfyndighet" "malmfyndigheter" ; -- malmfyndighet..nn.1
  malmfält_1_N = mkN "malmfält" neutrum  ; -- malmfält..nn.1
  malmförande_1_A = mkA "malmförande" ; -- malmförande..av.1
  malmgruva_1_N = mkN "malmgruva" ; -- malmgruva..nn.1
  malmgård_1_N = mkN "malmgård" ; -- malmgård..nn.1
  malmhalt_1_N = mkN "malmhalt" "malmhalter" ; -- malmhalt..nn.1
  malmklang_1_N = mkN "malmklang" "malmklanger" ; -- malmklang..nn.1
  malmkropp_1_N = mkN "malmkropp" ; -- malmkropp..nn.1
  malmkross_1_N = mkN "malmkross" ; -- malmkross..nn.1
  malmkörtel_1_N = mkN "malmkörtel" ; -- malmkörtel..nn.1
  malmslig_1_N = mkN "malmslig" ; -- malmslig..nn.1
  malmtransport_1_N = mkN "malmtransport" "malmtransporter" ; -- malmtransport..nn.1
  malmtäkt_1_N = mkN "malmtäkt" "malmtäkter" ; -- malmtäkt..nn.1
  malmöbo_1_N = mkN "malmöbo" "malmöbor" ; -- malmöbo..nn.1
  malmöitisk_1_A = mkA "malmöitisk" ; -- malmöitisk..av.1
  malning_1_N = mkN "malning" ; -- malning..nn.1
  malplacerad_1_A = mkA "malplacerad" ; -- malplacerad..av.1
  malpåse_1_N = mkN "malpåse" utrum  ; -- malpåse..nn.1
  malström_1_N = mkN "malström" "malströmmen" "malströmmar" "malströmmarna" ; -- malström..nn.1
  malt_1_N = mkN "malt" ; -- malt..nn.1
  maltdryck_1_N = mkN "maltdryck" "maltdrycker" ; -- maltdryck..nn.1
  maltes_1_N = mkN "maltes" "malteser" ; -- maltes..nn.1
  maltesare_1_N = mkN "maltesare" utrum  ; -- maltesare..nn.1
  malteserhund_1_N = mkN "malteserhund" ; -- malteserhund..nn.1
  malteserkors_1_N = mkN "malteserkors" neutrum  ; -- malteserkors..nn.1
  malteserorden_1_N = mkN "malteserorden" ; -- malteserorden..nn.1
  maltesisk_1_A = mkA "maltesisk" ; -- maltesisk..av.1
  maltesiska_1_N = mkN "maltesiska" ; -- maltesiska..nn.1
  maltesiska_2_N = mkN "maltesiska" ; -- maltesiska..nn.2
  maltos_1_N = mkN "maltos" ; -- maltos..nn.1
  malträtera_1_V = mkV "malträterar" ; -- malträtera..vb.1
  malträterande_1_N = mkN "malträterande" ; -- malträterande..nn.1
  malträterbar_1_A = mkA "malträterbar" ; -- malträterbar..av.1
  malträterbarhet_1_N = mkN "malträterbarhet" ; -- malträterbarhet..nn.1
  malträtering_1_N = mkN "malträtering" ; -- malträtering..nn.1
  maltsocker_1_N = mkN "maltsocker" neutrum  ; -- maltsocker..nn.1
  malva_1_N = mkN "malva" ; -- malva..nn.1
  malvafärgad_1_A = mkA "malvafärgad" ; -- malvafärgad..av.1
  malvasir_1_N = mkN "malvasir" ; -- malvasir..nn.1
  maläten_1_A = mkA "maläten" ; -- maläten..av.1
  malätenhet_1_N = mkN "malätenhet" ; -- malätenhet..nn.1
  malör_1_N = mkN "malör" "malörer" ; -- malör..nn.1
  malört_1_N = mkN "malört" ; -- malört..nn.1
  malörtsbägare_1_N = mkN "malörtsbägare" utrum  ; -- malörtsbägare..nn.1
  mamba_1_N = mkN "mamba" ; -- mamba..nn.1
  mambo_1_N = mkN "mambo" "mambor" ; -- mambo..nn.1
  mamma_1_N = mkN "mamma" ; -- mamma..nn.1
  mammaklänning_1_N = mkN "mammaklänning" ; -- mammaklänning..nn.1
  mammaledig_1_A = mkA "mammaledig" ; -- mammaledig..av.1
  mammaledighet_1_N = mkN "mammaledighet" ; -- mammaledighet..nn.1
  mammig_1_A = mkA "mammig" ; -- mammig..av.1
  mammighet_1_N = mkN "mammighet" ; -- mammighet..nn.1
  mammografi_1_N = mkN "mammografi" "mammografier" ; -- mammografi..nn.1
  mammon_1_N = mkN "mammon" ; -- mammon..nn.1
  mammonsdyrkare_1_N = mkN "mammonsdyrkare" utrum  ; -- mammonsdyrkare..nn.1
  mammonsträl_1_N = mkN "mammonsträl" ; -- mammonsträl..nn.1
  mammut_1_N = mkN "mammut" ; -- mammut..nn.1
  mammutjakt_1_N = mkN "mammutjakt" ; -- mammutjakt..nn.1
  mammutpopulation_1_N = mkN "mammutpopulation" ; -- mammutpopulation..nn.1
  mammutstam_1_N = mkN "mammutstam" "mammutstammen" "mammutstammar" "mammutstammarna" ; -- mammutstam..nn.1
  mammutträd_1_N = mkN "mammutträd" neutrum  ; -- mammutträd..nn.1
  mamsell_1_N = mkN "mamsell" "mamseller" ; -- mamsell..nn.1
  mamutfossil_1_N = mkN "mamutfossil" neutrum  ; -- mamutfossil..nn.1
  man_1_N = mkN "man" "mannen" "mannar" "mannarna" ; -- man..nn.1
  man_2_N = mkN "man" ; -- man..nn.2
  mana_1_N = mkN "mana" ; -- mana..nn.1
  mana_1_V = mkV "manar" ; -- mana..vb.1
  management_1_N = mkN "management" ; -- management..nn.1
  manager_1_N = mkN "manager" "managern" "manager" "managerna" ; -- manager..nn.1
  manande_1_N = mkN "manande" ; -- manande..nn.1
  manbar_1_A = mkA "manbar" ; -- manbar..av.1
  manbarhet_1_N = mkN "manbarhet" ; -- manbarhet..nn.1
  manbyggnad_1_N = mkN "manbyggnad" "manbyggnader" ; -- manbyggnad..nn.1
  manchester_1_N = mkN "manchester" ; -- manchester..nn.1
  manchesterbyxa_1_N = mkN "manchesterbyxa" ; -- manchesterbyxa..nn.1
  manchesterhängselkjol_1_N = mkN "manchesterhängselkjol" ; -- manchesterhängselkjol..nn.1
  manchesterjacka_1_N = mkN "manchesterjacka" ; -- manchesterjacka..nn.1
  manchesterkavaj_1_N = mkN "manchesterkavaj" "manchesterkavajer" ; -- manchesterkavaj..nn.1
  manchesterkostym_1_N = mkN "manchesterkostym" "manchesterkostymer" ; -- manchesterkostym..nn.1
  manchesterliberalism_1_N = mkN "manchesterliberalism" "manchesterliberalismer" ; -- manchesterliberalism..nn.1
  manchu_1_N = mkN "manchu" "manchun" "manchuer" "manchuerna" ; -- manchu..nn.1
  manchuisk_1_A = mkA "manchuisk" ; -- manchuisk..av.1
  manchuiska_1_N = mkN "manchuiska" ; -- manchuiska..nn.1
  manchuiska_2_N = mkN "manchuiska" ; -- manchuiska..nn.2
  mandarin_1_N = mkN "mandarin" "mandariner" ; -- mandarin..nn.1
  mandarin_2_N = mkN "mandarin" ; -- mandarin..nn.2
  mandat_1_N = mkN "mandat" neutrum  ; -- mandat..nn.1
  mandatfördelning_1_N = mkN "mandatfördelning" ; -- mandatfördelning..nn.1
  mandatperiod_1_N = mkN "mandatperiod" "mandatperioder" ; -- mandatperiod..nn.1
  mandel_1_N = mkN "mandel" ; -- mandel..nn.1
  mandelblomma_1_N = mkN "mandelblomma" ; -- mandelblomma..nn.1
  mandelformad_1_A = mkA "mandelformad" ; -- mandelformad..av.1
  mandelgrön_1_A = mkA "mandelgrön" ; -- mandelgrön..av.1
  mandelkaka_1_N = mkN "mandelkaka" ; -- mandelkaka..nn.1
  mandelkubb_1_N = mkN "mandelkubb" ; -- mandelkubb..nn.1
  mandelmassa_1_N = mkN "mandelmassa" ; -- mandelmassa..nn.1
  mandelolja_1_N = mkN "mandelolja" ; -- mandelolja..nn.1
  mandelpotatis_1_N = mkN "mandelpotatis" ; -- mandelpotatis..nn.1
  mandelspån_1_N = mkN "mandelspån" neutrum  ; -- mandelspån..nn.1
  mandeltårta_1_N = mkN "mandeltårta" ; -- mandeltårta..nn.1
  mandelögd_1_A = mkA "mandelögd" "mandelögt" ; -- mandelögd..av.1
  mandibel_1_N = mkN "mandibel" "mandibeln" "mandibler" "mandiblerna" ; -- mandibel..nn.1
  mandolin_1_N = mkN "mandolin" "mandoliner" ; -- mandolin..nn.1
  mandom_1_N = mkN "mandom" ; -- mandom..nn.1
  mandomsprov_1_N = mkN "mandomsprov" neutrum  ; -- mandomsprov..nn.1
  mandorla_1_N = mkN "mandorla" ; -- mandorla..nn.1
  mandragora_1_N = mkN "mandragora" ; -- mandragora..nn.1
  mandrill_1_N = mkN "mandrill" "mandriller" ; -- mandrill..nn.1
  manege_1_N = mkN "manege" "maneger" ; -- manege..nn.1
  maner_2_N = mkN "maner" "maneret" "maner" "maneren" ; -- maner..nn.2
  manet_1_N = mkN "manet" "maneter" ; -- manet..nn.1
  manetdoktorand_1_N = mkN "manetdoktorand" "manetdoktorander" ; -- manetdoktorand..nn.1
  manetforskning_1_N = mkN "manetforskning" ; -- manetforskning..nn.1
  manfall_1_N = mkN "manfall" neutrum  ; -- manfall..nn.1
  manfolk_1_N = mkN "manfolk" neutrum  ; -- manfolk..nn.1
  mangan_1_N = mkN "mangan" ; -- mangan..nn.1
  manganin_1_N = mkN "manganin" "manganiner" ; -- manganin..nn.1
  mangel_1_N = mkN "mangel" ; -- mangel..nn.1
  mangla_1_V = mkV "manglar" ; -- mangla..vb.1
  manglande_1_N = mkN "manglande" ; -- manglande..nn.1
  mango_1_N = mkN "mango" "mangon" "mangoer" "mangoerna" ; -- mango..nn.1
  mangogul_1_A = mkA "mangogul" ; -- mangogul..av.1
  mangold_1_N = mkN "mangold" ; -- mangold..nn.1
  mangrann_1_A = mkA "mangrann" "mangrant" ; -- mangrann..av.1
  mangrove_1_N = mkN "mangrove" "mangrover" ; -- mangrove..nn.1
  mangroveträsk_1_N = mkN "mangroveträsk" neutrum  ; -- mangroveträsk..nn.1
  mangust_1_N = mkN "mangust" "manguster" ; -- mangust..nn.1
  mangård_1_N = mkN "mangård" ; -- mangård..nn.1
  mangårdsbyggnad_1_N = mkN "mangårdsbyggnad" "mangårdsbyggnader" ; -- mangårdsbyggnad..nn.1
  manhaftig_1_A = mkA "manhaftig" ; -- manhaftig..av.1
  manhaftighet_1_N = mkN "manhaftighet" ; -- manhaftighet..nn.1
  manhål_1_N = mkN "manhål" neutrum  ; -- manhål..nn.1
  mani_1_N = mkN "mani" "manier" ; -- mani..nn.1
  maniakalisk_1_A = mkA "maniakalisk" ; -- maniakalisk..av.1
  manick_1_N = mkN "manick" "manicker" ; -- manick..nn.1
  maniererad_1_A = mkA "maniererad" ; -- maniererad..av.1
  manierism_1_N = mkN "manierism" "manierismer" ; -- manierism..nn.1
  manieristisk_1_A = mkA "manieristisk" ; -- manieristisk..av.1
  manifest_1_A = mkA "manifest" "manifest" ; -- manifest..av.1
  manifest_1_N = mkN "manifest" neutrum  ; -- manifest..nn.1
  manifestation_1_N = mkN "manifestation" ; -- manifestation..nn.1
  manifestera_1_V = mkV "manifesterar" ; -- manifestera..vb.1
  manifesterande_1_N = mkN "manifesterande" ; -- manifesterande..nn.1
  manifesterbar_1_A = mkA "manifesterbar" ; -- manifesterbar..av.1
  manifesterbarhet_1_N = mkN "manifesterbarhet" ; -- manifesterbarhet..nn.1
  manifestering_1_N = mkN "manifestering" ; -- manifestering..nn.1
  manikeism_1_N = mkN "manikeism" "manikeismer" ; -- manikeism..nn.1
  manikeistisk_1_A = mkA "manikeistisk" ; -- manikeistisk..av.1
  maniker_1_N = mkN "maniker" "manikern" "maniker" "manikerna" ; -- maniker..nn.1
  manikur_1_N = mkN "manikur" "manikurer" ; -- manikur..nn.1
  manikurera_1_V = mkV "manikurerar" ; -- manikurera..vb.1
  manikurerande_1_N = mkN "manikurerande" ; -- manikurerande..nn.1
  manikurerbar_1_A = mkA "manikurerbar" ; -- manikurerbar..av.1
  manikurerbarhet_1_N = mkN "manikurerbarhet" ; -- manikurerbarhet..nn.1
  manikurering_1_N = mkN "manikurering" ; -- manikurering..nn.1
  manikurist_1_N = mkN "manikurist" "manikurister" ; -- manikurist..nn.1
  manikyr_1_N = mkN "manikyr" ; -- manikyr..nn.1
  manikyrera_1_V = mkV "manikyrerar" ; -- manikyrera..vb.1
  manikyrerande_1_N = mkN "manikyrerande" ; -- manikyrerande..nn.1
  manikyrerbar_1_A = mkA "manikyrerbar" ; -- manikyrerbar..av.1
  manikyrerbarhet_1_N = mkN "manikyrerbarhet" ; -- manikyrerbarhet..nn.1
  manikyrering_1_N = mkN "manikyrering" ; -- manikyrering..nn.1
  manikyrist_1_N = mkN "manikyrist" "manikyrister" ; -- manikyrist..nn.1
  maniké_1_N = mkN "maniké" "manikéer" ; -- maniké..nn.1
  manilla_1_N = mkN "manilla" ; -- manilla..nn.1
  maning_1_N = mkN "maning" ; -- maning..nn.1
  maningsrop_1_N = mkN "maningsrop" neutrum  ; -- maningsrop..nn.1
  maniok_1_N = mkN "maniok" ; -- maniok..nn.1
  manipulation_1_N = mkN "manipulation" ; -- manipulation..nn.1
  manipulativ_1_A = mkA "manipulativ" ; -- manipulativ..av.1
  manipulera_1_V = mkV "manipulerar" ; -- manipulera..vb.1
  manipulerande_1_N = mkN "manipulerande" ; -- manipulerande..nn.1
  manipulerbar_1_A = mkA "manipulerbar" ; -- manipulerbar..av.1
  manipulerbarhet_1_N = mkN "manipulerbarhet" ; -- manipulerbarhet..nn.1
  manipulering_1_N = mkN "manipulering" ; -- manipulering..nn.1
  manisk_depressiv_1_A = mkA "manisk-depressiv" ; -- manisk-depressiv..av.1
  manisk_1_A = mkA "manisk" ; -- manisk..av.1
  manke_1_N = mkN "manke" utrum  ; -- manke..nn.1
  mankemang_1_N = mkN "mankemang" neutrum  ; -- mankemang..nn.1
  mankera_1_V = mkV "mankerar" ; -- mankera..vb.1
  mankerande_1_N = mkN "mankerande" ; -- mankerande..nn.1
  mankering_1_N = mkN "mankering" ; -- mankering..nn.1
  mankill_1_N = mkN "mankill" "mankiller" ; -- mankill..nn.1
  manko_1_N = mkN "manko" "mankot" "mankon" "mankona" ; -- manko..nn.1
  mankön_1_N = mkN "mankön" neutrum  ; -- mankön..nn.1
  manlig_1_A = mkA "manlig" ; -- manlig..av.1
  manlig_2_A = mkA "manlig" ; -- manlig..av.2
  manlighet_1_N = mkN "manlighet" ; -- manlighet..nn.1
  manlighetsdop_1_N = mkN "manlighetsdop" neutrum  ; -- manlighetsdop..nn.1
  manlighetsprov_1_N = mkN "manlighetsprov" neutrum  ; -- manlighetsprov..nn.1
  manlucka_1_N = mkN "manlucka" ; -- manlucka..nn.1
  manna_1_N = mkN "manna" ; -- manna..nn.1
  mannagryn_1_N = mkN "mannagryn" neutrum  ; -- mannagryn..nn.1
  mannagrynsgröt_1_N = mkN "mannagrynsgröt" ; -- mannagrynsgröt..nn.1
  mannagräs_1_N = mkN "mannagräs" neutrum  ; -- mannagräs..nn.1
  mannakraft_1_N = mkN "mannakraft" ; -- mannakraft..nn.1
  mannalav_1_N = mkN "mannalav" ; -- mannalav..nn.1
  mannamod_1_N = mkN "mannamod" neutrum  ; -- mannamod..nn.1
  mannamån_1_N = mkN "mannamån" ; -- mannamån..nn.1
  mannaålder_1_N = mkN "mannaålder" ; -- mannaålder..nn.1
  mannekäng_1_N = mkN "mannekäng" "mannekänger" ; -- mannekäng..nn.1
  manodepressiv_1_A = mkA "manodepressiv" ; -- manodepressiv..av.1
  manometer_1_N = mkN "manometer" ; -- manometer..nn.1
  mansard_1_N = mkN "mansard" "mansarder" ; -- mansard..nn.1
  mansardtak_1_N = mkN "mansardtak" neutrum  ; -- mansardtak..nn.1
  mansardvåning_1_N = mkN "mansardvåning" ; -- mansardvåning..nn.1
  mansbot_1_N = mkN "mansbot" ; -- mansbot..nn.1
  manschauvinism_1_N = mkN "manschauvinism" "manschauvinismer" ; -- manschauvinism..nn.1
  manschauvinistisk_1_A = mkA "manschauvinistisk" ; -- manschauvinistisk..av.1
  manschett_1_N = mkN "manschett" "manschetter" ; -- manschett..nn.1
  manschettknapp_1_N = mkN "manschettknapp" ; -- manschettknapp..nn.1
  manschettproletariat_1_N = mkN "manschettproletariat" neutrum  ; -- manschettproletariat..nn.1
  manschettyrke_1_N = mkN "manschettyrke" ; -- manschettyrke..nn.1
  mansdominans_1_N = mkN "mansdominans" ; -- mansdominans..nn.1
  mansdominerad_1_A = mkA "mansdominerad" ; -- mansdominerad..av.1
  mansdräkt_1_N = mkN "mansdräkt" "mansdräkter" ; -- mansdräkt..nn.1
  mansgrav_1_N = mkN "mansgrav" ; -- mansgrav..nn.1
  mansgris_1_N = mkN "mansgris" ; -- mansgris..nn.1
  manshög_1_A = mkA "manshög" ; -- manshög..av.1
  manshöjd_1_N = mkN "manshöjd" "manshöjder" ; -- manshöjd..nn.1
  mansideal_1_N = mkN "mansideal" neutrum  ; -- mansideal..nn.1
  mansintresse_1_N = mkN "mansintresse" ; -- mansintresse..nn.1
  manskap_1_N = mkN "manskap" neutrum  ; -- manskap..nn.1
  manskvartett_1_N = mkN "manskvartett" "manskvartetter" ; -- manskvartett..nn.1
  manskör_1_N = mkN "manskör" "manskörer" ; -- manskör..nn.1
  manslem_1_N = mkN "manslem" "manslemmen" "manslemmar" "manslemmarna" ; -- manslem..nn.1
  manslinje_1_N = mkN "manslinje" "manslinjer" ; -- manslinje..nn.1
  manslukerska_1_N = mkN "manslukerska" ; -- manslukerska..nn.1
  mansläger_1_N = mkN "mansläger" neutrum  ; -- mansläger..nn.1
  mansnamn_1_N = mkN "mansnamn" neutrum  ; -- mansnamn..nn.1
  mansperson_1_N = mkN "mansperson" "manspersoner" ; -- mansperson..nn.1
  mansröst_1_N = mkN "mansröst" "mansröster" ; -- mansröst..nn.1
  manssamhälle_1_N = mkN "manssamhälle" ; -- manssamhälle..nn.1
  manssida_1_N = mkN "manssida" ; -- manssida..nn.1
  mansslukerska_1_N = mkN "mansslukerska" ; -- mansslukerska..nn.1
  manstark_1_A = mkA "manstark" ; -- manstark..av.1
  manstukt_1_N = mkN "manstukt" ; -- manstukt..nn.1
  mansålder_1_N = mkN "mansålder" ; -- mansålder..nn.1
  mantal_1_N = mkN "mantal" neutrum  ; -- mantal..nn.1
  mantalslängd_1_N = mkN "mantalslängd" "mantalslängder" ; -- mantalslängd..nn.1
  mantalsskriva_1_V = mkV "mantalsskriva" "mantalsskrev" "mantalsskrivit" ; -- mantalsskriva..vb.1
  mantalsskrivande_1_N = mkN "mantalsskrivande" ; -- mantalsskrivande..nn.1
  mantalsskriven_1_A = mkA "mantalsskriven" ; -- mantalsskriven..av.1
  mantalsskrivning_1_N = mkN "mantalsskrivning" ; -- mantalsskrivning..nn.1
  mantel_1_N = mkN "mantel" ; -- mantel..nn.1
  manteldjur_1_N = mkN "manteldjur" neutrum  ; -- manteldjur..nn.1
  mantelklädd_1_A = mkA "mantelklädd" ; -- mantelklädd..av.1
  mantelrörelse_1_N = mkN "mantelrörelse" "mantelrörelser" ; -- mantelrörelse..nn.1
  mantelskura_1_N = mkN "mantelskura" ; -- mantelskura..nn.1
  mantelstyrning_1_N = mkN "mantelstyrning" ; -- mantelstyrning..nn.1
  mantelyta_1_N = mkN "mantelyta" ; -- mantelyta..nn.1
  mantilj_1_N = mkN "mantilj" "mantiljer" ; -- mantilj..nn.1
  mantissa_1_N = mkN "mantissa" ; -- mantissa..nn.1
  mantla_1_V = mkV "mantlar" ; -- mantla..vb.1
  mantlande_1_N = mkN "mantlande" ; -- mantlande..nn.1
  mantra_1_N = mkN "mantra" "mantrat" "mantran" "mantrana" ; -- mantra..nn.1
  mantåg_1_N = mkN "mantåg" neutrum  ; -- mantåg..nn.1
  manual_1_N = mkN "manual" "manualer" ; -- manual..nn.1
  manuell_1_A = mkA "manuell" ; -- manuell..av.1
  manufaktur_1_N = mkN "manufaktur" "manufakturer" ; -- manufaktur..nn.1
  manus_1_N = mkN "manus" neutrum  ; -- manus..nn.1
  manusförfattare_1_N = mkN "manusförfattare" utrum  ; -- manusförfattare..nn.1
  manusgenomgång_1_N = mkN "manusgenomgång" ; -- manusgenomgång..nn.1
  manuskript_1_N = mkN "manuskript" neutrum  ; -- manuskript..nn.1
  manår_1_N = mkN "manår" neutrum  ; -- manår..nn.1
  manér_1_N = mkN "manér" neutrum  ; -- manér..nn.1
  manöver_1_N = mkN "manöver" ; -- manöver..nn.1
  manöverduglig_1_A = mkA "manöverduglig" ; -- manöverduglig..av.1
  manöverduglighet_1_N = mkN "manöverduglighet" ; -- manöverduglighet..nn.1
  manöverkraft_1_N = mkN "manöverkraft" "manöverkrafter" ; -- manöverkraft..nn.1
  manöverutrymme_1_N = mkN "manöverutrymme" ; -- manöverutrymme..nn.1
  manövrera_1_V = mkV "manövrerar" ; -- manövrera..vb.1
  manövrerande_1_N = mkN "manövrerande" ; -- manövrerande..nn.1
  manövrerbar_1_A = mkA "manövrerbar" ; -- manövrerbar..av.1
  manövrerbarhet_1_N = mkN "manövrerbarhet" ; -- manövrerbarhet..nn.1
  manövrering_1_N = mkN "manövrering" ; -- manövrering..nn.1
  maoism_1_N = mkN "maoism" "maoismer" ; -- maoism..nn.1
  maoistisk_1_A = mkA "maoistisk" ; -- maoistisk..av.1
  maori_1_N = mkN "maori" "maorin" "maorier" "maorierna" ; -- maori..nn.1
  maorier_1_N = mkN "maorier" "maoriern" "maorier" "maorierna" ; -- maorier..nn.1
  maorisk_1_A = mkA "maorisk" ; -- maorisk..av.1
  mapp_1_N = mkN "mapp" ; -- mapp..nn.1
  mara_1_N = mkN "mara" ; -- mara..nn.1
  mara_2_N = mkN "mara" ; -- mara..nn.2
  marabu_1_N = mkN "marabu" "marabun" "marabuer" "marabuerna" ; -- marabu..nn.1
  maranata_1_N = mkN "maranata" ; -- maranata..nn.1
  maraskino_1_N = mkN "maraskino" ; -- maraskino..nn.1
  marasm_1_N = mkN "marasm" ; -- marasm..nn.1
  maraton_1_N = mkN "maraton" neutrum  ; -- maraton..nn.1
  maratondebatt_1_N = mkN "maratondebatt" "maratondebatter" ; -- maratondebatt..nn.1
  maratonförhandling_1_N = mkN "maratonförhandling" ; -- maratonförhandling..nn.1
  maratonlopp_1_N = mkN "maratonlopp" neutrum  ; -- maratonlopp..nn.1
  maratonrättegång_1_N = mkN "maratonrättegång" ; -- maratonrättegång..nn.1
  mardröm_1_N = mkN "mardröm" "mardrömmen" "mardrömmar" "mardrömmarna" ; -- mardröm..nn.1
  mardrömscenario_1_N = mkN "mardrömscenario" "mardrömscenariot" "mardrömscenarier" "mardrömscenarierna" ; -- mardrömscenario..nn.1
  mardrömsfantasi_1_N = mkN "mardrömsfantasi" "mardrömsfantasier" ; -- mardrömsfantasi..nn.1
  mardrömsjulfest_1_N = mkN "mardrömsjulfest" "mardrömsjulfester" ; -- mardrömsjulfest..nn.1
  mardrömskänsla_1_N = mkN "mardrömskänsla" ; -- mardrömskänsla..nn.1
  mardrömslik_1_A = mkA "mardrömslik" ; -- mardrömslik..av.1
  mardrömslikhet_1_N = mkN "mardrömslikhet" ; -- mardrömslikhet..nn.1
  mardrömsliknande_1_A = mkA "mardrömsliknande" ; -- mardrömsliknande..av.1
  mardrömsstart_1_N = mkN "mardrömsstart" "mardrömsstarter" ; -- mardrömsstart..nn.1
  mardrömssyn_1_N = mkN "mardrömssyn" "mardrömssyner" ; -- mardrömssyn..nn.1
  mareld_1_N = mkN "mareld" ; -- mareld..nn.1
  marg_1_N = mkN "marg" "marger" ; -- marg..nn.1
  margarin_1_N = mkN "margarin" "margariner" ; -- margarin..nn.1
  margarita_1_N = mkN "margarita" ; -- margarita..nn.1
  margfaldig_1_A = mkA "margfaldig" ; -- margfaldig..av.1
  marginal_1_N = mkN "marginal" "marginaler" ; -- marginal..nn.1
  marginalanteckning_1_N = mkN "marginalanteckning" ; -- marginalanteckning..nn.1
  marginalbeskattning_1_N = mkN "marginalbeskattning" ; -- marginalbeskattning..nn.1
  marginaleffekt_1_N = mkN "marginaleffekt" "marginaleffekter" ; -- marginaleffekt..nn.1
  marginalinkomst_1_N = mkN "marginalinkomst" "marginalinkomster" ; -- marginalinkomst..nn.1
  marginalintäkt_1_N = mkN "marginalintäkt" "marginalintäkter" ; -- marginalintäkt..nn.1
  marginalisera_1_V = mkV "marginaliserar" ; -- marginalisera..vb.1
  marginaliserad_1_A = mkA "marginaliserad" ; -- marginaliserad..av.1
  marginaliseraing_1_N = mkN "marginaliseraing" ; -- marginaliseraing..nn.1
  marginaliserande_1_N = mkN "marginaliserande" ; -- marginaliserande..nn.1
  marginaliserbar_1_A = mkA "marginaliserbar" ; -- marginaliserbar..av.1
  marginaliserbarhet_1_N = mkN "marginaliserbarhet" ; -- marginaliserbarhet..nn.1
  marginalkostnad_1_N = mkN "marginalkostnad" "marginalkostnader" ; -- marginalkostnad..nn.1
  marginalnot_1_N = mkN "marginalnot" "marginalnoter" ; -- marginalnot..nn.1
  marginalskatt_1_N = mkN "marginalskatt" "marginalskatter" ; -- marginalskatt..nn.1
  marginalväljare_1_N = mkN "marginalväljare" utrum  ; -- marginalväljare..nn.1
  marginell_1_A = mkA "marginell" ; -- marginell..av.1
  margräs_1_N = mkN "margräs" neutrum  ; -- margräs..nn.1
  marienglas_1_N = mkN "marienglas" ; -- marienglas..nn.1
  marig_1_A = mkA "marig" ; -- marig..av.1
  marighet_1_N = mkN "marighet" "marigheter" ; -- marighet..nn.1
  marihuana_1_N = mkN "marihuana" ; -- marihuana..nn.1
  marijuana_1_N = mkN "marijuana" ; -- marijuana..nn.1
  marimba_1_N = mkN "marimba" ; -- marimba..nn.1
  marin_1_A = mkA "marin" ; -- marin..av.1
  marin_1_N = mkN "marin" "mariner" ; -- marin..nn.1
  marina_1_N = mkN "marina" ; -- marina..nn.1
  marinad_1_N = mkN "marinad" "marinader" ; -- marinad..nn.1
  marinarkeolog_1_N = mkN "marinarkeolog" "marinarkeologer" ; -- marinarkeolog..nn.1
  marinarkeologi_1_N = mkN "marinarkeologi" ; -- marinarkeologi..nn.1
  marinarkeologisk_1_A = mkA "marinarkeologisk" ; -- marinarkeologisk..av.1
  marinattaché_1_N = mkN "marinattaché" "marinattachéer" ; -- marinattaché..nn.1
  marinbiolog_1_N = mkN "marinbiolog" "marinbiologer" ; -- marinbiolog..nn.1
  marinbiologi_1_N = mkN "marinbiologi" ; -- marinbiologi..nn.1
  marinbiologisk_1_A = mkA "marinbiologisk" ; -- marinbiologisk..av.1
  marinblå_1_A = mkA "marinblå" "marinblått" ; -- marinblå..av.1
  marindirektör_1_N = mkN "marindirektör" "marindirektörer" ; -- marindirektör..nn.1
  marinera_1_V = mkV "marinerar" ; -- marinera..vb.1
  marinerande_1_N = mkN "marinerande" ; -- marinerande..nn.1
  marinerbar_1_A = mkA "marinerbar" ; -- marinerbar..av.1
  marinerbarhet_1_N = mkN "marinerbarhet" ; -- marinerbarhet..nn.1
  marinering_1_N = mkN "marinering" ; -- marinering..nn.1
  marinkår_1_N = mkN "marinkår" "marinkårer" ; -- marinkår..nn.1
  marinledning_1_N = mkN "marinledning" ; -- marinledning..nn.1
  marinminister_1_N = mkN "marinminister" ; -- marinminister..nn.1
  marinmålare_1_N = mkN "marinmålare" utrum  ; -- marinmålare..nn.1
  marinmålning_1_N = mkN "marinmålning" ; -- marinmålning..nn.1
  marinsoldat_1_N = mkN "marinsoldat" "marinsoldater" ; -- marinsoldat..nn.1
  marinstyrka_1_N = mkN "marinstyrka" ; -- marinstyrka..nn.1
  marionett_1_N = mkN "marionett" "marionetter" ; -- marionett..nn.1
  marionetteater_1_N = mkN "marionetteater" ; -- marionetteater..nn.1
  maritim_1_A = mkA "maritim" ; -- maritim..av.1
  mark_1_N = mkN "mark" "marker" ; -- mark..nn.1
  mark_2_N = mkN "mark" "marken" "mark" "marken" ; -- mark..nn.2
  markant_1_A = mkA "markant" "markant" ; -- markant..av.1
  markatta_1_N = mkN "markatta" ; -- markatta..nn.1
  markavvattning_1_N = mkN "markavvattning" ; -- markavvattning..nn.1
  markberedning_1_N = mkN "markberedning" ; -- markberedning..nn.1
  markberedningsmaskin_1_N = mkN "markberedningsmaskin" "markberedningsmaskiner" ; -- markberedningsmaskin..nn.1
  markbrand_1_N = mkN "markbrand" "markbränder" ; -- markbrand..nn.1
  markbunden_1_A = mkA "markbunden" ; -- markbunden..av.1
  markeffektfarkost_1_N = mkN "markeffektfarkost" "markeffektfarkoster" ; -- markeffektfarkost..nn.1
  markegång_1_N = mkN "markegång" ; -- markegång..nn.1
  markera_1_V = mkV "markerar" ; -- markera..vb.1
  markerad_1_A = mkA "markerad" ; -- markerad..av.1
  markerande_1_N = mkN "markerande" ; -- markerande..nn.1
  markerbar_1_A = mkA "markerbar" ; -- markerbar..av.1
  markerbarhet_1_N = mkN "markerbarhet" ; -- markerbarhet..nn.1
  markering_1_N = mkN "markering" ; -- markering..nn.1
  marketentare_1_N = mkN "marketentare" utrum  ; -- marketentare..nn.1
  marketenteri_1_N = mkN "marketenteri" "marketenteriet" "marketenterier" "marketenterierna" ; -- marketenteri..nn.1
  marketeri_1_N = mkN "marketeri" "marketeriet" "marketerier" "marketerierna" ; -- marketeri..nn.1
  marketing_1_N = mkN "marketing" ; -- marketing..nn.1
  markgreve_1_N = mkN "markgreve" utrum  ; -- markgreve..nn.1
  markis_1_N = mkN "markis" "markiser" ; -- markis..nn.1
  markkonflikt_1_N = mkN "markkonflikt" "markkonflikter" ; -- markkonflikt..nn.1
  markkontakt_1_N = mkN "markkontakt" ; -- markkontakt..nn.1
  marklevande_1_A = mkA "marklevande" ; -- marklevande..av.1
  marklära_1_N = mkN "marklära" ; -- marklära..nn.1
  marknad_1_N = mkN "marknad" "marknader" ; -- marknad..nn.1
  marknadsandel_1_N = mkN "marknadsandel" "marknadsandelen" "marknadsandelar" "marknadsandelarna" ; -- marknadsandel..nn.1
  marknadsanpassa_1_V = mkV "marknadsanpassar" ; -- marknadsanpassa..vb.1
  marknadsanpassande_1_N = mkN "marknadsanpassande" ; -- marknadsanpassande..nn.1
  marknadsansvarig_1_A = mkA "marknadsansvarig" ; -- marknadsansvarig..av.1
  marknadsbaserad_1_A = mkA "marknadsbaserad" "marknadsbaseradt" ; -- marknadsbaserad..av.1
  marknadschef_1_N = mkN "marknadschef" "marknadschefer" ; -- marknadschef..nn.1
  marknadsekonomi_1_N = mkN "marknadsekonomi" "marknadsekonomier" ; -- marknadsekonomi..nn.1
  marknadsekonomisk_1_A = mkA "marknadsekonomisk" ; -- marknadsekonomisk..av.1
  marknadsfundamentalism_1_N = mkN "marknadsfundamentalism" "marknadsfundamentalismer" ; -- marknadsfundamentalism..nn.1
  marknadsföra_1_V = mkV "marknadsföra" "marknadsförde" "marknadsfört" ; -- marknadsföra..vb.1
  marknadsförande_1_N = mkN "marknadsförande" ; -- marknadsförande..nn.1
  marknadsförare_1_N = mkN "marknadsförare" utrum  ; -- marknadsförare..nn.1
  marknadsföring_1_N = mkN "marknadsföring" ; -- marknadsföring..nn.1
  marknadsföringskupp_1_N = mkN "marknadsföringskupp" "marknadsföringskupper" ; -- marknadsföringskupp..nn.1
  marknadsföringsmetod_1_N = mkN "marknadsföringsmetod" "marknadsföringsmetoder" ; -- marknadsföringsmetod..nn.1
  marknadsföringsmässig_1_A = mkA "marknadsföringsmässig" ; -- marknadsföringsmässig..av.1
  marknadsföringstrick_1_N = mkN "marknadsföringstrick" neutrum  ; -- marknadsföringstrick..nn.1
  marknadsgyckel_1_N = mkN "marknadsgyckel" neutrum  ; -- marknadsgyckel..nn.1
  marknadsgycklare_1_N = mkN "marknadsgycklare" utrum  ; -- marknadsgycklare..nn.1
  marknadshyra_1_N = mkN "marknadshyra" ; -- marknadshyra..nn.1
  marknadskapitalistisk_1_A = mkA "marknadskapitalistisk" ; -- marknadskapitalistisk..av.1
  marknadsledande_1_A = mkA "marknadsledande" ; -- marknadsledande..av.1
  marknadsliberal_1_A = mkA "marknadsliberal" ; -- marknadsliberal..av.1
  marknadsliberal_1_N = mkN "marknadsliberal" "marknadsliberaler" ; -- marknadsliberal..nn.1
  marknadsläge_1_N = mkN "marknadsläge" ; -- marknadsläge..nn.1
  marknadsmanipulation_1_N = mkN "marknadsmanipulation" ; -- marknadsmanipulation..nn.1
  marknadsmässig_1_A = mkA "marknadsmässig" ; -- marknadsmässig..av.1
  marknadsmässighet_1_N = mkN "marknadsmässighet" "marknadsmässigheter" ; -- marknadsmässighet..nn.1
  marknadsnoterad_1_A = mkA "marknadsnoterad" ; -- marknadsnoterad..av.1
  marknadsorienterad_1_A = mkA "marknadsorienterad" ; -- marknadsorienterad..av.1
  marknadsorientering_1_N = mkN "marknadsorientering" ; -- marknadsorientering..nn.1
  marknadsplats_1_N = mkN "marknadsplats" "marknadsplatser" ; -- marknadsplats..nn.1
  marknadspris_1_N = mkN "marknadspris" neutrum  ; -- marknadspris..nn.1
  marknadsreaktion_1_N = mkN "marknadsreaktion" ; -- marknadsreaktion..nn.1
  marknadsreform_1_N = mkN "marknadsreform" "marknadsreformer" ; -- marknadsreform..nn.1
  marknadsränta_1_N = mkN "marknadsränta" ; -- marknadsränta..nn.1
  marknadsstånd_1_N = mkN "marknadsstånd" neutrum  ; -- marknadsstånd..nn.1
  marknadstorg_1_N = mkN "marknadstorg" neutrum  ; -- marknadstorg..nn.1
  marknadsundersökning_1_N = mkN "marknadsundersökning" ; -- marknadsundersökning..nn.1
  marknadsvara_1_N = mkN "marknadsvara" ; -- marknadsvara..nn.1
  marknadsvärde_1_N = mkN "marknadsvärde" ; -- marknadsvärde..nn.1
  marknadsvärdera_1_V = mkV "marknadsvärderar" ; -- marknadsvärdera..vb.1
  marknadsvärderande_1_N = mkN "marknadsvärderande" ; -- marknadsvärderande..nn.1
  marknadsvärderbar_1_A = mkA "marknadsvärderbar" ; -- marknadsvärderbar..av.1
  marknadsvärderbarhet_1_N = mkN "marknadsvärderbarhet" ; -- marknadsvärderbarhet..nn.1
  marknadsvärdering_1_N = mkN "marknadsvärdering" ; -- marknadsvärdering..nn.1
  marknivå_1_N = mkN "marknivå" "marknivåer" ; -- marknivå..nn.1
  marknära_1_A = mkA "marknära" ; -- marknära..av.1
  marknät_1_N = mkN "marknät" neutrum  ; -- marknät..nn.1
  markomanner_1_N = mkN "markomanner" "markomannern" "markomanner" "markomannerna" ; -- markomanner..nn.1
  markområde_1_N = mkN "markområde" ; -- markområde..nn.1
  markorganism_1_N = mkN "markorganism" "markorganismer" ; -- markorganism..nn.1
  markplan_1_N = mkN "markplan" "markplaner" ; -- markplan..nn.1
  markservice_1_N = mkN "markservice" utrum  ; -- markservice..nn.1
  markstrid_1_N = mkN "markstrid" "markstrider" ; -- markstrid..nn.1
  markstycke_1_N = mkN "markstycke" ; -- markstycke..nn.1
  marktjänst_1_N = mkN "marktjänst" "marktjänster" ; -- marktjänst..nn.1
  marktrupp_1_N = mkN "marktrupp" "marktrupper" ; -- marktrupp..nn.1
  marktäckare_1_N = mkN "marktäckare" utrum  ; -- marktäckare..nn.1
  markväg_1_N = mkN "markväg" ; -- markväg..nn.1
  markyta_1_N = mkN "markyta" ; -- markyta..nn.1
  markägare_1_N = mkN "markägare" utrum  ; -- markägare..nn.1
  markör_1_N = mkN "markör" "markörer" ; -- markör..nn.1
  marleka_1_N = mkN "marleka" ; -- marleka..nn.1
  marmelad_1_N = mkN "marmelad" "marmelader" ; -- marmelad..nn.1
  marmeladgodis_1_N = mkN "marmeladgodis" neutrum  ; -- marmeladgodis..nn.1
  marmeladgodis_2_N = mkN "marmeladgodis" ; -- marmeladgodis..nn.2
  marmorbord_1_N = mkN "marmorbord" neutrum  ; -- marmorbord..nn.1
  marmorbyst_1_N = mkN "marmorbyst" "marmorbyster" ; -- marmorbyst..nn.1
  marmorera_1_V = mkV "marmorerar" ; -- marmorera..vb.1
  marmorerande_1_N = mkN "marmorerande" ; -- marmorerande..nn.1
  marmorerbar_1_A = mkA "marmorerbar" ; -- marmorerbar..av.1
  marmorerbarhet_1_N = mkN "marmorerbarhet" ; -- marmorerbarhet..nn.1
  marmorering_1_N = mkN "marmorering" ; -- marmorering..nn.1
  marmorgolv_1_N = mkN "marmorgolv" neutrum  ; -- marmorgolv..nn.1
  marmorhäll_1_N = mkN "marmorhäll" ; -- marmorhäll..nn.1
  marmorliknande_1_A = mkA "marmorliknande" ; -- marmorliknande..av.1
  marmorskinande_1_A = mkA "marmorskinande" ; -- marmorskinande..av.1
  marmorskiva_1_N = mkN "marmorskiva" ; -- marmorskiva..nn.1
  marmortrappa_1_N = mkN "marmortrappa" ; -- marmortrappa..nn.1
  marmorvit_1_A = mkA "marmorvit" ; -- marmorvit..av.1
  marockan_1_N = mkN "marockan" "marockaner" ; -- marockan..nn.1
  marockansk_1_A = mkA "marockansk" ; -- marockansk..av.1
  marockanska_1_N = mkN "marockanska" ; -- marockanska..nn.1
  marodera_1_V = mkV "maroderar" ; -- marodera..vb.1
  maroderande_1_N = mkN "maroderande" ; -- maroderande..nn.1
  marodering_1_N = mkN "marodering" ; -- marodering..nn.1
  marodör_1_N = mkN "marodör" "marodörer" ; -- marodör..nn.1
  marokäng_1_N = mkN "marokäng" ; -- marokäng..nn.1
  marritt_1_N = mkN "marritt" "marritter" ; -- marritt..nn.1
  mars_1_N = mkN "mars" ; -- mars..nn.1
  marsala_1_N = mkN "marsala" ; -- marsala..nn.1
  marsch_1_N = mkN "marsch" "marscher" ; -- marsch..nn.1
  marschall_1_N = mkN "marschall" "marschaller" ; -- marschall..nn.1
  marschdrill_1_N = mkN "marschdrill" ; -- marschdrill..nn.1
  marschera_1_V = mkV "marscherar" ; -- marschera..vb.1
  marscherande_1_N = mkN "marscherande" ; -- marscherande..nn.1
  marscherbar_1_A = mkA "marscherbar" ; -- marscherbar..av.1
  marscherbarhet_1_N = mkN "marscherbarhet" ; -- marscherbarhet..nn.1
  marschering_1_N = mkN "marschering" ; -- marschering..nn.1
  marschfart_1_N = mkN "marschfart" "marschfarter" ; -- marschfart..nn.1
  marschfärdig_1_A = mkA "marschfärdig" ; -- marschfärdig..av.1
  marschklar_1_A = mkA "marschklar" ; -- marschklar..av.1
  marschläge_1_N = mkN "marschläge" ; -- marschläge..nn.1
  marschmusik_1_N = mkN "marschmusik" ; -- marschmusik..nn.1
  marschorder_1_N = mkN "marschorder" ; -- marschorder..nn.1
  marschriktning_1_N = mkN "marschriktning" ; -- marschriktning..nn.1
  marschtakt_1_N = mkN "marschtakt" ; -- marschtakt..nn.1
  marseljäs_1_N = mkN "marseljäs" ; -- marseljäs..nn.1
  marshmallow_1_N = mkN "marshmallow" "marshmallower" ; -- marshmallow..nn.1
  marsian_1_N = mkN "marsian" "marsianer" ; -- marsian..nn.1
  marsipan_1_N = mkN "marsipan" ; -- marsipan..nn.1
  marsipantårta_1_N = mkN "marsipantårta" ; -- marsipantårta..nn.1
  marsk_1_N = mkN "marsk" "marsker" ; -- marsk..nn.1
  marskalk_1_N = mkN "marskalk" ; -- marskalk..nn.1
  marskalkstav_1_N = mkN "marskalkstav" ; -- marskalkstav..nn.1
  marskatt_1_N = mkN "marskatt" "marskatter" ; -- marskatt..nn.1
  marskland_1_N = mkN "marskland" neutrum  ; -- marskland..nn.1
  marsvin_1_N = mkN "marsvin" neutrum  ; -- marsvin..nn.1
  marsväder_1_N = mkN "marsväder" neutrum  ; -- marsväder..nn.1
  martall_1_N = mkN "martall" ; -- martall..nn.1
  martasbekymmer_1_N = mkN "martasbekymmer" neutrum  ; -- martasbekymmer..nn.1
  martera_1_V = mkV "marterar" ; -- martera..vb.1
  marterande_1_N = mkN "marterande" ; -- marterande..nn.1
  marterbar_1_A = mkA "marterbar" ; -- marterbar..av.1
  marterbarhet_1_N = mkN "marterbarhet" ; -- marterbarhet..nn.1
  martering_1_N = mkN "martering" ; -- martering..nn.1
  martialisk_1_A = mkA "martialisk" ; -- martialisk..av.1
  martini_1_N = mkN "martini" "martinin" "martinis" "martinisen" ; -- martini..nn.1
  martorn_1_N = mkN "martorn" ; -- martorn..nn.1
  martyr_1_N = mkN "martyr" "martyrer" ; -- martyr..nn.1
  martyrdöd_1_N = mkN "martyrdöd" ; -- martyrdöd..nn.1
  martyrgloria_1_N = mkN "martyrgloria" ; -- martyrgloria..nn.1
  martyrium_1_N = mkN "martyrium" "martyriet" "martyrier" "martyrierna" ; -- martyrium..nn.1
  martyrskap_1_N = mkN "martyrskap" neutrum  ; -- martyrskap..nn.1
  martyrstämpel_1_N = mkN "martyrstämpel" ; -- martyrstämpel..nn.1
  marulk_1_N = mkN "marulk" ; -- marulk..nn.1
  marviol_1_N = mkN "marviol" "marvioler" ; -- marviol..nn.1
  marxism_1_N = mkN "marxism" "marxismer" ; -- marxism..nn.1
  marxist_1_N = mkN "marxist" "marxister" ; -- marxist..nn.1
  marxistisk_1_A = mkA "marxistisk" ; -- marxistisk..av.1
  maräng_1_N = mkN "maräng" "maränger" ; -- maräng..nn.1
  marängsviss_1_N = mkN "marängsviss" "marängsvisser" ; -- marängsviss..nn.1
  mas_1_N = mkN "mas" ; -- mas..nn.1
  mas_2_N = mkN "mas" ; -- mas..nn.2
  masa_1_V = mkV "masar" ; -- masa..vb.1
  masande_1_N = mkN "masande" ; -- masande..nn.1
  mascara_1_N = mkN "mascara" ; -- mascara..nn.1
  maser_1_N = mkN "maser" ; -- maser..nn.1
  masig_1_A = mkA "masig" ; -- masig..av.1
  mask_1_N = mkN "mask" ; -- mask..nn.1
  mask_2_N = mkN "mask" "masker" ; -- mask..nn.2
  maska_1_N = mkN "maska" ; -- maska..nn.1
  maska_1_V = mkV "maskar" ; -- maska..vb.1
  maska_2_V = mkV "maskar" ; -- maska..vb.2
  maskande_1_N = mkN "maskande" ; -- maskande..nn.1
  maskdiarré_1_N = mkN "maskdiarré" "maskdiarréer" ; -- maskdiarré..nn.1
  maskera_1_V = mkV "maskerar" ; -- maskera..vb.1
  maskerad_1_N = mkN "maskerad" "maskerader" ; -- maskerad..nn.1
  maskeradbal_1_N = mkN "maskeradbal" "maskeradbaler" ; -- maskeradbal..nn.1
  maskeraddräkt_1_N = mkN "maskeraddräkt" "maskeraddräkter" ; -- maskeraddräkt..nn.1
  maskerande_1_N = mkN "maskerande" ; -- maskerande..nn.1
  maskerbar_1_A = mkA "maskerbar" ; -- maskerbar..av.1
  maskerbarhet_1_N = mkN "maskerbarhet" ; -- maskerbarhet..nn.1
  maskering_1_N = mkN "maskering" ; -- maskering..nn.1
  maskeringstejp_1_N = mkN "maskeringstejp" ; -- maskeringstejp..nn.1
  maskformig_1_A = mkA "maskformig" ; -- maskformig..av.1
  maskfrat_1_N = mkN "maskfrat" neutrum  ; -- maskfrat..nn.1
  maskhål_1_N = mkN "maskhål" neutrum  ; -- maskhål..nn.1
  maskin_1_N = mkN "maskin" "maskiner" ; -- maskin..nn.1
  maskinbrodera_1_V = mkV "maskinbroderar" ; -- maskinbrodera..vb.1
  maskinbroderande_1_N = mkN "maskinbroderande" ; -- maskinbroderande..nn.1
  maskinbrodering_1_N = mkN "maskinbrodering" ; -- maskinbrodering..nn.1
  maskindel_1_N = mkN "maskindel" "maskindelen" "maskindelar" "maskindelarna" ; -- maskindel..nn.1
  maskinelement_1_N = mkN "maskinelement" neutrum  ; -- maskinelement..nn.1
  maskinell_1_A = mkA "maskinell" ; -- maskinell..av.1
  maskineri_1_N = mkN "maskineri" "maskineriet" "maskinerier" "maskinerierna" ; -- maskineri..nn.1
  maskingevär_1_N = mkN "maskingevär" neutrum  ; -- maskingevär..nn.1
  maskinhall_1_N = mkN "maskinhall" ; -- maskinhall..nn.1
  maskinhaveri_1_N = mkN "maskinhaveri" "maskinhaveriet" "maskinhaverier" "maskinhaverierna" ; -- maskinhaveri..nn.1
  maskinist_1_N = mkN "maskinist" "maskinister" ; -- maskinist..nn.1
  maskinklippa_1_V = mkV "maskinklipper" ; -- maskinklippa..vb.1
  maskinklippande_1_N = mkN "maskinklippande" ; -- maskinklippande..nn.1
  maskinklippning_1_N = mkN "maskinklippning" ; -- maskinklippning..nn.1
  maskinläsbar_1_A = mkA "maskinläsbar" ; -- maskinläsbar..av.1
  maskinläsbarhet_1_N = mkN "maskinläsbarhet" ; -- maskinläsbarhet..nn.1
  maskinmässig_1_A = mkA "maskinmässig" ; -- maskinmässig..av.1
  maskinmässighet_1_N = mkN "maskinmässighet" ; -- maskinmässighet..nn.1
  maskinpark_1_N = mkN "maskinpark" "maskinparker" ; -- maskinpark..nn.1
  maskinpistol_1_N = mkN "maskinpistol" "maskinpistoler" ; -- maskinpistol..nn.1
  maskinpress_1_N = mkN "maskinpress" ; -- maskinpress..nn.1
  maskinrum_1_N = mkN "maskinrum" "maskinrummet" "maskinrum" "maskinrummen" ; -- maskinrum..nn.1
  maskinskalad_1_A = mkA "maskinskalad" ; -- maskinskalad..av.1
  maskinskrift_1_N = mkN "maskinskrift" ; -- maskinskrift..nn.1
  maskinskriven_1_A = mkA "maskinskriven" ; -- maskinskriven..av.1
  maskinskrivning_1_N = mkN "maskinskrivning" ; -- maskinskrivning..nn.1
  maskinspråk_1_N = mkN "maskinspråk" neutrum  ; -- maskinspråk..nn.1
  maskinteknisk_1_A = mkA "maskinteknisk" ; -- maskinteknisk..av.1
  maskintelegraf_1_N = mkN "maskintelegraf" "maskintelegrafer" ; -- maskintelegraf..nn.1
  maskintid_1_N = mkN "maskintid" "maskintider" ; -- maskintid..nn.1
  maskintvätt_1_N = mkN "maskintvätt" ; -- maskintvätt..nn.1
  maskinvara_1_N = mkN "maskinvara" ; -- maskinvara..nn.1
  maskinverkstad_1_N = mkN "maskinverkstad" "maskinverkstäder" ; -- maskinverkstad..nn.1
  maskinöversättning_1_N = mkN "maskinöversättning" ; -- maskinöversättning..nn.1
  maskliknande_1_A = mkA "maskliknande" ; -- maskliknande..av.1
  maskmedel_1_N = mkN "maskmedel" neutrum  ; -- maskmedel..nn.1
  maskning_1_N = mkN "maskning" ; -- maskning..nn.1
  maskningsaktion_1_N = mkN "maskningsaktion" ; -- maskningsaktion..nn.1
  maskopi_1_N = mkN "maskopi" "maskopier" ; -- maskopi..nn.1
  maskot_1_N = mkN "maskot" ; -- maskot..nn.1
  maskros_1_N = mkN "maskros" "maskrosor" ; -- maskros..nn.1
  maskrosbarn_1_N = mkN "maskrosbarn" neutrum  ; -- maskrosbarn..nn.1
  maskrosfjun_1_N = mkN "maskrosfjun" neutrum  ; -- maskrosfjun..nn.1
  maskrosfrö_1_N = mkN "maskrosfrö" "maskrosfröet" "maskrosfrön" "maskrosfröna" ; -- maskrosfrö..nn.1
  maskspel_1_N = mkN "maskspel" "maskspelet" "maskspel" "maskspelen" ; -- maskspel..nn.1
  maskstungen_1_A = mkA "maskstungen" ; -- maskstungen..av.1
  masktäthet_1_N = mkN "masktäthet" "masktätheter" ; -- masktäthet..nn.1
  maskulin_1_A = mkA "maskulin" ; -- maskulin..av.1
  maskulinisera_1_V = mkV "maskuliniserar" ; -- maskulinisera..vb.1
  maskuliniserande_1_N = mkN "maskuliniserande" ; -- maskuliniserande..nn.1
  maskuliniserbar_1_A = mkA "maskuliniserbar" ; -- maskuliniserbar..av.1
  maskuliniserbarhet_1_N = mkN "maskuliniserbarhet" ; -- maskuliniserbarhet..nn.1
  maskulinisering_1_N = mkN "maskulinisering" ; -- maskulinisering..nn.1
  maskulinum_1_N = mkN "maskulinum" "maskulinum" "maskuliner" "maskulinerna" ; -- maskulinum..nn.1
  maskäten_1_A = mkA "maskäten" ; -- maskäten..av.1
  maskör_1_N = mkN "maskör" "maskörer" ; -- maskör..nn.1
  masochism_1_N = mkN "masochism" "masochismer" ; -- masochism..nn.1
  masochist_1_N = mkN "masochist" "masochister" ; -- masochist..nn.1
  masochistisk_1_A = mkA "masochistisk" ; -- masochistisk..av.1
  masonit_1_N = mkN "masonit" ; -- masonit..nn.1
  massa_1_N = mkN "massa" ; -- massa..nn.1
  massa_2_N = mkN "massa" ; -- massa..nn.2
  massabruk_1_N = mkN "massabruk" neutrum  ; -- massabruk..nn.1
  massafabrik_1_N = mkN "massafabrik" "massafabriker" ; -- massafabrik..nn.1
  massage_1_N = mkN "massage" utrum  ; -- massage..nn.1
  massageapparat_1_N = mkN "massageapparat" "massageapparater" ; -- massageapparat..nn.1
  massagefåtölj_1_N = mkN "massagefåtölj" "massagefåtöljer" ; -- massagefåtölj..nn.1
  massageinstitut_1_N = mkN "massageinstitut" neutrum  ; -- massageinstitut..nn.1
  massagestol_1_N = mkN "massagestol" ; -- massagestol..nn.1
  massaker_1_N = mkN "massaker" "massakern" "massakrer" "massakrerna" ; -- massaker..nn.1
  massakerklan_1_N = mkN "massakerklan" "massakerklaner" ; -- massakerklan..nn.1
  massakerskytt_1_N = mkN "massakerskytt" ; -- massakerskytt..nn.1
  massakervåg_1_N = mkN "massakervåg" "massakervågor" ; -- massakervåg..nn.1
  massakrera_1_V = mkV "massakrerar" ; -- massakrera..vb.1
  massakrerande_1_N = mkN "massakrerande" ; -- massakrerande..nn.1
  massakrerbar_1_A = mkA "massakrerbar" ; -- massakrerbar..av.1
  massakrerbarhet_1_N = mkN "massakrerbarhet" ; -- massakrerbarhet..nn.1
  massakrering_1_N = mkN "massakrering" ; -- massakrering..nn.1
  massarbetslöshet_1_N = mkN "massarbetslöshet" ; -- massarbetslöshet..nn.1
  massarrestering_1_N = mkN "massarrestering" ; -- massarrestering..nn.1
  massaved_1_N = mkN "massaved" ; -- massaved..nn.1
  massavrättning_1_N = mkN "massavrättning" ; -- massavrättning..nn.1
  massavskeda_1_V = mkV "massavskedar" ; -- massavskeda..vb.1
  massavskedande_1_N = mkN "massavskedande" ; -- massavskedande..nn.1
  massavskedning_1_N = mkN "massavskedning" ; -- massavskedning..nn.1
  massbjässe_1_N = mkN "massbjässe" utrum  ; -- massbjässe..nn.1
  masscentrum_1_N = mkN "masscentrum" neutrum  ; -- masscentrum..nn.1
  massdöd_1_N = mkN "massdöd" ; -- massdöd..nn.1
  massera_1_V = mkV "masserar" ; -- massera..vb.1
  masserande_1_N = mkN "masserande" ; -- masserande..nn.1
  masserbar_1_A = mkA "masserbar" ; -- masserbar..av.1
  masserbarhet_1_N = mkN "masserbarhet" ; -- masserbarhet..nn.1
  massering_1_N = mkN "massering" ; -- massering..nn.1
  massfattigdom_1_N = mkN "massfattigdom" ; -- massfattigdom..nn.1
  massfångst_1_N = mkN "massfångst" "massfångster" ; -- massfångst..nn.1
  massförstörelse_1_N = mkN "massförstörelse" "massförstörelser" ; -- massförstörelse..nn.1
  massförstörelsevapen_1_N = mkN "massförstörelsevapen" "massförstörelsevapnet" "massförstörelsevapen" "massförstörelsevapnen" ; -- massförstörelsevapen..nn.1
  massgrav_1_N = mkN "massgrav" ; -- massgrav..nn.1
  massgripande_1_N = mkN "massgripande" ; -- massgripande..nn.1
  masshäktning_1_N = mkN "masshäktning" ; -- masshäktning..nn.1
  massillusion_1_N = mkN "massillusion" ; -- massillusion..nn.1
  massinvandring_1_N = mkN "massinvandring" ; -- massinvandring..nn.1
  massiv_1_A = mkA "massiv" ; -- massiv..av.1
  massiv_1_N = mkN "massiv" neutrum  ; -- massiv..nn.1
  massivitet_1_N = mkN "massivitet" "massiviteter" ; -- massivitet..nn.1
  massjätte_1_N = mkN "massjätte" utrum  ; -- massjätte..nn.1
  masskommunikation_1_N = mkN "masskommunikation" ; -- masskommunikation..nn.1
  masskonst_1_N = mkN "masskonst" "masskonster" ; -- masskonst..nn.1
  masskorsband_1_N = mkN "masskorsband" neutrum  ; -- masskorsband..nn.1
  masskultur_1_N = mkN "masskultur" "masskulturer" ; -- masskultur..nn.1
  masslakt_1_N = mkN "masslakt" "masslakter" ; -- masslakt..nn.1
  masslös_1_A = mkA "masslös" ; -- masslös..av.1
  masslöshet_1_N = mkN "masslöshet" ; -- masslöshet..nn.1
  massmedial_1_A = mkA "massmedial" ; -- massmedial..av.1
  massmedium_1_N = mkN "massmedium" "massmediet" "massmedia" "massmediana" ; -- massmedium..nn.1
  massmord_1_N = mkN "massmord" neutrum  ; -- massmord..nn.1
  massmördare_1_N = mkN "massmördare" utrum  ; -- massmördare..nn.1
  massmöte_1_N = mkN "massmöte" ; -- massmöte..nn.1
  masspektrum_1_N = mkN "masspektrum" neutrum  ; -- masspektrum..nn.1
  massproducera_1_V = mkV "massproducerar" ; -- massproducera..vb.1
  massproducerad_1_A = mkA "massproducerad" ; -- massproducerad..av.1
  massproducerande_1_N = mkN "massproducerande" ; -- massproducerande..nn.1
  massproducering_1_N = mkN "massproducering" ; -- massproducering..nn.1
  massproduktion_1_N = mkN "massproduktion" ; -- massproduktion..nn.1
  massprotest_1_N = mkN "massprotest" "massprotester" ; -- massprotest..nn.1
  masspsykologi_1_N = mkN "masspsykologi" ; -- masspsykologi..nn.1
  masspsykos_1_N = mkN "masspsykos" "masspsykoser" ; -- masspsykos..nn.1
  massrättegång_1_N = mkN "massrättegång" ; -- massrättegång..nn.1
  masstal_1_N = mkN "masstal" neutrum  ; -- masstal..nn.1
  massupplopp_1_N = mkN "massupplopp" neutrum  ; -- massupplopp..nn.1
  massuppsägning_1_N = mkN "massuppsägning" ; -- massuppsägning..nn.1
  massutdöende_1_N = mkN "massutdöende" ; -- massutdöende..nn.1
  massutskick_1_N = mkN "massutskick" neutrum  ; -- massutskick..nn.1
  massvaccinering_1_N = mkN "massvaccinering" ; -- massvaccinering..nn.1
  massverkanseffekt_1_N = mkN "massverkanseffekt" "massverkanseffekter" ; -- massverkanseffekt..nn.1
  massvis_1_Adv = mkAdv "massvis" ; -- massvis..ab.1
  massvält_1_N = mkN "massvält" ; -- massvält..nn.1
  massvåldtäkt_1_N = mkN "massvåldtäkt" "massvåldtäkter" ; -- massvåldtäkt..nn.1
  massör_1_N = mkN "massör" "massörer" ; -- massör..nn.1
  massös_1_N = mkN "massös" "massöser" ; -- massös..nn.1
  mast_1_N = mkN "mast" "master" ; -- mast..nn.1
  mastad_1_A = mkA "mastad" ; -- mastad..av.1
  master_1_N = mkN "master" ; -- master..nn.1
  mastfisk_1_N = mkN "mastfisk" ; -- mastfisk..nn.1
  masthål_1_N = mkN "masthål" neutrum  ; -- masthål..nn.1
  mastig_1_A = mkA "mastig" ; -- mastig..av.1
  mastighet_1_N = mkN "mastighet" ; -- mastighet..nn.1
  mastix_1_N = mkN "mastix" ; -- mastix..nn.1
  mastkorg_1_N = mkN "mastkorg" ; -- mastkorg..nn.1
  mastkrage_1_N = mkN "mastkrage" utrum  ; -- mastkrage..nn.1
  mastodont_1_N = mkN "mastodont" "mastodonter" ; -- mastodont..nn.1
  mastodontisk_1_A = mkA "mastodontisk" ; -- mastodontisk..av.1
  mastodontprocess_1_N = mkN "mastodontprocess" "mastodontprocesser" ; -- mastodontprocess..nn.1
  mastodontprojekt_1_N = mkN "mastodontprojekt" neutrum  ; -- mastodontprojekt..nn.1
  mastodontämne_1_N = mkN "mastodontämne" ; -- mastodontämne..nn.1
  masturbation_1_N = mkN "masturbation" ; -- masturbation..nn.1
  masturbera_1_V = mkV "masturberar" ; -- masturbera..vb.1
  masturberande_1_N = mkN "masturberande" ; -- masturberande..nn.1
  masturbering_1_N = mkN "masturbering" ; -- masturbering..nn.1
  masugn_1_N = mkN "masugn" ; -- masugn..nn.1
  masurbjörk_1_N = mkN "masurbjörk" ; -- masurbjörk..nn.1
  masurka_1_N = mkN "masurka" ; -- masurka..nn.1
  masverk_1_N = mkN "masverk" neutrum  ; -- masverk..nn.1
  mat_1_N = mkN "mat" ; -- mat..nn.1
  mat_2_N = mkN "mat" neutrum  ; -- mat..nn.2
  mata_1_V = mkV "matar" ; -- mata..vb.1
  matador_1_N = mkN "matador" "matadoren" "matadorer" "matadorerna" ; -- matador..nn.1
  mataffär_1_N = mkN "mataffär" "mataffärer" ; -- mataffär..nn.1
  matalarmist_1_N = mkN "matalarmist" "matalarmister" ; -- matalarmist..nn.1
  matande_1_N = mkN "matande" ; -- matande..nn.1
  matarbuss_1_N = mkN "matarbuss" ; -- matarbuss..nn.1
  matare_1_N = mkN "matare" utrum  ; -- matare..nn.1
  matarledning_1_N = mkN "matarledning" ; -- matarledning..nn.1
  matavfall_1_N = mkN "matavfall" neutrum  ; -- matavfall..nn.1
  matavfallskvarn_1_N = mkN "matavfallskvarn" ; -- matavfallskvarn..nn.1
  matberedare_1_N = mkN "matberedare" utrum  ; -- matberedare..nn.1
  matbestick_1_N = mkN "matbestick" neutrum  ; -- matbestick..nn.1
  matbit_1_N = mkN "matbit" ; -- matbit..nn.1
  matbord_1_N = mkN "matbord" neutrum  ; -- matbord..nn.1
  matbrist_1_N = mkN "matbrist" ; -- matbrist..nn.1
  matbröd_1_N = mkN "matbröd" neutrum  ; -- matbröd..nn.1
  matbutik_1_N = mkN "matbutik" "matbutiker" ; -- matbutik..nn.1
  match_1_N = mkN "match" "matcher" ; -- match..nn.1
  matcha_1_V = mkV "matchar" ; -- matcha..vb.1
  matchande_1_N = mkN "matchande" ; -- matchande..nn.1
  matchavgörande_1_A = mkA "matchavgörande" ; -- matchavgörande..av.1
  matchavgörande_1_N = mkN "matchavgörande" ; -- matchavgörande..nn.1
  matchboll_1_N = mkN "matchboll" ; -- matchboll..nn.1
  matchhjälte_1_N = mkN "matchhjälte" utrum  ; -- matchhjälte..nn.1
  matchning_1_N = mkN "matchning" ; -- matchning..nn.1
  matchstraff_1_N = mkN "matchstraff" neutrum  ; -- matchstraff..nn.1
  matchvinnare_1_N = mkN "matchvinnare" utrum  ; -- matchvinnare..nn.1
  matdags_1_N = mkN "matdags" ; -- matdags..nn.1
  mate_1_N = mkN "mate" ; -- mate..nn.1
  matelassera_1_V = mkV "matelasserar" ; -- matelassera..vb.1
  matelasserande_1_N = mkN "matelasserande" ; -- matelasserande..nn.1
  matelasserbar_1_A = mkA "matelasserbar" ; -- matelasserbar..av.1
  matelasserbarhet_1_N = mkN "matelasserbarhet" ; -- matelasserbarhet..nn.1
  matelassering_1_N = mkN "matelassering" ; -- matelassering..nn.1
  matematik_1_N = mkN "matematik" ; -- matematik..nn.1
  matematiker_1_N = mkN "matematiker" "matematikern" "matematiker" "matematikerna" ; -- matematiker..nn.1
  matematiklärare_1_N = mkN "matematiklärare" utrum  ; -- matematiklärare..nn.1
  matematisk_naturvetenskaplig_1_A = mkA "matematisk-naturvetenskaplig" ; -- matematisk-naturvetenskaplig..av.1
  matematisk_1_A = mkA "matematisk" ; -- matematisk..av.1
  materia_1_N = mkN "materia" "materian" "materier" "materierna" ; -- materia..nn.1
  material_1_N = mkN "material" neutrum  ; -- material..nn.1
  materialförråd_1_N = mkN "materialförråd" neutrum  ; -- materialförråd..nn.1
  materialisation_1_N = mkN "materialisation" ; -- materialisation..nn.1
  materialisera_1_V = mkV "materialiserar" ; -- materialisera..vb.1
  materialiserande_1_N = mkN "materialiserande" ; -- materialiserande..nn.1
  materialiserbar_1_A = mkA "materialiserbar" ; -- materialiserbar..av.1
  materialiserbarhet_1_N = mkN "materialiserbarhet" ; -- materialiserbarhet..nn.1
  materialisering_1_N = mkN "materialisering" ; -- materialisering..nn.1
  materialism_1_N = mkN "materialism" "materialismer" ; -- materialism..nn.1
  materialist_1_N = mkN "materialist" "materialister" ; -- materialist..nn.1
  materialistisk_1_A = mkA "materialistisk" ; -- materialistisk..av.1
  materialkonstant_1_N = mkN "materialkonstant" "materialkonstanter" ; -- materialkonstant..nn.1
  materialmässig_1_A = mkA "materialmässig" ; -- materialmässig..av.1
  materialproblem_1_N = mkN "materialproblem" neutrum  ; -- materialproblem..nn.1
  materialsamling_1_N = mkN "materialsamling" ; -- materialsamling..nn.1
  materialspelare_1_N = mkN "materialspelare" utrum  ; -- materialspelare..nn.1
  materie_1_N = mkN "materie" "materier" ; -- materie..nn.1
  materieera_1_N = mkN "materieera" ; -- materieera..nn.1
  materieforskning_1_N = mkN "materieforskning" ; -- materieforskning..nn.1
  materiegas_1_N = mkN "materiegas" "materiegaser" ; -- materiegas..nn.1
  materiell_1_A = mkA "materiell" ; -- materiell..av.1
  materiemoln_1_N = mkN "materiemoln" neutrum  ; -- materiemoln..nn.1
  materieström_1_N = mkN "materieström" "materieströmmen" "materieströmmar" "materieströmmarna" ; -- materieström..nn.1
  materietransport_1_N = mkN "materietransport" "materietransporter" ; -- materietransport..nn.1
  materieutbyte_1_N = mkN "materieutbyte" ; -- materieutbyte..nn.1
  matfett_1_N = mkN "matfett" "matfettet" "matfetter" "matfetterna" ; -- matfett..nn.1
  matfrisk_1_A = mkA "matfrisk" ; -- matfrisk..av.1
  matfrukt_1_N = mkN "matfrukt" "matfrukter" ; -- matfrukt..nn.1
  matförgiftad_1_A = mkA "matförgiftad" ; -- matförgiftad..av.1
  matförgiftning_1_N = mkN "matförgiftning" ; -- matförgiftning..nn.1
  matförpackning_1_N = mkN "matförpackning" ; -- matförpackning..nn.1
  matförråd_1_N = mkN "matförråd" neutrum  ; -- matförråd..nn.1
  matglad_1_A = mkA "matglad" "matglatt" ; -- matglad..av.1
  matgäst_1_N = mkN "matgäst" "matgäster" ; -- matgäst..nn.1
  mathak_1_N = mkN "mathak" neutrum  ; -- mathak..nn.1
  mathållning_1_N = mkN "mathållning" ; -- mathållning..nn.1
  matig_1_A = mkA "matig" ; -- matig..av.1
  matinköp_1_N = mkN "matinköp" neutrum  ; -- matinköp..nn.1
  matiné_1_N = mkN "matiné" "matinéer" ; -- matiné..nn.1
  matjessill_1_N = mkN "matjessill" ; -- matjessill..nn.1
  matjessilltårta_1_N = mkN "matjessilltårta" ; -- matjessilltårta..nn.1
  matjord_1_N = mkN "matjord" ; -- matjord..nn.1
  matkasse_1_N = mkN "matkasse" utrum  ; -- matkasse..nn.1
  matklet_1_N = mkN "matklet" neutrum  ; -- matklet..nn.1
  matkonserv_1_N = mkN "matkonserv" "matkonserver" ; -- matkonserv..nn.1
  matkorg_1_N = mkN "matkorg" ; -- matkorg..nn.1
  matkultur_1_N = mkN "matkultur" "matkulturer" ; -- matkultur..nn.1
  matkupong_1_N = mkN "matkupong" "matkuponger" ; -- matkupong..nn.1
  matkällare_1_N = mkN "matkällare" utrum  ; -- matkällare..nn.1
  matlag_1_N = mkN "matlag" neutrum  ; -- matlag..nn.1
  matlagning_1_N = mkN "matlagning" ; -- matlagning..nn.1
  matlagningsgrädde_1_N = mkN "matlagningsgrädde" utrum  ; -- matlagningsgrädde..nn.1
  matlagningskonst_1_N = mkN "matlagningskonst" "matlagningskonster" ; -- matlagningskonst..nn.1
  matlagningsskicklighet_1_N = mkN "matlagningsskicklighet" "matlagningsskickligheter" ; -- matlagningsskicklighet..nn.1
  matland_1_N = mkN "matland" "matlandet" "matländer" "matländerna" ; -- matland..nn.1
  matlarm_1_N = mkN "matlarm" neutrum  ; -- matlarm..nn.1
  matlust_1_N = mkN "matlust" ; -- matlust..nn.1
  matlåda_1_N = mkN "matlåda" ; -- matlåda..nn.1
  matlådeleverans_1_N = mkN "matlådeleverans" "matlådeleveranser" ; -- matlådeleverans..nn.1
  matlådetips_1_N = mkN "matlådetips" neutrum  ; -- matlådetips..nn.1
  matmamma_1_N = mkN "matmamma" ; -- matmamma..nn.1
  matmor_1_N = mkN "matmor" ; -- matmor..nn.1
  matmässig_1_A = mkA "matmässig" ; -- matmässig..av.1
  matning_1_N = mkN "matning" ; -- matning..nn.1
  matnyttig_1_A = mkA "matnyttig" ; -- matnyttig..av.1
  matnyttighet_1_N = mkN "matnyttighet" "matnyttigheter" ; -- matnyttighet..nn.1
  matolja_1_N = mkN "matolja" ; -- matolja..nn.1
  matorgie_1_N = mkN "matorgie" "matorgier" ; -- matorgie..nn.1
  matos_1_N = mkN "matos" neutrum  ; -- matos..nn.1
  matpatrull_1_N = mkN "matpatrull" "matpatruller" ; -- matpatrull..nn.1
  matpotatis_1_N = mkN "matpotatis" ; -- matpotatis..nn.1
  matpurist_1_N = mkN "matpurist" "matpurister" ; -- matpurist..nn.1
  matranson_1_N = mkN "matranson" "matransoner" ; -- matranson..nn.1
  matrast_1_N = mkN "matrast" "matraster" ; -- matrast..nn.1
  matrecept_1_N = mkN "matrecept" neutrum  ; -- matrecept..nn.1
  matrest_1_N = mkN "matrest" "matrester" ; -- matrest..nn.1
  matriarkal_1_A = mkA "matriarkal" ; -- matriarkal..av.1
  matriarkalisk_1_A = mkA "matriarkalisk" ; -- matriarkalisk..av.1
  matriarkat_1_N = mkN "matriarkat" neutrum  ; -- matriarkat..nn.1
  matrikel_1_N = mkN "matrikel" ; -- matrikel..nn.1
  matris_1_N = mkN "matris" "matriser" ; -- matris..nn.1
  matro_1_N = mkN "matro" ; -- matro..nn.1
  matrona_1_N = mkN "matrona" ; -- matrona..nn.1
  matros_1_N = mkN "matros" "matroser" ; -- matros..nn.1
  matroskostym_1_N = mkN "matroskostym" "matroskostymer" ; -- matroskostym..nn.1
  matrum_1_N = mkN "matrum" "matrummet" "matrum" "matrummen" ; -- matrum..nn.1
  maträtt_1_N = mkN "maträtt" "maträtter" ; -- maträtt..nn.1
  matsal_1_N = mkN "matsal" ; -- matsal..nn.1
  matsalong_1_N = mkN "matsalong" "matsalonger" ; -- matsalong..nn.1
  matsedel_1_N = mkN "matsedel" ; -- matsedel..nn.1
  matservering_1_N = mkN "matservering" ; -- matservering..nn.1
  matservering_2_N = mkN "matservering" ; -- matservering..nn.2
  matservis_1_N = mkN "matservis" "matserviser" ; -- matservis..nn.1
  matsilver_1_N = mkN "matsilver" neutrum  ; -- matsilver..nn.1
  matsked_1_N = mkN "matsked" ; -- matsked..nn.1
  matsmältning_1_N = mkN "matsmältning" ; -- matsmältning..nn.1
  matsmältningsapparat_1_N = mkN "matsmältningsapparat" "matsmältningsapparater" ; -- matsmältningsapparat..nn.1
  matsmältningskanal_1_N = mkN "matsmältningskanal" "matsmältningskanaler" ; -- matsmältningskanal..nn.1
  matsmältningsorgan_1_N = mkN "matsmältningsorgan" neutrum  ; -- matsmältningsorgan..nn.1
  matsmältningsprocess_1_N = mkN "matsmältningsprocess" "matsmältningsprocesser" ; -- matsmältningsprocess..nn.1
  matsmältningssystem_1_N = mkN "matsmältningssystem" neutrum  ; -- matsmältningssystem..nn.1
  matsmältningsvätska_1_N = mkN "matsmältningsvätska" ; -- matsmältningsvätska..nn.1
  matsmör_1_N = mkN "matsmör" neutrum  ; -- matsmör..nn.1
  matstrupe_1_N = mkN "matstrupe" utrum  ; -- matstrupe..nn.1
  matställe_1_N = mkN "matställe" ; -- matställe..nn.1
  matsvamp_1_N = mkN "matsvamp" ; -- matsvamp..nn.1
  matsvinn_1_N = mkN "matsvinn" neutrum  ; -- matsvinn..nn.1
  matsäck_1_N = mkN "matsäck" ; -- matsäck..nn.1
  matsäcksmat_1_N = mkN "matsäcksmat" ; -- matsäcksmat..nn.1
  matsäckssmörgås_1_N = mkN "matsäckssmörgås" ; -- matsäckssmörgås..nn.1
  matsäcksväska_1_N = mkN "matsäcksväska" ; -- matsäcksväska..nn.1
  matt_1_A = mkA "matt" ; -- matt..av.1
  matt_2_A = mkA "matt" ; -- matt..av.2
  matta_1_N = mkN "matta" ; -- matta..nn.1
  matta_1_V = mkV "mattar" ; -- matta..vb.1
  mattallrik_1_N = mkN "mattallrik" ; -- mattallrik..nn.1
  mattande_1_N = mkN "mattande" ; -- mattande..nn.1
  mattbelagd_1_A = mkA "mattbelagd" "mattbelagt" ; -- mattbelagd..av.1
  mattbrottning_1_N = mkN "mattbrottning" ; -- mattbrottning..nn.1
  mattdomare_1_N = mkN "mattdomare" utrum  ; -- mattdomare..nn.1
  matte_1_N = mkN "matte" utrum  ; -- matte..nn.1
  matte_2_N = mkN "matte" utrum  ; -- matte..nn.2
  matte_3_N = mkN "matte" ; -- matte..nn.3
  mattejp_1_N = mkN "mattejp" ; -- mattejp..nn.1
  matteprov_1_N = mkN "matteprov" neutrum  ; -- matteprov..nn.1
  mattera_1_V = mkV "matterar" ; -- mattera..vb.1
  matterande_1_N = mkN "matterande" ; -- matterande..nn.1
  matterbar_1_A = mkA "matterbar" ; -- matterbar..av.1
  matterbarhet_1_N = mkN "matterbarhet" ; -- matterbarhet..nn.1
  mattering_1_N = mkN "mattering" ; -- mattering..nn.1
  mattesnille_1_N = mkN "mattesnille" ; -- mattesnille..nn.1
  mattgrön_1_A = mkA "mattgrön" ; -- mattgrön..av.1
  matthet_1_N = mkN "matthet" "mattheter" ; -- matthet..nn.1
  matthet_2_N = mkN "matthet" ; -- matthet..nn.2
  mattighet_1_N = mkN "mattighet" "mattigheter" ; -- mattighet..nn.1
  mattkamp_1_N = mkN "mattkamp" "mattkamper" ; -- mattkamp..nn.1
  mattpiskare_1_N = mkN "mattpiskare" utrum  ; -- mattpiskare..nn.1
  mattpiskning_1_N = mkN "mattpiskning" ; -- mattpiskning..nn.1
  mattpiskställning_1_N = mkN "mattpiskställning" ; -- mattpiskställning..nn.1
  mattram_1_N = mkN "mattram" ; -- mattram..nn.1
  mattskiva_1_N = mkN "mattskiva" ; -- mattskiva..nn.1
  mattslipad_1_A = mkA "mattslipad" ; -- mattslipad..av.1
  mattslipning_1_N = mkN "mattslipning" ; -- mattslipning..nn.1
  mattsopare_1_N = mkN "mattsopare" utrum  ; -- mattsopare..nn.1
  mattsvart_1_A = mkA "mattsvart" "mattsvart" ; -- mattsvart..av.1
  mattvävare_1_N = mkN "mattvävare" utrum  ; -- mattvävare..nn.1
  mattögdhet_1_N = mkN "mattögdhet" ; -- mattögdhet..nn.1
  matutin_1_N = mkN "matutin" "matutiner" ; -- matutin..nn.1
  matvana_1_N = mkN "matvana" ; -- matvana..nn.1
  matvara_1_N = mkN "matvara" ; -- matvara..nn.1
  matvaruaffär_1_N = mkN "matvaruaffär" "matvaruaffärer" ; -- matvaruaffär..nn.1
  matvaruhall_1_N = mkN "matvaruhall" ; -- matvaruhall..nn.1
  matvarukedja_1_N = mkN "matvarukedja" ; -- matvarukedja..nn.1
  matvrak_1_N = mkN "matvrak" neutrum  ; -- matvrak..nn.1
  matvrå_1_N = mkN "matvrå" "matvrån" "matvrår" "matvrårna" ; -- matvrå..nn.1
  matvägra_1_V = mkV "matvägrar" ; -- matvägra..vb.1
  matvägrande_1_N = mkN "matvägrande" ; -- matvägrande..nn.1
  matäpple_1_N = mkN "matäpple" ; -- matäpple..nn.1
  mauretanier_1_N = mkN "mauretanier" "mauretaniern" "mauretanier" "mauretanierna" ; -- mauretanier..nn.1
  mauretansk_1_A = mkA "mauretansk" ; -- mauretansk..av.1
  mauretanska_1_N = mkN "mauretanska" ; -- mauretanska..nn.1
  mauritier_1_N = mkN "mauritier" "mauritiern" "mauritier" "mauritierna" ; -- mauritier..nn.1
  mauritisk_1_A = mkA "mauritisk" ; -- mauritisk..av.1
  mauritiska_1_N = mkN "mauritiska" ; -- mauritiska..nn.1
  mauser_1_N = mkN "mauser" "mausern" "mauser" "mauserna" ; -- mauser..nn.1
  mausergevär_1_N = mkN "mausergevär" neutrum  ; -- mausergevär..nn.1
  mauserpistol_1_N = mkN "mauserpistol" "mauserpistoler" ; -- mauserpistol..nn.1
  mausoleum_1_N = mkN "mausoleum" "mausoleet" "mausoleer" "mausoleerna" ; -- mausoleum..nn.1
  max_1_N = mkN "max" neutrum  ; -- max..nn.1
  maxa_1_V = mkV "maxar" ; -- maxa..vb.1
  maxande_1_N = mkN "maxande" ; -- maxande..nn.1
  maxfart_1_N = mkN "maxfart" "maxfarter" ; -- maxfart..nn.1
  maxhastighet_1_N = mkN "maxhastighet" "maxhastigheter" ; -- maxhastighet..nn.1
  maxikjol_1_N = mkN "maxikjol" ; -- maxikjol..nn.1
  maxill_1_N = mkN "maxill" "maxiller" ; -- maxill..nn.1
  maxilön_1_N = mkN "maxilön" "maxilöner" ; -- maxilön..nn.1
  maxim_1_N = mkN "maxim" "maximer" ; -- maxim..nn.1
  maximal_1_A = mkA "maximal" ; -- maximal..av.1
  maximera_1_V = mkV "maximerar" ; -- maximera..vb.1
  maximerande_1_N = mkN "maximerande" ; -- maximerande..nn.1
  maximerbar_1_A = mkA "maximerbar" ; -- maximerbar..av.1
  maximerbarhet_1_N = mkN "maximerbarhet" ; -- maximerbarhet..nn.1
  maximering_1_N = mkN "maximering" ; -- maximering..nn.1
  maximipunkt_1_N = mkN "maximipunkt" "maximipunkter" ; -- maximipunkt..nn.1
  maximitemperatur_1_N = mkN "maximitemperatur" "maximitemperaturer" ; -- maximitemperatur..nn.1
  maximitermometer_1_N = mkN "maximitermometer" ; -- maximitermometer..nn.1
  maximum_1_N = mkN "maximum" neutrum  ; -- maximum..nn.1
  maxiroller_1_N = mkN "maxiroller" ; -- maxiroller..nn.1
  maxlast_1_N = mkN "maxlast" "maxlaster" ; -- maxlast..nn.1
  maxtaxa_1_N = mkN "maxtaxa" ; -- maxtaxa..nn.1
  mayafolk_1_N = mkN "mayafolk" neutrum  ; -- mayafolk..nn.1
  mazarin_1_N = mkN "mazarin" "mazariner" ; -- mazarin..nn.1
  mazurka_1_N = mkN "mazurka" ; -- mazurka..nn.1
  mc_byxa_1_N = mkN "mc-byxa" ; -- mc-byxa..nn.1
  mc_gäng_1_N = mkN "mc-gäng" neutrum  ; -- mc-gäng..nn.1
  mc_lyft_1_N = mkN "mc-lyft" ; -- mc-lyft..nn.1
  mc_åkning_1_N = mkN "mc-åkning" ; -- mc-åkning..nn.1
  meander_1_N = mkN "meander" ; -- meander..nn.1
  meanderslinga_1_N = mkN "meanderslinga" ; -- meanderslinga..nn.1
  meccano_1_N = mkN "meccano" "meccanot" "meccanon" "meccanona" ; -- meccano..nn.1
  mecenat_1_N = mkN "mecenat" "mecenater" ; -- mecenat..nn.1
  mecenatskap_1_N = mkN "mecenatskap" neutrum  ; -- mecenatskap..nn.1
  mecka_1_N = mkN "mecka" "meckat" "meckan" "meckana" ; -- mecka..nn.1
  mecka_1_V = mkV "meckar" ; -- mecka..vb.1
  meckande_1_N = mkN "meckande" ; -- meckande..nn.1
  meckla_1_V = mkV "mecklar" ; -- meckla..vb.1
  mecklande_1_N = mkN "mecklande" ; -- mecklande..nn.1
  med_1_Adv = mkAdv "med" ; -- med..ab.1
  medalj_1_N = mkN "medalj" "medaljer" ; -- medalj..nn.1
  medaljceremoni_1_N = mkN "medaljceremoni" "medaljceremonier" ; -- medaljceremoni..nn.1
  medaljera_1_V = mkV "medaljerar" ; -- medaljera..vb.1
  medaljerande_1_N = mkN "medaljerande" ; -- medaljerande..nn.1
  medaljerbar_1_A = mkA "medaljerbar" ; -- medaljerbar..av.1
  medaljerbarhet_1_N = mkN "medaljerbarhet" ; -- medaljerbarhet..nn.1
  medaljering_1_N = mkN "medaljering" ; -- medaljering..nn.1
  medaljliga_1_N = mkN "medaljliga" ; -- medaljliga..nn.1
  medaljmässig_1_A = mkA "medaljmässig" ; -- medaljmässig..av.1
  medaljong_1_N = mkN "medaljong" "medaljonger" ; -- medaljong..nn.1
  medaljongtryck_1_N = mkN "medaljongtryck" neutrum  ; -- medaljongtryck..nn.1
  medaljplats_1_N = mkN "medaljplats" "medaljplatser" ; -- medaljplats..nn.1
  medaljutdelning_1_N = mkN "medaljutdelning" ; -- medaljutdelning..nn.1
  medaljör_1_N = mkN "medaljör" "medaljörer" ; -- medaljör..nn.1
  medansvar_1_N = mkN "medansvar" neutrum  ; -- medansvar..nn.1
  medansvarig_1_A = mkA "medansvarig" ; -- medansvarig..av.1
  medansvarighet_1_N = mkN "medansvarighet" ; -- medansvarighet..nn.1
  medarbeta_1_V = mkV "medarbetar" ; -- medarbeta..vb.1
  medarbetande_1_N = mkN "medarbetande" ; -- medarbetande..nn.1
  medarbetare_1_N = mkN "medarbetare" utrum  ; -- medarbetare..nn.1
  medbedömare_1_N = mkN "medbedömare" utrum  ; -- medbedömare..nn.1
  medbeslutande_1_N = mkN "medbeslutande" ; -- medbeslutande..nn.1
  medbeslutandeförfarande_1_N = mkN "medbeslutandeförfarande" ; -- medbeslutandeförfarande..nn.1
  medbestämmande_1_N = mkN "medbestämmande" ; -- medbestämmande..nn.1
  medbestämmandelag_1_N = mkN "medbestämmandelag" ; -- medbestämmandelag..nn.1
  medborgaranda_1_N = mkN "medborgaranda" ; -- medborgaranda..nn.1
  medborgare_1_N = mkN "medborgare" utrum  ; -- medborgare..nn.1
  medborgargarde_1_N = mkN "medborgargarde" ; -- medborgargarde..nn.1
  medborgarhus_1_N = mkN "medborgarhus" neutrum  ; -- medborgarhus..nn.1
  medborgarinflytande_1_N = mkN "medborgarinflytande" ; -- medborgarinflytande..nn.1
  medborgarinitierad_1_A = mkA "medborgarinitierad" ; -- medborgarinitierad..av.1
  medborgarrätt_1_N = mkN "medborgarrätt" ; -- medborgarrätt..nn.1
  medborgarrättsengagemang_1_N = mkN "medborgarrättsengagemang" neutrum  ; -- medborgarrättsengagemang..nn.1
  medborgarrättsrörelse_1_N = mkN "medborgarrättsrörelse" "medborgarrättsrörelser" ; -- medborgarrättsrörelse..nn.1
  medborgarsinne_1_N = mkN "medborgarsinne" ; -- medborgarsinne..nn.1
  medborgarskap_1_N = mkN "medborgarskap" neutrum  ; -- medborgarskap..nn.1
  medborgarvittne_1_N = mkN "medborgarvittne" ; -- medborgarvittne..nn.1
  medborgenär_1_N = mkN "medborgenär" "medborgenärer" ; -- medborgenär..nn.1
  medborgerlig_1_A = mkA "medborgerlig" ; -- medborgerlig..av.1
  medborgerlighet_1_N = mkN "medborgerlighet" ; -- medborgerlighet..nn.1
  medbringa_1_V = mkV "medbringar" ; -- medbringa..vb.1
  medbringande_1_N = mkN "medbringande" ; -- medbringande..nn.1
  medbringare_1_N = mkN "medbringare" utrum  ; -- medbringare..nn.1
  medbroder_1_N = mkN "medbroder" "medbrodern" "medbröder" "medbröderna" ; -- medbroder..nn.1
  medbrottslig_1_A = mkA "medbrottslig" ; -- medbrottslig..av.1
  medbrottslighet_1_N = mkN "medbrottslighet" ; -- medbrottslighet..nn.1
  medbrottsling_1_N = mkN "medbrottsling" ; -- medbrottsling..nn.1
  meddela_1_V = mkV "meddelar" ; -- meddela..vb.1
  meddelaktig_1_A = mkA "meddelaktig" ; -- meddelaktig..av.1
  meddelaktighet_1_N = mkN "meddelaktighet" ; -- meddelaktighet..nn.1
  meddelande_1_N = mkN "meddelande" ; -- meddelande..nn.1
  meddelandeplikt_1_N = mkN "meddelandeplikt" ; -- meddelandeplikt..nn.1
  meddelare_1_N = mkN "meddelare" utrum  ; -- meddelare..nn.1
  meddelelse_1_N = mkN "meddelelse" utrum  ; -- meddelelse..nn.1
  meddelelsemedel_1_N = mkN "meddelelsemedel" neutrum  ; -- meddelelsemedel..nn.1
  meddelsam_1_A = mkA "meddelsam" "meddelsamt" "meddelsamma" "meddelsamma" "meddelsammare" "meddelsammast" "meddelsammaste" ; -- meddelsam..av.1
  meddelsamhet_1_N = mkN "meddelsamhet" ; -- meddelsamhet..nn.1
  mede_1_N = mkN "med" ; -- mede..nn.1
  medel_1_A = mkA "medel" ; -- medel..av.1
  medel_1_N = mkN "medel" neutrum  ; -- medel..nn.1
  medelavstånd_1_N = mkN "medelavstånd" neutrum  ; -- medelavstånd..nn.1
  medelbar_1_A = mkA "medelbar" ; -- medelbar..av.1
  medelbarhet_1_N = mkN "medelbarhet" ; -- medelbarhet..nn.1
  medeldistans_1_N = mkN "medeldistans" "medeldistanser" ; -- medeldistans..nn.1
  medeldistansraket_1_N = mkN "medeldistansraket" "medeldistansraketer" ; -- medeldistansraket..nn.1
  medeldistansrobot_1_N = mkN "medeldistansrobot" ; -- medeldistansrobot..nn.1
  medelfel_1_N = mkN "medelfel" "medelfelet" "medelfel" "medelfelen" ; -- medelfel..nn.1
  medelfin_1_A = mkA "medelfin" ; -- medelfin..av.1
  medelfinhet_1_N = mkN "medelfinhet" ; -- medelfinhet..nn.1
  medelgod_1_A = mkA "medelgod" "medelgott" ; -- medelgod..av.1
  medelgrov_1_A = mkA "medelgrov" ; -- medelgrov..av.1
  medelhastighet_1_N = mkN "medelhastighet" "medelhastigheter" ; -- medelhastighet..nn.1
  medelhav_1_N = mkN "medelhav" neutrum  ; -- medelhav..nn.1
  medelhavsträd_1_N = mkN "medelhavsträd" neutrum  ; -- medelhavsträd..nn.1
  medelhög_1_A = mkA "medelhög" ; -- medelhög..av.1
  medelhöjd_1_N = mkN "medelhöjd" "medelhöjder" ; -- medelhöjd..nn.1
  medelindisk_1_A = mkA "medelindisk" ; -- medelindisk..av.1
  medelinkomst_1_N = mkN "medelinkomst" "medelinkomster" ; -- medelinkomst..nn.1
  medelinkomsttagare_1_N = mkN "medelinkomsttagare" utrum  ; -- medelinkomsttagare..nn.1
  medelklass_1_N = mkN "medelklass" "medelklasser" ; -- medelklass..nn.1
  medelklassfördom_1_N = mkN "medelklassfördom" ; -- medelklassfördom..nn.1
  medelklassgetto_1_N = mkN "medelklassgetto" "medelklassgettot" "medelklassgetton" "medelklassgettona" ; -- medelklassgetto..nn.1
  medelklassghetto_1_N = mkN "medelklassghetto" "medelklassghettot" "medelklassghetton" "medelklassghettona" ; -- medelklassghetto..nn.1
  medelklassområde_1_N = mkN "medelklassområde" ; -- medelklassområde..nn.1
  medelklasstänkande_1_N = mkN "medelklasstänkande" ; -- medelklasstänkande..nn.1
  medelkörsträcka_1_N = mkN "medelkörsträcka" ; -- medelkörsträcka..nn.1
  medellivslängd_1_N = mkN "medellivslängd" "medellivslängder" ; -- medellivslängd..nn.1
  medellängd_1_N = mkN "medellängd" "medellängder" ; -- medellängd..nn.1
  medellång_1_A = mkA "medellång" ; -- medellång..av.1
  medellös_1_A = mkA "medellös" ; -- medellös..av.1
  medellöshet_1_N = mkN "medellöshet" ; -- medellöshet..nn.1
  medelmåtta_1_N = mkN "medelmåtta" ; -- medelmåtta..nn.1
  medelmåttig_1_A = mkA "medelmåttig" ; -- medelmåttig..av.1
  medelmåttighet_1_N = mkN "medelmåttighet" ; -- medelmåttighet..nn.1
  medelpadare_1_N = mkN "medelpadare" utrum  ; -- medelpadare..nn.1
  medelpadsk_1_A = mkA "medelpadsk" ; -- medelpadsk..av.1
  medelpadska_1_N = mkN "medelpadska" ; -- medelpadska..nn.1
  medelpadska_2_N = mkN "medelpadska" ; -- medelpadska..nn.2
  medelpris_1_N = mkN "medelpris" neutrum  ; -- medelpris..nn.1
  medelproportional_1_N = mkN "medelproportional" "medelproportionaler" ; -- medelproportional..nn.1
  medelpunkt_1_N = mkN "medelpunkt" "medelpunkter" ; -- medelpunkt..nn.1
  medelsanvisning_1_N = mkN "medelsanvisning" ; -- medelsanvisning..nn.1
  medelskörd_1_N = mkN "medelskörd" ; -- medelskörd..nn.1
  medelsol_1_N = mkN "medelsol" ; -- medelsol..nn.1
  medelsoldygn_1_N = mkN "medelsoldygn" neutrum  ; -- medelsoldygn..nn.1
  medelsoltid_1_N = mkN "medelsoltid" "medelsoltider" ; -- medelsoltid..nn.1
  medelstor_1_A = mkA "medelstor" ; -- medelstor..av.1
  medelstorlek_1_N = mkN "medelstorlek" ; -- medelstorlek..nn.1
  medelsvensson_1_N = mkN "medelsvensson" "medelsvenssöner" ; -- medelsvensson..nn.1
  medelsvår_1_A = mkA "medelsvår" ; -- medelsvår..av.1
  medeltal_1_N = mkN "medeltal" neutrum  ; -- medeltal..nn.1
  medeltemperatur_1_N = mkN "medeltemperatur" "medeltemperaturer" ; -- medeltemperatur..nn.1
  medeltid_1_N = mkN "medeltid" ; -- medeltid..nn.1
  medeltida_1_A = mkA "medeltida" ; -- medeltida..av.1
  medeltidslatin_1_N = mkN "medeltidslatin" neutrum  ; -- medeltidslatin..nn.1
  medeltidsmänniska_1_N = mkN "medeltidsmänniska" ; -- medeltidsmänniska..nn.1
  medeltidsmässig_1_A = mkA "medeltidsmässig" ; -- medeltidsmässig..av.1
  medeltidsmålning_1_N = mkN "medeltidsmålning" ; -- medeltidsmålning..nn.1
  medeltidstänkare_1_N = mkN "medeltidstänkare" utrum  ; -- medeltidstänkare..nn.1
  medeltung_1_A = mkA "medeltung" ; -- medeltung..av.1
  medelvattenstånd_1_N = mkN "medelvattenstånd" neutrum  ; -- medelvattenstånd..nn.1
  medelväg_1_N = mkN "medelväg" ; -- medelväg..nn.1
  medelvärde_1_N = mkN "medelvärde" ; -- medelvärde..nn.1
  medelålder_1_N = mkN "medelålder" ; -- medelålder..nn.1
  medelålders_1_A = mkA "medelålders" ; -- medelålders..av.1
  medelålderskris_1_N = mkN "medelålderskris" "medelålderskriser" ; -- medelålderskris..nn.1
  medfaren_1_A = mkA "medfaren" ; -- medfaren..av.1
  medfarenhet_1_N = mkN "medfarenhet" ; -- medfarenhet..nn.1
  medfinansiär_1_N = mkN "medfinansiär" "medfinansiärer" ; -- medfinansiär..nn.1
  medfånge_1_N = mkN "medfånge" utrum  ; -- medfånge..nn.1
  medfödd_1_A = mkA "medfödd" ; -- medfödd..av.1
  medföddhet_1_N = mkN "medföddhet" ; -- medföddhet..nn.1
  medfölja_1_V = mkV "medfölja" "medföljde" "medföljt" ; -- medfölja..vb.1
  medföljande_1_N = mkN "medföljande" ; -- medföljande..nn.1
  medföra_1_V = mkV "medföra" "medförde" "medfört" ; -- medföra..vb.1
  medförande_1_N = mkN "medförande" ; -- medförande..nn.1
  medföredragande_1_N = mkN "medföredragande" "medföredraganden" "medföredraganden" "medföredragandena" ; -- medföredragande..nn.1
  medförfattare_1_N = mkN "medförfattare" utrum  ; -- medförfattare..nn.1
  medge_1_V = mkV "medgiva" "medgav" "medgivit" ; -- medge..vb.1
  medgivande_1_N = mkN "medgivande" ; -- medgivande..nn.1
  medgång_1_N = mkN "medgång" ; -- medgång..nn.1
  medgörlig_1_A = mkA "medgörlig" ; -- medgörlig..av.1
  medgörlighet_1_N = mkN "medgörlighet" ; -- medgörlighet..nn.1
  medhavd_1_A = mkA "medhavd" "medhavt" ; -- medhavd..av.1
  medhjälp_1_N = mkN "medhjälp" ; -- medhjälp..nn.1
  medhjälpare_1_N = mkN "medhjälpare" utrum  ; -- medhjälpare..nn.1
  medhåll_1_N = mkN "medhåll" neutrum  ; -- medhåll..nn.1
  medhållare_1_N = mkN "medhållare" utrum  ; -- medhållare..nn.1
  mediabevakning_1_N = mkN "mediabevakning" ; -- mediabevakning..nn.1
  mediabild_1_N = mkN "mediabild" "mediabilder" ; -- mediabild..nn.1
  mediabrus_1_N = mkN "mediabrus" neutrum  ; -- mediabrus..nn.1
  mediacirkus_1_N = mkN "mediacirkus" ; -- mediacirkus..nn.1
  mediadamm_1_N = mkN "mediadamm" ; -- mediadamm..nn.1
  mediadrev_1_N = mkN "mediadrev" neutrum  ; -- mediadrev..nn.1
  mediaetablissemang_1_N = mkN "mediaetablissemang" neutrum  ; -- mediaetablissemang..nn.1
  mediaföretag_1_N = mkN "mediaföretag" neutrum  ; -- mediaföretag..nn.1
  mediaindustri_1_N = mkN "mediaindustri" "mediaindustrier" ; -- mediaindustri..nn.1
  mediakanal_1_N = mkN "mediakanal" "mediakanaler" ; -- mediakanal..nn.1
  mediaklimat_1_N = mkN "mediaklimat" neutrum  ; -- mediaklimat..nn.1
  mediakritisk_1_A = mkA "mediakritisk" ; -- mediakritisk..av.1
  medial_1_A = mkA "medial" ; -- medial..av.1
  medialogik_1_N = mkN "medialogik" ; -- medialogik..nn.1
  mediamakt_1_N = mkN "mediamakt" ; -- mediamakt..nn.1
  mediamogul_1_N = mkN "mediamogul" "mediamoguler" ; -- mediamogul..nn.1
  mediamässig_1_A = mkA "mediamässig" ; -- mediamässig..av.1
  median_1_N = mkN "median" "medianer" ; -- median..nn.1
  medianväljare_1_N = mkN "medianväljare" utrum  ; -- medianväljare..nn.1
  mediapolitik_1_N = mkN "mediapolitik" ; -- mediapolitik..nn.1
  mediapolitisk_1_A = mkA "mediapolitisk" ; -- mediapolitisk..av.1
  mediarapportering_1_N = mkN "mediarapportering" ; -- mediarapportering..nn.1
  mediatek_1_N = mkN "mediatek" neutrum  ; -- mediatek..nn.1
  mediateknik_1_N = mkN "mediateknik" "mediatekniker" ; -- mediateknik..nn.1
  mediatrend_1_N = mkN "mediatrend" "mediatrender" ; -- mediatrend..nn.1
  mediauppbåd_1_N = mkN "mediauppbåd" neutrum  ; -- mediauppbåd..nn.1
  mediautbud_1_N = mkN "mediautbud" neutrum  ; -- mediautbud..nn.1
  medicin_1_N = mkN "medicin" "mediciner" ; -- medicin..nn.1
  medicinalstyrelse_1_N = mkN "medicinalstyrelse" "medicinalstyrelser" ; -- medicinalstyrelse..nn.1
  medicinalvikt_1_N = mkN "medicinalvikt" ; -- medicinalvikt..nn.1
  medicinalväxt_1_N = mkN "medicinalväxt" "medicinalväxter" ; -- medicinalväxt..nn.1
  medicinare_1_N = mkN "medicinare" utrum  ; -- medicinare..nn.1
  medicinbluff_1_N = mkN "medicinbluff" ; -- medicinbluff..nn.1
  medicinboll_1_N = mkN "medicinboll" ; -- medicinboll..nn.1
  medicinera_1_V = mkV "medicinerar" ; -- medicinera..vb.1
  medicinerande_1_N = mkN "medicinerande" ; -- medicinerande..nn.1
  medicinerbar_1_A = mkA "medicinerbar" ; -- medicinerbar..av.1
  medicinerbarhet_1_N = mkN "medicinerbarhet" ; -- medicinerbarhet..nn.1
  medicinering_1_N = mkN "medicinering" ; -- medicinering..nn.1
  medicinglas_1_N = mkN "medicinglas" neutrum  ; -- medicinglas..nn.1
  medicinhistoria_1_N = mkN "medicinhistoria" ; -- medicinhistoria..nn.1
  medicinhistorisk_1_A = mkA "medicinhistorisk" ; -- medicinhistorisk..av.1
  medicinman_1_N = mkN "medicinman" "medicinmannen" "medicinmän" "medicinmännen" ; -- medicinman..nn.1
  medicinreporter_1_N = mkN "medicinreporter" ; -- medicinreporter..nn.1
  medicinsk_1_A = mkA "medicinsk" ; -- medicinsk..av.1
  medicinteknik_1_N = mkN "medicinteknik" "medicintekniker" ; -- medicinteknik..nn.1
  medicinteknisk_1_A = mkA "medicinteknisk" ; -- medicinteknisk..av.1
  mediebevakning_1_N = mkN "mediebevakning" ; -- mediebevakning..nn.1
  mediebild_1_N = mkN "mediebild" "mediebilder" ; -- mediebild..nn.1
  mediebrus_1_N = mkN "mediebrus" neutrum  ; -- mediebrus..nn.1
  mediecirkus_1_N = mkN "mediecirkus" ; -- mediecirkus..nn.1
  mediedamm_1_N = mkN "mediedamm" ; -- mediedamm..nn.1
  mediedrev_1_N = mkN "mediedrev" neutrum  ; -- mediedrev..nn.1
  medieetablissemang_1_N = mkN "medieetablissemang" neutrum  ; -- medieetablissemang..nn.1
  medieföretag_1_N = mkN "medieföretag" neutrum  ; -- medieföretag..nn.1
  medieindustri_1_N = mkN "medieindustri" "medieindustrier" ; -- medieindustri..nn.1
  mediekanal_1_N = mkN "mediekanal" "mediekanaler" ; -- mediekanal..nn.1
  medieklimat_1_N = mkN "medieklimat" neutrum  ; -- medieklimat..nn.1
  medielogik_1_N = mkN "medielogik" ; -- medielogik..nn.1
  mediemakt_1_N = mkN "mediemakt" ; -- mediemakt..nn.1
  mediemogul_1_N = mkN "mediemogul" "mediemoguler" ; -- mediemogul..nn.1
  mediemässig_1_A = mkA "mediemässig" ; -- mediemässig..av.1
  mediepolitik_1_N = mkN "mediepolitik" ; -- mediepolitik..nn.1
  mediepolitisk_1_A = mkA "mediepolitisk" ; -- mediepolitisk..av.1
  medierapportering_1_N = mkN "medierapportering" ; -- medierapportering..nn.1
  medieteknik_1_N = mkN "medieteknik" "medietekniker" ; -- medieteknik..nn.1
  medietrend_1_N = mkN "medietrend" "medietrender" ; -- medietrend..nn.1
  medieuppbåd_1_N = mkN "medieuppbåd" neutrum  ; -- medieuppbåd..nn.1
  medieutbud_1_N = mkN "medieutbud" neutrum  ; -- medieutbud..nn.1
  medieval_1_N = mkN "medieval" "medievaler" ; -- medieval..nn.1
  medikament_1_N = mkN "medikament" neutrum  ; -- medikament..nn.1
  medikus_1_N = mkN "medikus" "medikusen" "medici" "medicina" ; -- medikus..nn.1
  medinflytande_1_N = mkN "medinflytande" ; -- medinflytande..nn.1
  medioker_1_A = mkA "medioker" ; -- medioker..av.1
  mediokerhet_1_N = mkN "mediokerhet" ; -- mediokerhet..nn.1
  mediotek_1_N = mkN "mediotek" neutrum  ; -- mediotek..nn.1
  medisterkorv_1_N = mkN "medisterkorv" ; -- medisterkorv..nn.1
  meditation_1_N = mkN "meditation" ; -- meditation..nn.1
  meditativ_1_A = mkA "meditativ" ; -- meditativ..av.1
  meditera_1_V = mkV "mediterar" ; -- meditera..vb.1
  mediterande_1_N = mkN "mediterande" ; -- mediterande..nn.1
  meditering_1_N = mkN "meditering" ; -- meditering..nn.1
  mediterran_1_A = mkA "mediterran" ; -- mediterran..av.1
  medium_1_N = mkN "medium" "mediet" "media" "mediana" ; -- medium..nn.1
  medium_2_N = mkN "medium" neutrum  ; -- medium..nn.2
  mediuppgift_1_N = mkN "mediuppgift" "mediuppgifter" ; -- mediuppgift..nn.1
  medkonsul_1_N = mkN "medkonsul" "medkonsuln" "medkonsuler" "medkonsulerna" ; -- medkonsul..nn.1
  medkristen_1_A = mkA "medkristen" ; -- medkristen..av.1
  medkännande_1_A = mkA "medkännande" ; -- medkännande..av.1
  medkänsla_1_N = mkN "medkänsla" ; -- medkänsla..nn.1
  medla_1_V = mkV "medlar" ; -- medla..vb.1
  medlande_1_N = mkN "medlande" ; -- medlande..nn.1
  medlare_1_N = mkN "medlare" utrum  ; -- medlare..nn.1
  medlarroll_1_N = mkN "medlarroll" "medlarroller" ; -- medlarroll..nn.1
  medlem_1_N = mkN "medlem" "medlemmen" "medlemmar" "medlemmarna" ; -- medlem..nn.1
  medlemsantal_1_N = mkN "medlemsantal" neutrum  ; -- medlemsantal..nn.1
  medlemsantalsmässig_1_A = mkA "medlemsantalsmässig" ; -- medlemsantalsmässig..av.1
  medlemsavgift_1_N = mkN "medlemsavgift" "medlemsavgifter" ; -- medlemsavgift..nn.1
  medlemsföretag_1_N = mkN "medlemsföretag" neutrum  ; -- medlemsföretag..nn.1
  medlemsförhandling_1_N = mkN "medlemsförhandling" ; -- medlemsförhandling..nn.1
  medlemskap_1_N = mkN "medlemskap" neutrum  ; -- medlemskap..nn.1
  medlemskartotek_1_N = mkN "medlemskartotek" neutrum  ; -- medlemskartotek..nn.1
  medlemskort_1_N = mkN "medlemskort" neutrum  ; -- medlemskort..nn.1
  medlemsland_1_N = mkN "medlemsland" "medlemslandet" "medlemsländer" "medlemsländerna" ; -- medlemsland..nn.1
  medlemsmässig_1_A = mkA "medlemsmässig" ; -- medlemsmässig..av.1
  medlemsmöte_1_N = mkN "medlemsmöte" ; -- medlemsmöte..nn.1
  medlemsskap_1_N = mkN "medlemsskap" neutrum  ; -- medlemsskap..nn.1
  medlemsstat_1_N = mkN "medlemsstat" "medlemsstater" ; -- medlemsstat..nn.1
  medlemstapp_1_N = mkN "medlemstapp" ; -- medlemstapp..nn.1
  medlidande_1_N = mkN "medlidande" ; -- medlidande..nn.1
  medlidsam_1_A = mkA "medlidsam" "medlidsamt" "medlidsamma" "medlidsamma" "medlidsammare" "medlidsammast" "medlidsammaste" ; -- medlidsam..av.1
  medlidsamhet_1_N = mkN "medlidsamhet" ; -- medlidsamhet..nn.1
  medling_1_N = mkN "medling" ; -- medling..nn.1
  medlingsförslag_1_N = mkN "medlingsförslag" neutrum  ; -- medlingsförslag..nn.1
  medlingsförsök_1_N = mkN "medlingsförsök" neutrum  ; -- medlingsförsök..nn.1
  medlingskommission_1_N = mkN "medlingskommission" ; -- medlingskommission..nn.1
  medlingsuppdrag_1_N = mkN "medlingsuppdrag" neutrum  ; -- medlingsuppdrag..nn.1
  medljud_1_N = mkN "medljud" neutrum  ; -- medljud..nn.1
  medlut_1_N = mkN "medlut" neutrum  ; -- medlut..nn.1
  medlöftesman_1_N = mkN "medlöftesman" "medlöftesmannen" "medlöftesmän" "medlöftesmännen" ; -- medlöftesman..nn.1
  medlöpare_1_N = mkN "medlöpare" utrum  ; -- medlöpare..nn.1
  medlöperi_1_N = mkN "medlöperi" neutrum  ; -- medlöperi..nn.1
  medmänniska_1_N = mkN "medmänniska" ; -- medmänniska..nn.1
  medmänsklig_1_A = mkA "medmänsklig" ; -- medmänsklig..av.1
  medmänsklighet_1_N = mkN "medmänsklighet" ; -- medmänsklighet..nn.1
  medpassagerare_1_N = mkN "medpassagerare" utrum  ; -- medpassagerare..nn.1
  medregent_1_N = mkN "medregent" "medregenter" ; -- medregent..nn.1
  medresenär_1_N = mkN "medresenär" "medresenärer" ; -- medresenär..nn.1
  medryckande_1_A = mkA "medryckande" ; -- medryckande..av.1
  medräknad_1_A = mkA "medräknad" ; -- medräknad..av.1
  medskyldig_1_A = mkA "medskyldig" ; -- medskyldig..av.1
  medskyldighet_1_N = mkN "medskyldighet" ; -- medskyldighet..nn.1
  medspelare_1_N = mkN "medspelare" utrum  ; -- medspelare..nn.1
  medström_1_N = mkN "medström" "medströmmen" "medströmmar" "medströmmarna" ; -- medström..nn.1
  medsyster_1_N = mkN "medsyster" ; -- medsyster..nn.1
  medsändning_1_N = mkN "medsändning" ; -- medsändning..nn.1
  medsökande_1_N = mkN "medsökande" "medsökanden" "medsökanden" "medsökandena" ; -- medsökande..nn.1
  medta_1_V = mkV "medtaga" "medtog" "medtagit" ; -- medta..vb.1
  medtagande_1_N = mkN "medtagande" ; -- medtagande..nn.1
  medtagen_1_A = mkA "medtagen" ; -- medtagen..av.1
  medtagenhet_1_N = mkN "medtagenhet" ; -- medtagenhet..nn.1
  medtrafikant_1_N = mkN "medtrafikant" "medtrafikanter" ; -- medtrafikant..nn.1
  medtävlande_1_N = mkN "medtävlande" "medtävlanden" "medtävlanden" "medtävlandena" ; -- medtävlande..nn.1
  medtävlare_1_N = mkN "medtävlare" utrum  ; -- medtävlare..nn.1
  medusa_1_N = mkN "medusa" ; -- medusa..nn.1
  medverka_1_V = mkV "medverkar" ; -- medverka..vb.1
  medverkande_1_A = mkA "medverkande" ; -- medverkande..av.1
  medverkande_1_N = mkN "medverkande" ; -- medverkande..nn.1
  medvetande_1_N = mkN "medvetande" ; -- medvetande..nn.1
  medvetandegöra_1_V = mkV "medvetandegöra" "medvetandegjorde" "medvetandegjort" ; -- medvetandegöra..vb.1
  medvetandegörande_1_N = mkN "medvetandegörande" ; -- medvetandegörande..nn.1
  medvetandegöring_1_N = mkN "medvetandegöring" ; -- medvetandegöring..nn.1
  medvetandehöjande_1_A = mkA "medvetandehöjande" ; -- medvetandehöjande..av.1
  medvetandenivå_1_N = mkN "medvetandenivå" "medvetandenivåer" ; -- medvetandenivå..nn.1
  medvetandeström_1_N = mkN "medvetandeström" "medvetandeströmmen" "medvetandeströmmar" "medvetandeströmmarna" ; -- medvetandeström..nn.1
  medveten_1_A = mkA "medveten" ; -- medveten..av.1
  medvetenhet_1_N = mkN "medvetenhet" "medvetenheter" ; -- medvetenhet..nn.1
  medvetslös_1_A = mkA "medvetslös" ; -- medvetslös..av.1
  medvetslöshet_1_N = mkN "medvetslöshet" ; -- medvetslöshet..nn.1
  medvind_1_N = mkN "medvind" ; -- medvind..nn.1
  medvurst_1_N = mkN "medvurst" ; -- medvurst..nn.1
  medåtalad_1_A = mkA "medåtalad" ; -- medåtalad..av.1
  medövning_1_N = mkN "medövning" ; -- medövning..nn.1
  mefa_1_N = mkN "mefa" ; -- mefa..nn.1
  mefistofelisk_1_A = mkA "mefistofelisk" ; -- mefistofelisk..av.1
  mefitisk_1_A = mkA "mefitisk" ; -- mefitisk..av.1
  megabyte_1_N = mkN "megabyte" "megabyten" "megabyte" "megabytena" ; -- megabyte..nn.1
  megafon_1_N = mkN "megafon" "megafoner" ; -- megafon..nn.1
  megajoule_1_N = mkN "megajoule" "megajoulen" "megajoule" "megajoulena" ; -- megajoule..nn.1
  megakollision_1_N = mkN "megakollision" ; -- megakollision..nn.1
  megalit_1_N = mkN "megalit" "megaliter" ; -- megalit..nn.1
  megaloman_1_N = mkN "megaloman" "megalomaner" ; -- megaloman..nn.1
  megalomani_1_N = mkN "megalomani" ; -- megalomani..nn.1
  meganewton_1_N = mkN "meganewton" "meganewtonen" "meganewton" "meganewtonen" ; -- meganewton..nn.1
  megaskräll_1_N = mkN "megaskräll" ; -- megaskräll..nn.1
  megaskuld_1_N = mkN "megaskuld" "megaskulder" ; -- megaskuld..nn.1
  megaton_1_N = mkN "megaton" "megatonnet" "megaton" "megatonnen" ; -- megaton..nn.1
  megawatt_1_N = mkN "megawatt" "megawatten" "megawatt" "megawatten" ; -- megawatt..nn.1
  megära_1_N = mkN "megära" ; -- megära..nn.1
  meios_1_N = mkN "meios" "meioser" ; -- meios..nn.1
  meja_1_V = mkV "mejar" ; -- meja..vb.1
  mejande_1_N = mkN "mejande" ; -- mejande..nn.1
  mejare_1_N = mkN "mejare" utrum  ; -- mejare..nn.1
  mejeri_1_N = mkN "mejeri" "mejeriet" "mejerier" "mejerierna" ; -- mejeri..nn.1
  mejerifabrik_1_N = mkN "mejerifabrik" "mejerifabriker" ; -- mejerifabrik..nn.1
  mejeriförening_1_N = mkN "mejeriförening" ; -- mejeriförening..nn.1
  mejerist_1_N = mkN "mejerist" "mejerister" ; -- mejerist..nn.1
  mejl_1_N = mkN "mejl" ; -- mejl..nn.1
  mejl_2_N = mkN "mejl" neutrum  ; -- mejl..nn.2
  mejla_1_V = mkV "mejlar" ; -- mejla..vb.1
  mejlande_1_N = mkN "mejlande" ; -- mejlande..nn.1
  mejlare_1_N = mkN "mejlare" utrum  ; -- mejlare..nn.1
  mejlbomba_1_V = mkV "mejlbombar" ; -- mejlbomba..vb.1
  mejlbombande_1_N = mkN "mejlbombande" ; -- mejlbombande..nn.1
  mejlbox_1_N = mkN "mejlbox" ; -- mejlbox..nn.1
  mejlhot_1_N = mkN "mejlhot" neutrum  ; -- mejlhot..nn.1
  mejlintervju_1_N = mkN "mejlintervju" "mejlintervjun" "mejlintervjuer" "mejlintervjuerna" ; -- mejlintervju..nn.1
  mejlintrång_1_N = mkN "mejlintrång" neutrum  ; -- mejlintrång..nn.1
  mejlledes_1_Adv = mkAdv "mejlledes" ; -- mejlledes..ab.1
  mejram_1_N = mkN "mejram" ; -- mejram..nn.1
  mejsel_1_N = mkN "mejsel" ; -- mejsel..nn.1
  mejsla_1_V = mkV "mejslar" ; -- mejsla..vb.1
  mejslande_1_N = mkN "mejslande" ; -- mejslande..nn.1
  meka_1_V = mkV "mekar" ; -- meka..vb.1
  mekande_1_N = mkN "mekande" ; -- mekande..nn.1
  mekanik_1_N = mkN "mekanik" ; -- mekanik..nn.1
  mekaniker_1_N = mkN "mekaniker" "mekanikern" "mekaniker" "mekanikerna" ; -- mekaniker..nn.1
  mekanikus_1_N = mkN "mekanikus" "mekanikusen" "mekanici" "mekanicina" ; -- mekanikus..nn.1
  mekanisera_1_V = mkV "mekaniserar" ; -- mekanisera..vb.1
  mekaniserande_1_N = mkN "mekaniserande" ; -- mekaniserande..nn.1
  mekaniserbar_1_A = mkA "mekaniserbar" ; -- mekaniserbar..av.1
  mekaniserbarhet_1_N = mkN "mekaniserbarhet" ; -- mekaniserbarhet..nn.1
  mekanisering_1_N = mkN "mekanisering" ; -- mekanisering..nn.1
  mekanisk_1_A = mkA "mekanisk" ; -- mekanisk..av.1
  mekanism_1_N = mkN "mekanism" "mekanismer" ; -- mekanism..nn.1
  mekanistisk_1_A = mkA "mekanistisk" ; -- mekanistisk..av.1
  mekvänlig_1_A = mkA "mekvänlig" ; -- mekvänlig..av.1
  mekvänlighet_1_N = mkN "mekvänlighet" ; -- mekvänlighet..nn.1
  melanesier_1_N = mkN "melanesier" "melanesiern" "melanesier" "melanesierna" ; -- melanesier..nn.1
  melanesisk_1_A = mkA "melanesisk" ; -- melanesisk..av.1
  melanesiska_1_N = mkN "melanesiska" ; -- melanesiska..nn.1
  melanin_1_N = mkN "melanin" "melaniner" ; -- melanin..nn.1
  melankoli_1_N = mkN "melankoli" ; -- melankoli..nn.1
  melankoliker_1_N = mkN "melankoliker" "melankolikern" "melankoliker" "melankolikerna" ; -- melankoliker..nn.1
  melankolisk_1_A = mkA "melankolisk" ; -- melankolisk..av.1
  melanom_1_N = mkN "melanom" neutrum  ; -- melanom..nn.1
  melass_1_N = mkN "melass" ; -- melass..nn.1
  melatonin_1_N = mkN "melatonin" "melatoniner" ; -- melatonin..nn.1
  melatoninnivå_1_N = mkN "melatoninnivå" "melatoninnivåer" ; -- melatoninnivå..nn.1
  melatoninproduktion_1_N = mkN "melatoninproduktion" ; -- melatoninproduktion..nn.1
  melerad_1_A = mkA "melerad" ; -- melerad..av.1
  melinit_1_N = mkN "melinit" ; -- melinit..nn.1
  melioration_1_N = mkN "melioration" ; -- melioration..nn.1
  melitta_1_N = mkN "melitta" ; -- melitta..nn.1
  melittafilter_1_N = mkN "melittafilter" neutrum  ; -- melittafilter..nn.1
  mellanakt_1_N = mkN "mellanakt" "mellanakter" ; -- mellanakt..nn.1
  mellanblå_1_A = mkA "mellanblå" "mellanblått" ; -- mellanblå..av.1
  mellanbok_1_N = mkN "mellanbok" "mellanböcker" ; -- mellanbok..nn.1
  mellanbror_1_N = mkN "mellanbror" "mellanbröder" ; -- mellanbror..nn.1
  mellanchef_1_N = mkN "mellanchef" "mellanchefer" ; -- mellanchef..nn.1
  mellandag_1_N = mkN "mellandag" ; -- mellandag..nn.1
  mellandel_1_N = mkN "mellandel" "mellandelen" "mellandelar" "mellandelarna" ; -- mellandel..nn.1
  mellandäck_1_N = mkN "mellandäck" neutrum  ; -- mellandäck..nn.1
  mellaneuropeisk_1_A = mkA "mellaneuropeisk" ; -- mellaneuropeisk..av.1
  mellanfolklig_1_A = mkA "mellanfolklig" ; -- mellanfolklig..av.1
  mellanform_1_N = mkN "mellanform" "mellanformer" ; -- mellanform..nn.1
  mellanguld_1_N = mkN "mellanguld" neutrum  ; -- mellanguld..nn.1
  mellangärde_1_N = mkN "mellangärde" ; -- mellangärde..nn.1
  mellanhand_1_N = mkN "mellanhand" "mellanhänder" ; -- mellanhand..nn.1
  mellanhavande_1_N = mkN "mellanhavande" ; -- mellanhavande..nn.1
  mellanheat_1_N = mkN "mellanheat" neutrum  ; -- mellanheat..nn.1
  mellanhjärna_1_N = mkN "mellanhjärna" ; -- mellanhjärna..nn.1
  mellanhopp_1_N = mkN "mellanhopp" neutrum  ; -- mellanhopp..nn.1
  mellankalv_1_N = mkN "mellankalv" ; -- mellankalv..nn.1
  mellankommande_1_A = mkA "mellankommande" ; -- mellankommande..av.1
  mellankommunal_1_A = mkA "mellankommunal" ; -- mellankommunal..av.1
  mellankomst_1_N = mkN "mellankomst" ; -- mellankomst..nn.1
  mellankrigstid_1_N = mkN "mellankrigstid" "mellankrigstider" ; -- mellankrigstid..nn.1
  mellankropp_1_N = mkN "mellankropp" ; -- mellankropp..nn.1
  mellankultur_1_N = mkN "mellankultur" "mellankulturer" ; -- mellankultur..nn.1
  mellanlanda_1_V = mkV "mellanlandar" ; -- mellanlanda..vb.1
  mellanlandande_1_N = mkN "mellanlandande" ; -- mellanlandande..nn.1
  mellanlandning_1_N = mkN "mellanlandning" ; -- mellanlandning..nn.1
  mellanled_1_N = mkN "mellanled" neutrum  ; -- mellanled..nn.1
  mellanliggande_1_A = mkA "mellanliggande" ; -- mellanliggande..av.1
  mellanläge_1_N = mkN "mellanläge" ; -- mellanläge..nn.1
  mellanlägg_1_N = mkN "mellanlägg" neutrum  ; -- mellanlägg..nn.1
  mellanmänsklig_1_A = mkA "mellanmänsklig" ; -- mellanmänsklig..av.1
  mellanmänsklighet_1_N = mkN "mellanmänsklighet" ; -- mellanmänsklighet..nn.1
  mellanmål_1_N = mkN "mellanmål" neutrum  ; -- mellanmål..nn.1
  mellanmålstips_1_N = mkN "mellanmålstips" neutrum  ; -- mellanmålstips..nn.1
  mellanparti_1_N = mkN "mellanparti" "mellanpartiet" "mellanpartier" "mellanpartierna" ; -- mellanparti..nn.1
  mellanregister_1_N = mkN "mellanregister" neutrum  ; -- mellanregister..nn.1
  mellanrev_1_N = mkN "mellanrev" neutrum  ; -- mellanrev..nn.1
  mellanriksbana_1_N = mkN "mellanriksbana" ; -- mellanriksbana..nn.1
  mellanriksväg_1_N = mkN "mellanriksväg" ; -- mellanriksväg..nn.1
  mellanrum_1_N = mkN "mellanrum" "mellanrummet" "mellanrum" "mellanrummen" ; -- mellanrum..nn.1
  mellanrumsförening_1_N = mkN "mellanrumsförening" ; -- mellanrumsförening..nn.1
  mellanrätt_1_N = mkN "mellanrätt" "mellanrätter" ; -- mellanrätt..nn.1
  mellanskikt_1_N = mkN "mellanskikt" neutrum  ; -- mellanskikt..nn.1
  mellanskillnad_1_N = mkN "mellanskillnad" "mellanskillnader" ; -- mellanskillnad..nn.1
  mellanskola_1_N = mkN "mellanskola" ; -- mellanskola..nn.1
  mellanslag_1_N = mkN "mellanslag" neutrum  ; -- mellanslag..nn.1
  mellanspel_1_N = mkN "mellanspel" "mellanspelet" "mellanspel" "mellanspelen" ; -- mellanspel..nn.1
  mellanspett_1_N = mkN "mellanspett" ; -- mellanspett..nn.1
  mellanstadielärare_1_N = mkN "mellanstadielärare" utrum  ; -- mellanstadielärare..nn.1
  mellanstadium_1_N = mkN "mellanstadium" "mellanstadiet" "mellanstadier" "mellanstadierna" ; -- mellanstadium..nn.1
  mellanstatlig_1_A = mkA "mellanstatlig" ; -- mellanstatlig..av.1
  mellanstick_1_N = mkN "mellanstick" neutrum  ; -- mellanstick..nn.1
  mellanstor_1_A = mkA "mellanstor" ; -- mellanstor..av.1
  mellanströmbrytare_1_N = mkN "mellanströmbrytare" utrum  ; -- mellanströmbrytare..nn.1
  mellansubstans_1_N = mkN "mellansubstans" "mellansubstanser" ; -- mellansubstans..nn.1
  mellansvensk_1_A = mkA "mellansvensk" ; -- mellansvensk..av.1
  mellantid_1_N = mkN "mellantid" "mellantider" ; -- mellantid..nn.1
  mellanting_1_N = mkN "mellanting" neutrum  ; -- mellanting..nn.1
  mellanverk_1_N = mkN "mellanverk" neutrum  ; -- mellanverk..nn.1
  mellanvikt_1_N = mkN "mellanvikt" ; -- mellanvikt..nn.1
  mellanväg_1_N = mkN "mellanväg" ; -- mellanväg..nn.1
  mellanvägg_1_N = mkN "mellanvägg" ; -- mellanvägg..nn.1
  mellanvärd_1_N = mkN "mellanvärd" ; -- mellanvärd..nn.1
  mellanvåg_1_N = mkN "mellanvåg" "mellanvågor" ; -- mellanvåg..nn.1
  mellanvåning_1_N = mkN "mellanvåning" ; -- mellanvåning..nn.1
  mellanöl_1_N = mkN "mellanöl" neutrum  ; -- mellanöl..nn.1
  mellanöra_1_N = mkN "mellanöra" "mellanörat" "mellanöron" "mellanöronen" ; -- mellanöra..nn.1
  mellerst_1_Adv = mkAdv "mellerst" ; -- mellerst..ab.1
  mellis_1_N = mkN "mellis" ; -- mellis..nn.1
  mellis_2_N = mkN "mellis" ; -- mellis..nn.2
  mello_1_N = mkN "mello" ; -- mello..nn.1
  melodi_1_N = mkN "melodi" "melodier" ; -- melodi..nn.1
  melodifestival_1_N = mkN "melodifestival" ; -- melodifestival..nn.1
  melodifras_1_N = mkN "melodifras" "melodifraser" ; -- melodifras..nn.1
  melodik_1_N = mkN "melodik" ; -- melodik..nn.1
  melodiradio_1_N = mkN "melodiradio" ; -- melodiradio..nn.1
  melodirik_1_A = mkA "melodirik" ; -- melodirik..av.1
  melodisk_1_A = mkA "melodisk" ; -- melodisk..av.1
  melodislinga_1_N = mkN "melodislinga" ; -- melodislinga..nn.1
  melodisnutt_1_N = mkN "melodisnutt" ; -- melodisnutt..nn.1
  melodistämma_1_N = mkN "melodistämma" ; -- melodistämma..nn.1
  melodiös_1_A = mkA "melodiös" ; -- melodiös..av.1
  melodram_1_N = mkN "melodram" "melodramer" ; -- melodram..nn.1
  melodrama_1_N = mkN "melodrama" "melodramat" "melodraman" "melodramana" ; -- melodrama..nn.1
  melodramatisk_1_A = mkA "melodramatisk" ; -- melodramatisk..av.1
  melon_1_N = mkN "melon" "meloner" ; -- melon..nn.1
  melonäpple_1_N = mkN "melonäpple" ; -- melonäpple..nn.1
  mem_1_N = mkN "mem" "memer" ; -- mem..nn.1
  membran_1_N = mkN "membran" neutrum  ; -- membran..nn.1
  membranskada_1_N = mkN "membranskada" ; -- membranskada..nn.1
  membrum_1_N = mkN "membrum" neutrum  ; -- membrum..nn.1
  memento_1_N = mkN "memento" "mementot" "mementon" "mementona" ; -- memento..nn.1
  memetik_1_N = mkN "memetik" ; -- memetik..nn.1
  memoar_1_N = mkN "memoar" "memoarer" ; -- memoar..nn.1
  memoarbok_1_N = mkN "memoarbok" "memoarböcker" ; -- memoarbok..nn.1
  memoarförfattare_1_N = mkN "memoarförfattare" utrum  ; -- memoarförfattare..nn.1
  memorandum_1_N = mkN "memorandum" "memorandumet" "memoranda" "memorandana" ; -- memorandum..nn.1
  memorera_1_V = mkV "memorerar" ; -- memorera..vb.1
  memorerande_1_N = mkN "memorerande" ; -- memorerande..nn.1
  memorerbar_1_A = mkA "memorerbar" ; -- memorerbar..av.1
  memorerbarhet_1_N = mkN "memorerbarhet" ; -- memorerbarhet..nn.1
  memorering_1_N = mkN "memorering" ; -- memorering..nn.1
  memorial_1_N = mkN "memorial" "memorialer" ; -- memorial..nn.1
  memorial_2_N = mkN "memorial" neutrum  ; -- memorial..nn.2
  men_1_N = mkN "men" neutrum  ; -- men..nn.1
  men_2_N = mkN "men" neutrum  ; -- men..nn.2
  mena_1_V = mkV "menar" ; -- mena..vb.1
  menageri_1_N = mkN "menageri" "menageriet" "menagerier" "menagerierna" ; -- menageri..nn.1
  menande_1_A = mkA "menande" ; -- menande..av.1
  menande_1_N = mkN "menande" ; -- menande..nn.1
  mendelevium_1_N = mkN "mendelevium" neutrum  ; -- mendelevium..nn.1
  mendelism_1_N = mkN "mendelism" "mendelismer" ; -- mendelism..nn.1
  mendelistisk_1_A = mkA "mendelistisk" ; -- mendelistisk..av.1
  mendelsk_1_A = mkA "mendelsk" ; -- mendelsk..av.1
  mened_1_N = mkN "mened" "meneder" ; -- mened..nn.1
  menedare_1_N = mkN "menedare" utrum  ; -- menedare..nn.1
  menföre_1_N = mkN "menföre" ; -- menföre..nn.1
  menig_1_A = mkA "menig" ; -- menig..av.1
  menighet_1_N = mkN "menighet" "menigheter" ; -- menighet..nn.1
  mening_1_N = mkN "mening" ; -- mening..nn.1
  meningit_1_N = mkN "meningit" ; -- meningit..nn.1
  meningsbrytning_1_N = mkN "meningsbrytning" ; -- meningsbrytning..nn.1
  meningsbyggnad_1_N = mkN "meningsbyggnad" "meningsbyggnader" ; -- meningsbyggnad..nn.1
  meningsbyte_1_N = mkN "meningsbyte" ; -- meningsbyte..nn.1
  meningsfrände_1_N = mkN "meningsfrände" "meningsfränder" ; -- meningsfrände..nn.1
  meningsfull_1_A = mkA "meningsfull" ; -- meningsfull..av.1
  meningsfullhet_1_N = mkN "meningsfullhet" ; -- meningsfullhet..nn.1
  meningsfylld_1_A = mkA "meningsfylld" "meningsfyllt" ; -- meningsfylld..av.1
  meningsfylldhet_1_N = mkN "meningsfylldhet" ; -- meningsfylldhet..nn.1
  meningslös_1_A = mkA "meningslös" ; -- meningslös..av.1
  meningslöshet_1_N = mkN "meningslöshet" "meningslösheter" ; -- meningslöshet..nn.1
  meningsmotståndare_1_N = mkN "meningsmotståndare" utrum  ; -- meningsmotståndare..nn.1
  meningsmotsättning_1_N = mkN "meningsmotsättning" ; -- meningsmotsättning..nn.1
  meningsriktning_1_N = mkN "meningsriktning" ; -- meningsriktning..nn.1
  meningsskapande_1_A = mkA "meningsskapande" ; -- meningsskapande..av.1
  meningsskiljaktighet_1_N = mkN "meningsskiljaktighet" "meningsskiljaktigheter" ; -- meningsskiljaktighet..nn.1
  meningsstrid_1_N = mkN "meningsstrid" "meningsstrider" ; -- meningsstrid..nn.1
  meningsutbyte_1_N = mkN "meningsutbyte" ; -- meningsutbyte..nn.1
  meningsyttring_1_N = mkN "meningsyttring" ; -- meningsyttring..nn.1
  menisk_1_N = mkN "menisk" "menisker" ; -- menisk..nn.1
  menlig_1_A = mkA "menlig" ; -- menlig..av.1
  menlighet_1_N = mkN "menlighet" ; -- menlighet..nn.1
  menlös_1_A = mkA "menlös" ; -- menlös..av.1
  menlöshet_1_N = mkN "menlöshet" "menlösheter" ; -- menlöshet..nn.1
  mennonit_1_N = mkN "mennonit" "mennoniter" ; -- mennonit..nn.1
  menopaus_1_N = mkN "menopaus" "menopauser" ; -- menopaus..nn.1
  mens_1_N = mkN "mens" ; -- mens..nn.1
  mensa_1_V = mkV "mensar" ; -- mensa..vb.1
  mensande_1_N = mkN "mensande" ; -- mensande..nn.1
  mensrubbning_1_N = mkN "mensrubbning" ; -- mensrubbning..nn.1
  mensskydd_1_N = mkN "mensskydd" neutrum  ; -- mensskydd..nn.1
  mensstörning_1_N = mkN "mensstörning" ; -- mensstörning..nn.1
  menstruation_1_N = mkN "menstruation" ; -- menstruation..nn.1
  menstruationscykel_1_N = mkN "menstruationscykel" ; -- menstruationscykel..nn.1
  menstruationsrubbning_1_N = mkN "menstruationsrubbning" ; -- menstruationsrubbning..nn.1
  menstruationsstörning_1_N = mkN "menstruationsstörning" ; -- menstruationsstörning..nn.1
  menstruera_1_V = mkV "menstruerar" ; -- menstruera..vb.1
  menstruerande_1_N = mkN "menstruerande" ; -- menstruerande..nn.1
  menstruering_1_N = mkN "menstruering" ; -- menstruering..nn.1
  mensur_1_N = mkN "mensur" "mensurer" ; -- mensur..nn.1
  mensvärk_1_N = mkN "mensvärk" ; -- mensvärk..nn.1
  mental_1_A = mkA "mental" ; -- mental..av.1
  mentalism_1_N = mkN "mentalism" "mentalismer" ; -- mentalism..nn.1
  mentalistisk_1_A = mkA "mentalistisk" ; -- mentalistisk..av.1
  mentalitet_1_N = mkN "mentalitet" "mentaliteter" ; -- mentalitet..nn.1
  mentalklinik_1_N = mkN "mentalklinik" "mentalkliniker" ; -- mentalklinik..nn.1
  mentalsjuk_1_A = mkA "mentalsjuk" ; -- mentalsjuk..av.1
  mentalsjukdom_1_N = mkN "mentalsjukdom" ; -- mentalsjukdom..nn.1
  mentalsjukhet_1_N = mkN "mentalsjukhet" ; -- mentalsjukhet..nn.1
  mentalsjukhus_1_N = mkN "mentalsjukhus" neutrum  ; -- mentalsjukhus..nn.1
  mentalvård_1_N = mkN "mentalvård" ; -- mentalvård..nn.1
  mentalvårdsinrättning_1_N = mkN "mentalvårdsinrättning" ; -- mentalvårdsinrättning..nn.1
  mentol_1_N = mkN "mentol" ; -- mentol..nn.1
  mentometer_1_N = mkN "mentometer" ; -- mentometer..nn.1
  mentor_1_N = mkN "mentor" "mentorer" ; -- mentor..nn.1
  menuett_1_N = mkN "menuett" "menuetter" ; -- menuett..nn.1
  meny_1_N = mkN "meny" "menyer" ; -- meny..nn.1
  menyförslag_1_N = mkN "menyförslag" neutrum  ; -- menyförslag..nn.1
  mer_1_Adv = mkAdv "mer" ; -- mer..ab.1
  mera_1_Adv = mkAdv "mera" ; -- mera..ab.1
  merarbete_1_N = mkN "merarbete" ; -- merarbete..nn.1
  merbemäld_1_A = mkA "merbemäld" "merbemält" ; -- merbemäld..av.1
  merca_1_N = mkN "merca" ; -- merca..nn.1
  mercedes_1_N = mkN "mercedes" ; -- mercedes..nn.1
  mercerisera_1_V = mkV "merceriserar" ; -- mercerisera..vb.1
  merceriserande_1_N = mkN "merceriserande" ; -- merceriserande..nn.1
  merceriserbar_1_A = mkA "merceriserbar" ; -- merceriserbar..av.1
  merceriserbarhet_1_N = mkN "merceriserbarhet" ; -- merceriserbarhet..nn.1
  mercerisering_1_N = mkN "mercerisering" ; -- mercerisering..nn.1
  meridian_1_N = mkN "meridian" "meridianer" ; -- meridian..nn.1
  meridiancirkel_1_N = mkN "meridiancirkel" ; -- meridiancirkel..nn.1
  meridianhöjd_1_N = mkN "meridianhöjd" "meridianhöjder" ; -- meridianhöjd..nn.1
  merinofår_1_N = mkN "merinofår" neutrum  ; -- merinofår..nn.1
  merit_1_N = mkN "merit" "meriter" ; -- merit..nn.1
  meritera_1_V = mkV "meriterar" ; -- meritera..vb.1
  meriterad_1_A = mkA "meriterad" ; -- meriterad..av.1
  meriterande_1_N = mkN "meriterande" ; -- meriterande..nn.1
  meriterbar_1_A = mkA "meriterbar" ; -- meriterbar..av.1
  meriterbarhet_1_N = mkN "meriterbarhet" ; -- meriterbarhet..nn.1
  meritering_1_N = mkN "meritering" ; -- meritering..nn.1
  meritförteckning_1_N = mkN "meritförteckning" ; -- meritförteckning..nn.1
  meritlista_1_N = mkN "meritlista" ; -- meritlista..nn.1
  meritmässig_1_A = mkA "meritmässig" ; -- meritmässig..av.1
  meritokrati_1_N = mkN "meritokrati" ; -- meritokrati..nn.1
  merkantil_1_A = mkA "merkantil" ; -- merkantil..av.1
  merkantilism_1_N = mkN "merkantilism" "merkantilismer" ; -- merkantilism..nn.1
  merkantilist_1_N = mkN "merkantilist" "merkantilister" ; -- merkantilist..nn.1
  merkantilistisk_1_A = mkA "merkantilistisk" ; -- merkantilistisk..av.1
  merkantilsystem_1_N = mkN "merkantilsystem" neutrum  ; -- merkantilsystem..nn.1
  merkaptan_1_N = mkN "merkaptan" "merkaptaner" ; -- merkaptan..nn.1
  merkostnad_1_N = mkN "merkostnad" "merkostnader" ; -- merkostnad..nn.1
  meronym_1_N = mkN "meronym" "meronymer" ; -- meronym..nn.1
  meronymi_1_N = mkN "meronymi" "meronymier" ; -- meronymi..nn.1
  merpart_1_N = mkN "merpart" ; -- merpart..nn.1
  mersa_1_N = mkN "mersa" ; -- mersa..nn.1
  mersmak_1_N = mkN "mersmak" ; -- mersmak..nn.1
  mervärde_1_N = mkN "mervärde" ; -- mervärde..nn.1
  mervärdesskatt_1_N = mkN "mervärdesskatt" "mervärdesskatter" ; -- mervärdesskatt..nn.1
  mes_1_N = mkN "mes" ; -- mes..nn.1
  mesaktig_1_A = mkA "mesaktig" ; -- mesaktig..av.1
  mesaktighet_1_N = mkN "mesaktighet" ; -- mesaktighet..nn.1
  mesallians_1_N = mkN "mesallians" "mesallianser" ; -- mesallians..nn.1
  mesan_1_N = mkN "mesan" "mesaner" ; -- mesan..nn.1
  mesanmast_1_N = mkN "mesanmast" "mesanmaster" ; -- mesanmast..nn.1
  mesfågel_1_N = mkN "mesfågel" ; -- mesfågel..nn.1
  mesig_1_A = mkA "mesig" ; -- mesig..av.1
  mesighet_1_N = mkN "mesighet" ; -- mesighet..nn.1
  meskalin_1_N = mkN "meskalin" "meskaliner" ; -- meskalin..nn.1
  mesoarkeikum_1_N = mkN "mesoarkeikum" ; -- mesoarkeikum..nn.1
  mesolitisk_1_A = mkA "mesolitisk" ; -- mesolitisk..av.1
  mesolitium_1_N = mkN "mesolitium" ; -- mesolitium..nn.1
  meson_1_N = mkN "meson" "mesoner" ; -- meson..nn.1
  mesopotam_1_N = mkN "mesopotam" "mesopotamer" ; -- mesopotam..nn.1
  mesopotamisk_1_A = mkA "mesopotamisk" ; -- mesopotamisk..av.1
  mesopotamiska_1_N = mkN "mesopotamiska" ; -- mesopotamiska..nn.1
  mesoproterozoikum_1_N = mkN "mesoproterozoikum" ; -- mesoproterozoikum..nn.1
  mesost_1_N = mkN "mesost" ; -- mesost..nn.1
  mesozoikum_1_N = mkN "mesozoikum" ; -- mesozoikum..nn.1
  mesozoisk_1_A = mkA "mesozoisk" ; -- mesozoisk..av.1
  mess_1_N = mkN "mess" neutrum  ; -- mess..nn.1
  messa_1_V = mkV "messar" ; -- messa..vb.1
  messande_1_N = mkN "messande" ; -- messande..nn.1
  messerschmitter_1_N = mkN "messerschmitter" ; -- messerschmitter..nn.1
  messersmitter_1_N = mkN "messersmitter" ; -- messersmitter..nn.1
  messiansk_1_A = mkA "messiansk" ; -- messiansk..av.1
  messiasrike_1_N = mkN "messiasrike" ; -- messiasrike..nn.1
  messmör_1_N = mkN "messmör" neutrum  ; -- messmör..nn.1
  mestadels_1_Adv = mkAdv "mestadels" ; -- mestadels..ab.1
  mestgynnadnation_1_N = mkN "mestgynnadnation" ; -- mestgynnadnation..nn.1
  mestis_1_N = mkN "mestis" "mestiser" ; -- mestis..nn.1
  meta_1_V = mkV "metar" ; -- meta..vb.1
  metabolisk_1_A = mkA "metabolisk" ; -- metabolisk..av.1
  metabolism_1_N = mkN "metabolism" "metabolismer" ; -- metabolism..nn.1
  metacenterhöjd_1_N = mkN "metacenterhöjd" "metacenterhöjder" ; -- metacenterhöjd..nn.1
  metacentrum_1_N = mkN "metacentrum" neutrum  ; -- metacentrum..nn.1
  metadata_1_N = mkN "metadata" "metadatat" "metadata" "metadatana" ; -- metadata..nn.1
  metadon_1_N = mkN "metadon" neutrum  ; -- metadon..nn.1
  metafiber_1_N = mkN "metafiber" "metafibern" "metafibrer" "metafibrerna" ; -- metafiber..nn.1
  metafor_1_N = mkN "metafor" "metaforen" "metaforer" "metaforerna" ; -- metafor..nn.1
  metaforik_1_N = mkN "metaforik" ; -- metaforik..nn.1
  metaforisk_1_A = mkA "metaforisk" ; -- metaforisk..av.1
  metafysik_1_N = mkN "metafysik" ; -- metafysik..nn.1
  metafysiker_1_N = mkN "metafysiker" "metafysikern" "metafysiker" "metafysikerna" ; -- metafysiker..nn.1
  metafysisk_1_A = mkA "metafysisk" ; -- metafysisk..av.1
  metakök_1_N = mkN "metakök" neutrum  ; -- metakök..nn.1
  metall_1_N = mkN "metall" "metaller" ; -- metall..nn.1
  metallarbetare_1_N = mkN "metallarbetare" utrum  ; -- metallarbetare..nn.1
  metallatom_1_N = mkN "metallatom" "metallatomer" ; -- metallatom..nn.1
  metallbad_1_N = mkN "metallbad" neutrum  ; -- metallbad..nn.1
  metallbit_1_N = mkN "metallbit" ; -- metallbit..nn.1
  metallbricka_1_N = mkN "metallbricka" ; -- metallbricka..nn.1
  metallbåge_1_N = mkN "metallbåge" utrum  ; -- metallbåge..nn.1
  metalldel_1_N = mkN "metalldel" "metalldelen" "metalldelar" "metalldelarna" ; -- metalldel..nn.1
  metalldetektor_1_N = mkN "metalldetektor" "metalldetektorer" ; -- metalldetektor..nn.1
  metallfena_1_N = mkN "metallfena" ; -- metallfena..nn.1
  metallfot_1_N = mkN "metallfot" "metallfötter" ; -- metallfot..nn.1
  metallföremål_1_N = mkN "metallföremål" neutrum  ; -- metallföremål..nn.1
  metallförgiftning_1_N = mkN "metallförgiftning" ; -- metallförgiftning..nn.1
  metallgjutning_1_N = mkN "metallgjutning" ; -- metallgjutning..nn.1
  metallglänsande_1_A = mkA "metallglänsande" ; -- metallglänsande..av.1
  metallgolv_1_N = mkN "metallgolv" neutrum  ; -- metallgolv..nn.1
  metallhandel_1_N = mkN "metallhandel" ; -- metallhandel..nn.1
  metallicfärg_1_N = mkN "metallicfärg" "metallicfärger" ; -- metallicfärg..nn.1
  metallindustri_1_N = mkN "metallindustri" "metallindustrier" ; -- metallindustri..nn.1
  metallisera_1_V = mkV "metalliserar" ; -- metallisera..vb.1
  metalliserande_1_N = mkN "metalliserande" ; -- metalliserande..nn.1
  metalliserbar_1_A = mkA "metalliserbar" ; -- metalliserbar..av.1
  metalliserbarhet_1_N = mkN "metalliserbarhet" ; -- metalliserbarhet..nn.1
  metallisering_1_N = mkN "metallisering" ; -- metallisering..nn.1
  metallisk_1_A = mkA "metallisk" ; -- metallisk..av.1
  metallkapmaskin_1_N = mkN "metallkapmaskin" "metallkapmaskiner" ; -- metallkapmaskin..nn.1
  metallklang_1_N = mkN "metallklang" "metallklanger" ; -- metallklang..nn.1
  metallklädd_1_A = mkA "metallklädd" ; -- metallklädd..av.1
  metallkorg_1_N = mkN "metallkorg" ; -- metallkorg..nn.1
  metallkula_1_N = mkN "metallkula" ; -- metallkula..nn.1
  metallmugg_1_N = mkN "metallmugg" ; -- metallmugg..nn.1
  metallografi_1_N = mkN "metallografi" ; -- metallografi..nn.1
  metallografisk_1_A = mkA "metallografisk" ; -- metallografisk..av.1
  metalloid_1_N = mkN "metalloid" "metalloider" ; -- metalloid..nn.1
  metalloxid_1_N = mkN "metalloxid" "metalloxider" ; -- metalloxid..nn.1
  metallpulver_1_N = mkN "metallpulver" neutrum  ; -- metallpulver..nn.1
  metallring_1_N = mkN "metallring" ; -- metallring..nn.1
  metallrusch_1_N = mkN "metallrusch" "metallruscher" ; -- metallrusch..nn.1
  metallslöjd_1_N = mkN "metallslöjd" ; -- metallslöjd..nn.1
  metallsmak_1_N = mkN "metallsmak" ; -- metallsmak..nn.1
  metallspekulant_1_N = mkN "metallspekulant" "metallspekulanter" ; -- metallspekulant..nn.1
  metallspiral_1_N = mkN "metallspiral" "metallspiraler" ; -- metallspiral..nn.1
  metallspån_1_N = mkN "metallspån" neutrum  ; -- metallspån..nn.1
  metallsvarv_1_N = mkN "metallsvarv" ; -- metallsvarv..nn.1
  metallsåg_1_N = mkN "metallsåg" ; -- metallsåg..nn.1
  metalltråd_1_N = mkN "metalltråd" ; -- metalltråd..nn.1
  metallurg_1_N = mkN "metallurg" "metallurger" ; -- metallurg..nn.1
  metallurgi_1_N = mkN "metallurgi" ; -- metallurgi..nn.1
  metallurgisk_1_A = mkA "metallurgisk" ; -- metallurgisk..av.1
  metallvikt_1_N = mkN "metallvikt" "metallvikter" ; -- metallvikt..nn.1
  metallvärde_1_N = mkN "metallvärde" ; -- metallvärde..nn.1
  metamorf_1_A = mkA "metamorf" ; -- metamorf..av.1
  metamorfos_1_N = mkN "metamorfos" "metamorfoser" ; -- metamorfos..nn.1
  metamorfosera_1_V = mkV "metamorfoserar" ; -- metamorfosera..vb.1
  metamorfoserande_1_N = mkN "metamorfoserande" ; -- metamorfoserande..nn.1
  metan_1_N = mkN "metan" "metaner" ; -- metan..nn.1
  metande_1_N = mkN "metande" ; -- metande..nn.1
  metangas_1_N = mkN "metangas" ; -- metangas..nn.1
  metanhydrat_1_N = mkN "metanhydrat" ; -- metanhydrat..nn.1
  metanis_1_N = mkN "metanis" ; -- metanis..nn.1
  metanklatrat_1_N = mkN "metanklatrat" ; -- metanklatrat..nn.1
  metanol_1_N = mkN "metanol" ; -- metanol..nn.1
  metare_1_N = mkN "metare" utrum  ; -- metare..nn.1
  metaspråk_1_N = mkN "metaspråk" neutrum  ; -- metaspråk..nn.1
  metastas_1_N = mkN "metastas" "metastaser" ; -- metastas..nn.1
  metastatisk_1_A = mkA "metastatisk" ; -- metastatisk..av.1
  metatablett_1_N = mkN "metatablett" "metatabletter" ; -- metatablett..nn.1
  metates_1_N = mkN "metates" "metateser" ; -- metates..nn.1
  metazo_1_N = mkN "metazo" "metazon" "metazoer" "metazoerna" ; -- metazo..nn.1
  mete_1_N = mkN "mete" ; -- mete..nn.1
  meteor_1_N = mkN "meteor" "meteoren" "meteorer" "meteorerna" ; -- meteor..nn.1
  meteorartad_1_A = mkA "meteorartad" ; -- meteorartad..av.1
  meteorit_1_N = mkN "meteorit" "meteoriter" ; -- meteorit..nn.1
  meteoritnedslag_1_N = mkN "meteoritnedslag" neutrum  ; -- meteoritnedslag..nn.1
  meteoritsvärm_1_N = mkN "meteoritsvärm" ; -- meteoritsvärm..nn.1
  meteorjärn_1_N = mkN "meteorjärn" neutrum  ; -- meteorjärn..nn.1
  meteorkrater_1_N = mkN "meteorkrater" ; -- meteorkrater..nn.1
  meteorolog_1_N = mkN "meteorolog" "meteorologer" ; -- meteorolog..nn.1
  meteorologi_1_N = mkN "meteorologi" ; -- meteorologi..nn.1
  meteorologisk_1_A = mkA "meteorologisk" ; -- meteorologisk..av.1
  meteorsten_1_N = mkN "meteorsten" "meteorstenen" "meteorstenar" "meteorstenarna" ; -- meteorsten..nn.1
  meteorstoft_1_N = mkN "meteorstoft" neutrum  ; -- meteorstoft..nn.1
  meter_1_N = mkN "meter" ; -- meter..nn.1
  meter_2_N = mkN "meter" ; -- meter..nn.2
  meterhög_1_A = mkA "meterhög" ; -- meterhög..av.1
  meterlikare_1_N = mkN "meterlikare" utrum  ; -- meterlikare..nn.1
  meterlång_1_A = mkA "meterlång" ; -- meterlång..av.1
  metermått_1_N = mkN "metermått" neutrum  ; -- metermått..nn.1
  meterprototyp_1_N = mkN "meterprototyp" "meterprototyper" ; -- meterprototyp..nn.1
  meterstav_1_N = mkN "meterstav" ; -- meterstav..nn.1
  meterstor_1_A = mkA "meterstor" ; -- meterstor..av.1
  metersystem_1_N = mkN "metersystem" neutrum  ; -- metersystem..nn.1
  metertjock_1_A = mkA "metertjock" ; -- metertjock..av.1
  metervara_1_N = mkN "metervara" ; -- metervara..nn.1
  metervis_1_Adv = mkAdv "metervis" ; -- metervis..ab.1
  metkrok_1_N = mkN "metkrok" ; -- metkrok..nn.1
  metmask_1_N = mkN "metmask" ; -- metmask..nn.1
  metod_1_N = mkN "metod" "metoder" ; -- metod..nn.1
  metodik_1_N = mkN "metodik" ; -- metodik..nn.1
  metodiker_1_N = mkN "metodiker" "metodikern" "metodiker" "metodikerna" ; -- metodiker..nn.1
  metodiklektor_1_N = mkN "metodiklektor" "metodiklektorer" ; -- metodiklektor..nn.1
  metodisk_1_A = mkA "metodisk" ; -- metodisk..av.1
  metodism_1_N = mkN "metodism" "metodismer" ; -- metodism..nn.1
  metodist_1_N = mkN "metodist" "metodister" ; -- metodist..nn.1
  metodistisk_1_A = mkA "metodistisk" ; -- metodistisk..av.1
  metodkrav_1_N = mkN "metodkrav" neutrum  ; -- metodkrav..nn.1
  metodlära_1_N = mkN "metodlära" ; -- metodlära..nn.1
  metodmässig_1_A = mkA "metodmässig" ; -- metodmässig..av.1
  metodologi_1_N = mkN "metodologi" "metodologier" ; -- metodologi..nn.1
  metodologisk_1_A = mkA "metodologisk" ; -- metodologisk..av.1
  metodsynpunkt_1_N = mkN "metodsynpunkt" "metodsynpunkter" ; -- metodsynpunkt..nn.1
  metodvetenskap_1_N = mkN "metodvetenskap" "metodvetenskaper" ; -- metodvetenskap..nn.1
  metonymi_1_N = mkN "metonymi" "metonymier" ; -- metonymi..nn.1
  metonymisk_1_A = mkA "metonymisk" ; -- metonymisk..av.1
  metrev_1_N = mkN "metrev" ; -- metrev..nn.1
  metrik_1_N = mkN "metrik" ; -- metrik..nn.1
  metrisk_1_A = mkA "metrisk" ; -- metrisk..av.1
  metro_1_N = mkN "metro" "metror" ; -- metro..nn.1
  metrologi_1_N = mkN "metrologi" ; -- metrologi..nn.1
  metrologisk_1_A = mkA "metrologisk" ; -- metrologisk..av.1
  metronom_1_N = mkN "metronom" "metronomer" ; -- metronom..nn.1
  metropol_1_N = mkN "metropol" "metropoler" ; -- metropol..nn.1
  metropolit_1_N = mkN "metropolit" "metropoliter" ; -- metropolit..nn.1
  metspö_1_N = mkN "metspö" "metspöt" "metspön" "metspöna" ; -- metspö..nn.1
  metvurst_1_N = mkN "metvurst" ; -- metvurst..nn.1
  metyl_1_N = mkN "metyl" ; -- metyl..nn.1
  metylalkohol_1_N = mkN "metylalkohol" ; -- metylalkohol..nn.1
  metylen_1_N = mkN "metylen" neutrum  ; -- metylen..nn.1
  metylenblått_1_N = mkN "metylenblått" ; -- metylenblått..nn.1
  metylering_1_N = mkN "metylering" ; -- metylering..nn.1
  mexikan_1_N = mkN "mexikan" "mexikaner" ; -- mexikan..nn.1
  mexikansk_1_A = mkA "mexikansk" ; -- mexikansk..av.1
  mexikanska_1_N = mkN "mexikanska" ; -- mexikanska..nn.1
  mexitegel_1_N = mkN "mexitegel" neutrum  ; -- mexitegel..nn.1
  mexitegelvilla_1_N = mkN "mexitegelvilla" ; -- mexitegelvilla..nn.1
  meze_1_N = mkN "meze" ; -- meze..nn.1
  mezzanin_1_N = mkN "mezzanin" "mezzaniner" ; -- mezzanin..nn.1
  mezzoforte_1_N = mkN "mezzoforte" ; -- mezzoforte..nn.1
  mezzosopran_1_N = mkN "mezzosopran" "mezzosopraner" ; -- mezzosopran..nn.1
  mezzotint_1_N = mkN "mezzotint" "mezzotinter" ; -- mezzotint..nn.1
  mezzotintgravyr_1_N = mkN "mezzotintgravyr" "mezzotintgravyrer" ; -- mezzotintgravyr..nn.1
  mezzotinto_1_N = mkN "mezzotinto" ; -- mezzotinto..nn.1
  mezzotintogravyr_1_N = mkN "mezzotintogravyr" "mezzotintogravyrer" ; -- mezzotintogravyr..nn.1
  miau_1_N = mkN "miau" "miaut" "miaun" "miauna" ; -- miau..nn.1
  miaua_1_V = mkV "miauar" ; -- miaua..vb.1
  miauande_1_N = mkN "miauande" ; -- miauande..nn.1
  mick_1_N = mkN "mick" ; -- mick..nn.1
  mickel_1_N = mkN "mickel" ; -- mickel..nn.1
  mickelsmässa_1_N = mkN "mickelsmässa" ; -- mickelsmässa..nn.1
  micra_1_V = mkV "micrar" ; -- micra..vb.1
  micrande_1_N = mkN "micrande" ; -- micrande..nn.1
  micro_1_N = mkN "micro" "micror" ; -- micro..nn.1
  microhatt_1_N = mkN "microhatt" ; -- microhatt..nn.1
  microlock_1_N = mkN "microlock" neutrum  ; -- microlock..nn.1
  microvågsugn_1_N = mkN "microvågsugn" ; -- microvågsugn..nn.1
  middag_1_N = mkN "middag" ; -- middag..nn.1
  middagsbjudning_1_N = mkN "middagsbjudning" ; -- middagsbjudning..nn.1
  middagsbord_1_N = mkN "middagsbord" neutrum  ; -- middagsbord..nn.1
  middagsdags_1_N = mkN "middagsdags" ; -- middagsdags..nn.1
  middagsgäst_1_N = mkN "middagsgäst" "middagsgäster" ; -- middagsgäst..nn.1
  middagshöjd_1_N = mkN "middagshöjd" "middagshöjder" ; -- middagshöjd..nn.1
  middagsklänning_1_N = mkN "middagsklänning" ; -- middagsklänning..nn.1
  middagslur_1_N = mkN "middagslur" ; -- middagslur..nn.1
  middagsmat_1_N = mkN "middagsmat" ; -- middagsmat..nn.1
  middagsmål_1_N = mkN "middagsmål" neutrum  ; -- middagsmål..nn.1
  middagsrast_1_N = mkN "middagsrast" "middagsraster" ; -- middagsrast..nn.1
  middagssol_1_N = mkN "middagssol" ; -- middagssol..nn.1
  middagssällskap_1_N = mkN "middagssällskap" neutrum  ; -- middagssällskap..nn.1
  middagstid_1_N = mkN "middagstid" "middagstider" ; -- middagstid..nn.1
  middagstimma_1_N = mkN "middagstimma" ; -- middagstimma..nn.1
  middagstimme_1_N = mkN "middagstimme" utrum  ; -- middagstimme..nn.1
  middagstystnad_1_N = mkN "middagstystnad" "middagstystnader" ; -- middagstystnad..nn.1
  middagsvett_1_N = mkN "middagsvett" neutrum  ; -- middagsvett..nn.1
  middagsätare_1_N = mkN "middagsätare" utrum  ; -- middagsätare..nn.1
  midfastosöndag_1_N = mkN "midfastosöndag" ; -- midfastosöndag..nn.1
  midgetbil_1_N = mkN "midgetbil" ; -- midgetbil..nn.1
  midja_1_N = mkN "midja" ; -- midja..nn.1
  midjeband_1_N = mkN "midjeband" neutrum  ; -- midjeband..nn.1
  midjemått_1_N = mkN "midjemått" neutrum  ; -- midjemått..nn.1
  midjetrakt_1_N = mkN "midjetrakt" "midjetrakter" ; -- midjetrakt..nn.1
  midjevidd_1_N = mkN "midjevidd" "midjevidder" ; -- midjevidd..nn.1
  midnatt_1_N = mkN "midnatt" ; -- midnatt..nn.1
  midnattsblå_1_A = mkA "midnattsblå" "midnattsblått" ; -- midnattsblå..av.1
  midnattssol_1_N = mkN "midnattssol" ; -- midnattssol..nn.1
  midskeppssektion_1_N = mkN "midskeppssektion" ; -- midskeppssektion..nn.1
  midsommar_1_N = mkN "midsommar" "midsommaren" "midsomrar" "midsomrarna" ; -- midsommar..nn.1
  midsommarafton_1_N = mkN "midsommarafton" "midsommaraftonen" "midsommaraftnar" "midsommaraftnarna" ; -- midsommarafton..nn.1
  midsommarblomster_1_N = mkN "midsommarblomster" neutrum  ; -- midsommarblomster..nn.1
  midsommardag_1_N = mkN "midsommardag" ; -- midsommardag..nn.1
  midsommarhelg_1_N = mkN "midsommarhelg" "midsommarhelger" ; -- midsommarhelg..nn.1
  midsommarnatt_1_N = mkN "midsommarnatt" "midsommarnätter" ; -- midsommarnatt..nn.1
  midsommarsol_1_N = mkN "midsommarsol" ; -- midsommarsol..nn.1
  midsommarstång_1_N = mkN "midsommarstång" "midsommarstänger" ; -- midsommarstång..nn.1
  midsommartid_1_N = mkN "midsommartid" "midsommartider" ; -- midsommartid..nn.1
  midvinter_1_N = mkN "midvinter" ; -- midvinter..nn.1
  midvinterblot_1_N = mkN "midvinterblot" neutrum  ; -- midvinterblot..nn.1
  midvinterköld_1_N = mkN "midvinterköld" ; -- midvinterköld..nn.1
  midvinternatt_1_N = mkN "midvinternatt" "midvinternätter" ; -- midvinternatt..nn.1
  miffo_1_N = mkN "miffo" "miffot" "miffon" "miffona" ; -- miffo..nn.1
  migrant_1_N = mkN "migrant" "migranter" ; -- migrant..nn.1
  migrantbåt_1_N = mkN "migrantbåt" ; -- migrantbåt..nn.1
  migration_1_N = mkN "migration" ; -- migration..nn.1
  migrationskommissionär_1_N = mkN "migrationskommissionär" "migrationskommissionärer" ; -- migrationskommissionär..nn.1
  migrationsminister_1_N = mkN "migrationsminister" ; -- migrationsminister..nn.1
  migrationsverk_1_N = mkN "migrationsverk" neutrum  ; -- migrationsverk..nn.1
  migrera_1_V = mkV "migrerar" ; -- migrera..vb.1
  migrerande_1_N = mkN "migrerande" ; -- migrerande..nn.1
  migrering_1_N = mkN "migrering" ; -- migrering..nn.1
  migrän_1_N = mkN "migrän" ; -- migrän..nn.1
  migränattack_1_N = mkN "migränattack" "migränattacker" ; -- migränattack..nn.1
  miko_1_N = mkN "miko" "mikot" "mikon" "mikona" ; -- miko..nn.1
  mikra_1_V = mkV "mikrar" ; -- mikra..vb.1
  mikrande_1_N = mkN "mikrande" ; -- mikrande..nn.1
  mikro_1_N = mkN "mikro" "mikror" ; -- mikro..nn.1
  mikroalg_1_N = mkN "mikroalg" "mikroalger" ; -- mikroalg..nn.1
  mikrob_1_N = mkN "mikrob" "mikrober" ; -- mikrob..nn.1
  mikrobiolog_1_N = mkN "mikrobiolog" "mikrobiologer" ; -- mikrobiolog..nn.1
  mikrobiologi_1_N = mkN "mikrobiologi" ; -- mikrobiologi..nn.1
  mikrobiologisk_1_A = mkA "mikrobiologisk" ; -- mikrobiologisk..av.1
  mikroblogg_1_N = mkN "mikroblogg" ; -- mikroblogg..nn.1
  mikroblogga_1_V = mkV "mikrobloggar" ; -- mikroblogga..vb.1
  mikrobloggande_1_N = mkN "mikrobloggande" ; -- mikrobloggande..nn.1
  mikrobloggare_1_N = mkN "mikrobloggare" utrum  ; -- mikrobloggare..nn.1
  mikrobloggtjänst_1_N = mkN "mikrobloggtjänst" "mikrobloggtjänster" ; -- mikrobloggtjänst..nn.1
  mikrobryggeri_1_N = mkN "mikrobryggeri" "mikrobryggeriet" "mikrobryggerier" "mikrobryggerierna" ; -- mikrobryggeri..nn.1
  mikrodator_1_N = mkN "mikrodator" "mikrodatorer" ; -- mikrodator..nn.1
  mikroelektronik_1_N = mkN "mikroelektronik" ; -- mikroelektronik..nn.1
  mikrofiber_1_N = mkN "mikrofiber" "mikrofibern" "mikrofibrer" "mikrofibrerna" ; -- mikrofiber..nn.1
  mikrofiberduk_1_N = mkN "mikrofiberduk" ; -- mikrofiberduk..nn.1
  mikrofiche_1_N = mkN "mikrofiche" "mikrofichen" "mikrofiche" "mikrofichen" ; -- mikrofiche..nn.1
  mikrofilm_1_N = mkN "mikrofilm" "mikrofilmer" ; -- mikrofilm..nn.1
  mikrofilma_1_V = mkV "mikrofilmar" ; -- mikrofilma..vb.1
  mikrofilmande_1_N = mkN "mikrofilmande" ; -- mikrofilmande..nn.1
  mikroflora_1_N = mkN "mikroflora" ; -- mikroflora..nn.1
  mikrofon_1_N = mkN "mikrofon" "mikrofoner" ; -- mikrofon..nn.1
  mikrofonbom_1_N = mkN "mikrofonbom" "mikrofonbommen" "mikrofonbommar" "mikrofonbommarna" ; -- mikrofonbom..nn.1
  mikrofonteknik_1_N = mkN "mikrofonteknik" "mikrofontekniker" ; -- mikrofonteknik..nn.1
  mikrofoto_1_N = mkN "mikrofoto" "mikrofotot" "mikrofoton" "mikrofotona" ; -- mikrofoto..nn.1
  mikrofotografera_1_V = mkV "mikrofotograferar" ; -- mikrofotografera..vb.1
  mikrofotograferande_1_N = mkN "mikrofotograferande" ; -- mikrofotograferande..nn.1
  mikrofotograferbar_1_A = mkA "mikrofotograferbar" ; -- mikrofotograferbar..av.1
  mikrofotograferbarhet_1_N = mkN "mikrofotograferbarhet" ; -- mikrofotograferbarhet..nn.1
  mikrofotografering_1_N = mkN "mikrofotografering" ; -- mikrofotografering..nn.1
  mikrogram_1_N = mkN "mikrogram" "mikrogrammet" "mikrogram" "mikrogrammen" ; -- mikrogram..nn.1
  mikrohatt_1_N = mkN "mikrohatt" ; -- mikrohatt..nn.1
  mikroklimat_1_N = mkN "mikroklimat" neutrum  ; -- mikroklimat..nn.1
  mikrokort_1_N = mkN "mikrokort" neutrum  ; -- mikrokort..nn.1
  mikrokosmisk_1_A = mkA "mikrokosmisk" ; -- mikrokosmisk..av.1
  mikrokosmos_1_N = mkN "mikrokosmos" neutrum  ; -- mikrokosmos..nn.1
  mikroliv_1_N = mkN "mikroliv" neutrum  ; -- mikroliv..nn.1
  mikrolock_1_N = mkN "mikrolock" neutrum  ; -- mikrolock..nn.1
  mikrometer_1_N = mkN "mikrometer" ; -- mikrometer..nn.1
  mikrometer_2_N = mkN "mikrometer" ; -- mikrometer..nn.2
  mikrometersikte_1_N = mkN "mikrometersikte" ; -- mikrometersikte..nn.1
  mikron_1_N = mkN "mikron" "mikronen" "mikron" "mikronen" ; -- mikron..nn.1
  mikronesier_1_N = mkN "mikronesier" "mikronesiern" "mikronesier" "mikronesierna" ; -- mikronesier..nn.1
  mikronesisk_1_A = mkA "mikronesisk" ; -- mikronesisk..av.1
  mikronesiska_1_N = mkN "mikronesiska" ; -- mikronesiska..nn.1
  mikroneurografi_1_N = mkN "mikroneurografi" ; -- mikroneurografi..nn.1
  mikroorganism_1_N = mkN "mikroorganism" "mikroorganismer" ; -- mikroorganism..nn.1
  mikrosekund_1_N = mkN "mikrosekund" "mikrosekunder" ; -- mikrosekund..nn.1
  mikrosievert_1_N = mkN "mikrosievert" "mikrosieverten" "mikrosievert" "mikrosieverten" ; -- mikrosievert..nn.1
  mikroskop_1_N = mkN "mikroskop" neutrum  ; -- mikroskop..nn.1
  mikroskopera_1_V = mkV "mikroskoperar" ; -- mikroskopera..vb.1
  mikroskoperande_1_N = mkN "mikroskoperande" ; -- mikroskoperande..nn.1
  mikroskoperbar_1_A = mkA "mikroskoperbar" ; -- mikroskoperbar..av.1
  mikroskoperbarhet_1_N = mkN "mikroskoperbarhet" ; -- mikroskoperbarhet..nn.1
  mikroskopering_1_N = mkN "mikroskopering" ; -- mikroskopering..nn.1
  mikroskopi_1_N = mkN "mikroskopi" ; -- mikroskopi..nn.1
  mikroskopisk_1_A = mkA "mikroskopisk" ; -- mikroskopisk..av.1
  mikrostyra_1_V = mkV "mikrostyra" "mikrostyrde" "mikrostyrt" ; -- mikrostyra..vb.1
  mikrostyrande_1_N = mkN "mikrostyrande" ; -- mikrostyrande..nn.1
  mikrostyrning_1_N = mkN "mikrostyrning" ; -- mikrostyrning..nn.1
  mikrosömn_1_N = mkN "mikrosömn" ; -- mikrosömn..nn.1
  mikrotelefon_1_N = mkN "mikrotelefon" "mikrotelefoner" ; -- mikrotelefon..nn.1
  mikrotom_1_N = mkN "mikrotom" "mikrotomer" ; -- mikrotom..nn.1
  mikrovåg_1_N = mkN "mikrovåg" "mikrovågor" ; -- mikrovåg..nn.1
  mikrovågsugn_1_N = mkN "mikrovågsugn" ; -- mikrovågsugn..nn.1
  mikroöl_1_N = mkN "mikroöl" neutrum  ; -- mikroöl..nn.1
  mikroöl_2_N = mkN "mikroöl" neutrum  ; -- mikroöl..nn.2
  mil_1_N = mkN "mil" "milen" "mil" "milen" ; -- mil..nn.1
  mila_1_N = mkN "mila" ; -- mila..nn.1
  milanesisk_1_A = mkA "milanesisk" ; -- milanesisk..av.1
  milanesiskhet_1_N = mkN "milanesiskhet" ; -- milanesiskhet..nn.1
  mild_1_A = mkA "mild" "milt" ; -- mild..av.1
  mildhet_1_N = mkN "mildhet" "mildheter" ; -- mildhet..nn.1
  mildra_1_V = mkV "mildrar" ; -- mildra..vb.1
  mildrande_1_N = mkN "mildrande" ; -- mildrande..nn.1
  mildring_1_N = mkN "mildring" ; -- mildring..nn.1
  mildsint_1_A = mkA "mildsint" "mildsint" ; -- mildsint..av.1
  mildsinthet_1_N = mkN "mildsinthet" ; -- mildsinthet..nn.1
  mildväder_1_N = mkN "mildväder" neutrum  ; -- mildväder..nn.1
  mildögd_1_A = mkA "mildögd" "mildögt" ; -- mildögd..av.1
  mildögdhet_1_N = mkN "mildögdhet" ; -- mildögdhet..nn.1
  milennieskifte_1_N = mkN "milennieskifte" ; -- milennieskifte..nn.1
  milennium_1_N = mkN "milennium" "milenniet" "milennier" "milennierna" ; -- milennium..nn.1
  miliartuberkulos_1_N = mkN "miliartuberkulos" ; -- miliartuberkulos..nn.1
  milis_1_N = mkN "milis" "miliser" ; -- milis..nn.1
  militant_1_A = mkA "militant" "militant" ; -- militant..av.1
  militarisera_1_V = mkV "militariserar" ; -- militarisera..vb.1
  militariserande_1_N = mkN "militariserande" ; -- militariserande..nn.1
  militariserbar_1_A = mkA "militariserbar" ; -- militariserbar..av.1
  militariserbarhet_1_N = mkN "militariserbarhet" ; -- militariserbarhet..nn.1
  militarisering_1_N = mkN "militarisering" ; -- militarisering..nn.1
  militarism_1_N = mkN "militarism" "militarismer" ; -- militarism..nn.1
  militarist_1_N = mkN "militarist" "militarister" ; -- militarist..nn.1
  militaristisk_1_A = mkA "militaristisk" ; -- militaristisk..av.1
  militieombudsman_1_N = mkN "militieombudsman" "militieombudsmannen" "militieombudsmän" "militieombudsmännen" ; -- militieombudsman..nn.1
  militär_1_A = mkA "militär" ; -- militär..av.1
  militär_1_N = mkN "militär" "militärer" ; -- militär..nn.1
  militärallians_1_N = mkN "militärallians" "militärallianser" ; -- militärallians..nn.1
  militärattaché_1_N = mkN "militärattaché" "militärattachéer" ; -- militärattaché..nn.1
  militärbas_1_N = mkN "militärbas" "militärbaser" ; -- militärbas..nn.1
  militärbefälhavare_1_N = mkN "militärbefälhavare" utrum  ; -- militärbefälhavare..nn.1
  militärblockad_1_N = mkN "militärblockad" "militärblockader" ; -- militärblockad..nn.1
  militärbudget_1_N = mkN "militärbudget" ; -- militärbudget..nn.1
  militärdiktator_1_N = mkN "militärdiktator" "militärdiktatorer" ; -- militärdiktator..nn.1
  militärdiktatur_1_N = mkN "militärdiktatur" "militärdiktaturer" ; -- militärdiktatur..nn.1
  militärdiplomatisk_1_A = mkA "militärdiplomatisk" ; -- militärdiplomatisk..av.1
  militärdomstol_1_N = mkN "militärdomstol" ; -- militärdomstol..nn.1
  militärfordon_1_N = mkN "militärfordon" neutrum  ; -- militärfordon..nn.1
  militärförband_1_N = mkN "militärförband" neutrum  ; -- militärförband..nn.1
  militärförläggning_1_N = mkN "militärförläggning" ; -- militärförläggning..nn.1
  militärförvaltning_1_N = mkN "militärförvaltning" ; -- militärförvaltning..nn.1
  militärhistoria_1_N = mkN "militärhistoria" ; -- militärhistoria..nn.1
  militärhistoriker_1_N = mkN "militärhistoriker" "militärhistorikern" "militärhistoriker" "militärhistorikerna" ; -- militärhistoriker..nn.1
  militärhistorisk_1_A = mkA "militärhistorisk" ; -- militärhistorisk..av.1
  militärindustri_1_N = mkN "militärindustri" "militärindustrier" ; -- militärindustri..nn.1
  militärindustriell_1_A = mkA "militärindustriell" ; -- militärindustriell..av.1
  militärisk_1_A = mkA "militärisk" ; -- militärisk..av.1
  militärjunta_1_N = mkN "militärjunta" ; -- militärjunta..nn.1
  militärklädd_1_A = mkA "militärklädd" ; -- militärklädd..av.1
  militärkolonn_1_N = mkN "militärkolonn" "militärkolonner" ; -- militärkolonn..nn.1
  militärkupp_1_N = mkN "militärkupp" "militärkupper" ; -- militärkupp..nn.1
  militärläkare_1_N = mkN "militärläkare" utrum  ; -- militärläkare..nn.1
  militärmakt_1_N = mkN "militärmakt" "militärmakter" ; -- militärmakt..nn.1
  militärmanöver_1_N = mkN "militärmanöver" ; -- militärmanöver..nn.1
  militärmarsch_1_N = mkN "militärmarsch" "militärmarscher" ; -- militärmarsch..nn.1
  militärmusik_1_N = mkN "militärmusik" ; -- militärmusik..nn.1
  militärområde_1_N = mkN "militärområde" ; -- militärområde..nn.1
  militärorkester_1_N = mkN "militärorkester" ; -- militärorkester..nn.1
  militärpolis_1_N = mkN "militärpolis" ; -- militärpolis..nn.1
  militärpolis_2_N = mkN "militärpolis" "militärpoliser" ; -- militärpolis..nn.2
  militärpostering_1_N = mkN "militärpostering" ; -- militärpostering..nn.1
  militärpromenad_1_N = mkN "militärpromenad" "militärpromenader" ; -- militärpromenad..nn.1
  militärråd_1_N = mkN "militärråd" neutrum  ; -- militärråd..nn.1
  militärskola_1_N = mkN "militärskola" ; -- militärskola..nn.1
  militärstrategisk_1_A = mkA "militärstrategisk" ; -- militärstrategisk..av.1
  militärstyrka_1_N = mkN "militärstyrka" ; -- militärstyrka..nn.1
  militärtjänst_1_N = mkN "militärtjänst" ; -- militärtjänst..nn.1
  militärtjänstgöring_1_N = mkN "militärtjänstgöring" ; -- militärtjänstgöring..nn.1
  militäruniform_1_N = mkN "militäruniform" "militäruniformer" ; -- militäruniform..nn.1
  militärövning_1_N = mkN "militärövning" ; -- militärövning..nn.1
  miljard_1_N = mkN "miljard" "miljarder" ; -- miljard..nn.1
  miljardaffär_1_N = mkN "miljardaffär" "miljardaffärer" ; -- miljardaffär..nn.1
  miljarddel_1_N = mkN "miljarddel" "miljarddelen" "miljarddelar" "miljarddelarna" ; -- miljarddel..nn.1
  miljardlån_1_N = mkN "miljardlån" neutrum  ; -- miljardlån..nn.1
  miljardsatsning_1_N = mkN "miljardsatsning" ; -- miljardsatsning..nn.1
  miljardte_1_A = mkA "miljardte" ; -- miljardte..av.1
  miljardär_1_N = mkN "miljardär" "miljardärer" ; -- miljardär..nn.1
  miljon_1_N = mkN "miljon" "miljoner" ; -- miljon..nn.1
  miljonbedrägeri_1_N = mkN "miljonbedrägeri" "miljonbedrägeriet" "miljonbedrägerier" "miljonbedrägerierna" ; -- miljonbedrägeri..nn.1
  miljonbelopp_1_N = mkN "miljonbelopp" neutrum  ; -- miljonbelopp..nn.1
  miljondel_1_N = mkN "miljondel" "miljondelen" "miljondelar" "miljondelarna" ; -- miljondel..nn.1
  miljonfilm_1_N = mkN "miljonfilm" "miljonfilmer" ; -- miljonfilm..nn.1
  miljoninvestering_1_N = mkN "miljoninvestering" ; -- miljoninvestering..nn.1
  miljonjubel_1_N = mkN "miljonjubel" neutrum  ; -- miljonjubel..nn.1
  miljonklass_1_N = mkN "miljonklass" "miljonklasser" ; -- miljonklass..nn.1
  miljonklipp_1_N = mkN "miljonklipp" neutrum  ; -- miljonklipp..nn.1
  miljonlön_1_N = mkN "miljonlön" "miljonlöner" ; -- miljonlön..nn.1
  miljonpublik_1_N = mkN "miljonpublik" "miljonpubliker" ; -- miljonpublik..nn.1
  miljonskadestånd_1_N = mkN "miljonskadestånd" neutrum  ; -- miljonskadestånd..nn.1
  miljonstad_1_N = mkN "miljonstad" "miljonstäder" ; -- miljonstad..nn.1
  miljonstöd_1_N = mkN "miljonstöd" neutrum  ; -- miljonstöd..nn.1
  miljonte_1_A = mkA "miljonte" ; -- miljonte..av.1
  miljonär_1_N = mkN "miljonär" "miljonärer" ; -- miljonär..nn.1
  miljö_1_N = mkN "miljö" "miljön" "miljöer" "miljöerna" ; -- miljö..nn.1
  miljöaktivist_1_N = mkN "miljöaktivist" "miljöaktivister" ; -- miljöaktivist..nn.1
  miljöanpassad_1_A = mkA "miljöanpassad" ; -- miljöanpassad..av.1
  miljöansvarig_1_A = mkA "miljöansvarig" ; -- miljöansvarig..av.1
  miljöarbete_1_N = mkN "miljöarbete" ; -- miljöarbete..nn.1
  miljöavtal_1_N = mkN "miljöavtal" neutrum  ; -- miljöavtal..nn.1
  miljöbalk_1_N = mkN "miljöbalk" ; -- miljöbalk..nn.1
  miljöbil_1_N = mkN "miljöbil" ; -- miljöbil..nn.1
  miljöbilssatsning_1_N = mkN "miljöbilssatsning" ; -- miljöbilssatsning..nn.1
  miljöbov_1_N = mkN "miljöbov" ; -- miljöbov..nn.1
  miljöbrott_1_N = mkN "miljöbrott" neutrum  ; -- miljöbrott..nn.1
  miljöbuse_1_N = mkN "miljöbuse" utrum  ; -- miljöbuse..nn.1
  miljöbyte_1_N = mkN "miljöbyte" ; -- miljöbyte..nn.1
  miljöcertifiera_1_V = mkV "miljöcertifierar" ; -- miljöcertifiera..vb.1
  miljöcertifierande_1_N = mkN "miljöcertifierande" ; -- miljöcertifierande..nn.1
  miljöcertifiering_1_N = mkN "miljöcertifiering" ; -- miljöcertifiering..nn.1
  miljödomstol_1_N = mkN "miljödomstol" ; -- miljödomstol..nn.1
  miljöfarlig_1_A = mkA "miljöfarlig" ; -- miljöfarlig..av.1
  miljöfarlighet_1_N = mkN "miljöfarlighet" ; -- miljöfarlighet..nn.1
  miljöfråga_1_N = mkN "miljöfråga" ; -- miljöfråga..nn.1
  miljöförbättrande_1_A = mkA "miljöförbättrande" ; -- miljöförbättrande..av.1
  miljöförorening_1_N = mkN "miljöförorening" ; -- miljöförorening..nn.1
  miljöförstöra_1_V = mkV "miljöförstörar" ; -- miljöförstöra..vb.1
  miljöförstörare_1_N = mkN "miljöförstörare" utrum  ; -- miljöförstörare..nn.1
  miljöförstörelse_1_N = mkN "miljöförstörelse" utrum  ; -- miljöförstörelse..nn.1
  miljöförstöring_1_N = mkN "miljöförstöring" ; -- miljöförstöring..nn.1
  miljöförsämring_1_N = mkN "miljöförsämring" ; -- miljöförsämring..nn.1
  miljöförvaltning_1_N = mkN "miljöförvaltning" ; -- miljöförvaltning..nn.1
  miljögift_1_N = mkN "miljögift" "miljögiftet" "miljögifter" "miljögifterna" ; -- miljögift..nn.1
  miljögiftshalt_1_N = mkN "miljögiftshalt" "miljögiftshalter" ; -- miljögiftshalt..nn.1
  miljöhjälte_1_N = mkN "miljöhjälte" utrum  ; -- miljöhjälte..nn.1
  miljöhycklare_1_N = mkN "miljöhycklare" utrum  ; -- miljöhycklare..nn.1
  miljöhänsyn_1_N = mkN "miljöhänsyn" neutrum  ; -- miljöhänsyn..nn.1
  miljökatastrof_1_N = mkN "miljökatastrof" "miljökatastrofer" ; -- miljökatastrof..nn.1
  miljökonsekvens_1_N = mkN "miljökonsekvens" "miljökonsekvenser" ; -- miljökonsekvens..nn.1
  miljökonsekvensbedömning_1_N = mkN "miljökonsekvensbedömning" ; -- miljökonsekvensbedömning..nn.1
  miljökrav_1_N = mkN "miljökrav" neutrum  ; -- miljökrav..nn.1
  miljöliberal_1_A = mkA "miljöliberal" ; -- miljöliberal..av.1
  miljömedicinsk_1_A = mkA "miljömedicinsk" ; -- miljömedicinsk..av.1
  miljömedveten_1_A = mkA "miljömedveten" ; -- miljömedveten..av.1
  miljömedvetenhet_1_N = mkN "miljömedvetenhet" ; -- miljömedvetenhet..nn.1
  miljöminister_1_N = mkN "miljöminister" ; -- miljöminister..nn.1
  miljöministerium_1_N = mkN "miljöministerium" "miljöministeriet" "miljöministerier" "miljöministerierna" ; -- miljöministerium..nn.1
  miljömärka_1_V = mkV "miljömärker" ; -- miljömärka..vb.1
  miljömärkande_1_N = mkN "miljömärkande" ; -- miljömärkande..nn.1
  miljömärkning_1_N = mkN "miljömärkning" ; -- miljömärkning..nn.1
  miljömässig_1_A = mkA "miljömässig" ; -- miljömässig..av.1
  miljömässighet_1_N = mkN "miljömässighet" ; -- miljömässighet..nn.1
  miljöombyte_1_N = mkN "miljöombyte" ; -- miljöombyte..nn.1
  miljöpartist_1_N = mkN "miljöpartist" "miljöpartister" ; -- miljöpartist..nn.1
  miljöpartistisk_1_A = mkA "miljöpartistisk" ; -- miljöpartistisk..av.1
  miljöpolitik_1_N = mkN "miljöpolitik" ; -- miljöpolitik..nn.1
  miljöpolitisk_1_A = mkA "miljöpolitisk" ; -- miljöpolitisk..av.1
  miljöproblem_1_N = mkN "miljöproblem" neutrum  ; -- miljöproblem..nn.1
  miljöprövning_1_N = mkN "miljöprövning" ; -- miljöprövning..nn.1
  miljörörelse_1_N = mkN "miljörörelse" "miljörörelser" ; -- miljörörelse..nn.1
  miljöskada_1_N = mkN "miljöskada" ; -- miljöskada..nn.1
  miljöskadad_1_A = mkA "miljöskadad" ; -- miljöskadad..av.1
  miljöskadlig_1_A = mkA "miljöskadlig" ; -- miljöskadlig..av.1
  miljöskildring_1_N = mkN "miljöskildring" ; -- miljöskildring..nn.1
  miljöskrift_1_N = mkN "miljöskrift" "miljöskrifter" ; -- miljöskrift..nn.1
  miljöskurk_1_N = mkN "miljöskurk" ; -- miljöskurk..nn.1
  miljöskydd_1_N = mkN "miljöskydd" ; -- miljöskydd..nn.1
  miljösmart_1_A = mkA "miljösmart" "miljösmart" ; -- miljösmart..av.1
  miljösynpunkt_1_N = mkN "miljösynpunkt" "miljösynpunkter" ; -- miljösynpunkt..nn.1
  miljötidskrift_1_N = mkN "miljötidskrift" "miljötidskrifter" ; -- miljötidskrift..nn.1
  miljötänkande_1_N = mkN "miljötänkande" ; -- miljötänkande..nn.1
  miljöutskott_1_N = mkN "miljöutskott" neutrum  ; -- miljöutskott..nn.1
  miljövinst_1_N = mkN "miljövinst" "miljövinster" ; -- miljövinst..nn.1
  miljövurmande_1_A = mkA "miljövurmande" ; -- miljövurmande..av.1
  miljövänlig_1_A = mkA "miljövänlig" ; -- miljövänlig..av.1
  miljövänlighet_1_N = mkN "miljövänlighet" ; -- miljövänlighet..nn.1
  miljövärn_1_N = mkN "miljövärn" neutrum  ; -- miljövärn..nn.1
  miljövård_1_N = mkN "miljövård" ; -- miljövård..nn.1
  milkshake_1_N = mkN "milkshake" utrum  ; -- milkshake..nn.1
  mille_1_N = mkN "mille" utrum  ; -- mille..nn.1
  millennieskifte_1_N = mkN "millennieskifte" ; -- millennieskifte..nn.1
  millennium_1_N = mkN "millennium" "millenniet" "millennier" "millennierna" ; -- millennium..nn.1
  milliard_1_N = mkN "milliard" "milliarder" ; -- milliard..nn.1
  millibar_1_N = mkN "millibar" "millibaren" "millibar" "millibaren" ; -- millibar..nn.1
  milligram_1_N = mkN "milligram" "milligrammet" "milligram" "milligrammen" ; -- milligram..nn.1
  milliliter_1_N = mkN "milliliter" "millilitern" "milliliter" "milliliterna" ; -- milliliter..nn.1
  millimeter_1_N = mkN "millimeter" ; -- millimeter..nn.1
  millimeterlång_1_A = mkA "millimeterlång" ; -- millimeterlång..av.1
  millimeterpapper_1_N = mkN "millimeterpapper" neutrum  ; -- millimeterpapper..nn.1
  millimeterrättvisa_1_N = mkN "millimeterrättvisa" ; -- millimeterrättvisa..nn.1
  millimetertjock_1_A = mkA "millimetertjock" ; -- millimetertjock..av.1
  million_1_N = mkN "million" ; -- million..nn.1
  millionte_1_A = mkA "millionte" ; -- millionte..av.1
  millisievert_1_N = mkN "millisievert" "millisieverten" "millisievert" "millisieverten" ; -- millisievert..nn.1
  milliwatt_1_N = mkN "milliwatt" "milliwatten" "milliwatt" "milliwatten" ; -- milliwatt..nn.1
  milo_1_N = mkN "milo" "milot" "milon" "milona" ; -- milo..nn.1
  milslång_1_A = mkA "milslång" ; -- milslång..av.1
  milsten_1_N = mkN "milsten" "milstenen" "milstenar" "milstenarna" ; -- milsten..nn.1
  milstolpe_1_N = mkN "milstolpe" utrum  ; -- milstolpe..nn.1
  milsvid_1_A = mkA "milsvid" "milsvitt" ; -- milsvid..av.1
  miltals_1_Adv = mkAdv "miltals" ; -- miltals..ab.1
  mim_1_N = mkN "mim" "mimer" ; -- mim..nn.1
  mima_1_V = mkV "mimar" ; -- mima..vb.1
  mimande_1_N = mkN "mimande" ; -- mimande..nn.1
  mimik_1_N = mkN "mimik" ; -- mimik..nn.1
  mimiker_1_N = mkN "mimiker" "mimikern" "mimiker" "mimikerna" ; -- mimiker..nn.1
  mimisk_1_A = mkA "mimisk" ; -- mimisk..av.1
  mimosa_1_N = mkN "mimosa" ; -- mimosa..nn.1
  mimosasallad_1_N = mkN "mimosasallad" "mimosasallader" ; -- mimosasallad..nn.1
  min_1_N = mkN "min" "miner" ; -- min..nn.1
  mina_1_N = mkN "mina" ; -- mina..nn.1
  minaret_1_N = mkN "minaret" "minareter" ; -- minaret..nn.1
  minaretbygge_1_N = mkN "minaretbygge" ; -- minaretbygge..nn.1
  minaretförbud_1_N = mkN "minaretförbud" neutrum  ; -- minaretförbud..nn.1
  minbomb_1_N = mkN "minbomb" "minbomber" ; -- minbomb..nn.1
  mindervärdeskomplex_1_N = mkN "mindervärdeskomplex" neutrum  ; -- mindervärdeskomplex..nn.1
  mindervärdeskänsla_1_N = mkN "mindervärdeskänsla" ; -- mindervärdeskänsla..nn.1
  mindervärdig_1_A = mkA "mindervärdig" ; -- mindervärdig..av.1
  mindervärdighet_1_N = mkN "mindervärdighet" ; -- mindervärdighet..nn.1
  minderårig_1_A = mkA "minderårig" ; -- minderårig..av.1
  minderårighet_1_N = mkN "minderårighet" ; -- minderårighet..nn.1
  minderåring_1_N = mkN "minderåring" ; -- minderåring..nn.1
  mindretal_1_N = mkN "mindretal" neutrum  ; -- mindretal..nn.1
  minera_1_V = mkV "minerar" ; -- minera..vb.1
  mineral_1_N = mkN "mineral" "mineralet" "mineralier" "mineralierna" ; -- mineral..nn.1
  mineralfärg_1_N = mkN "mineralfärg" "mineralfärger" ; -- mineralfärg..nn.1
  mineralgång_1_N = mkN "mineralgång" ; -- mineralgång..nn.1
  mineralhalt_1_N = mkN "mineralhalt" "mineralhalter" ; -- mineralhalt..nn.1
  mineralhaltig_1_A = mkA "mineralhaltig" ; -- mineralhaltig..av.1
  mineralisera_1_V = mkV "mineraliserar" ; -- mineralisera..vb.1
  mineraliserande_1_N = mkN "mineraliserande" ; -- mineraliserande..nn.1
  mineraliserbar_1_A = mkA "mineraliserbar" ; -- mineraliserbar..av.1
  mineraliserbarhet_1_N = mkN "mineraliserbarhet" ; -- mineraliserbarhet..nn.1
  mineralisering_1_N = mkN "mineralisering" ; -- mineralisering..nn.1
  mineralisk_1_A = mkA "mineralisk" ; -- mineralisk..av.1
  mineralmuseum_1_N = mkN "mineralmuseum" "mineralmuseet" "mineralmuseer" "mineralmuseerna" ; -- mineralmuseum..nn.1
  mineralog_1_N = mkN "mineralog" "mineraloger" ; -- mineralog..nn.1
  mineralogi_1_N = mkN "mineralogi" ; -- mineralogi..nn.1
  mineralogisk_1_A = mkA "mineralogisk" ; -- mineralogisk..av.1
  mineralolja_1_N = mkN "mineralolja" ; -- mineralolja..nn.1
  mineralprov_1_N = mkN "mineralprov" neutrum  ; -- mineralprov..nn.1
  mineralrik_1_A = mkA "mineralrik" ; -- mineralrik..av.1
  mineralrike_1_N = mkN "mineralrike" ; -- mineralrike..nn.1
  mineralsalt_1_N = mkN "mineralsalt" "mineralsaltet" "mineralsalter" "mineralsalterna" ; -- mineralsalt..nn.1
  mineraltillsats_1_N = mkN "mineraltillsats" "mineraltillsatser" ; -- mineraltillsats..nn.1
  mineralull_1_N = mkN "mineralull" ; -- mineralull..nn.1
  mineralutvinning_1_N = mkN "mineralutvinning" ; -- mineralutvinning..nn.1
  mineralvatten_1_N = mkN "mineralvatten" "mineralvattnet" "mineralvatten" "mineralvattnen" ; -- mineralvatten..nn.1
  mineralvattenflaska_1_N = mkN "mineralvattenflaska" ; -- mineralvattenflaska..nn.1
  mineralämne_1_N = mkN "mineralämne" ; -- mineralämne..nn.1
  mineralöverdrag_1_N = mkN "mineralöverdrag" neutrum  ; -- mineralöverdrag..nn.1
  minerande_1_N = mkN "minerande" ; -- minerande..nn.1
  minerbar_1_A = mkA "minerbar" ; -- minerbar..av.1
  minerbarhet_1_N = mkN "minerbarhet" ; -- minerbarhet..nn.1
  minering_1_N = mkN "minering" ; -- minering..nn.1
  minestrone_1_N = mkN "minestrone" utrum  ; -- minestrone..nn.1
  minestronesoppa_1_N = mkN "minestronesoppa" ; -- minestronesoppa..nn.1
  minett_1_N = mkN "minett" ; -- minett..nn.1
  minexplosion_1_N = mkN "minexplosion" ; -- minexplosion..nn.1
  minfartyg_1_N = mkN "minfartyg" neutrum  ; -- minfartyg..nn.1
  minfält_1_N = mkN "minfält" neutrum  ; -- minfält..nn.1
  mingel_1_N = mkN "mingel" neutrum  ; -- mingel..nn.1
  mingla_1_V = mkV "minglar" ; -- mingla..vb.1
  minglande_1_N = mkN "minglande" ; -- minglande..nn.1
  mingång_1_N = mkN "mingång" ; -- mingång..nn.1
  miniatyr_1_N = mkN "miniatyr" "miniatyrer" ; -- miniatyr..nn.1
  miniatyrflaska_1_N = mkN "miniatyrflaska" ; -- miniatyrflaska..nn.1
  miniatyrisera_1_V = mkV "miniatyriserar" ; -- miniatyrisera..vb.1
  miniatyriserande_1_N = mkN "miniatyriserande" ; -- miniatyriserande..nn.1
  miniatyriserbar_1_A = mkA "miniatyriserbar" ; -- miniatyriserbar..av.1
  miniatyriserbarhet_1_N = mkN "miniatyriserbarhet" ; -- miniatyriserbarhet..nn.1
  miniatyrisering_1_N = mkN "miniatyrisering" ; -- miniatyrisering..nn.1
  miniatyrmässig_1_A = mkA "miniatyrmässig" ; -- miniatyrmässig..av.1
  miniatyrmålare_1_N = mkN "miniatyrmålare" utrum  ; -- miniatyrmålare..nn.1
  miniatyrmålning_1_N = mkN "miniatyrmålning" ; -- miniatyrmålning..nn.1
  minibil_1_N = mkN "minibil" ; -- minibil..nn.1
  minibuss_1_N = mkN "minibuss" ; -- minibuss..nn.1
  minidator_1_N = mkN "minidator" "minidatorer" ; -- minidator..nn.1
  miniersättning_1_N = mkN "miniersättning" ; -- miniersättning..nn.1
  miniflaska_1_N = mkN "miniflaska" ; -- miniflaska..nn.1
  minigolf_1_N = mkN "minigolf" ; -- minigolf..nn.1
  minigran_1_N = mkN "minigran" ; -- minigran..nn.1
  minikjol_1_N = mkN "minikjol" ; -- minikjol..nn.1
  minimal_1_A = mkA "minimal" ; -- minimal..av.1
  minimalistisk_1_A = mkA "minimalistisk" ; -- minimalistisk..av.1
  minimera_1_V = mkV "minimerar" ; -- minimera..vb.1
  minimerande_1_N = mkN "minimerande" ; -- minimerande..nn.1
  minimerbar_1_A = mkA "minimerbar" ; -- minimerbar..av.1
  minimerbarhet_1_N = mkN "minimerbarhet" ; -- minimerbarhet..nn.1
  minimering_1_N = mkN "minimering" ; -- minimering..nn.1
  minimibelopp_1_N = mkN "minimibelopp" neutrum  ; -- minimibelopp..nn.1
  minimikapital_1_N = mkN "minimikapital" neutrum  ; -- minimikapital..nn.1
  minimikrav_1_N = mkN "minimikrav" neutrum  ; -- minimikrav..nn.1
  minimilön_1_N = mkN "minimilön" "minimilöner" ; -- minimilön..nn.1
  minimipris_1_N = mkN "minimipris" neutrum  ; -- minimipris..nn.1
  minimipunkt_1_N = mkN "minimipunkt" "minimipunkter" ; -- minimipunkt..nn.1
  minimisiffra_1_N = mkN "minimisiffra" ; -- minimisiffra..nn.1
  minimitemperatur_1_N = mkN "minimitemperatur" "minimitemperaturer" ; -- minimitemperatur..nn.1
  minimitermometer_1_N = mkN "minimitermometer" ; -- minimitermometer..nn.1
  minimum_1_N = mkN "minimum" neutrum  ; -- minimum..nn.1
  minior_1_N = mkN "minior" "minioren" "miniorer" "miniorerna" ; -- minior..nn.1
  miniroller_1_N = mkN "miniroller" ; -- miniroller..nn.1
  miniräknare_1_N = mkN "miniräknare" utrum  ; -- miniräknare..nn.1
  minister_1_N = mkN "minister" ; -- minister..nn.1
  ministeransvarighet_1_N = mkN "ministeransvarighet" "ministeransvarigheter" ; -- ministeransvarighet..nn.1
  ministerbänk_1_N = mkN "ministerbänk" ; -- ministerbänk..nn.1
  ministerialbok_1_N = mkN "ministerialbok" "ministerialböcker" ; -- ministerialbok..nn.1
  ministeriell_1_A = mkA "ministeriell" ; -- ministeriell..av.1
  ministerium_1_N = mkN "ministerium" "ministeriet" "ministerier" "ministerierna" ; -- ministerium..nn.1
  ministerportfölj_1_N = mkN "ministerportfölj" "ministerportföljer" ; -- ministerportfölj..nn.1
  ministerpost_1_N = mkN "ministerpost" "ministerposter" ; -- ministerpost..nn.1
  ministerpresident_1_N = mkN "ministerpresident" "ministerpresidenter" ; -- ministerpresident..nn.1
  ministerråd_1_N = mkN "ministerråd" neutrum  ; -- ministerråd..nn.1
  ministerstyre_1_N = mkN "ministerstyre" ; -- ministerstyre..nn.1
  ministerstyrelse_1_N = mkN "ministerstyrelse" "ministerstyrelser" ; -- ministerstyrelse..nn.1
  ministertaburett_1_N = mkN "ministertaburett" "ministertaburetter" ; -- ministertaburett..nn.1
  ministerämbete_1_N = mkN "ministerämbete" ; -- ministerämbete..nn.1
  ministär_1_N = mkN "ministär" "ministärer" ; -- ministär..nn.1
  miniväderkvarn_1_N = mkN "miniväderkvarn" ; -- miniväderkvarn..nn.1
  mink_1_N = mkN "mink" ; -- mink..nn.1
  minna_1_V = mkV "minna" "minde" "mint" ; -- minna..vb.1
  minnande_1_N = mkN "minnande" ; -- minnande..nn.1
  minne_1_N = mkN "minne" ; -- minne..nn.1
  minnesalbum_1_N = mkN "minnesalbum" neutrum  ; -- minnesalbum..nn.1
  minnesanteckning_1_N = mkN "minnesanteckning" ; -- minnesanteckning..nn.1
  minnesbeta_1_N = mkN "minnesbeta" ; -- minnesbeta..nn.1
  minnesbild_1_N = mkN "minnesbild" "minnesbilder" ; -- minnesbild..nn.1
  minnesbok_1_N = mkN "minnesbok" "minnesböcker" ; -- minnesbok..nn.1
  minnesbuss_1_N = mkN "minnesbuss" ; -- minnesbuss..nn.1
  minnesenhet_1_N = mkN "minnesenhet" "minnesenheter" ; -- minnesenhet..nn.1
  minnesfel_1_N = mkN "minnesfel" "minnesfelet" "minnesfel" "minnesfelen" ; -- minnesfel..nn.1
  minnesfest_1_N = mkN "minnesfest" "minnesfester" ; -- minnesfest..nn.1
  minnesfond_1_N = mkN "minnesfond" "minnesfonder" ; -- minnesfond..nn.1
  minnesfragment_1_N = mkN "minnesfragment" neutrum  ; -- minnesfragment..nn.1
  minnesfunktion_1_N = mkN "minnesfunktion" ; -- minnesfunktion..nn.1
  minnesförlust_1_N = mkN "minnesförlust" "minnesförluster" ; -- minnesförlust..nn.1
  minnesgod_1_A = mkA "minnesgod" "minnesgott" ; -- minnesgod..av.1
  minnesgodhet_1_N = mkN "minnesgodhet" ; -- minnesgodhet..nn.1
  minnesgudstjänst_1_N = mkN "minnesgudstjänst" "minnesgudstjänster" ; -- minnesgudstjänst..nn.1
  minnesgärd_1_N = mkN "minnesgärd" "minnesgärder" ; -- minnesgärd..nn.1
  minnesgåva_1_N = mkN "minnesgåva" ; -- minnesgåva..nn.1
  minneshögtidlighet_1_N = mkN "minneshögtidlighet" "minneshögtidligheter" ; -- minneshögtidlighet..nn.1
  minnesinstitution_1_N = mkN "minnesinstitution" ; -- minnesinstitution..nn.1
  minneskonst_1_N = mkN "minneskonst" "minneskonster" ; -- minneskonst..nn.1
  minneskonst_2_N = mkN "minneskonst" ; -- minneskonst..nn.2
  minneskonstnär_1_N = mkN "minneskonstnär" "minneskonstnärer" ; -- minneskonstnär..nn.1
  minneskunskap_1_N = mkN "minneskunskap" "minneskunskaper" ; -- minneskunskap..nn.1
  minneslista_1_N = mkN "minneslista" ; -- minneslista..nn.1
  minneslund_1_N = mkN "minneslund" ; -- minneslund..nn.1
  minneslös_1_A = mkA "minneslös" ; -- minneslös..av.1
  minneslöshet_1_N = mkN "minneslöshet" ; -- minneslöshet..nn.1
  minnesmärke_1_N = mkN "minnesmärke" ; -- minnesmärke..nn.1
  minnesord_1_N = mkN "minnesord" neutrum  ; -- minnesord..nn.1
  minnesregel_1_N = mkN "minnesregel" "minnesregeln" "minnesregler" "minnesreglerna" ; -- minnesregel..nn.1
  minnesrik_1_A = mkA "minnesrik" ; -- minnesrik..av.1
  minnesrikhet_1_N = mkN "minnesrikhet" ; -- minnesrikhet..nn.1
  minnesruna_1_N = mkN "minnesruna" ; -- minnesruna..nn.1
  minnesrymd_1_N = mkN "minnesrymd" "minnesrymder" ; -- minnesrymd..nn.1
  minnessak_1_N = mkN "minnessak" "minnessaker" ; -- minnessak..nn.1
  minnessiffra_1_N = mkN "minnessiffra" ; -- minnessiffra..nn.1
  minnesskrift_1_N = mkN "minnesskrift" "minnesskrifter" ; -- minnesskrift..nn.1
  minnesspår_1_N = mkN "minnesspår" neutrum  ; -- minnesspår..nn.1
  minnessten_1_N = mkN "minnessten" "minnesstenen" "minnesstenar" "minnesstenarna" ; -- minnessten..nn.1
  minnesstod_1_N = mkN "minnesstod" "minnesstoder" ; -- minnesstod..nn.1
  minnesstöd_1_N = mkN "minnesstöd" neutrum  ; -- minnesstöd..nn.1
  minnessång_1_N = mkN "minnessång" "minnessånger" ; -- minnessång..nn.1
  minnessångare_1_N = mkN "minnessångare" utrum  ; -- minnessångare..nn.1
  minnestal_1_N = mkN "minnestal" neutrum  ; -- minnestal..nn.1
  minnestavla_1_N = mkN "minnestavla" ; -- minnestavla..nn.1
  minnestecknare_1_N = mkN "minnestecknare" utrum  ; -- minnestecknare..nn.1
  minnesteckning_1_N = mkN "minnesteckning" ; -- minnesteckning..nn.1
  minnesvers_1_N = mkN "minnesvers" "minnesverser" ; -- minnesvers..nn.1
  minnesvilla_1_N = mkN "minnesvilla" ; -- minnesvilla..nn.1
  minnesvärd_1_A = mkA "minnesvärd" "minnesvärt" ; -- minnesvärd..av.1
  minnesvärdhet_1_N = mkN "minnesvärdhet" ; -- minnesvärdhet..nn.1
  minnesvård_1_N = mkN "minnesvård" ; -- minnesvård..nn.1
  minnesvård_2_N = mkN "minnesvård" ; -- minnesvård..nn.2
  minnesång_1_N = mkN "minnesång" "minnesånger" ; -- minnesång..nn.1
  minnesångare_1_N = mkN "minnesångare" utrum  ; -- minnesångare..nn.1
  minnig_1_A = mkA "minnig" ; -- minnig..av.1
  minoisk_1_A = mkA "minoisk" ; -- minoisk..av.1
  minoritet_1_N = mkN "minoritet" "minoriteter" ; -- minoritet..nn.1
  minoritetsfolk_1_N = mkN "minoritetsfolk" neutrum  ; -- minoritetsfolk..nn.1
  minoritetsforskning_1_N = mkN "minoritetsforskning" ; -- minoritetsforskning..nn.1
  minoritetsförtryck_1_N = mkN "minoritetsförtryck" neutrum  ; -- minoritetsförtryck..nn.1
  minoritetsregering_1_N = mkN "minoritetsregering" ; -- minoritetsregering..nn.1
  minoritetsskydd_1_N = mkN "minoritetsskydd" neutrum  ; -- minoritetsskydd..nn.1
  minoritetsspråk_1_N = mkN "minoritetsspråk" neutrum  ; -- minoritetsspråk..nn.1
  minoritetsställning_1_N = mkN "minoritetsställning" ; -- minoritetsställning..nn.1
  minoritetsvälde_1_N = mkN "minoritetsvälde" ; -- minoritetsvälde..nn.1
  minröjning_1_N = mkN "minröjning" ; -- minröjning..nn.1
  minsann_1_Adv = mkAdv "minsann" ; -- minsann..ab.1
  minsk_1_A = mkA "minsk" ; -- minsk..av.1
  minska_1_V = mkV "minskar" ; -- minska..vb.1
  minskande_1_N = mkN "minskande" ; -- minskande..nn.1
  minskhet_1_N = mkN "minskhet" ; -- minskhet..nn.1
  minskning_1_N = mkN "minskning" ; -- minskning..nn.1
  minspärr_1_N = mkN "minspärr" ; -- minspärr..nn.1
  minsting_1_N = mkN "minsting" ; -- minsting..nn.1
  minsvep_1_N = mkN "minsvep" neutrum  ; -- minsvep..nn.1
  minsvepare_1_N = mkN "minsvepare" utrum  ; -- minsvepare..nn.1
  minsvepning_1_N = mkN "minsvepning" ; -- minsvepning..nn.1
  minsökare_1_N = mkN "minsökare" utrum  ; -- minsökare..nn.1
  mint_1_N = mkN "mint" ; -- mint..nn.1
  mintblå_1_A = mkA "mintblå" "mintblått" ; -- mintblå..av.1
  mintlikör_1_N = mkN "mintlikör" "mintlikörer" ; -- mintlikör..nn.1
  minuend_1_N = mkN "minuend" "minuender" ; -- minuend..nn.1
  minus_1_N = mkN "minus" neutrum  ; -- minus..nn.1
  minusgrad_1_N = mkN "minusgrad" "minusgrader" ; -- minusgrad..nn.1
  minuskel_1_N = mkN "minuskel" "minuskeln" "minuskler" "minusklerna" ; -- minuskel..nn.1
  minuskelskrift_1_N = mkN "minuskelskrift" ; -- minuskelskrift..nn.1
  minuspol_1_N = mkN "minuspol" "minuspoler" ; -- minuspol..nn.1
  minusresultat_1_N = mkN "minusresultat" neutrum  ; -- minusresultat..nn.1
  minussida_1_N = mkN "minussida" ; -- minussida..nn.1
  minustecken_1_N = mkN "minustecken" "minustecknet" "minustecken" "minustecknen" ; -- minustecken..nn.1
  minut_1_N = mkN "minut" "minuten" "minutrar" "minutrarna" ; -- minut..nn.1
  minut_2_N = mkN "minut" "minuter" ; -- minut..nn.2
  minuthandel_1_N = mkN "minuthandel" ; -- minuthandel..nn.1
  minutiös_1_A = mkA "minutiös" ; -- minutiös..av.1
  minutkort_1_A = mkA "minutkort" "minutkort" ; -- minutkort..av.1
  minutlig_1_A = mkA "minutlig" ; -- minutlig..av.1
  minutläggning_1_N = mkN "minutläggning" ; -- minutläggning..nn.1
  minutvisare_1_N = mkN "minutvisare" utrum  ; -- minutvisare..nn.1
  minör_1_N = mkN "minör" "minörer" ; -- minör..nn.1
  miocen_1_N = mkN "miocen" ; -- miocen..nn.1
  miocentid_1_N = mkN "miocentid" ; -- miocentid..nn.1
  mirabell_1_N = mkN "mirabell" "mirabeller" ; -- mirabell..nn.1
  mirakel_1_N = mkN "mirakel" neutrum  ; -- mirakel..nn.1
  mirakelflicka_1_N = mkN "mirakelflicka" ; -- mirakelflicka..nn.1
  mirakelkur_1_N = mkN "mirakelkur" "mirakelkurer" ; -- mirakelkur..nn.1
  mirakelmedicin_1_N = mkN "mirakelmedicin" "mirakelmediciner" ; -- mirakelmedicin..nn.1
  mirakelräddad_1_A = mkA "mirakelräddad" ; -- mirakelräddad..av.1
  mirakelspel_1_N = mkN "mirakelspel" "mirakelspelet" "mirakelspel" "mirakelspelen" ; -- mirakelspel..nn.1
  mirakulös_1_A = mkA "mirakulös" ; -- mirakulös..av.1
  misantrop_1_N = mkN "misantrop" "misantroper" ; -- misantrop..nn.1
  misantropi_1_N = mkN "misantropi" ; -- misantropi..nn.1
  misantropisk_1_A = mkA "misantropisk" ; -- misantropisk..av.1
  mischmasch_1_N = mkN "mischmasch" neutrum  ; -- mischmasch..nn.1
  miserabel_1_A = mkA "miserabel" ; -- miserabel..av.1
  mispel_1_N = mkN "mispel" ; -- mispel..nn.1
  miss_1_N = mkN "miss" ; -- miss..nn.1
  miss_2_N = mkN "miss" "misser" ; -- miss..nn.2
  missa_1_V = mkV "missar" ; -- missa..vb.1
  missakta_1_V = mkV "missaktar" ; -- missakta..vb.1
  missaktande_1_N = mkN "missaktande" ; -- missaktande..nn.1
  missaktning_1_N = mkN "missaktning" ; -- missaktning..nn.1
  missale_1_N = mkN "missale" ; -- missale..nn.1
  missande_1_N = mkN "missande" ; -- missande..nn.1
  missanpassad_1_A = mkA "missanpassad" ; -- missanpassad..av.1
  missanpassning_1_N = mkN "missanpassning" ; -- missanpassning..nn.1
  missbedöma_1_V = mkV "missbedömer" ; -- missbedöma..vb.1
  missbedömande_1_N = mkN "missbedömande" ; -- missbedömande..nn.1
  missbedömning_1_N = mkN "missbedömning" ; -- missbedömning..nn.1
  missbelåten_1_A = mkA "missbelåten" ; -- missbelåten..av.1
  missbelåtenhet_1_N = mkN "missbelåtenhet" ; -- missbelåtenhet..nn.1
  missbildad_1_A = mkA "missbildad" ; -- missbildad..av.1
  missbildning_1_N = mkN "missbildning" ; -- missbildning..nn.1
  missbruk_1_N = mkN "missbruk" neutrum  ; -- missbruk..nn.1
  missbruka_1_V = mkV "missbrukar" ; -- missbruka..vb.1
  missbrukande_1_N = mkN "missbrukande" ; -- missbrukande..nn.1
  missbrukare_1_N = mkN "missbrukare" utrum  ; -- missbrukare..nn.1
  missbrukarhem_1_N = mkN "missbrukarhem" "missbrukarhemmet" "missbrukarhem" "missbrukarhemmen" ; -- missbrukarhem..nn.1
  missbrukarumgänge_1_N = mkN "missbrukarumgänge" ; -- missbrukarumgänge..nn.1
  missbruksfråga_1_N = mkN "missbruksfråga" ; -- missbruksfråga..nn.1
  missbruksproblematik_1_N = mkN "missbruksproblematik" "missbruksproblematiker" ; -- missbruksproblematik..nn.1
  missdåd_1_N = mkN "missdåd" neutrum  ; -- missdåd..nn.1
  missdådare_1_N = mkN "missdådare" utrum  ; -- missdådare..nn.1
  misse_1_N = mkN "misse" utrum  ; -- misse..nn.1
  missfall_1_N = mkN "missfall" neutrum  ; -- missfall..nn.1
  missfirma_1_V = mkV "missfirmar" ; -- missfirma..vb.1
  missfirmande_1_N = mkN "missfirmande" ; -- missfirmande..nn.1
  missfirmelse_1_N = mkN "missfirmelse" "missfirmelser" ; -- missfirmelse..nn.1
  missfoster_1_N = mkN "missfoster" neutrum  ; -- missfoster..nn.1
  missfärga_1_V = mkV "missfärgar" ; -- missfärga..vb.1
  missfärgande_1_N = mkN "missfärgande" ; -- missfärgande..nn.1
  missfärgning_1_N = mkN "missfärgning" ; -- missfärgning..nn.1
  missförhållande_1_N = mkN "missförhållande" ; -- missförhållande..nn.1
  missförstå_1_V = mkV "missförstå" "missförstod" "missförstådd" ; -- missförstå..vb.1
  missförstående_1_N = mkN "missförstående" ; -- missförstående..nn.1
  missförstånd_1_N = mkN "missförstånd" neutrum  ; -- missförstånd..nn.1
  missgrepp_1_N = mkN "missgrepp" neutrum  ; -- missgrepp..nn.1
  missgynna_1_V = mkV "missgynnar" ; -- missgynna..vb.1
  missgynnande_1_N = mkN "missgynnande" ; -- missgynnande..nn.1
  missgynnsam_1_A = mkA "missgynnsam" "missgynnsamt" "missgynnsamma" "missgynnsamma" "missgynnsammare" "missgynnsammast" "missgynnsammaste" ; -- missgynnsam..av.1
  missgynnsamhet_1_N = mkN "missgynnsamhet" "missgynnsamheter" ; -- missgynnsamhet..nn.1
  missgärning_1_N = mkN "missgärning" ; -- missgärning..nn.1
  missgärningsbalk_1_N = mkN "missgärningsbalk" ; -- missgärningsbalk..nn.1
  missgärningsman_1_N = mkN "missgärningsman" "missgärningsmannen" "missgärningsmän" "missgärningsmännen" ; -- missgärningsman..nn.1
  misshag_1_N = mkN "misshag" neutrum  ; -- misshag..nn.1
  misshaga_1_V = mkV "misshagar" ; -- misshaga..vb.1
  misshagande_1_N = mkN "misshagande" ; -- misshagande..nn.1
  misshaglig_1_A = mkA "misshaglig" ; -- misshaglig..av.1
  misshaglighet_1_N = mkN "misshaglighet" ; -- misshaglighet..nn.1
  misshandel_1_N = mkN "misshandel" ; -- misshandel..nn.1
  misshandelsfall_1_N = mkN "misshandelsfall" neutrum  ; -- misshandelsfall..nn.1
  misshandelsscen_1_N = mkN "misshandelsscen" "misshandelsscener" ; -- misshandelsscen..nn.1
  misshandla_1_V = mkV "misshandlar" ; -- misshandla..vb.1
  misshandlande_1_N = mkN "misshandlande" ; -- misshandlande..nn.1
  misshandling_1_N = mkN "misshandling" ; -- misshandling..nn.1
  misshumör_1_N = mkN "misshumör" neutrum  ; -- misshumör..nn.1
  misshushålla_1_V = mkV "misshushållar" ; -- misshushålla..vb.1
  misshushållande_1_N = mkN "misshushållande" ; -- misshushållande..nn.1
  misshushållare_1_N = mkN "misshushållare" utrum  ; -- misshushållare..nn.1
  misshushållning_1_N = mkN "misshushållning" ; -- misshushållning..nn.1
  misshällighet_1_N = mkN "misshällighet" "misshälligheter" ; -- misshällighet..nn.1
  missil_1_N = mkN "missil" "missiler" ; -- missil..nn.1
  missilavfyrare_1_N = mkN "missilavfyrare" utrum  ; -- missilavfyrare..nn.1
  mission_1_N = mkN "mission" ; -- mission..nn.1
  missionera_1_V = mkV "missionerar" ; -- missionera..vb.1
  missionerande_1_N = mkN "missionerande" ; -- missionerande..nn.1
  missionering_1_N = mkN "missionering" ; -- missionering..nn.1
  missionsbokhandel_1_N = mkN "missionsbokhandel" ; -- missionsbokhandel..nn.1
  missionsbudskap_1_N = mkN "missionsbudskap" neutrum  ; -- missionsbudskap..nn.1
  missionsdag_1_N = mkN "missionsdag" ; -- missionsdag..nn.1
  missionsfält_1_N = mkN "missionsfält" neutrum  ; -- missionsfält..nn.1
  missionsförbund_1_N = mkN "missionsförbund" neutrum  ; -- missionsförbund..nn.1
  missionshotell_1_N = mkN "missionshotell" neutrum  ; -- missionshotell..nn.1
  missionshus_1_N = mkN "missionshus" neutrum  ; -- missionshus..nn.1
  missionskyrka_1_N = mkN "missionskyrka" ; -- missionskyrka..nn.1
  missionsstation_1_N = mkN "missionsstation" ; -- missionsstation..nn.1
  missionär_1_N = mkN "missionär" "missionärer" ; -- missionär..nn.1
  missis_1_N = mkN "missis" ; -- missis..nn.1
  mississippi_1_N = mkN "mississippi" ; -- mississippi..nn.1
  missiv_1_N = mkN "missiv" neutrum  ; -- missiv..nn.1
  missivera_1_V = mkV "missiverar" ; -- missivera..vb.1
  missiverande_1_N = mkN "missiverande" ; -- missiverande..nn.1
  missiverbar_1_A = mkA "missiverbar" ; -- missiverbar..av.1
  missiverbarhet_1_N = mkN "missiverbarhet" ; -- missiverbarhet..nn.1
  missivering_1_N = mkN "missivering" ; -- missivering..nn.1
  missklä_1_V = mkV "missklä" "missklädde" "missklätt" ; -- missklä..vb.1
  missklädande_1_N = mkN "missklädande" ; -- missklädande..nn.1
  missklädsam_1_A = mkA "missklädsam" "missklädsamt" "missklädsamma" "missklädsamma" "missklädsammare" "missklädsammast" "missklädsammaste" ; -- missklädsam..av.1
  missklädsamhet_1_N = mkN "missklädsamhet" ; -- missklädsamhet..nn.1
  misskredit_1_N = mkN "misskredit" ; -- misskredit..nn.1
  misskreditera_1_V = mkV "misskrediterar" ; -- misskreditera..vb.1
  misskrediterande_1_N = mkN "misskrediterande" ; -- misskrediterande..nn.1
  misskrediterbar_1_A = mkA "misskrediterbar" ; -- misskrediterbar..av.1
  misskrediterbarhet_1_N = mkN "misskrediterbarhet" ; -- misskrediterbarhet..nn.1
  misskreditering_1_N = mkN "misskreditering" ; -- misskreditering..nn.1
  misskund_1_N = mkN "misskund" ; -- misskund..nn.1
  misskundsam_1_A = mkA "misskundsam" "misskundsamt" "misskundsamma" "misskundsamma" "misskundsammare" "misskundsammast" "misskundsammaste" ; -- misskundsam..av.1
  misskundsamhet_1_N = mkN "misskundsamhet" ; -- misskundsamhet..nn.1
  misskänd_1_A = mkA "misskänd" ; -- misskänd..av.1
  misskänna_1_V = mkV "misskänna" "misskände" "misskänt" ; -- misskänna..vb.1
  misskännande_1_N = mkN "misskännande" ; -- misskännande..nn.1
  missköta_1_V = mkV "missköter" ; -- missköta..vb.1
  misskötande_1_N = mkN "misskötande" ; -- misskötande..nn.1
  misskötsam_1_A = mkA "misskötsam" "misskötsamt" "misskötsamma" "misskötsamma" "misskötsammare" "misskötsammast" "misskötsammaste" ; -- misskötsam..av.1
  misskötsamhet_1_N = mkN "misskötsamhet" ; -- misskötsamhet..nn.1
  misskötsel_1_N = mkN "misskötsel" ; -- misskötsel..nn.1
  missleda_1_V = mkV "missleda" "missledde" "misslett" ; -- missleda..vb.1
  missledande_1_A = mkA "missledande" ; -- missledande..av.1
  missledande_1_N = mkN "missledande" ; -- missledande..nn.1
  missledd_1_A = mkA "missledd" ; -- missledd..av.1
  missledning_1_N = mkN "missledning" ; -- missledning..nn.1
  missljud_1_N = mkN "missljud" neutrum  ; -- missljud..nn.1
  missljudande_1_A = mkA "missljudande" ; -- missljudande..av.1
  misslyckad_1_A = mkA "misslyckad" ; -- misslyckad..av.1
  misslyckande_1_N = mkN "misslyckande" ; -- misslyckande..nn.1
  misslynt_1_A = mkA "misslynt" "misslynt" ; -- misslynt..av.1
  misslynthet_1_N = mkN "misslynthet" ; -- misslynthet..nn.1
  missmod_1_N = mkN "missmod" neutrum  ; -- missmod..nn.1
  missmodig_1_A = mkA "missmodig" ; -- missmodig..av.1
  missmodighet_1_N = mkN "missmodighet" ; -- missmodighet..nn.1
  missne_1_N = mkN "missne" ; -- missne..nn.1
  missnöjd_1_A = mkA "missnöjd" "missnöjt" ; -- missnöjd..av.1
  missnöjdhet_1_N = mkN "missnöjdhet" ; -- missnöjdhet..nn.1
  missnöje_1_N = mkN "missnöje" ; -- missnöje..nn.1
  missnöjesaktion_1_N = mkN "missnöjesaktion" ; -- missnöjesaktion..nn.1
  missnöjesanmälan_1_N = mkN "missnöjesanmälan" "missnöjesanmälan" "missnöjesanmälningar" "missnöjesanmälningarna" ; -- missnöjesanmälan..nn.1
  missnöjesparti_1_N = mkN "missnöjesparti" "missnöjespartiet" "missnöjespartier" "missnöjespartierna" ; -- missnöjesparti..nn.1
  missnöjesretorik_1_N = mkN "missnöjesretorik" ; -- missnöjesretorik..nn.1
  missnöjesväljare_1_N = mkN "missnöjesväljare" utrum  ; -- missnöjesväljare..nn.1
  misspryda_1_V = mkV "misspryda" "missprydde" "missprytt" ; -- misspryda..vb.1
  missprydande_1_N = mkN "missprydande" ; -- missprydande..nn.1
  missriktad_1_A = mkA "missriktad" ; -- missriktad..av.1
  missriktning_1_N = mkN "missriktning" ; -- missriktning..nn.1
  missroman_1_N = mkN "missroman" "missromaner" ; -- missroman..nn.1
  missräkning_1_N = mkN "missräkning" ; -- missräkning..nn.1
  missta_1_V = mkV "misstaga" "misstog" "misstagit" ; -- missta..vb.1
  misstag_1_N = mkN "misstag" neutrum  ; -- misstag..nn.1
  misstagande_1_N = mkN "misstagande" ; -- misstagande..nn.1
  misstanke_1_N = mkN "misstanke" utrum  ; -- misstanke..nn.1
  misstankegrad_1_N = mkN "misstankegrad" "misstankegrader" ; -- misstankegrad..nn.1
  misstolka_1_V = mkV "misstolkar" ; -- misstolka..vb.1
  misstolkande_1_N = mkN "misstolkande" ; -- misstolkande..nn.1
  misstolkning_1_N = mkN "misstolkning" ; -- misstolkning..nn.1
  misstro_1_N = mkN "misstro" ; -- misstro..nn.1
  misstro_1_V = mkV "misstror" ; -- misstro..vb.1
  misstroende_1_N = mkN "misstroende" ; -- misstroende..nn.1
  misstroendeförklaring_1_N = mkN "misstroendeförklaring" ; -- misstroendeförklaring..nn.1
  misstroendevotum_1_N = mkN "misstroendevotum" neutrum  ; -- misstroendevotum..nn.1
  misstrogen_1_A = mkA "misstrogen" ; -- misstrogen..av.1
  misstrogenhet_1_N = mkN "misstrogenhet" ; -- misstrogenhet..nn.1
  misströsta_1_V = mkV "misströstar" ; -- misströsta..vb.1
  misströstande_1_N = mkN "misströstande" ; -- misströstande..nn.1
  misstycka_1_V = mkV "misstycker" ; -- misstycka..vb.1
  misstyckande_1_N = mkN "misstyckande" ; -- misstyckande..nn.1
  misstycke_1_N = mkN "misstycke" ; -- misstycke..nn.1
  misstyda_1_V = mkV "misstyda" "misstydde" "misstytt" ; -- misstyda..vb.1
  misstydande_1_N = mkN "misstydande" ; -- misstydande..nn.1
  misstydning_1_N = mkN "misstydning" ; -- misstydning..nn.1
  misstämma_1_V = mkV "misstämmer" ; -- misstämma..vb.1
  misstämmande_1_N = mkN "misstämmande" ; -- misstämmande..nn.1
  misstämning_1_N = mkN "misstämning" ; -- misstämning..nn.1
  misstänka_1_V = mkV "misstänker" ; -- misstänka..vb.1
  misstänkande_1_N = mkN "misstänkande" ; -- misstänkande..nn.1
  misstänkliggöra_1_V = mkV "misstänkliggöra" "misstänkliggjorde" "misstänkliggjort" ; -- misstänkliggöra..vb.1
  misstänkliggörande_1_N = mkN "misstänkliggörande" ; -- misstänkliggörande..nn.1
  misstänkliggöring_1_N = mkN "misstänkliggöring" ; -- misstänkliggöring..nn.1
  misstänksam_1_A = mkA "misstänksam" "misstänksamt" "misstänksamma" "misstänksamma" "misstänksammare" "misstänksammast" "misstänksammaste" ; -- misstänksam..av.1
  misstänksamhet_1_N = mkN "misstänksamhet" "misstänksamheter" ; -- misstänksamhet..nn.1
  misstänkt_1_A = mkA "misstänkt" "misstänkt" ; -- misstänkt..av.1
  missunna_1_V = mkV "missunnar" ; -- missunna..vb.1
  missunnande_1_N = mkN "missunnande" ; -- missunnande..nn.1
  missunnsam_1_A = mkA "missunnsam" "missunnsamt" "missunnsamma" "missunnsamma" "missunnsammare" "missunnsammast" "missunnsammaste" ; -- missunnsam..av.1
  missunnsamhet_1_N = mkN "missunnsamhet" ; -- missunnsamhet..nn.1
  missuppfatta_1_V = mkV "missuppfattar" ; -- missuppfatta..vb.1
  missuppfattande_1_N = mkN "missuppfattande" ; -- missuppfattande..nn.1
  missuppfattning_1_N = mkN "missuppfattning" ; -- missuppfattning..nn.1
  missvisa_1_V = mkV "missvisar" ; -- missvisa..vb.1
  missvisande_1_A = mkA "missvisande" ; -- missvisande..av.1
  missvisande_1_N = mkN "missvisande" ; -- missvisande..nn.1
  missvisning_1_N = mkN "missvisning" ; -- missvisning..nn.1
  missväxt_1_N = mkN "missväxt" ; -- missväxt..nn.1
  missväxtår_1_N = mkN "missväxtår" neutrum  ; -- missväxtår..nn.1
  missämja_1_N = mkN "missämja" ; -- missämja..nn.1
  missöde_1_N = mkN "missöde" ; -- missöde..nn.1
  missöverensstämmelse_1_N = mkN "missöverensstämmelse" "missöverensstämmelser" ; -- missöverensstämmelse..nn.1
  mist_1_N = mkN "mist" ; -- mist..nn.1
  mista_1_V = mkV "mista" "miste" "mistat" ; -- mista..vb.1
  mistande_1_N = mkN "mistande" ; -- mistande..nn.1
  miste_1_Adv = mkAdv "miste" ; -- miste..ab.1
  mistel_1_N = mkN "mistel" ; -- mistel..nn.1
  mister_1_N = mkN "mister" ; -- mister..nn.1
  mistig_1_A = mkA "mistig" ; -- mistig..av.1
  mistighet_1_N = mkN "mistighet" ; -- mistighet..nn.1
  mistlig_1_A = mkA "mistlig" ; -- mistlig..av.1
  mistlur_1_N = mkN "mistlur" ; -- mistlur..nn.1
  mistning_1_N = mkN "mistning" ; -- mistning..nn.1
  mistral_1_N = mkN "mistral" ; -- mistral..nn.1
  misär_1_N = mkN "misär" "misärer" ; -- misär..nn.1
  mitella_1_N = mkN "mitella" ; -- mitella..nn.1
  mitokondrie_1_N = mkN "mitokondrie" "mitokondrier" ; -- mitokondrie..nn.1
  mitra_1_N = mkN "mitra" ; -- mitra..nn.1
  mitt_1_N = mkN "mitt" ; -- mitt..nn.1
  mittbena_1_N = mkN "mittbena" ; -- mittbena..nn.1
  mittel_1_N = mkN "mittel" ; -- mittel..nn.1
  mittelgång_1_N = mkN "mittelgång" ; -- mittelgång..nn.1
  mittenlager_1_N = mkN "mittenlager" neutrum  ; -- mittenlager..nn.1
  mittenorienterad_1_A = mkA "mittenorienterad" ; -- mittenorienterad..av.1
  mittenparti_1_N = mkN "mittenparti" "mittenpartiet" "mittenpartier" "mittenpartierna" ; -- mittenparti..nn.1
  mitterst_1_Adv = mkAdv "mitterst" ; -- mitterst..ab.1
  mittfisk_1_N = mkN "mittfisk" ; -- mittfisk..nn.1
  mittfält_1_N = mkN "mittfält" neutrum  ; -- mittfält..nn.1
  mittfältare_1_N = mkN "mittfältare" utrum  ; -- mittfältare..nn.1
  mittgång_1_N = mkN "mittgång" ; -- mittgång..nn.1
  mittlinje_1_N = mkN "mittlinje" "mittlinjer" ; -- mittlinje..nn.1
  mittparti_1_N = mkN "mittparti" "mittpartiet" "mittpartier" "mittpartierna" ; -- mittparti..nn.1
  mittpunkt_1_N = mkN "mittpunkt" "mittpunkter" ; -- mittpunkt..nn.1
  mittpunktsnormal_1_N = mkN "mittpunktsnormal" "mittpunktsnormaler" ; -- mittpunktsnormal..nn.1
  mitträcke_1_N = mkN "mitträcke" ; -- mitträcke..nn.1
  mittskepp_1_N = mkN "mittskepp" neutrum  ; -- mittskepp..nn.1
  mix_1_N = mkN "mix" ; -- mix..nn.1
  mixa_1_V = mkV "mixar" ; -- mixa..vb.1
  mixande_1_N = mkN "mixande" ; -- mixande..nn.1
  mixed_1_N = mkN "mixed" ; -- mixed..nn.1
  mixer_1_N = mkN "mixer" ; -- mixer..nn.1
  mixtra_1_V = mkV "mixtrar" ; -- mixtra..vb.1
  mixtrande_1_N = mkN "mixtrande" ; -- mixtrande..nn.1
  mixtur_1_N = mkN "mixtur" "mixturer" ; -- mixtur..nn.1
  mjau_1_N = mkN "mjau" "mjaut" "mjaun" "mjauna" ; -- mjau..nn.1
  mjaua_1_V = mkV "mjauar" ; -- mjaua..vb.1
  mjauande_1_N = mkN "mjauande" ; -- mjauande..nn.1
  mjuk_1_A = mkA "mjuk" ; -- mjuk..av.1
  mjuka_1_V = mkV "mjukar" ; -- mjuka..vb.1
  mjukande_1_N = mkN "mjukande" ; -- mjukande..nn.1
  mjukbagge_1_N = mkN "mjukbagge" utrum  ; -- mjukbagge..nn.1
  mjukdata_1_N = mkN "mjukdata" "mjukdatat" "mjukdata" "mjukdatana" ; -- mjukdata..nn.1
  mjukdel_1_N = mkN "mjukdel" "mjukdelen" "mjukdelar" "mjukdelarna" ; -- mjukdel..nn.1
  mjukdelsbehandling_1_N = mkN "mjukdelsbehandling" ; -- mjukdelsbehandling..nn.1
  mjukglass_1_N = mkN "mjukglass" ; -- mjukglass..nn.1
  mjukgöra_1_V = mkV "mjukgöra" "mjukgjorde" "mjukgjort" ; -- mjukgöra..vb.1
  mjukgörande_1_N = mkN "mjukgörande" ; -- mjukgörande..nn.1
  mjukhet_1_N = mkN "mjukhet" "mjukheter" ; -- mjukhet..nn.1
  mjukis_1_N = mkN "mjukis" ; -- mjukis..nn.1
  mjukisdjur_1_N = mkN "mjukisdjur" neutrum  ; -- mjukisdjur..nn.1
  mjuklanda_1_V = mkV "mjuklandar" ; -- mjuklanda..vb.1
  mjuklandande_1_N = mkN "mjuklandande" ; -- mjuklandande..nn.1
  mjuklod_1_N = mkN "mjuklod" neutrum  ; -- mjuklod..nn.1
  mjukna_1_V = mkV "mjuknar" ; -- mjukna..vb.1
  mjuknande_1_N = mkN "mjuknande" ; -- mjuknande..nn.1
  mjukningsmedel_1_N = mkN "mjukningsmedel" neutrum  ; -- mjukningsmedel..nn.1
  mjukost_1_N = mkN "mjukost" ; -- mjukost..nn.1
  mjukporr_1_N = mkN "mjukporr" ; -- mjukporr..nn.1
  mjukryggad_1_A = mkA "mjukryggad" ; -- mjukryggad..av.1
  mjukskalle_1_N = mkN "mjukskalle" utrum  ; -- mjukskalle..nn.1
  mjukvaluta_1_N = mkN "mjukvaluta" ; -- mjukvaluta..nn.1
  mjukvara_1_N = mkN "mjukvara" ; -- mjukvara..nn.1
  mjukvarupaket_1_N = mkN "mjukvarupaket" neutrum  ; -- mjukvarupaket..nn.1
  mjukvaruprogram_1_N = mkN "mjukvaruprogram" "mjukvaruprogrammet" "mjukvaruprogram" "mjukvaruprogrammen" ; -- mjukvaruprogram..nn.1
  mjukvarusystem_1_N = mkN "mjukvarusystem" neutrum  ; -- mjukvarusystem..nn.1
  mjukvävnad_1_N = mkN "mjukvävnad" "mjukvävnader" ; -- mjukvävnad..nn.1
  mjäkig_1_A = mkA "mjäkig" ; -- mjäkig..av.1
  mjäkighet_1_N = mkN "mjäkighet" ; -- mjäkighet..nn.1
  mjäla_1_N = mkN "mjäla" ; -- mjäla..nn.1
  mjäll_1_A = mkA "mjäll" ; -- mjäll..av.1
  mjäll_1_N = mkN "mjäll" ; -- mjäll..nn.1
  mjällhet_1_N = mkN "mjällhet" ; -- mjällhet..nn.1
  mjällig_1_A = mkA "mjällig" ; -- mjällig..av.1
  mjällighet_1_N = mkN "mjällighet" ; -- mjällighet..nn.1
  mjällschampo_1_N = mkN "mjällschampo" "mjällschampot" "mjällschampon" "mjällschampona" ; -- mjällschampo..nn.1
  mjältbrand_1_N = mkN "mjältbrand" ; -- mjältbrand..nn.1
  mjälte_1_N = mkN "mjälte" utrum  ; -- mjälte..nn.1
  mjälthugg_1_N = mkN "mjälthugg" neutrum  ; -- mjälthugg..nn.1
  mjältsjuk_1_A = mkA "mjältsjuk" ; -- mjältsjuk..av.1
  mjältsjuka_1_N = mkN "mjältsjuka" ; -- mjältsjuka..nn.1
  mjältsjukhet_1_N = mkN "mjältsjukhet" ; -- mjältsjukhet..nn.1
  mjärde_1_N = mkN "mjärde" utrum  ; -- mjärde..nn.1
  mjöd_1_N = mkN "mjöd" neutrum  ; -- mjöd..nn.1
  mjöl_1_N = mkN "mjöl" "mjölet" "mjöler" "mjölerna" ; -- mjöl..nn.1
  mjöla_1_V = mkV "mjölar" ; -- mjöla..vb.1
  mjölande_1_N = mkN "mjölande" ; -- mjölande..nn.1
  mjölbagge_1_N = mkN "mjölbagge" utrum  ; -- mjölbagge..nn.1
  mjöldagg_1_N = mkN "mjöldagg" ; -- mjöldagg..nn.1
  mjöldamm_1_N = mkN "mjöldamm" neutrum  ; -- mjöldamm..nn.1
  mjöldryga_1_N = mkN "mjöldryga" ; -- mjöldryga..nn.1
  mjölig_1_A = mkA "mjölig" ; -- mjölig..av.1
  mjölighet_1_N = mkN "mjölighet" ; -- mjölighet..nn.1
  mjölk_1_N = mkN "mjölk" ; -- mjölk..nn.1
  mjölka_1_V = mkV "mjölkar" ; -- mjölka..vb.1
  mjölkaffär_1_N = mkN "mjölkaffär" "mjölkaffärer" ; -- mjölkaffär..nn.1
  mjölkaktig_1_A = mkA "mjölkaktig" ; -- mjölkaktig..av.1
  mjölkaktighet_1_N = mkN "mjölkaktighet" ; -- mjölkaktighet..nn.1
  mjölkallergi_1_N = mkN "mjölkallergi" "mjölkallergier" ; -- mjölkallergi..nn.1
  mjölkande_1_N = mkN "mjölkande" ; -- mjölkande..nn.1
  mjölkare_1_N = mkN "mjölkare" utrum  ; -- mjölkare..nn.1
  mjölkartad_1_A = mkA "mjölkartad" ; -- mjölkartad..av.1
  mjölkbar_1_N = mkN "mjölkbar" "mjölkbarer" ; -- mjölkbar..nn.1
  mjölkbildande_1_A = mkA "mjölkbildande" ; -- mjölkbildande..av.1
  mjölkbonde_1_N = mkN "mjölkbonde" "mjölkbönder" ; -- mjölkbonde..nn.1
  mjölkboskap_1_N = mkN "mjölkboskap" ; -- mjölkboskap..nn.1
  mjölkbud_1_N = mkN "mjölkbud" neutrum  ; -- mjölkbud..nn.1
  mjölkcell_1_N = mkN "mjölkcell" "mjölkceller" ; -- mjölkcell..nn.1
  mjölkcentral_1_N = mkN "mjölkcentral" "mjölkcentraler" ; -- mjölkcentral..nn.1
  mjölkchoklad_1_N = mkN "mjölkchoklad" ; -- mjölkchoklad..nn.1
  mjölke_1_N = mkN "mjölke" utrum  ; -- mjölke..nn.1
  mjölkfeber_1_N = mkN "mjölkfeber" ; -- mjölkfeber..nn.1
  mjölkfett_1_N = mkN "mjölkfett" neutrum  ; -- mjölkfett..nn.1
  mjölkflytning_1_N = mkN "mjölkflytning" ; -- mjölkflytning..nn.1
  mjölkflöde_1_N = mkN "mjölkflöde" ; -- mjölkflöde..nn.1
  mjölkfärgad_1_A = mkA "mjölkfärgad" ; -- mjölkfärgad..av.1
  mjölkförpackning_1_N = mkN "mjölkförpackning" ; -- mjölkförpackning..nn.1
  mjölkglas_1_N = mkN "mjölkglas" neutrum  ; -- mjölkglas..nn.1
  mjölkgrymt_1_N = mkN "mjölkgrymt" neutrum  ; -- mjölkgrymt..nn.1
  mjölkgrymtning_1_N = mkN "mjölkgrymtning" ; -- mjölkgrymtning..nn.1
  mjölkgång_1_N = mkN "mjölkgång" ; -- mjölkgång..nn.1
  mjölkhink_1_N = mkN "mjölkhink" ; -- mjölkhink..nn.1
  mjölkig_1_A = mkA "mjölkig" ; -- mjölkig..av.1
  mjölkighet_1_N = mkN "mjölkighet" ; -- mjölkighet..nn.1
  mjölkkanal_1_N = mkN "mjölkkanal" "mjölkkanaler" ; -- mjölkkanal..nn.1
  mjölkko_1_N = mkN "mjölkko" "mjölkkor" ; -- mjölkko..nn.1
  mjölkkossa_1_N = mkN "mjölkkossa" ; -- mjölkkossa..nn.1
  mjölkkärl_1_N = mkN "mjölkkärl" neutrum  ; -- mjölkkärl..nn.1
  mjölkkörtel_1_N = mkN "mjölkkörtel" ; -- mjölkkörtel..nn.1
  mjölkmage_1_N = mkN "mjölkmage" utrum  ; -- mjölkmage..nn.1
  mjölkpaket_1_N = mkN "mjölkpaket" neutrum  ; -- mjölkpaket..nn.1
  mjölkpall_1_N = mkN "mjölkpall" ; -- mjölkpall..nn.1
  mjölkproducent_1_N = mkN "mjölkproducent" "mjölkproducenter" ; -- mjölkproducent..nn.1
  mjölkprodukt_1_N = mkN "mjölkprodukt" "mjölkprodukter" ; -- mjölkprodukt..nn.1
  mjölkproduktion_1_N = mkN "mjölkproduktion" ; -- mjölkproduktion..nn.1
  mjölksaft_1_N = mkN "mjölksaft" "mjölksafter" ; -- mjölksaft..nn.1
  mjölkskandal_1_N = mkN "mjölkskandal" "mjölkskandaler" ; -- mjölkskandal..nn.1
  mjölkskorv_1_N = mkN "mjölkskorv" ; -- mjölkskorv..nn.1
  mjölksocker_1_N = mkN "mjölksocker" neutrum  ; -- mjölksocker..nn.1
  mjölkspann_1_N = mkN "mjölkspann" neutrum  ; -- mjölkspann..nn.1
  mjölkspegel_1_N = mkN "mjölkspegel" ; -- mjölkspegel..nn.1
  mjölkstinn_1_A = mkA "mjölkstinn" "mjölkstint" ; -- mjölkstinn..av.1
  mjölkstinnhet_1_N = mkN "mjölkstinnhet" ; -- mjölkstinnhet..nn.1
  mjölkstockning_1_N = mkN "mjölkstockning" ; -- mjölkstockning..nn.1
  mjölksvullen_1_A = mkA "mjölksvullen" ; -- mjölksvullen..av.1
  mjölksvullenhet_1_N = mkN "mjölksvullenhet" ; -- mjölksvullenhet..nn.1
  mjölksyra_1_N = mkN "mjölksyra" ; -- mjölksyra..nn.1
  mjölksyraförgiftning_1_N = mkN "mjölksyraförgiftning" ; -- mjölksyraförgiftning..nn.1
  mjölksyrebakterie_1_N = mkN "mjölksyrebakterie" "mjölksyrebakterier" ; -- mjölksyrebakterie..nn.1
  mjölktand_1_N = mkN "mjölktand" "mjölktänder" ; -- mjölktand..nn.1
  mjölktetra_1_N = mkN "mjölktetra" ; -- mjölktetra..nn.1
  mjölkvit_1_A = mkA "mjölkvit" ; -- mjölkvit..av.1
  mjölkåder_1_N = mkN "mjölkådra" ; -- mjölkåder..nn.1
  mjölkört_1_N = mkN "mjölkört" "mjölkörter" ; -- mjölkört..nn.1
  mjölköverskott_1_N = mkN "mjölköverskott" neutrum  ; -- mjölköverskott..nn.1
  mjölnare_1_N = mkN "mjölnare" utrum  ; -- mjölnare..nn.1
  mjölnarmatte_1_N = mkN "mjölnarmatte" ; -- mjölnarmatte..nn.1
  mjölon_1_N = mkN "mjölon" neutrum  ; -- mjölon..nn.1
  mjölpåse_1_N = mkN "mjölpåse" utrum  ; -- mjölpåse..nn.1
  mjölskivling_1_N = mkN "mjölskivling" ; -- mjölskivling..nn.1
  mnemonik_1_N = mkN "mnemonik" ; -- mnemonik..nn.1
  mnemonisk_1_A = mkA "mnemonisk" ; -- mnemonisk..av.1
  mnemoteknik_1_N = mkN "mnemoteknik" ; -- mnemoteknik..nn.1
  mnemoteknisk_1_A = mkA "mnemoteknisk" ; -- mnemoteknisk..av.1
  mo_1_N = mkN "mo" ; -- mo..nn.1
  moaré_1_N = mkN "moaré" "moaréer" ; -- moaré..nn.1
  moatjé_1_N = mkN "moatjé" "moatjéer" ; -- moatjé..nn.1
  mobb_1_N = mkN "mobb" ; -- mobb..nn.1
  mobba_1_V = mkV "mobbar" ; -- mobba..vb.1
  mobbande_1_N = mkN "mobbande" ; -- mobbande..nn.1
  mobbing_1_N = mkN "mobbing" ; -- mobbing..nn.1
  mobbning_1_N = mkN "mobbning" ; -- mobbning..nn.1
  mobbningskampanj_1_N = mkN "mobbningskampanj" "mobbningskampanjer" ; -- mobbningskampanj..nn.1
  mobboffer_1_N = mkN "mobboffer" neutrum  ; -- mobboffer..nn.1
  mobil_1_A = mkA "mobil" ; -- mobil..av.1
  mobil_1_N = mkN "mobil" "mobiler" ; -- mobil..nn.1
  mobilabonnemang_1_N = mkN "mobilabonnemang" neutrum  ; -- mobilabonnemang..nn.1
  mobilabonnemangsförsäljare_1_N = mkN "mobilabonnemangsförsäljare" utrum  ; -- mobilabonnemangsförsäljare..nn.1
  mobilberoende_1_A = mkA "mobilberoende" ; -- mobilberoende..av.1
  mobilberoende_1_N = mkN "mobilberoende" ; -- mobilberoende..nn.1
  mobilblogga_1_V = mkV "mobilbloggar" ; -- mobilblogga..vb.1
  mobilbloggande_1_N = mkN "mobilbloggande" ; -- mobilbloggande..nn.1
  mobilbloggning_1_N = mkN "mobilbloggning" ; -- mobilbloggning..nn.1
  mobilförsäljning_1_N = mkN "mobilförsäljning" ; -- mobilförsäljning..nn.1
  mobilisera_1_V = mkV "mobiliserar" ; -- mobilisera..vb.1
  mobiliserande_1_N = mkN "mobiliserande" ; -- mobiliserande..nn.1
  mobiliserbar_1_A = mkA "mobiliserbar" ; -- mobiliserbar..av.1
  mobiliserbarhet_1_N = mkN "mobiliserbarhet" ; -- mobiliserbarhet..nn.1
  mobilisering_1_N = mkN "mobilisering" ; -- mobilisering..nn.1
  mobiliseringsplats_1_N = mkN "mobiliseringsplats" "mobiliseringsplatser" ; -- mobiliseringsplats..nn.1
  mobilitet_1_N = mkN "mobilitet" "mobiliteter" ; -- mobilitet..nn.1
  mobilladdare_1_N = mkN "mobilladdare" utrum  ; -- mobilladdare..nn.1
  mobilmissbruk_1_N = mkN "mobilmissbruk" neutrum  ; -- mobilmissbruk..nn.1
  mobilmodem_1_N = mkN "mobilmodem" neutrum  ; -- mobilmodem..nn.1
  mobiloperatör_1_N = mkN "mobiloperatör" "mobiloperatörer" ; -- mobiloperatör..nn.1
  mobilprat_1_N = mkN "mobilprat" neutrum  ; -- mobilprat..nn.1
  mobilpratande_1_N = mkN "mobilpratande" ; -- mobilpratande..nn.1
  mobilräkning_1_N = mkN "mobilräkning" ; -- mobilräkning..nn.1
  mobilsamtal_1_N = mkN "mobilsamtal" neutrum  ; -- mobilsamtal..nn.1
  mobilskugga_1_N = mkN "mobilskugga" ; -- mobilskugga..nn.1
  mobilskuld_1_N = mkN "mobilskuld" "mobilskulder" ; -- mobilskuld..nn.1
  mobiltelefon_1_N = mkN "mobiltelefon" "mobiltelefoner" ; -- mobiltelefon..nn.1
  mobiltelefoni_1_N = mkN "mobiltelefoni" ; -- mobiltelefoni..nn.1
  mobiltäckning_1_N = mkN "mobiltäckning" ; -- mobiltäckning..nn.1
  mobilvirus_1_N = mkN "mobilvirus" neutrum  ; -- mobilvirus..nn.1
  mocambikier_1_N = mkN "mocambikier" "mocambikiern" "mocambikier" "mocambikierna" ; -- mocambikier..nn.1
  mocambikisk_1_A = mkA "mocambikisk" ; -- mocambikisk..av.1
  mocka_1_N = mkN "mocka" ; -- mocka..nn.1
  mocka_1_V = mkV "mockar" ; -- mocka..vb.1
  mockakaffe_1_N = mkN "mockakaffe" ; -- mockakaffe..nn.1
  mockakopp_1_N = mkN "mockakopp" ; -- mockakopp..nn.1
  mockaliknande_1_A = mkA "mockaliknande" ; -- mockaliknande..av.1
  mockande_1_N = mkN "mockande" ; -- mockande..nn.1
  mockasin_1_N = mkN "mockasin" "mockasiner" ; -- mockasin..nn.1
  mockasinformad_1_A = mkA "mockasinformad" ; -- mockasinformad..av.1
  mockasked_1_N = mkN "mockasked" ; -- mockasked..nn.1
  mod_1_N = mkN "mod" neutrum  ; -- mod..nn.1
  modal_1_A = mkA "modal" ; -- modal..av.1
  modalitet_1_N = mkN "modalitet" "modaliteter" ; -- modalitet..nn.1
  modallogik_1_N = mkN "modallogik" ; -- modallogik..nn.1
  modd_1_N = mkN "modd" ; -- modd..nn.1
  moddig_1_A = mkA "moddig" ; -- moddig..av.1
  moddlare_1_N = mkN "moddlare" utrum  ; -- moddlare..nn.1
  mode_1_N = mkN "mode" ; -- mode..nn.1
  modeaffär_1_N = mkN "modeaffär" "modeaffärer" ; -- modeaffär..nn.1
  modeateljé_1_N = mkN "modeateljé" "modeateljéer" ; -- modeateljé..nn.1
  modebutik_1_N = mkN "modebutik" "modebutiker" ; -- modebutik..nn.1
  modedocka_1_N = mkN "modedocka" ; -- modedocka..nn.1
  modegrej_1_N = mkN "modegrej" "modegrejor" ; -- modegrej..nn.1
  modehus_1_N = mkN "modehus" neutrum  ; -- modehus..nn.1
  modeintresserad_1_A = mkA "modeintresserad" ; -- modeintresserad..av.1
  modejournal_1_N = mkN "modejournal" "modejournaler" ; -- modejournal..nn.1
  modekarriär_1_N = mkN "modekarriär" "modekarriärer" ; -- modekarriär..nn.1
  modekedja_1_N = mkN "modekedja" ; -- modekedja..nn.1
  modelejon_1_N = mkN "modelejon" neutrum  ; -- modelejon..nn.1
  modelinje_1_N = mkN "modelinje" "modelinjer" ; -- modelinje..nn.1
  modell_1_N = mkN "modell" "modeller" ; -- modell..nn.1
  modellberäkning_1_N = mkN "modellberäkning" ; -- modellberäkning..nn.1
  modellbygge_1_N = mkN "modellbygge" ; -- modellbygge..nn.1
  modellera_1_N = mkN "modellera" ; -- modellera..nn.1
  modellera_1_V = mkV "modellerar" ; -- modellera..vb.1
  modellerad_1_A = mkA "modellerad" ; -- modellerad..av.1
  modellerande_1_N = mkN "modellerande" ; -- modellerande..nn.1
  modellerbar_1_A = mkA "modellerbar" ; -- modellerbar..av.1
  modellerbarhet_1_N = mkN "modellerbarhet" ; -- modellerbarhet..nn.1
  modellering_1_N = mkN "modellering" ; -- modellering..nn.1
  modellflygplan_1_N = mkN "modellflygplan" neutrum  ; -- modellflygplan..nn.1
  modellförsök_1_N = mkN "modellförsök" neutrum  ; -- modellförsök..nn.1
  modelljärnväg_1_N = mkN "modelljärnväg" ; -- modelljärnväg..nn.1
  modellkarriär_1_N = mkN "modellkarriär" "modellkarriärer" ; -- modellkarriär..nn.1
  modellplan_1_N = mkN "modellplan" neutrum  ; -- modellplan..nn.1
  modellstudie_1_N = mkN "modellstudie" "modellstudier" ; -- modellstudie..nn.1
  modem_1_N = mkN "modem" neutrum  ; -- modem..nn.1
  modemagasin_1_N = mkN "modemagasin" neutrum  ; -- modemagasin..nn.1
  modemedveten_1_A = mkA "modemedveten" ; -- modemedveten..av.1
  modemässig_1_A = mkA "modemässig" ; -- modemässig..av.1
  modenyck_1_N = mkN "modenyck" "modenycker" ; -- modenyck..nn.1
  modeord_1_N = mkN "modeord" neutrum  ; -- modeord..nn.1
  modepryl_1_N = mkN "modepryl" ; -- modepryl..nn.1
  moder_1_N = mkN "moder" "modern" "mödrar" "mödrarna" ; -- moder..nn.1
  moderat_1_A = mkA "moderat" "moderat" ; -- moderat..av.1
  moderat_1_N = mkN "moderat" "moderater" ; -- moderat..nn.1
  moderation_1_N = mkN "moderation" ; -- moderation..nn.1
  moderatledare_1_N = mkN "moderatledare" utrum  ; -- moderatledare..nn.1
  moderator_1_N = mkN "moderator" "moderatorer" ; -- moderator..nn.1
  moderatpolitiker_1_N = mkN "moderatpolitiker" "moderatpolitikern" "moderatpolitiker" "moderatpolitikerna" ; -- moderatpolitiker..nn.1
  moderbolag_1_N = mkN "moderbolag" neutrum  ; -- moderbolag..nn.1
  modercell_1_N = mkN "modercell" "moderceller" ; -- modercell..nn.1
  moderera_1_V = mkV "modererar" ; -- moderera..vb.1
  modererande_1_N = mkN "modererande" ; -- modererande..nn.1
  modererbar_1_A = mkA "modererbar" ; -- modererbar..av.1
  modererbarhet_1_N = mkN "modererbarhet" ; -- modererbarhet..nn.1
  moderering_1_N = mkN "moderering" ; -- moderering..nn.1
  moderföretag_1_N = mkN "moderföretag" neutrum  ; -- moderföretag..nn.1
  moderiktig_1_A = mkA "moderiktig" ; -- moderiktig..av.1
  moderiktighet_1_N = mkN "moderiktighet" ; -- moderiktighet..nn.1
  moderkaka_1_N = mkN "moderkaka" ; -- moderkaka..nn.1
  moderklubb_1_N = mkN "moderklubb" ; -- moderklubb..nn.1
  moderkort_1_N = mkN "moderkort" neutrum  ; -- moderkort..nn.1
  moderland_1_N = mkN "moderland" "moderlandet" "moderländer" "moderländerna" ; -- moderland..nn.1
  moderlig_1_A = mkA "moderlig" ; -- moderlig..av.1
  moderlighet_1_N = mkN "moderlighet" ; -- moderlighet..nn.1
  moderliv_1_N = mkN "moderliv" neutrum  ; -- moderliv..nn.1
  moderlut_1_N = mkN "moderlut" ; -- moderlut..nn.1
  moderlös_1_A = mkA "moderlös" ; -- moderlös..av.1
  modermord_1_N = mkN "modermord" neutrum  ; -- modermord..nn.1
  modermun_1_N = mkN "modermun" "modermunnen" "modermunnar" "modermunnarna" ; -- modermun..nn.1
  modermördare_1_N = mkN "modermördare" utrum  ; -- modermördare..nn.1
  modern_1_A = mkA "modern" ; -- modern..av.1
  modernisera_1_V = mkV "moderniserar" ; -- modernisera..vb.1
  moderniserande_1_N = mkN "moderniserande" ; -- moderniserande..nn.1
  moderniserbar_1_A = mkA "moderniserbar" ; -- moderniserbar..av.1
  moderniserbarhet_1_N = mkN "moderniserbarhet" ; -- moderniserbarhet..nn.1
  modernisering_1_N = mkN "modernisering" ; -- modernisering..nn.1
  moderniseringsagenda_1_N = mkN "moderniseringsagenda" ; -- moderniseringsagenda..nn.1
  moderniseringsprogram_1_N = mkN "moderniseringsprogram" "moderniseringsprogrammet" "moderniseringsprogram" "moderniseringsprogrammen" ; -- moderniseringsprogram..nn.1
  moderniseringsprojekt_1_N = mkN "moderniseringsprojekt" neutrum  ; -- moderniseringsprojekt..nn.1
  moderniseringsreform_1_N = mkN "moderniseringsreform" "moderniseringsreformer" ; -- moderniseringsreform..nn.1
  modernism_1_N = mkN "modernism" "modernismer" ; -- modernism..nn.1
  modernist_1_N = mkN "modernist" "modernister" ; -- modernist..nn.1
  modernistisk_1_A = mkA "modernistisk" ; -- modernistisk..av.1
  modernitet_1_N = mkN "modernitet" "moderniteter" ; -- modernitet..nn.1
  modernitetsideal_1_N = mkN "modernitetsideal" neutrum  ; -- modernitetsideal..nn.1
  modernäring_1_N = mkN "modernäring" ; -- modernäring..nn.1
  moderrätt_1_N = mkN "moderrätt" ; -- moderrätt..nn.1
  modersfamn_1_N = mkN "modersfamn" ; -- modersfamn..nn.1
  modersgestalt_1_N = mkN "modersgestalt" "modersgestalter" ; -- modersgestalt..nn.1
  modersglädje_1_N = mkN "modersglädje" utrum  ; -- modersglädje..nn.1
  modershjärta_1_N = mkN "modershjärta" "modershjärtat" "modershjärtan" "modershjärtana" ; -- modershjärta..nn.1
  moderskap_1_N = mkN "moderskap" neutrum  ; -- moderskap..nn.1
  moderskepp_1_N = mkN "moderskepp" neutrum  ; -- moderskepp..nn.1
  moderskänsla_1_N = mkN "moderskänsla" ; -- moderskänsla..nn.1
  moderskärlek_1_N = mkN "moderskärlek" ; -- moderskärlek..nn.1
  modersmjölk_1_N = mkN "modersmjölk" ; -- modersmjölk..nn.1
  modersmål_1_N = mkN "modersmål" neutrum  ; -- modersmål..nn.1
  modersmålstalare_1_N = mkN "modersmålstalare" utrum  ; -- modersmålstalare..nn.1
  modersplikt_1_N = mkN "modersplikt" "modersplikter" ; -- modersplikt..nn.1
  moderssköte_1_N = mkN "moderssköte" ; -- moderssköte..nn.1
  moderstjärna_1_N = mkN "moderstjärna" ; -- moderstjärna..nn.1
  modesak_1_N = mkN "modesak" "modesaker" ; -- modesak..nn.1
  modeskapare_1_N = mkN "modeskapare" utrum  ; -- modeskapare..nn.1
  modest_1_A = mkA "modest" "modest" ; -- modest..av.1
  modesthet_1_N = mkN "modesthet" ; -- modesthet..nn.1
  modetidning_1_N = mkN "modetidning" ; -- modetidning..nn.1
  modeuppvisning_1_N = mkN "modeuppvisning" ; -- modeuppvisning..nn.1
  modevara_1_N = mkN "modevara" ; -- modevara..nn.1
  modevisning_1_N = mkN "modevisning" ; -- modevisning..nn.1
  modevärld_1_N = mkN "modevärld" ; -- modevärld..nn.1
  modfälld_1_A = mkA "modfälld" "modfällt" ; -- modfälld..av.1
  modfälldhet_1_N = mkN "modfälldhet" ; -- modfälldhet..nn.1
  modifiera_1_V = mkV "modifierar" ; -- modifiera..vb.1
  modifierande_1_N = mkN "modifierande" ; -- modifierande..nn.1
  modifierbar_1_A = mkA "modifierbar" ; -- modifierbar..av.1
  modifierbarhet_1_N = mkN "modifierbarhet" ; -- modifierbarhet..nn.1
  modifiering_1_N = mkN "modifiering" ; -- modifiering..nn.1
  modifikation_1_N = mkN "modifikation" ; -- modifikation..nn.1
  modig_1_A = mkA "modig" ; -- modig..av.1
  modist_1_N = mkN "modist" "modister" ; -- modist..nn.1
  modlös_1_A = mkA "modlös" ; -- modlös..av.1
  modlöshet_1_N = mkN "modlöshet" ; -- modlöshet..nn.1
  mods_1_N = mkN "mods" neutrum  ; -- mods..nn.1
  modslagen_1_A = mkA "modslagen" ; -- modslagen..av.1
  modslagenhet_1_N = mkN "modslagenhet" ; -- modslagenhet..nn.1
  modstulen_1_A = mkA "modstulen" ; -- modstulen..av.1
  modstulenhet_1_N = mkN "modstulenhet" ; -- modstulenhet..nn.1
  modul_1_N = mkN "modul" "moduler" ; -- modul..nn.1
  modulation_1_N = mkN "modulation" ; -- modulation..nn.1
  modulator_1_N = mkN "modulator" "modulatorer" ; -- modulator..nn.1
  modulera_1_V = mkV "modulerar" ; -- modulera..vb.1
  modulerande_1_N = mkN "modulerande" ; -- modulerande..nn.1
  modulerbar_1_A = mkA "modulerbar" ; -- modulerbar..av.1
  modulerbarhet_1_N = mkN "modulerbarhet" ; -- modulerbarhet..nn.1
  modulering_1_N = mkN "modulering" ; -- modulering..nn.1
  modulsystem_1_N = mkN "modulsystem" neutrum  ; -- modulsystem..nn.1
  modus_1_N = mkN "modus" neutrum  ; -- modus..nn.1
  modärn_1_A = mkA "modärn" ; -- modärn..av.1
  modärnisera_1_V = mkV "modärniserar" ; -- modärnisera..vb.1
  modärniserande_1_N = mkN "modärniserande" ; -- modärniserande..nn.1
  modärniserbar_1_A = mkA "modärniserbar" ; -- modärniserbar..av.1
  modärniserbarhet_1_N = mkN "modärniserbarhet" ; -- modärniserbarhet..nn.1
  modärnisering_1_N = mkN "modärnisering" ; -- modärnisering..nn.1
  moffa_1_N = mkN "moffa" ; -- moffa..nn.1
  moffa_1_V = mkV "moffar" ; -- moffa..vb.1
  moffande_1_N = mkN "moffande" ; -- moffande..nn.1
  moffande_2_N = mkN "moffande" ; -- moffande..nn.2
  moffning_1_N = mkN "moffning" ; -- moffning..nn.1
  moffning_2_N = mkN "moffning" ; -- moffning..nn.2
  mogen_1_A = mkA "mogen" ; -- mogen..av.1
  mogenhet_1_N = mkN "mogenhet" "mogenheter" ; -- mogenhet..nn.1
  mogenhetsexamen_1_N = mkN "mogenhetsexamen" "mogenhetsexamen" "mogenhetsexamina" "mogenhetsexamina" ; -- mogenhetsexamen..nn.1
  mogna_1_V = mkV "mognar" ; -- mogna..vb.1
  mognad_1_N = mkN "mognad" ; -- mognad..nn.1
  mognande_1_N = mkN "mognande" ; -- mognande..nn.1
  mogul_1_N = mkN "mogul" "moguln" "moguler" "mogulerna" ; -- mogul..nn.1
  mohair_1_N = mkN "mohair" ; -- mohair..nn.1
  mohammedan_1_N = mkN "mohammedan" "mohammedaner" ; -- mohammedan..nn.1
  mohammedanism_1_N = mkN "mohammedanism" "mohammedanismer" ; -- mohammedanism..nn.1
  mohammedansk_1_A = mkA "mohammedansk" ; -- mohammedansk..av.1
  mohikan_1_N = mkN "mohikan" "mohikaner" ; -- mohikan..nn.1
  mohär_1_N = mkN "mohär" ; -- mohär..nn.1
  moj_1_A = mkA "moj" ; -- moj..av.1
  moj_1_N = mkN "moj" neutrum  ; -- moj..nn.1
  moj_2_N = mkN "moj" ; -- moj..nn.2
  mojhet_1_N = mkN "mojhet" ; -- mojhet..nn.1
  mojna_1_V = mkV "mojnar" ; -- mojna..vb.1
  mojnande_1_N = mkN "mojnande" ; -- mojnande..nn.1
  mojs_1_N = mkN "mojs" neutrum  ; -- mojs..nn.1
  mojäng_1_N = mkN "mojäng" "mojänger" ; -- mojäng..nn.1
  mokare_1_N = mkN "mokare" utrum  ; -- mokare..nn.1
  mol_1_N = mkN "mol" ; -- mol..nn.1
  mola_1_V = mkV "molar" ; -- mola..vb.1
  molande_1_N = mkN "molande" ; -- molande..nn.1
  molar_1_N = mkN "molar" "molarer" ; -- molar..nn.1
  molaritet_1_N = mkN "molaritet" "molariteter" ; -- molaritet..nn.1
  moldavier_1_N = mkN "moldavier" "moldaviern" "moldavier" "moldavierna" ; -- moldavier..nn.1
  moldavisk_1_A = mkA "moldavisk" ; -- moldavisk..av.1
  moldaviska_1_N = mkN "moldaviska" ; -- moldaviska..nn.1
  moldaviska_2_N = mkN "moldaviska" ; -- moldaviska..nn.2
  molekyl_1_N = mkN "molekyl" "molekyler" ; -- molekyl..nn.1
  molekylarattraktion_1_N = mkN "molekylarattraktion" ; -- molekylarattraktion..nn.1
  molekylarkraft_1_N = mkN "molekylarkraft" "molekylarkrafter" ; -- molekylarkraft..nn.1
  molekylkedja_1_N = mkN "molekylkedja" ; -- molekylkedja..nn.1
  molekylvikt_1_N = mkN "molekylvikt" "molekylvikter" ; -- molekylvikt..nn.1
  molekylär_1_A = mkA "molekylär" ; -- molekylär..av.1
  molekylärbiolog_1_N = mkN "molekylärbiolog" "molekylärbiologer" ; -- molekylärbiolog..nn.1
  molekylärbiologi_1_N = mkN "molekylärbiologi" ; -- molekylärbiologi..nn.1
  molekylärgenetisk_1_A = mkA "molekylärgenetisk" ; -- molekylärgenetisk..av.1
  moll_1_N = mkN "moll" ; -- moll..nn.1
  mollackord_1_N = mkN "mollackord" neutrum  ; -- mollackord..nn.1
  mollskinn_1_N = mkN "mollskinn" neutrum  ; -- mollskinn..nn.1
  mollstämd_1_A = mkA "mollstämd" "mollstämt" ; -- mollstämd..av.1
  mollstämdhet_1_N = mkN "mollstämdhet" ; -- mollstämdhet..nn.1
  mollton_1_N = mkN "mollton" "molltoner" ; -- mollton..nn.1
  molltonart_1_N = mkN "molltonart" "molltonarter" ; -- molltonart..nn.1
  mollusk_1_N = mkN "mollusk" "mollusker" ; -- mollusk..nn.1
  moln_1_N = mkN "moln" neutrum  ; -- moln..nn.1
  molnbank_1_N = mkN "molnbank" ; -- molnbank..nn.1
  molnbildning_1_N = mkN "molnbildning" ; -- molnbildning..nn.1
  molnfläck_1_N = mkN "molnfläck" ; -- molnfläck..nn.1
  molnformation_1_N = mkN "molnformation" ; -- molnformation..nn.1
  molnfri_1_A = mkA "molnfri" "molnfritt" ; -- molnfri..av.1
  molngubbe_1_N = mkN "molngubbe" utrum  ; -- molngubbe..nn.1
  molnhop_1_N = mkN "molnhop" ; -- molnhop..nn.1
  molnhöjd_1_N = mkN "molnhöjd" "molnhöjder" ; -- molnhöjd..nn.1
  molnhöljd_1_A = mkA "molnhöljd" "molnhöljt" ; -- molnhöljd..av.1
  molnhölje_1_N = mkN "molnhölje" ; -- molnhölje..nn.1
  molnig_1_A = mkA "molnig" ; -- molnig..av.1
  molnighet_1_N = mkN "molnighet" "molnigheter" ; -- molnighet..nn.1
  molnkant_1_N = mkN "molnkant" "molnkanter" ; -- molnkant..nn.1
  molnmassa_1_N = mkN "molnmassa" ; -- molnmassa..nn.1
  molnrest_1_N = mkN "molnrest" "molnrester" ; -- molnrest..nn.1
  molnrulle_1_N = mkN "molnrulle" utrum  ; -- molnrulle..nn.1
  molnsky_1_N = mkN "molnsky" "molnskyn" "molnskyar" "molnskyarna" ; -- molnsky..nn.1
  molnstod_1_N = mkN "molnstod" "molnstoder" ; -- molnstod..nn.1
  molnstrimma_1_N = mkN "molnstrimma" ; -- molnstrimma..nn.1
  molntapp_1_N = mkN "molntapp" ; -- molntapp..nn.1
  molntott_1_N = mkN "molntott" ; -- molntott..nn.1
  molntäcke_1_N = mkN "molntäcke" ; -- molntäcke..nn.1
  molnvägg_1_N = mkN "molnvägg" ; -- molnvägg..nn.1
  molo_1_N = mkN "molo" "molon" "moloer" "moloerna" ; -- molo..nn.1
  molohamn_1_N = mkN "molohamn" ; -- molohamn..nn.1
  molok_1_N = mkN "molok" ; -- molok..nn.1
  moloken_1_A = mkA "moloken" ; -- moloken..av.1
  molokenhet_1_N = mkN "molokenhet" ; -- molokenhet..nn.1
  molotovcocktail_1_N = mkN "molotovcocktail" ; -- molotovcocktail..nn.1
  moltiga_1_V = mkV "moltiga" "molteg" "moltigit" ; -- moltiga..vb.1
  moltigande_1_N = mkN "moltigande" ; -- moltigande..nn.1
  moltyst_1_A = mkA "moltyst" "moltyst" ; -- moltyst..av.1
  molvärk_1_N = mkN "molvärk" ; -- molvärk..nn.1
  molvärka_1_V = mkV "molvärker" ; -- molvärka..vb.1
  molvärkande_1_N = mkN "molvärkande" ; -- molvärkande..nn.1
  molybden_1_N = mkN "molybden" neutrum  ; -- molybden..nn.1
  molybdenglans_1_N = mkN "molybdenglans" ; -- molybdenglans..nn.1
  momang_1_N = mkN "momang" "momanger" ; -- momang..nn.1
  moment_1_N = mkN "moment" neutrum  ; -- moment..nn.1
  momentan_1_A = mkA "momentan" ; -- momentan..av.1
  momentnyckel_1_N = mkN "momentnyckel" ; -- momentnyckel..nn.1
  mommo_1_N = mkN "mommo" ; -- mommo..nn.1
  moms_1_N = mkN "moms" ; -- moms..nn.1
  momsredovisa_1_V = mkV "momsredovisar" ; -- momsredovisa..vb.1
  momsredovisande_1_N = mkN "momsredovisande" ; -- momsredovisande..nn.1
  momsredovisning_1_N = mkN "momsredovisning" ; -- momsredovisning..nn.1
  monad_1_N = mkN "monad" "monader" ; -- monad..nn.1
  monark_1_N = mkN "monark" "monarker" ; -- monark..nn.1
  monarki_1_N = mkN "monarki" "monarkier" ; -- monarki..nn.1
  monarkisk_1_A = mkA "monarkisk" ; -- monarkisk..av.1
  monarkist_1_N = mkN "monarkist" "monarkister" ; -- monarkist..nn.1
  monarkistisk_1_A = mkA "monarkistisk" ; -- monarkistisk..av.1
  mondial_1_A = mkA "mondial" ; -- mondial..av.1
  mondän_1_A = mkA "mondän" ; -- mondän..av.1
  mondänitet_1_N = mkN "mondänitet" "mondäniteter" ; -- mondänitet..nn.1
  monegask_1_N = mkN "monegask" "monegasker" ; -- monegask..nn.1
  monegaskisk_1_A = mkA "monegaskisk" ; -- monegaskisk..av.1
  monegaskiska_1_N = mkN "monegaskiska" ; -- monegaskiska..nn.1
  monetär_1_A = mkA "monetär" ; -- monetär..av.1
  mongo_1_N = mkN "mongo" "mongot" "mongon" "mongona" ; -- mongo..nn.1
  mongol_1_N = mkN "mongol" "mongoler" ; -- mongol..nn.1
  mongolfläck_1_N = mkN "mongolfläck" ; -- mongolfläck..nn.1
  mongolisk_1_A = mkA "mongolisk" ; -- mongolisk..av.1
  mongoliska_1_N = mkN "mongoliska" ; -- mongoliska..nn.1
  mongolism_1_N = mkN "mongolism" "mongolismer" ; -- mongolism..nn.1
  mongoloid_1_A = mkA "mongoloid" ; -- mongoloid..av.1
  mongolrike_1_N = mkN "mongolrike" ; -- mongolrike..nn.1
  mongolvälde_1_N = mkN "mongolvälde" ; -- mongolvälde..nn.1
  monism_1_N = mkN "monism" "monismer" ; -- monism..nn.1
  monist_1_N = mkN "monist" "monister" ; -- monist..nn.1
  monistisk_1_A = mkA "monistisk" ; -- monistisk..av.1
  monitor_1_N = mkN "monitor" "monitorer" ; -- monitor..nn.1
  monke_1_N = mkN "monke" utrum  ; -- monke..nn.1
  mono_1_N = mkN "mono" ; -- mono..nn.1
  monoaminoxidas_1_N = mkN "monoaminoxidas" "monoaminoxidaser" ; -- monoaminoxidas..nn.1
  monoftong_1_N = mkN "monoftong" "monoftonger" ; -- monoftong..nn.1
  monoftongera_1_V = mkV "monoftongerar" ; -- monoftongera..vb.1
  monoftongerande_1_N = mkN "monoftongerande" ; -- monoftongerande..nn.1
  monoftongerbar_1_A = mkA "monoftongerbar" ; -- monoftongerbar..av.1
  monoftongerbarhet_1_N = mkN "monoftongerbarhet" ; -- monoftongerbarhet..nn.1
  monoftongering_1_N = mkN "monoftongering" ; -- monoftongering..nn.1
  monogam_1_A = mkA "monogam" ; -- monogam..av.1
  monogami_1_N = mkN "monogami" ; -- monogami..nn.1
  monografi_1_N = mkN "monografi" "monografier" ; -- monografi..nn.1
  monogram_1_N = mkN "monogram" "monogrammet" "monogram" "monogrammen" ; -- monogram..nn.1
  monokel_1_N = mkN "monokel" ; -- monokel..nn.1
  monoklin_1_A = mkA "monoklin" ; -- monoklin..av.1
  monokord_1_N = mkN "monokord" neutrum  ; -- monokord..nn.1
  monokotyledon_1_N = mkN "monokotyledon" "monokotyledoner" ; -- monokotyledon..nn.1
  monokrom_1_A = mkA "monokrom" ; -- monokrom..av.1
  monokromatisk_1_A = mkA "monokromatisk" ; -- monokromatisk..av.1
  monokultur_1_N = mkN "monokultur" "monokulturer" ; -- monokultur..nn.1
  monolit_1_N = mkN "monolit" "monoliter" ; -- monolit..nn.1
  monolitisk_1_A = mkA "monolitisk" ; -- monolitisk..av.1
  monolog_1_N = mkN "monolog" "monologer" ; -- monolog..nn.1
  monoman_1_A = mkA "monoman" ; -- monoman..av.1
  monoman_1_N = mkN "monoman" "monomaner" ; -- monoman..nn.1
  monomani_1_N = mkN "monomani" ; -- monomani..nn.1
  monoplan_1_N = mkN "monoplan" neutrum  ; -- monoplan..nn.1
  monopol_1_N = mkN "monopol" neutrum  ; -- monopol..nn.1
  monopol_2_N = mkN "monopol" neutrum  ; -- monopol..nn.2
  monopolisera_1_V = mkV "monopoliserar" ; -- monopolisera..vb.1
  monopoliserande_1_N = mkN "monopoliserande" ; -- monopoliserande..nn.1
  monopoliserbar_1_A = mkA "monopoliserbar" ; -- monopoliserbar..av.1
  monopoliserbarhet_1_N = mkN "monopoliserbarhet" ; -- monopoliserbarhet..nn.1
  monopolisering_1_N = mkN "monopolisering" ; -- monopolisering..nn.1
  monopolism_1_N = mkN "monopolism" "monopolismer" ; -- monopolism..nn.1
  monopolist_1_N = mkN "monopolist" "monopolister" ; -- monopolist..nn.1
  monopolistisk_1_A = mkA "monopolistisk" ; -- monopolistisk..av.1
  monopolkapitalism_1_N = mkN "monopolkapitalism" "monopolkapitalismer" ; -- monopolkapitalism..nn.1
  monopolkapitalistisk_1_A = mkA "monopolkapitalistisk" ; -- monopolkapitalistisk..av.1
  monopolliknande_1_A = mkA "monopolliknande" ; -- monopolliknande..av.1
  monopolställning_1_N = mkN "monopolställning" ; -- monopolställning..nn.1
  monosackarid_1_N = mkN "monosackarid" "monosackarider" ; -- monosackarid..nn.1
  monosyllabisk_1_A = mkA "monosyllabisk" ; -- monosyllabisk..av.1
  monoteism_1_N = mkN "monoteism" "monoteismer" ; -- monoteism..nn.1
  monoteist_1_N = mkN "monoteist" "monoteister" ; -- monoteist..nn.1
  monoteistisk_1_A = mkA "monoteistisk" ; -- monoteistisk..av.1
  monoton_1_A = mkA "monoton" ; -- monoton..av.1
  monotoni_1_N = mkN "monotoni" ; -- monotoni..nn.1
  monotonitet_1_N = mkN "monotonitet" "monotoniteter" ; -- monotonitet..nn.1
  monotoniundvikare_1_N = mkN "monotoniundvikare" utrum  ; -- monotoniundvikare..nn.1
  monotype_1_N = mkN "monotype" "monotyper" ; -- monotype..nn.1
  monseigneur_1_N = mkN "monseigneur" "monseigneurer" ; -- monseigneur..nn.1
  monsieur_1_N = mkN "monsieur" ; -- monsieur..nn.1
  monsignore_1_N = mkN "monsignore" "monsignorer" ; -- monsignore..nn.1
  monster_1_N = mkN "monster" neutrum  ; -- monster..nn.1
  monsterfartyg_1_N = mkN "monsterfartyg" neutrum  ; -- monsterfartyg..nn.1
  monsterkultur_1_N = mkN "monsterkultur" "monsterkulturer" ; -- monsterkultur..nn.1
  monsterstjärna_1_N = mkN "monsterstjärna" ; -- monsterstjärna..nn.1
  monstersvamp_1_N = mkN "monstersvamp" ; -- monstersvamp..nn.1
  monstrans_1_N = mkN "monstrans" "monstranser" ; -- monstrans..nn.1
  monstrositet_1_N = mkN "monstrositet" "monstrositeter" ; -- monstrositet..nn.1
  monstrum_1_N = mkN "monstrum" ; -- monstrum..nn.1
  monstruositet_1_N = mkN "monstruositet" "monstruositeter" ; -- monstruositet..nn.1
  monstruös_1_A = mkA "monstruös" ; -- monstruös..av.1
  monsun_1_N = mkN "monsun" "monsuner" ; -- monsun..nn.1
  monsunkantring_1_N = mkN "monsunkantring" ; -- monsunkantring..nn.1
  monsunvind_1_N = mkN "monsunvind" ; -- monsunvind..nn.1
  montage_1_N = mkN "montage" "montaget" "montage" "montagen" ; -- montage..nn.1
  montagearm_1_N = mkN "montagearm" ; -- montagearm..nn.1
  montenegrin_1_N = mkN "montenegrin" "montenegriner" ; -- montenegrin..nn.1
  montenegrinsk_1_A = mkA "montenegrinsk" ; -- montenegrinsk..av.1
  montenegrinska_1_N = mkN "montenegrinska" ; -- montenegrinska..nn.1
  monter_1_N = mkN "monter" ; -- monter..nn.1
  montera_1_V = mkV "monterar" ; -- montera..vb.1
  monterande_1_N = mkN "monterande" ; -- monterande..nn.1
  monterbar_1_A = mkA "monterbar" ; -- monterbar..av.1
  monterbarhet_1_N = mkN "monterbarhet" ; -- monterbarhet..nn.1
  montering_1_N = mkN "montering" ; -- montering..nn.1
  monteringsanvisning_1_N = mkN "monteringsanvisning" ; -- monteringsanvisning..nn.1
  monteringsfärdig_1_A = mkA "monteringsfärdig" ; -- monteringsfärdig..av.1
  monteringshål_1_N = mkN "monteringshål" neutrum  ; -- monteringshål..nn.1
  monteringsskruv_1_N = mkN "monteringsskruv" ; -- monteringsskruv..nn.1
  monteringstejp_1_N = mkN "monteringstejp" ; -- monteringstejp..nn.1
  montör_1_N = mkN "montör" "montörer" ; -- montör..nn.1
  monument_1_N = mkN "monument" neutrum  ; -- monument..nn.1
  monumental_1_A = mkA "monumental" ; -- monumental..av.1
  monumentalbyggnad_1_N = mkN "monumentalbyggnad" "monumentalbyggnader" ; -- monumentalbyggnad..nn.1
  monumentalitet_1_N = mkN "monumentalitet" "monumentaliteter" ; -- monumentalitet..nn.1
  monumentalkonst_1_N = mkN "monumentalkonst" ; -- monumentalkonst..nn.1
  moped_1_N = mkN "moped" "mopeder" ; -- moped..nn.1
  mopeda_1_V = mkV "mopedar" ; -- mopeda..vb.1
  mopedande_1_N = mkN "mopedande" ; -- mopedande..nn.1
  mopedist_1_N = mkN "mopedist" "mopedister" ; -- mopedist..nn.1
  mopedreparation_1_N = mkN "mopedreparation" ; -- mopedreparation..nn.1
  mopedtrimmare_1_N = mkN "mopedtrimmare" utrum  ; -- mopedtrimmare..nn.1
  mopp_1_N = mkN "mopp" ; -- mopp..nn.1
  moppa_1_V = mkV "moppar" ; -- moppa..vb.1
  moppande_1_N = mkN "moppande" ; -- moppande..nn.1
  moppe_1_N = mkN "moppe" utrum  ; -- moppe..nn.1
  mops_1_N = mkN "mops" ; -- mops..nn.1
  mopsig_1_A = mkA "mopsig" ; -- mopsig..av.1
  mopsighet_1_N = mkN "mopsighet" ; -- mopsighet..nn.1
  mor_unge_konflikt_1_N = mkN "mor-unge-konflikt" "mor-unge-konflikter" ; -- mor-unge-konflikt..nn.1
  mor_1_N = mkN "mor" "modern" "mödrar" "mödrarna" ; -- mor..nn.1
  mor_2_N = mkN "mor" "moren" "morer" "morerna" ; -- mor..nn.2
  mora_1_N = mkN "mora" ; -- mora..nn.1
  moraklocka_1_N = mkN "moraklocka" ; -- moraklocka..nn.1
  morakniv_1_N = mkN "morakniv" ; -- morakniv..nn.1
  moral_1_N = mkN "moral" "moraler" ; -- moral..nn.1
  moralbegrepp_1_N = mkN "moralbegrepp" neutrum  ; -- moralbegrepp..nn.1
  moralfilosofi_1_N = mkN "moralfilosofi" ; -- moralfilosofi..nn.1
  moralisera_1_V = mkV "moraliserar" ; -- moralisera..vb.1
  moraliserande_1_N = mkN "moraliserande" ; -- moraliserande..nn.1
  moralisering_1_N = mkN "moralisering" ; -- moralisering..nn.1
  moralisk_1_A = mkA "moralisk" ; -- moralisk..av.1
  moralisk_2_A = mkA "moralisk" ; -- moralisk..av.2
  moralism_1_N = mkN "moralism" "moralismer" ; -- moralism..nn.1
  moralist_1_N = mkN "moralist" "moralister" ; -- moralist..nn.1
  moralistisk_1_A = mkA "moralistisk" ; -- moralistisk..av.1
  moralitet_1_N = mkN "moralitet" "moraliteter" ; -- moralitet..nn.1
  moralkaka_1_N = mkN "moralkaka" ; -- moralkaka..nn.1
  moralkod_1_N = mkN "moralkod" "moralkoder" ; -- moralkod..nn.1
  morallag_1_N = mkN "morallag" ; -- morallag..nn.1
  moralnihilism_1_N = mkN "moralnihilism" "moralnihilismer" ; -- moralnihilism..nn.1
  moralpanik_1_N = mkN "moralpanik" ; -- moralpanik..nn.1
  moralsed_1_N = mkN "moralsed" "moralseder" ; -- moralsed..nn.1
  moras_1_N = mkN "moras" neutrum  ; -- moras..nn.1
  moras_2_N = mkN "moras" neutrum  ; -- moras..nn.2
  morasland_1_N = mkN "morasland" neutrum  ; -- morasland..nn.1
  moratorium_1_N = mkN "moratorium" "moratoriet" "moratorier" "moratorierna" ; -- moratorium..nn.1
  morbid_1_A = mkA "morbid" ; -- morbid..av.1
  morbiditet_1_N = mkN "morbiditet" "morbiditeter" ; -- morbiditet..nn.1
  morbror_1_N = mkN "morbror" "morbröder" ; -- morbror..nn.1
  mord_1_N = mkN "mord" neutrum  ; -- mord..nn.1
  mordbrand_1_N = mkN "mordbrand" "mordbränder" ; -- mordbrand..nn.1
  mordbrännare_1_N = mkN "mordbrännare" utrum  ; -- mordbrännare..nn.1
  morddom_1_N = mkN "morddom" ; -- morddom..nn.1
  morddömd_1_A = mkA "morddömd" "morddömt" ; -- morddömd..av.1
  mordfall_1_N = mkN "mordfall" neutrum  ; -- mordfall..nn.1
  mordförsök_1_N = mkN "mordförsök" neutrum  ; -- mordförsök..nn.1
  mordgåta_1_N = mkN "mordgåta" ; -- mordgåta..nn.1
  mordhota_1_V = mkV "mordhotar" ; -- mordhota..vb.1
  mordhotande_1_N = mkN "mordhotande" ; -- mordhotande..nn.1
  mordisk_1_A = mkA "mordisk" ; -- mordisk..av.1
  mordkommission_1_N = mkN "mordkommission" ; -- mordkommission..nn.1
  mordkonspiration_1_N = mkN "mordkonspiration" ; -- mordkonspiration..nn.1
  mordlust_1_N = mkN "mordlust" ; -- mordlust..nn.1
  mordlysten_1_A = mkA "mordlysten" ; -- mordlysten..av.1
  mordlystenhet_1_N = mkN "mordlystenhet" ; -- mordlystenhet..nn.1
  mordlystnad_1_N = mkN "mordlystnad" "mordlystnader" ; -- mordlystnad..nn.1
  mordmisstänkt_1_A = mkA "mordmisstänkt" "mordmisstänkt" ; -- mordmisstänkt..av.1
  mordnatt_1_N = mkN "mordnatt" "mordnätter" ; -- mordnatt..nn.1
  mordoffer_1_N = mkN "mordoffer" neutrum  ; -- mordoffer..nn.1
  mordrättegång_1_N = mkN "mordrättegång" ; -- mordrättegång..nn.1
  mordstämpling_1_N = mkN "mordstämpling" ; -- mordstämpling..nn.1
  mordvapen_1_N = mkN "mordvapen" "mordvapnet" "mordvapen" "mordvapnen" ; -- mordvapen..nn.1
  mordängel_1_N = mkN "mordängel" ; -- mordängel..nn.1
  mordåtalad_1_A = mkA "mordåtalad" ; -- mordåtalad..av.1
  morell_1_N = mkN "morell" "moreller" ; -- morell..nn.1
  morfar_1_N = mkN "morfader" "morfadern" "morfäder" "morfäderna" ; -- morfar..nn.1
  morfem_1_N = mkN "morfem" neutrum  ; -- morfem..nn.1
  morfemgräns_1_N = mkN "morfemgräns" "morfemgränser" ; -- morfemgräns..nn.1
  morfin_1_N = mkN "morfin" ; -- morfin..nn.1
  morfinist_1_N = mkN "morfinist" "morfinister" ; -- morfinist..nn.1
  morfinpreparat_1_N = mkN "morfinpreparat" neutrum  ; -- morfinpreparat..nn.1
  morfogenes_1_N = mkN "morfogenes" "morfogeneser" ; -- morfogenes..nn.1
  morfolog_1_N = mkN "morfolog" "morfologer" ; -- morfolog..nn.1
  morfologi_1_N = mkN "morfologi" "morfologier" ; -- morfologi..nn.1
  morfologisk_1_A = mkA "morfologisk" ; -- morfologisk..av.1
  morförälder_1_N = mkN "morförälder" ; -- morförälder..nn.1
  morganatisk_1_A = mkA "morganatisk" ; -- morganatisk..av.1
  morgon_1_N = mkN "morgon" "morgonen" "mornar" "mornarna" ; -- morgon..nn.1
  morgonandakt_1_N = mkN "morgonandakt" "morgonandakter" ; -- morgonandakt..nn.1
  morgonavgång_1_N = mkN "morgonavgång" ; -- morgonavgång..nn.1
  morgonbloss_1_N = mkN "morgonbloss" neutrum  ; -- morgonbloss..nn.1
  morgonbön_1_N = mkN "morgonbön" "morgonböner" ; -- morgonbön..nn.1
  morgondag_1_N = mkN "morgondag" ; -- morgondag..nn.1
  morgondagg_1_N = mkN "morgondagg" ; -- morgondagg..nn.1
  morgondimma_1_N = mkN "morgondimma" ; -- morgondimma..nn.1
  morgonfrisk_1_A = mkA "morgonfrisk" ; -- morgonfrisk..av.1
  morgonfryntlig_1_A = mkA "morgonfryntlig" ; -- morgonfryntlig..av.1
  morgongryning_1_N = mkN "morgongryning" ; -- morgongryning..nn.1
  morgongudstjänst_1_N = mkN "morgongudstjänst" "morgongudstjänster" ; -- morgongudstjänst..nn.1
  morgongåva_1_N = mkN "morgongåva" ; -- morgongåva..nn.1
  morgonhumör_1_N = mkN "morgonhumör" neutrum  ; -- morgonhumör..nn.1
  morgonkaffe_1_N = mkN "morgonkaffe" ; -- morgonkaffe..nn.1
  morgonmänniska_1_N = mkN "morgonmänniska" ; -- morgonmänniska..nn.1
  morgonmål_1_N = mkN "morgonmål" neutrum  ; -- morgonmål..nn.1
  morgonmöte_1_N = mkN "morgonmöte" ; -- morgonmöte..nn.1
  morgonpigg_1_A = mkA "morgonpigg" ; -- morgonpigg..av.1
  morgonpigghet_1_N = mkN "morgonpigghet" ; -- morgonpigghet..nn.1
  morgonpromenad_1_N = mkN "morgonpromenad" "morgonpromenader" ; -- morgonpromenad..nn.1
  morgonpsalm_1_N = mkN "morgonpsalm" "morgonpsalmer" ; -- morgonpsalm..nn.1
  morgonritual_1_N = mkN "morgonritual" neutrum  ; -- morgonritual..nn.1
  morgonrock_1_N = mkN "morgonrock" ; -- morgonrock..nn.1
  morgonrodnad_1_N = mkN "morgonrodnad" "morgonrodnader" ; -- morgonrodnad..nn.1
  morgonrusning_1_N = mkN "morgonrusning" ; -- morgonrusning..nn.1
  morgonsamling_1_N = mkN "morgonsamling" ; -- morgonsamling..nn.1
  morgonsol_1_N = mkN "morgonsol" ; -- morgonsol..nn.1
  morgonstjärna_1_N = mkN "morgonstjärna" ; -- morgonstjärna..nn.1
  morgonstund_1_N = mkN "morgonstund" "morgonstunder" ; -- morgonstund..nn.1
  morgonsvalka_1_N = mkN "morgonsvalka" ; -- morgonsvalka..nn.1
  morgonsång_1_N = mkN "morgonsång" "morgonsånger" ; -- morgonsång..nn.1
  morgontidig_1_A = mkA "morgontidig" ; -- morgontidig..av.1
  morgontidning_1_N = mkN "morgontidning" ; -- morgontidning..nn.1
  morgontimme_1_N = mkN "morgontimme" utrum  ; -- morgontimme..nn.1
  morgontrött_1_A = mkA "morgontrött" ; -- morgontrött..av.1
  morgontrötthet_1_N = mkN "morgontrötthet" ; -- morgontrötthet..nn.1
  morgonvind_1_N = mkN "morgonvind" ; -- morgonvind..nn.1
  morgonväkt_1_N = mkN "morgonväkt" ; -- morgonväkt..nn.1
  morian_1_N = mkN "morian" "morianer" ; -- morian..nn.1
  moring_1_N = mkN "moring" ; -- moring..nn.1
  moringsankare_1_N = mkN "moringsankare" "moringsankaret" "moringsankaren" "moringsankarna" ; -- moringsankare..nn.1
  moringsboj_1_N = mkN "moringsboj" ; -- moringsboj..nn.1
  morisk_1_A = mkA "morisk" ; -- morisk..av.1
  morisk_1_N = mkN "morisk" "morisker" ; -- morisk..nn.1
  morkulla_1_N = mkN "morkulla" ; -- morkulla..nn.1
  morkullssträck_1_N = mkN "morkullssträck" neutrum  ; -- morkullssträck..nn.1
  morla_1_V = mkV "morlar" ; -- morla..vb.1
  morlande_1_N = mkN "morlande" ; -- morlande..nn.1
  mormon_1_N = mkN "mormon" "mormoner" ; -- mormon..nn.1
  mormonism_1_N = mkN "mormonism" "mormonismer" ; -- mormonism..nn.1
  mormonsk_1_A = mkA "mormonsk" ; -- mormonsk..av.1
  mormonäktenskap_1_N = mkN "mormonäktenskap" neutrum  ; -- mormonäktenskap..nn.1
  mormor_1_N = mkN "mormor" "mormodern" "mormödrar" "mormödrarna" ; -- mormor..nn.1
  mormorsmor_1_N = mkN "mormorsmor" "mormorsmodern" "mormorsmödrar" "mormorsmödrarna" ; -- mormorsmor..nn.1
  mormorsstång_1_N = mkN "mormorsstång" "mormorsstänger" ; -- mormorsstång..nn.1
  morot_1_N = mkN "morot" "morötter" ; -- morot..nn.1
  morotbladloppa_1_N = mkN "morotbladloppa" ; -- morotbladloppa..nn.1
  morotsfluga_1_N = mkN "morotsfluga" ; -- morotsfluga..nn.1
  morotskaka_1_N = mkN "morotskaka" ; -- morotskaka..nn.1
  morr_1_N = mkN "morr" neutrum  ; -- morr..nn.1
  morra_1_V = mkV "morrar" ; -- morra..vb.1
  morrande_1_N = mkN "morrande" ; -- morrande..nn.1
  morrhår_1_N = mkN "morrhår" neutrum  ; -- morrhår..nn.1
  morrning_1_N = mkN "morrning" ; -- morrning..nn.1
  morron_1_N = mkN "morron" ; -- morron..nn.1
  morsa_1_N = mkN "morsa" ; -- morsa..nn.1
  morsa_1_V = mkV "morsar" ; -- morsa..vb.1
  morsande_1_N = mkN "morsande" ; -- morsande..nn.1
  morsarv_1_N = mkN "morsarv" neutrum  ; -- morsarv..nn.1
  morsealfabet_1_N = mkN "morsealfabet" neutrum  ; -- morsealfabet..nn.1
  morsefyr_1_N = mkN "morsefyr" ; -- morsefyr..nn.1
  morsera_1_V = mkV "morserar" ; -- morsera..vb.1
  morserande_1_N = mkN "morserande" ; -- morserande..nn.1
  morserbar_1_A = mkA "morserbar" ; -- morserbar..av.1
  morserbarhet_1_N = mkN "morserbarhet" ; -- morserbarhet..nn.1
  morsering_1_N = mkN "morsering" ; -- morsering..nn.1
  morsesignal_1_N = mkN "morsesignal" "morsesignaler" ; -- morsesignal..nn.1
  morsgris_1_N = mkN "morsgris" ; -- morsgris..nn.1
  morsgumma_1_N = mkN "morsgumma" ; -- morsgumma..nn.1
  morsk_1_A = mkA "morsk" ; -- morsk..av.1
  morskhet_1_N = mkN "morskhet" ; -- morskhet..nn.1
  morslott_1_N = mkN "morslott" "morslotter" ; -- morslott..nn.1
  morssida_1_N = mkN "morssida" ; -- morssida..nn.1
  mortalitet_1_N = mkN "mortalitet" "mortaliteter" ; -- mortalitet..nn.1
  mortel_1_N = mkN "mortel" ; -- mortel..nn.1
  mortelstöt_1_N = mkN "mortelstöt" ; -- mortelstöt..nn.1
  mortificera_1_V = mkV "mortificerar" ; -- mortificera..vb.1
  mortificerande_1_N = mkN "mortificerande" ; -- mortificerande..nn.1
  mortificerbar_1_A = mkA "mortificerbar" ; -- mortificerbar..av.1
  mortificerbarhet_1_N = mkN "mortificerbarhet" ; -- mortificerbarhet..nn.1
  mortificering_1_N = mkN "mortificering" ; -- mortificering..nn.1
  mortifiera_1_V = mkV "mortifierar" ; -- mortifiera..vb.1
  mortifierande_1_N = mkN "mortifierande" ; -- mortifierande..nn.1
  mortifierbar_1_A = mkA "mortifierbar" ; -- mortifierbar..av.1
  mortifierbarhet_1_N = mkN "mortifierbarhet" ; -- mortifierbarhet..nn.1
  mortifiering_1_N = mkN "mortifiering" ; -- mortifiering..nn.1
  mortifikation_1_N = mkN "mortifikation" ; -- mortifikation..nn.1
  morän_1_N = mkN "morän" "moräner" ; -- morän..nn.1
  moränbildning_1_N = mkN "moränbildning" ; -- moränbildning..nn.1
  moränmark_1_N = mkN "moränmark" "moränmarker" ; -- moränmark..nn.1
  moränsluttning_1_N = mkN "moränsluttning" ; -- moränsluttning..nn.1
  mos_1_N = mkN "mos" neutrum  ; -- mos..nn.1
  mosa_1_V = mkV "mosar" ; -- mosa..vb.1
  mosaik_1_N = mkN "mosaik" "mosaiker" ; -- mosaik..nn.1
  mosaikartad_1_A = mkA "mosaikartad" ; -- mosaikartad..av.1
  mosaikinramad_1_A = mkA "mosaikinramad" ; -- mosaikinramad..av.1
  mosaiklandskap_1_N = mkN "mosaiklandskap" neutrum  ; -- mosaiklandskap..nn.1
  mosaikmönster_1_N = mkN "mosaikmönster" neutrum  ; -- mosaikmönster..nn.1
  mosaiksjuka_1_N = mkN "mosaiksjuka" ; -- mosaiksjuka..nn.1
  mosaiksöm_1_N = mkN "mosaiksöm" "mosaiksömmen" "mosaiksömmar" "mosaiksömmarna" ; -- mosaiksöm..nn.1
  mosaisk_1_A = mkA "mosaisk" ; -- mosaisk..av.1
  mosande_1_N = mkN "mosande" ; -- mosande..nn.1
  mosel_1_N = mkN "mosel" ; -- mosel..nn.1
  moselvin_1_N = mkN "moselvin" "moselvinet" "moselviner" "moselvinerna" ; -- moselvin..nn.1
  mosig_1_A = mkA "mosig" ; -- mosig..av.1
  mosighet_1_N = mkN "mosighet" ; -- mosighet..nn.1
  mosippa_1_N = mkN "mosippa" ; -- mosippa..nn.1
  moskit_1_N = mkN "moskit" "moskiter" ; -- moskit..nn.1
  moskitnät_1_N = mkN "moskitnät" neutrum  ; -- moskitnät..nn.1
  moskovit_1_N = mkN "moskovit" "moskoviter" ; -- moskovit..nn.1
  moskovitisk_1_A = mkA "moskovitisk" ; -- moskovitisk..av.1
  moskvich_1_N = mkN "moskvich" ; -- moskvich..nn.1
  moskvitj_1_N = mkN "moskvitj" ; -- moskvitj..nn.1
  moské_1_N = mkN "moské" "moskéer" ; -- moské..nn.1
  moskévandal_1_N = mkN "moskévandal" "moskévandaler" ; -- moskévandal..nn.1
  mosning_1_N = mkN "mosning" ; -- mosning..nn.1
  mosnäppa_1_N = mkN "mosnäppa" ; -- mosnäppa..nn.1
  mossa_1_N = mkN "mossa" ; -- mossa..nn.1
  mossbelupen_1_A = mkA "mossbelupen" ; -- mossbelupen..av.1
  mossbelupenhet_1_N = mkN "mossbelupenhet" ; -- mossbelupenhet..nn.1
  mosse_1_N = mkN "mosse" utrum  ; -- mosse..nn.1
  mossfolk_1_N = mkN "mossfolk" neutrum  ; -- mossfolk..nn.1
  mossfynd_1_N = mkN "mossfynd" neutrum  ; -- mossfynd..nn.1
  mossgrön_1_A = mkA "mossgrön" ; -- mossgrön..av.1
  mossig_1_A = mkA "mossig" ; -- mossig..av.1
  mossighet_1_N = mkN "mossighet" ; -- mossighet..nn.1
  mossighet_2_N = mkN "mossighet" "mossigheter" ; -- mossighet..nn.2
  mossklädd_1_A = mkA "mossklädd" ; -- mossklädd..av.1
  mosskultur_1_N = mkN "mosskultur" "mosskulturer" ; -- mosskultur..nn.1
  mosslik_1_N = mkN "mosslik" neutrum  ; -- mosslik..nn.1
  mossljung_1_N = mkN "mossljung" ; -- mossljung..nn.1
  mossros_1_N = mkN "mossros" "mossrosor" ; -- mossros..nn.1
  mossrot_1_N = mkN "mossrot" "mossrötter" ; -- mossrot..nn.1
  mosstorv_1_N = mkN "mosstorv" ; -- mosstorv..nn.1
  moster_1_N = mkN "moster" ; -- moster..nn.1
  mosterlig_1_A = mkA "mosterlig" ; -- mosterlig..av.1
  mosterlighet_1_N = mkN "mosterlighet" ; -- mosterlighet..nn.1
  mot_1_N = mkN "mot" neutrum  ; -- mot..nn.1
  mota_1_V = mkV "motar" ; -- mota..vb.1
  motaktion_1_N = mkN "motaktion" ; -- motaktion..nn.1
  motande_1_N = mkN "motande" ; -- motande..nn.1
  motanfall_1_N = mkN "motanfall" neutrum  ; -- motanfall..nn.1
  motangrepp_1_N = mkN "motangrepp" neutrum  ; -- motangrepp..nn.1
  motarbeta_1_V = mkV "motarbetar" ; -- motarbeta..vb.1
  motarbetande_1_N = mkN "motarbetande" ; -- motarbetande..nn.1
  motargument_1_N = mkN "motargument" neutrum  ; -- motargument..nn.1
  motbeskyllning_1_N = mkN "motbeskyllning" ; -- motbeskyllning..nn.1
  motbevis_1_N = mkN "motbevis" neutrum  ; -- motbevis..nn.1
  motbevisa_1_V = mkV "motbevisar" ; -- motbevisa..vb.1
  motbevisande_1_N = mkN "motbevisande" ; -- motbevisande..nn.1
  motbevisning_1_N = mkN "motbevisning" ; -- motbevisning..nn.1
  motbild_1_N = mkN "motbild" "motbilder" ; -- motbild..nn.1
  motbjudande_1_A = mkA "motbjudande" ; -- motbjudande..av.1
  motbok_1_N = mkN "motbok" "motböcker" ; -- motbok..nn.1
  motbud_1_N = mkN "motbud" neutrum  ; -- motbud..nn.1
  motdemonstrant_1_N = mkN "motdemonstrant" "motdemonstranter" ; -- motdemonstrant..nn.1
  motdrag_1_N = mkN "motdrag" neutrum  ; -- motdrag..nn.1
  moteld_1_N = mkN "moteld" ; -- moteld..nn.1
  motell_1_N = mkN "motell" neutrum  ; -- motell..nn.1
  motellchef_1_N = mkN "motellchef" "motellchefer" ; -- motellchef..nn.1
  motett_1_N = mkN "motett" "motetter" ; -- motett..nn.1
  motfordran_1_N = mkN "motfordran" "motfordran" "motfordringar" "motfordringarna" ; -- motfordran..nn.1
  motfråga_1_N = mkN "motfråga" ; -- motfråga..nn.1
  motförslag_1_N = mkN "motförslag" neutrum  ; -- motförslag..nn.1
  motgift_1_N = mkN "motgift" "motgiftet" "motgifter" "motgifterna" ; -- motgift..nn.1
  motgång_1_N = mkN "motgång" ; -- motgång..nn.1
  mothugg_1_N = mkN "mothugg" neutrum  ; -- mothugg..nn.1
  mothåll_1_N = mkN "mothåll" neutrum  ; -- mothåll..nn.1
  motig_1_A = mkA "motig" ; -- motig..av.1
  motighet_1_N = mkN "motighet" "motigheter" ; -- motighet..nn.1
  motinlägg_1_N = mkN "motinlägg" neutrum  ; -- motinlägg..nn.1
  motion_1_N = mkN "motion" ; -- motion..nn.1
  motionera_1_V = mkV "motionerar" ; -- motionera..vb.1
  motionerande_1_N = mkN "motionerande" ; -- motionerande..nn.1
  motionering_1_N = mkN "motionering" ; -- motionering..nn.1
  motionsanläggning_1_N = mkN "motionsanläggning" ; -- motionsanläggning..nn.1
  motionscykel_1_N = mkN "motionscykel" ; -- motionscykel..nn.1
  motionsflod_1_N = mkN "motionsflod" "motionsfloder" ; -- motionsflod..nn.1
  motionsgymnastik_1_N = mkN "motionsgymnastik" ; -- motionsgymnastik..nn.1
  motionshall_1_N = mkN "motionshall" ; -- motionshall..nn.1
  motionshets_1_N = mkN "motionshets" ; -- motionshets..nn.1
  motionsidrott_1_N = mkN "motionsidrott" "motionsidrotter" ; -- motionsidrott..nn.1
  motionsrätt_1_N = mkN "motionsrätt" ; -- motionsrätt..nn.1
  motionsspår_1_N = mkN "motionsspår" neutrum  ; -- motionsspår..nn.1
  motionstid_1_N = mkN "motionstid" "motionstider" ; -- motionstid..nn.1
  motionsvana_1_N = mkN "motionsvana" ; -- motionsvana..nn.1
  motionär_1_N = mkN "motionär" "motionärer" ; -- motionär..nn.1
  motiv_1_N = mkN "motiv" neutrum  ; -- motiv..nn.1
  motivation_1_N = mkN "motivation" ; -- motivation..nn.1
  motivationskonsult_1_N = mkN "motivationskonsult" "motivationskonsulter" ; -- motivationskonsult..nn.1
  motivationsmässig_1_A = mkA "motivationsmässig" ; -- motivationsmässig..av.1
  motivbild_1_N = mkN "motivbild" "motivbilder" ; -- motivbild..nn.1
  motivera_1_V = mkV "motiverar" ; -- motivera..vb.1
  motiverad_1_A = mkA "motiverad" ; -- motiverad..av.1
  motiverande_1_N = mkN "motiverande" ; -- motiverande..nn.1
  motiverbar_1_A = mkA "motiverbar" ; -- motiverbar..av.1
  motiverbarhet_1_N = mkN "motiverbarhet" ; -- motiverbarhet..nn.1
  motivering_1_N = mkN "motivering" ; -- motivering..nn.1
  motivisk_1_A = mkA "motivisk" ; -- motivisk..av.1
  motivkrets_1_N = mkN "motivkrets" ; -- motivkrets..nn.1
  motivmässig_1_A = mkA "motivmässig" ; -- motivmässig..av.1
  motkampanj_1_N = mkN "motkampanj" "motkampanjer" ; -- motkampanj..nn.1
  motkandidat_1_N = mkN "motkandidat" "motkandidater" ; -- motkandidat..nn.1
  motkraft_1_N = mkN "motkraft" "motkrafter" ; -- motkraft..nn.1
  motkrav_1_N = mkN "motkrav" neutrum  ; -- motkrav..nn.1
  motkultur_1_N = mkN "motkultur" "motkulturer" ; -- motkultur..nn.1
  motliggande_1_A = mkA "motliggande" ; -- motliggande..av.1
  motljus_1_N = mkN "motljus" neutrum  ; -- motljus..nn.1
  motlut_1_N = mkN "motlut" neutrum  ; -- motlut..nn.1
  motläsa_1_V = mkV "motläser" ; -- motläsa..vb.1
  motläsande_1_N = mkN "motläsande" ; -- motläsande..nn.1
  motläsare_1_N = mkN "motläsare" utrum  ; -- motläsare..nn.1
  motläsning_1_N = mkN "motläsning" ; -- motläsning..nn.1
  motocross_1_N = mkN "motocross" ; -- motocross..nn.1
  motoffensiv_1_N = mkN "motoffensiv" "motoffensiver" ; -- motoffensiv..nn.1
  motor_1_N = mkN "motor" "motorer" ; -- motor..nn.1
  motorbränsle_1_N = mkN "motorbränsle" ; -- motorbränsle..nn.1
  motorbuller_1_N = mkN "motorbuller" neutrum  ; -- motorbuller..nn.1
  motorbädd_1_N = mkN "motorbädd" ; -- motorbädd..nn.1
  motorbåt_1_N = mkN "motorbåt" ; -- motorbåt..nn.1
  motorcykel_1_N = mkN "motorcykel" ; -- motorcykel..nn.1
  motorcykelhjälm_1_N = mkN "motorcykelhjälm" ; -- motorcykelhjälm..nn.1
  motorcykellyft_1_N = mkN "motorcykellyft" ; -- motorcykellyft..nn.1
  motorcykelolycka_1_N = mkN "motorcykelolycka" ; -- motorcykelolycka..nn.1
  motorcykelpolis_1_N = mkN "motorcykelpolis" "motorcykelpoliser" ; -- motorcykelpolis..nn.1
  motorcykelsemester_1_N = mkN "motorcykelsemester" ; -- motorcykelsemester..nn.1
  motorcykelställ_1_N = mkN "motorcykelställ" neutrum  ; -- motorcykelställ..nn.1
  motorcykeltävling_1_N = mkN "motorcykeltävling" ; -- motorcykeltävling..nn.1
  motorcyklist_1_N = mkN "motorcyklist" "motorcyklister" ; -- motorcyklist..nn.1
  motorcylinder_1_N = mkN "motorcylinder" ; -- motorcylinder..nn.1
  motordriven_1_A = mkA "motordriven" ; -- motordriven..av.1
  motoreffekt_1_N = mkN "motoreffekt" "motoreffekter" ; -- motoreffekt..nn.1
  motorfartyg_1_N = mkN "motorfartyg" neutrum  ; -- motorfartyg..nn.1
  motorfordon_1_N = mkN "motorfordon" neutrum  ; -- motorfordon..nn.1
  motorhotell_1_N = mkN "motorhotell" neutrum  ; -- motorhotell..nn.1
  motorhuv_1_N = mkN "motorhuv" ; -- motorhuv..nn.1
  motorik_1_N = mkN "motorik" ; -- motorik..nn.1
  motorisera_1_V = mkV "motoriserar" ; -- motorisera..vb.1
  motoriserande_1_N = mkN "motoriserande" ; -- motoriserande..nn.1
  motoriserbar_1_A = mkA "motoriserbar" ; -- motoriserbar..av.1
  motoriserbarhet_1_N = mkN "motoriserbarhet" ; -- motoriserbarhet..nn.1
  motorisering_1_N = mkN "motorisering" ; -- motorisering..nn.1
  motorisk_1_A = mkA "motorisk" ; -- motorisk..av.1
  motorism_1_N = mkN "motorism" "motorismer" ; -- motorism..nn.1
  motorist_1_N = mkN "motorist" "motorister" ; -- motorist..nn.1
  motorjakt_1_N = mkN "motorjakt" "motorjakter" ; -- motorjakt..nn.1
  motorkraft_1_N = mkN "motorkraft" "motorkrafter" ; -- motorkraft..nn.1
  motorkryssare_1_N = mkN "motorkryssare" utrum  ; -- motorkryssare..nn.1
  motorljud_1_N = mkN "motorljud" neutrum  ; -- motorljud..nn.1
  motorlyft_1_N = mkN "motorlyft" ; -- motorlyft..nn.1
  motorman_1_N = mkN "motorman" "motormannen" "motormän" "motormännen" ; -- motorman..nn.1
  motorrengöring_1_N = mkN "motorrengöring" ; -- motorrengöring..nn.1
  motorseglare_1_N = mkN "motorseglare" utrum  ; -- motorseglare..nn.1
  motorskydd_1_N = mkN "motorskydd" neutrum  ; -- motorskydd..nn.1
  motorsport_1_N = mkN "motorsport" ; -- motorsport..nn.1
  motorstark_1_A = mkA "motorstark" ; -- motorstark..av.1
  motorstativ_1_N = mkN "motorstativ" neutrum  ; -- motorstativ..nn.1
  motorstopp_1_N = mkN "motorstopp" neutrum  ; -- motorstopp..nn.1
  motorstyrka_1_N = mkN "motorstyrka" ; -- motorstyrka..nn.1
  motorsåg_1_N = mkN "motorsåg" ; -- motorsåg..nn.1
  motorsågskedja_1_N = mkN "motorsågskedja" ; -- motorsågskedja..nn.1
  motortorpedbåt_1_N = mkN "motortorpedbåt" ; -- motortorpedbåt..nn.1
  motortrafikled_1_N = mkN "motortrafikled" "motortrafikleder" ; -- motortrafikled..nn.1
  motortvätt_1_N = mkN "motortvätt" ; -- motortvätt..nn.1
  motorvagn_1_N = mkN "motorvagn" ; -- motorvagn..nn.1
  motorväg_1_N = mkN "motorväg" ; -- motorväg..nn.1
  motorvägsförbindelse_1_N = mkN "motorvägsförbindelse" "motorvägsförbindelser" ; -- motorvägsförbindelse..nn.1
  motorvägskramare_1_N = mkN "motorvägskramare" utrum  ; -- motorvägskramare..nn.1
  motorvägsmässig_1_A = mkA "motorvägsmässig" ; -- motorvägsmässig..av.1
  motorvärmare_1_N = mkN "motorvärmare" utrum  ; -- motorvärmare..nn.1
  motorvärmarkabel_1_N = mkN "motorvärmarkabel" ; -- motorvärmarkabel..nn.1
  motpart_1_N = mkN "motpart" "motparter" ; -- motpart..nn.1
  motpol_1_N = mkN "motpol" "motpoler" ; -- motpol..nn.1
  motprestation_1_N = mkN "motprestation" ; -- motprestation..nn.1
  motpåstående_1_N = mkN "motpåstående" ; -- motpåstående..nn.1
  motpåve_1_N = mkN "motpåve" utrum  ; -- motpåve..nn.1
  motreformation_1_N = mkN "motreformation" ; -- motreformation..nn.1
  motreplik_1_N = mkN "motreplik" "motrepliker" ; -- motreplik..nn.1
  motrevolution_1_N = mkN "motrevolution" ; -- motrevolution..nn.1
  motriktad_1_A = mkA "motriktad" ; -- motriktad..av.1
  motrytm_1_N = mkN "motrytm" "motrytmer" ; -- motrytm..nn.1
  motrörelse_1_N = mkN "motrörelse" "motrörelser" ; -- motrörelse..nn.1
  motsats_1_N = mkN "motsats" "motsatser" ; -- motsats..nn.1
  motsatsförhållande_1_N = mkN "motsatsförhållande" ; -- motsatsförhållande..nn.1
  motsatspar_1_N = mkN "motsatspar" neutrum  ; -- motsatspar..nn.1
  motsatt_1_A = mkA "motsatt" ; -- motsatt..av.1
  motse_1_V = mkV "motse" "motsåg" "motsett" ; -- motse..vb.1
  motseende_1_N = mkN "motseende" ; -- motseende..nn.1
  motskott_1_N = mkN "motskott" neutrum  ; -- motskott..nn.1
  motskrift_1_N = mkN "motskrift" "motskrifter" ; -- motskrift..nn.1
  motskäl_1_N = mkN "motskäl" neutrum  ; -- motskäl..nn.1
  motspelare_1_N = mkN "motspelare" utrum  ; -- motspelare..nn.1
  motspänstig_1_A = mkA "motspänstig" ; -- motspänstig..av.1
  motspänstighet_1_N = mkN "motspänstighet" ; -- motspänstighet..nn.1
  motstridande_1_A = mkA "motstridande" ; -- motstridande..av.1
  motstridig_1_A = mkA "motstridig" ; -- motstridig..av.1
  motstridighet_1_N = mkN "motstridighet" ; -- motstridighet..nn.1
  motstrof_1_N = mkN "motstrof" "motstrofer" ; -- motstrof..nn.1
  motsträvig_1_A = mkA "motsträvig" ; -- motsträvig..av.1
  motsträvighet_1_N = mkN "motsträvighet" ; -- motsträvighet..nn.1
  motström_1_N = mkN "motström" "motströmmen" "motströmmar" "motströmmarna" ; -- motström..nn.1
  motströms_1_Adv = mkAdv "motströms" ; -- motströms..ab.1
  motstycke_1_N = mkN "motstycke" ; -- motstycke..nn.1
  motstämning_1_N = mkN "motstämning" ; -- motstämning..nn.1
  motstå_1_V = mkV "motstå" "motstod" "motstått" ; -- motstå..vb.1
  motstående_1_A = mkA "motstående" ; -- motstående..av.1
  motstående_1_N = mkN "motstående" ; -- motstående..nn.1
  motstånd_1_N = mkN "motstånd" neutrum  ; -- motstånd..nn.1
  motståndare_1_N = mkN "motståndare" utrum  ; -- motståndare..nn.1
  motståndarlag_1_N = mkN "motståndarlag" neutrum  ; -- motståndarlag..nn.1
  motståndarsoldat_1_N = mkN "motståndarsoldat" "motståndarsoldater" ; -- motståndarsoldat..nn.1
  motståndshärd_1_N = mkN "motståndshärd" ; -- motståndshärd..nn.1
  motståndskamp_1_N = mkN "motståndskamp" ; -- motståndskamp..nn.1
  motståndskraft_1_N = mkN "motståndskraft" ; -- motståndskraft..nn.1
  motståndskraftig_1_A = mkA "motståndskraftig" ; -- motståndskraftig..av.1
  motståndslös_1_A = mkA "motståndslös" ; -- motståndslös..av.1
  motståndslöshet_1_N = mkN "motståndslöshet" ; -- motståndslöshet..nn.1
  motståndsman_1_N = mkN "motståndsman" "motståndsmannen" "motståndsmän" "motståndsmännen" ; -- motståndsman..nn.1
  motståndsnäste_1_N = mkN "motståndsnäste" ; -- motståndsnäste..nn.1
  motståndsområde_1_N = mkN "motståndsområde" ; -- motståndsområde..nn.1
  motståndsrörelse_1_N = mkN "motståndsrörelse" "motståndsrörelser" ; -- motståndsrörelse..nn.1
  motståndsstrateg_1_N = mkN "motståndsstrateg" "motståndsstrateger" ; -- motståndsstrateg..nn.1
  motståndssvetsning_1_N = mkN "motståndssvetsning" ; -- motståndssvetsning..nn.1
  motståndsvilja_1_N = mkN "motståndsvilja" ; -- motståndsvilja..nn.1
  motstöt_1_N = mkN "motstöt" ; -- motstöt..nn.1
  motsvara_1_V = mkV "motsvarar" ; -- motsvara..vb.1
  motsvarande_1_A = mkA "motsvarande" ; -- motsvarande..av.1
  motsvarande_1_N = mkN "motsvarande" ; -- motsvarande..nn.1
  motsvarighet_1_N = mkN "motsvarighet" "motsvarigheter" ; -- motsvarighet..nn.1
  motsäga_1_V = mkV "motsäga" "motsade" "motsagt" ; -- motsäga..vb.1
  motsägande_1_N = mkN "motsägande" ; -- motsägande..nn.1
  motsägelse_1_N = mkN "motsägelse" "motsägelser" ; -- motsägelse..nn.1
  motsägelsefull_1_A = mkA "motsägelsefull" ; -- motsägelsefull..av.1
  motsägelsefullhet_1_N = mkN "motsägelsefullhet" ; -- motsägelsefullhet..nn.1
  motsägelselust_1_N = mkN "motsägelselust" ; -- motsägelselust..nn.1
  motsägelselusta_1_N = mkN "motsägelselusta" ; -- motsägelselusta..nn.1
  motsägelselös_1_A = mkA "motsägelselös" ; -- motsägelselös..av.1
  motsättlig_1_A = mkA "motsättlig" ; -- motsättlig..av.1
  motsättlighet_1_N = mkN "motsättlighet" ; -- motsättlighet..nn.1
  motsättning_1_N = mkN "motsättning" ; -- motsättning..nn.1
  mott_1_N = mkN "mott" neutrum  ; -- mott..nn.1
  motta_1_V = mkV "mottaga" "mottog" "mottagit" ; -- motta..vb.1
  mottagande_1_N = mkN "mottagande" ; -- mottagande..nn.1
  mottagare_1_N = mkN "mottagare" utrum  ; -- mottagare..nn.1
  mottagarsäck_1_N = mkN "mottagarsäck" ; -- mottagarsäck..nn.1
  mottaglig_1_A = mkA "mottaglig" ; -- mottaglig..av.1
  mottaglighet_1_N = mkN "mottaglighet" ; -- mottaglighet..nn.1
  mottagning_1_N = mkN "mottagning" ; -- mottagning..nn.1
  mottagningsbevis_1_N = mkN "mottagningsbevis" neutrum  ; -- mottagningsbevis..nn.1
  mottagningshem_1_N = mkN "mottagningshem" "mottagningshemmet" "mottagningshem" "mottagningshemmen" ; -- mottagningshem..nn.1
  mottagningsrum_1_N = mkN "mottagningsrum" "mottagningsrummet" "mottagningsrum" "mottagningsrummen" ; -- mottagningsrum..nn.1
  motti_1_N = mkN "motti" "mottin" "motti" "mottina" ; -- motti..nn.1
  motto_1_N = mkN "motto" "mottot" "motton" "mottona" ; -- motto..nn.1
  mottryck_1_N = mkN "mottryck" neutrum  ; -- mottryck..nn.1
  motvalls_1_A = mkA "motvalls" ; -- motvalls..av.1
  motvallskäring_1_N = mkN "motvallskäring" ; -- motvallskäring..nn.1
  motvallskärring_1_N = mkN "motvallskärring" ; -- motvallskärring..nn.1
  motverka_1_V = mkV "motverkar" ; -- motverka..vb.1
  motverkande_1_N = mkN "motverkande" ; -- motverkande..nn.1
  motvikt_1_N = mkN "motvikt" "motvikter" ; -- motvikt..nn.1
  motvilja_1_N = mkN "motvilja" ; -- motvilja..nn.1
  motvillig_1_A = mkA "motvillig" ; -- motvillig..av.1
  motvillighet_1_N = mkN "motvillighet" ; -- motvillighet..nn.1
  motvind_1_N = mkN "motvind" ; -- motvind..nn.1
  motvisit_1_N = mkN "motvisit" "motvisiter" ; -- motvisit..nn.1
  motväga_1_V = mkV "motväger" ; -- motväga..vb.1
  motvägande_1_N = mkN "motvägande" ; -- motvägande..nn.1
  motvärn_1_N = mkN "motvärn" ; -- motvärn..nn.1
  motyl_1_N = mkN "motyl" ; -- motyl..nn.1
  motåtgärd_1_N = mkN "motåtgärd" "motåtgärder" ; -- motåtgärd..nn.1
  moulinégarn_1_N = mkN "moulinégarn" neutrum  ; -- moulinégarn..nn.1
  mousse_1_N = mkN "mousse" "mousser" ; -- mousse..nn.1
  moussera_1_V = mkV "mousserar" ; -- moussera..vb.1
  mousserande_1_N = mkN "mousserande" ; -- mousserande..nn.1
  moussering_1_N = mkN "moussering" ; -- moussering..nn.1
  movipa_1_N = mkN "movipa" ; -- movipa..nn.1
  mox_bränsle_1_N = mkN "mox-bränsle" ; -- mox-bränsle..nn.1
  mozzarella_1_N = mkN "mozzarella" ; -- mozzarella..nn.1
  moçambikier_1_N = mkN "moçambikier" "moçambikiern" "moçambikier" "moçambikierna" ; -- moçambikier..nn.1
  moçambikisk_1_A = mkA "moçambikisk" ; -- moçambikisk..av.1
  moçambikiska_1_N = mkN "moçambikiska" ; -- moçambikiska..nn.1
  mp3_bok_1_N = mkN "mp3-bok" "mp3-böcker" ; -- mp3-bok..nn.1
  mp3_spelare_1_N = mkN "mp3-spelare" utrum  ; -- mp3-spelare..nn.1
  muck_1_N = mkN "muck" ; -- muck..nn.1
  muck_2_N = mkN "muck" ; -- muck..nn.2
  mucka_1_V = mkV "muckar" ; -- mucka..vb.1
  muckande_1_N = mkN "muckande" ; -- muckande..nn.1
  muckare_1_N = mkN "muckare" utrum  ; -- muckare..nn.1
  mudd_1_N = mkN "mudd" ; -- mudd..nn.1
  mudder_1_N = mkN "mudder" neutrum  ; -- mudder..nn.1
  mudderverk_1_N = mkN "mudderverk" neutrum  ; -- mudderverk..nn.1
  muddra_1_V = mkV "muddrar" ; -- muddra..vb.1
  muddrande_1_N = mkN "muddrande" ; -- muddrande..nn.1
  muddrig_1_A = mkA "muddrig" ; -- muddrig..av.1
  muddrighet_1_N = mkN "muddrighet" ; -- muddrighet..nn.1
  muff_1_N = mkN "muff" ; -- muff..nn.1
  muffel_1_N = mkN "muffel" ; -- muffel..nn.1
  muffelfärg_1_N = mkN "muffelfärg" "muffelfärger" ; -- muffelfärg..nn.1
  muffelugn_1_N = mkN "muffelugn" ; -- muffelugn..nn.1
  muffin_mage_1_N = mkN "muffin-mage" utrum  ; -- muffin-mage..nn.1
  muffinmage_1_N = mkN "muffinmage" utrum  ; -- muffinmage..nn.1
  muffins_1_N = mkN "muffins" ; -- muffins..nn.1
  muffinsmage_1_N = mkN "muffinsmage" utrum  ; -- muffinsmage..nn.1
  mufflon_1_N = mkN "mufflon" "muffloner" ; -- mufflon..nn.1
  mufflonfår_1_N = mkN "mufflonfår" neutrum  ; -- mufflonfår..nn.1
  mufti_1_N = mkN "mufti" "muftin" "muftier" "muftierna" ; -- mufti..nn.1
  mugg_1_N = mkN "mugg" ; -- mugg..nn.1
  mugg_2_N = mkN "mugg" ; -- mugg..nn.2
  muggkaka_1_N = mkN "muggkaka" ; -- muggkaka..nn.1
  muhammedan_1_N = mkN "muhammedan" "muhammedaner" ; -- muhammedan..nn.1
  muhammedanism_1_N = mkN "muhammedanism" "muhammedanismer" ; -- muhammedanism..nn.1
  muhammedansk_1_A = mkA "muhammedansk" ; -- muhammedansk..av.1
  mujahedin_1_N = mkN "mujahedin" "mujahediner" ; -- mujahedin..nn.1
  mula_1_N = mkN "mula" ; -- mula..nn.1
  mula_1_V = mkV "mular" ; -- mula..vb.1
  mulande_1_N = mkN "mulande" ; -- mulande..nn.1
  mulatt_1_N = mkN "mulatt" "mulatter" ; -- mulatt..nn.1
  mulbete_1_N = mkN "mulbete" ; -- mulbete..nn.1
  mule_1_N = mkN "mule" utrum  ; -- mule..nn.1
  mulen_1_A = mkA "mulen" ; -- mulen..av.1
  mulenhet_1_N = mkN "mulenhet" ; -- mulenhet..nn.1
  muljera_1_V = mkV "muljerar" ; -- muljera..vb.1
  muljerande_1_N = mkN "muljerande" ; -- muljerande..nn.1
  muljerbar_1_A = mkA "muljerbar" ; -- muljerbar..av.1
  muljerbarhet_1_N = mkN "muljerbarhet" ; -- muljerbarhet..nn.1
  muljering_1_N = mkN "muljering" ; -- muljering..nn.1
  mull_1_N = mkN "mull" ; -- mull..nn.1
  mulla_1_N = mkN "mulla" ; -- mulla..nn.1
  mullah_1_N = mkN "mullah" ; -- mullah..nn.1
  mullbänk_1_N = mkN "mullbänk" ; -- mullbänk..nn.1
  mullbär_1_N = mkN "mullbär" neutrum  ; -- mullbär..nn.1
  mullbärsfikon_1_N = mkN "mullbärsfikon" neutrum  ; -- mullbärsfikon..nn.1
  mullbärsfikonträd_1_N = mkN "mullbärsfikonträd" neutrum  ; -- mullbärsfikonträd..nn.1
  mullbärsspinnare_1_N = mkN "mullbärsspinnare" utrum  ; -- mullbärsspinnare..nn.1
  mullbärsträd_1_N = mkN "mullbärsträd" neutrum  ; -- mullbärsträd..nn.1
  muller_1_N = mkN "muller" neutrum  ; -- muller..nn.1
  mullhalt_1_N = mkN "mullhalt" "mullhalter" ; -- mullhalt..nn.1
  mullig_1_A = mkA "mullig" ; -- mullig..av.1
  mullighet_1_N = mkN "mullighet" ; -- mullighet..nn.1
  mullra_1_V = mkV "mullrar" ; -- mullra..vb.1
  mullrande_1_N = mkN "mullrande" ; -- mullrande..nn.1
  mullrik_1_A = mkA "mullrik" ; -- mullrik..av.1
  mullsork_1_N = mkN "mullsork" ; -- mullsork..nn.1
  mullsyra_1_N = mkN "mullsyra" ; -- mullsyra..nn.1
  mulltoa_1_N = mkN "mulltoa" ; -- mulltoa..nn.1
  mullvad_1_N = mkN "mullvad" ; -- mullvad..nn.1
  mullvadsarbete_1_N = mkN "mullvadsarbete" ; -- mullvadsarbete..nn.1
  mullvadshög_1_N = mkN "mullvadshög" ; -- mullvadshög..nn.1
  mullvadssyrsa_1_N = mkN "mullvadssyrsa" ; -- mullvadssyrsa..nn.1
  mulna_1_V = mkV "mulnar" ; -- mulna..vb.1
  mulnande_1_N = mkN "mulnande" ; -- mulnande..nn.1
  mulning_1_N = mkN "mulning" ; -- mulning..nn.1
  multe_1_N = mkN "multe" utrum  ; -- multe..nn.1
  multegröt_1_N = mkN "multegröt" ; -- multegröt..nn.1
  multen_1_A = mkA "multen" ; -- multen..av.1
  multenhet_1_N = mkN "multenhet" ; -- multenhet..nn.1
  multietnisk_1_A = mkA "multietnisk" ; -- multietnisk..av.1
  multihandikapp_1_N = mkN "multihandikapp" neutrum  ; -- multihandikapp..nn.1
  multihandikappad_1_A = mkA "multihandikappad" ; -- multihandikappad..av.1
  multikonst_1_N = mkN "multikonst" ; -- multikonst..nn.1
  multikult_1_A = mkA "multikult" "multikult" ; -- multikult..av.1
  multikulta_1_V = mkV "multikultar" ; -- multikulta..vb.1
  multikultande_1_N = mkN "multikultande" ; -- multikultande..nn.1
  multikultare_1_N = mkN "multikultare" utrum  ; -- multikultare..nn.1
  multikulturalism_1_N = mkN "multikulturalism" "multikulturalismer" ; -- multikulturalism..nn.1
  multikulturell_1_A = mkA "multikulturell" ; -- multikulturell..av.1
  multilateral_1_A = mkA "multilateral" ; -- multilateral..av.1
  multimedium_1_N = mkN "multimedium" "multimediet" "multimedia" "multimediana" ; -- multimedium..nn.1
  multimiljardär_1_N = mkN "multimiljardär" "multimiljardärer" ; -- multimiljardär..nn.1
  multimiljonär_1_N = mkN "multimiljonär" "multimiljonärer" ; -- multimiljonär..nn.1
  multinationell_1_A = mkA "multinationell" ; -- multinationell..av.1
  multipel_1_A = mkA "multipel" ; -- multipel..av.1
  multipel_1_N = mkN "multipel" "multipeln" "multipler" "multiplerna" ; -- multipel..nn.1
  multipeltåg_1_N = mkN "multipeltåg" neutrum  ; -- multipeltåg..nn.1
  multiplicera_1_V = mkV "multiplicerar" ; -- multiplicera..vb.1
  multiplicerande_1_N = mkN "multiplicerande" ; -- multiplicerande..nn.1
  multiplicerbar_1_A = mkA "multiplicerbar" ; -- multiplicerbar..av.1
  multiplicerbarhet_1_N = mkN "multiplicerbarhet" ; -- multiplicerbarhet..nn.1
  multiplicering_1_N = mkN "multiplicering" ; -- multiplicering..nn.1
  multiplikand_1_N = mkN "multiplikand" "multiplikander" ; -- multiplikand..nn.1
  multiplikation_1_N = mkN "multiplikation" ; -- multiplikation..nn.1
  multiplikationstabell_1_N = mkN "multiplikationstabell" "multiplikationstabeller" ; -- multiplikationstabell..nn.1
  multiplikationstecken_1_N = mkN "multiplikationstecken" "multiplikationstecknet" "multiplikationstecken" "multiplikationstecknen" ; -- multiplikationstecken..nn.1
  multiplikator_1_N = mkN "multiplikator" "multiplikatorer" ; -- multiplikator..nn.1
  multiresistens_1_N = mkN "multiresistens" ; -- multiresistens..nn.1
  multiresistent_1_A = mkA "multiresistent" "multiresistent" ; -- multiresistent..av.1
  multisjuk_1_A = mkA "multisjuk" ; -- multisjuk..av.1
  multisjukhet_1_N = mkN "multisjukhet" ; -- multisjukhet..nn.1
  multituberkulat_1_N = mkN "multituberkulat" neutrum  ; -- multituberkulat..nn.1
  multna_1_V = mkV "multnar" ; -- multna..vb.1
  multnande_1_N = mkN "multnande" ; -- multnande..nn.1
  multum_1_N = mkN "multum" ; -- multum..nn.1
  mulåsna_1_N = mkN "mulåsna" ; -- mulåsna..nn.1
  mumie_1_N = mkN "mumie" "mumier" ; -- mumie..nn.1
  mumifiera_1_V = mkV "mumifierar" ; -- mumifiera..vb.1
  mumifierande_1_N = mkN "mumifierande" ; -- mumifierande..nn.1
  mumifierbar_1_A = mkA "mumifierbar" ; -- mumifierbar..av.1
  mumifierbarhet_1_N = mkN "mumifierbarhet" ; -- mumifierbarhet..nn.1
  mumifiering_1_N = mkN "mumifiering" ; -- mumifiering..nn.1
  mumifikation_1_N = mkN "mumifikation" ; -- mumifikation..nn.1
  mumla_1_V = mkV "mumlar" ; -- mumla..vb.1
  mumlande_1_N = mkN "mumlande" ; -- mumlande..nn.1
  mumma_1_A = mkA "mumma" ; -- mumma..av.1
  mumma_1_N = mkN "mumma" ; -- mumma..nn.1
  mummel_1_N = mkN "mummel" neutrum  ; -- mummel..nn.1
  mumrik_1_N = mkN "mumrik" ; -- mumrik..nn.1
  mums_1_N = mkN "mums" neutrum  ; -- mums..nn.1
  mumsa_1_V = mkV "mumsar" ; -- mumsa..vb.1
  mumsande_1_N = mkN "mumsande" ; -- mumsande..nn.1
  mumsfilibaba_1_A = mkA "mumsfilibaba" ; -- mumsfilibaba..av.1
  mumsfilibabba_1_A = mkA "mumsfilibabba" ; -- mumsfilibabba..av.1
  mumsfillibaba_1_A = mkA "mumsfillibaba" ; -- mumsfillibaba..av.1
  mumsfillibabba_1_A = mkA "mumsfillibabba" ; -- mumsfillibabba..av.1
  mumsig_1_A = mkA "mumsig" ; -- mumsig..av.1
  mumsighet_1_N = mkN "mumsighet" ; -- mumsighet..nn.1
  mumsmums_1_N = mkN "mumsmums" ; -- mumsmums..nn.1
  mumsning_1_N = mkN "mumsning" ; -- mumsning..nn.1
  mun_mot_muninblåsning_1_N = mkN "mun-mot-muninblåsning" ; -- mun-mot-muninblåsning..nn.1
  mun_1_N = mkN "mun" "munnen" "munnar" "munnarna" ; -- mun..nn.1
  munart_1_N = mkN "munart" "munarter" ; -- munart..nn.1
  munartlig_1_A = mkA "munartlig" ; -- munartlig..av.1
  munblåst_1_N = mkN "munblåst" ; -- munblåst..nn.1
  mundering_1_N = mkN "mundering" ; -- mundering..nn.1
  munflora_1_N = mkN "munflora" ; -- munflora..nn.1
  munfull_1_N = mkN "munfull" ; -- munfull..nn.1
  mungiga_1_N = mkN "mungiga" ; -- mungiga..nn.1
  mungipa_1_N = mkN "mungipa" ; -- mungipa..nn.1
  mungo_1_N = mkN "mungo" "mungon" "mungoer" "mungoerna" ; -- mungo..nn.1
  mungo_2_N = mkN "mungo" ; -- mungo..nn.2
  munharmonika_1_N = mkN "munharmonika" ; -- munharmonika..nn.1
  munharpa_1_N = mkN "munharpa" ; -- munharpa..nn.1
  munhäfta_1_N = mkN "munhäfta" ; -- munhäfta..nn.1
  munhåla_1_N = mkN "munhåla" ; -- munhåla..nn.1
  municipal_1_A = mkA "municipal" ; -- municipal..av.1
  municipalsamhälle_1_N = mkN "municipalsamhälle" ; -- municipalsamhälle..nn.1
  municipium_1_N = mkN "municipium" "municipiet" "municipier" "municipierna" ; -- municipium..nn.1
  munk_1_N = mkN "munk" ; -- munk..nn.1
  munkabälte_1_N = mkN "munkabälte" ; -- munkabälte..nn.1
  munkavel_1_N = mkN "munkavel" ; -- munkavel..nn.1
  munkavle_1_N = mkN "munkavle" utrum  ; -- munkavle..nn.1
  munkcell_1_N = mkN "munkcell" "munkceller" ; -- munkcell..nn.1
  munkförband_1_N = mkN "munkförband" neutrum  ; -- munkförband..nn.1
  munkhätta_1_N = mkN "munkhätta" ; -- munkhätta..nn.1
  munkkåpa_1_N = mkN "munkkåpa" ; -- munkkåpa..nn.1
  munklatin_1_N = mkN "munklatin" neutrum  ; -- munklatin..nn.1
  munklikör_1_N = mkN "munklikör" "munklikörer" ; -- munklikör..nn.1
  munklöfte_1_N = mkN "munklöfte" ; -- munklöfte..nn.1
  munkorden_1_N = mkN "munkorden" ; -- munkorden..nn.1
  munkorg_1_N = mkN "munkorg" ; -- munkorg..nn.1
  munkorgslag_1_N = mkN "munkorgslag" ; -- munkorgslag..nn.1
  munkskrift_1_N = mkN "munkskrift" ; -- munkskrift..nn.1
  munkstol_1_N = mkN "munkstol" ; -- munkstol..nn.1
  munktillvaro_1_N = mkN "munktillvaro" ; -- munktillvaro..nn.1
  munlag_1_N = mkN "munlag" neutrum  ; -- munlag..nn.1
  munläder_1_N = mkN "munläder" neutrum  ; -- munläder..nn.1
  munläsa_1_N = mkN "munläsa" ; -- munläsa..nn.1
  munsbit_1_N = mkN "munsbit" ; -- munsbit..nn.1
  munskydd_1_N = mkN "munskydd" neutrum  ; -- munskydd..nn.1
  munskänk_1_N = mkN "munskänk" ; -- munskänk..nn.1
  munslemhinna_1_N = mkN "munslemhinna" ; -- munslemhinna..nn.1
  munspel_1_N = mkN "munspel" "munspelet" "munspel" "munspelen" ; -- munspel..nn.1
  munstycke_1_N = mkN "munstycke" ; -- munstycke..nn.1
  munstycksbyte_1_N = mkN "munstycksbyte" ; -- munstycksbyte..nn.1
  munsår_1_N = mkN "munsår" neutrum  ; -- munsår..nn.1
  munta_1_N = mkN "munta" ; -- munta..nn.1
  munter_1_A = mkA "munter" ; -- munter..av.1
  muntergök_1_N = mkN "muntergök" ; -- muntergök..nn.1
  munterhet_1_N = mkN "munterhet" "munterheter" ; -- munterhet..nn.1
  muntlig_1_A = mkA "muntlig" ; -- muntlig..av.1
  muntligen_1_Adv = mkAdv "muntligen" ; -- muntligen..ab.1
  muntlighet_1_N = mkN "muntlighet" ; -- muntlighet..nn.1
  muntorr_1_A = mkA "muntorr" ; -- muntorr..av.1
  muntorrhet_1_N = mkN "muntorrhet" ; -- muntorrhet..nn.1
  muntration_1_N = mkN "muntration" ; -- muntration..nn.1
  munvatten_1_N = mkN "munvatten" "munvattnet" "munvatten" "munvattnen" ; -- munvatten..nn.1
  munvig_1_A = mkA "munvig" ; -- munvig..av.1
  munvighet_1_N = mkN "munvighet" ; -- munvighet..nn.1
  munvinkel_1_N = mkN "munvinkel" ; -- munvinkel..nn.1
  munväder_1_N = mkN "munväder" neutrum  ; -- munväder..nn.1
  muonneutrino_1_N = mkN "muonneutrino" "muonneutrinor" ; -- muonneutrino..nn.1
  mupp_1_N = mkN "mupp" ; -- mupp..nn.1
  muppig_1_A = mkA "muppig" ; -- muppig..av.1
  muppighet_1_N = mkN "muppighet" ; -- muppighet..nn.1
  mur_1_N = mkN "mur" ; -- mur..nn.1
  mura_1_V = mkV "murar" ; -- mura..vb.1
  mural_1_A = mkA "mural" ; -- mural..av.1
  muralmålning_1_N = mkN "muralmålning" ; -- muralmålning..nn.1
  murande_1_N = mkN "murande" ; -- murande..nn.1
  murankare_1_N = mkN "murankare" "murankaret" "murankaren" "murankarna" ; -- murankare..nn.1
  murare_1_N = mkN "murare" utrum  ; -- murare..nn.1
  murarskjorta_1_N = mkN "murarskjorta" ; -- murarskjorta..nn.1
  murarverktyg_1_N = mkN "murarverktyg" neutrum  ; -- murarverktyg..nn.1
  murband_1_N = mkN "murband" neutrum  ; -- murband..nn.1
  murbruk_1_N = mkN "murbruk" neutrum  ; -- murbruk..nn.1
  murbräcka_1_N = mkN "murbräcka" ; -- murbräcka..nn.1
  murbygge_1_N = mkN "murbygge" ; -- murbygge..nn.1
  murfog_1_N = mkN "murfog" ; -- murfog..nn.1
  murförband_1_N = mkN "murförband" neutrum  ; -- murförband..nn.1
  murgröna_1_N = mkN "murgröna" ; -- murgröna..nn.1
  murgrönemönster_1_N = mkN "murgrönemönster" neutrum  ; -- murgrönemönster..nn.1
  murhörn_1_N = mkN "murhörn" neutrum  ; -- murhörn..nn.1
  murintag_1_N = mkN "murintag" neutrum  ; -- murintag..nn.1
  murkelkindad_1_A = mkA "murkelkindad" ; -- murkelkindad..av.1
  murkelliknande_1_A = mkA "murkelliknande" ; -- murkelliknande..av.1
  murken_1_A = mkA "murken" ; -- murken..av.1
  murkenhet_1_N = mkN "murkenhet" ; -- murkenhet..nn.1
  murkla_1_N = mkN "murkla" ; -- murkla..nn.1
  murkna_1_V = mkV "murknar" ; -- murkna..vb.1
  murknande_1_N = mkN "murknande" ; -- murknande..nn.1
  murkrona_1_N = mkN "murkrona" ; -- murkrona..nn.1
  murkrön_1_N = mkN "murkrön" neutrum  ; -- murkrön..nn.1
  murliv_1_N = mkN "murliv" neutrum  ; -- murliv..nn.1
  murmel_1_N = mkN "murmel" ; -- murmel..nn.1
  murmeldjur_1_N = mkN "murmeldjur" neutrum  ; -- murmeldjur..nn.1
  muromgärdad_1_A = mkA "muromgärdad" ; -- muromgärdad..av.1
  muromsluten_1_A = mkA "muromsluten" ; -- muromsluten..av.1
  murr_1_N = mkN "murr" neutrum  ; -- murr..nn.1
  murra_1_V = mkV "murrar" ; -- murra..vb.1
  murrande_1_N = mkN "murrande" ; -- murrande..nn.1
  murre_1_N = mkN "murre" utrum  ; -- murre..nn.1
  murrig_1_A = mkA "murrig" ; -- murrig..av.1
  murrighet_1_N = mkN "murrighet" ; -- murrighet..nn.1
  mursida_1_N = mkN "mursida" ; -- mursida..nn.1
  murskift_1_N = mkN "murskift" neutrum  ; -- murskift..nn.1
  murslev_1_N = mkN "murslev" ; -- murslev..nn.1
  mursten_1_N = mkN "mursten" "murstenen" "murstenar" "murstenarna" ; -- mursten..nn.1
  murstock_1_N = mkN "murstock" ; -- murstock..nn.1
  murvel_1_N = mkN "murvel" ; -- murvel..nn.1
  murverk_1_N = mkN "murverk" neutrum  ; -- murverk..nn.1
  mus_1_N = mkN "mus" "musen" "möss" "mössen" ; -- mus..nn.1
  mus_2_N = mkN "mus" ; -- mus..nn.2
  musa_1_N = mkN "musa" ; -- musa..nn.1
  musarm_1_N = mkN "musarm" ; -- musarm..nn.1
  musband_1_N = mkN "musband" neutrum  ; -- musband..nn.1
  musbarn_1_N = mkN "musbarn" neutrum  ; -- musbarn..nn.1
  musch_1_N = mkN "musch" "muscher" ; -- musch..nn.1
  museal_1_A = mkA "museal" ; -- museal..av.1
  museibesökare_1_N = mkN "museibesökare" utrum  ; -- museibesökare..nn.1
  museichef_1_N = mkN "museichef" "museichefer" ; -- museichef..nn.1
  museiföremål_1_N = mkN "museiföremål" neutrum  ; -- museiföremål..nn.1
  museiförening_1_N = mkN "museiförening" ; -- museiförening..nn.1
  museiintendent_1_N = mkN "museiintendent" "museiintendenter" ; -- museiintendent..nn.1
  museikatalog_1_N = mkN "museikatalog" "museikataloger" ; -- museikatalog..nn.1
  museikonflikt_1_N = mkN "museikonflikt" "museikonflikter" ; -- museikonflikt..nn.1
  museimonter_1_N = mkN "museimonter" ; -- museimonter..nn.1
  museimässig_1_A = mkA "museimässig" ; -- museimässig..av.1
  museimässighet_1_N = mkN "museimässighet" ; -- museimässighet..nn.1
  museisal_1_N = mkN "museisal" ; -- museisal..nn.1
  museivaktmästare_1_N = mkN "museivaktmästare" utrum  ; -- museivaktmästare..nn.1
  muselman_1_N = mkN "muselman" "muselmaner" ; -- muselman..nn.1
  muselmansk_1_A = mkA "muselmansk" ; -- muselmansk..av.1
  musettedragspel_1_N = mkN "musettedragspel" "musettedragspelet" "musettedragspel" "musettedragspelen" ; -- musettedragspel..nn.1
  museum_1_N = mkN "museum" "museet" "museer" "museerna" ; -- museum..nn.1
  musfälla_1_N = mkN "musfälla" ; -- musfälla..nn.1
  musgrå_1_A = mkA "musgrå" "musgrått" ; -- musgrå..av.1
  mushona_1_N = mkN "mushona" ; -- mushona..nn.1
  musical_1_N = mkN "musical" "musicaler" ; -- musical..nn.1
  musicera_1_V = mkV "musicerar" ; -- musicera..vb.1
  musicerande_1_N = mkN "musicerande" ; -- musicerande..nn.1
  musicering_1_N = mkN "musicering" ; -- musicering..nn.1
  musik_1_N = mkN "musik" ; -- musik..nn.1
  musikal_1_A = mkA "musikal" ; -- musikal..av.1
  musikal_1_N = mkN "musikal" "musikaler" ; -- musikal..nn.1
  musikalbum_1_N = mkN "musikalbum" neutrum  ; -- musikalbum..nn.1
  musikalisk_1_A = mkA "musikalisk" ; -- musikalisk..av.1
  musikalitet_1_N = mkN "musikalitet" "musikaliteter" ; -- musikalitet..nn.1
  musikanläggning_1_N = mkN "musikanläggning" ; -- musikanläggning..nn.1
  musikant_1_N = mkN "musikant" "musikanter" ; -- musikant..nn.1
  musikbransch_1_N = mkN "musikbransch" "musikbranscher" ; -- musikbransch..nn.1
  musikdirektör_1_N = mkN "musikdirektör" "musikdirektörer" ; -- musikdirektör..nn.1
  musikdrama_1_N = mkN "musikdrama" "musikdramat" "musikdramer" "musikdramerna" ; -- musikdrama..nn.1
  musikdramatisk_1_A = mkA "musikdramatisk" ; -- musikdramatisk..av.1
  musikelev_1_N = mkN "musikelev" "musikelever" ; -- musikelev..nn.1
  musikensemble_1_N = mkN "musikensemble" "musikensembler" ; -- musikensemble..nn.1
  musiker_1_N = mkN "musiker" "musikern" "musiker" "musikerna" ; -- musiker..nn.1
  musikermiljö_1_N = mkN "musikermiljö" "musikermiljön" "musikermiljöer" "musikermiljöerna" ; -- musikermiljö..nn.1
  musikfanjunkare_1_N = mkN "musikfanjunkare" utrum  ; -- musikfanjunkare..nn.1
  musikfestival_1_N = mkN "musikfestival" "musikfestivaler" ; -- musikfestival..nn.1
  musikform_1_N = mkN "musikform" "musikformer" ; -- musikform..nn.1
  musikförlag_1_N = mkN "musikförlag" neutrum  ; -- musikförlag..nn.1
  musikgrupp_1_N = mkN "musikgrupp" "musikgrupper" ; -- musikgrupp..nn.1
  musikgudstjänst_1_N = mkN "musikgudstjänst" "musikgudstjänster" ; -- musikgudstjänst..nn.1
  musikgymnasium_1_N = mkN "musikgymnasium" "musikgymnasiet" "musikgymnasier" "musikgymnasierna" ; -- musikgymnasium..nn.1
  musikhögskola_1_N = mkN "musikhögskola" ; -- musikhögskola..nn.1
  musikinstrument_1_N = mkN "musikinstrument" neutrum  ; -- musikinstrument..nn.1
  musikintresserad_1_A = mkA "musikintresserad" ; -- musikintresserad..av.1
  musikkafé_1_N = mkN "musikkafé" "musikkaféet" "musikkaféer" "musikkaféerna" ; -- musikkafé..nn.1
  musikkomposition_1_N = mkN "musikkomposition" ; -- musikkomposition..nn.1
  musikkonservatorium_1_N = mkN "musikkonservatorium" "musikkonservatoriet" "musikkonservatorier" "musikkonservatorierna" ; -- musikkonservatorium..nn.1
  musikkvartett_1_N = mkN "musikkvartett" "musikkvartetter" ; -- musikkvartett..nn.1
  musikkännare_1_N = mkN "musikkännare" utrum  ; -- musikkännare..nn.1
  musikkår_1_N = mkN "musikkår" "musikkårer" ; -- musikkår..nn.1
  musikliv_1_N = mkN "musikliv" neutrum  ; -- musikliv..nn.1
  musiklärare_1_N = mkN "musiklärare" utrum  ; -- musiklärare..nn.1
  musikmässig_1_A = mkA "musikmässig" ; -- musikmässig..av.1
  musikolog_1_N = mkN "musikolog" "musikologer" ; -- musikolog..nn.1
  musikscen_1_N = mkN "musikscen" "musikscener" ; -- musikscen..nn.1
  musikskala_1_N = mkN "musikskala" ; -- musikskala..nn.1
  musikskola_1_N = mkN "musikskola" ; -- musikskola..nn.1
  musikstil_1_N = mkN "musikstil" ; -- musikstil..nn.1
  musikstycke_1_N = mkN "musikstycke" ; -- musikstycke..nn.1
  musikställe_1_N = mkN "musikställe" ; -- musikställe..nn.1
  musikstämma_1_N = mkN "musikstämma" ; -- musikstämma..nn.1
  musiktecken_1_N = mkN "musiktecken" "musiktecknet" "musiktecken" "musiktecknen" ; -- musiktecken..nn.1
  musiktomte_1_N = mkN "musiktomte" utrum  ; -- musiktomte..nn.1
  musikverk_1_N = mkN "musikverk" neutrum  ; -- musikverk..nn.1
  musikverksamhet_1_N = mkN "musikverksamhet" "musikverksamheter" ; -- musikverksamhet..nn.1
  musikvetenskap_1_N = mkN "musikvetenskap" "musikvetenskaper" ; -- musikvetenskap..nn.1
  musikvideo_1_N = mkN "musikvideo" "musikvideor" ; -- musikvideo..nn.1
  musikälskare_1_N = mkN "musikälskare" utrum  ; -- musikälskare..nn.1
  musisk_1_A = mkA "musisk" ; -- musisk..av.1
  musivguld_1_N = mkN "musivguld" neutrum  ; -- musivguld..nn.1
  musjik_1_N = mkN "musjik" "musjiker" ; -- musjik..nn.1
  muskat_1_N = mkN "muskat" ; -- muskat..nn.1
  muskatdruva_1_N = mkN "muskatdruva" ; -- muskatdruva..nn.1
  muskatell_1_N = mkN "muskatell" ; -- muskatell..nn.1
  muskedunder_1_N = mkN "muskedunder" neutrum  ; -- muskedunder..nn.1
  muskel_1_N = mkN "muskel" "muskeln" "muskler" "musklerna" ; -- muskel..nn.1
  muskelarbete_1_N = mkN "muskelarbete" ; -- muskelarbete..nn.1
  muskelatrofi_1_N = mkN "muskelatrofi" "muskelatrofier" ; -- muskelatrofi..nn.1
  muskelbil_1_N = mkN "muskelbil" ; -- muskelbil..nn.1
  muskelbristning_1_N = mkN "muskelbristning" ; -- muskelbristning..nn.1
  muskelbyggare_1_N = mkN "muskelbyggare" utrum  ; -- muskelbyggare..nn.1
  muskelbyggnad_1_N = mkN "muskelbyggnad" "muskelbyggnader" ; -- muskelbyggnad..nn.1
  muskelbåt_1_N = mkN "muskelbåt" ; -- muskelbåt..nn.1
  muskelcell_1_N = mkN "muskelcell" "muskelceller" ; -- muskelcell..nn.1
  muskelfiber_1_N = mkN "muskelfiber" "muskelfibern" "muskelfibrer" "muskelfibrerna" ; -- muskelfiber..nn.1
  muskelförlamning_1_N = mkN "muskelförlamning" ; -- muskelförlamning..nn.1
  muskelförtvining_1_N = mkN "muskelförtvining" ; -- muskelförtvining..nn.1
  muskelknippe_1_N = mkN "muskelknippe" ; -- muskelknippe..nn.1
  muskelknutte_1_N = mkN "muskelknutte" utrum  ; -- muskelknutte..nn.1
  muskelkraft_1_N = mkN "muskelkraft" "muskelkrafter" ; -- muskelkraft..nn.1
  muskelkramp_1_N = mkN "muskelkramp" "muskelkramper" ; -- muskelkramp..nn.1
  muskellängd_1_N = mkN "muskellängd" "muskellängder" ; -- muskellängd..nn.1
  muskelmage_1_N = mkN "muskelmage" utrum  ; -- muskelmage..nn.1
  muskelmassa_1_N = mkN "muskelmassa" ; -- muskelmassa..nn.1
  muskelreumatism_1_N = mkN "muskelreumatism" "muskelreumatismer" ; -- muskelreumatism..nn.1
  muskelring_1_N = mkN "muskelring" ; -- muskelring..nn.1
  muskelryckning_1_N = mkN "muskelryckning" ; -- muskelryckning..nn.1
  muskelrörelse_1_N = mkN "muskelrörelse" "muskelrörelser" ; -- muskelrörelse..nn.1
  muskelsammandragning_1_N = mkN "muskelsammandragning" ; -- muskelsammandragning..nn.1
  muskelsena_1_N = mkN "muskelsena" ; -- muskelsena..nn.1
  muskelsinne_1_N = mkN "muskelsinne" ; -- muskelsinne..nn.1
  muskelspole_1_N = mkN "muskelspole" utrum  ; -- muskelspole..nn.1
  muskelspänning_1_N = mkN "muskelspänning" ; -- muskelspänning..nn.1
  muskelstark_1_A = mkA "muskelstark" ; -- muskelstark..av.1
  muskelsträckning_1_N = mkN "muskelsträckning" ; -- muskelsträckning..nn.1
  muskelstyrka_1_N = mkN "muskelstyrka" ; -- muskelstyrka..nn.1
  muskelstärkare_1_N = mkN "muskelstärkare" utrum  ; -- muskelstärkare..nn.1
  muskeltråd_1_N = mkN "muskeltråd" ; -- muskeltråd..nn.1
  muskelvärk_1_N = mkN "muskelvärk" ; -- muskelvärk..nn.1
  muskelvävnad_1_N = mkN "muskelvävnad" "muskelvävnader" ; -- muskelvävnad..nn.1
  musketerare_1_N = mkN "musketerare" utrum  ; -- musketerare..nn.1
  musketör_1_N = mkN "musketör" "musketörer" ; -- musketör..nn.1
  musklick_1_N = mkN "musklick" neutrum  ; -- musklick..nn.1
  muskot_1_N = mkN "muskot" ; -- muskot..nn.1
  muskotblomma_1_N = mkN "muskotblomma" ; -- muskotblomma..nn.1
  muskotnöt_1_N = mkN "muskotnöt" "muskotnötter" ; -- muskotnöt..nn.1
  muskotträd_1_N = mkN "muskotträd" neutrum  ; -- muskotträd..nn.1
  muskulatur_1_N = mkN "muskulatur" "muskulaturer" ; -- muskulatur..nn.1
  muskulös_1_A = mkA "muskulös" ; -- muskulös..av.1
  musköt_1_N = mkN "musköt" "musköter" ; -- musköt..nn.1
  muskötgaffel_1_N = mkN "muskötgaffel" ; -- muskötgaffel..nn.1
  muslim_1_N = mkN "muslim" "muslimer" ; -- muslim..nn.1
  muslimkramare_1_N = mkN "muslimkramare" utrum  ; -- muslimkramare..nn.1
  muslimsk_1_A = mkA "muslimsk" ; -- muslimsk..av.1
  muslin_1_N = mkN "muslin" "musliner" ; -- muslin..nn.1
  muslinsklänning_1_N = mkN "muslinsklänning" ; -- muslinsklänning..nn.1
  musmamma_1_N = mkN "musmamma" ; -- musmamma..nn.1
  musselform_1_N = mkN "musselform" "musselformer" ; -- musselform..nn.1
  musselodling_1_N = mkN "musselodling" ; -- musselodling..nn.1
  musselskal_1_N = mkN "musselskal" neutrum  ; -- musselskal..nn.1
  mussemajje_1_N = mkN "mussemajje" utrum  ; -- mussemajje..nn.1
  mussera_1_V = mkV "musserar" ; -- mussera..vb.1
  musserande_1_N = mkN "musserande" ; -- musserande..nn.1
  mussering_1_N = mkN "mussering" ; -- mussering..nn.1
  musseron_1_N = mkN "musseron" "musseroner" ; -- musseron..nn.1
  mussla_1_N = mkN "mussla" ; -- mussla..nn.1
  must_1_N = mkN "must" "muster" ; -- must..nn.1
  must_2_N = mkN "must" ; -- must..nn.2
  must_3_N = mkN "must" ; -- must..nn.3
  mustang_1_N = mkN "mustang" "mustanger" ; -- mustang..nn.1
  mustasch_1_N = mkN "mustasch" "mustascher" ; -- mustasch..nn.1
  mustaschprydd_1_A = mkA "mustaschprydd" ; -- mustaschprydd..av.1
  musteri_1_N = mkN "musteri" "musteriet" "musterier" "musterierna" ; -- musteri..nn.1
  mustig_1_A = mkA "mustig" ; -- mustig..av.1
  mustighet_1_N = mkN "mustighet" ; -- mustighet..nn.1
  mustrakt_1_N = mkN "mustrakt" "mustrakter" ; -- mustrakt..nn.1
  musunge_1_N = mkN "musunge" utrum  ; -- musunge..nn.1
  musöra_1_N = mkN "musöra" "musörat" "musöron" "musöronen" ; -- musöra..nn.1
  muta_1_N = mkN "muta" ; -- muta..nn.1
  muta_1_V = mkV "mutar" ; -- muta..vb.1
  muta_2_V = mkV "mutar" ; -- muta..vb.2
  mutagen_1_A = mkA "mutagen" "mutagent" ; -- mutagen..av.1
  mutagen_1_N = mkN "mutagen" "mutagener" ; -- mutagen..nn.1
  mutande_1_N = mkN "mutande" ; -- mutande..nn.1
  mutanklagad_1_A = mkA "mutanklagad" ; -- mutanklagad..av.1
  mutant_1_N = mkN "mutant" "mutanter" ; -- mutant..nn.1
  mutation_1_N = mkN "mutation" ; -- mutation..nn.1
  mutbar_1_A = mkA "mutbar" ; -- mutbar..av.1
  mutbarhet_1_N = mkN "mutbarhet" ; -- mutbarhet..nn.1
  mutbrott_1_N = mkN "mutbrott" neutrum  ; -- mutbrott..nn.1
  mutera_1_V = mkV "muterar" ; -- mutera..vb.1
  muterande_1_N = mkN "muterande" ; -- muterande..nn.1
  muterbar_1_A = mkA "muterbar" ; -- muterbar..av.1
  muterbarhet_1_N = mkN "muterbarhet" ; -- muterbarhet..nn.1
  mutering_1_N = mkN "mutering" ; -- mutering..nn.1
  mutexpert_1_N = mkN "mutexpert" "mutexperter" ; -- mutexpert..nn.1
  mutgubbe_1_N = mkN "mutgubbe" utrum  ; -- mutgubbe..nn.1
  muthärva_1_N = mkN "muthärva" ; -- muthärva..nn.1
  mutkolv_1_N = mkN "mutkolv" ; -- mutkolv..nn.1
  mutmisstänkt_1_A = mkA "mutmisstänkt" "mutmisstänkt" ; -- mutmisstänkt..av.1
  mutmöjlig_1_A = mkA "mutmöjlig" ; -- mutmöjlig..av.1
  mutning_1_N = mkN "mutning" ; -- mutning..nn.1
  mutsedel_1_N = mkN "mutsedel" ; -- mutsedel..nn.1
  mutskandal_1_N = mkN "mutskandal" "mutskandaler" ; -- mutskandal..nn.1
  mutsystem_1_N = mkN "mutsystem" neutrum  ; -- mutsystem..nn.1
  mutta_1_N = mkN "mutta" ; -- mutta..nn.1
  mutter_1_N = mkN "mutter" ; -- mutter..nn.1
  mutterbricka_1_N = mkN "mutterbricka" ; -- mutterbricka..nn.1
  mutterdragare_1_N = mkN "mutterdragare" utrum  ; -- mutterdragare..nn.1
  mutterknack_1_N = mkN "mutterknack" neutrum  ; -- mutterknack..nn.1
  muttra_1_V = mkV "muttrar" ; -- muttra..vb.1
  muttrande_1_N = mkN "muttrande" ; -- muttrande..nn.1
  muzak_1_N = mkN "muzak" ; -- muzak..nn.1
  muzjik_1_N = mkN "muzjik" "muzjiker" ; -- muzjik..nn.1
  my_1_N = mkN "my" neutrum  ; -- my..nn.1
  mycelium_1_N = mkN "mycelium" "myceliet" "mycelier" "mycelierna" ; -- mycelium..nn.1
  myckenhet_1_N = mkN "myckenhet" "myckenheter" ; -- myckenhet..nn.1
  mycket_1_Adv = mkAdv "mycket" ; -- mycket..ab.1
  mygel_1_N = mkN "mygel" neutrum  ; -- mygel..nn.1
  mygg_1_N = mkN "mygg" neutrum  ; -- mygg..nn.1
  mygga_1_N = mkN "mygga" ; -- mygga..nn.1
  myggbett_1_N = mkN "myggbett" neutrum  ; -- myggbett..nn.1
  myggbiten_1_A = mkA "myggbiten" ; -- myggbiten..av.1
  myggfönster_1_N = mkN "myggfönster" neutrum  ; -- myggfönster..nn.1
  myggjagare_1_N = mkN "myggjagare" utrum  ; -- myggjagare..nn.1
  mygglarv_1_N = mkN "mygglarv" "mygglarver" ; -- mygglarv..nn.1
  myggmedel_1_N = mkN "myggmedel" neutrum  ; -- myggmedel..nn.1
  myggnät_1_N = mkN "myggnät" neutrum  ; -- myggnät..nn.1
  myggnätsdörr_1_N = mkN "myggnätsdörr" ; -- myggnätsdörr..nn.1
  mygla_1_V = mkV "myglar" ; -- mygla..vb.1
  myglande_1_N = mkN "myglande" ; -- myglande..nn.1
  myglare_1_N = mkN "myglare" utrum  ; -- myglare..nn.1
  mykensk_1_A = mkA "mykensk" ; -- mykensk..av.1
  mykolog_1_N = mkN "mykolog" "mykologer" ; -- mykolog..nn.1
  mykologi_1_N = mkN "mykologi" ; -- mykologi..nn.1
  mykologisk_1_A = mkA "mykologisk" ; -- mykologisk..av.1
  mykorrhiza_1_N = mkN "mykorrhiza" ; -- mykorrhiza..nn.1
  myling_1_N = mkN "myling" ; -- myling..nn.1
  mylla_1_N = mkN "mylla" ; -- mylla..nn.1
  mylla_1_V = mkV "myllar" ; -- mylla..vb.1
  myllande_1_N = mkN "myllande" ; -- myllande..nn.1
  myller_1_N = mkN "myller" neutrum  ; -- myller..nn.1
  myllig_1_A = mkA "myllig" ; -- myllig..av.1
  myllighet_1_N = mkN "myllighet" ; -- myllighet..nn.1
  myllra_1_V = mkV "myllrar" ; -- myllra..vb.1
  myllrande_1_N = mkN "myllrande" ; -- myllrande..nn.1
  mylta_1_N = mkN "mylta" ; -- mylta..nn.1
  myndig_1_A = mkA "myndig" ; -- myndig..av.1
  myndighet_1_N = mkN "myndighet" "myndigheter" ; -- myndighet..nn.1
  myndighet_2_N = mkN "myndighet" ; -- myndighet..nn.2
  myndighetschef_1_N = mkN "myndighetschef" "myndighetschefer" ; -- myndighetschef..nn.1
  myndighetsföreträdare_1_N = mkN "myndighetsföreträdare" utrum  ; -- myndighetsföreträdare..nn.1
  myndighetsförklaring_1_N = mkN "myndighetsförklaring" ; -- myndighetsförklaring..nn.1
  myndighetsperson_1_N = mkN "myndighetsperson" "myndighetspersoner" ; -- myndighetsperson..nn.1
  myndighetsrepresentant_1_N = mkN "myndighetsrepresentant" "myndighetsrepresentanter" ; -- myndighetsrepresentant..nn.1
  myndighetssnack_1_N = mkN "myndighetssnack" neutrum  ; -- myndighetssnack..nn.1
  myndighetstillstånd_1_N = mkN "myndighetstillstånd" neutrum  ; -- myndighetstillstånd..nn.1
  myndighetsutövare_1_N = mkN "myndighetsutövare" utrum  ; -- myndighetsutövare..nn.1
  myndighetsutövning_1_N = mkN "myndighetsutövning" ; -- myndighetsutövning..nn.1
  myndighetsålder_1_N = mkN "myndighetsålder" ; -- myndighetsålder..nn.1
  myndling_1_N = mkN "myndling" ; -- myndling..nn.1
  mynna_1_V = mkV "mynnar" ; -- mynna..vb.1
  mynnande_1_N = mkN "mynnande" ; -- mynnande..nn.1
  mynning_1_N = mkN "mynning" ; -- mynning..nn.1
  mynningsarm_1_N = mkN "mynningsarm" ; -- mynningsarm..nn.1
  mynningsbroms_1_N = mkN "mynningsbroms" ; -- mynningsbroms..nn.1
  mynningsflamma_1_N = mkN "mynningsflamma" ; -- mynningsflamma..nn.1
  mynningsknall_1_N = mkN "mynningsknall" ; -- mynningsknall..nn.1
  mynningsladdare_1_N = mkN "mynningsladdare" utrum  ; -- mynningsladdare..nn.1
  mynt_1_N = mkN "mynt" neutrum  ; -- mynt..nn.1
  mynta_1_N = mkN "mynta" ; -- mynta..nn.1
  mynta_1_V = mkV "myntar" ; -- mynta..vb.1
  myntande_1_N = mkN "myntande" ; -- myntande..nn.1
  myntautomat_1_N = mkN "myntautomat" "myntautomater" ; -- myntautomat..nn.1
  myntcirkulation_1_N = mkN "myntcirkulation" ; -- myntcirkulation..nn.1
  myntenhet_1_N = mkN "myntenhet" "myntenheter" ; -- myntenhet..nn.1
  myntfot_1_N = mkN "myntfot" ; -- myntfot..nn.1
  myntinkast_1_N = mkN "myntinkast" neutrum  ; -- myntinkast..nn.1
  myntlucka_1_N = mkN "myntlucka" ; -- myntlucka..nn.1
  myntlåda_1_N = mkN "myntlåda" ; -- myntlåda..nn.1
  myntmetall_1_N = mkN "myntmetall" "myntmetaller" ; -- myntmetall..nn.1
  myntrealisation_1_N = mkN "myntrealisation" ; -- myntrealisation..nn.1
  myntsamling_1_N = mkN "myntsamling" ; -- myntsamling..nn.1
  myntsystem_1_N = mkN "myntsystem" neutrum  ; -- myntsystem..nn.1
  mynttecken_1_N = mkN "mynttecken" "mynttecknet" "mynttecken" "mynttecknen" ; -- mynttecken..nn.1
  myntunion_1_N = mkN "myntunion" ; -- myntunion..nn.1
  myntvalör_1_N = mkN "myntvalör" "myntvalörer" ; -- myntvalör..nn.1
  myntverk_1_N = mkN "myntverk" neutrum  ; -- myntverk..nn.1
  myntvikt_1_N = mkN "myntvikt" "myntvikter" ; -- myntvikt..nn.1
  myntväsen_1_N = mkN "myntväsen" neutrum  ; -- myntväsen..nn.1
  myogen_1_N = mkN "myogen" neutrum  ; -- myogen..nn.1
  myom_1_N = mkN "myom" neutrum  ; -- myom..nn.1
  myon_1_N = mkN "myon" "myoner" ; -- myon..nn.1
  myopi_1_N = mkN "myopi" ; -- myopi..nn.1
  myopisk_1_A = mkA "myopisk" ; -- myopisk..av.1
  myosin_1_N = mkN "myosin" "myosiner" ; -- myosin..nn.1
  myr_1_N = mkN "myr" ; -- myr..nn.1
  myra_1_N = mkN "myra" ; -- myra..nn.1
  myrbagge_1_N = mkN "myrbagge" utrum  ; -- myrbagge..nn.1
  myrdrottning_1_N = mkN "myrdrottning" ; -- myrdrottning..nn.1
  myrforskare_1_N = mkN "myrforskare" utrum  ; -- myrforskare..nn.1
  myrgäst_1_N = mkN "myrgäst" "myrgäster" ; -- myrgäst..nn.1
  myrholme_1_N = mkN "myrholme" utrum  ; -- myrholme..nn.1
  myriad_1_N = mkN "myriad" "myriader" ; -- myriad..nn.1
  myrkant_1_N = mkN "myrkant" "myrkanter" ; -- myrkant..nn.1
  myrkott_1_N = mkN "myrkott" ; -- myrkott..nn.1
  myrkrypning_1_N = mkN "myrkrypning" ; -- myrkrypning..nn.1
  myrland_1_N = mkN "myrland" neutrum  ; -- myrland..nn.1
  myrlejon_1_N = mkN "myrlejon" neutrum  ; -- myrlejon..nn.1
  myrlejonslända_1_N = mkN "myrlejonslända" ; -- myrlejonslända..nn.1
  myrlilja_1_N = mkN "myrlilja" ; -- myrlilja..nn.1
  myrmalm_1_N = mkN "myrmalm" "myrmalmer" ; -- myrmalm..nn.1
  myrmark_1_N = mkN "myrmark" "myrmarker" ; -- myrmark..nn.1
  myrra_1_N = mkN "myrra" ; -- myrra..nn.1
  myrsamhälle_1_N = mkN "myrsamhälle" ; -- myrsamhälle..nn.1
  myrslok_1_N = mkN "myrslok" ; -- myrslok..nn.1
  myrspov_1_N = mkN "myrspov" ; -- myrspov..nn.1
  myrstack_1_N = mkN "myrstack" ; -- myrstack..nn.1
  myrsteg_1_N = mkN "myrsteg" neutrum  ; -- myrsteg..nn.1
  myrstig_1_N = mkN "myrstig" ; -- myrstig..nn.1
  myrsyra_1_N = mkN "myrsyra" ; -- myrsyra..nn.1
  myrten_1_N = mkN "myrten" "myrtenn" "myrtnar" "myrtnarna" ; -- myrten..nn.1
  myrtenkrona_1_N = mkN "myrtenkrona" ; -- myrtenkrona..nn.1
  myrväxt_1_N = mkN "myrväxt" "myrväxter" ; -- myrväxt..nn.1
  myrägg_1_N = mkN "myrägg" neutrum  ; -- myrägg..nn.1
  mys_1_N = mkN "mys" neutrum  ; -- mys..nn.1
  mysa_1_V = mkV "myser" ; -- mysa..vb.1
  mysande_1_N = mkN "mysande" ; -- mysande..nn.1
  mysdress_1_N = mkN "mysdress" ; -- mysdress..nn.1
  mysfaktor_1_N = mkN "mysfaktor" "mysfaktorer" ; -- mysfaktor..nn.1
  mysfyllo_1_N = mkN "mysfyllo" "mysfyllot" "mysfyllon" "mysfyllona" ; -- mysfyllo..nn.1
  mysig_1_A = mkA "mysig" ; -- mysig..av.1
  mysk_1_N = mkN "mysk" ; -- mysk..nn.1
  myskdjur_1_N = mkN "myskdjur" neutrum  ; -- myskdjur..nn.1
  myskdoftande_1_A = mkA "myskdoftande" ; -- myskdoftande..av.1
  myskhjort_1_N = mkN "myskhjort" ; -- myskhjort..nn.1
  myskmadra_1_N = mkN "myskmadra" ; -- myskmadra..nn.1
  mysko_1_A = mkA "mysko" ; -- mysko..av.1
  myskolja_1_N = mkN "myskolja" ; -- myskolja..nn.1
  myskoxe_1_N = mkN "myskoxe" utrum  ; -- myskoxe..nn.1
  myskoxkalv_1_N = mkN "myskoxkalv" ; -- myskoxkalv..nn.1
  mysning_1_N = mkN "mysning" ; -- mysning..nn.1
  mysteriereligion_1_N = mkN "mysteriereligion" ; -- mysteriereligion..nn.1
  mysteriespel_1_N = mkN "mysteriespel" "mysteriespelet" "mysteriespel" "mysteriespelen" ; -- mysteriespel..nn.1
  mysterium_1_N = mkN "mysterium" "mysteriet" "mysterier" "mysterierna" ; -- mysterium..nn.1
  mysteriös_1_A = mkA "mysteriös" ; -- mysteriös..av.1
  mysticism_1_N = mkN "mysticism" "mysticismer" ; -- mysticism..nn.1
  mysticistisk_1_A = mkA "mysticistisk" ; -- mysticistisk..av.1
  mystifiera_1_V = mkV "mystifierar" ; -- mystifiera..vb.1
  mystifierande_1_N = mkN "mystifierande" ; -- mystifierande..nn.1
  mystifierbar_1_A = mkA "mystifierbar" ; -- mystifierbar..av.1
  mystifierbarhet_1_N = mkN "mystifierbarhet" ; -- mystifierbarhet..nn.1
  mystifiering_1_N = mkN "mystifiering" ; -- mystifiering..nn.1
  mystifik_1_A = mkA "mystifik" ; -- mystifik..av.1
  mystifikation_1_N = mkN "mystifikation" ; -- mystifikation..nn.1
  mystik_1_N = mkN "mystik" ; -- mystik..nn.1
  mystiker_1_N = mkN "mystiker" "mystikern" "mystiker" "mystikerna" ; -- mystiker..nn.1
  mystisk_1_A = mkA "mystisk" ; -- mystisk..av.1
  myt_1_N = mkN "myt" "myter" ; -- myt..nn.1
  mytbildning_1_N = mkN "mytbildning" ; -- mytbildning..nn.1
  myteri_1_N = mkN "myteri" "myteriet" "myterier" "myterierna" ; -- myteri..nn.1
  myterist_1_N = mkN "myterist" "myterister" ; -- myterist..nn.1
  mytflora_1_N = mkN "mytflora" ; -- mytflora..nn.1
  mytforskare_1_N = mkN "mytforskare" utrum  ; -- mytforskare..nn.1
  mytifiera_1_V = mkV "mytifierar" ; -- mytifiera..vb.1
  mytifierande_1_N = mkN "mytifierande" ; -- mytifierande..nn.1
  mytifiering_1_N = mkN "mytifiering" ; -- mytifiering..nn.1
  mytisk_1_A = mkA "mytisk" ; -- mytisk..av.1
  mytolog_1_N = mkN "mytolog" "mytologer" ; -- mytolog..nn.1
  mytologi_1_N = mkN "mytologi" "mytologier" ; -- mytologi..nn.1
  mytologisk_1_A = mkA "mytologisk" ; -- mytologisk..av.1
  mytoman_1_N = mkN "mytoman" "mytomaner" ; -- mytoman..nn.1
  mytomani_1_N = mkN "mytomani" ; -- mytomani..nn.1
  mytomspunnen_1_A = mkA "mytomspunnen" "mytomspunnet" "mytomspunna" "mytomspunna" "mytomspunnare" "mytomspunnast" "mytomspunnaste" ; -- mytomspunnen..av.1
  mytskapande_1_A = mkA "mytskapande" ; -- mytskapande..av.1
  mytspridning_1_N = mkN "mytspridning" ; -- mytspridning..nn.1
  myxödem_1_N = mkN "myxödem" neutrum  ; -- myxödem..nn.1
  mähä_1_N = mkN "mähä" "mähät" "mähän" "mähäna" ; -- mähä..nn.1
  mäkla_1_V = mkV "mäklar" ; -- mäkla..vb.1
  mäkla_2_V = mkV "mäklar" ; -- mäkla..vb.2
  mäklande_1_N = mkN "mäklande" ; -- mäklande..nn.1
  mäklararvode_1_N = mkN "mäklararvode" ; -- mäklararvode..nn.1
  mäklare_1_N = mkN "mäklare" utrum  ; -- mäklare..nn.1
  mäklarinformation_1_N = mkN "mäklarinformation" ; -- mäklarinformation..nn.1
  mäkta_1_V = mkV "mäktar" ; -- mäkta..vb.1
  mäktande_1_N = mkN "mäktande" ; -- mäktande..nn.1
  mäktig_1_A = mkA "mäktig" ; -- mäktig..av.1
  mäktighet_1_N = mkN "mäktighet" "mäktigheter" ; -- mäktighet..nn.1
  mäla_1_V = mkV "mäler" ; -- mäla..vb.1
  mälande_1_N = mkN "mälande" ; -- mälande..nn.1
  mälarlandskap_1_N = mkN "mälarlandskap" neutrum  ; -- mälarlandskap..nn.1
  mäld_1_N = mkN "mäld" "mälder" ; -- mäld..nn.1
  mäll_1_N = mkN "mäll" ; -- mäll..nn.1
  mälta_1_N = mkN "mälta" ; -- mälta..nn.1
  mälta_1_V = mkV "mältar" ; -- mälta..vb.1
  mältande_1_N = mkN "mältande" ; -- mältande..nn.1
  mälteri_1_N = mkN "mälteri" "mälteriet" "mälterier" "mälterierna" ; -- mälteri..nn.1
  mänga_1_V = mkV "mänger" ; -- mänga..vb.1
  mängande_1_N = mkN "mängande" ; -- mängande..nn.1
  mängd_1_N = mkN "mängd" "mängder" ; -- mängd..nn.1
  mängddiagram_1_N = mkN "mängddiagram" "mängddiagrammet" "mängddiagram" "mängddiagrammen" ; -- mängddiagram..nn.1
  mängdlära_1_N = mkN "mängdlära" ; -- mängdlära..nn.1
  mängdvis_1_Adv = mkAdv "mängdvis" ; -- mängdvis..ab.1
  människa_1_N = mkN "människa" ; -- människa..nn.1
  människoande_1_N = mkN "människoande" utrum  ; -- människoande..nn.1
  människoansikte_1_N = mkN "människoansikte" ; -- människoansikte..nn.1
  människoapa_1_N = mkN "människoapa" ; -- människoapa..nn.1
  människobarn_1_N = mkN "människobarn" neutrum  ; -- människobarn..nn.1
  människoben_1_N = mkN "människoben" neutrum  ; -- människoben..nn.1
  människoblod_1_N = mkN "människoblod" neutrum  ; -- människoblod..nn.1
  människobröst_1_N = mkN "människobröst" neutrum  ; -- människobröst..nn.1
  människobörda_1_N = mkN "människobörda" ; -- människobörda..nn.1
  människocentrerad_1_A = mkA "människocentrerad" ; -- människocentrerad..av.1
  människofientlig_1_A = mkA "människofientlig" ; -- människofientlig..av.1
  människofientlighet_1_N = mkN "människofientlighet" ; -- människofientlighet..nn.1
  människofigur_1_N = mkN "människofigur" "människofigurer" ; -- människofigur..nn.1
  människofoster_1_N = mkN "människofoster" neutrum  ; -- människofoster..nn.1
  människoföda_1_N = mkN "människoföda" ; -- människoföda..nn.1
  människoförakt_1_N = mkN "människoförakt" neutrum  ; -- människoförakt..nn.1
  människoföraktande_1_A = mkA "människoföraktande" ; -- människoföraktande..av.1
  människoföraktare_1_N = mkN "människoföraktare" utrum  ; -- människoföraktare..nn.1
  människogestalt_1_N = mkN "människogestalt" "människogestalter" ; -- människogestalt..nn.1
  människogestaltad_1_A = mkA "människogestaltad" ; -- människogestaltad..av.1
  människohaj_1_N = mkN "människohaj" ; -- människohaj..nn.1
  människohamn_1_N = mkN "människohamn" ; -- människohamn..nn.1
  människohand_1_N = mkN "människohand" "människohänder" ; -- människohand..nn.1
  människohandel_1_N = mkN "människohandel" ; -- människohandel..nn.1
  människohat_1_N = mkN "människohat" neutrum  ; -- människohat..nn.1
  människohatare_1_N = mkN "människohatare" utrum  ; -- människohatare..nn.1
  människohjärta_1_N = mkN "människohjärta" "människohjärtat" "människohjärtan" "människohjärtana" ; -- människohjärta..nn.1
  människointresse_1_N = mkN "människointresse" ; -- människointresse..nn.1
  människojakt_1_N = mkN "människojakt" "människojakter" ; -- människojakt..nn.1
  människokropp_1_N = mkN "människokropp" ; -- människokropp..nn.1
  människokännare_1_N = mkN "människokännare" utrum  ; -- människokännare..nn.1
  människokännedom_1_N = mkN "människokännedom" ; -- människokännedom..nn.1
  människokärlek_1_N = mkN "människokärlek" ; -- människokärlek..nn.1
  människolik_1_A = mkA "människolik" ; -- människolik..av.1
  människolik_1_N = mkN "människolik" neutrum  ; -- människolik..nn.1
  människolikhet_1_N = mkN "människolikhet" ; -- människolikhet..nn.1
  människoliknande_1_A = mkA "människoliknande" ; -- människoliknande..av.1
  människoliv_1_N = mkN "människoliv" neutrum  ; -- människoliv..nn.1
  människomassa_1_N = mkN "människomassa" ; -- människomassa..nn.1
  människomaterial_1_N = mkN "människomaterial" neutrum  ; -- människomaterial..nn.1
  människooffer_1_N = mkN "människooffer" neutrum  ; -- människooffer..nn.1
  människoomflyttning_1_N = mkN "människoomflyttning" ; -- människoomflyttning..nn.1
  människoras_1_N = mkN "människoras" "människoraser" ; -- människoras..nn.1
  människorov_1_N = mkN "människorov" neutrum  ; -- människorov..nn.1
  människorovshärva_1_N = mkN "människorovshärva" ; -- människorovshärva..nn.1
  människorättsaktivist_1_N = mkN "människorättsaktivist" "människorättsaktivister" ; -- människorättsaktivist..nn.1
  människorättsbrott_1_N = mkN "människorättsbrott" neutrum  ; -- människorättsbrott..nn.1
  människorättsföreträdare_1_N = mkN "människorättsföreträdare" utrum  ; -- människorättsföreträdare..nn.1
  människorättskamp_1_N = mkN "människorättskamp" ; -- människorättskamp..nn.1
  människorättskämpe_1_N = mkN "människorättskämpe" utrum  ; -- människorättskämpe..nn.1
  människorättslig_1_A = mkA "människorättslig" ; -- människorättslig..av.1
  människorättsorganisation_1_N = mkN "människorättsorganisation" ; -- människorättsorganisation..nn.1
  människoröst_1_N = mkN "människoröst" "människoröster" ; -- människoröst..nn.1
  människoskildring_1_N = mkN "människoskildring" ; -- människoskildring..nn.1
  människosläkte_1_N = mkN "människosläkte" ; -- människosläkte..nn.1
  människosmugglare_1_N = mkN "människosmugglare" utrum  ; -- människosmugglare..nn.1
  människosmuggling_1_N = mkN "människosmuggling" ; -- människosmuggling..nn.1
  människoson_1_N = mkN "människoson" ; -- människoson..nn.1
  människospermie_1_N = mkN "människospermie" "människospermier" ; -- människospermie..nn.1
  människosyn_1_N = mkN "människosyn" ; -- människosyn..nn.1
  människotand_1_N = mkN "människotand" "människotänder" ; -- människotand..nn.1
  människouppfattning_1_N = mkN "människouppfattning" ; -- människouppfattning..nn.1
  människovän_1_N = mkN "människovän" "människovännen" "människovänner" "människovännerna" ; -- människovän..nn.1
  människovänlig_1_A = mkA "människovänlig" ; -- människovänlig..av.1
  människovänlighet_1_N = mkN "människovänlighet" "människovänligheter" ; -- människovänlighet..nn.1
  människovärde_1_N = mkN "människovärde" ; -- människovärde..nn.1
  människovärdig_1_A = mkA "människovärdig" ; -- människovärdig..av.1
  människovärdighet_1_N = mkN "människovärdighet" ; -- människovärdighet..nn.1
  människoätande_1_A = mkA "människoätande" ; -- människoätande..av.1
  människoätare_1_N = mkN "människoätare" utrum  ; -- människoätare..nn.1
  människoöde_1_N = mkN "människoöde" ; -- människoöde..nn.1
  mänska_1_N = mkN "mänska" ; -- mänska..nn.1
  mänsklig_1_A = mkA "mänsklig" ; -- mänsklig..av.1
  mänsklig_2_A = mkA "mänsklig" ; -- mänsklig..av.2
  mänsklighet_1_N = mkN "mänsklighet" "mänskligheter" ; -- mänsklighet..nn.1
  mänskobarn_1_N = mkN "mänskobarn" neutrum  ; -- mänskobarn..nn.1
  mär_1_N = mkN "mär" "märer" ; -- mär..nn.1
  märg_1_N = mkN "märg" ; -- märg..nn.1
  märgben_1_N = mkN "märgben" neutrum  ; -- märgben..nn.1
  märgel_1_N = mkN "märgel" ; -- märgel..nn.1
  märgelgrav_1_N = mkN "märgelgrav" ; -- märgelgrav..nn.1
  märgelskiffer_1_N = mkN "märgelskiffer" ; -- märgelskiffer..nn.1
  märgfläck_1_N = mkN "märgfläck" ; -- märgfläck..nn.1
  märgfull_1_A = mkA "märgfull" ; -- märgfull..av.1
  märgfullhet_1_N = mkN "märgfullhet" ; -- märgfullhet..nn.1
  märgla_1_V = mkV "märglar" ; -- märgla..vb.1
  märglande_1_N = mkN "märglande" ; -- märglande..nn.1
  märglig_1_A = mkA "märglig" ; -- märglig..av.1
  märgling_1_N = mkN "märgling" ; -- märgling..nn.1
  märglös_1_A = mkA "märglös" ; -- märglös..av.1
  märglöshet_1_N = mkN "märglöshet" ; -- märglöshet..nn.1
  märgpipa_1_N = mkN "märgpipa" ; -- märgpipa..nn.1
  märgskida_1_N = mkN "märgskida" ; -- märgskida..nn.1
  märgstråle_1_N = mkN "märgstråle" utrum  ; -- märgstråle..nn.1
  märka_1_V = mkV "märker" ; -- märka..vb.1
  märkande_1_N = mkN "märkande" ; -- märkande..nn.1
  märkband_1_N = mkN "märkband" neutrum  ; -- märkband..nn.1
  märkbar_1_A = mkA "märkbar" ; -- märkbar..av.1
  märkbarhet_1_N = mkN "märkbarhet" ; -- märkbarhet..nn.1
  märkbläck_1_N = mkN "märkbläck" neutrum  ; -- märkbläck..nn.1
  märkduk_1_N = mkN "märkduk" ; -- märkduk..nn.1
  märke_1_N = mkN "märke" ; -- märke..nn.1
  märkesdag_1_N = mkN "märkesdag" ; -- märkesdag..nn.1
  märkesman_1_N = mkN "märkesman" "märkesmannen" "märkesmän" "märkesmännen" ; -- märkesman..nn.1
  märkesmystik_1_N = mkN "märkesmystik" ; -- märkesmystik..nn.1
  märkesprodukt_1_N = mkN "märkesprodukt" "märkesprodukter" ; -- märkesprodukt..nn.1
  märkesrätt_1_N = mkN "märkesrätt" ; -- märkesrätt..nn.1
  märkesskjorta_1_N = mkN "märkesskjorta" ; -- märkesskjorta..nn.1
  märkesvara_1_N = mkN "märkesvara" ; -- märkesvara..nn.1
  märkgarn_1_N = mkN "märkgarn" neutrum  ; -- märkgarn..nn.1
  märkhammare_1_N = mkN "märkhammare" "märkhammaren" "märkhammare" "märkhamrarna" ; -- märkhammare..nn.1
  märklig_1_A = mkA "märklig" ; -- märklig..av.1
  märklighet_1_N = mkN "märklighet" "märkligheter" ; -- märklighet..nn.1
  märkning_1_N = mkN "märkning" ; -- märkning..nn.1
  märkpenna_1_N = mkN "märkpenna" ; -- märkpenna..nn.1
  märkrulla_1_N = mkN "märkrulla" ; -- märkrulla..nn.1
  märksnöre_1_N = mkN "märksnöre" ; -- märksnöre..nn.1
  märkvärdig_1_A = mkA "märkvärdig" ; -- märkvärdig..av.1
  märkvärdiggöra_1_V = mkV "märkvärdiggöra" "märkvärdiggjorde" "märkvärdiggjort" ; -- märkvärdiggöra..vb.1
  märkvärdighet_1_N = mkN "märkvärdighet" "märkvärdigheter" ; -- märkvärdighet..nn.1
  märla_1_N = mkN "märla" ; -- märla..nn.1
  märling_1_N = mkN "märling" ; -- märling..nn.1
  märlspik_1_N = mkN "märlspik" ; -- märlspik..nn.1
  märr_1_N = mkN "märr" ; -- märr..nn.1
  märs_1_N = mkN "märs" ; -- märs..nn.1
  märsrå_1_N = mkN "märsrå" "märsrån" "märsrår" "märsrårna" ; -- märsrå..nn.1
  märssegel_1_N = mkN "märssegel" neutrum  ; -- märssegel..nn.1
  märsstång_1_N = mkN "märsstång" "märsstänger" ; -- märsstång..nn.1
  mäsk_1_N = mkN "mäsk" ; -- mäsk..nn.1
  mäska_1_V = mkV "mäskar" ; -- mäska..vb.1
  mäskande_1_N = mkN "mäskande" ; -- mäskande..nn.1
  mäskning_1_N = mkN "mäskning" ; -- mäskning..nn.1
  mäskprovare_1_N = mkN "mäskprovare" utrum  ; -- mäskprovare..nn.1
  mäss_1_N = mkN "mäss" ; -- mäss..nn.1
  mässa_1_N = mkN "mässa" ; -- mässa..nn.1
  mässa_1_V = mkV "mässar" ; -- mässa..vb.1
  mässande_1_N = mkN "mässande" ; -- mässande..nn.1
  mässbok_1_N = mkN "mässbok" "mässböcker" ; -- mässbok..nn.1
  mässdräkt_1_N = mkN "mässdräkt" "mässdräkter" ; -- mässdräkt..nn.1
  mässfall_1_N = mkN "mässfall" neutrum  ; -- mässfall..nn.1
  mässhake_1_N = mkN "mässhake" utrum  ; -- mässhake..nn.1
  mässhall_1_N = mkN "mässhall" ; -- mässhall..nn.1
  mässing_1_N = mkN "mässing" ; -- mässing..nn.1
  mässingblåsinstrument_1_N = mkN "mässingblåsinstrument" neutrum  ; -- mässingblåsinstrument..nn.1
  mässinginstrument_1_N = mkN "mässinginstrument" neutrum  ; -- mässinginstrument..nn.1
  mässingsblänk_1_N = mkN "mässingsblänk" neutrum  ; -- mässingsblänk..nn.1
  mässingsblänkande_1_A = mkA "mässingsblänkande" ; -- mässingsblänkande..av.1
  mässingsdetalj_1_N = mkN "mässingsdetalj" "mässingsdetaljer" ; -- mässingsdetalj..nn.1
  mässingsfotstöd_1_N = mkN "mässingsfotstöd" neutrum  ; -- mässingsfotstöd..nn.1
  mässingsinstrument_1_N = mkN "mässingsinstrument" neutrum  ; -- mässingsinstrument..nn.1
  mässingsknapp_1_N = mkN "mässingsknapp" ; -- mässingsknapp..nn.1
  mässingsknäppe_1_N = mkN "mässingsknäppe" ; -- mässingsknäppe..nn.1
  mässingsmusik_1_N = mkN "mässingsmusik" ; -- mässingsmusik..nn.1
  mässingsspik_1_N = mkN "mässingsspik" ; -- mässingsspik..nn.1
  mässingsstång_1_N = mkN "mässingsstång" "mässingsstänger" ; -- mässingsstång..nn.1
  mässingstråd_1_N = mkN "mässingstråd" ; -- mässingstråd..nn.1
  mässjacka_1_N = mkN "mässjacka" ; -- mässjacka..nn.1
  mässkjorta_1_N = mkN "mässkjorta" ; -- mässkjorta..nn.1
  mässkrud_1_N = mkN "mässkrud" ; -- mässkrud..nn.1
  mässling_1_N = mkN "mässling" ; -- mässling..nn.1
  mässoffer_1_N = mkN "mässoffer" neutrum  ; -- mässoffer..nn.1
  mässpojke_1_N = mkN "mässpojke" utrum  ; -- mässpojke..nn.1
  mästarbrev_1_N = mkN "mästarbrev" neutrum  ; -- mästarbrev..nn.1
  mästare_1_N = mkN "mästare" utrum  ; -- mästare..nn.1
  mästarhand_1_N = mkN "mästarhand" "mästarhänder" ; -- mästarhand..nn.1
  mästarinna_1_N = mkN "mästarinna" ; -- mästarinna..nn.1
  mästarklass_1_N = mkN "mästarklass" "mästarklasser" ; -- mästarklass..nn.1
  mästarprov_1_N = mkN "mästarprov" neutrum  ; -- mästarprov..nn.1
  mäster_1_N = mkN "mäster" ; -- mäster..nn.1
  mästerhjärna_1_N = mkN "mästerhjärna" ; -- mästerhjärna..nn.1
  mästerklottrare_1_N = mkN "mästerklottrare" utrum  ; -- mästerklottrare..nn.1
  mästerlig_1_A = mkA "mästerlig" ; -- mästerlig..av.1
  mästerlighet_1_N = mkN "mästerlighet" ; -- mästerlighet..nn.1
  mästerlots_1_N = mkN "mästerlots" ; -- mästerlots..nn.1
  mästerman_1_N = mkN "mästerman" "mästermannen" "mästermän" "mästermännen" ; -- mästerman..nn.1
  mästerskap_1_N = mkN "mästerskap" neutrum  ; -- mästerskap..nn.1
  mästerskapstitel_1_N = mkN "mästerskapstitel" ; -- mästerskapstitel..nn.1
  mästerstycke_1_N = mkN "mästerstycke" ; -- mästerstycke..nn.1
  mästersång_1_N = mkN "mästersång" ; -- mästersång..nn.1
  mästersångare_1_N = mkN "mästersångare" utrum  ; -- mästersångare..nn.1
  mästertänkare_1_N = mkN "mästertänkare" utrum  ; -- mästertänkare..nn.1
  mästerverk_1_N = mkN "mästerverk" neutrum  ; -- mästerverk..nn.1
  mästra_1_V = mkV "mästrar" ; -- mästra..vb.1
  mästrande_1_A = mkA "mästrande" ; -- mästrande..av.1
  mästrande_1_N = mkN "mästrande" ; -- mästrande..nn.1
  mät_1_N = mkN "mät" ; -- mät..nn.1
  mäta_1_V = mkV "mäter" ; -- mäta..vb.1
  mätande_1_N = mkN "mätande" ; -- mätande..nn.1
  mätapparat_1_N = mkN "mätapparat" "mätapparater" ; -- mätapparat..nn.1
  mätapparatur_1_N = mkN "mätapparatur" "mätapparaturer" ; -- mätapparatur..nn.1
  mätare_1_N = mkN "mätare" utrum  ; -- mätare..nn.1
  mätarfjäril_1_N = mkN "mätarfjäril" ; -- mätarfjäril..nn.1
  mätarhus_1_N = mkN "mätarhus" neutrum  ; -- mätarhus..nn.1
  mätarlarv_1_N = mkN "mätarlarv" "mätarlarver" ; -- mätarlarv..nn.1
  mätband_1_N = mkN "mätband" neutrum  ; -- mätband..nn.1
  mätbar_1_A = mkA "mätbar" ; -- mätbar..av.1
  mätbarhet_1_N = mkN "mätbarhet" "mätbarheter" ; -- mätbarhet..nn.1
  mätbord_1_N = mkN "mätbord" neutrum  ; -- mätbord..nn.1
  mätbrev_1_N = mkN "mätbrev" neutrum  ; -- mätbrev..nn.1
  mätdata_1_N = mkN "mätdata" "mätdatat" "mätdata" "mätdatana" ; -- mätdata..nn.1
  mätetal_1_N = mkN "mätetal" neutrum  ; -- mätetal..nn.1
  mätglas_1_N = mkN "mätglas" neutrum  ; -- mätglas..nn.1
  mätinstrument_1_N = mkN "mätinstrument" neutrum  ; -- mätinstrument..nn.1
  mätmetod_1_N = mkN "mätmetod" "mätmetoder" ; -- mätmetod..nn.1
  mätmässig_1_A = mkA "mätmässig" ; -- mätmässig..av.1
  mätning_1_N = mkN "mätning" ; -- mätning..nn.1
  mätningsfartyg_1_N = mkN "mätningsfartyg" neutrum  ; -- mätningsfartyg..nn.1
  mätningsregel_1_N = mkN "mätningsregel" "mätningsregeln" "mätningsregler" "mätningsreglerna" ; -- mätningsregel..nn.1
  mätningstal_1_N = mkN "mätningstal" neutrum  ; -- mätningstal..nn.1
  mätområde_1_N = mkN "mätområde" ; -- mätområde..nn.1
  mätperiod_1_N = mkN "mätperiod" "mätperioder" ; -- mätperiod..nn.1
  mätredskap_1_N = mkN "mätredskap" neutrum  ; -- mätredskap..nn.1
  mätress_1_N = mkN "mätress" "mätresser" ; -- mätress..nn.1
  mätsticka_1_N = mkN "mätsticka" ; -- mätsticka..nn.1
  mätt_1_A = mkA "mätt" ; -- mätt..av.1
  mätta_1_V = mkV "mättar" ; -- mätta..vb.1
  mättad_1_A = mkA "mättad" ; -- mättad..av.1
  mättande_1_N = mkN "mättande" ; -- mättande..nn.1
  mätthet_1_N = mkN "mätthet" ; -- mätthet..nn.1
  mättnad_1_N = mkN "mättnad" "mättnader" ; -- mättnad..nn.1
  mättning_1_N = mkN "mättning" ; -- mättning..nn.1
  mättningstryck_1_N = mkN "mättningstryck" neutrum  ; -- mättningstryck..nn.1
  mättsam_1_A = mkA "mättsam" "mättsamt" "mättsamma" "mättsamma" "mättsammare" "mättsammast" "mättsammaste" ; -- mättsam..av.1
  mättsamhet_1_N = mkN "mättsamhet" ; -- mättsamhet..nn.1
  mätverktyg_1_N = mkN "mätverktyg" neutrum  ; -- mätverktyg..nn.1
  mätvärde_1_N = mkN "mätvärde" ; -- mätvärde..nn.1
  må_1_V = mkV "mår" ; -- må..vb.1
  måbär_1_N = mkN "måbär" neutrum  ; -- måbär..nn.1
  måbärsbuske_1_N = mkN "måbärsbuske" utrum  ; -- måbärsbuske..nn.1
  mående_1_N = mkN "mående" ; -- mående..nn.1
  måffa_1_V = mkV "måffar" ; -- måffa..vb.1
  måg_1_N = mkN "måg" ; -- måg..nn.1
  måhända_1_Adv = mkAdv "måhända" ; -- måhända..ab.1
  måkare_1_N = mkN "måkare" utrum  ; -- måkare..nn.1
  mål_1_N = mkN "mål" neutrum  ; -- mål..nn.1
  måla_1_V = mkV "målar" ; -- måla..vb.1
  målande_1_A = mkA "målande" ; -- målande..av.1
  målande_1_N = mkN "målande" ; -- målande..nn.1
  målangivning_1_N = mkN "målangivning" ; -- målangivning..nn.1
  målarbok_1_N = mkN "målarbok" "målarböcker" ; -- målarbok..nn.1
  målarborste_1_N = mkN "målarborste" utrum  ; -- målarborste..nn.1
  målarduk_1_N = mkN "målarduk" ; -- målarduk..nn.1
  målare_1_N = mkN "målare" utrum  ; -- målare..nn.1
  målarfärg_1_N = mkN "målarfärg" "målarfärger" ; -- målarfärg..nn.1
  målarkludd_1_N = mkN "målarkludd" ; -- målarkludd..nn.1
  målarkniv_1_N = mkN "målarkniv" ; -- målarkniv..nn.1
  målarmästare_1_N = mkN "målarmästare" utrum  ; -- målarmästare..nn.1
  målarrock_1_N = mkN "målarrock" ; -- målarrock..nn.1
  målarskola_1_N = mkN "målarskola" ; -- målarskola..nn.1
  målarstil_1_N = mkN "målarstil" ; -- målarstil..nn.1
  målarställning_1_N = mkN "målarställning" ; -- målarställning..nn.1
  målbrott_1_N = mkN "målbrott" neutrum  ; -- målbrott..nn.1
  målbrottsröst_1_N = mkN "målbrottsröst" "målbrottsröster" ; -- målbrottsröst..nn.1
  målbrottsstämma_1_N = mkN "målbrottsstämma" ; -- målbrottsstämma..nn.1
  målbur_1_N = mkN "målbur" ; -- målbur..nn.1
  målchans_1_N = mkN "målchans" "målchanser" ; -- målchans..nn.1
  måldomare_1_N = mkN "måldomare" utrum  ; -- måldomare..nn.1
  måldrottning_1_N = mkN "måldrottning" ; -- måldrottning..nn.1
  måleri_1_N = mkN "måleri" "måleriet" "målerier" "målerierna" ; -- måleri..nn.1
  måleriarbete_1_N = mkN "måleriarbete" ; -- måleriarbete..nn.1
  målerisk_1_A = mkA "målerisk" ; -- målerisk..av.1
  målfarlig_1_A = mkA "målfarlig" ; -- målfarlig..av.1
  målfarlighet_1_N = mkN "målfarlighet" ; -- målfarlighet..nn.1
  målfigur_1_N = mkN "målfigur" "målfigurer" ; -- målfigur..nn.1
  målforskning_1_N = mkN "målforskning" ; -- målforskning..nn.1
  målfoto_1_N = mkN "målfoto" "målfotot" "målfoton" "målfotona" ; -- målfoto..nn.1
  målföre_1_N = mkN "målföre" ; -- målföre..nn.1
  målgivande_1_A = mkA "målgivande" ; -- målgivande..av.1
  målgrupp_1_N = mkN "målgrupp" "målgrupper" ; -- målgrupp..nn.1
  målgång_1_N = mkN "målgång" ; -- målgång..nn.1
  målgård_1_N = mkN "målgård" ; -- målgård..nn.1
  målinriktad_1_A = mkA "målinriktad" ; -- målinriktad..av.1
  målis_1_N = mkN "målis" ; -- målis..nn.1
  målkamera_1_N = mkN "målkamera" ; -- målkamera..nn.1
  målkonflikt_1_N = mkN "målkonflikt" "målkonflikter" ; -- målkonflikt..nn.1
  målkung_1_N = mkN "målkung" ; -- målkung..nn.1
  målkvot_1_N = mkN "målkvot" "målkvoter" ; -- målkvot..nn.1
  målla_1_N = mkN "målla" ; -- målla..nn.1
  mållinje_1_N = mkN "mållinje" "mållinjer" ; -- mållinje..nn.1
  mållös_1_A = mkA "mållös" ; -- mållös..av.1
  mållöshet_1_N = mkN "mållöshet" ; -- mållöshet..nn.1
  målmedveten_1_A = mkA "målmedveten" ; -- målmedveten..av.1
  målmedvetenhet_1_N = mkN "målmedvetenhet" ; -- målmedvetenhet..nn.1
  målmässig_1_A = mkA "målmässig" ; -- målmässig..av.1
  målning_1_N = mkN "målning" ; -- målning..nn.1
  målning_2_N = mkN "målning" ; -- målning..nn.2
  målningsarbete_1_N = mkN "målningsarbete" ; -- målningsarbete..nn.1
  målningsteknik_1_N = mkN "målningsteknik" "målningstekniker" ; -- målningsteknik..nn.1
  målområde_1_N = mkN "målområde" ; -- målområde..nn.1
  målrelaterad_1_A = mkA "målrelaterad" ; -- målrelaterad..av.1
  målskillnad_1_N = mkN "målskillnad" "målskillnader" ; -- målskillnad..nn.1
  målskjutning_1_N = mkN "målskjutning" ; -- målskjutning..nn.1
  målskytt_1_N = mkN "målskytt" ; -- målskytt..nn.1
  målskytte_1_N = mkN "målskytte" ; -- målskytte..nn.1
  målsman_1_N = mkN "målsman" "målsmannen" "målsmän" "målsmännen" ; -- målsman..nn.1
  målsnål_1_A = mkA "målsnål" ; -- målsnål..av.1
  målsnöre_1_N = mkN "målsnöre" ; -- målsnöre..nn.1
  målspaning_1_N = mkN "målspaning" ; -- målspaning..nn.1
  målspottare_1_N = mkN "målspottare" utrum  ; -- målspottare..nn.1
  målspråk_1_N = mkN "målspråk" neutrum  ; -- målspråk..nn.1
  målstolpe_1_N = mkN "målstolpe" utrum  ; -- målstolpe..nn.1
  målstyrning_1_N = mkN "målstyrning" ; -- målstyrning..nn.1
  målställning_1_N = mkN "målställning" ; -- målställning..nn.1
  målsägande_1_N = mkN "målsägande" "målsäganden" "målsäganden" "målsägandena" ; -- målsägande..nn.1
  målsägarbiträde_1_N = mkN "målsägarbiträde" ; -- målsägarbiträde..nn.1
  målsägare_1_N = mkN "målsägare" utrum  ; -- målsägare..nn.1
  målsättning_1_N = mkN "målsättning" ; -- målsättning..nn.1
  målsökande_1_A = mkA "målsökande" ; -- målsökande..av.1
  målsökare_1_N = mkN "målsökare" utrum  ; -- målsökare..nn.1
  måltavla_1_N = mkN "måltavla" ; -- måltavla..nn.1
  måltid_1_N = mkN "måltid" "måltider" ; -- måltid..nn.1
  måltidsdricka_1_N = mkN "måltidsdricka" ; -- måltidsdricka..nn.1
  måltidsdryck_1_N = mkN "måltidsdryck" "måltidsdrycker" ; -- måltidsdryck..nn.1
  måltidstvång_1_N = mkN "måltidstvång" neutrum  ; -- måltidstvång..nn.1
  måltorka_1_N = mkN "måltorka" ; -- måltorka..nn.1
  målvakt_1_N = mkN "målvakt" "målvakter" ; -- målvakt..nn.1
  målyta_1_N = mkN "målyta" ; -- målyta..nn.1
  mån_1_A = mkA "mån" ; -- mån..av.1
  mån_1_N = mkN "mån" ; -- mån..nn.1
  måna_1_V = mkV "månar" ; -- måna..vb.1
  månad_1_N = mkN "månad" "månader" ; -- månad..nn.1
  månadsbidrag_1_N = mkN "månadsbidrag" neutrum  ; -- månadsbidrag..nn.1
  månadskontroll_1_N = mkN "månadskontroll" "månadskontroller" ; -- månadskontroll..nn.1
  månadskort_1_N = mkN "månadskort" neutrum  ; -- månadskort..nn.1
  månadslång_1_A = mkA "månadslång" ; -- månadslång..av.1
  månadslön_1_N = mkN "månadslön" "månadslöner" ; -- månadslön..nn.1
  månadspeng_1_N = mkN "månadspeng" ; -- månadspeng..nn.1
  månadspenning_1_N = mkN "månadspenning" ; -- månadspenning..nn.1
  månadsrasande_1_A = mkA "månadsrasande" ; -- månadsrasande..av.1
  månadsros_1_N = mkN "månadsros" "månadsrosor" ; -- månadsros..nn.1
  månadsskifte_1_N = mkN "månadsskifte" ; -- månadsskifte..nn.1
  månadsskrift_1_N = mkN "månadsskrift" "månadsskrifter" ; -- månadsskrift..nn.1
  månadssmultron_1_N = mkN "månadssmultron" neutrum  ; -- månadssmultron..nn.1
  månadstal_1_N = mkN "månadstal" neutrum  ; -- månadstal..nn.1
  månadstidskrift_1_N = mkN "månadstidskrift" "månadstidskrifter" ; -- månadstidskrift..nn.1
  månadsvis_1_Adv = mkAdv "månadsvis" ; -- månadsvis..ab.1
  månadsvis_1_A = mkA "månadsvis" ; -- månadsvis..av.1
  månadtal_1_N = mkN "månadtal" neutrum  ; -- månadtal..nn.1
  månande_1_N = mkN "månande" ; -- månande..nn.1
  månansikte_1_N = mkN "månansikte" ; -- månansikte..nn.1
  månatlig_1_A = mkA "månatlig" ; -- månatlig..av.1
  månatligen_1_Adv = mkAdv "månatligen" ; -- månatligen..ab.1
  månbana_1_N = mkN "månbana" ; -- månbana..nn.1
  månbelyst_1_A = mkA "månbelyst" "månbelyst" ; -- månbelyst..av.1
  månbävning_1_N = mkN "månbävning" ; -- månbävning..nn.1
  måncykel_1_N = mkN "måncykel" ; -- måncykel..nn.1
  måndag_1_N = mkN "måndag" ; -- måndag..nn.1
  måndageftermiddag_1_N = mkN "måndageftermiddag" ; -- måndageftermiddag..nn.1
  måndagkväll_1_N = mkN "måndagkväll" ; -- måndagkväll..nn.1
  måndagmorgon_1_N = mkN "måndagmorgon" "måndagmorgonen" "måndagmornar" "måndagmornarna" ; -- måndagmorgon..nn.1
  måndagseftermiddag_1_N = mkN "måndagseftermiddag" ; -- måndagseftermiddag..nn.1
  måndagsexemplar_1_N = mkN "måndagsexemplar" neutrum  ; -- måndagsexemplar..nn.1
  måndagskväll_1_N = mkN "måndagskväll" ; -- måndagskväll..nn.1
  måndagsmorgon_1_N = mkN "måndagsmorgon" "måndagsmorgonen" "måndagsmornar" "måndagsmornarna" ; -- måndagsmorgon..nn.1
  måndistans_1_N = mkN "måndistans" "måndistanser" ; -- måndistans..nn.1
  måndygn_1_N = mkN "måndygn" neutrum  ; -- måndygn..nn.1
  måne_1_N = mkN "måne" utrum  ; -- måne..nn.1
  månfas_1_N = mkN "månfas" "månfaser" ; -- månfas..nn.1
  månflod_1_N = mkN "månflod" "månfloder" ; -- månflod..nn.1
  månformig_1_A = mkA "månformig" ; -- månformig..av.1
  månformighet_1_N = mkN "månformighet" ; -- månformighet..nn.1
  månfärd_1_N = mkN "månfärd" "månfärder" ; -- månfärd..nn.1
  månförmörkelse_1_N = mkN "månförmörkelse" "månförmörkelser" ; -- månförmörkelse..nn.1
  mångahanda_1_A = mkA "mångahanda" ; -- mångahanda..av.1
  mångalen_1_A = mkA "mångalen" ; -- mångalen..av.1
  mångalenhet_1_N = mkN "mångalenhet" "mångalenheter" ; -- mångalenhet..nn.1
  mångalenskap_1_N = mkN "mångalenskap" "mångalenskaper" ; -- mångalenskap..nn.1
  mångarmad_1_A = mkA "mångarmad" ; -- mångarmad..av.1
  mångartad_1_A = mkA "mångartad" ; -- mångartad..av.1
  mångata_1_N = mkN "mångata" ; -- mångata..nn.1
  mångbeprövad_1_A = mkA "mångbeprövad" ; -- mångbeprövad..av.1
  mångbesjungen_1_A = mkA "mångbesjungen" ; -- mångbesjungen..av.1
  mångbottnad_1_A = mkA "mångbottnad" ; -- mångbottnad..av.1
  mångbyggare_1_N = mkN "mångbyggare" utrum  ; -- mångbyggare..nn.1
  mångdubbel_1_A = mkA "mångdubbel" ; -- mångdubbel..av.1
  mångdubbla_1_V = mkV "mångdubblar" ; -- mångdubbla..vb.1
  mångdubblande_1_N = mkN "mångdubblande" ; -- mångdubblande..nn.1
  mångdubbling_1_N = mkN "mångdubbling" ; -- mångdubbling..nn.1
  mångfacetterad_1_A = mkA "mångfacetterad" ; -- mångfacetterad..av.1
  mångfald_1_N = mkN "mångfald" "mångfalder" ; -- mångfald..nn.1
  mångfaldig_1_A = mkA "mångfaldig" ; -- mångfaldig..av.1
  mångfaldiga_1_V = mkV "mångfaldigar" ; -- mångfaldiga..vb.1
  mångfaldigande_1_N = mkN "mångfaldigande" ; -- mångfaldigande..nn.1
  mångfaldighet_1_N = mkN "mångfaldighet" ; -- mångfaldighet..nn.1
  mångfaldsbarometer_1_N = mkN "mångfaldsbarometer" ; -- mångfaldsbarometer..nn.1
  mångfasetterad_1_A = mkA "mångfasetterad" ; -- mångfasetterad..av.1
  mångflikig_1_A = mkA "mångflikig" ; -- mångflikig..av.1
  mångformig_1_A = mkA "mångformig" ; -- mångformig..av.1
  mångformighet_1_N = mkN "mångformighet" "mångformigheter" ; -- mångformighet..nn.1
  mångfotad_1_A = mkA "mångfotad" ; -- mångfotad..av.1
  mångfoting_1_N = mkN "mångfoting" ; -- mångfoting..nn.1
  mångfrestande_1_A = mkA "mångfrestande" ; -- mångfrestande..av.1
  mångfrestare_1_N = mkN "mångfrestare" utrum  ; -- mångfrestare..nn.1
  mångfärgad_1_A = mkA "mångfärgad" ; -- mångfärgad..av.1
  månggestaltad_1_A = mkA "månggestaltad" ; -- månggestaltad..av.1
  månggestaltning_1_N = mkN "månggestaltning" ; -- månggestaltning..nn.1
  månggifte_1_N = mkN "månggifte" ; -- månggifte..nn.1
  mångguderi_1_N = mkN "mångguderi" neutrum  ; -- mångguderi..nn.1
  månghundraårig_1_A = mkA "månghundraårig" ; -- månghundraårig..av.1
  månghörnig_1_A = mkA "månghörnig" ; -- månghörnig..av.1
  månghörning_1_N = mkN "månghörning" ; -- månghörning..nn.1
  månghövdad_1_A = mkA "månghövdad" ; -- månghövdad..av.1
  mångkamp_1_N = mkN "mångkamp" "mångkamper" ; -- mångkamp..nn.1
  mångkulturell_1_A = mkA "mångkulturell" ; -- mångkulturell..av.1
  mångkunnig_1_A = mkA "mångkunnig" ; -- mångkunnig..av.1
  mångkunnighet_1_N = mkN "mångkunnighet" ; -- mångkunnighet..nn.1
  mångla_1_V = mkV "månglar" ; -- mångla..vb.1
  månglande_1_N = mkN "månglande" ; -- månglande..nn.1
  månglare_1_N = mkN "månglare" utrum  ; -- månglare..nn.1
  mångleri_1_N = mkN "mångleri" neutrum  ; -- mångleri..nn.1
  mångmiljardaffär_1_N = mkN "mångmiljardaffär" "mångmiljardaffärer" ; -- mångmiljardaffär..nn.1
  mångmiljardbelopp_1_N = mkN "mångmiljardbelopp" neutrum  ; -- mångmiljardbelopp..nn.1
  mångmiljardförlust_1_N = mkN "mångmiljardförlust" "mångmiljardförluster" ; -- mångmiljardförlust..nn.1
  mångmiljondollarcenter_1_N = mkN "mångmiljondollarcenter" neutrum  ; -- mångmiljondollarcenter..nn.1
  mångmiljoninvestering_1_N = mkN "mångmiljoninvestering" ; -- mångmiljoninvestering..nn.1
  mångmiljonär_1_N = mkN "mångmiljonär" "mångmiljonärer" ; -- mångmiljonär..nn.1
  mångordig_1_A = mkA "mångordig" ; -- mångordig..av.1
  mångordighet_1_N = mkN "mångordighet" ; -- mångordighet..nn.1
  mångsidig_1_A = mkA "mångsidig" ; -- mångsidig..av.1
  mångsidighet_1_N = mkN "mångsidighet" "mångsidigheter" ; -- mångsidighet..nn.1
  mångsiding_1_N = mkN "mångsiding" ; -- mångsiding..nn.1
  mångskiftande_1_A = mkA "mångskiftande" ; -- mångskiftande..av.1
  mångskriveri_1_N = mkN "mångskriveri" neutrum  ; -- mångskriveri..nn.1
  mångspråkig_1_A = mkA "mångspråkig" ; -- mångspråkig..av.1
  mångspråkighet_1_N = mkN "mångspråkighet" ; -- mångspråkighet..nn.1
  mångstavig_1_A = mkA "mångstavig" ; -- mångstavig..av.1
  mångstavighet_1_N = mkN "mångstavighet" ; -- mångstavighet..nn.1
  mångstämmig_1_A = mkA "mångstämmig" ; -- mångstämmig..av.1
  mångstämmighet_1_N = mkN "mångstämmighet" ; -- mångstämmighet..nn.1
  mångsysslare_1_N = mkN "mångsysslare" utrum  ; -- mångsysslare..nn.1
  mångsyssleri_1_N = mkN "mångsyssleri" neutrum  ; -- mångsyssleri..nn.1
  mångtalig_1_A = mkA "mångtalig" ; -- mångtalig..av.1
  mångtalighet_1_N = mkN "mångtalighet" ; -- mångtalighet..nn.1
  mångtusenårig_1_A = mkA "mångtusenårig" ; -- mångtusenårig..av.1
  mångtydig_1_A = mkA "mångtydig" ; -- mångtydig..av.1
  mångtydighet_1_N = mkN "mångtydighet" "mångtydigheter" ; -- mångtydighet..nn.1
  mångubbe_1_N = mkN "mångubbe" utrum  ; -- mångubbe..nn.1
  mångvetenskaplig_1_A = mkA "mångvetenskaplig" ; -- mångvetenskaplig..av.1
  mångvetenskaplighet_1_N = mkN "mångvetenskaplighet" ; -- mångvetenskaplighet..nn.1
  mångård_1_N = mkN "mångård" ; -- mångård..nn.1
  mångårig_1_A = mkA "mångårig" ; -- mångårig..av.1
  mångårighet_1_N = mkN "mångårighet" ; -- mångårighet..nn.1
  månhet_1_N = mkN "månhet" ; -- månhet..nn.1
  månkalender_1_N = mkN "månkalender" ; -- månkalender..nn.1
  månkarta_1_N = mkN "månkarta" ; -- månkarta..nn.1
  månkrater_1_N = mkN "månkrater" ; -- månkrater..nn.1
  månlandare_1_N = mkN "månlandare" utrum  ; -- månlandare..nn.1
  månlandning_1_N = mkN "månlandning" ; -- månlandning..nn.1
  månlandskap_1_N = mkN "månlandskap" neutrum  ; -- månlandskap..nn.1
  månliknande_1_A = mkA "månliknande" ; -- månliknande..av.1
  månljus_1_A = mkA "månljus" ; -- månljus..av.1
  månljus_1_N = mkN "månljus" neutrum  ; -- månljus..nn.1
  månmark_1_N = mkN "månmark" ; -- månmark..nn.1
  månne_1_Adv = mkAdv "månne" ; -- månne..ab.1
  månntro_1_Adv = mkAdv "månntro" ; -- månntro..ab.1
  månsing_1_N = mkN "månsing" ; -- månsing..nn.1
  månsken_1_N = mkN "månsken" neutrum  ; -- månsken..nn.1
  månskensbonde_1_N = mkN "månskensbonde" "månskensbönder" ; -- månskensbonde..nn.1
  månskensvärmeri_1_N = mkN "månskensvärmeri" "månskensvärmeriet" "månskensvärmerier" "månskensvärmerierna" ; -- månskensvärmeri..nn.1
  månskifte_1_N = mkN "månskifte" ; -- månskifte..nn.1
  månskiva_1_N = mkN "månskiva" ; -- månskiva..nn.1
  månskugga_1_N = mkN "månskugga" ; -- månskugga..nn.1
  månskära_1_N = mkN "månskära" ; -- månskära..nn.1
  månsten_1_N = mkN "månsten" "månstenen" "månstenar" "månstenarna" ; -- månsten..nn.1
  månstråle_1_N = mkN "månstråle" utrum  ; -- månstråle..nn.1
  månvarv_1_N = mkN "månvarv" neutrum  ; -- månvarv..nn.1
  månviol_1_N = mkN "månviol" "månvioler" ; -- månviol..nn.1
  månår_1_N = mkN "månår" neutrum  ; -- månår..nn.1
  mår_1_N = mkN "mår" ; -- mår..nn.1
  måra_1_N = mkN "måra" ; -- måra..nn.1
  mård_1_N = mkN "mård" ; -- mård..nn.1
  mårddjur_1_N = mkN "mårddjur" neutrum  ; -- mårddjur..nn.1
  mårten_1_N = mkN "mårten" ; -- mårten..nn.1
  mårtensgås_1_N = mkN "mårtensgås" ; -- mårtensgås..nn.1
  mås_1_N = mkN "mås" ; -- mås..nn.1
  måsflock_1_N = mkN "måsflock" ; -- måsflock..nn.1
  måsfågel_1_N = mkN "måsfågel" ; -- måsfågel..nn.1
  måste_1_N = mkN "måste" ; -- måste..nn.1
  måsunge_1_N = mkN "måsunge" utrum  ; -- måsunge..nn.1
  måsägg_1_N = mkN "måsägg" neutrum  ; -- måsägg..nn.1
  måtro_1_Adv = mkAdv "måtro" ; -- måtro..ab.1
  mått_1_N = mkN "mått" neutrum  ; -- mått..nn.1
  måtta_1_N = mkN "måtta" ; -- måtta..nn.1
  måtta_1_V = mkV "måttar" ; -- måtta..vb.1
  måttagning_1_N = mkN "måttagning" ; -- måttagning..nn.1
  måttande_1_N = mkN "måttande" ; -- måttande..nn.1
  måttband_1_N = mkN "måttband" neutrum  ; -- måttband..nn.1
  måttbeställd_1_A = mkA "måttbeställd" "måttbeställt" ; -- måttbeställd..av.1
  måttenhet_1_N = mkN "måttenhet" "måttenheter" ; -- måttenhet..nn.1
  måttfull_1_A = mkA "måttfull" ; -- måttfull..av.1
  måttfullhet_1_N = mkN "måttfullhet" ; -- måttfullhet..nn.1
  måttlig_1_A = mkA "måttlig" ; -- måttlig..av.1
  måttlighet_1_N = mkN "måttlighet" ; -- måttlighet..nn.1
  måttlös_1_A = mkA "måttlös" ; -- måttlös..av.1
  måttlöshet_1_N = mkN "måttlöshet" ; -- måttlöshet..nn.1
  måttsats_1_N = mkN "måttsats" "måttsatser" ; -- måttsats..nn.1
  måttsenhet_1_N = mkN "måttsenhet" "måttsenheter" ; -- måttsenhet..nn.1
  måttstock_1_N = mkN "måttstock" ; -- måttstock..nn.1
  måttsydd_1_A = mkA "måttsydd" ; -- måttsydd..av.1
  måttsystem_1_N = mkN "måttsystem" neutrum  ; -- måttsystem..nn.1
  måttuppgift_1_N = mkN "måttuppgift" "måttuppgifter" ; -- måttuppgift..nn.1
  måttverktyg_1_N = mkN "måttverktyg" neutrum  ; -- måttverktyg..nn.1
  mö_1_N = mkN "mö" "mön" "mör" "mörna" ; -- mö..nn.1
  möbel_1_N = mkN "möbel" "möbeln" "möbler" "möblerna" ; -- möbel..nn.1
  möbelbuss_1_N = mkN "möbelbuss" ; -- möbelbuss..nn.1
  möbelfirma_1_N = mkN "möbelfirma" ; -- möbelfirma..nn.1
  möbelflyttning_1_N = mkN "möbelflyttning" ; -- möbelflyttning..nn.1
  möbelfot_1_N = mkN "möbelfot" "möbelfötter" ; -- möbelfot..nn.1
  möbelföretag_1_N = mkN "möbelföretag" neutrum  ; -- möbelföretag..nn.1
  möbelförsäljning_1_N = mkN "möbelförsäljning" ; -- möbelförsäljning..nn.1
  möbeljätte_1_N = mkN "möbeljätte" utrum  ; -- möbeljätte..nn.1
  möbelklädsel_1_N = mkN "möbelklädsel" ; -- möbelklädsel..nn.1
  möbelmässa_1_N = mkN "möbelmässa" ; -- möbelmässa..nn.1
  möbelsnickare_1_N = mkN "möbelsnickare" utrum  ; -- möbelsnickare..nn.1
  möbelsnickeri_1_N = mkN "möbelsnickeri" "möbelsnickeriet" "möbelsnickerier" "möbelsnickerierna" ; -- möbelsnickeri..nn.1
  möbelspik_1_N = mkN "möbelspik" ; -- möbelspik..nn.1
  möbelstil_1_N = mkN "möbelstil" ; -- möbelstil..nn.1
  möbeltass_1_N = mkN "möbeltass" ; -- möbeltass..nn.1
  möbeltrissa_1_N = mkN "möbeltrissa" ; -- möbeltrissa..nn.1
  möbeltyg_1_N = mkN "möbeltyg" neutrum  ; -- möbeltyg..nn.1
  möbelvaruhus_1_N = mkN "möbelvaruhus" neutrum  ; -- möbelvaruhus..nn.1
  möbelvinkel_1_N = mkN "möbelvinkel" ; -- möbelvinkel..nn.1
  möbelöverdrag_1_N = mkN "möbelöverdrag" neutrum  ; -- möbelöverdrag..nn.1
  möblemang_1_N = mkN "möblemang" neutrum  ; -- möblemang..nn.1
  möblera_1_V = mkV "möblerar" ; -- möblera..vb.1
  möblerande_1_N = mkN "möblerande" ; -- möblerande..nn.1
  möblerbar_1_A = mkA "möblerbar" ; -- möblerbar..av.1
  möblerbarhet_1_N = mkN "möblerbarhet" ; -- möblerbarhet..nn.1
  möblering_1_N = mkN "möblering" ; -- möblering..nn.1
  möda_1_N = mkN "möda" ; -- möda..nn.1
  möderne_1_N = mkN "möderne" ; -- möderne..nn.1
  mödernesida_1_N = mkN "mödernesida" ; -- mödernesida..nn.1
  mödernesläkt_1_N = mkN "mödernesläkt" ; -- mödernesläkt..nn.1
  mödofylld_1_A = mkA "mödofylld" "mödofyllt" ; -- mödofylld..av.1
  mödom_1_N = mkN "mödom" ; -- mödom..nn.1
  mödomshinna_1_N = mkN "mödomshinna" ; -- mödomshinna..nn.1
  mödosam_1_A = mkA "mödosam" "mödosamt" "mödosamma" "mödosamma" "mödosammare" "mödosammast" "mödosammaste" ; -- mödosam..av.1
  mödosamhet_1_N = mkN "mödosamhet" ; -- mödosamhet..nn.1
  mödravård_1_N = mkN "mödravård" ; -- mödravård..nn.1
  mödravårdscentral_1_N = mkN "mödravårdscentral" "mödravårdscentraler" ; -- mödravårdscentral..nn.1
  mögel_1_N = mkN "mögel" neutrum  ; -- mögel..nn.1
  mögelhindrande_1_A = mkA "mögelhindrande" ; -- mögelhindrande..av.1
  mögelhund_1_N = mkN "mögelhund" ; -- mögelhund..nn.1
  mögelost_1_N = mkN "mögelost" ; -- mögelost..nn.1
  mögelsvamp_1_N = mkN "mögelsvamp" ; -- mögelsvamp..nn.1
  mögeltråd_1_N = mkN "mögeltråd" ; -- mögeltråd..nn.1
  mögeltvätt_1_N = mkN "mögeltvätt" ; -- mögeltvätt..nn.1
  mögla_1_V = mkV "möglar" ; -- mögla..vb.1
  möglande_1_N = mkN "möglande" ; -- möglande..nn.1
  möglig_1_A = mkA "möglig" ; -- möglig..av.1
  möglighet_1_N = mkN "möglighet" ; -- möglighet..nn.1
  mögling_1_N = mkN "mögling" ; -- mögling..nn.1
  möhippa_1_N = mkN "möhippa" ; -- möhippa..nn.1
  möjlig_1_A = mkA "möjlig" ; -- möjlig..av.1
  möjligen_1_Adv = mkAdv "möjligen" ; -- möjligen..ab.1
  möjliggöra_1_V = mkV "möjliggöra" "möjliggjorde" "möjliggjort" ; -- möjliggöra..vb.1
  möjliggörande_1_N = mkN "möjliggörande" ; -- möjliggörande..nn.1
  möjlighet_1_N = mkN "möjlighet" "möjligheter" ; -- möjlighet..nn.1
  möjligtvis_1_Adv = mkAdv "möjligtvis" ; -- möjligtvis..ab.1
  mölla_1_N = mkN "mölla" ; -- mölla..nn.1
  mönja_1_N = mkN "mönja" ; -- mönja..nn.1
  mönjefärg_1_N = mkN "mönjefärg" "mönjefärger" ; -- mönjefärg..nn.1
  mönjefärgad_1_A = mkA "mönjefärgad" ; -- mönjefärgad..av.1
  mönster_1_N = mkN "mönster" neutrum  ; -- mönster..nn.1
  mönsterbok_1_N = mkN "mönsterbok" "mönsterböcker" ; -- mönsterbok..nn.1
  mönsterdjup_1_N = mkN "mönsterdjup" neutrum  ; -- mönsterdjup..nn.1
  mönsterfånge_1_N = mkN "mönsterfånge" utrum  ; -- mönsterfånge..nn.1
  mönstergarn_1_N = mkN "mönstergarn" neutrum  ; -- mönstergarn..nn.1
  mönstergill_1_A = mkA "mönstergill" ; -- mönstergill..av.1
  mönstergillhet_1_N = mkN "mönstergillhet" ; -- mönstergillhet..nn.1
  mönstergosse_1_N = mkN "mönstergosse" utrum  ; -- mönstergosse..nn.1
  mönstergård_1_N = mkN "mönstergård" ; -- mönstergård..nn.1
  mönsterjordbruk_1_N = mkN "mönsterjordbruk" neutrum  ; -- mönsterjordbruk..nn.1
  mönsterkarta_1_N = mkN "mönsterkarta" ; -- mönsterkarta..nn.1
  mönstersamhälle_1_N = mkN "mönstersamhälle" ; -- mönstersamhälle..nn.1
  mönsterskydd_1_N = mkN "mönsterskydd" neutrum  ; -- mönsterskydd..nn.1
  mönsterstickad_1_A = mkA "mönsterstickad" ; -- mönsterstickad..av.1
  mönstervävd_1_A = mkA "mönstervävd" "mönstervävt" ; -- mönstervävd..av.1
  mönstra_1_V = mkV "mönstrar" ; -- mönstra..vb.1
  mönstrad_1_A = mkA "mönstrad" ; -- mönstrad..av.1
  mönstrande_1_N = mkN "mönstrande" ; -- mönstrande..nn.1
  mönstring_1_N = mkN "mönstring" ; -- mönstring..nn.1
  mönstringsbevis_1_N = mkN "mönstringsbevis" neutrum  ; -- mönstringsbevis..nn.1
  mönstringsexpedition_1_N = mkN "mönstringsexpedition" ; -- mönstringsexpedition..nn.1
  mönstringsliggare_1_N = mkN "mönstringsliggare" utrum  ; -- mönstringsliggare..nn.1
  mör_1_A = mkA "mör" ; -- mör..av.1
  möra_1_V = mkV "mörar" ; -- möra..vb.1
  mörande_1_N = mkN "mörande" ; -- mörande..nn.1
  mörbulta_1_V = mkV "mörbultar" ; -- mörbulta..vb.1
  mörbultande_1_N = mkN "mörbultande" ; -- mörbultande..nn.1
  mörbultning_1_N = mkN "mörbultning" ; -- mörbultning..nn.1
  mörda_1_V = mkV "mördar" ; -- mörda..vb.1
  mördande_1_A = mkA "mördande" ; -- mördande..av.1
  mördande_1_N = mkN "mördande" ; -- mördande..nn.1
  mördarband_1_N = mkN "mördarband" neutrum  ; -- mördarband..nn.1
  mördare_1_N = mkN "mördare" utrum  ; -- mördare..nn.1
  mördarhund_1_N = mkN "mördarhund" ; -- mördarhund..nn.1
  mördarjakt_1_N = mkN "mördarjakt" "mördarjakter" ; -- mördarjakt..nn.1
  mördarsnigel_1_N = mkN "mördarsnigel" ; -- mördarsnigel..nn.1
  mördeg_1_N = mkN "mördeg" ; -- mördeg..nn.1
  mörhet_1_N = mkN "mörhet" ; -- mörhet..nn.1
  mörja_1_N = mkN "mörja" ; -- mörja..nn.1
  mörjig_1_A = mkA "mörjig" ; -- mörjig..av.1
  mörjighet_1_N = mkN "mörjighet" ; -- mörjighet..nn.1
  mörk_1_A = mkA "mörk" ; -- mörk..av.1
  mörk_1_N = mkN "mörk" ; -- mörk..nn.1
  mörka_1_V = mkV "mörkar" ; -- mörka..vb.1
  mörkalf_1_N = mkN "mörkalf" "mörkalfer" ; -- mörkalf..nn.1
  mörkalv_1_N = mkN "mörkalv" "mörkalver" ; -- mörkalv..nn.1
  mörkande_1_N = mkN "mörkande" ; -- mörkande..nn.1
  mörkblond_1_A = mkA "mörkblond" ; -- mörkblond..av.1
  mörkblondhet_1_N = mkN "mörkblondhet" ; -- mörkblondhet..nn.1
  mörkblå_1_A = mkA "mörkblå" "mörkblått" ; -- mörkblå..av.1
  mörkbrun_1_A = mkA "mörkbrun" ; -- mörkbrun..av.1
  mörker_1_N = mkN "mörker" neutrum  ; -- mörker..nn.1
  mörkerdöd_1_N = mkN "mörkerdöd" ; -- mörkerdöd..nn.1
  mörkerkörning_1_N = mkN "mörkerkörning" ; -- mörkerkörning..nn.1
  mörkerman_1_N = mkN "mörkerman" "mörkermannen" "mörkermän" "mörkermännen" ; -- mörkerman..nn.1
  mörkerseende_1_N = mkN "mörkerseende" ; -- mörkerseende..nn.1
  mörkertal_1_N = mkN "mörkertal" neutrum  ; -- mörkertal..nn.1
  mörkgrå_1_A = mkA "mörkgrå" "mörkgrått" ; -- mörkgrå..av.1
  mörkgrön_1_A = mkA "mörkgrön" ; -- mörkgrön..av.1
  mörkgul_1_A = mkA "mörkgul" ; -- mörkgul..av.1
  mörkhet_1_N = mkN "mörkhet" ; -- mörkhet..nn.1
  mörkhyad_1_A = mkA "mörkhyad" ; -- mörkhyad..av.1
  mörkhårig_1_A = mkA "mörkhårig" ; -- mörkhårig..av.1
  mörkhårighet_1_N = mkN "mörkhårighet" ; -- mörkhårighet..nn.1
  mörkklädd_1_A = mkA "mörkklädd" ; -- mörkklädd..av.1
  mörklagd_1_A = mkA "mörklagd" "mörklagt" ; -- mörklagd..av.1
  mörklockig_1_A = mkA "mörklockig" ; -- mörklockig..av.1
  mörklägga_1_V = mkV "mörklägga" "mörkla" "mörklagt" ; -- mörklägga..vb.1
  mörkläggande_1_N = mkN "mörkläggande" ; -- mörkläggande..nn.1
  mörkläggare_1_N = mkN "mörkläggare" utrum  ; -- mörkläggare..nn.1
  mörkläggning_1_N = mkN "mörkläggning" ; -- mörkläggning..nn.1
  mörkläggningsförsök_1_N = mkN "mörkläggningsförsök" neutrum  ; -- mörkläggningsförsök..nn.1
  mörkläggningsgardin_1_N = mkN "mörkläggningsgardin" "mörkläggningsgardiner" ; -- mörkläggningsgardin..nn.1
  mörkman_1_N = mkN "mörkman" "mörkmannen" "mörkmän" "mörkmännen" ; -- mörkman..nn.1
  mörkna_1_V = mkV "mörknar" ; -- mörkna..vb.1
  mörknande_1_N = mkN "mörknande" ; -- mörknande..nn.1
  mörkning_1_N = mkN "mörkning" ; -- mörkning..nn.1
  mörkning_2_N = mkN "mörkning" ; -- mörkning..nn.2
  mörkrostad_1_A = mkA "mörkrostad" ; -- mörkrostad..av.1
  mörkrum_1_N = mkN "mörkrum" "mörkrummet" "mörkrum" "mörkrummen" ; -- mörkrum..nn.1
  mörkrädd_1_A = mkA "mörkrädd" ; -- mörkrädd..av.1
  mörkrädsla_1_N = mkN "mörkrädsla" ; -- mörkrädsla..nn.1
  mörkröd_1_A = mkA "mörkröd" "mörkrött" ; -- mörkröd..av.1
  mörksens_1_A = mkA "mörksens" ; -- mörksens..av.1
  mörksyn_1_N = mkN "mörksyn" ; -- mörksyn..nn.1
  mörsare_1_N = mkN "mörsare" utrum  ; -- mörsare..nn.1
  mört_1_N = mkN "mört" ; -- mört..nn.1
  mössa_1_N = mkN "mössa" ; -- mössa..nn.1
  mösskapell_1_N = mkN "mösskapell" neutrum  ; -- mösskapell..nn.1
  mösskärm_1_N = mkN "mösskärm" ; -- mösskärm..nn.1
  mössparti_1_N = mkN "mössparti" neutrum  ; -- mössparti..nn.1
  mössrem_1_N = mkN "mössrem" "mössremmen" "mössremmar" "mössremmarna" ; -- mössrem..nn.1
  mössöra_1_N = mkN "mössöra" "mössörat" "mössöron" "mössöronen" ; -- mössöra..nn.1
  möta_1_V = mkV "möter" ; -- möta..vb.1
  mötande_1_N = mkN "mötande" ; -- mötande..nn.1
  möte_1_N = mkN "möte" ; -- möte..nn.1
  mötesfri_1_A = mkA "mötesfri" "mötesfritt" ; -- mötesfri..av.1
  mötesfrihet_1_N = mkN "mötesfrihet" "mötesfriheter" ; -- mötesfrihet..nn.1
  mötesförbud_1_N = mkN "mötesförbud" neutrum  ; -- mötesförbud..nn.1
  möteslokal_1_N = mkN "möteslokal" "möteslokaler" ; -- möteslokal..nn.1
  mötesordförande_1_N = mkN "mötesordförande" "mötesordföranden" "mötesordföranden" "mötesordförandena" ; -- mötesordförande..nn.1
  mötesplats_1_N = mkN "mötesplats" "mötesplatser" ; -- mötesplats..nn.1
  mötespunkt_1_N = mkN "mötespunkt" "mötespunkter" ; -- mötespunkt..nn.1
  mötesspår_1_N = mkN "mötesspår" neutrum  ; -- mötesspår..nn.1
  mötesstation_1_N = mkN "mötesstation" ; -- mötesstation..nn.1
  n_gram_1_N = mkN "n-gram" "n-grammet" "n-gram" "n-grammen" ; -- n-gram..nn.1
  n_1_N = mkN "n" neutrum  ; -- n..nn.1
  nabbad_1_A = mkA "nabbad" ; -- nabbad..av.1
  nabbe_1_N = mkN "nabb" ; -- nabbe..nn.1
  nabo_1_N = mkN "nabo" "nabor" ; -- nabo..nn.1
  nabob_1_N = mkN "nabob" "nabober" ; -- nabob..nn.1
  nabolag_1_N = mkN "nabolag" neutrum  ; -- nabolag..nn.1
  naborätt_1_N = mkN "naborätt" ; -- naborätt..nn.1
  nachspil_1_N = mkN "nachspil" neutrum  ; -- nachspil..nn.1
  nacka_1_V = mkV "nackar" ; -- nacka..vb.1
  nackande_1_N = mkN "nackande" ; -- nackande..nn.1
  nackben_1_N = mkN "nackben" neutrum  ; -- nackben..nn.1
  nackbjudning_1_N = mkN "nackbjudning" ; -- nackbjudning..nn.1
  nackdel_1_N = mkN "nackdel" "nackdelen" "nackdelar" "nackdelarna" ; -- nackdel..nn.1
  nacke_1_N = mkN "nacke" utrum  ; -- nacke..nn.1
  nackhår_1_N = mkN "nackhår" neutrum  ; -- nackhår..nn.1
  nackknut_1_N = mkN "nackknut" ; -- nackknut..nn.1
  nackman_1_N = mkN "nackman" ; -- nackman..nn.1
  nackskada_1_N = mkN "nackskada" ; -- nackskada..nn.1
  nackspärr_1_N = mkN "nackspärr" ; -- nackspärr..nn.1
  nackstyv_1_A = mkA "nackstyv" ; -- nackstyv..av.1
  nackstyvhet_1_N = mkN "nackstyvhet" ; -- nackstyvhet..nn.1
  nacksving_1_N = mkN "nacksving" neutrum  ; -- nacksving..nn.1
  nacktofs_1_N = mkN "nacktofs" ; -- nacktofs..nn.1
  nackvärk_1_N = mkN "nackvärk" ; -- nackvärk..nn.1
  nackvävnad_1_N = mkN "nackvävnad" "nackvävnader" ; -- nackvävnad..nn.1
  nadir_1_N = mkN "nadir" ; -- nadir..nn.1
  nafs_1_N = mkN "nafs" neutrum  ; -- nafs..nn.1
  nafsa_1_V = mkV "nafsar" ; -- nafsa..vb.1
  nafsande_1_N = mkN "nafsande" ; -- nafsande..nn.1
  nafsning_1_N = mkN "nafsning" ; -- nafsning..nn.1
  nafta_1_N = mkN "nafta" ; -- nafta..nn.1
  naftalen_1_N = mkN "naftalen" neutrum  ; -- naftalen..nn.1
  naftalin_1_N = mkN "naftalin" ; -- naftalin..nn.1
  nagajka_1_N = mkN "nagajka" ; -- nagajka..nn.1
  nagel_1_N = mkN "nagel" ; -- nagel..nn.1
  nagelband_1_N = mkN "nagelband" neutrum  ; -- nagelband..nn.1
  nagelbitande_1_A = mkA "nagelbitande" ; -- nagelbitande..av.1
  nagelbitande_1_N = mkN "nagelbitande" ; -- nagelbitande..nn.1
  nagelbitning_1_N = mkN "nagelbitning" ; -- nagelbitning..nn.1
  nagelbädd_1_N = mkN "nagelbädd" ; -- nagelbädd..nn.1
  nagelbänk_1_N = mkN "nagelbänk" ; -- nagelbänk..nn.1
  nagelfara_1_V = mkV "nagelfara" "nagelfor" "nagelfarit" ; -- nagelfara..vb.1
  nagelfarande_1_N = mkN "nagelfarande" ; -- nagelfarande..nn.1
  nagelfil_1_N = mkN "nagelfil" ; -- nagelfil..nn.1
  nagelklippande_1_A = mkA "nagelklippande" ; -- nagelklippande..av.1
  nagelklippande_1_N = mkN "nagelklippande" ; -- nagelklippande..nn.1
  nagelklippare_1_N = mkN "nagelklippare" utrum  ; -- nagelklippare..nn.1
  nagelklippning_1_N = mkN "nagelklippning" ; -- nagelklippning..nn.1
  nagelklippningslöfte_1_N = mkN "nagelklippningslöfte" ; -- nagelklippningslöfte..nn.1
  nagellack_1_N = mkN "nagellack" neutrum  ; -- nagellack..nn.1
  nagelpetare_1_N = mkN "nagelpetare" utrum  ; -- nagelpetare..nn.1
  nagelrot_1_N = mkN "nagelrot" "nagelrötter" ; -- nagelrot..nn.1
  nagelsax_1_N = mkN "nagelsax" ; -- nagelsax..nn.1
  nagelspets_1_N = mkN "nagelspets" ; -- nagelspets..nn.1
  nagelsöm_1_N = mkN "nagelsöm" "nagelsömmen" "nagelsömmar" "nagelsömmarna" ; -- nagelsöm..nn.1
  nageltrång_1_N = mkN "nageltrång" neutrum  ; -- nageltrång..nn.1
  nagelört_1_N = mkN "nagelört" "nagelörter" ; -- nagelört..nn.1
  nagg_1_N = mkN "nagg" ; -- nagg..nn.1
  nagg_2_N = mkN "nagg" neutrum  ; -- nagg..nn.2
  nagga_1_V = mkV "naggar" ; -- nagga..vb.1
  nagga_2_V = mkV "naggar" ; -- nagga..vb.2
  naggande_1_N = mkN "naggande" ; -- naggande..nn.1
  naggning_1_N = mkN "naggning" ; -- naggning..nn.1
  naggsågad_1_A = mkA "naggsågad" ; -- naggsågad..av.1
  nagla_1_V = mkV "naglar" ; -- nagla..vb.1
  naglande_1_N = mkN "naglande" ; -- naglande..nn.1
  nagling_1_N = mkN "nagling" ; -- nagling..nn.1
  naiv_1_A = mkA "naiv" ; -- naiv..av.1
  naivhet_1_N = mkN "naivhet" ; -- naivhet..nn.1
  naivism_1_N = mkN "naivism" "naivismer" ; -- naivism..nn.1
  naivist_1_N = mkN "naivist" "naivister" ; -- naivist..nn.1
  naivistisk_1_A = mkA "naivistisk" ; -- naivistisk..av.1
  naivitet_1_N = mkN "naivitet" "naiviteter" ; -- naivitet..nn.1
  naja_1_V = mkV "najar" ; -- naja..vb.1
  najad_1_N = mkN "najad" "najader" ; -- najad..nn.1
  najande_1_N = mkN "najande" ; -- najande..nn.1
  najtåg_1_N = mkN "najtåg" neutrum  ; -- najtåg..nn.1
  najögonstropp_1_N = mkN "najögonstropp" ; -- najögonstropp..nn.1
  naken_1_A = mkA "naken" ; -- naken..av.1
  nakenakt_1_N = mkN "nakenakt" "nakenakter" ; -- nakenakt..nn.1
  nakenbad_1_N = mkN "nakenbad" neutrum  ; -- nakenbad..nn.1
  nakenbadare_1_N = mkN "nakenbadare" utrum  ; -- nakenbadare..nn.1
  nakenbild_1_N = mkN "nakenbild" "nakenbilder" ; -- nakenbild..nn.1
  nakenblankning_1_N = mkN "nakenblankning" ; -- nakenblankning..nn.1
  nakenchock_1_N = mkN "nakenchock" "nakenchocker" ; -- nakenchock..nn.1
  nakendans_1_N = mkN "nakendans" "nakendanser" ; -- nakendans..nn.1
  nakendansös_1_N = mkN "nakendansös" "nakendansöser" ; -- nakendansös..nn.1
  nakenfröig_1_A = mkA "nakenfröig" ; -- nakenfröig..av.1
  nakenhet_1_N = mkN "nakenhet" "nakenheter" ; -- nakenhet..nn.1
  nakenkindad_1_A = mkA "nakenkindad" ; -- nakenkindad..av.1
  nakenkrav_1_N = mkN "nakenkrav" neutrum  ; -- nakenkrav..nn.1
  nakenkult_1_N = mkN "nakenkult" "nakenkulter" ; -- nakenkult..nn.1
  nakenkultur_1_N = mkN "nakenkultur" "nakenkulturer" ; -- nakenkultur..nn.1
  nakenmodell_1_N = mkN "nakenmodell" "nakenmodeller" ; -- nakenmodell..nn.1
  nakenscen_1_N = mkN "nakenscen" "nakenscener" ; -- nakenscen..nn.1
  nakenskanner_1_N = mkN "nakenskanner" ; -- nakenskanner..nn.1
  nakenstudie_1_N = mkN "nakenstudie" "nakenstudier" ; -- nakenstudie..nn.1
  nakenvandrare_1_N = mkN "nakenvandrare" utrum  ; -- nakenvandrare..nn.1
  naketbild_1_N = mkN "naketbild" "naketbilder" ; -- naketbild..nn.1
  naketmåleri_1_N = mkN "naketmåleri" neutrum  ; -- naketmåleri..nn.1
  nakterhus_1_N = mkN "nakterhus" neutrum  ; -- nakterhus..nn.1
  nalla_1_V = mkV "nallar" ; -- nalla..vb.1
  nallande_1_N = mkN "nallande" ; -- nallande..nn.1
  nalle_1_N = mkN "nalle" utrum  ; -- nalle..nn.1
  namibier_1_N = mkN "namibier" "namibiern" "namibier" "namibierna" ; -- namibier..nn.1
  namibisk_1_A = mkA "namibisk" ; -- namibisk..av.1
  namibiska_1_N = mkN "namibiska" ; -- namibiska..nn.1
  namn_1_N = mkN "namn" neutrum  ; -- namn..nn.1
  namna_1_V = mkV "namnar" ; -- namna..vb.1
  namnaktie_1_N = mkN "namnaktie" "namnaktier" ; -- namnaktie..nn.1
  namnam_1_N = mkN "namnam" neutrum  ; -- namnam..nn.1
  namnande_1_N = mkN "namnande" ; -- namnande..nn.1
  namnanrop_1_N = mkN "namnanrop" neutrum  ; -- namnanrop..nn.1
  namnberedning_1_N = mkN "namnberedning" ; -- namnberedning..nn.1
  namnbläck_1_N = mkN "namnbläck" neutrum  ; -- namnbläck..nn.1
  namnbråk_1_N = mkN "namnbråk" neutrum  ; -- namnbråk..nn.1
  namnbyte_1_N = mkN "namnbyte" ; -- namnbyte..nn.1
  namnbärare_1_N = mkN "namnbärare" utrum  ; -- namnbärare..nn.1
  namnchiffer_1_N = mkN "namnchiffer" neutrum  ; -- namnchiffer..nn.1
  namndikt_1_N = mkN "namndikt" "namndikter" ; -- namndikt..nn.1
  namne_1_N = mkN "namne" utrum  ; -- namne..nn.1
  namneligen_1_Adv = mkAdv "namneligen" ; -- namneligen..ab.1
  namnfrejd_1_N = mkN "namnfrejd" ; -- namnfrejd..nn.1
  namnfästa_1_V = mkV "namnfästa" "namnfäster" "namnfäst" "namnfäste" "namnfäst" "namnfäst" ; -- namnfästa..vb.1
  namnfästande_1_N = mkN "namnfästande" ; -- namnfästande..nn.1
  namnförklaring_1_N = mkN "namnförklaring" ; -- namnförklaring..nn.1
  namnförändring_1_N = mkN "namnförändring" ; -- namnförändring..nn.1
  namnge_1_V = mkV "namngiva" "namngav" "namngivit" ; -- namnge..vb.1
  namngivande_1_N = mkN "namngivande" ; -- namngivande..nn.1
  namngivning_1_N = mkN "namngivning" ; -- namngivning..nn.1
  namninsamling_1_N = mkN "namninsamling" ; -- namninsamling..nn.1
  namnkredit_1_N = mkN "namnkredit" "namnkrediter" ; -- namnkredit..nn.1
  namnkristen_1_A = mkA "namnkristen" ; -- namnkristen..av.1
  namnkunnig_1_A = mkA "namnkunnig" ; -- namnkunnig..av.1
  namnkunnighet_1_N = mkN "namnkunnighet" "namnkunnigheter" ; -- namnkunnighet..nn.1
  namnlag_1_N = mkN "namnlag" ; -- namnlag..nn.1
  namnlista_1_N = mkN "namnlista" ; -- namnlista..nn.1
  namnlängd_1_N = mkN "namnlängd" "namnlängder" ; -- namnlängd..nn.1
  namnlös_1_A = mkA "namnlös" ; -- namnlös..av.1
  namnlöshet_1_N = mkN "namnlöshet" ; -- namnlöshet..nn.1
  namnminne_1_N = mkN "namnminne" ; -- namnminne..nn.1
  namnmässig_1_A = mkA "namnmässig" ; -- namnmässig..av.1
  namnplåt_1_N = mkN "namnplåt" ; -- namnplåt..nn.1
  namnsdag_1_N = mkN "namnsdag" ; -- namnsdag..nn.1
  namnsdagsbarn_1_N = mkN "namnsdagsbarn" neutrum  ; -- namnsdagsbarn..nn.1
  namnsdagsgåva_1_N = mkN "namnsdagsgåva" ; -- namnsdagsgåva..nn.1
  namnsedel_1_N = mkN "namnsedel" ; -- namnsedel..nn.1
  namnskick_1_N = mkN "namnskick" neutrum  ; -- namnskick..nn.1
  namnskydd_1_N = mkN "namnskydd" neutrum  ; -- namnskydd..nn.1
  namnskyddad_1_A = mkA "namnskyddad" ; -- namnskyddad..av.1
  namnskylt_1_N = mkN "namnskylt" ; -- namnskylt..nn.1
  namnstandert_1_N = mkN "namnstandert" ; -- namnstandert..nn.1
  namnstämpel_1_N = mkN "namnstämpel" ; -- namnstämpel..nn.1
  namnsäkerhet_1_N = mkN "namnsäkerhet" "namnsäkerheter" ; -- namnsäkerhet..nn.1
  namntavla_1_N = mkN "namntavla" ; -- namntavla..nn.1
  namnteckning_1_N = mkN "namnteckning" ; -- namnteckning..nn.1
  namnunderskrift_1_N = mkN "namnunderskrift" "namnunderskrifter" ; -- namnunderskrift..nn.1
  namnuppgift_1_N = mkN "namnuppgift" "namnuppgifter" ; -- namnuppgift..nn.1
  namnupprop_1_N = mkN "namnupprop" neutrum  ; -- namnupprop..nn.1
  namnvärde_1_N = mkN "namnvärde" ; -- namnvärde..nn.1
  nankin_1_N = mkN "nankin" ; -- nankin..nn.1
  nanking_1_N = mkN "nanking" ; -- nanking..nn.1
  nanoblomma_1_N = mkN "nanoblomma" ; -- nanoblomma..nn.1
  nanobot_1_N = mkN "nanobot" ; -- nanobot..nn.1
  nanogram_1_N = mkN "nanogram" "nanogrammet" "nanogram" "nanogrammen" ; -- nanogram..nn.1
  nanokolrör_1_N = mkN "nanokolrör" neutrum  ; -- nanokolrör..nn.1
  nanomaterial_1_N = mkN "nanomaterial" neutrum  ; -- nanomaterial..nn.1
  nanometer_1_N = mkN "nanometer" ; -- nanometer..nn.1
  nanopartikel_1_N = mkN "nanopartikel" ; -- nanopartikel..nn.1
  nanorör_1_N = mkN "nanorör" neutrum  ; -- nanorör..nn.1
  nanosekund_1_N = mkN "nanosekund" "nanosekunder" ; -- nanosekund..nn.1
  nanoteknik_1_N = mkN "nanoteknik" ; -- nanoteknik..nn.1
  nanoteknologi_1_N = mkN "nanoteknologi" "nanoteknologier" ; -- nanoteknologi..nn.1
  nanotråd_1_N = mkN "nanotråd" ; -- nanotråd..nn.1
  napalm_1_N = mkN "napalm" ; -- napalm..nn.1
  napalmbomb_1_N = mkN "napalmbomb" "napalmbomber" ; -- napalmbomb..nn.1
  napoleonbakelse_1_N = mkN "napoleonbakelse" "napoleonbakelser" ; -- napoleonbakelse..nn.1
  napolitanare_1_N = mkN "napolitanare" utrum  ; -- napolitanare..nn.1
  napolitansk_1_A = mkA "napolitansk" ; -- napolitansk..av.1
  napp_1_N = mkN "napp" neutrum  ; -- napp..nn.1
  napp_2_N = mkN "napp" ; -- napp..nn.2
  nappa_1_N = mkN "nappa" ; -- nappa..nn.1
  nappa_1_V = mkV "nappar" ; -- nappa..vb.1
  nappa_2_V = mkV "nappar" ; -- nappa..vb.2
  nappande_1_N = mkN "nappande" ; -- nappande..nn.1
  nappatag_1_N = mkN "nappatag" neutrum  ; -- nappatag..nn.1
  nappflaska_1_N = mkN "nappflaska" ; -- nappflaska..nn.1
  naprapat_1_N = mkN "naprapat" "naprapater" ; -- naprapat..nn.1
  nar_1_N = mkN "nar" ; -- nar..nn.1
  nara_1_V = mkV "narar" ; -- nara..vb.1
  nara_2_V = mkV "narar" ; -- nara..vb.2
  narande_1_N = mkN "narande" ; -- narande..nn.1
  narciss_1_N = mkN "narciss" "narcisser" ; -- narciss..nn.1
  narcissism_1_N = mkN "narcissism" "narcissismer" ; -- narcissism..nn.1
  narcissistisk_1_A = mkA "narcissistisk" ; -- narcissistisk..av.1
  nardus_1_N = mkN "nardus" ; -- nardus..nn.1
  narduslilja_1_N = mkN "narduslilja" ; -- narduslilja..nn.1
  nare_1_N = mkN "nare" utrum  ; -- nare..nn.1
  narig_1_A = mkA "narig" ; -- narig..av.1
  narighet_1_N = mkN "narighet" "narigheter" ; -- narighet..nn.1
  narkoanalys_1_N = mkN "narkoanalys" "narkoanalyser" ; -- narkoanalys..nn.1
  narkolepsi_1_N = mkN "narkolepsi" "narkolepsier" ; -- narkolepsi..nn.1
  narkoleptiker_1_N = mkN "narkoleptiker" "narkoleptikern" "narkoleptiker" "narkoleptikerna" ; -- narkoleptiker..nn.1
  narkoman_1_N = mkN "narkoman" "narkomaner" ; -- narkoman..nn.1
  narkomani_1_N = mkN "narkomani" ; -- narkomani..nn.1
  narkomanvård_1_N = mkN "narkomanvård" ; -- narkomanvård..nn.1
  narkos_1_N = mkN "narkos" "narkoser" ; -- narkos..nn.1
  narkosläkare_1_N = mkN "narkosläkare" utrum  ; -- narkosläkare..nn.1
  narkosmedel_1_N = mkN "narkosmedel" neutrum  ; -- narkosmedel..nn.1
  narkotika_1_N = mkN "narkotika" ; -- narkotika..nn.1
  narkotikabekämpning_1_N = mkN "narkotikabekämpning" ; -- narkotikabekämpning..nn.1
  narkotikaberoende_1_N = mkN "narkotikaberoende" ; -- narkotikaberoende..nn.1
  narkotikabrott_1_N = mkN "narkotikabrott" neutrum  ; -- narkotikabrott..nn.1
  narkotikafri_1_A = mkA "narkotikafri" "narkotikafritt" ; -- narkotikafri..av.1
  narkotikaförsäljning_1_N = mkN "narkotikaförsäljning" ; -- narkotikaförsäljning..nn.1
  narkotikahaj_1_N = mkN "narkotikahaj" ; -- narkotikahaj..nn.1
  narkotikahandel_1_N = mkN "narkotikahandel" ; -- narkotikahandel..nn.1
  narkotikahund_1_N = mkN "narkotikahund" ; -- narkotikahund..nn.1
  narkotikainnehav_1_N = mkN "narkotikainnehav" neutrum  ; -- narkotikainnehav..nn.1
  narkotikaklassad_1_A = mkA "narkotikaklassad" ; -- narkotikaklassad..av.1
  narkotikaklinik_1_N = mkN "narkotikaklinik" "narkotikakliniker" ; -- narkotikaklinik..nn.1
  narkotikamissbruk_1_N = mkN "narkotikamissbruk" neutrum  ; -- narkotikamissbruk..nn.1
  narkotikapåverkad_1_A = mkA "narkotikapåverkad" ; -- narkotikapåverkad..av.1
  narkotikarelaterad_1_A = mkA "narkotikarelaterad" ; -- narkotikarelaterad..av.1
  narkotikarotel_1_N = mkN "narkotikarotel" ; -- narkotikarotel..nn.1
  narkotikasmugglare_1_N = mkN "narkotikasmugglare" utrum  ; -- narkotikasmugglare..nn.1
  narkotikasmuggling_1_N = mkN "narkotikasmuggling" ; -- narkotikasmuggling..nn.1
  narkotikastrategi_1_N = mkN "narkotikastrategi" "narkotikastrategier" ; -- narkotikastrategi..nn.1
  narkotikautredning_1_N = mkN "narkotikautredning" ; -- narkotikautredning..nn.1
  narkotikautskrivning_1_N = mkN "narkotikautskrivning" ; -- narkotikautskrivning..nn.1
  narkotikum_1_N = mkN "narkotikum" "narkotikumet" "narkotika" "narkotikana" ; -- narkotikum..nn.1
  narkotisk_1_A = mkA "narkotisk" ; -- narkotisk..av.1
  narr_1_N = mkN "narr" ; -- narr..nn.1
  narra_1_V = mkV "narrar" ; -- narra..vb.1
  narraktig_1_A = mkA "narraktig" ; -- narraktig..av.1
  narraktighet_1_N = mkN "narraktighet" ; -- narraktighet..nn.1
  narrande_1_N = mkN "narrande" ; -- narrande..nn.1
  narrativ_1_A = mkA "narrativ" ; -- narrativ..av.1
  narrdräkt_1_N = mkN "narrdräkt" "narrdräkter" ; -- narrdräkt..nn.1
  narrkåpa_1_N = mkN "narrkåpa" ; -- narrkåpa..nn.1
  narrluva_1_N = mkN "narrluva" ; -- narrluva..nn.1
  narrspegel_1_N = mkN "narrspegel" ; -- narrspegel..nn.1
  narrspel_1_N = mkN "narrspel" "narrspelet" "narrspel" "narrspelen" ; -- narrspel..nn.1
  narrstreck_1_N = mkN "narrstreck" neutrum  ; -- narrstreck..nn.1
  narv_1_N = mkN "narv" ; -- narv..nn.1
  narva_1_V = mkV "narvar" ; -- narva..vb.1
  narval_1_N = mkN "narval" ; -- narval..nn.1
  narvande_1_N = mkN "narvande" ; -- narvande..nn.1
  narvfel_1_N = mkN "narvfel" "narvfelet" "narvfel" "narvfelen" ; -- narvfel..nn.1
  narvhuggen_1_A = mkA "narvhuggen" ; -- narvhuggen..av.1
  narvspalt_1_N = mkN "narvspalt" "narvspalter" ; -- narvspalt..nn.1
  nasa_1_V = mkV "nasar" ; -- nasa..vb.1
  nasal_1_A = mkA "nasal" ; -- nasal..av.1
  nasal_1_N = mkN "nasal" "nasaler" ; -- nasal..nn.1
  nasalera_1_V = mkV "nasalerar" ; -- nasalera..vb.1
  nasalerande_1_N = mkN "nasalerande" ; -- nasalerande..nn.1
  nasalerbar_1_A = mkA "nasalerbar" ; -- nasalerbar..av.1
  nasalerbarhet_1_N = mkN "nasalerbarhet" ; -- nasalerbarhet..nn.1
  nasalering_1_N = mkN "nasalering" ; -- nasalering..nn.1
  nasalisera_1_V = mkV "nasaliserar" ; -- nasalisera..vb.1
  nasaliserande_1_N = mkN "nasaliserande" ; -- nasaliserande..nn.1
  nasaliserbar_1_A = mkA "nasaliserbar" ; -- nasaliserbar..av.1
  nasaliserbarhet_1_N = mkN "nasaliserbarhet" ; -- nasaliserbarhet..nn.1
  nasalisering_1_N = mkN "nasalisering" ; -- nasalisering..nn.1
  nasalljud_1_N = mkN "nasalljud" neutrum  ; -- nasalljud..nn.1
  nasalvokal_1_N = mkN "nasalvokal" "nasalvokaler" ; -- nasalvokal..nn.1
  nasande_1_N = mkN "nasande" ; -- nasande..nn.1
  nasare_1_N = mkN "nasare" utrum  ; -- nasare..nn.1
  nasaré_1_N = mkN "nasaré" "nasaréer" ; -- nasaré..nn.1
  nasir_1_N = mkN "nasir" "nasirer" ; -- nasir..nn.1
  nasse_1_N = mkN "nasse" utrum  ; -- nasse..nn.1
  nate_1_N = mkN "nate" utrum  ; -- nate..nn.1
  nation_1_N = mkN "nation" ; -- nation..nn.1
  nationalanda_1_N = mkN "nationalanda" ; -- nationalanda..nn.1
  nationalarena_1_N = mkN "nationalarena" ; -- nationalarena..nn.1
  nationalbegrepp_1_N = mkN "nationalbegrepp" neutrum  ; -- nationalbegrepp..nn.1
  nationalbudget_1_N = mkN "nationalbudget" ; -- nationalbudget..nn.1
  nationaldag_1_N = mkN "nationaldag" ; -- nationaldag..nn.1
  nationaldagsfirande_1_N = mkN "nationaldagsfirande" ; -- nationaldagsfirande..nn.1
  nationaldrag_1_N = mkN "nationaldrag" neutrum  ; -- nationaldrag..nn.1
  nationaldräkt_1_N = mkN "nationaldräkt" "nationaldräkter" ; -- nationaldräkt..nn.1
  nationalekonom_1_N = mkN "nationalekonom" "nationalekonomer" ; -- nationalekonom..nn.1
  nationalekonomi_1_N = mkN "nationalekonomi" ; -- nationalekonomi..nn.1
  nationalekonomisk_1_A = mkA "nationalekonomisk" ; -- nationalekonomisk..av.1
  nationalflagga_1_N = mkN "nationalflagga" ; -- nationalflagga..nn.1
  nationalförening_1_N = mkN "nationalförening" ; -- nationalförening..nn.1
  nationalförmögenhet_1_N = mkN "nationalförmögenhet" "nationalförmögenheter" ; -- nationalförmögenhet..nn.1
  nationalförsamling_1_N = mkN "nationalförsamling" ; -- nationalförsamling..nn.1
  nationalförsvar_1_N = mkN "nationalförsvar" neutrum  ; -- nationalförsvar..nn.1
  nationalgalleri_1_N = mkN "nationalgalleri" "nationalgalleriet" "nationalgallerier" "nationalgallerierna" ; -- nationalgalleri..nn.1
  nationalgarde_1_N = mkN "nationalgarde" ; -- nationalgarde..nn.1
  nationalhelgon_1_N = mkN "nationalhelgon" neutrum  ; -- nationalhelgon..nn.1
  nationalhjälte_1_N = mkN "nationalhjälte" utrum  ; -- nationalhjälte..nn.1
  nationalinkomst_1_N = mkN "nationalinkomst" "nationalinkomster" ; -- nationalinkomst..nn.1
  nationalisera_1_V = mkV "nationaliserar" ; -- nationalisera..vb.1
  nationaliserande_1_N = mkN "nationaliserande" ; -- nationaliserande..nn.1
  nationaliserbar_1_A = mkA "nationaliserbar" ; -- nationaliserbar..av.1
  nationaliserbarhet_1_N = mkN "nationaliserbarhet" ; -- nationaliserbarhet..nn.1
  nationalisering_1_N = mkN "nationalisering" ; -- nationalisering..nn.1
  nationalism_1_N = mkN "nationalism" "nationalismer" ; -- nationalism..nn.1
  nationalist_1_N = mkN "nationalist" "nationalister" ; -- nationalist..nn.1
  nationalistisk_1_A = mkA "nationalistisk" ; -- nationalistisk..av.1
  nationalistledare_1_N = mkN "nationalistledare" utrum  ; -- nationalistledare..nn.1
  nationaliströrelse_1_N = mkN "nationaliströrelse" "nationaliströrelser" ; -- nationaliströrelse..nn.1
  nationalitet_1_N = mkN "nationalitet" "nationaliteter" ; -- nationalitet..nn.1
  nationalitetsbeteckning_1_N = mkN "nationalitetsbeteckning" ; -- nationalitetsbeteckning..nn.1
  nationalitetsbevis_1_N = mkN "nationalitetsbevis" neutrum  ; -- nationalitetsbevis..nn.1
  nationalitetsbokstav_1_N = mkN "nationalitetsbokstav" "nationalitetsbokstäver" ; -- nationalitetsbokstav..nn.1
  nationalitetscertifikat_1_N = mkN "nationalitetscertifikat" neutrum  ; -- nationalitetscertifikat..nn.1
  nationalitetsflagga_1_N = mkN "nationalitetsflagga" ; -- nationalitetsflagga..nn.1
  nationalitetshandling_1_N = mkN "nationalitetshandling" ; -- nationalitetshandling..nn.1
  nationalitetsintyg_1_N = mkN "nationalitetsintyg" neutrum  ; -- nationalitetsintyg..nn.1
  nationalitetsmatrikel_1_N = mkN "nationalitetsmatrikel" ; -- nationalitetsmatrikel..nn.1
  nationalitetsmärke_1_N = mkN "nationalitetsmärke" ; -- nationalitetsmärke..nn.1
  nationalitetsprincip_1_N = mkN "nationalitetsprincip" ; -- nationalitetsprincip..nn.1
  nationalitetsspillra_1_N = mkN "nationalitetsspillra" ; -- nationalitetsspillra..nn.1
  nationalitetssträvande_1_N = mkN "nationalitetssträvande" ; -- nationalitetssträvande..nn.1
  nationalkapital_1_N = mkN "nationalkapital" neutrum  ; -- nationalkapital..nn.1
  nationalkaraktär_1_N = mkN "nationalkaraktär" "nationalkaraktärer" ; -- nationalkaraktär..nn.1
  nationalkyrka_1_N = mkN "nationalkyrka" ; -- nationalkyrka..nn.1
  nationalkänsla_1_N = mkN "nationalkänsla" ; -- nationalkänsla..nn.1
  nationalliberal_1_A = mkA "nationalliberal" ; -- nationalliberal..av.1
  nationalliberal_1_N = mkN "nationalliberal" "nationalliberaler" ; -- nationalliberal..nn.1
  nationalmedvetande_1_N = mkN "nationalmedvetande" ; -- nationalmedvetande..nn.1
  nationalmuseum_1_N = mkN "nationalmuseum" "nationalmuseet" "nationalmuseer" "nationalmuseerna" ; -- nationalmuseum..nn.1
  nationalpark_1_N = mkN "nationalpark" "nationalparker" ; -- nationalpark..nn.1
  nationalprodukt_1_N = mkN "nationalprodukt" "nationalprodukter" ; -- nationalprodukt..nn.1
  nationalromantik_1_N = mkN "nationalromantik" ; -- nationalromantik..nn.1
  nationalromantisk_1_A = mkA "nationalromantisk" ; -- nationalromantisk..av.1
  nationalrätt_1_N = mkN "nationalrätt" "nationalrätter" ; -- nationalrätt..nn.1
  nationalscen_1_N = mkN "nationalscen" "nationalscener" ; -- nationalscen..nn.1
  nationalskald_1_N = mkN "nationalskald" "nationalskalder" ; -- nationalskald..nn.1
  nationalsocialism_1_N = mkN "nationalsocialism" "nationalsocialismer" ; -- nationalsocialism..nn.1
  nationalsocialist_1_N = mkN "nationalsocialist" "nationalsocialister" ; -- nationalsocialist..nn.1
  nationalsocialistisk_1_A = mkA "nationalsocialistisk" ; -- nationalsocialistisk..av.1
  nationalsport_1_N = mkN "nationalsport" "nationalsporter" ; -- nationalsport..nn.1
  nationalspråk_1_N = mkN "nationalspråk" neutrum  ; -- nationalspråk..nn.1
  nationalstat_1_N = mkN "nationalstat" "nationalstater" ; -- nationalstat..nn.1
  nationalstereotyp_1_N = mkN "nationalstereotyp" "nationalstereotyper" ; -- nationalstereotyp..nn.1
  nationalsång_1_N = mkN "nationalsång" "nationalsånger" ; -- nationalsång..nn.1
  nationalteater_1_N = mkN "nationalteater" ; -- nationalteater..nn.1
  nationell_1_A = mkA "nationell" ; -- nationell..av.1
  nationsavgift_1_N = mkN "nationsavgift" "nationsavgifter" ; -- nationsavgift..nn.1
  nationsbygge_1_N = mkN "nationsbygge" ; -- nationsbygge..nn.1
  nationsflagga_1_N = mkN "nationsflagga" ; -- nationsflagga..nn.1
  nationsgräns_1_N = mkN "nationsgräns" "nationsgränser" ; -- nationsgräns..nn.1
  nationsinspektor_1_N = mkN "nationsinspektor" "nationsinspektorer" ; -- nationsinspektor..nn.1
  nationskurator_1_N = mkN "nationskurator" "nationskuratorer" ; -- nationskurator..nn.1
  nationsvis_1_Adv = mkAdv "nationsvis" ; -- nationsvis..ab.1
  nativ_1_A = mkA "nativ" ; -- nativ..av.1
  nativitet_1_N = mkN "nativitet" "nativiteter" ; -- nativitet..nn.1
  natrium_1_N = mkN "natrium" neutrum  ; -- natrium..nn.1
  natriumbikarbonat_1_N = mkN "natriumbikarbonat" ; -- natriumbikarbonat..nn.1
  natriumhalt_1_N = mkN "natriumhalt" "natriumhalter" ; -- natriumhalt..nn.1
  natriumhydroxid_1_N = mkN "natriumhydroxid" "natriumhydroxider" ; -- natriumhydroxid..nn.1
  natriumklorid_1_N = mkN "natriumklorid" ; -- natriumklorid..nn.1
  natriumkonsumtion_1_N = mkN "natriumkonsumtion" ; -- natriumkonsumtion..nn.1
  natriumkyld_1_A = mkA "natriumkyld" "natriumkylt" ; -- natriumkyld..av.1
  natriumlampa_1_N = mkN "natriumlampa" ; -- natriumlampa..nn.1
  natriumnitrat_1_N = mkN "natriumnitrat" neutrum  ; -- natriumnitrat..nn.1
  natriumsulfat_1_N = mkN "natriumsulfat" neutrum  ; -- natriumsulfat..nn.1
  natriumtiosulfat_1_N = mkN "natriumtiosulfat" "natriumtiosulfater" ; -- natriumtiosulfat..nn.1
  natron_1_N = mkN "natron" neutrum  ; -- natron..nn.1
  natroncellulosa_1_N = mkN "natroncellulosa" ; -- natroncellulosa..nn.1
  natronglas_1_N = mkN "natronglas" neutrum  ; -- natronglas..nn.1
  natronlut_1_N = mkN "natronlut" ; -- natronlut..nn.1
  natronsalpeter_1_N = mkN "natronsalpeter" ; -- natronsalpeter..nn.1
  natt_1_N = mkN "natt" "nätter" ; -- natt..nn.1
  natta_1_V = mkV "nattar" ; -- natta..vb.1
  nattaktiv_1_A = mkA "nattaktiv" ; -- nattaktiv..av.1
  nattande_1_N = mkN "nattande" ; -- nattande..nn.1
  nattarbete_1_N = mkN "nattarbete" ; -- nattarbete..nn.1
  nattbad_1_N = mkN "nattbad" neutrum  ; -- nattbad..nn.1
  nattblacka_1_N = mkN "nattblacka" ; -- nattblacka..nn.1
  nattblind_1_A = mkA "nattblind" ; -- nattblind..av.1
  nattblindhet_1_N = mkN "nattblindhet" "nattblindheter" ; -- nattblindhet..nn.1
  nattblomma_1_N = mkN "nattblomma" ; -- nattblomma..nn.1
  nattblå_1_A = mkA "nattblå" "nattblått" ; -- nattblå..av.1
  nattbord_1_N = mkN "nattbord" neutrum  ; -- nattbord..nn.1
  nattdjur_1_N = mkN "nattdjur" neutrum  ; -- nattdjur..nn.1
  nattdräkt_1_N = mkN "nattdräkt" "nattdräkter" ; -- nattdräkt..nn.1
  nattduksbord_1_N = mkN "nattduksbord" neutrum  ; -- nattduksbord..nn.1
  nattduksbordslåda_1_N = mkN "nattduksbordslåda" ; -- nattduksbordslåda..nn.1
  natteffekt_1_N = mkN "natteffekt" ; -- natteffekt..nn.1
  nattfack_1_N = mkN "nattfack" neutrum  ; -- nattfack..nn.1
  nattfjäril_1_N = mkN "nattfjäril" ; -- nattfjäril..nn.1
  nattfly_1_N = mkN "nattfly" "nattflyet" "nattflyn" "nattflyna" ; -- nattfly..nn.1
  nattfriare_1_N = mkN "nattfriare" utrum  ; -- nattfriare..nn.1
  nattfrieri_1_N = mkN "nattfrieri" "nattfrieriet" "nattfrierier" "nattfrierierna" ; -- nattfrieri..nn.1
  nattfrost_1_N = mkN "nattfrost" ; -- nattfrost..nn.1
  nattfrusen_1_A = mkA "nattfrusen" ; -- nattfrusen..av.1
  nattfrämmande_1_N = mkN "nattfrämmande" ; -- nattfrämmande..nn.1
  nattfågel_1_N = mkN "nattfågel" ; -- nattfågel..nn.1
  nattglim_1_N = mkN "nattglim" "nattglimmen" "nattglim" "nattglimmen" ; -- nattglim..nn.1
  nattgången_1_A = mkA "nattgången" ; -- nattgången..av.1
  natthamn_1_N = mkN "natthamn" ; -- natthamn..nn.1
  natthimmel_1_N = mkN "natthimmel" ; -- natthimmel..nn.1
  nattiné_1_N = mkN "nattiné" "nattinéer" ; -- nattiné..nn.1
  nattis_1_N = mkN "nattis" ; -- nattis..nn.1
  nattis_2_N = mkN "nattis" neutrum  ; -- nattis..nn.2
  nattjour_1_N = mkN "nattjour" "nattjourer" ; -- nattjour..nn.1
  nattjänstgöring_1_N = mkN "nattjänstgöring" ; -- nattjänstgöring..nn.1
  nattkappa_1_N = mkN "nattkappa" ; -- nattkappa..nn.1
  nattkikare_1_N = mkN "nattkikare" utrum  ; -- nattkikare..nn.1
  nattklocka_1_N = mkN "nattklocka" ; -- nattklocka..nn.1
  nattklubb_1_N = mkN "nattklubb" ; -- nattklubb..nn.1
  nattklubbsdanserska_1_N = mkN "nattklubbsdanserska" ; -- nattklubbsdanserska..nn.1
  nattklubbskund_1_N = mkN "nattklubbskund" "nattklubbskunder" ; -- nattklubbskund..nn.1
  nattkorv_1_N = mkN "nattkorv" ; -- nattkorv..nn.1
  nattkräm_1_N = mkN "nattkräm" "nattkrämer" ; -- nattkräm..nn.1
  nattkvist_1_N = mkN "nattkvist" ; -- nattkvist..nn.1
  nattkyla_1_N = mkN "nattkyla" ; -- nattkyla..nn.1
  nattkärl_1_N = mkN "nattkärl" neutrum  ; -- nattkärl..nn.1
  nattlampa_1_N = mkN "nattlampa" ; -- nattlampa..nn.1
  nattlig_1_A = mkA "nattlig" ; -- nattlig..av.1
  nattlik_1_A = mkA "nattlik" ; -- nattlik..av.1
  nattlinne_1_N = mkN "nattlinne" ; -- nattlinne..nn.1
  nattliv_1_N = mkN "nattliv" neutrum  ; -- nattliv..nn.1
  nattljus_1_N = mkN "nattljus" neutrum  ; -- nattljus..nn.1
  nattlogerare_1_N = mkN "nattlogerare" utrum  ; -- nattlogerare..nn.1
  nattlogi_1_N = mkN "nattlogi" neutrum  ; -- nattlogi..nn.1
  nattlucka_1_N = mkN "nattlucka" ; -- nattlucka..nn.1
  nattluft_1_N = mkN "nattluft" ; -- nattluft..nn.1
  nattläger_1_N = mkN "nattläger" neutrum  ; -- nattläger..nn.1
  nattlängd_1_N = mkN "nattlängd" "nattlängder" ; -- nattlängd..nn.1
  nattmangling_1_N = mkN "nattmangling" ; -- nattmangling..nn.1
  nattmara_1_N = mkN "nattmara" ; -- nattmara..nn.1
  nattmarsch_1_N = mkN "nattmarsch" "nattmarscher" ; -- nattmarsch..nn.1
  nattmoln_1_N = mkN "nattmoln" neutrum  ; -- nattmoln..nn.1
  nattmörker_1_N = mkN "nattmörker" neutrum  ; -- nattmörker..nn.1
  nattmössa_1_N = mkN "nattmössa" ; -- nattmössa..nn.1
  nattorientering_1_N = mkN "nattorientering" ; -- nattorientering..nn.1
  nattpatrull_1_N = mkN "nattpatrull" "nattpatruller" ; -- nattpatrull..nn.1
  nattraj_1_N = mkN "nattraj" neutrum  ; -- nattraj..nn.1
  nattro_1_N = mkN "nattro" ; -- nattro..nn.1
  nattrock_1_N = mkN "nattrock" ; -- nattrock..nn.1
  nattsexa_1_N = mkN "nattsexa" ; -- nattsexa..nn.1
  nattsikte_1_N = mkN "nattsikte" ; -- nattsikte..nn.1
  nattskatta_1_N = mkN "nattskatta" ; -- nattskatta..nn.1
  nattskift_1_N = mkN "nattskift" neutrum  ; -- nattskift..nn.1
  nattskjorta_1_N = mkN "nattskjorta" ; -- nattskjorta..nn.1
  nattskärra_1_N = mkN "nattskärra" ; -- nattskärra..nn.1
  nattsköterska_1_N = mkN "nattsköterska" ; -- nattsköterska..nn.1
  nattslag_1_N = mkN "nattslag" neutrum  ; -- nattslag..nn.1
  nattslända_1_N = mkN "nattslända" ; -- nattslända..nn.1
  nattsmyg_1_N = mkN "nattsmyg" ; -- nattsmyg..nn.1
  nattspanare_1_N = mkN "nattspanare" utrum  ; -- nattspanare..nn.1
  nattspår_1_N = mkN "nattspår" neutrum  ; -- nattspår..nn.1
  nattstol_1_N = mkN "nattstol" ; -- nattstol..nn.1
  nattstrid_1_N = mkN "nattstrid" "nattstrider" ; -- nattstrid..nn.1
  nattställning_1_N = mkN "nattställning" ; -- nattställning..nn.1
  nattstånden_1_A = mkA "nattstånden" ; -- nattstånden..av.1
  nattsudd_1_N = mkN "nattsudd" neutrum  ; -- nattsudd..nn.1
  nattsuddare_1_N = mkN "nattsuddare" utrum  ; -- nattsuddare..nn.1
  nattsvart_1_A = mkA "nattsvart" "nattsvart" ; -- nattsvart..av.1
  nattsvarthet_1_N = mkN "nattsvarthet" ; -- nattsvarthet..nn.1
  nattsyster_1_N = mkN "nattsyster" ; -- nattsyster..nn.1
  nattsäck_1_N = mkN "nattsäck" ; -- nattsäck..nn.1
  nattsömn_1_N = mkN "nattsömn" ; -- nattsömn..nn.1
  nattuggla_1_N = mkN "nattuggla" ; -- nattuggla..nn.1
  nattvak_1_N = mkN "nattvak" neutrum  ; -- nattvak..nn.1
  nattvakt_1_N = mkN "nattvakt" "nattvakter" ; -- nattvakt..nn.1
  nattvandrare_1_N = mkN "nattvandrare" utrum  ; -- nattvandrare..nn.1
  nattvard_1_N = mkN "nattvard" "nattvarder" ; -- nattvard..nn.1
  nattvardsbarn_1_N = mkN "nattvardsbarn" neutrum  ; -- nattvardsbarn..nn.1
  nattvardsberedelse_1_N = mkN "nattvardsberedelse" "nattvardsberedelser" ; -- nattvardsberedelse..nn.1
  nattvardsbesökare_1_N = mkN "nattvardsbesökare" utrum  ; -- nattvardsbesökare..nn.1
  nattvardsbord_1_N = mkN "nattvardsbord" neutrum  ; -- nattvardsbord..nn.1
  nattvardsbröd_1_N = mkN "nattvardsbröd" neutrum  ; -- nattvardsbröd..nn.1
  nattvardsgemenskap_1_N = mkN "nattvardsgemenskap" ; -- nattvardsgemenskap..nn.1
  nattvardsgudstjänst_1_N = mkN "nattvardsgudstjänst" "nattvardsgudstjänster" ; -- nattvardsgudstjänst..nn.1
  nattvardsgäst_1_N = mkN "nattvardsgäst" "nattvardsgäster" ; -- nattvardsgäst..nn.1
  nattvardsgång_1_N = mkN "nattvardsgång" ; -- nattvardsgång..nn.1
  nattvardskalk_1_N = mkN "nattvardskalk" ; -- nattvardskalk..nn.1
  nattvardskärl_1_N = mkN "nattvardskärl" neutrum  ; -- nattvardskärl..nn.1
  nattvardsundervisning_1_N = mkN "nattvardsundervisning" ; -- nattvardsundervisning..nn.1
  nattvardsvin_1_N = mkN "nattvardsvin" "nattvardsvinet" "nattvardsviner" "nattvardsvinerna" ; -- nattvardsvin..nn.1
  nattvila_1_N = mkN "nattvila" ; -- nattvila..nn.1
  nattviol_1_N = mkN "nattviol" "nattvioler" ; -- nattviol..nn.1
  nattväkt_1_N = mkN "nattväkt" "nattväkter" ; -- nattväkt..nn.1
  nattväktare_1_N = mkN "nattväktare" utrum  ; -- nattväktare..nn.1
  nattygsbord_1_N = mkN "nattygsbord" neutrum  ; -- nattygsbord..nn.1
  nattyxne_1_N = mkN "nattyxne" ; -- nattyxne..nn.1
  nattåg_1_N = mkN "nattåg" neutrum  ; -- nattåg..nn.1
  nattöppen_1_A = mkA "nattöppen" ; -- nattöppen..av.1
  natur_1_N = mkN "natur" ; -- natur..nn.1
  natur_2_N = mkN "natur" "naturer" ; -- natur..nn.2
  naturahushållning_1_N = mkN "naturahushållning" ; -- naturahushållning..nn.1
  naturalhistoria_1_N = mkN "naturalhistoria" ; -- naturalhistoria..nn.1
  naturaliekabinett_1_N = mkN "naturaliekabinett" neutrum  ; -- naturaliekabinett..nn.1
  naturalisation_1_N = mkN "naturalisation" ; -- naturalisation..nn.1
  naturalisera_1_V = mkV "naturaliserar" ; -- naturalisera..vb.1
  naturaliserande_1_N = mkN "naturaliserande" ; -- naturaliserande..nn.1
  naturaliserbar_1_A = mkA "naturaliserbar" ; -- naturaliserbar..av.1
  naturaliserbarhet_1_N = mkN "naturaliserbarhet" ; -- naturaliserbarhet..nn.1
  naturalisering_1_N = mkN "naturalisering" ; -- naturalisering..nn.1
  naturalism_1_N = mkN "naturalism" "naturalismer" ; -- naturalism..nn.1
  naturalist_1_N = mkN "naturalist" "naturalister" ; -- naturalist..nn.1
  naturalistisk_1_A = mkA "naturalistisk" ; -- naturalistisk..av.1
  naturaportion_1_N = mkN "naturaportion" ; -- naturaportion..nn.1
  naturbarn_1_N = mkN "naturbarn" neutrum  ; -- naturbarn..nn.1
  naturbegåvad_1_A = mkA "naturbegåvad" ; -- naturbegåvad..av.1
  naturbegåvning_1_N = mkN "naturbegåvning" ; -- naturbegåvning..nn.1
  naturbehandlad_1_A = mkA "naturbehandlad" ; -- naturbehandlad..av.1
  naturbehov_1_N = mkN "naturbehov" neutrum  ; -- naturbehov..nn.1
  naturbesjälning_1_N = mkN "naturbesjälning" ; -- naturbesjälning..nn.1
  naturbetingelse_1_N = mkN "naturbetingelse" "naturbetingelser" ; -- naturbetingelse..nn.1
  naturbunden_1_A = mkA "naturbunden" ; -- naturbunden..av.1
  naturdrift_1_N = mkN "naturdrift" "naturdrifter" ; -- naturdrift..nn.1
  naturell_1_A = mkA "naturell" ; -- naturell..av.1
  naturelltapet_1_N = mkN "naturelltapet" "naturelltapeter" ; -- naturelltapet..nn.1
  naturenlig_1_A = mkA "naturenlig" ; -- naturenlig..av.1
  naturenlighet_1_N = mkN "naturenlighet" ; -- naturenlighet..nn.1
  naturfenomen_1_N = mkN "naturfenomen" neutrum  ; -- naturfenomen..nn.1
  naturfiber_1_N = mkN "naturfiber" "naturfibern" "naturfibrer" "naturfibrerna" ; -- naturfiber..nn.1
  naturfilosof_1_N = mkN "naturfilosof" "naturfilosofer" ; -- naturfilosof..nn.1
  naturfilosofi_1_N = mkN "naturfilosofi" ; -- naturfilosofi..nn.1
  naturfilosofisk_1_A = mkA "naturfilosofisk" ; -- naturfilosofisk..av.1
  naturfolk_1_N = mkN "naturfolk" neutrum  ; -- naturfolk..nn.1
  naturformation_1_N = mkN "naturformation" ; -- naturformation..nn.1
  naturforskare_1_N = mkN "naturforskare" utrum  ; -- naturforskare..nn.1
  naturfärg_1_N = mkN "naturfärg" "naturfärger" ; -- naturfärg..nn.1
  naturfärgad_1_A = mkA "naturfärgad" ; -- naturfärgad..av.1
  naturföremål_1_N = mkN "naturföremål" neutrum  ; -- naturföremål..nn.1
  naturföreteelse_1_N = mkN "naturföreteelse" "naturföreteelser" ; -- naturföreteelse..nn.1
  naturgas_1_N = mkN "naturgas" "naturgaser" ; -- naturgas..nn.1
  naturgeografi_1_N = mkN "naturgeografi" ; -- naturgeografi..nn.1
  naturgiven_1_A = mkA "naturgiven" ; -- naturgiven..av.1
  naturgödsel_1_N = mkN "naturgödsel" ; -- naturgödsel..nn.1
  naturhamn_1_N = mkN "naturhamn" ; -- naturhamn..nn.1
  naturhinder_1_N = mkN "naturhinder" neutrum  ; -- naturhinder..nn.1
  naturhistoria_1_N = mkN "naturhistoria" ; -- naturhistoria..nn.1
  naturhistorisk_1_A = mkA "naturhistorisk" ; -- naturhistorisk..av.1
  naturhorn_1_N = mkN "naturhorn" neutrum  ; -- naturhorn..nn.1
  naturinstinkt_1_N = mkN "naturinstinkt" "naturinstinkter" ; -- naturinstinkt..nn.1
  naturis_1_N = mkN "naturis" ; -- naturis..nn.1
  naturism_1_N = mkN "naturism" "naturismer" ; -- naturism..nn.1
  naturist_1_N = mkN "naturist" "naturister" ; -- naturist..nn.1
  naturkatastrof_1_N = mkN "naturkatastrof" "naturkatastrofer" ; -- naturkatastrof..nn.1
  naturkonstant_1_N = mkN "naturkonstant" "naturkonstanter" ; -- naturkonstant..nn.1
  naturkosmetik_1_N = mkN "naturkosmetik" ; -- naturkosmetik..nn.1
  naturkraft_1_N = mkN "naturkraft" "naturkrafter" ; -- naturkraft..nn.1
  naturkunskap_1_N = mkN "naturkunskap" ; -- naturkunskap..nn.1
  naturkunskapsundervisning_1_N = mkN "naturkunskapsundervisning" ; -- naturkunskapsundervisning..nn.1
  naturlag_1_N = mkN "naturlag" ; -- naturlag..nn.1
  naturlig_1_A = mkA "naturlig" ; -- naturlig..av.1
  naturligen_1_Adv = mkAdv "naturligen" ; -- naturligen..ab.1
  naturlighet_1_N = mkN "naturlighet" ; -- naturlighet..nn.1
  naturligtvis_1_Adv = mkAdv "naturligtvis" ; -- naturligtvis..ab.1
  naturliv_1_N = mkN "naturliv" neutrum  ; -- naturliv..nn.1
  naturljud_1_N = mkN "naturljud" neutrum  ; -- naturljud..nn.1
  naturlyrik_1_N = mkN "naturlyrik" ; -- naturlyrik..nn.1
  naturlyrisk_1_A = mkA "naturlyrisk" ; -- naturlyrisk..av.1
  naturläkare_1_N = mkN "naturläkare" utrum  ; -- naturläkare..nn.1
  naturläkemedel_1_N = mkN "naturläkemedel" neutrum  ; -- naturläkemedel..nn.1
  naturläkemetod_1_N = mkN "naturläkemetod" "naturläkemetoder" ; -- naturläkemetod..nn.1
  naturlära_1_N = mkN "naturlära" ; -- naturlära..nn.1
  naturmagi_1_N = mkN "naturmagi" ; -- naturmagi..nn.1
  naturmakt_1_N = mkN "naturmakt" "naturmakter" ; -- naturmakt..nn.1
  naturmedicin_1_N = mkN "naturmedicin" "naturmediciner" ; -- naturmedicin..nn.1
  naturmetaforik_1_N = mkN "naturmetaforik" ; -- naturmetaforik..nn.1
  naturmetod_1_N = mkN "naturmetod" "naturmetoder" ; -- naturmetod..nn.1
  naturmiljö_1_N = mkN "naturmiljö" "naturmiljön" "naturmiljöer" "naturmiljöerna" ; -- naturmiljö..nn.1
  naturminne_1_N = mkN "naturminne" ; -- naturminne..nn.1
  naturminnesmärke_1_N = mkN "naturminnesmärke" ; -- naturminnesmärke..nn.1
  naturmystik_1_N = mkN "naturmystik" ; -- naturmystik..nn.1
  naturmänniska_1_N = mkN "naturmänniska" ; -- naturmänniska..nn.1
  naturmässig_1_A = mkA "naturmässig" ; -- naturmässig..av.1
  naturmålning_1_N = mkN "naturmålning" ; -- naturmålning..nn.1
  naturmålning_2_N = mkN "naturmålning" ; -- naturmålning..nn.2
  naturnamn_1_N = mkN "naturnamn" neutrum  ; -- naturnamn..nn.1
  naturnära_1_A = mkA "naturnära" ; -- naturnära..av.1
  naturnödvändig_1_A = mkA "naturnödvändig" ; -- naturnödvändig..av.1
  naturnödvändighet_1_N = mkN "naturnödvändighet" "naturnödvändigheter" ; -- naturnödvändighet..nn.1
  naturorienterande_1_A = mkA "naturorienterande" ; -- naturorienterande..av.1
  naturpark_1_N = mkN "naturpark" "naturparker" ; -- naturpark..nn.1
  naturpoesi_1_N = mkN "naturpoesi" ; -- naturpoesi..nn.1
  naturprodukt_1_N = mkN "naturprodukt" "naturprodukter" ; -- naturprodukt..nn.1
  naturreligion_1_N = mkN "naturreligion" ; -- naturreligion..nn.1
  naturreservat_1_N = mkN "naturreservat" neutrum  ; -- naturreservat..nn.1
  naturresurs_1_N = mkN "naturresurs" "naturresurser" ; -- naturresurs..nn.1
  naturrikedom_1_N = mkN "naturrikedom" ; -- naturrikedom..nn.1
  naturrätt_1_N = mkN "naturrätt" ; -- naturrätt..nn.1
  naturscen_1_N = mkN "naturscen" "naturscener" ; -- naturscen..nn.1
  natursceneri_1_N = mkN "natursceneri" "natursceneriet" "naturscenerier" "naturscenerierna" ; -- natursceneri..nn.1
  naturskildring_1_N = mkN "naturskildring" ; -- naturskildring..nn.1
  naturskog_1_N = mkN "naturskog" ; -- naturskog..nn.1
  naturskydd_1_N = mkN "naturskydd" neutrum  ; -- naturskydd..nn.1
  naturskyddad_1_A = mkA "naturskyddad" ; -- naturskyddad..av.1
  naturskön_1_A = mkA "naturskön" ; -- naturskön..av.1
  naturskönhet_1_N = mkN "naturskönhet" ; -- naturskönhet..nn.1
  natursten_1_N = mkN "natursten" "naturstenen" "naturstenar" "naturstenarna" ; -- natursten..nn.1
  naturstig_1_N = mkN "naturstig" ; -- naturstig..nn.1
  naturstridig_1_A = mkA "naturstridig" ; -- naturstridig..av.1
  naturstridighet_1_N = mkN "naturstridighet" ; -- naturstridighet..nn.1
  natursångare_1_N = mkN "natursångare" utrum  ; -- natursångare..nn.1
  naturtillgång_1_N = mkN "naturtillgång" ; -- naturtillgång..nn.1
  naturtillstånd_1_N = mkN "naturtillstånd" neutrum  ; -- naturtillstånd..nn.1
  naturtomt_1_N = mkN "naturtomt" "naturtomter" ; -- naturtomt..nn.1
  naturtrogen_1_A = mkA "naturtrogen" ; -- naturtrogen..av.1
  naturträ_1_N = mkN "naturträ" neutrum  ; -- naturträ..nn.1
  naturtyp_1_N = mkN "naturtyp" "naturtyper" ; -- naturtyp..nn.1
  naturvandra_1_V = mkV "naturvandrar" ; -- naturvandra..vb.1
  naturvetare_1_N = mkN "naturvetare" utrum  ; -- naturvetare..nn.1
  naturvetenskap_1_N = mkN "naturvetenskap" "naturvetenskaper" ; -- naturvetenskap..nn.1
  naturvetenskaplig_1_A = mkA "naturvetenskaplig" ; -- naturvetenskaplig..av.1
  naturvetenskaplighet_1_N = mkN "naturvetenskaplighet" ; -- naturvetenskaplighet..nn.1
  naturvetenskapsman_1_N = mkN "naturvetenskapsman" "naturvetenskapsmannen" "naturvetenskapsmän" "naturvetenskapsmännen" ; -- naturvetenskapsman..nn.1
  naturvidrig_1_A = mkA "naturvidrig" ; -- naturvidrig..av.1
  naturvidrighet_1_N = mkN "naturvidrighet" ; -- naturvidrighet..nn.1
  naturvän_1_N = mkN "naturvän" "naturvännen" "naturvänner" "naturvännerna" ; -- naturvän..nn.1
  naturvärde_1_N = mkN "naturvärde" ; -- naturvärde..nn.1
  naturväsen_1_N = mkN "naturväsen" "naturväsendet" "naturväsen" "naturväsena" ; -- naturväsen..nn.1
  naturvård_1_N = mkN "naturvård" ; -- naturvård..nn.1
  naturvårdare_1_N = mkN "naturvårdare" utrum  ; -- naturvårdare..nn.1
  naturvårdshandläggare_1_N = mkN "naturvårdshandläggare" utrum  ; -- naturvårdshandläggare..nn.1
  naturvårdsverk_1_N = mkN "naturvårdsverk" neutrum  ; -- naturvårdsverk..nn.1
  naurisk_1_A = mkA "naurisk" ; -- naurisk..av.1
  nauriska_1_N = mkN "nauriska" ; -- nauriska..nn.1
  nauruer_1_N = mkN "nauruer" "nauruern" "nauruer" "nauruerna" ; -- nauruer..nn.1
  nautik_1_N = mkN "nautik" ; -- nautik..nn.1
  nautiker_1_N = mkN "nautiker" "nautikern" "nautiker" "nautikerna" ; -- nautiker..nn.1
  nautisk_1_A = mkA "nautisk" ; -- nautisk..av.1
  nav_1_N = mkN "nav" neutrum  ; -- nav..nn.1
  navaho_1_N = mkN "navaho" "navahoen" "navahos" "navahoerna" ; -- navaho..nn.1
  navahoreservat_1_N = mkN "navahoreservat" neutrum  ; -- navahoreservat..nn.1
  navajo_1_N = mkN "navajo" "navajoen" "navajos" "navajoerna" ; -- navajo..nn.1
  navajoreservat_1_N = mkN "navajoreservat" neutrum  ; -- navajoreservat..nn.1
  navalmedicin_1_N = mkN "navalmedicin" ; -- navalmedicin..nn.1
  navalmedicinsk_1_A = mkA "navalmedicinsk" ; -- navalmedicinsk..av.1
  navarborr_1_N = mkN "navarborr" ; -- navarborr..nn.1
  navare_1_N = mkN "navare" utrum  ; -- navare..nn.1
  navel_1_N = mkN "navel" ; -- navel..nn.1
  navelband_1_N = mkN "navelband" neutrum  ; -- navelband..nn.1
  navelbinda_1_N = mkN "navelbinda" ; -- navelbinda..nn.1
  navelfläck_1_N = mkN "navelfläck" ; -- navelfläck..nn.1
  navelludd_1_N = mkN "navelludd" ; -- navelludd..nn.1
  navelskådande_1_A = mkA "navelskådande" ; -- navelskådande..av.1
  navelskådande_1_N = mkN "navelskådande" ; -- navelskådande..nn.1
  navelskådare_1_N = mkN "navelskådare" utrum  ; -- navelskådare..nn.1
  navelskådning_1_N = mkN "navelskådning" ; -- navelskådning..nn.1
  navelsträng_1_N = mkN "navelsträng" ; -- navelsträng..nn.1
  navelsvin_1_N = mkN "navelsvin" neutrum  ; -- navelsvin..nn.1
  naver_1_N = mkN "naver" ; -- naver..nn.1
  navigabel_1_A = mkA "navigabel" "navigabelt" ; -- navigabel..av.1
  navigation_1_N = mkN "navigation" ; -- navigation..nn.1
  navigationssatellit_1_N = mkN "navigationssatellit" "navigationssatelliter" ; -- navigationssatellit..nn.1
  navigationsvarning_1_N = mkN "navigationsvarning" ; -- navigationsvarning..nn.1
  navigatör_1_N = mkN "navigatör" "navigatörer" ; -- navigatör..nn.1
  navigera_1_V = mkV "navigerar" ; -- navigera..vb.1
  navigerande_1_N = mkN "navigerande" ; -- navigerande..nn.1
  navigerbar_1_A = mkA "navigerbar" ; -- navigerbar..av.1
  navigerbarhet_1_N = mkN "navigerbarhet" ; -- navigerbarhet..nn.1
  navigering_1_N = mkN "navigering" ; -- navigering..nn.1
  navigeringssystem_1_N = mkN "navigeringssystem" neutrum  ; -- navigeringssystem..nn.1
  navkapsel_1_N = mkN "navkapsel" ; -- navkapsel..nn.1
  navla_1_V = mkV "navlar" ; -- navla..vb.1
  navlande_1_N = mkN "navlande" ; -- navlande..nn.1
  naziarkitektur_1_N = mkN "naziarkitektur" "naziarkitekturer" ; -- naziarkitektur..nn.1
  nazibrott_1_N = mkN "nazibrott" neutrum  ; -- nazibrott..nn.1
  nazism_1_N = mkN "nazism" "nazismer" ; -- nazism..nn.1
  nazismitta_1_N = mkN "nazismitta" ; -- nazismitta..nn.1
  nazist_1_N = mkN "nazist" "nazister" ; -- nazist..nn.1
  nazistisk_1_A = mkA "nazistisk" ; -- nazistisk..av.1
  nazistofficer_1_N = mkN "nazistofficer" "nazistofficeren" "nazistofficerare" "nazistofficerarna" ; -- nazistofficer..nn.1
  nazistsympatisör_1_N = mkN "nazistsympatisör" "nazistsympatisörer" ; -- nazistsympatisör..nn.1
  nazitysk_1_A = mkA "nazitysk" ; -- nazitysk..av.1
  neandertalare_1_N = mkN "neandertalare" utrum  ; -- neandertalare..nn.1
  neandertalmänniska_1_N = mkN "neandertalmänniska" ; -- neandertalmänniska..nn.1
  neapolitan_1_N = mkN "neapolitan" "neapolitaner" ; -- neapolitan..nn.1
  neapolitansk_1_A = mkA "neapolitansk" ; -- neapolitansk..av.1
  nebulosa_1_N = mkN "nebulosa" ; -- nebulosa..nn.1
  nebulosalinje_1_N = mkN "nebulosalinje" "nebulosalinjer" ; -- nebulosalinje..nn.1
  nebulös_1_A = mkA "nebulös" ; -- nebulös..av.1
  necessär_1_N = mkN "necessär" "necessärer" ; -- necessär..nn.1
  nedan_1_N = mkN "nedan" ; -- nedan..nn.1
  nedanstående_1_A = mkA "nedanstående" ; -- nedanstående..av.1
  nedarbeta_1_V = mkV "nedarbetar" ; -- nedarbeta..vb.1
  nedarbetande_1_N = mkN "nedarbetande" ; -- nedarbetande..nn.1
  nedbantad_1_A = mkA "nedbantad" ; -- nedbantad..av.1
  nedblodad_1_A = mkA "nedblodad" ; -- nedblodad..av.1
  nedblodning_1_N = mkN "nedblodning" ; -- nedblodning..nn.1
  nedbläckning_1_N = mkN "nedbläckning" ; -- nedbläckning..nn.1
  nedblåsa_1_V = mkV "nedblåser" ; -- nedblåsa..vb.1
  nedblåsande_1_N = mkN "nedblåsande" ; -- nedblåsande..nn.1
  nedborrad_1_A = mkA "nedborrad" ; -- nedborrad..av.1
  nedbringa_1_V = mkV "nedbringar" ; -- nedbringa..vb.1
  nedbringande_1_N = mkN "nedbringande" ; -- nedbringande..nn.1
  nedbruten_1_A = mkA "nedbruten" ; -- nedbruten..av.1
  nedbryta_1_V = mkV "nedbryta" "nedbröt" "nedbrutit" ; -- nedbryta..vb.1
  nedbrytande_1_N = mkN "nedbrytande" ; -- nedbrytande..nn.1
  nedbrytbar_1_A = mkA "nedbrytbar" ; -- nedbrytbar..av.1
  nedbrytbarhet_1_N = mkN "nedbrytbarhet" ; -- nedbrytbarhet..nn.1
  nedbrytning_1_N = mkN "nedbrytning" ; -- nedbrytning..nn.1
  nedbrytningsstation_1_N = mkN "nedbrytningsstation" ; -- nedbrytningsstation..nn.1
  nedbränning_1_N = mkN "nedbränning" ; -- nedbränning..nn.1
  nedbusad_1_A = mkA "nedbusad" ; -- nedbusad..av.1
  nedbusning_1_N = mkN "nedbusning" ; -- nedbusning..nn.1
  nedbäddad_1_A = mkA "nedbäddad" ; -- nedbäddad..av.1
  nedbäddning_1_N = mkN "nedbäddning" ; -- nedbäddning..nn.1
  nedbärning_1_N = mkN "nedbärning" ; -- nedbärning..nn.1
  nedböjning_1_N = mkN "nedböjning" ; -- nedböjning..nn.1
  neddekad_1_A = mkA "neddekad" ; -- neddekad..av.1
  neddoppning_1_N = mkN "neddoppning" ; -- neddoppning..nn.1
  neddragen_1_A = mkA "neddragen" ; -- neddragen..av.1
  neddragning_1_N = mkN "neddragning" ; -- neddragning..nn.1
  neddrivning_1_N = mkN "neddrivning" ; -- neddrivning..nn.1
  nederbörd_1_N = mkN "nederbörd" ; -- nederbörd..nn.1
  nederbördsmängd_1_N = mkN "nederbördsmängd" "nederbördsmängder" ; -- nederbördsmängd..nn.1
  nederbördsområde_1_N = mkN "nederbördsområde" ; -- nederbördsområde..nn.1
  nederdel_1_N = mkN "nederdel" "nederdelen" "nederdelar" "nederdelarna" ; -- nederdel..nn.1
  nederkant_1_N = mkN "nederkant" "nederkanter" ; -- nederkant..nn.1
  nederlag_1_N = mkN "nederlag" neutrum  ; -- nederlag..nn.1
  nederlagsstämning_1_N = mkN "nederlagsstämning" ; -- nederlagsstämning..nn.1
  nederlagstyngd_1_A = mkA "nederlagstyngd" "nederlagstyngt" ; -- nederlagstyngd..av.1
  nederländare_1_N = mkN "nederländare" utrum  ; -- nederländare..nn.1
  nederländsk_1_A = mkA "nederländsk" ; -- nederländsk..av.1
  nederländska_1_N = mkN "nederländska" ; -- nederländska..nn.1
  nederländska_2_N = mkN "nederländska" ; -- nederländska..nn.2
  nederst_1_Adv = mkAdv "nederst" ; -- nederst..ab.1
  nedervåning_1_N = mkN "nedervåning" ; -- nedervåning..nn.1
  nedfall_1_N = mkN "nedfall" neutrum  ; -- nedfall..nn.1
  nedfallande_1_A = mkA "nedfallande" ; -- nedfallande..av.1
  nedfallen_1_A = mkA "nedfallen" ; -- nedfallen..av.1
  nedfart_1_N = mkN "nedfart" "nedfarter" ; -- nedfart..nn.1
  nedfartsschakt_1_N = mkN "nedfartsschakt" neutrum  ; -- nedfartsschakt..nn.1
  nedfirning_1_N = mkN "nedfirning" ; -- nedfirning..nn.1
  nedflyttning_1_N = mkN "nedflyttning" ; -- nedflyttning..nn.1
  nedfläckning_1_N = mkN "nedfläckning" ; -- nedfläckning..nn.1
  nedforsling_1_N = mkN "nedforsling" ; -- nedforsling..nn.1
  nedfrysande_1_N = mkN "nedfrysande" ; -- nedfrysande..nn.1
  nedfrysning_1_N = mkN "nedfrysning" ; -- nedfrysning..nn.1
  nedfälld_1_A = mkA "nedfälld" "nedfällt" ; -- nedfälld..av.1
  nedfällning_1_N = mkN "nedfällning" ; -- nedfällning..nn.1
  nedfärd_1_N = mkN "nedfärd" "nedfärder" ; -- nedfärd..nn.1
  nedföring_1_N = mkN "nedföring" ; -- nedföring..nn.1
  nedförsbacke_1_N = mkN "nedförsbacke" utrum  ; -- nedförsbacke..nn.1
  nedfösning_1_N = mkN "nedfösning" ; -- nedfösning..nn.1
  nedglidning_1_N = mkN "nedglidning" ; -- nedglidning..nn.1
  nedgrisad_1_A = mkA "nedgrisad" ; -- nedgrisad..av.1
  nedgräva_1_V = mkV "nedgräver" ; -- nedgräva..vb.1
  nedgrävande_1_N = mkN "nedgrävande" ; -- nedgrävande..nn.1
  nedgrävning_1_N = mkN "nedgrävning" ; -- nedgrävning..nn.1
  nedgående_1_N = mkN "nedgående" ; -- nedgående..nn.1
  nedgång_1_N = mkN "nedgång" ; -- nedgång..nn.1
  nedgången_1_A = mkA "nedgången" ; -- nedgången..av.1
  nedgöra_1_V = mkV "nedgöra" "nedgjorde" "nedgjort" ; -- nedgöra..vb.1
  nedgörande_1_N = mkN "nedgörande" ; -- nedgörande..nn.1
  nedhalare_1_N = mkN "nedhalare" utrum  ; -- nedhalare..nn.1
  nedhalning_1_N = mkN "nedhalning" ; -- nedhalning..nn.1
  nedhasning_1_N = mkN "nedhasning" ; -- nedhasning..nn.1
  nedhuggning_1_N = mkN "nedhuggning" ; -- nedhuggning..nn.1
  nedhukad_1_A = mkA "nedhukad" ; -- nedhukad..av.1
  nedhängande_1_A = mkA "nedhängande" ; -- nedhängande..av.1
  nedhåring_1_N = mkN "nedhåring" ; -- nedhåring..nn.1
  nedhårning_1_N = mkN "nedhårning" ; -- nedhårning..nn.1
  nedifrån_1_Adv = mkAdv "nedifrån" ; -- nedifrån..ab.1
  nedisa_1_V = mkV "nedisar" ; -- nedisa..vb.1
  nedisande_1_N = mkN "nedisande" ; -- nedisande..nn.1
  nedjustera_1_V = mkV "nedjusterar" ; -- nedjustera..vb.1
  nedjusterande_1_N = mkN "nedjusterande" ; -- nedjusterande..nn.1
  nedjustering_1_N = mkN "nedjustering" ; -- nedjustering..nn.1
  nedkalla_1_V = mkV "nedkallar" ; -- nedkalla..vb.1
  nedkallande_1_N = mkN "nedkallande" ; -- nedkallande..nn.1
  nedkasta_1_V = mkV "nedkastar" ; -- nedkasta..vb.1
  nedkastande_1_N = mkN "nedkastande" ; -- nedkastande..nn.1
  nedkastning_1_N = mkN "nedkastning" ; -- nedkastning..nn.1
  nedkavla_1_V = mkV "nedkavlar" ; -- nedkavla..vb.1
  nedkavlande_1_N = mkN "nedkavlande" ; -- nedkavlande..nn.1
  nedkippad_1_A = mkA "nedkippad" ; -- nedkippad..av.1
  nedklassa_1_V = mkV "nedklassar" ; -- nedklassa..vb.1
  nedklassande_1_N = mkN "nedklassande" ; -- nedklassande..nn.1
  nedkletad_1_A = mkA "nedkletad" ; -- nedkletad..av.1
  nedklottring_1_N = mkN "nedklottring" ; -- nedklottring..nn.1
  nedklättring_1_N = mkN "nedklättring" ; -- nedklättring..nn.1
  nedknarkad_1_A = mkA "nedknarkad" ; -- nedknarkad..av.1
  nedkomma_1_V = mkV "nedkomma" "nedkom" "nedkommit" ; -- nedkomma..vb.1
  nedkommande_1_N = mkN "nedkommande" ; -- nedkommande..nn.1
  nedkomst_1_N = mkN "nedkomst" ; -- nedkomst..nn.1
  nedkrypning_1_N = mkN "nedkrypning" ; -- nedkrypning..nn.1
  nedkörning_1_N = mkN "nedkörning" ; -- nedkörning..nn.1
  nedladdning_1_N = mkN "nedladdning" ; -- nedladdning..nn.1
  nedlegad_1_A = mkA "nedlegad" ; -- nedlegad..av.1
  nedlusad_1_A = mkA "nedlusad" ; -- nedlusad..av.1
  nedlyftning_1_N = mkN "nedlyftning" ; -- nedlyftning..nn.1
  nedlägga_1_V = mkV "nedlägga" "nedla" "nedlagt" ; -- nedlägga..vb.1
  nedläggande_1_N = mkN "nedläggande" ; -- nedläggande..nn.1
  nedläggelse_1_N = mkN "nedläggelse" "nedläggelser" ; -- nedläggelse..nn.1
  nedläggning_1_N = mkN "nedläggning" ; -- nedläggning..nn.1
  nedläggningshot_1_N = mkN "nedläggningshot" neutrum  ; -- nedläggningshot..nn.1
  nedläggningshotad_1_A = mkA "nedläggningshotad" ; -- nedläggningshotad..av.1
  nedlåtande_1_A = mkA "nedlåtande" ; -- nedlåtande..av.1
  nedlåten_1_A = mkA "nedlåten" ; -- nedlåten..av.1
  nedlåtenhet_1_N = mkN "nedlåtenhet" "nedlåtenheter" ; -- nedlåtenhet..nn.1
  nedmejning_1_N = mkN "nedmejning" ; -- nedmejning..nn.1
  nedmjölning_1_N = mkN "nedmjölning" ; -- nedmjölning..nn.1
  nedmontera_1_V = mkV "nedmonterar" ; -- nedmontera..vb.1
  nedmonterande_1_N = mkN "nedmonterande" ; -- nedmonterande..nn.1
  nedmonterbar_1_A = mkA "nedmonterbar" ; -- nedmonterbar..av.1
  nedmonterbarhet_1_N = mkN "nedmonterbarhet" ; -- nedmonterbarhet..nn.1
  nedmontering_1_N = mkN "nedmontering" ; -- nedmontering..nn.1
  nedmörk_1_A = mkA "nedmörk" ; -- nedmörk..av.1
  nedpackning_1_N = mkN "nedpackning" ; -- nedpackning..nn.1
  nedplockning_1_N = mkN "nedplockning" ; -- nedplockning..nn.1
  nedplöjning_1_N = mkN "nedplöjning" ; -- nedplöjning..nn.1
  nedpressning_1_N = mkN "nedpressning" ; -- nedpressning..nn.1
  nedprutning_1_N = mkN "nedprutning" ; -- nedprutning..nn.1
  nedra_1_A = mkA "nedra" ; -- nedra..av.1
  nedrans_1_A = mkA "nedrans" ; -- nedrans..av.1
  nedresa_1_N = mkN "nedresa" ; -- nedresa..nn.1
  nedrest_1_A = mkA "nedrest" "nedrest" ; -- nedrest..av.1
  nedrig_1_A = mkA "nedrig" ; -- nedrig..av.1
  nedrighet_1_N = mkN "nedrighet" "nedrigheter" ; -- nedrighet..nn.1
  nedringd_1_A = mkA "nedringd" "nedringt" ; -- nedringd..av.1
  nedrivning_1_N = mkN "nedrivning" ; -- nedrivning..nn.1
  nedrullning_1_N = mkN "nedrullning" ; -- nedrullning..nn.1
  nedrusning_1_N = mkN "nedrusning" ; -- nedrusning..nn.1
  nedrusta_1_V = mkV "nedrustar" ; -- nedrusta..vb.1
  nedrustande_1_N = mkN "nedrustande" ; -- nedrustande..nn.1
  nedrustning_1_N = mkN "nedrustning" ; -- nedrustning..nn.1
  nedräkning_1_N = mkN "nedräkning" ; -- nedräkning..nn.1
  nedrökt_1_A = mkA "nedrökt" "nedrökt" ; -- nedrökt..av.1
  nedsabling_1_N = mkN "nedsabling" ; -- nedsabling..nn.1
  nedsabling_2_N = mkN "nedsabling" ; -- nedsabling..nn.2
  nedsalta_1_V = mkV "nedsaltar" ; -- nedsalta..vb.1
  nedsaltande_1_N = mkN "nedsaltande" ; -- nedsaltande..nn.1
  nedsaltning_1_N = mkN "nedsaltning" ; -- nedsaltning..nn.1
  nedsatt_1_A = mkA "nedsatt" ; -- nedsatt..av.1
  nedskakning_1_N = mkN "nedskakning" ; -- nedskakning..nn.1
  nedskitad_1_A = mkA "nedskitad" ; -- nedskitad..av.1
  nedskiten_1_A = mkA "nedskiten" ; -- nedskiten..av.1
  nedskjutning_1_N = mkN "nedskjutning" ; -- nedskjutning..nn.1
  nedskrapning_1_N = mkN "nedskrapning" ; -- nedskrapning..nn.1
  nedskriva_1_V = mkV "nedskriva" "nedskrev" "nedskrivit" ; -- nedskriva..vb.1
  nedskrivande_1_N = mkN "nedskrivande" ; -- nedskrivande..nn.1
  nedskrivning_1_N = mkN "nedskrivning" ; -- nedskrivning..nn.1
  nedskruvning_1_N = mkN "nedskruvning" ; -- nedskruvning..nn.1
  nedskrynkling_1_N = mkN "nedskrynkling" ; -- nedskrynkling..nn.1
  nedskräpning_1_N = mkN "nedskräpning" ; -- nedskräpning..nn.1
  nedskuffning_1_N = mkN "nedskuffning" ; -- nedskuffning..nn.1
  nedskälld_1_A = mkA "nedskälld" "nedskällt" ; -- nedskälld..av.1
  nedskärning_1_N = mkN "nedskärning" ; -- nedskärning..nn.1
  nedskärningskonsulent_1_N = mkN "nedskärningskonsulent" "nedskärningskonsulenter" ; -- nedskärningskonsulent..nn.1
  nedskärningspolitik_1_N = mkN "nedskärningspolitik" ; -- nedskärningspolitik..nn.1
  nedsköljning_1_N = mkN "nedsköljning" ; -- nedsköljning..nn.1
  nedslag_1_N = mkN "nedslag" neutrum  ; -- nedslag..nn.1
  nedslagen_1_A = mkA "nedslagen" ; -- nedslagen..av.1
  nedslagenhet_1_N = mkN "nedslagenhet" ; -- nedslagenhet..nn.1
  nedslagskraft_1_N = mkN "nedslagskraft" ; -- nedslagskraft..nn.1
  nedslagskrater_1_N = mkN "nedslagskrater" ; -- nedslagskrater..nn.1
  nedslagsplats_1_N = mkN "nedslagsplats" "nedslagsplatser" ; -- nedslagsplats..nn.1
  nedslagsteori_1_N = mkN "nedslagsteori" "nedslagsteorier" ; -- nedslagsteori..nn.1
  nedslaktning_1_N = mkN "nedslaktning" ; -- nedslaktning..nn.1
  nedsliten_1_A = mkA "nedsliten" ; -- nedsliten..av.1
  nedsläckning_1_N = mkN "nedsläckning" ; -- nedsläckning..nn.1
  nedsläpp_1_N = mkN "nedsläpp" neutrum  ; -- nedsläpp..nn.1
  nedsläppning_1_N = mkN "nedsläppning" ; -- nedsläppning..nn.1
  nedslå_1_V = mkV "nedslå" "nedslog" "nedslagit" ; -- nedslå..vb.1
  nedslående_1_A = mkA "nedslående" ; -- nedslående..av.1
  nedslående_1_N = mkN "nedslående" ; -- nedslående..nn.1
  nedsmetning_1_N = mkN "nedsmetning" ; -- nedsmetning..nn.1
  nedsmittning_1_N = mkN "nedsmittning" ; -- nedsmittning..nn.1
  nedsmord_1_A = mkA "nedsmord" "nedsmort" ; -- nedsmord..av.1
  nedsmutsare_1_N = mkN "nedsmutsare" utrum  ; -- nedsmutsare..nn.1
  nedsmutsning_1_N = mkN "nedsmutsning" ; -- nedsmutsning..nn.1
  nedsmältning_1_N = mkN "nedsmältning" ; -- nedsmältning..nn.1
  nedsmörjning_1_N = mkN "nedsmörjning" ; -- nedsmörjning..nn.1
  nedsnöad_1_A = mkA "nedsnöad" ; -- nedsnöad..av.1
  nedsolkad_1_A = mkA "nedsolkad" ; -- nedsolkad..av.1
  nedsopning_1_N = mkN "nedsopning" ; -- nedsopning..nn.1
  nedsotning_1_N = mkN "nedsotning" ; -- nedsotning..nn.1
  nedspilld_1_A = mkA "nedspilld" "nedspillt" ; -- nedspilld..av.1
  nedstiga_1_V = mkV "nedstiga" "nedsteg" "nedstigit" ; -- nedstiga..vb.1
  nedstigande_1_N = mkN "nedstigande" ; -- nedstigande..nn.1
  nedstigning_1_N = mkN "nedstigning" ; -- nedstigning..nn.1
  nedstrykning_1_N = mkN "nedstrykning" ; -- nedstrykning..nn.1
  nedstråk_1_N = mkN "nedstråk" neutrum  ; -- nedstråk..nn.1
  nedstämd_1_A = mkA "nedstämd" "nedstämt" ; -- nedstämd..av.1
  nedstämdhet_1_N = mkN "nedstämdhet" ; -- nedstämdhet..nn.1
  nedstämmande_1_A = mkA "nedstämmande" ; -- nedstämmande..av.1
  nedstämning_1_N = mkN "nedstämning" ; -- nedstämning..nn.1
  nedstänkning_1_N = mkN "nedstänkning" ; -- nedstänkning..nn.1
  nedstörtning_1_N = mkN "nedstörtning" ; -- nedstörtning..nn.1
  nedstötning_1_N = mkN "nedstötning" ; -- nedstötning..nn.1
  nedsupen_1_A = mkA "nedsupen" ; -- nedsupen..av.1
  nedsutten_1_A = mkA "nedsutten" ; -- nedsutten..av.1
  nedsvärtning_1_N = mkN "nedsvärtning" ; -- nedsvärtning..nn.1
  nedsänka_1_V = mkV "nedsänker" ; -- nedsänka..vb.1
  nedsänkande_1_N = mkN "nedsänkande" ; -- nedsänkande..nn.1
  nedsänkning_1_N = mkN "nedsänkning" ; -- nedsänkning..nn.1
  nedsätta_1_V = mkV "nedsätta" "nedsätter" "nedsätt" "nedsatte" "nedsatt" "nedsatt" ; -- nedsätta..vb.1
  nedsättande_1_A = mkA "nedsättande" ; -- nedsättande..av.1
  nedsättande_1_N = mkN "nedsättande" ; -- nedsättande..nn.1
  nedsättning_1_N = mkN "nedsättning" ; -- nedsättning..nn.1
  nedsättningsbevis_1_N = mkN "nedsättningsbevis" neutrum  ; -- nedsättningsbevis..nn.1
  nedsölad_1_A = mkA "nedsölad" ; -- nedsölad..av.1
  nedsölning_1_N = mkN "nedsölning" ; -- nedsölning..nn.1
  nedtagning_1_N = mkN "nedtagning" ; -- nedtagning..nn.1
  nedteckna_1_V = mkV "nedtecknar" ; -- nedteckna..vb.1
  nedtecknande_1_N = mkN "nedtecknande" ; -- nedtecknande..nn.1
  nedtill_1_Adv = mkAdv "nedtill" ; -- nedtill..ab.1
  nedtjärning_1_N = mkN "nedtjärning" ; -- nedtjärning..nn.1
  nedtoning_1_N = mkN "nedtoning" ; -- nedtoning..nn.1
  nedtrampad_1_A = mkA "nedtrampad" ; -- nedtrampad..av.1
  nedtrampning_1_N = mkN "nedtrampning" ; -- nedtrampning..nn.1
  nedtransformera_1_V = mkV "nedtransformerar" ; -- nedtransformera..vb.1
  nedtransformerande_1_N = mkN "nedtransformerande" ; -- nedtransformerande..nn.1
  nedtransformerbar_1_A = mkA "nedtransformerbar" ; -- nedtransformerbar..av.1
  nedtransformerbarhet_1_N = mkN "nedtransformerbarhet" ; -- nedtransformerbarhet..nn.1
  nedtransformering_1_N = mkN "nedtransformering" ; -- nedtransformering..nn.1
  nedtransponera_1_V = mkV "nedtransponerar" ; -- nedtransponera..vb.1
  nedtransponerande_1_N = mkN "nedtransponerande" ; -- nedtransponerande..nn.1
  nedtransponerbar_1_A = mkA "nedtransponerbar" ; -- nedtransponerbar..av.1
  nedtransponerbarhet_1_N = mkN "nedtransponerbarhet" ; -- nedtransponerbarhet..nn.1
  nedtransponering_1_N = mkN "nedtransponering" ; -- nedtransponering..nn.1
  nedtrappa_1_V = mkV "nedtrappar" ; -- nedtrappa..vb.1
  nedtrappande_1_N = mkN "nedtrappande" ; -- nedtrappande..nn.1
  nedtrappning_1_N = mkN "nedtrappning" ; -- nedtrappning..nn.1
  nedtryckning_1_N = mkN "nedtryckning" ; -- nedtryckning..nn.1
  nedtryckt_1_A = mkA "nedtryckt" "nedtryckt" ; -- nedtryckt..av.1
  nedtryckthet_1_N = mkN "nedtryckthet" ; -- nedtryckthet..nn.1
  nedträngning_1_N = mkN "nedträngning" ; -- nedträngning..nn.1
  nedtvingad_1_A = mkA "nedtvingad" ; -- nedtvingad..av.1
  nedtynga_1_V = mkV "nedtynger" ; -- nedtynga..vb.1
  nedtyngande_1_N = mkN "nedtyngande" ; -- nedtyngande..nn.1
  nedtyngning_1_N = mkN "nedtyngning" ; -- nedtyngning..nn.1
  nedtysta_1_V = mkV "nedtystar" ; -- nedtysta..vb.1
  nedtystande_1_N = mkN "nedtystande" ; -- nedtystande..nn.1
  nedtystning_1_N = mkN "nedtystning" ; -- nedtystning..nn.1
  nedvikning_1_N = mkN "nedvikning" ; -- nedvikning..nn.1
  nedvissning_1_N = mkN "nedvissning" ; -- nedvissning..nn.1
  nedvräkning_1_N = mkN "nedvräkning" ; -- nedvräkning..nn.1
  nedväg_1_N = mkN "nedväg" ; -- nedväg..nn.1
  nedvältning_1_N = mkN "nedvältning" ; -- nedvältning..nn.1
  nedvältring_1_N = mkN "nedvältring" ; -- nedvältring..nn.1
  nedvärdera_1_V = mkV "nedvärderar" ; -- nedvärdera..vb.1
  nedvärderande_1_N = mkN "nedvärderande" ; -- nedvärderande..nn.1
  nedvärderbar_1_A = mkA "nedvärderbar" ; -- nedvärderbar..av.1
  nedvärderbarhet_1_N = mkN "nedvärderbarhet" ; -- nedvärderbarhet..nn.1
  nedvärdering_1_N = mkN "nedvärdering" ; -- nedvärdering..nn.1
  nedärvd_1_A = mkA "nedärvd" "nedärvt" ; -- nedärvd..av.1
  nedåtböjd_1_A = mkA "nedåtböjd" "nedåtböjt" ; -- nedåtböjd..av.1
  nedåtgående_1_A = mkA "nedåtgående" ; -- nedåtgående..av.1
  nedåtgående_1_N = mkN "nedåtgående" ; -- nedåtgående..nn.1
  nedåtgång_1_N = mkN "nedåtgång" ; -- nedåtgång..nn.1
  nedåtlutande_1_A = mkA "nedåtlutande" ; -- nedåtlutande..av.1
  nefrit_1_N = mkN "nefrit" "nefriter" ; -- nefrit..nn.1
  nefritisk_1_A = mkA "nefritisk" ; -- nefritisk..av.1
  negation_1_N = mkN "negation" ; -- negation..nn.1
  negationsmonotoni_1_N = mkN "negationsmonotoni" ; -- negationsmonotoni..nn.1
  negativ_1_A = mkA "negativ" ; -- negativ..av.1
  negativ_1_N = mkN "negativ" neutrum  ; -- negativ..nn.1
  negativbild_1_N = mkN "negativbild" "negativbilder" ; -- negativbild..nn.1
  negativism_1_N = mkN "negativism" "negativismer" ; -- negativism..nn.1
  negativistisk_1_A = mkA "negativistisk" ; -- negativistisk..av.1
  negativitet_1_N = mkN "negativitet" "negativiteter" ; -- negativitet..nn.1
  negativitet_2_N = mkN "negativitet" ; -- negativitet..nn.2
  neger_1_N = mkN "neger" "negern" "negrer" "negrerna" ; -- neger..nn.1
  negera_1_V = mkV "negerar" ; -- negera..vb.1
  negerande_1_N = mkN "negerande" ; -- negerande..nn.1
  negerbar_1_A = mkA "negerbar" ; -- negerbar..av.1
  negerbarhet_1_N = mkN "negerbarhet" ; -- negerbarhet..nn.1
  negerblod_1_N = mkN "negerblod" neutrum  ; -- negerblod..nn.1
  negerboll_1_N = mkN "negerboll" ; -- negerboll..nn.1
  negering_1_N = mkN "negering" ; -- negering..nn.1
  negerkorn_1_N = mkN "negerkorn" neutrum  ; -- negerkorn..nn.1
  neggo_1_N = mkN "neggo" "neggot" "neggon" "neggona" ; -- neggo..nn.1
  negligeabel_1_A = mkA "negligeabel" ; -- negligeabel..av.1
  negligera_1_V = mkV "negligerar" ; -- negligera..vb.1
  negligerande_1_N = mkN "negligerande" ; -- negligerande..nn.1
  negligerbar_1_A = mkA "negligerbar" ; -- negligerbar..av.1
  negligerbarhet_1_N = mkN "negligerbarhet" ; -- negligerbarhet..nn.1
  negligering_1_N = mkN "negligering" ; -- negligering..nn.1
  negligibel_1_A = mkA "negligibel" ; -- negligibel..av.1
  negligé_1_N = mkN "negligé" "negligéer" ; -- negligé..nn.1
  negociera_1_V = mkV "negocierar" ; -- negociera..vb.1
  negocierande_1_N = mkN "negocierande" ; -- negocierande..nn.1
  negocierbar_1_A = mkA "negocierbar" ; -- negocierbar..av.1
  negocierbarhet_1_N = mkN "negocierbarhet" ; -- negocierbarhet..nn.1
  negociering_1_N = mkN "negociering" ; -- negociering..nn.1
  negotiera_1_V = mkV "negotierar" ; -- negotiera..vb.1
  negotierande_1_N = mkN "negotierande" ; -- negotierande..nn.1
  negotierbar_1_A = mkA "negotierbar" ; -- negotierbar..av.1
  negotierbarhet_1_N = mkN "negotierbarhet" ; -- negotierbarhet..nn.1
  negotiering_1_N = mkN "negotiering" ; -- negotiering..nn.1
  negress_1_N = mkN "negress" "negresser" ; -- negress..nn.1
  negroid_1_N = mkN "negroid" "negroider" ; -- negroid..nn.1
  nej_1_N = mkN "nej" neutrum  ; -- nej..nn.1
  nejd_1_N = mkN "nejd" "nejder" ; -- nejd..nn.1
  nejlika_1_N = mkN "nejlika" ; -- nejlika..nn.1
  nejlikolja_1_N = mkN "nejlikolja" ; -- nejlikolja..nn.1
  nejlikrot_1_N = mkN "nejlikrot" "nejlikrötter" ; -- nejlikrot..nn.1
  nejlikväxt_1_N = mkN "nejlikväxt" "nejlikväxter" ; -- nejlikväxt..nn.1
  nejonöga_1_N = mkN "nejonöga" "nejonögat" "nejonögon" "nejonögonen" ; -- nejonöga..nn.1
  nejröst_1_N = mkN "nejröst" "nejröster" ; -- nejröst..nn.1
  nejsägare_1_N = mkN "nejsägare" utrum  ; -- nejsägare..nn.1
  nek_1_N = mkN "nek" ; -- nek..nn.1
  neka_1_V = mkV "nekar" ; -- neka..vb.1
  nekande_1_N = mkN "nekande" ; -- nekande..nn.1
  nekning_1_N = mkN "nekning" ; -- nekning..nn.1
  nekningsord_1_N = mkN "nekningsord" neutrum  ; -- nekningsord..nn.1
  nekrofil_1_A = mkA "nekrofil" ; -- nekrofil..av.1
  nekrofil_1_N = mkN "nekrofil" "nekrofiler" ; -- nekrofil..nn.1
  nekrofili_1_N = mkN "nekrofili" ; -- nekrofili..nn.1
  nekrolog_1_N = mkN "nekrolog" "nekrologer" ; -- nekrolog..nn.1
  nekros_1_N = mkN "nekros" ; -- nekros..nn.1
  nektardrag_1_N = mkN "nektardrag" neutrum  ; -- nektardrag..nn.1
  nektarin_1_N = mkN "nektarin" "nektariner" ; -- nektarin..nn.1
  nektarium_1_N = mkN "nektarium" "nektariet" "nektarier" "nektarierna" ; -- nektarium..nn.1
  nelson_1_N = mkN "nelson" ; -- nelson..nn.1
  nematod_1_N = mkN "nematod" "nematoder" ; -- nematod..nn.1
  nemesis_1_N = mkN "nemesis" ; -- nemesis..nn.1
  nemesistanke_1_N = mkN "nemesistanke" utrum  ; -- nemesistanke..nn.1
  nen_1_N = mkN "nen" ; -- nen..nn.1
  neoarkeikum_1_N = mkN "neoarkeikum" ; -- neoarkeikum..nn.1
  neodym_1_N = mkN "neodym" ; -- neodym..nn.1
  neodym_2_N = mkN "neodym" "neodymer" ; -- neodym..nn.2
  neodymmagnet_1_N = mkN "neodymmagnet" "neodymmagneter" ; -- neodymmagnet..nn.1
  neofili_1_N = mkN "neofili" ; -- neofili..nn.1
  neogen_1_N = mkN "neogen" ; -- neogen..nn.1
  neoimpressionism_1_N = mkN "neoimpressionism" "neoimpressionismer" ; -- neoimpressionism..nn.1
  neoimpressionistisk_1_A = mkA "neoimpressionistisk" ; -- neoimpressionistisk..av.1
  neoklassicism_1_N = mkN "neoklassicism" "neoklassicismer" ; -- neoklassicism..nn.1
  neoklassicistisk_1_A = mkA "neoklassicistisk" ; -- neoklassicistisk..av.1
  neoklassisk_1_A = mkA "neoklassisk" ; -- neoklassisk..av.1
  neokolonialism_1_N = mkN "neokolonialism" "neokolonialismer" ; -- neokolonialism..nn.1
  neokolonialistisk_1_A = mkA "neokolonialistisk" ; -- neokolonialistisk..av.1
  neolitisk_1_A = mkA "neolitisk" ; -- neolitisk..av.1
  neolitium_1_N = mkN "neolitium" ; -- neolitium..nn.1
  neolog_1_N = mkN "neolog" "neologer" ; -- neolog..nn.1
  neologi_1_N = mkN "neologi" ; -- neologi..nn.1
  neologism_1_N = mkN "neologism" "neologismer" ; -- neologism..nn.1
  neon_1_N = mkN "neon" neutrum  ; -- neon..nn.1
  neonfärgad_1_A = mkA "neonfärgad" ; -- neonfärgad..av.1
  neongas_1_N = mkN "neongas" "neongaser" ; -- neongas..nn.1
  neonljus_1_N = mkN "neonljus" neutrum  ; -- neonljus..nn.1
  neonrör_1_N = mkN "neonrör" neutrum  ; -- neonrör..nn.1
  neonskylt_1_N = mkN "neonskylt" ; -- neonskylt..nn.1
  neoproterozoikum_1_N = mkN "neoproterozoikum" ; -- neoproterozoikum..nn.1
  neotektonik_1_N = mkN "neotektonik" "neotektoniker" ; -- neotektonik..nn.1
  neotektonisk_1_A = mkA "neotektonisk" ; -- neotektonisk..av.1
  nepales_1_N = mkN "nepales" "nepaleser" ; -- nepales..nn.1
  nepalesisk_1_A = mkA "nepalesisk" ; -- nepalesisk..av.1
  nepalesiska_1_N = mkN "nepalesiska" ; -- nepalesiska..nn.1
  nepalesiska_2_N = mkN "nepalesiska" ; -- nepalesiska..nn.2
  nepali_1_N = mkN "nepali" ; -- nepali..nn.1
  nepotism_1_N = mkN "nepotism" "nepotismer" ; -- nepotism..nn.1
  neptunisk_1_A = mkA "neptunisk" ; -- neptunisk..av.1
  neptunium_1_N = mkN "neptunium" neutrum  ; -- neptunium..nn.1
  nerarbeta_1_V = mkV "nerarbetar" ; -- nerarbeta..vb.1
  nerarbetande_1_N = mkN "nerarbetande" ; -- nerarbetande..nn.1
  nerbantad_1_A = mkA "nerbantad" ; -- nerbantad..av.1
  nerblodad_1_A = mkA "nerblodad" ; -- nerblodad..av.1
  nerblodning_1_N = mkN "nerblodning" ; -- nerblodning..nn.1
  nerbläckning_1_N = mkN "nerbläckning" ; -- nerbläckning..nn.1
  nerblåsa_1_V = mkV "nerblåser" ; -- nerblåsa..vb.1
  nerblåsande_1_N = mkN "nerblåsande" ; -- nerblåsande..nn.1
  nerborrad_1_A = mkA "nerborrad" ; -- nerborrad..av.1
  nerbringa_1_V = mkV "nerbringar" ; -- nerbringa..vb.1
  nerbringande_1_N = mkN "nerbringande" ; -- nerbringande..nn.1
  nerbruten_1_A = mkA "nerbruten" ; -- nerbruten..av.1
  nerbryta_1_V = mkV "nerbryta" "nerbröt" "nerbrutit" ; -- nerbryta..vb.1
  nerbrytande_1_N = mkN "nerbrytande" ; -- nerbrytande..nn.1
  nerbrytning_1_N = mkN "nerbrytning" ; -- nerbrytning..nn.1
  nerbrytningsstation_1_N = mkN "nerbrytningsstation" ; -- nerbrytningsstation..nn.1
  nerbränning_1_N = mkN "nerbränning" ; -- nerbränning..nn.1
  nerbusad_1_A = mkA "nerbusad" ; -- nerbusad..av.1
  nerbusning_1_N = mkN "nerbusning" ; -- nerbusning..nn.1
  nerbäddning_1_N = mkN "nerbäddning" ; -- nerbäddning..nn.1
  nerdekad_1_A = mkA "nerdekad" ; -- nerdekad..av.1
  nerdragen_1_A = mkA "nerdragen" ; -- nerdragen..av.1
  nerdragning_1_N = mkN "nerdragning" ; -- nerdragning..nn.1
  nere_1_Adv = mkAdv "nere" ; -- nere..ab.1
  nere_1_A = mkA "nere" ; -- nere..av.1
  nereid_1_N = mkN "nereid" "nereider" ; -- nereid..nn.1
  nerfall_1_N = mkN "nerfall" neutrum  ; -- nerfall..nn.1
  nerfart_1_N = mkN "nerfart" "nerfarter" ; -- nerfart..nn.1
  nerfläckning_1_N = mkN "nerfläckning" ; -- nerfläckning..nn.1
  nerfrysande_1_N = mkN "nerfrysande" ; -- nerfrysande..nn.1
  nerfrysning_1_N = mkN "nerfrysning" ; -- nerfrysning..nn.1
  nerfälld_1_A = mkA "nerfälld" "nerfällt" ; -- nerfälld..av.1
  nerfärd_1_N = mkN "nerfärd" "nerfärder" ; -- nerfärd..nn.1
  nerförsbacke_1_N = mkN "nerförsbacke" utrum  ; -- nerförsbacke..nn.1
  nergrisad_1_A = mkA "nergrisad" ; -- nergrisad..av.1
  nergrävning_1_N = mkN "nergrävning" ; -- nergrävning..nn.1
  nergående_1_N = mkN "nergående" ; -- nergående..nn.1
  nergång_1_N = mkN "nergång" ; -- nergång..nn.1
  nergången_1_A = mkA "nergången" ; -- nergången..av.1
  nergöra_1_V = mkV "nergöra" "nergjorde" "nergjort" ; -- nergöra..vb.1
  nergörande_1_N = mkN "nergörande" ; -- nergörande..nn.1
  nerhalare_1_N = mkN "nerhalare" utrum  ; -- nerhalare..nn.1
  nerhuggning_1_N = mkN "nerhuggning" ; -- nerhuggning..nn.1
  nerhukad_1_A = mkA "nerhukad" ; -- nerhukad..av.1
  nerhängande_1_A = mkA "nerhängande" ; -- nerhängande..av.1
  nerhåring_1_N = mkN "nerhåring" ; -- nerhåring..nn.1
  nerhårning_1_N = mkN "nerhårning" ; -- nerhårning..nn.1
  nerifrån_1_Adv = mkAdv "nerifrån" ; -- nerifrån..ab.1
  nerisa_1_V = mkV "nerisar" ; -- nerisa..vb.1
  nerisande_1_N = mkN "nerisande" ; -- nerisande..nn.1
  nerium_1_N = mkN "nerium" "nerien" "nerier" "nerierna" ; -- nerium..nn.1
  nerkalla_1_V = mkV "nerkallar" ; -- nerkalla..vb.1
  nerkallande_1_N = mkN "nerkallande" ; -- nerkallande..nn.1
  nerkasta_1_V = mkV "nerkastar" ; -- nerkasta..vb.1
  nerkastande_1_N = mkN "nerkastande" ; -- nerkastande..nn.1
  nerkastning_1_N = mkN "nerkastning" ; -- nerkastning..nn.1
  nerkavla_1_V = mkV "nerkavlar" ; -- nerkavla..vb.1
  nerkavlande_1_N = mkN "nerkavlande" ; -- nerkavlande..nn.1
  nerkilad_1_A = mkA "nerkilad" ; -- nerkilad..av.1
  nerkippad_1_A = mkA "nerkippad" ; -- nerkippad..av.1
  nerklassa_1_V = mkV "nerklassar" ; -- nerklassa..vb.1
  nerklassande_1_N = mkN "nerklassande" ; -- nerklassande..nn.1
  nerklottring_1_N = mkN "nerklottring" ; -- nerklottring..nn.1
  nerknarkad_1_A = mkA "nerknarkad" ; -- nerknarkad..av.1
  nerkomma_1_V = mkV "nerkomma" "nerkom" "nerkommit" ; -- nerkomma..vb.1
  nerkommande_1_N = mkN "nerkommande" ; -- nerkommande..nn.1
  nerkomst_1_N = mkN "nerkomst" ; -- nerkomst..nn.1
  nerkvark_1_N = mkN "nerkvark" ; -- nerkvark..nn.1
  nerköp_1_N = mkN "nerköp" neutrum  ; -- nerköp..nn.1
  nerladdning_1_N = mkN "nerladdning" ; -- nerladdning..nn.1
  nerlegad_1_A = mkA "nerlegad" ; -- nerlegad..av.1
  nerlusad_1_A = mkA "nerlusad" ; -- nerlusad..av.1
  nerlägga_1_V = mkV "nerlägga" "nerla" "nerlagt" ; -- nerlägga..vb.1
  nerläggande_1_N = mkN "nerläggande" ; -- nerläggande..nn.1
  nerläggelse_1_N = mkN "nerläggelse" "nerläggelser" ; -- nerläggelse..nn.1
  nerläggning_1_N = mkN "nerläggning" ; -- nerläggning..nn.1
  nerläggningshot_1_N = mkN "nerläggningshot" neutrum  ; -- nerläggningshot..nn.1
  nerläggningshotad_1_A = mkA "nerläggningshotad" ; -- nerläggningshotad..av.1
  nerlåtande_1_A = mkA "nerlåtande" ; -- nerlåtande..av.1
  nerlåten_1_A = mkA "nerlåten" ; -- nerlåten..av.1
  nerlåtenhet_1_N = mkN "nerlåtenhet" "nerlåtenheter" ; -- nerlåtenhet..nn.1
  nermejning_1_N = mkN "nermejning" ; -- nermejning..nn.1
  nermjölning_1_N = mkN "nermjölning" ; -- nermjölning..nn.1
  nermörk_1_A = mkA "nermörk" ; -- nermörk..av.1
  nerpetad_1_A = mkA "nerpetad" ; -- nerpetad..av.1
  nerplitad_1_A = mkA "nerplitad" ; -- nerplitad..av.1
  nerplöjning_1_N = mkN "nerplöjning" ; -- nerplöjning..nn.1
  nerputtad_1_A = mkA "nerputtad" ; -- nerputtad..av.1
  nerringd_1_A = mkA "nerringd" "nerringt" ; -- nerringd..av.1
  nerrusta_1_V = mkV "nerrustar" ; -- nerrusta..vb.1
  nerrustande_1_N = mkN "nerrustande" ; -- nerrustande..nn.1
  nerrustning_1_N = mkN "nerrustning" ; -- nerrustning..nn.1
  nerräkning_1_N = mkN "nerräkning" ; -- nerräkning..nn.1
  nerrökt_1_A = mkA "nerrökt" "nerrökt" ; -- nerrökt..av.1
  nersabling_1_N = mkN "nersabling" ; -- nersabling..nn.1
  nersabling_2_N = mkN "nersabling" ; -- nersabling..nn.2
  nersalta_1_V = mkV "nersaltar" ; -- nersalta..vb.1
  nersaltande_1_N = mkN "nersaltande" ; -- nersaltande..nn.1
  nersaltning_1_N = mkN "nersaltning" ; -- nersaltning..nn.1
  nersatt_1_A = mkA "nersatt" ; -- nersatt..av.1
  nerskitad_1_A = mkA "nerskitad" ; -- nerskitad..av.1
  nerskiten_1_A = mkA "nerskiten" ; -- nerskiten..av.1
  nerskjutning_1_N = mkN "nerskjutning" ; -- nerskjutning..nn.1
  nerskriva_1_V = mkV "nerskriva" "nerskrev" "nerskrivit" ; -- nerskriva..vb.1
  nerskrivande_1_N = mkN "nerskrivande" ; -- nerskrivande..nn.1
  nerskräpning_1_N = mkN "nerskräpning" ; -- nerskräpning..nn.1
  nerskälld_1_A = mkA "nerskälld" "nerskällt" ; -- nerskälld..av.1
  nerskärning_1_N = mkN "nerskärning" ; -- nerskärning..nn.1
  nerslag_1_N = mkN "nerslag" neutrum  ; -- nerslag..nn.1
  nerslagen_1_A = mkA "nerslagen" ; -- nerslagen..av.1
  nerslagskrater_1_N = mkN "nerslagskrater" ; -- nerslagskrater..nn.1
  nerslagsplats_1_N = mkN "nerslagsplats" "nerslagsplatser" ; -- nerslagsplats..nn.1
  nerslagsteori_1_N = mkN "nerslagsteori" "nerslagsteorier" ; -- nerslagsteori..nn.1
  nerslaktning_1_N = mkN "nerslaktning" ; -- nerslaktning..nn.1
  nersliten_1_A = mkA "nersliten" ; -- nersliten..av.1
  nersläpp_1_N = mkN "nersläpp" neutrum  ; -- nersläpp..nn.1
  nerslå_1_V = mkV "nerslå" "nerslog" "nerslagit" ; -- nerslå..vb.1
  nerslående_1_A = mkA "nerslående" ; -- nerslående..av.1
  nerslående_1_N = mkN "nerslående" ; -- nerslående..nn.1
  nersmord_1_A = mkA "nersmord" "nersmort" ; -- nersmord..av.1
  nersmutsare_1_N = mkN "nersmutsare" utrum  ; -- nersmutsare..nn.1
  nersmutsning_1_N = mkN "nersmutsning" ; -- nersmutsning..nn.1
  nerspilld_1_A = mkA "nerspilld" "nerspillt" ; -- nerspilld..av.1
  nerstiga_1_V = mkV "nerstiga" "nersteg" "nerstigit" ; -- nerstiga..vb.1
  nerstigande_1_N = mkN "nerstigande" ; -- nerstigande..nn.1
  nerstigning_1_N = mkN "nerstigning" ; -- nerstigning..nn.1
  nerstrykning_1_N = mkN "nerstrykning" ; -- nerstrykning..nn.1
  nerstråk_1_N = mkN "nerstråk" neutrum  ; -- nerstråk..nn.1
  nerstämd_1_A = mkA "nerstämd" "nerstämt" ; -- nerstämd..av.1
  nersupen_1_A = mkA "nersupen" ; -- nersupen..av.1
  nersutten_1_A = mkA "nersutten" ; -- nersutten..av.1
  nersvärtning_1_N = mkN "nersvärtning" ; -- nersvärtning..nn.1
  nersänka_1_V = mkV "nersänker" ; -- nersänka..vb.1
  nersänkande_1_N = mkN "nersänkande" ; -- nersänkande..nn.1
  nersänkning_1_N = mkN "nersänkning" ; -- nersänkning..nn.1
  nersätta_1_V = mkV "nersätta" "nersätter" "nersätt" "nersatte" "nersatt" "nersatt" ; -- nersätta..vb.1
  nersättande_1_A = mkA "nersättande" ; -- nersättande..av.1
  nersättande_1_N = mkN "nersättande" ; -- nersättande..nn.1
  nersättning_1_N = mkN "nersättning" ; -- nersättning..nn.1
  nersättningsbevis_1_N = mkN "nersättningsbevis" neutrum  ; -- nersättningsbevis..nn.1
  nersölad_1_A = mkA "nersölad" ; -- nersölad..av.1
  nersölning_1_N = mkN "nersölning" ; -- nersölning..nn.1
  nertagning_1_N = mkN "nertagning" ; -- nertagning..nn.1
  nerteckna_1_V = mkV "nertecknar" ; -- nerteckna..vb.1
  nertecknande_1_N = mkN "nertecknande" ; -- nertecknande..nn.1
  nertid_1_N = mkN "nertid" ; -- nertid..nn.1
  nertill_1_Adv = mkAdv "nertill" ; -- nertill..ab.1
  nertoning_1_N = mkN "nertoning" ; -- nertoning..nn.1
  nertrampad_1_A = mkA "nertrampad" ; -- nertrampad..av.1
  nertransformera_1_V = mkV "nertransformerar" ; -- nertransformera..vb.1
  nertransformerande_1_N = mkN "nertransformerande" ; -- nertransformerande..nn.1
  nertransformerbar_1_A = mkA "nertransformerbar" ; -- nertransformerbar..av.1
  nertransformerbarhet_1_N = mkN "nertransformerbarhet" ; -- nertransformerbarhet..nn.1
  nertransformering_1_N = mkN "nertransformering" ; -- nertransformering..nn.1
  nertransponera_1_V = mkV "nertransponerar" ; -- nertransponera..vb.1
  nertransponerande_1_N = mkN "nertransponerande" ; -- nertransponerande..nn.1
  nertransponerbar_1_A = mkA "nertransponerbar" ; -- nertransponerbar..av.1
  nertransponerbarhet_1_N = mkN "nertransponerbarhet" ; -- nertransponerbarhet..nn.1
  nertransponering_1_N = mkN "nertransponering" ; -- nertransponering..nn.1
  nertrappa_1_V = mkV "nertrappar" ; -- nertrappa..vb.1
  nertrappande_1_N = mkN "nertrappande" ; -- nertrappande..nn.1
  nertrappning_1_N = mkN "nertrappning" ; -- nertrappning..nn.1
  nertryckning_1_N = mkN "nertryckning" ; -- nertryckning..nn.1
  nertryckt_1_A = mkA "nertryckt" "nertryckt" ; -- nertryckt..av.1
  nerts_1_N = mkN "nerts" ; -- nerts..nn.1
  nertsbisam_1_N = mkN "nertsbisam" ; -- nertsbisam..nn.1
  nertysta_1_V = mkV "nertystar" ; -- nertysta..vb.1
  nertystande_1_N = mkN "nertystande" ; -- nertystande..nn.1
  nertystning_1_N = mkN "nertystning" ; -- nertystning..nn.1
  nertz_1_N = mkN "nertz" ; -- nertz..nn.1
  nertzbisam_1_N = mkN "nertzbisam" ; -- nertzbisam..nn.1
  nerv_1_N = mkN "nerv" "nerver" ; -- nerv..nn.1
  nervaktivitet_1_N = mkN "nervaktivitet" "nervaktiviteter" ; -- nervaktivitet..nn.1
  nervattack_1_N = mkN "nervattack" "nervattacker" ; -- nervattack..nn.1
  nervbana_1_N = mkN "nervbana" ; -- nervbana..nn.1
  nervcell_1_N = mkN "nervcell" "nervceller" ; -- nervcell..nn.1
  nervcellsgrupp_1_N = mkN "nervcellsgrupp" "nervcellsgrupper" ; -- nervcellsgrupp..nn.1
  nervchock_1_N = mkN "nervchock" "nervchocker" ; -- nervchock..nn.1
  nervevad_1_A = mkA "nervevad" ; -- nervevad..av.1
  nervfeber_1_N = mkN "nervfeber" ; -- nervfeber..nn.1
  nervförbindelse_1_N = mkN "nervförbindelse" "nervförbindelser" ; -- nervförbindelse..nn.1
  nervgas_1_N = mkN "nervgas" "nervgaser" ; -- nervgas..nn.1
  nervgift_1_N = mkN "nervgift" "nervgiftet" "nervgifter" "nervgifterna" ; -- nervgift..nn.1
  nervgren_1_N = mkN "nervgren" "nervgrenen" "nervgrenar" "nervgrenarna" ; -- nervgren..nn.1
  nervig_1_A = mkA "nervig" ; -- nervig..av.1
  nervighet_1_N = mkN "nervighet" ; -- nervighet..nn.1
  nervimpuls_1_N = mkN "nervimpuls" "nervimpulser" ; -- nervimpuls..nn.1
  nervkittlande_1_A = mkA "nervkittlande" ; -- nervkittlande..av.1
  nervkittling_1_N = mkN "nervkittling" ; -- nervkittling..nn.1
  nervklen_1_A = mkA "nervklen" "nervklent" ; -- nervklen..av.1
  nervknippe_1_N = mkN "nervknippe" ; -- nervknippe..nn.1
  nervknut_1_N = mkN "nervknut" ; -- nervknut..nn.1
  nervkollaps_1_N = mkN "nervkollaps" "nervkollapser" ; -- nervkollaps..nn.1
  nervkrig_1_N = mkN "nervkrig" neutrum  ; -- nervkrig..nn.1
  nervmedicin_1_N = mkN "nervmedicin" "nervmediciner" ; -- nervmedicin..nn.1
  nervositet_1_N = mkN "nervositet" "nervositeter" ; -- nervositet..nn.1
  nervpirrande_1_A = mkA "nervpirrande" ; -- nervpirrande..av.1
  nervpress_1_N = mkN "nervpress" ; -- nervpress..nn.1
  nervpåfrestande_1_A = mkA "nervpåfrestande" ; -- nervpåfrestande..av.1
  nervretning_1_N = mkN "nervretning" ; -- nervretning..nn.1
  nervryckning_1_N = mkN "nervryckning" ; -- nervryckning..nn.1
  nervsammanbrott_1_N = mkN "nervsammanbrott" neutrum  ; -- nervsammanbrott..nn.1
  nervsignal_1_N = mkN "nervsignal" "nervsignaler" ; -- nervsignal..nn.1
  nervsignalmönster_1_N = mkN "nervsignalmönster" neutrum  ; -- nervsignalmönster..nn.1
  nervsjukdom_1_N = mkN "nervsjukdom" ; -- nervsjukdom..nn.1
  nervskada_1_N = mkN "nervskada" ; -- nervskada..nn.1
  nervskakande_1_A = mkA "nervskakande" ; -- nervskakande..av.1
  nervskida_1_N = mkN "nervskida" ; -- nervskida..nn.1
  nervskyddande_1_A = mkA "nervskyddande" ; -- nervskyddande..av.1
  nervsmärta_1_N = mkN "nervsmärta" ; -- nervsmärta..nn.1
  nervstump_1_N = mkN "nervstump" ; -- nervstump..nn.1
  nervstärkande_1_A = mkA "nervstärkande" ; -- nervstärkande..av.1
  nervsvag_1_A = mkA "nervsvag" ; -- nervsvag..av.1
  nervsvaghet_1_N = mkN "nervsvaghet" ; -- nervsvaghet..nn.1
  nervsystem_1_N = mkN "nervsystem" neutrum  ; -- nervsystem..nn.1
  nervtråd_1_N = mkN "nervtråd" ; -- nervtråd..nn.1
  nervvrak_1_N = mkN "nervvrak" neutrum  ; -- nervvrak..nn.1
  nervvävnad_1_N = mkN "nervvävnad" "nervvävnader" ; -- nervvävnad..nn.1
  nerväg_1_N = mkN "nerväg" ; -- nerväg..nn.1
  nervända_1_N = mkN "nervända" ; -- nervända..nn.1
  nervände_1_N = mkN "nervände" utrum  ; -- nervände..nn.1
  nervärdera_1_V = mkV "nervärderar" ; -- nervärdera..vb.1
  nervärderande_1_N = mkN "nervärderande" ; -- nervärderande..nn.1
  nervärderbar_1_A = mkA "nervärderbar" ; -- nervärderbar..av.1
  nervärderbarhet_1_N = mkN "nervärderbarhet" ; -- nervärderbarhet..nn.1
  nervärdering_1_N = mkN "nervärdering" ; -- nervärdering..nn.1
  nervös_1_A = mkA "nervös" ; -- nervös..av.1
  nervös_2_A = mkA "nervös" ; -- nervös..av.2
  nerz_1_N = mkN "nerz" ; -- nerz..nn.1
  nerzbisam_1_N = mkN "nerzbisam" ; -- nerzbisam..nn.1
  nerärvd_1_A = mkA "nerärvd" "nerärvt" ; -- nerärvd..av.1
  neråtböjd_1_A = mkA "neråtböjd" "neråtböjt" ; -- neråtböjd..av.1
  neråtgående_1_A = mkA "neråtgående" ; -- neråtgående..av.1
  neråtgående_1_N = mkN "neråtgående" ; -- neråtgående..nn.1
  neråtgång_1_N = mkN "neråtgång" ; -- neråtgång..nn.1
  nesa_1_N = mkN "nesa" ; -- nesa..nn.1
  neslig_1_A = mkA "neslig" ; -- neslig..av.1
  nesligen_1_Adv = mkAdv "nesligen" ; -- nesligen..ab.1
  neslighet_1_N = mkN "neslighet" "nesligheter" ; -- neslighet..nn.1
  nessosdräkt_1_N = mkN "nessosdräkt" ; -- nessosdräkt..nn.1
  nessusdräkt_1_N = mkN "nessusdräkt" ; -- nessusdräkt..nn.1
  nestorian_1_N = mkN "nestorian" "nestorianer" ; -- nestorian..nn.1
  nestorianism_1_N = mkN "nestorianism" "nestorianismer" ; -- nestorianism..nn.1
  nestoriansk_1_A = mkA "nestoriansk" ; -- nestoriansk..av.1
  netto_1_N = mkN "netto" "nettot" "netton" "nettona" ; -- netto..nn.1
  nettoavkastning_1_N = mkN "nettoavkastning" ; -- nettoavkastning..nn.1
  nettobehållning_1_N = mkN "nettobehållning" ; -- nettobehållning..nn.1
  nettoförmögenhet_1_N = mkN "nettoförmögenhet" "nettoförmögenheter" ; -- nettoförmögenhet..nn.1
  nettoinkomst_1_N = mkN "nettoinkomst" "nettoinkomster" ; -- nettoinkomst..nn.1
  nettolön_1_N = mkN "nettolön" "nettolöner" ; -- nettolön..nn.1
  nettopris_1_N = mkN "nettopris" neutrum  ; -- nettopris..nn.1
  nettoregisterton_1_N = mkN "nettoregisterton" "nettoregistertonnet" "nettoregisterton" "nettoregistertonnen" ; -- nettoregisterton..nn.1
  nettoskuld_1_N = mkN "nettoskuld" "nettoskulder" ; -- nettoskuld..nn.1
  nettosparande_1_N = mkN "nettosparande" ; -- nettosparande..nn.1
  nettostudietid_1_N = mkN "nettostudietid" "nettostudietider" ; -- nettostudietid..nn.1
  nettotonnage_1_N = mkN "nettotonnage" ; -- nettotonnage..nn.1
  nettovikt_1_N = mkN "nettovikt" ; -- nettovikt..nn.1
  nettovinst_1_N = mkN "nettovinst" "nettovinster" ; -- nettovinst..nn.1
  nettovärde_1_N = mkN "nettovärde" ; -- nettovärde..nn.1
  neural_1_A = mkA "neural" ; -- neural..av.1
  neuralgi_1_N = mkN "neuralgi" ; -- neuralgi..nn.1
  neuralgisk_1_A = mkA "neuralgisk" ; -- neuralgisk..av.1
  neuralisering_1_N = mkN "neuralisering" ; -- neuralisering..nn.1
  neurasteni_1_N = mkN "neurasteni" ; -- neurasteni..nn.1
  neurastenisk_1_A = mkA "neurastenisk" ; -- neurastenisk..av.1
  neurit_1_N = mkN "neurit" "neuriter" ; -- neurit..nn.1
  neurofysiolog_1_N = mkN "neurofysiolog" "neurofysiologer" ; -- neurofysiolog..nn.1
  neurofysiologi_1_N = mkN "neurofysiologi" ; -- neurofysiologi..nn.1
  neurografi_1_N = mkN "neurografi" ; -- neurografi..nn.1
  neurokirurgi_1_N = mkN "neurokirurgi" ; -- neurokirurgi..nn.1
  neurokirurgisk_1_A = mkA "neurokirurgisk" ; -- neurokirurgisk..av.1
  neuroleptika_1_N = mkN "neuroleptika" "neuroleptikat" "neuroleptika" "neuroleptikana" ; -- neuroleptika..nn.1
  neurolog_1_N = mkN "neurolog" "neurologer" ; -- neurolog..nn.1
  neurologi_1_N = mkN "neurologi" ; -- neurologi..nn.1
  neurologisk_1_A = mkA "neurologisk" ; -- neurologisk..av.1
  neurom_1_N = mkN "neurom" neutrum  ; -- neurom..nn.1
  neuron_1_N = mkN "neuron" neutrum  ; -- neuron..nn.1
  neuropat_1_N = mkN "neuropat" "neuropater" ; -- neuropat..nn.1
  neuropati_1_N = mkN "neuropati" ; -- neuropati..nn.1
  neuropsykiatrisk_1_A = mkA "neuropsykiatrisk" ; -- neuropsykiatrisk..av.1
  neuros_1_N = mkN "neuros" "neuroser" ; -- neuros..nn.1
  neurosedyn_1_N = mkN "neurosedyn" neutrum  ; -- neurosedyn..nn.1
  neurotiker_1_N = mkN "neurotiker" "neurotikern" "neurotiker" "neurotikerna" ; -- neurotiker..nn.1
  neurotisera_1_V = mkV "neurotiserar" ; -- neurotisera..vb.1
  neurotiserande_1_N = mkN "neurotiserande" ; -- neurotiserande..nn.1
  neurotisering_1_N = mkN "neurotisering" ; -- neurotisering..nn.1
  neurotisk_1_A = mkA "neurotisk" ; -- neurotisk..av.1
  neurovetenskap_1_N = mkN "neurovetenskap" "neurovetenskaper" ; -- neurovetenskap..nn.1
  neutral_1_A = mkA "neutral" ; -- neutral..av.1
  neutralisation_1_N = mkN "neutralisation" ; -- neutralisation..nn.1
  neutralisera_1_V = mkV "neutraliserar" ; -- neutralisera..vb.1
  neutraliserande_1_N = mkN "neutraliserande" ; -- neutraliserande..nn.1
  neutraliserbar_1_A = mkA "neutraliserbar" ; -- neutraliserbar..av.1
  neutraliserbarhet_1_N = mkN "neutraliserbarhet" ; -- neutraliserbarhet..nn.1
  neutralisering_1_N = mkN "neutralisering" ; -- neutralisering..nn.1
  neutralism_1_N = mkN "neutralism" "neutralismer" ; -- neutralism..nn.1
  neutralist_1_N = mkN "neutralist" "neutralister" ; -- neutralist..nn.1
  neutralistisk_1_A = mkA "neutralistisk" ; -- neutralistisk..av.1
  neutralitet_1_N = mkN "neutralitet" "neutraliteter" ; -- neutralitet..nn.1
  neutralitetsförklaring_1_N = mkN "neutralitetsförklaring" ; -- neutralitetsförklaring..nn.1
  neutralläge_1_N = mkN "neutralläge" ; -- neutralläge..nn.1
  neutrino_1_N = mkN "neutrino" "neutrinon" "neutrinos" "neutrinosarna" ; -- neutrino..nn.1
  neutrinofälla_1_N = mkN "neutrinofälla" ; -- neutrinofälla..nn.1
  neutrinoförtätning_1_N = mkN "neutrinoförtätning" ; -- neutrinoförtätning..nn.1
  neutrinohav_1_N = mkN "neutrinohav" neutrum  ; -- neutrinohav..nn.1
  neutrinomodell_1_N = mkN "neutrinomodell" "neutrinomodeller" ; -- neutrinomodell..nn.1
  neutrinopartikel_1_N = mkN "neutrinopartikel" ; -- neutrinopartikel..nn.1
  neutron_1_N = mkN "neutron" "neutroner" ; -- neutron..nn.1
  neutronbomb_1_N = mkN "neutronbomb" "neutronbomber" ; -- neutronbomb..nn.1
  neutronstjärna_1_N = mkN "neutronstjärna" ; -- neutronstjärna..nn.1
  neutronstrålning_1_N = mkN "neutronstrålning" ; -- neutronstrålning..nn.1
  neutrum_1_N = mkN "neutrum" neutrum  ; -- neutrum..nn.1
  nevö_1_N = mkN "nevö" "nevön" "nevöer" "nevöerna" ; -- nevö..nn.1
  newfoundlandshund_1_N = mkN "newfoundlandshund" ; -- newfoundlandshund..nn.1
  newfoundländare_1_N = mkN "newfoundländare" utrum  ; -- newfoundländare..nn.1
  newfoundländsk_1_A = mkA "newfoundländsk" ; -- newfoundländsk..av.1
  newton_1_N = mkN "newton" "newtonen" "newton" "newtonen" ; -- newton..nn.1
  newtonmeter_1_N = mkN "newtonmeter" ; -- newtonmeter..nn.1
  newtonsk_1_A = mkA "newtonsk" ; -- newtonsk..av.1
  newyorkoriginal_1_N = mkN "newyorkoriginal" neutrum  ; -- newyorkoriginal..nn.1
  ng_ljud_1_N = mkN "ng-ljud" neutrum  ; -- ng-ljud..nn.1
  nia_1_N = mkN "nia" ; -- nia..nn.1
  nia_1_V = mkV "niar" ; -- nia..vb.1
  niacin_1_N = mkN "niacin" "niaciner" ; -- niacin..nn.1
  niande_1_N = mkN "niande" ; -- niande..nn.1
  nicaraguan_1_N = mkN "nicaraguan" "nicaraguaner" ; -- nicaraguan..nn.1
  nicaraguansk_1_A = mkA "nicaraguansk" ; -- nicaraguansk..av.1
  nicaraguanska_1_N = mkN "nicaraguanska" ; -- nicaraguanska..nn.1
  nick_1_N = mkN "nick" ; -- nick..nn.1
  nicka_1_V = mkV "nickar" ; -- nicka..vb.1
  nicka_2_V = mkV "nickar" ; -- nicka..vb.2
  nickande_1_N = mkN "nickande" ; -- nickande..nn.1
  nickduell_1_N = mkN "nickduell" "nickdueller" ; -- nickduell..nn.1
  nickedocka_1_N = mkN "nickedocka" ; -- nickedocka..nn.1
  nickel_1_N = mkN "nickel" ; -- nickel..nn.1
  nickelkromstål_1_N = mkN "nickelkromstål" neutrum  ; -- nickelkromstål..nn.1
  nickelstål_1_N = mkN "nickelstål" neutrum  ; -- nickelstål..nn.1
  nickhake_1_N = mkN "nickhake" utrum  ; -- nickhake..nn.1
  nickning_1_N = mkN "nickning" ; -- nickning..nn.1
  nickpump_1_N = mkN "nickpump" ; -- nickpump..nn.1
  nidation_1_N = mkN "nidation" ; -- nidation..nn.1
  nidbild_1_N = mkN "nidbild" "nidbilder" ; -- nidbild..nn.1
  niddikt_1_N = mkN "niddikt" "niddikter" ; -- niddikt..nn.1
  niding_1_N = mkN "niding" ; -- niding..nn.1
  nidingsdåd_1_N = mkN "nidingsdåd" neutrum  ; -- nidingsdåd..nn.1
  nidingsverk_1_N = mkN "nidingsverk" neutrum  ; -- nidingsverk..nn.1
  nidsk_1_A = mkA "nidsk" ; -- nidsk..av.1
  nidskhet_1_N = mkN "nidskhet" ; -- nidskhet..nn.1
  nidskrift_1_N = mkN "nidskrift" "nidskrifter" ; -- nidskrift..nn.1
  nidstång_1_N = mkN "nidstång" "nidstänger" ; -- nidstång..nn.1
  nidvisa_1_N = mkN "nidvisa" ; -- nidvisa..nn.1
  niece_1_N = mkN "niece" "niecer" ; -- niece..nn.1
  niellera_1_V = mkV "niellerar" ; -- niellera..vb.1
  niellerande_1_N = mkN "niellerande" ; -- niellerande..nn.1
  niellerbar_1_A = mkA "niellerbar" ; -- niellerbar..av.1
  niellerbarhet_1_N = mkN "niellerbarhet" ; -- niellerbarhet..nn.1
  niellering_1_N = mkN "niellering" ; -- niellering..nn.1
  niello_1_N = mkN "niello" "niellon" "nieller" "niellerna" ; -- niello..nn.1
  nietzscheansk_1_A = mkA "nietzscheansk" ; -- nietzscheansk..av.1
  niga_1_V = mkV "niga" "neg" "nigit" ; -- niga..vb.1
  nigande_1_N = mkN "nigande" ; -- nigande..nn.1
  nigerer_1_N = mkN "nigerer" "nigerern" "nigerer" "nigererna" ; -- nigerer..nn.1
  nigerian_1_N = mkN "nigerian" "nigerianer" ; -- nigerian..nn.1
  nigeriansk_1_A = mkA "nigeriansk" ; -- nigeriansk..av.1
  nigerianska_1_N = mkN "nigerianska" ; -- nigerianska..nn.1
  nigerisk_1_A = mkA "nigerisk" ; -- nigerisk..av.1
  nigeriska_1_N = mkN "nigeriska" ; -- nigeriska..nn.1
  nigger_1_N = mkN "nigger" "niggern" "niggrer" "niggrerna" ; -- nigger..nn.1
  nigning_1_N = mkN "nigning" ; -- nigning..nn.1
  nigsittande_1_A = mkA "nigsittande" ; -- nigsittande..av.1
  nigstående_1_A = mkA "nigstående" ; -- nigstående..av.1
  nihilism_1_N = mkN "nihilism" "nihilismer" ; -- nihilism..nn.1
  nihilist_1_N = mkN "nihilist" "nihilister" ; -- nihilist..nn.1
  nihilistisk_1_A = mkA "nihilistisk" ; -- nihilistisk..av.1
  nikab_1_N = mkN "nikab" "nikaber" ; -- nikab..nn.1
  nikotin_1_N = mkN "nikotin" ; -- nikotin..nn.1
  nikotingul_1_A = mkA "nikotingul" ; -- nikotingul..av.1
  nikotinism_1_N = mkN "nikotinism" "nikotinismer" ; -- nikotinism..nn.1
  nikotinist_1_N = mkN "nikotinist" "nikotinister" ; -- nikotinist..nn.1
  nikt_1_N = mkN "nikt" ; -- nikt..nn.1
  nimbus_1_N = mkN "nimbus" ; -- nimbus..nn.1
  nimrod_1_N = mkN "nimrod" ; -- nimrod..nn.1
  ninja_1_N = mkN "ninja" ; -- ninja..nn.1
  niob_1_N = mkN "niob" ; -- niob..nn.1
  niodagarsturné_1_N = mkN "niodagarsturné" "niodagarsturnéer" ; -- niodagarsturné..nn.1
  niodubbel_1_A = mkA "niodubben" ; -- niodubbel..av.1
  niofaldig_1_A = mkA "niofaldig" ; -- niofaldig..av.1
  niohålsbana_1_N = mkN "niohålsbana" ; -- niohålsbana..nn.1
  niomannakommitté_1_N = mkN "niomannakommitté" "niomannakommittéer" ; -- niomannakommitté..nn.1
  nionde_1_A = mkA "nionde" ; -- nionde..av.1
  niondedel_1_N = mkN "niondedel" "niondedelen" "niondedelar" "niondedelarna" ; -- niondedel..nn.1
  niondel_1_N = mkN "niondel" "niondelen" "niondelar" "niondelarna" ; -- niondel..nn.1
  niotillhållarlås_1_N = mkN "niotillhållarlås" neutrum  ; -- niotillhållarlås..nn.1
  niotumsspik_1_N = mkN "niotumsspik" ; -- niotumsspik..nn.1
  nioårig_1_A = mkA "nioårig" ; -- nioårig..av.1
  nioåring_1_N = mkN "nioåring" ; -- nioåring..nn.1
  nipa_1_N = mkN "nipa" ; -- nipa..nn.1
  nipbrant_1_N = mkN "nipbrant" "nipbranter" ; -- nipbrant..nn.1
  nipflod_1_N = mkN "nipflod" "nipfloder" ; -- nipflod..nn.1
  nipig_1_A = mkA "nipig" ; -- nipig..av.1
  nippel_1_N = mkN "nippel" ; -- nippel..nn.1
  nippertippa_1_N = mkN "nippertippa" ; -- nippertippa..nn.1
  nippran_1_N = mkN "nippran" ; -- nippran..nn.1
  nipprig_1_A = mkA "nipprig" ; -- nipprig..av.1
  nipprighet_1_N = mkN "nipprighet" ; -- nipprighet..nn.1
  niqab_1_N = mkN "niqab" "niqaber" ; -- niqab..nn.1
  nisch_1_N = mkN "nisch" "nischer" ; -- nisch..nn.1
  nischad_1_A = mkA "nischad" ; -- nischad..av.1
  nischbank_1_N = mkN "nischbank" "nischbanker" ; -- nischbank..nn.1
  nissa_1_N = mkN "nissa" ; -- nissa..nn.1
  nisse_1_N = mkN "nisse" utrum  ; -- nisse..nn.1
  nisseflicka_1_N = mkN "nisseflicka" ; -- nisseflicka..nn.1
  nissöga_1_N = mkN "nissöga" "nissögat" "nissögon" "nissögonen" ; -- nissöga..nn.1
  nit_1_N = mkN "nit" neutrum  ; -- nit..nn.1
  nit_2_N = mkN "nit" ; -- nit..nn.2
  nit_3_N = mkN "nit" ; -- nit..nn.3
  nita_1_V = mkV "nitar" ; -- nita..vb.1
  nita_2_V = mkV "nitar" ; -- nita..vb.2
  nitande_1_N = mkN "nitande" ; -- nitande..nn.1
  nitbricka_1_N = mkN "nitbricka" ; -- nitbricka..nn.1
  nitfull_1_A = mkA "nitfull" ; -- nitfull..av.1
  nitförband_1_N = mkN "nitförband" neutrum  ; -- nitförband..nn.1
  nithuvud_1_N = mkN "nithuvud" "nithuvudet" "nithuvud" "nithuvudena" ; -- nithuvud..nn.1
  nitid_1_A = mkA "nitid" ; -- nitid..av.1
  nitisk_1_A = mkA "nitisk" ; -- nitisk..av.1
  nitiskhet_1_N = mkN "nitiskhet" ; -- nitiskhet..nn.1
  nitlott_1_N = mkN "nitlott" "nitlotter" ; -- nitlott..nn.1
  nitnagel_1_N = mkN "nitnagel" ; -- nitnagel..nn.1
  nitrat_1_N = mkN "nitrat" neutrum  ; -- nitrat..nn.1
  nitratbakterie_1_N = mkN "nitratbakterie" "nitratbakterier" ; -- nitratbakterie..nn.1
  nitrera_1_V = mkV "nitrerar" ; -- nitrera..vb.1
  nitrerande_1_N = mkN "nitrerande" ; -- nitrerande..nn.1
  nitrerbar_1_A = mkA "nitrerbar" ; -- nitrerbar..av.1
  nitrerbarhet_1_N = mkN "nitrerbarhet" ; -- nitrerbarhet..nn.1
  nitrering_1_N = mkN "nitrering" ; -- nitrering..nn.1
  nitrerstål_1_N = mkN "nitrerstål" neutrum  ; -- nitrerstål..nn.1
  nitrit_1_N = mkN "nitrit" neutrum  ; -- nitrit..nn.1
  nitritbakterie_1_N = mkN "nitritbakterie" "nitritbakterier" ; -- nitritbakterie..nn.1
  nitrocellulosa_1_N = mkN "nitrocellulosa" ; -- nitrocellulosa..nn.1
  nitroförening_1_N = mkN "nitroförening" ; -- nitroförening..nn.1
  nitrogen_1_N = mkN "nitrogen" neutrum  ; -- nitrogen..nn.1
  nitroglycerin_1_N = mkN "nitroglycerin" "nitroglyceriner" ; -- nitroglycerin..nn.1
  nitrogrupp_1_N = mkN "nitrogrupp" "nitrogrupper" ; -- nitrogrupp..nn.1
  nitrolit_1_N = mkN "nitrolit" ; -- nitrolit..nn.1
  nitrös_1_A = mkA "nitrös" ; -- nitrös..av.1
  nitskalle_1_N = mkN "nitskalle" utrum  ; -- nitskalle..nn.1
  nitstamp_1_N = mkN "nitstamp" ; -- nitstamp..nn.1
  nitstans_1_N = mkN "nitstans" ; -- nitstans..nn.1
  nittifemte_1_A = mkA "nittifemte" ; -- nittifemte..av.1
  nittiofemoktanig_1_A = mkA "nittiofemoktanig" ; -- nittiofemoktanig..av.1
  nittiofemte_1_A = mkA "nittiofemte" ; -- nittiofemte..av.1
  nittionde_1_A = mkA "nittionde" ; -- nittionde..av.1
  nittiosexprocentig_1_A = mkA "nittiosexprocentig" ; -- nittiosexprocentig..av.1
  nittiotal_1_N = mkN "nittiotal" neutrum  ; -- nittiotal..nn.1
  nittiotalism_1_N = mkN "nittiotalism" "nittiotalismer" ; -- nittiotalism..nn.1
  nittiotalist_1_N = mkN "nittiotalist" "nittiotalister" ; -- nittiotalist..nn.1
  nittiotalistisk_1_A = mkA "nittiotalistisk" ; -- nittiotalistisk..av.1
  nittisexprocentig_1_A = mkA "nittisexprocentig" ; -- nittisexprocentig..av.1
  nittital_1_N = mkN "nittital" neutrum  ; -- nittital..nn.1
  nittitalism_1_N = mkN "nittitalism" "nittitalismer" ; -- nittitalism..nn.1
  nittitalist_1_N = mkN "nittitalist" "nittitalister" ; -- nittitalist..nn.1
  nittonde_1_A = mkA "nittonde" ; -- nittonde..av.1
  nittonhundrafemtiotal_1_N = mkN "nittonhundrafemtiotal" neutrum  ; -- nittonhundrafemtiotal..nn.1
  nittonhundrafyrtiotal_1_N = mkN "nittonhundrafyrtiotal" neutrum  ; -- nittonhundrafyrtiotal..nn.1
  nittonhundranittiotal_1_N = mkN "nittonhundranittiotal" neutrum  ; -- nittonhundranittiotal..nn.1
  nittonhundrasextiotal_1_N = mkN "nittonhundrasextiotal" neutrum  ; -- nittonhundrasextiotal..nn.1
  nittonhundrasjuttiotal_1_N = mkN "nittonhundrasjuttiotal" neutrum  ; -- nittonhundrasjuttiotal..nn.1
  nittonhundratal_1_N = mkN "nittonhundratal" neutrum  ; -- nittonhundratal..nn.1
  nittonhundratiotal_1_N = mkN "nittonhundratiotal" neutrum  ; -- nittonhundratiotal..nn.1
  nittonhundratjugotal_1_N = mkN "nittonhundratjugotal" neutrum  ; -- nittonhundratjugotal..nn.1
  nittonhundratrettiotal_1_N = mkN "nittonhundratrettiotal" neutrum  ; -- nittonhundratrettiotal..nn.1
  nittonhundraåttiotal_1_N = mkN "nittonhundraåttiotal" neutrum  ; -- nittonhundraåttiotal..nn.1
  nittonårig_1_A = mkA "nittonårig" ; -- nittonårig..av.1
  nittonåring_1_N = mkN "nittonåring" ; -- nittonåring..nn.1
  nitälska_1_V = mkV "nitälskar" ; -- nitälska..vb.1
  nitälskande_1_N = mkN "nitälskande" ; -- nitälskande..nn.1
  niuer_1_N = mkN "niuer" "niuern" "niuer" "niuerna" ; -- niuer..nn.1
  niuiska_1_N = mkN "niuiska" ; -- niuiska..nn.1
  nivation_1_N = mkN "nivation" ; -- nivation..nn.1
  nivellera_1_V = mkV "nivellerar" ; -- nivellera..vb.1
  nivellerande_1_N = mkN "nivellerande" ; -- nivellerande..nn.1
  nivellerbar_1_A = mkA "nivellerbar" ; -- nivellerbar..av.1
  nivellerbarhet_1_N = mkN "nivellerbarhet" ; -- nivellerbarhet..nn.1
  nivellering_1_N = mkN "nivellering" ; -- nivellering..nn.1
  nivå_1_N = mkN "nivå" "nivåer" ; -- nivå..nn.1
  nivågruppera_1_V = mkV "nivågrupperar" ; -- nivågruppera..vb.1
  nivågrupperande_1_N = mkN "nivågrupperande" ; -- nivågrupperande..nn.1
  nivågrupperbar_1_A = mkA "nivågrupperbar" ; -- nivågrupperbar..av.1
  nivågrupperbarhet_1_N = mkN "nivågrupperbarhet" ; -- nivågrupperbarhet..nn.1
  nivågruppering_1_N = mkN "nivågruppering" ; -- nivågruppering..nn.1
  nivåkarta_1_N = mkN "nivåkarta" ; -- nivåkarta..nn.1
  nivåkurva_1_N = mkN "nivåkurva" ; -- nivåkurva..nn.1
  nivåskillnad_1_N = mkN "nivåskillnad" "nivåskillnader" ; -- nivåskillnad..nn.1
  nivåyta_1_N = mkN "nivåyta" ; -- nivåyta..nn.1
  njugg_1_A = mkA "njugg" ; -- njugg..av.1
  njugghet_1_N = mkN "njugghet" ; -- njugghet..nn.1
  njugghänt_1_A = mkA "njugghänt" "njugghänt" ; -- njugghänt..av.1
  njugghänthet_1_N = mkN "njugghänthet" ; -- njugghänthet..nn.1
  njurbäcken_1_N = mkN "njurbäcken" neutrum  ; -- njurbäcken..nn.1
  njurbälte_1_N = mkN "njurbälte" ; -- njurbälte..nn.1
  njure_1_N = mkN "njure" utrum  ; -- njure..nn.1
  njurformad_1_A = mkA "njurformad" ; -- njurformad..av.1
  njursjukdom_1_N = mkN "njursjukdom" ; -- njursjukdom..nn.1
  njurskada_1_N = mkN "njurskada" ; -- njurskada..nn.1
  njursten_1_N = mkN "njursten" "njurstenen" "njurstenar" "njurstenarna" ; -- njursten..nn.1
  njurtalg_1_N = mkN "njurtalg" ; -- njurtalg..nn.1
  njurtransplantation_1_N = mkN "njurtransplantation" ; -- njurtransplantation..nn.1
  njuta_1_V = mkV "njuta" "njöt" "njutit" ; -- njuta..vb.1
  njutande_1_N = mkN "njutande" ; -- njutande..nn.1
  njutbar_1_A = mkA "njutbar" ; -- njutbar..av.1
  njutbarhet_1_N = mkN "njutbarhet" ; -- njutbarhet..nn.1
  njutning_1_N = mkN "njutning" ; -- njutning..nn.1
  njutningsfilosofi_1_N = mkN "njutningsfilosofi" ; -- njutningsfilosofi..nn.1
  njutningsfull_1_A = mkA "njutningsfull" ; -- njutningsfull..av.1
  njutningsfullhet_1_N = mkN "njutningsfullhet" ; -- njutningsfullhet..nn.1
  njutningslysten_1_A = mkA "njutningslysten" ; -- njutningslysten..av.1
  njutningslystnad_1_N = mkN "njutningslystnad" "njutningslystnader" ; -- njutningslystnad..nn.1
  njutningsmedel_1_N = mkN "njutningsmedel" neutrum  ; -- njutningsmedel..nn.1
  njutningsmänniska_1_N = mkN "njutningsmänniska" ; -- njutningsmänniska..nn.1
  njutningsmässig_1_A = mkA "njutningsmässig" ; -- njutningsmässig..av.1
  njutningsrik_1_A = mkA "njutningsrik" ; -- njutningsrik..av.1
  njutningsrikedom_1_N = mkN "njutningsrikedom" ; -- njutningsrikedom..nn.1
  noa_1_N = mkN "noa" ; -- noa..nn.1
  noanamn_1_N = mkN "noanamn" neutrum  ; -- noanamn..nn.1
  noaord_1_N = mkN "noaord" neutrum  ; -- noaord..nn.1
  nobb_1_N = mkN "nobb" ; -- nobb..nn.1
  nobba_1_V = mkV "nobbar" ; -- nobba..vb.1
  nobbande_1_N = mkN "nobbande" ; -- nobbande..nn.1
  nobel_1_A = mkA "nobel" ; -- nobel..av.1
  nobelium_1_N = mkN "nobelium" neutrum  ; -- nobelium..nn.1
  nobelpris_1_N = mkN "nobelpris" neutrum  ; -- nobelpris..nn.1
  nobelpristagare_1_N = mkN "nobelpristagare" utrum  ; -- nobelpristagare..nn.1
  nobilisera_1_V = mkV "nobiliserar" ; -- nobilisera..vb.1
  nobiliserande_1_N = mkN "nobiliserande" ; -- nobiliserande..nn.1
  nobiliserbar_1_A = mkA "nobiliserbar" ; -- nobiliserbar..av.1
  nobiliserbarhet_1_N = mkN "nobiliserbarhet" ; -- nobiliserbarhet..nn.1
  nobilisering_1_N = mkN "nobilisering" ; -- nobilisering..nn.1
  nobless_1_N = mkN "nobless" ; -- nobless..nn.1
  nock_1_N = mkN "nock" ; -- nock..nn.1
  nocka_1_V = mkV "nockar" ; -- nocka..vb.1
  nockande_1_N = mkN "nockande" ; -- nockande..nn.1
  nockhöjd_1_N = mkN "nockhöjd" ; -- nockhöjd..nn.1
  nockout_1_N = mkN "nockout" "nockouter" ; -- nockout..nn.1
  nockås_1_N = mkN "nockås" ; -- nockås..nn.1
  nocturne_1_N = mkN "nocturne" "nocturner" ; -- nocturne..nn.1
  nod_1_N = mkN "nod" "noder" ; -- nod..nn.1
  nog_1_Adv = mkAdv "nog" ; -- nog..ab.1
  noga_1_Adv = mkAdv "noga" ; -- noga..ab.1
  noga_1_A = mkA "noga" ; -- noga..av.1
  nogav_1_Adv = mkAdv "nogav" ; -- nogav..ab.1
  noggrann_1_A = mkA "noggrann" "noggrant" ; -- noggrann..av.1
  noggrannhet_1_N = mkN "noggrannhet" "noggrannheter" ; -- noggrannhet..nn.1
  nogräknad_1_A = mkA "nogräknad" ; -- nogräknad..av.1
  noja_1_N = mkN "noja" ; -- noja..nn.1
  noja_1_V = mkV "nojar" ; -- noja..vb.1
  nojande_1_N = mkN "nojande" ; -- nojande..nn.1
  nojig_1_A = mkA "nojig" ; -- nojig..av.1
  nojighet_1_N = mkN "nojighet" "nojigheter" ; -- nojighet..nn.1
  nojja_1_N = mkN "nojja" ; -- nojja..nn.1
  nojja_1_V = mkV "nojjar" ; -- nojja..vb.1
  nojjig_1_A = mkA "nojjig" ; -- nojjig..av.1
  nojjighet_1_N = mkN "nojjighet" "nojjigheter" ; -- nojjighet..nn.1
  nojs_1_N = mkN "nojs" neutrum  ; -- nojs..nn.1
  nojsa_1_V = mkV "nojsar" ; -- nojsa..vb.1
  nojsande_1_N = mkN "nojsande" ; -- nojsande..nn.1
  nokturn_1_N = mkN "nokturn" "nokturner" ; -- nokturn..nn.1
  noll_1_N = mkN "noll" ; -- noll..nn.1
  nolla_1_N = mkN "nolla" ; -- nolla..nn.1
  nolla_1_V = mkV "nollar" ; -- nolla..vb.1
  nollalternativ_1_N = mkN "nollalternativ" neutrum  ; -- nollalternativ..nn.1
  nollande_1_N = mkN "nollande" ; -- nollande..nn.1
  nollcirkel_1_N = mkN "nollcirkel" ; -- nollcirkel..nn.1
  nolldimensionell_1_A = mkA "nolldimensionell" ; -- nolldimensionell..av.1
  nolledning_1_N = mkN "nolledning" ; -- nolledning..nn.1
  nollgradig_1_A = mkA "nollgradig" ; -- nollgradig..av.1
  nollkorrektur_1_N = mkN "nollkorrektur" neutrum  ; -- nollkorrektur..nn.1
  nollmeridian_1_N = mkN "nollmeridian" ; -- nollmeridian..nn.1
  nollmorfem_1_N = mkN "nollmorfem" neutrum  ; -- nollmorfem..nn.1
  nollning_1_N = mkN "nollning" ; -- nollning..nn.1
  nollnoll_tal_1_N = mkN "nollnoll-tal" neutrum  ; -- nollnoll-tal..nn.1
  nollnolltal_1_N = mkN "nollnolltal" neutrum  ; -- nollnolltal..nn.1
  nollplan_1_N = mkN "nollplan" neutrum  ; -- nollplan..nn.1
  nollpunkt_1_N = mkN "nollpunkt" "nollpunkter" ; -- nollpunkt..nn.1
  nollspant_1_N = mkN "nollspant" neutrum  ; -- nollspant..nn.1
  nollspänning_1_N = mkN "nollspänning" ; -- nollspänning..nn.1
  nollställa_1_V = mkV "nollställer" ; -- nollställa..vb.1
  nollställande_1_N = mkN "nollställande" ; -- nollställande..nn.1
  nollställe_1_N = mkN "nollställe" ; -- nollställe..nn.1
  nollsuffix_1_N = mkN "nollsuffix" neutrum  ; -- nollsuffix..nn.1
  nollsumma_1_N = mkN "nollsumma" ; -- nollsumma..nn.1
  nollsummespel_1_N = mkN "nollsummespel" "nollsummespelet" "nollsummespel" "nollsummespelen" ; -- nollsummespel..nn.1
  nolltaxa_1_N = mkN "nolltaxa" ; -- nolltaxa..nn.1
  nolltaxera_1_V = mkV "nolltaxerar" ; -- nolltaxera..vb.1
  nolltaxerande_1_N = mkN "nolltaxerande" ; -- nolltaxerande..nn.1
  nolltaxerare_1_N = mkN "nolltaxerare" utrum  ; -- nolltaxerare..nn.1
  nolltaxering_1_N = mkN "nolltaxering" ; -- nolltaxering..nn.1
  nollte_1_A = mkA "nollte" ; -- nollte..av.1
  nolltillväxt_1_N = mkN "nolltillväxt" ; -- nolltillväxt..nn.1
  nolltolerans_1_N = mkN "nolltolerans" ; -- nolltolerans..nn.1
  nollutsläpp_1_N = mkN "nollutsläpp" neutrum  ; -- nollutsläpp..nn.1
  nollvision_1_N = mkN "nollvision" ; -- nollvision..nn.1
  nollvisionär_1_N = mkN "nollvisionär" "nollvisionärer" ; -- nollvisionär..nn.1
  nolläge_1_N = mkN "nolläge" ; -- nolläge..nn.1
  noltig_1_A = mkA "noltig" ; -- noltig..av.1
  noltighet_1_N = mkN "noltighet" ; -- noltighet..nn.1
  nomad_1_N = mkN "nomad" "nomader" ; -- nomad..nn.1
  nomadfamilj_1_N = mkN "nomadfamilj" "nomadfamiljer" ; -- nomadfamilj..nn.1
  nomadfolk_1_N = mkN "nomadfolk" neutrum  ; -- nomadfolk..nn.1
  nomadhord_1_N = mkN "nomadhord" "nomadhorder" ; -- nomadhord..nn.1
  nomadisera_1_V = mkV "nomadiserar" ; -- nomadisera..vb.1
  nomadiserande_1_N = mkN "nomadiserande" ; -- nomadiserande..nn.1
  nomadisering_1_N = mkN "nomadisering" ; -- nomadisering..nn.1
  nomadisk_1_A = mkA "nomadisk" ; -- nomadisk..av.1
  nomadliv_1_N = mkN "nomadliv" neutrum  ; -- nomadliv..nn.1
  nomadläger_1_N = mkN "nomadläger" neutrum  ; -- nomadläger..nn.1
  nomadskola_1_N = mkN "nomadskola" ; -- nomadskola..nn.1
  nomadsystem_1_N = mkN "nomadsystem" neutrum  ; -- nomadsystem..nn.1
  nomen_1_N = mkN "nomen" neutrum  ; -- nomen..nn.1
  nomenklatur_1_N = mkN "nomenklatur" "nomenklaturer" ; -- nomenklatur..nn.1
  nominal_1_A = mkA "nominal" ; -- nominal..av.1
  nominalism_1_N = mkN "nominalism" "nominalismer" ; -- nominalism..nn.1
  nominalist_1_N = mkN "nominalist" "nominalister" ; -- nominalist..nn.1
  nominalistisk_1_A = mkA "nominalistisk" ; -- nominalistisk..av.1
  nominalkatalog_1_N = mkN "nominalkatalog" "nominalkataloger" ; -- nominalkatalog..nn.1
  nominallön_1_N = mkN "nominallön" "nominallöner" ; -- nominallön..nn.1
  nominalvärde_1_N = mkN "nominalvärde" ; -- nominalvärde..nn.1
  nominativ_1_N = mkN "nominativ" "nominativer" ; -- nominativ..nn.1
  nominativsubjekt_1_N = mkN "nominativsubjekt" neutrum  ; -- nominativsubjekt..nn.1
  nominell_1_A = mkA "nominell" ; -- nominell..av.1
  nominera_1_V = mkV "nominerar" ; -- nominera..vb.1
  nominerad_1_A = mkA "nominerad" ; -- nominerad..av.1
  nominerande_1_N = mkN "nominerande" ; -- nominerande..nn.1
  nominerbar_1_A = mkA "nominerbar" ; -- nominerbar..av.1
  nominerbarhet_1_N = mkN "nominerbarhet" ; -- nominerbarhet..nn.1
  nominering_1_N = mkN "nominering" ; -- nominering..nn.1
  nomineringstid_1_N = mkN "nomineringstid" "nomineringstider" ; -- nomineringstid..nn.1
  nomografi_1_N = mkN "nomografi" ; -- nomografi..nn.1
  nomogram_1_N = mkN "nomogram" "nomogrammet" "nomogram" "nomogrammen" ; -- nomogram..nn.1
  non_iron_1_A = mkA "non-iron" ; -- non-iron..av.1
  nona_1_N = mkN "nona" ; -- nona..nn.1
  nonaggression_1_N = mkN "nonaggression" ; -- nonaggression..nn.1
  nonaggressionsfördrag_1_N = mkN "nonaggressionsfördrag" neutrum  ; -- nonaggressionsfördrag..nn.1
  nonchalans_1_N = mkN "nonchalans" ; -- nonchalans..nn.1
  nonchalant_1_A = mkA "nonchalant" "nonchalant" ; -- nonchalant..av.1
  nonchalera_1_V = mkV "nonchalerar" ; -- nonchalera..vb.1
  nonchalerande_1_N = mkN "nonchalerande" ; -- nonchalerande..nn.1
  nonchalerbar_1_A = mkA "nonchalerbar" ; -- nonchalerbar..av.1
  nonchalerbarhet_1_N = mkN "nonchalerbarhet" ; -- nonchalerbarhet..nn.1
  nonchalering_1_N = mkN "nonchalering" ; -- nonchalering..nn.1
  nonfigurativ_1_A = mkA "nonfigurativ" ; -- nonfigurativ..av.1
  nonie_1_N = mkN "nonie" "nonier" ; -- nonie..nn.1
  nonintervention_1_N = mkN "nonintervention" ; -- nonintervention..nn.1
  nonkombattant_1_N = mkN "nonkombattant" "nonkombattanter" ; -- nonkombattant..nn.1
  nonkonformism_1_N = mkN "nonkonformism" "nonkonformismer" ; -- nonkonformism..nn.1
  nonkonformist_1_N = mkN "nonkonformist" "nonkonformister" ; -- nonkonformist..nn.1
  nonkonformistisk_1_A = mkA "nonkonformistisk" ; -- nonkonformistisk..av.1
  nonpareil_1_N = mkN "nonpareil" ; -- nonpareil..nn.1
  nonpareille_1_N = mkN "nonpareille" utrum  ; -- nonpareille..nn.1
  nonsens_1_N = mkN "nonsens" ; -- nonsens..nn.1
  nonsensprat_1_N = mkN "nonsensprat" neutrum  ; -- nonsensprat..nn.1
  nonsensvers_1_N = mkN "nonsensvers" "nonsensverser" ; -- nonsensvers..nn.1
  nonstopflyg_1_N = mkN "nonstopflyg" neutrum  ; -- nonstopflyg..nn.1
  nopp_1_N = mkN "nopp" ; -- nopp..nn.1
  noppa_1_N = mkN "noppa" ; -- noppa..nn.1
  noppa_1_V = mkV "noppar" ; -- noppa..vb.1
  noppande_1_N = mkN "noppande" ; -- noppande..nn.1
  noppig_1_A = mkA "noppig" ; -- noppig..av.1
  noppighet_1_N = mkN "noppighet" ; -- noppighet..nn.1
  noppra_1_N = mkN "noppra" ; -- noppra..nn.1
  noppra_1_V = mkV "nopprar" ; -- noppra..vb.1
  nopprig_1_A = mkA "nopprig" ; -- nopprig..av.1
  nor_1_N = mkN "nor" neutrum  ; -- nor..nn.1
  noradrenalin_1_N = mkN "noradrenalin" "noradrenaliner" ; -- noradrenalin..nn.1
  nord_sydlig_1_A = mkA "nord-sydlig" ; -- nord-sydlig..av.1
  nord_1_N = mkN "nord" ; -- nord..nn.1
  nordafrikansk_1_A = mkA "nordafrikansk" ; -- nordafrikansk..av.1
  nordamerikan_1_N = mkN "nordamerikan" "nordamerikaner" ; -- nordamerikan..nn.1
  nordamerikanare_1_N = mkN "nordamerikanare" utrum  ; -- nordamerikanare..nn.1
  nordamerikansk_1_A = mkA "nordamerikansk" ; -- nordamerikansk..av.1
  nordanland_1_N = mkN "nordanland" neutrum  ; -- nordanland..nn.1
  nordanskog_1_N = mkN "nordanskog" ; -- nordanskog..nn.1
  nordanstorm_1_N = mkN "nordanstorm" ; -- nordanstorm..nn.1
  nordanvind_1_N = mkN "nordanvind" ; -- nordanvind..nn.1
  nordatlantisk_1_A = mkA "nordatlantisk" ; -- nordatlantisk..av.1
  nordbo_1_N = mkN "nordbo" "nordbor" ; -- nordbo..nn.1
  nordeuropeisk_1_A = mkA "nordeuropeisk" ; -- nordeuropeisk..av.1
  nordfransk_1_A = mkA "nordfransk" ; -- nordfransk..av.1
  nordgräns_1_N = mkN "nordgräns" "nordgränser" ; -- nordgräns..nn.1
  nordirländsk_1_A = mkA "nordirländsk" ; -- nordirländsk..av.1
  nordisk_1_A = mkA "nordisk" ; -- nordisk..av.1
  nordism_1_N = mkN "nordism" "nordismer" ; -- nordism..nn.1
  nordist_1_N = mkN "nordist" "nordister" ; -- nordist..nn.1
  nordistisk_1_A = mkA "nordistisk" ; -- nordistisk..av.1
  norditaliensk_1_A = mkA "norditaliensk" ; -- norditaliensk..av.1
  nordjemenit_1_N = mkN "nordjemenit" "nordjemeniter" ; -- nordjemenit..nn.1
  nordkorean_1_N = mkN "nordkorean" "nordkoreaner" ; -- nordkorean..nn.1
  nordkoreansk_1_A = mkA "nordkoreansk" ; -- nordkoreansk..av.1
  nordkoreanska_1_N = mkN "nordkoreanska" ; -- nordkoreanska..nn.1
  nordkust_1_N = mkN "nordkust" "nordkuster" ; -- nordkust..nn.1
  nordlig_1_A = mkA "nordlig" ; -- nordlig..av.1
  nordman_1_N = mkN "nordman" "nordmannen" "nordmän" "nordmännen" ; -- nordman..nn.1
  nordnordost_1_Adv = mkAdv "nordnordost" ; -- nordnordost..ab.1
  nordnordostlig_1_A = mkA "nordnordostlig" ; -- nordnordostlig..av.1
  nordnordväst_1_Adv = mkAdv "nordnordväst" ; -- nordnordväst..ab.1
  nordnordvästlig_1_A = mkA "nordnordvästlig" ; -- nordnordvästlig..av.1
  nordnorsk_1_A = mkA "nordnorsk" ; -- nordnorsk..av.1
  nordost_1_N = mkN "nordost" ; -- nordost..nn.1
  nordostlig_1_A = mkA "nordostlig" ; -- nordostlig..av.1
  nordostpassage_1_N = mkN "nordostpassage" utrum  ; -- nordostpassage..nn.1
  nordpol_1_N = mkN "nordpol" "nordpoler" ; -- nordpol..nn.1
  nordpå_1_Adv = mkAdv "nordpå" ; -- nordpå..ab.1
  nordsamisk_1_A = mkA "nordsamisk" ; -- nordsamisk..av.1
  nordsamiska_1_N = mkN "nordsamiska" ; -- nordsamiska..nn.1
  nordsida_1_N = mkN "nordsida" ; -- nordsida..nn.1
  nordsjöfart_1_N = mkN "nordsjöfart" ; -- nordsjöfart..nn.1
  nordsluttning_1_N = mkN "nordsluttning" ; -- nordsluttning..nn.1
  nordstjärna_1_N = mkN "nordstjärna" ; -- nordstjärna..nn.1
  nordstjärneorden_1_N = mkN "nordstjärneorden" ; -- nordstjärneorden..nn.1
  nordsvensk_1_A = mkA "nordsvensk" ; -- nordsvensk..av.1
  nordsvensk_1_N = mkN "nordsvensk" ; -- nordsvensk..nn.1
  nordsydlig_1_A = mkA "nordsydlig" ; -- nordsydlig..av.1
  nordtysk_1_A = mkA "nordtysk" ; -- nordtysk..av.1
  nordvart_1_Adv = mkAdv "nordvart" ; -- nordvart..ab.1
  nordvietnamesisk_1_A = mkA "nordvietnamesisk" ; -- nordvietnamesisk..av.1
  nordväst_1_N = mkN "nordväst" ; -- nordväst..nn.1
  nordvästlig_1_A = mkA "nordvästlig" ; -- nordvästlig..av.1
  nordvästra_1_A = mkA "nordvästra" ; -- nordvästra..av.1
  nordyemenit_1_N = mkN "nordyemenit" "nordyemeniter" ; -- nordyemenit..nn.1
  nordöst_1_N = mkN "nordöst" ; -- nordöst..nn.1
  nordöstlig_1_A = mkA "nordöstlig" ; -- nordöstlig..av.1
  nordöstra_1_A = mkA "nordöstra" ; -- nordöstra..av.1
  norepinefrin_1_N = mkN "norepinefrin" "norepinefriner" ; -- norepinefrin..nn.1
  norm_1_N = mkN "norm" "normer" ; -- norm..nn.1
  normal_1_A = mkA "normal" ; -- normal..av.1
  normal_1_N = mkN "normal" "normaler" ; -- normal..nn.1
  normalbegåvad_1_A = mkA "normalbegåvad" ; -- normalbegåvad..av.1
  normalbild_1_N = mkN "normalbild" "normalbilder" ; -- normalbild..nn.1
  normalblyg_1_A = mkA "normalblyg" ; -- normalblyg..av.1
  normalblyghet_1_N = mkN "normalblyghet" ; -- normalblyghet..nn.1
  normalfilm_1_N = mkN "normalfilm" "normalfilmer" ; -- normalfilm..nn.1
  normalfärg_1_N = mkN "normalfärg" "normalfärger" ; -- normalfärg..nn.1
  normalfördelad_1_A = mkA "normalfördelad" ; -- normalfördelad..av.1
  normalfördelning_1_N = mkN "normalfördelning" ; -- normalfördelning..nn.1
  normalförfarande_1_N = mkN "normalförfarande" ; -- normalförfarande..nn.1
  normalgård_1_N = mkN "normalgård" ; -- normalgård..nn.1
  normalisera_1_V = mkV "normaliserar" ; -- normalisera..vb.1
  normaliserande_1_N = mkN "normaliserande" ; -- normaliserande..nn.1
  normaliserbar_1_A = mkA "normaliserbar" ; -- normaliserbar..av.1
  normaliserbarhet_1_N = mkN "normaliserbarhet" ; -- normaliserbarhet..nn.1
  normalisering_1_N = mkN "normalisering" ; -- normalisering..nn.1
  normaliseringsprocess_1_N = mkN "normaliseringsprocess" "normaliseringsprocesser" ; -- normaliseringsprocess..nn.1
  normaliseringsvåg_1_N = mkN "normaliseringsvåg" "normaliseringsvågor" ; -- normaliseringsvåg..nn.1
  normalitet_1_N = mkN "normalitet" "normaliteter" ; -- normalitet..nn.1
  normalkraft_1_N = mkN "normalkraft" ; -- normalkraft..nn.1
  normalmånad_1_N = mkN "normalmånad" "normalmånader" ; -- normalmånad..nn.1
  normalmått_1_N = mkN "normalmått" neutrum  ; -- normalmått..nn.1
  normalobjektiv_1_N = mkN "normalobjektiv" neutrum  ; -- normalobjektiv..nn.1
  normalpotential_1_N = mkN "normalpotential" ; -- normalpotential..nn.1
  normalprosa_1_N = mkN "normalprosa" ; -- normalprosa..nn.1
  normalskolekompetens_1_N = mkN "normalskolekompetens" ; -- normalskolekompetens..nn.1
  normalspårig_1_A = mkA "normalspårig" ; -- normalspårig..av.1
  normalstor_1_A = mkA "normalstor" ; -- normalstor..av.1
  normalstudietid_1_N = mkN "normalstudietid" "normalstudietider" ; -- normalstudietid..nn.1
  normaltid_1_N = mkN "normaltid" "normaltider" ; -- normaltid..nn.1
  normaltillstånd_1_N = mkN "normaltillstånd" neutrum  ; -- normaltillstånd..nn.1
  normalton_1_N = mkN "normalton" "normaltoner" ; -- normalton..nn.1
  normaltryck_1_N = mkN "normaltryck" neutrum  ; -- normaltryck..nn.1
  normalvikt_1_N = mkN "normalvikt" "normalvikter" ; -- normalvikt..nn.1
  normalviktig_1_A = mkA "normalviktig" ; -- normalviktig..av.1
  normalår_1_N = mkN "normalår" neutrum  ; -- normalår..nn.1
  normand_1_N = mkN "normand" "normander" ; -- normand..nn.1
  normandisk_1_A = mkA "normandisk" ; -- normandisk..av.1
  normativ_1_A = mkA "normativ" ; -- normativ..av.1
  normera_1_V = mkV "normerar" ; -- normera..vb.1
  normerande_1_A = mkA "normerande" ; -- normerande..av.1
  normerande_1_N = mkN "normerande" ; -- normerande..nn.1
  normerbar_1_A = mkA "normerbar" ; -- normerbar..av.1
  normerbarhet_1_N = mkN "normerbarhet" ; -- normerbarhet..nn.1
  normering_1_N = mkN "normering" ; -- normering..nn.1
  normgivande_1_A = mkA "normgivande" ; -- normgivande..av.1
  normlös_1_A = mkA "normlös" ; -- normlös..av.1
  normlöshet_1_N = mkN "normlöshet" "normlösheter" ; -- normlöshet..nn.1
  normsystem_1_N = mkN "normsystem" neutrum  ; -- normsystem..nn.1
  normupplösning_1_N = mkN "normupplösning" ; -- normupplösning..nn.1
  norna_1_N = mkN "norna" ; -- norna..nn.1
  norna_2_N = mkN "norna" ; -- norna..nn.2
  norpa_1_V = mkV "norpar" ; -- norpa..vb.1
  norpande_1_N = mkN "norpande" ; -- norpande..nn.1
  norr_1_Adv = mkAdv "norr" ; -- norr..ab.1
  norr_1_N = mkN "norr" ; -- norr..nn.1
  norra_1_A = mkA "norra" ; -- norra..av.1
  norrbagge_1_N = mkN "norrbagge" utrum  ; -- norrbagge..nn.1
  norrbottning_1_N = mkN "norrbottning" ; -- norrbottning..nn.1
  norrbottnisk_1_A = mkA "norrbottnisk" ; -- norrbottnisk..av.1
  norrbottniska_1_N = mkN "norrbottniska" ; -- norrbottniska..nn.1
  norrbottniska_2_N = mkN "norrbottniska" ; -- norrbottniska..nn.2
  norrgående_1_A = mkA "norrgående" ; -- norrgående..av.1
  norrgök_1_N = mkN "norrgök" ; -- norrgök..nn.1
  norrifrån_1_Adv = mkAdv "norrifrån" ; -- norrifrån..ab.1
  norrkvint_1_N = mkN "norrkvint" ; -- norrkvint..nn.1
  norrköpingsnäsa_1_N = mkN "norrköpingsnäsa" ; -- norrköpingsnäsa..nn.1
  norrlandshäst_1_N = mkN "norrlandshäst" ; -- norrlandshäst..nn.1
  norrlandsälv_1_N = mkN "norrlandsälv" ; -- norrlandsälv..nn.1
  norrländsk_1_A = mkA "norrländsk" ; -- norrländsk..av.1
  norrländska_1_N = mkN "norrländska" ; -- norrländska..nn.1
  norrländska_2_N = mkN "norrländska" ; -- norrländska..nn.2
  norrlänning_1_N = mkN "norrlänning" ; -- norrlänning..nn.1
  norrman_1_N = mkN "norrman" "norrmannen" "norrmän" "norrmännen" ; -- norrman..nn.1
  norrpå_1_Adv = mkAdv "norrpå" ; -- norrpå..ab.1
  norrsida_1_N = mkN "norrsida" ; -- norrsida..nn.1
  norrsken_1_N = mkN "norrsken" neutrum  ; -- norrsken..nn.1
  norrskensupplevelse_1_N = mkN "norrskensupplevelse" "norrskensupplevelser" ; -- norrskensupplevelse..nn.1
  norrut_1_Adv = mkAdv "norrut" ; -- norrut..ab.1
  norrön_1_A = mkA "norrön" ; -- norrön..av.1
  norröver_1_Adv = mkAdv "norröver" ; -- norröver..ab.1
  nors_1_N = mkN "nors" ; -- nors..nn.1
  norsk_1_A = mkA "norsk" ; -- norsk..av.1
  norska_1_N = mkN "norska" ; -- norska..nn.1
  norska_2_N = mkN "norska" ; -- norska..nn.2
  norskhet_1_N = mkN "norskhet" ; -- norskhet..nn.1
  norsktalande_1_A = mkA "norsktalande" ; -- norsktalande..av.1
  norsktillverkad_1_A = mkA "norsktillverkad" ; -- norsktillverkad..av.1
  norskägd_1_A = mkA "norskägd" "norskägt" ; -- norskägd..av.1
  norvagism_1_N = mkN "norvagism" "norvagismer" ; -- norvagism..nn.1
  nos_1_N = mkN "nos" ; -- nos..nn.1
  nosa_1_V = mkV "nosar" ; -- nosa..vb.1
  nosande_1_N = mkN "nosande" ; -- nosande..nn.1
  nosgrimma_1_N = mkN "nosgrimma" ; -- nosgrimma..nn.1
  noshjul_1_N = mkN "noshjul" neutrum  ; -- noshjul..nn.1
  noshörning_1_N = mkN "noshörning" ; -- noshörning..nn.1
  noshörningsbebis_1_N = mkN "noshörningsbebis" ; -- noshörningsbebis..nn.1
  noshörningshorn_1_N = mkN "noshörningshorn" neutrum  ; -- noshörningshorn..nn.1
  noshörningskalv_1_N = mkN "noshörningskalv" ; -- noshörningskalv..nn.1
  noshörningsunge_1_N = mkN "noshörningsunge" utrum  ; -- noshörningsunge..nn.1
  nosig_1_A = mkA "nosig" ; -- nosig..av.1
  nosighet_1_N = mkN "nosighet" "nosigheter" ; -- nosighet..nn.1
  noskig_1_A = mkA "noskig" ; -- noskig..av.1
  noskighet_1_N = mkN "noskighet" "noskigheter" ; -- noskighet..nn.1
  noskon_1_N = mkN "noskon" "noskoner" ; -- noskon..nn.1
  noskorg_1_N = mkN "noskorg" ; -- noskorg..nn.1
  noslängd_1_N = mkN "noslängd" "noslängder" ; -- noslängd..nn.1
  nosregion_1_N = mkN "nosregion" ; -- nosregion..nn.1
  nosring_1_N = mkN "nosring" ; -- nosring..nn.1
  nosserot_1_N = mkN "nosserot" ; -- nosserot..nn.1
  nosspets_1_N = mkN "nosspets" ; -- nosspets..nn.1
  nostalgi_1_N = mkN "nostalgi" "nostalgier" ; -- nostalgi..nn.1
  nostalgiker_1_N = mkN "nostalgiker" "nostalgikern" "nostalgiker" "nostalgikerna" ; -- nostalgiker..nn.1
  nostalgipjäs_1_N = mkN "nostalgipjäs" "nostalgipjäser" ; -- nostalgipjäs..nn.1
  nostalgisk_1_A = mkA "nostalgisk" ; -- nostalgisk..av.1
  nostalgitripp_1_N = mkN "nostalgitripp" ; -- nostalgitripp..nn.1
  not_1_N = mkN "not" "noter" ; -- not..nn.1
  not_2_N = mkN "not" ; -- not..nn.2
  nota_1_N = mkN "nota" ; -- nota..nn.1
  nota_1_V = mkV "notar" ; -- nota..vb.1
  notabel_1_A = mkA "notabel" ; -- notabel..av.1
  notabilitet_1_N = mkN "notabilitet" "notabiliteter" ; -- notabilitet..nn.1
  notande_1_N = mkN "notande" ; -- notande..nn.1
  notariat_1_N = mkN "notariat" neutrum  ; -- notariat..nn.1
  notariatavdelning_1_N = mkN "notariatavdelning" ; -- notariatavdelning..nn.1
  notarie_1_N = mkN "notarie" "notarier" ; -- notarie..nn.1
  notation_1_N = mkN "notation" ; -- notation..nn.1
  notblad_1_N = mkN "notblad" neutrum  ; -- notblad..nn.1
  notdragning_1_N = mkN "notdragning" ; -- notdragning..nn.1
  notdräkt_1_N = mkN "notdräkt" "notdräkter" ; -- notdräkt..nn.1
  notera_1_V = mkV "noterar" ; -- notera..vb.1
  noterande_1_N = mkN "noterande" ; -- noterande..nn.1
  noterbar_1_A = mkA "noterbar" ; -- noterbar..av.1
  noterbarhet_1_N = mkN "noterbarhet" ; -- noterbarhet..nn.1
  notering_1_N = mkN "notering" ; -- notering..nn.1
  notesblock_1_N = mkN "notesblock" neutrum  ; -- notesblock..nn.1
  notfast_1_A = mkA "notfast" "notfast" ; -- notfast..av.1
  notfjäder_1_N = mkN "notfjäder" ; -- notfjäder..nn.1
  notificera_1_V = mkV "notificerar" ; -- notificera..vb.1
  notificerande_1_N = mkN "notificerande" ; -- notificerande..nn.1
  notificerbar_1_A = mkA "notificerbar" ; -- notificerbar..av.1
  notificerbarhet_1_N = mkN "notificerbarhet" ; -- notificerbarhet..nn.1
  notificering_1_N = mkN "notificering" ; -- notificering..nn.1
  notifiera_1_V = mkV "notifierar" ; -- notifiera..vb.1
  notifierande_1_N = mkN "notifierande" ; -- notifierande..nn.1
  notifierbar_1_A = mkA "notifierbar" ; -- notifierbar..av.1
  notifierbarhet_1_N = mkN "notifierbarhet" ; -- notifierbarhet..nn.1
  notifiering_1_N = mkN "notifiering" ; -- notifiering..nn.1
  notifikation_1_N = mkN "notifikation" ; -- notifikation..nn.1
  notis_1_N = mkN "notis" "notiser" ; -- notis..nn.1
  notisera_1_V = mkV "notiserar" ; -- notisera..vb.1
  notiserande_1_N = mkN "notiserande" ; -- notiserande..nn.1
  notiserbar_1_A = mkA "notiserbar" ; -- notiserbar..av.1
  notiserbarhet_1_N = mkN "notiserbarhet" ; -- notiserbarhet..nn.1
  notisering_1_N = mkN "notisering" ; -- notisering..nn.1
  notlag_1_N = mkN "notlag" neutrum  ; -- notlag..nn.1
  notlinje_1_N = mkN "notlinje" "notlinjer" ; -- notlinje..nn.1
  notorietet_1_N = mkN "notorietet" "notorieteter" ; -- notorietet..nn.1
  notorisk_1_A = mkA "notorisk" ; -- notorisk..av.1
  nototenioid_1_N = mkN "nototenioid" "nototenioider" ; -- nototenioid..nn.1
  notpapper_1_N = mkN "notpapper" neutrum  ; -- notpapper..nn.1
  notplan_1_N = mkN "notplan" neutrum  ; -- notplan..nn.1
  notrad_1_N = mkN "notrad" "notrader" ; -- notrad..nn.1
  notsiffra_1_N = mkN "notsiffra" ; -- notsiffra..nn.1
  notskrift_1_N = mkN "notskrift" ; -- notskrift..nn.1
  notskriftstecken_1_N = mkN "notskriftstecken" "notskriftstecknet" "notskriftstecken" "notskriftstecknen" ; -- notskriftstecken..nn.1
  notställ_1_N = mkN "notställ" neutrum  ; -- notställ..nn.1
  notstål_1_N = mkN "notstål" neutrum  ; -- notstål..nn.1
  notsäker_1_A = mkA "notsäker" ; -- notsäker..av.1
  notsäkerhet_1_N = mkN "notsäkerhet" ; -- notsäkerhet..nn.1
  nottecken_1_N = mkN "nottecken" "nottecknet" "nottecken" "nottecknen" ; -- nottecken..nn.1
  notvarp_1_N = mkN "notvarp" neutrum  ; -- notvarp..nn.1
  notvändare_1_N = mkN "notvändare" utrum  ; -- notvändare..nn.1
  notväxling_1_N = mkN "notväxling" ; -- notväxling..nn.1
  nougat_1_N = mkN "nougat" "nougater" ; -- nougat..nn.1
  nova_1_N = mkN "nova" ; -- nova..nn.1
  novantik_1_A = mkA "novantik" ; -- novantik..av.1
  novation_1_N = mkN "novation" ; -- novation..nn.1
  novautbrott_1_N = mkN "novautbrott" neutrum  ; -- novautbrott..nn.1
  novell_1_N = mkN "novell" "noveller" ; -- novell..nn.1
  novellett_1_N = mkN "novellett" "novelletter" ; -- novellett..nn.1
  novellist_1_N = mkN "novellist" "novellister" ; -- novellist..nn.1
  novellistik_1_N = mkN "novellistik" ; -- novellistik..nn.1
  novellistisk_1_A = mkA "novellistisk" ; -- novellistisk..av.1
  novellpristävling_1_N = mkN "novellpristävling" ; -- novellpristävling..nn.1
  novellsamling_1_N = mkN "novellsamling" ; -- novellsamling..nn.1
  november_1_N = mkN "november" ; -- november..nn.1
  novembergrå_1_A = mkA "novembergrå" "novembergrått" ; -- novembergrå..av.1
  novemberkväll_1_N = mkN "novemberkväll" ; -- novemberkväll..nn.1
  novembermörker_1_N = mkN "novembermörker" neutrum  ; -- novembermörker..nn.1
  novemberskymning_1_N = mkN "novemberskymning" ; -- novemberskymning..nn.1
  novis_1_N = mkN "novis" "noviser" ; -- novis..nn.1
  novitet_1_N = mkN "novitet" "noviteter" ; -- novitet..nn.1
  novitiat_1_N = mkN "novitiat" neutrum  ; -- novitiat..nn.1
  nu_1_N = mkN "nu" neutrum  ; -- nu..nn.1
  nubb_1_N = mkN "nubb" neutrum  ; -- nubb..nn.1
  nubba_1_V = mkV "nubbar" ; -- nubba..vb.1
  nubba_2_V = mkV "nubbar" ; -- nubba..vb.2
  nubbande_1_N = mkN "nubbande" ; -- nubbande..nn.1
  nubbe_1_N = mkN "nubbe" utrum  ; -- nubbe..nn.1
  nubbevisa_1_N = mkN "nubbevisa" ; -- nubbevisa..nn.1
  nubier_1_N = mkN "nubier" "nubiern" "nubier" "nubierna" ; -- nubier..nn.1
  nubisk_1_A = mkA "nubisk" ; -- nubisk..av.1
  nucka_1_N = mkN "nucka" ; -- nucka..nn.1
  nuckig_1_A = mkA "nuckig" ; -- nuckig..av.1
  nuckighet_1_N = mkN "nuckighet" ; -- nuckighet..nn.1
  nudda_1_V = mkV "nuddar" ; -- nudda..vb.1
  nuddande_1_N = mkN "nuddande" ; -- nuddande..nn.1
  nudel_1_N = mkN "nudel" ; -- nudel..nn.1
  nudelwok_1_N = mkN "nudelwok" ; -- nudelwok..nn.1
  nudism_1_N = mkN "nudism" "nudismer" ; -- nudism..nn.1
  nudist_1_N = mkN "nudist" "nudister" ; -- nudist..nn.1
  nudistisk_1_A = mkA "nudistisk" ; -- nudistisk..av.1
  nuditet_1_N = mkN "nuditet" "nuditeter" ; -- nuditet..nn.1
  nuffra_1_N = mkN "nuffra" ; -- nuffra..nn.1
  nuförtiden_1_Adv = mkAdv "nuförtiden" ; -- nuförtiden..ab.1
  nugat_1_N = mkN "nugat" "nugater" ; -- nugat..nn.1
  nukleid_1_N = mkN "nukleid" "nukleider" ; -- nukleid..nn.1
  nuklein_1_N = mkN "nuklein" neutrum  ; -- nuklein..nn.1
  nukleinsyra_1_N = mkN "nukleinsyra" ; -- nukleinsyra..nn.1
  nukleon_1_N = mkN "nukleon" "nukleoner" ; -- nukleon..nn.1
  nukleontal_1_N = mkN "nukleontal" neutrum  ; -- nukleontal..nn.1
  nukleotid_1_N = mkN "nukleotid" "nukleotider" ; -- nukleotid..nn.1
  nukleär_1_A = mkA "nukleär" ; -- nukleär..av.1
  nuklid_1_N = mkN "nuklid" "nuklider" ; -- nuklid..nn.1
  nulevande_1_A = mkA "nulevande" ; -- nulevande..av.1
  nullitet_1_N = mkN "nullitet" "nulliteter" ; -- nullitet..nn.1
  nuläge_1_N = mkN "nuläge" ; -- nuläge..nn.1
  numen_1_N = mkN "numen" ; -- numen..nn.1
  numer_1_Adv = mkAdv "numer" ; -- numer..ab.1
  numera_1_Adv = mkAdv "numera" ; -- numera..ab.1
  numerisk_1_A = mkA "numerisk" ; -- numerisk..av.1
  numerus_1_N = mkN "numerus" neutrum  ; -- numerus..nn.1
  numerär_1_A = mkA "numerär" ; -- numerär..av.1
  numerär_1_N = mkN "numerär" "numerärer" ; -- numerär..nn.1
  numinös_1_A = mkA "numinös" ; -- numinös..av.1
  numismatik_1_N = mkN "numismatik" ; -- numismatik..nn.1
  numismatiker_1_N = mkN "numismatiker" "numismatikern" "numismatiker" "numismatikerna" ; -- numismatiker..nn.1
  numismatisk_1_A = mkA "numismatisk" ; -- numismatisk..av.1
  nummen_1_A = mkA "nummen" "nummet" "numna" "numna" "numnare" "numnast" "numnaste" ; -- nummen..av.1
  nummer_1_N = mkN "nummer" neutrum  ; -- nummer..nn.1
  nummerbricka_1_N = mkN "nummerbricka" ; -- nummerbricka..nn.1
  nummerbyrå_1_N = mkN "nummerbyrå" "nummerbyråer" ; -- nummerbyrå..nn.1
  nummerflicka_1_N = mkN "nummerflicka" ; -- nummerflicka..nn.1
  nummerföljd_1_N = mkN "nummerföljd" "nummerföljder" ; -- nummerföljd..nn.1
  nummerhäst_1_N = mkN "nummerhäst" ; -- nummerhäst..nn.1
  nummerkarl_1_N = mkN "nummerkarl" ; -- nummerkarl..nn.1
  nummerlapp_1_N = mkN "nummerlapp" ; -- nummerlapp..nn.1
  nummerordning_1_N = mkN "nummerordning" ; -- nummerordning..nn.1
  nummerplåt_1_N = mkN "nummerplåt" ; -- nummerplåt..nn.1
  nummerpresentatör_1_N = mkN "nummerpresentatör" "nummerpresentatörer" ; -- nummerpresentatör..nn.1
  nummerrevy_1_N = mkN "nummerrevy" "nummerrevyer" ; -- nummerrevy..nn.1
  nummerskiva_1_N = mkN "nummerskiva" ; -- nummerskiva..nn.1
  nummerskylt_1_N = mkN "nummerskylt" ; -- nummerskylt..nn.1
  nummerskyltsbelysning_1_N = mkN "nummerskyltsbelysning" ; -- nummerskyltsbelysning..nn.1
  nummertavla_1_N = mkN "nummertavla" ; -- nummertavla..nn.1
  numrera_1_V = mkV "numrerar" ; -- numrera..vb.1
  numrerande_1_N = mkN "numrerande" ; -- numrerande..nn.1
  numrerbar_1_A = mkA "numrerbar" ; -- numrerbar..av.1
  numrerbarhet_1_N = mkN "numrerbarhet" ; -- numrerbarhet..nn.1
  numrering_1_N = mkN "numrering" ; -- numrering..nn.1
  numro_1_N = mkN "numro" ; -- numro..nn.1
  nuna_1_N = mkN "nuna" ; -- nuna..nn.1
  nunatack_1_N = mkN "nunatack" "nunatacker" ; -- nunatack..nn.1
  nunatak_1_N = mkN "nunatak" "nunataker" ; -- nunatak..nn.1
  nunna_1_N = mkN "nunna" ; -- nunna..nn.1
  nunnedok_1_N = mkN "nunnedok" neutrum  ; -- nunnedok..nn.1
  nunneklädsel_1_N = mkN "nunneklädsel" ; -- nunneklädsel..nn.1
  nunneorden_1_N = mkN "nunneorden" ; -- nunneorden..nn.1
  nunneört_1_N = mkN "nunneört" "nunneörter" ; -- nunneört..nn.1
  nuntiatur_1_N = mkN "nuntiatur" "nuntiaturer" ; -- nuntiatur..nn.1
  nuntie_1_N = mkN "nuntie" "nuntier" ; -- nuntie..nn.1
  nuppa_1_V = mkV "nuppar" ; -- nuppa..vb.1
  nuppande_1_N = mkN "nuppande" ; -- nuppande..nn.1
  nuppning_1_N = mkN "nuppning" ; -- nuppning..nn.1
  nuspråklig_1_A = mkA "nuspråklig" ; -- nuspråklig..av.1
  nuspråklighet_1_N = mkN "nuspråklighet" "nuspråkligheter" ; -- nuspråklighet..nn.1
  nusvensk_1_A = mkA "nusvensk" ; -- nusvensk..av.1
  nusvenska_1_N = mkN "nusvenska" ; -- nusvenska..nn.1
  nutid_1_N = mkN "nutid" ; -- nutid..nn.1
  nutida_1_A = mkA "nutida" ; -- nutida..av.1
  nutidsfixerad_1_A = mkA "nutidsfixerad" ; -- nutidsfixerad..av.1
  nutidshistoria_1_N = mkN "nutidshistoria" "nutidshistorian" "nutidshistorier" "nutidshistorierna" ; -- nutidshistoria..nn.1
  nutidsmänniska_1_N = mkN "nutidsmänniska" ; -- nutidsmänniska..nn.1
  nutidsorienterad_1_A = mkA "nutidsorienterad" ; -- nutidsorienterad..av.1
  nutidsorientering_1_N = mkN "nutidsorientering" ; -- nutidsorientering..nn.1
  nutidsskildring_1_N = mkN "nutidsskildring" ; -- nutidsskildring..nn.1
  nutidstest_1_N = mkN "nutidstest" neutrum  ; -- nutidstest..nn.1
  nutilldags_1_Adv = mkAdv "nutilldags" ; -- nutilldags..ab.1
  nutria_1_N = mkN "nutria" ; -- nutria..nn.1
  nutrition_1_N = mkN "nutrition" ; -- nutrition..nn.1
  nutritionist_1_N = mkN "nutritionist" "nutritionister" ; -- nutritionist..nn.1
  nutritionsorgan_1_N = mkN "nutritionsorgan" neutrum  ; -- nutritionsorgan..nn.1
  nutritiv_1_A = mkA "nutritiv" ; -- nutritiv..av.1
  nuvarande_1_A = mkA "nuvarande" ; -- nuvarande..av.1
  nuvig_1_A = mkA "nuvig" ; -- nuvig..av.1
  ny_1_A = mkA "ny" "nytt" ; -- ny..av.1
  ny_1_N = mkN "ny" ; -- ny..nn.1
  ny_2_N = mkN "ny" neutrum  ; -- ny..nn.2
  nyagnad_1_A = mkA "nyagnad" ; -- nyagnad..av.1
  nyandlig_1_A = mkA "nyandlig" ; -- nyandlig..av.1
  nyanlägga_1_V = mkV "nyanlägga" "nyanla" "nyanlagt" ; -- nyanlägga..vb.1
  nyanläggande_1_N = mkN "nyanläggande" ; -- nyanläggande..nn.1
  nyanläggning_1_N = mkN "nyanläggning" ; -- nyanläggning..nn.1
  nyanländ_1_A = mkA "nyanländ" ; -- nyanländ..av.1
  nyans_1_N = mkN "nyans" "nyanser" ; -- nyans..nn.1
  nyansera_1_V = mkV "nyanserar" ; -- nyansera..vb.1
  nyanserad_1_A = mkA "nyanserad" ; -- nyanserad..av.1
  nyanserande_1_N = mkN "nyanserande" ; -- nyanserande..nn.1
  nyanserbar_1_A = mkA "nyanserbar" ; -- nyanserbar..av.1
  nyanserbarhet_1_N = mkN "nyanserbarhet" ; -- nyanserbarhet..nn.1
  nyansering_1_N = mkN "nyansering" ; -- nyansering..nn.1
  nyanseringstecken_1_N = mkN "nyanseringstecken" "nyanseringstecknet" "nyanseringstecken" "nyanseringstecknen" ; -- nyanseringstecken..nn.1
  nyanskaffa_1_V = mkV "nyanskaffar" ; -- nyanskaffa..vb.1
  nyanskaffande_1_N = mkN "nyanskaffande" ; -- nyanskaffande..nn.1
  nyanskaffning_1_N = mkN "nyanskaffning" ; -- nyanskaffning..nn.1
  nyanslös_1_A = mkA "nyanslös" ; -- nyanslös..av.1
  nyanslöshet_1_N = mkN "nyanslöshet" "nyanslösheter" ; -- nyanslöshet..nn.1
  nyansrik_1_A = mkA "nyansrik" ; -- nyansrik..av.1
  nyanställa_1_V = mkV "nyanställer" ; -- nyanställa..vb.1
  nyanställande_1_N = mkN "nyanställande" ; -- nyanställande..nn.1
  nyanställning_1_N = mkN "nyanställning" ; -- nyanställning..nn.1
  nyantik_1_A = mkA "nyantik" ; -- nyantik..av.1
  nyantik_1_N = mkN "nyantik" ; -- nyantik..nn.1
  nyavgången_1_A = mkA "nyavgången" ; -- nyavgången..av.1
  nybadad_1_A = mkA "nybadad" ; -- nybadad..av.1
  nybakad_1_A = mkA "nybakad" ; -- nybakad..av.1
  nybearbetning_1_N = mkN "nybearbetning" ; -- nybearbetning..nn.1
  nybildad_1_A = mkA "nybildad" ; -- nybildad..av.1
  nybildning_1_N = mkN "nybildning" ; -- nybildning..nn.1
  nybliven_1_A = mkA "nybliven" ; -- nybliven..av.1
  nyborstad_1_A = mkA "nyborstad" ; -- nyborstad..av.1
  nybruten_1_A = mkA "nybruten" ; -- nybruten..av.1
  nybryggd_1_A = mkA "nybryggd" "nybryggt" ; -- nybryggd..av.1
  nyburen_1_A = mkA "nyburen" ; -- nyburen..av.1
  nybyggare_1_N = mkN "nybyggare" utrum  ; -- nybyggare..nn.1
  nybyggd_1_A = mkA "nybyggd" "nybyggt" ; -- nybyggd..av.1
  nybygge_1_N = mkN "nybygge" ; -- nybygge..nn.1
  nybyggnad_1_N = mkN "nybyggnad" "nybyggnader" ; -- nybyggnad..nn.1
  nybörjarbok_1_N = mkN "nybörjarbok" "nybörjarböcker" ; -- nybörjarbok..nn.1
  nybörjarbrottslighet_1_N = mkN "nybörjarbrottslighet" ; -- nybörjarbrottslighet..nn.1
  nybörjarbåge_1_N = mkN "nybörjarbåge" utrum  ; -- nybörjarbåge..nn.1
  nybörjare_1_N = mkN "nybörjare" utrum  ; -- nybörjare..nn.1
  nybörjarset_1_N = mkN "nybörjarset" neutrum  ; -- nybörjarset..nn.1
  nyck_1_N = mkN "nyck" "nycker" ; -- nyck..nn.1
  nyckel_1_N = mkN "nyckel" ; -- nyckel..nn.1
  nyckelax_1_N = mkN "nyckelax" neutrum  ; -- nyckelax..nn.1
  nyckelbarn_1_N = mkN "nyckelbarn" neutrum  ; -- nyckelbarn..nn.1
  nyckelben_1_N = mkN "nyckelben" neutrum  ; -- nyckelben..nn.1
  nyckelblomster_1_N = mkN "nyckelblomster" neutrum  ; -- nyckelblomster..nn.1
  nyckelfunktion_1_N = mkN "nyckelfunktion" ; -- nyckelfunktion..nn.1
  nyckelfärdig_1_A = mkA "nyckelfärdig" ; -- nyckelfärdig..av.1
  nyckelharpa_1_N = mkN "nyckelharpa" ; -- nyckelharpa..nn.1
  nyckelhål_1_N = mkN "nyckelhål" neutrum  ; -- nyckelhål..nn.1
  nyckelindustri_1_N = mkN "nyckelindustri" "nyckelindustrier" ; -- nyckelindustri..nn.1
  nyckelinslag_1_N = mkN "nyckelinslag" neutrum  ; -- nyckelinslag..nn.1
  nyckelknippa_1_N = mkN "nyckelknippa" ; -- nyckelknippa..nn.1
  nyckelkort_1_N = mkN "nyckelkort" neutrum  ; -- nyckelkort..nn.1
  nyckelman_1_N = mkN "nyckelman" "nyckelmannen" "nyckelmän" "nyckelmännen" ; -- nyckelman..nn.1
  nyckelord_1_N = mkN "nyckelord" neutrum  ; -- nyckelord..nn.1
  nyckelperson_1_N = mkN "nyckelperson" "nyckelpersoner" ; -- nyckelperson..nn.1
  nyckelpiga_1_N = mkN "nyckelpiga" ; -- nyckelpiga..nn.1
  nyckelposition_1_N = mkN "nyckelposition" ; -- nyckelposition..nn.1
  nyckelretning_1_N = mkN "nyckelretning" ; -- nyckelretning..nn.1
  nyckelroll_1_N = mkN "nyckelroll" "nyckelroller" ; -- nyckelroll..nn.1
  nyckelroman_1_N = mkN "nyckelroman" "nyckelromaner" ; -- nyckelroman..nn.1
  nyckelskåp_1_N = mkN "nyckelskåp" neutrum  ; -- nyckelskåp..nn.1
  nyckelspelare_1_N = mkN "nyckelspelare" utrum  ; -- nyckelspelare..nn.1
  nyckelsten_1_N = mkN "nyckelsten" "nyckelstenen" "nyckelstenar" "nyckelstenarna" ; -- nyckelsten..nn.1
  nyckelstång_1_N = mkN "nyckelstång" "nyckelstänger" ; -- nyckelstång..nn.1
  nyckelsymbol_1_N = mkN "nyckelsymbol" "nyckelsymboler" ; -- nyckelsymbol..nn.1
  nyckelämne_1_N = mkN "nyckelämne" ; -- nyckelämne..nn.1
  nyckfull_1_A = mkA "nyckfull" ; -- nyckfull..av.1
  nyckfullhet_1_N = mkN "nyckfullhet" "nyckfullheter" ; -- nyckfullhet..nn.1
  nydana_1_V = mkV "nydanar" ; -- nydana..vb.1
  nydanande_1_N = mkN "nydanande" ; -- nydanande..nn.1
  nydanare_1_N = mkN "nydanare" utrum  ; -- nydanare..nn.1
  nydaning_1_N = mkN "nydaning" ; -- nydaning..nn.1
  nyduschad_1_A = mkA "nyduschad" ; -- nyduschad..av.1
  nyemission_1_N = mkN "nyemission" ; -- nyemission..nn.1
  nyemittera_1_V = mkV "nyemitterar" ; -- nyemittera..vb.1
  nyemitterande_1_N = mkN "nyemitterande" ; -- nyemitterande..nn.1
  nyemitterbar_1_A = mkA "nyemitterbar" ; -- nyemitterbar..av.1
  nyemitterbarhet_1_N = mkN "nyemitterbarhet" ; -- nyemitterbarhet..nn.1
  nyemittering_1_N = mkN "nyemittering" ; -- nyemittering..nn.1
  nyenkel_1_A = mkA "nyenkel" ; -- nyenkel..av.1
  nyerövring_1_N = mkN "nyerövring" ; -- nyerövring..nn.1
  nyetablera_1_V = mkV "nyetablerar" ; -- nyetablera..vb.1
  nyetablerande_1_N = mkN "nyetablerande" ; -- nyetablerande..nn.1
  nyetablerbar_1_A = mkA "nyetablerbar" ; -- nyetablerbar..av.1
  nyetablerbarhet_1_N = mkN "nyetablerbarhet" ; -- nyetablerbarhet..nn.1
  nyetablering_1_N = mkN "nyetablering" ; -- nyetablering..nn.1
  nyexaminerad_1_A = mkA "nyexaminerad" ; -- nyexaminerad..av.1
  nyfallen_1_A = mkA "nyfallen" ; -- nyfallen..av.1
  nyfascism_1_N = mkN "nyfascism" "nyfascismer" ; -- nyfascism..nn.1
  nyfascistisk_1_A = mkA "nyfascistisk" ; -- nyfascistisk..av.1
  nyfiken_1_A = mkA "nyfiken" ; -- nyfiken..av.1
  nyfikenhet_1_N = mkN "nyfikenhet" "nyfikenheter" ; -- nyfikenhet..nn.1
  nyfriserad_1_A = mkA "nyfriserad" ; -- nyfriserad..av.1
  nyfärgad_1_A = mkA "nyfärgad" ; -- nyfärgad..av.1
  nyfångad_1_A = mkA "nyfångad" ; -- nyfångad..av.1
  nyfödd_1_A = mkA "nyfödd" ; -- nyfödd..av.1
  nyföretagande_1_N = mkN "nyföretagande" ; -- nyföretagande..nn.1
  nyförlovad_1_A = mkA "nyförlovad" ; -- nyförlovad..av.1
  nyförlöst_1_A = mkA "nyförlöst" "nyförlöst" ; -- nyförlöst..av.1
  nyförvärv_1_N = mkN "nyförvärv" neutrum  ; -- nyförvärv..nn.1
  nyförvärvad_1_A = mkA "nyförvärvad" ; -- nyförvärvad..av.1
  nyförälskad_1_A = mkA "nyförälskad" ; -- nyförälskad..av.1
  nygift_1_A = mkA "nygift" "nygift" ; -- nygift..av.1
  nygjord_1_A = mkA "nygjord" "nygjort" ; -- nygjord..av.1
  nygotik_1_N = mkN "nygotik" ; -- nygotik..nn.1
  nygotisk_1_A = mkA "nygotisk" ; -- nygotisk..av.1
  nygrad_1_N = mkN "nygrad" "nygrader" ; -- nygrad..nn.1
  nygravid_1_A = mkA "nygravid" ; -- nygravid..av.1
  nygrekiska_1_N = mkN "nygrekiska" ; -- nygrekiska..nn.1
  nygrundad_1_A = mkA "nygrundad" ; -- nygrundad..av.1
  nygräddad_1_A = mkA "nygräddad" ; -- nygräddad..av.1
  nygången_1_A = mkA "nygången" ; -- nygången..av.1
  nyhet_1_N = mkN "nyhet" "nyheter" ; -- nyhet..nn.1
  nyhetisering_1_N = mkN "nyhetisering" ; -- nyhetisering..nn.1
  nyhetsankare_1_N = mkN "nyhetsankare" "nyhetsankaret" "nyhetsankaren" "nyhetsankarna" ; -- nyhetsankare..nn.1
  nyhetsbevakning_1_N = mkN "nyhetsbevakning" ; -- nyhetsbevakning..nn.1
  nyhetsblad_1_N = mkN "nyhetsblad" neutrum  ; -- nyhetsblad..nn.1
  nyhetsbrist_1_N = mkN "nyhetsbrist" ; -- nyhetsbrist..nn.1
  nyhetsbyrå_1_N = mkN "nyhetsbyrå" "nyhetsbyråer" ; -- nyhetsbyrå..nn.1
  nyhetsflöde_1_N = mkN "nyhetsflöde" ; -- nyhetsflöde..nn.1
  nyhetsförmedling_1_N = mkN "nyhetsförmedling" ; -- nyhetsförmedling..nn.1
  nyhetsjakt_1_N = mkN "nyhetsjakt" ; -- nyhetsjakt..nn.1
  nyhetsjägare_1_N = mkN "nyhetsjägare" utrum  ; -- nyhetsjägare..nn.1
  nyhetskonsument_1_N = mkN "nyhetskonsument" "nyhetskonsumenter" ; -- nyhetskonsument..nn.1
  nyhetskälla_1_N = mkN "nyhetskälla" ; -- nyhetskälla..nn.1
  nyhetslysten_1_A = mkA "nyhetslysten" ; -- nyhetslysten..av.1
  nyhetsmakare_1_N = mkN "nyhetsmakare" utrum  ; -- nyhetsmakare..nn.1
  nyhetsmakeri_1_N = mkN "nyhetsmakeri" neutrum  ; -- nyhetsmakeri..nn.1
  nyhetsmässig_1_A = mkA "nyhetsmässig" ; -- nyhetsmässig..av.1
  nyhetsnotis_1_N = mkN "nyhetsnotis" "nyhetsnotiser" ; -- nyhetsnotis..nn.1
  nyhetsnotisskrivande_1_N = mkN "nyhetsnotisskrivande" ; -- nyhetsnotisskrivande..nn.1
  nyhetsportal_1_N = mkN "nyhetsportal" "nyhetsportaler" ; -- nyhetsportal..nn.1
  nyhetsprogram_1_N = mkN "nyhetsprogram" "nyhetsprogrammet" "nyhetsprogram" "nyhetsprogrammen" ; -- nyhetsprogram..nn.1
  nyhetsredaktion_1_N = mkN "nyhetsredaktion" ; -- nyhetsredaktion..nn.1
  nyhetsreporter_1_N = mkN "nyhetsreporter" ; -- nyhetsreporter..nn.1
  nyhetssök_1_N = mkN "nyhetssök" neutrum  ; -- nyhetssök..nn.1
  nyhetstelegram_1_N = mkN "nyhetstelegram" "nyhetstelegrammet" "nyhetstelegram" "nyhetstelegrammen" ; -- nyhetstelegram..nn.1
  nyhetstest_1_N = mkN "nyhetstest" neutrum  ; -- nyhetstest..nn.1
  nyhetstips_1_N = mkN "nyhetstips" neutrum  ; -- nyhetstips..nn.1
  nyhetstorka_1_N = mkN "nyhetstorka" ; -- nyhetstorka..nn.1
  nyhetsuppläsare_1_N = mkN "nyhetsuppläsare" utrum  ; -- nyhetsuppläsare..nn.1
  nyhetsvärde_1_N = mkN "nyhetsvärde" ; -- nyhetsvärde..nn.1
  nyhetsvärdering_1_N = mkN "nyhetsvärdering" ; -- nyhetsvärdering..nn.1
  nyhumanism_1_N = mkN "nyhumanism" "nyhumanismer" ; -- nyhumanism..nn.1
  nyinflyttad_1_A = mkA "nyinflyttad" ; -- nyinflyttad..av.1
  nying_1_N = mkN "nying" ; -- nying..nn.1
  nyingsbrasa_1_N = mkN "nyingsbrasa" ; -- nyingsbrasa..nn.1
  nyinköpt_1_A = mkA "nyinköpt" "nyinköpt" ; -- nyinköpt..av.1
  nyinredd_1_A = mkA "nyinredd" ; -- nyinredd..av.1
  nyinrättad_1_A = mkA "nyinrättad" ; -- nyinrättad..av.1
  nyinskaffad_1_A = mkA "nyinskaffad" ; -- nyinskaffad..av.1
  nyinspelning_1_N = mkN "nyinspelning" ; -- nyinspelning..nn.1
  nyinstiftad_1_A = mkA "nyinstiftad" ; -- nyinstiftad..av.1
  nyintagning_1_N = mkN "nyintagning" ; -- nyintagning..nn.1
  nyinvestera_1_V = mkV "nyinvesterar" ; -- nyinvestera..vb.1
  nyinvesterande_1_N = mkN "nyinvesterande" ; -- nyinvesterande..nn.1
  nyinvesterbar_1_A = mkA "nyinvesterbar" ; -- nyinvesterbar..av.1
  nyinvesterbarhet_1_N = mkN "nyinvesterbarhet" ; -- nyinvesterbarhet..nn.1
  nyinvestering_1_N = mkN "nyinvestering" ; -- nyinvestering..nn.1
  nyklassicism_1_N = mkN "nyklassicism" "nyklassicismer" ; -- nyklassicism..nn.1
  nyklassicistisk_1_A = mkA "nyklassicistisk" ; -- nyklassicistisk..av.1
  nyklassiker_1_N = mkN "nyklassiker" "nyklassikern" "nyklassiker" "nyklassikerna" ; -- nyklassiker..nn.1
  nyklassisk_1_A = mkA "nyklassisk" ; -- nyklassisk..av.1
  nyklippt_1_A = mkA "nyklippt" "nyklippt" ; -- nyklippt..av.1
  nykläckt_1_A = mkA "nykläckt" "nykläckt" ; -- nykläckt..av.1
  nykokt_1_A = mkA "nykokt" "nykokt" ; -- nykokt..av.1
  nykolonialism_1_N = mkN "nykolonialism" "nykolonialismer" ; -- nykolonialism..nn.1
  nykolonialistisk_1_A = mkA "nykolonialistisk" ; -- nykolonialistisk..av.1
  nykolonisation_1_N = mkN "nykolonisation" ; -- nykolonisation..nn.1
  nykomling_1_N = mkN "nykomling" ; -- nykomling..nn.1
  nykomponerad_1_A = mkA "nykomponerad" ; -- nykomponerad..av.1
  nykonstruerad_1_A = mkA "nykonstruerad" ; -- nykonstruerad..av.1
  nykter_1_A = mkA "nykter" ; -- nykter..av.1
  nykterhet_1_N = mkN "nykterhet" "nykterheter" ; -- nykterhet..nn.1
  nykterhetsförening_1_N = mkN "nykterhetsförening" ; -- nykterhetsförening..nn.1
  nykterhetsivrare_1_N = mkN "nykterhetsivrare" utrum  ; -- nykterhetsivrare..nn.1
  nykterhetsnämnd_1_N = mkN "nykterhetsnämnd" "nykterhetsnämnder" ; -- nykterhetsnämnd..nn.1
  nykterhetsrörelse_1_N = mkN "nykterhetsrörelse" "nykterhetsrörelser" ; -- nykterhetsrörelse..nn.1
  nykterhetsvän_1_N = mkN "nykterhetsvän" "nykterhetsvännen" "nykterhetsvänner" "nykterhetsvännerna" ; -- nykterhetsvän..nn.1
  nykterhetsvård_1_N = mkN "nykterhetsvård" ; -- nykterhetsvård..nn.1
  nykterism_1_N = mkN "nykterism" "nykterismer" ; -- nykterism..nn.1
  nykterismlobby_1_N = mkN "nykterismlobby" "nykterismlobbyer" ; -- nykterismlobby..nn.1
  nykterist_1_N = mkN "nykterist" "nykterister" ; -- nykterist..nn.1
  nykteristisk_1_A = mkA "nykteristisk" ; -- nykteristisk..av.1
  nyktofobi_1_N = mkN "nyktofobi" ; -- nyktofobi..nn.1
  nylagad_1_A = mkA "nylagad" ; -- nylagad..av.1
  nylagd_1_A = mkA "nylagd" "nylagt" ; -- nylagd..av.1
  nylatin_1_N = mkN "nylatin" neutrum  ; -- nylatin..nn.1
  nyliberal_1_A = mkA "nyliberal" ; -- nyliberal..av.1
  nyliberalism_1_N = mkN "nyliberalism" ; -- nyliberalism..nn.1
  nyliberalistisk_1_A = mkA "nyliberalistisk" ; -- nyliberalistisk..av.1
  nyligen_1_Adv = mkAdv "nyligen" ; -- nyligen..ab.1
  nylle_1_N = mkN "nylle" ; -- nylle..nn.1
  nylon_1_N = mkN "nylon" ; -- nylon..nn.1
  nylonhjul_1_N = mkN "nylonhjul" neutrum  ; -- nylonhjul..nn.1
  nylonskjorta_1_N = mkN "nylonskjorta" ; -- nylonskjorta..nn.1
  nylonsnöre_1_N = mkN "nylonsnöre" ; -- nylonsnöre..nn.1
  nylonstrumpa_1_N = mkN "nylonstrumpa" ; -- nylonstrumpa..nn.1
  nylonsträng_1_N = mkN "nylonsträng" ; -- nylonsträng..nn.1
  nylonutsida_1_N = mkN "nylonutsida" ; -- nylonutsida..nn.1
  nyländsk_1_A = mkA "nyländsk" ; -- nyländsk..av.1
  nyländska_1_N = mkN "nyländska" ; -- nyländska..nn.1
  nyländska_2_N = mkN "nyländska" ; -- nyländska..nn.2
  nylänning_1_N = mkN "nylänning" ; -- nylänning..nn.1
  nyläsning_1_N = mkN "nyläsning" ; -- nyläsning..nn.1
  nylövad_1_A = mkA "nylövad" ; -- nylövad..av.1
  nymf_1_N = mkN "nymf" "nymfer" ; -- nymf..nn.1
  nymfoman_1_N = mkN "nymfoman" "nymfomaner" ; -- nymfoman..nn.1
  nymfomani_1_N = mkN "nymfomani" ; -- nymfomani..nn.1
  nymobiliserad_1_A = mkA "nymobiliserad" ; -- nymobiliserad..av.1
  nymodig_1_A = mkA "nymodig" ; -- nymodig..av.1
  nymodighet_1_N = mkN "nymodighet" "nymodigheter" ; -- nymodighet..nn.1
  nymorgnad_1_A = mkA "nymorgnad" ; -- nymorgnad..av.1
  nymornad_1_A = mkA "nymornad" ; -- nymornad..av.1
  nymålad_1_A = mkA "nymålad" ; -- nymålad..av.1
  nymåne_1_N = mkN "nymåne" utrum  ; -- nymåne..nn.1
  nynazism_1_N = mkN "nynazism" "nynazismer" ; -- nynazism..nn.1
  nynazist_1_N = mkN "nynazist" "nynazister" ; -- nynazist..nn.1
  nynazistisk_1_A = mkA "nynazistisk" ; -- nynazistisk..av.1
  nynna_1_V = mkV "nynnar" ; -- nynna..vb.1
  nynnande_1_N = mkN "nynnande" ; -- nynnande..nn.1
  nynorsk_1_A = mkA "nynorsk" ; -- nynorsk..av.1
  nynorska_1_N = mkN "nynorska" ; -- nynorska..nn.1
  nyodla_1_V = mkV "nyodlar" ; -- nyodla..vb.1
  nyodlande_1_N = mkN "nyodlande" ; -- nyodlande..nn.1
  nyodling_1_N = mkN "nyodling" ; -- nyodling..nn.1
  nyopererad_1_A = mkA "nyopererad" ; -- nyopererad..av.1
  nyord_1_N = mkN "nyord" neutrum  ; -- nyord..nn.1
  nyordning_1_N = mkN "nyordning" ; -- nyordning..nn.1
  nyorientering_1_N = mkN "nyorientering" ; -- nyorientering..nn.1
  nyp_1_N = mkN "nyp" neutrum  ; -- nyp..nn.1
  nypa_1_N = mkN "nypa" ; -- nypa..nn.1
  nypa_1_V = mkV "nypa" "nöp" "nupit" ; -- nypa..vb.1
  nypande_1_N = mkN "nypande" ; -- nypande..nn.1
  nyplantera_1_V = mkV "nyplanterar" ; -- nyplantera..vb.1
  nyplanterande_1_N = mkN "nyplanterande" ; -- nyplanterande..nn.1
  nyplanterbar_1_A = mkA "nyplanterbar" ; -- nyplanterbar..av.1
  nyplanterbarhet_1_N = mkN "nyplanterbarhet" ; -- nyplanterbarhet..nn.1
  nyplantering_1_N = mkN "nyplantering" ; -- nyplantering..nn.1
  nyplatonism_1_N = mkN "nyplatonism" "nyplatonismer" ; -- nyplatonism..nn.1
  nyplatonist_1_N = mkN "nyplatonist" "nyplatonister" ; -- nyplatonist..nn.1
  nyplatonistisk_1_A = mkA "nyplatonistisk" ; -- nyplatonistisk..av.1
  nyplatonsk_1_A = mkA "nyplatonsk" ; -- nyplatonsk..av.1
  nypning_1_N = mkN "nypning" ; -- nypning..nn.1
  nypolerad_1_A = mkA "nypolerad" ; -- nypolerad..av.1
  nypon_1_N = mkN "nypon" neutrum  ; -- nypon..nn.1
  nyponros_1_N = mkN "nyponros" "nyponrosor" ; -- nyponros..nn.1
  nyponsoppa_1_N = mkN "nyponsoppa" ; -- nyponsoppa..nn.1
  nyponte_1_N = mkN "nyponte" ; -- nyponte..nn.1
  nypremiär_1_N = mkN "nypremiär" "nypremiärer" ; -- nypremiär..nn.1
  nypressad_1_A = mkA "nypressad" ; -- nypressad..av.1
  nyproducerad_1_A = mkA "nyproducerad" ; -- nyproducerad..av.1
  nyproduktion_1_N = mkN "nyproduktion" ; -- nyproduktion..nn.1
  nyrakad_1_A = mkA "nyrakad" ; -- nyrakad..av.1
  nyrealism_1_N = mkN "nyrealism" "nyrealismer" ; -- nyrealism..nn.1
  nyrealistisk_1_A = mkA "nyrealistisk" ; -- nyrealistisk..av.1
  nyregistrerad_1_A = mkA "nyregistrerad" ; -- nyregistrerad..av.1
  nyrekryterad_1_A = mkA "nyrekryterad" ; -- nyrekryterad..av.1
  nyrekrytering_1_N = mkN "nyrekrytering" ; -- nyrekrytering..nn.1
  nyrenoverad_1_A = mkA "nyrenoverad" ; -- nyrenoverad..av.1
  nyrestaurerad_1_A = mkA "nyrestaurerad" ; -- nyrestaurerad..av.1
  nyrik_1_A = mkA "nyrik" ; -- nyrik..av.1
  nyrikhet_1_N = mkN "nyrikhet" ; -- nyrikhet..nn.1
  nyrokoko_1_N = mkN "nyrokoko" ; -- nyrokoko..nn.1
  nyromantik_1_N = mkN "nyromantik" ; -- nyromantik..nn.1
  nyromantiker_1_N = mkN "nyromantiker" "nyromantikern" "nyromantiker" "nyromantikerna" ; -- nyromantiker..nn.1
  nyromantisk_1_A = mkA "nyromantisk" ; -- nyromantisk..av.1
  nys_1_N = mkN "nys" neutrum  ; -- nys..nn.1
  nysa_1_V = mkV "nyser" ; -- nysa..vb.1
  nysande_1_N = mkN "nysande" ; -- nysande..nn.1
  nysatt_1_A = mkA "nysatt" ; -- nysatt..av.1
  nysattack_1_N = mkN "nysattack" "nysattacker" ; -- nysattack..nn.1
  nysilver_1_N = mkN "nysilver" neutrum  ; -- nysilver..nn.1
  nyskapa_1_V = mkV "nyskapar" ; -- nyskapa..vb.1
  nyskapande_1_N = mkN "nyskapande" ; -- nyskapande..nn.1
  nyskapare_1_N = mkN "nyskapare" utrum  ; -- nyskapare..nn.1
  nyskapelse_1_N = mkN "nyskapelse" "nyskapelser" ; -- nyskapelse..nn.1
  nyskott_1_N = mkN "nyskott" neutrum  ; -- nyskott..nn.1
  nyskriven_1_A = mkA "nyskriven" ; -- nyskriven..av.1
  nyslipad_1_A = mkA "nyslipad" ; -- nyslipad..av.1
  nysning_1_N = mkN "nysning" ; -- nysning..nn.1
  nysnö_1_N = mkN "nysnö" ; -- nysnö..nn.1
  nyspråk_1_N = mkN "nyspråk" neutrum  ; -- nyspråk..nn.1
  nyspulver_1_N = mkN "nyspulver" neutrum  ; -- nyspulver..nn.1
  nysta_1_V = mkV "nystar" ; -- nysta..vb.1
  nystan_1_N = mkN "nystan" neutrum  ; -- nystan..nn.1
  nystande_1_N = mkN "nystande" ; -- nystande..nn.1
  nystart_1_N = mkN "nystart" "nystarter" ; -- nystart..nn.1
  nystartad_1_A = mkA "nystartad" ; -- nystartad..av.1
  nystavare_1_N = mkN "nystavare" utrum  ; -- nystavare..nn.1
  nystavning_1_N = mkN "nystavning" ; -- nystavning..nn.1
  nystkrona_1_N = mkN "nystkrona" ; -- nystkrona..nn.1
  nystning_1_N = mkN "nystning" ; -- nystning..nn.1
  nystpinne_1_N = mkN "nystpinne" utrum  ; -- nystpinne..nn.1
  nyststjärna_1_N = mkN "nyststjärna" ; -- nyststjärna..nn.1
  nystvinda_1_N = mkN "nystvinda" ; -- nystvinda..nn.1
  nystädad_1_A = mkA "nystädad" ; -- nystädad..av.1
  nysvensk_1_A = mkA "nysvensk" ; -- nysvensk..av.1
  nysvenska_1_N = mkN "nysvenska" ; -- nysvenska..nn.1
  nysådd_1_A = mkA "nysådd" ; -- nysådd..av.1
  nysört_1_N = mkN "nysört" "nysörter" ; -- nysört..nn.1
  nytagen_1_A = mkA "nytagen" ; -- nytagen..av.1
  nyteckna_1_V = mkV "nytecknar" ; -- nyteckna..vb.1
  nytecknande_1_N = mkN "nytecknande" ; -- nytecknande..nn.1
  nyteckning_1_N = mkN "nyteckning" "nyteckningt" "nyteckningn" "nyteckningna" ; -- nyteckning..nn.1
  nyter_1_A = mkA "nyter" ; -- nyter..av.1
  nyterhet_1_N = mkN "nyterhet" ; -- nyterhet..nn.1
  nytestamentlig_1_A = mkA "nytestamentlig" ; -- nytestamentlig..av.1
  nytestamentlighet_1_N = mkN "nytestamentlighet" ; -- nytestamentlighet..nn.1
  nytillkommen_1_A = mkA "nytillkommen" "nytillkommet" "nytillkomna" "nytillkomna" "nytillkomnare" "nytillkomnast" "nytillkomnaste" ; -- nytillkommen..av.1
  nytillskott_1_N = mkN "nytillskott" neutrum  ; -- nytillskott..nn.1
  nytillträdande_1_A = mkA "nytillträdande" ; -- nytillträdande..av.1
  nytillträdd_1_A = mkA "nytillträdd" ; -- nytillträdd..av.1
  nytillverkad_1_A = mkA "nytillverkad" ; -- nytillverkad..av.1
  nytolkning_1_N = mkN "nytolkning" ; -- nytolkning..nn.1
  nytryck_1_N = mkN "nytryck" neutrum  ; -- nytryck..nn.1
  nytta_1_N = mkN "nytta" ; -- nytta..nn.1
  nytta_1_V = mkV "nyttar" ; -- nytta..vb.1
  nyttande_1_N = mkN "nyttande" ; -- nyttande..nn.1
  nyttig_1_A = mkA "nyttig" ; -- nyttig..av.1
  nyttiggöra_1_V = mkV "nyttiggöra" "nyttiggjorde" "nyttiggjort" ; -- nyttiggöra..vb.1
  nyttiggörande_1_N = mkN "nyttiggörande" ; -- nyttiggörande..nn.1
  nyttighet_1_N = mkN "nyttighet" "nyttigheter" ; -- nyttighet..nn.1
  nyttighetsmoral_1_N = mkN "nyttighetsmoral" ; -- nyttighetsmoral..nn.1
  nyttja_1_V = mkV "nyttjar" ; -- nyttja..vb.1
  nyttjande_1_N = mkN "nyttjande" ; -- nyttjande..nn.1
  nyttjandefrekvens_1_N = mkN "nyttjandefrekvens" "nyttjandefrekvenser" ; -- nyttjandefrekvens..nn.1
  nyttjanderätt_1_N = mkN "nyttjanderätt" ; -- nyttjanderätt..nn.1
  nyttjare_1_N = mkN "nyttjare" utrum  ; -- nyttjare..nn.1
  nyttobetonad_1_A = mkA "nyttobetonad" ; -- nyttobetonad..av.1
  nyttoföremål_1_N = mkN "nyttoföremål" neutrum  ; -- nyttoföremål..nn.1
  nyttokonst_1_N = mkN "nyttokonst" ; -- nyttokonst..nn.1
  nyttomoral_1_N = mkN "nyttomoral" ; -- nyttomoral..nn.1
  nyttosynpunkt_1_N = mkN "nyttosynpunkt" "nyttosynpunkter" ; -- nyttosynpunkt..nn.1
  nyttotrafik_1_N = mkN "nyttotrafik" ; -- nyttotrafik..nn.1
  nyttoväxt_1_N = mkN "nyttoväxt" "nyttoväxter" ; -- nyttoväxt..nn.1
  nytumlad_1_A = mkA "nytumlad" ; -- nytumlad..av.1
  nytvättad_1_A = mkA "nytvättad" ; -- nytvättad..av.1
  nytäljd_1_A = mkA "nytäljd" "nytäljt" ; -- nytäljd..av.1
  nytänd_1_A = mkA "nytänd" ; -- nytänd..av.1
  nytändning_1_N = mkN "nytändning" ; -- nytändning..nn.1
  nytänkande_1_N = mkN "nytänkande" ; -- nytänkande..nn.1
  nytänkare_1_N = mkN "nytänkare" utrum  ; -- nytänkare..nn.1
  nyuppförd_1_A = mkA "nyuppförd" "nyuppfört" ; -- nyuppförd..av.1
  nyupphängd_1_A = mkA "nyupphängd" "nyupphängt" ; -- nyupphängd..av.1
  nyupprättad_1_A = mkA "nyupprättad" ; -- nyupprättad..av.1
  nyuppsättning_1_N = mkN "nyuppsättning" ; -- nyuppsättning..nn.1
  nyupptäckt_1_A = mkA "nyupptäckt" "nyupptäckt" ; -- nyupptäckt..av.1
  nyutbildad_1_A = mkA "nyutbildad" ; -- nyutbildad..av.1
  nyutexaminerad_1_A = mkA "nyutexaminerad" ; -- nyutexaminerad..av.1
  nyutgiven_1_A = mkA "nyutgiven" ; -- nyutgiven..av.1
  nyutgåva_1_N = mkN "nyutgåva" ; -- nyutgåva..nn.1
  nyutkommen_1_A = mkA "nyutkommen" "nyutkommet" "nyutkomna" "nyutkomna" "nyutkomnare" "nyutkomnast" "nyutkomnaste" ; -- nyutkommen..av.1
  nyutnämnd_1_A = mkA "nyutnämnd" ; -- nyutnämnd..av.1
  nyutslagen_1_A = mkA "nyutslagen" ; -- nyutslagen..av.1
  nyutsprungen_1_A = mkA "nyutsprungen" ; -- nyutsprungen..av.1
  nyutvecklad_1_A = mkA "nyutvecklad" ; -- nyutvecklad..av.1
  nyvaknad_1_A = mkA "nyvaknad" ; -- nyvaknad..av.1
  nyval_1_N = mkN "nyval" neutrum  ; -- nyval..nn.1
  nyvald_1_A = mkA "nyvald" "nyvalt" ; -- nyvald..av.1
  nyvorden_1_A = mkA "nyvorden" ; -- nyvorden..av.1
  nyvunnen_1_A = mkA "nyvunnen" "nyvunnet" "nyvunna" "nyvunna" "nyvunnare" "nyvunnast" "nyvunnaste" ; -- nyvunnen..av.1
  nyväckt_1_A = mkA "nyväckt" "nyväckt" ; -- nyväckt..av.1
  nyvälja_1_V = mkV "nyvälja" "nyvalde" "nyvalt" ; -- nyvälja..vb.1
  nyvälle_1_N = mkN "nyvälle" ; -- nyvälle..nn.1
  nyvärde_1_N = mkN "nyvärde" ; -- nyvärde..nn.1
  nyvässad_1_A = mkA "nyvässad" ; -- nyvässad..av.1
  nyzeeländare_1_N = mkN "nyzeeländare" utrum  ; -- nyzeeländare..nn.1
  nyzeeländsk_1_A = mkA "nyzeeländsk" ; -- nyzeeländsk..av.1
  nyzeeländska_1_N = mkN "nyzeeländska" ; -- nyzeeländska..nn.1
  nyzeelänning_1_N = mkN "nyzeelänning" ; -- nyzeelänning..nn.1
  nyår_1_N = mkN "nyår" neutrum  ; -- nyår..nn.1
  nyårsafton_1_N = mkN "nyårsafton" "nyårsaftonen" "nyårsaftnar" "nyårsaftnarna" ; -- nyårsafton..nn.1
  nyårsbön_1_N = mkN "nyårsbön" "nyårsböner" ; -- nyårsbön..nn.1
  nyårsdag_1_N = mkN "nyårsdag" ; -- nyårsdag..nn.1
  nyårsfest_1_N = mkN "nyårsfest" "nyårsfester" ; -- nyårsfest..nn.1
  nyårsgåva_1_N = mkN "nyårsgåva" ; -- nyårsgåva..nn.1
  nyårslöfte_1_N = mkN "nyårslöfte" ; -- nyårslöfte..nn.1
  nyårsnatt_1_N = mkN "nyårsnatt" "nyårsnätter" ; -- nyårsnatt..nn.1
  nyårsvaka_1_N = mkN "nyårsvaka" ; -- nyårsvaka..nn.1
  nyöppnad_1_A = mkA "nyöppnad" ; -- nyöppnad..av.1
  näbb_1_N = mkN "näbb" ; -- näbb..nn.1
  näbba_1_N = mkN "näbba" ; -- näbba..nn.1
  näbbdjur_1_N = mkN "näbbdjur" neutrum  ; -- näbbdjur..nn.1
  näbbgädda_1_N = mkN "näbbgädda" ; -- näbbgädda..nn.1
  näbbig_1_A = mkA "näbbig" ; -- näbbig..av.1
  näbbighet_1_N = mkN "näbbighet" ; -- näbbighet..nn.1
  näbbknöl_1_N = mkN "näbbknöl" ; -- näbbknöl..nn.1
  näbbmus_1_N = mkN "näbbmus" "näbbmusen" "näbbmöss" "näbbmössen" ; -- näbbmus..nn.1
  näbbsko_1_N = mkN "näbbsko" "näbbskor" ; -- näbbsko..nn.1
  näbbval_1_N = mkN "näbbval" ; -- näbbval..nn.1
  näck_1_A = mkA "näck" ; -- näck..av.1
  näck_1_N = mkN "näck" ; -- näck..nn.1
  näcka_1_V = mkV "näckar" ; -- näcka..vb.1
  näckande_1_N = mkN "näckande" ; -- näckande..nn.1
  näckning_1_N = mkN "näckning" ; -- näckning..nn.1
  näckros_1_N = mkN "näckros" "näckrosor" ; -- näckros..nn.1
  näckrosblad_1_N = mkN "näckrosblad" neutrum  ; -- näckrosblad..nn.1
  näckrosrot_1_N = mkN "näckrosrot" "näckrosrötter" ; -- näckrosrot..nn.1
  näktergal_1_N = mkN "näktergal" ; -- näktergal..nn.1
  näktergalsslag_1_N = mkN "näktergalsslag" neutrum  ; -- näktergalsslag..nn.1
  nämligen_1_Adv = mkAdv "nämligen" ; -- nämligen..ab.1
  nämna_1_V = mkV "nämner" ; -- nämna..vb.1
  nämnande_1_N = mkN "nämnande" ; -- nämnande..nn.1
  nämnare_1_N = mkN "nämnare" utrum  ; -- nämnare..nn.1
  nämnbar_1_A = mkA "nämnbar" ; -- nämnbar..av.1
  nämnbarhet_1_N = mkN "nämnbarhet" ; -- nämnbarhet..nn.1
  nämnd_1_N = mkN "nämnd" "nämnder" ; -- nämnd..nn.1
  nämndeman_1_N = mkN "nämndeman" "nämndemannen" "nämndemän" "nämndemännen" ; -- nämndeman..nn.1
  nämnvärd_1_A = mkA "nämnvärd" "nämnvärt" ; -- nämnvärd..av.1
  nämnvärdhet_1_N = mkN "nämnvärdhet" ; -- nämnvärdhet..nn.1
  näpen_1_A = mkA "näpen" ; -- näpen..av.1
  näpenhet_1_N = mkN "näpenhet" "näpenheter" ; -- näpenhet..nn.1
  näppeligen_1_Adv = mkAdv "näppeligen" ; -- näppeligen..ab.1
  näpsa_1_V = mkV "näpser" ; -- näpsa..vb.1
  näpsande_1_N = mkN "näpsande" ; -- näpsande..nn.1
  näpst_1_N = mkN "näpst" ; -- näpst..nn.1
  när_1_Adv = mkAdv "när" ; -- när..ab.1
  nära_1_Adv = mkAdv "nära" ; -- nära..ab.1
  nära_1_A = mkA "nära" "nära" "nära" "närmre" "närmst" ; -- nära..av.1
  nära_1_V = mkV "nära" "närde" "närt" ; -- nära..vb.1
  näraliggande_1_A = mkA "näraliggande" ; -- näraliggande..av.1
  närande_1_A = mkA "närande" ; -- närande..av.1
  närande_1_N = mkN "närande" ; -- närande..nn.1
  närapå_1_Adv = mkAdv "närapå" ; -- närapå..ab.1
  närbelägen_1_A = mkA "närbelägen" ; -- närbelägen..av.1
  närbesläktad_1_A = mkA "närbesläktad" ; -- närbesläktad..av.1
  närbild_1_N = mkN "närbild" "närbilder" ; -- närbild..nn.1
  närboende_1_A = mkA "närboende" ; -- närboende..av.1
  närboende_1_N = mkN "närboende" ; -- närboende..nn.1
  närbutik_1_N = mkN "närbutik" "närbutiker" ; -- närbutik..nn.1
  närbyråkrat_1_N = mkN "närbyråkrat" "närbyråkrater" ; -- närbyråkrat..nn.1
  närbyråkrati_1_N = mkN "närbyråkrati" ; -- närbyråkrati..nn.1
  närbyråkratperspektiv_1_N = mkN "närbyråkratperspektiv" neutrum  ; -- närbyråkratperspektiv..nn.1
  närdemokrati_1_N = mkN "närdemokrati" ; -- närdemokrati..nn.1
  närförsvar_1_N = mkN "närförsvar" neutrum  ; -- närförsvar..nn.1
  närgången_1_A = mkA "närgången" ; -- närgången..av.1
  närgångenhet_1_N = mkN "närgångenhet" "närgångenheter" ; -- närgångenhet..nn.1
  närhet_1_N = mkN "närhet" "närheter" ; -- närhet..nn.1
  närig_1_A = mkA "närig" ; -- närig..av.1
  närighet_1_N = mkN "närighet" ; -- närighet..nn.1
  näring_1_N = mkN "näring" ; -- näring..nn.1
  näringsbrist_1_N = mkN "näringsbrist" "näringsbrister" ; -- näringsbrist..nn.1
  näringsdepartement_1_N = mkN "näringsdepartement" neutrum  ; -- näringsdepartement..nn.1
  näringsfattig_1_A = mkA "näringsfattig" ; -- näringsfattig..av.1
  näringsflit_1_N = mkN "näringsflit" ; -- näringsflit..nn.1
  näringsfrihet_1_N = mkN "näringsfrihet" "näringsfriheter" ; -- näringsfrihet..nn.1
  näringsfrihetsombudsman_1_N = mkN "näringsfrihetsombudsman" "näringsfrihetsombudsmannen" "näringsfrihetsombudsmän" "näringsfrihetsombudsmännen" ; -- näringsfrihetsombudsman..nn.1
  näringsfysiologi_1_N = mkN "näringsfysiologi" ; -- näringsfysiologi..nn.1
  näringsfysiologisk_1_A = mkA "näringsfysiologisk" ; -- näringsfysiologisk..av.1
  näringsfång_1_N = mkN "näringsfång" neutrum  ; -- näringsfång..nn.1
  näringsgeografi_1_N = mkN "näringsgeografi" ; -- näringsgeografi..nn.1
  näringsgren_1_N = mkN "näringsgren" "näringsgrenen" "näringsgrenar" "näringsgrenarna" ; -- näringsgren..nn.1
  näringsidkare_1_N = mkN "näringsidkare" utrum  ; -- näringsidkare..nn.1
  näringskedja_1_N = mkN "näringskedja" ; -- näringskedja..nn.1
  näringskälla_1_N = mkN "näringskälla" ; -- näringskälla..nn.1
  näringsliv_1_N = mkN "näringsliv" neutrum  ; -- näringsliv..nn.1
  näringslivsfrämjande_1_A = mkA "näringslivsfrämjande" ; -- näringslivsfrämjande..av.1
  näringslivskonsult_1_N = mkN "näringslivskonsult" "näringslivskonsulter" ; -- näringslivskonsult..nn.1
  näringslivsledare_1_N = mkN "näringslivsledare" utrum  ; -- näringslivsledare..nn.1
  näringslivsmässig_1_A = mkA "näringslivsmässig" ; -- näringslivsmässig..av.1
  näringslivspolitik_1_N = mkN "näringslivspolitik" ; -- näringslivspolitik..nn.1
  näringslivspolitisk_1_A = mkA "näringslivspolitisk" ; -- näringslivspolitisk..av.1
  näringslivstopp_1_N = mkN "näringslivstopp" ; -- näringslivstopp..nn.1
  näringslösning_1_N = mkN "näringslösning" ; -- näringslösning..nn.1
  näringsmedel_1_N = mkN "näringsmedel" neutrum  ; -- näringsmedel..nn.1
  näringsminister_1_N = mkN "näringsminister" ; -- näringsminister..nn.1
  näringsmässig_1_A = mkA "näringsmässig" ; -- näringsmässig..av.1
  näringspolitik_1_N = mkN "näringspolitik" ; -- näringspolitik..nn.1
  näringspolitisk_1_A = mkA "näringspolitisk" ; -- näringspolitisk..av.1
  näringsprocess_1_N = mkN "näringsprocess" "näringsprocesser" ; -- näringsprocess..nn.1
  näringsrik_1_A = mkA "näringsrik" ; -- näringsrik..av.1
  näringsrikhet_1_N = mkN "näringsrikhet" ; -- näringsrikhet..nn.1
  näringsriktig_1_A = mkA "näringsriktig" ; -- näringsriktig..av.1
  näringssalt_1_N = mkN "näringssalt" "näringssaltet" "näringssalter" "näringssalterna" ; -- näringssalt..nn.1
  näringsställe_1_N = mkN "näringsställe" ; -- näringsställe..nn.1
  näringsverksamhet_1_N = mkN "näringsverksamhet" "näringsverksamheter" ; -- näringsverksamhet..nn.1
  näringsvärde_1_N = mkN "näringsvärde" ; -- näringsvärde..nn.1
  näringsämne_1_N = mkN "näringsämne" ; -- näringsämne..nn.1
  närkamp_1_N = mkN "närkamp" "närkamper" ; -- närkamp..nn.1
  närking_1_N = mkN "närking" ; -- närking..nn.1
  närkingsk_1_A = mkA "närkingsk" ; -- närkingsk..av.1
  närkingska_1_N = mkN "närkingska" ; -- närkingska..nn.1
  närkingska_2_N = mkN "närkingska" ; -- närkingska..nn.2
  närkontakt_1_N = mkN "närkontakt" ; -- närkontakt..nn.1
  närlagd_1_A = mkA "närlagd" "närlagt" ; -- närlagd..av.1
  närliggande_1_A = mkA "närliggande" ; -- närliggande..av.1
  närma_1_V = mkV "närmar" ; -- närma..vb.1
  närmande_1_N = mkN "närmande" ; -- närmande..nn.1
  närmevärde_1_N = mkN "närmevärde" ; -- närmevärde..nn.1
  närmiljö_1_N = mkN "närmiljö" "närmiljön" "närmiljöer" "närmiljöerna" ; -- närmiljö..nn.1
  närminne_1_N = mkN "närminne" ; -- närminne..nn.1
  närområde_1_N = mkN "närområde" ; -- närområde..nn.1
  närpassage_1_N = mkN "närpassage" "närpassager" ; -- närpassage..nn.1
  närproducerad_1_A = mkA "närproducerad" ; -- närproducerad..av.1
  närpunkt_1_N = mkN "närpunkt" "närpunkter" ; -- närpunkt..nn.1
  närradio_1_N = mkN "närradio" ; -- närradio..nn.1
  närsalt_1_N = mkN "närsalt" "närsaltet" "närsalter" "närsalterna" ; -- närsalt..nn.1
  närsamhälle_1_N = mkN "närsamhälle" ; -- närsamhälle..nn.1
  närskyld_1_A = mkA "närskyld" "närskylt" ; -- närskyld..av.1
  närskyldhet_1_N = mkN "närskyldhet" ; -- närskyldhet..nn.1
  närsluta_1_V = mkV "närsluta" "närslöt" "närslutit" ; -- närsluta..vb.1
  närslutande_1_N = mkN "närslutande" ; -- närslutande..nn.1
  närsomhelst_1_Adv = mkAdv "närsomhelst" ; -- närsomhelst..ab.1
  närspaning_1_N = mkN "närspaning" ; -- närspaning..nn.1
  närstrid_1_N = mkN "närstrid" "närstrider" ; -- närstrid..nn.1
  närstridsinstruktör_1_N = mkN "närstridsinstruktör" "närstridsinstruktörer" ; -- närstridsinstruktör..nn.1
  närstridsvapen_1_N = mkN "närstridsvapen" "närstridsvapnet" "närstridsvapen" "närstridsvapnen" ; -- närstridsvapen..nn.1
  närstudera_1_V = mkV "närstuderar" ; -- närstudera..vb.1
  närstuderande_1_N = mkN "närstuderande" ; -- närstuderande..nn.1
  närstudering_1_N = mkN "närstudering" ; -- närstudering..nn.1
  närstudium_1_N = mkN "närstudium" "närstudiet" "närstudier" "närstudierna" ; -- närstudium..nn.1
  närstående_1_A = mkA "närstående" ; -- närstående..av.1
  närsynt_1_A = mkA "närsynt" "närsynt" ; -- närsynt..av.1
  närsynthet_1_N = mkN "närsynthet" "närsyntheter" ; -- närsynthet..nn.1
  närvara_1_V = mkV "närvarar" ; -- närvara..vb.1
  närvarande_1_A = mkA "närvarande" ; -- närvarande..av.1
  närvarande_1_N = mkN "närvarande" ; -- närvarande..nn.1
  närvarelse_1_N = mkN "närvarelse" utrum  ; -- närvarelse..nn.1
  närvaro_1_N = mkN "närvaro" ; -- närvaro..nn.1
  närvarorapportering_1_N = mkN "närvarorapportering" ; -- närvarorapportering..nn.1
  näs_1_N = mkN "näs" neutrum  ; -- näs..nn.1
  näsa_1_N = mkN "näsa" ; -- näsa..nn.1
  näsandning_1_N = mkN "näsandning" ; -- näsandning..nn.1
  näsavtryck_1_N = mkN "näsavtryck" neutrum  ; -- näsavtryck..nn.1
  näsben_1_N = mkN "näsben" neutrum  ; -- näsben..nn.1
  näsblod_1_N = mkN "näsblod" neutrum  ; -- näsblod..nn.1
  näsborre_1_N = mkN "näsborre" utrum  ; -- näsborre..nn.1
  näsbrosk_1_N = mkN "näsbrosk" neutrum  ; -- näsbrosk..nn.1
  näsbränna_1_N = mkN "näsbränna" ; -- näsbränna..nn.1
  näsduk_1_N = mkN "näsduk" ; -- näsduk..nn.1
  näsgång_1_N = mkN "näsgång" ; -- näsgång..nn.1
  näshåla_1_N = mkN "näshåla" ; -- näshåla..nn.1
  näskatarr_1_N = mkN "näskatarr" "näskatarrer" ; -- näskatarr..nn.1
  näsknäpp_1_N = mkN "näsknäpp" ; -- näsknäpp..nn.1
  näsljud_1_N = mkN "näsljud" neutrum  ; -- näsljud..nn.1
  näsprydnad_1_N = mkN "näsprydnad" "näsprydnader" ; -- näsprydnad..nn.1
  näspärla_1_N = mkN "näspärla" ; -- näspärla..nn.1
  näsring_1_N = mkN "näsring" ; -- näsring..nn.1
  näsrot_1_N = mkN "näsrot" "näsrötter" ; -- näsrot..nn.1
  näsrygg_1_N = mkN "näsrygg" ; -- näsrygg..nn.1
  näsrynkning_1_N = mkN "näsrynkning" ; -- näsrynkning..nn.1
  nässelcell_1_N = mkN "nässelcell" "nässelceller" ; -- nässelcell..nn.1
  nässeldjur_1_N = mkN "nässeldjur" neutrum  ; -- nässeldjur..nn.1
  nässelfeber_1_N = mkN "nässelfeber" ; -- nässelfeber..nn.1
  nässelfiber_1_N = mkN "nässelfiber" "nässelfibern" "nässelfibrer" "nässelfibrerna" ; -- nässelfiber..nn.1
  nässelfjäril_1_N = mkN "nässelfjäril" ; -- nässelfjäril..nn.1
  nässelkål_1_N = mkN "nässelkål" ; -- nässelkål..nn.1
  nässelsoppa_1_N = mkN "nässelsoppa" ; -- nässelsoppa..nn.1
  nässla_1_N = mkN "nässla" ; -- nässla..nn.1
  nässpets_1_N = mkN "nässpets" ; -- nässpets..nn.1
  nässpray_1_N = mkN "nässpray" "nässprayen" "nässprayer" "nässprayerna" ; -- nässpray..nn.1
  nässprej_1_N = mkN "nässprej" "nässprejer" ; -- nässprej..nn.1
  näst_1_N = mkN "näst" neutrum  ; -- näst..nn.1
  nästa_1_N = mkN "nästa" ; -- nästa..nn.1
  nästa_1_V = mkV "nästar" ; -- nästa..vb.1
  nästan_1_Adv = mkAdv "nästan" ; -- nästan..ab.1
  nästande_1_N = mkN "nästande" ; -- nästande..nn.1
  nästans_1_Adv = mkAdv "nästans" ; -- nästans..ab.1
  näste_1_N = mkN "näste" ; -- näste..nn.1
  nästföljande_1_A = mkA "nästföljande" ; -- nästföljande..av.1
  nästintill_1_Adv = mkAdv "nästintill" ; -- nästintill..ab.1
  nästipp_1_N = mkN "nästipp" ; -- nästipp..nn.1
  nästkommande_1_A = mkA "nästkommande" ; -- nästkommande..av.1
  nästkusin_1_N = mkN "nästkusin" "nästkusiner" ; -- nästkusin..nn.1
  nästliden_1_A = mkA "nästliden" ; -- nästliden..av.1
  näston_1_N = mkN "näston" ; -- näston..nn.1
  nästunge_1_N = mkN "nästunge" utrum  ; -- nästunge..nn.1
  nästägg_1_N = mkN "nästägg" neutrum  ; -- nästägg..nn.1
  nästäppa_1_N = mkN "nästäppa" ; -- nästäppa..nn.1
  näsvinge_1_N = mkN "näsvinge" utrum  ; -- näsvinge..nn.1
  näsvis_1_A = mkA "näsvis" ; -- näsvis..av.1
  näsvishet_1_N = mkN "näsvishet" ; -- näsvishet..nn.1
  nät_1_N = mkN "nät" neutrum  ; -- nät..nn.1
  näta_1_V = mkV "nätar" ; -- näta..vb.1
  nätande_1_N = mkN "nätande" ; -- nätande..nn.1
  nätansluten_1_A = mkA "nätansluten" ; -- nätansluten..av.1
  nätanvändande_1_N = mkN "nätanvändande" ; -- nätanvändande..nn.1
  nätartikel_1_N = mkN "nätartikel" ; -- nätartikel..nn.1
  nätattack_1_N = mkN "nätattack" "nätattacker" ; -- nätattack..nn.1
  nätbaserad_1_A = mkA "nätbaserad" ; -- nätbaserad..av.1
  nätbedragare_1_N = mkN "nätbedragare" utrum  ; -- nätbedragare..nn.1
  nätbedrägeri_1_N = mkN "nätbedrägeri" "nätbedrägeriet" "nätbedrägerier" "nätbedrägerierna" ; -- nätbedrägeri..nn.1
  nätbevakning_1_N = mkN "nätbevakning" ; -- nätbevakning..nn.1
  nätbluff_1_N = mkN "nätbluff" ; -- nätbluff..nn.1
  nätbokning_1_N = mkN "nätbokning" ; -- nätbokning..nn.1
  nätboll_1_N = mkN "nätboll" ; -- nätboll..nn.1
  nätbur_1_N = mkN "nätbur" ; -- nätbur..nn.1
  nätcensur_1_N = mkN "nätcensur" ; -- nätcensur..nn.1
  nätdomare_1_N = mkN "nätdomare" utrum  ; -- nätdomare..nn.1
  nätdrift_1_N = mkN "nätdrift" ; -- nätdrift..nn.1
  nätdrog_1_N = mkN "nätdrog" "nätdroger" ; -- nätdrog..nn.1
  nätdörr_1_N = mkN "nätdörr" ; -- nätdörr..nn.1
  nätfiske_1_N = mkN "nätfiske" ; -- nätfiske..nn.1
  nätformig_1_A = mkA "nätformig" ; -- nätformig..av.1
  nätformighet_1_N = mkN "nätformighet" ; -- nätformighet..nn.1
  nätfönster_1_N = mkN "nätfönster" neutrum  ; -- nätfönster..nn.1
  nätgemenskap_1_N = mkN "nätgemenskap" "nätgemenskaper" ; -- nätgemenskap..nn.1
  nätguru_1_N = mkN "nätguru" "nätgurun" "nätgurus" "nätgurusarna" ; -- nätguru..nn.1
  näthandel_1_N = mkN "näthandel" ; -- näthandel..nn.1
  näthandla_1_V = mkV "näthandlar" ; -- näthandla..vb.1
  näthandlande_1_N = mkN "näthandlande" ; -- näthandlande..nn.1
  näthat_1_N = mkN "näthat" neutrum  ; -- näthat..nn.1
  näthinna_1_N = mkN "näthinna" ; -- näthinna..nn.1
  näthinneavlossning_1_N = mkN "näthinneavlossning" ; -- näthinneavlossning..nn.1
  näthylla_1_N = mkN "näthylla" ; -- näthylla..nn.1
  nätkampanj_1_N = mkN "nätkampanj" "nätkampanjer" ; -- nätkampanj..nn.1
  nätkommunicera_1_V = mkV "nätkommunicerar" ; -- nätkommunicera..vb.1
  nätkommunicerande_1_N = mkN "nätkommunicerande" ; -- nätkommunicerande..nn.1
  nätkommunikation_1_N = mkN "nätkommunikation" ; -- nätkommunikation..nn.1
  nätkontakt_1_N = mkN "nätkontakt" "nätkontakter" ; -- nätkontakt..nn.1
  nätkultur_1_N = mkN "nätkultur" "nätkulturer" ; -- nätkultur..nn.1
  nätmage_1_N = mkN "nätmage" utrum  ; -- nätmage..nn.1
  nätmaska_1_N = mkN "nätmaska" ; -- nätmaska..nn.1
  nätmelon_1_N = mkN "nätmelon" "nätmeloner" ; -- nätmelon..nn.1
  nätnöt_1_N = mkN "nätnöt" "nätnötter" ; -- nätnöt..nn.1
  nätpedofil_1_N = mkN "nätpedofil" "nätpedofiler" ; -- nätpedofil..nn.1
  nätpedofili_1_N = mkN "nätpedofili" ; -- nätpedofili..nn.1
  nätporr_1_N = mkN "nätporr" ; -- nätporr..nn.1
  nätpåse_1_N = mkN "nätpåse" utrum  ; -- nätpåse..nn.1
  nätrullare_1_N = mkN "nätrullare" utrum  ; -- nätrullare..nn.1
  nätsax_1_N = mkN "nätsax" ; -- nätsax..nn.1
  nätspänning_1_N = mkN "nätspänning" ; -- nätspänning..nn.1
  nätstrumpa_1_N = mkN "nätstrumpa" ; -- nätstrumpa..nn.1
  nätsurfare_1_N = mkN "nätsurfare" utrum  ; -- nätsurfare..nn.1
  nätt_1_Adv = mkAdv "nätt" ; -- nätt..ab.1
  nätt_1_A = mkA "nätt" ; -- nätt..av.1
  nättelduk_1_N = mkN "nättelduk" ; -- nättelduk..nn.1
  nätthet_1_N = mkN "nätthet" ; -- nätthet..nn.1
  nättidning_1_N = mkN "nättidning" ; -- nättidning..nn.1
  nätting_1_N = mkN "nätting" ; -- nätting..nn.1
  nättopp_1_Adv = mkAdv "nättopp" ; -- nättopp..ab.1
  nättopp_1_N = mkN "nättopp" ; -- nättopp..nn.1
  nättroll_1_N = mkN "nättroll" neutrum  ; -- nättroll..nn.1
  nättröja_1_N = mkN "nättröja" ; -- nättröja..nn.1
  nättupp_1_Adv = mkAdv "nättupp" ; -- nättupp..ab.1
  nätupplaga_1_N = mkN "nätupplaga" ; -- nätupplaga..nn.1
  nätuppslagsverk_1_N = mkN "nätuppslagsverk" neutrum  ; -- nätuppslagsverk..nn.1
  nätvan_1_A = mkA "nätvan" ; -- nätvan..av.1
  nätvana_1_N = mkN "nätvana" ; -- nätvana..nn.1
  nätverk_1_N = mkN "nätverk" neutrum  ; -- nätverk..nn.1
  nätverka_1_V = mkV "nätverkar" ; -- nätverka..vb.1
  nätverkande_1_N = mkN "nätverkande" ; -- nätverkande..nn.1
  nätverkning_1_N = mkN "nätverkning" ; -- nätverkning..nn.1
  nätverksforskning_1_N = mkN "nätverksforskning" ; -- nätverksforskning..nn.1
  nätverksperspektiv_1_N = mkN "nätverksperspektiv" neutrum  ; -- nätverksperspektiv..nn.1
  nätvinge_1_N = mkN "nätvinge" utrum  ; -- nätvinge..nn.1
  näva_1_N = mkN "näva" ; -- näva..nn.1
  näve_1_N = mkN "näve" utrum  ; -- näve..nn.1
  näver_1_N = mkN "näver" ; -- näver..nn.1
  näverbehållare_1_N = mkN "näverbehållare" utrum  ; -- näverbehållare..nn.1
  näverflak_1_N = mkN "näverflak" neutrum  ; -- näverflak..nn.1
  näverkont_1_N = mkN "näverkont" ; -- näverkont..nn.1
  näverkorg_1_N = mkN "näverkorg" ; -- näverkorg..nn.1
  näverlur_1_N = mkN "näverlur" ; -- näverlur..nn.1
  näversöm_1_N = mkN "näversöm" "näversömmen" "näversömmar" "näversömmarna" ; -- näversöm..nn.1
  nävgröt_1_N = mkN "nävgröt" ; -- nävgröt..nn.1
  nävkamp_1_N = mkN "nävkamp" "nävkamper" ; -- nävkamp..nn.1
  nävrätt_1_N = mkN "nävrätt" ; -- nävrätt..nn.1
  nå_1_V = mkV "når" ; -- nå..vb.1
  nåbar_1_A = mkA "nåbar" ; -- nåbar..av.1
  nåbarhet_1_N = mkN "nåbarhet" "nåbarheter" ; -- nåbarhet..nn.1
  nåd_1_N = mkN "nåd" ; -- nåd..nn.1
  nåd_2_N = mkN "nåd" ; -- nåd..nn.2
  nåda_1_V = mkV "nådar" ; -- nåda..vb.1
  nådande_1_N = mkN "nådande" ; -- nådande..nn.1
  nådaskott_1_N = mkN "nådaskott" neutrum  ; -- nådaskott..nn.1
  nådastol_1_N = mkN "nådastol" ; -- nådastol..nn.1
  nådastöt_1_N = mkN "nådastöt" ; -- nådastöt..nn.1
  nådatid_1_N = mkN "nådatid" ; -- nådatid..nn.1
  nådaval_1_N = mkN "nådaval" neutrum  ; -- nådaval..nn.1
  nåde_1_V = mkV "nådes" ; -- nåde..vb.1
  nådeansökning_1_N = mkN "nådeansökning" ; -- nådeansökning..nn.1
  nådebevis_1_N = mkN "nådebevis" neutrum  ; -- nådebevis..nn.1
  nådebord_1_N = mkN "nådebord" neutrum  ; -- nådebord..nn.1
  nådebröd_1_N = mkN "nådebröd" neutrum  ; -- nådebröd..nn.1
  nådegåva_1_N = mkN "nådegåva" ; -- nådegåva..nn.1
  nådehjon_1_N = mkN "nådehjon" neutrum  ; -- nådehjon..nn.1
  nådelig_1_A = mkA "nådelig" ; -- nådelig..av.1
  nådeligen_1_Adv = mkAdv "nådeligen" ; -- nådeligen..ab.1
  nådelighet_1_N = mkN "nådelighet" ; -- nådelighet..nn.1
  nådemedel_1_N = mkN "nådemedel" neutrum  ; -- nådemedel..nn.1
  nåderik_1_A = mkA "nåderik" ; -- nåderik..av.1
  nådevedermäle_1_N = mkN "nådevedermäle" ; -- nådevedermäle..nn.1
  nådig_1_A = mkA "nådig" ; -- nådig..av.1
  nådning_1_N = mkN "nådning" ; -- nådning..nn.1
  nådår_1_N = mkN "nådår" neutrum  ; -- nådår..nn.1
  nående_1_N = mkN "nående" ; -- nående..nn.1
  någongång_1_Adv = mkAdv "någongång" ; -- någongång..ab.1
  någonsin_1_Adv = mkAdv "någonsin" ; -- någonsin..ab.1
  någonstans_1_Adv = mkAdv "någonstans" ; -- någonstans..ab.1
  någonvart_1_Adv = mkAdv "någonvart" ; -- någonvart..ab.1
  någorlunda_1_Adv = mkAdv "någorlunda" ; -- någorlunda..ab.1
  någotsånär_1_Adv = mkAdv "någotsånär" ; -- någotsånär..ab.1
  nål_1_N = mkN "nål" ; -- nål..nn.1
  nåla_1_V = mkV "nålar" ; -- nåla..vb.1
  nålande_1_N = mkN "nålande" ; -- nålande..nn.1
  nålbrev_1_N = mkN "nålbrev" neutrum  ; -- nålbrev..nn.1
  nåldyna_1_N = mkN "nåldyna" ; -- nåldyna..nn.1
  nålfil_1_N = mkN "nålfil" ; -- nålfil..nn.1
  nålfiltmatta_1_N = mkN "nålfiltmatta" ; -- nålfiltmatta..nn.1
  nålfiltsmatta_1_N = mkN "nålfiltsmatta" ; -- nålfiltsmatta..nn.1
  nålfin_1_A = mkA "nålfin" ; -- nålfin..av.1
  nålformig_1_A = mkA "nålformig" ; -- nålformig..av.1
  nålkort_1_N = mkN "nålkort" neutrum  ; -- nålkort..nn.1
  nålmikrofon_1_N = mkN "nålmikrofon" "nålmikrofoner" ; -- nålmikrofon..nn.1
  nålpeng_1_N = mkN "nålpeng" ; -- nålpeng..nn.1
  nålshuvud_1_N = mkN "nålshuvud" "nålshuvudet" "nålshuvud" "nålshuvudena" ; -- nålshuvud..nn.1
  nålspets_1_N = mkN "nålspets" ; -- nålspets..nn.1
  nålstick_1_N = mkN "nålstick" neutrum  ; -- nålstick..nn.1
  nålsticksangrepp_1_N = mkN "nålsticksangrepp" neutrum  ; -- nålsticksangrepp..nn.1
  nålsting_1_N = mkN "nålsting" neutrum  ; -- nålsting..nn.1
  nålstygn_1_N = mkN "nålstygn" neutrum  ; -- nålstygn..nn.1
  nålstyng_1_N = mkN "nålstyng" neutrum  ; -- nålstyng..nn.1
  nålsudd_1_N = mkN "nålsudd" ; -- nålsudd..nn.1
  nålsöga_1_N = mkN "nålsöga" "nålsögat" "nålsögon" "nålsögonen" ; -- nålsöga..nn.1
  nålventil_1_N = mkN "nålventil" "nålventiler" ; -- nålventil..nn.1
  nångång_1_Adv = mkAdv "nångång" ; -- nångång..ab.1
  nånstans_1_Adv = mkAdv "nånstans" ; -- nånstans..ab.1
  nånvart_1_Adv = mkAdv "nånvart" ; -- nånvart..ab.1
  nåt_1_N = mkN "nåt" ; -- nåt..nn.1
  nåta_1_V = mkV "nåtar" ; -- nåta..vb.1
  nåtande_1_N = mkN "nåtande" ; -- nåtande..nn.1
  nåtla_1_V = mkV "nåtlar" ; -- nåtla..vb.1
  nåtlande_1_N = mkN "nåtlande" ; -- nåtlande..nn.1
  nåtling_1_N = mkN "nåtling" ; -- nåtling..nn.1
  nåtsånär_1_Adv = mkAdv "nåtsånär" ; -- nåtsånär..ab.1
  nöd_1_N = mkN "nöd" ; -- nöd..nn.1
  nödankare_1_N = mkN "nödankare" "nödankaret" "nödankaren" "nödankarna" ; -- nödankare..nn.1
  nödanrop_1_N = mkN "nödanrop" neutrum  ; -- nödanrop..nn.1
  nödbedd_1_A = mkA "nödbedd" ; -- nödbedd..av.1
  nödbeddhet_1_N = mkN "nödbeddhet" ; -- nödbeddhet..nn.1
  nödbjuden_1_A = mkA "nödbjuden" ; -- nödbjuden..av.1
  nödbroms_1_N = mkN "nödbroms" ; -- nödbroms..nn.1
  nödbromsa_1_V = mkV "nödbromsar" ; -- nödbromsa..vb.1
  nödbromsande_1_N = mkN "nödbromsande" ; -- nödbromsande..nn.1
  nödd_1_A = mkA "nödd" ; -- nödd..av.1
  nöddhet_1_N = mkN "nöddhet" ; -- nöddhet..nn.1
  nöddop_1_N = mkN "nöddop" neutrum  ; -- nöddop..nn.1
  nödfall_1_N = mkN "nödfall" neutrum  ; -- nödfall..nn.1
  nödfallsutväg_1_N = mkN "nödfallsutväg" ; -- nödfallsutväg..nn.1
  nödflagg_1_N = mkN "nödflagg" ; -- nödflagg..nn.1
  nödflagga_1_N = mkN "nödflagga" ; -- nödflagga..nn.1
  nödga_1_V = mkV "nödgar" ; -- nödga..vb.1
  nödgande_1_N = mkN "nödgande" ; -- nödgande..nn.1
  nödhamn_1_N = mkN "nödhamn" ; -- nödhamn..nn.1
  nödhjälp_1_N = mkN "nödhjälp" ; -- nödhjälp..nn.1
  nödig_1_A = mkA "nödig" ; -- nödig..av.1
  nödlanda_1_V = mkV "nödlandar" ; -- nödlanda..vb.1
  nödlandande_1_N = mkN "nödlandande" ; -- nödlandande..nn.1
  nödlandning_1_N = mkN "nödlandning" ; -- nödlandning..nn.1
  nödlidande_1_A = mkA "nödlidande" ; -- nödlidande..av.1
  nödläge_1_N = mkN "nödläge" ; -- nödläge..nn.1
  nödlån_1_N = mkN "nödlån" neutrum  ; -- nödlån..nn.1
  nödlögn_1_N = mkN "nödlögn" "nödlögner" ; -- nödlögn..nn.1
  nödlösning_1_N = mkN "nödlösning" ; -- nödlösning..nn.1
  nödmynt_1_N = mkN "nödmynt" neutrum  ; -- nödmynt..nn.1
  nödproviant_1_N = mkN "nödproviant" ; -- nödproviant..nn.1
  nödraket_1_N = mkN "nödraket" "nödraketer" ; -- nödraket..nn.1
  nödrim_1_N = mkN "nödrim" "nödrimmet" "nödrim" "nödrimmen" ; -- nödrim..nn.1
  nödrop_1_N = mkN "nödrop" neutrum  ; -- nödrop..nn.1
  nödrätt_1_N = mkN "nödrätt" ; -- nödrätt..nn.1
  nödsaka_1_V = mkV "nödsakar" ; -- nödsaka..vb.1
  nödsakad_1_A = mkA "nödsakad" ; -- nödsakad..av.1
  nödsakande_1_N = mkN "nödsakande" ; -- nödsakande..nn.1
  nödsamtal_1_N = mkN "nödsamtal" neutrum  ; -- nödsamtal..nn.1
  nödsignal_1_N = mkN "nödsignal" "nödsignaler" ; -- nödsignal..nn.1
  nödsignalera_1_V = mkV "nödsignalerar" ; -- nödsignalera..vb.1
  nödsignalerande_1_N = mkN "nödsignalerande" ; -- nödsignalerande..nn.1
  nödsignalering_1_N = mkN "nödsignalering" ; -- nödsignalering..nn.1
  nödsituation_1_N = mkN "nödsituation" ; -- nödsituation..nn.1
  nödsituationslampa_1_N = mkN "nödsituationslampa" ; -- nödsituationslampa..nn.1
  nödslakt_1_N = mkN "nödslakt" ; -- nödslakt..nn.1
  nödstopp_1_N = mkN "nödstopp" neutrum  ; -- nödstopp..nn.1
  nödstoppa_1_V = mkV "nödstoppar" ; -- nödstoppa..vb.1
  nödstoppande_1_N = mkN "nödstoppande" ; -- nödstoppande..nn.1
  nödställd_1_A = mkA "nödställd" "nödställt" ; -- nödställd..av.1
  nödställdhet_1_N = mkN "nödställdhet" ; -- nödställdhet..nn.1
  nödtorft_1_N = mkN "nödtorft" ; -- nödtorft..nn.1
  nödtorftig_1_A = mkA "nödtorftig" ; -- nödtorftig..av.1
  nödtorftighet_1_N = mkN "nödtorftighet" "nödtorftigheter" ; -- nödtorftighet..nn.1
  nödtvungen_1_A = mkA "nödtvungen" ; -- nödtvungen..av.1
  nödtvång_1_N = mkN "nödtvång" neutrum  ; -- nödtvång..nn.1
  nödutgång_1_N = mkN "nödutgång" ; -- nödutgång..nn.1
  nödvuxen_1_A = mkA "nödvuxen" ; -- nödvuxen..av.1
  nödvändig_1_A = mkA "nödvändig" ; -- nödvändig..av.1
  nödvändiggöra_1_V = mkV "nödvändiggöra" "nödvändiggjorde" "nödvändiggjort" ; -- nödvändiggöra..vb.1
  nödvändiggörande_1_N = mkN "nödvändiggörande" ; -- nödvändiggörande..nn.1
  nödvändighet_1_N = mkN "nödvändighet" "nödvändigheter" ; -- nödvändighet..nn.1
  nödvändighetsartikel_1_N = mkN "nödvändighetsartikel" ; -- nödvändighetsartikel..nn.1
  nödvändighetsvara_1_N = mkN "nödvändighetsvara" ; -- nödvändighetsvara..nn.1
  nödvändigtvis_1_Adv = mkAdv "nödvändigtvis" ; -- nödvändigtvis..ab.1
  nödvärn_1_N = mkN "nödvärn" ; -- nödvärn..nn.1
  nödvärnsrätt_1_N = mkN "nödvärnsrätt" ; -- nödvärnsrätt..nn.1
  nödår_1_N = mkN "nödår" neutrum  ; -- nödår..nn.1
  nödöppna_1_V = mkV "nödöppnar" ; -- nödöppna..vb.1
  nödöppnande_1_N = mkN "nödöppnande" ; -- nödöppnande..nn.1
  nöjaktig_1_A = mkA "nöjaktig" ; -- nöjaktig..av.1
  nöjaktighet_1_N = mkN "nöjaktighet" ; -- nöjaktighet..nn.1
  nöjd_1_A = mkA "nöjd" "nöjt" ; -- nöjd..av.1
  nöjdförklaring_1_N = mkN "nöjdförklaring" ; -- nöjdförklaring..nn.1
  nöjdhet_1_N = mkN "nöjdhet" ; -- nöjdhet..nn.1
  nöje_1_N = mkN "nöje" ; -- nöje..nn.1
  nöjesbegär_1_N = mkN "nöjesbegär" neutrum  ; -- nöjesbegär..nn.1
  nöjesbransch_1_N = mkN "nöjesbransch" ; -- nöjesbransch..nn.1
  nöjesbåt_1_N = mkN "nöjesbåt" ; -- nöjesbåt..nn.1
  nöjesdistrikt_1_N = mkN "nöjesdistrikt" neutrum  ; -- nöjesdistrikt..nn.1
  nöjesetablissemang_1_N = mkN "nöjesetablissemang" neutrum  ; -- nöjesetablissemang..nn.1
  nöjesfiskare_1_N = mkN "nöjesfiskare" utrum  ; -- nöjesfiskare..nn.1
  nöjesfiske_1_N = mkN "nöjesfiske" ; -- nöjesfiske..nn.1
  nöjesfält_1_N = mkN "nöjesfält" neutrum  ; -- nöjesfält..nn.1
  nöjeshall_1_N = mkN "nöjeshall" ; -- nöjeshall..nn.1
  nöjesjakt_1_N = mkN "nöjesjakt" ; -- nöjesjakt..nn.1
  nöjeskörning_1_N = mkN "nöjeskörning" ; -- nöjeskörning..nn.1
  nöjesliv_1_N = mkN "nöjesliv" neutrum  ; -- nöjesliv..nn.1
  nöjeslokal_1_N = mkN "nöjeslokal" "nöjeslokaler" ; -- nöjeslokal..nn.1
  nöjeslysten_1_A = mkA "nöjeslysten" ; -- nöjeslysten..av.1
  nöjeslystnad_1_N = mkN "nöjeslystnad" ; -- nöjeslystnad..nn.1
  nöjesläsande_1_N = mkN "nöjesläsande" ; -- nöjesläsande..nn.1
  nöjesläsning_1_N = mkN "nöjesläsning" ; -- nöjesläsning..nn.1
  nöjesmaskin_1_N = mkN "nöjesmaskin" "nöjesmaskiner" ; -- nöjesmaskin..nn.1
  nöjesmord_1_N = mkN "nöjesmord" neutrum  ; -- nöjesmord..nn.1
  nöjesmörda_1_V = mkV "nöjesmördar" ; -- nöjesmörda..vb.1
  nöjesmördande_1_N = mkN "nöjesmördande" ; -- nöjesmördande..nn.1
  nöjespalats_1_N = mkN "nöjespalats" neutrum  ; -- nöjespalats..nn.1
  nöjespappa_1_N = mkN "nöjespappa" ; -- nöjespappa..nn.1
  nöjespark_1_N = mkN "nöjespark" "nöjesparker" ; -- nöjespark..nn.1
  nöjesprogram_1_N = mkN "nöjesprogram" "nöjesprogrammet" "nöjesprogram" "nöjesprogrammen" ; -- nöjesprogram..nn.1
  nöjesresa_1_N = mkN "nöjesresa" ; -- nöjesresa..nn.1
  nöjesresenär_1_N = mkN "nöjesresenär" "nöjesresenärer" ; -- nöjesresenär..nn.1
  nöjesskäl_1_N = mkN "nöjesskäl" neutrum  ; -- nöjesskäl..nn.1
  nöjestur_1_N = mkN "nöjestur" "nöjesturer" ; -- nöjestur..nn.1
  nöjsam_1_A = mkA "nöjsam" "nöjsamt" "nöjsamma" "nöjsamma" "nöjsammare" "nöjsammast" "nöjsammaste" ; -- nöjsam..av.1
  nöjsamhet_1_N = mkN "nöjsamhet" ; -- nöjsamhet..nn.1
  nörd_1_N = mkN "nörd" ; -- nörd..nn.1
  nörderi_1_N = mkN "nörderi" "nörderiet" "nörderier" "nörderierna" ; -- nörderi..nn.1
  nördig_1_A = mkA "nördig" ; -- nördig..av.1
  nördighet_1_N = mkN "nördighet" ; -- nördighet..nn.1
  nöt_1_N = mkN "nöt" "nötter" ; -- nöt..nn.1
  nöt_2_N = mkN "nöt" neutrum  ; -- nöt..nn.2
  nöta_1_V = mkV "nöter" ; -- nöta..vb.1
  nötande_1_N = mkN "nötande" ; -- nötande..nn.1
  nötbarhet_1_N = mkN "nötbarhet" "nötbarheter" ; -- nötbarhet..nn.1
  nötboskap_1_N = mkN "nötboskap" ; -- nötboskap..nn.1
  nötbrun_1_A = mkA "nötbrun" ; -- nötbrun..av.1
  nötchoklad_1_N = mkN "nötchoklad" ; -- nötchoklad..nn.1
  nötfnas_1_N = mkN "nötfnas" neutrum  ; -- nötfnas..nn.1
  nötfrukt_1_N = mkN "nötfrukt" "nötfrukter" ; -- nötfrukt..nn.1
  nöthår_1_N = mkN "nöthår" neutrum  ; -- nöthår..nn.1
  nötknäckare_1_N = mkN "nötknäckare" utrum  ; -- nötknäckare..nn.1
  nötknäpparansikte_1_N = mkN "nötknäpparansikte" ; -- nötknäpparansikte..nn.1
  nötknäppare_1_N = mkN "nötknäppare" utrum  ; -- nötknäppare..nn.1
  nötkreatur_1_N = mkN "nötkreatur" neutrum  ; -- nötkreatur..nn.1
  nötkreatursdrift_1_N = mkN "nötkreatursdrift" ; -- nötkreatursdrift..nn.1
  nötkråka_1_N = mkN "nötkråka" ; -- nötkråka..nn.1
  nötkärna_1_N = mkN "nötkärna" ; -- nötkärna..nn.1
  nötkött_1_N = mkN "nötkött" neutrum  ; -- nötkött..nn.1
  nötliknande_1_A = mkA "nötliknande" ; -- nötliknande..av.1
  nötmassa_1_N = mkN "nötmassa" ; -- nötmassa..nn.1
  nötning_1_N = mkN "nötning" ; -- nötning..nn.1
  nötningsbeständig_1_A = mkA "nötningsbeständig" ; -- nötningsbeständig..av.1
  nötningsbeständighet_1_N = mkN "nötningsbeständighet" ; -- nötningsbeständighet..nn.1
  nötningsresistans_1_N = mkN "nötningsresistans" ; -- nötningsresistans..nn.1
  nötningsresistent_1_A = mkA "nötningsresistent" ; -- nötningsresistent..av.1
  nötolja_1_N = mkN "nötolja" ; -- nötolja..nn.1
  nötskal_1_N = mkN "nötskal" neutrum  ; -- nötskal..nn.1
  nötskrika_1_N = mkN "nötskrika" ; -- nötskrika..nn.1
  nötstyng_1_N = mkN "nötstyng" neutrum  ; -- nötstyng..nn.1
  nött_1_A = mkA "nött" ; -- nött..av.1
  nötvivel_1_N = mkN "nötvivel" ; -- nötvivel..nn.1
  nötväcka_1_N = mkN "nötväcka" ; -- nötväcka..nn.1
  o_1_N = mkN "o" neutrum  ; -- o..nn.1
  oabbrevierad_1_A = mkA "oabbrevierad" ; -- oabbrevierad..av.1
  oabbrevierbar_1_A = mkA "oabbrevierbar" ; -- oabbrevierbar..av.1
  oabbrevierbarhet_1_N = mkN "oabbrevierbarhet" ; -- oabbrevierbarhet..nn.1
  oabdikerad_1_A = mkA "oabdikerad" ; -- oabdikerad..av.1
  oabdikerbar_1_A = mkA "oabdikerbar" ; -- oabdikerbar..av.1
  oabdikerbarhet_1_N = mkN "oabdikerbarhet" ; -- oabdikerbarhet..nn.1
  oabonnerad_1_A = mkA "oabonnerad" ; -- oabonnerad..av.1
  oabonnerbar_1_A = mkA "oabonnerbar" ; -- oabonnerbar..av.1
  oabonnerbarhet_1_N = mkN "oabonnerbarhet" ; -- oabonnerbarhet..nn.1
  oaborterad_1_A = mkA "oaborterad" ; -- oaborterad..av.1
  oaborterbar_1_A = mkA "oaborterbar" ; -- oaborterbar..av.1
  oaborterbarhet_1_N = mkN "oaborterbarhet" ; -- oaborterbarhet..nn.1
  oabraderad_1_A = mkA "oabraderad" ; -- oabraderad..av.1
  oabraderbar_1_A = mkA "oabraderbar" ; -- oabraderbar..av.1
  oabraderbarhet_1_N = mkN "oabraderbarhet" ; -- oabraderbarhet..nn.1
  oabsolverad_1_A = mkA "oabsolverad" ; -- oabsolverad..av.1
  oabsolverbar_1_A = mkA "oabsolverbar" ; -- oabsolverbar..av.1
  oabsolverbarhet_1_N = mkN "oabsolverbarhet" ; -- oabsolverbarhet..nn.1
  oabsorberad_1_A = mkA "oabsorberad" ; -- oabsorberad..av.1
  oabsorberbar_1_A = mkA "oabsorberbar" ; -- oabsorberbar..av.1
  oabsorberbarhet_1_N = mkN "oabsorberbarhet" ; -- oabsorberbarhet..nn.1
  oabstraherad_1_A = mkA "oabstraherad" ; -- oabstraherad..av.1
  oabstraherbar_1_A = mkA "oabstraherbar" ; -- oabstraherbar..av.1
  oabstraherbarhet_1_N = mkN "oabstraherbarhet" ; -- oabstraherbarhet..nn.1
  oaccederad_1_A = mkA "oaccederad" ; -- oaccederad..av.1
  oaccederbar_1_A = mkA "oaccederbar" ; -- oaccederbar..av.1
  oaccederbarhet_1_N = mkN "oaccederbarhet" ; -- oaccederbarhet..nn.1
  oaccelererad_1_A = mkA "oaccelererad" ; -- oaccelererad..av.1
  oaccelererbar_1_A = mkA "oaccelererbar" ; -- oaccelererbar..av.1
  oaccelererbarhet_1_N = mkN "oaccelererbarhet" ; -- oaccelererbarhet..nn.1
  oaccentuerad_1_A = mkA "oaccentuerad" ; -- oaccentuerad..av.1
  oaccentuerbar_1_A = mkA "oaccentuerbar" ; -- oaccentuerbar..av.1
  oaccentuerbarhet_1_N = mkN "oaccentuerbarhet" ; -- oaccentuerbarhet..nn.1
  oacceptabel_1_A = mkA "oacceptabel" ; -- oacceptabel..av.1
  oaccepterad_1_A = mkA "oaccepterad" ; -- oaccepterad..av.1
  oaccepterbar_1_A = mkA "oaccepterbar" ; -- oaccepterbar..av.1
  oaccepterbarhet_1_N = mkN "oaccepterbarhet" ; -- oaccepterbarhet..nn.1
  oacklimatiserad_1_A = mkA "oacklimatiserad" ; -- oacklimatiserad..av.1
  oacklimatiserbar_1_A = mkA "oacklimatiserbar" ; -- oacklimatiserbar..av.1
  oacklimatiserbarhet_1_N = mkN "oacklimatiserbarhet" ; -- oacklimatiserbarhet..nn.1
  oackommoderad_1_A = mkA "oackommoderad" ; -- oackommoderad..av.1
  oackommoderbar_1_A = mkA "oackommoderbar" ; -- oackommoderbar..av.1
  oackommoderbarhet_1_N = mkN "oackommoderbarhet" ; -- oackommoderbarhet..nn.1
  oackompanjerad_1_A = mkA "oackompanjerad" ; -- oackompanjerad..av.1
  oackompanjerbar_1_A = mkA "oackompanjerbar" ; -- oackompanjerbar..av.1
  oackompanjerbarhet_1_N = mkN "oackompanjerbarhet" ; -- oackompanjerbarhet..nn.1
  oackorderad_1_A = mkA "oackorderad" ; -- oackorderad..av.1
  oackorderbar_1_A = mkA "oackorderbar" ; -- oackorderbar..av.1
  oackorderbarhet_1_N = mkN "oackorderbarhet" ; -- oackorderbarhet..nn.1
  oackrediterad_1_A = mkA "oackrediterad" ; -- oackrediterad..av.1
  oackrediterbar_1_A = mkA "oackrediterbar" ; -- oackrediterbar..av.1
  oackrediterbarhet_1_N = mkN "oackrediterbarhet" ; -- oackrediterbarhet..nn.1
  oackumulerad_1_A = mkA "oackumulerad" ; -- oackumulerad..av.1
  oackumulerbar_1_A = mkA "oackumulerbar" ; -- oackumulerbar..av.1
  oackumulerbarhet_1_N = mkN "oackumulerbarhet" ; -- oackumulerbarhet..nn.1
  oackvirerad_1_A = mkA "oackvirerad" ; -- oackvirerad..av.1
  oackvirerbar_1_A = mkA "oackvirerbar" ; -- oackvirerbar..av.1
  oackvirerbarhet_1_N = mkN "oackvirerbarhet" ; -- oackvirerbarhet..nn.1
  oadapterad_1_A = mkA "oadapterad" ; -- oadapterad..av.1
  oadapterbar_1_A = mkA "oadapterbar" ; -- oadapterbar..av.1
  oadapterbarhet_1_N = mkN "oadapterbarhet" ; -- oadapterbarhet..nn.1
  oadderad_1_A = mkA "oadderad" ; -- oadderad..av.1
  oadderbar_1_A = mkA "oadderbar" ; -- oadderbar..av.1
  oadderbarhet_1_N = mkN "oadderbarhet" ; -- oadderbarhet..nn.1
  oadjungerad_1_A = mkA "oadjungerad" ; -- oadjungerad..av.1
  oadjungerbar_1_A = mkA "oadjungerbar" ; -- oadjungerbar..av.1
  oadjungerbarhet_1_N = mkN "oadjungerbarhet" ; -- oadjungerbarhet..nn.1
  oadlad_1_A = mkA "oadlad" ; -- oadlad..av.1
  oadministrerad_1_A = mkA "oadministrerad" ; -- oadministrerad..av.1
  oadministrerbar_1_A = mkA "oadministrerbar" ; -- oadministrerbar..av.1
  oadministrerbarhet_1_N = mkN "oadministrerbarhet" ; -- oadministrerbarhet..nn.1
  oadopterad_1_A = mkA "oadopterad" ; -- oadopterad..av.1
  oadopterbar_1_A = mkA "oadopterbar" ; -- oadopterbar..av.1
  oadopterbarhet_1_N = mkN "oadopterbarhet" ; -- oadopterbarhet..nn.1
  oadresserad_1_A = mkA "oadresserad" ; -- oadresserad..av.1
  oadresserbar_1_A = mkA "oadresserbar" ; -- oadresserbar..av.1
  oadresserbarhet_1_N = mkN "oadresserbarhet" ; -- oadresserbarhet..nn.1
  oadsorberad_1_A = mkA "oadsorberad" ; -- oadsorberad..av.1
  oadsorberbar_1_A = mkA "oadsorberbar" ; -- oadsorberbar..av.1
  oadsorberbarhet_1_N = mkN "oadsorberbarhet" ; -- oadsorberbarhet..nn.1
  oaducerad_1_A = mkA "oaducerad" ; -- oaducerad..av.1
  oaducerbar_1_A = mkA "oaducerbar" ; -- oaducerbar..av.1
  oaducerbarhet_1_N = mkN "oaducerbarhet" ; -- oaducerbarhet..nn.1
  oadvocerad_1_A = mkA "oadvocerad" ; -- oadvocerad..av.1
  oadvocerbar_1_A = mkA "oadvocerbar" ; -- oadvocerbar..av.1
  oadvocerbarhet_1_N = mkN "oadvocerbarhet" ; -- oadvocerbarhet..nn.1
  oafficierad_1_A = mkA "oafficierad" ; -- oafficierad..av.1
  oafficierbar_1_A = mkA "oafficierbar" ; -- oafficierbar..av.1
  oafficierbarhet_1_N = mkN "oafficierbarhet" ; -- oafficierbarhet..nn.1
  oaffinerad_1_A = mkA "oaffinerad" ; -- oaffinerad..av.1
  oaffinerbar_1_A = mkA "oaffinerbar" ; -- oaffinerbar..av.1
  oaffinerbarhet_1_N = mkN "oaffinerbarhet" ; -- oaffinerbarhet..nn.1
  oaffischerad_1_A = mkA "oaffischerad" ; -- oaffischerad..av.1
  oaffischerbar_1_A = mkA "oaffischerbar" ; -- oaffischerbar..av.1
  oaffischerbarhet_1_N = mkN "oaffischerbarhet" ; -- oaffischerbarhet..nn.1
  oafrikaniserad_1_A = mkA "oafrikaniserad" ; -- oafrikaniserad..av.1
  oafrikaniserbar_1_A = mkA "oafrikaniserbar" ; -- oafrikaniserbar..av.1
  oafrikaniserbarhet_1_N = mkN "oafrikaniserbarhet" ; -- oafrikaniserbarhet..nn.1
  oagad_1_A = mkA "oagad" ; -- oagad..av.1
  oagerad_1_A = mkA "oagerad" ; -- oagerad..av.1
  oagerbar_1_A = mkA "oagerbar" ; -- oagerbar..av.1
  oagerbarhet_1_N = mkN "oagerbarhet" ; -- oagerbarhet..nn.1
  oagglomererad_1_A = mkA "oagglomererad" ; -- oagglomererad..av.1
  oagglomererbar_1_A = mkA "oagglomererbar" ; -- oagglomererbar..av.1
  oagglomererbarhet_1_N = mkN "oagglomererbarhet" ; -- oagglomererbarhet..nn.1
  oagglutinerad_1_A = mkA "oagglutinerad" ; -- oagglutinerad..av.1
  oagglutinerbar_1_A = mkA "oagglutinerbar" ; -- oagglutinerbar..av.1
  oagglutinerbarhet_1_N = mkN "oagglutinerbarhet" ; -- oagglutinerbarhet..nn.1
  oagiterad_1_A = mkA "oagiterad" ; -- oagiterad..av.1
  oagiterbar_1_A = mkA "oagiterbar" ; -- oagiterbar..av.1
  oagiterbarhet_1_N = mkN "oagiterbarhet" ; -- oagiterbarhet..nn.1
  oagnad_1_A = mkA "oagnad" ; -- oagnad..av.1
  oajournerad_1_A = mkA "oajournerad" ; -- oajournerad..av.1
  oajournerbar_1_A = mkA "oajournerbar" ; -- oajournerbar..av.1
  oajournerbarhet_1_N = mkN "oajournerbarhet" ; -- oajournerbarhet..nn.1
  oaktad_1_A = mkA "oaktad" ; -- oaktad..av.1
  oaktiverad_1_A = mkA "oaktiverad" ; -- oaktiverad..av.1
  oaktiverbar_1_A = mkA "oaktiverbar" ; -- oaktiverbar..av.1
  oaktiverbarhet_1_N = mkN "oaktiverbarhet" ; -- oaktiverbarhet..nn.1
  oaktsam_1_A = mkA "oaktsam" "oaktsamt" "oaktsamma" "oaktsamma" "oaktsammare" "oaktsammast" "oaktsammaste" ; -- oaktsam..av.1
  oaktsamhet_1_N = mkN "oaktsamhet" "oaktsamheter" ; -- oaktsamhet..nn.1
  oaktsamhetsbrott_1_N = mkN "oaktsamhetsbrott" neutrum  ; -- oaktsamhetsbrott..nn.1
  oaktualiserad_1_A = mkA "oaktualiserad" ; -- oaktualiserad..av.1
  oaktualiserbar_1_A = mkA "oaktualiserbar" ; -- oaktualiserbar..av.1
  oaktualiserbarhet_1_N = mkN "oaktualiserbarhet" ; -- oaktualiserbarhet..nn.1
  oalarmerad_1_A = mkA "oalarmerad" ; -- oalarmerad..av.1
  oalarmerbar_1_A = mkA "oalarmerbar" ; -- oalarmerbar..av.1
  oalarmerbarhet_1_N = mkN "oalarmerbarhet" ; -- oalarmerbarhet..nn.1
  oalfabetiserad_1_A = mkA "oalfabetiserad" ; -- oalfabetiserad..av.1
  oalfabetiserbar_1_A = mkA "oalfabetiserbar" ; -- oalfabetiserbar..av.1
  oalfabetiserbarhet_1_N = mkN "oalfabetiserbarhet" ; -- oalfabetiserbarhet..nn.1
  oalienerad_1_A = mkA "oalienerad" ; -- oalienerad..av.1
  oalienerbar_1_A = mkA "oalienerbar" ; -- oalienerbar..av.1
  oalienerbarhet_1_N = mkN "oalienerbarhet" ; -- oalienerbarhet..nn.1
  oallegoriserad_1_A = mkA "oallegoriserad" ; -- oallegoriserad..av.1
  oallegoriserbar_1_A = mkA "oallegoriserbar" ; -- oallegoriserbar..av.1
  oallegoriserbarhet_1_N = mkN "oallegoriserbarhet" ; -- oallegoriserbarhet..nn.1
  oallierad_1_A = mkA "oallierad" ; -- oallierad..av.1
  oallierbar_1_A = mkA "oallierbar" ; -- oallierbar..av.1
  oallierbarhet_1_N = mkN "oallierbarhet" ; -- oallierbarhet..nn.1
  oallittererad_1_A = mkA "oallittererad" ; -- oallittererad..av.1
  oallittererbar_1_A = mkA "oallittererbar" ; -- oallittererbar..av.1
  oallittererbarhet_1_N = mkN "oallittererbarhet" ; -- oallittererbarhet..nn.1
  oallmänbildad_1_A = mkA "oallmänbildad" ; -- oallmänbildad..av.1
  oallokerad_1_A = mkA "oallokerad" ; -- oallokerad..av.1
  oallokerbar_1_A = mkA "oallokerbar" ; -- oallokerbar..av.1
  oallokerbarhet_1_N = mkN "oallokerbarhet" ; -- oallokerbarhet..nn.1
  oalluderad_1_A = mkA "oalluderad" ; -- oalluderad..av.1
  oalluderbar_1_A = mkA "oalluderbar" ; -- oalluderbar..av.1
  oalluderbarhet_1_N = mkN "oalluderbarhet" ; -- oalluderbarhet..nn.1
  oalstrad_1_A = mkA "oalstrad" ; -- oalstrad..av.1
  oalternerad_1_A = mkA "oalternerad" ; -- oalternerad..av.1
  oalternerbar_1_A = mkA "oalternerbar" ; -- oalternerbar..av.1
  oalternerbarhet_1_N = mkN "oalternerbarhet" ; -- oalternerbarhet..nn.1
  oaluminerad_1_A = mkA "oaluminerad" ; -- oaluminerad..av.1
  oaluminerbar_1_A = mkA "oaluminerbar" ; -- oaluminerbar..av.1
  oaluminerbarhet_1_N = mkN "oaluminerbarhet" ; -- oaluminerbarhet..nn.1
  oamalgamerad_1_A = mkA "oamalgamerad" ; -- oamalgamerad..av.1
  oamalgamerbar_1_A = mkA "oamalgamerbar" ; -- oamalgamerbar..av.1
  oamalgamerbarhet_1_N = mkN "oamalgamerbarhet" ; -- oamalgamerbarhet..nn.1
  oambulerad_1_A = mkA "oambulerad" ; -- oambulerad..av.1
  oambulerbar_1_A = mkA "oambulerbar" ; -- oambulerbar..av.1
  oambulerbarhet_1_N = mkN "oambulerbarhet" ; -- oambulerbarhet..nn.1
  oamerikaniserad_1_A = mkA "oamerikaniserad" ; -- oamerikaniserad..av.1
  oamerikaniserbar_1_A = mkA "oamerikaniserbar" ; -- oamerikaniserbar..av.1
  oamerikaniserbarhet_1_N = mkN "oamerikaniserbarhet" ; -- oamerikaniserbarhet..nn.1
  oamerikansk_1_A = mkA "oamerikansk" ; -- oamerikansk..av.1
  oammad_1_A = mkA "oammad" ; -- oammad..av.1
  oamorterad_1_A = mkA "oamorterad" ; -- oamorterad..av.1
  oamorterbar_1_A = mkA "oamorterbar" ; -- oamorterbar..av.1
  oamorterbarhet_1_N = mkN "oamorterbarhet" ; -- oamorterbarhet..nn.1
  oamplifierad_1_A = mkA "oamplifierad" ; -- oamplifierad..av.1
  oamplifierbar_1_A = mkA "oamplifierbar" ; -- oamplifierbar..av.1
  oamplifierbarhet_1_N = mkN "oamplifierbarhet" ; -- oamplifierbarhet..nn.1
  oamputerad_1_A = mkA "oamputerad" ; -- oamputerad..av.1
  oamputerbar_1_A = mkA "oamputerbar" ; -- oamputerbar..av.1
  oamputerbarhet_1_N = mkN "oamputerbarhet" ; -- oamputerbarhet..nn.1
  oanad_1_A = mkA "oanad" ; -- oanad..av.1
  oanalyserad_1_A = mkA "oanalyserad" ; -- oanalyserad..av.1
  oanalyserbar_1_A = mkA "oanalyserbar" ; -- oanalyserbar..av.1
  oanalyserbarhet_1_N = mkN "oanalyserbarhet" ; -- oanalyserbarhet..nn.1
  oanammad_1_A = mkA "oanammad" ; -- oanammad..av.1
  oanbefalld_1_A = mkA "oanbefalld" "oanbefallt" ; -- oanbefalld..av.1
  oandlig_1_A = mkA "oandlig" ; -- oandlig..av.1
  oandlighet_1_N = mkN "oandlighet" ; -- oandlighet..nn.1
  oanfrätt_1_A = mkA "oanfrätt" ; -- oanfrätt..av.1
  oanfrätthet_1_N = mkN "oanfrätthet" ; -- oanfrätthet..nn.1
  oanfäktad_1_A = mkA "oanfäktad" ; -- oanfäktad..av.1
  oanfäktbar_1_A = mkA "oanfäktbar" ; -- oanfäktbar..av.1
  oanfäktbarhet_1_N = mkN "oanfäktbarhet" "oanfäktbarheter" ; -- oanfäktbarhet..nn.1
  oanfäktlig_1_A = mkA "oanfäktlig" ; -- oanfäktlig..av.1
  oanfäktlighet_1_N = mkN "oanfäktlighet" "oanfäktligheter" ; -- oanfäktlighet..nn.1
  oanförd_1_A = mkA "oanförd" "oanfört" ; -- oanförd..av.1
  oangenäm_1_A = mkA "oangenäm" ; -- oangenäm..av.1
  oangenämhet_1_N = mkN "oangenämhet" ; -- oangenämhet..nn.1
  oanglad_1_A = mkA "oanglad" ; -- oanglad..av.1
  oanglifierad_1_A = mkA "oanglifierad" ; -- oanglifierad..av.1
  oanglifierbar_1_A = mkA "oanglifierbar" ; -- oanglifierbar..av.1
  oanglifierbarhet_1_N = mkN "oanglifierbarhet" ; -- oanglifierbarhet..nn.1
  oangliserad_1_A = mkA "oangliserad" ; -- oangliserad..av.1
  oangliserbar_1_A = mkA "oangliserbar" ; -- oangliserbar..av.1
  oangliserbarhet_1_N = mkN "oangliserbarhet" ; -- oangliserbarhet..nn.1
  oangripbar_1_A = mkA "oangripbar" ; -- oangripbar..av.1
  oangripbarhet_1_N = mkN "oangripbarhet" ; -- oangripbarhet..nn.1
  oangriplig_1_A = mkA "oangriplig" ; -- oangriplig..av.1
  oangriplighet_1_N = mkN "oangriplighet" ; -- oangriplighet..nn.1
  oanhopad_1_A = mkA "oanhopad" ; -- oanhopad..av.1
  oanimerad_1_A = mkA "oanimerad" ; -- oanimerad..av.1
  oanimerbar_1_A = mkA "oanimerbar" ; -- oanimerbar..av.1
  oanimerbarhet_1_N = mkN "oanimerbarhet" ; -- oanimerbarhet..nn.1
  oanklagad_1_A = mkA "oanklagad" ; -- oanklagad..av.1
  oankrad_1_A = mkA "oankrad" ; -- oankrad..av.1
  oanlitad_1_A = mkA "oanlitad" ; -- oanlitad..av.1
  oanländ_1_A = mkA "oanländ" ; -- oanländ..av.1
  oanlöpt_1_A = mkA "oanlöpt" "oanlöpt" ; -- oanlöpt..av.1
  oanmanad_1_A = mkA "oanmanad" ; -- oanmanad..av.1
  oanmodad_1_A = mkA "oanmodad" ; -- oanmodad..av.1
  oanmäld_1_A = mkA "oanmäld" "oanmält" ; -- oanmäld..av.1
  oanmärkt_1_A = mkA "oanmärkt" "oanmärkt" ; -- oanmärkt..av.1
  oannekterad_1_A = mkA "oannekterad" ; -- oannekterad..av.1
  oannekterbar_1_A = mkA "oannekterbar" ; -- oannekterbar..av.1
  oannekterbarhet_1_N = mkN "oannekterbarhet" ; -- oannekterbarhet..nn.1
  oannihilerad_1_A = mkA "oannihilerad" ; -- oannihilerad..av.1
  oannihilerbar_1_A = mkA "oannihilerbar" ; -- oannihilerbar..av.1
  oannihilerbarhet_1_N = mkN "oannihilerbarhet" ; -- oannihilerbarhet..nn.1
  oannonserad_1_A = mkA "oannonserad" ; -- oannonserad..av.1
  oannonserbar_1_A = mkA "oannonserbar" ; -- oannonserbar..av.1
  oannonserbarhet_1_N = mkN "oannonserbarhet" ; -- oannonserbarhet..nn.1
  oannoterad_1_A = mkA "oannoterad" ; -- oannoterad..av.1
  oannoterbar_1_A = mkA "oannoterbar" ; -- oannoterbar..av.1
  oannoterbarhet_1_N = mkN "oannoterbarhet" ; -- oannoterbarhet..nn.1
  oannullerad_1_A = mkA "oannullerad" ; -- oannullerad..av.1
  oannullerbar_1_A = mkA "oannullerbar" ; -- oannullerbar..av.1
  oannullerbarhet_1_N = mkN "oannullerbarhet" ; -- oannullerbarhet..nn.1
  oanodiserad_1_A = mkA "oanodiserad" ; -- oanodiserad..av.1
  oanodiserbar_1_A = mkA "oanodiserbar" ; -- oanodiserbar..av.1
  oanodiserbarhet_1_N = mkN "oanodiserbarhet" ; -- oanodiserbarhet..nn.1
  oanonymiserad_1_A = mkA "oanonymiserad" ; -- oanonymiserad..av.1
  oanonymiserbar_1_A = mkA "oanonymiserbar" ; -- oanonymiserbar..av.1
  oanonymiserbarhet_1_N = mkN "oanonymiserbarhet" ; -- oanonymiserbarhet..nn.1
  oanordnad_1_A = mkA "oanordnad" ; -- oanordnad..av.1
  oanpassad_1_A = mkA "oanpassad" ; -- oanpassad..av.1
  oanrikad_1_A = mkA "oanrikad" ; -- oanrikad..av.1
  oanropad_1_A = mkA "oanropad" ; -- oanropad..av.1
  oanrättad_1_A = mkA "oanrättad" ; -- oanrättad..av.1
  oansad_1_A = mkA "oansad" ; -- oansad..av.1
  oansamlad_1_A = mkA "oansamlad" ; -- oansamlad..av.1
  oansenlig_1_A = mkA "oansenlig" ; -- oansenlig..av.1
  oansenlighet_1_N = mkN "oansenlighet" ; -- oansenlighet..nn.1
  oanskaffad_1_A = mkA "oanskaffad" ; -- oanskaffad..av.1
  oanspelad_1_A = mkA "oanspelad" ; -- oanspelad..av.1
  oanstiftad_1_A = mkA "oanstiftad" ; -- oanstiftad..av.1
  oanstormad_1_A = mkA "oanstormad" ; -- oanstormad..av.1
  oansträngd_1_A = mkA "oansträngd" "oansträngt" ; -- oansträngd..av.1
  oanställd_1_A = mkA "oanställd" "oanställt" ; -- oanställd..av.1
  oanständig_1_A = mkA "oanständig" ; -- oanständig..av.1
  oanständighet_1_N = mkN "oanständighet" "oanständigheter" ; -- oanständighet..nn.1
  oansvarig_1_A = mkA "oansvarig" ; -- oansvarig..av.1
  oansvarighet_1_N = mkN "oansvarighet" ; -- oansvarighet..nn.1
  oansvälld_1_A = mkA "oansvälld" "oansvällt" ; -- oansvälld..av.1
  oansökt_1_A = mkA "oansökt" "oansökt" ; -- oansökt..av.1
  oantagbar_1_A = mkA "oantagbar" ; -- oantagbar..av.1
  oantagbarhet_1_N = mkN "oantagbarhet" ; -- oantagbarhet..nn.1
  oantaglig_1_A = mkA "oantaglig" ; -- oantaglig..av.1
  oantaglighet_1_N = mkN "oantaglighet" ; -- oantaglighet..nn.1
  oantastad_1_A = mkA "oantastad" ; -- oantastad..av.1
  oantastbar_1_A = mkA "oantastbar" ; -- oantastbar..av.1
  oantastbarhet_1_N = mkN "oantastbarhet" "oantastbarheter" ; -- oantastbarhet..nn.1
  oantastlig_1_A = mkA "oantastlig" ; -- oantastlig..av.1
  oantastlighet_1_N = mkN "oantastlighet" "oantastligheter" ; -- oantastlighet..nn.1
  oanteciperad_1_A = mkA "oanteciperad" ; -- oanteciperad..av.1
  oanteciperbar_1_A = mkA "oanteciperbar" ; -- oanteciperbar..av.1
  oanteciperbarhet_1_N = mkN "oanteciperbarhet" ; -- oanteciperbarhet..nn.1
  oantecknad_1_A = mkA "oantecknad" ; -- oantecknad..av.1
  oantedaterad_1_A = mkA "oantedaterad" ; -- oantedaterad..av.1
  oantedaterbar_1_A = mkA "oantedaterbar" ; -- oantedaterbar..av.1
  oantedaterbarhet_1_N = mkN "oantedaterbarhet" ; -- oantedaterbarhet..nn.1
  oantichambrerad_1_A = mkA "oantichambrerad" ; -- oantichambrerad..av.1
  oantichambrerbar_1_A = mkA "oantichambrerbar" ; -- oantichambrerbar..av.1
  oantichambrerbarhet_1_N = mkN "oantichambrerbarhet" ; -- oantichambrerbarhet..nn.1
  oantikiserad_1_A = mkA "oantikiserad" ; -- oantikiserad..av.1
  oantikiserbar_1_A = mkA "oantikiserbar" ; -- oantikiserbar..av.1
  oantikiserbarhet_1_N = mkN "oantikiserbarhet" ; -- oantikiserbarhet..nn.1
  oanträffad_1_A = mkA "oanträffad" ; -- oanträffad..av.1
  oanträffbar_1_A = mkA "oanträffbar" ; -- oanträffbar..av.1
  oanträffbarhet_1_N = mkN "oanträffbarhet" ; -- oanträffbarhet..nn.1
  oantvardad_1_A = mkA "oantvardad" ; -- oantvardad..av.1
  oantänd_1_A = mkA "oantänd" ; -- oantänd..av.1
  oantågad_1_A = mkA "oantågad" ; -- oantågad..av.1
  oanvisad_1_A = mkA "oanvisad" ; -- oanvisad..av.1
  oanvänd_1_A = mkA "oanvänd" ; -- oanvänd..av.1
  oanvändbar_1_A = mkA "oanvändbar" ; -- oanvändbar..av.1
  oanvändbarhet_1_N = mkN "oanvändbarhet" ; -- oanvändbarhet..nn.1
  oapostroferad_1_A = mkA "oapostroferad" ; -- oapostroferad..av.1
  oapostroferbar_1_A = mkA "oapostroferbar" ; -- oapostroferbar..av.1
  oapostroferbarhet_1_N = mkN "oapostroferbarhet" ; -- oapostroferbarhet..nn.1
  oappellerad_1_A = mkA "oappellerad" ; -- oappellerad..av.1
  oappellerbar_1_A = mkA "oappellerbar" ; -- oappellerbar..av.1
  oappellerbarhet_1_N = mkN "oappellerbarhet" ; -- oappellerbarhet..nn.1
  oapplicerad_1_A = mkA "oapplicerad" ; -- oapplicerad..av.1
  oapplicerbar_1_A = mkA "oapplicerbar" ; -- oapplicerbar..av.1
  oapplicerbarhet_1_N = mkN "oapplicerbarhet" ; -- oapplicerbarhet..nn.1
  oapplåderad_1_A = mkA "oapplåderad" ; -- oapplåderad..av.1
  oapplåderbar_1_A = mkA "oapplåderbar" ; -- oapplåderbar..av.1
  oapplåderbarhet_1_N = mkN "oapplåderbarhet" ; -- oapplåderbarhet..nn.1
  oapporterad_1_A = mkA "oapporterad" ; -- oapporterad..av.1
  oapporterbar_1_A = mkA "oapporterbar" ; -- oapporterbar..av.1
  oapporterbarhet_1_N = mkN "oapporterbarhet" ; -- oapporterbarhet..nn.1
  oapprecierad_1_A = mkA "oapprecierad" ; -- oapprecierad..av.1
  oapprecierbar_1_A = mkA "oapprecierbar" ; -- oapprecierbar..av.1
  oapprecierbarhet_1_N = mkN "oapprecierbarhet" ; -- oapprecierbarhet..nn.1
  oappreterad_1_A = mkA "oappreterad" ; -- oappreterad..av.1
  oappreterbar_1_A = mkA "oappreterbar" ; -- oappreterbar..av.1
  oappreterbarhet_1_N = mkN "oappreterbarhet" ; -- oappreterbarhet..nn.1
  oapprocherad_1_A = mkA "oapprocherad" ; -- oapprocherad..av.1
  oapprocherbar_1_A = mkA "oapprocherbar" ; -- oapprocherbar..av.1
  oapprocherbarhet_1_N = mkN "oapprocherbarhet" ; -- oapprocherbarhet..nn.1
  oapproximerad_1_A = mkA "oapproximerad" ; -- oapproximerad..av.1
  oapproximerbar_1_A = mkA "oapproximerbar" ; -- oapproximerbar..av.1
  oapproximerbarhet_1_N = mkN "oapproximerbarhet" ; -- oapproximerbarhet..nn.1
  oapterad_1_A = mkA "oapterad" ; -- oapterad..av.1
  oapterbar_1_A = mkA "oapterbar" ; -- oapterbar..av.1
  oapterbarhet_1_N = mkN "oapterbarhet" ; -- oapterbarhet..nn.1
  oaptitlig_1_A = mkA "oaptitlig" ; -- oaptitlig..av.1
  oaptitlighet_1_N = mkN "oaptitlighet" ; -- oaptitlighet..nn.1
  oarbetad_1_A = mkA "oarbetad" ; -- oarbetad..av.1
  oargumenterad_1_A = mkA "oargumenterad" ; -- oargumenterad..av.1
  oargumenterbar_1_A = mkA "oargumenterbar" ; -- oargumenterbar..av.1
  oargumenterbarhet_1_N = mkN "oargumenterbarhet" ; -- oargumenterbarhet..nn.1
  oarkaiserad_1_A = mkA "oarkaiserad" ; -- oarkaiserad..av.1
  oarkaiserbar_1_A = mkA "oarkaiserbar" ; -- oarkaiserbar..av.1
  oarkaiserbarhet_1_N = mkN "oarkaiserbarhet" ; -- oarkaiserbarhet..nn.1
  oarkebuserad_1_A = mkA "oarkebuserad" ; -- oarkebuserad..av.1
  oarkebuserbar_1_A = mkA "oarkebuserbar" ; -- oarkebuserbar..av.1
  oarkebuserbarhet_1_N = mkN "oarkebuserbarhet" ; -- oarkebuserbarhet..nn.1
  oarkiverad_1_A = mkA "oarkiverad" ; -- oarkiverad..av.1
  oarkiverbar_1_A = mkA "oarkiverbar" ; -- oarkiverbar..av.1
  oarkiverbarhet_1_N = mkN "oarkiverbarhet" ; -- oarkiverbarhet..nn.1
  oarmerad_1_A = mkA "oarmerad" ; -- oarmerad..av.1
  oarmerbar_1_A = mkA "oarmerbar" ; -- oarmerbar..av.1
  oarmerbarhet_1_N = mkN "oarmerbarhet" ; -- oarmerbarhet..nn.1
  oarrangerad_1_A = mkA "oarrangerad" ; -- oarrangerad..av.1
  oarrangerbar_1_A = mkA "oarrangerbar" ; -- oarrangerbar..av.1
  oarrangerbarhet_1_N = mkN "oarrangerbarhet" ; -- oarrangerbarhet..nn.1
  oarrenderad_1_A = mkA "oarrenderad" ; -- oarrenderad..av.1
  oarrenderbar_1_A = mkA "oarrenderbar" ; -- oarrenderbar..av.1
  oarrenderbarhet_1_N = mkN "oarrenderbarhet" ; -- oarrenderbarhet..nn.1
  oarresterad_1_A = mkA "oarresterad" ; -- oarresterad..av.1
  oarresterbar_1_A = mkA "oarresterbar" ; -- oarresterbar..av.1
  oarresterbarhet_1_N = mkN "oarresterbarhet" ; -- oarresterbarhet..nn.1
  oarronderad_1_A = mkA "oarronderad" ; -- oarronderad..av.1
  oarronderbar_1_A = mkA "oarronderbar" ; -- oarronderbar..av.1
  oarronderbarhet_1_N = mkN "oarronderbarhet" ; -- oarronderbarhet..nn.1
  oart_1_N = mkN "oart" "oarter" ; -- oart..nn.1
  oartig_1_A = mkA "oartig" ; -- oartig..av.1
  oartighet_1_N = mkN "oartighet" "oartigheter" ; -- oartighet..nn.1
  oartikulerad_1_A = mkA "oartikulerad" ; -- oartikulerad..av.1
  oartikulerbar_1_A = mkA "oartikulerbar" ; -- oartikulerbar..av.1
  oartikulerbarhet_1_N = mkN "oartikulerbarhet" ; -- oartikulerbarhet..nn.1
  oarvoderad_1_A = mkA "oarvoderad" ; -- oarvoderad..av.1
  oarvoderbar_1_A = mkA "oarvoderbar" ; -- oarvoderbar..av.1
  oarvoderbarhet_1_N = mkN "oarvoderbarhet" ; -- oarvoderbarhet..nn.1
  oas_1_N = mkN "oas" "oaser" ; -- oas..nn.1
  oasfalterad_1_A = mkA "oasfalterad" ; -- oasfalterad..av.1
  oasfalterbar_1_A = mkA "oasfalterbar" ; -- oasfalterbar..av.1
  oasfalterbarhet_1_N = mkN "oasfalterbarhet" ; -- oasfalterbarhet..nn.1
  oasis_1_N = mkN "oasis" ; -- oasis..nn.1
  oaskad_1_A = mkA "oaskad" ; -- oaskad..av.1
  oaspirerad_1_A = mkA "oaspirerad" ; -- oaspirerad..av.1
  oaspirerbar_1_A = mkA "oaspirerbar" ; -- oaspirerbar..av.1
  oaspirerbarhet_1_N = mkN "oaspirerbarhet" ; -- oaspirerbarhet..nn.1
  oassignerad_1_A = mkA "oassignerad" ; -- oassignerad..av.1
  oassignerbar_1_A = mkA "oassignerbar" ; -- oassignerbar..av.1
  oassignerbarhet_1_N = mkN "oassignerbarhet" ; -- oassignerbarhet..nn.1
  oassimilerad_1_A = mkA "oassimilerad" ; -- oassimilerad..av.1
  oassimilerbar_1_A = mkA "oassimilerbar" ; -- oassimilerbar..av.1
  oassimilerbarhet_1_N = mkN "oassimilerbarhet" ; -- oassimilerbarhet..nn.1
  oassisterad_1_A = mkA "oassisterad" ; -- oassisterad..av.1
  oassisterbar_1_A = mkA "oassisterbar" ; -- oassisterbar..av.1
  oassisterbarhet_1_N = mkN "oassisterbarhet" ; -- oassisterbarhet..nn.1
  oassocierad_1_A = mkA "oassocierad" ; -- oassocierad..av.1
  oassocierbar_1_A = mkA "oassocierbar" ; -- oassocierbar..av.1
  oassocierbarhet_1_N = mkN "oassocierbarhet" ; -- oassocierbarhet..nn.1
  oassurerad_1_A = mkA "oassurerad" ; -- oassurerad..av.1
  oassurerbar_1_A = mkA "oassurerbar" ; -- oassurerbar..av.1
  oassurerbarhet_1_N = mkN "oassurerbarhet" ; -- oassurerbarhet..nn.1
  oatrofierad_1_A = mkA "oatrofierad" ; -- oatrofierad..av.1
  oatrofierbar_1_A = mkA "oatrofierbar" ; -- oatrofierbar..av.1
  oatrofierbarhet_1_N = mkN "oatrofierbarhet" ; -- oatrofierbarhet..nn.1
  oattackerad_1_A = mkA "oattackerad" ; -- oattackerad..av.1
  oattackerbar_1_A = mkA "oattackerbar" ; -- oattackerbar..av.1
  oattackerbarhet_1_N = mkN "oattackerbarhet" ; -- oattackerbarhet..nn.1
  oattesterad_1_A = mkA "oattesterad" ; -- oattesterad..av.1
  oattesterbar_1_A = mkA "oattesterbar" ; -- oattesterbar..av.1
  oattesterbarhet_1_N = mkN "oattesterbarhet" ; -- oattesterbarhet..nn.1
  oattraherad_1_A = mkA "oattraherad" ; -- oattraherad..av.1
  oattraherbar_1_A = mkA "oattraherbar" ; -- oattraherbar..av.1
  oattraherbarhet_1_N = mkN "oattraherbarhet" ; -- oattraherbarhet..nn.1
  oattrapperad_1_A = mkA "oattrapperad" ; -- oattrapperad..av.1
  oattrapperbar_1_A = mkA "oattrapperbar" ; -- oattrapperbar..av.1
  oattrapperbarhet_1_N = mkN "oattrapperbarhet" ; -- oattrapperbarhet..nn.1
  oattribuerad_1_A = mkA "oattribuerad" ; -- oattribuerad..av.1
  oattribuerbar_1_A = mkA "oattribuerbar" ; -- oattribuerbar..av.1
  oattribuerbarhet_1_N = mkN "oattribuerbarhet" ; -- oattribuerbarhet..nn.1
  oauktionerad_1_A = mkA "oauktionerad" ; -- oauktionerad..av.1
  oauktionerbar_1_A = mkA "oauktionerbar" ; -- oauktionerbar..av.1
  oauktionerbarhet_1_N = mkN "oauktionerbarhet" ; -- oauktionerbarhet..nn.1
  oauktoriserad_1_A = mkA "oauktoriserad" ; -- oauktoriserad..av.1
  oauktoriserbar_1_A = mkA "oauktoriserbar" ; -- oauktoriserbar..av.1
  oauktoriserbarhet_1_N = mkN "oauktoriserbarhet" ; -- oauktoriserbarhet..nn.1
  oauskulterad_1_A = mkA "oauskulterad" ; -- oauskulterad..av.1
  oauskulterbar_1_A = mkA "oauskulterbar" ; -- oauskulterbar..av.1
  oauskulterbarhet_1_N = mkN "oauskulterbarhet" ; -- oauskulterbarhet..nn.1
  oautenticerad_1_A = mkA "oautenticerad" ; -- oautenticerad..av.1
  oautenticerbar_1_A = mkA "oautenticerbar" ; -- oautenticerbar..av.1
  oautenticerbarhet_1_N = mkN "oautenticerbarhet" ; -- oautenticerbarhet..nn.1
  oautentifierad_1_A = mkA "oautentifierad" ; -- oautentifierad..av.1
  oautentifierbar_1_A = mkA "oautentifierbar" ; -- oautentifierbar..av.1
  oautentifierbarhet_1_N = mkN "oautentifierbarhet" ; -- oautentifierbarhet..nn.1
  oautentiserad_1_A = mkA "oautentiserad" ; -- oautentiserad..av.1
  oautentiserbar_1_A = mkA "oautentiserbar" ; -- oautentiserbar..av.1
  oautentiserbarhet_1_N = mkN "oautentiserbarhet" ; -- oautentiserbarhet..nn.1
  oautomatiserad_1_A = mkA "oautomatiserad" ; -- oautomatiserad..av.1
  oautomatiserbar_1_A = mkA "oautomatiserbar" ; -- oautomatiserbar..av.1
  oautomatiserbarhet_1_N = mkN "oautomatiserbarhet" ; -- oautomatiserbarhet..nn.1
  oavad_1_A = mkA "oavad" ; -- oavad..av.1
  oavaktiverbar_1_A = mkA "oavaktiverbar" ; -- oavaktiverbar..av.1
  oavaktiverbarhet_1_N = mkN "oavaktiverbarhet" ; -- oavaktiverbarhet..nn.1
  oavancerad_1_A = mkA "oavancerad" ; -- oavancerad..av.1
  oavancerbar_1_A = mkA "oavancerbar" ; -- oavancerbar..av.1
  oavancerbarhet_1_N = mkN "oavancerbarhet" ; -- oavancerbarhet..nn.1
  oavannonserad_1_A = mkA "oavannonserad" ; -- oavannonserad..av.1
  oavannonserbar_1_A = mkA "oavannonserbar" ; -- oavannonserbar..av.1
  oavannonserbarhet_1_N = mkN "oavannonserbarhet" ; -- oavannonserbarhet..nn.1
  oavbalkad_1_A = mkA "oavbalkad" ; -- oavbalkad..av.1
  oavbeställd_1_A = mkA "oavbeställd" "oavbeställt" ; -- oavbeställd..av.1
  oavbetad_1_A = mkA "oavbetad" ; -- oavbetad..av.1
  oavbetalad_1_A = mkA "oavbetalad" ; -- oavbetalad..av.1
  oavbildad_1_A = mkA "oavbildad" ; -- oavbildad..av.1
  oavblåst_1_A = mkA "oavblåst" "oavblåst" ; -- oavblåst..av.1
  oavbruten_1_A = mkA "oavbruten" ; -- oavbruten..av.1
  oavböjd_1_A = mkA "oavböjd" "oavböjt" ; -- oavböjd..av.1
  oavbördad_1_A = mkA "oavbördad" ; -- oavbördad..av.1
  oavdelad_1_A = mkA "oavdelad" ; -- oavdelad..av.1
  oavdramatiserad_1_A = mkA "oavdramatiserad" ; -- oavdramatiserad..av.1
  oavdramatiserbar_1_A = mkA "oavdramatiserbar" ; -- oavdramatiserbar..av.1
  oavdramatiserbarhet_1_N = mkN "oavdramatiserbarhet" ; -- oavdramatiserbarhet..nn.1
  oavdunstad_1_A = mkA "oavdunstad" ; -- oavdunstad..av.1
  oavdämd_1_A = mkA "oavdämd" "oavdämt" ; -- oavdämd..av.1
  oavdömd_1_A = mkA "oavdömd" "oavdömt" ; -- oavdömd..av.1
  oavfattad_1_A = mkA "oavfattad" ; -- oavfattad..av.1
  oavfettad_1_A = mkA "oavfettad" ; -- oavfettad..av.1
  oavflyttad_1_A = mkA "oavflyttad" ; -- oavflyttad..av.1
  oavfolkad_1_A = mkA "oavfolkad" ; -- oavfolkad..av.1
  oavfordrad_1_A = mkA "oavfordrad" ; -- oavfordrad..av.1
  oavfuktad_1_A = mkA "oavfuktad" ; -- oavfuktad..av.1
  oavfyrad_1_A = mkA "oavfyrad" ; -- oavfyrad..av.1
  oavfärdad_1_A = mkA "oavfärdad" ; -- oavfärdad..av.1
  oavförd_1_A = mkA "oavförd" "oavfört" ; -- oavförd..av.1
  oavgiftad_1_A = mkA "oavgiftad" ; -- oavgiftad..av.1
  oavgjord_1_A = mkA "oavgjord" "oavgjort" ; -- oavgjord..av.1
  oavgränsad_1_A = mkA "oavgränsad" ; -- oavgränsad..av.1
  oavgudad_1_A = mkA "oavgudad" ; -- oavgudad..av.1
  oavgärdad_1_A = mkA "oavgärdad" ; -- oavgärdad..av.1
  oavhandlad_1_A = mkA "oavhandlad" ; -- oavhandlad..av.1
  oavhjälplig_1_A = mkA "oavhjälplig" ; -- oavhjälplig..av.1
  oavhjälpt_1_A = mkA "oavhjälpt" "oavhjälpt" ; -- oavhjälpt..av.1
  oavhyst_1_A = mkA "oavhyst" "oavhyst" ; -- oavhyst..av.1
  oavhämtad_1_A = mkA "oavhämtad" ; -- oavhämtad..av.1
  oavhändbar_1_A = mkA "oavhändbar" ; -- oavhändbar..av.1
  oavhändbarhet_1_N = mkN "oavhändbarhet" ; -- oavhändbarhet..nn.1
  oavhängd_1_A = mkA "oavhängd" "oavhängt" ; -- oavhängd..av.1
  oavhängig_1_A = mkA "oavhängig" ; -- oavhängig..av.1
  oavhängighet_1_N = mkN "oavhängighet" "oavhängigheter" ; -- oavhängighet..nn.1
  oavhärdad_1_A = mkA "oavhärdad" ; -- oavhärdad..av.1
  oavhörd_1_A = mkA "oavhörd" "oavhört" ; -- oavhörd..av.1
  oavhöstad_1_A = mkA "oavhöstad" ; -- oavhöstad..av.1
  oavinstallerbar_1_A = mkA "oavinstallerbar" ; -- oavinstallerbar..av.1
  oavintellektualiserbar_1_A = mkA "oavintellektualiserbar" ; -- oavintellektualiserbar..av.1
  oavisad_1_A = mkA "oavisad" ; -- oavisad..av.1
  oaviserad_1_A = mkA "oaviserad" ; -- oaviserad..av.1
  oaviserbar_1_A = mkA "oaviserbar" ; -- oaviserbar..av.1
  oaviserbarhet_1_N = mkN "oaviserbarhet" ; -- oaviserbarhet..nn.1
  oavjagad_1_A = mkA "oavjagad" ; -- oavjagad..av.1
  oavjämnad_1_A = mkA "oavjämnad" ; -- oavjämnad..av.1
  oavkalkad_1_A = mkA "oavkalkad" ; -- oavkalkad..av.1
  oavklarad_1_A = mkA "oavklarad" ; -- oavklarad..av.1
  oavklingad_1_A = mkA "oavklingad" ; -- oavklingad..av.1
  oavknoppad_1_A = mkA "oavknoppad" ; -- oavknoppad..av.1
  oavkoloniserad_1_A = mkA "oavkoloniserad" ; -- oavkoloniserad..av.1
  oavkoloniserbar_1_A = mkA "oavkoloniserbar" ; -- oavkoloniserbar..av.1
  oavkoloniserbarhet_1_N = mkN "oavkoloniserbarhet" ; -- oavkoloniserbarhet..nn.1
  oavkopplad_1_A = mkA "oavkopplad" ; -- oavkopplad..av.1
  oavkortad_1_A = mkA "oavkortad" ; -- oavkortad..av.1
  oavkriminaliserad_1_A = mkA "oavkriminaliserad" ; -- oavkriminaliserad..av.1
  oavkriminaliserbar_1_A = mkA "oavkriminaliserbar" ; -- oavkriminaliserbar..av.1
  oavkriminaliserbarhet_1_N = mkN "oavkriminaliserbarhet" ; -- oavkriminaliserbarhet..nn.1
  oavkristnad_1_A = mkA "oavkristnad" ; -- oavkristnad..av.1
  oavkrävd_1_A = mkA "oavkrävd" "oavkrävt" ; -- oavkrävd..av.1
  oavkunnad_1_A = mkA "oavkunnad" ; -- oavkunnad..av.1
  oavkyld_1_A = mkA "oavkyld" "oavkylt" ; -- oavkyld..av.1
  oavkänd_1_A = mkA "oavkänd" ; -- oavkänd..av.1
  oavkönad_1_A = mkA "oavkönad" ; -- oavkönad..av.1
  oavlad_1_A = mkA "oavlad" ; -- oavlad..av.1
  oavlagrad_1_A = mkA "oavlagrad" ; -- oavlagrad..av.1
  oavlastad_1_A = mkA "oavlastad" ; -- oavlastad..av.1
  oavlivad_1_A = mkA "oavlivad" ; -- oavlivad..av.1
  oavlockad_1_A = mkA "oavlockad" ; -- oavlockad..av.1
  oavlossad_1_A = mkA "oavlossad" ; -- oavlossad..av.1
  oavlusad_1_A = mkA "oavlusad" ; -- oavlusad..av.1
  oavlyssnad_1_A = mkA "oavlyssnad" ; -- oavlyssnad..av.1
  oavlyst_1_A = mkA "oavlyst" "oavlyst" ; -- oavlyst..av.1
  oavlägsnad_1_A = mkA "oavlägsnad" ; -- oavlägsnad..av.1
  oavlämnad_1_A = mkA "oavlämnad" ; -- oavlämnad..av.1
  oavlänkad_1_A = mkA "oavlänkad" ; -- oavlänkad..av.1
  oavlåtlig_1_A = mkA "oavlåtlig" ; -- oavlåtlig..av.1
  oavlåtligen_1_Adv = mkAdv "oavlåtligen" ; -- oavlåtligen..ab.1
  oavlåtlighet_1_N = mkN "oavlåtlighet" ; -- oavlåtlighet..nn.1
  oavlönad_1_A = mkA "oavlönad" ; -- oavlönad..av.1
  oavlöpt_1_A = mkA "oavlöpt" "oavlöpt" ; -- oavlöpt..av.1
  oavlöst_1_A = mkA "oavlöst" "oavlöst" ; -- oavlöst..av.1
  oavlövad_1_A = mkA "oavlövad" ; -- oavlövad..av.1
  oavmagnetiserad_1_A = mkA "oavmagnetiserad" ; -- oavmagnetiserad..av.1
  oavmagnetiserbar_1_A = mkA "oavmagnetiserbar" ; -- oavmagnetiserbar..av.1
  oavmagnetiserbarhet_1_N = mkN "oavmagnetiserbarhet" ; -- oavmagnetiserbarhet..nn.1
  oavmaskad_1_A = mkA "oavmaskad" ; -- oavmaskad..av.1
  oavmastad_1_A = mkA "oavmastad" ; -- oavmastad..av.1
  oavmattad_1_A = mkA "oavmattad" ; -- oavmattad..av.1
  oavmystifierbar_1_A = mkA "oavmystifierbar" ; -- oavmystifierbar..av.1
  oavmystifierbarhet_1_N = mkN "oavmystifierbarhet" ; -- oavmystifierbarhet..nn.1
  oavmätt_1_A = mkA "oavmätt" ; -- oavmätt..av.1
  oavmätthet_1_N = mkN "oavmätthet" ; -- oavmätthet..nn.1
  oavnavlad_1_A = mkA "oavnavlad" ; -- oavnavlad..av.1
  oavnazifierad_1_A = mkA "oavnazifierad" ; -- oavnazifierad..av.1
  oavnazifierbar_1_A = mkA "oavnazifierbar" ; -- oavnazifierbar..av.1
  oavnazifierbarhet_1_N = mkN "oavnazifierbarhet" ; -- oavnazifierbarhet..nn.1
  oavpassad_1_A = mkA "oavpassad" ; -- oavpassad..av.1
  oavpatrullerad_1_A = mkA "oavpatrullerad" ; -- oavpatrullerad..av.1
  oavpatrullerbar_1_A = mkA "oavpatrullerbar" ; -- oavpatrullerbar..av.1
  oavpatrullerbarhet_1_N = mkN "oavpatrullerbarhet" ; -- oavpatrullerbarhet..nn.1
  oavplanad_1_A = mkA "oavplanad" ; -- oavplanad..av.1
  oavpolitiserad_1_A = mkA "oavpolitiserad" ; -- oavpolitiserad..av.1
  oavpolitiserbar_1_A = mkA "oavpolitiserbar" ; -- oavpolitiserbar..av.1
  oavpolitiserbarhet_1_N = mkN "oavpolitiserbarhet" ; -- oavpolitiserbarhet..nn.1
  oavpolletterad_1_A = mkA "oavpolletterad" ; -- oavpolletterad..av.1
  oavpolletterbar_1_A = mkA "oavpolletterbar" ; -- oavpolletterbar..av.1
  oavpolletterbarhet_1_N = mkN "oavpolletterbarhet" ; -- oavpolletterbarhet..nn.1
  oavporträtterad_1_A = mkA "oavporträtterad" ; -- oavporträtterad..av.1
  oavporträtterbar_1_A = mkA "oavporträtterbar" ; -- oavporträtterbar..av.1
  oavporträtterbarhet_1_N = mkN "oavporträtterbarhet" ; -- oavporträtterbarhet..nn.1
  oavpressad_1_A = mkA "oavpressad" ; -- oavpressad..av.1
  oavreagerad_1_A = mkA "oavreagerad" ; -- oavreagerad..av.1
  oavreagerbar_1_A = mkA "oavreagerbar" ; -- oavreagerbar..av.1
  oavreagerbarhet_1_N = mkN "oavreagerbarhet" ; -- oavreagerbarhet..nn.1
  oavregistrerad_1_A = mkA "oavregistrerad" ; -- oavregistrerad..av.1
  oavregistrerbar_1_A = mkA "oavregistrerbar" ; -- oavregistrerbar..av.1
  oavregistrerbarhet_1_N = mkN "oavregistrerbarhet" ; -- oavregistrerbarhet..nn.1
  oavreglerad_1_A = mkA "oavreglerad" ; -- oavreglerad..av.1
  oavreglerbar_1_A = mkA "oavreglerbar" ; -- oavreglerbar..av.1
  oavreglerbarhet_1_N = mkN "oavreglerbarhet" ; -- oavreglerbarhet..nn.1
  oavrest_1_A = mkA "oavrest" "oavrest" ; -- oavrest..av.1
  oavromantiserad_1_A = mkA "oavromantiserad" ; -- oavromantiserad..av.1
  oavromantiserbar_1_A = mkA "oavromantiserbar" ; -- oavromantiserbar..av.1
  oavromantiserbarhet_1_N = mkN "oavromantiserbarhet" ; -- oavromantiserbarhet..nn.1
  oavrundad_1_A = mkA "oavrundad" ; -- oavrundad..av.1
  oavrustad_1_A = mkA "oavrustad" ; -- oavrustad..av.1
  oavräknad_1_A = mkA "oavräknad" ; -- oavräknad..av.1
  oavrättad_1_A = mkA "oavrättad" ; -- oavrättad..av.1
  oavsaltad_1_A = mkA "oavsaltad" ; -- oavsaltad..av.1
  oavsedd_1_A = mkA "oavsedd" ; -- oavsedd..av.1
  oavseglad_1_A = mkA "oavseglad" ; -- oavseglad..av.1
  oavsiktlig_1_A = mkA "oavsiktlig" ; -- oavsiktlig..av.1
  oavsiktligen_1_Adv = mkAdv "oavsiktligen" ; -- oavsiktligen..ab.1
  oavsiktlighet_1_N = mkN "oavsiktlighet" ; -- oavsiktlighet..nn.1
  oavskaffad_1_A = mkA "oavskaffad" ; -- oavskaffad..av.1
  oavskavd_1_A = mkA "oavskavd" "oavskavt" ; -- oavskavd..av.1
  oavskedad_1_A = mkA "oavskedad" ; -- oavskedad..av.1
  oavskräckt_1_A = mkA "oavskräckt" "oavskräckt" ; -- oavskräckt..av.1
  oavskärmad_1_A = mkA "oavskärmad" ; -- oavskärmad..av.1
  oavslipad_1_A = mkA "oavslipad" ; -- oavslipad..av.1
  oavslutad_1_A = mkA "oavslutad" ; -- oavslutad..av.1
  oavslöjad_1_A = mkA "oavslöjad" ; -- oavslöjad..av.1
  oavsmakad_1_A = mkA "oavsmakad" ; -- oavsmakad..av.1
  oavsmalnad_1_A = mkA "oavsmalnad" ; -- oavsmalnad..av.1
  oavsnörd_1_A = mkA "oavsnörd" "oavsnört" ; -- oavsnörd..av.1
  oavsocialiserad_1_A = mkA "oavsocialiserad" ; -- oavsocialiserad..av.1
  oavsocialiserbar_1_A = mkA "oavsocialiserbar" ; -- oavsocialiserbar..av.1
  oavsocialiserbarhet_1_N = mkN "oavsocialiserbarhet" ; -- oavsocialiserbarhet..nn.1
  oavsomnad_1_A = mkA "oavsomnad" ; -- oavsomnad..av.1
  oavspeglad_1_A = mkA "oavspeglad" ; -- oavspeglad..av.1
  oavspelad_1_A = mkA "oavspelad" ; -- oavspelad..av.1
  oavspisad_1_A = mkA "oavspisad" ; -- oavspisad..av.1
  oavspärrad_1_A = mkA "oavspärrad" ; -- oavspärrad..av.1
  oavstaliniserad_1_A = mkA "oavstaliniserad" ; -- oavstaliniserad..av.1
  oavstaliniserbar_1_A = mkA "oavstaliniserbar" ; -- oavstaliniserbar..av.1
  oavstaliniserbarhet_1_N = mkN "oavstaliniserbarhet" ; -- oavstaliniserbarhet..nn.1
  oavstannad_1_A = mkA "oavstannad" ; -- oavstannad..av.1
  oavstavad_1_A = mkA "oavstavad" ; -- oavstavad..av.1
  oavstressad_1_A = mkA "oavstressad" ; -- oavstressad..av.1
  oavstyckad_1_A = mkA "oavstyckad" ; -- oavstyckad..av.1
  oavstyrd_1_A = mkA "oavstyrd" "oavstyrt" ; -- oavstyrd..av.1
  oavstyrkt_1_A = mkA "oavstyrkt" "oavstyrkt" ; -- oavstyrkt..av.1
  oavställd_1_A = mkA "oavställd" "oavställt" ; -- oavställd..av.1
  oavstämd_1_A = mkA "oavstämd" "oavstämt" ; -- oavstämd..av.1
  oavstörd_1_A = mkA "oavstörd" "oavstört" ; -- oavstörd..av.1
  oavstött_1_A = mkA "oavstött" ; -- oavstött..av.1
  oavsvalnad_1_A = mkA "oavsvalnad" ; -- oavsvalnad..av.1
  oavsvavlad_1_A = mkA "oavsvavlad" ; -- oavsvavlad..av.1
  oavsynad_1_A = mkA "oavsynad" ; -- oavsynad..av.1
  oavsänd_1_A = mkA "oavsänd" ; -- oavsänd..av.1
  oavsättlig_1_A = mkA "oavsättlig" ; -- oavsättlig..av.1
  oavsättlighet_1_N = mkN "oavsättlighet" ; -- oavsättlighet..nn.1
  oavsökt_1_A = mkA "oavsökt" "oavsökt" ; -- oavsökt..av.1
  oavsöndrad_1_A = mkA "oavsöndrad" ; -- oavsöndrad..av.1
  oavtackad_1_A = mkA "oavtackad" ; -- oavtackad..av.1
  oavtalad_1_A = mkA "oavtalad" ; -- oavtalad..av.1
  oavtappad_1_A = mkA "oavtappad" ; -- oavtappad..av.1
  oavtecknad_1_A = mkA "oavtecknad" ; -- oavtecknad..av.1
  oavtjänad_1_A = mkA "oavtjänad" ; -- oavtjänad..av.1
  oavtonad_1_A = mkA "oavtonad" ; -- oavtonad..av.1
  oavtrappad_1_A = mkA "oavtrappad" ; -- oavtrappad..av.1
  oavtrubbad_1_A = mkA "oavtrubbad" ; -- oavtrubbad..av.1
  oavtunnad_1_A = mkA "oavtunnad" ; -- oavtunnad..av.1
  oavtäckt_1_A = mkA "oavtäckt" "oavtäckt" ; -- oavtäckt..av.1
  oavtågad_1_A = mkA "oavtågad" ; -- oavtågad..av.1
  oavvaktad_1_A = mkA "oavvaktad" ; -- oavvaktad..av.1
  oavvattnad_1_A = mkA "oavvattnad" ; -- oavvattnad..av.1
  oavvecklad_1_A = mkA "oavvecklad" ; -- oavvecklad..av.1
  oavverkad_1_A = mkA "oavverkad" ; -- oavverkad..av.1
  oavvisad_1_A = mkA "oavvisad" ; -- oavvisad..av.1
  oavvisbar_1_A = mkA "oavvisbar" ; -- oavvisbar..av.1
  oavvisbarhet_1_N = mkN "oavvisbarhet" ; -- oavvisbarhet..nn.1
  oavvislig_1_A = mkA "oavvislig" ; -- oavvislig..av.1
  oavvislighet_1_N = mkN "oavvislighet" ; -- oavvislighet..nn.1
  oavvitad_1_A = mkA "oavvitad" ; -- oavvitad..av.1
  oavvittrad_1_A = mkA "oavvittrad" ; -- oavvittrad..av.1
  oavvägd_1_A = mkA "oavvägd" "oavvägt" ; -- oavvägd..av.1
  oavvänd_1_A = mkA "oavvänd" ; -- oavvänd..av.1
  oavväpnad_1_A = mkA "oavväpnad" ; -- oavväpnad..av.1
  oavvärjd_1_A = mkA "oavvärjd" "oavvärjt" ; -- oavvärjd..av.1
  oavytterlig_1_A = mkA "oavytterlig" ; -- oavytterlig..av.1
  oavytterlighet_1_N = mkN "oavytterlighet" ; -- oavytterlighet..nn.1
  oavyttrad_1_A = mkA "oavyttrad" ; -- oavyttrad..av.1
  oaxiomatiserad_1_A = mkA "oaxiomatiserad" ; -- oaxiomatiserad..av.1
  oaxiomatiserbar_1_A = mkA "oaxiomatiserbar" ; -- oaxiomatiserbar..av.1
  oaxiomatiserbarhet_1_N = mkN "oaxiomatiserbarhet" ; -- oaxiomatiserbarhet..nn.1
  oaxlad_1_A = mkA "oaxlad" ; -- oaxlad..av.1
  obackad_1_A = mkA "obackad" ; -- obackad..av.1
  obackupad_1_A = mkA "obackupad" ; -- obackupad..av.1
  obackuppad_1_A = mkA "obackuppad" ; -- obackuppad..av.1
  obadad_1_A = mkA "obadad" ; -- obadad..av.1
  obaddad_1_A = mkA "obaddad" ; -- obaddad..av.1
  obagatelliserad_1_A = mkA "obagatelliserad" ; -- obagatelliserad..av.1
  obagatelliserbar_1_A = mkA "obagatelliserbar" ; -- obagatelliserbar..av.1
  obagatelliserbarhet_1_N = mkN "obagatelliserbarhet" ; -- obagatelliserbarhet..nn.1
  obaissad_1_A = mkA "obaissad" ; -- obaissad..av.1
  obajsad_1_A = mkA "obajsad" ; -- obajsad..av.1
  obakad_1_A = mkA "obakad" ; -- obakad..av.1
  obakdantad_1_A = mkA "obakdantad" ; -- obakdantad..av.1
  obaktalad_1_A = mkA "obaktalad" ; -- obaktalad..av.1
  obalad_1_A = mkA "obalad" ; -- obalad..av.1
  obalans_1_N = mkN "obalans" ; -- obalans..nn.1
  obalanserad_1_A = mkA "obalanserad" ; -- obalanserad..av.1
  obalanserbar_1_A = mkA "obalanserbar" ; -- obalanserbar..av.1
  obalanserbarhet_1_N = mkN "obalanserbarhet" ; -- obalanserbarhet..nn.1
  oballoterad_1_A = mkA "oballoterad" ; -- oballoterad..av.1
  oballoterbar_1_A = mkA "oballoterbar" ; -- oballoterbar..av.1
  oballoterbarhet_1_N = mkN "oballoterbarhet" ; -- oballoterbarhet..nn.1
  obalsamerad_1_A = mkA "obalsamerad" ; -- obalsamerad..av.1
  obalsamerbar_1_A = mkA "obalsamerbar" ; -- obalsamerbar..av.1
  obalsamerbarhet_1_N = mkN "obalsamerbarhet" ; -- obalsamerbarhet..nn.1
  obanad_1_A = mkA "obanad" ; -- obanad..av.1
  obanaliserad_1_A = mkA "obanaliserad" ; -- obanaliserad..av.1
  obanaliserbar_1_A = mkA "obanaliserbar" ; -- obanaliserbar..av.1
  obanaliserbarhet_1_N = mkN "obanaliserbarhet" ; -- obanaliserbarhet..nn.1
  obandad_1_A = mkA "obandad" ; -- obandad..av.1
  obankad_1_A = mkA "obankad" ; -- obankad..av.1
  obankrutterad_1_A = mkA "obankrutterad" ; -- obankrutterad..av.1
  obankrutterbar_1_A = mkA "obankrutterbar" ; -- obankrutterbar..av.1
  obankrutterbarhet_1_N = mkN "obankrutterbarhet" ; -- obankrutterbarhet..nn.1
  obannad_1_A = mkA "obannad" ; -- obannad..av.1
  obannlyst_1_A = mkA "obannlyst" "obannlyst" ; -- obannlyst..av.1
  obantad_1_A = mkA "obantad" ; -- obantad..av.1
  obarkad_1_A = mkA "obarkad" ; -- obarkad..av.1
  obarlastad_1_A = mkA "obarlastad" ; -- obarlastad..av.1
  obarmhärtig_1_A = mkA "obarmhärtig" ; -- obarmhärtig..av.1
  obarmhärtighet_1_N = mkN "obarmhärtighet" ; -- obarmhärtighet..nn.1
  obarrad_1_A = mkA "obarrad" ; -- obarrad..av.1
  obarrikaderad_1_A = mkA "obarrikaderad" ; -- obarrikaderad..av.1
  obarrikaderbar_1_A = mkA "obarrikaderbar" ; -- obarrikaderbar..av.1
  obarrikaderbarhet_1_N = mkN "obarrikaderbarhet" ; -- obarrikaderbarhet..nn.1
  obaserad_1_A = mkA "obaserad" ; -- obaserad..av.1
  obaserbar_1_A = mkA "obaserbar" ; -- obaserbar..av.1
  obaserbarhet_1_N = mkN "obaserbarhet" ; -- obaserbarhet..nn.1
  obastad_1_A = mkA "obastad" ; -- obastad..av.1
  obaxad_1_A = mkA "obaxad" ; -- obaxad..av.1
  obducent_1_N = mkN "obducent" "obducenter" ; -- obducent..nn.1
  obducera_1_V = mkV "obducerar" ; -- obducera..vb.1
  obducerande_1_N = mkN "obducerande" ; -- obducerande..nn.1
  obducerbar_1_A = mkA "obducerbar" ; -- obducerbar..av.1
  obducerbarhet_1_N = mkN "obducerbarhet" ; -- obducerbarhet..nn.1
  obducering_1_N = mkN "obducering" ; -- obducering..nn.1
  obduktion_1_N = mkN "obduktion" ; -- obduktion..nn.1
  obduktionsrapport_1_N = mkN "obduktionsrapport" "obduktionsrapporter" ; -- obduktionsrapport..nn.1
  obduktionsresultat_1_N = mkN "obduktionsresultat" neutrum  ; -- obduktionsresultat..nn.1
  obeaktad_1_A = mkA "obeaktad" ; -- obeaktad..av.1
  obearbetad_1_A = mkA "obearbetad" ; -- obearbetad..av.1
  obeatifierbar_1_A = mkA "obeatifierbar" ; -- obeatifierbar..av.1
  obeatifierbarhet_1_N = mkN "obeatifierbarhet" ; -- obeatifierbarhet..nn.1
  obebodd_1_A = mkA "obebodd" ; -- obebodd..av.1
  obeboelig_1_A = mkA "obeboelig" ; -- obeboelig..av.1
  obeboelighet_1_N = mkN "obeboelighet" ; -- obeboelighet..nn.1
  obebyggd_1_A = mkA "obebyggd" "obebyggt" ; -- obebyggd..av.1
  obebådad_1_A = mkA "obebådad" ; -- obebådad..av.1
  obeckad_1_A = mkA "obeckad" ; -- obeckad..av.1
  obedarrad_1_A = mkA "obedarrad" ; -- obedarrad..av.1
  obedd_1_A = mkA "obedd" ; -- obedd..av.1
  obedrövad_1_A = mkA "obedrövad" ; -- obedrövad..av.1
  obedyrad_1_A = mkA "obedyrad" ; -- obedyrad..av.1
  obedårad_1_A = mkA "obedårad" ; -- obedårad..av.1
  obedömd_1_A = mkA "obedömd" "obedömt" ; -- obedömd..av.1
  obedövad_1_A = mkA "obedövad" ; -- obedövad..av.1
  obeedigad_1_A = mkA "obeedigad" ; -- obeedigad..av.1
  obefalld_1_A = mkA "obefalld" "obefallt" ; -- obefalld..av.1
  obefarad_1_A = mkA "obefarad" ; -- obefarad..av.1
  obefaren_1_A = mkA "obefaren" ; -- obefaren..av.1
  obefintlig_1_A = mkA "obefintlig" ; -- obefintlig..av.1
  obefintlighet_1_N = mkN "obefintlighet" ; -- obefintlighet..nn.1
  obefläckad_1_A = mkA "obefläckad" ; -- obefläckad..av.1
  obefogad_1_A = mkA "obefogad" ; -- obefogad..av.1
  obefolkad_1_A = mkA "obefolkad" ; -- obefolkad..av.1
  obefordrad_1_A = mkA "obefordrad" ; -- obefordrad..av.1
  obefraktad_1_A = mkA "obefraktad" ; -- obefraktad..av.1
  obefriad_1_A = mkA "obefriad" ; -- obefriad..av.1
  obefruktad_1_A = mkA "obefruktad" ; -- obefruktad..av.1
  obefryndad_1_A = mkA "obefryndad" ; -- obefryndad..av.1
  obefrämjad_1_A = mkA "obefrämjad" ; -- obefrämjad..av.1
  obefullmäktigad_1_A = mkA "obefullmäktigad" ; -- obefullmäktigad..av.1
  obefäst_1_A = mkA "obefäst" "obefäst" ; -- obefäst..av.1
  obegabbad_1_A = mkA "obegabbad" ; -- obegabbad..av.1
  obegagnad_1_A = mkA "obegagnad" ; -- obegagnad..av.1
  obegapad_1_A = mkA "obegapad" ; -- obegapad..av.1
  obeglänst_1_A = mkA "obeglänst" "obeglänst" ; -- obeglänst..av.1
  obegriplig_1_A = mkA "obegriplig" ; -- obegriplig..av.1
  obegriplighet_1_N = mkN "obegriplighet" "obegripligheter" ; -- obegriplighet..nn.1
  obegrundad_1_A = mkA "obegrundad" ; -- obegrundad..av.1
  obegränsad_1_A = mkA "obegränsad" ; -- obegränsad..av.1
  obegråten_1_A = mkA "obegråten" ; -- obegråten..av.1
  obegärd_1_A = mkA "obegärd" "obegärt" ; -- obegärd..av.1
  obegåvad_1_A = mkA "obegåvad" ; -- obegåvad..av.1
  obehag_1_N = mkN "obehag" neutrum  ; -- obehag..nn.1
  obehaglig_1_A = mkA "obehaglig" ; -- obehaglig..av.1
  obehaglighet_1_N = mkN "obehaglighet" "obehagligheter" ; -- obehaglighet..nn.1
  obehandlad_1_A = mkA "obehandlad" ; -- obehandlad..av.1
  obehindrad_1_A = mkA "obehindrad" ; -- obehindrad..av.1
  obehängd_1_A = mkA "obehängd" "obehängt" ; -- obehängd..av.1
  obehärskad_1_A = mkA "obehärskad" ; -- obehärskad..av.1
  obehörig_1_A = mkA "obehörig" ; -- obehörig..av.1
  obehörigen_1_Adv = mkAdv "obehörigen" ; -- obehörigen..ab.1
  obehörighet_1_N = mkN "obehörighet" ; -- obehörighet..nn.1
  obehövd_1_A = mkA "obehövd" "obehövt" ; -- obehövd..av.1
  obehövlig_1_A = mkA "obehövlig" ; -- obehövlig..av.1
  obehövlighet_1_N = mkN "obehövlighet" "obehövligheter" ; -- obehövlighet..nn.1
  obeivrad_1_A = mkA "obeivrad" ; -- obeivrad..av.1
  obejakad_1_A = mkA "obejakad" ; -- obejakad..av.1
  obejublad_1_A = mkA "obejublad" ; -- obejublad..av.1
  obekajad_1_A = mkA "obekajad" ; -- obekajad..av.1
  obekant_1_A = mkA "obekant" "obekant" ; -- obekant..av.1
  obekantskap_1_N = mkN "obekantskap" neutrum  ; -- obekantskap..nn.1
  obekikad_1_A = mkA "obekikad" ; -- obekikad..av.1
  obeklagad_1_A = mkA "obeklagad" ; -- obeklagad..av.1
  obekostad_1_A = mkA "obekostad" ; -- obekostad..av.1
  obekransad_1_A = mkA "obekransad" ; -- obekransad..av.1
  obekrigad_1_A = mkA "obekrigad" ; -- obekrigad..av.1
  obekräftad_1_A = mkA "obekräftad" ; -- obekräftad..av.1
  obekrönt_1_A = mkA "obekrönt" "obekrönt" ; -- obekrönt..av.1
  obekväm_1_A = mkA "obekväm" ; -- obekväm..av.1
  obekvämhet_1_N = mkN "obekvämhet" "obekvämheter" ; -- obekvämhet..nn.1
  obekymrad_1_A = mkA "obekymrad" ; -- obekymrad..av.1
  obekämpad_1_A = mkA "obekämpad" ; -- obekämpad..av.1
  obekänd_1_A = mkA "obekänd" ; -- obekänd..av.1
  obelamrad_1_A = mkA "obelamrad" ; -- obelamrad..av.1
  obelastad_1_A = mkA "obelastad" ; -- obelastad..av.1
  obeledsagad_1_A = mkA "obeledsagad" ; -- obeledsagad..av.1
  obelevad_1_A = mkA "obelevad" ; -- obelevad..av.1
  obelevenhet_1_N = mkN "obelevenhet" ; -- obelevenhet..nn.1
  obelisk_1_N = mkN "obelisk" "obelisker" ; -- obelisk..nn.1
  obelyst_1_A = mkA "obelyst" "obelyst" ; -- obelyst..av.1
  obelägrad_1_A = mkA "obelägrad" ; -- obelägrad..av.1
  obeläst_1_A = mkA "obeläst" "obeläst" ; -- obeläst..av.1
  obelånad_1_A = mkA "obelånad" ; -- obelånad..av.1
  obelönad_1_A = mkA "obelönad" ; -- obelönad..av.1
  obemannad_1_A = mkA "obemannad" ; -- obemannad..av.1
  obemantlad_1_A = mkA "obemantlad" ; -- obemantlad..av.1
  obemedlad_1_A = mkA "obemedlad" ; -- obemedlad..av.1
  obemyndigad_1_A = mkA "obemyndigad" ; -- obemyndigad..av.1
  obemängd_1_A = mkA "obemängd" "obemängt" ; -- obemängd..av.1
  obemärkt_1_A = mkA "obemärkt" "obemärkt" ; -- obemärkt..av.1
  obemärkthet_1_N = mkN "obemärkthet" "obemärktheter" ; -- obemärkthet..nn.1
  obemästrad_1_A = mkA "obemästrad" ; -- obemästrad..av.1
  obemött_1_A = mkA "obemött" ; -- obemött..av.1
  obenad_1_A = mkA "obenad" ; -- obenad..av.1
  obenägen_1_A = mkA "obenägen" ; -- obenägen..av.1
  obenägenhet_1_N = mkN "obenägenhet" ; -- obenägenhet..nn.1
  obenämnd_1_A = mkA "obenämnd" ; -- obenämnd..av.1
  obenådad_1_A = mkA "obenådad" ; -- obenådad..av.1
  obeordrad_1_A = mkA "obeordrad" ; -- obeordrad..av.1
  obepansrad_1_A = mkA "obepansrad" ; -- obepansrad..av.1
  obeprisad_1_A = mkA "obeprisad" ; -- obeprisad..av.1
  obeprövad_1_A = mkA "obeprövad" ; -- obeprövad..av.1
  obepudrad_1_A = mkA "obepudrad" ; -- obepudrad..av.1
  oberedd_1_A = mkA "oberedd" ; -- oberedd..av.1
  obereddhet_1_N = mkN "obereddhet" ; -- obereddhet..nn.1
  oberikad_1_A = mkA "oberikad" ; -- oberikad..av.1
  oberiktigad_1_A = mkA "oberiktigad" ; -- oberiktigad..av.1
  oberoende_1_A = mkA "oberoende" ; -- oberoende..av.1
  oberoende_1_N = mkN "oberoende" ; -- oberoende..nn.1
  oberusad_1_A = mkA "oberusad" ; -- oberusad..av.1
  oberäknad_1_A = mkA "oberäknad" ; -- oberäknad..av.1
  oberäknelig_1_A = mkA "oberäknelig" ; -- oberäknelig..av.1
  oberäknelighet_1_N = mkN "oberäknelighet" ; -- oberäknelighet..nn.1
  oberättad_1_A = mkA "oberättad" ; -- oberättad..av.1
  oberättigad_1_A = mkA "oberättigad" ; -- oberättigad..av.1
  oberömd_1_A = mkA "oberömd" "oberömt" ; -- oberömd..av.1
  oberömdhet_1_N = mkN "oberömdhet" ; -- oberömdhet..nn.1
  oberörbar_1_A = mkA "oberörbar" ; -- oberörbar..av.1
  oberörbarhet_1_N = mkN "oberörbarhet" ; -- oberörbarhet..nn.1
  oberörd_1_A = mkA "oberörd" "oberört" ; -- oberörd..av.1
  oberördhet_1_N = mkN "oberördhet" "oberördheter" ; -- oberördhet..nn.1
  oberövad_1_A = mkA "oberövad" ; -- oberövad..av.1
  obesannad_1_A = mkA "obesannad" ; -- obesannad..av.1
  obesatt_1_A = mkA "obesatt" ; -- obesatt..av.1
  obesatthet_1_N = mkN "obesatthet" ; -- obesatthet..nn.1
  obesedd_1_A = mkA "obesedd" ; -- obesedd..av.1
  obeseglad_1_A = mkA "obeseglad" ; -- obeseglad..av.1
  obesegrad_1_A = mkA "obesegrad" ; -- obesegrad..av.1
  obesiktigad_1_A = mkA "obesiktigad" ; -- obesiktigad..av.1
  obesinnad_1_A = mkA "obesinnad" ; -- obesinnad..av.1
  obesjungen_1_A = mkA "obesjungen" ; -- obesjungen..av.1
  obesjälad_1_A = mkA "obesjälad" ; -- obesjälad..av.1
  obeskattad_1_A = mkA "obeskattad" ; -- obeskattad..av.1
  obeskedlig_1_A = mkA "obeskedlig" ; -- obeskedlig..av.1
  obeskedlighet_1_N = mkN "obeskedlighet" ; -- obeskedlighet..nn.1
  obeskickad_1_A = mkA "obeskickad" ; -- obeskickad..av.1
  obeskrivbar_1_A = mkA "obeskrivbar" ; -- obeskrivbar..av.1
  obeskrivbarhet_1_N = mkN "obeskrivbarhet" ; -- obeskrivbarhet..nn.1
  obeskrivlig_1_A = mkA "obeskrivlig" ; -- obeskrivlig..av.1
  obeskrivlighet_1_N = mkN "obeskrivlighet" ; -- obeskrivlighet..nn.1
  obeskuggad_1_A = mkA "obeskuggad" ; -- obeskuggad..av.1
  obeskuren_1_A = mkA "obeskuren" ; -- obeskuren..av.1
  obeskyddad_1_A = mkA "obeskyddad" ; -- obeskyddad..av.1
  obeskylld_1_A = mkA "obeskylld" "obeskyllt" ; -- obeskylld..av.1
  obeskärmad_1_A = mkA "obeskärmad" ; -- obeskärmad..av.1
  obeskådad_1_A = mkA "obeskådad" ; -- obeskådad..av.1
  obeslutsam_1_A = mkA "obeslutsam" "obeslutsamt" "obeslutsamma" "obeslutsamma" "obeslutsammare" "obeslutsammast" "obeslutsammaste" ; -- obeslutsam..av.1
  obeslutsamhet_1_N = mkN "obeslutsamhet" "obeslutsamheter" ; -- obeslutsamhet..nn.1
  obesläktad_1_A = mkA "obesläktad" ; -- obesläktad..av.1
  obeslöjad_1_A = mkA "obeslöjad" ; -- obeslöjad..av.1
  obesmittad_1_A = mkA "obesmittad" ; -- obesmittad..av.1
  obesockrad_1_A = mkA "obesockrad" ; -- obesockrad..av.1
  obesoldad_1_A = mkA "obesoldad" ; -- obesoldad..av.1
  obespejad_1_A = mkA "obespejad" ; -- obespejad..av.1
  obespisad_1_A = mkA "obespisad" ; -- obespisad..av.1
  obespolad_1_A = mkA "obespolad" ; -- obespolad..av.1
  obespottad_1_A = mkA "obespottad" ; -- obespottad..av.1
  obesprutad_1_A = mkA "obesprutad" ; -- obesprutad..av.1
  obesticklig_1_A = mkA "obesticklig" ; -- obesticklig..av.1
  obesticklighet_1_N = mkN "obesticklighet" ; -- obesticklighet..nn.1
  obestormad_1_A = mkA "obestormad" ; -- obestormad..av.1
  obestraffad_1_A = mkA "obestraffad" ; -- obestraffad..av.1
  obestridd_1_A = mkA "obestridd" ; -- obestridd..av.1
  obestridlig_1_A = mkA "obestridlig" ; -- obestridlig..av.1
  obestridligen_1_Adv = mkAdv "obestridligen" ; -- obestridligen..ab.1
  obestridlighet_1_N = mkN "obestridlighet" ; -- obestridlighet..nn.1
  obestrålad_1_A = mkA "obestrålad" ; -- obestrålad..av.1
  obestyckad_1_A = mkA "obestyckad" ; -- obestyckad..av.1
  obestyrkt_1_A = mkA "obestyrkt" "obestyrkt" ; -- obestyrkt..av.1
  obeställbar_1_A = mkA "obeställbar" ; -- obeställbar..av.1
  obeställbarhet_1_N = mkN "obeställbarhet" ; -- obeställbarhet..nn.1
  obeställd_1_A = mkA "obeställd" "obeställt" ; -- obeställd..av.1
  obestämbar_1_A = mkA "obestämbar" ; -- obestämbar..av.1
  obestämbarhet_1_N = mkN "obestämbarhet" "obestämbarheter" ; -- obestämbarhet..nn.1
  obestämd_1_A = mkA "obestämd" "obestämt" ; -- obestämd..av.1
  obestämdhet_1_N = mkN "obestämdhet" "obestämdheter" ; -- obestämdhet..nn.1
  obestämdhetsprincip_1_N = mkN "obestämdhetsprincip" "obestämdhetsprinciper" ; -- obestämdhetsprincip..nn.1
  obeständig_1_A = mkA "obeständig" ; -- obeständig..av.1
  obeständighet_1_N = mkN "obeständighet" "obeständigheter" ; -- obeständighet..nn.1
  obestänkt_1_A = mkA "obestänkt" "obestänkt" ; -- obestänkt..av.1
  obesudlad_1_A = mkA "obesudlad" ; -- obesudlad..av.1
  obesutten_1_A = mkA "obesutten" ; -- obesutten..av.1
  obesuttenhet_1_N = mkN "obesuttenhet" ; -- obesuttenhet..nn.1
  obesvarad_1_A = mkA "obesvarad" ; -- obesvarad..av.1
  obesvärad_1_A = mkA "obesvärad" ; -- obesvärad..av.1
  obesådd_1_A = mkA "obesådd" ; -- obesådd..av.1
  obesökt_1_A = mkA "obesökt" "obesökt" ; -- obesökt..av.1
  obesörjd_1_A = mkA "obesörjd" "obesörjt" ; -- obesörjd..av.1
  obetad_1_A = mkA "obetad" ; -- obetad..av.1
  obetagen_1_A = mkA "obetagen" ; -- obetagen..av.1
  obetalbar_1_A = mkA "obetalbar" ; -- obetalbar..av.1
  obetalbarhet_1_N = mkN "obetalbarhet" ; -- obetalbarhet..nn.1
  obetald_1_A = mkA "obetald" "obetalt" ; -- obetald..av.1
  obetecknad_1_A = mkA "obetecknad" ; -- obetecknad..av.1
  obetingad_1_A = mkA "obetingad" ; -- obetingad..av.1
  obetitlad_1_A = mkA "obetitlad" ; -- obetitlad..av.1
  obetittad_1_A = mkA "obetittad" ; -- obetittad..av.1
  obetjänad_1_A = mkA "obetjänad" ; -- obetjänad..av.1
  obetonad_1_A = mkA "obetonad" ; -- obetonad..av.1
  obetongerad_1_A = mkA "obetongerad" ; -- obetongerad..av.1
  obetongerbar_1_A = mkA "obetongerbar" ; -- obetongerbar..av.1
  obetongerbarhet_1_N = mkN "obetongerbarhet" ; -- obetongerbarhet..nn.1
  obetraktad_1_A = mkA "obetraktad" ; -- obetraktad..av.1
  obetryckt_1_A = mkA "obetryckt" "obetryckt" ; -- obetryckt..av.1
  obetryggad_1_A = mkA "obetryggad" ; -- obetryggad..av.1
  obeträffad_1_A = mkA "obeträffad" ; -- obeträffad..av.1
  obetsad_1_A = mkA "obetsad" ; -- obetsad..av.1
  obetslad_1_A = mkA "obetslad" ; -- obetslad..av.1
  obetungad_1_A = mkA "obetungad" ; -- obetungad..av.1
  obetvingad_1_A = mkA "obetvingad" ; -- obetvingad..av.1
  obetvinglig_1_A = mkA "obetvinglig" ; -- obetvinglig..av.1
  obetvinglighet_1_N = mkN "obetvinglighet" ; -- obetvinglighet..nn.1
  obetvivlad_1_A = mkA "obetvivlad" ; -- obetvivlad..av.1
  obetydlig_1_A = mkA "obetydlig" ; -- obetydlig..av.1
  obetydlighet_1_N = mkN "obetydlighet" "obetydligheter" ; -- obetydlighet..nn.1
  obetygad_1_A = mkA "obetygad" ; -- obetygad..av.1
  obetäckt_1_A = mkA "obetäckt" "obetäckt" ; -- obetäckt..av.1
  obetänksam_1_A = mkA "obetänksam" "obetänksamt" "obetänksamma" "obetänksamma" "obetänksammare" "obetänksammast" "obetänksammaste" ; -- obetänksam..av.1
  obetänksamhet_1_N = mkN "obetänksamhet" ; -- obetänksamhet..nn.1
  obetänkt_1_A = mkA "obetänkt" "obetänkt" ; -- obetänkt..av.1
  obetänkthet_1_N = mkN "obetänkthet" ; -- obetänkthet..nn.1
  obeundrad_1_A = mkA "obeundrad" ; -- obeundrad..av.1
  obevakad_1_A = mkA "obevakad" ; -- obevakad..av.1
  obevandrad_1_A = mkA "obevandrad" ; -- obevandrad..av.1
  obevarad_1_A = mkA "obevarad" ; -- obevarad..av.1
  obevattnad_1_A = mkA "obevattnad" ; -- obevattnad..av.1
  obeveklig_1_A = mkA "obeveklig" ; -- obeveklig..av.1
  obevekligen_1_Adv = mkAdv "obevekligen" ; -- obevekligen..ab.1
  obeveklighet_1_N = mkN "obeveklighet" ; -- obeveklighet..nn.1
  obeviljad_1_A = mkA "obeviljad" ; -- obeviljad..av.1
  obevisad_1_A = mkA "obevisad" ; -- obevisad..av.1
  obevislig_1_A = mkA "obevislig" ; -- obevislig..av.1
  obevislighet_1_N = mkN "obevislighet" ; -- obevislighet..nn.1
  obevistad_1_A = mkA "obevistad" ; -- obevistad..av.1
  obevittnad_1_A = mkA "obevittnad" ; -- obevittnad..av.1
  obeväpnad_1_A = mkA "obeväpnad" ; -- obeväpnad..av.1
  obevärad_1_A = mkA "obevärad" ; -- obevärad..av.1
  obevärdigad_1_A = mkA "obevärdigad" ; -- obevärdigad..av.1
  obidad_1_A = mkA "obidad" ; -- obidad..av.1
  obifogad_1_A = mkA "obifogad" ; -- obifogad..av.1
  obiktad_1_A = mkA "obiktad" ; -- obiktad..av.1
  obilad_1_A = mkA "obilad" ; -- obilad..av.1
  obildad_1_A = mkA "obildad" ; -- obildad..av.1
  obildbar_1_A = mkA "obildbar" ; -- obildbar..av.1
  obildbarhet_1_N = mkN "obildbarhet" ; -- obildbarhet..nn.1
  obildning_1_N = mkN "obildning" ; -- obildning..nn.1
  obillig_1_A = mkA "obillig" ; -- obillig..av.1
  obillighet_1_N = mkN "obillighet" "obilligheter" ; -- obillighet..nn.1
  obiograferad_1_A = mkA "obiograferad" ; -- obiograferad..av.1
  obiograferbar_1_A = mkA "obiograferbar" ; -- obiograferbar..av.1
  obiograferbarhet_1_N = mkN "obiograferbarhet" ; -- obiograferbarhet..nn.1
  obisserad_1_A = mkA "obisserad" ; -- obisserad..av.1
  obisserbar_1_A = mkA "obisserbar" ; -- obisserbar..av.1
  obisserbarhet_1_N = mkN "obisserbarhet" ; -- obisserbarhet..nn.1
  obisträckt_1_A = mkA "obisträckt" "obisträckt" ; -- obisträckt..av.1
  obitad_1_A = mkA "obitad" ; -- obitad..av.1
  obivackerad_1_A = mkA "obivackerad" ; -- obivackerad..av.1
  obivackerbar_1_A = mkA "obivackerbar" ; -- obivackerbar..av.1
  obivackerbarhet_1_N = mkN "obivackerbarhet" ; -- obivackerbarhet..nn.1
  objekt_1_N = mkN "objekt" neutrum  ; -- objekt..nn.1
  objektförlust_1_N = mkN "objektförlust" ; -- objektförlust..nn.1
  objektglas_1_N = mkN "objektglas" neutrum  ; -- objektglas..nn.1
  objektiv_1_A = mkA "objektiv" ; -- objektiv..av.1
  objektiv_1_N = mkN "objektiv" neutrum  ; -- objektiv..nn.1
  objektivera_1_V = mkV "objektiverar" ; -- objektivera..vb.1
  objektiverande_1_N = mkN "objektiverande" ; -- objektiverande..nn.1
  objektiverbar_1_A = mkA "objektiverbar" ; -- objektiverbar..av.1
  objektiverbarhet_1_N = mkN "objektiverbarhet" ; -- objektiverbarhet..nn.1
  objektivering_1_N = mkN "objektivering" ; -- objektivering..nn.1
  objektivglas_1_N = mkN "objektivglas" neutrum  ; -- objektivglas..nn.1
  objektivism_1_N = mkN "objektivism" "objektivismer" ; -- objektivism..nn.1
  objektivistisk_1_A = mkA "objektivistisk" ; -- objektivistisk..av.1
  objektivitet_1_N = mkN "objektivitet" "objektiviteter" ; -- objektivitet..nn.1
  objektivlins_1_N = mkN "objektivlins" "objektivlinser" ; -- objektivlins..nn.1
  objektsform_1_N = mkN "objektsform" "objektsformer" ; -- objektsform..nn.1
  objektskatt_1_N = mkN "objektskatt" "objektskatter" ; -- objektskatt..nn.1
  objektspråk_1_N = mkN "objektspråk" neutrum  ; -- objektspråk..nn.1
  objektändelse_1_N = mkN "objektändelse" "objektändelser" ; -- objektändelse..nn.1
  objuden_1_A = mkA "objuden" ; -- objuden..av.1
  objussad_1_A = mkA "objussad" ; -- objussad..av.1
  objörnad_1_A = mkA "objörnad" ; -- objörnad..av.1
  obladad_1_A = mkA "obladad" ; -- obladad..av.1
  oblancherad_1_A = mkA "oblancherad" ; -- oblancherad..av.1
  oblancherbar_1_A = mkA "oblancherbar" ; -- oblancherbar..av.1
  oblancherbarhet_1_N = mkN "oblancherbarhet" ; -- oblancherbarhet..nn.1
  oblandad_1_A = mkA "oblandad" ; -- oblandad..av.1
  oblankad_1_A = mkA "oblankad" ; -- oblankad..av.1
  oblankpolerbar_1_A = mkA "oblankpolerbar" ; -- oblankpolerbar..av.1
  oblankpolerbarhet_1_N = mkN "oblankpolerbarhet" ; -- oblankpolerbarhet..nn.1
  oblast_1_N = mkN "oblast" "oblaster" ; -- oblast..nn.1
  oblat_1_N = mkN "oblat" "oblater" ; -- oblat..nn.1
  obleknad_1_A = mkA "obleknad" ; -- obleknad..av.1
  oblekt_1_A = mkA "oblekt" "oblekt" ; -- oblekt..av.1
  oblesserad_1_A = mkA "oblesserad" ; -- oblesserad..av.1
  oblesserbar_1_A = mkA "oblesserbar" ; -- oblesserbar..av.1
  oblesserbarhet_1_N = mkN "oblesserbarhet" ; -- oblesserbarhet..nn.1
  oblid_1_A = mkA "oblid" "oblitt" ; -- oblid..av.1
  oblidhet_1_N = mkN "oblidhet" ; -- oblidhet..nn.1
  oblidkad_1_A = mkA "oblidkad" ; -- oblidkad..av.1
  oblidkelig_1_A = mkA "oblidkelig" ; -- oblidkelig..av.1
  oblidkelighet_1_N = mkN "oblidkelighet" ; -- oblidkelighet..nn.1
  obligat_1_A = mkA "obligat" "obligat" ; -- obligat..av.1
  obligat_1_N = mkN "obligat" "obligater" ; -- obligat..nn.1
  obligation_1_N = mkN "obligation" ; -- obligation..nn.1
  obligationslån_1_N = mkN "obligationslån" neutrum  ; -- obligationslån..nn.1
  obligatorisk_1_A = mkA "obligatorisk" ; -- obligatorisk..av.1
  obligatorium_1_N = mkN "obligatorium" "obligatoriet" "obligatorier" "obligatorierna" ; -- obligatorium..nn.1
  obligera_1_V = mkV "obligerar" ; -- obligera..vb.1
  obligerande_1_N = mkN "obligerande" ; -- obligerande..nn.1
  obligerbar_1_A = mkA "obligerbar" ; -- obligerbar..av.1
  obligerbarhet_1_N = mkN "obligerbarhet" ; -- obligerbarhet..nn.1
  obligering_1_N = mkN "obligering" ; -- obligering..nn.1
  oblik_1_A = mkA "oblik" ; -- oblik..av.1
  oblik_1_N = mkN "oblik" "obliker" ; -- oblik..nn.1
  oblikhet_1_N = mkN "oblikhet" ; -- oblikhet..nn.1
  oblikvitet_1_N = mkN "oblikvitet" "oblikviteter" ; -- oblikvitet..nn.1
  oblinderad_1_A = mkA "oblinderad" ; -- oblinderad..av.1
  oblinderbar_1_A = mkA "oblinderbar" ; -- oblinderbar..av.1
  oblinderbarhet_1_N = mkN "oblinderbarhet" ; -- oblinderbarhet..nn.1
  oblockad_1_A = mkA "oblockad" ; -- oblockad..av.1
  oblockerad_1_A = mkA "oblockerad" ; -- oblockerad..av.1
  oblockerbar_1_A = mkA "oblockerbar" ; -- oblockerbar..av.1
  oblockerbarhet_1_N = mkN "oblockerbarhet" ; -- oblockerbarhet..nn.1
  oblodad_1_A = mkA "oblodad" ; -- oblodad..av.1
  oblodig_1_A = mkA "oblodig" ; -- oblodig..av.1
  oblodighet_1_N = mkN "oblodighet" ; -- oblodighet..nn.1
  obloggad_1_A = mkA "obloggad" ; -- obloggad..av.1
  oblommograferad_1_A = mkA "oblommograferad" ; -- oblommograferad..av.1
  oblommograferbar_1_A = mkA "oblommograferbar" ; -- oblommograferbar..av.1
  oblommograferbarhet_1_N = mkN "oblommograferbarhet" ; -- oblommograferbarhet..nn.1
  oblonderad_1_A = mkA "oblonderad" ; -- oblonderad..av.1
  oblonderbar_1_A = mkA "oblonderbar" ; -- oblonderbar..av.1
  oblonderbarhet_1_N = mkN "oblonderbarhet" ; -- oblonderbarhet..nn.1
  oblottad_1_A = mkA "oblottad" ; -- oblottad..av.1
  obluffad_1_A = mkA "obluffad" ; -- obluffad..av.1
  oblyad_1_A = mkA "oblyad" ; -- oblyad..av.1
  oblyg_1_A = mkA "oblyg" ; -- oblyg..av.1
  oblyghet_1_N = mkN "oblyghet" ; -- oblyghet..nn.1
  obläckad_1_A = mkA "obläckad" ; -- obläckad..av.1
  oblädad_1_A = mkA "oblädad" ; -- oblädad..av.1
  obläddrad_1_A = mkA "obläddrad" ; -- obläddrad..av.1
  obländad_1_A = mkA "obländad" ; -- obländad..av.1
  oblästad_1_A = mkA "oblästad" ; -- oblästad..av.1
  oblästrad_1_A = mkA "oblästrad" ; -- oblästrad..av.1
  oblåst_1_A = mkA "oblåst" "oblåst" ; -- oblåst..av.1
  oblött_1_A = mkA "oblött" ; -- oblött..av.1
  oboaserad_1_A = mkA "oboaserad" ; -- oboaserad..av.1
  oboaserbar_1_A = mkA "oboaserbar" ; -- oboaserbar..av.1
  oboaserbarhet_1_N = mkN "oboaserbarhet" ; -- oboaserbarhet..nn.1
  obobbad_1_A = mkA "obobbad" ; -- obobbad..av.1
  obockad_1_A = mkA "obockad" ; -- obockad..av.1
  oboe_1_N = mkN "oboe" "oboer" ; -- oboe..nn.1
  obogserad_1_A = mkA "obogserad" ; -- obogserad..av.1
  obogserbar_1_A = mkA "obogserbar" ; -- obogserbar..av.1
  obogserbarhet_1_N = mkN "obogserbarhet" ; -- obogserbarhet..nn.1
  oboist_1_N = mkN "oboist" "oboister" ; -- oboist..nn.1
  obojkottad_1_A = mkA "obojkottad" ; -- obojkottad..av.1
  obokad_1_A = mkA "obokad" ; -- obokad..av.1
  obokförd_1_A = mkA "obokförd" "obokfört" ; -- obokförd..av.1
  obokstaverad_1_A = mkA "obokstaverad" ; -- obokstaverad..av.1
  obokstaverbar_1_A = mkA "obokstaverbar" ; -- obokstaverbar..av.1
  obokstaverbarhet_1_N = mkN "obokstaverbarhet" ; -- obokstaverbarhet..nn.1
  obol_1_N = mkN "obol" "oboler" ; -- obol..nn.1
  obolagiserbar_1_A = mkA "obolagiserbar" ; -- obolagiserbar..av.1
  obollad_1_A = mkA "obollad" ; -- obollad..av.1
  obombad_1_A = mkA "obombad" ; -- obombad..av.1
  obombarderad_1_A = mkA "obombarderad" ; -- obombarderad..av.1
  obombarderbar_1_A = mkA "obombarderbar" ; -- obombarderbar..av.1
  obombarderbarhet_1_N = mkN "obombarderbarhet" ; -- obombarderbarhet..nn.1
  obommad_1_A = mkA "obommad" ; -- obommad..av.1
  obonad_1_A = mkA "obonad" ; -- obonad..av.1
  obongad_1_A = mkA "obongad" ; -- obongad..av.1
  oboniterad_1_A = mkA "oboniterad" ; -- oboniterad..av.1
  oboniterbar_1_A = mkA "oboniterbar" ; -- oboniterbar..av.1
  oboniterbarhet_1_N = mkN "oboniterbarhet" ; -- oboniterbarhet..nn.1
  obootad_1_A = mkA "obootad" ; -- obootad..av.1
  obordad_1_A = mkA "obordad" ; -- obordad..av.1
  oborgad_1_A = mkA "oborgad" ; -- oborgad..av.1
  oborrad_1_A = mkA "oborrad" ; -- oborrad..av.1
  oborstad_1_A = mkA "oborstad" ; -- oborstad..av.1
  obortförd_1_A = mkA "obortförd" "obortfört" ; -- obortförd..av.1
  obortresonerbar_1_A = mkA "obortresonerbar" ; -- obortresonerbar..av.1
  obortresonerbarhet_1_N = mkN "obortresonerbarhet" ; -- obortresonerbarhet..nn.1
  obotad_1_A = mkA "obotad" ; -- obotad..av.1
  obotbar_1_A = mkA "obotbar" ; -- obotbar..av.1
  obotbarhet_1_N = mkN "obotbarhet" ; -- obotbarhet..nn.1
  obotfärdig_1_A = mkA "obotfärdig" ; -- obotfärdig..av.1
  obotfärdighet_1_N = mkN "obotfärdighet" ; -- obotfärdighet..nn.1
  obotlig_1_A = mkA "obotlig" ; -- obotlig..av.1
  obotlighet_1_N = mkN "obotlighet" ; -- obotlighet..nn.1
  oboxad_1_A = mkA "oboxad" ; -- oboxad..av.1
  obrassad_1_A = mkA "obrassad" ; -- obrassad..av.1
  obreddad_1_A = mkA "obreddad" ; -- obreddad..av.1
  obriefad_1_A = mkA "obriefad" ; -- obriefad..av.1
  obriketterad_1_A = mkA "obriketterad" ; -- obriketterad..av.1
  obriketterbar_1_A = mkA "obriketterbar" ; -- obriketterbar..av.1
  obriketterbarhet_1_N = mkN "obriketterbarhet" ; -- obriketterbarhet..nn.1
  obriserad_1_A = mkA "obriserad" ; -- obriserad..av.1
  obriserbar_1_A = mkA "obriserbar" ; -- obriserbar..av.1
  obriserbarhet_1_N = mkN "obriserbarhet" ; -- obriserbarhet..nn.1
  obroad_1_A = mkA "obroad" ; -- obroad..av.1
  obroddad_1_A = mkA "obroddad" ; -- obroddad..av.1
  obroderad_1_A = mkA "obroderad" ; -- obroderad..av.1
  obroderbar_1_A = mkA "obroderbar" ; -- obroderbar..av.1
  obroderbarhet_1_N = mkN "obroderbarhet" ; -- obroderbarhet..nn.1
  obromerad_1_A = mkA "obromerad" ; -- obromerad..av.1
  obromerbar_1_A = mkA "obromerbar" ; -- obromerbar..av.1
  obromerbarhet_1_N = mkN "obromerbarhet" ; -- obromerbarhet..nn.1
  obromsad_1_A = mkA "obromsad" ; -- obromsad..av.1
  obronserad_1_A = mkA "obronserad" ; -- obronserad..av.1
  obronserbar_1_A = mkA "obronserbar" ; -- obronserbar..av.1
  obronserbarhet_1_N = mkN "obronserbarhet" ; -- obronserbarhet..nn.1
  obroscherad_1_A = mkA "obroscherad" ; -- obroscherad..av.1
  obroscherbar_1_A = mkA "obroscherbar" ; -- obroscherbar..av.1
  obroscherbarhet_1_N = mkN "obroscherbarhet" ; -- obroscherbarhet..nn.1
  obrosslad_1_A = mkA "obrosslad" ; -- obrosslad..av.1
  obrotschad_1_A = mkA "obrotschad" ; -- obrotschad..av.1
  obrottslig_1_A = mkA "obrottslig" ; -- obrottslig..av.1
  obrottslighet_1_N = mkN "obrottslighet" ; -- obrottslighet..nn.1
  obrucklad_1_A = mkA "obrucklad" ; -- obrucklad..av.1
  obrukad_1_A = mkA "obrukad" ; -- obrukad..av.1
  obrukbar_1_A = mkA "obrukbar" ; -- obrukbar..av.1
  obrukbarhet_1_N = mkN "obrukbarhet" ; -- obrukbarhet..nn.1
  obruklig_1_A = mkA "obruklig" ; -- obruklig..av.1
  obruklighet_1_N = mkN "obruklighet" ; -- obruklighet..nn.1
  obrunerad_1_A = mkA "obrunerad" ; -- obrunerad..av.1
  obrunerbar_1_A = mkA "obrunerbar" ; -- obrunerbar..av.1
  obrunerbarhet_1_N = mkN "obrunerbarhet" ; -- obrunerbarhet..nn.1
  obrunfärgad_1_A = mkA "obrunfärgad" ; -- obrunfärgad..av.1
  obrunnen_1_A = mkA "obrunnen" "obrunnet" "obrunna" "obrunna" "obrunnare" "obrunnast" "obrunnaste" ; -- obrunnen..av.1
  obrutaliserad_1_A = mkA "obrutaliserad" ; -- obrutaliserad..av.1
  obrutaliserbar_1_A = mkA "obrutaliserbar" ; -- obrutaliserbar..av.1
  obrutaliserbarhet_1_N = mkN "obrutaliserbarhet" ; -- obrutaliserbarhet..nn.1
  obruten_1_A = mkA "obruten" ; -- obruten..av.1
  obryggd_1_A = mkA "obryggd" "obryggt" ; -- obryggd..av.1
  obrynt_1_A = mkA "obrynt" "obrynt" ; -- obrynt..av.1
  obrytbar_1_A = mkA "obrytbar" ; -- obrytbar..av.1
  obrytbarhet_1_N = mkN "obrytbarhet" ; -- obrytbarhet..nn.1
  obräckt_1_A = mkA "obräckt" "obräckt" ; -- obräckt..av.1
  obrädad_1_A = mkA "obrädad" ; -- obrädad..av.1
  obräddad_1_A = mkA "obräddad" ; -- obräddad..av.1
  obrämad_1_A = mkA "obrämad" ; -- obrämad..av.1
  obränd_1_A = mkA "obränd" ; -- obränd..av.1
  obrännbar_1_A = mkA "obrännbar" ; -- obrännbar..av.1
  obrännbarhet_1_N = mkN "obrännbarhet" ; -- obrännbarhet..nn.1
  obräserad_1_A = mkA "obräserad" ; -- obräserad..av.1
  obräserbar_1_A = mkA "obräserbar" ; -- obräserbar..av.1
  obräserbarhet_1_N = mkN "obräserbarhet" ; -- obräserbarhet..nn.1
  obråkad_1_A = mkA "obråkad" ; -- obråkad..av.1
  obröad_1_A = mkA "obröad" ; -- obröad..av.1
  obrödad_1_A = mkA "obrödad" ; -- obrödad..av.1
  obscen_1_A = mkA "obscen" "obscent" ; -- obscen..av.1
  obscenitet_1_N = mkN "obscenitet" "obsceniteter" ; -- obscenitet..nn.1
  observandum_1_N = mkN "observandum" neutrum  ; -- observandum..nn.1
  observans_1_N = mkN "observans" ; -- observans..nn.1
  observant_1_A = mkA "observant" "observant" ; -- observant..av.1
  observation_1_N = mkN "observation" ; -- observation..nn.1
  observationsakt_1_N = mkN "observationsakt" "observationsakter" ; -- observationsakt..nn.1
  observationsfel_1_N = mkN "observationsfel" "observationsfelet" "observationsfel" "observationsfelen" ; -- observationsfel..nn.1
  observationsklass_1_N = mkN "observationsklass" "observationsklasser" ; -- observationsklass..nn.1
  observationsklinik_1_N = mkN "observationsklinik" "observationskliniker" ; -- observationsklinik..nn.1
  observationsmaterial_1_N = mkN "observationsmaterial" neutrum  ; -- observationsmaterial..nn.1
  observatorium_1_N = mkN "observatorium" "observatoriet" "observatorier" "observatorierna" ; -- observatorium..nn.1
  observatör_1_N = mkN "observatör" "observatörer" ; -- observatör..nn.1
  observera_1_V = mkV "observerar" ; -- observera..vb.1
  observerande_1_N = mkN "observerande" ; -- observerande..nn.1
  observerbar_1_A = mkA "observerbar" ; -- observerbar..av.1
  observerbarhet_1_N = mkN "observerbarhet" ; -- observerbarhet..nn.1
  observering_1_N = mkN "observering" ; -- observering..nn.1
  obsidian_1_N = mkN "obsidian" "obsidianer" ; -- obsidian..nn.1
  obsklass_1_N = mkN "obsklass" "obsklasser" ; -- obsklass..nn.1
  obsklinik_1_N = mkN "obsklinik" "obskliniker" ; -- obsklinik..nn.1
  obskur_1_A = mkA "obskur" ; -- obskur..av.1
  obskurant_1_A = mkA "obskurant" "obskurant" ; -- obskurant..av.1
  obskurant_1_N = mkN "obskurant" "obskuranter" ; -- obskurant..nn.1
  obskurantism_1_N = mkN "obskurantism" "obskurantismer" ; -- obskurantism..nn.1
  obskurantist_1_N = mkN "obskurantist" "obskurantister" ; -- obskurantist..nn.1
  obskurantistisk_1_A = mkA "obskurantistisk" ; -- obskurantistisk..av.1
  obskurhet_1_N = mkN "obskurhet" ; -- obskurhet..nn.1
  obskyr_1_A = mkA "obskyr" ; -- obskyr..av.1
  obskyrhet_1_N = mkN "obskyrhet" ; -- obskyrhet..nn.1
  obsolet_1_A = mkA "obsolet" "obsolet" ; -- obsolet..av.1
  obsolethet_1_N = mkN "obsolethet" ; -- obsolethet..nn.1
  obstetrik_1_N = mkN "obstetrik" ; -- obstetrik..nn.1
  obstetrisk_1_A = mkA "obstetrisk" ; -- obstetrisk..av.1
  obstinat_1_A = mkA "obstinat" "obstinat" ; -- obstinat..av.1
  obstipation_1_N = mkN "obstipation" ; -- obstipation..nn.1
  obstruent_1_N = mkN "obstruent" "obstruenter" ; -- obstruent..nn.1
  obstruera_1_V = mkV "obstruerar" ; -- obstruera..vb.1
  obstruerande_1_N = mkN "obstruerande" ; -- obstruerande..nn.1
  obstruering_1_N = mkN "obstruering" ; -- obstruering..nn.1
  obstruktion_1_N = mkN "obstruktion" ; -- obstruktion..nn.1
  obstruktionspolitik_1_N = mkN "obstruktionspolitik" ; -- obstruktionspolitik..nn.1
  obstruktionstaktik_1_N = mkN "obstruktionstaktik" "obstruktionstaktiker" ; -- obstruktionstaktik..nn.1
  obstruktiv_1_A = mkA "obstruktiv" ; -- obstruktiv..av.1
  obubbad_1_A = mkA "obubbad" ; -- obubbad..av.1
  obudad_1_A = mkA "obudad" ; -- obudad..av.1
  obudgeterad_1_A = mkA "obudgeterad" ; -- obudgeterad..av.1
  obudgeterbar_1_A = mkA "obudgeterbar" ; -- obudgeterbar..av.1
  obudgeterbarhet_1_N = mkN "obudgeterbarhet" ; -- obudgeterbarhet..nn.1
  obuffad_1_A = mkA "obuffad" ; -- obuffad..av.1
  obuffrad_1_A = mkA "obuffrad" ; -- obuffrad..av.1
  obultad_1_A = mkA "obultad" ; -- obultad..av.1
  obunden_1_A = mkA "obunden" ; -- obunden..av.1
  obundenhet_1_N = mkN "obundenhet" ; -- obundenhet..nn.1
  obunkrad_1_A = mkA "obunkrad" ; -- obunkrad..av.1
  obuntad_1_A = mkA "obuntad" ; -- obuntad..av.1
  oburkad_1_A = mkA "oburkad" ; -- oburkad..av.1
  obuskad_1_A = mkA "obuskad" ; -- obuskad..av.1
  obussad_1_A = mkA "obussad" ; -- obussad..av.1
  obuteljerad_1_A = mkA "obuteljerad" ; -- obuteljerad..av.1
  obuteljerbar_1_A = mkA "obuteljerbar" ; -- obuteljerbar..av.1
  obuteljerbarhet_1_N = mkN "obuteljerbarhet" ; -- obuteljerbarhet..nn.1
  obygd_1_N = mkN "obygd" "obygder" ; -- obygd..nn.1
  obyggd_1_A = mkA "obyggd" "obyggt" ; -- obyggd..av.1
  obyråkratiserad_1_A = mkA "obyråkratiserad" ; -- obyråkratiserad..av.1
  obyråkratiserbar_1_A = mkA "obyråkratiserbar" ; -- obyråkratiserbar..av.1
  obyråkratiserbarhet_1_N = mkN "obyråkratiserbarhet" ; -- obyråkratiserbarhet..nn.1
  obytt_1_A = mkA "obytt" ; -- obytt..av.1
  obäddad_1_A = mkA "obäddad" ; -- obäddad..av.1
  obälgad_1_A = mkA "obälgad" ; -- obälgad..av.1
  obändig_1_A = mkA "obändig" ; -- obändig..av.1
  obändighet_1_N = mkN "obändighet" ; -- obändighet..nn.1
  obändslad_1_A = mkA "obändslad" ; -- obändslad..av.1
  obänslad_1_A = mkA "obänslad" ; -- obänslad..av.1
  obärgad_1_A = mkA "obärgad" ; -- obärgad..av.1
  obättrad_1_A = mkA "obättrad" ; -- obättrad..av.1
  obågnad_1_A = mkA "obågnad" ; -- obågnad..av.1
  oböjd_1_A = mkA "oböjd" "oböjt" ; -- oböjd..av.1
  oböjlig_1_A = mkA "oböjlig" ; -- oböjlig..av.1
  oböjlighet_1_N = mkN "oböjlighet" ; -- oböjlighet..nn.1
  obönhörd_1_A = mkA "obönhörd" "obönhört" ; -- obönhörd..av.1
  obönhörlig_1_A = mkA "obönhörlig" ; -- obönhörlig..av.1
  obönhörligen_1_Adv = mkAdv "obönhörligen" ; -- obönhörligen..ab.1
  obönhörlighet_1_N = mkN "obönhörlighet" "obönhörligheter" ; -- obönhörlighet..nn.1
  obörjad_1_A = mkA "obörjad" ; -- obörjad..av.1
  obötad_1_A = mkA "obötad" ; -- obötad..av.1
  ocamouflerad_1_A = mkA "ocamouflerad" ; -- ocamouflerad..av.1
  ocamouflerbar_1_A = mkA "ocamouflerbar" ; -- ocamouflerbar..av.1
  ocamouflerbarhet_1_N = mkN "ocamouflerbarhet" ; -- ocamouflerbarhet..nn.1
  ocarina_1_N = mkN "ocarina" ; -- ocarina..nn.1
  ocaterad_1_A = mkA "ocaterad" ; -- ocaterad..av.1
  occasion_1_N = mkN "occasion" ; -- occasion..nn.1
  occident_1_N = mkN "occident" ; -- occident..nn.1
  occidental_1_A = mkA "occidental" ; -- occidental..av.1
  occidentalisera_1_V = mkV "occidentaliserar" ; -- occidentalisera..vb.1
  occidentaliserande_1_N = mkN "occidentaliserande" ; -- occidentaliserande..nn.1
  occidentaliserbar_1_A = mkA "occidentaliserbar" ; -- occidentaliserbar..av.1
  occidentaliserbarhet_1_N = mkN "occidentaliserbarhet" ; -- occidentaliserbarhet..nn.1
  occidentalisering_1_N = mkN "occidentalisering" ; -- occidentalisering..nn.1
  occidentalisk_1_A = mkA "occidentalisk" ; -- occidentalisk..av.1
  ocean_1_N = mkN "ocean" "oceaner" ; -- ocean..nn.1
  oceangående_1_A = mkA "oceangående" ; -- oceangående..av.1
  oceanisk_1_A = mkA "oceanisk" ; -- oceanisk..av.1
  oceanograf_1_N = mkN "oceanograf" "oceanografer" ; -- oceanograf..nn.1
  oceanografi_1_N = mkN "oceanografi" ; -- oceanografi..nn.1
  oceanografisk_1_A = mkA "oceanografisk" ; -- oceanografisk..av.1
  oceanångare_1_N = mkN "oceanångare" utrum  ; -- oceanångare..nn.1
  ocederad_1_A = mkA "ocederad" ; -- ocederad..av.1
  ocederbar_1_A = mkA "ocederbar" ; -- ocederbar..av.1
  ocederbarhet_1_N = mkN "ocederbarhet" ; -- ocederbarhet..nn.1
  ocelebrerad_1_A = mkA "ocelebrerad" ; -- ocelebrerad..av.1
  ocelebrerbar_1_A = mkA "ocelebrerbar" ; -- ocelebrerbar..av.1
  ocelebrerbarhet_1_N = mkN "ocelebrerbarhet" ; -- ocelebrerbarhet..nn.1
  ocementad_1_A = mkA "ocementad" ; -- ocementad..av.1
  ocementerad_1_A = mkA "ocementerad" ; -- ocementerad..av.1
  ocementerbar_1_A = mkA "ocementerbar" ; -- ocementerbar..av.1
  ocementerbarhet_1_N = mkN "ocementerbarhet" ; -- ocementerbarhet..nn.1
  ocensurerad_1_A = mkA "ocensurerad" ; -- ocensurerad..av.1
  ocensurerbar_1_A = mkA "ocensurerbar" ; -- ocensurerbar..av.1
  ocensurerbarhet_1_N = mkN "ocensurerbarhet" ; -- ocensurerbarhet..nn.1
  ocentrad_1_A = mkA "ocentrad" ; -- ocentrad..av.1
  ocentraliserad_1_A = mkA "ocentraliserad" ; -- ocentraliserad..av.1
  ocentraliserbar_1_A = mkA "ocentraliserbar" ; -- ocentraliserbar..av.1
  ocentraliserbarhet_1_N = mkN "ocentraliserbarhet" ; -- ocentraliserbarhet..nn.1
  ocentrerad_1_A = mkA "ocentrerad" ; -- ocentrerad..av.1
  ocentrerbar_1_A = mkA "ocentrerbar" ; -- ocentrerbar..av.1
  ocentrerbarhet_1_N = mkN "ocentrerbarhet" ; -- ocentrerbarhet..nn.1
  ocentrifugerad_1_A = mkA "ocentrifugerad" ; -- ocentrifugerad..av.1
  ocentrifugerbar_1_A = mkA "ocentrifugerbar" ; -- ocentrifugerbar..av.1
  ocentrifugerbarhet_1_N = mkN "ocentrifugerbarhet" ; -- ocentrifugerbarhet..nn.1
  ocernerad_1_A = mkA "ocernerad" ; -- ocernerad..av.1
  ocernerbar_1_A = mkA "ocernerbar" ; -- ocernerbar..av.1
  ocernerbarhet_1_N = mkN "ocernerbarhet" ; -- ocernerbarhet..nn.1
  ochargerad_1_A = mkA "ochargerad" ; -- ochargerad..av.1
  ochargerbar_1_A = mkA "ochargerbar" ; -- ochargerbar..av.1
  ochargerbarhet_1_N = mkN "ochargerbarhet" ; -- ochargerbarhet..nn.1
  ocharmad_1_A = mkA "ocharmad" ; -- ocharmad..av.1
  ocharmerad_1_A = mkA "ocharmerad" ; -- ocharmerad..av.1
  ocharmerbar_1_A = mkA "ocharmerbar" ; -- ocharmerbar..av.1
  ocharmerbarhet_1_N = mkN "ocharmerbarhet" ; -- ocharmerbarhet..nn.1
  ochartrad_1_A = mkA "ochartrad" ; -- ochartrad..av.1
  ocheckad_1_A = mkA "ocheckad" ; -- ocheckad..av.1
  ochevroterad_1_A = mkA "ochevroterad" ; -- ochevroterad..av.1
  ochevroterbar_1_A = mkA "ochevroterbar" ; -- ochevroterbar..av.1
  ochevroterbarhet_1_N = mkN "ochevroterbarhet" ; -- ochevroterbarhet..nn.1
  ochiffrerad_1_A = mkA "ochiffrerad" ; -- ochiffrerad..av.1
  ochiffrerbar_1_A = mkA "ochiffrerbar" ; -- ochiffrerbar..av.1
  ochiffrerbarhet_1_N = mkN "ochiffrerbarhet" ; -- ochiffrerbarhet..nn.1
  ochikanerad_1_A = mkA "ochikanerad" ; -- ochikanerad..av.1
  ochikanerbar_1_A = mkA "ochikanerbar" ; -- ochikanerbar..av.1
  ochikanerbarhet_1_N = mkN "ochikanerbarhet" ; -- ochikanerbarhet..nn.1
  ochockad_1_A = mkA "ochockad" ; -- ochockad..av.1
  ochockerad_1_A = mkA "ochockerad" ; -- ochockerad..av.1
  ochockerbar_1_A = mkA "ochockerbar" ; -- ochockerbar..av.1
  ochockerbarhet_1_N = mkN "ochockerbarhet" ; -- ochockerbarhet..nn.1
  ochokad_1_A = mkA "ochokad" ; -- ochokad..av.1
  ocirkulerad_1_A = mkA "ocirkulerad" ; -- ocirkulerad..av.1
  ocirkulerbar_1_A = mkA "ocirkulerbar" ; -- ocirkulerbar..av.1
  ocirkulerbarhet_1_N = mkN "ocirkulerbarhet" ; -- ocirkulerbarhet..nn.1
  ociselerad_1_A = mkA "ociselerad" ; -- ociselerad..av.1
  ociselerbar_1_A = mkA "ociselerbar" ; -- ociselerbar..av.1
  ociselerbarhet_1_N = mkN "ociselerbarhet" ; -- ociselerbarhet..nn.1
  ociterad_1_A = mkA "ociterad" ; -- ociterad..av.1
  ociterbar_1_A = mkA "ociterbar" ; -- ociterbar..av.1
  ociterbarhet_1_N = mkN "ociterbarhet" ; -- ociterbarhet..nn.1
  ociviliserad_1_A = mkA "ociviliserad" ; -- ociviliserad..av.1
  ociviliserbar_1_A = mkA "ociviliserbar" ; -- ociviliserbar..av.1
  ociviliserbarhet_1_N = mkN "ociviliserbarhet" ; -- ociviliserbarhet..nn.1
  ockasion_1_N = mkN "ockasion" ; -- ockasion..nn.1
  ockasionell_1_A = mkA "ockasionell" ; -- ockasionell..av.1
  ocker_1_N = mkN "ocker" neutrum  ; -- ocker..nn.1
  ockerhyra_1_N = mkN "ockerhyra" ; -- ockerhyra..nn.1
  ockerränta_1_N = mkN "ockerränta" ; -- ockerränta..nn.1
  ocklusion_1_N = mkN "ocklusion" ; -- ocklusion..nn.1
  ockra_1_N = mkN "ockra" ; -- ockra..nn.1
  ockra_1_V = mkV "ockrar" ; -- ockra..vb.1
  ockrande_1_N = mkN "ockrande" ; -- ockrande..nn.1
  ockrare_1_N = mkN "ockrare" utrum  ; -- ockrare..nn.1
  också_1_Adv = mkAdv "också" ; -- också..ab.1
  ockult_1_A = mkA "ockult" "ockult" ; -- ockult..av.1
  ockultation_1_N = mkN "ockultation" ; -- ockultation..nn.1
  ockultera_1_V = mkV "ockulterar" ; -- ockultera..vb.1
  ockulterande_1_N = mkN "ockulterande" ; -- ockulterande..nn.1
  ockultering_1_N = mkN "ockultering" ; -- ockultering..nn.1
  ockulthet_1_N = mkN "ockulthet" ; -- ockulthet..nn.1
  ockultism_1_N = mkN "ockultism" "ockultismer" ; -- ockultism..nn.1
  ockultist_1_N = mkN "ockultist" "ockultister" ; -- ockultist..nn.1
  ockultistisk_1_A = mkA "ockultistisk" ; -- ockultistisk..av.1
  ockupant_1_N = mkN "ockupant" "ockupanter" ; -- ockupant..nn.1
  ockupation_1_N = mkN "ockupation" ; -- ockupation..nn.1
  ockupationaszon_1_N = mkN "ockupationaszon" "ockupationaszoner" ; -- ockupationaszon..nn.1
  ockupationspolitik_1_N = mkN "ockupationspolitik" ; -- ockupationspolitik..nn.1
  ockupera_1_V = mkV "ockuperar" ; -- ockupera..vb.1
  ockuperande_1_N = mkN "ockuperande" ; -- ockuperande..nn.1
  ockuperbar_1_A = mkA "ockuperbar" ; -- ockuperbar..av.1
  ockuperbarhet_1_N = mkN "ockuperbarhet" ; -- ockuperbarhet..nn.1
  ockupering_1_N = mkN "ockupering" ; -- ockupering..nn.1
  oclearad_1_A = mkA "oclearad" ; -- oclearad..av.1
  ocuraterad_1_A = mkA "ocuraterad" ; -- ocuraterad..av.1
  ocuraterbar_1_A = mkA "ocuraterbar" ; -- ocuraterbar..av.1
  ocuraterbarhet_1_N = mkN "ocuraterbarhet" ; -- ocuraterbarhet..nn.1
  ocurerad_1_A = mkA "ocurerad" ; -- ocurerad..av.1
  ocurerbar_1_A = mkA "ocurerbar" ; -- ocurerbar..av.1
  ocurerbarhet_1_N = mkN "ocurerbarhet" ; -- ocurerbarhet..nn.1
  ocyklad_1_A = mkA "ocyklad" ; -- ocyklad..av.1
  odaddad_1_A = mkA "odaddad" ; -- odaddad..av.1
  odal_1_N = mkN "odal" ; -- odal..nn.1
  odalbonde_1_N = mkN "odalbonde" "odalbönder" ; -- odalbonde..nn.1
  odalisk_1_N = mkN "odalisk" "odalisker" ; -- odalisk..nn.1
  odaljord_1_N = mkN "odaljord" ; -- odaljord..nn.1
  odalman_1_N = mkN "odalman" "odalmannen" "odalmän" "odalmännen" ; -- odalman..nn.1
  odammad_1_A = mkA "odammad" ; -- odammad..av.1
  odampad_1_A = mkA "odampad" ; -- odampad..av.1
  odanad_1_A = mkA "odanad" ; -- odanad..av.1
  odaskad_1_A = mkA "odaskad" ; -- odaskad..av.1
  odaterad_1_A = mkA "odaterad" ; -- odaterad..av.1
  odaterbar_1_A = mkA "odaterbar" ; -- odaterbar..av.1
  odaterbarhet_1_N = mkN "odaterbarhet" ; -- odaterbarhet..nn.1
  odatoriserad_1_A = mkA "odatoriserad" ; -- odatoriserad..av.1
  odatoriserbar_1_A = mkA "odatoriserbar" ; -- odatoriserbar..av.1
  odatoriserbarhet_1_N = mkN "odatoriserbarhet" ; -- odatoriserbarhet..nn.1
  odds_1_N = mkN "odds" neutrum  ; -- odds..nn.1
  ode_1_N = mkN "ode" ; -- ode..nn.1
  odeaktiverbar_1_A = mkA "odeaktiverbar" ; -- odeaktiverbar..av.1
  odeaktiverbarhet_1_N = mkN "odeaktiverbarhet" ; -- odeaktiverbarhet..nn.1
  odebarkerad_1_A = mkA "odebarkerad" ; -- odebarkerad..av.1
  odebarkerbar_1_A = mkA "odebarkerbar" ; -- odebarkerbar..av.1
  odebarkerbarhet_1_N = mkN "odebarkerbarhet" ; -- odebarkerbarhet..nn.1
  odebatterad_1_A = mkA "odebatterad" ; -- odebatterad..av.1
  odebatterbar_1_A = mkA "odebatterbar" ; -- odebatterbar..av.1
  odebatterbarhet_1_N = mkN "odebatterbarhet" ; -- odebatterbarhet..nn.1
  odebiterad_1_A = mkA "odebiterad" ; -- odebiterad..av.1
  odebiterbar_1_A = mkA "odebiterbar" ; -- odebiterbar..av.1
  odebiterbarhet_1_N = mkN "odebiterbarhet" ; -- odebiterbarhet..nn.1
  odecentraliserad_1_A = mkA "odecentraliserad" ; -- odecentraliserad..av.1
  odecentraliserbar_1_A = mkA "odecentraliserbar" ; -- odecentraliserbar..av.1
  odecentraliserbarhet_1_N = mkN "odecentraliserbarhet" ; -- odecentraliserbarhet..nn.1
  odechiffrerad_1_A = mkA "odechiffrerad" ; -- odechiffrerad..av.1
  odechiffrerbar_1_A = mkA "odechiffrerbar" ; -- odechiffrerbar..av.1
  odechiffrerbarhet_1_N = mkN "odechiffrerbarhet" ; -- odechiffrerbarhet..nn.1
  odeciderad_1_A = mkA "odeciderad" ; -- odeciderad..av.1
  odecimerad_1_A = mkA "odecimerad" ; -- odecimerad..av.1
  odecimerbar_1_A = mkA "odecimerbar" ; -- odecimerbar..av.1
  odecimerbarhet_1_N = mkN "odecimerbarhet" ; -- odecimerbarhet..nn.1
  odedicerad_1_A = mkA "odedicerad" ; -- odedicerad..av.1
  odedicerbar_1_A = mkA "odedicerbar" ; -- odedicerbar..av.1
  odedicerbarhet_1_N = mkN "odedicerbarhet" ; -- odedicerbarhet..nn.1
  odedikerad_1_A = mkA "odedikerad" ; -- odedikerad..av.1
  odedikerbar_1_A = mkA "odedikerbar" ; -- odedikerbar..av.1
  odedikerbarhet_1_N = mkN "odedikerbarhet" ; -- odedikerbarhet..nn.1
  odeducerad_1_A = mkA "odeducerad" ; -- odeducerad..av.1
  odeducerbar_1_A = mkA "odeducerbar" ; -- odeducerbar..av.1
  odeducerbarhet_1_N = mkN "odeducerbarhet" ; -- odeducerbarhet..nn.1
  odefilerad_1_A = mkA "odefilerad" ; -- odefilerad..av.1
  odefilerbar_1_A = mkA "odefilerbar" ; -- odefilerbar..av.1
  odefilerbarhet_1_N = mkN "odefilerbarhet" ; -- odefilerbarhet..nn.1
  odefinierad_1_A = mkA "odefinierad" ; -- odefinierad..av.1
  odefinierbar_1_A = mkA "odefinierbar" ; -- odefinierbar..av.1
  odefinierbarhet_1_N = mkN "odefinierbarhet" ; -- odefinierbarhet..nn.1
  odeflorerad_1_A = mkA "odeflorerad" ; -- odeflorerad..av.1
  odeflorerbar_1_A = mkA "odeflorerbar" ; -- odeflorerbar..av.1
  odeflorerbarhet_1_N = mkN "odeflorerbarhet" ; -- odeflorerbarhet..nn.1
  odeformerad_1_A = mkA "odeformerad" ; -- odeformerad..av.1
  odeformerbar_1_A = mkA "odeformerbar" ; -- odeformerbar..av.1
  odeformerbarhet_1_N = mkN "odeformerbarhet" ; -- odeformerbarhet..nn.1
  odegenererad_1_A = mkA "odegenererad" ; -- odegenererad..av.1
  odegenererbar_1_A = mkA "odegenererbar" ; -- odegenererbar..av.1
  odegenererbarhet_1_N = mkN "odegenererbarhet" ; -- odegenererbarhet..nn.1
  odegraderad_1_A = mkA "odegraderad" ; -- odegraderad..av.1
  odegraderbar_1_A = mkA "odegraderbar" ; -- odegraderbar..av.1
  odegraderbarhet_1_N = mkN "odegraderbarhet" ; -- odegraderbarhet..nn.1
  odejtad_1_A = mkA "odejtad" ; -- odejtad..av.1
  odekanterad_1_A = mkA "odekanterad" ; -- odekanterad..av.1
  odekanterbar_1_A = mkA "odekanterbar" ; -- odekanterbar..av.1
  odekanterbarhet_1_N = mkN "odekanterbarhet" ; -- odekanterbarhet..nn.1
  odekapiterad_1_A = mkA "odekapiterad" ; -- odekapiterad..av.1
  odekapiterbar_1_A = mkA "odekapiterbar" ; -- odekapiterbar..av.1
  odekapiterbarhet_1_N = mkN "odekapiterbarhet" ; -- odekapiterbarhet..nn.1
  odeklamerad_1_A = mkA "odeklamerad" ; -- odeklamerad..av.1
  odeklamerbar_1_A = mkA "odeklamerbar" ; -- odeklamerbar..av.1
  odeklamerbarhet_1_N = mkN "odeklamerbarhet" ; -- odeklamerbarhet..nn.1
  odeklarerad_1_A = mkA "odeklarerad" ; -- odeklarerad..av.1
  odeklarerbar_1_A = mkA "odeklarerbar" ; -- odeklarerbar..av.1
  odeklarerbarhet_1_N = mkN "odeklarerbarhet" ; -- odeklarerbarhet..nn.1
  odeklasserad_1_A = mkA "odeklasserad" ; -- odeklasserad..av.1
  odeklasserbar_1_A = mkA "odeklasserbar" ; -- odeklasserbar..av.1
  odeklasserbarhet_1_N = mkN "odeklasserbarhet" ; -- odeklasserbarhet..nn.1
  odeklinerad_1_A = mkA "odeklinerad" ; -- odeklinerad..av.1
  odeklinerbar_1_A = mkA "odeklinerbar" ; -- odeklinerbar..av.1
  odeklinerbarhet_1_N = mkN "odeklinerbarhet" ; -- odeklinerbarhet..nn.1
  odekorerad_1_A = mkA "odekorerad" ; -- odekorerad..av.1
  odekorerbar_1_A = mkA "odekorerbar" ; -- odekorerbar..av.1
  odekorerbarhet_1_N = mkN "odekorerbarhet" ; -- odekorerbarhet..nn.1
  odekouragerad_1_A = mkA "odekouragerad" ; -- odekouragerad..av.1
  odekouragerbar_1_A = mkA "odekouragerbar" ; -- odekouragerbar..av.1
  odekouragerbarhet_1_N = mkN "odekouragerbarhet" ; -- odekouragerbarhet..nn.1
  odekreterad_1_A = mkA "odekreterad" ; -- odekreterad..av.1
  odekreterbar_1_A = mkA "odekreterbar" ; -- odekreterbar..av.1
  odekreterbarhet_1_N = mkN "odekreterbarhet" ; -- odekreterbarhet..nn.1
  odelad_1_A = mkA "odelad" ; -- odelad..av.1
  odelbar_1_A = mkA "odelbar" ; -- odelbar..av.1
  odelbarhet_1_N = mkN "odelbarhet" ; -- odelbarhet..nn.1
  odelegerad_1_A = mkA "odelegerad" ; -- odelegerad..av.1
  odelegerbar_1_A = mkA "odelegerbar" ; -- odelegerbar..av.1
  odelegerbarhet_1_N = mkN "odelegerbarhet" ; -- odelegerbarhet..nn.1
  odelsting_1_N = mkN "odelsting" neutrum  ; -- odelsting..nn.1
  odemad_1_A = mkA "odemad" ; -- odemad..av.1
  odemaskerad_1_A = mkA "odemaskerad" ; -- odemaskerad..av.1
  odemaskerbar_1_A = mkA "odemaskerbar" ; -- odemaskerbar..av.1
  odemaskerbarhet_1_N = mkN "odemaskerbarhet" ; -- odemaskerbarhet..nn.1
  odementerad_1_A = mkA "odementerad" ; -- odementerad..av.1
  odementerbar_1_A = mkA "odementerbar" ; -- odementerbar..av.1
  odementerbarhet_1_N = mkN "odementerbarhet" ; -- odementerbarhet..nn.1
  odemilitariserad_1_A = mkA "odemilitariserad" ; -- odemilitariserad..av.1
  odemilitariserbar_1_A = mkA "odemilitariserbar" ; -- odemilitariserbar..av.1
  odemilitariserbarhet_1_N = mkN "odemilitariserbarhet" ; -- odemilitariserbarhet..nn.1
  odemissionerad_1_A = mkA "odemissionerad" ; -- odemissionerad..av.1
  odemobiliserad_1_A = mkA "odemobiliserad" ; -- odemobiliserad..av.1
  odemobiliserbar_1_A = mkA "odemobiliserbar" ; -- odemobiliserbar..av.1
  odemobiliserbarhet_1_N = mkN "odemobiliserbarhet" ; -- odemobiliserbarhet..nn.1
  odemokratiserad_1_A = mkA "odemokratiserad" ; -- odemokratiserad..av.1
  odemokratiserbar_1_A = mkA "odemokratiserbar" ; -- odemokratiserbar..av.1
  odemokratiserbarhet_1_N = mkN "odemokratiserbarhet" ; -- odemokratiserbarhet..nn.1
  odemokratisk_1_A = mkA "odemokratisk" ; -- odemokratisk..av.1
  odemolerad_1_A = mkA "odemolerad" ; -- odemolerad..av.1
  odemolerbar_1_A = mkA "odemolerbar" ; -- odemolerbar..av.1
  odemolerbarhet_1_N = mkN "odemolerbarhet" ; -- odemolerbarhet..nn.1
  odemoniserbar_1_A = mkA "odemoniserbar" ; -- odemoniserbar..av.1
  odemoniserbarhet_1_N = mkN "odemoniserbarhet" ; -- odemoniserbarhet..nn.1
  odemonstrerad_1_A = mkA "odemonstrerad" ; -- odemonstrerad..av.1
  odemonstrerbar_1_A = mkA "odemonstrerbar" ; -- odemonstrerbar..av.1
  odemonstrerbarhet_1_N = mkN "odemonstrerbarhet" ; -- odemonstrerbarhet..nn.1
  odemonterad_1_A = mkA "odemonterad" ; -- odemonterad..av.1
  odemonterbar_1_A = mkA "odemonterbar" ; -- odemonterbar..av.1
  odemonterbarhet_1_N = mkN "odemonterbarhet" ; -- odemonterbarhet..nn.1
  odemoraliserad_1_A = mkA "odemoraliserad" ; -- odemoraliserad..av.1
  odemoraliserbar_1_A = mkA "odemoraliserbar" ; -- odemoraliserbar..av.1
  odemoraliserbarhet_1_N = mkN "odemoraliserbarhet" ; -- odemoraliserbarhet..nn.1
  odenaturaliserad_1_A = mkA "odenaturaliserad" ; -- odenaturaliserad..av.1
  odenaturaliserbar_1_A = mkA "odenaturaliserbar" ; -- odenaturaliserbar..av.1
  odenaturaliserbarhet_1_N = mkN "odenaturaliserbarhet" ; -- odenaturaliserbarhet..nn.1
  odenaturerad_1_A = mkA "odenaturerad" ; -- odenaturerad..av.1
  odenaturerbar_1_A = mkA "odenaturerbar" ; -- odenaturerbar..av.1
  odenaturerbarhet_1_N = mkN "odenaturerbarhet" ; -- odenaturerbarhet..nn.1
  odenoterad_1_A = mkA "odenoterad" ; -- odenoterad..av.1
  odenoterbar_1_A = mkA "odenoterbar" ; -- odenoterbar..av.1
  odenoterbarhet_1_N = mkN "odenoterbarhet" ; -- odenoterbarhet..nn.1
  odensfly_1_N = mkN "odensfly" "odensflyet" "odensflyn" "odensflyna" ; -- odensfly..nn.1
  odenuderad_1_A = mkA "odenuderad" ; -- odenuderad..av.1
  odenuderbar_1_A = mkA "odenuderbar" ; -- odenuderbar..av.1
  odenuderbarhet_1_N = mkN "odenuderbarhet" ; -- odenuderbarhet..nn.1
  odeodoriserad_1_A = mkA "odeodoriserad" ; -- odeodoriserad..av.1
  odeodoriserbar_1_A = mkA "odeodoriserbar" ; -- odeodoriserbar..av.1
  odeodoriserbarhet_1_N = mkN "odeodoriserbarhet" ; -- odeodoriserbarhet..nn.1
  odepatrierad_1_A = mkA "odepatrierad" ; -- odepatrierad..av.1
  odepatrierbar_1_A = mkA "odepatrierbar" ; -- odepatrierbar..av.1
  odepatrierbarhet_1_N = mkN "odepatrierbarhet" ; -- odepatrierbarhet..nn.1
  odepenserad_1_A = mkA "odepenserad" ; -- odepenserad..av.1
  odepenserbar_1_A = mkA "odepenserbar" ; -- odepenserbar..av.1
  odepenserbarhet_1_N = mkN "odepenserbarhet" ; -- odepenserbarhet..nn.1
  odeplacerad_1_A = mkA "odeplacerad" ; -- odeplacerad..av.1
  odeplacerbar_1_A = mkA "odeplacerbar" ; -- odeplacerbar..av.1
  odeplacerbarhet_1_N = mkN "odeplacerbarhet" ; -- odeplacerbarhet..nn.1
  odeponerad_1_A = mkA "odeponerad" ; -- odeponerad..av.1
  odeponerbar_1_A = mkA "odeponerbar" ; -- odeponerbar..av.1
  odeponerbarhet_1_N = mkN "odeponerbarhet" ; -- odeponerbarhet..nn.1
  odeporterad_1_A = mkA "odeporterad" ; -- odeporterad..av.1
  odeporterbar_1_A = mkA "odeporterbar" ; -- odeporterbar..av.1
  odeporterbarhet_1_N = mkN "odeporterbarhet" ; -- odeporterbarhet..nn.1
  odeprecierad_1_A = mkA "odeprecierad" ; -- odeprecierad..av.1
  odeprecierbar_1_A = mkA "odeprecierbar" ; -- odeprecierbar..av.1
  odeprecierbarhet_1_N = mkN "odeprecierbarhet" ; -- odeprecierbarhet..nn.1
  oderangerad_1_A = mkA "oderangerad" ; -- oderangerad..av.1
  oderangerbar_1_A = mkA "oderangerbar" ; -- oderangerbar..av.1
  oderangerbarhet_1_N = mkN "oderangerbarhet" ; -- oderangerbarhet..nn.1
  oderiverad_1_A = mkA "oderiverad" ; -- oderiverad..av.1
  oderiverbar_1_A = mkA "oderiverbar" ; -- oderiverbar..av.1
  oderiverbarhet_1_N = mkN "oderiverbarhet" ; -- oderiverbarhet..nn.1
  odesarmerad_1_A = mkA "odesarmerad" ; -- odesarmerad..av.1
  odesarmerbar_1_A = mkA "odesarmerbar" ; -- odesarmerbar..av.1
  odesarmerbarhet_1_N = mkN "odesarmerbarhet" ; -- odesarmerbarhet..nn.1
  odesavouerad_1_A = mkA "odesavouerad" ; -- odesavouerad..av.1
  odesavouerbar_1_A = mkA "odesavouerbar" ; -- odesavouerbar..av.1
  odesavouerbarhet_1_N = mkN "odesavouerbarhet" ; -- odesavouerbarhet..nn.1
  odesensibiliserad_1_A = mkA "odesensibiliserad" ; -- odesensibiliserad..av.1
  odesensibiliserbar_1_A = mkA "odesensibiliserbar" ; -- odesensibiliserbar..av.1
  odesensibiliserbarhet_1_N = mkN "odesensibiliserbarhet" ; -- odesensibiliserbarhet..nn.1
  odesignad_1_A = mkA "odesignad" ; -- odesignad..av.1
  odesignerad_1_A = mkA "odesignerad" ; -- odesignerad..av.1
  odesignerbar_1_A = mkA "odesignerbar" ; -- odesignerbar..av.1
  odesignerbarhet_1_N = mkN "odesignerbarhet" ; -- odesignerbarhet..nn.1
  odesinfekterad_1_A = mkA "odesinfekterad" ; -- odesinfekterad..av.1
  odesinfekterbar_1_A = mkA "odesinfekterbar" ; -- odesinfekterbar..av.1
  odesinfekterbarhet_1_N = mkN "odesinfekterbarhet" ; -- odesinfekterbarhet..nn.1
  odesinficerad_1_A = mkA "odesinficerad" ; -- odesinficerad..av.1
  odesinficerbar_1_A = mkA "odesinficerbar" ; -- odesinficerbar..av.1
  odesinficerbarhet_1_N = mkN "odesinficerbarhet" ; -- odesinficerbarhet..nn.1
  odesinformerad_1_A = mkA "odesinformerad" ; -- odesinformerad..av.1
  odesinformerbar_1_A = mkA "odesinformerbar" ; -- odesinformerbar..av.1
  odesinformerbarhet_1_N = mkN "odesinformerbarhet" ; -- odesinformerbarhet..nn.1
  odesorganiserad_1_A = mkA "odesorganiserad" ; -- odesorganiserad..av.1
  odesorganiserbar_1_A = mkA "odesorganiserbar" ; -- odesorganiserbar..av.1
  odesorganiserbarhet_1_N = mkN "odesorganiserbarhet" ; -- odesorganiserbarhet..nn.1
  odestabiliserad_1_A = mkA "odestabiliserad" ; -- odestabiliserad..av.1
  odestabiliserbar_1_A = mkA "odestabiliserbar" ; -- odestabiliserbar..av.1
  odestabiliserbarhet_1_N = mkN "odestabiliserbarhet" ; -- odestabiliserbarhet..nn.1
  odestillerad_1_A = mkA "odestillerad" ; -- odestillerad..av.1
  odestillerbar_1_A = mkA "odestillerbar" ; -- odestillerbar..av.1
  odestillerbarhet_1_N = mkN "odestillerbarhet" ; -- odestillerbarhet..nn.1
  odestinerad_1_A = mkA "odestinerad" ; -- odestinerad..av.1
  odestinerbar_1_A = mkA "odestinerbar" ; -- odestinerbar..av.1
  odestinerbarhet_1_N = mkN "odestinerbarhet" ; -- odestinerbarhet..nn.1
  odestruerad_1_A = mkA "odestruerad" ; -- odestruerad..av.1
  odestruerbar_1_A = mkA "odestruerbar" ; -- odestruerbar..av.1
  odestruerbarhet_1_N = mkN "odestruerbarhet" ; -- odestruerbarhet..nn.1
  odetacherad_1_A = mkA "odetacherad" ; -- odetacherad..av.1
  odetacherbar_1_A = mkA "odetacherbar" ; -- odetacherbar..av.1
  odetacherbarhet_1_N = mkN "odetacherbarhet" ; -- odetacherbarhet..nn.1
  odetaljerad_1_A = mkA "odetaljerad" ; -- odetaljerad..av.1
  odetekterad_1_A = mkA "odetekterad" ; -- odetekterad..av.1
  odetekterbar_1_A = mkA "odetekterbar" ; -- odetekterbar..av.1
  odetekterbarhet_1_N = mkN "odetekterbarhet" ; -- odetekterbarhet..nn.1
  odeterminerad_1_A = mkA "odeterminerad" ; -- odeterminerad..av.1
  odeterminerbar_1_A = mkA "odeterminerbar" ; -- odeterminerbar..av.1
  odeterminerbarhet_1_N = mkN "odeterminerbarhet" ; -- odeterminerbarhet..nn.1
  odetonerad_1_A = mkA "odetonerad" ; -- odetonerad..av.1
  odetonerbar_1_A = mkA "odetonerbar" ; -- odetonerbar..av.1
  odetonerbarhet_1_N = mkN "odetonerbarhet" ; -- odetonerbarhet..nn.1
  odetroniserad_1_A = mkA "odetroniserad" ; -- odetroniserad..av.1
  odetroniserbar_1_A = mkA "odetroniserbar" ; -- odetroniserbar..av.1
  odetroniserbarhet_1_N = mkN "odetroniserbarhet" ; -- odetroniserbarhet..nn.1
  odevalverad_1_A = mkA "odevalverad" ; -- odevalverad..av.1
  odevalverbar_1_A = mkA "odevalverbar" ; -- odevalverbar..av.1
  odevalverbarhet_1_N = mkN "odevalverbarhet" ; -- odevalverbarhet..nn.1
  odiad_1_A = mkA "odiad" ; -- odiad..av.1
  odiagnosticerad_1_A = mkA "odiagnosticerad" ; -- odiagnosticerad..av.1
  odiagnosticerbar_1_A = mkA "odiagnosticerbar" ; -- odiagnosticerbar..av.1
  odiagnosticerbarhet_1_N = mkN "odiagnosticerbarhet" ; -- odiagnosticerbarhet..nn.1
  odiagnostiserad_1_A = mkA "odiagnostiserad" ; -- odiagnostiserad..av.1
  odiagnostiserbar_1_A = mkA "odiagnostiserbar" ; -- odiagnostiserbar..av.1
  odiagnostiserbarhet_1_N = mkN "odiagnostiserbarhet" ; -- odiagnostiserbarhet..nn.1
  odialyserad_1_A = mkA "odialyserad" ; -- odialyserad..av.1
  odialyserbar_1_A = mkA "odialyserbar" ; -- odialyserbar..av.1
  odialyserbarhet_1_N = mkN "odialyserbarhet" ; -- odialyserbarhet..nn.1
  odibblad_1_A = mkA "odibblad" ; -- odibblad..av.1
  odifferentierad_1_A = mkA "odifferentierad" ; -- odifferentierad..av.1
  odifferentierbar_1_A = mkA "odifferentierbar" ; -- odifferentierbar..av.1
  odifferentierbarhet_1_N = mkN "odifferentierbarhet" ; -- odifferentierbarhet..nn.1
  odiffunderad_1_A = mkA "odiffunderad" ; -- odiffunderad..av.1
  odiffunderbar_1_A = mkA "odiffunderbar" ; -- odiffunderbar..av.1
  odiffunderbarhet_1_N = mkN "odiffunderbarhet" ; -- odiffunderbarhet..nn.1
  odiftongerad_1_A = mkA "odiftongerad" ; -- odiftongerad..av.1
  odiftongerbar_1_A = mkA "odiftongerbar" ; -- odiftongerbar..av.1
  odiftongerbarhet_1_N = mkN "odiftongerbarhet" ; -- odiftongerbarhet..nn.1
  odigererad_1_A = mkA "odigererad" ; -- odigererad..av.1
  odigererbar_1_A = mkA "odigererbar" ; -- odigererbar..av.1
  odigererbarhet_1_N = mkN "odigererbarhet" ; -- odigererbarhet..nn.1
  odiggad_1_A = mkA "odiggad" ; -- odiggad..av.1
  odigitaliserad_1_A = mkA "odigitaliserad" ; -- odigitaliserad..av.1
  odigitaliserbar_1_A = mkA "odigitaliserbar" ; -- odigitaliserbar..av.1
  odigitaliserbarhet_1_N = mkN "odigitaliserbarhet" ; -- odigitaliserbarhet..nn.1
  odikad_1_A = mkA "odikad" ; -- odikad..av.1
  odiktad_1_A = mkA "odiktad" ; -- odiktad..av.1
  odikterad_1_A = mkA "odikterad" ; -- odikterad..av.1
  odikterbar_1_A = mkA "odikterbar" ; -- odikterbar..av.1
  odikterbarhet_1_N = mkN "odikterbarhet" ; -- odikterbarhet..nn.1
  odimensionerad_1_A = mkA "odimensionerad" ; -- odimensionerad..av.1
  odimensionerbar_1_A = mkA "odimensionerbar" ; -- odimensionerbar..av.1
  odimensionerbarhet_1_N = mkN "odimensionerbarhet" ; -- odimensionerbarhet..nn.1
  odiplomatisk_1_A = mkA "odiplomatisk" ; -- odiplomatisk..av.1
  odiplomerad_1_A = mkA "odiplomerad" ; -- odiplomerad..av.1
  odiplomerbar_1_A = mkA "odiplomerbar" ; -- odiplomerbar..av.1
  odiplomerbarhet_1_N = mkN "odiplomerbarhet" ; -- odiplomerbarhet..nn.1
  odippad_1_A = mkA "odippad" ; -- odippad..av.1
  odirigerad_1_A = mkA "odirigerad" ; -- odirigerad..av.1
  odirigerbar_1_A = mkA "odirigerbar" ; -- odirigerbar..av.1
  odirigerbarhet_1_N = mkN "odirigerbarhet" ; -- odirigerbarhet..nn.1
  odisambiguerad_1_A = mkA "odisambiguerad" ; -- odisambiguerad..av.1
  odisambiguerbar_1_A = mkA "odisambiguerbar" ; -- odisambiguerbar..av.1
  odisambiguerbarhet_1_N = mkN "odisambiguerbarhet" ; -- odisambiguerbarhet..nn.1
  odisciplinerad_1_A = mkA "odisciplinerad" ; -- odisciplinerad..av.1
  odisciplinerbar_1_A = mkA "odisciplinerbar" ; -- odisciplinerbar..av.1
  odisciplinerbarhet_1_N = mkN "odisciplinerbarhet" ; -- odisciplinerbarhet..nn.1
  odisharmonierad_1_A = mkA "odisharmonierad" ; -- odisharmonierad..av.1
  odisharmonierbar_1_A = mkA "odisharmonierbar" ; -- odisharmonierbar..av.1
  odisharmonierbarhet_1_N = mkN "odisharmonierbarhet" ; -- odisharmonierbarhet..nn.1
  odiskad_1_A = mkA "odiskad" ; -- odiskad..av.1
  odiskonterad_1_A = mkA "odiskonterad" ; -- odiskonterad..av.1
  odiskonterbar_1_A = mkA "odiskonterbar" ; -- odiskonterbar..av.1
  odiskonterbarhet_1_N = mkN "odiskonterbarhet" ; -- odiskonterbarhet..nn.1
  odiskrediterad_1_A = mkA "odiskrediterad" ; -- odiskrediterad..av.1
  odiskrediterbar_1_A = mkA "odiskrediterbar" ; -- odiskrediterbar..av.1
  odiskrediterbarhet_1_N = mkN "odiskrediterbarhet" ; -- odiskrediterbarhet..nn.1
  odiskriminerad_1_A = mkA "odiskriminerad" ; -- odiskriminerad..av.1
  odiskriminerbar_1_A = mkA "odiskriminerbar" ; -- odiskriminerbar..av.1
  odiskriminerbarhet_1_N = mkN "odiskriminerbarhet" ; -- odiskriminerbarhet..nn.1
  odiskutabel_1_A = mkA "odiskutabel" ; -- odiskutabel..av.1
  odiskuterad_1_A = mkA "odiskuterad" ; -- odiskuterad..av.1
  odiskuterbar_1_A = mkA "odiskuterbar" ; -- odiskuterbar..av.1
  odiskuterbarhet_1_N = mkN "odiskuterbarhet" ; -- odiskuterbarhet..nn.1
  odiskvalificerad_1_A = mkA "odiskvalificerad" ; -- odiskvalificerad..av.1
  odiskvalificerbar_1_A = mkA "odiskvalificerbar" ; -- odiskvalificerbar..av.1
  odiskvalificerbarhet_1_N = mkN "odiskvalificerbarhet" ; -- odiskvalificerbarhet..nn.1
  odispascherad_1_A = mkA "odispascherad" ; -- odispascherad..av.1
  odispascherbar_1_A = mkA "odispascherbar" ; -- odispascherbar..av.1
  odispascherbarhet_1_N = mkN "odispascherbarhet" ; -- odispascherbarhet..nn.1
  odispenserad_1_A = mkA "odispenserad" ; -- odispenserad..av.1
  odispenserbar_1_A = mkA "odispenserbar" ; -- odispenserbar..av.1
  odispenserbarhet_1_N = mkN "odispenserbarhet" ; -- odispenserbarhet..nn.1
  odispergerad_1_A = mkA "odispergerad" ; -- odispergerad..av.1
  odispergerbar_1_A = mkA "odispergerbar" ; -- odispergerbar..av.1
  odispergerbarhet_1_N = mkN "odispergerbarhet" ; -- odispergerbarhet..nn.1
  odisponerad_1_A = mkA "odisponerad" ; -- odisponerad..av.1
  odisponerbar_1_A = mkA "odisponerbar" ; -- odisponerbar..av.1
  odisponerbarhet_1_N = mkN "odisponerbarhet" ; -- odisponerbarhet..nn.1
  odisputabel_1_A = mkA "odisputabel" ; -- odisputabel..av.1
  odisputerad_1_A = mkA "odisputerad" ; -- odisputerad..av.1
  odisputerbar_1_A = mkA "odisputerbar" ; -- odisputerbar..av.1
  odisputerbarhet_1_N = mkN "odisputerbarhet" ; -- odisputerbarhet..nn.1
  odissad_1_A = mkA "odissad" ; -- odissad..av.1
  odissekerad_1_A = mkA "odissekerad" ; -- odissekerad..av.1
  odissekerbar_1_A = mkA "odissekerbar" ; -- odissekerbar..av.1
  odissekerbarhet_1_N = mkN "odissekerbarhet" ; -- odissekerbarhet..nn.1
  odissimilerad_1_A = mkA "odissimilerad" ; -- odissimilerad..av.1
  odissimilerbar_1_A = mkA "odissimilerbar" ; -- odissimilerbar..av.1
  odissimilerbarhet_1_N = mkN "odissimilerbarhet" ; -- odissimilerbarhet..nn.1
  odissocierad_1_A = mkA "odissocierad" ; -- odissocierad..av.1
  odissocierbar_1_A = mkA "odissocierbar" ; -- odissocierbar..av.1
  odissocierbarhet_1_N = mkN "odissocierbarhet" ; -- odissocierbarhet..nn.1
  odistanserad_1_A = mkA "odistanserad" ; -- odistanserad..av.1
  odistanserbar_1_A = mkA "odistanserbar" ; -- odistanserbar..av.1
  odistanserbarhet_1_N = mkN "odistanserbarhet" ; -- odistanserbarhet..nn.1
  odistraherad_1_A = mkA "odistraherad" ; -- odistraherad..av.1
  odistraherbar_1_A = mkA "odistraherbar" ; -- odistraherbar..av.1
  odistraherbarhet_1_N = mkN "odistraherbarhet" ; -- odistraherbarhet..nn.1
  odistribuerad_1_A = mkA "odistribuerad" ; -- odistribuerad..av.1
  odistribuerbar_1_A = mkA "odistribuerbar" ; -- odistribuerbar..av.1
  odistribuerbarhet_1_N = mkN "odistribuerbarhet" ; -- odistribuerbarhet..nn.1
  odivergerad_1_A = mkA "odivergerad" ; -- odivergerad..av.1
  odivergerbar_1_A = mkA "odivergerbar" ; -- odivergerbar..av.1
  odivergerbarhet_1_N = mkN "odivergerbarhet" ; -- odivergerbarhet..nn.1
  odiversifierad_1_A = mkA "odiversifierad" ; -- odiversifierad..av.1
  odiversifierbar_1_A = mkA "odiversifierbar" ; -- odiversifierbar..av.1
  odiversifierbarhet_1_N = mkN "odiversifierbarhet" ; -- odiversifierbarhet..nn.1
  odividerad_1_A = mkA "odividerad" ; -- odividerad..av.1
  odividerbar_1_A = mkA "odividerbar" ; -- odividerbar..av.1
  odividerbarhet_1_N = mkN "odividerbarhet" ; -- odividerbarhet..nn.1
  odiös_1_A = mkA "odiös" ; -- odiös..av.1
  odjur_1_N = mkN "odjur" neutrum  ; -- odjur..nn.1
  odla_1_V = mkV "odlar" ; -- odla..vb.1
  odlande_1_N = mkN "odlande" ; -- odlande..nn.1
  odlare_1_N = mkN "odlare" utrum  ; -- odlare..nn.1
  odling_1_N = mkN "odling" ; -- odling..nn.1
  odlingsareal_1_N = mkN "odlingsareal" "odlingsarealer" ; -- odlingsareal..nn.1
  odlingsbar_1_A = mkA "odlingsbar" ; -- odlingsbar..av.1
  odlingsbarhet_1_N = mkN "odlingsbarhet" ; -- odlingsbarhet..nn.1
  odlingsförsök_1_N = mkN "odlingsförsök" neutrum  ; -- odlingsförsök..nn.1
  odlingsgräns_1_N = mkN "odlingsgräns" "odlingsgränser" ; -- odlingsgräns..nn.1
  odlingslager_1_N = mkN "odlingslager" neutrum  ; -- odlingslager..nn.1
  odlingsmark_1_N = mkN "odlingsmark" "odlingsmarker" ; -- odlingsmark..nn.1
  odlingssäsong_1_N = mkN "odlingssäsong" "odlingssäsonger" ; -- odlingssäsong..nn.1
  odlingsvärde_1_N = mkN "odlingsvärde" ; -- odlingsvärde..nn.1
  odocerad_1_A = mkA "odocerad" ; -- odocerad..av.1
  odocerbar_1_A = mkA "odocerbar" ; -- odocerbar..av.1
  odocerbarhet_1_N = mkN "odocerbarhet" ; -- odocerbarhet..nn.1
  odockad_1_A = mkA "odockad" ; -- odockad..av.1
  odogmatiserad_1_A = mkA "odogmatiserad" ; -- odogmatiserad..av.1
  odogmatiserbar_1_A = mkA "odogmatiserbar" ; -- odogmatiserbar..av.1
  odogmatiserbarhet_1_N = mkN "odogmatiserbarhet" ; -- odogmatiserbarhet..nn.1
  odogmatisk_1_A = mkA "odogmatisk" ; -- odogmatisk..av.1
  odoktorerad_1_A = mkA "odoktorerad" ; -- odoktorerad..av.1
  odokumenterad_1_A = mkA "odokumenterad" ; -- odokumenterad..av.1
  odokumenterbar_1_A = mkA "odokumenterbar" ; -- odokumenterbar..av.1
  odokumenterbarhet_1_N = mkN "odokumenterbarhet" ; -- odokumenterbarhet..nn.1
  odomesticerad_1_A = mkA "odomesticerad" ; -- odomesticerad..av.1
  odomesticerbar_1_A = mkA "odomesticerbar" ; -- odomesticerbar..av.1
  odomesticerbarhet_1_N = mkN "odomesticerbarhet" ; -- odomesticerbarhet..nn.1
  odomicilierad_1_A = mkA "odomicilierad" ; -- odomicilierad..av.1
  odomicilierbar_1_A = mkA "odomicilierbar" ; -- odomicilierbar..av.1
  odomicilierbarhet_1_N = mkN "odomicilierbarhet" ; -- odomicilierbarhet..nn.1
  odominerad_1_A = mkA "odominerad" ; -- odominerad..av.1
  odominerbar_1_A = mkA "odominerbar" ; -- odominerbar..av.1
  odominerbarhet_1_N = mkN "odominerbarhet" ; -- odominerbarhet..nn.1
  odomnad_1_A = mkA "odomnad" ; -- odomnad..av.1
  odompterad_1_A = mkA "odompterad" ; -- odompterad..av.1
  odompterbar_1_A = mkA "odompterbar" ; -- odompterbar..av.1
  odompterbarhet_1_N = mkN "odompterbarhet" ; -- odompterbarhet..nn.1
  odon_1_N = mkN "odon" neutrum  ; -- odon..nn.1
  odonerad_1_A = mkA "odonerad" ; -- odonerad..av.1
  odonerbar_1_A = mkA "odonerbar" ; -- odonerbar..av.1
  odonerbarhet_1_N = mkN "odonerbarhet" ; -- odonerbarhet..nn.1
  odonkad_1_A = mkA "odonkad" ; -- odonkad..av.1
  odontolog_1_N = mkN "odontolog" "odontologer" ; -- odontolog..nn.1
  odontologi_1_N = mkN "odontologi" ; -- odontologi..nn.1
  odontologie_1_A = mkA "odontologie" ; -- odontologie..av.1
  odontologisk_1_A = mkA "odontologisk" ; -- odontologisk..av.1
  odopad_1_A = mkA "odopad" ; -- odopad..av.1
  odoppad_1_A = mkA "odoppad" ; -- odoppad..av.1
  odoserad_1_A = mkA "odoserad" ; -- odoserad..av.1
  odoserbar_1_A = mkA "odoserbar" ; -- odoserbar..av.1
  odoserbarhet_1_N = mkN "odoserbarhet" ; -- odoserbarhet..nn.1
  odosserad_1_A = mkA "odosserad" ; -- odosserad..av.1
  odosserbar_1_A = mkA "odosserbar" ; -- odosserbar..av.1
  odosserbarhet_1_N = mkN "odosserbarhet" ; -- odosserbarhet..nn.1
  odoterad_1_A = mkA "odoterad" ; -- odoterad..av.1
  odoterbar_1_A = mkA "odoterbar" ; -- odoterbar..av.1
  odoterbarhet_1_N = mkN "odoterbarhet" ; -- odoterbarhet..nn.1
  odrabbad_1_A = mkA "odrabbad" ; -- odrabbad..av.1
  odragerad_1_A = mkA "odragerad" ; -- odragerad..av.1
  odragerbar_1_A = mkA "odragerbar" ; -- odragerbar..av.1
  odragerbarhet_1_N = mkN "odragerbarhet" ; -- odragerbarhet..nn.1
  odraggad_1_A = mkA "odraggad" ; -- odraggad..av.1
  odramatiserad_1_A = mkA "odramatiserad" ; -- odramatiserad..av.1
  odramatiserbar_1_A = mkA "odramatiserbar" ; -- odramatiserbar..av.1
  odramatiserbarhet_1_N = mkN "odramatiserbarhet" ; -- odramatiserbarhet..nn.1
  odramatisk_1_A = mkA "odramatisk" ; -- odramatisk..av.1
  odraperad_1_A = mkA "odraperad" ; -- odraperad..av.1
  odraperbar_1_A = mkA "odraperbar" ; -- odraperbar..av.1
  odraperbarhet_1_N = mkN "odraperbarhet" ; -- odraperbarhet..nn.1
  odrattad_1_A = mkA "odrattad" ; -- odrattad..av.1
  odrejad_1_A = mkA "odrejad" ; -- odrejad..av.1
  odresserad_1_A = mkA "odresserad" ; -- odresserad..av.1
  odresserbar_1_A = mkA "odresserbar" ; -- odresserbar..av.1
  odresserbarhet_1_N = mkN "odresserbarhet" ; -- odresserbarhet..nn.1
  odrevad_1_A = mkA "odrevad" ; -- odrevad..av.1
  odribblad_1_A = mkA "odribblad" ; -- odribblad..av.1
  odrickbar_1_A = mkA "odrickbar" ; -- odrickbar..av.1
  odrickbarhet_1_N = mkN "odrickbarhet" "odrickbarheter" ; -- odrickbarhet..nn.1
  odrillad_1_A = mkA "odrillad" ; -- odrillad..av.1
  odriven_1_A = mkA "odriven" ; -- odriven..av.1
  odrogad_1_A = mkA "odrogad" ; -- odrogad..av.1
  odroppad_1_A = mkA "odroppad" ; -- odroppad..av.1
  odrunknad_1_A = mkA "odrunknad" ; -- odrunknad..av.1
  odryftad_1_A = mkA "odryftad" ; -- odryftad..av.1
  odryg_1_A = mkA "odryg" ; -- odryg..av.1
  odryghet_1_N = mkN "odryghet" ; -- odryghet..nn.1
  odräglig_1_A = mkA "odräglig" ; -- odräglig..av.1
  odräglighet_1_N = mkN "odräglighet" ; -- odräglighet..nn.1
  odrämd_1_A = mkA "odrämd" "odrämt" ; -- odrämd..av.1
  odränerad_1_A = mkA "odränerad" ; -- odränerad..av.1
  odränerbar_1_A = mkA "odränerbar" ; -- odränerbar..av.1
  odränerbarhet_1_N = mkN "odränerbarhet" ; -- odränerbarhet..nn.1
  odränkt_1_A = mkA "odränkt" "odränkt" ; -- odränkt..av.1
  odräpt_1_A = mkA "odräpt" "odräpt" ; -- odräpt..av.1
  odrömd_1_A = mkA "odrömd" "odrömt" ; -- odrömd..av.1
  oduad_1_A = mkA "oduad" ; -- oduad..av.1
  odubbad_1_A = mkA "odubbad" ; -- odubbad..av.1
  odubblad_1_A = mkA "odubblad" ; -- odubblad..av.1
  odubblerad_1_A = mkA "odubblerad" ; -- odubblerad..av.1
  odubblerbar_1_A = mkA "odubblerbar" ; -- odubblerbar..av.1
  odubblerbarhet_1_N = mkN "odubblerbarhet" ; -- odubblerbarhet..nn.1
  oduglig_1_A = mkA "oduglig" ; -- oduglig..av.1
  oduglighet_1_N = mkN "oduglighet" ; -- oduglighet..nn.1
  odugling_1_N = mkN "odugling" ; -- odugling..nn.1
  odukad_1_A = mkA "odukad" ; -- odukad..av.1
  odumpad_1_A = mkA "odumpad" ; -- odumpad..av.1
  odunkad_1_A = mkA "odunkad" ; -- odunkad..av.1
  odunstad_1_A = mkA "odunstad" ; -- odunstad..av.1
  oduperad_1_A = mkA "oduperad" ; -- oduperad..av.1
  oduperbar_1_A = mkA "oduperbar" ; -- oduperbar..av.1
  oduperbarhet_1_N = mkN "oduperbarhet" ; -- oduperbarhet..nn.1
  oduplicerad_1_A = mkA "oduplicerad" ; -- oduplicerad..av.1
  oduplicerbar_1_A = mkA "oduplicerbar" ; -- oduplicerbar..av.1
  oduplicerbarhet_1_N = mkN "oduplicerbarhet" ; -- oduplicerbarhet..nn.1
  oduschad_1_A = mkA "oduschad" ; -- oduschad..av.1
  odygd_1_N = mkN "odygd" ; -- odygd..nn.1
  odygdig_1_A = mkA "odygdig" ; -- odygdig..av.1
  odygdighet_1_N = mkN "odygdighet" ; -- odygdighet..nn.1
  odygdspåse_1_N = mkN "odygdspåse" utrum  ; -- odygdspåse..nn.1
  odyrkad_1_A = mkA "odyrkad" ; -- odyrkad..av.1
  odyssé_1_N = mkN "odyssé" "odysséer" ; -- odyssé..nn.1
  odäckad_1_A = mkA "odäckad" ; -- odäckad..av.1
  odäggad_1_A = mkA "odäggad" ; -- odäggad..av.1
  odämd_1_A = mkA "odämd" "odämt" ; -- odämd..av.1
  odämpad_1_A = mkA "odämpad" ; -- odämpad..av.1
  odängd_1_A = mkA "odängd" "odängt" ; -- odängd..av.1
  odänkt_1_A = mkA "odänkt" "odänkt" ; -- odänkt..av.1
  odävnad_1_A = mkA "odävnad" ; -- odävnad..av.1
  odåga_1_N = mkN "odåga" ; -- odåga..nn.1
  odånad_1_A = mkA "odånad" ; -- odånad..av.1
  odårad_1_A = mkA "odårad" ; -- odårad..av.1
  odödad_1_A = mkA "odödad" ; -- odödad..av.1
  odödlig_1_A = mkA "odödlig" ; -- odödlig..av.1
  odödliggöra_1_V = mkV "odödliggöra" "odödliggjorde" "odödliggjort" ; -- odödliggöra..vb.1
  odödliggörande_1_N = mkN "odödliggörande" ; -- odödliggörande..nn.1
  odödlighet_1_N = mkN "odödlighet" ; -- odödlighet..nn.1
  odömd_1_A = mkA "odömd" "odömt" ; -- odömd..av.1
  odöpt_1_A = mkA "odöpt" "odöpt" ; -- odöpt..av.1
  odör_1_N = mkN "odör" "odörer" ; -- odör..nn.1
  odörjad_1_A = mkA "odörjad" ; -- odörjad..av.1
  odört_1_N = mkN "odört" ; -- odört..nn.1
  odövad_1_A = mkA "odövad" ; -- odövad..av.1
  oederad_1_A = mkA "oederad" ; -- oederad..av.1
  oederbar_1_A = mkA "oederbar" ; -- oederbar..av.1
  oederbarhet_1_N = mkN "oederbarhet" ; -- oederbarhet..nn.1
  oeffacerad_1_A = mkA "oeffacerad" ; -- oeffacerad..av.1
  oeffacerbar_1_A = mkA "oeffacerbar" ; -- oeffacerbar..av.1
  oeffacerbarhet_1_N = mkN "oeffacerbarhet" ; -- oeffacerbarhet..nn.1
  oeffektiverad_1_A = mkA "oeffektiverad" ; -- oeffektiverad..av.1
  oeffektiverbar_1_A = mkA "oeffektiverbar" ; -- oeffektiverbar..av.1
  oeffektiverbarhet_1_N = mkN "oeffektiverbarhet" ; -- oeffektiverbarhet..nn.1
  oeffektiviserad_1_A = mkA "oeffektiviserad" ; -- oeffektiviserad..av.1
  oeffektiviserbar_1_A = mkA "oeffektiviserbar" ; -- oeffektiviserbar..av.1
  oeffektiviserbarhet_1_N = mkN "oeffektiviserbarhet" ; -- oeffektiviserbarhet..nn.1
  oeffektuerad_1_A = mkA "oeffektuerad" ; -- oeffektuerad..av.1
  oeffektuerbar_1_A = mkA "oeffektuerbar" ; -- oeffektuerbar..av.1
  oeffektuerbarhet_1_N = mkN "oeffektuerbarhet" ; -- oeffektuerbarhet..nn.1
  oefterapad_1_A = mkA "oefterapad" ; -- oefterapad..av.1
  oefterbehandlad_1_A = mkA "oefterbehandlad" ; -- oefterbehandlad..av.1
  oefterbildad_1_A = mkA "oefterbildad" ; -- oefterbildad..av.1
  oefterdaterad_1_A = mkA "oefterdaterad" ; -- oefterdaterad..av.1
  oefterdaterbar_1_A = mkA "oefterdaterbar" ; -- oefterdaterbar..av.1
  oefterdaterbarhet_1_N = mkN "oefterdaterbarhet" ; -- oefterdaterbarhet..nn.1
  oefterdebiterad_1_A = mkA "oefterdebiterad" ; -- oefterdebiterad..av.1
  oefterdebiterbar_1_A = mkA "oefterdebiterbar" ; -- oefterdebiterbar..av.1
  oefterdebiterbarhet_1_N = mkN "oefterdebiterbarhet" ; -- oefterdebiterbarhet..nn.1
  oefterforskad_1_A = mkA "oefterforskad" ; -- oefterforskad..av.1
  oefterfrågad_1_A = mkA "oefterfrågad" ; -- oefterfrågad..av.1
  oefterföljd_1_A = mkA "oefterföljd" "oefterföljt" ; -- oefterföljd..av.1
  oeftergivlig_1_A = mkA "oeftergivlig" ; -- oeftergivlig..av.1
  oeftergivlighet_1_N = mkN "oeftergivlighet" ; -- oeftergivlighet..nn.1
  oefterhärmad_1_A = mkA "oefterhärmad" ; -- oefterhärmad..av.1
  oefterhärmlig_1_A = mkA "oefterhärmlig" ; -- oefterhärmlig..av.1
  oefterhärmlighet_1_N = mkN "oefterhärmlighet" ; -- oefterhärmlighet..nn.1
  oefterhörd_1_A = mkA "oefterhörd" "oefterhört" ; -- oefterhörd..av.1
  oefterliknad_1_A = mkA "oefterliknad" ; -- oefterliknad..av.1
  oefterliknelig_1_A = mkA "oefterliknelig" ; -- oefterliknelig..av.1
  oefterlyst_1_A = mkA "oefterlyst" "oefterlyst" ; -- oefterlyst..av.1
  oefterlämnad_1_A = mkA "oefterlämnad" ; -- oefterlämnad..av.1
  oeftermognad_1_A = mkA "oeftermognad" ; -- oeftermognad..av.1
  oefterrationaliserad_1_A = mkA "oefterrationaliserad" ; -- oefterrationaliserad..av.1
  oefterrationaliserbar_1_A = mkA "oefterrationaliserbar" ; -- oefterrationaliserbar..av.1
  oefterrationaliserbarhet_1_N = mkN "oefterrationaliserbarhet" ; -- oefterrationaliserbarhet..nn.1
  oefterrättlig_1_A = mkA "oefterrättlig" ; -- oefterrättlig..av.1
  oefterrättlighet_1_N = mkN "oefterrättlighet" ; -- oefterrättlighet..nn.1
  oefterskänkt_1_A = mkA "oefterskänkt" "oefterskänkt" ; -- oefterskänkt..av.1
  oefterstavad_1_A = mkA "oefterstavad" ; -- oefterstavad..av.1
  oeftersträvad_1_A = mkA "oeftersträvad" ; -- oeftersträvad..av.1
  oeftersynkroniserad_1_A = mkA "oeftersynkroniserad" ; -- oeftersynkroniserad..av.1
  oeftersynkroniserbar_1_A = mkA "oeftersynkroniserbar" ; -- oeftersynkroniserbar..av.1
  oeftersynkroniserbarhet_1_N = mkN "oeftersynkroniserbarhet" ; -- oeftersynkroniserbarhet..nn.1
  oeftersänd_1_A = mkA "oeftersänd" ; -- oeftersänd..av.1
  oeftersökt_1_A = mkA "oeftersökt" "oeftersökt" ; -- oeftersökt..av.1
  oeftertaxerad_1_A = mkA "oeftertaxerad" ; -- oeftertaxerad..av.1
  oeftertaxerbar_1_A = mkA "oeftertaxerbar" ; -- oeftertaxerbar..av.1
  oeftertaxerbarhet_1_N = mkN "oeftertaxerbarhet" ; -- oeftertaxerbarhet..nn.1
  oeftertraktad_1_A = mkA "oeftertraktad" ; -- oeftertraktad..av.1
  oeftertänksam_1_A = mkA "oeftertänksam" ; -- oeftertänksam..av.1
  oeftertänksamhet_1_N = mkN "oeftertänksamhet" ; -- oeftertänksamhet..nn.1
  oegaliserad_1_A = mkA "oegaliserad" ; -- oegaliserad..av.1
  oegaliserbar_1_A = mkA "oegaliserbar" ; -- oegaliserbar..av.1
  oegaliserbarhet_1_N = mkN "oegaliserbarhet" ; -- oegaliserbarhet..nn.1
  oegennytta_1_N = mkN "oegennytta" ; -- oegennytta..nn.1
  oegennyttig_1_A = mkA "oegennyttig" ; -- oegennyttig..av.1
  oegennyttighet_1_N = mkN "oegennyttighet" ; -- oegennyttighet..nn.1
  oegentlig_1_A = mkA "oegentlig" ; -- oegentlig..av.1
  oegentlighet_1_N = mkN "oegentlighet" "oegentligheter" ; -- oegentlighet..nn.1
  oegentlighet_2_N = mkN "oegentlighet" ; -- oegentlighet..nn.2
  oeggad_1_A = mkA "oeggad" ; -- oeggad..av.1
  oekad_1_A = mkA "oekad" ; -- oekad..av.1
  oekiperad_1_A = mkA "oekiperad" ; -- oekiperad..av.1
  oekiperbar_1_A = mkA "oekiperbar" ; -- oekiperbar..av.1
  oekiperbarhet_1_N = mkN "oekiperbarhet" ; -- oekiperbarhet..nn.1
  oeklaterad_1_A = mkA "oeklaterad" ; -- oeklaterad..av.1
  oeklaterbar_1_A = mkA "oeklaterbar" ; -- oeklaterbar..av.1
  oeklaterbarhet_1_N = mkN "oeklaterbarhet" ; -- oeklaterbarhet..nn.1
  oeklärerad_1_A = mkA "oeklärerad" ; -- oeklärerad..av.1
  oeklärerbar_1_A = mkA "oeklärerbar" ; -- oeklärerbar..av.1
  oeklärerbarhet_1_N = mkN "oeklärerbarhet" ; -- oeklärerbarhet..nn.1
  oekonomiserad_1_A = mkA "oekonomiserad" ; -- oekonomiserad..av.1
  oekonomiserbar_1_A = mkA "oekonomiserbar" ; -- oekonomiserbar..av.1
  oekonomiserbarhet_1_N = mkN "oekonomiserbarhet" ; -- oekonomiserbarhet..nn.1
  oekonomisk_1_A = mkA "oekonomisk" ; -- oekonomisk..av.1
  oelaborerad_1_A = mkA "oelaborerad" ; -- oelaborerad..av.1
  oelaborerbar_1_A = mkA "oelaborerbar" ; -- oelaborerbar..av.1
  oelaborerbarhet_1_N = mkN "oelaborerbarhet" ; -- oelaborerbarhet..nn.1
  oelastiserad_1_A = mkA "oelastiserad" ; -- oelastiserad..av.1
  oelastiserbar_1_A = mkA "oelastiserbar" ; -- oelastiserbar..av.1
  oelastiserbarhet_1_N = mkN "oelastiserbarhet" ; -- oelastiserbarhet..nn.1
  oeldad_1_A = mkA "oeldad" ; -- oeldad..av.1
  oelektrificerad_1_A = mkA "oelektrificerad" ; -- oelektrificerad..av.1
  oelektrificerbar_1_A = mkA "oelektrificerbar" ; -- oelektrificerbar..av.1
  oelektrificerbarhet_1_N = mkN "oelektrificerbarhet" ; -- oelektrificerbarhet..nn.1
  oelektrifierad_1_A = mkA "oelektrifierad" ; -- oelektrifierad..av.1
  oelektrifierbar_1_A = mkA "oelektrifierbar" ; -- oelektrifierbar..av.1
  oelektrifierbarhet_1_N = mkN "oelektrifierbarhet" ; -- oelektrifierbarhet..nn.1
  oelektriserad_1_A = mkA "oelektriserad" ; -- oelektriserad..av.1
  oelektriserbar_1_A = mkA "oelektriserbar" ; -- oelektriserbar..av.1
  oelektriserbarhet_1_N = mkN "oelektriserbarhet" ; -- oelektriserbarhet..nn.1
  oeliderad_1_A = mkA "oeliderad" ; -- oeliderad..av.1
  oeliderbar_1_A = mkA "oeliderbar" ; -- oeliderbar..av.1
  oeliderbarhet_1_N = mkN "oeliderbarhet" ; -- oeliderbarhet..nn.1
  oeliminerad_1_A = mkA "oeliminerad" ; -- oeliminerad..av.1
  oeliminerbar_1_A = mkA "oeliminerbar" ; -- oeliminerbar..av.1
  oeliminerbarhet_1_N = mkN "oeliminerbarhet" ; -- oeliminerbarhet..nn.1
  oeloxerad_1_A = mkA "oeloxerad" ; -- oeloxerad..av.1
  oeloxerbar_1_A = mkA "oeloxerbar" ; -- oeloxerbar..av.1
  oeloxerbarhet_1_N = mkN "oeloxerbarhet" ; -- oeloxerbarhet..nn.1
  oeluderad_1_A = mkA "oeluderad" ; -- oeluderad..av.1
  oeluderbar_1_A = mkA "oeluderbar" ; -- oeluderbar..av.1
  oeluderbarhet_1_N = mkN "oeluderbarhet" ; -- oeluderbarhet..nn.1
  oeluerad_1_A = mkA "oeluerad" ; -- oeluerad..av.1
  oeluerbar_1_A = mkA "oeluerbar" ; -- oeluerbar..av.1
  oeluerbarhet_1_N = mkN "oeluerbarhet" ; -- oeluerbarhet..nn.1
  oemaljerad_1_A = mkA "oemaljerad" ; -- oemaljerad..av.1
  oemaljerbar_1_A = mkA "oemaljerbar" ; -- oemaljerbar..av.1
  oemaljerbarhet_1_N = mkN "oemaljerbarhet" ; -- oemaljerbarhet..nn.1
  oemanciperad_1_A = mkA "oemanciperad" ; -- oemanciperad..av.1
  oemanciperbar_1_A = mkA "oemanciperbar" ; -- oemanciperbar..av.1
  oemanciperbarhet_1_N = mkN "oemanciperbarhet" ; -- oemanciperbarhet..nn.1
  oemballerad_1_A = mkA "oemballerad" ; -- oemballerad..av.1
  oemballerbar_1_A = mkA "oemballerbar" ; -- oemballerbar..av.1
  oemballerbarhet_1_N = mkN "oemballerbarhet" ; -- oemballerbarhet..nn.1
  oembarkerad_1_A = mkA "oembarkerad" ; -- oembarkerad..av.1
  oembarkerbar_1_A = mkA "oembarkerbar" ; -- oembarkerbar..av.1
  oembarkerbarhet_1_N = mkN "oembarkerbarhet" ; -- oembarkerbarhet..nn.1
  oembellerad_1_A = mkA "oembellerad" ; -- oembellerad..av.1
  oembellerbar_1_A = mkA "oembellerbar" ; -- oembellerbar..av.1
  oembellerbarhet_1_N = mkN "oembellerbarhet" ; -- oembellerbarhet..nn.1
  oemenderad_1_A = mkA "oemenderad" ; -- oemenderad..av.1
  oemenderbar_1_A = mkA "oemenderbar" ; -- oemenderbar..av.1
  oemenderbarhet_1_N = mkN "oemenderbarhet" ; -- oemenderbarhet..nn.1
  oemigrerad_1_A = mkA "oemigrerad" ; -- oemigrerad..av.1
  oemigrerbar_1_A = mkA "oemigrerbar" ; -- oemigrerbar..av.1
  oemigrerbarhet_1_N = mkN "oemigrerbarhet" ; -- oemigrerbarhet..nn.1
  oemitterad_1_A = mkA "oemitterad" ; -- oemitterad..av.1
  oemitterbar_1_A = mkA "oemitterbar" ; -- oemitterbar..av.1
  oemitterbarhet_1_N = mkN "oemitterbarhet" ; -- oemitterbarhet..nn.1
  oemotsagd_1_A = mkA "oemotsagd" "oemotsagt" ; -- oemotsagd..av.1
  oemotståndlig_1_A = mkA "oemotståndlig" ; -- oemotståndlig..av.1
  oemotståndlighet_1_N = mkN "oemotståndlighet" ; -- oemotståndlighet..nn.1
  oemotsäglig_1_A = mkA "oemotsäglig" ; -- oemotsäglig..av.1
  oemotsäglighet_1_N = mkN "oemotsäglighet" ; -- oemotsäglighet..nn.1
  oemottaglig_1_A = mkA "oemottaglig" ; -- oemottaglig..av.1
  oemottaglighet_1_N = mkN "oemottaglighet" ; -- oemottaglighet..nn.1
  oemulgerad_1_A = mkA "oemulgerad" ; -- oemulgerad..av.1
  oemulgerbar_1_A = mkA "oemulgerbar" ; -- oemulgerbar..av.1
  oemulgerbarhet_1_N = mkN "oemulgerbarhet" ; -- oemulgerbarhet..nn.1
  oenad_1_A = mkA "oenad" ; -- oenad..av.1
  oendosserad_1_A = mkA "oendosserad" ; -- oendosserad..av.1
  oendosserbar_1_A = mkA "oendosserbar" ; -- oendosserbar..av.1
  oendosserbarhet_1_N = mkN "oendosserbarhet" ; -- oendosserbarhet..nn.1
  oenerverad_1_A = mkA "oenerverad" ; -- oenerverad..av.1
  oenerverbar_1_A = mkA "oenerverbar" ; -- oenerverbar..av.1
  oenerverbarhet_1_N = mkN "oenerverbarhet" ; -- oenerverbarhet..nn.1
  oengagerad_1_A = mkA "oengagerad" ; -- oengagerad..av.1
  oengagerbar_1_A = mkA "oengagerbar" ; -- oengagerbar..av.1
  oengagerbarhet_1_N = mkN "oengagerbarhet" ; -- oengagerbarhet..nn.1
  oenig_1_A = mkA "oenig" ; -- oenig..av.1
  oenighet_1_N = mkN "oenighet" "oenigheter" ; -- oenighet..nn.1
  oenklad_1_A = mkA "oenklad" ; -- oenklad..av.1
  oenleverad_1_A = mkA "oenleverad" ; -- oenleverad..av.1
  oenleverbar_1_A = mkA "oenleverbar" ; -- oenleverbar..av.1
  oenleverbarhet_1_N = mkN "oenleverbarhet" ; -- oenleverbarhet..nn.1
  oenolog_1_N = mkN "oenolog" "oenologer" ; -- oenolog..nn.1
  oenologi_1_N = mkN "oenologi" ; -- oenologi..nn.1
  oenrollerad_1_A = mkA "oenrollerad" ; -- oenrollerad..av.1
  oenrollerbar_1_A = mkA "oenrollerbar" ; -- oenrollerbar..av.1
  oenrollerbarhet_1_N = mkN "oenrollerbarhet" ; -- oenrollerbarhet..nn.1
  oensad_1_A = mkA "oensad" ; -- oensad..av.1
  oense_1_A = mkA "oense" ; -- oense..av.1
  oensilerad_1_A = mkA "oensilerad" ; -- oensilerad..av.1
  oensilerbar_1_A = mkA "oensilerbar" ; -- oensilerbar..av.1
  oensilerbarhet_1_N = mkN "oensilerbarhet" ; -- oensilerbarhet..nn.1
  oentledigad_1_A = mkA "oentledigad" ; -- oentledigad..av.1
  oentusiasmerad_1_A = mkA "oentusiasmerad" ; -- oentusiasmerad..av.1
  oentusiasmerbar_1_A = mkA "oentusiasmerbar" ; -- oentusiasmerbar..av.1
  oentusiasmerbarhet_1_N = mkN "oentusiasmerbarhet" ; -- oentusiasmerbarhet..nn.1
  oepilerad_1_A = mkA "oepilerad" ; -- oepilerad..av.1
  oepilerbar_1_A = mkA "oepilerbar" ; -- oepilerbar..av.1
  oepilerbarhet_1_N = mkN "oepilerbarhet" ; -- oepilerbarhet..nn.1
  oerfaren_1_A = mkA "oerfaren" ; -- oerfaren..av.1
  oerfarenhet_1_N = mkN "oerfarenhet" ; -- oerfarenhet..nn.1
  oerfordrad_1_A = mkA "oerfordrad" ; -- oerfordrad..av.1
  oerhörd_1_A = mkA "oerhörd" "oerhört" ; -- oerhörd..av.1
  oerhördhet_1_N = mkN "oerhördhet" ; -- oerhördhet..nn.1
  oerigerad_1_A = mkA "oerigerad" ; -- oerigerad..av.1
  oerigerbar_1_A = mkA "oerigerbar" ; -- oerigerbar..av.1
  oerigerbarhet_1_N = mkN "oerigerbarhet" ; -- oerigerbarhet..nn.1
  oerkänd_1_A = mkA "oerkänd" ; -- oerkänd..av.1
  oeroderad_1_A = mkA "oeroderad" ; -- oeroderad..av.1
  oeroderbar_1_A = mkA "oeroderbar" ; -- oeroderbar..av.1
  oeroderbarhet_1_N = mkN "oeroderbarhet" ; -- oeroderbarhet..nn.1
  oersättlig_1_A = mkA "oersättlig" ; -- oersättlig..av.1
  oersättlighet_1_N = mkN "oersättlighet" ; -- oersättlighet..nn.1
  oertappad_1_A = mkA "oertappad" ; -- oertappad..av.1
  oerövrad_1_A = mkA "oerövrad" ; -- oerövrad..av.1
  oeskalerad_1_A = mkA "oeskalerad" ; -- oeskalerad..av.1
  oeskalerbar_1_A = mkA "oeskalerbar" ; -- oeskalerbar..av.1
  oeskalerbarhet_1_N = mkN "oeskalerbarhet" ; -- oeskalerbarhet..nn.1
  oeskorterad_1_A = mkA "oeskorterad" ; -- oeskorterad..av.1
  oeskorterbar_1_A = mkA "oeskorterbar" ; -- oeskorterbar..av.1
  oeskorterbarhet_1_N = mkN "oeskorterbarhet" ; -- oeskorterbarhet..nn.1
  oesteticerad_1_A = mkA "oesteticerad" ; -- oesteticerad..av.1
  oesteticerbar_1_A = mkA "oesteticerbar" ; -- oesteticerbar..av.1
  oesteticerbarhet_1_N = mkN "oesteticerbarhet" ; -- oesteticerbarhet..nn.1
  oestetiserad_1_A = mkA "oestetiserad" ; -- oestetiserad..av.1
  oestetiserbar_1_A = mkA "oestetiserbar" ; -- oestetiserbar..av.1
  oestetiserbarhet_1_N = mkN "oestetiserbarhet" ; -- oestetiserbarhet..nn.1
  oestetisk_1_A = mkA "oestetisk" ; -- oestetisk..av.1
  oestimerad_1_A = mkA "oestimerad" ; -- oestimerad..av.1
  oestimerbar_1_A = mkA "oestimerbar" ; -- oestimerbar..av.1
  oestimerbarhet_1_N = mkN "oestimerbarhet" ; -- oestimerbarhet..nn.1
  oetablerad_1_A = mkA "oetablerad" ; -- oetablerad..av.1
  oetablerbar_1_A = mkA "oetablerbar" ; -- oetablerbar..av.1
  oetablerbarhet_1_N = mkN "oetablerbarhet" ; -- oetablerbarhet..nn.1
  oeteriserad_1_A = mkA "oeteriserad" ; -- oeteriserad..av.1
  oeteriserbar_1_A = mkA "oeteriserbar" ; -- oeteriserbar..av.1
  oeteriserbarhet_1_N = mkN "oeteriserbarhet" ; -- oeteriserbarhet..nn.1
  oetiketterad_1_A = mkA "oetiketterad" ; -- oetiketterad..av.1
  oetiketterbar_1_A = mkA "oetiketterbar" ; -- oetiketterbar..av.1
  oetiketterbarhet_1_N = mkN "oetiketterbarhet" ; -- oetiketterbarhet..nn.1
  oetisk_1_A = mkA "oetisk" ; -- oetisk..av.1
  oetnifierbar_1_A = mkA "oetnifierbar" ; -- oetnifierbar..av.1
  oetnifierbarhet_1_N = mkN "oetnifierbarhet" "oetnifierbarheter" ; -- oetnifierbarhet..nn.1
  oetsad_1_A = mkA "oetsad" ; -- oetsad..av.1
  oetymologiserad_1_A = mkA "oetymologiserad" ; -- oetymologiserad..av.1
  oetymologiserbar_1_A = mkA "oetymologiserbar" ; -- oetymologiserbar..av.1
  oetymologiserbarhet_1_N = mkN "oetymologiserbarhet" ; -- oetymologiserbarhet..nn.1
  oeuropeiserad_1_A = mkA "oeuropeiserad" ; -- oeuropeiserad..av.1
  oeuropeiserbar_1_A = mkA "oeuropeiserbar" ; -- oeuropeiserbar..av.1
  oeuropeiserbarhet_1_N = mkN "oeuropeiserbarhet" ; -- oeuropeiserbarhet..nn.1
  oevakuerad_1_A = mkA "oevakuerad" ; -- oevakuerad..av.1
  oevakuerbar_1_A = mkA "oevakuerbar" ; -- oevakuerbar..av.1
  oevakuerbarhet_1_N = mkN "oevakuerbarhet" ; -- oevakuerbarhet..nn.1
  oevaluerad_1_A = mkA "oevaluerad" ; -- oevaluerad..av.1
  oevaluerbar_1_A = mkA "oevaluerbar" ; -- oevaluerbar..av.1
  oevaluerbarhet_1_N = mkN "oevaluerbarhet" ; -- oevaluerbarhet..nn.1
  oevalverad_1_A = mkA "oevalverad" ; -- oevalverad..av.1
  oevalverbar_1_A = mkA "oevalverbar" ; -- oevalverbar..av.1
  oevalverbarhet_1_N = mkN "oevalverbarhet" ; -- oevalverbarhet..nn.1
  oevaporerad_1_A = mkA "oevaporerad" ; -- oevaporerad..av.1
  oevaporerbar_1_A = mkA "oevaporerbar" ; -- oevaporerbar..av.1
  oevaporerbarhet_1_N = mkN "oevaporerbarhet" ; -- oevaporerbarhet..nn.1
  oexaminerad_1_A = mkA "oexaminerad" ; -- oexaminerad..av.1
  oexaminerbar_1_A = mkA "oexaminerbar" ; -- oexaminerbar..av.1
  oexaminerbarhet_1_N = mkN "oexaminerbarhet" ; -- oexaminerbarhet..nn.1
  oexcerperad_1_A = mkA "oexcerperad" ; -- oexcerperad..av.1
  oexcerperbar_1_A = mkA "oexcerperbar" ; -- oexcerperbar..av.1
  oexcerperbarhet_1_N = mkN "oexcerperbarhet" ; -- oexcerperbarhet..nn.1
  oexciterad_1_A = mkA "oexciterad" ; -- oexciterad..av.1
  oexciterbar_1_A = mkA "oexciterbar" ; -- oexciterbar..av.1
  oexciterbarhet_1_N = mkN "oexciterbarhet" ; -- oexciterbarhet..nn.1
  oexekverad_1_A = mkA "oexekverad" ; -- oexekverad..av.1
  oexekverbar_1_A = mkA "oexekverbar" ; -- oexekverbar..av.1
  oexekverbarhet_1_N = mkN "oexekverbarhet" ; -- oexekverbarhet..nn.1
  oexemplifierad_1_A = mkA "oexemplifierad" ; -- oexemplifierad..av.1
  oexemplifierbar_1_A = mkA "oexemplifierbar" ; -- oexemplifierbar..av.1
  oexemplifierbarhet_1_N = mkN "oexemplifierbarhet" ; -- oexemplifierbarhet..nn.1
  oexercerad_1_A = mkA "oexercerad" ; -- oexercerad..av.1
  oexercerbar_1_A = mkA "oexercerbar" ; -- oexercerbar..av.1
  oexercerbarhet_1_N = mkN "oexercerbarhet" ; -- oexercerbarhet..nn.1
  oexkluderad_1_A = mkA "oexkluderad" ; -- oexkluderad..av.1
  oexkluderbar_1_A = mkA "oexkluderbar" ; -- oexkluderbar..av.1
  oexkluderbarhet_1_N = mkN "oexkluderbarhet" ; -- oexkluderbarhet..nn.1
  oexkommunicerad_1_A = mkA "oexkommunicerad" ; -- oexkommunicerad..av.1
  oexkommunicerbar_1_A = mkA "oexkommunicerbar" ; -- oexkommunicerbar..av.1
  oexkommunicerbarhet_1_N = mkN "oexkommunicerbarhet" ; -- oexkommunicerbarhet..nn.1
  oexpanderad_1_A = mkA "oexpanderad" ; -- oexpanderad..av.1
  oexpanderbar_1_A = mkA "oexpanderbar" ; -- oexpanderbar..av.1
  oexpanderbarhet_1_N = mkN "oexpanderbarhet" ; -- oexpanderbarhet..nn.1
  oexpatrierad_1_A = mkA "oexpatrierad" ; -- oexpatrierad..av.1
  oexpatrierbar_1_A = mkA "oexpatrierbar" ; -- oexpatrierbar..av.1
  oexpatrierbarhet_1_N = mkN "oexpatrierbarhet" ; -- oexpatrierbarhet..nn.1
  oexpedierad_1_A = mkA "oexpedierad" ; -- oexpedierad..av.1
  oexpedierbar_1_A = mkA "oexpedierbar" ; -- oexpedierbar..av.1
  oexpedierbarhet_1_N = mkN "oexpedierbarhet" ; -- oexpedierbarhet..nn.1
  oexpektorerad_1_A = mkA "oexpektorerad" ; -- oexpektorerad..av.1
  oexpektorerbar_1_A = mkA "oexpektorerbar" ; -- oexpektorerbar..av.1
  oexpektorerbarhet_1_N = mkN "oexpektorerbarhet" ; -- oexpektorerbarhet..nn.1
  oexplicerad_1_A = mkA "oexplicerad" ; -- oexplicerad..av.1
  oexplicerbar_1_A = mkA "oexplicerbar" ; -- oexplicerbar..av.1
  oexplicerbarhet_1_N = mkN "oexplicerbarhet" ; -- oexplicerbarhet..nn.1
  oexploaterad_1_A = mkA "oexploaterad" ; -- oexploaterad..av.1
  oexploaterbar_1_A = mkA "oexploaterbar" ; -- oexploaterbar..av.1
  oexploaterbarhet_1_N = mkN "oexploaterbarhet" ; -- oexploaterbarhet..nn.1
  oexploderad_1_A = mkA "oexploderad" ; -- oexploderad..av.1
  oexploderbar_1_A = mkA "oexploderbar" ; -- oexploderbar..av.1
  oexploderbarhet_1_N = mkN "oexploderbarhet" ; -- oexploderbarhet..nn.1
  oexponerad_1_A = mkA "oexponerad" ; -- oexponerad..av.1
  oexponerbar_1_A = mkA "oexponerbar" ; -- oexponerbar..av.1
  oexponerbarhet_1_N = mkN "oexponerbarhet" ; -- oexponerbarhet..nn.1
  oexporterad_1_A = mkA "oexporterad" ; -- oexporterad..av.1
  oexporterbar_1_A = mkA "oexporterbar" ; -- oexporterbar..av.1
  oexporterbarhet_1_N = mkN "oexporterbarhet" ; -- oexporterbarhet..nn.1
  oexproprierad_1_A = mkA "oexproprierad" ; -- oexproprierad..av.1
  oexproprierbar_1_A = mkA "oexproprierbar" ; -- oexproprierbar..av.1
  oexproprierbarhet_1_N = mkN "oexproprierbarhet" ; -- oexproprierbarhet..nn.1
  oexstirperad_1_A = mkA "oexstirperad" ; -- oexstirperad..av.1
  oexstirperbar_1_A = mkA "oexstirperbar" ; -- oexstirperbar..av.1
  oexstirperbarhet_1_N = mkN "oexstirperbarhet" ; -- oexstirperbarhet..nn.1
  oextemporerad_1_A = mkA "oextemporerad" ; -- oextemporerad..av.1
  oextemporerbar_1_A = mkA "oextemporerbar" ; -- oextemporerbar..av.1
  oextemporerbarhet_1_N = mkN "oextemporerbarhet" ; -- oextemporerbarhet..nn.1
  oextraherad_1_A = mkA "oextraherad" ; -- oextraherad..av.1
  oextraherbar_1_A = mkA "oextraherbar" ; -- oextraherbar..av.1
  oextraherbarhet_1_N = mkN "oextraherbarhet" ; -- oextraherbarhet..nn.1
  oextrapolerad_1_A = mkA "oextrapolerad" ; -- oextrapolerad..av.1
  oextrapolerbar_1_A = mkA "oextrapolerbar" ; -- oextrapolerbar..av.1
  oextrapolerbarhet_1_N = mkN "oextrapolerbarhet" ; -- oextrapolerbarhet..nn.1
  ofabricerad_1_A = mkA "ofabricerad" ; -- ofabricerad..av.1
  ofabricerbar_1_A = mkA "ofabricerbar" ; -- ofabricerbar..av.1
  ofabricerbarhet_1_N = mkN "ofabricerbarhet" ; -- ofabricerbarhet..nn.1
  ofabulerad_1_A = mkA "ofabulerad" ; -- ofabulerad..av.1
  ofabulerbar_1_A = mkA "ofabulerbar" ; -- ofabulerbar..av.1
  ofabulerbarhet_1_N = mkN "ofabulerbarhet" ; -- ofabulerbarhet..nn.1
  ofacetterad_1_A = mkA "ofacetterad" ; -- ofacetterad..av.1
  ofacetterbar_1_A = mkA "ofacetterbar" ; -- ofacetterbar..av.1
  ofacetterbarhet_1_N = mkN "ofacetterbarhet" ; -- ofacetterbarhet..nn.1
  ofakturerad_1_A = mkA "ofakturerad" ; -- ofakturerad..av.1
  ofakturerbar_1_A = mkA "ofakturerbar" ; -- ofakturerbar..av.1
  ofakturerbarhet_1_N = mkN "ofakturerbarhet" ; -- ofakturerbarhet..nn.1
  ofalnad_1_A = mkA "ofalnad" ; -- ofalnad..av.1
  ofalsad_1_A = mkA "ofalsad" ; -- ofalsad..av.1
  ofalsifierad_1_A = mkA "ofalsifierad" ; -- ofalsifierad..av.1
  ofalsifierbar_1_A = mkA "ofalsifierbar" ; -- ofalsifierbar..av.1
  ofalsifierbarhet_1_N = mkN "ofalsifierbarhet" ; -- ofalsifierbarhet..nn.1
  ofamnad_1_A = mkA "ofamnad" ; -- ofamnad..av.1
  ofantiserad_1_A = mkA "ofantiserad" ; -- ofantiserad..av.1
  ofantiserbar_1_A = mkA "ofantiserbar" ; -- ofantiserbar..av.1
  ofantiserbarhet_1_N = mkN "ofantiserbarhet" ; -- ofantiserbarhet..nn.1
  ofantlig_1_A = mkA "ofantlig" ; -- ofantlig..av.1
  ofantlighet_1_N = mkN "ofantlighet" ; -- ofantlighet..nn.1
  ofarbar_1_A = mkA "ofarbar" ; -- ofarbar..av.1
  ofarbarhet_1_N = mkN "ofarbarhet" ; -- ofarbarhet..nn.1
  ofarlig_1_A = mkA "ofarlig" ; -- ofarlig..av.1
  ofarliggjord_1_A = mkA "ofarliggjord" "ofarliggjort" ; -- ofarliggjord..av.1
  ofarlighet_1_N = mkN "ofarlighet" "ofarligheter" ; -- ofarlighet..nn.1
  ofasad_1_A = mkA "ofasad" ; -- ofasad..av.1
  ofascinerad_1_A = mkA "ofascinerad" ; -- ofascinerad..av.1
  ofascinerbar_1_A = mkA "ofascinerbar" ; -- ofascinerbar..av.1
  ofascinerbarhet_1_N = mkN "ofascinerbarhet" ; -- ofascinerbarhet..nn.1
  ofasetterad_1_A = mkA "ofasetterad" ; -- ofasetterad..av.1
  ofasetterbar_1_A = mkA "ofasetterbar" ; -- ofasetterbar..av.1
  ofasetterbarhet_1_N = mkN "ofasetterbarhet" ; -- ofasetterbarhet..nn.1
  ofasonerad_1_A = mkA "ofasonerad" ; -- ofasonerad..av.1
  ofasonerbar_1_A = mkA "ofasonerbar" ; -- ofasonerbar..av.1
  ofasonerbarhet_1_N = mkN "ofasonerbarhet" ; -- ofasonerbarhet..nn.1
  ofattbar_1_A = mkA "ofattbar" ; -- ofattbar..av.1
  ofattbarhet_1_N = mkN "ofattbarhet" ; -- ofattbarhet..nn.1
  ofattlig_1_A = mkA "ofattlig" ; -- ofattlig..av.1
  ofattlighet_1_N = mkN "ofattlighet" ; -- ofattlighet..nn.1
  ofavoriserad_1_A = mkA "ofavoriserad" ; -- ofavoriserad..av.1
  ofavoriserbar_1_A = mkA "ofavoriserbar" ; -- ofavoriserbar..av.1
  ofavoriserbarhet_1_N = mkN "ofavoriserbarhet" ; -- ofavoriserbarhet..nn.1
  ofaxad_1_A = mkA "ofaxad" ; -- ofaxad..av.1
  ofejad_1_A = mkA "ofejad" ; -- ofejad..av.1
  ofejkad_1_A = mkA "ofejkad" ; -- ofejkad..av.1
  ofelbar_1_A = mkA "ofelbar" ; -- ofelbar..av.1
  ofelbarhet_1_N = mkN "ofelbarhet" ; -- ofelbarhet..nn.1
  ofermenterad_1_A = mkA "ofermenterad" ; -- ofermenterad..av.1
  ofermenterbar_1_A = mkA "ofermenterbar" ; -- ofermenterbar..av.1
  ofermenterbarhet_1_N = mkN "ofermenterbarhet" ; -- ofermenterbarhet..nn.1
  ofernissad_1_A = mkA "ofernissad" ; -- ofernissad..av.1
  ofeterad_1_A = mkA "ofeterad" ; -- ofeterad..av.1
  ofeterbar_1_A = mkA "ofeterbar" ; -- ofeterbar..av.1
  ofeterbarhet_1_N = mkN "ofeterbarhet" ; -- ofeterbarhet..nn.1
  off_white_1_A = mkA "off-white" ; -- off-white..av.1
  offensiv_1_A = mkA "offensiv" ; -- offensiv..av.1
  offensiv_1_N = mkN "offensiv" "offensiver" ; -- offensiv..nn.1
  offentlig_1_A = mkA "offentlig" ; -- offentlig..av.1
  offentligen_1_Adv = mkAdv "offentligen" ; -- offentligen..ab.1
  offentliggöra_1_V = mkV "offentliggöra" "offentliggjorde" "offentliggjort" ; -- offentliggöra..vb.1
  offentliggörande_1_N = mkN "offentliggörande" ; -- offentliggörande..nn.1
  offentlighet_1_N = mkN "offentlighet" "offentligheter" ; -- offentlighet..nn.1
  offentlighetsprincip_1_N = mkN "offentlighetsprincip" ; -- offentlighetsprincip..nn.1
  offentligrättslig_1_A = mkA "offentligrättslig" ; -- offentligrättslig..av.1
  offentligrättslighet_1_N = mkN "offentligrättslighet" ; -- offentligrättslighet..nn.1
  offer_1_N = mkN "offer" neutrum  ; -- offer..nn.1
  offeranod_1_N = mkN "offeranod" "offeranoder" ; -- offeranod..nn.1
  offerent_1_N = mkN "offerent" "offerenter" ; -- offerent..nn.1
  offerera_1_V = mkV "offererar" ; -- offerera..vb.1
  offererande_1_N = mkN "offererande" ; -- offererande..nn.1
  offererbar_1_A = mkA "offererbar" ; -- offererbar..av.1
  offererbarhet_1_N = mkN "offererbarhet" ; -- offererbarhet..nn.1
  offerering_1_N = mkN "offerering" ; -- offerering..nn.1
  offerfest_1_N = mkN "offerfest" "offerfester" ; -- offerfest..nn.1
  offergärd_1_N = mkN "offergärd" ; -- offergärd..nn.1
  offergåva_1_N = mkN "offergåva" ; -- offergåva..nn.1
  offeridentitet_1_N = mkN "offeridentitet" "offeridentiteter" ; -- offeridentitet..nn.1
  offerjournalistik_1_N = mkN "offerjournalistik" ; -- offerjournalistik..nn.1
  offerkista_1_N = mkN "offerkista" ; -- offerkista..nn.1
  offerlamm_1_N = mkN "offerlamm" neutrum  ; -- offerlamm..nn.1
  offerrit_1_N = mkN "offerrit" "offerriter" ; -- offerrit..nn.1
  offerroll_1_N = mkN "offerroll" "offerroller" ; -- offerroll..nn.1
  offerstock_1_N = mkN "offerstock" ; -- offerstock..nn.1
  offerstämpel_1_N = mkN "offerstämpel" ; -- offerstämpel..nn.1
  offert_1_N = mkN "offert" "offerter" ; -- offert..nn.1
  offertorium_1_N = mkN "offertorium" "offertoriet" "offertorier" "offertorierna" ; -- offertorium..nn.1
  offervillig_1_A = mkA "offervillig" ; -- offervillig..av.1
  offervillighet_1_N = mkN "offervillighet" ; -- offervillighet..nn.1
  officer_1_N = mkN "officer" "officeren" "officerare" "officerarna" ; -- officer..nn.1
  officerare_1_N = mkN "officerare" utrum  ; -- officerare..nn.1
  officersaspirant_1_N = mkN "officersaspirant" "officersaspiranter" ; -- officersaspirant..nn.1
  officersförbund_1_N = mkN "officersförbund" neutrum  ; -- officersförbund..nn.1
  officerskamrat_1_N = mkN "officerskamrat" "officerskamrater" ; -- officerskamrat..nn.1
  officerskollega_1_N = mkN "officerskollega" ; -- officerskollega..nn.1
  officersmäss_1_N = mkN "officersmäss" ; -- officersmäss..nn.1
  officiant_1_N = mkN "officiant" "officianter" ; -- officiant..nn.1
  officiell_1_A = mkA "officiell" ; -- officiell..av.1
  officiera_1_V = mkV "officierar" ; -- officiera..vb.1
  officierande_1_N = mkN "officierande" ; -- officierande..nn.1
  officiering_1_N = mkN "officiering" ; -- officiering..nn.1
  officin_1_N = mkN "officin" "officiner" ; -- officin..nn.1
  officinell_1_A = mkA "officinell" ; -- officinell..av.1
  officiös_1_A = mkA "officiös" ; -- officiös..av.1
  offra_1_V = mkV "offrar" ; -- offra..vb.1
  offrande_1_N = mkN "offrande" ; -- offrande..nn.1
  offset_1_N = mkN "offset" ; -- offset..nn.1
  offshore_1_A = mkA "offshore" ; -- offshore..av.1
  ofilad_1_A = mkA "ofilad" ; -- ofilad..av.1
  ofilead_1_A = mkA "ofilead" ; -- ofilead..av.1
  ofilerad_1_A = mkA "ofilerad" ; -- ofilerad..av.1
  ofilerbar_1_A = mkA "ofilerbar" ; -- ofilerbar..av.1
  ofilerbarhet_1_N = mkN "ofilerbarhet" ; -- ofilerbarhet..nn.1
  ofilmad_1_A = mkA "ofilmad" ; -- ofilmad..av.1
  ofilmatiserad_1_A = mkA "ofilmatiserad" ; -- ofilmatiserad..av.1
  ofilmatiserbar_1_A = mkA "ofilmatiserbar" ; -- ofilmatiserbar..av.1
  ofilmatiserbarhet_1_N = mkN "ofilmatiserbarhet" ; -- ofilmatiserbarhet..nn.1
  ofiltad_1_A = mkA "ofiltad" ; -- ofiltad..av.1
  ofiltrerad_1_A = mkA "ofiltrerad" ; -- ofiltrerad..av.1
  ofiltrerbar_1_A = mkA "ofiltrerbar" ; -- ofiltrerbar..av.1
  ofiltrerbarhet_1_N = mkN "ofiltrerbarhet" ; -- ofiltrerbarhet..nn.1
  ofimpad_1_A = mkA "ofimpad" ; -- ofimpad..av.1
  ofin_1_A = mkA "ofin" ; -- ofin..av.1
  ofinansierad_1_A = mkA "ofinansierad" ; -- ofinansierad..av.1
  ofinansierbar_1_A = mkA "ofinansierbar" ; -- ofinansierbar..av.1
  ofinansierbarhet_1_N = mkN "ofinansierbarhet" ; -- ofinansierbarhet..nn.1
  ofingerad_1_A = mkA "ofingerad" ; -- ofingerad..av.1
  ofingerbar_1_A = mkA "ofingerbar" ; -- ofingerbar..av.1
  ofingerbarhet_1_N = mkN "ofingerbarhet" ; -- ofingerbarhet..nn.1
  ofinjusterbar_1_A = mkA "ofinjusterbar" ; -- ofinjusterbar..av.1
  ofinjusterbarhet_1_N = mkN "ofinjusterbarhet" ; -- ofinjusterbarhet..nn.1
  ofinkad_1_A = mkA "ofinkad" ; -- ofinkad..av.1
  ofinlandiserad_1_A = mkA "ofinlandiserad" ; -- ofinlandiserad..av.1
  ofinlandiserbar_1_A = mkA "ofinlandiserbar" ; -- ofinlandiserbar..av.1
  ofinlandiserbarhet_1_N = mkN "ofinlandiserbarhet" ; -- ofinlandiserbarhet..nn.1
  ofintad_1_A = mkA "ofintad" ; -- ofintad..av.1
  ofirad_1_A = mkA "ofirad" ; -- ofirad..av.1
  ofiskad_1_A = mkA "ofiskad" ; -- ofiskad..av.1
  ofixad_1_A = mkA "ofixad" ; -- ofixad..av.1
  ofixerad_1_A = mkA "ofixerad" ; -- ofixerad..av.1
  ofixerbar_1_A = mkA "ofixerbar" ; -- ofixerbar..av.1
  ofixerbarhet_1_N = mkN "ofixerbarhet" ; -- ofixerbarhet..nn.1
  ofjällad_1_A = mkA "ofjällad" ; -- ofjällad..av.1
  ofjärmad_1_A = mkA "ofjärmad" ; -- ofjärmad..av.1
  ofjättrad_1_A = mkA "ofjättrad" ; -- ofjättrad..av.1
  oflaggad_1_A = mkA "oflaggad" ; -- oflaggad..av.1
  oflagnad_1_A = mkA "oflagnad" ; -- oflagnad..av.1
  oflamberad_1_A = mkA "oflamberad" ; -- oflamberad..av.1
  oflamberbar_1_A = mkA "oflamberbar" ; -- oflamberbar..av.1
  oflamberbarhet_1_N = mkN "oflamberbarhet" ; -- oflamberbarhet..nn.1
  oflankerad_1_A = mkA "oflankerad" ; -- oflankerad..av.1
  oflankerbar_1_A = mkA "oflankerbar" ; -- oflankerbar..av.1
  oflankerbarhet_1_N = mkN "oflankerbarhet" ; -- oflankerbarhet..nn.1
  oflatterad_1_A = mkA "oflatterad" ; -- oflatterad..av.1
  oflatterbar_1_A = mkA "oflatterbar" ; -- oflatterbar..av.1
  oflatterbarhet_1_N = mkN "oflatterbarhet" ; -- oflatterbarhet..nn.1
  oflekterad_1_A = mkA "oflekterad" ; -- oflekterad..av.1
  oflekterbar_1_A = mkA "oflekterbar" ; -- oflekterbar..av.1
  oflekterbarhet_1_N = mkN "oflekterbarhet" ; -- oflekterbarhet..nn.1
  oflottad_1_A = mkA "oflottad" ; -- oflottad..av.1
  ofluidiserad_1_A = mkA "ofluidiserad" ; -- ofluidiserad..av.1
  ofluidiserbar_1_A = mkA "ofluidiserbar" ; -- ofluidiserbar..av.1
  ofluidiserbarhet_1_N = mkN "ofluidiserbarhet" ; -- ofluidiserbarhet..nn.1
  ofluorerad_1_A = mkA "ofluorerad" ; -- ofluorerad..av.1
  ofluorerbar_1_A = mkA "ofluorerbar" ; -- ofluorerbar..av.1
  ofluorerbarhet_1_N = mkN "ofluorerbarhet" ; -- ofluorerbarhet..nn.1
  ofluoriderad_1_A = mkA "ofluoriderad" ; -- ofluoriderad..av.1
  ofluoriderbar_1_A = mkA "ofluoriderbar" ; -- ofluoriderbar..av.1
  ofluoriderbarhet_1_N = mkN "ofluoriderbarhet" ; -- ofluoriderbarhet..nn.1
  oflyktad_1_A = mkA "oflyktad" ; -- oflyktad..av.1
  oflyt_1_N = mkN "oflyt" neutrum  ; -- oflyt..nn.1
  oflyttad_1_A = mkA "oflyttad" ; -- oflyttad..av.1
  ofläckad_1_A = mkA "ofläckad" ; -- ofläckad..av.1
  ofläkt_1_A = mkA "ofläkt" "ofläkt" ; -- ofläkt..av.1
  oflängd_1_A = mkA "oflängd" "oflängt" ; -- oflängd..av.1
  oflänsad_1_A = mkA "oflänsad" ; -- oflänsad..av.1
  oflätad_1_A = mkA "oflätad" ; -- oflätad..av.1
  oflöjlad_1_A = mkA "oflöjlad" ; -- oflöjlad..av.1
  oflöjtad_1_A = mkA "oflöjtad" ; -- oflöjtad..av.1
  ofockad_1_A = mkA "ofockad" ; -- ofockad..av.1
  ofodrad_1_A = mkA "ofodrad" ; -- ofodrad..av.1
  ofog_1_N = mkN "ofog" neutrum  ; -- ofog..nn.1
  ofogad_1_A = mkA "ofogad" ; -- ofogad..av.1
  ofokuserad_1_A = mkA "ofokuserad" ; -- ofokuserad..av.1
  ofokuserbar_1_A = mkA "ofokuserbar" ; -- ofokuserbar..av.1
  ofokuserbarhet_1_N = mkN "ofokuserbarhet" ; -- ofokuserbarhet..nn.1
  ofolierad_1_A = mkA "ofolierad" ; -- ofolierad..av.1
  ofolierbar_1_A = mkA "ofolierbar" ; -- ofolierbar..av.1
  ofolierbarhet_1_N = mkN "ofolierbarhet" ; -- ofolierbarhet..nn.1
  ofonderad_1_A = mkA "ofonderad" ; -- ofonderad..av.1
  ofonderbar_1_A = mkA "ofonderbar" ; -- ofonderbar..av.1
  ofonderbarhet_1_N = mkN "ofonderbarhet" ; -- ofonderbarhet..nn.1
  oforcerad_1_A = mkA "oforcerad" ; -- oforcerad..av.1
  oforcerbar_1_A = mkA "oforcerbar" ; -- oforcerbar..av.1
  oforcerbarhet_1_N = mkN "oforcerbarhet" ; -- oforcerbarhet..nn.1
  oforecheckad_1_A = mkA "oforecheckad" ; -- oforecheckad..av.1
  oformad_1_A = mkA "oformad" ; -- oformad..av.1
  oformaliserad_1_A = mkA "oformaliserad" ; -- oformaliserad..av.1
  oformaliserbar_1_A = mkA "oformaliserbar" ; -- oformaliserbar..av.1
  oformaliserbarhet_1_N = mkN "oformaliserbarhet" ; -- oformaliserbarhet..nn.1
  oformerad_1_A = mkA "oformerad" ; -- oformerad..av.1
  oformerbar_1_A = mkA "oformerbar" ; -- oformerbar..av.1
  oformerbarhet_1_N = mkN "oformerbarhet" ; -- oformerbarhet..nn.1
  oformlig_1_A = mkA "oformlig" ; -- oformlig..av.1
  oformlighet_1_N = mkN "oformlighet" "oformligheter" ; -- oformlighet..nn.1
  oformulerad_1_A = mkA "oformulerad" ; -- oformulerad..av.1
  oformulerbar_1_A = mkA "oformulerbar" ; -- oformulerbar..av.1
  oformulerbarhet_1_N = mkN "oformulerbarhet" ; -- oformulerbarhet..nn.1
  oforslad_1_A = mkA "oforslad" ; -- oforslad..av.1
  ofosfaterad_1_A = mkA "ofosfaterad" ; -- ofosfaterad..av.1
  ofosfaterbar_1_A = mkA "ofosfaterbar" ; -- ofosfaterbar..av.1
  ofosfaterbarhet_1_N = mkN "ofosfaterbarhet" ; -- ofosfaterbarhet..nn.1
  ofossiliserad_1_A = mkA "ofossiliserad" ; -- ofossiliserad..av.1
  ofossiliserbar_1_A = mkA "ofossiliserbar" ; -- ofossiliserbar..av.1
  ofossiliserbarhet_1_N = mkN "ofossiliserbarhet" ; -- ofossiliserbarhet..nn.1
  ofostrad_1_A = mkA "ofostrad" ; -- ofostrad..av.1
  ofotad_1_A = mkA "ofotad" ; -- ofotad..av.1
  ofotograferad_1_A = mkA "ofotograferad" ; -- ofotograferad..av.1
  ofotograferbar_1_A = mkA "ofotograferbar" ; -- ofotograferbar..av.1
  ofotograferbarhet_1_N = mkN "ofotograferbarhet" ; -- ofotograferbarhet..nn.1
  ofotokopierad_1_A = mkA "ofotokopierad" ; -- ofotokopierad..av.1
  ofragmenterad_1_A = mkA "ofragmenterad" ; -- ofragmenterad..av.1
  ofragmenterbar_1_A = mkA "ofragmenterbar" ; -- ofragmenterbar..av.1
  ofragmenterbarhet_1_N = mkN "ofragmenterbarhet" ; -- ofragmenterbarhet..nn.1
  ofragmentiserad_1_A = mkA "ofragmentiserad" ; -- ofragmentiserad..av.1
  ofragmentiserbar_1_A = mkA "ofragmentiserbar" ; -- ofragmentiserbar..av.1
  ofragmentiserbarhet_1_N = mkN "ofragmentiserbarhet" ; -- ofragmentiserbarhet..nn.1
  ofraktad_1_A = mkA "ofraktad" ; -- ofraktad..av.1
  ofraktionerad_1_A = mkA "ofraktionerad" ; -- ofraktionerad..av.1
  ofraktionerbar_1_A = mkA "ofraktionerbar" ; -- ofraktionerbar..av.1
  ofraktionerbarhet_1_N = mkN "ofraktionerbarhet" ; -- ofraktionerbarhet..nn.1
  oframflyttad_1_A = mkA "oframflyttad" ; -- oframflyttad..av.1
  oframförd_1_A = mkA "oframförd" "oframfört" ; -- oframförd..av.1
  oframhävd_1_A = mkA "oframhävd" "oframhävt" ; -- oframhävd..av.1
  oframkallad_1_A = mkA "oframkallad" ; -- oframkallad..av.1
  oframkastad_1_A = mkA "oframkastad" ; -- oframkastad..av.1
  oframkomlig_1_A = mkA "oframkomlig" ; -- oframkomlig..av.1
  oframkomlighet_1_N = mkN "oframkomlighet" ; -- oframkomlighet..nn.1
  oframmanad_1_A = mkA "oframmanad" ; -- oframmanad..av.1
  oframpressad_1_A = mkA "oframpressad" ; -- oframpressad..av.1
  oframskymtad_1_A = mkA "oframskymtad" ; -- oframskymtad..av.1
  oframställd_1_A = mkA "oframställd" "oframställt" ; -- oframställd..av.1
  oframträngd_1_A = mkA "oframträngd" "oframträngt" ; -- oframträngd..av.1
  oframvisad_1_A = mkA "oframvisad" ; -- oframvisad..av.1
  ofrankerad_1_A = mkA "ofrankerad" ; -- ofrankerad..av.1
  ofrankerbar_1_A = mkA "ofrankerbar" ; -- ofrankerbar..av.1
  ofrankerbarhet_1_N = mkN "ofrankerbarhet" ; -- ofrankerbarhet..nn.1
  ofransad_1_A = mkA "ofransad" ; -- ofransad..av.1
  ofrapperad_1_A = mkA "ofrapperad" ; -- ofrapperad..av.1
  ofraserad_1_A = mkA "ofraserad" ; -- ofraserad..av.1
  ofraserbar_1_A = mkA "ofraserbar" ; -- ofraserbar..av.1
  ofraserbarhet_1_N = mkN "ofraserbarhet" ; -- ofraserbarhet..nn.1
  ofred_1_N = mkN "ofred" ; -- ofred..nn.1
  ofreda_1_V = mkV "ofredar" ; -- ofreda..vb.1
  ofredad_1_A = mkA "ofredad" ; -- ofredad..av.1
  ofredande_1_N = mkN "ofredande" ; -- ofredande..nn.1
  ofredstid_1_N = mkN "ofredstid" "ofredstider" ; -- ofredstid..nn.1
  ofrekventerad_1_A = mkA "ofrekventerad" ; -- ofrekventerad..av.1
  ofrekventerbar_1_A = mkA "ofrekventerbar" ; -- ofrekventerbar..av.1
  ofrekventerbarhet_1_N = mkN "ofrekventerbarhet" ; -- ofrekventerbarhet..nn.1
  ofrestad_1_A = mkA "ofrestad" ; -- ofrestad..av.1
  ofri_1_A = mkA "ofri" "ofritt" ; -- ofri..av.1
  ofriad_1_A = mkA "ofriad" ; -- ofriad..av.1
  ofrid_1_N = mkN "ofrid" ; -- ofrid..nn.1
  ofrihet_1_N = mkN "ofrihet" "ofriheter" ; -- ofrihet..nn.1
  ofrimärkt_1_A = mkA "ofrimärkt" "ofrimärkt" ; -- ofrimärkt..av.1
  ofriserad_1_A = mkA "ofriserad" ; -- ofriserad..av.1
  ofriserbar_1_A = mkA "ofriserbar" ; -- ofriserbar..av.1
  ofriserbarhet_1_N = mkN "ofriserbarhet" ; -- ofriserbarhet..nn.1
  ofriterad_1_A = mkA "ofriterad" ; -- ofriterad..av.1
  ofriterbar_1_A = mkA "ofriterbar" ; -- ofriterbar..av.1
  ofriterbarhet_1_N = mkN "ofriterbarhet" ; -- ofriterbarhet..nn.1
  ofrivillig_1_A = mkA "ofrivillig" ; -- ofrivillig..av.1
  ofrivillighet_1_N = mkN "ofrivillighet" ; -- ofrivillighet..nn.1
  ofronderad_1_A = mkA "ofronderad" ; -- ofronderad..av.1
  ofronderbar_1_A = mkA "ofronderbar" ; -- ofronderbar..av.1
  ofronderbarhet_1_N = mkN "ofronderbarhet" ; -- ofronderbarhet..nn.1
  ofrontad_1_A = mkA "ofrontad" ; -- ofrontad..av.1
  ofrotterad_1_A = mkA "ofrotterad" ; -- ofrotterad..av.1
  ofrotterbar_1_A = mkA "ofrotterbar" ; -- ofrotterbar..av.1
  ofrotterbarhet_1_N = mkN "ofrotterbarhet" ; -- ofrotterbarhet..nn.1
  ofruktad_1_A = mkA "ofruktad" ; -- ofruktad..av.1
  ofruktbar_1_A = mkA "ofruktbar" ; -- ofruktbar..av.1
  ofruktbarhet_1_N = mkN "ofruktbarhet" ; -- ofruktbarhet..nn.1
  ofruktsam_1_A = mkA "ofruktsam" "ofruktsamt" "ofruktsamma" "ofruktsamma" "ofruktsammare" "ofruktsammast" "ofruktsammaste" ; -- ofruktsam..av.1
  ofruktsamhet_1_N = mkN "ofruktsamhet" ; -- ofruktsamhet..nn.1
  ofrustrerad_1_A = mkA "ofrustrerad" ; -- ofrustrerad..av.1
  ofrustrerbar_1_A = mkA "ofrustrerbar" ; -- ofrustrerbar..av.1
  ofrustrerbarhet_1_N = mkN "ofrustrerbarhet" ; -- ofrustrerbarhet..nn.1
  ofrälse_1_A = mkA "ofrälse" ; -- ofrälse..av.1
  ofrälst_1_A = mkA "ofrälst" "ofrälst" ; -- ofrälst..av.1
  ofrämjad_1_A = mkA "ofrämjad" ; -- ofrämjad..av.1
  ofräst_1_A = mkA "ofräst" "ofräst" ; -- ofräst..av.1
  ofrätt_1_A = mkA "ofrätt" ; -- ofrätt..av.1
  ofrågad_1_A = mkA "ofrågad" ; -- ofrågad..av.1
  ofrånkomlig_1_A = mkA "ofrånkomlig" ; -- ofrånkomlig..av.1
  ofrånkomligen_1_Adv = mkAdv "ofrånkomligen" ; -- ofrånkomligen..ab.1
  ofrånkomlighet_1_N = mkN "ofrånkomlighet" ; -- ofrånkomlighet..nn.1
  ofrånskiljbar_1_A = mkA "ofrånskiljbar" ; -- ofrånskiljbar..av.1
  ofrånskiljbarhet_1_N = mkN "ofrånskiljbarhet" ; -- ofrånskiljbarhet..nn.1
  ofta_1_Adv = mkAdv "ofta" ; -- ofta..ab.1
  oftalmi_1_N = mkN "oftalmi" "oftalmier" ; -- oftalmi..nn.1
  oftalmiatrik_1_N = mkN "oftalmiatrik" ; -- oftalmiatrik..nn.1
  oftalmolog_1_N = mkN "oftalmolog" "oftalmologer" ; -- oftalmolog..nn.1
  oftalmologi_1_N = mkN "oftalmologi" ; -- oftalmologi..nn.1
  oftalmologisk_1_A = mkA "oftalmologisk" ; -- oftalmologisk..av.1
  oftalmoskop_1_N = mkN "oftalmoskop" neutrum  ; -- oftalmoskop..nn.1
  oftalmoskopi_1_N = mkN "oftalmoskopi" ; -- oftalmoskopi..nn.1
  ofuktad_1_A = mkA "ofuktad" ; -- ofuktad..av.1
  ofullbordad_1_A = mkA "ofullbordad" ; -- ofullbordad..av.1
  ofullföljd_1_A = mkA "ofullföljd" "ofullföljt" ; -- ofullföljd..av.1
  ofullgången_1_A = mkA "ofullgången" ; -- ofullgången..av.1
  ofullgångenhet_1_N = mkN "ofullgångenhet" ; -- ofullgångenhet..nn.1
  ofullkomlig_1_A = mkA "ofullkomlig" ; -- ofullkomlig..av.1
  ofullkomlighet_1_N = mkN "ofullkomlighet" "ofullkomligheter" ; -- ofullkomlighet..nn.1
  ofullkomnad_1_A = mkA "ofullkomnad" ; -- ofullkomnad..av.1
  ofullständig_1_A = mkA "ofullständig" ; -- ofullständig..av.1
  ofullständigad_1_A = mkA "ofullständigad" ; -- ofullständigad..av.1
  ofullständighet_1_N = mkN "ofullständighet" "ofullständigheter" ; -- ofullständighet..nn.1
  ofulländad_1_A = mkA "ofulländad" ; -- ofulländad..av.1
  ofurnerad_1_A = mkA "ofurnerad" ; -- ofurnerad..av.1
  ofurnerbar_1_A = mkA "ofurnerbar" ; -- ofurnerbar..av.1
  ofurnerbarhet_1_N = mkN "ofurnerbarhet" ; -- ofurnerbarhet..nn.1
  ofusionerad_1_A = mkA "ofusionerad" ; -- ofusionerad..av.1
  ofusionerbar_1_A = mkA "ofusionerbar" ; -- ofusionerbar..av.1
  ofusionerbarhet_1_N = mkN "ofusionerbarhet" ; -- ofusionerbarhet..nn.1
  ofylkad_1_A = mkA "ofylkad" ; -- ofylkad..av.1
  ofylld_1_A = mkA "ofylld" "ofyllt" ; -- ofylld..av.1
  ofyndad_1_A = mkA "ofyndad" ; -- ofyndad..av.1
  ofyndig_1_A = mkA "ofyndig" ; -- ofyndig..av.1
  ofysiljerad_1_A = mkA "ofysiljerad" ; -- ofysiljerad..av.1
  ofysiljerbar_1_A = mkA "ofysiljerbar" ; -- ofysiljerbar..av.1
  ofysiljerbarhet_1_N = mkN "ofysiljerbarhet" ; -- ofysiljerbarhet..nn.1
  ofägnad_1_A = mkA "ofägnad" ; -- ofägnad..av.1
  ofälld_1_A = mkA "ofälld" "ofällt" ; -- ofälld..av.1
  ofängslad_1_A = mkA "ofängslad" ; -- ofängslad..av.1
  ofärd_1_N = mkN "ofärd" ; -- ofärd..nn.1
  ofärdig_1_A = mkA "ofärdig" ; -- ofärdig..av.1
  ofärdighet_1_N = mkN "ofärdighet" ; -- ofärdighet..nn.1
  ofärdighet_2_N = mkN "ofärdighet" "ofärdigheter" ; -- ofärdighet..nn.2
  ofärdsår_1_N = mkN "ofärdsår" neutrum  ; -- ofärdsår..nn.1
  ofärg_1_N = mkN "ofärg" "ofärger" ; -- ofärg..nn.1
  ofärgad_1_A = mkA "ofärgad" ; -- ofärgad..av.1
  ofärjad_1_A = mkA "ofärjad" ; -- ofärjad..av.1
  ofärserad_1_A = mkA "ofärserad" ; -- ofärserad..av.1
  ofärserbar_1_A = mkA "ofärserbar" ; -- ofärserbar..av.1
  ofärserbarhet_1_N = mkN "ofärserbarhet" ; -- ofärserbarhet..nn.1
  ofärskad_1_A = mkA "ofärskad" ; -- ofärskad..av.1
  ofållad_1_A = mkA "ofållad" ; -- ofållad..av.1
  ofångad_1_A = mkA "ofångad" ; -- ofångad..av.1
  ofårad_1_A = mkA "ofårad" ; -- ofårad..av.1
  ofödd_1_A = mkA "ofödd" ; -- ofödd..av.1
  oföljd_1_A = mkA "oföljd" "oföljt" ; -- oföljd..av.1
  ofönad_1_A = mkA "ofönad" ; -- ofönad..av.1
  oför_1_A = mkA "oför" ; -- oför..av.1
  oföraktad_1_A = mkA "oföraktad" ; -- oföraktad..av.1
  oförallmänligad_1_A = mkA "oförallmänligad" ; -- oförallmänligad..av.1
  oförandligad_1_A = mkA "oförandligad" ; -- oförandligad..av.1
  oförankrad_1_A = mkA "oförankrad" ; -- oförankrad..av.1
  oföranmäld_1_A = mkA "oföranmäld" "oföranmält" ; -- oföranmäld..av.1
  oförannonserad_1_A = mkA "oförannonserad" ; -- oförannonserad..av.1
  oförannonserbar_1_A = mkA "oförannonserbar" ; -- oförannonserbar..av.1
  oförannonserbarhet_1_N = mkN "oförannonserbarhet" ; -- oförannonserbarhet..nn.1
  oföranstaltad_1_A = mkA "oföranstaltad" ; -- oföranstaltad..av.1
  oförargad_1_A = mkA "oförargad" ; -- oförargad..av.1
  oförarglig_1_A = mkA "oförarglig" ; -- oförarglig..av.1
  oförarglighet_1_N = mkN "oförarglighet" "oförargligheter" ; -- oförarglighet..nn.1
  oförbannad_1_A = mkA "oförbannad" ; -- oförbannad..av.1
  oförbehållsam_1_A = mkA "oförbehållsam" "oförbehållsamt" "oförbehållsamma" "oförbehållsamma" "oförbehållsammare" "oförbehållsammast" "oförbehållsammaste" ; -- oförbehållsam..av.1
  oförbehållsamhet_1_N = mkN "oförbehållsamhet" ; -- oförbehållsamhet..nn.1
  oförberedd_1_A = mkA "oförberedd" ; -- oförberedd..av.1
  oförbereddhet_1_N = mkN "oförbereddhet" ; -- oförbereddhet..nn.1
  oförbidad_1_A = mkA "oförbidad" ; -- oförbidad..av.1
  oförbilligad_1_A = mkA "oförbilligad" ; -- oförbilligad..av.1
  oförbittrad_1_A = mkA "oförbittrad" ; -- oförbittrad..av.1
  oförblandad_1_A = mkA "oförblandad" ; -- oförblandad..av.1
  oförbleknad_1_A = mkA "oförbleknad" ; -- oförbleknad..av.1
  oförblindad_1_A = mkA "oförblindad" ; -- oförblindad..av.1
  oförblommerad_1_A = mkA "oförblommerad" ; -- oförblommerad..av.1
  oförbluffad_1_A = mkA "oförbluffad" ; -- oförbluffad..av.1
  oförborgad_1_A = mkA "oförborgad" ; -- oförborgad..av.1
  oförborgerligad_1_A = mkA "oförborgerligad" ; -- oförborgerligad..av.1
  oförbrukad_1_A = mkA "oförbrukad" ; -- oförbrukad..av.1
  oförbryllad_1_A = mkA "oförbryllad" ; -- oförbryllad..av.1
  oförbränd_1_A = mkA "oförbränd" ; -- oförbränd..av.1
  oförbrännelig_1_A = mkA "oförbrännelig" ; -- oförbrännelig..av.1
  oförbrännelighet_1_N = mkN "oförbrännelighet" ; -- oförbrännelighet..nn.1
  oförbrödrad_1_A = mkA "oförbrödrad" ; -- oförbrödrad..av.1
  oförbuskad_1_A = mkA "oförbuskad" ; -- oförbuskad..av.1
  oförbyggd_1_A = mkA "oförbyggd" "oförbyggt" ; -- oförbyggd..av.1
  oförbytt_1_A = mkA "oförbytt" ; -- oförbytt..av.1
  oförbätterlig_1_A = mkA "oförbätterlig" ; -- oförbätterlig..av.1
  oförbätterlighet_1_N = mkN "oförbätterlighet" ; -- oförbätterlighet..nn.1
  oförbättrad_1_A = mkA "oförbättrad" ; -- oförbättrad..av.1
  oförd_1_A = mkA "oförd" "ofört" ; -- oförd..av.1
  ofördelad_1_A = mkA "ofördelad" ; -- ofördelad..av.1
  ofördelaktig_1_A = mkA "ofördelaktig" ; -- ofördelaktig..av.1
  ofördelaktighet_1_N = mkN "ofördelaktighet" ; -- ofördelaktighet..nn.1
  ofördjupad_1_A = mkA "ofördjupad" ; -- ofördjupad..av.1
  ofördragsam_1_A = mkA "ofördragsam" "ofördragsamt" "ofördragsamma" "ofördragsamma" "ofördragsammare" "ofördragsammast" "ofördragsammaste" ; -- ofördragsam..av.1
  ofördragsamhet_1_N = mkN "ofördragsamhet" ; -- ofördragsamhet..nn.1
  ofördröjd_1_A = mkA "ofördröjd" "ofördröjt" ; -- ofördröjd..av.1
  ofördröjlig_1_A = mkA "ofördröjlig" ; -- ofördröjlig..av.1
  ofördröjligen_1_Adv = mkAdv "ofördröjligen" ; -- ofördröjligen..ab.1
  ofördubblad_1_A = mkA "ofördubblad" ; -- ofördubblad..av.1
  ofördummad_1_A = mkA "ofördummad" ; -- ofördummad..av.1
  ofördunklad_1_A = mkA "ofördunklad" ; -- ofördunklad..av.1
  ofördunstad_1_A = mkA "ofördunstad" ; -- ofördunstad..av.1
  ofördyrad_1_A = mkA "ofördyrad" ; -- ofördyrad..av.1
  ofördystrad_1_A = mkA "ofördystrad" ; -- ofördystrad..av.1
  ofördämd_1_A = mkA "ofördämd" "ofördämt" ; -- ofördämd..av.1
  ofördärvad_1_A = mkA "ofördärvad" ; -- ofördärvad..av.1
  ofördömd_1_A = mkA "ofördömd" "ofördömt" ; -- ofördömd..av.1
  oföre_1_N = mkN "oföre" ; -- oföre..nn.1
  oförebyggd_1_A = mkA "oförebyggd" "oförebyggt" ; -- oförebyggd..av.1
  oförebådad_1_A = mkA "oförebådad" ; -- oförebådad..av.1
  oförenklad_1_A = mkA "oförenklad" ; -- oförenklad..av.1
  oförenlig_1_A = mkA "oförenlig" ; -- oförenlig..av.1
  oförenlighet_1_N = mkN "oförenlighet" "oförenligheter" ; -- oförenlighet..nn.1
  oförespeglad_1_A = mkA "oförespeglad" ; -- oförespeglad..av.1
  oförespråkad_1_A = mkA "oförespråkad" ; -- oförespråkad..av.1
  oförestavad_1_A = mkA "oförestavad" ; -- oförestavad..av.1
  oföreställd_1_A = mkA "oföreställd" "oföreställt" ; -- oföreställd..av.1
  oföretagsam_1_A = mkA "oföretagsam" "oföretagsamt" "oföretagsamma" "oföretagsamma" "oföretagsammare" "oföretagsammast" "oföretagsammaste" ; -- oföretagsam..av.1
  oföretagsamhet_1_N = mkN "oföretagsamhet" ; -- oföretagsamhet..nn.1
  oförevigad_1_A = mkA "oförevigad" ; -- oförevigad..av.1
  oförevisad_1_A = mkA "oförevisad" ; -- oförevisad..av.1
  oförevitad_1_A = mkA "oförevitad" ; -- oförevitad..av.1
  oförfalskad_1_A = mkA "oförfalskad" ; -- oförfalskad..av.1
  oförfattad_1_A = mkA "oförfattad" ; -- oförfattad..av.1
  oförfelad_1_A = mkA "oförfelad" ; -- oförfelad..av.1
  oförfinad_1_A = mkA "oförfinad" ; -- oförfinad..av.1
  oförflackad_1_A = mkA "oförflackad" ; -- oförflackad..av.1
  oförflyttad_1_A = mkA "oförflyttad" ; -- oförflyttad..av.1
  oförfranskad_1_A = mkA "oförfranskad" ; -- oförfranskad..av.1
  oförfuskad_1_A = mkA "oförfuskad" ; -- oförfuskad..av.1
  oförfäad_1_A = mkA "oförfäad" ; -- oförfäad..av.1
  oförfäktad_1_A = mkA "oförfäktad" ; -- oförfäktad..av.1
  oförfärad_1_A = mkA "oförfärad" ; -- oförfärad..av.1
  oförfärdigad_1_A = mkA "oförfärdigad" ; -- oförfärdigad..av.1
  oförfångad_1_A = mkA "oförfångad" ; -- oförfångad..av.1
  oförföljd_1_A = mkA "oförföljd" "oförföljt" ; -- oförföljd..av.1
  oförförd_1_A = mkA "oförförd" "oförfört" ; -- oförförd..av.1
  oförfördelad_1_A = mkA "oförfördelad" ; -- oförfördelad..av.1
  oförgasad_1_A = mkA "oförgasad" ; -- oförgasad..av.1
  oförgiftad_1_A = mkA "oförgiftad" ; -- oförgiftad..av.1
  oförglömd_1_A = mkA "oförglömd" "oförglömt" ; -- oförglömd..av.1
  oförglömlig_1_A = mkA "oförglömlig" ; -- oförglömlig..av.1
  oförglömlighet_1_N = mkN "oförglömlighet" "oförglömligheter" ; -- oförglömlighet..nn.1
  oförgriplig_1_A = mkA "oförgriplig" ; -- oförgriplig..av.1
  oförgriplighet_1_N = mkN "oförgriplighet" ; -- oförgriplighet..nn.1
  oförgrovad_1_A = mkA "oförgrovad" ; -- oförgrovad..av.1
  oförgrymmad_1_A = mkA "oförgrymmad" ; -- oförgrymmad..av.1
  oförgylld_1_A = mkA "oförgylld" "oförgyllt" ; -- oförgylld..av.1
  oförgänglig_1_A = mkA "oförgänglig" ; -- oförgänglig..av.1
  oförgänglighet_1_N = mkN "oförgänglighet" "oförgängligheter" ; -- oförgänglighet..nn.1
  oförgätlig_1_A = mkA "oförgätlig" ; -- oförgätlig..av.1
  oförgätlighet_1_N = mkN "oförgätlighet" ; -- oförgätlighet..nn.1
  oförhalad_1_A = mkA "oförhalad" ; -- oförhalad..av.1
  oförhandlad_1_A = mkA "oförhandlad" ; -- oförhandlad..av.1
  oförhet_1_N = mkN "oförhet" ; -- oförhet..nn.1
  oförhindrad_1_A = mkA "oförhindrad" ; -- oförhindrad..av.1
  oförhyrd_1_A = mkA "oförhyrd" "oförhyrt" ; -- oförhyrd..av.1
  oförhärdad_1_A = mkA "oförhärdad" ; -- oförhärdad..av.1
  oförhärjad_1_A = mkA "oförhärjad" ; -- oförhärjad..av.1
  oförhärligad_1_A = mkA "oförhärligad" ; -- oförhärligad..av.1
  oförhäxad_1_A = mkA "oförhäxad" ; -- oförhäxad..av.1
  oförhånad_1_A = mkA "oförhånad" ; -- oförhånad..av.1
  oförhöjd_1_A = mkA "oförhöjd" "oförhöjt" ; -- oförhöjd..av.1
  oförhörd_1_A = mkA "oförhörd" "oförhört" ; -- oförhörd..av.1
  oförintad_1_A = mkA "oförintad" ; -- oförintad..av.1
  oförjagad_1_A = mkA "oförjagad" ; -- oförjagad..av.1
  oförkastad_1_A = mkA "oförkastad" ; -- oförkastad..av.1
  oförklarad_1_A = mkA "oförklarad" ; -- oförklarad..av.1
  oförklarlig_1_A = mkA "oförklarlig" ; -- oförklarlig..av.1
  oförklarlighet_1_N = mkN "oförklarlighet" "oförklarligheter" ; -- oförklarlighet..nn.1
  oförklingad_1_A = mkA "oförklingad" ; -- oförklingad..av.1
  oförklistrad_1_A = mkA "oförklistrad" ; -- oförklistrad..av.1
  oförknippad_1_A = mkA "oförknippad" ; -- oförknippad..av.1
  oförkolnad_1_A = mkA "oförkolnad" ; -- oförkolnad..av.1
  oförkortad_1_A = mkA "oförkortad" ; -- oförkortad..av.1
  oförkovrad_1_A = mkA "oförkovrad" ; -- oförkovrad..av.1
  oförkromad_1_A = mkA "oförkromad" ; -- oförkromad..av.1
  oförkroppsligad_1_A = mkA "oförkroppsligad" ; -- oförkroppsligad..av.1
  oförkrossad_1_A = mkA "oförkrossad" ; -- oförkrossad..av.1
  oförkrympt_1_A = mkA "oförkrympt" "oförkrympt" ; -- oförkrympt..av.1
  oförkunnad_1_A = mkA "oförkunnad" ; -- oförkunnad..av.1
  oförkvävd_1_A = mkA "oförkvävd" "oförkvävt" ; -- oförkvävd..av.1
  oförlamad_1_A = mkA "oförlamad" ; -- oförlamad..av.1
  oförliknelig_1_A = mkA "oförliknelig" ; -- oförliknelig..av.1
  oförliknelighet_1_N = mkN "oförliknelighet" ; -- oförliknelighet..nn.1
  oförlikt_1_A = mkA "oförlikt" "oförlikt" ; -- oförlikt..av.1
  oförlist_1_A = mkA "oförlist" "oförlist" ; -- oförlist..av.1
  oförljuvad_1_A = mkA "oförljuvad" ; -- oförljuvad..av.1
  oförlorad_1_A = mkA "oförlorad" ; -- oförlorad..av.1
  oförlossad_1_A = mkA "oförlossad" ; -- oförlossad..av.1
  oförlustad_1_A = mkA "oförlustad" ; -- oförlustad..av.1
  oförlänad_1_A = mkA "oförlänad" ; -- oförlänad..av.1
  oförlängd_1_A = mkA "oförlängd" "oförlängt" ; -- oförlängd..av.1
  oförlåtlig_1_A = mkA "oförlåtlig" ; -- oförlåtlig..av.1
  oförlåtlighet_1_N = mkN "oförlåtlighet" ; -- oförlåtlighet..nn.1
  oförlöjligad_1_A = mkA "oförlöjligad" ; -- oförlöjligad..av.1
  oförlöst_1_A = mkA "oförlöst" "oförlöst" ; -- oförlöst..av.1
  oförmanad_1_A = mkA "oförmanad" ; -- oförmanad..av.1
  oförmedlad_1_A = mkA "oförmedlad" ; -- oförmedlad..av.1
  oförmenad_1_A = mkA "oförmenad" ; -- oförmenad..av.1
  oförmildrad_1_A = mkA "oförmildrad" ; -- oförmildrad..av.1
  oförminskad_1_A = mkA "oförminskad" ; -- oförminskad..av.1
  oförmodad_1_A = mkA "oförmodad" ; -- oförmodad..av.1
  oförmultnad_1_A = mkA "oförmultnad" ; -- oförmultnad..av.1
  oförmäld_1_A = mkA "oförmäld" "oförmält" ; -- oförmäld..av.1
  oförmänskligad_1_A = mkA "oförmänskligad" ; -- oförmänskligad..av.1
  oförmärkt_1_A = mkA "oförmärkt" "oförmärkt" ; -- oförmärkt..av.1
  oförmärkthet_1_N = mkN "oförmärkthet" ; -- oförmärkthet..nn.1
  oförmåga_1_N = mkN "oförmåga" ; -- oförmåga..nn.1
  oförmånlig_1_A = mkA "oförmånlig" ; -- oförmånlig..av.1
  oförmögen_1_A = mkA "oförmögen" ; -- oförmögen..av.1
  oförmögenhet_1_N = mkN "oförmögenhet" ; -- oförmögenhet..nn.1
  oförmörkad_1_A = mkA "oförmörkad" ; -- oförmörkad..av.1
  oförnedrad_1_A = mkA "oförnedrad" ; -- oförnedrad..av.1
  oförnekad_1_A = mkA "oförnekad" ; -- oförnekad..av.1
  oförneklig_1_A = mkA "oförneklig" ; -- oförneklig..av.1
  oförneklighet_1_N = mkN "oförneklighet" ; -- oförneklighet..nn.1
  oförnicklad_1_A = mkA "oförnicklad" ; -- oförnicklad..av.1
  oförnimbar_1_A = mkA "oförnimbar" ; -- oförnimbar..av.1
  oförnimbarhet_1_N = mkN "oförnimbarhet" ; -- oförnimbarhet..nn.1
  oförnuft_1_N = mkN "oförnuft" neutrum  ; -- oförnuft..nn.1
  oförnuftig_1_A = mkA "oförnuftig" ; -- oförnuftig..av.1
  oförnuftighet_1_N = mkN "oförnuftighet" "oförnuftigheter" ; -- oförnuftighet..nn.1
  oförnyad_1_A = mkA "oförnyad" ; -- oförnyad..av.1
  oförnärmad_1_A = mkA "oförnärmad" ; -- oförnärmad..av.1
  oförnöjd_1_A = mkA "oförnöjd" "oförnöjt" ; -- oförnöjd..av.1
  oförnöjdhet_1_N = mkN "oförnöjdhet" ; -- oförnöjdhet..nn.1
  oförnöjsam_1_A = mkA "oförnöjsam" "oförnöjsamt" "oförnöjsamma" "oförnöjsamma" "oförnöjsammare" "oförnöjsammast" "oförnöjsammaste" ; -- oförnöjsam..av.1
  oförnöjsamhet_1_N = mkN "oförnöjsamhet" ; -- oförnöjsamhet..nn.1
  oförnött_1_A = mkA "oförnött" ; -- oförnött..av.1
  oförolämpad_1_A = mkA "oförolämpad" ; -- oförolämpad..av.1
  oförordad_1_A = mkA "oförordad" ; -- oförordad..av.1
  oförordnad_1_A = mkA "oförordnad" ; -- oförordnad..av.1
  oförorenad_1_A = mkA "oförorenad" ; -- oförorenad..av.1
  oförorsakad_1_A = mkA "oförorsakad" ; -- oförorsakad..av.1
  oförorättad_1_A = mkA "oförorättad" ; -- oförorättad..av.1
  oförpackad_1_A = mkA "oförpackad" ; -- oförpackad..av.1
  oförpaktad_1_A = mkA "oförpaktad" ; -- oförpaktad..av.1
  oförpantad_1_A = mkA "oförpantad" ; -- oförpantad..av.1
  oförpassad_1_A = mkA "oförpassad" ; -- oförpassad..av.1
  oförpestad_1_A = mkA "oförpestad" ; -- oförpestad..av.1
  oförpliktad_1_A = mkA "oförpliktad" ; -- oförpliktad..av.1
  oförpliktigad_1_A = mkA "oförpliktigad" ; -- oförpliktigad..av.1
  oförplägad_1_A = mkA "oförplägad" ; -- oförplägad..av.1
  oförprickad_1_A = mkA "oförprickad" ; -- oförprickad..av.1
  oförringad_1_A = mkA "oförringad" ; -- oförringad..av.1
  oförruttnad_1_A = mkA "oförruttnad" ; -- oförruttnad..av.1
  oförryckt_1_A = mkA "oförryckt" "oförryckt" ; -- oförryckt..av.1
  oförryckthet_1_N = mkN "oförryckthet" ; -- oförryckthet..nn.1
  oförryskad_1_A = mkA "oförryskad" ; -- oförryskad..av.1
  oförräntad_1_A = mkA "oförräntad" ; -- oförräntad..av.1
  oförrätt_1_N = mkN "oförrätt" "oförrätter" ; -- oförrätt..nn.1
  oförrättad_1_A = mkA "oförrättad" ; -- oförrättad..av.1
  oförråad_1_A = mkA "oförråad" ; -- oförråad..av.1
  oförsakad_1_A = mkA "oförsakad" ; -- oförsakad..av.1
  oförsamlad_1_A = mkA "oförsamlad" ; -- oförsamlad..av.1
  oförseglad_1_A = mkA "oförseglad" ; -- oförseglad..av.1
  oförsenad_1_A = mkA "oförsenad" ; -- oförsenad..av.1
  oförsiktig_1_A = mkA "oförsiktig" ; -- oförsiktig..av.1
  oförsiktighet_1_N = mkN "oförsiktighet" ; -- oförsiktighet..nn.1
  oförsiktigtvis_1_Adv = mkAdv "oförsiktigtvis" ; -- oförsiktigtvis..ab.1
  oförsilvrad_1_A = mkA "oförsilvrad" ; -- oförsilvrad..av.1
  oförsinkad_1_A = mkA "oförsinkad" ; -- oförsinkad..av.1
  oförskaffad_1_A = mkA "oförskaffad" ; -- oförskaffad..av.1
  oförskansad_1_A = mkA "oförskansad" ; -- oförskansad..av.1
  oförskingrad_1_A = mkA "oförskingrad" ; -- oförskingrad..av.1
  oförskonad_1_A = mkA "oförskonad" ; -- oförskonad..av.1
  oförskotterad_1_A = mkA "oförskotterad" ; -- oförskotterad..av.1
  oförskotterbar_1_A = mkA "oförskotterbar" ; -- oförskotterbar..av.1
  oförskotterbarhet_1_N = mkN "oförskotterbarhet" ; -- oförskotterbarhet..nn.1
  oförskräckt_1_A = mkA "oförskräckt" "oförskräckt" ; -- oförskräckt..av.1
  oförskräckthet_1_N = mkN "oförskräckthet" ; -- oförskräckthet..nn.1
  oförskylld_1_A = mkA "oförskylld" "oförskyllt" ; -- oförskylld..av.1
  oförskylldhet_1_N = mkN "oförskylldhet" ; -- oförskylldhet..nn.1
  oförskämd_1_A = mkA "oförskämd" "oförskämt" ; -- oförskämd..av.1
  oförskämdhet_1_N = mkN "oförskämdhet" "oförskämdheter" ; -- oförskämdhet..nn.1
  oförskönad_1_A = mkA "oförskönad" ; -- oförskönad..av.1
  oförslappad_1_A = mkA "oförslappad" ; -- oförslappad..av.1
  oförslavad_1_A = mkA "oförslavad" ; -- oförslavad..av.1
  oförslöad_1_A = mkA "oförslöad" ; -- oförslöad..av.1
  oförslösad_1_A = mkA "oförslösad" ; -- oförslösad..av.1
  oförsnillad_1_A = mkA "oförsnillad" ; -- oförsnillad..av.1
  oförsoffad_1_A = mkA "oförsoffad" ; -- oförsoffad..av.1
  oförsonad_1_A = mkA "oförsonad" ; -- oförsonad..av.1
  oförsonlig_1_A = mkA "oförsonlig" ; -- oförsonlig..av.1
  oförsonlighet_1_N = mkN "oförsonlighet" ; -- oförsonlighet..nn.1
  oförspilld_1_A = mkA "oförspilld" "oförspillt" ; -- oförspilld..av.1
  oförstatligad_1_A = mkA "oförstatligad" ; -- oförstatligad..av.1
  oförstelnad_1_A = mkA "oförstelnad" ; -- oförstelnad..av.1
  oförstenad_1_A = mkA "oförstenad" ; -- oförstenad..av.1
  oförstockad_1_A = mkA "oförstockad" ; -- oförstockad..av.1
  oförstoppad_1_A = mkA "oförstoppad" ; -- oförstoppad..av.1
  oförstorad_1_A = mkA "oförstorad" ; -- oförstorad..av.1
  oförsträckt_1_A = mkA "oförsträckt" "oförsträckt" ; -- oförsträckt..av.1
  oförsträvad_1_A = mkA "oförsträvad" ; -- oförsträvad..av.1
  oförstummad_1_A = mkA "oförstummad" ; -- oförstummad..av.1
  oförställd_1_A = mkA "oförställd" "oförställt" ; -- oförställd..av.1
  oförställdhet_1_N = mkN "oförställdhet" ; -- oförställdhet..nn.1
  oförstämd_1_A = mkA "oförstämd" "oförstämt" ; -- oförstämd..av.1
  oförstämdhet_1_N = mkN "oförstämdhet" ; -- oförstämdhet..nn.1
  oförständigad_1_A = mkA "oförständigad" ; -- oförständigad..av.1
  oförstärkt_1_A = mkA "oförstärkt" "oförstärkt" ; -- oförstärkt..av.1
  oförstådd_1_A = mkA "oförstådd" ; -- oförstådd..av.1
  oförståelig_1_A = mkA "oförståelig" ; -- oförståelig..av.1
  oförståelighet_1_N = mkN "oförståelighet" "oförståeligheter" ; -- oförståelighet..nn.1
  oförståelse_1_N = mkN "oförståelse" utrum  ; -- oförståelse..nn.1
  oförstående_1_A = mkA "oförstående" ; -- oförstående..av.1
  oförstånd_1_N = mkN "oförstånd" neutrum  ; -- oförstånd..nn.1
  oförståndig_1_A = mkA "oförståndig" ; -- oförståndig..av.1
  oförståndighet_1_N = mkN "oförståndighet" ; -- oförståndighet..nn.1
  oförstörbar_1_A = mkA "oförstörbar" ; -- oförstörbar..av.1
  oförstörbarhet_1_N = mkN "oförstörbarhet" ; -- oförstörbarhet..nn.1
  oförstörd_1_A = mkA "oförstörd" "oförstört" ; -- oförstörd..av.1
  oförstördhet_1_N = mkN "oförstördhet" ; -- oförstördhet..nn.1
  oförsummad_1_A = mkA "oförsummad" ; -- oförsummad..av.1
  oförsurad_1_A = mkA "oförsurad" ; -- oförsurad..av.1
  oförsvagad_1_A = mkA "oförsvagad" ; -- oförsvagad..av.1
  oförsvarad_1_A = mkA "oförsvarad" ; -- oförsvarad..av.1
  oförsvarbar_1_A = mkA "oförsvarbar" ; -- oförsvarbar..av.1
  oförsvarlig_1_A = mkA "oförsvarlig" ; -- oförsvarlig..av.1
  oförsvarlighet_1_N = mkN "oförsvarlighet" ; -- oförsvarlighet..nn.1
  oförsvenskad_1_A = mkA "oförsvenskad" ; -- oförsvenskad..av.1
  oförsvårad_1_A = mkA "oförsvårad" ; -- oförsvårad..av.1
  oförsynt_1_A = mkA "oförsynt" "oförsynt" ; -- oförsynt..av.1
  oförsynthet_1_N = mkN "oförsynthet" ; -- oförsynthet..nn.1
  oförsäkrad_1_A = mkA "oförsäkrad" ; -- oförsäkrad..av.1
  oförsämrad_1_A = mkA "oförsämrad" ; -- oförsämrad..av.1
  oförsänd_1_A = mkA "oförsänd" ; -- oförsänd..av.1
  oförsänkt_1_A = mkA "oförsänkt" "oförsänkt" ; -- oförsänkt..av.1
  oförsörjd_1_A = mkA "oförsörjd" "oförsörjt" ; -- oförsörjd..av.1
  oförtalad_1_A = mkA "oförtalad" ; -- oförtalad..av.1
  oförtecknad_1_A = mkA "oförtecknad" ; -- oförtecknad..av.1
  oförtennad_1_A = mkA "oförtennad" ; -- oförtennad..av.1
  oförtjockad_1_A = mkA "oförtjockad" ; -- oförtjockad..av.1
  oförtjust_1_A = mkA "oförtjust" "oförtjust" ; -- oförtjust..av.1
  oförtjusthet_1_N = mkN "oförtjusthet" ; -- oförtjusthet..nn.1
  oförtjänad_1_A = mkA "oförtjänad" ; -- oförtjänad..av.1
  oförtjänt_1_A = mkA "oförtjänt" "oförtjänt" ; -- oförtjänt..av.1
  oförtjänthet_1_N = mkN "oförtjänthet" ; -- oförtjänthet..nn.1
  oförtorkad_1_A = mkA "oförtorkad" ; -- oförtorkad..av.1
  oförtrampad_1_A = mkA "oförtrampad" ; -- oförtrampad..av.1
  oförtretad_1_A = mkA "oförtretad" ; -- oförtretad..av.1
  oförtrollad_1_A = mkA "oförtrollad" ; -- oförtrollad..av.1
  oförtrustad_1_A = mkA "oförtrustad" ; -- oförtrustad..av.1
  oförtruten_1_A = mkA "oförtruten" ; -- oförtruten..av.1
  oförtrutenhet_1_N = mkN "oförtrutenhet" ; -- oförtrutenhet..nn.1
  oförtryckt_1_A = mkA "oförtryckt" "oförtryckt" ; -- oförtryckt..av.1
  oförträngd_1_A = mkA "oförträngd" "oförträngt" ; -- oförträngd..av.1
  oförtröstad_1_A = mkA "oförtröstad" ; -- oförtröstad..av.1
  oförtröttad_1_A = mkA "oförtröttad" ; -- oförtröttad..av.1
  oförtröttlig_1_A = mkA "oförtröttlig" ; -- oförtröttlig..av.1
  oförtröttlighet_1_N = mkN "oförtröttlighet" ; -- oförtröttlighet..nn.1
  oförtullad_1_A = mkA "oförtullad" ; -- oförtullad..av.1
  oförtunnad_1_A = mkA "oförtunnad" ; -- oförtunnad..av.1
  oförtvinad_1_A = mkA "oförtvinad" ; -- oförtvinad..av.1
  oförtvivlad_1_A = mkA "oförtvivlad" ; -- oförtvivlad..av.1
  oförtvålad_1_A = mkA "oförtvålad" ; -- oförtvålad..av.1
  oförtyckt_1_A = mkA "oförtyckt" "oförtyckt" ; -- oförtyckt..av.1
  oförtydbar_1_A = mkA "oförtydbar" ; -- oförtydbar..av.1
  oförtydbarhet_1_N = mkN "oförtydbarhet" ; -- oförtydbarhet..nn.1
  oförtydligad_1_A = mkA "oförtydligad" ; -- oförtydligad..av.1
  oförtyskad_1_A = mkA "oförtyskad" ; -- oförtyskad..av.1
  oförtäckt_1_A = mkA "oförtäckt" "oförtäckt" ; -- oförtäckt..av.1
  oförtäckthet_1_N = mkN "oförtäckthet" ; -- oförtäckthet..nn.1
  oförtänksam_1_A = mkA "oförtänksam" ; -- oförtänksam..av.1
  oförtänkt_1_A = mkA "oförtänkt" "oförtänkt" ; -- oförtänkt..av.1
  oförtärd_1_A = mkA "oförtärd" "oförtärt" ; -- oförtärd..av.1
  oförtätad_1_A = mkA "oförtätad" ; -- oförtätad..av.1
  oförtöjd_1_A = mkA "oförtöjd" "oförtöjt" ; -- oförtöjd..av.1
  oförtövad_1_A = mkA "oförtövad" ; -- oförtövad..av.1
  oförundrad_1_A = mkA "oförundrad" ; -- oförundrad..av.1
  oförunnad_1_A = mkA "oförunnad" ; -- oförunnad..av.1
  oförutbestämd_1_A = mkA "oförutbestämd" "oförutbestämt" ; -- oförutbestämd..av.1
  oförutbestämdhet_1_N = mkN "oförutbestämdhet" ; -- oförutbestämdhet..nn.1
  oförutsebar_1_A = mkA "oförutsebar" ; -- oförutsebar..av.1
  oförutsebarhet_1_N = mkN "oförutsebarhet" ; -- oförutsebarhet..nn.1
  oförutsedd_1_A = mkA "oförutsedd" ; -- oförutsedd..av.1
  oförutseddhet_1_N = mkN "oförutseddhet" ; -- oförutseddhet..nn.1
  oförutskickad_1_A = mkA "oförutskickad" ; -- oförutskickad..av.1
  oförutspådd_1_A = mkA "oförutspådd" ; -- oförutspådd..av.1
  oförutspåddhet_1_N = mkN "oförutspåddhet" ; -- oförutspåddhet..nn.1
  oförutsägbar_1_A = mkA "oförutsägbar" ; -- oförutsägbar..av.1
  oförutsägbarhet_1_N = mkN "oförutsägbarhet" ; -- oförutsägbarhet..nn.1
  oförvaltad_1_A = mkA "oförvaltad" ; -- oförvaltad..av.1
  oförvandlad_1_A = mkA "oförvandlad" ; -- oförvandlad..av.1
  oförvanskad_1_A = mkA "oförvanskad" ; -- oförvanskad..av.1
  oförvarad_1_A = mkA "oförvarad" ; -- oförvarad..av.1
  oförvarnad_1_A = mkA "oförvarnad" ; -- oförvarnad..av.1
  oförvedad_1_A = mkA "oförvedad" ; -- oförvedad..av.1
  oförvekligad_1_A = mkA "oförvekligad" ; -- oförvekligad..av.1
  oförverkad_1_A = mkA "oförverkad" ; -- oförverkad..av.1
  oförverkligad_1_A = mkA "oförverkligad" ; -- oförverkligad..av.1
  oförvillad_1_A = mkA "oförvillad" ; -- oförvillad..av.1
  oförvirrad_1_A = mkA "oförvirrad" ; -- oförvirrad..av.1
  oförvisad_1_A = mkA "oförvisad" ; -- oförvisad..av.1
  oförvissad_1_A = mkA "oförvissad" ; -- oförvissad..av.1
  oförvissnad_1_A = mkA "oförvissnad" ; -- oförvissnad..av.1
  oförvitlig_1_A = mkA "oförvitlig" ; -- oförvitlig..av.1
  oförvitlighet_1_N = mkN "oförvitlighet" ; -- oförvitlighet..nn.1
  oförvittrad_1_A = mkA "oförvittrad" ; -- oförvittrad..av.1
  oförvrängd_1_A = mkA "oförvrängd" "oförvrängt" ; -- oförvrängd..av.1
  oförvägen_1_A = mkA "oförvägen" ; -- oförvägen..av.1
  oförvägenhet_1_N = mkN "oförvägenhet" "oförvägenheter" ; -- oförvägenhet..nn.1
  oförvägrad_1_A = mkA "oförvägrad" ; -- oförvägrad..av.1
  oförvälld_1_A = mkA "oförvälld" "oförvällt" ; -- oförvälld..av.1
  oförvänd_1_A = mkA "oförvänd" ; -- oförvänd..av.1
  oförväntad_1_A = mkA "oförväntad" ; -- oförväntad..av.1
  oförvärldsligad_1_A = mkA "oförvärldsligad" ; -- oförvärldsligad..av.1
  oförvärrad_1_A = mkA "oförvärrad" ; -- oförvärrad..av.1
  oförvärvad_1_A = mkA "oförvärvad" ; -- oförvärvad..av.1
  oförväxlad_1_A = mkA "oförväxlad" ; -- oförväxlad..av.1
  oförvållad_1_A = mkA "oförvållad" ; -- oförvållad..av.1
  oförvånad_1_A = mkA "oförvånad" ; -- oförvånad..av.1
  oföryngrad_1_A = mkA "oföryngrad" ; -- oföryngrad..av.1
  oförytterlig_1_A = mkA "oförytterlig" ; -- oförytterlig..av.1
  oförytterlighet_1_N = mkN "oförytterlighet" ; -- oförytterlighet..nn.1
  oförzinkad_1_A = mkA "oförzinkad" ; -- oförzinkad..av.1
  oförädlad_1_A = mkA "oförädlad" ; -- oförädlad..av.1
  oföränderlig_1_A = mkA "oföränderlig" ; -- oföränderlig..av.1
  oföränderlighet_1_N = mkN "oföränderlighet" "oföränderligheter" ; -- oföränderlighet..nn.1
  oförändrad_1_A = mkA "oförändrad" ; -- oförändrad..av.1
  oförärad_1_A = mkA "oförärad" ; -- oförärad..av.1
  oförångad_1_A = mkA "oförångad" ; -- oförångad..av.1
  oförödmjukad_1_A = mkA "oförödmjukad" ; -- oförödmjukad..av.1
  oförökad_1_A = mkA "oförökad" ; -- oförökad..av.1
  oförövad_1_A = mkA "oförövad" ; -- oförövad..av.1
  oföst_1_A = mkA "oföst" "oföst" ; -- oföst..av.1
  ogagnad_1_A = mkA "ogagnad" ; -- ogagnad..av.1
  ogalliserad_1_A = mkA "ogalliserad" ; -- ogalliserad..av.1
  ogalliserbar_1_A = mkA "ogalliserbar" ; -- ogalliserbar..av.1
  ogalliserbarhet_1_N = mkN "ogalliserbarhet" ; -- ogalliserbarhet..nn.1
  ogallrad_1_A = mkA "ogallrad" ; -- ogallrad..av.1
  ogaloscherad_1_A = mkA "ogaloscherad" ; -- ogaloscherad..av.1
  ogaloscherbar_1_A = mkA "ogaloscherbar" ; -- ogaloscherbar..av.1
  ogaloscherbarhet_1_N = mkN "ogaloscherbarhet" ; -- ogaloscherbarhet..nn.1
  ogalvad_1_A = mkA "ogalvad" ; -- ogalvad..av.1
  ogalvaniserad_1_A = mkA "ogalvaniserad" ; -- ogalvaniserad..av.1
  ogalvaniserbar_1_A = mkA "ogalvaniserbar" ; -- ogalvaniserbar..av.1
  ogalvaniserbarhet_1_N = mkN "ogalvaniserbarhet" ; -- ogalvaniserbarhet..nn.1
  oganad_1_A = mkA "oganad" ; -- oganad..av.1
  ogarad_1_A = mkA "ogarad" ; -- ogarad..av.1
  ogaragerad_1_A = mkA "ogaragerad" ; -- ogaragerad..av.1
  ogaragerbar_1_A = mkA "ogaragerbar" ; -- ogaragerbar..av.1
  ogaragerbarhet_1_N = mkN "ogaragerbarhet" ; -- ogaragerbarhet..nn.1
  ogaranterad_1_A = mkA "ogaranterad" ; -- ogaranterad..av.1
  ogaranterbar_1_A = mkA "ogaranterbar" ; -- ogaranterbar..av.1
  ogaranterbarhet_1_N = mkN "ogaranterbarhet" ; -- ogaranterbarhet..nn.1
  ogarderad_1_A = mkA "ogarderad" ; -- ogarderad..av.1
  ogarderbar_1_A = mkA "ogarderbar" ; -- ogarderbar..av.1
  ogarderbarhet_1_N = mkN "ogarderbarhet" ; -- ogarderbarhet..nn.1
  ogarnerad_1_A = mkA "ogarnerad" ; -- ogarnerad..av.1
  ogarnerbar_1_A = mkA "ogarnerbar" ; -- ogarnerbar..av.1
  ogarnerbarhet_1_N = mkN "ogarnerbarhet" ; -- ogarnerbarhet..nn.1
  ogarnisonerad_1_A = mkA "ogarnisonerad" ; -- ogarnisonerad..av.1
  ogarnisonerbar_1_A = mkA "ogarnisonerbar" ; -- ogarnisonerbar..av.1
  ogarnisonerbarhet_1_N = mkN "ogarnisonerbarhet" ; -- ogarnisonerbarhet..nn.1
  ogarrotterad_1_A = mkA "ogarrotterad" ; -- ogarrotterad..av.1
  ogarrotterbar_1_A = mkA "ogarrotterbar" ; -- ogarrotterbar..av.1
  ogarrotterbarhet_1_N = mkN "ogarrotterbarhet" ; -- ogarrotterbarhet..nn.1
  ogarvad_1_A = mkA "ogarvad" ; -- ogarvad..av.1
  ogasad_1_A = mkA "ogasad" ; -- ogasad..av.1
  ogastroskoperad_1_A = mkA "ogastroskoperad" ; -- ogastroskoperad..av.1
  ogastroskoperbar_1_A = mkA "ogastroskoperbar" ; -- ogastroskoperbar..av.1
  ogastroskoperbarhet_1_N = mkN "ogastroskoperbarhet" ; -- ogastroskoperbarhet..nn.1
  ogauffrerad_1_A = mkA "ogauffrerad" ; -- ogauffrerad..av.1
  ogauffrerbar_1_A = mkA "ogauffrerbar" ; -- ogauffrerbar..av.1
  ogauffrerbarhet_1_N = mkN "ogauffrerbarhet" ; -- ogauffrerbarhet..nn.1
  ogelatinerad_1_A = mkA "ogelatinerad" ; -- ogelatinerad..av.1
  ogelatinerbar_1_A = mkA "ogelatinerbar" ; -- ogelatinerbar..av.1
  ogelatinerbarhet_1_N = mkN "ogelatinerbarhet" ; -- ogelatinerbarhet..nn.1
  ogelead_1_A = mkA "ogelead" ; -- ogelead..av.1
  ogemen_1_A = mkA "ogemen" "ogement" ; -- ogemen..av.1
  ogeminerad_1_A = mkA "ogeminerad" ; -- ogeminerad..av.1
  ogeminerbar_1_A = mkA "ogeminerbar" ; -- ogeminerbar..av.1
  ogeminerbarhet_1_N = mkN "ogeminerbarhet" ; -- ogeminerbarhet..nn.1
  ogenerad_1_A = mkA "ogenerad" ; -- ogenerad..av.1
  ogeneraliserad_1_A = mkA "ogeneraliserad" ; -- ogeneraliserad..av.1
  ogeneraliserbar_1_A = mkA "ogeneraliserbar" ; -- ogeneraliserbar..av.1
  ogeneraliserbarhet_1_N = mkN "ogeneraliserbarhet" ; -- ogeneraliserbarhet..nn.1
  ogenerbar_1_A = mkA "ogenerbar" ; -- ogenerbar..av.1
  ogenerbarhet_1_N = mkN "ogenerbarhet" ; -- ogenerbarhet..nn.1
  ogenererad_1_A = mkA "ogenererad" ; -- ogenererad..av.1
  ogenererbar_1_A = mkA "ogenererbar" ; -- ogenererbar..av.1
  ogenererbarhet_1_N = mkN "ogenererbarhet" ; -- ogenererbarhet..nn.1
  ogengäldad_1_A = mkA "ogengäldad" ; -- ogengäldad..av.1
  ogenomarbetad_1_A = mkA "ogenomarbetad" ; -- ogenomarbetad..av.1
  ogenomborrad_1_A = mkA "ogenomborrad" ; -- ogenomborrad..av.1
  ogenomförbar_1_A = mkA "ogenomförbar" ; -- ogenomförbar..av.1
  ogenomförbarhet_1_N = mkN "ogenomförbarhet" ; -- ogenomförbarhet..nn.1
  ogenomförd_1_A = mkA "ogenomförd" "ogenomfört" ; -- ogenomförd..av.1
  ogenomkorsad_1_A = mkA "ogenomkorsad" ; -- ogenomkorsad..av.1
  ogenomlyst_1_A = mkA "ogenomlyst" "ogenomlyst" ; -- ogenomlyst..av.1
  ogenomsipprad_1_A = mkA "ogenomsipprad" ; -- ogenomsipprad..av.1
  ogenomskinlig_1_A = mkA "ogenomskinlig" ; -- ogenomskinlig..av.1
  ogenomskinlighet_1_N = mkN "ogenomskinlighet" ; -- ogenomskinlighet..nn.1
  ogenomskådad_1_A = mkA "ogenomskådad" ; -- ogenomskådad..av.1
  ogenomskådlig_1_A = mkA "ogenomskådlig" ; -- ogenomskådlig..av.1
  ogenomskådlighet_1_N = mkN "ogenomskådlighet" ; -- ogenomskådlighet..nn.1
  ogenomsköljd_1_A = mkA "ogenomsköljd" "ogenomsköljt" ; -- ogenomsköljd..av.1
  ogenomsläpplig_1_A = mkA "ogenomsläpplig" ; -- ogenomsläpplig..av.1
  ogenomsläpplighet_1_N = mkN "ogenomsläpplighet" ; -- ogenomsläpplighet..nn.1
  ogenomströmmad_1_A = mkA "ogenomströmmad" ; -- ogenomströmmad..av.1
  ogenomsyrad_1_A = mkA "ogenomsyrad" ; -- ogenomsyrad..av.1
  ogenomsökt_1_A = mkA "ogenomsökt" "ogenomsökt" ; -- ogenomsökt..av.1
  ogenomträngd_1_A = mkA "ogenomträngd" "ogenomträngt" ; -- ogenomträngd..av.1
  ogenomtränglig_1_A = mkA "ogenomtränglig" ; -- ogenomtränglig..av.1
  ogenomtränglighet_1_N = mkN "ogenomtränglighet" ; -- ogenomtränglighet..nn.1
  ogenomtänkt_1_A = mkA "ogenomtänkt" "ogenomtänkt" ; -- ogenomtänkt..av.1
  ogenomtänkthet_1_N = mkN "ogenomtänkthet" ; -- ogenomtänkthet..nn.1
  ogensäglig_1_A = mkA "ogensäglig" ; -- ogensäglig..av.1
  ogensäglighet_1_N = mkN "ogensäglighet" ; -- ogensäglighet..nn.1
  ogeometriserad_1_A = mkA "ogeometriserad" ; -- ogeometriserad..av.1
  ogeometriserbar_1_A = mkA "ogeometriserbar" ; -- ogeometriserbar..av.1
  ogeometriserbarhet_1_N = mkN "ogeometriserbarhet" ; -- ogeometriserbarhet..nn.1
  ogeotaggad_1_A = mkA "ogeotaggad" ; -- ogeotaggad..av.1
  ogermaniserad_1_A = mkA "ogermaniserad" ; -- ogermaniserad..av.1
  ogermaniserbar_1_A = mkA "ogermaniserbar" ; -- ogermaniserbar..av.1
  ogermaniserbarhet_1_N = mkN "ogermaniserbarhet" ; -- ogermaniserbarhet..nn.1
  ogestaltad_1_A = mkA "ogestaltad" ; -- ogestaltad..av.1
  ogift_1_A = mkA "ogift" "ogift" ; -- ogift..av.1
  ogiftig_1_A = mkA "ogiftig" ; -- ogiftig..av.1
  ogiftighet_1_N = mkN "ogiftighet" ; -- ogiftighet..nn.1
  ogigad_1_A = mkA "ogigad" ; -- ogigad..av.1
  ogiljotinerad_1_A = mkA "ogiljotinerad" ; -- ogiljotinerad..av.1
  ogiljotinerbar_1_A = mkA "ogiljotinerbar" ; -- ogiljotinerbar..av.1
  ogiljotinerbarhet_1_N = mkN "ogiljotinerbarhet" ; -- ogiljotinerbarhet..nn.1
  ogill_1_A = mkA "ogill" ; -- ogill..av.1
  ogilla_1_V = mkV "ogillar" ; -- ogilla..vb.1
  ogillad_1_A = mkA "ogillad" ; -- ogillad..av.1
  ogillande_1_N = mkN "ogillande" ; -- ogillande..nn.1
  ogillhet_1_N = mkN "ogillhet" ; -- ogillhet..nn.1
  ogillrad_1_A = mkA "ogillrad" ; -- ogillrad..av.1
  ogiltig_1_A = mkA "ogiltig" ; -- ogiltig..av.1
  ogiltigförklara_1_V = mkV "ogiltigförklarar" ; -- ogiltigförklara..vb.1
  ogiltigförklarad_1_A = mkA "ogiltigförklarad" ; -- ogiltigförklarad..av.1
  ogiltigförklarande_1_N = mkN "ogiltigförklarande" ; -- ogiltigförklarande..nn.1
  ogiltigförklarning_1_N = mkN "ogiltigförklarning" ; -- ogiltigförklarning..nn.1
  ogiltighet_1_N = mkN "ogiltighet" ; -- ogiltighet..nn.1
  ogin_1_A = mkA "ogin" ; -- ogin..av.1
  oginhet_1_N = mkN "oginhet" "oginheter" ; -- oginhet..nn.1
  ogipsad_1_A = mkA "ogipsad" ; -- ogipsad..av.1
  ogirerad_1_A = mkA "ogirerad" ; -- ogirerad..av.1
  ogirerbar_1_A = mkA "ogirerbar" ; -- ogirerbar..av.1
  ogirerbarhet_1_N = mkN "ogirerbarhet" ; -- ogirerbarhet..nn.1
  ogissad_1_A = mkA "ogissad" ; -- ogissad..av.1
  ogisslad_1_A = mkA "ogisslad" ; -- ogisslad..av.1
  ogistad_1_A = mkA "ogistad" ; -- ogistad..av.1
  ogjord_1_A = mkA "ogjord" "ogjort" ; -- ogjord..av.1
  ogjordad_1_A = mkA "ogjordad" ; -- ogjordad..av.1
  oglamoriserad_1_A = mkA "oglamoriserad" ; -- oglamoriserad..av.1
  oglamoriserbar_1_A = mkA "oglamoriserbar" ; -- oglamoriserbar..av.1
  oglamoriserbarhet_1_N = mkN "oglamoriserbarhet" ; -- oglamoriserbarhet..nn.1
  oglamorös_1_A = mkA "oglamorös" ; -- oglamorös..av.1
  oglamouriserad_1_A = mkA "oglamouriserad" ; -- oglamouriserad..av.1
  oglamouriserbar_1_A = mkA "oglamouriserbar" ; -- oglamouriserbar..av.1
  oglamouriserbarhet_1_N = mkN "oglamouriserbarhet" ; -- oglamouriserbarhet..nn.1
  oglamourös_1_A = mkA "oglamourös" ; -- oglamourös..av.1
  oglansad_1_A = mkA "oglansad" ; -- oglansad..av.1
  oglanskad_1_A = mkA "oglanskad" ; -- oglanskad..av.1
  oglasad_1_A = mkA "oglasad" ; -- oglasad..av.1
  oglaserad_1_A = mkA "oglaserad" ; -- oglaserad..av.1
  oglaserbar_1_A = mkA "oglaserbar" ; -- oglaserbar..av.1
  oglaserbarhet_1_N = mkN "oglaserbarhet" ; -- oglaserbarhet..nn.1
  oglattad_1_A = mkA "oglattad" ; -- oglattad..av.1
  oglesad_1_A = mkA "oglesad" ; -- oglesad..av.1
  oglesnad_1_A = mkA "oglesnad" ; -- oglesnad..av.1
  oglorifierad_1_A = mkA "oglorifierad" ; -- oglorifierad..av.1
  oglorifierbar_1_A = mkA "oglorifierbar" ; -- oglorifierbar..av.1
  oglorifierbarhet_1_N = mkN "oglorifierbarhet" ; -- oglorifierbarhet..nn.1
  ogläntad_1_A = mkA "ogläntad" ; -- ogläntad..av.1
  oglättad_1_A = mkA "oglättad" ; -- oglättad..av.1
  oglödgad_1_A = mkA "oglödgad" ; -- oglödgad..av.1
  oglömd_1_A = mkA "oglömd" "oglömt" ; -- oglömd..av.1
  ognagd_1_A = mkA "ognagd" "ognagt" ; -- ognagd..av.1
  ognavd_1_A = mkA "ognavd" "ognavt" ; -- ognavd..av.1
  ognistad_1_A = mkA "ognistad" ; -- ognistad..av.1
  ognolad_1_A = mkA "ognolad" ; -- ognolad..av.1
  ognuggad_1_A = mkA "ognuggad" ; -- ognuggad..av.1
  ogodkänd_1_A = mkA "ogodkänd" ; -- ogodkänd..av.1
  ogoffrerad_1_A = mkA "ogoffrerad" ; -- ogoffrerad..av.1
  ogoffrerbar_1_A = mkA "ogoffrerbar" ; -- ogoffrerbar..av.1
  ogoffrerbarhet_1_N = mkN "ogoffrerbarhet" ; -- ogoffrerbarhet..nn.1
  ogolvad_1_A = mkA "ogolvad" ; -- ogolvad..av.1
  ogooglad_1_A = mkA "ogooglad" ; -- ogooglad..av.1
  ogouterad_1_A = mkA "ogouterad" ; -- ogouterad..av.1
  ogouterbar_1_A = mkA "ogouterbar" ; -- ogouterbar..av.1
  ogouterbarhet_1_N = mkN "ogouterbarhet" ; -- ogouterbarhet..nn.1
  ograbbad_1_A = mkA "ograbbad" ; -- ograbbad..av.1
  ogradad_1_A = mkA "ogradad" ; -- ogradad..av.1
  ograderad_1_A = mkA "ograderad" ; -- ograderad..av.1
  ograderbar_1_A = mkA "ograderbar" ; -- ograderbar..av.1
  ograderbarhet_1_N = mkN "ograderbarhet" ; -- ograderbarhet..nn.1
  ograduerad_1_A = mkA "ograduerad" ; -- ograduerad..av.1
  ograduerbar_1_A = mkA "ograduerbar" ; -- ograduerbar..av.1
  ograduerbarhet_1_N = mkN "ograduerbarhet" ; -- ograduerbarhet..nn.1
  ografiterad_1_A = mkA "ografiterad" ; -- ografiterad..av.1
  ografiterbar_1_A = mkA "ografiterbar" ; -- ografiterbar..av.1
  ografiterbarhet_1_N = mkN "ografiterbarhet" ; -- ografiterbarhet..nn.1
  ogrammatikalisk_1_A = mkA "ogrammatikalisk" ; -- ogrammatikalisk..av.1
  ogrammatisk_1_A = mkA "ogrammatisk" ; -- ogrammatisk..av.1
  ogranskad_1_A = mkA "ogranskad" ; -- ogranskad..av.1
  ogranulerad_1_A = mkA "ogranulerad" ; -- ogranulerad..av.1
  ogranulerbar_1_A = mkA "ogranulerbar" ; -- ogranulerbar..av.1
  ogranulerbarhet_1_N = mkN "ogranulerbarhet" ; -- ogranulerbarhet..nn.1
  ogratinerad_1_A = mkA "ogratinerad" ; -- ogratinerad..av.1
  ogratinerbar_1_A = mkA "ogratinerbar" ; -- ogratinerbar..av.1
  ogratinerbarhet_1_N = mkN "ogratinerbarhet" ; -- ogratinerbarhet..nn.1
  ograttad_1_A = mkA "ograttad" ; -- ograttad..av.1
  ogratulerad_1_A = mkA "ogratulerad" ; -- ogratulerad..av.1
  ogratulerbar_1_A = mkA "ogratulerbar" ; -- ogratulerbar..av.1
  ogratulerbarhet_1_N = mkN "ogratulerbarhet" ; -- ogratulerbarhet..nn.1
  ogravad_1_A = mkA "ogravad" ; -- ogravad..av.1
  ograverad_1_A = mkA "ograverad" ; -- ograverad..av.1
  ograverbar_1_A = mkA "ograverbar" ; -- ograverbar..av.1
  ograverbarhet_1_N = mkN "ograverbarhet" ; -- ograverbarhet..nn.1
  ogrejad_1_A = mkA "ogrejad" ; -- ogrejad..av.1
  ogrenad_1_A = mkA "ogrenad" ; -- ogrenad..av.1
  ogrenslad_1_A = mkA "ogrenslad" ; -- ogrenslad..av.1
  ogreppad_1_A = mkA "ogreppad" ; -- ogreppad..av.1
  ogriljerad_1_A = mkA "ogriljerad" ; -- ogriljerad..av.1
  ogriljerbar_1_A = mkA "ogriljerbar" ; -- ogriljerbar..av.1
  ogriljerbarhet_1_N = mkN "ogriljerbarhet" ; -- ogriljerbarhet..nn.1
  ogrillad_1_A = mkA "ogrillad" ; -- ogrillad..av.1
  ogrimerad_1_A = mkA "ogrimerad" ; -- ogrimerad..av.1
  ogrimerbar_1_A = mkA "ogrimerbar" ; -- ogrimerbar..av.1
  ogrimerbarhet_1_N = mkN "ogrimerbarhet" ; -- ogrimerbarhet..nn.1
  ogripbar_1_A = mkA "ogripbar" ; -- ogripbar..av.1
  ogripbarhet_1_N = mkN "ogripbarhet" ; -- ogripbarhet..nn.1
  ogrobarhet_1_N = mkN "ogrobarhet" ; -- ogrobarhet..nn.1
  ogroddad_1_A = mkA "ogroddad" ; -- ogroddad..av.1
  ogrumlad_1_A = mkA "ogrumlad" ; -- ogrumlad..av.1
  ogrumsad_1_A = mkA "ogrumsad" ; -- ogrumsad..av.1
  ogrundad_1_A = mkA "ogrundad" ; -- ogrundad..av.1
  ogrunderad_1_A = mkA "ogrunderad" ; -- ogrunderad..av.1
  ogrunderbar_1_A = mkA "ogrunderbar" ; -- ogrunderbar..av.1
  ogrunderbarhet_1_N = mkN "ogrunderbarhet" ; -- ogrunderbarhet..nn.1
  ogrupperad_1_A = mkA "ogrupperad" ; -- ogrupperad..av.1
  ogrupperbar_1_A = mkA "ogrupperbar" ; -- ogrupperbar..av.1
  ogrupperbarhet_1_N = mkN "ogrupperbarhet" ; -- ogrupperbarhet..nn.1
  ogrusad_1_A = mkA "ogrusad" ; -- ogrusad..av.1
  ogräddad_1_A = mkA "ogräddad" ; -- ogräddad..av.1
  ogräftad_1_A = mkA "ogräftad" ; -- ogräftad..av.1
  ogränslad_1_A = mkA "ogränslad" ; -- ogränslad..av.1
  ogräs_1_N = mkN "ogräs" neutrum  ; -- ogräs..nn.1
  ogräsbekämpad_1_A = mkA "ogräsbekämpad" ; -- ogräsbekämpad..av.1
  ogräsbekämpning_1_N = mkN "ogräsbekämpning" ; -- ogräsbekämpning..nn.1
  ogräsfisk_1_N = mkN "ogräsfisk" ; -- ogräsfisk..nn.1
  ogrävd_1_A = mkA "ogrävd" "ogrävt" ; -- ogrävd..av.1
  ogrånad_1_A = mkA "ogrånad" ; -- ogrånad..av.1
  ogröpad_1_A = mkA "ogröpad" ; -- ogröpad..av.1
  ogudaktig_1_A = mkA "ogudaktig" ; -- ogudaktig..av.1
  ogudaktighet_1_N = mkN "ogudaktighet" ; -- ogudaktighet..nn.1
  ogudlig_1_A = mkA "ogudlig" ; -- ogudlig..av.1
  ogudlighet_1_N = mkN "ogudlighet" ; -- ogudlighet..nn.1
  oguidad_1_A = mkA "oguidad" ; -- oguidad..av.1
  ogulden_1_A = mkA "ogulden" ; -- ogulden..av.1
  ogulnad_1_A = mkA "ogulnad" ; -- ogulnad..av.1
  ogummerad_1_A = mkA "ogummerad" ; -- ogummerad..av.1
  ogummerbar_1_A = mkA "ogummerbar" ; -- ogummerbar..av.1
  ogummerbarhet_1_N = mkN "ogummerbarhet" ; -- ogummerbarhet..nn.1
  ogungad_1_A = mkA "ogungad" ; -- ogungad..av.1
  ogunstig_1_A = mkA "ogunstig" ; -- ogunstig..av.1
  ogunstighet_1_N = mkN "ogunstighet" ; -- ogunstighet..nn.1
  ogurglad_1_A = mkA "ogurglad" ; -- ogurglad..av.1
  oguskad_1_A = mkA "oguskad" ; -- oguskad..av.1
  oguterad_1_A = mkA "oguterad" ; -- oguterad..av.1
  oguterbar_1_A = mkA "oguterbar" ; -- oguterbar..av.1
  oguterbarhet_1_N = mkN "oguterbarhet" ; -- oguterbarhet..nn.1
  ogymnastiserad_1_A = mkA "ogymnastiserad" ; -- ogymnastiserad..av.1
  ogymnastiserbar_1_A = mkA "ogymnastiserbar" ; -- ogymnastiserbar..av.1
  ogymnastiserbarhet_1_N = mkN "ogymnastiserbarhet" ; -- ogymnastiserbarhet..nn.1
  ogynnad_1_A = mkA "ogynnad" ; -- ogynnad..av.1
  ogynnsam_1_A = mkA "ogynnsam" "ogynnsamt" "ogynnsamma" "ogynnsamma" "ogynnsammare" "ogynnsammast" "ogynnsammaste" ; -- ogynnsam..av.1
  ogynnsamhet_1_N = mkN "ogynnsamhet" ; -- ogynnsamhet..nn.1
  ogäckad_1_A = mkA "ogäckad" ; -- ogäckad..av.1
  ogälad_1_A = mkA "ogälad" ; -- ogälad..av.1
  ogängad_1_A = mkA "ogängad" ; -- ogängad..av.1
  ogärdad_1_A = mkA "ogärdad" ; -- ogärdad..av.1
  ogärdslad_1_A = mkA "ogärdslad" ; -- ogärdslad..av.1
  ogärning_1_N = mkN "ogärning" ; -- ogärning..nn.1
  ogärningsman_1_N = mkN "ogärningsman" "ogärningsmannen" "ogärningsmän" "ogärningsmännen" ; -- ogärningsman..nn.1
  ogästad_1_A = mkA "ogästad" ; -- ogästad..av.1
  ogästvänlig_1_A = mkA "ogästvänlig" ; -- ogästvänlig..av.1
  ogästvänlighet_1_N = mkN "ogästvänlighet" ; -- ogästvänlighet..nn.1
  ogångrad_1_A = mkA "ogångrad" ; -- ogångrad..av.1
  ogödslad_1_A = mkA "ogödslad" ; -- ogödslad..av.1
  ogökad_1_A = mkA "ogökad" ; -- ogökad..av.1
  ogömd_1_A = mkA "ogömd" "ogömt" ; -- ogömd..av.1
  ogörbar_1_A = mkA "ogörbar" ; -- ogörbar..av.1
  ogörbarhet_1_N = mkN "ogörbarhet" ; -- ogörbarhet..nn.1
  ogördlad_1_A = mkA "ogördlad" ; -- ogördlad..av.1
  ogörlig_1_A = mkA "ogörlig" ; -- ogörlig..av.1
  ogörlighet_1_N = mkN "ogörlighet" ; -- ogörlighet..nn.1
  ohackad_1_A = mkA "ohackad" ; -- ohackad..av.1
  ohaffad_1_A = mkA "ohaffad" ; -- ohaffad..av.1
  ohajad_1_A = mkA "ohajad" ; -- ohajad..av.1
  ohakad_1_A = mkA "ohakad" ; -- ohakad..av.1
  ohalad_1_A = mkA "ohalad" ; -- ohalad..av.1
  ohallucinerad_1_A = mkA "ohallucinerad" ; -- ohallucinerad..av.1
  ohallucinerbar_1_A = mkA "ohallucinerbar" ; -- ohallucinerbar..av.1
  ohallucinerbarhet_1_N = mkN "ohallucinerbarhet" ; -- ohallucinerbarhet..nn.1
  ohalsad_1_A = mkA "ohalsad" ; -- ohalsad..av.1
  ohalstrad_1_A = mkA "ohalstrad" ; -- ohalstrad..av.1
  ohalverad_1_A = mkA "ohalverad" ; -- ohalverad..av.1
  ohalverbar_1_A = mkA "ohalverbar" ; -- ohalverbar..av.1
  ohalverbarhet_1_N = mkN "ohalverbarhet" ; -- ohalverbarhet..nn.1
  ohamlad_1_A = mkA "ohamlad" ; -- ohamlad..av.1
  ohamrad_1_A = mkA "ohamrad" ; -- ohamrad..av.1
  ohamstrad_1_A = mkA "ohamstrad" ; -- ohamstrad..av.1
  ohandikappad_1_A = mkA "ohandikappad" ; -- ohandikappad..av.1
  ohandlad_1_A = mkA "ohandlad" ; -- ohandlad..av.1
  ohanterad_1_A = mkA "ohanterad" ; -- ohanterad..av.1
  ohanterbar_1_A = mkA "ohanterbar" ; -- ohanterbar..av.1
  ohanterbarhet_1_N = mkN "ohanterbarhet" ; -- ohanterbarhet..nn.1
  ohanterlig_1_A = mkA "ohanterlig" ; -- ohanterlig..av.1
  ohanterlighet_1_N = mkN "ohanterlighet" ; -- ohanterlighet..nn.1
  oharangerad_1_A = mkA "oharangerad" ; -- oharangerad..av.1
  oharangerbar_1_A = mkA "oharangerbar" ; -- oharangerbar..av.1
  oharangerbarhet_1_N = mkN "oharangerbarhet" ; -- oharangerbarhet..nn.1
  oharmad_1_A = mkA "oharmad" ; -- oharmad..av.1
  oharmoniserad_1_A = mkA "oharmoniserad" ; -- oharmoniserad..av.1
  oharmoniserbar_1_A = mkA "oharmoniserbar" ; -- oharmoniserbar..av.1
  oharmoniserbarhet_1_N = mkN "oharmoniserbarhet" ; -- oharmoniserbarhet..nn.1
  oharmonisk_1_A = mkA "oharmonisk" ; -- oharmonisk..av.1
  oharpunerad_1_A = mkA "oharpunerad" ; -- oharpunerad..av.1
  oharpunerbar_1_A = mkA "oharpunerbar" ; -- oharpunerbar..av.1
  oharpunerbarhet_1_N = mkN "oharpunerbarhet" ; -- oharpunerbarhet..nn.1
  ohartsad_1_A = mkA "ohartsad" ; -- ohartsad..av.1
  oharvad_1_A = mkA "oharvad" ; -- oharvad..av.1
  ohasad_1_A = mkA "ohasad" ; -- ohasad..av.1
  ohasarderad_1_A = mkA "ohasarderad" ; -- ohasarderad..av.1
  ohasarderbar_1_A = mkA "ohasarderbar" ; -- ohasarderbar..av.1
  ohasarderbarhet_1_N = mkN "ohasarderbarhet" ; -- ohasarderbarhet..nn.1
  ohaspad_1_A = mkA "ohaspad" ; -- ohaspad..av.1
  ohasplad_1_A = mkA "ohasplad" ; -- ohasplad..av.1
  ohatad_1_A = mkA "ohatad" ; -- ohatad..av.1
  ohaussad_1_A = mkA "ohaussad" ; -- ohaussad..av.1
  ohavererad_1_A = mkA "ohavererad" ; -- ohavererad..av.1
  ohavererbar_1_A = mkA "ohavererbar" ; -- ohavererbar..av.1
  ohavererbarhet_1_N = mkN "ohavererbarhet" ; -- ohavererbarhet..nn.1
  ohederlig_1_A = mkA "ohederlig" ; -- ohederlig..av.1
  ohederlighet_1_N = mkN "ohederlighet" "ohederligheter" ; -- ohederlighet..nn.1
  ohedrad_1_A = mkA "ohedrad" ; -- ohedrad..av.1
  ohejad_1_A = mkA "ohejad" ; -- ohejad..av.1
  ohejdad_1_A = mkA "ohejdad" ; -- ohejdad..av.1
  ohejdbar_1_A = mkA "ohejdbar" ; -- ohejdbar..av.1
  ohektograferbar_1_A = mkA "ohektograferbar" ; -- ohektograferbar..av.1
  ohektograferbarhet_1_N = mkN "ohektograferbarhet" ; -- ohektograferbarhet..nn.1
  ohelad_1_A = mkA "ohelad" ; -- ohelad..av.1
  ohelgad_1_A = mkA "ohelgad" ; -- ohelgad..av.1
  ohelig_1_A = mkA "ohelig" ; -- ohelig..av.1
  ohelighet_1_N = mkN "ohelighet" ; -- ohelighet..nn.1
  ohemsökt_1_A = mkA "ohemsökt" "ohemsökt" ; -- ohemsökt..av.1
  ohemul_1_A = mkA "ohemul" ; -- ohemul..av.1
  ohenad_1_A = mkA "ohenad" ; -- ohenad..av.1
  oheroiserad_1_A = mkA "oheroiserad" ; -- oheroiserad..av.1
  oheroiserbar_1_A = mkA "oheroiserbar" ; -- oheroiserbar..av.1
  oheroiserbarhet_1_N = mkN "oheroiserbarhet" ; -- oheroiserbarhet..nn.1
  oherrans_1_A = mkA "oherrans" ; -- oherrans..av.1
  ohetsad_1_A = mkA "ohetsad" ; -- ohetsad..av.1
  ohindrad_1_A = mkA "ohindrad" ; -- ohindrad..av.1
  ohinkad_1_A = mkA "ohinkad" ; -- ohinkad..av.1
  ohissad_1_A = mkA "ohissad" ; -- ohissad..av.1
  ohistorierad_1_A = mkA "ohistorierad" ; -- ohistorierad..av.1
  ohistorierbar_1_A = mkA "ohistorierbar" ; -- ohistorierbar..av.1
  ohistorierbarhet_1_N = mkN "ohistorierbarhet" ; -- ohistorierbarhet..nn.1
  ohistoriserad_1_A = mkA "ohistoriserad" ; -- ohistoriserad..av.1
  ohistoriserbar_1_A = mkA "ohistoriserbar" ; -- ohistoriserbar..av.1
  ohistoriserbarhet_1_N = mkN "ohistoriserbarhet" ; -- ohistoriserbarhet..nn.1
  ohistorisk_1_A = mkA "ohistorisk" ; -- ohistorisk..av.1
  ohittad_1_A = mkA "ohittad" ; -- ohittad..av.1
  ohivad_1_A = mkA "ohivad" ; -- ohivad..av.1
  ohjälplig_1_A = mkA "ohjälplig" ; -- ohjälplig..av.1
  ohjälplighet_1_N = mkN "ohjälplighet" ; -- ohjälplighet..nn.1
  ohjälpsam_1_A = mkA "ohjälpsam" ; -- ohjälpsam..av.1
  ohjälpsamhet_1_N = mkN "ohjälpsamhet" ; -- ohjälpsamhet..nn.1
  ohjälpt_1_A = mkA "ohjälpt" "ohjälpt" ; -- ohjälpt..av.1
  ohm_1_N = mkN "ohm" "ohmen" "ohm" "ohmen" ; -- ohm..nn.1
  oholograferad_1_A = mkA "oholograferad" ; -- oholograferad..av.1
  oholograferbar_1_A = mkA "oholograferbar" ; -- oholograferbar..av.1
  oholograferbarhet_1_N = mkN "oholograferbarhet" ; -- oholograferbarhet..nn.1
  ohomogeniserad_1_A = mkA "ohomogeniserad" ; -- ohomogeniserad..av.1
  ohomogeniserbar_1_A = mkA "ohomogeniserbar" ; -- ohomogeniserbar..av.1
  ohomogeniserbarhet_1_N = mkN "ohomogeniserbarhet" ; -- ohomogeniserbarhet..nn.1
  ohonorerad_1_A = mkA "ohonorerad" ; -- ohonorerad..av.1
  ohonorerbar_1_A = mkA "ohonorerbar" ; -- ohonorerbar..av.1
  ohonorerbarhet_1_N = mkN "ohonorerbarhet" ; -- ohonorerbarhet..nn.1
  ohopad_1_A = mkA "ohopad" ; -- ohopad..av.1
  ohopdiktad_1_A = mkA "ohopdiktad" ; -- ohopdiktad..av.1
  ohopfogad_1_A = mkA "ohopfogad" ; -- ohopfogad..av.1
  ohoplappad_1_A = mkA "ohoplappad" ; -- ohoplappad..av.1
  ohoppad_1_A = mkA "ohoppad" ; -- ohoppad..av.1
  ohospitaliserad_1_A = mkA "ohospitaliserad" ; -- ohospitaliserad..av.1
  ohospitaliserbar_1_A = mkA "ohospitaliserbar" ; -- ohospitaliserbar..av.1
  ohospitaliserbarhet_1_N = mkN "ohospitaliserbarhet" ; -- ohospitaliserbarhet..nn.1
  ohostad_1_A = mkA "ohostad" ; -- ohostad..av.1
  ohotad_1_A = mkA "ohotad" ; -- ohotad..av.1
  ohottad_1_A = mkA "ohottad" ; -- ohottad..av.1
  ohuggen_1_A = mkA "ohuggen" ; -- ohuggen..av.1
  ohugnad_1_A = mkA "ohugnad" ; -- ohugnad..av.1
  ohumaniserad_1_A = mkA "ohumaniserad" ; -- ohumaniserad..av.1
  ohumaniserbar_1_A = mkA "ohumaniserbar" ; -- ohumaniserbar..av.1
  ohumaniserbarhet_1_N = mkN "ohumaniserbarhet" ; -- ohumaniserbarhet..nn.1
  ohundsad_1_A = mkA "ohundsad" ; -- ohundsad..av.1
  ohundsfotterad_1_A = mkA "ohundsfotterad" ; -- ohundsfotterad..av.1
  ohundsfotterbar_1_A = mkA "ohundsfotterbar" ; -- ohundsfotterbar..av.1
  ohundsfotterbarhet_1_N = mkN "ohundsfotterbarhet" ; -- ohundsfotterbarhet..nn.1
  ohunsad_1_A = mkA "ohunsad" ; -- ohunsad..av.1
  ohuserad_1_A = mkA "ohuserad" ; -- ohuserad..av.1
  ohuserbar_1_A = mkA "ohuserbar" ; -- ohuserbar..av.1
  ohuserbarhet_1_N = mkN "ohuserbarhet" ; -- ohuserbarhet..nn.1
  ohybridiserad_1_A = mkA "ohybridiserad" ; -- ohybridiserad..av.1
  ohybridiserbar_1_A = mkA "ohybridiserbar" ; -- ohybridiserbar..av.1
  ohybridiserbarhet_1_N = mkN "ohybridiserbarhet" ; -- ohybridiserbarhet..nn.1
  ohycklad_1_A = mkA "ohycklad" ; -- ohycklad..av.1
  ohydrerad_1_A = mkA "ohydrerad" ; -- ohydrerad..av.1
  ohydrerbar_1_A = mkA "ohydrerbar" ; -- ohydrerbar..av.1
  ohydrerbarhet_1_N = mkN "ohydrerbarhet" ; -- ohydrerbarhet..nn.1
  ohyfsad_1_A = mkA "ohyfsad" ; -- ohyfsad..av.1
  ohygglig_1_A = mkA "ohygglig" ; -- ohygglig..av.1
  ohygglighet_1_N = mkN "ohygglighet" "ohyggligheter" ; -- ohygglighet..nn.1
  ohygienisk_1_A = mkA "ohygienisk" ; -- ohygienisk..av.1
  ohyllad_1_A = mkA "ohyllad" ; -- ohyllad..av.1
  ohypnotiserad_1_A = mkA "ohypnotiserad" ; -- ohypnotiserad..av.1
  ohypnotiserbar_1_A = mkA "ohypnotiserbar" ; -- ohypnotiserbar..av.1
  ohypnotiserbarhet_1_N = mkN "ohypnotiserbarhet" ; -- ohypnotiserbarhet..nn.1
  ohypotiserad_1_A = mkA "ohypotiserad" ; -- ohypotiserad..av.1
  ohypotiserbar_1_A = mkA "ohypotiserbar" ; -- ohypotiserbar..av.1
  ohypotiserbarhet_1_N = mkN "ohypotiserbarhet" ; -- ohypotiserbarhet..nn.1
  ohyra_1_N = mkN "ohyra" ; -- ohyra..nn.1
  ohyrd_1_A = mkA "ohyrd" "ohyrt" ; -- ohyrd..av.1
  ohysbar_1_A = mkA "ohysbar" ; -- ohysbar..av.1
  ohysbarhet_1_N = mkN "ohysbarhet" ; -- ohysbarhet..nn.1
  ohyssjad_1_A = mkA "ohyssjad" ; -- ohyssjad..av.1
  ohyst_1_A = mkA "ohyst" "ohyst" ; -- ohyst..av.1
  ohystad_1_A = mkA "ohystad" ; -- ohystad..av.1
  ohyvad_1_A = mkA "ohyvad" ; -- ohyvad..av.1
  ohyvlad_1_A = mkA "ohyvlad" ; -- ohyvlad..av.1
  ohäcklad_1_A = mkA "ohäcklad" ; -- ohäcklad..av.1
  ohädankallad_1_A = mkA "ohädankallad" ; -- ohädankallad..av.1
  ohäftad_1_A = mkA "ohäftad" ; -- ohäftad..av.1
  ohägn_1_N = mkN "ohägn" neutrum  ; -- ohägn..nn.1
  ohägnad_1_A = mkA "ohägnad" ; -- ohägnad..av.1
  ohäktad_1_A = mkA "ohäktad" ; -- ohäktad..av.1
  ohälld_1_A = mkA "ohälld" "ohällt" ; -- ohälld..av.1
  ohälsa_1_N = mkN "ohälsa" ; -- ohälsa..nn.1
  ohälsad_1_A = mkA "ohälsad" ; -- ohälsad..av.1
  ohälsosam_1_A = mkA "ohälsosam" "ohälsosamt" "ohälsosamma" "ohälsosamma" "ohälsosammare" "ohälsosammast" "ohälsosammaste" ; -- ohälsosam..av.1
  ohälsosamhet_1_N = mkN "ohälsosamhet" ; -- ohälsosamhet..nn.1
  ohälsotal_1_N = mkN "ohälsotal" neutrum  ; -- ohälsotal..nn.1
  ohämmad_1_A = mkA "ohämmad" ; -- ohämmad..av.1
  ohämnad_1_A = mkA "ohämnad" ; -- ohämnad..av.1
  ohämtad_1_A = mkA "ohämtad" ; -- ohämtad..av.1
  ohänförd_1_A = mkA "ohänförd" "ohänfört" ; -- ohänförd..av.1
  ohängd_1_A = mkA "ohängd" "ohängt" ; -- ohängd..av.1
  ohängdhet_1_N = mkN "ohängdhet" ; -- ohängdhet..nn.1
  ohänryckt_1_A = mkA "ohänryckt" "ohänryckt" ; -- ohänryckt..av.1
  ohänvisad_1_A = mkA "ohänvisad" ; -- ohänvisad..av.1
  ohärbärgerad_1_A = mkA "ohärbärgerad" ; -- ohärbärgerad..av.1
  ohärbärgerbar_1_A = mkA "ohärbärgerbar" ; -- ohärbärgerbar..av.1
  ohärbärgerbarhet_1_N = mkN "ohärbärgerbarhet" ; -- ohärbärgerbarhet..nn.1
  ohärdad_1_A = mkA "ohärdad" ; -- ohärdad..av.1
  ohärjad_1_A = mkA "ohärjad" ; -- ohärjad..av.1
  ohärmad_1_A = mkA "ohärmad" ; -- ohärmad..av.1
  ohärmbar_1_A = mkA "ohärmbar" ; -- ohärmbar..av.1
  ohärmbarhet_1_N = mkN "ohärmbarhet" "ohärmbarheter" ; -- ohärmbarhet..nn.1
  ohärsknad_1_A = mkA "ohärsknad" ; -- ohärsknad..av.1
  ohässjad_1_A = mkA "ohässjad" ; -- ohässjad..av.1
  ohävd_1_A = mkA "ohävd" "ohävt" ; -- ohävd..av.1
  ohävdad_1_A = mkA "ohävdad" ; -- ohävdad..av.1
  ohågad_1_A = mkA "ohågad" ; -- ohågad..av.1
  ohålad_1_A = mkA "ohålad" ; -- ohålad..av.1
  ohållbar_1_A = mkA "ohållbar" ; -- ohållbar..av.1
  ohållbarhet_1_N = mkN "ohållbarhet" "ohållbarheter" ; -- ohållbarhet..nn.1
  ohånad_1_A = mkA "ohånad" ; -- ohånad..av.1
  ohårdnad_1_A = mkA "ohårdnad" ; -- ohårdnad..av.1
  ohåvad_1_A = mkA "ohåvad" ; -- ohåvad..av.1
  ohögaktad_1_A = mkA "ohögaktad" ; -- ohögaktad..av.1
  ohöjd_1_A = mkA "ohöjd" "ohöjt" ; -- ohöjd..av.1
  ohöljd_1_A = mkA "ohöljd" "ohöljt" ; -- ohöljd..av.1
  ohöljdhet_1_N = mkN "ohöljdhet" ; -- ohöljdhet..nn.1
  ohörbar_1_A = mkA "ohörbar" ; -- ohörbar..av.1
  ohörbarhet_1_N = mkN "ohörbarhet" "ohörbarheter" ; -- ohörbarhet..nn.1
  ohörd_1_A = mkA "ohörd" "ohört" ; -- ohörd..av.1
  ohörsam_1_A = mkA "ohörsam" "ohörsamt" "ohörsamma" "ohörsamma" "ohörsammare" "ohörsammast" "ohörsammaste" ; -- ohörsam..av.1
  ohörsamhet_1_N = mkN "ohörsamhet" ; -- ohörsamhet..nn.1
  ohörsammad_1_A = mkA "ohörsammad" ; -- ohörsammad..av.1
  ohövisk_1_A = mkA "ohövisk" ; -- ohövisk..av.1
  ohöviskhet_1_N = mkN "ohöviskhet" ; -- ohöviskhet..nn.1
  ohövlig_1_A = mkA "ohövlig" ; -- ohövlig..av.1
  ohövlighet_1_N = mkN "ohövlighet" ; -- ohövlighet..nn.1
  oidealiserad_1_A = mkA "oidealiserad" ; -- oidealiserad..av.1
  oidealiserbar_1_A = mkA "oidealiserbar" ; -- oidealiserbar..av.1
  oidealiserbarhet_1_N = mkN "oidealiserbarhet" ; -- oidealiserbarhet..nn.1
  oidentifierad_1_A = mkA "oidentifierad" ; -- oidentifierad..av.1
  oidentifierbar_1_A = mkA "oidentifierbar" ; -- oidentifierbar..av.1
  oidentifierbarhet_1_N = mkN "oidentifierbarhet" ; -- oidentifierbarhet..nn.1
  oidipal_1_A = mkA "oidipal" ; -- oidipal..av.1
  oidipuskomplex_1_N = mkN "oidipuskomplex" neutrum  ; -- oidipuskomplex..nn.1
  oidisslad_1_A = mkA "oidisslad" ; -- oidisslad..av.1
  oidkad_1_A = mkA "oidkad" ; -- oidkad..av.1
  oigenkännlig_1_A = mkA "oigenkännlig" ; -- oigenkännlig..av.1
  oigenkännlighet_1_N = mkN "oigenkännlighet" ; -- oigenkännlighet..nn.1
  oignorerad_1_A = mkA "oignorerad" ; -- oignorerad..av.1
  oignorerbar_1_A = mkA "oignorerbar" ; -- oignorerbar..av.1
  oignorerbarhet_1_N = mkN "oignorerbarhet" ; -- oignorerbarhet..nn.1
  oilluminerad_1_A = mkA "oilluminerad" ; -- oilluminerad..av.1
  oilluminerbar_1_A = mkA "oilluminerbar" ; -- oilluminerbar..av.1
  oilluminerbarhet_1_N = mkN "oilluminerbarhet" ; -- oilluminerbarhet..nn.1
  oillustrerad_1_A = mkA "oillustrerad" ; -- oillustrerad..av.1
  oillustrerbar_1_A = mkA "oillustrerbar" ; -- oillustrerbar..av.1
  oillustrerbarhet_1_N = mkN "oillustrerbarhet" ; -- oillustrerbarhet..nn.1
  oimiterad_1_A = mkA "oimiterad" ; -- oimiterad..av.1
  oimiterbar_1_A = mkA "oimiterbar" ; -- oimiterbar..av.1
  oimiterbarhet_1_N = mkN "oimiterbarhet" ; -- oimiterbarhet..nn.1
  oimmatrikulerad_1_A = mkA "oimmatrikulerad" ; -- oimmatrikulerad..av.1
  oimmatrikulerbar_1_A = mkA "oimmatrikulerbar" ; -- oimmatrikulerbar..av.1
  oimmatrikulerbarhet_1_N = mkN "oimmatrikulerbarhet" ; -- oimmatrikulerbarhet..nn.1
  oimmigrerad_1_A = mkA "oimmigrerad" ; -- oimmigrerad..av.1
  oimmigrerbar_1_A = mkA "oimmigrerbar" ; -- oimmigrerbar..av.1
  oimmigrerbarhet_1_N = mkN "oimmigrerbarhet" ; -- oimmigrerbarhet..nn.1
  oimmuniserad_1_A = mkA "oimmuniserad" ; -- oimmuniserad..av.1
  oimmuniserbar_1_A = mkA "oimmuniserbar" ; -- oimmuniserbar..av.1
  oimmuniserbarhet_1_N = mkN "oimmuniserbarhet" ; -- oimmuniserbarhet..nn.1
  oimpad_1_A = mkA "oimpad" ; -- oimpad..av.1
  oimplanterad_1_A = mkA "oimplanterad" ; -- oimplanterad..av.1
  oimplanterbar_1_A = mkA "oimplanterbar" ; -- oimplanterbar..av.1
  oimplanterbarhet_1_N = mkN "oimplanterbarhet" ; -- oimplanterbarhet..nn.1
  oimplementerbar_1_A = mkA "oimplementerbar" ; -- oimplementerbar..av.1
  oimplementerbarhet_1_N = mkN "oimplementerbarhet" ; -- oimplementerbarhet..nn.1
  oimplicerad_1_A = mkA "oimplicerad" ; -- oimplicerad..av.1
  oimplicerbar_1_A = mkA "oimplicerbar" ; -- oimplicerbar..av.1
  oimplicerbarhet_1_N = mkN "oimplicerbarhet" ; -- oimplicerbarhet..nn.1
  oimploderad_1_A = mkA "oimploderad" ; -- oimploderad..av.1
  oimploderbar_1_A = mkA "oimploderbar" ; -- oimploderbar..av.1
  oimploderbarhet_1_N = mkN "oimploderbarhet" ; -- oimploderbarhet..nn.1
  oimponerad_1_A = mkA "oimponerad" ; -- oimponerad..av.1
  oimponerbar_1_A = mkA "oimponerbar" ; -- oimponerbar..av.1
  oimponerbarhet_1_N = mkN "oimponerbarhet" ; -- oimponerbarhet..nn.1
  oimporterad_1_A = mkA "oimporterad" ; -- oimporterad..av.1
  oimporterbar_1_A = mkA "oimporterbar" ; -- oimporterbar..av.1
  oimporterbarhet_1_N = mkN "oimporterbarhet" ; -- oimporterbarhet..nn.1
  oimpregnerad_1_A = mkA "oimpregnerad" ; -- oimpregnerad..av.1
  oimpregnerbar_1_A = mkA "oimpregnerbar" ; -- oimpregnerbar..av.1
  oimpregnerbarhet_1_N = mkN "oimpregnerbarhet" ; -- oimpregnerbarhet..nn.1
  oimproviserad_1_A = mkA "oimproviserad" ; -- oimproviserad..av.1
  oimproviserbar_1_A = mkA "oimproviserbar" ; -- oimproviserbar..av.1
  oimproviserbarhet_1_N = mkN "oimproviserbarhet" ; -- oimproviserbarhet..nn.1
  oinackorderad_1_A = mkA "oinackorderad" ; -- oinackorderad..av.1
  oinackorderbar_1_A = mkA "oinackorderbar" ; -- oinackorderbar..av.1
  oinackorderbarhet_1_N = mkN "oinackorderbarhet" ; -- oinackorderbarhet..nn.1
  oinaktiverbar_1_A = mkA "oinaktiverbar" ; -- oinaktiverbar..av.1
  oinaktiverbarhet_1_N = mkN "oinaktiverbarhet" ; -- oinaktiverbarhet..nn.1
  oinarbetad_1_A = mkA "oinarbetad" ; -- oinarbetad..av.1
  oinaugurerad_1_A = mkA "oinaugurerad" ; -- oinaugurerad..av.1
  oinaugurerbar_1_A = mkA "oinaugurerbar" ; -- oinaugurerbar..av.1
  oinaugurerbarhet_1_N = mkN "oinaugurerbarhet" ; -- oinaugurerbarhet..nn.1
  oinbakad_1_A = mkA "oinbakad" ; -- oinbakad..av.1
  oinberäknad_1_A = mkA "oinberäknad" ; -- oinberäknad..av.1
  oinbesparad_1_A = mkA "oinbesparad" ; -- oinbesparad..av.1
  oinbillad_1_A = mkA "oinbillad" ; -- oinbillad..av.1
  oinblandad_1_A = mkA "oinblandad" ; -- oinblandad..av.1
  oinbunden_1_A = mkA "oinbunden" ; -- oinbunden..av.1
  oinbyggd_1_A = mkA "oinbyggd" "oinbyggt" ; -- oinbyggd..av.1
  oindelad_1_A = mkA "oindelad" ; -- oindelad..av.1
  oindexerad_1_A = mkA "oindexerad" ; -- oindexerad..av.1
  oindexerbar_1_A = mkA "oindexerbar" ; -- oindexerbar..av.1
  oindexerbarhet_1_N = mkN "oindexerbarhet" ; -- oindexerbarhet..nn.1
  oindexreglerbar_1_A = mkA "oindexreglerbar" ; -- oindexreglerbar..av.1
  oindexreglerbarhet_1_N = mkN "oindexreglerbarhet" ; -- oindexreglerbarhet..nn.1
  oindicerad_1_A = mkA "oindicerad" ; -- oindicerad..av.1
  oindicerbar_1_A = mkA "oindicerbar" ; -- oindicerbar..av.1
  oindicerbarhet_1_N = mkN "oindicerbarhet" ; -- oindicerbarhet..nn.1
  oindikerad_1_A = mkA "oindikerad" ; -- oindikerad..av.1
  oindikerbar_1_A = mkA "oindikerbar" ; -- oindikerbar..av.1
  oindikerbarhet_1_N = mkN "oindikerbarhet" ; -- oindikerbarhet..nn.1
  oindividualiserad_1_A = mkA "oindividualiserad" ; -- oindividualiserad..av.1
  oindividualiserbar_1_A = mkA "oindividualiserbar" ; -- oindividualiserbar..av.1
  oindividualiserbarhet_1_N = mkN "oindividualiserbarhet" ; -- oindividualiserbarhet..nn.1
  oindoktrinerad_1_A = mkA "oindoktrinerad" ; -- oindoktrinerad..av.1
  oindoktrinerbar_1_A = mkA "oindoktrinerbar" ; -- oindoktrinerbar..av.1
  oindoktrinerbarhet_1_N = mkN "oindoktrinerbarhet" ; -- oindoktrinerbarhet..nn.1
  oindränkt_1_A = mkA "oindränkt" "oindränkt" ; -- oindränkt..av.1
  oinducerad_1_A = mkA "oinducerad" ; -- oinducerad..av.1
  oinducerbar_1_A = mkA "oinducerbar" ; -- oinducerbar..av.1
  oinducerbarhet_1_N = mkN "oinducerbarhet" ; -- oinducerbarhet..nn.1
  oindunstad_1_A = mkA "oindunstad" ; -- oindunstad..av.1
  oindustrialiserad_1_A = mkA "oindustrialiserad" ; -- oindustrialiserad..av.1
  oindustrialiserbar_1_A = mkA "oindustrialiserbar" ; -- oindustrialiserbar..av.1
  oindustrialiserbarhet_1_N = mkN "oindustrialiserbarhet" ; -- oindustrialiserbarhet..nn.1
  oinfantiliserbar_1_A = mkA "oinfantiliserbar" ; -- oinfantiliserbar..av.1
  oinfantiliserbarhet_1_N = mkN "oinfantiliserbarhet" ; -- oinfantiliserbarhet..nn.1
  oinfattad_1_A = mkA "oinfattad" ; -- oinfattad..av.1
  oinfekterad_1_A = mkA "oinfekterad" ; -- oinfekterad..av.1
  oinfekterbar_1_A = mkA "oinfekterbar" ; -- oinfekterbar..av.1
  oinfekterbarhet_1_N = mkN "oinfekterbarhet" ; -- oinfekterbarhet..nn.1
  oinfettad_1_A = mkA "oinfettad" ; -- oinfettad..av.1
  oinfiltrerad_1_A = mkA "oinfiltrerad" ; -- oinfiltrerad..av.1
  oinfiltrerbar_1_A = mkA "oinfiltrerbar" ; -- oinfiltrerbar..av.1
  oinfiltrerbarhet_1_N = mkN "oinfiltrerbarhet" ; -- oinfiltrerbarhet..nn.1
  oinflammerad_1_A = mkA "oinflammerad" ; -- oinflammerad..av.1
  oinflammerbar_1_A = mkA "oinflammerbar" ; -- oinflammerbar..av.1
  oinflammerbarhet_1_N = mkN "oinflammerbarhet" ; -- oinflammerbarhet..nn.1
  oinfluerad_1_A = mkA "oinfluerad" ; -- oinfluerad..av.1
  oinfluerbar_1_A = mkA "oinfluerbar" ; -- oinfluerbar..av.1
  oinfluerbarhet_1_N = mkN "oinfluerbarhet" ; -- oinfluerbarhet..nn.1
  oinflyttad_1_A = mkA "oinflyttad" ; -- oinflyttad..av.1
  oinflätad_1_A = mkA "oinflätad" ; -- oinflätad..av.1
  oinfodrad_1_A = mkA "oinfodrad" ; -- oinfodrad..av.1
  oinfogad_1_A = mkA "oinfogad" ; -- oinfogad..av.1
  oinfordrad_1_A = mkA "oinfordrad" ; -- oinfordrad..av.1
  oinformerad_1_A = mkA "oinformerad" ; -- oinformerad..av.1
  oinformerbar_1_A = mkA "oinformerbar" ; -- oinformerbar..av.1
  oinformerbarhet_1_N = mkN "oinformerbarhet" ; -- oinformerbarhet..nn.1
  oinfriad_1_A = mkA "oinfriad" ; -- oinfriad..av.1
  oinfångad_1_A = mkA "oinfångad" ; -- oinfångad..av.1
  oinförd_1_A = mkA "oinförd" "oinfört" ; -- oinförd..av.1
  oinförlivad_1_A = mkA "oinförlivad" ; -- oinförlivad..av.1
  oinförskaffad_1_A = mkA "oinförskaffad" ; -- oinförskaffad..av.1
  oingraverad_1_A = mkA "oingraverad" ; -- oingraverad..av.1
  oingraverbar_1_A = mkA "oingraverbar" ; -- oingraverbar..av.1
  oingraverbarhet_1_N = mkN "oingraverbarhet" ; -- oingraverbarhet..nn.1
  oinhalerad_1_A = mkA "oinhalerad" ; -- oinhalerad..av.1
  oinhalerbar_1_A = mkA "oinhalerbar" ; -- oinhalerbar..av.1
  oinhalerbarhet_1_N = mkN "oinhalerbarhet" ; -- oinhalerbarhet..nn.1
  oinhandlad_1_A = mkA "oinhandlad" ; -- oinhandlad..av.1
  oinhiberad_1_A = mkA "oinhiberad" ; -- oinhiberad..av.1
  oinhiberbar_1_A = mkA "oinhiberbar" ; -- oinhiberbar..av.1
  oinhiberbarhet_1_N = mkN "oinhiberbarhet" ; -- oinhiberbarhet..nn.1
  oinhibiterad_1_A = mkA "oinhibiterad" ; -- oinhibiterad..av.1
  oinhibiterbar_1_A = mkA "oinhibiterbar" ; -- oinhibiterbar..av.1
  oinhibiterbarhet_1_N = mkN "oinhibiterbarhet" ; -- oinhibiterbarhet..nn.1
  oinhyst_1_A = mkA "oinhyst" "oinhyst" ; -- oinhyst..av.1
  oinhägnad_1_A = mkA "oinhägnad" ; -- oinhägnad..av.1
  oinhämtad_1_A = mkA "oinhämtad" ; -- oinhämtad..av.1
  oinhöstad_1_A = mkA "oinhöstad" ; -- oinhöstad..av.1
  oinitierad_1_A = mkA "oinitierad" ; -- oinitierad..av.1
  oinitierbar_1_A = mkA "oinitierbar" ; -- oinitierbar..av.1
  oinitierbarhet_1_N = mkN "oinitierbarhet" ; -- oinitierbarhet..nn.1
  oinjagad_1_A = mkA "oinjagad" ; -- oinjagad..av.1
  oinjekterad_1_A = mkA "oinjekterad" ; -- oinjekterad..av.1
  oinjekterbar_1_A = mkA "oinjekterbar" ; -- oinjekterbar..av.1
  oinjekterbarhet_1_N = mkN "oinjekterbarhet" ; -- oinjekterbarhet..nn.1
  oinjicerad_1_A = mkA "oinjicerad" ; -- oinjicerad..av.1
  oinjicerbar_1_A = mkA "oinjicerbar" ; -- oinjicerbar..av.1
  oinjicerbarhet_1_N = mkN "oinjicerbarhet" ; -- oinjicerbarhet..nn.1
  oinkallad_1_A = mkA "oinkallad" ; -- oinkallad..av.1
  oinkapslad_1_A = mkA "oinkapslad" ; -- oinkapslad..av.1
  oinkarnerad_1_A = mkA "oinkarnerad" ; -- oinkarnerad..av.1
  oinkarnerbar_1_A = mkA "oinkarnerbar" ; -- oinkarnerbar..av.1
  oinkarnerbarhet_1_N = mkN "oinkarnerbarhet" ; -- oinkarnerbarhet..nn.1
  oinkasserad_1_A = mkA "oinkasserad" ; -- oinkasserad..av.1
  oinkasserbar_1_A = mkA "oinkasserbar" ; -- oinkasserbar..av.1
  oinkasserbarhet_1_N = mkN "oinkasserbarhet" ; -- oinkasserbarhet..nn.1
  oinklarerad_1_A = mkA "oinklarerad" ; -- oinklarerad..av.1
  oinklarerbar_1_A = mkA "oinklarerbar" ; -- oinklarerbar..av.1
  oinklarerbarhet_1_N = mkN "oinklarerbarhet" ; -- oinklarerbarhet..nn.1
  oinkluderad_1_A = mkA "oinkluderad" ; -- oinkluderad..av.1
  oinkluderbar_1_A = mkA "oinkluderbar" ; -- oinkluderbar..av.1
  oinkluderbarhet_1_N = mkN "oinkluderbarhet" ; -- oinkluderbarhet..nn.1
  oinkopplad_1_A = mkA "oinkopplad" ; -- oinkopplad..av.1
  oinkorporerad_1_A = mkA "oinkorporerad" ; -- oinkorporerad..av.1
  oinkorporerbar_1_A = mkA "oinkorporerbar" ; -- oinkorporerbar..av.1
  oinkorporerbarhet_1_N = mkN "oinkorporerbarhet" ; -- oinkorporerbarhet..nn.1
  oinkrävd_1_A = mkA "oinkrävd" "oinkrävt" ; -- oinkrävd..av.1
  oinkvarterad_1_A = mkA "oinkvarterad" ; -- oinkvarterad..av.1
  oinkvarterbar_1_A = mkA "oinkvarterbar" ; -- oinkvarterbar..av.1
  oinkvarterbarhet_1_N = mkN "oinkvarterbarhet" ; -- oinkvarterbarhet..nn.1
  oinköpt_1_A = mkA "oinköpt" "oinköpt" ; -- oinköpt..av.1
  oinlemmad_1_A = mkA "oinlemmad" ; -- oinlemmad..av.1
  oinlämnad_1_A = mkA "oinlämnad" ; -- oinlämnad..av.1
  oinlärd_1_A = mkA "oinlärd" "oinlärt" ; -- oinlärd..av.1
  oinlånad_1_A = mkA "oinlånad" ; -- oinlånad..av.1
  oinlöpt_1_A = mkA "oinlöpt" "oinlöpt" ; -- oinlöpt..av.1
  oinlöst_1_A = mkA "oinlöst" "oinlöst" ; -- oinlöst..av.1
  oinmatad_1_A = mkA "oinmatad" ; -- oinmatad..av.1
  oinmundigad_1_A = mkA "oinmundigad" ; -- oinmundigad..av.1
  oinmängd_1_A = mkA "oinmängd" "oinmängt" ; -- oinmängd..av.1
  oinmönstrad_1_A = mkA "oinmönstrad" ; -- oinmönstrad..av.1
  oinnefattad_1_A = mkA "oinnefattad" ; -- oinnefattad..av.1
  oinnerverad_1_A = mkA "oinnerverad" ; -- oinnerverad..av.1
  oinnerverbar_1_A = mkA "oinnerverbar" ; -- oinnerverbar..av.1
  oinnerverbarhet_1_N = mkN "oinnerverbarhet" ; -- oinnerverbarhet..nn.1
  oinnestängd_1_A = mkA "oinnestängd" "oinnestängt" ; -- oinnestängd..av.1
  oinnestängdhet_1_N = mkN "oinnestängdhet" ; -- oinnestängdhet..nn.1
  oinokulerad_1_A = mkA "oinokulerad" ; -- oinokulerad..av.1
  oinokulerbar_1_A = mkA "oinokulerbar" ; -- oinokulerbar..av.1
  oinokulerbarhet_1_N = mkN "oinokulerbarhet" ; -- oinokulerbarhet..nn.1
  oinoljad_1_A = mkA "oinoljad" ; -- oinoljad..av.1
  oinordnad_1_A = mkA "oinordnad" ; -- oinordnad..av.1
  oinpassad_1_A = mkA "oinpassad" ; -- oinpassad..av.1
  oinplantad_1_A = mkA "oinplantad" ; -- oinplantad..av.1
  oinplanterad_1_A = mkA "oinplanterad" ; -- oinplanterad..av.1
  oinplanterbar_1_A = mkA "oinplanterbar" ; -- oinplanterbar..av.1
  oinplanterbarhet_1_N = mkN "oinplanterbarhet" ; -- oinplanterbarhet..nn.1
  oinpressad_1_A = mkA "oinpressad" ; -- oinpressad..av.1
  oinprickad_1_A = mkA "oinprickad" ; -- oinprickad..av.1
  oinpräglad_1_A = mkA "oinpräglad" ; -- oinpräglad..av.1
  oinpräntad_1_A = mkA "oinpräntad" ; -- oinpräntad..av.1
  oinramad_1_A = mkA "oinramad" ; -- oinramad..av.1
  oinrangerad_1_A = mkA "oinrangerad" ; -- oinrangerad..av.1
  oinrangerbar_1_A = mkA "oinrangerbar" ; -- oinrangerbar..av.1
  oinrangerbarhet_1_N = mkN "oinrangerbarhet" ; -- oinrangerbarhet..nn.1
  oinrapporterad_1_A = mkA "oinrapporterad" ; -- oinrapporterad..av.1
  oinrapporterbar_1_A = mkA "oinrapporterbar" ; -- oinrapporterbar..av.1
  oinrapporterbarhet_1_N = mkN "oinrapporterbarhet" ; -- oinrapporterbarhet..nn.1
  oinredd_1_A = mkA "oinredd" ; -- oinredd..av.1
  oinregistrerad_1_A = mkA "oinregistrerad" ; -- oinregistrerad..av.1
  oinregistrerbar_1_A = mkA "oinregistrerbar" ; -- oinregistrerbar..av.1
  oinregistrerbarhet_1_N = mkN "oinregistrerbarhet" ; -- oinregistrerbarhet..nn.1
  oinriktad_1_A = mkA "oinriktad" ; -- oinriktad..av.1
  oinringad_1_A = mkA "oinringad" ; -- oinringad..av.1
  oinringd_1_A = mkA "oinringd" "oinringt" ; -- oinringd..av.1
  oinristad_1_A = mkA "oinristad" ; -- oinristad..av.1
  oinropad_1_A = mkA "oinropad" ; -- oinropad..av.1
  oinrymd_1_A = mkA "oinrymd" "oinrymt" ; -- oinrymd..av.1
  oinräknad_1_A = mkA "oinräknad" ; -- oinräknad..av.1
  oinrättad_1_A = mkA "oinrättad" ; -- oinrättad..av.1
  oinsamlad_1_A = mkA "oinsamlad" ; -- oinsamlad..av.1
  oinscenerad_1_A = mkA "oinscenerad" ; -- oinscenerad..av.1
  oinscenerbar_1_A = mkA "oinscenerbar" ; -- oinscenerbar..av.1
  oinscenerbarhet_1_N = mkN "oinscenerbarhet" ; -- oinscenerbarhet..nn.1
  oinseglad_1_A = mkA "oinseglad" ; -- oinseglad..av.1
  oinseminerad_1_A = mkA "oinseminerad" ; -- oinseminerad..av.1
  oinseminerbar_1_A = mkA "oinseminerbar" ; -- oinseminerbar..av.1
  oinseminerbarhet_1_N = mkN "oinseminerbarhet" ; -- oinseminerbarhet..nn.1
  oinsinuerad_1_A = mkA "oinsinuerad" ; -- oinsinuerad..av.1
  oinsinuerbar_1_A = mkA "oinsinuerbar" ; -- oinsinuerbar..av.1
  oinsinuerbarhet_1_N = mkN "oinsinuerbarhet" ; -- oinsinuerbarhet..nn.1
  oinsisterad_1_A = mkA "oinsisterad" ; -- oinsisterad..av.1
  oinsjuknad_1_A = mkA "oinsjuknad" ; -- oinsjuknad..av.1
  oinskaffad_1_A = mkA "oinskaffad" ; -- oinskaffad..av.1
  oinskeppad_1_A = mkA "oinskeppad" ; -- oinskeppad..av.1
  oinskolad_1_A = mkA "oinskolad" ; -- oinskolad..av.1
  oinskränkt_1_A = mkA "oinskränkt" "oinskränkt" ; -- oinskränkt..av.1
  oinskränkthet_1_N = mkN "oinskränkthet" ; -- oinskränkthet..nn.1
  oinskärpt_1_A = mkA "oinskärpt" "oinskärpt" ; -- oinskärpt..av.1
  oinsomnad_1_A = mkA "oinsomnad" ; -- oinsomnad..av.1
  oinspekterad_1_A = mkA "oinspekterad" ; -- oinspekterad..av.1
  oinspekterbar_1_A = mkA "oinspekterbar" ; -- oinspekterbar..av.1
  oinspekterbarhet_1_N = mkN "oinspekterbarhet" ; -- oinspekterbarhet..nn.1
  oinspirerad_1_A = mkA "oinspirerad" ; -- oinspirerad..av.1
  oinspirerande_1_A = mkA "oinspirerande" ; -- oinspirerande..av.1
  oinspirerbar_1_A = mkA "oinspirerbar" ; -- oinspirerbar..av.1
  oinspirerbarhet_1_N = mkN "oinspirerbarhet" ; -- oinspirerbarhet..nn.1
  oinstallerad_1_A = mkA "oinstallerad" ; -- oinstallerad..av.1
  oinstallerbar_1_A = mkA "oinstallerbar" ; -- oinstallerbar..av.1
  oinstallerbarhet_1_N = mkN "oinstallerbarhet" ; -- oinstallerbarhet..nn.1
  oinstiftad_1_A = mkA "oinstiftad" ; -- oinstiftad..av.1
  oinstitutionaliserad_1_A = mkA "oinstitutionaliserad" ; -- oinstitutionaliserad..av.1
  oinstitutionaliserbar_1_A = mkA "oinstitutionaliserbar" ; -- oinstitutionaliserbar..av.1
  oinstitutionaliserbarhet_1_N = mkN "oinstitutionaliserbarhet" ; -- oinstitutionaliserbarhet..nn.1
  oinstruerad_1_A = mkA "oinstruerad" ; -- oinstruerad..av.1
  oinstruerbar_1_A = mkA "oinstruerbar" ; -- oinstruerbar..av.1
  oinstruerbarhet_1_N = mkN "oinstruerbarhet" ; -- oinstruerbarhet..nn.1
  oinstrumenterad_1_A = mkA "oinstrumenterad" ; -- oinstrumenterad..av.1
  oinstrumenterbar_1_A = mkA "oinstrumenterbar" ; -- oinstrumenterbar..av.1
  oinstrumenterbarhet_1_N = mkN "oinstrumenterbarhet" ; -- oinstrumenterbarhet..nn.1
  oinstrålad_1_A = mkA "oinstrålad" ; -- oinstrålad..av.1
  oinstuderad_1_A = mkA "oinstuderad" ; -- oinstuderad..av.1
  oinstuderbar_1_A = mkA "oinstuderbar" ; -- oinstuderbar..av.1
  oinstuderbarhet_1_N = mkN "oinstuderbarhet" ; -- oinstuderbarhet..nn.1
  oinstämd_1_A = mkA "oinstämd" "oinstämt" ; -- oinstämd..av.1
  oinstängd_1_A = mkA "oinstängd" "oinstängt" ; -- oinstängd..av.1
  oinstängdhet_1_N = mkN "oinstängdhet" ; -- oinstängdhet..nn.1
  oinsvept_1_A = mkA "oinsvept" "oinsvept" ; -- oinsvept..av.1
  oinsänd_1_A = mkA "oinsänd" ; -- oinsänd..av.1
  oinsöndrad_1_A = mkA "oinsöndrad" ; -- oinsöndrad..av.1
  ointaglig_1_A = mkA "ointaglig" ; -- ointaglig..av.1
  ointaglighet_1_N = mkN "ointaglighet" ; -- ointaglighet..nn.1
  ointecknad_1_A = mkA "ointecknad" ; -- ointecknad..av.1
  ointegrerad_1_A = mkA "ointegrerad" ; -- ointegrerad..av.1
  ointegrerbar_1_A = mkA "ointegrerbar" ; -- ointegrerbar..av.1
  ointegrerbarhet_1_N = mkN "ointegrerbarhet" ; -- ointegrerbarhet..nn.1
  ointellektualiserad_1_A = mkA "ointellektualiserad" ; -- ointellektualiserad..av.1
  ointellektualiserbar_1_A = mkA "ointellektualiserbar" ; -- ointellektualiserbar..av.1
  ointellektualiserbarhet_1_N = mkN "ointellektualiserbarhet" ; -- ointellektualiserbarhet..nn.1
  ointelligent_1_A = mkA "ointelligent" "ointelligent" ; -- ointelligent..av.1
  ointelligenthet_1_N = mkN "ointelligenthet" ; -- ointelligenthet..nn.1
  ointensifierad_1_A = mkA "ointensifierad" ; -- ointensifierad..av.1
  ointensifierbar_1_A = mkA "ointensifierbar" ; -- ointensifierbar..av.1
  ointensifierbarhet_1_N = mkN "ointensifierbarhet" ; -- ointensifierbarhet..nn.1
  ointensiverad_1_A = mkA "ointensiverad" ; -- ointensiverad..av.1
  ointensiverbar_1_A = mkA "ointensiverbar" ; -- ointensiverbar..av.1
  ointensiverbarhet_1_N = mkN "ointensiverbarhet" ; -- ointensiverbarhet..nn.1
  ointerfolierad_1_A = mkA "ointerfolierad" ; -- ointerfolierad..av.1
  ointerfolierbar_1_A = mkA "ointerfolierbar" ; -- ointerfolierbar..av.1
  ointerfolierbarhet_1_N = mkN "ointerfolierbarhet" ; -- ointerfolierbarhet..nn.1
  ointernaliserad_1_A = mkA "ointernaliserad" ; -- ointernaliserad..av.1
  ointernaliserbar_1_A = mkA "ointernaliserbar" ; -- ointernaliserbar..av.1
  ointernaliserbarhet_1_N = mkN "ointernaliserbarhet" ; -- ointernaliserbarhet..nn.1
  ointernationaliserad_1_A = mkA "ointernationaliserad" ; -- ointernationaliserad..av.1
  ointernationaliserbar_1_A = mkA "ointernationaliserbar" ; -- ointernationaliserbar..av.1
  ointernationaliserbarhet_1_N = mkN "ointernationaliserbarhet" ; -- ointernationaliserbarhet..nn.1
  ointernerad_1_A = mkA "ointernerad" ; -- ointernerad..av.1
  ointernerbar_1_A = mkA "ointernerbar" ; -- ointernerbar..av.1
  ointernerbarhet_1_N = mkN "ointernerbarhet" ; -- ointernerbarhet..nn.1
  ointerpellerad_1_A = mkA "ointerpellerad" ; -- ointerpellerad..av.1
  ointerpellerbar_1_A = mkA "ointerpellerbar" ; -- ointerpellerbar..av.1
  ointerpellerbarhet_1_N = mkN "ointerpellerbarhet" ; -- ointerpellerbarhet..nn.1
  ointerpolerad_1_A = mkA "ointerpolerad" ; -- ointerpolerad..av.1
  ointerpolerbar_1_A = mkA "ointerpolerbar" ; -- ointerpolerbar..av.1
  ointerpolerbarhet_1_N = mkN "ointerpolerbarhet" ; -- ointerpolerbarhet..nn.1
  ointerpreterad_1_A = mkA "ointerpreterad" ; -- ointerpreterad..av.1
  ointerpreterbar_1_A = mkA "ointerpreterbar" ; -- ointerpreterbar..av.1
  ointerpreterbarhet_1_N = mkN "ointerpreterbarhet" ; -- ointerpreterbarhet..nn.1
  ointerpunkterad_1_A = mkA "ointerpunkterad" ; -- ointerpunkterad..av.1
  ointerpunkterbar_1_A = mkA "ointerpunkterbar" ; -- ointerpunkterbar..av.1
  ointerpunkterbarhet_1_N = mkN "ointerpunkterbarhet" ; -- ointerpunkterbarhet..nn.1
  ointervenerad_1_A = mkA "ointervenerad" ; -- ointervenerad..av.1
  ointervenerbar_1_A = mkA "ointervenerbar" ; -- ointervenerbar..av.1
  ointervenerbarhet_1_N = mkN "ointervenerbarhet" ; -- ointervenerbarhet..nn.1
  ointervjuad_1_A = mkA "ointervjuad" ; -- ointervjuad..av.1
  ointolkad_1_A = mkA "ointolkad" ; -- ointolkad..av.1
  ointonerad_1_A = mkA "ointonerad" ; -- ointonerad..av.1
  ointonerbar_1_A = mkA "ointonerbar" ; -- ointonerbar..av.1
  ointonerbarhet_1_N = mkN "ointonerbarhet" ; -- ointonerbarhet..nn.1
  ointressant_1_A = mkA "ointressant" "ointressant" ; -- ointressant..av.1
  ointresse_1_N = mkN "ointresse" ; -- ointresse..nn.1
  ointresserad_1_A = mkA "ointresserad" ; -- ointresserad..av.1
  ointresserbar_1_A = mkA "ointresserbar" ; -- ointresserbar..av.1
  ointresserbarhet_1_N = mkN "ointresserbarhet" ; -- ointresserbarhet..nn.1
  ointroducerad_1_A = mkA "ointroducerad" ; -- ointroducerad..av.1
  ointroducerbar_1_A = mkA "ointroducerbar" ; -- ointroducerbar..av.1
  ointroducerbarhet_1_N = mkN "ointroducerbarhet" ; -- ointroducerbarhet..nn.1
  ointrumfad_1_A = mkA "ointrumfad" ; -- ointrumfad..av.1
  ointräffad_1_A = mkA "ointräffad" ; -- ointräffad..av.1
  ointrängd_1_A = mkA "ointrängd" "ointrängt" ; -- ointrängd..av.1
  ointygad_1_A = mkA "ointygad" ; -- ointygad..av.1
  ointågad_1_A = mkA "ointågad" ; -- ointågad..av.1
  oinvaderad_1_A = mkA "oinvaderad" ; -- oinvaderad..av.1
  oinvaderbar_1_A = mkA "oinvaderbar" ; -- oinvaderbar..av.1
  oinvaderbarhet_1_N = mkN "oinvaderbarhet" ; -- oinvaderbarhet..nn.1
  oinvaggad_1_A = mkA "oinvaggad" ; -- oinvaggad..av.1
  oinvalidiserad_1_A = mkA "oinvalidiserad" ; -- oinvalidiserad..av.1
  oinvalidiserbar_1_A = mkA "oinvalidiserbar" ; -- oinvalidiserbar..av.1
  oinvalidiserbarhet_1_N = mkN "oinvalidiserbarhet" ; -- oinvalidiserbarhet..nn.1
  oinvandrad_1_A = mkA "oinvandrad" ; -- oinvandrad..av.1
  oinvecklad_1_A = mkA "oinvecklad" ; -- oinvecklad..av.1
  oinventerad_1_A = mkA "oinventerad" ; -- oinventerad..av.1
  oinventerbar_1_A = mkA "oinventerbar" ; -- oinventerbar..av.1
  oinventerbarhet_1_N = mkN "oinventerbarhet" ; -- oinventerbarhet..nn.1
  oinverterad_1_A = mkA "oinverterad" ; -- oinverterad..av.1
  oinverterbar_1_A = mkA "oinverterbar" ; -- oinverterbar..av.1
  oinverterbarhet_1_N = mkN "oinverterbarhet" ; -- oinverterbarhet..nn.1
  oinvesterad_1_A = mkA "oinvesterad" ; -- oinvesterad..av.1
  oinvesterbar_1_A = mkA "oinvesterbar" ; -- oinvesterbar..av.1
  oinvesterbarhet_1_N = mkN "oinvesterbarhet" ; -- oinvesterbarhet..nn.1
  oinvigd_1_A = mkA "oinvigd" "oinvigt" ; -- oinvigd..av.1
  oinvigdhet_1_N = mkN "oinvigdhet" ; -- oinvigdhet..nn.1
  oinviterad_1_A = mkA "oinviterad" ; -- oinviterad..av.1
  oinviterbar_1_A = mkA "oinviterbar" ; -- oinviterbar..av.1
  oinviterbarhet_1_N = mkN "oinviterbarhet" ; -- oinviterbarhet..nn.1
  oinvolverad_1_A = mkA "oinvolverad" ; -- oinvolverad..av.1
  oinvolverbar_1_A = mkA "oinvolverbar" ; -- oinvolverbar..av.1
  oinvolverbarhet_1_N = mkN "oinvolverbarhet" ; -- oinvolverbarhet..nn.1
  oinväntad_1_A = mkA "oinväntad" ; -- oinväntad..av.1
  oinvävd_1_A = mkA "oinvävd" "oinvävt" ; -- oinvävd..av.1
  oinympad_1_A = mkA "oinympad" ; -- oinympad..av.1
  oinövad_1_A = mkA "oinövad" ; -- oinövad..av.1
  oirriterad_1_A = mkA "oirriterad" ; -- oirriterad..av.1
  oirriterbar_1_A = mkA "oirriterbar" ; -- oirriterbar..av.1
  oirriterbarhet_1_N = mkN "oirriterbarhet" ; -- oirriterbarhet..nn.1
  oislamiserad_1_A = mkA "oislamiserad" ; -- oislamiserad..av.1
  oislamiserbar_1_A = mkA "oislamiserbar" ; -- oislamiserbar..av.1
  oislamiserbarhet_1_N = mkN "oislamiserbarhet" ; -- oislamiserbarhet..nn.1
  oisolerad_1_A = mkA "oisolerad" ; -- oisolerad..av.1
  oisolerbar_1_A = mkA "oisolerbar" ; -- oisolerbar..av.1
  oisolerbarhet_1_N = mkN "oisolerbarhet" ; -- oisolerbarhet..nn.1
  oitererad_1_A = mkA "oitererad" ; -- oitererad..av.1
  oitererbar_1_A = mkA "oitererbar" ; -- oitererbar..av.1
  oitererbarhet_1_N = mkN "oitererbarhet" ; -- oitererbarhet..nn.1
  oitutad_1_A = mkA "oitutad" ; -- oitutad..av.1
  oja_1_V = mkV "ojar" ; -- oja..vb.1
  ojabbad_1_A = mkA "ojabbad" ; -- ojabbad..av.1
  ojagad_1_A = mkA "ojagad" ; -- ojagad..av.1
  ojakad_1_A = mkA "ojakad" ; -- ojakad..av.1
  ojande_1_N = mkN "ojande" ; -- ojande..nn.1
  ojazzifierad_1_A = mkA "ojazzifierad" ; -- ojazzifierad..av.1
  ojazzifierbar_1_A = mkA "ojazzifierbar" ; -- ojazzifierbar..av.1
  ojazzifierbarhet_1_N = mkN "ojazzifierbarhet" ; -- ojazzifierbarhet..nn.1
  ojoddlad_1_A = mkA "ojoddlad" ; -- ojoddlad..av.1
  ojoderad_1_A = mkA "ojoderad" ; -- ojoderad..av.1
  ojoderbar_1_A = mkA "ojoderbar" ; -- ojoderbar..av.1
  ojoderbarhet_1_N = mkN "ojoderbarhet" ; -- ojoderbarhet..nn.1
  ojoggad_1_A = mkA "ojoggad" ; -- ojoggad..av.1
  ojojkad_1_A = mkA "ojojkad" ; -- ojojkad..av.1
  ojollrad_1_A = mkA "ojollrad" ; -- ojollrad..av.1
  ojonglerad_1_A = mkA "ojonglerad" ; -- ojonglerad..av.1
  ojonglerbar_1_A = mkA "ojonglerbar" ; -- ojonglerbar..av.1
  ojonglerbarhet_1_N = mkN "ojonglerbarhet" ; -- ojonglerbarhet..nn.1
  ojoniserad_1_A = mkA "ojoniserad" ; -- ojoniserad..av.1
  ojoniserbar_1_A = mkA "ojoniserbar" ; -- ojoniserbar..av.1
  ojoniserbarhet_1_N = mkN "ojoniserbarhet" ; -- ojoniserbarhet..nn.1
  ojordad_1_A = mkA "ojordad" ; -- ojordad..av.1
  ojordisk_1_A = mkA "ojordisk" ; -- ojordisk..av.1
  ojust_1_A = mkA "ojust" "ojust" ; -- ojust..av.1
  ojuste_1_A = mkA "ojuste" ; -- ojuste..av.1
  ojusterad_1_A = mkA "ojusterad" ; -- ojusterad..av.1
  ojusterbar_1_A = mkA "ojusterbar" ; -- ojusterbar..av.1
  ojusterbarhet_1_N = mkN "ojusterbarhet" ; -- ojusterbarhet..nn.1
  ojusthet_1_N = mkN "ojusthet" "ojustheter" ; -- ojusthet..nn.1
  ojäktad_1_A = mkA "ojäktad" ; -- ojäktad..av.1
  ojämförbar_1_A = mkA "ojämförbar" ; -- ojämförbar..av.1
  ojämförbarhet_1_N = mkN "ojämförbarhet" ; -- ojämförbarhet..nn.1
  ojämförd_1_A = mkA "ojämförd" "ojämfört" ; -- ojämförd..av.1
  ojämförlig_1_A = mkA "ojämförlig" ; -- ojämförlig..av.1
  ojämförlighet_1_N = mkN "ojämförlighet" ; -- ojämförlighet..nn.1
  ojämkad_1_A = mkA "ojämkad" ; -- ojämkad..av.1
  ojämlik_1_A = mkA "ojämlik" ; -- ojämlik..av.1
  ojämlikhet_1_N = mkN "ojämlikhet" "ojämlikheter" ; -- ojämlikhet..nn.1
  ojämn_1_A = mkA "ojämn" ; -- ojämn..av.1
  ojämnad_1_A = mkA "ojämnad" ; -- ojämnad..av.1
  ojämnhet_1_N = mkN "ojämnhet" "ojämnheter" ; -- ojämnhet..nn.1
  ojämställd_1_A = mkA "ojämställd" "ojämställt" ; -- ojämställd..av.1
  ojämställdhet_1_N = mkN "ojämställdhet" ; -- ojämställdhet..nn.1
  ojäst_1_A = mkA "ojäst" "ojäst" ; -- ojäst..av.1
  ojävad_1_A = mkA "ojävad" ; -- ojävad..av.1
  ojävig_1_A = mkA "ojävig" ; -- ojävig..av.1
  ojävighet_1_N = mkN "ojävighet" ; -- ojävighet..nn.1
  ok_1_A = mkA "ok" ; -- ok..av.1
  ok_1_N = mkN "ok" neutrum  ; -- ok..nn.1
  oka_1_V = mkV "okar" ; -- oka..vb.1
  okablad_1_A = mkA "okablad" ; -- okablad..av.1
  okaklad_1_A = mkA "okaklad" ; -- okaklad..av.1
  okalandrerad_1_A = mkA "okalandrerad" ; -- okalandrerad..av.1
  okalandrerbar_1_A = mkA "okalandrerbar" ; -- okalandrerbar..av.1
  okalandrerbarhet_1_N = mkN "okalandrerbarhet" ; -- okalandrerbarhet..nn.1
  okalcinerad_1_A = mkA "okalcinerad" ; -- okalcinerad..av.1
  okalcinerbar_1_A = mkA "okalcinerbar" ; -- okalcinerbar..av.1
  okalcinerbarhet_1_N = mkN "okalcinerbarhet" ; -- okalcinerbarhet..nn.1
  okalfatrad_1_A = mkA "okalfatrad" ; -- okalfatrad..av.1
  okalibrerad_1_A = mkA "okalibrerad" ; -- okalibrerad..av.1
  okalibrerbar_1_A = mkA "okalibrerbar" ; -- okalibrerbar..av.1
  okalibrerbarhet_1_N = mkN "okalibrerbarhet" ; -- okalibrerbarhet..nn.1
  okalkad_1_A = mkA "okalkad" ; -- okalkad..av.1
  okalkerad_1_A = mkA "okalkerad" ; -- okalkerad..av.1
  okalkerbar_1_A = mkA "okalkerbar" ; -- okalkerbar..av.1
  okalkerbarhet_1_N = mkN "okalkerbarhet" ; -- okalkerbarhet..nn.1
  okalkylerad_1_A = mkA "okalkylerad" ; -- okalkylerad..av.1
  okalkylerbar_1_A = mkA "okalkylerbar" ; -- okalkylerbar..av.1
  okalkylerbarhet_1_N = mkN "okalkylerbarhet" ; -- okalkylerbarhet..nn.1
  okallad_1_A = mkA "okallad" ; -- okallad..av.1
  okallnad_1_A = mkA "okallnad" ; -- okallnad..av.1
  okalmerad_1_A = mkA "okalmerad" ; -- okalmerad..av.1
  okalmerbar_1_A = mkA "okalmerbar" ; -- okalmerbar..av.1
  okalmerbarhet_1_N = mkN "okalmerbarhet" ; -- okalmerbarhet..nn.1
  okammad_1_A = mkA "okammad" ; -- okammad..av.1
  okamouflerad_1_A = mkA "okamouflerad" ; -- okamouflerad..av.1
  okamouflerbar_1_A = mkA "okamouflerbar" ; -- okamouflerbar..av.1
  okamouflerbarhet_1_N = mkN "okamouflerbarhet" ; -- okamouflerbarhet..nn.1
  okamratlig_1_A = mkA "okamratlig" ; -- okamratlig..av.1
  okamratlighet_1_N = mkN "okamratlighet" "okamratligheter" ; -- okamratlighet..nn.1
  okanaliserad_1_A = mkA "okanaliserad" ; -- okanaliserad..av.1
  okanaliserbar_1_A = mkA "okanaliserbar" ; -- okanaliserbar..av.1
  okanaliserbarhet_1_N = mkN "okanaliserbarhet" ; -- okanaliserbarhet..nn.1
  okande_1_N = mkN "okande" ; -- okande..nn.1
  okanderad_1_A = mkA "okanderad" ; -- okanderad..av.1
  okanderbar_1_A = mkA "okanderbar" ; -- okanderbar..av.1
  okanderbarhet_1_N = mkN "okanderbarhet" ; -- okanderbarhet..nn.1
  okandiderbar_1_A = mkA "okandiderbar" ; -- okandiderbar..av.1
  okandiderbarhet_1_N = mkN "okandiderbarhet" ; -- okandiderbarhet..nn.1
  okannelerad_1_A = mkA "okannelerad" ; -- okannelerad..av.1
  okannelerbar_1_A = mkA "okannelerbar" ; -- okannelerbar..av.1
  okannelerbarhet_1_N = mkN "okannelerbarhet" ; -- okannelerbarhet..nn.1
  okanoniserad_1_A = mkA "okanoniserad" ; -- okanoniserad..av.1
  okanoniserbar_1_A = mkA "okanoniserbar" ; -- okanoniserbar..av.1
  okanoniserbarhet_1_N = mkN "okanoniserbarhet" ; -- okanoniserbarhet..nn.1
  okantad_1_A = mkA "okantad" ; -- okantad..av.1
  okantrad_1_A = mkA "okantrad" ; -- okantrad..av.1
  okapad_1_A = mkA "okapad" ; -- okapad..av.1
  okapi_1_N = mkN "okapi" "okapin" "okapier" "okapierna" ; -- okapi..nn.1
  okapitaliserad_1_A = mkA "okapitaliserad" ; -- okapitaliserad..av.1
  okapitaliserbar_1_A = mkA "okapitaliserbar" ; -- okapitaliserbar..av.1
  okapitaliserbarhet_1_N = mkN "okapitaliserbarhet" ; -- okapitaliserbarhet..nn.1
  okapsejsad_1_A = mkA "okapsejsad" ; -- okapsejsad..av.1
  okapslad_1_A = mkA "okapslad" ; -- okapslad..av.1
  okarad_1_A = mkA "okarad" ; -- okarad..av.1
  okarakteriserad_1_A = mkA "okarakteriserad" ; -- okarakteriserad..av.1
  okarakteriserbar_1_A = mkA "okarakteriserbar" ; -- okarakteriserbar..av.1
  okarakteriserbarhet_1_N = mkN "okarakteriserbarhet" ; -- okarakteriserbarhet..nn.1
  okaraktäriserad_1_A = mkA "okaraktäriserad" ; -- okaraktäriserad..av.1
  okaraktäriserbar_1_A = mkA "okaraktäriserbar" ; -- okaraktäriserbar..av.1
  okaraktäriserbarhet_1_N = mkN "okaraktäriserbarhet" ; -- okaraktäriserbarhet..nn.1
  okarambolerad_1_A = mkA "okarambolerad" ; -- okarambolerad..av.1
  okarambolerbar_1_A = mkA "okarambolerbar" ; -- okarambolerbar..av.1
  okarambolerbarhet_1_N = mkN "okarambolerbarhet" ; -- okarambolerbarhet..nn.1
  okarboniserad_1_A = mkA "okarboniserad" ; -- okarboniserad..av.1
  okarboniserbar_1_A = mkA "okarboniserbar" ; -- okarboniserbar..av.1
  okarboniserbarhet_1_N = mkN "okarboniserbarhet" ; -- okarboniserbarhet..nn.1
  okardad_1_A = mkA "okardad" ; -- okardad..av.1
  okarikerad_1_A = mkA "okarikerad" ; -- okarikerad..av.1
  okarikerbar_1_A = mkA "okarikerbar" ; -- okarikerbar..av.1
  okarikerbarhet_1_N = mkN "okarikerbarhet" ; -- okarikerbarhet..nn.1
  okarina_1_N = mkN "okarina" ; -- okarina..nn.1
  okarterad_1_A = mkA "okarterad" ; -- okarterad..av.1
  okarterbar_1_A = mkA "okarterbar" ; -- okarterbar..av.1
  okarterbarhet_1_N = mkN "okarterbarhet" ; -- okarterbarhet..nn.1
  okartonnerad_1_A = mkA "okartonnerad" ; -- okartonnerad..av.1
  okartonnerbar_1_A = mkA "okartonnerbar" ; -- okartonnerbar..av.1
  okartonnerbarhet_1_N = mkN "okartonnerbarhet" ; -- okartonnerbarhet..nn.1
  okarvad_1_A = mkA "okarvad" ; -- okarvad..av.1
  okasserad_1_A = mkA "okasserad" ; -- okasserad..av.1
  okasserbar_1_A = mkA "okasserbar" ; -- okasserbar..av.1
  okasserbarhet_1_N = mkN "okasserbarhet" ; -- okasserbarhet..nn.1
  okastad_1_A = mkA "okastad" ; -- okastad..av.1
  okastrerad_1_A = mkA "okastrerad" ; -- okastrerad..av.1
  okastrerbar_1_A = mkA "okastrerbar" ; -- okastrerbar..av.1
  okastrerbarhet_1_N = mkN "okastrerbarhet" ; -- okastrerbarhet..nn.1
  okatalogiserad_1_A = mkA "okatalogiserad" ; -- okatalogiserad..av.1
  okatalogiserbar_1_A = mkA "okatalogiserbar" ; -- okatalogiserbar..av.1
  okatalogiserbarhet_1_N = mkN "okatalogiserbarhet" ; -- okatalogiserbarhet..nn.1
  okatalyserad_1_A = mkA "okatalyserad" ; -- okatalyserad..av.1
  okatalyserbar_1_A = mkA "okatalyserbar" ; -- okatalyserbar..av.1
  okatalyserbarhet_1_N = mkN "okatalyserbarhet" ; -- okatalyserbarhet..nn.1
  okategoriserad_1_A = mkA "okategoriserad" ; -- okategoriserad..av.1
  okategoriserbar_1_A = mkA "okategoriserbar" ; -- okategoriserbar..av.1
  okategoriserbarhet_1_N = mkN "okategoriserbarhet" ; -- okategoriserbarhet..nn.1
  okateteriserad_1_A = mkA "okateteriserad" ; -- okateteriserad..av.1
  okateteriserbar_1_A = mkA "okateteriserbar" ; -- okateteriserbar..av.1
  okateteriserbarhet_1_N = mkN "okateteriserbarhet" ; -- okateteriserbarhet..nn.1
  okatetriserad_1_A = mkA "okatetriserad" ; -- okatetriserad..av.1
  okatetriserbar_1_A = mkA "okatetriserbar" ; -- okatetriserbar..av.1
  okatetriserbarhet_1_N = mkN "okatetriserbarhet" ; -- okatetriserbarhet..nn.1
  okattad_1_A = mkA "okattad" ; -- okattad..av.1
  okauteriserad_1_A = mkA "okauteriserad" ; -- okauteriserad..av.1
  okauteriserbar_1_A = mkA "okauteriserbar" ; -- okauteriserbar..av.1
  okauteriserbarhet_1_N = mkN "okauteriserbarhet" ; -- okauteriserbarhet..nn.1
  okavlad_1_A = mkA "okavlad" ; -- okavlad..av.1
  okay_1_A = mkA "okay" ; -- okay..av.1
  okben_1_N = mkN "okben" neutrum  ; -- okben..nn.1
  okbåge_1_N = mkN "okbåge" utrum  ; -- okbåge..nn.1
  okedjad_1_A = mkA "okedjad" ; -- okedjad..av.1
  okej_1_A = mkA "okej" ; -- okej..av.1
  okeja_1_V = mkV "okejar" ; -- okeja..vb.1
  okejande_1_N = mkN "okejande" ; -- okejande..nn.1
  okey_1_A = mkA "okey" ; -- okey..av.1
  okickad_1_A = mkA "okickad" ; -- okickad..av.1
  okidnappad_1_A = mkA "okidnappad" ; -- okidnappad..av.1
  okikad_1_A = mkA "okikad" ; -- okikad..av.1
  okilad_1_A = mkA "okilad" ; -- okilad..av.1
  okillad_1_A = mkA "okillad" ; -- okillad..av.1
  okirrad_1_A = mkA "okirrad" ; -- okirrad..av.1
  okissad_1_A = mkA "okissad" ; -- okissad..av.1
  okittad_1_A = mkA "okittad" ; -- okittad..av.1
  okittlad_1_A = mkA "okittlad" ; -- okittlad..av.1
  oklackad_1_A = mkA "oklackad" ; -- oklackad..av.1
  oklampad_1_A = mkA "oklampad" ; -- oklampad..av.1
  oklamrad_1_A = mkA "oklamrad" ; -- oklamrad..av.1
  oklanderlig_1_A = mkA "oklanderlig" ; -- oklanderlig..av.1
  oklanderlighet_1_N = mkN "oklanderlighet" ; -- oklanderlighet..nn.1
  oklandrad_1_A = mkA "oklandrad" ; -- oklandrad..av.1
  oklappad_1_A = mkA "oklappad" ; -- oklappad..av.1
  oklar_1_A = mkA "oklar" ; -- oklar..av.1
  oklarad_1_A = mkA "oklarad" ; -- oklarad..av.1
  oklarerad_1_A = mkA "oklarerad" ; -- oklarerad..av.1
  oklarerbar_1_A = mkA "oklarerbar" ; -- oklarerbar..av.1
  oklarerbarhet_1_N = mkN "oklarerbarhet" ; -- oklarerbarhet..nn.1
  oklarhet_1_N = mkN "oklarhet" "oklarheter" ; -- oklarhet..nn.1
  oklassad_1_A = mkA "oklassad" ; -- oklassad..av.1
  oklassificerad_1_A = mkA "oklassificerad" ; -- oklassificerad..av.1
  oklassificerbar_1_A = mkA "oklassificerbar" ; -- oklassificerbar..av.1
  oklassificerbarhet_1_N = mkN "oklassificerbarhet" ; -- oklassificerbarhet..nn.1
  oklatschad_1_A = mkA "oklatschad" ; -- oklatschad..av.1
  oklenad_1_A = mkA "oklenad" ; -- oklenad..av.1
  okletad_1_A = mkA "okletad" ; -- okletad..av.1
  okliad_1_A = mkA "okliad" ; -- okliad..av.1
  oklippt_1_A = mkA "oklippt" "oklippt" ; -- oklippt..av.1
  oklirad_1_A = mkA "oklirad" ; -- oklirad..av.1
  oklistrad_1_A = mkA "oklistrad" ; -- oklistrad..av.1
  oklockad_1_A = mkA "oklockad" ; -- oklockad..av.1
  oklok_1_A = mkA "oklok" ; -- oklok..av.1
  oklokhet_1_N = mkN "oklokhet" ; -- oklokhet..nn.1
  oklonad_1_A = mkA "oklonad" ; -- oklonad..av.1
  oklorerad_1_A = mkA "oklorerad" ; -- oklorerad..av.1
  oklorerbar_1_A = mkA "oklorerbar" ; -- oklorerbar..av.1
  oklorerbarhet_1_N = mkN "oklorerbarhet" ; -- oklorerbarhet..nn.1
  oklottrad_1_A = mkA "oklottrad" ; -- oklottrad..av.1
  oklubbad_1_A = mkA "oklubbad" ; -- oklubbad..av.1
  okluddad_1_A = mkA "okluddad" ; -- okluddad..av.1
  oklyftad_1_A = mkA "oklyftad" ; -- oklyftad..av.1
  okläckt_1_A = mkA "okläckt" "okläckt" ; -- okläckt..av.1
  oklädd_1_A = mkA "oklädd" ; -- oklädd..av.1
  okläddhet_1_N = mkN "okläddhet" ; -- okläddhet..nn.1
  oklämd_1_A = mkA "oklämd" "oklämt" ; -- oklämd..av.1
  oklängd_1_A = mkA "oklängd" "oklängt" ; -- oklängd..av.1
  oklättrad_1_A = mkA "oklättrad" ; -- oklättrad..av.1
  oklöst_1_A = mkA "oklöst" "oklöst" ; -- oklöst..av.1
  oklövjad_1_A = mkA "oklövjad" ; -- oklövjad..av.1
  oknackad_1_A = mkA "oknackad" ; -- oknackad..av.1
  oknaprad_1_A = mkA "oknaprad" ; -- oknaprad..av.1
  oknarkad_1_A = mkA "oknarkad" ; -- oknarkad..av.1
  oknatad_1_A = mkA "oknatad" ; -- oknatad..av.1
  oknipsad_1_A = mkA "oknipsad" ; -- oknipsad..av.1
  oknivad_1_A = mkA "oknivad" ; -- oknivad..av.1
  oknockad_1_A = mkA "oknockad" ; -- oknockad..av.1
  oknollrad_1_A = mkA "oknollrad" ; -- oknollrad..av.1
  oknopad_1_A = mkA "oknopad" ; -- oknopad..av.1
  oknorvad_1_A = mkA "oknorvad" ; -- oknorvad..av.1
  oknuffad_1_A = mkA "oknuffad" ; -- oknuffad..av.1
  oknullad_1_A = mkA "oknullad" ; -- oknullad..av.1
  oknycklad_1_A = mkA "oknycklad" ; -- oknycklad..av.1
  oknyckt_1_A = mkA "oknyckt" "oknyckt" ; -- oknyckt..av.1
  oknypplad_1_A = mkA "oknypplad" ; -- oknypplad..av.1
  oknytt_1_N = mkN "oknytt" neutrum  ; -- oknytt..nn.1
  oknäad_1_A = mkA "oknäad" ; -- oknäad..av.1
  oknäböjd_1_A = mkA "oknäböjd" "oknäböjt" ; -- oknäböjd..av.1
  oknäckt_1_A = mkA "oknäckt" "oknäckt" ; -- oknäckt..av.1
  oknäppt_1_A = mkA "oknäppt" "oknäppt" ; -- oknäppt..av.1
  oknådad_1_A = mkA "oknådad" ; -- oknådad..av.1
  oknölad_1_A = mkA "oknölad" ; -- oknölad..av.1
  okoafferad_1_A = mkA "okoafferad" ; -- okoafferad..av.1
  okoafferbar_1_A = mkA "okoafferbar" ; -- okoafferbar..av.1
  okoafferbarhet_1_N = mkN "okoafferbarhet" ; -- okoafferbarhet..nn.1
  okoagulerad_1_A = mkA "okoagulerad" ; -- okoagulerad..av.1
  okoagulerbar_1_A = mkA "okoagulerbar" ; -- okoagulerbar..av.1
  okoagulerbarhet_1_N = mkN "okoagulerbarhet" ; -- okoagulerbarhet..nn.1
  okodad_1_A = mkA "okodad" ; -- okodad..av.1
  okodifierad_1_A = mkA "okodifierad" ; -- okodifierad..av.1
  okodifierbar_1_A = mkA "okodifierbar" ; -- okodifierbar..av.1
  okodifierbarhet_1_N = mkN "okodifierbarhet" ; -- okodifierbarhet..nn.1
  okojad_1_A = mkA "okojad" ; -- okojad..av.1
  okojsad_1_A = mkA "okojsad" ; -- okojsad..av.1
  okokt_1_A = mkA "okokt" "okokt" ; -- okokt..av.1
  okolad_1_A = mkA "okolad" ; -- okolad..av.1
  okolkad_1_A = mkA "okolkad" ; -- okolkad..av.1
  okollad_1_A = mkA "okollad" ; -- okollad..av.1
  okollapsad_1_A = mkA "okollapsad" ; -- okollapsad..av.1
  okollationerad_1_A = mkA "okollationerad" ; -- okollationerad..av.1
  okollationerbar_1_A = mkA "okollationerbar" ; -- okollationerbar..av.1
  okollationerbarhet_1_N = mkN "okollationerbarhet" ; -- okollationerbarhet..nn.1
  okollektiviserad_1_A = mkA "okollektiviserad" ; -- okollektiviserad..av.1
  okollektiviserbar_1_A = mkA "okollektiviserbar" ; -- okollektiviserbar..av.1
  okollektiviserbarhet_1_N = mkN "okollektiviserbarhet" ; -- okollektiviserbarhet..nn.1
  okoloniserad_1_A = mkA "okoloniserad" ; -- okoloniserad..av.1
  okoloniserbar_1_A = mkA "okoloniserbar" ; -- okoloniserbar..av.1
  okoloniserbarhet_1_N = mkN "okoloniserbarhet" ; -- okoloniserbarhet..nn.1
  okolorerad_1_A = mkA "okolorerad" ; -- okolorerad..av.1
  okolorerbar_1_A = mkA "okolorerbar" ; -- okolorerbar..av.1
  okolorerbarhet_1_N = mkN "okolorerbarhet" ; -- okolorerbarhet..nn.1
  okolporterad_1_A = mkA "okolporterad" ; -- okolporterad..av.1
  okolporterbar_1_A = mkA "okolporterbar" ; -- okolporterbar..av.1
  okolporterbarhet_1_N = mkN "okolporterbarhet" ; -- okolporterbarhet..nn.1
  okombinerad_1_A = mkA "okombinerad" ; -- okombinerad..av.1
  okombinerbar_1_A = mkA "okombinerbar" ; -- okombinerbar..av.1
  okombinerbarhet_1_N = mkN "okombinerbarhet" ; -- okombinerbarhet..nn.1
  okommaterad_1_A = mkA "okommaterad" ; -- okommaterad..av.1
  okommaterbar_1_A = mkA "okommaterbar" ; -- okommaterbar..av.1
  okommaterbarhet_1_N = mkN "okommaterbarhet" ; -- okommaterbarhet..nn.1
  okommenderad_1_A = mkA "okommenderad" ; -- okommenderad..av.1
  okommenderbar_1_A = mkA "okommenderbar" ; -- okommenderbar..av.1
  okommenderbarhet_1_N = mkN "okommenderbarhet" ; -- okommenderbarhet..nn.1
  okommenterad_1_A = mkA "okommenterad" ; -- okommenterad..av.1
  okommenterbar_1_A = mkA "okommenterbar" ; -- okommenterbar..av.1
  okommenterbarhet_1_N = mkN "okommenterbarhet" ; -- okommenterbarhet..nn.1
  okommersad_1_A = mkA "okommersad" ; -- okommersad..av.1
  okommersialiserad_1_A = mkA "okommersialiserad" ; -- okommersialiserad..av.1
  okommersialiserbar_1_A = mkA "okommersialiserbar" ; -- okommersialiserbar..av.1
  okommersialiserbarhet_1_N = mkN "okommersialiserbarhet" ; -- okommersialiserbarhet..nn.1
  okommunaliserad_1_A = mkA "okommunaliserad" ; -- okommunaliserad..av.1
  okommunaliserbar_1_A = mkA "okommunaliserbar" ; -- okommunaliserbar..av.1
  okommunaliserbarhet_1_N = mkN "okommunaliserbarhet" ; -- okommunaliserbarhet..nn.1
  okommunicerad_1_A = mkA "okommunicerad" ; -- okommunicerad..av.1
  okommunicerbar_1_A = mkA "okommunicerbar" ; -- okommunicerbar..av.1
  okommunicerbarhet_1_N = mkN "okommunicerbarhet" ; -- okommunicerbarhet..nn.1
  okommuterad_1_A = mkA "okommuterad" ; -- okommuterad..av.1
  okommuterbar_1_A = mkA "okommuterbar" ; -- okommuterbar..av.1
  okommuterbarhet_1_N = mkN "okommuterbarhet" ; -- okommuterbarhet..nn.1
  okompad_1_A = mkA "okompad" ; -- okompad..av.1
  okomparerad_1_A = mkA "okomparerad" ; -- okomparerad..av.1
  okomparerbar_1_A = mkA "okomparerbar" ; -- okomparerbar..av.1
  okomparerbarhet_1_N = mkN "okomparerbarhet" ; -- okomparerbarhet..nn.1
  okompenserad_1_A = mkA "okompenserad" ; -- okompenserad..av.1
  okompenserbar_1_A = mkA "okompenserbar" ; -- okompenserbar..av.1
  okompenserbarhet_1_N = mkN "okompenserbarhet" ; -- okompenserbarhet..nn.1
  okompilerad_1_A = mkA "okompilerad" ; -- okompilerad..av.1
  okompilerbar_1_A = mkA "okompilerbar" ; -- okompilerbar..av.1
  okompilerbarhet_1_N = mkN "okompilerbarhet" ; -- okompilerbarhet..nn.1
  okompletterad_1_A = mkA "okompletterad" ; -- okompletterad..av.1
  okompletterbar_1_A = mkA "okompletterbar" ; -- okompletterbar..av.1
  okompletterbarhet_1_N = mkN "okompletterbarhet" ; -- okompletterbarhet..nn.1
  okomplicerad_1_A = mkA "okomplicerad" ; -- okomplicerad..av.1
  okomplicerbar_1_A = mkA "okomplicerbar" ; -- okomplicerbar..av.1
  okomplicerbarhet_1_N = mkN "okomplicerbarhet" ; -- okomplicerbarhet..nn.1
  okomplimenterad_1_A = mkA "okomplimenterad" ; -- okomplimenterad..av.1
  okomplimenterbar_1_A = mkA "okomplimenterbar" ; -- okomplimenterbar..av.1
  okomplimenterbarhet_1_N = mkN "okomplimenterbarhet" ; -- okomplimenterbarhet..nn.1
  okomponerad_1_A = mkA "okomponerad" ; -- okomponerad..av.1
  okomponerbar_1_A = mkA "okomponerbar" ; -- okomponerbar..av.1
  okomponerbarhet_1_N = mkN "okomponerbarhet" ; -- okomponerbarhet..nn.1
  okomposterad_1_A = mkA "okomposterad" ; -- okomposterad..av.1
  okomposterbar_1_A = mkA "okomposterbar" ; -- okomposterbar..av.1
  okomposterbarhet_1_N = mkN "okomposterbarhet" ; -- okomposterbarhet..nn.1
  okomprimerad_1_A = mkA "okomprimerad" ; -- okomprimerad..av.1
  okomprimerbar_1_A = mkA "okomprimerbar" ; -- okomprimerbar..av.1
  okomprimerbarhet_1_N = mkN "okomprimerbarhet" ; -- okomprimerbarhet..nn.1
  okomprometterad_1_A = mkA "okomprometterad" ; -- okomprometterad..av.1
  okomprometterbar_1_A = mkA "okomprometterbar" ; -- okomprometterbar..av.1
  okomprometterbarhet_1_N = mkN "okomprometterbarhet" ; -- okomprometterbarhet..nn.1
  okoncentrerad_1_A = mkA "okoncentrerad" ; -- okoncentrerad..av.1
  okoncentrerbar_1_A = mkA "okoncentrerbar" ; -- okoncentrerbar..av.1
  okoncentrerbarhet_1_N = mkN "okoncentrerbarhet" ; -- okoncentrerbarhet..nn.1
  okoncessionerad_1_A = mkA "okoncessionerad" ; -- okoncessionerad..av.1
  okoncessionerbar_1_A = mkA "okoncessionerbar" ; -- okoncessionerbar..av.1
  okoncessionerbarhet_1_N = mkN "okoncessionerbarhet" ; -- okoncessionerbarhet..nn.1
  okoncipierad_1_A = mkA "okoncipierad" ; -- okoncipierad..av.1
  okoncipierbar_1_A = mkA "okoncipierbar" ; -- okoncipierbar..av.1
  okoncipierbarhet_1_N = mkN "okoncipierbarhet" ; -- okoncipierbarhet..nn.1
  okondemnerad_1_A = mkA "okondemnerad" ; -- okondemnerad..av.1
  okondemnerbar_1_A = mkA "okondemnerbar" ; -- okondemnerbar..av.1
  okondemnerbarhet_1_N = mkN "okondemnerbarhet" ; -- okondemnerbarhet..nn.1
  okondenserad_1_A = mkA "okondenserad" ; -- okondenserad..av.1
  okondenserbar_1_A = mkA "okondenserbar" ; -- okondenserbar..av.1
  okondenserbarhet_1_N = mkN "okondenserbarhet" ; -- okondenserbarhet..nn.1
  okonditionerad_1_A = mkA "okonditionerad" ; -- okonditionerad..av.1
  okonditionerbar_1_A = mkA "okonditionerbar" ; -- okonditionerbar..av.1
  okonditionerbarhet_1_N = mkN "okonditionerbarhet" ; -- okonditionerbarhet..nn.1
  okondolerad_1_A = mkA "okondolerad" ; -- okondolerad..av.1
  okondolerbar_1_A = mkA "okondolerbar" ; -- okondolerbar..av.1
  okondolerbarhet_1_N = mkN "okondolerbarhet" ; -- okondolerbarhet..nn.1
  okonfigurerbar_1_A = mkA "okonfigurerbar" ; -- okonfigurerbar..av.1
  okonfigurerbarhet_1_N = mkN "okonfigurerbarhet" ; -- okonfigurerbarhet..nn.1
  okonfirmerad_1_A = mkA "okonfirmerad" ; -- okonfirmerad..av.1
  okonfirmerbar_1_A = mkA "okonfirmerbar" ; -- okonfirmerbar..av.1
  okonfirmerbarhet_1_N = mkN "okonfirmerbarhet" ; -- okonfirmerbarhet..nn.1
  okonfiskerad_1_A = mkA "okonfiskerad" ; -- okonfiskerad..av.1
  okonfiskerbar_1_A = mkA "okonfiskerbar" ; -- okonfiskerbar..av.1
  okonfiskerbarhet_1_N = mkN "okonfiskerbarhet" ; -- okonfiskerbarhet..nn.1
  okonfronterad_1_A = mkA "okonfronterad" ; -- okonfronterad..av.1
  okonfronterbar_1_A = mkA "okonfronterbar" ; -- okonfronterbar..av.1
  okonfronterbarhet_1_N = mkN "okonfronterbarhet" ; -- okonfronterbarhet..nn.1
  okonfunderad_1_A = mkA "okonfunderad" ; -- okonfunderad..av.1
  okonfunderbar_1_A = mkA "okonfunderbar" ; -- okonfunderbar..av.1
  okonfunderbarhet_1_N = mkN "okonfunderbarhet" ; -- okonfunderbarhet..nn.1
  okongruerad_1_A = mkA "okongruerad" ; -- okongruerad..av.1
  okongruerbar_1_A = mkA "okongruerbar" ; -- okongruerbar..av.1
  okongruerbarhet_1_N = mkN "okongruerbarhet" ; -- okongruerbarhet..nn.1
  okonjugerad_1_A = mkA "okonjugerad" ; -- okonjugerad..av.1
  okonjugerbar_1_A = mkA "okonjugerbar" ; -- okonjugerbar..av.1
  okonjugerbarhet_1_N = mkN "okonjugerbarhet" ; -- okonjugerbarhet..nn.1
  okonkluderad_1_A = mkA "okonkluderad" ; -- okonkluderad..av.1
  okonkluderbar_1_A = mkA "okonkluderbar" ; -- okonkluderbar..av.1
  okonkluderbarhet_1_N = mkN "okonkluderbarhet" ; -- okonkluderbarhet..nn.1
  okonkretiserad_1_A = mkA "okonkretiserad" ; -- okonkretiserad..av.1
  okonkretiserbar_1_A = mkA "okonkretiserbar" ; -- okonkretiserbar..av.1
  okonkretiserbarhet_1_N = mkN "okonkretiserbarhet" ; -- okonkretiserbarhet..nn.1
  okonserverad_1_A = mkA "okonserverad" ; -- okonserverad..av.1
  okonserverbar_1_A = mkA "okonserverbar" ; -- okonserverbar..av.1
  okonserverbarhet_1_N = mkN "okonserverbarhet" ; -- okonserverbarhet..nn.1
  okonsignerad_1_A = mkA "okonsignerad" ; -- okonsignerad..av.1
  okonsignerbar_1_A = mkA "okonsignerbar" ; -- okonsignerbar..av.1
  okonsignerbarhet_1_N = mkN "okonsignerbarhet" ; -- okonsignerbarhet..nn.1
  okonsoliderad_1_A = mkA "okonsoliderad" ; -- okonsoliderad..av.1
  okonsoliderbar_1_A = mkA "okonsoliderbar" ; -- okonsoliderbar..av.1
  okonsoliderbarhet_1_N = mkN "okonsoliderbarhet" ; -- okonsoliderbarhet..nn.1
  okonstaterad_1_A = mkA "okonstaterad" ; -- okonstaterad..av.1
  okonstaterbar_1_A = mkA "okonstaterbar" ; -- okonstaterbar..av.1
  okonstaterbarhet_1_N = mkN "okonstaterbarhet" ; -- okonstaterbarhet..nn.1
  okonstbefruktad_1_A = mkA "okonstbefruktad" ; -- okonstbefruktad..av.1
  okonstbevattnad_1_A = mkA "okonstbevattnad" ; -- okonstbevattnad..av.1
  okonsternerad_1_A = mkA "okonsternerad" ; -- okonsternerad..av.1
  okonsternerbar_1_A = mkA "okonsternerbar" ; -- okonsternerbar..av.1
  okonsternerbarhet_1_N = mkN "okonsternerbarhet" ; -- okonsternerbarhet..nn.1
  okonstituerad_1_A = mkA "okonstituerad" ; -- okonstituerad..av.1
  okonstituerbar_1_A = mkA "okonstituerbar" ; -- okonstituerbar..av.1
  okonstituerbarhet_1_N = mkN "okonstituerbarhet" ; -- okonstituerbarhet..nn.1
  okonstlad_1_A = mkA "okonstlad" ; -- okonstlad..av.1
  okonstruerad_1_A = mkA "okonstruerad" ; -- okonstruerad..av.1
  okonstruerbar_1_A = mkA "okonstruerbar" ; -- okonstruerbar..av.1
  okonstruerbarhet_1_N = mkN "okonstruerbarhet" ; -- okonstruerbarhet..nn.1
  okonsulterad_1_A = mkA "okonsulterad" ; -- okonsulterad..av.1
  okonsulterbar_1_A = mkA "okonsulterbar" ; -- okonsulterbar..av.1
  okonsulterbarhet_1_N = mkN "okonsulterbarhet" ; -- okonsulterbarhet..nn.1
  okonsumerad_1_A = mkA "okonsumerad" ; -- okonsumerad..av.1
  okonsumerbar_1_A = mkA "okonsumerbar" ; -- okonsumerbar..av.1
  okonsumerbarhet_1_N = mkN "okonsumerbarhet" ; -- okonsumerbarhet..nn.1
  okontaktad_1_A = mkA "okontaktad" ; -- okontaktad..av.1
  okontaminerad_1_A = mkA "okontaminerad" ; -- okontaminerad..av.1
  okontaminerbar_1_A = mkA "okontaminerbar" ; -- okontaminerbar..av.1
  okontaminerbarhet_1_N = mkN "okontaminerbarhet" ; -- okontaminerbarhet..nn.1
  okontant_1_A = mkA "okontant" "okontant" ; -- okontant..av.1
  okonterad_1_A = mkA "okonterad" ; -- okonterad..av.1
  okonterbar_1_A = mkA "okonterbar" ; -- okonterbar..av.1
  okonterbarhet_1_N = mkN "okonterbarhet" ; -- okonterbarhet..nn.1
  okontingenterad_1_A = mkA "okontingenterad" ; -- okontingenterad..av.1
  okontingenterbar_1_A = mkA "okontingenterbar" ; -- okontingenterbar..av.1
  okontingenterbarhet_1_N = mkN "okontingenterbarhet" ; -- okontingenterbarhet..nn.1
  okontoriserad_1_A = mkA "okontoriserad" ; -- okontoriserad..av.1
  okontoriserbar_1_A = mkA "okontoriserbar" ; -- okontoriserbar..av.1
  okontoriserbarhet_1_N = mkN "okontoriserbarhet" ; -- okontoriserbarhet..nn.1
  okontraherad_1_A = mkA "okontraherad" ; -- okontraherad..av.1
  okontraherbar_1_A = mkA "okontraherbar" ; -- okontraherbar..av.1
  okontraherbarhet_1_N = mkN "okontraherbarhet" ; -- okontraherbarhet..nn.1
  okontrakterad_1_A = mkA "okontrakterad" ; -- okontrakterad..av.1
  okontrakterbar_1_A = mkA "okontrakterbar" ; -- okontrakterbar..av.1
  okontrakterbarhet_1_N = mkN "okontrakterbarhet" ; -- okontrakterbarhet..nn.1
  okontramanderad_1_A = mkA "okontramanderad" ; -- okontramanderad..av.1
  okontramanderbar_1_A = mkA "okontramanderbar" ; -- okontramanderbar..av.1
  okontramanderbarhet_1_N = mkN "okontramanderbarhet" ; -- okontramanderbarhet..nn.1
  okontrasignerad_1_A = mkA "okontrasignerad" ; -- okontrasignerad..av.1
  okontrasignerbar_1_A = mkA "okontrasignerbar" ; -- okontrasignerbar..av.1
  okontrasignerbarhet_1_N = mkN "okontrasignerbarhet" ; -- okontrasignerbarhet..nn.1
  okontrasterad_1_A = mkA "okontrasterad" ; -- okontrasterad..av.1
  okontrasterbar_1_A = mkA "okontrasterbar" ; -- okontrasterbar..av.1
  okontrasterbarhet_1_N = mkN "okontrasterbarhet" ; -- okontrasterbarhet..nn.1
  okontribuerad_1_A = mkA "okontribuerad" ; -- okontribuerad..av.1
  okontribuerbar_1_A = mkA "okontribuerbar" ; -- okontribuerbar..av.1
  okontribuerbarhet_1_N = mkN "okontribuerbarhet" ; -- okontribuerbarhet..nn.1
  okontrollerad_1_A = mkA "okontrollerad" ; -- okontrollerad..av.1
  okontrollerbar_1_A = mkA "okontrollerbar" ; -- okontrollerbar..av.1
  okontrollerbarhet_1_N = mkN "okontrollerbarhet" ; -- okontrollerbarhet..nn.1
  okontroversiell_1_A = mkA "okontroversiell" ; -- okontroversiell..av.1
  okonturerad_1_A = mkA "okonturerad" ; -- okonturerad..av.1
  okonturerbar_1_A = mkA "okonturerbar" ; -- okonturerbar..av.1
  okonturerbarhet_1_N = mkN "okonturerbarhet" ; -- okonturerbarhet..nn.1
  okonventionell_1_A = mkA "okonventionell" ; -- okonventionell..av.1
  okonvergerad_1_A = mkA "okonvergerad" ; -- okonvergerad..av.1
  okonvergerbar_1_A = mkA "okonvergerbar" ; -- okonvergerbar..av.1
  okonvergerbarhet_1_N = mkN "okonvergerbarhet" ; -- okonvergerbarhet..nn.1
  okonverserad_1_A = mkA "okonverserad" ; -- okonverserad..av.1
  okonverserbar_1_A = mkA "okonverserbar" ; -- okonverserbar..av.1
  okonverserbarhet_1_N = mkN "okonverserbarhet" ; -- okonverserbarhet..nn.1
  okonverterad_1_A = mkA "okonverterad" ; -- okonverterad..av.1
  okonverterbar_1_A = mkA "okonverterbar" ; -- okonverterbar..av.1
  okonverterbarhet_1_N = mkN "okonverterbarhet" ; -- okonverterbarhet..nn.1
  okonvojerad_1_A = mkA "okonvojerad" ; -- okonvojerad..av.1
  okonvojerbar_1_A = mkA "okonvojerbar" ; -- okonvojerbar..av.1
  okonvojerbarhet_1_N = mkN "okonvojerbarhet" ; -- okonvojerbarhet..nn.1
  okoordinerad_1_A = mkA "okoordinerad" ; -- okoordinerad..av.1
  okoordinerbar_1_A = mkA "okoordinerbar" ; -- okoordinerbar..av.1
  okoordinerbarhet_1_N = mkN "okoordinerbarhet" ; -- okoordinerbarhet..nn.1
  okopierad_1_A = mkA "okopierad" ; -- okopierad..av.1
  okopierbar_1_A = mkA "okopierbar" ; -- okopierbar..av.1
  okopierbarhet_1_N = mkN "okopierbarhet" ; -- okopierbarhet..nn.1
  okoppad_1_A = mkA "okoppad" ; -- okoppad..av.1
  okopplad_1_A = mkA "okopplad" ; -- okopplad..av.1
  okorad_1_A = mkA "okorad" ; -- okorad..av.1
  okoreograferbar_1_A = mkA "okoreograferbar" ; -- okoreograferbar..av.1
  okoreograferbarhet_1_N = mkN "okoreograferbarhet" ; -- okoreograferbarhet..nn.1
  okorkad_1_A = mkA "okorkad" ; -- okorkad..av.1
  okorpad_1_A = mkA "okorpad" ; -- okorpad..av.1
  okorrelerad_1_A = mkA "okorrelerad" ; -- okorrelerad..av.1
  okorrelerbar_1_A = mkA "okorrelerbar" ; -- okorrelerbar..av.1
  okorrelerbarhet_1_N = mkN "okorrelerbarhet" ; -- okorrelerbarhet..nn.1
  okorrigerad_1_A = mkA "okorrigerad" ; -- okorrigerad..av.1
  okorrigerbar_1_A = mkA "okorrigerbar" ; -- okorrigerbar..av.1
  okorrigerbarhet_1_N = mkN "okorrigerbarhet" ; -- okorrigerbarhet..nn.1
  okorroderad_1_A = mkA "okorroderad" ; -- okorroderad..av.1
  okorroderbar_1_A = mkA "okorroderbar" ; -- okorroderbar..av.1
  okorroderbarhet_1_N = mkN "okorroderbarhet" ; -- okorroderbarhet..nn.1
  okorrugerad_1_A = mkA "okorrugerad" ; -- okorrugerad..av.1
  okorrugerbar_1_A = mkA "okorrugerbar" ; -- okorrugerbar..av.1
  okorrugerbarhet_1_N = mkN "okorrugerbarhet" ; -- okorrugerbarhet..nn.1
  okorrumperad_1_A = mkA "okorrumperad" ; -- okorrumperad..av.1
  okorrumperbar_1_A = mkA "okorrumperbar" ; -- okorrumperbar..av.1
  okorrumperbarhet_1_N = mkN "okorrumperbarhet" ; -- okorrumperbarhet..nn.1
  okorsad_1_A = mkA "okorsad" ; -- okorsad..av.1
  okorsetterad_1_A = mkA "okorsetterad" ; -- okorsetterad..av.1
  okorsetterbar_1_A = mkA "okorsetterbar" ; -- okorsetterbar..av.1
  okorsetterbarhet_1_N = mkN "okorsetterbarhet" ; -- okorsetterbarhet..nn.1
  okorsförhörd_1_A = mkA "okorsförhörd" "okorsförhört" ; -- okorsförhörd..av.1
  okortad_1_A = mkA "okortad" ; -- okortad..av.1
  okostymerad_1_A = mkA "okostymerad" ; -- okostymerad..av.1
  okostymerbar_1_A = mkA "okostymerbar" ; -- okostymerbar..av.1
  okostymerbarhet_1_N = mkN "okostymerbarhet" ; -- okostymerbarhet..nn.1
  okrackad_1_A = mkA "okrackad" ; -- okrackad..av.1
  okrackelerad_1_A = mkA "okrackelerad" ; -- okrackelerad..av.1
  okrackelerbar_1_A = mkA "okrackelerbar" ; -- okrackelerbar..av.1
  okrackelerbarhet_1_N = mkN "okrackelerbarhet" ; -- okrackelerbarhet..nn.1
  okrafsad_1_A = mkA "okrafsad" ; -- okrafsad..av.1
  okramad_1_A = mkA "okramad" ; -- okramad..av.1
  okransad_1_A = mkA "okransad" ; -- okransad..av.1
  okraschad_1_A = mkA "okraschad" ; -- okraschad..av.1
  okratsad_1_A = mkA "okratsad" ; -- okratsad..av.1
  okrattad_1_A = mkA "okrattad" ; -- okrattad..av.1
  okredensad_1_A = mkA "okredensad" ; -- okredensad..av.1
  okrediterad_1_A = mkA "okrediterad" ; -- okrediterad..av.1
  okrediterbar_1_A = mkA "okrediterbar" ; -- okrediterbar..av.1
  okrediterbarhet_1_N = mkN "okrediterbarhet" ; -- okrediterbarhet..nn.1
  okreerad_1_A = mkA "okreerad" ; -- okreerad..av.1
  okreerbar_1_A = mkA "okreerbar" ; -- okreerbar..av.1
  okreerbarhet_1_N = mkN "okreerbarhet" ; -- okreerbarhet..nn.1
  okremerad_1_A = mkA "okremerad" ; -- okremerad..av.1
  okremerbar_1_A = mkA "okremerbar" ; -- okremerbar..av.1
  okremerbarhet_1_N = mkN "okremerbarhet" ; -- okremerbarhet..nn.1
  okreperad_1_A = mkA "okreperad" ; -- okreperad..av.1
  okreperbar_1_A = mkA "okreperbar" ; -- okreperbar..av.1
  okreperbarhet_1_N = mkN "okreperbarhet" ; -- okreperbarhet..nn.1
  okretad_1_A = mkA "okretad" ; -- okretad..av.1
  okreverad_1_A = mkA "okreverad" ; -- okreverad..av.1
  okreverbar_1_A = mkA "okreverbar" ; -- okreverbar..av.1
  okreverbarhet_1_N = mkN "okreverbarhet" ; -- okreverbarhet..nn.1
  okrigisk_1_A = mkA "okrigisk" ; -- okrigisk..av.1
  okriminaliserad_1_A = mkA "okriminaliserad" ; -- okriminaliserad..av.1
  okriminaliserbar_1_A = mkA "okriminaliserbar" ; -- okriminaliserbar..av.1
  okriminaliserbarhet_1_N = mkN "okriminaliserbarhet" ; -- okriminaliserbarhet..nn.1
  okringgärdad_1_A = mkA "okringgärdad" ; -- okringgärdad..av.1
  okringränd_1_A = mkA "okringränd" ; -- okringränd..av.1
  okringskansad_1_A = mkA "okringskansad" ; -- okringskansad..av.1
  okristalliserad_1_A = mkA "okristalliserad" ; -- okristalliserad..av.1
  okristalliserbar_1_A = mkA "okristalliserbar" ; -- okristalliserbar..av.1
  okristalliserbarhet_1_N = mkN "okristalliserbarhet" ; -- okristalliserbarhet..nn.1
  okristlig_1_A = mkA "okristlig" ; -- okristlig..av.1
  okristlighet_1_N = mkN "okristlighet" "okristligheter" ; -- okristlighet..nn.1
  okristnad_1_A = mkA "okristnad" ; -- okristnad..av.1
  okritad_1_A = mkA "okritad" ; -- okritad..av.1
  okritiserad_1_A = mkA "okritiserad" ; -- okritiserad..av.1
  okritiserbar_1_A = mkA "okritiserbar" ; -- okritiserbar..av.1
  okritiserbarhet_1_N = mkN "okritiserbarhet" ; -- okritiserbarhet..nn.1
  okritisk_1_A = mkA "okritisk" ; -- okritisk..av.1
  okrockad_1_A = mkA "okrockad" ; -- okrockad..av.1
  okrokad_1_A = mkA "okrokad" ; -- okrokad..av.1
  okroknad_1_A = mkA "okroknad" ; -- okroknad..av.1
  okromad_1_A = mkA "okromad" ; -- okromad..av.1
  okroppslig_1_A = mkA "okroppslig" ; -- okroppslig..av.1
  okroppslighet_1_N = mkN "okroppslighet" ; -- okroppslighet..nn.1
  okrossad_1_A = mkA "okrossad" ; -- okrossad..av.1
  okrossbar_1_A = mkA "okrossbar" ; -- okrossbar..av.1
  okrossbarhet_1_N = mkN "okrossbarhet" ; -- okrossbarhet..nn.1
  okrullad_1_A = mkA "okrullad" ; -- okrullad..av.1
  okrusad_1_A = mkA "okrusad" ; -- okrusad..av.1
  okryddad_1_A = mkA "okryddad" ; -- okryddad..av.1
  okrympt_1_A = mkA "okrympt" "okrympt" ; -- okrympt..av.1
  okrypterad_1_A = mkA "okrypterad" ; -- okrypterad..av.1
  okrypterbar_1_A = mkA "okrypterbar" ; -- okrypterbar..av.1
  okrypterbarhet_1_N = mkN "okrypterbarhet" ; -- okrypterbarhet..nn.1
  okryssad_1_A = mkA "okryssad" ; -- okryssad..av.1
  okrängd_1_A = mkA "okrängd" "okrängt" ; -- okrängd..av.1
  okränkbar_1_A = mkA "okränkbar" ; -- okränkbar..av.1
  okränkbarhet_1_N = mkN "okränkbarhet" ; -- okränkbarhet..nn.1
  okränkt_1_A = mkA "okränkt" "okränkt" ; -- okränkt..av.1
  okräppad_1_A = mkA "okräppad" ; -- okräppad..av.1
  okrävd_1_A = mkA "okrävd" "okrävt" ; -- okrävd..av.1
  okrökt_1_A = mkA "okrökt" "okrökt" ; -- okrökt..av.1
  okrönt_1_A = mkA "okrönt" "okrönt" ; -- okrönt..av.1
  oktaeder_1_N = mkN "oktaeder" ; -- oktaeder..nn.1
  oktan_1_N = mkN "oktan" neutrum  ; -- oktan..nn.1
  oktanol_1_N = mkN "oktanol" "oktanoler" ; -- oktanol..nn.1
  oktant_1_N = mkN "oktant" "oktanter" ; -- oktant..nn.1
  oktantal_1_N = mkN "oktantal" neutrum  ; -- oktantal..nn.1
  oktanvärde_1_N = mkN "oktanvärde" ; -- oktanvärde..nn.1
  oktav_1_N = mkN "oktav" "oktaver" ; -- oktav..nn.1
  oktavera_1_V = mkV "oktaverar" ; -- oktavera..vb.1
  oktaverande_1_N = mkN "oktaverande" ; -- oktaverande..nn.1
  oktavering_1_N = mkN "oktavering" ; -- oktavering..nn.1
  oktett_1_N = mkN "oktett" "oktetter" ; -- oktett..nn.1
  oktober_1_N = mkN "oktober" ; -- oktober..nn.1
  oktoberhimmel_1_N = mkN "oktoberhimmel" ; -- oktoberhimmel..nn.1
  oktoberrusk_1_N = mkN "oktoberrusk" neutrum  ; -- oktoberrusk..nn.1
  oktod_1_N = mkN "oktod" "oktoder" ; -- oktod..nn.1
  oktogen_1_N = mkN "oktogen" neutrum  ; -- oktogen..nn.1
  oktogon_1_N = mkN "oktogon" "oktogoner" ; -- oktogon..nn.1
  oktroj_1_N = mkN "oktroj" "oktrojer" ; -- oktroj..nn.1
  oktrojera_1_V = mkV "oktrojerar" ; -- oktrojera..vb.1
  oktrojerande_1_N = mkN "oktrojerande" ; -- oktrojerande..nn.1
  oktrojerbar_1_A = mkA "oktrojerbar" ; -- oktrojerbar..av.1
  oktrojerbarhet_1_N = mkN "oktrojerbarhet" ; -- oktrojerbarhet..nn.1
  oktrojering_1_N = mkN "oktrojering" ; -- oktrojering..nn.1
  okuberad_1_A = mkA "okuberad" ; -- okuberad..av.1
  okuberbar_1_A = mkA "okuberbar" ; -- okuberbar..av.1
  okuberbarhet_1_N = mkN "okuberbarhet" ; -- okuberbarhet..nn.1
  okuggad_1_A = mkA "okuggad" ; -- okuggad..av.1
  okujonerad_1_A = mkA "okujonerad" ; -- okujonerad..av.1
  okujonerbar_1_A = mkA "okujonerbar" ; -- okujonerbar..av.1
  okujonerbarhet_1_N = mkN "okujonerbarhet" ; -- okujonerbarhet..nn.1
  okulage_1_N = mkN "okulage" "okulaget" "okulager" "okulagerna" ; -- okulage..nn.1
  okular_1_A = mkA "okular" ; -- okular..av.1
  okular_1_N = mkN "okular" neutrum  ; -- okular..nn.1
  okularbesiktning_1_N = mkN "okularbesiktning" ; -- okularbesiktning..nn.1
  okulera_1_V = mkV "okulerar" ; -- okulera..vb.1
  okulerande_1_N = mkN "okulerande" ; -- okulerande..nn.1
  okulerbar_1_A = mkA "okulerbar" ; -- okulerbar..av.1
  okulerbarhet_1_N = mkN "okulerbarhet" ; -- okulerbarhet..nn.1
  okulering_1_N = mkN "okulering" ; -- okulering..nn.1
  okullad_1_A = mkA "okullad" ; -- okullad..av.1
  okullkastad_1_A = mkA "okullkastad" ; -- okullkastad..av.1
  okullpratad_1_A = mkA "okullpratad" ; -- okullpratad..av.1
  okultiverad_1_A = mkA "okultiverad" ; -- okultiverad..av.1
  okultiverbar_1_A = mkA "okultiverbar" ; -- okultiverbar..av.1
  okultiverbarhet_1_N = mkN "okultiverbarhet" ; -- okultiverbarhet..nn.1
  okultur_1_N = mkN "okultur" ; -- okultur..nn.1
  okulär_1_A = mkA "okulär" ; -- okulär..av.1
  okumulerad_1_A = mkA "okumulerad" ; -- okumulerad..av.1
  okumulerbar_1_A = mkA "okumulerbar" ; -- okumulerbar..av.1
  okumulerbarhet_1_N = mkN "okumulerbarhet" ; -- okumulerbarhet..nn.1
  okunnig_1_A = mkA "okunnig" ; -- okunnig..av.1
  okunnighet_1_N = mkN "okunnighet" "okunnigheter" ; -- okunnighet..nn.1
  okunnighetsstämpel_1_N = mkN "okunnighetsstämpel" ; -- okunnighetsstämpel..nn.1
  okunskap_1_N = mkN "okunskap" ; -- okunskap..nn.1
  okupad_1_A = mkA "okupad" ; -- okupad..av.1
  okuperad_1_A = mkA "okuperad" ; -- okuperad..av.1
  okuperbar_1_A = mkA "okuperbar" ; -- okuperbar..av.1
  okuperbarhet_1_N = mkN "okuperbarhet" ; -- okuperbarhet..nn.1
  okurad_1_A = mkA "okurad" ; -- okurad..av.1
  okuraterad_1_A = mkA "okuraterad" ; -- okuraterad..av.1
  okuraterbar_1_A = mkA "okuraterbar" ; -- okuraterbar..av.1
  okuraterbarhet_1_N = mkN "okuraterbarhet" ; -- okuraterbarhet..nn.1
  okurerad_1_A = mkA "okurerad" ; -- okurerad..av.1
  okurerbar_1_A = mkA "okurerbar" ; -- okurerbar..av.1
  okurerbarhet_1_N = mkN "okurerbarhet" ; -- okurerbarhet..nn.1
  okursad_1_A = mkA "okursad" ; -- okursad..av.1
  okursiverad_1_A = mkA "okursiverad" ; -- okursiverad..av.1
  okursiverbar_1_A = mkA "okursiverbar" ; -- okursiverbar..av.1
  okursiverbarhet_1_N = mkN "okursiverbarhet" ; -- okursiverbarhet..nn.1
  okurtiserad_1_A = mkA "okurtiserad" ; -- okurtiserad..av.1
  okurtiserbar_1_A = mkA "okurtiserbar" ; -- okurtiserbar..av.1
  okurtiserbarhet_1_N = mkN "okurtiserbarhet" ; -- okurtiserbarhet..nn.1
  okuschad_1_A = mkA "okuschad" ; -- okuschad..av.1
  okuvad_1_A = mkA "okuvad" ; -- okuvad..av.1
  okuverterad_1_A = mkA "okuverterad" ; -- okuverterad..av.1
  okuverterbar_1_A = mkA "okuverterbar" ; -- okuverterbar..av.1
  okuverterbarhet_1_N = mkN "okuverterbarhet" ; -- okuverterbarhet..nn.1
  okuvlig_1_A = mkA "okuvlig" ; -- okuvlig..av.1
  okuvlighet_1_N = mkN "okuvlighet" ; -- okuvlighet..nn.1
  okvaddad_1_A = mkA "okvaddad" ; -- okvaddad..av.1
  okvadrerad_1_A = mkA "okvadrerad" ; -- okvadrerad..av.1
  okvadrerbar_1_A = mkA "okvadrerbar" ; -- okvadrerbar..av.1
  okvadrerbarhet_1_N = mkN "okvadrerbarhet" ; -- okvadrerbarhet..nn.1
  okvald_1_A = mkA "okvald" "okvalt" ; -- okvald..av.1
  okvalificerad_1_A = mkA "okvalificerad" ; -- okvalificerad..av.1
  okvalificerbar_1_A = mkA "okvalificerbar" ; -- okvalificerbar..av.1
  okvalificerbarhet_1_N = mkN "okvalificerbarhet" ; -- okvalificerbarhet..nn.1
  okvantifierad_1_A = mkA "okvantifierad" ; -- okvantifierad..av.1
  okvantifierbar_1_A = mkA "okvantifierbar" ; -- okvantifierbar..av.1
  okvantifierbarhet_1_N = mkN "okvantifierbarhet" ; -- okvantifierbarhet..nn.1
  okvardröjd_1_A = mkA "okvardröjd" "okvardröjt" ; -- okvardröjd..av.1
  okvarlämnad_1_A = mkA "okvarlämnad" ; -- okvarlämnad..av.1
  okvarstannad_1_A = mkA "okvarstannad" ; -- okvarstannad..av.1
  okviltad_1_A = mkA "okviltad" ; -- okviltad..av.1
  okvinnlig_1_A = mkA "okvinnlig" ; -- okvinnlig..av.1
  okvinnlighet_1_N = mkN "okvinnlighet" ; -- okvinnlighet..nn.1
  okvistad_1_A = mkA "okvistad" ; -- okvistad..av.1
  okvittad_1_A = mkA "okvittad" ; -- okvittad..av.1
  okvitterad_1_A = mkA "okvitterad" ; -- okvitterad..av.1
  okvitterbar_1_A = mkA "okvitterbar" ; -- okvitterbar..av.1
  okvitterbarhet_1_N = mkN "okvitterbarhet" ; -- okvitterbarhet..nn.1
  okvoterad_1_A = mkA "okvoterad" ; -- okvoterad..av.1
  okvoterbar_1_A = mkA "okvoterbar" ; -- okvoterbar..av.1
  okvoterbarhet_1_N = mkN "okvoterbarhet" ; -- okvoterbarhet..nn.1
  okväda_1_V = mkV "okvädar" ; -- okväda..vb.1
  okvädande_1_N = mkN "okvädande" ; -- okvädande..nn.1
  okväde_1_N = mkN "okväde" ; -- okväde..nn.1
  okväden_1_A = mkA "okväden" ; -- okväden..av.1
  okvädingsord_1_N = mkN "okvädingsord" neutrum  ; -- okvädingsord..nn.1
  okvädinsord_1_N = mkN "okvädinsord" neutrum  ; -- okvädinsord..nn.1
  okväst_1_A = mkA "okväst" "okväst" ; -- okväst..av.1
  okvävd_1_A = mkA "okvävd" "okvävt" ; -- okvävd..av.1
  okyld_1_A = mkA "okyld" "okylt" ; -- okyld..av.1
  okynne_1_N = mkN "okynne" ; -- okynne..nn.1
  okynnesanvända_1_V = mkV "okynnesanvänder" ; -- okynnesanvända..vb.1
  okynnesanvändande_1_N = mkN "okynnesanvändande" ; -- okynnesanvändande..nn.1
  okynnesanvändning_1_N = mkN "okynnesanvändning" ; -- okynnesanvändning..nn.1
  okynnesfä_1_N = mkN "okynnesfä" "okynnesfät" "okynnesfän" "okynnesfäna" ; -- okynnesfä..nn.1
  okynneshund_1_N = mkN "okynneshund" ; -- okynneshund..nn.1
  okynnesjakt_1_N = mkN "okynnesjakt" "okynnesjakter" ; -- okynnesjakt..nn.1
  okynnesringa_1_V = mkV "okynnesringer" ; -- okynnesringa..vb.1
  okynnesringande_1_N = mkN "okynnesringande" ; -- okynnesringande..nn.1
  okynnesringning_1_N = mkN "okynnesringning" ; -- okynnesringning..nn.1
  okynnesstrejk_1_N = mkN "okynnesstrejk" "okynnesstrejker" ; -- okynnesstrejk..nn.1
  okynnesstrejka_1_V = mkV "okynnesstrejkar" ; -- okynnesstrejka..vb.1
  okynnesstrejkande_1_N = mkN "okynnesstrejkande" ; -- okynnesstrejkande..nn.1
  okynnig_1_A = mkA "okynnig" ; -- okynnig..av.1
  okynnighet_1_N = mkN "okynnighet" ; -- okynnighet..nn.1
  okyprad_1_A = mkA "okyprad" ; -- okyprad..av.1
  okyrklig_1_A = mkA "okyrklig" ; -- okyrklig..av.1
  okyrklighet_1_N = mkN "okyrklighet" ; -- okyrklighet..nn.1
  okysk_1_A = mkA "okysk" ; -- okysk..av.1
  okyskhet_1_N = mkN "okyskhet" "okyskheter" ; -- okyskhet..nn.1
  okysst_1_A = mkA "okysst" "okysst" ; -- okysst..av.1
  okäkad_1_A = mkA "okäkad" ; -- okäkad..av.1
  okälad_1_A = mkA "okälad" ; -- okälad..av.1
  okänd_1_A = mkA "okänd" ; -- okänd..av.1
  okändhet_1_N = mkN "okändhet" ; -- okändhet..nn.1
  okänslig_1_A = mkA "okänslig" ; -- okänslig..av.1
  okänslighet_1_N = mkN "okänslighet" "okänsligheter" ; -- okänslighet..nn.1
  okär_1_A = mkA "okär" ; -- okär..av.1
  okärad_1_A = mkA "okärad" ; -- okärad..av.1
  okärnad_1_A = mkA "okärnad" ; -- okärnad..av.1
  okånkad_1_A = mkA "okånkad" ; -- okånkad..av.1
  okårad_1_A = mkA "okårad" ; -- okårad..av.1
  okönad_1_A = mkA "okönad" ; -- okönad..av.1
  oköpt_1_A = mkA "oköpt" "oköpt" ; -- oköpt..av.1
  okörd_1_A = mkA "okörd" "okört" ; -- okörd..av.1
  okörnad_1_A = mkA "okörnad" ; -- okörnad..av.1
  okövd_1_A = mkA "okövd" "okövt" ; -- okövd..av.1
  ola_1_V = mkV "olar" ; -- ola..vb.1
  olabialiserad_1_A = mkA "olabialiserad" ; -- olabialiserad..av.1
  olabialiserbar_1_A = mkA "olabialiserbar" ; -- olabialiserbar..av.1
  olabialiserbarhet_1_N = mkN "olabialiserbarhet" ; -- olabialiserbarhet..nn.1
  olackad_1_A = mkA "olackad" ; -- olackad..av.1
  olackerad_1_A = mkA "olackerad" ; -- olackerad..av.1
  olackerbar_1_A = mkA "olackerbar" ; -- olackerbar..av.1
  olackerbarhet_1_N = mkN "olackerbarhet" ; -- olackerbarhet..nn.1
  oladdad_1_A = mkA "oladdad" ; -- oladdad..av.1
  olaga_1_A = mkA "olaga" ; -- olaga..av.1
  olagad_1_A = mkA "olagad" ; -- olagad..av.1
  olaggad_1_A = mkA "olaggad" ; -- olaggad..av.1
  olaglig_1_A = mkA "olaglig" ; -- olaglig..av.1
  olagligen_1_Adv = mkAdv "olagligen" ; -- olagligen..ab.1
  olagligförklara_1_V = mkV "olagligförklarar" ; -- olagligförklara..vb.1
  olaglighet_1_N = mkN "olaglighet" "olagligheter" ; -- olaglighet..nn.1
  olagrad_1_A = mkA "olagrad" ; -- olagrad..av.1
  olamenterad_1_A = mkA "olamenterad" ; -- olamenterad..av.1
  olamenterbar_1_A = mkA "olamenterbar" ; -- olamenterbar..av.1
  olamenterbarhet_1_N = mkN "olamenterbarhet" ; -- olamenterbarhet..nn.1
  olaminerad_1_A = mkA "olaminerad" ; -- olaminerad..av.1
  olaminerbar_1_A = mkA "olaminerbar" ; -- olaminerbar..av.1
  olaminerbarhet_1_N = mkN "olaminerbarhet" ; -- olaminerbarhet..nn.1
  olandad_1_A = mkA "olandad" ; -- olandad..av.1
  olande_1_N = mkN "olande" ; -- olande..nn.1
  olangad_1_A = mkA "olangad" ; -- olangad..av.1
  olangetterad_1_A = mkA "olangetterad" ; -- olangetterad..av.1
  olangetterbar_1_A = mkA "olangetterbar" ; -- olangetterbar..av.1
  olangetterbarhet_1_N = mkN "olangetterbarhet" ; -- olangetterbarhet..nn.1
  olanserad_1_A = mkA "olanserad" ; -- olanserad..av.1
  olanserbar_1_A = mkA "olanserbar" ; -- olanserbar..av.1
  olanserbarhet_1_N = mkN "olanserbarhet" ; -- olanserbarhet..nn.1
  olapad_1_A = mkA "olapad" ; -- olapad..av.1
  olapiserad_1_A = mkA "olapiserad" ; -- olapiserad..av.1
  olapiserbar_1_A = mkA "olapiserbar" ; -- olapiserbar..av.1
  olapiserbarhet_1_N = mkN "olapiserbarhet" ; -- olapiserbarhet..nn.1
  olappad_1_A = mkA "olappad" ; -- olappad..av.1
  olarmad_1_A = mkA "olarmad" ; -- olarmad..av.1
  olaserad_1_A = mkA "olaserad" ; -- olaserad..av.1
  olaserbar_1_A = mkA "olaserbar" ; -- olaserbar..av.1
  olaserbarhet_1_N = mkN "olaserbarhet" ; -- olaserbarhet..nn.1
  olaskad_1_A = mkA "olaskad" ; -- olaskad..av.1
  olastad_1_A = mkA "olastad" ; -- olastad..av.1
  olat_1_N = mkN "olat" "olater" ; -- olat..nn.1
  olatiniserad_1_A = mkA "olatiniserad" ; -- olatiniserad..av.1
  olatiniserbar_1_A = mkA "olatiniserbar" ; -- olatiniserbar..av.1
  olatiniserbarhet_1_N = mkN "olatiniserbarhet" ; -- olatiniserbarhet..nn.1
  olaverad_1_A = mkA "olaverad" ; -- olaverad..av.1
  olaverbar_1_A = mkA "olaverbar" ; -- olaverbar..av.1
  olaverbarhet_1_N = mkN "olaverbarhet" ; -- olaverbarhet..nn.1
  olaxad_1_A = mkA "olaxad" ; -- olaxad..av.1
  oldboy_1_N = mkN "oldboy" ; -- oldboy..nn.1
  oldtimer_1_N = mkN "oldtimer" "oldtimern" "oldtimers" "oldtimersarna" ; -- oldtimer..nn.1
  oleander_1_N = mkN "oleander" ; -- oleander..nn.1
  oleanderbuske_1_N = mkN "oleanderbuske" utrum  ; -- oleanderbuske..nn.1
  oleasad_1_A = mkA "oleasad" ; -- oleasad..av.1
  oleat_1_N = mkN "oleat" "oleater" ; -- oleat..nn.1
  oleat_2_N = mkN "oleat" neutrum  ; -- oleat..nn.2
  oledad_1_A = mkA "oledad" ; -- oledad..av.1
  oledare_1_N = mkN "oledare" utrum  ; -- oledare..nn.1
  oledsagad_1_A = mkA "oledsagad" ; -- oledsagad..av.1
  olefin_1_N = mkN "olefin" "olefiner" ; -- olefin..nn.1
  olegaliserad_1_A = mkA "olegaliserad" ; -- olegaliserad..av.1
  olegaliserbar_1_A = mkA "olegaliserbar" ; -- olegaliserbar..av.1
  olegaliserbarhet_1_N = mkN "olegaliserbarhet" ; -- olegaliserbarhet..nn.1
  olegerad_1_A = mkA "olegerad" ; -- olegerad..av.1
  olegerbar_1_A = mkA "olegerbar" ; -- olegerbar..av.1
  olegerbarhet_1_N = mkN "olegerbarhet" ; -- olegerbarhet..nn.1
  olegitimerad_1_A = mkA "olegitimerad" ; -- olegitimerad..av.1
  olegitimerbar_1_A = mkA "olegitimerbar" ; -- olegitimerbar..av.1
  olegitimerbarhet_1_N = mkN "olegitimerbarhet" ; -- olegitimerbarhet..nn.1
  olein_1_N = mkN "olein" ; -- olein..nn.1
  olejd_1_A = mkA "olejd" "olejt" ; -- olejd..av.1
  olejdrad_1_A = mkA "olejdrad" ; -- olejdrad..av.1
  olemlästad_1_A = mkA "olemlästad" ; -- olemlästad..av.1
  olenad_1_A = mkA "olenad" ; -- olenad..av.1
  oletad_1_A = mkA "oletad" ; -- oletad..av.1
  olettrad_1_A = mkA "olettrad" ; -- olettrad..av.1
  olevererad_1_A = mkA "olevererad" ; -- olevererad..av.1
  olevererbar_1_A = mkA "olevererbar" ; -- olevererbar..av.1
  olevererbarhet_1_N = mkN "olevererbarhet" ; -- olevererbarhet..nn.1
  oliberaliserad_1_A = mkA "oliberaliserad" ; -- oliberaliserad..av.1
  oliberaliserbar_1_A = mkA "oliberaliserbar" ; -- oliberaliserbar..av.1
  oliberaliserbarhet_1_N = mkN "oliberaliserbarhet" ; -- oliberaliserbarhet..nn.1
  olicenserad_1_A = mkA "olicenserad" ; -- olicenserad..av.1
  olicenserbar_1_A = mkA "olicenserbar" ; -- olicenserbar..av.1
  olicenserbarhet_1_N = mkN "olicenserbarhet" ; -- olicenserbarhet..nn.1
  olicensierad_1_A = mkA "olicensierad" ; -- olicensierad..av.1
  olicensierbar_1_A = mkA "olicensierbar" ; -- olicensierbar..av.1
  olicensierbarhet_1_N = mkN "olicensierbarhet" ; -- olicensierbarhet..nn.1
  olicentierad_1_A = mkA "olicentierad" ; -- olicentierad..av.1
  olicentierbar_1_A = mkA "olicentierbar" ; -- olicentierbar..av.1
  olicentierbarhet_1_N = mkN "olicentierbarhet" ; -- olicentierbarhet..nn.1
  olidlig_1_A = mkA "olidlig" ; -- olidlig..av.1
  olidlighet_1_N = mkN "olidlighet" "olidligheter" ; -- olidlighet..nn.1
  olierad_1_A = mkA "olierad" ; -- olierad..av.1
  olierbar_1_A = mkA "olierbar" ; -- olierbar..av.1
  olierbarhet_1_N = mkN "olierbarhet" ; -- olierbarhet..nn.1
  oligark_1_N = mkN "oligark" "oligarker" ; -- oligark..nn.1
  oligarki_1_N = mkN "oligarki" "oligarkier" ; -- oligarki..nn.1
  oligarkisk_1_A = mkA "oligarkisk" ; -- oligarkisk..av.1
  oligocen_1_N = mkN "oligocen" ; -- oligocen..nn.1
  oligofag_1_A = mkA "oligofag" ; -- oligofag..av.1
  oligofreni_1_N = mkN "oligofreni" ; -- oligofreni..nn.1
  oligopol_1_N = mkN "oligopol" neutrum  ; -- oligopol..nn.1
  oligotrof_1_A = mkA "oligotrof" ; -- oligotrof..av.1
  olik_1_A = mkA "olik" ; -- olik..av.1
  olikad_1_A = mkA "olikad" ; -- olikad..av.1
  olikartad_1_A = mkA "olikartad" ; -- olikartad..av.1
  olikformig_1_A = mkA "olikformig" ; -- olikformig..av.1
  olikformighet_1_N = mkN "olikformighet" "olikformigheter" ; -- olikformighet..nn.1
  olikfärgad_1_A = mkA "olikfärgad" ; -- olikfärgad..av.1
  olikhet_1_N = mkN "olikhet" "olikheter" ; -- olikhet..nn.1
  oliksidig_1_A = mkA "oliksidig" ; -- oliksidig..av.1
  olikstor_1_A = mkA "olikstor" ; -- olikstor..av.1
  oliksynthet_1_N = mkN "oliksynthet" ; -- oliksynthet..nn.1
  oliktänkande_1_A = mkA "oliktänkande" ; -- oliktänkande..av.1
  oliktänkare_1_N = mkN "oliktänkare" utrum  ; -- oliktänkare..nn.1
  olikviderad_1_A = mkA "olikviderad" ; -- olikviderad..av.1
  olikviderbar_1_A = mkA "olikviderbar" ; -- olikviderbar..av.1
  olikviderbarhet_1_N = mkN "olikviderbarhet" ; -- olikviderbarhet..nn.1
  olimmad_1_A = mkA "olimmad" ; -- olimmad..av.1
  olindad_1_A = mkA "olindad" ; -- olindad..av.1
  olindrad_1_A = mkA "olindrad" ; -- olindrad..av.1
  olinjerad_1_A = mkA "olinjerad" ; -- olinjerad..av.1
  olinjerbar_1_A = mkA "olinjerbar" ; -- olinjerbar..av.1
  olinjerbarhet_1_N = mkN "olinjerbarhet" ; -- olinjerbarhet..nn.1
  olirad_1_A = mkA "olirad" ; -- olirad..av.1
  olisserad_1_A = mkA "olisserad" ; -- olisserad..av.1
  olisserbar_1_A = mkA "olisserbar" ; -- olisserbar..av.1
  olisserbarhet_1_N = mkN "olisserbarhet" ; -- olisserbarhet..nn.1
  olistad_1_A = mkA "olistad" ; -- olistad..av.1
  olitograferad_1_A = mkA "olitograferad" ; -- olitograferad..av.1
  olitograferbar_1_A = mkA "olitograferbar" ; -- olitograferbar..av.1
  olitograferbarhet_1_N = mkN "olitograferbarhet" ; -- olitograferbarhet..nn.1
  olitsad_1_A = mkA "olitsad" ; -- olitsad..av.1
  oliv_1_N = mkN "oliv" "oliver" ; -- oliv..nn.1
  olivad_1_A = mkA "olivad" ; -- olivad..av.1
  olivfärgad_1_A = mkA "olivfärgad" ; -- olivfärgad..av.1
  olivgrön_1_A = mkA "olivgrön" ; -- olivgrön..av.1
  olivhyad_1_A = mkA "olivhyad" ; -- olivhyad..av.1
  olivin_1_N = mkN "olivin" "oliviner" ; -- olivin..nn.1
  olivkvist_1_N = mkN "olivkvist" ; -- olivkvist..nn.1
  olivolja_1_N = mkN "olivolja" ; -- olivolja..nn.1
  olivträd_1_N = mkN "olivträd" neutrum  ; -- olivträd..nn.1
  olja_1_N = mkN "olja" ; -- olja..nn.1
  olja_1_V = mkV "oljar" ; -- olja..vb.1
  oljande_1_N = mkN "oljande" ; -- oljande..nn.1
  oljeaggregat_1_N = mkN "oljeaggregat" neutrum  ; -- oljeaggregat..nn.1
  oljebad_1_N = mkN "oljebad" neutrum  ; -- oljebad..nn.1
  oljebaserad_1_A = mkA "oljebaserad" ; -- oljebaserad..av.1
  oljebekämpning_1_N = mkN "oljebekämpning" ; -- oljebekämpning..nn.1
  oljebekämpningsberedskap_1_N = mkN "oljebekämpningsberedskap" ; -- oljebekämpningsberedskap..nn.1
  oljeberoende_1_N = mkN "oljeberoende" ; -- oljeberoende..nn.1
  oljebeständig_1_A = mkA "oljebeständig" ; -- oljebeständig..av.1
  oljebeständighet_1_N = mkN "oljebeständighet" ; -- oljebeständighet..nn.1
  oljeblandad_1_A = mkA "oljeblandad" ; -- oljeblandad..av.1
  oljebolag_1_N = mkN "oljebolag" neutrum  ; -- oljebolag..nn.1
  oljeborrning_1_N = mkN "oljeborrning" ; -- oljeborrning..nn.1
  oljeborrtorn_1_N = mkN "oljeborrtorn" neutrum  ; -- oljeborrtorn..nn.1
  oljebrand_1_N = mkN "oljebrand" "oljebränder" ; -- oljebrand..nn.1
  oljebrunn_1_N = mkN "oljebrunn" ; -- oljebrunn..nn.1
  oljebrännare_1_N = mkN "oljebrännare" utrum  ; -- oljebrännare..nn.1
  oljebytartråg_1_N = mkN "oljebytartråg" neutrum  ; -- oljebytartråg..nn.1
  oljebyte_1_N = mkN "oljebyte" ; -- oljebyte..nn.1
  oljebälte_1_N = mkN "oljebälte" ; -- oljebälte..nn.1
  oljedränka_1_V = mkV "oljedränker" ; -- oljedränka..vb.1
  oljedränkande_1_N = mkN "oljedränkande" ; -- oljedränkande..nn.1
  oljedränkning_1_N = mkN "oljedränkning" ; -- oljedränkning..nn.1
  oljeduk_1_N = mkN "oljeduk" ; -- oljeduk..nn.1
  oljedådra_1_N = mkN "oljedådra" ; -- oljedådra..nn.1
  oljedöd_1_N = mkN "oljedöd" ; -- oljedöd..nn.1
  oljeeldning_1_N = mkN "oljeeldning" ; -- oljeeldning..nn.1
  oljefat_1_N = mkN "oljefat" neutrum  ; -- oljefat..nn.1
  oljefernissa_1_N = mkN "oljefernissa" ; -- oljefernissa..nn.1
  oljefilm_1_N = mkN "oljefilm" ; -- oljefilm..nn.1
  oljefilter_1_N = mkN "oljefilter" neutrum  ; -- oljefilter..nn.1
  oljefri_1_A = mkA "oljefri" "oljefritt" ; -- oljefri..av.1
  oljefält_1_N = mkN "oljefält" neutrum  ; -- oljefält..nn.1
  oljefärg_1_N = mkN "oljefärg" "oljefärger" ; -- oljefärg..nn.1
  oljegrus_1_N = mkN "oljegrus" neutrum  ; -- oljegrus..nn.1
  oljeinpackning_1_N = mkN "oljeinpackning" ; -- oljeinpackning..nn.1
  oljekaka_1_N = mkN "oljekaka" ; -- oljekaka..nn.1
  oljekanna_1_N = mkN "oljekanna" ; -- oljekanna..nn.1
  oljekonsumtion_1_N = mkN "oljekonsumtion" ; -- oljekonsumtion..nn.1
  oljekraftfoder_1_N = mkN "oljekraftfoder" neutrum  ; -- oljekraftfoder..nn.1
  oljekälla_1_N = mkN "oljekälla" ; -- oljekälla..nn.1
  oljelampa_1_N = mkN "oljelampa" ; -- oljelampa..nn.1
  oljeland_1_N = mkN "oljeland" "oljelandet" "oljeländer" "oljeländerna" ; -- oljeland..nn.1
  oljeledning_1_N = mkN "oljeledning" ; -- oljeledning..nn.1
  oljelykta_1_N = mkN "oljelykta" ; -- oljelykta..nn.1
  oljeläcka_1_N = mkN "oljeläcka" ; -- oljeläcka..nn.1
  oljeläckage_1_N = mkN "oljeläckage" "oljeläckaget" "oljeläckage" "oljeläckagen" ; -- oljeläckage..nn.1
  oljelås_1_N = mkN "oljelås" neutrum  ; -- oljelås..nn.1
  oljemålning_1_N = mkN "oljemålning" ; -- oljemålning..nn.1
  oljenivå_1_N = mkN "oljenivå" "oljenivåer" ; -- oljenivå..nn.1
  oljenivåmätare_1_N = mkN "oljenivåmätare" utrum  ; -- oljenivåmätare..nn.1
  oljenivåvakt_1_N = mkN "oljenivåvakt" "oljenivåvakter" ; -- oljenivåvakt..nn.1
  oljepalm_1_N = mkN "oljepalm" "oljepalmer" ; -- oljepalm..nn.1
  oljepapper_1_N = mkN "oljepapper" neutrum  ; -- oljepapper..nn.1
  oljepris_1_N = mkN "oljepris" neutrum  ; -- oljepris..nn.1
  oljeproducerande_1_A = mkA "oljeproducerande" ; -- oljeproducerande..av.1
  oljeprospektering_1_N = mkN "oljeprospektering" ; -- oljeprospektering..nn.1
  oljeraffinaderi_1_N = mkN "oljeraffinaderi" "oljeraffinaderiet" "oljeraffinaderier" "oljeraffinaderierna" ; -- oljeraffinaderi..nn.1
  oljerigg_1_N = mkN "oljerigg" ; -- oljerigg..nn.1
  oljerik_1_A = mkA "oljerik" ; -- oljerik..av.1
  oljerikhet_1_N = mkN "oljerikhet" ; -- oljerikhet..nn.1
  oljering_1_N = mkN "oljering" ; -- oljering..nn.1
  oljeriven_1_A = mkA "oljeriven" ; -- oljeriven..av.1
  oljerock_1_N = mkN "oljerock" ; -- oljerock..nn.1
  oljesanering_1_N = mkN "oljesanering" ; -- oljesanering..nn.1
  oljesanktion_1_N = mkN "oljesanktion" ; -- oljesanktion..nn.1
  oljeskadad_1_A = mkA "oljeskadad" ; -- oljeskadad..av.1
  oljeskiffer_1_N = mkN "oljeskiffer" ; -- oljeskiffer..nn.1
  oljeslageri_1_N = mkN "oljeslageri" "oljeslageriet" "oljeslagerier" "oljeslagerierna" ; -- oljeslageri..nn.1
  oljespill_1_N = mkN "oljespill" neutrum  ; -- oljespill..nn.1
  oljestad_1_N = mkN "oljestad" "oljestäder" ; -- oljestad..nn.1
  oljestopp_1_N = mkN "oljestopp" neutrum  ; -- oljestopp..nn.1
  oljeströmbrytare_1_N = mkN "oljeströmbrytare" utrum  ; -- oljeströmbrytare..nn.1
  oljeställ_1_N = mkN "oljeställ" neutrum  ; -- oljeställ..nn.1
  oljesump_1_N = mkN "oljesump" ; -- oljesump..nn.1
  oljesyra_1_N = mkN "oljesyra" ; -- oljesyra..nn.1
  oljetanker_1_N = mkN "oljetanker" ; -- oljetanker..nn.1
  oljetryck_1_N = mkN "oljetryck" neutrum  ; -- oljetryck..nn.1
  oljetråg_1_N = mkN "oljetråg" neutrum  ; -- oljetråg..nn.1
  oljetyg_1_N = mkN "oljetyg" neutrum  ; -- oljetyg..nn.1
  oljeutsläpp_1_N = mkN "oljeutsläpp" neutrum  ; -- oljeutsläpp..nn.1
  oljeutvinning_1_N = mkN "oljeutvinning" ; -- oljeutvinning..nn.1
  oljeväv_1_N = mkN "oljeväv" ; -- oljeväv..nn.1
  oljeväxt_1_N = mkN "oljeväxt" "oljeväxter" ; -- oljeväxt..nn.1
  oljeäkta_1_A = mkA "oljeäkta" ; -- oljeäkta..av.1
  oljig_1_A = mkA "oljig" ; -- oljig..av.1
  oljighet_1_N = mkN "oljighet" ; -- oljighet..nn.1
  oljud_1_N = mkN "oljud" neutrum  ; -- oljud..nn.1
  oljudad_1_A = mkA "oljudad" ; -- oljudad..av.1
  oljustrad_1_A = mkA "oljustrad" ; -- oljustrad..av.1
  olla_1_N = mkN "olla" ; -- olla..nn.1
  olla_1_V = mkV "ollar" ; -- olla..vb.1
  ollande_1_N = mkN "ollande" ; -- ollande..nn.1
  olle_1_N = mkN "olle" utrum  ; -- olle..nn.1
  ollning_1_N = mkN "ollning" ; -- ollning..nn.1
  ollon_1_N = mkN "ollon" neutrum  ; -- ollon..nn.1
  ollonborre_1_N = mkN "ollonborre" utrum  ; -- ollonborre..nn.1
  ollondröppel_1_N = mkN "ollondröppel" ; -- ollondröppel..nn.1
  ollonmask_1_N = mkN "ollonmask" ; -- ollonmask..nn.1
  ollonpistol_1_N = mkN "ollonpistol" "ollonpistoler" ; -- ollonpistol..nn.1
  ollonskog_1_N = mkN "ollonskog" ; -- ollonskog..nn.1
  ollonskott_1_N = mkN "ollonskott" neutrum  ; -- ollonskott..nn.1
  ollonsvin_1_N = mkN "ollonsvin" neutrum  ; -- ollonsvin..nn.1
  ollonträd_1_N = mkN "ollonträd" neutrum  ; -- ollonträd..nn.1
  olm_1_N = mkN "olm" ; -- olm..nn.1
  olobbad_1_A = mkA "olobbad" ; -- olobbad..av.1
  olockad_1_A = mkA "olockad" ; -- olockad..av.1
  olockoutad_1_A = mkA "olockoutad" ; -- olockoutad..av.1
  olodad_1_A = mkA "olodad" ; -- olodad..av.1
  olofsmässa_1_N = mkN "olofsmässa" ; -- olofsmässa..nn.1
  ologerad_1_A = mkA "ologerad" ; -- ologerad..av.1
  ologerbar_1_A = mkA "ologerbar" ; -- ologerbar..av.1
  ologerbarhet_1_N = mkN "ologerbarhet" ; -- ologerbarhet..nn.1
  ologgad_1_A = mkA "ologgad" ; -- ologgad..av.1
  ologisk_1_A = mkA "ologisk" ; -- ologisk..av.1
  ologiskhet_1_N = mkN "ologiskhet" ; -- ologiskhet..nn.1
  olokaliserad_1_A = mkA "olokaliserad" ; -- olokaliserad..av.1
  olokaliserbar_1_A = mkA "olokaliserbar" ; -- olokaliserbar..av.1
  olokaliserbarhet_1_N = mkN "olokaliserbarhet" ; -- olokaliserbarhet..nn.1
  oloppad_1_A = mkA "oloppad" ; -- oloppad..av.1
  olossad_1_A = mkA "olossad" ; -- olossad..av.1
  olotsad_1_A = mkA "olotsad" ; -- olotsad..av.1
  olottad_1_A = mkA "olottad" ; -- olottad..av.1
  olovad_1_A = mkA "olovad" ; -- olovad..av.1
  olovlig_1_A = mkA "olovlig" ; -- olovlig..av.1
  olovligen_1_Adv = mkAdv "olovligen" ; -- olovligen..ab.1
  olovlighet_1_N = mkN "olovlighet" "olovligheter" ; -- olovlighet..nn.1
  olsmässa_1_N = mkN "olsmässa" ; -- olsmässa..nn.1
  oluckrad_1_A = mkA "oluckrad" ; -- oluckrad..av.1
  oluftad_1_A = mkA "oluftad" ; -- oluftad..av.1
  oluggad_1_A = mkA "oluggad" ; -- oluggad..av.1
  olugnad_1_A = mkA "olugnad" ; -- olugnad..av.1
  oluktad_1_A = mkA "oluktad" ; -- oluktad..av.1
  olunnad_1_A = mkA "olunnad" ; -- olunnad..av.1
  olurad_1_A = mkA "olurad" ; -- olurad..av.1
  olust_1_N = mkN "olust" ; -- olust..nn.1
  olustig_1_A = mkA "olustig" ; -- olustig..av.1
  olustighet_1_N = mkN "olustighet" ; -- olustighet..nn.1
  olustkänsla_1_N = mkN "olustkänsla" ; -- olustkänsla..nn.1
  olutad_1_A = mkA "olutad" ; -- olutad..av.1
  oluteiniserad_1_A = mkA "oluteiniserad" ; -- oluteiniserad..av.1
  oluteiniserbar_1_A = mkA "oluteiniserbar" ; -- oluteiniserbar..av.1
  oluteiniserbarhet_1_N = mkN "oluteiniserbarhet" ; -- oluteiniserbarhet..nn.1
  oluttrad_1_A = mkA "oluttrad" ; -- oluttrad..av.1
  olvon_1_N = mkN "olvon" neutrum  ; -- olvon..nn.1
  olvonväxt_1_N = mkN "olvonväxt" "olvonväxter" ; -- olvonväxt..nn.1
  olycka_1_N = mkN "olycka" ; -- olycka..nn.1
  olycklig_1_A = mkA "olycklig" ; -- olycklig..av.1
  olycklighet_1_N = mkN "olycklighet" ; -- olycklighet..nn.1
  olyckligtvis_1_Adv = mkAdv "olyckligtvis" ; -- olyckligtvis..ab.1
  olycksalig_1_A = mkA "olycksalig" ; -- olycksalig..av.1
  olycksalighet_1_N = mkN "olycksalighet" ; -- olycksalighet..nn.1
  olycksbarn_1_N = mkN "olycksbarn" neutrum  ; -- olycksbarn..nn.1
  olycksbringande_1_A = mkA "olycksbringande" ; -- olycksbringande..av.1
  olycksbroder_1_N = mkN "olycksbroder" "olycksbrodern" "olycksbröder" "olycksbröderna" ; -- olycksbroder..nn.1
  olycksbådande_1_A = mkA "olycksbådande" ; -- olycksbådande..av.1
  olycksdag_1_N = mkN "olycksdag" ; -- olycksdag..nn.1
  olycksdiger_1_A = mkA "olycksdiger" ; -- olycksdiger..av.1
  olycksdigerhet_1_N = mkN "olycksdigerhet" ; -- olycksdigerhet..nn.1
  olycksdrabbad_1_A = mkA "olycksdrabbad" ; -- olycksdrabbad..av.1
  olycksfall_1_N = mkN "olycksfall" neutrum  ; -- olycksfall..nn.1
  olycksfallsfrekvens_1_N = mkN "olycksfallsfrekvens" "olycksfallsfrekvenser" ; -- olycksfallsfrekvens..nn.1
  olycksfallsförsäkring_1_N = mkN "olycksfallsförsäkring" ; -- olycksfallsförsäkring..nn.1
  olycksfågel_1_N = mkN "olycksfågel" ; -- olycksfågel..nn.1
  olyckshändelse_1_N = mkN "olyckshändelse" "olyckshändelser" ; -- olyckshändelse..nn.1
  olyckskamrat_1_N = mkN "olyckskamrat" "olyckskamrater" ; -- olyckskamrat..nn.1
  olyckskatastrof_1_N = mkN "olyckskatastrof" "olyckskatastrofer" ; -- olyckskatastrof..nn.1
  olyckskorp_1_N = mkN "olyckskorp" ; -- olyckskorp..nn.1
  olycksplats_1_N = mkN "olycksplats" "olycksplatser" ; -- olycksplats..nn.1
  olycksprofet_1_N = mkN "olycksprofet" "olycksprofeter" ; -- olycksprofet..nn.1
  olycksprofetia_1_N = mkN "olycksprofetia" ; -- olycksprofetia..nn.1
  olycksstatistik_1_N = mkN "olycksstatistik" "olycksstatistiker" ; -- olycksstatistik..nn.1
  olyckstal_1_N = mkN "olyckstal" neutrum  ; -- olyckstal..nn.1
  olyckstid_1_N = mkN "olyckstid" "olyckstider" ; -- olyckstid..nn.1
  olyckstillbud_1_N = mkN "olyckstillbud" neutrum  ; -- olyckstillbud..nn.1
  olyckstillfälle_1_N = mkN "olyckstillfälle" ; -- olyckstillfälle..nn.1
  olyckstrend_1_N = mkN "olyckstrend" "olyckstrender" ; -- olyckstrend..nn.1
  olycksvarslande_1_A = mkA "olycksvarslande" ; -- olycksvarslande..av.1
  olycksår_1_N = mkN "olycksår" neutrum  ; -- olycksår..nn.1
  olycksöde_1_N = mkN "olycksöde" ; -- olycksöde..nn.1
  olydig_1_A = mkA "olydig" ; -- olydig..av.1
  olydighet_1_N = mkN "olydighet" "olydigheter" ; -- olydighet..nn.1
  olydnad_1_N = mkN "olydnad" "olydnader" ; -- olydnad..nn.1
  olyktad_1_A = mkA "olyktad" ; -- olyktad..av.1
  olympiad_1_N = mkN "olympiad" "olympiader" ; -- olympiad..nn.1
  olympiasegrare_1_N = mkN "olympiasegrare" utrum  ; -- olympiasegrare..nn.1
  olympier_1_N = mkN "olympier" "olympiern" "olympier" "olympierna" ; -- olympier..nn.1
  olympisk_1_A = mkA "olympisk" ; -- olympisk..av.1
  olynchad_1_A = mkA "olynchad" ; -- olynchad..av.1
  olyrad_1_A = mkA "olyrad" ; -- olyrad..av.1
  olyst_1_A = mkA "olyst" "olyst" ; -- olyst..av.1
  olyxrenoverad_1_A = mkA "olyxrenoverad" ; -- olyxrenoverad..av.1
  olyxrenoverbar_1_A = mkA "olyxrenoverbar" ; -- olyxrenoverbar..av.1
  olyxrenoverbarhet_1_N = mkN "olyxrenoverbarhet" ; -- olyxrenoverbarhet..nn.1
  oläckt_1_A = mkA "oläckt" "oläckt" ; -- oläckt..av.1
  oläderad_1_A = mkA "oläderad" ; -- oläderad..av.1
  oläderbar_1_A = mkA "oläderbar" ; -- oläderbar..av.1
  oläderbarhet_1_N = mkN "oläderbarhet" ; -- oläderbarhet..nn.1
  olägenhet_1_N = mkN "olägenhet" "olägenheter" ; -- olägenhet..nn.1
  oläglig_1_A = mkA "oläglig" ; -- oläglig..av.1
  oläglighet_1_N = mkN "oläglighet" "olägligheter" ; -- oläglighet..nn.1
  olägrad_1_A = mkA "olägrad" ; -- olägrad..av.1
  oläkbar_1_A = mkA "oläkbar" ; -- oläkbar..av.1
  oläkbarhet_1_N = mkN "oläkbarhet" ; -- oläkbarhet..nn.1
  oläklig_1_A = mkA "oläklig" ; -- oläklig..av.1
  oläklighet_1_N = mkN "oläklighet" ; -- oläklighet..nn.1
  oläkt_1_A = mkA "oläkt" "oläkt" ; -- oläkt..av.1
  oläktrad_1_A = mkA "oläktrad" ; -- oläktrad..av.1
  olämnad_1_A = mkA "olämnad" ; -- olämnad..av.1
  olämpad_1_A = mkA "olämpad" ; -- olämpad..av.1
  olämplig_1_A = mkA "olämplig" ; -- olämplig..av.1
  olämplighet_1_N = mkN "olämplighet" ; -- olämplighet..nn.1
  oländig_1_A = mkA "oländig" ; -- oländig..av.1
  oländighet_1_N = mkN "oländighet" ; -- oländighet..nn.1
  olängd_1_A = mkA "olängd" "olängt" ; -- olängd..av.1
  olängdhet_1_N = mkN "olängdhet" ; -- olängdhet..nn.1
  olänkad_1_A = mkA "olänkad" ; -- olänkad..av.1
  olänsad_1_A = mkA "olänsad" ; -- olänsad..av.1
  olärd_1_A = mkA "olärd" "olärt" ; -- olärd..av.1
  olärdhet_1_N = mkN "olärdhet" ; -- olärdhet..nn.1
  oläsbar_1_A = mkA "oläsbar" ; -- oläsbar..av.1
  oläsbarhet_1_N = mkN "oläsbarhet" ; -- oläsbarhet..nn.1
  oläskad_1_A = mkA "oläskad" ; -- oläskad..av.1
  oläslig_1_A = mkA "oläslig" ; -- oläslig..av.1
  oläslighet_1_N = mkN "oläslighet" ; -- oläslighet..nn.1
  oläst_1_A = mkA "oläst" "oläst" ; -- oläst..av.1
  olättad_1_A = mkA "olättad" ; -- olättad..av.1
  olättrad_1_A = mkA "olättrad" ; -- olättrad..av.1
  olånad_1_A = mkA "olånad" ; -- olånad..av.1
  olåssad_1_A = mkA "olåssad" ; -- olåssad..av.1
  olåst_1_A = mkA "olåst" "olåst" ; -- olåst..av.1
  olåt_1_N = mkN "olåt" ; -- olåt..nn.1
  olåtsad_1_A = mkA "olåtsad" ; -- olåtsad..av.1
  olögad_1_A = mkA "olögad" ; -- olögad..av.1
  olönad_1_A = mkA "olönad" ; -- olönad..av.1
  olönsam_1_A = mkA "olönsam" "olönsamt" "olönsamma" "olönsamma" "olönsammare" "olönsammast" "olönsammaste" ; -- olönsam..av.1
  olönsamhet_1_N = mkN "olönsamhet" ; -- olönsamhet..nn.1
  olönt_1_A = mkA "olönt" "olönt" ; -- olönt..av.1
  olösbar_1_A = mkA "olösbar" ; -- olösbar..av.1
  olösbarhet_1_N = mkN "olösbarhet" ; -- olösbarhet..nn.1
  olöslig_1_A = mkA "olöslig" ; -- olöslig..av.1
  olöslighet_1_N = mkN "olöslighet" ; -- olöslighet..nn.1
  olöst_1_A = mkA "olöst" "olöst" ; -- olöst..av.1
  olövad_1_A = mkA "olövad" ; -- olövad..av.1
  om_1_N = mkN "om" neutrum  ; -- om..nn.1
  omadrasserad_1_A = mkA "omadrasserad" ; -- omadrasserad..av.1
  omadrasserbar_1_A = mkA "omadrasserbar" ; -- omadrasserbar..av.1
  omadrasserbarhet_1_N = mkN "omadrasserbarhet" ; -- omadrasserbarhet..nn.1
  omagasinerad_1_A = mkA "omagasinerad" ; -- omagasinerad..av.1
  omagasinerbar_1_A = mkA "omagasinerbar" ; -- omagasinerbar..av.1
  omagasinerbarhet_1_N = mkN "omagasinerbarhet" ; -- omagasinerbarhet..nn.1
  omagnetiserad_1_A = mkA "omagnetiserad" ; -- omagnetiserad..av.1
  omagnetiserbar_1_A = mkA "omagnetiserbar" ; -- omagnetiserbar..av.1
  omagnetiserbarhet_1_N = mkN "omagnetiserbarhet" ; -- omagnetiserbarhet..nn.1
  omailad_1_A = mkA "omailad" ; -- omailad..av.1
  omajad_1_A = mkA "omajad" ; -- omajad..av.1
  omak_1_N = mkN "omak" neutrum  ; -- omak..nn.1
  omaka_1_A = mkA "omaka" ; -- omaka..av.1
  omakad_1_A = mkA "omakad" ; -- omakad..av.1
  omakulerad_1_A = mkA "omakulerad" ; -- omakulerad..av.1
  omakulerbar_1_A = mkA "omakulerbar" ; -- omakulerbar..av.1
  omakulerbarhet_1_N = mkN "omakulerbarhet" ; -- omakulerbarhet..nn.1
  omalen_1_A = mkA "omalen" ; -- omalen..av.1
  omalfoberad_1_A = mkA "omalfoberad" ; -- omalfoberad..av.1
  omalfoberbar_1_A = mkA "omalfoberbar" ; -- omalfoberbar..av.1
  omalfoberbarhet_1_N = mkN "omalfoberbarhet" ; -- omalfoberbarhet..nn.1
  omalmad_1_A = mkA "omalmad" ; -- omalmad..av.1
  omalträterad_1_A = mkA "omalträterad" ; -- omalträterad..av.1
  omalträterbar_1_A = mkA "omalträterbar" ; -- omalträterbar..av.1
  omalträterbarhet_1_N = mkN "omalträterbarhet" ; -- omalträterbarhet..nn.1
  omanad_1_A = mkA "omanad" ; -- omanad..av.1
  omanglad_1_A = mkA "omanglad" ; -- omanglad..av.1
  omanier_1_N = mkN "omanier" "omaniern" "omanier" "omanierna" ; -- omanier..nn.1
  omanifesterad_1_A = mkA "omanifesterad" ; -- omanifesterad..av.1
  omanifesterbar_1_A = mkA "omanifesterbar" ; -- omanifesterbar..av.1
  omanifesterbarhet_1_N = mkN "omanifesterbarhet" ; -- omanifesterbarhet..nn.1
  omanikurerad_1_A = mkA "omanikurerad" ; -- omanikurerad..av.1
  omanikurerbar_1_A = mkA "omanikurerbar" ; -- omanikurerbar..av.1
  omanikurerbarhet_1_N = mkN "omanikurerbarhet" ; -- omanikurerbarhet..nn.1
  omanikyrerad_1_A = mkA "omanikyrerad" ; -- omanikyrerad..av.1
  omanikyrerbar_1_A = mkA "omanikyrerbar" ; -- omanikyrerbar..av.1
  omanikyrerbarhet_1_N = mkN "omanikyrerbarhet" ; -- omanikyrerbarhet..nn.1
  omanipulerad_1_A = mkA "omanipulerad" ; -- omanipulerad..av.1
  omanipulerbar_1_A = mkA "omanipulerbar" ; -- omanipulerbar..av.1
  omanipulerbarhet_1_N = mkN "omanipulerbarhet" ; -- omanipulerbarhet..nn.1
  omanlig_1_A = mkA "omanlig" ; -- omanlig..av.1
  omanlighet_1_N = mkN "omanlighet" ; -- omanlighet..nn.1
  omansk_1_A = mkA "omansk" ; -- omansk..av.1
  omanska_1_N = mkN "omanska" ; -- omanska..nn.1
  omantlad_1_A = mkA "omantlad" ; -- omantlad..av.1
  omanövrerad_1_A = mkA "omanövrerad" ; -- omanövrerad..av.1
  omanövrerbar_1_A = mkA "omanövrerbar" ; -- omanövrerbar..av.1
  omanövrerbarhet_1_N = mkN "omanövrerbarhet" ; -- omanövrerbarhet..nn.1
  omarbeta_1_V = mkV "omarbetar" ; -- omarbeta..vb.1
  omarbetande_1_N = mkN "omarbetande" ; -- omarbetande..nn.1
  omarbetning_1_N = mkN "omarbetning" ; -- omarbetning..nn.1
  omarginaliserad_1_A = mkA "omarginaliserad" ; -- omarginaliserad..av.1
  omarginaliserbar_1_A = mkA "omarginaliserbar" ; -- omarginaliserbar..av.1
  omarginaliserbarhet_1_N = mkN "omarginaliserbarhet" ; -- omarginaliserbarhet..nn.1
  omarinerad_1_A = mkA "omarinerad" ; -- omarinerad..av.1
  omarinerbar_1_A = mkA "omarinerbar" ; -- omarinerbar..av.1
  omarinerbarhet_1_N = mkN "omarinerbarhet" ; -- omarinerbarhet..nn.1
  omarkerad_1_A = mkA "omarkerad" ; -- omarkerad..av.1
  omarkerbar_1_A = mkA "omarkerbar" ; -- omarkerbar..av.1
  omarkerbarhet_1_N = mkN "omarkerbarhet" ; -- omarkerbarhet..nn.1
  omarmorerad_1_A = mkA "omarmorerad" ; -- omarmorerad..av.1
  omarmorerbar_1_A = mkA "omarmorerbar" ; -- omarmorerbar..av.1
  omarmorerbarhet_1_N = mkN "omarmorerbarhet" ; -- omarmorerbarhet..nn.1
  omarscherbar_1_A = mkA "omarscherbar" ; -- omarscherbar..av.1
  omarscherbarhet_1_N = mkN "omarscherbarhet" ; -- omarscherbarhet..nn.1
  omarterad_1_A = mkA "omarterad" ; -- omarterad..av.1
  omarterbar_1_A = mkA "omarterbar" ; -- omarterbar..av.1
  omarterbarhet_1_N = mkN "omarterbarhet" ; -- omarterbarhet..nn.1
  omasad_1_A = mkA "omasad" ; -- omasad..av.1
  omaskad_1_A = mkA "omaskad" ; -- omaskad..av.1
  omaskerad_1_A = mkA "omaskerad" ; -- omaskerad..av.1
  omaskerbar_1_A = mkA "omaskerbar" ; -- omaskerbar..av.1
  omaskerbarhet_1_N = mkN "omaskerbarhet" ; -- omaskerbarhet..nn.1
  omaskuliniserad_1_A = mkA "omaskuliniserad" ; -- omaskuliniserad..av.1
  omaskuliniserbar_1_A = mkA "omaskuliniserbar" ; -- omaskuliniserbar..av.1
  omaskuliniserbarhet_1_N = mkN "omaskuliniserbarhet" ; -- omaskuliniserbarhet..nn.1
  omassakrerad_1_A = mkA "omassakrerad" ; -- omassakrerad..av.1
  omassakrerbar_1_A = mkA "omassakrerbar" ; -- omassakrerbar..av.1
  omassakrerbarhet_1_N = mkN "omassakrerbarhet" ; -- omassakrerbarhet..nn.1
  omasserad_1_A = mkA "omasserad" ; -- omasserad..av.1
  omasserbar_1_A = mkA "omasserbar" ; -- omasserbar..av.1
  omasserbarhet_1_N = mkN "omasserbarhet" ; -- omasserbarhet..nn.1
  omastad_1_A = mkA "omastad" ; -- omastad..av.1
  omatad_1_A = mkA "omatad" ; -- omatad..av.1
  omatchad_1_A = mkA "omatchad" ; -- omatchad..av.1
  omatelasserad_1_A = mkA "omatelasserad" ; -- omatelasserad..av.1
  omatelasserbar_1_A = mkA "omatelasserbar" ; -- omatelasserbar..av.1
  omatelasserbarhet_1_N = mkN "omatelasserbarhet" ; -- omatelasserbarhet..nn.1
  omaterialiserad_1_A = mkA "omaterialiserad" ; -- omaterialiserad..av.1
  omaterialiserbar_1_A = mkA "omaterialiserbar" ; -- omaterialiserbar..av.1
  omaterialiserbarhet_1_N = mkN "omaterialiserbarhet" ; -- omaterialiserbarhet..nn.1
  omattad_1_A = mkA "omattad" ; -- omattad..av.1
  omatterad_1_A = mkA "omatterad" ; -- omatterad..av.1
  omatterbar_1_A = mkA "omatterbar" ; -- omatterbar..av.1
  omatterbarhet_1_N = mkN "omatterbarhet" ; -- omatterbarhet..nn.1
  omaxad_1_A = mkA "omaxad" ; -- omaxad..av.1
  omaximerad_1_A = mkA "omaximerad" ; -- omaximerad..av.1
  omaximerbar_1_A = mkA "omaximerbar" ; -- omaximerbar..av.1
  omaximerbarhet_1_N = mkN "omaximerbarhet" ; -- omaximerbarhet..nn.1
  ombe_1_V = mkV "ombeda" "ombad" "ombett" ; -- ombe..vb.1
  ombedjande_1_N = mkN "ombedjande" ; -- ombedjande..nn.1
  ombestyra_1_V = mkV "ombestyra" "ombestyrde" "ombestyrt" ; -- ombestyra..vb.1
  ombestyrande_1_N = mkN "ombestyrande" ; -- ombestyrande..nn.1
  ombesörja_1_V = mkV "ombesörja" "ombesörjde" "ombesörjt" ; -- ombesörja..vb.1
  ombesörjande_1_N = mkN "ombesörjande" ; -- ombesörjande..nn.1
  ombesörjning_1_N = mkN "ombesörjning" ; -- ombesörjning..nn.1
  ombetro_1_V = mkV "ombetror" ; -- ombetro..vb.1
  ombetroende_1_N = mkN "ombetroende" ; -- ombetroende..nn.1
  ombilda_1_V = mkV "ombildar" ; -- ombilda..vb.1
  ombildande_1_N = mkN "ombildande" ; -- ombildande..nn.1
  ombildning_1_N = mkN "ombildning" ; -- ombildning..nn.1
  ombindning_1_N = mkN "ombindning" ; -- ombindning..nn.1
  omblad_1_N = mkN "omblad" neutrum  ; -- omblad..nn.1
  omblandning_1_N = mkN "omblandning" ; -- omblandning..nn.1
  omblandningsprocess_1_N = mkN "omblandningsprocess" "omblandningsprocesser" ; -- omblandningsprocess..nn.1
  ombonad_1_A = mkA "ombonad" ; -- ombonad..av.1
  ombordanställd_1_A = mkA "ombordanställd" "ombordanställt" ; -- ombordanställd..av.1
  ombordläggning_1_N = mkN "ombordläggning" ; -- ombordläggning..nn.1
  ombordvarande_1_A = mkA "ombordvarande" ; -- ombordvarande..av.1
  ombryta_1_V = mkV "ombryta" "ombröt" "ombrutit" ; -- ombryta..vb.1
  ombrytande_1_N = mkN "ombrytande" ; -- ombrytande..nn.1
  ombrytning_1_N = mkN "ombrytning" ; -- ombrytning..nn.1
  ombud_1_N = mkN "ombud" neutrum  ; -- ombud..nn.1
  ombudsman_1_N = mkN "ombudsman" "ombudsmannen" "ombudsmän" "ombudsmännen" ; -- ombudsman..nn.1
  ombudsmannaskap_1_N = mkN "ombudsmannaskap" neutrum  ; -- ombudsmannaskap..nn.1
  ombyggande_1_N = mkN "ombyggande" ; -- ombyggande..nn.1
  ombyggnad_1_N = mkN "ombyggnad" "ombyggnader" ; -- ombyggnad..nn.1
  ombyggnation_1_N = mkN "ombyggnation" ; -- ombyggnation..nn.1
  ombyte_1_N = mkN "ombyte" ; -- ombyte..nn.1
  ombytlig_1_A = mkA "ombytlig" ; -- ombytlig..av.1
  ombytlighet_1_N = mkN "ombytlighet" ; -- ombytlighet..nn.1
  ombytt_1_A = mkA "ombytt" ; -- ombytt..av.1
  ombäddning_1_N = mkN "ombäddning" ; -- ombäddning..nn.1
  omdana_1_V = mkV "omdanar" ; -- omdana..vb.1
  omdanande_1_N = mkN "omdanande" ; -- omdanande..nn.1
  omdaning_1_N = mkN "omdaning" ; -- omdaning..nn.1
  omdebatterad_1_A = mkA "omdebatterad" ; -- omdebatterad..av.1
  omdirigera_1_V = mkV "omdirigerar" ; -- omdirigera..vb.1
  omdirigerande_1_N = mkN "omdirigerande" ; -- omdirigerande..nn.1
  omdirigerbar_1_A = mkA "omdirigerbar" ; -- omdirigerbar..av.1
  omdirigerbarhet_1_N = mkN "omdirigerbarhet" ; -- omdirigerbarhet..nn.1
  omdirigering_1_N = mkN "omdirigering" ; -- omdirigering..nn.1
  omdiskuterad_1_A = mkA "omdiskuterad" ; -- omdiskuterad..av.1
  omdöme_1_N = mkN "omdöme" ; -- omdöme..nn.1
  omdömesbrist_1_N = mkN "omdömesbrist" "omdömesbrister" ; -- omdömesbrist..nn.1
  omdömesfråga_1_N = mkN "omdömesfråga" ; -- omdömesfråga..nn.1
  omdömesförmåga_1_N = mkN "omdömesförmåga" ; -- omdömesförmåga..nn.1
  omdömesgill_1_A = mkA "omdömesgill" ; -- omdömesgill..av.1
  omdömesgillhet_1_N = mkN "omdömesgillhet" "omdömesgillheter" ; -- omdömesgillhet..nn.1
  omdömeslös_1_A = mkA "omdömeslös" ; -- omdömeslös..av.1
  omdömeslöshet_1_N = mkN "omdömeslöshet" "omdömeslösheter" ; -- omdömeslöshet..nn.1
  omedaljerad_1_A = mkA "omedaljerad" ; -- omedaljerad..av.1
  omedaljerbar_1_A = mkA "omedaljerbar" ; -- omedaljerbar..av.1
  omedaljerbarhet_1_N = mkN "omedaljerbarhet" ; -- omedaljerbarhet..nn.1
  omeddelsam_1_A = mkA "omeddelsam" ; -- omeddelsam..av.1
  omedelbar_1_A = mkA "omedelbar" ; -- omedelbar..av.1
  omedelbarhet_1_N = mkN "omedelbarhet" ; -- omedelbarhet..nn.1
  omedelbums_1_Adv = mkAdv "omedelbums" ; -- omedelbums..ab.1
  omedförd_1_A = mkA "omedförd" "omedfört" ; -- omedförd..av.1
  omedgörlig_1_A = mkA "omedgörlig" ; -- omedgörlig..av.1
  omedgörlighet_1_N = mkN "omedgörlighet" ; -- omedgörlighet..nn.1
  omedicinerad_1_A = mkA "omedicinerad" ; -- omedicinerad..av.1
  omedicinerbar_1_A = mkA "omedicinerbar" ; -- omedicinerbar..av.1
  omedicinerbarhet_1_N = mkN "omedicinerbarhet" ; -- omedicinerbarhet..nn.1
  omedveten_1_A = mkA "omedveten" ; -- omedveten..av.1
  omedvetenhet_1_N = mkN "omedvetenhet" "omedvetenheter" ; -- omedvetenhet..nn.1
  omega_1_N = mkN "omega" "omegat" "omegan" "omegana" ; -- omega..nn.1
  omejad_1_A = mkA "omejad" ; -- omejad..av.1
  omejlad_1_A = mkA "omejlad" ; -- omejlad..av.1
  omejslad_1_A = mkA "omejslad" ; -- omejslad..av.1
  omekaniserad_1_A = mkA "omekaniserad" ; -- omekaniserad..av.1
  omekaniserbar_1_A = mkA "omekaniserbar" ; -- omekaniserbar..av.1
  omekaniserbarhet_1_N = mkN "omekaniserbarhet" ; -- omekaniserbarhet..nn.1
  omelett_1_N = mkN "omelett" "omeletter" ; -- omelett..nn.1
  omelodisk_1_A = mkA "omelodisk" ; -- omelodisk..av.1
  omemorerad_1_A = mkA "omemorerad" ; -- omemorerad..av.1
  omemorerbar_1_A = mkA "omemorerbar" ; -- omemorerbar..av.1
  omemorerbarhet_1_N = mkN "omemorerbarhet" ; -- omemorerbarhet..nn.1
  omen_1_N = mkN "omen" neutrum  ; -- omen..nn.1
  omerceriserad_1_A = mkA "omerceriserad" ; -- omerceriserad..av.1
  omerceriserbar_1_A = mkA "omerceriserbar" ; -- omerceriserbar..av.1
  omerceriserbarhet_1_N = mkN "omerceriserbarhet" ; -- omerceriserbarhet..nn.1
  omeriterad_1_A = mkA "omeriterad" ; -- omeriterad..av.1
  omeriterbar_1_A = mkA "omeriterbar" ; -- omeriterbar..av.1
  omeriterbarhet_1_N = mkN "omeriterbarhet" ; -- omeriterbarhet..nn.1
  omessad_1_A = mkA "omessad" ; -- omessad..av.1
  ometalliserad_1_A = mkA "ometalliserad" ; -- ometalliserad..av.1
  ometalliserbar_1_A = mkA "ometalliserbar" ; -- ometalliserbar..av.1
  ometalliserbarhet_1_N = mkN "ometalliserbarhet" ; -- ometalliserbarhet..nn.1
  ometodisk_1_A = mkA "ometodisk" ; -- ometodisk..av.1
  omfamna_1_V = mkV "omfamnar" ; -- omfamna..vb.1
  omfamnande_1_N = mkN "omfamnande" ; -- omfamnande..nn.1
  omfamning_1_N = mkN "omfamning" ; -- omfamning..nn.1
  omfatta_1_V = mkV "omfattar" ; -- omfatta..vb.1
  omfattande_1_A = mkA "omfattande" ; -- omfattande..av.1
  omfattande_1_N = mkN "omfattande" ; -- omfattande..nn.1
  omfattning_1_N = mkN "omfattning" ; -- omfattning..nn.1
  omfladdrad_1_A = mkA "omfladdrad" ; -- omfladdrad..av.1
  omfluten_1_A = mkA "omfluten" ; -- omfluten..av.1
  omflytta_1_V = mkV "omflyttar" ; -- omflytta..vb.1
  omflyttning_1_N = mkN "omflyttning" ; -- omflyttning..nn.1
  omforma_1_V = mkV "omformar" ; -- omforma..vb.1
  omformande_1_N = mkN "omformande" ; -- omformande..nn.1
  omformare_1_N = mkN "omformare" utrum  ; -- omformare..nn.1
  omformning_1_N = mkN "omformning" ; -- omformning..nn.1
  omformulera_1_V = mkV "omformulerar" ; -- omformulera..vb.1
  omformulerande_1_N = mkN "omformulerande" ; -- omformulerande..nn.1
  omformulerbar_1_A = mkA "omformulerbar" ; -- omformulerbar..av.1
  omformulerbarhet_1_N = mkN "omformulerbarhet" ; -- omformulerbarhet..nn.1
  omformulering_1_N = mkN "omformulering" ; -- omformulering..nn.1
  omfång_1_N = mkN "omfång" neutrum  ; -- omfång..nn.1
  omfångsrik_1_A = mkA "omfångsrik" ; -- omfångsrik..av.1
  omfångsrikhet_1_N = mkN "omfångsrikhet" ; -- omfångsrikhet..nn.1
  omföderska_1_N = mkN "omföderska" ; -- omföderska..nn.1
  omföra_1_V = mkV "omföra" "omförde" "omfört" ; -- omföra..vb.1
  omförande_1_N = mkN "omförande" ; -- omförande..nn.1
  omfördela_1_V = mkV "omfördelar" ; -- omfördela..vb.1
  omfördelande_1_N = mkN "omfördelande" ; -- omfördelande..nn.1
  omfördelning_1_N = mkN "omfördelning" ; -- omfördelning..nn.1
  omförhandla_1_V = mkV "omförhandlar" ; -- omförhandla..vb.1
  omförhandlande_1_N = mkN "omförhandlande" ; -- omförhandlande..nn.1
  omförhandling_1_N = mkN "omförhandling" ; -- omförhandling..nn.1
  omförmäla_1_V = mkV "omförmäler" ; -- omförmäla..vb.1
  omförmälande_1_N = mkN "omförmälande" ; -- omförmälande..nn.1
  omförmälning_1_N = mkN "omförmälning" ; -- omförmälning..nn.1
  omge_1_V = mkV "omgiva" "omgav" "omgivit" ; -- omge..vb.1
  omgestalta_1_V = mkV "omgestaltar" ; -- omgestalta..vb.1
  omgestaltande_1_N = mkN "omgestaltande" ; -- omgestaltande..nn.1
  omgestaltning_1_N = mkN "omgestaltning" ; -- omgestaltning..nn.1
  omgift_1_A = mkA "omgift" "omgift" ; -- omgift..av.1
  omgifte_1_N = mkN "omgifte" ; -- omgifte..nn.1
  omgiv_1_N = mkN "omgiv" ; -- omgiv..nn.1
  omgivande_1_N = mkN "omgivande" ; -- omgivande..nn.1
  omgivning_1_N = mkN "omgivning" ; -- omgivning..nn.1
  omgjord_1_A = mkA "omgjord" "omgjort" ; -- omgjord..av.1
  omgjutning_1_N = mkN "omgjutning" ; -- omgjutning..nn.1
  omgruppera_1_V = mkV "omgrupperar" ; -- omgruppera..vb.1
  omgruppering_1_N = mkN "omgruppering" ; -- omgruppering..nn.1
  omgärda_1_V = mkV "omgärdar" ; -- omgärda..vb.1
  omgärdande_1_N = mkN "omgärdande" ; -- omgärdande..nn.1
  omgärdning_1_N = mkN "omgärdning" ; -- omgärdning..nn.1
  omgående_1_Adv = mkAdv "omgående" ; -- omgående..ab.1
  omgång_1_N = mkN "omgång" ; -- omgång..nn.1
  omhopp_1_N = mkN "omhopp" neutrum  ; -- omhopp..nn.1
  omhulda_1_V = mkV "omhuldar" ; -- omhulda..vb.1
  omhuldande_1_N = mkN "omhuldande" ; -- omhuldande..nn.1
  omhuldning_1_N = mkN "omhuldning" ; -- omhuldning..nn.1
  omhägna_1_V = mkV "omhägnar" ; -- omhägna..vb.1
  omhägnande_1_N = mkN "omhägnande" ; -- omhägnande..nn.1
  omhäkta_1_V = mkV "omhäktar" ; -- omhäkta..vb.1
  omhäktande_1_N = mkN "omhäktande" ; -- omhäktande..nn.1
  omhänderhavande_1_N = mkN "omhänderhavande" ; -- omhänderhavande..nn.1
  omhänderta_1_V = mkV "omhändertaga" "omhändertog" "omhändertagit" ; -- omhänderta..vb.1
  omhändertagande_1_N = mkN "omhändertagande" ; -- omhändertagande..nn.1
  omhänge_1_N = mkN "omhänge" ; -- omhänge..nn.1
  omhölja_1_V = mkV "omhölja" "omhöljde" "omhöljt" ; -- omhölja..vb.1
  omhöljande_1_N = mkN "omhöljande" ; -- omhöljande..nn.1
  omicrad_1_A = mkA "omicrad" ; -- omicrad..av.1
  omigen_1_Adv = mkAdv "omigen" ; -- omigen..ab.1
  omikrad_1_A = mkA "omikrad" ; -- omikrad..av.1
  omikron_1_N = mkN "omikron" neutrum  ; -- omikron..nn.1
  omikroskoperad_1_A = mkA "omikroskoperad" ; -- omikroskoperad..av.1
  omikroskoperbar_1_A = mkA "omikroskoperbar" ; -- omikroskoperbar..av.1
  omikroskoperbarhet_1_N = mkN "omikroskoperbarhet" ; -- omikroskoperbarhet..nn.1
  omild_1_A = mkA "omild" "omilt" ; -- omild..av.1
  omildhet_1_N = mkN "omildhet" ; -- omildhet..nn.1
  omildrad_1_A = mkA "omildrad" ; -- omildrad..av.1
  omilitariserad_1_A = mkA "omilitariserad" ; -- omilitariserad..av.1
  omilitariserbar_1_A = mkA "omilitariserbar" ; -- omilitariserbar..av.1
  omilitariserbarhet_1_N = mkN "omilitariserbarhet" ; -- omilitariserbarhet..nn.1
  omimad_1_A = mkA "omimad" ; -- omimad..av.1
  ominerad_1_A = mkA "ominerad" ; -- ominerad..av.1
  omineraliserad_1_A = mkA "omineraliserad" ; -- omineraliserad..av.1
  omineraliserbar_1_A = mkA "omineraliserbar" ; -- omineraliserbar..av.1
  omineraliserbarhet_1_N = mkN "omineraliserbarhet" ; -- omineraliserbarhet..nn.1
  ominerbar_1_A = mkA "ominerbar" ; -- ominerbar..av.1
  ominerbarhet_1_N = mkN "ominerbarhet" ; -- ominerbarhet..nn.1
  ominiatyriserad_1_A = mkA "ominiatyriserad" ; -- ominiatyriserad..av.1
  ominiatyriserbar_1_A = mkA "ominiatyriserbar" ; -- ominiatyriserbar..av.1
  ominiatyriserbarhet_1_N = mkN "ominiatyriserbarhet" ; -- ominiatyriserbarhet..nn.1
  ominimerad_1_A = mkA "ominimerad" ; -- ominimerad..av.1
  ominimerbar_1_A = mkA "ominimerbar" ; -- ominimerbar..av.1
  ominimerbarhet_1_N = mkN "ominimerbarhet" ; -- ominimerbarhet..nn.1
  ominskad_1_A = mkA "ominskad" ; -- ominskad..av.1
  omintetgöra_1_V = mkV "omintetgöra" "omintetgjorde" "omintetgjort" ; -- omintetgöra..vb.1
  omintetgörande_1_N = mkN "omintetgörande" ; -- omintetgörande..nn.1
  ominös_1_A = mkA "ominös" ; -- ominös..av.1
  omissad_1_A = mkA "omissad" ; -- omissad..av.1
  omissiverad_1_A = mkA "omissiverad" ; -- omissiverad..av.1
  omissiverbar_1_A = mkA "omissiverbar" ; -- omissiverbar..av.1
  omissiverbarhet_1_N = mkN "omissiverbarhet" ; -- omissiverbarhet..nn.1
  omisskrediterad_1_A = mkA "omisskrediterad" ; -- omisskrediterad..av.1
  omisskrediterbar_1_A = mkA "omisskrediterbar" ; -- omisskrediterbar..av.1
  omisskrediterbarhet_1_N = mkN "omisskrediterbarhet" ; -- omisskrediterbarhet..nn.1
  omisskännelig_1_A = mkA "omisskännelig" ; -- omisskännelig..av.1
  omisskännelighet_1_N = mkN "omisskännelighet" ; -- omisskännelighet..nn.1
  omisskännlig_1_A = mkA "omisskännlig" ; -- omisskännlig..av.1
  omisskännligen_1_Adv = mkAdv "omisskännligen" ; -- omisskännligen..ab.1
  omisskännlighet_1_N = mkN "omisskännlighet" ; -- omisskännlighet..nn.1
  omisstänksam_1_A = mkA "omisstänksam" "omisstänksamt" "omisstänksamma" "omisstänksamma" "omisstänksammare" "omisstänksammast" "omisstänksammaste" ; -- omisstänksam..av.1
  omisstänksamhet_1_N = mkN "omisstänksamhet" ; -- omisstänksamhet..nn.1
  omistlig_1_A = mkA "omistlig" ; -- omistlig..av.1
  omistlighet_1_N = mkN "omistlighet" "omistligheter" ; -- omistlighet..nn.1
  omixad_1_A = mkA "omixad" ; -- omixad..av.1
  omjukad_1_A = mkA "omjukad" ; -- omjukad..av.1
  omjölad_1_A = mkA "omjölad" ; -- omjölad..av.1
  omjölkad_1_A = mkA "omjölkad" ; -- omjölkad..av.1
  omkalfatring_1_N = mkN "omkalfatring" ; -- omkalfatring..nn.1
  omkast_1_N = mkN "omkast" neutrum  ; -- omkast..nn.1
  omkasta_1_V = mkV "omkastar" ; -- omkasta..vb.1
  omkastande_1_N = mkN "omkastande" ; -- omkastande..nn.1
  omkastare_1_N = mkN "omkastare" utrum  ; -- omkastare..nn.1
  omkastning_1_N = mkN "omkastning" ; -- omkastning..nn.1
  omklä_1_V = mkV "omklä" "omklädde" "omklätt" ; -- omklä..vb.1
  omklädande_1_N = mkN "omklädande" ; -- omklädande..nn.1
  omklädnad_1_N = mkN "omklädnad" ; -- omklädnad..nn.1
  omklädning_1_N = mkN "omklädning" ; -- omklädning..nn.1
  omklädningsrum_1_N = mkN "omklädningsrum" "omklädningsrummet" "omklädningsrum" "omklädningsrummen" ; -- omklädningsrum..nn.1
  omklädningsutrymme_1_N = mkN "omklädningsutrymme" ; -- omklädningsutrymme..nn.1
  omkläende_1_N = mkN "omkläende" ; -- omkläende..nn.1
  omknytning_1_N = mkN "omknytning" ; -- omknytning..nn.1
  omkomma_1_V = mkV "omkomma" "omkom" "omkommit" ; -- omkomma..vb.1
  omkommande_1_N = mkN "omkommande" ; -- omkommande..nn.1
  omkopplare_1_N = mkN "omkopplare" utrum  ; -- omkopplare..nn.1
  omkostnad_1_N = mkN "omkostnad" "omkostnader" ; -- omkostnad..nn.1
  omkostymera_1_V = mkV "omkostymerar" ; -- omkostymera..vb.1
  omkostymerande_1_N = mkN "omkostymerande" ; -- omkostymerande..nn.1
  omkostymering_1_N = mkN "omkostymering" ; -- omkostymering..nn.1
  omkransa_1_V = mkV "omkransar" ; -- omkransa..vb.1
  omkransande_1_N = mkN "omkransande" ; -- omkransande..nn.1
  omkrets_1_N = mkN "omkrets" ; -- omkrets..nn.1
  omkretsa_1_V = mkV "omkretsar" ; -- omkretsa..vb.1
  omkretsande_1_N = mkN "omkretsande" ; -- omkretsande..nn.1
  omkringliggande_1_A = mkA "omkringliggande" ; -- omkringliggande..av.1
  omkulldragen_1_A = mkA "omkulldragen" ; -- omkulldragen..av.1
  omkullfallen_1_A = mkA "omkullfallen" ; -- omkullfallen..av.1
  omkullkasta_1_V = mkV "omkullkastar" ; -- omkullkasta..vb.1
  omkullkastande_1_N = mkN "omkullkastande" ; -- omkullkastande..nn.1
  omkullkastning_1_N = mkN "omkullkastning" ; -- omkullkastning..nn.1
  omkullknuffad_1_A = mkA "omkullknuffad" ; -- omkullknuffad..av.1
  omkväde_1_N = mkN "omkväde" ; -- omkväde..nn.1
  omköp_1_N = mkN "omköp" neutrum  ; -- omköp..nn.1
  omköra_1_V = mkV "omköra" "omkörde" "omkört" ; -- omköra..vb.1
  omkörande_1_N = mkN "omkörande" ; -- omkörande..nn.1
  omkörning_1_N = mkN "omkörning" ; -- omkörning..nn.1
  omkörningsfil_1_N = mkN "omkörningsfil" "omkörningsfiler" ; -- omkörningsfil..nn.1
  omkörningsförbud_1_N = mkN "omkörningsförbud" neutrum  ; -- omkörningsförbud..nn.1
  omladdning_1_N = mkN "omladdning" ; -- omladdning..nn.1
  omland_1_N = mkN "omland" neutrum  ; -- omland..nn.1
  omlastning_1_N = mkN "omlastning" ; -- omlastning..nn.1
  omliggande_1_A = mkA "omliggande" ; -- omliggande..av.1
  omljud_1_N = mkN "omljud" neutrum  ; -- omljud..nn.1
  omljudd_1_A = mkA "omljudd" ; -- omljudd..av.1
  omljudsvokal_1_N = mkN "omljudsvokal" "omljudsvokaler" ; -- omljudsvokal..nn.1
  omlokalisera_1_V = mkV "omlokaliserar" ; -- omlokalisera..vb.1
  omlokaliserande_1_N = mkN "omlokaliserande" ; -- omlokaliserande..nn.1
  omlokaliserbar_1_A = mkA "omlokaliserbar" ; -- omlokaliserbar..av.1
  omlokaliserbarhet_1_N = mkN "omlokaliserbarhet" ; -- omlokaliserbarhet..nn.1
  omlokalisering_1_N = mkN "omlokalisering" ; -- omlokalisering..nn.1
  omlopp_1_N = mkN "omlopp" neutrum  ; -- omlopp..nn.1
  omloppsbana_1_N = mkN "omloppsbana" ; -- omloppsbana..nn.1
  omloppshastighet_1_N = mkN "omloppshastighet" "omloppshastigheter" ; -- omloppshastighet..nn.1
  omloppstid_1_N = mkN "omloppstid" "omloppstider" ; -- omloppstid..nn.1
  omläggning_1_N = mkN "omläggning" ; -- omläggning..nn.1
  ommålning_1_N = mkN "ommålning" ; -- ommålning..nn.1
  ommöblera_1_V = mkV "ommöblerar" ; -- ommöblera..vb.1
  ommöblerande_1_N = mkN "ommöblerande" ; -- ommöblerande..nn.1
  ommöblerbar_1_A = mkA "ommöblerbar" ; -- ommöblerbar..av.1
  ommöblerbarhet_1_N = mkN "ommöblerbarhet" ; -- ommöblerbarhet..nn.1
  ommöblering_1_N = mkN "ommöblering" ; -- ommöblering..nn.1
  omnejd_1_N = mkN "omnejd" ; -- omnejd..nn.1
  omnibus_1_N = mkN "omnibus" ; -- omnibus..nn.1
  omnibuss_1_N = mkN "omnibuss" ; -- omnibuss..nn.1
  omnifyr_1_N = mkN "omnifyr" ; -- omnifyr..nn.1
  omnipotens_1_N = mkN "omnipotens" ; -- omnipotens..nn.1
  omnipotent_1_A = mkA "omnipotent" ; -- omnipotent..av.1
  omnivor_1_N = mkN "omnivor" "omnivoren" "omnivorer" "omnivorerna" ; -- omnivor..nn.1
  omnämna_1_V = mkV "omnämner" ; -- omnämna..vb.1
  omnämnande_1_N = mkN "omnämnande" ; -- omnämnande..nn.1
  omobbad_1_A = mkA "omobbad" ; -- omobbad..av.1
  omobiliserad_1_A = mkA "omobiliserad" ; -- omobiliserad..av.1
  omobiliserbar_1_A = mkA "omobiliserbar" ; -- omobiliserbar..av.1
  omobiliserbarhet_1_N = mkN "omobiliserbarhet" ; -- omobiliserbarhet..nn.1
  omockad_1_A = mkA "omockad" ; -- omockad..av.1
  omodellerad_1_A = mkA "omodellerad" ; -- omodellerad..av.1
  omodellerbar_1_A = mkA "omodellerbar" ; -- omodellerbar..av.1
  omodellerbarhet_1_N = mkN "omodellerbarhet" ; -- omodellerbarhet..nn.1
  omodererad_1_A = mkA "omodererad" ; -- omodererad..av.1
  omodererbar_1_A = mkA "omodererbar" ; -- omodererbar..av.1
  omodererbarhet_1_N = mkN "omodererbarhet" ; -- omodererbarhet..nn.1
  omodern_1_A = mkA "omodern" ; -- omodern..av.1
  omoderniserad_1_A = mkA "omoderniserad" ; -- omoderniserad..av.1
  omoderniserbar_1_A = mkA "omoderniserbar" ; -- omoderniserbar..av.1
  omoderniserbarhet_1_N = mkN "omoderniserbarhet" ; -- omoderniserbarhet..nn.1
  omodifierad_1_A = mkA "omodifierad" ; -- omodifierad..av.1
  omodifierbar_1_A = mkA "omodifierbar" ; -- omodifierbar..av.1
  omodifierbarhet_1_N = mkN "omodifierbarhet" ; -- omodifierbarhet..nn.1
  omodulerad_1_A = mkA "omodulerad" ; -- omodulerad..av.1
  omodulerbar_1_A = mkA "omodulerbar" ; -- omodulerbar..av.1
  omodulerbarhet_1_N = mkN "omodulerbarhet" ; -- omodulerbarhet..nn.1
  omodärniserad_1_A = mkA "omodärniserad" ; -- omodärniserad..av.1
  omodärniserbar_1_A = mkA "omodärniserbar" ; -- omodärniserbar..av.1
  omodärniserbarhet_1_N = mkN "omodärniserbarhet" ; -- omodärniserbarhet..nn.1
  omogen_1_A = mkA "omogen" ; -- omogen..av.1
  omogenhet_1_N = mkN "omogenhet" "omogenheter" ; -- omogenhet..nn.1
  omonoftongerad_1_A = mkA "omonoftongerad" ; -- omonoftongerad..av.1
  omonoftongerbar_1_A = mkA "omonoftongerbar" ; -- omonoftongerbar..av.1
  omonoftongerbarhet_1_N = mkN "omonoftongerbarhet" ; -- omonoftongerbarhet..nn.1
  omonopoliserad_1_A = mkA "omonopoliserad" ; -- omonopoliserad..av.1
  omonopoliserbar_1_A = mkA "omonopoliserbar" ; -- omonopoliserbar..av.1
  omonopoliserbarhet_1_N = mkN "omonopoliserbarhet" ; -- omonopoliserbarhet..nn.1
  omonterad_1_A = mkA "omonterad" ; -- omonterad..av.1
  omonterbar_1_A = mkA "omonterbar" ; -- omonterbar..av.1
  omonterbarhet_1_N = mkN "omonterbarhet" ; -- omonterbarhet..nn.1
  omoppad_1_A = mkA "omoppad" ; -- omoppad..av.1
  omoral_1_N = mkN "omoral" ; -- omoral..nn.1
  omoralisk_1_A = mkA "omoralisk" ; -- omoralisk..av.1
  omorganisation_1_N = mkN "omorganisation" ; -- omorganisation..nn.1
  omorganisera_1_V = mkV "omorganiserar" ; -- omorganisera..vb.1
  omorganiserande_1_N = mkN "omorganiserande" ; -- omorganiserande..nn.1
  omorganiserbar_1_A = mkA "omorganiserbar" ; -- omorganiserbar..av.1
  omorganiserbarhet_1_N = mkN "omorganiserbarhet" ; -- omorganiserbarhet..nn.1
  omorganisering_1_N = mkN "omorganisering" ; -- omorganisering..nn.1
  omorgnad_1_A = mkA "omorgnad" ; -- omorgnad..av.1
  omornad_1_A = mkA "omornad" ; -- omornad..av.1
  omorserad_1_A = mkA "omorserad" ; -- omorserad..av.1
  omorserbar_1_A = mkA "omorserbar" ; -- omorserbar..av.1
  omorserbarhet_1_N = mkN "omorserbarhet" ; -- omorserbarhet..nn.1
  omortificerad_1_A = mkA "omortificerad" ; -- omortificerad..av.1
  omortificerbar_1_A = mkA "omortificerbar" ; -- omortificerbar..av.1
  omortificerbarhet_1_N = mkN "omortificerbarhet" ; -- omortificerbarhet..nn.1
  omortifierad_1_A = mkA "omortifierad" ; -- omortifierad..av.1
  omortifierbar_1_A = mkA "omortifierbar" ; -- omortifierbar..av.1
  omortifierbarhet_1_N = mkN "omortifierbarhet" ; -- omortifierbarhet..nn.1
  omosad_1_A = mkA "omosad" ; -- omosad..av.1
  omotad_1_A = mkA "omotad" ; -- omotad..av.1
  omotarbetad_1_A = mkA "omotarbetad" ; -- omotarbetad..av.1
  omotbevisad_1_A = mkA "omotbevisad" ; -- omotbevisad..av.1
  omotiverad_1_A = mkA "omotiverad" ; -- omotiverad..av.1
  omotiverbar_1_A = mkA "omotiverbar" ; -- omotiverbar..av.1
  omotiverbarhet_1_N = mkN "omotiverbarhet" ; -- omotiverbarhet..nn.1
  omotläst_1_A = mkA "omotläst" "omotläst" ; -- omotläst..av.1
  omotoriserad_1_A = mkA "omotoriserad" ; -- omotoriserad..av.1
  omotoriserbar_1_A = mkA "omotoriserbar" ; -- omotoriserbar..av.1
  omotoriserbarhet_1_N = mkN "omotoriserbarhet" ; -- omotoriserbarhet..nn.1
  omotsagd_1_A = mkA "omotsagd" "omotsagt" ; -- omotsagd..av.1
  omotståndlig_1_A = mkA "omotståndlig" ; -- omotståndlig..av.1
  omotståndlighet_1_N = mkN "omotståndlighet" ; -- omotståndlighet..nn.1
  omotsäglig_1_A = mkA "omotsäglig" ; -- omotsäglig..av.1
  omotsäglighet_1_N = mkN "omotsäglighet" ; -- omotsäglighet..nn.1
  omottaglig_1_A = mkA "omottaglig" ; -- omottaglig..av.1
  omottaglighet_1_N = mkN "omottaglighet" ; -- omottaglighet..nn.1
  omotverkad_1_A = mkA "omotverkad" ; -- omotverkad..av.1
  omotvägd_1_A = mkA "omotvägd" "omotvägt" ; -- omotvägd..av.1
  ompackning_1_N = mkN "ompackning" ; -- ompackning..nn.1
  omplacera_1_V = mkV "omplacerar" ; -- omplacera..vb.1
  omplacerande_1_N = mkN "omplacerande" ; -- omplacerande..nn.1
  omplacerbar_1_A = mkA "omplacerbar" ; -- omplacerbar..av.1
  omplacerbarhet_1_N = mkN "omplacerbarhet" ; -- omplacerbarhet..nn.1
  omplacering_1_N = mkN "omplacering" ; -- omplacering..nn.1
  omplantering_1_N = mkN "omplantering" ; -- omplantering..nn.1
  omplåstra_1_V = mkV "omplåstrar" ; -- omplåstra..vb.1
  omplåstrande_1_N = mkN "omplåstrande" ; -- omplåstrande..nn.1
  ompolering_1_N = mkN "ompolering" ; -- ompolering..nn.1
  omprioritera_1_V = mkV "omprioriterar" ; -- omprioritera..vb.1
  omprioriterande_1_N = mkN "omprioriterande" ; -- omprioriterande..nn.1
  omprioriterbar_1_A = mkA "omprioriterbar" ; -- omprioriterbar..av.1
  omprioriterbarhet_1_N = mkN "omprioriterbarhet" ; -- omprioriterbarhet..nn.1
  omprioritering_1_N = mkN "omprioritering" ; -- omprioritering..nn.1
  ompröva_1_V = mkV "omprövar" ; -- ompröva..vb.1
  omprövande_1_N = mkN "omprövande" ; -- omprövande..nn.1
  omprövning_1_N = mkN "omprövning" ; -- omprövning..nn.1
  omrama_1_V = mkV "omramar" ; -- omrama..vb.1
  omramande_1_N = mkN "omramande" ; -- omramande..nn.1
  omramning_1_N = mkN "omramning" ; -- omramning..nn.1
  omredigering_1_N = mkN "omredigering" ; -- omredigering..nn.1
  omreglering_1_N = mkN "omreglering" ; -- omreglering..nn.1
  omriktare_1_N = mkN "omriktare" utrum  ; -- omriktare..nn.1
  omringa_1_V = mkV "omringar" ; -- omringa..vb.1
  omringande_1_N = mkN "omringande" ; -- omringande..nn.1
  omringning_1_N = mkN "omringning" ; -- omringning..nn.1
  omräkna_1_V = mkV "omräknar" ; -- omräkna..vb.1
  omräknande_1_N = mkN "omräknande" ; -- omräknande..nn.1
  omräkning_1_N = mkN "omräkning" ; -- omräkning..nn.1
  omräkningsrysare_1_N = mkN "omräkningsrysare" utrum  ; -- omräkningsrysare..nn.1
  område_1_N = mkN "område" ; -- område..nn.1
  omröring_1_N = mkN "omröring" ; -- omröring..nn.1
  omrörning_1_N = mkN "omrörning" ; -- omrörning..nn.1
  omröstning_1_N = mkN "omröstning" ; -- omröstning..nn.1
  oms_1_N = mkN "oms" ; -- oms..nn.1
  omsams_1_A = mkA "omsams" ; -- omsams..av.1
  omse_1_V = mkV "omse" "omsåg" "omsett" ; -- omse..vb.1
  omseende_1_N = mkN "omseende" ; -- omseende..nn.1
  omsegling_1_N = mkN "omsegling" ; -- omsegling..nn.1
  omsider_1_Adv = mkAdv "omsider" ; -- omsider..ab.1
  omskakad_1_A = mkA "omskakad" ; -- omskakad..av.1
  omskakande_1_A = mkA "omskakande" ; -- omskakande..av.1
  omskapa_1_V = mkV "omskapar" ; -- omskapa..vb.1
  omskapande_1_N = mkN "omskapande" ; -- omskapande..nn.1
  omskapare_1_N = mkN "omskapare" utrum  ; -- omskapare..nn.1
  omskiftare_1_N = mkN "omskiftare" utrum  ; -- omskiftare..nn.1
  omskiftartangent_1_N = mkN "omskiftartangent" "omskiftartangenter" ; -- omskiftartangent..nn.1
  omskola_1_V = mkV "omskolar" ; -- omskola..vb.1
  omskolande_1_N = mkN "omskolande" ; -- omskolande..nn.1
  omskolning_1_N = mkN "omskolning" ; -- omskolning..nn.1
  omskriva_1_V = mkV "omskriva" "omskrev" "omskrivit" ; -- omskriva..vb.1
  omskrivande_1_N = mkN "omskrivande" ; -- omskrivande..nn.1
  omskriven_1_A = mkA "omskriven" ; -- omskriven..av.1
  omskrivning_1_N = mkN "omskrivning" ; -- omskrivning..nn.1
  omskruten_1_A = mkA "omskruten" ; -- omskruten..av.1
  omskulpturera_1_V = mkV "omskulpturerar" ; -- omskulpturera..vb.1
  omskulpturerande_1_N = mkN "omskulpturerande" ; -- omskulpturerande..nn.1
  omskulpturerbar_1_A = mkA "omskulpturerbar" ; -- omskulpturerbar..av.1
  omskulpturerbarhet_1_N = mkN "omskulpturerbarhet" ; -- omskulpturerbarhet..nn.1
  omskulpturering_1_N = mkN "omskulpturering" ; -- omskulpturering..nn.1
  omskära_1_V = mkV "omskära" "omskar" "omskurit" ; -- omskära..vb.1
  omskärande_1_N = mkN "omskärande" ; -- omskärande..nn.1
  omskärelse_1_N = mkN "omskärelse" "omskärelser" ; -- omskärelse..nn.1
  omsköta_1_V = mkV "omsköter" ; -- omsköta..vb.1
  omskötande_1_N = mkN "omskötande" ; -- omskötande..nn.1
  omslag_1_N = mkN "omslag" neutrum  ; -- omslag..nn.1
  omslagsbild_1_N = mkN "omslagsbild" "omslagsbilder" ; -- omslagsbild..nn.1
  omslagspapper_1_N = mkN "omslagspapper" neutrum  ; -- omslagspapper..nn.1
  omslagsrevers_1_N = mkN "omslagsrevers" "omslagsreverser" ; -- omslagsrevers..nn.1
  omslingra_1_V = mkV "omslingrar" ; -- omslingra..vb.1
  omslingrande_1_N = mkN "omslingrande" ; -- omslingrande..nn.1
  omslut_1_N = mkN "omslut" neutrum  ; -- omslut..nn.1
  omsluta_1_V = mkV "omsluta" "omslöt" "omslutit" ; -- omsluta..vb.1
  omslutande_1_N = mkN "omslutande" ; -- omslutande..nn.1
  omslutning_1_N = mkN "omslutning" ; -- omslutning..nn.1
  omsorg_1_N = mkN "omsorg" "omsorger" ; -- omsorg..nn.1
  omsorgsfull_1_A = mkA "omsorgsfull" ; -- omsorgsfull..av.1
  omsorgsfullhet_1_N = mkN "omsorgsfullhet" "omsorgsfullheter" ; -- omsorgsfullhet..nn.1
  omsorgsvård_1_N = mkN "omsorgsvård" ; -- omsorgsvård..nn.1
  omspel_1_N = mkN "omspel" "omspelet" "omspel" "omspelen" ; -- omspel..nn.1
  omspinna_1_V = mkV "omspinna" "omspann" "omspunnit" ; -- omspinna..vb.1
  omspinnande_1_N = mkN "omspinnande" ; -- omspinnande..nn.1
  omspinning_1_N = mkN "omspinning" ; -- omspinning..nn.1
  omspänna_1_V = mkV "omspänna" "omspände" "omspänt" ; -- omspänna..vb.1
  omspännande_1_N = mkN "omspännande" ; -- omspännande..nn.1
  omspänning_1_N = mkN "omspänning" ; -- omspänning..nn.1
  omstart_1_N = mkN "omstart" "omstarter" ; -- omstart..nn.1
  omstigning_1_N = mkN "omstigning" ; -- omstigning..nn.1
  omstridd_1_A = mkA "omstridd" ; -- omstridd..av.1
  omstriddhet_1_N = mkN "omstriddhet" ; -- omstriddhet..nn.1
  omstrukturera_1_V = mkV "omstrukturerar" ; -- omstrukturera..vb.1
  omstrukturerande_1_N = mkN "omstrukturerande" ; -- omstrukturerande..nn.1
  omstrukturerbar_1_A = mkA "omstrukturerbar" ; -- omstrukturerbar..av.1
  omstrukturerbarhet_1_N = mkN "omstrukturerbarhet" ; -- omstrukturerbarhet..nn.1
  omstrukturering_1_N = mkN "omstrukturering" ; -- omstrukturering..nn.1
  omstråla_1_V = mkV "omstrålar" ; -- omstråla..vb.1
  omstrålande_1_N = mkN "omstrålande" ; -- omstrålande..nn.1
  omstuvning_1_N = mkN "omstuvning" ; -- omstuvning..nn.1
  omställa_1_V = mkV "omställer" ; -- omställa..vb.1
  omställande_1_N = mkN "omställande" ; -- omställande..nn.1
  omställning_1_N = mkN "omställning" ; -- omställning..nn.1
  omställningsbar_1_A = mkA "omställningsbar" ; -- omställningsbar..av.1
  omställningsfråga_1_N = mkN "omställningsfråga" ; -- omställningsfråga..nn.1
  omständig_1_A = mkA "omständig" ; -- omständig..av.1
  omständighet_1_N = mkN "omständighet" "omständigheter" ; -- omständighet..nn.1
  omständlig_1_A = mkA "omständlig" ; -- omständlig..av.1
  omständlighet_1_N = mkN "omständlighet" ; -- omständlighet..nn.1
  omstående_1_A = mkA "omstående" ; -- omstående..av.1
  omstöpa_1_V = mkV "omstöper" ; -- omstöpa..vb.1
  omstöpande_1_N = mkN "omstöpande" ; -- omstöpande..nn.1
  omstöpning_1_N = mkN "omstöpning" ; -- omstöpning..nn.1
  omstörta_1_V = mkV "omstörtar" ; -- omstörta..vb.1
  omstörtande_1_A = mkA "omstörtande" ; -- omstörtande..av.1
  omstörtande_1_N = mkN "omstörtande" ; -- omstörtande..nn.1
  omstörtning_1_N = mkN "omstörtning" ; -- omstörtning..nn.1
  omsusad_1_A = mkA "omsusad" ; -- omsusad..av.1
  omsvepa_1_V = mkV "omsveper" ; -- omsvepa..vb.1
  omsvepande_1_N = mkN "omsvepande" ; -- omsvepande..nn.1
  omsving_1_N = mkN "omsving" ; -- omsving..nn.1
  omsvängning_1_N = mkN "omsvängning" ; -- omsvängning..nn.1
  omsvärma_1_V = mkV "omsvärmar" ; -- omsvärma..vb.1
  omsvärmande_1_N = mkN "omsvärmande" ; -- omsvärmande..nn.1
  omsyn_1_N = mkN "omsyn" ; -- omsyn..nn.1
  omsätta_1_V = mkV "omsätta" "omsätter" "omsätt" "omsatte" "omsatt" "omsatt" ; -- omsätta..vb.1
  omsättande_1_N = mkN "omsättande" ; -- omsättande..nn.1
  omsättning_1_N = mkN "omsättning" ; -- omsättning..nn.1
  omsättningsskatt_1_N = mkN "omsättningsskatt" "omsättningsskatter" ; -- omsättningsskatt..nn.1
  omsättningstillgång_1_N = mkN "omsättningstillgång" ; -- omsättningstillgång..nn.1
  omta_1_V = mkV "omtaga" "omtog" "omtagit" ; -- omta..vb.1
  omtag_1_N = mkN "omtag" neutrum  ; -- omtag..nn.1
  omtagande_1_N = mkN "omtagande" ; -- omtagande..nn.1
  omtagning_1_N = mkN "omtagning" ; -- omtagning..nn.1
  omtal_1_N = mkN "omtal" neutrum  ; -- omtal..nn.1
  omtala_1_V = mkV "omtalar" ; -- omtala..vb.1
  omtalad_1_A = mkA "omtalad" ; -- omtalad..av.1
  omtalande_1_N = mkN "omtalande" ; -- omtalande..nn.1
  omtanke_1_N = mkN "omtanke" utrum  ; -- omtanke..nn.1
  omtolka_1_V = mkV "omtolkar" ; -- omtolka..vb.1
  omtolkande_1_N = mkN "omtolkande" ; -- omtolkande..nn.1
  omtolkning_1_N = mkN "omtolkning" ; -- omtolkning..nn.1
  omtryck_1_N = mkN "omtryck" neutrum  ; -- omtryck..nn.1
  omtuggad_1_A = mkA "omtuggad" ; -- omtuggad..av.1
  omtuggning_1_N = mkN "omtuggning" ; -- omtuggning..nn.1
  omtumlad_1_A = mkA "omtumlad" ; -- omtumlad..av.1
  omtumlande_1_A = mkA "omtumlande" ; -- omtumlande..av.1
  omtvistad_1_A = mkA "omtvistad" ; -- omtvistad..av.1
  omtyckt_1_A = mkA "omtyckt" "omtyckt" ; -- omtyckt..av.1
  omtyckthet_1_N = mkN "omtyckthet" ; -- omtyckthet..nn.1
  omtänksam_1_A = mkA "omtänksam" "omtänksamt" "omtänksamma" "omtänksamma" "omtänksammare" "omtänksammast" "omtänksammaste" ; -- omtänksam..av.1
  omtänksamhet_1_N = mkN "omtänksamhet" ; -- omtänksamhet..nn.1
  omtöcknad_1_A = mkA "omtöcknad" ; -- omtöcknad..av.1
  omuddrad_1_A = mkA "omuddrad" ; -- omuddrad..av.1
  omuljerad_1_A = mkA "omuljerad" ; -- omuljerad..av.1
  omuljerbar_1_A = mkA "omuljerbar" ; -- omuljerbar..av.1
  omuljerbarhet_1_N = mkN "omuljerbarhet" ; -- omuljerbarhet..nn.1
  omultiplicerad_1_A = mkA "omultiplicerad" ; -- omultiplicerad..av.1
  omultiplicerbar_1_A = mkA "omultiplicerbar" ; -- omultiplicerbar..av.1
  omultiplicerbarhet_1_N = mkN "omultiplicerbarhet" ; -- omultiplicerbarhet..nn.1
  omumifierad_1_A = mkA "omumifierad" ; -- omumifierad..av.1
  omumifierbar_1_A = mkA "omumifierbar" ; -- omumifierbar..av.1
  omumifierbarhet_1_N = mkN "omumifierbarhet" ; -- omumifierbarhet..nn.1
  omurad_1_A = mkA "omurad" ; -- omurad..av.1
  omusikalisk_1_A = mkA "omusikalisk" ; -- omusikalisk..av.1
  omutad_1_A = mkA "omutad" ; -- omutad..av.1
  omutbar_1_A = mkA "omutbar" ; -- omutbar..av.1
  omutbarhet_1_N = mkN "omutbarhet" ; -- omutbarhet..nn.1
  omuterad_1_A = mkA "omuterad" ; -- omuterad..av.1
  omuterbar_1_A = mkA "omuterbar" ; -- omuterbar..av.1
  omuterbarhet_1_N = mkN "omuterbarhet" ; -- omuterbarhet..nn.1
  omutlig_1_A = mkA "omutlig" ; -- omutlig..av.1
  omutlighet_1_N = mkN "omutlighet" ; -- omutlighet..nn.1
  omval_1_N = mkN "omval" neutrum  ; -- omval..nn.1
  omvandla_1_V = mkV "omvandlar" ; -- omvandla..vb.1
  omvandlande_1_N = mkN "omvandlande" ; -- omvandlande..nn.1
  omvandlare_1_N = mkN "omvandlare" utrum  ; -- omvandlare..nn.1
  omvandling_1_N = mkN "omvandling" ; -- omvandling..nn.1
  omvandlingsprocess_1_N = mkN "omvandlingsprocess" "omvandlingsprocesser" ; -- omvandlingsprocess..nn.1
  omvittna_1_V = mkV "omvittnar" ; -- omvittna..vb.1
  omvittnande_1_N = mkN "omvittnande" ; -- omvittnande..nn.1
  omvridning_1_N = mkN "omvridning" ; -- omvridning..nn.1
  omväg_1_N = mkN "omväg" ; -- omväg..nn.1
  omvälja_1_V = mkV "omvälja" "omvalde" "omvalt" ; -- omvälja..vb.1
  omväljande_1_N = mkN "omväljande" ; -- omväljande..nn.1
  omväljning_1_N = mkN "omväljning" ; -- omväljning..nn.1
  omvälva_1_V = mkV "omvälver" ; -- omvälva..vb.1
  omvälvande_1_N = mkN "omvälvande" ; -- omvälvande..nn.1
  omvälvning_1_N = mkN "omvälvning" ; -- omvälvning..nn.1
  omvälvningsperiod_1_N = mkN "omvälvningsperiod" "omvälvningsperioder" ; -- omvälvningsperiod..nn.1
  omvänd_1_A = mkA "omvänd" ; -- omvänd..av.1
  omvända_1_V = mkV "omvänder" ; -- omvända..vb.1
  omvändande_1_N = mkN "omvändande" ; -- omvändande..nn.1
  omvändbar_1_A = mkA "omvändbar" ; -- omvändbar..av.1
  omvändbarhet_1_N = mkN "omvändbarhet" ; -- omvändbarhet..nn.1
  omvändelse_1_N = mkN "omvändelse" "omvändelser" ; -- omvändelse..nn.1
  omvändning_1_N = mkN "omvändning" ; -- omvändning..nn.1
  omvändningsfilm_1_N = mkN "omvändningsfilm" "omvändningsfilmer" ; -- omvändningsfilm..nn.1
  omvändningstecken_1_N = mkN "omvändningstecken" "omvändningstecknet" "omvändningstecken" "omvändningstecknen" ; -- omvändningstecken..nn.1
  omvärdera_1_V = mkV "omvärderar" ; -- omvärdera..vb.1
  omvärderande_1_N = mkN "omvärderande" ; -- omvärderande..nn.1
  omvärderbar_1_A = mkA "omvärderbar" ; -- omvärderbar..av.1
  omvärderbarhet_1_N = mkN "omvärderbarhet" ; -- omvärderbarhet..nn.1
  omvärdering_1_N = mkN "omvärdering" ; -- omvärdering..nn.1
  omvärld_1_N = mkN "omvärld" ; -- omvärld..nn.1
  omvärva_1_V = mkV "omvärver" ; -- omvärva..vb.1
  omvärvande_1_N = mkN "omvärvande" ; -- omvärvande..nn.1
  omväxla_1_V = mkV "omväxlar" ; -- omväxla..vb.1
  omväxlande_1_A = mkA "omväxlande" ; -- omväxlande..av.1
  omväxlande_1_N = mkN "omväxlande" ; -- omväxlande..nn.1
  omväxling_1_N = mkN "omväxling" ; -- omväxling..nn.1
  omvårdnad_1_N = mkN "omvårdnad" "omvårdnader" ; -- omvårdnad..nn.1
  omvårdnadsmässig_1_A = mkA "omvårdnadsmässig" ; -- omvårdnadsmässig..av.1
  omyllad_1_A = mkA "omyllad" ; -- omyllad..av.1
  omyndig_1_A = mkA "omyndig" ; -- omyndig..av.1
  omyndigförklara_1_V = mkV "omyndigförklarar" ; -- omyndigförklara..vb.1
  omyndigförklarande_1_N = mkN "omyndigförklarande" ; -- omyndigförklarande..nn.1
  omyndigförklaring_1_N = mkN "omyndigförklaring" ; -- omyndigförklaring..nn.1
  omyndighet_1_N = mkN "omyndighet" ; -- omyndighet..nn.1
  omyndighetsförklaring_1_N = mkN "omyndighetsförklaring" ; -- omyndighetsförklaring..nn.1
  omyntad_1_A = mkA "omyntad" ; -- omyntad..av.1
  omystifierad_1_A = mkA "omystifierad" ; -- omystifierad..av.1
  omystifierbar_1_A = mkA "omystifierbar" ; -- omystifierbar..av.1
  omystifierbarhet_1_N = mkN "omystifierbarhet" ; -- omystifierbarhet..nn.1
  omäklad_1_A = mkA "omäklad" ; -- omäklad..av.1
  omältad_1_A = mkA "omältad" ; -- omältad..av.1
  omändra_1_V = mkV "omändrar" ; -- omändra..vb.1
  omändrande_1_N = mkN "omändrande" ; -- omändrande..nn.1
  omängd_1_A = mkA "omängd" "omängt" ; -- omängd..av.1
  omängdhet_1_N = mkN "omängdhet" ; -- omängdhet..nn.1
  omänniska_1_N = mkN "omänniska" ; -- omänniska..nn.1
  omänsklig_1_A = mkA "omänsklig" ; -- omänsklig..av.1
  omänsklighet_1_N = mkN "omänsklighet" "omänskligheter" ; -- omänsklighet..nn.1
  omärglad_1_A = mkA "omärglad" ; -- omärglad..av.1
  omärkbar_1_A = mkA "omärkbar" ; -- omärkbar..av.1
  omärkbarhet_1_N = mkN "omärkbarhet" "omärkbarheter" ; -- omärkbarhet..nn.1
  omärklig_1_A = mkA "omärklig" ; -- omärklig..av.1
  omärklighet_1_N = mkN "omärklighet" ; -- omärklighet..nn.1
  omärkt_1_A = mkA "omärkt" "omärkt" ; -- omärkt..av.1
  omäskad_1_A = mkA "omäskad" ; -- omäskad..av.1
  omästrad_1_A = mkA "omästrad" ; -- omästrad..av.1
  omätbar_1_A = mkA "omätbar" ; -- omätbar..av.1
  omätbarhet_1_N = mkN "omätbarhet" "omätbarheter" ; -- omätbarhet..nn.1
  omätlig_1_A = mkA "omätlig" ; -- omätlig..av.1
  omätlighet_1_N = mkN "omätlighet" ; -- omätlighet..nn.1
  omätt_1_A = mkA "omätt" ; -- omätt..av.1
  omättad_1_A = mkA "omättad" ; -- omättad..av.1
  omättlig_1_A = mkA "omättlig" ; -- omättlig..av.1
  omättlighet_1_N = mkN "omättlighet" ; -- omättlighet..nn.1
  omålad_1_A = mkA "omålad" ; -- omålad..av.1
  omånglad_1_A = mkA "omånglad" ; -- omånglad..av.1
  omåttad_1_A = mkA "omåttad" ; -- omåttad..av.1
  omåttlig_1_A = mkA "omåttlig" ; -- omåttlig..av.1
  omåttlighet_1_N = mkN "omåttlighet" "omåttligheter" ; -- omåttlighet..nn.1
  omöblerad_1_A = mkA "omöblerad" ; -- omöblerad..av.1
  omöblerbar_1_A = mkA "omöblerbar" ; -- omöblerbar..av.1
  omöblerbarhet_1_N = mkN "omöblerbarhet" ; -- omöblerbarhet..nn.1
  omöjlig_1_A = mkA "omöjlig" ; -- omöjlig..av.1
  omöjligen_1_Adv = mkAdv "omöjligen" ; -- omöjligen..ab.1
  omöjliggöra_1_V = mkV "omöjliggöra" "omöjliggjorde" "omöjliggjort" ; -- omöjliggöra..vb.1
  omöjliggörande_1_N = mkN "omöjliggörande" ; -- omöjliggörande..nn.1
  omöjlighet_1_N = mkN "omöjlighet" "omöjligheter" ; -- omöjlighet..nn.1
  omönstrad_1_A = mkA "omönstrad" ; -- omönstrad..av.1
  omörad_1_A = mkA "omörad" ; -- omörad..av.1
  omördad_1_A = mkA "omördad" ; -- omördad..av.1
  omörkad_1_A = mkA "omörkad" ; -- omörkad..av.1
  omött_1_A = mkA "omött" ; -- omött..av.1
  onackad_1_A = mkA "onackad" ; -- onackad..av.1
  onafsad_1_A = mkA "onafsad" ; -- onafsad..av.1
  onager_1_N = mkN "onager" "onagern" "onagrer" "onagrerna" ; -- onager..nn.1
  onaggad_1_A = mkA "onaggad" ; -- onaggad..av.1
  onaglad_1_A = mkA "onaglad" ; -- onaglad..av.1
  onajad_1_A = mkA "onajad" ; -- onajad..av.1
  onallad_1_A = mkA "onallad" ; -- onallad..av.1
  onamnad_1_A = mkA "onamnad" ; -- onamnad..av.1
  onanera_1_V = mkV "onanerar" ; -- onanera..vb.1
  onanerande_1_N = mkN "onanerande" ; -- onanerande..nn.1
  onanering_1_N = mkN "onanering" ; -- onanering..nn.1
  onani_1_N = mkN "onani" ; -- onani..nn.1
  onanisera_1_V = mkV "onaniserar" ; -- onanisera..vb.1
  onaniserande_1_N = mkN "onaniserande" ; -- onaniserande..nn.1
  onanisering_1_N = mkN "onanisering" ; -- onanisering..nn.1
  onanist_1_N = mkN "onanist" "onanister" ; -- onanist..nn.1
  onappad_1_A = mkA "onappad" ; -- onappad..av.1
  onarad_1_A = mkA "onarad" ; -- onarad..av.1
  onarrad_1_A = mkA "onarrad" ; -- onarrad..av.1
  onarvad_1_A = mkA "onarvad" ; -- onarvad..av.1
  onasad_1_A = mkA "onasad" ; -- onasad..av.1
  onasalerad_1_A = mkA "onasalerad" ; -- onasalerad..av.1
  onasalerbar_1_A = mkA "onasalerbar" ; -- onasalerbar..av.1
  onasalerbarhet_1_N = mkN "onasalerbarhet" ; -- onasalerbarhet..nn.1
  onasaliserad_1_A = mkA "onasaliserad" ; -- onasaliserad..av.1
  onasaliserbar_1_A = mkA "onasaliserbar" ; -- onasaliserbar..av.1
  onasaliserbarhet_1_N = mkN "onasaliserbarhet" ; -- onasaliserbarhet..nn.1
  onationaliserad_1_A = mkA "onationaliserad" ; -- onationaliserad..av.1
  onationaliserbar_1_A = mkA "onationaliserbar" ; -- onationaliserbar..av.1
  onationaliserbarhet_1_N = mkN "onationaliserbarhet" ; -- onationaliserbarhet..nn.1
  onattad_1_A = mkA "onattad" ; -- onattad..av.1
  onatur_1_N = mkN "onatur" ; -- onatur..nn.1
  onaturaliserad_1_A = mkA "onaturaliserad" ; -- onaturaliserad..av.1
  onaturaliserbar_1_A = mkA "onaturaliserbar" ; -- onaturaliserbar..av.1
  onaturaliserbarhet_1_N = mkN "onaturaliserbarhet" ; -- onaturaliserbarhet..nn.1
  onaturlig_1_A = mkA "onaturlig" ; -- onaturlig..av.1
  onaturlighet_1_N = mkN "onaturlighet" "onaturligheter" ; -- onaturlighet..nn.1
  onavigerad_1_A = mkA "onavigerad" ; -- onavigerad..av.1
  onavigerbar_1_A = mkA "onavigerbar" ; -- onavigerbar..av.1
  onavigerbarhet_1_N = mkN "onavigerbarhet" ; -- onavigerbarhet..nn.1
  onavlad_1_A = mkA "onavlad" ; -- onavlad..av.1
  ond_1_A = mkA "ond" ; -- ond..av.1
  ondsint_1_A = mkA "ondsint" "ondsint" ; -- ondsint..av.1
  ondsinthet_1_N = mkN "ondsinthet" ; -- ondsinthet..nn.1
  ondska_1_N = mkN "ondska" ; -- ondska..nn.1
  ondskefull_1_A = mkA "ondskefull" ; -- ondskefull..av.1
  ondskefullhet_1_N = mkN "ondskefullhet" "ondskefullheter" ; -- ondskefullhet..nn.1
  ondulera_1_V = mkV "ondulerar" ; -- ondulera..vb.1
  ondulerande_1_N = mkN "ondulerande" ; -- ondulerande..nn.1
  ondulerbar_1_A = mkA "ondulerbar" ; -- ondulerbar..av.1
  ondulerbarhet_1_N = mkN "ondulerbarhet" ; -- ondulerbarhet..nn.1
  ondulering_1_N = mkN "ondulering" ; -- ondulering..nn.1
  one_step_1_N = mkN "one-step" ; -- one-step..nn.1
  onedarbetad_1_A = mkA "onedarbetad" ; -- onedarbetad..av.1
  onedblåst_1_A = mkA "onedblåst" "onedblåst" ; -- onedblåst..av.1
  onedisad_1_A = mkA "onedisad" ; -- onedisad..av.1
  onedkallad_1_A = mkA "onedkallad" ; -- onedkallad..av.1
  onedkastad_1_A = mkA "onedkastad" ; -- onedkastad..av.1
  onedkavlad_1_A = mkA "onedkavlad" ; -- onedkavlad..av.1
  onedklassad_1_A = mkA "onedklassad" ; -- onedklassad..av.1
  onedmonterbar_1_A = mkA "onedmonterbar" ; -- onedmonterbar..av.1
  onedmonterbarhet_1_N = mkN "onedmonterbarhet" ; -- onedmonterbarhet..nn.1
  onedrustad_1_A = mkA "onedrustad" ; -- onedrustad..av.1
  onedsänkt_1_A = mkA "onedsänkt" "onedsänkt" ; -- onedsänkt..av.1
  onedtecknad_1_A = mkA "onedtecknad" ; -- onedtecknad..av.1
  onedtransformerad_1_A = mkA "onedtransformerad" ; -- onedtransformerad..av.1
  onedtransformerbar_1_A = mkA "onedtransformerbar" ; -- onedtransformerbar..av.1
  onedtransformerbarhet_1_N = mkN "onedtransformerbarhet" ; -- onedtransformerbarhet..nn.1
  onedtransponerad_1_A = mkA "onedtransponerad" ; -- onedtransponerad..av.1
  onedtransponerbar_1_A = mkA "onedtransponerbar" ; -- onedtransponerbar..av.1
  onedtransponerbarhet_1_N = mkN "onedtransponerbarhet" ; -- onedtransponerbarhet..nn.1
  onedvärderad_1_A = mkA "onedvärderad" ; -- onedvärderad..av.1
  onedvärderbar_1_A = mkA "onedvärderbar" ; -- onedvärderbar..av.1
  onedvärderbarhet_1_N = mkN "onedvärderbarhet" ; -- onedvärderbarhet..nn.1
  onegerad_1_A = mkA "onegerad" ; -- onegerad..av.1
  onegerbar_1_A = mkA "onegerbar" ; -- onegerbar..av.1
  onegerbarhet_1_N = mkN "onegerbarhet" ; -- onegerbarhet..nn.1
  onegligerad_1_A = mkA "onegligerad" ; -- onegligerad..av.1
  onegligerbar_1_A = mkA "onegligerbar" ; -- onegligerbar..av.1
  onegligerbarhet_1_N = mkN "onegligerbarhet" ; -- onegligerbarhet..nn.1
  onegocierad_1_A = mkA "onegocierad" ; -- onegocierad..av.1
  onegocierbar_1_A = mkA "onegocierbar" ; -- onegocierbar..av.1
  onegocierbarhet_1_N = mkN "onegocierbarhet" ; -- onegocierbarhet..nn.1
  onegotierad_1_A = mkA "onegotierad" ; -- onegotierad..av.1
  onegotierbar_1_A = mkA "onegotierbar" ; -- onegotierbar..av.1
  onegotierbarhet_1_N = mkN "onegotierbarhet" ; -- onegotierbarhet..nn.1
  oneiromanti_1_N = mkN "oneiromanti" ; -- oneiromanti..nn.1
  onekad_1_A = mkA "onekad" ; -- onekad..av.1
  oneklig_1_A = mkA "oneklig" ; -- oneklig..av.1
  onekligen_1_Adv = mkAdv "onekligen" ; -- onekligen..ab.1
  oneklighet_1_N = mkN "oneklighet" ; -- oneklighet..nn.1
  onerarbetad_1_A = mkA "onerarbetad" ; -- onerarbetad..av.1
  onerblåst_1_A = mkA "onerblåst" "onerblåst" ; -- onerblåst..av.1
  onerisad_1_A = mkA "onerisad" ; -- onerisad..av.1
  onerkallad_1_A = mkA "onerkallad" ; -- onerkallad..av.1
  onerkastad_1_A = mkA "onerkastad" ; -- onerkastad..av.1
  onerkavlad_1_A = mkA "onerkavlad" ; -- onerkavlad..av.1
  onerklassad_1_A = mkA "onerklassad" ; -- onerklassad..av.1
  onerrustad_1_A = mkA "onerrustad" ; -- onerrustad..av.1
  onersänkt_1_A = mkA "onersänkt" "onersänkt" ; -- onersänkt..av.1
  onertecknad_1_A = mkA "onertecknad" ; -- onertecknad..av.1
  onertransformerad_1_A = mkA "onertransformerad" ; -- onertransformerad..av.1
  onertransformerbar_1_A = mkA "onertransformerbar" ; -- onertransformerbar..av.1
  onertransformerbarhet_1_N = mkN "onertransformerbarhet" ; -- onertransformerbarhet..nn.1
  onertransponerad_1_A = mkA "onertransponerad" ; -- onertransponerad..av.1
  onertransponerbar_1_A = mkA "onertransponerbar" ; -- onertransponerbar..av.1
  onertransponerbarhet_1_N = mkN "onertransponerbarhet" ; -- onertransponerbarhet..nn.1
  onervärderad_1_A = mkA "onervärderad" ; -- onervärderad..av.1
  onervärderbar_1_A = mkA "onervärderbar" ; -- onervärderbar..av.1
  onervärderbarhet_1_N = mkN "onervärderbarhet" ; -- onervärderbarhet..nn.1
  onestep_1_N = mkN "onestep" ; -- onestep..nn.1
  oneutraliserad_1_A = mkA "oneutraliserad" ; -- oneutraliserad..av.1
  oneutraliserbar_1_A = mkA "oneutraliserbar" ; -- oneutraliserbar..av.1
  oneutraliserbarhet_1_N = mkN "oneutraliserbarhet" ; -- oneutraliserbarhet..nn.1
  oniad_1_A = mkA "oniad" ; -- oniad..av.1
  onickad_1_A = mkA "onickad" ; -- onickad..av.1
  oniellerad_1_A = mkA "oniellerad" ; -- oniellerad..av.1
  oniellerbar_1_A = mkA "oniellerbar" ; -- oniellerbar..av.1
  oniellerbarhet_1_N = mkN "oniellerbarhet" ; -- oniellerbarhet..nn.1
  onitad_1_A = mkA "onitad" ; -- onitad..av.1
  onitrerad_1_A = mkA "onitrerad" ; -- onitrerad..av.1
  onitrerbar_1_A = mkA "onitrerbar" ; -- onitrerbar..av.1
  onitrerbarhet_1_N = mkN "onitrerbarhet" ; -- onitrerbarhet..nn.1
  onivellerad_1_A = mkA "onivellerad" ; -- onivellerad..av.1
  onivellerbar_1_A = mkA "onivellerbar" ; -- onivellerbar..av.1
  onivellerbarhet_1_N = mkN "onivellerbarhet" ; -- onivellerbarhet..nn.1
  onjutbar_1_A = mkA "onjutbar" ; -- onjutbar..av.1
  onjutbarhet_1_N = mkN "onjutbarhet" "onjutbarheter" ; -- onjutbarhet..nn.1
  onkel_1_N = mkN "onkel" ; -- onkel..nn.1
  onkolog_1_N = mkN "onkolog" "onkologer" ; -- onkolog..nn.1
  onkologi_1_N = mkN "onkologi" ; -- onkologi..nn.1
  onkologisk_1_A = mkA "onkologisk" ; -- onkologisk..av.1
  onobbad_1_A = mkA "onobbad" ; -- onobbad..av.1
  onobiliserad_1_A = mkA "onobiliserad" ; -- onobiliserad..av.1
  onobiliserbar_1_A = mkA "onobiliserbar" ; -- onobiliserbar..av.1
  onobiliserbarhet_1_N = mkN "onobiliserbarhet" ; -- onobiliserbarhet..nn.1
  onockad_1_A = mkA "onockad" ; -- onockad..av.1
  onollad_1_A = mkA "onollad" ; -- onollad..av.1
  onomastisk_1_A = mkA "onomastisk" ; -- onomastisk..av.1
  onomatologi_1_N = mkN "onomatologi" ; -- onomatologi..nn.1
  onomatopoesi_1_N = mkN "onomatopoesi" ; -- onomatopoesi..nn.1
  onomatopoetisk_1_A = mkA "onomatopoetisk" ; -- onomatopoetisk..av.1
  onominerad_1_A = mkA "onominerad" ; -- onominerad..av.1
  onominerbar_1_A = mkA "onominerbar" ; -- onominerbar..av.1
  onominerbarhet_1_N = mkN "onominerbarhet" ; -- onominerbarhet..nn.1
  ononchalerad_1_A = mkA "ononchalerad" ; -- ononchalerad..av.1
  ononchalerbar_1_A = mkA "ononchalerbar" ; -- ononchalerbar..av.1
  ononchalerbarhet_1_N = mkN "ononchalerbarhet" ; -- ononchalerbarhet..nn.1
  onoppad_1_A = mkA "onoppad" ; -- onoppad..av.1
  onormal_1_A = mkA "onormal" ; -- onormal..av.1
  onormaliserad_1_A = mkA "onormaliserad" ; -- onormaliserad..av.1
  onormaliserbar_1_A = mkA "onormaliserbar" ; -- onormaliserbar..av.1
  onormaliserbarhet_1_N = mkN "onormaliserbarhet" ; -- onormaliserbarhet..nn.1
  onormerad_1_A = mkA "onormerad" ; -- onormerad..av.1
  onormerbar_1_A = mkA "onormerbar" ; -- onormerbar..av.1
  onormerbarhet_1_N = mkN "onormerbarhet" ; -- onormerbarhet..nn.1
  onorpad_1_A = mkA "onorpad" ; -- onorpad..av.1
  onoslig_1_A = mkA "onoslig" ; -- onoslig..av.1
  onoslighet_1_N = mkN "onoslighet" ; -- onoslighet..nn.1
  onotad_1_A = mkA "onotad" ; -- onotad..av.1
  onoterad_1_A = mkA "onoterad" ; -- onoterad..av.1
  onoterbar_1_A = mkA "onoterbar" ; -- onoterbar..av.1
  onoterbarhet_1_N = mkN "onoterbarhet" ; -- onoterbarhet..nn.1
  onotificerad_1_A = mkA "onotificerad" ; -- onotificerad..av.1
  onotificerbar_1_A = mkA "onotificerbar" ; -- onotificerbar..av.1
  onotificerbarhet_1_N = mkN "onotificerbarhet" ; -- onotificerbarhet..nn.1
  onotifierad_1_A = mkA "onotifierad" ; -- onotifierad..av.1
  onotifierbar_1_A = mkA "onotifierbar" ; -- onotifierbar..av.1
  onotifierbarhet_1_N = mkN "onotifierbarhet" ; -- onotifierbarhet..nn.1
  onotiserad_1_A = mkA "onotiserad" ; -- onotiserad..av.1
  onotiserbar_1_A = mkA "onotiserbar" ; -- onotiserbar..av.1
  onotiserbarhet_1_N = mkN "onotiserbarhet" ; -- onotiserbarhet..nn.1
  onsdag_1_N = mkN "onsdag" ; -- onsdag..nn.1
  onsdageftermiddag_1_N = mkN "onsdageftermiddag" ; -- onsdageftermiddag..nn.1
  onsdagkväll_1_N = mkN "onsdagkväll" ; -- onsdagkväll..nn.1
  onsdagmorgon_1_N = mkN "onsdagmorgon" "onsdagmorgonen" "onsdagmornar" "onsdagmornarna" ; -- onsdagmorgon..nn.1
  onsdagseftermiddag_1_N = mkN "onsdagseftermiddag" ; -- onsdagseftermiddag..nn.1
  onsdagskväll_1_N = mkN "onsdagskväll" ; -- onsdagskväll..nn.1
  onsdagsmorgon_1_N = mkN "onsdagsmorgon" "onsdagsmorgonen" "onsdagsmornar" "onsdagsmornarna" ; -- onsdagsmorgon..nn.1
  ont_1_A = mkA "ont" ; -- ont..av.1
  ont_1_N = mkN "ont" neutrum  ; -- ont..nn.1
  ont_2_N = mkN "ont" neutrum  ; -- ont..nn.2
  ontogenetisk_1_A = mkA "ontogenetisk" ; -- ontogenetisk..av.1
  ontogeni_1_N = mkN "ontogeni" ; -- ontogeni..nn.1
  ontologi_1_N = mkN "ontologi" "ontologier" ; -- ontologi..nn.1
  ontologisk_1_A = mkA "ontologisk" ; -- ontologisk..av.1
  onubbad_1_A = mkA "onubbad" ; -- onubbad..av.1
  onuddad_1_A = mkA "onuddad" ; -- onuddad..av.1
  onumrerad_1_A = mkA "onumrerad" ; -- onumrerad..av.1
  onumrerbar_1_A = mkA "onumrerbar" ; -- onumrerbar..av.1
  onumrerbarhet_1_N = mkN "onumrerbarhet" ; -- onumrerbarhet..nn.1
  onus_1_N = mkN "onus" neutrum  ; -- onus..nn.1
  onyanserad_1_A = mkA "onyanserad" ; -- onyanserad..av.1
  onyanserbar_1_A = mkA "onyanserbar" ; -- onyanserbar..av.1
  onyanserbarhet_1_N = mkN "onyanserbarhet" ; -- onyanserbarhet..nn.1
  onykter_1_A = mkA "onykter" ; -- onykter..av.1
  onykterhet_1_N = mkN "onykterhet" "onykterheter" ; -- onykterhet..nn.1
  onynnad_1_A = mkA "onynnad" ; -- onynnad..av.1
  onystad_1_A = mkA "onystad" ; -- onystad..av.1
  onyttig_1_A = mkA "onyttig" ; -- onyttig..av.1
  onyttighet_1_N = mkN "onyttighet" "onyttigheter" ; -- onyttighet..nn.1
  onyttjad_1_A = mkA "onyttjad" ; -- onyttjad..av.1
  onyx_1_N = mkN "onyx" ; -- onyx..nn.1
  onämnbar_1_A = mkA "onämnbar" ; -- onämnbar..av.1
  onämnbarhet_1_N = mkN "onämnbarhet" ; -- onämnbarhet..nn.1
  onämnd_1_A = mkA "onämnd" ; -- onämnd..av.1
  onäpst_1_A = mkA "onäpst" "onäpst" ; -- onäpst..av.1
  onärd_1_A = mkA "onärd" "onärt" ; -- onärd..av.1
  onärmad_1_A = mkA "onärmad" ; -- onärmad..av.1
  onätad_1_A = mkA "onätad" ; -- onätad..av.1
  onåbar_1_A = mkA "onåbar" ; -- onåbar..av.1
  onåbarhet_1_N = mkN "onåbarhet" ; -- onåbarhet..nn.1
  onåd_1_N = mkN "onåd" ; -- onåd..nn.1
  onådad_1_A = mkA "onådad" ; -- onådad..av.1
  onådig_1_A = mkA "onådig" ; -- onådig..av.1
  onådighet_1_N = mkN "onådighet" ; -- onådighet..nn.1
  onålad_1_A = mkA "onålad" ; -- onålad..av.1
  onåtad_1_A = mkA "onåtad" ; -- onåtad..av.1
  onåtlad_1_A = mkA "onåtlad" ; -- onåtlad..av.1
  onödgad_1_A = mkA "onödgad" ; -- onödgad..av.1
  onödig_1_A = mkA "onödig" ; -- onödig..av.1
  onödighet_1_N = mkN "onödighet" "onödigheter" ; -- onödighet..nn.1
  onödigtvis_1_Adv = mkAdv "onödigtvis" ; -- onödigtvis..ab.1
  onöjaktig_1_A = mkA "onöjaktig" ; -- onöjaktig..av.1
  onöjaktighet_1_N = mkN "onöjaktighet" ; -- onöjaktighet..nn.1
  onött_1_A = mkA "onött" ; -- onött..av.1
  oobducerad_1_A = mkA "oobducerad" ; -- oobducerad..av.1
  oobducerbar_1_A = mkA "oobducerbar" ; -- oobducerbar..av.1
  oobducerbarhet_1_N = mkN "oobducerbarhet" ; -- oobducerbarhet..nn.1
  oobjektiverad_1_A = mkA "oobjektiverad" ; -- oobjektiverad..av.1
  oobjektiverbar_1_A = mkA "oobjektiverbar" ; -- oobjektiverbar..av.1
  oobjektiverbarhet_1_N = mkN "oobjektiverbarhet" ; -- oobjektiverbarhet..nn.1
  oobligerad_1_A = mkA "oobligerad" ; -- oobligerad..av.1
  oobligerbar_1_A = mkA "oobligerbar" ; -- oobligerbar..av.1
  oobligerbarhet_1_N = mkN "oobligerbarhet" ; -- oobligerbarhet..nn.1
  oobserverad_1_A = mkA "oobserverad" ; -- oobserverad..av.1
  oobserverbar_1_A = mkA "oobserverbar" ; -- oobserverbar..av.1
  oobserverbarhet_1_N = mkN "oobserverbarhet" ; -- oobserverbarhet..nn.1
  ooccidentaliserad_1_A = mkA "ooccidentaliserad" ; -- ooccidentaliserad..av.1
  ooccidentaliserbar_1_A = mkA "ooccidentaliserbar" ; -- ooccidentaliserbar..av.1
  ooccidentaliserbarhet_1_N = mkN "ooccidentaliserbarhet" ; -- ooccidentaliserbarhet..nn.1
  oockuperad_1_A = mkA "oockuperad" ; -- oockuperad..av.1
  oockuperbar_1_A = mkA "oockuperbar" ; -- oockuperbar..av.1
  oockuperbarhet_1_N = mkN "oockuperbarhet" ; -- oockuperbarhet..nn.1
  oodlad_1_A = mkA "oodlad" ; -- oodlad..av.1
  ooffererad_1_A = mkA "ooffererad" ; -- ooffererad..av.1
  ooffererbar_1_A = mkA "ooffererbar" ; -- ooffererbar..av.1
  ooffererbarhet_1_N = mkN "ooffererbarhet" ; -- ooffererbarhet..nn.1
  ooffrad_1_A = mkA "ooffrad" ; -- ooffrad..av.1
  oogami_1_N = mkN "oogami" ; -- oogami..nn.1
  ookad_1_A = mkA "ookad" ; -- ookad..av.1
  ooktrojerad_1_A = mkA "ooktrojerad" ; -- ooktrojerad..av.1
  ooktrojerbar_1_A = mkA "ooktrojerbar" ; -- ooktrojerbar..av.1
  ooktrojerbarhet_1_N = mkN "ooktrojerbarhet" ; -- ooktrojerbarhet..nn.1
  ookulerad_1_A = mkA "ookulerad" ; -- ookulerad..av.1
  ookulerbar_1_A = mkA "ookulerbar" ; -- ookulerbar..av.1
  ookulerbarhet_1_N = mkN "ookulerbarhet" ; -- ookulerbarhet..nn.1
  oolad_1_A = mkA "oolad" ; -- oolad..av.1
  oolit_1_N = mkN "oolit" ; -- oolit..nn.1
  ooljad_1_A = mkA "ooljad" ; -- ooljad..av.1
  oollad_1_A = mkA "oollad" ; -- oollad..av.1
  oomarbetad_1_A = mkA "oomarbetad" ; -- oomarbetad..av.1
  oombedd_1_A = mkA "oombedd" ; -- oombedd..av.1
  oombeddhet_1_N = mkN "oombeddhet" ; -- oombeddhet..nn.1
  oombestyrd_1_A = mkA "oombestyrd" "oombestyrt" ; -- oombestyrd..av.1
  oombesörjd_1_A = mkA "oombesörjd" "oombesörjt" ; -- oombesörjd..av.1
  oombildad_1_A = mkA "oombildad" ; -- oombildad..av.1
  oomdanad_1_A = mkA "oomdanad" ; -- oomdanad..av.1
  oomdirigerad_1_A = mkA "oomdirigerad" ; -- oomdirigerad..av.1
  oomdirigerbar_1_A = mkA "oomdirigerbar" ; -- oomdirigerbar..av.1
  oomdirigerbarhet_1_N = mkN "oomdirigerbarhet" ; -- oomdirigerbarhet..nn.1
  oomfamnad_1_A = mkA "oomfamnad" ; -- oomfamnad..av.1
  oomfattad_1_A = mkA "oomfattad" ; -- oomfattad..av.1
  oomflyttad_1_A = mkA "oomflyttad" ; -- oomflyttad..av.1
  oomformad_1_A = mkA "oomformad" ; -- oomformad..av.1
  oomformulerbar_1_A = mkA "oomformulerbar" ; -- oomformulerbar..av.1
  oomformulerbarhet_1_N = mkN "oomformulerbarhet" ; -- oomformulerbarhet..nn.1
  oomförd_1_A = mkA "oomförd" "oomfört" ; -- oomförd..av.1
  oomfördelad_1_A = mkA "oomfördelad" ; -- oomfördelad..av.1
  oomförhandlad_1_A = mkA "oomförhandlad" ; -- oomförhandlad..av.1
  oomgestaltad_1_A = mkA "oomgestaltad" ; -- oomgestaltad..av.1
  oomgrupperad_1_A = mkA "oomgrupperad" ; -- oomgrupperad..av.1
  oomgärdad_1_A = mkA "oomgärdad" ; -- oomgärdad..av.1
  oomhuldad_1_A = mkA "oomhuldad" ; -- oomhuldad..av.1
  oomhägnad_1_A = mkA "oomhägnad" ; -- oomhägnad..av.1
  oomhäktad_1_A = mkA "oomhäktad" ; -- oomhäktad..av.1
  oomhöljd_1_A = mkA "oomhöljd" "oomhöljt" ; -- oomhöljd..av.1
  oomkastad_1_A = mkA "oomkastad" ; -- oomkastad..av.1
  oomkransad_1_A = mkA "oomkransad" ; -- oomkransad..av.1
  oomkretsad_1_A = mkA "oomkretsad" ; -- oomkretsad..av.1
  oomkullkastlig_1_A = mkA "oomkullkastlig" ; -- oomkullkastlig..av.1
  oomkullkastlighet_1_N = mkN "oomkullkastlighet" ; -- oomkullkastlighet..nn.1
  oomkullrunkelig_1_A = mkA "oomkullrunkelig" ; -- oomkullrunkelig..av.1
  oomkullrunkelighet_1_N = mkN "oomkullrunkelighet" ; -- oomkullrunkelighet..nn.1
  oomljudd_1_A = mkA "oomljudd" ; -- oomljudd..av.1
  oomlokaliserbar_1_A = mkA "oomlokaliserbar" ; -- oomlokaliserbar..av.1
  oomlokaliserbarhet_1_N = mkN "oomlokaliserbarhet" ; -- oomlokaliserbarhet..nn.1
  oommöblerad_1_A = mkA "oommöblerad" ; -- oommöblerad..av.1
  oommöblerbar_1_A = mkA "oommöblerbar" ; -- oommöblerbar..av.1
  oommöblerbarhet_1_N = mkN "oommöblerbarhet" ; -- oommöblerbarhet..nn.1
  oomnämnd_1_A = mkA "oomnämnd" ; -- oomnämnd..av.1
  oomorganiserad_1_A = mkA "oomorganiserad" ; -- oomorganiserad..av.1
  oomorganiserbar_1_A = mkA "oomorganiserbar" ; -- oomorganiserbar..av.1
  oomorganiserbarhet_1_N = mkN "oomorganiserbarhet" ; -- oomorganiserbarhet..nn.1
  oomplacerad_1_A = mkA "oomplacerad" ; -- oomplacerad..av.1
  oomplacerbar_1_A = mkA "oomplacerbar" ; -- oomplacerbar..av.1
  oomplacerbarhet_1_N = mkN "oomplacerbarhet" ; -- oomplacerbarhet..nn.1
  oomplåstrad_1_A = mkA "oomplåstrad" ; -- oomplåstrad..av.1
  oomprioriterbar_1_A = mkA "oomprioriterbar" ; -- oomprioriterbar..av.1
  oomprioriterbarhet_1_N = mkN "oomprioriterbarhet" ; -- oomprioriterbarhet..nn.1
  oomprövad_1_A = mkA "oomprövad" ; -- oomprövad..av.1
  oomramad_1_A = mkA "oomramad" ; -- oomramad..av.1
  oomringad_1_A = mkA "oomringad" ; -- oomringad..av.1
  oomräknad_1_A = mkA "oomräknad" ; -- oomräknad..av.1
  oomskapad_1_A = mkA "oomskapad" ; -- oomskapad..av.1
  oomskolad_1_A = mkA "oomskolad" ; -- oomskolad..av.1
  oomskulpturerad_1_A = mkA "oomskulpturerad" ; -- oomskulpturerad..av.1
  oomskulpturerbar_1_A = mkA "oomskulpturerbar" ; -- oomskulpturerbar..av.1
  oomskulpturerbarhet_1_N = mkN "oomskulpturerbarhet" ; -- oomskulpturerbarhet..nn.1
  oomskuren_1_A = mkA "oomskuren" ; -- oomskuren..av.1
  oomskött_1_A = mkA "oomskött" ; -- oomskött..av.1
  oomslingrad_1_A = mkA "oomslingrad" ; -- oomslingrad..av.1
  oomspänd_1_A = mkA "oomspänd" ; -- oomspänd..av.1
  oomstridd_1_A = mkA "oomstridd" ; -- oomstridd..av.1
  oomstrukturerad_1_A = mkA "oomstrukturerad" ; -- oomstrukturerad..av.1
  oomstrukturerbar_1_A = mkA "oomstrukturerbar" ; -- oomstrukturerbar..av.1
  oomstrukturerbarhet_1_N = mkN "oomstrukturerbarhet" ; -- oomstrukturerbarhet..nn.1
  oomstrålad_1_A = mkA "oomstrålad" ; -- oomstrålad..av.1
  oomstöpt_1_A = mkA "oomstöpt" "oomstöpt" ; -- oomstöpt..av.1
  oomstörtad_1_A = mkA "oomstörtad" ; -- oomstörtad..av.1
  oomsvept_1_A = mkA "oomsvept" "oomsvept" ; -- oomsvept..av.1
  oomsvärmad_1_A = mkA "oomsvärmad" ; -- oomsvärmad..av.1
  oomtalad_1_A = mkA "oomtalad" ; -- oomtalad..av.1
  oomtolkad_1_A = mkA "oomtolkad" ; -- oomtolkad..av.1
  oomtvistad_1_A = mkA "oomtvistad" ; -- oomtvistad..av.1
  oomtvistlig_1_A = mkA "oomtvistlig" ; -- oomtvistlig..av.1
  oomtvistlighet_1_N = mkN "oomtvistlighet" ; -- oomtvistlighet..nn.1
  oomvandlad_1_A = mkA "oomvandlad" ; -- oomvandlad..av.1
  oomvittnad_1_A = mkA "oomvittnad" ; -- oomvittnad..av.1
  oomvälvd_1_A = mkA "oomvälvd" "oomvälvt" ; -- oomvälvd..av.1
  oomvänd_1_A = mkA "oomvänd" ; -- oomvänd..av.1
  oomvärderad_1_A = mkA "oomvärderad" ; -- oomvärderad..av.1
  oomvärderbar_1_A = mkA "oomvärderbar" ; -- oomvärderbar..av.1
  oomvärderbarhet_1_N = mkN "oomvärderbarhet" ; -- oomvärderbarhet..nn.1
  oomvärvd_1_A = mkA "oomvärvd" "oomvärvt" ; -- oomvärvd..av.1
  oomändrad_1_A = mkA "oomändrad" ; -- oomändrad..av.1
  oondulerad_1_A = mkA "oondulerad" ; -- oondulerad..av.1
  oondulerbar_1_A = mkA "oondulerbar" ; -- oondulerbar..av.1
  oondulerbarhet_1_N = mkN "oondulerbarhet" ; -- oondulerbarhet..nn.1
  ooperationaliserad_1_A = mkA "ooperationaliserad" ; -- ooperationaliserad..av.1
  ooperationaliserbar_1_A = mkA "ooperationaliserbar" ; -- ooperationaliserbar..av.1
  ooperationaliserbarhet_1_N = mkN "ooperationaliserbarhet" ; -- ooperationaliserbarhet..nn.1
  oopererad_1_A = mkA "oopererad" ; -- oopererad..av.1
  oopererbar_1_A = mkA "oopererbar" ; -- oopererbar..av.1
  oopererbarhet_1_N = mkN "oopererbarhet" ; -- oopererbarhet..nn.1
  ooppjusterad_1_A = mkA "ooppjusterad" ; -- ooppjusterad..av.1
  oopponerad_1_A = mkA "oopponerad" ; -- oopponerad..av.1
  oopponerbar_1_A = mkA "oopponerbar" ; -- oopponerbar..av.1
  oopponerbarhet_1_N = mkN "oopponerbarhet" ; -- oopponerbarhet..nn.1
  ooppvärderad_1_A = mkA "ooppvärderad" ; -- ooppvärderad..av.1
  ooptimerad_1_A = mkA "ooptimerad" ; -- ooptimerad..av.1
  ooptimerbar_1_A = mkA "ooptimerbar" ; -- ooptimerbar..av.1
  ooptimerbarhet_1_N = mkN "ooptimerbarhet" ; -- ooptimerbarhet..nn.1
  oordentlig_1_A = mkA "oordentlig" ; -- oordentlig..av.1
  oordentlighet_1_N = mkN "oordentlighet" ; -- oordentlighet..nn.1
  oordinerad_1_A = mkA "oordinerad" ; -- oordinerad..av.1
  oordinerbar_1_A = mkA "oordinerbar" ; -- oordinerbar..av.1
  oordinerbarhet_1_N = mkN "oordinerbarhet" ; -- oordinerbarhet..nn.1
  oordnad_1_A = mkA "oordnad" ; -- oordnad..av.1
  oordning_1_N = mkN "oordning" ; -- oordning..nn.1
  oorganiserad_1_A = mkA "oorganiserad" ; -- oorganiserad..av.1
  oorganiserbar_1_A = mkA "oorganiserbar" ; -- oorganiserbar..av.1
  oorganiserbarhet_1_N = mkN "oorganiserbarhet" ; -- oorganiserbarhet..nn.1
  oorganisk_1_A = mkA "oorganisk" ; -- oorganisk..av.1
  oorganiskhet_1_N = mkN "oorganiskhet" ; -- oorganiskhet..nn.1
  oorienterad_1_A = mkA "oorienterad" ; -- oorienterad..av.1
  oorienterbar_1_A = mkA "oorienterbar" ; -- oorienterbar..av.1
  oorienterbarhet_1_N = mkN "oorienterbarhet" ; -- oorienterbarhet..nn.1
  oorkestrerad_1_A = mkA "oorkestrerad" ; -- oorkestrerad..av.1
  oorkestrerbar_1_A = mkA "oorkestrerbar" ; -- oorkestrerbar..av.1
  oorkestrerbarhet_1_N = mkN "oorkestrerbarhet" ; -- oorkestrerbarhet..nn.1
  oornamenterad_1_A = mkA "oornamenterad" ; -- oornamenterad..av.1
  oornamenterbar_1_A = mkA "oornamenterbar" ; -- oornamenterbar..av.1
  oornamenterbarhet_1_N = mkN "oornamenterbarhet" ; -- oornamenterbarhet..nn.1
  oornerad_1_A = mkA "oornerad" ; -- oornerad..av.1
  oornerbar_1_A = mkA "oornerbar" ; -- oornerbar..av.1
  oornerbarhet_1_N = mkN "oornerbarhet" ; -- oornerbarhet..nn.1
  oorsakad_1_A = mkA "oorsakad" ; -- oorsakad..av.1
  oortodox_1_A = mkA "oortodox" ; -- oortodox..av.1
  oortodoxhet_1_N = mkN "oortodoxhet" ; -- oortodoxhet..nn.1
  ooutad_1_A = mkA "ooutad" ; -- ooutad..av.1
  ooxiderad_1_A = mkA "ooxiderad" ; -- ooxiderad..av.1
  ooxiderbar_1_A = mkA "ooxiderbar" ; -- ooxiderbar..av.1
  ooxiderbarhet_1_N = mkN "ooxiderbarhet" ; -- ooxiderbarhet..nn.1
  opacificerad_1_A = mkA "opacificerad" ; -- opacificerad..av.1
  opacificerbar_1_A = mkA "opacificerbar" ; -- opacificerbar..av.1
  opacificerbarhet_1_N = mkN "opacificerbarhet" ; -- opacificerbarhet..nn.1
  opacitet_1_N = mkN "opacitet" "opaciteter" ; -- opacitet..nn.1
  opackad_1_A = mkA "opackad" ; -- opackad..av.1
  opaginerad_1_A = mkA "opaginerad" ; -- opaginerad..av.1
  opaginerbar_1_A = mkA "opaginerbar" ; -- opaginerbar..av.1
  opaginerbarhet_1_N = mkN "opaginerbarhet" ; -- opaginerbarhet..nn.1
  opajad_1_A = mkA "opajad" ; -- opajad..av.1
  opak_1_A = mkA "opak" ; -- opak..av.1
  opaketerad_1_A = mkA "opaketerad" ; -- opaketerad..av.1
  opaketerbar_1_A = mkA "opaketerbar" ; -- opaketerbar..av.1
  opaketerbarhet_1_N = mkN "opaketerbarhet" ; -- opaketerbarhet..nn.1
  opakteknik_1_N = mkN "opakteknik" ; -- opakteknik..nn.1
  opal_1_N = mkN "opal" "opaler" ; -- opal..nn.1
  opalataliserad_1_A = mkA "opalataliserad" ; -- opalataliserad..av.1
  opalataliserbar_1_A = mkA "opalataliserbar" ; -- opalataliserbar..av.1
  opalataliserbarhet_1_N = mkN "opalataliserbarhet" ; -- opalataliserbarhet..nn.1
  opalescens_1_N = mkN "opalescens" ; -- opalescens..nn.1
  opalfärgad_1_A = mkA "opalfärgad" ; -- opalfärgad..av.1
  opalglas_1_N = mkN "opalglas" neutrum  ; -- opalglas..nn.1
  opaliserande_1_A = mkA "opaliserande" ; -- opaliserande..av.1
  opaljetterad_1_A = mkA "opaljetterad" ; -- opaljetterad..av.1
  opaljetterbar_1_A = mkA "opaljetterbar" ; -- opaljetterbar..av.1
  opaljetterbarhet_1_N = mkN "opaljetterbarhet" ; -- opaljetterbarhet..nn.1
  opallad_1_A = mkA "opallad" ; -- opallad..av.1
  opalmad_1_A = mkA "opalmad" ; -- opalmad..av.1
  opalperad_1_A = mkA "opalperad" ; -- opalperad..av.1
  opalperbar_1_A = mkA "opalperbar" ; -- opalperbar..av.1
  opalperbarhet_1_N = mkN "opalperbarhet" ; -- opalperbarhet..nn.1
  opalskimrande_1_A = mkA "opalskimrande" ; -- opalskimrande..av.1
  opanelad_1_A = mkA "opanelad" ; -- opanelad..av.1
  opanerad_1_A = mkA "opanerad" ; -- opanerad..av.1
  opanerbar_1_A = mkA "opanerbar" ; -- opanerbar..av.1
  opanerbarhet_1_N = mkN "opanerbarhet" ; -- opanerbarhet..nn.1
  opangad_1_A = mkA "opangad" ; -- opangad..av.1
  opanorerad_1_A = mkA "opanorerad" ; -- opanorerad..av.1
  opanorerbar_1_A = mkA "opanorerbar" ; -- opanorerbar..av.1
  opanorerbarhet_1_N = mkN "opanorerbarhet" ; -- opanorerbarhet..nn.1
  opansrad_1_A = mkA "opansrad" ; -- opansrad..av.1
  opantad_1_A = mkA "opantad" ; -- opantad..av.1
  opantograferad_1_A = mkA "opantograferad" ; -- opantograferad..av.1
  opantograferbar_1_A = mkA "opantograferbar" ; -- opantograferbar..av.1
  opantograferbarhet_1_N = mkN "opantograferbarhet" ; -- opantograferbarhet..nn.1
  oparad_1_A = mkA "oparad" ; -- oparad..av.1
  oparaderad_1_A = mkA "oparaderad" ; -- oparaderad..av.1
  oparaderbar_1_A = mkA "oparaderbar" ; -- oparaderbar..av.1
  oparaderbarhet_1_N = mkN "oparaderbarhet" ; -- oparaderbarhet..nn.1
  oparaferad_1_A = mkA "oparaferad" ; -- oparaferad..av.1
  oparaferbar_1_A = mkA "oparaferbar" ; -- oparaferbar..av.1
  oparaferbarhet_1_N = mkN "oparaferbarhet" ; -- oparaferbarhet..nn.1
  oparaffinerad_1_A = mkA "oparaffinerad" ; -- oparaffinerad..av.1
  oparaffinerbar_1_A = mkA "oparaffinerbar" ; -- oparaffinerbar..av.1
  oparaffinerbarhet_1_N = mkN "oparaffinerbarhet" ; -- oparaffinerbarhet..nn.1
  oparafraserad_1_A = mkA "oparafraserad" ; -- oparafraserad..av.1
  oparafraserbar_1_A = mkA "oparafraserbar" ; -- oparafraserbar..av.1
  oparafraserbarhet_1_N = mkN "oparafraserbarhet" ; -- oparafraserbarhet..nn.1
  oparallelliserad_1_A = mkA "oparallelliserad" ; -- oparallelliserad..av.1
  oparallelliserbar_1_A = mkA "oparallelliserbar" ; -- oparallelliserbar..av.1
  oparallelliserbarhet_1_N = mkN "oparallelliserbarhet" ; -- oparallelliserbarhet..nn.1
  oparalyserad_1_A = mkA "oparalyserad" ; -- oparalyserad..av.1
  oparalyserbar_1_A = mkA "oparalyserbar" ; -- oparalyserbar..av.1
  oparalyserbarhet_1_N = mkN "oparalyserbarhet" ; -- oparalyserbarhet..nn.1
  oparerad_1_A = mkA "oparerad" ; -- oparerad..av.1
  oparerbar_1_A = mkA "oparerbar" ; -- oparerbar..av.1
  oparerbarhet_1_N = mkN "oparerbarhet" ; -- oparerbarhet..nn.1
  oparfymerad_1_A = mkA "oparfymerad" ; -- oparfymerad..av.1
  oparfymerbar_1_A = mkA "oparfymerbar" ; -- oparfymerbar..av.1
  oparfymerbarhet_1_N = mkN "oparfymerbarhet" ; -- oparfymerbarhet..nn.1
  oparig_1_A = mkA "oparig" ; -- oparig..av.1
  oparkerad_1_A = mkA "oparkerad" ; -- oparkerad..av.1
  oparkerbar_1_A = mkA "oparkerbar" ; -- oparkerbar..av.1
  oparkerbarhet_1_N = mkN "oparkerbarhet" ; -- oparkerbarhet..nn.1
  oparketterad_1_A = mkA "oparketterad" ; -- oparketterad..av.1
  oparketterbar_1_A = mkA "oparketterbar" ; -- oparketterbar..av.1
  oparketterbarhet_1_N = mkN "oparketterbarhet" ; -- oparketterbarhet..nn.1
  oparlamentarisk_1_A = mkA "oparlamentarisk" ; -- oparlamentarisk..av.1
  oparodierad_1_A = mkA "oparodierad" ; -- oparodierad..av.1
  oparodierbar_1_A = mkA "oparodierbar" ; -- oparodierbar..av.1
  oparodierbarhet_1_N = mkN "oparodierbarhet" ; -- oparodierbarhet..nn.1
  opartisk_1_A = mkA "opartisk" ; -- opartisk..av.1
  opartiskhet_1_N = mkN "opartiskhet" ; -- opartiskhet..nn.1
  opassad_1_A = mkA "opassad" ; -- opassad..av.1
  opassande_1_A = mkA "opassande" ; -- opassande..av.1
  opasserad_1_A = mkA "opasserad" ; -- opasserad..av.1
  opasserbar_1_A = mkA "opasserbar" ; -- opasserbar..av.1
  opasserbarhet_1_N = mkN "opasserbarhet" ; -- opasserbarhet..nn.1
  opassiverad_1_A = mkA "opassiverad" ; -- opassiverad..av.1
  opassiverbar_1_A = mkA "opassiverbar" ; -- opassiverbar..av.1
  opassiverbarhet_1_N = mkN "opassiverbarhet" ; -- opassiverbarhet..nn.1
  opassiviserad_1_A = mkA "opassiviserad" ; -- opassiviserad..av.1
  opassiviserbar_1_A = mkA "opassiviserbar" ; -- opassiviserbar..av.1
  opassiviserbarhet_1_N = mkN "opassiviserbarhet" ; -- opassiviserbarhet..nn.1
  opasslig_1_A = mkA "opasslig" ; -- opasslig..av.1
  opasslighet_1_N = mkN "opasslighet" ; -- opasslighet..nn.1
  opastöriserad_1_A = mkA "opastöriserad" ; -- opastöriserad..av.1
  opastöriserbar_1_A = mkA "opastöriserbar" ; -- opastöriserbar..av.1
  opastöriserbarhet_1_N = mkN "opastöriserbarhet" ; -- opastöriserbarhet..nn.1
  opatenterad_1_A = mkA "opatenterad" ; -- opatenterad..av.1
  opatenterbar_1_A = mkA "opatenterbar" ; -- opatenterbar..av.1
  opatenterbarhet_1_N = mkN "opatenterbarhet" ; -- opatenterbarhet..nn.1
  opatinerad_1_A = mkA "opatinerad" ; -- opatinerad..av.1
  opatinerbar_1_A = mkA "opatinerbar" ; -- opatinerbar..av.1
  opatinerbarhet_1_N = mkN "opatinerbarhet" ; -- opatinerbarhet..nn.1
  opatriotisk_1_A = mkA "opatriotisk" ; -- opatriotisk..av.1
  opatrullerad_1_A = mkA "opatrullerad" ; -- opatrullerad..av.1
  opatrullerbar_1_A = mkA "opatrullerbar" ; -- opatrullerbar..av.1
  opatrullerbarhet_1_N = mkN "opatrullerbarhet" ; -- opatrullerbarhet..nn.1
  opauperiserad_1_A = mkA "opauperiserad" ; -- opauperiserad..av.1
  opauperiserbar_1_A = mkA "opauperiserbar" ; -- opauperiserbar..av.1
  opauperiserbarhet_1_N = mkN "opauperiserbarhet" ; -- opauperiserbarhet..nn.1
  opausad_1_A = mkA "opausad" ; -- opausad..av.1
  opauserad_1_A = mkA "opauserad" ; -- opauserad..av.1
  opauserbar_1_A = mkA "opauserbar" ; -- opauserbar..av.1
  opauserbarhet_1_N = mkN "opauserbarhet" ; -- opauserbarhet..nn.1
  opaxad_1_A = mkA "opaxad" ; -- opaxad..av.1
  opedagogisk_1_A = mkA "opedagogisk" ; -- opedagogisk..av.1
  opejlad_1_A = mkA "opejlad" ; -- opejlad..av.1
  opelleterad_1_A = mkA "opelleterad" ; -- opelleterad..av.1
  opelleterbar_1_A = mkA "opelleterbar" ; -- opelleterbar..av.1
  opelleterbarhet_1_N = mkN "opelleterbarhet" ; -- opelleterbarhet..nn.1
  open_1_A = mkA "open" ; -- open..av.1
  openetrerad_1_A = mkA "openetrerad" ; -- openetrerad..av.1
  openetrerbar_1_A = mkA "openetrerbar" ; -- openetrerbar..av.1
  openetrerbarhet_1_N = mkN "openetrerbarhet" ; -- openetrerbarhet..nn.1
  opensionerad_1_A = mkA "opensionerad" ; -- opensionerad..av.1
  opensionerbar_1_A = mkA "opensionerbar" ; -- opensionerbar..av.1
  opensionerbarhet_1_N = mkN "opensionerbarhet" ; -- opensionerbarhet..nn.1
  openslad_1_A = mkA "openslad" ; -- openslad..av.1
  opeppad_1_A = mkA "opeppad" ; -- opeppad..av.1
  opepprad_1_A = mkA "opepprad" ; -- opepprad..av.1
  opera_1_N = mkN "opera" ; -- opera..nn.1
  operabalett_1_N = mkN "operabalett" "operabaletter" ; -- operabalett..nn.1
  operabel_1_A = mkA "operabel" ; -- operabel..av.1
  operabiljett_1_N = mkN "operabiljett" "operabiljetter" ; -- operabiljett..nn.1
  operadike_1_N = mkN "operadike" ; -- operadike..nn.1
  operahus_1_N = mkN "operahus" neutrum  ; -- operahus..nn.1
  operakompositör_1_N = mkN "operakompositör" "operakompositörer" ; -- operakompositör..nn.1
  operamässig_1_A = mkA "operamässig" ; -- operamässig..av.1
  operapublik_1_N = mkN "operapublik" ; -- operapublik..nn.1
  operasångare_1_N = mkN "operasångare" utrum  ; -- operasångare..nn.1
  operasångerska_1_N = mkN "operasångerska" ; -- operasångerska..nn.1
  operation_1_N = mkN "operation" ; -- operation..nn.1
  operationalisera_1_V = mkV "operationaliserar" ; -- operationalisera..vb.1
  operationaliserande_1_N = mkN "operationaliserande" ; -- operationaliserande..nn.1
  operationaliserbar_1_A = mkA "operationaliserbar" ; -- operationaliserbar..av.1
  operationaliserbarhet_1_N = mkN "operationaliserbarhet" ; -- operationaliserbarhet..nn.1
  operationalisering_1_N = mkN "operationalisering" ; -- operationalisering..nn.1
  operationalism_1_N = mkN "operationalism" "operationalismer" ; -- operationalism..nn.1
  operationalistisk_1_A = mkA "operationalistisk" ; -- operationalistisk..av.1
  operationell_1_A = mkA "operationell" ; -- operationell..av.1
  operationsanalys_1_N = mkN "operationsanalys" ; -- operationsanalys..nn.1
  operationsbas_1_N = mkN "operationsbas" "operationsbaser" ; -- operationsbas..nn.1
  operationsbestick_1_N = mkN "operationsbestick" neutrum  ; -- operationsbestick..nn.1
  operationslinje_1_N = mkN "operationslinje" "operationslinjer" ; -- operationslinje..nn.1
  operationsläkare_1_N = mkN "operationsläkare" utrum  ; -- operationsläkare..nn.1
  operationsring_1_N = mkN "operationsring" ; -- operationsring..nn.1
  operationssal_1_N = mkN "operationssal" ; -- operationssal..nn.1
  operativ_1_A = mkA "operativ" ; -- operativ..av.1
  operativsystem_1_N = mkN "operativsystem" neutrum  ; -- operativsystem..nn.1
  operator_1_N = mkN "operator" "operatorer" ; -- operator..nn.1
  operatris_1_N = mkN "operatris" "operatriser" ; -- operatris..nn.1
  operatör_1_N = mkN "operatör" "operatörer" ; -- operatör..nn.1
  opercipierad_1_A = mkA "opercipierad" ; -- opercipierad..av.1
  opercipierbar_1_A = mkA "opercipierbar" ; -- opercipierbar..av.1
  opercipierbarhet_1_N = mkN "opercipierbarhet" ; -- opercipierbarhet..nn.1
  operera_1_V = mkV "opererar" ; -- operera..vb.1
  opererande_1_N = mkN "opererande" ; -- opererande..nn.1
  opererbar_1_A = mkA "opererbar" ; -- opererbar..av.1
  opererbarhet_1_N = mkN "opererbarhet" ; -- opererbarhet..nn.1
  operering_1_N = mkN "operering" ; -- operering..nn.1
  operett_1_N = mkN "operett" "operetter" ; -- operett..nn.1
  operetteater_1_N = mkN "operetteater" ; -- operetteater..nn.1
  operettland_1_N = mkN "operettland" "operettlandet" "operettländer" "operettländerna" ; -- operettland..nn.1
  operforerad_1_A = mkA "operforerad" ; -- operforerad..av.1
  operforerbar_1_A = mkA "operforerbar" ; -- operforerbar..av.1
  operforerbarhet_1_N = mkN "operforerbarhet" ; -- operforerbarhet..nn.1
  operiodiserad_1_A = mkA "operiodiserad" ; -- operiodiserad..av.1
  operiodiserbar_1_A = mkA "operiodiserbar" ; -- operiodiserbar..av.1
  operiodiserbarhet_1_N = mkN "operiodiserbarhet" ; -- operiodiserbarhet..nn.1
  opermanentad_1_A = mkA "opermanentad" ; -- opermanentad..av.1
  opermitterad_1_A = mkA "opermitterad" ; -- opermitterad..av.1
  opermitterbar_1_A = mkA "opermitterbar" ; -- opermitterbar..av.1
  opermitterbarhet_1_N = mkN "opermitterbarhet" ; -- opermitterbarhet..nn.1
  opermuterad_1_A = mkA "opermuterad" ; -- opermuterad..av.1
  opermuterbar_1_A = mkA "opermuterbar" ; -- opermuterbar..av.1
  opermuterbarhet_1_N = mkN "opermuterbarhet" ; -- opermuterbarhet..nn.1
  opersiflerad_1_A = mkA "opersiflerad" ; -- opersiflerad..av.1
  opersiflerbar_1_A = mkA "opersiflerbar" ; -- opersiflerbar..av.1
  opersiflerbarhet_1_N = mkN "opersiflerbarhet" ; -- opersiflerbarhet..nn.1
  opersonifierad_1_A = mkA "opersonifierad" ; -- opersonifierad..av.1
  opersonifierbar_1_A = mkA "opersonifierbar" ; -- opersonifierbar..av.1
  opersonifierbarhet_1_N = mkN "opersonifierbarhet" ; -- opersonifierbarhet..nn.1
  opersonlig_1_A = mkA "opersonlig" ; -- opersonlig..av.1
  opersonlighet_1_N = mkN "opersonlighet" ; -- opersonlighet..nn.1
  opersvaderad_1_A = mkA "opersvaderad" ; -- opersvaderad..av.1
  opersvaderbar_1_A = mkA "opersvaderbar" ; -- opersvaderbar..av.1
  opersvaderbarhet_1_N = mkN "opersvaderbarhet" ; -- opersvaderbarhet..nn.1
  operverterad_1_A = mkA "operverterad" ; -- operverterad..av.1
  operverterbar_1_A = mkA "operverterbar" ; -- operverterbar..av.1
  operverterbarhet_1_N = mkN "operverterbarhet" ; -- operverterbarhet..nn.1
  opetad_1_A = mkA "opetad" ; -- opetad..av.1
  opetrifierad_1_A = mkA "opetrifierad" ; -- opetrifierad..av.1
  opetrifierbar_1_A = mkA "opetrifierbar" ; -- opetrifierbar..av.1
  opetrifierbarhet_1_N = mkN "opetrifierbarhet" ; -- opetrifierbarhet..nn.1
  opiat_1_N = mkN "opiat" neutrum  ; -- opiat..nn.1
  opickad_1_A = mkA "opickad" ; -- opickad..av.1
  opikad_1_A = mkA "opikad" ; -- opikad..av.1
  opikerad_1_A = mkA "opikerad" ; -- opikerad..av.1
  opikerbar_1_A = mkA "opikerbar" ; -- opikerbar..av.1
  opikerbarhet_1_N = mkN "opikerbarhet" ; -- opikerbarhet..nn.1
  opilkad_1_A = mkA "opilkad" ; -- opilkad..av.1
  opimpad_1_A = mkA "opimpad" ; -- opimpad..av.1
  opimplad_1_A = mkA "opimplad" ; -- opimplad..av.1
  opinad_1_A = mkA "opinad" ; -- opinad..av.1
  opincerad_1_A = mkA "opincerad" ; -- opincerad..av.1
  opincerbar_1_A = mkA "opincerbar" ; -- opincerbar..av.1
  opincerbarhet_1_N = mkN "opincerbarhet" ; -- opincerbarhet..nn.1
  opinera_1_V = mkV "opinerar" ; -- opinera..vb.1
  opinerande_1_N = mkN "opinerande" ; -- opinerande..nn.1
  opinering_1_N = mkN "opinering" ; -- opinering..nn.1
  opinion_1_N = mkN "opinion" ; -- opinion..nn.1
  opinionsanalys_1_N = mkN "opinionsanalys" "opinionsanalyser" ; -- opinionsanalys..nn.1
  opinionsanalytiker_1_N = mkN "opinionsanalytiker" "opinionsanalytikern" "opinionsanalytiker" "opinionsanalytikerna" ; -- opinionsanalytiker..nn.1
  opinionsbildande_1_A = mkA "opinionsbildande" ; -- opinionsbildande..av.1
  opinionsbildare_1_N = mkN "opinionsbildare" utrum  ; -- opinionsbildare..nn.1
  opinionsbildning_1_N = mkN "opinionsbildning" ; -- opinionsbildning..nn.1
  opinionsjournalistik_1_N = mkN "opinionsjournalistik" ; -- opinionsjournalistik..nn.1
  opinionsmässig_1_A = mkA "opinionsmässig" ; -- opinionsmässig..av.1
  opinionsmätning_1_N = mkN "opinionsmätning" ; -- opinionsmätning..nn.1
  opinionsnämnd_1_N = mkN "opinionsnämnd" "opinionsnämnder" ; -- opinionsnämnd..nn.1
  opinionsorgan_1_N = mkN "opinionsorgan" neutrum  ; -- opinionsorgan..nn.1
  opinionssiffra_1_N = mkN "opinionssiffra" ; -- opinionssiffra..nn.1
  opinionssvängning_1_N = mkN "opinionssvängning" ; -- opinionssvängning..nn.1
  opinionsundersökning_1_N = mkN "opinionsundersökning" ; -- opinionsundersökning..nn.1
  opinionsvind_1_N = mkN "opinionsvind" ; -- opinionsvind..nn.1
  opinionsyttring_1_N = mkN "opinionsyttring" ; -- opinionsyttring..nn.1
  opinnad_1_A = mkA "opinnad" ; -- opinnad..av.1
  opippad_1_A = mkA "opippad" ; -- opippad..av.1
  opirkad_1_A = mkA "opirkad" ; -- opirkad..av.1
  opiskad_1_A = mkA "opiskad" ; -- opiskad..av.1
  opium_1_N = mkN "opium" neutrum  ; -- opium..nn.1
  opiumhandel_1_N = mkN "opiumhandel" ; -- opiumhandel..nn.1
  opiumhärva_1_N = mkN "opiumhärva" ; -- opiumhärva..nn.1
  opiumhåla_1_N = mkN "opiumhåla" ; -- opiumhåla..nn.1
  opiumliknande_1_A = mkA "opiumliknande" ; -- opiumliknande..av.1
  opiumpipa_1_N = mkN "opiumpipa" ; -- opiumpipa..nn.1
  opiumrökning_1_N = mkN "opiumrökning" ; -- opiumrökning..nn.1
  opkonst_1_N = mkN "opkonst" ; -- opkonst..nn.1
  oplacerad_1_A = mkA "oplacerad" ; -- oplacerad..av.1
  oplacerbar_1_A = mkA "oplacerbar" ; -- oplacerbar..av.1
  oplacerbarhet_1_N = mkN "oplacerbarhet" ; -- oplacerbarhet..nn.1
  oplagierad_1_A = mkA "oplagierad" ; -- oplagierad..av.1
  oplagierbar_1_A = mkA "oplagierbar" ; -- oplagierbar..av.1
  oplagierbarhet_1_N = mkN "oplagierbarhet" ; -- oplagierbarhet..nn.1
  oplanad_1_A = mkA "oplanad" ; -- oplanad..av.1
  oplanerad_1_A = mkA "oplanerad" ; -- oplanerad..av.1
  oplanerbar_1_A = mkA "oplanerbar" ; -- oplanerbar..av.1
  oplanerbarhet_1_N = mkN "oplanerbarhet" ; -- oplanerbarhet..nn.1
  oplankad_1_A = mkA "oplankad" ; -- oplankad..av.1
  oplantad_1_A = mkA "oplantad" ; -- oplantad..av.1
  oplanterad_1_A = mkA "oplanterad" ; -- oplanterad..av.1
  oplanterbar_1_A = mkA "oplanterbar" ; -- oplanterbar..av.1
  oplanterbarhet_1_N = mkN "oplanterbarhet" ; -- oplanterbarhet..nn.1
  oplastad_1_A = mkA "oplastad" ; -- oplastad..av.1
  oplatinerad_1_A = mkA "oplatinerad" ; -- oplatinerad..av.1
  oplatinerbar_1_A = mkA "oplatinerbar" ; -- oplatinerbar..av.1
  oplatinerbarhet_1_N = mkN "oplatinerbarhet" ; -- oplatinerbarhet..nn.1
  opliggad_1_A = mkA "opliggad" ; -- opliggad..av.1
  oplisserad_1_A = mkA "oplisserad" ; -- oplisserad..av.1
  oplisserbar_1_A = mkA "oplisserbar" ; -- oplisserbar..av.1
  oplisserbarhet_1_N = mkN "oplisserbarhet" ; -- oplisserbarhet..nn.1
  oplockad_1_A = mkA "oplockad" ; -- oplockad..av.1
  oplogad_1_A = mkA "oplogad" ; -- oplogad..av.1
  oplomberad_1_A = mkA "oplomberad" ; -- oplomberad..av.1
  oplomberbar_1_A = mkA "oplomberbar" ; -- oplomberbar..av.1
  oplomberbarhet_1_N = mkN "oplomberbarhet" ; -- oplomberbarhet..nn.1
  oplottad_1_A = mkA "oplottad" ; -- oplottad..av.1
  opluggad_1_A = mkA "opluggad" ; -- opluggad..av.1
  oplundrad_1_A = mkA "oplundrad" ; -- oplundrad..av.1
  oplysad_1_A = mkA "oplysad" ; -- oplysad..av.1
  opläterad_1_A = mkA "opläterad" ; -- opläterad..av.1
  opläterbar_1_A = mkA "opläterbar" ; -- opläterbar..av.1
  opläterbarhet_1_N = mkN "opläterbarhet" ; -- opläterbarhet..nn.1
  oplåstrad_1_A = mkA "oplåstrad" ; -- oplåstrad..av.1
  oplåtad_1_A = mkA "oplåtad" ; -- oplåtad..av.1
  oplöjd_1_A = mkA "oplöjd" "oplöjt" ; -- oplöjd..av.1
  opocherad_1_A = mkA "opocherad" ; -- opocherad..av.1
  opocherbar_1_A = mkA "opocherbar" ; -- opocherbar..av.1
  opocherbarhet_1_N = mkN "opocherbarhet" ; -- opocherbarhet..nn.1
  opoetisk_1_A = mkA "opoetisk" ; -- opoetisk..av.1
  opointerad_1_A = mkA "opointerad" ; -- opointerad..av.1
  opointerbar_1_A = mkA "opointerbar" ; -- opointerbar..av.1
  opointerbarhet_1_N = mkN "opointerbarhet" ; -- opointerbarhet..nn.1
  opolariserad_1_A = mkA "opolariserad" ; -- opolariserad..av.1
  opolariserbar_1_A = mkA "opolariserbar" ; -- opolariserbar..av.1
  opolariserbarhet_1_N = mkN "opolariserbarhet" ; -- opolariserbarhet..nn.1
  opolerad_1_A = mkA "opolerad" ; -- opolerad..av.1
  opolerbar_1_A = mkA "opolerbar" ; -- opolerbar..av.1
  opolerbarhet_1_N = mkN "opolerbarhet" ; -- opolerbarhet..nn.1
  opolitiserad_1_A = mkA "opolitiserad" ; -- opolitiserad..av.1
  opolitiserbar_1_A = mkA "opolitiserbar" ; -- opolitiserbar..av.1
  opolitiserbarhet_1_N = mkN "opolitiserbarhet" ; -- opolitiserbarhet..nn.1
  opolitisk_1_A = mkA "opolitisk" ; -- opolitisk..av.1
  opolletterad_1_A = mkA "opolletterad" ; -- opolletterad..av.1
  opolletterbar_1_A = mkA "opolletterbar" ; -- opolletterbar..av.1
  opolletterbarhet_1_N = mkN "opolletterbarhet" ; -- opolletterbarhet..nn.1
  opollinerad_1_A = mkA "opollinerad" ; -- opollinerad..av.1
  opollinerbar_1_A = mkA "opollinerbar" ; -- opollinerbar..av.1
  opollinerbarhet_1_N = mkN "opollinerbarhet" ; -- opollinerbarhet..nn.1
  opolstrad_1_A = mkA "opolstrad" ; -- opolstrad..av.1
  opomaderad_1_A = mkA "opomaderad" ; -- opomaderad..av.1
  opomaderbar_1_A = mkA "opomaderbar" ; -- opomaderbar..av.1
  opomaderbarhet_1_N = mkN "opomaderbarhet" ; -- opomaderbarhet..nn.1
  opoppad_1_A = mkA "opoppad" ; -- opoppad..av.1
  opopulariserad_1_A = mkA "opopulariserad" ; -- opopulariserad..av.1
  opopulariserbar_1_A = mkA "opopulariserbar" ; -- opopulariserbar..av.1
  opopulariserbarhet_1_N = mkN "opopulariserbarhet" ; -- opopulariserbarhet..nn.1
  oportad_1_A = mkA "oportad" ; -- oportad..av.1
  oportionerad_1_A = mkA "oportionerad" ; -- oportionerad..av.1
  oportionerbar_1_A = mkA "oportionerbar" ; -- oportionerbar..av.1
  oportionerbarhet_1_N = mkN "oportionerbarhet" ; -- oportionerbarhet..nn.1
  oporträtterad_1_A = mkA "oporträtterad" ; -- oporträtterad..av.1
  oporträtterbar_1_A = mkA "oporträtterbar" ; -- oporträtterbar..av.1
  oporträtterbarhet_1_N = mkN "oporträtterbarhet" ; -- oporträtterbarhet..nn.1
  opositionerbar_1_A = mkA "opositionerbar" ; -- opositionerbar..av.1
  opositionerbarhet_1_N = mkN "opositionerbarhet" ; -- opositionerbarhet..nn.1
  opossum_1_N = mkN "opossum" ; -- opossum..nn.1
  opostad_1_A = mkA "opostad" ; -- opostad..av.1
  opostdaterad_1_A = mkA "opostdaterad" ; -- opostdaterad..av.1
  opostdaterbar_1_A = mkA "opostdaterbar" ; -- opostdaterbar..av.1
  opostdaterbarhet_1_N = mkN "opostdaterbarhet" ; -- opostdaterbarhet..nn.1
  oposterad_1_A = mkA "oposterad" ; -- oposterad..av.1
  oposterbar_1_A = mkA "oposterbar" ; -- oposterbar..av.1
  oposterbarhet_1_N = mkN "oposterbarhet" ; -- oposterbarhet..nn.1
  opostponerad_1_A = mkA "opostponerad" ; -- opostponerad..av.1
  opostponerbar_1_A = mkA "opostponerbar" ; -- opostponerbar..av.1
  opostponerbarhet_1_N = mkN "opostponerbarhet" ; -- opostponerbarhet..nn.1
  opostulerad_1_A = mkA "opostulerad" ; -- opostulerad..av.1
  opostulerbar_1_A = mkA "opostulerbar" ; -- opostulerbar..av.1
  opostulerbarhet_1_N = mkN "opostulerbarhet" ; -- opostulerbarhet..nn.1
  opotentierbar_1_A = mkA "opotentierbar" ; -- opotentierbar..av.1
  opotentierbarhet_1_N = mkN "opotentierbarhet" ; -- opotentierbarhet..nn.1
  opoängterad_1_A = mkA "opoängterad" ; -- opoängterad..av.1
  opoängterbar_1_A = mkA "opoängterbar" ; -- opoängterbar..av.1
  opoängterbarhet_1_N = mkN "opoängterbarhet" ; -- opoängterbarhet..nn.1
  oppamma_1_V = mkV "oppammar" ; -- oppamma..vb.1
  oppammande_1_N = mkN "oppammande" ; -- oppammande..nn.1
  opparbeta_1_V = mkV "opparbetar" ; -- opparbeta..vb.1
  opparbetande_1_N = mkN "opparbetande" ; -- opparbetande..nn.1
  opparbetning_1_N = mkN "opparbetning" ; -- opparbetning..nn.1
  oppassa_1_V = mkV "oppassar" ; -- oppassa..vb.1
  oppassande_1_N = mkN "oppassande" ; -- oppassande..nn.1
  oppassare_1_N = mkN "oppassare" utrum  ; -- oppassare..nn.1
  oppassning_1_N = mkN "oppassning" ; -- oppassning..nn.1
  oppassningsställe_1_N = mkN "oppassningsställe" ; -- oppassningsställe..nn.1
  oppbackare_1_N = mkN "oppbackare" utrum  ; -- oppbackare..nn.1
  oppbackning_1_N = mkN "oppbackning" ; -- oppbackning..nn.1
  oppbindning_1_N = mkN "oppbindning" ; -- oppbindning..nn.1
  oppblanda_1_V = mkV "oppblandar" ; -- oppblanda..vb.1
  oppblandad_1_A = mkA "oppblandad" ; -- oppblandad..av.1
  oppblandande_1_N = mkN "oppblandande" ; -- oppblandande..nn.1
  oppblåsning_1_N = mkN "oppblåsning" ; -- oppblåsning..nn.1
  oppblåsningsfas_1_N = mkN "oppblåsningsfas" "oppblåsningsfaser" ; -- oppblåsningsfas..nn.1
  oppbringa_1_V = mkV "oppbringar" ; -- oppbringa..vb.1
  oppbringande_1_N = mkN "oppbringande" ; -- oppbringande..nn.1
  oppbunden_1_A = mkA "oppbunden" ; -- oppbunden..av.1
  oppbyggnad_1_N = mkN "oppbyggnad" "oppbyggnader" ; -- oppbyggnad..nn.1
  oppbära_1_V = mkV "oppbära" "oppbar" "oppburit" ; -- oppbära..vb.1
  oppbärande_1_N = mkN "oppbärande" ; -- oppbärande..nn.1
  oppdaga_1_V = mkV "oppdagar" ; -- oppdaga..vb.1
  oppdagande_1_N = mkN "oppdagande" ; -- oppdagande..nn.1
  oppdatera_1_V = mkV "oppdaterar" ; -- oppdatera..vb.1
  oppdaterande_1_N = mkN "oppdaterande" ; -- oppdaterande..nn.1
  oppdatering_1_N = mkN "oppdatering" ; -- oppdatering..nn.1
  oppdela_1_V = mkV "oppdelar" ; -- oppdela..vb.1
  oppdelande_1_N = mkN "oppdelande" ; -- oppdelande..nn.1
  oppdelning_1_N = mkN "oppdelning" ; -- oppdelning..nn.1
  oppdiktad_1_A = mkA "oppdiktad" ; -- oppdiktad..av.1
  oppdriva_1_V = mkV "oppdriva" "oppdrev" "oppdrivit" ; -- oppdriva..vb.1
  oppdrivande_1_N = mkN "oppdrivande" ; -- oppdrivande..nn.1
  oppdukning_1_N = mkN "oppdukning" ; -- oppdukning..nn.1
  oppegga_1_V = mkV "oppeggar" ; -- oppegga..vb.1
  oppeggande_1_N = mkN "oppeggande" ; -- oppeggande..nn.1
  oppeldad_1_A = mkA "oppeldad" ; -- oppeldad..av.1
  oppemot_1_Adv = mkAdv "oppemot" ; -- oppemot..ab.1
  oppfart_1_N = mkN "oppfart" "oppfarter" ; -- oppfart..nn.1
  oppfatta_1_V = mkV "oppfattar" ; -- oppfatta..vb.1
  oppfinna_1_V = mkV "oppfinna" "oppfann" "oppfunnit" ; -- oppfinna..vb.1
  oppfinning_1_N = mkN "oppfinning" ; -- oppfinning..nn.1
  oppfinningsförmåga_1_N = mkN "oppfinningsförmåga" ; -- oppfinningsförmåga..nn.1
  oppfinningsrik_1_A = mkA "oppfinningsrik" ; -- oppfinningsrik..av.1
  oppfinningsrikhet_1_N = mkN "oppfinningsrikhet" ; -- oppfinningsrikhet..nn.1
  oppflammande_1_A = mkA "oppflammande" ; -- oppflammande..av.1
  oppflog_1_N = mkN "oppflog" neutrum  ; -- oppflog..nn.1
  oppflugen_1_A = mkA "oppflugen" ; -- oppflugen..av.1
  oppflåg_1_N = mkN "oppflåg" neutrum  ; -- oppflåg..nn.1
  oppfostra_1_V = mkV "oppfostrar" ; -- oppfostra..vb.1
  oppfostrande_1_N = mkN "oppfostrande" ; -- oppfostrande..nn.1
  oppfostrare_1_N = mkN "oppfostrare" utrum  ; -- oppfostrare..nn.1
  oppfostring_1_N = mkN "oppfostring" ; -- oppfostring..nn.1
  oppfriska_1_V = mkV "oppfriskar" ; -- oppfriska..vb.1
  oppfriskande_1_A = mkA "oppfriskande" ; -- oppfriskande..av.1
  oppfriskande_1_N = mkN "oppfriskande" ; -- oppfriskande..nn.1
  oppfylla_1_V = mkV "oppfyller" ; -- oppfylla..vb.1
  oppfyllande_1_N = mkN "oppfyllande" ; -- oppfyllande..nn.1
  oppfyllelse_1_N = mkN "oppfyllelse" utrum  ; -- oppfyllelse..nn.1
  oppfällbar_1_A = mkA "oppfällbar" ; -- oppfällbar..av.1
  oppfällbarhet_1_N = mkN "oppfällbarhet" ; -- oppfällbarhet..nn.1
  oppfälld_1_A = mkA "oppfälld" "oppfällt" ; -- oppfälld..av.1
  oppfånga_1_V = mkV "oppfångar" ; -- oppfånga..vb.1
  oppfångande_1_N = mkN "oppfångande" ; -- oppfångande..nn.1
  oppföda_1_V = mkV "oppföda" "oppfödde" "oppfött" ; -- oppföda..vb.1
  oppfödande_1_N = mkN "oppfödande" ; -- oppfödande..nn.1
  oppfödare_1_N = mkN "oppfödare" utrum  ; -- oppfödare..nn.1
  oppfödning_1_N = mkN "oppfödning" ; -- oppfödning..nn.1
  oppföljning_1_N = mkN "oppföljning" ; -- oppföljning..nn.1
  oppge_1_V = mkV "oppgiva" "oppgav" "oppgivit" ; -- oppge..vb.1
  oppgjord_1_A = mkA "oppgjord" "oppgjort" ; -- oppgjord..av.1
  oppgång_1_N = mkN "oppgång" ; -- oppgång..nn.1
  oppgörelse_1_N = mkN "oppgörelse" "oppgörelser" ; -- oppgörelse..nn.1
  opphetsa_1_V = mkV "opphetsar" ; -- opphetsa..vb.1
  opphetsad_1_A = mkA "opphetsad" ; -- opphetsad..av.1
  opphetsande_1_N = mkN "opphetsande" ; -- opphetsande..nn.1
  opphetsning_1_N = mkN "opphetsning" ; -- opphetsning..nn.1
  opphetta_1_V = mkV "opphettar" ; -- opphetta..vb.1
  opphettande_1_N = mkN "opphettande" ; -- opphettande..nn.1
  opphettning_1_N = mkN "opphettning" ; -- opphettning..nn.1
  opphinnelig_1_A = mkA "opphinnelig" ; -- opphinnelig..av.1
  opphinnelighet_1_N = mkN "opphinnelighet" ; -- opphinnelighet..nn.1
  opphitta_1_V = mkV "opphittar" ; -- opphitta..vb.1
  opphittande_1_N = mkN "opphittande" ; -- opphittande..nn.1
  opphostning_1_N = mkN "opphostning" ; -- opphostning..nn.1
  opphottande_1_N = mkN "opphottande" ; -- opphottande..nn.1
  opphottning_1_N = mkN "opphottning" ; -- opphottning..nn.1
  opphämta_1_N = mkN "opphämta" ; -- opphämta..nn.1
  opphämta_1_V = mkV "opphämtar" ; -- opphämta..vb.1
  opphämtande_1_N = mkN "opphämtande" ; -- opphämtande..nn.1
  opphämtning_1_N = mkN "opphämtning" ; -- opphämtning..nn.1
  opphängning_1_N = mkN "opphängning" ; -- opphängning..nn.1
  opphäva_1_V = mkV "opphäver" ; -- opphäva..vb.1
  opphäva_2_V = mkV "opphäver" ; -- opphäva..vb.2
  opphävande_1_N = mkN "opphävande" ; -- opphävande..nn.1
  opphöja_1_V = mkV "opphöja" "opphöjde" "opphöjt" ; -- opphöja..vb.1
  opphöjande_1_N = mkN "opphöjande" ; -- opphöjande..nn.1
  opphöjd_1_A = mkA "opphöjd" "opphöjt" ; -- opphöjd..av.1
  opphöjdhet_1_N = mkN "opphöjdhet" "opphöjdheter" ; -- opphöjdhet..nn.1
  opphöjelse_1_N = mkN "opphöjelse" "opphöjelser" ; -- opphöjelse..nn.1
  opphöjning_1_N = mkN "opphöjning" ; -- opphöjning..nn.1
  oppifrån_1_Adv = mkAdv "oppifrån" ; -- oppifrån..ab.1
  oppiggande_1_A = mkA "oppiggande" ; -- oppiggande..av.1
  oppiggande_1_N = mkN "oppiggande" ; -- oppiggande..nn.1
  oppjagad_1_A = mkA "oppjagad" ; -- oppjagad..av.1
  oppjustera_1_V = mkV "oppjusterar" ; -- oppjustera..vb.1
  oppjusterande_1_N = mkN "oppjusterande" ; -- oppjusterande..nn.1
  oppjusterbar_1_A = mkA "oppjusterbar" ; -- oppjusterbar..av.1
  oppjusterbarhet_1_N = mkN "oppjusterbarhet" ; -- oppjusterbarhet..nn.1
  oppjustering_1_N = mkN "oppjustering" ; -- oppjustering..nn.1
  oppkalla_1_V = mkV "oppkallar" ; -- oppkalla..vb.1
  oppkallande_1_N = mkN "oppkallande" ; -- oppkallande..nn.1
  oppkammad_1_A = mkA "oppkammad" ; -- oppkammad..av.1
  oppkast_1_N = mkN "oppkast" neutrum  ; -- oppkast..nn.1
  oppkastning_1_N = mkN "oppkastning" ; -- oppkastning..nn.1
  oppklarande_1_N = mkN "oppklarande" ; -- oppklarande..nn.1
  oppklippt_1_A = mkA "oppklippt" "oppklippt" ; -- oppklippt..av.1
  oppklädd_1_A = mkA "oppklädd" ; -- oppklädd..av.1
  oppkläddhet_1_N = mkN "oppkläddhet" ; -- oppkläddhet..nn.1
  oppknuten_1_A = mkA "oppknuten" ; -- oppknuten..av.1
  oppknäppt_1_A = mkA "oppknäppt" "oppknäppt" ; -- oppknäppt..av.1
  oppknäppthet_1_N = mkN "oppknäppthet" ; -- oppknäppthet..nn.1
  oppkäftig_1_A = mkA "oppkäftig" ; -- oppkäftig..av.1
  oppkäftighet_1_N = mkN "oppkäftighet" "oppkäftigheter" ; -- oppkäftighet..nn.1
  oppkörd_1_A = mkA "oppkörd" "oppkört" ; -- oppkörd..av.1
  oppkördhet_1_N = mkN "oppkördhet" ; -- oppkördhet..nn.1
  oppkörning_1_N = mkN "oppkörning" ; -- oppkörning..nn.1
  oppkörsväg_1_N = mkN "oppkörsväg" ; -- oppkörsväg..nn.1
  oppladdad_1_A = mkA "oppladdad" ; -- oppladdad..av.1
  oppladdning_1_N = mkN "oppladdning" ; -- oppladdning..nn.1
  opplagd_1_A = mkA "opplagd" "opplagt" ; -- opplagd..av.1
  oppliva_1_V = mkV "opplivar" ; -- oppliva..vb.1
  opplivande_1_N = mkN "opplivande" ; -- opplivande..nn.1
  opplägg_1_N = mkN "opplägg" neutrum  ; -- opplägg..nn.1
  opplägga_1_V = mkV "opplägga" "oppla" "opplagt" ; -- opplägga..vb.1
  oppläggande_1_N = mkN "oppläggande" ; -- oppläggande..nn.1
  oppläggning_1_N = mkN "oppläggning" ; -- oppläggning..nn.1
  oppläsa_1_V = mkV "oppläser" ; -- oppläsa..vb.1
  oppläsande_1_N = mkN "oppläsande" ; -- oppläsande..nn.1
  oppmuntra_1_V = mkV "oppmuntrar" ; -- oppmuntra..vb.1
  oppmuntrande_1_N = mkN "oppmuntrande" ; -- oppmuntrande..nn.1
  oppochnedvänd_1_A = mkA "oppochnedvänd" ; -- oppochnedvänd..av.1
  oppochnedvändhet_1_N = mkN "oppochnedvändhet" ; -- oppochnedvändhet..nn.1
  oppochnervänd_1_A = mkA "oppochnervänd" ; -- oppochnervänd..av.1
  oppochnervändhet_1_N = mkN "oppochnervändhet" ; -- oppochnervändhet..nn.1
  opponent_1_N = mkN "opponent" "opponenter" ; -- opponent..nn.1
  opponentroll_1_N = mkN "opponentroll" neutrum  ; -- opponentroll..nn.1
  opponera_1_V = mkV "opponerar" ; -- opponera..vb.1
  opponerande_1_N = mkN "opponerande" ; -- opponerande..nn.1
  opponerbar_1_A = mkA "opponerbar" ; -- opponerbar..av.1
  opponerbarhet_1_N = mkN "opponerbarhet" ; -- opponerbarhet..nn.1
  opponering_1_N = mkN "opponering" ; -- opponering..nn.1
  opportun_1_A = mkA "opportun" ; -- opportun..av.1
  opportunhet_1_N = mkN "opportunhet" ; -- opportunhet..nn.1
  opportunism_1_N = mkN "opportunism" "opportunismer" ; -- opportunism..nn.1
  opportunist_1_N = mkN "opportunist" "opportunister" ; -- opportunist..nn.1
  opportunistisk_1_A = mkA "opportunistisk" ; -- opportunistisk..av.1
  opportunitet_1_N = mkN "opportunitet" "opportuniteter" ; -- opportunitet..nn.1
  opportunitetsprincip_1_N = mkN "opportunitetsprincip" ; -- opportunitetsprincip..nn.1
  opposition_1_N = mkN "opposition" ; -- opposition..nn.1
  oppositionell_1_A = mkA "oppositionell" ; -- oppositionell..av.1
  oppositionsaktivist_1_N = mkN "oppositionsaktivist" "oppositionsaktivister" ; -- oppositionsaktivist..nn.1
  oppositionsledare_1_N = mkN "oppositionsledare" utrum  ; -- oppositionsledare..nn.1
  oppositionsparti_1_N = mkN "oppositionsparti" "oppositionspartiet" "oppositionspartier" "oppositionspartierna" ; -- oppositionsparti..nn.1
  opprada_1_V = mkV "oppradar" ; -- opprada..vb.1
  oppradande_1_N = mkN "oppradande" ; -- oppradande..nn.1
  opprensa_1_V = mkV "opprensar" ; -- opprensa..vb.1
  opprensande_1_N = mkN "opprensande" ; -- opprensande..nn.1
  oppretad_1_A = mkA "oppretad" ; -- oppretad..av.1
  oppräkna_1_V = mkV "oppräknar" ; -- oppräkna..vb.1
  oppräknande_1_N = mkN "oppräknande" ; -- oppräknande..nn.1
  oppräkning_1_N = mkN "oppräkning" ; -- oppräkning..nn.1
  opprätt_1_A = mkA "opprätt" ; -- opprätt..av.1
  oppsamla_1_V = mkV "oppsamlar" ; -- oppsamla..vb.1
  oppsamlande_1_N = mkN "oppsamlande" ; -- oppsamlande..nn.1
  oppskjuta_1_V = mkV "oppskjuta" "oppsköt" "oppskjutit" ; -- oppskjuta..vb.1
  oppskjutande_1_N = mkN "oppskjutande" ; -- oppskjutande..nn.1
  oppskjutning_1_N = mkN "oppskjutning" ; -- oppskjutning..nn.1
  oppskojad_1_A = mkA "oppskojad" ; -- oppskojad..av.1
  oppskrivning_1_N = mkN "oppskrivning" ; -- oppskrivning..nn.1
  oppsnabba_1_V = mkV "oppsnabbar" ; -- oppsnabba..vb.1
  oppsnabbande_1_N = mkN "oppsnabbande" ; -- oppsnabbande..nn.1
  oppspärrad_1_A = mkA "oppspärrad" ; -- oppspärrad..av.1
  oppström_1_N = mkN "oppström" "oppströmmen" "oppströmmar" "oppströmmarna" ; -- oppström..nn.1
  oppställa_1_V = mkV "oppställer" ; -- oppställa..vb.1
  oppställande_1_N = mkN "oppställande" ; -- oppställande..nn.1
  oppställning_1_N = mkN "oppställning" ; -- oppställning..nn.1
  oppställningsplats_1_N = mkN "oppställningsplats" "oppställningsplatser" ; -- oppställningsplats..nn.1
  oppställningssignal_1_N = mkN "oppställningssignal" "oppställningssignaler" ; -- oppställningssignal..nn.1
  oppställningsspår_1_N = mkN "oppställningsspår" neutrum  ; -- oppställningsspår..nn.1
  oppstötning_1_N = mkN "oppstötning" ; -- oppstötning..nn.1
  oppsuga_1_V = mkV "oppsuga" "oppsög" "oppsugit" ; -- oppsuga..vb.1
  oppsugande_1_N = mkN "oppsugande" ; -- oppsugande..nn.1
  oppsugning_1_N = mkN "oppsugning" ; -- oppsugning..nn.1
  oppsummera_1_V = mkV "oppsummerar" ; -- oppsummera..vb.1
  oppsummerande_1_N = mkN "oppsummerande" ; -- oppsummerande..nn.1
  oppsummerbar_1_A = mkA "oppsummerbar" ; -- oppsummerbar..av.1
  oppsummerbarhet_1_N = mkN "oppsummerbarhet" ; -- oppsummerbarhet..nn.1
  oppsummering_1_N = mkN "oppsummering" ; -- oppsummering..nn.1
  oppsutten_1_A = mkA "oppsutten" ; -- oppsutten..av.1
  oppsving_1_N = mkN "oppsving" neutrum  ; -- oppsving..nn.1
  oppsätta_1_V = mkV "oppsätta" "oppsätter" "oppsätt" "oppsatte" "oppsatt" "oppsatt" ; -- oppsätta..vb.1
  oppsättande_1_N = mkN "oppsättande" ; -- oppsättande..nn.1
  oppsöka_1_V = mkV "oppsöker" ; -- oppsöka..vb.1
  oppsökande_1_N = mkN "oppsökande" ; -- oppsökande..nn.1
  oppta_1_V = mkV "opptaga" "opptog" "opptagit" ; -- oppta..vb.1
  opptag_1_N = mkN "opptag" neutrum  ; -- opptag..nn.1
  opptagande_1_N = mkN "opptagande" ; -- opptagande..nn.1
  opptagen_1_A = mkA "opptagen" ; -- opptagen..av.1
  opptagenhet_1_N = mkN "opptagenhet" "opptagenheter" ; -- opptagenhet..nn.1
  opptagning_1_N = mkN "opptagning" ; -- opptagning..nn.1
  opptorna_1_V = mkV "opptornar" ; -- opptorna..vb.1
  opptornande_1_N = mkN "opptornande" ; -- opptornande..nn.1
  opptrappa_1_V = mkV "opptrappar" ; -- opptrappa..vb.1
  opptrappande_1_N = mkN "opptrappande" ; -- opptrappande..nn.1
  opptrissa_1_V = mkV "opptrissar" ; -- opptrissa..vb.1
  opptrissande_1_N = mkN "opptrissande" ; -- opptrissande..nn.1
  oppvaknande_1_N = mkN "oppvaknande" ; -- oppvaknande..nn.1
  oppvakta_1_V = mkV "oppvaktar" ; -- oppvakta..vb.1
  oppvaktande_1_N = mkN "oppvaktande" ; -- oppvaktande..nn.1
  oppvaktning_1_N = mkN "oppvaktning" ; -- oppvaktning..nn.1
  oppvikt_1_A = mkA "oppvikt" "oppvikt" ; -- oppvikt..av.1
  oppvilad_1_A = mkA "oppvilad" ; -- oppvilad..av.1
  oppvisa_1_V = mkV "oppvisar" ; -- oppvisa..vb.1
  oppvisande_1_N = mkN "oppvisande" ; -- oppvisande..nn.1
  oppvisning_1_N = mkN "oppvisning" ; -- oppvisning..nn.1
  oppvuxen_1_A = mkA "oppvuxen" ; -- oppvuxen..av.1
  oppväga_1_V = mkV "oppväger" ; -- oppväga..vb.1
  oppvägande_1_N = mkN "oppvägande" ; -- oppvägande..nn.1
  oppvägning_1_N = mkN "oppvägning" ; -- oppvägning..nn.1
  oppvärdera_1_V = mkV "oppvärderar" ; -- oppvärdera..vb.1
  oppvärderande_1_N = mkN "oppvärderande" ; -- oppvärderande..nn.1
  oppvärderbar_1_A = mkA "oppvärderbar" ; -- oppvärderbar..av.1
  oppvärderbarhet_1_N = mkN "oppvärderbarhet" ; -- oppvärderbarhet..nn.1
  oppvärdering_1_N = mkN "oppvärdering" ; -- oppvärdering..nn.1
  oppväxa_1_V = mkV "oppväxa" "oppväxer" "oppväxa" "oppväxte" "oppväxt" "oppvuxen" ; -- oppväxa..vb.1
  oppväxande_1_N = mkN "oppväxande" ; -- oppväxande..nn.1
  oppväxt_1_N = mkN "oppväxt" ; -- oppväxt..nn.1
  oppäta_1_V = mkV "oppäta" "oppåt" "oppätit" ; -- oppäta..vb.1
  oppätande_1_N = mkN "oppätande" ; -- oppätande..nn.1
  oppåkt_1_A = mkA "oppåkt" "oppåkt" ; -- oppåkt..av.1
  oppånedvänd_1_A = mkA "oppånedvänd" ; -- oppånedvänd..av.1
  oppånedvändhet_1_N = mkN "oppånedvändhet" ; -- oppånedvändhet..nn.1
  oppånervänd_1_A = mkA "oppånervänd" ; -- oppånervänd..av.1
  oppånervändhet_1_N = mkN "oppånervändhet" ; -- oppånervändhet..nn.1
  oppåt_1_A = mkA "oppåt" ; -- oppåt..av.1
  oppåtgående_1_A = mkA "oppåtgående" ; -- oppåtgående..av.1
  oppåtgående_1_N = mkN "oppåtgående" ; -- oppåtgående..nn.1
  oppåtkammad_1_A = mkA "oppåtkammad" ; -- oppåtkammad..av.1
  oppåtriktad_1_A = mkA "oppåtriktad" ; -- oppåtriktad..av.1
  oppåtstigande_1_A = mkA "oppåtstigande" ; -- oppåtstigande..av.1
  oppåtsträvande_1_A = mkA "oppåtsträvande" ; -- oppåtsträvande..av.1
  oppåtsträvare_1_N = mkN "oppåtsträvare" utrum  ; -- oppåtsträvare..nn.1
  oppöva_1_V = mkV "oppövar" ; -- oppöva..vb.1
  oppövande_1_N = mkN "oppövande" ; -- oppövande..nn.1
  opraktiserad_1_A = mkA "opraktiserad" ; -- opraktiserad..av.1
  opraktiserbar_1_A = mkA "opraktiserbar" ; -- opraktiserbar..av.1
  opraktiserbarhet_1_N = mkN "opraktiserbarhet" ; -- opraktiserbarhet..nn.1
  opraktisk_1_A = mkA "opraktisk" ; -- opraktisk..av.1
  opraktiskhet_1_N = mkN "opraktiskhet" ; -- opraktiskhet..nn.1
  oprecis_1_A = mkA "oprecis" ; -- oprecis..av.1
  opreciserad_1_A = mkA "opreciserad" ; -- opreciserad..av.1
  opreciserbar_1_A = mkA "opreciserbar" ; -- opreciserbar..av.1
  opreciserbarhet_1_N = mkN "opreciserbarhet" ; -- opreciserbarhet..nn.1
  oprecishet_1_N = mkN "oprecishet" ; -- oprecishet..nn.1
  opredestinerad_1_A = mkA "opredestinerad" ; -- opredestinerad..av.1
  opredestinerbar_1_A = mkA "opredestinerbar" ; -- opredestinerbar..av.1
  opredestinerbarhet_1_N = mkN "opredestinerbarhet" ; -- opredestinerbarhet..nn.1
  opredicerad_1_A = mkA "opredicerad" ; -- opredicerad..av.1
  opredicerbar_1_A = mkA "opredicerbar" ; -- opredicerbar..av.1
  opredicerbarhet_1_N = mkN "opredicerbarhet" ; -- opredicerbarhet..nn.1
  opredisponerad_1_A = mkA "opredisponerad" ; -- opredisponerad..av.1
  opredisponerbar_1_A = mkA "opredisponerbar" ; -- opredisponerbar..av.1
  opredisponerbarhet_1_N = mkN "opredisponerbarhet" ; -- opredisponerbarhet..nn.1
  oprefabricerad_1_A = mkA "oprefabricerad" ; -- oprefabricerad..av.1
  oprefabricerbar_1_A = mkA "oprefabricerbar" ; -- oprefabricerbar..av.1
  oprefabricerbarhet_1_N = mkN "oprefabricerbarhet" ; -- oprefabricerbarhet..nn.1
  oprefererad_1_A = mkA "oprefererad" ; -- oprefererad..av.1
  oprefererbar_1_A = mkA "oprefererbar" ; -- oprefererbar..av.1
  oprefererbarhet_1_N = mkN "oprefererbarhet" ; -- oprefererbarhet..nn.1
  oprefigerad_1_A = mkA "oprefigerad" ; -- oprefigerad..av.1
  oprefigerbar_1_A = mkA "oprefigerbar" ; -- oprefigerbar..av.1
  oprefigerbarhet_1_N = mkN "oprefigerbarhet" ; -- oprefigerbarhet..nn.1
  oprejad_1_A = mkA "oprejad" ; -- oprejad..av.1
  opreludierad_1_A = mkA "opreludierad" ; -- opreludierad..av.1
  opreludierbar_1_A = mkA "opreludierbar" ; -- opreludierbar..av.1
  opreludierbarhet_1_N = mkN "opreludierbarhet" ; -- opreludierbarhet..nn.1
  opremierad_1_A = mkA "opremierad" ; -- opremierad..av.1
  opremierbar_1_A = mkA "opremierbar" ; -- opremierbar..av.1
  opremierbarhet_1_N = mkN "opremierbarhet" ; -- opremierbarhet..nn.1
  opreparerad_1_A = mkA "opreparerad" ; -- opreparerad..av.1
  opreparerbar_1_A = mkA "opreparerbar" ; -- opreparerbar..av.1
  opreparerbarhet_1_N = mkN "opreparerbarhet" ; -- opreparerbarhet..nn.1
  opresentad_1_A = mkA "opresentad" ; -- opresentad..av.1
  opresenterad_1_A = mkA "opresenterad" ; -- opresenterad..av.1
  opresenterbar_1_A = mkA "opresenterbar" ; -- opresenterbar..av.1
  opresenterbarhet_1_N = mkN "opresenterbarhet" ; -- opresenterbarhet..nn.1
  opreserverad_1_A = mkA "opreserverad" ; -- opreserverad..av.1
  opreserverbar_1_A = mkA "opreserverbar" ; -- opreserverbar..av.1
  opreserverbarhet_1_N = mkN "opreserverbarhet" ; -- opreserverbarhet..nn.1
  opreskriberad_1_A = mkA "opreskriberad" ; -- opreskriberad..av.1
  opreskriberbar_1_A = mkA "opreskriberbar" ; -- opreskriberbar..av.1
  opreskriberbarhet_1_N = mkN "opreskriberbarhet" ; -- opreskriberbarhet..nn.1
  opressad_1_A = mkA "opressad" ; -- opressad..av.1
  opresterad_1_A = mkA "opresterad" ; -- opresterad..av.1
  opresterbar_1_A = mkA "opresterbar" ; -- opresterbar..av.1
  opresterbarhet_1_N = mkN "opresterbarhet" ; -- opresterbarhet..nn.1
  opresumerad_1_A = mkA "opresumerad" ; -- opresumerad..av.1
  opresumerbar_1_A = mkA "opresumerbar" ; -- opresumerbar..av.1
  opresumerbarhet_1_N = mkN "opresumerbarhet" ; -- opresumerbarhet..nn.1
  opretentiös_1_A = mkA "opretentiös" ; -- opretentiös..av.1
  oprickad_1_A = mkA "oprickad" ; -- oprickad..av.1
  oprioriterad_1_A = mkA "oprioriterad" ; -- oprioriterad..av.1
  oprioriterbar_1_A = mkA "oprioriterbar" ; -- oprioriterbar..av.1
  oprioriterbarhet_1_N = mkN "oprioriterbarhet" ; -- oprioriterbarhet..nn.1
  opris_1_N = mkN "opris" neutrum  ; -- opris..nn.1
  oprisad_1_A = mkA "oprisad" ; -- oprisad..av.1
  oprivatiserad_1_A = mkA "oprivatiserad" ; -- oprivatiserad..av.1
  oprivatiserbar_1_A = mkA "oprivatiserbar" ; -- oprivatiserbar..av.1
  oprivatiserbarhet_1_N = mkN "oprivatiserbarhet" ; -- oprivatiserbarhet..nn.1
  oprivilegierad_1_A = mkA "oprivilegierad" ; -- oprivilegierad..av.1
  oprivilegierbar_1_A = mkA "oprivilegierbar" ; -- oprivilegierbar..av.1
  oprivilegierbarhet_1_N = mkN "oprivilegierbarhet" ; -- oprivilegierbarhet..nn.1
  oproberad_1_A = mkA "oproberad" ; -- oproberad..av.1
  oproberbar_1_A = mkA "oproberbar" ; -- oproberbar..av.1
  oproberbarhet_1_N = mkN "oproberbarhet" ; -- oproberbarhet..nn.1
  oproblematiserad_1_A = mkA "oproblematiserad" ; -- oproblematiserad..av.1
  oproblematiserbar_1_A = mkA "oproblematiserbar" ; -- oproblematiserbar..av.1
  oproblematiserbarhet_1_N = mkN "oproblematiserbarhet" ; -- oproblematiserbarhet..nn.1
  oproblematisk_1_A = mkA "oproblematisk" ; -- oproblematisk..av.1
  oprocessad_1_A = mkA "oprocessad" ; -- oprocessad..av.1
  oproducerad_1_A = mkA "oproducerad" ; -- oproducerad..av.1
  oproducerbar_1_A = mkA "oproducerbar" ; -- oproducerbar..av.1
  oproducerbarhet_1_N = mkN "oproducerbarhet" ; -- oproducerbarhet..nn.1
  oprofanerad_1_A = mkA "oprofanerad" ; -- oprofanerad..av.1
  oprofanerbar_1_A = mkA "oprofanerbar" ; -- oprofanerbar..av.1
  oprofanerbarhet_1_N = mkN "oprofanerbarhet" ; -- oprofanerbarhet..nn.1
  oprofessionaliserad_1_A = mkA "oprofessionaliserad" ; -- oprofessionaliserad..av.1
  oprofessionaliserbar_1_A = mkA "oprofessionaliserbar" ; -- oprofessionaliserbar..av.1
  oprofessionaliserbarhet_1_N = mkN "oprofessionaliserbarhet" ; -- oprofessionaliserbarhet..nn.1
  oprofessionell_1_A = mkA "oprofessionell" ; -- oprofessionell..av.1
  oprofilerad_1_A = mkA "oprofilerad" ; -- oprofilerad..av.1
  oprofilerbar_1_A = mkA "oprofilerbar" ; -- oprofilerbar..av.1
  oprofilerbarhet_1_N = mkN "oprofilerbarhet" ; -- oprofilerbarhet..nn.1
  oprognostiserad_1_A = mkA "oprognostiserad" ; -- oprognostiserad..av.1
  oprognostiserbar_1_A = mkA "oprognostiserbar" ; -- oprognostiserbar..av.1
  oprognostiserbarhet_1_N = mkN "oprognostiserbarhet" ; -- oprognostiserbarhet..nn.1
  oprogrammerad_1_A = mkA "oprogrammerad" ; -- oprogrammerad..av.1
  oprogrammerbar_1_A = mkA "oprogrammerbar" ; -- oprogrammerbar..av.1
  oprogrammerbarhet_1_N = mkN "oprogrammerbarhet" ; -- oprogrammerbarhet..nn.1
  oprojekterad_1_A = mkA "oprojekterad" ; -- oprojekterad..av.1
  oprojekterbar_1_A = mkA "oprojekterbar" ; -- oprojekterbar..av.1
  oprojekterbarhet_1_N = mkN "oprojekterbarhet" ; -- oprojekterbarhet..nn.1
  oprojicerad_1_A = mkA "oprojicerad" ; -- oprojicerad..av.1
  oprojicerbar_1_A = mkA "oprojicerbar" ; -- oprojicerbar..av.1
  oprojicerbarhet_1_N = mkN "oprojicerbarhet" ; -- oprojicerbarhet..nn.1
  oproklamerad_1_A = mkA "oproklamerad" ; -- oproklamerad..av.1
  oproklamerbar_1_A = mkA "oproklamerbar" ; -- oproklamerbar..av.1
  oproklamerbarhet_1_N = mkN "oproklamerbarhet" ; -- oproklamerbarhet..nn.1
  oproletariserad_1_A = mkA "oproletariserad" ; -- oproletariserad..av.1
  oproletariserbar_1_A = mkA "oproletariserbar" ; -- oproletariserbar..av.1
  oproletariserbarhet_1_N = mkN "oproletariserbarhet" ; -- oproletariserbarhet..nn.1
  oprolongerad_1_A = mkA "oprolongerad" ; -- oprolongerad..av.1
  oprolongerbar_1_A = mkA "oprolongerbar" ; -- oprolongerbar..av.1
  oprolongerbarhet_1_N = mkN "oprolongerbarhet" ; -- oprolongerbarhet..nn.1
  opromoverad_1_A = mkA "opromoverad" ; -- opromoverad..av.1
  opromoverbar_1_A = mkA "opromoverbar" ; -- opromoverbar..av.1
  opromoverbarhet_1_N = mkN "opromoverbarhet" ; -- opromoverbarhet..nn.1
  opromulgerad_1_A = mkA "opromulgerad" ; -- opromulgerad..av.1
  opromulgerbar_1_A = mkA "opromulgerbar" ; -- opromulgerbar..av.1
  opromulgerbarhet_1_N = mkN "opromulgerbarhet" ; -- opromulgerbarhet..nn.1
  opronerbar_1_A = mkA "opronerbar" ; -- opronerbar..av.1
  opronerbarhet_1_N = mkN "opronerbarhet" ; -- opronerbarhet..nn.1
  oprononcerad_1_A = mkA "oprononcerad" ; -- oprononcerad..av.1
  oprononcerbar_1_A = mkA "oprononcerbar" ; -- oprononcerbar..av.1
  oprononcerbarhet_1_N = mkN "oprononcerbarhet" ; -- oprononcerbarhet..nn.1
  oproponerad_1_A = mkA "oproponerad" ; -- oproponerad..av.1
  oproponerbar_1_A = mkA "oproponerbar" ; -- oproponerbar..av.1
  oproponerbarhet_1_N = mkN "oproponerbarhet" ; -- oproponerbarhet..nn.1
  oproportionell_1_A = mkA "oproportionell" ; -- oproportionell..av.1
  oproportionerad_1_A = mkA "oproportionerad" ; -- oproportionerad..av.1
  oproportionerbar_1_A = mkA "oproportionerbar" ; -- oproportionerbar..av.1
  oproportionerbarhet_1_N = mkN "oproportionerbarhet" ; -- oproportionerbarhet..nn.1
  oproportionerlig_1_A = mkA "oproportionerlig" ; -- oproportionerlig..av.1
  oproportionerlighet_1_N = mkN "oproportionerlighet" ; -- oproportionerlighet..nn.1
  oproppad_1_A = mkA "oproppad" ; -- oproppad..av.1
  oproskriberad_1_A = mkA "oproskriberad" ; -- oproskriberad..av.1
  oproskriberbar_1_A = mkA "oproskriberbar" ; -- oproskriberbar..av.1
  oproskriberbarhet_1_N = mkN "oproskriberbarhet" ; -- oproskriberbarhet..nn.1
  oprospekterad_1_A = mkA "oprospekterad" ; -- oprospekterad..av.1
  oprospekterbar_1_A = mkA "oprospekterbar" ; -- oprospekterbar..av.1
  oprospekterbarhet_1_N = mkN "oprospekterbarhet" ; -- oprospekterbarhet..nn.1
  oprotegerad_1_A = mkA "oprotegerad" ; -- oprotegerad..av.1
  oprotegerbar_1_A = mkA "oprotegerbar" ; -- oprotegerbar..av.1
  oprotegerbarhet_1_N = mkN "oprotegerbarhet" ; -- oprotegerbarhet..nn.1
  oprotesterad_1_A = mkA "oprotesterad" ; -- oprotesterad..av.1
  oprotokollerad_1_A = mkA "oprotokollerad" ; -- oprotokollerad..av.1
  oprotokollerbar_1_A = mkA "oprotokollerbar" ; -- oprotokollerbar..av.1
  oprotokollerbarhet_1_N = mkN "oprotokollerbarhet" ; -- oprotokollerbarhet..nn.1
  oprovad_1_A = mkA "oprovad" ; -- oprovad..av.1
  oprovocerad_1_A = mkA "oprovocerad" ; -- oprovocerad..av.1
  oprovocerbar_1_A = mkA "oprovocerbar" ; -- oprovocerbar..av.1
  oprovocerbarhet_1_N = mkN "oprovocerbarhet" ; -- oprovocerbarhet..nn.1
  oprutad_1_A = mkA "oprutad" ; -- oprutad..av.1
  oprydd_1_A = mkA "oprydd" ; -- oprydd..av.1
  opryglad_1_A = mkA "opryglad" ; -- opryglad..av.1
  opräglad_1_A = mkA "opräglad" ; -- opräglad..av.1
  opräntad_1_A = mkA "opräntad" ; -- opräntad..av.1
  opråmad_1_A = mkA "opråmad" ; -- opråmad..av.1
  opröjsad_1_A = mkA "opröjsad" ; -- opröjsad..av.1
  oprövad_1_A = mkA "oprövad" ; -- oprövad..av.1
  opsykad_1_A = mkA "opsykad" ; -- opsykad..av.1
  opsykologiserad_1_A = mkA "opsykologiserad" ; -- opsykologiserad..av.1
  opsykologiserbar_1_A = mkA "opsykologiserbar" ; -- opsykologiserbar..av.1
  opsykologiserbarhet_1_N = mkN "opsykologiserbarhet" ; -- opsykologiserbarhet..nn.1
  opsykologisk_1_A = mkA "opsykologisk" ; -- opsykologisk..av.1
  optant_1_N = mkN "optant" "optanter" ; -- optant..nn.1
  optativ_1_A = mkA "optativ" ; -- optativ..av.1
  optativ_1_N = mkN "optativ" "optativer" ; -- optativ..nn.1
  optera_1_V = mkV "opterar" ; -- optera..vb.1
  opterande_1_N = mkN "opterande" ; -- opterande..nn.1
  optering_1_N = mkN "optering" ; -- optering..nn.1
  optik_1_N = mkN "optik" ; -- optik..nn.1
  optiker_1_N = mkN "optiker" "optikern" "optiker" "optikerna" ; -- optiker..nn.1
  optimal_1_A = mkA "optimal" ; -- optimal..av.1
  optimera_1_V = mkV "optimerar" ; -- optimera..vb.1
  optimerande_1_N = mkN "optimerande" ; -- optimerande..nn.1
  optimerbar_1_A = mkA "optimerbar" ; -- optimerbar..av.1
  optimerbarhet_1_N = mkN "optimerbarhet" ; -- optimerbarhet..nn.1
  optimering_1_N = mkN "optimering" ; -- optimering..nn.1
  optimism_1_N = mkN "optimism" "optimismer" ; -- optimism..nn.1
  optimist_1_N = mkN "optimist" "optimister" ; -- optimist..nn.1
  optimistisk_1_A = mkA "optimistisk" ; -- optimistisk..av.1
  optimistjolle_1_N = mkN "optimistjolle" utrum  ; -- optimistjolle..nn.1
  optimum_1_N = mkN "optimum" neutrum  ; -- optimum..nn.1
  option_1_N = mkN "option" ; -- option..nn.1
  optionsrätt_1_N = mkN "optionsrätt" "optionsrätter" ; -- optionsrätt..nn.1
  optionsskandal_1_N = mkN "optionsskandal" "optionsskandaler" ; -- optionsskandal..nn.1
  optisk_1_A = mkA "optisk" ; -- optisk..av.1
  optoelektronik_1_N = mkN "optoelektronik" ; -- optoelektronik..nn.1
  optokomponent_1_N = mkN "optokomponent" "optokomponenter" ; -- optokomponent..nn.1
  opublicerad_1_A = mkA "opublicerad" ; -- opublicerad..av.1
  opublicerbar_1_A = mkA "opublicerbar" ; -- opublicerbar..av.1
  opublicerbarhet_1_N = mkN "opublicerbarhet" ; -- opublicerbarhet..nn.1
  opuddlad_1_A = mkA "opuddlad" ; -- opuddlad..av.1
  opudrad_1_A = mkA "opudrad" ; -- opudrad..av.1
  opuffad_1_A = mkA "opuffad" ; -- opuffad..av.1
  opulens_1_N = mkN "opulens" ; -- opulens..nn.1
  opulent_1_A = mkA "opulent" "opulent" ; -- opulent..av.1
  opulveriserad_1_A = mkA "opulveriserad" ; -- opulveriserad..av.1
  opulveriserbar_1_A = mkA "opulveriserbar" ; -- opulveriserbar..av.1
  opulveriserbarhet_1_N = mkN "opulveriserbarhet" ; -- opulveriserbarhet..nn.1
  opulvriserad_1_A = mkA "opulvriserad" ; -- opulvriserad..av.1
  opulvriserbar_1_A = mkA "opulvriserbar" ; -- opulvriserbar..av.1
  opulvriserbarhet_1_N = mkN "opulvriserbarhet" ; -- opulvriserbarhet..nn.1
  opumpad_1_A = mkA "opumpad" ; -- opumpad..av.1
  opunktad_1_A = mkA "opunktad" ; -- opunktad..av.1
  opunkterad_1_A = mkA "opunkterad" ; -- opunkterad..av.1
  opunkterbar_1_A = mkA "opunkterbar" ; -- opunkterbar..av.1
  opunkterbarhet_1_N = mkN "opunkterbarhet" ; -- opunkterbarhet..nn.1
  opunsad_1_A = mkA "opunsad" ; -- opunsad..av.1
  opurgerad_1_A = mkA "opurgerad" ; -- opurgerad..av.1
  opurgerbar_1_A = mkA "opurgerbar" ; -- opurgerbar..av.1
  opurgerbarhet_1_N = mkN "opurgerbarhet" ; -- opurgerbarhet..nn.1
  opurprad_1_A = mkA "opurprad" ; -- opurprad..av.1
  opurrad_1_A = mkA "opurrad" ; -- opurrad..av.1
  opus_1_N = mkN "opus" neutrum  ; -- opus..nn.1
  opushad_1_A = mkA "opushad" ; -- opushad..av.1
  opussad_1_A = mkA "opussad" ; -- opussad..av.1
  oputsad_1_A = mkA "oputsad" ; -- oputsad..av.1
  oputtad_1_A = mkA "oputtad" ; -- oputtad..av.1
  opyntad_1_A = mkA "opyntad" ; -- opyntad..av.1
  opytsad_1_A = mkA "opytsad" ; -- opytsad..av.1
  opälad_1_A = mkA "opälad" ; -- opälad..av.1
  opåad_1_A = mkA "opåad" ; -- opåad..av.1
  opåannonserbar_1_A = mkA "opåannonserbar" ; -- opåannonserbar..av.1
  opåannonserbarhet_1_N = mkN "opåannonserbarhet" ; -- opåannonserbarhet..nn.1
  opåbördad_1_A = mkA "opåbördad" ; -- opåbördad..av.1
  opåbörjad_1_A = mkA "opåbörjad" ; -- opåbörjad..av.1
  opådyvlad_1_A = mkA "opådyvlad" ; -- opådyvlad..av.1
  opåfordrad_1_A = mkA "opåfordrad" ; -- opåfordrad..av.1
  opåförd_1_A = mkA "opåförd" "opåfört" ; -- opåförd..av.1
  opåkallad_1_A = mkA "opåkallad" ; -- opåkallad..av.1
  opålad_1_A = mkA "opålad" ; -- opålad..av.1
  opålitlig_1_A = mkA "opålitlig" ; -- opålitlig..av.1
  opålitlighet_1_N = mkN "opålitlighet" ; -- opålitlighet..nn.1
  opåmind_1_A = mkA "opåmind" ; -- opåmind..av.1
  opåpekad_1_A = mkA "opåpekad" ; -- opåpekad..av.1
  opåropad_1_A = mkA "opåropad" ; -- opåropad..av.1
  opåräknad_1_A = mkA "opåräknad" ; -- opåräknad..av.1
  opåskyndad_1_A = mkA "opåskyndad" ; -- opåskyndad..av.1
  opåtalad_1_A = mkA "opåtalad" ; -- opåtalad..av.1
  opåtald_1_A = mkA "opåtald" "opåtalt" ; -- opåtald..av.1
  opåträffad_1_A = mkA "opåträffad" ; -- opåträffad..av.1
  opåtänkt_1_A = mkA "opåtänkt" "opåtänkt" ; -- opåtänkt..av.1
  opåverkad_1_A = mkA "opåverkad" ; -- opåverkad..av.1
  opåverkbar_1_A = mkA "opåverkbar" ; -- opåverkbar..av.1
  opåverkbarhet_1_N = mkN "opåverkbarhet" ; -- opåverkbarhet..nn.1
  opåvisad_1_A = mkA "opåvisad" ; -- opåvisad..av.1
  opåyrkad_1_A = mkA "opåyrkad" ; -- opåyrkad..av.1
  oquiltad_1_A = mkA "oquiltad" ; -- oquiltad..av.1
  or_1_N = mkN "or" neutrum  ; -- or..nn.1
  orabatterad_1_A = mkA "orabatterad" ; -- orabatterad..av.1
  orabatterbar_1_A = mkA "orabatterbar" ; -- orabatterbar..av.1
  orabatterbarhet_1_N = mkN "orabatterbarhet" ; -- orabatterbarhet..nn.1
  orabblad_1_A = mkA "orabblad" ; -- orabblad..av.1
  orackad_1_A = mkA "orackad" ; -- orackad..av.1
  oraderad_1_A = mkA "oraderad" ; -- oraderad..av.1
  oraderbar_1_A = mkA "oraderbar" ; -- oraderbar..av.1
  oraderbarhet_1_N = mkN "oraderbarhet" ; -- oraderbarhet..nn.1
  oradierad_1_A = mkA "oradierad" ; -- oradierad..av.1
  oradierbar_1_A = mkA "oradierbar" ; -- oradierbar..av.1
  oradierbarhet_1_N = mkN "oradierbarhet" ; -- oradierbarhet..nn.1
  oradikaliserad_1_A = mkA "oradikaliserad" ; -- oradikaliserad..av.1
  oradikaliserbar_1_A = mkA "oradikaliserbar" ; -- oradikaliserbar..av.1
  oradikaliserbarhet_1_N = mkN "oradikaliserbarhet" ; -- oradikaliserbarhet..nn.1
  oraffinerad_1_A = mkA "oraffinerad" ; -- oraffinerad..av.1
  oraffinerbar_1_A = mkA "oraffinerbar" ; -- oraffinerbar..av.1
  oraffinerbarhet_1_N = mkN "oraffinerbarhet" ; -- oraffinerbarhet..nn.1
  oraggad_1_A = mkA "oraggad" ; -- oraggad..av.1
  orakad_1_A = mkA "orakad" ; -- orakad..av.1
  orakel_1_N = mkN "orakel" neutrum  ; -- orakel..nn.1
  orakelmässig_1_A = mkA "orakelmässig" ; -- orakelmässig..av.1
  orakelspråk_1_N = mkN "orakelspråk" neutrum  ; -- orakelspråk..nn.1
  orakelsvar_1_N = mkN "orakelsvar" neutrum  ; -- orakelsvar..nn.1
  oral_1_A = mkA "oral" ; -- oral..av.1
  oralsex_1_N = mkN "oralsex" neutrum  ; -- oralsex..nn.1
  oramad_1_A = mkA "oramad" ; -- oramad..av.1
  orammad_1_A = mkA "orammad" ; -- orammad..av.1
  oramponerad_1_A = mkA "oramponerad" ; -- oramponerad..av.1
  oramponerbar_1_A = mkA "oramponerbar" ; -- oramponerbar..av.1
  oramponerbarhet_1_N = mkN "oramponerbarhet" ; -- oramponerbarhet..nn.1
  oramsad_1_A = mkA "oramsad" ; -- oramsad..av.1
  orandad_1_A = mkA "orandad" ; -- orandad..av.1
  orandomiserad_1_A = mkA "orandomiserad" ; -- orandomiserad..av.1
  orange_1_A = mkA "orange" "oranget" ; -- orange..av.1
  orange_1_N = mkN "orange" "oranger" ; -- orange..nn.1
  orangefärgad_1_A = mkA "orangefärgad" ; -- orangefärgad..av.1
  orangegul_1_A = mkA "orangegul" ; -- orangegul..av.1
  orangemålad_1_A = mkA "orangemålad" ; -- orangemålad..av.1
  orangerad_1_A = mkA "orangerad" ; -- orangerad..av.1
  orangerbar_1_A = mkA "orangerbar" ; -- orangerbar..av.1
  orangerbarhet_1_N = mkN "orangerbarhet" ; -- orangerbarhet..nn.1
  orangeri_1_N = mkN "orangeri" "orangeriet" "orangerier" "orangerierna" ; -- orangeri..nn.1
  orangeröd_1_A = mkA "orangeröd" "orangerött" ; -- orangeröd..av.1
  orangutang_1_N = mkN "orangutang" "orangutanger" ; -- orangutang..nn.1
  orankad_1_A = mkA "orankad" ; -- orankad..av.1
  orannsakad_1_A = mkA "orannsakad" ; -- orannsakad..av.1
  oransonerad_1_A = mkA "oransonerad" ; -- oransonerad..av.1
  oransonerbar_1_A = mkA "oransonerbar" ; -- oransonerbar..av.1
  oransonerbarhet_1_N = mkN "oransonerbarhet" ; -- oransonerbarhet..nn.1
  orant_1_N = mkN "orant" "oranter" ; -- orant..nn.1
  orappad_1_A = mkA "orappad" ; -- orappad..av.1
  orappellerad_1_A = mkA "orappellerad" ; -- orappellerad..av.1
  orappellerbar_1_A = mkA "orappellerbar" ; -- orappellerbar..av.1
  orappellerbarhet_1_N = mkN "orappellerbarhet" ; -- orappellerbarhet..nn.1
  orapporterad_1_A = mkA "orapporterad" ; -- orapporterad..av.1
  orapporterbar_1_A = mkA "orapporterbar" ; -- orapporterbar..av.1
  orapporterbarhet_1_N = mkN "orapporterbarhet" ; -- orapporterbarhet..nn.1
  oraserad_1_A = mkA "oraserad" ; -- oraserad..av.1
  oraserbar_1_A = mkA "oraserbar" ; -- oraserbar..av.1
  oraserbarhet_1_N = mkN "oraserbarhet" ; -- oraserbarhet..nn.1
  oraspad_1_A = mkA "oraspad" ; -- oraspad..av.1
  orastad_1_A = mkA "orastad" ; -- orastad..av.1
  oratad_1_A = mkA "oratad" ; -- oratad..av.1
  oratificerad_1_A = mkA "oratificerad" ; -- oratificerad..av.1
  oratificerbar_1_A = mkA "oratificerbar" ; -- oratificerbar..av.1
  oratificerbarhet_1_N = mkN "oratificerbarhet" ; -- oratificerbarhet..nn.1
  oration_1_N = mkN "oration" ; -- oration..nn.1
  orationaliserad_1_A = mkA "orationaliserad" ; -- orationaliserad..av.1
  orationaliserbar_1_A = mkA "orationaliserbar" ; -- orationaliserbar..av.1
  orationaliserbarhet_1_N = mkN "orationaliserbarhet" ; -- orationaliserbarhet..nn.1
  orationell_1_A = mkA "orationell" ; -- orationell..av.1
  orator_1_N = mkN "orator" "oratorer" ; -- orator..nn.1
  oratorisk_1_A = mkA "oratorisk" ; -- oratorisk..av.1
  oratorium_1_N = mkN "oratorium" "oratoriet" "oratorier" "oratorierna" ; -- oratorium..nn.1
  orattad_1_A = mkA "orattad" ; -- orattad..av.1
  orbital_1_N = mkN "orbital" "orbitaler" ; -- orbital..nn.1
  orchestra_1_N = mkN "orchestra" ; -- orchestra..nn.1
  ord_1_N = mkN "ord" neutrum  ; -- ord..nn.1
  orda_1_V = mkV "ordar" ; -- orda..vb.1
  ordaccent_1_N = mkN "ordaccent" "ordaccenter" ; -- ordaccent..nn.1
  ordagrann_1_A = mkA "ordagrann" "ordagrant" ; -- ordagrann..av.1
  ordagrannhet_1_N = mkN "ordagrannhet" ; -- ordagrannhet..nn.1
  ordal_1_N = mkN "ordal" "ordalier" ; -- ordal..nn.1
  ordalydelse_1_N = mkN "ordalydelse" "ordalydelser" ; -- ordalydelse..nn.1
  ordande_1_N = mkN "ordande" ; -- ordande..nn.1
  ordbajs_1_N = mkN "ordbajs" neutrum  ; -- ordbajs..nn.1
  ordbehandlare_1_N = mkN "ordbehandlare" utrum  ; -- ordbehandlare..nn.1
  ordbehandling_1_N = mkN "ordbehandling" ; -- ordbehandling..nn.1
  ordbetoning_1_N = mkN "ordbetoning" ; -- ordbetoning..nn.1
  ordbild_1_N = mkN "ordbild" "ordbilder" ; -- ordbild..nn.1
  ordbildning_1_N = mkN "ordbildning" ; -- ordbildning..nn.1
  ordblind_1_A = mkA "ordblind" ; -- ordblind..av.1
  ordblindhet_1_N = mkN "ordblindhet" "ordblindheter" ; -- ordblindhet..nn.1
  ordbok_1_N = mkN "ordbok" "ordböcker" ; -- ordbok..nn.1
  ordbredd_1_N = mkN "ordbredd" "ordbredder" ; -- ordbredd..nn.1
  ordbyte_1_N = mkN "ordbyte" ; -- ordbyte..nn.1
  ordböjning_1_N = mkN "ordböjning" ; -- ordböjning..nn.1
  orddel_1_N = mkN "orddel" "orddelen" "orddelar" "orddelarna" ; -- orddel..nn.1
  orddelare_1_N = mkN "orddelare" utrum  ; -- orddelare..nn.1
  orddöv_1_A = mkA "orddöv" ; -- orddöv..av.1
  orddövhet_1_N = mkN "orddövhet" ; -- orddövhet..nn.1
  orden_1_N = mkN "orden" ; -- orden..nn.1
  ordensband_1_N = mkN "ordensband" neutrum  ; -- ordensband..nn.1
  ordenskapitel_1_N = mkN "ordenskapitel" neutrum  ; -- ordenskapitel..nn.1
  ordensmedlem_1_N = mkN "ordensmedlem" "ordensmedlemmen" "ordensmedlemmar" "ordensmedlemmarna" ; -- ordensmedlem..nn.1
  ordensregel_1_N = mkN "ordensregel" "ordensregeln" "ordensregler" "ordensreglerna" ; -- ordensregel..nn.1
  ordenssamfund_1_N = mkN "ordenssamfund" neutrum  ; -- ordenssamfund..nn.1
  ordensstjärna_1_N = mkN "ordensstjärna" ; -- ordensstjärna..nn.1
  ordenssällskap_1_N = mkN "ordenssällskap" neutrum  ; -- ordenssällskap..nn.1
  ordentlig_1_A = mkA "ordentlig" ; -- ordentlig..av.1
  ordentlighet_1_N = mkN "ordentlighet" ; -- ordentlighet..nn.1
  ordentreprenör_1_N = mkN "ordentreprenör" "ordentreprenörer" ; -- ordentreprenör..nn.1
  order_1_N = mkN "order" ; -- order..nn.1
  orderbrott_1_N = mkN "orderbrott" neutrum  ; -- orderbrott..nn.1
  orderingång_1_N = mkN "orderingång" ; -- orderingång..nn.1
  orderstock_1_N = mkN "orderstock" ; -- orderstock..nn.1
  ordfattig_1_A = mkA "ordfattig" ; -- ordfattig..av.1
  ordfattigdom_1_N = mkN "ordfattigdom" ; -- ordfattigdom..nn.1
  ordfattighet_1_N = mkN "ordfattighet" ; -- ordfattighet..nn.1
  ordfejd_1_N = mkN "ordfejd" "ordfejder" ; -- ordfejd..nn.1
  ordfläta_1_N = mkN "ordfläta" ; -- ordfläta..nn.1
  ordflöde_1_N = mkN "ordflöde" ; -- ordflöde..nn.1
  ordfogning_1_N = mkN "ordfogning" ; -- ordfogning..nn.1
  ordform_1_N = mkN "ordform" "ordformer" ; -- ordform..nn.1
  ordfot_1_N = mkN "ordfot" "ordfötter" ; -- ordfot..nn.1
  ordfragment_1_N = mkN "ordfragment" neutrum  ; -- ordfragment..nn.1
  ordföljd_1_N = mkN "ordföljd" "ordföljder" ; -- ordföljd..nn.1
  ordförande_1_N = mkN "ordförande" "ordföranden" "ordföranden" "ordförandena" ; -- ordförande..nn.1
  ordförandeklubba_1_N = mkN "ordförandeklubba" ; -- ordförandeklubba..nn.1
  ordförandeland_1_N = mkN "ordförandeland" "ordförandelandet" "ordförandeländer" "ordförandeländerna" ; -- ordförandeland..nn.1
  ordförandepost_1_N = mkN "ordförandepost" "ordförandeposter" ; -- ordförandepost..nn.1
  ordförandeskap_1_N = mkN "ordförandeskap" neutrum  ; -- ordförandeskap..nn.1
  ordförekomst_1_N = mkN "ordförekomst" "ordförekomster" ; -- ordförekomst..nn.1
  ordförklaring_1_N = mkN "ordförklaring" ; -- ordförklaring..nn.1
  ordförråd_1_N = mkN "ordförråd" neutrum  ; -- ordförråd..nn.1
  ordgeografi_1_N = mkN "ordgeografi" ; -- ordgeografi..nn.1
  ordgrupp_1_N = mkN "ordgrupp" "ordgrupper" ; -- ordgrupp..nn.1
  ordgåta_1_N = mkN "ordgåta" ; -- ordgåta..nn.1
  ordhållig_1_A = mkA "ordhållig" ; -- ordhållig..av.1
  ordhållighet_1_N = mkN "ordhållighet" ; -- ordhållighet..nn.1
  ordinalskala_1_N = mkN "ordinalskala" ; -- ordinalskala..nn.1
  ordinand_1_N = mkN "ordinand" "ordinander" ; -- ordinand..nn.1
  ordinarie_1_A = mkA "ordinarie" ; -- ordinarie..av.1
  ordinariesätta_1_V = mkV "ordinariesätta" "ordinariesätter" "ordinariesätt" "ordinariesatte" "ordinariesatt" "ordinariesatt" ; -- ordinariesätta..vb.1
  ordinariesättande_1_N = mkN "ordinariesättande" ; -- ordinariesättande..nn.1
  ordinata_1_N = mkN "ordinata" ; -- ordinata..nn.1
  ordination_1_N = mkN "ordination" ; -- ordination..nn.1
  ordinera_1_V = mkV "ordinerar" ; -- ordinera..vb.1
  ordinerande_1_N = mkN "ordinerande" ; -- ordinerande..nn.1
  ordinerbar_1_A = mkA "ordinerbar" ; -- ordinerbar..av.1
  ordinerbarhet_1_N = mkN "ordinerbarhet" ; -- ordinerbarhet..nn.1
  ordinering_1_N = mkN "ordinering" ; -- ordinering..nn.1
  ordinär_1_A = mkA "ordinär" ; -- ordinär..av.1
  ordkampsspel_1_N = mkN "ordkampsspel" "ordkampsspelet" "ordkampsspel" "ordkampsspelen" ; -- ordkampsspel..nn.1
  ordkarg_1_A = mkA "ordkarg" ; -- ordkarg..av.1
  ordkarghet_1_N = mkN "ordkarghet" ; -- ordkarghet..nn.1
  ordklass_1_N = mkN "ordklass" "ordklasser" ; -- ordklass..nn.1
  ordklassindelning_1_N = mkN "ordklassindelning" ; -- ordklassindelning..nn.1
  ordklasstaggare_1_N = mkN "ordklasstaggare" utrum  ; -- ordklasstaggare..nn.1
  ordklyveri_1_N = mkN "ordklyveri" "ordklyveriet" "ordklyverier" "ordklyverierna" ; -- ordklyveri..nn.1
  ordknapp_1_A = mkA "ordknapp" ; -- ordknapp..av.1
  ordknapphet_1_N = mkN "ordknapphet" ; -- ordknapphet..nn.1
  ordkonstnär_1_N = mkN "ordkonstnär" "ordkonstnärer" ; -- ordkonstnär..nn.1
  ordkonstruktion_1_N = mkN "ordkonstruktion" ; -- ordkonstruktion..nn.1
  ordkrig_1_N = mkN "ordkrig" neutrum  ; -- ordkrig..nn.1
  ordlek_1_N = mkN "ordlek" ; -- ordlek..nn.1
  ordlista_1_N = mkN "ordlista" ; -- ordlista..nn.1
  ordlängd_1_N = mkN "ordlängd" "ordlängder" ; -- ordlängd..nn.1
  ordlös_1_A = mkA "ordlös" ; -- ordlös..av.1
  ordlöshet_1_N = mkN "ordlöshet" ; -- ordlöshet..nn.1
  ordmakare_1_N = mkN "ordmakare" utrum  ; -- ordmakare..nn.1
  ordna_1_V = mkV "ordnar" ; -- ordna..vb.1
  ordnande_1_N = mkN "ordnande" ; -- ordnande..nn.1
  ordnare_1_N = mkN "ordnare" utrum  ; -- ordnare..nn.1
  ordning_1_N = mkN "ordning" ; -- ordning..nn.1
  ordningsam_1_A = mkA "ordningsam" "ordningsamt" "ordningsamma" "ordningsamma" "ordningsammare" "ordningsammast" "ordningsammaste" ; -- ordningsam..av.1
  ordningsamhet_1_N = mkN "ordningsamhet" ; -- ordningsamhet..nn.1
  ordningsbestämmelse_1_N = mkN "ordningsbestämmelse" "ordningsbestämmelser" ; -- ordningsbestämmelse..nn.1
  ordningsbot_1_N = mkN "ordningsbot" ; -- ordningsbot..nn.1
  ordningsfråga_1_N = mkN "ordningsfråga" ; -- ordningsfråga..nn.1
  ordningsföljd_1_N = mkN "ordningsföljd" "ordningsföljder" ; -- ordningsföljd..nn.1
  ordningsföreskrift_1_N = mkN "ordningsföreskrift" "ordningsföreskrifter" ; -- ordningsföreskrift..nn.1
  ordningsförseelse_1_N = mkN "ordningsförseelse" "ordningsförseelser" ; -- ordningsförseelse..nn.1
  ordningsmakt_1_N = mkN "ordningsmakt" ; -- ordningsmakt..nn.1
  ordningsman_1_N = mkN "ordningsman" "ordningsmannen" "ordningsmän" "ordningsmännen" ; -- ordningsman..nn.1
  ordningsmani_1_N = mkN "ordningsmani" ; -- ordningsmani..nn.1
  ordningsmänniska_1_N = mkN "ordningsmänniska" ; -- ordningsmänniska..nn.1
  ordningsnummer_1_N = mkN "ordningsnummer" neutrum  ; -- ordningsnummer..nn.1
  ordningspolis_1_N = mkN "ordningspolis" ; -- ordningspolis..nn.1
  ordningspolis_2_N = mkN "ordningspolis" "ordningspoliser" ; -- ordningspolis..nn.2
  ordningsprincip_1_N = mkN "ordningsprincip" "ordningsprinciper" ; -- ordningsprincip..nn.1
  ordningsregel_1_N = mkN "ordningsregel" "ordningsregeln" "ordningsregler" "ordningsreglerna" ; -- ordningsregel..nn.1
  ordningssinne_1_N = mkN "ordningssinne" ; -- ordningssinne..nn.1
  ordningsstadga_1_N = mkN "ordningsstadga" ; -- ordningsstadga..nn.1
  ordningsstadgande_1_N = mkN "ordningsstadgande" ; -- ordningsstadgande..nn.1
  ordningstal_1_N = mkN "ordningstal" neutrum  ; -- ordningstal..nn.1
  ordningsvakt_1_N = mkN "ordningsvakt" "ordningsvakter" ; -- ordningsvakt..nn.1
  ordnät_1_N = mkN "ordnät" neutrum  ; -- ordnät..nn.1
  ordonnans_1_N = mkN "ordonnans" "ordonnanser" ; -- ordonnans..nn.1
  ordovicium_1_N = mkN "ordovicium" ; -- ordovicium..nn.1
  ordrik_1_A = mkA "ordrik" ; -- ordrik..av.1
  ordrikedom_1_N = mkN "ordrikedom" ; -- ordrikedom..nn.1
  ordrikhet_1_N = mkN "ordrikhet" ; -- ordrikhet..nn.1
  ordros_1_N = mkN "ordros" "ordrosor" ; -- ordros..nn.1
  ordrot_1_N = mkN "ordrot" "ordrötter" ; -- ordrot..nn.1
  ordryttare_1_N = mkN "ordryttare" utrum  ; -- ordryttare..nn.1
  ordrytteri_1_N = mkN "ordrytteri" "ordrytteriet" "ordrytterier" "ordrytterierna" ; -- ordrytteri..nn.1
  ordrätt_1_A = mkA "ordrätt" ; -- ordrätt..av.1
  ordsallad_1_N = mkN "ordsallad" ; -- ordsallad..nn.1
  ordsemantik_1_N = mkN "ordsemantik" ; -- ordsemantik..nn.1
  ordskatt_1_N = mkN "ordskatt" "ordskatter" ; -- ordskatt..nn.1
  ordskifte_1_N = mkN "ordskifte" ; -- ordskifte..nn.1
  ordskillnad_1_N = mkN "ordskillnad" "ordskillnader" ; -- ordskillnad..nn.1
  ordskrift_1_N = mkN "ordskrift" "ordskrifter" ; -- ordskrift..nn.1
  ordslut_1_N = mkN "ordslut" neutrum  ; -- ordslut..nn.1
  ordspel_1_N = mkN "ordspel" "ordspelet" "ordspel" "ordspelen" ; -- ordspel..nn.1
  ordspråk_1_N = mkN "ordspråk" neutrum  ; -- ordspråk..nn.1
  ordspråksmässig_1_A = mkA "ordspråksmässig" ; -- ordspråksmässig..av.1
  ordstam_1_N = mkN "ordstam" "ordstammen" "ordstammar" "ordstammarna" ; -- ordstam..nn.1
  ordstrid_1_N = mkN "ordstrid" "ordstrider" ; -- ordstrid..nn.1
  ordström_1_N = mkN "ordström" "ordströmmen" "ordströmmar" "ordströmmarna" ; -- ordström..nn.1
  ordstum_1_A = mkA "ordstum" "ordstumt" "ordstumma" "ordstumma" "ordstummare" "ordstummast" "ordstummaste" ; -- ordstum..av.1
  ordstumhet_1_N = mkN "ordstumhet" ; -- ordstumhet..nn.1
  ordstäv_1_N = mkN "ordstäv" neutrum  ; -- ordstäv..nn.1
  ordsvall_1_N = mkN "ordsvall" neutrum  ; -- ordsvall..nn.1
  ordtrogen_1_A = mkA "ordtrogen" ; -- ordtrogen..av.1
  ordtvist_1_N = mkN "ordtvist" "ordtvister" ; -- ordtvist..nn.1
  ordval_1_N = mkN "ordval" neutrum  ; -- ordval..nn.1
  ordvirvel_1_N = mkN "ordvirvel" ; -- ordvirvel..nn.1
  ordvits_1_N = mkN "ordvits" ; -- ordvits..nn.1
  ordvrängare_1_N = mkN "ordvrängare" utrum  ; -- ordvrängare..nn.1
  ordvrängeri_1_N = mkN "ordvrängeri" "ordvrängeriet" "ordvrängerier" "ordvrängerierna" ; -- ordvrängeri..nn.1
  ordvrängning_1_N = mkN "ordvrängning" ; -- ordvrängning..nn.1
  ordvändning_1_N = mkN "ordvändning" ; -- ordvändning..nn.1
  ordväxling_1_N = mkN "ordväxling" ; -- ordväxling..nn.1
  oread_1_N = mkN "oread" "oreader" ; -- oread..nn.1
  oreaktiverad_1_A = mkA "oreaktiverad" ; -- oreaktiverad..av.1
  oreaktiverbar_1_A = mkA "oreaktiverbar" ; -- oreaktiverbar..av.1
  oreaktiverbarhet_1_N = mkN "oreaktiverbarhet" ; -- oreaktiverbarhet..nn.1
  orealiserad_1_A = mkA "orealiserad" ; -- orealiserad..av.1
  orealiserbar_1_A = mkA "orealiserbar" ; -- orealiserbar..av.1
  orealiserbarhet_1_N = mkN "orealiserbarhet" ; -- orealiserbarhet..nn.1
  orealistisk_1_A = mkA "orealistisk" ; -- orealistisk..av.1
  oreassurerad_1_A = mkA "oreassurerad" ; -- oreassurerad..av.1
  oreassurerbar_1_A = mkA "oreassurerbar" ; -- oreassurerbar..av.1
  oreassurerbarhet_1_N = mkN "oreassurerbarhet" ; -- oreassurerbarhet..nn.1
  orecenserad_1_A = mkA "orecenserad" ; -- orecenserad..av.1
  orecenserbar_1_A = mkA "orecenserbar" ; -- orecenserbar..av.1
  orecenserbarhet_1_N = mkN "orecenserbarhet" ; -- orecenserbarhet..nn.1
  orecipierad_1_A = mkA "orecipierad" ; -- orecipierad..av.1
  orecipierbar_1_A = mkA "orecipierbar" ; -- orecipierbar..av.1
  orecipierbarhet_1_N = mkN "orecipierbarhet" ; -- orecipierbarhet..nn.1
  oreciterad_1_A = mkA "oreciterad" ; -- oreciterad..av.1
  oreciterbar_1_A = mkA "oreciterbar" ; -- oreciterbar..av.1
  oreciterbarhet_1_N = mkN "oreciterbarhet" ; -- oreciterbarhet..nn.1
  oreda_1_N = mkN "oreda" ; -- oreda..nn.1
  oreda_1_V = mkV "oredar" ; -- oreda..vb.1
  oredande_1_N = mkN "oredande" ; -- oredande..nn.1
  oredig_1_A = mkA "oredig" ; -- oredig..av.1
  oredigerad_1_A = mkA "oredigerad" ; -- oredigerad..av.1
  oredigerbar_1_A = mkA "oredigerbar" ; -- oredigerbar..av.1
  oredigerbarhet_1_N = mkN "oredigerbarhet" ; -- oredigerbarhet..nn.1
  oredighet_1_N = mkN "oredighet" ; -- oredighet..nn.1
  oredlig_1_A = mkA "oredlig" ; -- oredlig..av.1
  oredlighet_1_N = mkN "oredlighet" "oredligheter" ; -- oredlighet..nn.1
  oredovisad_1_A = mkA "oredovisad" ; -- oredovisad..av.1
  oredubblad_1_A = mkA "oredubblad" ; -- oredubblad..av.1
  oreducerad_1_A = mkA "oreducerad" ; -- oreducerad..av.1
  oreducerbar_1_A = mkA "oreducerbar" ; -- oreducerbar..av.1
  oreducerbarhet_1_N = mkN "oreducerbarhet" ; -- oreducerbarhet..nn.1
  orefererad_1_A = mkA "orefererad" ; -- orefererad..av.1
  orefererbar_1_A = mkA "orefererbar" ; -- orefererbar..av.1
  orefererbarhet_1_N = mkN "orefererbarhet" ; -- orefererbarhet..nn.1
  oreflekterad_1_A = mkA "oreflekterad" ; -- oreflekterad..av.1
  oreflekterbar_1_A = mkA "oreflekterbar" ; -- oreflekterbar..av.1
  oreflekterbarhet_1_N = mkN "oreflekterbarhet" ; -- oreflekterbarhet..nn.1
  oreformerad_1_A = mkA "oreformerad" ; -- oreformerad..av.1
  oreformerbar_1_A = mkA "oreformerbar" ; -- oreformerbar..av.1
  oreformerbarhet_1_N = mkN "oreformerbarhet" ; -- oreformerbarhet..nn.1
  orefuserad_1_A = mkA "orefuserad" ; -- orefuserad..av.1
  orefuserbar_1_A = mkA "orefuserbar" ; -- orefuserbar..av.1
  orefuserbarhet_1_N = mkN "orefuserbarhet" ; -- orefuserbarhet..nn.1
  oregalerad_1_A = mkA "oregalerad" ; -- oregalerad..av.1
  oregalerbar_1_A = mkA "oregalerbar" ; -- oregalerbar..av.1
  oregalerbarhet_1_N = mkN "oregalerbarhet" ; -- oregalerbarhet..nn.1
  oregano_1_N = mkN "oregano" ; -- oregano..nn.1
  oregelbunden_1_A = mkA "oregelbunden" ; -- oregelbunden..av.1
  oregelbundenhet_1_N = mkN "oregelbundenhet" "oregelbundenheter" ; -- oregelbundenhet..nn.1
  oregelmässig_1_A = mkA "oregelmässig" ; -- oregelmässig..av.1
  oregelmässighet_1_N = mkN "oregelmässighet" "oregelmässigheter" ; -- oregelmässighet..nn.1
  oregenererad_1_A = mkA "oregenererad" ; -- oregenererad..av.1
  oregenererbar_1_A = mkA "oregenererbar" ; -- oregenererbar..av.1
  oregenererbarhet_1_N = mkN "oregenererbarhet" ; -- oregenererbarhet..nn.1
  oregerad_1_A = mkA "oregerad" ; -- oregerad..av.1
  oregerbar_1_A = mkA "oregerbar" ; -- oregerbar..av.1
  oregerbarhet_1_N = mkN "oregerbarhet" ; -- oregerbarhet..nn.1
  oregerlig_1_A = mkA "oregerlig" ; -- oregerlig..av.1
  oregerlighet_1_N = mkN "oregerlighet" ; -- oregerlighet..nn.1
  oregisserad_1_A = mkA "oregisserad" ; -- oregisserad..av.1
  oregisserbar_1_A = mkA "oregisserbar" ; -- oregisserbar..av.1
  oregisserbarhet_1_N = mkN "oregisserbarhet" ; -- oregisserbarhet..nn.1
  oregistrerad_1_A = mkA "oregistrerad" ; -- oregistrerad..av.1
  oregistrerbar_1_A = mkA "oregistrerbar" ; -- oregistrerbar..av.1
  oregistrerbarhet_1_N = mkN "oregistrerbarhet" ; -- oregistrerbarhet..nn.1
  oreglad_1_A = mkA "oreglad" ; -- oreglad..av.1
  oreglementerad_1_A = mkA "oreglementerad" ; -- oreglementerad..av.1
  oreglementerbar_1_A = mkA "oreglementerbar" ; -- oreglementerbar..av.1
  oreglementerbarhet_1_N = mkN "oreglementerbarhet" ; -- oreglementerbarhet..nn.1
  oreglerad_1_A = mkA "oreglerad" ; -- oreglerad..av.1
  oreglerbar_1_A = mkA "oreglerbar" ; -- oreglerbar..av.1
  oreglerbarhet_1_N = mkN "oreglerbarhet" ; -- oreglerbarhet..nn.1
  oregummerad_1_A = mkA "oregummerad" ; -- oregummerad..av.1
  oregummerbar_1_A = mkA "oregummerbar" ; -- oregummerbar..av.1
  oregummerbarhet_1_N = mkN "oregummerbarhet" ; -- oregummerbarhet..nn.1
  orehabiliterad_1_A = mkA "orehabiliterad" ; -- orehabiliterad..av.1
  orehabiliterbar_1_A = mkA "orehabiliterbar" ; -- orehabiliterbar..av.1
  orehabiliterbarhet_1_N = mkN "orehabiliterbarhet" ; -- orehabiliterbarhet..nn.1
  oreinkarnerad_1_A = mkA "oreinkarnerad" ; -- oreinkarnerad..av.1
  oreinkarnerbar_1_A = mkA "oreinkarnerbar" ; -- oreinkarnerbar..av.1
  oreinkarnerbarhet_1_N = mkN "oreinkarnerbarhet" ; -- oreinkarnerbarhet..nn.1
  orekad_1_A = mkA "orekad" ; -- orekad..av.1
  orekapitulerad_1_A = mkA "orekapitulerad" ; -- orekapitulerad..av.1
  orekapitulerbar_1_A = mkA "orekapitulerbar" ; -- orekapitulerbar..av.1
  orekapitulerbarhet_1_N = mkN "orekapitulerbarhet" ; -- orekapitulerbarhet..nn.1
  oreklamerad_1_A = mkA "oreklamerad" ; -- oreklamerad..av.1
  oreklamerbar_1_A = mkA "oreklamerbar" ; -- oreklamerbar..av.1
  oreklamerbarhet_1_N = mkN "oreklamerbarhet" ; -- oreklamerbarhet..nn.1
  orekognoscerad_1_A = mkA "orekognoscerad" ; -- orekognoscerad..av.1
  orekognoscerbar_1_A = mkA "orekognoscerbar" ; -- orekognoscerbar..av.1
  orekognoscerbarhet_1_N = mkN "orekognoscerbarhet" ; -- orekognoscerbarhet..nn.1
  orekognoserad_1_A = mkA "orekognoserad" ; -- orekognoserad..av.1
  orekognoserbar_1_A = mkA "orekognoserbar" ; -- orekognoserbar..av.1
  orekognoserbarhet_1_N = mkN "orekognoserbarhet" ; -- orekognoserbarhet..nn.1
  orekommenderad_1_A = mkA "orekommenderad" ; -- orekommenderad..av.1
  orekommenderbar_1_A = mkA "orekommenderbar" ; -- orekommenderbar..av.1
  orekommenderbarhet_1_N = mkN "orekommenderbarhet" ; -- orekommenderbarhet..nn.1
  orekompenserad_1_A = mkA "orekompenserad" ; -- orekompenserad..av.1
  orekompenserbar_1_A = mkA "orekompenserbar" ; -- orekompenserbar..av.1
  orekompenserbarhet_1_N = mkN "orekompenserbarhet" ; -- orekompenserbarhet..nn.1
  orekonstruerad_1_A = mkA "orekonstruerad" ; -- orekonstruerad..av.1
  orekonstruerbar_1_A = mkA "orekonstruerbar" ; -- orekonstruerbar..av.1
  orekonstruerbarhet_1_N = mkN "orekonstruerbarhet" ; -- orekonstruerbarhet..nn.1
  orekryterad_1_A = mkA "orekryterad" ; -- orekryterad..av.1
  orekryterbar_1_A = mkA "orekryterbar" ; -- orekryterbar..av.1
  orekryterbarhet_1_N = mkN "orekryterbarhet" ; -- orekryterbarhet..nn.1
  orektificerad_1_A = mkA "orektificerad" ; -- orektificerad..av.1
  orektificerbar_1_A = mkA "orektificerbar" ; -- orektificerbar..av.1
  orektificerbarhet_1_N = mkN "orektificerbarhet" ; -- orektificerbarhet..nn.1
  orektifierad_1_A = mkA "orektifierad" ; -- orektifierad..av.1
  orektifierbar_1_A = mkA "orektifierbar" ; -- orektifierbar..av.1
  orektifierbarhet_1_N = mkN "orektifierbarhet" ; -- orektifierbarhet..nn.1
  orekvirerad_1_A = mkA "orekvirerad" ; -- orekvirerad..av.1
  orekvirerbar_1_A = mkA "orekvirerbar" ; -- orekvirerbar..av.1
  orekvirerbarhet_1_N = mkN "orekvirerbarhet" ; -- orekvirerbarhet..nn.1
  orelaterad_1_A = mkA "orelaterad" ; -- orelaterad..av.1
  orelaterbar_1_A = mkA "orelaterbar" ; -- orelaterbar..av.1
  orelaterbarhet_1_N = mkN "orelaterbarhet" ; -- orelaterbarhet..nn.1
  orelativiserbar_1_A = mkA "orelativiserbar" ; -- orelativiserbar..av.1
  orelativiserbarhet_1_N = mkN "orelativiserbarhet" ; -- orelativiserbarhet..nn.1
  orelegerad_1_A = mkA "orelegerad" ; -- orelegerad..av.1
  orelegerbar_1_A = mkA "orelegerbar" ; -- orelegerbar..av.1
  orelegerbarhet_1_N = mkN "orelegerbarhet" ; -- orelegerbarhet..nn.1
  oreläad_1_A = mkA "oreläad" ; -- oreläad..av.1
  oremitterad_1_A = mkA "oremitterad" ; -- oremitterad..av.1
  oremitterbar_1_A = mkA "oremitterbar" ; -- oremitterbar..av.1
  oremitterbarhet_1_N = mkN "oremitterbarhet" ; -- oremitterbarhet..nn.1
  oremmad_1_A = mkA "oremmad" ; -- oremmad..av.1
  oremplacerad_1_A = mkA "oremplacerad" ; -- oremplacerad..av.1
  oremplacerbar_1_A = mkA "oremplacerbar" ; -- oremplacerbar..av.1
  oremplacerbarhet_1_N = mkN "oremplacerbarhet" ; -- oremplacerbarhet..nn.1
  oren_1_A = mkA "oren" ; -- oren..av.1
  orena_1_V = mkV "orenar" ; -- orena..vb.1
  orenad_1_A = mkA "orenad" ; -- orenad..av.1
  orenande_1_N = mkN "orenande" ; -- orenande..nn.1
  orenderad_1_A = mkA "orenderad" ; -- orenderad..av.1
  orenderbar_1_A = mkA "orenderbar" ; -- orenderbar..av.1
  orenderbarhet_1_N = mkN "orenderbarhet" ; -- orenderbarhet..nn.1
  orenhet_1_N = mkN "orenhet" "orenheter" ; -- orenhet..nn.1
  orenlig_1_A = mkA "orenlig" ; -- orenlig..av.1
  orenlighet_1_N = mkN "orenlighet" "orenligheter" ; -- orenlighet..nn.1
  orenoverad_1_A = mkA "orenoverad" ; -- orenoverad..av.1
  orenoverbar_1_A = mkA "orenoverbar" ; -- orenoverbar..av.1
  orenoverbarhet_1_N = mkN "orenoverbarhet" ; -- orenoverbarhet..nn.1
  orensad_1_A = mkA "orensad" ; -- orensad..av.1
  oreorganiserad_1_A = mkA "oreorganiserad" ; -- oreorganiserad..av.1
  oreorganiserbar_1_A = mkA "oreorganiserbar" ; -- oreorganiserbar..av.1
  oreorganiserbarhet_1_N = mkN "oreorganiserbarhet" ; -- oreorganiserbarhet..nn.1
  orepad_1_A = mkA "orepad" ; -- orepad..av.1
  oreparerad_1_A = mkA "oreparerad" ; -- oreparerad..av.1
  oreparerbar_1_A = mkA "oreparerbar" ; -- oreparerbar..av.1
  oreparerbarhet_1_N = mkN "oreparerbarhet" ; -- oreparerbarhet..nn.1
  orepartiserad_1_A = mkA "orepartiserad" ; -- orepartiserad..av.1
  orepartiserbar_1_A = mkA "orepartiserbar" ; -- orepartiserbar..av.1
  orepartiserbarhet_1_N = mkN "orepartiserbarhet" ; -- orepartiserbarhet..nn.1
  orepatrierad_1_A = mkA "orepatrierad" ; -- orepatrierad..av.1
  orepatrierbar_1_A = mkA "orepatrierbar" ; -- orepatrierbar..av.1
  orepatrierbarhet_1_N = mkN "orepatrierbarhet" ; -- orepatrierbarhet..nn.1
  orepellerad_1_A = mkA "orepellerad" ; -- orepellerad..av.1
  orepellerbar_1_A = mkA "orepellerbar" ; -- orepellerbar..av.1
  orepellerbarhet_1_N = mkN "orepellerbarhet" ; -- orepellerbarhet..nn.1
  orepeterad_1_A = mkA "orepeterad" ; -- orepeterad..av.1
  orepeterbar_1_A = mkA "orepeterbar" ; -- orepeterbar..av.1
  orepeterbarhet_1_N = mkN "orepeterbarhet" ; -- orepeterbarhet..nn.1
  orepresenterad_1_A = mkA "orepresenterad" ; -- orepresenterad..av.1
  orepresenterbar_1_A = mkA "orepresenterbar" ; -- orepresenterbar..av.1
  orepresenterbarhet_1_N = mkN "orepresenterbarhet" ; -- orepresenterbarhet..nn.1
  orepriserad_1_A = mkA "orepriserad" ; -- orepriserad..av.1
  orepriserbar_1_A = mkA "orepriserbar" ; -- orepriserbar..av.1
  orepriserbarhet_1_N = mkN "orepriserbarhet" ; -- orepriserbarhet..nn.1
  oreproducerad_1_A = mkA "oreproducerad" ; -- oreproducerad..av.1
  oreproducerbar_1_A = mkA "oreproducerbar" ; -- oreproducerbar..av.1
  oreproducerbarhet_1_N = mkN "oreproducerbarhet" ; -- oreproducerbarhet..nn.1
  orera_1_V = mkV "orerar" ; -- orera..vb.1
  orerande_1_N = mkN "orerande" ; -- orerande..nn.1
  orering_1_N = mkN "orering" ; -- orering..nn.1
  oreserverad_1_A = mkA "oreserverad" ; -- oreserverad..av.1
  oreserverbar_1_A = mkA "oreserverbar" ; -- oreserverbar..av.1
  oreserverbarhet_1_N = mkN "oreserverbarhet" ; -- oreserverbarhet..nn.1
  oresolverad_1_A = mkA "oresolverad" ; -- oresolverad..av.1
  oresolverbar_1_A = mkA "oresolverbar" ; -- oresolverbar..av.1
  oresolverbarhet_1_N = mkN "oresolverbarhet" ; -- oresolverbarhet..nn.1
  oresonabel_1_A = mkA "oresonabel" "oresonabelt" ; -- oresonabel..av.1
  oresonlig_1_A = mkA "oresonlig" ; -- oresonlig..av.1
  oresonlighet_1_N = mkN "oresonlighet" ; -- oresonlighet..nn.1
  oresorberad_1_A = mkA "oresorberad" ; -- oresorberad..av.1
  oresorberbar_1_A = mkA "oresorberbar" ; -- oresorberbar..av.1
  oresorberbarhet_1_N = mkN "oresorberbarhet" ; -- oresorberbarhet..nn.1
  orespekterad_1_A = mkA "orespekterad" ; -- orespekterad..av.1
  orespekterbar_1_A = mkA "orespekterbar" ; -- orespekterbar..av.1
  orespekterbarhet_1_N = mkN "orespekterbarhet" ; -- orespekterbarhet..nn.1
  orespirerad_1_A = mkA "orespirerad" ; -- orespirerad..av.1
  orespirerbar_1_A = mkA "orespirerbar" ; -- orespirerbar..av.1
  orespirerbarhet_1_N = mkN "orespirerbarhet" ; -- orespirerbarhet..nn.1
  orest_1_A = mkA "orest" "orest" ; -- orest..av.1
  orestaurerad_1_A = mkA "orestaurerad" ; -- orestaurerad..av.1
  orestaurerbar_1_A = mkA "orestaurerbar" ; -- orestaurerbar..av.1
  orestaurerbarhet_1_N = mkN "orestaurerbarhet" ; -- orestaurerbarhet..nn.1
  orestituerad_1_A = mkA "orestituerad" ; -- orestituerad..av.1
  orestituerbar_1_A = mkA "orestituerbar" ; -- orestituerbar..av.1
  orestituerbarhet_1_N = mkN "orestituerbarhet" ; -- orestituerbarhet..nn.1
  oresumerad_1_A = mkA "oresumerad" ; -- oresumerad..av.1
  oresumerbar_1_A = mkA "oresumerbar" ; -- oresumerbar..av.1
  oresumerbarhet_1_N = mkN "oresumerbarhet" ; -- oresumerbarhet..nn.1
  oretablerad_1_A = mkA "oretablerad" ; -- oretablerad..av.1
  oretablerbar_1_A = mkA "oretablerbar" ; -- oretablerbar..av.1
  oretablerbarhet_1_N = mkN "oretablerbarhet" ; -- oretablerbarhet..nn.1
  oretad_1_A = mkA "oretad" ; -- oretad..av.1
  oretarderad_1_A = mkA "oretarderad" ; -- oretarderad..av.1
  oretarderbar_1_A = mkA "oretarderbar" ; -- oretarderbar..av.1
  oretarderbarhet_1_N = mkN "oretarderbarhet" ; -- oretarderbarhet..nn.1
  oreturnerad_1_A = mkA "oreturnerad" ; -- oreturnerad..av.1
  oreturnerbar_1_A = mkA "oreturnerbar" ; -- oreturnerbar..av.1
  oreturnerbarhet_1_N = mkN "oreturnerbarhet" ; -- oreturnerbarhet..nn.1
  oretuscherad_1_A = mkA "oretuscherad" ; -- oretuscherad..av.1
  oretuscherbar_1_A = mkA "oretuscherbar" ; -- oretuscherbar..av.1
  oretuscherbarhet_1_N = mkN "oretuscherbarhet" ; -- oretuscherbarhet..nn.1
  orevad_1_A = mkA "orevad" ; -- orevad..av.1
  orevalverad_1_A = mkA "orevalverad" ; -- orevalverad..av.1
  orevalverbar_1_A = mkA "orevalverbar" ; -- orevalverbar..av.1
  orevalverbarhet_1_N = mkN "orevalverbarhet" ; -- orevalverbarhet..nn.1
  oreveterad_1_A = mkA "oreveterad" ; -- oreveterad..av.1
  oreveterbar_1_A = mkA "oreveterbar" ; -- oreveterbar..av.1
  oreveterbarhet_1_N = mkN "oreveterbarhet" ; -- oreveterbarhet..nn.1
  oreviderad_1_A = mkA "oreviderad" ; -- oreviderad..av.1
  oreviderbar_1_A = mkA "oreviderbar" ; -- oreviderbar..av.1
  oreviderbarhet_1_N = mkN "oreviderbarhet" ; -- oreviderbarhet..nn.1
  orevolutionerad_1_A = mkA "orevolutionerad" ; -- orevolutionerad..av.1
  orevolutionerbar_1_A = mkA "orevolutionerbar" ; -- orevolutionerbar..av.1
  orevolutionerbarhet_1_N = mkN "orevolutionerbarhet" ; -- orevolutionerbarhet..nn.1
  orficism_1_N = mkN "orficism" "orficismer" ; -- orficism..nn.1
  orfisk_1_A = mkA "orfisk" ; -- orfisk..av.1
  orfism_1_N = mkN "orfism" "orfismer" ; -- orfism..nn.1
  orfistisk_1_A = mkA "orfistisk" ; -- orfistisk..av.1
  organ_1_N = mkN "organ" neutrum  ; -- organ..nn.1
  organbrist_1_N = mkN "organbrist" ; -- organbrist..nn.1
  organcell_1_N = mkN "organcell" "organceller" ; -- organcell..nn.1
  organdi_1_N = mkN "organdi" ; -- organdi..nn.1
  organdonation_1_N = mkN "organdonation" ; -- organdonation..nn.1
  organdonationskort_1_N = mkN "organdonationskort" neutrum  ; -- organdonationskort..nn.1
  organell_1_N = mkN "organell" "organeller" ; -- organell..nn.1
  organisation_1_N = mkN "organisation" ; -- organisation..nn.1
  organisation_2_N = mkN "organisation" ; -- organisation..nn.2
  organisationsarbete_1_N = mkN "organisationsarbete" ; -- organisationsarbete..nn.1
  organisationsform_1_N = mkN "organisationsform" "organisationsformer" ; -- organisationsform..nn.1
  organisationskommitté_1_N = mkN "organisationskommitté" "organisationskommittéer" ; -- organisationskommitté..nn.1
  organisationsmässig_1_A = mkA "organisationsmässig" ; -- organisationsmässig..av.1
  organisationsstruktur_1_N = mkN "organisationsstruktur" "organisationsstrukturer" ; -- organisationsstruktur..nn.1
  organisatorisk_1_A = mkA "organisatorisk" ; -- organisatorisk..av.1
  organisatör_1_N = mkN "organisatör" "organisatörer" ; -- organisatör..nn.1
  organisera_1_V = mkV "organiserar" ; -- organisera..vb.1
  organiserad_1_A = mkA "organiserad" ; -- organiserad..av.1
  organiserande_1_N = mkN "organiserande" ; -- organiserande..nn.1
  organiserbar_1_A = mkA "organiserbar" ; -- organiserbar..av.1
  organiserbarhet_1_N = mkN "organiserbarhet" ; -- organiserbarhet..nn.1
  organisering_1_N = mkN "organisering" ; -- organisering..nn.1
  organisk_1_A = mkA "organisk" ; -- organisk..av.1
  organism_1_N = mkN "organism" "organismer" ; -- organism..nn.1
  organist_1_N = mkN "organist" "organister" ; -- organist..nn.1
  organogen_1_A = mkA "organogen" "organogent" ; -- organogen..av.1
  organum_1_N = mkN "organum" neutrum  ; -- organum..nn.1
  organza_1_N = mkN "organza" ; -- organza..nn.1
  orgasm_1_N = mkN "orgasm" "orgasmer" ; -- orgasm..nn.1
  orgastisk_1_A = mkA "orgastisk" ; -- orgastisk..av.1
  orgel_1_N = mkN "orgel" ; -- orgel..nn.1
  orgelharmonium_1_N = mkN "orgelharmonium" "orgelharmoniet" "orgelharmonier" "orgelharmonierna" ; -- orgelharmonium..nn.1
  orgelliknande_1_A = mkA "orgelliknande" ; -- orgelliknande..av.1
  orgelmusik_1_N = mkN "orgelmusik" ; -- orgelmusik..nn.1
  orgelmässig_1_A = mkA "orgelmässig" ; -- orgelmässig..av.1
  orgelpipa_1_N = mkN "orgelpipa" ; -- orgelpipa..nn.1
  orgelpreludium_1_N = mkN "orgelpreludium" "orgelpreludiet" "orgelpreludier" "orgelpreludierna" ; -- orgelpreludium..nn.1
  orgelpunkt_1_N = mkN "orgelpunkt" ; -- orgelpunkt..nn.1
  orgelregister_1_N = mkN "orgelregister" neutrum  ; -- orgelregister..nn.1
  orgelstycke_1_N = mkN "orgelstycke" ; -- orgelstycke..nn.1
  orgelstämma_1_N = mkN "orgelstämma" ; -- orgelstämma..nn.1
  orgeltrampare_1_N = mkN "orgeltrampare" utrum  ; -- orgeltrampare..nn.1
  orgiasm_1_N = mkN "orgiasm" ; -- orgiasm..nn.1
  orgiastisk_1_A = mkA "orgiastisk" ; -- orgiastisk..av.1
  orgie_1_N = mkN "orgie" "orgier" ; -- orgie..nn.1
  oriad_1_A = mkA "oriad" ; -- oriad..av.1
  oridderlig_1_A = mkA "oridderlig" ; -- oridderlig..av.1
  oridderlighet_1_N = mkN "oridderlighet" ; -- oridderlighet..nn.1
  orient_1_N = mkN "orient" ; -- orient..nn.1
  oriental_1_N = mkN "oriental" "orientaler" ; -- oriental..nn.1
  orientalisk_1_A = mkA "orientalisk" ; -- orientalisk..av.1
  orientalism_1_N = mkN "orientalism" "orientalismer" ; -- orientalism..nn.1
  orientalist_1_N = mkN "orientalist" "orientalister" ; -- orientalist..nn.1
  orientalistik_1_N = mkN "orientalistik" ; -- orientalistik..nn.1
  orientalistisk_1_A = mkA "orientalistisk" ; -- orientalistisk..av.1
  orientera_1_V = mkV "orienterar" ; -- orientera..vb.1
  orientera_2_V = mkV "orienterar" ; -- orientera..vb.2
  orienterande_1_N = mkN "orienterande" ; -- orienterande..nn.1
  orienterare_1_N = mkN "orienterare" utrum  ; -- orienterare..nn.1
  orienterbar_1_A = mkA "orienterbar" ; -- orienterbar..av.1
  orienterbarhet_1_N = mkN "orienterbarhet" ; -- orienterbarhet..nn.1
  orientering_1_N = mkN "orientering" ; -- orientering..nn.1
  orienteringslampa_1_N = mkN "orienteringslampa" ; -- orienteringslampa..nn.1
  orienteringslöpare_1_N = mkN "orienteringslöpare" utrum  ; -- orienteringslöpare..nn.1
  orienteringspunkt_1_N = mkN "orienteringspunkt" "orienteringspunkter" ; -- orienteringspunkt..nn.1
  orienteringstavla_1_N = mkN "orienteringstavla" ; -- orienteringstavla..nn.1
  orienteringstävling_1_N = mkN "orienteringstävling" ; -- orienteringstävling..nn.1
  orienteringsämne_1_N = mkN "orienteringsämne" ; -- orienteringsämne..nn.1
  origgad_1_A = mkA "origgad" ; -- origgad..av.1
  original_1_N = mkN "original" neutrum  ; -- original..nn.1
  originalbudget_1_N = mkN "originalbudget" ; -- originalbudget..nn.1
  originaldokument_1_N = mkN "originaldokument" neutrum  ; -- originaldokument..nn.1
  originalhandling_1_N = mkN "originalhandling" ; -- originalhandling..nn.1
  originalitet_1_N = mkN "originalitet" "originaliteter" ; -- originalitet..nn.1
  originalitetskrav_1_N = mkN "originalitetskrav" neutrum  ; -- originalitetskrav..nn.1
  originalmotor_1_N = mkN "originalmotor" "originalmotorer" ; -- originalmotor..nn.1
  originalskrift_1_N = mkN "originalskrift" "originalskrifter" ; -- originalskrift..nn.1
  originalspråk_1_N = mkN "originalspråk" neutrum  ; -- originalspråk..nn.1
  originaltext_1_N = mkN "originaltext" "originaltexter" ; -- originaltext..nn.1
  originalurkund_1_N = mkN "originalurkund" "originalurkunder" ; -- originalurkund..nn.1
  originell_1_A = mkA "originell" ; -- originell..av.1
  origlad_1_A = mkA "origlad" ; -- origlad..av.1
  origo_1_N = mkN "origo" ; -- origo..nn.1
  orikoschetterad_1_A = mkA "orikoschetterad" ; -- orikoschetterad..av.1
  oriktad_1_A = mkA "oriktad" ; -- oriktad..av.1
  oriktig_1_A = mkA "oriktig" ; -- oriktig..av.1
  oriktighet_1_N = mkN "oriktighet" "oriktigheter" ; -- oriktighet..nn.1
  orimlig_1_A = mkA "orimlig" ; -- orimlig..av.1
  orimlighet_1_N = mkN "orimlighet" "orimligheter" ; -- orimlighet..nn.1
  orimmad_1_A = mkA "orimmad" ; -- orimmad..av.1
  oringad_1_A = mkA "oringad" ; -- oringad..av.1
  oringd_1_A = mkA "oringd" "oringt" ; -- oringd..av.1
  orisad_1_A = mkA "orisad" ; -- orisad..av.1
  orispad_1_A = mkA "orispad" ; -- orispad..av.1
  orisslad_1_A = mkA "orisslad" ; -- orisslad..av.1
  oristad_1_A = mkA "oristad" ; -- oristad..av.1
  oritad_1_A = mkA "oritad" ; -- oritad..av.1
  oritsad_1_A = mkA "oritsad" ; -- oritsad..av.1
  oritualiserad_1_A = mkA "oritualiserad" ; -- oritualiserad..av.1
  oritualiserbar_1_A = mkA "oritualiserbar" ; -- oritualiserbar..av.1
  oritualiserbarhet_1_N = mkN "oritualiserbarhet" ; -- oritualiserbarhet..nn.1
  ork_1_N = mkN "ork" ; -- ork..nn.1
  orka_1_V = mkV "orkar" ; -- orka..vb.1
  orkan_1_N = mkN "orkan" "orkaner" ; -- orkan..nn.1
  orkanartad_1_A = mkA "orkanartad" ; -- orkanartad..av.1
  orkande_1_N = mkN "orkande" ; -- orkande..nn.1
  orkanlik_1_A = mkA "orkanlik" ; -- orkanlik..av.1
  orkanstyrka_1_N = mkN "orkanstyrka" ; -- orkanstyrka..nn.1
  orkeslös_1_A = mkA "orkeslös" ; -- orkeslös..av.1
  orkeslöshet_1_N = mkN "orkeslöshet" ; -- orkeslöshet..nn.1
  orkester_1_N = mkN "orkester" ; -- orkester..nn.1
  orkesterdike_1_N = mkN "orkesterdike" ; -- orkesterdike..nn.1
  orkesterförening_1_N = mkN "orkesterförening" ; -- orkesterförening..nn.1
  orkesterledare_1_N = mkN "orkesterledare" utrum  ; -- orkesterledare..nn.1
  orkestermedlem_1_N = mkN "orkestermedlem" "orkestermedlemmen" "orkestermedlemmar" "orkestermedlemmarna" ; -- orkestermedlem..nn.1
  orkestermusik_1_N = mkN "orkestermusik" ; -- orkestermusik..nn.1
  orkesterplats_1_N = mkN "orkesterplats" "orkesterplatser" ; -- orkesterplats..nn.1
  orkesterstycke_1_N = mkN "orkesterstycke" ; -- orkesterstycke..nn.1
  orkestik_1_N = mkN "orkestik" ; -- orkestik..nn.1
  orkestra_1_N = mkN "orkestra" ; -- orkestra..nn.1
  orkestral_1_A = mkA "orkestral" ; -- orkestral..av.1
  orkestrera_1_V = mkV "orkestrerar" ; -- orkestrera..vb.1
  orkestrerande_1_N = mkN "orkestrerande" ; -- orkestrerande..nn.1
  orkestrerbar_1_A = mkA "orkestrerbar" ; -- orkestrerbar..av.1
  orkestrerbarhet_1_N = mkN "orkestrerbarhet" ; -- orkestrerbarhet..nn.1
  orkestrering_1_N = mkN "orkestrering" ; -- orkestrering..nn.1
  orkidé_1_N = mkN "orkidé" "orkidéer" ; -- orkidé..nn.1
  orkidéväxt_1_N = mkN "orkidéväxt" "orkidéväxter" ; -- orkidéväxt..nn.1
  orklös_1_A = mkA "orklös" ; -- orklös..av.1
  orklöshet_1_N = mkN "orklöshet" ; -- orklöshet..nn.1
  orlov_1_N = mkN "orlov" neutrum  ; -- orlov..nn.1
  orlovssedel_1_N = mkN "orlovssedel" ; -- orlovssedel..nn.1
  orm_1_N = mkN "orm" ; -- orm..nn.1
  orma_1_V = mkV "ormar" ; -- orma..vb.1
  ormande_1_N = mkN "ormande" ; -- ormande..nn.1
  ormbett_1_N = mkN "ormbett" neutrum  ; -- ormbett..nn.1
  ormbiten_1_A = mkA "ormbiten" ; -- ormbiten..av.1
  ormblåsa_1_N = mkN "ormblåsa" ; -- ormblåsa..nn.1
  ormbo_1_N = mkN "ormbo" "ormboet" "ormbon" "ormbona" ; -- ormbo..nn.1
  ormbunke_1_N = mkN "ormbunke" utrum  ; -- ormbunke..nn.1
  ormbunksväxt_1_N = mkN "ormbunksväxt" "ormbunksväxter" ; -- ormbunksväxt..nn.1
  ormbär_1_N = mkN "ormbär" neutrum  ; -- ormbär..nn.1
  ormdödare_1_N = mkN "ormdödare" utrum  ; -- ormdödare..nn.1
  ormetter_1_N = mkN "ormetter" neutrum  ; -- ormetter..nn.1
  ormgift_1_N = mkN "ormgift" "ormgiftet" "ormgifter" "ormgifterna" ; -- ormgift..nn.1
  ormgran_1_N = mkN "ormgran" ; -- ormgran..nn.1
  ormgrop_1_N = mkN "ormgrop" ; -- ormgrop..nn.1
  ormhår_1_N = mkN "ormhår" neutrum  ; -- ormhår..nn.1
  ormknut_1_N = mkN "ormknut" ; -- ormknut..nn.1
  ormlik_1_A = mkA "ormlik" ; -- ormlik..av.1
  ormliknande_1_A = mkA "ormliknande" ; -- ormliknande..av.1
  ormmänniska_1_N = mkN "ormmänniska" ; -- ormmänniska..nn.1
  ormolja_1_N = mkN "ormolja" ; -- ormolja..nn.1
  ormrot_1_N = mkN "ormrot" ; -- ormrot..nn.1
  ormserum_1_N = mkN "ormserum" neutrum  ; -- ormserum..nn.1
  ormskinn_1_N = mkN "ormskinn" neutrum  ; -- ormskinn..nn.1
  ormslinga_1_N = mkN "ormslinga" ; -- ormslinga..nn.1
  ormslå_1_N = mkN "ormslå" "ormslån" "ormslår" "ormslårna" ; -- ormslå..nn.1
  ormspott_1_N = mkN "ormspott" neutrum  ; -- ormspott..nn.1
  ormstjärna_1_N = mkN "ormstjärna" ; -- ormstjärna..nn.1
  ormtjusare_1_N = mkN "ormtjusare" utrum  ; -- ormtjusare..nn.1
  ormtunga_1_N = mkN "ormtunga" ; -- ormtunga..nn.1
  ormvråk_1_N = mkN "ormvråk" ; -- ormvråk..nn.1
  ormyngel_1_N = mkN "ormyngel" neutrum  ; -- ormyngel..nn.1
  ormörn_1_N = mkN "ormörn" ; -- ormörn..nn.1
  ornament_1_N = mkN "ornament" neutrum  ; -- ornament..nn.1
  ornamental_1_A = mkA "ornamental" ; -- ornamental..av.1
  ornamentera_1_V = mkV "ornamenterar" ; -- ornamentera..vb.1
  ornamenterande_1_N = mkN "ornamenterande" ; -- ornamenterande..nn.1
  ornamenterbar_1_A = mkA "ornamenterbar" ; -- ornamenterbar..av.1
  ornamenterbarhet_1_N = mkN "ornamenterbarhet" ; -- ornamenterbarhet..nn.1
  ornamentering_1_N = mkN "ornamentering" ; -- ornamentering..nn.1
  ornamentik_1_N = mkN "ornamentik" ; -- ornamentik..nn.1
  ornamentist_1_N = mkN "ornamentist" "ornamentister" ; -- ornamentist..nn.1
  ornat_1_N = mkN "ornat" "ornater" ; -- ornat..nn.1
  orne_1_N = mkN "orne" utrum  ; -- orne..nn.1
  ornera_1_V = mkV "ornerar" ; -- ornera..vb.1
  ornerande_1_N = mkN "ornerande" ; -- ornerande..nn.1
  ornerbar_1_A = mkA "ornerbar" ; -- ornerbar..av.1
  ornerbarhet_1_N = mkN "ornerbarhet" ; -- ornerbarhet..nn.1
  ornering_1_N = mkN "ornering" ; -- ornering..nn.1
  ornitolog_1_N = mkN "ornitolog" "ornitologer" ; -- ornitolog..nn.1
  ornitologi_1_N = mkN "ornitologi" ; -- ornitologi..nn.1
  ornitologisk_1_A = mkA "ornitologisk" ; -- ornitologisk..av.1
  ornäsbjörk_1_N = mkN "ornäsbjörk" ; -- ornäsbjörk..nn.1
  oro_1_N = mkN "oro" ; -- oro..nn.1
  oro_2_N = mkN "oro" ; -- oro..nn.2
  oroa_1_V = mkV "oroar" ; -- oroa..vb.1
  oroande_1_A = mkA "oroande" ; -- oroande..av.1
  oroande_1_N = mkN "oroande" ; -- oroande..nn.1
  orobotiserad_1_A = mkA "orobotiserad" ; -- orobotiserad..av.1
  orobotiserbar_1_A = mkA "orobotiserbar" ; -- orobotiserbar..av.1
  orobotiserbarhet_1_N = mkN "orobotiserbarhet" ; -- orobotiserbarhet..nn.1
  orockerad_1_A = mkA "orockerad" ; -- orockerad..av.1
  orockerbar_1_A = mkA "orockerbar" ; -- orockerbar..av.1
  orockerbarhet_1_N = mkN "orockerbarhet" ; -- orockerbarhet..nn.1
  oroffad_1_A = mkA "oroffad" ; -- oroffad..av.1
  orogenes_1_N = mkN "orogenes" ; -- orogenes..nn.1
  orogenetisk_1_A = mkA "orogenetisk" ; -- orogenetisk..av.1
  orografi_1_N = mkN "orografi" ; -- orografi..nn.1
  orolig_1_A = mkA "orolig" ; -- orolig..av.1
  orolighet_1_N = mkN "orolighet" "oroligheter" ; -- orolighet..nn.1
  orollad_1_A = mkA "orollad" ; -- orollad..av.1
  oromantiserad_1_A = mkA "oromantiserad" ; -- oromantiserad..av.1
  oromantiserbar_1_A = mkA "oromantiserbar" ; -- oromantiserbar..av.1
  oromantiserbarhet_1_N = mkN "oromantiserbarhet" ; -- oromantiserbarhet..nn.1
  orosad_1_A = mkA "orosad" ; -- orosad..av.1
  orosande_1_N = mkN "orosande" utrum  ; -- orosande..nn.1
  oroscentrum_1_N = mkN "oroscentrum" neutrum  ; -- oroscentrum..nn.1
  oroshärd_1_N = mkN "oroshärd" ; -- oroshärd..nn.1
  orosmoln_1_N = mkN "orosmoln" neutrum  ; -- orosmoln..nn.1
  orosmoment_1_N = mkN "orosmoment" neutrum  ; -- orosmoment..nn.1
  orosstiftare_1_N = mkN "orosstiftare" utrum  ; -- orosstiftare..nn.1
  orostad_1_A = mkA "orostad" ; -- orostad..av.1
  orosår_1_N = mkN "orosår" neutrum  ; -- orosår..nn.1
  oroterad_1_A = mkA "oroterad" ; -- oroterad..av.1
  oroterbar_1_A = mkA "oroterbar" ; -- oroterbar..av.1
  oroterbarhet_1_N = mkN "oroterbarhet" ; -- oroterbarhet..nn.1
  oroväckande_1_A = mkA "oroväckande" ; -- oroväckande..av.1
  orre_1_N = mkN "orre" utrum  ; -- orre..nn.1
  orrfågel_1_N = mkN "orrfågel" ; -- orrfågel..nn.1
  orrspel_1_N = mkN "orrspel" "orrspelet" "orrspel" "orrspelen" ; -- orrspel..nn.1
  orsak_1_N = mkN "orsak" "orsaker" ; -- orsak..nn.1
  orsaka_1_V = mkV "orsakar" ; -- orsaka..vb.1
  orsakande_1_N = mkN "orsakande" ; -- orsakande..nn.1
  orsaklig_1_A = mkA "orsaklig" ; -- orsaklig..av.1
  orsaklighet_1_N = mkN "orsaklighet" ; -- orsaklighet..nn.1
  orsaksadverbial_1_N = mkN "orsaksadverbial" neutrum  ; -- orsaksadverbial..nn.1
  orsaksbestämd_1_A = mkA "orsaksbestämd" "orsaksbestämt" ; -- orsaksbestämd..av.1
  orsaksbestämdhet_1_N = mkN "orsaksbestämdhet" ; -- orsaksbestämdhet..nn.1
  orsaksförhållande_1_N = mkN "orsaksförhållande" ; -- orsaksförhållande..nn.1
  orsakskategori_1_N = mkN "orsakskategori" "orsakskategorier" ; -- orsakskategori..nn.1
  orsakskedja_1_N = mkN "orsakskedja" ; -- orsakskedja..nn.1
  orsakskomplex_1_N = mkN "orsakskomplex" neutrum  ; -- orsakskomplex..nn.1
  orsakslös_1_A = mkA "orsakslös" ; -- orsakslös..av.1
  orsaksmässig_1_A = mkA "orsaksmässig" ; -- orsaksmässig..av.1
  orsaksmässighet_1_N = mkN "orsaksmässighet" ; -- orsaksmässighet..nn.1
  orsakssamband_1_N = mkN "orsakssamband" neutrum  ; -- orsakssamband..nn.1
  orsakssammanhang_1_N = mkN "orsakssammanhang" neutrum  ; -- orsakssammanhang..nn.1
  orselj_1_N = mkN "orselj" ; -- orselj..nn.1
  ort_1_N = mkN "ort" "orter" ; -- ort..nn.1
  ort_2_N = mkN "ort" ; -- ort..nn.2
  ort_3_N = mkN "ort" neutrum  ; -- ort..nn.3
  ortdrivare_1_N = mkN "ortdrivare" utrum  ; -- ortdrivare..nn.1
  ortikon_1_N = mkN "ortikon" "ortikoner" ; -- ortikon..nn.1
  ortlig_1_A = mkA "ortlig" ; -- ortlig..av.1
  ortlinje_1_N = mkN "ortlinje" "ortlinjer" ; -- ortlinje..nn.1
  ortnamn_1_N = mkN "ortnamn" neutrum  ; -- ortnamn..nn.1
  ortnamnsforskning_1_N = mkN "ortnamnsforskning" ; -- ortnamnsforskning..nn.1
  ortoceratit_1_N = mkN "ortoceratit" "ortoceratiter" ; -- ortoceratit..nn.1
  ortodonti_1_N = mkN "ortodonti" ; -- ortodonti..nn.1
  ortodox_1_A = mkA "ortodox" ; -- ortodox..av.1
  ortodoxhet_1_N = mkN "ortodoxhet" ; -- ortodoxhet..nn.1
  ortodoxi_1_N = mkN "ortodoxi" "ortodoxier" ; -- ortodoxi..nn.1
  ortodoxism_1_N = mkN "ortodoxism" "ortodoxismer" ; -- ortodoxism..nn.1
  ortodrom_1_N = mkN "ortodrom" "ortodromer" ; -- ortodrom..nn.1
  ortoepi_1_N = mkN "ortoepi" ; -- ortoepi..nn.1
  ortoepisk_1_A = mkA "ortoepisk" ; -- ortoepisk..av.1
  ortogonal_1_A = mkA "ortogonal" ; -- ortogonal..av.1
  ortografi_1_N = mkN "ortografi" "ortografier" ; -- ortografi..nn.1
  ortografisk_1_A = mkA "ortografisk" ; -- ortografisk..av.1
  ortoklas_1_N = mkN "ortoklas" ; -- ortoklas..nn.1
  ortokromatisk_1_A = mkA "ortokromatisk" ; -- ortokromatisk..av.1
  ortolan_1_N = mkN "ortolan" "ortolaner" ; -- ortolan..nn.1
  ortolansparv_1_N = mkN "ortolansparv" ; -- ortolansparv..nn.1
  ortoped_1_N = mkN "ortoped" "ortopeder" ; -- ortoped..nn.1
  ortopedi_1_N = mkN "ortopedi" ; -- ortopedi..nn.1
  ortopedisk_1_A = mkA "ortopedisk" ; -- ortopedisk..av.1
  ortoptist_1_N = mkN "ortoptist" "ortoptister" ; -- ortoptist..nn.1
  ortoptris_1_N = mkN "ortoptris" "ortoptriser" ; -- ortoptris..nn.1
  ortsavdrag_1_N = mkN "ortsavdrag" neutrum  ; -- ortsavdrag..nn.1
  ortsbo_1_N = mkN "ortsbo" "ortsbor" ; -- ortsbo..nn.1
  ortsgrupp_1_N = mkN "ortsgrupp" "ortsgrupper" ; -- ortsgrupp..nn.1
  ortstid_1_N = mkN "ortstid" "ortstider" ; -- ortstid..nn.1
  ortstillägg_1_N = mkN "ortstillägg" neutrum  ; -- ortstillägg..nn.1
  ortsula_1_N = mkN "ortsula" ; -- ortsula..nn.1
  orubbad_1_A = mkA "orubbad" ; -- orubbad..av.1
  orubblig_1_A = mkA "orubblig" ; -- orubblig..av.1
  orubblighet_1_N = mkN "orubblighet" ; -- orubblighet..nn.1
  orubricerad_1_A = mkA "orubricerad" ; -- orubricerad..av.1
  orubricerbar_1_A = mkA "orubricerbar" ; -- orubricerbar..av.1
  orubricerbarhet_1_N = mkN "orubricerbarhet" ; -- orubricerbarhet..nn.1
  oruckad_1_A = mkA "oruckad" ; -- oruckad..av.1
  oruggad_1_A = mkA "oruggad" ; -- oruggad..av.1
  oruinerad_1_A = mkA "oruinerad" ; -- oruinerad..av.1
  oruinerbar_1_A = mkA "oruinerbar" ; -- oruinerbar..av.1
  oruinerbarhet_1_N = mkN "oruinerbarhet" ; -- oruinerbarhet..nn.1
  orullad_1_A = mkA "orullad" ; -- orullad..av.1
  orund_1_A = mkA "orund" ; -- orund..av.1
  orundad_1_A = mkA "orundad" ; -- orundad..av.1
  orundhet_1_N = mkN "orundhet" ; -- orundhet..nn.1
  orunkad_1_A = mkA "orunkad" ; -- orunkad..av.1
  orusad_1_A = mkA "orusad" ; -- orusad..av.1
  oruskad_1_A = mkA "oruskad" ; -- oruskad..av.1
  orussificerad_1_A = mkA "orussificerad" ; -- orussificerad..av.1
  orussificerbar_1_A = mkA "orussificerbar" ; -- orussificerbar..av.1
  orussificerbarhet_1_N = mkN "orussificerbarhet" ; -- orussificerbarhet..nn.1
  orussifierad_1_A = mkA "orussifierad" ; -- orussifierad..av.1
  orussifierbar_1_A = mkA "orussifierbar" ; -- orussifierbar..av.1
  orussifierbarhet_1_N = mkN "orussifierbarhet" ; -- orussifierbarhet..nn.1
  orustad_1_A = mkA "orustad" ; -- orustad..av.1
  orutinerad_1_A = mkA "orutinerad" ; -- orutinerad..av.1
  oruvad_1_A = mkA "oruvad" ; -- oruvad..av.1
  orv_1_N = mkN "orv" neutrum  ; -- orv..nn.1
  orygglig_1_A = mkA "orygglig" ; -- orygglig..av.1
  orygglighet_1_N = mkN "orygglighet" ; -- orygglighet..nn.1
  oryktad_1_A = mkA "oryktad" ; -- oryktad..av.1
  orymd_1_A = mkA "orymd" "orymt" ; -- orymd..av.1
  orynkad_1_A = mkA "orynkad" ; -- orynkad..av.1
  orytmiserad_1_A = mkA "orytmiserad" ; -- orytmiserad..av.1
  orytmiserbar_1_A = mkA "orytmiserbar" ; -- orytmiserbar..av.1
  orytmiserbarhet_1_N = mkN "orytmiserbarhet" ; -- orytmiserbarhet..nn.1
  orytmisk_1_A = mkA "orytmisk" ; -- orytmisk..av.1
  oryx_1_N = mkN "oryx" "oryxer" ; -- oryx..nn.1
  oräckt_1_A = mkA "oräckt" "oräckt" ; -- oräckt..av.1
  orädd_1_A = mkA "orädd" ; -- orädd..av.1
  oräddad_1_A = mkA "oräddad" ; -- oräddad..av.1
  oräddhet_1_N = mkN "oräddhet" ; -- oräddhet..nn.1
  oräfflad_1_A = mkA "oräfflad" ; -- oräfflad..av.1
  oräfsad_1_A = mkA "oräfsad" ; -- oräfsad..av.1
  oräknad_1_A = mkA "oräknad" ; -- oräknad..av.1
  oräknelig_1_A = mkA "oräknelig" ; -- oräknelig..av.1
  oräknelighet_1_N = mkN "oräknelighet" ; -- oräknelighet..nn.1
  orämnad_1_A = mkA "orämnad" ; -- orämnad..av.1
  orätad_1_A = mkA "orätad" ; -- orätad..av.1
  orätt_1_A = mkA "orätt" ; -- orätt..av.1
  orätt_1_N = mkN "orätt" "orätter" ; -- orätt..nn.1
  orättad_1_A = mkA "orättad" ; -- orättad..av.1
  orättfärdig_1_A = mkA "orättfärdig" ; -- orättfärdig..av.1
  orättfärdigad_1_A = mkA "orättfärdigad" ; -- orättfärdigad..av.1
  orättfärdighet_1_N = mkN "orättfärdighet" "orättfärdigheter" ; -- orättfärdighet..nn.1
  orättfången_1_A = mkA "orättfången" ; -- orättfången..av.1
  orättmätig_1_A = mkA "orättmätig" ; -- orättmätig..av.1
  orättmätighet_1_N = mkN "orättmätighet" ; -- orättmätighet..nn.1
  orättrådig_1_A = mkA "orättrådig" ; -- orättrådig..av.1
  orättrådighet_1_N = mkN "orättrådighet" ; -- orättrådighet..nn.1
  orättvis_1_A = mkA "orättvis" ; -- orättvis..av.1
  orättvisa_1_N = mkN "orättvisa" ; -- orättvisa..nn.1
  orågad_1_A = mkA "orågad" ; -- orågad..av.1
  oråkad_1_A = mkA "oråkad" ; -- oråkad..av.1
  oråmad_1_A = mkA "oråmad" ; -- oråmad..av.1
  orånad_1_A = mkA "orånad" ; -- orånad..av.1
  oröjd_1_A = mkA "oröjd" "oröjt" ; -- oröjd..av.1
  orökt_1_A = mkA "orökt" "orökt" ; -- orökt..av.1
  orönt_1_A = mkA "orönt" "orönt" ; -- orönt..av.1
  oröntgad_1_A = mkA "oröntgad" ; -- oröntgad..av.1
  orörbar_1_A = mkA "orörbar" ; -- orörbar..av.1
  orörbarhet_1_N = mkN "orörbarhet" ; -- orörbarhet..nn.1
  orörd_1_A = mkA "orörd" "orört" ; -- orörd..av.1
  orördhet_1_N = mkN "orördhet" ; -- orördhet..nn.1
  orörlig_1_A = mkA "orörlig" ; -- orörlig..av.1
  orörlighet_1_N = mkN "orörlighet" ; -- orörlighet..nn.1
  orösad_1_A = mkA "orösad" ; -- orösad..av.1
  orövad_1_A = mkA "orövad" ; -- orövad..av.1
  os_1_N = mkN "os" neutrum  ; -- os..nn.1
  os_2_N = mkN "os" neutrum  ; -- os..nn.2
  osa_1_V = mkV "osar" ; -- osa..vb.1
  osabbad_1_A = mkA "osabbad" ; -- osabbad..av.1
  osaboterad_1_A = mkA "osaboterad" ; -- osaboterad..av.1
  osaboterbar_1_A = mkA "osaboterbar" ; -- osaboterbar..av.1
  osaboterbarhet_1_N = mkN "osaboterbarhet" ; -- osaboterbarhet..nn.1
  osabrerad_1_A = mkA "osabrerad" ; -- osabrerad..av.1
  osabrerbar_1_A = mkA "osabrerbar" ; -- osabrerbar..av.1
  osabrerbarhet_1_N = mkN "osabrerbarhet" ; -- osabrerbarhet..nn.1
  osadlad_1_A = mkA "osadlad" ; -- osadlad..av.1
  osaftad_1_A = mkA "osaftad" ; -- osaftad..av.1
  osagd_1_A = mkA "osagd" "osagt" ; -- osagd..av.1
  osakad_1_A = mkA "osakad" ; -- osakad..av.1
  osakkunnig_1_A = mkA "osakkunnig" ; -- osakkunnig..av.1
  osakkunnighet_1_N = mkN "osakkunnighet" ; -- osakkunnighet..nn.1
  osaklig_1_A = mkA "osaklig" ; -- osaklig..av.1
  osaklighet_1_N = mkN "osaklighet" "osakligheter" ; -- osaklighet..nn.1
  osaknad_1_A = mkA "osaknad" ; -- osaknad..av.1
  osaktad_1_A = mkA "osaktad" ; -- osaktad..av.1
  osalad_1_A = mkA "osalad" ; -- osalad..av.1
  osalderad_1_A = mkA "osalderad" ; -- osalderad..av.1
  osalderbar_1_A = mkA "osalderbar" ; -- osalderbar..av.1
  osalderbarhet_1_N = mkN "osalderbarhet" ; -- osalderbarhet..nn.1
  osalig_1_A = mkA "osalig" ; -- osalig..av.1
  osalighet_1_N = mkN "osalighet" ; -- osalighet..nn.1
  osaltad_1_A = mkA "osaltad" ; -- osaltad..av.1
  osaluterad_1_A = mkA "osaluterad" ; -- osaluterad..av.1
  osaluterbar_1_A = mkA "osaluterbar" ; -- osaluterbar..av.1
  osaluterbarhet_1_N = mkN "osaluterbarhet" ; -- osaluterbarhet..nn.1
  osambeskattad_1_A = mkA "osambeskattad" ; -- osambeskattad..av.1
  osamkad_1_A = mkA "osamkad" ; -- osamkad..av.1
  osamkörd_1_A = mkA "osamkörd" "osamkört" ; -- osamkörd..av.1
  osamlad_1_A = mkA "osamlad" ; -- osamlad..av.1
  osammanblandad_1_A = mkA "osammanblandad" ; -- osammanblandad..av.1
  osammanfattad_1_A = mkA "osammanfattad" ; -- osammanfattad..av.1
  osammanflätad_1_A = mkA "osammanflätad" ; -- osammanflätad..av.1
  osammanfogad_1_A = mkA "osammanfogad" ; -- osammanfogad..av.1
  osammanförd_1_A = mkA "osammanförd" "osammanfört" ; -- osammanförd..av.1
  osammanhopad_1_A = mkA "osammanhopad" ; -- osammanhopad..av.1
  osammanhängande_1_A = mkA "osammanhängande" ; -- osammanhängande..av.1
  osammanjämkad_1_A = mkA "osammanjämkad" ; -- osammanjämkad..av.1
  osammankallad_1_A = mkA "osammankallad" ; -- osammankallad..av.1
  osammankopplad_1_A = mkA "osammankopplad" ; -- osammankopplad..av.1
  osammanlänkad_1_A = mkA "osammanlänkad" ; -- osammanlänkad..av.1
  osammanlöpt_1_A = mkA "osammanlöpt" "osammanlöpt" ; -- osammanlöpt..av.1
  osammanpackad_1_A = mkA "osammanpackad" ; -- osammanpackad..av.1
  osammanpressad_1_A = mkA "osammanpressad" ; -- osammanpressad..av.1
  osammanringd_1_A = mkA "osammanringd" "osammanringt" ; -- osammanringd..av.1
  osammanräknad_1_A = mkA "osammanräknad" ; -- osammanräknad..av.1
  osammansatt_1_A = mkA "osammansatt" ; -- osammansatt..av.1
  osammanstrålad_1_A = mkA "osammanstrålad" ; -- osammanstrålad..av.1
  osammanställd_1_A = mkA "osammanställd" "osammanställt" ; -- osammanställd..av.1
  osammanstött_1_A = mkA "osammanstött" ; -- osammanstött..av.1
  osammansvetsad_1_A = mkA "osammansvetsad" ; -- osammansvetsad..av.1
  osammantryckt_1_A = mkA "osammantryckt" "osammantryckt" ; -- osammantryckt..av.1
  osammanträffad_1_A = mkA "osammanträffad" ; -- osammanträffad..av.1
  osammanvävd_1_A = mkA "osammanvävd" "osammanvävt" ; -- osammanvävd..av.1
  osammanväxt_1_A = mkA "osammanväxt" "osammanväxt" ; -- osammanväxt..av.1
  osamordnad_1_A = mkA "osamordnad" ; -- osamordnad..av.1
  osamplad_1_A = mkA "osamplad" ; -- osamplad..av.1
  osams_1_A = mkA "osams" ; -- osams..av.1
  osamsad_1_A = mkA "osamsad" ; -- osamsad..av.1
  osamtaxerad_1_A = mkA "osamtaxerad" ; -- osamtaxerad..av.1
  osamtaxerbar_1_A = mkA "osamtaxerbar" ; -- osamtaxerbar..av.1
  osamtaxerbarhet_1_N = mkN "osamtaxerbarhet" ; -- osamtaxerbarhet..nn.1
  osandad_1_A = mkA "osandad" ; -- osandad..av.1
  osande_1_N = mkN "osande" ; -- osande..nn.1
  osanerad_1_A = mkA "osanerad" ; -- osanerad..av.1
  osanerbar_1_A = mkA "osanerbar" ; -- osanerbar..av.1
  osanerbarhet_1_N = mkN "osanerbarhet" ; -- osanerbarhet..nn.1
  osanforiserad_1_A = mkA "osanforiserad" ; -- osanforiserad..av.1
  osanforiserbar_1_A = mkA "osanforiserbar" ; -- osanforiserbar..av.1
  osanforiserbarhet_1_N = mkN "osanforiserbarhet" ; -- osanforiserbarhet..nn.1
  osanktifierad_1_A = mkA "osanktifierad" ; -- osanktifierad..av.1
  osanktifierbar_1_A = mkA "osanktifierbar" ; -- osanktifierbar..av.1
  osanktifierbarhet_1_N = mkN "osanktifierbarhet" ; -- osanktifierbarhet..nn.1
  osanktionerad_1_A = mkA "osanktionerad" ; -- osanktionerad..av.1
  osanktionerbar_1_A = mkA "osanktionerbar" ; -- osanktionerbar..av.1
  osanktionerbarhet_1_N = mkN "osanktionerbarhet" ; -- osanktionerbarhet..nn.1
  osann_1_A = mkA "osann" "osant" ; -- osann..av.1
  osannad_1_A = mkA "osannad" ; -- osannad..av.1
  osannfärdig_1_A = mkA "osannfärdig" ; -- osannfärdig..av.1
  osannfärdighet_1_N = mkN "osannfärdighet" ; -- osannfärdighet..nn.1
  osanning_1_N = mkN "osanning" ; -- osanning..nn.1
  osannolik_1_A = mkA "osannolik" ; -- osannolik..av.1
  osannolikhet_1_N = mkN "osannolikhet" ; -- osannolikhet..nn.1
  osaponifierad_1_A = mkA "osaponifierad" ; -- osaponifierad..av.1
  osaponifierbar_1_A = mkA "osaponifierbar" ; -- osaponifierbar..av.1
  osaponifierbarhet_1_N = mkN "osaponifierbarhet" ; -- osaponifierbarhet..nn.1
  osargad_1_A = mkA "osargad" ; -- osargad..av.1
  osatinerad_1_A = mkA "osatinerad" ; -- osatinerad..av.1
  osatinerbar_1_A = mkA "osatinerbar" ; -- osatinerbar..av.1
  osatinerbarhet_1_N = mkN "osatinerbarhet" ; -- osatinerbarhet..nn.1
  osatisfierad_1_A = mkA "osatisfierad" ; -- osatisfierad..av.1
  osatisfierbar_1_A = mkA "osatisfierbar" ; -- osatisfierbar..av.1
  osatisfierbarhet_1_N = mkN "osatisfierbarhet" ; -- osatisfierbarhet..nn.1
  osatsad_1_A = mkA "osatsad" ; -- osatsad..av.1
  osaturerad_1_A = mkA "osaturerad" ; -- osaturerad..av.1
  osaturerbar_1_A = mkA "osaturerbar" ; -- osaturerbar..av.1
  osaturerbarhet_1_N = mkN "osaturerbarhet" ; -- osaturerbarhet..nn.1
  osauterad_1_A = mkA "osauterad" ; -- osauterad..av.1
  osauterbar_1_A = mkA "osauterbar" ; -- osauterbar..av.1
  osauterbarhet_1_N = mkN "osauterbarhet" ; -- osauterbarhet..nn.1
  osauverad_1_A = mkA "osauverad" ; -- osauverad..av.1
  osauverbar_1_A = mkA "osauverbar" ; -- osauverbar..av.1
  osauverbarhet_1_N = mkN "osauverbarhet" ; -- osauverbarhet..nn.1
  osaxad_1_A = mkA "osaxad" ; -- osaxad..av.1
  oscannad_1_A = mkA "oscannad" ; -- oscannad..av.1
  oschablonerad_1_A = mkA "oschablonerad" ; -- oschablonerad..av.1
  oschablonerbar_1_A = mkA "oschablonerbar" ; -- oschablonerbar..av.1
  oschablonerbarhet_1_N = mkN "oschablonerbarhet" ; -- oschablonerbarhet..nn.1
  oschabloniserad_1_A = mkA "oschabloniserad" ; -- oschabloniserad..av.1
  oschabloniserbar_1_A = mkA "oschabloniserbar" ; -- oschabloniserbar..av.1
  oschabloniserbarhet_1_N = mkN "oschabloniserbarhet" ; -- oschabloniserbarhet..nn.1
  oschackad_1_A = mkA "oschackad" ; -- oschackad..av.1
  oschacklad_1_A = mkA "oschacklad" ; -- oschacklad..av.1
  oschaktad_1_A = mkA "oschaktad" ; -- oschaktad..av.1
  oschamponerad_1_A = mkA "oschamponerad" ; -- oschamponerad..av.1
  oschamponerbar_1_A = mkA "oschamponerbar" ; -- oschamponerbar..av.1
  oschamponerbarhet_1_N = mkN "oschamponerbarhet" ; -- oschamponerbarhet..nn.1
  oschanghajad_1_A = mkA "oschanghajad" ; -- oschanghajad..av.1
  oschappad_1_A = mkA "oschappad" ; -- oschappad..av.1
  oschasad_1_A = mkA "oschasad" ; -- oschasad..av.1
  oschatterad_1_A = mkA "oschatterad" ; -- oschatterad..av.1
  oschatterbar_1_A = mkA "oschatterbar" ; -- oschatterbar..av.1
  oschatterbarhet_1_N = mkN "oschatterbarhet" ; -- oschatterbarhet..nn.1
  oschematiserad_1_A = mkA "oschematiserad" ; -- oschematiserad..av.1
  oschematiserbar_1_A = mkA "oschematiserbar" ; -- oschematiserbar..av.1
  oschematiserbarhet_1_N = mkN "oschematiserbarhet" ; -- oschematiserbarhet..nn.1
  oschveifad_1_A = mkA "oschveifad" ; -- oschveifad..av.1
  oscillation_1_N = mkN "oscillation" ; -- oscillation..nn.1
  oscillator_1_N = mkN "oscillator" "oscillatorer" ; -- oscillator..nn.1
  oscillera_1_V = mkV "oscillerar" ; -- oscillera..vb.1
  oscillerande_1_N = mkN "oscillerande" ; -- oscillerande..nn.1
  oscillering_1_N = mkN "oscillering" ; -- oscillering..nn.1
  oscillograf_1_N = mkN "oscillograf" "oscillografer" ; -- oscillograf..nn.1
  oscillogram_1_N = mkN "oscillogram" "oscillogrammet" "oscillogram" "oscillogrammen" ; -- oscillogram..nn.1
  oscilloskop_1_N = mkN "oscilloskop" neutrum  ; -- oscilloskop..nn.1
  osed_1_N = mkN "osed" "oseder" ; -- osed..nn.1
  osedd_1_A = mkA "osedd" ; -- osedd..av.1
  osedimenterad_1_A = mkA "osedimenterad" ; -- osedimenterad..av.1
  osedimenterbar_1_A = mkA "osedimenterbar" ; -- osedimenterbar..av.1
  osedimenterbarhet_1_N = mkN "osedimenterbarhet" ; -- osedimenterbarhet..nn.1
  osedlig_1_A = mkA "osedlig" ; -- osedlig..av.1
  osedlighet_1_N = mkN "osedlighet" "osedligheter" ; -- osedlighet..nn.1
  osedvanlig_1_A = mkA "osedvanlig" ; -- osedvanlig..av.1
  osedvanlighet_1_N = mkN "osedvanlighet" ; -- osedvanlighet..nn.1
  oseedad_1_A = mkA "oseedad" ; -- oseedad..av.1
  oseende_1_A = mkA "oseende" ; -- oseende..av.1
  oseglad_1_A = mkA "oseglad" ; -- oseglad..av.1
  osegmenterad_1_A = mkA "osegmenterad" ; -- osegmenterad..av.1
  osegmenterbar_1_A = mkA "osegmenterbar" ; -- osegmenterbar..av.1
  osegmenterbarhet_1_N = mkN "osegmenterbarhet" ; -- osegmenterbarhet..nn.1
  osegrad_1_A = mkA "osegrad" ; -- osegrad..av.1
  osegregerad_1_A = mkA "osegregerad" ; -- osegregerad..av.1
  osegregerbar_1_A = mkA "osegregerbar" ; -- osegregerbar..av.1
  osegregerbarhet_1_N = mkN "osegregerbarhet" ; -- osegregerbarhet..nn.1
  osejsad_1_A = mkA "osejsad" ; -- osejsad..av.1
  osekonderad_1_A = mkA "osekonderad" ; -- osekonderad..av.1
  osekonderbar_1_A = mkA "osekonderbar" ; -- osekonderbar..av.1
  osekonderbarhet_1_N = mkN "osekonderbarhet" ; -- osekonderbarhet..nn.1
  osekulariserad_1_A = mkA "osekulariserad" ; -- osekulariserad..av.1
  osekulariserbar_1_A = mkA "osekulariserbar" ; -- osekulariserbar..av.1
  osekulariserbarhet_1_N = mkN "osekulariserbarhet" ; -- osekulariserbarhet..nn.1
  osekunderad_1_A = mkA "osekunderad" ; -- osekunderad..av.1
  osekunderbar_1_A = mkA "osekunderbar" ; -- osekunderbar..av.1
  osekunderbarhet_1_N = mkN "osekunderbarhet" ; -- osekunderbarhet..nn.1
  osekvestrerad_1_A = mkA "osekvestrerad" ; -- osekvestrerad..av.1
  osekvestrerbar_1_A = mkA "osekvestrerbar" ; -- osekvestrerbar..av.1
  osekvestrerbarhet_1_N = mkN "osekvestrerbarhet" ; -- osekvestrerbarhet..nn.1
  oselad_1_A = mkA "oselad" ; -- oselad..av.1
  oselekterad_1_A = mkA "oselekterad" ; -- oselekterad..av.1
  oselekterbar_1_A = mkA "oselekterbar" ; -- oselekterbar..av.1
  oselekterbarhet_1_N = mkN "oselekterbarhet" ; -- oselekterbarhet..nn.1
  osemaforerad_1_A = mkA "osemaforerad" ; -- osemaforerad..av.1
  osemaforerbar_1_A = mkA "osemaforerbar" ; -- osemaforerbar..av.1
  osemaforerbarhet_1_N = mkN "osemaforerbarhet" ; -- osemaforerbarhet..nn.1
  oseminerad_1_A = mkA "oseminerad" ; -- oseminerad..av.1
  oseminerbar_1_A = mkA "oseminerbar" ; -- oseminerbar..av.1
  oseminerbarhet_1_N = mkN "oseminerbarhet" ; -- oseminerbarhet..nn.1
  osensibiliserad_1_A = mkA "osensibiliserad" ; -- osensibiliserad..av.1
  osensibiliserbar_1_A = mkA "osensibiliserbar" ; -- osensibiliserbar..av.1
  osensibiliserbarhet_1_N = mkN "osensibiliserbarhet" ; -- osensibiliserbarhet..nn.1
  osenterad_1_A = mkA "osenterad" ; -- osenterad..av.1
  osenterbar_1_A = mkA "osenterbar" ; -- osenterbar..av.1
  osenterbarhet_1_N = mkN "osenterbarhet" ; -- osenterbarhet..nn.1
  osentimental_1_A = mkA "osentimental" ; -- osentimental..av.1
  oseparerad_1_A = mkA "oseparerad" ; -- oseparerad..av.1
  oseparerbar_1_A = mkA "oseparerbar" ; -- oseparerbar..av.1
  oseparerbarhet_1_N = mkN "oseparerbarhet" ; -- oseparerbarhet..nn.1
  oseriös_1_A = mkA "oseriös" ; -- oseriös..av.1
  oservad_1_A = mkA "oservad" ; -- oservad..av.1
  oserverad_1_A = mkA "oserverad" ; -- oserverad..av.1
  oserverbar_1_A = mkA "oserverbar" ; -- oserverbar..av.1
  oserverbarhet_1_N = mkN "oserverbarhet" ; -- oserverbarhet..nn.1
  osexualiserad_1_A = mkA "osexualiserad" ; -- osexualiserad..av.1
  osexualiserbar_1_A = mkA "osexualiserbar" ; -- osexualiserbar..av.1
  osexualiserbarhet_1_N = mkN "osexualiserbarhet" ; -- osexualiserbarhet..nn.1
  oshamponerad_1_A = mkA "oshamponerad" ; -- oshamponerad..av.1
  oshamponerbar_1_A = mkA "oshamponerbar" ; -- oshamponerbar..av.1
  oshamponerbarhet_1_N = mkN "oshamponerbarhet" ; -- oshamponerbarhet..nn.1
  oshanghajad_1_A = mkA "oshanghajad" ; -- oshanghajad..av.1
  oshinglad_1_A = mkA "oshinglad" ; -- oshinglad..av.1
  oshortad_1_A = mkA "oshortad" ; -- oshortad..av.1
  oshuntad_1_A = mkA "oshuntad" ; -- oshuntad..av.1
  osickad_1_A = mkA "osickad" ; -- osickad..av.1
  osicklad_1_A = mkA "osicklad" ; -- osicklad..av.1
  osicksackad_1_A = mkA "osicksackad" ; -- osicksackad..av.1
  osigillerad_1_A = mkA "osigillerad" ; -- osigillerad..av.1
  osigillerbar_1_A = mkA "osigillerbar" ; -- osigillerbar..av.1
  osigillerbarhet_1_N = mkN "osigillerbarhet" ; -- osigillerbarhet..nn.1
  osignad_1_A = mkA "osignad" ; -- osignad..av.1
  osignalerad_1_A = mkA "osignalerad" ; -- osignalerad..av.1
  osignalerbar_1_A = mkA "osignalerbar" ; -- osignalerbar..av.1
  osignalerbarhet_1_N = mkN "osignalerbarhet" ; -- osignalerbarhet..nn.1
  osignerad_1_A = mkA "osignerad" ; -- osignerad..av.1
  osignerbar_1_A = mkA "osignerbar" ; -- osignerbar..av.1
  osignerbarhet_1_N = mkN "osignerbarhet" ; -- osignerbarhet..nn.1
  osiktad_1_A = mkA "osiktad" ; -- osiktad..av.1
  osiktbar_1_A = mkA "osiktbar" ; -- osiktbar..av.1
  osiktbarhet_1_N = mkN "osiktbarhet" ; -- osiktbarhet..nn.1
  osiktig_1_A = mkA "osiktig" ; -- osiktig..av.1
  osiktighet_1_N = mkN "osiktighet" ; -- osiktighet..nn.1
  osilad_1_A = mkA "osilad" ; -- osilad..av.1
  osilhuetterad_1_A = mkA "osilhuetterad" ; -- osilhuetterad..av.1
  osilhuetterbar_1_A = mkA "osilhuetterbar" ; -- osilhuetterbar..av.1
  osilhuetterbarhet_1_N = mkN "osilhuetterbarhet" ; -- osilhuetterbarhet..nn.1
  osiluetterad_1_A = mkA "osiluetterad" ; -- osiluetterad..av.1
  osiluetterbar_1_A = mkA "osiluetterbar" ; -- osiluetterbar..av.1
  osiluetterbarhet_1_N = mkN "osiluetterbarhet" ; -- osiluetterbarhet..nn.1
  osilvrad_1_A = mkA "osilvrad" ; -- osilvrad..av.1
  osimplifierad_1_A = mkA "osimplifierad" ; -- osimplifierad..av.1
  osimplifierbar_1_A = mkA "osimplifierbar" ; -- osimplifierbar..av.1
  osimplifierbarhet_1_N = mkN "osimplifierbarhet" ; -- osimplifierbarhet..nn.1
  osimsad_1_A = mkA "osimsad" ; -- osimsad..av.1
  osimulerad_1_A = mkA "osimulerad" ; -- osimulerad..av.1
  osimulerbar_1_A = mkA "osimulerbar" ; -- osimulerbar..av.1
  osimulerbarhet_1_N = mkN "osimulerbarhet" ; -- osimulerbarhet..nn.1
  osinkad_1_A = mkA "osinkad" ; -- osinkad..av.1
  osinlig_1_A = mkA "osinlig" ; -- osinlig..av.1
  osinlighet_1_N = mkN "osinlighet" ; -- osinlighet..nn.1
  osinnlig_1_A = mkA "osinnlig" ; -- osinnlig..av.1
  osinnlighet_1_N = mkN "osinnlighet" ; -- osinnlighet..nn.1
  osintrad_1_A = mkA "osintrad" ; -- osintrad..av.1
  osirad_1_A = mkA "osirad" ; -- osirad..av.1
  osis_1_N = mkN "osis" ; -- osis..nn.1
  osjanghajad_1_A = mkA "osjanghajad" ; -- osjanghajad..av.1
  osjappad_1_A = mkA "osjappad" ; -- osjappad..av.1
  osjasad_1_A = mkA "osjasad" ; -- osjasad..av.1
  osjälvisk_1_A = mkA "osjälvisk" ; -- osjälvisk..av.1
  osjälviskhet_1_N = mkN "osjälviskhet" "osjälviskheter" ; -- osjälviskhet..nn.1
  osjälvständig_1_A = mkA "osjälvständig" ; -- osjälvständig..av.1
  osjälvständighet_1_N = mkN "osjälvständighet" "osjälvständigheter" ; -- osjälvständighet..nn.1
  oskadad_1_A = mkA "oskadad" ; -- oskadad..av.1
  oskadd_1_A = mkA "oskadd" ; -- oskadd..av.1
  oskadlig_1_A = mkA "oskadlig" ; -- oskadlig..av.1
  oskadliggöra_1_V = mkV "oskadliggöra" "oskadliggjorde" "oskadliggjort" ; -- oskadliggöra..vb.1
  oskadliggörande_1_N = mkN "oskadliggörande" ; -- oskadliggörande..nn.1
  oskadlighet_1_N = mkN "oskadlighet" ; -- oskadlighet..nn.1
  oskaffad_1_A = mkA "oskaffad" ; -- oskaffad..av.1
  oskaftad_1_A = mkA "oskaftad" ; -- oskaftad..av.1
  oskakad_1_A = mkA "oskakad" ; -- oskakad..av.1
  oskalad_1_A = mkA "oskalad" ; -- oskalad..av.1
  oskaldad_1_A = mkA "oskaldad" ; -- oskaldad..av.1
  oskalkad_1_A = mkA "oskalkad" ; -- oskalkad..av.1
  oskallad_1_A = mkA "oskallad" ; -- oskallad..av.1
  oskalperad_1_A = mkA "oskalperad" ; -- oskalperad..av.1
  oskalperbar_1_A = mkA "oskalperbar" ; -- oskalperbar..av.1
  oskalperbarhet_1_N = mkN "oskalperbarhet" ; -- oskalperbarhet..nn.1
  oskandaliserad_1_A = mkA "oskandaliserad" ; -- oskandaliserad..av.1
  oskandaliserbar_1_A = mkA "oskandaliserbar" ; -- oskandaliserbar..av.1
  oskandaliserbarhet_1_N = mkN "oskandaliserbarhet" ; -- oskandaliserbarhet..nn.1
  oskanderad_1_A = mkA "oskanderad" ; -- oskanderad..av.1
  oskanderbar_1_A = mkA "oskanderbar" ; -- oskanderbar..av.1
  oskanderbarhet_1_N = mkN "oskanderbarhet" ; -- oskanderbarhet..nn.1
  oskannad_1_A = mkA "oskannad" ; -- oskannad..av.1
  oskapad_1_A = mkA "oskapad" ; -- oskapad..av.1
  oskaplig_1_A = mkA "oskaplig" ; -- oskaplig..av.1
  oskaplighet_1_N = mkN "oskaplighet" ; -- oskaplighet..nn.1
  oskarian_1_N = mkN "oskarian" "oskarianer" ; -- oskarian..nn.1
  oskariansk_1_A = mkA "oskariansk" ; -- oskariansk..av.1
  oskarp_1_A = mkA "oskarp" ; -- oskarp..av.1
  oskarphet_1_N = mkN "oskarphet" ; -- oskarphet..nn.1
  oskarvad_1_A = mkA "oskarvad" ; -- oskarvad..av.1
  oskattad_1_A = mkA "oskattad" ; -- oskattad..av.1
  oskattbar_1_A = mkA "oskattbar" ; -- oskattbar..av.1
  oskattbarhet_1_N = mkN "oskattbarhet" ; -- oskattbarhet..nn.1
  oskavd_1_A = mkA "oskavd" "oskavt" ; -- oskavd..av.1
  oskedad_1_A = mkA "oskedad" ; -- oskedad..av.1
  oskenad_1_A = mkA "oskenad" ; -- oskenad..av.1
  oskeppad_1_A = mkA "oskeppad" ; -- oskeppad..av.1
  oskevad_1_A = mkA "oskevad" ; -- oskevad..av.1
  oskevrad_1_A = mkA "oskevrad" ; -- oskevrad..av.1
  oskick_1_N = mkN "oskick" neutrum  ; -- oskick..nn.1
  oskicklig_1_A = mkA "oskicklig" ; -- oskicklig..av.1
  oskicklighet_1_N = mkN "oskicklighet" ; -- oskicklighet..nn.1
  oskiftad_1_A = mkA "oskiftad" ; -- oskiftad..av.1
  oskiktad_1_A = mkA "oskiktad" ; -- oskiktad..av.1
  oskildrad_1_A = mkA "oskildrad" ; -- oskildrad..av.1
  oskiljaktig_1_A = mkA "oskiljaktig" ; -- oskiljaktig..av.1
  oskiljaktighet_1_N = mkN "oskiljaktighet" "oskiljaktigheter" ; -- oskiljaktighet..nn.1
  oskingrad_1_A = mkA "oskingrad" ; -- oskingrad..av.1
  oskinnad_1_A = mkA "oskinnad" ; -- oskinnad..av.1
  oskipad_1_A = mkA "oskipad" ; -- oskipad..av.1
  oskippad_1_A = mkA "oskippad" ; -- oskippad..av.1
  oskirad_1_A = mkA "oskirad" ; -- oskirad..av.1
  oskissad_1_A = mkA "oskissad" ; -- oskissad..av.1
  oskisserad_1_A = mkA "oskisserad" ; -- oskisserad..av.1
  oskisserbar_1_A = mkA "oskisserbar" ; -- oskisserbar..av.1
  oskisserbarhet_1_N = mkN "oskisserbarhet" ; -- oskisserbarhet..nn.1
  oskivad_1_A = mkA "oskivad" ; -- oskivad..av.1
  oskjutsad_1_A = mkA "oskjutsad" ; -- oskjutsad..av.1
  oskjuvad_1_A = mkA "oskjuvad" ; -- oskjuvad..av.1
  oskodd_1_A = mkA "oskodd" ; -- oskodd..av.1
  oskojad_1_A = mkA "oskojad" ; -- oskojad..av.1
  oskolad_1_A = mkA "oskolad" ; -- oskolad..av.1
  oskonad_1_A = mkA "oskonad" ; -- oskonad..av.1
  oskopad_1_A = mkA "oskopad" ; -- oskopad..av.1
  oskotad_1_A = mkA "oskotad" ; -- oskotad..av.1
  oskottad_1_A = mkA "oskottad" ; -- oskottad..av.1
  oskovlad_1_A = mkA "oskovlad" ; -- oskovlad..av.1
  oskrafferad_1_A = mkA "oskrafferad" ; -- oskrafferad..av.1
  oskrafferbar_1_A = mkA "oskrafferbar" ; -- oskrafferbar..av.1
  oskrafferbarhet_1_N = mkN "oskrafferbarhet" ; -- oskrafferbarhet..nn.1
  oskramlad_1_A = mkA "oskramlad" ; -- oskramlad..av.1
  oskrapad_1_A = mkA "oskrapad" ; -- oskrapad..av.1
  oskriven_1_A = mkA "oskriven" ; -- oskriven..av.1
  oskrotad_1_A = mkA "oskrotad" ; -- oskrotad..av.1
  oskrubbad_1_A = mkA "oskrubbad" ; -- oskrubbad..av.1
  oskrudad_1_A = mkA "oskrudad" ; -- oskrudad..av.1
  oskrymtad_1_A = mkA "oskrymtad" ; -- oskrymtad..av.1
  oskuld_1_N = mkN "oskuld" "oskulder" ; -- oskuld..nn.1
  oskuldsbevis_1_N = mkN "oskuldsbevis" neutrum  ; -- oskuldsbevis..nn.1
  oskuldsfull_1_A = mkA "oskuldsfull" ; -- oskuldsfull..av.1
  oskuldsfullhet_1_N = mkN "oskuldsfullhet" ; -- oskuldsfullhet..nn.1
  oskuldspresumtion_1_N = mkN "oskuldspresumtion" ; -- oskuldspresumtion..nn.1
  oskulpterad_1_A = mkA "oskulpterad" ; -- oskulpterad..av.1
  oskulpterbar_1_A = mkA "oskulpterbar" ; -- oskulpterbar..av.1
  oskulpterbarhet_1_N = mkN "oskulpterbarhet" ; -- oskulpterbarhet..nn.1
  oskulpturerad_1_A = mkA "oskulpturerad" ; -- oskulpturerad..av.1
  oskulpturerbar_1_A = mkA "oskulpturerbar" ; -- oskulpturerbar..av.1
  oskulpturerbarhet_1_N = mkN "oskulpturerbarhet" ; -- oskulpturerbarhet..nn.1
  oskummad_1_A = mkA "oskummad" ; -- oskummad..av.1
  oskurad_1_A = mkA "oskurad" ; -- oskurad..av.1
  oskyddad_1_A = mkA "oskyddad" ; -- oskyddad..av.1
  oskyld_1_A = mkA "oskyld" "oskylt" ; -- oskyld..av.1
  oskyld_2_1_A = mkA "oskyld" "oskylt" ; -- oskyld_2..av.1
  oskyldig_1_A = mkA "oskyldig" ; -- oskyldig..av.1
  oskyldighet_1_N = mkN "oskyldighet" ; -- oskyldighet..nn.1
  oskälig_1_A = mkA "oskälig" ; -- oskälig..av.1
  oskälighet_1_N = mkN "oskälighet" ; -- oskälighet..nn.1
  oskära_1_V = mkV "oskärar" ; -- oskära..vb.1
  oskärande_1_N = mkN "oskärande" ; -- oskärande..nn.1
  oskärpa_1_N = mkN "oskärpa" ; -- oskärpa..nn.1
  oskön_1_A = mkA "oskön" ; -- oskön..av.1
  oskönhet_1_N = mkN "oskönhet" ; -- oskönhet..nn.1
  oskönjbar_1_A = mkA "oskönjbar" ; -- oskönjbar..av.1
  oskönjbarhet_1_N = mkN "oskönjbarhet" ; -- oskönjbarhet..nn.1
  oslagbar_1_A = mkA "oslagbar" ; -- oslagbar..av.1
  oslagbarhet_1_N = mkN "oslagbarhet" ; -- oslagbarhet..nn.1
  oslagen_1_A = mkA "oslagen" ; -- oslagen..av.1
  oslaktad_1_A = mkA "oslaktad" ; -- oslaktad..av.1
  oslaviserad_1_A = mkA "oslaviserad" ; -- oslaviserad..av.1
  oslaviserbar_1_A = mkA "oslaviserbar" ; -- oslaviserbar..av.1
  oslaviserbarhet_1_N = mkN "oslaviserbarhet" ; -- oslaviserbarhet..nn.1
  oslipad_1_A = mkA "oslipad" ; -- oslipad..av.1
  osläcklig_1_A = mkA "osläcklig" ; -- osläcklig..av.1
  osläcklighet_1_N = mkN "osläcklighet" ; -- osläcklighet..nn.1
  osläckt_1_A = mkA "osläckt" "osläckt" ; -- osläckt..av.1
  osmak_1_N = mkN "osmak" ; -- osmak..nn.1
  osmaklig_1_A = mkA "osmaklig" ; -- osmaklig..av.1
  osmaklighet_1_N = mkN "osmaklighet" "osmakligheter" ; -- osmaklighet..nn.1
  osman_1_N = mkN "osman" "osmaner" ; -- osman..nn.1
  osmansk_1_A = mkA "osmansk" ; -- osmansk..av.1
  osmidbar_1_A = mkA "osmidbar" ; -- osmidbar..av.1
  osmidbarhet_1_N = mkN "osmidbarhet" ; -- osmidbarhet..nn.1
  osmidig_1_A = mkA "osmidig" ; -- osmidig..av.1
  osmidighet_1_N = mkN "osmidighet" "osmidigheter" ; -- osmidighet..nn.1
  osminkad_1_A = mkA "osminkad" ; -- osminkad..av.1
  osmium_1_N = mkN "osmium" neutrum  ; -- osmium..nn.1
  osmord_1_A = mkA "osmord" "osmort" ; -- osmord..av.1
  osmos_1_N = mkN "osmos" ; -- osmos..nn.1
  osmotisk_1_A = mkA "osmotisk" ; -- osmotisk..av.1
  osmund_1_N = mkN "osmund" ; -- osmund..nn.1
  osmyckad_1_A = mkA "osmyckad" ; -- osmyckad..av.1
  osmält_1_A = mkA "osmält" "osmält" ; -- osmält..av.1
  osmältbar_1_A = mkA "osmältbar" ; -- osmältbar..av.1
  osmältbarhet_1_N = mkN "osmältbarhet" ; -- osmältbarhet..nn.1
  osnedrekryterbar_1_A = mkA "osnedrekryterbar" ; -- osnedrekryterbar..av.1
  osnedrekryterbarhet_1_N = mkN "osnedrekryterbarhet" ; -- osnedrekryterbarhet..nn.1
  osnuten_1_A = mkA "osnuten" ; -- osnuten..av.1
  osnygg_1_A = mkA "osnygg" ; -- osnygg..av.1
  osnygga_1_V = mkV "osnyggar" ; -- osnygga..vb.1
  osnyggande_1_N = mkN "osnyggande" ; -- osnyggande..nn.1
  osnygghet_1_N = mkN "osnygghet" ; -- osnygghet..nn.1
  osocial_1_A = mkA "osocial" ; -- osocial..av.1
  osocialiserad_1_A = mkA "osocialiserad" ; -- osocialiserad..av.1
  osocialiserbar_1_A = mkA "osocialiserbar" ; -- osocialiserbar..av.1
  osocialiserbarhet_1_N = mkN "osocialiserbarhet" ; -- osocialiserbarhet..nn.1
  osockrad_1_A = mkA "osockrad" ; -- osockrad..av.1
  osolidarisk_1_A = mkA "osolidarisk" ; -- osolidarisk..av.1
  osolverad_1_A = mkA "osolverad" ; -- osolverad..av.1
  osolverbar_1_A = mkA "osolverbar" ; -- osolverbar..av.1
  osolverbarhet_1_N = mkN "osolverbarhet" ; -- osolverbarhet..nn.1
  osonderad_1_A = mkA "osonderad" ; -- osonderad..av.1
  osonderbar_1_A = mkA "osonderbar" ; -- osonderbar..av.1
  osonderbarhet_1_N = mkN "osonderbarhet" ; -- osonderbarhet..nn.1
  osordinerad_1_A = mkA "osordinerad" ; -- osordinerad..av.1
  osordinerbar_1_A = mkA "osordinerbar" ; -- osordinerbar..av.1
  osordinerbarhet_1_N = mkN "osordinerbarhet" ; -- osordinerbarhet..nn.1
  osorterad_1_A = mkA "osorterad" ; -- osorterad..av.1
  osorterbar_1_A = mkA "osorterbar" ; -- osorterbar..av.1
  osorterbarhet_1_N = mkN "osorterbarhet" ; -- osorterbarhet..nn.1
  osoulagerad_1_A = mkA "osoulagerad" ; -- osoulagerad..av.1
  osoulagerbar_1_A = mkA "osoulagerbar" ; -- osoulagerbar..av.1
  osoulagerbarhet_1_N = mkN "osoulagerbarhet" ; -- osoulagerbarhet..nn.1
  osovjetiserad_1_A = mkA "osovjetiserad" ; -- osovjetiserad..av.1
  osovjetiserbar_1_A = mkA "osovjetiserbar" ; -- osovjetiserbar..av.1
  osovjetiserbarhet_1_N = mkN "osovjetiserbarhet" ; -- osovjetiserbarhet..nn.1
  ospaljerad_1_A = mkA "ospaljerad" ; -- ospaljerad..av.1
  ospaljerbar_1_A = mkA "ospaljerbar" ; -- ospaljerbar..av.1
  ospaljerbarhet_1_N = mkN "ospaljerbarhet" ; -- ospaljerbarhet..nn.1
  ospallerad_1_A = mkA "ospallerad" ; -- ospallerad..av.1
  ospallerbar_1_A = mkA "ospallerbar" ; -- ospallerbar..av.1
  ospallerbarhet_1_N = mkN "ospallerbarhet" ; -- ospallerbarhet..nn.1
  osparad_1_A = mkA "osparad" ; -- osparad..av.1
  ospard_1_A = mkA "ospard" "ospart" ; -- ospard..av.1
  ospecialiserad_1_A = mkA "ospecialiserad" ; -- ospecialiserad..av.1
  ospecialiserbar_1_A = mkA "ospecialiserbar" ; -- ospecialiserbar..av.1
  ospecialiserbarhet_1_N = mkN "ospecialiserbarhet" ; -- ospecialiserbarhet..nn.1
  ospecificerad_1_A = mkA "ospecificerad" ; -- ospecificerad..av.1
  ospecificerbar_1_A = mkA "ospecificerbar" ; -- ospecificerbar..av.1
  ospecificerbarhet_1_N = mkN "ospecificerbarhet" ; -- ospecificerbarhet..nn.1
  ospecifik_1_A = mkA "ospecifik" ; -- ospecifik..av.1
  ospeciminerad_1_A = mkA "ospeciminerad" ; -- ospeciminerad..av.1
  ospeciminerbar_1_A = mkA "ospeciminerbar" ; -- ospeciminerbar..av.1
  ospeciminerbarhet_1_N = mkN "ospeciminerbarhet" ; -- ospeciminerbarhet..nn.1
  ospekulerad_1_A = mkA "ospekulerad" ; -- ospekulerad..av.1
  ospekulerbar_1_A = mkA "ospekulerbar" ; -- ospekulerbar..av.1
  ospekulerbarhet_1_N = mkN "ospekulerbarhet" ; -- ospekulerbarhet..nn.1
  ospelbar_1_A = mkA "ospelbar" ; -- ospelbar..av.1
  ospelbarhet_1_N = mkN "ospelbarhet" ; -- ospelbarhet..nn.1
  ospenderad_1_A = mkA "ospenderad" ; -- ospenderad..av.1
  ospenderbar_1_A = mkA "ospenderbar" ; -- ospenderbar..av.1
  ospenderbarhet_1_N = mkN "ospenderbarhet" ; -- ospenderbarhet..nn.1
  ospolierad_1_A = mkA "ospolierad" ; -- ospolierad..av.1
  ospolierbar_1_A = mkA "ospolierbar" ; -- ospolierbar..av.1
  ospolierbarhet_1_N = mkN "ospolierbarhet" ; -- ospolierbarhet..nn.1
  osportslig_1_A = mkA "osportslig" ; -- osportslig..av.1
  osportslighet_1_N = mkN "osportslighet" "osportsligheter" ; -- osportslighet..nn.1
  ospärrad_1_A = mkA "ospärrad" ; -- ospärrad..av.1
  ossobuco_1_N = mkN "ossobuco" ; -- ossobuco..nn.1
  ossuarium_1_N = mkN "ossuarium" "ossuariet" "ossuarier" "ossuarierna" ; -- ossuarium..nn.1
  ost_1_N = mkN "ost" ; -- ost..nn.1
  ost_2_N = mkN "ost" ; -- ost..nn.2
  ostabiliserad_1_A = mkA "ostabiliserad" ; -- ostabiliserad..av.1
  ostabiliserbar_1_A = mkA "ostabiliserbar" ; -- ostabiliserbar..av.1
  ostabiliserbarhet_1_N = mkN "ostabiliserbarhet" ; -- ostabiliserbarhet..nn.1
  ostadig_1_A = mkA "ostadig" ; -- ostadig..av.1
  ostadighet_1_N = mkN "ostadighet" ; -- ostadighet..nn.1
  ostafferad_1_A = mkA "ostafferad" ; -- ostafferad..av.1
  ostafferbar_1_A = mkA "ostafferbar" ; -- ostafferbar..av.1
  ostafferbarhet_1_N = mkN "ostafferbarhet" ; -- ostafferbarhet..nn.1
  ostagnerad_1_A = mkA "ostagnerad" ; -- ostagnerad..av.1
  ostalgi_1_N = mkN "ostalgi" "ostalgier" ; -- ostalgi..nn.1
  ostan_1_N = mkN "ostan" ; -- ostan..nn.1
  ostandardiserad_1_A = mkA "ostandardiserad" ; -- ostandardiserad..av.1
  ostandardiserbar_1_A = mkA "ostandardiserbar" ; -- ostandardiserbar..av.1
  ostandardiserbarhet_1_N = mkN "ostandardiserbarhet" ; -- ostandardiserbarhet..nn.1
  ostanfrån_1_Adv = mkAdv "ostanfrån" ; -- ostanfrån..ab.1
  ostanifrån_1_Adv = mkAdv "ostanifrån" ; -- ostanifrån..ab.1
  ostasiat_1_N = mkN "ostasiat" "ostasiater" ; -- ostasiat..nn.1
  ostasiatisk_1_A = mkA "ostasiatisk" ; -- ostasiatisk..av.1
  ostationerad_1_A = mkA "ostationerad" ; -- ostationerad..av.1
  ostationerbar_1_A = mkA "ostationerbar" ; -- ostationerbar..av.1
  ostationerbarhet_1_N = mkN "ostationerbarhet" ; -- ostationerbarhet..nn.1
  ostatuerad_1_A = mkA "ostatuerad" ; -- ostatuerad..av.1
  ostatuerbar_1_A = mkA "ostatuerbar" ; -- ostatuerbar..av.1
  ostatuerbarhet_1_N = mkN "ostatuerbarhet" ; -- ostatuerbarhet..nn.1
  ostbricka_1_N = mkN "ostbricka" ; -- ostbricka..nn.1
  ostbåge_1_N = mkN "ostbåge" utrum  ; -- ostbåge..nn.1
  ostdisk_1_N = mkN "ostdisk" ; -- ostdisk..nn.1
  ostencilerad_1_A = mkA "ostencilerad" ; -- ostencilerad..av.1
  ostencilerbar_1_A = mkA "ostencilerbar" ; -- ostencilerbar..av.1
  ostencilerbarhet_1_N = mkN "ostencilerbarhet" ; -- ostencilerbarhet..nn.1
  ostenograferad_1_A = mkA "ostenograferad" ; -- ostenograferad..av.1
  ostenograferbar_1_A = mkA "ostenograferbar" ; -- ostenograferbar..av.1
  ostenograferbarhet_1_N = mkN "ostenograferbarhet" ; -- ostenograferbarhet..nn.1
  ostensiv_1_A = mkA "ostensiv" ; -- ostensiv..av.1
  ostentation_1_N = mkN "ostentation" ; -- ostentation..nn.1
  ostentativ_1_A = mkA "ostentativ" ; -- ostentativ..av.1
  osteolog_1_N = mkN "osteolog" "osteologer" ; -- osteolog..nn.1
  osteologi_1_N = mkN "osteologi" ; -- osteologi..nn.1
  osteoporos_1_N = mkN "osteoporos" "osteoporoser" ; -- osteoporos..nn.1
  ostereotyperad_1_A = mkA "ostereotyperad" ; -- ostereotyperad..av.1
  ostereotyperbar_1_A = mkA "ostereotyperbar" ; -- ostereotyperbar..av.1
  ostereotyperbarhet_1_N = mkN "ostereotyperbarhet" ; -- ostereotyperbarhet..nn.1
  osteria_1_N = mkN "osteria" ; -- osteria..nn.1
  osteriliserad_1_A = mkA "osteriliserad" ; -- osteriliserad..av.1
  osteriliserbar_1_A = mkA "osteriliserbar" ; -- osteriliserbar..av.1
  osteriliserbarhet_1_N = mkN "osteriliserbarhet" ; -- osteriliserbarhet..nn.1
  ostfluga_1_N = mkN "ostfluga" ; -- ostfluga..nn.1
  ostfondue_1_N = mkN "ostfondue" "ostfonduer" ; -- ostfondue..nn.1
  ostfondy_1_N = mkN "ostfondy" "ostfondyer" ; -- ostfondy..nn.1
  ostframställning_1_N = mkN "ostframställning" ; -- ostframställning..nn.1
  osthyvel_1_N = mkN "osthyvel" ; -- osthyvel..nn.1
  osthyvelsprincip_1_N = mkN "osthyvelsprincip" ; -- osthyvelsprincip..nn.1
  ostig_1_A = mkA "ostig" ; -- ostig..av.1
  ostighet_1_N = mkN "ostighet" ; -- ostighet..nn.1
  ostigmatiserad_1_A = mkA "ostigmatiserad" ; -- ostigmatiserad..av.1
  ostigmatiserbar_1_A = mkA "ostigmatiserbar" ; -- ostigmatiserbar..av.1
  ostigmatiserbarhet_1_N = mkN "ostigmatiserbarhet" ; -- ostigmatiserbarhet..nn.1
  ostiliserad_1_A = mkA "ostiliserad" ; -- ostiliserad..av.1
  ostiliserbar_1_A = mkA "ostiliserbar" ; -- ostiliserbar..av.1
  ostiliserbarhet_1_N = mkN "ostiliserbarhet" ; -- ostiliserbarhet..nn.1
  ostimulerad_1_A = mkA "ostimulerad" ; -- ostimulerad..av.1
  ostimulerbar_1_A = mkA "ostimulerbar" ; -- ostimulerbar..av.1
  ostimulerbarhet_1_N = mkN "ostimulerbarhet" ; -- ostimulerbarhet..nn.1
  ostinato_1_N = mkN "ostinato" "ostinatot" "ostinaton" "ostinatona" ; -- ostinato..nn.1
  ostindiefarare_1_N = mkN "ostindiefarare" utrum  ; -- ostindiefarare..nn.1
  ostindisk_1_A = mkA "ostindisk" ; -- ostindisk..av.1
  ostipendierad_1_A = mkA "ostipendierad" ; -- ostipendierad..av.1
  ostipendierbar_1_A = mkA "ostipendierbar" ; -- ostipendierbar..av.1
  ostipendierbarhet_1_N = mkN "ostipendierbarhet" ; -- ostipendierbarhet..nn.1
  ostipulerad_1_A = mkA "ostipulerad" ; -- ostipulerad..av.1
  ostipulerbar_1_A = mkA "ostipulerbar" ; -- ostipulerbar..av.1
  ostipulerbarhet_1_N = mkN "ostipulerbarhet" ; -- ostipulerbarhet..nn.1
  ostjak_1_N = mkN "ostjak" "ostjaker" ; -- ostjak..nn.1
  ostjakisk_1_A = mkA "ostjakisk" ; -- ostjakisk..av.1
  ostjakiska_1_N = mkN "ostjakiska" ; -- ostjakiska..nn.1
  ostkaka_1_N = mkN "ostkaka" ; -- ostkaka..nn.1
  ostkant_1_N = mkN "ostkant" "ostkanter" ; -- ostkant..nn.1
  ostkrok_1_N = mkN "ostkrok" ; -- ostkrok..nn.1
  ostkräm_1_N = mkN "ostkräm" "ostkrämer" ; -- ostkräm..nn.1
  ostkupa_1_N = mkN "ostkupa" ; -- ostkupa..nn.1
  ostkust_1_N = mkN "ostkust" "ostkuster" ; -- ostkust..nn.1
  ostlig_1_A = mkA "ostlig" ; -- ostlig..av.1
  ostliknande_1_A = mkA "ostliknande" ; -- ostliknande..av.1
  ostlöpe_1_N = mkN "ostlöpe" ; -- ostlöpe..nn.1
  ostmacka_1_N = mkN "ostmacka" ; -- ostmacka..nn.1
  ostmask_1_N = mkN "ostmask" ; -- ostmask..nn.1
  ostmassa_1_N = mkN "ostmassa" ; -- ostmassa..nn.1
  ostnordost_1_Adv = mkAdv "ostnordost" ; -- ostnordost..ab.1
  ostofferad_1_A = mkA "ostofferad" ; -- ostofferad..av.1
  ostofferbar_1_A = mkA "ostofferbar" ; -- ostofferbar..av.1
  ostofferbarhet_1_N = mkN "ostofferbarhet" ; -- ostofferbarhet..nn.1
  ostra_1_N = mkN "ostra" ; -- ostra..nn.1
  ostracism_1_N = mkN "ostracism" "ostracismer" ; -- ostracism..nn.1
  ostraffad_1_A = mkA "ostraffad" ; -- ostraffad..av.1
  ostrafflig_1_A = mkA "ostrafflig" ; -- ostrafflig..av.1
  ostrafflighet_1_N = mkN "ostrafflighet" ; -- ostrafflighet..nn.1
  ostrangulerad_1_A = mkA "ostrangulerad" ; -- ostrangulerad..av.1
  ostrangulerbar_1_A = mkA "ostrangulerbar" ; -- ostrangulerbar..av.1
  ostrangulerbarhet_1_N = mkN "ostrangulerbarhet" ; -- ostrangulerbarhet..nn.1
  ostratifierad_1_A = mkA "ostratifierad" ; -- ostratifierad..av.1
  ostratifierbar_1_A = mkA "ostratifierbar" ; -- ostratifierbar..av.1
  ostratifierbarhet_1_N = mkN "ostratifierbarhet" ; -- ostratifierbarhet..nn.1
  ostrest_1_N = mkN "ostrest" "ostrester" ; -- ostrest..nn.1
  ostridig_1_A = mkA "ostridig" ; -- ostridig..av.1
  ostridighet_1_N = mkN "ostridighet" ; -- ostridighet..nn.1
  ostron_1_N = mkN "ostron" neutrum  ; -- ostron..nn.1
  ostronbank_1_N = mkN "ostronbank" ; -- ostronbank..nn.1
  ostronförgiftning_1_N = mkN "ostronförgiftning" ; -- ostronförgiftning..nn.1
  ostronkniv_1_N = mkN "ostronkniv" ; -- ostronkniv..nn.1
  ostronskal_1_N = mkN "ostronskal" neutrum  ; -- ostronskal..nn.1
  ostronört_1_N = mkN "ostronört" ; -- ostronört..nn.1
  ostruken_1_A = mkA "ostruken" ; -- ostruken..av.1
  ostrukturerad_1_A = mkA "ostrukturerad" ; -- ostrukturerad..av.1
  ostrukturerbar_1_A = mkA "ostrukturerbar" ; -- ostrukturerbar..av.1
  ostrukturerbarhet_1_N = mkN "ostrukturerbarhet" ; -- ostrukturerbarhet..nn.1
  ostskalk_1_N = mkN "ostskalk" ; -- ostskalk..nn.1
  ostskiva_1_N = mkN "ostskiva" ; -- ostskiva..nn.1
  ostskärare_1_N = mkN "ostskärare" utrum  ; -- ostskärare..nn.1
  ostsmörgås_1_N = mkN "ostsmörgås" ; -- ostsmörgås..nn.1
  oststång_1_N = mkN "oststång" "oststänger" ; -- oststång..nn.1
  ostsydost_1_Adv = mkAdv "ostsydost" ; -- ostsydost..ab.1
  ostsås_1_N = mkN "ostsås" "ostsåser" ; -- ostsås..nn.1
  ostuderad_1_A = mkA "ostuderad" ; -- ostuderad..av.1
  ostuderbar_1_A = mkA "ostuderbar" ; -- ostuderbar..av.1
  ostuderbarhet_1_N = mkN "ostuderbarhet" ; -- ostuderbarhet..nn.1
  ostvart_1_Adv = mkAdv "ostvart" ; -- ostvart..ab.1
  ostvassla_1_N = mkN "ostvassla" ; -- ostvassla..nn.1
  ostyckad_1_A = mkA "ostyckad" ; -- ostyckad..av.1
  ostympad_1_A = mkA "ostympad" ; -- ostympad..av.1
  ostyrig_1_A = mkA "ostyrig" ; -- ostyrig..av.1
  ostyrighet_1_N = mkN "ostyrighet" ; -- ostyrighet..nn.1
  ostyrkt_1_A = mkA "ostyrkt" "ostyrkt" ; -- ostyrkt..av.1
  ostädad_1_A = mkA "ostädad" ; -- ostädad..av.1
  ostämd_1_A = mkA "ostämd" "ostämt" ; -- ostämd..av.1
  ostämdhet_1_N = mkN "ostämdhet" ; -- ostämdhet..nn.1
  ostämne_1_N = mkN "ostämne" ; -- ostämne..nn.1
  ostämplad_1_A = mkA "ostämplad" ; -- ostämplad..av.1
  ostärkt_1_A = mkA "ostärkt" "ostärkt" ; -- ostärkt..av.1
  ostörd_1_A = mkA "ostörd" "ostört" ; -- ostörd..av.1
  ostördhet_1_N = mkN "ostördhet" ; -- ostördhet..nn.1
  osublimerad_1_A = mkA "osublimerad" ; -- osublimerad..av.1
  osublimerbar_1_A = mkA "osublimerbar" ; -- osublimerbar..av.1
  osublimerbarhet_1_N = mkN "osublimerbarhet" ; -- osublimerbarhet..nn.1
  osubordinerad_1_A = mkA "osubordinerad" ; -- osubordinerad..av.1
  osubordinerbar_1_A = mkA "osubordinerbar" ; -- osubordinerbar..av.1
  osubordinerbarhet_1_N = mkN "osubordinerbarhet" ; -- osubordinerbarhet..nn.1
  osubsidierad_1_A = mkA "osubsidierad" ; -- osubsidierad..av.1
  osubsidierbar_1_A = mkA "osubsidierbar" ; -- osubsidierbar..av.1
  osubsidierbarhet_1_N = mkN "osubsidierbarhet" ; -- osubsidierbarhet..nn.1
  osubskriberad_1_A = mkA "osubskriberad" ; -- osubskriberad..av.1
  osubskriberbar_1_A = mkA "osubskriberbar" ; -- osubskriberbar..av.1
  osubskriberbarhet_1_N = mkN "osubskriberbarhet" ; -- osubskriberbarhet..nn.1
  osubstantiverad_1_A = mkA "osubstantiverad" ; -- osubstantiverad..av.1
  osubstantiverbar_1_A = mkA "osubstantiverbar" ; -- osubstantiverbar..av.1
  osubstantiverbarhet_1_N = mkN "osubstantiverbarhet" ; -- osubstantiverbarhet..nn.1
  osubstituerad_1_A = mkA "osubstituerad" ; -- osubstituerad..av.1
  osubstituerbar_1_A = mkA "osubstituerbar" ; -- osubstituerbar..av.1
  osubstituerbarhet_1_N = mkN "osubstituerbarhet" ; -- osubstituerbarhet..nn.1
  osubsumerad_1_A = mkA "osubsumerad" ; -- osubsumerad..av.1
  osubsumerbar_1_A = mkA "osubsumerbar" ; -- osubsumerbar..av.1
  osubsumerbarhet_1_N = mkN "osubsumerbarhet" ; -- osubsumerbarhet..nn.1
  osubtraherad_1_A = mkA "osubtraherad" ; -- osubtraherad..av.1
  osubtraherbar_1_A = mkA "osubtraherbar" ; -- osubtraherbar..av.1
  osubtraherbarhet_1_N = mkN "osubtraherbarhet" ; -- osubtraherbarhet..nn.1
  osubventionerad_1_A = mkA "osubventionerad" ; -- osubventionerad..av.1
  osubventionerbar_1_A = mkA "osubventionerbar" ; -- osubventionerbar..av.1
  osubventionerbarhet_1_N = mkN "osubventionerbarhet" ; -- osubventionerbarhet..nn.1
  osuccederad_1_A = mkA "osuccederad" ; -- osuccederad..av.1
  osuccederbar_1_A = mkA "osuccederbar" ; -- osuccederbar..av.1
  osuccederbarhet_1_N = mkN "osuccederbarhet" ; -- osuccederbarhet..nn.1
  osuffigerad_1_A = mkA "osuffigerad" ; -- osuffigerad..av.1
  osuffigerbar_1_A = mkA "osuffigerbar" ; -- osuffigerbar..av.1
  osuffigerbarhet_1_N = mkN "osuffigerbarhet" ; -- osuffigerbarhet..nn.1
  osufflerad_1_A = mkA "osufflerad" ; -- osufflerad..av.1
  osufflerbar_1_A = mkA "osufflerbar" ; -- osufflerbar..av.1
  osufflerbarhet_1_N = mkN "osufflerbarhet" ; -- osufflerbarhet..nn.1
  osuggererad_1_A = mkA "osuggererad" ; -- osuggererad..av.1
  osuggererbar_1_A = mkA "osuggererbar" ; -- osuggererbar..av.1
  osuggererbarhet_1_N = mkN "osuggererbarhet" ; -- osuggererbarhet..nn.1
  osummerad_1_A = mkA "osummerad" ; -- osummerad..av.1
  osummerbar_1_A = mkA "osummerbar" ; -- osummerbar..av.1
  osummerbarhet_1_N = mkN "osummerbarhet" ; -- osummerbarhet..nn.1
  osund_1_A = mkA "osund" ; -- osund..av.1
  osundhet_1_N = mkN "osundhet" "osundheter" ; -- osundhet..nn.1
  osupplerad_1_A = mkA "osupplerad" ; -- osupplerad..av.1
  osupplerbar_1_A = mkA "osupplerbar" ; -- osupplerbar..av.1
  osupplerbarhet_1_N = mkN "osupplerbarhet" ; -- osupplerbarhet..nn.1
  osupponerad_1_A = mkA "osupponerad" ; -- osupponerad..av.1
  osupponerbar_1_A = mkA "osupponerbar" ; -- osupponerbar..av.1
  osupponerbarhet_1_N = mkN "osupponerbarhet" ; -- osupponerbarhet..nn.1
  osurfbar_1_A = mkA "osurfbar" ; -- osurfbar..av.1
  osurfbarhet_1_N = mkN "osurfbarhet" ; -- osurfbarhet..nn.1
  osuspenderad_1_A = mkA "osuspenderad" ; -- osuspenderad..av.1
  osuspenderbar_1_A = mkA "osuspenderbar" ; -- osuspenderbar..av.1
  osuspenderbarhet_1_N = mkN "osuspenderbarhet" ; -- osuspenderbarhet..nn.1
  osvensk_1_A = mkA "osvensk" ; -- osvensk..av.1
  osviklig_1_A = mkA "osviklig" ; -- osviklig..av.1
  osviklighet_1_N = mkN "osviklighet" ; -- osviklighet..nn.1
  osvuren_1_A = mkA "osvuren" ; -- osvuren..av.1
  osymboliserad_1_A = mkA "osymboliserad" ; -- osymboliserad..av.1
  osymboliserbar_1_A = mkA "osymboliserbar" ; -- osymboliserbar..av.1
  osymboliserbarhet_1_N = mkN "osymboliserbarhet" ; -- osymboliserbarhet..nn.1
  osymmetrisk_1_A = mkA "osymmetrisk" ; -- osymmetrisk..av.1
  osympatisk_1_A = mkA "osympatisk" ; -- osympatisk..av.1
  osynkoperad_1_A = mkA "osynkoperad" ; -- osynkoperad..av.1
  osynkoperbar_1_A = mkA "osynkoperbar" ; -- osynkoperbar..av.1
  osynkoperbarhet_1_N = mkN "osynkoperbarhet" ; -- osynkoperbarhet..nn.1
  osynkroniserad_1_A = mkA "osynkroniserad" ; -- osynkroniserad..av.1
  osynkroniserbar_1_A = mkA "osynkroniserbar" ; -- osynkroniserbar..av.1
  osynkroniserbarhet_1_N = mkN "osynkroniserbarhet" ; -- osynkroniserbarhet..nn.1
  osynlig_1_A = mkA "osynlig" ; -- osynlig..av.1
  osynliggöra_1_V = mkV "osynliggöra" "osynliggjorde" "osynliggjort" ; -- osynliggöra..vb.1
  osynliggörande_1_N = mkN "osynliggörande" ; -- osynliggörande..nn.1
  osynliggöring_1_N = mkN "osynliggöring" ; -- osynliggöring..nn.1
  osynlighet_1_N = mkN "osynlighet" "osynligheter" ; -- osynlighet..nn.1
  osyntetiserad_1_A = mkA "osyntetiserad" ; -- osyntetiserad..av.1
  osyntetiserbar_1_A = mkA "osyntetiserbar" ; -- osyntetiserbar..av.1
  osyntetiserbarhet_1_N = mkN "osyntetiserbarhet" ; -- osyntetiserbarhet..nn.1
  osyrad_1_A = mkA "osyrad" ; -- osyrad..av.1
  osystematiserad_1_A = mkA "osystematiserad" ; -- osystematiserad..av.1
  osystematiserbar_1_A = mkA "osystematiserbar" ; -- osystematiserbar..av.1
  osystematiserbarhet_1_N = mkN "osystematiserbarhet" ; -- osystematiserbarhet..nn.1
  osystematisk_1_A = mkA "osystematisk" ; -- osystematisk..av.1
  osägbar_1_A = mkA "osägbar" ; -- osägbar..av.1
  osägbarhet_1_N = mkN "osägbarhet" ; -- osägbarhet..nn.1
  osäglig_1_A = mkA "osäglig" ; -- osäglig..av.1
  osäglighet_1_N = mkN "osäglighet" ; -- osäglighet..nn.1
  osäker_1_A = mkA "osäker" ; -- osäker..av.1
  osäkerhet_1_N = mkN "osäkerhet" "osäkerheter" ; -- osäkerhet..nn.1
  osäkerhetsmoment_1_N = mkN "osäkerhetsmoment" neutrum  ; -- osäkerhetsmoment..nn.1
  osäkerhetsrelation_1_N = mkN "osäkerhetsrelation" ; -- osäkerhetsrelation..nn.1
  osäkerhetstillstånd_1_N = mkN "osäkerhetstillstånd" neutrum  ; -- osäkerhetstillstånd..nn.1
  osäkra_1_V = mkV "osäkrar" ; -- osäkra..vb.1
  osäkrande_1_N = mkN "osäkrande" ; -- osäkrande..nn.1
  osäljbar_1_A = mkA "osäljbar" ; -- osäljbar..av.1
  osäljbarhet_1_N = mkN "osäljbarhet" ; -- osäljbarhet..nn.1
  osäll_1_A = mkA "osäll" ; -- osäll..av.1
  osällhet_1_N = mkN "osällhet" ; -- osällhet..nn.1
  osällskaplig_1_A = mkA "osällskaplig" ; -- osällskaplig..av.1
  osällskaplighet_1_N = mkN "osällskaplighet" ; -- osällskaplighet..nn.1
  osämja_1_N = mkN "osämja" ; -- osämja..nn.1
  osänkbar_1_A = mkA "osänkbar" ; -- osänkbar..av.1
  osänkbarhet_1_N = mkN "osänkbarhet" ; -- osänkbarhet..nn.1
  osåld_1_A = mkA "osåld" "osålt" ; -- osåld..av.1
  osårad_1_A = mkA "osårad" ; -- osårad..av.1
  osårbar_1_A = mkA "osårbar" ; -- osårbar..av.1
  osårbarhet_1_N = mkN "osårbarhet" ; -- osårbarhet..nn.1
  osåterad_1_A = mkA "osåterad" ; -- osåterad..av.1
  osåterbar_1_A = mkA "osåterbar" ; -- osåterbar..av.1
  osåterbarhet_1_N = mkN "osåterbarhet" ; -- osåterbarhet..nn.1
  osåverad_1_A = mkA "osåverad" ; -- osåverad..av.1
  osåverbar_1_A = mkA "osåverbar" ; -- osåverbar..av.1
  osåverbarhet_1_N = mkN "osåverbarhet" ; -- osåverbarhet..nn.1
  osökt_1_A = mkA "osökt" "osökt" ; -- osökt..av.1
  osökthet_1_N = mkN "osökthet" ; -- osökthet..nn.1
  osöndrad_1_A = mkA "osöndrad" ; -- osöndrad..av.1
  osötad_1_A = mkA "osötad" ; -- osötad..av.1
  otabellerad_1_A = mkA "otabellerad" ; -- otabellerad..av.1
  otabellerbar_1_A = mkA "otabellerbar" ; -- otabellerbar..av.1
  otabellerbarhet_1_N = mkN "otabellerbarhet" ; -- otabellerbarhet..nn.1
  otabuerad_1_A = mkA "otabuerad" ; -- otabuerad..av.1
  otabuerbar_1_A = mkA "otabuerbar" ; -- otabuerbar..av.1
  otabuerbarhet_1_N = mkN "otabuerbarhet" ; -- otabuerbarhet..nn.1
  otack_1_N = mkN "otack" neutrum  ; -- otack..nn.1
  otackad_1_A = mkA "otackad" ; -- otackad..av.1
  otacksam_1_A = mkA "otacksam" "otacksamt" "otacksamma" "otacksamma" "otacksammare" "otacksammast" "otacksammaste" ; -- otacksam..av.1
  otacksamhet_1_N = mkN "otacksamhet" ; -- otacksamhet..nn.1
  otadlig_1_A = mkA "otadlig" ; -- otadlig..av.1
  otadlighet_1_N = mkN "otadlighet" ; -- otadlighet..nn.1
  otagbar_1_A = mkA "otagbar" ; -- otagbar..av.1
  otaggad_1_A = mkA "otaggad" ; -- otaggad..av.1
  otal_1_N = mkN "otal" ; -- otal..nn.1
  otalig_1_A = mkA "otalig" ; -- otalig..av.1
  otalighet_1_N = mkN "otalighet" ; -- otalighet..nn.1
  otalt_1_N = mkN "otalt" ; -- otalt..nn.1
  otamponerad_1_A = mkA "otamponerad" ; -- otamponerad..av.1
  otamponerbar_1_A = mkA "otamponerbar" ; -- otamponerbar..av.1
  otamponerbarhet_1_N = mkN "otamponerbarhet" ; -- otamponerbarhet..nn.1
  otandad_1_A = mkA "otandad" ; -- otandad..av.1
  otangerad_1_A = mkA "otangerad" ; -- otangerad..av.1
  otangerbar_1_A = mkA "otangerbar" ; -- otangerbar..av.1
  otangerbarhet_1_N = mkN "otangerbarhet" ; -- otangerbarhet..nn.1
  otapetserad_1_A = mkA "otapetserad" ; -- otapetserad..av.1
  otapetserbar_1_A = mkA "otapetserbar" ; -- otapetserbar..av.1
  otapetserbarhet_1_N = mkN "otapetserbarhet" ; -- otapetserbarhet..nn.1
  otarerad_1_A = mkA "otarerad" ; -- otarerad..av.1
  otarerbar_1_A = mkA "otarerbar" ; -- otarerbar..av.1
  otarerbarhet_1_N = mkN "otarerbarhet" ; -- otarerbarhet..nn.1
  otarifferad_1_A = mkA "otarifferad" ; -- otarifferad..av.1
  otarifferbar_1_A = mkA "otarifferbar" ; -- otarifferbar..av.1
  otarifferbarhet_1_N = mkN "otarifferbarhet" ; -- otarifferbarhet..nn.1
  otatuerad_1_A = mkA "otatuerad" ; -- otatuerad..av.1
  otatuerbar_1_A = mkA "otatuerbar" ; -- otatuerbar..av.1
  otatuerbarhet_1_N = mkN "otatuerbarhet" ; -- otatuerbarhet..nn.1
  otaxerad_1_A = mkA "otaxerad" ; -- otaxerad..av.1
  otaxerbar_1_A = mkA "otaxerbar" ; -- otaxerbar..av.1
  otaxerbarhet_1_N = mkN "otaxerbarhet" ; -- otaxerbarhet..nn.1
  oteknifierad_1_A = mkA "oteknifierad" ; -- oteknifierad..av.1
  oteknifierbar_1_A = mkA "oteknifierbar" ; -- oteknifierbar..av.1
  oteknifierbarhet_1_N = mkN "oteknifierbarhet" ; -- oteknifierbarhet..nn.1
  oteknisk_1_A = mkA "oteknisk" ; -- oteknisk..av.1
  otelefonerad_1_A = mkA "otelefonerad" ; -- otelefonerad..av.1
  otelefonerbar_1_A = mkA "otelefonerbar" ; -- otelefonerbar..av.1
  otelefonerbarhet_1_N = mkN "otelefonerbarhet" ; -- otelefonerbarhet..nn.1
  otelegraferad_1_A = mkA "otelegraferad" ; -- otelegraferad..av.1
  otelegraferbar_1_A = mkA "otelegraferbar" ; -- otelegraferbar..av.1
  otelegraferbarhet_1_N = mkN "otelegraferbarhet" ; -- otelegraferbarhet..nn.1
  oteleviserad_1_A = mkA "oteleviserad" ; -- oteleviserad..av.1
  oteleviserbar_1_A = mkA "oteleviserbar" ; -- oteleviserbar..av.1
  oteleviserbarhet_1_N = mkN "oteleviserbarhet" ; -- oteleviserbarhet..nn.1
  otemperad_1_A = mkA "otemperad" ; -- otemperad..av.1
  otemperbar_1_A = mkA "otemperbar" ; -- otemperbar..av.1
  otemperbarhet_1_N = mkN "otemperbarhet" ; -- otemperbarhet..nn.1
  otempererad_1_A = mkA "otempererad" ; -- otempererad..av.1
  otempererbar_1_A = mkA "otempererbar" ; -- otempererbar..av.1
  otempererbarhet_1_N = mkN "otempererbarhet" ; -- otempererbarhet..nn.1
  otenterad_1_A = mkA "otenterad" ; -- otenterad..av.1
  otenterbar_1_A = mkA "otenterbar" ; -- otenterbar..av.1
  otenterbarhet_1_N = mkN "otenterbarhet" ; -- otenterbarhet..nn.1
  oterrasserad_1_A = mkA "oterrasserad" ; -- oterrasserad..av.1
  oterrasserbar_1_A = mkA "oterrasserbar" ; -- oterrasserbar..av.1
  oterrasserbarhet_1_N = mkN "oterrasserbarhet" ; -- oterrasserbarhet..nn.1
  oterroriserad_1_A = mkA "oterroriserad" ; -- oterroriserad..av.1
  oterroriserbar_1_A = mkA "oterroriserbar" ; -- oterroriserbar..av.1
  oterroriserbarhet_1_N = mkN "oterroriserbarhet" ; -- oterroriserbarhet..nn.1
  otesaurerad_1_A = mkA "otesaurerad" ; -- otesaurerad..av.1
  otesaurerbar_1_A = mkA "otesaurerbar" ; -- otesaurerbar..av.1
  otesaurerbarhet_1_N = mkN "otesaurerbarhet" ; -- otesaurerbarhet..nn.1
  otestamenterad_1_A = mkA "otestamenterad" ; -- otestamenterad..av.1
  otestamenterbar_1_A = mkA "otestamenterbar" ; -- otestamenterbar..av.1
  otestamenterbarhet_1_N = mkN "otestamenterbarhet" ; -- otestamenterbarhet..nn.1
  othello_1_N = mkN "othello" ; -- othello..nn.1
  otid_1_N = mkN "otid" ; -- otid..nn.1
  otidig_1_A = mkA "otidig" ; -- otidig..av.1
  otidighet_1_N = mkN "otidighet" "otidigheter" ; -- otidighet..nn.1
  otidsenlig_1_A = mkA "otidsenlig" ; -- otidsenlig..av.1
  otidsenlighet_1_N = mkN "otidsenlighet" "otidsenligheter" ; -- otidsenlighet..nn.1
  otillbörlig_1_A = mkA "otillbörlig" ; -- otillbörlig..av.1
  otillbörligen_1_Adv = mkAdv "otillbörligen" ; -- otillbörligen..ab.1
  otillbörlighet_1_N = mkN "otillbörlighet" "otillbörligheter" ; -- otillbörlighet..nn.1
  otillfreds_1_A = mkA "otillfreds" ; -- otillfreds..av.1
  otillfredsställande_1_A = mkA "otillfredsställande" ; -- otillfredsställande..av.1
  otillfredsställd_1_A = mkA "otillfredsställd" "otillfredsställt" ; -- otillfredsställd..av.1
  otillfredsställelse_1_N = mkN "otillfredsställelse" utrum  ; -- otillfredsställelse..nn.1
  otillförlitlig_1_A = mkA "otillförlitlig" ; -- otillförlitlig..av.1
  otillförlitlighet_1_N = mkN "otillförlitlighet" ; -- otillförlitlighet..nn.1
  otillgänglig_1_A = mkA "otillgänglig" ; -- otillgänglig..av.1
  otillgänglighet_1_N = mkN "otillgänglighet" "otillgängligheter" ; -- otillgänglighet..nn.1
  otillräcklig_1_A = mkA "otillräcklig" ; -- otillräcklig..av.1
  otillräcklighet_1_N = mkN "otillräcklighet" ; -- otillräcklighet..nn.1
  otillräknelig_1_A = mkA "otillräknelig" ; -- otillräknelig..av.1
  otillräknelighet_1_N = mkN "otillräknelighet" ; -- otillräknelighet..nn.1
  otillständig_1_A = mkA "otillständig" ; -- otillständig..av.1
  otillständighet_1_N = mkN "otillständighet" ; -- otillständighet..nn.1
  otillämplig_1_A = mkA "otillämplig" ; -- otillämplig..av.1
  otillämplighet_1_N = mkN "otillämplighet" ; -- otillämplighet..nn.1
  otillåten_1_A = mkA "otillåten" ; -- otillåten..av.1
  otillåtlig_1_A = mkA "otillåtlig" ; -- otillåtlig..av.1
  otillåtlighet_1_N = mkN "otillåtlighet" ; -- otillåtlighet..nn.1
  oting_1_N = mkN "oting" ; -- oting..nn.1
  otippad_1_A = mkA "otippad" ; -- otippad..av.1
  otit_1_N = mkN "otit" "otiter" ; -- otit..nn.1
  otitrerad_1_A = mkA "otitrerad" ; -- otitrerad..av.1
  otitrerbar_1_A = mkA "otitrerbar" ; -- otitrerbar..av.1
  otitrerbarhet_1_N = mkN "otitrerbarhet" ; -- otitrerbarhet..nn.1
  otitulerad_1_A = mkA "otitulerad" ; -- otitulerad..av.1
  otitulerbar_1_A = mkA "otitulerbar" ; -- otitulerbar..av.1
  otitulerbarhet_1_N = mkN "otitulerbarhet" ; -- otitulerbarhet..nn.1
  otium_1_N = mkN "otium" neutrum  ; -- otium..nn.1
  otjusig_1_A = mkA "otjusig" ; -- otjusig..av.1
  otjusighet_1_N = mkN "otjusighet" ; -- otjusighet..nn.1
  otjänlig_1_A = mkA "otjänlig" ; -- otjänlig..av.1
  otjänlighet_1_N = mkN "otjänlighet" ; -- otjänlighet..nn.1
  otjänst_1_N = mkN "otjänst" "otjänster" ; -- otjänst..nn.1
  otjänstbar_1_A = mkA "otjänstbar" ; -- otjänstbar..av.1
  otjänstbarhet_1_N = mkN "otjänstbarhet" ; -- otjänstbarhet..nn.1
  otolererad_1_A = mkA "otolererad" ; -- otolererad..av.1
  otolererbar_1_A = mkA "otolererbar" ; -- otolererbar..av.1
  otolererbarhet_1_N = mkN "otolererbarhet" ; -- otolererbarhet..nn.1
  otolog_1_N = mkN "otolog" "otologer" ; -- otolog..nn.1
  otologi_1_N = mkN "otologi" ; -- otologi..nn.1
  otorderad_1_A = mkA "otorderad" ; -- otorderad..av.1
  otorderbar_1_A = mkA "otorderbar" ; -- otorderbar..av.1
  otorderbarhet_1_N = mkN "otorderbarhet" ; -- otorderbarhet..nn.1
  otorpederad_1_A = mkA "otorpederad" ; -- otorpederad..av.1
  otorpederbar_1_A = mkA "otorpederbar" ; -- otorpederbar..av.1
  otorpederbarhet_1_N = mkN "otorpederbarhet" ; -- otorpederbarhet..nn.1
  otorterad_1_A = mkA "otorterad" ; -- otorterad..av.1
  otorterbar_1_A = mkA "otorterbar" ; -- otorterbar..av.1
  otorterbarhet_1_N = mkN "otorterbarhet" ; -- otorterbarhet..nn.1
  otoucherad_1_A = mkA "otoucherad" ; -- otoucherad..av.1
  otoucherbar_1_A = mkA "otoucherbar" ; -- otoucherbar..av.1
  otoucherbarhet_1_N = mkN "otoucherbarhet" ; -- otoucherbarhet..nn.1
  otouperad_1_A = mkA "otouperad" ; -- otouperad..av.1
  otouperbar_1_A = mkA "otouperbar" ; -- otouperbar..av.1
  otouperbarhet_1_N = mkN "otouperbarhet" ; -- otouperbarhet..nn.1
  otraderad_1_A = mkA "otraderad" ; -- otraderad..av.1
  otraderbar_1_A = mkA "otraderbar" ; -- otraderbar..av.1
  otraderbarhet_1_N = mkN "otraderbarhet" ; -- otraderbarhet..nn.1
  otraditionell_1_A = mkA "otraditionell" ; -- otraditionell..av.1
  otrafikerad_1_A = mkA "otrafikerad" ; -- otrafikerad..av.1
  otrafikerbar_1_A = mkA "otrafikerbar" ; -- otrafikerbar..av.1
  otrafikerbarhet_1_N = mkN "otrafikerbarhet" ; -- otrafikerbarhet..nn.1
  otrakasserad_1_A = mkA "otrakasserad" ; -- otrakasserad..av.1
  otrakasserbar_1_A = mkA "otrakasserbar" ; -- otrakasserbar..av.1
  otrakasserbarhet_1_N = mkN "otrakasserbarhet" ; -- otrakasserbarhet..nn.1
  otrakterad_1_A = mkA "otrakterad" ; -- otrakterad..av.1
  otrakterbar_1_A = mkA "otrakterbar" ; -- otrakterbar..av.1
  otrakterbarhet_1_N = mkN "otrakterbarhet" ; -- otrakterbarhet..nn.1
  otrampad_1_A = mkA "otrampad" ; -- otrampad..av.1
  otrancherad_1_A = mkA "otrancherad" ; -- otrancherad..av.1
  otrancherbar_1_A = mkA "otrancherbar" ; -- otrancherbar..av.1
  otrancherbarhet_1_N = mkN "otrancherbarhet" ; -- otrancherbarhet..nn.1
  otransfererad_1_A = mkA "otransfererad" ; -- otransfererad..av.1
  otransfererbar_1_A = mkA "otransfererbar" ; -- otransfererbar..av.1
  otransfererbarhet_1_N = mkN "otransfererbarhet" ; -- otransfererbarhet..nn.1
  otransformerad_1_A = mkA "otransformerad" ; -- otransformerad..av.1
  otransformerbar_1_A = mkA "otransformerbar" ; -- otransformerbar..av.1
  otransformerbarhet_1_N = mkN "otransformerbarhet" ; -- otransformerbarhet..nn.1
  otransiterad_1_A = mkA "otransiterad" ; -- otransiterad..av.1
  otransiterbar_1_A = mkA "otransiterbar" ; -- otransiterbar..av.1
  otransiterbarhet_1_N = mkN "otransiterbarhet" ; -- otransiterbarhet..nn.1
  otranskriberad_1_A = mkA "otranskriberad" ; -- otranskriberad..av.1
  otranskriberbar_1_A = mkA "otranskriberbar" ; -- otranskriberbar..av.1
  otranskriberbarhet_1_N = mkN "otranskriberbarhet" ; -- otranskriberbarhet..nn.1
  otranslittererad_1_A = mkA "otranslittererad" ; -- otranslittererad..av.1
  otranslittererbar_1_A = mkA "otranslittererbar" ; -- otranslittererbar..av.1
  otranslittererbarhet_1_N = mkN "otranslittererbarhet" ; -- otranslittererbarhet..nn.1
  otransmitterad_1_A = mkA "otransmitterad" ; -- otransmitterad..av.1
  otransmitterbar_1_A = mkA "otransmitterbar" ; -- otransmitterbar..av.1
  otransmitterbarhet_1_N = mkN "otransmitterbarhet" ; -- otransmitterbarhet..nn.1
  otransmuterad_1_A = mkA "otransmuterad" ; -- otransmuterad..av.1
  otransmuterbar_1_A = mkA "otransmuterbar" ; -- otransmuterbar..av.1
  otransmuterbarhet_1_N = mkN "otransmuterbarhet" ; -- otransmuterbarhet..nn.1
  otransplanterad_1_A = mkA "otransplanterad" ; -- otransplanterad..av.1
  otransplanterbar_1_A = mkA "otransplanterbar" ; -- otransplanterbar..av.1
  otransplanterbarhet_1_N = mkN "otransplanterbarhet" ; -- otransplanterbarhet..nn.1
  otransponerad_1_A = mkA "otransponerad" ; -- otransponerad..av.1
  otransponerbar_1_A = mkA "otransponerbar" ; -- otransponerbar..av.1
  otransponerbarhet_1_N = mkN "otransponerbarhet" ; -- otransponerbarhet..nn.1
  otransporterad_1_A = mkA "otransporterad" ; -- otransporterad..av.1
  otransporterbar_1_A = mkA "otransporterbar" ; -- otransporterbar..av.1
  otransporterbarhet_1_N = mkN "otransporterbarhet" ; -- otransporterbarhet..nn.1
  otransumerad_1_A = mkA "otransumerad" ; -- otransumerad..av.1
  otransumerbar_1_A = mkA "otransumerbar" ; -- otransumerbar..av.1
  otransumerbarhet_1_N = mkN "otransumerbarhet" ; -- otransumerbarhet..nn.1
  otrasserad_1_A = mkA "otrasserad" ; -- otrasserad..av.1
  otrasserbar_1_A = mkA "otrasserbar" ; -- otrasserbar..av.1
  otrasserbarhet_1_N = mkN "otrasserbarhet" ; -- otrasserbarhet..nn.1
  otraumatiserbar_1_A = mkA "otraumatiserbar" ; -- otraumatiserbar..av.1
  otraumatiserbarhet_1_N = mkN "otraumatiserbarhet" ; -- otraumatiserbarhet..nn.1
  otravesterad_1_A = mkA "otravesterad" ; -- otravesterad..av.1
  otravesterbar_1_A = mkA "otravesterbar" ; -- otravesterbar..av.1
  otravesterbarhet_1_N = mkN "otravesterbarhet" ; -- otravesterbarhet..nn.1
  otrendig_1_A = mkA "otrendig" ; -- otrendig..av.1
  otrepanerad_1_A = mkA "otrepanerad" ; -- otrepanerad..av.1
  otrepanerbar_1_A = mkA "otrepanerbar" ; -- otrepanerbar..av.1
  otrepanerbarhet_1_N = mkN "otrepanerbarhet" ; -- otrepanerbarhet..nn.1
  otrevlig_1_A = mkA "otrevlig" ; -- otrevlig..av.1
  otrevlighet_1_N = mkN "otrevlighet" "otrevligheter" ; -- otrevlighet..nn.1
  otrevnad_1_N = mkN "otrevnad" ; -- otrevnad..nn.1
  otriangulerad_1_A = mkA "otriangulerad" ; -- otriangulerad..av.1
  otriangulerbar_1_A = mkA "otriangulerbar" ; -- otriangulerbar..av.1
  otriangulerbarhet_1_N = mkN "otriangulerbarhet" ; -- otriangulerbarhet..nn.1
  otrierad_1_A = mkA "otrierad" ; -- otrierad..av.1
  otrierbar_1_A = mkA "otrierbar" ; -- otrierbar..av.1
  otrierbarhet_1_N = mkN "otrierbarhet" ; -- otrierbarhet..nn.1
  otrivialiserad_1_A = mkA "otrivialiserad" ; -- otrivialiserad..av.1
  otrivialiserbar_1_A = mkA "otrivialiserbar" ; -- otrivialiserbar..av.1
  otrivialiserbarhet_1_N = mkN "otrivialiserbarhet" ; -- otrivialiserbarhet..nn.1
  otrivsam_1_A = mkA "otrivsam" "otrivsamt" "otrivsamma" "otrivsamma" "otrivsammare" "otrivsammast" "otrivsammaste" ; -- otrivsam..av.1
  otrivsamhet_1_N = mkN "otrivsamhet" ; -- otrivsamhet..nn.1
  otrivsel_1_N = mkN "otrivsel" ; -- otrivsel..nn.1
  otro_1_N = mkN "otro" ; -- otro..nn.1
  otrogen_1_A = mkA "otrogen" ; -- otrogen..av.1
  otrohet_1_N = mkN "otrohet" "otroheter" ; -- otrohet..nn.1
  otrohetsaffär_1_N = mkN "otrohetsaffär" "otrohetsaffärer" ; -- otrohetsaffär..nn.1
  otrohetsdrama_1_N = mkN "otrohetsdrama" "otrohetsdramat" "otrohetsdramer" "otrohetsdramerna" ; -- otrohetsdrama..nn.1
  otrohetsgräl_1_N = mkN "otrohetsgräl" neutrum  ; -- otrohetsgräl..nn.1
  otrohetsskandal_1_N = mkN "otrohetsskandal" "otrohetsskandaler" ; -- otrohetsskandal..nn.1
  otrohetstrassel_1_N = mkN "otrohetstrassel" neutrum  ; -- otrohetstrassel..nn.1
  otrohetsuppgift_1_N = mkN "otrohetsuppgift" "otrohetsuppgifter" ; -- otrohetsuppgift..nn.1
  otrolig_1_A = mkA "otrolig" ; -- otrolig..av.1
  otrolig_2_A = mkA "otrolig" ; -- otrolig..av.2
  otrolighet_1_N = mkN "otrolighet" "otroligheter" ; -- otrolighet..nn.1
  otryckbar_1_A = mkA "otryckbar" ; -- otryckbar..av.1
  otryckbarhet_1_N = mkN "otryckbarhet" "otryckbarheter" ; -- otryckbarhet..nn.1
  otryckt_1_A = mkA "otryckt" "otryckt" ; -- otryckt..av.1
  otryfferad_1_A = mkA "otryfferad" ; -- otryfferad..av.1
  otryfferbar_1_A = mkA "otryfferbar" ; -- otryfferbar..av.1
  otryfferbarhet_1_N = mkN "otryfferbarhet" ; -- otryfferbarhet..nn.1
  otrygg_1_A = mkA "otrygg" ; -- otrygg..av.1
  otrygghet_1_N = mkN "otrygghet" ; -- otrygghet..nn.1
  otränad_1_A = mkA "otränad" ; -- otränad..av.1
  otröskad_1_A = mkA "otröskad" ; -- otröskad..av.1
  otröstlig_1_A = mkA "otröstlig" ; -- otröstlig..av.1
  otröstlighet_1_N = mkN "otröstlighet" ; -- otröstlighet..nn.1
  otröttlig_1_A = mkA "otröttlig" ; -- otröttlig..av.1
  otröttlighet_1_N = mkN "otröttlighet" ; -- otröttlighet..nn.1
  otta_1_N = mkN "otta" ; -- otta..nn.1
  ottesång_1_N = mkN "ottesång" ; -- ottesång..nn.1
  ottoman_1_N = mkN "ottoman" "ottomaner" ; -- ottoman..nn.1
  ottomansk_1_A = mkA "ottomansk" ; -- ottomansk..av.1
  ottomotor_1_N = mkN "ottomotor" "ottomotorer" ; -- ottomotor..nn.1
  otukt_1_N = mkN "otukt" ; -- otukt..nn.1
  otuktad_1_A = mkA "otuktad" ; -- otuktad..av.1
  otuktig_1_A = mkA "otuktig" ; -- otuktig..av.1
  otuperad_1_A = mkA "otuperad" ; -- otuperad..av.1
  otuperbar_1_A = mkA "otuperbar" ; -- otuperbar..av.1
  otuperbarhet_1_N = mkN "otuperbarhet" ; -- otuperbarhet..nn.1
  otur_1_N = mkN "otur" ; -- otur..nn.1
  oturlig_1_A = mkA "oturlig" ; -- oturlig..av.1
  oturlighet_1_N = mkN "oturlighet" ; -- oturlighet..nn.1
  oturnerad_1_A = mkA "oturnerad" ; -- oturnerad..av.1
  oturnerbar_1_A = mkA "oturnerbar" ; -- oturnerbar..av.1
  oturnerbarhet_1_N = mkN "oturnerbarhet" ; -- oturnerbarhet..nn.1
  otursam_1_A = mkA "otursam" "otursamt" "otursamma" "otursamma" "otursammare" "otursammast" "otursammaste" ; -- otursam..av.1
  otursamhet_1_N = mkN "otursamhet" ; -- otursamhet..nn.1
  otursdag_1_N = mkN "otursdag" ; -- otursdag..nn.1
  otursförföljd_1_A = mkA "otursförföljd" "otursförföljt" ; -- otursförföljd..av.1
  otursförföljdhet_1_N = mkN "otursförföljdhet" ; -- otursförföljdhet..nn.1
  otuscherad_1_A = mkA "otuscherad" ; -- otuscherad..av.1
  otuscherbar_1_A = mkA "otuscherbar" ; -- otuscherbar..av.1
  otuscherbarhet_1_N = mkN "otuscherbarhet" ; -- otuscherbarhet..nn.1
  otvetydig_1_A = mkA "otvetydig" ; -- otvetydig..av.1
  otvetydighet_1_N = mkN "otvetydighet" ; -- otvetydighet..nn.1
  otvivelaktig_1_A = mkA "otvivelaktig" ; -- otvivelaktig..av.1
  otvivelaktighet_1_N = mkN "otvivelaktighet" ; -- otvivelaktighet..nn.1
  otvungen_1_A = mkA "otvungen" ; -- otvungen..av.1
  otvungenhet_1_N = mkN "otvungenhet" ; -- otvungenhet..nn.1
  otvättad_1_A = mkA "otvättad" ; -- otvättad..av.1
  otydbar_1_A = mkA "otydbar" ; -- otydbar..av.1
  otydbarhet_1_N = mkN "otydbarhet" ; -- otydbarhet..nn.1
  otydlig_1_A = mkA "otydlig" ; -- otydlig..av.1
  otydlighet_1_N = mkN "otydlighet" "otydligheter" ; -- otydlighet..nn.1
  otyg_1_N = mkN "otyg" neutrum  ; -- otyg..nn.1
  otyglad_1_A = mkA "otyglad" ; -- otyglad..av.1
  otymplig_1_A = mkA "otymplig" ; -- otymplig..av.1
  otymplighet_1_N = mkN "otymplighet" "otympligheter" ; -- otymplighet..nn.1
  otypifierad_1_A = mkA "otypifierad" ; -- otypifierad..av.1
  otypifierbar_1_A = mkA "otypifierbar" ; -- otypifierbar..av.1
  otypifierbarhet_1_N = mkN "otypifierbarhet" ; -- otypifierbarhet..nn.1
  otypiserad_1_A = mkA "otypiserad" ; -- otypiserad..av.1
  otypiserbar_1_A = mkA "otypiserbar" ; -- otypiserbar..av.1
  otypiserbarhet_1_N = mkN "otypiserbarhet" ; -- otypiserbarhet..nn.1
  otypisk_1_A = mkA "otypisk" ; -- otypisk..av.1
  otyranniserad_1_A = mkA "otyranniserad" ; -- otyranniserad..av.1
  otyranniserbar_1_A = mkA "otyranniserbar" ; -- otyranniserbar..av.1
  otyranniserbarhet_1_N = mkN "otyranniserbarhet" ; -- otyranniserbarhet..nn.1
  otäck_1_A = mkA "otäck" ; -- otäck..av.1
  otäcka_1_N = mkN "otäcka" ; -- otäcka..nn.1
  otäckhet_1_N = mkN "otäckhet" "otäckheter" ; -- otäckhet..nn.1
  otäcking_1_N = mkN "otäcking" ; -- otäcking..nn.1
  otämd_1_A = mkA "otämd" "otämt" ; -- otämd..av.1
  otämjbar_1_A = mkA "otämjbar" ; -- otämjbar..av.1
  otämjbarhet_1_N = mkN "otämjbarhet" ; -- otämjbarhet..nn.1
  otämjd_1_A = mkA "otämjd" "otämjt" ; -- otämjd..av.1
  otänd_1_A = mkA "otänd" ; -- otänd..av.1
  otänjbar_1_A = mkA "otänjbar" ; -- otänjbar..av.1
  otänjbarhet_1_N = mkN "otänjbarhet" ; -- otänjbarhet..nn.1
  otänkbar_1_A = mkA "otänkbar" ; -- otänkbar..av.1
  otänkbarhet_1_N = mkN "otänkbarhet" ; -- otänkbarhet..nn.1
  otät_1_A = mkA "otät" ; -- otät..av.1
  otäthet_1_N = mkN "otäthet" "otätheter" ; -- otäthet..nn.1
  otålig_1_A = mkA "otålig" ; -- otålig..av.1
  otålighet_1_N = mkN "otålighet" ; -- otålighet..nn.1
  otörstig_1_A = mkA "otörstig" ; -- otörstig..av.1
  otörstighet_1_N = mkN "otörstighet" ; -- otörstighet..nn.1
  oumbärlig_1_A = mkA "oumbärlig" ; -- oumbärlig..av.1
  oumbärlighet_1_N = mkN "oumbärlighet" ; -- oumbärlighet..nn.1
  ounderbalanserbar_1_A = mkA "ounderbalanserbar" ; -- ounderbalanserbar..av.1
  ounderbalanserbarhet_1_N = mkN "ounderbalanserbarhet" ; -- ounderbalanserbarhet..nn.1
  ounderdimensionerbar_1_A = mkA "ounderdimensionerbar" ; -- ounderdimensionerbar..av.1
  ounderdimensionerbarhet_1_N = mkN "ounderdimensionerbarhet" ; -- ounderdimensionerbarhet..nn.1
  ounderexponerbar_1_A = mkA "ounderexponerbar" ; -- ounderexponerbar..av.1
  ounderexponerbarhet_1_N = mkN "ounderexponerbarhet" ; -- ounderexponerbarhet..nn.1
  ounderminerbar_1_A = mkA "ounderminerbar" ; -- ounderminerbar..av.1
  ounderminerbarhet_1_N = mkN "ounderminerbarhet" ; -- ounderminerbarhet..nn.1
  oundertaxerbar_1_A = mkA "oundertaxerbar" ; -- oundertaxerbar..av.1
  oundertaxerbarhet_1_N = mkN "oundertaxerbarhet" ; -- oundertaxerbarhet..nn.1
  oundervärderbar_1_A = mkA "oundervärderbar" ; -- oundervärderbar..av.1
  oundervärderbarhet_1_N = mkN "oundervärderbarhet" ; -- oundervärderbarhet..nn.1
  oundgänglig_1_A = mkA "oundgänglig" ; -- oundgänglig..av.1
  oundgängligen_1_Adv = mkAdv "oundgängligen" ; -- oundgängligen..ab.1
  oundgänglighet_1_N = mkN "oundgänglighet" ; -- oundgänglighet..nn.1
  oundviklig_1_A = mkA "oundviklig" ; -- oundviklig..av.1
  oundvikligen_1_Adv = mkAdv "oundvikligen" ; -- oundvikligen..ab.1
  oundviklighet_1_N = mkN "oundviklighet" ; -- oundviklighet..nn.1
  ounifierad_1_A = mkA "ounifierad" ; -- ounifierad..av.1
  ounifierbar_1_A = mkA "ounifierbar" ; -- ounifierbar..av.1
  ounifierbarhet_1_N = mkN "ounifierbarhet" ; -- ounifierbarhet..nn.1
  ouniformerad_1_A = mkA "ouniformerad" ; -- ouniformerad..av.1
  ouniformerbar_1_A = mkA "ouniformerbar" ; -- ouniformerbar..av.1
  ouniformerbarhet_1_N = mkN "ouniformerbarhet" ; -- ouniformerbarhet..nn.1
  ouppackad_1_A = mkA "ouppackad" ; -- ouppackad..av.1
  ouppdaterad_1_A = mkA "ouppdaterad" ; -- ouppdaterad..av.1
  ouppdaterbar_1_A = mkA "ouppdaterbar" ; -- ouppdaterbar..av.1
  ouppdaterbarhet_1_N = mkN "ouppdaterbarhet" ; -- ouppdaterbarhet..nn.1
  ouppfattbar_1_A = mkA "ouppfattbar" ; -- ouppfattbar..av.1
  ouppfattbarhet_1_N = mkN "ouppfattbarhet" ; -- ouppfattbarhet..nn.1
  ouppfostrad_1_A = mkA "ouppfostrad" ; -- ouppfostrad..av.1
  ouppfylld_1_A = mkA "ouppfylld" "ouppfyllt" ; -- ouppfylld..av.1
  ouppgjord_1_A = mkA "ouppgjord" "ouppgjort" ; -- ouppgjord..av.1
  ouppgraderad_1_A = mkA "ouppgraderad" ; -- ouppgraderad..av.1
  ouppgraderbar_1_A = mkA "ouppgraderbar" ; -- ouppgraderbar..av.1
  ouppgraderbarhet_1_N = mkN "ouppgraderbarhet" ; -- ouppgraderbarhet..nn.1
  oupphinnelig_1_A = mkA "oupphinnelig" ; -- oupphinnelig..av.1
  oupphinnelighet_1_N = mkN "oupphinnelighet" ; -- oupphinnelighet..nn.1
  oupphörlig_1_A = mkA "oupphörlig" ; -- oupphörlig..av.1
  oupphörligen_1_Adv = mkAdv "oupphörligen" ; -- oupphörligen..ab.1
  oupphörlighet_1_N = mkN "oupphörlighet" ; -- oupphörlighet..nn.1
  ouppjusterad_1_A = mkA "ouppjusterad" ; -- ouppjusterad..av.1
  ouppjusterbar_1_A = mkA "ouppjusterbar" ; -- ouppjusterbar..av.1
  ouppjusterbarhet_1_N = mkN "ouppjusterbarhet" ; -- ouppjusterbarhet..nn.1
  ouppklarad_1_A = mkA "ouppklarad" ; -- ouppklarad..av.1
  oupplyst_1_A = mkA "oupplyst" "oupplyst" ; -- oupplyst..av.1
  oupplysthet_1_N = mkN "oupplysthet" ; -- oupplysthet..nn.1
  oupplöslig_1_A = mkA "oupplöslig" ; -- oupplöslig..av.1
  oupplösligen_1_Adv = mkAdv "oupplösligen" ; -- oupplösligen..ab.1
  oupplöslighet_1_N = mkN "oupplöslighet" ; -- oupplöslighet..nn.1
  oupplöst_1_A = mkA "oupplöst" "oupplöst" ; -- oupplöst..av.1
  ouppmärksam_1_A = mkA "ouppmärksam" "ouppmärksamt" "ouppmärksamma" "ouppmärksamma" "ouppmärksammare" "ouppmärksammast" "ouppmärksammaste" ; -- ouppmärksam..av.1
  ouppmärksamhet_1_N = mkN "ouppmärksamhet" ; -- ouppmärksamhet..nn.1
  ouppnådd_1_A = mkA "ouppnådd" ; -- ouppnådd..av.1
  ouppnåelig_1_A = mkA "ouppnåelig" ; -- ouppnåelig..av.1
  ouppnåelighet_1_N = mkN "ouppnåelighet" ; -- ouppnåelighet..nn.1
  ouppodlad_1_A = mkA "ouppodlad" ; -- ouppodlad..av.1
  ouppreklamerad_1_A = mkA "ouppreklamerad" ; -- ouppreklamerad..av.1
  ouppreklamerbar_1_A = mkA "ouppreklamerbar" ; -- ouppreklamerbar..av.1
  ouppreklamerbarhet_1_N = mkN "ouppreklamerbarhet" ; -- ouppreklamerbarhet..nn.1
  ouppräknelig_1_A = mkA "ouppräknelig" ; -- ouppräknelig..av.1
  ouppräknelighet_1_N = mkN "ouppräknelighet" ; -- ouppräknelighet..nn.1
  ouppskattbar_1_A = mkA "ouppskattbar" ; -- ouppskattbar..av.1
  ouppskattbarhet_1_N = mkN "ouppskattbarhet" ; -- ouppskattbarhet..nn.1
  ouppskuren_1_A = mkA "ouppskuren" ; -- ouppskuren..av.1
  ouppsummerad_1_A = mkA "ouppsummerad" ; -- ouppsummerad..av.1
  ouppsummerbar_1_A = mkA "ouppsummerbar" ; -- ouppsummerbar..av.1
  ouppsummerbarhet_1_N = mkN "ouppsummerbarhet" ; -- ouppsummerbarhet..nn.1
  ouppsägbar_1_A = mkA "ouppsägbar" ; -- ouppsägbar..av.1
  ouppsägbarhet_1_N = mkN "ouppsägbarhet" ; -- ouppsägbarhet..nn.1
  ouppsåtlig_1_A = mkA "ouppsåtlig" ; -- ouppsåtlig..av.1
  ouppsåtlighet_1_N = mkN "ouppsåtlighet" ; -- ouppsåtlighet..nn.1
  oupptaxerad_1_A = mkA "oupptaxerad" ; -- oupptaxerad..av.1
  oupptaxerbar_1_A = mkA "oupptaxerbar" ; -- oupptaxerbar..av.1
  oupptaxerbarhet_1_N = mkN "oupptaxerbarhet" ; -- oupptaxerbarhet..nn.1
  oupptäckt_1_A = mkA "oupptäckt" "oupptäckt" ; -- oupptäckt..av.1
  ouppvärderad_1_A = mkA "ouppvärderad" ; -- ouppvärderad..av.1
  ouppvärderbar_1_A = mkA "ouppvärderbar" ; -- ouppvärderbar..av.1
  ouppvärderbarhet_1_N = mkN "ouppvärderbarhet" ; -- ouppvärderbarhet..nn.1
  ouppvärmd_1_A = mkA "ouppvärmd" "ouppvärmt" ; -- ouppvärmd..av.1
  ouppövad_1_A = mkA "ouppövad" ; -- ouppövad..av.1
  ourbaniserad_1_A = mkA "ourbaniserad" ; -- ourbaniserad..av.1
  ourbaniserbar_1_A = mkA "ourbaniserbar" ; -- ourbaniserbar..av.1
  ourbaniserbarhet_1_N = mkN "ourbaniserbarhet" ; -- ourbaniserbarhet..nn.1
  oursäktlig_1_A = mkA "oursäktlig" ; -- oursäktlig..av.1
  oursäktlighet_1_N = mkN "oursäktlighet" ; -- oursäktlighet..nn.1
  ousurperad_1_A = mkA "ousurperad" ; -- ousurperad..av.1
  ousurperbar_1_A = mkA "ousurperbar" ; -- ousurperbar..av.1
  ousurperbarhet_1_N = mkN "ousurperbarhet" ; -- ousurperbarhet..nn.1
  outa_1_V = mkV "outar" ; -- outa..vb.1
  outackorderad_1_A = mkA "outackorderad" ; -- outackorderad..av.1
  outackorderbar_1_A = mkA "outackorderbar" ; -- outackorderbar..av.1
  outackorderbarhet_1_N = mkN "outackorderbarhet" ; -- outackorderbarhet..nn.1
  outande_1_N = mkN "outande" ; -- outande..nn.1
  outannonserad_1_A = mkA "outannonserad" ; -- outannonserad..av.1
  outannonserbar_1_A = mkA "outannonserbar" ; -- outannonserbar..av.1
  outannonserbarhet_1_N = mkN "outannonserbarhet" ; -- outannonserbarhet..nn.1
  outarrenderad_1_A = mkA "outarrenderad" ; -- outarrenderad..av.1
  outarrenderbar_1_A = mkA "outarrenderbar" ; -- outarrenderbar..av.1
  outarrenderbarhet_1_N = mkN "outarrenderbarhet" ; -- outarrenderbarhet..nn.1
  outbalanserad_1_A = mkA "outbalanserad" ; -- outbalanserad..av.1
  outbalanserbar_1_A = mkA "outbalanserbar" ; -- outbalanserbar..av.1
  outbalanserbarhet_1_N = mkN "outbalanserbarhet" ; -- outbalanserbarhet..nn.1
  outbasunerad_1_A = mkA "outbasunerad" ; -- outbasunerad..av.1
  outbasunerbar_1_A = mkA "outbasunerbar" ; -- outbasunerbar..av.1
  outbasunerbarhet_1_N = mkN "outbasunerbarhet" ; -- outbasunerbarhet..nn.1
  outbildad_1_A = mkA "outbildad" ; -- outbildad..av.1
  outbroderad_1_A = mkA "outbroderad" ; -- outbroderad..av.1
  outbroderbar_1_A = mkA "outbroderbar" ; -- outbroderbar..av.1
  outbroderbarhet_1_N = mkN "outbroderbarhet" ; -- outbroderbarhet..nn.1
  outbytbar_1_A = mkA "outbytbar" ; -- outbytbar..av.1
  outbytbarhet_1_N = mkN "outbytbarhet" "outbytbarheter" ; -- outbytbarhet..nn.1
  outbytlig_1_A = mkA "outbytlig" ; -- outbytlig..av.1
  outbytlighet_1_N = mkN "outbytlighet" ; -- outbytlighet..nn.1
  outdebiterad_1_A = mkA "outdebiterad" ; -- outdebiterad..av.1
  outdebiterbar_1_A = mkA "outdebiterbar" ; -- outdebiterbar..av.1
  outdebiterbarhet_1_N = mkN "outdebiterbarhet" ; -- outdebiterbarhet..nn.1
  outexaminerad_1_A = mkA "outexaminerad" ; -- outexaminerad..av.1
  outexaminerbar_1_A = mkA "outexaminerbar" ; -- outexaminerbar..av.1
  outexaminerbarhet_1_N = mkN "outexaminerbarhet" ; -- outexaminerbarhet..nn.1
  outexperimenterad_1_A = mkA "outexperimenterad" ; -- outexperimenterad..av.1
  outexperimenterbar_1_A = mkA "outexperimenterbar" ; -- outexperimenterbar..av.1
  outexperimenterbarhet_1_N = mkN "outexperimenterbarhet" ; -- outexperimenterbarhet..nn.1
  outforskad_1_A = mkA "outforskad" ; -- outforskad..av.1
  outförbar_1_A = mkA "outförbar" ; -- outförbar..av.1
  outförbarhet_1_N = mkN "outförbarhet" ; -- outförbarhet..nn.1
  outgiven_1_A = mkA "outgiven" ; -- outgiven..av.1
  outgrundlig_1_A = mkA "outgrundlig" ; -- outgrundlig..av.1
  outgrundlighet_1_N = mkN "outgrundlighet" ; -- outgrundlighet..nn.1
  outhyrd_1_A = mkA "outhyrd" "outhyrt" ; -- outhyrd..av.1
  outhärdlig_1_A = mkA "outhärdlig" ; -- outhärdlig..av.1
  outhärdlighet_1_N = mkN "outhärdlighet" ; -- outhärdlighet..nn.1
  outklarerad_1_A = mkA "outklarerad" ; -- outklarerad..av.1
  outklarerbar_1_A = mkA "outklarerbar" ; -- outklarerbar..av.1
  outklarerbarhet_1_N = mkN "outklarerbarhet" ; -- outklarerbarhet..nn.1
  outkommenderad_1_A = mkA "outkommenderad" ; -- outkommenderad..av.1
  outkommenderbar_1_A = mkA "outkommenderbar" ; -- outkommenderbar..av.1
  outkommenderbarhet_1_N = mkN "outkommenderbarhet" ; -- outkommenderbarhet..nn.1
  outkonkurrerad_1_A = mkA "outkonkurrerad" ; -- outkonkurrerad..av.1
  outkonkurrerbar_1_A = mkA "outkonkurrerbar" ; -- outkonkurrerbar..av.1
  outkonkurrerbarhet_1_N = mkN "outkonkurrerbarhet" ; -- outkonkurrerbarhet..nn.1
  outkristalliserad_1_A = mkA "outkristalliserad" ; -- outkristalliserad..av.1
  outkristalliserbar_1_A = mkA "outkristalliserbar" ; -- outkristalliserbar..av.1
  outkristalliserbarhet_1_N = mkN "outkristalliserbarhet" ; -- outkristalliserbarhet..nn.1
  outkvitterad_1_A = mkA "outkvitterad" ; -- outkvitterad..av.1
  outkvitterbar_1_A = mkA "outkvitterbar" ; -- outkvitterbar..av.1
  outkvitterbarhet_1_N = mkN "outkvitterbarhet" ; -- outkvitterbarhet..nn.1
  outlokaliserad_1_A = mkA "outlokaliserad" ; -- outlokaliserad..av.1
  outlokaliserbar_1_A = mkA "outlokaliserbar" ; -- outlokaliserbar..av.1
  outlokaliserbarhet_1_N = mkN "outlokaliserbarhet" ; -- outlokaliserbarhet..nn.1
  outmanövrerad_1_A = mkA "outmanövrerad" ; -- outmanövrerad..av.1
  outmanövrerbar_1_A = mkA "outmanövrerbar" ; -- outmanövrerbar..av.1
  outmanövrerbarhet_1_N = mkN "outmanövrerbarhet" ; -- outmanövrerbarhet..nn.1
  outminuterad_1_A = mkA "outminuterad" ; -- outminuterad..av.1
  outminuterbar_1_A = mkA "outminuterbar" ; -- outminuterbar..av.1
  outminuterbarhet_1_N = mkN "outminuterbarhet" ; -- outminuterbarhet..nn.1
  outnyttjad_1_A = mkA "outnyttjad" ; -- outnyttjad..av.1
  outplacerad_1_A = mkA "outplacerad" ; -- outplacerad..av.1
  outplacerbar_1_A = mkA "outplacerbar" ; -- outplacerbar..av.1
  outplacerbarhet_1_N = mkN "outplacerbarhet" ; -- outplacerbarhet..nn.1
  outplånlig_1_A = mkA "outplånlig" ; -- outplånlig..av.1
  outplånlighet_1_N = mkN "outplånlighet" ; -- outplånlighet..nn.1
  outposterad_1_A = mkA "outposterad" ; -- outposterad..av.1
  outposterbar_1_A = mkA "outposterbar" ; -- outposterbar..av.1
  outposterbarhet_1_N = mkN "outposterbarhet" ; -- outposterbarhet..nn.1
  output_1_N = mkN "output" ; -- output..nn.1
  outraderad_1_A = mkA "outraderad" ; -- outraderad..av.1
  outraderbar_1_A = mkA "outraderbar" ; -- outraderbar..av.1
  outraderbarhet_1_N = mkN "outraderbarhet" ; -- outraderbarhet..nn.1
  outrangerad_1_A = mkA "outrangerad" ; -- outrangerad..av.1
  outrangerbar_1_A = mkA "outrangerbar" ; -- outrangerbar..av.1
  outrangerbarhet_1_N = mkN "outrangerbarhet" ; -- outrangerbarhet..nn.1
  outrannsaklig_1_A = mkA "outrannsaklig" ; -- outrannsaklig..av.1
  outrannsaklighet_1_N = mkN "outrannsaklighet" ; -- outrannsaklighet..nn.1
  outredbar_1_A = mkA "outredbar" ; -- outredbar..av.1
  outredbarhet_1_N = mkN "outredbarhet" ; -- outredbarhet..nn.1
  outredd_1_A = mkA "outredd" ; -- outredd..av.1
  outringd_1_A = mkA "outringd" "outringt" ; -- outringd..av.1
  outrotlig_1_A = mkA "outrotlig" ; -- outrotlig..av.1
  outrotlighet_1_N = mkN "outrotlighet" ; -- outrotlighet..nn.1
  outsagd_1_A = mkA "outsagd" "outsagt" ; -- outsagd..av.1
  outsagdhet_1_N = mkN "outsagdhet" ; -- outsagdhet..nn.1
  outsider_1_N = mkN "outsider" "outsidern" "outsiders" "outsidersen" ; -- outsider..nn.1
  outsinlig_1_A = mkA "outsinlig" ; -- outsinlig..av.1
  outsinlighet_1_N = mkN "outsinlighet" ; -- outsinlighet..nn.1
  outslagen_1_A = mkA "outslagen" ; -- outslagen..av.1
  outslitlig_1_A = mkA "outslitlig" ; -- outslitlig..av.1
  outslitlighet_1_N = mkN "outslitlighet" ; -- outslitlighet..nn.1
  outsläcklig_1_A = mkA "outsläcklig" ; -- outsläcklig..av.1
  outsläcklighet_1_N = mkN "outsläcklighet" ; -- outsläcklighet..nn.1
  outspädd_1_A = mkA "outspädd" ; -- outspädd..av.1
  outstanding_1_A = mkA "outstanding" ; -- outstanding..av.1
  outstofferad_1_A = mkA "outstofferad" ; -- outstofferad..av.1
  outstofferbar_1_A = mkA "outstofferbar" ; -- outstofferbar..av.1
  outstofferbarhet_1_N = mkN "outstofferbarhet" ; -- outstofferbarhet..nn.1
  outsägbar_1_A = mkA "outsägbar" ; -- outsägbar..av.1
  outsägbarhet_1_N = mkN "outsägbarhet" ; -- outsägbarhet..nn.1
  outsäglig_1_A = mkA "outsäglig" ; -- outsäglig..av.1
  outsäglighet_1_N = mkN "outsäglighet" ; -- outsäglighet..nn.1
  outtalad_1_A = mkA "outtalad" ; -- outtalad..av.1
  outtalbar_1_A = mkA "outtalbar" ; -- outtalbar..av.1
  outtalbarhet_1_N = mkN "outtalbarhet" ; -- outtalbarhet..nn.1
  outtaxerad_1_A = mkA "outtaxerad" ; -- outtaxerad..av.1
  outtaxerbar_1_A = mkA "outtaxerbar" ; -- outtaxerbar..av.1
  outtaxerbarhet_1_N = mkN "outtaxerbarhet" ; -- outtaxerbarhet..nn.1
  outtröttlig_1_A = mkA "outtröttlig" ; -- outtröttlig..av.1
  outtröttlighet_1_N = mkN "outtröttlighet" ; -- outtröttlighet..nn.1
  outtömlig_1_A = mkA "outtömlig" ; -- outtömlig..av.1
  outtömlighet_1_N = mkN "outtömlighet" ; -- outtömlighet..nn.1
  outvecklad_1_A = mkA "outvecklad" ; -- outvecklad..av.1
  outvuxen_1_A = mkA "outvuxen" ; -- outvuxen..av.1
  outvärderad_1_A = mkA "outvärderad" ; -- outvärderad..av.1
  outvärderbar_1_A = mkA "outvärderbar" ; -- outvärderbar..av.1
  outvärderbarhet_1_N = mkN "outvärderbarhet" ; -- outvärderbarhet..nn.1
  outväxt_1_A = mkA "outväxt" "outväxt" ; -- outväxt..av.1
  ouvertyr_1_N = mkN "ouvertyr" "ouvertyrer" ; -- ouvertyr..nn.1
  ouzo_1_N = mkN "ouzo" ; -- ouzo..nn.1
  ovaccinerad_1_A = mkA "ovaccinerad" ; -- ovaccinerad..av.1
  ovaccinerbar_1_A = mkA "ovaccinerbar" ; -- ovaccinerbar..av.1
  ovaccinerbarhet_1_N = mkN "ovaccinerbarhet" ; -- ovaccinerbarhet..nn.1
  ovadderad_1_A = mkA "ovadderad" ; -- ovadderad..av.1
  ovadderbar_1_A = mkA "ovadderbar" ; -- ovadderbar..av.1
  ovadderbarhet_1_N = mkN "ovadderbarhet" ; -- ovadderbarhet..nn.1
  ovaggad_1_A = mkA "ovaggad" ; -- ovaggad..av.1
  ovaksinerad_1_A = mkA "ovaksinerad" ; -- ovaksinerad..av.1
  ovaksinerbar_1_A = mkA "ovaksinerbar" ; -- ovaksinerbar..av.1
  ovaksinerbarhet_1_N = mkN "ovaksinerbarhet" ; -- ovaksinerbarhet..nn.1
  oval_1_A = mkA "oval" ; -- oval..av.1
  oval_1_N = mkN "oval" "ovaler" ; -- oval..nn.1
  ovalsvarvning_1_N = mkN "ovalsvarvning" ; -- ovalsvarvning..nn.1
  ovaluterad_1_A = mkA "ovaluterad" ; -- ovaluterad..av.1
  ovaluterbar_1_A = mkA "ovaluterbar" ; -- ovaluterbar..av.1
  ovaluterbarhet_1_N = mkN "ovaluterbarhet" ; -- ovaluterbarhet..nn.1
  ovalverad_1_A = mkA "ovalverad" ; -- ovalverad..av.1
  ovalverbar_1_A = mkA "ovalverbar" ; -- ovalverbar..av.1
  ovalverbarhet_1_N = mkN "ovalverbarhet" ; -- ovalverbarhet..nn.1
  ovan_1_A = mkA "ovan" ; -- ovan..av.1
  ovana_1_N = mkN "ovana" ; -- ovana..nn.1
  ovandager_1_N = mkN "ovandager" ; -- ovandager..nn.1
  ovandaliserad_1_A = mkA "ovandaliserad" ; -- ovandaliserad..av.1
  ovandaliserbar_1_A = mkA "ovandaliserbar" ; -- ovandaliserbar..av.1
  ovandaliserbarhet_1_N = mkN "ovandaliserbarhet" ; -- ovandaliserbarhet..nn.1
  ovandel_1_N = mkN "ovandel" "ovandelen" "ovandelar" "ovandelarna" ; -- ovandel..nn.1
  ovanjordisk_1_A = mkA "ovanjordisk" ; -- ovanjordisk..av.1
  ovanlig_1_A = mkA "ovanlig" ; -- ovanlig..av.1
  ovanlighet_1_N = mkN "ovanlighet" "ovanligheter" ; -- ovanlighet..nn.1
  ovanläder_1_N = mkN "ovanläder" neutrum  ; -- ovanläder..nn.1
  ovansida_1_N = mkN "ovansida" ; -- ovansida..nn.1
  ovansklig_1_A = mkA "ovansklig" ; -- ovansklig..av.1
  ovansklighet_1_N = mkN "ovansklighet" ; -- ovansklighet..nn.1
  ovanstycke_1_N = mkN "ovanstycke" ; -- ovanstycke..nn.1
  ovanstående_1_A = mkA "ovanstående" ; -- ovanstående..av.1
  ovantill_1_Adv = mkAdv "ovantill" ; -- ovantill..ab.1
  ovanvåning_1_N = mkN "ovanvåning" ; -- ovanvåning..nn.1
  ovarierad_1_A = mkA "ovarierad" ; -- ovarierad..av.1
  ovarierbar_1_A = mkA "ovarierbar" ; -- ovarierbar..av.1
  ovarierbarhet_1_N = mkN "ovarierbarhet" ; -- ovarierbarhet..nn.1
  ovariotomi_1_N = mkN "ovariotomi" "ovariotomier" ; -- ovariotomi..nn.1
  ovarium_1_N = mkN "ovarium" "ovariet" "ovarier" "ovarierna" ; -- ovarium..nn.1
  ovarsam_1_A = mkA "ovarsam" "ovarsamt" "ovarsamma" "ovarsamma" "ovarsammare" "ovarsammast" "ovarsammaste" ; -- ovarsam..av.1
  ovarsamhet_1_N = mkN "ovarsamhet" ; -- ovarsamhet..nn.1
  ovation_1_N = mkN "ovation" ; -- ovation..nn.1
  ovederhäftig_1_A = mkA "ovederhäftig" ; -- ovederhäftig..av.1
  ovederhäftighet_1_N = mkN "ovederhäftighet" ; -- ovederhäftighet..nn.1
  ovederlägglig_1_A = mkA "ovederlägglig" ; -- ovederlägglig..av.1
  ovederlägglighet_1_N = mkN "ovederlägglighet" ; -- ovederlägglighet..nn.1
  ovedersäglig_1_A = mkA "ovedersäglig" ; -- ovedersäglig..av.1
  ovedersägligen_1_Adv = mkAdv "ovedersägligen" ; -- ovedersägligen..ab.1
  ovedersäglighet_1_N = mkN "ovedersäglighet" ; -- ovedersäglighet..nn.1
  ovelouriserad_1_A = mkA "ovelouriserad" ; -- ovelouriserad..av.1
  ovelouriserbar_1_A = mkA "ovelouriserbar" ; -- ovelouriserbar..av.1
  ovelouriserbarhet_1_N = mkN "ovelouriserbarhet" ; -- ovelouriserbarhet..nn.1
  oventilerad_1_A = mkA "oventilerad" ; -- oventilerad..av.1
  oventilerbar_1_A = mkA "oventilerbar" ; -- oventilerbar..av.1
  oventilerbarhet_1_N = mkN "oventilerbarhet" ; -- oventilerbarhet..nn.1
  overall_1_N = mkN "overall" "overaller" ; -- overall..nn.1
  overbaliserad_1_A = mkA "overbaliserad" ; -- overbaliserad..av.1
  overbaliserbar_1_A = mkA "overbaliserbar" ; -- overbaliserbar..av.1
  overbaliserbarhet_1_N = mkN "overbaliserbarhet" ; -- overbaliserbarhet..nn.1
  overhead_projektor_1_N = mkN "overhead-projektor" "overhead-projektorer" ; -- overhead-projektor..nn.1
  overhead_1_N = mkN "overhead" ; -- overhead..nn.1
  overheadbild_1_N = mkN "overheadbild" "overheadbilder" ; -- overheadbild..nn.1
  overheadprojektor_1_N = mkN "overheadprojektor" "overheadprojektorer" ; -- overheadprojektor..nn.1
  overifierad_1_A = mkA "overifierad" ; -- overifierad..av.1
  overifierbar_1_A = mkA "overifierbar" ; -- overifierbar..av.1
  overifierbarhet_1_N = mkN "overifierbarhet" ; -- overifierbarhet..nn.1
  overklig_1_A = mkA "overklig" ; -- overklig..av.1
  overklighet_1_N = mkN "overklighet" ; -- overklighet..nn.1
  overksam_1_A = mkA "overksam" "overksamt" "overksamma" "overksamma" "overksammare" "overksammast" "overksammaste" ; -- overksam..av.1
  overksamhet_1_N = mkN "overksamhet" "overksamheter" ; -- overksamhet..nn.1
  oversifierad_1_A = mkA "oversifierad" ; -- oversifierad..av.1
  oversifierbar_1_A = mkA "oversifierbar" ; -- oversifierbar..av.1
  oversifierbarhet_1_N = mkN "oversifierbarhet" ; -- oversifierbarhet..nn.1
  ovetande_1_A = mkA "ovetande" ; -- ovetande..av.1
  ovetandes_1_A = mkA "ovetandes" ; -- ovetandes..av.1
  ovetbar_1_A = mkA "ovetbar" ; -- ovetbar..av.1
  ovetbarhet_1_N = mkN "ovetbarhet" ; -- ovetbarhet..nn.1
  oveten_1_A = mkA "oveten" ; -- oveten..av.1
  ovetenhet_1_N = mkN "ovetenhet" "ovetenheter" ; -- ovetenhet..nn.1
  ovetenskaplig_1_A = mkA "ovetenskaplig" ; -- ovetenskaplig..av.1
  ovetenskaplighet_1_N = mkN "ovetenskaplighet" ; -- ovetenskaplighet..nn.1
  ovetskap_1_N = mkN "ovetskap" ; -- ovetskap..nn.1
  ovett_1_N = mkN "ovett" neutrum  ; -- ovett..nn.1
  ovettig_1_A = mkA "ovettig" ; -- ovettig..av.1
  ovettighet_1_N = mkN "ovettighet" "ovettigheter" ; -- ovettighet..nn.1
  ovidimerad_1_A = mkA "ovidimerad" ; -- ovidimerad..av.1
  ovidimerbar_1_A = mkA "ovidimerbar" ; -- ovidimerbar..av.1
  ovidimerbarhet_1_N = mkN "ovidimerbarhet" ; -- ovidimerbarhet..nn.1
  ovidkommande_1_A = mkA "ovidkommande" ; -- ovidkommande..av.1
  ovig_1_A = mkA "ovig" ; -- ovig..av.1
  ovigd_1_A = mkA "ovigd" "ovigt" ; -- ovigd..av.1
  ovighet_1_N = mkN "ovighet" ; -- ovighet..nn.1
  oviktig_1_A = mkA "oviktig" ; -- oviktig..av.1
  oviktighet_1_N = mkN "oviktighet" ; -- oviktighet..nn.1
  ovilja_1_N = mkN "ovilja" ; -- ovilja..nn.1
  ovillig_1_A = mkA "ovillig" ; -- ovillig..av.1
  ovillighet_1_N = mkN "ovillighet" ; -- ovillighet..nn.1
  ovillkorlig_1_A = mkA "ovillkorlig" ; -- ovillkorlig..av.1
  ovillkorligen_1_Adv = mkAdv "ovillkorligen" ; -- ovillkorligen..ab.1
  ovillkorlighet_1_N = mkN "ovillkorlighet" ; -- ovillkorlighet..nn.1
  ovindicerad_1_A = mkA "ovindicerad" ; -- ovindicerad..av.1
  ovindicerbar_1_A = mkA "ovindicerbar" ; -- ovindicerbar..av.1
  ovindicerbarhet_1_N = mkN "ovindicerbarhet" ; -- ovindicerbarhet..nn.1
  ovipar_1_A = mkA "ovipar" ; -- ovipar..av.1
  ovis_1_A = mkA "ovis" ; -- ovis..av.1
  oviserad_1_A = mkA "oviserad" ; -- oviserad..av.1
  oviserbar_1_A = mkA "oviserbar" ; -- oviserbar..av.1
  oviserbarhet_1_N = mkN "oviserbarhet" ; -- oviserbarhet..nn.1
  ovishet_1_N = mkN "ovishet" ; -- ovishet..nn.1
  ovisiterad_1_A = mkA "ovisiterad" ; -- ovisiterad..av.1
  ovisiterbar_1_A = mkA "ovisiterbar" ; -- ovisiterbar..av.1
  ovisiterbarhet_1_N = mkN "ovisiterbarhet" ; -- ovisiterbarhet..nn.1
  oviss_1_A = mkA "oviss" ; -- oviss..av.1
  ovisshet_1_N = mkN "ovisshet" "ovissheter" ; -- ovisshet..nn.1
  ovisualiserad_1_A = mkA "ovisualiserad" ; -- ovisualiserad..av.1
  ovisualiserbar_1_A = mkA "ovisualiserbar" ; -- ovisualiserbar..av.1
  ovisualiserbarhet_1_N = mkN "ovisualiserbarhet" ; -- ovisualiserbarhet..nn.1
  ovitaliserad_1_A = mkA "ovitaliserad" ; -- ovitaliserad..av.1
  ovitaliserbar_1_A = mkA "ovitaliserbar" ; -- ovitaliserbar..av.1
  ovitaliserbarhet_1_N = mkN "ovitaliserbarhet" ; -- ovitaliserbarhet..nn.1
  ovitaminerad_1_A = mkA "ovitaminerad" ; -- ovitaminerad..av.1
  ovitaminerbar_1_A = mkA "ovitaminerbar" ; -- ovitaminerbar..av.1
  ovitaminerbarhet_1_N = mkN "ovitaminerbarhet" ; -- ovitaminerbarhet..nn.1
  ovitaminiserad_1_A = mkA "ovitaminiserad" ; -- ovitaminiserad..av.1
  ovitaminiserbar_1_A = mkA "ovitaminiserbar" ; -- ovitaminiserbar..av.1
  ovitaminiserbarhet_1_N = mkN "ovitaminiserbarhet" ; -- ovitaminiserbarhet..nn.1
  ovokaliserad_1_A = mkA "ovokaliserad" ; -- ovokaliserad..av.1
  ovokaliserbar_1_A = mkA "ovokaliserbar" ; -- ovokaliserbar..av.1
  ovokaliserbarhet_1_N = mkN "ovokaliserbarhet" ; -- ovokaliserbarhet..nn.1
  ovulation_1_N = mkN "ovulation" ; -- ovulation..nn.1
  ovulgariserad_1_A = mkA "ovulgariserad" ; -- ovulgariserad..av.1
  ovulgariserbar_1_A = mkA "ovulgariserbar" ; -- ovulgariserbar..av.1
  ovulgariserbarhet_1_N = mkN "ovulgariserbarhet" ; -- ovulgariserbarhet..nn.1
  ovulkaniserad_1_A = mkA "ovulkaniserad" ; -- ovulkaniserad..av.1
  ovulkaniserbar_1_A = mkA "ovulkaniserbar" ; -- ovulkaniserbar..av.1
  ovulkaniserbarhet_1_N = mkN "ovulkaniserbarhet" ; -- ovulkaniserbarhet..nn.1
  oväder_1_N = mkN "oväder" neutrum  ; -- oväder..nn.1
  oväderscentrum_1_N = mkN "oväderscentrum" neutrum  ; -- oväderscentrum..nn.1
  oväderspassage_1_N = mkN "oväderspassage" "oväderspassager" ; -- oväderspassage..nn.1
  oväld_1_N = mkN "oväld" ; -- oväld..nn.1
  oväldig_1_A = mkA "oväldig" ; -- oväldig..av.1
  oväldighet_1_N = mkN "oväldighet" ; -- oväldighet..nn.1
  ovälkommen_1_A = mkA "ovälkommen" "ovälkommet" "ovälkomna" "ovälkomna" "ovälkomnare" "ovälkomnast" "ovälkomnaste" ; -- ovälkommen..av.1
  ovän_1_N = mkN "ovän" "ovännen" "ovänner" "ovännerna" ; -- ovän..nn.1
  ovänlig_1_A = mkA "ovänlig" ; -- ovänlig..av.1
  ovänlighet_1_N = mkN "ovänlighet" "ovänligheter" ; -- ovänlighet..nn.1
  ovänskap_1_N = mkN "ovänskap" "ovänskaper" ; -- ovänskap..nn.1
  oväntad_1_A = mkA "oväntad" ; -- oväntad..av.1
  oväpnad_1_A = mkA "oväpnad" ; -- oväpnad..av.1
  ovärderad_1_A = mkA "ovärderad" ; -- ovärderad..av.1
  ovärderbar_1_A = mkA "ovärderbar" ; -- ovärderbar..av.1
  ovärderbarhet_1_N = mkN "ovärderbarhet" ; -- ovärderbarhet..nn.1
  ovärderlig_1_A = mkA "ovärderlig" ; -- ovärderlig..av.1
  ovärderlighet_1_N = mkN "ovärderlighet" ; -- ovärderlighet..nn.1
  ovärdig_1_A = mkA "ovärdig" ; -- ovärdig..av.1
  ovärdighet_1_N = mkN "ovärdighet" ; -- ovärdighet..nn.1
  ovärldslig_1_A = mkA "ovärldslig" ; -- ovärldslig..av.1
  ovärldslighet_1_N = mkN "ovärldslighet" ; -- ovärldslighet..nn.1
  oväsen_1_N = mkN "oväsen" neutrum  ; -- oväsen..nn.1
  oväsentlig_1_A = mkA "oväsentlig" ; -- oväsentlig..av.1
  oväsentlighet_1_N = mkN "oväsentlighet" "oväsentligheter" ; -- oväsentlighet..nn.1
  ovålig_1_A = mkA "ovålig" ; -- ovålig..av.1
  ovålighet_1_N = mkN "ovålighet" ; -- ovålighet..nn.1
  ovårdad_1_A = mkA "ovårdad" ; -- ovårdad..av.1
  oxalatsten_1_N = mkN "oxalatsten" "oxalatstenen" "oxalatstenar" "oxalatstenarna" ; -- oxalatsten..nn.1
  oxalsyra_1_N = mkN "oxalsyra" ; -- oxalsyra..nn.1
  oxalättiksyra_1_N = mkN "oxalättiksyra" ; -- oxalättiksyra..nn.1
  oxblod_1_N = mkN "oxblod" neutrum  ; -- oxblod..nn.1
  oxblodsröd_1_A = mkA "oxblodsröd" "oxblodsrött" ; -- oxblodsröd..av.1
  oxbär_1_N = mkN "oxbär" neutrum  ; -- oxbär..nn.1
  oxdans_1_N = mkN "oxdans" ; -- oxdans..nn.1
  oxdjur_1_N = mkN "oxdjur" neutrum  ; -- oxdjur..nn.1
  oxdrift_1_N = mkN "oxdrift" ; -- oxdrift..nn.1
  oxe_1_N = mkN "oxe" utrum  ; -- oxe..nn.1
  oxel_1_N = mkN "oxel" ; -- oxel..nn.1
  oxeltand_1_N = mkN "oxeltand" "oxeltänder" ; -- oxeltand..nn.1
  oxfilé_1_N = mkN "oxfilé" "oxfiléer" ; -- oxfilé..nn.1
  oxfordrörelse_1_N = mkN "oxfordrörelse" utrum  ; -- oxfordrörelse..nn.1
  oxfordskola_1_N = mkN "oxfordskola" ; -- oxfordskola..nn.1
  oxhuvud_1_N = mkN "oxhuvud" "oxhuvudet" "oxhuvud" "oxhuvudena" ; -- oxhuvud..nn.1
  oxid_1_N = mkN "oxid" "oxider" ; -- oxid..nn.1
  oxidation_1_N = mkN "oxidation" ; -- oxidation..nn.1
  oxidationsmedel_1_N = mkN "oxidationsmedel" neutrum  ; -- oxidationsmedel..nn.1
  oxidationsreaktion_1_N = mkN "oxidationsreaktion" ; -- oxidationsreaktion..nn.1
  oxidationstal_1_N = mkN "oxidationstal" neutrum  ; -- oxidationstal..nn.1
  oxidera_1_V = mkV "oxiderar" ; -- oxidera..vb.1
  oxiderande_1_N = mkN "oxiderande" ; -- oxiderande..nn.1
  oxiderbar_1_A = mkA "oxiderbar" ; -- oxiderbar..av.1
  oxiderbarhet_1_N = mkN "oxiderbarhet" ; -- oxiderbarhet..nn.1
  oxidering_1_N = mkN "oxidering" ; -- oxidering..nn.1
  oxjärpe_1_N = mkN "oxjärpe" utrum  ; -- oxjärpe..nn.1
  oxkött_1_N = mkN "oxkött" neutrum  ; -- oxkött..nn.1
  oxläder_1_N = mkN "oxläder" neutrum  ; -- oxläder..nn.1
  oxlägg_1_N = mkN "oxlägg" ; -- oxlägg..nn.1
  oxroulad_1_N = mkN "oxroulad" "oxroulader" ; -- oxroulad..nn.1
  oxrullad_1_N = mkN "oxrullad" "oxrullader" ; -- oxrullad..nn.1
  oxstek_1_N = mkN "oxstek" ; -- oxstek..nn.1
  oxstyng_1_N = mkN "oxstyng" neutrum  ; -- oxstyng..nn.1
  oxtunga_1_N = mkN "oxtunga" ; -- oxtunga..nn.1
  oxtungsvamp_1_N = mkN "oxtungsvamp" ; -- oxtungsvamp..nn.1
  oxvandring_1_N = mkN "oxvandring" ; -- oxvandring..nn.1
  oxvecka_1_N = mkN "oxvecka" ; -- oxvecka..nn.1
  oxygen_1_N = mkN "oxygen" neutrum  ; -- oxygen..nn.1
  oxytocin_1_N = mkN "oxytocin" "oxytociner" ; -- oxytocin..nn.1
  oxå_1_Adv = mkAdv "oxå" ; -- oxå..ab.1
  oxöga_1_N = mkN "oxöga" "oxögat" "oxögon" "oxögonen" ; -- oxöga..nn.1
  ozelot_1_N = mkN "ozelot" "ozeloter" ; -- ozelot..nn.1
  ozokerit_1_N = mkN "ozokerit" ; -- ozokerit..nn.1
  ozon_1_N = mkN "ozon" ; -- ozon..nn.1
  ozonhalt_1_N = mkN "ozonhalt" "ozonhalter" ; -- ozonhalt..nn.1
  ozonhaltig_1_A = mkA "ozonhaltig" ; -- ozonhaltig..av.1
  ozonlager_1_N = mkN "ozonlager" neutrum  ; -- ozonlager..nn.1
  ozonminskning_1_N = mkN "ozonminskning" ; -- ozonminskning..nn.1
  ozonmolekyl_1_N = mkN "ozonmolekyl" "ozonmolekyler" ; -- ozonmolekyl..nn.1
  ozonmängd_1_N = mkN "ozonmängd" "ozonmängder" ; -- ozonmängd..nn.1
  ozonreduktion_1_N = mkN "ozonreduktion" ; -- ozonreduktion..nn.1
  ozonskikt_1_N = mkN "ozonskikt" neutrum  ; -- ozonskikt..nn.1
  oädel_1_A = mkA "oädel" ; -- oädel..av.1
  oäkta_1_A = mkA "oäkta" ; -- oäkta..av.1
  oäkthet_1_N = mkN "oäkthet" ; -- oäkthet..nn.1
  oälskad_1_A = mkA "oälskad" ; -- oälskad..av.1
  oändamålsenlig_1_A = mkA "oändamålsenlig" ; -- oändamålsenlig..av.1
  oändlig_1_A = mkA "oändlig" ; -- oändlig..av.1
  oändlighet_1_N = mkN "oändlighet" "oändligheter" ; -- oändlighet..nn.1
  oärlig_1_A = mkA "oärlig" ; -- oärlig..av.1
  oärlighet_1_N = mkN "oärlighet" "oärligheter" ; -- oärlighet..nn.1
  oätbar_1_A = mkA "oätbar" ; -- oätbar..av.1
  oätbarhet_1_N = mkN "oätbarhet" ; -- oätbarhet..nn.1
  oätlig_1_A = mkA "oätlig" ; -- oätlig..av.1
  oätlighet_1_N = mkN "oätlighet" ; -- oätlighet..nn.1
  oår_1_N = mkN "oår" neutrum  ; -- oår..nn.1
  oåterhållsam_1_A = mkA "oåterhållsam" ; -- oåterhållsam..av.1
  oåterinplanterbar_1_A = mkA "oåterinplanterbar" ; -- oåterinplanterbar..av.1
  oåterinplanterbarhet_1_N = mkN "oåterinplanterbarhet" ; -- oåterinplanterbarhet..nn.1
  oåterinstallerbar_1_A = mkA "oåterinstallerbar" ; -- oåterinstallerbar..av.1
  oåterinstallerbarhet_1_N = mkN "oåterinstallerbarhet" ; -- oåterinstallerbarhet..nn.1
  oåterkallelig_1_A = mkA "oåterkallelig" ; -- oåterkallelig..av.1
  oåterkalleligen_1_Adv = mkAdv "oåterkalleligen" ; -- oåterkalleligen..ab.1
  oåterkallelighet_1_N = mkN "oåterkallelighet" ; -- oåterkallelighet..nn.1
  oåterrapporterbar_1_A = mkA "oåterrapporterbar" ; -- oåterrapporterbar..av.1
  oåterrapporterbarhet_1_N = mkN "oåterrapporterbarhet" ; -- oåterrapporterbarhet..nn.1
  oåterremitterbar_1_A = mkA "oåterremitterbar" ; -- oåterremitterbar..av.1
  oåterremitterbarhet_1_N = mkN "oåterremitterbarhet" ; -- oåterremitterbarhet..nn.1
  oåtkomlig_1_A = mkA "oåtkomlig" ; -- oåtkomlig..av.1
  oåtkomlighet_1_N = mkN "oåtkomlighet" "oåtkomligheter" ; -- oåtkomlighet..nn.1
  oöm_1_A = mkA "oöm" "oömt" "oömma" "oömma" "oömmare" "oömmast" "oömmaste" ; -- oöm..av.1
  oömhet_1_N = mkN "oömhet" ; -- oömhet..nn.1
  oönskad_1_A = mkA "oönskad" ; -- oönskad..av.1
  oöppnad_1_A = mkA "oöppnad" ; -- oöppnad..av.1
  oövad_1_A = mkA "oövad" ; -- oövad..av.1
  oöverbryggbar_1_A = mkA "oöverbryggbar" ; -- oöverbryggbar..av.1
  oöverbryggbarhet_1_N = mkN "oöverbryggbarhet" ; -- oöverbryggbarhet..nn.1
  oöverbrygglig_1_A = mkA "oöverbrygglig" ; -- oöverbrygglig..av.1
  oöverbrygglighet_1_N = mkN "oöverbrygglighet" ; -- oöverbrygglighet..nn.1
  oöverdimensionerbar_1_A = mkA "oöverdimensionerbar" ; -- oöverdimensionerbar..av.1
  oöverdimensionerbarhet_1_N = mkN "oöverdimensionerbarhet" ; -- oöverdimensionerbarhet..nn.1
  oöverdoserbar_1_A = mkA "oöverdoserbar" ; -- oöverdoserbar..av.1
  oöverdoserbarhet_1_N = mkN "oöverdoserbarhet" ; -- oöverdoserbarhet..nn.1
  oöverexponerbar_1_A = mkA "oöverexponerbar" ; -- oöverexponerbar..av.1
  oöverexponerbarhet_1_N = mkN "oöverexponerbarhet" ; -- oöverexponerbarhet..nn.1
  oöverfarbar_1_A = mkA "oöverfarbar" ; -- oöverfarbar..av.1
  oöverfarbarhet_1_N = mkN "oöverfarbarhet" ; -- oöverfarbarhet..nn.1
  oöverflyttbar_1_A = mkA "oöverflyttbar" ; -- oöverflyttbar..av.1
  oöverflyttbarhet_1_N = mkN "oöverflyttbarhet" ; -- oöverflyttbarhet..nn.1
  oöverkomlig_1_A = mkA "oöverkomlig" ; -- oöverkomlig..av.1
  oöverkomlighet_1_N = mkN "oöverkomlighet" ; -- oöverkomlighet..nn.1
  oöverkompenserbar_1_A = mkA "oöverkompenserbar" ; -- oöverkompenserbar..av.1
  oöverkompenserbarhet_1_N = mkN "oöverkompenserbarhet" ; -- oöverkompenserbarhet..nn.1
  oöverlagd_1_A = mkA "oöverlagd" "oöverlagt" ; -- oöverlagd..av.1
  oöverlagdhet_1_N = mkN "oöverlagdhet" ; -- oöverlagdhet..nn.1
  oöversatt_1_A = mkA "oöversatt" ; -- oöversatt..av.1
  oöverskådlig_1_A = mkA "oöverskådlig" ; -- oöverskådlig..av.1
  oöverskådlighet_1_N = mkN "oöverskådlighet" ; -- oöverskådlighet..nn.1
  oöverstiglig_1_A = mkA "oöverstiglig" ; -- oöverstiglig..av.1
  oöverstiglighet_1_N = mkN "oöverstiglighet" ; -- oöverstiglighet..nn.1
  oöversättbar_1_A = mkA "oöversättbar" ; -- oöversättbar..av.1
  oöversättbarhet_1_N = mkN "oöversättbarhet" "oöversättbarheter" ; -- oöversättbarhet..nn.1
  oöversättlig_1_A = mkA "oöversättlig" ; -- oöversättlig..av.1
  oöversättlighet_1_N = mkN "oöversättlighet" "oöversättligheter" ; -- oöversättlighet..nn.1
  oövertrasserbar_1_A = mkA "oövertrasserbar" ; -- oövertrasserbar..av.1
  oövertrasserbarhet_1_N = mkN "oövertrasserbarhet" ; -- oövertrasserbarhet..nn.1
  oöverträffad_1_A = mkA "oöverträffad" ; -- oöverträffad..av.1
  oöverträfflig_1_A = mkA "oöverträfflig" ; -- oöverträfflig..av.1
  oöverträfflighet_1_N = mkN "oöverträfflighet" ; -- oöverträfflighet..nn.1
  oövertänkt_1_A = mkA "oövertänkt" "oövertänkt" ; -- oövertänkt..av.1
  oövertänkthet_1_N = mkN "oövertänkthet" ; -- oövertänkthet..nn.1
  oövervinnelig_1_A = mkA "oövervinnelig" ; -- oövervinnelig..av.1
  oövervinnelighet_1_N = mkN "oövervinnelighet" ; -- oövervinnelighet..nn.1
  oövervinnerlig_1_A = mkA "oövervinnerlig" ; -- oövervinnerlig..av.1
  oövervinnerlighet_1_N = mkN "oövervinnerlighet" ; -- oövervinnerlighet..nn.1
  oövervinnlig_1_A = mkA "oövervinnlig" ; -- oövervinnlig..av.1
  oövervinnlighet_1_N = mkN "oövervinnlighet" ; -- oövervinnlighet..nn.1
  oövervägd_1_A = mkA "oövervägd" "oövervägt" ; -- oövervägd..av.1
  oövervärderbar_1_A = mkA "oövervärderbar" ; -- oövervärderbar..av.1
  oövervärderbarhet_1_N = mkN "oövervärderbarhet" ; -- oövervärderbarhet..nn.1
  p_piller_1_N = mkN "p-piller" neutrum  ; -- p-piller..nn.1
  p_plats_1_N = mkN "p-plats" "p-platser" ; -- p-plats..nn.1
  p_rulle_1_N = mkN "p-rulle" utrum  ; -- p-rulle..nn.1
  p_ruta_1_N = mkN "p-ruta" ; -- p-ruta..nn.1
  pH_balans_1_N = mkN "pH-balans" ; -- pH-balans..nn.1
  pH_värde_1_N = mkN "pH-värde" ; -- pH-värde..nn.1
  pacemaker_1_N = mkN "pacemaker" ; -- pacemaker..nn.1
  pacificera_1_V = mkV "pacificerar" ; -- pacificera..vb.1
  pacificerande_1_N = mkN "pacificerande" ; -- pacificerande..nn.1
  pacificerbar_1_A = mkA "pacificerbar" ; -- pacificerbar..av.1
  pacificerbarhet_1_N = mkN "pacificerbarhet" ; -- pacificerbarhet..nn.1
  pacificering_1_N = mkN "pacificering" ; -- pacificering..nn.1
  pacifism_1_N = mkN "pacifism" "pacifismer" ; -- pacifism..nn.1
  pacifist_1_N = mkN "pacifist" "pacifister" ; -- pacifist..nn.1
  pacifistisk_1_A = mkA "pacifistisk" ; -- pacifistisk..av.1
  pack_1_N = mkN "pack" neutrum  ; -- pack..nn.1
  packa_1_V = mkV "packar" ; -- packa..vb.1
  packad_1_A = mkA "packad" ; -- packad..av.1
  packande_1_N = mkN "packande" ; -- packande..nn.1
  packbox_1_N = mkN "packbox" ; -- packbox..nn.1
  packdjur_1_N = mkN "packdjur" neutrum  ; -- packdjur..nn.1
  packe_1_N = mkN "packe" utrum  ; -- packe..nn.1
  packhus_1_N = mkN "packhus" neutrum  ; -- packhus..nn.1
  packis_1_N = mkN "packis" ; -- packis..nn.1
  packkorg_1_N = mkN "packkorg" ; -- packkorg..nn.1
  packlår_1_N = mkN "packlår" ; -- packlår..nn.1
  packning_1_N = mkN "packning" ; -- packning..nn.1
  packningsdosa_1_N = mkN "packningsdosa" ; -- packningsdosa..nn.1
  packsadel_1_N = mkN "packsadel" ; -- packsadel..nn.1
  packtross_1_N = mkN "packtross" ; -- packtross..nn.1
  packåsna_1_N = mkN "packåsna" ; -- packåsna..nn.1
  padda_1_N = mkN "padda" ; -- padda..nn.1
  paddel_1_N = mkN "paddel" ; -- paddel..nn.1
  paddelliknande_1_A = mkA "paddelliknande" ; -- paddelliknande..av.1
  paddfot_1_N = mkN "paddfot" "paddfötter" ; -- paddfot..nn.1
  paddla_1_V = mkV "paddlar" ; -- paddla..vb.1
  paddlande_1_N = mkN "paddlande" ; -- paddlande..nn.1
  paddling_1_N = mkN "paddling" ; -- paddling..nn.1
  paddock_1_N = mkN "paddock" ; -- paddock..nn.1
  paddslakt_1_N = mkN "paddslakt" ; -- paddslakt..nn.1
  paella_1_N = mkN "paella" ; -- paella..nn.1
  paff_1_A = mkA "paff" ; -- paff..av.1
  paffhet_1_N = mkN "paffhet" ; -- paffhet..nn.1
  page_1_N = mkN "page" "pager" ; -- page..nn.1
  pagefrisyr_1_N = mkN "pagefrisyr" "pagefrisyrer" ; -- pagefrisyr..nn.1
  pagina_1_N = mkN "pagina" ; -- pagina..nn.1
  paginera_1_V = mkV "paginerar" ; -- paginera..vb.1
  paginerande_1_N = mkN "paginerande" ; -- paginerande..nn.1
  paginerbar_1_A = mkA "paginerbar" ; -- paginerbar..av.1
  paginerbarhet_1_N = mkN "paginerbarhet" ; -- paginerbarhet..nn.1
  paginering_1_N = mkN "paginering" ; -- paginering..nn.1
  pagod_1_N = mkN "pagod" "pagoder" ; -- pagod..nn.1
  pagodliknande_1_A = mkA "pagodliknande" ; -- pagodliknande..av.1
  paj_1_A = mkA "paj" ; -- paj..av.1
  paj_1_N = mkN "paj" "pajer" ; -- paj..nn.1
  paja_1_V = mkV "pajar" ; -- paja..vb.1
  pajande_1_N = mkN "pajande" ; -- pajande..nn.1
  pajas_1_N = mkN "pajas" ; -- pajas..nn.1
  pajdeg_1_N = mkN "pajdeg" ; -- pajdeg..nn.1
  pajig_1_A = mkA "pajig" ; -- pajig..av.1
  pajighet_1_N = mkN "pajighet" ; -- pajighet..nn.1
  pajkastning_1_N = mkN "pajkastning" ; -- pajkastning..nn.1
  pajsare_1_N = mkN "pajsare" utrum  ; -- pajsare..nn.1
  paket_1_N = mkN "paket" neutrum  ; -- paket..nn.1
  paketauktion_1_N = mkN "paketauktion" ; -- paketauktion..nn.1
  paketera_1_V = mkV "paketerar" ; -- paketera..vb.1
  paketerande_1_N = mkN "paketerande" ; -- paketerande..nn.1
  paketerbar_1_A = mkA "paketerbar" ; -- paketerbar..av.1
  paketerbarhet_1_N = mkN "paketerbarhet" ; -- paketerbarhet..nn.1
  paketering_1_N = mkN "paketering" ; -- paketering..nn.1
  paketeringsdisk_1_N = mkN "paketeringsdisk" ; -- paketeringsdisk..nn.1
  paketexpedition_1_N = mkN "paketexpedition" ; -- paketexpedition..nn.1
  paketgods_1_N = mkN "paketgods" neutrum  ; -- paketgods..nn.1
  pakethållare_1_N = mkN "pakethållare" utrum  ; -- pakethållare..nn.1
  paketinlämning_1_N = mkN "paketinlämning" ; -- paketinlämning..nn.1
  paketkärra_1_N = mkN "paketkärra" ; -- paketkärra..nn.1
  paketlösning_1_N = mkN "paketlösning" ; -- paketlösning..nn.1
  paketpris_1_N = mkN "paketpris" neutrum  ; -- paketpris..nn.1
  paketresa_1_N = mkN "paketresa" ; -- paketresa..nn.1
  paketutlämning_1_N = mkN "paketutlämning" ; -- paketutlämning..nn.1
  pakistan_1_N = mkN "pakistan" "pakistaner" ; -- pakistan..nn.1
  pakistanare_1_N = mkN "pakistanare" utrum  ; -- pakistanare..nn.1
  pakistansk_1_A = mkA "pakistansk" ; -- pakistansk..av.1
  pakistanska_1_N = mkN "pakistanska" ; -- pakistanska..nn.1
  pakt_1_N = mkN "pakt" "pakter" ; -- pakt..nn.1
  paktum_1_N = mkN "paktum" neutrum  ; -- paktum..nn.1
  paladin_1_N = mkN "paladin" "paladiner" ; -- paladin..nn.1
  palatal_1_A = mkA "palatal" ; -- palatal..av.1
  palatal_1_N = mkN "palatal" "palataler" ; -- palatal..nn.1
  palatalisera_1_V = mkV "palataliserar" ; -- palatalisera..vb.1
  palataliserande_1_N = mkN "palataliserande" ; -- palataliserande..nn.1
  palataliserbar_1_A = mkA "palataliserbar" ; -- palataliserbar..av.1
  palataliserbarhet_1_N = mkN "palataliserbarhet" ; -- palataliserbarhet..nn.1
  palatalisering_1_N = mkN "palatalisering" ; -- palatalisering..nn.1
  palatalljud_1_N = mkN "palatalljud" neutrum  ; -- palatalljud..nn.1
  palats_1_N = mkN "palats" neutrum  ; -- palats..nn.1
  palatsintrig_1_N = mkN "palatsintrig" "palatsintriger" ; -- palatsintrig..nn.1
  palatslik_1_A = mkA "palatslik" ; -- palatslik..av.1
  palatsliknande_1_A = mkA "palatsliknande" ; -- palatsliknande..av.1
  palatsmur_1_N = mkN "palatsmur" ; -- palatsmur..nn.1
  palatsrevolution_1_N = mkN "palatsrevolution" ; -- palatsrevolution..nn.1
  palauer_1_N = mkN "palauer" "palauern" "palauer" "palauerna" ; -- palauer..nn.1
  palauisk_1_A = mkA "palauisk" ; -- palauisk..av.1
  palauiska_1_N = mkN "palauiska" ; -- palauiska..nn.1
  palauiska_2_N = mkN "palauiska" ; -- palauiska..nn.2
  palaver_1_N = mkN "palaver" "palavern" "palavrer" "palavrerna" ; -- palaver..nn.1
  paleoarkeikum_1_N = mkN "paleoarkeikum" ; -- paleoarkeikum..nn.1
  paleocen_1_N = mkN "paleocen" ; -- paleocen..nn.1
  paleoekologisk_1_A = mkA "paleoekologisk" ; -- paleoekologisk..av.1
  paleogen_1_N = mkN "paleogen" ; -- paleogen..nn.1
  paleograf_1_N = mkN "paleograf" "paleografer" ; -- paleograf..nn.1
  paleografi_1_N = mkN "paleografi" ; -- paleografi..nn.1
  paleografisk_1_A = mkA "paleografisk" ; -- paleografisk..av.1
  paleolitisk_1_A = mkA "paleolitisk" ; -- paleolitisk..av.1
  paleolitium_1_N = mkN "paleolitium" ; -- paleolitium..nn.1
  paleontolog_1_N = mkN "paleontolog" "paleontologer" ; -- paleontolog..nn.1
  paleontologi_1_N = mkN "paleontologi" ; -- paleontologi..nn.1
  paleontologisk_1_A = mkA "paleontologisk" ; -- paleontologisk..av.1
  paleoproterozoikum_1_N = mkN "paleoproterozoikum" ; -- paleoproterozoikum..nn.1
  paleozoikum_1_N = mkN "paleozoikum" ; -- paleozoikum..nn.1
  palestinasjal_1_N = mkN "palestinasjal" ; -- palestinasjal..nn.1
  palestinier_1_N = mkN "palestinier" "palestiniern" "palestinier" "palestinierna" ; -- palestinier..nn.1
  palestinsk_1_A = mkA "palestinsk" ; -- palestinsk..av.1
  palett_1_N = mkN "palett" "paletter" ; -- palett..nn.1
  palettkniv_1_N = mkN "palettkniv" ; -- palettkniv..nn.1
  paletå_1_N = mkN "paletå" "paletåer" ; -- paletå..nn.1
  palimpsest_1_N = mkN "palimpsest" "palimpsester" ; -- palimpsest..nn.1
  palindrom_1_N = mkN "palindrom" neutrum  ; -- palindrom..nn.1
  palisander_1_N = mkN "palisander" ; -- palisander..nn.1
  palissad_1_N = mkN "palissad" "palissader" ; -- palissad..nn.1
  paljett_1_N = mkN "paljett" "paljetter" ; -- paljett..nn.1
  paljettbeströdd_1_A = mkA "paljettbeströdd" ; -- paljettbeströdd..av.1
  paljettera_1_V = mkV "paljetterar" ; -- paljettera..vb.1
  paljetterande_1_N = mkN "paljetterande" ; -- paljetterande..nn.1
  paljetterbar_1_A = mkA "paljetterbar" ; -- paljetterbar..av.1
  paljetterbarhet_1_N = mkN "paljetterbarhet" ; -- paljetterbarhet..nn.1
  paljettering_1_N = mkN "paljettering" ; -- paljettering..nn.1
  paljettklänning_1_N = mkN "paljettklänning" ; -- paljettklänning..nn.1
  pall_1_N = mkN "pall" ; -- pall..nn.1
  pall_2_N = mkN "pall" neutrum  ; -- pall..nn.2
  pall_3_N = mkN "pall" ; -- pall..nn.3
  palla_1_V = mkV "pallar" ; -- palla..vb.1
  palla_2_V = mkV "pallar" ; -- palla..vb.2
  palladium_1_N = mkN "palladium" neutrum  ; -- palladium..nn.1
  pallande_1_N = mkN "pallande" ; -- pallande..nn.1
  pallasch_1_N = mkN "pallasch" "pallascher" ; -- pallasch..nn.1
  palliativ_1_A = mkA "palliativ" ; -- palliativ..av.1
  palliativ_1_N = mkN "palliativ" "palliativet" "palliativer" "palliativerna" ; -- palliativ..nn.1
  pallplats_1_N = mkN "pallplats" "pallplatser" ; -- pallplats..nn.1
  pallställage_1_N = mkN "pallställage" "pallställaget" "pallställage" "pallställagen" ; -- pallställage..nn.1
  pallvis_1_Adv = mkAdv "pallvis" ; -- pallvis..ab.1
  palm_1_N = mkN "palm" "palmer" ; -- palm..nn.1
  palma_1_V = mkV "palmar" ; -- palma..vb.1
  palmande_1_N = mkN "palmande" ; -- palmande..nn.1
  palmblad_1_N = mkN "palmblad" neutrum  ; -- palmblad..nn.1
  palmett_1_N = mkN "palmett" "palmetter" ; -- palmett..nn.1
  palmfett_1_N = mkN "palmfett" neutrum  ; -- palmfett..nn.1
  palmhus_1_N = mkN "palmhus" neutrum  ; -- palmhus..nn.1
  palmitin_1_N = mkN "palmitin" ; -- palmitin..nn.1
  palmitinsyra_1_N = mkN "palmitinsyra" ; -- palmitinsyra..nn.1
  palmkvist_1_N = mkN "palmkvist" ; -- palmkvist..nn.1
  palmkärna_1_N = mkN "palmkärna" ; -- palmkärna..nn.1
  palmolja_1_N = mkN "palmolja" ; -- palmolja..nn.1
  palmplym_1_N = mkN "palmplym" "palmplymer" ; -- palmplym..nn.1
  palmsöndag_1_N = mkN "palmsöndag" ; -- palmsöndag..nn.1
  palmvin_1_N = mkN "palmvin" "palmvinet" "palmviner" "palmvinerna" ; -- palmvin..nn.1
  palp_1_N = mkN "palp" "palper" ; -- palp..nn.1
  palpation_1_N = mkN "palpation" ; -- palpation..nn.1
  palpera_1_V = mkV "palperar" ; -- palpera..vb.1
  palperande_1_N = mkN "palperande" ; -- palperande..nn.1
  palperbar_1_A = mkA "palperbar" ; -- palperbar..av.1
  palperbarhet_1_N = mkN "palperbarhet" ; -- palperbarhet..nn.1
  palpering_1_N = mkN "palpering" ; -- palpering..nn.1
  pals_1_N = mkN "pals" ; -- pals..nn.1
  palsternacka_1_N = mkN "palsternacka" ; -- palsternacka..nn.1
  palt_1_N = mkN "palt" ; -- palt..nn.1
  paltbröd_1_N = mkN "paltbröd" neutrum  ; -- paltbröd..nn.1
  paltig_1_A = mkA "paltig" ; -- paltig..av.1
  paltighet_1_N = mkN "paltighet" ; -- paltighet..nn.1
  paltkoma_1_N = mkN "paltkoma" ; -- paltkoma..nn.1
  paltrockkvarn_1_N = mkN "paltrockkvarn" ; -- paltrockkvarn..nn.1
  palä_1_N = mkN "palä" "paläet" "paläer" "paläerna" ; -- palä..nn.1
  pamflett_1_N = mkN "pamflett" "pamfletter" ; -- pamflett..nn.1
  pamflettist_1_N = mkN "pamflettist" "pamflettister" ; -- pamflettist..nn.1
  pamp_1_N = mkN "pamp" ; -- pamp..nn.1
  pampas_1_N = mkN "pampas" ; -- pampas..nn.1
  pampasgräs_1_N = mkN "pampasgräs" neutrum  ; -- pampasgräs..nn.1
  pampig_1_A = mkA "pampig" ; -- pampig..av.1
  pampighet_1_N = mkN "pampighet" ; -- pampighet..nn.1
  pampusch_1_N = mkN "pampusch" "pampuscher" ; -- pampusch..nn.1
  panafrikansk_1_A = mkA "panafrikansk" ; -- panafrikansk..av.1
  panama_1_N = mkN "panama" ; -- panama..nn.1
  panamahatt_1_N = mkN "panamahatt" ; -- panamahatt..nn.1
  panaman_1_N = mkN "panaman" "panamaner" ; -- panaman..nn.1
  panamansk_1_A = mkA "panamansk" ; -- panamansk..av.1
  panamanska_1_N = mkN "panamanska" ; -- panamanska..nn.1
  panamerikansk_1_A = mkA "panamerikansk" ; -- panamerikansk..av.1
  panarabisk_1_A = mkA "panarabisk" ; -- panarabisk..av.1
  panasch_1_N = mkN "panasch" "panascher" ; -- panasch..nn.1
  panaschering_1_N = mkN "panaschering" ; -- panaschering..nn.1
  panchis_1_N = mkN "panchis" ; -- panchis..nn.1
  panda_1_N = mkN "panda" ; -- panda..nn.1
  pandemi_1_N = mkN "pandemi" "pandemier" ; -- pandemi..nn.1
  pandemisk_1_A = mkA "pandemisk" ; -- pandemisk..av.1
  panegyrik_1_N = mkN "panegyrik" "panegyriker" ; -- panegyrik..nn.1
  panegyriker_1_N = mkN "panegyriker" "panegyrikern" "panegyriker" "panegyrikerna" ; -- panegyriker..nn.1
  panegyrisk_1_A = mkA "panegyrisk" ; -- panegyrisk..av.1
  panel_1_N = mkN "panel" "paneler" ; -- panel..nn.1
  panela_1_V = mkV "panelar" ; -- panela..vb.1
  panelande_1_N = mkN "panelande" ; -- panelande..nn.1
  paneldebatt_1_N = mkN "paneldebatt" "paneldebatter" ; -- paneldebatt..nn.1
  paneldiskussion_1_N = mkN "paneldiskussion" ; -- paneldiskussion..nn.1
  panelhöna_1_N = mkN "panelhöna" ; -- panelhöna..nn.1
  panera_1_V = mkV "panerar" ; -- panera..vb.1
  panerande_1_N = mkN "panerande" ; -- panerande..nn.1
  panerbar_1_A = mkA "panerbar" ; -- panerbar..av.1
  panerbarhet_1_N = mkN "panerbarhet" ; -- panerbarhet..nn.1
  panering_1_N = mkN "panering" ; -- panering..nn.1
  panett_1_N = mkN "panett" "panetter" ; -- panett..nn.1
  paneuropeisk_1_A = mkA "paneuropeisk" ; -- paneuropeisk..av.1
  panflöjt_1_N = mkN "panflöjt" "panflöjter" ; -- panflöjt..nn.1
  panflöjtsspelare_1_N = mkN "panflöjtsspelare" utrum  ; -- panflöjtsspelare..nn.1
  pang_pangfilm_1_N = mkN "pang-pangfilm" "pang-pangfilmer" ; -- pang-pangfilm..nn.1
  pang_1_N = mkN "pang" neutrum  ; -- pang..nn.1
  panga_1_V = mkV "pangar" ; -- panga..vb.1
  panga_2_V = mkV "pangar" ; -- panga..vb.2
  pangande_1_N = mkN "pangande" ; -- pangande..nn.1
  pangasius_1_N = mkN "pangasius" ; -- pangasius..nn.1
  pangpjäs_1_N = mkN "pangpjäs" "pangpjäser" ; -- pangpjäs..nn.1
  panhellenism_1_N = mkN "panhellenism" "panhellenismer" ; -- panhellenism..nn.1
  panik_1_N = mkN "panik" ; -- panik..nn.1
  panikanfall_1_N = mkN "panikanfall" neutrum  ; -- panikanfall..nn.1
  panikartad_1_A = mkA "panikartad" ; -- panikartad..av.1
  panikattack_1_N = mkN "panikattack" "panikattacker" ; -- panikattack..nn.1
  panikbromsa_1_V = mkV "panikbromsar" ; -- panikbromsa..vb.1
  panikmejl_1_N = mkN "panikmejl" ; -- panikmejl..nn.1
  panikmässig_1_A = mkA "panikmässig" ; -- panikmässig..av.1
  panikslagen_1_A = mkA "panikslagen" ; -- panikslagen..av.1
  panikunge_1_N = mkN "panikunge" utrum  ; -- panikunge..nn.1
  panikångest_1_N = mkN "panikångest" ; -- panikångest..nn.1
  panikångestattack_1_N = mkN "panikångestattack" "panikångestattacker" ; -- panikångestattack..nn.1
  panisk_1_A = mkA "panisk" ; -- panisk..av.1
  pank_1_A = mkA "pank" ; -- pank..av.1
  panka_1_N = mkN "panka" ; -- panka..nn.1
  pankhet_1_N = mkN "pankhet" ; -- pankhet..nn.1
  pankreaskörtel_1_N = mkN "pankreaskörtel" ; -- pankreaskörtel..nn.1
  pankreatit_1_N = mkN "pankreatit" "pankreatiter" ; -- pankreatit..nn.1
  pankromatisk_1_A = mkA "pankromatisk" ; -- pankromatisk..av.1
  panna_1_N = mkN "panna" ; -- panna..nn.1
  pannband_1_N = mkN "pannband" neutrum  ; -- pannband..nn.1
  pannben_1_N = mkN "pannben" neutrum  ; -- pannben..nn.1
  pannbiff_1_N = mkN "pannbiff" ; -- pannbiff..nn.1
  pannhåla_1_N = mkN "pannhåla" ; -- pannhåla..nn.1
  pannkaka_1_N = mkN "pannkaka" ; -- pannkaka..nn.1
  pannkaksmoln_1_N = mkN "pannkaksmoln" neutrum  ; -- pannkaksmoln..nn.1
  pannkakssmet_1_N = mkN "pannkakssmet" "pannkakssmeter" ; -- pannkakssmet..nn.1
  pannkaksteoretiker_1_N = mkN "pannkaksteoretiker" "pannkaksteoretikern" "pannkaksteoretiker" "pannkaksteoretikerna" ; -- pannkaksteoretiker..nn.1
  pannkaksteori_1_N = mkN "pannkaksteori" "pannkaksteorier" ; -- pannkaksteori..nn.1
  pannlampa_1_N = mkN "pannlampa" ; -- pannlampa..nn.1
  pannlob_1_N = mkN "pannlob" "pannlober" ; -- pannlob..nn.1
  pannrum_1_N = mkN "pannrum" "pannrummet" "pannrum" "pannrummen" ; -- pannrum..nn.1
  pannspegel_1_N = mkN "pannspegel" ; -- pannspegel..nn.1
  pannå_1_N = mkN "pannå" "pannåer" ; -- pannå..nn.1
  panoptikon_1_N = mkN "panoptikon" neutrum  ; -- panoptikon..nn.1
  panorama_1_N = mkN "panorama" "panoramat" "panoramor" "panoramorna" ; -- panorama..nn.1
  panoramafönster_1_N = mkN "panoramafönster" neutrum  ; -- panoramafönster..nn.1
  panoramakamera_1_N = mkN "panoramakamera" ; -- panoramakamera..nn.1
  panorera_1_V = mkV "panorerar" ; -- panorera..vb.1
  panorerande_1_N = mkN "panorerande" ; -- panorerande..nn.1
  panorerbar_1_A = mkA "panorerbar" ; -- panorerbar..av.1
  panorerbarhet_1_N = mkN "panorerbarhet" ; -- panorerbarhet..nn.1
  panorering_1_N = mkN "panorering" ; -- panorering..nn.1
  pansar_1_N = mkN "pansar" neutrum  ; -- pansar..nn.1
  pansarbil_1_N = mkN "pansarbil" ; -- pansarbil..nn.1
  pansarbrytande_1_A = mkA "pansarbrytande" ; -- pansarbrytande..av.1
  pansarbåt_1_N = mkN "pansarbåt" ; -- pansarbåt..nn.1
  pansarfartyg_1_N = mkN "pansarfartyg" neutrum  ; -- pansarfartyg..nn.1
  pansarflotta_1_N = mkN "pansarflotta" ; -- pansarflotta..nn.1
  pansarfordon_1_N = mkN "pansarfordon" neutrum  ; -- pansarfordon..nn.1
  pansarfärg_1_N = mkN "pansarfärg" ; -- pansarfärg..nn.1
  pansargeneral_1_N = mkN "pansargeneral" "pansargeneraler" ; -- pansargeneral..nn.1
  pansarglas_1_N = mkN "pansarglas" neutrum  ; -- pansarglas..nn.1
  pansargranat_1_N = mkN "pansargranat" "pansargranater" ; -- pansargranat..nn.1
  pansarhinder_1_N = mkN "pansarhinder" neutrum  ; -- pansarhinder..nn.1
  pansarhjärta_1_N = mkN "pansarhjärta" "pansarhjärtat" "pansarhjärtan" "pansarhjärtana" ; -- pansarhjärta..nn.1
  pansarklädd_1_A = mkA "pansarklädd" ; -- pansarklädd..av.1
  pansarkår_1_N = mkN "pansarkår" "pansarkårer" ; -- pansarkår..nn.1
  pansarmal_1_N = mkN "pansarmal" ; -- pansarmal..nn.1
  pansarplåt_1_N = mkN "pansarplåt" ; -- pansarplåt..nn.1
  pansarregemente_1_N = mkN "pansarregemente" ; -- pansarregemente..nn.1
  pansarrör_1_N = mkN "pansarrör" neutrum  ; -- pansarrör..nn.1
  pansarsjäl_1_N = mkN "pansarsjäl" ; -- pansarsjäl..nn.1
  pansarskjorta_1_N = mkN "pansarskjorta" ; -- pansarskjorta..nn.1
  pansarskott_1_N = mkN "pansarskott" neutrum  ; -- pansarskott..nn.1
  pansartorn_1_N = mkN "pansartorn" neutrum  ; -- pansartorn..nn.1
  pansartrupp_1_N = mkN "pansartrupp" "pansartrupper" ; -- pansartrupp..nn.1
  pansarvagn_1_N = mkN "pansarvagn" ; -- pansarvagn..nn.1
  pansarvärn_1_N = mkN "pansarvärn" neutrum  ; -- pansarvärn..nn.1
  pansarvärnsrobot_1_N = mkN "pansarvärnsrobot" ; -- pansarvärnsrobot..nn.1
  pansarvärnsvapen_1_N = mkN "pansarvärnsvapen" "pansarvärnsvapnet" "pansarvärnsvapen" "pansarvärnsvapnen" ; -- pansarvärnsvapen..nn.1
  panschis_1_N = mkN "panschis" ; -- panschis..nn.1
  pansjis_1_N = mkN "pansjis" ; -- pansjis..nn.1
  pansra_1_V = mkV "pansrar" ; -- pansra..vb.1
  pansrande_1_N = mkN "pansrande" ; -- pansrande..nn.1
  pant_1_N = mkN "pant" "panter" ; -- pant..nn.1
  panta_1_V = mkV "pantar" ; -- panta..vb.1
  pantad_1_A = mkA "pantad" ; -- pantad..av.1
  pantande_1_N = mkN "pantande" ; -- pantande..nn.1
  pantbank_1_N = mkN "pantbank" "pantbanker" ; -- pantbank..nn.1
  pantbrev_1_N = mkN "pantbrev" neutrum  ; -- pantbrev..nn.1
  pantburk_1_N = mkN "pantburk" ; -- pantburk..nn.1
  panteism_1_N = mkN "panteism" "panteismer" ; -- panteism..nn.1
  panteist_1_N = mkN "panteist" "panteister" ; -- panteist..nn.1
  panteistisk_1_A = mkA "panteistisk" ; -- panteistisk..av.1
  panteon_1_N = mkN "panteon" neutrum  ; -- panteon..nn.1
  panter_1_N = mkN "panter" ; -- panter..nn.1
  panterfläckig_1_A = mkA "panterfläckig" ; -- panterfläckig..av.1
  panterkatt_1_N = mkN "panterkatt" "panterkatter" ; -- panterkatt..nn.1
  pantersprång_1_N = mkN "pantersprång" neutrum  ; -- pantersprång..nn.1
  pantertant_1_N = mkN "pantertant" "pantertanter" ; -- pantertant..nn.1
  pantförskriva_1_V = mkV "pantförskriva" "pantförskrev" "pantförskrivit" ; -- pantförskriva..vb.1
  pantförskrivande_1_N = mkN "pantförskrivande" ; -- pantförskrivande..nn.1
  panthavare_1_N = mkN "panthavare" utrum  ; -- panthavare..nn.1
  pantlån_1_N = mkN "pantlån" neutrum  ; -- pantlån..nn.1
  pantlånare_1_N = mkN "pantlånare" utrum  ; -- pantlånare..nn.1
  pantlånerörelse_1_N = mkN "pantlånerörelse" "pantlånerörelser" ; -- pantlånerörelse..nn.1
  pantning_1_N = mkN "pantning" ; -- pantning..nn.1
  pantograf_1_N = mkN "pantograf" "pantografer" ; -- pantograf..nn.1
  pantografera_1_V = mkV "pantograferar" ; -- pantografera..vb.1
  pantograferande_1_N = mkN "pantograferande" ; -- pantograferande..nn.1
  pantograferbar_1_A = mkA "pantograferbar" ; -- pantograferbar..av.1
  pantograferbarhet_1_N = mkN "pantograferbarhet" ; -- pantograferbarhet..nn.1
  pantografering_1_N = mkN "pantografering" ; -- pantografering..nn.1
  pantomim_1_N = mkN "pantomim" "pantomimer" ; -- pantomim..nn.1
  pantomimisk_1_A = mkA "pantomimisk" ; -- pantomimisk..av.1
  panträtt_1_N = mkN "panträtt" "panträtter" ; -- panträtt..nn.1
  pantsätta_1_V = mkV "pantsätta" "pantsätter" "pantsätt" "pantsatte" "pantsatt" "pantsatt" ; -- pantsätta..vb.1
  pantsättande_1_N = mkN "pantsättande" ; -- pantsättande..nn.1
  pantsättare_1_N = mkN "pantsättare" utrum  ; -- pantsättare..nn.1
  papaverin_1_N = mkN "papaverin" neutrum  ; -- papaverin..nn.1
  papaya_1_N = mkN "papaya" ; -- papaya..nn.1
  papegoja_1_N = mkN "papegoja" ; -- papegoja..nn.1
  papegojfisk_1_N = mkN "papegojfisk" ; -- papegojfisk..nn.1
  papegojliknande_1_A = mkA "papegojliknande" ; -- papegojliknande..av.1
  papegojsjuka_1_N = mkN "papegojsjuka" ; -- papegojsjuka..nn.1
  papegojtulpan_1_N = mkN "papegojtulpan" "papegojtulpaner" ; -- papegojtulpan..nn.1
  paper_1_N = mkN "paper" "paperet" "paper" "paperen" ; -- paper..nn.1
  paperback_1_N = mkN "paperback" ; -- paperback..nn.1
  papeteri_1_N = mkN "papeteri" "papeteriet" "papeterier" "papeterierna" ; -- papeteri..nn.1
  papiljott_1_N = mkN "papiljott" "papiljotter" ; -- papiljott..nn.1
  papill_1_N = mkN "papill" "papiller" ; -- papill..nn.1
  papillom_1_N = mkN "papillom" neutrum  ; -- papillom..nn.1
  papillon_1_N = mkN "papillon" "papilloner" ; -- papillon..nn.1
  papism_1_N = mkN "papism" "papismer" ; -- papism..nn.1
  papist_1_N = mkN "papist" "papister" ; -- papist..nn.1
  papistisk_1_A = mkA "papistisk" ; -- papistisk..av.1
  papp_1_N = mkN "papp" ; -- papp..nn.1
  pappa_1_N = mkN "pappa" ; -- pappa..nn.1
  pappaledig_1_A = mkA "pappaledig" ; -- pappaledig..av.1
  pappaledighet_1_N = mkN "pappaledighet" ; -- pappaledighet..nn.1
  pappband_1_N = mkN "pappband" neutrum  ; -- pappband..nn.1
  pappburk_1_N = mkN "pappburk" ; -- pappburk..nn.1
  papper_1_N = mkN "papper" neutrum  ; -- papper..nn.1
  pappersarbete_1_N = mkN "pappersarbete" ; -- pappersarbete..nn.1
  pappersark_1_N = mkN "pappersark" neutrum  ; -- pappersark..nn.1
  pappersbit_1_N = mkN "pappersbit" ; -- pappersbit..nn.1
  pappersblomma_1_N = mkN "pappersblomma" ; -- pappersblomma..nn.1
  pappersbruk_1_N = mkN "pappersbruk" neutrum  ; -- pappersbruk..nn.1
  pappersbunt_1_N = mkN "pappersbunt" ; -- pappersbunt..nn.1
  pappersdokument_1_N = mkN "pappersdokument" neutrum  ; -- pappersdokument..nn.1
  pappersexercis_1_N = mkN "pappersexercis" ; -- pappersexercis..nn.1
  pappersformat_1_N = mkN "pappersformat" neutrum  ; -- pappersformat..nn.1
  pappershandduk_1_N = mkN "pappershandduk" ; -- pappershandduk..nn.1
  pappershandel_1_N = mkN "pappershandel" ; -- pappershandel..nn.1
  pappershög_1_N = mkN "pappershög" ; -- pappershög..nn.1
  pappersinsamling_1_N = mkN "pappersinsamling" ; -- pappersinsamling..nn.1
  papperskasse_1_N = mkN "papperskasse" utrum  ; -- papperskasse..nn.1
  pappersklämma_1_N = mkN "pappersklämma" ; -- pappersklämma..nn.1
  papperskniv_1_N = mkN "papperskniv" ; -- papperskniv..nn.1
  papperskorg_1_N = mkN "papperskorg" ; -- papperskorg..nn.1
  papperskrig_1_N = mkN "papperskrig" neutrum  ; -- papperskrig..nn.1
  papperskula_1_N = mkN "papperskula" ; -- papperskula..nn.1
  papperskvarn_1_N = mkN "papperskvarn" ; -- papperskvarn..nn.1
  papperslapp_1_N = mkN "papperslapp" ; -- papperslapp..nn.1
  papperslump_1_N = mkN "papperslump" ; -- papperslump..nn.1
  papperslös_1_A = mkA "papperslös" ; -- papperslös..av.1
  pappersmaskin_1_N = mkN "pappersmaskin" "pappersmaskiner" ; -- pappersmaskin..nn.1
  pappersmassa_1_N = mkN "pappersmassa" ; -- pappersmassa..nn.1
  pappersmugg_1_N = mkN "pappersmugg" ; -- pappersmugg..nn.1
  pappersmynt_1_N = mkN "pappersmynt" neutrum  ; -- pappersmynt..nn.1
  pappersmyntfot_1_N = mkN "pappersmyntfot" ; -- pappersmyntfot..nn.1
  pappersnäsduk_1_N = mkN "pappersnäsduk" ; -- pappersnäsduk..nn.1
  papperspapiljott_1_N = mkN "papperspapiljott" "papperspapiljotter" ; -- papperspapiljott..nn.1
  papperspelle_1_N = mkN "papperspelle" utrum  ; -- papperspelle..nn.1
  papperspeng_1_N = mkN "papperspeng" ; -- papperspeng..nn.1
  pappersplan_1_N = mkN "pappersplan" neutrum  ; -- pappersplan..nn.1
  papperspåse_1_N = mkN "papperspåse" utrum  ; -- papperspåse..nn.1
  pappersremsa_1_N = mkN "pappersremsa" ; -- pappersremsa..nn.1
  papperssax_1_N = mkN "papperssax" ; -- papperssax..nn.1
  pappersservett_1_N = mkN "pappersservett" "pappersservetter" ; -- pappersservett..nn.1
  papperssnöre_1_N = mkN "papperssnöre" ; -- papperssnöre..nn.1
  pappersstjärna_1_N = mkN "pappersstjärna" ; -- pappersstjärna..nn.1
  papperssvala_1_N = mkN "papperssvala" ; -- papperssvala..nn.1
  papperssäck_1_N = mkN "papperssäck" ; -- papperssäck..nn.1
  papperstallrik_1_N = mkN "papperstallrik" ; -- papperstallrik..nn.1
  papperstidning_1_N = mkN "papperstidning" ; -- papperstidning..nn.1
  papperstiger_1_N = mkN "papperstiger" ; -- papperstiger..nn.1
  papperstillverkning_1_N = mkN "papperstillverkning" ; -- papperstillverkning..nn.1
  papperstuss_1_N = mkN "papperstuss" ; -- papperstuss..nn.1
  pappersupplaga_1_N = mkN "pappersupplaga" ; -- pappersupplaga..nn.1
  pappig_1_A = mkA "pappig" ; -- pappig..av.1
  pappighet_1_N = mkN "pappighet" ; -- pappighet..nn.1
  pappkartong_1_N = mkN "pappkartong" "pappkartonger" ; -- pappkartong..nn.1
  papplåda_1_N = mkN "papplåda" ; -- papplåda..nn.1
  pappskalle_1_N = mkN "pappskalle" utrum  ; -- pappskalle..nn.1
  pappskylt_1_N = mkN "pappskylt" ; -- pappskylt..nn.1
  pappslöjd_1_N = mkN "pappslöjd" ; -- pappslöjd..nn.1
  pappspik_1_N = mkN "pappspik" ; -- pappspik..nn.1
  papptallrik_1_N = mkN "papptallrik" ; -- papptallrik..nn.1
  pappurna_1_N = mkN "pappurna" ; -- pappurna..nn.1
  paprika_1_N = mkN "paprika" ; -- paprika..nn.1
  paprikapulver_1_N = mkN "paprikapulver" neutrum  ; -- paprikapulver..nn.1
  paprikaring_1_N = mkN "paprikaring" ; -- paprikaring..nn.1
  papua_1_N = mkN "papua" "papuan" "papuas" "papuasarna" ; -- papua..nn.1
  papuan_1_N = mkN "papuan" "papuaner" ; -- papuan..nn.1
  papuansk_1_A = mkA "papuansk" ; -- papuansk..av.1
  papyrologi_1_N = mkN "papyrologi" ; -- papyrologi..nn.1
  papyross_1_N = mkN "papyross" "papyrosser" ; -- papyross..nn.1
  papyrus_1_N = mkN "papyrus" "papyrer" ; -- papyrus..nn.1
  papyrusrulle_1_N = mkN "papyrusrulle" utrum  ; -- papyrusrulle..nn.1
  par_1_N = mkN "par" neutrum  ; -- par..nn.1
  para_1_V = mkV "parar" ; -- para..vb.1
  parabel_1_N = mkN "parabel" "parabeln" "parabler" "parablerna" ; -- parabel..nn.1
  parabellum_1_N = mkN "parabellum" ; -- parabellum..nn.1
  parabol_1_N = mkN "parabol" "paraboler" ; -- parabol..nn.1
  parabolantenn_1_N = mkN "parabolantenn" "parabolantenner" ; -- parabolantenn..nn.1
  parabolisk_1_A = mkA "parabolisk" ; -- parabolisk..av.1
  paracervikalblockad_1_N = mkN "paracervikalblockad" "paracervikalblockader" ; -- paracervikalblockad..nn.1
  paracetamol_1_N = mkN "paracetamol" "paracetamoler" ; -- paracetamol..nn.1
  parad_1_N = mkN "parad" "parader" ; -- parad..nn.1
  paraddräkt_1_N = mkN "paraddräkt" "paraddräkter" ; -- paraddräkt..nn.1
  paradentit_1_N = mkN "paradentit" "paradentiter" ; -- paradentit..nn.1
  paradera_1_V = mkV "paraderar" ; -- paradera..vb.1
  paraderande_1_N = mkN "paraderande" ; -- paraderande..nn.1
  paraderbar_1_A = mkA "paraderbar" ; -- paraderbar..av.1
  paraderbarhet_1_N = mkN "paraderbarhet" ; -- paraderbarhet..nn.1
  paradering_1_N = mkN "paradering" ; -- paradering..nn.1
  paradexempel_1_N = mkN "paradexempel" neutrum  ; -- paradexempel..nn.1
  paradgata_1_N = mkN "paradgata" ; -- paradgata..nn.1
  paradhäst_1_N = mkN "paradhäst" ; -- paradhäst..nn.1
  paradigm_1_N = mkN "paradigm" neutrum  ; -- paradigm..nn.1
  paradigmskifte_1_N = mkN "paradigmskifte" ; -- paradigmskifte..nn.1
  paradis_1_N = mkN "paradis" neutrum  ; -- paradis..nn.1
  paradisdräkt_1_N = mkN "paradisdräkt" "paradisdräkter" ; -- paradisdräkt..nn.1
  paradisfrö_1_N = mkN "paradisfrö" "paradisfröet" "paradisfrön" "paradisfröna" ; -- paradisfrö..nn.1
  paradisfågel_1_N = mkN "paradisfågel" ; -- paradisfågel..nn.1
  paradisisk_1_A = mkA "paradisisk" ; -- paradisisk..av.1
  paradiskorn_1_N = mkN "paradiskorn" neutrum  ; -- paradiskorn..nn.1
  paradisstrand_1_N = mkN "paradisstrand" "paradisstränder" ; -- paradisstrand..nn.1
  paradisäpple_1_N = mkN "paradisäpple" ; -- paradisäpple..nn.1
  paradklädd_1_A = mkA "paradklädd" ; -- paradklädd..av.1
  paradmarsch_1_N = mkN "paradmarsch" "paradmarscher" ; -- paradmarsch..nn.1
  paradmässig_1_A = mkA "paradmässig" ; -- paradmässig..av.1
  paradmålning_1_N = mkN "paradmålning" ; -- paradmålning..nn.1
  paradnummer_1_N = mkN "paradnummer" neutrum  ; -- paradnummer..nn.1
  paradox_1_N = mkN "paradox" "paradoxer" ; -- paradox..nn.1
  paradoxal_1_A = mkA "paradoxal" ; -- paradoxal..av.1
  paradoxmakare_1_N = mkN "paradoxmakare" utrum  ; -- paradoxmakare..nn.1
  paradrum_1_N = mkN "paradrum" "paradrummet" "paradrum" "paradrummen" ; -- paradrum..nn.1
  paradsäng_1_N = mkN "paradsäng" ; -- paradsäng..nn.1
  paraduniform_1_N = mkN "paraduniform" "paraduniformer" ; -- paraduniform..nn.1
  paraduppställning_1_N = mkN "paraduppställning" ; -- paraduppställning..nn.1
  parafasi_1_N = mkN "parafasi" "parafasier" ; -- parafasi..nn.1
  parafera_1_V = mkV "paraferar" ; -- parafera..vb.1
  paraferande_1_N = mkN "paraferande" ; -- paraferande..nn.1
  paraferbar_1_A = mkA "paraferbar" ; -- paraferbar..av.1
  paraferbarhet_1_N = mkN "paraferbarhet" ; -- paraferbarhet..nn.1
  parafering_1_N = mkN "parafering" ; -- parafering..nn.1
  paraffin_1_N = mkN "paraffin" ; -- paraffin..nn.1
  paraffinera_1_V = mkV "paraffinerar" ; -- paraffinera..vb.1
  paraffinerande_1_N = mkN "paraffinerande" ; -- paraffinerande..nn.1
  paraffinerbar_1_A = mkA "paraffinerbar" ; -- paraffinerbar..av.1
  paraffinerbarhet_1_N = mkN "paraffinerbarhet" ; -- paraffinerbarhet..nn.1
  paraffinering_1_N = mkN "paraffinering" ; -- paraffinering..nn.1
  parafiber_1_N = mkN "parafiber" "parafibern" "parafibrer" "parafibrerna" ; -- parafiber..nn.1
  parafras_1_N = mkN "parafras" "parafraser" ; -- parafras..nn.1
  parafrasera_1_V = mkV "parafraserar" ; -- parafrasera..vb.1
  parafraserande_1_N = mkN "parafraserande" ; -- parafraserande..nn.1
  parafraserbar_1_A = mkA "parafraserbar" ; -- parafraserbar..av.1
  parafraserbarhet_1_N = mkN "parafraserbarhet" ; -- parafraserbarhet..nn.1
  parafrasering_1_N = mkN "parafrasering" ; -- parafrasering..nn.1
  parafrastisk_1_A = mkA "parafrastisk" ; -- parafrastisk..av.1
  paragon_1_N = mkN "paragon" "paragoner" ; -- paragon..nn.1
  paragraf_1_N = mkN "paragraf" "paragrafer" ; -- paragraf..nn.1
  paragrafryttare_1_N = mkN "paragrafryttare" utrum  ; -- paragrafryttare..nn.1
  paragraftecken_1_N = mkN "paragraftecken" "paragraftecknet" "paragraftecken" "paragraftecknen" ; -- paragraftecken..nn.1
  paraguayan_1_N = mkN "paraguayan" "paraguayaner" ; -- paraguayan..nn.1
  paraguayansk_1_A = mkA "paraguayansk" ; -- paraguayansk..av.1
  paraguayanska_1_N = mkN "paraguayanska" ; -- paraguayanska..nn.1
  paraguayare_1_N = mkN "paraguayare" utrum  ; -- paraguayare..nn.1
  paraguaysk_1_A = mkA "paraguaysk" ; -- paraguaysk..av.1
  paraguayte_1_N = mkN "paraguayte" ; -- paraguayte..nn.1
  parallaktisk_1_A = mkA "parallaktisk" ; -- parallaktisk..av.1
  parallax_1_N = mkN "parallax" ; -- parallax..nn.1
  parallell_1_A = mkA "parallell" ; -- parallell..av.1
  parallell_1_N = mkN "parallell" "paralleller" ; -- parallell..nn.1
  parallellaxiom_1_N = mkN "parallellaxiom" neutrum  ; -- parallellaxiom..nn.1
  parallellcirkel_1_N = mkN "parallellcirkel" ; -- parallellcirkel..nn.1
  parallelldam_1_N = mkN "parallelldam" "parallelldamer" ; -- parallelldam..nn.1
  parallellepiped_1_N = mkN "parallellepiped" "parallellepipeder" ; -- parallellepiped..nn.1
  parallellfall_1_N = mkN "parallellfall" neutrum  ; -- parallellfall..nn.1
  parallellfamilj_1_N = mkN "parallellfamilj" "parallellfamiljer" ; -- parallellfamilj..nn.1
  parallellgrad_1_N = mkN "parallellgrad" "parallellgrader" ; -- parallellgrad..nn.1
  parallellisera_1_V = mkV "parallelliserar" ; -- parallellisera..vb.1
  parallelliserande_1_N = mkN "parallelliserande" ; -- parallelliserande..nn.1
  parallelliserbar_1_A = mkA "parallelliserbar" ; -- parallelliserbar..av.1
  parallelliserbarhet_1_N = mkN "parallelliserbarhet" ; -- parallelliserbarhet..nn.1
  parallellisering_1_N = mkN "parallellisering" ; -- parallellisering..nn.1
  parallellism_1_N = mkN "parallellism" "parallellismer" ; -- parallellism..nn.1
  parallellistisk_1_A = mkA "parallellistisk" ; -- parallellistisk..av.1
  parallellitet_1_N = mkN "parallellitet" "parallelliteter" ; -- parallellitet..nn.1
  parallellklass_1_N = mkN "parallellklass" "parallellklasser" ; -- parallellklass..nn.1
  parallellkoppla_1_V = mkV "parallellkopplar" ; -- parallellkoppla..vb.1
  parallellkopplande_1_N = mkN "parallellkopplande" ; -- parallellkopplande..nn.1
  parallellkoppling_1_N = mkN "parallellkoppling" ; -- parallellkoppling..nn.1
  parallellogram_1_N = mkN "parallellogram" "parallellogrammen" "parallellogrammer" "parallellogrammerna" ; -- parallellogram..nn.1
  parallellstag_1_N = mkN "parallellstag" neutrum  ; -- parallellstag..nn.1
  parallellställe_1_N = mkN "parallellställe" ; -- parallellställe..nn.1
  parallelltrapets_1_N = mkN "parallelltrapets" "parallelltrapetset" "parallelltrapetser" "parallelltrapetserna" ; -- parallelltrapets..nn.1
  parallellvärld_1_N = mkN "parallellvärld" ; -- parallellvärld..nn.1
  paralys_1_N = mkN "paralys" "paralyser" ; -- paralys..nn.1
  paralysera_1_V = mkV "paralyserar" ; -- paralysera..vb.1
  paralyserande_1_N = mkN "paralyserande" ; -- paralyserande..nn.1
  paralyserbar_1_A = mkA "paralyserbar" ; -- paralyserbar..av.1
  paralyserbarhet_1_N = mkN "paralyserbarhet" ; -- paralyserbarhet..nn.1
  paralysering_1_N = mkN "paralysering" ; -- paralysering..nn.1
  paralytiker_1_N = mkN "paralytiker" "paralytikern" "paralytiker" "paralytikerna" ; -- paralytiker..nn.1
  paralytisk_1_A = mkA "paralytisk" ; -- paralytisk..av.1
  parameter_1_N = mkN "parameter" ; -- parameter..nn.1
  paramilitär_1_A = mkA "paramilitär" ; -- paramilitär..av.1
  parande_1_N = mkN "parande" ; -- parande..nn.1
  paranoia_1_N = mkN "paranoia" ; -- paranoia..nn.1
  paranoid_1_A = mkA "paranoid" ; -- paranoid..av.1
  paranoiker_1_N = mkN "paranoiker" "paranoikern" "paranoiker" "paranoikerna" ; -- paranoiker..nn.1
  paranormal_1_A = mkA "paranormal" ; -- paranormal..av.1
  parant_1_A = mkA "parant" "parant" ; -- parant..av.1
  paranöt_1_N = mkN "paranöt" "paranötter" ; -- paranöt..nn.1
  parapet_1_N = mkN "parapet" "parapeter" ; -- parapet..nn.1
  paraply_1_N = mkN "paraply" "paraplyn" "paraplyn" "paraplyna" ; -- paraply..nn.1
  paraplydrink_1_N = mkN "paraplydrink" ; -- paraplydrink..nn.1
  paraplyliknande_1_A = mkA "paraplyliknande" ; -- paraplyliknande..av.1
  paraplyorganisation_1_N = mkN "paraplyorganisation" ; -- paraplyorganisation..nn.1
  paraplyställ_1_N = mkN "paraplyställ" neutrum  ; -- paraplyställ..nn.1
  paraplytak_1_N = mkN "paraplytak" neutrum  ; -- paraplytak..nn.1
  paraplyvagn_1_N = mkN "paraplyvagn" ; -- paraplyvagn..nn.1
  parapsykologi_1_N = mkN "parapsykologi" ; -- parapsykologi..nn.1
  parasit_1_N = mkN "parasit" "parasiter" ; -- parasit..nn.1
  parasitera_1_V = mkV "parasiterar" ; -- parasitera..vb.1
  parasiterande_1_N = mkN "parasiterande" ; -- parasiterande..nn.1
  parasitering_1_N = mkN "parasitering" ; -- parasitering..nn.1
  parasitfluga_1_N = mkN "parasitfluga" ; -- parasitfluga..nn.1
  parasitinfektion_1_N = mkN "parasitinfektion" ; -- parasitinfektion..nn.1
  parasitisk_1_A = mkA "parasitisk" ; -- parasitisk..av.1
  parasitism_1_N = mkN "parasitism" "parasitismer" ; -- parasitism..nn.1
  parasitär_1_A = mkA "parasitär" ; -- parasitär..av.1
  paraskavedekatriafobi_1_N = mkN "paraskavedekatriafobi" ; -- paraskavedekatriafobi..nn.1
  paraskevidekatriafobi_1_N = mkN "paraskevidekatriafobi" ; -- paraskevidekatriafobi..nn.1
  parasoll_1_N = mkN "parasoll" neutrum  ; -- parasoll..nn.1
  parasömn_1_N = mkN "parasömn" ; -- parasömn..nn.1
  parat_1_A = mkA "parat" "parat" ; -- parat..av.1
  parataktisk_1_A = mkA "parataktisk" ; -- parataktisk..av.1
  paratax_1_N = mkN "paratax" ; -- paratax..nn.1
  paratyfus_1_N = mkN "paratyfus" ; -- paratyfus..nn.1
  paravan_1_N = mkN "paravan" "paravaner" ; -- paravan..nn.1
  parbladig_1_A = mkA "parbladig" ; -- parbladig..av.1
  parce_1_N = mkN "parce" "parcer" ; -- parce..nn.1
  parcell_1_N = mkN "parcell" "parceller" ; -- parcell..nn.1
  pardans_1_N = mkN "pardans" "pardanser" ; -- pardans..nn.1
  pardon_1_N = mkN "pardon" ; -- pardon..nn.1
  parenkym_1_N = mkN "parenkym" neutrum  ; -- parenkym..nn.1
  parentation_1_N = mkN "parentation" ; -- parentation..nn.1
  parentator_1_N = mkN "parentator" "parentatorer" ; -- parentator..nn.1
  parentera_1_V = mkV "parenterar" ; -- parentera..vb.1
  parenterande_1_N = mkN "parenterande" ; -- parenterande..nn.1
  parentering_1_N = mkN "parentering" ; -- parentering..nn.1
  parentes_1_N = mkN "parentes" "parenteser" ; -- parentes..nn.1
  parentestecken_1_N = mkN "parentestecken" "parentestecknet" "parentestecken" "parentestecknen" ; -- parentestecken..nn.1
  parentetisk_1_A = mkA "parentetisk" ; -- parentetisk..av.1
  parera_1_V = mkV "parerar" ; -- parera..vb.1
  parerande_1_N = mkN "parerande" ; -- parerande..nn.1
  parerbar_1_A = mkA "parerbar" ; -- parerbar..av.1
  parerbarhet_1_N = mkN "parerbarhet" ; -- parerbarhet..nn.1
  parering_1_N = mkN "parering" ; -- parering..nn.1
  parerplåt_1_N = mkN "parerplåt" ; -- parerplåt..nn.1
  parerstång_1_N = mkN "parerstång" "parerstänger" ; -- parerstång..nn.1
  pares_1_N = mkN "pares" "pareser" ; -- pares..nn.1
  parfait_1_N = mkN "parfait" "parfaiter" ; -- parfait..nn.1
  parflikig_1_A = mkA "parflikig" ; -- parflikig..av.1
  parfym_1_N = mkN "parfym" "parfymer" ; -- parfym..nn.1
  parfymaffär_1_N = mkN "parfymaffär" "parfymaffärer" ; -- parfymaffär..nn.1
  parfymdoft_1_N = mkN "parfymdoft" "parfymdofter" ; -- parfymdoft..nn.1
  parfymera_1_V = mkV "parfymerar" ; -- parfymera..vb.1
  parfymerande_1_N = mkN "parfymerande" ; -- parfymerande..nn.1
  parfymerbar_1_A = mkA "parfymerbar" ; -- parfymerbar..av.1
  parfymerbarhet_1_N = mkN "parfymerbarhet" ; -- parfymerbarhet..nn.1
  parfymeri_1_N = mkN "parfymeri" "parfymeriet" "parfymerier" "parfymerierna" ; -- parfymeri..nn.1
  parfymering_1_N = mkN "parfymering" ; -- parfymering..nn.1
  parfymflaska_1_N = mkN "parfymflaska" ; -- parfymflaska..nn.1
  parförhållande_1_N = mkN "parförhållande" ; -- parförhållande..nn.1
  parhus_1_N = mkN "parhus" neutrum  ; -- parhus..nn.1
  parhäst_1_N = mkN "parhäst" ; -- parhäst..nn.1
  paria_1_N = mkN "paria" ; -- paria..nn.1
  parian_1_N = mkN "parian" ; -- parian..nn.1
  parig_1_A = mkA "parig" ; -- parig..av.1
  parikurs_1_N = mkN "parikurs" "parikurser" ; -- parikurs..nn.1
  pariserhjul_1_N = mkN "pariserhjul" neutrum  ; -- pariserhjul..nn.1
  pariserliv_1_N = mkN "pariserliv" neutrum  ; -- pariserliv..nn.1
  parisersmörgås_1_N = mkN "parisersmörgås" ; -- parisersmörgås..nn.1
  parisfrisyr_1_N = mkN "parisfrisyr" "parisfrisyrer" ; -- parisfrisyr..nn.1
  parisisk_1_A = mkA "parisisk" ; -- parisisk..av.1
  parismode_1_N = mkN "parismode" ; -- parismode..nn.1
  paritet_1_N = mkN "paritet" "pariteter" ; -- paritet..nn.1
  park_1_N = mkN "park" "parker" ; -- park..nn.1
  parkas_1_N = mkN "parkas" ; -- parkas..nn.1
  parkbänk_1_N = mkN "parkbänk" ; -- parkbänk..nn.1
  parkera_1_V = mkV "parkerar" ; -- parkera..vb.1
  parkerande_1_N = mkN "parkerande" ; -- parkerande..nn.1
  parkerbar_1_A = mkA "parkerbar" ; -- parkerbar..av.1
  parkerbarhet_1_N = mkN "parkerbarhet" ; -- parkerbarhet..nn.1
  parkering_1_N = mkN "parkering" ; -- parkering..nn.1
  parkeringsautomat_1_N = mkN "parkeringsautomat" "parkeringsautomater" ; -- parkeringsautomat..nn.1
  parkeringsavgift_1_N = mkN "parkeringsavgift" "parkeringsavgifter" ; -- parkeringsavgift..nn.1
  parkeringsbot_1_N = mkN "parkeringsbot" "parkeringsböter" ; -- parkeringsbot..nn.1
  parkeringsbroms_1_N = mkN "parkeringsbroms" ; -- parkeringsbroms..nn.1
  parkeringsficka_1_N = mkN "parkeringsficka" ; -- parkeringsficka..nn.1
  parkeringshus_1_N = mkN "parkeringshus" neutrum  ; -- parkeringshus..nn.1
  parkeringslampa_1_N = mkN "parkeringslampa" ; -- parkeringslampa..nn.1
  parkeringsljus_1_N = mkN "parkeringsljus" neutrum  ; -- parkeringsljus..nn.1
  parkeringsmätare_1_N = mkN "parkeringsmätare" utrum  ; -- parkeringsmätare..nn.1
  parkeringsplats_1_N = mkN "parkeringsplats" "parkeringsplatser" ; -- parkeringsplats..nn.1
  parkeringsvakt_1_N = mkN "parkeringsvakt" "parkeringsvakter" ; -- parkeringsvakt..nn.1
  parkett_1_N = mkN "parkett" "parketter" ; -- parkett..nn.1
  parkettera_1_V = mkV "parketterar" ; -- parkettera..vb.1
  parketterande_1_N = mkN "parketterande" ; -- parketterande..nn.1
  parketterbar_1_A = mkA "parketterbar" ; -- parketterbar..av.1
  parketterbarhet_1_N = mkN "parketterbarhet" ; -- parketterbarhet..nn.1
  parkettering_1_N = mkN "parkettering" ; -- parkettering..nn.1
  parkettgolv_1_N = mkN "parkettgolv" neutrum  ; -- parkettgolv..nn.1
  parkettläggare_1_N = mkN "parkettläggare" utrum  ; -- parkettläggare..nn.1
  parkettstav_1_N = mkN "parkettstav" ; -- parkettstav..nn.1
  parkgång_1_N = mkN "parkgång" ; -- parkgång..nn.1
  parklek_1_N = mkN "parklek" ; -- parklek..nn.1
  parkliknande_1_A = mkA "parkliknande" ; -- parkliknande..av.1
  parkpromenad_1_N = mkN "parkpromenad" "parkpromenader" ; -- parkpromenad..nn.1
  parkskötare_1_N = mkN "parkskötare" utrum  ; -- parkskötare..nn.1
  parksnutt_1_N = mkN "parksnutt" ; -- parksnutt..nn.1
  parkum_1_N = mkN "parkum" ; -- parkum..nn.1
  parlament_1_N = mkN "parlament" neutrum  ; -- parlament..nn.1
  parlamentariker_1_N = mkN "parlamentariker" "parlamentarikern" "parlamentariker" "parlamentarikerna" ; -- parlamentariker..nn.1
  parlamentarisk_1_A = mkA "parlamentarisk" ; -- parlamentarisk..av.1
  parlamentarism_1_N = mkN "parlamentarism" "parlamentarismer" ; -- parlamentarism..nn.1
  parlamentaristisk_1_A = mkA "parlamentaristisk" ; -- parlamentaristisk..av.1
  parlamentera_1_V = mkV "parlamenterar" ; -- parlamentera..vb.1
  parlamenterande_1_N = mkN "parlamenterande" ; -- parlamenterande..nn.1
  parlamentering_1_N = mkN "parlamentering" ; -- parlamentering..nn.1
  parlamentsledamot_1_N = mkN "parlamentsledamot" "parlamentsledamöter" ; -- parlamentsledamot..nn.1
  parlamentsreform_1_N = mkN "parlamentsreform" "parlamentsreformer" ; -- parlamentsreform..nn.1
  parlamentsval_1_N = mkN "parlamentsval" neutrum  ; -- parlamentsval..nn.1
  parlamentär_1_N = mkN "parlamentär" "parlamentärer" ; -- parlamentär..nn.1
  parlamentärflagg_1_N = mkN "parlamentärflagg" ; -- parlamentärflagg..nn.1
  parlamentärflagga_1_N = mkN "parlamentärflagga" ; -- parlamentärflagga..nn.1
  parlando_1_N = mkN "parlando" "parlandot" "parlandon" "parlandona" ; -- parlando..nn.1
  parlera_1_V = mkV "parlerar" ; -- parlera..vb.1
  parlerande_1_N = mkN "parlerande" ; -- parlerande..nn.1
  parlering_1_N = mkN "parlering" ; -- parlering..nn.1
  parlör_1_N = mkN "parlör" "parlörer" ; -- parlör..nn.1
  parmesanost_1_N = mkN "parmesanost" ; -- parmesanost..nn.1
  parnass_1_N = mkN "parnass" "parnasser" ; -- parnass..nn.1
  parning_1_N = mkN "parning" ; -- parning..nn.1
  parningsdrift_1_N = mkN "parningsdrift" "parningsdrifter" ; -- parningsdrift..nn.1
  parningsdräkt_1_N = mkN "parningsdräkt" "parningsdräkter" ; -- parningsdräkt..nn.1
  parningslek_1_N = mkN "parningslek" ; -- parningslek..nn.1
  parningsmetod_1_N = mkN "parningsmetod" "parningsmetoder" ; -- parningsmetod..nn.1
  parningsorgan_1_N = mkN "parningsorgan" neutrum  ; -- parningsorgan..nn.1
  parningsrit_1_N = mkN "parningsrit" "parningsriter" ; -- parningsrit..nn.1
  parningstid_1_N = mkN "parningstid" "parningstider" ; -- parningstid..nn.1
  parodi_1_N = mkN "parodi" "parodier" ; -- parodi..nn.1
  parodiartad_1_A = mkA "parodiartad" ; -- parodiartad..av.1
  parodiera_1_V = mkV "parodierar" ; -- parodiera..vb.1
  parodierande_1_N = mkN "parodierande" ; -- parodierande..nn.1
  parodierbar_1_A = mkA "parodierbar" ; -- parodierbar..av.1
  parodierbarhet_1_N = mkN "parodierbarhet" ; -- parodierbarhet..nn.1
  parodiering_1_N = mkN "parodiering" ; -- parodiering..nn.1
  parodiker_1_N = mkN "parodiker" "parodikern" "parodiker" "parodikerna" ; -- parodiker..nn.1
  parodisk_1_A = mkA "parodisk" ; -- parodisk..av.1
  parodontit_1_N = mkN "parodontit" "parodontiter" ; -- parodontit..nn.1
  paroll_1_N = mkN "paroll" "paroller" ; -- paroll..nn.1
  paronym_1_N = mkN "paronym" "paronymer" ; -- paronym..nn.1
  paronymi_1_N = mkN "paronymi" "paronymier" ; -- paronymi..nn.1
  paroxysm_1_N = mkN "paroxysm" "paroxysmer" ; -- paroxysm..nn.1
  parrimmad_1_A = mkA "parrimmad" ; -- parrimmad..av.1
  parsa_1_V = mkV "parsar" ; -- parsa..vb.1
  parser_1_N = mkN "parser" ; -- parser..nn.1
  parsing_1_N = mkN "parsing" ; -- parsing..nn.1
  parsning_1_N = mkN "parsning" ; -- parsning..nn.1
  parspel_1_N = mkN "parspel" "parspelet" "parspel" "parspelen" ; -- parspel..nn.1
  parstuga_1_N = mkN "parstuga" ; -- parstuga..nn.1
  part_1_N = mkN "part" "parter" ; -- part..nn.1
  parta_1_V = mkV "partar" ; -- parta..vb.1
  partaj_1_N = mkN "partaj" neutrum  ; -- partaj..nn.1
  partaja_1_V = mkV "partajar" ; -- partaja..vb.1
  partajande_1_N = mkN "partajande" ; -- partajande..nn.1
  partande_1_N = mkN "partande" ; -- partande..nn.1
  partenogenes_1_N = mkN "partenogenes" ; -- partenogenes..nn.1
  parterr_1_N = mkN "parterr" "parterrer" ; -- parterr..nn.1
  parti_1_N = mkN "parti" "partiet" "partier" "partierna" ; -- parti..nn.1
  partialton_1_N = mkN "partialton" "partialtoner" ; -- partialton..nn.1
  partialtryck_1_N = mkN "partialtryck" neutrum  ; -- partialtryck..nn.1
  partianda_1_N = mkN "partianda" ; -- partianda..nn.1
  partiapparat_1_N = mkN "partiapparat" "partiapparater" ; -- partiapparat..nn.1
  partibildning_1_N = mkN "partibildning" ; -- partibildning..nn.1
  partiblock_1_N = mkN "partiblock" neutrum  ; -- partiblock..nn.1
  partichef_1_N = mkN "partichef" "partichefer" ; -- partichef..nn.1
  particip_1_N = mkN "particip" neutrum  ; -- particip..nn.1
  participiell_1_A = mkA "participiell" ; -- participiell..av.1
  partidisciplin_1_N = mkN "partidisciplin" "partidiscipliner" ; -- partidisciplin..nn.1
  partidistrikt_1_N = mkN "partidistrikt" neutrum  ; -- partidistrikt..nn.1
  partiell_1_A = mkA "partiell" ; -- partiell..av.1
  partifärg_1_N = mkN "partifärg" "partifärger" ; -- partifärg..nn.1
  partifålla_1_N = mkN "partifålla" ; -- partifålla..nn.1
  partiföreträdare_1_N = mkN "partiföreträdare" utrum  ; -- partiföreträdare..nn.1
  partigrupp_1_N = mkN "partigrupp" "partigrupper" ; -- partigrupp..nn.1
  partigruppering_1_N = mkN "partigruppering" ; -- partigruppering..nn.1
  partigängare_1_N = mkN "partigängare" utrum  ; -- partigängare..nn.1
  partigängarjournalistik_1_N = mkN "partigängarjournalistik" ; -- partigängarjournalistik..nn.1
  partihandel_1_N = mkN "partihandel" ; -- partihandel..nn.1
  partikamrat_1_N = mkN "partikamrat" "partikamrater" ; -- partikamrat..nn.1
  partikel_1_N = mkN "partikel" ; -- partikel..nn.1
  partikelaccelerator_1_N = mkN "partikelaccelerator" "partikelacceleratorer" ; -- partikelaccelerator..nn.1
  partikelbana_1_N = mkN "partikelbana" ; -- partikelbana..nn.1
  partikelegenskap_1_N = mkN "partikelegenskap" "partikelegenskaper" ; -- partikelegenskap..nn.1
  partikelfysiker_1_N = mkN "partikelfysiker" "partikelfysikern" "partikelfysiker" "partikelfysikerna" ; -- partikelfysiker..nn.1
  partikelkolliderare_1_N = mkN "partikelkolliderare" utrum  ; -- partikelkolliderare..nn.1
  partikelkross_1_N = mkN "partikelkross" ; -- partikelkross..nn.1
  partikellaboratorium_1_N = mkN "partikellaboratorium" "partikellaboratoriet" "partikellaboratorier" "partikellaboratorierna" ; -- partikellaboratorium..nn.1
  partikellock_1_N = mkN "partikellock" neutrum  ; -- partikellock..nn.1
  partikelreaktion_1_N = mkN "partikelreaktion" ; -- partikelreaktion..nn.1
  partikelregn_1_N = mkN "partikelregn" neutrum  ; -- partikelregn..nn.1
  partikelstråle_1_N = mkN "partikelstråle" utrum  ; -- partikelstråle..nn.1
  partikelstrålning_1_N = mkN "partikelstrålning" ; -- partikelstrålning..nn.1
  partikelström_1_N = mkN "partikelström" "partikelströmmen" "partikelströmmar" "partikelströmmarna" ; -- partikelström..nn.1
  partikollega_1_N = mkN "partikollega" ; -- partikollega..nn.1
  partikongress_1_N = mkN "partikongress" "partikongresser" ; -- partikongress..nn.1
  partikularism_1_N = mkN "partikularism" "partikularismer" ; -- partikularism..nn.1
  partikularist_1_N = mkN "partikularist" "partikularister" ; -- partikularist..nn.1
  partikularistisk_1_A = mkA "partikularistisk" ; -- partikularistisk..av.1
  partikuljär_1_A = mkA "partikuljär" ; -- partikuljär..av.1
  partikulär_1_A = mkA "partikulär" ; -- partikulär..av.1
  partiköp_1_N = mkN "partiköp" neutrum  ; -- partiköp..nn.1
  partiledarbyte_1_N = mkN "partiledarbyte" ; -- partiledarbyte..nn.1
  partiledardebatt_1_N = mkN "partiledardebatt" "partiledardebatter" ; -- partiledardebatt..nn.1
  partiledare_1_N = mkN "partiledare" utrum  ; -- partiledare..nn.1
  partiledarkandidat_1_N = mkN "partiledarkandidat" "partiledarkandidater" ; -- partiledarkandidat..nn.1
  partiledarpost_1_N = mkN "partiledarpost" "partiledarposter" ; -- partiledarpost..nn.1
  partiledarutfrågning_1_N = mkN "partiledarutfrågning" ; -- partiledarutfrågning..nn.1
  partiledning_1_N = mkN "partiledning" ; -- partiledning..nn.1
  partilös_1_A = mkA "partilös" ; -- partilös..av.1
  partilöshet_1_N = mkN "partilöshet" ; -- partilöshet..nn.1
  partiman_1_N = mkN "partiman" "partimannen" "partimän" "partimännen" ; -- partiman..nn.1
  partimanöver_1_N = mkN "partimanöver" ; -- partimanöver..nn.1
  partimedlem_1_N = mkN "partimedlem" "partimedlemmen" "partimedlemmar" "partimedlemmarna" ; -- partimedlem..nn.1
  partimotion_1_N = mkN "partimotion" ; -- partimotion..nn.1
  partimässig_1_A = mkA "partimässig" ; -- partimässig..av.1
  partiobunden_1_A = mkA "partiobunden" ; -- partiobunden..av.1
  partiordförande_1_N = mkN "partiordförande" "partiordföranden" "partiordföranden" "partiordförandena" ; -- partiordförande..nn.1
  partiorgan_1_N = mkN "partiorgan" neutrum  ; -- partiorgan..nn.1
  partipiska_1_N = mkN "partipiska" ; -- partipiska..nn.1
  partipolitisk_1_A = mkA "partipolitisk" ; -- partipolitisk..av.1
  partipris_1_N = mkN "partipris" neutrum  ; -- partipris..nn.1
  partiprogram_1_N = mkN "partiprogram" "partiprogrammet" "partiprogram" "partiprogrammen" ; -- partiprogram..nn.1
  partisan_1_N = mkN "partisan" "partisaner" ; -- partisan..nn.1
  partisekreterare_1_N = mkN "partisekreterare" utrum  ; -- partisekreterare..nn.1
  partisk_1_A = mkA "partisk" ; -- partisk..av.1
  partiskhet_1_N = mkN "partiskhet" "partiskheter" ; -- partiskhet..nn.1
  partiskiljande_1_A = mkA "partiskiljande" ; -- partiskiljande..av.1
  partiskrift_1_N = mkN "partiskrift" "partiskrifter" ; -- partiskrift..nn.1
  partisplittring_1_N = mkN "partisplittring" ; -- partisplittring..nn.1
  partisprängning_1_N = mkN "partisprängning" ; -- partisprängning..nn.1
  partispärr_1_N = mkN "partispärr" ; -- partispärr..nn.1
  partistrateg_1_N = mkN "partistrateg" "partistrateger" ; -- partistrateg..nn.1
  partistrategi_1_N = mkN "partistrategi" "partistrategier" ; -- partistrategi..nn.1
  partistrid_1_N = mkN "partistrid" "partistrider" ; -- partistrid..nn.1
  partistyrelse_1_N = mkN "partistyrelse" "partistyrelser" ; -- partistyrelse..nn.1
  partistöd_1_N = mkN "partistöd" neutrum  ; -- partistöd..nn.1
  partisympati_1_N = mkN "partisympati" "partisympatier" ; -- partisympati..nn.1
  partisympatimätning_1_N = mkN "partisympatimätning" ; -- partisympatimätning..nn.1
  partisöndring_1_N = mkN "partisöndring" ; -- partisöndring..nn.1
  partitaktik_1_N = mkN "partitaktik" "partitaktiker" ; -- partitaktik..nn.1
  partitaktisk_1_A = mkA "partitaktisk" ; -- partitaktisk..av.1
  partitillhörighet_1_N = mkN "partitillhörighet" ; -- partitillhörighet..nn.1
  partitiv_1_A = mkA "partitiv" ; -- partitiv..av.1
  partitiv_1_N = mkN "partitiv" "partitiver" ; -- partitiv..nn.1
  partitivattribut_1_N = mkN "partitivattribut" neutrum  ; -- partitivattribut..nn.1
  partitopp_1_N = mkN "partitopp" ; -- partitopp..nn.1
  partitrohet_1_N = mkN "partitrohet" "partitroheter" ; -- partitrohet..nn.1
  partitur_1_N = mkN "partitur" neutrum  ; -- partitur..nn.1
  partivän_1_N = mkN "partivän" "partivännen" "partivänner" "partivännerna" ; -- partivän..nn.1
  partiväsen_1_N = mkN "partiväsen" "partiväsendet" "partiväsen" "partiväsena" ; -- partiväsen..nn.1
  partiväsende_1_N = mkN "partiväsende" ; -- partiväsende..nn.1
  partner_1_N = mkN "partner" "partnern" "partners" "partnersen" ; -- partner..nn.1
  partnerbytare_1_N = mkN "partnerbytare" utrum  ; -- partnerbytare..nn.1
  partnerbyte_1_N = mkN "partnerbyte" ; -- partnerbyte..nn.1
  partnerskap_1_N = mkN "partnerskap" neutrum  ; -- partnerskap..nn.1
  partnerskapsland_1_N = mkN "partnerskapsland" "partnerskapslandet" "partnerskapsländer" "partnerskapsländerna" ; -- partnerskapsland..nn.1
  partonym_1_N = mkN "partonym" "partonymer" ; -- partonym..nn.1
  partonymi_1_N = mkN "partonymi" "partonymier" ; -- partonymi..nn.1
  partsbehörighet_1_N = mkN "partsbehörighet" "partsbehörigheter" ; -- partsbehörighet..nn.1
  partsinlaga_1_N = mkN "partsinlaga" ; -- partsinlaga..nn.1
  partsorgan_1_N = mkN "partsorgan" neutrum  ; -- partsorgan..nn.1
  party_1_N = mkN "party" "partyt" "partyn" "partyna" ; -- party..nn.1
  partyglad_1_A = mkA "partyglad" "partyglatt" ; -- partyglad..av.1
  partyklänning_1_N = mkN "partyklänning" ; -- partyklänning..nn.1
  partylejon_1_N = mkN "partylejon" neutrum  ; -- partylejon..nn.1
  partyprisse_1_N = mkN "partyprisse" utrum  ; -- partyprisse..nn.1
  partysugen_1_A = mkA "partysugen" ; -- partysugen..av.1
  partytält_1_N = mkN "partytält" neutrum  ; -- partytält..nn.1
  partåig_1_A = mkA "partåig" ; -- partåig..av.1
  parvel_1_N = mkN "parvel" ; -- parvel..nn.1
  parveny_1_N = mkN "parveny" "parvenyer" ; -- parveny..nn.1
  parvis_1_Adv = mkAdv "parvis" ; -- parvis..ab.1
  paråkning_1_N = mkN "paråkning" ; -- paråkning..nn.1
  pascal_1_N = mkN "pascal" "pascalen" "pascal" "pascalen" ; -- pascal..nn.1
  pascha_1_N = mkN "pascha" ; -- pascha..nn.1
  paskill_1_N = mkN "paskill" "paskiller" ; -- paskill..nn.1
  pasma_1_N = mkN "pasma" ; -- pasma..nn.1
  pass_1_N = mkN "pass" neutrum  ; -- pass..nn.1
  passa_1_V = mkV "passar" ; -- passa..vb.1
  passa_2_V = mkV "passar" ; -- passa..vb.2
  passabel_1_A = mkA "passabel" ; -- passabel..av.1
  passad_1_N = mkN "passad" "passader" ; -- passad..nn.1
  passadvind_1_N = mkN "passadvind" ; -- passadvind..nn.1
  passage_1_N = mkN "passage" "passager" ; -- passage..nn.1
  passagerarbåt_1_N = mkN "passagerarbåt" ; -- passagerarbåt..nn.1
  passagerare_1_N = mkN "passagerare" utrum  ; -- passagerare..nn.1
  passagerarflyg_1_N = mkN "passagerarflyg" neutrum  ; -- passagerarflyg..nn.1
  passagerarflygplan_1_N = mkN "passagerarflygplan" neutrum  ; -- passagerarflygplan..nn.1
  passagerarfordon_1_N = mkN "passagerarfordon" neutrum  ; -- passagerarfordon..nn.1
  passagerarplats_1_N = mkN "passagerarplats" "passagerarplatser" ; -- passagerarplats..nn.1
  passagerarsalong_1_N = mkN "passagerarsalong" "passagerarsalonger" ; -- passagerarsalong..nn.1
  passagerarsiffra_1_N = mkN "passagerarsiffra" ; -- passagerarsiffra..nn.1
  passagerarstol_1_N = mkN "passagerarstol" ; -- passagerarstol..nn.1
  passagerarsäte_1_N = mkN "passagerarsäte" ; -- passagerarsäte..nn.1
  passagerartom_1_A = mkA "passagerartom" "passagerartomt" "passagerartomma" "passagerartomma" "passagerartommare" "passagerartommast" "passagerartommaste" ; -- passagerartom..av.1
  passande_1_A = mkA "passande" ; -- passande..av.1
  passande_1_N = mkN "passande" ; -- passande..nn.1
  passare_1_N = mkN "passare" utrum  ; -- passare..nn.1
  passbit_1_N = mkN "passbit" ; -- passbit..nn.1
  passbåt_1_N = mkN "passbåt" ; -- passbåt..nn.1
  passepartout_1_N = mkN "passepartout" "passepartouter" ; -- passepartout..nn.1
  passera_1_V = mkV "passerar" ; -- passera..vb.1
  passerad_1_A = mkA "passerad" ; -- passerad..av.1
  passerande_1_N = mkN "passerande" ; -- passerande..nn.1
  passerbar_1_A = mkA "passerbar" ; -- passerbar..av.1
  passerbarhet_1_N = mkN "passerbarhet" ; -- passerbarhet..nn.1
  passering_1_N = mkN "passering" ; -- passering..nn.1
  passerkort_1_N = mkN "passerkort" neutrum  ; -- passerkort..nn.1
  passersedel_1_N = mkN "passersedel" ; -- passersedel..nn.1
  passform_1_N = mkN "passform" ; -- passform..nn.1
  passfoto_1_N = mkN "passfoto" "passfotot" "passfoton" "passfotona" ; -- passfoto..nn.1
  passfrihet_1_N = mkN "passfrihet" "passfriheter" ; -- passfrihet..nn.1
  passgång_1_N = mkN "passgång" ; -- passgång..nn.1
  passgångare_1_N = mkN "passgångare" utrum  ; -- passgångare..nn.1
  passion_1_N = mkN "passion" ; -- passion..nn.1
  passionerad_1_A = mkA "passionerad" ; -- passionerad..av.1
  passionsblomma_1_N = mkN "passionsblomma" ; -- passionsblomma..nn.1
  passionsepos_1_N = mkN "passionsepos" neutrum  ; -- passionsepos..nn.1
  passionsfri_1_A = mkA "passionsfri" "passionsfritt" ; -- passionsfri..av.1
  passionsfrukt_1_N = mkN "passionsfrukt" "passionsfrukter" ; -- passionsfrukt..nn.1
  passionshistoria_1_N = mkN "passionshistoria" "passionshistorian" "passionshistorier" "passionshistorierna" ; -- passionshistoria..nn.1
  passionssamlag_1_N = mkN "passionssamlag" neutrum  ; -- passionssamlag..nn.1
  passionsspel_1_N = mkN "passionsspel" "passionsspelet" "passionsspel" "passionsspelen" ; -- passionsspel..nn.1
  passionsvecka_1_N = mkN "passionsvecka" ; -- passionsvecka..nn.1
  passiv_1_A = mkA "passiv" ; -- passiv..av.1
  passiva_1_N = mkN "passiva" "passivan" "passiva" "passivana" ; -- passiva..nn.1
  passivera_1_V = mkV "passiverar" ; -- passivera..vb.1
  passiverande_1_N = mkN "passiverande" ; -- passiverande..nn.1
  passiverbar_1_A = mkA "passiverbar" ; -- passiverbar..av.1
  passiverbarhet_1_N = mkN "passiverbarhet" ; -- passiverbarhet..nn.1
  passivering_1_N = mkN "passivering" ; -- passivering..nn.1
  passivform_1_N = mkN "passivform" "passivformer" ; -- passivform..nn.1
  passivisera_1_V = mkV "passiviserar" ; -- passivisera..vb.1
  passiviserande_1_N = mkN "passiviserande" ; -- passiviserande..nn.1
  passiviserbar_1_A = mkA "passiviserbar" ; -- passiviserbar..av.1
  passiviserbarhet_1_N = mkN "passiviserbarhet" ; -- passiviserbarhet..nn.1
  passivisering_1_N = mkN "passivisering" ; -- passivisering..nn.1
  passivitet_1_N = mkN "passivitet" "passiviteter" ; -- passivitet..nn.1
  passivum_1_N = mkN "passivum" "passivum" "passiver" "passiverna" ; -- passivum..nn.1
  passkontroll_1_N = mkN "passkontroll" "passkontroller" ; -- passkontroll..nn.1
  passkontrollant_1_N = mkN "passkontrollant" "passkontrollanter" ; -- passkontrollant..nn.1
  passlig_1_A = mkA "passlig" ; -- passlig..av.1
  passlighet_1_N = mkN "passlighet" ; -- passlighet..nn.1
  passning_1_N = mkN "passning" ; -- passning..nn.1
  passopp_1_N = mkN "passopp" "passopper" ; -- passopp..nn.1
  passpoal_1_N = mkN "passpoal" "passpoaler" ; -- passpoal..nn.1
  passtvång_1_N = mkN "passtvång" neutrum  ; -- passtvång..nn.1
  passus_1_N = mkN "passus" ; -- passus..nn.1
  passvisering_1_N = mkN "passvisering" ; -- passvisering..nn.1
  passé_1_A = mkA "passé" ; -- passé..av.1
  pasta_1_N = mkN "pasta" ; -- pasta..nn.1
  pasta_2_N = mkN "pasta" ; -- pasta..nn.2
  pastagratäng_1_N = mkN "pastagratäng" "pastagratänger" ; -- pastagratäng..nn.1
  pastarätt_1_N = mkN "pastarätt" "pastarätter" ; -- pastarätt..nn.1
  pastasallad_1_N = mkN "pastasallad" "pastasallader" ; -- pastasallad..nn.1
  pastej_1_N = mkN "pastej" "pastejer" ; -- pastej..nn.1
  pastell_1_N = mkN "pastell" "pasteller" ; -- pastell..nn.1
  pastellfärg_1_N = mkN "pastellfärg" "pastellfärger" ; -- pastellfärg..nn.1
  pastellfärgad_1_A = mkA "pastellfärgad" ; -- pastellfärgad..av.1
  pastellmålning_1_N = mkN "pastellmålning" ; -- pastellmålning..nn.1
  pastill_1_N = mkN "pastill" "pastiller" ; -- pastill..nn.1
  pastis_1_N = mkN "pastis" ; -- pastis..nn.1
  pastisch_1_N = mkN "pastisch" "pastischer" ; -- pastisch..nn.1
  pastischkaraktär_1_N = mkN "pastischkaraktär" ; -- pastischkaraktär..nn.1
  pastor_1_N = mkN "pastor" "pastorer" ; -- pastor..nn.1
  pastoral_1_A = mkA "pastoral" ; -- pastoral..av.1
  pastoral_1_N = mkN "pastoral" "pastoraler" ; -- pastoral..nn.1
  pastorat_1_N = mkN "pastorat" neutrum  ; -- pastorat..nn.1
  pastoratsadjunkt_1_N = mkN "pastoratsadjunkt" "pastoratsadjunkter" ; -- pastoratsadjunkt..nn.1
  pastorsadjunkt_1_N = mkN "pastorsadjunkt" "pastorsadjunkter" ; -- pastorsadjunkt..nn.1
  pastorsexpedition_1_N = mkN "pastorsexpedition" ; -- pastorsexpedition..nn.1
  pastorsämbete_1_N = mkN "pastorsämbete" ; -- pastorsämbete..nn.1
  pastos_1_A = mkA "pastos" ; -- pastos..av.1
  pastramiskinka_1_N = mkN "pastramiskinka" ; -- pastramiskinka..nn.1
  pastörisera_1_V = mkV "pastöriserar" ; -- pastörisera..vb.1
  pastöriserande_1_N = mkN "pastöriserande" ; -- pastöriserande..nn.1
  pastöriserbar_1_A = mkA "pastöriserbar" ; -- pastöriserbar..av.1
  pastöriserbarhet_1_N = mkN "pastöriserbarhet" ; -- pastöriserbarhet..nn.1
  pastörisering_1_N = mkN "pastörisering" ; -- pastörisering..nn.1
  pastös_1_A = mkA "pastös" ; -- pastös..av.1
  pata_1_N = mkN "pata" ; -- pata..nn.1
  patella_1_N = mkN "patella" ; -- patella..nn.1
  patellarreflex_1_N = mkN "patellarreflex" ; -- patellarreflex..nn.1
  paten_1_N = mkN "paten" "patener" ; -- paten..nn.1
  patent_1_N = mkN "patent" neutrum  ; -- patent..nn.1
  patentadvokat_1_N = mkN "patentadvokat" "patentadvokater" ; -- patentadvokat..nn.1
  patentera_1_V = mkV "patenterar" ; -- patentera..vb.1
  patenterad_1_A = mkA "patenterad" ; -- patenterad..av.1
  patenterande_1_N = mkN "patenterande" ; -- patenterande..nn.1
  patenterbar_1_A = mkA "patenterbar" ; -- patenterbar..av.1
  patenterbarhet_1_N = mkN "patenterbarhet" ; -- patenterbarhet..nn.1
  patentering_1_N = mkN "patentering" ; -- patentering..nn.1
  patentfärg_1_N = mkN "patentfärg" ; -- patentfärg..nn.1
  patentintrång_1_N = mkN "patentintrång" neutrum  ; -- patentintrång..nn.1
  patentlås_1_N = mkN "patentlås" neutrum  ; -- patentlås..nn.1
  patentmedicin_1_N = mkN "patentmedicin" "patentmediciner" ; -- patentmedicin..nn.1
  patentmål_1_N = mkN "patentmål" neutrum  ; -- patentmål..nn.1
  patentsmörgås_1_N = mkN "patentsmörgås" ; -- patentsmörgås..nn.1
  patentstickad_1_A = mkA "patentstickad" ; -- patentstickad..av.1
  patentsökare_1_N = mkN "patentsökare" utrum  ; -- patentsökare..nn.1
  patentverk_1_N = mkN "patentverk" neutrum  ; -- patentverk..nn.1
  pater_1_N = mkN "pater" ; -- pater..nn.1
  paternoster_1_N = mkN "paternoster" neutrum  ; -- paternoster..nn.1
  paternosterhiss_1_N = mkN "paternosterhiss" ; -- paternosterhiss..nn.1
  paternosterverk_1_N = mkN "paternosterverk" neutrum  ; -- paternosterverk..nn.1
  patetik_1_N = mkN "patetik" ; -- patetik..nn.1
  patetisk_1_A = mkA "patetisk" ; -- patetisk..av.1
  patiens_1_N = mkN "patiens" "patienser" ; -- patiens..nn.1
  patient_1_N = mkN "patient" "patienter" ; -- patient..nn.1
  patientbemötande_1_N = mkN "patientbemötande" ; -- patientbemötande..nn.1
  patientbesök_1_N = mkN "patientbesök" neutrum  ; -- patientbesök..nn.1
  patientjournal_1_N = mkN "patientjournal" "patientjournaler" ; -- patientjournal..nn.1
  patientplats_1_N = mkN "patientplats" "patientplatser" ; -- patientplats..nn.1
  patientplåt_1_N = mkN "patientplåt" ; -- patientplåt..nn.1
  patientsekretess_1_N = mkN "patientsekretess" ; -- patientsekretess..nn.1
  patientsäkerhet_1_N = mkN "patientsäkerhet" ; -- patientsäkerhet..nn.1
  patientsäkerhetslag_1_N = mkN "patientsäkerhetslag" ; -- patientsäkerhetslag..nn.1
  patina_1_N = mkN "patina" ; -- patina..nn.1
  patinera_1_V = mkV "patinerar" ; -- patinera..vb.1
  patinerande_1_N = mkN "patinerande" ; -- patinerande..nn.1
  patinerbar_1_A = mkA "patinerbar" ; -- patinerbar..av.1
  patinerbarhet_1_N = mkN "patinerbarhet" ; -- patinerbarhet..nn.1
  patinering_1_N = mkN "patinering" ; -- patinering..nn.1
  patio_1_N = mkN "patio" "patior" ; -- patio..nn.1
  patofysiologi_1_N = mkN "patofysiologi" ; -- patofysiologi..nn.1
  patogen_1_A = mkA "patogen" "patogent" ; -- patogen..av.1
  patogen_1_N = mkN "patogen" "patogener" ; -- patogen..nn.1
  patolog_1_N = mkN "patolog" "patologer" ; -- patolog..nn.1
  patologi_1_N = mkN "patologi" "patologier" ; -- patologi..nn.1
  patologisk_1_A = mkA "patologisk" ; -- patologisk..av.1
  patos_1_N = mkN "patos" neutrum  ; -- patos..nn.1
  patrask_1_N = mkN "patrask" neutrum  ; -- patrask..nn.1
  patriark_1_N = mkN "patriark" "patriarker" ; -- patriark..nn.1
  patriarkal_1_A = mkA "patriarkal" ; -- patriarkal..av.1
  patriarkalisk_1_A = mkA "patriarkalisk" ; -- patriarkalisk..av.1
  patriarkat_1_N = mkN "patriarkat" neutrum  ; -- patriarkat..nn.1
  patriarkskägg_1_N = mkN "patriarkskägg" neutrum  ; -- patriarkskägg..nn.1
  patricier_1_N = mkN "patricier" "patriciern" "patricier" "patricierna" ; -- patricier..nn.1
  patricierhus_1_N = mkN "patricierhus" neutrum  ; -- patricierhus..nn.1
  patriciersläkt_1_N = mkN "patriciersläkt" "patriciersläkter" ; -- patriciersläkt..nn.1
  patricisk_1_A = mkA "patricisk" ; -- patricisk..av.1
  patriot_1_N = mkN "patriot" "patrioter" ; -- patriot..nn.1
  patriotisk_1_A = mkA "patriotisk" ; -- patriotisk..av.1
  patriotism_1_N = mkN "patriotism" "patriotismer" ; -- patriotism..nn.1
  patriotistisk_1_A = mkA "patriotistisk" ; -- patriotistisk..av.1
  patris_1_N = mkN "patris" "patriser" ; -- patris..nn.1
  patristik_1_N = mkN "patristik" ; -- patristik..nn.1
  patron_1_N = mkN "patron" "patron" "patroner" "patronerna" ; -- patron..nn.1
  patron_2_N = mkN "patron" "patroner" ; -- patron..nn.2
  patronatsrätt_1_N = mkN "patronatsrätt" ; -- patronatsrätt..nn.1
  patronbälte_1_N = mkN "patronbälte" ; -- patronbälte..nn.1
  patronhylsa_1_N = mkN "patronhylsa" ; -- patronhylsa..nn.1
  patronhållare_1_N = mkN "patronhållare" utrum  ; -- patronhållare..nn.1
  patronkök_1_N = mkN "patronkök" neutrum  ; -- patronkök..nn.1
  patronspruta_1_N = mkN "patronspruta" ; -- patronspruta..nn.1
  patronväska_1_N = mkN "patronväska" ; -- patronväska..nn.1
  patronymikon_1_N = mkN "patronymikon" neutrum  ; -- patronymikon..nn.1
  patrull_1_N = mkN "patrull" "patruller" ; -- patrull..nn.1
  patrullbil_1_N = mkN "patrullbil" ; -- patrullbil..nn.1
  patrullbåt_1_N = mkN "patrullbåt" ; -- patrullbåt..nn.1
  patrullera_1_V = mkV "patrullerar" ; -- patrullera..vb.1
  patrullerande_1_N = mkN "patrullerande" ; -- patrullerande..nn.1
  patrullerbar_1_A = mkA "patrullerbar" ; -- patrullerbar..av.1
  patrullerbarhet_1_N = mkN "patrullerbarhet" ; -- patrullerbarhet..nn.1
  patrullering_1_N = mkN "patrullering" ; -- patrullering..nn.1
  patt_1_N = mkN "patt" "patter" ; -- patt..nn.1
  patt_2_N = mkN "patt" ; -- patt..nn.2
  patte_1_N = mkN "patte" utrum  ; -- patte..nn.1
  pattställning_1_N = mkN "pattställning" ; -- pattställning..nn.1
  paté_1_N = mkN "paté" "patéer" ; -- paté..nn.1
  paulun_1_N = mkN "paulun" "pauluner" ; -- paulun..nn.1
  pauperisera_1_V = mkV "pauperiserar" ; -- pauperisera..vb.1
  pauperiserande_1_N = mkN "pauperiserande" ; -- pauperiserande..nn.1
  pauperiserbar_1_A = mkA "pauperiserbar" ; -- pauperiserbar..av.1
  pauperiserbarhet_1_N = mkN "pauperiserbarhet" ; -- pauperiserbarhet..nn.1
  pauperisering_1_N = mkN "pauperisering" ; -- pauperisering..nn.1
  pauperism_1_N = mkN "pauperism" "pauperismer" ; -- pauperism..nn.1
  paus_1_N = mkN "paus" "pauser" ; -- paus..nn.1
  pausa_1_V = mkV "pausar" ; -- pausa..vb.1
  pausande_1_N = mkN "pausande" ; -- pausande..nn.1
  pausera_1_V = mkV "pauserar" ; -- pausera..vb.1
  pauserande_1_N = mkN "pauserande" ; -- pauserande..nn.1
  pauserbar_1_A = mkA "pauserbar" ; -- pauserbar..av.1
  pauserbarhet_1_N = mkN "pauserbarhet" ; -- pauserbarhet..nn.1
  pausering_1_N = mkN "pausering" ; -- pausering..nn.1
  pausfågel_1_N = mkN "pausfågel" ; -- pausfågel..nn.1
  pauskommatera_1_V = mkV "pauskommaterar" ; -- pauskommatera..vb.1
  pauskommaterande_1_N = mkN "pauskommaterande" ; -- pauskommaterande..nn.1
  pauskommaterbar_1_A = mkA "pauskommaterbar" ; -- pauskommaterbar..av.1
  pauskommaterbarhet_1_N = mkN "pauskommaterbarhet" ; -- pauskommaterbarhet..nn.1
  pauskommatering_1_N = mkN "pauskommatering" ; -- pauskommatering..nn.1
  paussignal_1_N = mkN "paussignal" "paussignaler" ; -- paussignal..nn.1
  paustecken_1_N = mkN "paustecken" "paustecknet" "paustecken" "paustecknen" ; -- paustecken..nn.1
  pava_1_N = mkN "pava" ; -- pava..nn.1
  pavane_1_N = mkN "pavane" "pavaner" ; -- pavane..nn.1
  paviljong_1_N = mkN "paviljong" "paviljonger" ; -- paviljong..nn.1
  paxa_1_V = mkV "paxar" ; -- paxa..vb.1
  paxande_1_N = mkN "paxande" ; -- paxande..nn.1
  pdf_format_1_N = mkN "pdf-format" neutrum  ; -- pdf-format..nn.1
  pdf_tidning_1_N = mkN "pdf-tidning" ; -- pdf-tidning..nn.1
  peaka_1_V = mkV "peakar" ; -- peaka..vb.1
  peakande_1_N = mkN "peakande" ; -- peakande..nn.1
  peakning_1_N = mkN "peakning" ; -- peakning..nn.1
  peang_1_N = mkN "peang" "peanger" ; -- peang..nn.1
  pechblände_1_N = mkN "pechblände" ; -- pechblände..nn.1
  pecheneg_1_N = mkN "pecheneg" "pecheneger" ; -- pecheneg..nn.1
  pedagog_1_N = mkN "pedagog" "pedagoger" ; -- pedagog..nn.1
  pedagogik_1_N = mkN "pedagogik" ; -- pedagogik..nn.1
  pedagogisk_1_A = mkA "pedagogisk" ; -- pedagogisk..av.1
  pedal_1_N = mkN "pedal" "pedaler" ; -- pedal..nn.1
  pedalbåt_1_N = mkN "pedalbåt" ; -- pedalbåt..nn.1
  pedalförstärkt_1_A = mkA "pedalförstärkt" "pedalförstärkt" ; -- pedalförstärkt..av.1
  pedalmanövrerad_1_A = mkA "pedalmanövrerad" ; -- pedalmanövrerad..av.1
  pedalregister_1_N = mkN "pedalregister" neutrum  ; -- pedalregister..nn.1
  pedalstämma_1_N = mkN "pedalstämma" ; -- pedalstämma..nn.1
  pedant_1_N = mkN "pedant" "pedanter" ; -- pedant..nn.1
  pedanteri_1_N = mkN "pedanteri" "pedanteriet" "pedanterier" "pedanterierna" ; -- pedanteri..nn.1
  pedantisk_1_A = mkA "pedantisk" ; -- pedantisk..av.1
  peddo_1_N = mkN "peddo" "peddot" "peddon" "peddona" ; -- peddo..nn.1
  pedell_1_N = mkN "pedell" "pedeller" ; -- pedell..nn.1
  pederast_1_N = mkN "pederast" "pederaster" ; -- pederast..nn.1
  pederasti_1_N = mkN "pederasti" ; -- pederasti..nn.1
  pediatrik_1_N = mkN "pediatrik" ; -- pediatrik..nn.1
  pediatriker_1_N = mkN "pediatriker" "pediatrikern" "pediatriker" "pediatrikerna" ; -- pediatriker..nn.1
  pediatrisk_1_A = mkA "pediatrisk" ; -- pediatrisk..av.1
  pedikur_1_N = mkN "pedikur" ; -- pedikur..nn.1
  pedikurist_1_N = mkN "pedikurist" "pedikurister" ; -- pedikurist..nn.1
  pedikyr_1_N = mkN "pedikyr" ; -- pedikyr..nn.1
  pedikyrist_1_N = mkN "pedikyrist" "pedikyrister" ; -- pedikyrist..nn.1
  pediment_1_N = mkN "pediment" neutrum  ; -- pediment..nn.1
  pedofil_1_A = mkA "pedofil" ; -- pedofil..av.1
  pedofil_1_N = mkN "pedofil" "pedofiler" ; -- pedofil..nn.1
  pedofilhysteri_1_N = mkN "pedofilhysteri" "pedofilhysteriet" "pedofilhysterier" "pedofilhysterierna" ; -- pedofilhysteri..nn.1
  pedofilhärva_1_N = mkN "pedofilhärva" ; -- pedofilhärva..nn.1
  pedofili_1_N = mkN "pedofili" ; -- pedofili..nn.1
  pedofilskräck_1_N = mkN "pedofilskräck" ; -- pedofilskräck..nn.1
  pedologi_1_N = mkN "pedologi" ; -- pedologi..nn.1
  peeling_1_N = mkN "peeling" ; -- peeling..nn.1
  peelingkräm_1_N = mkN "peelingkräm" "peelingkrämer" ; -- peelingkräm..nn.1
  pegamoid_1_N = mkN "pegamoid" ; -- pegamoid..nn.1
  pegas_1_N = mkN "pegas" "pegaser" ; -- pegas..nn.1
  pegel_1_N = mkN "pegel" ; -- pegel..nn.1
  pegmatit_1_N = mkN "pegmatit" "pegmatiter" ; -- pegmatit..nn.1
  pejla_1_V = mkV "pejlar" ; -- pejla..vb.1
  pejlande_1_N = mkN "pejlande" ; -- pejlande..nn.1
  pejling_1_N = mkN "pejling" ; -- pejling..nn.1
  pejlskiva_1_N = mkN "pejlskiva" ; -- pejlskiva..nn.1
  pejorativ_1_A = mkA "pejorativ" ; -- pejorativ..av.1
  pejorativ_1_N = mkN "pejorativ" neutrum  ; -- pejorativ..nn.1
  peka_1_V = mkV "pekar" ; -- peka..vb.1
  pekande_1_N = mkN "pekande" ; -- pekande..nn.1
  pekannöt_1_N = mkN "pekannöt" "pekannötter" ; -- pekannöt..nn.1
  pekare_1_N = mkN "pekare" utrum  ; -- pekare..nn.1
  pekbok_1_N = mkN "pekbok" "pekböcker" ; -- pekbok..nn.1
  pekfinger_1_N = mkN "pekfinger" ; -- pekfinger..nn.1
  pekfingernagel_1_N = mkN "pekfingernagel" ; -- pekfingernagel..nn.1
  pekfingertest_1_N = mkN "pekfingertest" neutrum  ; -- pekfingertest..nn.1
  pekfingervals_1_N = mkN "pekfingervals" ; -- pekfingervals..nn.1
  pekines_1_N = mkN "pekines" "pekineser" ; -- pekines..nn.1
  pekinges_1_N = mkN "pekinges" "pekingeser" ; -- pekinges..nn.1
  pekning_1_N = mkN "pekning" ; -- pekning..nn.1
  pekoral_1_N = mkN "pekoral" neutrum  ; -- pekoral..nn.1
  pekoralist_1_N = mkN "pekoralist" "pekoralister" ; -- pekoralist..nn.1
  pekoralistisk_1_A = mkA "pekoralistisk" ; -- pekoralistisk..av.1
  pekpinne_1_N = mkN "pekpinne" utrum  ; -- pekpinne..nn.1
  pekskärm_1_N = mkN "pekskärm" ; -- pekskärm..nn.1
  pektin_1_N = mkN "pektin" neutrum  ; -- pektin..nn.1
  pektå_1_N = mkN "pektå" "pektån" "pektår" "pektårna" ; -- pektå..nn.1
  pekuniär_1_A = mkA "pekuniär" ; -- pekuniär..av.1
  pelagisk_1_A = mkA "pelagisk" ; -- pelagisk..av.1
  pelarbord_1_N = mkN "pelarbord" neutrum  ; -- pelarbord..nn.1
  pelarborrmaskin_1_N = mkN "pelarborrmaskin" "pelarborrmaskiner" ; -- pelarborrmaskin..nn.1
  pelardomkraft_1_N = mkN "pelardomkraft" "pelardomkrafter" ; -- pelardomkraft..nn.1
  pelare_1_N = mkN "pelare" utrum  ; -- pelare..nn.1
  pelarformig_1_A = mkA "pelarformig" ; -- pelarformig..av.1
  pelargalleri_1_N = mkN "pelargalleri" "pelargalleriet" "pelargallerier" "pelargallerierna" ; -- pelargalleri..nn.1
  pelargon_1_N = mkN "pelargon" "pelargoner" ; -- pelargon..nn.1
  pelargonia_1_N = mkN "pelargonia" ; -- pelargonia..nn.1
  pelargång_1_N = mkN "pelargång" ; -- pelargång..nn.1
  pelarhall_1_N = mkN "pelarhall" ; -- pelarhall..nn.1
  pelarhelgon_1_N = mkN "pelarhelgon" neutrum  ; -- pelarhelgon..nn.1
  pelarhuvud_1_N = mkN "pelarhuvud" "pelarhuvudet" "pelarhuvud" "pelarhuvudena" ; -- pelarhuvud..nn.1
  pelarkapitäl_1_N = mkN "pelarkapitäl" neutrum  ; -- pelarkapitäl..nn.1
  pelarsal_1_N = mkN "pelarsal" ; -- pelarsal..nn.1
  pelerin_1_N = mkN "pelerin" "peleriner" ; -- pelerin..nn.1
  pelikan_1_N = mkN "pelikan" "pelikaner" ; -- pelikan..nn.1
  pellagra_1_N = mkN "pellagra" ; -- pellagra..nn.1
  pellejöns_1_N = mkN "pellejöns" ; -- pellejöns..nn.1
  pellet_1_N = mkN "pellet" ; -- pellet..nn.1
  pelletera_1_V = mkV "pelleterar" ; -- pelletera..vb.1
  pelleterande_1_N = mkN "pelleterande" ; -- pelleterande..nn.1
  pelleterbar_1_A = mkA "pelleterbar" ; -- pelleterbar..av.1
  pelleterbarhet_1_N = mkN "pelleterbarhet" ; -- pelleterbarhet..nn.1
  pelletering_1_N = mkN "pelletering" ; -- pelletering..nn.1
  peloponnesisk_1_A = mkA "peloponnesisk" ; -- peloponnesisk..av.1
  pelota_1_N = mkN "pelota" ; -- pelota..nn.1
  peltonturbin_1_N = mkN "peltonturbin" "peltonturbiner" ; -- peltonturbin..nn.1
  pemmikan_1_N = mkN "pemmikan" ; -- pemmikan..nn.1
  pen_1_N = mkN "pen" "penen" "penar" "penarna" ; -- pen..nn.1
  penchis_1_N = mkN "penchis" ; -- penchis..nn.1
  pendang_1_N = mkN "pendang" "pendanger" ; -- pendang..nn.1
  pendant_1_N = mkN "pendant" "pendanter" ; -- pendant..nn.1
  pendel_1_N = mkN "pendel" ; -- pendel..nn.1
  pendel_2_N = mkN "pendel" ; -- pendel..nn.2
  pendelavstånd_1_N = mkN "pendelavstånd" neutrum  ; -- pendelavstånd..nn.1
  pendelbåt_1_N = mkN "pendelbåt" ; -- pendelbåt..nn.1
  pendelbåtsflotta_1_N = mkN "pendelbåtsflotta" ; -- pendelbåtsflotta..nn.1
  pendelbåtstrafik_1_N = mkN "pendelbåtstrafik" ; -- pendelbåtstrafik..nn.1
  pendelkaos_1_N = mkN "pendelkaos" neutrum  ; -- pendelkaos..nn.1
  pendelrörelse_1_N = mkN "pendelrörelse" "pendelrörelser" ; -- pendelrörelse..nn.1
  pendelslag_1_N = mkN "pendelslag" neutrum  ; -- pendelslag..nn.1
  pendelsvängning_1_N = mkN "pendelsvängning" ; -- pendelsvängning..nn.1
  pendeltidtabell_1_N = mkN "pendeltidtabell" "pendeltidtabeller" ; -- pendeltidtabell..nn.1
  pendeltrafik_1_N = mkN "pendeltrafik" ; -- pendeltrafik..nn.1
  pendeltåg_1_N = mkN "pendeltåg" neutrum  ; -- pendeltåg..nn.1
  pendeltågsankomst_1_N = mkN "pendeltågsankomst" "pendeltågsankomster" ; -- pendeltågsankomst..nn.1
  pendeltågsavgång_1_N = mkN "pendeltågsavgång" ; -- pendeltågsavgång..nn.1
  pendeltågstidtabell_1_N = mkN "pendeltågstidtabell" "pendeltågstidtabeller" ; -- pendeltågstidtabell..nn.1
  pendeltågstrafik_1_N = mkN "pendeltågstrafik" ; -- pendeltågstrafik..nn.1
  pendeltågstunnel_1_N = mkN "pendeltågstunnel" ; -- pendeltågstunnel..nn.1
  pendelur_1_N = mkN "pendelur" neutrum  ; -- pendelur..nn.1
  pendla_1_V = mkV "pendlar" ; -- pendla..vb.1
  pendlande_1_N = mkN "pendlande" ; -- pendlande..nn.1
  pendlare_1_N = mkN "pendlare" utrum  ; -- pendlare..nn.1
  pendling_1_N = mkN "pendling" ; -- pendling..nn.1
  pendling_2_N = mkN "pendling" ; -- pendling..nn.2
  pendlingssurfa_1_V = mkV "pendlingssurfar" ; -- pendlingssurfa..vb.1
  pendlingssurfande_1_N = mkN "pendlingssurfande" ; -- pendlingssurfande..nn.1
  pendlingssurfning_1_N = mkN "pendlingssurfning" ; -- pendlingssurfning..nn.1
  pendyl_1_N = mkN "pendyl" "pendyler" ; -- pendyl..nn.1
  peneplan_1_N = mkN "peneplan" neutrum  ; -- peneplan..nn.1
  penetration_1_N = mkN "penetration" ; -- penetration..nn.1
  penetrationstvång_1_N = mkN "penetrationstvång" neutrum  ; -- penetrationstvång..nn.1
  penetrera_1_V = mkV "penetrerar" ; -- penetrera..vb.1
  penetrerande_1_N = mkN "penetrerande" ; -- penetrerande..nn.1
  penetrerbar_1_A = mkA "penetrerbar" ; -- penetrerbar..av.1
  penetrerbarhet_1_N = mkN "penetrerbarhet" ; -- penetrerbarhet..nn.1
  penetrering_1_N = mkN "penetrering" ; -- penetrering..nn.1
  peng_1_N = mkN "peng" ; -- peng..nn.1
  pengabistånd_1_N = mkN "pengabistånd" neutrum  ; -- pengabistånd..nn.1
  pengabrist_1_N = mkN "pengabrist" ; -- pengabrist..nn.1
  pengamässig_1_A = mkA "pengamässig" ; -- pengamässig..av.1
  pengarullning_1_N = mkN "pengarullning" ; -- pengarullning..nn.1
  pengaslarv_1_N = mkN "pengaslarv" neutrum  ; -- pengaslarv..nn.1
  pengaslukande_1_A = mkA "pengaslukande" ; -- pengaslukande..av.1
  pengastinn_1_A = mkA "pengastinn" "pengastint" ; -- pengastinn..av.1
  pengastinnhet_1_N = mkN "pengastinnhet" ; -- pengastinnhet..nn.1
  penibel_1_A = mkA "penibel" ; -- penibel..av.1
  penicillin_1_N = mkN "penicillin" "penicilliner" ; -- penicillin..nn.1
  penis_1_N = mkN "penis" ; -- penis..nn.1
  penisattrapp_1_N = mkN "penisattrapp" "penisattrapper" ; -- penisattrapp..nn.1
  penisavund_1_N = mkN "penisavund" ; -- penisavund..nn.1
  penisollon_1_N = mkN "penisollon" neutrum  ; -- penisollon..nn.1
  penisring_1_N = mkN "penisring" ; -- penisring..nn.1
  penitens_1_N = mkN "penitens" ; -- penitens..nn.1
  penjoar_1_N = mkN "penjoar" "penjoarer" ; -- penjoar..nn.1
  penna_1_N = mkN "penna" ; -- penna..nn.1
  pennalism_1_N = mkN "pennalism" "pennalismer" ; -- pennalism..nn.1
  pennalist_1_N = mkN "pennalist" "pennalister" ; -- pennalist..nn.1
  pennalistisk_1_A = mkA "pennalistisk" ; -- pennalistisk..av.1
  penndrag_1_N = mkN "penndrag" neutrum  ; -- penndrag..nn.1
  pennformerare_1_N = mkN "pennformerare" utrum  ; -- pennformerare..nn.1
  pennfäktare_1_N = mkN "pennfäktare" utrum  ; -- pennfäktare..nn.1
  pennfäkteri_1_N = mkN "pennfäkteri" "pennfäkteriet" "pennfäkterier" "pennfäkterierna" ; -- pennfäkteri..nn.1
  penni_1_N = mkN "penni" "pennin" "penni" "pennina" ; -- penni..nn.1
  penning_1_N = mkN "penning" ; -- penning..nn.1
  penningaristokrat_1_N = mkN "penningaristokrat" "penningaristokrater" ; -- penningaristokrat..nn.1
  penningaristokrati_1_N = mkN "penningaristokrati" "penningaristokratier" ; -- penningaristokrati..nn.1
  penningbekymmer_1_N = mkN "penningbekymmer" neutrum  ; -- penningbekymmer..nn.1
  penningbrist_1_N = mkN "penningbrist" ; -- penningbrist..nn.1
  penningflöde_1_N = mkN "penningflöde" ; -- penningflöde..nn.1
  penningförsändelse_1_N = mkN "penningförsändelse" "penningförsändelser" ; -- penningförsändelse..nn.1
  penninggräs_1_N = mkN "penninggräs" neutrum  ; -- penninggräs..nn.1
  penninghjälp_1_N = mkN "penninghjälp" ; -- penninghjälp..nn.1
  penninghushållning_1_N = mkN "penninghushållning" ; -- penninghushållning..nn.1
  penninghäleri_1_N = mkN "penninghäleri" "penninghäleriet" "penninghälerier" "penninghälerierna" ; -- penninghäleri..nn.1
  penninginsamlare_1_N = mkN "penninginsamlare" utrum  ; -- penninginsamlare..nn.1
  penninginsamling_1_N = mkN "penninginsamling" ; -- penninginsamling..nn.1
  penningkista_1_N = mkN "penningkista" ; -- penningkista..nn.1
  penningknipa_1_N = mkN "penningknipa" ; -- penningknipa..nn.1
  penninglott_1_N = mkN "penninglott" "penninglotter" ; -- penninglott..nn.1
  penninglotteri_1_N = mkN "penninglotteri" neutrum  ; -- penninglotteri..nn.1
  penninglån_1_N = mkN "penninglån" neutrum  ; -- penninglån..nn.1
  penningmarknad_1_N = mkN "penningmarknad" "penningmarknader" ; -- penningmarknad..nn.1
  penningmedel_1_N = mkN "penningmedel" neutrum  ; -- penningmedel..nn.1
  penningmässig_1_A = mkA "penningmässig" ; -- penningmässig..av.1
  penningpolitik_1_N = mkN "penningpolitik" ; -- penningpolitik..nn.1
  penningpolitisk_1_A = mkA "penningpolitisk" ; -- penningpolitisk..av.1
  penningpung_1_N = mkN "penningpung" ; -- penningpung..nn.1
  penningpåse_1_N = mkN "penningpåse" utrum  ; -- penningpåse..nn.1
  penningstark_1_A = mkA "penningstark" ; -- penningstark..av.1
  penningstinn_1_A = mkA "penningstinn" "penningstint" ; -- penningstinn..av.1
  penningstinnhet_1_N = mkN "penningstinnhet" ; -- penningstinnhet..nn.1
  penningsumma_1_N = mkN "penningsumma" ; -- penningsumma..nn.1
  penningsystem_1_N = mkN "penningsystem" neutrum  ; -- penningsystem..nn.1
  penningtilldelning_1_N = mkN "penningtilldelning" ; -- penningtilldelning..nn.1
  penningtillgång_1_N = mkN "penningtillgång" ; -- penningtillgång..nn.1
  penningtransaktion_1_N = mkN "penningtransaktion" ; -- penningtransaktion..nn.1
  penningtvätt_1_N = mkN "penningtvätt" ; -- penningtvätt..nn.1
  penningvärde_1_N = mkN "penningvärde" ; -- penningvärde..nn.1
  penningväsen_1_N = mkN "penningväsen" neutrum  ; -- penningväsen..nn.1
  penningört_1_N = mkN "penningört" ; -- penningört..nn.1
  pennkniv_1_N = mkN "pennkniv" ; -- pennkniv..nn.1
  pennliknande_1_A = mkA "pennliknande" ; -- pennliknande..av.1
  pennmodell_1_N = mkN "pennmodell" "pennmodeller" ; -- pennmodell..nn.1
  pennritning_1_N = mkN "pennritning" ; -- pennritning..nn.1
  pennskaft_1_N = mkN "pennskaft" neutrum  ; -- pennskaft..nn.1
  pennstreck_1_N = mkN "pennstreck" neutrum  ; -- pennstreck..nn.1
  pennsylvan_1_N = mkN "pennsylvan" ; -- pennsylvan..nn.1
  pennteckning_1_N = mkN "pennteckning" ; -- pennteckning..nn.1
  pennvässare_1_N = mkN "pennvässare" utrum  ; -- pennvässare..nn.1
  penny_1_N = mkN "penny" "pennyn" "pennies" "penniesarna" ; -- penny..nn.1
  penschis_1_N = mkN "penschis" ; -- penschis..nn.1
  pensel_1_N = mkN "pensel" ; -- pensel..nn.1
  penseldrag_1_N = mkN "penseldrag" neutrum  ; -- penseldrag..nn.1
  penselföring_1_N = mkN "penselföring" ; -- penselföring..nn.1
  pension_1_N = mkN "pension" ; -- pension..nn.1
  pensionat_1_N = mkN "pensionat" neutrum  ; -- pensionat..nn.1
  pensionatsinnehavare_1_N = mkN "pensionatsinnehavare" utrum  ; -- pensionatsinnehavare..nn.1
  pensionera_1_V = mkV "pensionerar" ; -- pensionera..vb.1
  pensionerande_1_N = mkN "pensionerande" ; -- pensionerande..nn.1
  pensionerbar_1_A = mkA "pensionerbar" ; -- pensionerbar..av.1
  pensionerbarhet_1_N = mkN "pensionerbarhet" ; -- pensionerbarhet..nn.1
  pensionering_1_N = mkN "pensionering" ; -- pensionering..nn.1
  pensioneringsdag_1_N = mkN "pensioneringsdag" ; -- pensioneringsdag..nn.1
  pensioneringsdatum_1_N = mkN "pensioneringsdatum" ; -- pensioneringsdatum..nn.1
  pensionsbrev_1_N = mkN "pensionsbrev" neutrum  ; -- pensionsbrev..nn.1
  pensionsfråga_1_N = mkN "pensionsfråga" ; -- pensionsfråga..nn.1
  pensionsförsäkring_1_N = mkN "pensionsförsäkring" ; -- pensionsförsäkring..nn.1
  pensionsgrundande_1_A = mkA "pensionsgrundande" ; -- pensionsgrundande..av.1
  pensionsinbetalning_1_N = mkN "pensionsinbetalning" ; -- pensionsinbetalning..nn.1
  pensionskassa_1_N = mkN "pensionskassa" ; -- pensionskassa..nn.1
  pensionsmässig_1_A = mkA "pensionsmässig" ; -- pensionsmässig..av.1
  pensionsnämnd_1_N = mkN "pensionsnämnd" "pensionsnämnder" ; -- pensionsnämnd..nn.1
  pensionspoäng_1_N = mkN "pensionspoäng" "pensionspoängen" "pensionspoäng" "pensionspoängen" ; -- pensionspoäng..nn.1
  pensionsrätt_1_N = mkN "pensionsrätt" ; -- pensionsrätt..nn.1
  pensionsrådgivare_1_N = mkN "pensionsrådgivare" utrum  ; -- pensionsrådgivare..nn.1
  pensionsspara_1_V = mkV "pensionssparar" ; -- pensionsspara..vb.1
  pensionssparande_1_N = mkN "pensionssparande" ; -- pensionssparande..nn.1
  pensionssystem_1_N = mkN "pensionssystem" neutrum  ; -- pensionssystem..nn.1
  pensionstagare_1_N = mkN "pensionstagare" utrum  ; -- pensionstagare..nn.1
  pensionsval_1_N = mkN "pensionsval" neutrum  ; -- pensionsval..nn.1
  pensionsålder_1_N = mkN "pensionsålder" ; -- pensionsålder..nn.1
  pensionär_1_N = mkN "pensionär" "pensionärer" ; -- pensionär..nn.1
  pensionärslägenhet_1_N = mkN "pensionärslägenhet" "pensionärslägenheter" ; -- pensionärslägenhet..nn.1
  pensionärstillhåll_1_N = mkN "pensionärstillhåll" neutrum  ; -- pensionärstillhåll..nn.1
  pensionärstillvaro_1_N = mkN "pensionärstillvaro" ; -- pensionärstillvaro..nn.1
  pensjis_1_N = mkN "pensjis" ; -- pensjis..nn.1
  pensla_1_V = mkV "penslar" ; -- pensla..vb.1
  penslande_1_N = mkN "penslande" ; -- penslande..nn.1
  pensling_1_N = mkN "pensling" ; -- pensling..nn.1
  pensum_1_N = mkN "pensum" neutrum  ; -- pensum..nn.1
  pensé_1_N = mkN "pensé" "penséer" ; -- pensé..nn.1
  pentaeder_1_N = mkN "pentaeder" ; -- pentaeder..nn.1
  pentagram_1_N = mkN "pentagram" "pentagrammet" "pentagram" "pentagrammen" ; -- pentagram..nn.1
  pentameter_1_N = mkN "pentameter" ; -- pentameter..nn.1
  pentateuk_1_N = mkN "pentateuk" ; -- pentateuk..nn.1
  pentatonik_1_N = mkN "pentatonik" ; -- pentatonik..nn.1
  pentry_1_N = mkN "pentry" "pentryt" "pentryn" "pentryna" ; -- pentry..nn.1
  pentylpulver_1_N = mkN "pentylpulver" neutrum  ; -- pentylpulver..nn.1
  penultima_1_N = mkN "penultima" ; -- penultima..nn.1
  peon_1_N = mkN "peon" "peoner" ; -- peon..nn.1
  pepita_1_N = mkN "pepita" ; -- pepita..nn.1
  pepitarutig_1_A = mkA "pepitarutig" ; -- pepitarutig..av.1
  pepitarutighet_1_N = mkN "pepitarutighet" ; -- pepitarutighet..nn.1
  peppa_1_V = mkV "peppar" ; -- peppa..vb.1
  peppande_1_N = mkN "peppande" ; -- peppande..nn.1
  pepparkaka_1_N = mkN "pepparkaka" ; -- pepparkaka..nn.1
  pepparkaksbak_1_N = mkN "pepparkaksbak" neutrum  ; -- pepparkaksbak..nn.1
  pepparkaksdeg_1_N = mkN "pepparkaksdeg" ; -- pepparkaksdeg..nn.1
  pepparkaksgris_1_N = mkN "pepparkaksgris" ; -- pepparkaksgris..nn.1
  pepparkaksgubbe_1_N = mkN "pepparkaksgubbe" utrum  ; -- pepparkaksgubbe..nn.1
  pepparkakshus_1_N = mkN "pepparkakshus" neutrum  ; -- pepparkakshus..nn.1
  pepparkaksmarodör_1_N = mkN "pepparkaksmarodör" "pepparkaksmarodörer" ; -- pepparkaksmarodör..nn.1
  pepparkaksrekord_1_N = mkN "pepparkaksrekord" neutrum  ; -- pepparkaksrekord..nn.1
  pepparkaksstad_1_N = mkN "pepparkaksstad" "pepparkaksstäder" ; -- pepparkaksstad..nn.1
  pepparkorn_1_N = mkN "pepparkorn" neutrum  ; -- pepparkorn..nn.1
  pepparkvarn_1_N = mkN "pepparkvarn" ; -- pepparkvarn..nn.1
  pepparmint_1_N = mkN "pepparmint" ; -- pepparmint..nn.1
  pepparmynt_1_N = mkN "pepparmynt" ; -- pepparmynt..nn.1
  pepparmynta_1_N = mkN "pepparmynta" ; -- pepparmynta..nn.1
  pepparmyntsolja_1_N = mkN "pepparmyntsolja" ; -- pepparmyntsolja..nn.1
  pepparrot_1_N = mkN "pepparrot" ; -- pepparrot..nn.1
  pepparsprej_1_N = mkN "pepparsprej" ; -- pepparsprej..nn.1
  pepparspreja_1_V = mkV "pepparsprejar" ; -- pepparspreja..vb.1
  pepparsprejande_1_N = mkN "pepparsprejande" ; -- pepparsprejande..nn.1
  peppra_1_V = mkV "pepprar" ; -- peppra..vb.1
  pepprad_1_A = mkA "pepprad" ; -- pepprad..av.1
  pepprande_1_N = mkN "pepprande" ; -- pepprande..nn.1
  pepprig_1_A = mkA "pepprig" ; -- pepprig..av.1
  pepsin_1_N = mkN "pepsin" ; -- pepsin..nn.1
  peptid_1_N = mkN "peptid" neutrum  ; -- peptid..nn.1
  perborat_1_N = mkN "perborat" "perboratet" "perborater" "perboraterna" ; -- perborat..nn.1
  percentil_1_N = mkN "percentil" "percentiler" ; -- percentil..nn.1
  perception_1_N = mkN "perception" ; -- perception..nn.1
  perceptionsstörning_1_N = mkN "perceptionsstörning" ; -- perceptionsstörning..nn.1
  perceptuell_1_A = mkA "perceptuell" ; -- perceptuell..av.1
  percipiera_1_V = mkV "percipierar" ; -- percipiera..vb.1
  percipierande_1_N = mkN "percipierande" ; -- percipierande..nn.1
  percipierbar_1_A = mkA "percipierbar" ; -- percipierbar..av.1
  percipierbarhet_1_N = mkN "percipierbarhet" ; -- percipierbarhet..nn.1
  percipiering_1_N = mkN "percipiering" ; -- percipiering..nn.1
  peremtorisk_1_A = mkA "peremtorisk" ; -- peremtorisk..av.1
  perenn_1_A = mkA "perenn" "perent" ; -- perenn..av.1
  perenn_1_N = mkN "perenn" "perenner" ; -- perenn..nn.1
  perennera_1_V = mkV "perennerar" ; -- perennera..vb.1
  perennerande_1_N = mkN "perennerande" ; -- perennerande..nn.1
  perennering_1_N = mkN "perennering" ; -- perennering..nn.1
  perestrojka_1_N = mkN "perestrojka" ; -- perestrojka..nn.1
  perfekt_1_A = mkA "perfekt" "perfekt" ; -- perfekt..av.1
  perfekthet_1_N = mkN "perfekthet" ; -- perfekthet..nn.1
  perfektion_1_N = mkN "perfektion" ; -- perfektion..nn.1
  perfektionism_1_N = mkN "perfektionism" "perfektionismer" ; -- perfektionism..nn.1
  perfektionist_1_N = mkN "perfektionist" "perfektionister" ; -- perfektionist..nn.1
  perfektionistisk_1_A = mkA "perfektionistisk" ; -- perfektionistisk..av.1
  perfektiv_1_A = mkA "perfektiv" ; -- perfektiv..av.1
  perfektiv_1_N = mkN "perfektiv" neutrum  ; -- perfektiv..nn.1
  perfektivisk_1_A = mkA "perfektivisk" ; -- perfektivisk..av.1
  perfektparticip_1_N = mkN "perfektparticip" neutrum  ; -- perfektparticip..nn.1
  perfektum_1_N = mkN "perfektum" "perfektum" "perfekter" "perfekterna" ; -- perfektum..nn.1
  perfid_1_A = mkA "perfid" ; -- perfid..av.1
  perfiditet_1_N = mkN "perfiditet" "perfiditeter" ; -- perfiditet..nn.1
  perforation_1_N = mkN "perforation" ; -- perforation..nn.1
  perforator_1_N = mkN "perforator" "perforatorer" ; -- perforator..nn.1
  perforera_1_V = mkV "perforerar" ; -- perforera..vb.1
  perforerande_1_N = mkN "perforerande" ; -- perforerande..nn.1
  perforerbar_1_A = mkA "perforerbar" ; -- perforerbar..av.1
  perforerbarhet_1_N = mkN "perforerbarhet" ; -- perforerbarhet..nn.1
  perforering_1_N = mkN "perforering" ; -- perforering..nn.1
  pergament_1_N = mkN "pergament" neutrum  ; -- pergament..nn.1
  pergamentband_1_N = mkN "pergamentband" neutrum  ; -- pergamentband..nn.1
  pergamentbit_1_N = mkN "pergamentbit" ; -- pergamentbit..nn.1
  pergamentbrev_1_N = mkN "pergamentbrev" neutrum  ; -- pergamentbrev..nn.1
  pergamentrulle_1_N = mkN "pergamentrulle" utrum  ; -- pergamentrulle..nn.1
  pergamentsbrev_1_N = mkN "pergamentsbrev" neutrum  ; -- pergamentsbrev..nn.1
  pergola_1_N = mkN "pergola" ; -- pergola..nn.1
  perifer_1_A = mkA "perifer" "perifert" ; -- perifer..av.1
  periferhet_1_N = mkN "periferhet" ; -- periferhet..nn.1
  periferi_1_N = mkN "periferi" "periferier" ; -- periferi..nn.1
  periferivinkel_1_N = mkN "periferivinkel" ; -- periferivinkel..nn.1
  perifon_1_N = mkN "perifon" "perifoner" ; -- perifon..nn.1
  perifras_1_N = mkN "perifras" "perifraser" ; -- perifras..nn.1
  perifrastisk_1_A = mkA "perifrastisk" ; -- perifrastisk..av.1
  perigeum_1_N = mkN "perigeum" neutrum  ; -- perigeum..nn.1
  perihelium_1_N = mkN "perihelium" neutrum  ; -- perihelium..nn.1
  perimeter_1_N = mkN "perimeter" ; -- perimeter..nn.1
  perinatal_1_A = mkA "perinatal" ; -- perinatal..av.1
  period_1_N = mkN "period" "perioder" ; -- period..nn.1
  periodare_1_N = mkN "periodare" utrum  ; -- periodare..nn.1
  periodbyggnad_1_N = mkN "periodbyggnad" "periodbyggnader" ; -- periodbyggnad..nn.1
  periodicitet_1_N = mkN "periodicitet" "periodiciteter" ; -- periodicitet..nn.1
  periodindelning_1_N = mkN "periodindelning" ; -- periodindelning..nn.1
  periodisera_1_V = mkV "periodiserar" ; -- periodisera..vb.1
  periodiserande_1_N = mkN "periodiserande" ; -- periodiserande..nn.1
  periodiserbar_1_A = mkA "periodiserbar" ; -- periodiserbar..av.1
  periodiserbarhet_1_N = mkN "periodiserbarhet" ; -- periodiserbarhet..nn.1
  periodisering_1_N = mkN "periodisering" ; -- periodisering..nn.1
  periodisk_1_A = mkA "periodisk" ; -- periodisk..av.1
  periodsupare_1_N = mkN "periodsupare" utrum  ; -- periodsupare..nn.1
  periodtal_1_N = mkN "periodtal" neutrum  ; -- periodtal..nn.1
  periodvis_1_Adv = mkAdv "periodvis" ; -- periodvis..ab.1
  peripeti_1_N = mkN "peripeti" "peripetier" ; -- peripeti..nn.1
  periskop_1_N = mkN "periskop" neutrum  ; -- periskop..nn.1
  periskopisk_1_A = mkA "periskopisk" ; -- periskopisk..av.1
  peristaltik_1_N = mkN "peristaltik" ; -- peristaltik..nn.1
  peristaltisk_1_A = mkA "peristaltisk" ; -- peristaltisk..av.1
  peristyl_1_N = mkN "peristyl" "peristyler" ; -- peristyl..nn.1
  peritonit_1_N = mkN "peritonit" "peritoniter" ; -- peritonit..nn.1
  perkal_1_N = mkN "perkal" "perkaler" ; -- perkal..nn.1
  perkolation_1_N = mkN "perkolation" ; -- perkolation..nn.1
  perkolator_1_N = mkN "perkolator" "perkolatorer" ; -- perkolator..nn.1
  perkussion_1_N = mkN "perkussion" ; -- perkussion..nn.1
  perkussionsinstrument_1_N = mkN "perkussionsinstrument" neutrum  ; -- perkussionsinstrument..nn.1
  perkutan_1_A = mkA "perkutan" ; -- perkutan..av.1
  perm_1_N = mkN "perm" ; -- perm..nn.1
  permafrost_1_N = mkN "permafrost" ; -- permafrost..nn.1
  permafrostforskare_1_N = mkN "permafrostforskare" utrum  ; -- permafrostforskare..nn.1
  permanens_1_N = mkN "permanens" ; -- permanens..nn.1
  permanent_1_A = mkA "permanent" "permanent" ; -- permanent..av.1
  permanent_1_N = mkN "permanent" ; -- permanent..nn.1
  permanenta_1_V = mkV "permanentar" ; -- permanenta..vb.1
  permanentande_1_N = mkN "permanentande" ; -- permanentande..nn.1
  permanenthet_1_N = mkN "permanenthet" ; -- permanenthet..nn.1
  permanentning_1_N = mkN "permanentning" ; -- permanentning..nn.1
  permanentondulera_1_V = mkV "permanentondulerar" ; -- permanentondulera..vb.1
  permanentondulerande_1_N = mkN "permanentondulerande" ; -- permanentondulerande..nn.1
  permanentondulerbar_1_A = mkA "permanentondulerbar" ; -- permanentondulerbar..av.1
  permanentondulerbarhet_1_N = mkN "permanentondulerbarhet" ; -- permanentondulerbarhet..nn.1
  permanentondulering_1_N = mkN "permanentondulering" ; -- permanentondulering..nn.1
  permeabel_1_A = mkA "permeabel" ; -- permeabel..av.1
  permeabilitet_1_N = mkN "permeabilitet" "permeabiliteter" ; -- permeabilitet..nn.1
  permis_1_N = mkN "permis" ; -- permis..nn.1
  permission_1_N = mkN "permission" ; -- permission..nn.1
  permittent_1_N = mkN "permittent" "permittenter" ; -- permittent..nn.1
  permittera_1_V = mkV "permitterar" ; -- permittera..vb.1
  permitterande_1_N = mkN "permitterande" ; -- permitterande..nn.1
  permitterbar_1_A = mkA "permitterbar" ; -- permitterbar..av.1
  permitterbarhet_1_N = mkN "permitterbarhet" ; -- permitterbarhet..nn.1
  permittering_1_N = mkN "permittering" ; -- permittering..nn.1
  permobil_1_N = mkN "permobil" "permobiler" ; -- permobil..nn.1
  permutation_1_N = mkN "permutation" ; -- permutation..nn.1
  permutationsrätt_1_N = mkN "permutationsrätt" ; -- permutationsrätt..nn.1
  permutera_1_V = mkV "permuterar" ; -- permutera..vb.1
  permuterande_1_N = mkN "permuterande" ; -- permuterande..nn.1
  permuterbar_1_A = mkA "permuterbar" ; -- permuterbar..av.1
  permuterbarhet_1_N = mkN "permuterbarhet" ; -- permuterbarhet..nn.1
  permutering_1_N = mkN "permutering" ; -- permutering..nn.1
  perniciös_1_A = mkA "perniciös" ; -- perniciös..av.1
  peroxid_1_N = mkN "peroxid" "peroxider" ; -- peroxid..nn.1
  perpendikel_1_N = mkN "perpendikel" ; -- perpendikel..nn.1
  perpendikulär_1_A = mkA "perpendikulär" ; -- perpendikulär..av.1
  perpetuell_1_A = mkA "perpetuell" ; -- perpetuell..av.1
  perplex_1_A = mkA "perplex" ; -- perplex..av.1
  perplexhet_1_N = mkN "perplexhet" ; -- perplexhet..nn.1
  perrong_1_N = mkN "perrong" "perronger" ; -- perrong..nn.1
  perrongkant_1_N = mkN "perrongkant" "perrongkanter" ; -- perrongkant..nn.1
  pers_1_N = mkN "pers" ; -- pers..nn.1
  pers_2_N = mkN "pers" neutrum  ; -- pers..nn.2
  persedel_1_N = mkN "persedel" ; -- persedel..nn.1
  persedelpåse_1_N = mkN "persedelpåse" utrum  ; -- persedelpåse..nn.1
  persedelvård_1_N = mkN "persedelvård" ; -- persedelvård..nn.1
  perser_1_N = mkN "perser" "persern" "perser" "perserna" ; -- perser..nn.1
  perseveration_1_N = mkN "perseveration" ; -- perseveration..nn.1
  persian_1_N = mkN "persian" ; -- persian..nn.1
  persianpäls_1_N = mkN "persianpäls" ; -- persianpäls..nn.1
  persienn_1_N = mkN "persienn" "persienner" ; -- persienn..nn.1
  persiennglipa_1_N = mkN "persiennglipa" ; -- persiennglipa..nn.1
  persiflage_1_N = mkN "persiflage" ; -- persiflage..nn.1
  persiflera_1_V = mkV "persiflerar" ; -- persiflera..vb.1
  persiflerande_1_N = mkN "persiflerande" ; -- persiflerande..nn.1
  persiflerbar_1_A = mkA "persiflerbar" ; -- persiflerbar..av.1
  persiflerbarhet_1_N = mkN "persiflerbarhet" ; -- persiflerbarhet..nn.1
  persiflering_1_N = mkN "persiflering" ; -- persiflering..nn.1
  persika_1_N = mkN "persika" ; -- persika..nn.1
  persikofärgad_1_A = mkA "persikofärgad" ; -- persikofärgad..av.1
  persilja_1_N = mkN "persilja" ; -- persilja..nn.1
  persiljesmör_1_N = mkN "persiljesmör" neutrum  ; -- persiljesmör..nn.1
  persimon_1_N = mkN "persimon" "persimoner" ; -- persimon..nn.1
  persisk_1_A = mkA "persisk" ; -- persisk..av.1
  persiska_1_N = mkN "persiska" ; -- persiska..nn.1
  persiska_2_N = mkN "persiska" ; -- persiska..nn.2
  person_1_N = mkN "person" "personer" ; -- person..nn.1
  personage_1_N = mkN "personage" "personager" ; -- personage..nn.1
  personal_1_N = mkN "personal" "personaler" ; -- personal..nn.1
  personal_2_N = mkN "personal" "personalen" "personal" "personalen" ; -- personal..nn.2
  personalansvar_1_N = mkN "personalansvar" neutrum  ; -- personalansvar..nn.1
  personalansvarig_1_A = mkA "personalansvarig" ; -- personalansvarig..av.1
  personalansvarsnämnd_1_N = mkN "personalansvarsnämnd" "personalansvarsnämnder" ; -- personalansvarsnämnd..nn.1
  personalavdelning_1_N = mkN "personalavdelning" ; -- personalavdelning..nn.1
  personalbehov_1_N = mkN "personalbehov" neutrum  ; -- personalbehov..nn.1
  personalblad_1_N = mkN "personalblad" neutrum  ; -- personalblad..nn.1
  personalbrist_1_N = mkN "personalbrist" ; -- personalbrist..nn.1
  personalchef_1_N = mkN "personalchef" "personalchefer" ; -- personalchef..nn.1
  personalerfarenhet_1_N = mkN "personalerfarenhet" "personalerfarenheter" ; -- personalerfarenhet..nn.1
  personalfråga_1_N = mkN "personalfråga" ; -- personalfråga..nn.1
  personalia_1_N = mkN "personalia" "personaliat" "personalia" "personaliana" ; -- personalia..nn.1
  personalingång_1_N = mkN "personalingång" ; -- personalingång..nn.1
  personalism_1_N = mkN "personalism" "personalismer" ; -- personalism..nn.1
  personalistisk_1_A = mkA "personalistisk" ; -- personalistisk..av.1
  personalkostnad_1_N = mkN "personalkostnad" "personalkostnader" ; -- personalkostnad..nn.1
  personalkrävande_1_A = mkA "personalkrävande" ; -- personalkrävande..av.1
  personalläkare_1_N = mkN "personalläkare" utrum  ; -- personalläkare..nn.1
  personalmatsal_1_N = mkN "personalmatsal" ; -- personalmatsal..nn.1
  personalmässig_1_A = mkA "personalmässig" ; -- personalmässig..av.1
  personalorganisation_1_N = mkN "personalorganisation" ; -- personalorganisation..nn.1
  personalpolitik_1_N = mkN "personalpolitik" ; -- personalpolitik..nn.1
  personalpolitisk_1_A = mkA "personalpolitisk" ; -- personalpolitisk..av.1
  personalpool_1_N = mkN "personalpool" "personalpooler" ; -- personalpool..nn.1
  personalrum_1_N = mkN "personalrum" "personalrummet" "personalrum" "personalrummen" ; -- personalrum..nn.1
  personalstyrka_1_N = mkN "personalstyrka" ; -- personalstyrka..nn.1
  personaltidning_1_N = mkN "personaltidning" ; -- personaltidning..nn.1
  personaltäthet_1_N = mkN "personaltäthet" "personaltätheter" ; -- personaltäthet..nn.1
  personalunion_1_N = mkN "personalunion" ; -- personalunion..nn.1
  personalutbildare_1_N = mkN "personalutbildare" utrum  ; -- personalutbildare..nn.1
  personalutbildning_1_N = mkN "personalutbildning" ; -- personalutbildning..nn.1
  personalvård_1_N = mkN "personalvård" ; -- personalvård..nn.1
  personattack_1_N = mkN "personattack" "personattacker" ; -- personattack..nn.1
  personbeskrivning_1_N = mkN "personbeskrivning" ; -- personbeskrivning..nn.1
  personbevis_1_N = mkN "personbevis" neutrum  ; -- personbevis..nn.1
  personbil_1_N = mkN "personbil" ; -- personbil..nn.1
  personbilsvolym_1_N = mkN "personbilsvolym" "personbilsvolymer" ; -- personbilsvolym..nn.1
  personbästa_1_N = mkN "personbästa" "personbästat" "personbästan" "personbästana" ; -- personbästa..nn.1
  personcertifiering_1_N = mkN "personcertifiering" ; -- personcertifiering..nn.1
  personcertifikat_1_N = mkN "personcertifikat" neutrum  ; -- personcertifikat..nn.1
  persondator_1_N = mkN "persondator" "persondatorer" ; -- persondator..nn.1
  personell_1_A = mkA "personell" ; -- personell..av.1
  personfixerad_1_A = mkA "personfixerad" ; -- personfixerad..av.1
  personfråga_1_N = mkN "personfråga" ; -- personfråga..nn.1
  personförsäkring_1_N = mkN "personförsäkring" ; -- personförsäkring..nn.1
  persongalleri_1_N = mkN "persongalleri" "persongalleriet" "persongallerier" "persongallerierna" ; -- persongalleri..nn.1
  personhistoria_1_N = mkN "personhistoria" ; -- personhistoria..nn.1
  personhistorisk_1_A = mkA "personhistorisk" ; -- personhistorisk..av.1
  personifiera_1_V = mkV "personifierar" ; -- personifiera..vb.1
  personifierande_1_N = mkN "personifierande" ; -- personifierande..nn.1
  personifierbar_1_A = mkA "personifierbar" ; -- personifierbar..av.1
  personifierbarhet_1_N = mkN "personifierbarhet" ; -- personifierbarhet..nn.1
  personifiering_1_N = mkN "personifiering" ; -- personifiering..nn.1
  personifikation_1_N = mkN "personifikation" ; -- personifikation..nn.1
  personintervju_1_N = mkN "personintervju" "personintervjun" "personintervjuer" "personintervjuerna" ; -- personintervju..nn.1
  personkemi_1_N = mkN "personkemi" ; -- personkemi..nn.1
  personkilometer_1_N = mkN "personkilometer" "personkilometern" "personkilometer" "personkilometerna" ; -- personkilometer..nn.1
  personkontakt_1_N = mkN "personkontakt" "personkontakter" ; -- personkontakt..nn.1
  personkonto_1_N = mkN "personkonto" "personkontot" "personkonton" "personkontona" ; -- personkonto..nn.1
  personkryssa_1_V = mkV "personkryssar" ; -- personkryssa..vb.1
  personkryssande_1_N = mkN "personkryssande" ; -- personkryssande..nn.1
  personkryssning_1_N = mkN "personkryssning" ; -- personkryssning..nn.1
  personkult_1_N = mkN "personkult" "personkulter" ; -- personkult..nn.1
  personlig_1_A = mkA "personlig" ; -- personlig..av.1
  personligen_1_Adv = mkAdv "personligen" ; -- personligen..ab.1
  personlighet_1_N = mkN "personlighet" "personligheter" ; -- personlighet..nn.1
  personlighet_2_N = mkN "personlighet" ; -- personlighet..nn.2
  personlighetsdrag_1_N = mkN "personlighetsdrag" neutrum  ; -- personlighetsdrag..nn.1
  personlighetsförändrande_1_A = mkA "personlighetsförändrande" ; -- personlighetsförändrande..av.1
  personlighetsklyvning_1_N = mkN "personlighetsklyvning" ; -- personlighetsklyvning..nn.1
  personlighetsmässig_1_A = mkA "personlighetsmässig" ; -- personlighetsmässig..av.1
  personlighetsstörning_1_N = mkN "personlighetsstörning" ; -- personlighetsstörning..nn.1
  personlighetstest_1_N = mkN "personlighetstest" neutrum  ; -- personlighetstest..nn.1
  personlighetstyp_1_N = mkN "personlighetstyp" "personlighetstyper" ; -- personlighetstyp..nn.1
  personmässig_1_A = mkA "personmässig" ; -- personmässig..av.1
  personnamn_1_N = mkN "personnamn" neutrum  ; -- personnamn..nn.1
  personnummer_1_N = mkN "personnummer" neutrum  ; -- personnummer..nn.1
  personpolitik_1_N = mkN "personpolitik" ; -- personpolitik..nn.1
  personpolitisk_1_A = mkA "personpolitisk" ; -- personpolitisk..av.1
  personregister_1_N = mkN "personregister" neutrum  ; -- personregister..nn.1
  personrån_1_N = mkN "personrån" neutrum  ; -- personrån..nn.1
  personrösta_1_V = mkV "personröstar" ; -- personrösta..vb.1
  personsammansättning_1_N = mkN "personsammansättning" ; -- personsammansättning..nn.1
  personskada_1_N = mkN "personskada" ; -- personskada..nn.1
  personsökare_1_N = mkN "personsökare" utrum  ; -- personsökare..nn.1
  persontrafik_1_N = mkN "persontrafik" ; -- persontrafik..nn.1
  persontrakasseri_1_N = mkN "persontrakasseri" "persontrakasseriet" "persontrakasserier" "persontrakasserierna" ; -- persontrakasseri..nn.1
  persontyp_1_N = mkN "persontyp" "persontyper" ; -- persontyp..nn.1
  persontåg_1_N = mkN "persontåg" neutrum  ; -- persontåg..nn.1
  personundersökning_1_N = mkN "personundersökning" ; -- personundersökning..nn.1
  personuppgift_1_N = mkN "personuppgift" "personuppgifter" ; -- personuppgift..nn.1
  personuppklarad_1_A = mkA "personuppklarad" ; -- personuppklarad..av.1
  personvagn_1_N = mkN "personvagn" ; -- personvagn..nn.1
  personval_1_N = mkN "personval" neutrum  ; -- personval..nn.1
  personvalskampanj_1_N = mkN "personvalskampanj" "personvalskampanjer" ; -- personvalskampanj..nn.1
  personvåg_1_N = mkN "personvåg" ; -- personvåg..nn.1
  perspektiv_1_N = mkN "perspektiv" neutrum  ; -- perspektiv..nn.1
  perspektivbild_1_N = mkN "perspektivbild" "perspektivbilder" ; -- perspektivbild..nn.1
  perspektivfönster_1_N = mkN "perspektivfönster" neutrum  ; -- perspektivfönster..nn.1
  perspektivförflyttning_1_N = mkN "perspektivförflyttning" ; -- perspektivförflyttning..nn.1
  perspektivförskjutning_1_N = mkN "perspektivförskjutning" ; -- perspektivförskjutning..nn.1
  perspektivisk_1_A = mkA "perspektivisk" ; -- perspektivisk..av.1
  perspektivlös_1_A = mkA "perspektivlös" ; -- perspektivlös..av.1
  perspektivlöshet_1_N = mkN "perspektivlöshet" ; -- perspektivlöshet..nn.1
  perspektivmässig_1_A = mkA "perspektivmässig" ; -- perspektivmässig..av.1
  perspektivskapande_1_A = mkA "perspektivskapande" ; -- perspektivskapande..av.1
  perspektivskifte_1_N = mkN "perspektivskifte" ; -- perspektivskifte..nn.1
  perstorpsplatta_1_N = mkN "perstorpsplatta" ; -- perstorpsplatta..nn.1
  perstorpsskiva_1_N = mkN "perstorpsskiva" ; -- perstorpsskiva..nn.1
  persvadera_1_V = mkV "persvaderar" ; -- persvadera..vb.1
  persvaderande_1_N = mkN "persvaderande" ; -- persvaderande..nn.1
  persvaderbar_1_A = mkA "persvaderbar" ; -- persvaderbar..av.1
  persvaderbarhet_1_N = mkN "persvaderbarhet" ; -- persvaderbarhet..nn.1
  persvadering_1_N = mkN "persvadering" ; -- persvadering..nn.1
  perturbation_1_N = mkN "perturbation" ; -- perturbation..nn.1
  perturbera_1_V = mkV "perturberar" ; -- perturbera..vb.1
  perturberande_1_N = mkN "perturberande" ; -- perturberande..nn.1
  peruan_1_N = mkN "peruan" "peruaner" ; -- peruan..nn.1
  peruansk_1_A = mkA "peruansk" ; -- peruansk..av.1
  peruanska_1_N = mkN "peruanska" ; -- peruanska..nn.1
  peruk_1_N = mkN "peruk" "peruker" ; -- peruk..nn.1
  perukbråk_1_N = mkN "perukbråk" neutrum  ; -- perukbråk..nn.1
  perukmakare_1_N = mkN "perukmakare" utrum  ; -- perukmakare..nn.1
  perukstock_1_N = mkN "perukstock" ; -- perukstock..nn.1
  pervers_1_A = mkA "pervers" ; -- pervers..av.1
  pervershet_1_N = mkN "pervershet" ; -- pervershet..nn.1
  perversion_1_N = mkN "perversion" ; -- perversion..nn.1
  perversitet_1_N = mkN "perversitet" "perversiteter" ; -- perversitet..nn.1
  pervertera_1_V = mkV "perverterar" ; -- pervertera..vb.1
  perverterande_1_N = mkN "perverterande" ; -- perverterande..nn.1
  perverterbar_1_A = mkA "perverterbar" ; -- perverterbar..av.1
  perverterbarhet_1_N = mkN "perverterbarhet" ; -- perverterbarhet..nn.1
  pervertering_1_N = mkN "pervertering" ; -- pervertering..nn.1
  pervo_1_N = mkN "pervo" "pervot" "pervon" "pervona" ; -- pervo..nn.1
  peseta_1_N = mkN "peseta" "pesetan" "pesetas" "pesetasarna" ; -- peseta..nn.1
  peso_1_N = mkN "peso" "pesor" ; -- peso..nn.1
  pessar_1_N = mkN "pessar" neutrum  ; -- pessar..nn.1
  pessimism_1_N = mkN "pessimism" "pessimismer" ; -- pessimism..nn.1
  pessimist_1_N = mkN "pessimist" "pessimister" ; -- pessimist..nn.1
  pessimistisk_1_A = mkA "pessimistisk" ; -- pessimistisk..av.1
  pest_1_N = mkN "pest" "pester" ; -- pest..nn.1
  pestböld_1_N = mkN "pestböld" "pestbölder" ; -- pestböld..nn.1
  pesticid_1_N = mkN "pesticid" "pesticider" ; -- pesticid..nn.1
  pestilens_1_N = mkN "pestilens" "pestilenser" ; -- pestilens..nn.1
  pestilensrot_1_N = mkN "pestilensrot" ; -- pestilensrot..nn.1
  pesto_1_N = mkN "pesto" ; -- pesto..nn.1
  pestskråp_1_N = mkN "pestskråp" ; -- pestskråp..nn.1
  pet_1_N = mkN "pet" neutrum  ; -- pet..nn.1
  peta_1_V = mkV "petar" ; -- peta..vb.1
  peta_2_V = mkV "petar" ; -- peta..vb.2
  petabyte_1_N = mkN "petabyte" "petabyten" "petabyte" "petabytena" ; -- petabyte..nn.1
  petande_1_N = mkN "petande" ; -- petande..nn.1
  peterspenning_1_N = mkN "peterspenning" ; -- peterspenning..nn.1
  petig_1_A = mkA "petig" ; -- petig..av.1
  petighet_1_N = mkN "petighet" ; -- petighet..nn.1
  petimäter_1_N = mkN "petimäter" ; -- petimäter..nn.1
  petit_chou_1_N = mkN "petit-chou" "petit-choun" "petit-chouer" "petit-chouerna" ; -- petit-chou..nn.1
  petit_1_N = mkN "petit" ; -- petit..nn.1
  petita_1_N = mkN "petita" ; -- petita..nn.1
  petitchou_1_N = mkN "petitchou" "petitchoun" "petitchouer" "petitchouerna" ; -- petitchou..nn.1
  petitess_1_N = mkN "petitess" "petitesser" ; -- petitess..nn.1
  petition_1_N = mkN "petition" ; -- petition..nn.1
  petitionera_1_V = mkV "petitionerar" ; -- petitionera..vb.1
  petitionerande_1_N = mkN "petitionerande" ; -- petitionerande..nn.1
  petitionär_1_N = mkN "petitionär" "petitionärer" ; -- petitionär..nn.1
  petitstil_1_N = mkN "petitstil" ; -- petitstil..nn.1
  petmoj_1_N = mkN "petmoj" ; -- petmoj..nn.1
  petning_1_N = mkN "petning" ; -- petning..nn.1
  petnoga_1_A = mkA "petnoga" ; -- petnoga..av.1
  petrifiera_1_V = mkV "petrifierar" ; -- petrifiera..vb.1
  petrifierande_1_N = mkN "petrifierande" ; -- petrifierande..nn.1
  petrifierbar_1_A = mkA "petrifierbar" ; -- petrifierbar..av.1
  petrifierbarhet_1_N = mkN "petrifierbarhet" ; -- petrifierbarhet..nn.1
  petrifiering_1_N = mkN "petrifiering" ; -- petrifiering..nn.1
  petrifikat_1_N = mkN "petrifikat" neutrum  ; -- petrifikat..nn.1
  petriskål_1_N = mkN "petriskål" ; -- petriskål..nn.1
  petrografi_1_N = mkN "petrografi" ; -- petrografi..nn.1
  petrokemisk_1_A = mkA "petrokemisk" ; -- petrokemisk..av.1
  petroleum_1_N = mkN "petroleum" ; -- petroleum..nn.1
  petroleumbaserad_1_A = mkA "petroleumbaserad" ; -- petroleumbaserad..av.1
  petsäker_1_A = mkA "petsäker" ; -- petsäker..av.1
  petsäkerhet_1_N = mkN "petsäkerhet" ; -- petsäkerhet..nn.1
  petting_1_N = mkN "petting" ; -- petting..nn.1
  petunia_1_N = mkN "petunia" ; -- petunia..nn.1
  pfennig_1_N = mkN "pfennig" "pfennigen" "pfennig" "pfennigen" ; -- pfennig..nn.1
  phi_1_N = mkN "phi" neutrum  ; -- phi..nn.1
  physalis_1_N = mkN "physalis" ; -- physalis..nn.1
  pi_1_N = mkN "pi" neutrum  ; -- pi..nn.1
  piaff_1_N = mkN "piaff" "piaffer" ; -- piaff..nn.1
  pianino_1_N = mkN "pianino" "pianinot" "pianinon" "pianinona" ; -- pianino..nn.1
  pianissimo_1_N = mkN "pianissimo" "pianissimot" "pianissimon" "pianissimona" ; -- pianissimo..nn.1
  pianist_1_N = mkN "pianist" "pianister" ; -- pianist..nn.1
  piano_1_N = mkN "piano" "pianot" "pianon" "pianona" ; -- piano..nn.1
  pianokonsert_1_N = mkN "pianokonsert" "pianokonserter" ; -- pianokonsert..nn.1
  pianola_1_N = mkN "pianola" ; -- pianola..nn.1
  pianolektion_1_N = mkN "pianolektion" ; -- pianolektion..nn.1
  pianomusik_1_N = mkN "pianomusik" ; -- pianomusik..nn.1
  pianopedal_1_N = mkN "pianopedal" "pianopedaler" ; -- pianopedal..nn.1
  pianopling_1_N = mkN "pianopling" neutrum  ; -- pianopling..nn.1
  pianosonat_1_N = mkN "pianosonat" "pianosonater" ; -- pianosonat..nn.1
  pianospel_1_N = mkN "pianospel" "pianospelet" "pianospel" "pianospelen" ; -- pianospel..nn.1
  pianospelning_1_N = mkN "pianospelning" ; -- pianospelning..nn.1
  pianostol_1_N = mkN "pianostol" ; -- pianostol..nn.1
  pianotråd_1_N = mkN "pianotråd" ; -- pianotråd..nn.1
  piasavakvast_1_N = mkN "piasavakvast" ; -- piasavakvast..nn.1
  piassava_1_N = mkN "piassava" ; -- piassava..nn.1
  piassavakvast_1_N = mkN "piassavakvast" ; -- piassavakvast..nn.1
  piaster_1_N = mkN "piaster" ; -- piaster..nn.1
  piazza_1_N = mkN "piazza" ; -- piazza..nn.1
  picador_1_N = mkN "picador" "picadoren" "picadorer" "picadorerna" ; -- picador..nn.1
  piccola_1_N = mkN "piccola" ; -- piccola..nn.1
  piccolaflöjt_1_N = mkN "piccolaflöjt" "piccolaflöjter" ; -- piccolaflöjt..nn.1
  piccolo_1_N = mkN "piccolo" "piccolor" ; -- piccolo..nn.1
  pick_1_N = mkN "pick" ; -- pick..nn.1
  picka_1_N = mkN "picka" ; -- picka..nn.1
  picka_1_V = mkV "pickar" ; -- picka..vb.1
  pickadoll_1_N = mkN "pickadoll" "pickadoller" ; -- pickadoll..nn.1
  pickande_1_N = mkN "pickande" ; -- pickande..nn.1
  pickelhuva_1_N = mkN "pickelhuva" ; -- pickelhuva..nn.1
  picknick_1_N = mkN "picknick" ; -- picknick..nn.1
  pickolaflöjt_1_N = mkN "pickolaflöjt" "pickolaflöjter" ; -- pickolaflöjt..nn.1
  pickup_1_N = mkN "pickup" "pickuper" ; -- pickup..nn.1
  picot_1_N = mkN "picot" "picoter" ; -- picot..nn.1
  pidgin_1_N = mkN "pidgin" neutrum  ; -- pidgin..nn.1
  pidginengelska_1_N = mkN "pidginengelska" ; -- pidginengelska..nn.1
  piedestal_1_N = mkN "piedestal" "piedestaler" ; -- piedestal..nn.1
  pierca_1_V = mkV "piercar" ; -- pierca..vb.1
  piercande_1_N = mkN "piercande" ; -- piercande..nn.1
  piercing_1_N = mkN "piercing" ; -- piercing..nn.1
  piercingsmycke_1_N = mkN "piercingsmycke" ; -- piercingsmycke..nn.1
  pierrot_1_N = mkN "pierrot" "pierroter" ; -- pierrot..nn.1
  pietet_1_N = mkN "pietet" "pieteter" ; -- pietet..nn.1
  pietetsfull_1_A = mkA "pietetsfull" ; -- pietetsfull..av.1
  pietetsfullhet_1_N = mkN "pietetsfullhet" ; -- pietetsfullhet..nn.1
  pietetskänsla_1_N = mkN "pietetskänsla" ; -- pietetskänsla..nn.1
  pietetslös_1_A = mkA "pietetslös" ; -- pietetslös..av.1
  pietetslöshet_1_N = mkN "pietetslöshet" ; -- pietetslöshet..nn.1
  pietism_1_N = mkN "pietism" "pietismer" ; -- pietism..nn.1
  pietist_1_N = mkN "pietist" "pietister" ; -- pietist..nn.1
  pietistisk_1_A = mkA "pietistisk" ; -- pietistisk..av.1
  piezoelektricitet_1_N = mkN "piezoelektricitet" "piezoelektriciteter" ; -- piezoelektricitet..nn.1
  piezoelektrisk_1_A = mkA "piezoelektrisk" ; -- piezoelektrisk..av.1
  piff_1_N = mkN "piff" ; -- piff..nn.1
  piffig_1_A = mkA "piffig" ; -- piffig..av.1
  piffighet_1_N = mkN "piffighet" ; -- piffighet..nn.1
  piga_1_N = mkN "piga" ; -- piga..nn.1
  pigavdrag_1_N = mkN "pigavdrag" neutrum  ; -- pigavdrag..nn.1
  pigdebatt_1_N = mkN "pigdebatt" "pigdebatter" ; -- pigdebatt..nn.1
  pigg_1_A = mkA "pigg" ; -- pigg..av.1
  pigg_1_N = mkN "pigg" ; -- pigg..nn.1
  piggelin_1_A = mkA "piggelin" ; -- piggelin..av.1
  pigghaj_1_N = mkN "pigghaj" ; -- pigghaj..nn.1
  pigghet_1_N = mkN "pigghet" ; -- pigghet..nn.1
  piggsvin_1_N = mkN "piggsvin" neutrum  ; -- piggsvin..nn.1
  piggvar_1_N = mkN "piggvar" ; -- piggvar..nn.1
  pigment_1_N = mkN "pigment" neutrum  ; -- pigment..nn.1
  pigmenterad_1_A = mkA "pigmenterad" ; -- pigmenterad..av.1
  pigmentering_1_N = mkN "pigmentering" ; -- pigmentering..nn.1
  pigroman_1_N = mkN "pigroman" "pigromaner" ; -- pigroman..nn.1
  pigtittare_1_N = mkN "pigtittare" utrum  ; -- pigtittare..nn.1
  pigtjusare_1_N = mkN "pigtjusare" utrum  ; -- pigtjusare..nn.1
  pik_1_N = mkN "pik" ; -- pik..nn.1
  pika_1_V = mkV "pikar" ; -- pika..vb.1
  pikador_1_N = mkN "pikador" "pikadoren" "pikadorer" "pikadorerna" ; -- pikador..nn.1
  pikande_1_N = mkN "pikande" ; -- pikande..nn.1
  pikant_1_A = mkA "pikant" "pikant" ; -- pikant..av.1
  pikanteri_1_N = mkN "pikanteri" "pikanteriet" "pikanterier" "pikanterierna" ; -- pikanteri..nn.1
  pikantsås_1_N = mkN "pikantsås" ; -- pikantsås..nn.1
  pikaresk_1_N = mkN "pikaresk" "pikaresker" ; -- pikaresk..nn.1
  pikareskroman_1_N = mkN "pikareskroman" "pikareskromaner" ; -- pikareskroman..nn.1
  pikera_1_V = mkV "pikerar" ; -- pikera..vb.1
  pikerande_1_N = mkN "pikerande" ; -- pikerande..nn.1
  pikerbar_1_A = mkA "pikerbar" ; -- pikerbar..av.1
  pikerbarhet_1_N = mkN "pikerbarhet" ; -- pikerbarhet..nn.1
  pikering_1_N = mkN "pikering" ; -- pikering..nn.1
  piket_1_N = mkN "piket" "piketer" ; -- piket..nn.1
  piketbil_1_N = mkN "piketbil" ; -- piketbil..nn.1
  pikhacka_1_N = mkN "pikhacka" ; -- pikhacka..nn.1
  pikkadoll_1_N = mkN "pikkadoll" "pikkadoller" ; -- pikkadoll..nn.1
  pikrinsyra_1_N = mkN "pikrinsyra" ; -- pikrinsyra..nn.1
  pikstav_1_N = mkN "pikstav" ; -- pikstav..nn.1
  piktogram_1_N = mkN "piktogram" "piktogrammet" "piktogram" "piktogrammen" ; -- piktogram..nn.1
  piktur_1_N = mkN "piktur" "pikturer" ; -- piktur..nn.1
  pikyxa_1_N = mkN "pikyxa" ; -- pikyxa..nn.1
  piké_1_N = mkN "piké" "pikéer" ; -- piké..nn.1
  pikémönster_1_N = mkN "pikémönster" neutrum  ; -- pikémönster..nn.1
  pikör_1_N = mkN "pikör" "pikörer" ; -- pikör..nn.1
  pil_1_N = mkN "pil" ; -- pil..nn.1
  pila_1_V = mkV "pilar" ; -- pila..vb.1
  pilaff_1_N = mkN "pilaff" "pilaffer" ; -- pilaff..nn.1
  pilallé_1_N = mkN "pilallé" "pilalléer" ; -- pilallé..nn.1
  pilande_1_N = mkN "pilande" ; -- pilande..nn.1
  pilaster_1_N = mkN "pilaster" ; -- pilaster..nn.1
  pilbåge_1_N = mkN "pilbåge" utrum  ; -- pilbåge..nn.1
  pilfink_1_N = mkN "pilfink" ; -- pilfink..nn.1
  pilformig_1_A = mkA "pilformig" ; -- pilformig..av.1
  pilgift_1_N = mkN "pilgift" neutrum  ; -- pilgift..nn.1
  pilgrim_1_N = mkN "pilgrim" "pilgrimer" ; -- pilgrim..nn.1
  pilgrimsfalk_1_N = mkN "pilgrimsfalk" ; -- pilgrimsfalk..nn.1
  pilgrimsfärd_1_N = mkN "pilgrimsfärd" "pilgrimsfärder" ; -- pilgrimsfärd..nn.1
  pilgrimsmål_1_N = mkN "pilgrimsmål" neutrum  ; -- pilgrimsmål..nn.1
  pilgrimsstav_1_N = mkN "pilgrimsstav" ; -- pilgrimsstav..nn.1
  pilk_1_N = mkN "pilk" ; -- pilk..nn.1
  pilka_1_V = mkV "pilkar" ; -- pilka..vb.1
  pilkande_1_N = mkN "pilkande" ; -- pilkande..nn.1
  pilkastning_1_N = mkN "pilkastning" ; -- pilkastning..nn.1
  pilkoger_1_N = mkN "pilkoger" neutrum  ; -- pilkoger..nn.1
  pill_1_N = mkN "pill" neutrum  ; -- pill..nn.1
  pilla_1_V = mkV "pillar" ; -- pilla..vb.1
  pillande_1_N = mkN "pillande" ; -- pillande..nn.1
  pilleknarkare_1_N = mkN "pilleknarkare" utrum  ; -- pilleknarkare..nn.1
  pillemarisk_1_A = mkA "pillemarisk" ; -- pillemarisk..av.1
  piller_1_N = mkN "piller" neutrum  ; -- piller..nn.1
  pillerbagge_1_N = mkN "pillerbagge" utrum  ; -- pillerbagge..nn.1
  pillerburk_1_N = mkN "pillerburk" ; -- pillerburk..nn.1
  pillertrillare_1_N = mkN "pillertrillare" utrum  ; -- pillertrillare..nn.1
  pillra_1_V = mkV "pillrar" ; -- pillra..vb.1
  pillrande_1_N = mkN "pillrande" ; -- pillrande..nn.1
  pillrig_1_A = mkA "pillrig" ; -- pillrig..av.1
  pillrighet_1_N = mkN "pillrighet" ; -- pillrighet..nn.1
  pilot_1_N = mkN "pilot" "piloter" ; -- pilot..nn.1
  pilotballong_1_N = mkN "pilotballong" "pilotballonger" ; -- pilotballong..nn.1
  pilotfall_1_N = mkN "pilotfall" neutrum  ; -- pilotfall..nn.1
  pilotjacka_1_N = mkN "pilotjacka" ; -- pilotjacka..nn.1
  pilotprojekt_1_N = mkN "pilotprojekt" neutrum  ; -- pilotprojekt..nn.1
  pilotstrejk_1_N = mkN "pilotstrejk" "pilotstrejker" ; -- pilotstrejk..nn.1
  pilotstudie_1_N = mkN "pilotstudie" "pilotstudier" ; -- pilotstudie..nn.1
  pilotundersökning_1_N = mkN "pilotundersökning" ; -- pilotundersökning..nn.1
  pilsk_1_A = mkA "pilsk" ; -- pilsk..av.1
  pilskhet_1_N = mkN "pilskhet" ; -- pilskhet..nn.1
  pilsnabb_1_A = mkA "pilsnabb" ; -- pilsnabb..av.1
  pilsnabbhet_1_N = mkN "pilsnabbhet" ; -- pilsnabbhet..nn.1
  pilsner_1_N = mkN "pilsner" "pilsnern" "pilsner" "pilsnerna" ; -- pilsner..nn.1
  pilsnerfilm_1_N = mkN "pilsnerfilm" "pilsnerfilmer" ; -- pilsnerfilm..nn.1
  pilsnerflaska_1_N = mkN "pilsnerflaska" ; -- pilsnerflaska..nn.1
  pilsnerkorv_1_N = mkN "pilsnerkorv" ; -- pilsnerkorv..nn.1
  pilspets_1_N = mkN "pilspets" ; -- pilspets..nn.1
  pilt_1_N = mkN "pilt" ; -- pilt..nn.1
  piltavla_1_N = mkN "piltavla" ; -- piltavla..nn.1
  pilträd_1_N = mkN "pilträd" neutrum  ; -- pilträd..nn.1
  pilört_1_N = mkN "pilört" ; -- pilört..nn.1
  pimpa_1_V = mkV "pimpar" ; -- pimpa..vb.1
  pimpande_1_N = mkN "pimpande" ; -- pimpande..nn.1
  pimpel_1_N = mkN "pimpel" ; -- pimpel..nn.1
  pimpelfiske_1_N = mkN "pimpelfiske" ; -- pimpelfiske..nn.1
  pimpelspö_1_N = mkN "pimpelspö" "pimpelspöt" "pimpelspön" "pimpelspöna" ; -- pimpelspö..nn.1
  pimpinella_1_N = mkN "pimpinella" ; -- pimpinella..nn.1
  pimpinett_1_A = mkA "pimpinett" ; -- pimpinett..av.1
  pimpinetthet_1_N = mkN "pimpinetthet" ; -- pimpinetthet..nn.1
  pimpla_1_V = mkV "pimplar" ; -- pimpla..vb.1
  pimplande_1_N = mkN "pimplande" ; -- pimplande..nn.1
  pimpning_1_N = mkN "pimpning" ; -- pimpning..nn.1
  pina_1_N = mkN "pina" ; -- pina..nn.1
  pina_1_V = mkV "pinar" ; -- pina..vb.1
  pinakotek_1_N = mkN "pinakotek" neutrum  ; -- pinakotek..nn.1
  pinal_1_N = mkN "pinal" "pinaler" ; -- pinal..nn.1
  pinande_1_A = mkA "pinande" ; -- pinande..av.1
  pinande_1_N = mkN "pinande" ; -- pinande..nn.1
  pinbänk_1_N = mkN "pinbänk" ; -- pinbänk..nn.1
  pincené_1_N = mkN "pincené" "pincenéer" ; -- pincené..nn.1
  pincera_1_V = mkV "pincerar" ; -- pincera..vb.1
  pincerande_1_N = mkN "pincerande" ; -- pincerande..nn.1
  pincerbar_1_A = mkA "pincerbar" ; -- pincerbar..av.1
  pincerbarhet_1_N = mkN "pincerbarhet" ; -- pincerbarhet..nn.1
  pincering_1_N = mkN "pincering" ; -- pincering..nn.1
  pincett_1_N = mkN "pincett" "pincetter" ; -- pincett..nn.1
  pinfärsk_1_A = mkA "pinfärsk" ; -- pinfärsk..av.1
  ping_pong_1_N = mkN "ping-pong" ; -- ping-pong..nn.1
  ping_pongboll_1_N = mkN "ping-pongboll" ; -- ping-pongboll..nn.1
  pingel_1_N = mkN "pingel" neutrum  ; -- pingel..nn.1
  pingis_1_N = mkN "pingis" ; -- pingis..nn.1
  pingla_1_N = mkN "pingla" ; -- pingla..nn.1
  pingla_1_V = mkV "pinglar" ; -- pingla..vb.1
  pinglande_1_N = mkN "pinglande" ; -- pinglande..nn.1
  pingpong_1_N = mkN "pingpong" ; -- pingpong..nn.1
  pingpongboll_1_N = mkN "pingpongboll" ; -- pingpongboll..nn.1
  pingst_1_N = mkN "pingst" ; -- pingst..nn.1
  pingstafton_1_N = mkN "pingstafton" "pingstaftonen" "pingstaftnar" "pingstaftnarna" ; -- pingstafton..nn.1
  pingstdag_1_N = mkN "pingstdag" ; -- pingstdag..nn.1
  pingsthelg_1_N = mkN "pingsthelg" "pingsthelger" ; -- pingsthelg..nn.1
  pingstlilja_1_N = mkN "pingstlilja" ; -- pingstlilja..nn.1
  pingstpastor_1_N = mkN "pingstpastor" "pingstpastorer" ; -- pingstpastor..nn.1
  pingströrelse_1_N = mkN "pingströrelse" utrum  ; -- pingströrelse..nn.1
  pingstvän_1_N = mkN "pingstvän" "pingstvännen" "pingstvänner" "pingstvännerna" ; -- pingstvän..nn.1
  pingstvänlig_1_A = mkA "pingstvänlig" ; -- pingstvänlig..av.1
  pingstvänlighet_1_N = mkN "pingstvänlighet" ; -- pingstvänlighet..nn.1
  pingvin_1_N = mkN "pingvin" "pingviner" ; -- pingvin..nn.1
  pingvinturist_1_N = mkN "pingvinturist" "pingvinturister" ; -- pingvinturist..nn.1
  pinig_1_A = mkA "pinig" ; -- pinig..av.1
  pinighet_1_N = mkN "pinighet" "pinigheter" ; -- pinighet..nn.1
  pinje_1_N = mkN "pinje" "pinjer" ; -- pinje..nn.1
  pinjenöt_1_N = mkN "pinjenöt" "pinjenötter" ; -- pinjenöt..nn.1
  pinjong_1_N = mkN "pinjong" "pinjonger" ; -- pinjong..nn.1
  pink_1_N = mkN "pink" neutrum  ; -- pink..nn.1
  pinka_1_V = mkV "pinkar" ; -- pinka..vb.1
  pinkande_1_N = mkN "pinkande" ; -- pinkande..nn.1
  pinkning_1_N = mkN "pinkning" ; -- pinkning..nn.1
  pinknödig_1_A = mkA "pinknödig" ; -- pinknödig..av.1
  pinknödighet_1_N = mkN "pinknödighet" ; -- pinknödighet..nn.1
  pinkod_1_N = mkN "pinkod" "pinkoder" ; -- pinkod..nn.1
  pinlig_1_A = mkA "pinlig" ; -- pinlig..av.1
  pinlighet_1_N = mkN "pinlighet" "pinligheter" ; -- pinlighet..nn.1
  pinna_1_V = mkV "pinnar" ; -- pinna..vb.1
  pinna_2_V = mkV "pinnar" ; -- pinna..vb.2
  pinnande_1_N = mkN "pinnande" ; -- pinnande..nn.1
  pinne_1_N = mkN "pinne" utrum  ; -- pinne..nn.1
  pinnharv_1_N = mkN "pinnharv" ; -- pinnharv..nn.1
  pinnhål_1_N = mkN "pinnhål" neutrum  ; -- pinnhål..nn.1
  pinnig_1_A = mkA "pinnig" ; -- pinnig..av.1
  pinnighet_1_N = mkN "pinnighet" ; -- pinnighet..nn.1
  pinnmo_1_N = mkN "pinnmo" ; -- pinnmo..nn.1
  pinnsmal_1_A = mkA "pinnsmal" ; -- pinnsmal..av.1
  pinnsoffa_1_N = mkN "pinnsoffa" ; -- pinnsoffa..nn.1
  pinnstol_1_N = mkN "pinnstol" ; -- pinnstol..nn.1
  pinnved_1_N = mkN "pinnved" ; -- pinnved..nn.1
  pinoande_1_N = mkN "pinoande" utrum  ; -- pinoande..nn.1
  pinobänk_1_N = mkN "pinobänk" ; -- pinobänk..nn.1
  pinoredskap_1_N = mkN "pinoredskap" neutrum  ; -- pinoredskap..nn.1
  pinorum_1_N = mkN "pinorum" "pinorummet" "pinorum" "pinorummen" ; -- pinorum..nn.1
  pinrök_1_N = mkN "pinrök" ; -- pinrök..nn.1
  pinsam_1_A = mkA "pinsam" "pinsamt" "pinsamma" "pinsamma" "pinsammare" "pinsammast" "pinsammaste" ; -- pinsam..av.1
  pinsamhet_1_N = mkN "pinsamhet" "pinsamheter" ; -- pinsamhet..nn.1
  pinscher_1_N = mkN "pinscher" ; -- pinscher..nn.1
  pinupbild_1_N = mkN "pinupbild" "pinupbilder" ; -- pinupbild..nn.1
  pinuppa_1_N = mkN "pinuppa" ; -- pinuppa..nn.1
  pion_1_N = mkN "pion" ; -- pion..nn.1
  pionjär_1_N = mkN "pionjär" "pionjärer" ; -- pionjär..nn.1
  pionjärmässig_1_A = mkA "pionjärmässig" ; -- pionjärmässig..av.1
  pionröd_1_A = mkA "pionröd" "pionrött" ; -- pionröd..av.1
  pip_1_N = mkN "pip" ; -- pip..nn.1
  pip_2_N = mkN "pip" neutrum  ; -- pip..nn.2
  pipa_1_N = mkN "pipa" ; -- pipa..nn.1
  pipa_1_V = mkV "pipa" "pep" "pipit" ; -- pipa..vb.1
  pipande_1_N = mkN "pipande" ; -- pipande..nn.1
  pipare_1_N = mkN "pipare" utrum  ; -- pipare..nn.1
  pipeline_1_N = mkN "pipeline" "pipeliner" ; -- pipeline..nn.1
  pipett_1_N = mkN "pipett" "pipetter" ; -- pipett..nn.1
  piphas_1_N = mkN "piphas" ; -- piphas..nn.1
  piphuvud_1_N = mkN "piphuvud" "piphuvudet" "piphuvud" "piphuvudena" ; -- piphuvud..nn.1
  pipig_1_A = mkA "pipig" ; -- pipig..av.1
  pipighet_1_N = mkN "pipighet" ; -- pipighet..nn.1
  pipkrage_1_N = mkN "pipkrage" utrum  ; -- pipkrage..nn.1
  piplukt_1_N = mkN "piplukt" ; -- piplukt..nn.1
  piplängd_1_N = mkN "piplängd" "piplängder" ; -- piplängd..nn.1
  piplärka_1_N = mkN "piplärka" ; -- piplärka..nn.1
  pipolja_1_N = mkN "pipolja" ; -- pipolja..nn.1
  pippa_1_V = mkV "pippar" ; -- pippa..vb.1
  pippande_1_N = mkN "pippande" ; -- pippande..nn.1
  pippi_1_N = mkN "pippi" "pippin" "pippiar" "pippiarna" ; -- pippi..nn.1
  pipping_1_N = mkN "pipping" ; -- pipping..nn.1
  piprensare_1_N = mkN "piprensare" utrum  ; -- piprensare..nn.1
  piprökande_1_A = mkA "piprökande" ; -- piprökande..av.1
  piprökande_1_N = mkN "piprökande" ; -- piprökande..nn.1
  piprökare_1_N = mkN "piprökare" utrum  ; -- piprökare..nn.1
  pipskaft_1_N = mkN "pipskaft" neutrum  ; -- pipskaft..nn.1
  pipskägg_1_N = mkN "pipskägg" neutrum  ; -- pipskägg..nn.1
  pipspännare_1_N = mkN "pipspännare" utrum  ; -- pipspännare..nn.1
  pipstopp_1_N = mkN "pipstopp" ; -- pipstopp..nn.1
  pipstoppare_1_N = mkN "pipstoppare" utrum  ; -- pipstoppare..nn.1
  pipsvamp_1_N = mkN "pipsvamp" ; -- pipsvamp..nn.1
  piptobak_1_N = mkN "piptobak" ; -- piptobak..nn.1
  pipverk_1_N = mkN "pipverk" neutrum  ; -- pipverk..nn.1
  pir_1_N = mkN "pir" ; -- pir..nn.1
  pirat_1_N = mkN "pirat" "pirater" ; -- pirat..nn.1
  piratbyxa_1_N = mkN "piratbyxa" ; -- piratbyxa..nn.1
  piratkopiera_1_V = mkV "piratkopierar" ; -- piratkopiera..vb.1
  piratkopierande_1_N = mkN "piratkopierande" ; -- piratkopierande..nn.1
  piratkopiering_1_N = mkN "piratkopiering" ; -- piratkopiering..nn.1
  piratsändare_1_N = mkN "piratsändare" utrum  ; -- piratsändare..nn.1
  piraya_1_N = mkN "piraya" ; -- piraya..nn.1
  pirhuvud_1_N = mkN "pirhuvud" "pirhuvudet" "pirhuvud" "pirhuvudena" ; -- pirhuvud..nn.1
  pirk_1_N = mkN "pirk" ; -- pirk..nn.1
  pirka_1_N = mkN "pirka" ; -- pirka..nn.1
  pirka_1_V = mkV "pirkar" ; -- pirka..vb.1
  pirkande_1_N = mkN "pirkande" ; -- pirkande..nn.1
  pirog_1_N = mkN "pirog" "piroger" ; -- pirog..nn.1
  pirra_1_N = mkN "pirra" ; -- pirra..nn.1
  pirra_1_V = mkV "pirrar" ; -- pirra..vb.1
  pirrande_1_N = mkN "pirrande" ; -- pirrande..nn.1
  pirrig_1_A = mkA "pirrig" ; -- pirrig..av.1
  pirrighet_1_N = mkN "pirrighet" ; -- pirrighet..nn.1
  piruett_1_N = mkN "piruett" "piruetter" ; -- piruett..nn.1
  piruettera_1_V = mkV "piruetterar" ; -- piruettera..vb.1
  piruetterande_1_N = mkN "piruetterande" ; -- piruetterande..nn.1
  piruettering_1_N = mkN "piruettering" ; -- piruettering..nn.1
  pirum_1_A = mkA "pirum" ; -- pirum..av.1
  pisk_1_N = mkN "pisk" neutrum  ; -- pisk..nn.1
  piska_1_N = mkN "piska" ; -- piska..nn.1
  piska_1_V = mkV "piskar" ; -- piska..vb.1
  piskad_1_A = mkA "piskad" ; -- piskad..av.1
  piskande_1_N = mkN "piskande" ; -- piskande..nn.1
  piskbalkong_1_N = mkN "piskbalkong" "piskbalkonger" ; -- piskbalkong..nn.1
  piskklatsch_1_N = mkN "piskklatsch" ; -- piskklatsch..nn.1
  piskmask_1_N = mkN "piskmask" ; -- piskmask..nn.1
  piskning_1_N = mkN "piskning" ; -- piskning..nn.1
  piskperuk_1_N = mkN "piskperuk" "piskperuker" ; -- piskperuk..nn.1
  piskrapp_1_N = mkN "piskrapp" neutrum  ; -- piskrapp..nn.1
  piskskaft_1_N = mkN "piskskaft" neutrum  ; -- piskskaft..nn.1
  pisksläng_1_N = mkN "pisksläng" ; -- pisksläng..nn.1
  pisksnärt_1_N = mkN "pisksnärt" ; -- pisksnärt..nn.1
  pisksnärtoperation_1_N = mkN "pisksnärtoperation" ; -- pisksnärtoperation..nn.1
  pisksnärtskada_1_N = mkN "pisksnärtskada" ; -- pisksnärtskada..nn.1
  pisksnärtskadad_1_A = mkA "pisksnärtskadad" ; -- pisksnärtskadad..av.1
  pisksnärtskydd_1_N = mkN "pisksnärtskydd" neutrum  ; -- pisksnärtskydd..nn.1
  pisksnärtsoperation_1_N = mkN "pisksnärtsoperation" ; -- pisksnärtsoperation..nn.1
  pisksnärtsskada_1_N = mkN "pisksnärtsskada" ; -- pisksnärtsskada..nn.1
  piskställning_1_N = mkN "piskställning" ; -- piskställning..nn.1
  piss_1_N = mkN "piss" neutrum  ; -- piss..nn.1
  pissa_1_V = mkV "pissar" ; -- pissa..vb.1
  pissande_1_N = mkN "pissande" ; -- pissande..nn.1
  pissig_1_A = mkA "pissig" ; -- pissig..av.1
  pissighet_1_N = mkN "pissighet" ; -- pissighet..nn.1
  pissoar_1_N = mkN "pissoar" "pissoarer" ; -- pissoar..nn.1
  pist_1_N = mkN "pist" "pister" ; -- pist..nn.1
  pistage_1_N = mkN "pistage" "pistager" ; -- pistage..nn.1
  pistagemandel_1_N = mkN "pistagemandel" ; -- pistagemandel..nn.1
  pistagenöt_1_N = mkN "pistagenöt" "pistagenötter" ; -- pistagenöt..nn.1
  pistasch_1_N = mkN "pistasch" "pistascher" ; -- pistasch..nn.1
  pistaschmandel_1_N = mkN "pistaschmandel" ; -- pistaschmandel..nn.1
  pistaschnöt_1_N = mkN "pistaschnöt" "pistaschnötter" ; -- pistaschnöt..nn.1
  pistill_1_N = mkN "pistill" "pistiller" ; -- pistill..nn.1
  pistol_1_N = mkN "pistol" "pistoler" ; -- pistol..nn.1
  pistolbeväpnad_1_A = mkA "pistolbeväpnad" ; -- pistolbeväpnad..av.1
  pistolformad_1_A = mkA "pistolformad" ; -- pistolformad..av.1
  pistolhot_1_N = mkN "pistolhot" neutrum  ; -- pistolhot..nn.1
  pistolhota_1_V = mkV "pistolhotar" ; -- pistolhota..vb.1
  pistolkula_1_N = mkN "pistolkula" ; -- pistolkula..nn.1
  pistolliknande_1_A = mkA "pistolliknande" ; -- pistolliknande..av.1
  pistolrån_1_N = mkN "pistolrån" neutrum  ; -- pistolrån..nn.1
  pistolskott_1_N = mkN "pistolskott" neutrum  ; -- pistolskott..nn.1
  pistolskytte_1_N = mkN "pistolskytte" ; -- pistolskytte..nn.1
  pistolväska_1_N = mkN "pistolväska" ; -- pistolväska..nn.1
  pistong_1_N = mkN "pistong" "pistonger" ; -- pistong..nn.1
  pitepalt_1_N = mkN "pitepalt" ; -- pitepalt..nn.1
  pitprops_1_N = mkN "pitprops" ; -- pitprops..nn.1
  pitt_1_N = mkN "pitt" ; -- pitt..nn.1
  pittoresk_1_A = mkA "pittoresk" ; -- pittoresk..av.1
  pivot_1_N = mkN "pivot" "pivoter" ; -- pivot..nn.1
  pivotera_1_V = mkV "pivoterar" ; -- pivotera..vb.1
  pivoterande_1_N = mkN "pivoterande" ; -- pivoterande..nn.1
  pivotering_1_N = mkN "pivotering" ; -- pivotering..nn.1
  pivotfönster_1_N = mkN "pivotfönster" neutrum  ; -- pivotfönster..nn.1
  pivothjul_1_N = mkN "pivothjul" neutrum  ; -- pivothjul..nn.1
  pivothängd_1_A = mkA "pivothängd" "pivothängt" ; -- pivothängd..av.1
  pivotvagn_1_N = mkN "pivotvagn" ; -- pivotvagn..nn.1
  pivå_1_N = mkN "pivå" "pivåer" ; -- pivå..nn.1
  pivåfönster_1_N = mkN "pivåfönster" neutrum  ; -- pivåfönster..nn.1
  pivåhängd_1_A = mkA "pivåhängd" "pivåhängt" ; -- pivåhängd..av.1
  pivåvagn_1_N = mkN "pivåvagn" ; -- pivåvagn..nn.1
  pix_1_N = mkN "pix" neutrum  ; -- pix..nn.1
  pizza_1_N = mkN "pizza" ; -- pizza..nn.1
  pizzabagare_1_N = mkN "pizzabagare" utrum  ; -- pizzabagare..nn.1
  pizzabit_1_N = mkN "pizzabit" ; -- pizzabit..nn.1
  pizzakartong_1_N = mkN "pizzakartong" "pizzakartonger" ; -- pizzakartong..nn.1
  pizzeria_1_N = mkN "pizzeria" ; -- pizzeria..nn.1
  pizzicato_1_N = mkN "pizzicato" "pizzicatot" "pizzicaton" "pizzicatona" ; -- pizzicato..nn.1
  pjatt_1_N = mkN "pjatt" ; -- pjatt..nn.1
  pjatthatt_1_N = mkN "pjatthatt" ; -- pjatthatt..nn.1
  pjoller_1_N = mkN "pjoller" neutrum  ; -- pjoller..nn.1
  pjollra_1_V = mkV "pjollrar" ; -- pjollra..vb.1
  pjollrande_1_N = mkN "pjollrande" ; -- pjollrande..nn.1
  pjoltersällskap_1_N = mkN "pjoltersällskap" neutrum  ; -- pjoltersällskap..nn.1
  pjosk_1_N = mkN "pjosk" neutrum  ; -- pjosk..nn.1
  pjoska_1_V = mkV "pjoskar" ; -- pjoska..vb.1
  pjoskande_1_N = mkN "pjoskande" ; -- pjoskande..nn.1
  pjoskig_1_A = mkA "pjoskig" ; -- pjoskig..av.1
  pjoskighet_1_N = mkN "pjoskighet" ; -- pjoskighet..nn.1
  pjuck_1_N = mkN "pjuck" neutrum  ; -- pjuck..nn.1
  pjunk_1_N = mkN "pjunk" neutrum  ; -- pjunk..nn.1
  pjunka_1_V = mkV "pjunkar" ; -- pjunka..vb.1
  pjunkande_1_N = mkN "pjunkande" ; -- pjunkande..nn.1
  pjunkig_1_A = mkA "pjunkig" ; -- pjunkig..av.1
  pjunkighet_1_N = mkN "pjunkighet" ; -- pjunkighet..nn.1
  pjäs_1_N = mkN "pjäs" "pjäser" ; -- pjäs..nn.1
  pjäxa_1_N = mkN "pjäxa" ; -- pjäxa..nn.1
  pjåkig_1_A = mkA "pjåkig" ; -- pjåkig..av.1
  pjåkighet_1_N = mkN "pjåkighet" ; -- pjåkighet..nn.1
  placebo_1_N = mkN "placebo" ; -- placebo..nn.1
  placeboeffekt_1_N = mkN "placeboeffekt" "placeboeffekter" ; -- placeboeffekt..nn.1
  placenta_1_N = mkN "placenta" ; -- placenta..nn.1
  placera_1_V = mkV "placerar" ; -- placera..vb.1
  placerande_1_N = mkN "placerande" ; -- placerande..nn.1
  placerare_1_N = mkN "placerare" utrum  ; -- placerare..nn.1
  placerbar_1_A = mkA "placerbar" ; -- placerbar..av.1
  placerbarhet_1_N = mkN "placerbarhet" ; -- placerbarhet..nn.1
  placering_1_N = mkN "placering" ; -- placering..nn.1
  placeringskort_1_N = mkN "placeringskort" neutrum  ; -- placeringskort..nn.1
  placeringsobjekt_1_N = mkN "placeringsobjekt" neutrum  ; -- placeringsobjekt..nn.1
  plack_1_N = mkN "plack" ; -- plack..nn.1
  pladder_1_N = mkN "pladder" neutrum  ; -- pladder..nn.1
  pladderblogg_1_N = mkN "pladderblogg" ; -- pladderblogg..nn.1
  pladderkultur_1_N = mkN "pladderkultur" "pladderkulturer" ; -- pladderkultur..nn.1
  pladdra_1_V = mkV "pladdrar" ; -- pladdra..vb.1
  pladdrande_1_N = mkN "pladdrande" ; -- pladdrande..nn.1
  pladdrare_1_N = mkN "pladdrare" utrum  ; -- pladdrare..nn.1
  pladdrig_1_A = mkA "pladdrig" ; -- pladdrig..av.1
  pladdrighet_1_N = mkN "pladdrighet" ; -- pladdrighet..nn.1
  pladuska_1_N = mkN "pladuska" ; -- pladuska..nn.1
  plafond_1_N = mkN "plafond" "plafonder" ; -- plafond..nn.1
  plafondmålning_1_N = mkN "plafondmålning" ; -- plafondmålning..nn.1
  plage_1_N = mkN "plage" "plager" ; -- plage..nn.1
  plagg_1_N = mkN "plagg" neutrum  ; -- plagg..nn.1
  plagiat_1_N = mkN "plagiat" neutrum  ; -- plagiat..nn.1
  plagiatanklagelse_1_N = mkN "plagiatanklagelse" "plagiatanklagelser" ; -- plagiatanklagelse..nn.1
  plagiator_1_N = mkN "plagiator" "plagiatorer" ; -- plagiator..nn.1
  plagiera_1_V = mkV "plagierar" ; -- plagiera..vb.1
  plagierande_1_N = mkN "plagierande" ; -- plagierande..nn.1
  plagierbar_1_A = mkA "plagierbar" ; -- plagierbar..av.1
  plagierbarhet_1_N = mkN "plagierbarhet" ; -- plagierbarhet..nn.1
  plagiering_1_N = mkN "plagiering" ; -- plagiering..nn.1
  plaidoyer_1_N = mkN "plaidoyer" "plaidoyerer" ; -- plaidoyer..nn.1
  plakat_1_A = mkA "plakat" ; -- plakat..av.1
  plakat_1_N = mkN "plakat" neutrum  ; -- plakat..nn.1
  plakett_1_N = mkN "plakett" "plaketter" ; -- plakett..nn.1
  plan_1_A = mkA "plan" ; -- plan..av.1
  plan_1_N = mkN "plan" "planer" ; -- plan..nn.1
  plan_2_N = mkN "plan" neutrum  ; -- plan..nn.2
  plan_3_N = mkN "plan" "planer" ; -- plan..nn.3
  plana_1_V = mkV "planar" ; -- plana..vb.1
  plana_2_V = mkV "planar" ; -- plana..vb.2
  planande_1_N = mkN "planande" ; -- planande..nn.1
  planekonomi_1_N = mkN "planekonomi" "planekonomier" ; -- planekonomi..nn.1
  planekonomisk_1_A = mkA "planekonomisk" ; -- planekonomisk..av.1
  planenlig_1_A = mkA "planenlig" ; -- planenlig..av.1
  planenlighet_1_N = mkN "planenlighet" ; -- planenlighet..nn.1
  planera_1_V = mkV "planerar" ; -- planera..vb.1
  planerande_1_N = mkN "planerande" ; -- planerande..nn.1
  planerare_1_N = mkN "planerare" utrum  ; -- planerare..nn.1
  planerbar_1_A = mkA "planerbar" ; -- planerbar..av.1
  planerbarhet_1_N = mkN "planerbarhet" ; -- planerbarhet..nn.1
  planering_1_N = mkN "planering" ; -- planering..nn.1
  planeringsmässig_1_A = mkA "planeringsmässig" ; -- planeringsmässig..av.1
  planeringsorgan_1_N = mkN "planeringsorgan" neutrum  ; -- planeringsorgan..nn.1
  planet_1_N = mkN "planet" "planeter" ; -- planet..nn.1
  planetarisk_1_A = mkA "planetarisk" ; -- planetarisk..av.1
  planetarium_1_N = mkN "planetarium" "planetariet" "planetarier" "planetarierna" ; -- planetarium..nn.1
  planetbana_1_N = mkN "planetbana" ; -- planetbana..nn.1
  planetbildning_1_N = mkN "planetbildning" ; -- planetbildning..nn.1
  planetesimal_1_N = mkN "planetesimal" "planetesimaler" ; -- planetesimal..nn.1
  planetrörelse_1_N = mkN "planetrörelse" "planetrörelser" ; -- planetrörelse..nn.1
  planetsystem_1_N = mkN "planetsystem" neutrum  ; -- planetsystem..nn.1
  plangeometri_1_N = mkN "plangeometri" ; -- plangeometri..nn.1
  planhalva_1_N = mkN "planhalva" ; -- planhalva..nn.1
  planhet_1_N = mkN "planhet" ; -- planhet..nn.1
  planhushållning_1_N = mkN "planhushållning" ; -- planhushållning..nn.1
  planhyvel_1_N = mkN "planhyvel" ; -- planhyvel..nn.1
  planimetri_1_N = mkN "planimetri" ; -- planimetri..nn.1
  planimetrisk_1_A = mkA "planimetrisk" ; -- planimetrisk..av.1
  plank_1_N = mkN "plank" ; -- plank..nn.1
  plank_2_N = mkN "plank" neutrum  ; -- plank..nn.2
  planka_1_N = mkN "planka" ; -- planka..nn.1
  planka_1_V = mkV "plankar" ; -- planka..vb.1
  planka_2_V = mkV "plankar" ; -- planka..vb.2
  plankande_1_N = mkN "plankande" ; -- plankande..nn.1
  plankare_1_N = mkN "plankare" utrum  ; -- plankare..nn.1
  plankgolv_1_N = mkN "plankgolv" neutrum  ; -- plankgolv..nn.1
  plankgång_1_N = mkN "plankgång" ; -- plankgång..nn.1
  plankonkav_1_A = mkA "plankonkav" ; -- plankonkav..av.1
  plankonvex_1_A = mkA "plankonvex" ; -- plankonvex..av.1
  plankorsning_1_N = mkN "plankorsning" ; -- plankorsning..nn.1
  plankstek_1_N = mkN "plankstek" ; -- plankstek..nn.1
  plankstrykare_1_N = mkN "plankstrykare" utrum  ; -- plankstrykare..nn.1
  plankter_1_N = mkN "plankter" "planktern" "plankter" "plankterna" ; -- plankter..nn.1
  plankton_1_N = mkN "plankton" neutrum  ; -- plankton..nn.1
  planktondjur_1_N = mkN "planktondjur" neutrum  ; -- planktondjur..nn.1
  planktonväxt_1_N = mkN "planktonväxt" "planktonväxter" ; -- planktonväxt..nn.1
  planlägga_1_V = mkV "planlägga" "planla" "planlagt" ; -- planlägga..vb.1
  planläggande_1_N = mkN "planläggande" ; -- planläggande..nn.1
  planläggning_1_N = mkN "planläggning" ; -- planläggning..nn.1
  planlös_1_A = mkA "planlös" ; -- planlös..av.1
  planlöshet_1_N = mkN "planlöshet" ; -- planlöshet..nn.1
  planlösning_1_N = mkN "planlösning" ; -- planlösning..nn.1
  planmässig_1_A = mkA "planmässig" ; -- planmässig..av.1
  planmässighet_1_N = mkN "planmässighet" ; -- planmässighet..nn.1
  planmätning_1_N = mkN "planmätning" ; -- planmätning..nn.1
  planparallell_1_A = mkA "planparallell" ; -- planparallell..av.1
  planritning_1_N = mkN "planritning" ; -- planritning..nn.1
  plansch_1_N = mkN "plansch" "planscher" ; -- plansch..nn.1
  planschett_1_N = mkN "planschett" "planschetter" ; -- planschett..nn.1
  planschverk_1_N = mkN "planschverk" neutrum  ; -- planschverk..nn.1
  planskild_1_A = mkA "planskild" "planskilt" ; -- planskild..av.1
  planta_1_N = mkN "planta" ; -- planta..nn.1
  planta_1_V = mkV "plantar" ; -- planta..vb.1
  plantage_1_N = mkN "plantage" "plantager" ; -- plantage..nn.1
  plantageekonomi_1_N = mkN "plantageekonomi" "plantageekonomier" ; -- plantageekonomi..nn.1
  plantande_1_N = mkN "plantande" ; -- plantande..nn.1
  plantera_1_V = mkV "planterar" ; -- plantera..vb.1
  planterande_1_N = mkN "planterande" ; -- planterande..nn.1
  planterbar_1_A = mkA "planterbar" ; -- planterbar..av.1
  planterbarhet_1_N = mkN "planterbarhet" ; -- planterbarhet..nn.1
  plantering_1_N = mkN "plantering" ; -- plantering..nn.1
  planteringsspade_1_N = mkN "planteringsspade" utrum  ; -- planteringsspade..nn.1
  plantryck_1_N = mkN "plantryck" neutrum  ; -- plantryck..nn.1
  plants_1_N = mkN "plants" ; -- plants..nn.1
  plantskola_1_N = mkN "plantskola" ; -- plantskola..nn.1
  plask_1_N = mkN "plask" neutrum  ; -- plask..nn.1
  plaska_1_V = mkV "plaskar" ; -- plaska..vb.1
  plaskande_1_N = mkN "plaskande" ; -- plaskande..nn.1
  plaskdamm_1_N = mkN "plaskdamm" ; -- plaskdamm..nn.1
  plaskning_1_N = mkN "plaskning" ; -- plaskning..nn.1
  plaskvåt_1_A = mkA "plaskvåt" ; -- plaskvåt..av.1
  plasma_teve_1_N = mkN "plasma-teve" "plasma-teven" "plasma-tevear" "plasma-tevearna" ; -- plasma-teve..nn.1
  plasma_1_N = mkN "plasma" "plasman" "plasmer" "plasmerna" ; -- plasma..nn.1
  plasmaskärm_1_N = mkN "plasmaskärm" ; -- plasmaskärm..nn.1
  plasmateve_1_N = mkN "plasmateve" "plasmateven" "plasmatevear" "plasmatevearna" ; -- plasmateve..nn.1
  plast_1_N = mkN "plast" "plaster" ; -- plast..nn.1
  plasta_1_V = mkV "plastar" ; -- plasta..vb.1
  plastande_1_N = mkN "plastande" ; -- plastande..nn.1
  plastback_1_N = mkN "plastback" ; -- plastback..nn.1
  plastbalja_1_N = mkN "plastbalja" ; -- plastbalja..nn.1
  plastband_1_N = mkN "plastband" neutrum  ; -- plastband..nn.1
  plastbassäng_1_N = mkN "plastbassäng" "plastbassänger" ; -- plastbassäng..nn.1
  plastbestick_1_N = mkN "plastbestick" neutrum  ; -- plastbestick..nn.1
  plastbindemedel_1_N = mkN "plastbindemedel" neutrum  ; -- plastbindemedel..nn.1
  plastbunden_1_A = mkA "plastbunden" ; -- plastbunden..av.1
  plastbåge_1_N = mkN "plastbåge" utrum  ; -- plastbåge..nn.1
  plastcykel_1_N = mkN "plastcykel" ; -- plastcykel..nn.1
  plastdunk_1_N = mkN "plastdunk" ; -- plastdunk..nn.1
  plastellin_1_N = mkN "plastellin" ; -- plastellin..nn.1
  plastellina_1_N = mkN "plastellina" ; -- plastellina..nn.1
  plastfiber_1_N = mkN "plastfiber" "plastfibern" "plastfibrer" "plastfibrerna" ; -- plastfiber..nn.1
  plastflaska_1_N = mkN "plastflaska" ; -- plastflaska..nn.1
  plastflygplan_1_N = mkN "plastflygplan" neutrum  ; -- plastflygplan..nn.1
  plastfolie_1_N = mkN "plastfolie" "plastfolier" ; -- plastfolie..nn.1
  plastgaffel_1_N = mkN "plastgaffel" ; -- plastgaffel..nn.1
  plastglas_1_N = mkN "plastglas" neutrum  ; -- plastglas..nn.1
  plastglob_1_N = mkN "plastglob" "plastglober" ; -- plastglob..nn.1
  plasticitet_1_N = mkN "plasticitet" "plasticiteter" ; -- plasticitet..nn.1
  plastig_1_A = mkA "plastig" ; -- plastig..av.1
  plastik_1_N = mkN "plastik" ; -- plastik..nn.1
  plastikhaveri_1_N = mkN "plastikhaveri" "plastikhaveriet" "plastikhaverier" "plastikhaverierna" ; -- plastikhaveri..nn.1
  plastikkirurg_1_N = mkN "plastikkirurg" "plastikkirurger" ; -- plastikkirurg..nn.1
  plastikkirurgi_1_N = mkN "plastikkirurgi" ; -- plastikkirurgi..nn.1
  plastikkirurgisk_1_A = mkA "plastikkirurgisk" ; -- plastikkirurgisk..av.1
  plastikoperation_1_N = mkN "plastikoperation" ; -- plastikoperation..nn.1
  plastikoperera_1_V = mkV "plastikopererar" ; -- plastikoperera..vb.1
  plastikopererande_1_N = mkN "plastikopererande" ; -- plastikopererande..nn.1
  plastikträsk_1_N = mkN "plastikträsk" neutrum  ; -- plastikträsk..nn.1
  plastindustri_1_N = mkN "plastindustri" "plastindustrier" ; -- plastindustri..nn.1
  plastinpackad_1_A = mkA "plastinpackad" ; -- plastinpackad..av.1
  plastisk_1_A = mkA "plastisk" ; -- plastisk..av.1
  plastkirurgi_1_N = mkN "plastkirurgi" ; -- plastkirurgi..nn.1
  plastkirurgisk_1_A = mkA "plastkirurgisk" ; -- plastkirurgisk..av.1
  plastkork_1_N = mkN "plastkork" ; -- plastkork..nn.1
  plastkort_1_N = mkN "plastkort" neutrum  ; -- plastkort..nn.1
  plastlaminat_1_N = mkN "plastlaminat" neutrum  ; -- plastlaminat..nn.1
  plastliknande_1_A = mkA "plastliknande" ; -- plastliknande..av.1
  plastlur_1_N = mkN "plastlur" ; -- plastlur..nn.1
  plastmamma_1_N = mkN "plastmamma" ; -- plastmamma..nn.1
  plastnav_1_N = mkN "plastnav" neutrum  ; -- plastnav..nn.1
  plastpappa_1_N = mkN "plastpappa" ; -- plastpappa..nn.1
  plastpil_1_N = mkN "plastpil" ; -- plastpil..nn.1
  plastpryl_1_N = mkN "plastpryl" ; -- plastpryl..nn.1
  plastpulka_1_N = mkN "plastpulka" ; -- plastpulka..nn.1
  plastpåse_1_N = mkN "plastpåse" utrum  ; -- plastpåse..nn.1
  plastring_1_N = mkN "plastring" ; -- plastring..nn.1
  plastron_1_N = mkN "plastron" "plastroner" ; -- plastron..nn.1
  plastrong_1_N = mkN "plastrong" "plastronger" ; -- plastrong..nn.1
  plasträfsa_1_N = mkN "plasträfsa" ; -- plasträfsa..nn.1
  plastsked_1_N = mkN "plastsked" ; -- plastsked..nn.1
  plastskiva_1_N = mkN "plastskiva" ; -- plastskiva..nn.1
  plastsko_1_N = mkN "plastsko" "plastskor" ; -- plastsko..nn.1
  plastsoppåse_1_N = mkN "plastsoppåse" utrum  ; -- plastsoppåse..nn.1
  plastspiral_1_N = mkN "plastspiral" "plastspiraler" ; -- plastspiral..nn.1
  plastsäck_1_N = mkN "plastsäck" ; -- plastsäck..nn.1
  plasttrumpet_1_N = mkN "plasttrumpet" "plasttrumpeter" ; -- plasttrumpet..nn.1
  plastålder_1_N = mkN "plastålder" ; -- plastålder..nn.1
  platan_1_N = mkN "platan" "plataner" ; -- platan..nn.1
  platina_1_N = mkN "platina" ; -- platina..nn.1
  platinablond_1_A = mkA "platinablond" ; -- platinablond..av.1
  platinablondhet_1_N = mkN "platinablondhet" ; -- platinablondhet..nn.1
  platinera_1_V = mkV "platinerar" ; -- platinera..vb.1
  platinerande_1_N = mkN "platinerande" ; -- platinerande..nn.1
  platinerbar_1_A = mkA "platinerbar" ; -- platinerbar..av.1
  platinerbarhet_1_N = mkN "platinerbarhet" ; -- platinerbarhet..nn.1
  platinering_1_N = mkN "platinering" ; -- platinering..nn.1
  platoniker_1_N = mkN "platoniker" "platonikern" "platoniker" "platonikerna" ; -- platoniker..nn.1
  platonisk_1_A = mkA "platonisk" ; -- platonisk..av.1
  platonism_1_N = mkN "platonism" "platonismer" ; -- platonism..nn.1
  platonsk_1_A = mkA "platonsk" ; -- platonsk..av.1
  plats_1_N = mkN "plats" "platser" ; -- plats..nn.1
  platsa_1_V = mkV "platsar" ; -- platsa..vb.1
  platsande_1_N = mkN "platsande" ; -- platsande..nn.1
  platsansökning_1_N = mkN "platsansökning" ; -- platsansökning..nn.1
  platsbiljett_1_N = mkN "platsbiljett" "platsbiljetter" ; -- platsbiljett..nn.1
  platsbrist_1_N = mkN "platsbrist" ; -- platsbrist..nn.1
  platschef_1_N = mkN "platschef" "platschefer" ; -- platschef..nn.1
  platskontor_1_N = mkN "platskontor" neutrum  ; -- platskontor..nn.1
  platsmässig_1_A = mkA "platsmässig" ; -- platsmässig..av.1
  platssiffra_1_N = mkN "platssiffra" ; -- platssiffra..nn.1
  platssökande_1_A = mkA "platssökande" ; -- platssökande..av.1
  platt_teve_1_N = mkN "platt-teve" "platt-teven" "platt-tevear" "platt-tevearna" ; -- platt-teve..nn.1
  platt_1_A = mkA "platt" ; -- platt..av.1
  platta_1_N = mkN "platta" ; -- platta..nn.1
  plattdistribution_1_N = mkN "plattdistribution" ; -- plattdistribution..nn.1
  plattektonik_1_N = mkN "plattektonik" ; -- plattektonik..nn.1
  plattfil_1_N = mkN "plattfil" ; -- plattfil..nn.1
  plattfisk_1_N = mkN "plattfisk" ; -- plattfisk..nn.1
  plattform_1_N = mkN "plattform" ; -- plattform..nn.1
  plattfot_1_N = mkN "plattfot" ; -- plattfot..nn.1
  plattfotad_1_A = mkA "plattfotad" ; -- plattfotad..av.1
  plattfoting_1_N = mkN "plattfoting" ; -- plattfoting..nn.1
  platthet_1_N = mkN "platthet" ; -- platthet..nn.1
  platthet_2_N = mkN "platthet" "plattheter" ; -- platthet..nn.2
  platting_1_N = mkN "platting" ; -- platting..nn.1
  plattityd_1_N = mkN "plattityd" "plattityder" ; -- plattityd..nn.1
  plattjärn_1_N = mkN "plattjärn" neutrum  ; -- plattjärn..nn.1
  plattläggning_1_N = mkN "plattläggning" ; -- plattläggning..nn.1
  plattläggningsproblem_1_N = mkN "plattläggningsproblem" neutrum  ; -- plattläggningsproblem..nn.1
  plattmask_1_N = mkN "plattmask" ; -- plattmask..nn.1
  plattnaglad_1_A = mkA "plattnaglad" ; -- plattnaglad..av.1
  plattnäst_1_A = mkA "plattnäst" "plattnäst" ; -- plattnäst..av.1
  plattskärm_1_N = mkN "plattskärm" ; -- plattskärm..nn.1
  plattsättare_1_N = mkN "plattsättare" utrum  ; -- plattsättare..nn.1
  plattsöm_1_N = mkN "plattsöm" "plattsömmen" "plattsömmar" "plattsömmarna" ; -- plattsöm..nn.1
  plattysk_1_A = mkA "plattysk" ; -- plattysk..av.1
  plattyska_1_N = mkN "plattyska" ; -- plattyska..nn.1
  plattång_1_N = mkN "plattång" "plattänger" ; -- plattång..nn.1
  platå_1_N = mkN "platå" "platåer" ; -- platå..nn.1
  platåberg_1_N = mkN "platåberg" neutrum  ; -- platåberg..nn.1
  platågupp_1_N = mkN "platågupp" neutrum  ; -- platågupp..nn.1
  plausibel_1_A = mkA "plausibel" ; -- plausibel..av.1
  play_off_1_N = mkN "play-off" neutrum  ; -- play-off..nn.1
  playback_1_N = mkN "playback" ; -- playback..nn.1
  playboy_1_N = mkN "playboy" ; -- playboy..nn.1
  plebej_1_N = mkN "plebej" "plebejer" ; -- plebej..nn.1
  plebejisk_1_A = mkA "plebejisk" ; -- plebejisk..av.1
  plebiscit_1_N = mkN "plebiscit" neutrum  ; -- plebiscit..nn.1
  plebs_1_N = mkN "plebs" ; -- plebs..nn.1
  pleistocen_1_N = mkN "pleistocen" ; -- pleistocen..nn.1
  plejad_1_N = mkN "plejad" "plejader" ; -- plejad..nn.1
  plekter_1_N = mkN "plekter" neutrum  ; -- plekter..nn.1
  plektron_1_N = mkN "plektron" neutrum  ; -- plektron..nn.1
  plektrum_1_N = mkN "plektrum" neutrum  ; -- plektrum..nn.1
  plenarförsamling_1_N = mkN "plenarförsamling" ; -- plenarförsamling..nn.1
  plenimål_1_N = mkN "plenimål" neutrum  ; -- plenimål..nn.1
  plenum_1_N = mkN "plenum" neutrum  ; -- plenum..nn.1
  pleonasm_1_N = mkN "pleonasm" "pleonasmer" ; -- pleonasm..nn.1
  pleonastisk_1_A = mkA "pleonastisk" ; -- pleonastisk..av.1
  plesiomorfi_1_N = mkN "plesiomorfi" "plesiomorfier" ; -- plesiomorfi..nn.1
  plesiosaurie_1_N = mkN "plesiosaurie" "plesiosaurier" ; -- plesiosaurie..nn.1
  pleurit_1_N = mkN "pleurit" "pleuriter" ; -- pleurit..nn.1
  plexiglas_1_N = mkN "plexiglas" neutrum  ; -- plexiglas..nn.1
  pligg_1_N = mkN "pligg" ; -- pligg..nn.1
  pligga_1_V = mkV "pliggar" ; -- pligga..vb.1
  pliggande_1_N = mkN "pliggande" ; -- pliggande..nn.1
  pliggning_1_N = mkN "pliggning" ; -- pliggning..nn.1
  plikt_1_N = mkN "plikt" "plikter" ; -- plikt..nn.1
  plikta_1_V = mkV "pliktar" ; -- plikta..vb.1
  pliktande_1_N = mkN "pliktande" ; -- pliktande..nn.1
  pliktcelibat_1_N = mkN "pliktcelibat" neutrum  ; -- pliktcelibat..nn.1
  pliktenlig_1_A = mkA "pliktenlig" ; -- pliktenlig..av.1
  pliktenlighet_1_N = mkN "pliktenlighet" "pliktenligheter" ; -- pliktenlighet..nn.1
  pliktexemplar_1_N = mkN "pliktexemplar" neutrum  ; -- pliktexemplar..nn.1
  pliktfälla_1_V = mkV "pliktfäller" ; -- pliktfälla..vb.1
  pliktfällande_1_N = mkN "pliktfällande" ; -- pliktfällande..nn.1
  pliktfällning_1_N = mkN "pliktfällning" ; -- pliktfällning..nn.1
  pliktförgäten_1_A = mkA "pliktförgäten" ; -- pliktförgäten..av.1
  pliktförgätenhet_1_N = mkN "pliktförgätenhet" ; -- pliktförgätenhet..nn.1
  plikthuggare_1_N = mkN "plikthuggare" utrum  ; -- plikthuggare..nn.1
  pliktig_1_A = mkA "pliktig" ; -- pliktig..av.1
  pliktkänsla_1_N = mkN "pliktkänsla" ; -- pliktkänsla..nn.1
  pliktmedveten_1_A = mkA "pliktmedveten" ; -- pliktmedveten..av.1
  pliktmässig_1_A = mkA "pliktmässig" ; -- pliktmässig..av.1
  pliktskyldig_1_A = mkA "pliktskyldig" ; -- pliktskyldig..av.1
  pliktskyldighet_1_N = mkN "pliktskyldighet" ; -- pliktskyldighet..nn.1
  plikttrogen_1_A = mkA "plikttrogen" ; -- plikttrogen..av.1
  plikttrogenhet_1_N = mkN "plikttrogenhet" ; -- plikttrogenhet..nn.1
  plikttrohet_1_N = mkN "plikttrohet" ; -- plikttrohet..nn.1
  pliktuppfyllelse_1_N = mkN "pliktuppfyllelse" utrum  ; -- pliktuppfyllelse..nn.1
  pliktåra_1_N = mkN "pliktåra" ; -- pliktåra..nn.1
  pling_1_N = mkN "pling" neutrum  ; -- pling..nn.1
  plint_1_N = mkN "plint" ; -- plint..nn.1
  pliocen_1_N = mkN "pliocen" ; -- pliocen..nn.1
  pliocenbildning_1_N = mkN "pliocenbildning" ; -- pliocenbildning..nn.1
  plira_1_V = mkV "plirar" ; -- plira..vb.1
  plirande_1_N = mkN "plirande" ; -- plirande..nn.1
  plirig_1_A = mkA "plirig" ; -- plirig..av.1
  plirögdhet_1_N = mkN "plirögdhet" ; -- plirögdhet..nn.1
  plissera_1_V = mkV "plisserar" ; -- plissera..vb.1
  plisserande_1_N = mkN "plisserande" ; -- plisserande..nn.1
  plisserbar_1_A = mkA "plisserbar" ; -- plisserbar..av.1
  plisserbarhet_1_N = mkN "plisserbarhet" ; -- plisserbarhet..nn.1
  plissering_1_N = mkN "plissering" ; -- plissering..nn.1
  plissé_1_N = mkN "plissé" "plisséer" ; -- plissé..nn.1
  plister_1_N = mkN "plister" ; -- plister..nn.1
  plit_1_N = mkN "plit" neutrum  ; -- plit..nn.1
  plit_2_N = mkN "plit" ; -- plit..nn.2
  plita_1_N = mkN "plita" ; -- plita..nn.1
  plita_1_V = mkV "plitar" ; -- plita..vb.1
  plitande_1_N = mkN "plitande" ; -- plitande..nn.1
  plock_1_N = mkN "plock" neutrum  ; -- plock..nn.1
  plocka_1_V = mkV "plockar" ; -- plocka..vb.1
  plockande_1_N = mkN "plockande" ; -- plockande..nn.1
  plockare_1_N = mkN "plockare" utrum  ; -- plockare..nn.1
  plockig_1_A = mkA "plockig" ; -- plockig..av.1
  plockighet_1_N = mkN "plockighet" ; -- plockighet..nn.1
  plockmat_1_N = mkN "plockmat" ; -- plockmat..nn.1
  plockning_1_N = mkN "plockning" ; -- plockning..nn.1
  plog_1_N = mkN "plog" ; -- plog..nn.1
  ploga_1_V = mkV "plogar" ; -- ploga..vb.1
  plogande_1_N = mkN "plogande" ; -- plogande..nn.1
  plogben_1_N = mkN "plogben" neutrum  ; -- plogben..nn.1
  plogbill_1_N = mkN "plogbill" ; -- plogbill..nn.1
  plogfåra_1_N = mkN "plogfåra" ; -- plogfåra..nn.1
  plogtilta_1_N = mkN "plogtilta" ; -- plogtilta..nn.1
  ploj_1_N = mkN "ploj" ; -- ploj..nn.1
  plomb_1_N = mkN "plomb" "plomber" ; -- plomb..nn.1
  plombera_1_V = mkV "plomberar" ; -- plombera..vb.1
  plomberande_1_N = mkN "plomberande" ; -- plomberande..nn.1
  plomberbar_1_A = mkA "plomberbar" ; -- plomberbar..av.1
  plomberbarhet_1_N = mkN "plomberbarhet" ; -- plomberbarhet..nn.1
  plombering_1_N = mkN "plombering" ; -- plombering..nn.1
  plommon_1_N = mkN "plommon" neutrum  ; -- plommon..nn.1
  plommonbrännvin_1_N = mkN "plommonbrännvin" neutrum  ; -- plommonbrännvin..nn.1
  plommonskörd_1_N = mkN "plommonskörd" ; -- plommonskörd..nn.1
  plommonstop_1_N = mkN "plommonstop" neutrum  ; -- plommonstop..nn.1
  plommonsylt_1_N = mkN "plommonsylt" "plommonsylter" ; -- plommonsylt..nn.1
  plotta_1_V = mkV "plottar" ; -- plotta..vb.1
  plottande_1_N = mkN "plottande" ; -- plottande..nn.1
  plotter_1_N = mkN "plotter" neutrum  ; -- plotter..nn.1
  plottra_1_V = mkV "plottrar" ; -- plottra..vb.1
  plottrande_1_N = mkN "plottrande" ; -- plottrande..nn.1
  plottrig_1_A = mkA "plottrig" ; -- plottrig..av.1
  plottrighet_1_N = mkN "plottrighet" ; -- plottrighet..nn.1
  plufsig_1_A = mkA "plufsig" ; -- plufsig..av.1
  plufsighet_1_N = mkN "plufsighet" ; -- plufsighet..nn.1
  plugg_1_N = mkN "plugg" neutrum  ; -- plugg..nn.1
  plugg_2_N = mkN "plugg" ; -- plugg..nn.2
  plugga_1_V = mkV "pluggar" ; -- plugga..vb.1
  plugga_2_V = mkV "pluggar" ; -- plugga..vb.2
  pluggande_1_N = mkN "pluggande" ; -- pluggande..nn.1
  pluggare_1_N = mkN "pluggare" utrum  ; -- pluggare..nn.1
  plugghäst_1_N = mkN "plugghäst" ; -- plugghäst..nn.1
  pluggning_1_N = mkN "pluggning" ; -- pluggning..nn.1
  pluggskivling_1_N = mkN "pluggskivling" ; -- pluggskivling..nn.1
  pluggämne_1_N = mkN "pluggämne" ; -- pluggämne..nn.1
  plump_1_A = mkA "plump" ; -- plump..av.1
  plump_1_N = mkN "plump" ; -- plump..nn.1
  plumpa_1_V = mkV "plumpar" ; -- plumpa..vb.1
  plumpande_1_N = mkN "plumpande" ; -- plumpande..nn.1
  plumphet_1_N = mkN "plumphet" "plumpheter" ; -- plumphet..nn.1
  plumpning_1_N = mkN "plumpning" ; -- plumpning..nn.1
  plumpudding_1_N = mkN "plumpudding" ; -- plumpudding..nn.1
  plums_1_N = mkN "plums" ; -- plums..nn.1
  plumsa_1_V = mkV "plumsar" ; -- plumsa..vb.1
  plumsande_1_N = mkN "plumsande" ; -- plumsande..nn.1
  plundra_1_V = mkV "plundrar" ; -- plundra..vb.1
  plundrande_1_N = mkN "plundrande" ; -- plundrande..nn.1
  plundrare_1_N = mkN "plundrare" utrum  ; -- plundrare..nn.1
  plundring_1_N = mkN "plundring" ; -- plundring..nn.1
  plundringståg_1_N = mkN "plundringståg" neutrum  ; -- plundringståg..nn.1
  plunta_1_N = mkN "plunta" ; -- plunta..nn.1
  plural_1_A = mkA "plural" ; -- plural..av.1
  plural_1_N = mkN "plural" "pluraler" ; -- plural..nn.1
  pluralis_1_N = mkN "pluralis" ; -- pluralis..nn.1
  pluralism_1_N = mkN "pluralism" "pluralismer" ; -- pluralism..nn.1
  pluralistisk_1_A = mkA "pluralistisk" ; -- pluralistisk..av.1
  pluralitet_1_N = mkN "pluralitet" "pluraliteter" ; -- pluralitet..nn.1
  pluring_1_N = mkN "pluring" ; -- pluring..nn.1
  pluripotent_1_A = mkA "pluripotent" "pluripotent" ; -- pluripotent..av.1
  plurr_1_N = mkN "plurr" neutrum  ; -- plurr..nn.1
  plurra_1_V = mkV "plurrar" ; -- plurra..vb.1
  plurrande_1_N = mkN "plurrande" ; -- plurrande..nn.1
  plus_1_N = mkN "plus" neutrum  ; -- plus..nn.1
  plusgrad_1_N = mkN "plusgrad" "plusgrader" ; -- plusgrad..nn.1
  pluska_1_N = mkN "pluska" ; -- pluska..nn.1
  pluskvamperfektum_1_N = mkN "pluskvamperfektum" "pluskvamperfektum" "pluskvamperfekter" "pluskvamperfekterna" ; -- pluskvamperfektum..nn.1
  pluspol_1_N = mkN "pluspol" "pluspoler" ; -- pluspol..nn.1
  pluss_1_N = mkN "pluss" neutrum  ; -- pluss..nn.1
  plussa_1_V = mkV "plussar" ; -- plussa..vb.1
  plussande_1_N = mkN "plussande" ; -- plussande..nn.1
  plussida_1_N = mkN "plussida" ; -- plussida..nn.1
  plussig_1_A = mkA "plussig" ; -- plussig..av.1
  plussighet_1_N = mkN "plussighet" ; -- plussighet..nn.1
  plustecken_1_N = mkN "plustecken" "plustecknet" "plustecken" "plustecknen" ; -- plustecken..nn.1
  plut_1_N = mkN "plut" neutrum  ; -- plut..nn.1
  pluta_1_V = mkV "plutar" ; -- pluta..vb.1
  plutande_1_N = mkN "plutande" ; -- plutande..nn.1
  plutokrat_1_N = mkN "plutokrat" "plutokrater" ; -- plutokrat..nn.1
  plutokrati_1_N = mkN "plutokrati" "plutokratier" ; -- plutokrati..nn.1
  plutokratisk_1_A = mkA "plutokratisk" ; -- plutokratisk..av.1
  pluton_1_N = mkN "pluton" "plutoner" ; -- pluton..nn.1
  plutonchef_1_N = mkN "plutonchef" "plutonchefer" ; -- plutonchef..nn.1
  plutonisk_1_A = mkA "plutonisk" ; -- plutonisk..av.1
  plutonium_1_N = mkN "plutonium" neutrum  ; -- plutonium..nn.1
  plutonvis_1_Adv = mkAdv "plutonvis" ; -- plutonvis..ab.1
  plutonvis_1_A = mkA "plutonvis" ; -- plutonvis..av.1
  plutt_1_N = mkN "plutt" ; -- plutt..nn.1
  pluttig_1_A = mkA "pluttig" ; -- pluttig..av.1
  pluttighet_1_N = mkN "pluttighet" ; -- pluttighet..nn.1
  pluvial_1_A = mkA "pluvial" ; -- pluvial..av.1
  pluvialperiod_1_N = mkN "pluvialperiod" "pluvialperioder" ; -- pluvialperiod..nn.1
  plym_1_N = mkN "plym" "plymer" ; -- plym..nn.1
  plymasch_1_N = mkN "plymasch" "plymascher" ; -- plymasch..nn.1
  plymascherad_1_A = mkA "plymascherad" ; -- plymascherad..av.1
  plymå_1_N = mkN "plymå" "plymåer" ; -- plymå..nn.1
  plysa_1_V = mkV "plysar" ; -- plysa..vb.1
  plysande_1_N = mkN "plysande" ; -- plysande..nn.1
  plysch_1_N = mkN "plysch" "plyscher" ; -- plysch..nn.1
  plyschklädd_1_A = mkA "plyschklädd" ; -- plyschklädd..av.1
  plysmaskin_1_N = mkN "plysmaskin" "plysmaskiner" ; -- plysmaskin..nn.1
  plyte_1_N = mkN "plyte" ; -- plyte..nn.1
  plywood_1_N = mkN "plywood" ; -- plywood..nn.1
  plywoodfabrik_1_N = mkN "plywoodfabrik" "plywoodfabriker" ; -- plywoodfabrik..nn.1
  pläd_1_N = mkN "pläd" ; -- pläd..nn.1
  plädera_1_V = mkV "pläderar" ; -- plädera..vb.1
  pläderande_1_N = mkN "pläderande" ; -- pläderande..nn.1
  plädering_1_N = mkN "plädering" ; -- plädering..nn.1
  plädoajé_1_N = mkN "plädoajé" "plädoajéer" ; -- plädoajé..nn.1
  pläga_1_V = mkV "plägar" ; -- pläga..vb.1
  plägande_1_N = mkN "plägande" ; -- plägande..nn.1
  plägning_1_N = mkN "plägning" ; -- plägning..nn.1
  plägsed_1_N = mkN "plägsed" "plägseder" ; -- plägsed..nn.1
  pläter_1_N = mkN "pläter" ; -- pläter..nn.1
  plätera_1_V = mkV "pläterar" ; -- plätera..vb.1
  pläterande_1_N = mkN "pläterande" ; -- pläterande..nn.1
  pläterbar_1_A = mkA "pläterbar" ; -- pläterbar..av.1
  pläterbarhet_1_N = mkN "pläterbarhet" ; -- pläterbarhet..nn.1
  plätering_1_N = mkN "plätering" ; -- plätering..nn.1
  plätt_1_N = mkN "plätt" ; -- plätt..nn.1
  plättlagg_1_N = mkN "plättlagg" ; -- plättlagg..nn.1
  plåga_1_N = mkN "plåga" ; -- plåga..nn.1
  plåga_1_V = mkV "plågar" ; -- plåga..vb.1
  plågande_1_N = mkN "plågande" ; -- plågande..nn.1
  plågare_1_N = mkN "plågare" utrum  ; -- plågare..nn.1
  plågoande_1_N = mkN "plågoande" utrum  ; -- plågoande..nn.1
  plågoris_1_N = mkN "plågoris" neutrum  ; -- plågoris..nn.1
  plågsam_1_A = mkA "plågsam" "plågsamt" "plågsamma" "plågsamma" "plågsammare" "plågsammast" "plågsammaste" ; -- plågsam..av.1
  plågsamhet_1_N = mkN "plågsamhet" "plågsamheter" ; -- plågsamhet..nn.1
  plån_1_N = mkN "plån" neutrum  ; -- plån..nn.1
  plånbok_1_N = mkN "plånbok" "plånböcker" ; -- plånbok..nn.1
  plånboksfråga_1_N = mkN "plånboksfråga" ; -- plånboksfråga..nn.1
  plåster_1_N = mkN "plåster" neutrum  ; -- plåster..nn.1
  plåstra_1_V = mkV "plåstrar" ; -- plåstra..vb.1
  plåstrande_1_N = mkN "plåstrande" ; -- plåstrande..nn.1
  plåt_1_N = mkN "plåt" ; -- plåt..nn.1
  plåta_1_V = mkV "plåtar" ; -- plåta..vb.1
  plåtande_1_N = mkN "plåtande" ; -- plåtande..nn.1
  plåtbearbetning_1_N = mkN "plåtbearbetning" ; -- plåtbearbetning..nn.1
  plåtfälg_1_N = mkN "plåtfälg" ; -- plåtfälg..nn.1
  plåtfärg_1_N = mkN "plåtfärg" "plåtfärger" ; -- plåtfärg..nn.1
  plåthuv_1_N = mkN "plåthuv" ; -- plåthuv..nn.1
  plåtkant_1_N = mkN "plåtkant" "plåtkanter" ; -- plåtkant..nn.1
  plåtkärl_1_N = mkN "plåtkärl" neutrum  ; -- plåtkärl..nn.1
  plåtlist_1_N = mkN "plåtlist" "plåtlister" ; -- plåtlist..nn.1
  plåtmage_1_N = mkN "plåtmage" utrum  ; -- plåtmage..nn.1
  plåtmynt_1_N = mkN "plåtmynt" neutrum  ; -- plåtmynt..nn.1
  plåtnav_1_N = mkN "plåtnav" neutrum  ; -- plåtnav..nn.1
  plåtpolis_1_N = mkN "plåtpolis" "plåtpoliser" ; -- plåtpolis..nn.1
  plåtsax_1_N = mkN "plåtsax" ; -- plåtsax..nn.1
  plåtschabrak_1_N = mkN "plåtschabrak" neutrum  ; -- plåtschabrak..nn.1
  plåtskada_1_N = mkN "plåtskada" ; -- plåtskada..nn.1
  plåtskiva_1_N = mkN "plåtskiva" ; -- plåtskiva..nn.1
  plåtskjul_1_N = mkN "plåtskjul" neutrum  ; -- plåtskjul..nn.1
  plåtskrammel_1_N = mkN "plåtskrammel" neutrum  ; -- plåtskrammel..nn.1
  plåtslagare_1_N = mkN "plåtslagare" utrum  ; -- plåtslagare..nn.1
  plåtslageri_1_N = mkN "plåtslageri" "plåtslageriet" "plåtslagerier" "plåtslagerierna" ; -- plåtslageri..nn.1
  plåttak_1_N = mkN "plåttak" neutrum  ; -- plåttak..nn.1
  plåtverktyg_1_N = mkN "plåtverktyg" neutrum  ; -- plåtverktyg..nn.1
  plöja_1_V = mkV "plöja" "plöjde" "plöjt" ; -- plöja..vb.1
  plöjande_1_N = mkN "plöjande" ; -- plöjande..nn.1
  plöjning_1_N = mkN "plöjning" ; -- plöjning..nn.1
  plörös_1_N = mkN "plörös" ; -- plörös..nn.1
  plös_1_N = mkN "plös" ; -- plös..nn.1
  plöska_1_N = mkN "plöska" ; -- plöska..nn.1
  plötslig_1_A = mkA "plötslig" ; -- plötslig..av.1
  plötsligen_1_Adv = mkAdv "plötsligen" ; -- plötsligen..ab.1
  plötslighet_1_N = mkN "plötslighet" "plötsligheter" ; -- plötslighet..nn.1
  pneumatik_1_N = mkN "pneumatik" ; -- pneumatik..nn.1
  pneumatisk_1_A = mkA "pneumatisk" ; -- pneumatisk..av.1
  pneumoni_1_N = mkN "pneumoni" "pneumonier" ; -- pneumoni..nn.1
  pochera_1_V = mkV "pocherar" ; -- pochera..vb.1
  pocherande_1_N = mkN "pocherande" ; -- pocherande..nn.1
  pocherbar_1_A = mkA "pocherbar" ; -- pocherbar..av.1
  pocherbarhet_1_N = mkN "pocherbarhet" ; -- pocherbarhet..nn.1
  pochering_1_N = mkN "pochering" ; -- pochering..nn.1
  pock_1_N = mkN "pock" neutrum  ; -- pock..nn.1
  pocka_1_V = mkV "pockar" ; -- pocka..vb.1
  pockande_1_N = mkN "pockande" ; -- pockande..nn.1
  pocker_1_N = mkN "pocker" ; -- pocker..nn.1
  pocket_1_N = mkN "pocket" ; -- pocket..nn.1
  pocketbok_1_N = mkN "pocketbok" "pocketböcker" ; -- pocketbok..nn.1
  podager_1_N = mkN "podager" ; -- podager..nn.1
  podest_1_N = mkN "podest" "podester" ; -- podest..nn.1
  podium_1_N = mkN "podium" "podiet" "podier" "podierna" ; -- podium..nn.1
  podsoljord_1_N = mkN "podsoljord" ; -- podsoljord..nn.1
  poem_1_N = mkN "poem" neutrum  ; -- poem..nn.1
  poesi_1_N = mkN "poesi" "poesier" ; -- poesi..nn.1
  poesiafton_1_N = mkN "poesiafton" "poesiaftonen" "poesiaftnar" "poesiaftnarna" ; -- poesiafton..nn.1
  poesiläsning_1_N = mkN "poesiläsning" ; -- poesiläsning..nn.1
  poesilös_1_A = mkA "poesilös" ; -- poesilös..av.1
  poesitradition_1_N = mkN "poesitradition" ; -- poesitradition..nn.1
  poet_1_N = mkN "poet" "poeter" ; -- poet..nn.1
  poetik_1_N = mkN "poetik" ; -- poetik..nn.1
  poetisk_1_A = mkA "poetisk" ; -- poetisk..av.1
  poetissa_1_N = mkN "poetissa" ; -- poetissa..nn.1
  pogram_1_N = mkN "pogram" "pogrammet" "pogram" "pogrammen" ; -- pogram..nn.1
  pogrom_1_N = mkN "pogrom" "pogromer" ; -- pogrom..nn.1
  pointer_1_N = mkN "pointer" ; -- pointer..nn.1
  pointera_1_V = mkV "pointerar" ; -- pointera..vb.1
  pointerande_1_N = mkN "pointerande" ; -- pointerande..nn.1
  pointerbar_1_A = mkA "pointerbar" ; -- pointerbar..av.1
  pointerbarhet_1_N = mkN "pointerbarhet" ; -- pointerbarhet..nn.1
  pointering_1_N = mkN "pointering" ; -- pointering..nn.1
  pointillism_1_N = mkN "pointillism" "pointillismer" ; -- pointillism..nn.1
  pointillistisk_1_A = mkA "pointillistisk" ; -- pointillistisk..av.1
  pojk_1_N = mkN "pojk" ; -- pojk..nn.1
  pojkaktig_1_A = mkA "pojkaktig" ; -- pojkaktig..av.1
  pojkaktighet_1_N = mkN "pojkaktighet" ; -- pojkaktighet..nn.1
  pojkbok_1_N = mkN "pojkbok" "pojkböcker" ; -- pojkbok..nn.1
  pojkbokshjälte_1_N = mkN "pojkbokshjälte" utrum  ; -- pojkbokshjälte..nn.1
  pojkboksrekvisita_1_N = mkN "pojkboksrekvisita" ; -- pojkboksrekvisita..nn.1
  pojkbyting_1_N = mkN "pojkbyting" ; -- pojkbyting..nn.1
  pojkcykel_1_N = mkN "pojkcykel" ; -- pojkcykel..nn.1
  pojke_1_N = mkN "pojke" utrum  ; -- pojke..nn.1
  pojkflicka_1_N = mkN "pojkflicka" ; -- pojkflicka..nn.1
  pojkfnasker_1_N = mkN "pojkfnasker" ; -- pojkfnasker..nn.1
  pojkhals_1_N = mkN "pojkhals" ; -- pojkhals..nn.1
  pojkinstinkt_1_N = mkN "pojkinstinkt" "pojkinstinkter" ; -- pojkinstinkt..nn.1
  pojklag_1_N = mkN "pojklag" neutrum  ; -- pojklag..nn.1
  pojklagsmässig_1_A = mkA "pojklagsmässig" ; -- pojklagsmässig..av.1
  pojknamn_1_N = mkN "pojknamn" neutrum  ; -- pojknamn..nn.1
  pojkorkester_1_N = mkN "pojkorkester" ; -- pojkorkester..nn.1
  pojkscout_1_N = mkN "pojkscout" "pojkscouter" ; -- pojkscout..nn.1
  pojkskildring_1_N = mkN "pojkskildring" ; -- pojkskildring..nn.1
  pojkslyngel_1_N = mkN "pojkslyngel" ; -- pojkslyngel..nn.1
  pojkspoling_1_N = mkN "pojkspoling" ; -- pojkspoling..nn.1
  pojkstreck_1_N = mkN "pojkstreck" neutrum  ; -- pojkstreck..nn.1
  pojktycke_1_N = mkN "pojktycke" ; -- pojktycke..nn.1
  pojkvasker_1_N = mkN "pojkvasker" ; -- pojkvasker..nn.1
  pojkvän_1_N = mkN "pojkvän" "pojkvännen" "pojkvänner" "pojkvännerna" ; -- pojkvän..nn.1
  pojkvärld_1_N = mkN "pojkvärld" ; -- pojkvärld..nn.1
  pojkår_1_N = mkN "pojkår" neutrum  ; -- pojkår..nn.1
  pokal_1_N = mkN "pokal" "pokaler" ; -- pokal..nn.1
  poker_1_N = mkN "poker" ; -- poker..nn.1
  pokeransikte_1_N = mkN "pokeransikte" ; -- pokeransikte..nn.1
  pokerface_1_N = mkN "pokerface" ; -- pokerface..nn.1
  pokerhand_1_N = mkN "pokerhand" "pokerhänder" ; -- pokerhand..nn.1
  pokerparti_1_N = mkN "pokerparti" "pokerpartiet" "pokerpartier" "pokerpartierna" ; -- pokerparti..nn.1
  pokerprofil_1_N = mkN "pokerprofil" "pokerprofiler" ; -- pokerprofil..nn.1
  pokulera_1_V = mkV "pokulerar" ; -- pokulera..vb.1
  pokulerande_1_N = mkN "pokulerande" ; -- pokulerande..nn.1
  pokulering_1_N = mkN "pokulering" ; -- pokulering..nn.1
  pol_1_N = mkN "pol" "poler" ; -- pol..nn.1
  pola_1_V = mkV "polar" ; -- pola..vb.1
  polack_1_N = mkN "polack" "polacker" ; -- polack..nn.1
  polande_1_N = mkN "polande" ; -- polande..nn.1
  polar_1_A = mkA "polar" ; -- polar..av.1
  polardag_1_N = mkN "polardag" ; -- polardag..nn.1
  polardimma_1_N = mkN "polardimma" ; -- polardimma..nn.1
  polare_1_N = mkN "polare" utrum  ; -- polare..nn.1
  polarexpedition_1_N = mkN "polarexpedition" ; -- polarexpedition..nn.1
  polarflyg_1_N = mkN "polarflyg" neutrum  ; -- polarflyg..nn.1
  polarforskning_1_N = mkN "polarforskning" ; -- polarforskning..nn.1
  polarfront_1_N = mkN "polarfront" "polarfronter" ; -- polarfront..nn.1
  polarhav_1_N = mkN "polarhav" neutrum  ; -- polarhav..nn.1
  polaris_1_N = mkN "polaris" ; -- polaris..nn.1
  polarisation_1_N = mkN "polarisation" ; -- polarisation..nn.1
  polarisationsfilter_1_N = mkN "polarisationsfilter" neutrum  ; -- polarisationsfilter..nn.1
  polarisator_1_N = mkN "polarisator" "polarisatorer" ; -- polarisator..nn.1
  polarisera_1_V = mkV "polariserar" ; -- polarisera..vb.1
  polariserande_1_N = mkN "polariserande" ; -- polariserande..nn.1
  polariserbar_1_A = mkA "polariserbar" ; -- polariserbar..av.1
  polariserbarhet_1_N = mkN "polariserbarhet" ; -- polariserbarhet..nn.1
  polarisering_1_N = mkN "polarisering" ; -- polarisering..nn.1
  polaritet_1_N = mkN "polaritet" "polariteter" ; -- polaritet..nn.1
  polarluft_1_N = mkN "polarluft" ; -- polarluft..nn.1
  polarmiljö_1_N = mkN "polarmiljö" "polarmiljön" "polarmiljöer" "polarmiljöerna" ; -- polarmiljö..nn.1
  polarmörker_1_N = mkN "polarmörker" neutrum  ; -- polarmörker..nn.1
  polarnatt_1_N = mkN "polarnatt" ; -- polarnatt..nn.1
  polaroidfilm_1_N = mkN "polaroidfilm" "polaroidfilmer" ; -- polaroidfilm..nn.1
  polaroidkamera_1_N = mkN "polaroidkamera" ; -- polaroidkamera..nn.1
  polarområde_1_N = mkN "polarområde" ; -- polarområde..nn.1
  polarräv_1_N = mkN "polarräv" ; -- polarräv..nn.1
  polarsken_1_N = mkN "polarsken" neutrum  ; -- polarsken..nn.1
  polartrakt_1_N = mkN "polartrakt" "polartrakter" ; -- polartrakt..nn.1
  polarvinter_1_N = mkN "polarvinter" ; -- polarvinter..nn.1
  polcirkel_1_N = mkN "polcirkel" ; -- polcirkel..nn.1
  polder_1_N = mkN "polder" ; -- polder..nn.1
  polderland_1_N = mkN "polderland" neutrum  ; -- polderland..nn.1
  polemik_1_N = mkN "polemik" "polemiker" ; -- polemik..nn.1
  polemiker_1_N = mkN "polemiker" "polemikern" "polemiker" "polemikerna" ; -- polemiker..nn.1
  polemisera_1_V = mkV "polemiserar" ; -- polemisera..vb.1
  polemiserande_1_N = mkN "polemiserande" ; -- polemiserande..nn.1
  polemisering_1_N = mkN "polemisering" ; -- polemisering..nn.1
  polemisk_1_A = mkA "polemisk" ; -- polemisk..av.1
  polenta_1_N = mkN "polenta" ; -- polenta..nn.1
  polentagryn_1_N = mkN "polentagryn" neutrum  ; -- polentagryn..nn.1
  polera_1_V = mkV "polerar" ; -- polera..vb.1
  polerad_1_A = mkA "polerad" ; -- polerad..av.1
  polerande_1_N = mkN "polerande" ; -- polerande..nn.1
  polerbar_1_A = mkA "polerbar" ; -- polerbar..av.1
  polerbarhet_1_N = mkN "polerbarhet" ; -- polerbarhet..nn.1
  polerduk_1_N = mkN "polerduk" ; -- polerduk..nn.1
  polering_1_N = mkN "polering" ; -- polering..nn.1
  polermaskin_1_N = mkN "polermaskin" "polermaskiner" ; -- polermaskin..nn.1
  polermedel_1_N = mkN "polermedel" neutrum  ; -- polermedel..nn.1
  polerpasta_1_N = mkN "polerpasta" ; -- polerpasta..nn.1
  polerrondell_1_N = mkN "polerrondell" "polerrondeller" ; -- polerrondell..nn.1
  polersvamp_1_N = mkN "polersvamp" ; -- polersvamp..nn.1
  polertrassel_1_N = mkN "polertrassel" neutrum  ; -- polertrassel..nn.1
  polervax_1_N = mkN "polervax" "polervaxet" "polervaxer" "polervaxerna" ; -- polervax..nn.1
  polhemsknut_1_N = mkN "polhemsknut" ; -- polhemsknut..nn.1
  polhemslås_1_N = mkN "polhemslås" neutrum  ; -- polhemslås..nn.1
  polhöjd_1_N = mkN "polhöjd" ; -- polhöjd..nn.1
  policy_1_N = mkN "policy" "policyn" "policysar" "policysarna" ; -- policy..nn.1
  poliklinik_1_N = mkN "poliklinik" "polikliniker" ; -- poliklinik..nn.1
  poliklinisk_1_A = mkA "poliklinisk" ; -- poliklinisk..av.1
  polio_1_N = mkN "polio" ; -- polio..nn.1
  poliomyelit_1_N = mkN "poliomyelit" ; -- poliomyelit..nn.1
  polis_1_N = mkN "polis" ; -- polis..nn.1
  polis_2_N = mkN "polis" "poliser" ; -- polis..nn.2
  polisanmäla_1_V = mkV "polisanmäler" ; -- polisanmäla..vb.1
  polisanmälande_1_N = mkN "polisanmälande" ; -- polisanmälande..nn.1
  polisanmälning_1_N = mkN "polisanmälning" ; -- polisanmälning..nn.1
  polisarbete_1_N = mkN "polisarbete" ; -- polisarbete..nn.1
  polisarrest_1_N = mkN "polisarrest" "polisarrester" ; -- polisarrest..nn.1
  polisaspirant_1_N = mkN "polisaspirant" "polisaspiranter" ; -- polisaspirant..nn.1
  polisbefäl_1_N = mkN "polisbefäl" neutrum  ; -- polisbefäl..nn.1
  polisbevaka_1_V = mkV "polisbevakar" ; -- polisbevaka..vb.1
  polisbevakande_1_N = mkN "polisbevakande" ; -- polisbevakande..nn.1
  polisbevakning_1_N = mkN "polisbevakning" ; -- polisbevakning..nn.1
  polisbil_1_N = mkN "polisbil" ; -- polisbil..nn.1
  polisbricka_1_N = mkN "polisbricka" ; -- polisbricka..nn.1
  polischef_1_N = mkN "polischef" "polischefer" ; -- polischef..nn.1
  polischock_1_N = mkN "polischock" "polischocker" ; -- polischock..nn.1
  polisdistrikt_1_N = mkN "polisdistrikt" neutrum  ; -- polisdistrikt..nn.1
  polisfordon_1_N = mkN "polisfordon" neutrum  ; -- polisfordon..nn.1
  polisförhör_1_N = mkN "polisförhör" neutrum  ; -- polisförhör..nn.1
  polisförordning_1_N = mkN "polisförordning" ; -- polisförordning..nn.1
  polish_1_N = mkN "polish" ; -- polish..nn.1
  polishelikopter_1_N = mkN "polishelikopter" ; -- polishelikopter..nn.1
  polishjälm_1_N = mkN "polishjälm" ; -- polishjälm..nn.1
  polishund_1_N = mkN "polishund" ; -- polishund..nn.1
  polishus_1_N = mkN "polishus" neutrum  ; -- polishus..nn.1
  polisingripande_1_N = mkN "polisingripande" ; -- polisingripande..nn.1
  polisintendent_1_N = mkN "polisintendent" "polisintendenter" ; -- polisintendent..nn.1
  polisiär_1_A = mkA "polisiär" ; -- polisiär..av.1
  poliskedja_1_N = mkN "poliskedja" ; -- poliskedja..nn.1
  poliskommissarie_1_N = mkN "poliskommissarie" "poliskommissarier" ; -- poliskommissarie..nn.1
  poliskonstapel_1_N = mkN "poliskonstapel" ; -- poliskonstapel..nn.1
  poliskund_1_N = mkN "poliskund" "poliskunder" ; -- poliskund..nn.1
  poliskvinna_1_N = mkN "poliskvinna" ; -- poliskvinna..nn.1
  poliskår_1_N = mkN "poliskår" "poliskårer" ; -- poliskår..nn.1
  polismajor_1_N = mkN "polismajor" "polismajoren" "polismajorer" "polismajorerna" ; -- polismajor..nn.1
  polismakt_1_N = mkN "polismakt" ; -- polismakt..nn.1
  polisman_1_N = mkN "polisman" "polismannen" "polismän" "polismännen" ; -- polisman..nn.1
  polismyndighet_1_N = mkN "polismyndighet" "polismyndigheter" ; -- polismyndighet..nn.1
  polismästare_1_N = mkN "polismästare" utrum  ; -- polismästare..nn.1
  polisnatur_1_N = mkN "polisnatur" "polisnaturer" ; -- polisnatur..nn.1
  polisong_1_N = mkN "polisong" "polisonger" ; -- polisong..nn.1
  polisorganisation_1_N = mkN "polisorganisation" ; -- polisorganisation..nn.1
  polispatrull_1_N = mkN "polispatrull" "polispatruller" ; -- polispatrull..nn.1
  polisserie_1_N = mkN "polisserie" "polisserier" ; -- polisserie..nn.1
  polisspaning_1_N = mkN "polisspaning" ; -- polisspaning..nn.1
  polisstat_1_N = mkN "polisstat" "polisstater" ; -- polisstat..nn.1
  polisstation_1_N = mkN "polisstation" ; -- polisstation..nn.1
  polisstyrka_1_N = mkN "polisstyrka" ; -- polisstyrka..nn.1
  polistejp_1_N = mkN "polistejp" ; -- polistejp..nn.1
  polistekniker_1_N = mkN "polistekniker" "polisteknikern" "polistekniker" "polisteknikerna" ; -- polistekniker..nn.1
  polistillslag_1_N = mkN "polistillslag" neutrum  ; -- polistillslag..nn.1
  polistjänst_1_N = mkN "polistjänst" "polistjänster" ; -- polistjänst..nn.1
  polistjänsteman_1_N = mkN "polistjänsteman" "polistjänstemannen" "polistjänstemän" "polistjänstemännen" ; -- polistjänsteman..nn.1
  polistjänstgöring_1_N = mkN "polistjänstgöring" ; -- polistjänstgöring..nn.1
  polisundersökning_1_N = mkN "polisundersökning" ; -- polisundersökning..nn.1
  polisuniform_1_N = mkN "polisuniform" "polisuniformer" ; -- polisuniform..nn.1
  polisutredning_1_N = mkN "polisutredning" ; -- polisutredning..nn.1
  polisutryckning_1_N = mkN "polisutryckning" ; -- polisutryckning..nn.1
  polisväsende_1_N = mkN "polisväsende" ; -- polisväsende..nn.1
  polisyrke_1_N = mkN "polisyrke" ; -- polisyrke..nn.1
  polisärende_1_N = mkN "polisärende" ; -- polisärende..nn.1
  politbyrå_1_N = mkN "politbyrå" "politbyråer" ; -- politbyrå..nn.1
  politess_1_N = mkN "politess" ; -- politess..nn.1
  politik_1_N = mkN "politik" ; -- politik..nn.1
  politiker_1_N = mkN "politiker" "politikern" "politiker" "politikerna" ; -- politiker..nn.1
  politikerförakt_1_N = mkN "politikerförakt" neutrum  ; -- politikerförakt..nn.1
  politikerhustru_1_N = mkN "politikerhustru" "politikerhustrun" "politikerhustrur" "politikerhustrurna" ; -- politikerhustru..nn.1
  politikermisstro_1_N = mkN "politikermisstro" ; -- politikermisstro..nn.1
  politikerporträtt_1_N = mkN "politikerporträtt" neutrum  ; -- politikerporträtt..nn.1
  politikervecka_1_N = mkN "politikervecka" ; -- politikervecka..nn.1
  politikus_1_N = mkN "politikus" ; -- politikus..nn.1
  politisera_1_V = mkV "politiserar" ; -- politisera..vb.1
  politiserande_1_N = mkN "politiserande" ; -- politiserande..nn.1
  politiserbar_1_A = mkA "politiserbar" ; -- politiserbar..av.1
  politiserbarhet_1_N = mkN "politiserbarhet" ; -- politiserbarhet..nn.1
  politisering_1_N = mkN "politisering" ; -- politisering..nn.1
  politisk_1_A = mkA "politisk" ; -- politisk..av.1
  politruk_1_N = mkN "politruk" "politruker" ; -- politruk..nn.1
  polityr_1_N = mkN "polityr" "polityrer" ; -- polityr..nn.1
  polka_1_N = mkN "polka" ; -- polka..nn.1
  polkagris_1_N = mkN "polkagris" ; -- polkagris..nn.1
  polkahår_1_N = mkN "polkahår" neutrum  ; -- polkahår..nn.1
  polkett_1_N = mkN "polkett" "polketter" ; -- polkett..nn.1
  polkropp_1_N = mkN "polkropp" ; -- polkropp..nn.1
  pollare_1_N = mkN "pollare" utrum  ; -- pollare..nn.1
  pollen_1_N = mkN "pollen" neutrum  ; -- pollen..nn.1
  pollenallergi_1_N = mkN "pollenallergi" "pollenallergier" ; -- pollenallergi..nn.1
  pollenanalys_1_N = mkN "pollenanalys" ; -- pollenanalys..nn.1
  pollendiagram_1_N = mkN "pollendiagram" "pollendiagrammet" "pollendiagram" "pollendiagrammen" ; -- pollendiagram..nn.1
  pollenfynd_1_N = mkN "pollenfynd" neutrum  ; -- pollenfynd..nn.1
  pollenförekomst_1_N = mkN "pollenförekomst" "pollenförekomster" ; -- pollenförekomst..nn.1
  pollenkorn_1_N = mkN "pollenkorn" neutrum  ; -- pollenkorn..nn.1
  pollenplåga_1_N = mkN "pollenplåga" ; -- pollenplåga..nn.1
  pollenslang_1_N = mkN "pollenslang" ; -- pollenslang..nn.1
  pollett_1_N = mkN "pollett" "polletter" ; -- pollett..nn.1
  pollettera_1_V = mkV "polletterar" ; -- pollettera..vb.1
  polletterande_1_N = mkN "polletterande" ; -- polletterande..nn.1
  polletterbar_1_A = mkA "polletterbar" ; -- polletterbar..av.1
  polletterbarhet_1_N = mkN "polletterbarhet" ; -- polletterbarhet..nn.1
  pollettering_1_N = mkN "pollettering" ; -- pollettering..nn.1
  pollination_1_N = mkN "pollination" ; -- pollination..nn.1
  pollinera_1_V = mkV "pollinerar" ; -- pollinera..vb.1
  pollinerande_1_N = mkN "pollinerande" ; -- pollinerande..nn.1
  pollinerbar_1_A = mkA "pollinerbar" ; -- pollinerbar..av.1
  pollinerbarhet_1_N = mkN "pollinerbarhet" ; -- pollinerbarhet..nn.1
  pollinering_1_N = mkN "pollinering" ; -- pollinering..nn.1
  pollution_1_N = mkN "pollution" ; -- pollution..nn.1
  polo_1_N = mkN "polo" ; -- polo..nn.1
  polo_2_N = mkN "polo" ; -- polo..nn.2
  poloboll_1_N = mkN "poloboll" ; -- poloboll..nn.1
  polohäst_1_N = mkN "polohäst" ; -- polohäst..nn.1
  poloklubba_1_N = mkN "poloklubba" ; -- poloklubba..nn.1
  polokrage_1_N = mkN "polokrage" utrum  ; -- polokrage..nn.1
  polonium_1_N = mkN "polonium" neutrum  ; -- polonium..nn.1
  polonäs_1_N = mkN "polonäs" "polonäser" ; -- polonäs..nn.1
  polospelare_1_N = mkN "polospelare" utrum  ; -- polospelare..nn.1
  polotröja_1_N = mkN "polotröja" ; -- polotröja..nn.1
  polsk_fransk_1_A = mkA "polsk-fransk" ; -- polsk-fransk..av.1
  polsk_1_A = mkA "polsk" ; -- polsk..av.1
  polska_1_N = mkN "polska" ; -- polska..nn.1
  polska_2_N = mkN "polska" ; -- polska..nn.2
  polskhet_1_N = mkN "polskhet" ; -- polskhet..nn.1
  polsko_1_N = mkN "polsko" "polskor" ; -- polsko..nn.1
  polstjärna_1_N = mkN "polstjärna" ; -- polstjärna..nn.1
  polstra_1_V = mkV "polstrar" ; -- polstra..vb.1
  polstrande_1_N = mkN "polstrande" ; -- polstrande..nn.1
  polvändning_1_N = mkN "polvändning" ; -- polvändning..nn.1
  polvändningsskydd_1_N = mkN "polvändningsskydd" neutrum  ; -- polvändningsskydd..nn.1
  polyamid_1_N = mkN "polyamid" "polyamider" ; -- polyamid..nn.1
  polyandri_1_N = mkN "polyandri" ; -- polyandri..nn.1
  polycentrism_1_N = mkN "polycentrism" "polycentrismer" ; -- polycentrism..nn.1
  polyeder_1_N = mkN "polyeder" ; -- polyeder..nn.1
  polyester_1_N = mkN "polyester" ; -- polyester..nn.1
  polyesterbaserad_1_A = mkA "polyesterbaserad" ; -- polyesterbaserad..av.1
  polyeten_1_N = mkN "polyeten" neutrum  ; -- polyeten..nn.1
  polyeter_1_N = mkN "polyeter" ; -- polyeter..nn.1
  polyfon_1_A = mkA "polyfon" ; -- polyfon..av.1
  polyfoni_1_N = mkN "polyfoni" "polyfonier" ; -- polyfoni..nn.1
  polyfosfat_1_N = mkN "polyfosfat" "polyfosfater" ; -- polyfosfat..nn.1
  polygam_1_A = mkA "polygam" ; -- polygam..av.1
  polygami_1_N = mkN "polygami" ; -- polygami..nn.1
  polygamist_1_N = mkN "polygamist" "polygamister" ; -- polygamist..nn.1
  polyglott_1_A = mkA "polyglott" ; -- polyglott..av.1
  polyglott_1_N = mkN "polyglott" "polyglotter" ; -- polyglott..nn.1
  polygon_1_N = mkN "polygon" "polygoner" ; -- polygon..nn.1
  polygraf_1_N = mkN "polygraf" "polygrafer" ; -- polygraf..nn.1
  polygyni_1_N = mkN "polygyni" ; -- polygyni..nn.1
  polyhistor_1_N = mkN "polyhistor" "polyhistorer" ; -- polyhistor..nn.1
  polyhistorisk_1_A = mkA "polyhistorisk" ; -- polyhistorisk..av.1
  polyklorerad_1_A = mkA "polyklorerad" ; -- polyklorerad..av.1
  polykrom_1_A = mkA "polykrom" ; -- polykrom..av.1
  polymer_1_N = mkN "polymer" "polymerer" ; -- polymer..nn.1
  polymerbeläggning_1_N = mkN "polymerbeläggning" ; -- polymerbeläggning..nn.1
  polymerisation_1_N = mkN "polymerisation" ; -- polymerisation..nn.1
  polymerlösning_1_N = mkN "polymerlösning" ; -- polymerlösning..nn.1
  polymorf_1_A = mkA "polymorf" ; -- polymorf..av.1
  polymorfisk_1_A = mkA "polymorfisk" ; -- polymorfisk..av.1
  polynesier_1_N = mkN "polynesier" "polynesiern" "polynesier" "polynesierna" ; -- polynesier..nn.1
  polynesisk_1_A = mkA "polynesisk" ; -- polynesisk..av.1
  polynesiska_1_N = mkN "polynesiska" ; -- polynesiska..nn.1
  polynia_1_N = mkN "polynia" ; -- polynia..nn.1
  polynom_1_N = mkN "polynom" neutrum  ; -- polynom..nn.1
  polyp_1_N = mkN "polyp" "polyper" ; -- polyp..nn.1
  polypropen_1_N = mkN "polypropen" neutrum  ; -- polypropen..nn.1
  polypropenmaterial_1_N = mkN "polypropenmaterial" neutrum  ; -- polypropenmaterial..nn.1
  polystyren_1_N = mkN "polystyren" neutrum  ; -- polystyren..nn.1
  polysyndes_1_N = mkN "polysyndes" "polysyndeser" ; -- polysyndes..nn.1
  polyteism_1_N = mkN "polyteism" "polyteismer" ; -- polyteism..nn.1
  polyteist_1_N = mkN "polyteist" "polyteister" ; -- polyteist..nn.1
  polyteistisk_1_A = mkA "polyteistisk" ; -- polyteistisk..av.1
  polyteknisk_1_A = mkA "polyteknisk" ; -- polyteknisk..av.1
  polyuretan_1_N = mkN "polyuretan" ; -- polyuretan..nn.1
  polyvinylklorid_1_N = mkN "polyvinylklorid" ; -- polyvinylklorid..nn.1
  polär_1_A = mkA "polär" ; -- polär..av.1
  pomada_1_N = mkN "pomada" ; -- pomada..nn.1
  pomadera_1_V = mkV "pomaderar" ; -- pomadera..vb.1
  pomaderande_1_N = mkN "pomaderande" ; -- pomaderande..nn.1
  pomaderbar_1_A = mkA "pomaderbar" ; -- pomaderbar..av.1
  pomaderbarhet_1_N = mkN "pomaderbarhet" ; -- pomaderbarhet..nn.1
  pomadering_1_N = mkN "pomadering" ; -- pomadering..nn.1
  pomerans_1_N = mkN "pomerans" "pomeranser" ; -- pomerans..nn.1
  pomeransskal_1_N = mkN "pomeransskal" neutrum  ; -- pomeransskal..nn.1
  pommersk_1_A = mkA "pommersk" ; -- pommersk..av.1
  pomolog_1_N = mkN "pomolog" "pomologer" ; -- pomolog..nn.1
  pomologi_1_N = mkN "pomologi" ; -- pomologi..nn.1
  pomologisk_1_A = mkA "pomologisk" ; -- pomologisk..av.1
  pomp_1_N = mkN "pomp" ; -- pomp..nn.1
  pompa_1_N = mkN "pompa" ; -- pompa..nn.1
  pomperipossaeffekt_1_N = mkN "pomperipossaeffekt" ; -- pomperipossaeffekt..nn.1
  pompong_1_N = mkN "pompong" "pomponger" ; -- pompong..nn.1
  pompös_1_A = mkA "pompös" ; -- pompös..av.1
  poncho_1_N = mkN "poncho" "ponchor" ; -- poncho..nn.1
  pond_1_N = mkN "pond" neutrum  ; -- pond..nn.1
  ponderabel_1_A = mkA "ponderabel" ; -- ponderabel..av.1
  pondus_1_N = mkN "pondus" ; -- pondus..nn.1
  ponera_1_V = mkV "ponerar" ; -- ponera..vb.1
  ponerande_1_N = mkN "ponerande" ; -- ponerande..nn.1
  ponering_1_N = mkN "ponering" ; -- ponering..nn.1
  ponny_1_N = mkN "ponny" "ponnyn" "ponnysar" "ponnysarna" ; -- ponny..nn.1
  pontifikat_1_N = mkN "pontifikat" neutrum  ; -- pontifikat..nn.1
  ponton_1_N = mkN "ponton" "pontoner" ; -- ponton..nn.1
  pontonbro_1_N = mkN "pontonbro" ; -- pontonbro..nn.1
  pontonbrygga_1_N = mkN "pontonbrygga" ; -- pontonbrygga..nn.1
  pontonjär_1_N = mkN "pontonjär" "pontonjärer" ; -- pontonjär..nn.1
  pool_1_N = mkN "pool" "pooler" ; -- pool..nn.1
  poolkant_1_N = mkN "poolkant" "poolkanter" ; -- poolkant..nn.1
  pop_1_N = mkN "pop" ; -- pop..nn.1
  pop_2_N = mkN "pop" "poper" ; -- pop..nn.2
  popcorn_1_N = mkN "popcorn" neutrum  ; -- popcorn..nn.1
  popcornapparat_1_N = mkN "popcornapparat" "popcornapparater" ; -- popcornapparat..nn.1
  popdänga_1_N = mkN "popdänga" ; -- popdänga..nn.1
  popgrupp_1_N = mkN "popgrupp" "popgrupper" ; -- popgrupp..nn.1
  popkonsert_1_N = mkN "popkonsert" "popkonserter" ; -- popkonsert..nn.1
  popkonst_1_N = mkN "popkonst" ; -- popkonst..nn.1
  poplin_1_N = mkN "poplin" "popliner" ; -- poplin..nn.1
  poplinrock_1_N = mkN "poplinrock" ; -- poplinrock..nn.1
  poplåt_1_N = mkN "poplåt" ; -- poplåt..nn.1
  popmusik_1_N = mkN "popmusik" ; -- popmusik..nn.1
  popmusiker_1_N = mkN "popmusiker" "popmusikern" "popmusiker" "popmusikerna" ; -- popmusiker..nn.1
  popp_1_N = mkN "popp" ; -- popp..nn.1
  poppa_1_V = mkV "poppar" ; -- poppa..vb.1
  poppande_1_N = mkN "poppande" ; -- poppande..nn.1
  poppel_1_N = mkN "poppel" ; -- poppel..nn.1
  poppig_1_A = mkA "poppig" ; -- poppig..av.1
  poppighet_1_N = mkN "poppighet" ; -- poppighet..nn.1
  poppis_1_A = mkA "poppis" ; -- poppis..av.1
  popsångare_1_N = mkN "popsångare" utrum  ; -- popsångare..nn.1
  popsångerska_1_N = mkN "popsångerska" ; -- popsångerska..nn.1
  popularisator_1_N = mkN "popularisator" "popularisatorer" ; -- popularisator..nn.1
  popularisera_1_V = mkV "populariserar" ; -- popularisera..vb.1
  populariserande_1_N = mkN "populariserande" ; -- populariserande..nn.1
  populariserbar_1_A = mkA "populariserbar" ; -- populariserbar..av.1
  populariserbarhet_1_N = mkN "populariserbarhet" ; -- populariserbarhet..nn.1
  popularisering_1_N = mkN "popularisering" ; -- popularisering..nn.1
  popularitet_1_N = mkN "popularitet" "populariteter" ; -- popularitet..nn.1
  popularitetsjakt_1_N = mkN "popularitetsjakt" ; -- popularitetsjakt..nn.1
  popularitetsjägare_1_N = mkN "popularitetsjägare" utrum  ; -- popularitetsjägare..nn.1
  popularitetsmässig_1_A = mkA "popularitetsmässig" ; -- popularitetsmässig..av.1
  populas_1_N = mkN "populas" ; -- populas..nn.1
  population_1_N = mkN "population" ; -- population..nn.1
  populism_1_N = mkN "populism" "populismer" ; -- populism..nn.1
  populist_1_N = mkN "populist" "populister" ; -- populist..nn.1
  populistisk_1_A = mkA "populistisk" ; -- populistisk..av.1
  populär_1_A = mkA "populär" ; -- populär..av.1
  populärkonsert_1_N = mkN "populärkonsert" "populärkonserter" ; -- populärkonsert..nn.1
  populärkultur_1_N = mkN "populärkultur" "populärkulturer" ; -- populärkultur..nn.1
  populärkulturalitet_1_N = mkN "populärkulturalitet" ; -- populärkulturalitet..nn.1
  populärkulturell_1_A = mkA "populärkulturell" ; -- populärkulturell..av.1
  populärmusik_1_N = mkN "populärmusik" ; -- populärmusik..nn.1
  populärpress_1_N = mkN "populärpress" ; -- populärpress..nn.1
  populärvetenskap_1_N = mkN "populärvetenskap" ; -- populärvetenskap..nn.1
  populärvetenskaplig_1_A = mkA "populärvetenskaplig" ; -- populärvetenskaplig..av.1
  populärvetenskaplighet_1_N = mkN "populärvetenskaplighet" ; -- populärvetenskaplighet..nn.1
  por_1_N = mkN "por" "poren" "porer" "porerna" ; -- por..nn.1
  porfyr_1_N = mkN "porfyr" "porfyrer" ; -- porfyr..nn.1
  porig_1_A = mkA "porig" ; -- porig..av.1
  porl_1_N = mkN "porl" neutrum  ; -- porl..nn.1
  porla_1_V = mkV "porlar" ; -- porla..vb.1
  porlande_1_N = mkN "porlande" ; -- porlande..nn.1
  pormask_1_N = mkN "pormask" ; -- pormask..nn.1
  pornografi_1_N = mkN "pornografi" ; -- pornografi..nn.1
  pornografisk_1_A = mkA "pornografisk" ; -- pornografisk..av.1
  porositet_1_N = mkN "porositet" "porositeter" ; -- porositet..nn.1
  porr_1_N = mkN "porr" ; -- porr..nn.1
  porrfilm_1_N = mkN "porrfilm" "porrfilmer" ; -- porrfilm..nn.1
  porrfilmsproducent_1_N = mkN "porrfilmsproducent" "porrfilmsproducenter" ; -- porrfilmsproducent..nn.1
  porrig_1_A = mkA "porrig" ; -- porrig..av.1
  porrighet_1_N = mkN "porrighet" ; -- porrighet..nn.1
  porrklubb_1_N = mkN "porrklubb" ; -- porrklubb..nn.1
  porrmodell_1_N = mkN "porrmodell" "porrmodeller" ; -- porrmodell..nn.1
  porrstjärna_1_N = mkN "porrstjärna" ; -- porrstjärna..nn.1
  porrsurfa_1_V = mkV "porrsurfar" ; -- porrsurfa..vb.1
  porrsurfande_1_N = mkN "porrsurfande" ; -- porrsurfande..nn.1
  porrsurfning_1_N = mkN "porrsurfning" ; -- porrsurfning..nn.1
  porrtidning_1_N = mkN "porrtidning" ; -- porrtidning..nn.1
  pors_1_N = mkN "pors" ; -- pors..nn.1
  porslin_1_N = mkN "porslin" "porslinet" "porsliner" "porslinerna" ; -- porslin..nn.1
  porslinsaffär_1_N = mkN "porslinsaffär" "porslinsaffärer" ; -- porslinsaffär..nn.1
  porslinsblomma_1_N = mkN "porslinsblomma" ; -- porslinsblomma..nn.1
  porslinsdegel_1_N = mkN "porslinsdegel" ; -- porslinsdegel..nn.1
  porslinsfigur_1_N = mkN "porslinsfigur" "porslinsfigurer" ; -- porslinsfigur..nn.1
  porslinsfilter_1_N = mkN "porslinsfilter" neutrum  ; -- porslinsfilter..nn.1
  porslinsfärg_1_N = mkN "porslinsfärg" "porslinsfärger" ; -- porslinsfärg..nn.1
  porslinskrossning_1_N = mkN "porslinskrossning" ; -- porslinskrossning..nn.1
  porslinskula_1_N = mkN "porslinskula" ; -- porslinskula..nn.1
  porslinsmålning_1_N = mkN "porslinsmålning" ; -- porslinsmålning..nn.1
  porslinsskål_1_N = mkN "porslinsskål" ; -- porslinsskål..nn.1
  porslinsskåp_1_N = mkN "porslinsskåp" neutrum  ; -- porslinsskåp..nn.1
  porslinssäkring_1_N = mkN "porslinssäkring" ; -- porslinssäkring..nn.1
  porslinstillverkning_1_N = mkN "porslinstillverkning" ; -- porslinstillverkning..nn.1
  porslinsvara_1_N = mkN "porslinsvara" ; -- porslinsvara..nn.1
  porslinsyta_1_N = mkN "porslinsyta" ; -- porslinsyta..nn.1
  porsvamp_1_N = mkN "porsvamp" ; -- porsvamp..nn.1
  port_1_N = mkN "port" ; -- port..nn.1
  porta_1_V = mkV "portar" ; -- porta..vb.1
  portabel_1_A = mkA "portabel" ; -- portabel..av.1
  portal_1_N = mkN "portal" "portaler" ; -- portal..nn.1
  portalbegrepp_1_N = mkN "portalbegrepp" neutrum  ; -- portalbegrepp..nn.1
  portalfigur_1_N = mkN "portalfigur" "portalfigurer" ; -- portalfigur..nn.1
  portalgestalt_1_N = mkN "portalgestalt" "portalgestalter" ; -- portalgestalt..nn.1
  portamento_1_N = mkN "portamento" "portamentot" "portamenton" "portamentona" ; -- portamento..nn.1
  portande_1_N = mkN "portande" ; -- portande..nn.1
  portativ_1_A = mkA "portativ" ; -- portativ..av.1
  portepé_1_N = mkN "portepé" "portepéer" ; -- portepé..nn.1
  porter_1_N = mkN "porter" "portern" "porter" "porterna" ; -- porter..nn.1
  portfölj_1_N = mkN "portfölj" "portföljer" ; -- portfölj..nn.1
  portföljbärare_1_N = mkN "portföljbärare" utrum  ; -- portföljbärare..nn.1
  portförbjuda_1_V = mkV "portförbjuda" "portförbjöd" "portförbjudit" ; -- portförbjuda..vb.1
  portförbjudande_1_N = mkN "portförbjudande" ; -- portförbjudande..nn.1
  portförbud_1_N = mkN "portförbud" neutrum  ; -- portförbud..nn.1
  portföre_1_N = mkN "portföre" ; -- portföre..nn.1
  portgång_1_N = mkN "portgång" ; -- portgång..nn.1
  porthalva_1_N = mkN "porthalva" ; -- porthalva..nn.1
  portier_1_N = mkN "portier" "portierer" ; -- portier..nn.1
  portik_1_N = mkN "portik" "portiker" ; -- portik..nn.1
  portingång_1_N = mkN "portingång" ; -- portingång..nn.1
  portion_1_N = mkN "portion" ; -- portion..nn.1
  portionera_1_V = mkV "portionerar" ; -- portionera..vb.1
  portionerande_1_N = mkN "portionerande" ; -- portionerande..nn.1
  portionerbar_1_A = mkA "portionerbar" ; -- portionerbar..av.1
  portionerbarhet_1_N = mkN "portionerbarhet" ; -- portionerbarhet..nn.1
  portionering_1_N = mkN "portionering" ; -- portionering..nn.1
  portionssnus_1_N = mkN "portionssnus" "portionssnuset" "portionssnuser" "portionssnuserna" ; -- portionssnus..nn.1
  portionsvis_1_Adv = mkAdv "portionsvis" ; -- portionsvis..ab.1
  portiär_1_N = mkN "portiär" "portiärer" ; -- portiär..nn.1
  portklapp_1_N = mkN "portklapp" ; -- portklapp..nn.1
  portlucka_1_N = mkN "portlucka" ; -- portlucka..nn.1
  portmonnä_1_N = mkN "portmonnä" "portmonnän" "portmonnäer" "portmonnäerna" ; -- portmonnä..nn.1
  portnyckel_1_N = mkN "portnyckel" ; -- portnyckel..nn.1
  porto_1_N = mkN "porto" "portot" "porton" "portona" ; -- porto..nn.1
  portofri_1_A = mkA "portofri" "portofritt" ; -- portofri..av.1
  portofrihet_1_N = mkN "portofrihet" ; -- portofrihet..nn.1
  porträtt_1_N = mkN "porträtt" neutrum  ; -- porträtt..nn.1
  porträttbyst_1_N = mkN "porträttbyst" "porträttbyster" ; -- porträttbyst..nn.1
  porträttera_1_V = mkV "porträtterar" ; -- porträttera..vb.1
  porträtterande_1_N = mkN "porträtterande" ; -- porträtterande..nn.1
  porträtterbar_1_A = mkA "porträtterbar" ; -- porträtterbar..av.1
  porträtterbarhet_1_N = mkN "porträtterbarhet" ; -- porträtterbarhet..nn.1
  porträttering_1_N = mkN "porträttering" ; -- porträttering..nn.1
  porträttlik_1_A = mkA "porträttlik" ; -- porträttlik..av.1
  porträttlikhet_1_N = mkN "porträttlikhet" ; -- porträttlikhet..nn.1
  porträttmålare_1_N = mkN "porträttmålare" utrum  ; -- porträttmålare..nn.1
  porträttmålning_1_N = mkN "porträttmålning" ; -- porträttmålning..nn.1
  porträttmålning_2_N = mkN "porträttmålning" ; -- porträttmålning..nn.2
  porträttör_1_N = mkN "porträttör" "porträttörer" ; -- porträttör..nn.1
  portskrymsle_1_N = mkN "portskrymsle" ; -- portskrymsle..nn.1
  porttavla_1_N = mkN "porttavla" ; -- porttavla..nn.1
  porttelefon_1_N = mkN "porttelefon" "porttelefoner" ; -- porttelefon..nn.1
  portugis_1_N = mkN "portugis" "portugiser" ; -- portugis..nn.1
  portugisisk_1_A = mkA "portugisisk" ; -- portugisisk..av.1
  portugisiska_1_N = mkN "portugisiska" ; -- portugisiska..nn.1
  portugisiska_2_N = mkN "portugisiska" ; -- portugisiska..nn.2
  portuppgång_1_N = mkN "portuppgång" ; -- portuppgång..nn.1
  portvakt_1_N = mkN "portvakt" "portvakter" ; -- portvakt..nn.1
  portvaktssyssla_1_N = mkN "portvaktssyssla" ; -- portvaktssyssla..nn.1
  portvalv_1_N = mkN "portvalv" neutrum  ; -- portvalv..nn.1
  portvin_1_N = mkN "portvin" "portvinet" "portviner" "portvinerna" ; -- portvin..nn.1
  portvinstå_1_N = mkN "portvinstå" "portvinstån" "portvinstår" "portvinstårna" ; -- portvinstå..nn.1
  portör_1_N = mkN "portör" "portörer" ; -- portör..nn.1
  porös_1_A = mkA "porös" ; -- porös..av.1
  pose_1_N = mkN "pose" "poser" ; -- pose..nn.1
  posera_1_V = mkV "poserar" ; -- posera..vb.1
  poserande_1_N = mkN "poserande" ; -- poserande..nn.1
  posering_1_N = mkN "posering" ; -- posering..nn.1
  position_1_N = mkN "position" ; -- position..nn.1
  positionera_1_V = mkV "positionerar" ; -- positionera..vb.1
  positionerande_1_N = mkN "positionerande" ; -- positionerande..nn.1
  positionerbar_1_A = mkA "positionerbar" ; -- positionerbar..av.1
  positionerbarhet_1_N = mkN "positionerbarhet" ; -- positionerbarhet..nn.1
  positionering_1_N = mkN "positionering" ; -- positionering..nn.1
  positionsbestämning_1_N = mkN "positionsbestämning" ; -- positionsbestämning..nn.1
  positionsförskjutning_1_N = mkN "positionsförskjutning" ; -- positionsförskjutning..nn.1
  positionsljus_1_N = mkN "positionsljus" neutrum  ; -- positionsljus..nn.1
  positiv_1_A = mkA "positiv" ; -- positiv..av.1
  positiv_1_N = mkN "positiv" neutrum  ; -- positiv..nn.1
  positiv_2_N = mkN "positiv" "positiver" ; -- positiv..nn.2
  positivhalare_1_N = mkN "positivhalare" utrum  ; -- positivhalare..nn.1
  positivism_1_N = mkN "positivism" "positivismer" ; -- positivism..nn.1
  positivist_1_N = mkN "positivist" "positivister" ; -- positivist..nn.1
  positivistisk_1_A = mkA "positivistisk" ; -- positivistisk..av.1
  positivvisa_1_N = mkN "positivvisa" ; -- positivvisa..nn.1
  positron_1_N = mkN "positron" "positroner" ; -- positron..nn.1
  possession_1_N = mkN "possession" ; -- possession..nn.1
  possessionat_1_N = mkN "possessionat" "possessionater" ; -- possessionat..nn.1
  possessiv_1_A = mkA "possessiv" ; -- possessiv..av.1
  possessivattribut_1_N = mkN "possessivattribut" neutrum  ; -- possessivattribut..nn.1
  possessivpronomen_1_N = mkN "possessivpronomen" neutrum  ; -- possessivpronomen..nn.1
  post_1_N = mkN "post" ; -- post..nn.1
  post_2_N = mkN "post" "poster" ; -- post..nn.2
  posta_1_V = mkV "postar" ; -- posta..vb.1
  postadress_1_N = mkN "postadress" "postadresser" ; -- postadress..nn.1
  postal_1_A = mkA "postal" ; -- postal..av.1
  postament_1_N = mkN "postament" neutrum  ; -- postament..nn.1
  postande_1_N = mkN "postande" ; -- postande..nn.1
  postanstalt_1_N = mkN "postanstalt" "postanstalter" ; -- postanstalt..nn.1
  postanställd_1_A = mkA "postanställd" "postanställt" ; -- postanställd..av.1
  postanvisning_1_N = mkN "postanvisning" ; -- postanvisning..nn.1
  postbox_1_N = mkN "postbox" ; -- postbox..nn.1
  postbud_1_N = mkN "postbud" neutrum  ; -- postbud..nn.1
  postbåt_1_N = mkN "postbåt" ; -- postbåt..nn.1
  postdatera_1_V = mkV "postdaterar" ; -- postdatera..vb.1
  postdaterande_1_N = mkN "postdaterande" ; -- postdaterande..nn.1
  postdaterbar_1_A = mkA "postdaterbar" ; -- postdaterbar..av.1
  postdaterbarhet_1_N = mkN "postdaterbarhet" ; -- postdaterbarhet..nn.1
  postdatering_1_N = mkN "postdatering" ; -- postdatering..nn.1
  poster_1_N = mkN "poster" ; -- poster..nn.1
  postera_1_V = mkV "posterar" ; -- postera..vb.1
  posterande_1_N = mkN "posterande" ; -- posterande..nn.1
  posterbar_1_A = mkA "posterbar" ; -- posterbar..av.1
  posterbarhet_1_N = mkN "posterbarhet" ; -- posterbarhet..nn.1
  postering_1_N = mkN "postering" ; -- postering..nn.1
  posterioritet_1_N = mkN "posterioritet" ; -- posterioritet..nn.1
  postexpedition_1_N = mkN "postexpedition" ; -- postexpedition..nn.1
  postfack_1_N = mkN "postfack" neutrum  ; -- postfack..nn.1
  postförskott_1_N = mkN "postförskott" neutrum  ; -- postförskott..nn.1
  postförsändelse_1_N = mkN "postförsändelse" "postförsändelser" ; -- postförsändelse..nn.1
  postgiro_1_N = mkN "postgiro" "postgirot" "postgiron" "postgirona" ; -- postgiro..nn.1
  postgirokonto_1_N = mkN "postgirokonto" "postgirokontot" "postgirokonton" "postgirokontona" ; -- postgirokonto..nn.1
  postglacial_1_A = mkA "postglacial" ; -- postglacial..av.1
  postgymnasial_1_A = mkA "postgymnasial" ; -- postgymnasial..av.1
  postgång_1_N = mkN "postgång" ; -- postgång..nn.1
  posthorn_1_N = mkN "posthorn" neutrum  ; -- posthorn..nn.1
  postiljon_1_N = mkN "postiljon" "postiljoner" ; -- postiljon..nn.1
  postilla_1_N = mkN "postilla" ; -- postilla..nn.1
  postindustriell_1_A = mkA "postindustriell" ; -- postindustriell..av.1
  postisch_1_N = mkN "postisch" "postischer" ; -- postisch..nn.1
  postkod_1_N = mkN "postkod" "postkoder" ; -- postkod..nn.1
  postkolonial_1_A = mkA "postkolonial" ; -- postkolonial..av.1
  postkommunistisk_1_A = mkA "postkommunistisk" ; -- postkommunistisk..av.1
  postkontor_1_N = mkN "postkontor" neutrum  ; -- postkontor..nn.1
  postkort_1_N = mkN "postkort" neutrum  ; -- postkort..nn.1
  postkupé_1_N = mkN "postkupé" "postkupéer" ; -- postkupé..nn.1
  postledes_1_Adv = mkAdv "postledes" ; -- postledes..ab.1
  postludium_1_N = mkN "postludium" "postludiet" "postludier" "postludierna" ; -- postludium..nn.1
  postlåda_1_N = mkN "postlåda" ; -- postlåda..nn.1
  postmodern_1_A = mkA "postmodern" ; -- postmodern..av.1
  postmodernism_1_N = mkN "postmodernism" "postmodernismer" ; -- postmodernism..nn.1
  postmodernist_1_N = mkN "postmodernist" "postmodernister" ; -- postmodernist..nn.1
  postmodernistisk_1_A = mkA "postmodernistisk" ; -- postmodernistisk..av.1
  postmästare_1_N = mkN "postmästare" utrum  ; -- postmästare..nn.1
  postnatal_1_A = mkA "postnatal" ; -- postnatal..av.1
  postnummer_1_N = mkN "postnummer" neutrum  ; -- postnummer..nn.1
  postoperativ_1_A = mkA "postoperativ" ; -- postoperativ..av.1
  postorder_1_N = mkN "postorder" ; -- postorder..nn.1
  postorderföretag_1_N = mkN "postorderföretag" neutrum  ; -- postorderföretag..nn.1
  postponera_1_V = mkV "postponerar" ; -- postponera..vb.1
  postponerande_1_N = mkN "postponerande" ; -- postponerande..nn.1
  postponerbar_1_A = mkA "postponerbar" ; -- postponerbar..av.1
  postponerbarhet_1_N = mkN "postponerbarhet" ; -- postponerbarhet..nn.1
  postponering_1_N = mkN "postponering" ; -- postponering..nn.1
  postposition_1_N = mkN "postposition" ; -- postposition..nn.1
  postremissväxel_1_N = mkN "postremissväxel" ; -- postremissväxel..nn.1
  postrån_1_N = mkN "postrån" neutrum  ; -- postrån..nn.1
  poströst_1_N = mkN "poströst" "poströster" ; -- poströst..nn.1
  poströsta_1_V = mkV "poströstar" ; -- poströsta..vb.1
  poströstande_1_N = mkN "poströstande" ; -- poströstande..nn.1
  postseminarium_1_N = mkN "postseminarium" "postseminariet" "postseminarier" "postseminarierna" ; -- postseminarium..nn.1
  postskriptum_1_N = mkN "postskriptum" neutrum  ; -- postskriptum..nn.1
  postsovjetisk_1_A = mkA "postsovjetisk" ; -- postsovjetisk..av.1
  poststation_1_N = mkN "poststation" ; -- poststation..nn.1
  poststämpel_1_N = mkN "poststämpel" ; -- poststämpel..nn.1
  poststämpla_1_V = mkV "poststämplar" ; -- poststämpla..vb.1
  poststämplande_1_N = mkN "poststämplande" ; -- poststämplande..nn.1
  posttjänsteman_1_N = mkN "posttjänsteman" "posttjänstemannen" "posttjänstemän" "posttjänstemännen" ; -- posttjänsteman..nn.1
  posttraumatisk_1_A = mkA "posttraumatisk" ; -- posttraumatisk..av.1
  posttur_1_N = mkN "posttur" "postturer" ; -- posttur..nn.1
  postulat_1_N = mkN "postulat" neutrum  ; -- postulat..nn.1
  postulera_1_V = mkV "postulerar" ; -- postulera..vb.1
  postulerande_1_N = mkN "postulerande" ; -- postulerande..nn.1
  postulerbar_1_A = mkA "postulerbar" ; -- postulerbar..av.1
  postulerbarhet_1_N = mkN "postulerbarhet" ; -- postulerbarhet..nn.1
  postulering_1_N = mkN "postulering" ; -- postulering..nn.1
  postum_1_A = mkA "postum" ; -- postum..av.1
  postutdelning_1_N = mkN "postutdelning" ; -- postutdelning..nn.1
  postvagn_1_N = mkN "postvagn" ; -- postvagn..nn.1
  postverk_1_N = mkN "postverk" neutrum  ; -- postverk..nn.1
  postväxel_1_N = mkN "postväxel" ; -- postväxel..nn.1
  posör_1_N = mkN "posör" "posörer" ; -- posör..nn.1
  potage_1_N = mkN "potage" "potager" ; -- potage..nn.1
  potatis_1_N = mkN "potatis" ; -- potatis..nn.1
  potatisbrännvin_1_N = mkN "potatisbrännvin" neutrum  ; -- potatisbrännvin..nn.1
  potatischips_1_N = mkN "potatischips" neutrum  ; -- potatischips..nn.1
  potatiskanon_1_N = mkN "potatiskanon" "potatiskanoner" ; -- potatiskanon..nn.1
  potatisklyfta_1_N = mkN "potatisklyfta" ; -- potatisklyfta..nn.1
  potatisliknande_1_A = mkA "potatisliknande" ; -- potatisliknande..av.1
  potatismjöl_1_N = mkN "potatismjöl" neutrum  ; -- potatismjöl..nn.1
  potatismos_1_N = mkN "potatismos" neutrum  ; -- potatismos..nn.1
  potatisnäsa_1_N = mkN "potatisnäsa" ; -- potatisnäsa..nn.1
  potatispuré_1_N = mkN "potatispuré" "potatispuréer" ; -- potatispuré..nn.1
  potatissallad_1_N = mkN "potatissallad" "potatissallader" ; -- potatissallad..nn.1
  potatisskalare_1_N = mkN "potatisskalare" utrum  ; -- potatisskalare..nn.1
  potatisskörd_1_N = mkN "potatisskörd" ; -- potatisskörd..nn.1
  potatisväxt_1_N = mkN "potatisväxt" "potatisväxter" ; -- potatisväxt..nn.1
  potemkinkuliss_1_N = mkN "potemkinkuliss" "potemkinkulisser" ; -- potemkinkuliss..nn.1
  potens_1_N = mkN "potens" "potenser" ; -- potens..nn.1
  potent_1_A = mkA "potent" "potent" ; -- potent..av.1
  potentat_1_N = mkN "potentat" "potentater" ; -- potentat..nn.1
  potential_1_N = mkN "potential" "potentialer" ; -- potential..nn.1
  potentialitet_1_N = mkN "potentialitet" "potentialiteter" ; -- potentialitet..nn.1
  potentialyta_1_N = mkN "potentialyta" ; -- potentialyta..nn.1
  potentiell_1_A = mkA "potentiell" ; -- potentiell..av.1
  potentiera_1_V = mkV "potentierar" ; -- potentiera..vb.1
  potentierande_1_N = mkN "potentierande" ; -- potentierande..nn.1
  potentierbar_1_A = mkA "potentierbar" ; -- potentierbar..av.1
  potentierbarhet_1_N = mkN "potentierbarhet" ; -- potentierbarhet..nn.1
  potentiering_1_N = mkN "potentiering" ; -- potentiering..nn.1
  potentiometer_1_N = mkN "potentiometer" ; -- potentiometer..nn.1
  potkes_1_N = mkN "potkes" ; -- potkes..nn.1
  potkäs_1_N = mkN "potkäs" ; -- potkäs..nn.1
  potpurri_1_N = mkN "potpurri" "potpurriet" "potpurrier" "potpurrierna" ; -- potpurri..nn.1
  potpurrimusik_1_N = mkN "potpurrimusik" ; -- potpurrimusik..nn.1
  potpurristycke_1_N = mkN "potpurristycke" ; -- potpurristycke..nn.1
  pott_1_N = mkN "pott" "potter" ; -- pott..nn.1
  potta_1_N = mkN "potta" ; -- potta..nn.1
  pottaska_1_N = mkN "pottaska" ; -- pottaska..nn.1
  potträning_1_N = mkN "potträning" ; -- potträning..nn.1
  pottskräck_1_N = mkN "pottskräck" ; -- pottskräck..nn.1
  poulard_1_N = mkN "poulard" "poularder" ; -- poulard..nn.1
  powerpoint_1_N = mkN "powerpoint" ; -- powerpoint..nn.1
  poäng_1_N = mkN "poäng" neutrum  ; -- poäng..nn.1
  poäng_2_N = mkN "poäng" "poänger" ; -- poäng..nn.2
  poängantal_1_N = mkN "poängantal" neutrum  ; -- poängantal..nn.1
  poängdrottning_1_N = mkN "poängdrottning" ; -- poängdrottning..nn.1
  poänggivande_1_A = mkA "poänggivande" ; -- poänggivande..av.1
  poängkung_1_N = mkN "poängkung" ; -- poängkung..nn.1
  poängliga_1_N = mkN "poängliga" ; -- poängliga..nn.1
  poänglös_1_A = mkA "poänglös" ; -- poänglös..av.1
  poänglöshet_1_N = mkN "poänglöshet" ; -- poänglöshet..nn.1
  poängmässig_1_A = mkA "poängmässig" ; -- poängmässig..av.1
  poängplockare_1_N = mkN "poängplockare" utrum  ; -- poängplockare..nn.1
  poängpromenad_1_N = mkN "poängpromenad" "poängpromenader" ; -- poängpromenad..nn.1
  poängseger_1_N = mkN "poängseger" ; -- poängseger..nn.1
  poängställning_1_N = mkN "poängställning" ; -- poängställning..nn.1
  poängtera_1_V = mkV "poängterar" ; -- poängtera..vb.1
  poängterande_1_N = mkN "poängterande" ; -- poängterande..nn.1
  poängterbar_1_A = mkA "poängterbar" ; -- poängterbar..av.1
  poängterbarhet_1_N = mkN "poängterbarhet" ; -- poängterbarhet..nn.1
  poängtering_1_N = mkN "poängtering" ; -- poängtering..nn.1
  poängtips_1_N = mkN "poängtips" neutrum  ; -- poängtips..nn.1
  poängvärde_1_N = mkN "poängvärde" ; -- poängvärde..nn.1
  pr_kupp_1_N = mkN "pr-kupp" "pr-kupper" ; -- pr-kupp..nn.1
  pracka_1_N = mkN "pracka" ; -- pracka..nn.1
  pragmatik_1_N = mkN "pragmatik" ; -- pragmatik..nn.1
  pragmatiker_1_N = mkN "pragmatiker" "pragmatikern" "pragmatiker" "pragmatikerna" ; -- pragmatiker..nn.1
  pragmatisk_1_A = mkA "pragmatisk" ; -- pragmatisk..av.1
  pragmatism_1_N = mkN "pragmatism" "pragmatismer" ; -- pragmatism..nn.1
  prakrit_1_N = mkN "prakrit" "prakriter" ; -- prakrit..nn.1
  prakt_1_N = mkN "prakt" ; -- prakt..nn.1
  praktarsel_1_N = mkN "praktarsel" ; -- praktarsel..nn.1
  praktarsle_1_N = mkN "praktarsle" ; -- praktarsle..nn.1
  praktbagge_1_N = mkN "praktbagge" utrum  ; -- praktbagge..nn.1
  praktband_1_N = mkN "praktband" neutrum  ; -- praktband..nn.1
  praktblomma_1_N = mkN "praktblomma" ; -- praktblomma..nn.1
  praktbägare_1_N = mkN "praktbägare" utrum  ; -- praktbägare..nn.1
  praktexempel_1_N = mkN "praktexempel" neutrum  ; -- praktexempel..nn.1
  praktexemplar_1_N = mkN "praktexemplar" neutrum  ; -- praktexemplar..nn.1
  praktfiasko_1_N = mkN "praktfiasko" "praktfiaskot" "praktfiaskon" "praktfiaskona" ; -- praktfiasko..nn.1
  praktfull_1_A = mkA "praktfull" ; -- praktfull..av.1
  praktfullhet_1_N = mkN "praktfullhet" "praktfullheter" ; -- praktfullhet..nn.1
  praktik_1_N = mkN "praktik" "praktiker" ; -- praktik..nn.1
  praktikabel_1_A = mkA "praktikabel" ; -- praktikabel..av.1
  praktikalitet_1_N = mkN "praktikalitet" "praktikaliteter" ; -- praktikalitet..nn.1
  praktikant_1_N = mkN "praktikant" "praktikanter" ; -- praktikant..nn.1
  praktiker_1_N = mkN "praktiker" "praktikern" "praktiker" "praktikerna" ; -- praktiker..nn.1
  praktikplats_1_N = mkN "praktikplats" "praktikplatser" ; -- praktikplats..nn.1
  praktiktjänstgöring_1_N = mkN "praktiktjänstgöring" ; -- praktiktjänstgöring..nn.1
  praktisera_1_V = mkV "praktiserar" ; -- praktisera..vb.1
  praktiserande_1_N = mkN "praktiserande" ; -- praktiserande..nn.1
  praktiserbar_1_A = mkA "praktiserbar" ; -- praktiserbar..av.1
  praktiserbarhet_1_N = mkN "praktiserbarhet" ; -- praktiserbarhet..nn.1
  praktisering_1_N = mkN "praktisering" ; -- praktisering..nn.1
  praktisk_1_A = mkA "praktisk" ; -- praktisk..av.1
  praktiskhet_1_N = mkN "praktiskhet" ; -- praktiskhet..nn.1
  praktiskhet_2_N = mkN "praktiskhet" "praktiskheter" ; -- praktiskhet..nn.2
  praktkräk_1_N = mkN "praktkräk" neutrum  ; -- praktkräk..nn.1
  praktmålning_1_N = mkN "praktmålning" ; -- praktmålning..nn.1
  praktpjäs_1_N = mkN "praktpjäs" "praktpjäser" ; -- praktpjäs..nn.1
  praktskandal_1_N = mkN "praktskandal" "praktskandaler" ; -- praktskandal..nn.1
  praktsvin_1_N = mkN "praktsvin" neutrum  ; -- praktsvin..nn.1
  praktupplaga_1_N = mkN "praktupplaga" ; -- praktupplaga..nn.1
  praktverk_1_N = mkN "praktverk" neutrum  ; -- praktverk..nn.1
  praktälskande_1_A = mkA "praktälskande" ; -- praktälskande..av.1
  pralin_1_N = mkN "pralin" "praliner" ; -- pralin..nn.1
  prao_1_N = mkN "prao" ; -- prao..nn.1
  praoa_1_V = mkV "praoar" ; -- praoa..vb.1
  praseodym_1_N = mkN "praseodym" neutrum  ; -- praseodym..nn.1
  prassel_1_N = mkN "prassel" neutrum  ; -- prassel..nn.1
  prassla_1_V = mkV "prasslar" ; -- prassla..vb.1
  prasslande_1_N = mkN "prasslande" ; -- prasslande..nn.1
  prasslig_1_A = mkA "prasslig" ; -- prasslig..av.1
  prat_1_N = mkN "prat" neutrum  ; -- prat..nn.1
  prata_1_N = mkN "prata" ; -- prata..nn.1
  prata_1_V = mkV "pratar" ; -- prata..vb.1
  pratande_1_N = mkN "pratande" ; -- pratande..nn.1
  pratbar_1_A = mkA "pratbar" ; -- pratbar..av.1
  pratbehov_1_N = mkN "pratbehov" neutrum  ; -- pratbehov..nn.1
  pratbubbla_1_N = mkN "pratbubbla" ; -- pratbubbla..nn.1
  pratglad_1_A = mkA "pratglad" "pratglatt" ; -- pratglad..av.1
  pratig_1_A = mkA "pratig" ; -- pratig..av.1
  pratkvarn_1_N = mkN "pratkvarn" ; -- pratkvarn..nn.1
  pratmakare_1_N = mkN "pratmakare" utrum  ; -- pratmakare..nn.1
  pratsam_1_A = mkA "pratsam" "pratsamt" "pratsamma" "pratsamma" "pratsammare" "pratsammast" "pratsammaste" ; -- pratsam..av.1
  pratsamhet_1_N = mkN "pratsamhet" ; -- pratsamhet..nn.1
  pratsjuk_1_A = mkA "pratsjuk" ; -- pratsjuk..av.1
  pratsjuka_1_N = mkN "pratsjuka" ; -- pratsjuka..nn.1
  pratsjukhet_1_N = mkN "pratsjukhet" ; -- pratsjukhet..nn.1
  pratsoffa_1_N = mkN "pratsoffa" ; -- pratsoffa..nn.1
  pratstund_1_N = mkN "pratstund" "pratstunder" ; -- pratstund..nn.1
  praxis_1_N = mkN "praxis" ; -- praxis..nn.1
  prebende_1_N = mkN "prebende" ; -- prebende..nn.1
  precedens_1_N = mkN "precedens" ; -- precedens..nn.1
  precedensfall_1_N = mkN "precedensfall" neutrum  ; -- precedensfall..nn.1
  preceptor_1_N = mkN "preceptor" "preceptorer" ; -- preceptor..nn.1
  preceptur_1_N = mkN "preceptur" "precepturer" ; -- preceptur..nn.1
  preciosa_1_N = mkN "preciosa" "preciosat" "preciosa" "preciosana" ; -- preciosa..nn.1
  preciositet_1_N = mkN "preciositet" "preciositeter" ; -- preciositet..nn.1
  precis_1_Adv = mkAdv "precis" ; -- precis..ab.1
  precis_1_A = mkA "precis" ; -- precis..av.1
  precisera_1_V = mkV "preciserar" ; -- precisera..vb.1
  preciserande_1_N = mkN "preciserande" ; -- preciserande..nn.1
  preciserbar_1_A = mkA "preciserbar" ; -- preciserbar..av.1
  preciserbarhet_1_N = mkN "preciserbarhet" ; -- preciserbarhet..nn.1
  precisering_1_N = mkN "precisering" ; -- precisering..nn.1
  precision_1_N = mkN "precision" ; -- precision..nn.1
  precisionsarbete_1_N = mkN "precisionsarbete" ; -- precisionsarbete..nn.1
  precisionsmejsel_1_N = mkN "precisionsmejsel" ; -- precisionsmejsel..nn.1
  precisionsmått_1_N = mkN "precisionsmått" neutrum  ; -- precisionsmått..nn.1
  precisionsrörelse_1_N = mkN "precisionsrörelse" "precisionsrörelser" ; -- precisionsrörelse..nn.1
  precisionsskjutning_1_N = mkN "precisionsskjutning" ; -- precisionsskjutning..nn.1
  precisionsskytte_1_N = mkN "precisionsskytte" ; -- precisionsskytte..nn.1
  preciös_1_A = mkA "preciös" ; -- preciös..av.1
  predation_1_N = mkN "predation" ; -- predation..nn.1
  predator_1_N = mkN "predator" "predatorer" ; -- predator..nn.1
  predestination_1_N = mkN "predestination" ; -- predestination..nn.1
  predestinationslära_1_N = mkN "predestinationslära" ; -- predestinationslära..nn.1
  predestinera_1_V = mkV "predestinerar" ; -- predestinera..vb.1
  predestinerande_1_N = mkN "predestinerande" ; -- predestinerande..nn.1
  predestinerbar_1_A = mkA "predestinerbar" ; -- predestinerbar..av.1
  predestinerbarhet_1_N = mkN "predestinerbarhet" ; -- predestinerbarhet..nn.1
  predestinering_1_N = mkN "predestinering" ; -- predestinering..nn.1
  predicera_1_V = mkV "predicerar" ; -- predicera..vb.1
  predicerande_1_N = mkN "predicerande" ; -- predicerande..nn.1
  predicerbar_1_A = mkA "predicerbar" ; -- predicerbar..av.1
  predicerbarhet_1_N = mkN "predicerbarhet" ; -- predicerbarhet..nn.1
  predicering_1_N = mkN "predicering" ; -- predicering..nn.1
  predika_1_V = mkV "predikar" ; -- predika..vb.1
  predikament_1_N = mkN "predikament" neutrum  ; -- predikament..nn.1
  predikande_1_N = mkN "predikande" ; -- predikande..nn.1
  predikant_1_N = mkN "predikant" "predikanter" ; -- predikant..nn.1
  predikantmässig_1_A = mkA "predikantmässig" ; -- predikantmässig..av.1
  predikare_1_N = mkN "predikare" utrum  ; -- predikare..nn.1
  predikat_1_N = mkN "predikat" neutrum  ; -- predikat..nn.1
  predikatadverbial_1_N = mkN "predikatadverbial" neutrum  ; -- predikatadverbial..nn.1
  predikativ_1_A = mkA "predikativ" ; -- predikativ..av.1
  predikativ_1_N = mkN "predikativ" neutrum  ; -- predikativ..nn.1
  predikativadverbial_1_N = mkN "predikativadverbial" neutrum  ; -- predikativadverbial..nn.1
  predikatlogik_1_N = mkN "predikatlogik" ; -- predikatlogik..nn.1
  predikatlogisk_1_A = mkA "predikatlogisk" ; -- predikatlogisk..av.1
  predikatsfyllnad_1_N = mkN "predikatsfyllnad" "predikatsfyllnader" ; -- predikatsfyllnad..nn.1
  predikning_1_N = mkN "predikning" ; -- predikning..nn.1
  predikohandledare_1_N = mkN "predikohandledare" utrum  ; -- predikohandledare..nn.1
  predikokonst_1_N = mkN "predikokonst" "predikokonster" ; -- predikokonst..nn.1
  predikosamling_1_N = mkN "predikosamling" ; -- predikosamling..nn.1
  predikotext_1_N = mkN "predikotext" "predikotexter" ; -- predikotext..nn.1
  predikotur_1_N = mkN "predikotur" "predikoturer" ; -- predikotur..nn.1
  predikstol_1_N = mkN "predikstol" ; -- predikstol..nn.1
  predisponera_1_V = mkV "predisponerar" ; -- predisponera..vb.1
  predisponerande_1_N = mkN "predisponerande" ; -- predisponerande..nn.1
  predisponerbar_1_A = mkA "predisponerbar" ; -- predisponerbar..av.1
  predisponerbarhet_1_N = mkN "predisponerbarhet" ; -- predisponerbarhet..nn.1
  predisponering_1_N = mkN "predisponering" ; -- predisponering..nn.1
  predisposition_1_N = mkN "predisposition" ; -- predisposition..nn.1
  predominera_1_V = mkV "predominerar" ; -- predominera..vb.1
  predominerande_1_N = mkN "predominerande" ; -- predominerande..nn.1
  predominering_1_N = mkN "predominering" ; -- predominering..nn.1
  preexistens_1_N = mkN "preexistens" ; -- preexistens..nn.1
  prefabricera_1_V = mkV "prefabricerar" ; -- prefabricera..vb.1
  prefabricerande_1_N = mkN "prefabricerande" ; -- prefabricerande..nn.1
  prefabricerbar_1_A = mkA "prefabricerbar" ; -- prefabricerbar..av.1
  prefabricerbarhet_1_N = mkN "prefabricerbarhet" ; -- prefabricerbarhet..nn.1
  prefabricering_1_N = mkN "prefabricering" ; -- prefabricering..nn.1
  prefekt_1_N = mkN "prefekt" "prefekter" ; -- prefekt..nn.1
  prefektur_1_N = mkN "prefektur" "prefekturer" ; -- prefektur..nn.1
  preferens_1_N = mkN "preferens" "preferenser" ; -- preferens..nn.1
  preferensaktie_1_N = mkN "preferensaktie" "preferensaktier" ; -- preferensaktie..nn.1
  preferera_1_V = mkV "prefererar" ; -- preferera..vb.1
  prefererande_1_N = mkN "prefererande" ; -- prefererande..nn.1
  prefererbar_1_A = mkA "prefererbar" ; -- prefererbar..av.1
  prefererbarhet_1_N = mkN "prefererbarhet" ; -- prefererbarhet..nn.1
  prefigera_1_V = mkV "prefigerar" ; -- prefigera..vb.1
  prefigerande_1_N = mkN "prefigerande" ; -- prefigerande..nn.1
  prefigerbar_1_A = mkA "prefigerbar" ; -- prefigerbar..av.1
  prefigerbarhet_1_N = mkN "prefigerbarhet" ; -- prefigerbarhet..nn.1
  prefigering_1_N = mkN "prefigering" ; -- prefigering..nn.1
  prefix_1_N = mkN "prefix" neutrum  ; -- prefix..nn.1
  preglacial_1_A = mkA "preglacial" ; -- preglacial..av.1
  pregnans_1_N = mkN "pregnans" ; -- pregnans..nn.1
  pregnant_1_A = mkA "pregnant" "pregnant" ; -- pregnant..av.1
  prehistorisk_1_A = mkA "prehistorisk" ; -- prehistorisk..av.1
  preja_1_V = mkV "prejar" ; -- preja..vb.1
  prejande_1_N = mkN "prejande" ; -- prejande..nn.1
  prejare_1_N = mkN "prejare" utrum  ; -- prejare..nn.1
  prejeri_1_N = mkN "prejeri" neutrum  ; -- prejeri..nn.1
  prejning_1_N = mkN "prejning" ; -- prejning..nn.1
  prejningsförsök_1_N = mkN "prejningsförsök" neutrum  ; -- prejningsförsök..nn.1
  prejudicerande_1_A = mkA "prejudicerande" ; -- prejudicerande..av.1
  prejudikat_1_N = mkN "prejudikat" neutrum  ; -- prejudikat..nn.1
  prekär_1_A = mkA "prekär" ; -- prekär..av.1
  prelat_1_N = mkN "prelat" "prelater" ; -- prelat..nn.1
  preliminär_1_A = mkA "preliminär" ; -- preliminär..av.1
  preliminäravtal_1_N = mkN "preliminäravtal" neutrum  ; -- preliminäravtal..nn.1
  preliminärskatt_1_N = mkN "preliminärskatt" "preliminärskatter" ; -- preliminärskatt..nn.1
  preliminärundersökning_1_N = mkN "preliminärundersökning" ; -- preliminärundersökning..nn.1
  preludiera_1_V = mkV "preludierar" ; -- preludiera..vb.1
  preludierande_1_N = mkN "preludierande" ; -- preludierande..nn.1
  preludierbar_1_A = mkA "preludierbar" ; -- preludierbar..av.1
  preludierbarhet_1_N = mkN "preludierbarhet" ; -- preludierbarhet..nn.1
  preludiering_1_N = mkN "preludiering" ; -- preludiering..nn.1
  preludium_1_N = mkN "preludium" "preludiet" "preludier" "preludierna" ; -- preludium..nn.1
  premenstruell_1_A = mkA "premenstruell" ; -- premenstruell..av.1
  premie_1_N = mkN "premie" "premier" ; -- premie..nn.1
  premiebetalare_1_N = mkN "premiebetalare" utrum  ; -- premiebetalare..nn.1
  premiegill_1_A = mkA "premiegill" ; -- premiegill..av.1
  premielån_1_N = mkN "premielån" neutrum  ; -- premielån..nn.1
  premieobligation_1_N = mkN "premieobligation" ; -- premieobligation..nn.1
  premiera_1_V = mkV "premierar" ; -- premiera..vb.1
  premierande_1_N = mkN "premierande" ; -- premierande..nn.1
  premierbar_1_A = mkA "premierbar" ; -- premierbar..av.1
  premierbarhet_1_N = mkN "premierbarhet" ; -- premierbarhet..nn.1
  premiering_1_N = mkN "premiering" ; -- premiering..nn.1
  premiss_1_N = mkN "premiss" "premisser" ; -- premiss..nn.1
  premium_1_N = mkN "premium" "premiet" "premier" "premierna" ; -- premium..nn.1
  premium_2_N = mkN "premium" ; -- premium..nn.2
  premiär_1_N = mkN "premiär" "premiärer" ; -- premiär..nn.1
  premiärbiljett_1_N = mkN "premiärbiljett" "premiärbiljetter" ; -- premiärbiljett..nn.1
  premiärfångst_1_N = mkN "premiärfångst" "premiärfångster" ; -- premiärfångst..nn.1
  premiärköra_1_V = mkV "premiärköra" "premiärkörde" "premiärkört" ; -- premiärköra..vb.1
  premiärkörande_1_N = mkN "premiärkörande" ; -- premiärkörande..nn.1
  premiärminister_1_N = mkN "premiärminister" ; -- premiärminister..nn.1
  premiärministerpost_1_N = mkN "premiärministerpost" "premiärministerposter" ; -- premiärministerpost..nn.1
  premiärministerskifte_1_N = mkN "premiärministerskifte" ; -- premiärministerskifte..nn.1
  premiärtest_1_N = mkN "premiärtest" neutrum  ; -- premiärtest..nn.1
  premiärvisa_1_V = mkV "premiärvisar" ; -- premiärvisa..vb.1
  premolar_1_N = mkN "premolar" "premolarer" ; -- premolar..nn.1
  prenatal_1_A = mkA "prenatal" ; -- prenatal..av.1
  prenumerant_1_N = mkN "prenumerant" "prenumeranter" ; -- prenumerant..nn.1
  prenumeration_1_N = mkN "prenumeration" ; -- prenumeration..nn.1
  prenumerera_1_V = mkV "prenumererar" ; -- prenumerera..vb.1
  prenumererande_1_N = mkN "prenumererande" ; -- prenumererande..nn.1
  prenumerering_1_N = mkN "prenumerering" ; -- prenumerering..nn.1
  preoperativ_1_A = mkA "preoperativ" ; -- preoperativ..av.1
  preparand_1_N = mkN "preparand" "preparander" ; -- preparand..nn.1
  preparat_1_N = mkN "preparat" neutrum  ; -- preparat..nn.1
  preparation_1_N = mkN "preparation" ; -- preparation..nn.1
  preparator_1_N = mkN "preparator" "preparatorer" ; -- preparator..nn.1
  preparatris_1_N = mkN "preparatris" "preparatriser" ; -- preparatris..nn.1
  preparera_1_V = mkV "preparerar" ; -- preparera..vb.1
  preparerande_1_N = mkN "preparerande" ; -- preparerande..nn.1
  preparerbar_1_A = mkA "preparerbar" ; -- preparerbar..av.1
  preparerbarhet_1_N = mkN "preparerbarhet" ; -- preparerbarhet..nn.1
  preparering_1_N = mkN "preparering" ; -- preparering..nn.1
  preposition_1_N = mkN "preposition" ; -- preposition..nn.1
  prepositionell_1_A = mkA "prepositionell" ; -- prepositionell..av.1
  prepositionskasus_1_N = mkN "prepositionskasus" neutrum  ; -- prepositionskasus..nn.1
  prepositionsuttryck_1_N = mkN "prepositionsuttryck" neutrum  ; -- prepositionsuttryck..nn.1
  prerafaelit_1_N = mkN "prerafaelit" "prerafaeliter" ; -- prerafaelit..nn.1
  prerafaelitisk_1_A = mkA "prerafaelitisk" ; -- prerafaelitisk..av.1
  prerogativ_1_N = mkN "prerogativ" neutrum  ; -- prerogativ..nn.1
  presbyter_1_N = mkN "presbyter" "presbytern" "presbyterer" "presbytererna" ; -- presbyter..nn.1
  presbyterian_1_N = mkN "presbyterian" "presbyterianer" ; -- presbyterian..nn.1
  presbyteriansk_1_A = mkA "presbyteriansk" ; -- presbyteriansk..av.1
  presenning_1_N = mkN "presenning" ; -- presenning..nn.1
  presens_1_N = mkN "presens" neutrum  ; -- presens..nn.1
  presensparticip_1_N = mkN "presensparticip" neutrum  ; -- presensparticip..nn.1
  present_1_A = mkA "present" "present" ; -- present..av.1
  present_1_N = mkN "present" "presenter" ; -- present..nn.1
  presenta_1_V = mkV "presentar" ; -- presenta..vb.1
  presentabel_1_A = mkA "presentabel" ; -- presentabel..av.1
  presentande_1_N = mkN "presentande" ; -- presentande..nn.1
  presentask_1_N = mkN "presentask" ; -- presentask..nn.1
  presentation_1_N = mkN "presentation" ; -- presentation..nn.1
  presentatör_1_N = mkN "presentatör" "presentatörer" ; -- presentatör..nn.1
  presentera_1_V = mkV "presenterar" ; -- presentera..vb.1
  presenterande_1_N = mkN "presenterande" ; -- presenterande..nn.1
  presenterbar_1_A = mkA "presenterbar" ; -- presenterbar..av.1
  presenterbarhet_1_N = mkN "presenterbarhet" ; -- presenterbarhet..nn.1
  presenterbricka_1_N = mkN "presenterbricka" ; -- presenterbricka..nn.1
  presentering_1_N = mkN "presentering" ; -- presentering..nn.1
  presentkort_1_N = mkN "presentkort" neutrum  ; -- presentkort..nn.1
  preservativ_1_N = mkN "preservativ" neutrum  ; -- preservativ..nn.1
  preservera_1_V = mkV "preserverar" ; -- preservera..vb.1
  preserverande_1_N = mkN "preserverande" ; -- preserverande..nn.1
  preserverbar_1_A = mkA "preserverbar" ; -- preserverbar..av.1
  preserverbarhet_1_N = mkN "preserverbarhet" ; -- preserverbarhet..nn.1
  preservering_1_N = mkN "preservering" ; -- preservering..nn.1
  preses_1_N = mkN "preses" "preses" "presesar" "presesarna" ; -- preses..nn.1
  president_1_N = mkN "president" "presidenter" ; -- president..nn.1
  presidentaspirant_1_N = mkN "presidentaspirant" "presidentaspiranter" ; -- presidentaspirant..nn.1
  presidentbeslut_1_N = mkN "presidentbeslut" neutrum  ; -- presidentbeslut..nn.1
  presidentbostad_1_N = mkN "presidentbostad" "presidentbostäder" ; -- presidentbostad..nn.1
  presidenthustru_1_N = mkN "presidenthustru" "presidenthustrun" "presidenthustrur" "presidenthustrurna" ; -- presidenthustru..nn.1
  presidenthögkvarter_1_N = mkN "presidenthögkvarter" "presidenthögkvarteret" "presidenthögkvarter" "presidenthögkvarteren" ; -- presidenthögkvarter..nn.1
  presidentkandidat_1_N = mkN "presidentkandidat" "presidentkandidater" ; -- presidentkandidat..nn.1
  presidentmaterial_1_N = mkN "presidentmaterial" neutrum  ; -- presidentmaterial..nn.1
  presidentmässig_1_A = mkA "presidentmässig" ; -- presidentmässig..av.1
  presidentskap_1_N = mkN "presidentskap" neutrum  ; -- presidentskap..nn.1
  presidentstyre_1_N = mkN "presidentstyre" ; -- presidentstyre..nn.1
  presidentur_1_N = mkN "presidentur" "presidenturer" ; -- presidentur..nn.1
  presidentval_1_N = mkN "presidentval" neutrum  ; -- presidentval..nn.1
  presidentvalskampanj_1_N = mkN "presidentvalskampanj" "presidentvalskampanjer" ; -- presidentvalskampanj..nn.1
  presidera_1_V = mkV "presiderar" ; -- presidera..vb.1
  presiderande_1_N = mkN "presiderande" ; -- presiderande..nn.1
  presidering_1_N = mkN "presidering" ; -- presidering..nn.1
  presidium_1_N = mkN "presidium" "presidiet" "presidier" "presidierna" ; -- presidium..nn.1
  preskribera_1_V = mkV "preskriberar" ; -- preskribera..vb.1
  preskriberande_1_N = mkN "preskriberande" ; -- preskriberande..nn.1
  preskriberbar_1_A = mkA "preskriberbar" ; -- preskriberbar..av.1
  preskriberbarhet_1_N = mkN "preskriberbarhet" ; -- preskriberbarhet..nn.1
  preskribering_1_N = mkN "preskribering" ; -- preskribering..nn.1
  preskription_1_N = mkN "preskription" ; -- preskription..nn.1
  preskriptionstid_1_N = mkN "preskriptionstid" "preskriptionstider" ; -- preskriptionstid..nn.1
  press_1_N = mkN "press" ; -- press..nn.1
  press_2_N = mkN "press" ; -- press..nn.2
  pressa_1_V = mkV "pressar" ; -- pressa..vb.1
  pressande_1_A = mkA "pressande" ; -- pressande..av.1
  pressande_1_N = mkN "pressande" ; -- pressande..nn.1
  pressansvarig_1_A = mkA "pressansvarig" ; -- pressansvarig..av.1
  pressare_1_N = mkN "pressare" utrum  ; -- pressare..nn.1
  pressbyrå_1_N = mkN "pressbyrå" "pressbyråer" ; -- pressbyrå..nn.1
  presschef_1_N = mkN "presschef" "presschefer" ; -- presschef..nn.1
  pressdetalj_1_N = mkN "pressdetalj" ; -- pressdetalj..nn.1
  presseri_1_N = mkN "presseri" "presseriet" "presserier" "presserierna" ; -- presseri..nn.1
  pressetik_1_N = mkN "pressetik" ; -- pressetik..nn.1
  pressetisk_1_A = mkA "pressetisk" ; -- pressetisk..av.1
  pressfoder_1_N = mkN "pressfoder" neutrum  ; -- pressfoder..nn.1
  pressfotograf_1_N = mkN "pressfotograf" "pressfotografer" ; -- pressfotograf..nn.1
  pressfrihet_1_N = mkN "pressfrihet" ; -- pressfrihet..nn.1
  pressglas_1_N = mkN "pressglas" neutrum  ; -- pressglas..nn.1
  pressgranne_1_N = mkN "pressgranne" utrum  ; -- pressgranne..nn.1
  pressgurka_1_N = mkN "pressgurka" ; -- pressgurka..nn.1
  pressgäng_1_N = mkN "pressgäng" neutrum  ; -- pressgäng..nn.1
  pressinformatör_1_N = mkN "pressinformatör" "pressinformatörer" ; -- pressinformatör..nn.1
  pression_1_N = mkN "pression" ; -- pression..nn.1
  pressjärn_1_N = mkN "pressjärn" neutrum  ; -- pressjärn..nn.1
  presskommissarie_1_N = mkN "presskommissarie" "presskommissarier" ; -- presskommissarie..nn.1
  presskonferens_1_N = mkN "presskonferens" "presskonferenser" ; -- presskonferens..nn.1
  presskort_1_N = mkN "presskort" neutrum  ; -- presskort..nn.1
  presslägga_1_V = mkV "presslägga" "pressla" "presslagt" ; -- presslägga..vb.1
  pressläggande_1_N = mkN "pressläggande" ; -- pressläggande..nn.1
  pressläggning_1_N = mkN "pressläggning" ; -- pressläggning..nn.1
  pressläktare_1_N = mkN "pressläktare" utrum  ; -- pressläktare..nn.1
  pressmaskin_1_N = mkN "pressmaskin" "pressmaskiner" ; -- pressmaskin..nn.1
  pressmeddelande_1_N = mkN "pressmeddelande" ; -- pressmeddelande..nn.1
  pressmottagning_1_N = mkN "pressmottagning" ; -- pressmottagning..nn.1
  pressmöte_1_N = mkN "pressmöte" ; -- pressmöte..nn.1
  pressning_1_N = mkN "pressning" ; -- pressning..nn.1
  pressorgan_1_N = mkN "pressorgan" neutrum  ; -- pressorgan..nn.1
  presspan_1_N = mkN "presspan" ; -- presspan..nn.1
  pressrelease_1_N = mkN "pressrelease" "pressreleaser" ; -- pressrelease..nn.1
  pressrevider_1_N = mkN "pressrevider" "pressrevideret" "pressrevider" "pressrevideren" ; -- pressrevider..nn.1
  presstalesman_1_N = mkN "presstalesman" "presstalesmannen" "presstalesmän" "presstalesmännen" ; -- presstalesman..nn.1
  presstelegram_1_N = mkN "presstelegram" "presstelegrammet" "presstelegram" "presstelegrammen" ; -- presstelegram..nn.1
  presstopp_1_N = mkN "presstopp" neutrum  ; -- presstopp..nn.1
  pressträff_1_N = mkN "pressträff" ; -- pressträff..nn.1
  presstöd_1_N = mkN "presstöd" neutrum  ; -- presstöd..nn.1
  presstödsnämnd_1_N = mkN "presstödsnämnd" "presstödsnämnder" ; -- presstödsnämnd..nn.1
  presstödsregel_1_N = mkN "presstödsregel" "presstödsregeln" "presstödsregler" "presstödsreglerna" ; -- presstödsregel..nn.1
  pressveck_1_N = mkN "pressveck" neutrum  ; -- pressveck..nn.1
  pressylta_1_N = mkN "pressylta" ; -- pressylta..nn.1
  prestanda_1_N = mkN "prestanda" "prestandat" "prestanda" "prestandana" ; -- prestanda..nn.1
  prestandajämförelse_1_N = mkN "prestandajämförelse" "prestandajämförelser" ; -- prestandajämförelse..nn.1
  prestandamässig_1_A = mkA "prestandamässig" ; -- prestandamässig..av.1
  prestation_1_N = mkN "prestation" ; -- prestation..nn.1
  prestationsfixerad_1_A = mkA "prestationsfixerad" ; -- prestationsfixerad..av.1
  prestationshöjande_1_A = mkA "prestationshöjande" ; -- prestationshöjande..av.1
  prestationsinriktad_1_A = mkA "prestationsinriktad" ; -- prestationsinriktad..av.1
  prestationskrav_1_N = mkN "prestationskrav" neutrum  ; -- prestationskrav..nn.1
  prestationslön_1_N = mkN "prestationslön" "prestationslöner" ; -- prestationslön..nn.1
  prestationsprinsessa_1_N = mkN "prestationsprinsessa" ; -- prestationsprinsessa..nn.1
  prestationsångest_1_N = mkN "prestationsångest" ; -- prestationsångest..nn.1
  prestav_1_N = mkN "prestav" "prestaver" ; -- prestav..nn.1
  prestavera_1_V = mkV "prestaverar" ; -- prestavera..vb.1
  prestaverande_1_N = mkN "prestaverande" ; -- prestaverande..nn.1
  prestavering_1_N = mkN "prestavering" ; -- prestavering..nn.1
  prestera_1_V = mkV "presterar" ; -- prestera..vb.1
  presterande_1_N = mkN "presterande" ; -- presterande..nn.1
  presterbar_1_A = mkA "presterbar" ; -- presterbar..av.1
  presterbarhet_1_N = mkN "presterbarhet" ; -- presterbarhet..nn.1
  prestering_1_N = mkN "prestering" ; -- prestering..nn.1
  prestige_1_N = mkN "prestige" utrum  ; -- prestige..nn.1
  prestigefull_1_A = mkA "prestigefull" ; -- prestigefull..av.1
  prestigefylld_1_A = mkA "prestigefylld" "prestigefyllt" ; -- prestigefylld..av.1
  prestigefylldhet_1_N = mkN "prestigefylldhet" ; -- prestigefylldhet..nn.1
  prestigeförlust_1_N = mkN "prestigeförlust" "prestigeförluster" ; -- prestigeförlust..nn.1
  prestigelös_1_A = mkA "prestigelös" ; -- prestigelös..av.1
  prestigemässig_1_A = mkA "prestigemässig" ; -- prestigemässig..av.1
  prestigeprojekt_1_N = mkN "prestigeprojekt" neutrum  ; -- prestigeprojekt..nn.1
  prestigeuppdrag_1_N = mkN "prestigeuppdrag" neutrum  ; -- prestigeuppdrag..nn.1
  presto_1_N = mkN "presto" "prestot" "preston" "prestona" ; -- presto..nn.1
  presumera_1_V = mkV "presumerar" ; -- presumera..vb.1
  presumerande_1_N = mkN "presumerande" ; -- presumerande..nn.1
  presumerbar_1_A = mkA "presumerbar" ; -- presumerbar..av.1
  presumerbarhet_1_N = mkN "presumerbarhet" ; -- presumerbarhet..nn.1
  presumering_1_N = mkN "presumering" ; -- presumering..nn.1
  presumtiv_1_A = mkA "presumtiv" ; -- presumtiv..av.1
  pretendent_1_N = mkN "pretendent" "pretendenter" ; -- pretendent..nn.1
  pretendera_1_V = mkV "pretenderar" ; -- pretendera..vb.1
  pretenderande_1_N = mkN "pretenderande" ; -- pretenderande..nn.1
  pretendering_1_N = mkN "pretendering" ; -- pretendering..nn.1
  pretention_1_N = mkN "pretention" ; -- pretention..nn.1
  pretentiös_1_A = mkA "pretentiös" ; -- pretentiös..av.1
  preteritum_1_N = mkN "preteritum" "preteritumet" "preteriter" "preteriterna" ; -- preteritum..nn.1
  pretext_1_N = mkN "pretext" "pretexter" ; -- pretext..nn.1
  pretiosa_1_N = mkN "pretiosa" "pretiosat" "pretiosa" "pretiosana" ; -- pretiosa..nn.1
  pretiositet_1_N = mkN "pretiositet" "pretiositeter" ; -- pretiositet..nn.1
  pretiös_1_A = mkA "pretiös" ; -- pretiös..av.1
  pretor_1_N = mkN "pretor" "pretorer" ; -- pretor..nn.1
  pretorian_1_N = mkN "pretorian" "pretorianer" ; -- pretorian..nn.1
  pretoriangarde_1_N = mkN "pretoriangarde" ; -- pretoriangarde..nn.1
  pretto_1_A = mkA "pretto" ; -- pretto..av.1
  pretto_1_N = mkN "pretto" "prettot" "pretton" "prettona" ; -- pretto..nn.1
  preussare_1_N = mkN "preussare" utrum  ; -- preussare..nn.1
  preusseri_1_N = mkN "preusseri" neutrum  ; -- preusseri..nn.1
  preussisk_1_A = mkA "preussisk" ; -- preussisk..av.1
  prevention_1_N = mkN "prevention" ; -- prevention..nn.1
  preventiv_1_A = mkA "preventiv" ; -- preventiv..av.1
  preventivkrig_1_N = mkN "preventivkrig" neutrum  ; -- preventivkrig..nn.1
  preventivmedel_1_N = mkN "preventivmedel" neutrum  ; -- preventivmedel..nn.1
  preventivpiller_1_N = mkN "preventivpiller" neutrum  ; -- preventivpiller..nn.1
  prick_1_N = mkN "prick" ; -- prick..nn.1
  pricka_1_V = mkV "prickar" ; -- pricka..vb.1
  prickande_1_N = mkN "prickande" ; -- prickande..nn.1
  prickare_1_N = mkN "prickare" utrum  ; -- prickare..nn.1
  prickfri_1_A = mkA "prickfri" "prickfritt" ; -- prickfri..av.1
  prickig_1_A = mkA "prickig" ; -- prickig..av.1
  prickighet_1_N = mkN "prickighet" ; -- prickighet..nn.1
  prickning_1_N = mkN "prickning" ; -- prickning..nn.1
  prickskjuta_1_V = mkV "prickskjuta" "pricksköt" "prickskjutit" ; -- prickskjuta..vb.1
  prickskjutande_1_N = mkN "prickskjutande" ; -- prickskjutande..nn.1
  prickskjutning_1_N = mkN "prickskjutning" ; -- prickskjutning..nn.1
  prickskytt_1_N = mkN "prickskytt" ; -- prickskytt..nn.1
  prickskytte_1_N = mkN "prickskytte" ; -- prickskytte..nn.1
  pricksäker_1_A = mkA "pricksäker" ; -- pricksäker..av.1
  pricksäkerhet_1_N = mkN "pricksäkerhet" ; -- pricksäkerhet..nn.1
  pridoli_1_N = mkN "pridoli" ; -- pridoli..nn.1
  priffe_1_N = mkN "priffe" utrum  ; -- priffe..nn.1
  prilla_1_N = mkN "prilla" ; -- prilla..nn.1
  prillig_1_A = mkA "prillig" ; -- prillig..av.1
  prillighet_1_N = mkN "prillighet" "prilligheter" ; -- prillighet..nn.1
  prim_1_N = mkN "prim" "primer" ; -- prim..nn.1
  prima_1_A = mkA "prima" ; -- prima..av.1
  primadonna_1_N = mkN "primadonna" ; -- primadonna..nn.1
  primalskrik_1_N = mkN "primalskrik" neutrum  ; -- primalskrik..nn.1
  primalterapi_1_N = mkN "primalterapi" ; -- primalterapi..nn.1
  primarie_1_N = mkN "primarie" "primarier" ; -- primarie..nn.1
  primat_1_N = mkN "primat" neutrum  ; -- primat..nn.1
  primat_2_N = mkN "primat" "primater" ; -- primat..nn.2
  primatolog_1_N = mkN "primatolog" "primatologer" ; -- primatolog..nn.1
  primer_1_N = mkN "primer" ; -- primer..nn.1
  primfaktor_1_N = mkN "primfaktor" "primfaktorer" ; -- primfaktor..nn.1
  primitiv_1_A = mkA "primitiv" ; -- primitiv..av.1
  primitivism_1_N = mkN "primitivism" "primitivismer" ; -- primitivism..nn.1
  primitivistisk_1_A = mkA "primitivistisk" ; -- primitivistisk..av.1
  primitivitet_1_N = mkN "primitivitet" "primitiviteter" ; -- primitivitet..nn.1
  primklocka_1_N = mkN "primklocka" ; -- primklocka..nn.1
  primogenitur_1_N = mkN "primogenitur" "primogeniturer" ; -- primogenitur..nn.1
  primtal_1_N = mkN "primtal" neutrum  ; -- primtal..nn.1
  primtalsdifferentiering_1_N = mkN "primtalsdifferentiering" ; -- primtalsdifferentiering..nn.1
  primtalsfaktor_1_N = mkN "primtalsfaktor" "primtalsfaktorer" ; -- primtalsfaktor..nn.1
  primula_1_N = mkN "primula" ; -- primula..nn.1
  primuskök_1_N = mkN "primuskök" neutrum  ; -- primuskök..nn.1
  primär_1_A = mkA "primär" ; -- primär..av.1
  primärgrupp_1_N = mkN "primärgrupp" "primärgrupper" ; -- primärgrupp..nn.1
  primärkommun_1_N = mkN "primärkommun" "primärkommuner" ; -- primärkommun..nn.1
  primärkredit_1_N = mkN "primärkredit" "primärkrediter" ; -- primärkredit..nn.1
  primärkälla_1_N = mkN "primärkälla" ; -- primärkälla..nn.1
  primärlån_1_N = mkN "primärlån" neutrum  ; -- primärlån..nn.1
  primärminne_1_N = mkN "primärminne" ; -- primärminne..nn.1
  primärval_1_N = mkN "primärval" neutrum  ; -- primärval..nn.1
  primärvård_1_N = mkN "primärvård" ; -- primärvård..nn.1
  primör_1_N = mkN "primör" "primörer" ; -- primör..nn.1
  princip_1_N = mkN "princip" "principer" ; -- princip..nn.1
  principal_1_N = mkN "principal" "principaler" ; -- principal..nn.1
  principalstämma_1_N = mkN "principalstämma" ; -- principalstämma..nn.1
  principfast_1_A = mkA "principfast" "principfast" ; -- principfast..av.1
  principfasthet_1_N = mkN "principfasthet" ; -- principfasthet..nn.1
  principfråga_1_N = mkN "principfråga" ; -- principfråga..nn.1
  principförklaring_1_N = mkN "principförklaring" ; -- principförklaring..nn.1
  principiell_1_A = mkA "principiell" ; -- principiell..av.1
  principlös_1_A = mkA "principlös" ; -- principlös..av.1
  principlöshet_1_N = mkN "principlöshet" ; -- principlöshet..nn.1
  principmänniska_1_N = mkN "principmänniska" ; -- principmänniska..nn.1
  principprogram_1_N = mkN "principprogram" "principprogrammet" "principprogram" "principprogrammen" ; -- principprogram..nn.1
  principryttare_1_N = mkN "principryttare" utrum  ; -- principryttare..nn.1
  prins_1_N = mkN "prins" ; -- prins..nn.1
  prinsessa_1_N = mkN "prinsessa" ; -- prinsessa..nn.1
  prinsessdop_1_N = mkN "prinsessdop" neutrum  ; -- prinsessdop..nn.1
  prinsessklänning_1_N = mkN "prinsessklänning" ; -- prinsessklänning..nn.1
  prinsesstårta_1_N = mkN "prinsesstårta" ; -- prinsesstårta..nn.1
  prinsesstårtbit_1_N = mkN "prinsesstårtbit" ; -- prinsesstårtbit..nn.1
  prinsgemål_1_N = mkN "prinsgemål" "prinsgemåler" ; -- prinsgemål..nn.1
  prinskorv_1_N = mkN "prinskorv" ; -- prinskorv..nn.1
  prinsregent_1_N = mkN "prinsregent" "prinsregenter" ; -- prinsregent..nn.1
  print_on_demand_1_N = mkN "print-on-demand" ; -- print-on-demand..nn.1
  printer_1_N = mkN "printer" ; -- printer..nn.1
  prior_1_N = mkN "prior" "priorer" ; -- prior..nn.1
  priorinna_1_N = mkN "priorinna" ; -- priorinna..nn.1
  prioritera_1_V = mkV "prioriterar" ; -- prioritera..vb.1
  prioriterande_1_N = mkN "prioriterande" ; -- prioriterande..nn.1
  prioriterbar_1_A = mkA "prioriterbar" ; -- prioriterbar..av.1
  prioriterbarhet_1_N = mkN "prioriterbarhet" ; -- prioriterbarhet..nn.1
  prioritering_1_N = mkN "prioritering" ; -- prioritering..nn.1
  prioriteringsfråga_1_N = mkN "prioriteringsfråga" ; -- prioriteringsfråga..nn.1
  prioriteringsmässig_1_A = mkA "prioriteringsmässig" ; -- prioriteringsmässig..av.1
  prioritet_1_N = mkN "prioritet" "prioriteter" ; -- prioritet..nn.1
  prioritetsordning_1_N = mkN "prioritetsordning" ; -- prioritetsordning..nn.1
  pris_1_N = mkN "pris" neutrum  ; -- pris..nn.1
  pris_2_N = mkN "pris" neutrum  ; -- pris..nn.2
  pris_3_N = mkN "pris" "priser" ; -- pris..nn.3
  pris_4_N = mkN "pris" ; -- pris..nn.4
  prisa_1_V = mkV "prisar" ; -- prisa..vb.1
  prisande_1_N = mkN "prisande" ; -- prisande..nn.1
  prisavdrag_1_N = mkN "prisavdrag" neutrum  ; -- prisavdrag..nn.1
  prisbelöna_1_V = mkV "prisbelönar" ; -- prisbelöna..vb.1
  prisbelönande_1_N = mkN "prisbelönande" ; -- prisbelönande..nn.1
  prisbelöning_1_N = mkN "prisbelöning" ; -- prisbelöning..nn.1
  prisbillig_1_A = mkA "prisbillig" ; -- prisbillig..av.1
  prisbillighet_1_N = mkN "prisbillighet" ; -- prisbillighet..nn.1
  prisbluff_1_N = mkN "prisbluff" ; -- prisbluff..nn.1
  prisbomb_1_N = mkN "prisbomb" "prisbomber" ; -- prisbomb..nn.1
  prisboxare_1_N = mkN "prisboxare" utrum  ; -- prisboxare..nn.1
  prisceremoni_1_N = mkN "prisceremoni" "prisceremonier" ; -- prisceremoni..nn.1
  prischock_1_N = mkN "prischock" "prischocker" ; -- prischock..nn.1
  prisdomare_1_N = mkN "prisdomare" utrum  ; -- prisdomare..nn.1
  priselasticitet_1_N = mkN "priselasticitet" "priselasticiteter" ; -- priselasticitet..nn.1
  prisfall_1_N = mkN "prisfall" neutrum  ; -- prisfall..nn.1
  prisfest_1_N = mkN "prisfest" "prisfester" ; -- prisfest..nn.1
  prisförändring_1_N = mkN "prisförändring" ; -- prisförändring..nn.1
  prisge_1_V = mkV "prisgiva" "prisgav" "prisgivit" ; -- prisge..vb.1
  prisgivande_1_N = mkN "prisgivande" ; -- prisgivande..nn.1
  prisgiven_1_A = mkA "prisgiven" ; -- prisgiven..av.1
  prisgivning_1_N = mkN "prisgivning" ; -- prisgivning..nn.1
  prishöjning_1_N = mkN "prishöjning" ; -- prishöjning..nn.1
  prisjakt_1_N = mkN "prisjakt" "prisjakter" ; -- prisjakt..nn.1
  priskontroll_1_N = mkN "priskontroll" ; -- priskontroll..nn.1
  priskrig_1_N = mkN "priskrig" neutrum  ; -- priskrig..nn.1
  priskurant_1_N = mkN "priskurant" "priskuranter" ; -- priskurant..nn.1
  priskänslig_1_A = mkA "priskänslig" ; -- priskänslig..av.1
  prislapp_1_N = mkN "prislapp" ; -- prislapp..nn.1
  prislista_1_N = mkN "prislista" ; -- prislista..nn.1
  prisma_1_N = mkN "prisma" ; -- prisma..nn.1
  prismaformad_1_A = mkA "prismaformad" ; -- prismaformad..av.1
  prismakikare_1_N = mkN "prismakikare" utrum  ; -- prismakikare..nn.1
  prismatisk_1_A = mkA "prismatisk" ; -- prismatisk..av.1
  prismedveten_1_A = mkA "prismedveten" ; -- prismedveten..av.1
  prismotivering_1_N = mkN "prismotivering" ; -- prismotivering..nn.1
  prismärka_1_V = mkV "prismärker" ; -- prismärka..vb.1
  prismärkande_1_N = mkN "prismärkande" ; -- prismärkande..nn.1
  prismässig_1_A = mkA "prismässig" ; -- prismässig..av.1
  prisnedsätta_1_V = mkV "prisnedsätta" "prisnedsätter" "prisnedsätt" "prisnedsatte" "prisnedsatt" "prisnedsatt" ; -- prisnedsätta..vb.1
  prisnedsättande_1_N = mkN "prisnedsättande" ; -- prisnedsättande..nn.1
  prisnedsättning_1_N = mkN "prisnedsättning" ; -- prisnedsättning..nn.1
  prisnivå_1_N = mkN "prisnivå" "prisnivåer" ; -- prisnivå..nn.1
  prisnotering_1_N = mkN "prisnotering" ; -- prisnotering..nn.1
  prispall_1_N = mkN "prispall" ; -- prispall..nn.1
  prispress_1_N = mkN "prispress" ; -- prispress..nn.1
  prisrally_1_N = mkN "prisrally" "prisrallyt" "prisrallyn" "prisrallyna" ; -- prisrally..nn.1
  prisras_1_N = mkN "prisras" neutrum  ; -- prisras..nn.1
  prisreducera_1_V = mkV "prisreducerar" ; -- prisreducera..vb.1
  prisreducerande_1_N = mkN "prisreducerande" ; -- prisreducerande..nn.1
  prisreduktion_1_N = mkN "prisreduktion" ; -- prisreduktion..nn.1
  prisreglera_1_V = mkV "prisreglerar" ; -- prisreglera..vb.1
  prisreglerande_1_N = mkN "prisreglerande" ; -- prisreglerande..nn.1
  prisreglerbar_1_A = mkA "prisreglerbar" ; -- prisreglerbar..av.1
  prisreglerbarhet_1_N = mkN "prisreglerbarhet" ; -- prisreglerbarhet..nn.1
  prisreglering_1_N = mkN "prisreglering" ; -- prisreglering..nn.1
  prisregn_1_N = mkN "prisregn" neutrum  ; -- prisregn..nn.1
  prisse_1_N = mkN "prisse" utrum  ; -- prisse..nn.1
  prissensation_1_N = mkN "prissensation" ; -- prissensation..nn.1
  prisskjutning_1_N = mkN "prisskjutning" ; -- prisskjutning..nn.1
  prisstabilitet_1_N = mkN "prisstabilitet" ; -- prisstabilitet..nn.1
  prisstegring_1_N = mkN "prisstegring" ; -- prisstegring..nn.1
  prisstopp_1_N = mkN "prisstopp" neutrum  ; -- prisstopp..nn.1
  prissätta_1_V = mkV "prissätta" "prissätter" "prissätt" "prissatte" "prissatt" "prissatt" ; -- prissätta..vb.1
  prissättande_1_N = mkN "prissättande" ; -- prissättande..nn.1
  prissättning_1_N = mkN "prissättning" ; -- prissättning..nn.1
  pristagare_1_N = mkN "pristagare" utrum  ; -- pristagare..nn.1
  pristak_1_N = mkN "pristak" neutrum  ; -- pristak..nn.1
  pristävling_1_N = mkN "pristävling" ; -- pristävling..nn.1
  prisuppgift_1_N = mkN "prisuppgift" "prisuppgifter" ; -- prisuppgift..nn.1
  prisutdelning_1_N = mkN "prisutdelning" ; -- prisutdelning..nn.1
  prisutdelningsjury_1_N = mkN "prisutdelningsjury" "prisutdelningsjuryer" ; -- prisutdelningsjury..nn.1
  prisutveckling_1_N = mkN "prisutveckling" ; -- prisutveckling..nn.1
  prisvariation_1_N = mkN "prisvariation" ; -- prisvariation..nn.1
  prisvinnare_1_N = mkN "prisvinnare" utrum  ; -- prisvinnare..nn.1
  prisvärd_1_A = mkA "prisvärd" "prisvärt" ; -- prisvärd..av.1
  prisvärdhet_1_N = mkN "prisvärdhet" ; -- prisvärdhet..nn.1
  prisökning_1_N = mkN "prisökning" ; -- prisökning..nn.1
  privat_1_A = mkA "privat" "privat" ; -- privat..av.1
  privatanställd_1_A = mkA "privatanställd" "privatanställt" ; -- privatanställd..av.1
  privatbank_1_N = mkN "privatbank" "privatbanker" ; -- privatbank..nn.1
  privatbil_1_N = mkN "privatbil" ; -- privatbil..nn.1
  privatdetektiv_1_N = mkN "privatdetektiv" "privatdetektiver" ; -- privatdetektiv..nn.1
  privatdiskontör_1_N = mkN "privatdiskontör" "privatdiskontörer" ; -- privatdiskontör..nn.1
  privategendom_1_N = mkN "privategendom" ; -- privategendom..nn.1
  privatekonomi_1_N = mkN "privatekonomi" "privatekonomier" ; -- privatekonomi..nn.1
  privatekonomisk_1_A = mkA "privatekonomisk" ; -- privatekonomisk..av.1
  privatisera_1_V = mkV "privatiserar" ; -- privatisera..vb.1
  privatiserande_1_N = mkN "privatiserande" ; -- privatiserande..nn.1
  privatiserbar_1_A = mkA "privatiserbar" ; -- privatiserbar..av.1
  privatiserbarhet_1_N = mkN "privatiserbarhet" ; -- privatiserbarhet..nn.1
  privatisering_1_N = mkN "privatisering" ; -- privatisering..nn.1
  privatiseringshysteri_1_N = mkN "privatiseringshysteri" "privatiseringshysteriet" "privatiseringshysterier" "privatiseringshysterierna" ; -- privatiseringshysteri..nn.1
  privatiseringsivrare_1_N = mkN "privatiseringsivrare" utrum  ; -- privatiseringsivrare..nn.1
  privatiseringsprogram_1_N = mkN "privatiseringsprogram" "privatiseringsprogrammet" "privatiseringsprogram" "privatiseringsprogrammen" ; -- privatiseringsprogram..nn.1
  privatiseringsprojekt_1_N = mkN "privatiseringsprojekt" neutrum  ; -- privatiseringsprojekt..nn.1
  privatiseringsspektakel_1_N = mkN "privatiseringsspektakel" neutrum  ; -- privatiseringsspektakel..nn.1
  privatist_1_N = mkN "privatist" "privatister" ; -- privatist..nn.1
  privatkapital_1_N = mkN "privatkapital" neutrum  ; -- privatkapital..nn.1
  privatkapitalism_1_N = mkN "privatkapitalism" ; -- privatkapitalism..nn.1
  privatkapitalistisk_1_A = mkA "privatkapitalistisk" ; -- privatkapitalistisk..av.1
  privatkopiera_1_V = mkV "privatkopierar" ; -- privatkopiera..vb.1
  privatkopierande_1_N = mkN "privatkopierande" ; -- privatkopierande..nn.1
  privatkopierbar_1_A = mkA "privatkopierbar" ; -- privatkopierbar..av.1
  privatkopierbarhet_1_N = mkN "privatkopierbarhet" ; -- privatkopierbarhet..nn.1
  privatkopiering_1_N = mkN "privatkopiering" ; -- privatkopiering..nn.1
  privatlektion_1_N = mkN "privatlektion" ; -- privatlektion..nn.1
  privatliv_1_N = mkN "privatliv" neutrum  ; -- privatliv..nn.1
  privatläkare_1_N = mkN "privatläkare" utrum  ; -- privatläkare..nn.1
  privatlärare_1_N = mkN "privatlärare" utrum  ; -- privatlärare..nn.1
  privatlån_1_N = mkN "privatlån" neutrum  ; -- privatlån..nn.1
  privatman_1_N = mkN "privatman" "privatmannen" "privatmän" "privatmännen" ; -- privatman..nn.1
  privatmicklare_1_N = mkN "privatmicklare" utrum  ; -- privatmicklare..nn.1
  privatperson_1_N = mkN "privatperson" "privatpersoner" ; -- privatperson..nn.1
  privatpraktik_1_N = mkN "privatpraktik" "privatpraktiker" ; -- privatpraktik..nn.1
  privatpraktiker_1_N = mkN "privatpraktiker" "privatpraktikern" "privatpraktiker" "privatpraktikerna" ; -- privatpraktiker..nn.1
  privatpraktiserande_1_A = mkA "privatpraktiserande" ; -- privatpraktiserande..av.1
  privaträtt_1_N = mkN "privaträtt" ; -- privaträtt..nn.1
  privaträttslig_1_A = mkA "privaträttslig" ; -- privaträttslig..av.1
  privatsak_1_N = mkN "privatsak" "privatsaker" ; -- privatsak..nn.1
  privatscen_1_N = mkN "privatscen" "privatscener" ; -- privatscen..nn.1
  privatsekreterare_1_N = mkN "privatsekreterare" utrum  ; -- privatsekreterare..nn.1
  privatskola_1_N = mkN "privatskola" ; -- privatskola..nn.1
  privatsnok_1_N = mkN "privatsnok" ; -- privatsnok..nn.1
  privatsnut_1_N = mkN "privatsnut" ; -- privatsnut..nn.1
  privattryck_1_N = mkN "privattryck" neutrum  ; -- privattryck..nn.1
  privatägd_1_A = mkA "privatägd" "privatägt" ; -- privatägd..av.1
  privilegiebrev_1_N = mkN "privilegiebrev" neutrum  ; -- privilegiebrev..nn.1
  privilegiera_1_V = mkV "privilegierar" ; -- privilegiera..vb.1
  privilegierad_1_A = mkA "privilegierad" ; -- privilegierad..av.1
  privilegierande_1_N = mkN "privilegierande" ; -- privilegierande..nn.1
  privilegierbar_1_A = mkA "privilegierbar" ; -- privilegierbar..av.1
  privilegierbarhet_1_N = mkN "privilegierbarhet" ; -- privilegierbarhet..nn.1
  privilegiering_1_N = mkN "privilegiering" ; -- privilegiering..nn.1
  privilegieutjämnande_1_A = mkA "privilegieutjämnande" ; -- privilegieutjämnande..av.1
  privilegium_1_N = mkN "privilegium" "privilegiet" "privilegier" "privilegierna" ; -- privilegium..nn.1
  prkupp_1_N = mkN "prkupp" "prkupper" ; -- prkupp..nn.1
  proamerikansk_1_A = mkA "proamerikansk" ; -- proamerikansk..av.1
  proamerikanskhet_1_N = mkN "proamerikanskhet" ; -- proamerikanskhet..nn.1
  probabel_1_A = mkA "probabel" ; -- probabel..av.1
  probabilistisk_1_A = mkA "probabilistisk" ; -- probabilistisk..av.1
  probabilitet_1_N = mkN "probabilitet" "probabiliteter" ; -- probabilitet..nn.1
  probabilitetskalkyl_1_N = mkN "probabilitetskalkyl" "probabilitetskalkyler" ; -- probabilitetskalkyl..nn.1
  probat_1_A = mkA "probat" "probat" ; -- probat..av.1
  probera_1_V = mkV "proberar" ; -- probera..vb.1
  proberande_1_N = mkN "proberande" ; -- proberande..nn.1
  proberbar_1_A = mkA "proberbar" ; -- proberbar..av.1
  proberbarhet_1_N = mkN "proberbarhet" ; -- proberbarhet..nn.1
  probering_1_N = mkN "probering" ; -- probering..nn.1
  problem_1_N = mkN "problem" neutrum  ; -- problem..nn.1
  problemanläggning_1_N = mkN "problemanläggning" ; -- problemanläggning..nn.1
  problematik_1_N = mkN "problematik" ; -- problematik..nn.1
  problematisera_1_V = mkV "problematiserar" ; -- problematisera..vb.1
  problematiserande_1_N = mkN "problematiserande" ; -- problematiserande..nn.1
  problematiserbar_1_A = mkA "problematiserbar" ; -- problematiserbar..av.1
  problematiserbarhet_1_N = mkN "problematiserbarhet" ; -- problematiserbarhet..nn.1
  problematisering_1_N = mkN "problematisering" ; -- problematisering..nn.1
  problematisk_1_A = mkA "problematisk" ; -- problematisk..av.1
  problembarn_1_N = mkN "problembarn" neutrum  ; -- problembarn..nn.1
  problembild_1_N = mkN "problembild" "problembilder" ; -- problembild..nn.1
  problemdeg_1_N = mkN "problemdeg" ; -- problemdeg..nn.1
  problemdiktning_1_N = mkN "problemdiktning" ; -- problemdiktning..nn.1
  problemformulering_1_N = mkN "problemformulering" ; -- problemformulering..nn.1
  problemformuleringsprivilegium_1_N = mkN "problemformuleringsprivilegium" "problemformuleringsprivilegiet" "problemformuleringsprivilegier" "problemformuleringsprivilegierna" ; -- problemformuleringsprivilegium..nn.1
  problemfri_1_A = mkA "problemfri" "problemfritt" ; -- problemfri..av.1
  problemkomplex_1_N = mkN "problemkomplex" neutrum  ; -- problemkomplex..nn.1
  problemlösande_1_A = mkA "problemlösande" ; -- problemlösande..av.1
  problemorienterad_1_A = mkA "problemorienterad" ; -- problemorienterad..av.1
  problemorientering_1_N = mkN "problemorientering" ; -- problemorientering..nn.1
  problemställning_1_N = mkN "problemställning" ; -- problemställning..nn.1
  problemtyngd_1_A = mkA "problemtyngd" "problemtyngt" ; -- problemtyngd..av.1
  procedur_1_N = mkN "procedur" "procedurer" ; -- procedur..nn.1
  procent_1_N = mkN "procent" "procenten" "procent" "procenten" ; -- procent..nn.1
  procenta_1_V = mkV "procentar" ; -- procenta..vb.1
  procentande_1_N = mkN "procentande" ; -- procentande..nn.1
  procentandel_1_N = mkN "procentandel" "procentandelen" "procentandelar" "procentandelarna" ; -- procentandel..nn.1
  procentare_1_N = mkN "procentare" utrum  ; -- procentare..nn.1
  procentenhet_1_N = mkN "procentenhet" "procentenheter" ; -- procentenhet..nn.1
  procenteri_1_N = mkN "procenteri" neutrum  ; -- procenteri..nn.1
  procenthalt_1_N = mkN "procenthalt" "procenthalter" ; -- procenthalt..nn.1
  procentisk_1_A = mkA "procentisk" ; -- procentisk..av.1
  procentsiffra_1_N = mkN "procentsiffra" ; -- procentsiffra..nn.1
  procentuell_1_A = mkA "procentuell" ; -- procentuell..av.1
  procentvärde_1_N = mkN "procentvärde" ; -- procentvärde..nn.1
  process_1_N = mkN "process" "processer" ; -- process..nn.1
  processa_1_V = mkV "processar" ; -- processa..vb.1
  processa_2_V = mkV "processar" ; -- processa..vb.2
  processande_1_N = mkN "processande" ; -- processande..nn.1
  processindustri_1_N = mkN "processindustri" "processindustrier" ; -- processindustri..nn.1
  processingenjör_1_N = mkN "processingenjör" "processingenjörer" ; -- processingenjör..nn.1
  processinriktad_1_A = mkA "processinriktad" ; -- processinriktad..av.1
  procession_1_N = mkN "procession" ; -- procession..nn.1
  processionsordning_1_N = mkN "processionsordning" ; -- processionsordning..nn.1
  processor_1_N = mkN "processor" "processorer" ; -- processor..nn.1
  processordning_1_N = mkN "processordning" ; -- processordning..nn.1
  processrätt_1_N = mkN "processrätt" ; -- processrätt..nn.1
  processuell_1_A = mkA "processuell" ; -- processuell..av.1
  producent_1_N = mkN "producent" "producenter" ; -- producent..nn.1
  producera_1_V = mkV "producerar" ; -- producera..vb.1
  producerad_1_A = mkA "producerad" ; -- producerad..av.1
  producerande_1_N = mkN "producerande" ; -- producerande..nn.1
  producerbar_1_A = mkA "producerbar" ; -- producerbar..av.1
  producerbarhet_1_N = mkN "producerbarhet" ; -- producerbarhet..nn.1
  producering_1_N = mkN "producering" ; -- producering..nn.1
  produkt_1_N = mkN "produkt" "produkter" ; -- produkt..nn.1
  produktansvarig_1_A = mkA "produktansvarig" ; -- produktansvarig..av.1
  produktframtagning_1_N = mkN "produktframtagning" ; -- produktframtagning..nn.1
  produktframtagningsprocess_1_N = mkN "produktframtagningsprocess" "produktframtagningsprocesser" ; -- produktframtagningsprocess..nn.1
  produktion_1_N = mkN "produktion" ; -- produktion..nn.1
  produktionsansvarig_1_A = mkA "produktionsansvarig" ; -- produktionsansvarig..av.1
  produktionsapparat_1_N = mkN "produktionsapparat" "produktionsapparater" ; -- produktionsapparat..nn.1
  produktionsbolag_1_N = mkN "produktionsbolag" neutrum  ; -- produktionsbolag..nn.1
  produktionsbortfall_1_N = mkN "produktionsbortfall" neutrum  ; -- produktionsbortfall..nn.1
  produktionsdirektör_1_N = mkN "produktionsdirektör" "produktionsdirektörer" ; -- produktionsdirektör..nn.1
  produktionsfaktor_1_N = mkN "produktionsfaktor" "produktionsfaktorer" ; -- produktionsfaktor..nn.1
  produktionsförhållande_1_N = mkN "produktionsförhållande" ; -- produktionsförhållande..nn.1
  produktionskostnad_1_N = mkN "produktionskostnad" "produktionskostnader" ; -- produktionskostnad..nn.1
  produktionsmedel_1_N = mkN "produktionsmedel" neutrum  ; -- produktionsmedel..nn.1
  produktionsmässig_1_A = mkA "produktionsmässig" ; -- produktionsmässig..av.1
  produktionsskatt_1_N = mkN "produktionsskatt" "produktionsskatter" ; -- produktionsskatt..nn.1
  produktionsteknik_1_N = mkN "produktionsteknik" "produktionstekniker" ; -- produktionsteknik..nn.1
  produktiv_1_A = mkA "produktiv" ; -- produktiv..av.1
  produktivitet_1_N = mkN "produktivitet" "produktiviteter" ; -- produktivitet..nn.1
  produktivkraft_1_N = mkN "produktivkraft" "produktivkrafter" ; -- produktivkraft..nn.1
  produktmängd_1_N = mkN "produktmängd" "produktmängder" ; -- produktmängd..nn.1
  produktmässig_1_A = mkA "produktmässig" ; -- produktmässig..av.1
  produktplanering_1_N = mkN "produktplanering" ; -- produktplanering..nn.1
  produktutveckling_1_N = mkN "produktutveckling" ; -- produktutveckling..nn.1
  profan_1_A = mkA "profan" ; -- profan..av.1
  profanation_1_N = mkN "profanation" ; -- profanation..nn.1
  profanera_1_V = mkV "profanerar" ; -- profanera..vb.1
  profanerande_1_N = mkN "profanerande" ; -- profanerande..nn.1
  profanerbar_1_A = mkA "profanerbar" ; -- profanerbar..av.1
  profanerbarhet_1_N = mkN "profanerbarhet" ; -- profanerbarhet..nn.1
  profanering_1_N = mkN "profanering" ; -- profanering..nn.1
  profession_1_N = mkN "profession" ; -- profession..nn.1
  professionalisera_1_V = mkV "professionaliserar" ; -- professionalisera..vb.1
  professionaliserande_1_N = mkN "professionaliserande" ; -- professionaliserande..nn.1
  professionaliserbar_1_A = mkA "professionaliserbar" ; -- professionaliserbar..av.1
  professionaliserbarhet_1_N = mkN "professionaliserbarhet" ; -- professionaliserbarhet..nn.1
  professionalisering_1_N = mkN "professionalisering" ; -- professionalisering..nn.1
  professionalism_1_N = mkN "professionalism" "professionalismer" ; -- professionalism..nn.1
  professionalitet_1_N = mkN "professionalitet" ; -- professionalitet..nn.1
  professionell_1_A = mkA "professionell" ; -- professionell..av.1
  professor_1_N = mkN "professor" "professorer" ; -- professor..nn.1
  professorlig_1_A = mkA "professorlig" ; -- professorlig..av.1
  professorlighet_1_N = mkN "professorlighet" ; -- professorlighet..nn.1
  professorska_1_N = mkN "professorska" ; -- professorska..nn.1
  professorstillsättning_1_N = mkN "professorstillsättning" ; -- professorstillsättning..nn.1
  professur_1_N = mkN "professur" "professurer" ; -- professur..nn.1
  profet_1_N = mkN "profet" "profeter" ; -- profet..nn.1
  profetera_1_V = mkV "profeterar" ; -- profetera..vb.1
  profeterande_1_N = mkN "profeterande" ; -- profeterande..nn.1
  profetering_1_N = mkN "profetering" ; -- profetering..nn.1
  profetia_1_N = mkN "profetia" ; -- profetia..nn.1
  profetisk_1_A = mkA "profetisk" ; -- profetisk..av.1
  proffs_1_N = mkN "proffs" neutrum  ; -- proffs..nn.1
  proffsdemonstrant_1_N = mkN "proffsdemonstrant" "proffsdemonstranter" ; -- proffsdemonstrant..nn.1
  proffsig_1_A = mkA "proffsig" ; -- proffsig..av.1
  proffsighet_1_N = mkN "proffsighet" ; -- proffsighet..nn.1
  proffsspelare_1_N = mkN "proffsspelare" utrum  ; -- proffsspelare..nn.1
  proffsvinnare_1_N = mkN "proffsvinnare" utrum  ; -- proffsvinnare..nn.1
  proffsåkare_1_N = mkN "proffsåkare" utrum  ; -- proffsåkare..nn.1
  profil_1_N = mkN "profil" "profiler" ; -- profil..nn.1
  profilera_1_V = mkV "profilerar" ; -- profilera..vb.1
  profilerad_1_A = mkA "profilerad" ; -- profilerad..av.1
  profilerande_1_N = mkN "profilerande" ; -- profilerande..nn.1
  profilerbar_1_A = mkA "profilerbar" ; -- profilerbar..av.1
  profilerbarhet_1_N = mkN "profilerbarhet" ; -- profilerbarhet..nn.1
  profilering_1_N = mkN "profilering" ; -- profilering..nn.1
  profiljärn_1_N = mkN "profiljärn" neutrum  ; -- profiljärn..nn.1
  profillös_1_A = mkA "profillös" ; -- profillös..av.1
  profilporträtt_1_N = mkN "profilporträtt" neutrum  ; -- profilporträtt..nn.1
  profilspår_1_N = mkN "profilspår" neutrum  ; -- profilspår..nn.1
  profit_1_N = mkN "profit" "profiter" ; -- profit..nn.1
  profitabel_1_A = mkA "profitabel" ; -- profitabel..av.1
  profitera_1_V = mkV "profiterar" ; -- profitera..vb.1
  profiterande_1_N = mkN "profiterande" ; -- profiterande..nn.1
  profitering_1_N = mkN "profitering" ; -- profitering..nn.1
  profithaj_1_N = mkN "profithaj" ; -- profithaj..nn.1
  profitör_1_N = mkN "profitör" "profitörer" ; -- profitör..nn.1
  profoss_1_N = mkN "profoss" "profosser" ; -- profoss..nn.1
  profylaktisk_1_A = mkA "profylaktisk" ; -- profylaktisk..av.1
  profylax_1_N = mkN "profylax" ; -- profylax..nn.1
  prog_1_N = mkN "prog" ; -- prog..nn.1
  progala_1_N = mkN "progala" ; -- progala..nn.1
  progesteron_1_N = mkN "progesteron" neutrum  ; -- progesteron..nn.1
  progg_1_N = mkN "progg" ; -- progg..nn.1
  proggare_1_N = mkN "proggare" utrum  ; -- proggare..nn.1
  proggband_1_N = mkN "proggband" neutrum  ; -- proggband..nn.1
  prognat_1_A = mkA "prognat" "prognat" ; -- prognat..av.1
  prognos_1_N = mkN "prognos" "prognoser" ; -- prognos..nn.1
  prognostisera_1_V = mkV "prognostiserar" ; -- prognostisera..vb.1
  prognostiserande_1_N = mkN "prognostiserande" ; -- prognostiserande..nn.1
  prognostiserbar_1_A = mkA "prognostiserbar" ; -- prognostiserbar..av.1
  prognostiserbarhet_1_N = mkN "prognostiserbarhet" ; -- prognostiserbarhet..nn.1
  prognostisering_1_N = mkN "prognostisering" ; -- prognostisering..nn.1
  prognostisk_1_A = mkA "prognostisk" ; -- prognostisk..av.1
  program_1_N = mkN "program" "programmet" "program" "programmen" ; -- program..nn.1
  programansvarig_1_A = mkA "programansvarig" ; -- programansvarig..av.1
  programbudget_1_N = mkN "programbudget" ; -- programbudget..nn.1
  programbudgetering_1_N = mkN "programbudgetering" ; -- programbudgetering..nn.1
  programchef_1_N = mkN "programchef" "programchefer" ; -- programchef..nn.1
  programenlig_1_A = mkA "programenlig" ; -- programenlig..av.1
  programenlighet_1_N = mkN "programenlighet" ; -- programenlighet..nn.1
  programformat_1_N = mkN "programformat" neutrum  ; -- programformat..nn.1
  programförklaring_1_N = mkN "programförklaring" ; -- programförklaring..nn.1
  programkod_1_N = mkN "programkod" ; -- programkod..nn.1
  programland_1_N = mkN "programland" "programlandet" "programländer" "programländerna" ; -- programland..nn.1
  programledare_1_N = mkN "programledare" utrum  ; -- programledare..nn.1
  programledarmässig_1_A = mkA "programledarmässig" ; -- programledarmässig..av.1
  programmakare_1_N = mkN "programmakare" utrum  ; -- programmakare..nn.1
  programmatisk_1_A = mkA "programmatisk" ; -- programmatisk..av.1
  programmera_1_V = mkV "programmerar" ; -- programmera..vb.1
  programmerande_1_N = mkN "programmerande" ; -- programmerande..nn.1
  programmerare_1_N = mkN "programmerare" utrum  ; -- programmerare..nn.1
  programmerbar_1_A = mkA "programmerbar" ; -- programmerbar..av.1
  programmerbarhet_1_N = mkN "programmerbarhet" ; -- programmerbarhet..nn.1
  programmering_1_N = mkN "programmering" ; -- programmering..nn.1
  programmeringsspråk_1_N = mkN "programmeringsspråk" neutrum  ; -- programmeringsspråk..nn.1
  programmotek_1_N = mkN "programmotek" neutrum  ; -- programmotek..nn.1
  programmusik_1_N = mkN "programmusik" ; -- programmusik..nn.1
  programmässig_1_A = mkA "programmässig" ; -- programmässig..av.1
  programpaket_1_N = mkN "programpaket" neutrum  ; -- programpaket..nn.1
  programproduktion_1_N = mkN "programproduktion" ; -- programproduktion..nn.1
  programpunkt_1_N = mkN "programpunkt" "programpunkter" ; -- programpunkt..nn.1
  programskrift_1_N = mkN "programskrift" "programskrifter" ; -- programskrift..nn.1
  programspråk_1_N = mkN "programspråk" neutrum  ; -- programspråk..nn.1
  programstyrning_1_N = mkN "programstyrning" ; -- programstyrning..nn.1
  programutgivare_1_N = mkN "programutgivare" utrum  ; -- programutgivare..nn.1
  programutvecklare_1_N = mkN "programutvecklare" utrum  ; -- programutvecklare..nn.1
  programvara_1_N = mkN "programvara" ; -- programvara..nn.1
  programväljare_1_N = mkN "programväljare" utrum  ; -- programväljare..nn.1
  programvärd_1_N = mkN "programvärd" ; -- programvärd..nn.1
  progress_1_N = mkN "progress" ; -- progress..nn.1
  progression_1_N = mkN "progression" ; -- progression..nn.1
  progressiv_1_A = mkA "progressiv" ; -- progressiv..av.1
  progressivfjädring_1_N = mkN "progressivfjädring" ; -- progressivfjädring..nn.1
  progressivitet_1_N = mkN "progressivitet" "progressiviteter" ; -- progressivitet..nn.1
  prohibitiv_1_A = mkA "prohibitiv" ; -- prohibitiv..av.1
  proinspektor_1_N = mkN "proinspektor" "proinspektorer" ; -- proinspektor..nn.1
  proinsulin_1_N = mkN "proinsulin" "proinsuliner" ; -- proinsulin..nn.1
  proisraelisk_1_A = mkA "proisraelisk" ; -- proisraelisk..av.1
  proisraeliskhet_1_N = mkN "proisraeliskhet" ; -- proisraeliskhet..nn.1
  projekt_1_N = mkN "projekt" neutrum  ; -- projekt..nn.1
  projektanställd_1_A = mkA "projektanställd" "projektanställt" ; -- projektanställd..av.1
  projektansvarig_1_A = mkA "projektansvarig" ; -- projektansvarig..av.1
  projektarbete_1_N = mkN "projektarbete" ; -- projektarbete..nn.1
  projektera_1_V = mkV "projekterar" ; -- projektera..vb.1
  projekterande_1_N = mkN "projekterande" ; -- projekterande..nn.1
  projekterbar_1_A = mkA "projekterbar" ; -- projekterbar..av.1
  projekterbarhet_1_N = mkN "projekterbarhet" ; -- projekterbarhet..nn.1
  projektering_1_N = mkN "projektering" ; -- projektering..nn.1
  projektgrupp_1_N = mkN "projektgrupp" "projektgrupper" ; -- projektgrupp..nn.1
  projektil_1_N = mkN "projektil" "projektiler" ; -- projektil..nn.1
  projektilbana_1_N = mkN "projektilbana" ; -- projektilbana..nn.1
  projektion_1_N = mkN "projektion" ; -- projektion..nn.1
  projektionsapparat_1_N = mkN "projektionsapparat" "projektionsapparater" ; -- projektionsapparat..nn.1
  projektionsyta_1_N = mkN "projektionsyta" ; -- projektionsyta..nn.1
  projektiv_1_A = mkA "projektiv" ; -- projektiv..av.1
  projektledare_1_N = mkN "projektledare" utrum  ; -- projektledare..nn.1
  projektor_1_N = mkN "projektor" "projektorer" ; -- projektor..nn.1
  projektör_1_N = mkN "projektör" "projektörer" ; -- projektör..nn.1
  projicera_1_V = mkV "projicerar" ; -- projicera..vb.1
  projicerande_1_N = mkN "projicerande" ; -- projicerande..nn.1
  projicerbar_1_A = mkA "projicerbar" ; -- projicerbar..av.1
  projicerbarhet_1_N = mkN "projicerbarhet" ; -- projicerbarhet..nn.1
  projicering_1_N = mkN "projicering" ; -- projicering..nn.1
  prokansler_1_N = mkN "prokansler" ; -- prokansler..nn.1
  proklamation_1_N = mkN "proklamation" ; -- proklamation..nn.1
  proklamera_1_V = mkV "proklamerar" ; -- proklamera..vb.1
  proklamerande_1_N = mkN "proklamerande" ; -- proklamerande..nn.1
  proklamerbar_1_A = mkA "proklamerbar" ; -- proklamerbar..av.1
  proklamerbarhet_1_N = mkN "proklamerbarhet" ; -- proklamerbarhet..nn.1
  proklamering_1_N = mkN "proklamering" ; -- proklamering..nn.1
  proklitisk_1_A = mkA "proklitisk" ; -- proklitisk..av.1
  prokonsul_1_N = mkN "prokonsul" "prokonsuln" "prokonsuler" "prokonsulerna" ; -- prokonsul..nn.1
  prokrustesbädd_1_N = mkN "prokrustesbädd" ; -- prokrustesbädd..nn.1
  prokrustessäng_1_N = mkN "prokrustessäng" ; -- prokrustessäng..nn.1
  prokrustisk_1_A = mkA "prokrustisk" ; -- prokrustisk..av.1
  prokura_1_N = mkN "prokura" ; -- prokura..nn.1
  prokurator_1_N = mkN "prokurator" "prokuratorer" ; -- prokurator..nn.1
  prokurdisk_1_A = mkA "prokurdisk" ; -- prokurdisk..av.1
  prokurdiskhet_1_N = mkN "prokurdiskhet" ; -- prokurdiskhet..nn.1
  prokurist_1_N = mkN "prokurist" "prokurister" ; -- prokurist..nn.1
  prolaktin_1_N = mkN "prolaktin" "prolaktiner" ; -- prolaktin..nn.1
  prolaps_1_N = mkN "prolaps" "prolapser" ; -- prolaps..nn.1
  proleptisk_1_A = mkA "proleptisk" ; -- proleptisk..av.1
  proletariat_1_N = mkN "proletariat" neutrum  ; -- proletariat..nn.1
  proletarisera_1_V = mkV "proletariserar" ; -- proletarisera..vb.1
  proletariserande_1_N = mkN "proletariserande" ; -- proletariserande..nn.1
  proletariserbar_1_A = mkA "proletariserbar" ; -- proletariserbar..av.1
  proletariserbarhet_1_N = mkN "proletariserbarhet" ; -- proletariserbarhet..nn.1
  proletarisering_1_N = mkN "proletarisering" ; -- proletarisering..nn.1
  proletär_1_A = mkA "proletär" ; -- proletär..av.1
  proletär_1_N = mkN "proletär" "proletärer" ; -- proletär..nn.1
  prolog_1_N = mkN "prolog" "prologer" ; -- prolog..nn.1
  prolongation_1_N = mkN "prolongation" ; -- prolongation..nn.1
  prolongera_1_V = mkV "prolongerar" ; -- prolongera..vb.1
  prolongerande_1_N = mkN "prolongerande" ; -- prolongerande..nn.1
  prolongerbar_1_A = mkA "prolongerbar" ; -- prolongerbar..av.1
  prolongerbarhet_1_N = mkN "prolongerbarhet" ; -- prolongerbarhet..nn.1
  prolongering_1_N = mkN "prolongering" ; -- prolongering..nn.1
  promemoria_1_N = mkN "promemoria" ; -- promemoria..nn.1
  promenad_1_N = mkN "promenad" "promenader" ; -- promenad..nn.1
  promenadavstånd_1_N = mkN "promenadavstånd" neutrum  ; -- promenadavstånd..nn.1
  promenadgata_1_N = mkN "promenadgata" ; -- promenadgata..nn.1
  promenadkonsert_1_N = mkN "promenadkonsert" "promenadkonserter" ; -- promenadkonsert..nn.1
  promenadkäpp_1_N = mkN "promenadkäpp" ; -- promenadkäpp..nn.1
  promenadköra_1_V = mkV "promenadköra" "promenadkörde" "promenadkört" ; -- promenadköra..vb.1
  promenadkörande_1_N = mkN "promenadkörande" ; -- promenadkörande..nn.1
  promenadlimpa_1_N = mkN "promenadlimpa" ; -- promenadlimpa..nn.1
  promenadseger_1_N = mkN "promenadseger" ; -- promenadseger..nn.1
  promenadstig_1_N = mkN "promenadstig" ; -- promenadstig..nn.1
  promenadstråk_1_N = mkN "promenadstråk" neutrum  ; -- promenadstråk..nn.1
  promenadtakt_1_N = mkN "promenadtakt" ; -- promenadtakt..nn.1
  promenadväg_1_N = mkN "promenadväg" ; -- promenadväg..nn.1
  promenera_1_V = mkV "promenerar" ; -- promenera..vb.1
  promenerande_1_N = mkN "promenerande" ; -- promenerande..nn.1
  promenering_1_N = mkN "promenering" ; -- promenering..nn.1
  promenix_1_N = mkN "promenix" "promenixer" ; -- promenix..nn.1
  promenixa_1_V = mkV "promenixar" ; -- promenixa..vb.1
  promenixande_1_N = mkN "promenixande" ; -- promenixande..nn.1
  promenoar_1_N = mkN "promenoar" "promenoarer" ; -- promenoar..nn.1
  prometium_1_N = mkN "prometium" neutrum  ; -- prometium..nn.1
  promille_1_N = mkN "promille" "promillen" "promille" "promillena" ; -- promille..nn.1
  prominens_1_N = mkN "prominens" "prominenser" ; -- prominens..nn.1
  prominent_1_A = mkA "prominent" "prominent" ; -- prominent..av.1
  promiskuitet_1_N = mkN "promiskuitet" "promiskuiteter" ; -- promiskuitet..nn.1
  promiskuös_1_A = mkA "promiskuös" ; -- promiskuös..av.1
  promota_1_V = mkV "promotar" ; -- promota..vb.1
  promotande_1_N = mkN "promotande" ; -- promotande..nn.1
  promotion_1_N = mkN "promotion" ; -- promotion..nn.1
  promotning_1_N = mkN "promotning" ; -- promotning..nn.1
  promotor_1_N = mkN "promotor" "promotorer" ; -- promotor..nn.1
  promovend_1_N = mkN "promovend" "promovenden" "promovendi" "promovendina" ; -- promovend..nn.1
  promovera_1_V = mkV "promoverar" ; -- promovera..vb.1
  promoverande_1_N = mkN "promoverande" ; -- promoverande..nn.1
  promoverbar_1_A = mkA "promoverbar" ; -- promoverbar..av.1
  promoverbarhet_1_N = mkN "promoverbarhet" ; -- promoverbarhet..nn.1
  promovering_1_N = mkN "promovering" ; -- promovering..nn.1
  proms_1_N = mkN "proms" ; -- proms..nn.1
  promulgation_1_N = mkN "promulgation" ; -- promulgation..nn.1
  promulgera_1_V = mkV "promulgerar" ; -- promulgera..vb.1
  promulgerande_1_N = mkN "promulgerande" ; -- promulgerande..nn.1
  promulgerbar_1_A = mkA "promulgerbar" ; -- promulgerbar..av.1
  promulgerbarhet_1_N = mkN "promulgerbarhet" ; -- promulgerbarhet..nn.1
  promulgering_1_N = mkN "promulgering" ; -- promulgering..nn.1
  pronation_1_N = mkN "pronation" ; -- pronation..nn.1
  pronera_1_V = mkV "pronerar" ; -- pronera..vb.1
  pronerande_1_N = mkN "pronerande" ; -- pronerande..nn.1
  pronerbar_1_A = mkA "pronerbar" ; -- pronerbar..av.1
  pronerbarhet_1_N = mkN "pronerbarhet" ; -- pronerbarhet..nn.1
  pronering_1_N = mkN "pronering" ; -- pronering..nn.1
  pronomen_1_N = mkN "pronomen" neutrum  ; -- pronomen..nn.1
  pronominal_1_A = mkA "pronominal" ; -- pronominal..av.1
  pronominell_1_A = mkA "pronominell" ; -- pronominell..av.1
  prononcera_1_V = mkV "prononcerar" ; -- prononcera..vb.1
  prononcerad_1_A = mkA "prononcerad" ; -- prononcerad..av.1
  prononcerande_1_N = mkN "prononcerande" ; -- prononcerande..nn.1
  prononcerbar_1_A = mkA "prononcerbar" ; -- prononcerbar..av.1
  prononcerbarhet_1_N = mkN "prononcerbarhet" ; -- prononcerbarhet..nn.1
  prononcering_1_N = mkN "prononcering" ; -- prononcering..nn.1
  prononciation_1_N = mkN "prononciation" ; -- prononciation..nn.1
  propaganda_1_N = mkN "propaganda" ; -- propaganda..nn.1
  propagandadikt_1_N = mkN "propagandadikt" "propagandadikter" ; -- propagandadikt..nn.1
  propagandafilm_1_N = mkN "propagandafilm" "propagandafilmer" ; -- propagandafilm..nn.1
  propagandafras_1_N = mkN "propagandafras" "propagandafraser" ; -- propagandafras..nn.1
  propagandalögn_1_N = mkN "propagandalögn" "propagandalögner" ; -- propagandalögn..nn.1
  propagandaminister_1_N = mkN "propagandaminister" ; -- propagandaminister..nn.1
  propagandamässig_1_A = mkA "propagandamässig" ; -- propagandamässig..av.1
  propagandaövertag_1_N = mkN "propagandaövertag" neutrum  ; -- propagandaövertag..nn.1
  propagandist_1_N = mkN "propagandist" "propagandister" ; -- propagandist..nn.1
  propagandistisk_1_A = mkA "propagandistisk" ; -- propagandistisk..av.1
  propagera_1_V = mkV "propagerar" ; -- propagera..vb.1
  propagerande_1_N = mkN "propagerande" ; -- propagerande..nn.1
  propagering_1_N = mkN "propagering" ; -- propagering..nn.1
  propalestinsk_1_A = mkA "propalestinsk" ; -- propalestinsk..av.1
  propalestinskhet_1_N = mkN "propalestinskhet" ; -- propalestinskhet..nn.1
  propan_1_N = mkN "propan" ; -- propan..nn.1
  propanol_1_N = mkN "propanol" ; -- propanol..nn.1
  propedeutik_1_N = mkN "propedeutik" ; -- propedeutik..nn.1
  propedeutisk_1_A = mkA "propedeutisk" ; -- propedeutisk..av.1
  propell_1_N = mkN "propell" ; -- propell..nn.1
  propeller_1_N = mkN "propeller" ; -- propeller..nn.1
  propelleraxel_1_N = mkN "propelleraxel" ; -- propelleraxel..nn.1
  propellerdrift_1_N = mkN "propellerdrift" ; -- propellerdrift..nn.1
  propellerfartyg_1_N = mkN "propellerfartyg" neutrum  ; -- propellerfartyg..nn.1
  propellerplan_1_N = mkN "propellerplan" neutrum  ; -- propellerplan..nn.1
  propen_1_N = mkN "propen" neutrum  ; -- propen..nn.1
  propenplast_1_N = mkN "propenplast" ; -- propenplast..nn.1
  proper_1_A = mkA "proper" ; -- proper..av.1
  proponent_1_N = mkN "proponent" "proponenter" ; -- proponent..nn.1
  proponera_1_V = mkV "proponerar" ; -- proponera..vb.1
  proponerande_1_N = mkN "proponerande" ; -- proponerande..nn.1
  proponerbar_1_A = mkA "proponerbar" ; -- proponerbar..av.1
  proponerbarhet_1_N = mkN "proponerbarhet" ; -- proponerbarhet..nn.1
  proponering_1_N = mkN "proponering" ; -- proponering..nn.1
  proportion_1_N = mkN "proportion" ; -- proportion..nn.1
  proportional_1_N = mkN "proportional" "proportionaler" ; -- proportional..nn.1
  proportionalism_1_N = mkN "proportionalism" "proportionalismer" ; -- proportionalism..nn.1
  proportionalitet_1_N = mkN "proportionalitet" "proportionaliteter" ; -- proportionalitet..nn.1
  proportionell_1_A = mkA "proportionell" ; -- proportionell..av.1
  proportionera_1_V = mkV "proportionerar" ; -- proportionera..vb.1
  proportionerande_1_N = mkN "proportionerande" ; -- proportionerande..nn.1
  proportionerbar_1_A = mkA "proportionerbar" ; -- proportionerbar..av.1
  proportionerbarhet_1_N = mkN "proportionerbarhet" ; -- proportionerbarhet..nn.1
  proportionering_1_N = mkN "proportionering" ; -- proportionering..nn.1
  proportionerlig_1_A = mkA "proportionerlig" ; -- proportionerlig..av.1
  proportionerlighet_1_N = mkN "proportionerlighet" ; -- proportionerlighet..nn.1
  proportionslära_1_N = mkN "proportionslära" ; -- proportionslära..nn.1
  proposition_1_N = mkN "proposition" ; -- proposition..nn.1
  propp_1_N = mkN "propp" ; -- propp..nn.1
  proppa_1_V = mkV "proppar" ; -- proppa..vb.1
  proppande_1_N = mkN "proppande" ; -- proppande..nn.1
  proppfull_1_A = mkA "proppfull" ; -- proppfull..av.1
  proppfullhet_1_N = mkN "proppfullhet" "proppfullheter" ; -- proppfullhet..nn.1
  propplösande_1_A = mkA "propplösande" ; -- propplösande..av.1
  proppmätt_1_A = mkA "proppmätt" ; -- proppmätt..av.1
  proppmätthet_1_N = mkN "proppmätthet" ; -- proppmätthet..nn.1
  proppning_1_N = mkN "proppning" ; -- proppning..nn.1
  proppskåp_1_N = mkN "proppskåp" neutrum  ; -- proppskåp..nn.1
  proppsäkring_1_N = mkN "proppsäkring" ; -- proppsäkring..nn.1
  proprietär_1_A = mkA "proprietär" ; -- proprietär..av.1
  proprietär_1_N = mkN "proprietär" "proprietärer" ; -- proprietär..nn.1
  props_1_N = mkN "props" ; -- props..nn.1
  propsa_1_V = mkV "propsar" ; -- propsa..vb.1
  propsande_1_N = mkN "propsande" ; -- propsande..nn.1
  propyl_1_N = mkN "propyl" "propyler" ; -- propyl..nn.1
  propylé_1_N = mkN "propylé" "propyléer" ; -- propylé..nn.1
  propå_1_N = mkN "propå" "propåer" ; -- propå..nn.1
  prorektor_1_N = mkN "prorektor" "prorektorer" ; -- prorektor..nn.1
  prorektorat_1_N = mkN "prorektorat" neutrum  ; -- prorektorat..nn.1
  prorogation_1_N = mkN "prorogation" ; -- prorogation..nn.1
  prosa_1_N = mkN "prosa" ; -- prosa..nn.1
  prosadikt_1_N = mkN "prosadikt" "prosadikter" ; -- prosadikt..nn.1
  prosaiker_1_N = mkN "prosaiker" "prosaikern" "prosaiker" "prosaikerna" ; -- prosaiker..nn.1
  prosaisk_1_A = mkA "prosaisk" ; -- prosaisk..av.1
  prosaist_1_N = mkN "prosaist" "prosaister" ; -- prosaist..nn.1
  prosastil_1_N = mkN "prosastil" ; -- prosastil..nn.1
  prosatext_1_N = mkN "prosatext" "prosatexter" ; -- prosatext..nn.1
  proscenium_1_N = mkN "proscenium" "prosceniet" "proscenier" "proscenierna" ; -- proscenium..nn.1
  prosektor_1_N = mkN "prosektor" "prosektorer" ; -- prosektor..nn.1
  proselyt_1_N = mkN "proselyt" "proselyter" ; -- proselyt..nn.1
  proseminarium_1_N = mkN "proseminarium" "proseminariet" "proseminarier" "proseminarierna" ; -- proseminarium..nn.1
  proskribera_1_V = mkV "proskriberar" ; -- proskribera..vb.1
  proskriberande_1_N = mkN "proskriberande" ; -- proskriberande..nn.1
  proskriberbar_1_A = mkA "proskriberbar" ; -- proskriberbar..av.1
  proskriberbarhet_1_N = mkN "proskriberbarhet" ; -- proskriberbarhet..nn.1
  proskribering_1_N = mkN "proskribering" ; -- proskribering..nn.1
  proskription_1_N = mkN "proskription" ; -- proskription..nn.1
  prosodi_1_N = mkN "prosodi" "prosodier" ; -- prosodi..nn.1
  prosodisk_1_A = mkA "prosodisk" ; -- prosodisk..av.1
  prosopagnosi_1_N = mkN "prosopagnosi" ; -- prosopagnosi..nn.1
  prospekt_1_N = mkN "prospekt" neutrum  ; -- prospekt..nn.1
  prospektera_1_V = mkV "prospekterar" ; -- prospektera..vb.1
  prospekterande_1_N = mkN "prospekterande" ; -- prospekterande..nn.1
  prospekterbar_1_A = mkA "prospekterbar" ; -- prospekterbar..av.1
  prospekterbarhet_1_N = mkN "prospekterbarhet" ; -- prospekterbarhet..nn.1
  prospektering_1_N = mkN "prospektering" ; -- prospektering..nn.1
  prospektiv_1_A = mkA "prospektiv" ; -- prospektiv..av.1
  prost_1_N = mkN "prost" ; -- prost..nn.1
  prostata_1_N = mkN "prostata" ; -- prostata..nn.1
  prostatacancer_1_N = mkN "prostatacancer" ; -- prostatacancer..nn.1
  prostatacancertumör_1_N = mkN "prostatacancertumör" "prostatacancertumörer" ; -- prostatacancertumör..nn.1
  prostatahypertrofi_1_N = mkN "prostatahypertrofi" ; -- prostatahypertrofi..nn.1
  prostataprov_1_N = mkN "prostataprov" neutrum  ; -- prostataprov..nn.1
  prostatit_1_N = mkN "prostatit" "prostatiter" ; -- prostatit..nn.1
  prosteri_1_N = mkN "prosteri" "prosteriet" "prosterier" "prosterierna" ; -- prosteri..nn.1
  prostgård_1_N = mkN "prostgård" ; -- prostgård..nn.1
  prostituera_1_V = mkV "prostituerar" ; -- prostituera..vb.1
  prostituerad_1_A = mkA "prostituerad" ; -- prostituerad..av.1
  prostituerande_1_N = mkN "prostituerande" ; -- prostituerande..nn.1
  prostituering_1_N = mkN "prostituering" ; -- prostituering..nn.1
  prostitution_1_N = mkN "prostitution" ; -- prostitution..nn.1
  prostitutionshärva_1_N = mkN "prostitutionshärva" ; -- prostitutionshärva..nn.1
  prosyrisk_1_A = mkA "prosyrisk" ; -- prosyrisk..av.1
  protagonist_1_N = mkN "protagonist" "protagonister" ; -- protagonist..nn.1
  protaktinium_1_N = mkN "protaktinium" neutrum  ; -- protaktinium..nn.1
  protegera_1_V = mkV "protegerar" ; -- protegera..vb.1
  protegerande_1_N = mkN "protegerande" ; -- protegerande..nn.1
  protegerbar_1_A = mkA "protegerbar" ; -- protegerbar..av.1
  protegerbarhet_1_N = mkN "protegerbarhet" ; -- protegerbarhet..nn.1
  protegering_1_N = mkN "protegering" ; -- protegering..nn.1
  protegé_1_N = mkN "protegé" "protegéer" ; -- protegé..nn.1
  protein_1_N = mkN "protein" "proteinet" "proteiner" "proteinerna" ; -- protein..nn.1
  proteinanalys_1_N = mkN "proteinanalys" "proteinanalyser" ; -- proteinanalys..nn.1
  proteinbehov_1_N = mkN "proteinbehov" neutrum  ; -- proteinbehov..nn.1
  proteinfabrik_1_N = mkN "proteinfabrik" "proteinfabriker" ; -- proteinfabrik..nn.1
  proteinfamilj_1_N = mkN "proteinfamilj" "proteinfamiljer" ; -- proteinfamilj..nn.1
  proteinforskning_1_N = mkN "proteinforskning" ; -- proteinforskning..nn.1
  proteinkedja_1_N = mkN "proteinkedja" ; -- proteinkedja..nn.1
  proteinkemist_1_N = mkN "proteinkemist" "proteinkemister" ; -- proteinkemist..nn.1
  proteinmolekyl_1_N = mkN "proteinmolekyl" "proteinmolekyler" ; -- proteinmolekyl..nn.1
  proteinnerbrytande_1_A = mkA "proteinnerbrytande" ; -- proteinnerbrytande..av.1
  proteinrik_1_A = mkA "proteinrik" ; -- proteinrik..av.1
  proteinrikhet_1_N = mkN "proteinrikhet" ; -- proteinrikhet..nn.1
  proteinslag_1_N = mkN "proteinslag" neutrum  ; -- proteinslag..nn.1
  proteisk_1_A = mkA "proteisk" ; -- proteisk..av.1
  protektion_1_N = mkN "protektion" ; -- protektion..nn.1
  protektionism_1_N = mkN "protektionism" "protektionismer" ; -- protektionism..nn.1
  protektionist_1_N = mkN "protektionist" "protektionister" ; -- protektionist..nn.1
  protektionistisk_1_A = mkA "protektionistisk" ; -- protektionistisk..av.1
  protektor_1_N = mkN "protektor" "protektorer" ; -- protektor..nn.1
  protektorat_1_N = mkN "protektorat" neutrum  ; -- protektorat..nn.1
  proterozoikum_1_N = mkN "proterozoikum" ; -- proterozoikum..nn.1
  protes_1_N = mkN "protes" "proteser" ; -- protes..nn.1
  protest_1_N = mkN "protest" "protester" ; -- protest..nn.1
  protestaktion_1_N = mkN "protestaktion" ; -- protestaktion..nn.1
  protestant_1_N = mkN "protestant" "protestanter" ; -- protestant..nn.1
  protestantisk_1_A = mkA "protestantisk" ; -- protestantisk..av.1
  protestantism_1_N = mkN "protestantism" "protestantismer" ; -- protestantism..nn.1
  protestera_1_V = mkV "protesterar" ; -- protestera..vb.1
  protesterande_1_N = mkN "protesterande" ; -- protesterande..nn.1
  protestering_1_N = mkN "protestering" ; -- protestering..nn.1
  protestklicka_1_V = mkV "protestklickar" ; -- protestklicka..vb.1
  protestklickande_1_N = mkN "protestklickande" ; -- protestklickande..nn.1
  protestklickning_1_N = mkN "protestklickning" ; -- protestklickning..nn.1
  protestkultur_1_N = mkN "protestkultur" "protestkulturer" ; -- protestkultur..nn.1
  protestmöte_1_N = mkN "protestmöte" ; -- protestmöte..nn.1
  proteströrelse_1_N = mkN "proteströrelse" "proteströrelser" ; -- proteströrelse..nn.1
  proteströst_1_N = mkN "proteströst" "proteströster" ; -- proteströst..nn.1
  proteströsta_1_V = mkV "proteströstar" ; -- proteströsta..vb.1
  proteströstande_1_N = mkN "proteströstande" ; -- proteströstande..nn.1
  protestskrivelse_1_N = mkN "protestskrivelse" "protestskrivelser" ; -- protestskrivelse..nn.1
  proteststorm_1_N = mkN "proteststorm" ; -- proteststorm..nn.1
  proteststrejk_1_N = mkN "proteststrejk" "proteststrejker" ; -- proteststrejk..nn.1
  protesttal_1_N = mkN "protesttal" neutrum  ; -- protesttal..nn.1
  protestvilja_1_N = mkN "protestvilja" ; -- protestvilja..nn.1
  protetik_1_N = mkN "protetik" ; -- protetik..nn.1
  protokoll_1_N = mkN "protokoll" neutrum  ; -- protokoll..nn.1
  protokoll_2_N = mkN "protokoll" neutrum  ; -- protokoll..nn.2
  protokollera_1_V = mkV "protokollerar" ; -- protokollera..vb.1
  protokollerande_1_N = mkN "protokollerande" ; -- protokollerande..nn.1
  protokollerbar_1_A = mkA "protokollerbar" ; -- protokollerbar..av.1
  protokollerbarhet_1_N = mkN "protokollerbarhet" ; -- protokollerbarhet..nn.1
  protokollering_1_N = mkN "protokollering" ; -- protokollering..nn.1
  protokollfråga_1_N = mkN "protokollfråga" ; -- protokollfråga..nn.1
  protokollföra_1_V = mkV "protokollföra" "protokollförde" "protokollfört" ; -- protokollföra..vb.1
  protokollförande_1_N = mkN "protokollförande" ; -- protokollförande..nn.1
  protokollföring_1_N = mkN "protokollföring" ; -- protokollföring..nn.1
  protokollmässig_1_A = mkA "protokollmässig" ; -- protokollmässig..av.1
  protokollär_1_A = mkA "protokollär" ; -- protokollär..av.1
  protolys_1_N = mkN "protolys" "protolyser" ; -- protolys..nn.1
  protolyt_1_N = mkN "protolyt" "protolyter" ; -- protolyt..nn.1
  proton_1_N = mkN "proton" "protoner" ; -- proton..nn.1
  protonkarusell_1_N = mkN "protonkarusell" "protonkaruseller" ; -- protonkarusell..nn.1
  protonkniv_1_N = mkN "protonkniv" ; -- protonkniv..nn.1
  protonladdning_1_N = mkN "protonladdning" ; -- protonladdning..nn.1
  protonterapi_1_N = mkN "protonterapi" ; -- protonterapi..nn.1
  protoplasma_1_N = mkN "protoplasma" ; -- protoplasma..nn.1
  prototyp_1_N = mkN "prototyp" "prototyper" ; -- prototyp..nn.1
  protozo_1_N = mkN "protozo" "protozon" "protozoer" "protozoerna" ; -- protozo..nn.1
  protuberans_1_N = mkN "protuberans" "protuberanser" ; -- protuberans..nn.1
  prov_1_N = mkN "prov" neutrum  ; -- prov..nn.1
  prov_2_N = mkN "prov" neutrum  ; -- prov..nn.2
  prova_1_V = mkV "provar" ; -- prova..vb.1
  provanalys_1_N = mkN "provanalys" "provanalyser" ; -- provanalys..nn.1
  provande_1_N = mkN "provande" ; -- provande..nn.1
  provanställning_1_N = mkN "provanställning" ; -- provanställning..nn.1
  provanställningstid_1_N = mkN "provanställningstid" "provanställningstider" ; -- provanställningstid..nn.1
  provare_1_N = mkN "provare" utrum  ; -- provare..nn.1
  provbit_1_N = mkN "provbit" ; -- provbit..nn.1
  provdocka_1_N = mkN "provdocka" ; -- provdocka..nn.1
  proveniens_1_N = mkN "proveniens" "provenienser" ; -- proveniens..nn.1
  provensal_1_N = mkN "provensal" "provensaler" ; -- provensal..nn.1
  provensalsk_1_A = mkA "provensalsk" ; -- provensalsk..av.1
  provensalska_1_N = mkN "provensalska" ; -- provensalska..nn.1
  provensalska_2_N = mkN "provensalska" ; -- provensalska..nn.2
  proverb_1_N = mkN "proverb" neutrum  ; -- proverb..nn.1
  provföreläsa_1_V = mkV "provföreläser" ; -- provföreläsa..vb.1
  provglas_1_N = mkN "provglas" neutrum  ; -- provglas..nn.1
  proviant_1_N = mkN "proviant" ; -- proviant..nn.1
  proviantera_1_V = mkV "provianterar" ; -- proviantera..vb.1
  provianterande_1_N = mkN "provianterande" ; -- provianterande..nn.1
  proviantering_1_N = mkN "proviantering" ; -- proviantering..nn.1
  proviantlista_1_N = mkN "proviantlista" ; -- proviantlista..nn.1
  provie_1_N = mkN "provie" "provien" "provies" "proviesarna" ; -- provie..nn.1
  provins_1_N = mkN "provins" "provinser" ; -- provins..nn.1
  provinsguvernör_1_N = mkN "provinsguvernör" "provinsguvernörer" ; -- provinsguvernör..nn.1
  provinsialism_1_N = mkN "provinsialism" "provinsialismer" ; -- provinsialism..nn.1
  provinsialistisk_1_A = mkA "provinsialistisk" ; -- provinsialistisk..av.1
  provinsialläkare_1_N = mkN "provinsialläkare" utrum  ; -- provinsialläkare..nn.1
  provinsiell_1_A = mkA "provinsiell" ; -- provinsiell..av.1
  provinsståthållare_1_N = mkN "provinsståthållare" utrum  ; -- provinsståthållare..nn.1
  provision_1_N = mkN "provision" ; -- provision..nn.1
  provisorisk_1_A = mkA "provisorisk" ; -- provisorisk..av.1
  provisorium_1_N = mkN "provisorium" "provisoriet" "provisorier" "provisorierna" ; -- provisorium..nn.1
  provjobba_1_V = mkV "provjobbar" ; -- provjobba..vb.1
  provjobbande_1_N = mkN "provjobbande" ; -- provjobbande..nn.1
  provjobbning_1_N = mkN "provjobbning" ; -- provjobbning..nn.1
  provkarta_1_N = mkN "provkarta" ; -- provkarta..nn.1
  provkök_1_N = mkN "provkök" neutrum  ; -- provkök..nn.1
  provköra_1_V = mkV "provköra" "provkörde" "provkört" ; -- provköra..vb.1
  provkörande_1_N = mkN "provkörande" ; -- provkörande..nn.1
  provkörning_1_N = mkN "provkörning" ; -- provkörning..nn.1
  provläsa_1_V = mkV "provläser" ; -- provläsa..vb.1
  provläsande_1_N = mkN "provläsande" ; -- provläsande..nn.1
  provläsning_1_N = mkN "provläsning" ; -- provläsning..nn.1
  provning_1_N = mkN "provning" ; -- provning..nn.1
  provocera_1_V = mkV "provocerar" ; -- provocera..vb.1
  provocerande_1_N = mkN "provocerande" ; -- provocerande..nn.1
  provocerbar_1_A = mkA "provocerbar" ; -- provocerbar..av.1
  provocerbarhet_1_N = mkN "provocerbarhet" ; -- provocerbarhet..nn.1
  provocering_1_N = mkN "provocering" ; -- provocering..nn.1
  provokation_1_N = mkN "provokation" ; -- provokation..nn.1
  provokativ_1_A = mkA "provokativ" ; -- provokativ..av.1
  provokatorisk_1_A = mkA "provokatorisk" ; -- provokatorisk..av.1
  provokatör_1_N = mkN "provokatör" "provokatörer" ; -- provokatör..nn.1
  provrida_1_V = mkV "provrida" "provred" "provridit" ; -- provrida..vb.1
  provridande_1_N = mkN "provridande" ; -- provridande..nn.1
  provridning_1_N = mkN "provridning" ; -- provridning..nn.1
  provrum_1_N = mkN "provrum" "provrummet" "provrum" "provrummen" ; -- provrum..nn.1
  provryttare_1_N = mkN "provryttare" utrum  ; -- provryttare..nn.1
  provräkning_1_N = mkN "provräkning" ; -- provräkning..nn.1
  provrör_1_N = mkN "provrör" neutrum  ; -- provrör..nn.1
  provrörsbarn_1_N = mkN "provrörsbarn" neutrum  ; -- provrörsbarn..nn.1
  provrörsbefrukta_1_V = mkV "provrörsbefruktar" ; -- provrörsbefrukta..vb.1
  provrörsbefruktande_1_N = mkN "provrörsbefruktande" ; -- provrörsbefruktande..nn.1
  provrörsbefruktning_1_N = mkN "provrörsbefruktning" ; -- provrörsbefruktning..nn.1
  provskjuta_1_V = mkV "provskjuta" "provsköt" "provskjutit" ; -- provskjuta..vb.1
  provskjutning_1_N = mkN "provskjutning" ; -- provskjutning..nn.1
  provsmaka_1_V = mkV "provsmakar" ; -- provsmaka..vb.1
  provsmakande_1_N = mkN "provsmakande" ; -- provsmakande..nn.1
  provsmakning_1_N = mkN "provsmakning" ; -- provsmakning..nn.1
  provsmaksservitör_1_N = mkN "provsmaksservitör" "provsmaksservitörer" ; -- provsmaksservitör..nn.1
  provspela_1_V = mkV "provspelar" ; -- provspela..vb.1
  provspelande_1_N = mkN "provspelande" ; -- provspelande..nn.1
  provspelning_1_N = mkN "provspelning" ; -- provspelning..nn.1
  provsprängning_1_N = mkN "provsprängning" ; -- provsprängning..nn.1
  provstopp_1_N = mkN "provstopp" neutrum  ; -- provstopp..nn.1
  provsvar_1_N = mkN "provsvar" neutrum  ; -- provsvar..nn.1
  provtagning_1_N = mkN "provtagning" ; -- provtagning..nn.1
  provtjänstgöring_1_N = mkN "provtjänstgöring" ; -- provtjänstgöring..nn.1
  provträna_1_V = mkV "provtränar" ; -- provträna..vb.1
  provtränande_1_N = mkN "provtränande" ; -- provtränande..nn.1
  provträning_1_N = mkN "provträning" ; -- provträning..nn.1
  provtur_1_N = mkN "provtur" "provturer" ; -- provtur..nn.1
  provuppgift_1_N = mkN "provuppgift" "provuppgifter" ; -- provuppgift..nn.1
  provår_1_N = mkN "provår" neutrum  ; -- provår..nn.1
  provöversättning_1_N = mkN "provöversättning" ; -- provöversättning..nn.1
  proximal_1_A = mkA "proximal" ; -- proximal..av.1
  prudentlig_1_A = mkA "prudentlig" ; -- prudentlig..av.1
  prudentlighet_1_N = mkN "prudentlighet" "prudentligheter" ; -- prudentlighet..nn.1
  prunefärgad_1_A = mkA "prunefärgad" ; -- prunefärgad..av.1
  prunell_1_N = mkN "prunell" "pruneller" ; -- prunell..nn.1
  prunk_1_N = mkN "prunk" neutrum  ; -- prunk..nn.1
  prunka_1_V = mkV "prunkar" ; -- prunka..vb.1
  prunkande_1_N = mkN "prunkande" ; -- prunkande..nn.1
  prusta_1_V = mkV "prustar" ; -- prusta..vb.1
  prustande_1_N = mkN "prustande" ; -- prustande..nn.1
  prustning_1_N = mkN "prustning" ; -- prustning..nn.1
  prustrot_1_N = mkN "prustrot" ; -- prustrot..nn.1
  prut_1_N = mkN "prut" neutrum  ; -- prut..nn.1
  pruta_1_V = mkV "prutar" ; -- pruta..vb.1
  prutande_1_N = mkN "prutande" ; -- prutande..nn.1
  prutgås_1_N = mkN "prutgås" "prutgåsen" "prutgäss" "prutgässen" ; -- prutgås..nn.1
  prutmån_1_N = mkN "prutmån" ; -- prutmån..nn.1
  prutning_1_N = mkN "prutning" ; -- prutning..nn.1
  prutt_1_N = mkN "prutt" ; -- prutt..nn.1
  prutta_1_V = mkV "pruttar" ; -- prutta..vb.1
  pruttande_1_N = mkN "pruttande" ; -- pruttande..nn.1
  pruttig_1_A = mkA "pruttig" ; -- pruttig..av.1
  pruttighet_1_N = mkN "pruttighet" ; -- pruttighet..nn.1
  pruttkudde_1_N = mkN "pruttkudde" utrum  ; -- pruttkudde..nn.1
  prya_1_N = mkN "prya" ; -- prya..nn.1
  prya_1_V = mkV "pryar" ; -- prya..vb.1
  pryande_1_N = mkN "pryande" ; -- pryande..nn.1
  pryd_1_A = mkA "pryd" "prytt" ; -- pryd..av.1
  pryda_1_V = mkV "pryda" "prydde" "prytt" ; -- pryda..vb.1
  prydande_1_N = mkN "prydande" ; -- prydande..nn.1
  prydd_1_A = mkA "prydd" ; -- prydd..av.1
  pryderi_1_N = mkN "pryderi" neutrum  ; -- pryderi..nn.1
  prydhet_1_N = mkN "prydhet" "prydheter" ; -- prydhet..nn.1
  prydlig_1_A = mkA "prydlig" ; -- prydlig..av.1
  prydlighet_1_N = mkN "prydlighet" ; -- prydlighet..nn.1
  prydnad_1_N = mkN "prydnad" "prydnader" ; -- prydnad..nn.1
  prydnadsartikel_1_N = mkN "prydnadsartikel" ; -- prydnadsartikel..nn.1
  prydnadsblomma_1_N = mkN "prydnadsblomma" ; -- prydnadsblomma..nn.1
  prydnadsbuske_1_N = mkN "prydnadsbuske" utrum  ; -- prydnadsbuske..nn.1
  prydnadsdetalj_1_N = mkN "prydnadsdetalj" "prydnadsdetaljer" ; -- prydnadsdetalj..nn.1
  prydnadsfigur_1_N = mkN "prydnadsfigur" "prydnadsfigurer" ; -- prydnadsfigur..nn.1
  prydnadsfjäder_1_N = mkN "prydnadsfjäder" ; -- prydnadsfjäder..nn.1
  prydnadsfågel_1_N = mkN "prydnadsfågel" ; -- prydnadsfågel..nn.1
  prydnadsföremål_1_N = mkN "prydnadsföremål" neutrum  ; -- prydnadsföremål..nn.1
  prydnadsgavel_1_N = mkN "prydnadsgavel" ; -- prydnadsgavel..nn.1
  prydnadshjärta_1_N = mkN "prydnadshjärta" "prydnadshjärtat" "prydnadshjärtan" "prydnadshjärtana" ; -- prydnadshjärta..nn.1
  prydnadskam_1_N = mkN "prydnadskam" "prydnadskammen" "prydnadskammar" "prydnadskammarna" ; -- prydnadskam..nn.1
  prydnadskrans_1_N = mkN "prydnadskrans" ; -- prydnadskrans..nn.1
  prydnadskudde_1_N = mkN "prydnadskudde" utrum  ; -- prydnadskudde..nn.1
  prydnadslist_1_N = mkN "prydnadslist" "prydnadslister" ; -- prydnadslist..nn.1
  prydnadsskål_1_N = mkN "prydnadsskål" ; -- prydnadsskål..nn.1
  prydnadssnöre_1_N = mkN "prydnadssnöre" ; -- prydnadssnöre..nn.1
  prydnadsstjärna_1_N = mkN "prydnadsstjärna" ; -- prydnadsstjärna..nn.1
  prydnadssöm_1_N = mkN "prydnadssöm" "prydnadssömmen" "prydnadssömmar" "prydnadssömmarna" ; -- prydnadssöm..nn.1
  prydnadsvapen_1_N = mkN "prydnadsvapen" "prydnadsvapnet" "prydnadsvapen" "prydnadsvapnen" ; -- prydnadsvapen..nn.1
  prydnadsväv_1_N = mkN "prydnadsväv" ; -- prydnadsväv..nn.1
  prydnadsväxt_1_N = mkN "prydnadsväxt" "prydnadsväxter" ; -- prydnadsväxt..nn.1
  prygel_1_N = mkN "prygel" neutrum  ; -- prygel..nn.1
  prygelstraff_1_N = mkN "prygelstraff" neutrum  ; -- prygelstraff..nn.1
  prygla_1_V = mkV "pryglar" ; -- prygla..vb.1
  pryglande_1_N = mkN "pryglande" ; -- pryglande..nn.1
  prygling_1_N = mkN "prygling" ; -- prygling..nn.1
  pryl_1_N = mkN "pryl" ; -- pryl..nn.1
  pryltokig_1_A = mkA "pryltokig" ; -- pryltokig..av.1
  pryltokighet_1_N = mkN "pryltokighet" ; -- pryltokighet..nn.1
  pryo_1_N = mkN "pryo" "pryor" ; -- pryo..nn.1
  pryttel_1_N = mkN "pryttel" ; -- pryttel..nn.1
  prägel_1_N = mkN "prägel" ; -- prägel..nn.1
  prägelvärde_1_N = mkN "prägelvärde" ; -- prägelvärde..nn.1
  prägla_1_V = mkV "präglar" ; -- prägla..vb.1
  präglande_1_N = mkN "präglande" ; -- präglande..nn.1
  prägling_1_N = mkN "prägling" ; -- prägling..nn.1
  präktig_1_A = mkA "präktig" ; -- präktig..av.1
  präktighet_1_N = mkN "präktighet" ; -- präktighet..nn.1
  prälle_1_N = mkN "prälle" utrum  ; -- prälle..nn.1
  pränt_1_N = mkN "pränt" neutrum  ; -- pränt..nn.1
  pränta_1_V = mkV "präntar" ; -- pränta..vb.1
  präntande_1_N = mkN "präntande" ; -- präntande..nn.1
  präntning_1_N = mkN "präntning" ; -- präntning..nn.1
  prärie_1_N = mkN "prärie" "prärier" ; -- prärie..nn.1
  präriehund_1_N = mkN "präriehund" ; -- präriehund..nn.1
  prärievarg_1_N = mkN "prärievarg" ; -- prärievarg..nn.1
  präst_1_N = mkN "präst" "präster" ; -- präst..nn.1
  prästbetyg_1_N = mkN "prästbetyg" neutrum  ; -- prästbetyg..nn.1
  prästcelibat_1_N = mkN "prästcelibat" neutrum  ; -- prästcelibat..nn.1
  prästdräkt_1_N = mkN "prästdräkt" "prästdräkter" ; -- prästdräkt..nn.1
  prästerlig_1_A = mkA "prästerlig" ; -- prästerlig..av.1
  prästerlighet_1_N = mkN "prästerlighet" ; -- prästerlighet..nn.1
  prästerskap_1_N = mkN "prästerskap" neutrum  ; -- prästerskap..nn.1
  prästestånd_1_N = mkN "prästestånd" neutrum  ; -- prästestånd..nn.1
  prästgäll_1_N = mkN "prästgäll" neutrum  ; -- prästgäll..nn.1
  prästgård_1_N = mkN "prästgård" ; -- prästgård..nn.1
  prästgårdsarrendator_1_N = mkN "prästgårdsarrendator" "prästgårdsarrendatorer" ; -- prästgårdsarrendator..nn.1
  prästgårdslänstol_1_N = mkN "prästgårdslänstol" ; -- prästgårdslänstol..nn.1
  prästgårdsträdgård_1_N = mkN "prästgårdsträdgård" ; -- prästgårdsträdgård..nn.1
  prästinna_1_N = mkN "prästinna" ; -- prästinna..nn.1
  prästkappa_1_N = mkN "prästkappa" ; -- prästkappa..nn.1
  prästkrage_1_N = mkN "prästkrage" utrum  ; -- prästkrage..nn.1
  prästman_1_N = mkN "prästman" "prästmannen" "prästmän" "prästmännen" ; -- prästman..nn.1
  prästost_1_N = mkN "prästost" ; -- prästost..nn.1
  prästrock_1_N = mkN "prästrock" ; -- prästrock..nn.1
  prästroll_1_N = mkN "prästroll" "prästroller" ; -- prästroll..nn.1
  prästseminarium_1_N = mkN "prästseminarium" "prästseminariet" "prästseminarier" "prästseminarierna" ; -- prästseminarium..nn.1
  prästskrud_1_N = mkN "prästskrud" ; -- prästskrud..nn.1
  präststånd_1_N = mkN "präststånd" neutrum  ; -- präststånd..nn.1
  prästtillsättning_1_N = mkN "prästtillsättning" ; -- prästtillsättning..nn.1
  prästtitel_1_N = mkN "prästtitel" ; -- prästtitel..nn.1
  prästutbildning_1_N = mkN "prästutbildning" ; -- prästutbildning..nn.1
  prästviga_1_V = mkV "prästviger" ; -- prästviga..vb.1
  prästvigande_1_N = mkN "prästvigande" ; -- prästvigande..nn.1
  prästvigning_1_N = mkN "prästvigning" ; -- prästvigning..nn.1
  prästvälde_1_N = mkN "prästvälde" ; -- prästvälde..nn.1
  prästämbete_1_N = mkN "prästämbete" ; -- prästämbete..nn.1
  prästänka_1_N = mkN "prästänka" ; -- prästänka..nn.1
  prål_1_N = mkN "prål" neutrum  ; -- prål..nn.1
  pråla_1_V = mkV "prålar" ; -- pråla..vb.1
  prålande_1_N = mkN "prålande" ; -- prålande..nn.1
  prålfri_1_A = mkA "prålfri" "prålfritt" ; -- prålfri..av.1
  prålig_1_A = mkA "prålig" ; -- prålig..av.1
  prålighet_1_N = mkN "prålighet" "pråligheter" ; -- prålighet..nn.1
  pråm_1_N = mkN "pråm" ; -- pråm..nn.1
  pråma_1_V = mkV "pråmar" ; -- pråma..vb.1
  pråmande_1_N = mkN "pråmande" ; -- pråmande..nn.1
  prång_1_N = mkN "prång" neutrum  ; -- prång..nn.1
  prångla_1_V = mkV "prånglar" ; -- prångla..vb.1
  prånglande_1_N = mkN "prånglande" ; -- prånglande..nn.1
  prånglare_1_N = mkN "prånglare" utrum  ; -- prånglare..nn.1
  prångleri_1_N = mkN "prångleri" "prångleriet" "prånglerier" "prånglerierna" ; -- prångleri..nn.1
  pröjs_1_N = mkN "pröjs" neutrum  ; -- pröjs..nn.1
  pröjsa_1_V = mkV "pröjsar" ; -- pröjsa..vb.1
  pröjsande_1_N = mkN "pröjsande" ; -- pröjsande..nn.1
  pröva_1_V = mkV "prövar" ; -- pröva..vb.1
  prövande_1_A = mkA "prövande" ; -- prövande..av.1
  prövande_1_N = mkN "prövande" ; -- prövande..nn.1
  prövning_1_N = mkN "prövning" ; -- prövning..nn.1
  prövningstillstånd_1_N = mkN "prövningstillstånd" neutrum  ; -- prövningstillstånd..nn.1
  prövostund_1_N = mkN "prövostund" "prövostunder" ; -- prövostund..nn.1
  prövotid_1_N = mkN "prövotid" "prövotider" ; -- prövotid..nn.1
  psalm_1_N = mkN "psalm" "psalmer" ; -- psalm..nn.1
  psalmbok_1_N = mkN "psalmbok" "psalmböcker" ; -- psalmbok..nn.1
  psalmdiktare_1_N = mkN "psalmdiktare" utrum  ; -- psalmdiktare..nn.1
  psalmist_1_N = mkN "psalmist" "psalmister" ; -- psalmist..nn.1
  psalmnummer_1_N = mkN "psalmnummer" neutrum  ; -- psalmnummer..nn.1
  psalmodi_1_N = mkN "psalmodi" "psalmodier" ; -- psalmodi..nn.1
  psalmodikon_1_N = mkN "psalmodikon" neutrum  ; -- psalmodikon..nn.1
  psalmvers_1_N = mkN "psalmvers" ; -- psalmvers..nn.1
  psaltare_1_N = mkN "psaltare" utrum  ; -- psaltare..nn.1
  pseudohändelse_1_N = mkN "pseudohändelse" "pseudohändelser" ; -- pseudohändelse..nn.1
  pseudonyhet_1_N = mkN "pseudonyhet" "pseudonyheter" ; -- pseudonyhet..nn.1
  pseudonym_1_N = mkN "pseudonym" "pseudonymer" ; -- pseudonym..nn.1
  pseudoproblem_1_N = mkN "pseudoproblem" neutrum  ; -- pseudoproblem..nn.1
  pseudovetenskap_1_N = mkN "pseudovetenskap" "pseudovetenskaper" ; -- pseudovetenskap..nn.1
  pseudovetenskaplig_1_A = mkA "pseudovetenskaplig" ; -- pseudovetenskaplig..av.1
  psi_1_N = mkN "psi" neutrum  ; -- psi..nn.1
  psittakos_1_N = mkN "psittakos" ; -- psittakos..nn.1
  psoriasis_1_N = mkN "psoriasis" ; -- psoriasis..nn.1
  psoriasisartrit_1_N = mkN "psoriasisartrit" ; -- psoriasisartrit..nn.1
  psoriatiker_1_N = mkN "psoriatiker" "psoriatikern" "psoriatiker" "psoriatikerna" ; -- psoriatiker..nn.1
  psyka_1_V = mkV "psykar" ; -- psyka..vb.1
  psykande_1_N = mkN "psykande" ; -- psykande..nn.1
  psykbryt_1_N = mkN "psykbryt" neutrum  ; -- psykbryt..nn.1
  psykdoktor_1_N = mkN "psykdoktor" "psykdoktorer" ; -- psykdoktor..nn.1
  psyke_1_N = mkN "psyke" ; -- psyke..nn.1
  psykedelisk_1_A = mkA "psykedelisk" ; -- psykedelisk..av.1
  psykfall_1_N = mkN "psykfall" neutrum  ; -- psykfall..nn.1
  psykiater_1_N = mkN "psykiater" "psykiatern" "psykiatrer" "psykiatrerna" ; -- psykiater..nn.1
  psykiaterförbund_1_N = mkN "psykiaterförbund" neutrum  ; -- psykiaterförbund..nn.1
  psykiatri_1_N = mkN "psykiatri" ; -- psykiatri..nn.1
  psykiatriker_1_N = mkN "psykiatriker" "psykiatrikern" "psykiatriker" "psykiatrikerna" ; -- psykiatriker..nn.1
  psykiatrisk_1_A = mkA "psykiatrisk" ; -- psykiatrisk..av.1
  psykisk_1_A = mkA "psykisk" ; -- psykisk..av.1
  psykoanalys_1_N = mkN "psykoanalys" "psykoanalyser" ; -- psykoanalys..nn.1
  psykoanalysera_1_V = mkV "psykoanalyserar" ; -- psykoanalysera..vb.1
  psykoanalyserande_1_N = mkN "psykoanalyserande" ; -- psykoanalyserande..nn.1
  psykoanalyserbar_1_A = mkA "psykoanalyserbar" ; -- psykoanalyserbar..av.1
  psykoanalyserbarhet_1_N = mkN "psykoanalyserbarhet" ; -- psykoanalyserbarhet..nn.1
  psykoanalysering_1_N = mkN "psykoanalysering" ; -- psykoanalysering..nn.1
  psykoanalyssoffa_1_N = mkN "psykoanalyssoffa" ; -- psykoanalyssoffa..nn.1
  psykoanalytiker_1_N = mkN "psykoanalytiker" "psykoanalytikern" "psykoanalytiker" "psykoanalytikerna" ; -- psykoanalytiker..nn.1
  psykoanalytisk_1_A = mkA "psykoanalytisk" ; -- psykoanalytisk..av.1
  psykofarmaka_1_N = mkN "psykofarmaka" "psykofarmakat" "psykofarmaka" "psykofarmakana" ; -- psykofarmaka..nn.1
  psykofysik_1_N = mkN "psykofysik" ; -- psykofysik..nn.1
  psykogen_1_A = mkA "psykogen" "psykogent" ; -- psykogen..av.1
  psykokirurgi_1_N = mkN "psykokirurgi" ; -- psykokirurgi..nn.1
  psykolingvistik_1_N = mkN "psykolingvistik" ; -- psykolingvistik..nn.1
  psykolog_1_N = mkN "psykolog" "psykologer" ; -- psykolog..nn.1
  psykologhjälp_1_N = mkN "psykologhjälp" ; -- psykologhjälp..nn.1
  psykologi_1_N = mkN "psykologi" ; -- psykologi..nn.1
  psykologiprofessor_1_N = mkN "psykologiprofessor" "psykologiprofessorer" ; -- psykologiprofessor..nn.1
  psykologisera_1_V = mkV "psykologiserar" ; -- psykologisera..vb.1
  psykologiserande_1_N = mkN "psykologiserande" ; -- psykologiserande..nn.1
  psykologiserbar_1_A = mkA "psykologiserbar" ; -- psykologiserbar..av.1
  psykologiserbarhet_1_N = mkN "psykologiserbarhet" ; -- psykologiserbarhet..nn.1
  psykologisering_1_N = mkN "psykologisering" ; -- psykologisering..nn.1
  psykologisk_1_A = mkA "psykologisk" ; -- psykologisk..av.1
  psykometri_1_N = mkN "psykometri" ; -- psykometri..nn.1
  psykopat_1_N = mkN "psykopat" "psykopater" ; -- psykopat..nn.1
  psykopati_1_N = mkN "psykopati" "psykopatier" ; -- psykopati..nn.1
  psykopatologi_1_N = mkN "psykopatologi" ; -- psykopatologi..nn.1
  psykoprofylaktisk_1_A = mkA "psykoprofylaktisk" ; -- psykoprofylaktisk..av.1
  psykoprofylax_1_N = mkN "psykoprofylax" ; -- psykoprofylax..nn.1
  psykos_1_N = mkN "psykos" "psykoser" ; -- psykos..nn.1
  psykosocial_1_A = mkA "psykosocial" ; -- psykosocial..av.1
  psykosomatisk_1_A = mkA "psykosomatisk" ; -- psykosomatisk..av.1
  psykoteknik_1_N = mkN "psykoteknik" ; -- psykoteknik..nn.1
  psykoterapeut_1_N = mkN "psykoterapeut" "psykoterapeuter" ; -- psykoterapeut..nn.1
  psykoterapeutisk_1_A = mkA "psykoterapeutisk" ; -- psykoterapeutisk..av.1
  psykoterapi_1_N = mkN "psykoterapi" "psykoterapier" ; -- psykoterapi..nn.1
  psykotisk_1_A = mkA "psykotisk" ; -- psykotisk..av.1
  psykotropisk_1_A = mkA "psykotropisk" ; -- psykotropisk..av.1
  psykotropiskhet_1_N = mkN "psykotropiskhet" ; -- psykotropiskhet..nn.1
  psykrometer_1_N = mkN "psykrometer" ; -- psykrometer..nn.1
  ptolemeisk_1_A = mkA "ptolemeisk" ; -- ptolemeisk..av.1
  pub_1_N = mkN "pub" ; -- pub..nn.1
  pubbeunge_1_N = mkN "pubbeunge" utrum  ; -- pubbeunge..nn.1
  pubertal_1_A = mkA "pubertal" ; -- pubertal..av.1
  pubertet_1_N = mkN "pubertet" "puberteter" ; -- pubertet..nn.1
  pubertetsflicka_1_N = mkN "pubertetsflicka" ; -- pubertetsflicka..nn.1
  pubertetsperiod_1_N = mkN "pubertetsperiod" "pubertetsperioder" ; -- pubertetsperiod..nn.1
  pubertetsyngling_1_N = mkN "pubertetsyngling" ; -- pubertetsyngling..nn.1
  pubertetsålder_1_N = mkN "pubertetsålder" ; -- pubertetsålder..nn.1
  pubeshår_1_N = mkN "pubeshår" neutrum  ; -- pubeshår..nn.1
  pubeshår_2_N = mkN "pubeshår" neutrum  ; -- pubeshår..nn.2
  pubesring_1_N = mkN "pubesring" ; -- pubesring..nn.1
  pubisring_1_N = mkN "pubisring" ; -- pubisring..nn.1
  publicera_1_V = mkV "publicerar" ; -- publicera..vb.1
  publicerande_1_N = mkN "publicerande" ; -- publicerande..nn.1
  publicerbar_1_A = mkA "publicerbar" ; -- publicerbar..av.1
  publicerbarhet_1_N = mkN "publicerbarhet" ; -- publicerbarhet..nn.1
  publicering_1_N = mkN "publicering" ; -- publicering..nn.1
  publiceringsbeslut_1_N = mkN "publiceringsbeslut" neutrum  ; -- publiceringsbeslut..nn.1
  publicist_1_N = mkN "publicist" "publicister" ; -- publicist..nn.1
  publicistik_1_N = mkN "publicistik" ; -- publicistik..nn.1
  publicistisk_1_A = mkA "publicistisk" ; -- publicistisk..av.1
  publicitet_1_N = mkN "publicitet" "publiciteter" ; -- publicitet..nn.1
  publik_1_A = mkA "publik" ; -- publik..av.1
  publik_1_N = mkN "publik" "publiker" ; -- publik..nn.1
  publikan_1_N = mkN "publikan" "publikaner" ; -- publikan..nn.1
  publikation_1_N = mkN "publikation" ; -- publikation..nn.1
  publikdragande_1_A = mkA "publikdragande" ; -- publikdragande..av.1
  publikfriande_1_A = mkA "publikfriande" ; -- publikfriande..av.1
  publikhav_1_N = mkN "publikhav" neutrum  ; -- publikhav..nn.1
  publikmässig_1_A = mkA "publikmässig" ; -- publikmässig..av.1
  publiktryck_1_N = mkN "publiktryck" neutrum  ; -- publiktryck..nn.1
  publikum_1_N = mkN "publikum" ; -- publikum..nn.1
  puck_1_N = mkN "puck" ; -- puck..nn.1
  puckad_1_A = mkA "puckad" ; -- puckad..av.1
  puckadhet_1_N = mkN "puckadhet" "puckadheter" ; -- puckadhet..nn.1
  puckare_1_N = mkN "puckare" utrum  ; -- puckare..nn.1
  puckel_1_N = mkN "puckel" ; -- puckel..nn.1
  puckel_2_N = mkN "puckel" neutrum  ; -- puckel..nn.2
  puckeloxe_1_N = mkN "puckeloxe" utrum  ; -- puckeloxe..nn.1
  puckelpist_1_N = mkN "puckelpist" "puckelpister" ; -- puckelpist..nn.1
  puckelrygg_1_N = mkN "puckelrygg" ; -- puckelrygg..nn.1
  puckelryggig_1_A = mkA "puckelryggig" ; -- puckelryggig..av.1
  puckelryggighet_1_N = mkN "puckelryggighet" ; -- puckelryggighet..nn.1
  pucklig_1_A = mkA "pucklig" ; -- pucklig..av.1
  pucklighet_1_N = mkN "pucklighet" ; -- pucklighet..nn.1
  pucko_1_N = mkN "pucko" "puckot" "puckon" "puckona" ; -- pucko..nn.1
  pudding_1_N = mkN "pudding" ; -- pudding..nn.1
  puddla_1_V = mkV "puddlar" ; -- puddla..vb.1
  puddlande_1_N = mkN "puddlande" ; -- puddlande..nn.1
  pudel_1_N = mkN "pudel" ; -- pudel..nn.1
  puder_1_N = mkN "puder" neutrum  ; -- puder..nn.1
  puderfin_1_A = mkA "puderfin" ; -- puderfin..av.1
  puderkräm_1_N = mkN "puderkräm" "puderkrämer" ; -- puderkräm..nn.1
  pudersnö_1_N = mkN "pudersnö" ; -- pudersnö..nn.1
  pudersocker_1_N = mkN "pudersocker" neutrum  ; -- pudersocker..nn.1
  puderunderlag_1_N = mkN "puderunderlag" neutrum  ; -- puderunderlag..nn.1
  pudervippa_1_N = mkN "pudervippa" ; -- pudervippa..nn.1
  pudla_1_V = mkV "pudlar" ; -- pudla..vb.1
  pudlande_1_N = mkN "pudlande" ; -- pudlande..nn.1
  pudra_1_V = mkV "pudrar" ; -- pudra..vb.1
  pudrande_1_N = mkN "pudrande" ; -- pudrande..nn.1
  pudrett_1_N = mkN "pudrett" ; -- pudrett..nn.1
  pudrig_1_A = mkA "pudrig" ; -- pudrig..av.1
  pudrighet_1_N = mkN "pudrighet" ; -- pudrighet..nn.1
  puebloindian_1_N = mkN "puebloindian" "puebloindianer" ; -- puebloindian..nn.1
  pueril_1_A = mkA "pueril" ; -- pueril..av.1
  puerilitet_1_N = mkN "puerilitet" "pueriliteter" ; -- puerilitet..nn.1
  puertoricansk_1_A = mkA "puertoricansk" ; -- puertoricansk..av.1
  puertoricanskhet_1_N = mkN "puertoricanskhet" ; -- puertoricanskhet..nn.1
  puff_1_N = mkN "puff" ; -- puff..nn.1
  puffa_1_V = mkV "puffar" ; -- puffa..vb.1
  puffa_2_V = mkV "puffar" ; -- puffa..vb.2
  puffande_1_N = mkN "puffande" ; -- puffande..nn.1
  puffert_1_N = mkN "puffert" ; -- puffert..nn.1
  puffra_1_N = mkN "puffra" ; -- puffra..nn.1
  puffärm_1_N = mkN "puffärm" ; -- puffärm..nn.1
  pugilism_1_N = mkN "pugilism" "pugilismer" ; -- pugilism..nn.1
  pugilist_1_N = mkN "pugilist" "pugilister" ; -- pugilist..nn.1
  pugilistik_1_N = mkN "pugilistik" ; -- pugilistik..nn.1
  pugilistisk_1_A = mkA "pugilistisk" ; -- pugilistisk..av.1
  puka_1_N = mkN "puka" ; -- puka..nn.1
  puke_1_N = mkN "puke" utrum  ; -- puke..nn.1
  pukslag_1_N = mkN "pukslag" neutrum  ; -- pukslag..nn.1
  pukslagare_1_N = mkN "pukslagare" utrum  ; -- pukslagare..nn.1
  pula_1_V = mkV "pular" ; -- pula..vb.1
  pulande_1_N = mkN "pulande" ; -- pulande..nn.1
  pulka_1_N = mkN "pulka" ; -- pulka..nn.1
  pulkabacke_1_N = mkN "pulkabacke" utrum  ; -- pulkabacke..nn.1
  pulkåkning_1_N = mkN "pulkåkning" ; -- pulkåkning..nn.1
  pulla_1_N = mkN "pulla" ; -- pulla..nn.1
  pulla_1_V = mkV "pullar" ; -- pulla..vb.1
  pullande_1_N = mkN "pullande" ; -- pullande..nn.1
  pullmanvagn_1_N = mkN "pullmanvagn" ; -- pullmanvagn..nn.1
  pullover_1_N = mkN "pullover" ; -- pullover..nn.1
  pulpa_1_N = mkN "pulpa" ; -- pulpa..nn.1
  pulpet_1_N = mkN "pulpet" "pulpeter" ; -- pulpet..nn.1
  pulpettak_1_N = mkN "pulpettak" neutrum  ; -- pulpettak..nn.1
  pulpit_1_N = mkN "pulpit" ; -- pulpit..nn.1
  puls_1_N = mkN "puls" "pulser" ; -- puls..nn.1
  puls_2_N = mkN "puls" ; -- puls..nn.2
  pulsa_1_V = mkV "pulsar" ; -- pulsa..vb.1
  pulsande_1_N = mkN "pulsande" ; -- pulsande..nn.1
  pulsar_1_N = mkN "pulsar" "pulsarer" ; -- pulsar..nn.1
  pulsera_1_V = mkV "pulserar" ; -- pulsera..vb.1
  pulserande_1_N = mkN "pulserande" ; -- pulserande..nn.1
  pulsering_1_N = mkN "pulsering" ; -- pulsering..nn.1
  pulsklocka_1_N = mkN "pulsklocka" ; -- pulsklocka..nn.1
  pulsläsare_1_N = mkN "pulsläsare" utrum  ; -- pulsläsare..nn.1
  pulsslag_1_N = mkN "pulsslag" neutrum  ; -- pulsslag..nn.1
  pulstagning_1_N = mkN "pulstagning" ; -- pulstagning..nn.1
  pulståg_1_N = mkN "pulståg" neutrum  ; -- pulståg..nn.1
  pulsval_1_N = mkN "pulsval" neutrum  ; -- pulsval..nn.1
  pulsåder_1_N = mkN "pulsådra" ; -- pulsåder..nn.1
  pult_1_N = mkN "pult" "pulter" ; -- pult..nn.1
  pultron_1_N = mkN "pultron" "pultroner" ; -- pultron..nn.1
  pultroneri_1_N = mkN "pultroneri" neutrum  ; -- pultroneri..nn.1
  pulver_1_N = mkN "pulver" neutrum  ; -- pulver..nn.1
  pulverform_1_N = mkN "pulverform" ; -- pulverform..nn.1
  pulverisera_1_V = mkV "pulveriserar" ; -- pulverisera..vb.1
  pulveriserande_1_N = mkN "pulveriserande" ; -- pulveriserande..nn.1
  pulveriserbar_1_A = mkA "pulveriserbar" ; -- pulveriserbar..av.1
  pulveriserbarhet_1_N = mkN "pulveriserbarhet" ; -- pulveriserbarhet..nn.1
  pulverisering_1_N = mkN "pulverisering" ; -- pulverisering..nn.1
  pulverkaffe_1_N = mkN "pulverkaffe" ; -- pulverkaffe..nn.1
  pulverlack_1_N = mkN "pulverlack" "pulverlacker" ; -- pulverlack..nn.1
  pulverlackera_1_V = mkV "pulverlackerar" ; -- pulverlackera..vb.1
  pulverlackerande_1_N = mkN "pulverlackerande" ; -- pulverlackerande..nn.1
  pulverlackerbar_1_A = mkA "pulverlackerbar" ; -- pulverlackerbar..av.1
  pulverlackerbarhet_1_N = mkN "pulverlackerbarhet" ; -- pulverlackerbarhet..nn.1
  pulvermetallurgi_1_N = mkN "pulvermetallurgi" ; -- pulvermetallurgi..nn.1
  pulversläckare_1_N = mkN "pulversläckare" utrum  ; -- pulversläckare..nn.1
  pulversoppa_1_N = mkN "pulversoppa" ; -- pulversoppa..nn.1
  pulvrisera_1_V = mkV "pulvriserar" ; -- pulvrisera..vb.1
  pulvriserande_1_N = mkN "pulvriserande" ; -- pulvriserande..nn.1
  pulvriserbar_1_A = mkA "pulvriserbar" ; -- pulvriserbar..av.1
  pulvriserbarhet_1_N = mkN "pulvriserbarhet" ; -- pulvriserbarhet..nn.1
  pulvrisering_1_N = mkN "pulvrisering" ; -- pulvrisering..nn.1
  puma_1_N = mkN "puma" ; -- puma..nn.1
  pump_1_N = mkN "pump" ; -- pump..nn.1
  pump_2_N = mkN "pump" ; -- pump..nn.2
  pumpa_1_N = mkN "pumpa" ; -- pumpa..nn.1
  pumpa_1_V = mkV "pumpar" ; -- pumpa..vb.1
  pumpande_1_N = mkN "pumpande" ; -- pumpande..nn.1
  pumpernickel_1_N = mkN "pumpernickel" ; -- pumpernickel..nn.1
  pumpkolv_1_N = mkN "pumpkolv" ; -- pumpkolv..nn.1
  pumpmotor_1_N = mkN "pumpmotor" "pumpmotorer" ; -- pumpmotor..nn.1
  pumpsats_1_N = mkN "pumpsats" "pumpsatser" ; -- pumpsats..nn.1
  pumpstövel_1_N = mkN "pumpstövel" ; -- pumpstövel..nn.1
  pumpverk_1_N = mkN "pumpverk" neutrum  ; -- pumpverk..nn.1
  punch_1_N = mkN "punch" ; -- punch..nn.1
  pund_1_N = mkN "pund" neutrum  ; -- pund..nn.1
  pundare_1_N = mkN "pundare" utrum  ; -- pundare..nn.1
  pundhuvud_1_N = mkN "pundhuvud" "pundhuvudet" "pundhuvud" "pundhuvudena" ; -- pundhuvud..nn.1
  pundig_1_A = mkA "pundig" ; -- pundig..av.1
  pundighet_1_N = mkN "pundighet" ; -- pundighet..nn.1
  pundkris_1_N = mkN "pundkris" "pundkriser" ; -- pundkris..nn.1
  pung_1_N = mkN "pung" ; -- pung..nn.1
  pungbjörn_1_N = mkN "pungbjörn" ; -- pungbjörn..nn.1
  pungdjur_1_N = mkN "pungdjur" neutrum  ; -- pungdjur..nn.1
  pungdjävul_1_N = mkN "pungdjävul" ; -- pungdjävul..nn.1
  punggrävling_1_N = mkN "punggrävling" ; -- punggrävling..nn.1
  punghållande_1_N = mkN "punghållande" ; -- punghållande..nn.1
  pungmes_1_N = mkN "pungmes" ; -- pungmes..nn.1
  pungråtta_1_N = mkN "pungråtta" ; -- pungråtta..nn.1
  pungslagning_1_N = mkN "pungslagning" ; -- pungslagning..nn.1
  pungslå_1_V = mkV "pungslå" "pungslog" "pungslagit" ; -- pungslå..vb.1
  pungslående_1_N = mkN "pungslående" ; -- pungslående..nn.1
  pungsten_1_N = mkN "pungsten" "pungstenen" "pungstenar" "pungstenarna" ; -- pungsten..nn.1
  punisk_1_A = mkA "punisk" ; -- punisk..av.1
  punk_1_N = mkN "punk" ; -- punk..nn.1
  punka_1_N = mkN "punka" ; -- punka..nn.1
  punkare_1_N = mkN "punkare" utrum  ; -- punkare..nn.1
  punkband_1_N = mkN "punkband" neutrum  ; -- punkband..nn.1
  punkfrisyr_1_N = mkN "punkfrisyr" "punkfrisyrer" ; -- punkfrisyr..nn.1
  punkig_1_A = mkA "punkig" ; -- punkig..av.1
  punkt_1_N = mkN "punkt" "punkter" ; -- punkt..nn.1
  punkta_1_V = mkV "punktar" ; -- punkta..vb.1
  punktalglas_1_N = mkN "punktalglas" neutrum  ; -- punktalglas..nn.1
  punktande_1_N = mkN "punktande" ; -- punktande..nn.1
  punktbevaka_1_V = mkV "punktbevakar" ; -- punktbevaka..vb.1
  punktbevakande_1_N = mkN "punktbevakande" ; -- punktbevakande..nn.1
  punktbevakning_1_N = mkN "punktbevakning" ; -- punktbevakning..nn.1
  punktera_1_V = mkV "punkterar" ; -- punktera..vb.1
  punkterande_1_N = mkN "punkterande" ; -- punkterande..nn.1
  punkterbar_1_A = mkA "punkterbar" ; -- punkterbar..av.1
  punkterbarhet_1_N = mkN "punkterbarhet" ; -- punkterbarhet..nn.1
  punktering_1_N = mkN "punktering" ; -- punktering..nn.1
  punkteringsspray_1_N = mkN "punkteringsspray" "punkteringssprayen" "punkteringssprayer" "punkteringssprayerna" ; -- punkteringsspray..nn.1
  punkteringssprej_1_N = mkN "punkteringssprej" "punkteringssprejer" ; -- punkteringssprej..nn.1
  punktgravyr_1_N = mkN "punktgravyr" ; -- punktgravyr..nn.1
  punkthus_1_N = mkN "punkthus" neutrum  ; -- punkthus..nn.1
  punktinsats_1_N = mkN "punktinsats" "punktinsatser" ; -- punktinsats..nn.1
  punktion_1_N = mkN "punktion" ; -- punktion..nn.1
  punktlig_1_A = mkA "punktlig" ; -- punktlig..av.1
  punktlighet_1_N = mkN "punktlighet" ; -- punktlighet..nn.1
  punktmarkera_1_V = mkV "punktmarkerar" ; -- punktmarkera..vb.1
  punktmusik_1_N = mkN "punktmusik" ; -- punktmusik..nn.1
  punktmängd_1_N = mkN "punktmängd" "punktmängder" ; -- punktmängd..nn.1
  punktskatt_1_N = mkN "punktskatt" "punktskatter" ; -- punktskatt..nn.1
  punktskrift_1_N = mkN "punktskrift" ; -- punktskrift..nn.1
  punktsvetsa_1_V = mkV "punktsvetsar" ; -- punktsvetsa..vb.1
  punktsvetsande_1_N = mkN "punktsvetsande" ; -- punktsvetsande..nn.1
  punktuell_1_A = mkA "punktuell" ; -- punktuell..av.1
  punktur_1_N = mkN "punktur" "punkturer" ; -- punktur..nn.1
  punktvis_1_Adv = mkAdv "punktvis" ; -- punktvis..ab.1
  puns_1_N = mkN "puns" ; -- puns..nn.1
  punsa_1_V = mkV "punsar" ; -- punsa..vb.1
  punsande_1_N = mkN "punsande" ; -- punsande..nn.1
  punsch_1_N = mkN "punsch" ; -- punsch..nn.1
  punschpralin_1_N = mkN "punschpralin" "punschpraliner" ; -- punschpralin..nn.1
  punsning_1_N = mkN "punsning" ; -- punsning..nn.1
  pupill_1_N = mkN "pupill" "pupiller" ; -- pupill..nn.1
  pupillförstorande_1_A = mkA "pupillförstorande" ; -- pupillförstorande..av.1
  puppa_1_N = mkN "puppa" ; -- puppa..nn.1
  pur_1_A = mkA "pur" ; -- pur..av.1
  purgativ_1_N = mkN "purgativ" neutrum  ; -- purgativ..nn.1
  purgera_1_V = mkV "purgerar" ; -- purgera..vb.1
  purgerande_1_N = mkN "purgerande" ; -- purgerande..nn.1
  purgerbar_1_A = mkA "purgerbar" ; -- purgerbar..av.1
  purgerbarhet_1_N = mkN "purgerbarhet" ; -- purgerbarhet..nn.1
  purgering_1_N = mkN "purgering" ; -- purgering..nn.1
  purhet_1_N = mkN "purhet" ; -- purhet..nn.1
  purin_1_N = mkN "purin" "puriner" ; -- purin..nn.1
  purism_1_N = mkN "purism" "purismer" ; -- purism..nn.1
  purist_1_N = mkN "purist" "purister" ; -- purist..nn.1
  puristisk_1_A = mkA "puristisk" ; -- puristisk..av.1
  puritan_1_N = mkN "puritan" "puritaner" ; -- puritan..nn.1
  puritanism_1_N = mkN "puritanism" "puritanismer" ; -- puritanism..nn.1
  puritanistisk_1_A = mkA "puritanistisk" ; -- puritanistisk..av.1
  puritansk_1_A = mkA "puritansk" ; -- puritansk..av.1
  purjolök_1_N = mkN "purjolök" ; -- purjolök..nn.1
  purken_1_A = mkA "purken" ; -- purken..av.1
  purkenhet_1_N = mkN "purkenhet" ; -- purkenhet..nn.1
  purkna_1_V = mkV "purknar" ; -- purkna..vb.1
  purknande_1_N = mkN "purknande" ; -- purknande..nn.1
  purpra_1_V = mkV "purprar" ; -- purpra..vb.1
  purprande_1_N = mkN "purprande" ; -- purprande..nn.1
  purpurfärga_1_V = mkV "purpurfärgar" ; -- purpurfärga..vb.1
  purpurfärgad_1_A = mkA "purpurfärgad" ; -- purpurfärgad..av.1
  purpurfärgande_1_N = mkN "purpurfärgande" ; -- purpurfärgande..nn.1
  purpurmantel_1_N = mkN "purpurmantel" ; -- purpurmantel..nn.1
  purpurröd_1_A = mkA "purpurröd" "purpurrött" ; -- purpurröd..av.1
  purpursnäcka_1_N = mkN "purpursnäcka" ; -- purpursnäcka..nn.1
  purra_1_V = mkV "purrar" ; -- purra..vb.1
  purrande_1_N = mkN "purrande" ; -- purrande..nn.1
  purser_1_N = mkN "purser" ; -- purser..nn.1
  puré_1_N = mkN "puré" "puréer" ; -- puré..nn.1
  pusha_1_V = mkV "pushar" ; -- pusha..vb.1
  pushande_1_N = mkN "pushande" ; -- pushande..nn.1
  pushup_1_N = mkN "pushup" "pushuper" ; -- pushup..nn.1
  puss_1_N = mkN "puss" ; -- puss..nn.1
  pussa_1_V = mkV "pussar" ; -- pussa..vb.1
  pussande_1_N = mkN "pussande" ; -- pussande..nn.1
  pussel_1_N = mkN "pussel" neutrum  ; -- pussel..nn.1
  pusselbit_1_N = mkN "pusselbit" ; -- pusselbit..nn.1
  pussig_1_A = mkA "pussig" ; -- pussig..av.1
  pussighet_1_N = mkN "pussighet" ; -- pussighet..nn.1
  pusskalas_1_N = mkN "pusskalas" neutrum  ; -- pusskalas..nn.1
  pussla_1_V = mkV "pusslar" ; -- pussla..vb.1
  pusslande_1_N = mkN "pusslande" ; -- pusslande..nn.1
  pust_1_N = mkN "pust" ; -- pust..nn.1
  pusta_1_N = mkN "pusta" ; -- pusta..nn.1
  pusta_1_V = mkV "pustar" ; -- pusta..vb.1
  pustande_1_N = mkN "pustande" ; -- pustande..nn.1
  pustel_1_N = mkN "pustel" "pusteln" "pustler" "pustlerna" ; -- pustel..nn.1
  pustning_1_N = mkN "pustning" ; -- pustning..nn.1
  puta_1_N = mkN "puta" ; -- puta..nn.1
  puta_1_V = mkV "putar" ; -- puta..vb.1
  putande_1_N = mkN "putande" ; -- putande..nn.1
  putig_1_A = mkA "putig" ; -- putig..av.1
  putmage_1_N = mkN "putmage" utrum  ; -- putmage..nn.1
  putrid_1_A = mkA "putrid" ; -- putrid..av.1
  puts_1_N = mkN "puts" ; -- puts..nn.1
  puts_2_N = mkN "puts" neutrum  ; -- puts..nn.2
  putsa_1_V = mkV "putsar" ; -- putsa..vb.1
  putsande_1_N = mkN "putsande" ; -- putsande..nn.1
  putsch_1_N = mkN "putsch" "putscher" ; -- putsch..nn.1
  putsduk_1_N = mkN "putsduk" ; -- putsduk..nn.1
  putslustig_1_A = mkA "putslustig" ; -- putslustig..av.1
  putslustighet_1_N = mkN "putslustighet" "putslustigheter" ; -- putslustighet..nn.1
  putsning_1_N = mkN "putsning" ; -- putsning..nn.1
  putstrasa_1_N = mkN "putstrasa" ; -- putstrasa..nn.1
  putt_1_A = mkA "putt" ; -- putt..av.1
  putt_1_N = mkN "putt" ; -- putt..nn.1
  putta_1_V = mkV "puttar" ; -- putta..vb.1
  puttande_1_N = mkN "puttande" ; -- puttande..nn.1
  putte_1_N = mkN "putte" utrum  ; -- putte..nn.1
  puttefnask_1_N = mkN "puttefnask" ; -- puttefnask..nn.1
  putter_1_N = mkN "putter" neutrum  ; -- putter..nn.1
  putthet_1_N = mkN "putthet" ; -- putthet..nn.1
  putting_1_N = mkN "putting" ; -- putting..nn.1
  putto_1_N = mkN "putto" "putton" "putti" "puttina" ; -- putto..nn.1
  puttra_1_V = mkV "puttrar" ; -- puttra..vb.1
  puttrande_1_N = mkN "puttrande" ; -- puttrande..nn.1
  puttrig_1_A = mkA "puttrig" ; -- puttrig..av.1
  puttrighet_1_N = mkN "puttrighet" ; -- puttrighet..nn.1
  puzzle_1_N = mkN "puzzle" "puzzlet" "puzzle" "puzzlen" ; -- puzzle..nn.1
  pycke_1_N = mkN "pycke" ; -- pycke..nn.1
  pyelit_1_N = mkN "pyelit" "pyeliter" ; -- pyelit..nn.1
  pygmé_1_N = mkN "pygmé" "pygméer" ; -- pygmé..nn.1
  pyjamas_1_N = mkN "pyjamas" ; -- pyjamas..nn.1
  pyjamasficka_1_N = mkN "pyjamasficka" ; -- pyjamasficka..nn.1
  pyjamasgylf_1_N = mkN "pyjamasgylf" ; -- pyjamasgylf..nn.1
  pyjamasparty_1_N = mkN "pyjamasparty" "pyjamaspartyt" "pyjamaspartyn" "pyjamaspartyna" ; -- pyjamasparty..nn.1
  pykniker_1_N = mkN "pykniker" "pyknikern" "pykniker" "pyknikerna" ; -- pykniker..nn.1
  pyknisk_1_A = mkA "pyknisk" ; -- pyknisk..av.1
  pyknometer_1_N = mkN "pyknometer" ; -- pyknometer..nn.1
  pylon_1_N = mkN "pylon" "pyloner" ; -- pylon..nn.1
  pyndare_1_N = mkN "pyndare" utrum  ; -- pyndare..nn.1
  pyngel_1_N = mkN "pyngel" neutrum  ; -- pyngel..nn.1
  pynt_1_N = mkN "pynt" neutrum  ; -- pynt..nn.1
  pynt_2_N = mkN "pynt" ; -- pynt..nn.2
  pynta_1_V = mkV "pyntar" ; -- pynta..vb.1
  pyntande_1_N = mkN "pyntande" ; -- pyntande..nn.1
  pyra_1_V = mkV "pyra" "pyrde" "pyrt" ; -- pyra..vb.1
  pyramid_1_N = mkN "pyramid" "pyramider" ; -- pyramid..nn.1
  pyramidal_1_A = mkA "pyramidal" ; -- pyramidal..av.1
  pyramidformad_1_A = mkA "pyramidformad" ; -- pyramidformad..av.1
  pyrande_1_N = mkN "pyrande" ; -- pyrande..nn.1
  pyre_1_N = mkN "pyre" ; -- pyre..nn.1
  pyreneisk_1_A = mkA "pyreneisk" ; -- pyreneisk..av.1
  pyridin_1_N = mkN "pyridin" "pyridiner" ; -- pyridin..nn.1
  pyrit_1_N = mkN "pyrit" "pyriter" ; -- pyrit..nn.1
  pyrofil_1_A = mkA "pyrofil" ; -- pyrofil..av.1
  pyrofor_1_A = mkA "pyrofor" ; -- pyrofor..av.1
  pyroklast_1_N = mkN "pyroklast" "pyroklaster" ; -- pyroklast..nn.1
  pyroklastisk_1_A = mkA "pyroklastisk" ; -- pyroklastisk..av.1
  pyrola_1_N = mkN "pyrola" ; -- pyrola..nn.1
  pyrolys_1_N = mkN "pyrolys" ; -- pyrolys..nn.1
  pyroman_1_N = mkN "pyroman" "pyromaner" ; -- pyroman..nn.1
  pyromani_1_N = mkN "pyromani" ; -- pyromani..nn.1
  pyrometer_1_N = mkN "pyrometer" ; -- pyrometer..nn.1
  pyroteknik_1_N = mkN "pyroteknik" ; -- pyroteknik..nn.1
  pyroteknisk_1_A = mkA "pyroteknisk" ; -- pyroteknisk..av.1
  pyrrhusseger_1_N = mkN "pyrrhusseger" ; -- pyrrhusseger..nn.1
  pyrrusseger_1_N = mkN "pyrrusseger" ; -- pyrrusseger..nn.1
  pyrschjakt_1_N = mkN "pyrschjakt" ; -- pyrschjakt..nn.1
  pyrt_1_Adv = mkAdv "pyrt" ; -- pyrt..ab.1
  pys_1_N = mkN "pys" ; -- pys..nn.1
  pysa_1_V = mkV "pyser" ; -- pysa..vb.1
  pysande_1_N = mkN "pysande" ; -- pysande..nn.1
  pyspunka_1_N = mkN "pyspunka" ; -- pyspunka..nn.1
  pyssel_1_N = mkN "pyssel" neutrum  ; -- pyssel..nn.1
  pyssla_1_V = mkV "pysslar" ; -- pyssla..vb.1
  pysslande_1_N = mkN "pysslande" ; -- pysslande..nn.1
  pysslig_1_A = mkA "pysslig" ; -- pysslig..av.1
  pysslighet_1_N = mkN "pysslighet" ; -- pysslighet..nn.1
  pyssling_1_N = mkN "pyssling" ; -- pyssling..nn.1
  pyton_1_A = mkA "pyton" ; -- pyton..av.1
  pyton_1_N = mkN "pyton" ; -- pyton..nn.1
  pytonorm_1_N = mkN "pytonorm" ; -- pytonorm..nn.1
  pyts_1_N = mkN "pyts" ; -- pyts..nn.1
  pytsa_1_V = mkV "pytsar" ; -- pytsa..vb.1
  pytsande_1_N = mkN "pytsande" ; -- pytsande..nn.1
  pytt_1_N = mkN "pytt" ; -- pytt..nn.1
  pytte_1_A = mkA "pytte" ; -- pytte..av.1
  pyttipanna_1_N = mkN "pyttipanna" ; -- pyttipanna..nn.1
  päla_1_V = mkV "pälar" ; -- päla..vb.1
  pälande_1_N = mkN "pälande" ; -- pälande..nn.1
  päll_1_N = mkN "päll" ; -- päll..nn.1
  päls_1_N = mkN "päls" ; -- päls..nn.1
  pälsallergi_1_N = mkN "pälsallergi" "pälsallergier" ; -- pälsallergi..nn.1
  pälsboll_1_N = mkN "pälsboll" ; -- pälsboll..nn.1
  pälsbrämad_1_A = mkA "pälsbrämad" ; -- pälsbrämad..av.1
  pälsdesign_1_N = mkN "pälsdesign" ; -- pälsdesign..nn.1
  pälsdjur_1_N = mkN "pälsdjur" neutrum  ; -- pälsdjur..nn.1
  pälsfarm_1_N = mkN "pälsfarm" ; -- pälsfarm..nn.1
  pälsfladdrare_1_N = mkN "pälsfladdrare" utrum  ; -- pälsfladdrare..nn.1
  pälsfår_1_N = mkN "pälsfår" neutrum  ; -- pälsfår..nn.1
  pälsjägare_1_N = mkN "pälsjägare" utrum  ; -- pälsjägare..nn.1
  pälsskinn_1_N = mkN "pälsskinn" neutrum  ; -- pälsskinn..nn.1
  pälssäl_1_N = mkN "pälssäl" ; -- pälssäl..nn.1
  pälsteknisk_1_A = mkA "pälsteknisk" ; -- pälsteknisk..av.1
  pälsverk_1_N = mkN "pälsverk" neutrum  ; -- pälsverk..nn.1
  pälsänger_1_N = mkN "pälsänger" ; -- pälsänger..nn.1
  pär_1_N = mkN "pär" "pärer" ; -- pär..nn.1
  pärk_1_N = mkN "pärk" ; -- pärk..nn.1
  pärla_1_N = mkN "pärla" ; -- pärla..nn.1
  pärla_1_V = mkV "pärlar" ; -- pärla..vb.1
  pärlande_1_N = mkN "pärlande" ; -- pärlande..nn.1
  pärlband_1_N = mkN "pärlband" neutrum  ; -- pärlband..nn.1
  pärlbroderi_1_N = mkN "pärlbroderi" "pärlbroderiet" "pärlbroderier" "pärlbroderierna" ; -- pärlbroderi..nn.1
  pärlbåt_1_N = mkN "pärlbåt" ; -- pärlbåt..nn.1
  pärldraperi_1_N = mkN "pärldraperi" "pärldraperiet" "pärldraperier" "pärldraperierna" ; -- pärldraperi..nn.1
  pärlemo_1_N = mkN "pärlemo" ; -- pärlemo..nn.1
  pärlemorfjäril_1_N = mkN "pärlemorfjäril" ; -- pärlemorfjäril..nn.1
  pärlemormoln_1_N = mkN "pärlemormoln" neutrum  ; -- pärlemormoln..nn.1
  pärlemorskimrande_1_A = mkA "pärlemorskimrande" ; -- pärlemorskimrande..av.1
  pärlgarn_1_N = mkN "pärlgarn" neutrum  ; -- pärlgarn..nn.1
  pärlgryn_1_N = mkN "pärlgryn" neutrum  ; -- pärlgryn..nn.1
  pärlgrå_1_A = mkA "pärlgrå" "pärlgrått" ; -- pärlgrå..av.1
  pärlhalsband_1_N = mkN "pärlhalsband" neutrum  ; -- pärlhalsband..nn.1
  pärlhyacint_1_N = mkN "pärlhyacint" "pärlhyacinter" ; -- pärlhyacint..nn.1
  pärlhöna_1_N = mkN "pärlhöna" ; -- pärlhöna..nn.1
  pärlmussla_1_N = mkN "pärlmussla" ; -- pärlmussla..nn.1
  pärlplatta_1_N = mkN "pärlplatta" ; -- pärlplatta..nn.1
  pärlsocker_1_N = mkN "pärlsocker" neutrum  ; -- pärlsocker..nn.1
  pärlspont_1_N = mkN "pärlspont" ; -- pärlspont..nn.1
  pärlspontad_1_A = mkA "pärlspontad" ; -- pärlspontad..av.1
  pärlsponttak_1_N = mkN "pärlsponttak" neutrum  ; -- pärlsponttak..nn.1
  pärlstav_1_N = mkN "pärlstav" ; -- pärlstav..nn.1
  pärlstickning_1_N = mkN "pärlstickning" ; -- pärlstickning..nn.1
  pärlsvart_1_A = mkA "pärlsvart" "pärlsvart" ; -- pärlsvart..av.1
  pärluggla_1_N = mkN "pärluggla" ; -- pärluggla..nn.1
  pärlvit_1_A = mkA "pärlvit" ; -- pärlvit..av.1
  pärm_1_N = mkN "pärm" ; -- pärm..nn.1
  pärmblad_1_N = mkN "pärmblad" neutrum  ; -- pärmblad..nn.1
  pärmbrev_1_N = mkN "pärmbrev" neutrum  ; -- pärmbrev..nn.1
  pärmbärare_1_N = mkN "pärmbärare" utrum  ; -- pärmbärare..nn.1
  pärmebrev_1_N = mkN "pärmebrev" neutrum  ; -- pärmebrev..nn.1
  pärmkarusell_1_N = mkN "pärmkarusell" "pärmkaruseller" ; -- pärmkarusell..nn.1
  pärmslukare_1_N = mkN "pärmslukare" utrum  ; -- pärmslukare..nn.1
  päron_1_N = mkN "päron" neutrum  ; -- päron..nn.1
  päronskiva_1_N = mkN "päronskiva" ; -- päronskiva..nn.1
  päronskörd_1_N = mkN "päronskörd" ; -- päronskörd..nn.1
  päronsmak_1_N = mkN "päronsmak" ; -- päronsmak..nn.1
  päronsoda_1_N = mkN "päronsoda" ; -- päronsoda..nn.1
  päronträ_1_N = mkN "päronträ" neutrum  ; -- päronträ..nn.1
  päronträd_1_N = mkN "päronträd" neutrum  ; -- päronträd..nn.1
  pärs_1_N = mkN "pärs" ; -- pärs..nn.1
  pärt_1_N = mkN "pärt" "pärter" ; -- pärt..nn.1
  pärta_1_N = mkN "pärta" ; -- pärta..nn.1
  päsk_1_N = mkN "päsk" ; -- päsk..nn.1
  på_1_Adv = mkAdv "på" ; -- på..ab.1
  på_1_A = mkA "på" ; -- på..av.1
  påa_1_N = mkN "påa" ; -- påa..nn.1
  påa_1_V = mkV "påar" ; -- påa..vb.1
  påande_1_N = mkN "påande" ; -- påande..nn.1
  påannons_1_N = mkN "påannons" "påannonser" ; -- påannons..nn.1
  påannonsera_1_V = mkV "påannonserar" ; -- påannonsera..vb.1
  påannonserande_1_N = mkN "påannonserande" ; -- påannonserande..nn.1
  påannonserbar_1_A = mkA "påannonserbar" ; -- påannonserbar..av.1
  påannonserbarhet_1_N = mkN "påannonserbarhet" ; -- påannonserbarhet..nn.1
  påannonsering_1_N = mkN "påannonsering" ; -- påannonsering..nn.1
  påbackning_1_N = mkN "påbackning" ; -- påbackning..nn.1
  påbjuda_1_V = mkV "påbjuda" "påbjöd" "påbjudit" ; -- påbjuda..vb.1
  påbjudande_1_N = mkN "påbjudande" ; -- påbjudande..nn.1
  påbrå_1_N = mkN "påbrå" neutrum  ; -- påbrå..nn.1
  påbröd_1_N = mkN "påbröd" neutrum  ; -- påbröd..nn.1
  påbud_1_N = mkN "påbud" neutrum  ; -- påbud..nn.1
  påbyggnad_1_N = mkN "påbyggnad" "påbyggnader" ; -- påbyggnad..nn.1
  påbyltning_1_N = mkN "påbyltning" ; -- påbyltning..nn.1
  påbörda_1_V = mkV "påbördar" ; -- påbörda..vb.1
  påbördande_1_N = mkN "påbördande" ; -- påbördande..nn.1
  påbörja_1_V = mkV "påbörjar" ; -- påbörja..vb.1
  påbörjande_1_N = mkN "påbörjande" ; -- påbörjande..nn.1
  pådrag_1_N = mkN "pådrag" neutrum  ; -- pådrag..nn.1
  pådrivande_1_A = mkA "pådrivande" ; -- pådrivande..av.1
  pådrivare_1_N = mkN "pådrivare" utrum  ; -- pådrivare..nn.1
  pådrivning_1_N = mkN "pådrivning" ; -- pådrivning..nn.1
  pådyvla_1_V = mkV "pådyvlar" ; -- pådyvla..vb.1
  pådyvlande_1_N = mkN "pådyvlande" ; -- pådyvlande..nn.1
  pådyvling_1_N = mkN "pådyvling" ; -- pådyvling..nn.1
  påfallande_1_A = mkA "påfallande" ; -- påfallande..av.1
  påfart_1_N = mkN "påfart" "påfarter" ; -- påfart..nn.1
  påflugen_1_A = mkA "påflugen" ; -- påflugen..av.1
  påflugenhet_1_N = mkN "påflugenhet" ; -- påflugenhet..nn.1
  påfordra_1_V = mkV "påfordrar" ; -- påfordra..vb.1
  påfordrande_1_N = mkN "påfordrande" ; -- påfordrande..nn.1
  påfrestande_1_A = mkA "påfrestande" ; -- påfrestande..av.1
  påfrestning_1_N = mkN "påfrestning" ; -- påfrestning..nn.1
  påfund_1_N = mkN "påfund" neutrum  ; -- påfund..nn.1
  påfyllnadsförpackning_1_N = mkN "påfyllnadsförpackning" ; -- påfyllnadsförpackning..nn.1
  påfyllning_1_N = mkN "påfyllning" ; -- påfyllning..nn.1
  påfyllningspip_1_N = mkN "påfyllningspip" ; -- påfyllningspip..nn.1
  påfågel_1_N = mkN "påfågel" ; -- påfågel..nn.1
  påfågelsfjäder_1_N = mkN "påfågelsfjäder" ; -- påfågelsfjäder..nn.1
  påfågelsöga_1_N = mkN "påfågelsöga" "påfågelsögat" "påfågelsögon" "påfågelsögonen" ; -- påfågelsöga..nn.1
  påfågelöga_1_N = mkN "påfågelöga" "påfågelögat" "påfågelögon" "påfågelögonen" ; -- påfågelöga..nn.1
  påfågleri_1_N = mkN "påfågleri" "påfågleriet" "påfåglerier" "påfåglerierna" ; -- påfågleri..nn.1
  påföljande_1_A = mkA "påföljande" ; -- påföljande..av.1
  påföljd_1_N = mkN "påföljd" "påföljder" ; -- påföljd..nn.1
  påföra_1_V = mkV "påföra" "påförde" "påfört" ; -- påföra..vb.1
  påförande_1_N = mkN "påförande" ; -- påförande..nn.1
  påg_1_N = mkN "påg" ; -- påg..nn.1
  pågå_1_V = mkV "pågå" "pågick" "pågått" ; -- pågå..vb.1
  pågående_1_A = mkA "pågående" ; -- pågående..av.1
  pågående_1_N = mkN "pågående" ; -- pågående..nn.1
  påhakning_1_N = mkN "påhakning" ; -- påhakning..nn.1
  påhejad_1_A = mkA "påhejad" ; -- påhejad..av.1
  påhejare_1_N = mkN "påhejare" utrum  ; -- påhejare..nn.1
  påhet_1_N = mkN "påhet" ; -- påhet..nn.1
  påhitt_1_N = mkN "påhitt" neutrum  ; -- påhitt..nn.1
  påhittad_1_A = mkA "påhittad" ; -- påhittad..av.1
  påhittig_1_A = mkA "påhittig" ; -- påhittig..av.1
  påhittighet_1_N = mkN "påhittighet" "påhittigheter" ; -- påhittighet..nn.1
  påhopp_1_N = mkN "påhopp" neutrum  ; -- påhopp..nn.1
  påhoppad_1_A = mkA "påhoppad" ; -- påhoppad..av.1
  påhugg_1_N = mkN "påhugg" neutrum  ; -- påhugg..nn.1
  påhälsning_1_N = mkN "påhälsning" ; -- påhälsning..nn.1
  påhäng_1_N = mkN "påhäng" neutrum  ; -- påhäng..nn.1
  påhängsvagn_1_N = mkN "påhängsvagn" ; -- påhängsvagn..nn.1
  påk_1_N = mkN "påk" ; -- påk..nn.1
  påkalla_1_V = mkV "påkallar" ; -- påkalla..vb.1
  påkallande_1_N = mkN "påkallande" ; -- påkallande..nn.1
  påklistring_1_N = mkN "påklistring" ; -- påklistring..nn.1
  påklädande_1_N = mkN "påklädande" ; -- påklädande..nn.1
  påklädare_1_N = mkN "påklädare" utrum  ; -- påklädare..nn.1
  påklädd_1_A = mkA "påklädd" ; -- påklädd..av.1
  påkläddhet_1_N = mkN "påkläddhet" ; -- påkläddhet..nn.1
  påklädning_1_N = mkN "påklädning" ; -- påklädning..nn.1
  påklädningsrum_1_N = mkN "påklädningsrum" "påklädningsrummet" "påklädningsrum" "påklädningsrummen" ; -- påklädningsrum..nn.1
  påknäppning_1_N = mkN "påknäppning" ; -- påknäppning..nn.1
  påkommen_1_A = mkA "påkommen" "påkommet" "påkomna" "påkomna" "påkomnare" "påkomnast" "påkomnaste" ; -- påkommen..av.1
  påkoppling_1_N = mkN "påkoppling" ; -- påkoppling..nn.1
  påkostad_1_A = mkA "påkostad" ; -- påkostad..av.1
  påkostande_1_A = mkA "påkostande" ; -- påkostande..av.1
  påkänning_1_N = mkN "påkänning" ; -- påkänning..nn.1
  påkörning_1_N = mkN "påkörning" ; -- påkörning..nn.1
  påla_1_V = mkV "pålar" ; -- påla..vb.1
  pålaga_1_N = mkN "pålaga" ; -- pålaga..nn.1
  pålande_1_N = mkN "pålande" ; -- pålande..nn.1
  pålandsvind_1_N = mkN "pålandsvind" ; -- pålandsvind..nn.1
  pålassning_1_N = mkN "pålassning" ; -- pålassning..nn.1
  pålastning_1_N = mkN "pålastning" ; -- pålastning..nn.1
  pålbrygga_1_N = mkN "pålbrygga" ; -- pålbrygga..nn.1
  påle_1_N = mkN "påle" utrum  ; -- påle..nn.1
  pålimning_1_N = mkN "pålimning" ; -- pålimning..nn.1
  pålitlig_1_A = mkA "pålitlig" ; -- pålitlig..av.1
  pålitlighet_1_N = mkN "pålitlighet" ; -- pålitlighet..nn.1
  pålkran_1_N = mkN "pålkran" ; -- pålkran..nn.1
  pålle_1_N = mkN "pålle" utrum  ; -- pålle..nn.1
  pålmast_1_N = mkN "pålmast" "pålmaster" ; -- pålmast..nn.1
  pålning_1_N = mkN "pålning" ; -- pålning..nn.1
  pålningsarbete_1_N = mkN "pålningsarbete" ; -- pålningsarbete..nn.1
  pålrot_1_N = mkN "pålrot" "pålrötter" ; -- pålrot..nn.1
  pålstek_1_N = mkN "pålstek" neutrum  ; -- pålstek..nn.1
  pålverk_1_N = mkN "pålverk" neutrum  ; -- pålverk..nn.1
  pålägg_1_N = mkN "pålägg" neutrum  ; -- pålägg..nn.1
  pålägga_1_V = mkV "pålägga" "påla" "pålagt" ; -- pålägga..vb.1
  påläggande_1_N = mkN "påläggande" ; -- påläggande..nn.1
  påläggning_1_N = mkN "påläggning" ; -- påläggning..nn.1
  påläggskalv_1_N = mkN "påläggskalv" ; -- påläggskalv..nn.1
  påläst_1_A = mkA "påläst" "påläst" ; -- påläst..av.1
  pålöda_1_V = mkV "pålöda" "pålödde" "pålött" ; -- pålöda..vb.1
  pålödande_1_N = mkN "pålödande" ; -- pålödande..nn.1
  påminna_1_V = mkV "påminna" "påminde" "påmint" ; -- påminna..vb.1
  påminnande_1_N = mkN "påminnande" ; -- påminnande..nn.1
  påminnelse_1_N = mkN "påminnelse" "påminnelser" ; -- påminnelse..nn.1
  påmålning_1_N = mkN "påmålning" ; -- påmålning..nn.1
  påmönstring_1_N = mkN "påmönstring" ; -- påmönstring..nn.1
  pånyttföda_1_V = mkV "pånyttföda" "pånyttfödde" "pånyttfött" ; -- pånyttföda..vb.1
  pånyttfödande_1_N = mkN "pånyttfödande" ; -- pånyttfödande..nn.1
  pånyttfödd_1_A = mkA "pånyttfödd" ; -- pånyttfödd..av.1
  pånyttfödelse_1_N = mkN "pånyttfödelse" "pånyttfödelser" ; -- pånyttfödelse..nn.1
  påpassad_1_A = mkA "påpassad" ; -- påpassad..av.1
  påpasslig_1_A = mkA "påpasslig" ; -- påpasslig..av.1
  påpasslighet_1_N = mkN "påpasslighet" ; -- påpasslighet..nn.1
  påpeka_1_V = mkV "påpekar" ; -- påpeka..vb.1
  påpekande_1_N = mkN "påpekande" ; -- påpekande..nn.1
  påpälsad_1_A = mkA "påpälsad" ; -- påpälsad..av.1
  påpälsning_1_N = mkN "påpälsning" ; -- påpälsning..nn.1
  påringning_1_N = mkN "påringning" ; -- påringning..nn.1
  pårop_1_N = mkN "pårop" neutrum  ; -- pårop..nn.1
  påropa_1_V = mkV "påropar" ; -- påropa..vb.1
  påropande_1_N = mkN "påropande" ; -- påropande..nn.1
  påropning_1_N = mkN "påropning" ; -- påropning..nn.1
  påräkna_1_V = mkV "påräknar" ; -- påräkna..vb.1
  påräknande_1_N = mkN "påräknande" ; -- påräknande..nn.1
  påsadling_1_N = mkN "påsadling" ; -- påsadling..nn.1
  påse_1_N = mkN "påse" utrum  ; -- påse..nn.1
  påseende_1_N = mkN "påseende" ; -- påseende..nn.1
  påsegling_1_N = mkN "påsegling" ; -- påsegling..nn.1
  påselad_1_A = mkA "påselad" ; -- påselad..av.1
  påselning_1_N = mkN "påselning" ; -- påselning..nn.1
  påsformig_1_A = mkA "påsformig" ; -- påsformig..av.1
  påsig_1_A = mkA "påsig" ; -- påsig..av.1
  påsk_1_N = mkN "påsk" ; -- påsk..nn.1
  påskafton_1_N = mkN "påskafton" "påskaftonen" "påskaftnar" "påskaftnarna" ; -- påskafton..nn.1
  påskalamm_1_N = mkN "påskalamm" neutrum  ; -- påskalamm..nn.1
  påskdag_1_N = mkN "påskdag" ; -- påskdag..nn.1
  påskeld_1_N = mkN "påskeld" ; -- påskeld..nn.1
  påskfirande_1_A = mkA "påskfirande" ; -- påskfirande..av.1
  påskfirande_1_N = mkN "påskfirande" ; -- påskfirande..nn.1
  påskhare_1_N = mkN "påskhare" "påskharar" ; -- påskhare..nn.1
  påskhelg_1_N = mkN "påskhelg" "påskhelger" ; -- påskhelg..nn.1
  påskina_1_V = mkV "påskina" "påsken" "påskinit" ; -- påskina..vb.1
  påskinande_1_N = mkN "påskinande" ; -- påskinande..nn.1
  påskinspirerad_1_A = mkA "påskinspirerad" ; -- påskinspirerad..av.1
  påskkäring_1_N = mkN "påskkäring" ; -- påskkäring..nn.1
  påskkärring_1_N = mkN "påskkärring" ; -- påskkärring..nn.1
  påskledig_1_A = mkA "påskledig" ; -- påskledig..av.1
  påskledighet_1_N = mkN "påskledighet" ; -- påskledighet..nn.1
  påsklilja_1_N = mkN "påsklilja" ; -- påsklilja..nn.1
  påsklov_1_N = mkN "påsklov" neutrum  ; -- påsklov..nn.1
  påskpyssel_1_N = mkN "påskpyssel" neutrum  ; -- påskpyssel..nn.1
  påskrift_1_N = mkN "påskrift" "påskrifter" ; -- påskrift..nn.1
  påskris_1_N = mkN "påskris" neutrum  ; -- påskris..nn.1
  påsksmäll_1_N = mkN "påsksmäll" ; -- påsksmäll..nn.1
  påsktrafik_1_N = mkN "påsktrafik" ; -- påsktrafik..nn.1
  påskvecka_1_N = mkN "påskvecka" ; -- påskvecka..nn.1
  påskynda_1_V = mkV "påskyndar" ; -- påskynda..vb.1
  påskyndande_1_N = mkN "påskyndande" ; -- påskyndande..nn.1
  påskyndning_1_N = mkN "påskyndning" ; -- påskyndning..nn.1
  påskägg_1_N = mkN "påskägg" neutrum  ; -- påskägg..nn.1
  påsköl_1_N = mkN "påsköl" neutrum  ; -- påsköl..nn.1
  påslag_1_N = mkN "påslag" neutrum  ; -- påslag..nn.1
  påslagning_1_N = mkN "påslagning" ; -- påslagning..nn.1
  påslakan_1_N = mkN "påslakan" neutrum  ; -- påslakan..nn.1
  påsläppning_1_N = mkN "påsläppning" ; -- påsläppning..nn.1
  påsmetning_1_N = mkN "påsmetning" ; -- påsmetning..nn.1
  påspikning_1_N = mkN "påspikning" ; -- påspikning..nn.1
  påspä_1_V = mkV "påspä" "påspädde" "påspätt" ; -- påspä..vb.1
  påspädande_1_N = mkN "påspädande" ; -- påspädande..nn.1
  påspädning_1_N = mkN "påspädning" ; -- påspädning..nn.1
  påspäende_1_N = mkN "påspäende" ; -- påspäende..nn.1
  påspänning_1_N = mkN "påspänning" ; -- påspänning..nn.1
  påssjuka_1_N = mkN "påssjuka" ; -- påssjuka..nn.1
  påstigande_1_N = mkN "påstigande" ; -- påstigande..nn.1
  påstigning_1_N = mkN "påstigning" ; -- påstigning..nn.1
  påstigningsplats_1_N = mkN "påstigningsplats" "påstigningsplatser" ; -- påstigningsplats..nn.1
  påstridig_1_A = mkA "påstridig" ; -- påstridig..av.1
  påstridighet_1_N = mkN "påstridighet" ; -- påstridighet..nn.1
  påstruken_1_A = mkA "påstruken" ; -- påstruken..av.1
  påstrykning_1_N = mkN "påstrykning" ; -- påstrykning..nn.1
  påstå_1_V = mkV "påstå" "påstod" "påstådd" ; -- påstå..vb.1
  påståelig_1_A = mkA "påståelig" ; -- påståelig..av.1
  påståelighet_1_N = mkN "påståelighet" ; -- påståelighet..nn.1
  påstående_1_N = mkN "påstående" ; -- påstående..nn.1
  påståendesats_1_N = mkN "påståendesats" "påståendesatser" ; -- påståendesats..nn.1
  påstötning_1_N = mkN "påstötning" ; -- påstötning..nn.1
  påsyn_1_N = mkN "påsyn" ; -- påsyn..nn.1
  påsättning_1_N = mkN "påsättning" ; -- påsättning..nn.1
  påt_1_N = mkN "påt" neutrum  ; -- påt..nn.1
  påta_1_V = mkV "påtaga" "påtog" "påtagit" ; -- påta..vb.1
  påta_2_V = mkV "påtar" ; -- påta..vb.2
  påtagande_1_N = mkN "påtagande" ; -- påtagande..nn.1
  påtagbar_1_A = mkA "påtagbar" ; -- påtagbar..av.1
  påtagbarhet_1_N = mkN "påtagbarhet" ; -- påtagbarhet..nn.1
  påtaglig_1_A = mkA "påtaglig" ; -- påtaglig..av.1
  påtaglighet_1_N = mkN "påtaglighet" ; -- påtaglighet..nn.1
  påtagning_1_N = mkN "påtagning" ; -- påtagning..nn.1
  påtala_1_V = mkV "påtalar" ; -- påtala..vb.1
  påtalande_1_N = mkN "påtalande" ; -- påtalande..nn.1
  påtande_1_N = mkN "påtande" ; -- påtande..nn.1
  påtryckare_1_N = mkN "påtryckare" utrum  ; -- påtryckare..nn.1
  påtryckning_1_N = mkN "påtryckning" ; -- påtryckning..nn.1
  påtryckningsmedel_1_N = mkN "påtryckningsmedel" neutrum  ; -- påtryckningsmedel..nn.1
  påträffa_1_V = mkV "påträffar" ; -- påträffa..vb.1
  påträffande_1_N = mkN "påträffande" ; -- påträffande..nn.1
  påträngande_1_A = mkA "påträngande" ; -- påträngande..av.1
  påtvinga_1_V = mkV "påtvingar" ; -- påtvinga..vb.1
  påtvingande_1_N = mkN "påtvingande" ; -- påtvingande..nn.1
  påtänd_1_A = mkA "påtänd" ; -- påtänd..av.1
  påtändhet_1_N = mkN "påtändhet" ; -- påtändhet..nn.1
  påtändning_1_N = mkN "påtändning" ; -- påtändning..nn.1
  påtänkt_1_A = mkA "påtänkt" "påtänkt" ; -- påtänkt..av.1
  påtår_1_N = mkN "påtår" ; -- påtår..nn.1
  påve_1_N = mkN "påve" utrum  ; -- påve..nn.1
  påvedöme_1_N = mkN "påvedöme" ; -- påvedöme..nn.1
  påvehov_1_N = mkN "påvehov" neutrum  ; -- påvehov..nn.1
  påvekyrka_1_N = mkN "påvekyrka" ; -- påvekyrka..nn.1
  påvemössa_1_N = mkN "påvemössa" ; -- påvemössa..nn.1
  påver_1_A = mkA "påver" ; -- påver..av.1
  påverka_1_V = mkV "påverkar" ; -- påverka..vb.1
  påverkad_1_A = mkA "påverkad" ; -- påverkad..av.1
  påverkande_1_N = mkN "påverkande" ; -- påverkande..nn.1
  påverkbar_1_A = mkA "påverkbar" ; -- påverkbar..av.1
  påverkbarhet_1_N = mkN "påverkbarhet" ; -- påverkbarhet..nn.1
  påverkning_1_N = mkN "påverkning" ; -- påverkning..nn.1
  påvestol_1_N = mkN "påvestol" ; -- påvestol..nn.1
  påvetron_1_N = mkN "påvetron" ; -- påvetron..nn.1
  påvevärdighet_1_N = mkN "påvevärdighet" "påvevärdigheter" ; -- påvevärdighet..nn.1
  påvila_1_V = mkV "påvilar" ; -- påvila..vb.1
  påvilande_1_N = mkN "påvilande" ; -- påvilande..nn.1
  påvisa_1_V = mkV "påvisar" ; -- påvisa..vb.1
  påvisande_1_N = mkN "påvisande" ; -- påvisande..nn.1
  påvisbar_1_A = mkA "påvisbar" ; -- påvisbar..av.1
  påvisbarhet_1_N = mkN "påvisbarhet" ; -- påvisbarhet..nn.1
  påvisk_1_A = mkA "påvisk" ; -- påvisk..av.1
  påvislig_1_A = mkA "påvislig" ; -- påvislig..av.1
  påvislighet_1_N = mkN "påvislighet" ; -- påvislighet..nn.1
  påvisning_1_N = mkN "påvisning" ; -- påvisning..nn.1
  påvlig_1_A = mkA "påvlig" ; -- påvlig..av.1
  påvlighet_1_N = mkN "påvlighet" ; -- påvlighet..nn.1
  påväxt_1_N = mkN "påväxt" ; -- påväxt..nn.1
  påväxtproblem_1_N = mkN "påväxtproblem" neutrum  ; -- påväxtproblem..nn.1
  påyrka_1_V = mkV "påyrkar" ; -- påyrka..vb.1
  påyrkande_1_N = mkN "påyrkande" ; -- påyrkande..nn.1
  påökning_1_N = mkN "påökning" ; -- påökning..nn.1
  påökt_1_N = mkN "påökt" ; -- påökt..nn.1
  påösning_1_N = mkN "påösning" ; -- påösning..nn.1
  pöbel_1_N = mkN "pöbel" ; -- pöbel..nn.1
  pöbelaktig_1_A = mkA "pöbelaktig" ; -- pöbelaktig..av.1
  pöbelaktighet_1_N = mkN "pöbelaktighet" "pöbelaktigheter" ; -- pöbelaktighet..nn.1
  pöbelhop_1_N = mkN "pöbelhop" ; -- pöbelhop..nn.1
  pöbelmentalitet_1_N = mkN "pöbelmentalitet" "pöbelmentaliteter" ; -- pöbelmentalitet..nn.1
  pöbelvälde_1_N = mkN "pöbelvälde" ; -- pöbelvälde..nn.1
  pöl_1_N = mkN "pöl" ; -- pöl..nn.1
  pöla_1_V = mkV "pölar" ; -- pöla..vb.1
  pölande_1_N = mkN "pölande" ; -- pölande..nn.1
  pölsa_1_N = mkN "pölsa" ; -- pölsa..nn.1
  pölsig_1_A = mkA "pölsig" ; -- pölsig..av.1
  pölsighet_1_N = mkN "pölsighet" ; -- pölsighet..nn.1
  pömsig_1_A = mkA "pömsig" ; -- pömsig..av.1
  pörte_1_N = mkN "pörte" ; -- pörte..nn.1
  pös_1_N = mkN "pös" neutrum  ; -- pös..nn.1
  pösa_1_V = mkV "pöser" ; -- pösa..vb.1
  pösande_1_N = mkN "pösande" ; -- pösande..nn.1
  pösig_1_A = mkA "pösig" ; -- pösig..av.1
  pösighet_1_N = mkN "pösighet" ; -- pösighet..nn.1
  pösmunk_1_N = mkN "pösmunk" ; -- pösmunk..nn.1
  pösning_1_N = mkN "pösning" ; -- pösning..nn.1
  qatarier_1_N = mkN "qatarier" "qatariern" "qatarier" "qatarierna" ; -- qatarier..nn.1
  qatarisk_1_A = mkA "qatarisk" ; -- qatarisk..av.1
  qatariska_1_N = mkN "qatariska" ; -- qatariska..nn.1
  qr_kod_1_N = mkN "qr-kod" "qr-koder" ; -- qr-kod..nn.1
  quenell_1_N = mkN "quenell" "queneller" ; -- quenell..nn.1
  quilta_1_V = mkV "quiltar" ; -- quilta..vb.1
  quiltande_1_N = mkN "quiltande" ; -- quiltande..nn.1
  quisling_1_N = mkN "quisling" ; -- quisling..nn.1
  quiss_1_N = mkN "quiss" ; -- quiss..nn.1
  quissa_1_V = mkV "quissar" ; -- quissa..vb.1
  quissande_1_N = mkN "quissande" ; -- quissande..nn.1
  quiz_1_N = mkN "quiz" ; -- quiz..nn.1
  quiza_1_V = mkV "quizar" ; -- quiza..vb.1
  quizande_1_N = mkN "quizande" ; -- quizande..nn.1
  quizz_1_N = mkN "quizz" ; -- quizz..nn.1
  quizza_1_V = mkV "quizzar" ; -- quizza..vb.1
  quizzande_1_N = mkN "quizzande" ; -- quizzande..nn.1
  r_1_N = mkN "r" neutrum  ; -- r..nn.1
  rabalder_1_N = mkN "rabalder" neutrum  ; -- rabalder..nn.1
  rabarber_1_N = mkN "rabarber" ; -- rabarber..nn.1
  rabarberblad_1_N = mkN "rabarberblad" neutrum  ; -- rabarberblad..nn.1
  rabarberkaka_1_N = mkN "rabarberkaka" ; -- rabarberkaka..nn.1
  rabarberpaj_1_N = mkN "rabarberpaj" "rabarberpajer" ; -- rabarberpaj..nn.1
  rabatt_1_N = mkN "rabatt" "rabatter" ; -- rabatt..nn.1
  rabattera_1_V = mkV "rabatterar" ; -- rabattera..vb.1
  rabatterande_1_N = mkN "rabatterande" ; -- rabatterande..nn.1
  rabatterbar_1_A = mkA "rabatterbar" ; -- rabatterbar..av.1
  rabatterbarhet_1_N = mkN "rabatterbarhet" ; -- rabatterbarhet..nn.1
  rabattering_1_N = mkN "rabattering" ; -- rabattering..nn.1
  rabattfrimärke_1_N = mkN "rabattfrimärke" ; -- rabattfrimärke..nn.1
  rabatthäfte_1_N = mkN "rabatthäfte" ; -- rabatthäfte..nn.1
  rabattjägare_1_N = mkN "rabattjägare" utrum  ; -- rabattjägare..nn.1
  rabattkort_1_N = mkN "rabattkort" neutrum  ; -- rabattkort..nn.1
  rabattkupong_1_N = mkN "rabattkupong" "rabattkuponger" ; -- rabattkupong..nn.1
  rabbel_1_N = mkN "rabbel" neutrum  ; -- rabbel..nn.1
  rabbi_1_N = mkN "rabbi" "rabbin" "rabbier" "rabbierna" ; -- rabbi..nn.1
  rabbin_1_N = mkN "rabbin" "rabbiner" ; -- rabbin..nn.1
  rabbinism_1_N = mkN "rabbinism" ; -- rabbinism..nn.1
  rabbinsk_1_A = mkA "rabbinsk" ; -- rabbinsk..av.1
  rabbis_1_N = mkN "rabbis" ; -- rabbis..nn.1
  rabbla_1_V = mkV "rabblar" ; -- rabbla..vb.1
  rabblande_1_N = mkN "rabblande" ; -- rabblande..nn.1
  rabiat_1_A = mkA "rabiat" "rabiat" ; -- rabiat..av.1
  rabies_1_N = mkN "rabies" ; -- rabies..nn.1
  rabiesskräck_1_N = mkN "rabiesskräck" ; -- rabiesskräck..nn.1
  rabiesutbrott_1_N = mkN "rabiesutbrott" neutrum  ; -- rabiesutbrott..nn.1
  rabulism_1_N = mkN "rabulism" "rabulismer" ; -- rabulism..nn.1
  rabulist_1_N = mkN "rabulist" "rabulister" ; -- rabulist..nn.1
  rabulistisk_1_A = mkA "rabulistisk" ; -- rabulistisk..av.1
  racer_1_N = mkN "racer" ; -- racer..nn.1
  racerbil_1_N = mkN "racerbil" ; -- racerbil..nn.1
  racerbåt_1_N = mkN "racerbåt" ; -- racerbåt..nn.1
  racercykel_1_N = mkN "racercykel" ; -- racercykel..nn.1
  racerförare_1_N = mkN "racerförare" utrum  ; -- racerförare..nn.1
  racing_1_N = mkN "racing" ; -- racing..nn.1
  racingbåt_1_N = mkN "racingbåt" ; -- racingbåt..nn.1
  racingmässig_1_A = mkA "racingmässig" ; -- racingmässig..av.1
  rack_1_N = mkN "rack" ; -- rack..nn.1
  rack_2_N = mkN "rack" neutrum  ; -- rack..nn.2
  rack_3_N = mkN "rack" ; -- rack..nn.3
  racka_1_N = mkN "racka" ; -- racka..nn.1
  racka_1_V = mkV "rackar" ; -- racka..vb.1
  rackabajsare_1_N = mkN "rackabajsare" utrum  ; -- rackabajsare..nn.1
  rackande_1_N = mkN "rackande" ; -- rackande..nn.1
  rackaraktig_1_A = mkA "rackaraktig" ; -- rackaraktig..av.1
  rackaraktighet_1_N = mkN "rackaraktighet" ; -- rackaraktighet..nn.1
  rackare_1_N = mkN "rackare" utrum  ; -- rackare..nn.1
  rackarns_1_A = mkA "rackarns" ; -- rackarns..av.1
  rackartyg_1_N = mkN "rackartyg" neutrum  ; -- rackartyg..nn.1
  rackarunge_1_N = mkN "rackarunge" utrum  ; -- rackarunge..nn.1
  rackelhane_1_N = mkN "rackelhane" utrum  ; -- rackelhane..nn.1
  racket_1_N = mkN "racket" ; -- racket..nn.1
  racklig_1_A = mkA "racklig" ; -- racklig..av.1
  racklighet_1_N = mkN "racklighet" ; -- racklighet..nn.1
  rad_1_N = mkN "rad" "rader" ; -- rad..nn.1
  rad_2_N = mkN "rad" "raden" "rad" "raden" ; -- rad..nn.2
  radannons_1_N = mkN "radannons" "radannonser" ; -- radannons..nn.1
  radarantenn_1_N = mkN "radarantenn" "radarantenner" ; -- radarantenn..nn.1
  radarfyr_1_N = mkN "radarfyr" ; -- radarfyr..nn.1
  radarkommunikation_1_N = mkN "radarkommunikation" ; -- radarkommunikation..nn.1
  radarkontroll_1_N = mkN "radarkontroll" "radarkontroller" ; -- radarkontroll..nn.1
  radarpar_1_N = mkN "radarpar" neutrum  ; -- radarpar..nn.1
  radarreflektor_1_N = mkN "radarreflektor" "radarreflektorer" ; -- radarreflektor..nn.1
  radarskärm_1_N = mkN "radarskärm" ; -- radarskärm..nn.1
  radarvåg_1_N = mkN "radarvåg" "radarvågor" ; -- radarvåg..nn.1
  radavstånd_1_N = mkN "radavstånd" neutrum  ; -- radavstånd..nn.1
  radband_1_N = mkN "radband" neutrum  ; -- radband..nn.1
  radbyte_1_N = mkN "radbyte" ; -- radbyte..nn.1
  radda_1_N = mkN "radda" ; -- radda..nn.1
  radera_1_V = mkV "raderar" ; -- radera..vb.1
  raderande_1_N = mkN "raderande" ; -- raderande..nn.1
  raderbar_1_A = mkA "raderbar" ; -- raderbar..av.1
  raderbarhet_1_N = mkN "raderbarhet" ; -- raderbarhet..nn.1
  radergummi_1_N = mkN "radergummi" "radergummit" "radergummin" "radergummina" ; -- radergummi..nn.1
  radering_1_N = mkN "radering" ; -- radering..nn.1
  raderkniv_1_N = mkN "raderkniv" ; -- raderkniv..nn.1
  radernål_1_N = mkN "radernål" ; -- radernål..nn.1
  raderstift_1_N = mkN "raderstift" neutrum  ; -- raderstift..nn.1
  radhus_1_N = mkN "radhus" neutrum  ; -- radhus..nn.1
  radhusfamilj_1_N = mkN "radhusfamilj" "radhusfamiljer" ; -- radhusfamilj..nn.1
  radhusområde_1_N = mkN "radhusområde" ; -- radhusområde..nn.1
  radiak_1_N = mkN "radiak" ; -- radiak..nn.1
  radiakbehandling_1_N = mkN "radiakbehandling" ; -- radiakbehandling..nn.1
  radial_1_A = mkA "radial" ; -- radial..av.1
  radialdäck_1_N = mkN "radialdäck" neutrum  ; -- radialdäck..nn.1
  radialhastighet_1_N = mkN "radialhastighet" "radialhastigheter" ; -- radialhastighet..nn.1
  radiallager_1_N = mkN "radiallager" neutrum  ; -- radiallager..nn.1
  radian_1_N = mkN "radian" "radianer" ; -- radian..nn.1
  radiator_1_N = mkN "radiator" "radiatorer" ; -- radiator..nn.1
  radie_1_N = mkN "radie" "radier" ; -- radie..nn.1
  radiell_1_A = mkA "radiell" ; -- radiell..av.1
  radiera_1_V = mkV "radierar" ; -- radiera..vb.1
  radierande_1_N = mkN "radierande" ; -- radierande..nn.1
  radierbar_1_A = mkA "radierbar" ; -- radierbar..av.1
  radierbarhet_1_N = mkN "radierbarhet" ; -- radierbarhet..nn.1
  radiering_1_N = mkN "radiering" ; -- radiering..nn.1
  radikal_1_A = mkA "radikal" ; -- radikal..av.1
  radikal_1_N = mkN "radikal" "radikaler" ; -- radikal..nn.1
  radikalisera_1_V = mkV "radikaliserar" ; -- radikalisera..vb.1
  radikaliserande_1_N = mkN "radikaliserande" ; -- radikaliserande..nn.1
  radikaliserbar_1_A = mkA "radikaliserbar" ; -- radikaliserbar..av.1
  radikaliserbarhet_1_N = mkN "radikaliserbarhet" ; -- radikaliserbarhet..nn.1
  radikalisering_1_N = mkN "radikalisering" ; -- radikalisering..nn.1
  radikalism_1_N = mkN "radikalism" "radikalismer" ; -- radikalism..nn.1
  radikaloperation_1_N = mkN "radikaloperation" ; -- radikaloperation..nn.1
  radio_1_N = mkN "radio" "radior" ; -- radio..nn.1
  radioaktiv_1_A = mkA "radioaktiv" ; -- radioaktiv..av.1
  radioaktivitet_1_N = mkN "radioaktivitet" "radioaktiviteter" ; -- radioaktivitet..nn.1
  radioamatör_1_N = mkN "radioamatör" "radioamatörer" ; -- radioamatör..nn.1
  radioandakt_1_N = mkN "radioandakt" "radioandakter" ; -- radioandakt..nn.1
  radioantenn_1_N = mkN "radioantenn" "radioantenner" ; -- radioantenn..nn.1
  radioapparat_1_N = mkN "radioapparat" "radioapparater" ; -- radioapparat..nn.1
  radioastronomi_1_N = mkN "radioastronomi" ; -- radioastronomi..nn.1
  radioastronomisk_1_A = mkA "radioastronomisk" ; -- radioastronomisk..av.1
  radioavlyssning_1_N = mkN "radioavlyssning" ; -- radioavlyssning..nn.1
  radiobil_1_N = mkN "radiobil" ; -- radiobil..nn.1
  radiobiologi_1_N = mkN "radiobiologi" ; -- radiobiologi..nn.1
  radiobrus_1_N = mkN "radiobrus" neutrum  ; -- radiobrus..nn.1
  radiodramatik_1_N = mkN "radiodramatik" ; -- radiodramatik..nn.1
  radiofrekvent_1_A = mkA "radiofrekvent" "radiofrekvent" ; -- radiofrekvent..av.1
  radiofyr_1_N = mkN "radiofyr" ; -- radiofyr..nn.1
  radiofysik_1_N = mkN "radiofysik" ; -- radiofysik..nn.1
  radiogram_1_N = mkN "radiogram" "radiogrammet" "radiogram" "radiogrammen" ; -- radiogram..nn.1
  radiogrammofon_1_N = mkN "radiogrammofon" "radiogrammofoner" ; -- radiogrammofon..nn.1
  radiohus_1_N = mkN "radiohus" neutrum  ; -- radiohus..nn.1
  radioisotop_1_N = mkN "radioisotop" "radioisotoper" ; -- radioisotop..nn.1
  radiokanal_1_N = mkN "radiokanal" "radiokanaler" ; -- radiokanal..nn.1
  radiokol_1_N = mkN "radiokol" neutrum  ; -- radiokol..nn.1
  radiokommunikation_1_N = mkN "radiokommunikation" ; -- radiokommunikation..nn.1
  radiokälla_1_N = mkN "radiokälla" ; -- radiokälla..nn.1
  radiolag_1_N = mkN "radiolag" ; -- radiolag..nn.1
  radiolarie_1_N = mkN "radiolarie" "radiolarier" ; -- radiolarie..nn.1
  radiolog_1_N = mkN "radiolog" "radiologer" ; -- radiolog..nn.1
  radiologi_1_N = mkN "radiologi" ; -- radiologi..nn.1
  radiologisk_1_A = mkA "radiologisk" ; -- radiologisk..av.1
  radiolänk_1_N = mkN "radiolänk" ; -- radiolänk..nn.1
  radioman_1_N = mkN "radioman" "radiomannen" "radiomän" "radiomännen" ; -- radioman..nn.1
  radiometer_1_N = mkN "radiometer" ; -- radiometer..nn.1
  radiomottagare_1_N = mkN "radiomottagare" utrum  ; -- radiomottagare..nn.1
  radiomottagning_1_N = mkN "radiomottagning" ; -- radiomottagning..nn.1
  radiomässig_1_A = mkA "radiomässig" ; -- radiomässig..av.1
  radionavigera_1_V = mkV "radionavigerar" ; -- radionavigera..vb.1
  radionavigerande_1_N = mkN "radionavigerande" ; -- radionavigerande..nn.1
  radionavigerbar_1_A = mkA "radionavigerbar" ; -- radionavigerbar..av.1
  radionavigerbarhet_1_N = mkN "radionavigerbarhet" ; -- radionavigerbarhet..nn.1
  radionavigering_1_N = mkN "radionavigering" ; -- radionavigering..nn.1
  radionavigeringssystem_1_N = mkN "radionavigeringssystem" neutrum  ; -- radionavigeringssystem..nn.1
  radionämnd_1_N = mkN "radionämnd" ; -- radionämnd..nn.1
  radiopejling_1_N = mkN "radiopejling" ; -- radiopejling..nn.1
  radiopjäs_1_N = mkN "radiopjäs" "radiopjäser" ; -- radiopjäs..nn.1
  radioprogram_1_N = mkN "radioprogram" "radioprogrammet" "radioprogram" "radioprogrammen" ; -- radioprogram..nn.1
  radiorör_1_N = mkN "radiorör" neutrum  ; -- radiorör..nn.1
  radioröst_1_N = mkN "radioröst" "radioröster" ; -- radioröst..nn.1
  radiosignal_1_N = mkN "radiosignal" "radiosignaler" ; -- radiosignal..nn.1
  radioskugga_1_N = mkN "radioskugga" ; -- radioskugga..nn.1
  radiosond_1_N = mkN "radiosond" "radiosonder" ; -- radiosond..nn.1
  radiostation_1_N = mkN "radiostation" ; -- radiostation..nn.1
  radiostrålning_1_N = mkN "radiostrålning" ; -- radiostrålning..nn.1
  radiostyrd_1_A = mkA "radiostyrd" "radiostyrt" ; -- radiostyrd..av.1
  radiostyrning_1_N = mkN "radiostyrning" ; -- radiostyrning..nn.1
  radiostörning_1_N = mkN "radiostörning" ; -- radiostörning..nn.1
  radiosändare_1_N = mkN "radiosändare" utrum  ; -- radiosändare..nn.1
  radiosändning_1_N = mkN "radiosändning" ; -- radiosändning..nn.1
  radiot_1_N = mkN "radiot" "radioter" ; -- radiot..nn.1
  radiotagg_1_N = mkN "radiotagg" ; -- radiotagg..nn.1
  radioteknik_1_N = mkN "radioteknik" "radiotekniker" ; -- radioteknik..nn.1
  radiotelefon_1_N = mkN "radiotelefon" "radiotelefoner" ; -- radiotelefon..nn.1
  radiotelegrafi_1_N = mkN "radiotelegrafi" ; -- radiotelegrafi..nn.1
  radiotelegrafist_1_N = mkN "radiotelegrafist" "radiotelegrafister" ; -- radiotelegrafist..nn.1
  radioteleskop_1_N = mkN "radioteleskop" neutrum  ; -- radioteleskop..nn.1
  radioterapi_1_N = mkN "radioterapi" ; -- radioterapi..nn.1
  radiotrafik_1_N = mkN "radiotrafik" ; -- radiotrafik..nn.1
  radiotystnad_1_N = mkN "radiotystnad" ; -- radiotystnad..nn.1
  radiotång_1_N = mkN "radiotång" "radiotänger" ; -- radiotång..nn.1
  radioutsändning_1_N = mkN "radioutsändning" ; -- radioutsändning..nn.1
  radiovåg_1_N = mkN "radiovåg" "radiovågor" ; -- radiovåg..nn.1
  radium_1_N = mkN "radium" neutrum  ; -- radium..nn.1
  radja_1_N = mkN "radja" ; -- radja..nn.1
  radon_1_N = mkN "radon" ; -- radon..nn.1
  radondotter_1_N = mkN "radondotter" "radondottern" "radondöttrar" "radondöttrarna" ; -- radondotter..nn.1
  radonhus_1_N = mkN "radonhus" neutrum  ; -- radonhus..nn.1
  radskiftare_1_N = mkN "radskiftare" utrum  ; -- radskiftare..nn.1
  radskrivare_1_N = mkN "radskrivare" utrum  ; -- radskrivare..nn.1
  radslutssignal_1_N = mkN "radslutssignal" "radslutssignaler" ; -- radslutssignal..nn.1
  radsåning_1_N = mkN "radsåning" ; -- radsåning..nn.1
  radvis_1_Adv = mkAdv "radvis" ; -- radvis..ab.1
  radvis_1_A = mkA "radvis" ; -- radvis..av.1
  raffel_1_N = mkN "raffel" neutrum  ; -- raffel..nn.1
  raffel_2_N = mkN "raffel" ; -- raffel..nn.2
  raffig_1_A = mkA "raffig" ; -- raffig..av.1
  raffighet_1_N = mkN "raffighet" ; -- raffighet..nn.1
  raffinad_1_N = mkN "raffinad" "raffinader" ; -- raffinad..nn.1
  raffinaderi_1_N = mkN "raffinaderi" "raffinaderiet" "raffinaderier" "raffinaderierna" ; -- raffinaderi..nn.1
  raffinemang_1_N = mkN "raffinemang" neutrum  ; -- raffinemang..nn.1
  raffinera_1_V = mkV "raffinerar" ; -- raffinera..vb.1
  raffinerad_1_A = mkA "raffinerad" ; -- raffinerad..av.1
  raffinerande_1_N = mkN "raffinerande" ; -- raffinerande..nn.1
  raffinerbar_1_A = mkA "raffinerbar" ; -- raffinerbar..av.1
  raffinerbarhet_1_N = mkN "raffinerbarhet" ; -- raffinerbarhet..nn.1
  raffinering_1_N = mkN "raffinering" ; -- raffinering..nn.1
  rafflande_1_A = mkA "rafflande" ; -- rafflande..av.1
  rafflig_1_A = mkA "rafflig" ; -- rafflig..av.1
  rafflighet_1_N = mkN "rafflighet" ; -- rafflighet..nn.1
  rafistulera_1_V = mkV "rafistulerar" ; -- rafistulera..vb.1
  rafistulerande_1_N = mkN "rafistulerande" ; -- rafistulerande..nn.1
  rafistulering_1_N = mkN "rafistulering" ; -- rafistulering..nn.1
  rafräschissör_1_N = mkN "rafräschissör" "rafräschissörer" ; -- rafräschissör..nn.1
  rafsa_1_V = mkV "rafsar" ; -- rafsa..vb.1
  raga_1_N = mkN "raga" ; -- raga..nn.1
  ragata_1_N = mkN "ragata" ; -- ragata..nn.1
  ragg_1_N = mkN "ragg" ; -- ragg..nn.1
  ragg_2_N = mkN "ragg" neutrum  ; -- ragg..nn.2
  ragga_1_V = mkV "raggar" ; -- ragga..vb.1
  raggande_1_N = mkN "raggande" ; -- raggande..nn.1
  raggarbil_1_N = mkN "raggarbil" ; -- raggarbil..nn.1
  raggarbrud_1_N = mkN "raggarbrud" ; -- raggarbrud..nn.1
  raggare_1_N = mkN "raggare" utrum  ; -- raggare..nn.1
  raggaråk_1_N = mkN "raggaråk" ; -- raggaråk..nn.1
  raggig_1_A = mkA "raggig" ; -- raggig..av.1
  raggighet_1_N = mkN "raggighet" ; -- raggighet..nn.1
  raggla_1_V = mkV "ragglar" ; -- raggla..vb.1
  ragglande_1_N = mkN "ragglande" ; -- ragglande..nn.1
  raggmunk_1_N = mkN "raggmunk" ; -- raggmunk..nn.1
  raggmunkmix_1_N = mkN "raggmunkmix" "raggmunkmixer" ; -- raggmunkmix..nn.1
  raggsocka_1_N = mkN "raggsocka" ; -- raggsocka..nn.1
  ragla_1_V = mkV "raglar" ; -- ragla..vb.1
  raglan_1_N = mkN "raglan" ; -- raglan..nn.1
  raglande_1_N = mkN "raglande" ; -- raglande..nn.1
  raglanärm_1_N = mkN "raglanärm" ; -- raglanärm..nn.1
  ragnarök_1_N = mkN "ragnarök" ; -- ragnarök..nn.1
  ragtime_1_N = mkN "ragtime" utrum  ; -- ragtime..nn.1
  ragu_1_N = mkN "ragu" "ragun" "raguer" "raguerna" ; -- ragu..nn.1
  raid_1_N = mkN "raid" "raider" ; -- raid..nn.1
  raja_1_N = mkN "raja" ; -- raja..nn.1
  rajd_1_N = mkN "rajd" "rajder" ; -- rajd..nn.1
  rajgräs_1_N = mkN "rajgräs" neutrum  ; -- rajgräs..nn.1
  rak_1_A = mkA "rak" ; -- rak..av.1
  raka_1_N = mkN "raka" ; -- raka..nn.1
  raka_1_V = mkV "rakar" ; -- raka..vb.1
  rakande_1_N = mkN "rakande" ; -- rakande..nn.1
  rakapparat_1_N = mkN "rakapparat" "rakapparater" ; -- rakapparat..nn.1
  rakblad_1_N = mkN "rakblad" neutrum  ; -- rakblad..nn.1
  rakborste_1_N = mkN "rakborste" utrum  ; -- rakborste..nn.1
  raket_1_N = mkN "raket" "raketer" ; -- raket..nn.1
  raketbas_1_N = mkN "raketbas" "raketbaser" ; -- raketbas..nn.1
  raketdrift_1_N = mkN "raketdrift" ; -- raketdrift..nn.1
  raketfart_1_N = mkN "raketfart" ; -- raketfart..nn.1
  raketforskning_1_N = mkN "raketforskning" ; -- raketforskning..nn.1
  raketforskningsinstitut_1_N = mkN "raketforskningsinstitut" neutrum  ; -- raketforskningsinstitut..nn.1
  raketfärd_1_N = mkN "raketfärd" "raketfärder" ; -- raketfärd..nn.1
  raketgevär_1_N = mkN "raketgevär" neutrum  ; -- raketgevär..nn.1
  raketkonstruktör_1_N = mkN "raketkonstruktör" "raketkonstruktörer" ; -- raketkonstruktör..nn.1
  raketmotor_1_N = mkN "raketmotor" "raketmotorer" ; -- raketmotor..nn.1
  raketsteg_1_N = mkN "raketsteg" neutrum  ; -- raketsteg..nn.1
  raketvapen_1_N = mkN "raketvapen" "raketvapnet" "raketvapen" "raketvapnen" ; -- raketvapen..nn.1
  rakhet_1_N = mkN "rakhet" ; -- rakhet..nn.1
  rakhyvel_1_N = mkN "rakhyvel" ; -- rakhyvel..nn.1
  rakhårig_1_A = mkA "rakhårig" ; -- rakhårig..av.1
  rakitis_1_N = mkN "rakitis" ; -- rakitis..nn.1
  rakitisk_1_A = mkA "rakitisk" ; -- rakitisk..av.1
  rakkniv_1_N = mkN "rakkniv" ; -- rakkniv..nn.1
  raklinjig_1_A = mkA "raklinjig" ; -- raklinjig..av.1
  raklinjighet_1_N = mkN "raklinjighet" ; -- raklinjighet..nn.1
  raklång_1_A = mkA "raklång" ; -- raklång..av.1
  raklödder_1_N = mkN "raklödder" neutrum  ; -- raklödder..nn.1
  rakna_1_V = mkV "raknar" ; -- rakna..vb.1
  raknande_1_N = mkN "raknande" ; -- raknande..nn.1
  rakning_1_N = mkN "rakning" ; -- rakning..nn.1
  rakryggad_1_A = mkA "rakryggad" ; -- rakryggad..av.1
  rakspegel_1_N = mkN "rakspegel" ; -- rakspegel..nn.1
  rakstammig_1_A = mkA "rakstammig" ; -- rakstammig..av.1
  rakstrigel_1_N = mkN "rakstrigel" ; -- rakstrigel..nn.1
  raksträcka_1_N = mkN "raksträcka" ; -- raksträcka..nn.1
  raktvål_1_N = mkN "raktvål" ; -- raktvål..nn.1
  rakvatten_1_N = mkN "rakvatten" "rakvattnet" "rakvatten" "rakvattnen" ; -- rakvatten..nn.1
  rakvuxen_1_A = mkA "rakvuxen" ; -- rakvuxen..av.1
  raljans_1_N = mkN "raljans" ; -- raljans..nn.1
  raljant_1_A = mkA "raljant" "raljant" ; -- raljant..av.1
  raljera_1_V = mkV "raljerar" ; -- raljera..vb.1
  raljerande_1_N = mkN "raljerande" ; -- raljerande..nn.1
  raljeri_1_N = mkN "raljeri" "raljeriet" "raljerier" "raljerierna" ; -- raljeri..nn.1
  raljering_1_N = mkN "raljering" ; -- raljering..nn.1
  rall_1_N = mkN "rall" ; -- rall..nn.1
  rallarbas_1_N = mkN "rallarbas" ; -- rallarbas..nn.1
  rallare_1_N = mkN "rallare" utrum  ; -- rallare..nn.1
  rallarros_1_N = mkN "rallarros" "rallarrosor" ; -- rallarros..nn.1
  rallarsving_1_N = mkN "rallarsving" ; -- rallarsving..nn.1
  rally_1_N = mkN "rally" "rallyt" "rallyn" "rallyna" ; -- rally..nn.1
  rallycross_1_N = mkN "rallycross" ; -- rallycross..nn.1
  ram_1_N = mkN "ram" ; -- ram..nn.1
  rama_1_V = mkV "ramar" ; -- rama..vb.1
  ramadan_1_N = mkN "ramadan" ; -- ramadan..nn.1
  ramande_1_N = mkN "ramande" ; -- ramande..nn.1
  ramaskri_1_N = mkN "ramaskri" "ramaskriet" "ramaskrin" "ramaskrina" ; -- ramaskri..nn.1
  ramavtal_1_N = mkN "ramavtal" neutrum  ; -- ramavtal..nn.1
  ramberättelse_1_N = mkN "ramberättelse" "ramberättelser" ; -- ramberättelse..nn.1
  rambeslut_1_N = mkN "rambeslut" neutrum  ; -- rambeslut..nn.1
  rambudget_1_N = mkN "rambudget" ; -- rambudget..nn.1
  ramla_1_V = mkV "ramlar" ; -- ramla..vb.1
  ramlande_1_N = mkN "ramlande" ; -- ramlande..nn.1
  ramlare_1_N = mkN "ramlare" utrum  ; -- ramlare..nn.1
  ramlösa_1_N = mkN "ramlösa" ; -- ramlösa..nn.1
  ramm_1_N = mkN "ramm" ; -- ramm..nn.1
  ramma_1_V = mkV "rammar" ; -- ramma..vb.1
  rammande_1_N = mkN "rammande" ; -- rammande..nn.1
  rammelbuljong_1_N = mkN "rammelbuljong" ; -- rammelbuljong..nn.1
  ramning_1_N = mkN "ramning" ; -- ramning..nn.1
  ramp_1_N = mkN "ramp" "ramper" ; -- ramp..nn.1
  rampfeber_1_N = mkN "rampfeber" ; -- rampfeber..nn.1
  rampljus_1_N = mkN "rampljus" neutrum  ; -- rampljus..nn.1
  ramponera_1_V = mkV "ramponerar" ; -- ramponera..vb.1
  ramponerande_1_N = mkN "ramponerande" ; -- ramponerande..nn.1
  ramponerbar_1_A = mkA "ramponerbar" ; -- ramponerbar..av.1
  ramponerbarhet_1_N = mkN "ramponerbarhet" ; -- ramponerbarhet..nn.1
  ramponering_1_N = mkN "ramponering" ; -- ramponering..nn.1
  rampris_1_N = mkN "rampris" neutrum  ; -- rampris..nn.1
  rams_1_N = mkN "rams" ; -- rams..nn.1
  ramsa_1_N = mkN "ramsa" ; -- ramsa..nn.1
  ramsa_1_V = mkV "ramsar" ; -- ramsa..vb.1
  ramsande_1_N = mkN "ramsande" ; -- ramsande..nn.1
  ramstark_1_A = mkA "ramstark" ; -- ramstark..av.1
  ramstarkhet_1_N = mkN "ramstarkhet" ; -- ramstarkhet..nn.1
  ramsvart_1_A = mkA "ramsvart" "ramsvart" ; -- ramsvart..av.1
  ramsättare_1_N = mkN "ramsättare" utrum  ; -- ramsättare..nn.1
  ramverk_1_N = mkN "ramverk" neutrum  ; -- ramverk..nn.1
  ramverkstad_1_N = mkN "ramverkstad" "ramverkstäder" ; -- ramverkstad..nn.1
  rana_1_N = mkN "rana" ; -- rana..nn.1
  ranch_1_N = mkN "ranch" "rancher" ; -- ranch..nn.1
  ranchägare_1_N = mkN "ranchägare" utrum  ; -- ranchägare..nn.1
  ranchägartyp_1_N = mkN "ranchägartyp" "ranchägartyper" ; -- ranchägartyp..nn.1
  rancune_1_N = mkN "rancune" "rancuner" ; -- rancune..nn.1
  rand_1_N = mkN "rand" "ränder" ; -- rand..nn.1
  rand_2_N = mkN "rand" "randen" "rand" "randen" ; -- rand..nn.2
  randa_1_V = mkV "randar" ; -- randa..vb.1
  randande_1_N = mkN "randande" ; -- randande..nn.1
  randanmärkning_1_N = mkN "randanmärkning" ; -- randanmärkning..nn.1
  randanteckning_1_N = mkN "randanteckning" ; -- randanteckning..nn.1
  randberg_1_N = mkN "randberg" neutrum  ; -- randberg..nn.1
  randbildning_1_N = mkN "randbildning" ; -- randbildning..nn.1
  randdelta_1_N = mkN "randdelta" "randdeltat" "randdeltan" "randdeltana" ; -- randdelta..nn.1
  randfenomen_1_N = mkN "randfenomen" neutrum  ; -- randfenomen..nn.1
  randhav_1_N = mkN "randhav" neutrum  ; -- randhav..nn.1
  randig_1_A = mkA "randig" ; -- randig..av.1
  randighet_1_N = mkN "randighet" ; -- randighet..nn.1
  randning_1_N = mkN "randning" ; -- randning..nn.1
  randomisera_1_V = mkV "randomiserar" ; -- randomisera..vb.1
  randomiserad_1_A = mkA "randomiserad" ; -- randomiserad..av.1
  randomiserbar_1_A = mkA "randomiserbar" ; -- randomiserbar..av.1
  randomiserbarhet_1_N = mkN "randomiserbarhet" ; -- randomiserbarhet..nn.1
  randplatå_1_N = mkN "randplatå" "randplatåer" ; -- randplatå..nn.1
  randsjö_1_N = mkN "randsjö" ; -- randsjö..nn.1
  randsydd_1_A = mkA "randsydd" ; -- randsydd..av.1
  rang_1_N = mkN "rang" ; -- rang..nn.1
  ranger_1_N = mkN "ranger" "rangern" "rangers" "rangersarna" ; -- ranger..nn.1
  rangera_1_V = mkV "rangerar" ; -- rangera..vb.1
  rangerad_1_A = mkA "rangerad" ; -- rangerad..av.1
  rangerande_1_N = mkN "rangerande" ; -- rangerande..nn.1
  rangerbangård_1_N = mkN "rangerbangård" ; -- rangerbangård..nn.1
  rangerbar_1_A = mkA "rangerbar" ; -- rangerbar..av.1
  rangerbarhet_1_N = mkN "rangerbarhet" ; -- rangerbarhet..nn.1
  rangering_1_N = mkN "rangering" ; -- rangering..nn.1
  rangkorrelation_1_N = mkN "rangkorrelation" ; -- rangkorrelation..nn.1
  rangkorrelationskoefficient_1_N = mkN "rangkorrelationskoefficient" "rangkorrelationskoefficienter" ; -- rangkorrelationskoefficient..nn.1
  rangla_1_V = mkV "ranglar" ; -- rangla..vb.1
  ranglande_1_N = mkN "ranglande" ; -- ranglande..nn.1
  ranglig_1_A = mkA "ranglig" ; -- ranglig..av.1
  ranglighet_1_N = mkN "ranglighet" ; -- ranglighet..nn.1
  rangmässig_1_A = mkA "rangmässig" ; -- rangmässig..av.1
  rangordna_1_V = mkV "rangordnar" ; -- rangordna..vb.1
  rangordnande_1_N = mkN "rangordnande" ; -- rangordnande..nn.1
  rangordning_1_N = mkN "rangordning" ; -- rangordning..nn.1
  rangplats_1_N = mkN "rangplats" "rangplatser" ; -- rangplats..nn.1
  rangrulla_1_N = mkN "rangrulla" ; -- rangrulla..nn.1
  rangskala_1_N = mkN "rangskala" ; -- rangskala..nn.1
  rank_1_A = mkA "rank" ; -- rank..av.1
  ranka_1_N = mkN "ranka" ; -- ranka..nn.1
  ranka_1_V = mkV "rankar" ; -- ranka..vb.1
  rankande_1_N = mkN "rankande" ; -- rankande..nn.1
  rankfoting_1_N = mkN "rankfoting" ; -- rankfoting..nn.1
  rankhet_1_N = mkN "rankhet" ; -- rankhet..nn.1
  rankig_1_A = mkA "rankig" ; -- rankig..av.1
  rankighet_1_N = mkN "rankighet" ; -- rankighet..nn.1
  ranking_1_N = mkN "ranking" ; -- ranking..nn.1
  rankinglista_1_N = mkN "rankinglista" ; -- rankinglista..nn.1
  rankning_1_N = mkN "rankning" ; -- rankning..nn.1
  rankningslista_1_N = mkN "rankningslista" ; -- rankningslista..nn.1
  rannsaka_1_V = mkV "rannsakar" ; -- rannsaka..vb.1
  rannsakande_1_N = mkN "rannsakande" ; -- rannsakande..nn.1
  rannsakning_1_N = mkN "rannsakning" ; -- rannsakning..nn.1
  ranson_1_N = mkN "ranson" "ransoner" ; -- ranson..nn.1
  ransonera_1_V = mkV "ransonerar" ; -- ransonera..vb.1
  ransonerande_1_N = mkN "ransonerande" ; -- ransonerande..nn.1
  ransonerbar_1_A = mkA "ransonerbar" ; -- ransonerbar..av.1
  ransonerbarhet_1_N = mkN "ransonerbarhet" ; -- ransonerbarhet..nn.1
  ransonering_1_N = mkN "ransonering" ; -- ransonering..nn.1
  ransoneringskort_1_N = mkN "ransoneringskort" neutrum  ; -- ransoneringskort..nn.1
  ranta_1_V = mkV "rantar" ; -- ranta..vb.1
  rantande_1_N = mkN "rantande" ; -- rantande..nn.1
  rantande_2_N = mkN "rantande" ; -- rantande..nn.2
  ranunkel_1_N = mkN "ranunkel" ; -- ranunkel..nn.1
  ranunkelväxt_1_N = mkN "ranunkelväxt" "ranunkelväxter" ; -- ranunkelväxt..nn.1
  rap_1_N = mkN "rap" neutrum  ; -- rap..nn.1
  rap_2_N = mkN "rap" ; -- rap..nn.2
  rapa_1_V = mkV "rapar" ; -- rapa..vb.1
  rapande_1_N = mkN "rapande" ; -- rapande..nn.1
  rapid_1_A = mkA "rapid" ; -- rapid..av.1
  rapmusik_1_N = mkN "rapmusik" ; -- rapmusik..nn.1
  rapning_1_N = mkN "rapning" ; -- rapning..nn.1
  rapp_1_A = mkA "rapp" ; -- rapp..av.1
  rapp_1_N = mkN "rapp" ; -- rapp..nn.1
  rapp_2_N = mkN "rapp" neutrum  ; -- rapp..nn.2
  rapp_3_N = mkN "rapp" ; -- rapp..nn.3
  rappa_1_V = mkV "rappar" ; -- rappa..vb.1
  rappakalja_1_N = mkN "rappakalja" ; -- rappakalja..nn.1
  rappande_1_N = mkN "rappande" ; -- rappande..nn.1
  rappare_1_N = mkN "rappare" utrum  ; -- rappare..nn.1
  rappell_1_N = mkN "rappell" "rappeller" ; -- rappell..nn.1
  rappellera_1_V = mkV "rappellerar" ; -- rappellera..vb.1
  rappellerande_1_N = mkN "rappellerande" ; -- rappellerande..nn.1
  rappellerbar_1_A = mkA "rappellerbar" ; -- rappellerbar..av.1
  rappellerbarhet_1_N = mkN "rappellerbarhet" ; -- rappellerbarhet..nn.1
  rappellering_1_N = mkN "rappellering" ; -- rappellering..nn.1
  rapphet_1_N = mkN "rapphet" ; -- rapphet..nn.1
  rapphöna_1_N = mkN "rapphöna" ; -- rapphöna..nn.1
  rapphöns_1_N = mkN "rapphöns" neutrum  ; -- rapphöns..nn.1
  rappkäftad_1_A = mkA "rappkäftad" ; -- rappkäftad..av.1
  rappning_1_N = mkN "rappning" ; -- rappning..nn.1
  rapport_1_N = mkN "rapport" "rapporter" ; -- rapport..nn.1
  rapportbok_1_N = mkN "rapportbok" "rapportböcker" ; -- rapportbok..nn.1
  rapportera_1_V = mkV "rapporterar" ; -- rapportera..vb.1
  rapporterande_1_N = mkN "rapporterande" ; -- rapporterande..nn.1
  rapporterbar_1_A = mkA "rapporterbar" ; -- rapporterbar..av.1
  rapporterbarhet_1_N = mkN "rapporterbarhet" ; -- rapporterbarhet..nn.1
  rapportering_1_N = mkN "rapportering" ; -- rapportering..nn.1
  rapporteringsplikt_1_N = mkN "rapporteringsplikt" ; -- rapporteringsplikt..nn.1
  rapportkarl_1_N = mkN "rapportkarl" ; -- rapportkarl..nn.1
  rapportör_1_N = mkN "rapportör" "rapportörer" ; -- rapportör..nn.1
  raps_1_N = mkN "raps" ; -- raps..nn.1
  rapsbagge_1_N = mkN "rapsbagge" utrum  ; -- rapsbagge..nn.1
  rapsfrö_1_N = mkN "rapsfrö" "rapsfröt" "rapsfrön" "rapsfröen" ; -- rapsfrö..nn.1
  rapsfält_1_N = mkN "rapsfält" neutrum  ; -- rapsfält..nn.1
  rapskaka_1_N = mkN "rapskaka" ; -- rapskaka..nn.1
  rapsod_1_N = mkN "rapsod" "rapsoder" ; -- rapsod..nn.1
  rapsodi_1_N = mkN "rapsodi" "rapsodier" ; -- rapsodi..nn.1
  rapsodisk_1_A = mkA "rapsodisk" ; -- rapsodisk..av.1
  rapsolja_1_N = mkN "rapsolja" ; -- rapsolja..nn.1
  rapsplanta_1_N = mkN "rapsplanta" ; -- rapsplanta..nn.1
  rapstjärna_1_N = mkN "rapstjärna" ; -- rapstjärna..nn.1
  rapsåker_1_N = mkN "rapsåker" ; -- rapsåker..nn.1
  raptus_1_N = mkN "raptus" neutrum  ; -- raptus..nn.1
  rar_1_A = mkA "rar" ; -- rar..av.1
  rarhet_1_N = mkN "rarhet" ; -- rarhet..nn.1
  raring_1_N = mkN "raring" ; -- raring..nn.1
  raritet_1_N = mkN "raritet" "rariteter" ; -- raritet..nn.1
  ras_1_N = mkN "ras" "raser" ; -- ras..nn.1
  ras_2_N = mkN "ras" neutrum  ; -- ras..nn.2
  rasa_1_V = mkV "rasar" ; -- rasa..vb.1
  rasande_1_A = mkA "rasande" ; -- rasande..av.1
  rasande_1_N = mkN "rasande" ; -- rasande..nn.1
  rasben_1_N = mkN "rasben" neutrum  ; -- rasben..nn.1
  rasbiologi_1_N = mkN "rasbiologi" ; -- rasbiologi..nn.1
  rasbiologisk_1_A = mkA "rasbiologisk" ; -- rasbiologisk..av.1
  rasblandning_1_N = mkN "rasblandning" ; -- rasblandning..nn.1
  rasdiskriminera_1_V = mkV "rasdiskriminerar" ; -- rasdiskriminera..vb.1
  rasdiskriminerande_1_N = mkN "rasdiskriminerande" ; -- rasdiskriminerande..nn.1
  rasdiskriminerbar_1_A = mkA "rasdiskriminerbar" ; -- rasdiskriminerbar..av.1
  rasdiskriminerbarhet_1_N = mkN "rasdiskriminerbarhet" ; -- rasdiskriminerbarhet..nn.1
  rasdiskriminering_1_N = mkN "rasdiskriminering" ; -- rasdiskriminering..nn.1
  rasdjur_1_N = mkN "rasdjur" neutrum  ; -- rasdjur..nn.1
  rasera_1_V = mkV "raserar" ; -- rasera..vb.1
  raserande_1_N = mkN "raserande" ; -- raserande..nn.1
  raserbar_1_A = mkA "raserbar" ; -- raserbar..av.1
  raserbarhet_1_N = mkN "raserbarhet" ; -- raserbarhet..nn.1
  raseri_1_N = mkN "raseri" neutrum  ; -- raseri..nn.1
  rasering_1_N = mkN "rasering" ; -- rasering..nn.1
  raseriutbrott_1_N = mkN "raseriutbrott" neutrum  ; -- raseriutbrott..nn.1
  rasfrämling_1_N = mkN "rasfrämling" ; -- rasfrämling..nn.1
  rasfråga_1_N = mkN "rasfråga" ; -- rasfråga..nn.1
  rasfördom_1_N = mkN "rasfördom" ; -- rasfördom..nn.1
  rasförföljelse_1_N = mkN "rasförföljelse" "rasförföljelser" ; -- rasförföljelse..nn.1
  rashat_1_N = mkN "rashat" neutrum  ; -- rashat..nn.1
  rashets_1_N = mkN "rashets" ; -- rashets..nn.1
  rashetsare_1_N = mkN "rashetsare" utrum  ; -- rashetsare..nn.1
  rashäst_1_N = mkN "rashäst" ; -- rashäst..nn.1
  rasism_1_N = mkN "rasism" "rasismer" ; -- rasism..nn.1
  rasist_1_N = mkN "rasist" "rasister" ; -- rasist..nn.1
  rasistisk_1_A = mkA "rasistisk" ; -- rasistisk..av.1
  rasistskandal_1_N = mkN "rasistskandal" "rasistskandaler" ; -- rasistskandal..nn.1
  rask_1_A = mkA "rask" ; -- rask..av.1
  raskhet_1_N = mkN "raskhet" ; -- raskhet..nn.1
  raskrig_1_N = mkN "raskrig" neutrum  ; -- raskrig..nn.1
  raslära_1_N = mkN "raslära" ; -- raslära..nn.1
  rasmassa_1_N = mkN "rasmassa" ; -- rasmassa..nn.1
  rasmotsättning_1_N = mkN "rasmotsättning" ; -- rasmotsättning..nn.1
  rasmässig_1_A = mkA "rasmässig" ; -- rasmässig..av.1
  rasorolighet_1_N = mkN "rasorolighet" "rasoroligheter" ; -- rasorolighet..nn.1
  rasp_1_N = mkN "rasp" ; -- rasp..nn.1
  rasp_2_N = mkN "rasp" neutrum  ; -- rasp..nn.2
  raspa_1_V = mkV "raspar" ; -- raspa..vb.1
  raspande_1_A = mkA "raspande" ; -- raspande..av.1
  raspande_1_N = mkN "raspande" ; -- raspande..nn.1
  raspig_1_A = mkA "raspig" ; -- raspig..av.1
  raspighet_1_N = mkN "raspighet" ; -- raspighet..nn.1
  raspning_1_N = mkN "raspning" ; -- raspning..nn.1
  rasren_1_A = mkA "rasren" "rasrent" ; -- rasren..av.1
  rasse_1_N = mkN "rasse" utrum  ; -- rasse..nn.1
  rassegregation_1_N = mkN "rassegregation" ; -- rassegregation..nn.1
  rassegregerad_1_A = mkA "rassegregerad" ; -- rassegregerad..av.1
  rassel_1_N = mkN "rassel" neutrum  ; -- rassel..nn.1
  rassla_1_V = mkV "rasslar" ; -- rassla..vb.1
  rasslande_1_N = mkN "rasslande" ; -- rasslande..nn.1
  rast_1_N = mkN "rast" "raster" ; -- rast..nn.1
  rasta_1_V = mkV "rastar" ; -- rasta..vb.1
  rasta_2_V = mkV "rastar" ; -- rasta..vb.2
  rastabarr_1_N = mkN "rastabarr" neutrum  ; -- rastabarr..nn.1
  rastafari_1_N = mkN "rastafari" "rastafarin" "rastafaris" "rastafarisarna" ; -- rastafari..nn.1
  rastafarisekt_1_N = mkN "rastafarisekt" ; -- rastafarisekt..nn.1
  rastafrisyr_1_N = mkN "rastafrisyr" "rastafrisyrer" ; -- rastafrisyr..nn.1
  rastahår_1_N = mkN "rastahår" neutrum  ; -- rastahår..nn.1
  rastande_1_N = mkN "rastande" ; -- rastande..nn.1
  rastatro_1_N = mkN "rastatro" ; -- rastatro..nn.1
  rastatroende_1_A = mkA "rastatroende" ; -- rastatroende..av.1
  rasteori_1_N = mkN "rasteori" "rasteorier" ; -- rasteori..nn.1
  raster_1_N = mkN "raster" neutrum  ; -- raster..nn.1
  rastgård_1_N = mkN "rastgård" ; -- rastgård..nn.1
  rastlös_1_A = mkA "rastlös" ; -- rastlös..av.1
  rastlöshet_1_N = mkN "rastlöshet" ; -- rastlöshet..nn.1
  rastplats_1_N = mkN "rastplats" "rastplatser" ; -- rastplats..nn.1
  rasåtskillnad_1_N = mkN "rasåtskillnad" ; -- rasåtskillnad..nn.1
  rata_1_V = mkV "ratar" ; -- rata..vb.1
  ratande_1_N = mkN "ratande" ; -- ratande..nn.1
  rate_1_N = mkN "rate" "rater" ; -- rate..nn.1
  ratificera_1_V = mkV "ratificerar" ; -- ratificera..vb.1
  ratificerande_1_N = mkN "ratificerande" ; -- ratificerande..nn.1
  ratificerbar_1_A = mkA "ratificerbar" ; -- ratificerbar..av.1
  ratificerbarhet_1_N = mkN "ratificerbarhet" ; -- ratificerbarhet..nn.1
  ratificering_1_N = mkN "ratificering" ; -- ratificering..nn.1
  ratifikation_1_N = mkN "ratifikation" ; -- ratifikation..nn.1
  ratifikationsinstrument_1_N = mkN "ratifikationsinstrument" neutrum  ; -- ratifikationsinstrument..nn.1
  ration_1_N = mkN "ration" ; -- ration..nn.1
  rationalisera_1_V = mkV "rationaliserar" ; -- rationalisera..vb.1
  rationaliserande_1_N = mkN "rationaliserande" ; -- rationaliserande..nn.1
  rationaliserbar_1_A = mkA "rationaliserbar" ; -- rationaliserbar..av.1
  rationaliserbarhet_1_N = mkN "rationaliserbarhet" ; -- rationaliserbarhet..nn.1
  rationalisering_1_N = mkN "rationalisering" ; -- rationalisering..nn.1
  rationalism_1_N = mkN "rationalism" "rationalismer" ; -- rationalism..nn.1
  rationalist_1_N = mkN "rationalist" "rationalister" ; -- rationalist..nn.1
  rationalistisk_1_A = mkA "rationalistisk" ; -- rationalistisk..av.1
  rationalitet_1_N = mkN "rationalitet" "rationaliteter" ; -- rationalitet..nn.1
  rationalitetsskepsis_1_N = mkN "rationalitetsskepsis" ; -- rationalitetsskepsis..nn.1
  rationell_1_A = mkA "rationell" ; -- rationell..av.1
  ratsch_1_N = mkN "ratsch" neutrum  ; -- ratsch..nn.1
  ratscha_1_V = mkV "ratschar" ; -- ratscha..vb.1
  ratschande_1_N = mkN "ratschande" ; -- ratschande..nn.1
  ratt_1_N = mkN "ratt" ; -- ratt..nn.1
  ratta_1_V = mkV "rattar" ; -- ratta..vb.1
  rattande_1_N = mkN "rattande" ; -- rattande..nn.1
  rattfull_1_A = mkA "rattfull" ; -- rattfull..av.1
  rattfylla_1_N = mkN "rattfylla" ; -- rattfylla..nn.1
  rattfylleri_1_N = mkN "rattfylleri" neutrum  ; -- rattfylleri..nn.1
  rattfyllerist_1_N = mkN "rattfyllerist" "rattfyllerister" ; -- rattfyllerist..nn.1
  rattkrycka_1_N = mkN "rattkrycka" ; -- rattkrycka..nn.1
  rattkälke_1_N = mkN "rattkälke" utrum  ; -- rattkälke..nn.1
  rattlås_1_N = mkN "rattlås" neutrum  ; -- rattlås..nn.1
  rattonykterhet_1_N = mkN "rattonykterhet" "rattonykterheter" ; -- rattonykterhet..nn.1
  rattstång_1_N = mkN "rattstång" "rattstänger" ; -- rattstång..nn.1
  rattväxel_1_N = mkN "rattväxel" ; -- rattväxel..nn.1
  rauk_1_N = mkN "rauk" ; -- rauk..nn.1
  ravaillac_1_N = mkN "ravaillac" ; -- ravaillac..nn.1
  rave_1_N = mkN "rave" utrum  ; -- rave..nn.1
  ravefest_1_N = mkN "ravefest" "ravefester" ; -- ravefest..nn.1
  ravelin_1_N = mkN "ravelin" "raveliner" ; -- ravelin..nn.1
  ravin_1_N = mkN "ravin" "raviner" ; -- ravin..nn.1
  rayon_1_N = mkN "rayon" neutrum  ; -- rayon..nn.1
  rayonsilke_1_N = mkN "rayonsilke" ; -- rayonsilke..nn.1
  rayonull_1_N = mkN "rayonull" ; -- rayonull..nn.1
  razzia_1_N = mkN "razzia" ; -- razzia..nn.1
  rea_1_N = mkN "rea" ; -- rea..nn.1
  rea_1_V = mkV "rear" ; -- rea..vb.1
  ready_made_1_N = mkN "ready-made" ; -- ready-made..nn.1
  reagens_1_N = mkN "reagens" neutrum  ; -- reagens..nn.1
  reagenspapper_1_N = mkN "reagenspapper" neutrum  ; -- reagenspapper..nn.1
  reagera_1_V = mkV "reagerar" ; -- reagera..vb.1
  reagerande_1_N = mkN "reagerande" ; -- reagerande..nn.1
  reagering_1_N = mkN "reagering" ; -- reagering..nn.1
  reaktion_1_N = mkN "reaktion" ; -- reaktion..nn.1
  reaktionsbenägen_1_A = mkA "reaktionsbenägen" ; -- reaktionsbenägen..av.1
  reaktionsdrift_1_N = mkN "reaktionsdrift" ; -- reaktionsdrift..nn.1
  reaktionsfas_1_N = mkN "reaktionsfas" "reaktionsfaser" ; -- reaktionsfas..nn.1
  reaktionsförmåga_1_N = mkN "reaktionsförmåga" ; -- reaktionsförmåga..nn.1
  reaktionsmotor_1_N = mkN "reaktionsmotor" "reaktionsmotorer" ; -- reaktionsmotor..nn.1
  reaktionsprodukt_1_N = mkN "reaktionsprodukt" "reaktionsprodukter" ; -- reaktionsprodukt..nn.1
  reaktionstemperatur_1_N = mkN "reaktionstemperatur" "reaktionstemperaturer" ; -- reaktionstemperatur..nn.1
  reaktionstid_1_N = mkN "reaktionstid" "reaktionstider" ; -- reaktionstid..nn.1
  reaktionszon_1_N = mkN "reaktionszon" "reaktionszoner" ; -- reaktionszon..nn.1
  reaktionär_1_A = mkA "reaktionär" ; -- reaktionär..av.1
  reaktionär_1_N = mkN "reaktionär" "reaktionärer" ; -- reaktionär..nn.1
  reaktiv_1_A = mkA "reaktiv" ; -- reaktiv..av.1
  reaktivera_1_V = mkV "reaktiverar" ; -- reaktivera..vb.1
  reaktiverande_1_N = mkN "reaktiverande" ; -- reaktiverande..nn.1
  reaktiverbar_1_A = mkA "reaktiverbar" ; -- reaktiverbar..av.1
  reaktiverbarhet_1_N = mkN "reaktiverbarhet" ; -- reaktiverbarhet..nn.1
  reaktivering_1_N = mkN "reaktivering" ; -- reaktivering..nn.1
  reaktor_1_N = mkN "reaktor" "reaktorer" ; -- reaktor..nn.1
  reaktorbyggnad_1_N = mkN "reaktorbyggnad" "reaktorbyggnader" ; -- reaktorbyggnad..nn.1
  reaktorfysik_1_N = mkN "reaktorfysik" ; -- reaktorfysik..nn.1
  reaktorhärd_1_N = mkN "reaktorhärd" ; -- reaktorhärd..nn.1
  reaktorkatastrof_1_N = mkN "reaktorkatastrof" "reaktorkatastrofer" ; -- reaktorkatastrof..nn.1
  reaktorkramare_1_N = mkN "reaktorkramare" utrum  ; -- reaktorkramare..nn.1
  reaktorsäkerhet_1_N = mkN "reaktorsäkerhet" "reaktorsäkerheter" ; -- reaktorsäkerhet..nn.1
  reaktortyp_1_N = mkN "reaktortyp" "reaktortyper" ; -- reaktortyp..nn.1
  reaktorutsläpp_1_N = mkN "reaktorutsläpp" neutrum  ; -- reaktorutsläpp..nn.1
  real_1_A = mkA "real" ; -- real..av.1
  real_1_N = mkN "real" ; -- real..nn.1
  reale_1_N = mkN "reale" ; -- reale..nn.1
  realexamen_1_N = mkN "realexamen" "realexamen" "realexamina" "realexamina" ; -- realexamen..nn.1
  realgenus_1_N = mkN "realgenus" neutrum  ; -- realgenus..nn.1
  realia_1_N = mkN "realia" "realian" "realia" "realiana" ; -- realia..nn.1
  realindex_1_N = mkN "realindex" neutrum  ; -- realindex..nn.1
  realisation_1_N = mkN "realisation" ; -- realisation..nn.1
  realisationsvinst_1_N = mkN "realisationsvinst" "realisationsvinster" ; -- realisationsvinst..nn.1
  realisera_1_V = mkV "realiserar" ; -- realisera..vb.1
  realiserande_1_N = mkN "realiserande" ; -- realiserande..nn.1
  realiserbar_1_A = mkA "realiserbar" ; -- realiserbar..av.1
  realiserbarhet_1_N = mkN "realiserbarhet" ; -- realiserbarhet..nn.1
  realisering_1_N = mkN "realisering" ; -- realisering..nn.1
  realism_1_N = mkN "realism" "realismer" ; -- realism..nn.1
  realist_1_N = mkN "realist" "realister" ; -- realist..nn.1
  realistisk_1_A = mkA "realistisk" ; -- realistisk..av.1
  realitet_1_N = mkN "realitet" "realiteter" ; -- realitet..nn.1
  realitystjärna_1_N = mkN "realitystjärna" ; -- realitystjärna..nn.1
  realkapital_1_N = mkN "realkapital" neutrum  ; -- realkapital..nn.1
  realkatalog_1_N = mkN "realkatalog" "realkataloger" ; -- realkatalog..nn.1
  reallinje_1_N = mkN "reallinje" "reallinjer" ; -- reallinje..nn.1
  realläroverk_1_N = mkN "realläroverk" neutrum  ; -- realläroverk..nn.1
  reallön_1_N = mkN "reallön" "reallöner" ; -- reallön..nn.1
  reallönesänkning_1_N = mkN "reallönesänkning" ; -- reallönesänkning..nn.1
  realpolitik_1_N = mkN "realpolitik" ; -- realpolitik..nn.1
  realpolitisk_1_A = mkA "realpolitisk" ; -- realpolitisk..av.1
  realskola_1_N = mkN "realskola" ; -- realskola..nn.1
  realsäkerhet_1_N = mkN "realsäkerhet" "realsäkerheter" ; -- realsäkerhet..nn.1
  realtidsbearbetning_1_N = mkN "realtidsbearbetning" ; -- realtidsbearbetning..nn.1
  realunion_1_N = mkN "realunion" ; -- realunion..nn.1
  realvärde_1_N = mkN "realvärde" ; -- realvärde..nn.1
  reamotor_1_N = mkN "reamotor" "reamotorer" ; -- reamotor..nn.1
  reande_1_N = mkN "reande" ; -- reande..nn.1
  reaplan_1_N = mkN "reaplan" neutrum  ; -- reaplan..nn.1
  reapris_1_N = mkN "reapris" neutrum  ; -- reapris..nn.1
  reassurans_1_N = mkN "reassurans" "reassuranser" ; -- reassurans..nn.1
  reassurera_1_V = mkV "reassurerar" ; -- reassurera..vb.1
  reassurerande_1_N = mkN "reassurerande" ; -- reassurerande..nn.1
  reassurerbar_1_A = mkA "reassurerbar" ; -- reassurerbar..av.1
  reassurerbarhet_1_N = mkN "reassurerbarhet" ; -- reassurerbarhet..nn.1
  reassurering_1_N = mkN "reassurering" ; -- reassurering..nn.1
  rebell_1_N = mkN "rebell" "rebeller" ; -- rebell..nn.1
  rebelledare_1_N = mkN "rebelledare" utrum  ; -- rebelledare..nn.1
  rebellera_1_V = mkV "rebellerar" ; -- rebellera..vb.1
  rebellerande_1_N = mkN "rebellerande" ; -- rebellerande..nn.1
  rebellering_1_N = mkN "rebellering" ; -- rebellering..nn.1
  rebellfäste_1_N = mkN "rebellfäste" ; -- rebellfäste..nn.1
  rebellisk_1_A = mkA "rebellisk" ; -- rebellisk..av.1
  rebus_1_N = mkN "rebus" ; -- rebus..nn.1
  receiver_1_N = mkN "receiver" ; -- receiver..nn.1
  recensent_1_N = mkN "recensent" "recensenter" ; -- recensent..nn.1
  recensera_1_V = mkV "recenserar" ; -- recensera..vb.1
  recenserande_1_N = mkN "recenserande" ; -- recenserande..nn.1
  recenserbar_1_A = mkA "recenserbar" ; -- recenserbar..av.1
  recenserbarhet_1_N = mkN "recenserbarhet" ; -- recenserbarhet..nn.1
  recensering_1_N = mkN "recensering" ; -- recensering..nn.1
  recension_1_N = mkN "recension" ; -- recension..nn.1
  recensionsexemplar_1_N = mkN "recensionsexemplar" neutrum  ; -- recensionsexemplar..nn.1
  recensionsuppdrag_1_N = mkN "recensionsuppdrag" neutrum  ; -- recensionsuppdrag..nn.1
  recent_1_A = mkA "recent" "recent" ; -- recent..av.1
  recentior_1_N = mkN "recentior" "recentiorer" ; -- recentior..nn.1
  recept_1_N = mkN "recept" neutrum  ; -- recept..nn.1
  receptarie_1_N = mkN "receptarie" "receptarier" ; -- receptarie..nn.1
  receptbelagd_1_A = mkA "receptbelagd" "receptbelagt" ; -- receptbelagd..av.1
  receptdatabas_1_N = mkN "receptdatabas" "receptdatabaser" ; -- receptdatabas..nn.1
  receptfri_1_A = mkA "receptfri" "receptfritt" ; -- receptfri..av.1
  reception_1_N = mkN "reception" ; -- reception..nn.1
  receptionist_1_N = mkN "receptionist" "receptionister" ; -- receptionist..nn.1
  receptionsdisk_1_N = mkN "receptionsdisk" ; -- receptionsdisk..nn.1
  receptiv_1_A = mkA "receptiv" ; -- receptiv..av.1
  receptivitet_1_N = mkN "receptivitet" "receptiviteter" ; -- receptivitet..nn.1
  receptor_1_N = mkN "receptor" "receptorer" ; -- receptor..nn.1
  receptur_1_N = mkN "receptur" "recepturer" ; -- receptur..nn.1
  recess_1_N = mkN "recess" "recesser" ; -- recess..nn.1
  recession_1_N = mkN "recession" ; -- recession..nn.1
  recessiv_1_A = mkA "recessiv" ; -- recessiv..av.1
  recett_1_N = mkN "recett" "recetter" ; -- recett..nn.1
  recherch_1_N = mkN "recherch" "rechercher" ; -- recherch..nn.1
  recidiv_1_N = mkN "recidiv" neutrum  ; -- recidiv..nn.1
  recidivera_1_V = mkV "recidiverar" ; -- recidivera..vb.1
  recidiverande_1_N = mkN "recidiverande" ; -- recidiverande..nn.1
  recidivering_1_N = mkN "recidivering" ; -- recidivering..nn.1
  recipiend_1_N = mkN "recipiend" "recipiender" ; -- recipiend..nn.1
  recipient_1_N = mkN "recipient" "recipienter" ; -- recipient..nn.1
  recipiera_1_V = mkV "recipierar" ; -- recipiera..vb.1
  recipierande_1_N = mkN "recipierande" ; -- recipierande..nn.1
  recipierbar_1_A = mkA "recipierbar" ; -- recipierbar..av.1
  recipierbarhet_1_N = mkN "recipierbarhet" ; -- recipierbarhet..nn.1
  recipiering_1_N = mkN "recipiering" ; -- recipiering..nn.1
  reciprocitet_1_N = mkN "reciprocitet" "reciprociteter" ; -- reciprocitet..nn.1
  reciprok_1_A = mkA "reciprok" ; -- reciprok..av.1
  recit_1_N = mkN "recit" "reciter" ; -- recit..nn.1
  recitation_1_N = mkN "recitation" ; -- recitation..nn.1
  recitativ_1_N = mkN "recitativ" neutrum  ; -- recitativ..nn.1
  recitera_1_V = mkV "reciterar" ; -- recitera..vb.1
  reciterande_1_N = mkN "reciterande" ; -- reciterande..nn.1
  reciterbar_1_A = mkA "reciterbar" ; -- reciterbar..av.1
  reciterbarhet_1_N = mkN "reciterbarhet" ; -- reciterbarhet..nn.1
  recitering_1_N = mkN "recitering" ; -- recitering..nn.1
  reda_1_N = mkN "reda" ; -- reda..nn.1
  reda_1_V = mkV "reda" "redde" "rett" ; -- reda..vb.1
  redaktion_1_N = mkN "redaktion" ; -- redaktion..nn.1
  redaktionell_1_A = mkA "redaktionell" ; -- redaktionell..av.1
  redaktionschef_1_N = mkN "redaktionschef" "redaktionschefer" ; -- redaktionschef..nn.1
  redaktionssekreterare_1_N = mkN "redaktionssekreterare" utrum  ; -- redaktionssekreterare..nn.1
  redaktör_1_N = mkN "redaktör" "redaktörer" ; -- redaktör..nn.1
  redan_1_Adv = mkAdv "redan" ; -- redan..ab.1
  redande_1_N = mkN "redande" ; -- redande..nn.1
  redare_1_N = mkN "redare" utrum  ; -- redare..nn.1
  redbar_1_A = mkA "redbar" ; -- redbar..av.1
  redbarhet_1_N = mkN "redbarhet" ; -- redbarhet..nn.1
  redd_1_N = mkN "redd" "redder" ; -- redd..nn.1
  rede_1_N = mkN "rede" ; -- rede..nn.1
  rederi_1_N = mkN "rederi" "rederiet" "rederier" "rederierna" ; -- rederi..nn.1
  rederiverksamhet_1_N = mkN "rederiverksamhet" "rederiverksamheter" ; -- rederiverksamhet..nn.1
  redig_1_A = mkA "redig" ; -- redig..av.1
  redigera_1_V = mkV "redigerar" ; -- redigera..vb.1
  redigerande_1_N = mkN "redigerande" ; -- redigerande..nn.1
  redigerbar_1_A = mkA "redigerbar" ; -- redigerbar..av.1
  redigerbarhet_1_N = mkN "redigerbarhet" ; -- redigerbarhet..nn.1
  redigering_1_N = mkN "redigering" ; -- redigering..nn.1
  redighet_1_N = mkN "redighet" ; -- redighet..nn.1
  redikyl_1_N = mkN "redikyl" "redikyler" ; -- redikyl..nn.1
  redingot_1_N = mkN "redingot" "redingoter" ; -- redingot..nn.1
  redlig_1_A = mkA "redlig" ; -- redlig..av.1
  redligen_1_Adv = mkAdv "redligen" ; -- redligen..ab.1
  redlighet_1_N = mkN "redlighet" "redligheter" ; -- redlighet..nn.1
  redlighetskrav_1_N = mkN "redlighetskrav" neutrum  ; -- redlighetskrav..nn.1
  redlös_1_A = mkA "redlös" ; -- redlös..av.1
  redlöshet_1_N = mkN "redlöshet" ; -- redlöshet..nn.1
  redning_1_N = mkN "redning" ; -- redning..nn.1
  redo_1_A = mkA "redo" ; -- redo..av.1
  redobogen_1_A = mkA "redobogen" ; -- redobogen..av.1
  redobogenhet_1_N = mkN "redobogenhet" ; -- redobogenhet..nn.1
  redogöra_1_V = mkV "redogöra" "redogjorde" "redogjort" ; -- redogöra..vb.1
  redogörande_1_N = mkN "redogörande" ; -- redogörande..nn.1
  redogörare_1_N = mkN "redogörare" utrum  ; -- redogörare..nn.1
  redogörelse_1_N = mkN "redogörelse" "redogörelser" ; -- redogörelse..nn.1
  redovisa_1_V = mkV "redovisar" ; -- redovisa..vb.1
  redovisande_1_N = mkN "redovisande" ; -- redovisande..nn.1
  redovisning_1_N = mkN "redovisning" ; -- redovisning..nn.1
  redovisningsmässig_1_A = mkA "redovisningsmässig" ; -- redovisningsmässig..av.1
  redovisningsskyldig_1_A = mkA "redovisningsskyldig" ; -- redovisningsskyldig..av.1
  redovisningsskyldighet_1_N = mkN "redovisningsskyldighet" "redovisningsskyldigheter" ; -- redovisningsskyldighet..nn.1
  redoxprocess_1_N = mkN "redoxprocess" "redoxprocesser" ; -- redoxprocess..nn.1
  redskap_1_N = mkN "redskap" neutrum  ; -- redskap..nn.1
  redskapsgymnastik_1_N = mkN "redskapsgymnastik" ; -- redskapsgymnastik..nn.1
  redskapsmetall_1_N = mkN "redskapsmetall" "redskapsmetaller" ; -- redskapsmetall..nn.1
  redubbla_1_V = mkV "redubblar" ; -- redubbla..vb.1
  redubblande_1_N = mkN "redubblande" ; -- redubblande..nn.1
  reducera_1_V = mkV "reducerar" ; -- reducera..vb.1
  reducerande_1_N = mkN "reducerande" ; -- reducerande..nn.1
  reducerbar_1_A = mkA "reducerbar" ; -- reducerbar..av.1
  reducerbarhet_1_N = mkN "reducerbarhet" ; -- reducerbarhet..nn.1
  reducering_1_N = mkN "reducering" ; -- reducering..nn.1
  reduceringsventil_1_N = mkN "reduceringsventil" "reduceringsventiler" ; -- reduceringsventil..nn.1
  reduktion_1_N = mkN "reduktion" ; -- reduktion..nn.1
  reduktionsdelning_1_N = mkN "reduktionsdelning" ; -- reduktionsdelning..nn.1
  redundans_1_N = mkN "redundans" ; -- redundans..nn.1
  redundant_1_A = mkA "redundant" "redundant" ; -- redundant..av.1
  reduplicera_1_V = mkV "reduplicerar" ; -- reduplicera..vb.1
  reduplikation_1_N = mkN "reduplikation" ; -- reduplikation..nn.1
  reduplikationsstavelse_1_N = mkN "reduplikationsstavelse" "reduplikationsstavelser" ; -- reduplikationsstavelse..nn.1
  redutt_1_N = mkN "redutt" "redutter" ; -- redutt..nn.1
  reell_1_A = mkA "reell" ; -- reell..av.1
  reexport_1_N = mkN "reexport" ; -- reexport..nn.1
  reexportera_1_V = mkV "reexporterar" ; -- reexportera..vb.1
  reexporterande_1_N = mkN "reexporterande" ; -- reexporterande..nn.1
  refektorium_1_N = mkN "refektorium" "refektoriet" "refektorier" "refektorierna" ; -- refektorium..nn.1
  referat_1_N = mkN "referat" neutrum  ; -- referat..nn.1
  referendum_1_N = mkN "referendum" neutrum  ; -- referendum..nn.1
  referens_1_N = mkN "referens" "referenser" ; -- referens..nn.1
  referensbibliotek_1_N = mkN "referensbibliotek" neutrum  ; -- referensbibliotek..nn.1
  referensgrupp_1_N = mkN "referensgrupp" "referensgrupper" ; -- referensgrupp..nn.1
  referenslitteratur_1_N = mkN "referenslitteratur" ; -- referenslitteratur..nn.1
  referensmaterial_1_N = mkN "referensmaterial" neutrum  ; -- referensmaterial..nn.1
  referenspunkt_1_N = mkN "referenspunkt" "referenspunkter" ; -- referenspunkt..nn.1
  referensram_1_N = mkN "referensram" ; -- referensram..nn.1
  referenssort_1_N = mkN "referenssort" "referenssorter" ; -- referenssort..nn.1
  referenssystem_1_N = mkN "referenssystem" neutrum  ; -- referenssystem..nn.1
  referent_1_N = mkN "referent" "referenter" ; -- referent..nn.1
  referera_1_V = mkV "refererar" ; -- referera..vb.1
  refererande_1_N = mkN "refererande" ; -- refererande..nn.1
  refererbar_1_A = mkA "refererbar" ; -- refererbar..av.1
  refererbarhet_1_N = mkN "refererbarhet" ; -- refererbarhet..nn.1
  referering_1_N = mkN "referering" ; -- referering..nn.1
  refill_1_N = mkN "refill" "refiller" ; -- refill..nn.1
  reflektera_1_V = mkV "reflekterar" ; -- reflektera..vb.1
  reflekterad_1_A = mkA "reflekterad" ; -- reflekterad..av.1
  reflekterande_1_N = mkN "reflekterande" ; -- reflekterande..nn.1
  reflekterbar_1_A = mkA "reflekterbar" ; -- reflekterbar..av.1
  reflekterbarhet_1_N = mkN "reflekterbarhet" ; -- reflekterbarhet..nn.1
  reflektering_1_N = mkN "reflektering" ; -- reflektering..nn.1
  reflektion_1_N = mkN "reflektion" ; -- reflektion..nn.1
  reflektionslös_1_A = mkA "reflektionslös" ; -- reflektionslös..av.1
  reflektometer_1_N = mkN "reflektometer" ; -- reflektometer..nn.1
  reflektor_1_N = mkN "reflektor" "reflektorer" ; -- reflektor..nn.1
  reflex_1_N = mkN "reflex" "reflexer" ; -- reflex..nn.1
  reflexion_1_N = mkN "reflexion" ; -- reflexion..nn.1
  reflexionslös_1_A = mkA "reflexionslös" ; -- reflexionslös..av.1
  reflexionslöshet_1_N = mkN "reflexionslöshet" ; -- reflexionslöshet..nn.1
  reflexionsvinkel_1_N = mkN "reflexionsvinkel" ; -- reflexionsvinkel..nn.1
  reflexiv_1_A = mkA "reflexiv" ; -- reflexiv..av.1
  reflexivitet_1_N = mkN "reflexivitet" ; -- reflexivitet..nn.1
  reflexivpronomen_1_N = mkN "reflexivpronomen" neutrum  ; -- reflexivpronomen..nn.1
  reflexmässig_1_A = mkA "reflexmässig" ; -- reflexmässig..av.1
  reflexmässighet_1_N = mkN "reflexmässighet" ; -- reflexmässighet..nn.1
  reflexrörelse_1_N = mkN "reflexrörelse" "reflexrörelser" ; -- reflexrörelse..nn.1
  reflexväst_1_N = mkN "reflexväst" ; -- reflexväst..nn.1
  reform_1_N = mkN "reform" "reformer" ; -- reform..nn.1
  reformation_1_N = mkN "reformation" ; -- reformation..nn.1
  reformator_1_N = mkN "reformator" "reformatorer" ; -- reformator..nn.1
  reformatorisk_1_A = mkA "reformatorisk" ; -- reformatorisk..av.1
  reformbenägen_1_A = mkA "reformbenägen" ; -- reformbenägen..av.1
  reformera_1_V = mkV "reformerar" ; -- reformera..vb.1
  reformerande_1_N = mkN "reformerande" ; -- reformerande..nn.1
  reformerbar_1_A = mkA "reformerbar" ; -- reformerbar..av.1
  reformerbarhet_1_N = mkN "reformerbarhet" ; -- reformerbarhet..nn.1
  reformering_1_N = mkN "reformering" ; -- reformering..nn.1
  reformert_1_A = mkA "reformert" "reformert" ; -- reformert..av.1
  reforminriktad_1_A = mkA "reforminriktad" ; -- reforminriktad..av.1
  reformism_1_N = mkN "reformism" "reformismer" ; -- reformism..nn.1
  reformist_1_N = mkN "reformist" "reformister" ; -- reformist..nn.1
  reformistisk_1_A = mkA "reformistisk" ; -- reformistisk..av.1
  reformkrav_1_N = mkN "reformkrav" neutrum  ; -- reformkrav..nn.1
  reformpolitik_1_N = mkN "reformpolitik" ; -- reformpolitik..nn.1
  reformsinnad_1_A = mkA "reformsinnad" ; -- reformsinnad..av.1
  reformsträvande_1_N = mkN "reformsträvande" ; -- reformsträvande..nn.1
  reformvänlig_1_A = mkA "reformvänlig" ; -- reformvänlig..av.1
  reformvänlighet_1_N = mkN "reformvänlighet" ; -- reformvänlighet..nn.1
  refraktion_1_N = mkN "refraktion" ; -- refraktion..nn.1
  refraktor_1_N = mkN "refraktor" "refraktorer" ; -- refraktor..nn.1
  refräng_1_N = mkN "refräng" "refränger" ; -- refräng..nn.1
  refrängsångare_1_N = mkN "refrängsångare" utrum  ; -- refrängsångare..nn.1
  refug_1_N = mkN "refug" "refuger" ; -- refug..nn.1
  refusera_1_V = mkV "refuserar" ; -- refusera..vb.1
  refuserande_1_N = mkN "refuserande" ; -- refuserande..nn.1
  refuserbar_1_A = mkA "refuserbar" ; -- refuserbar..av.1
  refuserbarhet_1_N = mkN "refuserbarhet" ; -- refuserbarhet..nn.1
  refusering_1_N = mkN "refusering" ; -- refusering..nn.1
  regal_1_A = mkA "regal" ; -- regal..av.1
  regal_1_N = mkN "regal" "regaler" ; -- regal..nn.1
  regale_1_N = mkN "regale" ; -- regale..nn.1
  regalera_1_V = mkV "regalerar" ; -- regalera..vb.1
  regalerande_1_N = mkN "regalerande" ; -- regalerande..nn.1
  regalerbar_1_A = mkA "regalerbar" ; -- regalerbar..av.1
  regalerbarhet_1_N = mkN "regalerbarhet" ; -- regalerbarhet..nn.1
  regalering_1_N = mkN "regalering" ; -- regalering..nn.1
  regalskepp_1_N = mkN "regalskepp" neutrum  ; -- regalskepp..nn.1
  regatta_1_N = mkN "regatta" ; -- regatta..nn.1
  regel_1_N = mkN "regel" "regeln" "regler" "reglerna" ; -- regel..nn.1
  regel_2_N = mkN "regel" ; -- regel..nn.2
  regelbrott_1_N = mkN "regelbrott" neutrum  ; -- regelbrott..nn.1
  regelbunden_1_A = mkA "regelbunden" ; -- regelbunden..av.1
  regelbundenhet_1_N = mkN "regelbundenhet" "regelbundenheter" ; -- regelbundenhet..nn.1
  regelbåt_1_N = mkN "regelbåt" ; -- regelbåt..nn.1
  regelefterlevnad_1_N = mkN "regelefterlevnad" "regelefterlevnader" ; -- regelefterlevnad..nn.1
  regelkrångel_1_N = mkN "regelkrångel" neutrum  ; -- regelkrångel..nn.1
  regellös_1_A = mkA "regellös" ; -- regellös..av.1
  regellöshet_1_N = mkN "regellöshet" ; -- regellöshet..nn.1
  regelmässig_1_A = mkA "regelmässig" ; -- regelmässig..av.1
  regelmässighet_1_N = mkN "regelmässighet" "regelmässigheter" ; -- regelmässighet..nn.1
  regelryttare_1_N = mkN "regelryttare" utrum  ; -- regelryttare..nn.1
  regelrätt_1_A = mkA "regelrätt" ; -- regelrätt..av.1
  regelrätthet_1_N = mkN "regelrätthet" ; -- regelrätthet..nn.1
  regelsystem_1_N = mkN "regelsystem" neutrum  ; -- regelsystem..nn.1
  regeltillämpning_1_N = mkN "regeltillämpning" ; -- regeltillämpning..nn.1
  regeltvång_1_N = mkN "regeltvång" neutrum  ; -- regeltvång..nn.1
  regelutformning_1_N = mkN "regelutformning" ; -- regelutformning..nn.1
  regelverk_1_N = mkN "regelverk" neutrum  ; -- regelverk..nn.1
  regelvidrig_1_A = mkA "regelvidrig" ; -- regelvidrig..av.1
  regelvidrighet_1_N = mkN "regelvidrighet" "regelvidrigheter" ; -- regelvidrighet..nn.1
  regemente_1_N = mkN "regemente" ; -- regemente..nn.1
  regementsbefälhavare_1_N = mkN "regementsbefälhavare" utrum  ; -- regementsbefälhavare..nn.1
  regementschef_1_N = mkN "regementschef" "regementschefer" ; -- regementschef..nn.1
  regementsmusik_1_N = mkN "regementsmusik" ; -- regementsmusik..nn.1
  regementsofficer_1_N = mkN "regementsofficer" "regementsofficeren" "regementsofficerare" "regementsofficerarna" ; -- regementsofficer..nn.1
  regementspastor_1_N = mkN "regementspastor" "regementspastorer" ; -- regementspastor..nn.1
  regeneration_1_N = mkN "regeneration" ; -- regeneration..nn.1
  regenerativ_1_A = mkA "regenerativ" ; -- regenerativ..av.1
  regenerator_1_N = mkN "regenerator" "regeneratorer" ; -- regenerator..nn.1
  regenerera_1_V = mkV "regenererar" ; -- regenerera..vb.1
  regenererande_1_N = mkN "regenererande" ; -- regenererande..nn.1
  regenererbar_1_A = mkA "regenererbar" ; -- regenererbar..av.1
  regenererbarhet_1_N = mkN "regenererbarhet" ; -- regenererbarhet..nn.1
  regenerering_1_N = mkN "regenerering" ; -- regenerering..nn.1
  regent_1_N = mkN "regent" "regenter" ; -- regent..nn.1
  regentfamilj_1_N = mkN "regentfamilj" "regentfamiljer" ; -- regentfamilj..nn.1
  regentlängd_1_N = mkN "regentlängd" "regentlängder" ; -- regentlängd..nn.1
  regentskap_1_N = mkN "regentskap" neutrum  ; -- regentskap..nn.1
  regera_1_V = mkV "regerar" ; -- regera..vb.1
  regerande_1_N = mkN "regerande" ; -- regerande..nn.1
  regerbar_1_A = mkA "regerbar" ; -- regerbar..av.1
  regerbarhet_1_N = mkN "regerbarhet" ; -- regerbarhet..nn.1
  regering_1_N = mkN "regering" ; -- regering..nn.1
  regeringsalternativ_1_N = mkN "regeringsalternativ" neutrum  ; -- regeringsalternativ..nn.1
  regeringsanhängare_1_N = mkN "regeringsanhängare" utrum  ; -- regeringsanhängare..nn.1
  regeringsbeslut_1_N = mkN "regeringsbeslut" neutrum  ; -- regeringsbeslut..nn.1
  regeringsbyggnad_1_N = mkN "regeringsbyggnad" "regeringsbyggnader" ; -- regeringsbyggnad..nn.1
  regeringsbänk_1_N = mkN "regeringsbänk" ; -- regeringsbänk..nn.1
  regeringschef_1_N = mkN "regeringschef" "regeringschefer" ; -- regeringschef..nn.1
  regeringsdeklaration_1_N = mkN "regeringsdeklaration" ; -- regeringsdeklaration..nn.1
  regeringsdirektiv_1_N = mkN "regeringsdirektiv" neutrum  ; -- regeringsdirektiv..nn.1
  regeringsduglig_1_A = mkA "regeringsduglig" ; -- regeringsduglig..av.1
  regeringsduglighet_1_N = mkN "regeringsduglighet" ; -- regeringsduglighet..nn.1
  regeringsfientlig_1_A = mkA "regeringsfientlig" ; -- regeringsfientlig..av.1
  regeringsform_1_N = mkN "regeringsform" "regeringsformer" ; -- regeringsform..nn.1
  regeringsförklaring_1_N = mkN "regeringsförklaring" ; -- regeringsförklaring..nn.1
  regeringskansli_1_N = mkN "regeringskansli" "regeringskansliet" "regeringskanslier" "regeringskanslierna" ; -- regeringskansli..nn.1
  regeringskoalition_1_N = mkN "regeringskoalition" ; -- regeringskoalition..nn.1
  regeringskollega_1_N = mkN "regeringskollega" ; -- regeringskollega..nn.1
  regeringskrets_1_N = mkN "regeringskrets" ; -- regeringskrets..nn.1
  regeringskritisk_1_A = mkA "regeringskritisk" ; -- regeringskritisk..av.1
  regeringsmakt_1_N = mkN "regeringsmakt" "regeringsmakter" ; -- regeringsmakt..nn.1
  regeringsmedlem_1_N = mkN "regeringsmedlem" "regeringsmedlemmen" "regeringsmedlemmar" "regeringsmedlemmarna" ; -- regeringsmedlem..nn.1
  regeringsnivå_1_N = mkN "regeringsnivå" ; -- regeringsnivå..nn.1
  regeringsombildning_1_N = mkN "regeringsombildning" ; -- regeringsombildning..nn.1
  regeringsorgan_1_N = mkN "regeringsorgan" neutrum  ; -- regeringsorgan..nn.1
  regeringsparti_1_N = mkN "regeringsparti" "regeringspartiet" "regeringspartier" "regeringspartierna" ; -- regeringsparti..nn.1
  regeringsplan_1_N = mkN "regeringsplan" neutrum  ; -- regeringsplan..nn.1
  regeringsplattform_1_N = mkN "regeringsplattform" ; -- regeringsplattform..nn.1
  regeringspost_1_N = mkN "regeringspost" "regeringsposter" ; -- regeringspost..nn.1
  regeringsproposition_1_N = mkN "regeringsproposition" ; -- regeringsproposition..nn.1
  regeringspussel_1_N = mkN "regeringspussel" neutrum  ; -- regeringspussel..nn.1
  regeringsrätt_1_N = mkN "regeringsrätt" "regeringsrätter" ; -- regeringsrätt..nn.1
  regeringsråd_1_N = mkN "regeringsråd" neutrum  ; -- regeringsråd..nn.1
  regeringssammanträde_1_N = mkN "regeringssammanträde" ; -- regeringssammanträde..nn.1
  regeringssida_1_N = mkN "regeringssida" ; -- regeringssida..nn.1
  regeringsskifte_1_N = mkN "regeringsskifte" ; -- regeringsskifte..nn.1
  regeringssoldat_1_N = mkN "regeringssoldat" "regeringssoldater" ; -- regeringssoldat..nn.1
  regeringsstyrd_1_A = mkA "regeringsstyrd" "regeringsstyrt" ; -- regeringsstyrd..av.1
  regeringsställning_1_N = mkN "regeringsställning" ; -- regeringsställning..nn.1
  regeringsställning_2_N = mkN "regeringsställning" ; -- regeringsställning..nn.2
  regeringssätt_1_N = mkN "regeringssätt" neutrum  ; -- regeringssätt..nn.1
  regeringstaburett_1_N = mkN "regeringstaburett" "regeringstaburetter" ; -- regeringstaburett..nn.1
  regeringstalesman_1_N = mkN "regeringstalesman" "regeringstalesmannen" "regeringstalesmän" "regeringstalesmännen" ; -- regeringstalesman..nn.1
  regeringstid_1_N = mkN "regeringstid" "regeringstider" ; -- regeringstid..nn.1
  regeringstrogen_1_A = mkA "regeringstrogen" ; -- regeringstrogen..av.1
  regeringsunderlag_1_N = mkN "regeringsunderlag" neutrum  ; -- regeringsunderlag..nn.1
  regeringsvänlig_1_A = mkA "regeringsvänlig" ; -- regeringsvänlig..av.1
  regerlig_1_A = mkA "regerlig" ; -- regerlig..av.1
  regerlighet_1_N = mkN "regerlighet" ; -- regerlighet..nn.1
  reggae_1_N = mkN "reggae" utrum  ; -- reggae..nn.1
  regi_1_N = mkN "regi" ; -- regi..nn.1
  regim_1_N = mkN "regim" "regimer" ; -- regim..nn.1
  regimfiende_1_N = mkN "regimfiende" "regimfiender" ; -- regimfiende..nn.1
  regimkritiker_1_N = mkN "regimkritiker" "regimkritikern" "regimkritiker" "regimkritikerna" ; -- regimkritiker..nn.1
  regimkritisk_1_A = mkA "regimkritisk" ; -- regimkritisk..av.1
  regimkritiskhet_1_N = mkN "regimkritiskhet" ; -- regimkritiskhet..nn.1
  regimskifte_1_N = mkN "regimskifte" ; -- regimskifte..nn.1
  regimvänlig_1_A = mkA "regimvänlig" ; -- regimvänlig..av.1
  regimässig_1_A = mkA "regimässig" ; -- regimässig..av.1
  region_1_N = mkN "region" ; -- region..nn.1
  regional_1_A = mkA "regional" ; -- regional..av.1
  regionalism_1_N = mkN "regionalism" "regionalismer" ; -- regionalism..nn.1
  regionalistisk_1_A = mkA "regionalistisk" ; -- regionalistisk..av.1
  regionalpolitik_1_N = mkN "regionalpolitik" ; -- regionalpolitik..nn.1
  regionalpolitisk_1_A = mkA "regionalpolitisk" ; -- regionalpolitisk..av.1
  regionmusik_1_N = mkN "regionmusik" ; -- regionmusik..nn.1
  regionplan_1_N = mkN "regionplan" "regionplaner" ; -- regionplan..nn.1
  regionpolitik_1_N = mkN "regionpolitik" ; -- regionpolitik..nn.1
  regionpolitisk_1_A = mkA "regionpolitisk" ; -- regionpolitisk..av.1
  regionsjukhus_1_N = mkN "regionsjukhus" neutrum  ; -- regionsjukhus..nn.1
  regionspolitik_1_N = mkN "regionspolitik" ; -- regionspolitik..nn.1
  regionspolitisk_1_A = mkA "regionspolitisk" ; -- regionspolitisk..av.1
  regionstyrelse_1_N = mkN "regionstyrelse" "regionstyrelser" ; -- regionstyrelse..nn.1
  regissera_1_V = mkV "regisserar" ; -- regissera..vb.1
  regisserande_1_N = mkN "regisserande" ; -- regisserande..nn.1
  regisserbar_1_A = mkA "regisserbar" ; -- regisserbar..av.1
  regisserbarhet_1_N = mkN "regisserbarhet" ; -- regisserbarhet..nn.1
  regissering_1_N = mkN "regissering" ; -- regissering..nn.1
  regissör_1_N = mkN "regissör" "regissörer" ; -- regissör..nn.1
  register_1_N = mkN "register" neutrum  ; -- register..nn.1
  registerknapp_1_N = mkN "registerknapp" ; -- registerknapp..nn.1
  registerton_1_N = mkN "registerton" "registertonnet" "registerton" "registertonnen" ; -- registerton..nn.1
  registerutdrag_1_N = mkN "registerutdrag" neutrum  ; -- registerutdrag..nn.1
  registrator_1_N = mkN "registrator" "registratorer" ; -- registrator..nn.1
  registratur_1_N = mkN "registratur" neutrum  ; -- registratur..nn.1
  registrera_1_V = mkV "registrerar" ; -- registrera..vb.1
  registrerande_1_N = mkN "registrerande" ; -- registrerande..nn.1
  registrerbar_1_A = mkA "registrerbar" ; -- registrerbar..av.1
  registrerbarhet_1_N = mkN "registrerbarhet" ; -- registrerbarhet..nn.1
  registrering_1_N = mkN "registrering" ; -- registrering..nn.1
  registreringsbevis_1_N = mkN "registreringsbevis" neutrum  ; -- registreringsbevis..nn.1
  registreringsnummer_1_N = mkN "registreringsnummer" neutrum  ; -- registreringsnummer..nn.1
  registreringsskylt_1_N = mkN "registreringsskylt" ; -- registreringsskylt..nn.1
  regla_1_V = mkV "reglar" ; -- regla..vb.1
  reglage_1_N = mkN "reglage" "reglaget" "reglage" "reglagen" ; -- reglage..nn.1
  reglande_1_N = mkN "reglande" ; -- reglande..nn.1
  reglementarisk_1_A = mkA "reglementarisk" ; -- reglementarisk..av.1
  reglemente_1_N = mkN "reglemente" ; -- reglemente..nn.1
  reglementera_1_V = mkV "reglementerar" ; -- reglementera..vb.1
  reglementerande_1_N = mkN "reglementerande" ; -- reglementerande..nn.1
  reglementerbar_1_A = mkA "reglementerbar" ; -- reglementerbar..av.1
  reglementerbarhet_1_N = mkN "reglementerbarhet" ; -- reglementerbarhet..nn.1
  reglementering_1_N = mkN "reglementering" ; -- reglementering..nn.1
  reglementsenlig_1_A = mkA "reglementsenlig" ; -- reglementsenlig..av.1
  reglementsenlighet_1_N = mkN "reglementsenlighet" ; -- reglementsenlighet..nn.1
  reglementsvidrig_1_A = mkA "reglementsvidrig" ; -- reglementsvidrig..av.1
  reglementsvidrighet_1_N = mkN "reglementsvidrighet" ; -- reglementsvidrighet..nn.1
  reglera_1_V = mkV "reglerar" ; -- reglera..vb.1
  reglera_2_V = mkV "reglerar" ; -- reglera..vb.2
  reglerande_1_N = mkN "reglerande" ; -- reglerande..nn.1
  reglerbar_1_A = mkA "reglerbar" ; -- reglerbar..av.1
  reglerbarhet_1_N = mkN "reglerbarhet" ; -- reglerbarhet..nn.1
  reglering_1_N = mkN "reglering" ; -- reglering..nn.1
  regleringsiver_1_N = mkN "regleringsiver" ; -- regleringsiver..nn.1
  regleringsivrig_1_A = mkA "regleringsivrig" ; -- regleringsivrig..av.1
  regleringsskruv_1_N = mkN "regleringsskruv" ; -- regleringsskruv..nn.1
  reglerkapacitet_1_N = mkN "reglerkapacitet" ; -- reglerkapacitet..nn.1
  reglerkraft_1_N = mkN "reglerkraft" ; -- reglerkraft..nn.1
  reglerteknik_1_N = mkN "reglerteknik" ; -- reglerteknik..nn.1
  regling_1_N = mkN "regling" ; -- regling..nn.1
  regn_1_N = mkN "regn" neutrum  ; -- regn..nn.1
  regna_1_V = mkV "regnar" ; -- regna..vb.1
  regnande_1_N = mkN "regnande" ; -- regnande..nn.1
  regnbrist_1_N = mkN "regnbrist" ; -- regnbrist..nn.1
  regnby_1_N = mkN "regnby" "regnbyn" "regnbyar" "regnbyarna" ; -- regnby..nn.1
  regnbåge_1_N = mkN "regnbåge" utrum  ; -- regnbåge..nn.1
  regnbågshinna_1_N = mkN "regnbågshinna" ; -- regnbågshinna..nn.1
  regnbågsmärka_1_V = mkV "regnbågsmärker" ; -- regnbågsmärka..vb.1
  regnbågsmärkande_1_N = mkN "regnbågsmärkande" ; -- regnbågsmärkande..nn.1
  regnbågsmärkning_1_N = mkN "regnbågsmärkning" ; -- regnbågsmärkning..nn.1
  regndroppe_1_N = mkN "regndroppe" utrum  ; -- regndroppe..nn.1
  regnfri_1_A = mkA "regnfri" "regnfritt" ; -- regnfri..av.1
  regngrå_1_A = mkA "regngrå" "regngrått" ; -- regngrå..av.1
  regnig_1_A = mkA "regnig" ; -- regnig..av.1
  regnighet_1_N = mkN "regnighet" ; -- regnighet..nn.1
  regnkappa_1_N = mkN "regnkappa" ; -- regnkappa..nn.1
  regnmoln_1_N = mkN "regnmoln" neutrum  ; -- regnmoln..nn.1
  regnmängd_1_N = mkN "regnmängd" "regnmängder" ; -- regnmängd..nn.1
  regnmätare_1_N = mkN "regnmätare" utrum  ; -- regnmätare..nn.1
  regnområde_1_N = mkN "regnområde" ; -- regnområde..nn.1
  regnoverall_1_N = mkN "regnoverall" "regnoveraller" ; -- regnoverall..nn.1
  regnoväder_1_N = mkN "regnoväder" neutrum  ; -- regnoväder..nn.1
  regnperiod_1_N = mkN "regnperiod" "regnperioder" ; -- regnperiod..nn.1
  regnrock_1_N = mkN "regnrock" ; -- regnrock..nn.1
  regnskog_1_N = mkN "regnskog" ; -- regnskog..nn.1
  regnskogsskövling_1_N = mkN "regnskogsskövling" ; -- regnskogsskövling..nn.1
  regnskugga_1_N = mkN "regnskugga" ; -- regnskugga..nn.1
  regnskur_1_N = mkN "regnskur" ; -- regnskur..nn.1
  regnskydd_1_N = mkN "regnskydd" neutrum  ; -- regnskydd..nn.1
  regnställ_1_N = mkN "regnställ" neutrum  ; -- regnställ..nn.1
  regnstänk_1_N = mkN "regnstänk" neutrum  ; -- regnstänk..nn.1
  regntid_1_N = mkN "regntid" "regntider" ; -- regntid..nn.1
  regntung_1_A = mkA "regntung" ; -- regntung..av.1
  regntunghet_1_N = mkN "regntunghet" ; -- regntunghet..nn.1
  regntät_1_A = mkA "regntät" ; -- regntät..av.1
  regntäthet_1_N = mkN "regntäthet" ; -- regntäthet..nn.1
  regnvatten_1_N = mkN "regnvatten" "regnvattnet" "regnvatten" "regnvattnen" ; -- regnvatten..nn.1
  regnvåt_1_A = mkA "regnvåt" ; -- regnvåt..av.1
  regolit_1_N = mkN "regolit" "regoliter" ; -- regolit..nn.1
  regrediera_1_V = mkV "regredierar" ; -- regrediera..vb.1
  regress_1_N = mkN "regress" "regresser" ; -- regress..nn.1
  regression_1_N = mkN "regression" ; -- regression..nn.1
  regressiv_1_A = mkA "regressiv" ; -- regressiv..av.1
  reguladetri_1_N = mkN "reguladetri" ; -- reguladetri..nn.1
  regular_1_N = mkN "regular" ; -- regular..nn.1
  regularitet_1_N = mkN "regularitet" "regulariteter" ; -- regularitet..nn.1
  regulator_1_N = mkN "regulator" "regulatorer" ; -- regulator..nn.1
  reguljär_1_A = mkA "reguljär" ; -- reguljär..av.1
  regummera_1_V = mkV "regummerar" ; -- regummera..vb.1
  regummerande_1_N = mkN "regummerande" ; -- regummerande..nn.1
  regummerbar_1_A = mkA "regummerbar" ; -- regummerbar..av.1
  regummerbarhet_1_N = mkN "regummerbarhet" ; -- regummerbarhet..nn.1
  regummering_1_N = mkN "regummering" ; -- regummering..nn.1
  rehabilitation_1_N = mkN "rehabilitation" ; -- rehabilitation..nn.1
  rehabilitera_1_V = mkV "rehabiliterar" ; -- rehabilitera..vb.1
  rehabiliterande_1_N = mkN "rehabiliterande" ; -- rehabiliterande..nn.1
  rehabiliterbar_1_A = mkA "rehabiliterbar" ; -- rehabiliterbar..av.1
  rehabiliterbarhet_1_N = mkN "rehabiliterbarhet" ; -- rehabiliterbarhet..nn.1
  rehabilitering_1_N = mkN "rehabilitering" ; -- rehabilitering..nn.1
  rehabiliteringsförmåga_1_N = mkN "rehabiliteringsförmåga" ; -- rehabiliteringsförmåga..nn.1
  rehabiliteringshem_1_N = mkN "rehabiliteringshem" "rehabiliteringshemmet" "rehabiliteringshem" "rehabiliteringshemmen" ; -- rehabiliteringshem..nn.1
  rehabiliteringsplan_1_N = mkN "rehabiliteringsplan" "rehabiliteringsplaner" ; -- rehabiliteringsplan..nn.1
  reifikation_1_N = mkN "reifikation" ; -- reifikation..nn.1
  reinkarnation_1_N = mkN "reinkarnation" ; -- reinkarnation..nn.1
  reinkarnera_1_V = mkV "reinkarnerar" ; -- reinkarnera..vb.1
  reinkarnerande_1_N = mkN "reinkarnerande" ; -- reinkarnerande..nn.1
  reinkarnerbar_1_A = mkA "reinkarnerbar" ; -- reinkarnerbar..av.1
  reinkarnerbarhet_1_N = mkN "reinkarnerbarhet" ; -- reinkarnerbarhet..nn.1
  reinkarnering_1_N = mkN "reinkarnering" ; -- reinkarnering..nn.1
  rejv_1_N = mkN "rejv" ; -- rejv..nn.1
  rejvfest_1_N = mkN "rejvfest" "rejvfester" ; -- rejvfest..nn.1
  rejäl_1_A = mkA "rejäl" ; -- rejäl..av.1
  rek_1_N = mkN "rek" neutrum  ; -- rek..nn.1
  reka_1_V = mkV "rekar" ; -- reka..vb.1
  rekande_1_N = mkN "rekande" ; -- rekande..nn.1
  rekapitulation_1_N = mkN "rekapitulation" ; -- rekapitulation..nn.1
  rekapitulera_1_V = mkV "rekapitulerar" ; -- rekapitulera..vb.1
  rekapitulerande_1_N = mkN "rekapitulerande" ; -- rekapitulerande..nn.1
  rekapitulerbar_1_A = mkA "rekapitulerbar" ; -- rekapitulerbar..av.1
  rekapitulerbarhet_1_N = mkN "rekapitulerbarhet" ; -- rekapitulerbarhet..nn.1
  rekapitulering_1_N = mkN "rekapitulering" ; -- rekapitulering..nn.1
  reklam_1_N = mkN "reklam" "reklamer" ; -- reklam..nn.1
  reklamaffisch_1_N = mkN "reklamaffisch" "reklamaffischer" ; -- reklamaffisch..nn.1
  reklamagent_1_N = mkN "reklamagent" "reklamagenter" ; -- reklamagent..nn.1
  reklamare_1_N = mkN "reklamare" utrum  ; -- reklamare..nn.1
  reklamation_1_N = mkN "reklamation" ; -- reklamation..nn.1
  reklamblockering_1_N = mkN "reklamblockering" ; -- reklamblockering..nn.1
  reklambransch_1_N = mkN "reklambransch" ; -- reklambransch..nn.1
  reklambroschyr_1_N = mkN "reklambroschyr" "reklambroschyrer" ; -- reklambroschyr..nn.1
  reklambyrå_1_N = mkN "reklambyrå" "reklambyråer" ; -- reklambyrå..nn.1
  reklamera_1_V = mkV "reklamerar" ; -- reklamera..vb.1
  reklamerande_1_N = mkN "reklamerande" ; -- reklamerande..nn.1
  reklamerbar_1_A = mkA "reklamerbar" ; -- reklamerbar..av.1
  reklamerbarhet_1_N = mkN "reklamerbarhet" ; -- reklamerbarhet..nn.1
  reklamering_1_N = mkN "reklamering" ; -- reklamering..nn.1
  reklamfilm_1_N = mkN "reklamfilm" "reklamfilmer" ; -- reklamfilm..nn.1
  reklamfinansierad_1_A = mkA "reklamfinansierad" ; -- reklamfinansierad..av.1
  reklaminslag_1_N = mkN "reklaminslag" neutrum  ; -- reklaminslag..nn.1
  reklamjingel_1_N = mkN "reklamjingel" ; -- reklamjingel..nn.1
  reklamjippo_1_N = mkN "reklamjippo" "reklamjippot" "reklamjippon" "reklamjippona" ; -- reklamjippo..nn.1
  reklamkampanj_1_N = mkN "reklamkampanj" "reklamkampanjer" ; -- reklamkampanj..nn.1
  reklamkupp_1_N = mkN "reklamkupp" "reklamkupper" ; -- reklamkupp..nn.1
  reklampaus_1_N = mkN "reklampaus" "reklampauser" ; -- reklampaus..nn.1
  reklampeng_1_N = mkN "reklampeng" ; -- reklampeng..nn.1
  reklampenna_1_N = mkN "reklampenna" ; -- reklampenna..nn.1
  reklamplakat_1_N = mkN "reklamplakat" neutrum  ; -- reklamplakat..nn.1
  reklamsyfte_1_N = mkN "reklamsyfte" ; -- reklamsyfte..nn.1
  reklamtillvaro_1_N = mkN "reklamtillvaro" ; -- reklamtillvaro..nn.1
  reklamtrick_1_N = mkN "reklamtrick" neutrum  ; -- reklamtrick..nn.1
  reklamväsen_1_N = mkN "reklamväsen" neutrum  ; -- reklamväsen..nn.1
  reko_1_A = mkA "reko" ; -- reko..av.1
  rekognoscera_1_V = mkV "rekognoscerar" ; -- rekognoscera..vb.1
  rekognoscerande_1_N = mkN "rekognoscerande" ; -- rekognoscerande..nn.1
  rekognoscerbar_1_A = mkA "rekognoscerbar" ; -- rekognoscerbar..av.1
  rekognoscerbarhet_1_N = mkN "rekognoscerbarhet" ; -- rekognoscerbarhet..nn.1
  rekognoscering_1_N = mkN "rekognoscering" ; -- rekognoscering..nn.1
  rekognosera_1_V = mkV "rekognoserar" ; -- rekognosera..vb.1
  rekognoserande_1_N = mkN "rekognoserande" ; -- rekognoserande..nn.1
  rekognoserbar_1_A = mkA "rekognoserbar" ; -- rekognoserbar..av.1
  rekognoserbarhet_1_N = mkN "rekognoserbarhet" ; -- rekognoserbarhet..nn.1
  rekognosering_1_N = mkN "rekognosering" ; -- rekognosering..nn.1
  rekommendabel_1_A = mkA "rekommendabel" ; -- rekommendabel..av.1
  rekommendation_1_N = mkN "rekommendation" ; -- rekommendation..nn.1
  rekommendationsbrev_1_N = mkN "rekommendationsbrev" neutrum  ; -- rekommendationsbrev..nn.1
  rekommendera_1_V = mkV "rekommenderar" ; -- rekommendera..vb.1
  rekommenderande_1_N = mkN "rekommenderande" ; -- rekommenderande..nn.1
  rekommenderbar_1_A = mkA "rekommenderbar" ; -- rekommenderbar..av.1
  rekommenderbarhet_1_N = mkN "rekommenderbarhet" ; -- rekommenderbarhet..nn.1
  rekommendering_1_N = mkN "rekommendering" ; -- rekommendering..nn.1
  rekompensera_1_V = mkV "rekompenserar" ; -- rekompensera..vb.1
  rekompenserande_1_N = mkN "rekompenserande" ; -- rekompenserande..nn.1
  rekompenserbar_1_A = mkA "rekompenserbar" ; -- rekompenserbar..av.1
  rekompenserbarhet_1_N = mkN "rekompenserbarhet" ; -- rekompenserbarhet..nn.1
  rekompensering_1_N = mkN "rekompensering" ; -- rekompensering..nn.1
  rekonstruera_1_V = mkV "rekonstruerar" ; -- rekonstruera..vb.1
  rekonstruerande_1_N = mkN "rekonstruerande" ; -- rekonstruerande..nn.1
  rekonstruerbar_1_A = mkA "rekonstruerbar" ; -- rekonstruerbar..av.1
  rekonstruerbarhet_1_N = mkN "rekonstruerbarhet" ; -- rekonstruerbarhet..nn.1
  rekonstruering_1_N = mkN "rekonstruering" ; -- rekonstruering..nn.1
  rekonstruktion_1_N = mkN "rekonstruktion" ; -- rekonstruktion..nn.1
  rekonvalescens_1_N = mkN "rekonvalescens" ; -- rekonvalescens..nn.1
  rekord_1_N = mkN "rekord" neutrum  ; -- rekord..nn.1
  rekordartad_1_A = mkA "rekordartad" ; -- rekordartad..av.1
  rekordbonus_1_N = mkN "rekordbonus" ; -- rekordbonus..nn.1
  rekorddjup_1_A = mkA "rekorddjup" ; -- rekorddjup..av.1
  rekorderlig_1_A = mkA "rekorderlig" ; -- rekorderlig..av.1
  rekorderlighet_1_N = mkN "rekorderlighet" ; -- rekorderlighet..nn.1
  rekordfart_1_N = mkN "rekordfart" ; -- rekordfart..nn.1
  rekordform_1_N = mkN "rekordform" ; -- rekordform..nn.1
  rekordfå_1_A = mkA "rekordfå" "rekordfå" "rekordfå" "rekordfärre" "rekordfärst" ; -- rekordfå..av.1
  rekordhög_1_A = mkA "rekordhög" ; -- rekordhög..av.1
  rekordhöjd_1_N = mkN "rekordhöjd" "rekordhöjder" ; -- rekordhöjd..nn.1
  rekordintresse_1_N = mkN "rekordintresse" ; -- rekordintresse..nn.1
  rekordklantig_1_A = mkA "rekordklantig" ; -- rekordklantig..av.1
  rekordlåg_1_A = mkA "rekordlåg" ; -- rekordlåg..av.1
  rekordlång_1_A = mkA "rekordlång" ; -- rekordlång..av.1
  rekordmässig_1_A = mkA "rekordmässig" ; -- rekordmässig..av.1
  rekordnivå_1_N = mkN "rekordnivå" "rekordnivåer" ; -- rekordnivå..nn.1
  rekordsatsning_1_N = mkN "rekordsatsning" ; -- rekordsatsning..nn.1
  rekordsiffra_1_N = mkN "rekordsiffra" ; -- rekordsiffra..nn.1
  rekordsnabb_1_A = mkA "rekordsnabb" ; -- rekordsnabb..av.1
  rekordstor_1_A = mkA "rekordstor" ; -- rekordstor..av.1
  rekordtidig_1_A = mkA "rekordtidig" ; -- rekordtidig..av.1
  rekordvarvtal_1_N = mkN "rekordvarvtal" neutrum  ; -- rekordvarvtal..nn.1
  rekreation_1_N = mkN "rekreation" ; -- rekreation..nn.1
  rekreationsanläggning_1_N = mkN "rekreationsanläggning" ; -- rekreationsanläggning..nn.1
  rekreationscenter_1_N = mkN "rekreationscenter" neutrum  ; -- rekreationscenter..nn.1
  rekreationsmässig_1_A = mkA "rekreationsmässig" ; -- rekreationsmässig..av.1
  rekreationsområde_1_N = mkN "rekreationsområde" ; -- rekreationsområde..nn.1
  rekreationspolitik_1_N = mkN "rekreationspolitik" ; -- rekreationspolitik..nn.1
  rekreationspolitisk_1_A = mkA "rekreationspolitisk" ; -- rekreationspolitisk..av.1
  rekreationsskog_1_N = mkN "rekreationsskog" ; -- rekreationsskog..nn.1
  rekreativ_1_A = mkA "rekreativ" ; -- rekreativ..av.1
  rekryt_1_N = mkN "rekryt" "rekryter" ; -- rekryt..nn.1
  rekrytera_1_V = mkV "rekryterar" ; -- rekrytera..vb.1
  rekryterande_1_N = mkN "rekryterande" ; -- rekryterande..nn.1
  rekryterbar_1_A = mkA "rekryterbar" ; -- rekryterbar..av.1
  rekryterbarhet_1_N = mkN "rekryterbarhet" ; -- rekryterbarhet..nn.1
  rekrytering_1_N = mkN "rekrytering" ; -- rekrytering..nn.1
  rekryteringsföretag_1_N = mkN "rekryteringsföretag" neutrum  ; -- rekryteringsföretag..nn.1
  rekryteringsland_1_N = mkN "rekryteringsland" "rekryteringslandet" "rekryteringsländer" "rekryteringsländerna" ; -- rekryteringsland..nn.1
  rektal_1_A = mkA "rektal" ; -- rektal..av.1
  rektangel_1_N = mkN "rektangel" ; -- rektangel..nn.1
  rektangulär_1_A = mkA "rektangulär" ; -- rektangulär..av.1
  rektascension_1_N = mkN "rektascension" ; -- rektascension..nn.1
  rektificera_1_V = mkV "rektificerar" ; -- rektificera..vb.1
  rektificerande_1_N = mkN "rektificerande" ; -- rektificerande..nn.1
  rektificerbar_1_A = mkA "rektificerbar" ; -- rektificerbar..av.1
  rektificerbarhet_1_N = mkN "rektificerbarhet" ; -- rektificerbarhet..nn.1
  rektificering_1_N = mkN "rektificering" ; -- rektificering..nn.1
  rektifiera_1_V = mkV "rektifierar" ; -- rektifiera..vb.1
  rektifierande_1_N = mkN "rektifierande" ; -- rektifierande..nn.1
  rektifierbar_1_A = mkA "rektifierbar" ; -- rektifierbar..av.1
  rektifierbarhet_1_N = mkN "rektifierbarhet" ; -- rektifierbarhet..nn.1
  rektifiering_1_N = mkN "rektifiering" ; -- rektifiering..nn.1
  rektifikation_1_N = mkN "rektifikation" ; -- rektifikation..nn.1
  rektion_1_N = mkN "rektion" ; -- rektion..nn.1
  rektor_1_N = mkN "rektor" "rektorer" ; -- rektor..nn.1
  rektorat_1_N = mkN "rektorat" neutrum  ; -- rektorat..nn.1
  rektorsexpedition_1_N = mkN "rektorsexpedition" ; -- rektorsexpedition..nn.1
  rektorsområde_1_N = mkN "rektorsområde" ; -- rektorsområde..nn.1
  rekurrens_1_N = mkN "rekurrens" "rekurrenser" ; -- rekurrens..nn.1
  rekurrensrelation_1_N = mkN "rekurrensrelation" ; -- rekurrensrelation..nn.1
  rekursion_1_N = mkN "rekursion" "rekursionar" ; -- rekursion..nn.1
  rekursiv_1_A = mkA "rekursiv" ; -- rekursiv..av.1
  rekursivitet_1_N = mkN "rekursivitet" ; -- rekursivitet..nn.1
  rekviem_1_N = mkN "rekviem" neutrum  ; -- rekviem..nn.1
  rekvirera_1_V = mkV "rekvirerar" ; -- rekvirera..vb.1
  rekvirerande_1_N = mkN "rekvirerande" ; -- rekvirerande..nn.1
  rekvirerbar_1_A = mkA "rekvirerbar" ; -- rekvirerbar..av.1
  rekvirerbarhet_1_N = mkN "rekvirerbarhet" ; -- rekvirerbarhet..nn.1
  rekvirering_1_N = mkN "rekvirering" ; -- rekvirering..nn.1
  rekvisit_1_N = mkN "rekvisit" neutrum  ; -- rekvisit..nn.1
  rekvisita_1_N = mkN "rekvisita" ; -- rekvisita..nn.1
  rekvisition_1_N = mkN "rekvisition" ; -- rekvisition..nn.1
  rekvisitör_1_N = mkN "rekvisitör" "rekvisitörer" ; -- rekvisitör..nn.1
  rekyl_1_N = mkN "rekyl" "rekyler" ; -- rekyl..nn.1
  rekylera_1_V = mkV "rekylerar" ; -- rekylera..vb.1
  rekylerande_1_N = mkN "rekylerande" ; -- rekylerande..nn.1
  rekylering_1_N = mkN "rekylering" ; -- rekylering..nn.1
  relatera_1_V = mkV "relaterar" ; -- relatera..vb.1
  relaterande_1_N = mkN "relaterande" ; -- relaterande..nn.1
  relaterbar_1_A = mkA "relaterbar" ; -- relaterbar..av.1
  relaterbarhet_1_N = mkN "relaterbarhet" ; -- relaterbarhet..nn.1
  relatering_1_N = mkN "relatering" ; -- relatering..nn.1
  relation_1_N = mkN "relation" ; -- relation..nn.1
  relationslös_1_A = mkA "relationslös" ; -- relationslös..av.1
  relationslöshet_1_N = mkN "relationslöshet" ; -- relationslöshet..nn.1
  relationsmässig_1_A = mkA "relationsmässig" ; -- relationsmässig..av.1
  relationspsykolog_1_N = mkN "relationspsykolog" "relationspsykologer" ; -- relationspsykolog..nn.1
  relationspsykologi_1_N = mkN "relationspsykologi" ; -- relationspsykologi..nn.1
  relationsråd_1_N = mkN "relationsråd" neutrum  ; -- relationsråd..nn.1
  relationstal_1_N = mkN "relationstal" neutrum  ; -- relationstal..nn.1
  relativ_1_A = mkA "relativ" ; -- relativ..av.1
  relativisera_1_V = mkV "relativiserar" ; -- relativisera..vb.1
  relativiserande_1_N = mkN "relativiserande" ; -- relativiserande..nn.1
  relativiserbar_1_A = mkA "relativiserbar" ; -- relativiserbar..av.1
  relativiserbarhet_1_N = mkN "relativiserbarhet" ; -- relativiserbarhet..nn.1
  relativisering_1_N = mkN "relativisering" ; -- relativisering..nn.1
  relativism_1_N = mkN "relativism" "relativismer" ; -- relativism..nn.1
  relativist_1_N = mkN "relativist" "relativister" ; -- relativist..nn.1
  relativistisk_1_A = mkA "relativistisk" ; -- relativistisk..av.1
  relativitet_1_N = mkN "relativitet" "relativiteter" ; -- relativitet..nn.1
  relativitetsteori_1_N = mkN "relativitetsteori" ; -- relativitetsteori..nn.1
  relativpronomen_1_N = mkN "relativpronomen" neutrum  ; -- relativpronomen..nn.1
  relativsats_1_N = mkN "relativsats" "relativsatser" ; -- relativsats..nn.1
  relaxa_1_V = mkV "relaxar" ; -- relaxa..vb.1
  relaxande_1_N = mkN "relaxande" ; -- relaxande..nn.1
  relaxation_1_N = mkN "relaxation" ; -- relaxation..nn.1
  release_1_N = mkN "release" "releaser" ; -- release..nn.1
  relegera_1_V = mkV "relegerar" ; -- relegera..vb.1
  relegerande_1_N = mkN "relegerande" ; -- relegerande..nn.1
  relegerbar_1_A = mkA "relegerbar" ; -- relegerbar..av.1
  relegerbarhet_1_N = mkN "relegerbarhet" ; -- relegerbarhet..nn.1
  relegering_1_N = mkN "relegering" ; -- relegering..nn.1
  relevans_1_N = mkN "relevans" ; -- relevans..nn.1
  relevant_1_A = mkA "relevant" "relevant" ; -- relevant..av.1
  reliabel_1_A = mkA "reliabel" ; -- reliabel..av.1
  reliabilitet_1_N = mkN "reliabilitet" "reliabiliteter" ; -- reliabilitet..nn.1
  relief_1_N = mkN "relief" "reliefer" ; -- relief..nn.1
  reliefartad_1_A = mkA "reliefartad" ; -- reliefartad..av.1
  religion_1_N = mkN "religion" ; -- religion..nn.1
  religionsfientlig_1_A = mkA "religionsfientlig" ; -- religionsfientlig..av.1
  religionsfilosofi_1_N = mkN "religionsfilosofi" "religionsfilosofier" ; -- religionsfilosofi..nn.1
  religionsfrihet_1_N = mkN "religionsfrihet" "religionsfriheter" ; -- religionsfrihet..nn.1
  religionsförföljelse_1_N = mkN "religionsförföljelse" "religionsförföljelser" ; -- religionsförföljelse..nn.1
  religionskritik_1_N = mkN "religionskritik" "religionskritiker" ; -- religionskritik..nn.1
  religionskritiker_1_N = mkN "religionskritiker" "religionskritikern" "religionskritiker" "religionskritikerna" ; -- religionskritiker..nn.1
  religionskritisk_1_A = mkA "religionskritisk" ; -- religionskritisk..av.1
  religionskunskap_1_N = mkN "religionskunskap" ; -- religionskunskap..nn.1
  religionslära_1_N = mkN "religionslära" ; -- religionslära..nn.1
  religionslös_1_A = mkA "religionslös" ; -- religionslös..av.1
  religionsstiftare_1_N = mkN "religionsstiftare" utrum  ; -- religionsstiftare..nn.1
  religionstillhörighet_1_N = mkN "religionstillhörighet" ; -- religionstillhörighet..nn.1
  religionsurkund_1_N = mkN "religionsurkund" "religionsurkunder" ; -- religionsurkund..nn.1
  religionsutövande_1_N = mkN "religionsutövande" ; -- religionsutövande..nn.1
  religionsutövning_1_N = mkN "religionsutövning" ; -- religionsutövning..nn.1
  religionsvetenskap_1_N = mkN "religionsvetenskap" "religionsvetenskaper" ; -- religionsvetenskap..nn.1
  religionsvetenskaplig_1_A = mkA "religionsvetenskaplig" ; -- religionsvetenskaplig..av.1
  religiositet_1_N = mkN "religiositet" "religiositeter" ; -- religiositet..nn.1
  religiös_1_A = mkA "religiös" ; -- religiös..av.1
  relik_1_N = mkN "relik" "reliker" ; -- relik..nn.1
  relikskrin_1_N = mkN "relikskrin" neutrum  ; -- relikskrin..nn.1
  relikt_1_N = mkN "relikt" "relikter" ; -- relikt..nn.1
  reling_1_N = mkN "reling" ; -- reling..nn.1
  relingsmanning_1_N = mkN "relingsmanning" ; -- relingsmanning..nn.1
  relä_1_N = mkN "relä" "reläet" "reläer" "reläerna" ; -- relä..nn.1
  reläa_1_V = mkV "reläar" ; -- reläa..vb.1
  reläande_1_N = mkN "reläande" ; -- reläande..nn.1
  relästation_1_N = mkN "relästation" ; -- relästation..nn.1
  rem_1_N = mkN "rem" "remmen" "remmar" "remmarna" ; -- rem..nn.1
  rem_2_N = mkN "rem" "remen" "rem" "remen" ; -- rem..nn.2
  remanens_1_N = mkN "remanens" ; -- remanens..nn.1
  remarkabel_1_A = mkA "remarkabel" ; -- remarkabel..av.1
  rembours_1_N = mkN "rembours" "rembourser" ; -- rembours..nn.1
  rembrandt_1_N = mkN "rembrandt" "rembrandter" ; -- rembrandt..nn.1
  remburs_1_N = mkN "remburs" "remburser" ; -- remburs..nn.1
  remedium_1_N = mkN "remedium" "remediet" "remedier" "remedierna" ; -- remedium..nn.1
  remi_1_N = mkN "remi" "remier" ; -- remi..nn.1
  remingtongevär_1_N = mkN "remingtongevär" neutrum  ; -- remingtongevär..nn.1
  reminiscens_1_N = mkN "reminiscens" "reminiscenser" ; -- reminiscens..nn.1
  remis_1_N = mkN "remis" ; -- remis..nn.1
  remis_2_N = mkN "remis" "remiser" ; -- remis..nn.2
  remiss_1_N = mkN "remiss" "remisser" ; -- remiss..nn.1
  remissa_1_N = mkN "remissa" ; -- remissa..nn.1
  remissbehandla_1_V = mkV "remissbehandlar" ; -- remissbehandla..vb.1
  remissbehandlande_1_N = mkN "remissbehandlande" ; -- remissbehandlande..nn.1
  remissbehandling_1_N = mkN "remissbehandling" ; -- remissbehandling..nn.1
  remissdebatt_1_N = mkN "remissdebatt" "remissdebatter" ; -- remissdebatt..nn.1
  remisshandling_1_N = mkN "remisshandling" ; -- remisshandling..nn.1
  remissinstans_1_N = mkN "remissinstans" "remissinstanser" ; -- remissinstans..nn.1
  remissvar_1_N = mkN "remissvar" neutrum  ; -- remissvar..nn.1
  remissyttrande_1_N = mkN "remissyttrande" ; -- remissyttrande..nn.1
  remittent_1_A = mkA "remittent" "remittent" ; -- remittent..av.1
  remittent_1_N = mkN "remittent" "remittenter" ; -- remittent..nn.1
  remittera_1_V = mkV "remitterar" ; -- remittera..vb.1
  remitterande_1_N = mkN "remitterande" ; -- remitterande..nn.1
  remitterbar_1_A = mkA "remitterbar" ; -- remitterbar..av.1
  remitterbarhet_1_N = mkN "remitterbarhet" ; -- remitterbarhet..nn.1
  remittering_1_N = mkN "remittering" ; -- remittering..nn.1
  remma_1_V = mkV "remmar" ; -- remma..vb.1
  remma_2_V = mkV "remmar" ; -- remma..vb.2
  remmande_1_N = mkN "remmande" ; -- remmande..nn.1
  remmare_1_N = mkN "remmare" utrum  ; -- remmare..nn.1
  remont_1_N = mkN "remont" "remonter" ; -- remont..nn.1
  remontantros_1_N = mkN "remontantros" "remontantrosor" ; -- remontantros..nn.1
  remontera_1_V = mkV "remonterar" ; -- remontera..vb.1
  remonterande_1_N = mkN "remonterande" ; -- remonterande..nn.1
  remontering_1_N = mkN "remontering" ; -- remontering..nn.1
  remouladsås_1_N = mkN "remouladsås" "remouladsåser" ; -- remouladsås..nn.1
  remplacera_1_V = mkV "remplacerar" ; -- remplacera..vb.1
  remplacerande_1_N = mkN "remplacerande" ; -- remplacerande..nn.1
  remplacerbar_1_A = mkA "remplacerbar" ; -- remplacerbar..av.1
  remplacerbarhet_1_N = mkN "remplacerbarhet" ; -- remplacerbarhet..nn.1
  remplacering_1_N = mkN "remplacering" ; -- remplacering..nn.1
  remsa_1_N = mkN "remsa" ; -- remsa..nn.1
  remtyg_1_N = mkN "remtyg" neutrum  ; -- remtyg..nn.1
  remuladsås_1_N = mkN "remuladsås" "remuladsåser" ; -- remuladsås..nn.1
  ren_1_A = mkA "ren" ; -- ren..av.1
  ren_1_N = mkN "ren" "renen" "renar" "renarna" ; -- ren..nn.1
  rena_1_V = mkV "renar" ; -- rena..vb.1
  renande_1_N = mkN "renande" ; -- renande..nn.1
  renat_1_N = mkN "renat" ; -- renat..nn.1
  renben_1_N = mkN "renben" neutrum  ; -- renben..nn.1
  renbete_1_N = mkN "renbete" ; -- renbete..nn.1
  rendera_1_V = mkV "renderar" ; -- rendera..vb.1
  renderande_1_N = mkN "renderande" ; -- renderande..nn.1
  renderbar_1_A = mkA "renderbar" ; -- renderbar..av.1
  renderbarhet_1_N = mkN "renderbarhet" ; -- renderbarhet..nn.1
  rendering_1_N = mkN "rendering" ; -- rendering..nn.1
  rendezvous_1_N = mkN "rendezvous" "rendezvouset" "rendezvouser" "rendezvouserna" ; -- rendezvous..nn.1
  rendrift_1_N = mkN "rendrift" ; -- rendrift..nn.1
  renegat_1_N = mkN "renegat" "renegater" ; -- renegat..nn.1
  renfana_1_N = mkN "renfana" ; -- renfana..nn.1
  renfäll_1_N = mkN "renfäll" ; -- renfäll..nn.1
  rengöra_1_V = mkV "rengöra" "rengjorde" "rengjort" ; -- rengöra..vb.1
  rengörande_1_N = mkN "rengörande" ; -- rengörande..nn.1
  rengöring_1_N = mkN "rengöring" ; -- rengöring..nn.1
  rengöringsduk_1_N = mkN "rengöringsduk" ; -- rengöringsduk..nn.1
  rengöringsmedel_1_N = mkN "rengöringsmedel" neutrum  ; -- rengöringsmedel..nn.1
  rengöringssats_1_N = mkN "rengöringssats" "rengöringssatser" ; -- rengöringssats..nn.1
  rengöringssnöre_1_N = mkN "rengöringssnöre" ; -- rengöringssnöre..nn.1
  renhet_1_N = mkN "renhet" "renheter" ; -- renhet..nn.1
  renhetsdröm_1_N = mkN "renhetsdröm" "renhetsdrömmen" "renhetsdrömmar" "renhetsdrömmarna" ; -- renhetsdröm..nn.1
  renhjord_1_N = mkN "renhjord" ; -- renhjord..nn.1
  renhjärta_1_N = mkN "renhjärta" "renhjärtat" "renhjärtan" "renhjärtana" ; -- renhjärta..nn.1
  renhjärtad_1_A = mkA "renhjärtad" ; -- renhjärtad..av.1
  renhjärtadhet_1_N = mkN "renhjärtadhet" ; -- renhjärtadhet..nn.1
  renhjärtenhet_1_N = mkN "renhjärtenhet" ; -- renhjärtenhet..nn.1
  renhorn_1_N = mkN "renhorn" neutrum  ; -- renhorn..nn.1
  renhållning_1_N = mkN "renhållning" ; -- renhållning..nn.1
  renhållningsgubbe_1_N = mkN "renhållningsgubbe" utrum  ; -- renhållningsgubbe..nn.1
  renhållningsmyndighet_1_N = mkN "renhållningsmyndighet" "renhållningsmyndigheter" ; -- renhållningsmyndighet..nn.1
  renhårig_1_A = mkA "renhårig" ; -- renhårig..av.1
  renhårighet_1_N = mkN "renhårighet" ; -- renhårighet..nn.1
  rening_1_N = mkN "rening" ; -- rening..nn.1
  reningsverk_1_N = mkN "reningsverk" neutrum  ; -- reningsverk..nn.1
  renjakt_1_N = mkN "renjakt" "renjakter" ; -- renjakt..nn.1
  renjägare_1_N = mkN "renjägare" utrum  ; -- renjägare..nn.1
  renko_1_N = mkN "renko" "renkor" ; -- renko..nn.1
  renkonter_1_N = mkN "renkonter" "renkontern" "renkontrer" "renkontrerna" ; -- renkonter..nn.1
  renkonterstrid_1_N = mkN "renkonterstrid" "renkonterstrider" ; -- renkonterstrid..nn.1
  renkött_1_N = mkN "renkött" neutrum  ; -- renkött..nn.1
  renlav_1_N = mkN "renlav" ; -- renlav..nn.1
  renlevnad_1_N = mkN "renlevnad" "renlevnader" ; -- renlevnad..nn.1
  renlevnadskrav_1_N = mkN "renlevnadskrav" neutrum  ; -- renlevnadskrav..nn.1
  renlevnadsman_1_N = mkN "renlevnadsman" "renlevnadsmannen" "renlevnadsmän" "renlevnadsmännen" ; -- renlevnadsman..nn.1
  renlig_1_A = mkA "renlig" ; -- renlig..av.1
  renlighet_1_N = mkN "renlighet" "renligheter" ; -- renlighet..nn.1
  renlärig_1_A = mkA "renlärig" ; -- renlärig..av.1
  renlärighet_1_N = mkN "renlärighet" "renlärigheter" ; -- renlärighet..nn.1
  renlärighetsiver_1_N = mkN "renlärighetsiver" ; -- renlärighetsiver..nn.1
  renmage_1_N = mkN "renmage" utrum  ; -- renmage..nn.1
  renmärke_1_N = mkN "renmärke" ; -- renmärke..nn.1
  renodla_1_V = mkV "renodlar" ; -- renodla..vb.1
  renodlande_1_N = mkN "renodlande" ; -- renodlande..nn.1
  renodling_1_N = mkN "renodling" ; -- renodling..nn.1
  renommerad_1_A = mkA "renommerad" ; -- renommerad..av.1
  renommé_1_N = mkN "renommé" neutrum  ; -- renommé..nn.1
  renons_1_A = mkA "renons" ; -- renons..av.1
  renovation_1_N = mkN "renovation" ; -- renovation..nn.1
  renovera_1_V = mkV "renoverar" ; -- renovera..vb.1
  renoverande_1_N = mkN "renoverande" ; -- renoverande..nn.1
  renoverbar_1_A = mkA "renoverbar" ; -- renoverbar..av.1
  renoverbarhet_1_N = mkN "renoverbarhet" ; -- renoverbarhet..nn.1
  renovering_1_N = mkN "renovering" ; -- renovering..nn.1
  renoveringsarbete_1_N = mkN "renoveringsarbete" ; -- renoveringsarbete..nn.1
  renoveringsbehov_1_N = mkN "renoveringsbehov" neutrum  ; -- renoveringsbehov..nn.1
  renoxe_1_N = mkN "renoxe" utrum  ; -- renoxe..nn.1
  renraka_1_V = mkV "renrakar" ; -- renraka..vb.1
  renrakande_1_N = mkN "renrakande" ; -- renrakande..nn.1
  renrasig_1_A = mkA "renrasig" ; -- renrasig..av.1
  renrasighet_1_N = mkN "renrasighet" ; -- renrasighet..nn.1
  rensa_1_V = mkV "rensar" ; -- rensa..vb.1
  rensande_1_N = mkN "rensande" ; -- rensande..nn.1
  rensbar_1_A = mkA "rensbar" ; -- rensbar..av.1
  rensbarhet_1_N = mkN "rensbarhet" ; -- rensbarhet..nn.1
  renseri_1_N = mkN "renseri" "renseriet" "renserier" "renserierna" ; -- renseri..nn.1
  renskav_1_N = mkN "renskav" ; -- renskav..nn.1
  renskiljning_1_N = mkN "renskiljning" ; -- renskiljning..nn.1
  renskinn_1_N = mkN "renskinn" neutrum  ; -- renskinn..nn.1
  renskinnspäls_1_N = mkN "renskinnspäls" ; -- renskinnspäls..nn.1
  renskrift_1_N = mkN "renskrift" "renskrifter" ; -- renskrift..nn.1
  renskriva_1_V = mkV "renskriva" "renskrev" "renskrivit" ; -- renskriva..vb.1
  renskrivande_1_N = mkN "renskrivande" ; -- renskrivande..nn.1
  renskrivning_1_N = mkN "renskrivning" ; -- renskrivning..nn.1
  renskötande_1_A = mkA "renskötande" ; -- renskötande..av.1
  renskötare_1_N = mkN "renskötare" utrum  ; -- renskötare..nn.1
  renskötsel_1_N = mkN "renskötsel" ; -- renskötsel..nn.1
  renslucka_1_N = mkN "renslucka" ; -- renslucka..nn.1
  rensning_1_N = mkN "rensning" ; -- rensning..nn.1
  rensningsnål_1_N = mkN "rensningsnål" ; -- rensningsnål..nn.1
  rensopad_1_A = mkA "rensopad" ; -- rensopad..av.1
  renspolad_1_A = mkA "renspolad" ; -- renspolad..av.1
  rensrör_1_N = mkN "rensrör" neutrum  ; -- rensrör..nn.1
  renstek_1_N = mkN "renstek" ; -- renstek..nn.1
  renstratt_1_N = mkN "renstratt" ; -- renstratt..nn.1
  renstyngsfluga_1_N = mkN "renstyngsfluga" ; -- renstyngsfluga..nn.1
  rentarm_1_N = mkN "rentarm" ; -- rentarm..nn.1
  rentav_1_Adv = mkAdv "rentav" ; -- rentav..ab.1
  rentier_1_N = mkN "rentier" "rentierer" ; -- rentier..nn.1
  rentjur_1_N = mkN "rentjur" ; -- rentjur..nn.1
  rentjé_1_N = mkN "rentjé" "rentjéer" ; -- rentjé..nn.1
  rentré_1_N = mkN "rentré" "rentréer" ; -- rentré..nn.1
  rentut_1_Adv = mkAdv "rentut" ; -- rentut..ab.1
  rentutav_1_Adv = mkAdv "rentutav" ; -- rentutav..ab.1
  rentvå_1_V = mkV "rentvår" ; -- rentvå..vb.1
  rentvående_1_N = mkN "rentvående" ; -- rentvående..nn.1
  renässans_1_N = mkN "renässans" "renässanser" ; -- renässans..nn.1
  renässansarkitektur_1_N = mkN "renässansarkitektur" "renässansarkitekturer" ; -- renässansarkitektur..nn.1
  renässanskonst_1_N = mkN "renässanskonst" "renässanskonster" ; -- renässanskonst..nn.1
  renässansmänniska_1_N = mkN "renässansmänniska" ; -- renässansmänniska..nn.1
  renässanspalats_1_N = mkN "renässanspalats" neutrum  ; -- renässanspalats..nn.1
  reol_1_N = mkN "reol" "reoler" ; -- reol..nn.1
  reologi_1_N = mkN "reologi" ; -- reologi..nn.1
  reorganisation_1_N = mkN "reorganisation" ; -- reorganisation..nn.1
  reorganisera_1_V = mkV "reorganiserar" ; -- reorganisera..vb.1
  reorganiserande_1_N = mkN "reorganiserande" ; -- reorganiserande..nn.1
  reorganiserbar_1_A = mkA "reorganiserbar" ; -- reorganiserbar..av.1
  reorganiserbarhet_1_N = mkN "reorganiserbarhet" ; -- reorganiserbarhet..nn.1
  reorganisering_1_N = mkN "reorganisering" ; -- reorganisering..nn.1
  reostat_1_N = mkN "reostat" "reostater" ; -- reostat..nn.1
  rep_1_N = mkN "rep" neutrum  ; -- rep..nn.1
  repa_1_N = mkN "repa" ; -- repa..nn.1
  repa_1_V = mkV "repar" ; -- repa..vb.1
  repande_1_N = mkN "repande" ; -- repande..nn.1
  reparabel_1_A = mkA "reparabel" ; -- reparabel..av.1
  reparation_1_N = mkN "reparation" ; -- reparation..nn.1
  reparatör_1_N = mkN "reparatör" "reparatörer" ; -- reparatör..nn.1
  reparera_1_V = mkV "reparerar" ; -- reparera..vb.1
  reparerande_1_N = mkN "reparerande" ; -- reparerande..nn.1
  reparerbar_1_A = mkA "reparerbar" ; -- reparerbar..av.1
  reparerbarhet_1_N = mkN "reparerbarhet" ; -- reparerbarhet..nn.1
  reparering_1_N = mkN "reparering" ; -- reparering..nn.1
  repartisera_1_V = mkV "repartiserar" ; -- repartisera..vb.1
  repartiserande_1_N = mkN "repartiserande" ; -- repartiserande..nn.1
  repartiserbar_1_A = mkA "repartiserbar" ; -- repartiserbar..av.1
  repartiserbarhet_1_N = mkN "repartiserbarhet" ; -- repartiserbarhet..nn.1
  repartisering_1_N = mkN "repartisering" ; -- repartisering..nn.1
  repartition_1_N = mkN "repartition" ; -- repartition..nn.1
  repatriera_1_V = mkV "repatrierar" ; -- repatriera..vb.1
  repatrierande_1_N = mkN "repatrierande" ; -- repatrierande..nn.1
  repatrierbar_1_A = mkA "repatrierbar" ; -- repatrierbar..av.1
  repatrierbarhet_1_N = mkN "repatrierbarhet" ; -- repatrierbarhet..nn.1
  repatriering_1_N = mkN "repatriering" ; -- repatriering..nn.1
  repborttagare_1_N = mkN "repborttagare" utrum  ; -- repborttagare..nn.1
  repe_1_N = mkN "repe" ; -- repe..nn.1
  repellera_1_V = mkV "repellerar" ; -- repellera..vb.1
  repellerande_1_N = mkN "repellerande" ; -- repellerande..nn.1
  repellerbar_1_A = mkA "repellerbar" ; -- repellerbar..av.1
  repellerbarhet_1_N = mkN "repellerbarhet" ; -- repellerbarhet..nn.1
  repellering_1_N = mkN "repellering" ; -- repellering..nn.1
  repertoar_1_N = mkN "repertoar" "repertoarer" ; -- repertoar..nn.1
  repertoarmässig_1_A = mkA "repertoarmässig" ; -- repertoarmässig..av.1
  repeter_1_N = mkN "repeter" ; -- repeter..nn.1
  repetera_1_V = mkV "repeterar" ; -- repetera..vb.1
  repeterande_1_N = mkN "repeterande" ; -- repeterande..nn.1
  repeterbar_1_A = mkA "repeterbar" ; -- repeterbar..av.1
  repeterbarhet_1_N = mkN "repeterbarhet" ; -- repeterbarhet..nn.1
  repetergevär_1_N = mkN "repetergevär" neutrum  ; -- repetergevär..nn.1
  repetering_1_N = mkN "repetering" ; -- repetering..nn.1
  repetition_1_N = mkN "repetition" ; -- repetition..nn.1
  repetitionslokal_1_N = mkN "repetitionslokal" "repetitionslokaler" ; -- repetitionslokal..nn.1
  repetitionsövning_1_N = mkN "repetitionsövning" ; -- repetitionsövning..nn.1
  repetitiv_1_A = mkA "repetitiv" ; -- repetitiv..av.1
  repetitorium_1_N = mkN "repetitorium" "repetitoriet" "repetitorier" "repetitorierna" ; -- repetitorium..nn.1
  repetitör_1_N = mkN "repetitör" "repetitörer" ; -- repetitör..nn.1
  rephoppande_1_N = mkN "rephoppande" ; -- rephoppande..nn.1
  rephoppning_1_N = mkN "rephoppning" ; -- rephoppning..nn.1
  repig_1_A = mkA "repig" ; -- repig..av.1
  repliera_1_V = mkV "replierar" ; -- repliera..vb.1
  replierande_1_N = mkN "replierande" ; -- replierande..nn.1
  repliering_1_N = mkN "repliering" ; -- repliering..nn.1
  replik_1_N = mkN "replik" "repliker" ; -- replik..nn.1
  replikera_1_V = mkV "replikerar" ; -- replikera..vb.1
  replikerande_1_N = mkN "replikerande" ; -- replikerande..nn.1
  replikering_1_N = mkN "replikering" ; -- replikering..nn.1
  replikskifte_1_N = mkN "replikskifte" ; -- replikskifte..nn.1
  replikväxling_1_N = mkN "replikväxling" ; -- replikväxling..nn.1
  replipunkt_1_N = mkN "replipunkt" "replipunkter" ; -- replipunkt..nn.1
  replokal_1_N = mkN "replokal" "replokaler" ; -- replokal..nn.1
  repmånad_1_N = mkN "repmånad" "repmånader" ; -- repmånad..nn.1
  reportage_1_N = mkN "reportage" "reportaget" "reportage" "reportagen" ; -- reportage..nn.1
  reportagebok_1_N = mkN "reportagebok" "reportageböcker" ; -- reportagebok..nn.1
  reportagemässig_1_A = mkA "reportagemässig" ; -- reportagemässig..av.1
  reporter_1_N = mkN "reporter" ; -- reporter..nn.1
  reporterlegend_1_N = mkN "reporterlegend" "reporterlegender" ; -- reporterlegend..nn.1
  reporänta_1_N = mkN "reporänta" ; -- reporänta..nn.1
  representant_1_N = mkN "representant" "representanter" ; -- representant..nn.1
  representantförsamling_1_N = mkN "representantförsamling" ; -- representantförsamling..nn.1
  representanthus_1_N = mkN "representanthus" neutrum  ; -- representanthus..nn.1
  representation_1_N = mkN "representation" ; -- representation..nn.1
  representation_2_N = mkN "representation" ; -- representation..nn.2
  representationskostnad_1_N = mkN "representationskostnad" "representationskostnader" ; -- representationskostnad..nn.1
  representationsreform_1_N = mkN "representationsreform" "representationsreformer" ; -- representationsreform..nn.1
  representativ_1_A = mkA "representativ" ; -- representativ..av.1
  representera_1_V = mkV "representerar" ; -- representera..vb.1
  representera_2_V = mkV "representerar" ; -- representera..vb.2
  representerande_1_N = mkN "representerande" ; -- representerande..nn.1
  representerbar_1_A = mkA "representerbar" ; -- representerbar..av.1
  representerbarhet_1_N = mkN "representerbarhet" ; -- representerbarhet..nn.1
  representering_1_N = mkN "representering" ; -- representering..nn.1
  repressalie_1_N = mkN "repressalie" "repressalier" ; -- repressalie..nn.1
  repressalieåtgärd_1_N = mkN "repressalieåtgärd" "repressalieåtgärder" ; -- repressalieåtgärd..nn.1
  repression_1_N = mkN "repression" ; -- repression..nn.1
  repressiv_1_A = mkA "repressiv" ; -- repressiv..av.1
  reprimand_1_N = mkN "reprimand" "reprimander" ; -- reprimand..nn.1
  repris_1_N = mkN "repris" "repriser" ; -- repris..nn.1
  reprisera_1_V = mkV "repriserar" ; -- reprisera..vb.1
  repriserande_1_N = mkN "repriserande" ; -- repriserande..nn.1
  repriserbar_1_A = mkA "repriserbar" ; -- repriserbar..av.1
  repriserbarhet_1_N = mkN "repriserbarhet" ; -- repriserbarhet..nn.1
  reprisering_1_N = mkN "reprisering" ; -- reprisering..nn.1
  repristecken_1_N = mkN "repristecken" "repristecknet" "repristecken" "repristecknen" ; -- repristecken..nn.1
  reproducera_1_V = mkV "reproducerar" ; -- reproducera..vb.1
  reproducerande_1_N = mkN "reproducerande" ; -- reproducerande..nn.1
  reproducerbar_1_A = mkA "reproducerbar" ; -- reproducerbar..av.1
  reproducerbarhet_1_N = mkN "reproducerbarhet" ; -- reproducerbarhet..nn.1
  reproducering_1_N = mkN "reproducering" ; -- reproducering..nn.1
  reproducering_2_N = mkN "reproducering" ; -- reproducering..nn.2
  reproduktion_1_N = mkN "reproduktion" ; -- reproduktion..nn.1
  reproduktionsförmåga_1_N = mkN "reproduktionsförmåga" ; -- reproduktionsförmåga..nn.1
  reproduktionsorgan_1_N = mkN "reproduktionsorgan" neutrum  ; -- reproduktionsorgan..nn.1
  reproduktiv_1_A = mkA "reproduktiv" ; -- reproduktiv..av.1
  reprografi_1_N = mkN "reprografi" ; -- reprografi..nn.1
  repslagare_1_N = mkN "repslagare" utrum  ; -- repslagare..nn.1
  repstege_1_N = mkN "repstege" utrum  ; -- repstege..nn.1
  reptil_1_N = mkN "reptil" "reptiler" ; -- reptil..nn.1
  reptilhjärna_1_N = mkN "reptilhjärna" ; -- reptilhjärna..nn.1
  reptilliknande_1_A = mkA "reptilliknande" ; -- reptilliknande..av.1
  reptilsnabb_1_A = mkA "reptilsnabb" ; -- reptilsnabb..av.1
  reptrick_1_N = mkN "reptrick" neutrum  ; -- reptrick..nn.1
  republik_1_N = mkN "republik" "republiker" ; -- republik..nn.1
  republikan_1_N = mkN "republikan" "republikaner" ; -- republikan..nn.1
  republikanism_1_N = mkN "republikanism" ; -- republikanism..nn.1
  republikansk_1_A = mkA "republikansk" ; -- republikansk..av.1
  repulsion_1_N = mkN "repulsion" ; -- repulsion..nn.1
  repulsiv_1_A = mkA "repulsiv" ; -- repulsiv..av.1
  reputation_1_N = mkN "reputation" ; -- reputation..nn.1
  reputerlig_1_A = mkA "reputerlig" ; -- reputerlig..av.1
  reputerlighet_1_N = mkN "reputerlighet" ; -- reputerlighet..nn.1
  repända_1_N = mkN "repända" ; -- repända..nn.1
  repände_1_N = mkN "repände" utrum  ; -- repände..nn.1
  repövning_1_N = mkN "repövning" ; -- repövning..nn.1
  resa_1_N = mkN "resa" ; -- resa..nn.1
  resa_1_V = mkV "reser" ; -- resa..vb.1
  resa_2_V = mkV "reser" ; -- resa..vb.2
  resande_1_N = mkN "resande" "resanden" "resanden" "resandena" ; -- resande..nn.1
  resande_2_N = mkN "resande" ; -- resande..nn.2
  resande_3_N = mkN "resande" ; -- resande..nn.3
  resandebok_1_N = mkN "resandebok" "resandeböcker" ; -- resandebok..nn.1
  rese_1_N = mkN "rese" utrum  ; -- rese..nn.1
  reseapotek_1_N = mkN "reseapotek" neutrum  ; -- reseapotek..nn.1
  research_1_N = mkN "research" "researcher" ; -- research..nn.1
  researcher_1_N = mkN "researcher" "researchern" "researchers" "researchersen" ; -- researcher..nn.1
  researrangemang_1_N = mkN "researrangemang" neutrum  ; -- researrangemang..nn.1
  researrangör_1_N = mkN "researrangör" "researrangörer" ; -- researrangör..nn.1
  resebadkar_1_N = mkN "resebadkar" neutrum  ; -- resebadkar..nn.1
  resebeskrivning_1_N = mkN "resebeskrivning" ; -- resebeskrivning..nn.1
  resebiljett_1_N = mkN "resebiljett" "resebiljetter" ; -- resebiljett..nn.1
  resebyrå_1_N = mkN "resebyrå" "resebyråer" ; -- resebyrå..nn.1
  resecheck_1_N = mkN "resecheck" ; -- resecheck..nn.1
  reseda_1_N = mkN "reseda" ; -- reseda..nn.1
  reseförbud_1_N = mkN "reseförbud" neutrum  ; -- reseförbud..nn.1
  resegarderob_1_N = mkN "resegarderob" "resegarderober" ; -- resegarderob..nn.1
  resegrammofon_1_N = mkN "resegrammofon" "resegrammofoner" ; -- resegrammofon..nn.1
  reseguide_1_N = mkN "reseguide" "reseguider" ; -- reseguide..nn.1
  resehandbok_1_N = mkN "resehandbok" "resehandböcker" ; -- resehandbok..nn.1
  resejournalistik_1_N = mkN "resejournalistik" ; -- resejournalistik..nn.1
  resekreditiv_1_N = mkN "resekreditiv" neutrum  ; -- resekreditiv..nn.1
  resektion_1_N = mkN "resektion" ; -- resektion..nn.1
  reseledare_1_N = mkN "reseledare" utrum  ; -- reseledare..nn.1
  resemugg_1_N = mkN "resemugg" ; -- resemugg..nn.1
  resenär_1_N = mkN "resenär" "resenärer" ; -- resenär..nn.1
  resereportage_1_N = mkN "resereportage" "resereportaget" "resereportage" "resereportagen" ; -- resereportage..nn.1
  reserv_1_N = mkN "reserv" "reserver" ; -- reserv..nn.1
  reservant_1_N = mkN "reservant" "reservanter" ; -- reservant..nn.1
  reservare_1_N = mkN "reservare" utrum  ; -- reservare..nn.1
  reservat_1_N = mkN "reservat" neutrum  ; -- reservat..nn.1
  reservation_1_N = mkN "reservation" ; -- reservation..nn.1
  reservationsanslag_1_N = mkN "reservationsanslag" neutrum  ; -- reservationsanslag..nn.1
  reservationslös_1_A = mkA "reservationslös" ; -- reservationslös..av.1
  reservationslöshet_1_N = mkN "reservationslöshet" "reservationslösheter" ; -- reservationslöshet..nn.1
  reservdel_1_N = mkN "reservdel" "reservdelen" "reservdelar" "reservdelarna" ; -- reservdel..nn.1
  reservera_1_V = mkV "reserverar" ; -- reservera..vb.1
  reserverad_1_A = mkA "reserverad" ; -- reserverad..av.1
  reserverande_1_N = mkN "reserverande" ; -- reserverande..nn.1
  reserverbar_1_A = mkA "reserverbar" ; -- reserverbar..av.1
  reserverbarhet_1_N = mkN "reserverbarhet" ; -- reserverbarhet..nn.1
  reservering_1_N = mkN "reservering" ; -- reservering..nn.1
  reservfond_1_N = mkN "reservfond" "reservfonder" ; -- reservfond..nn.1
  reservkapital_1_N = mkN "reservkapital" neutrum  ; -- reservkapital..nn.1
  reservlager_1_N = mkN "reservlager" neutrum  ; -- reservlager..nn.1
  reservnäring_1_N = mkN "reservnäring" ; -- reservnäring..nn.1
  reservoar_1_N = mkN "reservoar" "reservoarer" ; -- reservoar..nn.1
  reservoarpenna_1_N = mkN "reservoarpenna" ; -- reservoarpenna..nn.1
  reservofficer_1_N = mkN "reservofficer" "reservofficeren" "reservofficerare" "reservofficerarna" ; -- reservofficer..nn.1
  reservpappa_1_N = mkN "reservpappa" ; -- reservpappa..nn.1
  reservskärm_1_N = mkN "reservskärm" ; -- reservskärm..nn.1
  reservspelare_1_N = mkN "reservspelare" utrum  ; -- reservspelare..nn.1
  reseräkning_1_N = mkN "reseräkning" ; -- reseräkning..nn.1
  reseskildrare_1_N = mkN "reseskildrare" utrum  ; -- reseskildrare..nn.1
  reseskildring_1_N = mkN "reseskildring" ; -- reseskildring..nn.1
  reseskrivmaskin_1_N = mkN "reseskrivmaskin" "reseskrivmaskiner" ; -- reseskrivmaskin..nn.1
  resestipendium_1_N = mkN "resestipendium" "resestipendiet" "resestipendier" "resestipendierna" ; -- resestipendium..nn.1
  resesökmotor_1_N = mkN "resesökmotor" "resesökmotorer" ; -- resesökmotor..nn.1
  resetillbehör_1_N = mkN "resetillbehör" neutrum  ; -- resetillbehör..nn.1
  resfeber_1_N = mkN "resfeber" ; -- resfeber..nn.1
  resfärdig_1_A = mkA "resfärdig" ; -- resfärdig..av.1
  resgods_1_N = mkN "resgods" neutrum  ; -- resgods..nn.1
  resguide_1_N = mkN "resguide" "resguider" ; -- resguide..nn.1
  residens_1_N = mkN "residens" neutrum  ; -- residens..nn.1
  residensstad_1_N = mkN "residensstad" "residensstäder" ; -- residensstad..nn.1
  residera_1_V = mkV "residerar" ; -- residera..vb.1
  residerande_1_N = mkN "residerande" ; -- residerande..nn.1
  residuum_1_N = mkN "residuum" "residuet" "residua" "residuana" ; -- residuum..nn.1
  resignation_1_N = mkN "resignation" ; -- resignation..nn.1
  resignera_1_V = mkV "resignerar" ; -- resignera..vb.1
  resignerad_1_A = mkA "resignerad" ; -- resignerad..av.1
  resignerande_1_N = mkN "resignerande" ; -- resignerande..nn.1
  resignering_1_N = mkN "resignering" ; -- resignering..nn.1
  resistans_1_N = mkN "resistans" ; -- resistans..nn.1
  resistens_1_N = mkN "resistens" ; -- resistens..nn.1
  resistensområde_1_N = mkN "resistensområde" ; -- resistensområde..nn.1
  resistent_1_A = mkA "resistent" "resistent" ; -- resistent..av.1
  resistenthet_1_N = mkN "resistenthet" ; -- resistenthet..nn.1
  resistivitet_1_N = mkN "resistivitet" "resistiviteter" ; -- resistivitet..nn.1
  resistor_1_N = mkN "resistor" "resistorer" ; -- resistor..nn.1
  reskamrat_1_N = mkN "reskamrat" "reskamrater" ; -- reskamrat..nn.1
  reskaos_1_N = mkN "reskaos" neutrum  ; -- reskaos..nn.1
  resklar_1_A = mkA "resklar" ; -- resklar..av.1
  resklass_1_N = mkN "resklass" "resklasser" ; -- resklass..nn.1
  reskontra_1_N = mkN "reskontra" ; -- reskontra..nn.1
  reskript_1_N = mkN "reskript" neutrum  ; -- reskript..nn.1
  reslig_1_A = mkA "reslig" ; -- reslig..av.1
  reslighet_1_N = mkN "reslighet" ; -- reslighet..nn.1
  resmål_1_N = mkN "resmål" neutrum  ; -- resmål..nn.1
  resning_1_N = mkN "resning" ; -- resning..nn.1
  resningsbeslut_1_N = mkN "resningsbeslut" neutrum  ; -- resningsbeslut..nn.1
  resningsärende_1_N = mkN "resningsärende" ; -- resningsärende..nn.1
  resolut_1_A = mkA "resolut" "resolut" ; -- resolut..av.1
  resoluthet_1_N = mkN "resoluthet" ; -- resoluthet..nn.1
  resolution_1_N = mkN "resolution" ; -- resolution..nn.1
  resolutionsförslag_1_N = mkN "resolutionsförslag" neutrum  ; -- resolutionsförslag..nn.1
  resolvera_1_V = mkV "resolverar" ; -- resolvera..vb.1
  resolverande_1_N = mkN "resolverande" ; -- resolverande..nn.1
  resolverbar_1_A = mkA "resolverbar" ; -- resolverbar..av.1
  resolverbarhet_1_N = mkN "resolverbarhet" ; -- resolverbarhet..nn.1
  resolvering_1_N = mkN "resolvering" ; -- resolvering..nn.1
  reson_1_N = mkN "reson" ; -- reson..nn.1
  resonabel_1_A = mkA "resonabel" ; -- resonabel..av.1
  resonans_1_N = mkN "resonans" ; -- resonans..nn.1
  resonansbotten_1_N = mkN "resonansbotten" ; -- resonansbotten..nn.1
  resonanshåla_1_N = mkN "resonanshåla" ; -- resonanshåla..nn.1
  resonanslåda_1_N = mkN "resonanslåda" ; -- resonanslåda..nn.1
  resonemang_1_N = mkN "resonemang" neutrum  ; -- resonemang..nn.1
  resonemangskarusell_1_N = mkN "resonemangskarusell" "resonemangskaruseller" ; -- resonemangskarusell..nn.1
  resonemangsparti_1_N = mkN "resonemangsparti" "resonemangspartiet" "resonemangspartier" "resonemangspartierna" ; -- resonemangsparti..nn.1
  resonemangsäktenskap_1_N = mkN "resonemangsäktenskap" neutrum  ; -- resonemangsäktenskap..nn.1
  resonera_1_V = mkV "resonerar" ; -- resonera..vb.1
  resonerande_1_N = mkN "resonerande" ; -- resonerande..nn.1
  resonering_1_N = mkN "resonering" ; -- resonering..nn.1
  resonlig_1_A = mkA "resonlig" ; -- resonlig..av.1
  resonlighet_1_N = mkN "resonlighet" ; -- resonlighet..nn.1
  resonör_1_N = mkN "resonör" "resonörer" ; -- resonör..nn.1
  resorbera_1_V = mkV "resorberar" ; -- resorbera..vb.1
  resorberande_1_N = mkN "resorberande" ; -- resorberande..nn.1
  resorberbar_1_A = mkA "resorberbar" ; -- resorberbar..av.1
  resorberbarhet_1_N = mkN "resorberbarhet" ; -- resorberbarhet..nn.1
  resorbering_1_N = mkN "resorbering" ; -- resorbering..nn.1
  resorption_1_N = mkN "resorption" ; -- resorption..nn.1
  respass_1_N = mkN "respass" neutrum  ; -- respass..nn.1
  respekt_1_N = mkN "respekt" ; -- respekt..nn.1
  respektabel_1_A = mkA "respektabel" ; -- respektabel..av.1
  respektera_1_V = mkV "respekterar" ; -- respektera..vb.1
  respekterande_1_N = mkN "respekterande" ; -- respekterande..nn.1
  respekterbar_1_A = mkA "respekterbar" ; -- respekterbar..av.1
  respekterbarhet_1_N = mkN "respekterbarhet" ; -- respekterbarhet..nn.1
  respektering_1_N = mkN "respektering" ; -- respektering..nn.1
  respektfull_1_A = mkA "respektfull" ; -- respektfull..av.1
  respektfullhet_1_N = mkN "respektfullhet" "respektfullheter" ; -- respektfullhet..nn.1
  respektingivande_1_A = mkA "respektingivande" ; -- respektingivande..av.1
  respektive_1_A = mkA "respektive" ; -- respektive..av.1
  respektive_1_N = mkN "respektive" "respektiven" "respektiven" "respektivena" ; -- respektive..nn.1
  respektlös_1_A = mkA "respektlös" ; -- respektlös..av.1
  respektlöshet_1_N = mkN "respektlöshet" "respektlösheter" ; -- respektlöshet..nn.1
  respiration_1_N = mkN "respiration" ; -- respiration..nn.1
  respirator_1_N = mkN "respirator" "respiratorer" ; -- respirator..nn.1
  respiratorisk_1_A = mkA "respiratorisk" ; -- respiratorisk..av.1
  respirera_1_V = mkV "respirerar" ; -- respirera..vb.1
  respirerande_1_N = mkN "respirerande" ; -- respirerande..nn.1
  respirerbar_1_A = mkA "respirerbar" ; -- respirerbar..av.1
  respirerbarhet_1_N = mkN "respirerbarhet" ; -- respirerbarhet..nn.1
  respirering_1_N = mkN "respirering" ; -- respirering..nn.1
  respit_1_N = mkN "respit" "respiter" ; -- respit..nn.1
  respondent_1_N = mkN "respondent" "respondenter" ; -- respondent..nn.1
  respondera_1_V = mkV "responderar" ; -- respondera..vb.1
  responderande_1_N = mkN "responderande" ; -- responderande..nn.1
  respons_1_N = mkN "respons" ; -- respons..nn.1
  ressentiment_1_N = mkN "ressentiment" neutrum  ; -- ressentiment..nn.1
  ressugen_1_A = mkA "ressugen" ; -- ressugen..av.1
  rest_1_N = mkN "rest" "rester" ; -- rest..nn.1
  restaurang_1_N = mkN "restaurang" "restauranger" ; -- restaurang..nn.1
  restaurangalibi_1_N = mkN "restaurangalibi" "restaurangalibit" "restaurangalibin" "restaurangalibina" ; -- restaurangalibi..nn.1
  restaurangbesök_1_N = mkN "restaurangbesök" neutrum  ; -- restaurangbesök..nn.1
  restaurangbord_1_N = mkN "restaurangbord" neutrum  ; -- restaurangbord..nn.1
  restaurangbransch_1_N = mkN "restaurangbransch" ; -- restaurangbransch..nn.1
  restaurangbåt_1_N = mkN "restaurangbåt" ; -- restaurangbåt..nn.1
  restauranggäst_1_N = mkN "restauranggäst" "restauranggäster" ; -- restauranggäst..nn.1
  restauranghypotes_1_N = mkN "restauranghypotes" ; -- restauranghypotes..nn.1
  restaurangkök_1_N = mkN "restaurangkök" neutrum  ; -- restaurangkök..nn.1
  restaurangmiddag_1_N = mkN "restaurangmiddag" ; -- restaurangmiddag..nn.1
  restaurangnäring_1_N = mkN "restaurangnäring" ; -- restaurangnäring..nn.1
  restaurangrecension_1_N = mkN "restaurangrecension" ; -- restaurangrecension..nn.1
  restaurangvagn_1_N = mkN "restaurangvagn" ; -- restaurangvagn..nn.1
  restaurangägare_1_N = mkN "restaurangägare" utrum  ; -- restaurangägare..nn.1
  restaurant_1_N = mkN "restaurant" "restauranter" ; -- restaurant..nn.1
  restauration_1_N = mkN "restauration" ; -- restauration..nn.1
  restaurator_1_N = mkN "restaurator" "restauratorer" ; -- restaurator..nn.1
  restauratris_1_N = mkN "restauratris" "restauratriser" ; -- restauratris..nn.1
  restauratör_1_N = mkN "restauratör" "restauratörer" ; -- restauratör..nn.1
  restaurera_1_V = mkV "restaurerar" ; -- restaurera..vb.1
  restaurerande_1_N = mkN "restaurerande" ; -- restaurerande..nn.1
  restaurerbar_1_A = mkA "restaurerbar" ; -- restaurerbar..av.1
  restaurerbarhet_1_N = mkN "restaurerbarhet" ; -- restaurerbarhet..nn.1
  restaurering_1_N = mkN "restaurering" ; -- restaurering..nn.1
  restera_1_V = mkV "resterar" ; -- restera..vb.1
  resterande_1_N = mkN "resterande" ; -- resterande..nn.1
  restid_1_N = mkN "restid" "restider" ; -- restid..nn.1
  restidsgaranti_1_N = mkN "restidsgaranti" "restidsgarantier" ; -- restidsgaranti..nn.1
  restituera_1_V = mkV "restituerar" ; -- restituera..vb.1
  restituerande_1_N = mkN "restituerande" ; -- restituerande..nn.1
  restituerbar_1_A = mkA "restituerbar" ; -- restituerbar..av.1
  restituerbarhet_1_N = mkN "restituerbarhet" ; -- restituerbarhet..nn.1
  restituering_1_N = mkN "restituering" ; -- restituering..nn.1
  restitution_1_N = mkN "restitution" ; -- restitution..nn.1
  restlager_1_N = mkN "restlager" neutrum  ; -- restlager..nn.1
  restlängd_1_N = mkN "restlängd" "restlängder" ; -- restlängd..nn.1
  restlös_1_A = mkA "restlös" ; -- restlös..av.1
  restlöshet_1_N = mkN "restlöshet" ; -- restlöshet..nn.1
  restprodukt_1_N = mkN "restprodukt" "restprodukter" ; -- restprodukt..nn.1
  restriktion_1_N = mkN "restriktion" ; -- restriktion..nn.1
  restriktiv_1_A = mkA "restriktiv" ; -- restriktiv..av.1
  restriktivitet_1_N = mkN "restriktivitet" ; -- restriktivitet..nn.1
  restriktivitetsprincip_1_N = mkN "restriktivitetsprincip" "restriktivitetsprinciper" ; -- restriktivitetsprincip..nn.1
  restrött_1_A = mkA "restrött" ; -- restrött..av.1
  reströtthet_1_N = mkN "reströtthet" ; -- reströtthet..nn.1
  restskatt_1_N = mkN "restskatt" "restskatter" ; -- restskatt..nn.1
  resultant_1_N = mkN "resultant" "resultanter" ; -- resultant..nn.1
  resultat_1_N = mkN "resultat" neutrum  ; -- resultat..nn.1
  resultatbesked_1_N = mkN "resultatbesked" neutrum  ; -- resultatbesked..nn.1
  resultatförbättring_1_N = mkN "resultatförbättring" ; -- resultatförbättring..nn.1
  resultatinriktad_1_A = mkA "resultatinriktad" ; -- resultatinriktad..av.1
  resultativ_1_A = mkA "resultativ" ; -- resultativ..av.1
  resultatlista_1_N = mkN "resultatlista" ; -- resultatlista..nn.1
  resultatlös_1_A = mkA "resultatlös" ; -- resultatlös..av.1
  resultatlöshet_1_N = mkN "resultatlöshet" ; -- resultatlöshet..nn.1
  resultatmässig_1_A = mkA "resultatmässig" ; -- resultatmässig..av.1
  resultatredovisning_1_N = mkN "resultatredovisning" ; -- resultatredovisning..nn.1
  resultaträkning_1_N = mkN "resultaträkning" ; -- resultaträkning..nn.1
  resultera_1_V = mkV "resulterar" ; -- resultera..vb.1
  resulterande_1_N = mkN "resulterande" ; -- resulterande..nn.1
  resultering_1_N = mkN "resultering" ; -- resultering..nn.1
  resumera_1_V = mkV "resumerar" ; -- resumera..vb.1
  resumerande_1_N = mkN "resumerande" ; -- resumerande..nn.1
  resumerbar_1_A = mkA "resumerbar" ; -- resumerbar..av.1
  resumerbarhet_1_N = mkN "resumerbarhet" ; -- resumerbarhet..nn.1
  resumering_1_N = mkN "resumering" ; -- resumering..nn.1
  resumé_1_N = mkN "resumé" "resuméer" ; -- resumé..nn.1
  resurs_1_N = mkN "resurs" "resurser" ; -- resurs..nn.1
  resursbas_1_N = mkN "resursbas" "resursbaser" ; -- resursbas..nn.1
  resursbrist_1_N = mkN "resursbrist" ; -- resursbrist..nn.1
  resurskris_1_N = mkN "resurskris" "resurskriser" ; -- resurskris..nn.1
  resurskrävande_1_A = mkA "resurskrävande" ; -- resurskrävande..av.1
  resursmässig_1_A = mkA "resursmässig" ; -- resursmässig..av.1
  resursorienterad_1_A = mkA "resursorienterad" ; -- resursorienterad..av.1
  resursstark_1_A = mkA "resursstark" ; -- resursstark..av.1
  resurssvag_1_A = mkA "resurssvag" ; -- resurssvag..av.1
  resursöverföring_1_N = mkN "resursöverföring" ; -- resursöverföring..nn.1
  resvan_1_A = mkA "resvan" ; -- resvan..av.1
  resvana_1_N = mkN "resvana" ; -- resvana..nn.1
  resväg_1_N = mkN "resväg" ; -- resväg..nn.1
  resväska_1_N = mkN "resväska" ; -- resväska..nn.1
  resår_1_N = mkN "resår" "resårer" ; -- resår..nn.1
  resårband_1_N = mkN "resårband" neutrum  ; -- resårband..nn.1
  resårbyxa_1_N = mkN "resårbyxa" ; -- resårbyxa..nn.1
  resårmadrass_1_N = mkN "resårmadrass" "resårmadrasser" ; -- resårmadrass..nn.1
  resårstickning_1_N = mkN "resårstickning" ; -- resårstickning..nn.1
  reta_1_V = mkV "retar" ; -- reta..vb.1
  retablera_1_V = mkV "retablerar" ; -- retablera..vb.1
  retablerande_1_N = mkN "retablerande" ; -- retablerande..nn.1
  retablerbar_1_A = mkA "retablerbar" ; -- retablerbar..av.1
  retablerbarhet_1_N = mkN "retablerbarhet" ; -- retablerbarhet..nn.1
  retablering_1_N = mkN "retablering" ; -- retablering..nn.1
  retande_1_N = mkN "retande" ; -- retande..nn.1
  retardation_1_N = mkN "retardation" ; -- retardation..nn.1
  retardationsfält_1_N = mkN "retardationsfält" neutrum  ; -- retardationsfält..nn.1
  retardera_1_V = mkV "retarderar" ; -- retardera..vb.1
  retarderad_1_A = mkA "retarderad" ; -- retarderad..av.1
  retarderande_1_N = mkN "retarderande" ; -- retarderande..nn.1
  retarderbar_1_A = mkA "retarderbar" ; -- retarderbar..av.1
  retarderbarhet_1_N = mkN "retarderbarhet" ; -- retarderbarhet..nn.1
  retardering_1_N = mkN "retardering" ; -- retardering..nn.1
  retbarhet_1_N = mkN "retbarhet" "retbarheter" ; -- retbarhet..nn.1
  retention_1_N = mkN "retention" ; -- retention..nn.1
  retentionsrätt_1_N = mkN "retentionsrätt" ; -- retentionsrätt..nn.1
  retfull_1_A = mkA "retfull" ; -- retfull..av.1
  retfullhet_1_N = mkN "retfullhet" ; -- retfullhet..nn.1
  rethosta_1_N = mkN "rethosta" ; -- rethosta..nn.1
  retina_1_N = mkN "retina" ; -- retina..nn.1
  retirera_1_V = mkV "retirerar" ; -- retirera..vb.1
  retirerande_1_N = mkN "retirerande" ; -- retirerande..nn.1
  retirering_1_N = mkN "retirering" ; -- retirering..nn.1
  retlig_1_A = mkA "retlig" ; -- retlig..av.1
  retlighet_1_N = mkN "retlighet" ; -- retlighet..nn.1
  retning_1_N = mkN "retning" ; -- retning..nn.1
  retor_1_N = mkN "retor" "retorer" ; -- retor..nn.1
  retorik_1_N = mkN "retorik" ; -- retorik..nn.1
  retoriker_1_N = mkN "retoriker" "retorikern" "retoriker" "retorikerna" ; -- retoriker..nn.1
  retorikexpert_1_N = mkN "retorikexpert" "retorikexperter" ; -- retorikexpert..nn.1
  retorisk_1_A = mkA "retorisk" ; -- retorisk..av.1
  retort_1_N = mkN "retort" "retorter" ; -- retort..nn.1
  retriever_1_N = mkN "retriever" ; -- retriever..nn.1
  retro_1_A = mkA "retro" ; -- retro..av.1
  retroaktiv_1_A = mkA "retroaktiv" ; -- retroaktiv..av.1
  retrofuturistisk_1_A = mkA "retrofuturistisk" ; -- retrofuturistisk..av.1
  retrogradavledning_1_N = mkN "retrogradavledning" ; -- retrogradavledning..nn.1
  retronym_1_N = mkN "retronym" "retronymer" ; -- retronym..nn.1
  retrospektiv_1_A = mkA "retrospektiv" ; -- retrospektiv..av.1
  reträtt_1_N = mkN "reträtt" "reträtter" ; -- reträtt..nn.1
  reträttplats_1_N = mkN "reträttplats" "reträttplatser" ; -- reträttplats..nn.1
  retsam_1_A = mkA "retsam" "retsamt" "retsamma" "retsamma" "retsammare" "retsammast" "retsammaste" ; -- retsam..av.1
  retsamhet_1_N = mkN "retsamhet" "retsamheter" ; -- retsamhet..nn.1
  retsina_1_N = mkN "retsina" ; -- retsina..nn.1
  retsticka_1_N = mkN "retsticka" ; -- retsticka..nn.1
  retur_1_N = mkN "retur" "returer" ; -- retur..nn.1
  retur_2_N = mkN "retur" ; -- retur..nn.2
  returfärd_1_N = mkN "returfärd" "returfärder" ; -- returfärd..nn.1
  returglas_1_N = mkN "returglas" neutrum  ; -- returglas..nn.1
  returkapsel_1_N = mkN "returkapsel" ; -- returkapsel..nn.1
  returmatch_1_N = mkN "returmatch" "returmatcher" ; -- returmatch..nn.1
  returnera_1_V = mkV "returnerar" ; -- returnera..vb.1
  returnerande_1_N = mkN "returnerande" ; -- returnerande..nn.1
  returnerbar_1_A = mkA "returnerbar" ; -- returnerbar..av.1
  returnerbarhet_1_N = mkN "returnerbarhet" ; -- returnerbarhet..nn.1
  returnering_1_N = mkN "returnering" ; -- returnering..nn.1
  returporto_1_N = mkN "returporto" "returportot" "returporton" "returportona" ; -- returporto..nn.1
  returresa_1_N = mkN "returresa" ; -- returresa..nn.1
  returtangent_1_N = mkN "returtangent" "returtangenter" ; -- returtangent..nn.1
  retusch_1_N = mkN "retusch" "retuscher" ; -- retusch..nn.1
  retuschera_1_V = mkV "retuscherar" ; -- retuschera..vb.1
  retuscherande_1_N = mkN "retuscherande" ; -- retuscherande..nn.1
  retuscherbar_1_A = mkA "retuscherbar" ; -- retuscherbar..av.1
  retuscherbarhet_1_N = mkN "retuscherbarhet" ; -- retuscherbarhet..nn.1
  retuschering_1_N = mkN "retuschering" ; -- retuschering..nn.1
  reumatiker_1_N = mkN "reumatiker" "reumatikern" "reumatiker" "reumatikerna" ; -- reumatiker..nn.1
  reumatisk_1_A = mkA "reumatisk" ; -- reumatisk..av.1
  reumatism_1_N = mkN "reumatism" "reumatismer" ; -- reumatism..nn.1
  reumatoid_1_A = mkA "reumatoid" ; -- reumatoid..av.1
  reumatolog_1_N = mkN "reumatolog" "reumatologer" ; -- reumatolog..nn.1
  reumatologi_1_N = mkN "reumatologi" ; -- reumatologi..nn.1
  reunion_1_N = mkN "reunion" ; -- reunion..nn.1
  rev_1_N = mkN "rev" neutrum  ; -- rev..nn.1
  rev_2_N = mkN "rev" ; -- rev..nn.2
  reva_1_N = mkN "reva" ; -- reva..nn.1
  reva_1_V = mkV "revar" ; -- reva..vb.1
  revalvera_1_V = mkV "revalverar" ; -- revalvera..vb.1
  revalverande_1_N = mkN "revalverande" ; -- revalverande..nn.1
  revalverbar_1_A = mkA "revalverbar" ; -- revalverbar..av.1
  revalverbarhet_1_N = mkN "revalverbarhet" ; -- revalverbarhet..nn.1
  revalvering_1_N = mkN "revalvering" ; -- revalvering..nn.1
  revande_1_N = mkN "revande" ; -- revande..nn.1
  revansch_1_N = mkN "revansch" "revanscher" ; -- revansch..nn.1
  revanschism_1_N = mkN "revanschism" "revanschismer" ; -- revanschism..nn.1
  revanschistisk_1_A = mkA "revanschistisk" ; -- revanschistisk..av.1
  revanschlysten_1_A = mkA "revanschlysten" ; -- revanschlysten..av.1
  revanschpolitik_1_N = mkN "revanschpolitik" ; -- revanschpolitik..nn.1
  revanschsugen_1_A = mkA "revanschsugen" ; -- revanschsugen..av.1
  revben_1_N = mkN "revben" neutrum  ; -- revben..nn.1
  revbensspjäll_1_N = mkN "revbensspjäll" neutrum  ; -- revbensspjäll..nn.1
  revel_1_N = mkN "revel" ; -- revel..nn.1
  revelation_1_N = mkN "revelation" ; -- revelation..nn.1
  revelj_1_N = mkN "revelj" "reveljer" ; -- revelj..nn.1
  reveny_1_N = mkN "reveny" "revenyer" ; -- reveny..nn.1
  reverens_1_N = mkN "reverens" "reverenser" ; -- reverens..nn.1
  revers_1_N = mkN "revers" "reverser" ; -- revers..nn.1
  reversal_1_N = mkN "reversal" neutrum  ; -- reversal..nn.1
  reversibel_1_A = mkA "reversibel" ; -- reversibel..av.1
  revetera_1_V = mkV "reveterar" ; -- revetera..vb.1
  reveterande_1_N = mkN "reveterande" ; -- reveterande..nn.1
  reveterbar_1_A = mkA "reveterbar" ; -- reveterbar..av.1
  reveterbarhet_1_N = mkN "reveterbarhet" ; -- reveterbarhet..nn.1
  revetering_1_N = mkN "revetering" ; -- revetering..nn.1
  revider_1_N = mkN "revider" "revideret" "revider" "revideren" ; -- revider..nn.1
  revidera_1_V = mkV "reviderar" ; -- revidera..vb.1
  reviderande_1_N = mkN "reviderande" ; -- reviderande..nn.1
  reviderbar_1_A = mkA "reviderbar" ; -- reviderbar..av.1
  reviderbarhet_1_N = mkN "reviderbarhet" ; -- reviderbarhet..nn.1
  revidering_1_N = mkN "revidering" ; -- revidering..nn.1
  revig_1_A = mkA "revig" ; -- revig..av.1
  revir_1_N = mkN "revir" neutrum  ; -- revir..nn.1
  revirpinkning_1_N = mkN "revirpinkning" ; -- revirpinkning..nn.1
  revision_1_N = mkN "revision" ; -- revision..nn.1
  revisionism_1_N = mkN "revisionism" "revisionismer" ; -- revisionism..nn.1
  revisionist_1_N = mkN "revisionist" "revisionister" ; -- revisionist..nn.1
  revisionistisk_1_A = mkA "revisionistisk" ; -- revisionistisk..av.1
  revisionsberättelse_1_N = mkN "revisionsberättelse" "revisionsberättelser" ; -- revisionsberättelse..nn.1
  revisionsrätt_1_N = mkN "revisionsrätt" ; -- revisionsrätt..nn.1
  revisionssekreterare_1_N = mkN "revisionssekreterare" utrum  ; -- revisionssekreterare..nn.1
  revisor_1_N = mkN "revisor" "revisorer" ; -- revisor..nn.1
  revning_1_N = mkN "revning" ; -- revning..nn.1
  revoke_1_N = mkN "revoke" "revoker" ; -- revoke..nn.1
  revolt_1_N = mkN "revolt" "revolter" ; -- revolt..nn.1
  revoltanda_1_N = mkN "revoltanda" ; -- revoltanda..nn.1
  revoltera_1_V = mkV "revolterar" ; -- revoltera..vb.1
  revolterande_1_N = mkN "revolterande" ; -- revolterande..nn.1
  revoltering_1_N = mkN "revoltering" ; -- revoltering..nn.1
  revoltör_1_N = mkN "revoltör" "revoltörer" ; -- revoltör..nn.1
  revolution_1_N = mkN "revolution" ; -- revolution..nn.1
  revolutionera_1_V = mkV "revolutionerar" ; -- revolutionera..vb.1
  revolutionerande_1_A = mkA "revolutionerande" ; -- revolutionerande..av.1
  revolutionerande_1_N = mkN "revolutionerande" ; -- revolutionerande..nn.1
  revolutionerbar_1_A = mkA "revolutionerbar" ; -- revolutionerbar..av.1
  revolutionerbarhet_1_N = mkN "revolutionerbarhet" ; -- revolutionerbarhet..nn.1
  revolutionering_1_N = mkN "revolutionering" ; -- revolutionering..nn.1
  revolutionsledare_1_N = mkN "revolutionsledare" utrum  ; -- revolutionsledare..nn.1
  revolutionär_1_A = mkA "revolutionär" ; -- revolutionär..av.1
  revolutionär_1_N = mkN "revolutionär" "revolutionärer" ; -- revolutionär..nn.1
  revolver_1_N = mkN "revolver" ; -- revolver..nn.1
  revorm_1_N = mkN "revorm" ; -- revorm..nn.1
  revsmörblomma_1_N = mkN "revsmörblomma" ; -- revsmörblomma..nn.1
  revy_1_N = mkN "revy" "revyer" ; -- revy..nn.1
  revyartist_1_N = mkN "revyartist" "revyartister" ; -- revyartist..nn.1
  revymakare_1_N = mkN "revymakare" utrum  ; -- revymakare..nn.1
  revär_1_N = mkN "revär" "revärer" ; -- revär..nn.1
  revärbyxa_1_N = mkN "revärbyxa" ; -- revärbyxa..nn.1
  rh_faktor_1_N = mkN "rh-faktor" "rh-faktorer" ; -- rh-faktor..nn.1
  rh_negativ_1_A = mkA "rh-negativ" ; -- rh-negativ..av.1
  rh_positiv_1_A = mkA "rh-positiv" ; -- rh-positiv..av.1
  rhenium_1_N = mkN "rhenium" neutrum  ; -- rhenium..nn.1
  rhensk_1_A = mkA "rhensk" ; -- rhensk..av.1
  rhenskhet_1_N = mkN "rhenskhet" ; -- rhenskhet..nn.1
  rhenvin_1_N = mkN "rhenvin" "rhenvinet" "rhenviner" "rhenvinerna" ; -- rhenvin..nn.1
  rhinologi_1_N = mkN "rhinologi" ; -- rhinologi..nn.1
  rhizom_1_N = mkN "rhizom" "rhizomer" ; -- rhizom..nn.1
  rho_1_N = mkN "rho" neutrum  ; -- rho..nn.1
  rhodesier_1_N = mkN "rhodesier" "rhodesiern" "rhodesier" "rhodesierna" ; -- rhodesier..nn.1
  rhodesisk_1_A = mkA "rhodesisk" ; -- rhodesisk..av.1
  rhododendron_1_N = mkN "rhododendron" "rhododendrer" ; -- rhododendron..nn.1
  rhythm_and_blues_1_N = mkN "rhythm-and-blues" ; -- rhythm-and-blues..nn.1
  ri_1_N = mkN "ri" "riet" "rin" "rina" ; -- ri..nn.1
  ria_1_N = mkN "ria" ; -- ria..nn.1
  ria_1_V = mkV "riar" ; -- ria..vb.1
  riande_1_N = mkN "riande" ; -- riande..nn.1
  ribb_1_N = mkN "ribb" ; -- ribb..nn.1
  ribba_1_N = mkN "ribba" ; -- ribba..nn.1
  ribba_2_N = mkN "ribba" ; -- ribba..nn.2
  ribbad_1_A = mkA "ribbad" ; -- ribbad..av.1
  ribbstickad_1_A = mkA "ribbstickad" ; -- ribbstickad..av.1
  ribbstol_1_N = mkN "ribbstol" ; -- ribbstol..nn.1
  ribbvalv_1_N = mkN "ribbvalv" neutrum  ; -- ribbvalv..nn.1
  riboflavin_1_N = mkN "riboflavin" "riboflaviner" ; -- riboflavin..nn.1
  ribos_1_N = mkN "ribos" ; -- ribos..nn.1
  ribosom_1_N = mkN "ribosom" "ribosomer" ; -- ribosom..nn.1
  ricinbuske_1_N = mkN "ricinbuske" utrum  ; -- ricinbuske..nn.1
  ricinolja_1_N = mkN "ricinolja" ; -- ricinolja..nn.1
  ricka_1_V = mkV "rickar" ; -- ricka..vb.1
  rickande_1_N = mkN "rickande" ; -- rickande..nn.1
  rickettsie_1_N = mkN "rickettsie" "rickettsier" ; -- rickettsie..nn.1
  rickig_1_A = mkA "rickig" ; -- rickig..av.1
  rickighet_1_N = mkN "rickighet" ; -- rickighet..nn.1
  rickshaw_1_N = mkN "rickshaw" "rickshawn" "rickshawer" "rickshawerna" ; -- rickshaw..nn.1
  rickshawförare_1_N = mkN "rickshawförare" utrum  ; -- rickshawförare..nn.1
  rida_1_V = mkV "rida" "red" "ridit" ; -- rida..vb.1
  ridande_1_N = mkN "ridande" ; -- ridande..nn.1
  ridbana_1_N = mkN "ridbana" ; -- ridbana..nn.1
  ridborgarmärke_1_N = mkN "ridborgarmärke" ; -- ridborgarmärke..nn.1
  ridbyxa_1_N = mkN "ridbyxa" ; -- ridbyxa..nn.1
  riddarborg_1_N = mkN "riddarborg" ; -- riddarborg..nn.1
  riddare_1_N = mkN "riddare" utrum  ; -- riddare..nn.1
  riddarhus_1_N = mkN "riddarhus" neutrum  ; -- riddarhus..nn.1
  riddarorden_1_N = mkN "riddarorden" ; -- riddarorden..nn.1
  riddarslag_1_N = mkN "riddarslag" neutrum  ; -- riddarslag..nn.1
  riddarsporre_1_N = mkN "riddarsporre" utrum  ; -- riddarsporre..nn.1
  ridderlig_1_A = mkA "ridderlig" ; -- ridderlig..av.1
  ridderlighet_1_N = mkN "ridderlighet" ; -- ridderlighet..nn.1
  ridderskap_1_N = mkN "ridderskap" neutrum  ; -- ridderskap..nn.1
  riddersman_1_N = mkN "riddersman" "riddersmannen" "riddersmän" "riddersmännen" ; -- riddersman..nn.1
  riddjur_1_N = mkN "riddjur" neutrum  ; -- riddjur..nn.1
  riddräkt_1_N = mkN "riddräkt" "riddräkter" ; -- riddräkt..nn.1
  ridhjälm_1_N = mkN "ridhjälm" ; -- ridhjälm..nn.1
  ridhus_1_N = mkN "ridhus" neutrum  ; -- ridhus..nn.1
  ridhäst_1_N = mkN "ridhäst" ; -- ridhäst..nn.1
  ridhästdressyr_1_N = mkN "ridhästdressyr" "ridhästdressyrer" ; -- ridhästdressyr..nn.1
  ridikyl_1_N = mkN "ridikyl" "ridikyler" ; -- ridikyl..nn.1
  ridinstruktör_1_N = mkN "ridinstruktör" "ridinstruktörer" ; -- ridinstruktör..nn.1
  ridkonst_1_N = mkN "ridkonst" "ridkonster" ; -- ridkonst..nn.1
  ridkunnig_1_A = mkA "ridkunnig" ; -- ridkunnig..av.1
  ridkunnighet_1_N = mkN "ridkunnighet" "ridkunnigheter" ; -- ridkunnighet..nn.1
  ridkunnighetsprov_1_N = mkN "ridkunnighetsprov" neutrum  ; -- ridkunnighetsprov..nn.1
  ridning_1_N = mkN "ridning" ; -- ridning..nn.1
  ridpiska_1_N = mkN "ridpiska" ; -- ridpiska..nn.1
  ridskola_1_N = mkN "ridskola" ; -- ridskola..nn.1
  ridsport_1_N = mkN "ridsport" ; -- ridsport..nn.1
  ridspö_1_N = mkN "ridspö" "ridspöt" "ridspön" "ridspöna" ; -- ridspö..nn.1
  ridstövel_1_N = mkN "ridstövel" ; -- ridstövel..nn.1
  ridsår_1_N = mkN "ridsår" neutrum  ; -- ridsår..nn.1
  ridtur_1_N = mkN "ridtur" "ridturer" ; -- ridtur..nn.1
  ridtävling_1_N = mkN "ridtävling" ; -- ridtävling..nn.1
  ridväg_1_N = mkN "ridväg" ; -- ridväg..nn.1
  ridå_1_N = mkN "ridå" "ridåer" ; -- ridå..nn.1
  ridåfall_1_N = mkN "ridåfall" neutrum  ; -- ridåfall..nn.1
  riesenschnauzer_1_N = mkN "riesenschnauzer" ; -- riesenschnauzer..nn.1
  riff_1_N = mkN "riff" neutrum  ; -- riff..nn.1
  rififikupp_1_N = mkN "rififikupp" "rififikupper" ; -- rififikupp..nn.1
  rigel_1_N = mkN "rigel" ; -- rigel..nn.1
  rigg_1_N = mkN "rigg" ; -- rigg..nn.1
  rigga_1_V = mkV "riggar" ; -- rigga..vb.1
  riggande_1_N = mkN "riggande" ; -- riggande..nn.1
  rigid_1_A = mkA "rigid" ; -- rigid..av.1
  rigla_1_V = mkV "riglar" ; -- rigla..vb.1
  riglande_1_N = mkN "riglande" ; -- riglande..nn.1
  rigling_1_N = mkN "rigling" ; -- rigling..nn.1
  rigorism_1_N = mkN "rigorism" "rigorismer" ; -- rigorism..nn.1
  rigorös_1_A = mkA "rigorös" ; -- rigorös..av.1
  rik_1_A = mkA "rik" ; -- rik..av.1
  rike_1_N = mkN "rike" ; -- rike..nn.1
  rikedom_1_N = mkN "rikedom" ; -- rikedom..nn.1
  rikeman_1_N = mkN "rikeman" "rikemannen" "rikemän" "rikemännen" ; -- rikeman..nn.1
  rikemansbarn_1_N = mkN "rikemansbarn" neutrum  ; -- rikemansbarn..nn.1
  rikhaltig_1_A = mkA "rikhaltig" ; -- rikhaltig..av.1
  rikhaltighet_1_N = mkN "rikhaltighet" ; -- rikhaltighet..nn.1
  rikhet_1_N = mkN "rikhet" ; -- rikhet..nn.1
  riklig_1_A = mkA "riklig" ; -- riklig..av.1
  rikligen_1_Adv = mkAdv "rikligen" ; -- rikligen..ab.1
  riklighet_1_N = mkN "riklighet" ; -- riklighet..nn.1
  rikoschett_1_N = mkN "rikoschett" "rikoschetter" ; -- rikoschett..nn.1
  rikoschettera_1_V = mkV "rikoschetterar" ; -- rikoschettera..vb.1
  rikoschetterande_1_N = mkN "rikoschetterande" ; -- rikoschetterande..nn.1
  rikoschettering_1_N = mkN "rikoschettering" ; -- rikoschettering..nn.1
  riks_1_N = mkN "riks" neutrum  ; -- riks..nn.1
  riksangelägenhet_1_N = mkN "riksangelägenhet" "riksangelägenheter" ; -- riksangelägenhet..nn.1
  riksantikvarie_1_N = mkN "riksantikvarie" "riksantikvarier" ; -- riksantikvarie..nn.1
  riksarkiv_1_N = mkN "riksarkiv" neutrum  ; -- riksarkiv..nn.1
  riksarkivarie_1_N = mkN "riksarkivarie" "riksarkivarier" ; -- riksarkivarie..nn.1
  riksbank_1_N = mkN "riksbank" "riksbanker" ; -- riksbank..nn.1
  riksbankschef_1_N = mkN "riksbankschef" "riksbankschefer" ; -- riksbankschef..nn.1
  riksbekant_1_A = mkA "riksbekant" "riksbekant" ; -- riksbekant..av.1
  riksbibliotekarie_1_N = mkN "riksbibliotekarie" "riksbibliotekarier" ; -- riksbibliotekarie..nn.1
  riksbyggare_1_N = mkN "riksbyggare" utrum  ; -- riksbyggare..nn.1
  riksdag_1_N = mkN "riksdag" ; -- riksdag..nn.1
  riksdagsbeslut_1_N = mkN "riksdagsbeslut" neutrum  ; -- riksdagsbeslut..nn.1
  riksdagsdebatt_1_N = mkN "riksdagsdebatt" "riksdagsdebatter" ; -- riksdagsdebatt..nn.1
  riksdagsgrupp_1_N = mkN "riksdagsgrupp" "riksdagsgrupper" ; -- riksdagsgrupp..nn.1
  riksdagshus_1_N = mkN "riksdagshus" neutrum  ; -- riksdagshus..nn.1
  riksdagskvinna_1_N = mkN "riksdagskvinna" ; -- riksdagskvinna..nn.1
  riksdagsledamot_1_N = mkN "riksdagsledamot" "riksdagsledamöter" ; -- riksdagsledamot..nn.1
  riksdagsmajoritet_1_N = mkN "riksdagsmajoritet" "riksdagsmajoriteter" ; -- riksdagsmajoritet..nn.1
  riksdagsman_1_N = mkN "riksdagsman" "riksdagsmannen" "riksdagsmän" "riksdagsmännen" ; -- riksdagsman..nn.1
  riksdagsmandat_1_N = mkN "riksdagsmandat" neutrum  ; -- riksdagsmandat..nn.1
  riksdagsordning_1_N = mkN "riksdagsordning" ; -- riksdagsordning..nn.1
  riksdagsparti_1_N = mkN "riksdagsparti" "riksdagspartiet" "riksdagspartier" "riksdagspartierna" ; -- riksdagsparti..nn.1
  riksdagsplats_1_N = mkN "riksdagsplats" "riksdagsplatser" ; -- riksdagsplats..nn.1
  riksdagspolitiker_1_N = mkN "riksdagspolitiker" "riksdagspolitikern" "riksdagspolitiker" "riksdagspolitikerna" ; -- riksdagspolitiker..nn.1
  riksdagsprotokoll_1_N = mkN "riksdagsprotokoll" neutrum  ; -- riksdagsprotokoll..nn.1
  riksdagssammanträde_1_N = mkN "riksdagssammanträde" ; -- riksdagssammanträde..nn.1
  riksdagsspärr_1_N = mkN "riksdagsspärr" ; -- riksdagsspärr..nn.1
  riksdagsval_1_N = mkN "riksdagsval" neutrum  ; -- riksdagsval..nn.1
  riksdagsvälde_1_N = mkN "riksdagsvälde" ; -- riksdagsvälde..nn.1
  riksdaler_1_N = mkN "riksdaler" "riksdalern" "riksdaler" "riksdalerna" ; -- riksdaler..nn.1
  riksfurste_1_N = mkN "riksfurste" utrum  ; -- riksfurste..nn.1
  riksförbund_1_N = mkN "riksförbund" neutrum  ; -- riksförbund..nn.1
  riksföreståndare_1_N = mkN "riksföreståndare" utrum  ; -- riksföreståndare..nn.1
  riksförrädare_1_N = mkN "riksförrädare" utrum  ; -- riksförrädare..nn.1
  riksförsamling_1_N = mkN "riksförsamling" ; -- riksförsamling..nn.1
  riksgenomsnitt_1_N = mkN "riksgenomsnitt" neutrum  ; -- riksgenomsnitt..nn.1
  riksgräns_1_N = mkN "riksgräns" "riksgränser" ; -- riksgräns..nn.1
  riksgäld_1_N = mkN "riksgäld" ; -- riksgäld..nn.1
  riksha_1_N = mkN "riksha" ; -- riksha..nn.1
  riksintressant_1_A = mkA "riksintressant" "riksintressant" ; -- riksintressant..av.1
  riksintresse_1_N = mkN "riksintresse" ; -- riksintresse..nn.1
  rikskansler_1_N = mkN "rikskansler" ; -- rikskansler..nn.1
  rikskänd_1_A = mkA "rikskänd" ; -- rikskänd..av.1
  rikslikare_1_N = mkN "rikslikare" utrum  ; -- rikslikare..nn.1
  riksmarskalk_1_N = mkN "riksmarskalk" ; -- riksmarskalk..nn.1
  riksmuseum_1_N = mkN "riksmuseum" "riksmuseet" "riksmuseer" "riksmuseerna" ; -- riksmuseum..nn.1
  riksmynt_1_N = mkN "riksmynt" neutrum  ; -- riksmynt..nn.1
  riksmål_1_N = mkN "riksmål" neutrum  ; -- riksmål..nn.1
  riksmöte_1_N = mkN "riksmöte" ; -- riksmöte..nn.1
  riksnivå_1_N = mkN "riksnivå" ; -- riksnivå..nn.1
  riksnyckel_1_N = mkN "riksnyckel" ; -- riksnyckel..nn.1
  riksnät_1_N = mkN "riksnät" neutrum  ; -- riksnät..nn.1
  riksolycka_1_N = mkN "riksolycka" ; -- riksolycka..nn.1
  riksomfattande_1_A = mkA "riksomfattande" ; -- riksomfattande..av.1
  riksorganisation_1_N = mkN "riksorganisation" ; -- riksorganisation..nn.1
  riksplan_1_N = mkN "riksplan" neutrum  ; -- riksplan..nn.1
  riksplanering_1_N = mkN "riksplanering" ; -- riksplanering..nn.1
  rikspolisstyrelse_1_N = mkN "rikspolisstyrelse" utrum  ; -- rikspolisstyrelse..nn.1
  rikspolitik_1_N = mkN "rikspolitik" ; -- rikspolitik..nn.1
  rikspolitisk_1_A = mkA "rikspolitisk" ; -- rikspolitisk..av.1
  riksprototyp_1_N = mkN "riksprototyp" "riksprototyper" ; -- riksprototyp..nn.1
  riksrätt_1_N = mkN "riksrätt" "riksrätter" ; -- riksrätt..nn.1
  riksråd_1_N = mkN "riksråd" neutrum  ; -- riksråd..nn.1
  riksrös_1_N = mkN "riksrös" neutrum  ; -- riksrös..nn.1
  riksröse_1_N = mkN "riksröse" ; -- riksröse..nn.1
  rikssal_1_N = mkN "rikssal" ; -- rikssal..nn.1
  rikssamtal_1_N = mkN "rikssamtal" neutrum  ; -- rikssamtal..nn.1
  riksskandal_1_N = mkN "riksskandal" "riksskandaler" ; -- riksskandal..nn.1
  riksskatteverk_1_N = mkN "riksskatteverk" neutrum  ; -- riksskatteverk..nn.1
  riksspråk_1_N = mkN "riksspråk" neutrum  ; -- riksspråk..nn.1
  riksstat_1_N = mkN "riksstat" ; -- riksstat..nn.1
  riksstyrelse_1_N = mkN "riksstyrelse" "riksstyrelser" ; -- riksstyrelse..nn.1
  riksstämma_1_N = mkN "riksstämma" ; -- riksstämma..nn.1
  rikssvensk_1_A = mkA "rikssvensk" ; -- rikssvensk..av.1
  rikssvenska_1_N = mkN "rikssvenska" ; -- rikssvenska..nn.1
  rikssvärd_1_N = mkN "rikssvärd" neutrum  ; -- rikssvärd..nn.1
  rikstidning_1_N = mkN "rikstidning" ; -- rikstidning..nn.1
  rikstäckande_1_A = mkA "rikstäckande" ; -- rikstäckande..av.1
  riksuttag_1_N = mkN "riksuttag" neutrum  ; -- riksuttag..nn.1
  riksvapen_1_N = mkN "riksvapen" "riksvapnet" "riksvapen" "riksvapnen" ; -- riksvapen..nn.1
  riksviktig_1_A = mkA "riksviktig" ; -- riksviktig..av.1
  riksviktighet_1_N = mkN "riksviktighet" ; -- riksviktighet..nn.1
  riksväg_1_N = mkN "riksväg" ; -- riksväg..nn.1
  riksäpple_1_N = mkN "riksäpple" ; -- riksäpple..nn.1
  riksåklagare_1_N = mkN "riksåklagare" utrum  ; -- riksåklagare..nn.1
  rikta_1_V = mkV "riktar" ; -- rikta..vb.1
  riktande_1_N = mkN "riktande" ; -- riktande..nn.1
  rikthyvel_1_N = mkN "rikthyvel" ; -- rikthyvel..nn.1
  riktig_1_A = mkA "riktig" ; -- riktig..av.1
  riktighet_1_N = mkN "riktighet" "riktigheter" ; -- riktighet..nn.1
  riktinstrument_1_N = mkN "riktinstrument" neutrum  ; -- riktinstrument..nn.1
  riktkarl_1_N = mkN "riktkarl" ; -- riktkarl..nn.1
  riktlinje_1_N = mkN "riktlinje" "riktlinjer" ; -- riktlinje..nn.1
  riktmedel_1_N = mkN "riktmedel" neutrum  ; -- riktmedel..nn.1
  riktmärke_1_N = mkN "riktmärke" ; -- riktmärke..nn.1
  riktning_1_N = mkN "riktning" ; -- riktning..nn.1
  riktningskoefficient_1_N = mkN "riktningskoefficient" "riktningskoefficienter" ; -- riktningskoefficient..nn.1
  riktnummer_1_N = mkN "riktnummer" neutrum  ; -- riktnummer..nn.1
  riktpris_1_N = mkN "riktpris" neutrum  ; -- riktpris..nn.1
  riktpunkt_1_N = mkN "riktpunkt" "riktpunkter" ; -- riktpunkt..nn.1
  rim_1_N = mkN "rim" "rimmet" "rim" "rimmen" ; -- rim..nn.1
  rimflätning_1_N = mkN "rimflätning" ; -- rimflätning..nn.1
  rimfrost_1_N = mkN "rimfrost" ; -- rimfrost..nn.1
  rimkrönika_1_N = mkN "rimkrönika" ; -- rimkrönika..nn.1
  rimlexikon_1_N = mkN "rimlexikon" neutrum  ; -- rimlexikon..nn.1
  rimlig_1_A = mkA "rimlig" ; -- rimlig..av.1
  rimligen_1_Adv = mkAdv "rimligen" ; -- rimligen..ab.1
  rimlighet_1_N = mkN "rimlighet" "rimligheter" ; -- rimlighet..nn.1
  rimligtvis_1_Adv = mkAdv "rimligtvis" ; -- rimligtvis..ab.1
  rimma_1_V = mkV "rimmar" ; -- rimma..vb.1
  rimma_2_V = mkV "rimmar" ; -- rimma..vb.2
  rimmande_1_N = mkN "rimmande" ; -- rimmande..nn.1
  rimmande_2_N = mkN "rimmande" ; -- rimmande..nn.2
  rimmare_1_N = mkN "rimmare" utrum  ; -- rimmare..nn.1
  rimmeri_1_N = mkN "rimmeri" neutrum  ; -- rimmeri..nn.1
  rimning_1_N = mkN "rimning" ; -- rimning..nn.1
  rimsalta_1_V = mkV "rimsaltar" ; -- rimsalta..vb.1
  rimsaltande_1_N = mkN "rimsaltande" ; -- rimsaltande..nn.1
  rimsmed_1_N = mkN "rimsmed" "rimsmeder" ; -- rimsmed..nn.1
  rimturs_1_N = mkN "rimturs" ; -- rimturs..nn.1
  rindläder_1_N = mkN "rindläder" neutrum  ; -- rindläder..nn.1
  ring_1_N = mkN "ring" ; -- ring..nn.1
  ring_2_N = mkN "ring" neutrum  ; -- ring..nn.2
  ringa_1_A = mkA "ringa" ; -- ringa..av.1
  ringa_1_V = mkV "ringer" ; -- ringa..vb.1
  ringa_2_V = mkV "ringar" ; -- ringa..vb.2
  ringa_3_V = mkV "ringer" ; -- ringa..vb.3
  ringakta_1_V = mkV "ringaktar" ; -- ringakta..vb.1
  ringaktande_1_N = mkN "ringaktande" ; -- ringaktande..nn.1
  ringaktning_1_N = mkN "ringaktning" ; -- ringaktning..nn.1
  ringande_1_N = mkN "ringande" ; -- ringande..nn.1
  ringare_1_N = mkN "ringare" utrum  ; -- ringare..nn.1
  ringart_1_N = mkN "ringart" "ringarter" ; -- ringart..nn.1
  ringbarka_1_V = mkV "ringbarkar" ; -- ringbarka..vb.1
  ringbarkande_1_N = mkN "ringbarkande" ; -- ringbarkande..nn.1
  ringberg_1_N = mkN "ringberg" neutrum  ; -- ringberg..nn.1
  ringblomma_1_N = mkN "ringblomma" ; -- ringblomma..nn.1
  ringbrosk_1_N = mkN "ringbrosk" neutrum  ; -- ringbrosk..nn.1
  ringbrynja_1_N = mkN "ringbrynja" ; -- ringbrynja..nn.1
  ringdans_1_N = mkN "ringdans" "ringdanser" ; -- ringdans..nn.1
  ringdomare_1_N = mkN "ringdomare" utrum  ; -- ringdomare..nn.1
  ringduva_1_N = mkN "ringduva" ; -- ringduva..nn.1
  ringfinger_1_N = mkN "ringfinger" ; -- ringfinger..nn.1
  ringformad_1_A = mkA "ringformad" ; -- ringformad..av.1
  ringformig_1_A = mkA "ringformig" ; -- ringformig..av.1
  ringformighet_1_N = mkN "ringformighet" ; -- ringformighet..nn.1
  ringförlovad_1_A = mkA "ringförlovad" ; -- ringförlovad..av.1
  ringgata_1_N = mkN "ringgata" ; -- ringgata..nn.1
  ringgrav_1_N = mkN "ringgrav" ; -- ringgrav..nn.1
  ringhet_1_N = mkN "ringhet" "ringheter" ; -- ringhet..nn.1
  ringhörna_1_N = mkN "ringhörna" ; -- ringhörna..nn.1
  ringklocka_1_N = mkN "ringklocka" ; -- ringklocka..nn.1
  ringla_1_V = mkV "ringlar" ; -- ringla..vb.1
  ringlande_1_N = mkN "ringlande" ; -- ringlande..nn.1
  ringledning_1_N = mkN "ringledning" ; -- ringledning..nn.1
  ringlek_1_N = mkN "ringlek" ; -- ringlek..nn.1
  ringmask_1_N = mkN "ringmask" ; -- ringmask..nn.1
  ringmur_1_N = mkN "ringmur" ; -- ringmur..nn.1
  ringmuskel_1_N = mkN "ringmuskel" "ringmuskeln" "ringmuskler" "ringmusklerna" ; -- ringmuskel..nn.1
  ringmärka_1_V = mkV "ringmärker" ; -- ringmärka..vb.1
  ringmärkande_1_N = mkN "ringmärkande" ; -- ringmärkande..nn.1
  ringmärkning_1_N = mkN "ringmärkning" ; -- ringmärkning..nn.1
  ringning_1_N = mkN "ringning" ; -- ringning..nn.1
  ringorm_1_N = mkN "ringorm" ; -- ringorm..nn.1
  ringprydd_1_A = mkA "ringprydd" ; -- ringprydd..av.1
  ringpärm_1_N = mkN "ringpärm" ; -- ringpärm..nn.1
  ringrev_1_N = mkN "ringrev" neutrum  ; -- ringrev..nn.1
  ringrostig_1_A = mkA "ringrostig" ; -- ringrostig..av.1
  ringrostighet_1_N = mkN "ringrostighet" ; -- ringrostighet..nn.1
  ringräv_1_N = mkN "ringräv" ; -- ringräv..nn.1
  ringside_1_N = mkN "ringside" ; -- ringside..nn.1
  ringstruktur_1_N = mkN "ringstruktur" "ringstrukturer" ; -- ringstruktur..nn.1
  ringtrast_1_N = mkN "ringtrast" ; -- ringtrast..nn.1
  ringtryck_1_N = mkN "ringtryck" neutrum  ; -- ringtryck..nn.1
  ringvrak_1_N = mkN "ringvrak" neutrum  ; -- ringvrak..nn.1
  rink_1_N = mkN "rink" ; -- rink..nn.1
  rinna_1_V = mkV "rinna" "rann" "runnit" ; -- rinna..vb.1
  rinnande_1_N = mkN "rinnande" ; -- rinnande..nn.1
  rioja_1_N = mkN "rioja" ; -- rioja..nn.1
  riojaprovning_1_N = mkN "riojaprovning" ; -- riojaprovning..nn.1
  ripa_1_N = mkN "ripa" ; -- ripa..nn.1
  ripost_1_N = mkN "ripost" "riposter" ; -- ripost..nn.1
  ripostera_1_V = mkV "riposterar" ; -- ripostera..vb.1
  riposterande_1_N = mkN "riposterande" ; -- riposterande..nn.1
  ripostering_1_N = mkN "ripostering" ; -- ripostering..nn.1
  rippel_1_N = mkN "rippel" ; -- rippel..nn.1
  rips_1_N = mkN "rips" "ripser" ; -- rips..nn.1
  ris_1_N = mkN "ris" neutrum  ; -- ris..nn.1
  ris_2_N = mkN "ris" neutrum  ; -- ris..nn.2
  risa_1_V = mkV "risar" ; -- risa..vb.1
  risande_1_N = mkN "risande" ; -- risande..nn.1
  risbastu_1_N = mkN "risbastu" ; -- risbastu..nn.1
  risbrännvin_1_N = mkN "risbrännvin" neutrum  ; -- risbrännvin..nn.1
  risfält_1_N = mkN "risfält" neutrum  ; -- risfält..nn.1
  risgryn_1_N = mkN "risgryn" neutrum  ; -- risgryn..nn.1
  risgrynsgröt_1_N = mkN "risgrynsgröt" ; -- risgrynsgröt..nn.1
  rishög_1_N = mkN "rishög" ; -- rishög..nn.1
  risig_1_A = mkA "risig" ; -- risig..av.1
  risk_1_N = mkN "risk" "risker" ; -- risk..nn.1
  riska_1_N = mkN "riska" ; -- riska..nn.1
  riskabel_1_A = mkA "riskabel" ; -- riskabel..av.1
  riskaka_1_N = mkN "riskaka" ; -- riskaka..nn.1
  riskanalys_1_N = mkN "riskanalys" "riskanalyser" ; -- riskanalys..nn.1
  riskbedömning_1_N = mkN "riskbedömning" ; -- riskbedömning..nn.1
  riskbenägen_1_A = mkA "riskbenägen" ; -- riskbenägen..av.1
  riskbenägenhet_1_N = mkN "riskbenägenhet" "riskbenägenheter" ; -- riskbenägenhet..nn.1
  riskbeteende_1_N = mkN "riskbeteende" ; -- riskbeteende..nn.1
  riskbygge_1_N = mkN "riskbygge" ; -- riskbygge..nn.1
  riskera_1_V = mkV "riskerar" ; -- riskera..vb.1
  riskerande_1_N = mkN "riskerande" ; -- riskerande..nn.1
  riskering_1_N = mkN "riskering" ; -- riskering..nn.1
  riskfaktor_1_N = mkN "riskfaktor" "riskfaktorer" ; -- riskfaktor..nn.1
  riskforskare_1_N = mkN "riskforskare" utrum  ; -- riskforskare..nn.1
  riskfri_1_A = mkA "riskfri" "riskfritt" ; -- riskfri..av.1
  riskfrihet_1_N = mkN "riskfrihet" ; -- riskfrihet..nn.1
  riskfylld_1_A = mkA "riskfylld" "riskfyllt" ; -- riskfylld..av.1
  riskfylldhet_1_N = mkN "riskfylldhet" ; -- riskfylldhet..nn.1
  riskgrupp_1_N = mkN "riskgrupp" "riskgrupper" ; -- riskgrupp..nn.1
  riskkalkylering_1_N = mkN "riskkalkylering" ; -- riskkalkylering..nn.1
  riskkapital_1_N = mkN "riskkapital" neutrum  ; -- riskkapital..nn.1
  riskkapitalbolag_1_N = mkN "riskkapitalbolag" neutrum  ; -- riskkapitalbolag..nn.1
  riskkapitalbolagsägare_1_N = mkN "riskkapitalbolagsägare" utrum  ; -- riskkapitalbolagsägare..nn.1
  riskkapitalist_1_N = mkN "riskkapitalist" "riskkapitalister" ; -- riskkapitalist..nn.1
  riskminimering_1_N = mkN "riskminimering" ; -- riskminimering..nn.1
  riskminimeringsstrategi_1_N = mkN "riskminimeringsstrategi" "riskminimeringsstrategier" ; -- riskminimeringsstrategi..nn.1
  riskmodell_1_N = mkN "riskmodell" "riskmodeller" ; -- riskmodell..nn.1
  risknivå_1_N = mkN "risknivå" "risknivåer" ; -- risknivå..nn.1
  riskområde_1_N = mkN "riskområde" ; -- riskområde..nn.1
  riskspridning_1_N = mkN "riskspridning" ; -- riskspridning..nn.1
  risktagande_1_A = mkA "risktagande" ; -- risktagande..av.1
  risktagande_1_N = mkN "risktagande" ; -- risktagande..nn.1
  risktagare_1_N = mkN "risktagare" utrum  ; -- risktagare..nn.1
  risktal_1_N = mkN "risktal" neutrum  ; -- risktal..nn.1
  riskuppfattning_1_N = mkN "riskuppfattning" ; -- riskuppfattning..nn.1
  riskvillig_1_A = mkA "riskvillig" ; -- riskvillig..av.1
  riskvillighet_1_N = mkN "riskvillighet" ; -- riskvillighet..nn.1
  riskzon_1_N = mkN "riskzon" "riskzoner" ; -- riskzon..nn.1
  risodling_1_N = mkN "risodling" ; -- risodling..nn.1
  risodling_2_N = mkN "risodling" ; -- risodling..nn.2
  risoll_1_N = mkN "risoll" "risoller" ; -- risoll..nn.1
  risotto_1_N = mkN "risotto" ; -- risotto..nn.1
  rispa_1_N = mkN "rispa" ; -- rispa..nn.1
  rispa_1_V = mkV "rispar" ; -- rispa..vb.1
  rispande_1_N = mkN "rispande" ; -- rispande..nn.1
  rispapper_1_N = mkN "rispapper" neutrum  ; -- rispapper..nn.1
  rispig_1_A = mkA "rispig" ; -- rispig..av.1
  rispning_1_N = mkN "rispning" ; -- rispning..nn.1
  risrätt_1_N = mkN "risrätt" "risrätter" ; -- risrätt..nn.1
  rissel_1_N = mkN "rissel" neutrum  ; -- rissel..nn.1
  rissla_1_N = mkN "rissla" ; -- rissla..nn.1
  rissla_1_V = mkV "risslar" ; -- rissla..vb.1
  rissla_2_V = mkV "risslar" ; -- rissla..vb.2
  risslande_1_N = mkN "risslande" ; -- risslande..nn.1
  rist_1_N = mkN "rist" ; -- rist..nn.1
  rista_1_V = mkV "ristar" ; -- rista..vb.1
  rista_2_V = mkV "rista" "riste" "ristat" ; -- rista..vb.2
  ristande_1_N = mkN "ristande" ; -- ristande..nn.1
  ristning_1_N = mkN "ristning" ; -- ristning..nn.1
  risvase_1_N = mkN "risvase" utrum  ; -- risvase..nn.1
  rit_1_N = mkN "rit" "riter" ; -- rit..nn.1
  rita_1_V = mkV "ritar" ; -- rita..vb.1
  ritande_1_N = mkN "ritande" ; -- ritande..nn.1
  ritapparat_1_N = mkN "ritapparat" "ritapparater" ; -- ritapparat..nn.1
  ritardando_1_N = mkN "ritardando" "ritardandot" "ritardandon" "ritardandona" ; -- ritardando..nn.1
  ritare_1_N = mkN "ritare" utrum  ; -- ritare..nn.1
  ritbestick_1_N = mkN "ritbestick" neutrum  ; -- ritbestick..nn.1
  ritblock_1_N = mkN "ritblock" neutrum  ; -- ritblock..nn.1
  ritbord_1_N = mkN "ritbord" neutrum  ; -- ritbord..nn.1
  ritkol_1_N = mkN "ritkol" neutrum  ; -- ritkol..nn.1
  ritning_1_N = mkN "ritning" ; -- ritning..nn.1
  rits_1_N = mkN "rits" ; -- rits..nn.1
  ritsa_1_V = mkV "ritsar" ; -- ritsa..vb.1
  ritsande_1_N = mkN "ritsande" ; -- ritsande..nn.1
  ritsch_1_N = mkN "ritsch" neutrum  ; -- ritsch..nn.1
  ritscha_1_V = mkV "ritschar" ; -- ritscha..vb.1
  ritschande_1_N = mkN "ritschande" ; -- ritschande..nn.1
  ritskola_1_N = mkN "ritskola" ; -- ritskola..nn.1
  ritt_1_N = mkN "ritt" "ritter" ; -- ritt..nn.1
  ritual_1_N = mkN "ritual" neutrum  ; -- ritual..nn.1
  ritualisera_1_V = mkV "ritualiserar" ; -- ritualisera..vb.1
  ritualiserande_1_N = mkN "ritualiserande" ; -- ritualiserande..nn.1
  ritualiserbar_1_A = mkA "ritualiserbar" ; -- ritualiserbar..av.1
  ritualiserbarhet_1_N = mkN "ritualiserbarhet" ; -- ritualiserbarhet..nn.1
  ritualisering_1_N = mkN "ritualisering" ; -- ritualisering..nn.1
  ritualism_1_N = mkN "ritualism" "ritualismer" ; -- ritualism..nn.1
  ritualistisk_1_A = mkA "ritualistisk" ; -- ritualistisk..av.1
  ritualmord_1_N = mkN "ritualmord" neutrum  ; -- ritualmord..nn.1
  ritualmässig_1_A = mkA "ritualmässig" ; -- ritualmässig..av.1
  rituell_1_A = mkA "rituell" ; -- rituell..av.1
  riv_1_N = mkN "riv" neutrum  ; -- riv..nn.1
  riva_1_V = mkV "riva" "rev" "rivit" ; -- riva..vb.1
  rival_1_N = mkN "rival" "rivaler" ; -- rival..nn.1
  rivalisera_1_V = mkV "rivaliserar" ; -- rivalisera..vb.1
  rivaliserande_1_N = mkN "rivaliserande" ; -- rivaliserande..nn.1
  rivalisering_1_N = mkN "rivalisering" ; -- rivalisering..nn.1
  rivalitet_1_N = mkN "rivalitet" "rivaliteter" ; -- rivalitet..nn.1
  rivande_1_N = mkN "rivande" ; -- rivande..nn.1
  rivebröd_1_N = mkN "rivebröd" neutrum  ; -- rivebröd..nn.1
  rivig_1_A = mkA "rivig" ; -- rivig..av.1
  rivjärn_1_N = mkN "rivjärn" neutrum  ; -- rivjärn..nn.1
  rivning_1_N = mkN "rivning" ; -- rivning..nn.1
  rivningshotad_1_A = mkA "rivningshotad" ; -- rivningshotad..av.1
  rivningshus_1_N = mkN "rivningshus" neutrum  ; -- rivningshus..nn.1
  rivningskontrakt_1_N = mkN "rivningskontrakt" neutrum  ; -- rivningskontrakt..nn.1
  rivningskula_1_N = mkN "rivningskula" ; -- rivningskula..nn.1
  rivningskåk_1_N = mkN "rivningskåk" ; -- rivningskåk..nn.1
  rivningslägenhet_1_N = mkN "rivningslägenhet" "rivningslägenheter" ; -- rivningslägenhet..nn.1
  rivningstomt_1_N = mkN "rivningstomt" "rivningstomter" ; -- rivningstomt..nn.1
  rivstart_1_N = mkN "rivstart" "rivstarter" ; -- rivstart..nn.1
  rivstarta_1_V = mkV "rivstartar" ; -- rivstarta..vb.1
  rivstartande_1_N = mkN "rivstartande" ; -- rivstartande..nn.1
  ro_ro_fartyg_1_N = mkN "ro-ro-fartyg" neutrum  ; -- ro-ro-fartyg..nn.1
  ro_1_N = mkN "ro" ; -- ro..nn.1
  ro_2_N = mkN "ro" "ror" ; -- ro..nn.2
  ro_3_N = mkN "ro" neutrum  ; -- ro..nn.3
  ro_1_V = mkV "ror" ; -- ro..vb.1
  roa_1_V = mkV "roar" ; -- roa..vb.1
  road_1_A = mkA "road" "roat" ; -- road..av.1
  roadie_1_N = mkN "roadie" "roadien" "roadies" "roadiesarna" ; -- roadie..nn.1
  roande_1_N = mkN "roande" ; -- roande..nn.1
  rob_1_N = mkN "rob" "rober" ; -- rob..nn.1
  robbert_1_N = mkN "robbert" ; -- robbert..nn.1
  robe_1_N = mkN "robe" "rober" ; -- robe..nn.1
  robinsonad_1_N = mkN "robinsonad" "robinsonader" ; -- robinsonad..nn.1
  robot_1_N = mkN "robot" ; -- robot..nn.1
  robothandel_1_N = mkN "robothandel" ; -- robothandel..nn.1
  robotisera_1_V = mkV "robotiserar" ; -- robotisera..vb.1
  robotiserande_1_N = mkN "robotiserande" ; -- robotiserande..nn.1
  robotiserbar_1_A = mkA "robotiserbar" ; -- robotiserbar..av.1
  robotiserbarhet_1_N = mkN "robotiserbarhet" ; -- robotiserbarhet..nn.1
  robotisering_1_N = mkN "robotisering" ; -- robotisering..nn.1
  robotkrasch_1_N = mkN "robotkrasch" "robotkrascher" ; -- robotkrasch..nn.1
  robotröst_1_N = mkN "robotröst" "robotröster" ; -- robotröst..nn.1
  robotvapen_1_N = mkN "robotvapen" "robotvapnet" "robotvapen" "robotvapnen" ; -- robotvapen..nn.1
  robust_1_A = mkA "robust" "robust" ; -- robust..av.1
  robusthet_1_N = mkN "robusthet" ; -- robusthet..nn.1
  rock_n_roll_1_N = mkN "rock'n'roll" ; -- rock-n-roll..nn.1
  rock_1_N = mkN "rock" ; -- rock..nn.1
  rock_2_N = mkN "rock" ; -- rock..nn.2
  rocka_1_N = mkN "rocka" ; -- rocka..nn.1
  rocka_1_V = mkV "rockar" ; -- rocka..vb.1
  rockad_1_N = mkN "rockad" "rockader" ; -- rockad..nn.1
  rockande_1_N = mkN "rockande" ; -- rockande..nn.1
  rockare_1_N = mkN "rockare" utrum  ; -- rockare..nn.1
  rockband_1_N = mkN "rockband" neutrum  ; -- rockband..nn.1
  rockera_1_V = mkV "rockerar" ; -- rockera..vb.1
  rockerande_1_N = mkN "rockerande" ; -- rockerande..nn.1
  rockerbar_1_A = mkA "rockerbar" ; -- rockerbar..av.1
  rockerbarhet_1_N = mkN "rockerbarhet" ; -- rockerbarhet..nn.1
  rockering_1_N = mkN "rockering" ; -- rockering..nn.1
  rockfestival_1_N = mkN "rockfestival" "rockfestivaler" ; -- rockfestival..nn.1
  rockficka_1_N = mkN "rockficka" ; -- rockficka..nn.1
  rockgrupp_1_N = mkN "rockgrupp" "rockgrupper" ; -- rockgrupp..nn.1
  rockig_1_A = mkA "rockig" ; -- rockig..av.1
  rockikon_1_N = mkN "rockikon" "rockikoner" ; -- rockikon..nn.1
  rockinspirerad_1_A = mkA "rockinspirerad" ; -- rockinspirerad..av.1
  rockkonsert_1_N = mkN "rockkonsert" "rockkonserter" ; -- rockkonsert..nn.1
  rockmusik_1_N = mkN "rockmusik" ; -- rockmusik..nn.1
  rockmusiker_1_N = mkN "rockmusiker" "rockmusikern" "rockmusiker" "rockmusikerna" ; -- rockmusiker..nn.1
  rockring_1_N = mkN "rockring" ; -- rockring..nn.1
  rockslusk_1_N = mkN "rockslusk" ; -- rockslusk..nn.1
  rockvaktmästare_1_N = mkN "rockvaktmästare" utrum  ; -- rockvaktmästare..nn.1
  rockärm_1_N = mkN "rockärm" ; -- rockärm..nn.1
  rodd_1_N = mkN "rodd" "rodder" ; -- rodd..nn.1
  roddarbänk_1_N = mkN "roddarbänk" ; -- roddarbänk..nn.1
  roddare_1_N = mkN "roddare" utrum  ; -- roddare..nn.1
  roddarlag_1_N = mkN "roddarlag" neutrum  ; -- roddarlag..nn.1
  roddarmadam_1_N = mkN "roddarmadam" "roddarmadammen" "roddarmadammer" "roddarmadammerna" ; -- roddarmadam..nn.1
  roddarslav_1_N = mkN "roddarslav" ; -- roddarslav..nn.1
  roddarsång_1_N = mkN "roddarsång" "roddarsånger" ; -- roddarsång..nn.1
  roddbåt_1_N = mkN "roddbåt" ; -- roddbåt..nn.1
  roddtävling_1_N = mkN "roddtävling" ; -- roddtävling..nn.1
  rodel_1_N = mkN "rodel" ; -- rodel..nn.1
  rodeo_1_N = mkN "rodeo" "rodeor" ; -- rodeo..nn.1
  roder_1_N = mkN "roder" neutrum  ; -- roder..nn.1
  roderblad_1_N = mkN "roderblad" neutrum  ; -- roderblad..nn.1
  roderfel_1_N = mkN "roderfel" "roderfelet" "roderfel" "roderfelen" ; -- roderfel..nn.1
  roderhaveri_1_N = mkN "roderhaveri" "roderhaveriet" "roderhaverier" "roderhaverierna" ; -- roderhaveri..nn.1
  roderlös_1_A = mkA "roderlös" ; -- roderlös..av.1
  roderlöshet_1_N = mkN "roderlöshet" ; -- roderlöshet..nn.1
  rodium_1_N = mkN "rodium" neutrum  ; -- rodium..nn.1
  rodna_1_V = mkV "rodnar" ; -- rodna..vb.1
  rodnad_1_N = mkN "rodnad" "rodnader" ; -- rodnad..nn.1
  rodnande_1_N = mkN "rodnande" ; -- rodnande..nn.1
  rododendron_1_N = mkN "rododendron" "rododendrer" ; -- rododendron..nn.1
  roende_1_N = mkN "roende" ; -- roende..nn.1
  roffa_1_V = mkV "roffar" ; -- roffa..vb.1
  roffande_1_N = mkN "roffande" ; -- roffande..nn.1
  roffare_1_N = mkN "roffare" utrum  ; -- roffare..nn.1
  roffarmentalitet_1_N = mkN "roffarmentalitet" "roffarmentaliteter" ; -- roffarmentalitet..nn.1
  rofferi_1_N = mkN "rofferi" "rofferiet" "rofferier" "rofferierna" ; -- rofferi..nn.1
  rofylld_1_A = mkA "rofylld" "rofyllt" ; -- rofylld..av.1
  rofylldhet_1_N = mkN "rofylldhet" ; -- rofylldhet..nn.1
  rogivande_1_A = mkA "rogivande" ; -- rogivande..av.1
  rojalism_1_N = mkN "rojalism" "rojalismer" ; -- rojalism..nn.1
  rojalist_1_N = mkN "rojalist" "rojalister" ; -- rojalist..nn.1
  rojalistisk_1_A = mkA "rojalistisk" ; -- rojalistisk..av.1
  rokoko_1_N = mkN "rokoko" ; -- rokoko..nn.1
  rokokodam_1_N = mkN "rokokodam" "rokokodamer" ; -- rokokodam..nn.1
  rokokopyntad_1_A = mkA "rokokopyntad" ; -- rokokopyntad..av.1
  rokokostol_1_N = mkN "rokokostol" ; -- rokokostol..nn.1
  rolig_1_A = mkA "rolig" ; -- rolig..av.1
  rolighet_1_N = mkN "rolighet" "roligheter" ; -- rolighet..nn.1
  rolighetsmakare_1_N = mkN "rolighetsmakare" utrum  ; -- rolighetsmakare..nn.1
  rolighetsminister_1_N = mkN "rolighetsminister" ; -- rolighetsminister..nn.1
  roll_on_deodorant_1_N = mkN "roll-on-deodorant" "roll-on-deodoranter" ; -- roll-on-deodorant..nn.1
  roll_on_roll_off_fartyg_1_N = mkN "roll-on/roll-off-fartyg" neutrum  ; -- roll-on-roll-off-fartyg..nn.1
  roll_1_N = mkN "roll" "roller" ; -- roll..nn.1
  roll_2_N = mkN "roll" ; -- roll..nn.2
  rolla_1_V = mkV "rollar" ; -- rolla..vb.1
  rollande_1_N = mkN "rollande" ; -- rollande..nn.1
  rollator_1_N = mkN "rollator" "rollatorer" ; -- rollator..nn.1
  rollbesätta_1_V = mkV "rollbesätta" "rollbesätter" "rollbesätt" "rollbesatte" "rollbesatt" "rollbesatt" ; -- rollbesätta..vb.1
  rollbesättande_1_N = mkN "rollbesättande" ; -- rollbesättande..nn.1
  rollbesättning_1_N = mkN "rollbesättning" ; -- rollbesättning..nn.1
  roller_1_N = mkN "roller" ; -- roller..nn.1
  rollerhandtag_1_N = mkN "rollerhandtag" neutrum  ; -- rollerhandtag..nn.1
  rollfack_1_N = mkN "rollfack" neutrum  ; -- rollfack..nn.1
  rollfigur_1_N = mkN "rollfigur" "rollfigurer" ; -- rollfigur..nn.1
  rollista_1_N = mkN "rollista" ; -- rollista..nn.1
  rollmops_1_N = mkN "rollmops" ; -- rollmops..nn.1
  rolls_1_N = mkN "rolls" ; -- rolls..nn.1
  rollskifte_1_N = mkN "rollskifte" ; -- rollskifte..nn.1
  rollspel_1_N = mkN "rollspel" "rollspelet" "rollspel" "rollspelen" ; -- rollspel..nn.1
  rollsättning_1_N = mkN "rollsättning" ; -- rollsättning..nn.1
  rolltolkning_1_N = mkN "rolltolkning" ; -- rolltolkning..nn.1
  rolös_1_A = mkA "rolös" ; -- rolös..av.1
  rolöshet_1_N = mkN "rolöshet" ; -- rolöshet..nn.1
  rom_2_N = mkN "rom" "romer" ; -- rom..nn.2
  roman_1_N = mkN "roman" "romaner" ; -- roman..nn.1
  romanesk_1_A = mkA "romanesk" ; -- romanesk..av.1
  romanfigur_1_N = mkN "romanfigur" "romanfigurer" ; -- romanfigur..nn.1
  romanförfattare_1_N = mkN "romanförfattare" utrum  ; -- romanförfattare..nn.1
  romangestalt_1_N = mkN "romangestalt" "romangestalter" ; -- romangestalt..nn.1
  romanist_1_N = mkN "romanist" "romanister" ; -- romanist..nn.1
  romanistik_1_N = mkN "romanistik" "romanistiker" ; -- romanistik..nn.1
  romanistisk_1_A = mkA "romanistisk" ; -- romanistisk..av.1
  romans_1_N = mkN "romans" "romanser" ; -- romans..nn.1
  romansk_1_A = mkA "romansk" ; -- romansk..av.1
  romansvit_1_N = mkN "romansvit" "romansviter" ; -- romansvit..nn.1
  romantik_1_N = mkN "romantik" ; -- romantik..nn.1
  romantiker_1_N = mkN "romantiker" "romantikern" "romantiker" "romantikerna" ; -- romantiker..nn.1
  romantisera_1_V = mkV "romantiserar" ; -- romantisera..vb.1
  romantiserande_1_N = mkN "romantiserande" ; -- romantiserande..nn.1
  romantiserbar_1_A = mkA "romantiserbar" ; -- romantiserbar..av.1
  romantiserbarhet_1_N = mkN "romantiserbarhet" ; -- romantiserbarhet..nn.1
  romantisering_1_N = mkN "romantisering" ; -- romantisering..nn.1
  romantisk_1_A = mkA "romantisk" ; -- romantisk..av.1
  romantisk_2_A = mkA "romantisk" ; -- romantisk..av.2
  romantradition_1_N = mkN "romantradition" ; -- romantradition..nn.1
  romanutkast_1_N = mkN "romanutkast" neutrum  ; -- romanutkast..nn.1
  romare_1_N = mkN "romare" utrum  ; -- romare..nn.1
  romarhär_1_N = mkN "romarhär" ; -- romarhär..nn.1
  romarinna_1_N = mkN "romarinna" ; -- romarinna..nn.1
  romarrike_1_N = mkN "romarrike" ; -- romarrike..nn.1
  romartid_1_N = mkN "romartid" ; -- romartid..nn.1
  romb_1_N = mkN "romb" "romber" ; -- romb..nn.1
  rombisk_1_A = mkA "rombisk" ; -- rombisk..av.1
  romboid_1_N = mkN "romboid" "romboider" ; -- romboid..nn.1
  romboidisk_1_A = mkA "romboidisk" ; -- romboidisk..av.1
  romcom_1_N = mkN "romcom" "romcommen" "romcommar" "romcommarna" ; -- romcom..nn.1
  romersk_katolsk_1_A = mkA "romersk-katolsk" ; -- romersk-katolsk..av.1
  romersk_1_A = mkA "romersk" ; -- romersk..av.1
  romkom_1_N = mkN "romkom" "romkommen" "romkommar" "romkommarna" ; -- romkom..nn.1
  romsk_1_A = mkA "romsk" ; -- romsk..av.1
  romska_1_N = mkN "romska" ; -- romska..nn.1
  romska_2_N = mkN "romska" ; -- romska..nn.2
  rond_1_N = mkN "rond" "ronder" ; -- rond..nn.1
  rondell_1_N = mkN "rondell" "rondeller" ; -- rondell..nn.1
  rondellhund_1_N = mkN "rondellhund" ; -- rondellhund..nn.1
  rondo_1_N = mkN "rondo" "rondot" "rondon" "rondona" ; -- rondo..nn.1
  rondör_1_N = mkN "rondör" ; -- rondör..nn.1
  rookie_1_N = mkN "rookie" "rookien" "rookies" "rookiesarna" ; -- rookie..nn.1
  rop_1_N = mkN "rop" neutrum  ; -- rop..nn.1
  ropa_1_V = mkV "ropar" ; -- ropa..vb.1
  ropande_1_N = mkN "ropande" ; -- ropande..nn.1
  ropare_1_N = mkN "ropare" utrum  ; -- ropare..nn.1
  roquefort_1_N = mkN "roquefort" ; -- roquefort..nn.1
  roquefortost_1_N = mkN "roquefortost" ; -- roquefortost..nn.1
  rorgängare_1_N = mkN "rorgängare" utrum  ; -- rorgängare..nn.1
  rorkult_1_N = mkN "rorkult" ; -- rorkult..nn.1
  rorpinne_1_N = mkN "rorpinne" utrum  ; -- rorpinne..nn.1
  rorschachtest_1_N = mkN "rorschachtest" neutrum  ; -- rorschachtest..nn.1
  rorsman_1_N = mkN "rorsman" "rorsmannen" "rorsmän" "rorsmännen" ; -- rorsman..nn.1
  ros_1_N = mkN "ros" "rosor" ; -- ros..nn.1
  ros_2_N = mkN "ros" neutrum  ; -- ros..nn.2
  rosa_1_A = mkA "rosa" ; -- rosa..av.1
  rosa_1_V = mkV "rosar" ; -- rosa..vb.1
  rosafärg_1_N = mkN "rosafärg" ; -- rosafärg..nn.1
  rosafärgad_1_A = mkA "rosafärgad" ; -- rosafärgad..av.1
  rosande_1_N = mkN "rosande" ; -- rosande..nn.1
  rosaskimrande_1_A = mkA "rosaskimrande" ; -- rosaskimrande..av.1
  rosenaktig_1_A = mkA "rosenaktig" ; -- rosenaktig..av.1
  rosenaktighet_1_N = mkN "rosenaktighet" ; -- rosenaktighet..nn.1
  rosenbröd_1_N = mkN "rosenbröd" neutrum  ; -- rosenbröd..nn.1
  rosenbuske_1_N = mkN "rosenbuske" utrum  ; -- rosenbuske..nn.1
  rosende_1_A = mkA "rosende" ; -- rosende..av.1
  rosendoft_1_N = mkN "rosendoft" ; -- rosendoft..nn.1
  rosenfink_1_N = mkN "rosenfink" ; -- rosenfink..nn.1
  rosengång_1_N = mkN "rosengång" ; -- rosengång..nn.1
  rosengård_1_N = mkN "rosengård" ; -- rosengård..nn.1
  rosenkind_1_N = mkN "rosenkind" "rosenkinder" ; -- rosenkind..nn.1
  rosenkindad_1_A = mkA "rosenkindad" ; -- rosenkindad..av.1
  rosenkrans_1_N = mkN "rosenkrans" ; -- rosenkrans..nn.1
  rosenkål_1_N = mkN "rosenkål" ; -- rosenkål..nn.1
  rosenmoln_1_N = mkN "rosenmoln" neutrum  ; -- rosenmoln..nn.1
  rosenmun_1_N = mkN "rosenmun" "rosenmunnen" "rosenmunnar" "rosenmunnarna" ; -- rosenmun..nn.1
  rosenolja_1_N = mkN "rosenolja" ; -- rosenolja..nn.1
  rosenrabatt_1_N = mkN "rosenrabatt" "rosenrabatter" ; -- rosenrabatt..nn.1
  rosenrasande_1_A = mkA "rosenrasande" ; -- rosenrasande..av.1
  rosenröd_1_A = mkA "rosenröd" "rosenrött" ; -- rosenröd..av.1
  rosenskimrande_1_A = mkA "rosenskimrande" ; -- rosenskimrande..av.1
  rosenstock_1_N = mkN "rosenstock" ; -- rosenstock..nn.1
  rosenträ_1_N = mkN "rosenträ" neutrum  ; -- rosenträ..nn.1
  rosett_1_N = mkN "rosett" "rosetter" ; -- rosett..nn.1
  rosettfönster_1_N = mkN "rosettfönster" neutrum  ; -- rosettfönster..nn.1
  rosettmönster_1_N = mkN "rosettmönster" neutrum  ; -- rosettmönster..nn.1
  rosettprydd_1_A = mkA "rosettprydd" ; -- rosettprydd..av.1
  rosettställd_1_A = mkA "rosettställd" "rosettställt" ; -- rosettställd..av.1
  rosförsäljare_1_N = mkN "rosförsäljare" utrum  ; -- rosförsäljare..nn.1
  rosig_1_A = mkA "rosig" ; -- rosig..av.1
  roskarl_1_N = mkN "roskarl" ; -- roskarl..nn.1
  rosling_1_N = mkN "rosling" ; -- rosling..nn.1
  rosmarin_1_N = mkN "rosmarin" "rosmariner" ; -- rosmarin..nn.1
  rospigg_1_N = mkN "rospigg" ; -- rospigg..nn.1
  rossla_1_V = mkV "rosslar" ; -- rossla..vb.1
  rosslande_1_N = mkN "rosslande" ; -- rosslande..nn.1
  rosslig_1_A = mkA "rosslig" ; -- rosslig..av.1
  rosslighet_1_N = mkN "rosslighet" ; -- rosslighet..nn.1
  rossling_1_N = mkN "rossling" ; -- rossling..nn.1
  rost_1_N = mkN "rost" ; -- rost..nn.1
  rost_2_N = mkN "rost" ; -- rost..nn.2
  rosta_1_V = mkV "rostar" ; -- rosta..vb.1
  rosta_2_V = mkV "rostar" ; -- rosta..vb.2
  rostande_1_N = mkN "rostande" ; -- rostande..nn.1
  rostbehandla_1_V = mkV "rostbehandlar" ; -- rostbehandla..vb.1
  rostbehandlande_1_N = mkN "rostbehandlande" ; -- rostbehandlande..nn.1
  rostbiff_1_N = mkN "rostbiff" ; -- rostbiff..nn.1
  rostbrun_1_A = mkA "rostbrun" ; -- rostbrun..av.1
  roster_1_N = mkN "roster" neutrum  ; -- roster..nn.1
  rosteri_1_N = mkN "rosteri" "rosteriet" "rosterier" "rosterierna" ; -- rosteri..nn.1
  rostfläck_1_N = mkN "rostfläck" ; -- rostfläck..nn.1
  rostfläckad_1_A = mkA "rostfläckad" ; -- rostfläckad..av.1
  rostfläckig_1_A = mkA "rostfläckig" ; -- rostfläckig..av.1
  rostfri_1_A = mkA "rostfri" "rostfritt" ; -- rostfri..av.1
  rostig_1_A = mkA "rostig" ; -- rostig..av.1
  rostighet_1_N = mkN "rostighet" ; -- rostighet..nn.1
  rostning_1_N = mkN "rostning" ; -- rostning..nn.1
  roströd_1_A = mkA "roströd" "rostrött" ; -- roströd..av.1
  rostskydd_1_N = mkN "rostskydd" neutrum  ; -- rostskydd..nn.1
  rostskydda_1_V = mkV "rostskyddar" ; -- rostskydda..vb.1
  rostskyddande_1_N = mkN "rostskyddande" ; -- rostskyddande..nn.1
  rostskyddsbehandling_1_N = mkN "rostskyddsbehandling" ; -- rostskyddsbehandling..nn.1
  rostskyddsfärg_1_N = mkN "rostskyddsfärg" "rostskyddsfärger" ; -- rostskyddsfärg..nn.1
  rostskyddsfärgad_1_A = mkA "rostskyddsfärgad" ; -- rostskyddsfärgad..av.1
  rostskyddsmedel_1_N = mkN "rostskyddsmedel" neutrum  ; -- rostskyddsmedel..nn.1
  rostskyddspigment_1_N = mkN "rostskyddspigment" neutrum  ; -- rostskyddspigment..nn.1
  rostsvamp_1_N = mkN "rostsvamp" ; -- rostsvamp..nn.1
  roséminglande_1_A = mkA "roséminglande" ; -- roséminglande..av.1
  roséminglande_1_N = mkN "roséminglande" ; -- roséminglande..nn.1
  rosévin_1_N = mkN "rosévin" "rosévinet" "roséviner" "rosévinerna" ; -- rosévin..nn.1
  rosévinsmingel_1_N = mkN "rosévinsmingel" neutrum  ; -- rosévinsmingel..nn.1
  rot_1_N = mkN "rot" "rötter" ; -- rot..nn.1
  rota_1_V = mkV "rotar" ; -- rota..vb.1
  rotad_1_A = mkA "rotad" ; -- rotad..av.1
  rotande_1_N = mkN "rotande" ; -- rotande..nn.1
  rotation_1_N = mkN "rotation" ; -- rotation..nn.1
  rotationsaxel_1_N = mkN "rotationsaxel" ; -- rotationsaxel..nn.1
  rotationsenergi_1_N = mkN "rotationsenergi" ; -- rotationsenergi..nn.1
  rotationshastighet_1_N = mkN "rotationshastighet" "rotationshastigheter" ; -- rotationshastighet..nn.1
  rotationsmotor_1_N = mkN "rotationsmotor" "rotationsmotorer" ; -- rotationsmotor..nn.1
  rotationspress_1_N = mkN "rotationspress" ; -- rotationspress..nn.1
  rotavdrag_1_N = mkN "rotavdrag" neutrum  ; -- rotavdrag..nn.1
  rotbedragare_1_N = mkN "rotbedragare" utrum  ; -- rotbedragare..nn.1
  rotblad_1_N = mkN "rotblad" neutrum  ; -- rotblad..nn.1
  rotblöta_1_N = mkN "rotblöta" ; -- rotblöta..nn.1
  rotborste_1_N = mkN "rotborste" utrum  ; -- rotborste..nn.1
  rote_1_N = mkN "rote" utrum  ; -- rote..nn.1
  rotel_1_N = mkN "rotel" ; -- rotel..nn.1
  rotenon_1_N = mkN "rotenon" neutrum  ; -- rotenon..nn.1
  rotera_1_V = mkV "roterar" ; -- rotera..vb.1
  roterande_1_N = mkN "roterande" ; -- roterande..nn.1
  roterbar_1_A = mkA "roterbar" ; -- roterbar..av.1
  rotering_1_N = mkN "rotering" ; -- rotering..nn.1
  rotfast_1_A = mkA "rotfast" "rotfast" ; -- rotfast..av.1
  rotfasthet_1_N = mkN "rotfasthet" ; -- rotfasthet..nn.1
  rotfrukt_1_N = mkN "rotfrukt" "rotfrukter" ; -- rotfrukt..nn.1
  rotfylla_1_V = mkV "rotfyller" ; -- rotfylla..vb.1
  rotfyllande_1_N = mkN "rotfyllande" ; -- rotfyllande..nn.1
  rotfyllning_1_N = mkN "rotfyllning" ; -- rotfyllning..nn.1
  rotfäste_1_N = mkN "rotfäste" ; -- rotfäste..nn.1
  rotgrönsak_1_N = mkN "rotgrönsak" "rotgrönsaker" ; -- rotgrönsak..nn.1
  rotisseri_1_N = mkN "rotisseri" "rotisseriet" "rotisserier" "rotisserierna" ; -- rotisseri..nn.1
  rotkanal_1_N = mkN "rotkanal" "rotkanaler" ; -- rotkanal..nn.1
  rotknöl_1_N = mkN "rotknöl" ; -- rotknöl..nn.1
  rotlös_1_A = mkA "rotlös" ; -- rotlös..av.1
  rotlöshet_1_N = mkN "rotlöshet" ; -- rotlöshet..nn.1
  rotmorfem_1_N = mkN "rotmorfem" neutrum  ; -- rotmorfem..nn.1
  rotmos_1_N = mkN "rotmos" neutrum  ; -- rotmos..nn.1
  rotmärke_1_N = mkN "rotmärke" ; -- rotmärke..nn.1
  rotogravyr_1_N = mkN "rotogravyr" "rotogravyrer" ; -- rotogravyr..nn.1
  rotogravyrbild_1_N = mkN "rotogravyrbild" "rotogravyrbilder" ; -- rotogravyrbild..nn.1
  rotor_1_N = mkN "rotor" "rotorer" ; -- rotor..nn.1
  rotorblad_1_N = mkN "rotorblad" neutrum  ; -- rotorblad..nn.1
  rots_1_N = mkN "rots" ; -- rots..nn.1
  rotsak_1_N = mkN "rotsak" "rotsaker" ; -- rotsak..nn.1
  rotskott_1_N = mkN "rotskott" neutrum  ; -- rotskott..nn.1
  rotstock_1_N = mkN "rotstock" ; -- rotstock..nn.1
  rotsystem_1_N = mkN "rotsystem" neutrum  ; -- rotsystem..nn.1
  rottecken_1_N = mkN "rottecken" "rottecknet" "rottecken" "rottecknen" ; -- rottecken..nn.1
  rotting_1_N = mkN "rotting" ; -- rotting..nn.1
  rottingflätning_1_N = mkN "rottingflätning" ; -- rottingflätning..nn.1
  rottingfåtölj_1_N = mkN "rottingfåtölj" "rottingfåtöljer" ; -- rottingfåtölj..nn.1
  rottingsoffa_1_N = mkN "rottingsoffa" ; -- rottingsoffa..nn.1
  rottryck_1_N = mkN "rottryck" neutrum  ; -- rottryck..nn.1
  rottråd_1_N = mkN "rottråd" ; -- rottråd..nn.1
  rottweiler_1_N = mkN "rottweiler" "rottweilern" "rottweiler" "rottweilerna" ; -- rottweiler..nn.1
  rotunda_1_N = mkN "rotunda" ; -- rotunda..nn.1
  rotvälska_1_N = mkN "rotvälska" ; -- rotvälska..nn.1
  rotvälta_1_N = mkN "rotvälta" ; -- rotvälta..nn.1
  rotända_1_N = mkN "rotända" ; -- rotända..nn.1
  rotände_1_N = mkN "rotände" utrum  ; -- rotände..nn.1
  rouge_1_N = mkN "rouge" ; -- rouge..nn.1
  rough_1_N = mkN "rough" ; -- rough..nn.1
  roulad_1_N = mkN "roulad" "roulader" ; -- roulad..nn.1
  roulett_1_N = mkN "roulett" "rouletter" ; -- roulett..nn.1
  roulette_1_N = mkN "roulette" ; -- roulette..nn.1
  roulettespelare_1_N = mkN "roulettespelare" utrum  ; -- roulettespelare..nn.1
  rousseauan_1_N = mkN "rousseauan" "rousseauaner" ; -- rousseauan..nn.1
  rousseauanism_1_N = mkN "rousseauanism" "rousseauanismer" ; -- rousseauanism..nn.1
  route_1_N = mkN "route" "router" ; -- route..nn.1
  router_1_N = mkN "router" ; -- router..nn.1
  roué_1_N = mkN "roué" "rouéer" ; -- roué..nn.1
  rov_1_N = mkN "rov" neutrum  ; -- rov..nn.1
  rova_1_N = mkN "rova" ; -- rova..nn.1
  rovdjur_1_N = mkN "rovdjur" neutrum  ; -- rovdjur..nn.1
  rovdjursjakt_1_N = mkN "rovdjursjakt" "rovdjursjakter" ; -- rovdjursjakt..nn.1
  rovdjursstam_1_N = mkN "rovdjursstam" "rovdjursstammen" "rovdjursstammar" "rovdjursstammarna" ; -- rovdjursstam..nn.1
  rovdrift_1_N = mkN "rovdrift" ; -- rovdrift..nn.1
  rovfisk_1_N = mkN "rovfisk" ; -- rovfisk..nn.1
  rovfiske_1_N = mkN "rovfiske" ; -- rovfiske..nn.1
  rovfågel_1_N = mkN "rovfågel" ; -- rovfågel..nn.1
  rovgirig_1_A = mkA "rovgirig" ; -- rovgirig..av.1
  rovgirighet_1_N = mkN "rovgirighet" ; -- rovgirighet..nn.1
  rovlysten_1_A = mkA "rovlysten" ; -- rovlysten..av.1
  rovlystnad_1_N = mkN "rovlystnad" ; -- rovlystnad..nn.1
  rovriddare_1_N = mkN "rovriddare" utrum  ; -- rovriddare..nn.1
  rovödla_1_N = mkN "rovödla" ; -- rovödla..nn.1
  royalty_1_N = mkN "royalty" "royaltyn" "royalties" "royaltiesarna" ; -- royalty..nn.1
  rubank_1_N = mkN "rubank" ; -- rubank..nn.1
  rubba_1_V = mkV "rubbar" ; -- rubba..vb.1
  rubbad_1_A = mkA "rubbad" ; -- rubbad..av.1
  rubbande_1_N = mkN "rubbande" ; -- rubbande..nn.1
  rubbing_1_N = mkN "rubbing" ; -- rubbing..nn.1
  rubbning_1_N = mkN "rubbning" ; -- rubbning..nn.1
  rubel_1_N = mkN "rubel" "rubeln" "rubler" "rublerna" ; -- rubel..nn.1
  rubidium_1_N = mkN "rubidium" neutrum  ; -- rubidium..nn.1
  rubin_1_N = mkN "rubin" "rubiner" ; -- rubin..nn.1
  rubinglas_1_N = mkN "rubinglas" neutrum  ; -- rubinglas..nn.1
  rubinröd_1_A = mkA "rubinröd" "rubinrött" ; -- rubinröd..av.1
  rubinsamling_1_N = mkN "rubinsamling" ; -- rubinsamling..nn.1
  rubricera_1_V = mkV "rubricerar" ; -- rubricera..vb.1
  rubricerande_1_N = mkN "rubricerande" ; -- rubricerande..nn.1
  rubricerbar_1_A = mkA "rubricerbar" ; -- rubricerbar..av.1
  rubricerbarhet_1_N = mkN "rubricerbarhet" ; -- rubricerbarhet..nn.1
  rubricering_1_N = mkN "rubricering" ; -- rubricering..nn.1
  rubrik_1_N = mkN "rubrik" "rubriker" ; -- rubrik..nn.1
  rubrikmässig_1_A = mkA "rubrikmässig" ; -- rubrikmässig..av.1
  rubrikstil_1_N = mkN "rubrikstil" ; -- rubrikstil..nn.1
  ruccola_1_N = mkN "ruccola" ; -- ruccola..nn.1
  rucka_1_V = mkV "ruckar" ; -- rucka..vb.1
  ruckande_1_N = mkN "ruckande" ; -- ruckande..nn.1
  ruckel_1_N = mkN "ruckel" neutrum  ; -- ruckel..nn.1
  ruckla_1_V = mkV "rucklar" ; -- ruckla..vb.1
  rucklande_1_N = mkN "rucklande" ; -- rucklande..nn.1
  rucklare_1_N = mkN "rucklare" utrum  ; -- rucklare..nn.1
  rucklig_1_A = mkA "rucklig" ; -- rucklig..av.1
  rucklighet_1_N = mkN "rucklighet" ; -- rucklighet..nn.1
  ruckning_1_N = mkN "ruckning" ; -- ruckning..nn.1
  rucola_1_N = mkN "rucola" ; -- rucola..nn.1
  ruda_1_N = mkN "ruda" ; -- ruda..nn.1
  ruderatväxt_1_N = mkN "ruderatväxt" "ruderatväxter" ; -- ruderatväxt..nn.1
  rudiment_1_N = mkN "rudiment" neutrum  ; -- rudiment..nn.1
  rudimentär_1_A = mkA "rudimentär" ; -- rudimentär..av.1
  rudis_1_A = mkA "rudis" ; -- rudis..av.1
  ruelse_1_N = mkN "ruelse" utrum  ; -- ruelse..nn.1
  ruff_1_N = mkN "ruff" ; -- ruff..nn.1
  ruff_2_N = mkN "ruff" ; -- ruff..nn.2
  ruffad_1_A = mkA "ruffad" ; -- ruffad..av.1
  ruffel_1_N = mkN "ruffel" neutrum  ; -- ruffel..nn.1
  ruffhäxa_1_N = mkN "ruffhäxa" ; -- ruffhäxa..nn.1
  ruffig_1_A = mkA "ruffig" ; -- ruffig..av.1
  ruffighet_1_N = mkN "ruffighet" ; -- ruffighet..nn.1
  ruffla_1_V = mkV "rufflar" ; -- ruffla..vb.1
  rufflande_1_N = mkN "rufflande" ; -- rufflande..nn.1
  rufflare_1_N = mkN "rufflare" utrum  ; -- rufflare..nn.1
  rufftak_1_N = mkN "rufftak" neutrum  ; -- rufftak..nn.1
  rufs_1_N = mkN "rufs" neutrum  ; -- rufs..nn.1
  rufsa_1_V = mkV "rufsar" ; -- rufsa..vb.1
  rufsande_1_N = mkN "rufsande" ; -- rufsande..nn.1
  rufsig_1_A = mkA "rufsig" ; -- rufsig..av.1
  rufsighet_1_N = mkN "rufsighet" ; -- rufsighet..nn.1
  rugga_1_V = mkV "ruggar" ; -- rugga..vb.1
  rugga_2_V = mkV "ruggar" ; -- rugga..vb.2
  ruggad_1_A = mkA "ruggad" ; -- ruggad..av.1
  ruggande_1_N = mkN "ruggande" ; -- ruggande..nn.1
  rugge_1_N = mkN "rugg" ; -- rugge..nn.1
  ruggig_1_A = mkA "ruggig" ; -- ruggig..av.1
  ruggighet_1_N = mkN "ruggighet" ; -- ruggighet..nn.1
  ruggning_1_N = mkN "ruggning" ; -- ruggning..nn.1
  ruin_1_N = mkN "ruin" "ruiner" ; -- ruin..nn.1
  ruin_2_N = mkN "ruin" ; -- ruin..nn.2
  ruinera_1_V = mkV "ruinerar" ; -- ruinera..vb.1
  ruinerande_1_N = mkN "ruinerande" ; -- ruinerande..nn.1
  ruinerbar_1_A = mkA "ruinerbar" ; -- ruinerbar..av.1
  ruinerbarhet_1_N = mkN "ruinerbarhet" ; -- ruinerbarhet..nn.1
  ruinering_1_N = mkN "ruinering" ; -- ruinering..nn.1
  ruinhög_1_N = mkN "ruinhög" ; -- ruinhög..nn.1
  ruinstad_1_N = mkN "ruinstad" "ruinstäder" ; -- ruinstad..nn.1
  rulad_1_N = mkN "rulad" "rulader" ; -- rulad..nn.1
  rulett_1_N = mkN "rulett" "ruletter" ; -- rulett..nn.1
  ruljangs_1_N = mkN "ruljangs" ; -- ruljangs..nn.1
  rulla_1_N = mkN "rulla" ; -- rulla..nn.1
  rulla_1_V = mkV "rullar" ; -- rulla..vb.1
  rulla_2_V = mkV "rullar" ; -- rulla..vb.2
  rullad_1_N = mkN "rullad" "rullader" ; -- rullad..nn.1
  rullager_1_N = mkN "rullager" neutrum  ; -- rullager..nn.1
  rullande_1_N = mkN "rullande" ; -- rullande..nn.1
  rullator_1_N = mkN "rullator" "rullatorer" ; -- rullator..nn.1
  rullband_1_N = mkN "rullband" neutrum  ; -- rullband..nn.1
  rullbar_1_A = mkA "rullbar" ; -- rullbar..av.1
  rullbarhet_1_N = mkN "rullbarhet" ; -- rullbarhet..nn.1
  rullbord_1_N = mkN "rullbord" neutrum  ; -- rullbord..nn.1
  rullbräda_1_N = mkN "rullbräda" ; -- rullbräda..nn.1
  rullbräde_1_N = mkN "rullbräde" ; -- rullbräde..nn.1
  rullbälte_1_N = mkN "rullbälte" ; -- rullbälte..nn.1
  rulle_1_N = mkN "rulle" utrum  ; -- rulle..nn.1
  rullgardin_1_N = mkN "rullgardin" "rullgardiner" ; -- rullgardin..nn.1
  rullning_1_N = mkN "rullning" ; -- rullning..nn.1
  rullning_2_N = mkN "rullning" ; -- rullning..nn.2
  rullrev_1_N = mkN "rullrev" neutrum  ; -- rullrev..nn.1
  rullskida_1_N = mkN "rullskida" ; -- rullskida..nn.1
  rullskridsko_1_N = mkN "rullskridsko" "rullskridskor" ; -- rullskridsko..nn.1
  rullskridskobana_1_N = mkN "rullskridskobana" ; -- rullskridskobana..nn.1
  rullsten_1_N = mkN "rullsten" "rullstenen" "rullstenar" "rullstenarna" ; -- rullsten..nn.1
  rullstensås_1_N = mkN "rullstensås" ; -- rullstensås..nn.1
  rullstil_1_N = mkN "rullstil" ; -- rullstil..nn.1
  rullstol_1_N = mkN "rullstol" ; -- rullstol..nn.1
  rullstolsbunden_1_A = mkA "rullstolsbunden" ; -- rullstolsbunden..av.1
  rullstolsburen_1_A = mkA "rullstolsburen" ; -- rullstolsburen..av.1
  rullstolssele_1_N = mkN "rullstolssele" ; -- rullstolssele..nn.1
  rulltrappa_1_N = mkN "rulltrappa" ; -- rulltrappa..nn.1
  rulltrappsräcke_1_N = mkN "rulltrappsräcke" ; -- rulltrappsräcke..nn.1
  rulltårta_1_N = mkN "rulltårta" ; -- rulltårta..nn.1
  rullvagn_1_N = mkN "rullvagn" ; -- rullvagn..nn.1
  rullväska_1_N = mkN "rullväska" ; -- rullväska..nn.1
  rulta_1_N = mkN "rulta" ; -- rulta..nn.1
  rulta_1_V = mkV "rultar" ; -- rulta..vb.1
  rultande_1_N = mkN "rultande" ; -- rultande..nn.1
  rultig_1_A = mkA "rultig" ; -- rultig..av.1
  rultighet_1_N = mkN "rultighet" ; -- rultighet..nn.1
  rum_1_A = mkA "rum" "rumt" "rumma" "rumma" "rummare" "rummast" "rummaste" ; -- rum..av.1
  rum_1_N = mkN "rum" "rummet" "rum" "rummen" ; -- rum..nn.1
  rumba_1_N = mkN "rumba" ; -- rumba..nn.1
  rumhet_1_N = mkN "rumhet" ; -- rumhet..nn.1
  rumla_1_V = mkV "rumlar" ; -- rumla..vb.1
  rumlande_1_N = mkN "rumlande" ; -- rumlande..nn.1
  rumlare_1_N = mkN "rumlare" utrum  ; -- rumlare..nn.1
  rummel_1_N = mkN "rummel" neutrum  ; -- rummel..nn.1
  rumpa_1_N = mkN "rumpa" ; -- rumpa..nn.1
  rumphugga_1_V = mkV "rumphugga" "rumphögg" "rumphuggit" ; -- rumphugga..vb.1
  rumphuggande_1_N = mkN "rumphuggande" ; -- rumphuggande..nn.1
  rumpnisse_1_N = mkN "rumpnisse" utrum  ; -- rumpnisse..nn.1
  rumpsniffare_1_N = mkN "rumpsniffare" utrum  ; -- rumpsniffare..nn.1
  rumpstek_1_N = mkN "rumpstek" ; -- rumpstek..nn.1
  rumptafsare_1_N = mkN "rumptafsare" utrum  ; -- rumptafsare..nn.1
  rumptroll_1_N = mkN "rumptroll" neutrum  ; -- rumptroll..nn.1
  rumpvärmare_1_N = mkN "rumpvärmare" utrum  ; -- rumpvärmare..nn.1
  rumsadverb_1_N = mkN "rumsadverb" neutrum  ; -- rumsadverb..nn.1
  rumsadverbial_1_N = mkN "rumsadverbial" neutrum  ; -- rumsadverbial..nn.1
  rumsarrest_1_N = mkN "rumsarrest" ; -- rumsarrest..nn.1
  rumsbeställning_1_N = mkN "rumsbeställning" ; -- rumsbeställning..nn.1
  rumsbredd_1_N = mkN "rumsbredd" "rumsbredder" ; -- rumsbredd..nn.1
  rumsförmedling_1_N = mkN "rumsförmedling" ; -- rumsförmedling..nn.1
  rumsgranne_1_N = mkN "rumsgranne" utrum  ; -- rumsgranne..nn.1
  rumskamrat_1_N = mkN "rumskamrat" "rumskamrater" ; -- rumskamrat..nn.1
  rumskrökning_1_N = mkN "rumskrökning" ; -- rumskrökning..nn.1
  rumslast_1_N = mkN "rumslast" "rumslaster" ; -- rumslast..nn.1
  rumslig_1_A = mkA "rumslig" ; -- rumslig..av.1
  rumslighet_1_N = mkN "rumslighet" "rumsligheter" ; -- rumslighet..nn.1
  rumsnummer_1_N = mkN "rumsnummer" neutrum  ; -- rumsnummer..nn.1
  rumsren_1_A = mkA "rumsren" "rumsrent" ; -- rumsren..av.1
  rumstemperatur_1_N = mkN "rumstemperatur" "rumstemperaturer" ; -- rumstemperatur..nn.1
  rumstempererad_1_A = mkA "rumstempererad" ; -- rumstempererad..av.1
  rumstera_1_V = mkV "rumsterar" ; -- rumstera..vb.1
  rumsterande_1_N = mkN "rumsterande" ; -- rumsterande..nn.1
  rumstering_1_N = mkN "rumstering" ; -- rumstering..nn.1
  rumstid_1_N = mkN "rumstid" ; -- rumstid..nn.1
  rumsuppfattning_1_N = mkN "rumsuppfattning" ; -- rumsuppfattning..nn.1
  rumsvarm_1_A = mkA "rumsvarm" ; -- rumsvarm..av.1
  rumtid_1_N = mkN "rumtid" ; -- rumtid..nn.1
  rumän_1_N = mkN "rumän" "rumäner" ; -- rumän..nn.1
  rumänsk_fransk_1_A = mkA "rumänsk-fransk" ; -- rumänsk-fransk..av.1
  rumänsk_1_A = mkA "rumänsk" ; -- rumänsk..av.1
  rumänska_1_N = mkN "rumänska" ; -- rumänska..nn.1
  rumänska_2_N = mkN "rumänska" ; -- rumänska..nn.2
  runa_1_N = mkN "runa" ; -- runa..nn.1
  rund_1_A = mkA "rund" ; -- rund..av.1
  runda_1_N = mkN "runda" ; -- runda..nn.1
  runda_1_V = mkV "rundar" ; -- runda..vb.1
  rundabordskonferens_1_N = mkN "rundabordskonferens" "rundabordskonferenser" ; -- rundabordskonferens..nn.1
  rundabordssamtal_1_N = mkN "rundabordssamtal" neutrum  ; -- rundabordssamtal..nn.1
  rundad_1_A = mkA "rundad" ; -- rundad..av.1
  rundande_1_N = mkN "rundande" ; -- rundande..nn.1
  rundbottnad_1_A = mkA "rundbottnad" ; -- rundbottnad..av.1
  rundbrev_1_N = mkN "rundbrev" neutrum  ; -- rundbrev..nn.1
  rundbåge_1_N = mkN "rundbåge" utrum  ; -- rundbåge..nn.1
  rundbågig_1_A = mkA "rundbågig" ; -- rundbågig..av.1
  rundbågsfönster_1_N = mkN "rundbågsfönster" neutrum  ; -- rundbågsfönster..nn.1
  rundbågsvalv_1_N = mkN "rundbågsvalv" neutrum  ; -- rundbågsvalv..nn.1
  rundel_1_N = mkN "rundel" ; -- rundel..nn.1
  rundfil_1_N = mkN "rundfil" ; -- rundfil..nn.1
  rundflygning_1_N = mkN "rundflygning" ; -- rundflygning..nn.1
  rundfråga_1_N = mkN "rundfråga" ; -- rundfråga..nn.1
  rundfrågning_1_N = mkN "rundfrågning" ; -- rundfrågning..nn.1
  rundfönster_1_N = mkN "rundfönster" neutrum  ; -- rundfönster..nn.1
  rundgång_1_N = mkN "rundgång" ; -- rundgång..nn.1
  rundhet_1_N = mkN "rundhet" "rundheter" ; -- rundhet..nn.1
  rundhorisont_1_N = mkN "rundhorisont" "rundhorisonter" ; -- rundhorisont..nn.1
  rundhult_1_N = mkN "rundhult" ; -- rundhult..nn.1
  rundhyllt_1_A = mkA "rundhyllt" "rundhyllt" ; -- rundhyllt..av.1
  rundhyllthet_1_N = mkN "rundhyllthet" ; -- rundhyllthet..nn.1
  rundhäll_1_N = mkN "rundhäll" ; -- rundhäll..nn.1
  rundhänt_1_A = mkA "rundhänt" "rundhänt" ; -- rundhänt..av.1
  rundhänthet_1_N = mkN "rundhänthet" ; -- rundhänthet..nn.1
  rundhövdad_1_A = mkA "rundhövdad" ; -- rundhövdad..av.1
  rundjärn_1_N = mkN "rundjärn" neutrum  ; -- rundjärn..nn.1
  rundklippt_1_A = mkA "rundklippt" "rundklippt" ; -- rundklippt..av.1
  rundkula_1_N = mkN "rundkula" ; -- rundkula..nn.1
  rundkullig_1_A = mkA "rundkullig" ; -- rundkullig..av.1
  rundkullighet_1_N = mkN "rundkullighet" ; -- rundkullighet..nn.1
  rundkyrka_1_N = mkN "rundkyrka" ; -- rundkyrka..nn.1
  rundlagd_1_A = mkA "rundlagd" "rundlagt" ; -- rundlagd..av.1
  rundlagdhet_1_N = mkN "rundlagdhet" ; -- rundlagdhet..nn.1
  rundlig_1_A = mkA "rundlig" ; -- rundlig..av.1
  rundlighet_1_N = mkN "rundlighet" ; -- rundlighet..nn.1
  rundmask_1_N = mkN "rundmask" ; -- rundmask..nn.1
  rundmun_1_N = mkN "rundmun" "rundmunnen" "rundmunnar" "rundmunnarna" ; -- rundmun..nn.1
  rundmålning_1_N = mkN "rundmålning" ; -- rundmålning..nn.1
  rundning_1_N = mkN "rundning" ; -- rundning..nn.1
  rundningsmärke_1_N = mkN "rundningsmärke" ; -- rundningsmärke..nn.1
  rundnätt_1_A = mkA "rundnätt" ; -- rundnätt..av.1
  rundnätthet_1_N = mkN "rundnätthet" ; -- rundnätthet..nn.1
  rundpall_1_N = mkN "rundpall" ; -- rundpall..nn.1
  rundradio_1_N = mkN "rundradio" ; -- rundradio..nn.1
  rundresa_1_N = mkN "rundresa" ; -- rundresa..nn.1
  rundringning_1_N = mkN "rundringning" ; -- rundringning..nn.1
  rundskrivelse_1_N = mkN "rundskrivelse" "rundskrivelser" ; -- rundskrivelse..nn.1
  rundslipad_1_A = mkA "rundslipad" ; -- rundslipad..av.1
  rundsmörja_1_V = mkV "rundsmörja" "rundsmorde" "rundsmort" ; -- rundsmörja..vb.1
  rundsmörjande_1_N = mkN "rundsmörjande" ; -- rundsmörjande..nn.1
  rundsmörjning_1_N = mkN "rundsmörjning" ; -- rundsmörjning..nn.1
  rundsnack_1_N = mkN "rundsnack" neutrum  ; -- rundsnack..nn.1
  rundstav_1_N = mkN "rundstav" ; -- rundstav..nn.1
  rundsticka_1_N = mkN "rundsticka" ; -- rundsticka..nn.1
  rundsticka_1_V = mkV "rundstickar" ; -- rundsticka..vb.1
  rundstickad_1_A = mkA "rundstickad" ; -- rundstickad..av.1
  rundstickande_1_N = mkN "rundstickande" ; -- rundstickande..nn.1
  rundstycke_1_N = mkN "rundstycke" ; -- rundstycke..nn.1
  rundtur_1_N = mkN "rundtur" "rundturer" ; -- rundtur..nn.1
  rundtörn_1_N = mkN "rundtörn" ; -- rundtörn..nn.1
  rundvandring_1_N = mkN "rundvandring" ; -- rundvandring..nn.1
  rundvirke_1_N = mkN "rundvirke" ; -- rundvirke..nn.1
  runga_1_V = mkV "rungar" ; -- runga..vb.1
  rungande_1_N = mkN "rungande" ; -- rungande..nn.1
  runinskrift_1_N = mkN "runinskrift" "runinskrifter" ; -- runinskrift..nn.1
  runk_1_N = mkN "runk" neutrum  ; -- runk..nn.1
  runka_1_V = mkV "runkar" ; -- runka..vb.1
  runkande_1_N = mkN "runkande" ; -- runkande..nn.1
  runkare_1_N = mkN "runkare" utrum  ; -- runkare..nn.1
  runkning_1_N = mkN "runkning" ; -- runkning..nn.1
  runmagi_1_N = mkN "runmagi" ; -- runmagi..nn.1
  runnare_1_N = mkN "runnare" utrum  ; -- runnare..nn.1
  runolog_1_N = mkN "runolog" "runologer" ; -- runolog..nn.1
  runologi_1_N = mkN "runologi" ; -- runologi..nn.1
  runometer_1_N = mkN "runometer" ; -- runometer..nn.1
  runosång_1_N = mkN "runosång" "runosånger" ; -- runosång..nn.1
  runrad_1_N = mkN "runrad" "runrader" ; -- runrad..nn.1
  runristare_1_N = mkN "runristare" utrum  ; -- runristare..nn.1
  runskrift_1_N = mkN "runskrift" "runskrifter" ; -- runskrift..nn.1
  runstav_1_N = mkN "runstav" ; -- runstav..nn.1
  runsten_1_N = mkN "runsten" "runstenen" "runstenar" "runstenarna" ; -- runsten..nn.1
  runstensområde_1_N = mkN "runstensområde" ; -- runstensområde..nn.1
  runstycke_1_N = mkN "runstycke" ; -- runstycke..nn.1
  runtknulleri_1_N = mkN "runtknulleri" neutrum  ; -- runtknulleri..nn.1
  rupie_1_N = mkN "rupie" "rupier" ; -- rupie..nn.1
  ruppad_1_A = mkA "ruppad" ; -- ruppad..av.1
  ruptur_1_N = mkN "ruptur" "rupturer" ; -- ruptur..nn.1
  rural_1_A = mkA "rural" ; -- rural..av.1
  rus_1_N = mkN "rus" neutrum  ; -- rus..nn.1
  rusa_1_V = mkV "rusar" ; -- rusa..vb.1
  rusa_2_V = mkV "rusar" ; -- rusa..vb.2
  rusande_1_N = mkN "rusande" ; -- rusande..nn.1
  rusch_1_N = mkN "rusch" "ruscher" ; -- rusch..nn.1
  ruschelbana_1_N = mkN "ruschelbana" ; -- ruschelbana..nn.1
  ruschelkana_1_N = mkN "ruschelkana" ; -- ruschelkana..nn.1
  ruschig_1_A = mkA "ruschig" ; -- ruschig..av.1
  ruschighet_1_N = mkN "ruschighet" ; -- ruschighet..nn.1
  rusdryck_1_N = mkN "rusdryck" "rusdrycker" ; -- rusdryck..nn.1
  rusdrycksförbud_1_N = mkN "rusdrycksförbud" neutrum  ; -- rusdrycksförbud..nn.1
  rush_1_N = mkN "rush" "rusher" ; -- rush..nn.1
  rusig_1_A = mkA "rusig" ; -- rusig..av.1
  rusighet_1_N = mkN "rusighet" ; -- rusighet..nn.1
  rusk_1_N = mkN "rusk" neutrum  ; -- rusk..nn.1
  ruska_1_N = mkN "ruska" ; -- ruska..nn.1
  ruska_1_V = mkV "ruskar" ; -- ruska..vb.1
  ruska_2_V = mkV "ruskar" ; -- ruska..vb.2
  ruskande_1_N = mkN "ruskande" ; -- ruskande..nn.1
  ruskig_1_A = mkA "ruskig" ; -- ruskig..av.1
  ruskighet_1_N = mkN "ruskighet" "ruskigheter" ; -- ruskighet..nn.1
  ruskning_1_N = mkN "ruskning" ; -- ruskning..nn.1
  ruskprick_1_N = mkN "ruskprick" ; -- ruskprick..nn.1
  ruskväder_1_N = mkN "ruskväder" neutrum  ; -- ruskväder..nn.1
  rusning_1_N = mkN "rusning" ; -- rusning..nn.1
  rusningstid_1_N = mkN "rusningstid" "rusningstider" ; -- rusningstid..nn.1
  rusningstrafik_1_N = mkN "rusningstrafik" ; -- rusningstrafik..nn.1
  russ_1_N = mkN "russ" neutrum  ; -- russ..nn.1
  russificera_1_V = mkV "russificerar" ; -- russificera..vb.1
  russificerande_1_N = mkN "russificerande" ; -- russificerande..nn.1
  russificerbar_1_A = mkA "russificerbar" ; -- russificerbar..av.1
  russificerbarhet_1_N = mkN "russificerbarhet" ; -- russificerbarhet..nn.1
  russificering_1_N = mkN "russificering" ; -- russificering..nn.1
  russifiera_1_V = mkV "russifierar" ; -- russifiera..vb.1
  russifierande_1_N = mkN "russifierande" ; -- russifierande..nn.1
  russifierbar_1_A = mkA "russifierbar" ; -- russifierbar..av.1
  russifierbarhet_1_N = mkN "russifierbarhet" ; -- russifierbarhet..nn.1
  russifiering_1_N = mkN "russifiering" ; -- russifiering..nn.1
  russin_1_N = mkN "russin" neutrum  ; -- russin..nn.1
  rusta_1_V = mkV "rustar" ; -- rusta..vb.1
  rustad_1_A = mkA "rustad" ; -- rustad..av.1
  rustande_1_N = mkN "rustande" ; -- rustande..nn.1
  rustare_1_N = mkN "rustare" utrum  ; -- rustare..nn.1
  rusthåll_1_N = mkN "rusthåll" neutrum  ; -- rusthåll..nn.1
  rusthållare_1_N = mkN "rusthållare" utrum  ; -- rusthållare..nn.1
  rustibuss_1_N = mkN "rustibuss" ; -- rustibuss..nn.1
  rustik_1_A = mkA "rustik" ; -- rustik..av.1
  rustkammare_1_N = mkN "rustkammare" "rustkammaren" "rustkammare" "rustkamrarna" ; -- rustkammare..nn.1
  rustmästare_1_N = mkN "rustmästare" utrum  ; -- rustmästare..nn.1
  rustning_1_N = mkN "rustning" ; -- rustning..nn.1
  rustningskostnad_1_N = mkN "rustningskostnad" "rustningskostnader" ; -- rustningskostnad..nn.1
  rusttjänst_1_N = mkN "rusttjänst" ; -- rusttjänst..nn.1
  ruta_1_N = mkN "ruta" ; -- ruta..nn.1
  rutad_1_A = mkA "rutad" ; -- rutad..av.1
  rutande_1_N = mkN "rutande" ; -- rutande..nn.1
  rutavdrag_1_N = mkN "rutavdrag" neutrum  ; -- rutavdrag..nn.1
  rutchbana_1_N = mkN "rutchbana" ; -- rutchbana..nn.1
  rutchelbana_1_N = mkN "rutchelbana" ; -- rutchelbana..nn.1
  rutchelkana_1_N = mkN "rutchelkana" ; -- rutchelkana..nn.1
  rutchkana_1_N = mkN "rutchkana" ; -- rutchkana..nn.1
  ruten_1_N = mkN "ruten" "rutener" ; -- ruten..nn.1
  rutenium_1_N = mkN "rutenium" neutrum  ; -- rutenium..nn.1
  ruter_1_N = mkN "ruter" "rutern" "ruter" "ruterna" ; -- ruter..nn.1
  ruter_2_N = mkN "ruter" ; -- ruter..nn.2
  rutformig_1_A = mkA "rutformig" ; -- rutformig..av.1
  rutig_1_A = mkA "rutig" ; -- rutig..av.1
  rutighet_1_N = mkN "rutighet" ; -- rutighet..nn.1
  rutin_1_N = mkN "rutin" "rutiner" ; -- rutin..nn.1
  rutin_2_N = mkN "rutin" ; -- rutin..nn.2
  rutinerad_1_A = mkA "rutinerad" ; -- rutinerad..av.1
  rutinmässig_1_A = mkA "rutinmässig" ; -- rutinmässig..av.1
  rutinoperation_1_N = mkN "rutinoperation" ; -- rutinoperation..nn.1
  rutinärende_1_N = mkN "rutinärende" ; -- rutinärende..nn.1
  rutkod_1_N = mkN "rutkod" "rutkoder" ; -- rutkod..nn.1
  rutmönster_1_N = mkN "rutmönster" neutrum  ; -- rutmönster..nn.1
  rutnät_1_N = mkN "rutnät" neutrum  ; -- rutnät..nn.1
  rutpapper_1_N = mkN "rutpapper" neutrum  ; -- rutpapper..nn.1
  rutsch_1_N = mkN "rutsch" ; -- rutsch..nn.1
  rutscha_1_V = mkV "rutschar" ; -- rutscha..vb.1
  rutschande_1_N = mkN "rutschande" ; -- rutschande..nn.1
  rutschbana_1_N = mkN "rutschbana" ; -- rutschbana..nn.1
  rutschelbana_1_N = mkN "rutschelbana" ; -- rutschelbana..nn.1
  rutschelkana_1_N = mkN "rutschelkana" ; -- rutschelkana..nn.1
  rutschkana_1_N = mkN "rutschkana" ; -- rutschkana..nn.1
  rutt_1_N = mkN "rutt" "rutter" ; -- rutt..nn.1
  rutten_1_A = mkA "rutten" ; -- rutten..av.1
  ruttenhet_1_N = mkN "ruttenhet" ; -- ruttenhet..nn.1
  ruttenhet_2_N = mkN "ruttenhet" "ruttenheter" ; -- ruttenhet..nn.2
  ruttna_1_V = mkV "ruttnar" ; -- ruttna..vb.1
  ruttnande_1_N = mkN "ruttnande" ; -- ruttnande..nn.1
  ruva_1_V = mkV "ruvar" ; -- ruva..vb.1
  ruva_2_V = mkV "ruvar" ; -- ruva..vb.2
  ruvande_1_N = mkN "ruvande" ; -- ruvande..nn.1
  ruvlåda_1_N = mkN "ruvlåda" ; -- ruvlåda..nn.1
  ruvning_1_N = mkN "ruvning" ; -- ruvning..nn.1
  ruvningstid_1_N = mkN "ruvningstid" "ruvningstider" ; -- ruvningstid..nn.1
  rwandier_1_N = mkN "rwandier" "rwandiern" "rwandier" "rwandierna" ; -- rwandier..nn.1
  rwandisk_1_A = mkA "rwandisk" ; -- rwandisk..av.1
  rwandiska_1_N = mkN "rwandiska" ; -- rwandiska..nn.1
  rya_1_N = mkN "rya" ; -- rya..nn.1
  rya_1_V = mkV "ryar" ; -- rya..vb.1
  ryande_1_N = mkN "ryande" ; -- ryande..nn.1
  rybs_1_N = mkN "rybs" ; -- rybs..nn.1
  ryck_1_N = mkN "ryck" neutrum  ; -- ryck..nn.1
  ryck_2_N = mkN "ryck" ; -- ryck..nn.2
  rycka_1_V = mkV "rycker" ; -- rycka..vb.1
  ryckande_1_N = mkN "ryckande" ; -- ryckande..nn.1
  ryckig_1_A = mkA "ryckig" ; -- ryckig..av.1
  ryckighet_1_N = mkN "ryckighet" ; -- ryckighet..nn.1
  ryckning_1_N = mkN "ryckning" ; -- ryckning..nn.1
  ryckvis_1_Adv = mkAdv "ryckvis" ; -- ryckvis..ab.1
  rygg_1_N = mkN "rygg" ; -- rygg..nn.1
  rygga_1_N = mkN "rygga" ; -- rygga..nn.1
  rygga_1_V = mkV "ryggar" ; -- rygga..vb.1
  ryggande_1_N = mkN "ryggande" ; -- ryggande..nn.1
  ryggbesvär_1_N = mkN "ryggbesvär" neutrum  ; -- ryggbesvär..nn.1
  ryggbiff_1_N = mkN "ryggbiff" ; -- ryggbiff..nn.1
  ryggbruten_1_A = mkA "ryggbruten" ; -- ryggbruten..av.1
  ryggdunkande_1_A = mkA "ryggdunkande" ; -- ryggdunkande..av.1
  ryggdunkande_1_N = mkN "ryggdunkande" ; -- ryggdunkande..nn.1
  ryggdunkare_1_N = mkN "ryggdunkare" utrum  ; -- ryggdunkare..nn.1
  ryggdunkning_1_N = mkN "ryggdunkning" ; -- ryggdunkning..nn.1
  ryggfena_1_N = mkN "ryggfena" ; -- ryggfena..nn.1
  ryggkliande_1_N = mkN "ryggkliande" ; -- ryggkliande..nn.1
  ryggkota_1_N = mkN "ryggkota" ; -- ryggkota..nn.1
  ryggläge_1_N = mkN "ryggläge" ; -- ryggläge..nn.1
  ryggmuskel_1_N = mkN "ryggmuskel" "ryggmuskeln" "ryggmuskler" "ryggmusklerna" ; -- ryggmuskel..nn.1
  ryggmuskelparalys_1_N = mkN "ryggmuskelparalys" "ryggmuskelparalyser" ; -- ryggmuskelparalys..nn.1
  ryggmärg_1_N = mkN "ryggmärg" ; -- ryggmärg..nn.1
  ryggmärgsbedövning_1_N = mkN "ryggmärgsbedövning" ; -- ryggmärgsbedövning..nn.1
  ryggmärgsmässig_1_A = mkA "ryggmärgsmässig" ; -- ryggmärgsmässig..av.1
  ryggmärgsprov_1_N = mkN "ryggmärgsprov" neutrum  ; -- ryggmärgsprov..nn.1
  ryggmärgsreflex_1_N = mkN "ryggmärgsreflex" "ryggmärgsreflexer" ; -- ryggmärgsreflex..nn.1
  ryggmärgsskadad_1_A = mkA "ryggmärgsskadad" ; -- ryggmärgsskadad..av.1
  ryggning_1_N = mkN "ryggning" ; -- ryggning..nn.1
  ryggont_1_N = mkN "ryggont" neutrum  ; -- ryggont..nn.1
  ryggoperation_1_N = mkN "ryggoperation" ; -- ryggoperation..nn.1
  ryggornament_1_N = mkN "ryggornament" neutrum  ; -- ryggornament..nn.1
  ryggparti_1_N = mkN "ryggparti" "ryggpartiet" "ryggpartier" "ryggpartierna" ; -- ryggparti..nn.1
  ryggrad_1_N = mkN "ryggrad" "ryggrader" ; -- ryggrad..nn.1
  ryggradsdjur_1_N = mkN "ryggradsdjur" neutrum  ; -- ryggradsdjur..nn.1
  ryggradslös_1_A = mkA "ryggradslös" ; -- ryggradslös..av.1
  ryggradslös_2_A = mkA "ryggradslös" ; -- ryggradslös..av.2
  ryggradslöshet_1_N = mkN "ryggradslöshet" ; -- ryggradslöshet..nn.1
  ryggskott_1_N = mkN "ryggskott" neutrum  ; -- ryggskott..nn.1
  ryggsköld_1_N = mkN "ryggsköld" ; -- ryggsköld..nn.1
  ryggslut_1_N = mkN "ryggslut" neutrum  ; -- ryggslut..nn.1
  ryggsträckning_1_N = mkN "ryggsträckning" ; -- ryggsträckning..nn.1
  ryggstöd_1_N = mkN "ryggstöd" neutrum  ; -- ryggstöd..nn.1
  ryggsäck_1_N = mkN "ryggsäck" ; -- ryggsäck..nn.1
  ryggsäcksluffa_1_V = mkV "ryggsäcksluffar" ; -- ryggsäcksluffa..vb.1
  ryggsäcksluffande_1_N = mkN "ryggsäcksluffande" ; -- ryggsäcksluffande..nn.1
  ryggsäcksluffning_1_N = mkN "ryggsäcksluffning" ; -- ryggsäcksluffning..nn.1
  ryggsäcksturism_1_N = mkN "ryggsäcksturism" ; -- ryggsäcksturism..nn.1
  ryggsäcksturist_1_N = mkN "ryggsäcksturist" "ryggsäcksturister" ; -- ryggsäcksturist..nn.1
  ryggtavla_1_N = mkN "ryggtavla" ; -- ryggtavla..nn.1
  ryggtrakt_1_N = mkN "ryggtrakt" "ryggtrakter" ; -- ryggtrakt..nn.1
  ryggvärk_1_N = mkN "ryggvärk" ; -- ryggvärk..nn.1
  ryggås_1_N = mkN "ryggås" ; -- ryggås..nn.1
  ryggåsstuga_1_N = mkN "ryggåsstuga" ; -- ryggåsstuga..nn.1
  ryka_1_V = mkV "ryker" ; -- ryka..vb.1
  rykande_1_N = mkN "rykande" ; -- rykande..nn.1
  rykt_1_N = mkN "rykt" ; -- rykt..nn.1
  rykta_1_V = mkV "ryktar" ; -- rykta..vb.1
  ryktande_1_N = mkN "ryktande" ; -- ryktande..nn.1
  ryktbar_1_A = mkA "ryktbar" ; -- ryktbar..av.1
  ryktbarhet_1_N = mkN "ryktbarhet" "ryktbarheter" ; -- ryktbarhet..nn.1
  ryktborste_1_N = mkN "ryktborste" utrum  ; -- ryktborste..nn.1
  rykte_1_N = mkN "rykte" ; -- rykte..nn.1
  ryktesflora_1_N = mkN "ryktesflora" ; -- ryktesflora..nn.1
  rykteskarusell_1_N = mkN "rykteskarusell" ; -- rykteskarusell..nn.1
  ryktespridning_1_N = mkN "ryktespridning" ; -- ryktespridning..nn.1
  ryktessmidare_1_N = mkN "ryktessmidare" utrum  ; -- ryktessmidare..nn.1
  ryktesspridning_1_N = mkN "ryktesspridning" ; -- ryktesspridning..nn.1
  ryktesvis_1_Adv = mkAdv "ryktesvis" ; -- ryktesvis..ab.1
  ryktskrapa_1_N = mkN "ryktskrapa" ; -- ryktskrapa..nn.1
  rymd_1_N = mkN "rymd" "rymder" ; -- rymd..nn.1
  rymdbiologi_1_N = mkN "rymdbiologi" ; -- rymdbiologi..nn.1
  rymddräkt_1_N = mkN "rymddräkt" "rymddräkter" ; -- rymddräkt..nn.1
  rymdepos_1_N = mkN "rymdepos" neutrum  ; -- rymdepos..nn.1
  rymdfarare_1_N = mkN "rymdfarare" utrum  ; -- rymdfarare..nn.1
  rymdfarkost_1_N = mkN "rymdfarkost" "rymdfarkoster" ; -- rymdfarkost..nn.1
  rymdfart_1_N = mkN "rymdfart" ; -- rymdfart..nn.1
  rymdfartsstyrelse_1_N = mkN "rymdfartsstyrelse" "rymdfartsstyrelser" ; -- rymdfartsstyrelse..nn.1
  rymdfärd_1_N = mkN "rymdfärd" "rymdfärder" ; -- rymdfärd..nn.1
  rymdfärja_1_N = mkN "rymdfärja" ; -- rymdfärja..nn.1
  rymdgeometri_1_N = mkN "rymdgeometri" ; -- rymdgeometri..nn.1
  rymdgrus_1_N = mkN "rymdgrus" neutrum  ; -- rymdgrus..nn.1
  rymdinspirerad_1_A = mkA "rymdinspirerad" ; -- rymdinspirerad..av.1
  rymdkapplöpning_1_N = mkN "rymdkapplöpning" ; -- rymdkapplöpning..nn.1
  rymdkapsel_1_N = mkN "rymdkapsel" ; -- rymdkapsel..nn.1
  rymdmateria_1_N = mkN "rymdmateria" "rymdmaterian" "rymdmaterier" "rymdmaterierna" ; -- rymdmateria..nn.1
  rymdmedicin_1_N = mkN "rymdmedicin" ; -- rymdmedicin..nn.1
  rymdmått_1_N = mkN "rymdmått" neutrum  ; -- rymdmått..nn.1
  rymdpilot_1_N = mkN "rymdpilot" "rymdpiloter" ; -- rymdpilot..nn.1
  rymdprogram_1_N = mkN "rymdprogram" "rymdprogrammet" "rymdprogram" "rymdprogrammen" ; -- rymdprogram..nn.1
  rymdpromenad_1_N = mkN "rymdpromenad" "rymdpromenader" ; -- rymdpromenad..nn.1
  rymdraket_1_N = mkN "rymdraket" "rymdraketer" ; -- rymdraket..nn.1
  rymdresa_1_N = mkN "rymdresa" ; -- rymdresa..nn.1
  rymdsatsning_1_N = mkN "rymdsatsning" ; -- rymdsatsning..nn.1
  rymdskepp_1_N = mkN "rymdskepp" neutrum  ; -- rymdskepp..nn.1
  rymdskrot_1_N = mkN "rymdskrot" neutrum  ; -- rymdskrot..nn.1
  rymdsond_1_N = mkN "rymdsond" "rymdsonder" ; -- rymdsond..nn.1
  rymdstation_1_N = mkN "rymdstation" ; -- rymdstation..nn.1
  rymdstyrelse_1_N = mkN "rymdstyrelse" "rymdstyrelser" ; -- rymdstyrelse..nn.1
  rymdtrafik_1_N = mkN "rymdtrafik" ; -- rymdtrafik..nn.1
  rymdvapen_1_N = mkN "rymdvapen" "rymdvapnet" "rymdvapen" "rymdvapnen" ; -- rymdvapen..nn.1
  rymdvikt_1_N = mkN "rymdvikt" ; -- rymdvikt..nn.1
  rymdvinkel_1_N = mkN "rymdvinkel" ; -- rymdvinkel..nn.1
  rymdålder_1_N = mkN "rymdålder" ; -- rymdålder..nn.1
  rymlig_1_A = mkA "rymlig" ; -- rymlig..av.1
  rymlighet_1_N = mkN "rymlighet" ; -- rymlighet..nn.1
  rymling_1_N = mkN "rymling" ; -- rymling..nn.1
  rymma_1_V = mkV "rymmer" ; -- rymma..vb.1
  rymma_2_V = mkV "rymmer" ; -- rymma..vb.2
  rymmande_1_N = mkN "rymmande" ; -- rymmande..nn.1
  rymmare_1_N = mkN "rymmare" utrum  ; -- rymmare..nn.1
  rymning_1_N = mkN "rymning" ; -- rymning..nn.1
  rymningsbenägen_1_A = mkA "rymningsbenägen" ; -- rymningsbenägen..av.1
  rymningssäker_1_A = mkA "rymningssäker" ; -- rymningssäker..av.1
  rymningssäkerhet_1_N = mkN "rymningssäkerhet" ; -- rymningssäkerhet..nn.1
  rynka_1_N = mkN "rynka" ; -- rynka..nn.1
  rynka_1_V = mkV "rynkar" ; -- rynka..vb.1
  rynkande_1_N = mkN "rynkande" ; -- rynkande..nn.1
  rynkband_1_N = mkN "rynkband" neutrum  ; -- rynkband..nn.1
  rynkfri_1_A = mkA "rynkfri" "rynkfritt" ; -- rynkfri..av.1
  rynkfrihet_1_N = mkN "rynkfrihet" ; -- rynkfrihet..nn.1
  rynkig_1_A = mkA "rynkig" ; -- rynkig..av.1
  rynkighet_1_N = mkN "rynkighet" ; -- rynkighet..nn.1
  rynkning_1_N = mkN "rynkning" ; -- rynkning..nn.1
  ryps_1_N = mkN "ryps" ; -- ryps..nn.1
  rysande_1_N = mkN "rysande" ; -- rysande..nn.1
  rysansvärd_1_A = mkA "rysansvärd" "rysansvärt" ; -- rysansvärd..av.1
  rysansvärdhet_1_N = mkN "rysansvärdhet" ; -- rysansvärdhet..nn.1
  rysare_1_N = mkN "rysare" utrum  ; -- rysare..nn.1
  rysaromröstning_1_N = mkN "rysaromröstning" ; -- rysaromröstning..nn.1
  rysch_1_N = mkN "rysch" neutrum  ; -- rysch..nn.1
  ryschig_1_A = mkA "ryschig" ; -- ryschig..av.1
  ryschighet_1_N = mkN "ryschighet" ; -- ryschighet..nn.1
  rysk_amerikansk_1_A = mkA "rysk-amerikansk" ; -- rysk-amerikansk..av.1
  rysk_1_A = mkA "rysk" ; -- rysk..av.1
  ryska_1_N = mkN "ryska" ; -- ryska..nn.1
  ryska_2_N = mkN "ryska" ; -- ryska..nn.2
  ryskakurs_1_N = mkN "ryskakurs" "ryskakurser" ; -- ryskakurs..nn.1
  ryskalektion_1_N = mkN "ryskalektion" ; -- ryskalektion..nn.1
  ryskalärare_1_N = mkN "ryskalärare" utrum  ; -- ryskalärare..nn.1
  ryskhet_1_N = mkN "ryskhet" ; -- ryskhet..nn.1
  ryskkurs_1_N = mkN "ryskkurs" "ryskkurser" ; -- ryskkurs..nn.1
  rysklektion_1_N = mkN "rysklektion" ; -- rysklektion..nn.1
  rysklärare_1_N = mkN "rysklärare" utrum  ; -- rysklärare..nn.1
  ryskspråkig_1_A = mkA "ryskspråkig" ; -- ryskspråkig..av.1
  ryskspråkighet_1_N = mkN "ryskspråkighet" ; -- ryskspråkighet..nn.1
  rysktalande_1_A = mkA "rysktalande" ; -- rysktalande..av.1
  ryskundervisning_1_N = mkN "ryskundervisning" ; -- ryskundervisning..nn.1
  ryskvänlig_1_A = mkA "ryskvänlig" ; -- ryskvänlig..av.1
  ryskvänlighet_1_N = mkN "ryskvänlighet" ; -- ryskvänlighet..nn.1
  ryslig_1_A = mkA "ryslig" ; -- ryslig..av.1
  ryslighet_1_N = mkN "ryslighet" "rysligheter" ; -- ryslighet..nn.1
  rysning_1_N = mkN "rysning" ; -- rysning..nn.1
  ryss_1_N = mkN "ryss" ; -- ryss..nn.1
  ryssfobi_1_N = mkN "ryssfobi" "ryssfobier" ; -- ryssfobi..nn.1
  ryssgubbe_1_N = mkN "ryssgubbe" utrum  ; -- ryssgubbe..nn.1
  rysshat_1_N = mkN "rysshat" neutrum  ; -- rysshat..nn.1
  ryssja_1_N = mkN "ryssja" ; -- ryssja..nn.1
  rysskräck_1_N = mkN "rysskräck" ; -- rysskräck..nn.1
  rysskyla_1_N = mkN "rysskyla" ; -- rysskyla..nn.1
  ryssläder_1_N = mkN "ryssläder" neutrum  ; -- ryssläder..nn.1
  ryssländare_1_N = mkN "ryssländare" utrum  ; -- ryssländare..nn.1
  ryssländsk_1_A = mkA "ryssländsk" ; -- ryssländsk..av.1
  ryssländska_1_N = mkN "ryssländska" ; -- ryssländska..nn.1
  ryta_1_V = mkV "ryta" "röt" "rutit" ; -- ryta..vb.1
  rytande_1_N = mkN "rytande" ; -- rytande..nn.1
  rytm_1_N = mkN "rytm" "rytmer" ; -- rytm..nn.1
  rytmicitet_1_N = mkN "rytmicitet" "rytmiciteter" ; -- rytmicitet..nn.1
  rytmik_1_N = mkN "rytmik" ; -- rytmik..nn.1
  rytmisera_1_V = mkV "rytmiserar" ; -- rytmisera..vb.1
  rytmiserande_1_N = mkN "rytmiserande" ; -- rytmiserande..nn.1
  rytmiserbar_1_A = mkA "rytmiserbar" ; -- rytmiserbar..av.1
  rytmiserbarhet_1_N = mkN "rytmiserbarhet" ; -- rytmiserbarhet..nn.1
  rytmisering_1_N = mkN "rytmisering" ; -- rytmisering..nn.1
  rytmisk_1_A = mkA "rytmisk" ; -- rytmisk..av.1
  rytmsektion_1_N = mkN "rytmsektion" ; -- rytmsektion..nn.1
  ryttare_1_N = mkN "ryttare" utrum  ; -- ryttare..nn.1
  ryttarfolk_1_N = mkN "ryttarfolk" neutrum  ; -- ryttarfolk..nn.1
  ryttargång_1_N = mkN "ryttargång" ; -- ryttargång..nn.1
  ryttarlek_1_N = mkN "ryttarlek" ; -- ryttarlek..nn.1
  ryttarstaty_1_N = mkN "ryttarstaty" "ryttarstatyer" ; -- ryttarstaty..nn.1
  ryttaruppvisning_1_N = mkN "ryttaruppvisning" ; -- ryttaruppvisning..nn.1
  rytteri_1_N = mkN "rytteri" neutrum  ; -- rytteri..nn.1
  ryttla_1_V = mkV "ryttlar" ; -- ryttla..vb.1
  ryttlande_1_N = mkN "ryttlande" ; -- ryttlande..nn.1
  ryttling_1_N = mkN "ryttling" ; -- ryttling..nn.1
  ryttmästare_1_N = mkN "ryttmästare" utrum  ; -- ryttmästare..nn.1
  räck_1_N = mkN "räck" neutrum  ; -- räck..nn.1
  räcka_1_N = mkN "räcka" ; -- räcka..nn.1
  räcka_1_V = mkV "räcker" ; -- räcka..vb.1
  räcka_2_V = mkV "räcker" ; -- räcka..vb.2
  räckande_1_N = mkN "räckande" ; -- räckande..nn.1
  räcke_1_N = mkN "räcke" ; -- räcke..nn.1
  räckhåll_1_N = mkN "räckhåll" ; -- räckhåll..nn.1
  räckning_1_N = mkN "räckning" ; -- räckning..nn.1
  räckverk_1_N = mkN "räckverk" neutrum  ; -- räckverk..nn.1
  räckvidd_1_N = mkN "räckvidd" "räckvidder" ; -- räckvidd..nn.1
  räd_1_N = mkN "räd" "räder" ; -- räd..nn.1
  rädd_1_A = mkA "rädd" ; -- rädd..av.1
  rädda_1_V = mkV "räddar" ; -- rädda..vb.1
  räddande_1_N = mkN "räddande" ; -- räddande..nn.1
  räddare_1_N = mkN "räddare" utrum  ; -- räddare..nn.1
  räddhet_1_N = mkN "räddhet" ; -- räddhet..nn.1
  räddhåga_1_N = mkN "räddhåga" ; -- räddhåga..nn.1
  räddhågad_1_A = mkA "räddhågad" ; -- räddhågad..av.1
  räddhågsen_1_A = mkA "räddhågsen" ; -- räddhågsen..av.1
  räddning_1_N = mkN "räddning" ; -- räddning..nn.1
  räddningsaktion_1_N = mkN "räddningsaktion" ; -- räddningsaktion..nn.1
  räddningsarbete_1_N = mkN "räddningsarbete" ; -- räddningsarbete..nn.1
  räddningschef_1_N = mkN "räddningschef" "räddningschefer" ; -- räddningschef..nn.1
  räddningsdykare_1_N = mkN "räddningsdykare" utrum  ; -- räddningsdykare..nn.1
  räddningsenhet_1_N = mkN "räddningsenhet" "räddningsenheter" ; -- räddningsenhet..nn.1
  räddningsflyg_1_N = mkN "räddningsflyg" neutrum  ; -- räddningsflyg..nn.1
  räddningshelikopter_1_N = mkN "räddningshelikopter" ; -- räddningshelikopter..nn.1
  räddningshem_1_N = mkN "räddningshem" "räddningshemmet" "räddningshem" "räddningshemmen" ; -- räddningshem..nn.1
  räddningsinsats_1_N = mkN "räddningsinsats" "räddningsinsatser" ; -- räddningsinsats..nn.1
  räddningsklocka_1_N = mkN "räddningsklocka" ; -- räddningsklocka..nn.1
  räddningsledare_1_N = mkN "räddningsledare" utrum  ; -- räddningsledare..nn.1
  räddningslös_1_A = mkA "räddningslös" ; -- räddningslös..av.1
  räddningslöshet_1_N = mkN "räddningslöshet" ; -- räddningslöshet..nn.1
  räddningsoperation_1_N = mkN "räddningsoperation" ; -- räddningsoperation..nn.1
  räddningspaket_1_N = mkN "räddningspaket" neutrum  ; -- räddningspaket..nn.1
  räddningsplan_1_N = mkN "räddningsplan" "räddningsplaner" ; -- räddningsplan..nn.1
  räddningsplanka_1_N = mkN "räddningsplanka" ; -- räddningsplanka..nn.1
  räddningspådrag_1_N = mkN "räddningspådrag" neutrum  ; -- räddningspådrag..nn.1
  räddningsstyrka_1_N = mkN "räddningsstyrka" ; -- räddningsstyrka..nn.1
  räddningstjänst_1_N = mkN "räddningstjänst" "räddningstjänster" ; -- räddningstjänst..nn.1
  rädisa_1_N = mkN "rädisa" ; -- rädisa..nn.1
  rädsel_1_N = mkN "rädsel" ; -- rädsel..nn.1
  rädsla_1_N = mkN "rädsla" ; -- rädsla..nn.1
  räffla_1_N = mkN "räffla" ; -- räffla..nn.1
  räffla_1_V = mkV "räfflar" ; -- räffla..vb.1
  räfflad_1_A = mkA "räfflad" ; -- räfflad..av.1
  räfflande_1_N = mkN "räfflande" ; -- räfflande..nn.1
  räffling_1_N = mkN "räffling" ; -- räffling..nn.1
  räfsa_1_N = mkN "räfsa" ; -- räfsa..nn.1
  räfsa_1_V = mkV "räfsar" ; -- räfsa..vb.1
  räfsande_1_N = mkN "räfsande" ; -- räfsande..nn.1
  räfst_1_N = mkN "räfst" "räfster" ; -- räfst..nn.1
  räjong_1_N = mkN "räjong" "räjonger" ; -- räjong..nn.1
  räka_1_N = mkN "räka" ; -- räka..nn.1
  räkcocktail_1_N = mkN "räkcocktail" ; -- räkcocktail..nn.1
  räkel_1_N = mkN "räkel" ; -- räkel..nn.1
  räkenskap_1_N = mkN "räkenskap" ; -- räkenskap..nn.1
  räkenskapsår_1_N = mkN "räkenskapsår" neutrum  ; -- räkenskapsår..nn.1
  räkfiske_1_N = mkN "räkfiske" ; -- räkfiske..nn.1
  räkfrossa_1_N = mkN "räkfrossa" ; -- räkfrossa..nn.1
  räkkryssning_1_N = mkN "räkkryssning" ; -- räkkryssning..nn.1
  räkmacka_1_N = mkN "räkmacka" ; -- räkmacka..nn.1
  räkna_1_V = mkV "räknar" ; -- räkna..vb.1
  räknande_1_N = mkN "räknande" ; -- räknande..nn.1
  räknare_1_N = mkN "räknare" utrum  ; -- räknare..nn.1
  räkneapparat_1_N = mkN "räkneapparat" "räkneapparater" ; -- räkneapparat..nn.1
  räknedosa_1_N = mkN "räknedosa" ; -- räknedosa..nn.1
  räkneexempel_1_N = mkN "räkneexempel" neutrum  ; -- räkneexempel..nn.1
  räknefel_1_N = mkN "räknefel" "räknefelet" "räknefel" "räknefelen" ; -- räknefel..nn.1
  räknekapacitet_1_N = mkN "räknekapacitet" "räknekapaciteter" ; -- räknekapacitet..nn.1
  räknekonst_1_N = mkN "räknekonst" "räknekonster" ; -- räknekonst..nn.1
  räknemaskin_1_N = mkN "räknemaskin" "räknemaskiner" ; -- räknemaskin..nn.1
  räknenisse_1_N = mkN "räknenisse" utrum  ; -- räknenisse..nn.1
  räkneord_1_N = mkN "räkneord" neutrum  ; -- räkneord..nn.1
  räkneramsa_1_N = mkN "räkneramsa" ; -- räkneramsa..nn.1
  räknesnabbhet_1_N = mkN "räknesnabbhet" "räknesnabbheter" ; -- räknesnabbhet..nn.1
  räknesticka_1_N = mkN "räknesticka" ; -- räknesticka..nn.1
  räknesätt_1_N = mkN "räknesätt" neutrum  ; -- räknesätt..nn.1
  räkneverk_1_N = mkN "räkneverk" neutrum  ; -- räkneverk..nn.1
  räkning_1_N = mkN "räkning" ; -- räkning..nn.1
  räkpaj_1_N = mkN "räkpaj" "räkpajer" ; -- räkpaj..nn.1
  räksallad_1_N = mkN "räksallad" "räksallader" ; -- räksallad..nn.1
  räksmörgås_1_N = mkN "räksmörgås" ; -- räksmörgås..nn.1
  räl_1_N = mkN "räl" "räler" ; -- räl..nn.1
  rälig_1_A = mkA "rälig" ; -- rälig..av.1
  rälighet_1_N = mkN "rälighet" "räligheter" ; -- rälighet..nn.1
  räls_1_N = mkN "räls" ; -- räls..nn.1
  rälsbrott_1_N = mkN "rälsbrott" neutrum  ; -- rälsbrott..nn.1
  rälsbuss_1_N = mkN "rälsbuss" ; -- rälsbuss..nn.1
  rälsbusstation_1_N = mkN "rälsbusstation" ; -- rälsbusstation..nn.1
  rälsfel_1_N = mkN "rälsfel" "rälsfelet" "rälsfel" "rälsfelen" ; -- rälsfel..nn.1
  rämna_1_N = mkN "rämna" ; -- rämna..nn.1
  rämna_1_V = mkV "rämnar" ; -- rämna..vb.1
  rämnande_1_N = mkN "rämnande" ; -- rämnande..nn.1
  ränkfull_1_A = mkA "ränkfull" ; -- ränkfull..av.1
  ränkfullhet_1_N = mkN "ränkfullhet" "ränkfullheter" ; -- ränkfullhet..nn.1
  ränkmakare_1_N = mkN "ränkmakare" utrum  ; -- ränkmakare..nn.1
  ränksmidare_1_N = mkN "ränksmidare" utrum  ; -- ränksmidare..nn.1
  ränksmideri_1_N = mkN "ränksmideri" "ränksmideriet" "ränksmiderier" "ränksmiderierna" ; -- ränksmideri..nn.1
  ränkspel_1_N = mkN "ränkspel" "ränkspelet" "ränkspel" "ränkspelen" ; -- ränkspel..nn.1
  ränn_1_N = mkN "ränn" neutrum  ; -- ränn..nn.1
  ränna_1_N = mkN "ränna" ; -- ränna..nn.1
  ränna_1_V = mkV "ränna" "rände" "ränt" ; -- ränna..vb.1
  rännande_1_N = mkN "rännande" ; -- rännande..nn.1
  rännarbana_1_N = mkN "rännarbana" ; -- rännarbana..nn.1
  rännil_1_N = mkN "rännil" ; -- rännil..nn.1
  ränning_1_N = mkN "ränning" ; -- ränning..nn.1
  rännskita_1_N = mkN "rännskita" ; -- rännskita..nn.1
  rännskita_1_V = mkV "rännskita" "rännsket" "rännskitit" ; -- rännskita..vb.1
  rännsnara_1_N = mkN "rännsnara" ; -- rännsnara..nn.1
  rännsten_1_N = mkN "rännsten" "rännstenen" "rännstenar" "rännstenarna" ; -- rännsten..nn.1
  rännstensunge_1_N = mkN "rännstensunge" utrum  ; -- rännstensunge..nn.1
  ränsel_1_N = mkN "ränsel" ; -- ränsel..nn.1
  ränta_1_N = mkN "ränta" ; -- ränta..nn.1
  räntabel_1_A = mkA "räntabel" ; -- räntabel..av.1
  räntabilitet_1_N = mkN "räntabilitet" "räntabiliteter" ; -- räntabilitet..nn.1
  ränteavdrag_1_N = mkN "ränteavdrag" neutrum  ; -- ränteavdrag..nn.1
  räntebesked_1_N = mkN "räntebesked" neutrum  ; -- räntebesked..nn.1
  räntebärande_1_A = mkA "räntebärande" ; -- räntebärande..av.1
  räntefot_1_N = mkN "räntefot" ; -- räntefot..nn.1
  räntefri_1_A = mkA "räntefri" "räntefritt" ; -- räntefri..av.1
  räntehot_1_N = mkN "räntehot" neutrum  ; -- räntehot..nn.1
  räntehöjning_1_N = mkN "räntehöjning" ; -- räntehöjning..nn.1
  räntemarginal_1_N = mkN "räntemarginal" "räntemarginaler" ; -- räntemarginal..nn.1
  räntenivå_1_N = mkN "räntenivå" "räntenivåer" ; -- räntenivå..nn.1
  ränteoro_1_N = mkN "ränteoro" ; -- ränteoro..nn.1
  räntesats_1_N = mkN "räntesats" "räntesatser" ; -- räntesats..nn.1
  räntesubvention_1_N = mkN "räntesubvention" ; -- räntesubvention..nn.1
  räntesänkning_1_N = mkN "räntesänkning" ; -- räntesänkning..nn.1
  räntetermin_1_N = mkN "räntetermin" "ränteterminer" ; -- räntetermin..nn.1
  räntetryck_1_N = mkN "räntetryck" neutrum  ; -- räntetryck..nn.1
  räntmästare_1_N = mkN "räntmästare" utrum  ; -- räntmästare..nn.1
  rät_1_A = mkA "rät" ; -- rät..av.1
  räta_1_N = mkN "räta" ; -- räta..nn.1
  räta_1_V = mkV "rätar" ; -- räta..vb.1
  rätande_1_N = mkN "rätande" ; -- rätande..nn.1
  rätblock_1_N = mkN "rätblock" neutrum  ; -- rätblock..nn.1
  räthet_1_N = mkN "räthet" ; -- räthet..nn.1
  rätlinjig_1_A = mkA "rätlinjig" ; -- rätlinjig..av.1
  rätlinjighet_1_N = mkN "rätlinjighet" ; -- rätlinjighet..nn.1
  rätning_1_N = mkN "rätning" ; -- rätning..nn.1
  rätoromanska_1_N = mkN "rätoromanska" ; -- rätoromanska..nn.1
  rätsida_1_N = mkN "rätsida" ; -- rätsida..nn.1
  rätskiva_1_N = mkN "rätskiva" ; -- rätskiva..nn.1
  rätstege_1_N = mkN "rätstege" utrum  ; -- rätstege..nn.1
  rätstickad_1_A = mkA "rätstickad" ; -- rätstickad..av.1
  rätstickning_1_N = mkN "rätstickning" ; -- rätstickning..nn.1
  rätt_1_A = mkA "rätt" ; -- rätt..av.1
  rätt_1_N = mkN "rätt" ; -- rätt..nn.1
  rätt_2_N = mkN "rätt" "rätter" ; -- rätt..nn.2
  rätt_3_N = mkN "rätt" "rätter" ; -- rätt..nn.3
  rätta_1_V = mkV "rättar" ; -- rätta..vb.1
  rättande_1_N = mkN "rättande" ; -- rättande..nn.1
  rättare_1_N = mkN "rättare" utrum  ; -- rättare..nn.1
  rättegång_1_N = mkN "rättegång" ; -- rättegång..nn.1
  rättegångsbalk_1_N = mkN "rättegångsbalk" ; -- rättegångsbalk..nn.1
  rättegångsbiträde_1_N = mkN "rättegångsbiträde" ; -- rättegångsbiträde..nn.1
  rättegångsdag_1_N = mkN "rättegångsdag" ; -- rättegångsdag..nn.1
  rättegångsfel_1_N = mkN "rättegångsfel" "rättegångsfelet" "rättegångsfel" "rättegångsfelen" ; -- rättegångsfel..nn.1
  rättegångsmaterial_1_N = mkN "rättegångsmaterial" neutrum  ; -- rättegångsmaterial..nn.1
  rättegångsordning_1_N = mkN "rättegångsordning" ; -- rättegångsordning..nn.1
  rätteligen_1_Adv = mkAdv "rätteligen" ; -- rätteligen..ab.1
  rättelse_1_N = mkN "rättelse" "rättelser" ; -- rättelse..nn.1
  rättesnöre_1_N = mkN "rättesnöre" ; -- rättesnöre..nn.1
  rättfram_1_A = mkA "rättfram" "rättframt" "rättframma" "rättframma" "rättframmare" "rättframmast" "rättframmaste" ; -- rättfram..av.1
  rättframhet_1_N = mkN "rättframhet" "rättframheter" ; -- rättframhet..nn.1
  rättfärdig_1_A = mkA "rättfärdig" ; -- rättfärdig..av.1
  rättfärdiga_1_V = mkV "rättfärdigar" ; -- rättfärdiga..vb.1
  rättfärdigande_1_N = mkN "rättfärdigande" ; -- rättfärdigande..nn.1
  rättfärdiggöra_1_V = mkV "rättfärdiggöra" "rättfärdiggjorde" "rättfärdiggjort" ; -- rättfärdiggöra..vb.1
  rättfärdiggörande_1_N = mkN "rättfärdiggörande" ; -- rättfärdiggörande..nn.1
  rättfärdiggörelse_1_N = mkN "rättfärdiggörelse" utrum  ; -- rättfärdiggörelse..nn.1
  rättfärdighet_1_N = mkN "rättfärdighet" "rättfärdigheter" ; -- rättfärdighet..nn.1
  rätthet_1_N = mkN "rätthet" ; -- rätthet..nn.1
  rättighet_1_N = mkN "rättighet" "rättigheter" ; -- rättighet..nn.1
  rättika_1_N = mkN "rättika" ; -- rättika..nn.1
  rättmätig_1_A = mkA "rättmätig" ; -- rättmätig..av.1
  rättmätighet_1_N = mkN "rättmätighet" ; -- rättmätighet..nn.1
  rättning_1_N = mkN "rättning" ; -- rättning..nn.1
  rättroende_1_A = mkA "rättroende" ; -- rättroende..av.1
  rättrogen_1_A = mkA "rättrogen" ; -- rättrogen..av.1
  rättrogenhet_1_N = mkN "rättrogenhet" ; -- rättrogenhet..nn.1
  rättrådig_1_A = mkA "rättrådig" ; -- rättrådig..av.1
  rättrådighet_1_N = mkN "rättrådighet" ; -- rättrådighet..nn.1
  rättsanspråk_1_N = mkN "rättsanspråk" neutrum  ; -- rättsanspråk..nn.1
  rättsbegrepp_1_N = mkN "rättsbegrepp" neutrum  ; -- rättsbegrepp..nn.1
  rättsbetjänt_1_N = mkN "rättsbetjänt" "rättsbetjänter" ; -- rättsbetjänt..nn.1
  rättsbildning_1_N = mkN "rättsbildning" ; -- rättsbildning..nn.1
  rättschef_1_N = mkN "rättschef" "rättschefer" ; -- rättschef..nn.1
  rättsenlig_1_A = mkA "rättsenlig" ; -- rättsenlig..av.1
  rättsenlighet_1_N = mkN "rättsenlighet" ; -- rättsenlighet..nn.1
  rättsexpert_1_N = mkN "rättsexpert" "rättsexperter" ; -- rättsexpert..nn.1
  rättsfall_1_N = mkN "rättsfall" neutrum  ; -- rättsfall..nn.1
  rättsfilosofi_1_N = mkN "rättsfilosofi" ; -- rättsfilosofi..nn.1
  rättsfråga_1_N = mkN "rättsfråga" ; -- rättsfråga..nn.1
  rättsförfarande_1_N = mkN "rättsförfarande" ; -- rättsförfarande..nn.1
  rättsförmåga_1_N = mkN "rättsförmåga" ; -- rättsförmåga..nn.1
  rättsgiltig_1_A = mkA "rättsgiltig" ; -- rättsgiltig..av.1
  rättsgiltighet_1_N = mkN "rättsgiltighet" ; -- rättsgiltighet..nn.1
  rättsgrund_1_N = mkN "rättsgrund" "rättsgrunder" ; -- rättsgrund..nn.1
  rättshaveri_1_N = mkN "rättshaveri" neutrum  ; -- rättshaveri..nn.1
  rättshaverist_1_N = mkN "rättshaverist" "rättshaverister" ; -- rättshaverist..nn.1
  rättshaveristisk_1_A = mkA "rättshaveristisk" ; -- rättshaveristisk..av.1
  rättshaveristiskhet_1_N = mkN "rättshaveristiskhet" ; -- rättshaveristiskhet..nn.1
  rättshjälp_1_N = mkN "rättshjälp" ; -- rättshjälp..nn.1
  rättshjälpskontor_1_N = mkN "rättshjälpskontor" neutrum  ; -- rättshjälpskontor..nn.1
  rättsinformation_1_N = mkN "rättsinformation" ; -- rättsinformation..nn.1
  rättsinnad_1_A = mkA "rättsinnad" ; -- rättsinnad..av.1
  rättsinne_1_N = mkN "rättsinne" ; -- rättsinne..nn.1
  rättsinnehavare_1_N = mkN "rättsinnehavare" utrum  ; -- rättsinnehavare..nn.1
  rättsinnig_1_A = mkA "rättsinnig" ; -- rättsinnig..av.1
  rättsinnighet_1_N = mkN "rättsinnighet" ; -- rättsinnighet..nn.1
  rättsint_1_A = mkA "rättsint" "rättsint" ; -- rättsint..av.1
  rättsinthet_1_N = mkN "rättsinthet" ; -- rättsinthet..nn.1
  rättskaffenhet_1_N = mkN "rättskaffenhet" ; -- rättskaffenhet..nn.1
  rättskaffens_1_A = mkA "rättskaffens" ; -- rättskaffens..av.1
  rättskapacitet_1_N = mkN "rättskapacitet" "rättskapaciteter" ; -- rättskapacitet..nn.1
  rättskemi_1_N = mkN "rättskemi" ; -- rättskemi..nn.1
  rättskipning_1_N = mkN "rättskipning" ; -- rättskipning..nn.1
  rättskrav_1_N = mkN "rättskrav" neutrum  ; -- rättskrav..nn.1
  rättskrivning_1_N = mkN "rättskrivning" ; -- rättskrivning..nn.1
  rättskränkning_1_N = mkN "rättskränkning" ; -- rättskränkning..nn.1
  rättskänsla_1_N = mkN "rättskänsla" ; -- rättskänsla..nn.1
  rättslig_1_A = mkA "rättslig" ; -- rättslig..av.1
  rättslighet_1_N = mkN "rättslighet" ; -- rättslighet..nn.1
  rättsläge_1_N = mkN "rättsläge" ; -- rättsläge..nn.1
  rättsläkare_1_N = mkN "rättsläkare" utrum  ; -- rättsläkare..nn.1
  rättsläkarutlåtande_1_N = mkN "rättsläkarutlåtande" ; -- rättsläkarutlåtande..nn.1
  rättslära_1_N = mkN "rättslära" ; -- rättslära..nn.1
  rättslös_1_A = mkA "rättslös" ; -- rättslös..av.1
  rättslöshet_1_N = mkN "rättslöshet" ; -- rättslöshet..nn.1
  rättsmedicin_1_N = mkN "rättsmedicin" ; -- rättsmedicin..nn.1
  rättsmedicinalverk_1_N = mkN "rättsmedicinalverk" neutrum  ; -- rättsmedicinalverk..nn.1
  rättsmedicinsk_1_A = mkA "rättsmedicinsk" ; -- rättsmedicinsk..av.1
  rättsmedvetande_1_N = mkN "rättsmedvetande" ; -- rättsmedvetande..nn.1
  rättsnorm_1_N = mkN "rättsnorm" "rättsnormer" ; -- rättsnorm..nn.1
  rättsordning_1_N = mkN "rättsordning" ; -- rättsordning..nn.1
  rättsosäkerhet_1_N = mkN "rättsosäkerhet" "rättsosäkerheter" ; -- rättsosäkerhet..nn.1
  rättspolitik_1_N = mkN "rättspolitik" ; -- rättspolitik..nn.1
  rättspolitisk_1_A = mkA "rättspolitisk" ; -- rättspolitisk..av.1
  rättsprincip_1_N = mkN "rättsprincip" "rättsprinciper" ; -- rättsprincip..nn.1
  rättspsykiatri_1_N = mkN "rättspsykiatri" ; -- rättspsykiatri..nn.1
  rättspsykiatriker_1_N = mkN "rättspsykiatriker" "rättspsykiatrikern" "rättspsykiatriker" "rättspsykiatrikerna" ; -- rättspsykiatriker..nn.1
  rättspsykiatrisk_1_A = mkA "rättspsykiatrisk" ; -- rättspsykiatrisk..av.1
  rättspåföljd_1_N = mkN "rättspåföljd" "rättspåföljder" ; -- rättspåföljd..nn.1
  rättsregel_1_N = mkN "rättsregel" "rättsregeln" "rättsregler" "rättsreglerna" ; -- rättsregel..nn.1
  rättsröta_1_N = mkN "rättsröta" ; -- rättsröta..nn.1
  rättssak_1_N = mkN "rättssak" "rättssaker" ; -- rättssak..nn.1
  rättssal_1_N = mkN "rättssal" ; -- rättssal..nn.1
  rättssamhälle_1_N = mkN "rättssamhälle" ; -- rättssamhälle..nn.1
  rättsskandal_1_N = mkN "rättsskandal" "rättsskandaler" ; -- rättsskandal..nn.1
  rättsskipning_1_N = mkN "rättsskipning" ; -- rättsskipning..nn.1
  rättsstat_1_N = mkN "rättsstat" "rättsstater" ; -- rättsstat..nn.1
  rättsstatlig_1_A = mkA "rättsstatlig" ; -- rättsstatlig..av.1
  rättsstridig_1_A = mkA "rättsstridig" ; -- rättsstridig..av.1
  rättsstridighet_1_N = mkN "rättsstridighet" ; -- rättsstridighet..nn.1
  rättssubjekt_1_N = mkN "rättssubjekt" neutrum  ; -- rättssubjekt..nn.1
  rättssystem_1_N = mkN "rättssystem" neutrum  ; -- rättssystem..nn.1
  rättssäker_1_A = mkA "rättssäker" ; -- rättssäker..av.1
  rättssäkerhet_1_N = mkN "rättssäkerhet" "rättssäkerheter" ; -- rättssäkerhet..nn.1
  rättssäkerhetsintresse_1_N = mkN "rättssäkerhetsintresse" ; -- rättssäkerhetsintresse..nn.1
  rättstavning_1_N = mkN "rättstavning" ; -- rättstavning..nn.1
  rättstillämpning_1_N = mkN "rättstillämpning" ; -- rättstillämpning..nn.1
  rättstjänare_1_N = mkN "rättstjänare" utrum  ; -- rättstjänare..nn.1
  rättstvist_1_N = mkN "rättstvist" "rättstvister" ; -- rättstvist..nn.1
  rättsuppfattning_1_N = mkN "rättsuppfattning" ; -- rättsuppfattning..nn.1
  rättsvetenskap_1_N = mkN "rättsvetenskap" ; -- rättsvetenskap..nn.1
  rättsvidrig_1_A = mkA "rättsvidrig" ; -- rättsvidrig..av.1
  rättsvidrighet_1_N = mkN "rättsvidrighet" ; -- rättsvidrighet..nn.1
  rättsväsen_1_N = mkN "rättsväsen" neutrum  ; -- rättsväsen..nn.1
  rättsväsende_1_N = mkN "rättsväsende" ; -- rättsväsende..nn.1
  rättsvårdande_1_A = mkA "rättsvårdande" ; -- rättsvårdande..av.1
  rättsövergrepp_1_N = mkN "rättsövergrepp" neutrum  ; -- rättsövergrepp..nn.1
  rättvis_1_A = mkA "rättvis" ; -- rättvis..av.1
  rättvisa_1_N = mkN "rättvisa" ; -- rättvisa..nn.1
  rättvisande_1_A = mkA "rättvisande" ; -- rättvisande..av.1
  rättviseengagemang_1_N = mkN "rättviseengagemang" neutrum  ; -- rättviseengagemang..nn.1
  rättviseideal_1_N = mkN "rättviseideal" neutrum  ; -- rättviseideal..nn.1
  rättvisekrävande_1_A = mkA "rättvisekrävande" ; -- rättvisekrävande..av.1
  rättvisemärkning_1_N = mkN "rättvisemärkning" ; -- rättvisemärkning..nn.1
  rättvisemärkt_1_A = mkA "rättvisemärkt" "rättvisemärkt" ; -- rättvisemärkt..av.1
  rättvisemässig_1_A = mkA "rättvisemässig" ; -- rättvisemässig..av.1
  rättvisepatos_1_N = mkN "rättvisepatos" neutrum  ; -- rättvisepatos..nn.1
  rättviseperspektiv_1_N = mkN "rättviseperspektiv" neutrum  ; -- rättviseperspektiv..nn.1
  rättänkande_1_A = mkA "rättänkande" ; -- rättänkande..av.1
  rätvinge_1_N = mkN "rätvinge" utrum  ; -- rätvinge..nn.1
  rätvinklig_1_A = mkA "rätvinklig" ; -- rätvinklig..av.1
  rätvinklighet_1_N = mkN "rätvinklighet" ; -- rätvinklighet..nn.1
  räv_1_N = mkN "räv" ; -- räv..nn.1
  rävaktig_1_A = mkA "rävaktig" ; -- rävaktig..av.1
  rävaktighet_1_N = mkN "rävaktighet" ; -- rävaktighet..nn.1
  rävfarm_1_N = mkN "rävfarm" ; -- rävfarm..nn.1
  rävgift_1_N = mkN "rävgift" neutrum  ; -- rävgift..nn.1
  rävhund_1_N = mkN "rävhund" ; -- rävhund..nn.1
  rävjakt_1_N = mkN "rävjakt" "rävjakter" ; -- rävjakt..nn.1
  rävpäls_1_N = mkN "rävpäls" ; -- rävpäls..nn.1
  rävrumpa_1_N = mkN "rävrumpa" ; -- rävrumpa..nn.1
  rävsax_1_N = mkN "rävsax" ; -- rävsax..nn.1
  rävspel_1_N = mkN "rävspel" "rävspelet" "rävspel" "rävspelen" ; -- rävspel..nn.1
  rävsvans_1_N = mkN "rävsvans" ; -- rävsvans..nn.1
  rå_1_A = mkA "rå" "rått" ; -- rå..av.1
  rå_1_N = mkN "rå" "rån" "rår" "rårna" ; -- rå..nn.1
  rå_2_N = mkN "rå" "rån" "rån" "råna" ; -- rå..nn.2
  rå_3_N = mkN "rå" "råt" "rår" "rårna" ; -- rå..nn.3
  rå_1_V = mkV "rå" "rådde" "rått" ; -- rå..vb.1
  rå_2_V = mkV "rår" ; -- rå..vb.2
  råband_1_N = mkN "råband" neutrum  ; -- råband..nn.1
  råbandsknop_1_N = mkN "råbandsknop" ; -- råbandsknop..nn.1
  råbarkad_1_A = mkA "råbarkad" ; -- råbarkad..av.1
  råbiff_1_N = mkN "råbiff" ; -- råbiff..nn.1
  råbock_1_N = mkN "råbock" ; -- råbock..nn.1
  råd_1_N = mkN "råd" neutrum  ; -- råd..nn.1
  råd_2_N = mkN "råd" neutrum  ; -- råd..nn.2
  råd_3_N = mkN "råd" ; -- råd..nn.3
  råda_1_V = mkV "råda" "rådde" "rått" ; -- råda..vb.1
  rådande_1_A = mkA "rådande" ; -- rådande..av.1
  rådande_1_N = mkN "rådande" ; -- rådande..nn.1
  rådbråka_1_V = mkV "rådbråkar" ; -- rådbråka..vb.1
  rådbråkande_1_N = mkN "rådbråkande" ; -- rådbråkande..nn.1
  rådbråkning_1_N = mkN "rådbråkning" ; -- rådbråkning..nn.1
  råddig_1_A = mkA "råddig" ; -- råddig..av.1
  råddighet_1_N = mkN "råddighet" ; -- råddighet..nn.1
  rådfråga_1_V = mkV "rådfrågar" ; -- rådfråga..vb.1
  rådfrågande_1_N = mkN "rådfrågande" ; -- rådfrågande..nn.1
  rådfrågning_1_N = mkN "rådfrågning" ; -- rådfrågning..nn.1
  rådföra_1_V = mkV "rådföra" "rådförde" "rådfört" ; -- rådföra..vb.1
  rådförande_1_N = mkN "rådförande" ; -- rådförande..nn.1
  rådgivande_1_A = mkA "rådgivande" ; -- rådgivande..av.1
  rådgivare_1_N = mkN "rådgivare" utrum  ; -- rådgivare..nn.1
  rådgivning_1_N = mkN "rådgivning" ; -- rådgivning..nn.1
  rådgöra_1_V = mkV "rådgöra" "rådgjorde" "rådgjort" ; -- rådgöra..vb.1
  rådgörande_1_N = mkN "rådgörande" ; -- rådgörande..nn.1
  rådhus_1_N = mkN "rådhus" neutrum  ; -- rådhus..nn.1
  rådhuskällare_1_N = mkN "rådhuskällare" utrum  ; -- rådhuskällare..nn.1
  rådhusrätt_1_N = mkN "rådhusrätt" "rådhusrätter" ; -- rådhusrätt..nn.1
  rådig_1_A = mkA "rådig" ; -- rådig..av.1
  rådighet_1_N = mkN "rådighet" ; -- rådighet..nn.1
  rådjur_1_N = mkN "rådjur" neutrum  ; -- rådjur..nn.1
  rådjursjakt_1_N = mkN "rådjursjakt" ; -- rådjursjakt..nn.1
  rådjurskid_1_N = mkN "rådjurskid" neutrum  ; -- rådjurskid..nn.1
  rådjursolycka_1_N = mkN "rådjursolycka" ; -- rådjursolycka..nn.1
  rådjurssadel_1_N = mkN "rådjurssadel" ; -- rådjurssadel..nn.1
  rådkammare_1_N = mkN "rådkammare" "rådkammaren" "rådkammare" "rådkamrarna" ; -- rådkammare..nn.1
  rådlig_1_A = mkA "rådlig" ; -- rådlig..av.1
  rådlighet_1_N = mkN "rådlighet" ; -- rådlighet..nn.1
  rådlägga_1_V = mkV "rådlägga" "rådla" "rådlagt" ; -- rådlägga..vb.1
  rådläggande_1_N = mkN "rådläggande" ; -- rådläggande..nn.1
  rådlös_1_A = mkA "rådlös" ; -- rådlös..av.1
  rådlöshet_1_N = mkN "rådlöshet" ; -- rådlöshet..nn.1
  rådman_1_N = mkN "rådman" "rådmannen" "rådmän" "rådmännen" ; -- rådman..nn.1
  rådpläga_1_V = mkV "rådplägar" ; -- rådpläga..vb.1
  rådplägande_1_N = mkN "rådplägande" ; -- rådplägande..nn.1
  rådplägning_1_N = mkN "rådplägning" ; -- rådplägning..nn.1
  rådsal_1_N = mkN "rådsal" ; -- rådsal..nn.1
  rådsbord_1_N = mkN "rådsbord" neutrum  ; -- rådsbord..nn.1
  rådsförsamling_1_N = mkN "rådsförsamling" ; -- rådsförsamling..nn.1
  rådsherre_1_N = mkN "rådsherre" utrum  ; -- rådsherre..nn.1
  rådslag_1_N = mkN "rådslag" neutrum  ; -- rådslag..nn.1
  rådslut_1_N = mkN "rådslut" neutrum  ; -- rådslut..nn.1
  rådslå_1_V = mkV "rådslå" "rådslog" "rådslagit" ; -- rådslå..vb.1
  rådslående_1_N = mkN "rådslående" ; -- rådslående..nn.1
  rådsnar_1_A = mkA "rådsnar" ; -- rådsnar..av.1
  rådsrepublik_1_N = mkN "rådsrepublik" "rådsrepubliker" ; -- rådsrepublik..nn.1
  rådstu_1_N = mkN "rådstu" ; -- rådstu..nn.1
  rådstuga_1_N = mkN "rådstuga" ; -- rådstuga..nn.1
  rådstugurätt_1_N = mkN "rådstugurätt" "rådstugurätter" ; -- rådstugurätt..nn.1
  rådsturätt_1_N = mkN "rådsturätt" "rådsturätter" ; -- rådsturätt..nn.1
  rådstuvurätt_1_N = mkN "rådstuvurätt" "rådstuvurätter" ; -- rådstuvurätt..nn.1
  rådvill_1_A = mkA "rådvill" ; -- rådvill..av.1
  rådvillhet_1_N = mkN "rådvillhet" ; -- rådvillhet..nn.1
  rående_1_N = mkN "rående" ; -- rående..nn.1
  råg_1_N = mkN "råg" ; -- råg..nn.1
  råga_1_V = mkV "rågar" ; -- råga..vb.1
  rågande_1_N = mkN "rågande" ; -- rågande..nn.1
  rågblond_1_A = mkA "rågblond" ; -- rågblond..av.1
  rågblondhet_1_N = mkN "rågblondhet" ; -- rågblondhet..nn.1
  rågbröd_1_N = mkN "rågbröd" neutrum  ; -- rågbröd..nn.1
  råge_1_N = mkN "råge" utrum  ; -- råge..nn.1
  råget_1_N = mkN "råget" "rågetter" ; -- råget..nn.1
  rågkorn_1_N = mkN "rågkorn" neutrum  ; -- rågkorn..nn.1
  råglas_1_N = mkN "råglas" neutrum  ; -- råglas..nn.1
  råglimpa_1_N = mkN "råglimpa" ; -- råglimpa..nn.1
  rågmjöl_1_N = mkN "rågmjöl" neutrum  ; -- rågmjöl..nn.1
  rågmjölsgröt_1_N = mkN "rågmjölsgröt" ; -- rågmjölsgröt..nn.1
  rågsikt_1_N = mkN "rågsikt" ; -- rågsikt..nn.1
  rågåker_1_N = mkN "rågåker" ; -- rågåker..nn.1
  rågång_1_N = mkN "rågång" ; -- rågång..nn.1
  råhet_1_N = mkN "råhet" "råheter" ; -- råhet..nn.1
  råk_1_N = mkN "råk" ; -- råk..nn.1
  råk_2_N = mkN "råk" ; -- råk..nn.2
  råka_1_N = mkN "råka" ; -- råka..nn.1
  råka_1_V = mkV "råkar" ; -- råka..vb.1
  råkall_1_A = mkA "råkall" ; -- råkall..av.1
  råkande_1_N = mkN "råkande" ; -- råkande..nn.1
  råkopia_1_N = mkN "råkopia" ; -- råkopia..nn.1
  råkost_1_N = mkN "råkost" ; -- råkost..nn.1
  råkostaffär_1_N = mkN "råkostaffär" "råkostaffärer" ; -- råkostaffär..nn.1
  råkurr_1_N = mkN "råkurr" neutrum  ; -- råkurr..nn.1
  råma_1_V = mkV "råmar" ; -- råma..vb.1
  råmande_1_N = mkN "råmande" ; -- råmande..nn.1
  råmaterial_1_N = mkN "råmaterial" neutrum  ; -- råmaterial..nn.1
  råmjölk_1_N = mkN "råmjölk" ; -- råmjölk..nn.1
  råmning_1_N = mkN "råmning" ; -- råmning..nn.1
  råmärke_1_N = mkN "råmärke" ; -- råmärke..nn.1
  rån_1_N = mkN "rån" neutrum  ; -- rån..nn.1
  råna_1_V = mkV "rånar" ; -- råna..vb.1
  rånande_1_N = mkN "rånande" ; -- rånande..nn.1
  rånare_1_N = mkN "rånare" utrum  ; -- rånare..nn.1
  rånarhuva_1_N = mkN "rånarhuva" ; -- rånarhuva..nn.1
  rånarluva_1_N = mkN "rånarluva" ; -- rånarluva..nn.1
  rånbyte_1_N = mkN "rånbyte" ; -- rånbyte..nn.1
  rånförsök_1_N = mkN "rånförsök" neutrum  ; -- rånförsök..nn.1
  rånmord_1_N = mkN "rånmord" neutrum  ; -- rånmord..nn.1
  rånmördare_1_N = mkN "rånmördare" utrum  ; -- rånmördare..nn.1
  rånock_1_N = mkN "rånock" ; -- rånock..nn.1
  rånutveckling_1_N = mkN "rånutveckling" ; -- rånutveckling..nn.1
  rånvåg_1_N = mkN "rånvåg" "rånvågor" ; -- rånvåg..nn.1
  råolja_1_N = mkN "råolja" ; -- råolja..nn.1
  råoljemotor_1_N = mkN "råoljemotor" "råoljemotorer" ; -- råoljemotor..nn.1
  råoljeprisdipp_1_N = mkN "råoljeprisdipp" ; -- råoljeprisdipp..nn.1
  råplugg_1_N = mkN "råplugg" neutrum  ; -- råplugg..nn.1
  råplugga_1_V = mkV "råpluggar" ; -- råplugga..vb.1
  råpluggande_1_N = mkN "råpluggande" ; -- råpluggande..nn.1
  råraka_1_N = mkN "råraka" ; -- råraka..nn.1
  råris_1_N = mkN "råris" neutrum  ; -- råris..nn.1
  råriva_1_V = mkV "råriva" "rårev" "rårivit" ; -- råriva..vb.1
  rårivande_1_N = mkN "rårivande" ; -- rårivande..nn.1
  rårörd_1_A = mkA "rårörd" "rårört" ; -- rårörd..av.1
  råsallad_1_N = mkN "råsallad" "råsallader" ; -- råsallad..nn.1
  råsegel_1_N = mkN "råsegel" neutrum  ; -- råsegel..nn.1
  råseglare_1_N = mkN "råseglare" utrum  ; -- råseglare..nn.1
  råsiden_1_N = mkN "råsiden" neutrum  ; -- råsiden..nn.1
  råskala_1_V = mkV "råskalar" ; -- råskala..vb.1
  råskalande_1_N = mkN "råskalande" ; -- råskalande..nn.1
  råskinn_1_N = mkN "råskinn" neutrum  ; -- råskinn..nn.1
  råskälla_1_V = mkV "råskäller" ; -- råskälla..vb.1
  råskällande_1_N = mkN "råskällande" ; -- råskällande..nn.1
  råsocker_1_N = mkN "råsocker" neutrum  ; -- råsocker..nn.1
  råsockerfabrik_1_N = mkN "råsockerfabrik" "råsockerfabriker" ; -- råsockerfabrik..nn.1
  råsop_1_N = mkN "råsop" ; -- råsop..nn.1
  råsteka_1_V = mkV "råsteker" ; -- råsteka..vb.1
  råstekande_1_N = mkN "råstekande" ; -- råstekande..nn.1
  råstyrka_1_N = mkN "råstyrka" ; -- råstyrka..nn.1
  råtacklad_1_A = mkA "råtacklad" ; -- råtacklad..av.1
  råtegel_1_N = mkN "råtegel" neutrum  ; -- råtegel..nn.1
  råtta_1_N = mkN "råtta" ; -- råtta..nn.1
  råttbo_1_N = mkN "råttbo" "råttboet" "råttbon" "råttbona" ; -- råttbo..nn.1
  råttdjur_1_N = mkN "råttdjur" neutrum  ; -- råttdjur..nn.1
  råttfrat_1_N = mkN "råttfrat" neutrum  ; -- råttfrat..nn.1
  råttfälla_1_N = mkN "råttfälla" ; -- råttfälla..nn.1
  råttgift_1_N = mkN "råttgift" neutrum  ; -- råttgift..nn.1
  råtthål_1_N = mkN "råtthål" neutrum  ; -- råtthål..nn.1
  råttskit_1_N = mkN "råttskit" ; -- råttskit..nn.1
  råttsvans_1_N = mkN "råttsvans" ; -- råttsvans..nn.1
  råttäten_1_A = mkA "råttäten" ; -- råttäten..av.1
  råvara_1_N = mkN "råvara" ; -- råvara..nn.1
  råvaruekonomi_1_N = mkN "råvaruekonomi" "råvaruekonomier" ; -- råvaruekonomi..nn.1
  råvaruförsörjning_1_N = mkN "råvaruförsörjning" ; -- råvaruförsörjning..nn.1
  råvarumässig_1_A = mkA "råvarumässig" ; -- råvarumässig..av.1
  råämne_1_N = mkN "råämne" ; -- råämne..nn.1
  rö_1_N = mkN "rö" "röet" "rön" "röna" ; -- rö..nn.1
  röd_1_A = mkA "röd" "rött" ; -- röd..av.1
  rödaktig_1_A = mkA "rödaktig" ; -- rödaktig..av.1
  rödaktighet_1_N = mkN "rödaktighet" ; -- rödaktighet..nn.1
  rödbena_1_N = mkN "rödbena" ; -- rödbena..nn.1
  rödbeta_1_N = mkN "rödbeta" ; -- rödbeta..nn.1
  rödbetssallad_1_N = mkN "rödbetssallad" "rödbetssallader" ; -- rödbetssallad..nn.1
  rödblind_1_A = mkA "rödblind" ; -- rödblind..av.1
  rödblindhet_1_N = mkN "rödblindhet" ; -- rödblindhet..nn.1
  rödblommig_1_A = mkA "rödblommig" ; -- rödblommig..av.1
  rödblond_1_A = mkA "rödblond" ; -- rödblond..av.1
  rödblondhet_1_N = mkN "rödblondhet" ; -- rödblondhet..nn.1
  rödblå_1_A = mkA "rödblå" "rödblått" ; -- rödblå..av.1
  rödbok_1_N = mkN "rödbok" ; -- rödbok..nn.1
  rödbrokig_1_A = mkA "rödbrokig" ; -- rödbrokig..av.1
  rödbrun_1_A = mkA "rödbrun" ; -- rödbrun..av.1
  rödbrusig_1_A = mkA "rödbrusig" ; -- rödbrusig..av.1
  rödbrusighet_1_N = mkN "rödbrusighet" ; -- rödbrusighet..nn.1
  rödbränd_1_A = mkA "rödbränd" ; -- rödbränd..av.1
  rödfilter_1_N = mkN "rödfilter" neutrum  ; -- rödfilter..nn.1
  rödflammande_1_A = mkA "rödflammande" ; -- rödflammande..av.1
  rödflammig_1_A = mkA "rödflammig" ; -- rödflammig..av.1
  rödflammighet_1_N = mkN "rödflammighet" ; -- rödflammighet..nn.1
  rödfnasig_1_A = mkA "rödfnasig" ; -- rödfnasig..av.1
  rödfärg_1_N = mkN "rödfärg" ; -- rödfärg..nn.1
  rödfärgad_1_A = mkA "rödfärgad" ; -- rödfärgad..av.1
  rödfärgning_1_N = mkN "rödfärgning" ; -- rödfärgning..nn.1
  rödförskjutning_1_N = mkN "rödförskjutning" ; -- rödförskjutning..nn.1
  rödglödga_1_V = mkV "rödglödgar" ; -- rödglödga..vb.1
  rödglödgande_1_N = mkN "rödglödgande" ; -- rödglödgande..nn.1
  rödgråten_1_A = mkA "rödgråten" ; -- rödgråten..av.1
  rödgrön_1_A = mkA "rödgrön" ; -- rödgrön..av.1
  rödgrönblind_1_A = mkA "rödgrönblind" ; -- rödgrönblind..av.1
  rödgrönblindhet_1_N = mkN "rödgrönblindhet" ; -- rödgrönblindhet..nn.1
  rödgul_1_A = mkA "rödgul" ; -- rödgul..av.1
  rödhake_1_N = mkN "rödhake" utrum  ; -- rödhake..nn.1
  rödhakesångare_1_N = mkN "rödhakesångare" utrum  ; -- rödhakesångare..nn.1
  rödhet_1_A = mkA "rödhet" ; -- rödhet..av.1
  rödhet_1_N = mkN "rödhet" ; -- rödhet..nn.1
  rödhårig_1_A = mkA "rödhårig" ; -- rödhårig..av.1
  rödhårighet_1_N = mkN "rödhårighet" ; -- rödhårighet..nn.1
  röding_1_N = mkN "röding" ; -- röding..nn.1
  rödkantad_1_A = mkA "rödkantad" ; -- rödkantad..av.1
  rödkindad_1_A = mkA "rödkindad" ; -- rödkindad..av.1
  rödklint_1_N = mkN "rödklint" ; -- rödklint..nn.1
  rödklöver_1_N = mkN "rödklöver" ; -- rödklöver..nn.1
  rödkål_1_N = mkN "rödkål" ; -- rödkål..nn.1
  rödlila_1_A = mkA "rödlila" ; -- rödlila..av.1
  rödlista_1_N = mkN "rödlista" ; -- rödlista..nn.1
  rödlista_1_V = mkV "rödlistar" ; -- rödlista..vb.1
  rödlistande_1_N = mkN "rödlistande" ; -- rödlistande..nn.1
  rödlistning_1_N = mkN "rödlistning" ; -- rödlistning..nn.1
  rödlätt_1_A = mkA "rödlätt" ; -- rödlätt..av.1
  rödlätthet_1_N = mkN "rödlätthet" ; -- rödlätthet..nn.1
  rödlök_1_N = mkN "rödlök" ; -- rödlök..nn.1
  rödmosig_1_A = mkA "rödmosig" ; -- rödmosig..av.1
  rödmosighet_1_N = mkN "rödmosighet" ; -- rödmosighet..nn.1
  rödmyra_1_N = mkN "rödmyra" ; -- rödmyra..nn.1
  rödmålad_1_A = mkA "rödmålad" ; -- rödmålad..av.1
  rödnäst_1_A = mkA "rödnäst" "rödnäst" ; -- rödnäst..av.1
  rödnästhet_1_N = mkN "rödnästhet" ; -- rödnästhet..nn.1
  rödockra_1_N = mkN "rödockra" ; -- rödockra..nn.1
  rödpenna_1_N = mkN "rödpenna" ; -- rödpenna..nn.1
  rödprickig_1_A = mkA "rödprickig" ; -- rödprickig..av.1
  rödpunktsikte_1_N = mkN "rödpunktsikte" ; -- rödpunktsikte..nn.1
  rödpunktssikte_1_N = mkN "rödpunktssikte" ; -- rödpunktssikte..nn.1
  rödrandig_1_A = mkA "rödrandig" ; -- rödrandig..av.1
  rödräv_1_N = mkN "rödräv" ; -- rödräv..nn.1
  rödskimrande_1_A = mkA "rödskimrande" ; -- rödskimrande..av.1
  rödskinn_1_N = mkN "rödskinn" neutrum  ; -- rödskinn..nn.1
  rödsot_1_N = mkN "rödsot" ; -- rödsot..nn.1
  rödspotta_1_N = mkN "rödspotta" ; -- rödspotta..nn.1
  rödspov_1_N = mkN "rödspov" ; -- rödspov..nn.1
  rödsprit_1_N = mkN "rödsprit" ; -- rödsprit..nn.1
  rödsprängd_1_A = mkA "rödsprängd" "rödsprängt" ; -- rödsprängd..av.1
  rödsprängdhet_1_N = mkN "rödsprängdhet" ; -- rödsprängdhet..nn.1
  rödspätta_1_N = mkN "rödspätta" ; -- rödspätta..nn.1
  rödstjärt_1_N = mkN "rödstjärt" ; -- rödstjärt..nn.1
  rödstrumpa_1_N = mkN "rödstrumpa" ; -- rödstrumpa..nn.1
  rödtjut_1_N = mkN "rödtjut" neutrum  ; -- rödtjut..nn.1
  rödtunga_1_N = mkN "rödtunga" ; -- rödtunga..nn.1
  rödvin_1_N = mkN "rödvin" "rödvinet" "rödviner" "rödvinerna" ; -- rödvin..nn.1
  rödvingetrast_1_N = mkN "rödvingetrast" ; -- rödvingetrast..nn.1
  rödvit_1_A = mkA "rödvit" ; -- rödvit..av.1
  rödvitrandig_1_A = mkA "rödvitrandig" ; -- rödvitrandig..av.1
  rödväppling_1_N = mkN "rödväppling" ; -- rödväppling..nn.1
  rödögd_1_A = mkA "rödögd" "rödögt" ; -- rödögd..av.1
  rödögdhet_1_N = mkN "rödögdhet" ; -- rödögdhet..nn.1
  röja_1_V = mkV "röja" "röjde" "röjt" ; -- röja..vb.1
  röja_2_V = mkV "röja" "röjde" "röjt" ; -- röja..vb.2
  röjande_1_N = mkN "röjande" ; -- röjande..nn.1
  röjarskiva_1_N = mkN "röjarskiva" ; -- röjarskiva..nn.1
  röjdykare_1_N = mkN "röjdykare" utrum  ; -- röjdykare..nn.1
  röjel_1_N = mkN "röjel" ; -- röjel..nn.1
  röjning_1_N = mkN "röjning" ; -- röjning..nn.1
  röjningsarbete_1_N = mkN "röjningsarbete" ; -- röjningsarbete..nn.1
  röjsåg_1_N = mkN "röjsåg" ; -- röjsåg..nn.1
  rök_1_N = mkN "rök" ; -- rök..nn.1
  röka_1_V = mkV "röker" ; -- röka..vb.1
  rökande_1_N = mkN "rökande" ; -- rökande..nn.1
  rökare_1_N = mkN "rökare" utrum  ; -- rökare..nn.1
  rökavvänjning_1_N = mkN "rökavvänjning" ; -- rökavvänjning..nn.1
  rökblå_1_A = mkA "rökblå" "rökblått" ; -- rökblå..av.1
  rökbomb_1_N = mkN "rökbomb" "rökbomber" ; -- rökbomb..nn.1
  rökbord_1_N = mkN "rökbord" neutrum  ; -- rökbord..nn.1
  rökdetektor_1_N = mkN "rökdetektor" "rökdetektorer" ; -- rökdetektor..nn.1
  rökdykare_1_N = mkN "rökdykare" utrum  ; -- rökdykare..nn.1
  rökdykning_1_N = mkN "rökdykning" ; -- rökdykning..nn.1
  rökelse_1_N = mkN "rökelse" "rökelser" ; -- rökelse..nn.1
  rökelsekar_1_N = mkN "rökelsekar" neutrum  ; -- rökelsekar..nn.1
  rökelsesvärtad_1_A = mkA "rökelsesvärtad" ; -- rökelsesvärtad..av.1
  rökeri_1_N = mkN "rökeri" "rökeriet" "rökerier" "rökerierna" ; -- rökeri..nn.1
  rökfri_1_A = mkA "rökfri" "rökfritt" ; -- rökfri..av.1
  rökfärgad_1_A = mkA "rökfärgad" ; -- rökfärgad..av.1
  rökfång_1_N = mkN "rökfång" neutrum  ; -- rökfång..nn.1
  rökförbud_1_N = mkN "rökförbud" neutrum  ; -- rökförbud..nn.1
  rökgas_1_N = mkN "rökgas" "rökgaser" ; -- rökgas..nn.1
  rökgranat_1_N = mkN "rökgranat" "rökgranater" ; -- rökgranat..nn.1
  rökgrå_1_A = mkA "rökgrå" "rökgrått" ; -- rökgrå..av.1
  rökgång_1_N = mkN "rökgång" ; -- rökgång..nn.1
  rökgård_1_N = mkN "rökgård" ; -- rökgård..nn.1
  rökheroin_1_N = mkN "rökheroin" "rökheroiner" ; -- rökheroin..nn.1
  rökhosta_1_N = mkN "rökhosta" ; -- rökhosta..nn.1
  rökig_1_A = mkA "rökig" ; -- rökig..av.1
  rökighet_1_N = mkN "rökighet" ; -- rökighet..nn.1
  rökkanal_1_N = mkN "rökkanal" "rökkanaler" ; -- rökkanal..nn.1
  rökkupé_1_N = mkN "rökkupé" "rökkupéer" ; -- rökkupé..nn.1
  röklukt_1_N = mkN "röklukt" ; -- röklukt..nn.1
  rökmani_1_N = mkN "rökmani" "rökmanier" ; -- rökmani..nn.1
  rökmask_1_N = mkN "rökmask" "rökmasker" ; -- rökmask..nn.1
  rökmoln_1_N = mkN "rökmoln" neutrum  ; -- rökmoln..nn.1
  rökning_1_N = mkN "rökning" ; -- rökning..nn.1
  rökpelare_1_N = mkN "rökpelare" utrum  ; -- rökpelare..nn.1
  rökpuff_1_N = mkN "rökpuff" ; -- rökpuff..nn.1
  rökridå_1_N = mkN "rökridå" "rökridåer" ; -- rökridå..nn.1
  rökring_1_N = mkN "rökring" ; -- rökring..nn.1
  rökrock_1_N = mkN "rökrock" ; -- rökrock..nn.1
  rökruta_1_N = mkN "rökruta" ; -- rökruta..nn.1
  röksignal_1_N = mkN "röksignal" "röksignaler" ; -- röksignal..nn.1
  rökskadad_1_A = mkA "rökskadad" ; -- rökskadad..av.1
  rökslinga_1_N = mkN "rökslinga" ; -- rökslinga..nn.1
  rökspiral_1_N = mkN "rökspiral" "rökspiraler" ; -- rökspiral..nn.1
  rökstrimma_1_N = mkN "rökstrimma" ; -- rökstrimma..nn.1
  röksugen_1_A = mkA "röksugen" ; -- röksugen..av.1
  röksvag_1_A = mkA "röksvag" ; -- röksvag..av.1
  röksvaghet_1_N = mkN "röksvaghet" ; -- röksvaghet..nn.1
  röksvamp_1_N = mkN "röksvamp" ; -- röksvamp..nn.1
  röksvärtad_1_A = mkA "röksvärtad" ; -- röksvärtad..av.1
  rökt_1_A = mkA "rökt" "rökt" ; -- rökt..av.1
  rökthet_1_N = mkN "rökthet" ; -- rökthet..nn.1
  röktopas_1_N = mkN "röktopas" "röktopaser" ; -- röktopas..nn.1
  rökutveckling_1_N = mkN "rökutveckling" ; -- rökutveckling..nn.1
  rökverk_1_N = mkN "rökverk" neutrum  ; -- rökverk..nn.1
  rölakan_1_N = mkN "rölakan" neutrum  ; -- rölakan..nn.1
  röllakan_1_N = mkN "röllakan" neutrum  ; -- röllakan..nn.1
  rölleka_1_N = mkN "rölleka" ; -- rölleka..nn.1
  röllika_1_N = mkN "röllika" ; -- röllika..nn.1
  rön_1_N = mkN "rön" neutrum  ; -- rön..nn.1
  röna_1_V = mkV "röna" "röner" "rön" "rönte" "rönt" "rönt" ; -- röna..vb.1
  rönande_1_N = mkN "rönande" ; -- rönande..nn.1
  rönn_1_N = mkN "rönn" ; -- rönn..nn.1
  rönnbär_1_N = mkN "rönnbär" neutrum  ; -- rönnbär..nn.1
  rönnbärsfilosofi_1_N = mkN "rönnbärsfilosofi" ; -- rönnbärsfilosofi..nn.1
  röntga_1_V = mkV "röntgar" ; -- röntga..vb.1
  röntgande_1_N = mkN "röntgande" ; -- röntgande..nn.1
  röntgenapparat_1_N = mkN "röntgenapparat" "röntgenapparater" ; -- röntgenapparat..nn.1
  röntgenbehandling_1_N = mkN "röntgenbehandling" ; -- röntgenbehandling..nn.1
  röntgenbild_1_N = mkN "röntgenbild" "röntgenbilder" ; -- röntgenbild..nn.1
  röntgenblick_1_N = mkN "röntgenblick" ; -- röntgenblick..nn.1
  röntgendiagnostik_1_N = mkN "röntgendiagnostik" ; -- röntgendiagnostik..nn.1
  röntgenfotografera_1_V = mkV "röntgenfotograferar" ; -- röntgenfotografera..vb.1
  röntgenfotograferande_1_N = mkN "röntgenfotograferande" ; -- röntgenfotograferande..nn.1
  röntgenfotograferbar_1_A = mkA "röntgenfotograferbar" ; -- röntgenfotograferbar..av.1
  röntgenfotograferbarhet_1_N = mkN "röntgenfotograferbarhet" ; -- röntgenfotograferbarhet..nn.1
  röntgenfotografering_1_N = mkN "röntgenfotografering" ; -- röntgenfotografering..nn.1
  röntgenkamera_1_N = mkN "röntgenkamera" ; -- röntgenkamera..nn.1
  röntgenmikroskop_1_N = mkN "röntgenmikroskop" neutrum  ; -- röntgenmikroskop..nn.1
  röntgenrör_1_N = mkN "röntgenrör" neutrum  ; -- röntgenrör..nn.1
  röntgenstrålande_1_A = mkA "röntgenstrålande" ; -- röntgenstrålande..av.1
  röntgenstråle_1_N = mkN "röntgenstråle" utrum  ; -- röntgenstråle..nn.1
  röntgenstrålning_1_N = mkN "röntgenstrålning" ; -- röntgenstrålning..nn.1
  röntgentid_1_N = mkN "röntgentid" "röntgentider" ; -- röntgentid..nn.1
  röntgenundersökning_1_N = mkN "röntgenundersökning" ; -- röntgenundersökning..nn.1
  rör_mig_ej_1_N = mkN "rör-mig-ej" ; -- rör-mig-ej..nn.1
  rör_1_N = mkN "rör" neutrum  ; -- rör..nn.1
  röra_1_N = mkN "röra" ; -- röra..nn.1
  röra_2_N = mkN "röra" ; -- röra..nn.2
  röra_1_V = mkV "röra" "rörde" "rört" ; -- röra..vb.1
  rörande_1_A = mkA "rörande" ; -- rörande..av.1
  rörande_1_N = mkN "rörande" ; -- rörande..nn.1
  rörblad_1_N = mkN "rörblad" neutrum  ; -- rörblad..nn.1
  rörbrunn_1_N = mkN "rörbrunn" ; -- rörbrunn..nn.1
  rörd_1_A = mkA "rörd" "rört" ; -- rörd..av.1
  rördhet_1_N = mkN "rördhet" ; -- rördhet..nn.1
  rördrom_1_N = mkN "rördrom" "rördrommen" "rördrommar" "rördrommarna" ; -- rördrom..nn.1
  rörelse_1_N = mkN "rörelse" "rörelser" ; -- rörelse..nn.1
  rörelsecentrum_1_N = mkN "rörelsecentrum" neutrum  ; -- rörelsecentrum..nn.1
  rörelsedetektor_1_N = mkN "rörelsedetektor" "rörelsedetektorer" ; -- rörelsedetektor..nn.1
  rörelsedrivande_1_A = mkA "rörelsedrivande" ; -- rörelsedrivande..av.1
  rörelseenergi_1_N = mkN "rörelseenergi" ; -- rörelseenergi..nn.1
  rörelsefrihet_1_N = mkN "rörelsefrihet" "rörelsefriheter" ; -- rörelsefrihet..nn.1
  rörelseförmåga_1_N = mkN "rörelseförmåga" ; -- rörelseförmåga..nn.1
  rörelsegivare_1_N = mkN "rörelsegivare" utrum  ; -- rörelsegivare..nn.1
  rörelsehindrad_1_A = mkA "rörelsehindrad" ; -- rörelsehindrad..av.1
  rörelseinkomst_1_N = mkN "rörelseinkomst" "rörelseinkomster" ; -- rörelseinkomst..nn.1
  rörelsekapital_1_N = mkN "rörelsekapital" neutrum  ; -- rörelsekapital..nn.1
  rörelsekommando_1_N = mkN "rörelsekommando" "rörelsekommandot" "rörelsekommandon" "rörelsekommandona" ; -- rörelsekommando..nn.1
  rörelselag_1_N = mkN "rörelselag" ; -- rörelselag..nn.1
  rörelsemängd_1_N = mkN "rörelsemängd" "rörelsemängder" ; -- rörelsemängd..nn.1
  rörelsemängdsmoment_1_N = mkN "rörelsemängdsmoment" neutrum  ; -- rörelsemängdsmoment..nn.1
  rörelsemässig_1_A = mkA "rörelsemässig" ; -- rörelsemässig..av.1
  rörelsemönster_1_N = mkN "rörelsemönster" neutrum  ; -- rörelsemönster..nn.1
  rörelseoförmåga_1_N = mkN "rörelseoförmåga" ; -- rörelseoförmåga..nn.1
  rörelseriktning_1_N = mkN "rörelseriktning" ; -- rörelseriktning..nn.1
  rörelsesinne_1_N = mkN "rörelsesinne" ; -- rörelsesinne..nn.1
  rörelsesjuka_1_N = mkN "rörelsesjuka" ; -- rörelsesjuka..nn.1
  rörelsestörning_1_N = mkN "rörelsestörning" ; -- rörelsestörning..nn.1
  rörelsesvårighet_1_N = mkN "rörelsesvårighet" "rörelsesvårigheter" ; -- rörelsesvårighet..nn.1
  rörelsevinst_1_N = mkN "rörelsevinst" "rörelsevinster" ; -- rörelsevinst..nn.1
  rörformig_1_A = mkA "rörformig" ; -- rörformig..av.1
  rörhöna_1_N = mkN "rörhöna" ; -- rörhöna..nn.1
  rörig_1_A = mkA "rörig" ; -- rörig..av.1
  röring_1_N = mkN "röring" ; -- röring..nn.1
  rörknippe_1_N = mkN "rörknippe" ; -- rörknippe..nn.1
  rörledning_1_N = mkN "rörledning" ; -- rörledning..nn.1
  rörlig_1_A = mkA "rörlig" ; -- rörlig..av.1
  rörlighet_1_N = mkN "rörlighet" "rörligheter" ; -- rörlighet..nn.1
  rörläggare_1_N = mkN "rörläggare" utrum  ; -- rörläggare..nn.1
  rörläggning_1_N = mkN "rörläggning" ; -- rörläggning..nn.1
  rörmigej_1_N = mkN "rörmigej" ; -- rörmigej..nn.1
  rörmokare_1_N = mkN "rörmokare" utrum  ; -- rörmokare..nn.1
  rörmontör_1_N = mkN "rörmontör" "rörmontörer" ; -- rörmontör..nn.1
  rörpost_1_N = mkN "rörpost" ; -- rörpost..nn.1
  rörsocker_1_N = mkN "rörsocker" neutrum  ; -- rörsocker..nn.1
  rörsopp_1_N = mkN "rörsopp" ; -- rörsopp..nn.1
  rörspis_1_N = mkN "rörspis" ; -- rörspis..nn.1
  rörsvamp_1_N = mkN "rörsvamp" ; -- rörsvamp..nn.1
  rörsångare_1_N = mkN "rörsångare" utrum  ; -- rörsångare..nn.1
  rörtång_1_N = mkN "rörtång" "rörtänger" ; -- rörtång..nn.1
  rös_1_N = mkN "rös" neutrum  ; -- rös..nn.1
  rösa_1_V = mkV "rösar" ; -- rösa..vb.1
  rösande_1_N = mkN "rösande" ; -- rösande..nn.1
  röse_1_N = mkN "röse" ; -- röse..nn.1
  rösning_1_N = mkN "rösning" ; -- rösning..nn.1
  röst_1_N = mkN "röst" "röster" ; -- röst..nn.1
  röst_2_N = mkN "röst" neutrum  ; -- röst..nn.2
  rösta_1_V = mkV "röstar" ; -- rösta..vb.1
  röstande_1_N = mkN "röstande" ; -- röstande..nn.1
  röstberättigad_1_A = mkA "röstberättigad" ; -- röstberättigad..av.1
  röstcoach_1_N = mkN "röstcoach" ; -- röstcoach..nn.1
  röste_1_N = mkN "röste" ; -- röste..nn.1
  röstetal_1_N = mkN "röstetal" neutrum  ; -- röstetal..nn.1
  röstfiska_1_V = mkV "röstfiskar" ; -- röstfiska..vb.1
  röstfiskande_1_N = mkN "röstfiskande" ; -- röstfiskande..nn.1
  röstfiskare_1_N = mkN "röstfiskare" utrum  ; -- röstfiskare..nn.1
  röstfiske_1_N = mkN "röstfiske" ; -- röstfiske..nn.1
  röstfiskning_1_N = mkN "röstfiskning" ; -- röstfiskning..nn.1
  röstjärn_1_N = mkN "röstjärn" neutrum  ; -- röstjärn..nn.1
  röstkaos_1_N = mkN "röstkaos" neutrum  ; -- röstkaos..nn.1
  röstklang_1_N = mkN "röstklang" ; -- röstklang..nn.1
  röstkort_1_N = mkN "röstkort" neutrum  ; -- röstkort..nn.1
  röstläge_1_N = mkN "röstläge" ; -- röstläge..nn.1
  röstlängd_1_N = mkN "röstlängd" "röstlängder" ; -- röstlängd..nn.1
  röstmaximera_1_V = mkV "röstmaximerar" ; -- röstmaximera..vb.1
  röstmaximerande_1_N = mkN "röstmaximerande" ; -- röstmaximerande..nn.1
  röstmaximering_1_N = mkN "röstmaximering" ; -- röstmaximering..nn.1
  röstmässig_1_A = mkA "röstmässig" ; -- röstmässig..av.1
  röstning_1_N = mkN "röstning" ; -- röstning..nn.1
  rösträkning_1_N = mkN "rösträkning" ; -- rösträkning..nn.1
  rösträkningsmaskin_1_N = mkN "rösträkningsmaskin" "rösträkningsmaskiner" ; -- rösträkningsmaskin..nn.1
  rösträtt_1_N = mkN "rösträtt" ; -- rösträtt..nn.1
  rösträttsfråga_1_N = mkN "rösträttsfråga" ; -- rösträttsfråga..nn.1
  röstschabbel_1_N = mkN "röstschabbel" neutrum  ; -- röstschabbel..nn.1
  röstsedel_1_N = mkN "röstsedel" ; -- röstsedel..nn.1
  röstsjabbel_1_N = mkN "röstsjabbel" neutrum  ; -- röstsjabbel..nn.1
  röstskolk_1_N = mkN "röstskolk" neutrum  ; -- röstskolk..nn.1
  röstskolka_1_V = mkV "röstskolkar" ; -- röstskolka..vb.1
  röstskolkande_1_N = mkN "röstskolkande" ; -- röstskolkande..nn.1
  röstskolkning_1_N = mkN "röstskolkning" ; -- röstskolkning..nn.1
  röstspringa_1_N = mkN "röstspringa" ; -- röstspringa..nn.1
  röststark_1_A = mkA "röststark" ; -- röststark..av.1
  röststyrka_1_N = mkN "röststyrka" ; -- röststyrka..nn.1
  röstvärvning_1_N = mkN "röstvärvning" ; -- röstvärvning..nn.1
  röstövervikt_1_N = mkN "röstövervikt" ; -- röstövervikt..nn.1
  röta_1_N = mkN "röta" ; -- röta..nn.1
  röta_1_V = mkV "rötar" ; -- röta..vb.1
  rötkammare_1_N = mkN "rötkammare" "rötkammaren" "rötkammare" "rötkamrarna" ; -- rötkammare..nn.1
  rötmånad_1_N = mkN "rötmånad" "rötmånader" ; -- rötmånad..nn.1
  rötägg_1_N = mkN "rötägg" neutrum  ; -- rötägg..nn.1
  röv_1_N = mkN "röv" ; -- röv..nn.1
  röva_1_V = mkV "rövar" ; -- röva..vb.1
  rövande_1_N = mkN "rövande" ; -- rövande..nn.1
  rövarband_1_N = mkN "rövarband" neutrum  ; -- rövarband..nn.1
  rövare_1_N = mkN "rövare" utrum  ; -- rövare..nn.1
  rövarhistoria_1_N = mkN "rövarhistoria" "rövarhistorian" "rövarhistorier" "rövarhistorierna" ; -- rövarhistoria..nn.1
  rövarhövding_1_N = mkN "rövarhövding" ; -- rövarhövding..nn.1
  rövarkula_1_N = mkN "rövarkula" ; -- rövarkula..nn.1
  rövarliv_1_N = mkN "rövarliv" neutrum  ; -- rövarliv..nn.1
  rövarnäste_1_N = mkN "rövarnäste" ; -- rövarnäste..nn.1
  rövarpris_1_N = mkN "rövarpris" neutrum  ; -- rövarpris..nn.1
  rövarroman_1_N = mkN "rövarroman" "rövarromaner" ; -- rövarroman..nn.1
  rövarspråk_1_N = mkN "rövarspråk" neutrum  ; -- rövarspråk..nn.1
  röveri_1_N = mkN "röveri" "röveriet" "röverier" "röverierna" ; -- röveri..nn.1
  rövhalva_1_N = mkN "rövhalva" ; -- rövhalva..nn.1
  rövhål_1_N = mkN "rövhål" neutrum  ; -- rövhål..nn.1
  rövknulla_1_V = mkV "rövknullar" ; -- rövknulla..vb.1
  rövknullande_1_N = mkN "rövknullande" ; -- rövknullande..nn.1
  rövmögel_1_N = mkN "rövmögel" neutrum  ; -- rövmögel..nn.1
  rövslickare_1_N = mkN "rövslickare" utrum  ; -- rövslickare..nn.1
  rövslickeri_1_N = mkN "rövslickeri" neutrum  ; -- rövslickeri..nn.1
  rövtrakt_1_N = mkN "rövtrakt" "rövtrakter" ; -- rövtrakt..nn.1
  s_formad_1_A = mkA "s-formad" ; -- s-formad..av.1
  s_kurva_1_N = mkN "s-kurva" ; -- s-kurva..nn.1
  saab_1_N = mkN "saab" ; -- saab..nn.1
  sabadill_1_N = mkN "sabadill" "sabadiller" ; -- sabadill..nn.1
  sabadillättika_1_N = mkN "sabadillättika" ; -- sabadillättika..nn.1
  sabb_1_N = mkN "sabb" neutrum  ; -- sabb..nn.1
  sabba_1_V = mkV "sabbar" ; -- sabba..vb.1
  sabbande_1_N = mkN "sabbande" ; -- sabbande..nn.1
  sabbat_1_N = mkN "sabbat" "sabbater" ; -- sabbat..nn.1
  sabbatsbrott_1_N = mkN "sabbatsbrott" neutrum  ; -- sabbatsbrott..nn.1
  sabbatstermin_1_N = mkN "sabbatstermin" "sabbatsterminer" ; -- sabbatstermin..nn.1
  sabbatsår_1_N = mkN "sabbatsår" neutrum  ; -- sabbatsår..nn.1
  sabbik_1_N = mkN "sabbik" ; -- sabbik..nn.1
  sabel_1_N = mkN "sabel" ; -- sabel..nn.1
  sabelbajonett_1_N = mkN "sabelbajonett" "sabelbajonetter" ; -- sabelbajonett..nn.1
  sabelbalja_1_N = mkN "sabelbalja" ; -- sabelbalja..nn.1
  sabelbent_1_A = mkA "sabelbent" "sabelbent" ; -- sabelbent..av.1
  sabelbenthet_1_N = mkN "sabelbenthet" ; -- sabelbenthet..nn.1
  sabelformad_1_A = mkA "sabelformad" ; -- sabelformad..av.1
  sabelfäktning_1_N = mkN "sabelfäktning" ; -- sabelfäktning..nn.1
  sabelklinga_1_N = mkN "sabelklinga" ; -- sabelklinga..nn.1
  sabellilja_1_N = mkN "sabellilja" ; -- sabellilja..nn.1
  sabelskramlare_1_N = mkN "sabelskramlare" utrum  ; -- sabelskramlare..nn.1
  sabelskrammel_1_N = mkN "sabelskrammel" neutrum  ; -- sabelskrammel..nn.1
  sabeltandad_1_A = mkA "sabeltandad" ; -- sabeltandad..av.1
  sabin_1_N = mkN "sabin" "sabiner" ; -- sabin..nn.1
  sabla_1_A = mkA "sabla" ; -- sabla..av.1
  sabotage_1_N = mkN "sabotage" "sabotaget" "sabotage" "sabotagen" ; -- sabotage..nn.1
  sabotera_1_V = mkV "saboterar" ; -- sabotera..vb.1
  saboterande_1_N = mkN "saboterande" ; -- saboterande..nn.1
  saboterbar_1_A = mkA "saboterbar" ; -- saboterbar..av.1
  saboterbarhet_1_N = mkN "saboterbarhet" ; -- saboterbarhet..nn.1
  sabotering_1_N = mkN "sabotering" ; -- sabotering..nn.1
  sabotör_1_N = mkN "sabotör" "sabotörer" ; -- sabotör..nn.1
  sabrera_1_V = mkV "sabrerar" ; -- sabrera..vb.1
  sabrerande_1_N = mkN "sabrerande" ; -- sabrerande..nn.1
  sabrerbar_1_A = mkA "sabrerbar" ; -- sabrerbar..av.1
  sabrerbarhet_1_N = mkN "sabrerbarhet" ; -- sabrerbarhet..nn.1
  sabrering_1_N = mkN "sabrering" ; -- sabrering..nn.1
  sachertårta_1_N = mkN "sachertårta" ; -- sachertårta..nn.1
  sachsare_1_N = mkN "sachsare" utrum  ; -- sachsare..nn.1
  sachsisk_1_A = mkA "sachsisk" ; -- sachsisk..av.1
  sacka_1_V = mkV "sackar" ; -- sacka..vb.1
  sackande_1_N = mkN "sackande" ; -- sackande..nn.1
  sackarin_1_N = mkN "sackarin" "sackariner" ; -- sackarin..nn.1
  sackaros_1_N = mkN "sackaros" ; -- sackaros..nn.1
  sackett_1_N = mkN "sackett" "sacketter" ; -- sackett..nn.1
  sackning_1_N = mkN "sackning" ; -- sackning..nn.1
  sadduceisk_1_A = mkA "sadduceisk" ; -- sadduceisk..av.1
  sadducé_1_N = mkN "sadducé" "sadducéer" ; -- sadducé..nn.1
  sadducéisk_1_A = mkA "sadducéisk" ; -- sadducéisk..av.1
  sadducéism_1_N = mkN "sadducéism" ; -- sadducéism..nn.1
  sadel_1_N = mkN "sadel" ; -- sadel..nn.1
  sadelbom_1_N = mkN "sadelbom" "sadelbommen" "sadelbommar" "sadelbommarna" ; -- sadelbom..nn.1
  sadelbrott_1_N = mkN "sadelbrott" neutrum  ; -- sadelbrott..nn.1
  sadelbruten_1_A = mkA "sadelbruten" ; -- sadelbruten..av.1
  sadeldyna_1_N = mkN "sadeldyna" ; -- sadeldyna..nn.1
  sadelfilt_1_N = mkN "sadelfilt" ; -- sadelfilt..nn.1
  sadelformad_1_A = mkA "sadelformad" ; -- sadelformad..av.1
  sadelformig_1_A = mkA "sadelformig" ; -- sadelformig..av.1
  sadelformighet_1_N = mkN "sadelformighet" ; -- sadelformighet..nn.1
  sadelgjord_1_N = mkN "sadelgjord" ; -- sadelgjord..nn.1
  sadelknapp_1_N = mkN "sadelknapp" ; -- sadelknapp..nn.1
  sadelläge_1_N = mkN "sadelläge" ; -- sadelläge..nn.1
  sadelmakare_1_N = mkN "sadelmakare" utrum  ; -- sadelmakare..nn.1
  sadelmakarnål_1_N = mkN "sadelmakarnål" ; -- sadelmakarnål..nn.1
  sadelmakarstift_1_N = mkN "sadelmakarstift" neutrum  ; -- sadelmakarstift..nn.1
  sadelmakeri_1_N = mkN "sadelmakeri" "sadelmakeriet" "sadelmakerier" "sadelmakerierna" ; -- sadelmakeri..nn.1
  sadelnäsa_1_N = mkN "sadelnäsa" ; -- sadelnäsa..nn.1
  sadelplats_1_N = mkN "sadelplats" "sadelplatser" ; -- sadelplats..nn.1
  sadelputa_1_N = mkN "sadelputa" ; -- sadelputa..nn.1
  sadelskydd_1_N = mkN "sadelskydd" neutrum  ; -- sadelskydd..nn.1
  sadelstad_1_N = mkN "sadelstad" ; -- sadelstad..nn.1
  sadeltak_1_N = mkN "sadeltak" neutrum  ; -- sadeltak..nn.1
  sadeltryck_1_N = mkN "sadeltryck" neutrum  ; -- sadeltryck..nn.1
  sadeltäcke_1_N = mkN "sadeltäcke" ; -- sadeltäcke..nn.1
  sadism_1_N = mkN "sadism" "sadismer" ; -- sadism..nn.1
  sadist_1_N = mkN "sadist" "sadister" ; -- sadist..nn.1
  sadistisk_1_A = mkA "sadistisk" ; -- sadistisk..av.1
  sadla_1_V = mkV "sadlar" ; -- sadla..vb.1
  sadlande_1_N = mkN "sadlande" ; -- sadlande..nn.1
  sadling_1_N = mkN "sadling" ; -- sadling..nn.1
  sado_masochism_1_N = mkN "sado-masochism" "sado-masochismer" ; -- sado-masochism..nn.1
  sado_masochistisk_1_A = mkA "sado-masochistisk" ; -- sado-masochistisk..av.1
  sadomasochism_1_N = mkN "sadomasochism" "sadomasochismer" ; -- sadomasochism..nn.1
  sadomasochist_1_N = mkN "sadomasochist" "sadomasochister" ; -- sadomasochist..nn.1
  sadomasochistisk_1_A = mkA "sadomasochistisk" ; -- sadomasochistisk..av.1
  safari_1_N = mkN "safari" "safarin" "safaris" "safarisarna" ; -- safari..nn.1
  safariguide_1_N = mkN "safariguide" "safariguider" ; -- safariguide..nn.1
  saffian_1_N = mkN "saffian" ; -- saffian..nn.1
  saffran_1_N = mkN "saffran" ; -- saffran..nn.1
  saffransbröd_1_N = mkN "saffransbröd" neutrum  ; -- saffransbröd..nn.1
  saffransbulla_1_N = mkN "saffransbulla" ; -- saffransbulla..nn.1
  saffransbulle_1_N = mkN "saffransbulle" utrum  ; -- saffransbulle..nn.1
  saffransfärg_1_N = mkN "saffransfärg" ; -- saffransfärg..nn.1
  saffransfärgad_1_A = mkA "saffransfärgad" ; -- saffransfärgad..av.1
  saffransgul_1_A = mkA "saffransgul" ; -- saffransgul..av.1
  saffranslängd_1_N = mkN "saffranslängd" "saffranslängder" ; -- saffranslängd..nn.1
  saffranspannkaka_1_N = mkN "saffranspannkaka" ; -- saffranspannkaka..nn.1
  safir_1_N = mkN "safir" "safirer" ; -- safir..nn.1
  safirblå_1_A = mkA "safirblå" "safirblått" ; -- safirblå..av.1
  safirnål_1_N = mkN "safirnål" ; -- safirnål..nn.1
  saft_1_N = mkN "saft" "safter" ; -- saft..nn.1
  safta_1_V = mkV "saftar" ; -- safta..vb.1
  saftande_1_N = mkN "saftande" ; -- saftande..nn.1
  saftfoder_1_N = mkN "saftfoder" neutrum  ; -- saftfoder..nn.1
  saftfull_1_A = mkA "saftfull" ; -- saftfull..av.1
  saftglas_1_N = mkN "saftglas" neutrum  ; -- saftglas..nn.1
  saftglass_1_N = mkN "saftglass" ; -- saftglass..nn.1
  saftig_1_A = mkA "saftig" ; -- saftig..av.1
  saftighet_1_N = mkN "saftighet" ; -- saftighet..nn.1
  saftkalas_1_N = mkN "saftkalas" neutrum  ; -- saftkalas..nn.1
  saftkanna_1_N = mkN "saftkanna" ; -- saftkanna..nn.1
  saftkräm_1_N = mkN "saftkräm" "saftkrämer" ; -- saftkräm..nn.1
  saftlös_1_A = mkA "saftlös" ; -- saftlös..av.1
  saftlöshet_1_N = mkN "saftlöshet" ; -- saftlöshet..nn.1
  saftpress_1_N = mkN "saftpress" ; -- saftpress..nn.1
  saftrik_1_A = mkA "saftrik" ; -- saftrik..av.1
  saftsoppa_1_N = mkN "saftsoppa" ; -- saftsoppa..nn.1
  saftspänning_1_N = mkN "saftspänning" ; -- saftspänning..nn.1
  saftstation_1_N = mkN "saftstation" ; -- saftstation..nn.1
  saftströmning_1_N = mkN "saftströmning" ; -- saftströmning..nn.1
  saftsås_1_N = mkN "saftsås" "saftsåser" ; -- saftsås..nn.1
  saga_1_N = mkN "saga" ; -- saga..nn.1
  sagalitteratur_1_N = mkN "sagalitteratur" ; -- sagalitteratur..nn.1
  sagatid_1_N = mkN "sagatid" ; -- sagatid..nn.1
  sagesman_1_N = mkN "sagesman" "sagesmannen" "sagesmän" "sagesmännen" ; -- sagesman..nn.1
  sagesperson_1_N = mkN "sagesperson" "sagespersoner" ; -- sagesperson..nn.1
  sagg_1_N = mkN "sagg" neutrum  ; -- sagg..nn.1
  sagga_1_V = mkV "saggar" ; -- sagga..vb.1
  saggande_1_N = mkN "saggande" ; -- saggande..nn.1
  sagla_1_V = mkV "saglar" ; -- sagla..vb.1
  saglande_1_N = mkN "saglande" ; -- saglande..nn.1
  sago_1_N = mkN "sago" ; -- sago..nn.1
  sagoberättare_1_N = mkN "sagoberättare" utrum  ; -- sagoberättare..nn.1
  sagobok_1_N = mkN "sagobok" "sagoböcker" ; -- sagobok..nn.1
  sagocykel_1_N = mkN "sagocykel" ; -- sagocykel..nn.1
  sagodjur_1_N = mkN "sagodjur" neutrum  ; -- sagodjur..nn.1
  sagofigur_1_N = mkN "sagofigur" "sagofigurer" ; -- sagofigur..nn.1
  sagogestalt_1_N = mkN "sagogestalt" "sagogestalter" ; -- sagogestalt..nn.1
  sagogryn_1_N = mkN "sagogryn" neutrum  ; -- sagogryn..nn.1
  sagohjälte_1_N = mkN "sagohjälte" utrum  ; -- sagohjälte..nn.1
  sagohörna_1_N = mkN "sagohörna" ; -- sagohörna..nn.1
  sagokrets_1_N = mkN "sagokrets" ; -- sagokrets..nn.1
  sagokung_1_N = mkN "sagokung" ; -- sagokung..nn.1
  sagoland_1_N = mkN "sagoland" "sagolandet" "sagoländer" "sagoländerna" ; -- sagoland..nn.1
  sagolik_1_A = mkA "sagolik" ; -- sagolik..av.1
  sagolikhet_1_N = mkN "sagolikhet" ; -- sagolikhet..nn.1
  sagomjöl_1_N = mkN "sagomjöl" neutrum  ; -- sagomjöl..nn.1
  sagomässig_1_A = mkA "sagomässig" ; -- sagomässig..av.1
  sagoomspunnen_1_A = mkA "sagoomspunnen" "sagoomspunnet" "sagoomspunna" "sagoomspunna" "sagoomspunnare" "sagoomspunnast" "sagoomspunnaste" ; -- sagoomspunnen..av.1
  sagopalm_1_N = mkN "sagopalm" "sagopalmer" ; -- sagopalm..nn.1
  sagoprins_1_N = mkN "sagoprins" ; -- sagoprins..nn.1
  sagoprinsessa_1_N = mkN "sagoprinsessa" ; -- sagoprinsessa..nn.1
  sagosamling_1_N = mkN "sagosamling" ; -- sagosamling..nn.1
  sagoskimmer_1_N = mkN "sagoskimmer" neutrum  ; -- sagoskimmer..nn.1
  sagoskimrande_1_A = mkA "sagoskimrande" ; -- sagoskimrande..av.1
  sagoslott_1_N = mkN "sagoslott" neutrum  ; -- sagoslott..nn.1
  sagosoppa_1_N = mkN "sagosoppa" ; -- sagosoppa..nn.1
  sagostoff_1_N = mkN "sagostoff" neutrum  ; -- sagostoff..nn.1
  sagostund_1_N = mkN "sagostund" "sagostunder" ; -- sagostund..nn.1
  sagotid_1_N = mkN "sagotid" "sagotider" ; -- sagotid..nn.1
  sagovärld_1_N = mkN "sagovärld" ; -- sagovärld..nn.1
  sagoväsen_1_N = mkN "sagoväsen" "sagoväsendet" "sagoväsen" "sagoväsena" ; -- sagoväsen..nn.1
  sagoålder_1_N = mkN "sagoålder" ; -- sagoålder..nn.1
  sagoö_1_N = mkN "sagoö" ; -- sagoö..nn.1
  sahib_1_N = mkN "sahib" "sahiber" ; -- sahib..nn.1
  saiga_1_N = mkN "saiga" ; -- saiga..nn.1
  saint_1_N = mkN "saint" ; -- saint..nn.1
  saintpaulia_1_N = mkN "saintpaulia" ; -- saintpaulia..nn.1
  sajt_1_N = mkN "sajt" "sajter" ; -- sajt..nn.1
  sak_1_N = mkN "sak" "saker" ; -- sak..nn.1
  saka_1_V = mkV "sakar" ; -- saka..vb.1
  sakande_1_N = mkN "sakande" ; -- sakande..nn.1
  sakdebatt_1_N = mkN "sakdebatt" "sakdebatter" ; -- sakdebatt..nn.1
  sakdiskussion_1_N = mkN "sakdiskussion" ; -- sakdiskussion..nn.1
  saker_1_A = mkA "saker" ; -- saker..av.1
  sakerförklara_1_V = mkV "sakerförklarar" ; -- sakerförklara..vb.1
  sakerförklarande_1_N = mkN "sakerförklarande" ; -- sakerförklarande..nn.1
  sakfel_1_N = mkN "sakfel" "sakfelet" "sakfel" "sakfelen" ; -- sakfel..nn.1
  sakframställan_1_N = mkN "sakframställan" "sakframställan" "sakframställanden" "sakframställandena" ; -- sakframställan..nn.1
  sakframställning_1_N = mkN "sakframställning" ; -- sakframställning..nn.1
  sakfråga_1_N = mkN "sakfråga" ; -- sakfråga..nn.1
  sakfälla_1_V = mkV "sakfäller" ; -- sakfälla..vb.1
  sakfällande_1_N = mkN "sakfällande" ; -- sakfällande..nn.1
  sakförare_1_N = mkN "sakförare" utrum  ; -- sakförare..nn.1
  sakförhållande_1_N = mkN "sakförhållande" ; -- sakförhållande..nn.1
  sakförklaring_1_N = mkN "sakförklaring" ; -- sakförklaring..nn.1
  sakförstånd_1_N = mkN "sakförstånd" neutrum  ; -- sakförstånd..nn.1
  sakförståndig_1_A = mkA "sakförståndig" ; -- sakförståndig..av.1
  sakförståndighet_1_N = mkN "sakförståndighet" ; -- sakförståndighet..nn.1
  sakförsäkring_1_N = mkN "sakförsäkring" ; -- sakförsäkring..nn.1
  sakkunnig_1_A = mkA "sakkunnig" ; -- sakkunnig..av.1
  sakkunnigberedning_1_N = mkN "sakkunnigberedning" ; -- sakkunnigberedning..nn.1
  sakkunnigbetänkande_1_N = mkN "sakkunnigbetänkande" ; -- sakkunnigbetänkande..nn.1
  sakkunnighet_1_N = mkN "sakkunnighet" ; -- sakkunnighet..nn.1
  sakkunnigprövning_1_N = mkN "sakkunnigprövning" ; -- sakkunnigprövning..nn.1
  sakkunniguppdrag_1_N = mkN "sakkunniguppdrag" neutrum  ; -- sakkunniguppdrag..nn.1
  sakkunnigutlåtande_1_N = mkN "sakkunnigutlåtande" ; -- sakkunnigutlåtande..nn.1
  sakkunskap_1_N = mkN "sakkunskap" ; -- sakkunskap..nn.1
  sakkännare_1_N = mkN "sakkännare" utrum  ; -- sakkännare..nn.1
  sakkännedom_1_N = mkN "sakkännedom" ; -- sakkännedom..nn.1
  saklig_1_A = mkA "saklig" ; -- saklig..av.1
  saklighet_1_N = mkN "saklighet" "sakligheter" ; -- saklighet..nn.1
  sakläge_1_N = mkN "sakläge" ; -- sakläge..nn.1
  saklös_1_A = mkA "saklös" ; -- saklös..av.1
  saklöshet_1_N = mkN "saklöshet" ; -- saklöshet..nn.1
  sakna_1_V = mkV "saknar" ; -- sakna..vb.1
  sakna_2_V = mkV "saknar" ; -- sakna..vb.2
  saknad_1_N = mkN "saknad" "saknader" ; -- saknad..nn.1
  saknande_1_N = mkN "saknande" ; -- saknande..nn.1
  sakobjekt_1_N = mkN "sakobjekt" neutrum  ; -- sakobjekt..nn.1
  sakocker_1_N = mkN "sakocker" neutrum  ; -- sakocker..nn.1
  sakord_1_N = mkN "sakord" neutrum  ; -- sakord..nn.1
  sakpolitik_1_N = mkN "sakpolitik" ; -- sakpolitik..nn.1
  sakpolitisk_1_A = mkA "sakpolitisk" ; -- sakpolitisk..av.1
  sakprosa_1_N = mkN "sakprosa" ; -- sakprosa..nn.1
  sakprövning_1_N = mkN "sakprövning" ; -- sakprövning..nn.1
  sakral_1_A = mkA "sakral" ; -- sakral..av.1
  sakrament_1_N = mkN "sakrament" neutrum  ; -- sakrament..nn.1
  sakramental_1_A = mkA "sakramental" ; -- sakramental..av.1
  sakramentsförvaltare_1_N = mkN "sakramentsförvaltare" utrum  ; -- sakramentsförvaltare..nn.1
  sakramentskad_1_A = mkA "sakramentskad" ; -- sakramentskad..av.1
  sakramentsskåp_1_N = mkN "sakramentsskåp" neutrum  ; -- sakramentsskåp..nn.1
  sakregister_1_N = mkN "sakregister" neutrum  ; -- sakregister..nn.1
  sakrilegium_1_N = mkN "sakrilegium" "sakrilegiet" "sakrilegier" "sakrilegierna" ; -- sakrilegium..nn.1
  sakristia_1_N = mkN "sakristia" ; -- sakristia..nn.1
  sakrosankt_1_A = mkA "sakrosankt" "sakrosankt" ; -- sakrosankt..av.1
  sakrosankthet_1_N = mkN "sakrosankthet" ; -- sakrosankthet..nn.1
  sakrosant_1_A = mkA "sakrosant" "sakrosant" ; -- sakrosant..av.1
  sakrätt_1_N = mkN "sakrätt" ; -- sakrätt..nn.1
  sakrättslig_1_A = mkA "sakrättslig" ; -- sakrättslig..av.1
  sakskada_1_N = mkN "sakskada" ; -- sakskada..nn.1
  sakskäl_1_N = mkN "sakskäl" neutrum  ; -- sakskäl..nn.1
  saksökande_1_A = mkA "saksökande" ; -- saksökande..av.1
  saksökande_1_N = mkN "saksökande" ; -- saksökande..nn.1
  saksökeri_1_N = mkN "saksökeri" neutrum  ; -- saksökeri..nn.1
  sakta_1_Adv = mkAdv "sakta" ; -- sakta..ab.1
  sakta_1_A = mkA "sakta" ; -- sakta..av.1
  sakta_1_V = mkV "saktar" ; -- sakta..vb.1
  saktande_1_N = mkN "saktande" ; -- saktande..nn.1
  sakteliga_1_Adv = mkAdv "sakteliga" ; -- sakteliga..ab.1
  sakteligen_1_Adv = mkAdv "sakteligen" ; -- sakteligen..ab.1
  saktfärdig_1_A = mkA "saktfärdig" ; -- saktfärdig..av.1
  saktfärdighet_1_N = mkN "saktfärdighet" ; -- saktfärdighet..nn.1
  saktmod_1_N = mkN "saktmod" neutrum  ; -- saktmod..nn.1
  saktmodig_1_A = mkA "saktmodig" ; -- saktmodig..av.1
  saktmodighet_1_N = mkN "saktmodighet" ; -- saktmodighet..nn.1
  sakuppgift_1_N = mkN "sakuppgift" "sakuppgifter" ; -- sakuppgift..nn.1
  sakupplysning_1_N = mkN "sakupplysning" ; -- sakupplysning..nn.1
  sakägande_1_N = mkN "sakägande" "sakäganden" "sakäganden" "sakägandena" ; -- sakägande..nn.1
  sakägare_1_N = mkN "sakägare" utrum  ; -- sakägare..nn.1
  saköre_1_N = mkN "saköre" ; -- saköre..nn.1
  saköreslängd_1_N = mkN "saköreslängd" "saköreslängder" ; -- saköreslängd..nn.1
  sal_1_N = mkN "sal" ; -- sal..nn.1
  sala_1_V = mkV "salar" ; -- sala..vb.1
  saladjär_1_N = mkN "saladjär" "saladjärer" ; -- saladjär..nn.1
  salamander_1_N = mkN "salamander" ; -- salamander..nn.1
  salande_1_N = mkN "salande" ; -- salande..nn.1
  salat_1_N = mkN "salat" ; -- salat..nn.1
  salband_1_N = mkN "salband" neutrum  ; -- salband..nn.1
  saldera_1_V = mkV "salderar" ; -- saldera..vb.1
  salderande_1_N = mkN "salderande" ; -- salderande..nn.1
  salderbar_1_A = mkA "salderbar" ; -- salderbar..av.1
  salderbarhet_1_N = mkN "salderbarhet" ; -- salderbarhet..nn.1
  saldering_1_N = mkN "saldering" ; -- saldering..nn.1
  saldo_1_N = mkN "saldo" "saldot" "saldon" "saldona" ; -- saldo..nn.1
  salep_1_N = mkN "salep" ; -- salep..nn.1
  salepsrot_1_N = mkN "salepsrot" ; -- salepsrot..nn.1
  salicylbomull_1_N = mkN "salicylbomull" ; -- salicylbomull..nn.1
  salicylsyra_1_N = mkN "salicylsyra" ; -- salicylsyra..nn.1
  salicylsyrepulver_1_N = mkN "salicylsyrepulver" neutrum  ; -- salicylsyrepulver..nn.1
  salig_1_A = mkA "salig" ; -- salig..av.1
  salig_2_A = mkA "salig" ; -- salig..av.2
  saligen_1_Adv = mkAdv "saligen" ; -- saligen..ab.1
  saligförklara_1_V = mkV "saligförklarar" ; -- saligförklara..vb.1
  saligförklarande_1_N = mkN "saligförklarande" ; -- saligförklarande..nn.1
  saligförklaring_1_N = mkN "saligförklaring" ; -- saligförklaring..nn.1
  saliggöra_1_V = mkV "saliggöra" "saliggjorde" "saliggjort" ; -- saliggöra..vb.1
  saliggörande_1_N = mkN "saliggörande" ; -- saliggörande..nn.1
  salighet_1_N = mkN "salighet" "saligheter" ; -- salighet..nn.1
  salighet_2_N = mkN "salighet" ; -- salighet..nn.2
  salighetslära_1_N = mkN "salighetslära" ; -- salighetslära..nn.1
  salighetsmedel_1_N = mkN "salighetsmedel" neutrum  ; -- salighetsmedel..nn.1
  salighetsrus_1_N = mkN "salighetsrus" neutrum  ; -- salighetsrus..nn.1
  salighetsväg_1_N = mkN "salighetsväg" ; -- salighetsväg..nn.1
  saligprisning_1_N = mkN "saligprisning" ; -- saligprisning..nn.1
  salin_1_N = mkN "salin" "saliner" ; -- salin..nn.1
  salinitet_1_N = mkN "salinitet" "saliniteter" ; -- salinitet..nn.1
  salisk_1_A = mkA "salisk" ; -- salisk..av.1
  saliv_1_N = mkN "saliv" ; -- saliv..nn.1
  salivation_1_N = mkN "salivation" ; -- salivation..nn.1
  salivera_1_V = mkV "saliverar" ; -- salivera..vb.1
  saliverande_1_N = mkN "saliverande" ; -- saliverande..nn.1
  salivering_1_N = mkN "salivering" ; -- salivering..nn.1
  salivprov_1_N = mkN "salivprov" neutrum  ; -- salivprov..nn.1
  salivsug_1_N = mkN "salivsug" ; -- salivsug..nn.1
  salivsugare_1_N = mkN "salivsugare" utrum  ; -- salivsugare..nn.1
  sallad_1_N = mkN "sallad" "sallader" ; -- sallad..nn.1
  salladsbar_1_N = mkN "salladsbar" "salladsbarer" ; -- salladsbar..nn.1
  salladsbestick_1_N = mkN "salladsbestick" neutrum  ; -- salladsbestick..nn.1
  salladsblad_1_N = mkN "salladsblad" neutrum  ; -- salladsblad..nn.1
  salladsgurka_1_N = mkN "salladsgurka" ; -- salladsgurka..nn.1
  salladshuvud_1_N = mkN "salladshuvud" "salladshuvudet" "salladshuvud" "salladshuvudena" ; -- salladshuvud..nn.1
  salladsland_1_N = mkN "salladsland" neutrum  ; -- salladsland..nn.1
  salladsskål_1_N = mkN "salladsskål" ; -- salladsskål..nn.1
  sallat_1_N = mkN "sallat" ; -- sallat..nn.1
  salmiak_1_N = mkN "salmiak" ; -- salmiak..nn.1
  salmiaksprit_1_N = mkN "salmiaksprit" ; -- salmiaksprit..nn.1
  salmonella_1_N = mkN "salmonella" ; -- salmonella..nn.1
  salmonellafärs_1_N = mkN "salmonellafärs" "salmonellafärser" ; -- salmonellafärs..nn.1
  salmonellainfekterad_1_A = mkA "salmonellainfekterad" ; -- salmonellainfekterad..av.1
  salning_1_N = mkN "salning" ; -- salning..nn.1
  salningshorn_1_N = mkN "salningshorn" neutrum  ; -- salningshorn..nn.1
  salomonier_1_N = mkN "salomonier" "salomoniern" "salomonier" "salomonierna" ; -- salomonier..nn.1
  salomonisk_1_A = mkA "salomonisk" ; -- salomonisk..av.1
  salomonsk_1_A = mkA "salomonsk" ; -- salomonsk..av.1
  salomonska_1_N = mkN "salomonska" ; -- salomonska..nn.1
  salong_1_N = mkN "salong" "salonger" ; -- salong..nn.1
  salongsberusad_1_A = mkA "salongsberusad" ; -- salongsberusad..av.1
  salongsbiljett_1_N = mkN "salongsbiljett" "salongsbiljetter" ; -- salongsbiljett..nn.1
  salongsbolsjevik_1_N = mkN "salongsbolsjevik" "salongsbolsjeviker" ; -- salongsbolsjevik..nn.1
  salongsbåt_1_N = mkN "salongsbåt" ; -- salongsbåt..nn.1
  salongsfilosof_1_N = mkN "salongsfilosof" "salongsfilosofer" ; -- salongsfilosof..nn.1
  salongsfähig_1_A = mkA "salongsfähig" ; -- salongsfähig..av.1
  salongsfähighet_1_N = mkN "salongsfähighet" ; -- salongsfähighet..nn.1
  salongsgevär_1_N = mkN "salongsgevär" neutrum  ; -- salongsgevär..nn.1
  salongskomedi_1_N = mkN "salongskomedi" "salongskomedier" ; -- salongskomedi..nn.1
  salongskommunist_1_N = mkN "salongskommunist" "salongskommunister" ; -- salongskommunist..nn.1
  salongslejon_1_N = mkN "salongslejon" neutrum  ; -- salongslejon..nn.1
  salongsmusik_1_N = mkN "salongsmusik" ; -- salongsmusik..nn.1
  salongsmässig_1_A = mkA "salongsmässig" ; -- salongsmässig..av.1
  salongsorkester_1_N = mkN "salongsorkester" ; -- salongsorkester..nn.1
  salongsruff_1_N = mkN "salongsruff" ; -- salongsruff..nn.1
  salongsuppassare_1_N = mkN "salongsuppassare" utrum  ; -- salongsuppassare..nn.1
  salongsvagn_1_N = mkN "salongsvagn" ; -- salongsvagn..nn.1
  saloon_1_N = mkN "saloon" "salooner" ; -- saloon..nn.1
  saloondörr_1_N = mkN "saloondörr" ; -- saloondörr..nn.1
  salpeter_1_N = mkN "salpeter" ; -- salpeter..nn.1
  salpeterbakterie_1_N = mkN "salpeterbakterie" "salpeterbakterier" ; -- salpeterbakterie..nn.1
  salpetergruva_1_N = mkN "salpetergruva" ; -- salpetergruva..nn.1
  salpetersjuderi_1_N = mkN "salpetersjuderi" "salpetersjuderiet" "salpetersjuderier" "salpetersjuderierna" ; -- salpetersjuderi..nn.1
  salpetersyra_1_N = mkN "salpetersyra" ; -- salpetersyra..nn.1
  salpetersyrlighet_1_N = mkN "salpetersyrlighet" "salpetersyrligheter" ; -- salpetersyrlighet..nn.1
  salpingit_1_N = mkN "salpingit" "salpingiter" ; -- salpingit..nn.1
  salsgolv_1_N = mkN "salsgolv" neutrum  ; -- salsgolv..nn.1
  salskrake_1_N = mkN "salskrak" ; -- salskrake..nn.1
  salspatient_1_N = mkN "salspatient" "salspatienter" ; -- salspatient..nn.1
  salt_1_A = mkA "salt" "salt" ; -- salt..av.1
  salt_1_N = mkN "salt" neutrum  ; -- salt..nn.1
  salt_2_N = mkN "salt" "saltet" "salter" "salterna" ; -- salt..nn.2
  salta_1_V = mkV "saltar" ; -- salta..vb.1
  saltande_1_N = mkN "saltande" ; -- saltande..nn.1
  saltavlagring_1_N = mkN "saltavlagring" ; -- saltavlagring..nn.1
  saltbad_1_N = mkN "saltbad" neutrum  ; -- saltbad..nn.1
  saltbassäng_1_N = mkN "saltbassäng" "saltbassänger" ; -- saltbassäng..nn.1
  saltbehov_1_N = mkN "saltbehov" neutrum  ; -- saltbehov..nn.1
  saltbemängd_1_A = mkA "saltbemängd" "saltbemängt" ; -- saltbemängd..av.1
  saltbemängdhet_1_N = mkN "saltbemängdhet" ; -- saltbemängdhet..nn.1
  saltbil_1_N = mkN "saltbil" ; -- saltbil..nn.1
  saltbildare_1_N = mkN "saltbildare" utrum  ; -- saltbildare..nn.1
  saltdamm_1_N = mkN "saltdamm" ; -- saltdamm..nn.1
  salteri_1_N = mkN "salteri" "salteriet" "salterier" "salterierna" ; -- salteri..nn.1
  saltfisk_1_N = mkN "saltfisk" ; -- saltfisk..nn.1
  saltglasyr_1_N = mkN "saltglasyr" ; -- saltglasyr..nn.1
  saltgrop_1_N = mkN "saltgrop" ; -- saltgrop..nn.1
  saltgruva_1_N = mkN "saltgruva" ; -- saltgruva..nn.1
  saltgurka_1_N = mkN "saltgurka" ; -- saltgurka..nn.1
  salthalt_1_N = mkN "salthalt" "salthalter" ; -- salthalt..nn.1
  salthaltig_1_A = mkA "salthaltig" ; -- salthaltig..av.1
  salthet_1_N = mkN "salthet" ; -- salthet..nn.1
  saltig_1_A = mkA "saltig" ; -- saltig..av.1
  saltighet_1_N = mkN "saltighet" ; -- saltighet..nn.1
  saltimbocca_1_N = mkN "saltimbocca" ; -- saltimbocca..nn.1
  saltkar_1_N = mkN "saltkar" neutrum  ; -- saltkar..nn.1
  saltkoncentration_1_N = mkN "saltkoncentration" ; -- saltkoncentration..nn.1
  saltkristall_1_N = mkN "saltkristall" "saltkristaller" ; -- saltkristall..nn.1
  saltkälla_1_N = mkN "saltkälla" ; -- saltkälla..nn.1
  saltlake_1_N = mkN "saltlake" utrum  ; -- saltlake..nn.1
  saltlånga_1_N = mkN "saltlånga" ; -- saltlånga..nn.1
  saltlösning_1_N = mkN "saltlösning" ; -- saltlösning..nn.1
  saltomortal_1_N = mkN "saltomortal" "saltomortaler" ; -- saltomortal..nn.1
  saltprovare_1_N = mkN "saltprovare" utrum  ; -- saltprovare..nn.1
  saltrik_1_A = mkA "saltrik" ; -- saltrik..av.1
  saltsjö_1_N = mkN "saltsjö" ; -- saltsjö..nn.1
  saltsjöbadsanda_1_N = mkN "saltsjöbadsanda" ; -- saltsjöbadsanda..nn.1
  saltsleke_1_N = mkN "saltsleke" ; -- saltsleke..nn.1
  saltspad_1_N = mkN "saltspad" neutrum  ; -- saltspad..nn.1
  saltstod_1_N = mkN "saltstod" "saltstoder" ; -- saltstod..nn.1
  saltströare_1_N = mkN "saltströare" utrum  ; -- saltströare..nn.1
  saltstänkt_1_A = mkA "saltstänkt" "saltstänkt" ; -- saltstänkt..av.1
  saltstänkthet_1_N = mkN "saltstänkthet" ; -- saltstänkthet..nn.1
  saltsyra_1_N = mkN "saltsyra" ; -- saltsyra..nn.1
  saltutvinning_1_N = mkN "saltutvinning" ; -- saltutvinning..nn.1
  saltvatten_1_N = mkN "saltvatten" "saltvattnet" "saltvatten" "saltvattnen" ; -- saltvatten..nn.1
  saltvattenkrokodil_1_N = mkN "saltvattenkrokodil" "saltvattenkrokodiler" ; -- saltvattenkrokodil..nn.1
  saltvattensfisk_1_N = mkN "saltvattensfisk" ; -- saltvattensfisk..nn.1
  saltvattenskrokodil_1_N = mkN "saltvattenskrokodil" "saltvattenskrokodiler" ; -- saltvattenskrokodil..nn.1
  saltvattensnäcka_1_N = mkN "saltvattensnäcka" ; -- saltvattensnäcka..nn.1
  saltverk_1_N = mkN "saltverk" neutrum  ; -- saltverk..nn.1
  saltväxt_1_N = mkN "saltväxt" "saltväxter" ; -- saltväxt..nn.1
  saltälskande_1_A = mkA "saltälskande" ; -- saltälskande..av.1
  saltäng_1_N = mkN "saltäng" ; -- saltäng..nn.1
  saltöken_1_N = mkN "saltöken" "saltökenn" "saltöknar" "saltöknarna" ; -- saltöken..nn.1
  saltört_1_N = mkN "saltört" "saltörter" ; -- saltört..nn.1
  salubjuda_1_V = mkV "salubjuda" "salubjöd" "salubjudit" ; -- salubjuda..vb.1
  salubjudande_1_N = mkN "salubjudande" ; -- salubjudande..nn.1
  salubrin_1_N = mkN "salubrin" ; -- salubrin..nn.1
  saluföra_1_V = mkV "saluföra" "saluförde" "salufört" ; -- saluföra..vb.1
  saluförande_1_N = mkN "saluförande" ; -- saluförande..nn.1
  saluhall_1_N = mkN "saluhall" ; -- saluhall..nn.1
  salupris_1_N = mkN "salupris" neutrum  ; -- salupris..nn.1
  salustånd_1_N = mkN "salustånd" neutrum  ; -- salustånd..nn.1
  salut_1_N = mkN "salut" "saluter" ; -- salut..nn.1
  salutdag_1_N = mkN "salutdag" ; -- salutdag..nn.1
  salutera_1_V = mkV "saluterar" ; -- salutera..vb.1
  saluterande_1_N = mkN "saluterande" ; -- saluterande..nn.1
  saluterbar_1_A = mkA "saluterbar" ; -- saluterbar..av.1
  saluterbarhet_1_N = mkN "saluterbarhet" ; -- saluterbarhet..nn.1
  salutering_1_N = mkN "salutering" ; -- salutering..nn.1
  salutkanon_1_N = mkN "salutkanon" "salutkanoner" ; -- salutkanon..nn.1
  salutorg_1_N = mkN "salutorg" neutrum  ; -- salutorg..nn.1
  salutskjutning_1_N = mkN "salutskjutning" ; -- salutskjutning..nn.1
  salutskott_1_N = mkN "salutskott" neutrum  ; -- salutskott..nn.1
  saluvärde_1_N = mkN "saluvärde" ; -- saluvärde..nn.1
  salva_1_N = mkN "salva" ; -- salva..nn.1
  salvadoran_1_N = mkN "salvadoran" "salvadoraner" ; -- salvadoran..nn.1
  salvadoransk_1_A = mkA "salvadoransk" ; -- salvadoransk..av.1
  salvadoranska_1_N = mkN "salvadoranska" ; -- salvadoranska..nn.1
  salvarsan_1_N = mkN "salvarsan" ; -- salvarsan..nn.1
  salvationist_1_N = mkN "salvationist" "salvationister" ; -- salvationist..nn.1
  salveld_1_N = mkN "salveld" ; -- salveld..nn.1
  salvelse_1_N = mkN "salvelse" utrum  ; -- salvelse..nn.1
  salvelsefull_1_A = mkA "salvelsefull" ; -- salvelsefull..av.1
  salvelsefullhet_1_N = mkN "salvelsefullhet" "salvelsefullheter" ; -- salvelsefullhet..nn.1
  salvia_1_N = mkN "salvia" ; -- salvia..nn.1
  salvkanon_1_N = mkN "salvkanon" "salvkanoner" ; -- salvkanon..nn.1
  samarbeta_1_V = mkV "samarbetar" ; -- samarbeta..vb.1
  samarbetande_1_N = mkN "samarbetande" ; -- samarbetande..nn.1
  samarbete_1_N = mkN "samarbete" ; -- samarbete..nn.1
  samarbetsform_1_N = mkN "samarbetsform" "samarbetsformer" ; -- samarbetsform..nn.1
  samarbetsman_1_N = mkN "samarbetsman" "samarbetsmannen" "samarbetsmän" "samarbetsmännen" ; -- samarbetsman..nn.1
  samarbetsorgan_1_N = mkN "samarbetsorgan" neutrum  ; -- samarbetsorgan..nn.1
  samarbetsorganisation_1_N = mkN "samarbetsorganisation" ; -- samarbetsorganisation..nn.1
  samarbetspartner_1_N = mkN "samarbetspartner" "samarbetspartnern" "samarbetspartners" "samarbetspartnersen" ; -- samarbetspartner..nn.1
  samarbetsplan_1_N = mkN "samarbetsplan" "samarbetsplaner" ; -- samarbetsplan..nn.1
  samarbetsprojekt_1_N = mkN "samarbetsprojekt" neutrum  ; -- samarbetsprojekt..nn.1
  samarbetsvillig_1_A = mkA "samarbetsvillig" ; -- samarbetsvillig..av.1
  samarbetsvillighet_1_N = mkN "samarbetsvillighet" ; -- samarbetsvillighet..nn.1
  samarit_1_N = mkN "samarit" "samariter" ; -- samarit..nn.1
  samaritlåda_1_N = mkN "samaritlåda" ; -- samaritlåda..nn.1
  samarium_1_N = mkN "samarium" neutrum  ; -- samarium..nn.1
  samarv_1_N = mkN "samarv" neutrum  ; -- samarv..nn.1
  samarva_1_A = mkA "samarva" ; -- samarva..av.1
  samba_1_N = mkN "samba" ; -- samba..nn.1
  sambadansare_1_N = mkN "sambadansare" utrum  ; -- sambadansare..nn.1
  samband_1_N = mkN "samband" neutrum  ; -- samband..nn.1
  sambandsofficer_1_N = mkN "sambandsofficer" "sambandsofficeren" "sambandsofficerare" "sambandsofficerarna" ; -- sambandsofficer..nn.1
  sambeskatta_1_V = mkV "sambeskattar" ; -- sambeskatta..vb.1
  sambeskattande_1_N = mkN "sambeskattande" ; -- sambeskattande..nn.1
  sambeskattning_1_N = mkN "sambeskattning" ; -- sambeskattning..nn.1
  sambladig_1_A = mkA "sambladig" ; -- sambladig..av.1
  sambo_1_N = mkN "sambo" "sambor" ; -- sambo..nn.1
  sambo_2_N = mkN "sambo" "sambor" ; -- sambo..nn.2
  sambo_1_V = mkV "sambor" ; -- sambo..vb.1
  samboavtal_1_N = mkN "samboavtal" neutrum  ; -- samboavtal..nn.1
  samboende_1_A = mkA "samboende" ; -- samboende..av.1
  samboende_1_N = mkN "samboende" ; -- samboende..nn.1
  samboende_2_N = mkN "samboende" ; -- samboende..nn.2
  samboförhållande_1_N = mkN "samboförhållande" ; -- samboförhållande..nn.1
  sambord_1_N = mkN "sambord" neutrum  ; -- sambord..nn.1
  sambovåld_1_N = mkN "sambovåld" neutrum  ; -- sambovåld..nn.1
  sambruk_1_N = mkN "sambruk" neutrum  ; -- sambruk..nn.1
  sambuca_1_N = mkN "sambuca" ; -- sambuca..nn.1
  sambuca_2_N = mkN "sambuca" ; -- sambuca..nn.2
  sambyggare_1_N = mkN "sambyggare" utrum  ; -- sambyggare..nn.1
  samdistribution_1_N = mkN "samdistribution" ; -- samdistribution..nn.1
  samdräkt_1_N = mkN "samdräkt" ; -- samdräkt..nn.1
  same_1_N = mkN "same" "samer" ; -- same..nn.1
  sameby_1_N = mkN "sameby" "samebyn" "samebyar" "samebyarna" ; -- sameby..nn.1
  samekultur_1_N = mkN "samekultur" "samekulturer" ; -- samekultur..nn.1
  sameland_1_N = mkN "sameland" "samelandet" "sameländer" "sameländerna" ; -- sameland..nn.1
  samexistens_1_N = mkN "samexistens" ; -- samexistens..nn.1
  samexistera_1_V = mkV "samexisterar" ; -- samexistera..vb.1
  samexisterande_1_N = mkN "samexisterande" ; -- samexisterande..nn.1
  samfund_1_N = mkN "samfund" neutrum  ; -- samfund..nn.1
  samfundsmässig_1_A = mkA "samfundsmässig" ; -- samfundsmässig..av.1
  samfälld_1_A = mkA "samfälld" "samfällt" ; -- samfälld..av.1
  samfällig_1_A = mkA "samfällig" ; -- samfällig..av.1
  samfällighet_1_N = mkN "samfällighet" "samfälligheter" ; -- samfällighet..nn.1
  samfällighet_2_N = mkN "samfällighet" ; -- samfällighet..nn.2
  samfärd_1_N = mkN "samfärd" ; -- samfärd..nn.1
  samfärdsel_1_N = mkN "samfärdsel" ; -- samfärdsel..nn.1
  samfärdsled_1_N = mkN "samfärdsled" "samfärdsleder" ; -- samfärdsled..nn.1
  samfärdsmedel_1_N = mkN "samfärdsmedel" neutrum  ; -- samfärdsmedel..nn.1
  samförstånd_1_N = mkN "samförstånd" neutrum  ; -- samförstånd..nn.1
  samgå_1_V = mkV "samgå" "samgår" "samgå" "samgick" "samgått" "samgången" ; -- samgå..vb.1
  samgående_1_N = mkN "samgående" ; -- samgående..nn.1
  samhälle_1_N = mkN "samhälle" ; -- samhälle..nn.1
  samhällelig_1_A = mkA "samhällelig" ; -- samhällelig..av.1
  samhällelighet_1_N = mkN "samhällelighet" ; -- samhällelighet..nn.1
  samhällsanda_1_N = mkN "samhällsanda" ; -- samhällsanda..nn.1
  samhällsarbete_1_N = mkN "samhällsarbete" ; -- samhällsarbete..nn.1
  samhällsbevakning_1_N = mkN "samhällsbevakning" ; -- samhällsbevakning..nn.1
  samhällsbevarande_1_A = mkA "samhällsbevarande" ; -- samhällsbevarande..av.1
  samhällsbevarare_1_N = mkN "samhällsbevarare" utrum  ; -- samhällsbevarare..nn.1
  samhällsbildande_1_A = mkA "samhällsbildande" ; -- samhällsbildande..av.1
  samhällsbyggnad_1_N = mkN "samhällsbyggnad" "samhällsbyggnader" ; -- samhällsbyggnad..nn.1
  samhällsbärande_1_A = mkA "samhällsbärande" ; -- samhällsbärande..av.1
  samhällsdebatt_1_N = mkN "samhällsdebatt" "samhällsdebatter" ; -- samhällsdebatt..nn.1
  samhällsekonomi_1_N = mkN "samhällsekonomi" ; -- samhällsekonomi..nn.1
  samhällsekonomisk_1_A = mkA "samhällsekonomisk" ; -- samhällsekonomisk..av.1
  samhällsfara_1_N = mkN "samhällsfara" ; -- samhällsfara..nn.1
  samhällsfarlig_1_A = mkA "samhällsfarlig" ; -- samhällsfarlig..av.1
  samhällsfarlighet_1_N = mkN "samhällsfarlighet" ; -- samhällsfarlighet..nn.1
  samhällsfasad_1_N = mkN "samhällsfasad" "samhällsfasader" ; -- samhällsfasad..nn.1
  samhällsfientlig_1_A = mkA "samhällsfientlig" ; -- samhällsfientlig..av.1
  samhällsfientlighet_1_N = mkN "samhällsfientlighet" ; -- samhällsfientlighet..nn.1
  samhällsform_1_N = mkN "samhällsform" "samhällsformer" ; -- samhällsform..nn.1
  samhällsforskare_1_N = mkN "samhällsforskare" utrum  ; -- samhällsforskare..nn.1
  samhällsfrånvänd_1_A = mkA "samhällsfrånvänd" ; -- samhällsfrånvänd..av.1
  samhällsfrånvändhet_1_N = mkN "samhällsfrånvändhet" ; -- samhällsfrånvändhet..nn.1
  samhällsfunktion_1_N = mkN "samhällsfunktion" ; -- samhällsfunktion..nn.1
  samhällsförbättrare_1_N = mkN "samhällsförbättrare" utrum  ; -- samhällsförbättrare..nn.1
  samhällsfördrag_1_N = mkN "samhällsfördrag" neutrum  ; -- samhällsfördrag..nn.1
  samhällsgrupp_1_N = mkN "samhällsgrupp" "samhällsgrupper" ; -- samhällsgrupp..nn.1
  samhällshatare_1_N = mkN "samhällshatare" utrum  ; -- samhällshatare..nn.1
  samhällshjälp_1_N = mkN "samhällshjälp" ; -- samhällshjälp..nn.1
  samhällsideal_1_N = mkN "samhällsideal" neutrum  ; -- samhällsideal..nn.1
  samhällsinflytande_1_N = mkN "samhällsinflytande" ; -- samhällsinflytande..nn.1
  samhällsinformation_1_N = mkN "samhällsinformation" ; -- samhällsinformation..nn.1
  samhällsingripande_1_N = mkN "samhällsingripande" ; -- samhällsingripande..nn.1
  samhällsinsats_1_N = mkN "samhällsinsats" "samhällsinsatser" ; -- samhällsinsats..nn.1
  samhällsintresserad_1_A = mkA "samhällsintresserad" ; -- samhällsintresserad..av.1
  samhällsjournalistik_1_N = mkN "samhällsjournalistik" ; -- samhällsjournalistik..nn.1
  samhällsklass_1_N = mkN "samhällsklass" "samhällsklasser" ; -- samhällsklass..nn.1
  samhällskontrakt_1_N = mkN "samhällskontrakt" neutrum  ; -- samhällskontrakt..nn.1
  samhällskostnad_1_N = mkN "samhällskostnad" "samhällskostnader" ; -- samhällskostnad..nn.1
  samhällskritik_1_N = mkN "samhällskritik" ; -- samhällskritik..nn.1
  samhällskritiker_1_N = mkN "samhällskritiker" "samhällskritikern" "samhällskritiker" "samhällskritikerna" ; -- samhällskritiker..nn.1
  samhällskritisk_1_A = mkA "samhällskritisk" ; -- samhällskritisk..av.1
  samhällskropp_1_N = mkN "samhällskropp" ; -- samhällskropp..nn.1
  samhällskunskap_1_N = mkN "samhällskunskap" ; -- samhällskunskap..nn.1
  samhällskunskapslärare_1_N = mkN "samhällskunskapslärare" utrum  ; -- samhällskunskapslärare..nn.1
  samhällslager_1_N = mkN "samhällslager" neutrum  ; -- samhällslager..nn.1
  samhällsliv_1_N = mkN "samhällsliv" neutrum  ; -- samhällsliv..nn.1
  samhällslära_1_N = mkN "samhällslära" ; -- samhällslära..nn.1
  samhällsmaskineri_1_N = mkN "samhällsmaskineri" neutrum  ; -- samhällsmaskineri..nn.1
  samhällsmässig_1_A = mkA "samhällsmässig" ; -- samhällsmässig..av.1
  samhällsnorm_1_N = mkN "samhällsnorm" "samhällsnormer" ; -- samhällsnorm..nn.1
  samhällsnytta_1_N = mkN "samhällsnytta" ; -- samhällsnytta..nn.1
  samhällsnyttig_1_A = mkA "samhällsnyttig" ; -- samhällsnyttig..av.1
  samhällsnyttighet_1_N = mkN "samhällsnyttighet" ; -- samhällsnyttighet..nn.1
  samhällsområde_1_N = mkN "samhällsområde" ; -- samhällsområde..nn.1
  samhällsomstörtande_1_A = mkA "samhällsomstörtande" ; -- samhällsomstörtande..av.1
  samhällsomstörtare_1_N = mkN "samhällsomstörtare" utrum  ; -- samhällsomstörtare..nn.1
  samhällsomvandling_1_N = mkN "samhällsomvandling" ; -- samhällsomvandling..nn.1
  samhällsordning_1_N = mkN "samhällsordning" ; -- samhällsordning..nn.1
  samhällsorgan_1_N = mkN "samhällsorgan" neutrum  ; -- samhällsorgan..nn.1
  samhällsorienterande_1_A = mkA "samhällsorienterande" ; -- samhällsorienterande..av.1
  samhällsplanera_1_V = mkV "samhällsplanerar" ; -- samhällsplanera..vb.1
  samhällsplanerande_1_N = mkN "samhällsplanerande" ; -- samhällsplanerande..nn.1
  samhällsplanerare_1_N = mkN "samhällsplanerare" utrum  ; -- samhällsplanerare..nn.1
  samhällsplanering_1_N = mkN "samhällsplanering" ; -- samhällsplanering..nn.1
  samhällsplikt_1_N = mkN "samhällsplikt" "samhällsplikter" ; -- samhällsplikt..nn.1
  samhällspolitik_1_N = mkN "samhällspolitik" ; -- samhällspolitik..nn.1
  samhällspolitisk_1_A = mkA "samhällspolitisk" ; -- samhällspolitisk..av.1
  samhällsposition_1_N = mkN "samhällsposition" ; -- samhällsposition..nn.1
  samhällsproblem_1_N = mkN "samhällsproblem" neutrum  ; -- samhällsproblem..nn.1
  samhällspyramid_1_N = mkN "samhällspyramid" "samhällspyramider" ; -- samhällspyramid..nn.1
  samhällsreformator_1_N = mkN "samhällsreformator" "samhällsreformatorer" ; -- samhällsreformator..nn.1
  samhällsrepresentant_1_N = mkN "samhällsrepresentant" "samhällsrepresentanter" ; -- samhällsrepresentant..nn.1
  samhällsservice_1_N = mkN "samhällsservice" utrum  ; -- samhällsservice..nn.1
  samhällssfär_1_N = mkN "samhällssfär" "samhällssfärer" ; -- samhällssfär..nn.1
  samhällsskick_1_N = mkN "samhällsskick" neutrum  ; -- samhällsskick..nn.1
  samhällsskikt_1_N = mkN "samhällsskikt" neutrum  ; -- samhällsskikt..nn.1
  samhällsskildring_1_N = mkN "samhällsskildring" ; -- samhällsskildring..nn.1
  samhällssolidarisk_1_A = mkA "samhällssolidarisk" ; -- samhällssolidarisk..av.1
  samhällsstyrning_1_N = mkN "samhällsstyrning" ; -- samhällsstyrning..nn.1
  samhällsställning_1_N = mkN "samhällsställning" ; -- samhällsställning..nn.1
  samhällsstöd_1_N = mkN "samhällsstöd" neutrum  ; -- samhällsstöd..nn.1
  samhällssymbol_1_N = mkN "samhällssymbol" "samhällssymboler" ; -- samhällssymbol..nn.1
  samhällssyn_1_N = mkN "samhällssyn" "samhällssyner" ; -- samhällssyn..nn.1
  samhällssystem_1_N = mkN "samhällssystem" neutrum  ; -- samhällssystem..nn.1
  samhällstillvänd_1_A = mkA "samhällstillvänd" ; -- samhällstillvänd..av.1
  samhällstillvändhet_1_N = mkN "samhällstillvändhet" ; -- samhällstillvändhet..nn.1
  samhällstjänst_1_N = mkN "samhällstjänst" ; -- samhällstjänst..nn.1
  samhällsuppbyggnad_1_N = mkN "samhällsuppbyggnad" "samhällsuppbyggnader" ; -- samhällsuppbyggnad..nn.1
  samhällsupplösande_1_A = mkA "samhällsupplösande" ; -- samhällsupplösande..av.1
  samhällsutveckling_1_N = mkN "samhällsutveckling" ; -- samhällsutveckling..nn.1
  samhällsvarelse_1_N = mkN "samhällsvarelse" "samhällsvarelser" ; -- samhällsvarelse..nn.1
  samhällsvetare_1_N = mkN "samhällsvetare" utrum  ; -- samhällsvetare..nn.1
  samhällsvetenskap_1_N = mkN "samhällsvetenskap" "samhällsvetenskaper" ; -- samhällsvetenskap..nn.1
  samhällsvetenskaplig_1_A = mkA "samhällsvetenskaplig" ; -- samhällsvetenskaplig..av.1
  samhällsvetenskaplighet_1_N = mkN "samhällsvetenskaplighet" ; -- samhällsvetenskaplighet..nn.1
  samhällsviktig_1_A = mkA "samhällsviktig" ; -- samhällsviktig..av.1
  samhällsvådlig_1_A = mkA "samhällsvådlig" ; -- samhällsvådlig..av.1
  samhällsvård_1_N = mkN "samhällsvård" ; -- samhällsvård..nn.1
  samhällsövervakning_1_N = mkN "samhällsövervakning" ; -- samhällsövervakning..nn.1
  samhörande_1_A = mkA "samhörande" ; -- samhörande..av.1
  samhörig_1_A = mkA "samhörig" ; -- samhörig..av.1
  samhörighet_1_N = mkN "samhörighet" "samhörigheter" ; -- samhörighet..nn.1
  samhörighetskänsla_1_N = mkN "samhörighetskänsla" ; -- samhörighetskänsla..nn.1
  samisk_1_A = mkA "samisk" ; -- samisk..av.1
  samiska_1_N = mkN "samiska" ; -- samiska..nn.1
  samizdat_1_N = mkN "samizdat" ; -- samizdat..nn.1
  samka_1_V = mkV "samkar" ; -- samka..vb.1
  samkande_1_N = mkN "samkande" ; -- samkande..nn.1
  samklang_1_N = mkN "samklang" ; -- samklang..nn.1
  samklinga_1_V = mkV "samklingar" ; -- samklinga..vb.1
  samklingande_1_N = mkN "samklingande" ; -- samklingande..nn.1
  samkväm_1_N = mkN "samkväm" neutrum  ; -- samkväm..nn.1
  samkänsla_1_N = mkN "samkänsla" ; -- samkänsla..nn.1
  samkönad_1_A = mkA "samkönad" ; -- samkönad..av.1
  samköp_1_N = mkN "samköp" neutrum  ; -- samköp..nn.1
  samköra_1_V = mkV "samköra" "samkörde" "samkört" ; -- samköra..vb.1
  samkörande_1_N = mkN "samkörande" ; -- samkörande..nn.1
  samkörning_1_N = mkN "samkörning" ; -- samkörning..nn.1
  samla_1_V = mkV "samlar" ; -- samla..vb.1
  samla_2_V = mkV "samlar" ; -- samla..vb.2
  samlad_1_A = mkA "samlad" ; -- samlad..av.1
  samlag_1_N = mkN "samlag" neutrum  ; -- samlag..nn.1
  samlagsdebut_1_N = mkN "samlagsdebut" ; -- samlagsdebut..nn.1
  samlagspartner_1_N = mkN "samlagspartner" "samlagspartnern" "samlagspartners" "samlagspartnersen" ; -- samlagspartner..nn.1
  samlagsställning_1_N = mkN "samlagsställning" ; -- samlagsställning..nn.1
  samlande_1_N = mkN "samlande" ; -- samlande..nn.1
  samlare_1_N = mkN "samlare" utrum  ; -- samlare..nn.1
  samlarflit_1_N = mkN "samlarflit" ; -- samlarflit..nn.1
  samlarfolk_1_N = mkN "samlarfolk" neutrum  ; -- samlarfolk..nn.1
  samlarföremål_1_N = mkN "samlarföremål" neutrum  ; -- samlarföremål..nn.1
  samlarinstinkt_1_N = mkN "samlarinstinkt" ; -- samlarinstinkt..nn.1
  samlarsyssla_1_N = mkN "samlarsyssla" ; -- samlarsyssla..nn.1
  samlarvurm_1_N = mkN "samlarvurm" ; -- samlarvurm..nn.1
  samlarvärde_1_N = mkN "samlarvärde" ; -- samlarvärde..nn.1
  samlevnad_1_N = mkN "samlevnad" "samlevnader" ; -- samlevnad..nn.1
  samling_1_N = mkN "samling" ; -- samling..nn.1
  samlingsband_1_N = mkN "samlingsband" neutrum  ; -- samlingsband..nn.1
  samlingslins_1_N = mkN "samlingslins" "samlingslinser" ; -- samlingslins..nn.1
  samlingslokal_1_N = mkN "samlingslokal" "samlingslokaler" ; -- samlingslokal..nn.1
  samlingsnamn_1_N = mkN "samlingsnamn" neutrum  ; -- samlingsnamn..nn.1
  samlingsparti_1_N = mkN "samlingsparti" "samlingspartiet" "samlingspartier" "samlingspartierna" ; -- samlingsparti..nn.1
  samlingsplats_1_N = mkN "samlingsplats" "samlingsplatser" ; -- samlingsplats..nn.1
  samlingspunkt_1_N = mkN "samlingspunkt" "samlingspunkter" ; -- samlingspunkt..nn.1
  samlingspärm_1_N = mkN "samlingspärm" ; -- samlingspärm..nn.1
  samlingsregering_1_N = mkN "samlingsregering" ; -- samlingsregering..nn.1
  samlingsrum_1_N = mkN "samlingsrum" "samlingsrummet" "samlingsrum" "samlingsrummen" ; -- samlingsrum..nn.1
  samlingssal_1_N = mkN "samlingssal" ; -- samlingssal..nn.1
  samlingsverk_1_N = mkN "samlingsverk" neutrum  ; -- samlingsverk..nn.1
  samliv_1_N = mkN "samliv" neutrum  ; -- samliv..nn.1
  samlivsdrama_1_N = mkN "samlivsdrama" "samlivsdramat" "samlivsdraman" "samlivsdramana" ; -- samlivsdrama..nn.1
  sammald_1_A = mkA "sammald" "sammalt" ; -- sammald..av.1
  sammaledes_1_Adv = mkAdv "sammaledes" ; -- sammaledes..ab.1
  sammalen_1_A = mkA "sammalen" ; -- sammalen..av.1
  sammalunda_1_Adv = mkAdv "sammalunda" ; -- sammalunda..ab.1
  sammanavla_1_V = mkV "sammanavlar" ; -- sammanavla..vb.1
  sammanavlande_1_N = mkN "sammanavlande" ; -- sammanavlande..nn.1
  sammanbinda_1_V = mkV "sammanbinda" "sammanband" "sammanbundit" ; -- sammanbinda..vb.1
  sammanbindande_1_N = mkN "sammanbindande" ; -- sammanbindande..nn.1
  sammanbindning_1_N = mkN "sammanbindning" ; -- sammanbindning..nn.1
  sammanbiten_1_A = mkA "sammanbiten" ; -- sammanbiten..av.1
  sammanbitning_1_N = mkN "sammanbitning" ; -- sammanbitning..nn.1
  sammanblanda_1_V = mkV "sammanblandar" ; -- sammanblanda..vb.1
  sammanblandande_1_N = mkN "sammanblandande" ; -- sammanblandande..nn.1
  sammanblandning_1_N = mkN "sammanblandning" ; -- sammanblandning..nn.1
  sammanbo_1_V = mkV "sammanbor" ; -- sammanbo..vb.1
  sammanboende_1_A = mkA "sammanboende" ; -- sammanboende..av.1
  sammanboende_1_N = mkN "sammanboende" ; -- sammanboende..nn.1
  sammanbragt_1_A = mkA "sammanbragt" "sammanbragt" ; -- sammanbragt..av.1
  sammanbrott_1_N = mkN "sammanbrott" neutrum  ; -- sammanbrott..nn.1
  sammandra_1_V = mkV "sammandraga" "sammandrog" "sammandragit" ; -- sammandra..vb.1
  sammandrabba_1_V = mkV "sammandrabbar" ; -- sammandrabba..vb.1
  sammandrabbande_1_N = mkN "sammandrabbande" ; -- sammandrabbande..nn.1
  sammandrabbning_1_N = mkN "sammandrabbning" ; -- sammandrabbning..nn.1
  sammandrag_1_N = mkN "sammandrag" neutrum  ; -- sammandrag..nn.1
  sammandragande_1_N = mkN "sammandragande" ; -- sammandragande..nn.1
  sammandragning_1_N = mkN "sammandragning" ; -- sammandragning..nn.1
  sammanfall_1_N = mkN "sammanfall" neutrum  ; -- sammanfall..nn.1
  sammanfalla_1_V = mkV "sammanfalla" "sammanföll" "sammanfallit" ; -- sammanfalla..vb.1
  sammanfallande_1_N = mkN "sammanfallande" ; -- sammanfallande..nn.1
  sammanfatta_1_V = mkV "sammanfattar" ; -- sammanfatta..vb.1
  sammanfattande_1_N = mkN "sammanfattande" ; -- sammanfattande..nn.1
  sammanfattning_1_N = mkN "sammanfattning" ; -- sammanfattning..nn.1
  sammanfattningsvis_1_Adv = mkAdv "sammanfattningsvis" ; -- sammanfattningsvis..ab.1
  sammanflytning_1_N = mkN "sammanflytning" ; -- sammanflytning..nn.1
  sammanfläta_1_V = mkV "sammanflätar" ; -- sammanfläta..vb.1
  sammanflätande_1_N = mkN "sammanflätande" ; -- sammanflätande..nn.1
  sammanflöde_1_N = mkN "sammanflöde" ; -- sammanflöde..nn.1
  sammanfoga_1_V = mkV "sammanfogar" ; -- sammanfoga..vb.1
  sammanfogande_1_N = mkN "sammanfogande" ; -- sammanfogande..nn.1
  sammanfogning_1_N = mkN "sammanfogning" ; -- sammanfogning..nn.1
  sammanföra_1_V = mkV "sammanföra" "sammanförde" "sammanfört" ; -- sammanföra..vb.1
  sammanförande_1_N = mkN "sammanförande" ; -- sammanförande..nn.1
  sammangaddning_1_N = mkN "sammangaddning" ; -- sammangaddning..nn.1
  sammangyttrad_1_A = mkA "sammangyttrad" ; -- sammangyttrad..av.1
  sammangyttring_1_N = mkN "sammangyttring" ; -- sammangyttring..nn.1
  sammangå_1_V = mkV "sammangå" "sammangår" "sammangå" "sammangick" "sammangått" "sammangången" ; -- sammangå..vb.1
  sammangående_1_N = mkN "sammangående" ; -- sammangående..nn.1
  sammanhang_1_N = mkN "sammanhang" neutrum  ; -- sammanhang..nn.1
  sammanhopa_1_V = mkV "sammanhopar" ; -- sammanhopa..vb.1
  sammanhopande_1_N = mkN "sammanhopande" ; -- sammanhopande..nn.1
  sammanhopning_1_N = mkN "sammanhopning" ; -- sammanhopning..nn.1
  sammanhänga_1_V = mkV "sammanhänger" ; -- sammanhänga..vb.1
  sammanhängande_1_N = mkN "sammanhängande" ; -- sammanhängande..nn.1
  sammanhålla_1_V = mkV "sammanhålla" "sammanhöll" "sammanhållit" ; -- sammanhålla..vb.1
  sammanhållande_1_N = mkN "sammanhållande" ; -- sammanhållande..nn.1
  sammanhållen_1_A = mkA "sammanhållen" ; -- sammanhållen..av.1
  sammanhållig_1_A = mkA "sammanhållig" ; -- sammanhållig..av.1
  sammanhållighet_1_N = mkN "sammanhållighet" ; -- sammanhållighet..nn.1
  sammanhållning_1_N = mkN "sammanhållning" ; -- sammanhållning..nn.1
  sammanjämka_1_V = mkV "sammanjämkar" ; -- sammanjämka..vb.1
  sammanjämkande_1_N = mkN "sammanjämkande" ; -- sammanjämkande..nn.1
  sammanjämkning_1_N = mkN "sammanjämkning" ; -- sammanjämkning..nn.1
  sammankalla_1_V = mkV "sammankallar" ; -- sammankalla..vb.1
  sammankallande_1_A = mkA "sammankallande" ; -- sammankallande..av.1
  sammankallande_1_N = mkN "sammankallande" ; -- sammankallande..nn.1
  sammanknytning_1_N = mkN "sammanknytning" ; -- sammanknytning..nn.1
  sammankomst_1_N = mkN "sammankomst" "sammankomster" ; -- sammankomst..nn.1
  sammankoppla_1_V = mkV "sammankopplar" ; -- sammankoppla..vb.1
  sammankopplande_1_N = mkN "sammankopplande" ; -- sammankopplande..nn.1
  sammankoppling_1_N = mkN "sammankoppling" ; -- sammankoppling..nn.1
  sammankrympning_1_N = mkN "sammankrympning" ; -- sammankrympning..nn.1
  sammanlagd_1_A = mkA "sammanlagd" "sammanlagt" ; -- sammanlagd..av.1
  sammanleva_1_V = mkV "sammanlever" ; -- sammanleva..vb.1
  sammanlevande_1_N = mkN "sammanlevande" ; -- sammanlevande..nn.1
  sammanlevnad_1_N = mkN "sammanlevnad" ; -- sammanlevnad..nn.1
  sammanlägga_1_V = mkV "sammanlägga" "sammanla" "sammanlagt" ; -- sammanlägga..vb.1
  sammanläggande_1_N = mkN "sammanläggande" ; -- sammanläggande..nn.1
  sammanläggning_1_N = mkN "sammanläggning" ; -- sammanläggning..nn.1
  sammanläggningsavhandling_1_N = mkN "sammanläggningsavhandling" ; -- sammanläggningsavhandling..nn.1
  sammanlänka_1_V = mkV "sammanlänkar" ; -- sammanlänka..vb.1
  sammanlänkande_1_N = mkN "sammanlänkande" ; -- sammanlänkande..nn.1
  sammanlänkning_1_N = mkN "sammanlänkning" ; -- sammanlänkning..nn.1
  sammanlöpa_1_V = mkV "sammanlöper" ; -- sammanlöpa..vb.1
  sammanlöpande_1_N = mkN "sammanlöpande" ; -- sammanlöpande..nn.1
  sammanpacka_1_V = mkV "sammanpackar" ; -- sammanpacka..vb.1
  sammanpackande_1_N = mkN "sammanpackande" ; -- sammanpackande..nn.1
  sammanpackning_1_N = mkN "sammanpackning" ; -- sammanpackning..nn.1
  sammanparning_1_N = mkN "sammanparning" ; -- sammanparning..nn.1
  sammanpassning_1_N = mkN "sammanpassning" ; -- sammanpassning..nn.1
  sammanplockning_1_N = mkN "sammanplockning" ; -- sammanplockning..nn.1
  sammanpressa_1_V = mkV "sammanpressar" ; -- sammanpressa..vb.1
  sammanpressande_1_N = mkN "sammanpressande" ; -- sammanpressande..nn.1
  sammanrafsad_1_A = mkA "sammanrafsad" ; -- sammanrafsad..av.1
  sammanringa_1_V = mkV "sammanringer" ; -- sammanringa..vb.1
  sammanringande_1_N = mkN "sammanringande" ; -- sammanringande..nn.1
  sammanringning_1_N = mkN "sammanringning" ; -- sammanringning..nn.1
  sammanräkna_1_V = mkV "sammanräknar" ; -- sammanräkna..vb.1
  sammanräknande_1_N = mkN "sammanräknande" ; -- sammanräknande..nn.1
  sammanräkning_1_N = mkN "sammanräkning" ; -- sammanräkning..nn.1
  sammanröring_1_N = mkN "sammanröring" ; -- sammanröring..nn.1
  sammanrörning_1_N = mkN "sammanrörning" ; -- sammanrörning..nn.1
  sammansatt_1_A = mkA "sammansatt" ; -- sammansatt..av.1
  sammansatthet_1_N = mkN "sammansatthet" ; -- sammansatthet..nn.1
  sammanskjuta_1_V = mkV "sammanskjuta" "sammansköt" "sammanskjutit" ; -- sammanskjuta..vb.1
  sammanskjutande_1_N = mkN "sammanskjutande" ; -- sammanskjutande..nn.1
  sammanskockning_1_N = mkN "sammanskockning" ; -- sammanskockning..nn.1
  sammanskott_1_N = mkN "sammanskott" neutrum  ; -- sammanskott..nn.1
  sammanskriva_1_V = mkV "sammanskriva" "sammanskrev" "sammanskrivit" ; -- sammanskriva..vb.1
  sammanskrivande_1_N = mkN "sammanskrivande" ; -- sammanskrivande..nn.1
  sammanskrivning_1_N = mkN "sammanskrivning" ; -- sammanskrivning..nn.1
  sammanslagen_1_A = mkA "sammanslagen" ; -- sammanslagen..av.1
  sammanslagning_1_N = mkN "sammanslagning" ; -- sammanslagning..nn.1
  sammanslingrad_1_A = mkA "sammanslingrad" ; -- sammanslingrad..av.1
  sammanslutning_1_N = mkN "sammanslutning" ; -- sammanslutning..nn.1
  sammanslå_1_V = mkV "sammanslå" "sammanslog" "sammanslagit" ; -- sammanslå..vb.1
  sammanslående_1_N = mkN "sammanslående" ; -- sammanslående..nn.1
  sammansmälta_1_V = mkV "sammansmälta" "sammansmälter" "sammansmält" "sammansmälte" "sammansmält" "sammansmält" ; -- sammansmälta..vb.1
  sammansmältande_1_N = mkN "sammansmältande" ; -- sammansmältande..nn.1
  sammansmältning_1_N = mkN "sammansmältning" ; -- sammansmältning..nn.1
  sammanstråla_1_V = mkV "sammanstrålar" ; -- sammanstråla..vb.1
  sammanstrålande_1_N = mkN "sammanstrålande" ; -- sammanstrålande..nn.1
  sammanställa_1_V = mkV "sammanställer" ; -- sammanställa..vb.1
  sammanställande_1_N = mkN "sammanställande" ; -- sammanställande..nn.1
  sammanställning_1_N = mkN "sammanställning" ; -- sammanställning..nn.1
  sammanstörtande_1_N = mkN "sammanstörtande" ; -- sammanstörtande..nn.1
  sammanstörtning_1_N = mkN "sammanstörtning" ; -- sammanstörtning..nn.1
  sammanstöta_1_V = mkV "sammanstöter" ; -- sammanstöta..vb.1
  sammanstötande_1_N = mkN "sammanstötande" ; -- sammanstötande..nn.1
  sammanstötning_1_N = mkN "sammanstötning" ; -- sammanstötning..nn.1
  sammansvetsa_1_V = mkV "sammansvetsar" ; -- sammansvetsa..vb.1
  sammansvetsande_1_N = mkN "sammansvetsande" ; -- sammansvetsande..nn.1
  sammansvetsning_1_N = mkN "sammansvetsning" ; -- sammansvetsning..nn.1
  sammansvuren_1_A = mkA "sammansvuren" ; -- sammansvuren..av.1
  sammansvärjning_1_N = mkN "sammansvärjning" ; -- sammansvärjning..nn.1
  sammansätta_1_V = mkV "sammansätta" "sammansätter" "sammansätt" "sammansatte" "sammansatt" "sammansatt" ; -- sammansätta..vb.1
  sammansättande_1_N = mkN "sammansättande" ; -- sammansättande..nn.1
  sammansättning_1_N = mkN "sammansättning" ; -- sammansättning..nn.1
  sammansättningsanalys_1_N = mkN "sammansättningsanalys" "sammansättningsanalyser" ; -- sammansättningsanalys..nn.1
  sammansättningsfabrik_1_N = mkN "sammansättningsfabrik" "sammansättningsfabriker" ; -- sammansättningsfabrik..nn.1
  sammansättningsled_1_N = mkN "sammansättningsled" neutrum  ; -- sammansättningsled..nn.1
  sammantagen_1_A = mkA "sammantagen" ; -- sammantagen..av.1
  sammantrycka_1_V = mkV "sammantrycker" ; -- sammantrycka..vb.1
  sammantryckande_1_N = mkN "sammantryckande" ; -- sammantryckande..nn.1
  sammanträda_1_V = mkV "sammanträda" "sammanträdde" "sammanträtt" ; -- sammanträda..vb.1
  sammanträdande_1_N = mkN "sammanträdande" ; -- sammanträdande..nn.1
  sammanträde_1_N = mkN "sammanträde" ; -- sammanträde..nn.1
  sammanträdesordning_1_N = mkN "sammanträdesordning" ; -- sammanträdesordning..nn.1
  sammanträdesrum_1_N = mkN "sammanträdesrum" "sammanträdesrummet" "sammanträdesrum" "sammanträdesrummen" ; -- sammanträdesrum..nn.1
  sammanträffa_1_V = mkV "sammanträffar" ; -- sammanträffa..vb.1
  sammanträffande_1_N = mkN "sammanträffande" ; -- sammanträffande..nn.1
  sammanviga_1_V = mkV "sammanviger" ; -- sammanviga..vb.1
  sammanvigande_1_N = mkN "sammanvigande" ; -- sammanvigande..nn.1
  sammanvigning_1_N = mkN "sammanvigning" ; -- sammanvigning..nn.1
  sammanvikning_1_N = mkN "sammanvikning" ; -- sammanvikning..nn.1
  sammanvuxen_1_A = mkA "sammanvuxen" ; -- sammanvuxen..av.1
  sammanväga_1_V = mkV "sammanväger" ; -- sammanväga..vb.1
  sammanväva_1_V = mkV "sammanväver" ; -- sammanväva..vb.1
  sammanvävande_1_N = mkN "sammanvävande" ; -- sammanvävande..nn.1
  sammanvävning_1_N = mkN "sammanvävning" ; -- sammanvävning..nn.1
  sammanväxa_1_V = mkV "sammanväxer" ; -- sammanväxa..vb.1
  sammanväxande_1_N = mkN "sammanväxande" ; -- sammanväxande..nn.1
  sammanväxning_1_N = mkN "sammanväxning" ; -- sammanväxning..nn.1
  sammelband_1_N = mkN "sammelband" neutrum  ; -- sammelband..nn.1
  sammelnamn_1_N = mkN "sammelnamn" neutrum  ; -- sammelnamn..nn.1
  sammelplats_1_N = mkN "sammelplats" "sammelplatser" ; -- sammelplats..nn.1
  sammelsurium_1_N = mkN "sammelsurium" "sammelsuriet" "sammelsurier" "sammelsurierna" ; -- sammelsurium..nn.1
  sammet_1_N = mkN "sammet" ; -- sammet..nn.1
  sammetsblomster_1_N = mkN "sammetsblomster" neutrum  ; -- sammetsblomster..nn.1
  sammetslen_1_A = mkA "sammetslen" "sammetslent" ; -- sammetslen..av.1
  sammetsmjuk_1_A = mkA "sammetsmjuk" ; -- sammetsmjuk..av.1
  sammetsmjukhet_1_N = mkN "sammetsmjukhet" ; -- sammetsmjukhet..nn.1
  sammetsnatt_1_N = mkN "sammetsnatt" "sammetsnätter" ; -- sammetsnatt..nn.1
  sammäld_1_N = mkN "sammäld" ; -- sammäld..nn.1
  samnit_1_N = mkN "samnit" "samniter" ; -- samnit..nn.1
  samnordisk_1_A = mkA "samnordisk" ; -- samnordisk..av.1
  samoan_1_N = mkN "samoan" "samoaner" ; -- samoan..nn.1
  samoanska_1_N = mkN "samoanska" ; -- samoanska..nn.1
  samoanska_2_N = mkN "samoanska" ; -- samoanska..nn.2
  samojed_1_N = mkN "samojed" "samojeder" ; -- samojed..nn.1
  samojediska_1_N = mkN "samojediska" ; -- samojediska..nn.1
  samordna_1_V = mkV "samordnar" ; -- samordna..vb.1
  samordnande_1_N = mkN "samordnande" ; -- samordnande..nn.1
  samordnare_1_N = mkN "samordnare" utrum  ; -- samordnare..nn.1
  samordning_1_N = mkN "samordning" ; -- samordning..nn.1
  samordningsansvar_1_N = mkN "samordningsansvar" neutrum  ; -- samordningsansvar..nn.1
  samovar_1_N = mkN "samovar" "samovarer" ; -- samovar..nn.1
  sampan_1_N = mkN "sampan" "sampaner" ; -- sampan..nn.1
  sampel_1_N = mkN "sampel" neutrum  ; -- sampel..nn.1
  sampla_1_V = mkV "samplar" ; -- sampla..vb.1
  samplande_1_N = mkN "samplande" ; -- samplande..nn.1
  sampling_1_N = mkN "sampling" ; -- sampling..nn.1
  samregera_1_V = mkV "samregerar" ; -- samregera..vb.1
  samregerande_1_N = mkN "samregerande" ; -- samregerande..nn.1
  samregering_1_N = mkN "samregering" ; -- samregering..nn.1
  samråd_1_N = mkN "samråd" neutrum  ; -- samråd..nn.1
  samråda_1_V = mkV "samråda" "samrådde" "samrått" ; -- samråda..vb.1
  samrådande_1_N = mkN "samrådande" ; -- samrådande..nn.1
  samrådsrätt_1_N = mkN "samrådsrätt" ; -- samrådsrätt..nn.1
  samröre_1_N = mkN "samröre" ; -- samröre..nn.1
  sams_1_A = mkA "sams" ; -- sams..av.1
  samsa_1_V = mkV "samsar" ; -- samsa..vb.1
  samsande_1_N = mkN "samsande" ; -- samsande..nn.1
  samsara_1_N = mkN "samsara" ; -- samsara..nn.1
  samsikt_1_N = mkN "samsikt" ; -- samsikt..nn.1
  samskola_1_N = mkN "samskola" ; -- samskola..nn.1
  samspela_1_V = mkV "samspelar" ; -- samspela..vb.1
  samspelande_1_N = mkN "samspelande" ; -- samspelande..nn.1
  samspelt_1_A = mkA "samspelt" "samspelt" ; -- samspelt..av.1
  samspelthet_1_N = mkN "samspelthet" ; -- samspelthet..nn.1
  samspråk_1_N = mkN "samspråk" neutrum  ; -- samspråk..nn.1
  samspråka_1_V = mkV "samspråkar" ; -- samspråka..vb.1
  samspråkande_1_N = mkN "samspråkande" ; -- samspråkande..nn.1
  samstämd_1_A = mkA "samstämd" "samstämt" ; -- samstämd..av.1
  samstämdhet_1_N = mkN "samstämdhet" ; -- samstämdhet..nn.1
  samstämmig_1_A = mkA "samstämmig" ; -- samstämmig..av.1
  samstämmighet_1_N = mkN "samstämmighet" ; -- samstämmighet..nn.1
  samsu_1_N = mkN "samsu" ; -- samsu..nn.1
  samsyn_1_N = mkN "samsyn" ; -- samsyn..nn.1
  samsyskon_1_N = mkN "samsyskon" neutrum  ; -- samsyskon..nn.1
  samsändning_1_N = mkN "samsändning" ; -- samsändning..nn.1
  samtal_1_N = mkN "samtal" neutrum  ; -- samtal..nn.1
  samtala_1_V = mkV "samtalar" ; -- samtala..vb.1
  samtalande_1_N = mkN "samtalande" ; -- samtalande..nn.1
  samtalsavgift_1_N = mkN "samtalsavgift" "samtalsavgifter" ; -- samtalsavgift..nn.1
  samtalsgrupp_1_N = mkN "samtalsgrupp" "samtalsgrupper" ; -- samtalsgrupp..nn.1
  samtalsläge_1_N = mkN "samtalsläge" ; -- samtalsläge..nn.1
  samtalsmarkering_1_N = mkN "samtalsmarkering" ; -- samtalsmarkering..nn.1
  samtalsmätare_1_N = mkN "samtalsmätare" utrum  ; -- samtalsmätare..nn.1
  samtalsperiod_1_N = mkN "samtalsperiod" "samtalsperioder" ; -- samtalsperiod..nn.1
  samtalsrum_1_N = mkN "samtalsrum" "samtalsrummet" "samtalsrum" "samtalsrummen" ; -- samtalsrum..nn.1
  samtalsräknare_1_N = mkN "samtalsräknare" utrum  ; -- samtalsräknare..nn.1
  samtalsspråk_1_N = mkN "samtalsspråk" neutrum  ; -- samtalsspråk..nn.1
  samtalsterapeut_1_N = mkN "samtalsterapeut" "samtalsterapeuter" ; -- samtalsterapeut..nn.1
  samtalsterapi_1_N = mkN "samtalsterapi" ; -- samtalsterapi..nn.1
  samtalston_1_N = mkN "samtalston" ; -- samtalston..nn.1
  samtalsämne_1_N = mkN "samtalsämne" ; -- samtalsämne..nn.1
  samtaxera_1_V = mkV "samtaxerar" ; -- samtaxera..vb.1
  samtaxerande_1_N = mkN "samtaxerande" ; -- samtaxerande..nn.1
  samtaxerbar_1_A = mkA "samtaxerbar" ; -- samtaxerbar..av.1
  samtaxerbarhet_1_N = mkN "samtaxerbarhet" ; -- samtaxerbarhet..nn.1
  samtaxering_1_N = mkN "samtaxering" ; -- samtaxering..nn.1
  samtid_1_N = mkN "samtid" ; -- samtid..nn.1
  samtida_1_A = mkA "samtida" ; -- samtida..av.1
  samtidig_1_A = mkA "samtidig" ; -- samtidig..av.1
  samtidighet_1_N = mkN "samtidighet" "samtidigheter" ; -- samtidighet..nn.1
  samtidsarkeologi_1_N = mkN "samtidsarkeologi" ; -- samtidsarkeologi..nn.1
  samtidsbetraktare_1_N = mkN "samtidsbetraktare" utrum  ; -- samtidsbetraktare..nn.1
  samtidsdystopi_1_N = mkN "samtidsdystopi" "samtidsdystopier" ; -- samtidsdystopi..nn.1
  samtidshistoria_1_N = mkN "samtidshistoria" ; -- samtidshistoria..nn.1
  samtidskommentar_1_N = mkN "samtidskommentar" "samtidskommentarer" ; -- samtidskommentar..nn.1
  samtidskänsla_1_N = mkN "samtidskänsla" ; -- samtidskänsla..nn.1
  samtidsmiljö_1_N = mkN "samtidsmiljö" "samtidsmiljön" "samtidsmiljöer" "samtidsmiljöerna" ; -- samtidsmiljö..nn.1
  samtidsprosa_1_N = mkN "samtidsprosa" ; -- samtidsprosa..nn.1
  samtidsskildring_1_N = mkN "samtidsskildring" ; -- samtidsskildring..nn.1
  samtrafik_1_N = mkN "samtrafik" ; -- samtrafik..nn.1
  samtycka_1_V = mkV "samtycker" ; -- samtycka..vb.1
  samtyckande_1_N = mkN "samtyckande" ; -- samtyckande..nn.1
  samtycke_1_N = mkN "samtycke" ; -- samtycke..nn.1
  samum_1_N = mkN "samum" ; -- samum..nn.1
  samundervisning_1_N = mkN "samundervisning" ; -- samundervisning..nn.1
  samuraj_1_N = mkN "samuraj" "samurajer" ; -- samuraj..nn.1
  samurajsvärd_1_N = mkN "samurajsvärd" neutrum  ; -- samurajsvärd..nn.1
  samvarande_1_N = mkN "samvarande" ; -- samvarande..nn.1
  samvariation_1_N = mkN "samvariation" ; -- samvariation..nn.1
  samvaro_1_N = mkN "samvaro" ; -- samvaro..nn.1
  samverka_1_V = mkV "samverkar" ; -- samverka..vb.1
  samverkande_1_N = mkN "samverkande" ; -- samverkande..nn.1
  samverkanskomponent_1_N = mkN "samverkanskomponent" "samverkanskomponenter" ; -- samverkanskomponent..nn.1
  samverkansprojekt_1_N = mkN "samverkansprojekt" neutrum  ; -- samverkansprojekt..nn.1
  samvete_1_N = mkN "samvete" ; -- samvete..nn.1
  samvetsattack_1_N = mkN "samvetsattack" "samvetsattacker" ; -- samvetsattack..nn.1
  samvetsbetänklighet_1_N = mkN "samvetsbetänklighet" "samvetsbetänkligheter" ; -- samvetsbetänklighet..nn.1
  samvetsfrid_1_N = mkN "samvetsfrid" ; -- samvetsfrid..nn.1
  samvetsfrihet_1_N = mkN "samvetsfrihet" "samvetsfriheter" ; -- samvetsfrihet..nn.1
  samvetsfråga_1_N = mkN "samvetsfråga" ; -- samvetsfråga..nn.1
  samvetsfånge_1_N = mkN "samvetsfånge" utrum  ; -- samvetsfånge..nn.1
  samvetsförebråelse_1_N = mkN "samvetsförebråelse" "samvetsförebråelser" ; -- samvetsförebråelse..nn.1
  samvetsgrann_1_A = mkA "samvetsgrann" "samvetsgrant" ; -- samvetsgrann..av.1
  samvetsgrannhet_1_N = mkN "samvetsgrannhet" ; -- samvetsgrannhet..nn.1
  samvetskonflikt_1_N = mkN "samvetskonflikt" "samvetskonflikter" ; -- samvetskonflikt..nn.1
  samvetskval_1_N = mkN "samvetskval" neutrum  ; -- samvetskval..nn.1
  samvetslös_1_A = mkA "samvetslös" ; -- samvetslös..av.1
  samvetslöshet_1_N = mkN "samvetslöshet" "samvetslösheter" ; -- samvetslöshet..nn.1
  samvetsnöd_1_N = mkN "samvetsnöd" ; -- samvetsnöd..nn.1
  samvetspeng_1_N = mkN "samvetspeng" ; -- samvetspeng..nn.1
  samvetsplikt_1_N = mkN "samvetsplikt" "samvetsplikter" ; -- samvetsplikt..nn.1
  samvetsro_1_N = mkN "samvetsro" ; -- samvetsro..nn.1
  samvetssak_1_N = mkN "samvetssak" "samvetssaker" ; -- samvetssak..nn.1
  samvetsskäl_1_N = mkN "samvetsskäl" neutrum  ; -- samvetsskäl..nn.1
  samvetsstyng_1_N = mkN "samvetsstyng" neutrum  ; -- samvetsstyng..nn.1
  samvetstvång_1_N = mkN "samvetstvång" neutrum  ; -- samvetstvång..nn.1
  samvetsäktenskap_1_N = mkN "samvetsäktenskap" neutrum  ; -- samvetsäktenskap..nn.1
  samvetsöm_1_A = mkA "samvetsöm" "samvetsömt" "samvetsömma" "samvetsömma" "samvetsömmare" "samvetsömmast" "samvetsömmaste" ; -- samvetsöm..av.1
  samvetsömhet_1_N = mkN "samvetsömhet" ; -- samvetsömhet..nn.1
  samvälde_1_N = mkN "samvälde" ; -- samvälde..nn.1
  samägande_1_N = mkN "samägande" ; -- samägande..nn.1
  samäganderätt_1_N = mkN "samäganderätt" ; -- samäganderätt..nn.1
  samåka_1_V = mkV "samåker" ; -- samåka..vb.1
  samåkande_1_N = mkN "samåkande" ; -- samåkande..nn.1
  sanatorium_1_N = mkN "sanatorium" "sanatoriet" "sanatorier" "sanatorierna" ; -- sanatorium..nn.1
  sand_1_N = mkN "sand" ; -- sand..nn.1
  sanda_1_V = mkV "sandar" ; -- sanda..vb.1
  sandal_1_N = mkN "sandal" "sandaler" ; -- sandal..nn.1
  sandalett_1_N = mkN "sandalett" "sandaletter" ; -- sandalett..nn.1
  sandande_1_N = mkN "sandande" ; -- sandande..nn.1
  sandbacke_1_N = mkN "sandbacke" utrum  ; -- sandbacke..nn.1
  sandbad_1_N = mkN "sandbad" neutrum  ; -- sandbad..nn.1
  sandbakelse_1_N = mkN "sandbakelse" "sandbakelser" ; -- sandbakelse..nn.1
  sandbank_1_N = mkN "sandbank" ; -- sandbank..nn.1
  sandbindande_1_A = mkA "sandbindande" ; -- sandbindande..av.1
  sandbindare_1_N = mkN "sandbindare" utrum  ; -- sandbindare..nn.1
  sandblandad_1_A = mkA "sandblandad" ; -- sandblandad..av.1
  sandbläster_1_N = mkN "sandbläster" ; -- sandbläster..nn.1
  sandblästra_1_V = mkV "sandblästrar" ; -- sandblästra..vb.1
  sandblästrande_1_N = mkN "sandblästrande" ; -- sandblästrande..nn.1
  sandblästring_1_N = mkN "sandblästring" ; -- sandblästring..nn.1
  sandbotten_1_N = mkN "sandbotten" ; -- sandbotten..nn.1
  sandbrun_1_A = mkA "sandbrun" ; -- sandbrun..av.1
  sanddyn_1_N = mkN "sanddyn" "sanddyner" ; -- sanddyn..nn.1
  sandel_1_N = mkN "sandel" ; -- sandel..nn.1
  sandelolja_1_N = mkN "sandelolja" ; -- sandelolja..nn.1
  sandelträ_1_N = mkN "sandelträ" neutrum  ; -- sandelträ..nn.1
  sandelträd_1_N = mkN "sandelträd" neutrum  ; -- sandelträd..nn.1
  sandfluga_1_N = mkN "sandfluga" ; -- sandfluga..nn.1
  sandflugebett_1_N = mkN "sandflugebett" neutrum  ; -- sandflugebett..nn.1
  sandflundra_1_N = mkN "sandflundra" ; -- sandflundra..nn.1
  sandflykt_1_N = mkN "sandflykt" ; -- sandflykt..nn.1
  sandform_1_N = mkN "sandform" ; -- sandform..nn.1
  sandfärgad_1_A = mkA "sandfärgad" ; -- sandfärgad..av.1
  sandhavre_1_N = mkN "sandhavre" utrum  ; -- sandhavre..nn.1
  sandhed_1_N = mkN "sandhed" ; -- sandhed..nn.1
  sandig_1_A = mkA "sandig" ; -- sandig..av.1
  sandighet_1_N = mkN "sandighet" ; -- sandighet..nn.1
  sandjord_1_N = mkN "sandjord" ; -- sandjord..nn.1
  sandjägare_1_N = mkN "sandjägare" utrum  ; -- sandjägare..nn.1
  sandkaka_1_N = mkN "sandkaka" ; -- sandkaka..nn.1
  sandkorn_1_N = mkN "sandkorn" neutrum  ; -- sandkorn..nn.1
  sandkrasse_1_N = mkN "sandkrasse" utrum  ; -- sandkrasse..nn.1
  sandkrypare_1_N = mkN "sandkrypare" utrum  ; -- sandkrypare..nn.1
  sandlilja_1_N = mkN "sandlilja" ; -- sandlilja..nn.1
  sandloppa_1_N = mkN "sandloppa" ; -- sandloppa..nn.1
  sandlåda_1_N = mkN "sandlåda" ; -- sandlåda..nn.1
  sandlådekrig_1_N = mkN "sandlådekrig" neutrum  ; -- sandlådekrig..nn.1
  sandlådenivå_1_N = mkN "sandlådenivå" ; -- sandlådenivå..nn.1
  sandlöpare_1_N = mkN "sandlöpare" utrum  ; -- sandlöpare..nn.1
  sandmark_1_N = mkN "sandmark" "sandmarker" ; -- sandmark..nn.1
  sandmask_1_N = mkN "sandmask" ; -- sandmask..nn.1
  sandmussla_1_N = mkN "sandmussla" ; -- sandmussla..nn.1
  sandnarv_1_N = mkN "sandnarv" ; -- sandnarv..nn.1
  sandnejlika_1_N = mkN "sandnejlika" ; -- sandnejlika..nn.1
  sandnörel_1_N = mkN "sandnörel" ; -- sandnörel..nn.1
  sandpapper_1_N = mkN "sandpapper" neutrum  ; -- sandpapper..nn.1
  sandpappra_1_V = mkV "sandpapprar" ; -- sandpappra..vb.1
  sandpapprande_1_N = mkN "sandpapprande" ; -- sandpapprande..nn.1
  sandpärla_1_N = mkN "sandpärla" ; -- sandpärla..nn.1
  sandrev_1_N = mkN "sandrev" neutrum  ; -- sandrev..nn.1
  sandrevel_1_N = mkN "sandrevel" ; -- sandrevel..nn.1
  sandräka_1_N = mkN "sandräka" ; -- sandräka..nn.1
  sandrör_1_N = mkN "sandrör" neutrum  ; -- sandrör..nn.1
  sandskädda_1_N = mkN "sandskädda" ; -- sandskädda..nn.1
  sandspår_1_N = mkN "sandspår" neutrum  ; -- sandspår..nn.1
  sandstenshus_1_N = mkN "sandstenshus" neutrum  ; -- sandstenshus..nn.1
  sandstenstrappa_1_N = mkN "sandstenstrappa" ; -- sandstenstrappa..nn.1
  sandstorm_1_N = mkN "sandstorm" ; -- sandstorm..nn.1
  sandstrand_1_N = mkN "sandstrand" "sandstränder" ; -- sandstrand..nn.1
  sandsugare_1_N = mkN "sandsugare" utrum  ; -- sandsugare..nn.1
  sandsäck_1_N = mkN "sandsäck" ; -- sandsäck..nn.1
  sandtag_1_N = mkN "sandtag" neutrum  ; -- sandtag..nn.1
  sandtrav_1_N = mkN "sandtrav" ; -- sandtrav..nn.1
  sandtäkt_1_N = mkN "sandtäkt" "sandtäkter" ; -- sandtäkt..nn.1
  sandur_1_N = mkN "sandur" neutrum  ; -- sandur..nn.1
  sandvikare_1_N = mkN "sandvikare" utrum  ; -- sandvikare..nn.1
  sandvita_1_N = mkN "sandvita" ; -- sandvita..nn.1
  sandväxt_1_N = mkN "sandväxt" "sandväxter" ; -- sandväxt..nn.1
  sandwich_1_N = mkN "sandwich" ; -- sandwich..nn.1
  sandwichman_1_N = mkN "sandwichman" "sandwichmannen" "sandwichmän" "sandwichmännen" ; -- sandwichman..nn.1
  sandödla_1_N = mkN "sandödla" ; -- sandödla..nn.1
  sandöken_1_N = mkN "sandöken" "sandökenn" "sandöknar" "sandöknarna" ; -- sandöken..nn.1
  sanera_1_V = mkV "sanerar" ; -- sanera..vb.1
  sanerande_1_N = mkN "sanerande" ; -- sanerande..nn.1
  sanerbar_1_A = mkA "sanerbar" ; -- sanerbar..av.1
  sanerbarhet_1_N = mkN "sanerbarhet" ; -- sanerbarhet..nn.1
  sanering_1_N = mkN "sanering" ; -- sanering..nn.1
  saneringsfartyg_1_N = mkN "saneringsfartyg" neutrum  ; -- saneringsfartyg..nn.1
  saneringsfastighet_1_N = mkN "saneringsfastighet" "saneringsfastigheter" ; -- saneringsfastighet..nn.1
  saneringsfirma_1_N = mkN "saneringsfirma" ; -- saneringsfirma..nn.1
  saneringskostnad_1_N = mkN "saneringskostnad" "saneringskostnader" ; -- saneringskostnad..nn.1
  saneringsmedel_1_N = mkN "saneringsmedel" neutrum  ; -- saneringsmedel..nn.1
  saneringsplan_1_N = mkN "saneringsplan" "saneringsplaner" ; -- saneringsplan..nn.1
  sanforisera_1_V = mkV "sanforiserar" ; -- sanforisera..vb.1
  sanforiserande_1_N = mkN "sanforiserande" ; -- sanforiserande..nn.1
  sanforiserbar_1_A = mkA "sanforiserbar" ; -- sanforiserbar..av.1
  sanforiserbarhet_1_N = mkN "sanforiserbarhet" ; -- sanforiserbarhet..nn.1
  sanforisering_1_N = mkN "sanforisering" ; -- sanforisering..nn.1
  sang_1_N = mkN "sang" "sangen" "sang" "sangen" ; -- sang..nn.1
  sangria_1_N = mkN "sangria" ; -- sangria..nn.1
  sangviniker_1_N = mkN "sangviniker" "sangvinikern" "sangviniker" "sangvinikerna" ; -- sangviniker..nn.1
  sangvinisk_1_A = mkA "sangvinisk" ; -- sangvinisk..av.1
  sanitet_1_N = mkN "sanitet" "saniteter" ; -- sanitet..nn.1
  sanitetsanstalt_1_N = mkN "sanitetsanstalt" "sanitetsanstalter" ; -- sanitetsanstalt..nn.1
  sanitetsartikel_1_N = mkN "sanitetsartikel" ; -- sanitetsartikel..nn.1
  sanitetsbinda_1_N = mkN "sanitetsbinda" ; -- sanitetsbinda..nn.1
  sanitetsflagga_1_N = mkN "sanitetsflagga" ; -- sanitetsflagga..nn.1
  sanitetsgods_1_N = mkN "sanitetsgods" neutrum  ; -- sanitetsgods..nn.1
  sanitetshund_1_N = mkN "sanitetshund" ; -- sanitetshund..nn.1
  sanitetskompani_1_N = mkN "sanitetskompani" "sanitetskompaniet" "sanitetskompanier" "sanitetskompanierna" ; -- sanitetskompani..nn.1
  sanitetskärl_1_N = mkN "sanitetskärl" neutrum  ; -- sanitetskärl..nn.1
  sanitetsporslin_1_N = mkN "sanitetsporslin" neutrum  ; -- sanitetsporslin..nn.1
  sanitetsteknik_1_N = mkN "sanitetsteknik" ; -- sanitetsteknik..nn.1
  sanitetstekniker_1_N = mkN "sanitetstekniker" "sanitetsteknikern" "sanitetstekniker" "sanitetsteknikerna" ; -- sanitetstekniker..nn.1
  sanitetstrupp_1_N = mkN "sanitetstrupp" "sanitetstrupper" ; -- sanitetstrupp..nn.1
  sanitär_1_A = mkA "sanitär" ; -- sanitär..av.1
  sank_1_A = mkA "sank" ; -- sank..av.1
  sankhet_1_N = mkN "sankhet" ; -- sankhet..nn.1
  sankt_1_A = mkA "sankt" "sankt" ; -- sankt..av.1
  sanktbernhardshund_1_N = mkN "sanktbernhardshund" ; -- sanktbernhardshund..nn.1
  sanktifiera_1_V = mkV "sanktifierar" ; -- sanktifiera..vb.1
  sanktifierande_1_N = mkN "sanktifierande" ; -- sanktifierande..nn.1
  sanktifierbar_1_A = mkA "sanktifierbar" ; -- sanktifierbar..av.1
  sanktifierbarhet_1_N = mkN "sanktifierbarhet" ; -- sanktifierbarhet..nn.1
  sanktifiering_1_N = mkN "sanktifiering" ; -- sanktifiering..nn.1
  sanktifikation_1_N = mkN "sanktifikation" ; -- sanktifikation..nn.1
  sanktion_1_N = mkN "sanktion" ; -- sanktion..nn.1
  sanktionera_1_V = mkV "sanktionerar" ; -- sanktionera..vb.1
  sanktionerande_1_N = mkN "sanktionerande" ; -- sanktionerande..nn.1
  sanktionerbar_1_A = mkA "sanktionerbar" ; -- sanktionerbar..av.1
  sanktionerbarhet_1_N = mkN "sanktionerbarhet" ; -- sanktionerbarhet..nn.1
  sanktionering_1_N = mkN "sanktionering" ; -- sanktionering..nn.1
  sanktionsmakt_1_N = mkN "sanktionsmakt" ; -- sanktionsmakt..nn.1
  sanktionspolitik_1_N = mkN "sanktionspolitik" ; -- sanktionspolitik..nn.1
  sanktpaulia_1_N = mkN "sanktpaulia" ; -- sanktpaulia..nn.1
  sanktuarium_1_N = mkN "sanktuarium" "sanktuariet" "sanktuarier" "sanktuarierna" ; -- sanktuarium..nn.1
  sanmarinesare_1_N = mkN "sanmarinesare" utrum  ; -- sanmarinesare..nn.1
  sanmarinesisk_1_A = mkA "sanmarinesisk" ; -- sanmarinesisk..av.1
  sanmarinier_1_N = mkN "sanmarinier" "sanmariniern" "sanmarinier" "sanmarinierna" ; -- sanmarinier..nn.1
  sanmarinsk_1_A = mkA "sanmarinsk" ; -- sanmarinsk..av.1
  sanmarinska_1_N = mkN "sanmarinska" ; -- sanmarinska..nn.1
  sann_1_A = mkA "sann" "sant" ; -- sann..av.1
  sanna_1_V = mkV "sannar" ; -- sanna..vb.1
  sannande_1_N = mkN "sannande" ; -- sannande..nn.1
  sanndröm_1_N = mkN "sanndröm" "sanndrömmen" "sanndrömmar" "sanndrömmarna" ; -- sanndröm..nn.1
  sannerligen_1_Adv = mkAdv "sannerligen" ; -- sannerligen..ab.1
  sannfärdig_1_A = mkA "sannfärdig" ; -- sannfärdig..av.1
  sannfärdighet_1_N = mkN "sannfärdighet" ; -- sannfärdighet..nn.1
  sannhet_1_N = mkN "sannhet" ; -- sannhet..nn.1
  sanning_1_N = mkN "sanning" ; -- sanning..nn.1
  sanningsanspråk_1_N = mkN "sanningsanspråk" neutrum  ; -- sanningsanspråk..nn.1
  sanningsdrog_1_N = mkN "sanningsdrog" "sanningsdroger" ; -- sanningsdrog..nn.1
  sanningsenlig_1_A = mkA "sanningsenlig" ; -- sanningsenlig..av.1
  sanningsenlighet_1_N = mkN "sanningsenlighet" ; -- sanningsenlighet..nn.1
  sanningsförsäkran_1_N = mkN "sanningsförsäkran" "sanningsförsäkran" "sanningsförsäkringar" "sanningsförsäkringarna" ; -- sanningsförsäkran..nn.1
  sanningshalt_1_N = mkN "sanningshalt" ; -- sanningshalt..nn.1
  sanningskommission_1_N = mkN "sanningskommission" ; -- sanningskommission..nn.1
  sanningskorn_1_N = mkN "sanningskorn" neutrum  ; -- sanningskorn..nn.1
  sanningskrav_1_N = mkN "sanningskrav" neutrum  ; -- sanningskrav..nn.1
  sanningskärlek_1_N = mkN "sanningskärlek" ; -- sanningskärlek..nn.1
  sanningslidelse_1_N = mkN "sanningslidelse" utrum  ; -- sanningslidelse..nn.1
  sanningslös_1_A = mkA "sanningslös" ; -- sanningslös..av.1
  sanningslöshet_1_N = mkN "sanningslöshet" ; -- sanningslöshet..nn.1
  sanningsserum_1_N = mkN "sanningsserum" neutrum  ; -- sanningsserum..nn.1
  sanningssägare_1_N = mkN "sanningssägare" utrum  ; -- sanningssägare..nn.1
  sanningssökande_1_A = mkA "sanningssökande" ; -- sanningssökande..av.1
  sanningssökande_1_N = mkN "sanningssökande" ; -- sanningssökande..nn.1
  sanningssökare_1_N = mkN "sanningssökare" utrum  ; -- sanningssökare..nn.1
  sanningsvittne_1_N = mkN "sanningsvittne" ; -- sanningsvittne..nn.1
  sanningsvärde_1_N = mkN "sanningsvärde" ; -- sanningsvärde..nn.1
  sanningsälskande_1_A = mkA "sanningsälskande" ; -- sanningsälskande..av.1
  sannolik_1_A = mkA "sannolik" ; -- sannolik..av.1
  sannolikhet_1_N = mkN "sannolikhet" "sannolikheter" ; -- sannolikhet..nn.1
  sannolikhetsberäkna_1_V = mkV "sannolikhetsberäknar" ; -- sannolikhetsberäkna..vb.1
  sannolikhetsberäknande_1_N = mkN "sannolikhetsberäknande" ; -- sannolikhetsberäknande..nn.1
  sannolikhetsberäkning_1_N = mkN "sannolikhetsberäkning" ; -- sannolikhetsberäkning..nn.1
  sannolikhetsbevis_1_N = mkN "sannolikhetsbevis" neutrum  ; -- sannolikhetsbevis..nn.1
  sannolikhetskalkyl_1_N = mkN "sannolikhetskalkyl" "sannolikhetskalkyler" ; -- sannolikhetskalkyl..nn.1
  sannolikhetsteori_1_N = mkN "sannolikhetsteori" "sannolikhetsteorier" ; -- sannolikhetsteori..nn.1
  sannolikhetsvåg_1_N = mkN "sannolikhetsvåg" "sannolikhetsvågor" ; -- sannolikhetsvåg..nn.1
  sannsaga_1_N = mkN "sannsaga" ; -- sannsaga..nn.1
  sannskyldig_1_A = mkA "sannskyldig" ; -- sannskyldig..av.1
  sannskyldighet_1_N = mkN "sannskyldighet" ; -- sannskyldighet..nn.1
  sannspådd_1_A = mkA "sannspådd" ; -- sannspådd..av.1
  sannspåddhet_1_N = mkN "sannspåddhet" ; -- sannspåddhet..nn.1
  sans_1_N = mkN "sans" ; -- sans..nn.1
  sansad_1_A = mkA "sansad" ; -- sansad..av.1
  sansculotte_1_N = mkN "sansculotte" "sansculotter" ; -- sansculotte..nn.1
  sanserif_1_N = mkN "sanserif" "sanserifer" ; -- sanserif..nn.1
  sanseriff_1_N = mkN "sanseriff" "sanseriffer" ; -- sanseriff..nn.1
  sanskrit_1_N = mkN "sanskrit" ; -- sanskrit..nn.1
  sanskulott_1_N = mkN "sanskulott" "sanskulotter" ; -- sanskulott..nn.1
  sanslös_1_A = mkA "sanslös" ; -- sanslös..av.1
  sanslöshet_1_N = mkN "sanslöshet" ; -- sanslöshet..nn.1
  sanslöshet_2_N = mkN "sanslöshet" "sanslösheter" ; -- sanslöshet..nn.2
  sansning_1_N = mkN "sansning" ; -- sansning..nn.1
  sansserif_1_N = mkN "sansserif" "sansserifer" ; -- sansserif..nn.1
  sansseriff_1_N = mkN "sansseriff" "sansseriffer" ; -- sansseriff..nn.1
  saotomean_1_N = mkN "saotomean" "saotomeaner" ; -- saotomean..nn.1
  saotomeansk_1_A = mkA "saotomeansk" ; -- saotomeansk..av.1
  saotomeanska_1_N = mkN "saotomeanska" ; -- saotomeanska..nn.1
  sapfisk_1_A = mkA "sapfisk" ; -- sapfisk..av.1
  saponifiera_1_V = mkV "saponifierar" ; -- saponifiera..vb.1
  saponifierande_1_N = mkN "saponifierande" ; -- saponifierande..nn.1
  saponifierbar_1_A = mkA "saponifierbar" ; -- saponifierbar..av.1
  saponifierbarhet_1_N = mkN "saponifierbarhet" ; -- saponifierbarhet..nn.1
  saponifiering_1_N = mkN "saponifiering" ; -- saponifiering..nn.1
  saponin_1_N = mkN "saponin" "saponinet" "saponiner" "saponinerna" ; -- saponin..nn.1
  sapp_1_N = mkN "sapp" "sapper" ; -- sapp..nn.1
  sappör_1_N = mkN "sappör" "sappörer" ; -- sappör..nn.1
  saprofyt_1_N = mkN "saprofyt" "saprofyter" ; -- saprofyt..nn.1
  saprogen_1_A = mkA "saprogen" "saprogent" ; -- saprogen..av.1
  saraband_1_N = mkN "saraband" "sarabander" ; -- saraband..nn.1
  saracen_1_N = mkN "saracen" "saracener" ; -- saracen..nn.1
  saracensk_1_A = mkA "saracensk" ; -- saracensk..av.1
  sarafan_1_N = mkN "sarafan" "sarafaner" ; -- sarafan..nn.1
  sard_1_N = mkN "sard" "sarder" ; -- sard..nn.1
  sardell_1_N = mkN "sardell" "sardeller" ; -- sardell..nn.1
  sardin_1_N = mkN "sardin" "sardiner" ; -- sardin..nn.1
  sardinare_1_N = mkN "sardinare" utrum  ; -- sardinare..nn.1
  sardinburk_1_N = mkN "sardinburk" ; -- sardinburk..nn.1
  sardinisk_1_A = mkA "sardinisk" ; -- sardinisk..av.1
  sardiniska_1_N = mkN "sardiniska" ; -- sardiniska..nn.1
  sardiniska_2_N = mkN "sardiniska" ; -- sardiniska..nn.2
  sardinsk_1_A = mkA "sardinsk" ; -- sardinsk..av.1
  sardinska_1_N = mkN "sardinska" ; -- sardinska..nn.1
  sardinska_2_N = mkN "sardinska" ; -- sardinska..nn.2
  sardisk_1_A = mkA "sardisk" ; -- sardisk..av.1
  sardiska_1_N = mkN "sardiska" ; -- sardiska..nn.1
  sardiska_2_N = mkN "sardiska" ; -- sardiska..nn.2
  sardonisk_1_A = mkA "sardonisk" ; -- sardonisk..av.1
  sardonyx_1_N = mkN "sardonyx" ; -- sardonyx..nn.1
  sarg_1_N = mkN "sarg" ; -- sarg..nn.1
  sarga_1_V = mkV "sargar" ; -- sarga..vb.1
  sargande_1_N = mkN "sargande" ; -- sargande..nn.1
  sargasso_1_N = mkN "sargasso" ; -- sargasso..nn.1
  sargassotång_1_N = mkN "sargassotång" ; -- sargassotång..nn.1
  sargning_1_N = mkN "sargning" ; -- sargning..nn.1
  sari_1_N = mkN "sari" "sarin" "saris" "sarisarna" ; -- sari..nn.1
  sarin_1_N = mkN "sarin" neutrum  ; -- sarin..nn.1
  sarkasm_1_N = mkN "sarkasm" "sarkasmer" ; -- sarkasm..nn.1
  sarkastisk_1_A = mkA "sarkastisk" ; -- sarkastisk..av.1
  sarkofag_1_N = mkN "sarkofag" "sarkofager" ; -- sarkofag..nn.1
  sarkom_1_N = mkN "sarkom" neutrum  ; -- sarkom..nn.1
  sarong_1_N = mkN "sarong" "saronger" ; -- sarong..nn.1
  sars_1_N = mkN "sars" "sarser" ; -- sars..nn.1
  sarv_1_N = mkN "sarv" ; -- sarv..nn.1
  satanisk_1_A = mkA "satanisk" ; -- satanisk..av.1
  satanism_1_N = mkN "satanism" "satanismer" ; -- satanism..nn.1
  satanist_1_N = mkN "satanist" "satanister" ; -- satanist..nn.1
  satanistisk_1_A = mkA "satanistisk" ; -- satanistisk..av.1
  satans_1_A = mkA "satans" ; -- satans..av.1
  satanskult_1_N = mkN "satanskult" ; -- satanskult..nn.1
  sate_1_N = mkN "sate" utrum  ; -- sate..nn.1
  satellit_1_N = mkN "satellit" "satelliter" ; -- satellit..nn.1
  satellitbana_1_N = mkN "satellitbana" ; -- satellitbana..nn.1
  satellitbevakning_1_N = mkN "satellitbevakning" ; -- satellitbevakning..nn.1
  satellitbild_1_N = mkN "satellitbild" "satellitbilder" ; -- satellitbild..nn.1
  satellitkamera_1_N = mkN "satellitkamera" ; -- satellitkamera..nn.1
  satellitkarta_1_N = mkN "satellitkarta" ; -- satellitkarta..nn.1
  satellitradio_1_N = mkN "satellitradio" ; -- satellitradio..nn.1
  satellitradiostation_1_N = mkN "satellitradiostation" ; -- satellitradiostation..nn.1
  satellitstat_1_N = mkN "satellitstat" "satellitstater" ; -- satellitstat..nn.1
  satellitövervakning_1_N = mkN "satellitövervakning" ; -- satellitövervakning..nn.1
  satemspråk_1_N = mkN "satemspråk" neutrum  ; -- satemspråk..nn.1
  satin_1_N = mkN "satin" "satiner" ; -- satin..nn.1
  satinera_1_V = mkV "satinerar" ; -- satinera..vb.1
  satinerande_1_N = mkN "satinerande" ; -- satinerande..nn.1
  satinerbar_1_A = mkA "satinerbar" ; -- satinerbar..av.1
  satinerbarhet_1_N = mkN "satinerbarhet" ; -- satinerbarhet..nn.1
  satinering_1_N = mkN "satinering" ; -- satinering..nn.1
  satinliknande_1_A = mkA "satinliknande" ; -- satinliknande..av.1
  satir_1_N = mkN "satir" "satirer" ; -- satir..nn.1
  satirdiktare_1_N = mkN "satirdiktare" utrum  ; -- satirdiktare..nn.1
  satiriker_1_N = mkN "satiriker" "satirikern" "satiriker" "satirikerna" ; -- satiriker..nn.1
  satirisera_1_V = mkV "satiriserar" ; -- satirisera..vb.1
  satiriserande_1_N = mkN "satiriserande" ; -- satiriserande..nn.1
  satirisering_1_N = mkN "satirisering" ; -- satirisering..nn.1
  satirisk_1_A = mkA "satirisk" ; -- satirisk..av.1
  satisfaktion_1_N = mkN "satisfaktion" ; -- satisfaktion..nn.1
  satisfiera_1_V = mkV "satisfierar" ; -- satisfiera..vb.1
  satisfierande_1_N = mkN "satisfierande" ; -- satisfierande..nn.1
  satisfierbar_1_A = mkA "satisfierbar" ; -- satisfierbar..av.1
  satisfierbarhet_1_N = mkN "satisfierbarhet" ; -- satisfierbarhet..nn.1
  satisfiering_1_N = mkN "satisfiering" ; -- satisfiering..nn.1
  satkäring_1_N = mkN "satkäring" ; -- satkäring..nn.1
  satkärring_1_N = mkN "satkärring" ; -- satkärring..nn.1
  satmara_1_N = mkN "satmara" ; -- satmara..nn.1
  satrap_1_N = mkN "satrap" "satraper" ; -- satrap..nn.1
  satrapi_1_N = mkN "satrapi" "satrapier" ; -- satrapi..nn.1
  sats_1_N = mkN "sats" "satser" ; -- sats..nn.1
  satsa_1_V = mkV "satsar" ; -- satsa..vb.1
  satsaccent_1_N = mkN "satsaccent" "satsaccenter" ; -- satsaccent..nn.1
  satsadverbial_1_N = mkN "satsadverbial" neutrum  ; -- satsadverbial..nn.1
  satsanalys_1_N = mkN "satsanalys" "satsanalyser" ; -- satsanalys..nn.1
  satsande_1_N = mkN "satsande" ; -- satsande..nn.1
  satsbindning_1_N = mkN "satsbindning" ; -- satsbindning..nn.1
  satsbord_1_N = mkN "satsbord" neutrum  ; -- satsbord..nn.1
  satsbräda_1_N = mkN "satsbräda" ; -- satsbräda..nn.1
  satsbräde_1_N = mkN "satsbräde" ; -- satsbräde..nn.1
  satsbyggnad_1_N = mkN "satsbyggnad" "satsbyggnader" ; -- satsbyggnad..nn.1
  satsdel_1_N = mkN "satsdel" "satsdelen" "satsdelar" "satsdelarna" ; -- satsdel..nn.1
  satsfläta_1_N = mkN "satsfläta" ; -- satsfläta..nn.1
  satsfogning_1_N = mkN "satsfogning" ; -- satsfogning..nn.1
  satsföljd_1_N = mkN "satsföljd" ; -- satsföljd..nn.1
  satsförkortning_1_N = mkN "satsförkortning" ; -- satsförkortning..nn.1
  satsig_1_A = mkA "satsig" ; -- satsig..av.1
  satskommatering_1_N = mkN "satskommatering" ; -- satskommatering..nn.1
  satskompletteringstest_1_N = mkN "satskompletteringstest" neutrum  ; -- satskompletteringstest..nn.1
  satskonstruktion_1_N = mkN "satskonstruktion" ; -- satskonstruktion..nn.1
  satslära_1_N = mkN "satslära" ; -- satslära..nn.1
  satslösning_1_N = mkN "satslösning" ; -- satslösning..nn.1
  satsmelodi_1_N = mkN "satsmelodi" "satsmelodier" ; -- satsmelodi..nn.1
  satsning_1_N = mkN "satsning" ; -- satsning..nn.1
  satstyp_1_N = mkN "satstyp" "satstyper" ; -- satstyp..nn.1
  satsuma_1_N = mkN "satsuma" "satsuman" "satsumas" "satsumasarna" ; -- satsuma..nn.1
  satsyta_1_N = mkN "satsyta" ; -- satsyta..nn.1
  satt_1_A = mkA "satt" ; -- satt..av.1
  satthet_1_N = mkN "satthet" ; -- satthet..nn.1
  sattyg_1_N = mkN "sattyg" neutrum  ; -- sattyg..nn.1
  satunge_1_N = mkN "satunge" utrum  ; -- satunge..nn.1
  saturera_1_V = mkV "saturerar" ; -- saturera..vb.1
  saturerande_1_N = mkN "saturerande" ; -- saturerande..nn.1
  saturerbar_1_A = mkA "saturerbar" ; -- saturerbar..av.1
  saturerbarhet_1_N = mkN "saturerbarhet" ; -- saturerbarhet..nn.1
  saturering_1_N = mkN "saturering" ; -- saturering..nn.1
  saturnaliefest_1_N = mkN "saturnaliefest" "saturnaliefester" ; -- saturnaliefest..nn.1
  saturnalisk_1_A = mkA "saturnalisk" ; -- saturnalisk..av.1
  saturnisk_1_A = mkA "saturnisk" ; -- saturnisk..av.1
  saturnism_1_N = mkN "saturnism" "saturnismer" ; -- saturnism..nn.1
  satyr_1_N = mkN "satyr" "satyrer" ; -- satyr..nn.1
  satyrdrama_1_N = mkN "satyrdrama" "satyrdramat" "satyrdramer" "satyrdramerna" ; -- satyrdrama..nn.1
  satyriasis_1_N = mkN "satyriasis" ; -- satyriasis..nn.1
  satyrisk_1_A = mkA "satyrisk" ; -- satyrisk..av.1
  satyriskhet_1_N = mkN "satyriskhet" ; -- satyriskhet..nn.1
  satyrspel_1_N = mkN "satyrspel" "satyrspelet" "satyrspel" "satyrspelen" ; -- satyrspel..nn.1
  satäng_1_N = mkN "satäng" "satänger" ; -- satäng..nn.1
  saudiarab_1_N = mkN "saudiarab" "saudiaraber" ; -- saudiarab..nn.1
  saudiarabisk_1_A = mkA "saudiarabisk" ; -- saudiarabisk..av.1
  saudiarabiska_1_N = mkN "saudiarabiska" ; -- saudiarabiska..nn.1
  saudier_1_N = mkN "saudier" "saudiern" "saudier" "saudierna" ; -- saudier..nn.1
  saudisk_1_A = mkA "saudisk" ; -- saudisk..av.1
  sauerkraut_1_N = mkN "sauerkraut" ; -- sauerkraut..nn.1
  sauna_1_N = mkN "sauna" ; -- sauna..nn.1
  sautera_1_V = mkV "sauterar" ; -- sautera..vb.1
  sauterande_1_N = mkN "sauterande" ; -- sauterande..nn.1
  sauterbar_1_A = mkA "sauterbar" ; -- sauterbar..av.1
  sauterbarhet_1_N = mkN "sauterbarhet" ; -- sauterbarhet..nn.1
  sautering_1_N = mkN "sautering" ; -- sautering..nn.1
  sauternes_1_N = mkN "sauternes" ; -- sauternes..nn.1
  sauté_1_N = mkN "sauté" "sautéer" ; -- sauté..nn.1
  sauvera_1_V = mkV "sauverar" ; -- sauvera..vb.1
  sauverande_1_N = mkN "sauverande" ; -- sauverande..nn.1
  sauverbar_1_A = mkA "sauverbar" ; -- sauverbar..av.1
  sauverbarhet_1_N = mkN "sauverbarhet" ; -- sauverbarhet..nn.1
  sauvering_1_N = mkN "sauvering" ; -- sauvering..nn.1
  sav_1_N = mkN "sav" ; -- sav..nn.1
  sava_1_V = mkV "savar" ; -- sava..vb.1
  savande_1_N = mkN "savande" ; -- savande..nn.1
  savann_1_N = mkN "savann" "savanner" ; -- savann..nn.1
  savarin_1_N = mkN "savarin" "savariner" ; -- savarin..nn.1
  savig_1_A = mkA "savig" ; -- savig..av.1
  savning_1_N = mkN "savning" ; -- savning..nn.1
  savningstid_1_N = mkN "savningstid" "savningstider" ; -- savningstid..nn.1
  savoir_faire_1_N = mkN "savoir-faire" ; -- savoir-faire..nn.1
  savoir_vivre_1_N = mkN "savoir-vivre" ; -- savoir-vivre..nn.1
  savojard_1_N = mkN "savojard" "savojarder" ; -- savojard..nn.1
  savojkål_1_N = mkN "savojkål" ; -- savojkål..nn.1
  savtid_1_N = mkN "savtid" "savtider" ; -- savtid..nn.1
  sax_1_N = mkN "sax" ; -- sax..nn.1
  saxa_1_V = mkV "saxar" ; -- saxa..vb.1
  saxande_1_N = mkN "saxande" ; -- saxande..nn.1
  saxare_1_N = mkN "saxare" utrum  ; -- saxare..nn.1
  saxarm_1_N = mkN "saxarm" ; -- saxarm..nn.1
  saxblad_1_N = mkN "saxblad" neutrum  ; -- saxblad..nn.1
  saxdomkraft_1_N = mkN "saxdomkraft" "saxdomkrafter" ; -- saxdomkraft..nn.1
  saxformig_1_A = mkA "saxformig" ; -- saxformig..av.1
  saxformighet_1_N = mkN "saxformighet" ; -- saxformighet..nn.1
  saxisk_1_A = mkA "saxisk" ; -- saxisk..av.1
  saxkrok_1_N = mkN "saxkrok" ; -- saxkrok..nn.1
  saxliknande_1_A = mkA "saxliknande" ; -- saxliknande..av.1
  saxning_1_N = mkN "saxning" ; -- saxning..nn.1
  saxnäbb_1_N = mkN "saxnäbb" ; -- saxnäbb..nn.1
  saxofon_1_N = mkN "saxofon" "saxofoner" ; -- saxofon..nn.1
  saxofonist_1_N = mkN "saxofonist" "saxofonister" ; -- saxofonist..nn.1
  saxredskap_1_N = mkN "saxredskap" neutrum  ; -- saxredskap..nn.1
  saxskalm_1_N = mkN "saxskalm" ; -- saxskalm..nn.1
  saxskänkel_1_N = mkN "saxskänkel" ; -- saxskänkel..nn.1
  saxskär_1_N = mkN "saxskär" neutrum  ; -- saxskär..nn.1
  saxsprint_1_N = mkN "saxsprint" ; -- saxsprint..nn.1
  saxstil_1_N = mkN "saxstil" ; -- saxstil..nn.1
  sbirr_1_N = mkN "sbirr" "sbirrer" ; -- sbirr..nn.1
  scanna_1_V = mkV "scannar" ; -- scanna..vb.1
  scannande_1_N = mkN "scannande" ; -- scannande..nn.1
  scanner_1_N = mkN "scanner" ; -- scanner..nn.1
  scanning_1_N = mkN "scanning" ; -- scanning..nn.1
  scarf_1_N = mkN "scarf" ; -- scarf..nn.1
  scarlatina_1_N = mkN "scarlatina" ; -- scarlatina..nn.1
  scatsång_1_N = mkN "scatsång" ; -- scatsång..nn.1
  scen_1_N = mkN "scen" "scener" ; -- scen..nn.1
  scenanvisning_1_N = mkN "scenanvisning" ; -- scenanvisning..nn.1
  scenarbetare_1_N = mkN "scenarbetare" utrum  ; -- scenarbetare..nn.1
  scenario_1_N = mkN "scenario" "scenariot" "scenarier" "scenarierna" ; -- scenario..nn.1
  scenbearbetning_1_N = mkN "scenbearbetning" ; -- scenbearbetning..nn.1
  scenbild_1_N = mkN "scenbild" "scenbilder" ; -- scenbild..nn.1
  scenbyte_1_N = mkN "scenbyte" ; -- scenbyte..nn.1
  scendebutera_1_V = mkV "scendebuterar" ; -- scendebutera..vb.1
  scendebuterande_1_N = mkN "scendebuterande" ; -- scendebuterande..nn.1
  scendebutering_1_N = mkN "scendebutering" ; -- scendebutering..nn.1
  sceneri_1_N = mkN "sceneri" "sceneriet" "scenerier" "scenerierna" ; -- sceneri..nn.1
  scenframträdande_1_N = mkN "scenframträdande" ; -- scenframträdande..nn.1
  scenförändring_1_N = mkN "scenförändring" ; -- scenförändring..nn.1
  sceningång_1_N = mkN "sceningång" ; -- sceningång..nn.1
  sceninstruktör_1_N = mkN "sceninstruktör" "sceninstruktörer" ; -- sceninstruktör..nn.1
  scenisk_1_A = mkA "scenisk" ; -- scenisk..av.1
  scenkonst_1_N = mkN "scenkonst" ; -- scenkonst..nn.1
  scenkonstarbetare_1_N = mkN "scenkonstarbetare" utrum  ; -- scenkonstarbetare..nn.1
  scenograf_1_N = mkN "scenograf" "scenografer" ; -- scenograf..nn.1
  scenografi_1_N = mkN "scenografi" ; -- scenografi..nn.1
  scenografisk_1_A = mkA "scenografisk" ; -- scenografisk..av.1
  scenshow_1_N = mkN "scenshow" "scenshower" ; -- scenshow..nn.1
  scenskola_1_N = mkN "scenskola" ; -- scenskola..nn.1
  scenskräck_1_N = mkN "scenskräck" ; -- scenskräck..nn.1
  scenuppförande_1_N = mkN "scenuppförande" ; -- scenuppförande..nn.1
  scenuppsättning_1_N = mkN "scenuppsättning" ; -- scenuppsättning..nn.1
  scenuttal_1_N = mkN "scenuttal" neutrum  ; -- scenuttal..nn.1
  scenvana_1_N = mkN "scenvana" ; -- scenvana..nn.1
  scenvind_1_N = mkN "scenvind" ; -- scenvind..nn.1
  scenväxling_1_N = mkN "scenväxling" ; -- scenväxling..nn.1
  scenöppning_1_N = mkN "scenöppning" ; -- scenöppning..nn.1
  scepter_1_N = mkN "scepter" neutrum  ; -- scepter..nn.1
  schabbel_1_N = mkN "schabbel" neutrum  ; -- schabbel..nn.1
  schabbelverk_1_N = mkN "schabbelverk" neutrum  ; -- schabbelverk..nn.1
  schabbla_1_V = mkV "schabblar" ; -- schabbla..vb.1
  schabblande_1_N = mkN "schabblande" ; -- schabblande..nn.1
  schablon_1_N = mkN "schablon" "schabloner" ; -- schablon..nn.1
  schablonavdrag_1_N = mkN "schablonavdrag" neutrum  ; -- schablonavdrag..nn.1
  schablonbelopp_1_N = mkN "schablonbelopp" neutrum  ; -- schablonbelopp..nn.1
  schablonbild_1_N = mkN "schablonbild" "schablonbilder" ; -- schablonbild..nn.1
  schablonera_1_V = mkV "schablonerar" ; -- schablonera..vb.1
  schablonerande_1_N = mkN "schablonerande" ; -- schablonerande..nn.1
  schablonerbar_1_A = mkA "schablonerbar" ; -- schablonerbar..av.1
  schablonerbarhet_1_N = mkN "schablonerbarhet" ; -- schablonerbarhet..nn.1
  schablonering_1_N = mkN "schablonering" ; -- schablonering..nn.1
  schablonisera_1_V = mkV "schabloniserar" ; -- schablonisera..vb.1
  schabloniserande_1_N = mkN "schabloniserande" ; -- schabloniserande..nn.1
  schabloniserbar_1_A = mkA "schabloniserbar" ; -- schabloniserbar..av.1
  schabloniserbarhet_1_N = mkN "schabloniserbarhet" ; -- schabloniserbarhet..nn.1
  schablonisering_1_N = mkN "schablonisering" ; -- schablonisering..nn.1
  schablonmässig_1_A = mkA "schablonmässig" ; -- schablonmässig..av.1
  schablonmässighet_1_N = mkN "schablonmässighet" ; -- schablonmässighet..nn.1
  schablontaxera_1_V = mkV "schablontaxerar" ; -- schablontaxera..vb.1
  schablontaxerande_1_N = mkN "schablontaxerande" ; -- schablontaxerande..nn.1
  schablontaxerbar_1_A = mkA "schablontaxerbar" ; -- schablontaxerbar..av.1
  schablontaxerbarhet_1_N = mkN "schablontaxerbarhet" ; -- schablontaxerbarhet..nn.1
  schablontaxering_1_N = mkN "schablontaxering" ; -- schablontaxering..nn.1
  schablontillägg_1_N = mkN "schablontillägg" neutrum  ; -- schablontillägg..nn.1
  schabrak_1_N = mkN "schabrak" neutrum  ; -- schabrak..nn.1
  schack_1_A = mkA "schack" ; -- schack..av.1
  schack_1_N = mkN "schack" neutrum  ; -- schack..nn.1
  schacka_1_V = mkV "schackar" ; -- schacka..vb.1
  schackande_1_N = mkN "schackande" ; -- schackande..nn.1
  schackbord_1_N = mkN "schackbord" neutrum  ; -- schackbord..nn.1
  schackbräda_1_N = mkN "schackbräda" ; -- schackbräda..nn.1
  schackbräde_1_N = mkN "schackbräde" ; -- schackbräde..nn.1
  schackdrag_1_N = mkN "schackdrag" neutrum  ; -- schackdrag..nn.1
  schackel_1_N = mkN "schackel" ; -- schackel..nn.1
  schacker_1_N = mkN "schacker" neutrum  ; -- schacker..nn.1
  schackla_1_V = mkV "schacklar" ; -- schackla..vb.1
  schacklande_1_N = mkN "schacklande" ; -- schacklande..nn.1
  schackmatt_1_A = mkA "schackmatt" ; -- schackmatt..av.1
  schackmönster_1_N = mkN "schackmönster" neutrum  ; -- schackmönster..nn.1
  schackningsperiod_1_N = mkN "schackningsperiod" "schackningsperioder" ; -- schackningsperiod..nn.1
  schackparti_1_N = mkN "schackparti" "schackpartiet" "schackpartier" "schackpartierna" ; -- schackparti..nn.1
  schackpjäs_1_N = mkN "schackpjäs" "schackpjäser" ; -- schackpjäs..nn.1
  schackproblem_1_N = mkN "schackproblem" neutrum  ; -- schackproblem..nn.1
  schackra_1_V = mkV "schackrar" ; -- schackra..vb.1
  schackrande_1_N = mkN "schackrande" ; -- schackrande..nn.1
  schackrare_1_N = mkN "schackrare" utrum  ; -- schackrare..nn.1
  schackspel_1_N = mkN "schackspel" "schackspelet" "schackspel" "schackspelen" ; -- schackspel..nn.1
  schackspelare_1_N = mkN "schackspelare" utrum  ; -- schackspelare..nn.1
  schackturnering_1_N = mkN "schackturnering" ; -- schackturnering..nn.1
  schagg_1_N = mkN "schagg" "schagger" ; -- schagg..nn.1
  schah_1_N = mkN "schah" "schaher" ; -- schah..nn.1
  schajas_1_N = mkN "schajas" ; -- schajas..nn.1
  schakal_1_N = mkN "schakal" "schakaler" ; -- schakal..nn.1
  schakt_1_N = mkN "schakt" neutrum  ; -- schakt..nn.1
  schakta_1_V = mkV "schaktar" ; -- schakta..vb.1
  schaktande_1_N = mkN "schaktande" ; -- schaktande..nn.1
  schaktkant_1_N = mkN "schaktkant" "schaktkanter" ; -- schaktkant..nn.1
  schaktmaskin_1_N = mkN "schaktmaskin" "schaktmaskiner" ; -- schaktmaskin..nn.1
  schaktmassa_1_N = mkN "schaktmassa" ; -- schaktmassa..nn.1
  schaktugn_1_N = mkN "schaktugn" ; -- schaktugn..nn.1
  schakå_1_N = mkN "schakå" "schakåer" ; -- schakå..nn.1
  schal_1_N = mkN "schal" ; -- schal..nn.1
  schalett_1_N = mkN "schalett" "schaletter" ; -- schalett..nn.1
  schalottenlök_1_N = mkN "schalottenlök" ; -- schalottenlök..nn.1
  schaman_1_N = mkN "schaman" "schamaner" ; -- schaman..nn.1
  schamanism_1_N = mkN "schamanism" "schamanismer" ; -- schamanism..nn.1
  schamanistisk_1_A = mkA "schamanistisk" ; -- schamanistisk..av.1
  schampo_1_N = mkN "schampo" "schampot" "schampon" "schampona" ; -- schampo..nn.1
  schamponera_1_V = mkV "schamponerar" ; -- schamponera..vb.1
  schamponerande_1_N = mkN "schamponerande" ; -- schamponerande..nn.1
  schamponerbar_1_A = mkA "schamponerbar" ; -- schamponerbar..av.1
  schamponerbarhet_1_N = mkN "schamponerbarhet" ; -- schamponerbarhet..nn.1
  schamponering_1_N = mkN "schamponering" ; -- schamponering..nn.1
  schampopatron_1_N = mkN "schampopatron" "schampopatroner" ; -- schampopatron..nn.1
  schangdobel_1_A = mkA "schangdobel" "schangdobelt" ; -- schangdobel..av.1
  schanghaja_1_V = mkV "schanghajar" ; -- schanghaja..vb.1
  schanghajande_1_N = mkN "schanghajande" ; -- schanghajande..nn.1
  schanghajning_1_N = mkN "schanghajning" ; -- schanghajning..nn.1
  schangtil_1_A = mkA "schangtil" ; -- schangtil..av.1
  schanker_1_N = mkN "schanker" ; -- schanker..nn.1
  schapp_1_N = mkN "schapp" neutrum  ; -- schapp..nn.1
  schappa_1_V = mkV "schappar" ; -- schappa..vb.1
  schappande_1_N = mkN "schappande" ; -- schappande..nn.1
  scharlakan_1_N = mkN "scharlakan" neutrum  ; -- scharlakan..nn.1
  scharlakansfeber_1_N = mkN "scharlakansfeber" ; -- scharlakansfeber..nn.1
  scharlakansröd_1_A = mkA "scharlakansröd" "scharlakansrött" ; -- scharlakansröd..av.1
  scharlakansrött_1_N = mkN "scharlakansrött" ; -- scharlakansrött..nn.1
  scharner_1_N = mkN "scharner" "scharneret" "scharner" "scharneren" ; -- scharner..nn.1
  schartauan_1_N = mkN "schartauan" "schartauaner" ; -- schartauan..nn.1
  schartauanism_1_N = mkN "schartauanism" "schartauanismer" ; -- schartauanism..nn.1
  schartauansk_1_A = mkA "schartauansk" ; -- schartauansk..av.1
  schasa_1_V = mkV "schasar" ; -- schasa..vb.1
  schasande_1_N = mkN "schasande" ; -- schasande..nn.1
  schasning_1_N = mkN "schasning" ; -- schasning..nn.1
  schattera_1_V = mkV "schatterar" ; -- schattera..vb.1
  schatterande_1_N = mkN "schatterande" ; -- schatterande..nn.1
  schatterbar_1_A = mkA "schatterbar" ; -- schatterbar..av.1
  schatterbarhet_1_N = mkN "schatterbarhet" ; -- schatterbarhet..nn.1
  schattering_1_N = mkN "schattering" ; -- schattering..nn.1
  schattersöm_1_N = mkN "schattersöm" "schattersömmen" "schattersömmar" "schattersömmarna" ; -- schattersöm..nn.1
  schatull_1_N = mkN "schatull" neutrum  ; -- schatull..nn.1
  schau_1_N = mkN "schau" ; -- schau..nn.1
  schavott_1_N = mkN "schavott" "schavotter" ; -- schavott..nn.1
  schavottera_1_V = mkV "schavotterar" ; -- schavottera..vb.1
  schavotterande_1_N = mkN "schavotterande" ; -- schavotterande..nn.1
  schavottering_1_N = mkN "schavottering" ; -- schavottering..nn.1
  schejk_1_N = mkN "schejk" "schejker" ; -- schejk..nn.1
  schellack_1_N = mkN "schellack" ; -- schellack..nn.1
  schema_1_N = mkN "schema" "schemat" "scheman" "schemana" ; -- schema..nn.1
  schemabunden_1_A = mkA "schemabunden" ; -- schemabunden..av.1
  schemalagd_1_A = mkA "schemalagd" "schemalagt" ; -- schemalagd..av.1
  schemalägga_1_V = mkV "schemalägga" "schemala" "schemalagt" ; -- schemalägga..vb.1
  schemaläggande_1_N = mkN "schemaläggande" ; -- schemaläggande..nn.1
  schemaläggning_1_N = mkN "schemaläggning" ; -- schemaläggning..nn.1
  schemamässig_1_A = mkA "schemamässig" ; -- schemamässig..av.1
  schematisera_1_V = mkV "schematiserar" ; -- schematisera..vb.1
  schematiserande_1_N = mkN "schematiserande" ; -- schematiserande..nn.1
  schematiserbar_1_A = mkA "schematiserbar" ; -- schematiserbar..av.1
  schematiserbarhet_1_N = mkN "schematiserbarhet" ; -- schematiserbarhet..nn.1
  schematisering_1_N = mkN "schematisering" ; -- schematisering..nn.1
  schematisk_1_A = mkA "schematisk" ; -- schematisk..av.1
  schematism_1_N = mkN "schematism" "schematismer" ; -- schematism..nn.1
  schersmin_1_N = mkN "schersmin" "schersminer" ; -- schersmin..nn.1
  scherzo_1_N = mkN "scherzo" "scherzot" "scherzon" "scherzona" ; -- scherzo..nn.1
  schibbolet_1_N = mkN "schibbolet" neutrum  ; -- schibbolet..nn.1
  schillerkrage_1_N = mkN "schillerkrage" utrum  ; -- schillerkrage..nn.1
  schillerstövare_1_N = mkN "schillerstövare" utrum  ; -- schillerstövare..nn.1
  schilling_1_N = mkN "schilling" ; -- schilling..nn.1
  schimpans_1_N = mkN "schimpans" "schimpanser" ; -- schimpans..nn.1
  schism_1_N = mkN "schism" "schismer" ; -- schism..nn.1
  schismatiker_1_N = mkN "schismatiker" "schismatikern" "schismatiker" "schismatikerna" ; -- schismatiker..nn.1
  schismatisk_1_A = mkA "schismatisk" ; -- schismatisk..av.1
  schizofren_1_A = mkA "schizofren" "schizofrent" ; -- schizofren..av.1
  schizofreni_1_N = mkN "schizofreni" "schizofrenier" ; -- schizofreni..nn.1
  schizoid_1_A = mkA "schizoid" ; -- schizoid..av.1
  schizotym_1_A = mkA "schizotym" ; -- schizotym..av.1
  schizotymi_1_N = mkN "schizotymi" ; -- schizotymi..nn.1
  schizzig_1_A = mkA "schizzig" ; -- schizzig..av.1
  schizzighet_1_N = mkN "schizzighet" ; -- schizzighet..nn.1
  schlager_1_N = mkN "schlager" ; -- schlager..nn.1
  schlagerbidrag_1_N = mkN "schlagerbidrag" neutrum  ; -- schlagerbidrag..nn.1
  schlagerbråk_1_N = mkN "schlagerbråk" neutrum  ; -- schlagerbråk..nn.1
  schlagermusik_1_N = mkN "schlagermusik" ; -- schlagermusik..nn.1
  schlagertext_1_N = mkN "schlagertext" "schlagertexter" ; -- schlagertext..nn.1
  schlaraffenland_1_N = mkN "schlaraffenland" ; -- schlaraffenland..nn.1
  schnauzer_1_N = mkN "schnauzer" ; -- schnauzer..nn.1
  schnellklops_1_N = mkN "schnellklops" ; -- schnellklops..nn.1
  schnitzel_1_N = mkN "schnitzel" ; -- schnitzel..nn.1
  schottis_1_N = mkN "schottis" ; -- schottis..nn.1
  schrammelkvartett_1_N = mkN "schrammelkvartett" "schrammelkvartetter" ; -- schrammelkvartett..nn.1
  schrammelmusik_1_N = mkN "schrammelmusik" ; -- schrammelmusik..nn.1
  schumring_1_N = mkN "schumring" ; -- schumring..nn.1
  schvaback_1_N = mkN "schvaback" ; -- schvaback..nn.1
  schveifa_1_V = mkV "schveifar" ; -- schveifa..vb.1
  schveifande_1_N = mkN "schveifande" ; -- schveifande..nn.1
  schvung_1_N = mkN "schvung" ; -- schvung..nn.1
  schvungfull_1_A = mkA "schvungfull" ; -- schvungfull..av.1
  schvungfullhet_1_N = mkN "schvungfullhet" ; -- schvungfullhet..nn.1
  schvungig_1_A = mkA "schvungig" ; -- schvungig..av.1
  schvungighet_1_N = mkN "schvungighet" ; -- schvungighet..nn.1
  schwa_ljud_1_N = mkN "schwa-ljud" neutrum  ; -- schwa-ljud..nn.1
  schwabach_1_N = mkN "schwabach" ; -- schwabach..nn.1
  schwarzwaldtårta_1_N = mkN "schwarzwaldtårta" ; -- schwarzwaldtårta..nn.1
  schweizare_1_N = mkN "schweizare" utrum  ; -- schweizare..nn.1
  schweizerfranc_1_N = mkN "schweizerfranc" "schweizerfrancen" "schweizerfrancs" "schweizerfrancsen" ; -- schweizerfranc..nn.1
  schweizeri_1_N = mkN "schweizeri" "schweizeriet" "schweizerier" "schweizerierna" ; -- schweizeri..nn.1
  schweizernöt_1_N = mkN "schweizernöt" "schweizernötter" ; -- schweizernöt..nn.1
  schweizerost_1_N = mkN "schweizerost" ; -- schweizerost..nn.1
  schweizisk_1_A = mkA "schweizisk" ; -- schweizisk..av.1
  schweiziska_1_N = mkN "schweiziska" ; -- schweiziska..nn.1
  schwung_1_N = mkN "schwung" ; -- schwung..nn.1
  schwungfull_1_A = mkA "schwungfull" ; -- schwungfull..av.1
  schwungfullhet_1_N = mkN "schwungfullhet" ; -- schwungfullhet..nn.1
  schwungig_1_A = mkA "schwungig" ; -- schwungig..av.1
  schwungighet_1_N = mkN "schwungighet" ; -- schwungighet..nn.1
  schwyzerdütsch_1_N = mkN "schwyzerdütsch" ; -- schwyzerdütsch..nn.1
  schwyzertütsch_1_N = mkN "schwyzertütsch" ; -- schwyzertütsch..nn.1
  schysst_1_A = mkA "schysst" "schysst" ; -- schysst..av.1
  schyssthet_1_N = mkN "schyssthet" ; -- schyssthet..nn.1
  schyst_1_A = mkA "schyst" "schyst" ; -- schyst..av.1
  schysthet_1_N = mkN "schysthet" ; -- schysthet..nn.1
  schäfer_1_N = mkN "schäfer" ; -- schäfer..nn.1
  schäferhatt_1_N = mkN "schäferhatt" ; -- schäferhatt..nn.1
  schäferhund_1_N = mkN "schäferhund" ; -- schäferhund..nn.1
  schäferi_1_N = mkN "schäferi" "schäferiet" "schäferier" "schäferierna" ; -- schäferi..nn.1
  schäfervalp_1_N = mkN "schäfervalp" ; -- schäfervalp..nn.1
  schäs_1_N = mkN "schäs" ; -- schäs..nn.1
  schäslong_1_N = mkN "schäslong" "schäslonger" ; -- schäslong..nn.1
  schå_1_N = mkN "schå" neutrum  ; -- schå..nn.1
  sci_fi_rulle_1_N = mkN "sci-fi-rulle" utrum  ; -- sci-fi-rulle..nn.1
  science_fictionroman_1_N = mkN "science-fictionroman" "science-fictionromaner" ; -- science-fictionroman..nn.1
  sciencefictionlitteratur_1_N = mkN "sciencefictionlitteratur" ; -- sciencefictionlitteratur..nn.1
  scientist_1_N = mkN "scientist" "scientister" ; -- scientist..nn.1
  scientolog_1_N = mkN "scientolog" "scientologer" ; -- scientolog..nn.1
  scientologi_1_N = mkN "scientologi" ; -- scientologi..nn.1
  scifi_rulle_1_N = mkN "scifi-rulle" utrum  ; -- scifi-rulle..nn.1
  scifirulle_1_N = mkN "scifirulle" utrum  ; -- scifirulle..nn.1
  scilla_1_N = mkN "scilla" ; -- scilla..nn.1
  scintigrafi_1_N = mkN "scintigrafi" ; -- scintigrafi..nn.1
  scintillation_1_N = mkN "scintillation" ; -- scintillation..nn.1
  scirocco_1_N = mkN "scirocco" "sciroccor" ; -- scirocco..nn.1
  scone_1_N = mkN "scone" "sconer" ; -- scone..nn.1
  scoop_1_N = mkN "scoop" neutrum  ; -- scoop..nn.1
  scooter_1_N = mkN "scooter" ; -- scooter..nn.1
  scopolamin_1_N = mkN "scopolamin" "scopolaminer" ; -- scopolamin..nn.1
  scout_1_N = mkN "scout" "scouter" ; -- scout..nn.1
  scouthälsning_1_N = mkN "scouthälsning" ; -- scouthälsning..nn.1
  scouting_1_N = mkN "scouting" ; -- scouting..nn.1
  scoutjamboree_1_N = mkN "scoutjamboree" "scoutjamboreer" ; -- scoutjamboree..nn.1
  scoutkår_1_N = mkN "scoutkår" "scoutkårer" ; -- scoutkår..nn.1
  scoutlag_1_N = mkN "scoutlag" ; -- scoutlag..nn.1
  scoutläger_1_N = mkN "scoutläger" neutrum  ; -- scoutläger..nn.1
  scoutlöfte_1_N = mkN "scoutlöfte" ; -- scoutlöfte..nn.1
  scoutmässig_1_A = mkA "scoutmässig" ; -- scoutmässig..av.1
  scoutpatrull_1_N = mkN "scoutpatrull" "scoutpatruller" ; -- scoutpatrull..nn.1
  scoutrörelse_1_N = mkN "scoutrörelse" utrum  ; -- scoutrörelse..nn.1
  scoututmärkelse_1_N = mkN "scoututmärkelse" "scoututmärkelser" ; -- scoututmärkelse..nn.1
  scratch_1_N = mkN "scratch" ; -- scratch..nn.1
  scratchman_1_N = mkN "scratchman" "scratchmannen" "scratchmän" "scratchmännen" ; -- scratchman..nn.1
  screentryck_1_N = mkN "screentryck" neutrum  ; -- screentryck..nn.1
  script_girl_1_N = mkN "script-girl" "script-girlen" "script-girls" "script-girlsarna" ; -- script-girl..nn.1
  scripta_1_N = mkN "scripta" ; -- scripta..nn.1
  scrolla_1_V = mkV "scrollar" ; -- scrolla..vb.1
  scrollande_1_N = mkN "scrollande" ; -- scrollande..nn.1
  scrollning_1_N = mkN "scrollning" ; -- scrollning..nn.1
  scrotum_1_N = mkN "scrotum" ; -- scrotum..nn.1
  se_1_V = mkV "se" "såg" "sett" ; -- se..vb.1
  seans_1_N = mkN "seans" "seanser" ; -- seans..nn.1
  sebar_1_A = mkA "sebar" ; -- sebar..av.1
  sebarhet_1_N = mkN "sebarhet" ; -- sebarhet..nn.1
  seborré_1_N = mkN "seborré" "seborréer" ; -- seborré..nn.1
  sebra_1_N = mkN "sebra" ; -- sebra..nn.1
  sebu_1_N = mkN "sebu" "sebun" "sebuer" "sebuerna" ; -- sebu..nn.1
  sec_1_N = mkN "sec" ; -- sec..nn.1
  seccomålning_1_N = mkN "seccomålning" ; -- seccomålning..nn.1
  sed_1_N = mkN "sed" "seder" ; -- sed..nn.1
  sedan_1_Adv = mkAdv "sedan" ; -- sedan..ab.1
  sedan_1_N = mkN "sedan" "sedaner" ; -- sedan..nn.1
  sedativ_1_A = mkA "sedativ" ; -- sedativ..av.1
  sedativum_1_N = mkN "sedativum" "sedativum" "sedativer" "sedativerna" ; -- sedativum..nn.1
  sedebetyg_1_N = mkN "sedebetyg" neutrum  ; -- sedebetyg..nn.1
  sedefördärv_1_N = mkN "sedefördärv" neutrum  ; -- sedefördärv..nn.1
  sedeförfall_1_N = mkN "sedeförfall" neutrum  ; -- sedeförfall..nn.1
  sedekomedi_1_N = mkN "sedekomedi" "sedekomedier" ; -- sedekomedi..nn.1
  sedel_1_N = mkN "sedel" ; -- sedel..nn.1
  sedelautomat_1_N = mkN "sedelautomat" "sedelautomater" ; -- sedelautomat..nn.1
  sedelbränning_1_N = mkN "sedelbränning" ; -- sedelbränning..nn.1
  sedelpress_1_N = mkN "sedelpress" ; -- sedelpress..nn.1
  sedelreserv_1_N = mkN "sedelreserv" "sedelreserver" ; -- sedelreserv..nn.1
  sedelstock_1_N = mkN "sedelstock" ; -- sedelstock..nn.1
  sedeltryck_1_N = mkN "sedeltryck" neutrum  ; -- sedeltryck..nn.1
  sedeltryckeri_1_N = mkN "sedeltryckeri" "sedeltryckeriet" "sedeltryckerier" "sedeltryckerierna" ; -- sedeltryckeri..nn.1
  sedeltryckning_1_N = mkN "sedeltryckning" ; -- sedeltryckning..nn.1
  sedeltäckning_1_N = mkN "sedeltäckning" ; -- sedeltäckning..nn.1
  sedelutgivande_1_A = mkA "sedelutgivande" ; -- sedelutgivande..av.1
  sedelutgivning_1_N = mkN "sedelutgivning" ; -- sedelutgivning..nn.1
  sedelära_1_N = mkN "sedelära" ; -- sedelära..nn.1
  sedelärande_1_A = mkA "sedelärande" ; -- sedelärande..av.1
  sedermera_1_Adv = mkAdv "sedermera" ; -- sedermera..ab.1
  sederoman_1_N = mkN "sederoman" "sederomaner" ; -- sederoman..nn.1
  sedes_1_N = mkN "sedes" "sedeser" ; -- sedes..nn.1
  sedesam_1_A = mkA "sedesam" "sedesamt" "sedesamma" "sedesamma" "sedesammare" "sedesammast" "sedesammaste" ; -- sedesam..av.1
  sedesamhet_1_N = mkN "sedesamhet" ; -- sedesamhet..nn.1
  sedesfördärv_1_N = mkN "sedesfördärv" neutrum  ; -- sedesfördärv..nn.1
  sedeskildring_1_N = mkN "sedeskildring" ; -- sedeskildring..nn.1
  sedeslös_1_A = mkA "sedeslös" ; -- sedeslös..av.1
  sedeslöshet_1_N = mkN "sedeslöshet" ; -- sedeslöshet..nn.1
  sedig_1_A = mkA "sedig" ; -- sedig..av.1
  sedighet_1_N = mkN "sedighet" ; -- sedighet..nn.1
  sediment_1_N = mkN "sediment" neutrum  ; -- sediment..nn.1
  sedimentera_1_V = mkV "sedimenterar" ; -- sedimentera..vb.1
  sedimenterande_1_N = mkN "sedimenterande" ; -- sedimenterande..nn.1
  sedimenterbar_1_A = mkA "sedimenterbar" ; -- sedimenterbar..av.1
  sedimenterbarhet_1_N = mkN "sedimenterbarhet" ; -- sedimenterbarhet..nn.1
  sedimentering_1_N = mkN "sedimentering" ; -- sedimentering..nn.1
  sedimentförande_1_A = mkA "sedimentförande" ; -- sedimentförande..av.1
  sedimentkärna_1_N = mkN "sedimentkärna" ; -- sedimentkärna..nn.1
  sedimentlager_1_N = mkN "sedimentlager" neutrum  ; -- sedimentlager..nn.1
  sedimentprov_1_N = mkN "sedimentprov" neutrum  ; -- sedimentprov..nn.1
  sedimentär_1_A = mkA "sedimentär" ; -- sedimentär..av.1
  sedlig_1_A = mkA "sedlig" ; -- sedlig..av.1
  sedlighet_1_N = mkN "sedlighet" "sedligheter" ; -- sedlighet..nn.1
  sedlighetsapostel_1_N = mkN "sedlighetsapostel" ; -- sedlighetsapostel..nn.1
  sedlighetsbrott_1_N = mkN "sedlighetsbrott" neutrum  ; -- sedlighetsbrott..nn.1
  sedlighetsiver_1_N = mkN "sedlighetsiver" ; -- sedlighetsiver..nn.1
  sedlighetsivrare_1_N = mkN "sedlighetsivrare" utrum  ; -- sedlighetsivrare..nn.1
  sedlighetsrotel_1_N = mkN "sedlighetsrotel" ; -- sedlighetsrotel..nn.1
  sedlighetssårande_1_A = mkA "sedlighetssårande" ; -- sedlighetssårande..av.1
  sedum_1_N = mkN "sedum" ; -- sedum..nn.1
  sedvana_1_N = mkN "sedvana" ; -- sedvana..nn.1
  sedvanerätt_1_N = mkN "sedvanerätt" ; -- sedvanerätt..nn.1
  sedvanlig_1_A = mkA "sedvanlig" ; -- sedvanlig..av.1
  sedvanlighet_1_N = mkN "sedvanlighet" ; -- sedvanlighet..nn.1
  sedvänja_1_N = mkN "sedvänja" ; -- sedvänja..nn.1
  seeda_1_V = mkV "seedar" ; -- seeda..vb.1
  seedande_1_N = mkN "seedande" ; -- seedande..nn.1
  seende_1_A = mkA "seende" ; -- seende..av.1
  seende_1_N = mkN "seende" ; -- seende..nn.1
  sefard_1_N = mkN "sefard" "sefarder" ; -- sefard..nn.1
  sefardisk_1_A = mkA "sefardisk" ; -- sefardisk..av.1
  sefir_1_N = mkN "sefir" ; -- sefir..nn.1
  sefirgarn_1_N = mkN "sefirgarn" neutrum  ; -- sefirgarn..nn.1
  sefyr_1_N = mkN "sefyr" "sefyrer" ; -- sefyr..nn.1
  seg_1_A = mkA "seg" ; -- seg..av.1
  sega_1_V = mkV "segar" ; -- sega..vb.1
  segande_1_N = mkN "segande" ; -- segande..nn.1
  segdra_1_V = mkV "segdraga" "segdrog" "segdragit" ; -- segdra..vb.1
  segdragande_1_N = mkN "segdragande" ; -- segdragande..nn.1
  segdragen_1_A = mkA "segdragen" ; -- segdragen..av.1
  segel_1_N = mkN "segel" neutrum  ; -- segel..nn.1
  segelarea_1_N = mkN "segelarea" ; -- segelarea..nn.1
  segelbar_1_A = mkA "segelbar" ; -- segelbar..av.1
  segelbarhet_1_N = mkN "segelbarhet" ; -- segelbarhet..nn.1
  segelbärgning_1_N = mkN "segelbärgning" ; -- segelbärgning..nn.1
  segelbåt_1_N = mkN "segelbåt" ; -- segelbåt..nn.1
  segelduk_1_N = mkN "segelduk" ; -- segelduk..nn.1
  segelduksklädd_1_A = mkA "segelduksklädd" ; -- segelduksklädd..av.1
  segelfart_1_N = mkN "segelfart" ; -- segelfart..nn.1
  segelfartyg_1_N = mkN "segelfartyg" neutrum  ; -- segelfartyg..nn.1
  segelflyg_1_N = mkN "segelflyg" neutrum  ; -- segelflyg..nn.1
  segelflyga_1_V = mkV "segelflyga" "segelflög" "segelflugit" ; -- segelflyga..vb.1
  segelflygande_1_N = mkN "segelflygande" ; -- segelflygande..nn.1
  segelflygare_1_N = mkN "segelflygare" utrum  ; -- segelflygare..nn.1
  segelflygklubb_1_N = mkN "segelflygklubb" ; -- segelflygklubb..nn.1
  segelflygning_1_N = mkN "segelflygning" ; -- segelflygning..nn.1
  segelflygplan_1_N = mkN "segelflygplan" neutrum  ; -- segelflygplan..nn.1
  segelflykt_1_N = mkN "segelflykt" ; -- segelflykt..nn.1
  segelfri_1_A = mkA "segelfri" "segelfritt" ; -- segelfri..av.1
  segelföring_1_N = mkN "segelföring" ; -- segelföring..nn.1
  segelgarn_1_N = mkN "segelgarn" neutrum  ; -- segelgarn..nn.1
  segeljakt_1_N = mkN "segeljakt" "segeljakter" ; -- segeljakt..nn.1
  segeljolle_1_N = mkN "segeljolle" utrum  ; -- segeljolle..nn.1
  segelkanot_1_N = mkN "segelkanot" "segelkanoter" ; -- segelkanot..nn.1
  segelkapell_1_N = mkN "segelkapell" neutrum  ; -- segelkapell..nn.1
  segelled_1_N = mkN "segelled" "segelleder" ; -- segelled..nn.1
  segelmakare_1_N = mkN "segelmakare" utrum  ; -- segelmakare..nn.1
  segelmakeri_1_N = mkN "segelmakeri" "segelmakeriet" "segelmakerier" "segelmakerierna" ; -- segelmakeri..nn.1
  segelmärke_1_N = mkN "segelmärke" ; -- segelmärke..nn.1
  segelränna_1_N = mkN "segelränna" ; -- segelränna..nn.1
  segelskridsko_1_N = mkN "segelskridsko" "segelskridskor" ; -- segelskridsko..nn.1
  segelskuta_1_N = mkN "segelskuta" ; -- segelskuta..nn.1
  segelsport_1_N = mkN "segelsport" ; -- segelsport..nn.1
  segelställ_1_N = mkN "segelställ" neutrum  ; -- segelställ..nn.1
  segelsällskap_1_N = mkN "segelsällskap" neutrum  ; -- segelsällskap..nn.1
  segelsömmare_1_N = mkN "segelsömmare" utrum  ; -- segelsömmare..nn.1
  segelsömnad_1_N = mkN "segelsömnad" ; -- segelsömnad..nn.1
  segelsömnadslära_1_N = mkN "segelsömnadslära" ; -- segelsömnadslära..nn.1
  segeltur_1_N = mkN "segeltur" "segelturer" ; -- segeltur..nn.1
  segelyta_1_N = mkN "segelyta" ; -- segelyta..nn.1
  seger_1_N = mkN "seger" ; -- seger..nn.1
  segeraktuell_1_A = mkA "segeraktuell" ; -- segeraktuell..av.1
  segerbyte_1_N = mkN "segerbyte" ; -- segerbyte..nn.1
  segercigarr_1_N = mkN "segercigarr" "segercigarrer" ; -- segercigarr..nn.1
  segerdrucken_1_A = mkA "segerdrucken" ; -- segerdrucken..av.1
  segerfest_1_N = mkN "segerfest" "segerfester" ; -- segerfest..nn.1
  segerglad_1_A = mkA "segerglad" ; -- segerglad..av.1
  segergudinna_1_N = mkN "segergudinna" ; -- segergudinna..nn.1
  segerherre_1_N = mkN "segerherre" utrum  ; -- segerherre..nn.1
  segerhjälte_1_N = mkN "segerhjälte" utrum  ; -- segerhjälte..nn.1
  segerhuva_1_N = mkN "segerhuva" ; -- segerhuva..nn.1
  segerkrans_1_N = mkN "segerkrans" ; -- segerkrans..nn.1
  segerkrönt_1_A = mkA "segerkrönt" "segerkrönt" ; -- segerkrönt..av.1
  segerkyss_1_N = mkN "segerkyss" ; -- segerkyss..nn.1
  segerlös_1_A = mkA "segerlös" ; -- segerlös..av.1
  segermonument_1_N = mkN "segermonument" neutrum  ; -- segermonument..nn.1
  segermål_1_N = mkN "segermål" neutrum  ; -- segermål..nn.1
  segerrik_1_A = mkA "segerrik" ; -- segerrik..av.1
  segerrikhet_1_N = mkN "segerrikhet" ; -- segerrikhet..nn.1
  segerrus_1_N = mkN "segerrus" neutrum  ; -- segerrus..nn.1
  segerrusig_1_A = mkA "segerrusig" ; -- segerrusig..av.1
  segerrusighet_1_N = mkN "segerrusighet" ; -- segerrusighet..nn.1
  segersmajl_1_N = mkN "segersmajl" neutrum  ; -- segersmajl..nn.1
  segerstämning_1_N = mkN "segerstämning" ; -- segerstämning..nn.1
  segersäll_1_A = mkA "segersäll" ; -- segersäll..av.1
  segersällhet_1_N = mkN "segersällhet" ; -- segersällhet..nn.1
  segertaktik_1_N = mkN "segertaktik" "segertaktiker" ; -- segertaktik..nn.1
  segertecken_1_N = mkN "segertecken" "segertecknet" "segertecken" "segertecknen" ; -- segertecken..nn.1
  segertorka_1_N = mkN "segertorka" ; -- segertorka..nn.1
  segertåg_1_N = mkN "segertåg" neutrum  ; -- segertåg..nn.1
  segervinnare_1_N = mkN "segervinnare" utrum  ; -- segervinnare..nn.1
  segerviss_1_A = mkA "segerviss" ; -- segerviss..av.1
  segervisshet_1_N = mkN "segervisshet" ; -- segervisshet..nn.1
  segervittring_1_N = mkN "segervittring" ; -- segervittring..nn.1
  segeryra_1_N = mkN "segeryra" ; -- segeryra..nn.1
  seghet_1_N = mkN "seghet" "segheter" ; -- seghet..nn.1
  seghärda_1_V = mkV "seghärdar" ; -- seghärda..vb.1
  seghärdande_1_N = mkN "seghärdande" ; -- seghärdande..nn.1
  segla_1_V = mkV "seglar" ; -- segla..vb.1
  seglande_1_N = mkN "seglande" ; -- seglande..nn.1
  seglare_1_N = mkN "seglare" utrum  ; -- seglare..nn.1
  seglarmössa_1_N = mkN "seglarmössa" ; -- seglarmössa..nn.1
  seglarstövel_1_N = mkN "seglarstövel" ; -- seglarstövel..nn.1
  seglation_1_N = mkN "seglation" ; -- seglation..nn.1
  seglationsklar_1_A = mkA "seglationsklar" ; -- seglationsklar..av.1
  seglats_1_N = mkN "seglats" "seglatser" ; -- seglats..nn.1
  segling_1_N = mkN "segling" ; -- segling..nn.1
  seglingsbeskrivning_1_N = mkN "seglingsbeskrivning" ; -- seglingsbeskrivning..nn.1
  seglingsfri_1_A = mkA "seglingsfri" "seglingsfritt" ; -- seglingsfri..av.1
  seglivad_1_A = mkA "seglivad" ; -- seglivad..av.1
  segment_1_N = mkN "segment" neutrum  ; -- segment..nn.1
  segmentbåge_1_N = mkN "segmentbåge" utrum  ; -- segmentbåge..nn.1
  segmentell_1_A = mkA "segmentell" ; -- segmentell..av.1
  segmentera_1_V = mkV "segmenterar" ; -- segmentera..vb.1
  segmenterande_1_N = mkN "segmenterande" ; -- segmenterande..nn.1
  segmenterbar_1_A = mkA "segmenterbar" ; -- segmenterbar..av.1
  segmenterbarhet_1_N = mkN "segmenterbarhet" ; -- segmenterbarhet..nn.1
  segmentering_1_N = mkN "segmentering" ; -- segmentering..nn.1
  segmogen_1_A = mkA "segmogen" ; -- segmogen..av.1
  segna_1_V = mkV "segnar" ; -- segna..vb.1
  segnande_1_N = mkN "segnande" ; -- segnande..nn.1
  segra_1_V = mkV "segrar" ; -- segra..vb.1
  segra_2_V = mkV "segrar" ; -- segra..vb.2
  segrande_1_N = mkN "segrande" ; -- segrande..nn.1
  segrare_1_N = mkN "segrare" utrum  ; -- segrare..nn.1
  segregat_1_N = mkN "segregat" neutrum  ; -- segregat..nn.1
  segregation_1_N = mkN "segregation" ; -- segregation..nn.1
  segregera_1_V = mkV "segregerar" ; -- segregera..vb.1
  segregerande_1_N = mkN "segregerande" ; -- segregerande..nn.1
  segregerbar_1_A = mkA "segregerbar" ; -- segregerbar..av.1
  segregerbarhet_1_N = mkN "segregerbarhet" ; -- segregerbarhet..nn.1
  segregering_1_N = mkN "segregering" ; -- segregering..nn.1
  segring_1_N = mkN "segring" ; -- segring..nn.1
  segsliten_1_A = mkA "segsliten" ; -- segsliten..av.1
  segway_1_N = mkN "segway" "segwayen" "segwayer" "segwayerna" ; -- segway..nn.1
  seigneur_1_N = mkN "seigneur" "seigneurer" ; -- seigneur..nn.1
  seismisk_1_A = mkA "seismisk" ; -- seismisk..av.1
  seismograf_1_N = mkN "seismograf" "seismografer" ; -- seismograf..nn.1
  seismogram_1_N = mkN "seismogram" "seismogrammet" "seismogram" "seismogrammen" ; -- seismogram..nn.1
  seismologi_1_N = mkN "seismologi" ; -- seismologi..nn.1
  seismologisk_1_A = mkA "seismologisk" ; -- seismologisk..av.1
  seismometer_1_N = mkN "seismometer" ; -- seismometer..nn.1
  sej_1_N = mkN "sej" ; -- sej..nn.1
  sejd_1_N = mkN "sejd" ; -- sejd..nn.1
  sejda_1_V = mkV "sejdar" ; -- sejda..vb.1
  sejdande_1_N = mkN "sejdande" ; -- sejdande..nn.1
  sejdare_1_N = mkN "sejdare" utrum  ; -- sejdare..nn.1
  sejdel_1_N = mkN "sejdel" ; -- sejdel..nn.1
  sejm_1_N = mkN "sejm" ; -- sejm..nn.1
  sejnfall_1_N = mkN "sejnfall" neutrum  ; -- sejnfall..nn.1
  sejour_1_N = mkN "sejour" "sejourer" ; -- sejour..nn.1
  sejsa_1_V = mkV "sejsar" ; -- sejsa..vb.1
  sejsande_1_N = mkN "sejsande" ; -- sejsande..nn.1
  sejsing_1_N = mkN "sejsing" ; -- sejsing..nn.1
  sejsning_1_N = mkN "sejsning" ; -- sejsning..nn.1
  sejte_1_N = mkN "sejte" utrum  ; -- sejte..nn.1
  sekant_1_N = mkN "sekant" "sekanter" ; -- sekant..nn.1
  sekatör_1_N = mkN "sekatör" "sekatörer" ; -- sekatör..nn.1
  sekel_1_N = mkN "sekel" neutrum  ; -- sekel..nn.1
  sekellång_1_A = mkA "sekellång" ; -- sekellång..av.1
  sekelskifte_1_N = mkN "sekelskifte" ; -- sekelskifte..nn.1
  sekelskiftesintellektuell_1_A = mkA "sekelskiftesintellektuell" ; -- sekelskiftesintellektuell..av.1
  sekelskiftesmåleri_1_N = mkN "sekelskiftesmåleri" neutrum  ; -- sekelskiftesmåleri..nn.1
  sekelskiftshus_1_N = mkN "sekelskiftshus" neutrum  ; -- sekelskiftshus..nn.1
  sekin_1_N = mkN "sekin" "sekiner" ; -- sekin..nn.1
  sekond_1_N = mkN "sekond" "sekonder" ; -- sekond..nn.1
  sekondera_1_V = mkV "sekonderar" ; -- sekondera..vb.1
  sekonderande_1_N = mkN "sekonderande" ; -- sekonderande..nn.1
  sekonderbar_1_A = mkA "sekonderbar" ; -- sekonderbar..av.1
  sekonderbarhet_1_N = mkN "sekonderbarhet" ; -- sekonderbarhet..nn.1
  sekondering_1_N = mkN "sekondering" ; -- sekondering..nn.1
  sekret_1_A = mkA "sekret" "sekret" ; -- sekret..av.1
  sekret_1_N = mkN "sekret" neutrum  ; -- sekret..nn.1
  sekretariat_1_N = mkN "sekretariat" neutrum  ; -- sekretariat..nn.1
  sekreterare_1_N = mkN "sekreterare" utrum  ; -- sekreterare..nn.1
  sekreterarfågel_1_N = mkN "sekreterarfågel" ; -- sekreterarfågel..nn.1
  sekretess_1_N = mkN "sekretess" ; -- sekretess..nn.1
  sekretessbelägga_1_V = mkV "sekretessbelägga" "sekretessbela" "sekretessbelagt" ; -- sekretessbelägga..vb.1
  sekretessbeläggande_1_N = mkN "sekretessbeläggande" ; -- sekretessbeläggande..nn.1
  sekretesslag_1_N = mkN "sekretesslag" ; -- sekretesslag..nn.1
  sekretesslovlig_1_A = mkA "sekretesslovlig" ; -- sekretesslovlig..av.1
  sekretessprövning_1_N = mkN "sekretessprövning" ; -- sekretessprövning..nn.1
  sekretion_1_N = mkN "sekretion" ; -- sekretion..nn.1
  sekretionsrubbning_1_N = mkN "sekretionsrubbning" ; -- sekretionsrubbning..nn.1
  sekretorisk_1_A = mkA "sekretorisk" ; -- sekretorisk..av.1
  sekretär_1_N = mkN "sekretär" "sekretärer" ; -- sekretär..nn.1
  sekt_1_N = mkN "sekt" "sekter" ; -- sekt..nn.1
  sekt_2_N = mkN "sekt" ; -- sekt..nn.2
  sekter_1_N = mkN "sekter" ; -- sekter..nn.1
  sekterism_1_N = mkN "sekterism" "sekterismer" ; -- sekterism..nn.1
  sekterist_1_N = mkN "sekterist" "sekterister" ; -- sekterist..nn.1
  sekteristisk_1_A = mkA "sekteristisk" ; -- sekteristisk..av.1
  sektion_1_N = mkN "sektion" ; -- sektion..nn.1
  sektionsvis_1_Adv = mkAdv "sektionsvis" ; -- sektionsvis..ab.1
  sektionsvis_1_A = mkA "sektionsvis" ; -- sektionsvis..av.1
  sektliknande_1_A = mkA "sektliknande" ; -- sektliknande..av.1
  sektmedlem_1_N = mkN "sektmedlem" "sektmedlemmen" "sektmedlemmar" "sektmedlemmarna" ; -- sektmedlem..nn.1
  sektmentalitet_1_N = mkN "sektmentalitet" "sektmentaliteter" ; -- sektmentalitet..nn.1
  sektor_1_N = mkN "sektor" "sektorer" ; -- sektor..nn.1
  sektorfyr_1_N = mkN "sektorfyr" ; -- sektorfyr..nn.1
  sektoriell_1_A = mkA "sektoriell" ; -- sektoriell..av.1
  sektorport_1_N = mkN "sektorport" ; -- sektorport..nn.1
  sektorsvis_1_Adv = mkAdv "sektorsvis" ; -- sektorsvis..ab.1
  sektorsvis_1_A = mkA "sektorsvis" ; -- sektorsvis..av.1
  sekularisation_1_N = mkN "sekularisation" ; -- sekularisation..nn.1
  sekularisera_1_V = mkV "sekulariserar" ; -- sekularisera..vb.1
  sekulariserande_1_N = mkN "sekulariserande" ; -- sekulariserande..nn.1
  sekulariserbar_1_A = mkA "sekulariserbar" ; -- sekulariserbar..av.1
  sekulariserbarhet_1_N = mkN "sekulariserbarhet" ; -- sekulariserbarhet..nn.1
  sekularisering_1_N = mkN "sekularisering" ; -- sekularisering..nn.1
  sekularpräst_1_N = mkN "sekularpräst" "sekularpräster" ; -- sekularpräst..nn.1
  sekularsnille_1_N = mkN "sekularsnille" ; -- sekularsnille..nn.1
  sekulär_1_A = mkA "sekulär" ; -- sekulär..av.1
  sekulär_2_A = mkA "sekulär" ; -- sekulär..av.2
  sekund_1_N = mkN "sekund" "sekunder" ; -- sekund..nn.1
  sekunda_1_A = mkA "sekunda" ; -- sekunda..av.1
  sekundant_1_N = mkN "sekundant" "sekundanter" ; -- sekundant..nn.1
  sekundchef_1_N = mkN "sekundchef" "sekundchefer" ; -- sekundchef..nn.1
  sekundera_1_V = mkV "sekunderar" ; -- sekundera..vb.1
  sekunderande_1_N = mkN "sekunderande" ; -- sekunderande..nn.1
  sekunderbar_1_A = mkA "sekunderbar" ; -- sekunderbar..av.1
  sekunderbarhet_1_N = mkN "sekunderbarhet" ; -- sekunderbarhet..nn.1
  sekundering_1_N = mkN "sekundering" ; -- sekundering..nn.1
  sekundmeter_1_N = mkN "sekundmeter" "sekundmetern" "sekundmeter" "sekundmeterna" ; -- sekundmeter..nn.1
  sekundsnabb_1_A = mkA "sekundsnabb" ; -- sekundsnabb..av.1
  sekundvisare_1_N = mkN "sekundvisare" utrum  ; -- sekundvisare..nn.1
  sekundär_1_A = mkA "sekundär" ; -- sekundär..av.1
  sekundärbelysning_1_N = mkN "sekundärbelysning" ; -- sekundärbelysning..nn.1
  sekundärgrupp_1_N = mkN "sekundärgrupp" "sekundärgrupper" ; -- sekundärgrupp..nn.1
  sekundärinfektion_1_N = mkN "sekundärinfektion" ; -- sekundärinfektion..nn.1
  sekundärkommun_1_N = mkN "sekundärkommun" "sekundärkommuner" ; -- sekundärkommun..nn.1
  sekundärluft_1_N = mkN "sekundärluft" ; -- sekundärluft..nn.1
  sekundärminne_1_N = mkN "sekundärminne" ; -- sekundärminne..nn.1
  sekundärskola_1_N = mkN "sekundärskola" ; -- sekundärskola..nn.1
  sekundärspole_1_N = mkN "sekundärspole" utrum  ; -- sekundärspole..nn.1
  sekundärstadium_1_N = mkN "sekundärstadium" "sekundärstadiet" "sekundärstadier" "sekundärstadierna" ; -- sekundärstadium..nn.1
  sekundärström_1_N = mkN "sekundärström" "sekundärströmmen" "sekundärströmmar" "sekundärströmmarna" ; -- sekundärström..nn.1
  sekvens_1_N = mkN "sekvens" "sekvenser" ; -- sekvens..nn.1
  sekvensera_1_V = mkV "sekvenserar" ; -- sekvensera..vb.1
  sekvenserande_1_N = mkN "sekvenserande" ; -- sekvenserande..nn.1
  sekvensering_1_N = mkN "sekvensering" ; -- sekvensering..nn.1
  sekventiell_1_A = mkA "sekventiell" ; -- sekventiell..av.1
  sekvester_1_N = mkN "sekvester" ; -- sekvester..nn.1
  sekvestrera_1_V = mkV "sekvestrerar" ; -- sekvestrera..vb.1
  sekvestrerande_1_N = mkN "sekvestrerande" ; -- sekvestrerande..nn.1
  sekvestrerbar_1_A = mkA "sekvestrerbar" ; -- sekvestrerbar..av.1
  sekvestrerbarhet_1_N = mkN "sekvestrerbarhet" ; -- sekvestrerbarhet..nn.1
  sekvestrering_1_N = mkN "sekvestrering" ; -- sekvestrering..nn.1
  sel_1_N = mkN "sel" neutrum  ; -- sel..nn.1
  sela_1_V = mkV "selar" ; -- sela..vb.1
  selande_1_N = mkN "selande" ; -- selande..nn.1
  selbrott_1_N = mkN "selbrott" neutrum  ; -- selbrott..nn.1
  selbruten_1_A = mkA "selbruten" ; -- selbruten..av.1
  seldon_1_N = mkN "seldon" neutrum  ; -- seldon..nn.1
  sele_1_N = mkN "sele" utrum  ; -- sele..nn.1
  selektera_1_V = mkV "selekterar" ; -- selektera..vb.1
  selekterande_1_N = mkN "selekterande" ; -- selekterande..nn.1
  selekterbar_1_A = mkA "selekterbar" ; -- selekterbar..av.1
  selekterbarhet_1_N = mkN "selekterbarhet" ; -- selekterbarhet..nn.1
  selektering_1_N = mkN "selektering" ; -- selektering..nn.1
  selektion_1_N = mkN "selektion" ; -- selektion..nn.1
  selektionslära_1_N = mkN "selektionslära" ; -- selektionslära..nn.1
  selektiv_1_A = mkA "selektiv" ; -- selektiv..av.1
  selektivitet_1_N = mkN "selektivitet" "selektiviteter" ; -- selektivitet..nn.1
  selen_1_N = mkN "selen" neutrum  ; -- selen..nn.1
  selencell_1_N = mkN "selencell" "selenceller" ; -- selencell..nn.1
  selfie_1_N = mkN "selfie" "selfier" ; -- selfie..nn.1
  selfies_1_N = mkN "selfies" ; -- selfies..nn.1
  selfmade_1_A = mkA "selfmade" ; -- selfmade..av.1
  selleribotten_1_N = mkN "selleribotten" ; -- selleribotten..nn.1
  sellerikål_1_N = mkN "sellerikål" ; -- sellerikål..nn.1
  selning_1_N = mkN "selning" ; -- selning..nn.1
  selot_1_N = mkN "selot" "seloter" ; -- selot..nn.1
  selotisk_1_A = mkA "selotisk" ; -- selotisk..av.1
  seltersglas_1_N = mkN "seltersglas" neutrum  ; -- seltersglas..nn.1
  seltyg_1_N = mkN "seltyg" neutrum  ; -- seltyg..nn.1
  semafor_1_N = mkN "semafor" "semaforen" "semaforer" "semaforerna" ; -- semafor..nn.1
  semaforalfabet_1_N = mkN "semaforalfabet" neutrum  ; -- semaforalfabet..nn.1
  semaforera_1_V = mkV "semaforerar" ; -- semaforera..vb.1
  semaforerande_1_N = mkN "semaforerande" ; -- semaforerande..nn.1
  semaforerbar_1_A = mkA "semaforerbar" ; -- semaforerbar..av.1
  semaforerbarhet_1_N = mkN "semaforerbarhet" ; -- semaforerbarhet..nn.1
  semaforering_1_N = mkN "semaforering" ; -- semaforering..nn.1
  semaforflagga_1_N = mkN "semaforflagga" ; -- semaforflagga..nn.1
  semantik_1_N = mkN "semantik" ; -- semantik..nn.1
  semantisk_1_A = mkA "semantisk" ; -- semantisk..av.1
  semasiologi_1_N = mkN "semasiologi" ; -- semasiologi..nn.1
  semem_1_N = mkN "semem" neutrum  ; -- semem..nn.1
  semester_1_N = mkN "semester" ; -- semester..nn.1
  semesterarvode_1_N = mkN "semesterarvode" ; -- semesterarvode..nn.1
  semesterby_1_N = mkN "semesterby" "semesterbyn" "semesterbyar" "semesterbyarna" ; -- semesterby..nn.1
  semesterdag_1_N = mkN "semesterdag" ; -- semesterdag..nn.1
  semesterersättning_1_N = mkN "semesterersättning" ; -- semesterersättning..nn.1
  semesterfirande_1_A = mkA "semesterfirande" ; -- semesterfirande..av.1
  semesterfirande_1_N = mkN "semesterfirande" ; -- semesterfirande..nn.1
  semesterfirare_1_N = mkN "semesterfirare" utrum  ; -- semesterfirare..nn.1
  semesterflört_1_N = mkN "semesterflört" "semesterflörter" ; -- semesterflört..nn.1
  semesterfynd_1_N = mkN "semesterfynd" neutrum  ; -- semesterfynd..nn.1
  semesterkamera_1_N = mkN "semesterkamera" ; -- semesterkamera..nn.1
  semesterkassa_1_N = mkN "semesterkassa" ; -- semesterkassa..nn.1
  semesterlön_1_N = mkN "semesterlön" "semesterlöner" ; -- semesterlön..nn.1
  semestermånad_1_N = mkN "semestermånad" "semestermånader" ; -- semestermånad..nn.1
  semesterort_1_N = mkN "semesterort" "semesterorter" ; -- semesterort..nn.1
  semesterpeng_1_N = mkN "semesterpeng" ; -- semesterpeng..nn.1
  semesterplan_1_N = mkN "semesterplan" "semesterplaner" ; -- semesterplan..nn.1
  semesterresa_1_V = mkV "semesterreser" ; -- semesterresa..vb.1
  semesterromans_1_N = mkN "semesterromans" "semesterromanser" ; -- semesterromans..nn.1
  semesterstängd_1_A = mkA "semesterstängd" "semesterstängt" ; -- semesterstängd..av.1
  semestertid_1_N = mkN "semestertid" "semestertider" ; -- semestertid..nn.1
  semestertillägg_1_N = mkN "semestertillägg" neutrum  ; -- semestertillägg..nn.1
  semestervecka_1_N = mkN "semestervecka" ; -- semestervecka..nn.1
  semestra_1_V = mkV "semestrar" ; -- semestra..vb.1
  semestrande_1_N = mkN "semestrande" ; -- semestrande..nn.1
  semestrare_1_N = mkN "semestrare" utrum  ; -- semestrare..nn.1
  semiautomatisk_1_A = mkA "semiautomatisk" ; -- semiautomatisk..av.1
  semifinal_1_N = mkN "semifinal" "semifinaler" ; -- semifinal..nn.1
  semifinalplats_1_N = mkN "semifinalplats" "semifinalplatser" ; -- semifinalplats..nn.1
  semikolon_1_N = mkN "semikolon" neutrum  ; -- semikolon..nn.1
  seminarielärare_1_N = mkN "seminarielärare" utrum  ; -- seminarielärare..nn.1
  seminarist_1_N = mkN "seminarist" "seminarister" ; -- seminarist..nn.1
  seminarium_1_N = mkN "seminarium" "seminariet" "seminarier" "seminarierna" ; -- seminarium..nn.1
  semination_1_N = mkN "semination" ; -- semination..nn.1
  seminavel_1_N = mkN "seminavel" ; -- seminavel..nn.1
  seminera_1_V = mkV "seminerar" ; -- seminera..vb.1
  seminerande_1_N = mkN "seminerande" ; -- seminerande..nn.1
  seminerbar_1_A = mkA "seminerbar" ; -- seminerbar..av.1
  seminerbarhet_1_N = mkN "seminerbarhet" ; -- seminerbarhet..nn.1
  seminering_1_N = mkN "seminering" ; -- seminering..nn.1
  seminstation_1_N = mkN "seminstation" ; -- seminstation..nn.1
  seminör_1_N = mkN "seminör" "seminörer" ; -- seminör..nn.1
  semiologi_1_N = mkN "semiologi" ; -- semiologi..nn.1
  semiotik_1_N = mkN "semiotik" ; -- semiotik..nn.1
  semiotisk_1_A = mkA "semiotisk" ; -- semiotisk..av.1
  semipermeabel_1_A = mkA "semipermeabel" ; -- semipermeabel..av.1
  semit_1_N = mkN "semit" "semiter" ; -- semit..nn.1
  semitisk_1_A = mkA "semitisk" ; -- semitisk..av.1
  semitist_1_N = mkN "semitist" "semitister" ; -- semitist..nn.1
  semitrailer_1_N = mkN "semitrailer" ; -- semitrailer..nn.1
  semla_1_N = mkN "semla" ; -- semla..nn.1
  semologi_1_N = mkN "semologi" ; -- semologi..nn.1
  semologisk_1_A = mkA "semologisk" ; -- semologisk..av.1
  sen_1_Adv = mkAdv "sen" ; -- sen..ab.1
  sen_1_A = mkA "sen" ; -- sen..av.1
  sena_1_N = mkN "sena" ; -- sena..nn.1
  senantik_1_A = mkA "senantik" ; -- senantik..av.1
  senantik_1_N = mkN "senantik" ; -- senantik..nn.1
  senap_1_N = mkN "senap" ; -- senap..nn.1
  senapsdeg_1_N = mkN "senapsdeg" ; -- senapsdeg..nn.1
  senapsgas_1_N = mkN "senapsgas" ; -- senapsgas..nn.1
  senapsglas_1_N = mkN "senapsglas" neutrum  ; -- senapsglas..nn.1
  senapsgul_1_A = mkA "senapsgul" ; -- senapsgul..av.1
  senapskorn_1_N = mkN "senapskorn" neutrum  ; -- senapskorn..nn.1
  senapskål_1_N = mkN "senapskål" ; -- senapskål..nn.1
  senar_1_N = mkN "senar" "senarer" ; -- senar..nn.1
  senare_1_Adv = mkAdv "senare-" ; -- senare..ab.1
  senare_1_A = mkA "senare" ; -- senare..av.1
  senarelägga_1_V = mkV "senarelägga" "senarela" "senarelagt" ; -- senarelägga..vb.1
  senareläggande_1_N = mkN "senareläggande" ; -- senareläggande..nn.1
  senareläggning_1_N = mkN "senareläggning" ; -- senareläggning..nn.1
  senast_1_Adv = mkAdv "senast" ; -- senast..ab.1
  senat_1_N = mkN "senat" "senater" ; -- senat..nn.1
  senator_1_N = mkN "senator" "senatorer" ; -- senator..nn.1
  senatsval_1_N = mkN "senatsval" neutrum  ; -- senatsval..nn.1
  sendrag_1_N = mkN "sendrag" neutrum  ; -- sendrag..nn.1
  senegales_1_N = mkN "senegales" "senegaleser" ; -- senegales..nn.1
  senegalesisk_1_A = mkA "senegalesisk" ; -- senegalesisk..av.1
  senegalesiska_1_N = mkN "senegalesiska" ; -- senegalesiska..nn.1
  senfärdig_1_A = mkA "senfärdig" ; -- senfärdig..av.1
  senfärdighet_1_N = mkN "senfärdighet" ; -- senfärdighet..nn.1
  senfäste_1_N = mkN "senfäste" ; -- senfäste..nn.1
  senfångad_1_A = mkA "senfångad" ; -- senfångad..av.1
  senfödd_1_A = mkA "senfödd" ; -- senfödd..av.1
  sengångaraktig_1_A = mkA "sengångaraktig" ; -- sengångaraktig..av.1
  sengångaraktighet_1_N = mkN "sengångaraktighet" ; -- sengångaraktighet..nn.1
  sengångare_1_N = mkN "sengångare" utrum  ; -- sengångare..nn.1
  senhet_1_N = mkN "senhet" ; -- senhet..nn.1
  senhinna_1_N = mkN "senhinna" ; -- senhinna..nn.1
  senhöst_1_N = mkN "senhöst" ; -- senhöst..nn.1
  senig_1_A = mkA "senig" ; -- senig..av.1
  senighet_1_N = mkN "senighet" ; -- senighet..nn.1
  senil_1_A = mkA "senil" ; -- senil..av.1
  senildement_1_A = mkA "senildement" ; -- senildement..av.1
  senilitet_1_N = mkN "senilitet" "seniliteter" ; -- senilitet..nn.1
  senilvårta_1_N = mkN "senilvårta" ; -- senilvårta..nn.1
  senior_1_A = mkA "senior" ; -- senior..av.1
  senior_1_N = mkN "senior" "senioren" "seniorer" "seniorerna" ; -- senior..nn.1
  senior_2_N = mkN "senior" ; -- senior..nn.2
  seniorat_1_N = mkN "seniorat" neutrum  ; -- seniorat..nn.1
  seniorboende_1_N = mkN "seniorboende" ; -- seniorboende..nn.1
  senklapp_1_N = mkN "senklapp" ; -- senklapp..nn.1
  senknarr_1_N = mkN "senknarr" neutrum  ; -- senknarr..nn.1
  senknut_1_N = mkN "senknut" ; -- senknut..nn.1
  senkomling_1_N = mkN "senkomling" ; -- senkomling..nn.1
  senkommen_1_A = mkA "senkommen" "senkommet" "senkomna" "senkomna" "senkomnare" "senkomnast" "senkomnaste" ; -- senkommen..av.1
  senmedeltid_1_N = mkN "senmedeltid" ; -- senmedeltid..nn.1
  senmedeltida_1_A = mkA "senmedeltida" ; -- senmedeltida..av.1
  senna_1_N = mkN "senna" ; -- senna..nn.1
  senneolitisk_1_A = mkA "senneolitisk" ; -- senneolitisk..av.1
  senorgan_1_N = mkN "senorgan" neutrum  ; -- senorgan..nn.1
  senrenässans_1_N = mkN "senrenässans" ; -- senrenässans..nn.1
  senromersk_1_A = mkA "senromersk" ; -- senromersk..av.1
  sensation_1_N = mkN "sensation" ; -- sensation..nn.1
  sensationalism_1_N = mkN "sensationalism" ; -- sensationalism..nn.1
  sensationell_1_A = mkA "sensationell" ; -- sensationell..av.1
  sensationsbetonad_1_A = mkA "sensationsbetonad" ; -- sensationsbetonad..av.1
  sensationsjournalistik_1_N = mkN "sensationsjournalistik" ; -- sensationsjournalistik..nn.1
  sensationslysten_1_A = mkA "sensationslysten" ; -- sensationslysten..av.1
  sensationslystnad_1_N = mkN "sensationslystnad" ; -- sensationslystnad..nn.1
  sensationssug_1_N = mkN "sensationssug" neutrum  ; -- sensationssug..nn.1
  sensibel_1_A = mkA "sensibel" ; -- sensibel..av.1
  sensibilisera_1_V = mkV "sensibiliserar" ; -- sensibilisera..vb.1
  sensibiliserande_1_N = mkN "sensibiliserande" ; -- sensibiliserande..nn.1
  sensibiliserbar_1_A = mkA "sensibiliserbar" ; -- sensibiliserbar..av.1
  sensibiliserbarhet_1_N = mkN "sensibiliserbarhet" ; -- sensibiliserbarhet..nn.1
  sensibilisering_1_N = mkN "sensibilisering" ; -- sensibilisering..nn.1
  sensibilitet_1_N = mkN "sensibilitet" "sensibiliteter" ; -- sensibilitet..nn.1
  sensigrupp_1_N = mkN "sensigrupp" "sensigrupper" ; -- sensigrupp..nn.1
  sensitiv_1_A = mkA "sensitiv" ; -- sensitiv..av.1
  sensitiva_1_N = mkN "sensitiva" ; -- sensitiva..nn.1
  sensitivitet_1_N = mkN "sensitivitet" "sensitiviteter" ; -- sensitivitet..nn.1
  sensitivitetstalang_1_N = mkN "sensitivitetstalang" "sensitivitetstalanger" ; -- sensitivitetstalang..nn.1
  sensitivitetsträning_1_N = mkN "sensitivitetsträning" ; -- sensitivitetsträning..nn.1
  sensiträning_1_N = mkN "sensiträning" ; -- sensiträning..nn.1
  senskida_1_N = mkN "senskida" ; -- senskida..nn.1
  sensmoral_1_N = mkN "sensmoral" "sensmoraler" ; -- sensmoral..nn.1
  sensommar_1_N = mkN "sensommar" "sensommaren" "sensomrar" "sensomrarna" ; -- sensommar..nn.1
  sensommarfluga_1_N = mkN "sensommarfluga" ; -- sensommarfluga..nn.1
  sensommarnatt_1_N = mkN "sensommarnatt" "sensommarnätter" ; -- sensommarnatt..nn.1
  sensomotorisk_1_A = mkA "sensomotorisk" ; -- sensomotorisk..av.1
  sensor_1_N = mkN "sensor" "sensorer" ; -- sensor..nn.1
  sensorisk_1_A = mkA "sensorisk" ; -- sensorisk..av.1
  sensträckning_1_N = mkN "sensträckning" ; -- sensträckning..nn.1
  sensträng_1_N = mkN "sensträng" ; -- sensträng..nn.1
  sensualism_1_N = mkN "sensualism" "sensualismer" ; -- sensualism..nn.1
  sensualistisk_1_A = mkA "sensualistisk" ; -- sensualistisk..av.1
  sensualitet_1_N = mkN "sensualitet" "sensualiteter" ; -- sensualitet..nn.1
  sensuell_1_A = mkA "sensuell" ; -- sensuell..av.1
  sentens_1_N = mkN "sentens" "sentenser" ; -- sentens..nn.1
  sentensiös_1_A = mkA "sentensiös" ; -- sentensiös..av.1
  sententiös_1_A = mkA "sententiös" ; -- sententiös..av.1
  sentera_1_V = mkV "senterar" ; -- sentera..vb.1
  senterande_1_N = mkN "senterande" ; -- senterande..nn.1
  senterbar_1_A = mkA "senterbar" ; -- senterbar..av.1
  senterbarhet_1_N = mkN "senterbarhet" ; -- senterbarhet..nn.1
  sentering_1_N = mkN "sentering" ; -- sentering..nn.1
  sentida_1_A = mkA "sentida" ; -- sentida..av.1
  sentima_1_A = mkA "sentima" ; -- sentima..av.1
  sentiment_1_N = mkN "sentiment" neutrum  ; -- sentiment..nn.1
  sentimental_1_A = mkA "sentimental" ; -- sentimental..av.1
  sentimentalitet_1_N = mkN "sentimentalitet" "sentimentaliteter" ; -- sentimentalitet..nn.1
  senvinter_1_N = mkN "senvinter" ; -- senvinter..nn.1
  senvår_1_N = mkN "senvår" ; -- senvår..nn.1
  separabel_1_A = mkA "separabel" ; -- separabel..av.1
  separat_1_A = mkA "separat" "separat" ; -- separat..av.1
  separat_1_N = mkN "separat" neutrum  ; -- separat..nn.1
  separatfjädring_1_N = mkN "separatfjädring" ; -- separatfjädring..nn.1
  separatfred_1_N = mkN "separatfred" "separatfreder" ; -- separatfred..nn.1
  separation_1_N = mkN "separation" ; -- separation..nn.1
  separationsångest_1_N = mkN "separationsångest" ; -- separationsångest..nn.1
  separatism_1_N = mkN "separatism" "separatismer" ; -- separatism..nn.1
  separatist_1_N = mkN "separatist" "separatister" ; -- separatist..nn.1
  separatistisk_1_A = mkA "separatistisk" ; -- separatistisk..av.1
  separatistledare_1_N = mkN "separatistledare" utrum  ; -- separatistledare..nn.1
  separatiströrelse_1_N = mkN "separatiströrelse" "separatiströrelser" ; -- separatiströrelse..nn.1
  separator_1_N = mkN "separator" "separatorer" ; -- separator..nn.1
  separattryck_1_N = mkN "separattryck" neutrum  ; -- separattryck..nn.1
  separatutställning_1_N = mkN "separatutställning" ; -- separatutställning..nn.1
  separera_1_V = mkV "separerar" ; -- separera..vb.1
  separerande_1_N = mkN "separerande" ; -- separerande..nn.1
  separerbar_1_A = mkA "separerbar" ; -- separerbar..av.1
  separerbarhet_1_N = mkN "separerbarhet" ; -- separerbarhet..nn.1
  separering_1_N = mkN "separering" ; -- separering..nn.1
  sepia_1_N = mkN "sepia" ; -- sepia..nn.1
  sepiafärgad_1_A = mkA "sepiafärgad" ; -- sepiafärgad..av.1
  sepiatoning_1_N = mkN "sepiatoning" ; -- sepiatoning..nn.1
  seponera_1_V = mkV "seponerar" ; -- seponera..vb.1
  sepoy_1_N = mkN "sepoy" "sepoyen" "sepoys" "sepoysarna" ; -- sepoy..nn.1
  sepsis_1_N = mkN "sepsis" ; -- sepsis..nn.1
  september_1_N = mkN "september" ; -- september..nn.1
  septennium_1_N = mkN "septennium" "septenniet" "septennier" "septennierna" ; -- septennium..nn.1
  septett_1_N = mkN "septett" "septetter" ; -- septett..nn.1
  septiktank_1_N = mkN "septiktank" ; -- septiktank..nn.1
  septima_1_N = mkN "septima" ; -- septima..nn.1
  septimackord_1_N = mkN "septimackord" neutrum  ; -- septimackord..nn.1
  septisk_1_A = mkA "septisk" ; -- septisk..av.1
  septuagesima_1_N = mkN "septuagesima" ; -- septuagesima..nn.1
  sepulkral_1_A = mkA "sepulkral" ; -- sepulkral..av.1
  sequoia_1_N = mkN "sequoia" ; -- sequoia..nn.1
  seraf_1_N = mkN "seraf" "serafer" ; -- seraf..nn.1
  serafimerband_1_N = mkN "serafimerband" neutrum  ; -- serafimerband..nn.1
  serafisk_1_A = mkA "serafisk" ; -- serafisk..av.1
  seralj_1_N = mkN "seralj" "seraljer" ; -- seralj..nn.1
  serb_1_N = mkN "serb" "serber" ; -- serb..nn.1
  serbisk_1_A = mkA "serbisk" ; -- serbisk..av.1
  serbiska_1_N = mkN "serbiska" ; -- serbiska..nn.1
  serbledare_1_N = mkN "serbledare" utrum  ; -- serbledare..nn.1
  serbokroatisk_1_A = mkA "serbokroatisk" ; -- serbokroatisk..av.1
  serbokroatiska_1_N = mkN "serbokroatiska" ; -- serbokroatiska..nn.1
  seren_1_A = mkA "seren" "serent" ; -- seren..av.1
  serenad_1_N = mkN "serenad" "serenader" ; -- serenad..nn.1
  serenitet_1_N = mkN "serenitet" "sereniteter" ; -- serenitet..nn.1
  sergeant_1_N = mkN "sergeant" "sergeanter" ; -- sergeant..nn.1
  serie_1_N = mkN "serie" "serier" ; -- serie..nn.1
  seriefigur_1_N = mkN "seriefigur" "seriefigurer" ; -- seriefigur..nn.1
  serieinlärning_1_N = mkN "serieinlärning" ; -- serieinlärning..nn.1
  seriekoppla_1_V = mkV "seriekopplar" ; -- seriekoppla..vb.1
  seriekopplande_1_N = mkN "seriekopplande" ; -- seriekopplande..nn.1
  seriekoppling_1_N = mkN "seriekoppling" ; -- seriekoppling..nn.1
  seriekrock_1_N = mkN "seriekrock" ; -- seriekrock..nn.1
  serieledande_1_A = mkA "serieledande" ; -- serieledande..av.1
  seriell_1_A = mkA "seriell" ; -- seriell..av.1
  seriemagasin_1_N = mkN "seriemagasin" neutrum  ; -- seriemagasin..nn.1
  seriematch_1_N = mkN "seriematch" "seriematcher" ; -- seriematch..nn.1
  seriemord_1_N = mkN "seriemord" neutrum  ; -- seriemord..nn.1
  seriemässig_1_A = mkA "seriemässig" ; -- seriemässig..av.1
  seriemördare_1_N = mkN "seriemördare" utrum  ; -- seriemördare..nn.1
  serieproduktion_1_N = mkN "serieproduktion" ; -- serieproduktion..nn.1
  serieruta_1_N = mkN "serieruta" ; -- serieruta..nn.1
  seriespel_1_N = mkN "seriespel" "seriespelet" "seriespel" "seriespelen" ; -- seriespel..nn.1
  seriestrip_1_N = mkN "seriestrip" ; -- seriestrip..nn.1
  seriestripp_1_N = mkN "seriestripp" ; -- seriestripp..nn.1
  serietecknare_1_N = mkN "serietecknare" utrum  ; -- serietecknare..nn.1
  serietidning_1_N = mkN "serietidning" ; -- serietidning..nn.1
  serietidningstappning_1_N = mkN "serietidningstappning" ; -- serietidningstappning..nn.1
  serietillverka_1_V = mkV "serietillverkar" ; -- serietillverka..vb.1
  serietillverkande_1_N = mkN "serietillverkande" ; -- serietillverkande..nn.1
  serietillverkning_1_N = mkN "serietillverkning" ; -- serietillverkning..nn.1
  serievåldtäktsman_1_N = mkN "serievåldtäktsman" "serievåldtäktsmannen" "serievåldtäktsmän" "serievåldtäktsmännen" ; -- serievåldtäktsman..nn.1
  serif_1_N = mkN "serif" "serifer" ; -- serif..nn.1
  seriff_1_N = mkN "seriff" "seriffer" ; -- seriff..nn.1
  serigrafi_1_N = mkN "serigrafi" "serigrafier" ; -- serigrafi..nn.1
  seriositet_1_N = mkN "seriositet" "seriositeter" ; -- seriositet..nn.1
  seriös_1_A = mkA "seriös" ; -- seriös..av.1
  serologi_1_N = mkN "serologi" ; -- serologi..nn.1
  serotonin_1_N = mkN "serotonin" "serotoniner" ; -- serotonin..nn.1
  serotoninhöjande_1_A = mkA "serotoninhöjande" ; -- serotoninhöjande..av.1
  serpent_1_N = mkN "serpent" "serpenter" ; -- serpent..nn.1
  serpentin_1_N = mkN "serpentin" "serpentiner" ; -- serpentin..nn.1
  serpentinisering_1_N = mkN "serpentinisering" ; -- serpentinisering..nn.1
  serum_1_N = mkN "serum" neutrum  ; -- serum..nn.1
  serumdiagnostik_1_N = mkN "serumdiagnostik" ; -- serumdiagnostik..nn.1
  serumterapi_1_N = mkN "serumterapi" ; -- serumterapi..nn.1
  serva_1_V = mkV "servar" ; -- serva..vb.1
  serval_1_N = mkN "serval" "servaler" ; -- serval..nn.1
  servande_1_N = mkN "servande" ; -- servande..nn.1
  servboll_1_N = mkN "servboll" ; -- servboll..nn.1
  serve_1_N = mkN "serve" utrum  ; -- serve..nn.1
  serveboll_1_N = mkN "serveboll" ; -- serveboll..nn.1
  serveess_1_N = mkN "serveess" neutrum  ; -- serveess..nn.1
  servegame_1_N = mkN "servegame" "servegamet" "servegame" "servegamen" ; -- servegame..nn.1
  servelinje_1_N = mkN "servelinje" "servelinjer" ; -- servelinje..nn.1
  server_1_N = mkN "server" ; -- server..nn.1
  servera_1_V = mkV "serverar" ; -- servera..vb.1
  serverande_1_N = mkN "serverande" ; -- serverande..nn.1
  serverbar_1_A = mkA "serverbar" ; -- serverbar..av.1
  serverbarhet_1_N = mkN "serverbarhet" ; -- serverbarhet..nn.1
  serverfarm_1_N = mkN "serverfarm" "serverfarmer" ; -- serverfarm..nn.1
  servering_1_N = mkN "servering" ; -- servering..nn.1
  serveringsavgift_1_N = mkN "serveringsavgift" "serveringsavgifter" ; -- serveringsavgift..nn.1
  serveringsbord_1_N = mkN "serveringsbord" neutrum  ; -- serveringsbord..nn.1
  serveringsfat_1_N = mkN "serveringsfat" neutrum  ; -- serveringsfat..nn.1
  serveringsgång_1_N = mkN "serveringsgång" ; -- serveringsgång..nn.1
  serveringskork_1_N = mkN "serveringskork" ; -- serveringskork..nn.1
  serveringspersonal_1_N = mkN "serveringspersonal" ; -- serveringspersonal..nn.1
  serveringsrum_1_N = mkN "serveringsrum" "serveringsrummet" "serveringsrum" "serveringsrummen" ; -- serveringsrum..nn.1
  serveringsvagn_1_N = mkN "serveringsvagn" ; -- serveringsvagn..nn.1
  serveruta_1_N = mkN "serveruta" ; -- serveruta..nn.1
  servess_1_N = mkN "servess" neutrum  ; -- servess..nn.1
  servett_1_N = mkN "servett" "servetter" ; -- servett..nn.1
  servettbrytning_1_N = mkN "servettbrytning" ; -- servettbrytning..nn.1
  servettring_1_N = mkN "servettring" ; -- servettring..nn.1
  serveuppkast_1_N = mkN "serveuppkast" neutrum  ; -- serveuppkast..nn.1
  servgame_1_N = mkN "servgame" "servgamet" "servgame" "servgamen" ; -- servgame..nn.1
  service_1_N = mkN "service" utrum  ; -- service..nn.1
  servicebil_1_N = mkN "servicebil" ; -- servicebil..nn.1
  servicebostad_1_N = mkN "servicebostad" "servicebostäder" ; -- servicebostad..nn.1
  servicebox_1_N = mkN "servicebox" ; -- servicebox..nn.1
  servicebutik_1_N = mkN "servicebutik" "servicebutiker" ; -- servicebutik..nn.1
  servicehus_1_N = mkN "servicehus" neutrum  ; -- servicehus..nn.1
  serviceinriktad_1_A = mkA "serviceinriktad" ; -- serviceinriktad..av.1
  serviceinrättning_1_N = mkN "serviceinrättning" ; -- serviceinrättning..nn.1
  servicekänsla_1_N = mkN "servicekänsla" ; -- servicekänsla..nn.1
  servicelucka_1_N = mkN "servicelucka" ; -- servicelucka..nn.1
  servicelägenhet_1_N = mkN "servicelägenhet" "servicelägenheter" ; -- servicelägenhet..nn.1
  serviceman_1_N = mkN "serviceman" "servicemannen" "servicemän" "servicemännen" ; -- serviceman..nn.1
  servicemässig_1_A = mkA "servicemässig" ; -- servicemässig..av.1
  servicenäring_1_N = mkN "servicenäring" ; -- servicenäring..nn.1
  servicepersonal_1_N = mkN "servicepersonal" "servicepersonaler" ; -- servicepersonal..nn.1
  servicestation_1_N = mkN "servicestation" ; -- servicestation..nn.1
  serviceyrke_1_N = mkN "serviceyrke" ; -- serviceyrke..nn.1
  servil_1_A = mkA "servil" ; -- servil..av.1
  servilism_1_N = mkN "servilism" "servilismer" ; -- servilism..nn.1
  servilitet_1_N = mkN "servilitet" "serviliteter" ; -- servilitet..nn.1
  servis_1_N = mkN "servis" "serviser" ; -- servis..nn.1
  servisledning_1_N = mkN "servisledning" ; -- servisledning..nn.1
  servitris_1_N = mkN "servitris" "servitriser" ; -- servitris..nn.1
  servitrisbak_1_N = mkN "servitrisbak" ; -- servitrisbak..nn.1
  servitrisklapp_1_N = mkN "servitrisklapp" ; -- servitrisklapp..nn.1
  servitut_1_N = mkN "servitut" neutrum  ; -- servitut..nn.1
  servitör_1_N = mkN "servitör" "servitörer" ; -- servitör..nn.1
  servlinje_1_N = mkN "servlinje" "servlinjer" ; -- servlinje..nn.1
  servobroms_1_N = mkN "servobroms" ; -- servobroms..nn.1
  servomotor_1_N = mkN "servomotor" "servomotorer" ; -- servomotor..nn.1
  servostyrning_1_N = mkN "servostyrning" ; -- servostyrning..nn.1
  servruta_1_N = mkN "servruta" ; -- servruta..nn.1
  serös_1_A = mkA "serös" ; -- serös..av.1
  sesam_1_N = mkN "sesam" ; -- sesam..nn.1
  sesamfrö_1_N = mkN "sesamfrö" "sesamfröet" "sesamfrön" "sesamfröna" ; -- sesamfrö..nn.1
  sessa_1_N = mkN "sessa" ; -- sessa..nn.1
  session_1_N = mkN "session" ; -- session..nn.1
  set_1_N = mkN "set" neutrum  ; -- set..nn.1
  setboll_1_N = mkN "setboll" ; -- setboll..nn.1
  setter_1_N = mkN "setter" ; -- setter..nn.1
  settlement_1_N = mkN "settlement" neutrum  ; -- settlement..nn.1
  sevärd_1_A = mkA "sevärd" "sevärt" ; -- sevärd..av.1
  sevärdhet_1_N = mkN "sevärdhet" "sevärdheter" ; -- sevärdhet..nn.1
  sex_1_N = mkN "sex" neutrum  ; -- sex..nn.1
  sexa_1_N = mkN "sexa" ; -- sexa..nn.1
  sexaffär_1_N = mkN "sexaffär" "sexaffärer" ; -- sexaffär..nn.1
  sexagesima_1_N = mkN "sexagesima" ; -- sexagesima..nn.1
  sexakt_1_N = mkN "sexakt" "sexakter" ; -- sexakt..nn.1
  sexarbetare_1_N = mkN "sexarbetare" utrum  ; -- sexarbetare..nn.1
  sexavslöjande_1_N = mkN "sexavslöjande" ; -- sexavslöjande..nn.1
  sexbarnsmoder_1_N = mkN "sexbarnsmoder" "sexbarnsmodern" "sexbarnsmödrar" "sexbarnsmödrarna" ; -- sexbarnsmoder..nn.1
  sexbomb_1_N = mkN "sexbomb" "sexbomber" ; -- sexbomb..nn.1
  sexbrott_1_N = mkN "sexbrott" neutrum  ; -- sexbrott..nn.1
  sexbrottsutredning_1_N = mkN "sexbrottsutredning" ; -- sexbrottsutredning..nn.1
  sexbås_1_N = mkN "sexbås" neutrum  ; -- sexbås..nn.1
  sexchatta_1_V = mkV "sexchattar" ; -- sexchatta..vb.1
  sexchattande_1_N = mkN "sexchattande" ; -- sexchattande..nn.1
  sexcylindrig_1_A = mkA "sexcylindrig" ; -- sexcylindrig..av.1
  sexdebut_1_N = mkN "sexdebut" "sexdebuter" ; -- sexdebut..nn.1
  sexdubbel_1_A = mkA "sexdubben" ; -- sexdubbel..av.1
  sexdubbla_1_V = mkV "sexdubblar" ; -- sexdubbla..vb.1
  sexdubblande_1_N = mkN "sexdubblande" ; -- sexdubblande..nn.1
  sexdubbling_1_N = mkN "sexdubbling" ; -- sexdubbling..nn.1
  sexexpert_1_N = mkN "sexexpert" "sexexperter" ; -- sexexpert..nn.1
  sexfaldig_1_A = mkA "sexfaldig" ; -- sexfaldig..av.1
  sexfaldiga_1_V = mkV "sexfaldigar" ; -- sexfaldiga..vb.1
  sexfaldigande_1_N = mkN "sexfaldigande" ; -- sexfaldigande..nn.1
  sexfantasi_1_N = mkN "sexfantasi" "sexfantasier" ; -- sexfantasi..nn.1
  sexfixerad_1_A = mkA "sexfixerad" ; -- sexfixerad..av.1
  sexfoting_1_N = mkN "sexfoting" ; -- sexfoting..nn.1
  sexförbrytare_1_N = mkN "sexförbrytare" utrum  ; -- sexförbrytare..nn.1
  sexgalning_1_N = mkN "sexgalning" ; -- sexgalning..nn.1
  sexhjälpmedel_1_N = mkN "sexhjälpmedel" neutrum  ; -- sexhjälpmedel..nn.1
  sexhändelse_1_N = mkN "sexhändelse" "sexhändelser" ; -- sexhändelse..nn.1
  sexhärva_1_N = mkN "sexhärva" ; -- sexhärva..nn.1
  sexhörnig_1_A = mkA "sexhörnig" ; -- sexhörnig..av.1
  sexhörning_1_N = mkN "sexhörning" ; -- sexhörning..nn.1
  sexig_1_A = mkA "sexig" ; -- sexig..av.1
  sexindustri_1_N = mkN "sexindustri" "sexindustrier" ; -- sexindustri..nn.1
  sexintresse_1_N = mkN "sexintresse" ; -- sexintresse..nn.1
  sexism_1_N = mkN "sexism" "sexismer" ; -- sexism..nn.1
  sexist_1_N = mkN "sexist" "sexister" ; -- sexist..nn.1
  sexistisk_1_A = mkA "sexistisk" ; -- sexistisk..av.1
  sexkantig_1_A = mkA "sexkantig" ; -- sexkantig..av.1
  sexkantsnyckel_1_N = mkN "sexkantsnyckel" ; -- sexkantsnyckel..nn.1
  sexkidnappning_1_N = mkN "sexkidnappning" ; -- sexkidnappning..nn.1
  sexklinik_1_N = mkN "sexklinik" "sexkliniker" ; -- sexklinik..nn.1
  sexklipp_1_N = mkN "sexklipp" neutrum  ; -- sexklipp..nn.1
  sexköp_1_N = mkN "sexköp" neutrum  ; -- sexköp..nn.1
  sexköpslag_1_N = mkN "sexköpslag" ; -- sexköpslag..nn.1
  sexleksak_1_N = mkN "sexleksak" "sexleksaker" ; -- sexleksak..nn.1
  sexling_1_N = mkN "sexling" ; -- sexling..nn.1
  sexliv_1_N = mkN "sexliv" neutrum  ; -- sexliv..nn.1
  sexlust_1_N = mkN "sexlust" ; -- sexlust..nn.1
  sexmissbruk_1_N = mkN "sexmissbruk" neutrum  ; -- sexmissbruk..nn.1
  sexmissbrukare_1_N = mkN "sexmissbrukare" utrum  ; -- sexmissbrukare..nn.1
  sexmobbing_1_N = mkN "sexmobbing" ; -- sexmobbing..nn.1
  sexmord_1_N = mkN "sexmord" neutrum  ; -- sexmord..nn.1
  sexmyt_1_N = mkN "sexmyt" "sexmyter" ; -- sexmyt..nn.1
  sexmästare_1_N = mkN "sexmästare" utrum  ; -- sexmästare..nn.1
  sexmånadersperiod_1_N = mkN "sexmånadersperiod" "sexmånadersperioder" ; -- sexmånadersperiod..nn.1
  sexmördare_1_N = mkN "sexmördare" utrum  ; -- sexmördare..nn.1
  sexofredande_1_N = mkN "sexofredande" ; -- sexofredande..nn.1
  sexolog_1_N = mkN "sexolog" "sexologer" ; -- sexolog..nn.1
  sexologi_1_N = mkN "sexologi" ; -- sexologi..nn.1
  sexpack_1_N = mkN "sexpack" ; -- sexpack..nn.1
  sexpartner_1_N = mkN "sexpartner" "sexpartnern" "sexpartners" "sexpartnersen" ; -- sexpartner..nn.1
  sexpartssamtal_1_N = mkN "sexpartssamtal" neutrum  ; -- sexpartssamtal..nn.1
  sexpipig_1_A = mkA "sexpipig" ; -- sexpipig..av.1
  sexradig_1_A = mkA "sexradig" ; -- sexradig..av.1
  sexrådgivare_1_N = mkN "sexrådgivare" utrum  ; -- sexrådgivare..nn.1
  sexsajt_1_N = mkN "sexsajt" "sexsajter" ; -- sexsajt..nn.1
  sexscen_1_N = mkN "sexscen" "sexscener" ; -- sexscen..nn.1
  sexsiffrig_1_A = mkA "sexsiffrig" ; -- sexsiffrig..av.1
  sexskandal_1_N = mkN "sexskandal" "sexskandaler" ; -- sexskandal..nn.1
  sexskämt_1_N = mkN "sexskämt" neutrum  ; -- sexskämt..nn.1
  sexslav_1_N = mkN "sexslav" ; -- sexslav..nn.1
  sexspann_1_N = mkN "sexspann" neutrum  ; -- sexspann..nn.1
  sexsymbol_1_N = mkN "sexsymbol" "sexsymboler" ; -- sexsymbol..nn.1
  sext_1_N = mkN "sext" "sexter" ; -- sext..nn.1
  sextant_1_N = mkN "sextant" "sextanter" ; -- sextant..nn.1
  sextett_1_N = mkN "sextett" "sextetter" ; -- sextett..nn.1
  sextifemte_1_A = mkA "sextifemte" ; -- sextifemte..av.1
  sextifemårsdag_1_N = mkN "sextifemårsdag" ; -- sextifemårsdag..nn.1
  sextinionde_1_A = mkA "sextinionde" ; -- sextinionde..av.1
  sextiofemte_1_A = mkA "sextiofemte" ; -- sextiofemte..av.1
  sextiofemårsdag_1_N = mkN "sextiofemårsdag" ; -- sextiofemårsdag..nn.1
  sextionde_1_A = mkA "sextionde" ; -- sextionde..av.1
  sextiondedel_1_N = mkN "sextiondedel" "sextiondedelen" "sextiondedelar" "sextiondedelarna" ; -- sextiondedel..nn.1
  sextiondel_1_N = mkN "sextiondel" "sextiondelen" "sextiondelar" "sextiondelarna" ; -- sextiondel..nn.1
  sextionionde_1_A = mkA "sextionionde" ; -- sextionionde..av.1
  sextiotal_1_N = mkN "sextiotal" neutrum  ; -- sextiotal..nn.1
  sextioårsdag_1_N = mkN "sextioårsdag" ; -- sextioårsdag..nn.1
  sextioårsjubileum_1_N = mkN "sextioårsjubileum" "sextioårsjubileet" "sextioårsjubileer" "sextioårsjubileerna" ; -- sextioårsjubileum..nn.1
  sextital_1_N = mkN "sextital" neutrum  ; -- sextital..nn.1
  sextiårsdag_1_N = mkN "sextiårsdag" ; -- sextiårsdag..nn.1
  sextiårsjubileum_1_N = mkN "sextiårsjubileum" "sextiårsjubileet" "sextiårsjubileer" "sextiårsjubileerna" ; -- sextiårsjubileum..nn.1
  sextjänst_1_N = mkN "sextjänst" "sextjänster" ; -- sextjänst..nn.1
  sextol_1_N = mkN "sextol" "sextoler" ; -- sextol..nn.1
  sextonde_1_A = mkA "sextonde" ; -- sextonde..av.1
  sextonhundratal_1_N = mkN "sextonhundratal" neutrum  ; -- sextonhundratal..nn.1
  sextonårig_1_A = mkA "sextonårig" ; -- sextonårig..av.1
  sextonåring_1_N = mkN "sextonåring" ; -- sextonåring..nn.1
  sextrakasseri_1_N = mkN "sextrakasseri" "sextrakasseriet" "sextrakasserier" "sextrakasserierna" ; -- sextrakasseri..nn.1
  sextumsspik_1_N = mkN "sextumsspik" ; -- sextumsspik..nn.1
  sexturism_1_N = mkN "sexturism" "sexturismer" ; -- sexturism..nn.1
  sexualakt_1_N = mkN "sexualakt" "sexualakter" ; -- sexualakt..nn.1
  sexualbrott_1_N = mkN "sexualbrott" neutrum  ; -- sexualbrott..nn.1
  sexualcykel_1_N = mkN "sexualcykel" ; -- sexualcykel..nn.1
  sexualdrift_1_N = mkN "sexualdrift" "sexualdrifter" ; -- sexualdrift..nn.1
  sexualdåre_1_N = mkN "sexualdåre" utrum  ; -- sexualdåre..nn.1
  sexualia_1_N = mkN "sexualia" "sexualian" "sexualia" "sexualiana" ; -- sexualia..nn.1
  sexualisera_1_V = mkV "sexualiserar" ; -- sexualisera..vb.1
  sexualiserande_1_N = mkN "sexualiserande" ; -- sexualiserande..nn.1
  sexualiserbar_1_A = mkA "sexualiserbar" ; -- sexualiserbar..av.1
  sexualiserbarhet_1_N = mkN "sexualiserbarhet" ; -- sexualiserbarhet..nn.1
  sexualisering_1_N = mkN "sexualisering" ; -- sexualisering..nn.1
  sexualitet_1_N = mkN "sexualitet" ; -- sexualitet..nn.1
  sexualitet_2_N = mkN "sexualitet" "sexualiteter" ; -- sexualitet..nn.2
  sexualkunskap_1_N = mkN "sexualkunskap" ; -- sexualkunskap..nn.1
  sexualliv_1_N = mkN "sexualliv" neutrum  ; -- sexualliv..nn.1
  sexualmord_1_N = mkN "sexualmord" neutrum  ; -- sexualmord..nn.1
  sexualorgan_1_N = mkN "sexualorgan" neutrum  ; -- sexualorgan..nn.1
  sexualradikalitet_1_N = mkN "sexualradikalitet" ; -- sexualradikalitet..nn.1
  sexualsystem_1_N = mkN "sexualsystem" neutrum  ; -- sexualsystem..nn.1
  sexualupplysning_1_N = mkN "sexualupplysning" ; -- sexualupplysning..nn.1
  sexuell_1_A = mkA "sexuell" ; -- sexuell..av.1
  sexuologi_1_N = mkN "sexuologi" ; -- sexuologi..nn.1
  sexutnyttja_1_V = mkV "sexutnyttjar" ; -- sexutnyttja..vb.1
  sexutnyttjande_1_N = mkN "sexutnyttjande" ; -- sexutnyttjande..nn.1
  sexvägra_1_V = mkV "sexvägrar" ; -- sexvägra..vb.1
  sexvägrande_1_N = mkN "sexvägrande" ; -- sexvägrande..nn.1
  sexårig_1_A = mkA "sexårig" ; -- sexårig..av.1
  sexåring_1_N = mkN "sexåring" ; -- sexåring..nn.1
  sexårsperiod_1_N = mkN "sexårsperiod" "sexårsperioder" ; -- sexårsperiod..nn.1
  seychellier_1_N = mkN "seychellier" "seychelliern" "seychellier" "seychellierna" ; -- seychellier..nn.1
  seychellisk_1_A = mkA "seychellisk" ; -- seychellisk..av.1
  seychelliska_1_N = mkN "seychelliska" ; -- seychelliska..nn.1
  señor_1_N = mkN "señor" "señoren" "señorer" "señorerna" ; -- señor..nn.1
  señora_1_N = mkN "señora" ; -- señora..nn.1
  señorita_1_N = mkN "señorita" ; -- señorita..nn.1
  sfinkter_1_N = mkN "sfinkter" ; -- sfinkter..nn.1
  sfinx_1_N = mkN "sfinx" "sfinxer" ; -- sfinx..nn.1
  sfinxartad_1_A = mkA "sfinxartad" ; -- sfinxartad..av.1
  sfragistik_1_N = mkN "sfragistik" ; -- sfragistik..nn.1
  sfumato_1_N = mkN "sfumato" ; -- sfumato..nn.1
  sfär_1_N = mkN "sfär" "sfärer" ; -- sfär..nn.1
  sfärisk_1_A = mkA "sfärisk" ; -- sfärisk..av.1
  sfäroid_1_N = mkN "sfäroid" "sfäroider" ; -- sfäroid..nn.1
  sfärometer_1_N = mkN "sfärometer" ; -- sfärometer..nn.1
  sgraffito_1_N = mkN "sgraffito" ; -- sgraffito..nn.1
  shag_1_N = mkN "shag" ; -- shag..nn.1
  shah_1_N = mkN "shah" "shaher" ; -- shah..nn.1
  shaka_1_V = mkV "shakar" ; -- shaka..vb.1
  shakande_1_N = mkN "shakande" ; -- shakande..nn.1
  shake_1_N = mkN "shake" utrum  ; -- shake..nn.1
  shaker_1_N = mkN "shaker" ; -- shaker..nn.1
  shaman_1_N = mkN "shaman" "shamaner" ; -- shaman..nn.1
  shamanism_1_N = mkN "shamanism" "shamanismer" ; -- shamanism..nn.1
  shamponera_1_V = mkV "shamponerar" ; -- shamponera..vb.1
  shamponerande_1_N = mkN "shamponerande" ; -- shamponerande..nn.1
  shamponerbar_1_A = mkA "shamponerbar" ; -- shamponerbar..av.1
  shamponerbarhet_1_N = mkN "shamponerbarhet" ; -- shamponerbarhet..nn.1
  shamponering_1_N = mkN "shamponering" ; -- shamponering..nn.1
  shampoo_1_N = mkN "shampoo" "shampoot" "shampoon" "shampoona" ; -- shampoo..nn.1
  shanghaja_1_V = mkV "shanghajar" ; -- shanghaja..vb.1
  shanghajande_1_N = mkN "shanghajande" ; -- shanghajande..nn.1
  shanghajning_1_N = mkN "shanghajning" ; -- shanghajning..nn.1
  shantung_1_N = mkN "shantung" ; -- shantung..nn.1
  shanty_1_N = mkN "shanty" "shantyn" "shanties" "shantiesarna" ; -- shanty..nn.1
  shejk_1_N = mkN "shejk" "shejker" ; -- shejk..nn.1
  shelf_1_N = mkN "shelf" ; -- shelf..nn.1
  shelfis_1_N = mkN "shelfis" ; -- shelfis..nn.1
  shellack_1_N = mkN "shellack" neutrum  ; -- shellack..nn.1
  shelterdäck_1_N = mkN "shelterdäck" neutrum  ; -- shelterdäck..nn.1
  sheriff_1_N = mkN "sheriff" "sheriffer" ; -- sheriff..nn.1
  sherpa_1_N = mkN "sherpa" ; -- sherpa..nn.1
  shetlandsponny_1_N = mkN "shetlandsponny" "shetlandsponnyn" "shetlandsponnysar" "shetlandsponnysarna" ; -- shetlandsponny..nn.1
  shetlandströja_1_N = mkN "shetlandströja" ; -- shetlandströja..nn.1
  shetlandsull_1_N = mkN "shetlandsull" ; -- shetlandsull..nn.1
  shetländsk_1_A = mkA "shetländsk" ; -- shetländsk..av.1
  shia_1_N = mkN "shia" ; -- shia..nn.1
  shiaarabisk_1_A = mkA "shiaarabisk" ; -- shiaarabisk..av.1
  shiamuslim_1_N = mkN "shiamuslim" "shiamuslimer" ; -- shiamuslim..nn.1
  shiamuslimsk_1_A = mkA "shiamuslimsk" ; -- shiamuslimsk..av.1
  shiit_1_N = mkN "shiit" "shiiter" ; -- shiit..nn.1
  shiitisk_1_A = mkA "shiitisk" ; -- shiitisk..av.1
  shilling_1_N = mkN "shilling" "shillingen" "shillings" "shillingsen" ; -- shilling..nn.1
  shingel_1_N = mkN "shingel" ; -- shingel..nn.1
  shingla_1_V = mkV "shinglar" ; -- shingla..vb.1
  shinglande_1_N = mkN "shinglande" ; -- shinglande..nn.1
  shintoism_1_N = mkN "shintoism" "shintoismer" ; -- shintoism..nn.1
  shintoistisk_1_A = mkA "shintoistisk" ; -- shintoistisk..av.1
  shipping_1_N = mkN "shipping" ; -- shipping..nn.1
  shirting_1_N = mkN "shirting" ; -- shirting..nn.1
  shogun_1_N = mkN "shogun" "shogun" "shoguner" "shogunerna" ; -- shogun..nn.1
  shop_1_N = mkN "shop" ; -- shop..nn.1
  shoppa_1_V = mkV "shoppar" ; -- shoppa..vb.1
  shoppande_1_N = mkN "shoppande" ; -- shoppande..nn.1
  shopping_1_N = mkN "shopping" ; -- shopping..nn.1
  shoppingcenter_1_N = mkN "shoppingcenter" "shoppingcentret" "shoppingcentrer" "shoppingcentrerna" ; -- shoppingcenter..nn.1
  shoppingcentrum_1_N = mkN "shoppingcentrum" neutrum  ; -- shoppingcentrum..nn.1
  shoppinggalleria_1_N = mkN "shoppinggalleria" ; -- shoppinggalleria..nn.1
  shoppingrunda_1_N = mkN "shoppingrunda" ; -- shoppingrunda..nn.1
  shoppingsugen_1_A = mkA "shoppingsugen" ; -- shoppingsugen..av.1
  shoppingtur_1_N = mkN "shoppingtur" "shoppingturer" ; -- shoppingtur..nn.1
  shoppingvagn_1_N = mkN "shoppingvagn" ; -- shoppingvagn..nn.1
  shoppingväska_1_N = mkN "shoppingväska" ; -- shoppingväska..nn.1
  shorta_1_V = mkV "shortar" ; -- shorta..vb.1
  shortande_1_N = mkN "shortande" ; -- shortande..nn.1
  shorting_1_N = mkN "shorting" ; -- shorting..nn.1
  shortning_1_N = mkN "shortning" ; -- shortning..nn.1
  shot_1_N = mkN "shot" ; -- shot..nn.1
  shota_1_V = mkV "shotar" ; -- shota..vb.1
  shots_1_N = mkN "shots" ; -- shots..nn.1
  shotsa_1_V = mkV "shotsar" ; -- shotsa..vb.1
  shott_1_N = mkN "shott" ; -- shott..nn.1
  shotta_1_V = mkV "shottar" ; -- shotta..vb.1
  show_1_N = mkN "show" "shower" ; -- show..nn.1
  showa_1_V = mkV "showar" ; -- showa..vb.1
  showande_1_N = mkN "showande" ; -- showande..nn.1
  showbiz_1_N = mkN "showbiz" ; -- showbiz..nn.1
  showdrill_1_N = mkN "showdrill" ; -- showdrill..nn.1
  showmässig_1_A = mkA "showmässig" ; -- showmässig..av.1
  showvärd_1_N = mkN "showvärd" ; -- showvärd..nn.1
  showvärdinna_1_N = mkN "showvärdinna" ; -- showvärdinna..nn.1
  shuffle_board_1_N = mkN "shuffle-board" neutrum  ; -- shuffle-board..nn.1
  shunt_1_N = mkN "shunt" ; -- shunt..nn.1
  shunta_1_V = mkV "shuntar" ; -- shunta..vb.1
  shuntande_1_N = mkN "shuntande" ; -- shuntande..nn.1
  shuntkoppling_1_N = mkN "shuntkoppling" ; -- shuntkoppling..nn.1
  shuntventil_1_N = mkN "shuntventil" "shuntventiler" ; -- shuntventil..nn.1
  sia_1_V = mkV "siar" ; -- sia..vb.1
  sial_1_N = mkN "sial" ; -- sial..nn.1
  siames_1_N = mkN "siames" "siameser" ; -- siames..nn.1
  siamesisk_1_A = mkA "siamesisk" ; -- siamesisk..av.1
  siameskatt_1_N = mkN "siameskatt" "siameskatter" ; -- siameskatt..nn.1
  siande_1_N = mkN "siande" ; -- siande..nn.1
  siare_1_N = mkN "siare" utrum  ; -- siare..nn.1
  sibet_1_N = mkN "sibet" "sibeter" ; -- sibet..nn.1
  sibetdjur_1_N = mkN "sibetdjur" neutrum  ; -- sibetdjur..nn.1
  sibetkatt_1_N = mkN "sibetkatt" "sibetkatter" ; -- sibetkatt..nn.1
  sibetolja_1_N = mkN "sibetolja" ; -- sibetolja..nn.1
  sibirier_1_N = mkN "sibirier" "sibiriern" "sibirier" "sibirierna" ; -- sibirier..nn.1
  sibirisk_1_A = mkA "sibirisk" ; -- sibirisk..av.1
  sibylla_1_N = mkN "sibylla" ; -- sibylla..nn.1
  sibyllinsk_1_A = mkA "sibyllinsk" ; -- sibyllinsk..av.1
  sic_1_Adv = mkAdv "sic" ; -- sic..ab.1
  sicilian_1_N = mkN "sicilian" "sicilianer" ; -- sicilian..nn.1
  sicilianare_1_N = mkN "sicilianare" utrum  ; -- sicilianare..nn.1
  siciliansk_1_A = mkA "siciliansk" ; -- siciliansk..av.1
  sicilianska_1_N = mkN "sicilianska" ; -- sicilianska..nn.1
  sick_1_N = mkN "sick" ; -- sick..nn.1
  sicka_1_V = mkV "sickar" ; -- sicka..vb.1
  sickande_1_N = mkN "sickande" ; -- sickande..nn.1
  sickativ_1_N = mkN "sickativ" neutrum  ; -- sickativ..nn.1
  sickel_1_N = mkN "sickel" ; -- sickel..nn.1
  sicken_1_A = mkA "sicken" ; -- sicken..av.1
  sickla_1_V = mkV "sicklar" ; -- sickla..vb.1
  sicklande_1_N = mkN "sicklande" ; -- sicklande..nn.1
  sicklecellsanemi_1_N = mkN "sicklecellsanemi" ; -- sicklecellsanemi..nn.1
  sickling_1_N = mkN "sickling" ; -- sickling..nn.1
  sicksack_1_N = mkN "sicksack" ; -- sicksack..nn.1
  sicksack_2_N = mkN "sicksack" ; -- sicksack..nn.2
  sicksacka_1_V = mkV "sicksackar" ; -- sicksacka..vb.1
  sicksacka_2_V = mkV "sicksackar" ; -- sicksacka..vb.2
  sicksackande_1_N = mkN "sicksackande" ; -- sicksackande..nn.1
  sid_1_A = mkA "sid" "sitt" ; -- sid..av.1
  sida_1_N = mkN "sida" ; -- sida..nn.1
  sidbena_1_N = mkN "sidbena" ; -- sidbena..nn.1
  sidbyte_1_N = mkN "sidbyte" ; -- sidbyte..nn.1
  sideboard_1_N = mkN "sideboard" neutrum  ; -- sideboard..nn.1
  siden_1_N = mkN "siden" neutrum  ; -- siden..nn.1
  sidenapa_1_N = mkN "sidenapa" ; -- sidenapa..nn.1
  sidenbyxa_1_N = mkN "sidenbyxa" ; -- sidenbyxa..nn.1
  sidendraperi_1_N = mkN "sidendraperi" "sidendraperiet" "sidendraperier" "sidendraperierna" ; -- sidendraperi..nn.1
  sidenkudde_1_N = mkN "sidenkudde" utrum  ; -- sidenkudde..nn.1
  sidenliknande_1_A = mkA "sidenliknande" ; -- sidenliknande..av.1
  sidennäsduk_1_N = mkN "sidennäsduk" ; -- sidennäsduk..nn.1
  sidenros_1_N = mkN "sidenros" "sidenrosor" ; -- sidenros..nn.1
  sidenskärm_1_N = mkN "sidenskärm" ; -- sidenskärm..nn.1
  sidensvans_1_N = mkN "sidensvans" ; -- sidensvans..nn.1
  sidenträ_1_N = mkN "sidenträ" neutrum  ; -- sidenträ..nn.1
  sidentyg_1_N = mkN "sidentyg" neutrum  ; -- sidentyg..nn.1
  sidenvit_1_A = mkA "sidenvit" ; -- sidenvit..av.1
  siderisk_1_A = mkA "siderisk" ; -- siderisk..av.1
  siderit_1_N = mkN "siderit" ; -- siderit..nn.1
  sideros_1_N = mkN "sideros" ; -- sideros..nn.1
  siderurgi_1_N = mkN "siderurgi" ; -- siderurgi..nn.1
  sidfläsk_1_N = mkN "sidfläsk" neutrum  ; -- sidfläsk..nn.1
  sidledes_1_Adv = mkAdv "sidledes" ; -- sidledes..ab.1
  sidlinje_1_N = mkN "sidlinje" "sidlinjer" ; -- sidlinje..nn.1
  sidländ_1_A = mkA "sidländ" ; -- sidländ..av.1
  sidlänt_1_A = mkA "sidlänt" "sidlänt" ; -- sidlänt..av.1
  sidnummer_1_N = mkN "sidnummer" neutrum  ; -- sidnummer..nn.1
  sidnumrera_1_V = mkV "sidnumrerar" ; -- sidnumrera..vb.1
  sidnumrerande_1_N = mkN "sidnumrerande" ; -- sidnumrerande..nn.1
  sidnumrerbar_1_A = mkA "sidnumrerbar" ; -- sidnumrerbar..av.1
  sidnumrerbarhet_1_N = mkN "sidnumrerbarhet" ; -- sidnumrerbarhet..nn.1
  sidnumrering_1_N = mkN "sidnumrering" ; -- sidnumrering..nn.1
  sidoaltare_1_N = mkN "sidoaltare" "sidoaltaret" "sidoaltaren" "sidoaltarna" ; -- sidoaltare..nn.1
  sidoapparat_1_N = mkN "sidoapparat" "sidoapparater" ; -- sidoapparat..nn.1
  sidoarv_1_N = mkN "sidoarv" neutrum  ; -- sidoarv..nn.1
  sidoarvinge_1_N = mkN "sidoarvinge" utrum  ; -- sidoarvinge..nn.1
  sidobana_1_N = mkN "sidobana" ; -- sidobana..nn.1
  sidobelysning_1_N = mkN "sidobelysning" ; -- sidobelysning..nn.1
  sidoblick_1_N = mkN "sidoblick" ; -- sidoblick..nn.1
  sidobord_1_N = mkN "sidobord" neutrum  ; -- sidobord..nn.1
  sidobyggnad_1_N = mkN "sidobyggnad" "sidobyggnader" ; -- sidobyggnad..nn.1
  sidodal_1_N = mkN "sidodal" ; -- sidodal..nn.1
  sidodäck_1_N = mkN "sidodäck" neutrum  ; -- sidodäck..nn.1
  sidodörr_1_N = mkN "sidodörr" ; -- sidodörr..nn.1
  sidoeffekt_1_N = mkN "sidoeffekt" "sidoeffekter" ; -- sidoeffekt..nn.1
  sidoentré_1_N = mkN "sidoentré" "sidoentréer" ; -- sidoentré..nn.1
  sidogalleri_1_N = mkN "sidogalleri" "sidogalleriet" "sidogallerier" "sidogallerierna" ; -- sidogalleri..nn.1
  sidogata_1_N = mkN "sidogata" ; -- sidogata..nn.1
  sidogevär_1_N = mkN "sidogevär" neutrum  ; -- sidogevär..nn.1
  sidogren_1_N = mkN "sidogren" "sidogrenen" "sidogrenar" "sidogrenarna" ; -- sidogren..nn.1
  sidogång_1_N = mkN "sidogång" ; -- sidogång..nn.1
  sidohandtag_1_N = mkN "sidohandtag" neutrum  ; -- sidohandtag..nn.1
  sidohänsyn_1_N = mkN "sidohänsyn" ; -- sidohänsyn..nn.1
  sidoinflytande_1_N = mkN "sidoinflytande" ; -- sidoinflytande..nn.1
  sidoingång_1_N = mkN "sidoingång" ; -- sidoingång..nn.1
  sidoinkomst_1_N = mkN "sidoinkomst" "sidoinkomster" ; -- sidoinkomst..nn.1
  sidojustering_1_N = mkN "sidojustering" ; -- sidojustering..nn.1
  sidokrockkudde_1_N = mkN "sidokrockkudde" utrum  ; -- sidokrockkudde..nn.1
  sidolanterna_1_N = mkN "sidolanterna" ; -- sidolanterna..nn.1
  sidolinje_1_N = mkN "sidolinje" "sidolinjer" ; -- sidolinje..nn.1
  sidolinjeorgan_1_N = mkN "sidolinjeorgan" neutrum  ; -- sidolinjeorgan..nn.1
  sidologe_1_N = mkN "sidologe" "sidologer" ; -- sidologe..nn.1
  sidoläge_1_N = mkN "sidoläge" ; -- sidoläge..nn.1
  sidoordnad_1_A = mkA "sidoordnad" ; -- sidoordnad..av.1
  sidoplan_1_N = mkN "sidoplan" neutrum  ; -- sidoplan..nn.1
  sidoroder_1_N = mkN "sidoroder" neutrum  ; -- sidoroder..nn.1
  sidorum_1_N = mkN "sidorum" "sidorummet" "sidorum" "sidorummen" ; -- sidorum..nn.1
  sidoruta_1_N = mkN "sidoruta" ; -- sidoruta..nn.1
  sidoskepp_1_N = mkN "sidoskepp" neutrum  ; -- sidoskepp..nn.1
  sidoskott_1_N = mkN "sidoskott" neutrum  ; -- sidoskott..nn.1
  sidosprång_1_N = mkN "sidosprång" neutrum  ; -- sidosprång..nn.1
  sidospår_1_N = mkN "sidospår" neutrum  ; -- sidospår..nn.1
  sidostycke_1_N = mkN "sidostycke" ; -- sidostycke..nn.1
  sidostöt_1_N = mkN "sidostöt" ; -- sidostöt..nn.1
  sidotema_1_N = mkN "sidotema" "sidotemat" "sidotemata" "sidotematana" ; -- sidotema..nn.1
  sidovapen_1_N = mkN "sidovapen" "sidovapnet" "sidovapen" "sidovapnen" ; -- sidovapen..nn.1
  sidovind_1_N = mkN "sidovind" ; -- sidovind..nn.1
  sidovinkel_1_N = mkN "sidovinkel" ; -- sidovinkel..nn.1
  sidoväg_1_N = mkN "sidoväg" ; -- sidoväg..nn.1
  sidovägg_1_N = mkN "sidovägg" ; -- sidovägg..nn.1
  sidroder_1_N = mkN "sidroder" neutrum  ; -- sidroder..nn.1
  sidskruv_1_N = mkN "sidskruv" ; -- sidskruv..nn.1
  sidsteppa_1_V = mkV "sidsteppar" ; -- sidsteppa..vb.1
  sidsteppande_1_N = mkN "sidsteppande" ; -- sidsteppande..nn.1
  sidvagn_1_N = mkN "sidvagn" ; -- sidvagn..nn.1
  sidvall_1_N = mkN "sidvall" ; -- sidvall..nn.1
  sidvind_1_N = mkN "sidvind" ; -- sidvind..nn.1
  sidvördnad_1_N = mkN "sidvördnad" "sidvördnader" ; -- sidvördnad..nn.1
  siemens_1_N = mkN "siemens" "siemensen" "siemens" "siemensen" ; -- siemens..nn.1
  siena_1_N = mkN "siena" ; -- siena..nn.1
  sierraleonier_1_N = mkN "sierraleonier" "sierraleoniern" "sierraleonier" "sierraleonierna" ; -- sierraleonier..nn.1
  sierraleonsk_1_A = mkA "sierraleonsk" ; -- sierraleonsk..av.1
  sierraleonska_1_N = mkN "sierraleonska" ; -- sierraleonska..nn.1
  sierska_1_N = mkN "sierska" ; -- sierska..nn.1
  siesta_1_N = mkN "siesta" ; -- siesta..nn.1
  sievert_1_N = mkN "sievert" "sieverten" "sievert" "sieverten" ; -- sievert..nn.1
  sifferbetyg_1_N = mkN "sifferbetyg" neutrum  ; -- sifferbetyg..nn.1
  sifferblind_1_A = mkA "sifferblind" ; -- sifferblind..av.1
  sifferblindhet_1_N = mkN "sifferblindhet" ; -- sifferblindhet..nn.1
  sifferföljd_1_N = mkN "sifferföljd" "sifferföljder" ; -- sifferföljd..nn.1
  sifferkarl_1_N = mkN "sifferkarl" ; -- sifferkarl..nn.1
  sifferkolumn_1_N = mkN "sifferkolumn" "sifferkolumner" ; -- sifferkolumn..nn.1
  sifferkombination_1_N = mkN "sifferkombination" ; -- sifferkombination..nn.1
  sifferminne_1_N = mkN "sifferminne" ; -- sifferminne..nn.1
  siffermässig_1_A = mkA "siffermässig" ; -- siffermässig..av.1
  sifferpussel_1_N = mkN "sifferpussel" neutrum  ; -- sifferpussel..nn.1
  sifferräkning_1_N = mkN "sifferräkning" ; -- sifferräkning..nn.1
  sifferstans_1_N = mkN "sifferstans" ; -- sifferstans..nn.1
  siffersumma_1_N = mkN "siffersumma" ; -- siffersumma..nn.1
  siffertavla_1_N = mkN "siffertavla" ; -- siffertavla..nn.1
  siffertips_1_N = mkN "siffertips" neutrum  ; -- siffertips..nn.1
  sifferuppgift_1_N = mkN "sifferuppgift" "sifferuppgifter" ; -- sifferuppgift..nn.1
  siffra_1_N = mkN "siffra" ; -- siffra..nn.1
  sifon_1_N = mkN "sifon" "sifoner" ; -- sifon..nn.1
  sifoundersökning_1_N = mkN "sifoundersökning" ; -- sifoundersökning..nn.1
  sigel_1_N = mkN "sigel" "sigeln" "sigler" "siglerna" ; -- sigel..nn.1
  sightseeing_1_N = mkN "sightseeing" ; -- sightseeing..nn.1
  sightseeingmål_1_N = mkN "sightseeingmål" neutrum  ; -- sightseeingmål..nn.1
  sigill_1_N = mkN "sigill" neutrum  ; -- sigill..nn.1
  sigillbevarare_1_N = mkN "sigillbevarare" utrum  ; -- sigillbevarare..nn.1
  sigillera_1_V = mkV "sigillerar" ; -- sigillera..vb.1
  sigillerande_1_N = mkN "sigillerande" ; -- sigillerande..nn.1
  sigillerbar_1_A = mkA "sigillerbar" ; -- sigillerbar..av.1
  sigillerbarhet_1_N = mkN "sigillerbarhet" ; -- sigillerbarhet..nn.1
  sigillering_1_N = mkN "sigillering" ; -- sigillering..nn.1
  sigillografi_1_N = mkN "sigillografi" ; -- sigillografi..nn.1
  sigillring_1_N = mkN "sigillring" ; -- sigillring..nn.1
  sigillstamp_1_N = mkN "sigillstamp" ; -- sigillstamp..nn.1
  sigillstämpel_1_N = mkN "sigillstämpel" ; -- sigillstämpel..nn.1
  sigma_1_N = mkN "sigma" "sigmat" "sigman" "sigmana" ; -- sigma..nn.1
  signa_1_V = mkV "signar" ; -- signa..vb.1
  signal_1_N = mkN "signal" "signaler" ; -- signal..nn.1
  signalbana_1_N = mkN "signalbana" ; -- signalbana..nn.1
  signalbloss_1_N = mkN "signalbloss" neutrum  ; -- signalbloss..nn.1
  signalbok_1_N = mkN "signalbok" "signalböcker" ; -- signalbok..nn.1
  signalduk_1_N = mkN "signalduk" ; -- signalduk..nn.1
  signaleld_1_N = mkN "signaleld" ; -- signaleld..nn.1
  signalement_1_N = mkN "signalement" neutrum  ; -- signalement..nn.1
  signalera_1_V = mkV "signalerar" ; -- signalera..vb.1
  signalera_2_V = mkV "signalerar" ; -- signalera..vb.2
  signalerande_1_N = mkN "signalerande" ; -- signalerande..nn.1
  signalerbar_1_A = mkA "signalerbar" ; -- signalerbar..av.1
  signalerbarhet_1_N = mkN "signalerbarhet" ; -- signalerbarhet..nn.1
  signalering_1_N = mkN "signalering" ; -- signalering..nn.1
  signalflagga_1_N = mkN "signalflagga" ; -- signalflagga..nn.1
  signalhastighet_1_N = mkN "signalhastighet" "signalhastigheter" ; -- signalhastighet..nn.1
  signalhorn_1_N = mkN "signalhorn" neutrum  ; -- signalhorn..nn.1
  signalist_1_N = mkN "signalist" "signalister" ; -- signalist..nn.1
  signalkräfta_1_N = mkN "signalkräfta" ; -- signalkräfta..nn.1
  signalmönster_1_N = mkN "signalmönster" neutrum  ; -- signalmönster..nn.1
  signalpistol_1_N = mkN "signalpistol" "signalpistoler" ; -- signalpistol..nn.1
  signalreglerad_1_A = mkA "signalreglerad" ; -- signalreglerad..av.1
  signalrött_1_N = mkN "signalrött" ; -- signalrött..nn.1
  signalskydd_1_N = mkN "signalskydd" neutrum  ; -- signalskydd..nn.1
  signalspade_1_N = mkN "signalspade" utrum  ; -- signalspade..nn.1
  signalspana_1_V = mkV "signalspanar" ; -- signalspana..vb.1
  signalspanande_1_N = mkN "signalspanande" ; -- signalspanande..nn.1
  signalspaning_1_N = mkN "signalspaning" ; -- signalspaning..nn.1
  signalspaningsmyndighet_1_N = mkN "signalspaningsmyndighet" "signalspaningsmyndigheter" ; -- signalspaningsmyndighet..nn.1
  signalställ_1_N = mkN "signalställ" neutrum  ; -- signalställ..nn.1
  signalsubstans_1_N = mkN "signalsubstans" "signalsubstanser" ; -- signalsubstans..nn.1
  signaltjänst_1_N = mkN "signaltjänst" ; -- signaltjänst..nn.1
  signaltrupp_1_N = mkN "signaltrupp" "signaltrupper" ; -- signaltrupp..nn.1
  signalur_1_N = mkN "signalur" neutrum  ; -- signalur..nn.1
  signalöverföring_1_N = mkN "signalöverföring" ; -- signalöverföring..nn.1
  signande_1_N = mkN "signande" ; -- signande..nn.1
  signatur_1_N = mkN "signatur" "signaturer" ; -- signatur..nn.1
  signaturmelodi_1_N = mkN "signaturmelodi" "signaturmelodier" ; -- signaturmelodi..nn.1
  signaturmässig_1_A = mkA "signaturmässig" ; -- signaturmässig..av.1
  signatär_1_N = mkN "signatär" "signatärer" ; -- signatär..nn.1
  signatärmakt_1_N = mkN "signatärmakt" "signatärmakter" ; -- signatärmakt..nn.1
  signelse_1_N = mkN "signelse" "signelser" ; -- signelse..nn.1
  signera_1_V = mkV "signerar" ; -- signera..vb.1
  signerande_1_N = mkN "signerande" ; -- signerande..nn.1
  signerbar_1_A = mkA "signerbar" ; -- signerbar..av.1
  signerbarhet_1_N = mkN "signerbarhet" ; -- signerbarhet..nn.1
  signeri_1_N = mkN "signeri" "signeriet" "signerier" "signerierna" ; -- signeri..nn.1
  signering_1_N = mkN "signering" ; -- signering..nn.1
  signet_1_N = mkN "signet" neutrum  ; -- signet..nn.1
  signetring_1_N = mkN "signetring" ; -- signetring..nn.1
  signifikans_1_N = mkN "signifikans" "signifikanser" ; -- signifikans..nn.1
  signifikansprövning_1_N = mkN "signifikansprövning" ; -- signifikansprövning..nn.1
  signifikant_1_A = mkA "signifikant" "signifikant" ; -- signifikant..av.1
  signifikativ_1_A = mkA "signifikativ" ; -- signifikativ..av.1
  signor_1_N = mkN "signor" "signoren" "signorer" "signorerna" ; -- signor..nn.1
  signora_1_N = mkN "signora" ; -- signora..nn.1
  signorina_1_N = mkN "signorina" ; -- signorina..nn.1
  signum_1_N = mkN "signum" neutrum  ; -- signum..nn.1
  sik_1_N = mkN "sik" ; -- sik..nn.1
  sikahjort_1_N = mkN "sikahjort" ; -- sikahjort..nn.1
  sikel_1_N = mkN "sikel" ; -- sikel..nn.1
  sikh_1_N = mkN "sikh" "sikher" ; -- sikh..nn.1
  sikhisk_1_A = mkA "sikhisk" ; -- sikhisk..av.1
  siklöja_1_N = mkN "siklöja" ; -- siklöja..nn.1
  sikt_1_N = mkN "sikt" ; -- sikt..nn.1
  sikt_2_N = mkN "sikt" ; -- sikt..nn.2
  sikta_1_V = mkV "siktar" ; -- sikta..vb.1
  sikta_2_V = mkV "siktar" ; -- sikta..vb.2
  siktande_1_N = mkN "siktande" ; -- siktande..nn.1
  siktbar_1_A = mkA "siktbar" ; -- siktbar..av.1
  siktbarhet_1_N = mkN "siktbarhet" ; -- siktbarhet..nn.1
  siktbröd_1_N = mkN "siktbröd" neutrum  ; -- siktbröd..nn.1
  siktdjup_1_N = mkN "siktdjup" neutrum  ; -- siktdjup..nn.1
  siktduk_1_N = mkN "siktduk" ; -- siktduk..nn.1
  sikte_1_N = mkN "sikte" ; -- sikte..nn.1
  siktförbättring_1_N = mkN "siktförbättring" ; -- siktförbättring..nn.1
  siktförsämring_1_N = mkN "siktförsämring" ; -- siktförsämring..nn.1
  siktig_1_A = mkA "siktig" ; -- siktig..av.1
  siktighet_1_N = mkN "siktighet" ; -- siktighet..nn.1
  siktkaka_1_N = mkN "siktkaka" ; -- siktkaka..nn.1
  siktlinje_1_N = mkN "siktlinje" "siktlinjer" ; -- siktlinje..nn.1
  siktmjöl_1_N = mkN "siktmjöl" neutrum  ; -- siktmjöl..nn.1
  siktning_1_N = mkN "siktning" ; -- siktning..nn.1
  siktram_1_N = mkN "siktram" ; -- siktram..nn.1
  siktruta_1_N = mkN "siktruta" ; -- siktruta..nn.1
  siktskåra_1_N = mkN "siktskåra" ; -- siktskåra..nn.1
  siktsträcka_1_N = mkN "siktsträcka" ; -- siktsträcka..nn.1
  sil_1_N = mkN "sil" ; -- sil..nn.1
  sila_1_V = mkV "silar" ; -- sila..vb.1
  sila_2_V = mkV "silar" ; -- sila..vb.2
  silande_1_N = mkN "silande" ; -- silande..nn.1
  silben_1_N = mkN "silben" neutrum  ; -- silben..nn.1
  silduk_1_N = mkN "silduk" ; -- silduk..nn.1
  silen_1_N = mkN "silen" "silener" ; -- silen..nn.1
  sileshår_1_N = mkN "sileshår" neutrum  ; -- sileshår..nn.1
  silhuett_1_N = mkN "silhuett" "silhuetter" ; -- silhuett..nn.1
  silhuettera_1_V = mkV "silhuetterar" ; -- silhuettera..vb.1
  silhuetterande_1_N = mkN "silhuetterande" ; -- silhuetterande..nn.1
  silhuetterbar_1_A = mkA "silhuetterbar" ; -- silhuetterbar..av.1
  silhuetterbarhet_1_N = mkN "silhuetterbarhet" ; -- silhuetterbarhet..nn.1
  silhuettering_1_N = mkN "silhuettering" ; -- silhuettering..nn.1
  silicium_1_N = mkN "silicium" neutrum  ; -- silicium..nn.1
  silikat_1_N = mkN "silikat" neutrum  ; -- silikat..nn.1
  silikon_1_N = mkN "silikon" neutrum  ; -- silikon..nn.1
  silikonbröst_1_N = mkN "silikonbröst" neutrum  ; -- silikonbröst..nn.1
  silikonimplantat_1_N = mkN "silikonimplantat" neutrum  ; -- silikonimplantat..nn.1
  silikonlist_1_N = mkN "silikonlist" "silikonlister" ; -- silikonlist..nn.1
  silikos_1_N = mkN "silikos" ; -- silikos..nn.1
  silke_1_N = mkN "silke" ; -- silke..nn.1
  silkeapa_1_N = mkN "silkeapa" ; -- silkeapa..nn.1
  silkegarn_1_N = mkN "silkegarn" neutrum  ; -- silkegarn..nn.1
  silkepapper_1_N = mkN "silkepapper" neutrum  ; -- silkepapper..nn.1
  silkesapa_1_N = mkN "silkesapa" ; -- silkesapa..nn.1
  silkesatlas_1_N = mkN "silkesatlas" ; -- silkesatlas..nn.1
  silkesband_1_N = mkN "silkesband" neutrum  ; -- silkesband..nn.1
  silkesbehå_1_N = mkN "silkesbehå" ; -- silkesbehå..nn.1
  silkesbomull_1_N = mkN "silkesbomull" ; -- silkesbomull..nn.1
  silkesfjäril_1_N = mkN "silkesfjäril" ; -- silkesfjäril..nn.1
  silkeshare_1_N = mkN "silkeshare" "silkesharar" ; -- silkeshare..nn.1
  silkeskanin_1_N = mkN "silkeskanin" "silkeskaniner" ; -- silkeskanin..nn.1
  silkeskokong_1_N = mkN "silkeskokong" "silkeskokonger" ; -- silkeskokong..nn.1
  silkeslarv_1_N = mkN "silkeslarv" "silkeslarver" ; -- silkeslarv..nn.1
  silkeslen_1_A = mkA "silkeslen" "silkeslent" ; -- silkeslen..av.1
  silkesmask_1_N = mkN "silkesmask" ; -- silkesmask..nn.1
  silkesnöre_1_N = mkN "silkesnöre" ; -- silkesnöre..nn.1
  silkesodling_1_N = mkN "silkesodling" ; -- silkesodling..nn.1
  silkespapper_1_N = mkN "silkespapper" neutrum  ; -- silkespapper..nn.1
  silkespinnare_1_N = mkN "silkespinnare" utrum  ; -- silkespinnare..nn.1
  silkessnöre_1_N = mkN "silkessnöre" ; -- silkessnöre..nn.1
  silkesspinnare_1_N = mkN "silkesspinnare" utrum  ; -- silkesspinnare..nn.1
  silkesstickad_1_A = mkA "silkesstickad" ; -- silkesstickad..av.1
  silkesstrumpa_1_N = mkN "silkesstrumpa" ; -- silkesstrumpa..nn.1
  silkestickad_1_A = mkA "silkestickad" ; -- silkestickad..av.1
  silkestrumpa_1_N = mkN "silkestrumpa" ; -- silkestrumpa..nn.1
  silkestråd_1_N = mkN "silkestråd" ; -- silkestråd..nn.1
  silketass_1_N = mkN "silketass" ; -- silketass..nn.1
  silkig_1_A = mkA "silkig" ; -- silkig..av.1
  silkighet_1_N = mkN "silkighet" ; -- silkighet..nn.1
  sill_1_N = mkN "sill" ; -- sill..nn.1
  sillavfall_1_N = mkN "sillavfall" neutrum  ; -- sillavfall..nn.1
  sillbit_1_N = mkN "sillbit" ; -- sillbit..nn.1
  sillblixt_1_N = mkN "sillblixt" ; -- sillblixt..nn.1
  sillbricka_1_N = mkN "sillbricka" ; -- sillbricka..nn.1
  sillbulle_1_N = mkN "sillbulle" utrum  ; -- sillbulle..nn.1
  sillfilé_1_N = mkN "sillfilé" "sillfiléer" ; -- sillfilé..nn.1
  sillfrukost_1_N = mkN "sillfrukost" ; -- sillfrukost..nn.1
  sillgrissla_1_N = mkN "sillgrissla" ; -- sillgrissla..nn.1
  sillguano_1_N = mkN "sillguano" ; -- sillguano..nn.1
  sillhaj_1_N = mkN "sillhaj" ; -- sillhaj..nn.1
  sillinläggning_1_N = mkN "sillinläggning" ; -- sillinläggning..nn.1
  sillkung_1_N = mkN "sillkung" ; -- sillkung..nn.1
  sillmjöl_1_N = mkN "sillmjöl" neutrum  ; -- sillmjöl..nn.1
  sillmjölke_1_N = mkN "sillmjölke" utrum  ; -- sillmjölke..nn.1
  sillperiod_1_N = mkN "sillperiod" "sillperioder" ; -- sillperiod..nn.1
  sillpudding_1_N = mkN "sillpudding" ; -- sillpudding..nn.1
  sillrecept_1_N = mkN "sillrecept" neutrum  ; -- sillrecept..nn.1
  sillrätt_1_N = mkN "sillrätt" "sillrätter" ; -- sillrätt..nn.1
  sillsallad_1_N = mkN "sillsallad" "sillsallader" ; -- sillsallad..nn.1
  sillsallat_1_N = mkN "sillsallat" "sillsallater" ; -- sillsallat..nn.1
  sillstrypare_1_N = mkN "sillstrypare" utrum  ; -- sillstrypare..nn.1
  silltrut_1_N = mkN "silltrut" ; -- silltrut..nn.1
  sillval_1_N = mkN "sillval" ; -- sillval..nn.1
  sillvrakning_1_N = mkN "sillvrakning" ; -- sillvrakning..nn.1
  sillåda_1_N = mkN "sillåda" ; -- sillåda..nn.1
  silning_1_N = mkN "silning" ; -- silning..nn.1
  silo_1_N = mkN "silo" "silor" ; -- silo..nn.1
  silt_1_N = mkN "silt" ; -- silt..nn.1
  siluett_1_N = mkN "siluett" "siluetter" ; -- siluett..nn.1
  siluettera_1_V = mkV "siluetterar" ; -- siluettera..vb.1
  siluetterande_1_N = mkN "siluetterande" ; -- siluetterande..nn.1
  siluetterbar_1_A = mkA "siluetterbar" ; -- siluetterbar..av.1
  siluetterbarhet_1_N = mkN "siluetterbarhet" ; -- siluetterbarhet..nn.1
  siluettering_1_N = mkN "siluettering" ; -- siluettering..nn.1
  silur_1_N = mkN "silur" ; -- silur..nn.1
  silver_1_N = mkN "silver" ; -- silver..nn.1
  silver_2_N = mkN "silver" neutrum  ; -- silver..nn.2
  silver_3_N = mkN "silver" neutrum  ; -- silver..nn.3
  silverbeslag_1_N = mkN "silverbeslag" neutrum  ; -- silverbeslag..nn.1
  silverblad_1_N = mkN "silverblad" neutrum  ; -- silverblad..nn.1
  silverblond_1_A = mkA "silverblond" ; -- silverblond..av.1
  silverblondhet_1_N = mkN "silverblondhet" ; -- silverblondhet..nn.1
  silverblänkande_1_A = mkA "silverblänkande" ; -- silverblänkande..av.1
  silverbromid_1_N = mkN "silverbromid" ; -- silverbromid..nn.1
  silverbrudpar_1_N = mkN "silverbrudpar" neutrum  ; -- silverbrudpar..nn.1
  silverbröllop_1_N = mkN "silverbröllop" neutrum  ; -- silverbröllop..nn.1
  silverbägare_1_N = mkN "silverbägare" utrum  ; -- silverbägare..nn.1
  silverbåge_1_N = mkN "silverbåge" utrum  ; -- silverbåge..nn.1
  silverfasan_1_N = mkN "silverfasan" "silverfasaner" ; -- silverfasan..nn.1
  silverfat_1_N = mkN "silverfat" neutrum  ; -- silverfat..nn.1
  silverfemma_1_N = mkN "silverfemma" ; -- silverfemma..nn.1
  silverfisk_1_N = mkN "silverfisk" ; -- silverfisk..nn.1
  silverfolie_1_N = mkN "silverfolie" "silverfolier" ; -- silverfolie..nn.1
  silverfärgad_1_A = mkA "silverfärgad" ; -- silverfärgad..av.1
  silverföremål_1_N = mkN "silverföremål" neutrum  ; -- silverföremål..nn.1
  silverglans_1_N = mkN "silverglans" ; -- silverglans..nn.1
  silverglänsande_1_A = mkA "silverglänsande" ; -- silverglänsande..av.1
  silvergran_1_N = mkN "silvergran" ; -- silvergran..nn.1
  silvergrogg_1_N = mkN "silvergrogg" ; -- silvergrogg..nn.1
  silvergruva_1_N = mkN "silvergruva" ; -- silvergruva..nn.1
  silvergrå_1_A = mkA "silvergrå" "silvergrått" ; -- silvergrå..av.1
  silverhalt_1_N = mkN "silverhalt" "silverhalter" ; -- silverhalt..nn.1
  silverhaltig_1_A = mkA "silverhaltig" ; -- silverhaltig..av.1
  silverhår_1_N = mkN "silverhår" neutrum  ; -- silverhår..nn.1
  silverhårig_1_A = mkA "silverhårig" ; -- silverhårig..av.1
  silverinfatta_1_V = mkV "silverinfattar" ; -- silverinfatta..vb.1
  silverinfattande_1_N = mkN "silverinfattande" ; -- silverinfattande..nn.1
  silverklang_1_N = mkN "silverklang" ; -- silverklang..nn.1
  silverklar_1_A = mkA "silverklar" ; -- silverklar..av.1
  silverklorid_1_N = mkN "silverklorid" ; -- silverklorid..nn.1
  silverlejon_1_N = mkN "silverlejon" neutrum  ; -- silverlejon..nn.1
  silverliknande_1_A = mkA "silverliknande" ; -- silverliknande..av.1
  silverlock_1_N = mkN "silverlock" ; -- silverlock..nn.1
  silvermagister_1_N = mkN "silvermagister" ; -- silvermagister..nn.1
  silvermedalj_1_N = mkN "silvermedalj" "silvermedaljer" ; -- silvermedalj..nn.1
  silvermedaljör_1_N = mkN "silvermedaljör" "silvermedaljörer" ; -- silvermedaljör..nn.1
  silvermynt_1_N = mkN "silvermynt" neutrum  ; -- silvermynt..nn.1
  silverne_1_A = mkA "silverne" ; -- silverne..av.1
  silvernitrat_1_N = mkN "silvernitrat" neutrum  ; -- silvernitrat..nn.1
  silverpeng_1_N = mkN "silverpeng" ; -- silverpeng..nn.1
  silverpenning_1_N = mkN "silverpenning" ; -- silverpenning..nn.1
  silverpokal_1_N = mkN "silverpokal" "silverpokaler" ; -- silverpokal..nn.1
  silverpoppel_1_N = mkN "silverpoppel" ; -- silverpoppel..nn.1
  silverprobering_1_N = mkN "silverprobering" ; -- silverprobering..nn.1
  silverputs_1_N = mkN "silverputs" ; -- silverputs..nn.1
  silverräv_1_N = mkN "silverräv" ; -- silverräv..nn.1
  silversalt_1_N = mkN "silversalt" "silversaltet" "silversalter" "silversalterna" ; -- silversalt..nn.1
  silverservis_1_N = mkN "silverservis" "silverserviser" ; -- silverservis..nn.1
  silversked_1_N = mkN "silversked" ; -- silversked..nn.1
  silverskimrande_1_A = mkA "silverskimrande" ; -- silverskimrande..av.1
  silverslev_1_N = mkN "silverslev" ; -- silverslev..nn.1
  silversmed_1_N = mkN "silversmed" "silversmeder" ; -- silversmed..nn.1
  silversmide_1_N = mkN "silversmide" ; -- silversmide..nn.1
  silverstickad_1_A = mkA "silverstickad" ; -- silverstickad..av.1
  silverstämma_1_N = mkN "silverstämma" ; -- silverstämma..nn.1
  silverstämpel_1_N = mkN "silverstämpel" ; -- silverstämpel..nn.1
  silvertacka_1_N = mkN "silvertacka" ; -- silvertacka..nn.1
  silverte_1_N = mkN "silverte" ; -- silverte..nn.1
  silvertejp_1_N = mkN "silvertejp" ; -- silvertejp..nn.1
  silvertråd_1_N = mkN "silvertråd" ; -- silvertråd..nn.1
  silvertärna_1_N = mkN "silvertärna" ; -- silvertärna..nn.1
  silvervitt_1_N = mkN "silvervitt" ; -- silvervitt..nn.1
  silvervåg_1_N = mkN "silvervåg" "silvervågor" ; -- silvervåg..nn.1
  silverört_1_N = mkN "silverört" ; -- silverört..nn.1
  silvra_1_V = mkV "silvrar" ; -- silvra..vb.1
  silvrad_1_A = mkA "silvrad" ; -- silvrad..av.1
  silvrande_1_N = mkN "silvrande" ; -- silvrande..nn.1
  silvrig_1_A = mkA "silvrig" ; -- silvrig..av.1
  silvrighet_1_N = mkN "silvrighet" ; -- silvrighet..nn.1
  sim_kort_1_N = mkN "sim-kort" neutrum  ; -- sim-kort..nn.1
  simand_1_N = mkN "simand" "simänder" ; -- simand..nn.1
  simbassäng_1_N = mkN "simbassäng" "simbassänger" ; -- simbassäng..nn.1
  simblåsa_1_N = mkN "simblåsa" ; -- simblåsa..nn.1
  simborgarmärke_1_N = mkN "simborgarmärke" ; -- simborgarmärke..nn.1
  simbyxa_1_N = mkN "simbyxa" ; -- simbyxa..nn.1
  simbälte_1_N = mkN "simbälte" ; -- simbälte..nn.1
  simdräkt_1_N = mkN "simdräkt" "simdräkter" ; -- simdräkt..nn.1
  simdyna_1_N = mkN "simdyna" ; -- simdyna..nn.1
  simfena_1_N = mkN "simfena" ; -- simfena..nn.1
  simflotte_1_N = mkN "simflotte" utrum  ; -- simflotte..nn.1
  simfot_1_N = mkN "simfot" "simfötter" ; -- simfot..nn.1
  simfågel_1_N = mkN "simfågel" ; -- simfågel..nn.1
  simhall_1_N = mkN "simhall" ; -- simhall..nn.1
  simhallstak_1_N = mkN "simhallstak" neutrum  ; -- simhallstak..nn.1
  simhopp_1_N = mkN "simhopp" neutrum  ; -- simhopp..nn.1
  simhud_1_N = mkN "simhud" ; -- simhud..nn.1
  simkandidat_1_N = mkN "simkandidat" "simkandidater" ; -- simkandidat..nn.1
  simklubb_1_N = mkN "simklubb" ; -- simklubb..nn.1
  simkonst_1_N = mkN "simkonst" "simkonster" ; -- simkonst..nn.1
  simkort_1_N = mkN "simkort" neutrum  ; -- simkort..nn.1
  simkunnig_1_A = mkA "simkunnig" ; -- simkunnig..av.1
  simkunnighet_1_N = mkN "simkunnighet" ; -- simkunnighet..nn.1
  simlärare_1_N = mkN "simlärare" utrum  ; -- simlärare..nn.1
  simma_1_V = mkV "simmar" ; -- simma..vb.1
  simmagister_1_N = mkN "simmagister" ; -- simmagister..nn.1
  simmande_1_N = mkN "simmande" ; -- simmande..nn.1
  simmare_1_N = mkN "simmare" utrum  ; -- simmare..nn.1
  simmig_1_A = mkA "simmig" ; -- simmig..av.1
  simmighet_1_N = mkN "simmighet" ; -- simmighet..nn.1
  simmärke_1_N = mkN "simmärke" ; -- simmärke..nn.1
  simning_1_N = mkN "simning" ; -- simning..nn.1
  simoni_1_N = mkN "simoni" ; -- simoni..nn.1
  simorgan_1_N = mkN "simorgan" neutrum  ; -- simorgan..nn.1
  simpa_1_N = mkN "simpa" ; -- simpa..nn.1
  simpel_1_A = mkA "simpel" ; -- simpel..av.1
  simpelhet_1_N = mkN "simpelhet" "simpelheter" ; -- simpelhet..nn.1
  simpelkort_1_N = mkN "simpelkort" neutrum  ; -- simpelkort..nn.1
  simplex_1_N = mkN "simplex" neutrum  ; -- simplex..nn.1
  simplexpåle_1_N = mkN "simplexpåle" utrum  ; -- simplexpåle..nn.1
  simplextelegrafi_1_N = mkN "simplextelegrafi" ; -- simplextelegrafi..nn.1
  simplextrafik_1_N = mkN "simplextrafik" ; -- simplextrafik..nn.1
  simplifiera_1_V = mkV "simplifierar" ; -- simplifiera..vb.1
  simplifierande_1_N = mkN "simplifierande" ; -- simplifierande..nn.1
  simplifierbar_1_A = mkA "simplifierbar" ; -- simplifierbar..av.1
  simplifierbarhet_1_N = mkN "simplifierbarhet" ; -- simplifierbarhet..nn.1
  simplifiering_1_N = mkN "simplifiering" ; -- simplifiering..nn.1
  simpromotion_1_N = mkN "simpromotion" ; -- simpromotion..nn.1
  simprov_1_N = mkN "simprov" neutrum  ; -- simprov..nn.1
  sims_1_N = mkN "sims" "simser" ; -- sims..nn.1
  simsa_1_V = mkV "simsar" ; -- simsa..vb.1
  simsande_1_N = mkN "simsande" ; -- simsande..nn.1
  simshyvel_1_N = mkN "simshyvel" ; -- simshyvel..nn.1
  simskola_1_N = mkN "simskola" ; -- simskola..nn.1
  simsnäppa_1_N = mkN "simsnäppa" ; -- simsnäppa..nn.1
  simsätt_1_N = mkN "simsätt" neutrum  ; -- simsätt..nn.1
  simtag_1_N = mkN "simtag" neutrum  ; -- simtag..nn.1
  simträning_1_N = mkN "simträning" ; -- simträning..nn.1
  simtur_1_N = mkN "simtur" "simturer" ; -- simtur..nn.1
  simtävling_1_N = mkN "simtävling" ; -- simtävling..nn.1
  simulant_1_N = mkN "simulant" "simulanter" ; -- simulant..nn.1
  simulation_1_N = mkN "simulation" ; -- simulation..nn.1
  simulator_1_N = mkN "simulator" "simulatorer" ; -- simulator..nn.1
  simulera_1_V = mkV "simulerar" ; -- simulera..vb.1
  simulerande_1_N = mkN "simulerande" ; -- simulerande..nn.1
  simulerbar_1_A = mkA "simulerbar" ; -- simulerbar..av.1
  simulerbarhet_1_N = mkN "simulerbarhet" ; -- simulerbarhet..nn.1
  simulering_1_N = mkN "simulering" ; -- simulering..nn.1
  simultan_1_A = mkA "simultan" ; -- simultan..av.1
  simultanism_1_N = mkN "simultanism" "simultanismer" ; -- simultanism..nn.1
  simultanscen_1_N = mkN "simultanscen" "simultanscener" ; -- simultanscen..nn.1
  simultanschack_1_N = mkN "simultanschack" neutrum  ; -- simultanschack..nn.1
  simultantolk_1_N = mkN "simultantolk" ; -- simultantolk..nn.1
  simultantolka_1_V = mkV "simultantolkar" ; -- simultantolka..vb.1
  simultantolkande_1_N = mkN "simultantolkande" ; -- simultantolkande..nn.1
  simultantolkning_1_N = mkN "simultantolkning" ; -- simultantolkning..nn.1
  sina_1_V = mkV "sinar" ; -- sina..vb.1
  sinande_1_N = mkN "sinande" ; -- sinande..nn.1
  sinder_1_N = mkN "sinder" neutrum  ; -- sinder..nn.1
  sinekur_1_N = mkN "sinekur" "sinekurer" ; -- sinekur..nn.1
  sinfonia_1_N = mkN "sinfonia" ; -- sinfonia..nn.1
  singales_1_N = mkN "singales" "singaleser" ; -- singales..nn.1
  singalesisk_1_A = mkA "singalesisk" ; -- singalesisk..av.1
  singalesiska_1_N = mkN "singalesiska" ; -- singalesiska..nn.1
  singalesiska_2_N = mkN "singalesiska" ; -- singalesiska..nn.2
  singaporian_1_N = mkN "singaporian" "singaporianer" ; -- singaporian..nn.1
  singaporianska_1_N = mkN "singaporianska" ; -- singaporianska..nn.1
  singel_1_N = mkN "singel" ; -- singel..nn.1
  singel_2_N = mkN "singel" ; -- singel..nn.2
  singelmamma_1_N = mkN "singelmamma" ; -- singelmamma..nn.1
  singelolycka_1_N = mkN "singelolycka" ; -- singelolycka..nn.1
  singelspel_1_N = mkN "singelspel" "singelspelet" "singelspel" "singelspelen" ; -- singelspel..nn.1
  singla_1_V = mkV "singlar" ; -- singla..vb.1
  singlande_1_N = mkN "singlande" ; -- singlande..nn.1
  singular_1_A = mkA "singular" ; -- singular..av.1
  singular_1_N = mkN "singular" "singularer" ; -- singular..nn.1
  singularis_1_N = mkN "singularis" ; -- singularis..nn.1
  singularitet_1_N = mkN "singularitet" "singulariteter" ; -- singularitet..nn.1
  singuljär_1_A = mkA "singuljär" ; -- singuljär..av.1
  singulär_1_A = mkA "singulär" ; -- singulär..av.1
  sinister_1_A = mkA "sinister" ; -- sinister..av.1
  sinisterhet_1_N = mkN "sinisterhet" ; -- sinisterhet..nn.1
  sink_1_N = mkN "sink" neutrum  ; -- sink..nn.1
  sinka_1_V = mkV "sinkar" ; -- sinka..vb.1
  sinkabirum_1_N = mkN "sinkabirum" ; -- sinkabirum..nn.1
  sinkadus_1_N = mkN "sinkadus" "sinkaduser" ; -- sinkadus..nn.1
  sinkande_1_N = mkN "sinkande" ; -- sinkande..nn.1
  sinkare_1_N = mkN "sinkare" utrum  ; -- sinkare..nn.1
  sinkning_1_N = mkN "sinkning" ; -- sinkning..nn.1
  sinnad_1_A = mkA "sinnad" ; -- sinnad..av.1
  sinne_1_N = mkN "sinne" ; -- sinne..nn.1
  sinnebild_1_N = mkN "sinnebild" "sinnebilder" ; -- sinnebild..nn.1
  sinnebildlig_1_A = mkA "sinnebildlig" ; -- sinnebildlig..av.1
  sinnelag_1_N = mkN "sinnelag" neutrum  ; -- sinnelag..nn.1
  sinnesanalogi_1_N = mkN "sinnesanalogi" "sinnesanalogier" ; -- sinnesanalogi..nn.1
  sinnesart_1_N = mkN "sinnesart" "sinnesarter" ; -- sinnesart..nn.1
  sinnescell_1_N = mkN "sinnescell" "sinnesceller" ; -- sinnescell..nn.1
  sinnesfrid_1_N = mkN "sinnesfrid" ; -- sinnesfrid..nn.1
  sinnesförfattning_1_N = mkN "sinnesförfattning" ; -- sinnesförfattning..nn.1
  sinnesförnimmelse_1_N = mkN "sinnesförnimmelse" "sinnesförnimmelser" ; -- sinnesförnimmelse..nn.1
  sinnesförvirrad_1_A = mkA "sinnesförvirrad" ; -- sinnesförvirrad..av.1
  sinnesförvirring_1_N = mkN "sinnesförvirring" ; -- sinnesförvirring..nn.1
  sinnesglädje_1_N = mkN "sinnesglädje" utrum  ; -- sinnesglädje..nn.1
  sinnesintryck_1_N = mkN "sinnesintryck" neutrum  ; -- sinnesintryck..nn.1
  sinneslugn_1_N = mkN "sinneslugn" neutrum  ; -- sinneslugn..nn.1
  sinnesnerv_1_N = mkN "sinnesnerv" "sinnesnerver" ; -- sinnesnerv..nn.1
  sinnesnärvaro_1_N = mkN "sinnesnärvaro" ; -- sinnesnärvaro..nn.1
  sinnesorgan_1_N = mkN "sinnesorgan" neutrum  ; -- sinnesorgan..nn.1
  sinnesoro_1_N = mkN "sinnesoro" ; -- sinnesoro..nn.1
  sinnesro_1_N = mkN "sinnesro" ; -- sinnesro..nn.1
  sinnesrubbad_1_A = mkA "sinnesrubbad" ; -- sinnesrubbad..av.1
  sinnesrubbning_1_N = mkN "sinnesrubbning" ; -- sinnesrubbning..nn.1
  sinnesrus_1_N = mkN "sinnesrus" neutrum  ; -- sinnesrus..nn.1
  sinnesrörelse_1_N = mkN "sinnesrörelse" "sinnesrörelser" ; -- sinnesrörelse..nn.1
  sinnessjuk_1_A = mkA "sinnessjuk" ; -- sinnessjuk..av.1
  sinnessjukdom_1_N = mkN "sinnessjukdom" ; -- sinnessjukdom..nn.1
  sinnessjukhet_1_N = mkN "sinnessjukhet" ; -- sinnessjukhet..nn.1
  sinnessjukhus_1_N = mkN "sinnessjukhus" neutrum  ; -- sinnessjukhus..nn.1
  sinnessjukläkare_1_N = mkN "sinnessjukläkare" utrum  ; -- sinnessjukläkare..nn.1
  sinnessjukvård_1_N = mkN "sinnessjukvård" ; -- sinnessjukvård..nn.1
  sinnesslö_1_A = mkA "sinnesslö" "sinnesslött" ; -- sinnesslö..av.1
  sinnesslöhet_1_N = mkN "sinnesslöhet" ; -- sinnesslöhet..nn.1
  sinnesstark_1_A = mkA "sinnesstark" ; -- sinnesstark..av.1
  sinnesstyrka_1_N = mkN "sinnesstyrka" ; -- sinnesstyrka..nn.1
  sinnesstämning_1_N = mkN "sinnesstämning" ; -- sinnesstämning..nn.1
  sinnessvag_1_A = mkA "sinnessvag" ; -- sinnessvag..av.1
  sinnessvaghet_1_N = mkN "sinnessvaghet" ; -- sinnessvaghet..nn.1
  sinnestillstånd_1_N = mkN "sinnestillstånd" neutrum  ; -- sinnestillstånd..nn.1
  sinnesundersökning_1_N = mkN "sinnesundersökning" ; -- sinnesundersökning..nn.1
  sinnesupplevelse_1_N = mkN "sinnesupplevelse" "sinnesupplevelser" ; -- sinnesupplevelse..nn.1
  sinnesvilla_1_N = mkN "sinnesvilla" ; -- sinnesvilla..nn.1
  sinnesändring_1_N = mkN "sinnesändring" ; -- sinnesändring..nn.1
  sinnevärld_1_N = mkN "sinnevärld" ; -- sinnevärld..nn.1
  sinnlig_1_A = mkA "sinnlig" ; -- sinnlig..av.1
  sinnlighet_1_N = mkN "sinnlighet" "sinnligheter" ; -- sinnlighet..nn.1
  sinnrik_1_A = mkA "sinnrik" ; -- sinnrik..av.1
  sinnrikhet_1_N = mkN "sinnrikhet" ; -- sinnrikhet..nn.1
  sinolog_1_N = mkN "sinolog" "sinologer" ; -- sinolog..nn.1
  sinologi_1_N = mkN "sinologi" ; -- sinologi..nn.1
  sinsemellan_1_Adv = mkAdv "sinsemellan" ; -- sinsemellan..ab.1
  sinter_1_N = mkN "sinter" ; -- sinter..nn.1
  sintra_1_V = mkV "sintrar" ; -- sintra..vb.1
  sintrande_1_N = mkN "sintrande" ; -- sintrande..nn.1
  sinuit_1_N = mkN "sinuit" "sinuiter" ; -- sinuit..nn.1
  sinus_1_N = mkN "sinus" ; -- sinus..nn.1
  sinusit_1_N = mkN "sinusit" "sinusiter" ; -- sinusit..nn.1
  sinuskurva_1_N = mkN "sinuskurva" ; -- sinuskurva..nn.1
  sinuston_1_N = mkN "sinuston" "sinustoner" ; -- sinuston..nn.1
  sinusvåg_1_N = mkN "sinusvåg" "sinusvågor" ; -- sinusvåg..nn.1
  sionism_1_N = mkN "sionism" "sionismer" ; -- sionism..nn.1
  sionist_1_N = mkN "sionist" "sionister" ; -- sionist..nn.1
  sionistisk_1_A = mkA "sionistisk" ; -- sionistisk..av.1
  sioux_1_N = mkN "sioux" "siouxer" ; -- sioux..nn.1
  sipp_1_A = mkA "sipp" ; -- sipp..av.1
  sippa_1_N = mkN "sippa" ; -- sippa..nn.1
  sipphet_1_N = mkN "sipphet" ; -- sipphet..nn.1
  sippra_1_V = mkV "sipprar" ; -- sippra..vb.1
  sipprande_1_N = mkN "sipprande" ; -- sipprande..nn.1
  sir_1_N = mkN "sir" neutrum  ; -- sir..nn.1
  sir_2_N = mkN "sir" ; -- sir..nn.2
  sira_1_V = mkV "sirar" ; -- sira..vb.1
  sirande_1_N = mkN "sirande" ; -- sirande..nn.1
  sirap_1_N = mkN "sirap" ; -- sirap..nn.1
  sirapslen_1_A = mkA "sirapslen" "sirapslent" ; -- sirapslen..av.1
  sirapsliknande_1_A = mkA "sirapsliknande" ; -- sirapsliknande..av.1
  sirapslimpa_1_N = mkN "sirapslimpa" ; -- sirapslimpa..nn.1
  sirapssöt_1_A = mkA "sirapssöt" ; -- sirapssöt..av.1
  sirapssöthet_1_N = mkN "sirapssöthet" ; -- sirapssöthet..nn.1
  sirat_1_N = mkN "sirat" "sirater" ; -- sirat..nn.1
  siratlig_1_A = mkA "siratlig" ; -- siratlig..av.1
  siratlighet_1_N = mkN "siratlighet" ; -- siratlighet..nn.1
  siren_1_N = mkN "siren" "sirener" ; -- siren..nn.1
  sirendjur_1_N = mkN "sirendjur" neutrum  ; -- sirendjur..nn.1
  sirensång_1_N = mkN "sirensång" ; -- sirensång..nn.1
  sirentjut_1_N = mkN "sirentjut" neutrum  ; -- sirentjut..nn.1
  sirlig_1_A = mkA "sirlig" ; -- sirlig..av.1
  sirlighet_1_N = mkN "sirlighet" "sirligheter" ; -- sirlighet..nn.1
  sirocko_1_N = mkN "sirocko" ; -- sirocko..nn.1
  sirp_1_N = mkN "sirp" neutrum  ; -- sirp..nn.1
  sirpa_1_V = mkV "sirpar" ; -- sirpa..vb.1
  sirpande_1_N = mkN "sirpande" ; -- sirpande..nn.1
  sirra_1_V = mkV "sirrar" ; -- sirra..vb.1
  sirrande_1_N = mkN "sirrande" ; -- sirrande..nn.1
  sis_1_N = mkN "sis" neutrum  ; -- sis..nn.1
  sisa_1_V = mkV "sisar" ; -- sisa..vb.1
  sisal_1_N = mkN "sisal" ; -- sisal..nn.1
  sisalhampa_1_N = mkN "sisalhampa" ; -- sisalhampa..nn.1
  sisande_1_N = mkN "sisande" ; -- sisande..nn.1
  sisel_1_N = mkN "sisel" ; -- sisel..nn.1
  siska_1_N = mkN "siska" ; -- siska..nn.1
  sista_minutenresa_1_N = mkN "sista-minutenresa" ; -- sista-minutenresa..nn.1
  sista_1_N = mkN "sista" ; -- sista..nn.1
  sistaårsstudent_1_N = mkN "sistaårsstudent" "sistaårsstudenter" ; -- sistaårsstudent..nn.1
  sisten_1_N = mkN "sisten" ; -- sisten..nn.1
  sistfödd_1_A = mkA "sistfödd" ; -- sistfödd..av.1
  sistkommande_1_A = mkA "sistkommande" ; -- sistkommande..av.1
  sistliden_1_A = mkA "sistliden" ; -- sistliden..av.1
  sistnämnd_1_A = mkA "sistnämnd" ; -- sistnämnd..av.1
  sisu_1_N = mkN "sisu" ; -- sisu..nn.1
  sisyfusarbete_1_N = mkN "sisyfusarbete" ; -- sisyfusarbete..nn.1
  sitar_1_N = mkN "sitar" "sitarer" ; -- sitar..nn.1
  sitcom_1_N = mkN "sitcom" "sitcommen" "sitcommar" "sitcommarna" ; -- sitcom..nn.1
  sitkom_1_N = mkN "sitkom" "sitkommen" "sitkommar" "sitkommarna" ; -- sitkom..nn.1
  sits_1_N = mkN "sits" ; -- sits..nn.1
  sitta_1_V = mkV "sitta" "satt" "suttit" ; -- sitta..vb.1
  sittande_1_N = mkN "sittande" ; -- sittande..nn.1
  sittbadkar_1_N = mkN "sittbadkar" neutrum  ; -- sittbadkar..nn.1
  sittben_1_N = mkN "sittben" neutrum  ; -- sittben..nn.1
  sittbrunn_1_N = mkN "sittbrunn" ; -- sittbrunn..nn.1
  sittbräda_1_N = mkN "sittbräda" ; -- sittbräda..nn.1
  sittbräde_1_N = mkN "sittbräde" ; -- sittbräde..nn.1
  sittdyna_1_N = mkN "sittdyna" ; -- sittdyna..nn.1
  sitter_1_N = mkN "sitter" ; -- sitter..nn.1
  sittfläsk_1_N = mkN "sittfläsk" neutrum  ; -- sittfläsk..nn.1
  sittgrupp_1_N = mkN "sittgrupp" "sittgrupper" ; -- sittgrupp..nn.1
  sittkudde_1_N = mkN "sittkudde" utrum  ; -- sittkudde..nn.1
  sittmöbel_1_N = mkN "sittmöbel" "sittmöbeln" "sittmöbler" "sittmöblerna" ; -- sittmöbel..nn.1
  sittning_1_N = mkN "sittning" ; -- sittning..nn.1
  sittopp_1_N = mkN "sittopp" ; -- sittopp..nn.1
  sittpinne_1_N = mkN "sittpinne" utrum  ; -- sittpinne..nn.1
  sittplats_1_N = mkN "sittplats" "sittplatser" ; -- sittplats..nn.1
  sittriktig_1_A = mkA "sittriktig" ; -- sittriktig..av.1
  sittriktighet_1_N = mkN "sittriktighet" ; -- sittriktighet..nn.1
  sittstrejk_1_N = mkN "sittstrejk" "sittstrejker" ; -- sittstrejk..nn.1
  sittstrejka_1_V = mkV "sittstrejkar" ; -- sittstrejka..vb.1
  sittstrejkande_1_N = mkN "sittstrejkande" ; -- sittstrejkande..nn.1
  sittställning_1_N = mkN "sittställning" ; -- sittställning..nn.1
  sittstång_1_N = mkN "sittstång" "sittstänger" ; -- sittstång..nn.1
  sittup_1_N = mkN "sittup" ; -- sittup..nn.1
  sittupa_1_V = mkV "sittupar" ; -- sittupa..vb.1
  sittupande_1_N = mkN "sittupande" ; -- sittupande..nn.1
  sittupp_1_N = mkN "sittupp" ; -- sittupp..nn.1
  sittuppa_1_V = mkV "sittuppar" ; -- sittuppa..vb.1
  sittuppande_1_N = mkN "sittuppande" ; -- sittuppande..nn.1
  sittvagn_1_N = mkN "sittvagn" ; -- sittvagn..nn.1
  sittvänlig_1_A = mkA "sittvänlig" ; -- sittvänlig..av.1
  sittvänlighet_1_N = mkN "sittvänlighet" ; -- sittvänlighet..nn.1
  situation_1_N = mkN "situation" ; -- situation..nn.1
  situationsbild_1_N = mkN "situationsbild" "situationsbilder" ; -- situationsbild..nn.1
  situationskomik_1_N = mkN "situationskomik" ; -- situationskomik..nn.1
  situationstecken_1_N = mkN "situationstecken" "situationstecknet" "situationstecken" "situationstecknen" ; -- situationstecken..nn.1
  situerad_1_A = mkA "situerad" ; -- situerad..av.1
  situp_1_N = mkN "situp" ; -- situp..nn.1
  situpa_1_V = mkV "situpar" ; -- situpa..vb.1
  situpande_1_N = mkN "situpande" ; -- situpande..nn.1
  situpp_1_N = mkN "situpp" ; -- situpp..nn.1
  situppa_1_V = mkV "situppar" ; -- situppa..vb.1
  situppande_1_N = mkN "situppande" ; -- situppande..nn.1
  sj_ljud_1_N = mkN "sj-ljud" neutrum  ; -- sj-ljud..nn.1
  sjabbel_1_N = mkN "sjabbel" neutrum  ; -- sjabbel..nn.1
  sjabbig_1_A = mkA "sjabbig" ; -- sjabbig..av.1
  sjabbighet_1_N = mkN "sjabbighet" ; -- sjabbighet..nn.1
  sjabbla_1_V = mkV "sjabblar" ; -- sjabbla..vb.1
  sjabblande_1_N = mkN "sjabblande" ; -- sjabblande..nn.1
  sjagg_1_N = mkN "sjagg" "sjagger" ; -- sjagg..nn.1
  sjajas_1_N = mkN "sjajas" ; -- sjajas..nn.1
  sjakal_1_N = mkN "sjakal" "sjakaler" ; -- sjakal..nn.1
  sjal_1_N = mkN "sjal" ; -- sjal..nn.1
  sjalett_1_N = mkN "sjalett" "sjaletter" ; -- sjalett..nn.1
  sjalkrage_1_N = mkN "sjalkrage" utrum  ; -- sjalkrage..nn.1
  sjana_1_N = mkN "sjana" ; -- sjana..nn.1
  sjangdobel_1_A = mkA "sjangdobel" ; -- sjangdobel..av.1
  sjanghaja_1_V = mkV "sjanghajar" ; -- sjanghaja..vb.1
  sjanghajande_1_N = mkN "sjanghajande" ; -- sjanghajande..nn.1
  sjanghajning_1_N = mkN "sjanghajning" ; -- sjanghajning..nn.1
  sjangsera_1_V = mkV "sjangserar" ; -- sjangsera..vb.1
  sjangserande_1_N = mkN "sjangserande" ; -- sjangserande..nn.1
  sjangsering_1_N = mkN "sjangsering" ; -- sjangsering..nn.1
  sjangtil_1_A = mkA "sjangtil" ; -- sjangtil..av.1
  sjapp_1_N = mkN "sjapp" neutrum  ; -- sjapp..nn.1
  sjappa_1_V = mkV "sjappar" ; -- sjappa..vb.1
  sjappande_1_N = mkN "sjappande" ; -- sjappande..nn.1
  sjasa_1_V = mkV "sjasar" ; -- sjasa..vb.1
  sjasande_1_N = mkN "sjasande" ; -- sjasande..nn.1
  sjaska_1_V = mkV "sjaskar" ; -- sjaska..vb.1
  sjaskande_1_N = mkN "sjaskande" ; -- sjaskande..nn.1
  sjasker_1_N = mkN "sjasker" ; -- sjasker..nn.1
  sjaskig_1_A = mkA "sjaskig" ; -- sjaskig..av.1
  sjaskighet_1_N = mkN "sjaskighet" "sjaskigheter" ; -- sjaskighet..nn.1
  sjaslik_1_N = mkN "sjaslik" ; -- sjaslik..nn.1
  sjava_1_V = mkV "sjavar" ; -- sjava..vb.1
  sjavande_1_N = mkN "sjavande" ; -- sjavande..nn.1
  sjavig_1_A = mkA "sjavig" ; -- sjavig..av.1
  sjavighet_1_N = mkN "sjavighet" ; -- sjavighet..nn.1
  sjok_1_N = mkN "sjok" neutrum  ; -- sjok..nn.1
  sjua_1_N = mkN "sjua" ; -- sjua..nn.1
  sjuarmad_1_A = mkA "sjuarmad" ; -- sjuarmad..av.1
  sjubarnspappa_1_N = mkN "sjubarnspappa" ; -- sjubarnspappa..nn.1
  sjubb_1_N = mkN "sjubb" ; -- sjubb..nn.1
  sjuda_1_V = mkV "sjuda" "sjöd" "sjudit" ; -- sjuda..vb.1
  sjudagarsvecka_1_N = mkN "sjudagarsvecka" ; -- sjudagarsvecka..nn.1
  sjudande_1_N = mkN "sjudande" ; -- sjudande..nn.1
  sjudimensionell_1_A = mkA "sjudimensionell" ; -- sjudimensionell..av.1
  sjudning_1_N = mkN "sjudning" ; -- sjudning..nn.1
  sjudubbel_1_A = mkA "sjudubben" ; -- sjudubbel..av.1
  sjudundrande_1_A = mkA "sjudundrande" ; -- sjudundrande..av.1
  sjufaldig_1_A = mkA "sjufaldig" ; -- sjufaldig..av.1
  sjufaldiga_1_V = mkV "sjufaldigar" ; -- sjufaldiga..vb.1
  sjufaldigande_1_N = mkN "sjufaldigande" ; -- sjufaldigande..nn.1
  sjuglasvagn_1_N = mkN "sjuglasvagn" ; -- sjuglasvagn..nn.1
  sjuhelvetes_1_Adv = mkAdv "sjuhelvetes" ; -- sjuhelvetes..ab.1
  sjuhelvetes_1_A = mkA "sjuhelvetes" ; -- sjuhelvetes..av.1
  sjuhundrade_1_A = mkA "sjuhundrade" ; -- sjuhundrade..av.1
  sjuk_1_A = mkA "sjuk" ; -- sjuk..av.1
  sjuka_1_N = mkN "sjuka" ; -- sjuka..nn.1
  sjukanmäla_1_V = mkV "sjukanmäler" ; -- sjukanmäla..vb.1
  sjukanmälande_1_N = mkN "sjukanmälande" ; -- sjukanmälande..nn.1
  sjukavdrag_1_N = mkN "sjukavdrag" neutrum  ; -- sjukavdrag..nn.1
  sjukbesök_1_N = mkN "sjukbesök" neutrum  ; -- sjukbesök..nn.1
  sjukbud_1_N = mkN "sjukbud" neutrum  ; -- sjukbud..nn.1
  sjukbädd_1_N = mkN "sjukbädd" ; -- sjukbädd..nn.1
  sjukbärare_1_N = mkN "sjukbärare" utrum  ; -- sjukbärare..nn.1
  sjukdag_1_N = mkN "sjukdag" ; -- sjukdag..nn.1
  sjukdom_1_N = mkN "sjukdom" ; -- sjukdom..nn.1
  sjukdomsalstrande_1_A = mkA "sjukdomsalstrande" ; -- sjukdomsalstrande..av.1
  sjukdomsbild_1_N = mkN "sjukdomsbild" "sjukdomsbilder" ; -- sjukdomsbild..nn.1
  sjukdomsdiagnos_1_N = mkN "sjukdomsdiagnos" "sjukdomsdiagnoser" ; -- sjukdomsdiagnos..nn.1
  sjukdomsfall_1_N = mkN "sjukdomsfall" neutrum  ; -- sjukdomsfall..nn.1
  sjukdomsframkallande_1_A = mkA "sjukdomsframkallande" ; -- sjukdomsframkallande..av.1
  sjukdomsförklaring_1_N = mkN "sjukdomsförklaring" ; -- sjukdomsförklaring..nn.1
  sjukdomsförlopp_1_N = mkN "sjukdomsförlopp" neutrum  ; -- sjukdomsförlopp..nn.1
  sjukdomshistoria_1_N = mkN "sjukdomshistoria" "sjukdomshistorian" "sjukdomshistorier" "sjukdomshistorierna" ; -- sjukdomshistoria..nn.1
  sjukdomsklassad_1_A = mkA "sjukdomsklassad" ; -- sjukdomsklassad..av.1
  sjukdomsstämpla_1_V = mkV "sjukdomsstämplar" ; -- sjukdomsstämpla..vb.1
  sjukdomsstämplande_1_N = mkN "sjukdomsstämplande" ; -- sjukdomsstämplande..nn.1
  sjukdomsstämpling_1_N = mkN "sjukdomsstämpling" ; -- sjukdomsstämpling..nn.1
  sjukdomssymptom_1_N = mkN "sjukdomssymptom" neutrum  ; -- sjukdomssymptom..nn.1
  sjukdomssymtom_1_N = mkN "sjukdomssymtom" neutrum  ; -- sjukdomssymtom..nn.1
  sjukdomstillstånd_1_N = mkN "sjukdomstillstånd" neutrum  ; -- sjukdomstillstånd..nn.1
  sjukersättning_1_N = mkN "sjukersättning" ; -- sjukersättning..nn.1
  sjukfrånvaro_1_N = mkN "sjukfrånvaro" ; -- sjukfrånvaro..nn.1
  sjukförsäkring_1_N = mkN "sjukförsäkring" ; -- sjukförsäkring..nn.1
  sjukförsäkringssystem_1_N = mkN "sjukförsäkringssystem" neutrum  ; -- sjukförsäkringssystem..nn.1
  sjukgymnast_1_N = mkN "sjukgymnast" "sjukgymnaster" ; -- sjukgymnast..nn.1
  sjukgymnastik_1_N = mkN "sjukgymnastik" ; -- sjukgymnastik..nn.1
  sjukhem_1_N = mkN "sjukhem" "sjukhemmet" "sjukhem" "sjukhemmen" ; -- sjukhem..nn.1
  sjukhet_1_N = mkN "sjukhet" "sjukheter" ; -- sjukhet..nn.1
  sjukhus_1_N = mkN "sjukhus" neutrum  ; -- sjukhus..nn.1
  sjukhusavdelning_1_N = mkN "sjukhusavdelning" ; -- sjukhusavdelning..nn.1
  sjukhusbädd_1_N = mkN "sjukhusbädd" ; -- sjukhusbädd..nn.1
  sjukhusdirektör_1_N = mkN "sjukhusdirektör" "sjukhusdirektörer" ; -- sjukhusdirektör..nn.1
  sjukhusentré_1_N = mkN "sjukhusentré" "sjukhusentréer" ; -- sjukhusentré..nn.1
  sjukhusfödsel_1_N = mkN "sjukhusfödsel" ; -- sjukhusfödsel..nn.1
  sjukhuskorridor_1_N = mkN "sjukhuskorridor" "sjukhuskorridoren" "sjukhuskorridorer" "sjukhuskorridorerna" ; -- sjukhuskorridor..nn.1
  sjukhusren_1_A = mkA "sjukhusren" "sjukhusrent" ; -- sjukhusren..av.1
  sjukhussal_1_N = mkN "sjukhussal" ; -- sjukhussal..nn.1
  sjukhussjuka_1_N = mkN "sjukhussjuka" ; -- sjukhussjuka..nn.1
  sjukhussäng_1_N = mkN "sjukhussäng" ; -- sjukhussäng..nn.1
  sjukhusvård_1_N = mkN "sjukhusvård" ; -- sjukhusvård..nn.1
  sjukjournal_1_N = mkN "sjukjournal" "sjukjournaler" ; -- sjukjournal..nn.1
  sjukkassa_1_N = mkN "sjukkassa" ; -- sjukkassa..nn.1
  sjukledig_1_A = mkA "sjukledig" ; -- sjukledig..av.1
  sjukledighet_1_N = mkN "sjukledighet" "sjukledigheter" ; -- sjukledighet..nn.1
  sjuklig_1_A = mkA "sjuklig" ; -- sjuklig..av.1
  sjuklighet_1_N = mkN "sjuklighet" "sjukligheter" ; -- sjuklighet..nn.1
  sjukling_1_N = mkN "sjukling" ; -- sjukling..nn.1
  sjukläger_1_N = mkN "sjukläger" neutrum  ; -- sjukläger..nn.1
  sjukna_1_V = mkV "sjuknar" ; -- sjukna..vb.1
  sjuknande_1_N = mkN "sjuknande" ; -- sjuknande..nn.1
  sjukpeng_1_N = mkN "sjukpeng" ; -- sjukpeng..nn.1
  sjukpenning_1_N = mkN "sjukpenning" ; -- sjukpenning..nn.1
  sjukpenninggrundande_1_A = mkA "sjukpenninggrundande" ; -- sjukpenninggrundande..av.1
  sjukpenningutbetalning_1_N = mkN "sjukpenningutbetalning" ; -- sjukpenningutbetalning..nn.1
  sjukpension_1_N = mkN "sjukpension" ; -- sjukpension..nn.1
  sjukpensionera_1_V = mkV "sjukpensionerar" ; -- sjukpensionera..vb.1
  sjukpensionerande_1_N = mkN "sjukpensionerande" ; -- sjukpensionerande..nn.1
  sjukpensionering_1_N = mkN "sjukpensionering" ; -- sjukpensionering..nn.1
  sjukpensionär_1_N = mkN "sjukpensionär" "sjukpensionärer" ; -- sjukpensionär..nn.1
  sjukrapportera_1_V = mkV "sjukrapporterar" ; -- sjukrapportera..vb.1
  sjukrapporterande_1_N = mkN "sjukrapporterande" ; -- sjukrapporterande..nn.1
  sjukrapportering_1_N = mkN "sjukrapportering" ; -- sjukrapportering..nn.1
  sjukregel_1_N = mkN "sjukregel" "sjukregeln" "sjukregler" "sjukreglerna" ; -- sjukregel..nn.1
  sjukskriva_1_V = mkV "sjukskriva" "sjukskrev" "sjukskrivit" ; -- sjukskriva..vb.1
  sjukskrivande_1_N = mkN "sjukskrivande" ; -- sjukskrivande..nn.1
  sjukskrivning_1_N = mkN "sjukskrivning" ; -- sjukskrivning..nn.1
  sjukskrivningskverulant_1_N = mkN "sjukskrivningskverulant" "sjukskrivningskverulanter" ; -- sjukskrivningskverulant..nn.1
  sjukskötare_1_N = mkN "sjukskötare" utrum  ; -- sjukskötare..nn.1
  sjuksköterska_1_N = mkN "sjuksköterska" ; -- sjuksköterska..nn.1
  sjuksköterskeexamen_1_N = mkN "sjuksköterskeexamen" "sjuksköterskeexamen" "sjuksköterskeexamina" "sjuksköterskeexamina" ; -- sjuksköterskeexamen..nn.1
  sjuksköterskeskola_1_N = mkN "sjuksköterskeskola" ; -- sjuksköterskeskola..nn.1
  sjuksköterskeutbildning_1_N = mkN "sjuksköterskeutbildning" ; -- sjuksköterskeutbildning..nn.1
  sjukstuga_1_N = mkN "sjukstuga" ; -- sjukstuga..nn.1
  sjuksyster_1_N = mkN "sjuksyster" ; -- sjuksyster..nn.1
  sjukt_1_Adv = mkAdv "sjukt" ; -- sjukt..ab.1
  sjuktransport_1_N = mkN "sjuktransport" "sjuktransporter" ; -- sjuktransport..nn.1
  sjukvikarie_1_N = mkN "sjukvikarie" "sjukvikarier" ; -- sjukvikarie..nn.1
  sjukvård_1_N = mkN "sjukvård" ; -- sjukvård..nn.1
  sjukvårdande_1_A = mkA "sjukvårdande" ; -- sjukvårdande..av.1
  sjukvårdare_1_N = mkN "sjukvårdare" utrum  ; -- sjukvårdare..nn.1
  sjukvårdsaffär_1_N = mkN "sjukvårdsaffär" "sjukvårdsaffärer" ; -- sjukvårdsaffär..nn.1
  sjukvårdsapparat_1_N = mkN "sjukvårdsapparat" "sjukvårdsapparater" ; -- sjukvårdsapparat..nn.1
  sjukvårdsartikel_1_N = mkN "sjukvårdsartikel" ; -- sjukvårdsartikel..nn.1
  sjukvårdsbiträde_1_N = mkN "sjukvårdsbiträde" ; -- sjukvårdsbiträde..nn.1
  sjukvårdsförsäkring_1_N = mkN "sjukvårdsförsäkring" ; -- sjukvårdsförsäkring..nn.1
  sjukvårdsmässig_1_A = mkA "sjukvårdsmässig" ; -- sjukvårdsmässig..av.1
  sjukvårdsnämnd_1_N = mkN "sjukvårdsnämnd" "sjukvårdsnämnder" ; -- sjukvårdsnämnd..nn.1
  sjukvårdspersonal_1_N = mkN "sjukvårdspersonal" ; -- sjukvårdspersonal..nn.1
  sjukvårdspolitik_1_N = mkN "sjukvårdspolitik" ; -- sjukvårdspolitik..nn.1
  sjukvårdspolitisk_1_A = mkA "sjukvårdspolitisk" ; -- sjukvårdspolitisk..av.1
  sjukvårdsreform_1_N = mkN "sjukvårdsreform" "sjukvårdsreformer" ; -- sjukvårdsreform..nn.1
  sjukvårdsregion_1_N = mkN "sjukvårdsregion" ; -- sjukvårdsregion..nn.1
  sjukvårdsutbildning_1_N = mkN "sjukvårdsutbildning" ; -- sjukvårdsutbildning..nn.1
  sjukvårdsutrustning_1_N = mkN "sjukvårdsutrustning" ; -- sjukvårdsutrustning..nn.1
  sjuling_1_N = mkN "sjuling" ; -- sjuling..nn.1
  sjumilakliv_1_N = mkN "sjumilakliv" neutrum  ; -- sjumilakliv..nn.1
  sjunde_1_A = mkA "sjunde" ; -- sjunde..av.1
  sjundedagsadventist_1_N = mkN "sjundedagsadventist" "sjundedagsadventister" ; -- sjundedagsadventist..nn.1
  sjundedel_1_N = mkN "sjundedel" "sjundedelen" "sjundedelar" "sjundedelarna" ; -- sjundedel..nn.1
  sjunga_1_V = mkV "sjunga" "sjöng" "sjungit" ; -- sjunga..vb.1
  sjungande_1_N = mkN "sjungande" ; -- sjungande..nn.1
  sjunka_1_V = mkV "sjunka" "sjönk" "sjunkit" ; -- sjunka..vb.1
  sjunkande_1_N = mkN "sjunkande" ; -- sjunkande..nn.1
  sjunkbomb_1_N = mkN "sjunkbomb" "sjunkbomber" ; -- sjunkbomb..nn.1
  sjunkfärdig_1_A = mkA "sjunkfärdig" ; -- sjunkfärdig..av.1
  sjunkning_1_N = mkN "sjunkning" ; -- sjunkning..nn.1
  sjurygg_1_N = mkN "sjurygg" ; -- sjurygg..nn.1
  sjurättersmeny_1_N = mkN "sjurättersmeny" "sjurättersmenyer" ; -- sjurättersmeny..nn.1
  sjusovare_1_N = mkN "sjusovare" utrum  ; -- sjusovare..nn.1
  sjustjärna_1_N = mkN "sjustjärna" ; -- sjustjärna..nn.1
  sjusärdeles_1_Adv = mkAdv "sjusärdeles" ; -- sjusärdeles..ab.1
  sjutillhållarlås_1_N = mkN "sjutillhållarlås" neutrum  ; -- sjutillhållarlås..nn.1
  sjuttionde_1_A = mkA "sjuttionde" ; -- sjuttionde..av.1
  sjuttiotal_1_N = mkN "sjuttiotal" neutrum  ; -- sjuttiotal..nn.1
  sjuttioårsålder_1_N = mkN "sjuttioårsålder" ; -- sjuttioårsålder..nn.1
  sjuttital_1_N = mkN "sjuttital" neutrum  ; -- sjuttital..nn.1
  sjuttonde_1_A = mkA "sjuttonde" ; -- sjuttonde..av.1
  sjuttonhundratal_1_N = mkN "sjuttonhundratal" neutrum  ; -- sjuttonhundratal..nn.1
  sjuttonårig_1_A = mkA "sjuttonårig" ; -- sjuttonårig..av.1
  sjuttonåring_1_N = mkN "sjuttonåring" ; -- sjuttonåring..nn.1
  sjutumsspik_1_N = mkN "sjutumsspik" ; -- sjutumsspik..nn.1
  sjutusan_1_N = mkN "sjutusan" ; -- sjutusan..nn.1
  sjuårig_1_A = mkA "sjuårig" ; -- sjuårig..av.1
  sjuåring_1_N = mkN "sjuåring" ; -- sjuåring..nn.1
  sjyst_1_A = mkA "sjyst" "sjyst" ; -- sjyst..av.1
  sjysthet_1_N = mkN "sjysthet" ; -- sjysthet..nn.1
  själ_1_N = mkN "själ" ; -- själ..nn.1
  själaglad_1_A = mkA "själaglad" "själaglatt" ; -- själaglad..av.1
  själaherde_1_N = mkN "själaherde" utrum  ; -- själaherde..nn.1
  själamässa_1_N = mkN "själamässa" ; -- själamässa..nn.1
  själanöd_1_N = mkN "själanöd" ; -- själanöd..nn.1
  själaringning_1_N = mkN "själaringning" ; -- själaringning..nn.1
  själasörjare_1_N = mkN "själasörjare" utrum  ; -- själasörjare..nn.1
  själatåg_1_N = mkN "själatåg" neutrum  ; -- själatåg..nn.1
  själavandring_1_N = mkN "själavandring" ; -- själavandring..nn.1
  själavård_1_N = mkN "själavård" ; -- själavård..nn.1
  själavårdande_1_A = mkA "själavårdande" ; -- själavårdande..av.1
  själavårdsmässig_1_A = mkA "själavårdsmässig" ; -- själavårdsmässig..av.1
  själfull_1_A = mkA "själfull" ; -- själfull..av.1
  själfullhet_1_N = mkN "själfullhet" ; -- själfullhet..nn.1
  själisk_1_A = mkA "själisk" ; -- själisk..av.1
  själlös_1_A = mkA "själlös" ; -- själlös..av.1
  själlöshet_1_N = mkN "själlöshet" "själlösheter" ; -- själlöshet..nn.1
  själsadel_1_N = mkN "själsadel" ; -- själsadel..nn.1
  själsanalys_1_N = mkN "själsanalys" "själsanalyser" ; -- själsanalys..nn.1
  själsbesläktad_1_A = mkA "själsbesläktad" ; -- själsbesläktad..av.1
  själsdödande_1_A = mkA "själsdödande" ; -- själsdödande..av.1
  själsegenskap_1_N = mkN "själsegenskap" "själsegenskaper" ; -- själsegenskap..nn.1
  själsfinhet_1_N = mkN "själsfinhet" ; -- själsfinhet..nn.1
  själsfrände_1_N = mkN "själsfrände" "själsfränder" ; -- själsfrände..nn.1
  själsfrändskap_1_N = mkN "själsfrändskap" ; -- själsfrändskap..nn.1
  själsfrånvarande_1_A = mkA "själsfrånvarande" ; -- själsfrånvarande..av.1
  själsfrånvaro_1_N = mkN "själsfrånvaro" ; -- själsfrånvaro..nn.1
  själsförmögenhet_1_N = mkN "själsförmögenhet" "själsförmögenheter" ; -- själsförmögenhet..nn.1
  själskonflikt_1_N = mkN "själskonflikt" "själskonflikter" ; -- själskonflikt..nn.1
  själskraft_1_N = mkN "själskraft" "själskrafter" ; -- själskraft..nn.1
  själskval_1_N = mkN "själskval" neutrum  ; -- själskval..nn.1
  själslidande_1_N = mkN "själslidande" ; -- själslidande..nn.1
  själslig_1_A = mkA "själslig" ; -- själslig..av.1
  själsligen_1_Adv = mkAdv "själsligen" ; -- själsligen..ab.1
  själslighet_1_N = mkN "själslighet" ; -- själslighet..nn.1
  själsliv_1_N = mkN "själsliv" neutrum  ; -- själsliv..nn.1
  själsmördande_1_A = mkA "själsmördande" ; -- själsmördande..av.1
  själsnärvaro_1_N = mkN "själsnärvaro" ; -- själsnärvaro..nn.1
  själsnöd_1_N = mkN "själsnöd" ; -- själsnöd..nn.1
  själsodling_1_N = mkN "själsodling" ; -- själsodling..nn.1
  själsro_1_N = mkN "själsro" ; -- själsro..nn.1
  själssjuk_1_A = mkA "själssjuk" ; -- själssjuk..av.1
  själssjukdom_1_N = mkN "själssjukdom" ; -- själssjukdom..nn.1
  själssjukhet_1_N = mkN "själssjukhet" ; -- själssjukhet..nn.1
  själsskakande_1_A = mkA "själsskakande" ; -- själsskakande..av.1
  själsstark_1_A = mkA "själsstark" ; -- själsstark..av.1
  själsstrid_1_N = mkN "själsstrid" "själsstrider" ; -- själsstrid..nn.1
  själsstyrka_1_N = mkN "själsstyrka" ; -- själsstyrka..nn.1
  själstillstånd_1_N = mkN "själstillstånd" neutrum  ; -- själstillstånd..nn.1
  själsvånda_1_N = mkN "själsvånda" ; -- själsvånda..nn.1
  själsångest_1_N = mkN "själsångest" ; -- själsångest..nn.1
  självaktning_1_N = mkN "självaktning" ; -- självaktning..nn.1
  självalstring_1_N = mkN "självalstring" ; -- självalstring..nn.1
  självanalys_1_N = mkN "självanalys" "självanalyser" ; -- självanalys..nn.1
  självanklagelse_1_N = mkN "självanklagelse" "självanklagelser" ; -- självanklagelse..nn.1
  självantända_1_V = mkV "självantänder" ; -- självantända..vb.1
  självantändning_1_N = mkN "självantändning" ; -- självantändning..nn.1
  självbedrägeri_1_N = mkN "självbedrägeri" "självbedrägeriet" "självbedrägerier" "självbedrägerierna" ; -- självbedrägeri..nn.1
  självbefläckelse_1_N = mkN "självbefläckelse" utrum  ; -- självbefläckelse..nn.1
  självbefruktning_1_N = mkN "självbefruktning" ; -- självbefruktning..nn.1
  självbehärskning_1_N = mkN "självbehärskning" ; -- självbehärskning..nn.1
  självbekännelse_1_N = mkN "självbekännelse" "självbekännelser" ; -- självbekännelse..nn.1
  självbelåten_1_A = mkA "självbelåten" ; -- självbelåten..av.1
  självbelåtenhet_1_N = mkN "självbelåtenhet" "självbelåtenheter" ; -- självbelåtenhet..nn.1
  självbespeglande_1_A = mkA "självbespeglande" ; -- självbespeglande..av.1
  självbespeglande_1_N = mkN "självbespeglande" ; -- självbespeglande..nn.1
  självbespegling_1_N = mkN "självbespegling" ; -- självbespegling..nn.1
  självbestämmande_1_N = mkN "självbestämmande" ; -- självbestämmande..nn.1
  självbetjäning_1_N = mkN "självbetjäning" ; -- självbetjäning..nn.1
  självbetraktelse_1_N = mkN "självbetraktelse" "självbetraktelser" ; -- självbetraktelse..nn.1
  självbevarande_1_A = mkA "självbevarande" ; -- självbevarande..av.1
  självbevarande_1_N = mkN "självbevarande" ; -- självbevarande..nn.1
  självbevarelsedrift_1_N = mkN "självbevarelsedrift" ; -- självbevarelsedrift..nn.1
  självbild_1_N = mkN "självbild" "självbilder" ; -- självbild..nn.1
  självbildning_1_N = mkN "självbildning" ; -- självbildning..nn.1
  självbindare_1_N = mkN "självbindare" utrum  ; -- självbindare..nn.1
  självbiografi_1_N = mkN "självbiografi" "självbiografier" ; -- självbiografi..nn.1
  självbiografisk_1_A = mkA "självbiografisk" ; -- självbiografisk..av.1
  självbo_1_N = mkN "självbo" "självbor" ; -- självbo..nn.1
  självbärande_1_A = mkA "självbärande" ; -- självbärande..av.1
  självcentrerad_1_A = mkA "självcentrerad" ; -- självcentrerad..av.1
  självdeklaration_1_N = mkN "självdeklaration" ; -- självdeklaration..nn.1
  självdestruktiv_1_A = mkA "självdestruktiv" ; -- självdestruktiv..av.1
  självdiagnos_1_N = mkN "självdiagnos" "självdiagnoser" ; -- självdiagnos..nn.1
  självdiagnostik_1_N = mkN "självdiagnostik" ; -- självdiagnostik..nn.1
  självdisciplin_1_N = mkN "självdisciplin" ; -- självdisciplin..nn.1
  självdistanserad_1_A = mkA "självdistanserad" ; -- självdistanserad..av.1
  självdrag_1_N = mkN "självdrag" neutrum  ; -- självdrag..nn.1
  självdö_1_V = mkV "självdö" "självdog" "självdött" ; -- självdö..vb.1
  självdöd_1_A = mkA "självdöd" "självdött" ; -- självdöd..av.1
  självdöende_1_N = mkN "självdöende" ; -- självdöende..nn.1
  självfallen_1_A = mkA "självfallen" ; -- självfallen..av.1
  självfinansiera_1_V = mkV "självfinansierar" ; -- självfinansiera..vb.1
  självfinansierande_1_N = mkN "självfinansierande" ; -- självfinansierande..nn.1
  självfinansierbar_1_A = mkA "självfinansierbar" ; -- självfinansierbar..av.1
  självfinansierbarhet_1_N = mkN "självfinansierbarhet" ; -- självfinansierbarhet..nn.1
  självfinansiering_1_N = mkN "självfinansiering" ; -- självfinansiering..nn.1
  självförakt_1_N = mkN "självförakt" neutrum  ; -- självförakt..nn.1
  självförbrännande_1_A = mkA "självförbrännande" ; -- självförbrännande..av.1
  självförbränning_1_N = mkN "självförbränning" ; -- självförbränning..nn.1
  självförebråelse_1_N = mkN "självförebråelse" "självförebråelser" ; -- självförebråelse..nn.1
  självförglömmande_1_A = mkA "självförglömmande" ; -- självförglömmande..av.1
  självförhärligande_1_A = mkA "självförhärligande" ; -- självförhärligande..av.1
  självförhärligande_1_N = mkN "självförhärligande" ; -- självförhärligande..nn.1
  självförhävelse_1_N = mkN "självförhävelse" "självförhävelser" ; -- självförhävelse..nn.1
  självförnedring_1_N = mkN "självförnedring" ; -- självförnedring..nn.1
  självförnekare_1_N = mkN "självförnekare" utrum  ; -- självförnekare..nn.1
  självförnekelse_1_N = mkN "självförnekelse" "självförnekelser" ; -- självförnekelse..nn.1
  självförsakelse_1_N = mkN "självförsakelse" utrum  ; -- självförsakelse..nn.1
  självförsjunken_1_A = mkA "självförsjunken" ; -- självförsjunken..av.1
  självförstärkande_1_A = mkA "självförstärkande" ; -- självförstärkande..av.1
  självförsvar_1_N = mkN "självförsvar" neutrum  ; -- självförsvar..nn.1
  självförsörjande_1_A = mkA "självförsörjande" ; -- självförsörjande..av.1
  självförsörjare_1_N = mkN "självförsörjare" utrum  ; -- självförsörjare..nn.1
  självförsörjning_1_N = mkN "självförsörjning" ; -- självförsörjning..nn.1
  självförtroende_1_N = mkN "självförtroende" ; -- självförtroende..nn.1
  självförtärande_1_A = mkA "självförtärande" ; -- självförtärande..av.1
  självförverkligande_1_N = mkN "självförverkligande" ; -- självförverkligande..nn.1
  självförvärvad_1_A = mkA "självförvärvad" ; -- självförvärvad..av.1
  självförvållad_1_A = mkA "självförvållad" ; -- självförvållad..av.1
  självföryngring_1_N = mkN "självföryngring" ; -- självföryngring..nn.1
  självförälskelse_1_N = mkN "självförälskelse" "självförälskelser" ; -- självförälskelse..nn.1
  självgod_1_A = mkA "självgod" "självgott" ; -- självgod..av.1
  självgodhet_1_N = mkN "självgodhet" "självgodheter" ; -- självgodhet..nn.1
  självhjälp_1_N = mkN "självhjälp" ; -- självhjälp..nn.1
  självhjälpsbok_1_N = mkN "självhjälpsbok" "självhjälpsböcker" ; -- självhjälpsbok..nn.1
  självhjälpsbransch_1_N = mkN "självhjälpsbransch" "självhjälpsbranscher" ; -- självhjälpsbransch..nn.1
  självhjälpsentreprenör_1_N = mkN "självhjälpsentreprenör" "självhjälpsentreprenörer" ; -- självhjälpsentreprenör..nn.1
  självhjälpsgenre_1_N = mkN "självhjälpsgenre" "självhjälpsgenrer" ; -- självhjälpsgenre..nn.1
  självhjälpsgeschäft_1_N = mkN "självhjälpsgeschäft" neutrum  ; -- självhjälpsgeschäft..nn.1
  självhjälpsindustri_1_N = mkN "självhjälpsindustri" "självhjälpsindustrier" ; -- självhjälpsindustri..nn.1
  självhjälpsklyscha_1_N = mkN "självhjälpsklyscha" ; -- självhjälpsklyscha..nn.1
  självhjälpslitteratur_1_N = mkN "självhjälpslitteratur" ; -- självhjälpslitteratur..nn.1
  självhjälpsråd_1_N = mkN "självhjälpsråd" neutrum  ; -- självhjälpsråd..nn.1
  självhjälpsvärld_1_N = mkN "självhjälpsvärld" ; -- självhjälpsvärld..nn.1
  självhushåll_1_N = mkN "självhushåll" neutrum  ; -- självhushåll..nn.1
  självhushållande_1_N = mkN "självhushållande" ; -- självhushållande..nn.1
  självhushållning_1_N = mkN "självhushållning" ; -- självhushållning..nn.1
  självhäckling_1_N = mkN "självhäckling" ; -- självhäckling..nn.1
  självhäftande_1_A = mkA "självhäftande" ; -- självhäftande..av.1
  självhärlig_1_A = mkA "självhärlig" ; -- självhärlig..av.1
  självhärlighet_1_N = mkN "självhärlighet" ; -- självhärlighet..nn.1
  självhärskare_1_N = mkN "självhärskare" utrum  ; -- självhärskare..nn.1
  självhävdelse_1_N = mkN "självhävdelse" utrum  ; -- självhävdelse..nn.1
  självhävdelsebegär_1_N = mkN "självhävdelsebegär" neutrum  ; -- självhävdelsebegär..nn.1
  själviakttagelse_1_N = mkN "själviakttagelse" "själviakttagelser" ; -- själviakttagelse..nn.1
  självinstruerande_1_A = mkA "självinstruerande" ; -- självinstruerande..av.1
  självironi_1_N = mkN "självironi" ; -- självironi..nn.1
  självironisk_1_A = mkA "självironisk" ; -- självironisk..av.1
  självis_1_N = mkN "självis" ; -- självis..nn.1
  självisk_1_A = mkA "självisk" ; -- självisk..av.1
  själviskhet_1_N = mkN "själviskhet" "själviskheter" ; -- själviskhet..nn.1
  självkem_1_N = mkN "självkem" ; -- självkem..nn.1
  självklar_1_A = mkA "självklar" ; -- självklar..av.1
  självklarhet_1_N = mkN "självklarhet" "självklarheter" ; -- självklarhet..nn.1
  självklistrande_1_A = mkA "självklistrande" ; -- självklistrande..av.1
  självkontroll_1_N = mkN "självkontroll" ; -- självkontroll..nn.1
  självkostnadspris_1_N = mkN "självkostnadspris" neutrum  ; -- självkostnadspris..nn.1
  självkritik_1_N = mkN "självkritik" ; -- självkritik..nn.1
  självkritisk_1_A = mkA "självkritisk" ; -- självkritisk..av.1
  självkännedom_1_N = mkN "självkännedom" ; -- självkännedom..nn.1
  självkänsla_1_N = mkN "självkänsla" ; -- självkänsla..nn.1
  självkärlek_1_N = mkN "självkärlek" ; -- självkärlek..nn.1
  självljud_1_N = mkN "självljud" neutrum  ; -- självljud..nn.1
  självlysande_1_A = mkA "självlysande" ; -- självlysande..av.1
  självläka_1_V = mkV "självläker" ; -- självläka..vb.1
  självläkande_1_N = mkN "självläkande" ; -- självläkande..nn.1
  självläkning_1_N = mkN "självläkning" ; -- självläkning..nn.1
  självläns_1_N = mkN "självläns" ; -- självläns..nn.1
  självlärd_1_A = mkA "självlärd" "självlärt" ; -- självlärd..av.1
  självlärdhet_1_N = mkN "självlärdhet" ; -- självlärdhet..nn.1
  självmant_1_Adv = mkAdv "självmant" ; -- självmant..ab.1
  självmedvetande_1_N = mkN "självmedvetande" ; -- självmedvetande..nn.1
  självmedveten_1_A = mkA "självmedveten" ; -- självmedveten..av.1
  självmedvetenhet_1_N = mkN "självmedvetenhet" "självmedvetenheter" ; -- självmedvetenhet..nn.1
  självmord_1_N = mkN "självmord" neutrum  ; -- självmord..nn.1
  självmordsattack_1_N = mkN "självmordsattack" "självmordsattacker" ; -- självmordsattack..nn.1
  självmordsbenägen_1_A = mkA "självmordsbenägen" ; -- självmordsbenägen..av.1
  självmordsbomb_1_N = mkN "självmordsbomb" "självmordsbomber" ; -- självmordsbomb..nn.1
  självmordsbombare_1_N = mkN "självmordsbombare" utrum  ; -- självmordsbombare..nn.1
  självmordsförsök_1_N = mkN "självmordsförsök" neutrum  ; -- självmordsförsök..nn.1
  självmordskandidat_1_N = mkN "självmordskandidat" "självmordskandidater" ; -- självmordskandidat..nn.1
  självmordsmässig_1_A = mkA "självmordsmässig" ; -- självmordsmässig..av.1
  självmordspilot_1_N = mkN "självmordspilot" "självmordspiloter" ; -- självmordspilot..nn.1
  självmordsrisk_1_N = mkN "självmordsrisk" "självmordsrisker" ; -- självmordsrisk..nn.1
  självmordsstatistik_1_N = mkN "självmordsstatistik" ; -- självmordsstatistik..nn.1
  självmordsuppdrag_1_N = mkN "självmordsuppdrag" neutrum  ; -- självmordsuppdrag..nn.1
  självmotsägande_1_A = mkA "självmotsägande" ; -- självmotsägande..av.1
  självmotsägelse_1_N = mkN "självmotsägelse" "självmotsägelser" ; -- självmotsägelse..nn.1
  självmål_1_N = mkN "självmål" neutrum  ; -- självmål..nn.1
  självmördare_1_N = mkN "självmördare" utrum  ; -- självmördare..nn.1
  självnedbrytning_1_N = mkN "självnedbrytning" ; -- självnedbrytning..nn.1
  självparodi_1_N = mkN "självparodi" "självparodier" ; -- självparodi..nn.1
  självplågande_1_A = mkA "självplågande" ; -- självplågande..av.1
  självplågare_1_N = mkN "självplågare" utrum  ; -- självplågare..nn.1
  självplågarscen_1_N = mkN "självplågarscen" "självplågarscener" ; -- självplågarscen..nn.1
  självplågeri_1_N = mkN "självplågeri" "självplågeriet" "självplågerier" "självplågerierna" ; -- självplågeri..nn.1
  självporträtt_1_N = mkN "självporträtt" neutrum  ; -- självporträtt..nn.1
  självpåhittad_1_A = mkA "självpåhittad" ; -- självpåhittad..av.1
  självpåtagen_1_A = mkA "självpåtagen" ; -- självpåtagen..av.1
  självreglerande_1_A = mkA "självreglerande" ; -- självreglerande..av.1
  självreparerande_1_A = mkA "självreparerande" ; -- självreparerande..av.1
  självrepellerande_1_A = mkA "självrepellerande" ; -- självrepellerande..av.1
  självrisk_1_N = mkN "självrisk" "självrisker" ; -- självrisk..nn.1
  självrättfärdig_1_A = mkA "självrättfärdig" ; -- självrättfärdig..av.1
  självrättfärdighet_1_N = mkN "självrättfärdighet" ; -- självrättfärdighet..nn.1
  självrådig_1_A = mkA "självrådig" ; -- självrådig..av.1
  självrådighet_1_N = mkN "självrådighet" ; -- självrådighet..nn.1
  självsanerande_1_A = mkA "självsanerande" ; -- självsanerande..av.1
  självservering_1_N = mkN "självservering" ; -- självservering..nn.1
  självsex_1_N = mkN "självsex" neutrum  ; -- självsex..nn.1
  självskadebeteende_1_N = mkN "självskadebeteende" ; -- självskadebeteende..nn.1
  självskadepatient_1_N = mkN "självskadepatient" "självskadepatienter" ; -- självskadepatient..nn.1
  självskriven_1_A = mkA "självskriven" ; -- självskriven..av.1
  självskrivenhet_1_N = mkN "självskrivenhet" ; -- självskrivenhet..nn.1
  självskryt_1_N = mkN "självskryt" neutrum  ; -- självskryt..nn.1
  självspelande_1_A = mkA "självspelande" ; -- självspelande..av.1
  självspilling_1_N = mkN "självspilling" ; -- självspilling..nn.1
  självspricka_1_N = mkN "självspricka" ; -- självspricka..nn.1
  självspäkelse_1_N = mkN "självspäkelse" "självspäkelser" ; -- självspäkelse..nn.1
  självspäkning_1_N = mkN "självspäkning" ; -- självspäkning..nn.1
  självstart_1_N = mkN "självstart" ; -- självstart..nn.1
  självstarta_1_V = mkV "självstartar" ; -- självstarta..vb.1
  självstudium_1_N = mkN "självstudium" "självstudiet" "självstudier" "självstudierna" ; -- självstudium..nn.1
  självstyrande_1_A = mkA "självstyrande" ; -- självstyrande..av.1
  självstyre_1_N = mkN "självstyre" ; -- självstyre..nn.1
  självstyrelse_1_N = mkN "självstyrelse" utrum  ; -- självstyrelse..nn.1
  självständig_1_A = mkA "självständig" ; -- självständig..av.1
  självständighet_1_N = mkN "självständighet" "självständigheter" ; -- självständighet..nn.1
  självständighetsförklaring_1_N = mkN "självständighetsförklaring" ; -- självständighetsförklaring..nn.1
  självständighetssträvande_1_N = mkN "självständighetssträvande" ; -- självständighetssträvande..nn.1
  självstängande_1_A = mkA "självstängande" ; -- självstängande..av.1
  självsuggestion_1_N = mkN "självsuggestion" ; -- självsuggestion..nn.1
  självsvält_1_N = mkN "självsvält" ; -- självsvält..nn.1
  självsvåld_1_N = mkN "självsvåld" neutrum  ; -- självsvåld..nn.1
  självsvåldig_1_A = mkA "självsvåldig" ; -- självsvåldig..av.1
  självsvåldighet_1_N = mkN "självsvåldighet" ; -- självsvåldighet..nn.1
  självsäker_1_A = mkA "självsäker" ; -- självsäker..av.1
  självsäkerhet_1_N = mkN "självsäkerhet" "självsäkerheter" ; -- självsäkerhet..nn.1
  självsådd_1_N = mkN "självsådd" ; -- självsådd..nn.1
  självterapi_1_N = mkN "självterapi" "självterapier" ; -- självterapi..nn.1
  självtillit_1_N = mkN "självtillit" ; -- självtillit..nn.1
  självtillräcklig_1_A = mkA "självtillräcklig" ; -- självtillräcklig..av.1
  självtillräcklighet_1_N = mkN "självtillräcklighet" ; -- självtillräcklighet..nn.1
  självtorka_1_V = mkV "självtorkar" ; -- självtorka..vb.1
  självtorkande_1_N = mkN "självtorkande" ; -- självtorkande..nn.1
  självtorkning_1_N = mkN "självtorkning" ; -- självtorkning..nn.1
  självtvivel_1_N = mkN "självtvivel" neutrum  ; -- självtvivel..nn.1
  självtvivlande_1_A = mkA "självtvivlande" ; -- självtvivlande..av.1
  självtäkt_1_N = mkN "självtäkt" ; -- självtäkt..nn.1
  självtända_1_V = mkV "självtänder" ; -- självtända..vb.1
  självtändande_1_N = mkN "självtändande" ; -- självtändande..nn.1
  självtändning_1_N = mkN "självtändning" ; -- självtändning..nn.1
  självuppfattning_1_N = mkN "självuppfattning" ; -- självuppfattning..nn.1
  självuppfyllande_1_A = mkA "självuppfyllande" ; -- självuppfyllande..av.1
  självupplevd_1_A = mkA "självupplevd" "självupplevt" ; -- självupplevd..av.1
  självupplevdhet_1_N = mkN "självupplevdhet" ; -- självupplevdhet..nn.1
  självuppoffrande_1_A = mkA "självuppoffrande" ; -- självuppoffrande..av.1
  självuppoffring_1_N = mkN "självuppoffring" ; -- självuppoffring..nn.1
  självupptagen_1_A = mkA "självupptagen" ; -- självupptagen..av.1
  självupptagenhet_1_N = mkN "självupptagenhet" ; -- självupptagenhet..nn.1
  självurladdning_1_N = mkN "självurladdning" ; -- självurladdning..nn.1
  självutlämnande_1_A = mkA "självutlämnande" ; -- självutlämnande..av.1
  självutlösare_1_N = mkN "självutlösare" utrum  ; -- självutlösare..nn.1
  självutnämnd_1_A = mkA "självutnämnd" ; -- självutnämnd..av.1
  självutplånande_1_A = mkA "självutplånande" ; -- självutplånande..av.1
  självutplåning_1_N = mkN "självutplåning" ; -- självutplåning..nn.1
  självvald_1_A = mkA "självvald" "självvalt" ; -- självvald..av.1
  självverksamhet_1_N = mkN "självverksamhet" ; -- självverksamhet..nn.1
  själväckel_1_N = mkN "själväckel" neutrum  ; -- själväckel..nn.1
  självägande_1_A = mkA "självägande" ; -- självägande..av.1
  självändamål_1_N = mkN "självändamål" neutrum  ; -- självändamål..nn.1
  självömkande_1_N = mkN "självömkande" ; -- självömkande..nn.1
  självöverskattning_1_N = mkN "självöverskattning" ; -- självöverskattning..nn.1
  självövervinnelse_1_N = mkN "självövervinnelse" utrum  ; -- självövervinnelse..nn.1
  sjätte_1_A = mkA "sjätte" ; -- sjätte..av.1
  sjättedel_1_N = mkN "sjättedel" "sjättedelen" "sjättedelar" "sjättedelarna" ; -- sjättedel..nn.1
  sjätteplats_1_N = mkN "sjätteplats" "sjätteplatser" ; -- sjätteplats..nn.1
  sjå_1_N = mkN "sjå" neutrum  ; -- sjå..nn.1
  sjåa_1_V = mkV "sjåar" ; -- sjåa..vb.1
  sjåande_1_N = mkN "sjåande" ; -- sjåande..nn.1
  sjåare_1_N = mkN "sjåare" utrum  ; -- sjåare..nn.1
  sjåp_1_N = mkN "sjåp" neutrum  ; -- sjåp..nn.1
  sjåperi_1_N = mkN "sjåperi" "sjåperiet" "sjåperier" "sjåperierna" ; -- sjåperi..nn.1
  sjåpig_1_A = mkA "sjåpig" ; -- sjåpig..av.1
  sjåpighet_1_N = mkN "sjåpighet" ; -- sjåpighet..nn.1
  sjö_1_N = mkN "sjö" ; -- sjö..nn.1
  sjöartilleri_1_N = mkN "sjöartilleri" neutrum  ; -- sjöartilleri..nn.1
  sjöavlagring_1_N = mkN "sjöavlagring" ; -- sjöavlagring..nn.1
  sjöbefäl_1_N = mkN "sjöbefäl" neutrum  ; -- sjöbefäl..nn.1
  sjöbjörn_1_N = mkN "sjöbjörn" ; -- sjöbjörn..nn.1
  sjöblöt_1_A = mkA "sjöblöt" ; -- sjöblöt..av.1
  sjöbod_1_N = mkN "sjöbod" ; -- sjöbod..nn.1
  sjöborre_1_N = mkN "sjöborre" utrum  ; -- sjöborre..nn.1
  sjöbotten_1_N = mkN "sjöbotten" ; -- sjöbotten..nn.1
  sjöbris_1_N = mkN "sjöbris" ; -- sjöbris..nn.1
  sjöbuss_1_N = mkN "sjöbuss" ; -- sjöbuss..nn.1
  sjödränkt_1_A = mkA "sjödränkt" "sjödränkt" ; -- sjödränkt..av.1
  sjöduglig_1_A = mkA "sjöduglig" ; -- sjöduglig..av.1
  sjöduglighet_1_N = mkN "sjöduglighet" ; -- sjöduglighet..nn.1
  sjöelefant_1_N = mkN "sjöelefant" "sjöelefanter" ; -- sjöelefant..nn.1
  sjöfarande_1_A = mkA "sjöfarande" ; -- sjöfarande..av.1
  sjöfarande_1_N = mkN "sjöfarande" ; -- sjöfarande..nn.1
  sjöfarare_1_N = mkN "sjöfarare" utrum  ; -- sjöfarare..nn.1
  sjöfart_1_N = mkN "sjöfart" ; -- sjöfart..nn.1
  sjöfartsmuseum_1_N = mkN "sjöfartsmuseum" "sjöfartsmuseet" "sjöfartsmuseer" "sjöfartsmuseerna" ; -- sjöfartsmuseum..nn.1
  sjöfartspolitik_1_N = mkN "sjöfartspolitik" ; -- sjöfartspolitik..nn.1
  sjöfartspolitisk_1_A = mkA "sjöfartspolitisk" ; -- sjöfartspolitisk..av.1
  sjöfartsregel_1_N = mkN "sjöfartsregel" "sjöfartsregeln" "sjöfartsregler" "sjöfartsreglerna" ; -- sjöfartsregel..nn.1
  sjöfartsverk_1_N = mkN "sjöfartsverk" neutrum  ; -- sjöfartsverk..nn.1
  sjöflygplan_1_N = mkN "sjöflygplan" neutrum  ; -- sjöflygplan..nn.1
  sjöfolk_1_N = mkN "sjöfolk" neutrum  ; -- sjöfolk..nn.1
  sjöfrakt_1_N = mkN "sjöfrakt" "sjöfrakter" ; -- sjöfrakt..nn.1
  sjöfylleri_1_N = mkN "sjöfylleri" neutrum  ; -- sjöfylleri..nn.1
  sjöfyllerist_1_N = mkN "sjöfyllerist" "sjöfyllerister" ; -- sjöfyllerist..nn.1
  sjöfynd_1_N = mkN "sjöfynd" neutrum  ; -- sjöfynd..nn.1
  sjöfärd_1_N = mkN "sjöfärd" "sjöfärder" ; -- sjöfärd..nn.1
  sjöfågel_1_N = mkN "sjöfågel" ; -- sjöfågel..nn.1
  sjöfågelsjakt_1_N = mkN "sjöfågelsjakt" "sjöfågelsjakter" ; -- sjöfågelsjakt..nn.1
  sjöförhör_1_N = mkN "sjöförhör" neutrum  ; -- sjöförhör..nn.1
  sjöförklaring_1_N = mkN "sjöförklaring" ; -- sjöförklaring..nn.1
  sjöförsvar_1_N = mkN "sjöförsvar" neutrum  ; -- sjöförsvar..nn.1
  sjögräs_1_N = mkN "sjögräs" neutrum  ; -- sjögräs..nn.1
  sjögurka_1_N = mkN "sjögurka" ; -- sjögurka..nn.1
  sjögående_1_A = mkA "sjögående" ; -- sjögående..av.1
  sjögång_1_N = mkN "sjögång" ; -- sjögång..nn.1
  sjöhistorisk_1_A = mkA "sjöhistorisk" ; -- sjöhistorisk..av.1
  sjöhäst_1_N = mkN "sjöhäst" ; -- sjöhäst..nn.1
  sjöhävning_1_N = mkN "sjöhävning" ; -- sjöhävning..nn.1
  sjöjungfru_1_N = mkN "sjöjungfru" "sjöjungfrun" "sjöjungfrur" "sjöjungfrurna" ; -- sjöjungfru..nn.1
  sjökapten_1_N = mkN "sjökapten" "sjökaptener" ; -- sjökapten..nn.1
  sjökaptensbrev_1_N = mkN "sjökaptensbrev" neutrum  ; -- sjökaptensbrev..nn.1
  sjöko_1_N = mkN "sjöko" "sjökor" ; -- sjöko..nn.1
  sjökort_1_N = mkN "sjökort" neutrum  ; -- sjökort..nn.1
  sjökortsplotter_1_N = mkN "sjökortsplotter" ; -- sjökortsplotter..nn.1
  sjökrig_1_N = mkN "sjökrig" neutrum  ; -- sjökrig..nn.1
  sjöledes_1_Adv = mkAdv "sjöledes" ; -- sjöledes..ab.1
  sjölejon_1_N = mkN "sjölejon" neutrum  ; -- sjölejon..nn.1
  sjöleopard_1_N = mkN "sjöleopard" "sjöleoparder" ; -- sjöleopard..nn.1
  sjöluft_1_N = mkN "sjöluft" ; -- sjöluft..nn.1
  sjölägenhet_1_N = mkN "sjölägenhet" "sjölägenheter" ; -- sjölägenhet..nn.1
  sjömakt_1_N = mkN "sjömakt" "sjömakter" ; -- sjömakt..nn.1
  sjömalm_1_N = mkN "sjömalm" ; -- sjömalm..nn.1
  sjöman_1_N = mkN "sjöman" "sjömannen" "sjömän" "sjömännen" ; -- sjöman..nn.1
  sjömaning_1_N = mkN "sjömaning" ; -- sjömaning..nn.1
  sjömansbiff_1_N = mkN "sjömansbiff" ; -- sjömansbiff..nn.1
  sjömansblus_1_N = mkN "sjömansblus" ; -- sjömansblus..nn.1
  sjömansbyxa_1_N = mkN "sjömansbyxa" ; -- sjömansbyxa..nn.1
  sjömansförmedling_1_N = mkN "sjömansförmedling" ; -- sjömansförmedling..nn.1
  sjömanshus_1_N = mkN "sjömanshus" neutrum  ; -- sjömanshus..nn.1
  sjömanskap_1_N = mkN "sjömanskap" neutrum  ; -- sjömanskap..nn.1
  sjömanskista_1_N = mkN "sjömanskista" ; -- sjömanskista..nn.1
  sjömansklänning_1_N = mkN "sjömansklänning" ; -- sjömansklänning..nn.1
  sjömansknop_1_N = mkN "sjömansknop" ; -- sjömansknop..nn.1
  sjömanskrage_1_N = mkN "sjömanskrage" utrum  ; -- sjömanskrage..nn.1
  sjömansmässig_1_A = mkA "sjömansmässig" ; -- sjömansmässig..av.1
  sjömanssäck_1_N = mkN "sjömanssäck" ; -- sjömanssäck..nn.1
  sjömansutbildning_1_N = mkN "sjömansutbildning" ; -- sjömansutbildning..nn.1
  sjömansvisa_1_N = mkN "sjömansvisa" ; -- sjömansvisa..nn.1
  sjömil_1_N = mkN "sjömil" "sjömilen" "sjömil" "sjömilen" ; -- sjömil..nn.1
  sjömina_1_N = mkN "sjömina" ; -- sjömina..nn.1
  sjömärke_1_N = mkN "sjömärke" ; -- sjömärke..nn.1
  sjömätning_1_N = mkN "sjömätning" ; -- sjömätning..nn.1
  sjönöd_1_N = mkN "sjönöd" ; -- sjönöd..nn.1
  sjönöt_1_N = mkN "sjönöt" ; -- sjönöt..nn.1
  sjöodjur_1_N = mkN "sjöodjur" neutrum  ; -- sjöodjur..nn.1
  sjöoduglig_1_A = mkA "sjöoduglig" ; -- sjöoduglig..av.1
  sjöofficer_1_N = mkN "sjöofficer" "sjöofficeren" "sjöofficerare" "sjöofficerarna" ; -- sjöofficer..nn.1
  sjöolycka_1_N = mkN "sjöolycka" ; -- sjöolycka..nn.1
  sjöorm_1_N = mkN "sjöorm" ; -- sjöorm..nn.1
  sjöorre_1_N = mkN "sjöorre" utrum  ; -- sjöorre..nn.1
  sjöpenna_1_N = mkN "sjöpenna" ; -- sjöpenna..nn.1
  sjöpung_1_N = mkN "sjöpung" ; -- sjöpung..nn.1
  sjörapport_1_N = mkN "sjörapport" "sjörapporter" ; -- sjörapport..nn.1
  sjöreglering_1_N = mkN "sjöreglering" ; -- sjöreglering..nn.1
  sjöresa_1_N = mkN "sjöresa" ; -- sjöresa..nn.1
  sjöräddning_1_N = mkN "sjöräddning" ; -- sjöräddning..nn.1
  sjörätt_1_N = mkN "sjörätt" ; -- sjörätt..nn.1
  sjörå_1_N = mkN "sjörå" "sjörån" "sjörån" "sjöråna" ; -- sjörå..nn.1
  sjörök_1_N = mkN "sjörök" ; -- sjörök..nn.1
  sjörövare_1_N = mkN "sjörövare" utrum  ; -- sjörövare..nn.1
  sjörövarkapten_1_N = mkN "sjörövarkapten" "sjörövarkaptener" ; -- sjörövarkapten..nn.1
  sjöröveri_1_N = mkN "sjöröveri" "sjöröveriet" "sjöröverier" "sjöröverierna" ; -- sjöröveri..nn.1
  sjösediment_1_N = mkN "sjösediment" neutrum  ; -- sjösediment..nn.1
  sjösida_1_N = mkN "sjösida" ; -- sjösida..nn.1
  sjösjuk_1_A = mkA "sjösjuk" ; -- sjösjuk..av.1
  sjösjuka_1_N = mkN "sjösjuka" ; -- sjösjuka..nn.1
  sjösjukhet_1_N = mkN "sjösjukhet" ; -- sjösjukhet..nn.1
  sjöskumspipa_1_N = mkN "sjöskumspipa" ; -- sjöskumspipa..nn.1
  sjöslag_1_N = mkN "sjöslag" neutrum  ; -- sjöslag..nn.1
  sjöstjärna_1_N = mkN "sjöstjärna" ; -- sjöstjärna..nn.1
  sjöstrid_1_N = mkN "sjöstrid" "sjöstrider" ; -- sjöstrid..nn.1
  sjöstövel_1_N = mkN "sjöstövel" ; -- sjöstövel..nn.1
  sjösäker_1_A = mkA "sjösäker" ; -- sjösäker..av.1
  sjösäkerhet_1_N = mkN "sjösäkerhet" ; -- sjösäkerhet..nn.1
  sjösäkerhetsmässig_1_A = mkA "sjösäkerhetsmässig" ; -- sjösäkerhetsmässig..av.1
  sjösätta_1_V = mkV "sjösätta" "sjösätter" "sjösätt" "sjösatte" "sjösatt" "sjösatt" ; -- sjösätta..vb.1
  sjösättande_1_N = mkN "sjösättande" ; -- sjösättande..nn.1
  sjösättning_1_N = mkN "sjösättning" ; -- sjösättning..nn.1
  sjöterrass_1_N = mkN "sjöterrass" "sjöterrasser" ; -- sjöterrass..nn.1
  sjötjocka_1_N = mkN "sjötjocka" ; -- sjötjocka..nn.1
  sjötomt_1_N = mkN "sjötomt" "sjötomter" ; -- sjötomt..nn.1
  sjötransport_1_N = mkN "sjötransport" "sjötransporter" ; -- sjötransport..nn.1
  sjötunga_1_N = mkN "sjötunga" ; -- sjötunga..nn.1
  sjöutsikt_1_N = mkN "sjöutsikt" ; -- sjöutsikt..nn.1
  sjövan_1_A = mkA "sjövan" ; -- sjövan..av.1
  sjövana_1_N = mkN "sjövana" ; -- sjövana..nn.1
  sjövatten_1_N = mkN "sjövatten" "sjövattnet" "sjövatten" "sjövattnen" ; -- sjövatten..nn.1
  sjövild_1_A = mkA "sjövild" "sjövilt" ; -- sjövild..av.1
  sjövildhet_1_N = mkN "sjövildhet" ; -- sjövildhet..nn.1
  sjöväg_1_N = mkN "sjöväg" ; -- sjöväg..nn.1
  sjövägsregel_1_N = mkN "sjövägsregel" "sjövägsregeln" "sjövägsregler" "sjövägsreglerna" ; -- sjövägsregel..nn.1
  sjövärdig_1_A = mkA "sjövärdig" ; -- sjövärdig..av.1
  sjövärdighet_1_N = mkN "sjövärdighet" "sjövärdigheter" ; -- sjövärdighet..nn.1
  sjöyta_1_N = mkN "sjöyta" ; -- sjöyta..nn.1
  skabb_1_N = mkN "skabb" ; -- skabb..nn.1
  skabbdjur_1_N = mkN "skabbdjur" neutrum  ; -- skabbdjur..nn.1
  skabbig_1_A = mkA "skabbig" ; -- skabbig..av.1
  skabbighet_1_N = mkN "skabbighet" ; -- skabbighet..nn.1
  skabrös_1_A = mkA "skabrös" ; -- skabrös..av.1
  skackel_1_N = mkN "skackel" ; -- skackel..nn.1
  skada_1_A = mkA "skada" ; -- skada..av.1
  skada_1_N = mkN "skada" ; -- skada..nn.1
  skada_1_V = mkV "skadar" ; -- skada..vb.1
  skadande_1_N = mkN "skadande" ; -- skadande..nn.1
  skadedjur_1_N = mkN "skadedjur" neutrum  ; -- skadedjur..nn.1
  skadedjursbekämpning_1_N = mkN "skadedjursbekämpning" ; -- skadedjursbekämpning..nn.1
  skadedrabbad_1_A = mkA "skadedrabbad" ; -- skadedrabbad..av.1
  skadeersättning_1_N = mkN "skadeersättning" ; -- skadeersättning..nn.1
  skadefri_1_A = mkA "skadefri" "skadefritt" ; -- skadefri..av.1
  skadeförebyggande_1_A = mkA "skadeförebyggande" ; -- skadeförebyggande..av.1
  skadeglad_1_A = mkA "skadeglad" "skadeglatt" ; -- skadeglad..av.1
  skadeglädje_1_N = mkN "skadeglädje" utrum  ; -- skadeglädje..nn.1
  skadegörare_1_N = mkN "skadegörare" utrum  ; -- skadegörare..nn.1
  skadegörelse_1_N = mkN "skadegörelse" "skadegörelser" ; -- skadegörelse..nn.1
  skadeinsekt_1_N = mkN "skadeinsekt" "skadeinsekter" ; -- skadeinsekt..nn.1
  skademinimering_1_N = mkN "skademinimering" ; -- skademinimering..nn.1
  skadereglera_1_V = mkV "skadereglerar" ; -- skadereglera..vb.1
  skadereglerande_1_N = mkN "skadereglerande" ; -- skadereglerande..nn.1
  skadereglerbar_1_A = mkA "skadereglerbar" ; -- skadereglerbar..av.1
  skadereglerbarhet_1_N = mkN "skadereglerbarhet" ; -- skadereglerbarhet..nn.1
  skadereglering_1_N = mkN "skadereglering" ; -- skadereglering..nn.1
  skadeskjuta_1_V = mkV "skadeskjuta" "skadesköt" "skadeskjutit" ; -- skadeskjuta..vb.1
  skadeskjutande_1_N = mkN "skadeskjutande" ; -- skadeskjutande..nn.1
  skadeskjutning_1_N = mkN "skadeskjutning" ; -- skadeskjutning..nn.1
  skadeslös_1_A = mkA "skadeslös" ; -- skadeslös..av.1
  skadeslöshet_1_N = mkN "skadeslöshet" ; -- skadeslöshet..nn.1
  skadestånd_1_N = mkN "skadestånd" neutrum  ; -- skadestånd..nn.1
  skadeståndsansvar_1_N = mkN "skadeståndsansvar" neutrum  ; -- skadeståndsansvar..nn.1
  skadeståndskrav_1_N = mkN "skadeståndskrav" neutrum  ; -- skadeståndskrav..nn.1
  skadeståndsrättslig_1_A = mkA "skadeståndsrättslig" ; -- skadeståndsrättslig..av.1
  skadeståndsskyldig_1_A = mkA "skadeståndsskyldig" ; -- skadeståndsskyldig..av.1
  skadeståndsskyldighet_1_N = mkN "skadeståndsskyldighet" ; -- skadeståndsskyldighet..nn.1
  skadeståndsyrkande_1_N = mkN "skadeståndsyrkande" ; -- skadeståndsyrkande..nn.1
  skadeverkning_1_N = mkN "skadeverkning" ; -- skadeverkning..nn.1
  skadevärdering_1_N = mkN "skadevärdering" ; -- skadevärdering..nn.1
  skadeväxt_1_N = mkN "skadeväxt" "skadeväxter" ; -- skadeväxt..nn.1
  skadlig_1_A = mkA "skadlig" ; -- skadlig..av.1
  skadlighet_1_N = mkN "skadlighet" "skadligheter" ; -- skadlighet..nn.1
  skadskjuta_1_V = mkV "skadskjuta" "skadsköt" "skadskjutit" ; -- skadskjuta..vb.1
  skadskjutande_1_N = mkN "skadskjutande" ; -- skadskjutande..nn.1
  skadskjutning_1_N = mkN "skadskjutning" ; -- skadskjutning..nn.1
  skaffa_1_V = mkV "skaffar" ; -- skaffa..vb.1
  skaffande_1_N = mkN "skaffande" ; -- skaffande..nn.1
  skaffare_1_N = mkN "skaffare" utrum  ; -- skaffare..nn.1
  skafferi_1_N = mkN "skafferi" "skafferiet" "skafferier" "skafferierna" ; -- skafferi..nn.1
  skafferihylla_1_N = mkN "skafferihylla" ; -- skafferihylla..nn.1
  skaffning_1_N = mkN "skaffning" ; -- skaffning..nn.1
  skaft_1_N = mkN "skaft" neutrum  ; -- skaft..nn.1
  skafta_1_V = mkV "skaftar" ; -- skafta..vb.1
  skaftande_1_N = mkN "skaftande" ; -- skaftande..nn.1
  skak_1_N = mkN "skak" neutrum  ; -- skak..nn.1
  skaka_1_V = mkV "skakar" ; -- skaka..vb.1
  skaka_2_V = mkV "skakar" ; -- skaka..vb.2
  skakad_1_A = mkA "skakad" ; -- skakad..av.1
  skakande_1_A = mkA "skakande" ; -- skakande..av.1
  skakande_1_N = mkN "skakande" ; -- skakande..nn.1
  skakel_1_N = mkN "skakel" ; -- skakel..nn.1
  skakig_1_A = mkA "skakig" ; -- skakig..av.1
  skakinkubator_1_N = mkN "skakinkubator" "skakinkubatorer" ; -- skakinkubator..nn.1
  skakis_1_A = mkA "skakis" ; -- skakis..av.1
  skakning_1_N = mkN "skakning" ; -- skakning..nn.1
  skaktålig_1_A = mkA "skaktålig" ; -- skaktålig..av.1
  skaktålighet_1_N = mkN "skaktålighet" ; -- skaktålighet..nn.1
  skal_1_N = mkN "skal" neutrum  ; -- skal..nn.1
  skala_1_N = mkN "skala" ; -- skala..nn.1
  skala_1_V = mkV "skalar" ; -- skala..vb.1
  skala_2_V = mkV "skalar" ; -- skala..vb.2
  skalande_1_N = mkN "skalande" ; -- skalande..nn.1
  skalbagge_1_N = mkN "skalbagge" utrum  ; -- skalbagge..nn.1
  skalbolag_1_N = mkN "skalbolag" neutrum  ; -- skalbolag..nn.1
  skald_1_N = mkN "skald" "skalder" ; -- skald..nn.1
  skalda_1_V = mkV "skaldar" ; -- skalda..vb.1
  skaldande_1_N = mkN "skaldande" ; -- skaldande..nn.1
  skaldegåva_1_N = mkN "skaldegåva" ; -- skaldegåva..nn.1
  skaldekonst_1_N = mkN "skaldekonst" "skaldekonster" ; -- skaldekonst..nn.1
  skaldestycke_1_N = mkN "skaldestycke" ; -- skaldestycke..nn.1
  skaldisk_1_A = mkA "skaldisk" ; -- skaldisk..av.1
  skaldjur_1_N = mkN "skaldjur" neutrum  ; -- skaldjur..nn.1
  skaldjursrest_1_N = mkN "skaldjursrest" "skaldjursrester" ; -- skaldjursrest..nn.1
  skaldskap_1_N = mkN "skaldskap" neutrum  ; -- skaldskap..nn.1
  skalenlig_1_A = mkA "skalenlig" ; -- skalenlig..av.1
  skalenlighet_1_N = mkN "skalenlighet" ; -- skalenlighet..nn.1
  skalhus_1_N = mkN "skalhus" neutrum  ; -- skalhus..nn.1
  skalk_1_N = mkN "skalk" ; -- skalk..nn.1
  skalka_1_V = mkV "skalkar" ; -- skalka..vb.1
  skalkaktig_1_A = mkA "skalkaktig" ; -- skalkaktig..av.1
  skalkaktighet_1_N = mkN "skalkaktighet" ; -- skalkaktighet..nn.1
  skalkande_1_N = mkN "skalkande" ; -- skalkande..nn.1
  skalkeskjul_1_N = mkN "skalkeskjul" neutrum  ; -- skalkeskjul..nn.1
  skalkorn_1_N = mkN "skalkorn" neutrum  ; -- skalkorn..nn.1
  skall_1_N = mkN "skall" neutrum  ; -- skall..nn.1
  skalla_1_V = mkV "skallar" ; -- skalla..vb.1
  skalla_2_V = mkV "skallar" ; -- skalla..vb.2
  skallande_1_N = mkN "skallande" ; -- skallande..nn.1
  skallbas_1_N = mkN "skallbas" "skallbaser" ; -- skallbas..nn.1
  skallben_1_N = mkN "skallben" neutrum  ; -- skallben..nn.1
  skallblödning_1_N = mkN "skallblödning" ; -- skallblödning..nn.1
  skalle_1_N = mkN "skalle" utrum  ; -- skalle..nn.1
  skaller_1_N = mkN "skaller" neutrum  ; -- skaller..nn.1
  skallerorm_1_N = mkN "skallerorm" ; -- skallerorm..nn.1
  skallform_1_N = mkN "skallform" "skallformer" ; -- skallform..nn.1
  skallgång_1_N = mkN "skallgång" ; -- skallgång..nn.1
  skallgångskedja_1_N = mkN "skallgångskedja" ; -- skallgångskedja..nn.1
  skallig_1_A = mkA "skallig" ; -- skallig..av.1
  skallighet_1_N = mkN "skallighet" ; -- skallighet..nn.1
  skallra_1_N = mkN "skallra" ; -- skallra..nn.1
  skallra_1_V = mkV "skallrar" ; -- skallra..vb.1
  skallrande_1_N = mkN "skallrande" ; -- skallrande..nn.1
  skallskada_1_N = mkN "skallskada" ; -- skallskada..nn.1
  skallös_1_A = mkA "skallös" ; -- skallös..av.1
  skallöshet_1_N = mkN "skallöshet" ; -- skallöshet..nn.1
  skalm_1_N = mkN "skalm" ; -- skalm..nn.1
  skalmeja_1_N = mkN "skalmeja" ; -- skalmeja..nn.1
  skalning_1_N = mkN "skalning" ; -- skalning..nn.1
  skalp_1_N = mkN "skalp" "skalper" ; -- skalp..nn.1
  skalpell_1_N = mkN "skalpell" "skalpeller" ; -- skalpell..nn.1
  skalpera_1_V = mkV "skalperar" ; -- skalpera..vb.1
  skalperande_1_N = mkN "skalperande" ; -- skalperande..nn.1
  skalperbar_1_A = mkA "skalperbar" ; -- skalperbar..av.1
  skalperbarhet_1_N = mkN "skalperbarhet" ; -- skalperbarhet..nn.1
  skalpering_1_N = mkN "skalpering" ; -- skalpering..nn.1
  skalperkniv_1_N = mkN "skalperkniv" ; -- skalperkniv..nn.1
  skalskydd_1_N = mkN "skalskydd" neutrum  ; -- skalskydd..nn.1
  skalstreck_1_N = mkN "skalstreck" neutrum  ; -- skalstreck..nn.1
  skaltyp_1_N = mkN "skaltyp" "skaltyper" ; -- skaltyp..nn.1
  skalv_1_N = mkN "skalv" neutrum  ; -- skalv..nn.1
  skalär_1_A = mkA "skalär" ; -- skalär..av.1
  skalär_1_N = mkN "skalär" "skalärer" ; -- skalär..nn.1
  skalövning_1_N = mkN "skalövning" ; -- skalövning..nn.1
  skambelagd_1_A = mkA "skambelagd" "skambelagt" ; -- skambelagd..av.1
  skambelägga_1_V = mkV "skambelägga" "skambela" "skambelagt" ; -- skambelägga..vb.1
  skamfila_1_V = mkV "skamfilar" ; -- skamfila..vb.1
  skamfilande_1_N = mkN "skamfilande" ; -- skamfilande..nn.1
  skamfilning_1_N = mkN "skamfilning" ; -- skamfilning..nn.1
  skamflat_1_A = mkA "skamflat" ; -- skamflat..av.1
  skamfläck_1_N = mkN "skamfläck" ; -- skamfläck..nn.1
  skamgrepp_1_N = mkN "skamgrepp" neutrum  ; -- skamgrepp..nn.1
  skamkänsla_1_N = mkN "skamkänsla" ; -- skamkänsla..nn.1
  skamlig_1_A = mkA "skamlig" ; -- skamlig..av.1
  skamligen_1_Adv = mkAdv "skamligen" ; -- skamligen..ab.1
  skamlighet_1_N = mkN "skamlighet" "skamligheter" ; -- skamlighet..nn.1
  skamlös_1_A = mkA "skamlös" ; -- skamlös..av.1
  skamlöshet_1_N = mkN "skamlöshet" "skamlösheter" ; -- skamlöshet..nn.1
  skampåle_1_N = mkN "skampåle" utrum  ; -- skampåle..nn.1
  skamrodnad_1_N = mkN "skamrodnad" ; -- skamrodnad..nn.1
  skamsen_1_A = mkA "skamsen" ; -- skamsen..av.1
  skamsenhet_1_N = mkN "skamsenhet" ; -- skamsenhet..nn.1
  skamstock_1_N = mkN "skamstock" ; -- skamstock..nn.1
  skamvrå_1_N = mkN "skamvrå" ; -- skamvrå..nn.1
  skandal_1_N = mkN "skandal" "skandaler" ; -- skandal..nn.1
  skandalartad_1_A = mkA "skandalartad" ; -- skandalartad..av.1
  skandalavlyssning_1_N = mkN "skandalavlyssning" ; -- skandalavlyssning..nn.1
  skandalavslöjande_1_N = mkN "skandalavslöjande" ; -- skandalavslöjande..nn.1
  skandalbild_1_N = mkN "skandalbild" "skandalbilder" ; -- skandalbild..nn.1
  skandalhistoria_1_N = mkN "skandalhistoria" "skandalhistorian" "skandalhistorier" "skandalhistorierna" ; -- skandalhistoria..nn.1
  skandalhunger_1_N = mkN "skandalhunger" ; -- skandalhunger..nn.1
  skandalhungrig_1_A = mkA "skandalhungrig" ; -- skandalhungrig..av.1
  skandalisera_1_V = mkV "skandaliserar" ; -- skandalisera..vb.1
  skandaliserande_1_N = mkN "skandaliserande" ; -- skandaliserande..nn.1
  skandaliserbar_1_A = mkA "skandaliserbar" ; -- skandaliserbar..av.1
  skandaliserbarhet_1_N = mkN "skandaliserbarhet" ; -- skandaliserbarhet..nn.1
  skandalisering_1_N = mkN "skandalisering" ; -- skandalisering..nn.1
  skandalkrönika_1_N = mkN "skandalkrönika" ; -- skandalkrönika..nn.1
  skandallysten_1_A = mkA "skandallysten" ; -- skandallysten..av.1
  skandallystnad_1_N = mkN "skandallystnad" ; -- skandallystnad..nn.1
  skandalmiss_1_N = mkN "skandalmiss" ; -- skandalmiss..nn.1
  skandalmål_1_N = mkN "skandalmål" neutrum  ; -- skandalmål..nn.1
  skandalomsusad_1_A = mkA "skandalomsusad" ; -- skandalomsusad..av.1
  skandalpress_1_N = mkN "skandalpress" ; -- skandalpress..nn.1
  skandalscen_1_N = mkN "skandalscen" "skandalscener" ; -- skandalscen..nn.1
  skandalskrift_1_N = mkN "skandalskrift" "skandalskrifter" ; -- skandalskrift..nn.1
  skandalskrivare_1_N = mkN "skandalskrivare" utrum  ; -- skandalskrivare..nn.1
  skandalskriveri_1_N = mkN "skandalskriveri" "skandalskriveriet" "skandalskriverier" "skandalskriverierna" ; -- skandalskriveri..nn.1
  skandaltidning_1_N = mkN "skandaltidning" ; -- skandaltidning..nn.1
  skandalunge_1_N = mkN "skandalunge" utrum  ; -- skandalunge..nn.1
  skandalös_1_A = mkA "skandalös" ; -- skandalös..av.1
  skandera_1_V = mkV "skanderar" ; -- skandera..vb.1
  skanderande_1_N = mkN "skanderande" ; -- skanderande..nn.1
  skanderbar_1_A = mkA "skanderbar" ; -- skanderbar..av.1
  skanderbarhet_1_N = mkN "skanderbarhet" ; -- skanderbarhet..nn.1
  skandering_1_N = mkN "skandering" ; -- skandering..nn.1
  skandinav_1_N = mkN "skandinav" "skandinaver" ; -- skandinav..nn.1
  skandinavisk_1_A = mkA "skandinavisk" ; -- skandinavisk..av.1
  skandinavism_1_N = mkN "skandinavism" "skandinavismer" ; -- skandinavism..nn.1
  skandinavist_1_N = mkN "skandinavist" "skandinavister" ; -- skandinavist..nn.1
  skandinavistisk_1_A = mkA "skandinavistisk" ; -- skandinavistisk..av.1
  skandium_1_N = mkN "skandium" neutrum  ; -- skandium..nn.1
  skanism_1_N = mkN "skanism" "skanismer" ; -- skanism..nn.1
  skank_1_N = mkN "skank" ; -- skank..nn.1
  skanna_1_V = mkV "skannar" ; -- skanna..vb.1
  skannande_1_N = mkN "skannande" ; -- skannande..nn.1
  skanner_1_N = mkN "skanner" ; -- skanner..nn.1
  skanning_1_N = mkN "skanning" ; -- skanning..nn.1
  skans_1_N = mkN "skans" ; -- skans..nn.1
  skap_1_N = mkN "skap" neutrum  ; -- skap..nn.1
  skapa_1_V = mkV "skapar" ; -- skapa..vb.1
  skapad_1_A = mkA "skapad" ; -- skapad..av.1
  skapande_1_A = mkA "skapande" ; -- skapande..av.1
  skapande_1_N = mkN "skapande" ; -- skapande..nn.1
  skaparanda_1_N = mkN "skaparanda" ; -- skaparanda..nn.1
  skapare_1_N = mkN "skapare" utrum  ; -- skapare..nn.1
  skaparkraft_1_N = mkN "skaparkraft" "skaparkrafter" ; -- skaparkraft..nn.1
  skapelse_1_N = mkN "skapelse" "skapelser" ; -- skapelse..nn.1
  skapelseakt_1_N = mkN "skapelseakt" "skapelseakter" ; -- skapelseakt..nn.1
  skapelseberättelse_1_N = mkN "skapelseberättelse" "skapelseberättelser" ; -- skapelseberättelse..nn.1
  skaplig_1_A = mkA "skaplig" ; -- skaplig..av.1
  skaplighet_1_N = mkN "skaplighet" ; -- skaplighet..nn.1
  skaplynne_1_N = mkN "skaplynne" ; -- skaplynne..nn.1
  skapnad_1_N = mkN "skapnad" "skapnader" ; -- skapnad..nn.1
  skara_1_N = mkN "skara" ; -- skara..nn.1
  skaraborgsk_1_A = mkA "skaraborgsk" ; -- skaraborgsk..av.1
  skarabé_1_N = mkN "skarabé" "skarabéer" ; -- skarabé..nn.1
  skare_1_N = mkN "skare" utrum  ; -- skare..nn.1
  skarf_1_N = mkN "skarf" ; -- skarf..nn.1
  skarn_1_N = mkN "skarn" neutrum  ; -- skarn..nn.1
  skarndäck_1_N = mkN "skarndäck" neutrum  ; -- skarndäck..nn.1
  skarp_1_A = mkA "skarp" ; -- skarp..av.1
  skarp_2_A = mkA "skarp" ; -- skarp..av.2
  skarpblick_1_N = mkN "skarpblick" ; -- skarpblick..nn.1
  skarpeggad_1_A = mkA "skarpeggad" ; -- skarpeggad..av.1
  skarphet_1_N = mkN "skarphet" ; -- skarphet..nn.1
  skarphet_2_N = mkN "skarphet" "skarpheter" ; -- skarphet..nn.2
  skarpkantig_1_A = mkA "skarpkantig" ; -- skarpkantig..av.1
  skarpladdad_1_A = mkA "skarpladdad" ; -- skarpladdad..av.1
  skarprättare_1_N = mkN "skarprättare" utrum  ; -- skarprättare..nn.1
  skarpsill_1_N = mkN "skarpsill" ; -- skarpsill..nn.1
  skarpsinne_1_N = mkN "skarpsinne" ; -- skarpsinne..nn.1
  skarpsinnig_1_A = mkA "skarpsinnig" ; -- skarpsinnig..av.1
  skarpsinnighet_1_N = mkN "skarpsinnighet" ; -- skarpsinnighet..nn.1
  skarpskuren_1_A = mkA "skarpskuren" ; -- skarpskuren..av.1
  skarpskytt_1_N = mkN "skarpskytt" ; -- skarpskytt..nn.1
  skarpslipad_1_A = mkA "skarpslipad" ; -- skarpslipad..av.1
  skarpsyn_1_N = mkN "skarpsyn" "skarpsyner" ; -- skarpsyn..nn.1
  skarpsynt_1_A = mkA "skarpsynt" "skarpsynt" ; -- skarpsynt..av.1
  skarpsynthet_1_N = mkN "skarpsynthet" ; -- skarpsynthet..nn.1
  skarpsås_1_N = mkN "skarpsås" ; -- skarpsås..nn.1
  skarptandad_1_A = mkA "skarptandad" ; -- skarptandad..av.1
  skarpögd_1_A = mkA "skarpögd" "skarpögt" ; -- skarpögd..av.1
  skarpögdhet_1_N = mkN "skarpögdhet" ; -- skarpögdhet..nn.1
  skarsnö_1_N = mkN "skarsnö" ; -- skarsnö..nn.1
  skarv_1_N = mkN "skarv" ; -- skarv..nn.1
  skarva_1_V = mkV "skarvar" ; -- skarva..vb.1
  skarva_2_V = mkV "skarvar" ; -- skarva..vb.2
  skarvande_1_N = mkN "skarvande" ; -- skarvande..nn.1
  skarvklämma_1_N = mkN "skarvklämma" ; -- skarvklämma..nn.1
  skarvpopulation_1_N = mkN "skarvpopulation" ; -- skarvpopulation..nn.1
  skarvrulle_1_N = mkN "skarvrulle" utrum  ; -- skarvrulle..nn.1
  skarvsladd_1_N = mkN "skarvsladd" ; -- skarvsladd..nn.1
  skata_1_N = mkN "skata" ; -- skata..nn.1
  skata_1_V = mkV "skatar" ; -- skata..vb.1
  skatande_1_N = mkN "skatande" ; -- skatande..nn.1
  skate_1_N = mkN "skate" utrum  ; -- skate..nn.1
  skateboard_1_N = mkN "skateboard" "skateboarden" "skateboards" "skateboardsen" ; -- skateboard..nn.1
  skatnäva_1_N = mkN "skatnäva" ; -- skatnäva..nn.1
  skatt_1_N = mkN "skatt" "skatter" ; -- skatt..nn.1
  skatt_2_N = mkN "skatt" "skatter" ; -- skatt..nn.2
  skatta_1_V = mkV "skattar" ; -- skatta..vb.1
  skatta_2_V = mkV "skattar" ; -- skatta..vb.2
  skattande_1_N = mkN "skattande" ; -- skattande..nn.1
  skatteallergisk_1_A = mkA "skatteallergisk" ; -- skatteallergisk..av.1
  skatteavdrag_1_N = mkN "skatteavdrag" neutrum  ; -- skatteavdrag..nn.1
  skattebas_1_N = mkN "skattebas" "skattebaser" ; -- skattebas..nn.1
  skattebefria_1_V = mkV "skattebefriar" ; -- skattebefria..vb.1
  skattebefriande_1_N = mkN "skattebefriande" ; -- skattebefriande..nn.1
  skattebefrielse_1_N = mkN "skattebefrielse" "skattebefrielser" ; -- skattebefrielse..nn.1
  skattebelopp_1_N = mkN "skattebelopp" neutrum  ; -- skattebelopp..nn.1
  skattebetalande_1_A = mkA "skattebetalande" ; -- skattebetalande..av.1
  skattebetalare_1_N = mkN "skattebetalare" utrum  ; -- skattebetalare..nn.1
  skattebetalning_1_N = mkN "skattebetalning" ; -- skattebetalning..nn.1
  skattebonde_1_N = mkN "skattebonde" "skattebönder" ; -- skattebonde..nn.1
  skattebrott_1_N = mkN "skattebrott" neutrum  ; -- skattebrott..nn.1
  skattechock_1_N = mkN "skattechock" "skattechocker" ; -- skattechock..nn.1
  skattefiffel_1_N = mkN "skattefiffel" neutrum  ; -- skattefiffel..nn.1
  skattefiffla_1_V = mkV "skattefifflar" ; -- skattefiffla..vb.1
  skattefifflande_1_N = mkN "skattefifflande" ; -- skattefifflande..nn.1
  skattefifflare_1_N = mkN "skattefifflare" utrum  ; -- skattefifflare..nn.1
  skattefinansierad_1_A = mkA "skattefinansierad" ; -- skattefinansierad..av.1
  skatteflykt_1_N = mkN "skatteflykt" ; -- skatteflykt..nn.1
  skattefri_1_A = mkA "skattefri" "skattefritt" ; -- skattefri..av.1
  skattefrihet_1_N = mkN "skattefrihet" "skattefriheter" ; -- skattefrihet..nn.1
  skattefråga_1_N = mkN "skattefråga" ; -- skattefråga..nn.1
  skattefusk_1_N = mkN "skattefusk" neutrum  ; -- skattefusk..nn.1
  skattefuskare_1_N = mkN "skattefuskare" utrum  ; -- skattefuskare..nn.1
  skatteförmåga_1_N = mkN "skatteförmåga" ; -- skatteförmåga..nn.1
  skatteförslag_1_N = mkN "skatteförslag" neutrum  ; -- skatteförslag..nn.1
  skattehemman_1_N = mkN "skattehemman" neutrum  ; -- skattehemman..nn.1
  skattehöjning_1_N = mkN "skattehöjning" ; -- skattehöjning..nn.1
  skatteinbetalning_1_N = mkN "skatteinbetalning" ; -- skatteinbetalning..nn.1
  skatteindrivare_1_N = mkN "skatteindrivare" utrum  ; -- skatteindrivare..nn.1
  skatteingenjör_1_N = mkN "skatteingenjör" "skatteingenjörer" ; -- skatteingenjör..nn.1
  skatteinkomst_1_N = mkN "skatteinkomst" "skatteinkomster" ; -- skatteinkomst..nn.1
  skatteintäkt_1_N = mkN "skatteintäkt" "skatteintäkter" ; -- skatteintäkt..nn.1
  skattekil_1_N = mkN "skattekil" ; -- skattekil..nn.1
  skatteklass_1_N = mkN "skatteklass" "skatteklasser" ; -- skatteklass..nn.1
  skattekort_1_N = mkN "skattekort" neutrum  ; -- skattekort..nn.1
  skattekraft_1_N = mkN "skattekraft" "skattekrafter" ; -- skattekraft..nn.1
  skattekrona_1_N = mkN "skattekrona" ; -- skattekrona..nn.1
  skattekverulant_1_N = mkN "skattekverulant" "skattekverulanter" ; -- skattekverulant..nn.1
  skattelag_1_N = mkN "skattelag" ; -- skattelag..nn.1
  skattelättnad_1_N = mkN "skattelättnad" "skattelättnader" ; -- skattelättnad..nn.1
  skattemedel_1_N = mkN "skattemedel" neutrum  ; -- skattemedel..nn.1
  skattemoral_1_N = mkN "skattemoral" "skattemoraler" ; -- skattemoral..nn.1
  skattemyndighet_1_N = mkN "skattemyndighet" "skattemyndigheter" ; -- skattemyndighet..nn.1
  skattemärke_1_N = mkN "skattemärke" ; -- skattemärke..nn.1
  skattemässig_1_A = mkA "skattemässig" ; -- skattemässig..av.1
  skattenivå_1_N = mkN "skattenivå" "skattenivåer" ; -- skattenivå..nn.1
  skatteparadis_1_N = mkN "skatteparadis" neutrum  ; -- skatteparadis..nn.1
  skattepeng_1_N = mkN "skattepeng" ; -- skattepeng..nn.1
  skatteplanera_1_V = mkV "skatteplanerar" ; -- skatteplanera..vb.1
  skatteplanerande_1_N = mkN "skatteplanerande" ; -- skatteplanerande..nn.1
  skatteplanerbar_1_A = mkA "skatteplanerbar" ; -- skatteplanerbar..av.1
  skatteplanerbarhet_1_N = mkN "skatteplanerbarhet" ; -- skatteplanerbarhet..nn.1
  skatteplanering_1_N = mkN "skatteplanering" ; -- skatteplanering..nn.1
  skatteplikt_1_N = mkN "skatteplikt" ; -- skatteplikt..nn.1
  skattepliktig_1_A = mkA "skattepliktig" ; -- skattepliktig..av.1
  skattepliktighet_1_N = mkN "skattepliktighet" ; -- skattepliktighet..nn.1
  skattepolitik_1_N = mkN "skattepolitik" ; -- skattepolitik..nn.1
  skattepolitisk_1_A = mkA "skattepolitisk" ; -- skattepolitisk..av.1
  skattepopulism_1_N = mkN "skattepopulism" ; -- skattepopulism..nn.1
  skatteprincip_1_N = mkN "skatteprincip" "skatteprinciper" ; -- skatteprincip..nn.1
  skatteprotest_1_N = mkN "skatteprotest" "skatteprotester" ; -- skatteprotest..nn.1
  skattereduktion_1_N = mkN "skattereduktion" ; -- skattereduktion..nn.1
  skattereform_1_N = mkN "skattereform" "skattereformer" ; -- skattereform..nn.1
  skatteregel_1_N = mkN "skatteregel" "skatteregeln" "skatteregler" "skattereglerna" ; -- skatteregel..nn.1
  skatterevolt_1_N = mkN "skatterevolt" "skatterevolter" ; -- skatterevolt..nn.1
  skatterättslig_1_A = mkA "skatterättslig" ; -- skatterättslig..av.1
  skattesats_1_N = mkN "skattesats" "skattesatser" ; -- skattesats..nn.1
  skatteskala_1_N = mkN "skatteskala" ; -- skatteskala..nn.1
  skattesmitare_1_N = mkN "skattesmitare" utrum  ; -- skattesmitare..nn.1
  skattesmitning_1_N = mkN "skattesmitning" ; -- skattesmitning..nn.1
  skattesmäll_1_N = mkN "skattesmäll" ; -- skattesmäll..nn.1
  skattespöke_1_N = mkN "skattespöke" ; -- skattespöke..nn.1
  skattesubvention_1_N = mkN "skattesubvention" ; -- skattesubvention..nn.1
  skattesubventionerad_1_A = mkA "skattesubventionerad" ; -- skattesubventionerad..av.1
  skattesystem_1_N = mkN "skattesystem" neutrum  ; -- skattesystem..nn.1
  skattesänkarraseri_1_N = mkN "skattesänkarraseri" "skattesänkarraseriet" "skattesänkarraserier" "skattesänkarraserierna" ; -- skattesänkarraseri..nn.1
  skattesänkning_1_N = mkN "skattesänkning" ; -- skattesänkning..nn.1
  skattetabell_1_N = mkN "skattetabell" "skattetabeller" ; -- skattetabell..nn.1
  skattetak_1_N = mkN "skattetak" neutrum  ; -- skattetak..nn.1
  skatteteknisk_1_A = mkA "skatteteknisk" ; -- skatteteknisk..av.1
  skattetillägg_1_N = mkN "skattetillägg" neutrum  ; -- skattetillägg..nn.1
  skattetrixare_1_N = mkN "skattetrixare" utrum  ; -- skattetrixare..nn.1
  skattetryck_1_N = mkN "skattetryck" neutrum  ; -- skattetryck..nn.1
  skattetyngd_1_N = mkN "skattetyngd" ; -- skattetyngd..nn.1
  skatteunderlag_1_N = mkN "skatteunderlag" neutrum  ; -- skatteunderlag..nn.1
  skatteuppbörd_1_N = mkN "skatteuppbörd" "skatteuppbörder" ; -- skatteuppbörd..nn.1
  skatteuppbördsman_1_N = mkN "skatteuppbördsman" "skatteuppbördsmannen" "skatteuppbördsmän" "skatteuppbördsmännen" ; -- skatteuppbördsman..nn.1
  skatteuppskov_1_N = mkN "skatteuppskov" neutrum  ; -- skatteuppskov..nn.1
  skatteutjämning_1_N = mkN "skatteutjämning" ; -- skatteutjämning..nn.1
  skatteutjämningssystem_1_N = mkN "skatteutjämningssystem" neutrum  ; -- skatteutjämningssystem..nn.1
  skatteuttag_1_N = mkN "skatteuttag" neutrum  ; -- skatteuttag..nn.1
  skatteverk_1_N = mkN "skatteverk" neutrum  ; -- skatteverk..nn.1
  skatteväxling_1_N = mkN "skatteväxling" ; -- skatteväxling..nn.1
  skatteärende_1_N = mkN "skatteärende" ; -- skatteärende..nn.1
  skatteåterbäring_1_N = mkN "skatteåterbäring" ; -- skatteåterbäring..nn.1
  skattgömma_1_N = mkN "skattgömma" ; -- skattgömma..nn.1
  skattkammare_1_N = mkN "skattkammare" "skattkammaren" "skattkammare" "skattkamrarna" ; -- skattkammare..nn.1
  skattkammarväxel_1_N = mkN "skattkammarväxel" ; -- skattkammarväxel..nn.1
  skattkista_1_N = mkN "skattkista" ; -- skattkista..nn.1
  skattlägga_1_V = mkV "skattlägga" "skattla" "skattlagt" ; -- skattlägga..vb.1
  skattläggande_1_N = mkN "skattläggande" ; -- skattläggande..nn.1
  skattläggning_1_N = mkN "skattläggning" ; -- skattläggning..nn.1
  skattmas_1_N = mkN "skattmas" ; -- skattmas..nn.1
  skattmästare_1_N = mkN "skattmästare" utrum  ; -- skattmästare..nn.1
  skattning_1_N = mkN "skattning" ; -- skattning..nn.1
  skattsedel_1_N = mkN "skattsedel" ; -- skattsedel..nn.1
  skattskriva_1_V = mkV "skattskriva" "skattskrev" "skattskrivit" ; -- skattskriva..vb.1
  skattskrivande_1_N = mkN "skattskrivande" ; -- skattskrivande..nn.1
  skattskyldig_1_A = mkA "skattskyldig" ; -- skattskyldig..av.1
  skattskyldighet_1_N = mkN "skattskyldighet" ; -- skattskyldighet..nn.1
  skattsökare_1_N = mkN "skattsökare" utrum  ; -- skattsökare..nn.1
  skav_1_N = mkN "skav" neutrum  ; -- skav..nn.1
  skava_1_V = mkV "skaver" ; -- skava..vb.1
  skavande_1_N = mkN "skavande" ; -- skavande..nn.1
  skavank_1_N = mkN "skavank" "skavanker" ; -- skavank..nn.1
  skavning_1_N = mkN "skavning" ; -- skavning..nn.1
  skavskydd_1_N = mkN "skavskydd" neutrum  ; -- skavskydd..nn.1
  skavsår_1_N = mkN "skavsår" neutrum  ; -- skavsår..nn.1
  ske_1_V = mkV "ske" "skedde" "skett" ; -- ske..vb.1
  sked_1_N = mkN "sked" ; -- sked..nn.1
  skeda_1_V = mkV "skedar" ; -- skeda..vb.1
  skedand_1_N = mkN "skedand" "skedänder" ; -- skedand..nn.1
  skedande_1_N = mkN "skedande" ; -- skedande..nn.1
  skedblad_1_N = mkN "skedblad" neutrum  ; -- skedblad..nn.1
  skeddrag_1_N = mkN "skeddrag" neutrum  ; -- skeddrag..nn.1
  skede_1_N = mkN "skede" ; -- skede..nn.1
  skedsovning_1_N = mkN "skedsovning" ; -- skedsovning..nn.1
  skedstork_1_N = mkN "skedstork" ; -- skedstork..nn.1
  skedvis_1_Adv = mkAdv "skedvis" ; -- skedvis..ab.1
  skeende_1_N = mkN "skeende" ; -- skeende..nn.1
  skejt_1_N = mkN "skejt" neutrum  ; -- skejt..nn.1
  skejt_2_N = mkN "skejt" ; -- skejt..nn.2
  skejta_1_V = mkV "skejtar" ; -- skejta..vb.1
  skejtande_1_N = mkN "skejtande" ; -- skejtande..nn.1
  skejtare_1_N = mkN "skejtare" utrum  ; -- skejtare..nn.1
  skejtning_1_N = mkN "skejtning" ; -- skejtning..nn.1
  skela_1_V = mkV "skelar" ; -- skela..vb.1
  skelande_1_N = mkN "skelande" ; -- skelande..nn.1
  skeleton_1_N = mkN "skeleton" ; -- skeleton..nn.1
  skelett_1_N = mkN "skelett" neutrum  ; -- skelett..nn.1
  skelettartad_1_A = mkA "skelettartad" ; -- skelettartad..av.1
  skelettmuskel_1_N = mkN "skelettmuskel" "skelettmuskeln" "skelettmuskler" "skelettmusklerna" ; -- skelettmuskel..nn.1
  skelettmuskulatur_1_N = mkN "skelettmuskulatur" ; -- skelettmuskulatur..nn.1
  skelettrest_1_N = mkN "skelettrest" "skelettrester" ; -- skelettrest..nn.1
  skelögd_1_A = mkA "skelögd" "skelögt" ; -- skelögd..av.1
  skelögdhet_1_N = mkN "skelögdhet" "skelögdheter" ; -- skelögdhet..nn.1
  skelört_1_N = mkN "skelört" ; -- skelört..nn.1
  sken_1_N = mkN "sken" neutrum  ; -- sken..nn.1
  skena_1_N = mkN "skena" ; -- skena..nn.1
  skena_1_V = mkV "skenar" ; -- skena..vb.1
  skenande_1_N = mkN "skenande" ; -- skenande..nn.1
  skenavrättning_1_N = mkN "skenavrättning" ; -- skenavrättning..nn.1
  skenbar_1_A = mkA "skenbar" ; -- skenbar..av.1
  skenbarhet_1_N = mkN "skenbarhet" ; -- skenbarhet..nn.1
  skenbarligen_1_Adv = mkAdv "skenbarligen" ; -- skenbarligen..ab.1
  skenben_1_N = mkN "skenben" neutrum  ; -- skenben..nn.1
  skenbild_1_N = mkN "skenbild" "skenbilder" ; -- skenbild..nn.1
  skendräktig_1_A = mkA "skendräktig" ; -- skendräktig..av.1
  skendränkning_1_N = mkN "skendränkning" ; -- skendränkning..nn.1
  skendöd_1_A = mkA "skendöd" "skendött" ; -- skendöd..av.1
  skendödhet_1_N = mkN "skendödhet" ; -- skendödhet..nn.1
  skenfrukt_1_N = mkN "skenfrukt" "skenfrukter" ; -- skenfrukt..nn.1
  skenfäktning_1_N = mkN "skenfäktning" ; -- skenfäktning..nn.1
  skengestalt_1_N = mkN "skengestalt" "skengestalter" ; -- skengestalt..nn.1
  skengravid_1_A = mkA "skengravid" ; -- skengravid..av.1
  skengraviditet_1_N = mkN "skengraviditet" "skengraviditeter" ; -- skengraviditet..nn.1
  skenhelig_1_A = mkA "skenhelig" ; -- skenhelig..av.1
  skenhelighet_1_N = mkN "skenhelighet" "skenheligheter" ; -- skenhelighet..nn.1
  skenhändelse_1_N = mkN "skenhändelse" "skenhändelser" ; -- skenhändelse..nn.1
  skenmanöver_1_N = mkN "skenmanöver" ; -- skenmanöver..nn.1
  skenplocka_1_V = mkV "skenplockar" ; -- skenplocka..vb.1
  skenplockande_1_N = mkN "skenplockande" ; -- skenplockande..nn.1
  skenplockning_1_N = mkN "skenplockning" ; -- skenplockning..nn.1
  skenrättegång_1_N = mkN "skenrättegång" ; -- skenrättegång..nn.1
  skenskarv_1_N = mkN "skenskarv" ; -- skenskarv..nn.1
  skenvärld_1_N = mkN "skenvärld" ; -- skenvärld..nn.1
  skenäktenskap_1_N = mkN "skenäktenskap" neutrum  ; -- skenäktenskap..nn.1
  skepnad_1_N = mkN "skepnad" "skepnader" ; -- skepnad..nn.1
  skepp_1_N = mkN "skepp" neutrum  ; -- skepp..nn.1
  skeppa_1_V = mkV "skeppar" ; -- skeppa..vb.1
  skeppande_1_N = mkN "skeppande" ; -- skeppande..nn.1
  skepparbrev_1_N = mkN "skepparbrev" neutrum  ; -- skepparbrev..nn.1
  skeppare_1_N = mkN "skeppare" utrum  ; -- skeppare..nn.1
  skepparexamen_1_N = mkN "skepparexamen" "skepparexamen" "skepparexamina" "skepparexamina" ; -- skepparexamen..nn.1
  skepparhistoria_1_N = mkN "skepparhistoria" "skepparhistorian" "skepparhistorier" "skepparhistorierna" ; -- skepparhistoria..nn.1
  skepparkrans_1_N = mkN "skepparkrans" ; -- skepparkrans..nn.1
  skepplista_1_N = mkN "skepplista" ; -- skepplista..nn.1
  skeppning_1_N = mkN "skeppning" ; -- skeppning..nn.1
  skeppsapotek_1_N = mkN "skeppsapotek" neutrum  ; -- skeppsapotek..nn.1
  skeppsbesättning_1_N = mkN "skeppsbesättning" ; -- skeppsbesättning..nn.1
  skeppsbro_1_N = mkN "skeppsbro" ; -- skeppsbro..nn.1
  skeppsbrott_1_N = mkN "skeppsbrott" neutrum  ; -- skeppsbrott..nn.1
  skeppsbruten_1_A = mkA "skeppsbruten" ; -- skeppsbruten..av.1
  skeppsbyggeri_1_N = mkN "skeppsbyggeri" "skeppsbyggeriet" "skeppsbyggerier" "skeppsbyggerierna" ; -- skeppsbyggeri..nn.1
  skeppsbåt_1_N = mkN "skeppsbåt" ; -- skeppsbåt..nn.1
  skeppsdäck_1_N = mkN "skeppsdäck" neutrum  ; -- skeppsdäck..nn.1
  skeppsfart_1_N = mkN "skeppsfart" ; -- skeppsfart..nn.1
  skeppsfolk_1_N = mkN "skeppsfolk" neutrum  ; -- skeppsfolk..nn.1
  skeppsgosse_1_N = mkN "skeppsgosse" utrum  ; -- skeppsgosse..nn.1
  skeppshandel_1_N = mkN "skeppshandel" ; -- skeppshandel..nn.1
  skeppshistorisk_1_A = mkA "skeppshistorisk" ; -- skeppshistorisk..av.1
  skeppsklarerare_1_N = mkN "skeppsklarerare" utrum  ; -- skeppsklarerare..nn.1
  skeppsklocka_1_N = mkN "skeppsklocka" ; -- skeppsklocka..nn.1
  skeppslag_1_N = mkN "skeppslag" neutrum  ; -- skeppslag..nn.1
  skeppsljus_1_N = mkN "skeppsljus" neutrum  ; -- skeppsljus..nn.1
  skeppsmanskap_1_N = mkN "skeppsmanskap" neutrum  ; -- skeppsmanskap..nn.1
  skeppsmask_1_N = mkN "skeppsmask" ; -- skeppsmask..nn.1
  skeppsmäklare_1_N = mkN "skeppsmäklare" utrum  ; -- skeppsmäklare..nn.1
  skeppsmätning_1_N = mkN "skeppsmätning" ; -- skeppsmätning..nn.1
  skeppspojke_1_N = mkN "skeppspojke" utrum  ; -- skeppspojke..nn.1
  skeppsproviant_1_N = mkN "skeppsproviant" ; -- skeppsproviant..nn.1
  skeppsredare_1_N = mkN "skeppsredare" utrum  ; -- skeppsredare..nn.1
  skeppsskorpa_1_N = mkN "skeppsskorpa" ; -- skeppsskorpa..nn.1
  skeppssättning_1_N = mkN "skeppssättning" ; -- skeppssättning..nn.1
  skeppsvarv_1_N = mkN "skeppsvarv" neutrum  ; -- skeppsvarv..nn.1
  skeppsvirke_1_N = mkN "skeppsvirke" ; -- skeppsvirke..nn.1
  skeppund_1_N = mkN "skeppund" neutrum  ; -- skeppund..nn.1
  skepsis_1_N = mkN "skepsis" ; -- skepsis..nn.1
  skepticism_1_N = mkN "skepticism" "skepticismer" ; -- skepticism..nn.1
  skeptiker_1_N = mkN "skeptiker" "skeptikern" "skeptiker" "skeptikerna" ; -- skeptiker..nn.1
  skeptisk_1_A = mkA "skeptisk" ; -- skeptisk..av.1
  sketch_1_N = mkN "sketch" "sketcher" ; -- sketch..nn.1
  sketen_1_A = mkA "sketen" ; -- sketen..av.1
  skev_1_A = mkA "skev" ; -- skev..av.1
  skeva_1_V = mkV "skevar" ; -- skeva..vb.1
  skeva_2_V = mkV "skevar" ; -- skeva..vb.2
  skevande_1_N = mkN "skevande" ; -- skevande..nn.1
  skevhet_1_N = mkN "skevhet" "skevheter" ; -- skevhet..nn.1
  skevning_1_N = mkN "skevning" ; -- skevning..nn.1
  skevningsroder_1_N = mkN "skevningsroder" neutrum  ; -- skevningsroder..nn.1
  skevra_1_V = mkV "skevrar" ; -- skevra..vb.1
  skevrande_1_N = mkN "skevrande" ; -- skevrande..nn.1
  skevroder_1_N = mkN "skevroder" neutrum  ; -- skevroder..nn.1
  skick_1_N = mkN "skick" neutrum  ; -- skick..nn.1
  skicka_1_V = mkV "skickar" ; -- skicka..vb.1
  skickad_1_A = mkA "skickad" ; -- skickad..av.1
  skickande_1_N = mkN "skickande" ; -- skickande..nn.1
  skickebud_1_N = mkN "skickebud" neutrum  ; -- skickebud..nn.1
  skickelse_1_N = mkN "skickelse" utrum  ; -- skickelse..nn.1
  skickelsediger_1_A = mkA "skickelsediger" ; -- skickelsediger..av.1
  skicklig_1_A = mkA "skicklig" ; -- skicklig..av.1
  skicklighet_1_N = mkN "skicklighet" "skickligheter" ; -- skicklighet..nn.1
  skickning_1_N = mkN "skickning" ; -- skickning..nn.1
  skida_1_N = mkN "skida" ; -- skida..nn.1
  skida_1_V = mkV "skidar" ; -- skida..vb.1
  skidande_1_N = mkN "skidande" ; -- skidande..nn.1
  skidanläggning_1_N = mkN "skidanläggning" ; -- skidanläggning..nn.1
  skidbacke_1_N = mkN "skidbacke" utrum  ; -- skidbacke..nn.1
  skiddrottning_1_N = mkN "skiddrottning" ; -- skiddrottning..nn.1
  skidformig_1_A = mkA "skidformig" ; -- skidformig..av.1
  skidfynd_1_N = mkN "skidfynd" neutrum  ; -- skidfynd..nn.1
  skidföre_1_N = mkN "skidföre" ; -- skidföre..nn.1
  skidgymnasium_1_N = mkN "skidgymnasium" "skidgymnasiet" "skidgymnasier" "skidgymnasierna" ; -- skidgymnasium..nn.1
  skidhandske_1_N = mkN "skidhandske" utrum  ; -- skidhandske..nn.1
  skidhjälm_1_N = mkN "skidhjälm" ; -- skidhjälm..nn.1
  skidhoppning_1_N = mkN "skidhoppning" ; -- skidhoppning..nn.1
  skidlift_1_N = mkN "skidlift" ; -- skidlift..nn.1
  skidlöpare_1_N = mkN "skidlöpare" utrum  ; -- skidlöpare..nn.1
  skidlöpning_1_N = mkN "skidlöpning" ; -- skidlöpning..nn.1
  skidmössa_1_N = mkN "skidmössa" ; -- skidmössa..nn.1
  skidort_1_N = mkN "skidort" "skidorter" ; -- skidort..nn.1
  skidra_1_V = mkV "skidrar" ; -- skidra..vb.1
  skidresa_1_N = mkN "skidresa" ; -- skidresa..nn.1
  skidsemester_1_N = mkN "skidsemester" ; -- skidsemester..nn.1
  skidskytte_1_N = mkN "skidskytte" ; -- skidskytte..nn.1
  skidskyttestafett_1_N = mkN "skidskyttestafett" "skidskyttestafetter" ; -- skidskyttestafett..nn.1
  skidspår_1_N = mkN "skidspår" neutrum  ; -- skidspår..nn.1
  skidstav_1_N = mkN "skidstav" ; -- skidstav..nn.1
  skidtur_1_N = mkN "skidtur" "skidturer" ; -- skidtur..nn.1
  skidtyp_1_N = mkN "skidtyp" "skidtyper" ; -- skidtyp..nn.1
  skidtävling_1_N = mkN "skidtävling" ; -- skidtävling..nn.1
  skidåkare_1_N = mkN "skidåkare" utrum  ; -- skidåkare..nn.1
  skidåkning_1_N = mkN "skidåkning" ; -- skidåkning..nn.1
  skiffer_1_N = mkN "skiffer" ; -- skiffer..nn.1
  skiffergrå_1_A = mkA "skiffergrå" "skiffergrått" ; -- skiffergrå..av.1
  skifferolja_1_N = mkN "skifferolja" ; -- skifferolja..nn.1
  skifferplatta_1_N = mkN "skifferplatta" ; -- skifferplatta..nn.1
  skiffertak_1_N = mkN "skiffertak" neutrum  ; -- skiffertak..nn.1
  skiffle_1_N = mkN "skiffle" utrum  ; -- skiffle..nn.1
  skiffrig_1_A = mkA "skiffrig" ; -- skiffrig..av.1
  skiffrighet_1_N = mkN "skiffrighet" ; -- skiffrighet..nn.1
  skift_1_N = mkN "skift" neutrum  ; -- skift..nn.1
  skifta_1_V = mkV "skiftar" ; -- skifta..vb.1
  skifta_2_V = mkV "skiftar" ; -- skifta..vb.2
  skiftande_1_N = mkN "skiftande" ; -- skiftande..nn.1
  skiftarbete_1_N = mkN "skiftarbete" ; -- skiftarbete..nn.1
  skifte_1_N = mkN "skifte" ; -- skifte..nn.1
  skiftesbruk_1_N = mkN "skiftesbruk" neutrum  ; -- skiftesbruk..nn.1
  skiftesrik_1_A = mkA "skiftesrik" ; -- skiftesrik..av.1
  skiftesverk_1_N = mkN "skiftesverk" neutrum  ; -- skiftesverk..nn.1
  skiftläge_1_N = mkN "skiftläge" ; -- skiftläge..nn.1
  skiftning_1_N = mkN "skiftning" ; -- skiftning..nn.1
  skiftnyckel_1_N = mkN "skiftnyckel" ; -- skiftnyckel..nn.1
  skiftrik_1_A = mkA "skiftrik" ; -- skiftrik..av.1
  skifttangent_1_N = mkN "skifttangent" "skifttangenter" ; -- skifttangent..nn.1
  skikt_1_N = mkN "skikt" neutrum  ; -- skikt..nn.1
  skikta_1_V = mkV "skiktar" ; -- skikta..vb.1
  skiktad_1_A = mkA "skiktad" ; -- skiktad..av.1
  skiktande_1_N = mkN "skiktande" ; -- skiktande..nn.1
  skiktmoln_1_N = mkN "skiktmoln" neutrum  ; -- skiktmoln..nn.1
  skiktning_1_N = mkN "skiktning" ; -- skiktning..nn.1
  skiktröntgenapparat_1_N = mkN "skiktröntgenapparat" "skiktröntgenapparater" ; -- skiktröntgenapparat..nn.1
  skild_1_A = mkA "skild" "skilt" ; -- skild..av.1
  skildkönad_1_A = mkA "skildkönad" ; -- skildkönad..av.1
  skildra_1_V = mkV "skildrar" ; -- skildra..vb.1
  skildrande_1_N = mkN "skildrande" ; -- skildrande..nn.1
  skildrare_1_N = mkN "skildrare" utrum  ; -- skildrare..nn.1
  skildring_1_N = mkN "skildring" ; -- skildring..nn.1
  skilja_1_V = mkV "skilja" "skilde" "skilt" ; -- skilja..vb.1
  skiljaktig_1_A = mkA "skiljaktig" ; -- skiljaktig..av.1
  skiljaktighet_1_N = mkN "skiljaktighet" "skiljaktigheter" ; -- skiljaktighet..nn.1
  skiljande_1_N = mkN "skiljande" ; -- skiljande..nn.1
  skiljbar_1_A = mkA "skiljbar" ; -- skiljbar..av.1
  skiljbarhet_1_N = mkN "skiljbarhet" ; -- skiljbarhet..nn.1
  skilje_1_N = mkN "skilje" ; -- skilje..nn.1
  skiljedom_1_N = mkN "skiljedom" ; -- skiljedom..nn.1
  skiljedomare_1_N = mkN "skiljedomare" utrum  ; -- skiljedomare..nn.1
  skiljedomstol_1_N = mkN "skiljedomstol" ; -- skiljedomstol..nn.1
  skiljeförfarande_1_N = mkN "skiljeförfarande" ; -- skiljeförfarande..nn.1
  skiljelinje_1_N = mkN "skiljelinje" "skiljelinjer" ; -- skiljelinje..nn.1
  skiljeman_1_N = mkN "skiljeman" "skiljemannen" "skiljemän" "skiljemännen" ; -- skiljeman..nn.1
  skiljemur_1_N = mkN "skiljemur" ; -- skiljemur..nn.1
  skiljemynt_1_N = mkN "skiljemynt" neutrum  ; -- skiljemynt..nn.1
  skiljenämnd_1_N = mkN "skiljenämnd" "skiljenämnder" ; -- skiljenämnd..nn.1
  skiljeset_1_N = mkN "skiljeset" neutrum  ; -- skiljeset..nn.1
  skiljetecken_1_N = mkN "skiljetecken" "skiljetecknet" "skiljetecken" "skiljetecknen" ; -- skiljetecken..nn.1
  skiljeväg_1_N = mkN "skiljeväg" ; -- skiljeväg..nn.1
  skiljevägg_1_N = mkN "skiljevägg" ; -- skiljevägg..nn.1
  skilling_1_N = mkN "skilling" ; -- skilling..nn.1
  skillingtryck_1_N = mkN "skillingtryck" neutrum  ; -- skillingtryck..nn.1
  skillnad_1_N = mkN "skillnad" "skillnader" ; -- skillnad..nn.1
  skillnadsdom_1_N = mkN "skillnadsdom" ; -- skillnadsdom..nn.1
  skilsmässa_1_N = mkN "skilsmässa" ; -- skilsmässa..nn.1
  skilsmässobarn_1_N = mkN "skilsmässobarn" neutrum  ; -- skilsmässobarn..nn.1
  skilsmässoepidemi_1_N = mkN "skilsmässoepidemi" "skilsmässoepidemier" ; -- skilsmässoepidemi..nn.1
  skilsmässoförälder_1_N = mkN "skilsmässoförälder" ; -- skilsmässoförälder..nn.1
  skilsmässopapper_1_N = mkN "skilsmässopapper" neutrum  ; -- skilsmässopapper..nn.1
  skiltvakt_1_N = mkN "skiltvakt" "skiltvakter" ; -- skiltvakt..nn.1
  skimma_1_V = mkV "skimmar" ; -- skimma..vb.1
  skimmande_1_N = mkN "skimmande" ; -- skimmande..nn.1
  skimmel_1_N = mkN "skimmel" "skimmeln" "skimmlar" "skimmlarna" ; -- skimmel..nn.1
  skimmer_1_N = mkN "skimmer" neutrum  ; -- skimmer..nn.1
  skimming_1_N = mkN "skimming" ; -- skimming..nn.1
  skimra_1_V = mkV "skimrar" ; -- skimra..vb.1
  skimrande_1_N = mkN "skimrande" ; -- skimrande..nn.1
  skina_1_V = mkV "skina" "sken" "skinit" ; -- skina..vb.1
  skinande_1_N = mkN "skinande" ; -- skinande..nn.1
  skineffekt_1_N = mkN "skineffekt" ; -- skineffekt..nn.1
  skingra_1_V = mkV "skingrar" ; -- skingra..vb.1
  skingrande_1_N = mkN "skingrande" ; -- skingrande..nn.1
  skingringsförbud_1_N = mkN "skingringsförbud" neutrum  ; -- skingringsförbud..nn.1
  skinhead_1_N = mkN "skinhead" "skinheadet" "skinheads" "skinheadsen" ; -- skinhead..nn.1
  skinka_1_N = mkN "skinka" ; -- skinka..nn.1
  skinkbluffande_1_A = mkA "skinkbluffande" ; -- skinkbluffande..av.1
  skinn_1_N = mkN "skinn" neutrum  ; -- skinn..nn.1
  skinna_1_V = mkV "skinnar" ; -- skinna..vb.1
  skinnande_1_N = mkN "skinnande" ; -- skinnande..nn.1
  skinnare_1_N = mkN "skinnare" utrum  ; -- skinnare..nn.1
  skinnbagge_1_N = mkN "skinnbagge" utrum  ; -- skinnbagge..nn.1
  skinnband_1_N = mkN "skinnband" neutrum  ; -- skinnband..nn.1
  skinnbit_1_N = mkN "skinnbit" ; -- skinnbit..nn.1
  skinnerbur_1_N = mkN "skinnerbur" ; -- skinnerbur..nn.1
  skinneri_1_N = mkN "skinneri" neutrum  ; -- skinneri..nn.1
  skinnflådd_1_A = mkA "skinnflådd" ; -- skinnflådd..av.1
  skinnfäll_1_N = mkN "skinnfäll" ; -- skinnfäll..nn.1
  skinnfåtölj_1_N = mkN "skinnfåtölj" "skinnfåtöljer" ; -- skinnfåtölj..nn.1
  skinnimitation_1_N = mkN "skinnimitation" ; -- skinnimitation..nn.1
  skinnjacka_1_N = mkN "skinnjacka" ; -- skinnjacka..nn.1
  skinnkavaj_1_N = mkN "skinnkavaj" "skinnkavajer" ; -- skinnkavaj..nn.1
  skinnklädd_1_A = mkA "skinnklädd" ; -- skinnklädd..av.1
  skinnklädsel_1_N = mkN "skinnklädsel" ; -- skinnklädsel..nn.1
  skinnknutte_1_N = mkN "skinnknutte" utrum  ; -- skinnknutte..nn.1
  skinnkälke_1_N = mkN "skinnkälke" utrum  ; -- skinnkälke..nn.1
  skinnpaj_1_N = mkN "skinnpaj" ; -- skinnpaj..nn.1
  skinnskalle_1_N = mkN "skinnskalle" utrum  ; -- skinnskalle..nn.1
  skinnsoffa_1_N = mkN "skinnsoffa" ; -- skinnsoffa..nn.1
  skinntorr_1_A = mkA "skinntorr" ; -- skinntorr..av.1
  skinntorrhet_1_N = mkN "skinntorrhet" ; -- skinntorrhet..nn.1
  skinnvara_1_N = mkN "skinnvara" ; -- skinnvara..nn.1
  skinnväst_1_N = mkN "skinnväst" ; -- skinnväst..nn.1
  skioptikon_1_N = mkN "skioptikon" neutrum  ; -- skioptikon..nn.1
  skipa_1_V = mkV "skipar" ; -- skipa..vb.1
  skipande_1_N = mkN "skipande" ; -- skipande..nn.1
  skipod_1_N = mkN "skipod" "skipoder" ; -- skipod..nn.1
  skippa_1_V = mkV "skippar" ; -- skippa..vb.1
  skippande_1_N = mkN "skippande" ; -- skippande..nn.1
  skir_1_A = mkA "skir" ; -- skir..av.1
  skira_1_V = mkV "skirar" ; -- skira..vb.1
  skirande_1_N = mkN "skirande" ; -- skirande..nn.1
  skirhet_1_N = mkN "skirhet" ; -- skirhet..nn.1
  skirning_1_N = mkN "skirning" ; -- skirning..nn.1
  skiss_1_N = mkN "skiss" "skisser" ; -- skiss..nn.1
  skissa_1_V = mkV "skissar" ; -- skissa..vb.1
  skissande_1_N = mkN "skissande" ; -- skissande..nn.1
  skissartad_1_A = mkA "skissartad" ; -- skissartad..av.1
  skissblock_1_N = mkN "skissblock" neutrum  ; -- skissblock..nn.1
  skissbok_1_N = mkN "skissbok" "skissböcker" ; -- skissbok..nn.1
  skissera_1_V = mkV "skisserar" ; -- skissera..vb.1
  skisserande_1_N = mkN "skisserande" ; -- skisserande..nn.1
  skisserbar_1_A = mkA "skisserbar" ; -- skisserbar..av.1
  skisserbarhet_1_N = mkN "skisserbarhet" ; -- skisserbarhet..nn.1
  skissering_1_N = mkN "skissering" ; -- skissering..nn.1
  skit_1_N = mkN "skit" ; -- skit..nn.1
  skita_1_V = mkV "skita" "sket" "skitit" ; -- skita..vb.1
  skitande_1_N = mkN "skitande" ; -- skitande..nn.1
  skitbesvärlig_1_A = mkA "skitbesvärlig" ; -- skitbesvärlig..av.1
  skitbra_1_A = mkA "skitbra" ; -- skitbra..av.1
  skitdålig_1_A = mkA "skitdålig" ; -- skitdålig..av.1
  skitförbannad_1_A = mkA "skitförbannad" ; -- skitförbannad..av.1
  skitförnäm_1_A = mkA "skitförnäm" ; -- skitförnäm..av.1
  skitförnämhet_1_N = mkN "skitförnämhet" ; -- skitförnämhet..nn.1
  skitglad_1_A = mkA "skitglad" "skitglatt" ; -- skitglad..av.1
  skitgubbe_1_N = mkN "skitgubbe" utrum  ; -- skitgubbe..nn.1
  skitig_1_A = mkA "skitig" ; -- skitig..av.1
  skitjobbig_1_A = mkA "skitjobbig" ; -- skitjobbig..av.1
  skitkass_1_A = mkA "skitkass" ; -- skitkass..av.1
  skitkul_1_A = mkA "skitkul" ; -- skitkul..av.1
  skitlåt_1_N = mkN "skitlåt" ; -- skitlåt..nn.1
  skitnödig_1_A = mkA "skitnödig" ; -- skitnödig..av.1
  skitnödighet_1_N = mkN "skitnödighet" ; -- skitnödighet..nn.1
  skitnöjd_1_A = mkA "skitnöjd" "skitnöjt" ; -- skitnöjd..av.1
  skitond_1_A = mkA "skitond" ; -- skitond..av.1
  skitprat_1_N = mkN "skitprat" neutrum  ; -- skitprat..nn.1
  skiträdd_1_A = mkA "skiträdd" ; -- skiträdd..av.1
  skitsak_1_N = mkN "skitsak" "skitsaker" ; -- skitsak..nn.1
  skitsamma_1_A = mkA "skitsamma" ; -- skitsamma..av.1
  skitsnack_1_N = mkN "skitsnack" neutrum  ; -- skitsnack..nn.1
  skitsnygg_1_A = mkA "skitsnygg" ; -- skitsnygg..av.1
  skitsnygghet_1_N = mkN "skitsnygghet" ; -- skitsnygghet..nn.1
  skitställe_1_N = mkN "skitställe" ; -- skitställe..nn.1
  skitstövel_1_N = mkN "skitstövel" ; -- skitstövel..nn.1
  skittråkig_1_A = mkA "skittråkig" ; -- skittråkig..av.1
  skittråkighet_1_N = mkN "skittråkighet" ; -- skittråkighet..nn.1
  skittöntig_1_A = mkA "skittöntig" ; -- skittöntig..av.1
  skitviktig_1_A = mkA "skitviktig" ; -- skitviktig..av.1
  skitviktighet_1_N = mkN "skitviktighet" ; -- skitviktighet..nn.1
  skitvåg_1_N = mkN "skitvåg" ; -- skitvåg..nn.1
  skitår_1_N = mkN "skitår" neutrum  ; -- skitår..nn.1
  skiva_1_N = mkN "skiva" ; -- skiva..nn.1
  skiva_1_V = mkV "skivar" ; -- skiva..vb.1
  skivaffär_1_N = mkN "skivaffär" "skivaffärer" ; -- skivaffär..nn.1
  skivaktuell_1_A = mkA "skivaktuell" ; -- skivaktuell..av.1
  skivalbum_1_N = mkN "skivalbum" neutrum  ; -- skivalbum..nn.1
  skivande_1_N = mkN "skivande" ; -- skivande..nn.1
  skivbar_1_N = mkN "skivbar" "skivbarer" ; -- skivbar..nn.1
  skivbolag_1_N = mkN "skivbolag" neutrum  ; -- skivbolag..nn.1
  skivbolagsdirektör_1_N = mkN "skivbolagsdirektör" "skivbolagsdirektörer" ; -- skivbolagsdirektör..nn.1
  skivbolagsmogul_1_N = mkN "skivbolagsmogul" "skivbolagsmoguler" ; -- skivbolagsmogul..nn.1
  skivbroms_1_N = mkN "skivbroms" ; -- skivbroms..nn.1
  skivdebutera_1_V = mkV "skivdebuterar" ; -- skivdebutera..vb.1
  skivdebuterande_1_N = mkN "skivdebuterande" ; -- skivdebuterande..nn.1
  skivdebutering_1_N = mkN "skivdebutering" ; -- skivdebutering..nn.1
  skivdistribution_1_N = mkN "skivdistribution" ; -- skivdistribution..nn.1
  skivformig_1_A = mkA "skivformig" ; -- skivformig..av.1
  skivhus_1_N = mkN "skivhus" neutrum  ; -- skivhus..nn.1
  skivig_1_A = mkA "skivig" ; -- skivig..av.1
  skivinspelning_1_N = mkN "skivinspelning" ; -- skivinspelning..nn.1
  skivkontrakt_1_N = mkN "skivkontrakt" neutrum  ; -- skivkontrakt..nn.1
  skivling_1_N = mkN "skivling" ; -- skivling..nn.1
  skivminne_1_N = mkN "skivminne" ; -- skivminne..nn.1
  skivomslag_1_N = mkN "skivomslag" neutrum  ; -- skivomslag..nn.1
  skivpratare_1_N = mkN "skivpratare" utrum  ; -- skivpratare..nn.1
  skivsamling_1_N = mkN "skivsamling" ; -- skivsamling..nn.1
  skivspelare_1_N = mkN "skivspelare" utrum  ; -- skivspelare..nn.1
  skivstång_1_N = mkN "skivstång" "skivstänger" ; -- skivstång..nn.1
  skivsvamp_1_N = mkN "skivsvamp" ; -- skivsvamp..nn.1
  skivtallrik_1_N = mkN "skivtallrik" ; -- skivtallrik..nn.1
  skjorta_1_N = mkN "skjorta" ; -- skjorta..nn.1
  skjortblus_1_N = mkN "skjortblus" ; -- skjortblus..nn.1
  skjortbröst_1_N = mkN "skjortbröst" neutrum  ; -- skjortbröst..nn.1
  skjortkrage_1_N = mkN "skjortkrage" utrum  ; -- skjortkrage..nn.1
  skjortärm_1_N = mkN "skjortärm" ; -- skjortärm..nn.1
  skjul_1_N = mkN "skjul" neutrum  ; -- skjul..nn.1
  skjut_1_N = mkN "skjut" neutrum  ; -- skjut..nn.1
  skjuta_1_V = mkV "skjuta" "sköt" "skjutit" ; -- skjuta..vb.1
  skjutande_1_N = mkN "skjutande" ; -- skjutande..nn.1
  skjutbana_1_N = mkN "skjutbana" ; -- skjutbana..nn.1
  skjutbar_1_A = mkA "skjutbar" ; -- skjutbar..av.1
  skjutbarhet_1_N = mkN "skjutbarhet" ; -- skjutbarhet..nn.1
  skjutdörr_1_N = mkN "skjutdörr" ; -- skjutdörr..nn.1
  skjutfält_1_N = mkN "skjutfält" neutrum  ; -- skjutfält..nn.1
  skjutfärdig_1_A = mkA "skjutfärdig" ; -- skjutfärdig..av.1
  skjutfönster_1_N = mkN "skjutfönster" neutrum  ; -- skjutfönster..nn.1
  skjutglad_1_A = mkA "skjutglad" "skjutglatt" ; -- skjutglad..av.1
  skjutjärn_1_N = mkN "skjutjärn" neutrum  ; -- skjutjärn..nn.1
  skjutjärnsintervju_1_N = mkN "skjutjärnsintervju" "skjutjärnsintervjun" "skjutjärnsintervjuer" "skjutjärnsintervjuerna" ; -- skjutjärnsintervju..nn.1
  skjutjärnsjournalist_1_N = mkN "skjutjärnsjournalist" "skjutjärnsjournalister" ; -- skjutjärnsjournalist..nn.1
  skjutklar_1_A = mkA "skjutklar" ; -- skjutklar..av.1
  skjutlucka_1_N = mkN "skjutlucka" ; -- skjutlucka..nn.1
  skjutmått_1_N = mkN "skjutmått" neutrum  ; -- skjutmått..nn.1
  skjutmåttset_1_N = mkN "skjutmåttset" neutrum  ; -- skjutmåttset..nn.1
  skjutmåttsset_1_N = mkN "skjutmåttsset" neutrum  ; -- skjutmåttsset..nn.1
  skjutning_1_N = mkN "skjutning" ; -- skjutning..nn.1
  skjutriktning_1_N = mkN "skjutriktning" ; -- skjutriktning..nn.1
  skjuts_1_N = mkN "skjuts" ; -- skjuts..nn.1
  skjutsa_1_V = mkV "skjutsar" ; -- skjutsa..vb.1
  skjutsande_1_N = mkN "skjutsande" ; -- skjutsande..nn.1
  skjutshåll_1_N = mkN "skjutshåll" neutrum  ; -- skjutshåll..nn.1
  skjutskåre_1_N = mkN "skjutskåre" utrum  ; -- skjutskåre..nn.1
  skjutsning_1_N = mkN "skjutsning" ; -- skjutsning..nn.1
  skjutsningsplikt_1_N = mkN "skjutsningsplikt" "skjutsningsplikter" ; -- skjutsningsplikt..nn.1
  skjuttävling_1_N = mkN "skjuttävling" ; -- skjuttävling..nn.1
  skjututbildning_1_N = mkN "skjututbildning" ; -- skjututbildning..nn.1
  skjutvapen_1_N = mkN "skjutvapen" "skjutvapnet" "skjutvapen" "skjutvapnen" ; -- skjutvapen..nn.1
  skjutvinkel_1_N = mkN "skjutvinkel" ; -- skjutvinkel..nn.1
  skjuva_1_V = mkV "skjuvar" ; -- skjuva..vb.1
  skjuvande_1_N = mkN "skjuvande" ; -- skjuvande..nn.1
  skleros_1_N = mkN "skleros" "skleroser" ; -- skleros..nn.1
  sklerotisk_1_A = mkA "sklerotisk" ; -- sklerotisk..av.1
  sko_1_N = mkN "sko" "skor" ; -- sko..nn.1
  sko_1_V = mkV "skor" ; -- sko..vb.1
  skoblock_1_N = mkN "skoblock" neutrum  ; -- skoblock..nn.1
  skoborste_1_N = mkN "skoborste" utrum  ; -- skoborste..nn.1
  skoborstning_1_N = mkN "skoborstning" ; -- skoborstning..nn.1
  skock_1_N = mkN "skock" ; -- skock..nn.1
  skocka_1_N = mkN "skocka" ; -- skocka..nn.1
  skockning_1_N = mkN "skockning" ; -- skockning..nn.1
  skockvis_1_Adv = mkAdv "skockvis" ; -- skockvis..ab.1
  skodon_1_N = mkN "skodon" neutrum  ; -- skodon..nn.1
  skoende_1_N = mkN "skoende" ; -- skoende..nn.1
  skoflickare_1_N = mkN "skoflickare" utrum  ; -- skoflickare..nn.1
  skog_1_N = mkN "skog" ; -- skog..nn.1
  skogbevuxen_1_A = mkA "skogbevuxen" ; -- skogbevuxen..av.1
  skogbeväxt_1_A = mkA "skogbeväxt" "skogbeväxt" ; -- skogbeväxt..av.1
  skogbit_1_N = mkN "skogbit" ; -- skogbit..nn.1
  skogfattig_1_A = mkA "skogfattig" ; -- skogfattig..av.1
  skogfattighet_1_N = mkN "skogfattighet" ; -- skogfattighet..nn.1
  skogig_1_A = mkA "skogig" ; -- skogig..av.1
  skogighet_1_N = mkN "skogighet" ; -- skogighet..nn.1
  skogklädd_1_A = mkA "skogklädd" ; -- skogklädd..av.1
  skogkläddhet_1_N = mkN "skogkläddhet" ; -- skogkläddhet..nn.1
  skoglig_1_A = mkA "skoglig" ; -- skoglig..av.1
  skoglös_1_A = mkA "skoglös" ; -- skoglös..av.1
  skoglöshet_1_N = mkN "skoglöshet" ; -- skoglöshet..nn.1
  skogrik_1_A = mkA "skogrik" ; -- skogrik..av.1
  skogsarbetare_1_N = mkN "skogsarbetare" utrum  ; -- skogsarbetare..nn.1
  skogsarbete_1_N = mkN "skogsarbete" ; -- skogsarbete..nn.1
  skogsavverkning_1_N = mkN "skogsavverkning" ; -- skogsavverkning..nn.1
  skogsbacke_1_N = mkN "skogsbacke" utrum  ; -- skogsbacke..nn.1
  skogsbagge_1_N = mkN "skogsbagge" utrum  ; -- skogsbagge..nn.1
  skogsbete_1_N = mkN "skogsbete" ; -- skogsbete..nn.1
  skogsblomma_1_N = mkN "skogsblomma" ; -- skogsblomma..nn.1
  skogsbolag_1_N = mkN "skogsbolag" neutrum  ; -- skogsbolag..nn.1
  skogsbrand_1_N = mkN "skogsbrand" "skogsbränder" ; -- skogsbrand..nn.1
  skogsbruk_1_N = mkN "skogsbruk" neutrum  ; -- skogsbruk..nn.1
  skogsbryn_1_N = mkN "skogsbryn" neutrum  ; -- skogsbryn..nn.1
  skogsbäck_1_N = mkN "skogsbäck" ; -- skogsbäck..nn.1
  skogsdunge_1_N = mkN "skogsdunge" utrum  ; -- skogsdunge..nn.1
  skogsduva_1_N = mkN "skogsduva" ; -- skogsduva..nn.1
  skogsdöd_1_N = mkN "skogsdöd" ; -- skogsdöd..nn.1
  skogsflanör_1_N = mkN "skogsflanör" "skogsflanörer" ; -- skogsflanör..nn.1
  skogsfru_1_N = mkN "skogsfru" ; -- skogsfru..nn.1
  skogsfågel_1_N = mkN "skogsfågel" ; -- skogsfågel..nn.1
  skogsförbättring_1_N = mkN "skogsförbättring" ; -- skogsförbättring..nn.1
  skogsförvaltning_1_N = mkN "skogsförvaltning" ; -- skogsförvaltning..nn.1
  skogsgallring_1_N = mkN "skogsgallring" ; -- skogsgallring..nn.1
  skogsgenetik_1_N = mkN "skogsgenetik" ; -- skogsgenetik..nn.1
  skogsgenetiker_1_N = mkN "skogsgenetiker" "skogsgenetikern" "skogsgenetiker" "skogsgenetikerna" ; -- skogsgenetiker..nn.1
  skogsgenetisk_1_A = mkA "skogsgenetisk" ; -- skogsgenetisk..av.1
  skogsglänta_1_N = mkN "skogsglänta" ; -- skogsglänta..nn.1
  skogsgräns_1_N = mkN "skogsgräns" ; -- skogsgräns..nn.1
  skogsgud_1_N = mkN "skogsgud" ; -- skogsgud..nn.1
  skogshuggare_1_N = mkN "skogshuggare" utrum  ; -- skogshuggare..nn.1
  skogshushållning_1_N = mkN "skogshushållning" ; -- skogshushållning..nn.1
  skogshögskola_1_N = mkN "skogshögskola" ; -- skogshögskola..nn.1
  skogshöns_1_N = mkN "skogshöns" neutrum  ; -- skogshöns..nn.1
  skogsindustri_1_N = mkN "skogsindustri" "skogsindustrier" ; -- skogsindustri..nn.1
  skogsjacka_1_N = mkN "skogsjacka" ; -- skogsjacka..nn.1
  skogskornell_1_N = mkN "skogskornell" "skogskorneller" ; -- skogskornell..nn.1
  skogskovall_1_N = mkN "skogskovall" "skogskovaller" ; -- skogskovall..nn.1
  skogsland_1_N = mkN "skogsland" neutrum  ; -- skogsland..nn.1
  skogslandskap_1_N = mkN "skogslandskap" neutrum  ; -- skogslandskap..nn.1
  skogsluft_1_N = mkN "skogsluft" ; -- skogsluft..nn.1
  skogsmark_1_N = mkN "skogsmark" "skogsmarker" ; -- skogsmark..nn.1
  skogsmulleskola_1_N = mkN "skogsmulleskola" ; -- skogsmulleskola..nn.1
  skogsmus_1_N = mkN "skogsmus" "skogsmusen" "skogsmöss" "skogsmössen" ; -- skogsmus..nn.1
  skogsmästare_1_N = mkN "skogsmästare" utrum  ; -- skogsmästare..nn.1
  skogsnäva_1_N = mkN "skogsnäva" ; -- skogsnäva..nn.1
  skogsområde_1_N = mkN "skogsområde" ; -- skogsområde..nn.1
  skogsparti_1_N = mkN "skogsparti" "skogspartiet" "skogspartier" "skogspartierna" ; -- skogsparti..nn.1
  skogsrand_1_N = mkN "skogsrand" ; -- skogsrand..nn.1
  skogsrå_1_N = mkN "skogsrå" "skogsrån" "skogsrån" "skogsråna" ; -- skogsrå..nn.1
  skogsröjning_1_N = mkN "skogsröjning" ; -- skogsröjning..nn.1
  skogsskötsel_1_N = mkN "skogsskötsel" ; -- skogsskötsel..nn.1
  skogsskövling_1_N = mkN "skogsskövling" ; -- skogsskövling..nn.1
  skogssnuva_1_N = mkN "skogssnuva" ; -- skogssnuva..nn.1
  skogssnäppa_1_N = mkN "skogssnäppa" ; -- skogssnäppa..nn.1
  skogsstjärna_1_N = mkN "skogsstjärna" ; -- skogsstjärna..nn.1
  skogsterräng_1_N = mkN "skogsterräng" ; -- skogsterräng..nn.1
  skogstokig_1_A = mkA "skogstokig" ; -- skogstokig..av.1
  skogstomt_1_N = mkN "skogstomt" "skogstomter" ; -- skogstomt..nn.1
  skogstrakt_1_N = mkN "skogstrakt" "skogstrakter" ; -- skogstrakt..nn.1
  skogstroll_1_N = mkN "skogstroll" neutrum  ; -- skogstroll..nn.1
  skogsträd_1_N = mkN "skogsträd" neutrum  ; -- skogsträd..nn.1
  skogsträdsförädlare_1_N = mkN "skogsträdsförädlare" utrum  ; -- skogsträdsförädlare..nn.1
  skogsutflykt_1_N = mkN "skogsutflykt" "skogsutflykter" ; -- skogsutflykt..nn.1
  skogsvandring_1_N = mkN "skogsvandring" ; -- skogsvandring..nn.1
  skogsvidd_1_N = mkN "skogsvidd" "skogsvidder" ; -- skogsvidd..nn.1
  skogsväg_1_N = mkN "skogsväg" ; -- skogsväg..nn.1
  skogsvård_1_N = mkN "skogsvård" ; -- skogsvård..nn.1
  skogsägare_1_N = mkN "skogsägare" utrum  ; -- skogsägare..nn.1
  skogvaktare_1_N = mkN "skogvaktare" utrum  ; -- skogvaktare..nn.1
  skohorn_1_N = mkN "skohorn" neutrum  ; -- skohorn..nn.1
  skoj_1_A = mkA "skoj" ; -- skoj..av.1
  skoj_1_N = mkN "skoj" neutrum  ; -- skoj..nn.1
  skoja_1_V = mkV "skojar" ; -- skoja..vb.1
  skoja_2_V = mkV "skojar" ; -- skoja..vb.2
  skojande_1_N = mkN "skojande" ; -- skojande..nn.1
  skojaraktig_1_A = mkA "skojaraktig" ; -- skojaraktig..av.1
  skojare_1_N = mkN "skojare" utrum  ; -- skojare..nn.1
  skojeri_1_N = mkN "skojeri" "skojeriet" "skojerier" "skojerierna" ; -- skojeri..nn.1
  skojfrisk_1_A = mkA "skojfrisk" ; -- skojfrisk..av.1
  skojig_1_A = mkA "skojig" ; -- skojig..av.1
  skojighet_1_N = mkN "skojighet" "skojigheter" ; -- skojighet..nn.1
  skokartong_1_N = mkN "skokartong" "skokartonger" ; -- skokartong..nn.1
  skokastare_1_N = mkN "skokastare" utrum  ; -- skokastare..nn.1
  skoklädd_1_A = mkA "skoklädd" ; -- skoklädd..av.1
  skokräm_1_N = mkN "skokräm" "skokrämer" ; -- skokräm..nn.1
  skola_1_N = mkN "skola" ; -- skola..nn.1
  skola_1_V = mkV "skolar" ; -- skola..vb.1
  skolande_1_N = mkN "skolande" ; -- skolande..nn.1
  skolansvarig_1_A = mkA "skolansvarig" ; -- skolansvarig..av.1
  skolarbete_1_N = mkN "skolarbete" ; -- skolarbete..nn.1
  skolastik_1_N = mkN "skolastik" ; -- skolastik..nn.1
  skolastiker_1_N = mkN "skolastiker" "skolastikern" "skolastiker" "skolastikerna" ; -- skolastiker..nn.1
  skolastisk_1_A = mkA "skolastisk" ; -- skolastisk..av.1
  skolavgift_1_N = mkN "skolavgift" "skolavgifter" ; -- skolavgift..nn.1
  skolavslutning_1_N = mkN "skolavslutning" ; -- skolavslutning..nn.1
  skolavslutningsfest_1_N = mkN "skolavslutningsfest" "skolavslutningsfester" ; -- skolavslutningsfest..nn.1
  skolbarn_1_N = mkN "skolbarn" neutrum  ; -- skolbarn..nn.1
  skolbetyg_1_N = mkN "skolbetyg" neutrum  ; -- skolbetyg..nn.1
  skolbibliotek_1_N = mkN "skolbibliotek" neutrum  ; -- skolbibliotek..nn.1
  skolbildad_1_A = mkA "skolbildad" ; -- skolbildad..av.1
  skolbildning_1_N = mkN "skolbildning" ; -- skolbildning..nn.1
  skolbok_1_N = mkN "skolbok" "skolböcker" ; -- skolbok..nn.1
  skolboksmässig_1_A = mkA "skolboksmässig" ; -- skolboksmässig..av.1
  skolbrand_1_N = mkN "skolbrand" "skolbränder" ; -- skolbrand..nn.1
  skolbuss_1_N = mkN "skolbuss" ; -- skolbuss..nn.1
  skolbygge_1_N = mkN "skolbygge" ; -- skolbygge..nn.1
  skolbyggnad_1_N = mkN "skolbyggnad" "skolbyggnader" ; -- skolbyggnad..nn.1
  skolbänk_1_N = mkN "skolbänk" ; -- skolbänk..nn.1
  skolchef_1_N = mkN "skolchef" "skolchefer" ; -- skolchef..nn.1
  skoldag_1_N = mkN "skoldag" ; -- skoldag..nn.1
  skoldans_1_N = mkN "skoldans" "skoldanser" ; -- skoldans..nn.1
  skoldirektör_1_N = mkN "skoldirektör" "skoldirektörer" ; -- skoldirektör..nn.1
  skoldistrikt_1_N = mkN "skoldistrikt" neutrum  ; -- skoldistrikt..nn.1
  skolelev_1_N = mkN "skolelev" "skolelever" ; -- skolelev..nn.1
  skolexempel_1_N = mkN "skolexempel" neutrum  ; -- skolexempel..nn.1
  skolfartyg_1_N = mkN "skolfartyg" neutrum  ; -- skolfartyg..nn.1
  skolflicka_1_N = mkN "skolflicka" ; -- skolflicka..nn.1
  skolflygplan_1_N = mkN "skolflygplan" neutrum  ; -- skolflygplan..nn.1
  skolform_1_N = mkN "skolform" "skolformer" ; -- skolform..nn.1
  skolfranska_1_N = mkN "skolfranska" ; -- skolfranska..nn.1
  skolfröken_1_N = mkN "skolfröken" ; -- skolfröken..nn.1
  skolfux_1_N = mkN "skolfux" ; -- skolfux..nn.1
  skolförvaltning_1_N = mkN "skolförvaltning" ; -- skolförvaltning..nn.1
  skolgosse_1_N = mkN "skolgosse" utrum  ; -- skolgosse..nn.1
  skolgrammatik_1_N = mkN "skolgrammatik" "skolgrammatiker" ; -- skolgrammatik..nn.1
  skolgrind_1_N = mkN "skolgrind" ; -- skolgrind..nn.1
  skolgång_1_N = mkN "skolgång" ; -- skolgång..nn.1
  skolgård_1_N = mkN "skolgård" ; -- skolgård..nn.1
  skolgårdsminne_1_N = mkN "skolgårdsminne" ; -- skolgårdsminne..nn.1
  skolhem_1_N = mkN "skolhem" "skolhemmet" "skolhem" "skolhemmen" ; -- skolhem..nn.1
  skolhus_1_N = mkN "skolhus" neutrum  ; -- skolhus..nn.1
  skolhälsovård_1_N = mkN "skolhälsovård" ; -- skolhälsovård..nn.1
  skolinspektion_1_N = mkN "skolinspektion" ; -- skolinspektion..nn.1
  skolinspektör_1_N = mkN "skolinspektör" "skolinspektörer" ; -- skolinspektör..nn.1
  skolios_1_N = mkN "skolios" ; -- skolios..nn.1
  skoljazz_1_N = mkN "skoljazz" ; -- skoljazz..nn.1
  skoljazztävling_1_N = mkN "skoljazztävling" ; -- skoljazztävling..nn.1
  skoljournal_1_N = mkN "skoljournal" "skoljournaler" ; -- skoljournal..nn.1
  skolk_1_N = mkN "skolk" neutrum  ; -- skolk..nn.1
  skolka_1_V = mkV "skolkar" ; -- skolka..vb.1
  skolkamrat_1_N = mkN "skolkamrat" "skolkamrater" ; -- skolkamrat..nn.1
  skolkande_1_N = mkN "skolkande" ; -- skolkande..nn.1
  skolkare_1_N = mkN "skolkare" utrum  ; -- skolkare..nn.1
  skolklass_1_N = mkN "skolklass" "skolklasser" ; -- skolklass..nn.1
  skolkning_1_N = mkN "skolkning" ; -- skolkning..nn.1
  skolkorridor_1_N = mkN "skolkorridor" "skolkorridoren" "skolkorridorer" "skolkorridorerna" ; -- skolkorridor..nn.1
  skolkort_1_N = mkN "skolkort" neutrum  ; -- skolkort..nn.1
  skolkök_1_N = mkN "skolkök" neutrum  ; -- skolkök..nn.1
  skollag_1_N = mkN "skollag" ; -- skollag..nn.1
  skolledare_1_N = mkN "skolledare" utrum  ; -- skolledare..nn.1
  skolledning_1_N = mkN "skolledning" ; -- skolledning..nn.1
  skolljus_1_N = mkN "skolljus" neutrum  ; -- skolljus..nn.1
  skollov_1_N = mkN "skollov" neutrum  ; -- skollov..nn.1
  skollunch_1_N = mkN "skollunch" "skolluncher" ; -- skollunch..nn.1
  skollärare_1_N = mkN "skollärare" utrum  ; -- skollärare..nn.1
  skolmagister_1_N = mkN "skolmagister" ; -- skolmagister..nn.1
  skolmassaker_1_N = mkN "skolmassaker" "skolmassakern" "skolmassakrer" "skolmassakrerna" ; -- skolmassaker..nn.1
  skolmat_1_N = mkN "skolmat" ; -- skolmat..nn.1
  skolmatematik_1_N = mkN "skolmatematik" ; -- skolmatematik..nn.1
  skolminister_1_N = mkN "skolminister" ; -- skolminister..nn.1
  skolmogen_1_A = mkA "skolmogen" ; -- skolmogen..av.1
  skolmognad_1_N = mkN "skolmognad" "skolmognader" ; -- skolmognad..nn.1
  skolmognadsklass_1_N = mkN "skolmognadsklass" "skolmognadsklasser" ; -- skolmognadsklass..nn.1
  skolmognadsprov_1_N = mkN "skolmognadsprov" neutrum  ; -- skolmognadsprov..nn.1
  skolmyndighet_1_N = mkN "skolmyndighet" "skolmyndigheter" ; -- skolmyndighet..nn.1
  skolmässig_1_A = mkA "skolmässig" ; -- skolmässig..av.1
  skolmästaraktig_1_A = mkA "skolmästaraktig" ; -- skolmästaraktig..av.1
  skolmästaraktighet_1_N = mkN "skolmästaraktighet" ; -- skolmästaraktighet..nn.1
  skolmästare_1_N = mkN "skolmästare" utrum  ; -- skolmästare..nn.1
  skolmåltid_1_N = mkN "skolmåltid" "skolmåltider" ; -- skolmåltid..nn.1
  skolmössa_1_N = mkN "skolmössa" ; -- skolmössa..nn.1
  skolning_1_N = mkN "skolning" ; -- skolning..nn.1
  skolnämnd_1_N = mkN "skolnämnd" "skolnämnder" ; -- skolnämnd..nn.1
  skolpersonal_1_N = mkN "skolpersonal" ; -- skolpersonal..nn.1
  skolplikt_1_N = mkN "skolplikt" ; -- skolplikt..nn.1
  skolpliktig_1_A = mkA "skolpliktig" ; -- skolpliktig..av.1
  skolpojke_1_N = mkN "skolpojke" utrum  ; -- skolpojke..nn.1
  skolpolis_1_N = mkN "skolpolis" "skolpoliser" ; -- skolpolis..nn.1
  skolpolitik_1_N = mkN "skolpolitik" ; -- skolpolitik..nn.1
  skolpolitisk_1_A = mkA "skolpolitisk" ; -- skolpolitisk..av.1
  skolprov_1_N = mkN "skolprov" neutrum  ; -- skolprov..nn.1
  skolradio_1_N = mkN "skolradio" ; -- skolradio..nn.1
  skolresa_1_N = mkN "skolresa" ; -- skolresa..nn.1
  skolridning_1_N = mkN "skolridning" ; -- skolridning..nn.1
  skolritt_1_N = mkN "skolritt" ; -- skolritt..nn.1
  skolryttare_1_N = mkN "skolryttare" utrum  ; -- skolryttare..nn.1
  skolråd_1_N = mkN "skolråd" neutrum  ; -- skolråd..nn.1
  skolsal_1_N = mkN "skolsal" ; -- skolsal..nn.1
  skolsituation_1_N = mkN "skolsituation" ; -- skolsituation..nn.1
  skolsjuk_1_A = mkA "skolsjuk" ; -- skolsjuk..av.1
  skolsjukhet_1_N = mkN "skolsjukhet" ; -- skolsjukhet..nn.1
  skolskepp_1_N = mkN "skolskepp" neutrum  ; -- skolskepp..nn.1
  skolskjutning_1_N = mkN "skolskjutning" ; -- skolskjutning..nn.1
  skolskjuts_1_N = mkN "skolskjuts" ; -- skolskjuts..nn.1
  skolsköterska_1_N = mkN "skolsköterska" ; -- skolsköterska..nn.1
  skolstudium_1_N = mkN "skolstudium" "skolstudiet" "skolstudier" "skolstudierna" ; -- skolstudium..nn.1
  skolstyrelse_1_N = mkN "skolstyrelse" "skolstyrelser" ; -- skolstyrelse..nn.1
  skolsystem_1_N = mkN "skolsystem" neutrum  ; -- skolsystem..nn.1
  skolsyster_1_N = mkN "skolsyster" ; -- skolsyster..nn.1
  skolt_1_N = mkN "skolt" "skolter" ; -- skolt..nn.1
  skoltid_1_N = mkN "skoltid" "skoltider" ; -- skoltid..nn.1
  skoltrött_1_A = mkA "skoltrött" ; -- skoltrött..av.1
  skoltrötthet_1_N = mkN "skoltrötthet" ; -- skoltrötthet..nn.1
  skolunderbyggnad_1_N = mkN "skolunderbyggnad" "skolunderbyggnader" ; -- skolunderbyggnad..nn.1
  skolundervisning_1_N = mkN "skolundervisning" ; -- skolundervisning..nn.1
  skolungdom_1_N = mkN "skolungdom" ; -- skolungdom..nn.1
  skolungdomsidrott_1_N = mkN "skolungdomsidrott" "skolungdomsidrotter" ; -- skolungdomsidrott..nn.1
  skoluppsats_1_N = mkN "skoluppsats" "skoluppsatser" ; -- skoluppsats..nn.1
  skolutbildning_1_N = mkN "skolutbildning" ; -- skolutbildning..nn.1
  skolvaktmästare_1_N = mkN "skolvaktmästare" utrum  ; -- skolvaktmästare..nn.1
  skolväg_1_N = mkN "skolväg" ; -- skolväg..nn.1
  skolväsen_1_N = mkN "skolväsen" neutrum  ; -- skolväsen..nn.1
  skolväsende_1_N = mkN "skolväsende" ; -- skolväsende..nn.1
  skolämne_1_N = mkN "skolämne" ; -- skolämne..nn.1
  skoläst_1_N = mkN "skoläst" "skoläster" ; -- skoläst..nn.1
  skoläst_2_N = mkN "skoläst" ; -- skoläst..nn.2
  skolålder_1_N = mkN "skolålder" ; -- skolålder..nn.1
  skolår_1_N = mkN "skolår" neutrum  ; -- skolår..nn.1
  skolövning_1_N = mkN "skolövning" ; -- skolövning..nn.1
  skomakare_1_N = mkN "skomakare" utrum  ; -- skomakare..nn.1
  skomakarrealism_1_N = mkN "skomakarrealism" "skomakarrealismer" ; -- skomakarrealism..nn.1
  skomakarverkstad_1_N = mkN "skomakarverkstad" "skomakarverkstäder" ; -- skomakarverkstad..nn.1
  skomakeri_1_N = mkN "skomakeri" "skomakeriet" "skomakerier" "skomakerierna" ; -- skomakeri..nn.1
  skona_1_V = mkV "skonar" ; -- skona..vb.1
  skonande_1_N = mkN "skonande" ; -- skonande..nn.1
  skonare_1_N = mkN "skonare" utrum  ; -- skonare..nn.1
  skonert_1_N = mkN "skonert" "skonerter" ; -- skonert..nn.1
  skonertskepp_1_N = mkN "skonertskepp" neutrum  ; -- skonertskepp..nn.1
  skongång_1_N = mkN "skongång" ; -- skongång..nn.1
  skoning_1_N = mkN "skoning" ; -- skoning..nn.1
  skoningslös_1_A = mkA "skoningslös" ; -- skoningslös..av.1
  skoningslöshet_1_N = mkN "skoningslöshet" "skoningslösheter" ; -- skoningslöshet..nn.1
  skonsam_1_A = mkA "skonsam" "skonsamt" "skonsamma" "skonsamma" "skonsammare" "skonsammast" "skonsammaste" ; -- skonsam..av.1
  skonsamhet_1_N = mkN "skonsamhet" ; -- skonsamhet..nn.1
  skonummer_1_N = mkN "skonummer" neutrum  ; -- skonummer..nn.1
  skopa_1_N = mkN "skopa" ; -- skopa..nn.1
  skopa_1_V = mkV "skopar" ; -- skopa..vb.1
  skopande_1_N = mkN "skopande" ; -- skopande..nn.1
  skopcylinder_1_N = mkN "skopcylinder" ; -- skopcylinder..nn.1
  skopofil_1_A = mkA "skopofil" ; -- skopofil..av.1
  skopofil_1_N = mkN "skopofil" "skopofiler" ; -- skopofil..nn.1
  skopofili_1_N = mkN "skopofili" ; -- skopofili..nn.1
  skopolamin_1_N = mkN "skopolamin" "skopolaminer" ; -- skopolamin..nn.1
  skoptofili_1_N = mkN "skoptofili" ; -- skoptofili..nn.1
  skoputsare_1_N = mkN "skoputsare" utrum  ; -- skoputsare..nn.1
  skopåse_1_N = mkN "skopåse" utrum  ; -- skopåse..nn.1
  skorbut_1_N = mkN "skorbut" ; -- skorbut..nn.1
  skorpa_1_N = mkN "skorpa" ; -- skorpa..nn.1
  skorpion_1_N = mkN "skorpion" ; -- skorpion..nn.1
  skorpmjöl_1_N = mkN "skorpmjöl" neutrum  ; -- skorpmjöl..nn.1
  skorr_1_N = mkN "skorr" neutrum  ; -- skorr..nn.1
  skorra_1_V = mkV "skorrar" ; -- skorra..vb.1
  skorrande_1_N = mkN "skorrande" ; -- skorrande..nn.1
  skorrning_1_N = mkN "skorrning" ; -- skorrning..nn.1
  skorsten_1_N = mkN "skorsten" "skorstenen" "skorstenar" "skorstenarna" ; -- skorsten..nn.1
  skorstensfejare_1_N = mkN "skorstensfejare" utrum  ; -- skorstensfejare..nn.1
  skorstensmur_1_N = mkN "skorstensmur" ; -- skorstensmur..nn.1
  skorstensrök_1_N = mkN "skorstensrök" ; -- skorstensrök..nn.1
  skorv_1_N = mkN "skorv" ; -- skorv..nn.1
  skorv_2_N = mkN "skorv" ; -- skorv..nn.2
  skorvig_1_A = mkA "skorvig" ; -- skorvig..av.1
  skorvighet_1_N = mkN "skorvighet" ; -- skorvighet..nn.1
  skoskav_1_N = mkN "skoskav" neutrum  ; -- skoskav..nn.1
  skosmörja_1_N = mkN "skosmörja" ; -- skosmörja..nn.1
  skosnöre_1_N = mkN "skosnöre" ; -- skosnöre..nn.1
  skosula_1_N = mkN "skosula" ; -- skosula..nn.1
  skot_1_N = mkN "skot" neutrum  ; -- skot..nn.1
  skota_1_V = mkV "skotar" ; -- skota..vb.1
  skotande_1_N = mkN "skotande" ; -- skotande..nn.1
  skoter_1_N = mkN "skoter" ; -- skoter..nn.1
  skoterfylleri_1_N = mkN "skoterfylleri" neutrum  ; -- skoterfylleri..nn.1
  skoterkänga_1_N = mkN "skoterkänga" ; -- skoterkänga..nn.1
  skothorn_1_N = mkN "skothorn" neutrum  ; -- skothorn..nn.1
  skotsk_1_A = mkA "skotsk" ; -- skotsk..av.1
  skotska_1_N = mkN "skotska" ; -- skotska..nn.1
  skotska_2_N = mkN "skotska" ; -- skotska..nn.2
  skotskhet_1_N = mkN "skotskhet" ; -- skotskhet..nn.1
  skotskrutig_1_A = mkA "skotskrutig" ; -- skotskrutig..av.1
  skotstek_1_N = mkN "skotstek" neutrum  ; -- skotstek..nn.1
  skott_1_N = mkN "skott" neutrum  ; -- skott..nn.1
  skotta_1_V = mkV "skottar" ; -- skotta..vb.1
  skottande_1_N = mkN "skottande" ; -- skottande..nn.1
  skottavla_1_N = mkN "skottavla" ; -- skottavla..nn.1
  skottdag_1_N = mkN "skottdag" ; -- skottdag..nn.1
  skottdrama_1_N = mkN "skottdrama" "skottdramat" "skottdramer" "skottdramerna" ; -- skottdrama..nn.1
  skotte_1_N = mkN "skotte" utrum  ; -- skotte..nn.1
  skottfri_1_A = mkA "skottfri" "skottfritt" ; -- skottfri..av.1
  skottfrihet_1_N = mkN "skottfrihet" ; -- skottfrihet..nn.1
  skottfält_1_N = mkN "skottfält" neutrum  ; -- skottfält..nn.1
  skottglugg_1_N = mkN "skottglugg" ; -- skottglugg..nn.1
  skotthål_1_N = mkN "skotthål" neutrum  ; -- skotthål..nn.1
  skotthåll_1_N = mkN "skotthåll" neutrum  ; -- skotthåll..nn.1
  skottkärra_1_N = mkN "skottkärra" ; -- skottkärra..nn.1
  skottkärrehjul_1_N = mkN "skottkärrehjul" neutrum  ; -- skottkärrehjul..nn.1
  skottlinje_1_N = mkN "skottlinje" "skottlinjer" ; -- skottlinje..nn.1
  skottlossning_1_N = mkN "skottlossning" ; -- skottlossning..nn.1
  skottning_1_N = mkN "skottning" ; -- skottning..nn.1
  skottningsolycka_1_N = mkN "skottningsolycka" ; -- skottningsolycka..nn.1
  skottpeng_1_N = mkN "skottpeng" ; -- skottpeng..nn.1
  skotträdd_1_A = mkA "skotträdd" ; -- skotträdd..av.1
  skotträddhet_1_N = mkN "skotträddhet" ; -- skotträddhet..nn.1
  skottsekund_1_N = mkN "skottsekund" "skottsekunder" ; -- skottsekund..nn.1
  skottskada_1_N = mkN "skottskada" ; -- skottskada..nn.1
  skottskada_1_V = mkV "skottskadar" ; -- skottskada..vb.1
  skottskadande_1_N = mkN "skottskadande" ; -- skottskadande..nn.1
  skottskog_1_N = mkN "skottskog" ; -- skottskog..nn.1
  skottspole_1_N = mkN "skottspole" utrum  ; -- skottspole..nn.1
  skottsäker_1_A = mkA "skottsäker" ; -- skottsäker..av.1
  skottsäkerhet_1_N = mkN "skottsäkerhet" ; -- skottsäkerhet..nn.1
  skottvidd_1_N = mkN "skottvidd" "skottvidder" ; -- skottvidd..nn.1
  skottår_1_N = mkN "skottår" neutrum  ; -- skottår..nn.1
  skov_1_N = mkN "skov" neutrum  ; -- skov..nn.1
  skovel_1_N = mkN "skovel" ; -- skovel..nn.1
  skovelhjul_1_N = mkN "skovelhjul" neutrum  ; -- skovelhjul..nn.1
  skovla_1_V = mkV "skovlar" ; -- skovla..vb.1
  skovlande_1_N = mkN "skovlande" ; -- skovlande..nn.1
  skrabba_1_N = mkN "skrabba" ; -- skrabba..nn.1
  skrabbig_1_A = mkA "skrabbig" ; -- skrabbig..av.1
  skrabbighet_1_N = mkN "skrabbighet" ; -- skrabbighet..nn.1
  skraffera_1_V = mkV "skrafferar" ; -- skraffera..vb.1
  skrafferande_1_N = mkN "skrafferande" ; -- skrafferande..nn.1
  skrafferbar_1_A = mkA "skrafferbar" ; -- skrafferbar..av.1
  skrafferbarhet_1_N = mkN "skrafferbarhet" ; -- skrafferbarhet..nn.1
  skraffering_1_N = mkN "skraffering" ; -- skraffering..nn.1
  skraj_1_A = mkA "skraj" ; -- skraj..av.1
  skrajhet_1_N = mkN "skrajhet" ; -- skrajhet..nn.1
  skrajsen_1_A = mkA "skrajsen" ; -- skrajsen..av.1
  skrake_1_N = mkN "skrak" ; -- skrake..nn.1
  skral_1_A = mkA "skral" ; -- skral..av.1
  skralhet_1_N = mkN "skralhet" ; -- skralhet..nn.1
  skralna_1_V = mkV "skralnar" ; -- skralna..vb.1
  skralnande_1_N = mkN "skralnande" ; -- skralnande..nn.1
  skralta_1_V = mkV "skraltar" ; -- skralta..vb.1
  skraltande_1_N = mkN "skraltande" ; -- skraltande..nn.1
  skraltig_1_A = mkA "skraltig" ; -- skraltig..av.1
  skraltighet_1_N = mkN "skraltighet" ; -- skraltighet..nn.1
  skramla_1_N = mkN "skramla" ; -- skramla..nn.1
  skramla_1_V = mkV "skramlar" ; -- skramla..vb.1
  skramla_2_V = mkV "skramlar" ; -- skramla..vb.2
  skramlande_1_N = mkN "skramlande" ; -- skramlande..nn.1
  skramlig_1_A = mkA "skramlig" ; -- skramlig..av.1
  skramlighet_1_N = mkN "skramlighet" ; -- skramlighet..nn.1
  skrammel_1_N = mkN "skrammel" neutrum  ; -- skrammel..nn.1
  skranglig_1_A = mkA "skranglig" ; -- skranglig..av.1
  skranglighet_1_N = mkN "skranglighet" ; -- skranglighet..nn.1
  skrank_1_N = mkN "skrank" neutrum  ; -- skrank..nn.1
  skranka_1_N = mkN "skranka" ; -- skranka..nn.1
  skrap_1_N = mkN "skrap" neutrum  ; -- skrap..nn.1
  skrapa_1_N = mkN "skrapa" ; -- skrapa..nn.1
  skrapa_1_V = mkV "skrapar" ; -- skrapa..vb.1
  skrapande_1_N = mkN "skrapande" ; -- skrapande..nn.1
  skrapfält_1_N = mkN "skrapfält" neutrum  ; -- skrapfält..nn.1
  skraplott_1_N = mkN "skraplott" "skraplotter" ; -- skraplott..nn.1
  skrapning_1_N = mkN "skrapning" ; -- skrapning..nn.1
  skrapnos_1_N = mkN "skrapnos" ; -- skrapnos..nn.1
  skrapsår_1_N = mkN "skrapsår" neutrum  ; -- skrapsår..nn.1
  skratt_1_N = mkN "skratt" neutrum  ; -- skratt..nn.1
  skratta_1_V = mkV "skrattar" ; -- skratta..vb.1
  skrattande_1_N = mkN "skrattande" ; -- skrattande..nn.1
  skrattare_1_N = mkN "skrattare" utrum  ; -- skrattare..nn.1
  skrattfest_1_N = mkN "skrattfest" "skrattfester" ; -- skrattfest..nn.1
  skrattgrop_1_N = mkN "skrattgrop" ; -- skrattgrop..nn.1
  skrattkalas_1_N = mkN "skrattkalas" neutrum  ; -- skrattkalas..nn.1
  skrattkramp_1_N = mkN "skrattkramp" "skrattkramper" ; -- skrattkramp..nn.1
  skrattlust_1_N = mkN "skrattlust" ; -- skrattlust..nn.1
  skrattlysten_1_A = mkA "skrattlysten" ; -- skrattlysten..av.1
  skrattmås_1_N = mkN "skrattmås" ; -- skrattmås..nn.1
  skrattparoxysm_1_N = mkN "skrattparoxysm" "skrattparoxysmer" ; -- skrattparoxysm..nn.1
  skrattpålägg_1_N = mkN "skrattpålägg" neutrum  ; -- skrattpålägg..nn.1
  skrattretande_1_A = mkA "skrattretande" ; -- skrattretande..av.1
  skrattrynka_1_N = mkN "skrattrynka" ; -- skrattrynka..nn.1
  skrattsalva_1_N = mkN "skrattsalva" ; -- skrattsalva..nn.1
  skrattspegel_1_N = mkN "skrattspegel" ; -- skrattspegel..nn.1
  skravel_1_N = mkN "skravel" neutrum  ; -- skravel..nn.1
  skred_1_N = mkN "skred" neutrum  ; -- skred..nn.1
  skrev_1_N = mkN "skrev" neutrum  ; -- skrev..nn.1
  skreva_1_N = mkN "skreva" ; -- skreva..nn.1
  skreva_1_V = mkV "skrevar" ; -- skreva..vb.1
  skrevande_1_N = mkN "skrevande" ; -- skrevande..nn.1
  skri_1_N = mkN "skri" "skriet" "skrin" "skrina" ; -- skri..nn.1
  skria_1_V = mkV "skriar" ; -- skria..vb.1
  skriande_1_A = mkA "skriande" ; -- skriande..av.1
  skriande_1_N = mkN "skriande" ; -- skriande..nn.1
  skribent_1_N = mkN "skribent" "skribenter" ; -- skribent..nn.1
  skrida_1_V = mkV "skrida" "skred" "skridit" ; -- skrida..vb.1
  skridande_1_N = mkN "skridande" ; -- skridande..nn.1
  skridning_1_N = mkN "skridning" ; -- skridning..nn.1
  skridsko_1_N = mkN "skridsko" "skridskor" ; -- skridsko..nn.1
  skridskobana_1_N = mkN "skridskobana" ; -- skridskobana..nn.1
  skridskoprinsessa_1_N = mkN "skridskoprinsessa" ; -- skridskoprinsessa..nn.1
  skridskosegling_1_N = mkN "skridskosegling" ; -- skridskosegling..nn.1
  skridskoåkare_1_N = mkN "skridskoåkare" utrum  ; -- skridskoåkare..nn.1
  skridskoåkning_1_N = mkN "skridskoåkning" ; -- skridskoåkning..nn.1
  skrift_1_N = mkN "skrift" "skrifter" ; -- skrift..nn.1
  skriftbild_1_N = mkN "skriftbild" "skriftbilder" ; -- skriftbild..nn.1
  skriftdrag_1_N = mkN "skriftdrag" neutrum  ; -- skriftdrag..nn.1
  skriftenlig_1_A = mkA "skriftenlig" ; -- skriftenlig..av.1
  skriftermål_1_N = mkN "skriftermål" neutrum  ; -- skriftermål..nn.1
  skriftkonst_1_N = mkN "skriftkonst" "skriftkonster" ; -- skriftkonst..nn.1
  skriftlig_1_A = mkA "skriftlig" ; -- skriftlig..av.1
  skriftligen_1_Adv = mkAdv "skriftligen" ; -- skriftligen..ab.1
  skriftlighet_1_N = mkN "skriftlighet" ; -- skriftlighet..nn.1
  skriftlärd_1_A = mkA "skriftlärd" "skriftlärt" ; -- skriftlärd..av.1
  skriftspråk_1_N = mkN "skriftspråk" neutrum  ; -- skriftspråk..nn.1
  skriftspråklig_1_A = mkA "skriftspråklig" ; -- skriftspråklig..av.1
  skriftspråklighet_1_N = mkN "skriftspråklighet" "skriftspråkligheter" ; -- skriftspråklighet..nn.1
  skriftställare_1_N = mkN "skriftställare" utrum  ; -- skriftställare..nn.1
  skriftställeri_1_N = mkN "skriftställeri" "skriftställeriet" "skriftställerier" "skriftställerierna" ; -- skriftställeri..nn.1
  skriftsvenska_1_N = mkN "skriftsvenska" ; -- skriftsvenska..nn.1
  skriftsystem_1_N = mkN "skriftsystem" neutrum  ; -- skriftsystem..nn.1
  skrifttolkning_1_N = mkN "skrifttolkning" ; -- skrifttolkning..nn.1
  skriftväxla_1_V = mkV "skriftväxlar" ; -- skriftväxla..vb.1
  skriftväxlande_1_N = mkN "skriftväxlande" ; -- skriftväxlande..nn.1
  skriftväxling_1_N = mkN "skriftväxling" ; -- skriftväxling..nn.1
  skrik_1_N = mkN "skrik" neutrum  ; -- skrik..nn.1
  skrika_1_N = mkN "skrika" ; -- skrika..nn.1
  skrika_1_V = mkV "skrika" "skrek" "skrikit" ; -- skrika..vb.1
  skrikande_1_N = mkN "skrikande" ; -- skrikande..nn.1
  skrikhals_1_N = mkN "skrikhals" ; -- skrikhals..nn.1
  skrikig_1_A = mkA "skrikig" ; -- skrikig..av.1
  skrikighet_1_N = mkN "skrikighet" ; -- skrikighet..nn.1
  skriksession_1_N = mkN "skriksession" ; -- skriksession..nn.1
  skrin_1_N = mkN "skrin" neutrum  ; -- skrin..nn.1
  skrinda_1_N = mkN "skrinda" ; -- skrinda..nn.1
  skrinlägga_1_V = mkV "skrinlägga" "skrinla" "skrinlagt" ; -- skrinlägga..vb.1
  skrinläggande_1_N = mkN "skrinläggande" ; -- skrinläggande..nn.1
  skrinläggning_1_N = mkN "skrinläggning" ; -- skrinläggning..nn.1
  skrinna_1_V = mkV "skrinnar" ; -- skrinna..vb.1
  skrinnande_1_N = mkN "skrinnande" ; -- skrinnande..nn.1
  skrinnare_1_N = mkN "skrinnare" utrum  ; -- skrinnare..nn.1
  skripta_1_N = mkN "skripta" ; -- skripta..nn.1
  skriptum_1_N = mkN "skriptum" neutrum  ; -- skriptum..nn.1
  skritt_1_N = mkN "skritt" ; -- skritt..nn.1
  skritta_1_V = mkV "skrittar" ; -- skritta..vb.1
  skrittande_1_N = mkN "skrittande" ; -- skrittande..nn.1
  skriva_1_V = mkV "skriva" "skrev" "skrivit" ; -- skriva..vb.1
  skrivande_1_N = mkN "skrivande" ; -- skrivande..nn.1
  skrivare_1_N = mkN "skrivare" utrum  ; -- skrivare..nn.1
  skrivarförmåga_1_N = mkN "skrivarförmåga" ; -- skrivarförmåga..nn.1
  skrivarkurs_1_N = mkN "skrivarkurs" "skrivarkurser" ; -- skrivarkurs..nn.1
  skrivarpapper_1_N = mkN "skrivarpapper" neutrum  ; -- skrivarpapper..nn.1
  skrivbar_1_A = mkA "skrivbar" ; -- skrivbar..av.1
  skrivberedd_1_A = mkA "skrivberedd" ; -- skrivberedd..av.1
  skrivblock_1_N = mkN "skrivblock" neutrum  ; -- skrivblock..nn.1
  skrivbok_1_N = mkN "skrivbok" "skrivböcker" ; -- skrivbok..nn.1
  skrivbord_1_N = mkN "skrivbord" neutrum  ; -- skrivbord..nn.1
  skrivbordsjobb_1_N = mkN "skrivbordsjobb" neutrum  ; -- skrivbordsjobb..nn.1
  skrivbordsjournalistik_1_N = mkN "skrivbordsjournalistik" ; -- skrivbordsjournalistik..nn.1
  skrivbordskonstruktion_1_N = mkN "skrivbordskonstruktion" ; -- skrivbordskonstruktion..nn.1
  skrivbordslampa_1_N = mkN "skrivbordslampa" ; -- skrivbordslampa..nn.1
  skrivbordslåda_1_N = mkN "skrivbordslåda" ; -- skrivbordslåda..nn.1
  skrivbordsprodukt_1_N = mkN "skrivbordsprodukt" "skrivbordsprodukter" ; -- skrivbordsprodukt..nn.1
  skrivbordsstol_1_N = mkN "skrivbordsstol" ; -- skrivbordsstol..nn.1
  skrivbordstjänst_1_N = mkN "skrivbordstjänst" ; -- skrivbordstjänst..nn.1
  skrivbordsunderlägg_1_N = mkN "skrivbordsunderlägg" neutrum  ; -- skrivbordsunderlägg..nn.1
  skrivbyrå_1_N = mkN "skrivbyrå" "skrivbyråer" ; -- skrivbyrå..nn.1
  skrivdon_1_N = mkN "skrivdon" neutrum  ; -- skrivdon..nn.1
  skrivelse_1_N = mkN "skrivelse" "skrivelser" ; -- skrivelse..nn.1
  skriveri_1_N = mkN "skriveri" "skriveriet" "skriverier" "skriverierna" ; -- skriveri..nn.1
  skrivfel_1_N = mkN "skrivfel" "skrivfelet" "skrivfel" "skrivfelen" ; -- skrivfel..nn.1
  skrivförmåga_1_N = mkN "skrivförmåga" ; -- skrivförmåga..nn.1
  skrivhäfte_1_N = mkN "skrivhäfte" ; -- skrivhäfte..nn.1
  skrivhörna_1_N = mkN "skrivhörna" ; -- skrivhörna..nn.1
  skrivklåda_1_N = mkN "skrivklåda" ; -- skrivklåda..nn.1
  skrivkonst_1_N = mkN "skrivkonst" "skrivkonster" ; -- skrivkonst..nn.1
  skrivkramp_1_N = mkN "skrivkramp" ; -- skrivkramp..nn.1
  skrivkunnig_1_A = mkA "skrivkunnig" ; -- skrivkunnig..av.1
  skrivkunnighet_1_N = mkN "skrivkunnighet" ; -- skrivkunnighet..nn.1
  skrivmaskin_1_N = mkN "skrivmaskin" "skrivmaskiner" ; -- skrivmaskin..nn.1
  skrivmaskinsbord_1_N = mkN "skrivmaskinsbord" neutrum  ; -- skrivmaskinsbord..nn.1
  skrivmaskinsknatter_1_N = mkN "skrivmaskinsknatter" neutrum  ; -- skrivmaskinsknatter..nn.1
  skrivmaskinsstol_1_N = mkN "skrivmaskinsstol" ; -- skrivmaskinsstol..nn.1
  skrivmaskinstangent_1_N = mkN "skrivmaskinstangent" "skrivmaskinstangenter" ; -- skrivmaskinstangent..nn.1
  skrivmaskinstillverkare_1_N = mkN "skrivmaskinstillverkare" utrum  ; -- skrivmaskinstillverkare..nn.1
  skrivning_1_N = mkN "skrivning" ; -- skrivning..nn.1
  skrivplats_1_N = mkN "skrivplats" "skrivplatser" ; -- skrivplats..nn.1
  skrivplån_1_N = mkN "skrivplån" neutrum  ; -- skrivplån..nn.1
  skrivpulpet_1_N = mkN "skrivpulpet" "skrivpulpeter" ; -- skrivpulpet..nn.1
  skrivsal_1_N = mkN "skrivsal" ; -- skrivsal..nn.1
  skrivseans_1_N = mkN "skrivseans" "skrivseanser" ; -- skrivseans..nn.1
  skrivstil_1_N = mkN "skrivstil" ; -- skrivstil..nn.1
  skrivstörning_1_N = mkN "skrivstörning" ; -- skrivstörning..nn.1
  skrivsätt_1_N = mkN "skrivsätt" neutrum  ; -- skrivsätt..nn.1
  skrivtavla_1_N = mkN "skrivtavla" ; -- skrivtavla..nn.1
  skrivtecken_1_N = mkN "skrivtecken" "skrivtecknet" "skrivtecken" "skrivtecknen" ; -- skrivtecken..nn.1
  skrivunderlägg_1_N = mkN "skrivunderlägg" neutrum  ; -- skrivunderlägg..nn.1
  skrivår_1_N = mkN "skrivår" neutrum  ; -- skrivår..nn.1
  skrivövning_1_N = mkN "skrivövning" ; -- skrivövning..nn.1
  skrock_1_N = mkN "skrock" neutrum  ; -- skrock..nn.1
  skrocka_1_V = mkV "skrockar" ; -- skrocka..vb.1
  skrockande_1_N = mkN "skrockande" ; -- skrockande..nn.1
  skrockfull_1_A = mkA "skrockfull" ; -- skrockfull..av.1
  skrockfullhet_1_N = mkN "skrockfullhet" "skrockfullheter" ; -- skrockfullhet..nn.1
  skrockning_1_N = mkN "skrockning" ; -- skrockning..nn.1
  skrodera_1_V = mkV "skroderar" ; -- skrodera..vb.1
  skroderande_1_N = mkN "skroderande" ; -- skroderande..nn.1
  skrodering_1_N = mkN "skrodering" ; -- skrodering..nn.1
  skrodör_1_N = mkN "skrodör" "skrodörer" ; -- skrodör..nn.1
  skrofulös_1_A = mkA "skrofulös" ; -- skrofulös..av.1
  skrot_1_N = mkN "skrot" neutrum  ; -- skrot..nn.1
  skrot_2_N = mkN "skrot" ; -- skrot..nn.2
  skrota_1_V = mkV "skrotar" ; -- skrota..vb.1
  skrota_2_V = mkV "skrotar" ; -- skrota..vb.2
  skrotande_1_N = mkN "skrotande" ; -- skrotande..nn.1
  skrotbil_1_N = mkN "skrotbil" ; -- skrotbil..nn.1
  skrotfärdig_1_A = mkA "skrotfärdig" ; -- skrotfärdig..av.1
  skrothämtning_1_N = mkN "skrothämtning" ; -- skrothämtning..nn.1
  skrothämtningsgubbe_1_N = mkN "skrothämtningsgubbe" utrum  ; -- skrothämtningsgubbe..nn.1
  skrothög_1_N = mkN "skrothög" ; -- skrothög..nn.1
  skrotning_1_N = mkN "skrotning" ; -- skrotning..nn.1
  skrotningspremie_1_N = mkN "skrotningspremie" "skrotningspremier" ; -- skrotningspremie..nn.1
  skrotsamlare_1_N = mkN "skrotsamlare" utrum  ; -- skrotsamlare..nn.1
  skrotskulptur_1_N = mkN "skrotskulptur" "skrotskulpturer" ; -- skrotskulptur..nn.1
  skrott_1_N = mkN "skrott" ; -- skrott..nn.1
  skrotupplag_1_N = mkN "skrotupplag" neutrum  ; -- skrotupplag..nn.1
  skrotvärde_1_N = mkN "skrotvärde" ; -- skrotvärde..nn.1
  skrov_1_N = mkN "skrov" neutrum  ; -- skrov..nn.1
  skrovlig_1_A = mkA "skrovlig" ; -- skrovlig..av.1
  skrovlighet_1_N = mkN "skrovlighet" "skrovligheter" ; -- skrovlighet..nn.1
  skrovmål_1_N = mkN "skrovmål" neutrum  ; -- skrovmål..nn.1
  skrubb_1_N = mkN "skrubb" ; -- skrubb..nn.1
  skrubba_1_N = mkN "skrubba" ; -- skrubba..nn.1
  skrubba_1_V = mkV "skrubbar" ; -- skrubba..vb.1
  skrubbande_1_N = mkN "skrubbande" ; -- skrubbande..nn.1
  skrubbdörr_1_N = mkN "skrubbdörr" ; -- skrubbdörr..nn.1
  skrubbliknande_1_A = mkA "skrubbliknande" ; -- skrubbliknande..av.1
  skrubbning_1_N = mkN "skrubbning" ; -- skrubbning..nn.1
  skrubbsår_1_N = mkN "skrubbsår" neutrum  ; -- skrubbsår..nn.1
  skrud_1_N = mkN "skrud" ; -- skrud..nn.1
  skruda_1_V = mkV "skrudar" ; -- skruda..vb.1
  skrudande_1_N = mkN "skrudande" ; -- skrudande..nn.1
  skrumpen_1_A = mkA "skrumpen" ; -- skrumpen..av.1
  skrumpenhet_1_N = mkN "skrumpenhet" ; -- skrumpenhet..nn.1
  skrumplever_1_N = mkN "skrumplever" ; -- skrumplever..nn.1
  skrumpna_1_V = mkV "skrumpnar" ; -- skrumpna..vb.1
  skrumpnande_1_N = mkN "skrumpnande" ; -- skrumpnande..nn.1
  skrumpnjure_1_N = mkN "skrumpnjure" utrum  ; -- skrumpnjure..nn.1
  skrupel_1_N = mkN "skrupel" "skrupeln" "skrupler" "skruplerna" ; -- skrupel..nn.1
  skrupelfri_1_A = mkA "skrupelfri" "skrupelfritt" ; -- skrupelfri..av.1
  skrupellös_1_A = mkA "skrupellös" ; -- skrupellös..av.1
  skrupellöshet_1_N = mkN "skrupellöshet" "skrupellösheter" ; -- skrupellöshet..nn.1
  skrupulös_1_A = mkA "skrupulös" ; -- skrupulös..av.1
  skrutt_1_N = mkN "skrutt" ; -- skrutt..nn.1
  skrutt_2_N = mkN "skrutt" ; -- skrutt..nn.2
  skruttig_1_A = mkA "skruttig" ; -- skruttig..av.1
  skruttighet_1_N = mkN "skruttighet" ; -- skruttighet..nn.1
  skruv_1_N = mkN "skruv" ; -- skruv..nn.1
  skruva_1_V = mkV "skruvar" ; -- skruva..vb.1
  skruvad_1_A = mkA "skruvad" ; -- skruvad..av.1
  skruvande_1_N = mkN "skruvande" ; -- skruvande..nn.1
  skruvavstånd_1_N = mkN "skruvavstånd" neutrum  ; -- skruvavstånd..nn.1
  skruvbar_1_A = mkA "skruvbar" ; -- skruvbar..av.1
  skruvdragare_1_N = mkN "skruvdragare" utrum  ; -- skruvdragare..nn.1
  skruvformig_1_A = mkA "skruvformig" ; -- skruvformig..av.1
  skruvförband_1_N = mkN "skruvförband" neutrum  ; -- skruvförband..nn.1
  skruvhuvud_1_N = mkN "skruvhuvud" "skruvhuvudet" "skruvhuvud" "skruvhuvudena" ; -- skruvhuvud..nn.1
  skruvhål_1_N = mkN "skruvhål" neutrum  ; -- skruvhål..nn.1
  skruvis_1_N = mkN "skruvis" ; -- skruvis..nn.1
  skruvkrok_1_N = mkN "skruvkrok" ; -- skruvkrok..nn.1
  skruvmejsel_1_N = mkN "skruvmejsel" ; -- skruvmejsel..nn.1
  skruvnyckel_1_N = mkN "skruvnyckel" ; -- skruvnyckel..nn.1
  skruvskalle_1_N = mkN "skruvskalle" utrum  ; -- skruvskalle..nn.1
  skruvstycke_1_N = mkN "skruvstycke" ; -- skruvstycke..nn.1
  skruvstäd_1_N = mkN "skruvstäd" neutrum  ; -- skruvstäd..nn.1
  skruvtving_1_N = mkN "skruvtving" ; -- skruvtving..nn.1
  skrymma_1_V = mkV "skrymmer" ; -- skrymma..vb.1
  skrymmande_1_A = mkA "skrymmande" ; -- skrymmande..av.1
  skrymmande_1_N = mkN "skrymmande" ; -- skrymmande..nn.1
  skrymsla_1_N = mkN "skrymsla" ; -- skrymsla..nn.1
  skrymsle_1_N = mkN "skrymsle" ; -- skrymsle..nn.1
  skrymt_1_N = mkN "skrymt" neutrum  ; -- skrymt..nn.1
  skrymt_2_N = mkN "skrymt" ; -- skrymt..nn.2
  skrymta_1_V = mkV "skrymtar" ; -- skrymta..vb.1
  skrymtaktig_1_A = mkA "skrymtaktig" ; -- skrymtaktig..av.1
  skrymtaktighet_1_N = mkN "skrymtaktighet" ; -- skrymtaktighet..nn.1
  skrymtande_1_N = mkN "skrymtande" ; -- skrymtande..nn.1
  skrymtare_1_N = mkN "skrymtare" utrum  ; -- skrymtare..nn.1
  skrymteri_1_N = mkN "skrymteri" "skrymteriet" "skrymterier" "skrymterierna" ; -- skrymteri..nn.1
  skrynkelfri_1_A = mkA "skrynkelfri" "skrynkelfritt" ; -- skrynkelfri..av.1
  skrynkelhärdig_1_A = mkA "skrynkelhärdig" ; -- skrynkelhärdig..av.1
  skrynkla_1_N = mkN "skrynkla" ; -- skrynkla..nn.1
  skrynkla_1_V = mkV "skrynklar" ; -- skrynkla..vb.1
  skrynklande_1_N = mkN "skrynklande" ; -- skrynklande..nn.1
  skrynklare_1_N = mkN "skrynklare" utrum  ; -- skrynklare..nn.1
  skrynklig_1_A = mkA "skrynklig" ; -- skrynklig..av.1
  skrynklighet_1_N = mkN "skrynklighet" ; -- skrynklighet..nn.1
  skrynkling_1_N = mkN "skrynkling" ; -- skrynkling..nn.1
  skryt_1_N = mkN "skryt" neutrum  ; -- skryt..nn.1
  skryta_1_V = mkV "skryta" "skröt" "skrutit" ; -- skryta..vb.1
  skrytande_1_N = mkN "skrytande" ; -- skrytande..nn.1
  skrytare_1_N = mkN "skrytare" utrum  ; -- skrytare..nn.1
  skrytbygge_1_N = mkN "skrytbygge" ; -- skrytbygge..nn.1
  skrytfena_1_N = mkN "skrytfena" ; -- skrytfena..nn.1
  skrytmåns_1_N = mkN "skrytmåns" ; -- skrytmåns..nn.1
  skrytsam_1_A = mkA "skrytsam" "skrytsamt" "skrytsamma" "skrytsamma" "skrytsammare" "skrytsammast" "skrytsammaste" ; -- skrytsam..av.1
  skrytsamhet_1_N = mkN "skrytsamhet" ; -- skrytsamhet..nn.1
  skräck_1_N = mkN "skräck" ; -- skräck..nn.1
  skräckberättelse_1_N = mkN "skräckberättelse" "skräckberättelser" ; -- skräckberättelse..nn.1
  skräckbild_1_N = mkN "skräckbild" "skräckbilder" ; -- skräckbild..nn.1
  skräckblandad_1_A = mkA "skräckblandad" ; -- skräckblandad..av.1
  skräckdrog_1_N = mkN "skräckdrog" "skräckdroger" ; -- skräckdrog..nn.1
  skräckel_1_N = mkN "skräckel" neutrum  ; -- skräckel..nn.1
  skräckexempel_1_N = mkN "skräckexempel" neutrum  ; -- skräckexempel..nn.1
  skräckfilm_1_N = mkN "skräckfilm" "skräckfilmer" ; -- skräckfilm..nn.1
  skräckfylld_1_A = mkA "skräckfylld" "skräckfyllt" ; -- skräckfylld..av.1
  skräckfängelse_1_N = mkN "skräckfängelse" "skräckfängelset" "skräckfängelser" "skräckfängelserna" ; -- skräckfängelse..nn.1
  skräckhistoria_1_N = mkN "skräckhistoria" "skräckhistorian" "skräckhistorier" "skräckhistorierna" ; -- skräckhistoria..nn.1
  skräckinjagande_1_A = mkA "skräckinjagande" ; -- skräckinjagande..av.1
  skräckkabinett_1_N = mkN "skräckkabinett" neutrum  ; -- skräckkabinett..nn.1
  skräcknatt_1_N = mkN "skräcknatt" "skräcknätter" ; -- skräcknatt..nn.1
  skräcknovell_1_N = mkN "skräcknovell" "skräcknoveller" ; -- skräcknovell..nn.1
  skräckpropaganda_1_N = mkN "skräckpropaganda" ; -- skräckpropaganda..nn.1
  skräckregemente_1_N = mkN "skräckregemente" ; -- skräckregemente..nn.1
  skräckregering_1_N = mkN "skräckregering" ; -- skräckregering..nn.1
  skräckrubrik_1_N = mkN "skräckrubrik" "skräckrubriker" ; -- skräckrubrik..nn.1
  skräckscen_1_N = mkN "skräckscen" "skräckscener" ; -- skräckscen..nn.1
  skräckskildrare_1_N = mkN "skräckskildrare" utrum  ; -- skräckskildrare..nn.1
  skräckskildring_1_N = mkN "skräckskildring" ; -- skräckskildring..nn.1
  skräckslagen_1_A = mkA "skräckslagen" ; -- skräckslagen..av.1
  skräcksyn_1_N = mkN "skräcksyn" "skräcksyner" ; -- skräcksyn..nn.1
  skräcksystem_1_N = mkN "skräcksystem" neutrum  ; -- skräcksystem..nn.1
  skräcktackling_1_N = mkN "skräcktackling" ; -- skräcktackling..nn.1
  skräckvision_1_N = mkN "skräckvision" ; -- skräckvision..nn.1
  skräckvälde_1_N = mkN "skräckvälde" ; -- skräckvälde..nn.1
  skräcködla_1_N = mkN "skräcködla" ; -- skräcködla..nn.1
  skräda_1_V = mkV "skräda" "skrädde" "skrätt" ; -- skräda..vb.1
  skrädande_1_N = mkN "skrädande" ; -- skrädande..nn.1
  skrädda_1_V = mkV "skräddar" ; -- skrädda..vb.1
  skräddande_1_N = mkN "skräddande" ; -- skräddande..nn.1
  skräddare_1_N = mkN "skräddare" utrum  ; -- skräddare..nn.1
  skräddarsax_1_N = mkN "skräddarsax" ; -- skräddarsax..nn.1
  skräddarsy_1_V = mkV "skräddarsyr" ; -- skräddarsy..vb.1
  skräddarsyende_1_N = mkN "skräddarsyende" ; -- skräddarsyende..nn.1
  skrädderi_1_N = mkN "skrädderi" "skrädderiet" "skrädderier" "skrädderierna" ; -- skrädderi..nn.1
  skrädning_1_N = mkN "skrädning" ; -- skrädning..nn.1
  skrädyxa_1_N = mkN "skrädyxa" ; -- skrädyxa..nn.1
  skräll_1_N = mkN "skräll" ; -- skräll..nn.1
  skrälla_1_V = mkV "skräller" ; -- skrälla..vb.1
  skrällande_1_N = mkN "skrällande" ; -- skrällande..nn.1
  skrälldus_1_N = mkN "skrälldus" "skrällduser" ; -- skrälldus..nn.1
  skrälle_1_N = mkN "skrälle" ; -- skrälle..nn.1
  skrällhosta_1_N = mkN "skrällhosta" ; -- skrällhosta..nn.1
  skrällig_1_A = mkA "skrällig" ; -- skrällig..av.1
  skrällighet_1_N = mkN "skrällighet" ; -- skrällighet..nn.1
  skrällseger_1_N = mkN "skrällseger" ; -- skrällseger..nn.1
  skrällvinst_1_N = mkN "skrällvinst" "skrällvinster" ; -- skrällvinst..nn.1
  skrämma_1_V = mkV "skrämmer" ; -- skrämma..vb.1
  skrämmande_1_A = mkA "skrämmande" ; -- skrämmande..av.1
  skrämmande_1_N = mkN "skrämmande" ; -- skrämmande..nn.1
  skrämsel_1_N = mkN "skrämsel" ; -- skrämsel..nn.1
  skrämselhicka_1_N = mkN "skrämselhicka" ; -- skrämselhicka..nn.1
  skrämselpropaganda_1_N = mkN "skrämselpropaganda" ; -- skrämselpropaganda..nn.1
  skrämskott_1_N = mkN "skrämskott" neutrum  ; -- skrämskott..nn.1
  skrän_1_N = mkN "skrän" neutrum  ; -- skrän..nn.1
  skräna_1_V = mkV "skränar" ; -- skräna..vb.1
  skränande_1_N = mkN "skränande" ; -- skränande..nn.1
  skränare_1_N = mkN "skränare" utrum  ; -- skränare..nn.1
  skränfock_1_N = mkN "skränfock" ; -- skränfock..nn.1
  skränig_1_A = mkA "skränig" ; -- skränig..av.1
  skränka_1_V = mkV "skränker" ; -- skränka..vb.1
  skränkande_1_N = mkN "skränkande" ; -- skränkande..nn.1
  skräp_1_N = mkN "skräp" neutrum  ; -- skräp..nn.1
  skräpa_1_V = mkV "skräpar" ; -- skräpa..vb.1
  skräpande_1_N = mkN "skräpande" ; -- skräpande..nn.1
  skräpbot_1_N = mkN "skräpbot" "skräpböter" ; -- skräpbot..nn.1
  skräphög_1_N = mkN "skräphög" ; -- skräphög..nn.1
  skräpig_1_A = mkA "skräpig" ; -- skräpig..av.1
  skräpighet_1_N = mkN "skräpighet" ; -- skräpighet..nn.1
  skräpkammare_1_N = mkN "skräpkammare" "skräpkammaren" "skräpkammare" "skräpkamrarna" ; -- skräpkammare..nn.1
  skräpkorg_1_N = mkN "skräpkorg" ; -- skräpkorg..nn.1
  skräpkultur_1_N = mkN "skräpkultur" "skräpkulturer" ; -- skräpkultur..nn.1
  skräpmat_1_N = mkN "skräpmat" ; -- skräpmat..nn.1
  skräppa_1_N = mkN "skräppa" ; -- skräppa..nn.1
  skräppa_1_V = mkV "skräpper" ; -- skräppa..vb.1
  skräppande_1_N = mkN "skräppande" ; -- skräppande..nn.1
  skräpplockning_1_N = mkN "skräpplockning" ; -- skräpplockning..nn.1
  skräpplockningsspjut_1_N = mkN "skräpplockningsspjut" neutrum  ; -- skräpplockningsspjut..nn.1
  skräppost_1_N = mkN "skräppost" ; -- skräppost..nn.1
  skräpprodukt_1_N = mkN "skräpprodukt" "skräpprodukter" ; -- skräpprodukt..nn.1
  skrävel_1_N = mkN "skrävel" neutrum  ; -- skrävel..nn.1
  skrävla_1_V = mkV "skrävlar" ; -- skrävla..vb.1
  skrävlande_1_N = mkN "skrävlande" ; -- skrävlande..nn.1
  skrävlare_1_N = mkN "skrävlare" utrum  ; -- skrävlare..nn.1
  skrävlig_1_A = mkA "skrävlig" ; -- skrävlig..av.1
  skrävlighet_1_N = mkN "skrävlighet" ; -- skrävlighet..nn.1
  skrå_1_A = mkA "skrå" "skrått" ; -- skrå..av.1
  skrå_1_N = mkN "skrå" "skrået" "skrån" "skråna" ; -- skrå..nn.1
  skråanda_1_N = mkN "skråanda" ; -- skråanda..nn.1
  skrål_1_N = mkN "skrål" neutrum  ; -- skrål..nn.1
  skråla_1_V = mkV "skrålar" ; -- skråla..vb.1
  skrålande_1_N = mkN "skrålande" ; -- skrålande..nn.1
  skråma_1_N = mkN "skråma" ; -- skråma..nn.1
  skråma_1_V = mkV "skråmar" ; -- skråma..vb.1
  skråmande_1_N = mkN "skråmande" ; -- skråmande..nn.1
  skråmig_1_A = mkA "skråmig" ; -- skråmig..av.1
  skråmässig_1_A = mkA "skråmässig" ; -- skråmässig..av.1
  skråmästare_1_N = mkN "skråmästare" utrum  ; -- skråmästare..nn.1
  skråordning_1_N = mkN "skråordning" ; -- skråordning..nn.1
  skråpuk_1_N = mkN "skråpuk" ; -- skråpuk..nn.1
  skråväsen_1_N = mkN "skråväsen" neutrum  ; -- skråväsen..nn.1
  skröna_1_N = mkN "skröna" ; -- skröna..nn.1
  skröplig_1_A = mkA "skröplig" ; -- skröplig..av.1
  skröplighet_1_N = mkN "skröplighet" "skröpligheter" ; -- skröplighet..nn.1
  skubb_1_N = mkN "skubb" neutrum  ; -- skubb..nn.1
  skubba_1_V = mkV "skubbar" ; -- skubba..vb.1
  skubbande_1_N = mkN "skubbande" ; -- skubbande..nn.1
  skubbning_1_N = mkN "skubbning" ; -- skubbning..nn.1
  skudda_1_V = mkV "skuddar" ; -- skudda..vb.1
  skuddande_1_N = mkN "skuddande" ; -- skuddande..nn.1
  skuff_1_N = mkN "skuff" ; -- skuff..nn.1
  skuffa_1_V = mkV "skuffar" ; -- skuffa..vb.1
  skuffande_1_N = mkN "skuffande" ; -- skuffande..nn.1
  skuffert_1_N = mkN "skuffert" ; -- skuffert..nn.1
  skugga_1_N = mkN "skugga" ; -- skugga..nn.1
  skugga_1_V = mkV "skuggar" ; -- skugga..vb.1
  skuggande_1_N = mkN "skuggande" ; -- skuggande..nn.1
  skuggbild_1_N = mkN "skuggbild" "skuggbilder" ; -- skuggbild..nn.1
  skuggboxa_1_V = mkV "skuggboxar" ; -- skuggboxa..vb.1
  skuggboxande_1_N = mkN "skuggboxande" ; -- skuggboxande..nn.1
  skuggboxning_1_N = mkN "skuggboxning" ; -- skuggboxning..nn.1
  skuggbudget_1_N = mkN "skuggbudget" ; -- skuggbudget..nn.1
  skuggföredragande_1_A = mkA "skuggföredragande" ; -- skuggföredragande..av.1
  skuggig_1_A = mkA "skuggig" ; -- skuggig..av.1
  skuggighet_1_N = mkN "skuggighet" ; -- skuggighet..nn.1
  skuggindustri_1_N = mkN "skuggindustri" "skuggindustrier" ; -- skuggindustri..nn.1
  skuggkabinett_1_N = mkN "skuggkabinett" neutrum  ; -- skuggkabinett..nn.1
  skugglik_1_A = mkA "skugglik" ; -- skugglik..av.1
  skugglös_1_A = mkA "skugglös" ; -- skugglös..av.1
  skugglöshet_1_N = mkN "skugglöshet" ; -- skugglöshet..nn.1
  skugglösning_1_N = mkN "skugglösning" ; -- skugglösning..nn.1
  skuggning_1_N = mkN "skuggning" ; -- skuggning..nn.1
  skuggregering_1_N = mkN "skuggregering" ; -- skuggregering..nn.1
  skuggrik_1_A = mkA "skuggrik" ; -- skuggrik..av.1
  skuggrikhet_1_N = mkN "skuggrikhet" ; -- skuggrikhet..nn.1
  skuggsida_1_N = mkN "skuggsida" ; -- skuggsida..nn.1
  skuggspelsteater_1_N = mkN "skuggspelsteater" ; -- skuggspelsteater..nn.1
  skuld_1_N = mkN "skuld" "skulder" ; -- skuld..nn.1
  skuldavskrivning_1_N = mkN "skuldavskrivning" ; -- skuldavskrivning..nn.1
  skuldbelastad_1_A = mkA "skuldbelastad" ; -- skuldbelastad..av.1
  skuldbelopp_1_N = mkN "skuldbelopp" neutrum  ; -- skuldbelopp..nn.1
  skuldbelägga_1_V = mkV "skuldbelägga" "skuldbela" "skuldbelagt" ; -- skuldbelägga..vb.1
  skuldbeläggande_1_N = mkN "skuldbeläggande" ; -- skuldbeläggande..nn.1
  skuldbeläggelse_1_N = mkN "skuldbeläggelse" "skuldbeläggelser" ; -- skuldbeläggelse..nn.1
  skuldbeläggning_1_N = mkN "skuldbeläggning" ; -- skuldbeläggning..nn.1
  skuldberg_1_N = mkN "skuldberg" neutrum  ; -- skuldberg..nn.1
  skuldbörda_1_N = mkN "skuldbörda" ; -- skuldbörda..nn.1
  skuldderivat_1_N = mkN "skuldderivat" neutrum  ; -- skuldderivat..nn.1
  skuldebrev_1_N = mkN "skuldebrev" neutrum  ; -- skuldebrev..nn.1
  skulderblad_1_N = mkN "skulderblad" neutrum  ; -- skulderblad..nn.1
  skuldergördel_1_N = mkN "skuldergördel" ; -- skuldergördel..nn.1
  skulderled_1_N = mkN "skulderled" "skulderleder" ; -- skulderled..nn.1
  skuldfri_1_A = mkA "skuldfri" "skuldfritt" ; -- skuldfri..av.1
  skuldfrihet_1_N = mkN "skuldfrihet" ; -- skuldfrihet..nn.1
  skuldfälla_1_N = mkN "skuldfälla" ; -- skuldfälla..nn.1
  skuldförbindelse_1_N = mkN "skuldförbindelse" "skuldförbindelser" ; -- skuldförbindelse..nn.1
  skuldkris_1_N = mkN "skuldkris" "skuldkriser" ; -- skuldkris..nn.1
  skuldkänsla_1_N = mkN "skuldkänsla" ; -- skuldkänsla..nn.1
  skuldlös_1_A = mkA "skuldlös" ; -- skuldlös..av.1
  skuldlöshet_1_N = mkN "skuldlöshet" ; -- skuldlöshet..nn.1
  skuldmedvetande_1_N = mkN "skuldmedvetande" ; -- skuldmedvetande..nn.1
  skuldmedveten_1_A = mkA "skuldmedveten" ; -- skuldmedveten..av.1
  skuldmedvetenhet_1_N = mkN "skuldmedvetenhet" ; -- skuldmedvetenhet..nn.1
  skuldnedskrivning_1_N = mkN "skuldnedskrivning" ; -- skuldnedskrivning..nn.1
  skuldpåtagande_1_N = mkN "skuldpåtagande" ; -- skuldpåtagande..nn.1
  skuldra_1_N = mkN "skuldra" ; -- skuldra..nn.1
  skuldränta_1_N = mkN "skuldränta" ; -- skuldränta..nn.1
  skuldsanera_1_V = mkV "skuldsanerar" ; -- skuldsanera..vb.1
  skuldsanerande_1_N = mkN "skuldsanerande" ; -- skuldsanerande..nn.1
  skuldsanering_1_N = mkN "skuldsanering" ; -- skuldsanering..nn.1
  skuldsatt_1_A = mkA "skuldsatt" ; -- skuldsatt..av.1
  skuldsatthet_1_N = mkN "skuldsatthet" ; -- skuldsatthet..nn.1
  skuldsedel_1_N = mkN "skuldsedel" ; -- skuldsedel..nn.1
  skuldslav_1_N = mkN "skuldslav" ; -- skuldslav..nn.1
  skuldslaveri_1_N = mkN "skuldslaveri" neutrum  ; -- skuldslaveri..nn.1
  skuldsumma_1_N = mkN "skuldsumma" ; -- skuldsumma..nn.1
  skuldsätta_1_V = mkV "skuldsätta" "skuldsätter" "skuldsätt" "skuldsatte" "skuldsatt" "skuldsatt" ; -- skuldsätta..vb.1
  skuldsättande_1_N = mkN "skuldsättande" ; -- skuldsättande..nn.1
  skuldsättning_1_N = mkN "skuldsättning" ; -- skuldsättning..nn.1
  skuldtak_1_N = mkN "skuldtak" neutrum  ; -- skuldtak..nn.1
  skuldtyngd_1_A = mkA "skuldtyngd" "skuldtyngt" ; -- skuldtyngd..av.1
  skuldtyngdhet_1_N = mkN "skuldtyngdhet" ; -- skuldtyngdhet..nn.1
  skulle_1_N = mkN "skulle" utrum  ; -- skulle..nn.1
  skulptera_1_V = mkV "skulpterar" ; -- skulptera..vb.1
  skulpterande_1_N = mkN "skulpterande" ; -- skulpterande..nn.1
  skulpterbar_1_A = mkA "skulpterbar" ; -- skulpterbar..av.1
  skulpterbarhet_1_N = mkN "skulpterbarhet" ; -- skulpterbarhet..nn.1
  skulptering_1_N = mkN "skulptering" ; -- skulptering..nn.1
  skulptris_1_N = mkN "skulptris" "skulptriser" ; -- skulptris..nn.1
  skulptur_1_N = mkN "skulptur" "skulpturer" ; -- skulptur..nn.1
  skulptural_1_A = mkA "skulptural" ; -- skulptural..av.1
  skulpturera_1_V = mkV "skulpturerar" ; -- skulpturera..vb.1
  skulpturerande_1_N = mkN "skulpturerande" ; -- skulpturerande..nn.1
  skulpturerbar_1_A = mkA "skulpturerbar" ; -- skulpturerbar..av.1
  skulpturerbarhet_1_N = mkN "skulpturerbarhet" ; -- skulpturerbarhet..nn.1
  skulpturering_1_N = mkN "skulpturering" ; -- skulpturering..nn.1
  skulpturgrupp_1_N = mkN "skulpturgrupp" "skulpturgrupper" ; -- skulpturgrupp..nn.1
  skulpturpark_1_N = mkN "skulpturpark" "skulpturparker" ; -- skulpturpark..nn.1
  skulptör_1_N = mkN "skulptör" "skulptörer" ; -- skulptör..nn.1
  skult_1_N = mkN "skult" ; -- skult..nn.1
  skum_1_A = mkA "skum" "skumt" "skumma" "skumma" "skummare" "skummast" "skummaste" ; -- skum..av.1
  skumbad_1_N = mkN "skumbad" neutrum  ; -- skumbad..nn.1
  skumbubbla_1_N = mkN "skumbubbla" ; -- skumbubbla..nn.1
  skumgummimadrass_1_N = mkN "skumgummimadrass" "skumgummimadrasser" ; -- skumgummimadrass..nn.1
  skumgummiracket_1_N = mkN "skumgummiracket" ; -- skumgummiracket..nn.1
  skumhet_1_N = mkN "skumhet" ; -- skumhet..nn.1
  skumhet_2_N = mkN "skumhet" "skumheter" ; -- skumhet..nn.2
  skumhjärta_1_N = mkN "skumhjärta" "skumhjärtat" "skumhjärtan" "skumhjärtana" ; -- skumhjärta..nn.1
  skumliknande_1_A = mkA "skumliknande" ; -- skumliknande..av.1
  skumma_1_V = mkV "skummar" ; -- skumma..vb.1
  skumma_2_V = mkV "skummar" ; -- skumma..vb.2
  skummande_1_N = mkN "skummande" ; -- skummande..nn.1
  skummig_1_A = mkA "skummig" ; -- skummig..av.1
  skummighet_1_N = mkN "skummighet" ; -- skummighet..nn.1
  skummis_1_N = mkN "skummis" ; -- skummis..nn.1
  skummjölk_1_N = mkN "skummjölk" ; -- skummjölk..nn.1
  skumning_1_N = mkN "skumning" ; -- skumning..nn.1
  skumpa_1_N = mkN "skumpa" ; -- skumpa..nn.1
  skumpa_1_V = mkV "skumpar" ; -- skumpa..vb.1
  skumpakork_1_N = mkN "skumpakork" ; -- skumpakork..nn.1
  skumpande_1_N = mkN "skumpande" ; -- skumpande..nn.1
  skumpig_1_A = mkA "skumpig" ; -- skumpig..av.1
  skumpighet_1_N = mkN "skumpighet" ; -- skumpighet..nn.1
  skumpiskad_1_A = mkA "skumpiskad" ; -- skumpiskad..av.1
  skumplast_1_N = mkN "skumplast" ; -- skumplast..nn.1
  skumplasttejp_1_N = mkN "skumplasttejp" ; -- skumplasttejp..nn.1
  skumpning_1_N = mkN "skumpning" ; -- skumpning..nn.1
  skumrask_1_N = mkN "skumrask" neutrum  ; -- skumrask..nn.1
  skumrask_2_N = mkN "skumrask" neutrum  ; -- skumrask..nn.2
  skumraskaffär_1_N = mkN "skumraskaffär" "skumraskaffärer" ; -- skumraskaffär..nn.1
  skumraskförehavande_1_N = mkN "skumraskförehavande" ; -- skumraskförehavande..nn.1
  skumsläckare_1_N = mkN "skumsläckare" utrum  ; -- skumsläckare..nn.1
  skumtvätt_1_N = mkN "skumtvätt" ; -- skumtvätt..nn.1
  skumtvätta_1_V = mkV "skumtvättar" ; -- skumtvätta..vb.1
  skumtvättande_1_N = mkN "skumtvättande" ; -- skumtvättande..nn.1
  skumtvättning_1_N = mkN "skumtvättning" ; -- skumtvättning..nn.1
  skumutrustning_1_N = mkN "skumutrustning" ; -- skumutrustning..nn.1
  skumögd_1_A = mkA "skumögd" "skumögt" ; -- skumögd..av.1
  skumögdhet_1_N = mkN "skumögdhet" ; -- skumögdhet..nn.1
  skunk_1_N = mkN "skunk" ; -- skunk..nn.1
  skunkdjur_1_N = mkN "skunkdjur" neutrum  ; -- skunkdjur..nn.1
  skunkig_1_A = mkA "skunkig" ; -- skunkig..av.1
  skunkighet_1_N = mkN "skunkighet" "skunkigheter" ; -- skunkighet..nn.1
  skur_1_N = mkN "skur" ; -- skur..nn.1
  skura_1_V = mkV "skurar" ; -- skura..vb.1
  skuramedel_1_N = mkN "skuramedel" neutrum  ; -- skuramedel..nn.1
  skurande_1_N = mkN "skurande" ; -- skurande..nn.1
  skurborste_1_N = mkN "skurborste" utrum  ; -- skurborste..nn.1
  skurduk_1_N = mkN "skurduk" ; -- skurduk..nn.1
  skurgolv_1_N = mkN "skurgolv" neutrum  ; -- skurgolv..nn.1
  skurgumma_1_N = mkN "skurgumma" ; -- skurgumma..nn.1
  skurhink_1_N = mkN "skurhink" ; -- skurhink..nn.1
  skurk_1_N = mkN "skurk" ; -- skurk..nn.1
  skurkaktig_1_A = mkA "skurkaktig" ; -- skurkaktig..av.1
  skurkaktighet_1_N = mkN "skurkaktighet" "skurkaktigheter" ; -- skurkaktighet..nn.1
  skurkansikte_1_N = mkN "skurkansikte" ; -- skurkansikte..nn.1
  skurknä_1_N = mkN "skurknä" "skurknät" "skurknän" "skurknäna" ; -- skurknä..nn.1
  skurkregim_1_N = mkN "skurkregim" "skurkregimer" ; -- skurkregim..nn.1
  skurkstat_1_N = mkN "skurkstat" "skurkstater" ; -- skurkstat..nn.1
  skurkstreck_1_N = mkN "skurkstreck" neutrum  ; -- skurkstreck..nn.1
  skurlov_1_N = mkN "skurlov" neutrum  ; -- skurlov..nn.1
  skurmedel_1_N = mkN "skurmedel" neutrum  ; -- skurmedel..nn.1
  skurning_1_N = mkN "skurning" ; -- skurning..nn.1
  skurpulver_1_N = mkN "skurpulver" neutrum  ; -- skurpulver..nn.1
  skurril_1_A = mkA "skurril" ; -- skurril..av.1
  skurtrasa_1_N = mkN "skurtrasa" ; -- skurtrasa..nn.1
  skuta_1_N = mkN "skuta" ; -- skuta..nn.1
  skutt_1_N = mkN "skutt" neutrum  ; -- skutt..nn.1
  skutta_1_V = mkV "skuttar" ; -- skutta..vb.1
  skuttande_1_N = mkN "skuttande" ; -- skuttande..nn.1
  skvader_1_N = mkN "skvader" ; -- skvader..nn.1
  skvadron_1_N = mkN "skvadron" "skvadroner" ; -- skvadron..nn.1
  skval_1_N = mkN "skval" neutrum  ; -- skval..nn.1
  skvala_1_V = mkV "skvalar" ; -- skvala..vb.1
  skvalande_1_N = mkN "skvalande" ; -- skvalande..nn.1
  skvalbank_1_N = mkN "skvalbank" ; -- skvalbank..nn.1
  skvaller_1_N = mkN "skvaller" neutrum  ; -- skvaller..nn.1
  skvalleraktig_1_A = mkA "skvalleraktig" ; -- skvalleraktig..av.1
  skvalleraktighet_1_N = mkN "skvalleraktighet" ; -- skvalleraktighet..nn.1
  skvallerblogg_1_N = mkN "skvallerblogg" ; -- skvallerblogg..nn.1
  skvallerbloggare_1_N = mkN "skvallerbloggare" utrum  ; -- skvallerbloggare..nn.1
  skvallerbytta_1_N = mkN "skvallerbytta" ; -- skvallerbytta..nn.1
  skvallerbär_1_N = mkN "skvallerbär" neutrum  ; -- skvallerbär..nn.1
  skvallerdrev_1_N = mkN "skvallerdrev" neutrum  ; -- skvallerdrev..nn.1
  skvallerhistoria_1_N = mkN "skvallerhistoria" "skvallerhistorian" "skvallerhistorier" "skvallerhistorierna" ; -- skvallerhistoria..nn.1
  skvallerkäring_1_N = mkN "skvallerkäring" ; -- skvallerkäring..nn.1
  skvallerkål_1_N = mkN "skvallerkål" ; -- skvallerkål..nn.1
  skvallermoster_1_N = mkN "skvallermoster" ; -- skvallermoster..nn.1
  skvallerpress_1_N = mkN "skvallerpress" ; -- skvallerpress..nn.1
  skvallersajt_1_N = mkN "skvallersajt" "skvallersajter" ; -- skvallersajt..nn.1
  skvallerspalt_1_N = mkN "skvallerspalt" "skvallerspalter" ; -- skvallerspalt..nn.1
  skvallerspegel_1_N = mkN "skvallerspegel" ; -- skvallerspegel..nn.1
  skvallertacka_1_N = mkN "skvallertacka" ; -- skvallertacka..nn.1
  skvallertant_1_N = mkN "skvallertant" "skvallertanter" ; -- skvallertant..nn.1
  skvallertaska_1_N = mkN "skvallertaska" ; -- skvallertaska..nn.1
  skvallra_1_V = mkV "skvallrar" ; -- skvallra..vb.1
  skvallrande_1_N = mkN "skvallrande" ; -- skvallrande..nn.1
  skvallrare_1_N = mkN "skvallrare" utrum  ; -- skvallrare..nn.1
  skvallrig_1_A = mkA "skvallrig" ; -- skvallrig..av.1
  skvallrighet_1_N = mkN "skvallrighet" ; -- skvallrighet..nn.1
  skvalmusik_1_N = mkN "skvalmusik" ; -- skvalmusik..nn.1
  skvalp_1_N = mkN "skvalp" neutrum  ; -- skvalp..nn.1
  skvalpa_1_V = mkV "skvalpar" ; -- skvalpa..vb.1
  skvalpande_1_N = mkN "skvalpande" ; -- skvalpande..nn.1
  skvalpig_1_A = mkA "skvalpig" ; -- skvalpig..av.1
  skvalpighet_1_N = mkN "skvalpighet" ; -- skvalpighet..nn.1
  skvalradio_1_N = mkN "skvalradio" ; -- skvalradio..nn.1
  skvalta_1_N = mkN "skvalta" ; -- skvalta..nn.1
  skvalta_1_V = mkV "skvaltar" ; -- skvalta..vb.1
  skvaltande_1_N = mkN "skvaltande" ; -- skvaltande..nn.1
  skvaltkvarn_1_N = mkN "skvaltkvarn" ; -- skvaltkvarn..nn.1
  skvaltorre_1_N = mkN "skvaltorre" utrum  ; -- skvaltorre..nn.1
  skvattram_1_N = mkN "skvattram" ; -- skvattram..nn.1
  skvimpa_1_V = mkV "skvimpar" ; -- skvimpa..vb.1
  skvimpande_1_N = mkN "skvimpande" ; -- skvimpande..nn.1
  skvis_1_N = mkN "skvis" ; -- skvis..nn.1
  skvisa_1_V = mkV "skvisar" ; -- skvisa..vb.1
  skvisande_1_N = mkN "skvisande" ; -- skvisande..nn.1
  skvätt_1_N = mkN "skvätt" ; -- skvätt..nn.1
  skvätta_1_N = mkN "skvätta" ; -- skvätta..nn.1
  skvätta_1_V = mkV "skvätta" "skvätter" "skvätt" "skvätte" "skvätt" "skvättad" ; -- skvätta..vb.1
  skvätta_2_V = mkV "skvätta" "skvätter" "skvätt" "skvätte" "skvätt" "skvätt" ; -- skvätta..vb.2
  skvättande_1_N = mkN "skvättande" ; -- skvättande..nn.1
  skvättvis_1_Adv = mkAdv "skvättvis" ; -- skvättvis..ab.1
  sky_1_N = mkN "sky" "skyn" "skyar" "skyarna" ; -- sky..nn.1
  sky_1_V = mkV "skyr" ; -- sky..vb.1
  skya_1_V = mkV "skyar" ; -- skya..vb.1
  skyande_1_N = mkN "skyande" ; -- skyande..nn.1
  skydd_1_A = mkA "skydd" ; -- skydd..av.1
  skydd_1_N = mkN "skydd" neutrum  ; -- skydd..nn.1
  skydda_1_V = mkV "skyddar" ; -- skydda..vb.1
  skyddande_1_N = mkN "skyddande" ; -- skyddande..nn.1
  skyddare_1_N = mkN "skyddare" utrum  ; -- skyddare..nn.1
  skyddsande_1_N = mkN "skyddsande" utrum  ; -- skyddsande..nn.1
  skyddsbehövande_1_A = mkA "skyddsbehövande" ; -- skyddsbehövande..av.1
  skyddsdräkt_1_N = mkN "skyddsdräkt" "skyddsdräkter" ; -- skyddsdräkt..nn.1
  skyddsduk_1_N = mkN "skyddsduk" ; -- skyddsduk..nn.1
  skyddsfärg_1_N = mkN "skyddsfärg" "skyddsfärger" ; -- skyddsfärg..nn.1
  skyddsgrav_1_N = mkN "skyddsgrav" ; -- skyddsgrav..nn.1
  skyddsgud_1_N = mkN "skyddsgud" ; -- skyddsgud..nn.1
  skyddshelgon_1_N = mkN "skyddshelgon" neutrum  ; -- skyddshelgon..nn.1
  skyddshem_1_N = mkN "skyddshem" "skyddshemmet" "skyddshem" "skyddshemmen" ; -- skyddshem..nn.1
  skyddshölje_1_N = mkN "skyddshölje" ; -- skyddshölje..nn.1
  skyddsimpregnera_1_V = mkV "skyddsimpregnerar" ; -- skyddsimpregnera..vb.1
  skyddsimpregnerande_1_N = mkN "skyddsimpregnerande" ; -- skyddsimpregnerande..nn.1
  skyddsimpregnerbar_1_A = mkA "skyddsimpregnerbar" ; -- skyddsimpregnerbar..av.1
  skyddsimpregnerbarhet_1_N = mkN "skyddsimpregnerbarhet" ; -- skyddsimpregnerbarhet..nn.1
  skyddsimpregnering_1_N = mkN "skyddsimpregnering" ; -- skyddsimpregnering..nn.1
  skyddskonsulent_1_N = mkN "skyddskonsulent" "skyddskonsulenter" ; -- skyddskonsulent..nn.1
  skyddskropp_1_N = mkN "skyddskropp" ; -- skyddskropp..nn.1
  skyddskår_1_N = mkN "skyddskår" "skyddskårer" ; -- skyddskår..nn.1
  skyddsling_1_N = mkN "skyddsling" ; -- skyddsling..nn.1
  skyddslock_1_N = mkN "skyddslock" neutrum  ; -- skyddslock..nn.1
  skyddslös_1_A = mkA "skyddslös" ; -- skyddslös..av.1
  skyddslöshet_1_N = mkN "skyddslöshet" ; -- skyddslöshet..nn.1
  skyddsmask_1_N = mkN "skyddsmask" "skyddsmasker" ; -- skyddsmask..nn.1
  skyddsmedel_1_N = mkN "skyddsmedel" neutrum  ; -- skyddsmedel..nn.1
  skyddsmekanism_1_N = mkN "skyddsmekanism" "skyddsmekanismer" ; -- skyddsmekanism..nn.1
  skyddsmur_1_N = mkN "skyddsmur" ; -- skyddsmur..nn.1
  skyddsnät_1_N = mkN "skyddsnät" neutrum  ; -- skyddsnät..nn.1
  skyddsoblat_1_N = mkN "skyddsoblat" "skyddsoblater" ; -- skyddsoblat..nn.1
  skyddsombud_1_N = mkN "skyddsombud" neutrum  ; -- skyddsombud..nn.1
  skyddsområde_1_N = mkN "skyddsområde" ; -- skyddsområde..nn.1
  skyddspapper_1_N = mkN "skyddspapper" neutrum  ; -- skyddspapper..nn.1
  skyddspatron_1_N = mkN "skyddspatron" "skyddspatroner" ; -- skyddspatron..nn.1
  skyddsrock_1_N = mkN "skyddsrock" ; -- skyddsrock..nn.1
  skyddsrum_1_N = mkN "skyddsrum" "skyddsrummet" "skyddsrum" "skyddsrummen" ; -- skyddsrum..nn.1
  skyddsslang_1_N = mkN "skyddsslang" ; -- skyddsslang..nn.1
  skyddsstat_1_N = mkN "skyddsstat" "skyddsstater" ; -- skyddsstat..nn.1
  skyddsstopp_1_N = mkN "skyddsstopp" neutrum  ; -- skyddsstopp..nn.1
  skyddstak_1_N = mkN "skyddstak" neutrum  ; -- skyddstak..nn.1
  skyddstillsyn_1_N = mkN "skyddstillsyn" ; -- skyddstillsyn..nn.1
  skyddstjänst_1_N = mkN "skyddstjänst" ; -- skyddstjänst..nn.1
  skyddstull_1_N = mkN "skyddstull" ; -- skyddstull..nn.1
  skyddsvakt_1_N = mkN "skyddsvakt" "skyddsvakter" ; -- skyddsvakt..nn.1
  skyddsvall_1_N = mkN "skyddsvall" ; -- skyddsvall..nn.1
  skyddsvärd_1_A = mkA "skyddsvärd" "skyddsvärt" ; -- skyddsvärd..av.1
  skyddsvärn_1_N = mkN "skyddsvärn" neutrum  ; -- skyddsvärn..nn.1
  skyddsympa_1_V = mkV "skyddsympar" ; -- skyddsympa..vb.1
  skyddsympande_1_N = mkN "skyddsympande" ; -- skyddsympande..nn.1
  skyddsängel_1_N = mkN "skyddsängel" ; -- skyddsängel..nn.1
  skyddsåtgärd_1_N = mkN "skyddsåtgärd" "skyddsåtgärder" ; -- skyddsåtgärd..nn.1
  skyddsöverdrag_1_N = mkN "skyddsöverdrag" neutrum  ; -- skyddsöverdrag..nn.1
  skydrag_1_N = mkN "skydrag" neutrum  ; -- skydrag..nn.1
  skyende_1_N = mkN "skyende" ; -- skyende..nn.1
  skyeterrier_1_N = mkN "skyeterrier" "skyeterriern" "skyeterrier" "skyeterrierna" ; -- skyeterrier..nn.1
  skyfall_1_N = mkN "skyfall" neutrum  ; -- skyfall..nn.1
  skyffel_1_N = mkN "skyffel" ; -- skyffel..nn.1
  skyffla_1_V = mkV "skyfflar" ; -- skyffla..vb.1
  skyfflande_1_N = mkN "skyfflande" ; -- skyfflande..nn.1
  skygd_1_N = mkN "skygd" neutrum  ; -- skygd..nn.1
  skygg_1_A = mkA "skygg" ; -- skygg..av.1
  skygga_1_V = mkV "skyggar" ; -- skygga..vb.1
  skyggande_1_N = mkN "skyggande" ; -- skyggande..nn.1
  skygge_1_N = mkN "skygge" ; -- skygge..nn.1
  skygghet_1_N = mkN "skygghet" ; -- skygghet..nn.1
  skygglapp_1_N = mkN "skygglapp" ; -- skygglapp..nn.1
  skyhög_1_A = mkA "skyhög" ; -- skyhög..av.1
  skyig_1_A = mkA "skyig" ; -- skyig..av.1
  skyighet_1_N = mkN "skyighet" ; -- skyighet..nn.1
  skyl_1_N = mkN "skyl" ; -- skyl..nn.1
  skyla_1_V = mkV "skyler" ; -- skyla..vb.1
  skyla_2_V = mkV "skylar" ; -- skyla..vb.2
  skylande_1_N = mkN "skylande" ; -- skylande..nn.1
  skyld_1_A = mkA "skyld" "skylt" ; -- skyld..av.1
  skyldig_1_A = mkA "skyldig" ; -- skyldig..av.1
  skyldighet_1_N = mkN "skyldighet" "skyldigheter" ; -- skyldighet..nn.1
  skyldra_1_V = mkV "skyldrar" ; -- skyldra..vb.1
  skyldrande_1_N = mkN "skyldrande" ; -- skyldrande..nn.1
  skylight_1_N = mkN "skylight" neutrum  ; -- skylight..nn.1
  skylla_1_V = mkV "skyller" ; -- skylla..vb.1
  skyllande_1_N = mkN "skyllande" ; -- skyllande..nn.1
  skyllerkur_1_N = mkN "skyllerkur" ; -- skyllerkur..nn.1
  skylt_1_N = mkN "skylt" ; -- skylt..nn.1
  skylta_1_V = mkV "skyltar" ; -- skylta..vb.1
  skyltande_1_N = mkN "skyltande" ; -- skyltande..nn.1
  skyltdocka_1_N = mkN "skyltdocka" ; -- skyltdocka..nn.1
  skyltdockekropp_1_N = mkN "skyltdockekropp" ; -- skyltdockekropp..nn.1
  skyltfönster_1_N = mkN "skyltfönster" neutrum  ; -- skyltfönster..nn.1
  skyltlåda_1_N = mkN "skyltlåda" ; -- skyltlåda..nn.1
  skyltning_1_N = mkN "skyltning" ; -- skyltning..nn.1
  skyltskåp_1_N = mkN "skyltskåp" neutrum  ; -- skyltskåp..nn.1
  skyltsöndag_1_N = mkN "skyltsöndag" ; -- skyltsöndag..nn.1
  skylttjuv_1_N = mkN "skylttjuv" ; -- skylttjuv..nn.1
  skymf_1_N = mkN "skymf" "skymfer" ; -- skymf..nn.1
  skymfa_1_V = mkV "skymfar" ; -- skymfa..vb.1
  skymfande_1_N = mkN "skymfande" ; -- skymfande..nn.1
  skymflig_1_A = mkA "skymflig" ; -- skymflig..av.1
  skymfligen_1_Adv = mkAdv "skymfligen" ; -- skymfligen..ab.1
  skymflighet_1_N = mkN "skymflighet" ; -- skymflighet..nn.1
  skymford_1_N = mkN "skymford" neutrum  ; -- skymford..nn.1
  skymla_1_V = mkV "skymlar" ; -- skymla..vb.1
  skymlande_1_N = mkN "skymlande" ; -- skymlande..nn.1
  skymma_1_V = mkV "skymmer" ; -- skymma..vb.1
  skymmande_1_N = mkN "skymmande" ; -- skymmande..nn.1
  skymmel_1_N = mkN "skymmel" neutrum  ; -- skymmel..nn.1
  skymmel_2_N = mkN "skymmel" "skymmeln" "skymmlar" "skymmlarna" ; -- skymmel..nn.2
  skymning_1_N = mkN "skymning" ; -- skymning..nn.1
  skymningsdunkel_1_N = mkN "skymningsdunkel" neutrum  ; -- skymningsdunkel..nn.1
  skymningsland_1_N = mkN "skymningsland" neutrum  ; -- skymningsland..nn.1
  skymningslandskap_1_N = mkN "skymningslandskap" neutrum  ; -- skymningslandskap..nn.1
  skymt_1_N = mkN "skymt" ; -- skymt..nn.1
  skymta_1_V = mkV "skymtar" ; -- skymta..vb.1
  skymtande_1_N = mkN "skymtande" ; -- skymtande..nn.1
  skynda_1_V = mkV "skyndar" ; -- skynda..vb.1
  skyndande_1_N = mkN "skyndande" ; -- skyndande..nn.1
  skyndsam_1_A = mkA "skyndsam" "skyndsamt" "skyndsamma" "skyndsamma" "skyndsammare" "skyndsammast" "skyndsammaste" ; -- skyndsam..av.1
  skyndsamhet_1_N = mkN "skyndsamhet" ; -- skyndsamhet..nn.1
  skynke_1_N = mkN "skynke" ; -- skynke..nn.1
  skypa_1_V = mkV "skypar" ; -- skypa..vb.1
  skypande_1_N = mkN "skypande" ; -- skypande..nn.1
  skypea_1_V = mkV "skypear" ; -- skypea..vb.1
  skypeande_1_N = mkN "skypeande" ; -- skypeande..nn.1
  skypening_1_N = mkN "skypening" ; -- skypening..nn.1
  skypning_1_N = mkN "skypning" ; -- skypning..nn.1
  skyskrapa_1_N = mkN "skyskrapa" ; -- skyskrapa..nn.1
  skyt_1_N = mkN "skyt" "skyter" ; -- skyt..nn.1
  skytisk_1_A = mkA "skytisk" ; -- skytisk..av.1
  skytt_1_N = mkN "skytt" ; -- skytt..nn.1
  skytte_1_N = mkN "skytte" ; -- skytte..nn.1
  skyttebrigad_1_N = mkN "skyttebrigad" "skyttebrigader" ; -- skyttebrigad..nn.1
  skyttedrottning_1_N = mkN "skyttedrottning" ; -- skyttedrottning..nn.1
  skyttegrav_1_N = mkN "skyttegrav" ; -- skyttegrav..nn.1
  skyttegravskant_1_N = mkN "skyttegravskant" "skyttegravskanter" ; -- skyttegravskant..nn.1
  skyttegravskrig_1_N = mkN "skyttegravskrig" neutrum  ; -- skyttegravskrig..nn.1
  skyttegrop_1_N = mkN "skyttegrop" ; -- skyttegrop..nn.1
  skyttegrupp_1_N = mkN "skyttegrupp" "skyttegrupper" ; -- skyttegrupp..nn.1
  skyttegång_1_N = mkN "skyttegång" ; -- skyttegång..nn.1
  skyttekung_1_N = mkN "skyttekung" ; -- skyttekung..nn.1
  skyttel_1_N = mkN "skyttel" ; -- skyttel..nn.1
  skytteliga_1_N = mkN "skytteliga" ; -- skytteliga..nn.1
  skyttelinje_1_N = mkN "skyttelinje" "skyttelinjer" ; -- skyttelinje..nn.1
  skytteltrafik_1_N = mkN "skytteltrafik" ; -- skytteltrafik..nn.1
  skyttepaviljong_1_N = mkN "skyttepaviljong" "skyttepaviljonger" ; -- skyttepaviljong..nn.1
  skyttesalong_1_N = mkN "skyttesalong" "skyttesalonger" ; -- skyttesalong..nn.1
  skytteskälva_1_N = mkN "skytteskälva" ; -- skytteskälva..nn.1
  skyttetävling_1_N = mkN "skyttetävling" ; -- skyttetävling..nn.1
  skyttevärn_1_N = mkN "skyttevärn" neutrum  ; -- skyttevärn..nn.1
  skäck_1_N = mkN "skäck" ; -- skäck..nn.1
  skäckig_1_A = mkA "skäckig" ; -- skäckig..av.1
  skäckighet_1_N = mkN "skäckighet" ; -- skäckighet..nn.1
  skädda_1_N = mkN "skädda" ; -- skädda..nn.1
  skäfta_1_V = mkV "skäftar" ; -- skäfta..vb.1
  skäftande_1_N = mkN "skäftande" ; -- skäftande..nn.1
  skäftig_1_A = mkA "skäftig" ; -- skäftig..av.1
  skäftighet_1_N = mkN "skäftighet" ; -- skäftighet..nn.1
  skägg_1_N = mkN "skägg" neutrum  ; -- skägg..nn.1
  skägga_1_V = mkV "skäggar" ; -- skägga..vb.1
  skäggande_1_N = mkN "skäggande" ; -- skäggande..nn.1
  skäggbotten_1_N = mkN "skäggbotten" ; -- skäggbotten..nn.1
  skäggdopping_1_N = mkN "skäggdopping" ; -- skäggdopping..nn.1
  skäggig_1_A = mkA "skäggig" ; -- skäggig..av.1
  skäggighet_1_N = mkN "skäggighet" ; -- skäggighet..nn.1
  skägglapp_1_N = mkN "skägglapp" ; -- skägglapp..nn.1
  skägglav_1_N = mkN "skägglav" ; -- skägglav..nn.1
  skägglös_1_A = mkA "skägglös" ; -- skägglös..av.1
  skägglöshet_1_N = mkN "skägglöshet" ; -- skägglöshet..nn.1
  skäggmunsmal_1_N = mkN "skäggmunsmal" ; -- skäggmunsmal..nn.1
  skäggstrå_1_N = mkN "skäggstrå" "skäggstråt" "skäggstrån" "skäggstråna" ; -- skäggstrå..nn.1
  skäggstubb_1_N = mkN "skäggstubb" ; -- skäggstubb..nn.1
  skäggsvamp_1_N = mkN "skäggsvamp" ; -- skäggsvamp..nn.1
  skäggtöm_1_N = mkN "skäggtöm" "skäggtömmen" "skäggtömmar" "skäggtömmarna" ; -- skäggtöm..nn.1
  skäggvårta_1_N = mkN "skäggvårta" ; -- skäggvårta..nn.1
  skäkt_1_N = mkN "skäkt" ; -- skäkt..nn.1
  skäkta_1_N = mkN "skäkta" ; -- skäkta..nn.1
  skäkta_1_V = mkV "skäktar" ; -- skäkta..vb.1
  skäktande_1_N = mkN "skäktande" ; -- skäktande..nn.1
  skäkteträ_1_N = mkN "skäkteträ" "skäkteträt" "skäkteträn" "skäkteträna" ; -- skäkteträ..nn.1
  skäktkniv_1_N = mkN "skäktkniv" ; -- skäktkniv..nn.1
  skäktstol_1_N = mkN "skäktstol" ; -- skäktstol..nn.1
  skäktträ_1_N = mkN "skäktträ" "skäktträt" "skäktträn" "skäktträna" ; -- skäktträ..nn.1
  skäl_1_N = mkN "skäl" neutrum  ; -- skäl..nn.1
  skälig_1_A = mkA "skälig" ; -- skälig..av.1
  skäligen_1_Adv = mkAdv "skäligen" ; -- skäligen..ab.1
  skälighet_1_N = mkN "skälighet" ; -- skälighet..nn.1
  skäll_1_A = mkA "skäll" ; -- skäll..av.1
  skäll_1_N = mkN "skäll" neutrum  ; -- skäll..nn.1
  skälla_1_N = mkN "skälla" ; -- skälla..nn.1
  skälla_1_V = mkV "skäller" ; -- skälla..vb.1
  skällande_1_N = mkN "skällande" ; -- skällande..nn.1
  skällig_1_A = mkA "skällig" ; -- skällig..av.1
  skällko_1_N = mkN "skällko" "skällkor" ; -- skällko..nn.1
  skällning_1_N = mkN "skällning" ; -- skällning..nn.1
  skällsord_1_N = mkN "skällsord" neutrum  ; -- skällsord..nn.1
  skälm_1_N = mkN "skälm" ; -- skälm..nn.1
  skälmaktig_1_A = mkA "skälmaktig" ; -- skälmaktig..av.1
  skälmaktighet_1_N = mkN "skälmaktighet" ; -- skälmaktighet..nn.1
  skälmroman_1_N = mkN "skälmroman" "skälmromaner" ; -- skälmroman..nn.1
  skälmsk_1_A = mkA "skälmsk" ; -- skälmsk..av.1
  skälmskhet_1_N = mkN "skälmskhet" ; -- skälmskhet..nn.1
  skälmstycke_1_N = mkN "skälmstycke" ; -- skälmstycke..nn.1
  skälva_1_N = mkN "skälva" ; -- skälva..nn.1
  skälva_1_V = mkV "skälva" "skälvde" "skälv" ; -- skälva..vb.1
  skälvande_1_N = mkN "skälvande" ; -- skälvande..nn.1
  skälvesot_1_N = mkN "skälvesot" ; -- skälvesot..nn.1
  skälvning_1_N = mkN "skälvning" ; -- skälvning..nn.1
  skälvosot_1_N = mkN "skälvosot" ; -- skälvosot..nn.1
  skämd_1_A = mkA "skämd" "skämt" ; -- skämd..av.1
  skämdhet_1_N = mkN "skämdhet" ; -- skämdhet..nn.1
  skämma_1_V = mkV "skämmer" ; -- skämma..vb.1
  skämmande_1_N = mkN "skämmande" ; -- skämmande..nn.1
  skämmig_1_A = mkA "skämmig" ; -- skämmig..av.1
  skämmighet_1_N = mkN "skämmighet" ; -- skämmighet..nn.1
  skämt_1_N = mkN "skämt" neutrum  ; -- skämt..nn.1
  skämta_1_V = mkV "skämtar" ; -- skämta..vb.1
  skämtande_1_N = mkN "skämtande" ; -- skämtande..nn.1
  skämtare_1_N = mkN "skämtare" utrum  ; -- skämtare..nn.1
  skämtlynne_1_N = mkN "skämtlynne" ; -- skämtlynne..nn.1
  skämtsam_1_A = mkA "skämtsam" "skämtsamt" "skämtsamma" "skämtsamma" "skämtsammare" "skämtsammast" "skämtsammaste" ; -- skämtsam..av.1
  skämtsamhet_1_N = mkN "skämtsamhet" "skämtsamheter" ; -- skämtsamhet..nn.1
  skämttecknare_1_N = mkN "skämttecknare" utrum  ; -- skämttecknare..nn.1
  skämtteckning_1_N = mkN "skämtteckning" ; -- skämtteckning..nn.1
  skända_1_V = mkV "skändar" ; -- skända..vb.1
  skändande_1_N = mkN "skändande" ; -- skändande..nn.1
  skändare_1_N = mkN "skändare" utrum  ; -- skändare..nn.1
  skändlig_1_A = mkA "skändlig" ; -- skändlig..av.1
  skändligen_1_Adv = mkAdv "skändligen" ; -- skändligen..ab.1
  skändlighet_1_N = mkN "skändlighet" "skändligheter" ; -- skändlighet..nn.1
  skändning_1_N = mkN "skändning" ; -- skändning..nn.1
  skänk_1_N = mkN "skänk" ; -- skänk..nn.1
  skänk_2_N = mkN "skänk" "skänker" ; -- skänk..nn.2
  skänka_1_V = mkV "skänker" ; -- skänka..vb.1
  skänkande_1_N = mkN "skänkande" ; -- skänkande..nn.1
  skänkel_1_N = mkN "skänkel" ; -- skänkel..nn.1
  skänkelhjälp_1_N = mkN "skänkelhjälp" ; -- skänkelhjälp..nn.1
  skänkla_1_V = mkV "skänklar" ; -- skänkla..vb.1
  skänklande_1_N = mkN "skänklande" ; -- skänklande..nn.1
  skäppa_1_N = mkN "skäppa" ; -- skäppa..nn.1
  skär_1_A = mkA "skär" ; -- skär..av.1
  skär_1_N = mkN "skär" neutrum  ; -- skär..nn.1
  skära_1_N = mkN "skära" ; -- skära..nn.1
  skära_1_V = mkV "skära" "skar" "skurit" ; -- skära..vb.1
  skära_2_V = mkV "skärar" ; -- skära..vb.2
  skärande_1_A = mkA "skärande" ; -- skärande..av.1
  skärande_1_N = mkN "skärande" ; -- skärande..nn.1
  skärbräda_1_N = mkN "skärbräda" ; -- skärbräda..nn.1
  skärbräde_1_N = mkN "skärbräde" ; -- skärbräde..nn.1
  skärbrännare_1_N = mkN "skärbrännare" utrum  ; -- skärbrännare..nn.1
  skärböna_1_N = mkN "skärböna" ; -- skärböna..nn.1
  skäregg_1_N = mkN "skäregg" ; -- skäregg..nn.1
  skärfläcka_1_N = mkN "skärfläcka" ; -- skärfläcka..nn.1
  skärgård_1_N = mkN "skärgård" ; -- skärgård..nn.1
  skärgårdsbo_1_N = mkN "skärgårdsbo" "skärgårdsbor" ; -- skärgårdsbo..nn.1
  skärgårdsis_1_N = mkN "skärgårdsis" ; -- skärgårdsis..nn.1
  skärgårdskryssare_1_N = mkN "skärgårdskryssare" utrum  ; -- skärgårdskryssare..nn.1
  skärgårdsturist_1_N = mkN "skärgårdsturist" "skärgårdsturister" ; -- skärgårdsturist..nn.1
  skärgårdsö_1_N = mkN "skärgårdsö" ; -- skärgårdsö..nn.1
  skärhet_1_N = mkN "skärhet" ; -- skärhet..nn.1
  skärhållfasthet_1_N = mkN "skärhållfasthet" "skärhållfastheter" ; -- skärhållfasthet..nn.1
  skärkapacitet_1_N = mkN "skärkapacitet" ; -- skärkapacitet..nn.1
  skärkarl_1_N = mkN "skärkarl" ; -- skärkarl..nn.1
  skärkniv_1_N = mkN "skärkniv" ; -- skärkniv..nn.1
  skärlåda_1_N = mkN "skärlåda" ; -- skärlåda..nn.1
  skärm_1_N = mkN "skärm" ; -- skärm..nn.1
  skärmbild_1_N = mkN "skärmbild" "skärmbilder" ; -- skärmbild..nn.1
  skärmbilda_1_V = mkV "skärmbildar" ; -- skärmbilda..vb.1
  skärmbildande_1_N = mkN "skärmbildande" ; -- skärmbildande..nn.1
  skärmbildsundersökning_1_N = mkN "skärmbildsundersökning" ; -- skärmbildsundersökning..nn.1
  skärmdump_1_N = mkN "skärmdump" ; -- skärmdump..nn.1
  skärmmössa_1_N = mkN "skärmmössa" ; -- skärmmössa..nn.1
  skärmsläckare_1_N = mkN "skärmsläckare" utrum  ; -- skärmsläckare..nn.1
  skärmytsel_1_N = mkN "skärmytsel" ; -- skärmytsel..nn.1
  skärmytsling_1_N = mkN "skärmytsling" ; -- skärmytsling..nn.1
  skärning_1_N = mkN "skärning" ; -- skärning..nn.1
  skärningslinje_1_N = mkN "skärningslinje" "skärningslinjer" ; -- skärningslinje..nn.1
  skärningspunkt_1_N = mkN "skärningspunkt" "skärningspunkter" ; -- skärningspunkt..nn.1
  skärp_1_N = mkN "skärp" neutrum  ; -- skärp..nn.1
  skärpa_1_N = mkN "skärpa" ; -- skärpa..nn.1
  skärpa_1_V = mkV "skärper" ; -- skärpa..vb.1
  skärpande_1_N = mkN "skärpande" ; -- skärpande..nn.1
  skärpedjup_1_N = mkN "skärpedjup" neutrum  ; -- skärpedjup..nn.1
  skärpiplärka_1_N = mkN "skärpiplärka" ; -- skärpiplärka..nn.1
  skärpning_1_N = mkN "skärpning" ; -- skärpning..nn.1
  skärpt_1_A = mkA "skärpt" "skärpt" ; -- skärpt..av.1
  skärpthet_1_N = mkN "skärpthet" ; -- skärpthet..nn.1
  skärra_1_N = mkN "skärra" ; -- skärra..nn.1
  skärra_1_V = mkV "skärrar" ; -- skärra..vb.1
  skärrande_1_N = mkN "skärrande" ; -- skärrande..nn.1
  skärseld_1_N = mkN "skärseld" ; -- skärseld..nn.1
  skärskåda_1_V = mkV "skärskådar" ; -- skärskåda..vb.1
  skärskådande_1_N = mkN "skärskådande" ; -- skärskådande..nn.1
  skärskådning_1_N = mkN "skärskådning" ; -- skärskådning..nn.1
  skärslipare_1_N = mkN "skärslipare" utrum  ; -- skärslipare..nn.1
  skärstock_1_N = mkN "skärstock" ; -- skärstock..nn.1
  skärsår_1_N = mkN "skärsår" neutrum  ; -- skärsår..nn.1
  skärtorsdag_1_N = mkN "skärtorsdag" ; -- skärtorsdag..nn.1
  skärtorv_1_N = mkN "skärtorv" ; -- skärtorv..nn.1
  skärv_1_N = mkN "skärv" ; -- skärv..nn.1
  skärva_1_N = mkN "skärva" ; -- skärva..nn.1
  skärva_1_V = mkV "skärvar" ; -- skärva..vb.1
  skärvande_1_N = mkN "skärvande" ; -- skärvande..nn.1
  skärvfrö_1_N = mkN "skärvfrö" neutrum  ; -- skärvfrö..nn.1
  skävig_1_A = mkA "skävig" ; -- skävig..av.1
  skåda_1_V = mkV "skådar" ; -- skåda..vb.1
  skådande_1_N = mkN "skådande" ; -- skådande..nn.1
  skådebana_1_N = mkN "skådebana" ; -- skådebana..nn.1
  skådebröd_1_N = mkN "skådebröd" neutrum  ; -- skådebröd..nn.1
  skådelysten_1_A = mkA "skådelysten" ; -- skådelysten..av.1
  skådelystnad_1_N = mkN "skådelystnad" ; -- skådelystnad..nn.1
  skådemynt_1_N = mkN "skådemynt" neutrum  ; -- skådemynt..nn.1
  skådeplats_1_N = mkN "skådeplats" "skådeplatser" ; -- skådeplats..nn.1
  skådeprocess_1_N = mkN "skådeprocess" "skådeprocesser" ; -- skådeprocess..nn.1
  skåderättegång_1_N = mkN "skåderättegång" ; -- skåderättegång..nn.1
  skådespel_1_N = mkN "skådespel" "skådespelet" "skådespel" "skådespelen" ; -- skådespel..nn.1
  skådespela_1_V = mkV "skådespelar" ; -- skådespela..vb.1
  skådespelande_1_A = mkA "skådespelande" ; -- skådespelande..av.1
  skådespelardröm_1_N = mkN "skådespelardröm" "skådespelardrömmen" "skådespelardrömmar" "skådespelardrömmarna" ; -- skådespelardröm..nn.1
  skådespelare_1_N = mkN "skådespelare" utrum  ; -- skådespelare..nn.1
  skådespelarkonst_1_N = mkN "skådespelarkonst" ; -- skådespelarkonst..nn.1
  skådespelarmässig_1_A = mkA "skådespelarmässig" ; -- skådespelarmässig..av.1
  skådespelarpar_1_N = mkN "skådespelarpar" neutrum  ; -- skådespelarpar..nn.1
  skådespelartrupp_1_N = mkN "skådespelartrupp" "skådespelartrupper" ; -- skådespelartrupp..nn.1
  skådespeleri_1_N = mkN "skådespeleri" neutrum  ; -- skådespeleri..nn.1
  skådespelerska_1_N = mkN "skådespelerska" ; -- skådespelerska..nn.1
  skådis_1_N = mkN "skådis" ; -- skådis..nn.1
  skål_1_N = mkN "skål" ; -- skål..nn.1
  skåla_1_V = mkV "skålar" ; -- skåla..vb.1
  skålande_1_N = mkN "skålande" ; -- skålande..nn.1
  skålformig_1_A = mkA "skålformig" ; -- skålformig..av.1
  skålformighet_1_N = mkN "skålformighet" ; -- skålformighet..nn.1
  skålgrop_1_N = mkN "skålgrop" ; -- skålgrop..nn.1
  skålig_1_A = mkA "skålig" ; -- skålig..av.1
  skålighet_1_N = mkN "skålighet" ; -- skålighet..nn.1
  skålkors_1_N = mkN "skålkors" neutrum  ; -- skålkors..nn.1
  skålla_1_V = mkV "skållar" ; -- skålla..vb.1
  skållande_1_N = mkN "skållande" ; -- skållande..nn.1
  skållhet_1_A = mkA "skållhet" ; -- skållhet..av.1
  skållning_1_N = mkN "skållning" ; -- skållning..nn.1
  skålpund_1_N = mkN "skålpund" neutrum  ; -- skålpund..nn.1
  skålrost_1_N = mkN "skålrost" ; -- skålrost..nn.1
  skålskärva_1_N = mkN "skålskärva" ; -- skålskärva..nn.1
  skålsnäcka_1_N = mkN "skålsnäcka" ; -- skålsnäcka..nn.1
  skålsvamp_1_N = mkN "skålsvamp" ; -- skålsvamp..nn.1
  skåltal_1_N = mkN "skåltal" neutrum  ; -- skåltal..nn.1
  skåltalare_1_N = mkN "skåltalare" utrum  ; -- skåltalare..nn.1
  skåltom_1_A = mkA "skåltom" "skåltomt" "skåltomma" "skåltomma" "skåltommare" "skåltommast" "skåltommaste" ; -- skåltom..av.1
  skålvirke_1_N = mkN "skålvirke" ; -- skålvirke..nn.1
  skångra_1_V = mkV "skångrar" ; -- skångra..vb.1
  skångrande_1_N = mkN "skångrande" ; -- skångrande..nn.1
  skåning_1_N = mkN "skåning" ; -- skåning..nn.1
  skånk_1_N = mkN "skånk" ; -- skånk..nn.1
  skånsk_1_A = mkA "skånsk" ; -- skånsk..av.1
  skånska_1_N = mkN "skånska" ; -- skånska..nn.1
  skånska_2_N = mkN "skånska" ; -- skånska..nn.2
  skånskhet_1_N = mkN "skånskhet" ; -- skånskhet..nn.1
  skåp_1_N = mkN "skåp" neutrum  ; -- skåp..nn.1
  skåpbil_1_N = mkN "skåpbil" ; -- skåpbil..nn.1
  skåpdörr_1_N = mkN "skåpdörr" ; -- skåpdörr..nn.1
  skåpliknande_1_A = mkA "skåpliknande" ; -- skåpliknande..av.1
  skåpmat_1_N = mkN "skåpmat" ; -- skåpmat..nn.1
  skåpsupa_1_V = mkV "skåpsupa" "skåpsöp" "skåpsupit" ; -- skåpsupa..vb.1
  skåpsupande_1_N = mkN "skåpsupande" ; -- skåpsupande..nn.1
  skåpsupare_1_N = mkN "skåpsupare" utrum  ; -- skåpsupare..nn.1
  skåpsäng_1_N = mkN "skåpsäng" ; -- skåpsäng..nn.1
  skåpvagn_1_N = mkN "skåpvagn" ; -- skåpvagn..nn.1
  skåpätande_1_N = mkN "skåpätande" ; -- skåpätande..nn.1
  skår_1_N = mkN "skår" neutrum  ; -- skår..nn.1
  skåra_1_N = mkN "skåra" ; -- skåra..nn.1
  skåra_1_V = mkV "skårar" ; -- skåra..vb.1
  skårande_1_N = mkN "skårande" ; -- skårande..nn.1
  skåre_1_N = mkN "skåre" utrum  ; -- skåre..nn.1
  sköka_1_N = mkN "sköka" ; -- sköka..nn.1
  sköl_1_N = mkN "sköl" ; -- sköl..nn.1
  sköld_1_N = mkN "sköld" ; -- sköld..nn.1
  sköldborg_1_N = mkN "sköldborg" ; -- sköldborg..nn.1
  sköldbrosk_1_N = mkN "sköldbrosk" neutrum  ; -- sköldbrosk..nn.1
  sköldebrev_1_N = mkN "sköldebrev" neutrum  ; -- sköldebrev..nn.1
  sköldemärke_1_N = mkN "sköldemärke" ; -- sköldemärke..nn.1
  sköldhållare_1_N = mkN "sköldhållare" utrum  ; -- sköldhållare..nn.1
  sköldkörtel_1_N = mkN "sköldkörtel" ; -- sköldkörtel..nn.1
  sköldkörtelcancer_1_N = mkN "sköldkörtelcancer" ; -- sköldkörtelcancer..nn.1
  sköldkörtelhormon_1_N = mkN "sköldkörtelhormon" neutrum  ; -- sköldkörtelhormon..nn.1
  sköldlus_1_N = mkN "sköldlus" "sköldlusen" "sköldlöss" "sköldlössen" ; -- sköldlus..nn.1
  sköldmö_1_N = mkN "sköldmö" "sköldmön" "sköldmör" "sköldmörna" ; -- sköldmö..nn.1
  sköldpadd_1_N = mkN "sköldpadd" ; -- sköldpadd..nn.1
  sköldpadda_1_N = mkN "sköldpadda" ; -- sköldpadda..nn.1
  sköldpaddsjakt_1_N = mkN "sköldpaddsjakt" ; -- sköldpaddsjakt..nn.1
  sköldpaddssoppa_1_N = mkN "sköldpaddssoppa" ; -- sköldpaddssoppa..nn.1
  skölja_1_V = mkV "skölja" "sköljde" "sköljt" ; -- skölja..vb.1
  sköljande_1_N = mkN "sköljande" ; -- sköljande..nn.1
  sköljbassäng_1_N = mkN "sköljbassäng" "sköljbassänger" ; -- sköljbassäng..nn.1
  sköljkanna_1_N = mkN "sköljkanna" ; -- sköljkanna..nn.1
  sköljkopp_1_N = mkN "sköljkopp" ; -- sköljkopp..nn.1
  sköljning_1_N = mkN "sköljning" ; -- sköljning..nn.1
  skölp_1_N = mkN "skölp" ; -- skölp..nn.1
  skölpa_1_V = mkV "skölpar" ; -- skölpa..vb.1
  skölpande_1_N = mkN "skölpande" ; -- skölpande..nn.1
  skön_1_A = mkA "skön" ; -- skön..av.1
  skön_1_N = mkN "skön" ; -- skön..nn.1
  sköna_1_V = mkV "skönar" ; -- sköna..vb.1
  skönande_1_N = mkN "skönande" utrum  ; -- skönande..nn.1
  skönande_2_N = mkN "skönande" ; -- skönande..nn.2
  skönhet_1_N = mkN "skönhet" "skönheter" ; -- skönhet..nn.1
  skönhet_2_N = mkN "skönhet" ; -- skönhet..nn.2
  skönhetsdrottning_1_N = mkN "skönhetsdrottning" ; -- skönhetsdrottning..nn.1
  skönhetsfel_1_N = mkN "skönhetsfel" "skönhetsfelet" "skönhetsfel" "skönhetsfelen" ; -- skönhetsfel..nn.1
  skönhetsfläck_1_N = mkN "skönhetsfläck" ; -- skönhetsfläck..nn.1
  skönhetsföretag_1_N = mkN "skönhetsföretag" neutrum  ; -- skönhetsföretag..nn.1
  skönhetsideal_1_N = mkN "skönhetsideal" neutrum  ; -- skönhetsideal..nn.1
  skönhetsingrepp_1_N = mkN "skönhetsingrepp" neutrum  ; -- skönhetsingrepp..nn.1
  skönhetsjätte_1_N = mkN "skönhetsjätte" utrum  ; -- skönhetsjätte..nn.1
  skönhetsmedel_1_N = mkN "skönhetsmedel" neutrum  ; -- skönhetsmedel..nn.1
  skönhetsmiss_1_N = mkN "skönhetsmiss" ; -- skönhetsmiss..nn.1
  skönhetsoperation_1_N = mkN "skönhetsoperation" ; -- skönhetsoperation..nn.1
  skönhetspris_1_N = mkN "skönhetspris" neutrum  ; -- skönhetspris..nn.1
  skönhetssalong_1_N = mkN "skönhetssalong" "skönhetssalonger" ; -- skönhetssalong..nn.1
  skönhetssinne_1_N = mkN "skönhetssinne" ; -- skönhetssinne..nn.1
  skönhetssömn_1_N = mkN "skönhetssömn" ; -- skönhetssömn..nn.1
  skönhetstuggummi_1_N = mkN "skönhetstuggummi" "skönhetstuggummit" "skönhetstuggummin" "skönhetstuggummina" ; -- skönhetstuggummi..nn.1
  skönhetstävling_1_N = mkN "skönhetstävling" ; -- skönhetstävling..nn.1
  skönhetsupplevelse_1_N = mkN "skönhetsupplevelse" "skönhetsupplevelser" ; -- skönhetsupplevelse..nn.1
  skönhetsvärde_1_N = mkN "skönhetsvärde" ; -- skönhetsvärde..nn.1
  skönhetsvård_1_N = mkN "skönhetsvård" ; -- skönhetsvård..nn.1
  skönja_1_V = mkV "skönja" "skönjde" "skönjt" ; -- skönja..vb.1
  skönjande_1_N = mkN "skönjande" ; -- skönjande..nn.1
  skönjbar_1_A = mkA "skönjbar" ; -- skönjbar..av.1
  skönjbarhet_1_N = mkN "skönjbarhet" ; -- skönjbarhet..nn.1
  skönlitteratur_1_N = mkN "skönlitteratur" ; -- skönlitteratur..nn.1
  skönlitterär_1_A = mkA "skönlitterär" ; -- skönlitterär..av.1
  skönlockig_1_A = mkA "skönlockig" ; -- skönlockig..av.1
  skönlockighet_1_N = mkN "skönlockighet" ; -- skönlockighet..nn.1
  skönmåla_1_V = mkV "skönmålar" ; -- skönmåla..vb.1
  skönmålande_1_N = mkN "skönmålande" ; -- skönmålande..nn.1
  skönmålning_1_N = mkN "skönmålning" ; -- skönmålning..nn.1
  skönprosa_1_N = mkN "skönprosa" ; -- skönprosa..nn.1
  skönsjungande_1_A = mkA "skönsjungande" ; -- skönsjungande..av.1
  skönskrift_1_N = mkN "skönskrift" ; -- skönskrift..nn.1
  skönskrivare_1_N = mkN "skönskrivare" utrum  ; -- skönskrivare..nn.1
  skönskrivning_1_N = mkN "skönskrivning" ; -- skönskrivning..nn.1
  skönskrivning_2_N = mkN "skönskrivning" ; -- skönskrivning..nn.2
  skönsmässig_1_A = mkA "skönsmässig" ; -- skönsmässig..av.1
  skönstaxera_1_V = mkV "skönstaxerar" ; -- skönstaxera..vb.1
  skönstaxerande_1_N = mkN "skönstaxerande" ; -- skönstaxerande..nn.1
  skönstaxerbar_1_A = mkA "skönstaxerbar" ; -- skönstaxerbar..av.1
  skönstaxerbarhet_1_N = mkN "skönstaxerbarhet" ; -- skönstaxerbarhet..nn.1
  skönstaxering_1_N = mkN "skönstaxering" ; -- skönstaxering..nn.1
  skönsvärde_1_N = mkN "skönsvärde" ; -- skönsvärde..nn.1
  sköntaxera_1_V = mkV "sköntaxerar" ; -- sköntaxera..vb.1
  sköntaxerande_1_N = mkN "sköntaxerande" ; -- sköntaxerande..nn.1
  sköntaxerbar_1_A = mkA "sköntaxerbar" ; -- sköntaxerbar..av.1
  sköntaxerbarhet_1_N = mkN "sköntaxerbarhet" ; -- sköntaxerbarhet..nn.1
  sköntaxering_1_N = mkN "sköntaxering" ; -- sköntaxering..nn.1
  skör_1_A = mkA "skör" ; -- skör..av.1
  sköra_1_N = mkN "sköra" ; -- sköra..nn.1
  sköra_1_V = mkV "skörar" ; -- sköra..vb.1
  skörande_1_N = mkN "skörande" ; -- skörande..nn.1
  skörbjugg_1_N = mkN "skörbjugg" ; -- skörbjugg..nn.1
  skörbjuggsört_1_N = mkN "skörbjuggsört" ; -- skörbjuggsört..nn.1
  skörd_1_N = mkN "skörd" ; -- skörd..nn.1
  skörda_1_V = mkV "skördar" ; -- skörda..vb.1
  skördande_1_N = mkN "skördande" ; -- skördande..nn.1
  skördeand_1_N = mkN "skördeand" ; -- skördeand..nn.1
  skördeenhet_1_N = mkN "skördeenhet" "skördeenheter" ; -- skördeenhet..nn.1
  skördefest_1_N = mkN "skördefest" "skördefester" ; -- skördefest..nn.1
  skördemaskin_1_N = mkN "skördemaskin" "skördemaskiner" ; -- skördemaskin..nn.1
  skördemånad_1_N = mkN "skördemånad" "skördemånader" ; -- skördemånad..nn.1
  skördetid_1_N = mkN "skördetid" "skördetider" ; -- skördetid..nn.1
  skördetröska_1_N = mkN "skördetröska" ; -- skördetröska..nn.1
  skördeuppskattning_1_N = mkN "skördeuppskattning" ; -- skördeuppskattning..nn.1
  sköre_1_N = mkN "sköre" ; -- sköre..nn.1
  skörhet_1_N = mkN "skörhet" ; -- skörhet..nn.1
  skörl_1_N = mkN "skörl" ; -- skörl..nn.1
  skörlevnad_1_N = mkN "skörlevnad" "skörlevnader" ; -- skörlevnad..nn.1
  skörna_1_V = mkV "skörnar" ; -- skörna..vb.1
  skörnande_1_N = mkN "skörnande" ; -- skörnande..nn.1
  skörpil_1_N = mkN "skörpil" ; -- skörpil..nn.1
  skört_1_N = mkN "skört" neutrum  ; -- skört..nn.1
  sköt_1_N = mkN "sköt" ; -- sköt..nn.1
  sköta_1_V = mkV "sköter" ; -- sköta..vb.1
  skötande_1_N = mkN "skötande" ; -- skötande..nn.1
  skötare_1_N = mkN "skötare" utrum  ; -- skötare..nn.1
  skötbord_1_N = mkN "skötbord" neutrum  ; -- skötbord..nn.1
  sköte_1_N = mkN "sköte" ; -- sköte..nn.1
  skötebarn_1_N = mkN "skötebarn" neutrum  ; -- skötebarn..nn.1
  sköterska_1_N = mkN "sköterska" ; -- sköterska..nn.1
  sköterskegrad_1_N = mkN "sköterskegrad" "sköterskegrader" ; -- sköterskegrad..nn.1
  skötesynd_1_N = mkN "skötesynd" "skötesynder" ; -- skötesynd..nn.1
  skötrum_1_N = mkN "skötrum" "skötrummet" "skötrum" "skötrummen" ; -- skötrum..nn.1
  skötsam_1_A = mkA "skötsam" "skötsamt" "skötsamma" "skötsamma" "skötsammare" "skötsammast" "skötsammaste" ; -- skötsam..av.1
  skötsamhet_1_N = mkN "skötsamhet" ; -- skötsamhet..nn.1
  skötsel_1_N = mkN "skötsel" ; -- skötsel..nn.1
  skövla_1_V = mkV "skövlar" ; -- skövla..vb.1
  skövlande_1_N = mkN "skövlande" ; -- skövlande..nn.1
  skövling_1_N = mkN "skövling" ; -- skövling..nn.1
  slabb_1_A = mkA "slabb" ; -- slabb..av.1
  slabb_1_N = mkN "slabb" neutrum  ; -- slabb..nn.1
  slabba_1_V = mkV "slabbar" ; -- slabba..vb.1
  slabbande_1_N = mkN "slabbande" ; -- slabbande..nn.1
  slabbertacka_1_N = mkN "slabbertacka" ; -- slabbertacka..nn.1
  slabbhet_1_N = mkN "slabbhet" ; -- slabbhet..nn.1
  slabbig_1_A = mkA "slabbig" ; -- slabbig..av.1
  slabbighet_1_N = mkN "slabbighet" ; -- slabbighet..nn.1
  slabbkista_1_N = mkN "slabbkista" ; -- slabbkista..nn.1
  slabbra_1_V = mkV "slabbrar" ; -- slabbra..vb.1
  slabbrande_1_N = mkN "slabbrande" ; -- slabbrande..nn.1
  slack_1_A = mkA "slack" ; -- slack..av.1
  slack_1_N = mkN "slack" neutrum  ; -- slack..nn.1
  slacka_1_V = mkV "slackar" ; -- slacka..vb.1
  slackande_1_N = mkN "slackande" ; -- slackande..nn.1
  slackhet_1_N = mkN "slackhet" ; -- slackhet..nn.1
  sladd_1_N = mkN "sladd" ; -- sladd..nn.1
  sladda_1_V = mkV "sladdar" ; -- sladda..vb.1
  sladdande_1_N = mkN "sladdande" ; -- sladdande..nn.1
  sladdbarn_1_N = mkN "sladdbarn" neutrum  ; -- sladdbarn..nn.1
  sladder_1_N = mkN "sladder" neutrum  ; -- sladder..nn.1
  sladderkäring_1_N = mkN "sladderkäring" ; -- sladderkäring..nn.1
  sladdhållare_1_N = mkN "sladdhållare" utrum  ; -- sladdhållare..nn.1
  sladdig_1_A = mkA "sladdig" ; -- sladdig..av.1
  sladdighet_1_N = mkN "sladdighet" ; -- sladdighet..nn.1
  sladdklämma_1_N = mkN "sladdklämma" ; -- sladdklämma..nn.1
  sladdlampa_1_N = mkN "sladdlampa" ; -- sladdlampa..nn.1
  sladdlös_1_A = mkA "sladdlös" ; -- sladdlös..av.1
  sladdra_1_V = mkV "sladdrar" ; -- sladdra..vb.1
  sladdrande_1_N = mkN "sladdrande" ; -- sladdrande..nn.1
  sladdrare_1_N = mkN "sladdrare" utrum  ; -- sladdrare..nn.1
  sladdrig_1_A = mkA "sladdrig" ; -- sladdrig..av.1
  sladdrighet_1_N = mkN "sladdrighet" ; -- sladdrighet..nn.1
  slaf_1_N = mkN "slaf" ; -- slaf..nn.1
  slafa_1_V = mkV "slafar" ; -- slafa..vb.1
  slafande_1_N = mkN "slafande" ; -- slafande..nn.1
  slafs_1_N = mkN "slafs" ; -- slafs..nn.1
  slafs_2_N = mkN "slafs" neutrum  ; -- slafs..nn.2
  slafsa_1_N = mkN "slafsa" ; -- slafsa..nn.1
  slafsa_1_V = mkV "slafsar" ; -- slafsa..vb.1
  slafsande_1_N = mkN "slafsande" ; -- slafsande..nn.1
  slafsig_1_A = mkA "slafsig" ; -- slafsig..av.1
  slafsighet_1_N = mkN "slafsighet" ; -- slafsighet..nn.1
  slag_1_N = mkN "slag" neutrum  ; -- slag..nn.1
  slaga_1_N = mkN "slaga" ; -- slaga..nn.1
  slaganfall_1_N = mkN "slaganfall" neutrum  ; -- slaganfall..nn.1
  slaganfallspatient_1_N = mkN "slaganfallspatient" "slaganfallspatienter" ; -- slaganfallspatient..nn.1
  slagbjörn_1_N = mkN "slagbjörn" ; -- slagbjörn..nn.1
  slagbom_1_N = mkN "slagbom" "slagbommen" "slagbommar" "slagbommarna" ; -- slagbom..nn.1
  slagbord_1_N = mkN "slagbord" neutrum  ; -- slagbord..nn.1
  slagborr_1_N = mkN "slagborr" ; -- slagborr..nn.1
  slagdänga_1_N = mkN "slagdänga" ; -- slagdänga..nn.1
  slagen_1_A = mkA "slagen" ; -- slagen..av.1
  slagfel_1_N = mkN "slagfel" "slagfelet" "slagfel" "slagfelen" ; -- slagfel..nn.1
  slagfjäder_1_N = mkN "slagfjäder" ; -- slagfjäder..nn.1
  slagfält_1_N = mkN "slagfält" neutrum  ; -- slagfält..nn.1
  slagfärdig_1_A = mkA "slagfärdig" ; -- slagfärdig..av.1
  slagfärdighet_1_N = mkN "slagfärdighet" ; -- slagfärdighet..nn.1
  slagg_1_N = mkN "slagg" "slagger" ; -- slagg..nn.1
  slagga_1_V = mkV "slaggar" ; -- slagga..vb.1
  slagga_2_V = mkV "slaggar" ; -- slagga..vb.2
  slaggande_1_N = mkN "slaggande" ; -- slaggande..nn.1
  slaggfärskning_1_N = mkN "slaggfärskning" ; -- slaggfärskning..nn.1
  slaggig_1_A = mkA "slaggig" ; -- slaggig..av.1
  slaggighet_1_N = mkN "slaggighet" ; -- slaggighet..nn.1
  slaggmängd_1_N = mkN "slaggmängd" "slaggmängder" ; -- slaggmängd..nn.1
  slaghök_1_N = mkN "slaghök" ; -- slaghök..nn.1
  slaginstrument_1_N = mkN "slaginstrument" neutrum  ; -- slaginstrument..nn.1
  slagkraft_1_N = mkN "slagkraft" ; -- slagkraft..nn.1
  slagkraftig_1_A = mkA "slagkraftig" ; -- slagkraftig..av.1
  slagkraftighet_1_N = mkN "slagkraftighet" ; -- slagkraftighet..nn.1
  slaglod_1_N = mkN "slaglod" neutrum  ; -- slaglod..nn.1
  slaglängd_1_N = mkN "slaglängd" "slaglängder" ; -- slaglängd..nn.1
  slagmask_1_N = mkN "slagmask" "slagmasker" ; -- slagmask..nn.1
  slagnummer_1_N = mkN "slagnummer" neutrum  ; -- slagnummer..nn.1
  slagord_1_N = mkN "slagord" neutrum  ; -- slagord..nn.1
  slagordning_1_N = mkN "slagordning" ; -- slagordning..nn.1
  slagordsmässig_1_A = mkA "slagordsmässig" ; -- slagordsmässig..av.1
  slagordsmässighet_1_N = mkN "slagordsmässighet" ; -- slagordsmässighet..nn.1
  slagpåse_1_N = mkN "slagpåse" utrum  ; -- slagpåse..nn.1
  slagregn_1_N = mkN "slagregn" neutrum  ; -- slagregn..nn.1
  slagrodd_1_N = mkN "slagrodd" ; -- slagrodd..nn.1
  slagruta_1_N = mkN "slagruta" ; -- slagruta..nn.1
  slagrutegängare_1_N = mkN "slagrutegängare" utrum  ; -- slagrutegängare..nn.1
  slagrörd_1_A = mkA "slagrörd" "slagrört" ; -- slagrörd..av.1
  slags_1_A = mkA "slags" ; -- slags..av.1
  slagseghet_1_N = mkN "slagseghet" "slagsegheter" ; -- slagseghet..nn.1
  slagsida_1_N = mkN "slagsida" ; -- slagsida..nn.1
  slagskatt_1_N = mkN "slagskatt" "slagskatter" ; -- slagskatt..nn.1
  slagskepp_1_N = mkN "slagskepp" neutrum  ; -- slagskepp..nn.1
  slagskeppsmatros_1_N = mkN "slagskeppsmatros" "slagskeppsmatroser" ; -- slagskeppsmatros..nn.1
  slagskugga_1_N = mkN "slagskugga" ; -- slagskugga..nn.1
  slagskämpe_1_N = mkN "slagskämpe" utrum  ; -- slagskämpe..nn.1
  slagsmål_1_N = mkN "slagsmål" neutrum  ; -- slagsmål..nn.1
  slagstift_1_N = mkN "slagstift" neutrum  ; -- slagstift..nn.1
  slagsvärd_1_N = mkN "slagsvärd" neutrum  ; -- slagsvärd..nn.1
  slagträ_1_N = mkN "slagträ" "slagträt" "slagträn" "slagträna" ; -- slagträ..nn.1
  slagtålig_1_A = mkA "slagtålig" ; -- slagtålig..av.1
  slagtålighet_1_N = mkN "slagtålighet" ; -- slagtålighet..nn.1
  slaguggla_1_N = mkN "slaguggla" ; -- slaguggla..nn.1
  slagvapen_1_N = mkN "slagvapen" "slagvapnet" "slagvapen" "slagvapnen" ; -- slagvapen..nn.1
  slagverk_1_N = mkN "slagverk" neutrum  ; -- slagverk..nn.1
  slagvolym_1_N = mkN "slagvolym" ; -- slagvolym..nn.1
  slagvägare_1_N = mkN "slagvägare" utrum  ; -- slagvägare..nn.1
  slagväxling_1_N = mkN "slagväxling" ; -- slagväxling..nn.1
  slagäntring_1_N = mkN "slagäntring" ; -- slagäntring..nn.1
  slak_1_A = mkA "slak" ; -- slak..av.1
  slaka_1_V = mkV "slakar" ; -- slaka..vb.1
  slakande_1_N = mkN "slakande" ; -- slakande..nn.1
  slakhet_1_N = mkN "slakhet" ; -- slakhet..nn.1
  slakna_1_V = mkV "slaknar" ; -- slakna..vb.1
  slaknande_1_N = mkN "slaknande" ; -- slaknande..nn.1
  slaksida_1_N = mkN "slaksida" ; -- slaksida..nn.1
  slakt_1_N = mkN "slakt" "slakter" ; -- slakt..nn.1
  slakta_1_V = mkV "slaktar" ; -- slakta..vb.1
  slaktande_1_N = mkN "slaktande" ; -- slaktande..nn.1
  slaktarbod_1_N = mkN "slaktarbod" ; -- slaktarbod..nn.1
  slaktare_1_N = mkN "slaktare" utrum  ; -- slaktare..nn.1
  slaktavfall_1_N = mkN "slaktavfall" neutrum  ; -- slaktavfall..nn.1
  slaktbod_1_N = mkN "slaktbod" ; -- slaktbod..nn.1
  slaktdjur_1_N = mkN "slaktdjur" neutrum  ; -- slaktdjur..nn.1
  slakteri_1_N = mkN "slakteri" "slakteriet" "slakterier" "slakterierna" ; -- slakteri..nn.1
  slakteributik_1_N = mkN "slakteributik" "slakteributiker" ; -- slakteributik..nn.1
  slakthus_1_N = mkN "slakthus" neutrum  ; -- slakthus..nn.1
  slaktmask_1_N = mkN "slaktmask" "slaktmasker" ; -- slaktmask..nn.1
  slaktmånad_1_N = mkN "slaktmånad" "slaktmånader" ; -- slaktmånad..nn.1
  slaktning_1_N = mkN "slaktning" ; -- slaktning..nn.1
  slaktoffer_1_N = mkN "slaktoffer" neutrum  ; -- slaktoffer..nn.1
  slaktvikt_1_N = mkN "slaktvikt" ; -- slaktvikt..nn.1
  slalom_1_N = mkN "slalom" ; -- slalom..nn.1
  slalomport_1_N = mkN "slalomport" ; -- slalomport..nn.1
  slalomskida_1_N = mkN "slalomskida" ; -- slalomskida..nn.1
  slalomåkare_1_N = mkN "slalomåkare" utrum  ; -- slalomåkare..nn.1
  slam_2_N = mkN "slam" "slammen" "slammar" "slammarna" ; -- slam..nn.2
  slamfluga_1_N = mkN "slamfluga" ; -- slamfluga..nn.1
  slamfärg_1_N = mkN "slamfärg" ; -- slamfärg..nn.1
  slamkrypare_1_N = mkN "slamkrypare" utrum  ; -- slamkrypare..nn.1
  slamma_1_V = mkV "slammar" ; -- slamma..vb.1
  slamma_2_V = mkV "slammar" ; -- slamma..vb.2
  slammande_1_N = mkN "slammande" ; -- slammande..nn.1
  slammer_1_N = mkN "slammer" neutrum  ; -- slammer..nn.1
  slammig_1_A = mkA "slammig" ; -- slammig..av.1
  slammighet_1_N = mkN "slammighet" ; -- slammighet..nn.1
  slampa_1_N = mkN "slampa" ; -- slampa..nn.1
  slampig_1_A = mkA "slampig" ; -- slampig..av.1
  slampighet_1_N = mkN "slampighet" ; -- slampighet..nn.1
  slamra_1_V = mkV "slamrar" ; -- slamra..vb.1
  slamrande_1_N = mkN "slamrande" ; -- slamrande..nn.1
  slams_1_N = mkN "slams" neutrum  ; -- slams..nn.1
  slamsa_1_N = mkN "slamsa" ; -- slamsa..nn.1
  slamsa_1_V = mkV "slamsar" ; -- slamsa..vb.1
  slamsande_1_N = mkN "slamsande" ; -- slamsande..nn.1
  slamsig_1_A = mkA "slamsig" ; -- slamsig..av.1
  slamsighet_1_N = mkN "slamsighet" ; -- slamsighet..nn.1
  slamsugning_1_N = mkN "slamsugning" ; -- slamsugning..nn.1
  slamsugningsbil_1_N = mkN "slamsugningsbil" ; -- slamsugningsbil..nn.1
  slana_1_N = mkN "slana" ; -- slana..nn.1
  slang_1_N = mkN "slang" ; -- slang..nn.1
  slang_2_N = mkN "slang" ; -- slang..nn.2
  slanga_1_V = mkV "slangar" ; -- slanga..vb.1
  slangande_1_N = mkN "slangande" ; -- slangande..nn.1
  slangbella_1_N = mkN "slangbella" ; -- slangbella..nn.1
  slangbåge_1_N = mkN "slangbåge" utrum  ; -- slangbåge..nn.1
  slanggurka_1_N = mkN "slanggurka" ; -- slanggurka..nn.1
  slangklämma_1_N = mkN "slangklämma" ; -- slangklämma..nn.1
  slangkoppling_1_N = mkN "slangkoppling" ; -- slangkoppling..nn.1
  slanglös_1_A = mkA "slanglös" ; -- slanglös..av.1
  slanglöshet_1_N = mkN "slanglöshet" ; -- slanglöshet..nn.1
  slangning_1_N = mkN "slangning" ; -- slangning..nn.1
  slangspråk_1_N = mkN "slangspråk" neutrum  ; -- slangspråk..nn.1
  slanguttryck_1_N = mkN "slanguttryck" neutrum  ; -- slanguttryck..nn.1
  slank_1_A = mkA "slank" ; -- slank..av.1
  slanka_1_V = mkV "slankar" ; -- slanka..vb.1
  slankande_1_N = mkN "slankande" ; -- slankande..nn.1
  slankhet_1_N = mkN "slankhet" ; -- slankhet..nn.1
  slankig_1_A = mkA "slankig" ; -- slankig..av.1
  slankighet_1_N = mkN "slankighet" ; -- slankighet..nn.1
  slankna_1_V = mkV "slanknar" ; -- slankna..vb.1
  slanknande_1_N = mkN "slanknande" ; -- slanknande..nn.1
  slant_1_N = mkN "slant" ; -- slant..nn.1
  slanta_1_V = mkV "slantar" ; -- slanta..vb.1
  slantande_1_N = mkN "slantande" ; -- slantande..nn.1
  slantsingling_1_N = mkN "slantsingling" ; -- slantsingling..nn.1
  slantspö_1_N = mkN "slantspö" "slantspöt" "slantspön" "slantspöna" ; -- slantspö..nn.1
  slapp_1_A = mkA "slapp" ; -- slapp..av.1
  slappa_1_V = mkV "slappar" ; -- slappa..vb.1
  slappande_1_N = mkN "slappande" ; -- slappande..nn.1
  slapphet_1_N = mkN "slapphet" ; -- slapphet..nn.1
  slapphänt_1_A = mkA "slapphänt" "slapphänt" ; -- slapphänt..av.1
  slapphänthet_1_N = mkN "slapphänthet" ; -- slapphänthet..nn.1
  slappna_1_V = mkV "slappnar" ; -- slappna..vb.1
  slappnande_1_N = mkN "slappnande" ; -- slappnande..nn.1
  slappzappa_1_V = mkV "slappzappar" ; -- slappzappa..vb.1
  slappzappande_1_N = mkN "slappzappande" ; -- slappzappande..nn.1
  slappzappning_1_N = mkN "slappzappning" ; -- slappzappning..nn.1
  slapstick_1_N = mkN "slapstick" ; -- slapstick..nn.1
  slarv_1_N = mkN "slarv" neutrum  ; -- slarv..nn.1
  slarva_1_N = mkN "slarva" ; -- slarva..nn.1
  slarva_1_V = mkV "slarvar" ; -- slarva..vb.1
  slarvande_1_N = mkN "slarvande" ; -- slarvande..nn.1
  slarver_1_N = mkN "slarver" ; -- slarver..nn.1
  slarverland_1_N = mkN "slarverland" "slarverlandet" "slarverländer" "slarverländerna" ; -- slarverland..nn.1
  slarvfel_1_N = mkN "slarvfel" "slarvfelet" "slarvfel" "slarvfelen" ; -- slarvfel..nn.1
  slarvig_1_A = mkA "slarvig" ; -- slarvig..av.1
  slarvighet_1_N = mkN "slarvighet" "slarvigheter" ; -- slarvighet..nn.1
  slarvpotta_1_N = mkN "slarvpotta" ; -- slarvpotta..nn.1
  slarvsylta_1_N = mkN "slarvsylta" ; -- slarvsylta..nn.1
  slasa_1_V = mkV "slasar" ; -- slasa..vb.1
  slasande_1_N = mkN "slasande" ; -- slasande..nn.1
  slase_1_N = mkN "slas" ; -- slase..nn.1
  slash_1_N = mkN "slash" ; -- slash..nn.1
  slashas_1_N = mkN "slashas" ; -- slashas..nn.1
  slashing_1_N = mkN "slashing" ; -- slashing..nn.1
  slask_1_N = mkN "slask" neutrum  ; -- slask..nn.1
  slask_2_N = mkN "slask" ; -- slask..nn.2
  slaska_1_V = mkV "slaskar" ; -- slaska..vb.1
  slaskande_1_N = mkN "slaskande" ; -- slaskande..nn.1
  slaskhink_1_N = mkN "slaskhink" ; -- slaskhink..nn.1
  slaskig_1_A = mkA "slaskig" ; -- slaskig..av.1
  slaskighet_1_N = mkN "slaskighet" ; -- slaskighet..nn.1
  slaskspalt_1_N = mkN "slaskspalt" "slaskspalter" ; -- slaskspalt..nn.1
  slasktratt_1_N = mkN "slasktratt" ; -- slasktratt..nn.1
  slaskvatten_1_N = mkN "slaskvatten" "slaskvattnet" "slaskvatten" "slaskvattnen" ; -- slaskvatten..nn.1
  slaskväder_1_N = mkN "slaskväder" neutrum  ; -- slaskväder..nn.1
  slatt_1_N = mkN "slatt" ; -- slatt..nn.1
  slattrig_1_A = mkA "slattrig" ; -- slattrig..av.1
  slattrighet_1_N = mkN "slattrighet" ; -- slattrighet..nn.1
  slav_1_N = mkN "slav" ; -- slav..nn.1
  slav_2_N = mkN "slav" "slaver" ; -- slav..nn.2
  slava_1_V = mkV "slavar" ; -- slava..vb.1
  slavande_1_N = mkN "slavande" ; -- slavande..nn.1
  slavarbetare_1_N = mkN "slavarbetare" utrum  ; -- slavarbetare..nn.1
  slavarbete_1_N = mkN "slavarbete" ; -- slavarbete..nn.1
  slavarbetsläger_1_N = mkN "slavarbetsläger" neutrum  ; -- slavarbetsläger..nn.1
  slavdrivare_1_N = mkN "slavdrivare" utrum  ; -- slavdrivare..nn.1
  slavdriven_1_A = mkA "slavdriven" ; -- slavdriven..av.1
  slaveri_1_N = mkN "slaveri" neutrum  ; -- slaveri..nn.1
  slavhandel_1_N = mkN "slavhandel" ; -- slavhandel..nn.1
  slavhandlare_1_N = mkN "slavhandlare" utrum  ; -- slavhandlare..nn.1
  slavhus_1_N = mkN "slavhus" neutrum  ; -- slavhus..nn.1
  slavinna_1_N = mkN "slavinna" ; -- slavinna..nn.1
  slavisera_1_V = mkV "slaviserar" ; -- slavisera..vb.1
  slaviserande_1_N = mkN "slaviserande" ; -- slaviserande..nn.1
  slaviserbar_1_A = mkA "slaviserbar" ; -- slaviserbar..av.1
  slaviserbarhet_1_N = mkN "slaviserbarhet" ; -- slaviserbarhet..nn.1
  slavisering_1_N = mkN "slavisering" ; -- slavisering..nn.1
  slavisk_1_A = mkA "slavisk" ; -- slavisk..av.1
  slaviskhet_1_N = mkN "slaviskhet" ; -- slaviskhet..nn.1
  slavism_1_N = mkN "slavism" "slavismer" ; -- slavism..nn.1
  slavist_1_N = mkN "slavist" "slavister" ; -- slavist..nn.1
  slavistik_1_N = mkN "slavistik" ; -- slavistik..nn.1
  slavliknande_1_A = mkA "slavliknande" ; -- slavliknande..av.1
  slavläger_1_N = mkN "slavläger" neutrum  ; -- slavläger..nn.1
  slavlön_1_N = mkN "slavlön" "slavlöner" ; -- slavlön..nn.1
  slavmärke_1_N = mkN "slavmärke" ; -- slavmärke..nn.1
  slavofil_1_A = mkA "slavofil" ; -- slavofil..av.1
  slavräd_1_N = mkN "slavräd" "slavräder" ; -- slavräd..nn.1
  slavstation_1_N = mkN "slavstation" ; -- slavstation..nn.1
  slavsändare_1_N = mkN "slavsändare" utrum  ; -- slavsändare..nn.1
  slavtillvaro_1_N = mkN "slavtillvaro" ; -- slavtillvaro..nn.1
  slavuppror_1_N = mkN "slavuppror" neutrum  ; -- slavuppror..nn.1
  slavättling_1_N = mkN "slavättling" ; -- slavättling..nn.1
  slejf_1_N = mkN "slejf" ; -- slejf..nn.1
  slejs_1_N = mkN "slejs" ; -- slejs..nn.1
  sleke_1_N = mkN "sleke" ; -- sleke..nn.1
  slem_1_A = mkA "slem" "slemt" "slemma" "slemma" "slemmare" "slemmast" "slemmaste" ; -- slem..av.1
  slemhet_1_N = mkN "slemhet" ; -- slemhet..nn.1
  slemhinna_1_N = mkN "slemhinna" ; -- slemhinna..nn.1
  slemlösande_1_A = mkA "slemlösande" ; -- slemlösande..av.1
  slemlösning_1_N = mkN "slemlösning" ; -- slemlösning..nn.1
  slemmig_1_A = mkA "slemmig" ; -- slemmig..av.1
  slemmighet_1_N = mkN "slemmighet" ; -- slemmighet..nn.1
  slemmighet_2_N = mkN "slemmighet" "slemmigheter" ; -- slemmighet..nn.2
  slempropp_1_N = mkN "slempropp" ; -- slempropp..nn.1
  slemsvamp_1_N = mkN "slemsvamp" ; -- slemsvamp..nn.1
  slemsäck_1_N = mkN "slemsäck" ; -- slemsäck..nn.1
  slentrian_1_N = mkN "slentrian" ; -- slentrian..nn.1
  slentrianföreställning_1_N = mkN "slentrianföreställning" ; -- slentrianföreställning..nn.1
  slentrianmässig_1_A = mkA "slentrianmässig" ; -- slentrianmässig..av.1
  slentrianmörka_1_V = mkV "slentrianmörkar" ; -- slentrianmörka..vb.1
  slentrianmörkande_1_N = mkN "slentrianmörkande" ; -- slentrianmörkande..nn.1
  slentrianmörkning_1_N = mkN "slentrianmörkning" ; -- slentrianmörkning..nn.1
  slev_1_N = mkN "slev" ; -- slev..nn.1
  sleva_1_V = mkV "slevar" ; -- sleva..vb.1
  slevande_1_N = mkN "slevande" ; -- slevande..nn.1
  slibbig_1_A = mkA "slibbig" ; -- slibbig..av.1
  slibbighet_1_N = mkN "slibbighet" "slibbigheter" ; -- slibbighet..nn.1
  slice_1_N = mkN "slice" utrum  ; -- slice..nn.1
  slick_1_N = mkN "slick" ; -- slick..nn.1
  slicka_1_V = mkV "slickar" ; -- slicka..vb.1
  slickande_1_N = mkN "slickande" ; -- slickande..nn.1
  slickepinne_1_N = mkN "slickepinne" utrum  ; -- slickepinne..nn.1
  slickepott_1_N = mkN "slickepott" ; -- slickepott..nn.1
  slickning_1_N = mkN "slickning" ; -- slickning..nn.1
  slicksten_1_N = mkN "slicksten" "slickstenen" "slickstenar" "slickstenarna" ; -- slicksten..nn.1
  slid_1_N = mkN "slid" "slider" ; -- slid..nn.1
  slida_1_N = mkN "slida" ; -- slida..nn.1
  slidder_1_N = mkN "slidder" neutrum  ; -- slidder..nn.1
  sliddersladder_1_N = mkN "sliddersladder" neutrum  ; -- sliddersladder..nn.1
  sliddrig_1_A = mkA "sliddrig" ; -- sliddrig..av.1
  sliddrighet_1_N = mkN "sliddrighet" ; -- sliddrighet..nn.1
  slidhornsdjur_1_N = mkN "slidhornsdjur" neutrum  ; -- slidhornsdjur..nn.1
  slidkniv_1_N = mkN "slidkniv" ; -- slidkniv..nn.1
  slidkrans_1_N = mkN "slidkrans" ; -- slidkrans..nn.1
  slidmotor_1_N = mkN "slidmotor" "slidmotorer" ; -- slidmotor..nn.1
  slig_1_N = mkN "slig" ; -- slig..nn.1
  slikta_1_V = mkV "sliktar" ; -- slikta..vb.1
  sliktande_1_N = mkN "sliktande" ; -- sliktande..nn.1
  slimmad_1_A = mkA "slimmad" ; -- slimmad..av.1
  slinder_1_N = mkN "slinder" neutrum  ; -- slinder..nn.1
  sling_1_N = mkN "sling" neutrum  ; -- sling..nn.1
  slinga_1_N = mkN "slinga" ; -- slinga..nn.1
  slingerbord_1_N = mkN "slingerbord" neutrum  ; -- slingerbord..nn.1
  slingerbult_1_N = mkN "slingerbult" ; -- slingerbult..nn.1
  slingerkoj_1_N = mkN "slingerkoj" "slingerkojer" ; -- slingerkoj..nn.1
  slingerköl_1_N = mkN "slingerköl" ; -- slingerköl..nn.1
  slingerskott_1_N = mkN "slingerskott" neutrum  ; -- slingerskott..nn.1
  slingerväxt_1_N = mkN "slingerväxt" "slingerväxter" ; -- slingerväxt..nn.1
  slingra_1_V = mkV "slingrar" ; -- slingra..vb.1
  slingrande_1_N = mkN "slingrande" ; -- slingrande..nn.1
  slingrig_1_A = mkA "slingrig" ; -- slingrig..av.1
  slingrighet_1_N = mkN "slingrighet" ; -- slingrighet..nn.1
  slinka_1_N = mkN "slinka" ; -- slinka..nn.1
  slinka_1_V = mkV "slinka" "slank" "slunkit" ; -- slinka..vb.1
  slinkande_1_N = mkN "slinkande" ; -- slinkande..nn.1
  slinkig_1_A = mkA "slinkig" ; -- slinkig..av.1
  slinkighet_1_N = mkN "slinkighet" ; -- slinkighet..nn.1
  slinkled_1_N = mkN "slinkled" "slinkleder" ; -- slinkled..nn.1
  slinta_1_V = mkV "slinta" "slant" "sluntit" ; -- slinta..vb.1
  slintande_1_N = mkN "slintande" ; -- slintande..nn.1
  slintning_1_N = mkN "slintning" ; -- slintning..nn.1
  slip_1_N = mkN "slip" ; -- slip..nn.1
  slipa_1_V = mkV "slipar" ; -- slipa..vb.1
  slipad_1_A = mkA "slipad" ; -- slipad..av.1
  slipande_1_N = mkN "slipande" ; -- slipande..nn.1
  sliper_1_N = mkN "sliper" ; -- sliper..nn.1
  sliperi_1_N = mkN "sliperi" "sliperiet" "sliperier" "sliperierna" ; -- sliperi..nn.1
  slipersolja_1_N = mkN "slipersolja" ; -- slipersolja..nn.1
  slipkloss_1_N = mkN "slipkloss" ; -- slipkloss..nn.1
  slipmaskin_1_N = mkN "slipmaskin" "slipmaskiner" ; -- slipmaskin..nn.1
  slipmassa_1_N = mkN "slipmassa" ; -- slipmassa..nn.1
  slipmedel_1_N = mkN "slipmedel" neutrum  ; -- slipmedel..nn.1
  slipning_1_N = mkN "slipning" ; -- slipning..nn.1
  slipover_1_N = mkN "slipover" ; -- slipover..nn.1
  slippa_1_V = mkV "slippa" "slapp" "sluppit" ; -- slippa..vb.1
  slippande_1_N = mkN "slippande" ; -- slippande..nn.1
  slippapper_1_N = mkN "slippapper" neutrum  ; -- slippapper..nn.1
  slippasta_1_N = mkN "slippasta" ; -- slippasta..nn.1
  slipprig_1_A = mkA "slipprig" ; -- slipprig..av.1
  slipprighet_1_N = mkN "slipprighet" "slipprigheter" ; -- slipprighet..nn.1
  slipprov_1_N = mkN "slipprov" neutrum  ; -- slipprov..nn.1
  slipresultat_1_N = mkN "slipresultat" neutrum  ; -- slipresultat..nn.1
  slips_1_N = mkN "slips" ; -- slips..nn.1
  slipsknut_1_N = mkN "slipsknut" ; -- slipsknut..nn.1
  slipsnitt_1_N = mkN "slipsnitt" neutrum  ; -- slipsnitt..nn.1
  slipsten_1_N = mkN "slipsten" "slipstenen" "slipstenar" "slipstenarna" ; -- slipsten..nn.1
  slipstvång_1_N = mkN "slipstvång" neutrum  ; -- slipstvång..nn.1
  slipsval_1_N = mkN "slipsval" neutrum  ; -- slipsval..nn.1
  slipsvamp_1_N = mkN "slipsvamp" ; -- slipsvamp..nn.1
  slira_1_N = mkN "slira" ; -- slira..nn.1
  slira_1_V = mkV "slirar" ; -- slira..vb.1
  slirande_1_N = mkN "slirande" ; -- slirande..nn.1
  slirig_1_A = mkA "slirig" ; -- slirig..av.1
  slirighet_1_N = mkN "slirighet" ; -- slirighet..nn.1
  slirighet_2_N = mkN "slirighet" "slirigheter" ; -- slirighet..nn.2
  slirkoppling_1_N = mkN "slirkoppling" ; -- slirkoppling..nn.1
  slirning_1_N = mkN "slirning" ; -- slirning..nn.1
  slirskydd_1_N = mkN "slirskydd" neutrum  ; -- slirskydd..nn.1
  slisk_1_N = mkN "slisk" neutrum  ; -- slisk..nn.1
  sliskig_1_A = mkA "sliskig" ; -- sliskig..av.1
  sliskighet_1_N = mkN "sliskighet" ; -- sliskighet..nn.1
  slit_1_N = mkN "slit" neutrum  ; -- slit..nn.1
  slita_1_V = mkV "slita" "slet" "slitit" ; -- slita..vb.1
  slitage_1_N = mkN "slitage" ; -- slitage..nn.1
  slitande_1_N = mkN "slitande" ; -- slitande..nn.1
  slitbana_1_N = mkN "slitbana" ; -- slitbana..nn.1
  sliten_1_A = mkA "sliten" ; -- sliten..av.1
  slitig_1_A = mkA "slitig" ; -- slitig..av.1
  slitlager_1_N = mkN "slitlager" neutrum  ; -- slitlager..nn.1
  slitning_1_N = mkN "slitning" ; -- slitning..nn.1
  slits_1_N = mkN "slits" ; -- slits..nn.1
  slitsa_1_V = mkV "slitsar" ; -- slitsa..vb.1
  slitsam_1_A = mkA "slitsam" "slitsamt" "slitsamma" "slitsamma" "slitsammare" "slitsammast" "slitsammaste" ; -- slitsam..av.1
  slitsamhet_1_N = mkN "slitsamhet" ; -- slitsamhet..nn.1
  slitsande_1_N = mkN "slitsande" ; -- slitsande..nn.1
  slitskydd_1_N = mkN "slitskydd" neutrum  ; -- slitskydd..nn.1
  slitstark_1_A = mkA "slitstark" ; -- slitstark..av.1
  slitstarkhet_1_N = mkN "slitstarkhet" ; -- slitstarkhet..nn.1
  slittålig_1_A = mkA "slittålig" ; -- slittålig..av.1
  slittålighet_1_N = mkN "slittålighet" ; -- slittålighet..nn.1
  slitvarg_1_N = mkN "slitvarg" ; -- slitvarg..nn.1
  slityta_1_N = mkN "slityta" ; -- slityta..nn.1
  slivovica_1_N = mkN "slivovica" ; -- slivovica..nn.1
  slivovice_1_N = mkN "slivovice" utrum  ; -- slivovice..nn.1
  slivovits_1_N = mkN "slivovits" ; -- slivovits..nn.1
  slivovitz_1_N = mkN "slivovitz" ; -- slivovitz..nn.1
  sliwowitz_1_N = mkN "sliwowitz" ; -- sliwowitz..nn.1
  slockna_1_V = mkV "slocknar" ; -- slockna..vb.1
  slocknande_1_N = mkN "slocknande" ; -- slocknande..nn.1
  slog_1_N = mkN "slog" ; -- slog..nn.1
  slogan_1_N = mkN "slogan" "sloganen" "slogans" "slogansen" ; -- slogan..nn.1
  slok_1_N = mkN "slok" ; -- slok..nn.1
  sloka_1_V = mkV "slokar" ; -- sloka..vb.1
  slokande_1_N = mkN "slokande" ; -- slokande..nn.1
  slokhatt_1_N = mkN "slokhatt" ; -- slokhatt..nn.1
  slokig_1_A = mkA "slokig" ; -- slokig..av.1
  slokörad_1_A = mkA "slokörad" ; -- slokörad..av.1
  slom_1_N = mkN "slom" "slommen" "slommar" "slommarna" ; -- slom..nn.1
  slopa_1_V = mkV "slopar" ; -- slopa..vb.1
  slopande_1_N = mkN "slopande" ; -- slopande..nn.1
  slopning_1_N = mkN "slopning" ; -- slopning..nn.1
  slosill_1_N = mkN "slosill" ; -- slosill..nn.1
  slot_1_N = mkN "slot" ; -- slot..nn.1
  slott_1_N = mkN "slott" neutrum  ; -- slott..nn.1
  slott_2_N = mkN "slott" ; -- slott..nn.2
  slottsbrand_1_N = mkN "slottsbrand" "slottsbränder" ; -- slottsbrand..nn.1
  slottsfru_1_N = mkN "slottsfru" ; -- slottsfru..nn.1
  slottsherre_1_N = mkN "slottsherre" utrum  ; -- slottsherre..nn.1
  slottsknekt_1_N = mkN "slottsknekt" ; -- slottsknekt..nn.1
  slottskyrka_1_N = mkN "slottskyrka" ; -- slottskyrka..nn.1
  slottslik_1_A = mkA "slottslik" ; -- slottslik..av.1
  slottslikhet_1_N = mkN "slottslikhet" ; -- slottslikhet..nn.1
  slottsliknande_1_A = mkA "slottsliknande" ; -- slottsliknande..av.1
  slottspark_1_N = mkN "slottspark" "slottsparker" ; -- slottspark..nn.1
  slottsruin_1_N = mkN "slottsruin" "slottsruiner" ; -- slottsruin..nn.1
  slottssal_1_N = mkN "slottssal" ; -- slottssal..nn.1
  slottsstek_1_N = mkN "slottsstek" ; -- slottsstek..nn.1
  slottstappad_1_A = mkA "slottstappad" ; -- slottstappad..av.1
  slottsvallgrav_1_N = mkN "slottsvallgrav" ; -- slottsvallgrav..nn.1
  slottsvin_1_N = mkN "slottsvin" "slottsvinet" "slottsviner" "slottsvinerna" ; -- slottsvin..nn.1
  slovak_1_N = mkN "slovak" "slovaker" ; -- slovak..nn.1
  slovakisk_1_A = mkA "slovakisk" ; -- slovakisk..av.1
  slovakiska_1_N = mkN "slovakiska" ; -- slovakiska..nn.1
  slovakiska_2_N = mkN "slovakiska" ; -- slovakiska..nn.2
  sloven_1_N = mkN "sloven" "slovener" ; -- sloven..nn.1
  slovensk_1_A = mkA "slovensk" ; -- slovensk..av.1
  slovenska_1_N = mkN "slovenska" ; -- slovenska..nn.1
  slovenska_2_N = mkN "slovenska" ; -- slovenska..nn.2
  slow_fox_1_N = mkN "slow-fox" ; -- slow-fox..nn.1
  slubb_1_N = mkN "slubb" ; -- slubb..nn.1
  slubba_1_V = mkV "slubbar" ; -- slubba..vb.1
  slubbande_1_N = mkN "slubbande" ; -- slubbande..nn.1
  sludder_1_N = mkN "sludder" neutrum  ; -- sludder..nn.1
  sluddra_1_V = mkV "sluddrar" ; -- sluddra..vb.1
  sluddrande_1_N = mkN "sluddrande" ; -- sluddrande..nn.1
  sluddrig_1_A = mkA "sluddrig" ; -- sluddrig..av.1
  sluddrighet_1_N = mkN "sluddrighet" ; -- sluddrighet..nn.1
  slug_1_A = mkA "slug" ; -- slug..av.1
  slugga_1_V = mkV "sluggar" ; -- slugga..vb.1
  sluggande_1_N = mkN "sluggande" ; -- sluggande..nn.1
  slugger_1_N = mkN "slugger" ; -- slugger..nn.1
  sluggermässig_1_A = mkA "sluggermässig" ; -- sluggermässig..av.1
  slughet_1_N = mkN "slughet" "slugheter" ; -- slughet..nn.1
  slughuvud_1_N = mkN "slughuvud" "slughuvudet" "slughuvud" "slughuvudena" ; -- slughuvud..nn.1
  sluka_1_V = mkV "slukar" ; -- sluka..vb.1
  slukande_1_N = mkN "slukande" ; -- slukande..nn.1
  slukhål_1_N = mkN "slukhål" neutrum  ; -- slukhål..nn.1
  slukrist_1_N = mkN "slukrist" ; -- slukrist..nn.1
  slumområde_1_N = mkN "slumområde" ; -- slumområde..nn.1
  slump_1_N = mkN "slump" ; -- slump..nn.1
  slump_2_N = mkN "slump" ; -- slump..nn.2
  slumpa_1_V = mkV "slumpar" ; -- slumpa..vb.1
  slumpande_1_N = mkN "slumpande" ; -- slumpande..nn.1
  slumpartad_1_A = mkA "slumpartad" ; -- slumpartad..av.1
  slumpmässig_1_A = mkA "slumpmässig" ; -- slumpmässig..av.1
  slumpmässighet_1_N = mkN "slumpmässighet" ; -- slumpmässighet..nn.1
  slumptal_1_N = mkN "slumptal" neutrum  ; -- slumptal..nn.1
  slumpurval_1_N = mkN "slumpurval" neutrum  ; -- slumpurval..nn.1
  slumpvis_1_Adv = mkAdv "slumpvis" ; -- slumpvis..ab.1
  slumpvis_1_A = mkA "slumpvis" "slumpvit" ; -- slumpvis..av.1
  slumra_1_V = mkV "slumrar" ; -- slumra..vb.1
  slumrande_1_A = mkA "slumrande" ; -- slumrande..av.1
  slumrande_1_N = mkN "slumrande" ; -- slumrande..nn.1
  slumsyster_1_N = mkN "slumsyster" ; -- slumsyster..nn.1
  slunga_1_N = mkN "slunga" ; -- slunga..nn.1
  slunga_1_V = mkV "slungar" ; -- slunga..vb.1
  slungande_1_N = mkN "slungande" ; -- slungande..nn.1
  slungboll_1_N = mkN "slungboll" ; -- slungboll..nn.1
  slungning_1_N = mkN "slungning" ; -- slungning..nn.1
  slup_1_N = mkN "slup" ; -- slup..nn.1
  slurfa_1_V = mkV "slurfar" ; -- slurfa..vb.1
  sluring_1_N = mkN "sluring" ; -- sluring..nn.1
  slurk_1_N = mkN "slurk" ; -- slurk..nn.1
  slurpa_1_V = mkV "slurpar" ; -- slurpa..vb.1
  slurpande_1_N = mkN "slurpande" ; -- slurpande..nn.1
  slurpning_1_N = mkN "slurpning" ; -- slurpning..nn.1
  slusk_1_N = mkN "slusk" ; -- slusk..nn.1
  sluskig_1_A = mkA "sluskig" ; -- sluskig..av.1
  sluskighet_1_N = mkN "sluskighet" ; -- sluskighet..nn.1
  sluss_1_N = mkN "sluss" ; -- sluss..nn.1
  slussa_1_V = mkV "slussar" ; -- slussa..vb.1
  slussande_1_N = mkN "slussande" ; -- slussande..nn.1
  slusshuvud_1_N = mkN "slusshuvud" "slusshuvudet" "slusshuvud" "slusshuvudena" ; -- slusshuvud..nn.1
  slussport_1_N = mkN "slussport" ; -- slussport..nn.1
  slusstrappa_1_N = mkN "slusstrappa" ; -- slusstrappa..nn.1
  slut_1_A = mkA "slut" ; -- slut..av.1
  slut_1_N = mkN "slut" neutrum  ; -- slut..nn.1
  sluta_1_V = mkV "slutar" ; -- sluta..vb.1
  sluta_3_V = mkV "sluta" "slöt" "slutit" ; -- sluta..vb.3
  slutackord_1_N = mkN "slutackord" neutrum  ; -- slutackord..nn.1
  slutakt_1_N = mkN "slutakt" "slutakter" ; -- slutakt..nn.1
  slutande_1_N = mkN "slutande" ; -- slutande..nn.1
  slutanförande_1_N = mkN "slutanförande" ; -- slutanförande..nn.1
  slutare_1_N = mkN "slutare" utrum  ; -- slutare..nn.1
  slutartikel_1_N = mkN "slutartikel" ; -- slutartikel..nn.1
  slutbehandla_1_V = mkV "slutbehandlar" ; -- slutbehandla..vb.1
  slutbehandlande_1_N = mkN "slutbehandlande" ; -- slutbehandlande..nn.1
  slutbehandling_1_N = mkN "slutbehandling" ; -- slutbehandling..nn.1
  sluteffekt_1_N = mkN "sluteffekt" "sluteffekter" ; -- sluteffekt..nn.1
  sluten_1_A = mkA "sluten" ; -- sluten..av.1
  slutenhet_1_N = mkN "slutenhet" ; -- slutenhet..nn.1
  slutenvård_1_N = mkN "slutenvård" ; -- slutenvård..nn.1
  slutfall_1_N = mkN "slutfall" neutrum  ; -- slutfall..nn.1
  slutfas_1_N = mkN "slutfas" "slutfaser" ; -- slutfas..nn.1
  slutfåra_1_N = mkN "slutfåra" ; -- slutfåra..nn.1
  slutföra_1_V = mkV "slutföra" "slutförde" "slutfört" ; -- slutföra..vb.1
  slutförande_1_N = mkN "slutförande" ; -- slutförande..nn.1
  slutförvar_1_N = mkN "slutförvar" neutrum  ; -- slutförvar..nn.1
  slutförvara_1_V = mkV "slutförvarar" ; -- slutförvara..vb.1
  slutförvarande_1_N = mkN "slutförvarande" ; -- slutförvarande..nn.1
  slutförvaring_1_N = mkN "slutförvaring" ; -- slutförvaring..nn.1
  slutförvaringsanläggning_1_N = mkN "slutförvaringsanläggning" ; -- slutförvaringsanläggning..nn.1
  slutgiltig_1_A = mkA "slutgiltig" ; -- slutgiltig..av.1
  slutgiltighet_1_N = mkN "slutgiltighet" ; -- slutgiltighet..nn.1
  slutkläm_1_N = mkN "slutkläm" "slutklämmen" "slutklämmar" "slutklämmarna" ; -- slutkläm..nn.1
  slutknorr_1_N = mkN "slutknorr" ; -- slutknorr..nn.1
  slutkörd_1_A = mkA "slutkörd" "slutkört" ; -- slutkörd..av.1
  slutkördhet_1_N = mkN "slutkördhet" ; -- slutkördhet..nn.1
  slutledning_1_N = mkN "slutledning" ; -- slutledning..nn.1
  slutledningsförmåga_1_N = mkN "slutledningsförmåga" ; -- slutledningsförmåga..nn.1
  slutlig_1_A = mkA "slutlig" ; -- slutlig..av.1
  slutligen_1_Adv = mkAdv "slutligen" ; -- slutligen..ab.1
  slutlighet_1_N = mkN "slutlighet" ; -- slutlighet..nn.1
  slutlikvid_1_N = mkN "slutlikvid" "slutlikvider" ; -- slutlikvid..nn.1
  slutljud_1_N = mkN "slutljud" neutrum  ; -- slutljud..nn.1
  slutlön_1_N = mkN "slutlön" "slutlöner" ; -- slutlön..nn.1
  slutminut_1_N = mkN "slutminut" "slutminuten" "slutminutrar" "slutminutrarna" ; -- slutminut..nn.1
  slutmuskel_1_N = mkN "slutmuskel" "slutmuskeln" "slutmuskler" "slutmusklerna" ; -- slutmuskel..nn.1
  slutmål_1_N = mkN "slutmål" neutrum  ; -- slutmål..nn.1
  slutnota_1_N = mkN "slutnota" ; -- slutnota..nn.1
  slutoffensiv_1_N = mkN "slutoffensiv" "slutoffensiver" ; -- slutoffensiv..nn.1
  slutomdöme_1_N = mkN "slutomdöme" ; -- slutomdöme..nn.1
  slutplädera_1_V = mkV "slutpläderar" ; -- slutplädera..vb.1
  slutpläderande_1_N = mkN "slutpläderande" ; -- slutpläderande..nn.1
  slutplädering_1_N = mkN "slutplädering" ; -- slutplädering..nn.1
  slutprodukt_1_N = mkN "slutprodukt" "slutprodukter" ; -- slutprodukt..nn.1
  slutprov_1_N = mkN "slutprov" neutrum  ; -- slutprov..nn.1
  slutpunkt_1_N = mkN "slutpunkt" "slutpunkter" ; -- slutpunkt..nn.1
  slutrad_1_N = mkN "slutrad" "slutrader" ; -- slutrad..nn.1
  slutresultat_1_N = mkN "slutresultat" neutrum  ; -- slutresultat..nn.1
  slutrim_1_N = mkN "slutrim" "slutrimmet" "slutrim" "slutrimmen" ; -- slutrim..nn.1
  slutsats_1_N = mkN "slutsats" "slutsatser" ; -- slutsats..nn.1
  slutskede_1_N = mkN "slutskede" ; -- slutskede..nn.1
  slutskrift_1_N = mkN "slutskrift" "slutskrifter" ; -- slutskrift..nn.1
  slutskämtad_1_A = mkA "slutskämtad" ; -- slutskämtad..av.1
  slutspel_1_N = mkN "slutspel" "slutspelet" "slutspel" "slutspelen" ; -- slutspel..nn.1
  slutspelad_1_A = mkA "slutspelad" ; -- slutspelad..av.1
  slutspurt_1_N = mkN "slutspurt" "slutspurter" ; -- slutspurt..nn.1
  slutstadium_1_N = mkN "slutstadium" "slutstadiet" "slutstadier" "slutstadierna" ; -- slutstadium..nn.1
  slutstation_1_N = mkN "slutstation" ; -- slutstation..nn.1
  slutsteg_1_N = mkN "slutsteg" neutrum  ; -- slutsteg..nn.1
  slutsten_1_N = mkN "slutsten" "slutstenen" "slutstenar" "slutstenarna" ; -- slutsten..nn.1
  slutstreck_1_N = mkN "slutstreck" neutrum  ; -- slutstreck..nn.1
  slutsträcka_1_N = mkN "slutsträcka" ; -- slutsträcka..nn.1
  slutstycke_1_N = mkN "slutstycke" ; -- slutstycke..nn.1
  slutställning_1_N = mkN "slutställning" ; -- slutställning..nn.1
  slutsumma_1_N = mkN "slutsumma" ; -- slutsumma..nn.1
  slutsåld_1_A = mkA "slutsåld" "slutsålt" ; -- slutsåld..av.1
  slutta_1_V = mkV "sluttar" ; -- slutta..vb.1
  sluttamp_1_N = mkN "sluttamp" ; -- sluttamp..nn.1
  sluttande_1_N = mkN "sluttande" ; -- sluttande..nn.1
  sluttid_1_N = mkN "sluttid" "sluttider" ; -- sluttid..nn.1
  sluttning_1_N = mkN "sluttning" ; -- sluttning..nn.1
  slutuppgörelse_1_N = mkN "slutuppgörelse" "slutuppgörelser" ; -- slutuppgörelse..nn.1
  slutvinjett_1_N = mkN "slutvinjett" "slutvinjetter" ; -- slutvinjett..nn.1
  slutvokal_1_N = mkN "slutvokal" "slutvokaler" ; -- slutvokal..nn.1
  sly_1_N = mkN "sly" "slyt" "slyn" "slyna" ; -- sly..nn.1
  slya_1_N = mkN "slya" ; -- slya..nn.1
  slyklinga_1_N = mkN "slyklinga" ; -- slyklinga..nn.1
  slyna_1_N = mkN "slyna" ; -- slyna..nn.1
  slynga_1_N = mkN "slynga" ; -- slynga..nn.1
  slyngel_1_N = mkN "slyngel" ; -- slyngel..nn.1
  slynig_1_A = mkA "slynig" ; -- slynig..av.1
  slypinne_1_N = mkN "slypinne" utrum  ; -- slypinne..nn.1
  släcka_1_V = mkV "släcker" ; -- släcka..vb.1
  släckande_1_N = mkN "släckande" ; -- släckande..nn.1
  släckning_1_N = mkN "släckning" ; -- släckning..nn.1
  släckningsarbete_1_N = mkN "släckningsarbete" ; -- släckningsarbete..nn.1
  släddon_1_N = mkN "släddon" neutrum  ; -- släddon..nn.1
  släde_1_N = mkN "släde" utrum  ; -- släde..nn.1
  slädföre_1_N = mkN "slädföre" ; -- slädföre..nn.1
  slädhund_1_N = mkN "slädhund" ; -- slädhund..nn.1
  slädmed_1_N = mkN "slädmed" ; -- slädmed..nn.1
  slädparti_1_N = mkN "slädparti" "slädpartiet" "slädpartier" "slädpartierna" ; -- slädparti..nn.1
  slägga_1_N = mkN "slägga" ; -- slägga..nn.1
  slägga_1_V = mkV "släggar" ; -- slägga..vb.1
  släggande_1_N = mkN "släggande" ; -- släggande..nn.1
  slägghammare_1_N = mkN "slägghammare" "slägghammaren" "slägghammare" "slägghamrarna" ; -- slägghammare..nn.1
  släkt_1_A = mkA "släkt" ; -- släkt..av.1
  släkt_1_N = mkN "släkt" "släkter" ; -- släkt..nn.1
  släktband_1_N = mkN "släktband" neutrum  ; -- släktband..nn.1
  släktbesök_1_N = mkN "släktbesök" neutrum  ; -- släktbesök..nn.1
  släktdrag_1_N = mkN "släktdrag" neutrum  ; -- släktdrag..nn.1
  släktdrift_1_N = mkN "släktdrift" "släktdrifter" ; -- släktdrift..nn.1
  släkte_1_N = mkN "släkte" ; -- släkte..nn.1
  släktfejd_1_N = mkN "släktfejd" "släktfejder" ; -- släktfejd..nn.1
  släktforska_1_V = mkV "släktforskar" ; -- släktforska..vb.1
  släktforskande_1_N = mkN "släktforskande" ; -- släktforskande..nn.1
  släktforskning_1_N = mkN "släktforskning" ; -- släktforskning..nn.1
  släktföljd_1_N = mkN "släktföljd" ; -- släktföljd..nn.1
  släktgemenskap_1_N = mkN "släktgemenskap" "släktgemenskaper" ; -- släktgemenskap..nn.1
  släktgren_1_N = mkN "släktgren" "släktgrenen" "släktgrenar" "släktgrenarna" ; -- släktgren..nn.1
  släktgård_1_N = mkN "släktgård" ; -- släktgård..nn.1
  släkthistoria_1_N = mkN "släkthistoria" "släkthistorian" "släkthistorier" "släkthistorierna" ; -- släkthistoria..nn.1
  släkting_1_N = mkN "släkting" ; -- släkting..nn.1
  släktkalas_1_N = mkN "släktkalas" neutrum  ; -- släktkalas..nn.1
  släktklenod_1_N = mkN "släktklenod" "släktklenoder" ; -- släktklenod..nn.1
  släktkrönika_1_N = mkN "släktkrönika" ; -- släktkrönika..nn.1
  släktkär_1_A = mkA "släktkär" ; -- släktkär..av.1
  släktkärlek_1_N = mkN "släktkärlek" ; -- släktkärlek..nn.1
  släktled_1_N = mkN "släktled" neutrum  ; -- släktled..nn.1
  släktledning_1_N = mkN "släktledning" ; -- släktledning..nn.1
  släktlinje_1_N = mkN "släktlinje" "släktlinjer" ; -- släktlinje..nn.1
  släktmässig_1_A = mkA "släktmässig" ; -- släktmässig..av.1
  släktnamn_1_N = mkN "släktnamn" neutrum  ; -- släktnamn..nn.1
  släktporträtt_1_N = mkN "släktporträtt" neutrum  ; -- släktporträtt..nn.1
  släktregister_1_N = mkN "släktregister" neutrum  ; -- släktregister..nn.1
  släktsaga_1_N = mkN "släktsaga" ; -- släktsaga..nn.1
  släktskap_1_N = mkN "släktskap" ; -- släktskap..nn.1
  släktskapsband_1_N = mkN "släktskapsband" neutrum  ; -- släktskapsband..nn.1
  släktskapsförhållande_1_N = mkN "släktskapsförhållande" ; -- släktskapsförhållande..nn.1
  släktskapsträd_1_N = mkN "släktskapsträd" neutrum  ; -- släktskapsträd..nn.1
  släktspråk_1_N = mkN "släktspråk" neutrum  ; -- släktspråk..nn.1
  släkttavla_1_N = mkN "släkttavla" ; -- släkttavla..nn.1
  släktträd_1_N = mkN "släktträd" neutrum  ; -- släktträd..nn.1
  släkttycke_1_N = mkN "släkttycke" ; -- släkttycke..nn.1
  släktvapen_1_N = mkN "släktvapen" "släktvapnet" "släktvapen" "släktvapnen" ; -- släktvapen..nn.1
  slända_1_N = mkN "slända" ; -- slända..nn.1
  sländlarv_1_N = mkN "sländlarv" "sländlarver" ; -- sländlarv..nn.1
  sländtrissa_1_N = mkN "sländtrissa" ; -- sländtrissa..nn.1
  släng_1_N = mkN "släng" ; -- släng..nn.1
  slänga_1_V = mkV "slänger" ; -- slänga..vb.1
  slängande_1_N = mkN "slängande" ; -- slängande..nn.1
  slängd_1_A = mkA "slängd" "slängt" ; -- slängd..av.1
  slänggunga_1_N = mkN "slänggunga" ; -- slänggunga..nn.1
  slängig_1_A = mkA "slängig" ; -- slängig..av.1
  slängighet_1_N = mkN "slängighet" ; -- slängighet..nn.1
  slängkappa_1_N = mkN "slängkappa" ; -- slängkappa..nn.1
  slängkyss_1_N = mkN "slängkyss" ; -- slängkyss..nn.1
  slängkälke_1_N = mkN "slängkälke" utrum  ; -- slängkälke..nn.1
  slängning_1_N = mkN "slängning" ; -- slängning..nn.1
  slängpolska_1_N = mkN "slängpolska" ; -- slängpolska..nn.1
  slängskopa_1_N = mkN "slängskopa" ; -- slängskopa..nn.1
  slängskott_1_N = mkN "slängskott" neutrum  ; -- slängskott..nn.1
  slänt_1_N = mkN "slänt" "slänter" ; -- slänt..nn.1
  släntra_1_V = mkV "släntrar" ; -- släntra..vb.1
  släntrande_1_N = mkN "släntrande" ; -- släntrande..nn.1
  släp_1_N = mkN "släp" neutrum  ; -- släp..nn.1
  släpa_1_V = mkV "släpar" ; -- släpa..vb.1
  släpande_1_N = mkN "släpande" ; -- släpande..nn.1
  släpankare_1_N = mkN "släpankare" "släpankaret" "släpankaren" "släpankarna" ; -- släpankare..nn.1
  släpig_1_A = mkA "släpig" ; -- släpig..av.1
  släpighet_1_N = mkN "släpighet" ; -- släpighet..nn.1
  släpkontakt_1_N = mkN "släpkontakt" "släpkontakter" ; -- släpkontakt..nn.1
  släpkärra_1_N = mkN "släpkärra" ; -- släpkärra..nn.1
  släplift_1_N = mkN "släplift" ; -- släplift..nn.1
  släplina_1_N = mkN "släplina" ; -- släplina..nn.1
  släpljus_1_N = mkN "släpljus" neutrum  ; -- släpljus..nn.1
  släplogg_1_N = mkN "släplogg" ; -- släplogg..nn.1
  släpnot_1_N = mkN "släpnot" ; -- släpnot..nn.1
  släpp_1_N = mkN "släpp" neutrum  ; -- släpp..nn.1
  släppa_1_V = mkV "släpper" ; -- släppa..vb.1
  släppande_1_N = mkN "släppande" ; -- släppande..nn.1
  släppfest_1_N = mkN "släppfest" "släppfester" ; -- släppfest..nn.1
  släpphänt_1_A = mkA "släpphänt" "släpphänt" ; -- släpphänt..av.1
  släpphänthet_1_N = mkN "släpphänthet" ; -- släpphänthet..nn.1
  släpring_1_N = mkN "släpring" ; -- släpring..nn.1
  släpsam_1_A = mkA "släpsam" "släpsamt" "släpsamma" "släpsamma" "släpsammare" "släpsammast" "släpsammaste" ; -- släpsam..av.1
  släpsamhet_1_N = mkN "släpsamhet" ; -- släpsamhet..nn.1
  släpsko_1_N = mkN "släpsko" "släpskor" ; -- släpsko..nn.1
  släpvad_1_N = mkN "släpvad" ; -- släpvad..nn.1
  släpvagn_1_N = mkN "släpvagn" ; -- släpvagn..nn.1
  släpvagnskoppling_1_N = mkN "släpvagnskoppling" ; -- släpvagnskoppling..nn.1
  slät_1_A = mkA "slät" ; -- slät..av.1
  släta_1_V = mkV "slätar" ; -- släta..vb.1
  slätande_1_N = mkN "slätande" ; -- slätande..nn.1
  slätbana_1_N = mkN "slätbana" ; -- slätbana..nn.1
  slätborra_1_V = mkV "slätborrar" ; -- slätborra..vb.1
  slätborrande_1_N = mkN "slätborrande" ; -- slätborrande..nn.1
  slätborrning_1_N = mkN "slätborrning" ; -- slätborrning..nn.1
  slätfog_1_N = mkN "slätfog" ; -- slätfog..nn.1
  slätharv_1_N = mkN "slätharv" ; -- slätharv..nn.1
  släthet_1_N = mkN "släthet" ; -- släthet..nn.1
  släthugga_1_V = mkV "släthugga" "släthögg" "släthuggit" ; -- släthugga..vb.1
  släthuggande_1_N = mkN "släthuggande" ; -- släthuggande..nn.1
  släthuggning_1_N = mkN "släthuggning" ; -- släthuggning..nn.1
  släthyvla_1_V = mkV "släthyvlar" ; -- släthyvla..vb.1
  släthyvlande_1_N = mkN "släthyvlande" ; -- släthyvlande..nn.1
  släthyvling_1_N = mkN "släthyvling" ; -- släthyvling..nn.1
  släthårig_1_A = mkA "släthårig" ; -- släthårig..av.1
  släthårighet_1_N = mkN "släthårighet" ; -- släthårighet..nn.1
  slätkammad_1_A = mkA "slätkammad" ; -- slätkammad..av.1
  slätlöpning_1_N = mkN "slätlöpning" ; -- slätlöpning..nn.1
  slätning_1_N = mkN "slätning" ; -- slätning..nn.1
  slätprick_1_N = mkN "slätprick" ; -- slätprick..nn.1
  slätraka_1_V = mkV "slätrakar" ; -- slätraka..vb.1
  slätrakad_1_A = mkA "slätrakad" ; -- slätrakad..av.1
  slätrakande_1_N = mkN "slätrakande" ; -- slätrakande..nn.1
  slätriggad_1_A = mkA "slätriggad" ; -- slätriggad..av.1
  slätslipa_1_V = mkV "slätslipar" ; -- slätslipa..vb.1
  slätslipande_1_N = mkN "slätslipande" ; -- slätslipande..nn.1
  slätstickad_1_A = mkA "slätstickad" ; -- slätstickad..av.1
  slätstickning_1_N = mkN "slätstickning" ; -- slätstickning..nn.1
  slätstruken_1_A = mkA "slätstruken" ; -- slätstruken..av.1
  slätstryka_1_V = mkV "slätstryka" "slätströk" "slätstrukit" ; -- slätstryka..vb.1
  slätstrykande_1_N = mkN "slätstrykande" ; -- slätstrykande..nn.1
  slätstrykning_1_N = mkN "slätstrykning" ; -- slätstrykning..nn.1
  slätsvamp_1_N = mkN "slätsvamp" ; -- slätsvamp..nn.1
  slätt_1_N = mkN "slätt" "slätter" ; -- slätt..nn.1
  slättbygd_1_N = mkN "slättbygd" "slättbygder" ; -- slättbygd..nn.1
  slättland_1_N = mkN "slättland" neutrum  ; -- slättland..nn.1
  slättmark_1_N = mkN "slättmark" "slättmarker" ; -- slättmark..nn.1
  slättoppad_1_A = mkA "slättoppad" ; -- slättoppad..av.1
  slätvar_1_N = mkN "slätvar" ; -- slätvar..nn.1
  slätvälling_1_N = mkN "slätvälling" ; -- slätvälling..nn.1
  slå_1_N = mkN "slå" ; -- slå..nn.1
  slå_1_V = mkV "slå" "slog" "slagit" ; -- slå..vb.1
  slående_1_A = mkA "slående" ; -- slående..av.1
  slående_1_N = mkN "slående" ; -- slående..nn.1
  slån_1_N = mkN "slån" ; -- slån..nn.1
  slånbär_1_N = mkN "slånbär" neutrum  ; -- slånbär..nn.1
  slånbärsbuske_1_N = mkN "slånbärsbuske" utrum  ; -- slånbärsbuske..nn.1
  slåtta_1_N = mkN "slåtta" ; -- slåtta..nn.1
  slåtta_1_V = mkV "slåttar" ; -- slåtta..vb.1
  slåttande_1_N = mkN "slåttande" ; -- slåttande..nn.1
  slåtter_1_N = mkN "slåtter" ; -- slåtter..nn.1
  slåtterblomma_1_N = mkN "slåtterblomma" ; -- slåtterblomma..nn.1
  slåtterfest_1_N = mkN "slåtterfest" "slåtterfester" ; -- slåtterfest..nn.1
  slåtterkniv_1_N = mkN "slåtterkniv" ; -- slåtterkniv..nn.1
  slåttermaskin_1_N = mkN "slåttermaskin" "slåttermaskiner" ; -- slåttermaskin..nn.1
  slåttermyr_1_N = mkN "slåttermyr" ; -- slåttermyr..nn.1
  slåtteräng_1_N = mkN "slåtteräng" ; -- slåtteräng..nn.1
  slö_1_A = mkA "slö" "slött" ; -- slö..av.1
  slöa_1_V = mkV "slöar" ; -- slöa..vb.1
  slöande_1_N = mkN "slöande" ; -- slöande..nn.1
  slödder_1_N = mkN "slödder" neutrum  ; -- slödder..nn.1
  slödricka_1_N = mkN "slödricka" ; -- slödricka..nn.1
  slödryck_1_N = mkN "slödryck" ; -- slödryck..nn.1
  slöfock_1_N = mkN "slöfock" ; -- slöfock..nn.1
  slöhet_1_N = mkN "slöhet" "slöheter" ; -- slöhet..nn.1
  slöhet_2_N = mkN "slöhet" ; -- slöhet..nn.2
  slöja_1_N = mkN "slöja" ; -- slöja..nn.1
  slöjd_1_N = mkN "slöjd" "slöjder" ; -- slöjd..nn.1
  slöjda_1_V = mkV "slöjdar" ; -- slöjda..vb.1
  slöjdande_1_N = mkN "slöjdande" ; -- slöjdande..nn.1
  slöjdare_1_N = mkN "slöjdare" utrum  ; -- slöjdare..nn.1
  slöjdebatt_1_N = mkN "slöjdebatt" "slöjdebatter" ; -- slöjdebatt..nn.1
  slöjdkniv_1_N = mkN "slöjdkniv" ; -- slöjdkniv..nn.1
  slöjdspäntkniv_1_N = mkN "slöjdspäntkniv" ; -- slöjdspäntkniv..nn.1
  slöjförbud_1_N = mkN "slöjförbud" neutrum  ; -- slöjförbud..nn.1
  slöjig_1_A = mkA "slöjig" ; -- slöjig..av.1
  slöjliknande_1_A = mkA "slöjliknande" ; -- slöjliknande..av.1
  slöjmoln_1_N = mkN "slöjmoln" neutrum  ; -- slöjmoln..nn.1
  slöjskivling_1_N = mkN "slöjskivling" ; -- slöjskivling..nn.1
  slöjstjärt_1_N = mkN "slöjstjärt" ; -- slöjstjärt..nn.1
  slökorn_1_N = mkN "slökorn" neutrum  ; -- slökorn..nn.1
  slör_1_N = mkN "slör" ; -- slör..nn.1
  slör_2_N = mkN "slör" neutrum  ; -- slör..nn.2
  slöra_1_V = mkV "slörar" ; -- slöra..vb.1
  slörande_1_N = mkN "slörande" ; -- slörande..nn.1
  slösa_1_V = mkV "slösar" ; -- slösa..vb.1
  slösaktig_1_A = mkA "slösaktig" ; -- slösaktig..av.1
  slösaktighet_1_N = mkN "slösaktighet" ; -- slösaktighet..nn.1
  slösande_1_A = mkA "slösande" ; -- slösande..av.1
  slösande_1_N = mkN "slösande" ; -- slösande..nn.1
  slösare_1_N = mkN "slösare" utrum  ; -- slösare..nn.1
  slöseri_1_N = mkN "slöseri" neutrum  ; -- slöseri..nn.1
  slösig_1_A = mkA "slösig" ; -- slösig..av.1
  slösint_1_A = mkA "slösint" "slösint" ; -- slösint..av.1
  slösinthet_1_N = mkN "slösinthet" ; -- slösinthet..nn.1
  slösurfa_1_V = mkV "slösurfar" ; -- slösurfa..vb.1
  slösäd_1_N = mkN "slösäd" ; -- slösäd..nn.1
  slötitta_1_V = mkV "slötittar" ; -- slötitta..vb.1
  slötittande_1_N = mkN "slötittande" ; -- slötittande..nn.1
  smack_1_N = mkN "smack" ; -- smack..nn.1
  smack_2_N = mkN "smack" neutrum  ; -- smack..nn.2
  smacka_1_V = mkV "smackar" ; -- smacka..vb.1
  smackande_1_N = mkN "smackande" ; -- smackande..nn.1
  smackljud_1_N = mkN "smackljud" neutrum  ; -- smackljud..nn.1
  smackning_1_N = mkN "smackning" ; -- smackning..nn.1
  smajl_1_N = mkN "smajl" neutrum  ; -- smajl..nn.1
  smajlis_1_N = mkN "smajlis" ; -- smajlis..nn.1
  smak_1_N = mkN "smak" "smaker" ; -- smak..nn.1
  smaka_1_V = mkV "smakar" ; -- smaka..vb.1
  smaka_2_V = mkV "smakar" ; -- smaka..vb.2
  smakande_1_N = mkN "smakande" ; -- smakande..nn.1
  smakbit_1_N = mkN "smakbit" ; -- smakbit..nn.1
  smakdomare_1_N = mkN "smakdomare" utrum  ; -- smakdomare..nn.1
  smakfråga_1_N = mkN "smakfråga" ; -- smakfråga..nn.1
  smakfull_1_A = mkA "smakfull" ; -- smakfull..av.1
  smakfullhet_1_N = mkN "smakfullhet" "smakfullheter" ; -- smakfullhet..nn.1
  smakförstärkare_1_N = mkN "smakförstärkare" utrum  ; -- smakförstärkare..nn.1
  smaklig_1_A = mkA "smaklig" ; -- smaklig..av.1
  smaklighet_1_N = mkN "smaklighet" "smakligheter" ; -- smaklighet..nn.1
  smaklök_1_N = mkN "smaklök" ; -- smaklök..nn.1
  smaklös_1_A = mkA "smaklös" ; -- smaklös..av.1
  smaklöshet_1_N = mkN "smaklöshet" "smaklösheter" ; -- smaklöshet..nn.1
  smakmässig_1_A = mkA "smakmässig" ; -- smakmässig..av.1
  smaknerv_1_N = mkN "smaknerv" "smaknerver" ; -- smaknerv..nn.1
  smakorgan_1_N = mkN "smakorgan" neutrum  ; -- smakorgan..nn.1
  smakpanel_1_N = mkN "smakpanel" "smakpaneler" ; -- smakpanel..nn.1
  smakproblem_1_N = mkN "smakproblem" neutrum  ; -- smakproblem..nn.1
  smakprov_1_N = mkN "smakprov" neutrum  ; -- smakprov..nn.1
  smakrik_1_A = mkA "smakrik" ; -- smakrik..av.1
  smakriktning_1_N = mkN "smakriktning" ; -- smakriktning..nn.1
  smakråd_1_N = mkN "smakråd" neutrum  ; -- smakråd..nn.1
  smaksak_1_N = mkN "smaksak" "smaksaker" ; -- smaksak..nn.1
  smaksinne_1_N = mkN "smaksinne" ; -- smaksinne..nn.1
  smakstark_1_A = mkA "smakstark" ; -- smakstark..av.1
  smakstart_1_N = mkN "smakstart" "smakstarter" ; -- smakstart..nn.1
  smakstyrka_1_N = mkN "smakstyrka" ; -- smakstyrka..nn.1
  smaksätta_1_V = mkV "smaksätta" "smaksätter" "smaksätt" "smaksatte" "smaksatt" "smaksatt" ; -- smaksätta..vb.1
  smaksättande_1_N = mkN "smaksättande" ; -- smaksättande..nn.1
  smaksättning_1_N = mkN "smaksättning" ; -- smaksättning..nn.1
  smakupplevelse_1_N = mkN "smakupplevelse" "smakupplevelser" ; -- smakupplevelse..nn.1
  smakämne_1_N = mkN "smakämne" ; -- smakämne..nn.1
  smal_1_A = mkA "smal" ; -- smal..av.1
  smalben_1_N = mkN "smalben" neutrum  ; -- smalben..nn.1
  smaldjur_1_N = mkN "smaldjur" neutrum  ; -- smaldjur..nn.1
  smalfilm_1_N = mkN "smalfilm" "smalfilmer" ; -- smalfilm..nn.1
  smalfilma_1_V = mkV "smalfilmar" ; -- smalfilma..vb.1
  smalfilmande_1_N = mkN "smalfilmande" ; -- smalfilmande..nn.1
  smalhet_1_N = mkN "smalhet" ; -- smalhet..nn.1
  smalmeny_1_N = mkN "smalmeny" "smalmenyer" ; -- smalmeny..nn.1
  smalna_1_V = mkV "smalnar" ; -- smalna..vb.1
  smalnande_1_N = mkN "smalnande" ; -- smalnande..nn.1
  smalnäsapa_1_N = mkN "smalnäsapa" ; -- smalnäsapa..nn.1
  smalspårig_1_A = mkA "smalspårig" ; -- smalspårig..av.1
  smalspårighet_1_N = mkN "smalspårighet" ; -- smalspårighet..nn.1
  smalt_1_N = mkN "smalt" ; -- smalt..nn.1
  smalts_1_N = mkN "smalts" ; -- smalts..nn.1
  smalvägg_1_N = mkN "smalvägg" ; -- smalvägg..nn.1
  smalända_1_N = mkN "smalända" ; -- smalända..nn.1
  smalände_1_N = mkN "smalände" utrum  ; -- smalände..nn.1
  smaragd_1_N = mkN "smaragd" "smaragder" ; -- smaragd..nn.1
  smaragdfärgad_1_A = mkA "smaragdfärgad" ; -- smaragdfärgad..av.1
  smaragdgrön_1_A = mkA "smaragdgrön" ; -- smaragdgrön..av.1
  smarra_1_V = mkV "smarrar" ; -- smarra..vb.1
  smarrande_1_N = mkN "smarrande" ; -- smarrande..nn.1
  smarrig_1_A = mkA "smarrig" ; -- smarrig..av.1
  smarrighet_1_N = mkN "smarrighet" ; -- smarrighet..nn.1
  smart_1_A = mkA "smart" "smart" ; -- smart..av.1
  smarthet_1_N = mkN "smarthet" "smartheter" ; -- smarthet..nn.1
  smartmobil_1_N = mkN "smartmobil" "smartmobiler" ; -- smartmobil..nn.1
  smarto_1_N = mkN "smarto" "smartot" "smarton" "smartona" ; -- smarto..nn.1
  smartphone_1_N = mkN "smartphone" "smartphoner" ; -- smartphone..nn.1
  smarttelefon_1_N = mkN "smarttelefon" "smarttelefoner" ; -- smarttelefon..nn.1
  smash_1_N = mkN "smash" ; -- smash..nn.1
  smasha_1_V = mkV "smashar" ; -- smasha..vb.1
  smashande_1_N = mkN "smashande" ; -- smashande..nn.1
  smask_1_N = mkN "smask" neutrum  ; -- smask..nn.1
  smaska_1_V = mkV "smaskar" ; -- smaska..vb.1
  smaskande_1_N = mkN "smaskande" ; -- smaskande..nn.1
  smaskens_1_A = mkA "smaskens" ; -- smaskens..av.1
  smaskig_1_A = mkA "smaskig" ; -- smaskig..av.1
  smaskighet_1_N = mkN "smaskighet" "smaskigheter" ; -- smaskighet..nn.1
  smaskning_1_N = mkN "smaskning" ; -- smaskning..nn.1
  smatt_1_N = mkN "smatt" ; -- smatt..nn.1
  smatter_1_N = mkN "smatter" neutrum  ; -- smatter..nn.1
  smattra_1_V = mkV "smattrar" ; -- smattra..vb.1
  smattrande_1_N = mkN "smattrande" ; -- smattrande..nn.1
  smed_1_N = mkN "smed" "smeder" ; -- smed..nn.1
  smedhalva_1_N = mkN "smedhalva" ; -- smedhalva..nn.1
  smedja_1_N = mkN "smedja" ; -- smedja..nn.1
  smedlärling_1_N = mkN "smedlärling" ; -- smedlärling..nn.1
  smedslärling_1_N = mkN "smedslärling" ; -- smedslärling..nn.1
  smegma_1_N = mkN "smegma" ; -- smegma..nn.1
  smek_1_N = mkN "smek" neutrum  ; -- smek..nn.1
  smeka_1_N = mkN "smeka" ; -- smeka..nn.1
  smeka_1_V = mkV "smeker" ; -- smeka..vb.1
  smekande_1_N = mkN "smekande" ; -- smekande..nn.1
  smekfull_1_A = mkA "smekfull" ; -- smekfull..av.1
  smekmånad_1_N = mkN "smekmånad" "smekmånader" ; -- smekmånad..nn.1
  smekmånadslyx_1_N = mkN "smekmånadslyx" ; -- smekmånadslyx..nn.1
  smeknamn_1_N = mkN "smeknamn" neutrum  ; -- smeknamn..nn.1
  smekning_1_N = mkN "smekning" ; -- smekning..nn.1
  smekord_1_N = mkN "smekord" neutrum  ; -- smekord..nn.1
  smeksam_1_A = mkA "smeksam" "smeksamt" "smeksamma" "smeksamma" "smeksammare" "smeksammast" "smeksammaste" ; -- smeksam..av.1
  smeksamhet_1_N = mkN "smeksamhet" ; -- smeksamhet..nn.1
  smet_1_N = mkN "smet" "smeter" ; -- smet..nn.1
  smeta_1_V = mkV "smetar" ; -- smeta..vb.1
  smetana_1_N = mkN "smetana" ; -- smetana..nn.1
  smetande_1_N = mkN "smetande" ; -- smetande..nn.1
  smetig_1_A = mkA "smetig" ; -- smetig..av.1
  smetighet_1_N = mkN "smetighet" ; -- smetighet..nn.1
  smetning_1_N = mkN "smetning" ; -- smetning..nn.1
  smicker_1_N = mkN "smicker" neutrum  ; -- smicker..nn.1
  smickra_1_V = mkV "smickrar" ; -- smickra..vb.1
  smickrad_1_A = mkA "smickrad" ; -- smickrad..av.1
  smickrande_1_A = mkA "smickrande" ; -- smickrande..av.1
  smickrande_1_N = mkN "smickrande" ; -- smickrande..nn.1
  smickrare_1_N = mkN "smickrare" utrum  ; -- smickrare..nn.1
  smida_1_V = mkV "smida" "smidde" "smitt" ; -- smida..vb.1
  smidande_1_N = mkN "smidande" ; -- smidande..nn.1
  smidare_1_N = mkN "smidare" utrum  ; -- smidare..nn.1
  smidbar_1_A = mkA "smidbar" ; -- smidbar..av.1
  smidbarhet_1_N = mkN "smidbarhet" ; -- smidbarhet..nn.1
  smide_1_N = mkN "smide" ; -- smide..nn.1
  smideri_1_N = mkN "smideri" "smideriet" "smiderier" "smiderierna" ; -- smideri..nn.1
  smidesjärn_1_N = mkN "smidesjärn" neutrum  ; -- smidesjärn..nn.1
  smidesljusstake_1_N = mkN "smidesljusstake" utrum  ; -- smidesljusstake..nn.1
  smidespust_1_N = mkN "smidespust" ; -- smidespust..nn.1
  smidesverktyg_1_N = mkN "smidesverktyg" neutrum  ; -- smidesverktyg..nn.1
  smidig_1_A = mkA "smidig" ; -- smidig..av.1
  smidighet_1_N = mkN "smidighet" ; -- smidighet..nn.1
  smidjebälte_1_N = mkN "smidjebälte" ; -- smidjebälte..nn.1
  smil_1_N = mkN "smil" neutrum  ; -- smil..nn.1
  smila_1_V = mkV "smilar" ; -- smila..vb.1
  smilande_1_N = mkN "smilande" ; -- smilande..nn.1
  smilare_1_N = mkN "smilare" utrum  ; -- smilare..nn.1
  smiley_1_N = mkN "smiley" "smileyn" "smileys" "smileysarna" ; -- smiley..nn.1
  smilfink_1_N = mkN "smilfink" ; -- smilfink..nn.1
  smilgrop_1_N = mkN "smilgrop" ; -- smilgrop..nn.1
  smilig_1_A = mkA "smilig" ; -- smilig..av.1
  smilighet_1_N = mkN "smilighet" ; -- smilighet..nn.1
  smilsk_1_A = mkA "smilsk" ; -- smilsk..av.1
  smilskhet_1_N = mkN "smilskhet" ; -- smilskhet..nn.1
  smink_1_N = mkN "smink" "sminket" "sminker" "sminkerna" ; -- smink..nn.1
  sminka_1_V = mkV "sminkar" ; -- sminka..vb.1
  sminkande_1_N = mkN "sminkande" ; -- sminkande..nn.1
  sminkare_1_N = mkN "sminkare" utrum  ; -- sminkare..nn.1
  sminkerska_1_N = mkN "sminkerska" ; -- sminkerska..nn.1
  sminkexpert_1_N = mkN "sminkexpert" "sminkexperter" ; -- sminkexpert..nn.1
  sminkning_1_N = mkN "sminkning" ; -- sminkning..nn.1
  sminkrot_1_N = mkN "sminkrot" ; -- sminkrot..nn.1
  sminkspegel_1_N = mkN "sminkspegel" ; -- sminkspegel..nn.1
  sminkör_1_N = mkN "sminkör" "sminkörer" ; -- sminkör..nn.1
  sminkös_1_N = mkN "sminkös" "sminköser" ; -- sminkös..nn.1
  smisk_1_N = mkN "smisk" neutrum  ; -- smisk..nn.1
  smiska_1_V = mkV "smiskar" ; -- smiska..vb.1
  smiskande_1_N = mkN "smiskande" ; -- smiskande..nn.1
  smita_1_N = mkN "smita" ; -- smita..nn.1
  smita_1_V = mkV "smita" "smet" "smitit" ; -- smita..vb.1
  smitande_1_N = mkN "smitande" ; -- smitande..nn.1
  smitare_1_N = mkN "smitare" utrum  ; -- smitare..nn.1
  smitning_1_N = mkN "smitning" ; -- smitning..nn.1
  smitningsolycka_1_N = mkN "smitningsolycka" ; -- smitningsolycka..nn.1
  smitta_1_N = mkN "smitta" ; -- smitta..nn.1
  smitta_1_V = mkV "smittar" ; -- smitta..vb.1
  smittande_1_N = mkN "smittande" ; -- smittande..nn.1
  smittbar_1_A = mkA "smittbar" ; -- smittbar..av.1
  smittbärande_1_A = mkA "smittbärande" ; -- smittbärande..av.1
  smittbärare_1_N = mkN "smittbärare" utrum  ; -- smittbärare..nn.1
  smittfri_1_A = mkA "smittfri" "smittfritt" ; -- smittfri..av.1
  smittfrihet_1_N = mkN "smittfrihet" ; -- smittfrihet..nn.1
  smitthärd_1_N = mkN "smitthärd" ; -- smitthärd..nn.1
  smittkoppa_1_N = mkN "smittkoppa" ; -- smittkoppa..nn.1
  smittkoppsvaccin_1_N = mkN "smittkoppsvaccin" "smittkoppsvacciner" ; -- smittkoppsvaccin..nn.1
  smittkälla_1_N = mkN "smittkälla" ; -- smittkälla..nn.1
  smittoeffekt_1_N = mkN "smittoeffekt" ; -- smittoeffekt..nn.1
  smittohärd_1_N = mkN "smittohärd" ; -- smittohärd..nn.1
  smittorisk_1_N = mkN "smittorisk" "smittorisker" ; -- smittorisk..nn.1
  smittosam_1_A = mkA "smittosam" "smittosamt" "smittosamma" "smittosamma" "smittosammare" "smittosammast" "smittosammaste" ; -- smittosam..av.1
  smittosamhet_1_N = mkN "smittosamhet" ; -- smittosamhet..nn.1
  smittoväg_1_N = mkN "smittoväg" ; -- smittoväg..nn.1
  smittoövervakning_1_N = mkN "smittoövervakning" ; -- smittoövervakning..nn.1
  smittsam_1_A = mkA "smittsam" "smittsamt" "smittsamma" "smittsamma" "smittsammare" "smittsammast" "smittsammaste" ; -- smittsam..av.1
  smittsamhet_1_N = mkN "smittsamhet" ; -- smittsamhet..nn.1
  smittskydd_1_N = mkN "smittskydd" neutrum  ; -- smittskydd..nn.1
  smittskyddsinstitut_1_N = mkN "smittskyddsinstitut" neutrum  ; -- smittskyddsinstitut..nn.1
  smittskyddsläkare_1_N = mkN "smittskyddsläkare" utrum  ; -- smittskyddsläkare..nn.1
  smittskyddsmyndighet_1_N = mkN "smittskyddsmyndighet" "smittskyddsmyndigheter" ; -- smittskyddsmyndighet..nn.1
  smittskyddssamordnare_1_N = mkN "smittskyddssamordnare" utrum  ; -- smittskyddssamordnare..nn.1
  smittspridning_1_N = mkN "smittspridning" ; -- smittspridning..nn.1
  smittspåra_1_V = mkV "smittspårar" ; -- smittspåra..vb.1
  smittspårande_1_N = mkN "smittspårande" ; -- smittspårande..nn.1
  smittspårning_1_N = mkN "smittspårning" ; -- smittspårning..nn.1
  smittämne_1_N = mkN "smittämne" ; -- smittämne..nn.1
  smock_1_N = mkN "smock" ; -- smock..nn.1
  smocka_1_N = mkN "smocka" ; -- smocka..nn.1
  smocka_1_V = mkV "smockar" ; -- smocka..vb.1
  smockad_1_A = mkA "smockad" ; -- smockad..av.1
  smockande_1_N = mkN "smockande" ; -- smockande..nn.1
  smockfull_1_A = mkA "smockfull" ; -- smockfull..av.1
  smockfullhet_1_N = mkN "smockfullhet" ; -- smockfullhet..nn.1
  smog_1_N = mkN "smog" ; -- smog..nn.1
  smoking_1_N = mkN "smoking" ; -- smoking..nn.1
  smokingklänning_1_N = mkN "smokingklänning" ; -- smokingklänning..nn.1
  smokingskjorta_1_N = mkN "smokingskjorta" ; -- smokingskjorta..nn.1
  smolk_1_N = mkN "smolk" neutrum  ; -- smolk..nn.1
  smolt_1_N = mkN "smolt" ; -- smolt..nn.1
  smorläder_1_N = mkN "smorläder" neutrum  ; -- smorläder..nn.1
  sms_tumme_1_N = mkN "sms-tumme" utrum  ; -- sms-tumme..nn.1
  smsa_1_V = mkV "sms:ar" ; -- smsa..vb.1
  smsande_1_N = mkN "sms:ande" ; -- smsande..nn.1
  smuggel_1_N = mkN "smuggel" neutrum  ; -- smuggel..nn.1
  smuggelcigarett_1_N = mkN "smuggelcigarett" "smuggelcigaretter" ; -- smuggelcigarett..nn.1
  smuggelsprit_1_N = mkN "smuggelsprit" ; -- smuggelsprit..nn.1
  smuggla_1_V = mkV "smugglar" ; -- smuggla..vb.1
  smugglande_1_N = mkN "smugglande" ; -- smugglande..nn.1
  smugglarband_1_N = mkN "smugglarband" neutrum  ; -- smugglarband..nn.1
  smugglare_1_N = mkN "smugglare" utrum  ; -- smugglare..nn.1
  smugglarskepp_1_N = mkN "smugglarskepp" neutrum  ; -- smugglarskepp..nn.1
  smuggleri_1_N = mkN "smuggleri" "smuggleriet" "smugglerier" "smugglerierna" ; -- smuggleri..nn.1
  smuggling_1_N = mkN "smuggling" ; -- smuggling..nn.1
  smugglingsbrott_1_N = mkN "smugglingsbrott" neutrum  ; -- smugglingsbrott..nn.1
  smul_1_A = mkA "smul" ; -- smul..av.1
  smula_1_N = mkN "smula" ; -- smula..nn.1
  smula_1_V = mkV "smular" ; -- smula..vb.1
  smulande_1_N = mkN "smulande" ; -- smulande..nn.1
  smulgråt_1_N = mkN "smulgråt" ; -- smulgråt..nn.1
  smulig_1_A = mkA "smulig" ; -- smulig..av.1
  smulighet_1_N = mkN "smulighet" ; -- smulighet..nn.1
  smult_1_N = mkN "smult" neutrum  ; -- smult..nn.1
  smulta_1_V = mkV "smultar" ; -- smulta..vb.1
  smultande_1_N = mkN "smultande" ; -- smultande..nn.1
  smultron_1_N = mkN "smultron" neutrum  ; -- smultron..nn.1
  smultronrik_1_A = mkA "smultronrik" ; -- smultronrik..av.1
  smultronsommar_1_N = mkN "smultronsommar" "smultronsommaren" "smultronsomrar" "smultronsomrarna" ; -- smultronsommar..nn.1
  smultronstrå_1_N = mkN "smultronstrå" "smultronstråt" "smultronstrån" "smultronstråna" ; -- smultronstrå..nn.1
  smultronställe_1_N = mkN "smultronställe" ; -- smultronställe..nn.1
  smultrontunga_1_N = mkN "smultrontunga" ; -- smultrontunga..nn.1
  smurf_1_N = mkN "smurf" ; -- smurf..nn.1
  smussel_1_N = mkN "smussel" neutrum  ; -- smussel..nn.1
  smussla_1_V = mkV "smusslar" ; -- smussla..vb.1
  smusslande_1_N = mkN "smusslande" ; -- smusslande..nn.1
  smuts_1_N = mkN "smuts" ; -- smuts..nn.1
  smutsa_1_V = mkV "smutsar" ; -- smutsa..vb.1
  smutsande_1_N = mkN "smutsande" ; -- smutsande..nn.1
  smutsavvisande_1_A = mkA "smutsavvisande" ; -- smutsavvisande..av.1
  smutsblad_1_N = mkN "smutsblad" neutrum  ; -- smutsblad..nn.1
  smutsfläck_1_N = mkN "smutsfläck" ; -- smutsfläck..nn.1
  smutsgris_1_N = mkN "smutsgris" ; -- smutsgris..nn.1
  smutsgrå_1_A = mkA "smutsgrå" "smutsgrått" ; -- smutsgrå..av.1
  smutsig_1_A = mkA "smutsig" ; -- smutsig..av.1
  smutsighet_1_N = mkN "smutsighet" ; -- smutsighet..nn.1
  smutskasta_1_V = mkV "smutskastar" ; -- smutskasta..vb.1
  smutskastande_1_N = mkN "smutskastande" ; -- smutskastande..nn.1
  smutskastning_1_N = mkN "smutskastning" ; -- smutskastning..nn.1
  smutskastningskampanj_1_N = mkN "smutskastningskampanj" "smutskastningskampanjer" ; -- smutskastningskampanj..nn.1
  smutskastningsteknik_1_N = mkN "smutskastningsteknik" "smutskastningstekniker" ; -- smutskastningsteknik..nn.1
  smutslitteratur_1_N = mkN "smutslitteratur" ; -- smutslitteratur..nn.1
  smutsorange_1_A = mkA "smutsorange" "smutsoranget" ; -- smutsorange..av.1
  smutspåse_1_N = mkN "smutspåse" utrum  ; -- smutspåse..nn.1
  smutstitel_1_N = mkN "smutstitel" ; -- smutstitel..nn.1
  smutstvätt_1_N = mkN "smutstvätt" ; -- smutstvätt..nn.1
  smutsvatten_1_N = mkN "smutsvatten" "smutsvattnet" "smutsvatten" "smutsvattnen" ; -- smutsvatten..nn.1
  smutt_1_N = mkN "smutt" ; -- smutt..nn.1
  smutta_1_V = mkV "smuttar" ; -- smutta..vb.1
  smuttande_1_N = mkN "smuttande" ; -- smuttande..nn.1
  smycka_1_V = mkV "smyckar" ; -- smycka..vb.1
  smyckande_1_N = mkN "smyckande" ; -- smyckande..nn.1
  smycke_1_N = mkN "smycke" ; -- smycke..nn.1
  smyckegarnityr_1_N = mkN "smyckegarnityr" neutrum  ; -- smyckegarnityr..nn.1
  smycketyp_1_N = mkN "smycketyp" "smycketyper" ; -- smycketyp..nn.1
  smyg_1_N = mkN "smyg" ; -- smyg..nn.1
  smyga_1_V = mkV "smyga" "smög" "smugit" ; -- smyga..vb.1
  smygande_1_N = mkN "smygande" ; -- smygande..nn.1
  smygfilma_1_V = mkV "smygfilmar" ; -- smygfilma..vb.1
  smygfilmande_1_N = mkN "smygfilmande" ; -- smygfilmande..nn.1
  smygfilmning_1_N = mkN "smygfilmning" ; -- smygfilmning..nn.1
  smyghandel_1_N = mkN "smyghandel" ; -- smyghandel..nn.1
  smyghål_1_N = mkN "smyghål" neutrum  ; -- smyghål..nn.1
  smygimpuls_1_N = mkN "smygimpuls" "smygimpulser" ; -- smygimpuls..nn.1
  smygislamisera_1_V = mkV "smygislamiserar" ; -- smygislamisera..vb.1
  smygislamiserande_1_N = mkN "smygislamiserande" ; -- smygislamiserande..nn.1
  smygislamisering_1_N = mkN "smygislamisering" ; -- smygislamisering..nn.1
  smygjaga_1_V = mkV "smygjagar" ; -- smygjaga..vb.1
  smygjägare_1_N = mkN "smygjägare" utrum  ; -- smygjägare..nn.1
  smygkolonisera_1_V = mkV "smygkoloniserar" ; -- smygkolonisera..vb.1
  smygkoloniserande_1_N = mkN "smygkoloniserande" ; -- smygkoloniserande..nn.1
  smygkoloniserbar_1_A = mkA "smygkoloniserbar" ; -- smygkoloniserbar..av.1
  smygkoloniserbarhet_1_N = mkN "smygkoloniserbarhet" ; -- smygkoloniserbarhet..nn.1
  smygkolonisering_1_N = mkN "smygkolonisering" ; -- smygkolonisering..nn.1
  smyglyssna_1_V = mkV "smyglyssnar" ; -- smyglyssna..vb.1
  smyglyssnande_1_N = mkN "smyglyssnande" ; -- smyglyssnande..nn.1
  smygpremiär_1_N = mkN "smygpremiär" "smygpremiärer" ; -- smygpremiär..nn.1
  smygröka_1_V = mkV "smygröker" ; -- smygröka..vb.1
  smygrökande_1_N = mkN "smygrökande" ; -- smygrökande..nn.1
  smygrökning_1_N = mkN "smygrökning" ; -- smygrökning..nn.1
  smygsupa_1_V = mkV "smygsupa" "smygsöp" "smygsupit" ; -- smygsupa..vb.1
  smygsupande_1_N = mkN "smygsupande" ; -- smygsupande..nn.1
  smygsöm_1_N = mkN "smygsöm" "smygsömmen" "smygsömmar" "smygsömmarna" ; -- smygsöm..nn.1
  smygtitta_1_V = mkV "smygtittar" ; -- smygtitta..vb.1
  smygtittande_1_N = mkN "smygtittande" ; -- smygtittande..nn.1
  smygtittare_1_N = mkN "smygtittare" utrum  ; -- smygtittare..nn.1
  smygvinkel_1_N = mkN "smygvinkel" ; -- smygvinkel..nn.1
  smygväg_1_N = mkN "smygväg" ; -- smygväg..nn.1
  smygäta_1_V = mkV "smygäta" "smygåt" "smygätit" ; -- smygäta..vb.1
  smygätande_1_N = mkN "smygätande" ; -- smygätande..nn.1
  smäck_1_N = mkN "smäck" ; -- smäck..nn.1
  smäck_2_N = mkN "smäck" neutrum  ; -- smäck..nn.2
  smäcka_1_V = mkV "smäcker" ; -- smäcka..vb.1
  smäckande_1_N = mkN "smäckande" ; -- smäckande..nn.1
  smäcker_1_A = mkA "smäcker" ; -- smäcker..av.1
  smäckerhet_1_N = mkN "smäckerhet" ; -- smäckerhet..nn.1
  smäckfet_1_A = mkA "smäckfet" ; -- smäckfet..av.1
  smäckfethet_1_N = mkN "smäckfethet" ; -- smäckfethet..nn.1
  smäckfull_1_A = mkA "smäckfull" ; -- smäckfull..av.1
  smäckfullhet_1_N = mkN "smäckfullhet" ; -- smäckfullhet..nn.1
  smäckig_1_A = mkA "smäckig" ; -- smäckig..av.1
  smäckighet_1_N = mkN "smäckighet" ; -- smäckighet..nn.1
  smäcklås_1_N = mkN "smäcklås" neutrum  ; -- smäcklås..nn.1
  smäda_1_V = mkV "smädar" ; -- smäda..vb.1
  smädande_1_N = mkN "smädande" ; -- smädande..nn.1
  smädare_1_N = mkN "smädare" utrum  ; -- smädare..nn.1
  smädebild_1_N = mkN "smädebild" "smädebilder" ; -- smädebild..nn.1
  smädedikt_1_N = mkN "smädedikt" "smädedikter" ; -- smädedikt..nn.1
  smädelse_1_N = mkN "smädelse" "smädelser" ; -- smädelse..nn.1
  smädenamn_1_N = mkN "smädenamn" neutrum  ; -- smädenamn..nn.1
  smädeord_1_N = mkN "smädeord" neutrum  ; -- smädeord..nn.1
  smädeskrift_1_N = mkN "smädeskrift" "smädeskrifter" ; -- smädeskrift..nn.1
  smädevisa_1_N = mkN "smädevisa" ; -- smädevisa..nn.1
  smädlig_1_A = mkA "smädlig" ; -- smädlig..av.1
  smädlighet_1_N = mkN "smädlighet" "smädligheter" ; -- smädlighet..nn.1
  smäkta_1_V = mkV "smäktar" ; -- smäkta..vb.1
  smäktande_1_A = mkA "smäktande" ; -- smäktande..av.1
  smäktande_1_N = mkN "smäktande" ; -- smäktande..nn.1
  smälek_1_N = mkN "smälek" ; -- smälek..nn.1
  smäll_1_N = mkN "smäll" ; -- smäll..nn.1
  smäll_2_N = mkN "smäll" neutrum  ; -- smäll..nn.2
  smälla_1_N = mkN "smälla" ; -- smälla..nn.1
  smälla_1_V = mkV "smäller" ; -- smälla..vb.1
  smälla_2_V = mkV "smälla" "smällde" "smäll" ; -- smälla..vb.2
  smällande_1_N = mkN "smällande" ; -- smällande..nn.1
  smällare_1_N = mkN "smällare" utrum  ; -- smällare..nn.1
  smällfet_1_A = mkA "smällfet" ; -- smällfet..av.1
  smällfethet_1_N = mkN "smällfethet" ; -- smällfethet..nn.1
  smällglim_1_N = mkN "smällglim" "smällglimmen" "smällglim" "smällglimmen" ; -- smällglim..nn.1
  smällkall_1_A = mkA "smällkall" ; -- smällkall..av.1
  smällkaramell_1_N = mkN "smällkaramell" "smällkarameller" ; -- smällkaramell..nn.1
  smällkyss_1_N = mkN "smällkyss" ; -- smällkyss..nn.1
  smälta_1_N = mkN "smälta" ; -- smälta..nn.1
  smälta_1_V = mkV "smälta" "smälter" "smält" "smälte" "smält" "smulten" ; -- smälta..vb.1
  smälta_2_V = mkV "smälta" "smälter" "smält" "smälte" "smält" "smält" ; -- smälta..vb.2
  smältande_1_N = mkN "smältande" ; -- smältande..nn.1
  smältbar_1_A = mkA "smältbar" ; -- smältbar..av.1
  smältbarhet_1_N = mkN "smältbarhet" ; -- smältbarhet..nn.1
  smältdegel_1_N = mkN "smältdegel" ; -- smältdegel..nn.1
  smältentalpitet_1_N = mkN "smältentalpitet" "smältentalpiteter" ; -- smältentalpitet..nn.1
  smälteri_1_N = mkN "smälteri" "smälteriet" "smälterier" "smälterierna" ; -- smälteri..nn.1
  smältmetall_1_N = mkN "smältmetall" ; -- smältmetall..nn.1
  smältning_1_N = mkN "smältning" ; -- smältning..nn.1
  smältost_1_N = mkN "smältost" ; -- smältost..nn.1
  smältpropp_1_N = mkN "smältpropp" ; -- smältpropp..nn.1
  smältpunkt_1_N = mkN "smältpunkt" "smältpunkter" ; -- smältpunkt..nn.1
  smältskydd_1_N = mkN "smältskydd" neutrum  ; -- smältskydd..nn.1
  smältsäkring_1_N = mkN "smältsäkring" ; -- smältsäkring..nn.1
  smältugn_1_N = mkN "smältugn" ; -- smältugn..nn.1
  smältvatten_1_N = mkN "smältvatten" "smältvattnet" "smältvatten" "smältvattnen" ; -- smältvatten..nn.1
  smältverk_1_N = mkN "smältverk" neutrum  ; -- smältverk..nn.1
  smältvärme_1_N = mkN "smältvärme" ; -- smältvärme..nn.1
  smärgel_1_N = mkN "smärgel" ; -- smärgel..nn.1
  smärgelduk_1_N = mkN "smärgelduk" ; -- smärgelduk..nn.1
  smärgla_1_V = mkV "smärglar" ; -- smärgla..vb.1
  smärt_1_A = mkA "smärt" "smärt" ; -- smärt..av.1
  smärta_1_N = mkN "smärta" ; -- smärta..nn.1
  smärta_1_V = mkV "smärtar" ; -- smärta..vb.1
  smärtaktivering_1_N = mkN "smärtaktivering" ; -- smärtaktivering..nn.1
  smärtande_1_N = mkN "smärtande" ; -- smärtande..nn.1
  smärtattack_1_N = mkN "smärtattack" "smärtattacker" ; -- smärtattack..nn.1
  smärtbehandling_1_N = mkN "smärtbehandling" ; -- smärtbehandling..nn.1
  smärtfri_1_A = mkA "smärtfri" "smärtfritt" ; -- smärtfri..av.1
  smärtfrihet_1_N = mkN "smärtfrihet" ; -- smärtfrihet..nn.1
  smärtförnimmelse_1_N = mkN "smärtförnimmelse" "smärtförnimmelser" ; -- smärtförnimmelse..nn.1
  smärtgräns_1_N = mkN "smärtgräns" ; -- smärtgräns..nn.1
  smärthet_1_N = mkN "smärthet" ; -- smärthet..nn.1
  smärthämning_1_N = mkN "smärthämning" ; -- smärthämning..nn.1
  smärting_1_N = mkN "smärting" ; -- smärting..nn.1
  smärtkänslig_1_A = mkA "smärtkänslig" ; -- smärtkänslig..av.1
  smärtlindrande_1_A = mkA "smärtlindrande" ; -- smärtlindrande..av.1
  smärtlindring_1_N = mkN "smärtlindring" ; -- smärtlindring..nn.1
  smärtpunkt_1_N = mkN "smärtpunkt" "smärtpunkter" ; -- smärtpunkt..nn.1
  smärtreceptor_1_N = mkN "smärtreceptor" "smärtreceptorer" ; -- smärtreceptor..nn.1
  smärtsam_1_A = mkA "smärtsam" "smärtsamt" "smärtsamma" "smärtsamma" "smärtsammare" "smärtsammast" "smärtsammaste" ; -- smärtsam..av.1
  smärtsamhet_1_N = mkN "smärtsamhet" ; -- smärtsamhet..nn.1
  smärtsinne_1_N = mkN "smärtsinne" ; -- smärtsinne..nn.1
  smärtstillande_1_A = mkA "smärtstillande" ; -- smärtstillande..av.1
  smärttillstånd_1_N = mkN "smärttillstånd" neutrum  ; -- smärttillstånd..nn.1
  smärttröskel_1_N = mkN "smärttröskel" ; -- smärttröskel..nn.1
  smärttålighet_1_N = mkN "smärttålighet" ; -- smärttålighet..nn.1
  smärtupplevelse_1_N = mkN "smärtupplevelse" "smärtupplevelser" ; -- smärtupplevelse..nn.1
  smätta_1_V = mkV "smätta" "smätter" "smätt" "smätte" "smätt" "smätt" ; -- smätta..vb.1
  smättande_1_N = mkN "smättande" ; -- smättande..nn.1
  småaktig_1_A = mkA "småaktig" ; -- småaktig..av.1
  småaktighet_1_N = mkN "småaktighet" "småaktigheter" ; -- småaktighet..nn.1
  småax_1_N = mkN "småax" neutrum  ; -- småax..nn.1
  småbarn_1_N = mkN "småbarn" neutrum  ; -- småbarn..nn.1
  småbarnsaktig_1_A = mkA "småbarnsaktig" ; -- småbarnsaktig..av.1
  småbarnsaktighet_1_N = mkN "småbarnsaktighet" "småbarnsaktigheter" ; -- småbarnsaktighet..nn.1
  småbarnsbok_1_N = mkN "småbarnsbok" "småbarnsböcker" ; -- småbarnsbok..nn.1
  småbarnsfamilj_1_N = mkN "småbarnsfamilj" "småbarnsfamiljer" ; -- småbarnsfamilj..nn.1
  småbarnsförälder_1_N = mkN "småbarnsförälder" ; -- småbarnsförälder..nn.1
  småbarnsgrind_1_N = mkN "småbarnsgrind" ; -- småbarnsgrind..nn.1
  småbarnsliv_1_N = mkN "småbarnsliv" neutrum  ; -- småbarnsliv..nn.1
  småbarnsmamma_1_N = mkN "småbarnsmamma" ; -- småbarnsmamma..nn.1
  småbarnsår_1_N = mkN "småbarnsår" neutrum  ; -- småbarnsår..nn.1
  småbil_1_N = mkN "småbil" ; -- småbil..nn.1
  småbildskamera_1_N = mkN "småbildskamera" ; -- småbildskamera..nn.1
  småbit_1_N = mkN "småbit" ; -- småbit..nn.1
  småbladig_1_A = mkA "småbladig" ; -- småbladig..av.1
  småblommig_1_A = mkA "småblommig" ; -- småblommig..av.1
  småblåsa_1_V = mkV "småblåser" ; -- småblåsa..vb.1
  småblåsig_1_A = mkA "småblåsig" ; -- småblåsig..av.1
  småbonde_1_N = mkN "småbonde" "småbönder" ; -- småbonde..nn.1
  småborgare_1_N = mkN "småborgare" utrum  ; -- småborgare..nn.1
  småborgerlig_1_A = mkA "småborgerlig" ; -- småborgerlig..av.1
  småborgerlighet_1_N = mkN "småborgerlighet" "småborgerligheter" ; -- småborgerlighet..nn.1
  småborgerskap_1_N = mkN "småborgerskap" neutrum  ; -- småborgerskap..nn.1
  småbruk_1_N = mkN "småbruk" neutrum  ; -- småbruk..nn.1
  småbrukare_1_N = mkN "småbrukare" utrum  ; -- småbrukare..nn.1
  småbruten_1_A = mkA "småbruten" ; -- småbruten..av.1
  småbrygga_1_N = mkN "småbrygga" ; -- småbrygga..nn.1
  småbröd_1_N = mkN "småbröd" neutrum  ; -- småbröd..nn.1
  småbåtshamn_1_N = mkN "småbåtshamn" ; -- småbåtshamn..nn.1
  småcitrus_1_N = mkN "småcitrus" ; -- småcitrus..nn.1
  smådel_1_N = mkN "smådel" "smådelen" "smådelar" "smådelarna" ; -- smådel..nn.1
  smådetalj_1_N = mkN "smådetalj" "smådetaljer" ; -- smådetalj..nn.1
  smådjur_1_N = mkN "smådjur" neutrum  ; -- smådjur..nn.1
  smådjursklinik_1_N = mkN "smådjursklinik" "smådjurskliniker" ; -- smådjursklinik..nn.1
  smådopping_1_N = mkN "smådopping" ; -- smådopping..nn.1
  småeker_1_N = mkN "småeker" ; -- småeker..nn.1
  småelak_1_A = mkA "småelak" ; -- småelak..av.1
  småelakhet_1_N = mkN "småelakhet" ; -- småelakhet..nn.1
  småfisk_1_N = mkN "småfisk" ; -- småfisk..nn.1
  småflicka_1_N = mkN "småflicka" ; -- småflicka..nn.1
  småflin_1_N = mkN "småflin" neutrum  ; -- småflin..nn.1
  småflina_1_V = mkV "småflinar" ; -- småflina..vb.1
  småflinande_1_N = mkN "småflinande" ; -- småflinande..nn.1
  småfolk_1_N = mkN "småfolk" neutrum  ; -- småfolk..nn.1
  småfranska_1_N = mkN "småfranska" ; -- småfranska..nn.1
  småfågel_1_N = mkN "småfågel" ; -- småfågel..nn.1
  småföretag_1_N = mkN "småföretag" neutrum  ; -- småföretag..nn.1
  småföretagare_1_N = mkN "småföretagare" utrum  ; -- småföretagare..nn.1
  smågangster_1_N = mkN "smågangster" ; -- smågangster..nn.1
  smågli_1_N = mkN "smågli" "smågliet" "småglin" "småglina" ; -- smågli..nn.1
  smågnabbig_1_A = mkA "smågnabbig" ; -- smågnabbig..av.1
  smågnabbighet_1_N = mkN "smågnabbighet" ; -- smågnabbighet..nn.1
  smågnagare_1_N = mkN "smågnagare" utrum  ; -- smågnagare..nn.1
  smågnola_1_V = mkV "smågnolar" ; -- smågnola..vb.1
  smågnolande_1_N = mkN "smågnolande" ; -- smågnolande..nn.1
  smågris_1_N = mkN "smågris" ; -- smågris..nn.1
  smågrisdödlighet_1_N = mkN "smågrisdödlighet" "smågrisdödligheter" ; -- smågrisdödlighet..nn.1
  smågräl_1_N = mkN "smågräl" neutrum  ; -- smågräl..nn.1
  smågräla_1_V = mkV "smågrälar" ; -- smågräla..vb.1
  smågrälande_1_N = mkN "smågrälande" ; -- smågrälande..nn.1
  småhagla_1_V = mkV "småhaglar" ; -- småhagla..vb.1
  småhandlare_1_N = mkN "småhandlare" utrum  ; -- småhandlare..nn.1
  småhet_1_A = mkA "småhet" ; -- småhet..av.1
  småhet_1_N = mkN "småhet" "småheter" ; -- småhet..nn.1
  småhus_1_N = mkN "småhus" neutrum  ; -- småhus..nn.1
  småhuslån_1_N = mkN "småhuslån" neutrum  ; -- småhuslån..nn.1
  småhusägare_1_N = mkN "småhusägare" utrum  ; -- småhusägare..nn.1
  småjordbruk_1_N = mkN "småjordbruk" neutrum  ; -- småjordbruk..nn.1
  småjordbrukare_1_N = mkN "småjordbrukare" utrum  ; -- småjordbrukare..nn.1
  småkaka_1_N = mkN "småkaka" ; -- småkaka..nn.1
  småkoka_1_V = mkV "småkokar" ; -- småkoka..vb.1
  småkokande_1_N = mkN "småkokande" ; -- småkokande..nn.1
  småkokning_1_N = mkN "småkokning" ; -- småkokning..nn.1
  småkornig_1_A = mkA "småkornig" ; -- småkornig..av.1
  småkornighet_1_N = mkN "småkornighet" ; -- småkornighet..nn.1
  småkrafs_1_N = mkN "småkrafs" neutrum  ; -- småkrafs..nn.1
  småkryp_1_N = mkN "småkryp" neutrum  ; -- småkryp..nn.1
  småkär_1_A = mkA "småkär" ; -- småkär..av.1
  småkåt_1_A = mkA "småkåt" ; -- småkåt..av.1
  småle_1_V = mkV "småle" "smålog" "smålett" ; -- småle..vb.1
  småleende_1_A = mkA "småleende" ; -- småleende..av.1
  småleende_1_N = mkN "småleende" ; -- småleende..nn.1
  småligist_1_N = mkN "småligist" "småligister" ; -- småligist..nn.1
  småländsk_1_A = mkA "småländsk" ; -- småländsk..av.1
  småländska_1_N = mkN "småländska" ; -- småländska..nn.1
  småländska_2_N = mkN "småländska" ; -- småländska..nn.2
  smålänning_1_N = mkN "smålänning" ; -- smålänning..nn.1
  smålök_1_N = mkN "smålök" ; -- smålök..nn.1
  småmaskig_1_A = mkA "småmaskig" ; -- småmaskig..av.1
  småmynt_1_N = mkN "småmynt" neutrum  ; -- småmynt..nn.1
  småmys_1_N = mkN "småmys" neutrum  ; -- småmys..nn.1
  småmysa_1_V = mkV "småmyser" ; -- småmysa..vb.1
  småmysande_1_N = mkN "småmysande" ; -- småmysande..nn.1
  småmönstrad_1_A = mkA "småmönstrad" ; -- småmönstrad..av.1
  smånervös_1_A = mkA "smånervös" ; -- smånervös..av.1
  småningom_1_Adv = mkAdv "småningom" ; -- småningom..ab.1
  småord_1_N = mkN "småord" neutrum  ; -- småord..nn.1
  småorganism_1_N = mkN "småorganism" "småorganismer" ; -- småorganism..nn.1
  småpaket_1_N = mkN "småpaket" neutrum  ; -- småpaket..nn.1
  småpeng_1_N = mkN "småpeng" ; -- småpeng..nn.1
  småpipig_1_A = mkA "småpipig" ; -- småpipig..av.1
  småplanet_1_N = mkN "småplanet" "småplaneter" ; -- småplanet..nn.1
  småplock_1_N = mkN "småplock" neutrum  ; -- småplock..nn.1
  småpojke_1_N = mkN "småpojke" utrum  ; -- småpojke..nn.1
  småprat_1_N = mkN "småprat" neutrum  ; -- småprat..nn.1
  småprata_1_V = mkV "småpratar" ; -- småprata..vb.1
  småpratande_1_N = mkN "småpratande" ; -- småpratande..nn.1
  småprins_1_N = mkN "småprins" ; -- småprins..nn.1
  småprinsessa_1_N = mkN "småprinsessa" ; -- småprinsessa..nn.1
  småputtra_1_V = mkV "småputtrar" ; -- småputtra..vb.1
  småpåve_1_N = mkN "småpåve" utrum  ; -- småpåve..nn.1
  småregna_1_V = mkV "småregnar" ; -- småregna..vb.1
  smårolig_1_A = mkA "smårolig" ; -- smårolig..av.1
  smårolighet_1_N = mkN "smårolighet" "småroligheter" ; -- smårolighet..nn.1
  smårufsig_1_A = mkA "smårufsig" ; -- smårufsig..av.1
  smårutig_1_A = mkA "smårutig" ; -- smårutig..av.1
  smårätt_1_N = mkN "smårätt" "smårätter" ; -- smårätt..nn.1
  småsak_1_N = mkN "småsak" "småsaker" ; -- småsak..nn.1
  småsessa_1_N = mkN "småsessa" ; -- småsessa..nn.1
  småsint_1_A = mkA "småsint" "småsint" ; -- småsint..av.1
  småsinthet_1_N = mkN "småsinthet" ; -- småsinthet..nn.1
  småsjunga_1_V = mkV "småsjunga" "småsjöng" "småsjungit" ; -- småsjunga..vb.1
  småsjungande_1_N = mkN "småsjungande" ; -- småsjungande..nn.1
  småskalig_1_A = mkA "småskalig" ; -- småskalig..av.1
  småskalighet_1_N = mkN "småskalighet" ; -- småskalighet..nn.1
  småskog_1_N = mkN "småskog" ; -- småskog..nn.1
  småskola_1_N = mkN "småskola" ; -- småskola..nn.1
  småskolelärare_1_N = mkN "småskolelärare" utrum  ; -- småskolelärare..nn.1
  småskrak_1_N = mkN "småskrak" ; -- småskrak..nn.1
  småskratta_1_V = mkV "småskrattar" ; -- småskratta..vb.1
  småskuren_1_A = mkA "småskuren" ; -- småskuren..av.1
  småskvaller_1_N = mkN "småskvaller" neutrum  ; -- småskvaller..nn.1
  småsnäppa_1_N = mkN "småsnäppa" ; -- småsnäppa..nn.1
  småsnål_1_A = mkA "småsnål" ; -- småsnål..av.1
  småsnöa_1_V = mkV "småsnöar" ; -- småsnöa..vb.1
  småsova_1_V = mkV "småsova" "småsov" "småsovit" ; -- småsova..vb.1
  småsovande_1_N = mkN "småsovande" ; -- småsovande..nn.1
  småsparare_1_N = mkN "småsparare" utrum  ; -- småsparare..nn.1
  småspov_1_N = mkN "småspov" ; -- småspov..nn.1
  småspringa_1_V = mkV "småspringa" "småsprang" "småsprungit" ; -- småspringa..vb.1
  småspringande_1_N = mkN "småspringande" ; -- småspringande..nn.1
  småstad_1_N = mkN "småstad" "småstäder" ; -- småstad..nn.1
  småstadsaktig_1_A = mkA "småstadsaktig" ; -- småstadsaktig..av.1
  småstadsaktighet_1_N = mkN "småstadsaktighet" ; -- småstadsaktighet..nn.1
  småstadsbo_1_N = mkN "småstadsbo" "småstadsbor" ; -- småstadsbo..nn.1
  småstadsgata_1_N = mkN "småstadsgata" ; -- småstadsgata..nn.1
  småstadshåla_1_N = mkN "småstadshåla" ; -- småstadshåla..nn.1
  småstadsmässig_1_A = mkA "småstadsmässig" ; -- småstadsmässig..av.1
  småstadstjej_1_N = mkN "småstadstjej" "småstadstjejer" ; -- småstadstjej..nn.1
  småsten_1_N = mkN "småsten" "småstenen" "småstenar" "småstenarna" ; -- småsten..nn.1
  småsupa_1_V = mkV "småsupa" "småsöp" "småsupit" ; -- småsupa..vb.1
  småsupande_1_N = mkN "småsupande" ; -- småsupande..nn.1
  småsur_1_A = mkA "småsur" ; -- småsur..av.1
  småsven_1_N = mkN "småsven" "småsvennen" "småsvennar" "småsvennarna" ; -- småsven..nn.1
  småsvärande_1_N = mkN "småsvärande" ; -- småsvärande..nn.1
  småsyskon_1_N = mkN "småsyskon" neutrum  ; -- småsyskon..nn.1
  småtjej_1_N = mkN "småtjej" "småtjejer" ; -- småtjej..nn.1
  småtrevlig_1_A = mkA "småtrevlig" ; -- småtrevlig..av.1
  småtrist_1_A = mkA "småtrist" "småtrist" ; -- småtrist..av.1
  småträta_1_V = mkV "småträter" ; -- småträta..vb.1
  småträtande_1_N = mkN "småträtande" ; -- småträtande..nn.1
  småtråkig_1_A = mkA "småtråkig" ; -- småtråkig..av.1
  småtrött_1_A = mkA "småtrött" ; -- småtrött..av.1
  smått_1_A = mkA "smått" ; -- smått..av.1
  småtteri_1_N = mkN "småtteri" "småtteriet" "småtterier" "småtterierna" ; -- småtteri..nn.1
  småttig_1_A = mkA "småttig" ; -- småttig..av.1
  småttighet_1_N = mkN "småttighet" "småttigheter" ; -- småttighet..nn.1
  småtting_1_N = mkN "småtting" ; -- småtting..nn.1
  småtvätt_1_N = mkN "småtvätt" ; -- småtvätt..nn.1
  småviktig_1_A = mkA "småviktig" ; -- småviktig..av.1
  småviktighet_1_N = mkN "småviktighet" ; -- småviktighet..nn.1
  småvilt_1_N = mkN "småvilt" neutrum  ; -- småvilt..nn.1
  småvuxen_1_A = mkA "småvuxen" ; -- småvuxen..av.1
  småväxt_1_A = mkA "småväxt" "småväxt" ; -- småväxt..av.1
  småväxthet_1_N = mkN "småväxthet" ; -- småväxthet..nn.1
  smör_1_N = mkN "smör" "smöret" "smörer" "smörerna" ; -- smör..nn.1
  smöra_1_V = mkV "smörar" ; -- smöra..vb.1
  smöra_2_V = mkV "smörar" ; -- smöra..vb.2
  smörande_1_N = mkN "smörande" ; -- smörande..nn.1
  smörbakelse_1_N = mkN "smörbakelse" "smörbakelser" ; -- smörbakelse..nn.1
  smörberg_1_N = mkN "smörberg" neutrum  ; -- smörberg..nn.1
  smörblomma_1_N = mkN "smörblomma" ; -- smörblomma..nn.1
  smörboll_1_N = mkN "smörboll" ; -- smörboll..nn.1
  smörbult_1_N = mkN "smörbult" ; -- smörbult..nn.1
  smördeg_1_N = mkN "smördeg" ; -- smördeg..nn.1
  smördegspastej_1_N = mkN "smördegspastej" "smördegspastejer" ; -- smördegspastej..nn.1
  smörfräsa_1_V = mkV "smörfräser" ; -- smörfräsa..vb.1
  smörfräsande_1_N = mkN "smörfräsande" ; -- smörfräsande..nn.1
  smörgås_1_N = mkN "smörgås" ; -- smörgås..nn.1
  smörgåsbord_1_N = mkN "smörgåsbord" neutrum  ; -- smörgåsbord..nn.1
  smörgåsgaffel_1_N = mkN "smörgåsgaffel" ; -- smörgåsgaffel..nn.1
  smörgåskniv_1_N = mkN "smörgåskniv" ; -- smörgåskniv..nn.1
  smörgåskrasse_1_N = mkN "smörgåskrasse" utrum  ; -- smörgåskrasse..nn.1
  smörgåsmargarin_1_N = mkN "smörgåsmargarin" neutrum  ; -- smörgåsmargarin..nn.1
  smörgåsmat_1_N = mkN "smörgåsmat" ; -- smörgåsmat..nn.1
  smörgåsnisse_1_N = mkN "smörgåsnisse" utrum  ; -- smörgåsnisse..nn.1
  smörgåspapper_1_N = mkN "smörgåspapper" neutrum  ; -- smörgåspapper..nn.1
  smörgåspålägg_1_N = mkN "smörgåspålägg" neutrum  ; -- smörgåspålägg..nn.1
  smörgåsskinka_1_N = mkN "smörgåsskinka" ; -- smörgåsskinka..nn.1
  smörgåstårta_1_N = mkN "smörgåstårta" ; -- smörgåstårta..nn.1
  smörig_1_A = mkA "smörig" ; -- smörig..av.1
  smörj_1_N = mkN "smörj" neutrum  ; -- smörj..nn.1
  smörja_1_N = mkN "smörja" ; -- smörja..nn.1
  smörja_1_V = mkV "smörja" "smorde" "smort" ; -- smörja..vb.1
  smörjande_1_N = mkN "smörjande" ; -- smörjande..nn.1
  smörjanordning_1_N = mkN "smörjanordning" ; -- smörjanordning..nn.1
  smörjelse_1_N = mkN "smörjelse" "smörjelser" ; -- smörjelse..nn.1
  smörjfett_1_N = mkN "smörjfett" neutrum  ; -- smörjfett..nn.1
  smörjgrop_1_N = mkN "smörjgrop" ; -- smörjgrop..nn.1
  smörjhall_1_N = mkN "smörjhall" ; -- smörjhall..nn.1
  smörjhål_1_N = mkN "smörjhål" neutrum  ; -- smörjhål..nn.1
  smörjig_1_A = mkA "smörjig" ; -- smörjig..av.1
  smörjighet_1_N = mkN "smörjighet" ; -- smörjighet..nn.1
  smörjkanna_1_N = mkN "smörjkanna" ; -- smörjkanna..nn.1
  smörjmedel_1_N = mkN "smörjmedel" neutrum  ; -- smörjmedel..nn.1
  smörjning_1_N = mkN "smörjning" ; -- smörjning..nn.1
  smörjolja_1_N = mkN "smörjolja" ; -- smörjolja..nn.1
  smörklick_1_N = mkN "smörklick" ; -- smörklick..nn.1
  smörkniv_1_N = mkN "smörkniv" ; -- smörkniv..nn.1
  smörkräm_1_N = mkN "smörkräm" ; -- smörkräm..nn.1
  smörkula_1_N = mkN "smörkula" ; -- smörkula..nn.1
  smörpapper_1_N = mkN "smörpapper" neutrum  ; -- smörpapper..nn.1
  smörsopp_1_N = mkN "smörsopp" ; -- smörsopp..nn.1
  smörspade_1_N = mkN "smörspade" utrum  ; -- smörspade..nn.1
  smörsteka_1_V = mkV "smörsteker" ; -- smörsteka..vb.1
  smörstekande_1_N = mkN "smörstekande" ; -- smörstekande..nn.1
  smörstekning_1_N = mkN "smörstekning" ; -- smörstekning..nn.1
  smörsvamp_1_N = mkN "smörsvamp" ; -- smörsvamp..nn.1
  smörsyra_1_N = mkN "smörsyra" ; -- smörsyra..nn.1
  smörsång_1_N = mkN "smörsång" ; -- smörsång..nn.1
  smörsångare_1_N = mkN "smörsångare" utrum  ; -- smörsångare..nn.1
  smörtenor_1_N = mkN "smörtenor" "smörtenoren" "smörtenorer" "smörtenorerna" ; -- smörtenor..nn.1
  snabb_1_A = mkA "snabb" ; -- snabb..av.1
  snabbavveckling_1_N = mkN "snabbavveckling" ; -- snabbavveckling..nn.1
  snabbcement_1_N = mkN "snabbcement" ; -- snabbcement..nn.1
  snabbeld_1_N = mkN "snabbeld" ; -- snabbeld..nn.1
  snabbfotad_1_A = mkA "snabbfotad" ; -- snabbfotad..av.1
  snabbfoto_1_N = mkN "snabbfoto" "snabbfotot" "snabbfoton" "snabbfotona" ; -- snabbfoto..nn.1
  snabbfrysande_1_N = mkN "snabbfrysande" ; -- snabbfrysande..nn.1
  snabbförband_1_N = mkN "snabbförband" neutrum  ; -- snabbförband..nn.1
  snabbgjord_1_A = mkA "snabbgjord" "snabbgjort" ; -- snabbgjord..av.1
  snabbgranska_1_V = mkV "snabbgranskar" ; -- snabbgranska..vb.1
  snabbgranskande_1_N = mkN "snabbgranskande" ; -- snabbgranskande..nn.1
  snabbguide_1_N = mkN "snabbguide" "snabbguider" ; -- snabbguide..nn.1
  snabbgående_1_A = mkA "snabbgående" ; -- snabbgående..av.1
  snabbhet_1_N = mkN "snabbhet" "snabbheter" ; -- snabbhet..nn.1
  snabbhetspremie_1_N = mkN "snabbhetspremie" "snabbhetspremier" ; -- snabbhetspremie..nn.1
  snabbinsats_1_N = mkN "snabbinsats" "snabbinsatser" ; -- snabbinsats..nn.1
  snabbinsatsberedskap_1_N = mkN "snabbinsatsberedskap" ; -- snabbinsatsberedskap..nn.1
  snabbinsatsförmåga_1_N = mkN "snabbinsatsförmåga" ; -- snabbinsatsförmåga..nn.1
  snabbkaffe_1_N = mkN "snabbkaffe" ; -- snabbkaffe..nn.1
  snabbkassa_1_N = mkN "snabbkassa" ; -- snabbkassa..nn.1
  snabbkoppling_1_N = mkN "snabbkoppling" ; -- snabbkoppling..nn.1
  snabbkurs_1_N = mkN "snabbkurs" "snabbkurser" ; -- snabbkurs..nn.1
  snabbköp_1_N = mkN "snabbköp" neutrum  ; -- snabbköp..nn.1
  snabbköpsbutik_1_N = mkN "snabbköpsbutik" "snabbköpsbutiker" ; -- snabbköpsbutik..nn.1
  snabbköpskassa_1_N = mkN "snabbköpskassa" ; -- snabbköpskassa..nn.1
  snabbladdare_1_N = mkN "snabbladdare" utrum  ; -- snabbladdare..nn.1
  snabblagad_1_A = mkA "snabblagad" ; -- snabblagad..av.1
  snabblunch_1_N = mkN "snabblunch" "snabbluncher" ; -- snabblunch..nn.1
  snabblån_1_N = mkN "snabblån" neutrum  ; -- snabblån..nn.1
  snabblöslig_1_A = mkA "snabblöslig" ; -- snabblöslig..av.1
  snabblöslighet_1_N = mkN "snabblöslighet" ; -- snabblöslighet..nn.1
  snabbmat_1_N = mkN "snabbmat" ; -- snabbmat..nn.1
  snabbmatsrestaurang_1_N = mkN "snabbmatsrestaurang" "snabbmatsrestauranger" ; -- snabbmatsrestaurang..nn.1
  snabbmiddag_1_N = mkN "snabbmiddag" ; -- snabbmiddag..nn.1
  snabbplatta_1_N = mkN "snabbplatta" ; -- snabbplatta..nn.1
  snabbporträtt_1_N = mkN "snabbporträtt" neutrum  ; -- snabbporträtt..nn.1
  snabbprotokoll_1_N = mkN "snabbprotokoll" neutrum  ; -- snabbprotokoll..nn.1
  snabbregulator_1_N = mkN "snabbregulator" "snabbregulatorer" ; -- snabbregulator..nn.1
  snabbremiss_1_N = mkN "snabbremiss" "snabbremisser" ; -- snabbremiss..nn.1
  snabbreparation_1_N = mkN "snabbreparation" ; -- snabbreparation..nn.1
  snabbrepris_1_N = mkN "snabbrepris" "snabbrepriser" ; -- snabbrepris..nn.1
  snabbseglande_1_A = mkA "snabbseglande" ; -- snabbseglande..av.1
  snabbseparerande_1_A = mkA "snabbseparerande" ; -- snabbseparerande..av.1
  snabbskilsmässa_1_N = mkN "snabbskilsmässa" ; -- snabbskilsmässa..nn.1
  snabbskiss_1_N = mkN "snabbskiss" "snabbskisser" ; -- snabbskiss..nn.1
  snabbskjutande_1_A = mkA "snabbskjutande" ; -- snabbskjutande..av.1
  snabbskrift_1_N = mkN "snabbskrift" ; -- snabbskrift..nn.1
  snabbspola_1_V = mkV "snabbspolar" ; -- snabbspola..vb.1
  snabbspolande_1_N = mkN "snabbspolande" ; -- snabbspolande..nn.1
  snabbspänne_1_N = mkN "snabbspänne" ; -- snabbspänne..nn.1
  snabbstopp_1_N = mkN "snabbstopp" neutrum  ; -- snabbstopp..nn.1
  snabbstål_1_N = mkN "snabbstål" neutrum  ; -- snabbstål..nn.1
  snabbsvarvstål_1_N = mkN "snabbsvarvstål" neutrum  ; -- snabbsvarvstål..nn.1
  snabbteckna_1_V = mkV "snabbtecknar" ; -- snabbteckna..vb.1
  snabbtecknande_1_N = mkN "snabbtecknande" ; -- snabbtecknande..nn.1
  snabbtelefon_1_N = mkN "snabbtelefon" "snabbtelefoner" ; -- snabbtelefon..nn.1
  snabbtorkande_1_A = mkA "snabbtorkande" ; -- snabbtorkande..av.1
  snabbtänkt_1_A = mkA "snabbtänkt" "snabbtänkt" ; -- snabbtänkt..av.1
  snabbtänkthet_1_N = mkN "snabbtänkthet" ; -- snabbtänkthet..nn.1
  snabbtåg_1_N = mkN "snabbtåg" neutrum  ; -- snabbtåg..nn.1
  snabbtågslinje_1_N = mkN "snabbtågslinje" "snabbtågslinjer" ; -- snabbtågslinje..nn.1
  snabbtörsta_1_V = mkV "snabbtörstar" ; -- snabbtörsta..vb.1
  snabbtörstande_1_N = mkN "snabbtörstande" ; -- snabbtörstande..nn.1
  snabbuss_1_N = mkN "snabbuss" ; -- snabbuss..nn.1
  snabbutreda_1_V = mkV "snabbutreda" "snabbutredde" "snabbutrett" ; -- snabbutreda..vb.1
  snabbutredande_1_N = mkN "snabbutredande" ; -- snabbutredande..nn.1
  snabbverkande_1_A = mkA "snabbverkande" ; -- snabbverkande..av.1
  snabbversion_1_N = mkN "snabbversion" ; -- snabbversion..nn.1
  snabbvisit_1_N = mkN "snabbvisit" "snabbvisiter" ; -- snabbvisit..nn.1
  snabbväljare_1_N = mkN "snabbväljare" utrum  ; -- snabbväljare..nn.1
  snabbväxande_1_A = mkA "snabbväxande" ; -- snabbväxande..av.1
  snabel_1_N = mkN "snabel" ; -- snabel..nn.1
  snabelliknande_1_A = mkA "snabelliknande" ; -- snabelliknande..av.1
  snabelsko_1_N = mkN "snabelsko" "snabelskor" ; -- snabelsko..nn.1
  snack_1_N = mkN "snack" neutrum  ; -- snack..nn.1
  snacka_1_V = mkV "snackar" ; -- snacka..vb.1
  snackande_1_N = mkN "snackande" ; -- snackande..nn.1
  snackbar_1_N = mkN "snackbar" "snackbarer" ; -- snackbar..nn.1
  snackesalig_1_A = mkA "snackesalig" ; -- snackesalig..av.1
  snackesalighet_1_N = mkN "snackesalighet" ; -- snackesalighet..nn.1
  snackis_1_N = mkN "snackis" ; -- snackis..nn.1
  snacks_1_N = mkN "snacks" neutrum  ; -- snacks..nn.1
  snacksalig_1_A = mkA "snacksalig" ; -- snacksalig..av.1
  snacksalighet_1_N = mkN "snacksalighet" ; -- snacksalighet..nn.1
  snafs_1_N = mkN "snafs" neutrum  ; -- snafs..nn.1
  snagg_1_N = mkN "snagg" ; -- snagg..nn.1
  snagga_1_V = mkV "snaggar" ; -- snagga..vb.1
  snaggande_1_N = mkN "snaggande" ; -- snaggande..nn.1
  snappa_1_V = mkV "snappar" ; -- snappa..vb.1
  snappande_1_N = mkN "snappande" ; -- snappande..nn.1
  snapphane_1_N = mkN "snapphane" utrum  ; -- snapphane..nn.1
  snapphaneri_1_N = mkN "snapphaneri" neutrum  ; -- snapphaneri..nn.1
  snaps_1_N = mkN "snaps" ; -- snaps..nn.1
  snapsa_1_V = mkV "snapsar" ; -- snapsa..vb.1
  snapsande_1_N = mkN "snapsande" ; -- snapsande..nn.1
  snapshot_1_N = mkN "snapshot" neutrum  ; -- snapshot..nn.1
  snapsvisa_1_N = mkN "snapsvisa" ; -- snapsvisa..nn.1
  snar_1_A = mkA "snar" ; -- snar..av.1
  snara_1_N = mkN "snara" ; -- snara..nn.1
  snara_1_V = mkV "snarar" ; -- snara..vb.1
  snarande_1_N = mkN "snarande" ; -- snarande..nn.1
  snarare_1_Adv = mkAdv "snarare" ; -- snarare..ab.1
  snarast_1_Adv = mkAdv "snarast" ; -- snarast..ab.1
  snarfager_1_A = mkA "snarfager" ; -- snarfager..av.1
  snarfagerhet_1_N = mkN "snarfagerhet" ; -- snarfagerhet..nn.1
  snarfyndig_1_A = mkA "snarfyndig" ; -- snarfyndig..av.1
  snarfyndighet_1_N = mkN "snarfyndighet" ; -- snarfyndighet..nn.1
  snarfärdig_1_A = mkA "snarfärdig" ; -- snarfärdig..av.1
  snarfärdighet_1_N = mkN "snarfärdighet" ; -- snarfärdighet..nn.1
  snarhet_1_N = mkN "snarhet" ; -- snarhet..nn.1
  snarka_1_V = mkV "snarkar" ; -- snarka..vb.1
  snarkande_1_N = mkN "snarkande" ; -- snarkande..nn.1
  snarkare_1_N = mkN "snarkare" utrum  ; -- snarkare..nn.1
  snarkfri_1_A = mkA "snarkfri" "snarkfritt" ; -- snarkfri..av.1
  snarkning_1_N = mkN "snarkning" ; -- snarkning..nn.1
  snarlig_1_A = mkA "snarlig" ; -- snarlig..av.1
  snarliga_1_Adv = mkAdv "snarliga" ; -- snarliga..ab.1
  snarligen_1_Adv = mkAdv "snarligen" ; -- snarligen..ab.1
  snarlighet_1_N = mkN "snarlighet" ; -- snarlighet..nn.1
  snarlik_1_A = mkA "snarlik" ; -- snarlik..av.1
  snarlikhet_1_N = mkN "snarlikhet" ; -- snarlikhet..nn.1
  snarpa_1_V = mkV "snarpar" ; -- snarpa..vb.1
  snarpande_1_N = mkN "snarpande" ; -- snarpande..nn.1
  snarra_1_V = mkV "snarrar" ; -- snarra..vb.1
  snarrande_1_N = mkN "snarrande" ; -- snarrande..nn.1
  snarreva_1_N = mkN "snarreva" ; -- snarreva..nn.1
  snarrådig_1_A = mkA "snarrådig" ; -- snarrådig..av.1
  snarstucken_1_A = mkA "snarstucken" ; -- snarstucken..av.1
  snarstuckenhet_1_N = mkN "snarstuckenhet" ; -- snarstuckenhet..nn.1
  snart_1_Adv = mkAdv "snart" ; -- snart..ab.1
  snartänkt_1_A = mkA "snartänkt" "snartänkt" ; -- snartänkt..av.1
  snartänkthet_1_N = mkN "snartänkthet" ; -- snartänkthet..nn.1
  snarvacker_1_A = mkA "snarvacker" ; -- snarvacker..av.1
  snarvackerhet_1_N = mkN "snarvackerhet" ; -- snarvackerhet..nn.1
  snask_1_N = mkN "snask" neutrum  ; -- snask..nn.1
  snaska_1_V = mkV "snaskar" ; -- snaska..vb.1
  snaskande_1_N = mkN "snaskande" ; -- snaskande..nn.1
  snasker_1_N = mkN "snasker" ; -- snasker..nn.1
  snaskeri_1_N = mkN "snaskeri" "snaskeriet" "snaskerier" "snaskerierna" ; -- snaskeri..nn.1
  snaskig_1_A = mkA "snaskig" ; -- snaskig..av.1
  snaskighet_1_N = mkN "snaskighet" "snaskigheter" ; -- snaskighet..nn.1
  snatta_1_V = mkV "snattar" ; -- snatta..vb.1
  snattande_1_N = mkN "snattande" ; -- snattande..nn.1
  snattare_1_N = mkN "snattare" utrum  ; -- snattare..nn.1
  snatter_1_N = mkN "snatter" neutrum  ; -- snatter..nn.1
  snatterand_1_N = mkN "snatterand" "snatteränder" ; -- snatterand..nn.1
  snatteri_1_N = mkN "snatteri" "snatteriet" "snatterier" "snatterierna" ; -- snatteri..nn.1
  snattra_1_V = mkV "snattrar" ; -- snattra..vb.1
  snattrande_1_N = mkN "snattrande" ; -- snattrande..nn.1
  snava_1_V = mkV "snavar" ; -- snava..vb.1
  snavande_1_N = mkN "snavande" ; -- snavande..nn.1
  snavning_1_N = mkN "snavning" ; -- snavning..nn.1
  sned_1_A = mkA "sned" "snett" ; -- sned..av.1
  snedbena_1_N = mkN "snedbena" ; -- snedbena..nn.1
  snedda_1_V = mkV "sneddar" ; -- snedda..vb.1
  sneddande_1_N = mkN "sneddande" ; -- sneddande..nn.1
  sneddning_1_N = mkN "sneddning" ; -- sneddning..nn.1
  snedfördelning_1_N = mkN "snedfördelning" ; -- snedfördelning..nn.1
  snedgången_1_A = mkA "snedgången" ; -- snedgången..av.1
  snedhet_1_N = mkN "snedhet" "snedheter" ; -- snedhet..nn.1
  snedhiss_1_N = mkN "snedhiss" ; -- snedhiss..nn.1
  snedhörnig_1_A = mkA "snedhörnig" ; -- snedhörnig..av.1
  snedig_1_A = mkA "snedig" ; -- snedig..av.1
  snedparkera_1_V = mkV "snedparkerar" ; -- snedparkera..vb.1
  snedparkerande_1_N = mkN "snedparkerande" ; -- snedparkerande..nn.1
  snedparkerbar_1_A = mkA "snedparkerbar" ; -- snedparkerbar..av.1
  snedparkerbarhet_1_N = mkN "snedparkerbarhet" ; -- snedparkerbarhet..nn.1
  snedparkering_1_N = mkN "snedparkering" ; -- snedparkering..nn.1
  snedprofil_1_N = mkN "snedprofil" "snedprofiler" ; -- snedprofil..nn.1
  snedrekrytera_1_V = mkV "snedrekryterar" ; -- snedrekrytera..vb.1
  snedrekryterande_1_N = mkN "snedrekryterande" ; -- snedrekryterande..nn.1
  snedrekryterbar_1_A = mkA "snedrekryterbar" ; -- snedrekryterbar..av.1
  snedrekryterbarhet_1_N = mkN "snedrekryterbarhet" ; -- snedrekryterbarhet..nn.1
  snedrekrytering_1_N = mkN "snedrekrytering" ; -- snedrekrytering..nn.1
  snedremsa_1_N = mkN "snedremsa" ; -- snedremsa..nn.1
  snedruta_1_N = mkN "snedruta" ; -- snedruta..nn.1
  snedrygg_1_N = mkN "snedrygg" ; -- snedrygg..nn.1
  snedsegel_1_N = mkN "snedsegel" neutrum  ; -- snedsegel..nn.1
  snedseglare_1_N = mkN "snedseglare" utrum  ; -- snedseglare..nn.1
  snedskuren_1_A = mkA "snedskuren" ; -- snedskuren..av.1
  snedskära_1_V = mkV "snedskära" "snedskar" "snedskurit" ; -- snedskära..vb.1
  snedskärande_1_N = mkN "snedskärande" ; -- snedskärande..nn.1
  snedskärning_1_N = mkN "snedskärning" ; -- snedskärning..nn.1
  snedslå_1_N = mkN "snedslå" ; -- snedslå..nn.1
  snedsprång_1_N = mkN "snedsprång" neutrum  ; -- snedsprång..nn.1
  snedsteg_1_N = mkN "snedsteg" neutrum  ; -- snedsteg..nn.1
  snedstreck_1_N = mkN "snedstreck" neutrum  ; -- snedstreck..nn.1
  snedställa_1_V = mkV "snedställer" ; -- snedställa..vb.1
  snedställande_1_N = mkN "snedställande" ; -- snedställande..nn.1
  snedtak_1_N = mkN "snedtak" neutrum  ; -- snedtak..nn.1
  snedtrampad_1_A = mkA "snedtrampad" ; -- snedtrampad..av.1
  snedtändning_1_N = mkN "snedtändning" ; -- snedtändning..nn.1
  snedvinklig_1_A = mkA "snedvinklig" ; -- snedvinklig..av.1
  snedvinklighet_1_N = mkN "snedvinklighet" ; -- snedvinklighet..nn.1
  snedvrida_1_V = mkV "snedvrida" "snedvred" "snedvridit" ; -- snedvrida..vb.1
  snedvridande_1_N = mkN "snedvridande" ; -- snedvridande..nn.1
  snedvriden_1_A = mkA "snedvriden" ; -- snedvriden..av.1
  snedvridning_1_N = mkN "snedvridning" ; -- snedvridning..nn.1
  snedögd_1_A = mkA "snedögd" "snedögt" ; -- snedögd..av.1
  snedögdhet_1_N = mkN "snedögdhet" ; -- snedögdhet..nn.1
  snegla_1_V = mkV "sneglar" ; -- snegla..vb.1
  sneglande_1_N = mkN "sneglande" ; -- sneglande..nn.1
  snegling_1_N = mkN "snegling" ; -- snegling..nn.1
  snes_1_N = mkN "snes" ; -- snes..nn.1
  snibb_1_N = mkN "snibb" ; -- snibb..nn.1
  snibbig_1_A = mkA "snibbig" ; -- snibbig..av.1
  snibbighet_1_N = mkN "snibbighet" ; -- snibbighet..nn.1
  snibbskål_1_N = mkN "snibbskål" ; -- snibbskål..nn.1
  snickarbälte_1_N = mkN "snickarbälte" ; -- snickarbälte..nn.1
  snickarbänk_1_N = mkN "snickarbänk" ; -- snickarbänk..nn.1
  snickare_1_N = mkN "snickare" utrum  ; -- snickare..nn.1
  snickarförkläde_1_N = mkN "snickarförkläde" ; -- snickarförkläde..nn.1
  snickarglädje_1_N = mkN "snickarglädje" utrum  ; -- snickarglädje..nn.1
  snickarverkstad_1_N = mkN "snickarverkstad" "snickarverkstäder" ; -- snickarverkstad..nn.1
  snickarverktyg_1_N = mkN "snickarverktyg" neutrum  ; -- snickarverktyg..nn.1
  snickeri_1_N = mkN "snickeri" "snickeriet" "snickerier" "snickerierna" ; -- snickeri..nn.1
  snickerifabrik_1_N = mkN "snickerifabrik" "snickerifabriker" ; -- snickerifabrik..nn.1
  snickra_1_V = mkV "snickrar" ; -- snickra..vb.1
  snickrande_1_N = mkN "snickrande" ; -- snickrande..nn.1
  snicksnack_1_N = mkN "snicksnack" neutrum  ; -- snicksnack..nn.1
  snida_1_V = mkV "snidar" ; -- snida..vb.1
  snidande_1_N = mkN "snidande" ; -- snidande..nn.1
  snidare_1_N = mkN "snidare" utrum  ; -- snidare..nn.1
  snideri_1_N = mkN "snideri" "snideriet" "sniderier" "sniderierna" ; -- snideri..nn.1
  sniff_1_N = mkN "sniff" ; -- sniff..nn.1
  sniff_2_N = mkN "sniff" neutrum  ; -- sniff..nn.2
  sniffa_1_V = mkV "sniffar" ; -- sniffa..vb.1
  sniffande_1_N = mkN "sniffande" ; -- sniffande..nn.1
  snigel_1_N = mkN "snigel" ; -- snigel..nn.1
  snigelfart_1_N = mkN "snigelfart" ; -- snigelfart..nn.1
  snigelgång_1_N = mkN "snigelgång" ; -- snigelgång..nn.1
  snigelhus_1_N = mkN "snigelhus" neutrum  ; -- snigelhus..nn.1
  snigelpost_1_N = mkN "snigelpost" ; -- snigelpost..nn.1
  snigeltakt_1_N = mkN "snigeltakt" ; -- snigeltakt..nn.1
  snigla_1_V = mkV "sniglar" ; -- snigla..vb.1
  snikande_1_N = mkN "snikande" ; -- snikande..nn.1
  sniken_1_A = mkA "sniken" ; -- sniken..av.1
  snikenhet_1_N = mkN "snikenhet" ; -- snikenhet..nn.1
  snilj_1_N = mkN "snilj" "sniljer" ; -- snilj..nn.1
  snilja_1_N = mkN "snilja" ; -- snilja..nn.1
  sniljeflossa_1_N = mkN "sniljeflossa" ; -- sniljeflossa..nn.1
  snille_1_N = mkN "snille" ; -- snille..nn.1
  snilleblixt_1_N = mkN "snilleblixt" ; -- snilleblixt..nn.1
  snilledrag_1_N = mkN "snilledrag" neutrum  ; -- snilledrag..nn.1
  snillefoster_1_N = mkN "snillefoster" neutrum  ; -- snillefoster..nn.1
  snilleprov_1_N = mkN "snilleprov" neutrum  ; -- snilleprov..nn.1
  snilleverk_1_N = mkN "snilleverk" neutrum  ; -- snilleverk..nn.1
  snillrik_1_A = mkA "snillrik" ; -- snillrik..av.1
  snillrikhet_1_N = mkN "snillrikhet" "snillrikheter" ; -- snillrikhet..nn.1
  snip_1_N = mkN "snip" ; -- snip..nn.1
  snip_2_N = mkN "snip" ; -- snip..nn.2
  snipa_1_N = mkN "snipa" ; -- snipa..nn.1
  snipig_1_A = mkA "snipig" ; -- snipig..av.1
  snippa_1_N = mkN "snippa" ; -- snippa..nn.1
  snirkel_1_N = mkN "snirkel" ; -- snirkel..nn.1
  snirkla_1_V = mkV "snirklar" ; -- snirkla..vb.1
  snirklande_1_N = mkN "snirklande" ; -- snirklande..nn.1
  snirklig_1_A = mkA "snirklig" ; -- snirklig..av.1
  snirklighet_1_N = mkN "snirklighet" ; -- snirklighet..nn.1
  snits_1_N = mkN "snits" ; -- snits..nn.1
  snitsa_1_V = mkV "snitsar" ; -- snitsa..vb.1
  snitsande_1_N = mkN "snitsande" ; -- snitsande..nn.1
  snitsare_1_N = mkN "snitsare" utrum  ; -- snitsare..nn.1
  snitsel_1_N = mkN "snitsel" ; -- snitsel..nn.1
  snitsig_1_A = mkA "snitsig" ; -- snitsig..av.1
  snitsighet_1_N = mkN "snitsighet" ; -- snitsighet..nn.1
  snitsla_1_V = mkV "snitslar" ; -- snitsla..vb.1
  snitslande_1_N = mkN "snitslande" ; -- snitslande..nn.1
  snitt_1_N = mkN "snitt" neutrum  ; -- snitt..nn.1
  snitt_2_N = mkN "snitt" ; -- snitt..nn.2
  snitta_1_V = mkV "snittar" ; -- snitta..vb.1
  snittande_1_N = mkN "snittande" ; -- snittande..nn.1
  snittbetyg_1_N = mkN "snittbetyg" neutrum  ; -- snittbetyg..nn.1
  snittblomma_1_N = mkN "snittblomma" ; -- snittblomma..nn.1
  snittmängd_1_N = mkN "snittmängd" "snittmängder" ; -- snittmängd..nn.1
  snittyta_1_N = mkN "snittyta" ; -- snittyta..nn.1
  sno_1_V = mkV "snor" ; -- sno..vb.1
  snoa_1_N = mkN "snoa" ; -- snoa..nn.1
  snobb_1_N = mkN "snobb" ; -- snobb..nn.1
  snobba_1_V = mkV "snobbar" ; -- snobba..vb.1
  snobbande_1_N = mkN "snobbande" ; -- snobbande..nn.1
  snobberi_1_N = mkN "snobberi" "snobberiet" "snobberier" "snobberierna" ; -- snobberi..nn.1
  snobbfason_1_N = mkN "snobbfason" "snobbfasoner" ; -- snobbfason..nn.1
  snobbig_1_A = mkA "snobbig" ; -- snobbig..av.1
  snobbighet_1_N = mkN "snobbighet" ; -- snobbighet..nn.1
  snobbism_1_N = mkN "snobbism" "snobbismer" ; -- snobbism..nn.1
  snobbistisk_1_A = mkA "snobbistisk" ; -- snobbistisk..av.1
  snobbmaner_1_N = mkN "snobbmaner" "snobbmaneret" "snobbmaner" "snobbmaneren" ; -- snobbmaner..nn.1
  snobbmanér_1_N = mkN "snobbmanér" neutrum  ; -- snobbmanér..nn.1
  snobbränna_1_N = mkN "snobbränna" ; -- snobbränna..nn.1
  snodd_1_N = mkN "snodd" ; -- snodd..nn.1
  snoende_1_N = mkN "snoende" ; -- snoende..nn.1
  snofsig_1_A = mkA "snofsig" ; -- snofsig..av.1
  snofsighet_1_N = mkN "snofsighet" ; -- snofsighet..nn.1
  snok_1_N = mkN "snok" ; -- snok..nn.1
  snoka_1_V = mkV "snokar" ; -- snoka..vb.1
  snokande_1_N = mkN "snokande" ; -- snokande..nn.1
  snopen_1_A = mkA "snopen" ; -- snopen..av.1
  snopenhet_1_N = mkN "snopenhet" ; -- snopenhet..nn.1
  snopp_1_N = mkN "snopp" ; -- snopp..nn.1
  snoppa_1_V = mkV "snoppar" ; -- snoppa..vb.1
  snoppande_1_N = mkN "snoppande" ; -- snoppande..nn.1
  snoppare_1_N = mkN "snoppare" utrum  ; -- snoppare..nn.1
  snoppning_1_N = mkN "snoppning" ; -- snoppning..nn.1
  snor_1_N = mkN "snor" ; -- snor..nn.1
  snora_1_V = mkV "snorar" ; -- snora..vb.1
  snorande_1_N = mkN "snorande" ; -- snorande..nn.1
  snorbroms_1_N = mkN "snorbroms" ; -- snorbroms..nn.1
  snorgers_1_N = mkN "snorgers" ; -- snorgers..nn.1
  snorgärs_1_N = mkN "snorgärs" ; -- snorgärs..nn.1
  snorig_1_A = mkA "snorig" ; -- snorig..av.1
  snorighet_1_N = mkN "snorighet" ; -- snorighet..nn.1
  snork_1_N = mkN "snork" ; -- snork..nn.1
  snorkel_1_N = mkN "snorkel" ; -- snorkel..nn.1
  snorkig_1_A = mkA "snorkig" ; -- snorkig..av.1
  snorkighet_1_N = mkN "snorkighet" ; -- snorkighet..nn.1
  snorkla_1_V = mkV "snorklar" ; -- snorkla..vb.1
  snorklande_1_N = mkN "snorklande" ; -- snorklande..nn.1
  snorre_1_N = mkN "snorre" utrum  ; -- snorre..nn.1
  snorta_1_V = mkV "snortar" ; -- snorta..vb.1
  snortande_1_N = mkN "snortande" ; -- snortande..nn.1
  snortning_1_N = mkN "snortning" ; -- snortning..nn.1
  snorunge_1_N = mkN "snorunge" utrum  ; -- snorunge..nn.1
  snorvalp_1_N = mkN "snorvalp" ; -- snorvalp..nn.1
  snowboard_1_N = mkN "snowboard" "snowboarden" "snowboards" "snowboardsarna" ; -- snowboard..nn.1
  snubba_1_N = mkN "snubba" ; -- snubba..nn.1
  snubba_2_N = mkN "snubba" ; -- snubba..nn.2
  snubba_1_V = mkV "snubbar" ; -- snubba..vb.1
  snubbande_1_N = mkN "snubbande" ; -- snubbande..nn.1
  snubbe_1_N = mkN "snubbe" utrum  ; -- snubbe..nn.1
  snubbelfotad_1_A = mkA "snubbelfotad" ; -- snubbelfotad..av.1
  snubbelsladd_1_N = mkN "snubbelsladd" ; -- snubbelsladd..nn.1
  snubbeltråd_1_N = mkN "snubbeltråd" ; -- snubbeltråd..nn.1
  snubbla_1_V = mkV "snubblar" ; -- snubbla..vb.1
  snubblande_1_N = mkN "snubblande" ; -- snubblande..nn.1
  snubblig_1_A = mkA "snubblig" ; -- snubblig..av.1
  snubblighet_1_N = mkN "snubblighet" ; -- snubblighet..nn.1
  snubbling_1_N = mkN "snubbling" ; -- snubbling..nn.1
  snudd_1_N = mkN "snudd" ; -- snudd..nn.1
  snudda_1_V = mkV "snuddar" ; -- snudda..vb.1
  snuddande_1_N = mkN "snuddande" ; -- snuddande..nn.1
  snudig_1_A = mkA "snudig" ; -- snudig..av.1
  snugga_1_N = mkN "snugga" ; -- snugga..nn.1
  snultra_1_N = mkN "snultra" ; -- snultra..nn.1
  snurr_1_N = mkN "snurr" ; -- snurr..nn.1
  snurra_1_N = mkN "snurra" ; -- snurra..nn.1
  snurra_1_V = mkV "snurrar" ; -- snurra..vb.1
  snurra_2_V = mkV "snurrar" ; -- snurra..vb.2
  snurrande_1_N = mkN "snurrande" ; -- snurrande..nn.1
  snurrbar_1_A = mkA "snurrbar" ; -- snurrbar..av.1
  snurrbarhet_1_N = mkN "snurrbarhet" ; -- snurrbarhet..nn.1
  snurrefiske_1_N = mkN "snurrefiske" ; -- snurrefiske..nn.1
  snurrevad_1_N = mkN "snurrevad" ; -- snurrevad..nn.1
  snurrfåtölj_1_N = mkN "snurrfåtölj" "snurrfåtöljer" ; -- snurrfåtölj..nn.1
  snurrig_1_A = mkA "snurrig" ; -- snurrig..av.1
  snurrighet_1_N = mkN "snurrighet" "snurrigheter" ; -- snurrighet..nn.1
  snurrstol_1_N = mkN "snurrstol" ; -- snurrstol..nn.1
  snus_1_N = mkN "snus" "snuset" "snuser" "snuserna" ; -- snus..nn.1
  snusa_1_V = mkV "snusar" ; -- snusa..vb.1
  snusande_1_N = mkN "snusande" ; -- snusande..nn.1
  snusbrun_1_A = mkA "snusbrun" ; -- snusbrun..av.1
  snusdosa_1_N = mkN "snusdosa" ; -- snusdosa..nn.1
  snusförnuft_1_N = mkN "snusförnuft" neutrum  ; -- snusförnuft..nn.1
  snusförnuftig_1_A = mkA "snusförnuftig" ; -- snusförnuftig..av.1
  snusförnuftighet_1_N = mkN "snusförnuftighet" ; -- snusförnuftighet..nn.1
  snusgubbe_1_N = mkN "snusgubbe" utrum  ; -- snusgubbe..nn.1
  snusig_1_A = mkA "snusig" ; -- snusig..av.1
  snusjätte_1_N = mkN "snusjätte" utrum  ; -- snusjätte..nn.1
  snusk_1_N = mkN "snusk" neutrum  ; -- snusk..nn.1
  snuska_1_V = mkV "snuskar" ; -- snuska..vb.1
  snuskande_1_N = mkN "snuskande" ; -- snuskande..nn.1
  snusker_1_N = mkN "snusker" ; -- snusker..nn.1
  snuskhummer_1_N = mkN "snuskhummer" "snuskhummern" "snuskhumrar" "snuskhumrarna" ; -- snuskhummer..nn.1
  snuskig_1_A = mkA "snuskig" ; -- snuskig..av.1
  snuskighet_1_N = mkN "snuskighet" "snuskigheter" ; -- snuskighet..nn.1
  snuskpelle_1_N = mkN "snuskpelle" utrum  ; -- snuskpelle..nn.1
  snusmala_1_V = mkV "snusmala" "snusmal" "snusmal" "snusmalde" "snusmalt" "snusmalen" ; -- snusmala..vb.1
  snusmalande_1_N = mkN "snusmalande" ; -- snusmalande..nn.1
  snusmumrik_1_N = mkN "snusmumrik" ; -- snusmumrik..nn.1
  snusnäsduk_1_N = mkN "snusnäsduk" ; -- snusnäsduk..nn.1
  snustillverkning_1_N = mkN "snustillverkning" ; -- snustillverkning..nn.1
  snustorr_1_A = mkA "snustorr" ; -- snustorr..av.1
  snustorrhet_1_N = mkN "snustorrhet" ; -- snustorrhet..nn.1
  snut_1_N = mkN "snut" ; -- snut..nn.1
  snut_2_N = mkN "snut" ; -- snut..nn.2
  snutfager_1_A = mkA "snutfager" ; -- snutfager..av.1
  snutfagerhet_1_N = mkN "snutfagerhet" ; -- snutfagerhet..nn.1
  snuthäck_1_N = mkN "snuthäck" ; -- snuthäck..nn.1
  snutkollega_1_N = mkN "snutkollega" ; -- snutkollega..nn.1
  snutmoral_1_N = mkN "snutmoral" ; -- snutmoral..nn.1
  snutt_1_N = mkN "snutt" ; -- snutt..nn.1
  snuttefilt_1_N = mkN "snuttefilt" ; -- snuttefilt..nn.1
  snuttifiering_1_N = mkN "snuttifiering" ; -- snuttifiering..nn.1
  snuva_1_N = mkN "snuva" ; -- snuva..nn.1
  snuva_1_V = mkV "snuvar" ; -- snuva..vb.1
  snuvande_1_N = mkN "snuvande" ; -- snuvande..nn.1
  snuvig_1_A = mkA "snuvig" ; -- snuvig..av.1
  snyft_1_N = mkN "snyft" neutrum  ; -- snyft..nn.1
  snyfta_1_V = mkV "snyftar" ; -- snyfta..vb.1
  snyftande_1_A = mkA "snyftande" ; -- snyftande..av.1
  snyftande_1_N = mkN "snyftande" ; -- snyftande..nn.1
  snyftning_1_N = mkN "snyftning" ; -- snyftning..nn.1
  snyftreportage_1_N = mkN "snyftreportage" "snyftreportaget" "snyftreportage" "snyftreportagen" ; -- snyftreportage..nn.1
  snyftventil_1_N = mkN "snyftventil" "snyftventiler" ; -- snyftventil..nn.1
  snygg_1_A = mkA "snygg" ; -- snygg..av.1
  snygghet_1_N = mkN "snygghet" ; -- snygghet..nn.1
  snygging_1_N = mkN "snygging" ; -- snygging..nn.1
  snyggma_1_N = mkN "snyggma" ; -- snyggma..nn.1
  snylta_1_V = mkV "snyltar" ; -- snylta..vb.1
  snyltande_1_N = mkN "snyltande" ; -- snyltande..nn.1
  snyltare_1_N = mkN "snyltare" utrum  ; -- snyltare..nn.1
  snyltbi_1_N = mkN "snyltbi" "snyltbiet" "snyltbin" "snyltbina" ; -- snyltbi..nn.1
  snyltgäst_1_N = mkN "snyltgäst" "snyltgäster" ; -- snyltgäst..nn.1
  snyltrot_1_N = mkN "snyltrot" ; -- snyltrot..nn.1
  snyltväxt_1_N = mkN "snyltväxt" "snyltväxter" ; -- snyltväxt..nn.1
  snyta_1_V = mkV "snyta" "snöt" "snutit" ; -- snyta..vb.1
  snytande_1_N = mkN "snytande" ; -- snytande..nn.1
  snytbagge_1_N = mkN "snytbagge" utrum  ; -- snytbagge..nn.1
  snyte_1_N = mkN "snyte" ; -- snyte..nn.1
  snyting_1_N = mkN "snyting" ; -- snyting..nn.1
  snytning_1_N = mkN "snytning" ; -- snytning..nn.1
  snäcka_1_N = mkN "snäcka" ; -- snäcka..nn.1
  snäckart_1_N = mkN "snäckart" "snäckarter" ; -- snäckart..nn.1
  snäckdjur_1_N = mkN "snäckdjur" neutrum  ; -- snäckdjur..nn.1
  snäckhjul_1_N = mkN "snäckhjul" neutrum  ; -- snäckhjul..nn.1
  snäckhus_1_N = mkN "snäckhus" neutrum  ; -- snäckhus..nn.1
  snäckmärgel_1_N = mkN "snäckmärgel" ; -- snäckmärgel..nn.1
  snäckskal_1_N = mkN "snäckskal" neutrum  ; -- snäckskal..nn.1
  snäckskruv_1_N = mkN "snäckskruv" ; -- snäckskruv..nn.1
  snäckväxel_1_N = mkN "snäckväxel" ; -- snäckväxel..nn.1
  snäll_1_A = mkA "snäll" ; -- snäll..av.1
  snällgående_1_A = mkA "snällgående" ; -- snällgående..av.1
  snällhet_1_N = mkN "snällhet" "snällheter" ; -- snällhet..nn.1
  snällhetsguru_1_N = mkN "snällhetsguru" "snällhetsgurun" "snällhetsgurus" "snällhetsgurusarna" ; -- snällhetsguru..nn.1
  snällod_1_N = mkN "snällod" neutrum  ; -- snällod..nn.1
  snälltåg_1_N = mkN "snälltåg" neutrum  ; -- snälltåg..nn.1
  snäpp_1_N = mkN "snäpp" neutrum  ; -- snäpp..nn.1
  snäppa_1_N = mkN "snäppa" ; -- snäppa..nn.1
  snäppa_1_V = mkV "snäpper" ; -- snäppa..vb.1
  snäppande_1_N = mkN "snäppande" ; -- snäppande..nn.1
  snäppfågel_1_N = mkN "snäppfågel" ; -- snäppfågel..nn.1
  snäpplock_1_N = mkN "snäpplock" neutrum  ; -- snäpplock..nn.1
  snäpplås_1_N = mkN "snäpplås" neutrum  ; -- snäpplås..nn.1
  snärj_1_N = mkN "snärj" neutrum  ; -- snärj..nn.1
  snärj_2_N = mkN "snärj" neutrum  ; -- snärj..nn.2
  snärja_1_N = mkN "snärja" ; -- snärja..nn.1
  snärja_1_V = mkV "snärja" "snärjde" "snärjt" ; -- snärja..vb.1
  snärjande_1_N = mkN "snärjande" ; -- snärjande..nn.1
  snärje_1_N = mkN "snärje" ; -- snärje..nn.1
  snärjgräs_1_N = mkN "snärjgräs" neutrum  ; -- snärjgräs..nn.1
  snärjig_1_A = mkA "snärjig" ; -- snärjig..av.1
  snärjighet_1_N = mkN "snärjighet" ; -- snärjighet..nn.1
  snärjmåra_1_N = mkN "snärjmåra" ; -- snärjmåra..nn.1
  snärjning_1_N = mkN "snärjning" ; -- snärjning..nn.1
  snärjvävnad_1_N = mkN "snärjvävnad" "snärjvävnader" ; -- snärjvävnad..nn.1
  snärp_1_N = mkN "snärp" neutrum  ; -- snärp..nn.1
  snärp_2_N = mkN "snärp" neutrum  ; -- snärp..nn.2
  snärpa_1_N = mkN "snärpa" ; -- snärpa..nn.1
  snärpa_1_V = mkV "snärper" ; -- snärpa..vb.1
  snärpande_1_N = mkN "snärpande" ; -- snärpande..nn.1
  snärt_1_N = mkN "snärt" ; -- snärt..nn.1
  snärta_1_N = mkN "snärta" ; -- snärta..nn.1
  snärta_1_V = mkV "snärtar" ; -- snärta..vb.1
  snärtande_1_N = mkN "snärtande" ; -- snärtande..nn.1
  snärtig_1_A = mkA "snärtig" ; -- snärtig..av.1
  snärtighet_1_N = mkN "snärtighet" ; -- snärtighet..nn.1
  snäsa_1_N = mkN "snäsa" ; -- snäsa..nn.1
  snäsa_1_V = mkV "snäser" ; -- snäsa..vb.1
  snäsande_1_N = mkN "snäsande" ; -- snäsande..nn.1
  snäsig_1_A = mkA "snäsig" ; -- snäsig..av.1
  snäsighet_1_N = mkN "snäsighet" ; -- snäsighet..nn.1
  snäv_1_A = mkA "snäv" ; -- snäv..av.1
  snäva_1_V = mkV "snävar" ; -- snäva..vb.1
  snävande_1_N = mkN "snävande" ; -- snävande..nn.1
  snävhet_1_N = mkN "snävhet" ; -- snävhet..nn.1
  snål_1_A = mkA "snål" ; -- snål..av.1
  snåla_1_V = mkV "snålar" ; -- snåla..vb.1
  snålande_1_N = mkN "snålande" ; -- snålande..nn.1
  snålblåst_1_N = mkN "snålblåst" ; -- snålblåst..nn.1
  snålhet_1_N = mkN "snålhet" ; -- snålhet..nn.1
  snåljåp_1_N = mkN "snåljåp" ; -- snåljåp..nn.1
  snålmåns_1_N = mkN "snålmåns" ; -- snålmåns..nn.1
  snålskjuts_1_N = mkN "snålskjuts" ; -- snålskjuts..nn.1
  snålspolande_1_A = mkA "snålspolande" ; -- snålspolande..av.1
  snålvarg_1_N = mkN "snålvarg" ; -- snålvarg..nn.1
  snår_1_N = mkN "snår" neutrum  ; -- snår..nn.1
  snårig_1_A = mkA "snårig" ; -- snårig..av.1
  snårskog_1_N = mkN "snårskog" ; -- snårskog..nn.1
  snårvinda_1_N = mkN "snårvinda" ; -- snårvinda..nn.1
  snö_1_N = mkN "snö" ; -- snö..nn.1
  snöa_1_V = mkV "snöar" ; -- snöa..vb.1
  snöalg_1_N = mkN "snöalg" "snöalger" ; -- snöalg..nn.1
  snöande_1_N = mkN "snöande" ; -- snöande..nn.1
  snöbark_1_N = mkN "snöbark" ; -- snöbark..nn.1
  snöbivack_1_N = mkN "snöbivack" "snöbivacker" ; -- snöbivack..nn.1
  snöblandad_1_A = mkA "snöblandad" ; -- snöblandad..av.1
  snöblind_1_A = mkA "snöblind" ; -- snöblind..av.1
  snöblindhet_1_N = mkN "snöblindhet" "snöblindheter" ; -- snöblindhet..nn.1
  snöboll_1_N = mkN "snöboll" ; -- snöboll..nn.1
  snöbollsbuske_1_N = mkN "snöbollsbuske" utrum  ; -- snöbollsbuske..nn.1
  snöbollskrig_1_N = mkN "snöbollskrig" neutrum  ; -- snöbollskrig..nn.1
  snöborste_1_N = mkN "snöborste" utrum  ; -- snöborste..nn.1
  snöbräda_1_N = mkN "snöbräda" ; -- snöbräda..nn.1
  snöbräde_1_N = mkN "snöbräde" ; -- snöbräde..nn.1
  snöbudget_1_N = mkN "snöbudget" ; -- snöbudget..nn.1
  snöbär_1_N = mkN "snöbär" neutrum  ; -- snöbär..nn.1
  snöd_1_A = mkA "snöd" ; -- snöd..av.1
  snödhet_1_N = mkN "snödhet" ; -- snödhet..nn.1
  snödjup_1_N = mkN "snödjup" neutrum  ; -- snödjup..nn.1
  snödrev_1_N = mkN "snödrev" neutrum  ; -- snödrev..nn.1
  snödrift_1_N = mkN "snödrift" ; -- snödrift..nn.1
  snödriva_1_N = mkN "snödriva" ; -- snödriva..nn.1
  snödroppe_1_N = mkN "snödroppe" utrum  ; -- snödroppe..nn.1
  snödräkt_1_N = mkN "snödräkt" "snödräkter" ; -- snödräkt..nn.1
  snöfall_1_N = mkN "snöfall" neutrum  ; -- snöfall..nn.1
  snöfattig_1_A = mkA "snöfattig" ; -- snöfattig..av.1
  snöfjäll_1_N = mkN "snöfjäll" neutrum  ; -- snöfjäll..nn.1
  snöflinga_1_N = mkN "snöflinga" ; -- snöflinga..nn.1
  snöflingedekoration_1_N = mkN "snöflingedekoration" ; -- snöflingedekoration..nn.1
  snöfri_1_A = mkA "snöfri" "snöfritt" ; -- snöfri..av.1
  snöglopp_1_N = mkN "snöglopp" neutrum  ; -- snöglopp..nn.1
  snögräns_1_N = mkN "snögräns" ; -- snögräns..nn.1
  snögubbe_1_N = mkN "snögubbe" utrum  ; -- snögubbe..nn.1
  snöhagel_1_N = mkN "snöhagel" neutrum  ; -- snöhagel..nn.1
  snöhal_1_A = mkA "snöhal" ; -- snöhal..av.1
  snöhalka_1_N = mkN "snöhalka" ; -- snöhalka..nn.1
  snöig_1_A = mkA "snöig" ; -- snöig..av.1
  snöka_1_N = mkN "snöka" ; -- snöka..nn.1
  snökanon_1_N = mkN "snökanon" "snökanoner" ; -- snökanon..nn.1
  snökaos_1_N = mkN "snökaos" neutrum  ; -- snökaos..nn.1
  snökedja_1_N = mkN "snökedja" ; -- snökedja..nn.1
  snöklocka_1_N = mkN "snöklocka" ; -- snöklocka..nn.1
  snöklot_1_N = mkN "snöklot" neutrum  ; -- snöklot..nn.1
  snöklädd_1_A = mkA "snöklädd" ; -- snöklädd..av.1
  snökristall_1_N = mkN "snökristall" "snökristaller" ; -- snökristall..nn.1
  snölandskap_1_N = mkN "snölandskap" neutrum  ; -- snölandskap..nn.1
  snölega_1_N = mkN "snölega" ; -- snölega..nn.1
  snölykta_1_N = mkN "snölykta" ; -- snölykta..nn.1
  snömassa_1_N = mkN "snömassa" ; -- snömassa..nn.1
  snömodd_1_N = mkN "snömodd" ; -- snömodd..nn.1
  snömos_1_N = mkN "snömos" neutrum  ; -- snömos..nn.1
  snömula_1_V = mkV "snömular" ; -- snömula..vb.1
  snömulande_1_N = mkN "snömulande" ; -- snömulande..nn.1
  snömulning_1_N = mkN "snömulning" ; -- snömulning..nn.1
  snömögel_1_N = mkN "snömögel" neutrum  ; -- snömögel..nn.1
  snöoväder_1_N = mkN "snöoväder" neutrum  ; -- snöoväder..nn.1
  snöpa_1_V = mkV "snöper" ; -- snöpa..vb.1
  snöpande_1_N = mkN "snöpande" ; -- snöpande..nn.1
  snöpare_1_N = mkN "snöpare" utrum  ; -- snöpare..nn.1
  snöpegel_1_N = mkN "snöpegel" ; -- snöpegel..nn.1
  snöping_1_N = mkN "snöping" ; -- snöping..nn.1
  snöplig_1_A = mkA "snöplig" ; -- snöplig..av.1
  snöplighet_1_N = mkN "snöplighet" ; -- snöplighet..nn.1
  snöplog_1_N = mkN "snöplog" ; -- snöplog..nn.1
  snöploga_1_V = mkV "snöplogar" ; -- snöploga..vb.1
  snöplogande_1_N = mkN "snöplogande" ; -- snöplogande..nn.1
  snöplogning_1_N = mkN "snöplogning" ; -- snöplogning..nn.1
  snöpning_1_N = mkN "snöpning" ; -- snöpning..nn.1
  snöprognos_1_N = mkN "snöprognos" "snöprognoser" ; -- snöprognos..nn.1
  snöra_1_V = mkV "snöra" "snörde" "snört" ; -- snöra..vb.1
  snörande_1_N = mkN "snörande" ; -- snörande..nn.1
  snörapport_1_N = mkN "snörapport" "snörapporter" ; -- snörapport..nn.1
  snöre_1_N = mkN "snöre" ; -- snöre..nn.1
  snöredskap_1_N = mkN "snöredskap" neutrum  ; -- snöredskap..nn.1
  snöregion_1_N = mkN "snöregion" ; -- snöregion..nn.1
  snöregn_1_N = mkN "snöregn" neutrum  ; -- snöregn..nn.1
  snörik_1_A = mkA "snörik" ; -- snörik..av.1
  snörikhet_1_N = mkN "snörikhet" ; -- snörikhet..nn.1
  snöripa_1_N = mkN "snöripa" ; -- snöripa..nn.1
  snörkänga_1_N = mkN "snörkänga" ; -- snörkänga..nn.1
  snörliv_1_N = mkN "snörliv" neutrum  ; -- snörliv..nn.1
  snörmakare_1_N = mkN "snörmakare" utrum  ; -- snörmakare..nn.1
  snörmakeri_1_N = mkN "snörmakeri" "snörmakeriet" "snörmakerier" "snörmakerierna" ; -- snörmakeri..nn.1
  snörning_1_N = mkN "snörning" ; -- snörning..nn.1
  snörpa_1_V = mkV "snörper" ; -- snörpa..vb.1
  snörpande_1_N = mkN "snörpande" ; -- snörpande..nn.1
  snörpig_1_A = mkA "snörpig" ; -- snörpig..av.1
  snörpighet_1_N = mkN "snörpighet" ; -- snörpighet..nn.1
  snörpning_1_N = mkN "snörpning" ; -- snörpning..nn.1
  snörpvad_1_N = mkN "snörpvad" ; -- snörpvad..nn.1
  snörrät_1_A = mkA "snörrät" ; -- snörrät..av.1
  snörräthet_1_N = mkN "snörräthet" ; -- snörräthet..nn.1
  snörsko_1_N = mkN "snörsko" "snörskor" ; -- snörsko..nn.1
  snörslå_1_N = mkN "snörslå" ; -- snörslå..nn.1
  snörstart_1_N = mkN "snörstart" "snörstarter" ; -- snörstart..nn.1
  snörstump_1_N = mkN "snörstump" ; -- snörstump..nn.1
  snörstövel_1_N = mkN "snörstövel" ; -- snörstövel..nn.1
  snörvla_1_V = mkV "snörvlar" ; -- snörvla..vb.1
  snörvlande_1_N = mkN "snörvlande" ; -- snörvlande..nn.1
  snörvlig_1_A = mkA "snörvlig" ; -- snörvlig..av.1
  snörvlighet_1_N = mkN "snörvlighet" ; -- snörvlighet..nn.1
  snörvling_1_N = mkN "snörvling" ; -- snörvling..nn.1
  snöröjning_1_N = mkN "snöröjning" ; -- snöröjning..nn.1
  snöröjningskapacitet_1_N = mkN "snöröjningskapacitet" ; -- snöröjningskapacitet..nn.1
  snöröjningspersonal_1_N = mkN "snöröjningspersonal" ; -- snöröjningspersonal..nn.1
  snöscooter_1_N = mkN "snöscooter" ; -- snöscooter..nn.1
  snöscooterförare_1_N = mkN "snöscooterförare" utrum  ; -- snöscooterförare..nn.1
  snöskata_1_N = mkN "snöskata" ; -- snöskata..nn.1
  snösko_1_N = mkN "snösko" "snöskor" ; -- snösko..nn.1
  snöskorpa_1_N = mkN "snöskorpa" ; -- snöskorpa..nn.1
  snöskoter_1_N = mkN "snöskoter" ; -- snöskoter..nn.1
  snöskoterförare_1_N = mkN "snöskoterförare" utrum  ; -- snöskoterförare..nn.1
  snöskottare_1_N = mkN "snöskottare" utrum  ; -- snöskottare..nn.1
  snöskottning_1_N = mkN "snöskottning" ; -- snöskottning..nn.1
  snöskred_1_N = mkN "snöskred" neutrum  ; -- snöskred..nn.1
  snöskrud_1_N = mkN "snöskrud" ; -- snöskrud..nn.1
  snöskyffel_1_N = mkN "snöskyffel" ; -- snöskyffel..nn.1
  snöskytte_1_N = mkN "snöskytte" ; -- snöskytte..nn.1
  snöslask_1_N = mkN "snöslask" neutrum  ; -- snöslask..nn.1
  snöslunga_1_N = mkN "snöslunga" ; -- snöslunga..nn.1
  snösläde_1_N = mkN "snösläde" utrum  ; -- snösläde..nn.1
  snösmältning_1_N = mkN "snösmältning" ; -- snösmältning..nn.1
  snösparv_1_N = mkN "snösparv" ; -- snösparv..nn.1
  snöstaket_1_N = mkN "snöstaket" neutrum  ; -- snöstaket..nn.1
  snöstjärna_1_N = mkN "snöstjärna" ; -- snöstjärna..nn.1
  snöstorm_1_N = mkN "snöstorm" ; -- snöstorm..nn.1
  snösväng_1_N = mkN "snösväng" ; -- snösväng..nn.1
  snösörja_1_N = mkN "snösörja" ; -- snösörja..nn.1
  snötillgång_1_N = mkN "snötillgång" ; -- snötillgång..nn.1
  snötyngd_1_A = mkA "snötyngd" "snötyngt" ; -- snötyngd..av.1
  snötäcke_1_N = mkN "snötäcke" ; -- snötäcke..nn.1
  snötäckt_1_A = mkA "snötäckt" "snötäckt" ; -- snötäckt..av.1
  snövall_1_N = mkN "snövall" ; -- snövall..nn.1
  snövinter_1_N = mkN "snövinter" ; -- snövinter..nn.1
  snövit_1_A = mkA "snövit" ; -- snövit..av.1
  snöyra_1_N = mkN "snöyra" ; -- snöyra..nn.1
  so_1_N = mkN "so" ; -- so..nn.1
  soaré_1_N = mkN "soaré" "soaréer" ; -- soaré..nn.1
  sobel_1_N = mkN "sobel" ; -- sobel..nn.1
  sobelmössa_1_N = mkN "sobelmössa" ; -- sobelmössa..nn.1
  sobelpäls_1_N = mkN "sobelpäls" ; -- sobelpäls..nn.1
  sobelskinn_1_N = mkN "sobelskinn" neutrum  ; -- sobelskinn..nn.1
  sober_1_A = mkA "sober" ; -- sober..av.1
  social_1_A = mkA "social" ; -- social..av.1
  socialantropolog_1_N = mkN "socialantropolog" "socialantropologer" ; -- socialantropolog..nn.1
  socialantropologi_1_N = mkN "socialantropologi" ; -- socialantropologi..nn.1
  socialantropologisk_1_A = mkA "socialantropologisk" ; -- socialantropologisk..av.1
  socialarbetare_1_N = mkN "socialarbetare" utrum  ; -- socialarbetare..nn.1
  socialarbete_1_N = mkN "socialarbete" ; -- socialarbete..nn.1
  socialassistent_1_N = mkN "socialassistent" "socialassistenter" ; -- socialassistent..nn.1
  socialavgift_1_N = mkN "socialavgift" "socialavgifter" ; -- socialavgift..nn.1
  socialbidrag_1_N = mkN "socialbidrag" neutrum  ; -- socialbidrag..nn.1
  socialbidragskostnad_1_N = mkN "socialbidragskostnad" "socialbidragskostnader" ; -- socialbidragskostnad..nn.1
  socialbyrå_1_N = mkN "socialbyrå" "socialbyråer" ; -- socialbyrå..nn.1
  socialdemokrat_1_N = mkN "socialdemokrat" "socialdemokrater" ; -- socialdemokrat..nn.1
  socialdemokrati_1_N = mkN "socialdemokrati" ; -- socialdemokrati..nn.1
  socialdemokratisk_1_A = mkA "socialdemokratisk" ; -- socialdemokratisk..av.1
  socialdirektör_1_N = mkN "socialdirektör" "socialdirektörer" ; -- socialdirektör..nn.1
  socialekonomi_1_N = mkN "socialekonomi" ; -- socialekonomi..nn.1
  socialekonomisk_1_A = mkA "socialekonomisk" ; -- socialekonomisk..av.1
  socialfall_1_N = mkN "socialfall" neutrum  ; -- socialfall..nn.1
  socialfascistisk_1_A = mkA "socialfascistisk" ; -- socialfascistisk..av.1
  socialfråga_1_N = mkN "socialfråga" ; -- socialfråga..nn.1
  socialförsäkring_1_N = mkN "socialförsäkring" ; -- socialförsäkring..nn.1
  socialförsäkringsminister_1_N = mkN "socialförsäkringsminister" ; -- socialförsäkringsminister..nn.1
  socialförsäkringsområde_1_N = mkN "socialförsäkringsområde" ; -- socialförsäkringsområde..nn.1
  socialförsäkringsutskott_1_N = mkN "socialförsäkringsutskott" neutrum  ; -- socialförsäkringsutskott..nn.1
  socialförvaltning_1_N = mkN "socialförvaltning" ; -- socialförvaltning..nn.1
  socialgrupp_1_N = mkN "socialgrupp" "socialgrupper" ; -- socialgrupp..nn.1
  socialhjälp_1_N = mkN "socialhjälp" ; -- socialhjälp..nn.1
  socialhjälpstagare_1_N = mkN "socialhjälpstagare" utrum  ; -- socialhjälpstagare..nn.1
  socialhögskola_1_N = mkN "socialhögskola" ; -- socialhögskola..nn.1
  socialisation_1_N = mkN "socialisation" ; -- socialisation..nn.1
  socialisera_1_V = mkV "socialiserar" ; -- socialisera..vb.1
  socialiserande_1_N = mkN "socialiserande" ; -- socialiserande..nn.1
  socialiserbar_1_A = mkA "socialiserbar" ; -- socialiserbar..av.1
  socialiserbarhet_1_N = mkN "socialiserbarhet" ; -- socialiserbarhet..nn.1
  socialisering_1_N = mkN "socialisering" ; -- socialisering..nn.1
  socialism_1_N = mkN "socialism" "socialismer" ; -- socialism..nn.1
  socialist_1_N = mkN "socialist" "socialister" ; -- socialist..nn.1
  socialistisk_1_A = mkA "socialistisk" ; -- socialistisk..av.1
  socialistparti_1_N = mkN "socialistparti" "socialistpartiet" "socialistpartier" "socialistpartierna" ; -- socialistparti..nn.1
  socialitet_1_N = mkN "socialitet" "socialiteter" ; -- socialitet..nn.1
  socialklass_1_N = mkN "socialklass" "socialklasser" ; -- socialklass..nn.1
  socialliberal_1_A = mkA "socialliberal" ; -- socialliberal..av.1
  socialliberal_1_N = mkN "socialliberal" "socialliberaler" ; -- socialliberal..nn.1
  socialliberalism_1_N = mkN "socialliberalism" "socialliberalismer" ; -- socialliberalism..nn.1
  socialläkare_1_N = mkN "socialläkare" utrum  ; -- socialläkare..nn.1
  sociallön_1_N = mkN "sociallön" "sociallöner" ; -- sociallön..nn.1
  socialmedicin_1_N = mkN "socialmedicin" ; -- socialmedicin..nn.1
  socialmedicinare_1_N = mkN "socialmedicinare" utrum  ; -- socialmedicinare..nn.1
  socialminister_1_N = mkN "socialminister" ; -- socialminister..nn.1
  socialnämnd_1_N = mkN "socialnämnd" "socialnämnder" ; -- socialnämnd..nn.1
  socialpolitik_1_N = mkN "socialpolitik" ; -- socialpolitik..nn.1
  socialpolitisk_1_A = mkA "socialpolitisk" ; -- socialpolitisk..av.1
  socialpornografi_1_N = mkN "socialpornografi" ; -- socialpornografi..nn.1
  socialpsykolog_1_N = mkN "socialpsykolog" "socialpsykologer" ; -- socialpsykolog..nn.1
  socialpsykologi_1_N = mkN "socialpsykologi" ; -- socialpsykologi..nn.1
  socialrealism_1_N = mkN "socialrealism" "socialrealismer" ; -- socialrealism..nn.1
  socialrealistisk_1_A = mkA "socialrealistisk" ; -- socialrealistisk..av.1
  socialregister_1_N = mkN "socialregister" neutrum  ; -- socialregister..nn.1
  socialreportage_1_N = mkN "socialreportage" "socialreportaget" "socialreportage" "socialreportagen" ; -- socialreportage..nn.1
  socialstyrelse_1_N = mkN "socialstyrelse" utrum  ; -- socialstyrelse..nn.1
  socialtjänst_1_N = mkN "socialtjänst" ; -- socialtjänst..nn.1
  socialtjänstlag_1_N = mkN "socialtjänstlag" ; -- socialtjänstlag..nn.1
  socialvetenskap_1_N = mkN "socialvetenskap" "socialvetenskaper" ; -- socialvetenskap..nn.1
  socialvård_1_N = mkN "socialvård" ; -- socialvård..nn.1
  societet_1_N = mkN "societet" "societeter" ; -- societet..nn.1
  societetsfotograf_1_N = mkN "societetsfotograf" "societetsfotografer" ; -- societetsfotograf..nn.1
  societetshus_1_N = mkN "societetshus" neutrum  ; -- societetshus..nn.1
  societetslejon_1_N = mkN "societetslejon" neutrum  ; -- societetslejon..nn.1
  societetsstege_1_N = mkN "societetsstege" utrum  ; -- societetsstege..nn.1
  socioekonomisk_1_A = mkA "socioekonomisk" ; -- socioekonomisk..av.1
  sociogram_1_N = mkN "sociogram" "sociogrammet" "sociogram" "sociogrammen" ; -- sociogram..nn.1
  sociokulturell_1_A = mkA "sociokulturell" ; -- sociokulturell..av.1
  sociolekt_1_N = mkN "sociolekt" "sociolekter" ; -- sociolekt..nn.1
  sociolingvistik_1_N = mkN "sociolingvistik" ; -- sociolingvistik..nn.1
  sociolog_1_N = mkN "sociolog" "sociologer" ; -- sociolog..nn.1
  sociologi_1_N = mkN "sociologi" ; -- sociologi..nn.1
  sociologisk_1_A = mkA "sociologisk" ; -- sociologisk..av.1
  socionom_1_N = mkN "socionom" "socionomer" ; -- socionom..nn.1
  sociopat_1_N = mkN "sociopat" "sociopater" ; -- sociopat..nn.1
  socioterapi_1_N = mkN "socioterapi" ; -- socioterapi..nn.1
  socka_1_N = mkN "socka" ; -- socka..nn.1
  sockel_1_N = mkN "sockel" ; -- sockel..nn.1
  sockellist_1_N = mkN "sockellist" "sockellister" ; -- sockellist..nn.1
  socken_1_N = mkN "socken" ; -- socken..nn.1
  sockenbud_1_N = mkN "sockenbud" neutrum  ; -- sockenbud..nn.1
  sockendräkt_1_N = mkN "sockendräkt" "sockendräkter" ; -- sockendräkt..nn.1
  sockengång_1_N = mkN "sockengång" ; -- sockengång..nn.1
  sockenkyrka_1_N = mkN "sockenkyrka" ; -- sockenkyrka..nn.1
  sockenstuga_1_N = mkN "sockenstuga" ; -- sockenstuga..nn.1
  socker_1_N = mkN "socker" neutrum  ; -- socker..nn.1
  sockerart_1_N = mkN "sockerart" "sockerarter" ; -- sockerart..nn.1
  sockerbagare_1_N = mkN "sockerbagare" utrum  ; -- sockerbagare..nn.1
  sockerbageri_1_N = mkN "sockerbageri" "sockerbageriet" "sockerbagerier" "sockerbagerierna" ; -- sockerbageri..nn.1
  sockerberoende_1_N = mkN "sockerberoende" ; -- sockerberoende..nn.1
  sockerbeta_1_N = mkN "sockerbeta" ; -- sockerbeta..nn.1
  sockerbetssaft_1_N = mkN "sockerbetssaft" "sockerbetssafter" ; -- sockerbetssaft..nn.1
  sockerbildning_1_N = mkN "sockerbildning" ; -- sockerbildning..nn.1
  sockerbindning_1_N = mkN "sockerbindning" ; -- sockerbindning..nn.1
  sockerbit_1_N = mkN "sockerbit" ; -- sockerbit..nn.1
  sockerbomb_1_N = mkN "sockerbomb" "sockerbomber" ; -- sockerbomb..nn.1
  sockerbruk_1_N = mkN "sockerbruk" neutrum  ; -- sockerbruk..nn.1
  sockerdricka_1_N = mkN "sockerdricka" ; -- sockerdricka..nn.1
  sockerfri_1_A = mkA "sockerfri" "sockerfritt" ; -- sockerfri..av.1
  sockerfälla_1_N = mkN "sockerfälla" ; -- sockerfälla..nn.1
  sockerglasyr_1_N = mkN "sockerglasyr" "sockerglasyrer" ; -- sockerglasyr..nn.1
  sockergryn_1_N = mkN "sockergryn" neutrum  ; -- sockergryn..nn.1
  sockerhalt_1_N = mkN "sockerhalt" "sockerhalter" ; -- sockerhalt..nn.1
  sockerhaltig_1_A = mkA "sockerhaltig" ; -- sockerhaltig..av.1
  sockerhaltighet_1_N = mkN "sockerhaltighet" ; -- sockerhaltighet..nn.1
  sockerkaka_1_N = mkN "sockerkaka" ; -- sockerkaka..nn.1
  sockerkakssmet_1_N = mkN "sockerkakssmet" ; -- sockerkakssmet..nn.1
  sockerkampanj_1_N = mkN "sockerkampanj" "sockerkampanjer" ; -- sockerkampanj..nn.1
  sockerkist_1_N = mkN "sockerkist" ; -- sockerkist..nn.1
  sockerkulör_1_N = mkN "sockerkulör" ; -- sockerkulör..nn.1
  sockerlag_1_N = mkN "sockerlag" ; -- sockerlag..nn.1
  sockerlönn_1_N = mkN "sockerlönn" ; -- sockerlönn..nn.1
  sockermolekyl_1_N = mkN "sockermolekyl" "sockermolekyler" ; -- sockermolekyl..nn.1
  sockermässig_1_A = mkA "sockermässig" ; -- sockermässig..av.1
  sockerpiller_1_N = mkN "sockerpiller" neutrum  ; -- sockerpiller..nn.1
  sockerpulla_1_N = mkN "sockerpulla" ; -- sockerpulla..nn.1
  sockerraffinaderi_1_N = mkN "sockerraffinaderi" "sockerraffinaderiet" "sockerraffinaderier" "sockerraffinaderierna" ; -- sockerraffinaderi..nn.1
  sockerrik_1_A = mkA "sockerrik" ; -- sockerrik..av.1
  sockerrikhet_1_N = mkN "sockerrikhet" ; -- sockerrikhet..nn.1
  sockerrot_1_N = mkN "sockerrot" ; -- sockerrot..nn.1
  sockerrör_1_N = mkN "sockerrör" neutrum  ; -- sockerrör..nn.1
  sockerrörsodling_1_N = mkN "sockerrörsodling" ; -- sockerrörsodling..nn.1
  sockerrörsproduktion_1_N = mkN "sockerrörsproduktion" ; -- sockerrörsproduktion..nn.1
  sockersalta_1_V = mkV "sockersaltar" ; -- sockersalta..vb.1
  sockersaltande_1_N = mkN "sockersaltande" ; -- sockersaltande..nn.1
  sockersjuk_1_A = mkA "sockersjuk" ; -- sockersjuk..av.1
  sockersjuka_1_N = mkN "sockersjuka" ; -- sockersjuka..nn.1
  sockerskorpa_1_N = mkN "sockerskorpa" ; -- sockerskorpa..nn.1
  sockerskål_1_N = mkN "sockerskål" ; -- sockerskål..nn.1
  sockerströare_1_N = mkN "sockerströare" utrum  ; -- sockerströare..nn.1
  sockersug_1_N = mkN "sockersug" neutrum  ; -- sockersug..nn.1
  sockersöt_1_A = mkA "sockersöt" ; -- sockersöt..av.1
  sockersöthet_1_N = mkN "sockersöthet" ; -- sockersöthet..nn.1
  sockertillverkning_1_N = mkN "sockertillverkning" ; -- sockertillverkning..nn.1
  sockertopp_1_N = mkN "sockertopp" ; -- sockertopp..nn.1
  sockertång_1_N = mkN "sockertång" "sockertänger" ; -- sockertång..nn.1
  sockeröverdrag_1_N = mkN "sockeröverdrag" neutrum  ; -- sockeröverdrag..nn.1
  sockra_1_V = mkV "sockrar" ; -- sockra..vb.1
  sockrande_1_N = mkN "sockrande" ; -- sockrande..nn.1
  sockrig_1_A = mkA "sockrig" ; -- sockrig..av.1
  sockrighet_1_N = mkN "sockrighet" ; -- sockrighet..nn.1
  soda_1_N = mkN "soda" ; -- soda..nn.1
  sodaglas_1_N = mkN "sodaglas" neutrum  ; -- sodaglas..nn.1
  sodahalt_1_N = mkN "sodahalt" "sodahalter" ; -- sodahalt..nn.1
  sodahaltig_1_A = mkA "sodahaltig" ; -- sodahaltig..av.1
  sodamassa_1_N = mkN "sodamassa" ; -- sodamassa..nn.1
  sodavatten_1_N = mkN "sodavatten" "sodavattnet" "sodavatten" "sodavattnen" ; -- sodavatten..nn.1
  sodaört_1_N = mkN "sodaört" ; -- sodaört..nn.1
  sodomi_1_N = mkN "sodomi" ; -- sodomi..nn.1
  sodomitisk_1_A = mkA "sodomitisk" ; -- sodomitisk..av.1
  sodomsäpple_1_N = mkN "sodomsäpple" ; -- sodomsäpple..nn.1
  soffa_1_N = mkN "soffa" ; -- soffa..nn.1
  soffbord_1_N = mkN "soffbord" neutrum  ; -- soffbord..nn.1
  soffgrupp_1_N = mkN "soffgrupp" "soffgrupper" ; -- soffgrupp..nn.1
  soffit_1_N = mkN "soffit" "soffiter" ; -- soffit..nn.1
  soffliggare_1_N = mkN "soffliggare" utrum  ; -- soffliggare..nn.1
  sofflock_1_N = mkN "sofflock" neutrum  ; -- sofflock..nn.1
  soffpotatis_1_N = mkN "soffpotatis" ; -- soffpotatis..nn.1
  soffsurfa_1_V = mkV "soffsurfar" ; -- soffsurfa..vb.1
  soffsurfande_1_N = mkN "soffsurfande" ; -- soffsurfande..nn.1
  sofism_1_N = mkN "sofism" "sofismer" ; -- sofism..nn.1
  sofist_1_N = mkN "sofist" "sofister" ; -- sofist..nn.1
  sofisteri_1_N = mkN "sofisteri" "sofisteriet" "sofisterier" "sofisterierna" ; -- sofisteri..nn.1
  sofistik_1_N = mkN "sofistik" ; -- sofistik..nn.1
  sofistikerad_1_A = mkA "sofistikerad" ; -- sofistikerad..av.1
  sofistisk_1_A = mkA "sofistisk" ; -- sofistisk..av.1
  softa_1_V = mkV "softar" ; -- softa..vb.1
  softball_1_N = mkN "softball" ; -- softball..nn.1
  softballplan_1_N = mkN "softballplan" "softballplaner" ; -- softballplan..nn.1
  software_1_N = mkN "software" utrum  ; -- software..nn.1
  soignerad_1_A = mkA "soignerad" ; -- soignerad..av.1
  soja_1_N = mkN "soja" ; -- soja..nn.1
  sojabiff_1_N = mkN "sojabiff" ; -- sojabiff..nn.1
  sojaböna_1_N = mkN "sojaböna" ; -- sojaböna..nn.1
  sojakaka_1_N = mkN "sojakaka" ; -- sojakaka..nn.1
  sojamjöl_1_N = mkN "sojamjöl" neutrum  ; -- sojamjöl..nn.1
  sojamjölk_1_N = mkN "sojamjölk" ; -- sojamjölk..nn.1
  sokratisk_1_A = mkA "sokratisk" ; -- sokratisk..av.1
  sol_och_vår_1_N = mkN "sol-och-vår" ; -- sol-och-vår..nn.1
  sol_och_våra_1_V = mkV "sol-och-vårar" ; -- sol-och-våra..vb.1
  sol_och_vårande_1_N = mkN "sol-och-vårande" ; -- sol-och-vårande..nn.1
  sol_och_vårare_1_N = mkN "sol-och-vårare" utrum  ; -- sol-och-vårare..nn.1
  sol_1_N = mkN "sol" ; -- sol..nn.1
  sol_2_N = mkN "sol" ; -- sol..nn.2
  sola_1_V = mkV "solar" ; -- sola..vb.1
  solande_1_N = mkN "solande" ; -- solande..nn.1
  solanin_1_N = mkN "solanin" "solaniner" ; -- solanin..nn.1
  solar_1_A = mkA "solar" ; -- solar..av.1
  solariehöna_1_N = mkN "solariehöna" ; -- solariehöna..nn.1
  solarisk_1_A = mkA "solarisk" ; -- solarisk..av.1
  solarium_1_N = mkN "solarium" "solariet" "solarier" "solarierna" ; -- solarium..nn.1
  solarplexus_1_N = mkN "solarplexus" ; -- solarplexus..nn.1
  solaväxel_1_N = mkN "solaväxel" ; -- solaväxel..nn.1
  solbad_1_N = mkN "solbad" neutrum  ; -- solbad..nn.1
  solbada_1_V = mkV "solbadar" ; -- solbada..vb.1
  solbadande_1_N = mkN "solbadande" ; -- solbadande..nn.1
  solbadare_1_N = mkN "solbadare" utrum  ; -- solbadare..nn.1
  solbatteri_1_N = mkN "solbatteri" "solbatteriet" "solbatterier" "solbatterierna" ; -- solbatteri..nn.1
  solbelysning_1_N = mkN "solbelysning" ; -- solbelysning..nn.1
  solbelyst_1_A = mkA "solbelyst" "solbelyst" ; -- solbelyst..av.1
  solbestrålning_1_N = mkN "solbestrålning" ; -- solbestrålning..nn.1
  solblekt_1_A = mkA "solblekt" "solblekt" ; -- solblekt..av.1
  solblind_1_A = mkA "solblind" ; -- solblind..av.1
  solblindhet_1_N = mkN "solblindhet" "solblindheter" ; -- solblindhet..nn.1
  solbrilledags_1_N = mkN "solbrilledags" ; -- solbrilledags..nn.1
  solbränd_1_A = mkA "solbränd" ; -- solbränd..av.1
  solbrändhet_1_N = mkN "solbrändhet" ; -- solbrändhet..nn.1
  solbränna_1_N = mkN "solbränna" ; -- solbränna..nn.1
  solbänk_1_N = mkN "solbänk" ; -- solbänk..nn.1
  solbärgning_1_N = mkN "solbärgning" ; -- solbärgning..nn.1
  solcell_1_N = mkN "solcell" "solceller" ; -- solcell..nn.1
  solcellsanläggning_1_N = mkN "solcellsanläggning" ; -- solcellsanläggning..nn.1
  solcellsdriven_1_A = mkA "solcellsdriven" ; -- solcellsdriven..av.1
  solcellslampa_1_N = mkN "solcellslampa" ; -- solcellslampa..nn.1
  solcellspanel_1_N = mkN "solcellspanel" "solcellspaneler" ; -- solcellspanel..nn.1
  solcellsväska_1_N = mkN "solcellsväska" ; -- solcellsväska..nn.1
  solcirkel_1_N = mkN "solcirkel" ; -- solcirkel..nn.1
  solcykel_1_N = mkN "solcykel" ; -- solcykel..nn.1
  sold_1_N = mkN "sold" ; -- sold..nn.1
  soldag_1_N = mkN "soldag" ; -- soldag..nn.1
  soldat_1_N = mkN "soldat" "soldater" ; -- soldat..nn.1
  soldatesk_1_N = mkN "soldatesk" ; -- soldatesk..nn.1
  soldatfigur_1_N = mkN "soldatfigur" "soldatfigurer" ; -- soldatfigur..nn.1
  soldathem_1_N = mkN "soldathem" "soldathemmet" "soldathem" "soldathemmen" ; -- soldathem..nn.1
  soldathop_1_N = mkN "soldathop" ; -- soldathop..nn.1
  soldatkappa_1_N = mkN "soldatkappa" ; -- soldatkappa..nn.1
  soldatmaterial_1_N = mkN "soldatmaterial" neutrum  ; -- soldatmaterial..nn.1
  soldatmässig_1_A = mkA "soldatmässig" ; -- soldatmässig..av.1
  soldatnamn_1_N = mkN "soldatnamn" neutrum  ; -- soldatnamn..nn.1
  soldatrock_1_N = mkN "soldatrock" ; -- soldatrock..nn.1
  soldattorp_1_N = mkN "soldattorp" neutrum  ; -- soldattorp..nn.1
  soldatutrustning_1_N = mkN "soldatutrustning" ; -- soldatutrustning..nn.1
  soldatänka_1_N = mkN "soldatänka" ; -- soldatänka..nn.1
  soldenär_1_N = mkN "soldenär" "soldenärer" ; -- soldenär..nn.1
  soldis_1_N = mkN "soldis" neutrum  ; -- soldis..nn.1
  soldnär_1_N = mkN "soldnär" "soldnärer" ; -- soldnär..nn.1
  soldrucken_1_A = mkA "soldrucken" ; -- soldrucken..av.1
  soldräkt_1_N = mkN "soldräkt" "soldräkter" ; -- soldräkt..nn.1
  soldränkt_1_A = mkA "soldränkt" "soldränkt" ; -- soldränkt..av.1
  soldygn_1_N = mkN "soldygn" neutrum  ; -- soldygn..nn.1
  soldyrkare_1_N = mkN "soldyrkare" utrum  ; -- soldyrkare..nn.1
  soleksem_1_N = mkN "soleksem" neutrum  ; -- soleksem..nn.1
  solenergi_1_N = mkN "solenergi" ; -- solenergi..nn.1
  solenergiteknologi_1_N = mkN "solenergiteknologi" "solenergiteknologier" ; -- solenergiteknologi..nn.1
  solenn_1_A = mkA "solenn" "solent" ; -- solenn..av.1
  solennitet_1_N = mkN "solennitet" "solenniteter" ; -- solennitet..nn.1
  solfall_1_N = mkN "solfall" neutrum  ; -- solfall..nn.1
  solfatar_1_N = mkN "solfatar" "solfatarer" ; -- solfatar..nn.1
  solfattig_1_A = mkA "solfattig" ; -- solfattig..av.1
  solfattighet_1_N = mkN "solfattighet" ; -- solfattighet..nn.1
  solfest_1_N = mkN "solfest" "solfester" ; -- solfest..nn.1
  solfjäder_1_N = mkN "solfjäder" ; -- solfjäder..nn.1
  solfjäderformig_1_A = mkA "solfjäderformig" ; -- solfjäderformig..av.1
  solflod_1_N = mkN "solflod" "solfloder" ; -- solflod..nn.1
  solfläck_1_N = mkN "solfläck" ; -- solfläck..nn.1
  solforskare_1_N = mkN "solforskare" utrum  ; -- solforskare..nn.1
  solfångare_1_N = mkN "solfångare" utrum  ; -- solfångare..nn.1
  solförmörkelse_1_N = mkN "solförmörkelse" "solförmörkelser" ; -- solförmörkelse..nn.1
  solgass_1_N = mkN "solgass" neutrum  ; -- solgass..nn.1
  solgata_1_N = mkN "solgata" ; -- solgata..nn.1
  solglas_1_N = mkN "solglas" neutrum  ; -- solglas..nn.1
  solglimt_1_N = mkN "solglimt" ; -- solglimt..nn.1
  solgud_1_N = mkN "solgud" ; -- solgud..nn.1
  solgul_1_A = mkA "solgul" ; -- solgul..av.1
  solgård_1_N = mkN "solgård" ; -- solgård..nn.1
  solhatt_1_N = mkN "solhatt" ; -- solhatt..nn.1
  solhet_1_A = mkA "solhet" ; -- solhet..av.1
  solhetta_1_N = mkN "solhetta" ; -- solhetta..nn.1
  solhjul_1_N = mkN "solhjul" neutrum  ; -- solhjul..nn.1
  solhöjd_1_N = mkN "solhöjd" ; -- solhöjd..nn.1
  solid_1_A = mkA "solid" "solitt" ; -- solid..av.1
  solidarisk_1_A = mkA "solidarisk" ; -- solidarisk..av.1
  solidaritet_1_N = mkN "solidaritet" "solidariteter" ; -- solidaritet..nn.1
  solidaritetskänsla_1_N = mkN "solidaritetskänsla" ; -- solidaritetskänsla..nn.1
  solidaritetsåtgärd_1_N = mkN "solidaritetsåtgärd" "solidaritetsåtgärder" ; -- solidaritetsåtgärd..nn.1
  soliditet_1_N = mkN "soliditet" "soliditeter" ; -- soliditet..nn.1
  solig_1_A = mkA "solig" ; -- solig..av.1
  solighet_1_N = mkN "solighet" ; -- solighet..nn.1
  solinstrålning_1_N = mkN "solinstrålning" ; -- solinstrålning..nn.1
  solipsism_1_N = mkN "solipsism" "solipsismer" ; -- solipsism..nn.1
  solipsistisk_1_A = mkA "solipsistisk" ; -- solipsistisk..av.1
  solist_1_N = mkN "solist" "solister" ; -- solist..nn.1
  solistisk_1_A = mkA "solistisk" ; -- solistisk..av.1
  solitär_1_A = mkA "solitär" ; -- solitär..av.1
  solitär_1_N = mkN "solitär" "solitärer" ; -- solitär..nn.1
  solk_1_N = mkN "solk" neutrum  ; -- solk..nn.1
  solka_1_V = mkV "solkar" ; -- solka..vb.1
  solkande_1_N = mkN "solkande" ; -- solkande..nn.1
  solkatt_1_N = mkN "solkatt" "solkatter" ; -- solkatt..nn.1
  solkig_1_A = mkA "solkig" ; -- solkig..av.1
  solkighet_1_N = mkN "solkighet" ; -- solkighet..nn.1
  solklar_1_A = mkA "solklar" ; -- solklar..av.1
  solklipp_1_N = mkN "solklipp" neutrum  ; -- solklipp..nn.1
  solklänning_1_N = mkN "solklänning" ; -- solklänning..nn.1
  solkraftsdriven_1_A = mkA "solkraftsdriven" ; -- solkraftsdriven..av.1
  solkräm_1_N = mkN "solkräm" "solkrämer" ; -- solkräm..nn.1
  solkurva_1_N = mkN "solkurva" ; -- solkurva..nn.1
  solkust_1_N = mkN "solkust" ; -- solkust..nn.1
  sollampa_1_N = mkN "sollampa" ; -- sollampa..nn.1
  solliknande_1_A = mkA "solliknande" ; -- solliknande..av.1
  solljus_1_A = mkA "solljus" ; -- solljus..av.1
  solljus_1_N = mkN "solljus" neutrum  ; -- solljus..nn.1
  solljusreflekterande_1_A = mkA "solljusreflekterande" ; -- solljusreflekterande..av.1
  sollös_1_A = mkA "sollös" ; -- sollös..av.1
  solmateria_1_N = mkN "solmateria" "solmaterian" "solmaterier" "solmaterierna" ; -- solmateria..nn.1
  solmisation_1_N = mkN "solmisation" ; -- solmisation..nn.1
  solmogen_1_A = mkA "solmogen" ; -- solmogen..av.1
  solmål_1_N = mkN "solmål" neutrum  ; -- solmål..nn.1
  solnedgång_1_N = mkN "solnedgång" ; -- solnedgång..nn.1
  solnedgångsljus_1_N = mkN "solnedgångsljus" neutrum  ; -- solnedgångsljus..nn.1
  solo_1_A = mkA "solo" ; -- solo..av.1
  solo_1_N = mkN "solo" "solot" "soli" "solona" ; -- solo..nn.1
  soloartist_1_N = mkN "soloartist" "soloartister" ; -- soloartist..nn.1
  solochvår_1_N = mkN "solochvår" ; -- solochvår..nn.1
  solochvåra_1_V = mkV "solochvårar" ; -- solochvåra..vb.1
  solochvårande_1_N = mkN "solochvårande" ; -- solochvårande..nn.1
  solochvårare_1_N = mkN "solochvårare" utrum  ; -- solochvårare..nn.1
  solodansör_1_N = mkN "solodansör" "solodansörer" ; -- solodansör..nn.1
  solokvist_1_A = mkA "solokvist" ; -- solokvist..av.1
  sololja_1_N = mkN "sololja" ; -- sololja..nn.1
  soloparti_1_N = mkN "soloparti" "solopartiet" "solopartier" "solopartierna" ; -- soloparti..nn.1
  solospel_1_N = mkN "solospel" "solospelet" "solospel" "solospelen" ; -- solospel..nn.1
  solosång_1_N = mkN "solosång" ; -- solosång..nn.1
  solosångare_1_N = mkN "solosångare" utrum  ; -- solosångare..nn.1
  solpanel_1_N = mkN "solpanel" "solpaneler" ; -- solpanel..nn.1
  solprotuberans_1_N = mkN "solprotuberans" "solprotuberanser" ; -- solprotuberans..nn.1
  solreflex_1_N = mkN "solreflex" "solreflexer" ; -- solreflex..nn.1
  solregn_1_N = mkN "solregn" neutrum  ; -- solregn..nn.1
  solresa_1_N = mkN "solresa" ; -- solresa..nn.1
  solring_1_N = mkN "solring" ; -- solring..nn.1
  solros_1_N = mkN "solros" "solrosor" ; -- solros..nn.1
  solrosfrö_1_N = mkN "solrosfrö" "solrosfröet" "solrosfrön" "solrosfröna" ; -- solrosfrö..nn.1
  solrök_1_N = mkN "solrök" ; -- solrök..nn.1
  solrörelse_1_N = mkN "solrörelse" "solrörelser" ; -- solrörelse..nn.1
  solsemester_1_N = mkN "solsemester" ; -- solsemester..nn.1
  solsida_1_N = mkN "solsida" ; -- solsida..nn.1
  solsken_1_N = mkN "solsken" neutrum  ; -- solsken..nn.1
  solskensdag_1_N = mkN "solskensdag" ; -- solskensdag..nn.1
  solskensväder_1_N = mkN "solskensväder" neutrum  ; -- solskensväder..nn.1
  solskifte_1_N = mkN "solskifte" ; -- solskifte..nn.1
  solskiva_1_N = mkN "solskiva" ; -- solskiva..nn.1
  solskydd_1_N = mkN "solskydd" neutrum  ; -- solskydd..nn.1
  solskyddsmedel_1_N = mkN "solskyddsmedel" neutrum  ; -- solskyddsmedel..nn.1
  solsnibb_1_N = mkN "solsnibb" ; -- solsnibb..nn.1
  solsprängning_1_N = mkN "solsprängning" ; -- solsprängning..nn.1
  solstekt_1_A = mkA "solstekt" "solstekt" ; -- solstekt..av.1
  solsting_1_N = mkN "solsting" neutrum  ; -- solsting..nn.1
  solstol_1_N = mkN "solstol" ; -- solstol..nn.1
  solstrimma_1_N = mkN "solstrimma" ; -- solstrimma..nn.1
  solstråle_1_N = mkN "solstråle" utrum  ; -- solstråle..nn.1
  solstrålning_1_N = mkN "solstrålning" ; -- solstrålning..nn.1
  solsystem_1_N = mkN "solsystem" neutrum  ; -- solsystem..nn.1
  soltak_1_N = mkN "soltak" neutrum  ; -- soltak..nn.1
  solterapi_1_N = mkN "solterapi" ; -- solterapi..nn.1
  soltid_1_N = mkN "soltid" ; -- soltid..nn.1
  soltimma_1_N = mkN "soltimma" ; -- soltimma..nn.1
  soltimme_1_N = mkN "soltimme" utrum  ; -- soltimme..nn.1
  soltorka_1_V = mkV "soltorkar" ; -- soltorka..vb.1
  soltorkande_1_N = mkN "soltorkande" ; -- soltorkande..nn.1
  soluppgång_1_N = mkN "soluppgång" ; -- soluppgång..nn.1
  soluppvärmd_1_A = mkA "soluppvärmd" "soluppvärmt" ; -- soluppvärmd..av.1
  solur_1_N = mkN "solur" neutrum  ; -- solur..nn.1
  solution_1_N = mkN "solution" ; -- solution..nn.1
  solv_1_N = mkN "solv" neutrum  ; -- solv..nn.1
  solva_1_V = mkV "solvar" ; -- solva..vb.1
  solvande_1_N = mkN "solvande" ; -- solvande..nn.1
  solvarg_1_N = mkN "solvarg" ; -- solvarg..nn.1
  solvarm_1_A = mkA "solvarm" ; -- solvarm..av.1
  solvarv_1_N = mkN "solvarv" neutrum  ; -- solvarv..nn.1
  solvens_1_N = mkN "solvens" ; -- solvens..nn.1
  solvent_1_A = mkA "solvent" "solvent" ; -- solvent..av.1
  solventil_1_N = mkN "solventil" "solventiler" ; -- solventil..nn.1
  solvera_1_V = mkV "solverar" ; -- solvera..vb.1
  solveranda_1_N = mkN "solveranda" ; -- solveranda..nn.1
  solverande_1_N = mkN "solverande" ; -- solverande..nn.1
  solverbar_1_A = mkA "solverbar" ; -- solverbar..av.1
  solverbarhet_1_N = mkN "solverbarhet" ; -- solverbarhet..nn.1
  solvering_1_N = mkN "solvering" ; -- solvering..nn.1
  solvind_1_N = mkN "solvind" ; -- solvind..nn.1
  solvisare_1_N = mkN "solvisare" utrum  ; -- solvisare..nn.1
  solvkäpp_1_N = mkN "solvkäpp" ; -- solvkäpp..nn.1
  solvtråd_1_N = mkN "solvtråd" ; -- solvtråd..nn.1
  solvända_1_N = mkN "solvända" ; -- solvända..nn.1
  solvärme_1_N = mkN "solvärme" utrum  ; -- solvärme..nn.1
  solvärmefångare_1_N = mkN "solvärmefångare" utrum  ; -- solvärmefångare..nn.1
  soläkta_1_A = mkA "soläkta" ; -- soläkta..av.1
  solär_1_A = mkA "solär" ; -- solär..av.1
  solår_1_N = mkN "solår" neutrum  ; -- solår..nn.1
  solöga_1_N = mkN "solöga" "solögat" "solögon" "solögonen" ; -- solöga..nn.1
  som_1_Adv = mkAdv "som" ; -- som..ab.1
  somalier_1_N = mkN "somalier" "somaliern" "somalier" "somalierna" ; -- somalier..nn.1
  somalisk_1_A = mkA "somalisk" ; -- somalisk..av.1
  somaliska_1_N = mkN "somaliska" ; -- somaliska..nn.1
  somaliska_2_N = mkN "somaliska" ; -- somaliska..nn.2
  somatiker_1_N = mkN "somatiker" "somatikern" "somatiker" "somatikerna" ; -- somatiker..nn.1
  somatisk_1_A = mkA "somatisk" ; -- somatisk..av.1
  sombrero_1_N = mkN "sombrero" "sombreron" "sombreroer" "sombreroerna" ; -- sombrero..nn.1
  sommar_1_N = mkN "sommar" "sommaren" "somrar" "somrarna" ; -- sommar..nn.1
  sommaradress_1_N = mkN "sommaradress" "sommaradresser" ; -- sommaradress..nn.1
  sommaraktig_1_A = mkA "sommaraktig" ; -- sommaraktig..av.1
  sommaraktighet_1_N = mkN "sommaraktighet" ; -- sommaraktighet..nn.1
  sommarbadande_1_A = mkA "sommarbadande" ; -- sommarbadande..av.1
  sommarbarn_1_N = mkN "sommarbarn" neutrum  ; -- sommarbarn..nn.1
  sommarberså_1_N = mkN "sommarberså" "sommarbersåer" ; -- sommarberså..nn.1
  sommarboende_1_N = mkN "sommarboende" ; -- sommarboende..nn.1
  sommarbostad_1_N = mkN "sommarbostad" "sommarbostäder" ; -- sommarbostad..nn.1
  sommardag_1_N = mkN "sommardag" ; -- sommardag..nn.1
  sommardimma_1_N = mkN "sommardimma" ; -- sommardimma..nn.1
  sommardräkt_1_N = mkN "sommardräkt" ; -- sommardräkt..nn.1
  sommardäck_1_N = mkN "sommardäck" neutrum  ; -- sommardäck..nn.1
  sommareftermiddag_1_N = mkN "sommareftermiddag" ; -- sommareftermiddag..nn.1
  sommarfjäril_1_N = mkN "sommarfjäril" ; -- sommarfjäril..nn.1
  sommarfrisyr_1_N = mkN "sommarfrisyr" "sommarfrisyrer" ; -- sommarfrisyr..nn.1
  sommarfågel_1_N = mkN "sommarfågel" ; -- sommarfågel..nn.1
  sommargotlänning_1_N = mkN "sommargotlänning" ; -- sommargotlänning..nn.1
  sommargräs_1_N = mkN "sommargräs" neutrum  ; -- sommargräs..nn.1
  sommargyllen_1_N = mkN "sommargyllen" neutrum  ; -- sommargyllen..nn.1
  sommargylling_1_N = mkN "sommargylling" ; -- sommargylling..nn.1
  sommargäst_1_N = mkN "sommargäst" "sommargäster" ; -- sommargäst..nn.1
  sommarhalvår_1_N = mkN "sommarhalvår" neutrum  ; -- sommarhalvår..nn.1
  sommarhatt_1_N = mkN "sommarhatt" ; -- sommarhatt..nn.1
  sommarhem_1_N = mkN "sommarhem" "sommarhemmet" "sommarhem" "sommarhemmen" ; -- sommarhem..nn.1
  sommarhetta_1_N = mkN "sommarhetta" ; -- sommarhetta..nn.1
  sommarhus_1_N = mkN "sommarhus" neutrum  ; -- sommarhus..nn.1
  sommaris_1_N = mkN "sommaris" ; -- sommaris..nn.1
  sommarjobb_1_N = mkN "sommarjobb" neutrum  ; -- sommarjobb..nn.1
  sommarjobba_1_V = mkV "sommarjobbar" ; -- sommarjobba..vb.1
  sommarjobbande_1_N = mkN "sommarjobbande" ; -- sommarjobbande..nn.1
  sommarjobbning_1_N = mkN "sommarjobbning" ; -- sommarjobbning..nn.1
  sommarklänning_1_N = mkN "sommarklänning" ; -- sommarklänning..nn.1
  sommarkostym_1_N = mkN "sommarkostym" "sommarkostymer" ; -- sommarkostym..nn.1
  sommarkväll_1_N = mkN "sommarkväll" ; -- sommarkväll..nn.1
  sommarkvällsdunkel_1_N = mkN "sommarkvällsdunkel" neutrum  ; -- sommarkvällsdunkel..nn.1
  sommarland_1_N = mkN "sommarland" neutrum  ; -- sommarland..nn.1
  sommarledig_1_A = mkA "sommarledig" ; -- sommarledig..av.1
  sommarledighet_1_N = mkN "sommarledighet" "sommarledigheter" ; -- sommarledighet..nn.1
  sommarlig_1_A = mkA "sommarlig" ; -- sommarlig..av.1
  sommarlov_1_N = mkN "sommarlov" neutrum  ; -- sommarlov..nn.1
  sommarlovsledig_1_A = mkA "sommarlovsledig" ; -- sommarlovsledig..av.1
  sommarluft_1_N = mkN "sommarluft" ; -- sommarluft..nn.1
  sommarläger_1_N = mkN "sommarläger" neutrum  ; -- sommarläger..nn.1
  sommarmoln_1_N = mkN "sommarmoln" neutrum  ; -- sommarmoln..nn.1
  sommarmånad_1_A = mkA "sommarmånad" ; -- sommarmånad..av.1
  sommarmörker_1_N = mkN "sommarmörker" neutrum  ; -- sommarmörker..nn.1
  sommarnatt_1_N = mkN "sommarnatt" "sommarnätter" ; -- sommarnatt..nn.1
  sommarnattsljus_1_N = mkN "sommarnattsljus" neutrum  ; -- sommarnattsljus..nn.1
  sommarnöje_1_N = mkN "sommarnöje" ; -- sommarnöje..nn.1
  sommarparadis_1_N = mkN "sommarparadis" neutrum  ; -- sommarparadis..nn.1
  sommarpotatis_1_N = mkN "sommarpotatis" ; -- sommarpotatis..nn.1
  sommarprat_1_N = mkN "sommarprat" neutrum  ; -- sommarprat..nn.1
  sommarprata_1_V = mkV "sommarpratar" ; -- sommarprata..vb.1
  sommarpratande_1_N = mkN "sommarpratande" ; -- sommarpratande..nn.1
  sommarpratare_1_N = mkN "sommarpratare" utrum  ; -- sommarpratare..nn.1
  sommarpratning_1_N = mkN "sommarpratning" ; -- sommarpratning..nn.1
  sommarregn_1_N = mkN "sommarregn" neutrum  ; -- sommarregn..nn.1
  sommarsemester_1_N = mkN "sommarsemester" ; -- sommarsemester..nn.1
  sommarsjuka_1_N = mkN "sommarsjuka" ; -- sommarsjuka..nn.1
  sommarsolstånd_1_N = mkN "sommarsolstånd" neutrum  ; -- sommarsolstånd..nn.1
  sommarspel_1_N = mkN "sommarspel" "sommarspelet" "sommarspel" "sommarspelen" ; -- sommarspel..nn.1
  sommarstuga_1_N = mkN "sommarstuga" ; -- sommarstuga..nn.1
  sommarstugeägare_1_N = mkN "sommarstugeägare" utrum  ; -- sommarstugeägare..nn.1
  sommarställe_1_N = mkN "sommarställe" ; -- sommarställe..nn.1
  sommarsvettig_1_A = mkA "sommarsvettig" ; -- sommarsvettig..av.1
  sommarsvettighet_1_N = mkN "sommarsvettighet" ; -- sommarsvettighet..nn.1
  sommartid_1_Adv = mkAdv "sommartid" ; -- sommartid..ab.1
  sommartid_1_N = mkN "sommartid" ; -- sommartid..nn.1
  sommartorka_1_N = mkN "sommartorka" ; -- sommartorka..nn.1
  sommartorp_1_N = mkN "sommartorp" neutrum  ; -- sommartorp..nn.1
  sommarturné_1_N = mkN "sommarturné" "sommarturnéer" ; -- sommarturné..nn.1
  sommarvarm_1_A = mkA "sommarvarm" ; -- sommarvarm..av.1
  sommarvecka_1_N = mkN "sommarvecka" ; -- sommarvecka..nn.1
  sommarvilla_1_N = mkN "sommarvilla" ; -- sommarvilla..nn.1
  sommarvind_1_N = mkN "sommarvind" ; -- sommarvind..nn.1
  sommarvindsomfladdrad_1_A = mkA "sommarvindsomfladdrad" ; -- sommarvindsomfladdrad..av.1
  sommarvistelse_1_N = mkN "sommarvistelse" "sommarvistelser" ; -- sommarvistelse..nn.1
  sommarväder_1_N = mkN "sommarväder" neutrum  ; -- sommarväder..nn.1
  sommarvärd_1_N = mkN "sommarvärd" ; -- sommarvärd..nn.1
  sommarvärme_1_N = mkN "sommarvärme" utrum  ; -- sommarvärme..nn.1
  sommaräng_1_N = mkN "sommaräng" ; -- sommaräng..nn.1
  somna_1_V = mkV "somnar" ; -- somna..vb.1
  somnambul_1_A = mkA "somnambul" ; -- somnambul..av.1
  somnambul_1_N = mkN "somnambul" "somnambuler" ; -- somnambul..nn.1
  somnambulisk_1_A = mkA "somnambulisk" ; -- somnambulisk..av.1
  somnambulism_1_N = mkN "somnambulism" "somnambulismer" ; -- somnambulism..nn.1
  somnande_1_N = mkN "somnande" ; -- somnande..nn.1
  somrig_1_A = mkA "somrig" ; -- somrig..av.1
  somrighet_1_N = mkN "somrighet" ; -- somrighet..nn.1
  son_namn_1_N = mkN "son-namn" neutrum  ; -- son-namn..nn.1
  son_1_N = mkN "son" "söner" ; -- son..nn.1
  sona_1_V = mkV "sonar" ; -- sona..vb.1
  sonande_1_N = mkN "sonande" ; -- sonande..nn.1
  sonant_1_N = mkN "sonant" "sonanter" ; -- sonant..nn.1
  sonantisk_1_A = mkA "sonantisk" ; -- sonantisk..av.1
  sonat_1_N = mkN "sonat" "sonater" ; -- sonat..nn.1
  sonatform_1_N = mkN "sonatform" ; -- sonatform..nn.1
  sonatin_1_N = mkN "sonatin" "sonatiner" ; -- sonatin..nn.1
  sond_1_N = mkN "sond" "sonder" ; -- sond..nn.1
  sondera_1_V = mkV "sonderar" ; -- sondera..vb.1
  sonderande_1_N = mkN "sonderande" ; -- sonderande..nn.1
  sonderbar_1_A = mkA "sonderbar" ; -- sonderbar..av.1
  sonderbarhet_1_N = mkN "sonderbarhet" ; -- sonderbarhet..nn.1
  sondering_1_N = mkN "sondering" ; -- sondering..nn.1
  sondmata_1_V = mkV "sondmatar" ; -- sondmata..vb.1
  sondmatande_1_N = mkN "sondmatande" ; -- sondmatande..nn.1
  sondmatning_1_N = mkN "sondmatning" ; -- sondmatning..nn.1
  sondotter_1_N = mkN "sondotter" "sondottern" "sondöttrar" "sondöttrarna" ; -- sondotter..nn.1
  sonett_1_N = mkN "sonett" "sonetter" ; -- sonett..nn.1
  sonhustru_1_N = mkN "sonhustru" "sonhustrun" "sonhustrur" "sonhustrurna" ; -- sonhustru..nn.1
  sonisk_1_A = mkA "sonisk" ; -- sonisk..av.1
  sonlig_1_A = mkA "sonlig" ; -- sonlig..av.1
  sonlighet_1_N = mkN "sonlighet" ; -- sonlighet..nn.1
  sonnamn_1_N = mkN "sonnamn" neutrum  ; -- sonnamn..nn.1
  sonor_1_A = mkA "sonor" ; -- sonor..av.1
  sonoritet_1_N = mkN "sonoritet" "sonoriteter" ; -- sonoritet..nn.1
  sonson_1_N = mkN "sonson" "sonsöner" ; -- sonson..nn.1
  sop_1_N = mkN "sop" ; -- sop..nn.1
  sopa_1_N = mkN "sopa" ; -- sopa..nn.1
  sopa_1_V = mkV "sopar" ; -- sopa..vb.1
  sopande_1_N = mkN "sopande" ; -- sopande..nn.1
  sopbacke_1_N = mkN "sopbacke" utrum  ; -- sopbacke..nn.1
  sopberg_1_N = mkN "sopberg" neutrum  ; -- sopberg..nn.1
  sopbil_1_N = mkN "sopbil" ; -- sopbil..nn.1
  sopborste_1_N = mkN "sopborste" utrum  ; -- sopborste..nn.1
  sopbälte_1_N = mkN "sopbälte" ; -- sopbälte..nn.1
  sophämtare_1_N = mkN "sophämtare" utrum  ; -- sophämtare..nn.1
  sophög_1_N = mkN "sophög" ; -- sophög..nn.1
  sopkvast_1_N = mkN "sopkvast" ; -- sopkvast..nn.1
  sopmaja_1_N = mkN "sopmaja" ; -- sopmaja..nn.1
  sopnedkast_1_N = mkN "sopnedkast" neutrum  ; -- sopnedkast..nn.1
  sopp_1_N = mkN "sopp" ; -- sopp..nn.1
  soppa_1_N = mkN "soppa" ; -- soppa..nn.1
  soppa_2_N = mkN "soppa" ; -- soppa..nn.2
  soppatorsk_1_N = mkN "soppatorsk" ; -- soppatorsk..nn.1
  soppförpackning_1_N = mkN "soppförpackning" ; -- soppförpackning..nn.1
  soppig_1_A = mkA "soppig" ; -- soppig..av.1
  soppighet_1_N = mkN "soppighet" ; -- soppighet..nn.1
  soppkök_1_N = mkN "soppkök" neutrum  ; -- soppkök..nn.1
  sopprot_1_N = mkN "sopprot" "sopprötter" ; -- sopprot..nn.1
  soppskål_1_N = mkN "soppskål" ; -- soppskål..nn.1
  soppslev_1_N = mkN "soppslev" ; -- soppslev..nn.1
  sopptallrik_1_N = mkN "sopptallrik" ; -- sopptallrik..nn.1
  soppåse_1_N = mkN "soppåse" utrum  ; -- soppåse..nn.1
  sopran_1_N = mkN "sopran" "sopraner" ; -- sopran..nn.1
  sopranklav_1_N = mkN "sopranklav" ; -- sopranklav..nn.1
  sopransångare_1_N = mkN "sopransångare" utrum  ; -- sopransångare..nn.1
  sopransångerska_1_N = mkN "sopransångerska" ; -- sopransångerska..nn.1
  sopskyffel_1_N = mkN "sopskyffel" ; -- sopskyffel..nn.1
  sopsortera_1_V = mkV "sopsorterar" ; -- sopsortera..vb.1
  sopsorterare_1_N = mkN "sopsorterare" utrum  ; -- sopsorterare..nn.1
  sopsortering_1_N = mkN "sopsortering" ; -- sopsortering..nn.1
  sopstation_1_N = mkN "sopstation" ; -- sopstation..nn.1
  sopsäck_1_N = mkN "sopsäck" ; -- sopsäck..nn.1
  sopsäckshållare_1_N = mkN "sopsäckshållare" utrum  ; -- sopsäckshållare..nn.1
  sopsäckskärra_1_N = mkN "sopsäckskärra" ; -- sopsäckskärra..nn.1
  soptipp_1_N = mkN "soptipp" ; -- soptipp..nn.1
  soptunna_1_N = mkN "soptunna" ; -- soptunna..nn.1
  sopåkare_1_N = mkN "sopåkare" utrum  ; -- sopåkare..nn.1
  sorb_1_N = mkN "sorb" "sorber" ; -- sorb..nn.1
  sorbet_1_N = mkN "sorbet" ; -- sorbet..nn.1
  sorbetglass_1_N = mkN "sorbetglass" ; -- sorbetglass..nn.1
  sordin_1_N = mkN "sordin" "sordiner" ; -- sordin..nn.1
  sordinera_1_V = mkV "sordinerar" ; -- sordinera..vb.1
  sordinerande_1_N = mkN "sordinerande" ; -- sordinerande..nn.1
  sordinerbar_1_A = mkA "sordinerbar" ; -- sordinerbar..av.1
  sordinerbarhet_1_N = mkN "sordinerbarhet" ; -- sordinerbarhet..nn.1
  sordinering_1_N = mkN "sordinering" ; -- sordinering..nn.1
  sorg_1_N = mkN "sorg" "sorger" ; -- sorg..nn.1
  sorgband_1_N = mkN "sorgband" neutrum  ; -- sorgband..nn.1
  sorgbarn_1_N = mkN "sorgbarn" neutrum  ; -- sorgbarn..nn.1
  sorgbetonad_1_A = mkA "sorgbetonad" ; -- sorgbetonad..av.1
  sorgbunden_1_A = mkA "sorgbunden" ; -- sorgbunden..av.1
  sorgbundenhet_1_N = mkN "sorgbundenhet" ; -- sorgbundenhet..nn.1
  sorgdok_1_N = mkN "sorgdok" neutrum  ; -- sorgdok..nn.1
  sorgdräkt_1_N = mkN "sorgdräkt" "sorgdräkter" ; -- sorgdräkt..nn.1
  sorgeakt_1_N = mkN "sorgeakt" "sorgeakter" ; -- sorgeakt..nn.1
  sorgearbete_1_N = mkN "sorgearbete" ; -- sorgearbete..nn.1
  sorgebarn_1_N = mkN "sorgebarn" neutrum  ; -- sorgebarn..nn.1
  sorgebetygelse_1_N = mkN "sorgebetygelse" "sorgebetygelser" ; -- sorgebetygelse..nn.1
  sorgebud_1_N = mkN "sorgebud" neutrum  ; -- sorgebud..nn.1
  sorgebudskap_1_N = mkN "sorgebudskap" neutrum  ; -- sorgebudskap..nn.1
  sorgedag_1_N = mkN "sorgedag" ; -- sorgedag..nn.1
  sorgegudstjänst_1_N = mkN "sorgegudstjänst" "sorgegudstjänster" ; -- sorgegudstjänst..nn.1
  sorgehus_1_N = mkN "sorgehus" neutrum  ; -- sorgehus..nn.1
  sorgekväde_1_N = mkN "sorgekväde" ; -- sorgekväde..nn.1
  sorgelåt_1_N = mkN "sorgelåt" ; -- sorgelåt..nn.1
  sorgemusik_1_N = mkN "sorgemusik" ; -- sorgemusik..nn.1
  sorgeprocess_1_N = mkN "sorgeprocess" "sorgeprocesser" ; -- sorgeprocess..nn.1
  sorgeritual_1_N = mkN "sorgeritual" "sorgeritualer" ; -- sorgeritual..nn.1
  sorgesam_1_A = mkA "sorgesam" "sorgesamt" "sorgesamma" "sorgesamma" "sorgesammare" "sorgesammast" "sorgesammaste" ; -- sorgesam..av.1
  sorgesamhet_1_N = mkN "sorgesamhet" ; -- sorgesamhet..nn.1
  sorgespel_1_N = mkN "sorgespel" "sorgespelet" "sorgespel" "sorgespelen" ; -- sorgespel..nn.1
  sorgestund_1_N = mkN "sorgestund" "sorgestunder" ; -- sorgestund..nn.1
  sorgesång_1_N = mkN "sorgesång" "sorgesånger" ; -- sorgesång..nn.1
  sorgetid_1_N = mkN "sorgetid" ; -- sorgetid..nn.1
  sorgetåg_1_N = mkN "sorgetåg" neutrum  ; -- sorgetåg..nn.1
  sorgeämne_1_N = mkN "sorgeämne" ; -- sorgeämne..nn.1
  sorgeår_1_N = mkN "sorgeår" neutrum  ; -- sorgeår..nn.1
  sorgflor_1_N = mkN "sorgflor" neutrum  ; -- sorgflor..nn.1
  sorgfri_1_A = mkA "sorgfri" "sorgfritt" ; -- sorgfri..av.1
  sorgfrihet_1_N = mkN "sorgfrihet" ; -- sorgfrihet..nn.1
  sorgfull_1_A = mkA "sorgfull" ; -- sorgfull..av.1
  sorgfällig_1_A = mkA "sorgfällig" ; -- sorgfällig..av.1
  sorgfällighet_1_N = mkN "sorgfällighet" ; -- sorgfällighet..nn.1
  sorgfärg_1_N = mkN "sorgfärg" "sorgfärger" ; -- sorgfärg..nn.1
  sorgkant_1_N = mkN "sorgkant" "sorgkanter" ; -- sorgkant..nn.1
  sorgkantad_1_A = mkA "sorgkantad" ; -- sorgkantad..av.1
  sorgklädd_1_A = mkA "sorgklädd" ; -- sorgklädd..av.1
  sorglig_1_A = mkA "sorglig" ; -- sorglig..av.1
  sorglighet_1_N = mkN "sorglighet" "sorgligheter" ; -- sorglighet..nn.1
  sorglustig_1_A = mkA "sorglustig" ; -- sorglustig..av.1
  sorglustighet_1_N = mkN "sorglustighet" ; -- sorglustighet..nn.1
  sorglös_1_A = mkA "sorglös" ; -- sorglös..av.1
  sorglöshet_1_N = mkN "sorglöshet" "sorglösheter" ; -- sorglöshet..nn.1
  sorgmantel_1_N = mkN "sorgmantel" ; -- sorgmantel..nn.1
  sorgmarsch_1_N = mkN "sorgmarsch" "sorgmarscher" ; -- sorgmarsch..nn.1
  sorgmod_1_N = mkN "sorgmod" neutrum  ; -- sorgmod..nn.1
  sorgmodig_1_A = mkA "sorgmodig" ; -- sorgmodig..av.1
  sorgmodighet_1_N = mkN "sorgmodighet" ; -- sorgmodighet..nn.1
  sorgmusik_1_N = mkN "sorgmusik" ; -- sorgmusik..nn.1
  sorgpil_1_N = mkN "sorgpil" ; -- sorgpil..nn.1
  sorgsalut_1_N = mkN "sorgsalut" "sorgsaluter" ; -- sorgsalut..nn.1
  sorgsen_1_A = mkA "sorgsen" ; -- sorgsen..av.1
  sorgsenhet_1_N = mkN "sorgsenhet" ; -- sorgsenhet..nn.1
  sorgslöja_1_N = mkN "sorgslöja" ; -- sorgslöja..nn.1
  sorgtyngd_1_A = mkA "sorgtyngd" "sorgtyngt" ; -- sorgtyngd..av.1
  sorgtyngdhet_1_N = mkN "sorgtyngdhet" ; -- sorgtyngdhet..nn.1
  sork_1_N = mkN "sork" ; -- sork..nn.1
  sorkvirus_1_N = mkN "sorkvirus" neutrum  ; -- sorkvirus..nn.1
  sorl_1_N = mkN "sorl" neutrum  ; -- sorl..nn.1
  sorla_1_V = mkV "sorlar" ; -- sorla..vb.1
  sorlande_1_N = mkN "sorlande" ; -- sorlande..nn.1
  sort_1_N = mkN "sort" "sorter" ; -- sort..nn.1
  sortera_1_V = mkV "sorterar" ; -- sortera..vb.1
  sorterande_1_N = mkN "sorterande" ; -- sorterande..nn.1
  sorterare_1_N = mkN "sorterare" utrum  ; -- sorterare..nn.1
  sorterbar_1_A = mkA "sorterbar" ; -- sorterbar..av.1
  sorterbarhet_1_N = mkN "sorterbarhet" ; -- sorterbarhet..nn.1
  sortering_1_N = mkN "sortering" ; -- sortering..nn.1
  sorteringsverk_1_N = mkN "sorteringsverk" neutrum  ; -- sorteringsverk..nn.1
  sorti_1_N = mkN "sorti" "sortier" ; -- sorti..nn.1
  sortiment_1_N = mkN "sortiment" neutrum  ; -- sortiment..nn.1
  sortimentask_1_N = mkN "sortimentask" ; -- sortimentask..nn.1
  sorts_1_A = mkA "sorts" ; -- sorts..av.1
  sosse_1_N = mkN "sosse" utrum  ; -- sosse..nn.1
  sossekvinna_1_N = mkN "sossekvinna" ; -- sossekvinna..nn.1
  sot_1_N = mkN "sot" neutrum  ; -- sot..nn.1
  sot_2_N = mkN "sot" ; -- sot..nn.2
  sota_1_V = mkV "sotar" ; -- sota..vb.1
  sota_2_V = mkV "sotar" ; -- sota..vb.2
  sotande_1_N = mkN "sotande" ; -- sotande..nn.1
  sotare_1_N = mkN "sotare" utrum  ; -- sotare..nn.1
  sotarmurre_1_N = mkN "sotarmurre" utrum  ; -- sotarmurre..nn.1
  sotarspråk_1_N = mkN "sotarspråk" neutrum  ; -- sotarspråk..nn.1
  sotbildning_1_N = mkN "sotbildning" ; -- sotbildning..nn.1
  sotbrand_1_N = mkN "sotbrand" "sotbränder" ; -- sotbrand..nn.1
  sotdöd_1_A = mkA "sotdöd" "sotdött" ; -- sotdöd..av.1
  sotdöd_1_N = mkN "sotdöd" ; -- sotdöd..nn.1
  soteld_1_N = mkN "soteld" ; -- soteld..nn.1
  sothöna_1_N = mkN "sothöna" ; -- sothöna..nn.1
  sotig_1_A = mkA "sotig" ; -- sotig..av.1
  sotis_1_A = mkA "sotis" ; -- sotis..av.1
  sotmoln_1_N = mkN "sotmoln" neutrum  ; -- sotmoln..nn.1
  sotning_1_N = mkN "sotning" ; -- sotning..nn.1
  sotpartikel_1_N = mkN "sotpartikel" ; -- sotpartikel..nn.1
  sotskikt_1_N = mkN "sotskikt" neutrum  ; -- sotskikt..nn.1
  sotsvamp_1_N = mkN "sotsvamp" ; -- sotsvamp..nn.1
  sotsvart_1_A = mkA "sotsvart" "sotsvart" ; -- sotsvart..av.1
  sotsäng_1_N = mkN "sotsäng" ; -- sotsäng..nn.1
  sottis_1_N = mkN "sottis" "sottiser" ; -- sottis..nn.1
  sotutsläpp_1_N = mkN "sotutsläpp" neutrum  ; -- sotutsläpp..nn.1
  soul_1_N = mkN "soul" ; -- soul..nn.1
  soulagemang_1_N = mkN "soulagemang" neutrum  ; -- soulagemang..nn.1
  soulagera_1_V = mkV "soulagerar" ; -- soulagera..vb.1
  soulagerande_1_N = mkN "soulagerande" ; -- soulagerande..nn.1
  soulagerbar_1_A = mkA "soulagerbar" ; -- soulagerbar..av.1
  soulagerbarhet_1_N = mkN "soulagerbarhet" ; -- soulagerbarhet..nn.1
  soulagering_1_N = mkN "soulagering" ; -- soulagering..nn.1
  soulmusik_1_N = mkN "soulmusik" ; -- soulmusik..nn.1
  soumak_1_N = mkN "soumak" ; -- soumak..nn.1
  sound_1_N = mkN "sound" neutrum  ; -- sound..nn.1
  soundmässig_1_A = mkA "soundmässig" ; -- soundmässig..av.1
  sousafon_1_N = mkN "sousafon" "sousafoner" ; -- sousafon..nn.1
  souschef_1_N = mkN "souschef" "souschefer" ; -- souschef..nn.1
  souterrain_1_N = mkN "souterrain" "souterrainer" ; -- souterrain..nn.1
  souterrainbyggnad_1_N = mkN "souterrainbyggnad" "souterrainbyggnader" ; -- souterrainbyggnad..nn.1
  souterrainhus_1_N = mkN "souterrainhus" neutrum  ; -- souterrainhus..nn.1
  souterrainplan_1_N = mkN "souterrainplan" neutrum  ; -- souterrainplan..nn.1
  souterrainvåning_1_N = mkN "souterrainvåning" ; -- souterrainvåning..nn.1
  souterräng_1_N = mkN "souterräng" "souterränger" ; -- souterräng..nn.1
  souterrängbyggnad_1_N = mkN "souterrängbyggnad" "souterrängbyggnader" ; -- souterrängbyggnad..nn.1
  souterränghus_1_N = mkN "souterränghus" neutrum  ; -- souterränghus..nn.1
  souterrängplan_1_N = mkN "souterrängplan" neutrum  ; -- souterrängplan..nn.1
  souterrängvåning_1_N = mkN "souterrängvåning" ; -- souterrängvåning..nn.1
  souvenir_1_N = mkN "souvenir" "souvenirer" ; -- souvenir..nn.1
  sova_1_V = mkV "sova" "sov" "sovit" ; -- sova..vb.1
  sovande_1_A = mkA "sovande" ; -- sovande..av.1
  sovande_1_N = mkN "sovande" ; -- sovande..nn.1
  sovbrits_1_N = mkN "sovbrits" ; -- sovbrits..nn.1
  sovchos_1_N = mkN "sovchos" "sovchoser" ; -- sovchos..nn.1
  sovdags_1_N = mkN "sovdags" ; -- sovdags..nn.1
  sovel_1_N = mkN "sovel" neutrum  ; -- sovel..nn.1
  sovgemak_1_N = mkN "sovgemak" neutrum  ; -- sovgemak..nn.1
  sovjet_1_N = mkN "sovjet" "sovjeter" ; -- sovjet..nn.1
  sovjetisera_1_V = mkV "sovjetiserar" ; -- sovjetisera..vb.1
  sovjetiserande_1_N = mkN "sovjetiserande" ; -- sovjetiserande..nn.1
  sovjetiserbar_1_A = mkA "sovjetiserbar" ; -- sovjetiserbar..av.1
  sovjetiserbarhet_1_N = mkN "sovjetiserbarhet" ; -- sovjetiserbarhet..nn.1
  sovjetisering_1_N = mkN "sovjetisering" ; -- sovjetisering..nn.1
  sovjetisk_1_A = mkA "sovjetisk" ; -- sovjetisk..av.1
  sovjetmedborgare_1_N = mkN "sovjetmedborgare" utrum  ; -- sovjetmedborgare..nn.1
  sovjetrepublik_1_N = mkN "sovjetrepublik" "sovjetrepubliker" ; -- sovjetrepublik..nn.1
  sovjetrysk_1_A = mkA "sovjetrysk" ; -- sovjetrysk..av.1
  sovjetunderstödd_1_A = mkA "sovjetunderstödd" ; -- sovjetunderstödd..av.1
  sovmask_1_N = mkN "sovmask" "sovmasker" ; -- sovmask..nn.1
  sovmorgon_1_N = mkN "sovmorgon" "sovmorgonen" "sovmornar" "sovmornarna" ; -- sovmorgon..nn.1
  sovplats_1_N = mkN "sovplats" "sovplatser" ; -- sovplats..nn.1
  sovra_1_V = mkV "sovrar" ; -- sovra..vb.1
  sovrande_1_N = mkN "sovrande" ; -- sovrande..nn.1
  sovrum_1_N = mkN "sovrum" "sovrummet" "sovrum" "sovrummen" ; -- sovrum..nn.1
  sovrumsfönster_1_N = mkN "sovrumsfönster" neutrum  ; -- sovrumsfönster..nn.1
  sovsal_1_N = mkN "sovsal" ; -- sovsal..nn.1
  sovstad_1_N = mkN "sovstad" "sovstäder" ; -- sovstad..nn.1
  sovställning_1_N = mkN "sovställning" ; -- sovställning..nn.1
  sovsäck_1_N = mkN "sovsäck" ; -- sovsäck..nn.1
  sovvagn_1_N = mkN "sovvagn" ; -- sovvagn..nn.1
  sovvagnsbiljett_1_N = mkN "sovvagnsbiljett" "sovvagnsbiljetter" ; -- sovvagnsbiljett..nn.1
  spa_1_N = mkN "spa" "spat" "span" "spana" ; -- spa..nn.1
  spackel_1_N = mkN "spackel" neutrum  ; -- spackel..nn.1
  spackel_2_N = mkN "spackel" ; -- spackel..nn.2
  spackelkniv_1_N = mkN "spackelkniv" ; -- spackelkniv..nn.1
  spackla_1_V = mkV "spacklar" ; -- spackla..vb.1
  spacklande_1_N = mkN "spacklande" ; -- spacklande..nn.1
  spackling_1_N = mkN "spackling" ; -- spackling..nn.1
  spad_1_N = mkN "spad" neutrum  ; -- spad..nn.1
  spade_1_N = mkN "spade" utrum  ; -- spade..nn.1
  spader_1_N = mkN "spader" "spadern" "spader" "spaderna" ; -- spader..nn.1
  spadtag_1_N = mkN "spadtag" neutrum  ; -- spadtag..nn.1
  spadvända_1_V = mkV "spadvänder" ; -- spadvända..vb.1
  spadvändande_1_N = mkN "spadvändande" ; -- spadvändande..nn.1
  spagat_1_N = mkN "spagat" ; -- spagat..nn.1
  spak_1_A = mkA "spak" ; -- spak..av.1
  spak_1_N = mkN "spak" ; -- spak..nn.1
  spaka_1_V = mkV "spakar" ; -- spaka..vb.1
  spakande_1_N = mkN "spakande" ; -- spakande..nn.1
  spakblock_1_N = mkN "spakblock" neutrum  ; -- spakblock..nn.1
  spakhet_1_N = mkN "spakhet" ; -- spakhet..nn.1
  spakna_1_V = mkV "spaknar" ; -- spakna..vb.1
  spaknande_1_N = mkN "spaknande" ; -- spaknande..nn.1
  spaljera_1_V = mkV "spaljerar" ; -- spaljera..vb.1
  spaljerande_1_N = mkN "spaljerande" ; -- spaljerande..nn.1
  spaljerbar_1_A = mkA "spaljerbar" ; -- spaljerbar..av.1
  spaljerbarhet_1_N = mkN "spaljerbarhet" ; -- spaljerbarhet..nn.1
  spaljering_1_N = mkN "spaljering" ; -- spaljering..nn.1
  spaljé_1_N = mkN "spaljé" "spaljéer" ; -- spaljé..nn.1
  spallation_1_N = mkN "spallation" ; -- spallation..nn.1
  spallera_1_V = mkV "spallerar" ; -- spallera..vb.1
  spallerande_1_N = mkN "spallerande" ; -- spallerande..nn.1
  spallerbar_1_A = mkA "spallerbar" ; -- spallerbar..av.1
  spallerbarhet_1_N = mkN "spallerbarhet" ; -- spallerbarhet..nn.1
  spallering_1_N = mkN "spallering" ; -- spallering..nn.1
  spalt_1_N = mkN "spalt" "spalter" ; -- spalt..nn.1
  spalta_1_V = mkV "spaltar" ; -- spalta..vb.1
  spaltande_1_N = mkN "spaltande" ; -- spaltande..nn.1
  spaltfyllnad_1_N = mkN "spaltfyllnad" "spaltfyllnader" ; -- spaltfyllnad..nn.1
  spaltkilometer_1_N = mkN "spaltkilometer" ; -- spaltkilometer..nn.1
  spaltkorrektur_1_N = mkN "spaltkorrektur" neutrum  ; -- spaltkorrektur..nn.1
  spaltläder_1_N = mkN "spaltläder" neutrum  ; -- spaltläder..nn.1
  spam_1_N = mkN "spam" neutrum  ; -- spam..nn.1
  spamfilter_1_N = mkN "spamfilter" neutrum  ; -- spamfilter..nn.1
  spamm_1_N = mkN "spamm" neutrum  ; -- spamm..nn.1
  spamma_1_V = mkV "spammar" ; -- spamma..vb.1
  spammande_1_N = mkN "spammande" ; -- spammande..nn.1
  spamning_1_N = mkN "spamning" ; -- spamning..nn.1
  spana_1_V = mkV "spanar" ; -- spana..vb.1
  spanande_1_N = mkN "spanande" ; -- spanande..nn.1
  spanare_1_N = mkN "spanare" utrum  ; -- spanare..nn.1
  spaniel_1_N = mkN "spaniel" "spanieln" "spaniels" "spanielarna" ; -- spaniel..nn.1
  spaning_1_N = mkN "spaning" ; -- spaning..nn.1
  spaningsflyg_1_N = mkN "spaningsflyg" neutrum  ; -- spaningsflyg..nn.1
  spaningsmord_1_N = mkN "spaningsmord" neutrum  ; -- spaningsmord..nn.1
  spaningspatrull_1_N = mkN "spaningspatrull" "spaningspatruller" ; -- spaningspatrull..nn.1
  spaningsplan_1_N = mkN "spaningsplan" neutrum  ; -- spaningsplan..nn.1
  spaningsuppdrag_1_N = mkN "spaningsuppdrag" neutrum  ; -- spaningsuppdrag..nn.1
  spanjolett_1_N = mkN "spanjolett" "spanjoletter" ; -- spanjolett..nn.1
  spanjolettfönster_1_N = mkN "spanjolettfönster" neutrum  ; -- spanjolettfönster..nn.1
  spanjor_1_N = mkN "spanjor" "spanjoren" "spanjorer" "spanjorerna" ; -- spanjor..nn.1
  spanjorska_1_N = mkN "spanjorska" ; -- spanjorska..nn.1
  spankulera_1_V = mkV "spankulerar" ; -- spankulera..vb.1
  spankulerande_1_N = mkN "spankulerande" ; -- spankulerande..nn.1
  spankulering_1_N = mkN "spankulering" ; -- spankulering..nn.1
  spann_1_N = mkN "spann" ; -- spann..nn.1
  spann_2_N = mkN "spann" ; -- spann..nn.2
  spann_3_N = mkN "spann" neutrum  ; -- spann..nn.3
  spannmål_1_N = mkN "spannmål" ; -- spannmål..nn.1
  spannmålsförsörjning_1_N = mkN "spannmålsförsörjning" ; -- spannmålsförsörjning..nn.1
  spannmålshandel_1_N = mkN "spannmålshandel" ; -- spannmålshandel..nn.1
  spannmålsleverans_1_N = mkN "spannmålsleverans" "spannmålsleveranser" ; -- spannmålsleverans..nn.1
  spannmålsmagasin_1_N = mkN "spannmålsmagasin" neutrum  ; -- spannmålsmagasin..nn.1
  spannmålsskörd_1_N = mkN "spannmålsskörd" ; -- spannmålsskörd..nn.1
  spannmålssmuggling_1_N = mkN "spannmålssmuggling" ; -- spannmålssmuggling..nn.1
  spansk_1_A = mkA "spansk" ; -- spansk..av.1
  spanska_1_N = mkN "spanska" ; -- spanska..nn.1
  spanskhet_1_N = mkN "spanskhet" ; -- spanskhet..nn.1
  spanskrör_1_N = mkN "spanskrör" neutrum  ; -- spanskrör..nn.1
  spanskspråkig_1_A = mkA "spanskspråkig" ; -- spanskspråkig..av.1
  spanskspråkighet_1_N = mkN "spanskspråkighet" ; -- spanskspråkighet..nn.1
  spansktalande_1_A = mkA "spansktalande" ; -- spansktalande..av.1
  spanskvälde_1_N = mkN "spanskvälde" ; -- spanskvälde..nn.1
  spant_1_N = mkN "spant" neutrum  ; -- spant..nn.1
  spara_1_V = mkV "spara" "sparade" "sparat" ; -- spara..vb.1
  spara_2_V = mkV "sparar" ; -- spara..vb.2
  sparagmit_1_N = mkN "sparagmit" "sparagmiter" ; -- sparagmit..nn.1
  sparande_1_N = mkN "sparande" ; -- sparande..nn.1
  sparare_1_N = mkN "sparare" utrum  ; -- sparare..nn.1
  sparbank_1_N = mkN "sparbank" "sparbanker" ; -- sparbank..nn.1
  sparbanksbok_1_N = mkN "sparbanksbok" "sparbanksböcker" ; -- sparbanksbok..nn.1
  sparbeting_1_N = mkN "sparbeting" neutrum  ; -- sparbeting..nn.1
  sparbössa_1_N = mkN "sparbössa" ; -- sparbössa..nn.1
  sparform_1_N = mkN "sparform" "sparformer" ; -- sparform..nn.1
  spargris_1_N = mkN "spargris" ; -- spargris..nn.1
  spark_1_N = mkN "spark" ; -- spark..nn.1
  sparka_1_V = mkV "sparkar" ; -- sparka..vb.1
  sparkande_1_N = mkN "sparkande" ; -- sparkande..nn.1
  sparkassa_1_N = mkN "sparkassa" ; -- sparkassa..nn.1
  sparkbyxa_1_N = mkN "sparkbyxa" ; -- sparkbyxa..nn.1
  sparkcykel_1_N = mkN "sparkcykel" ; -- sparkcykel..nn.1
  sparkdräkt_1_N = mkN "sparkdräkt" "sparkdräkter" ; -- sparkdräkt..nn.1
  sparknummer_1_N = mkN "sparknummer" neutrum  ; -- sparknummer..nn.1
  sparkonto_1_N = mkN "sparkonto" "sparkontot" "sparkonton" "sparkontona" ; -- sparkonto..nn.1
  sparkrav_1_N = mkN "sparkrav" neutrum  ; -- sparkrav..nn.1
  sparkstötting_1_N = mkN "sparkstötting" ; -- sparkstötting..nn.1
  sparkur_1_N = mkN "sparkur" "sparkurer" ; -- sparkur..nn.1
  sparlakan_1_N = mkN "sparlakan" neutrum  ; -- sparlakan..nn.1
  sparlakansläxa_1_N = mkN "sparlakansläxa" ; -- sparlakansläxa..nn.1
  sparlåga_1_N = mkN "sparlåga" ; -- sparlåga..nn.1
  sparlån_1_N = mkN "sparlån" neutrum  ; -- sparlån..nn.1
  sparpaket_1_N = mkN "sparpaket" neutrum  ; -- sparpaket..nn.1
  sparra_1_V = mkV "sparrar" ; -- sparra..vb.1
  sparrande_1_N = mkN "sparrande" ; -- sparrande..nn.1
  sparre_1_N = mkN "sparre" utrum  ; -- sparre..nn.1
  sparring_1_N = mkN "sparring" ; -- sparring..nn.1
  sparringpartner_1_N = mkN "sparringpartner" "sparringpartnern" "sparringpartners" "sparringpartnersen" ; -- sparringpartner..nn.1
  sparris_1_N = mkN "sparris" ; -- sparris..nn.1
  sparrissoppa_1_N = mkN "sparrissoppa" ; -- sparrissoppa..nn.1
  sparsam_1_A = mkA "sparsam" "sparsamt" "sparsamma" "sparsamma" "sparsammare" "sparsammast" "sparsammaste" ; -- sparsam..av.1
  sparsamhet_1_N = mkN "sparsamhet" ; -- sparsamhet..nn.1
  sparslant_1_N = mkN "sparslant" ; -- sparslant..nn.1
  sparsmakad_1_A = mkA "sparsmakad" ; -- sparsmakad..av.1
  spartakist_1_N = mkN "spartakist" "spartakister" ; -- spartakist..nn.1
  spartan_1_N = mkN "spartan" "spartaner" ; -- spartan..nn.1
  spartansk_1_A = mkA "spartansk" ; -- spartansk..av.1
  sparv_1_N = mkN "sparv" ; -- sparv..nn.1
  sparvfink_1_N = mkN "sparvfink" ; -- sparvfink..nn.1
  sparvhök_1_N = mkN "sparvhök" ; -- sparvhök..nn.1
  sparvuggla_1_N = mkN "sparvuggla" ; -- sparvuggla..nn.1
  spasm_1_N = mkN "spasm" "spasmer" ; -- spasm..nn.1
  spasmodisk_1_A = mkA "spasmodisk" ; -- spasmodisk..av.1
  spasticitet_1_N = mkN "spasticitet" "spasticiteter" ; -- spasticitet..nn.1
  spastiker_1_N = mkN "spastiker" "spastikern" "spastiker" "spastikerna" ; -- spastiker..nn.1
  spastisk_1_A = mkA "spastisk" ; -- spastisk..av.1
  spatel_1_N = mkN "spatel" ; -- spatel..nn.1
  spatial_1_A = mkA "spatial" ; -- spatial..av.1
  spatium_1_N = mkN "spatium" "spatiet" "spatier" "spatierna" ; -- spatium..nn.1
  spatiös_1_A = mkA "spatiös" ; -- spatiös..av.1
  spatsera_1_V = mkV "spatserar" ; -- spatsera..vb.1
  spatserande_1_N = mkN "spatserande" ; -- spatserande..nn.1
  spatserfärd_1_N = mkN "spatserfärd" "spatserfärder" ; -- spatserfärd..nn.1
  spatsering_1_N = mkN "spatsering" ; -- spatsering..nn.1
  spatsertur_1_N = mkN "spatsertur" "spatserturer" ; -- spatsertur..nn.1
  spatt_1_N = mkN "spatt" ; -- spatt..nn.1
  spattig_1_A = mkA "spattig" ; -- spattig..av.1
  spattighet_1_N = mkN "spattighet" "spattigheter" ; -- spattighet..nn.1
  spe_1_N = mkN "spe" ; -- spe..nn.1
  speaker_1_N = mkN "speaker" "speakern" "speakers" "speakersen" ; -- speaker..nn.1
  spearing_1_N = mkN "spearing" ; -- spearing..nn.1
  speceriaffär_1_N = mkN "speceriaffär" "speceriaffärer" ; -- speceriaffär..nn.1
  specerihandlare_1_N = mkN "specerihandlare" utrum  ; -- specerihandlare..nn.1
  specerist_1_N = mkN "specerist" "specerister" ; -- specerist..nn.1
  special_1_N = mkN "special" "specialer" ; -- special..nn.1
  specialanpassad_1_A = mkA "specialanpassad" ; -- specialanpassad..av.1
  specialarbete_1_N = mkN "specialarbete" ; -- specialarbete..nn.1
  specialare_1_N = mkN "specialare" utrum  ; -- specialare..nn.1
  specialbegåvning_1_N = mkN "specialbegåvning" ; -- specialbegåvning..nn.1
  specialbeställa_1_V = mkV "specialbeställer" ; -- specialbeställa..vb.1
  specialbeställande_1_N = mkN "specialbeställande" ; -- specialbeställande..nn.1
  specialbeställning_1_N = mkN "specialbeställning" ; -- specialbeställning..nn.1
  specialdammsugare_1_N = mkN "specialdammsugare" utrum  ; -- specialdammsugare..nn.1
  specialdestinerad_1_A = mkA "specialdestinerad" ; -- specialdestinerad..av.1
  specialdomstol_1_N = mkN "specialdomstol" ; -- specialdomstol..nn.1
  specialeffekt_1_N = mkN "specialeffekt" "specialeffekter" ; -- specialeffekt..nn.1
  specialgjord_1_A = mkA "specialgjord" "specialgjort" ; -- specialgjord..av.1
  specialintresse_1_N = mkN "specialintresse" ; -- specialintresse..nn.1
  specialintresserad_1_A = mkA "specialintresserad" ; -- specialintresserad..av.1
  specialisera_1_V = mkV "specialiserar" ; -- specialisera..vb.1
  specialiserande_1_N = mkN "specialiserande" ; -- specialiserande..nn.1
  specialiserbar_1_A = mkA "specialiserbar" ; -- specialiserbar..av.1
  specialiserbarhet_1_N = mkN "specialiserbarhet" ; -- specialiserbarhet..nn.1
  specialisering_1_N = mkN "specialisering" ; -- specialisering..nn.1
  specialist_1_N = mkN "specialist" "specialister" ; -- specialist..nn.1
  specialistkompetens_1_N = mkN "specialistkompetens" "specialistkompetenser" ; -- specialistkompetens..nn.1
  specialistvård_1_N = mkN "specialistvård" ; -- specialistvård..nn.1
  specialitet_1_N = mkN "specialitet" "specialiteter" ; -- specialitet..nn.1
  specialkarta_1_N = mkN "specialkarta" ; -- specialkarta..nn.1
  specialklass_1_N = mkN "specialklass" "specialklasser" ; -- specialklass..nn.1
  specialkommando_1_N = mkN "specialkommando" "specialkommandot" "specialkommandon" "specialkommandona" ; -- specialkommando..nn.1
  specialkomponerad_1_A = mkA "specialkomponerad" ; -- specialkomponerad..av.1
  speciallagstftning_1_N = mkN "speciallagstftning" ; -- speciallagstftning..nn.1
  speciallärare_1_N = mkN "speciallärare" utrum  ; -- speciallärare..nn.1
  specialmotivering_1_N = mkN "specialmotivering" ; -- specialmotivering..nn.1
  specialnummer_1_N = mkN "specialnummer" neutrum  ; -- specialnummer..nn.1
  specialområde_1_N = mkN "specialområde" ; -- specialområde..nn.1
  specialproblem_1_N = mkN "specialproblem" neutrum  ; -- specialproblem..nn.1
  specialskola_1_N = mkN "specialskola" ; -- specialskola..nn.1
  specialskriven_1_A = mkA "specialskriven" ; -- specialskriven..av.1
  specialstudium_1_N = mkN "specialstudium" "specialstudiet" "specialstudier" "specialstudierna" ; -- specialstudium..nn.1
  specialstyrka_1_N = mkN "specialstyrka" ; -- specialstyrka..nn.1
  specialstål_1_N = mkN "specialstål" neutrum  ; -- specialstål..nn.1
  specialtillstånd_1_N = mkN "specialtillstånd" neutrum  ; -- specialtillstånd..nn.1
  specialtillverka_1_V = mkV "specialtillverkar" ; -- specialtillverka..vb.1
  specialtillverkande_1_N = mkN "specialtillverkande" ; -- specialtillverkande..nn.1
  specialtillverkning_1_N = mkN "specialtillverkning" ; -- specialtillverkning..nn.1
  specialtränad_1_A = mkA "specialtränad" ; -- specialtränad..av.1
  specialtåg_1_N = mkN "specialtåg" neutrum  ; -- specialtåg..nn.1
  specialundervisning_1_N = mkN "specialundervisning" ; -- specialundervisning..nn.1
  specialutformad_1_A = mkA "specialutformad" ; -- specialutformad..av.1
  specie_1_N = mkN "specie" "specier" ; -- specie..nn.1
  speciell_1_A = mkA "speciell" ; -- speciell..av.1
  species_1_N = mkN "species" neutrum  ; -- species..nn.1
  specificera_1_V = mkV "specificerar" ; -- specificera..vb.1
  specificerande_1_N = mkN "specificerande" ; -- specificerande..nn.1
  specificerbar_1_A = mkA "specificerbar" ; -- specificerbar..av.1
  specificerbarhet_1_N = mkN "specificerbarhet" ; -- specificerbarhet..nn.1
  specificering_1_N = mkN "specificering" ; -- specificering..nn.1
  specifik_1_A = mkA "specifik" ; -- specifik..av.1
  specifikation_1_N = mkN "specifikation" ; -- specifikation..nn.1
  specimen_1_N = mkN "specimen" neutrum  ; -- specimen..nn.1
  speciminera_1_V = mkV "speciminerar" ; -- speciminera..vb.1
  speciminerande_1_N = mkN "speciminerande" ; -- speciminerande..nn.1
  speciminerbar_1_A = mkA "speciminerbar" ; -- speciminerbar..av.1
  speciminerbarhet_1_N = mkN "speciminerbarhet" ; -- speciminerbarhet..nn.1
  speciminering_1_N = mkN "speciminering" ; -- speciminering..nn.1
  specnaz_1_N = mkN "specnaz" ; -- specnaz..nn.1
  spedition_1_N = mkN "spedition" ; -- spedition..nn.1
  speditör_1_N = mkN "speditör" "speditörer" ; -- speditör..nn.1
  speed_1_N = mkN "speed" ; -- speed..nn.1
  speedway_1_N = mkN "speedway" ; -- speedway..nn.1
  speedwaybana_1_N = mkN "speedwaybana" ; -- speedwaybana..nn.1
  spefull_1_A = mkA "spefull" ; -- spefull..av.1
  spefullhet_1_N = mkN "spefullhet" "spefullheter" ; -- spefullhet..nn.1
  spefylld_1_A = mkA "spefylld" "spefyllt" ; -- spefylld..av.1
  spefylldhet_1_N = mkN "spefylldhet" ; -- spefylldhet..nn.1
  spefågel_1_N = mkN "spefågel" ; -- spefågel..nn.1
  spegel_1_N = mkN "spegel" ; -- spegel..nn.1
  spegelbild_1_N = mkN "spegelbild" "spegelbilder" ; -- spegelbild..nn.1
  spegelblank_1_A = mkA "spegelblank" ; -- spegelblank..av.1
  spegelblankhet_1_N = mkN "spegelblankhet" ; -- spegelblankhet..nn.1
  spegelfäkteri_1_N = mkN "spegelfäkteri" "spegelfäkteriet" "spegelfäkterier" "spegelfäkterierna" ; -- spegelfäkteri..nn.1
  spegelfäktning_1_N = mkN "spegelfäktning" ; -- spegelfäktning..nn.1
  spegelglas_1_N = mkN "spegelglas" neutrum  ; -- spegelglas..nn.1
  spegelkärna_1_N = mkN "spegelkärna" ; -- spegelkärna..nn.1
  spegelmonogram_1_N = mkN "spegelmonogram" "spegelmonogrammet" "spegelmonogram" "spegelmonogrammen" ; -- spegelmonogram..nn.1
  spegelreflexkamera_1_N = mkN "spegelreflexkamera" ; -- spegelreflexkamera..nn.1
  spegelskrift_1_N = mkN "spegelskrift" ; -- spegelskrift..nn.1
  spegelteleskop_1_N = mkN "spegelteleskop" neutrum  ; -- spegelteleskop..nn.1
  spegeltest_1_N = mkN "spegeltest" neutrum  ; -- spegeltest..nn.1
  spegelvänd_1_A = mkA "spegelvänd" ; -- spegelvänd..av.1
  spegelyta_1_N = mkN "spegelyta" ; -- spegelyta..nn.1
  spegla_1_V = mkV "speglar" ; -- spegla..vb.1
  speglande_1_N = mkN "speglande" ; -- speglande..nn.1
  spegling_1_N = mkN "spegling" ; -- spegling..nn.1
  speja_1_V = mkV "spejar" ; -- speja..vb.1
  spejande_1_N = mkN "spejande" ; -- spejande..nn.1
  spejare_1_N = mkN "spejare" utrum  ; -- spejare..nn.1
  spektakel_1_N = mkN "spektakel" neutrum  ; -- spektakel..nn.1
  spektakulär_1_A = mkA "spektakulär" ; -- spektakulär..av.1
  spektral_1_A = mkA "spektral" ; -- spektral..av.1
  spektralanalys_1_N = mkN "spektralanalys" ; -- spektralanalys..nn.1
  spektralapparat_1_N = mkN "spektralapparat" "spektralapparater" ; -- spektralapparat..nn.1
  spektrallinje_1_N = mkN "spektrallinje" "spektrallinjer" ; -- spektrallinje..nn.1
  spektrograf_1_N = mkN "spektrograf" "spektrografer" ; -- spektrograf..nn.1
  spektroskop_1_N = mkN "spektroskop" neutrum  ; -- spektroskop..nn.1
  spektroskopi_1_N = mkN "spektroskopi" ; -- spektroskopi..nn.1
  spektroskopisk_1_A = mkA "spektroskopisk" ; -- spektroskopisk..av.1
  spektrum_1_N = mkN "spektrum" neutrum  ; -- spektrum..nn.1
  spekulant_1_N = mkN "spekulant" "spekulanter" ; -- spekulant..nn.1
  spekulation_1_N = mkN "spekulation" ; -- spekulation..nn.1
  spekulationsekonomi_1_N = mkN "spekulationsekonomi" "spekulationsekonomier" ; -- spekulationsekonomi..nn.1
  spekulationskarusell_1_N = mkN "spekulationskarusell" "spekulationskaruseller" ; -- spekulationskarusell..nn.1
  spekulationsvåg_1_N = mkN "spekulationsvåg" "spekulationsvågor" ; -- spekulationsvåg..nn.1
  spekulativ_1_A = mkA "spekulativ" ; -- spekulativ..av.1
  spekulera_1_V = mkV "spekulerar" ; -- spekulera..vb.1
  spekulerande_1_N = mkN "spekulerande" ; -- spekulerande..nn.1
  spekulerbar_1_A = mkA "spekulerbar" ; -- spekulerbar..av.1
  spekulerbarhet_1_N = mkN "spekulerbarhet" ; -- spekulerbarhet..nn.1
  spekulering_1_N = mkN "spekulering" ; -- spekulering..nn.1
  spel_1_N = mkN "spel" neutrum  ; -- spel..nn.1
  spela_1_V = mkV "spelar" ; -- spela..vb.1
  spela_2_V = mkV "spelar" ; -- spela..vb.2
  spelande_1_N = mkN "spelande" ; -- spelande..nn.1
  spelarbyte_1_N = mkN "spelarbyte" ; -- spelarbyte..nn.1
  spelare_1_N = mkN "spelare" utrum  ; -- spelare..nn.1
  spelarmässig_1_A = mkA "spelarmässig" ; -- spelarmässig..av.1
  spelautomat_1_N = mkN "spelautomat" "spelautomater" ; -- spelautomat..nn.1
  spelbar_1_A = mkA "spelbar" ; -- spelbar..av.1
  spelbarhet_1_N = mkN "spelbarhet" ; -- spelbarhet..nn.1
  spelberoende_1_A = mkA "spelberoende" ; -- spelberoende..av.1
  spelbord_1_N = mkN "spelbord" neutrum  ; -- spelbord..nn.1
  spelbricka_1_N = mkN "spelbricka" ; -- spelbricka..nn.1
  spelbutik_1_N = mkN "spelbutik" "spelbutiker" ; -- spelbutik..nn.1
  speldjävul_1_N = mkN "speldjävul" ; -- speldjävul..nn.1
  speldosa_1_N = mkN "speldosa" ; -- speldosa..nn.1
  speldrama_1_N = mkN "speldrama" "speldramat" "speldramer" "speldramerna" ; -- speldrama..nn.1
  speleman_1_N = mkN "speleman" "spelemannen" "spelemän" "spelemännen" ; -- speleman..nn.1
  speleolog_1_N = mkN "speleolog" "speleologer" ; -- speleolog..nn.1
  speleologi_1_N = mkN "speleologi" ; -- speleologi..nn.1
  spelevink_1_N = mkN "spelevink" ; -- spelevink..nn.1
  spelevinker_1_N = mkN "spelevinker" ; -- spelevinker..nn.1
  spelfilm_1_N = mkN "spelfilm" "spelfilmer" ; -- spelfilm..nn.1
  spelglädje_1_N = mkN "spelglädje" utrum  ; -- spelglädje..nn.1
  spelhall_1_N = mkN "spelhall" ; -- spelhall..nn.1
  spelhelvete_1_N = mkN "spelhelvete" ; -- spelhelvete..nn.1
  spelhåla_1_N = mkN "spelhåla" ; -- spelhåla..nn.1
  spelklar_1_A = mkA "spelklar" ; -- spelklar..av.1
  spelkonsol_1_N = mkN "spelkonsol" "spelkonsoler" ; -- spelkonsol..nn.1
  spelkort_1_N = mkN "spelkort" neutrum  ; -- spelkort..nn.1
  spelman_1_N = mkN "spelman" "spelmannen" "spelmän" "spelmännen" ; -- spelman..nn.1
  spelmani_1_N = mkN "spelmani" "spelmanier" ; -- spelmani..nn.1
  spelmansstämma_1_N = mkN "spelmansstämma" ; -- spelmansstämma..nn.1
  spelmark_1_N = mkN "spelmark" "spelmarker" ; -- spelmark..nn.1
  spelmässig_1_A = mkA "spelmässig" ; -- spelmässig..av.1
  spelning_1_N = mkN "spelning" ; -- spelning..nn.1
  spelomgång_1_N = mkN "spelomgång" ; -- spelomgång..nn.1
  spelplan_1_N = mkN "spelplan" "spelplaner" ; -- spelplan..nn.1
  spelplan_2_N = mkN "spelplan" "spelplaner" ; -- spelplan..nn.2
  spelproblem_1_N = mkN "spelproblem" neutrum  ; -- spelproblem..nn.1
  spelprov_1_N = mkN "spelprov" neutrum  ; -- spelprov..nn.1
  spelrazzia_1_N = mkN "spelrazzia" ; -- spelrazzia..nn.1
  spelregel_1_N = mkN "spelregel" "spelregeln" "spelregler" "spelreglerna" ; -- spelregel..nn.1
  spelskicklig_1_A = mkA "spelskicklig" ; -- spelskicklig..av.1
  spelstil_1_N = mkN "spelstil" ; -- spelstil..nn.1
  spelsugen_1_A = mkA "spelsugen" ; -- spelsugen..av.1
  spelteori_1_N = mkN "spelteori" ; -- spelteori..nn.1
  speltid_1_N = mkN "speltid" "speltider" ; -- speltid..nn.1
  spelutvecklare_1_N = mkN "spelutvecklare" utrum  ; -- spelutvecklare..nn.1
  spelutveckling_1_N = mkN "spelutveckling" ; -- spelutveckling..nn.1
  spelverk_1_N = mkN "spelverk" neutrum  ; -- spelverk..nn.1
  spelår_1_N = mkN "spelår" neutrum  ; -- spelår..nn.1
  spelöppning_1_N = mkN "spelöppning" ; -- spelöppning..nn.1
  spenabarn_1_N = mkN "spenabarn" neutrum  ; -- spenabarn..nn.1
  spenat_1_N = mkN "spenat" ; -- spenat..nn.1
  spendera_1_V = mkV "spenderar" ; -- spendera..vb.1
  spenderande_1_N = mkN "spenderande" ; -- spenderande..nn.1
  spenderbar_1_A = mkA "spenderbar" ; -- spenderbar..av.1
  spenderbarhet_1_N = mkN "spenderbarhet" ; -- spenderbarhet..nn.1
  spendersam_1_A = mkA "spendersam" ; -- spendersam..av.1
  spendersamhet_1_N = mkN "spendersamhet" ; -- spendersamhet..nn.1
  spene_1_N = mkN "spene" utrum  ; -- spene..nn.1
  spenordning_1_N = mkN "spenordning" ; -- spenordning..nn.1
  spens_1_N = mkN "spens" "spenser" ; -- spens..nn.1
  spenslig_1_A = mkA "spenslig" ; -- spenslig..av.1
  spenslighet_1_N = mkN "spenslighet" ; -- spenslighet..nn.1
  spenvarm_1_A = mkA "spenvarm" ; -- spenvarm..av.1
  sperma_1_N = mkN "sperma" ; -- sperma..nn.1
  spermabank_1_N = mkN "spermabank" "spermabanker" ; -- spermabank..nn.1
  spermabildning_1_N = mkN "spermabildning" ; -- spermabildning..nn.1
  spermadonator_1_N = mkN "spermadonator" "spermadonatorer" ; -- spermadonator..nn.1
  spermakvalitet_1_N = mkN "spermakvalitet" "spermakvaliteter" ; -- spermakvalitet..nn.1
  spermamottagarsäck_1_N = mkN "spermamottagarsäck" ; -- spermamottagarsäck..nn.1
  spermatofor_1_N = mkN "spermatofor" "spermatoforen" "spermatoforer" "spermatoforerna" ; -- spermatofor..nn.1
  spermatozo_1_N = mkN "spermatozo" "spermatozon" "spermatozoer" "spermatozoerna" ; -- spermatozo..nn.1
  spermatozoid_1_N = mkN "spermatozoid" "spermatozoider" ; -- spermatozoid..nn.1
  spermie_1_N = mkN "spermie" "spermier" ; -- spermie..nn.1
  spermiemitokondrie_1_N = mkN "spermiemitokondrie" "spermiemitokondrier" ; -- spermiemitokondrie..nn.1
  spermiemodercell_1_N = mkN "spermiemodercell" "spermiemoderceller" ; -- spermiemodercell..nn.1
  speta_1_N = mkN "speta" ; -- speta..nn.1
  speta_1_V = mkV "spetar" ; -- speta..vb.1
  spetande_1_N = mkN "spetande" ; -- spetande..nn.1
  spetig_1_A = mkA "spetig" ; -- spetig..av.1
  spets_1_N = mkN "spets" ; -- spets..nn.1
  spetsa_1_V = mkV "spetsar" ; -- spetsa..vb.1
  spetsande_1_N = mkN "spetsande" ; -- spetsande..nn.1
  spetsartikel_1_N = mkN "spetsartikel" ; -- spetsartikel..nn.1
  spetsbergsgås_1_N = mkN "spetsbergsgås" "spetsbergsgåsen" "spetsbergsgäss" "spetsbergsgässen" ; -- spetsbergsgås..nn.1
  spetsborgare_1_N = mkN "spetsborgare" utrum  ; -- spetsborgare..nn.1
  spetsbov_1_N = mkN "spetsbov" ; -- spetsbov..nn.1
  spetsbroderi_1_N = mkN "spetsbroderi" "spetsbroderiet" "spetsbroderier" "spetsbroderierna" ; -- spetsbroderi..nn.1
  spetsbyxa_1_N = mkN "spetsbyxa" ; -- spetsbyxa..nn.1
  spetsbåge_1_N = mkN "spetsbåge" utrum  ; -- spetsbåge..nn.1
  spetsbågestil_1_N = mkN "spetsbågestil" ; -- spetsbågestil..nn.1
  spetsbågig_1_A = mkA "spetsbågig" ; -- spetsbågig..av.1
  spetsbågsstil_1_N = mkN "spetsbågsstil" ; -- spetsbågsstil..nn.1
  spetsduk_1_N = mkN "spetsduk" ; -- spetsduk..nn.1
  spetsforskning_1_N = mkN "spetsforskning" ; -- spetsforskning..nn.1
  spetsfot_1_N = mkN "spetsfot" ; -- spetsfot..nn.1
  spetsfundig_1_A = mkA "spetsfundig" ; -- spetsfundig..av.1
  spetsfundighet_1_N = mkN "spetsfundighet" "spetsfundigheter" ; -- spetsfundighet..nn.1
  spetsgardin_1_N = mkN "spetsgardin" "spetsgardiner" ; -- spetsgardin..nn.1
  spetsgattad_1_A = mkA "spetsgattad" ; -- spetsgattad..av.1
  spetsgavel_1_N = mkN "spetsgavel" ; -- spetsgavel..nn.1
  spetsglas_1_N = mkN "spetsglas" neutrum  ; -- spetsglas..nn.1
  spetshund_1_N = mkN "spetshund" ; -- spetshund..nn.1
  spetsig_1_A = mkA "spetsig" ; -- spetsig..av.1
  spetsighet_1_N = mkN "spetsighet" ; -- spetsighet..nn.1
  spetsighet_2_N = mkN "spetsighet" "spetsigheter" ; -- spetsighet..nn.2
  spetskompetens_1_N = mkN "spetskompetens" "spetskompetenser" ; -- spetskompetens..nn.1
  spetsnaz_1_N = mkN "spetsnaz" ; -- spetsnaz..nn.1
  spetsning_1_N = mkN "spetsning" ; -- spetsning..nn.1
  spetsnäst_1_A = mkA "spetsnäst" "spetsnäst" ; -- spetsnäst..av.1
  spetstång_1_N = mkN "spetstång" "spetstänger" ; -- spetstång..nn.1
  spetsvinklig_1_A = mkA "spetsvinklig" ; -- spetsvinklig..av.1
  spetsvinklighet_1_N = mkN "spetsvinklighet" ; -- spetsvinklighet..nn.1
  spett_1_N = mkN "spett" neutrum  ; -- spett..nn.1
  spetta_1_V = mkV "spettar" ; -- spetta..vb.1
  spettande_1_N = mkN "spettande" ; -- spettande..nn.1
  spettekaka_1_N = mkN "spettekaka" ; -- spettekaka..nn.1
  spettkaka_1_N = mkN "spettkaka" ; -- spettkaka..nn.1
  spetälsk_1_A = mkA "spetälsk" ; -- spetälsk..av.1
  spetälska_1_N = mkN "spetälska" ; -- spetälska..nn.1
  spex_1_N = mkN "spex" neutrum  ; -- spex..nn.1
  spexa_1_V = mkV "spexar" ; -- spexa..vb.1
  spexande_1_N = mkN "spexande" ; -- spexande..nn.1
  spexare_1_N = mkN "spexare" utrum  ; -- spexare..nn.1
  spexig_1_A = mkA "spexig" ; -- spexig..av.1
  spicken_1_A = mkA "spicken" ; -- spicken..av.1
  spigg_1_N = mkN "spigg" ; -- spigg..nn.1
  spik_1_N = mkN "spik" ; -- spik..nn.1
  spika_1_V = mkV "spikar" ; -- spika..vb.1
  spikad_1_A = mkA "spikad" ; -- spikad..av.1
  spikande_1_N = mkN "spikande" ; -- spikande..nn.1
  spikattentat_1_N = mkN "spikattentat" neutrum  ; -- spikattentat..nn.1
  spikband_1_N = mkN "spikband" neutrum  ; -- spikband..nn.1
  spikhinder_1_N = mkN "spikhinder" neutrum  ; -- spikhinder..nn.1
  spikhuvud_1_N = mkN "spikhuvud" "spikhuvudet" "spikhuvud" "spikhuvudena" ; -- spikhuvud..nn.1
  spikklubba_1_N = mkN "spikklubba" ; -- spikklubba..nn.1
  spiklös_1_A = mkA "spiklös" ; -- spiklös..av.1
  spikmatta_1_N = mkN "spikmatta" ; -- spikmatta..nn.1
  spikmatteliggande_1_A = mkA "spikmatteliggande" ; -- spikmatteliggande..av.1
  spikning_1_N = mkN "spikning" ; -- spikning..nn.1
  spiknykter_1_A = mkA "spiknykter" ; -- spiknykter..av.1
  spiknykterhet_1_N = mkN "spiknykterhet" ; -- spiknykterhet..nn.1
  spikpiano_1_N = mkN "spikpiano" "spikpianot" "spikpianon" "spikpianona" ; -- spikpiano..nn.1
  spikpistol_1_N = mkN "spikpistol" "spikpistoler" ; -- spikpistol..nn.1
  spikrak_1_A = mkA "spikrak" ; -- spikrak..av.1
  spikrakhet_1_N = mkN "spikrakhet" ; -- spikrakhet..nn.1
  spikskalle_1_N = mkN "spikskalle" utrum  ; -- spikskalle..nn.1
  spiksko_1_N = mkN "spiksko" "spikskor" ; -- spiksko..nn.1
  spikspets_1_N = mkN "spikspets" ; -- spikspets..nn.1
  spiksäker_1_A = mkA "spiksäker" ; -- spiksäker..av.1
  spiksäkerhet_1_N = mkN "spiksäkerhet" ; -- spiksäkerhet..nn.1
  spila_1_V = mkV "spilar" ; -- spila..vb.1
  spilande_1_N = mkN "spilande" ; -- spilande..nn.1
  spilkum_1_N = mkN "spilkum" ; -- spilkum..nn.1
  spill_1_N = mkN "spill" neutrum  ; -- spill..nn.1
  spilla_1_V = mkV "spiller" ; -- spilla..vb.1
  spillande_1_N = mkN "spillande" ; -- spillande..nn.1
  spillkråka_1_N = mkN "spillkråka" ; -- spillkråka..nn.1
  spillning_1_N = mkN "spillning" ; -- spillning..nn.1
  spillolja_1_N = mkN "spillolja" ; -- spillolja..nn.1
  spillra_1_N = mkN "spillra" ; -- spillra..nn.1
  spilltid_1_N = mkN "spilltid" ; -- spilltid..nn.1
  spillvatten_1_N = mkN "spillvatten" "spillvattnet" "spillvatten" "spillvattnen" ; -- spillvatten..nn.1
  spillvärme_1_N = mkN "spillvärme" ; -- spillvärme..nn.1
  spillånga_1_N = mkN "spillånga" ; -- spillånga..nn.1
  spilta_1_N = mkN "spilta" ; -- spilta..nn.1
  spilåpipa_1_N = mkN "spilåpipa" ; -- spilåpipa..nn.1
  spin_off_1_N = mkN "spin-off" "spin-offen" "spin-offs" "spin-offerna" ; -- spin-off..nn.1
  spin_1_N = mkN "spin" neutrum  ; -- spin..nn.1
  spinal_1_A = mkA "spinal" ; -- spinal..av.1
  spinalanestesi_1_N = mkN "spinalanestesi" "spinalanestesier" ; -- spinalanestesi..nn.1
  spinalganglie_1_N = mkN "spinalganglie" "spinalganglier" ; -- spinalganglie..nn.1
  spindel_1_N = mkN "spindel" ; -- spindel..nn.1
  spindelapa_1_N = mkN "spindelapa" ; -- spindelapa..nn.1
  spindelart_1_N = mkN "spindelart" "spindelarter" ; -- spindelart..nn.1
  spindelben_1_N = mkN "spindelben" neutrum  ; -- spindelben..nn.1
  spindelbett_1_N = mkN "spindelbett" neutrum  ; -- spindelbett..nn.1
  spindelbult_1_N = mkN "spindelbult" ; -- spindelbult..nn.1
  spindeldjur_1_N = mkN "spindeldjur" neutrum  ; -- spindeldjur..nn.1
  spindelhona_1_N = mkN "spindelhona" ; -- spindelhona..nn.1
  spindellik_1_A = mkA "spindellik" ; -- spindellik..av.1
  spindellikhet_1_N = mkN "spindellikhet" ; -- spindellikhet..nn.1
  spindelnät_1_N = mkN "spindelnät" neutrum  ; -- spindelnät..nn.1
  spindeltråd_1_N = mkN "spindeltråd" ; -- spindeltråd..nn.1
  spindeltunn_1_A = mkA "spindeltunn" "spindeltunt" ; -- spindeltunn..av.1
  spindeltunnhet_1_N = mkN "spindeltunnhet" ; -- spindeltunnhet..nn.1
  spindelväv_1_N = mkN "spindelväv" ; -- spindelväv..nn.1
  spindelvävsaktig_1_A = mkA "spindelvävsaktig" ; -- spindelvävsaktig..av.1
  spindelvävsaktighet_1_N = mkN "spindelvävsaktighet" ; -- spindelvävsaktighet..nn.1
  spindelvävshinna_1_N = mkN "spindelvävshinna" ; -- spindelvävshinna..nn.1
  spindelvävsmönstrad_1_A = mkA "spindelvävsmönstrad" ; -- spindelvävsmönstrad..av.1
  spindelvävstunn_1_A = mkA "spindelvävstunn" "spindelvävstunt" ; -- spindelvävstunn..av.1
  spindelvävstunnhet_1_N = mkN "spindelvävstunnhet" ; -- spindelvävstunnhet..nn.1
  spinell_1_N = mkN "spinell" "spineller" ; -- spinell..nn.1
  spinett_1_N = mkN "spinett" "spinetter" ; -- spinett..nn.1
  spinkig_1_A = mkA "spinkig" ; -- spinkig..av.1
  spinkighet_1_N = mkN "spinkighet" ; -- spinkighet..nn.1
  spinn_1_N = mkN "spinn" neutrum  ; -- spinn..nn.1
  spinna_1_V = mkV "spinna" "spann" "spunnit" ; -- spinna..vb.1
  spinnaker_1_N = mkN "spinnaker" ; -- spinnaker..nn.1
  spinnakerbom_1_N = mkN "spinnakerbom" "spinnakerbommen" "spinnakerbommar" "spinnakerbommarna" ; -- spinnakerbom..nn.1
  spinnande_1_N = mkN "spinnande" ; -- spinnande..nn.1
  spinnare_1_N = mkN "spinnare" utrum  ; -- spinnare..nn.1
  spinnarfjäril_1_N = mkN "spinnarfjäril" ; -- spinnarfjäril..nn.1
  spinndoktor_1_N = mkN "spinndoktor" "spinndoktorer" ; -- spinndoktor..nn.1
  spinneri_1_N = mkN "spinneri" "spinneriet" "spinnerier" "spinnerierna" ; -- spinneri..nn.1
  spinnfiske_1_N = mkN "spinnfiske" ; -- spinnfiske..nn.1
  spinnhus_1_N = mkN "spinnhus" neutrum  ; -- spinnhus..nn.1
  spinninghall_1_N = mkN "spinninghall" ; -- spinninghall..nn.1
  spinnkvalster_1_N = mkN "spinnkvalster" neutrum  ; -- spinnkvalster..nn.1
  spinnrock_1_N = mkN "spinnrock" ; -- spinnrock..nn.1
  spinnrulle_1_N = mkN "spinnrulle" utrum  ; -- spinnrulle..nn.1
  spinnsida_1_N = mkN "spinnsida" ; -- spinnsida..nn.1
  spinnspö_1_N = mkN "spinnspö" "spinnspöt" "spinnspön" "spinnspöna" ; -- spinnspö..nn.1
  spion_1_N = mkN "spion" ; -- spion..nn.1
  spionage_1_N = mkN "spionage" ; -- spionage..nn.1
  spionageanklagelse_1_N = mkN "spionageanklagelse" "spionageanklagelser" ; -- spionageanklagelse..nn.1
  spionanklagelse_1_N = mkN "spionanklagelse" "spionanklagelser" ; -- spionanklagelse..nn.1
  spionera_1_V = mkV "spionerar" ; -- spionera..vb.1
  spionerande_1_N = mkN "spionerande" ; -- spionerande..nn.1
  spioneri_1_N = mkN "spioneri" "spioneriet" "spionerier" "spionerierna" ; -- spioneri..nn.1
  spionering_1_N = mkN "spionering" ; -- spionering..nn.1
  spioneriverksamhet_1_N = mkN "spioneriverksamhet" ; -- spioneriverksamhet..nn.1
  spionfall_1_N = mkN "spionfall" neutrum  ; -- spionfall..nn.1
  spionflygning_1_N = mkN "spionflygning" ; -- spionflygning..nn.1
  spionhysteri_1_N = mkN "spionhysteri" ; -- spionhysteri..nn.1
  spionkamera_1_N = mkN "spionkamera" ; -- spionkamera..nn.1
  spionskräck_1_N = mkN "spionskräck" ; -- spionskräck..nn.1
  spionvärvning_1_N = mkN "spionvärvning" ; -- spionvärvning..nn.1
  spira_1_N = mkN "spira" ; -- spira..nn.1
  spira_1_V = mkV "spirar" ; -- spira..vb.1
  spiral_1_N = mkN "spiral" "spiraler" ; -- spiral..nn.1
  spiralblock_1_N = mkN "spiralblock" neutrum  ; -- spiralblock..nn.1
  spiralbotten_1_N = mkN "spiralbotten" ; -- spiralbotten..nn.1
  spiralfjäder_1_N = mkN "spiralfjäder" ; -- spiralfjäder..nn.1
  spiralformad_1_A = mkA "spiralformad" ; -- spiralformad..av.1
  spiralgalax_1_N = mkN "spiralgalax" "spiralgalaxer" ; -- spiralgalax..nn.1
  spiralgalaxformad_1_A = mkA "spiralgalaxformad" ; -- spiralgalaxformad..av.1
  spiralkabel_1_N = mkN "spiralkabel" ; -- spiralkabel..nn.1
  spiralnebulosa_1_N = mkN "spiralnebulosa" ; -- spiralnebulosa..nn.1
  spiralrörelse_1_N = mkN "spiralrörelse" "spiralrörelser" ; -- spiralrörelse..nn.1
  spiralsäng_1_N = mkN "spiralsäng" ; -- spiralsäng..nn.1
  spiraltrappa_1_N = mkN "spiraltrappa" ; -- spiraltrappa..nn.1
  spiralvisp_1_N = mkN "spiralvisp" ; -- spiralvisp..nn.1
  spiralvriden_1_A = mkA "spiralvriden" ; -- spiralvriden..av.1
  spirande_1_N = mkN "spirande" ; -- spirande..nn.1
  spirant_1_N = mkN "spirant" "spiranter" ; -- spirant..nn.1
  spirea_1_N = mkN "spirea" ; -- spirea..nn.1
  spirellakorsett_1_N = mkN "spirellakorsett" "spirellakorsetter" ; -- spirellakorsett..nn.1
  spirill_1_N = mkN "spirill" "spiriller" ; -- spirill..nn.1
  spiritism_1_N = mkN "spiritism" "spiritismer" ; -- spiritism..nn.1
  spiritist_1_N = mkN "spiritist" "spiritister" ; -- spiritist..nn.1
  spiritistisk_1_A = mkA "spiritistisk" ; -- spiritistisk..av.1
  spiritualism_1_N = mkN "spiritualism" "spiritualismer" ; -- spiritualism..nn.1
  spiritualist_1_N = mkN "spiritualist" "spiritualister" ; -- spiritualist..nn.1
  spiritualistisk_1_A = mkA "spiritualistisk" ; -- spiritualistisk..av.1
  spiritualitet_1_N = mkN "spiritualitet" "spiritualiteter" ; -- spiritualitet..nn.1
  spirituell_1_A = mkA "spirituell" ; -- spirituell..av.1
  spirituosa_1_N = mkN "spirituosa" ; -- spirituosa..nn.1
  spiritus_1_N = mkN "spiritus" ; -- spiritus..nn.1
  spirituös_1_A = mkA "spirituös" ; -- spirituös..av.1
  spirlånga_1_N = mkN "spirlånga" ; -- spirlånga..nn.1
  spiroket_1_N = mkN "spiroket" "spiroketer" ; -- spiroket..nn.1
  spirometri_1_N = mkN "spirometri" ; -- spirometri..nn.1
  spis_1_N = mkN "spis" ; -- spis..nn.1
  spis_2_N = mkN "spis" ; -- spis..nn.2
  spisa_1_V = mkV "spisar" ; -- spisa..vb.1
  spisande_1_N = mkN "spisande" ; -- spisande..nn.1
  spisare_1_N = mkN "spisare" utrum  ; -- spisare..nn.1
  spisarparty_1_N = mkN "spisarparty" "spisarpartyt" "spisarpartyn" "spisarpartyna" ; -- spisarparty..nn.1
  spisbröd_1_N = mkN "spisbröd" neutrum  ; -- spisbröd..nn.1
  spisel_1_N = mkN "spisel" ; -- spisel..nn.1
  spiselhylla_1_N = mkN "spiselhylla" ; -- spiselhylla..nn.1
  spiselhäll_1_N = mkN "spiselhäll" ; -- spiselhäll..nn.1
  spiselkrans_1_N = mkN "spiselkrans" ; -- spiselkrans..nn.1
  spiselkrok_1_N = mkN "spiselkrok" ; -- spiselkrok..nn.1
  spiselmur_1_N = mkN "spiselmur" ; -- spiselmur..nn.1
  spiselvrå_1_N = mkN "spiselvrå" "spiselvrån" "spiselvrår" "spiselvrårna" ; -- spiselvrå..nn.1
  spiselvärme_1_N = mkN "spiselvärme" utrum  ; -- spiselvärme..nn.1
  spishylla_1_N = mkN "spishylla" ; -- spishylla..nn.1
  spishäll_1_N = mkN "spishäll" ; -- spishäll..nn.1
  spiskammare_1_N = mkN "spiskammare" "spiskammaren" "spiskammare" "spiskamrarna" ; -- spiskammare..nn.1
  spiskrans_1_N = mkN "spiskrans" ; -- spiskrans..nn.1
  spiskrok_1_N = mkN "spiskrok" ; -- spiskrok..nn.1
  spiskupa_1_N = mkN "spiskupa" ; -- spiskupa..nn.1
  spiskåpa_1_N = mkN "spiskåpa" ; -- spiskåpa..nn.1
  spisning_1_N = mkN "spisning" ; -- spisning..nn.1
  spisplatta_1_N = mkN "spisplatta" ; -- spisplatta..nn.1
  spjut_1_N = mkN "spjut" neutrum  ; -- spjut..nn.1
  spjutkastare_1_N = mkN "spjutkastare" utrum  ; -- spjutkastare..nn.1
  spjutkastarkarriär_1_N = mkN "spjutkastarkarriär" "spjutkastarkarriärer" ; -- spjutkastarkarriär..nn.1
  spjutkastning_1_N = mkN "spjutkastning" ; -- spjutkastning..nn.1
  spjutspets_1_N = mkN "spjutspets" ; -- spjutspets..nn.1
  spjuver_1_N = mkN "spjuver" ; -- spjuver..nn.1
  spjuveraktig_1_A = mkA "spjuveraktig" ; -- spjuveraktig..av.1
  spjäla_1_N = mkN "spjäla" ; -- spjäla..nn.1
  spjäla_1_V = mkV "spjälar" ; -- spjäla..vb.1
  spjälande_1_N = mkN "spjälande" ; -- spjälande..nn.1
  spjäle_1_N = mkN "spjäle" utrum  ; -- spjäle..nn.1
  spjälgrind_1_N = mkN "spjälgrind" ; -- spjälgrind..nn.1
  spjälka_1_V = mkV "spjälkar" ; -- spjälka..vb.1
  spjälkande_1_N = mkN "spjälkande" ; -- spjälkande..nn.1
  spjälkning_1_N = mkN "spjälkning" ; -- spjälkning..nn.1
  spjäll_1_N = mkN "spjäll" neutrum  ; -- spjäll..nn.1
  spjällband_1_N = mkN "spjällband" neutrum  ; -- spjällband..nn.1
  spjällsnöre_1_N = mkN "spjällsnöre" ; -- spjällsnöre..nn.1
  spjällåda_1_N = mkN "spjällåda" ; -- spjällåda..nn.1
  spjälning_1_N = mkN "spjälning" ; -- spjälning..nn.1
  spjälsäng_1_N = mkN "spjälsäng" ; -- spjälsäng..nn.1
  spjälverk_1_N = mkN "spjälverk" neutrum  ; -- spjälverk..nn.1
  spjärn_1_N = mkN "spjärn" neutrum  ; -- spjärn..nn.1
  spjärna_1_V = mkV "spjärnar" ; -- spjärna..vb.1
  spjärnande_1_N = mkN "spjärnande" ; -- spjärnande..nn.1
  splatterfilm_1_N = mkN "splatterfilm" "splatterfilmer" ; -- splatterfilm..nn.1
  splejk_1_N = mkN "splejk" ; -- splejk..nn.1
  splint_1_N = mkN "splint" ; -- splint..nn.1
  splinta_1_V = mkV "splintar" ; -- splinta..vb.1
  splintande_1_N = mkN "splintande" ; -- splintande..nn.1
  spliss_1_N = mkN "spliss" ; -- spliss..nn.1
  splissa_1_V = mkV "splissar" ; -- splissa..vb.1
  splissande_1_N = mkN "splissande" ; -- splissande..nn.1
  split_1_N = mkN "split" neutrum  ; -- split..nn.1
  splitcane_1_N = mkN "splitcane" ; -- splitcane..nn.1
  splits_1_N = mkN "splits" ; -- splits..nn.1
  splitsa_1_V = mkV "splitsar" ; -- splitsa..vb.1
  splitsande_1_N = mkN "splitsande" ; -- splitsande..nn.1
  splitsning_1_N = mkN "splitsning" ; -- splitsning..nn.1
  splitter_1_N = mkN "splitter" neutrum  ; -- splitter..nn.1
  splitterbomb_1_N = mkN "splitterbomb" "splitterbomber" ; -- splitterbomb..nn.1
  splitterny_1_A = mkA "splitterny" "splitternytt" ; -- splitterny..av.1
  splittersår_1_N = mkN "splittersår" neutrum  ; -- splittersår..nn.1
  splittny_1_A = mkA "splittny" "splittnytt" ; -- splittny..av.1
  splittra_1_N = mkN "splittra" ; -- splittra..nn.1
  splittra_1_V = mkV "splittrar" ; -- splittra..vb.1
  splittrad_1_A = mkA "splittrad" ; -- splittrad..av.1
  splittrande_1_N = mkN "splittrande" ; -- splittrande..nn.1
  splittrare_1_N = mkN "splittrare" utrum  ; -- splittrare..nn.1
  splittring_1_N = mkN "splittring" ; -- splittring..nn.1
  spoiler_1_N = mkN "spoiler" "spoilern" "spoilers" "spoilersen" ; -- spoiler..nn.1
  spola_1_V = mkV "spolar" ; -- spola..vb.1
  spolande_1_N = mkN "spolande" ; -- spolande..nn.1
  spolarvätska_1_N = mkN "spolarvätska" ; -- spolarvätska..nn.1
  spole_1_N = mkN "spole" utrum  ; -- spole..nn.1
  spolformad_1_A = mkA "spolformad" ; -- spolformad..av.1
  spolformig_1_A = mkA "spolformig" ; -- spolformig..av.1
  spolformighet_1_N = mkN "spolformighet" ; -- spolformighet..nn.1
  spoliera_1_V = mkV "spolierar" ; -- spoliera..vb.1
  spolierande_1_N = mkN "spolierande" ; -- spolierande..nn.1
  spolierbar_1_A = mkA "spolierbar" ; -- spolierbar..av.1
  spolierbarhet_1_N = mkN "spolierbarhet" ; -- spolierbarhet..nn.1
  spoliering_1_N = mkN "spoliering" ; -- spoliering..nn.1
  spoling_1_N = mkN "spoling" ; -- spoling..nn.1
  spolmask_1_N = mkN "spolmask" ; -- spolmask..nn.1
  spolning_1_N = mkN "spolning" ; -- spolning..nn.1
  spondeisk_1_A = mkA "spondeisk" ; -- spondeisk..av.1
  spondylit_1_N = mkN "spondylit" "spondyliter" ; -- spondylit..nn.1
  spondylos_1_N = mkN "spondylos" ; -- spondylos..nn.1
  spondé_1_N = mkN "spondé" "spondéer" ; -- spondé..nn.1
  sponk_1_N = mkN "sponk" ; -- sponk..nn.1
  sponsor_1_N = mkN "sponsor" "sponsorer" ; -- sponsor..nn.1
  sponsorera_1_V = mkV "sponsorerar" ; -- sponsorera..vb.1
  sponsorerande_1_N = mkN "sponsorerande" ; -- sponsorerande..nn.1
  sponsorering_1_N = mkN "sponsorering" ; -- sponsorering..nn.1
  sponsormässig_1_A = mkA "sponsormässig" ; -- sponsormässig..av.1
  sponsra_1_V = mkV "sponsrar" ; -- sponsra..vb.1
  sponsrande_1_N = mkN "sponsrande" ; -- sponsrande..nn.1
  sponsring_1_N = mkN "sponsring" ; -- sponsring..nn.1
  spont_1_N = mkN "spont" "sponter" ; -- spont..nn.1
  sponta_1_V = mkV "spontar" ; -- sponta..vb.1
  spontan_1_A = mkA "spontan" ; -- spontan..av.1
  spontan_2_A = mkA "spontan" ; -- spontan..av.2
  spontande_1_N = mkN "spontande" ; -- spontande..nn.1
  spontanism_1_N = mkN "spontanism" "spontanismer" ; -- spontanism..nn.1
  spontanistisk_1_A = mkA "spontanistisk" ; -- spontanistisk..av.1
  spontanitet_1_N = mkN "spontanitet" "spontaniteter" ; -- spontanitet..nn.1
  spontankåt_1_A = mkA "spontankåt" ; -- spontankåt..av.1
  spontning_1_N = mkN "spontning" ; -- spontning..nn.1
  spor_1_N = mkN "spor" "sporen" "sporer" "sporerna" ; -- spor..nn.1
  sporadisk_1_A = mkA "sporadisk" ; -- sporadisk..av.1
  sporangium_1_N = mkN "sporangium" "sporangiet" "sporangier" "sporangierna" ; -- sporangium..nn.1
  sporbildande_1_A = mkA "sporbildande" ; -- sporbildande..av.1
  spordjur_1_N = mkN "spordjur" neutrum  ; -- spordjur..nn.1
  sporgömme_1_N = mkN "sporgömme" ; -- sporgömme..nn.1
  sporkapsel_1_N = mkN "sporkapsel" ; -- sporkapsel..nn.1
  sporra_1_V = mkV "sporrar" ; -- sporra..vb.1
  sporrande_1_N = mkN "sporrande" ; -- sporrande..nn.1
  sporre_1_N = mkN "sporre" utrum  ; -- sporre..nn.1
  sporrning_1_N = mkN "sporrning" ; -- sporrning..nn.1
  sporrsträck_1_N = mkN "sporrsträck" neutrum  ; -- sporrsträck..nn.1
  sporsäck_1_N = mkN "sporsäck" ; -- sporsäck..nn.1
  sport_1_N = mkN "sport" "sporter" ; -- sport..nn.1
  sporta_1_V = mkV "sportar" ; -- sporta..vb.1
  sportaffär_1_N = mkN "sportaffär" "sportaffärer" ; -- sportaffär..nn.1
  sportande_1_N = mkN "sportande" ; -- sportande..nn.1
  sportarena_1_N = mkN "sportarena" ; -- sportarena..nn.1
  sportbil_1_N = mkN "sportbil" ; -- sportbil..nn.1
  sportchef_1_N = mkN "sportchef" "sportchefer" ; -- sportchef..nn.1
  sportdykning_1_N = mkN "sportdykning" ; -- sportdykning..nn.1
  sportfiske_1_N = mkN "sportfiske" ; -- sportfiske..nn.1
  sportfiskemetod_1_N = mkN "sportfiskemetod" "sportfiskemetoder" ; -- sportfiskemetod..nn.1
  sportflygplan_1_N = mkN "sportflygplan" neutrum  ; -- sportflygplan..nn.1
  sportform_1_N = mkN "sportform" "sportformer" ; -- sportform..nn.1
  sportfåne_1_N = mkN "sportfåne" utrum  ; -- sportfåne..nn.1
  sportgren_1_N = mkN "sportgren" "sportgrenen" "sportgrenar" "sportgrenarna" ; -- sportgren..nn.1
  sporthall_1_N = mkN "sporthall" ; -- sporthall..nn.1
  sportig_1_A = mkA "sportig" ; -- sportig..av.1
  sportighet_1_N = mkN "sportighet" ; -- sportighet..nn.1
  sportintresserad_1_A = mkA "sportintresserad" ; -- sportintresserad..av.1
  sportjournalist_1_N = mkN "sportjournalist" "sportjournalister" ; -- sportjournalist..nn.1
  sportklubb_1_N = mkN "sportklubb" ; -- sportklubb..nn.1
  sportkommentator_1_N = mkN "sportkommentator" "sportkommentatorer" ; -- sportkommentator..nn.1
  sportlegend_1_N = mkN "sportlegend" "sportlegender" ; -- sportlegend..nn.1
  sportliv_1_N = mkN "sportliv" neutrum  ; -- sportliv..nn.1
  sportlov_1_N = mkN "sportlov" neutrum  ; -- sportlov..nn.1
  sportlovsstuga_1_N = mkN "sportlovsstuga" ; -- sportlovsstuga..nn.1
  sportlovstrafik_1_N = mkN "sportlovstrafik" ; -- sportlovstrafik..nn.1
  sportläkare_1_N = mkN "sportläkare" utrum  ; -- sportläkare..nn.1
  sportmodell_1_N = mkN "sportmodell" "sportmodeller" ; -- sportmodell..nn.1
  sportmössa_1_N = mkN "sportmössa" ; -- sportmössa..nn.1
  sportprestation_1_N = mkN "sportprestation" ; -- sportprestation..nn.1
  sportreporter_1_N = mkN "sportreporter" ; -- sportreporter..nn.1
  sportsida_1_N = mkN "sportsida" ; -- sportsida..nn.1
  sportslig_1_A = mkA "sportslig" ; -- sportslig..av.1
  sportslig_2_A = mkA "sportslig" ; -- sportslig..av.2
  sportslighet_1_N = mkN "sportslighet" ; -- sportslighet..nn.1
  sportsman_1_N = mkN "sportsman" "sportsmannen" "sportsmän" "sportsmännen" ; -- sportsman..nn.1
  sportsmannamässig_1_A = mkA "sportsmannamässig" ; -- sportsmannamässig..av.1
  sportsmanship_1_N = mkN "sportsmanship" neutrum  ; -- sportsmanship..nn.1
  sportstuga_1_N = mkN "sportstuga" ; -- sportstuga..nn.1
  sportvagn_1_N = mkN "sportvagn" ; -- sportvagn..nn.1
  sporväxt_1_N = mkN "sporväxt" "sporväxter" ; -- sporväxt..nn.1
  spot_1_N = mkN "spot" ; -- spot..nn.1
  spotlight_1_N = mkN "spotlight" "spotlighten" "spotlights" "spotlightsarna" ; -- spotlight..nn.1
  spotsk_1_A = mkA "spotsk" ; -- spotsk..av.1
  spotskhet_1_N = mkN "spotskhet" ; -- spotskhet..nn.1
  spott_1_N = mkN "spott" ; -- spott..nn.1
  spott_2_N = mkN "spott" ; -- spott..nn.2
  spotta_1_V = mkV "spottar" ; -- spotta..vb.1
  spottande_1_N = mkN "spottande" ; -- spottande..nn.1
  spottkörtel_1_N = mkN "spottkörtel" ; -- spottkörtel..nn.1
  spottloska_1_N = mkN "spottloska" ; -- spottloska..nn.1
  spottstrit_1_N = mkN "spottstrit" ; -- spottstrit..nn.1
  spottstyver_1_N = mkN "spottstyver" ; -- spottstyver..nn.1
  spov_1_N = mkN "spov" ; -- spov..nn.1
  spovsnäppa_1_N = mkN "spovsnäppa" ; -- spovsnäppa..nn.1
  spraka_1_V = mkV "sprakar" ; -- spraka..vb.1
  sprakande_1_N = mkN "sprakande" ; -- sprakande..nn.1
  sprakfåle_1_N = mkN "sprakfåle" utrum  ; -- sprakfåle..nn.1
  sprakning_1_N = mkN "sprakning" ; -- sprakning..nn.1
  spralla_1_V = mkV "sprallar" ; -- spralla..vb.1
  sprallande_1_N = mkN "sprallande" ; -- sprallande..nn.1
  sprallig_1_A = mkA "sprallig" ; -- sprallig..av.1
  sprallighet_1_N = mkN "sprallighet" ; -- sprallighet..nn.1
  spratt_1_N = mkN "spratt" neutrum  ; -- spratt..nn.1
  sprattel_1_N = mkN "sprattel" neutrum  ; -- sprattel..nn.1
  sprattelgubbe_1_N = mkN "sprattelgubbe" utrum  ; -- sprattelgubbe..nn.1
  sprattla_1_V = mkV "sprattlar" ; -- sprattla..vb.1
  sprattlande_1_N = mkN "sprattlande" ; -- sprattlande..nn.1
  spray_1_N = mkN "spray" "sprayen" "sprayer" "sprayerna" ; -- spray..nn.1
  spraya_1_V = mkV "sprayar" ; -- spraya..vb.1
  sprayande_1_N = mkN "sprayande" ; -- sprayande..nn.1
  sprayburkskonstnär_1_N = mkN "sprayburkskonstnär" "sprayburkskonstnärer" ; -- sprayburkskonstnär..nn.1
  sprayflaska_1_N = mkN "sprayflaska" ; -- sprayflaska..nn.1
  sprayhood_1_N = mkN "sprayhood" ; -- sprayhood..nn.1
  spraymunstycke_1_N = mkN "spraymunstycke" ; -- spraymunstycke..nn.1
  sprej_1_N = mkN "sprej" "sprejer" ; -- sprej..nn.1
  spreja_1_V = mkV "sprejar" ; -- spreja..vb.1
  sprejande_1_N = mkN "sprejande" ; -- sprejande..nn.1
  sprejflaska_1_N = mkN "sprejflaska" ; -- sprejflaska..nn.1
  sprejmunstycke_1_N = mkN "sprejmunstycke" ; -- sprejmunstycke..nn.1
  spreta_1_V = mkV "spretar" ; -- spreta..vb.1
  spretande_1_N = mkN "spretande" ; -- spretande..nn.1
  spretig_1_A = mkA "spretig" ; -- spretig..av.1
  spretighet_1_N = mkN "spretighet" "spretigheter" ; -- spretighet..nn.1
  spri_1_N = mkN "spri" "spriet" "sprin" "sprina" ; -- spri..nn.1
  spricka_1_N = mkN "spricka" ; -- spricka..nn.1
  spricka_1_V = mkV "spricka" "sprack" "spruckit" ; -- spricka..vb.1
  sprickande_1_N = mkN "sprickande" ; -- sprickande..nn.1
  sprickbildning_1_N = mkN "sprickbildning" ; -- sprickbildning..nn.1
  sprickdal_1_N = mkN "sprickdal" ; -- sprickdal..nn.1
  sprickfri_1_A = mkA "sprickfri" "sprickfritt" ; -- sprickfri..av.1
  sprickfärdig_1_A = mkA "sprickfärdig" ; -- sprickfärdig..av.1
  sprickfärdighet_1_N = mkN "sprickfärdighet" ; -- sprickfärdighet..nn.1
  sprickig_1_A = mkA "sprickig" ; -- sprickig..av.1
  sprickighet_1_N = mkN "sprickighet" ; -- sprickighet..nn.1
  sprickning_1_N = mkN "sprickning" ; -- sprickning..nn.1
  sprida_1_V = mkV "sprida" "sprider" "sprid" "spridde" "spridit" "spridd" ; -- sprida..vb.1
  spridande_1_N = mkN "spridande" ; -- spridande..nn.1
  spridare_1_N = mkN "spridare" utrum  ; -- spridare..nn.1
  spridarvagn_1_N = mkN "spridarvagn" ; -- spridarvagn..nn.1
  spridd_1_A = mkA "spridd" ; -- spridd..av.1
  spriddhet_1_N = mkN "spriddhet" ; -- spriddhet..nn.1
  spridning_1_N = mkN "spridning" ; -- spridning..nn.1
  spridningseffekt_1_N = mkN "spridningseffekt" "spridningseffekter" ; -- spridningseffekt..nn.1
  spridningskälla_1_N = mkN "spridningskälla" ; -- spridningskälla..nn.1
  spridningslins_1_N = mkN "spridningslins" "spridningslinser" ; -- spridningslins..nn.1
  spridningsmått_1_N = mkN "spridningsmått" neutrum  ; -- spridningsmått..nn.1
  spridprogram_1_N = mkN "spridprogram" "spridprogrammet" "spridprogram" "spridprogrammen" ; -- spridprogram..nn.1
  sprillan_1_A = mkA "sprillan" ; -- sprillan..av.1
  sprillans_1_A = mkA "sprillans" ; -- sprillans..av.1
  spring_1_N = mkN "spring" neutrum  ; -- spring..nn.1
  spring_2_N = mkN "spring" neutrum  ; -- spring..nn.2
  springa_1_N = mkN "springa" ; -- springa..nn.1
  springa_1_V = mkV "springa" "sprang" "sprungit" ; -- springa..vb.1
  springande_1_N = mkN "springande" ; -- springande..nn.1
  springardrag_1_N = mkN "springardrag" neutrum  ; -- springardrag..nn.1
  springare_1_N = mkN "springare" utrum  ; -- springare..nn.1
  springbock_1_N = mkN "springbock" ; -- springbock..nn.1
  springbrunn_1_N = mkN "springbrunn" ; -- springbrunn..nn.1
  springflicka_1_N = mkN "springflicka" ; -- springflicka..nn.1
  springflod_1_N = mkN "springflod" ; -- springflod..nn.1
  springkälla_1_N = mkN "springkälla" ; -- springkälla..nn.1
  springmask_1_N = mkN "springmask" ; -- springmask..nn.1
  springning_1_N = mkN "springning" ; -- springning..nn.1
  springnota_1_N = mkN "springnota" ; -- springnota..nn.1
  springpojke_1_N = mkN "springpojke" utrum  ; -- springpojke..nn.1
  springpojksjobb_1_N = mkN "springpojksjobb" neutrum  ; -- springpojksjobb..nn.1
  springschas_1_N = mkN "springschas" ; -- springschas..nn.1
  springsjas_1_N = mkN "springsjas" ; -- springsjas..nn.1
  springstilett_1_N = mkN "springstilett" "springstiletter" ; -- springstilett..nn.1
  springvatten_1_N = mkN "springvatten" "springvattnet" "springvatten" "springvattnen" ; -- springvatten..nn.1
  springvikarie_1_N = mkN "springvikarie" "springvikarier" ; -- springvikarie..nn.1
  sprinkler_1_N = mkN "sprinkler" "sprinklern" "sprinklers" "sprinklersen" ; -- sprinkler..nn.1
  sprinkleranläggning_1_N = mkN "sprinkleranläggning" ; -- sprinkleranläggning..nn.1
  sprinklersystem_1_N = mkN "sprinklersystem" neutrum  ; -- sprinklersystem..nn.1
  sprint_1_N = mkN "sprint" ; -- sprint..nn.1
  sprinta_1_V = mkV "sprintar" ; -- sprinta..vb.1
  sprintande_1_N = mkN "sprintande" ; -- sprintande..nn.1
  sprinter_1_N = mkN "sprinter" "sprintern" "sprinters" "sprintersen" ; -- sprinter..nn.1
  sprit_1_N = mkN "sprit" ; -- sprit..nn.1
  sprita_1_V = mkV "spritar" ; -- sprita..vb.1
  sprita_2_V = mkV "spritar" ; -- sprita..vb.2
  spritande_1_N = mkN "spritande" ; -- spritande..nn.1
  spritbegåvad_1_A = mkA "spritbegåvad" ; -- spritbegåvad..av.1
  spritdryck_1_N = mkN "spritdryck" "spritdrycker" ; -- spritdryck..nn.1
  spritdränka_1_V = mkV "spritdränker" ; -- spritdränka..vb.1
  spritdränkande_1_N = mkN "spritdränkande" ; -- spritdränkande..nn.1
  spritdränkning_1_N = mkN "spritdränkning" ; -- spritdränkning..nn.1
  sprithalt_1_N = mkN "sprithalt" "sprithalter" ; -- sprithalt..nn.1
  sprithaltig_1_A = mkA "sprithaltig" ; -- sprithaltig..av.1
  spritkök_1_N = mkN "spritkök" neutrum  ; -- spritkök..nn.1
  spritlampa_1_N = mkN "spritlampa" ; -- spritlampa..nn.1
  spritlukt_1_N = mkN "spritlukt" ; -- spritlukt..nn.1
  spritlösning_1_N = mkN "spritlösning" ; -- spritlösning..nn.1
  spritmissbruk_1_N = mkN "spritmissbruk" neutrum  ; -- spritmissbruk..nn.1
  spritning_1_N = mkN "spritning" ; -- spritning..nn.1
  spritnota_1_N = mkN "spritnota" ; -- spritnota..nn.1
  spritpenna_1_N = mkN "spritpenna" ; -- spritpenna..nn.1
  spriträttighet_1_N = mkN "spriträttighet" "spriträttigheter" ; -- spriträttighet..nn.1
  sprits_1_N = mkN "sprits" ; -- sprits..nn.1
  spritsa_1_V = mkV "spritsar" ; -- spritsa..vb.1
  spritsande_1_N = mkN "spritsande" ; -- spritsande..nn.1
  spritsmugglare_1_N = mkN "spritsmugglare" utrum  ; -- spritsmugglare..nn.1
  spritspion_1_N = mkN "spritspion" ; -- spritspion..nn.1
  spritta_1_V = mkV "spritta" "spratt" "spruttit" ; -- spritta..vb.1
  sprittande_1_N = mkN "sprittande" ; -- sprittande..nn.1
  sprittermometer_1_N = mkN "sprittermometer" ; -- sprittermometer..nn.1
  sprittning_1_N = mkN "sprittning" ; -- sprittning..nn.1
  sprucken_1_A = mkA "sprucken" ; -- sprucken..av.1
  sprudla_1_V = mkV "sprudlar" ; -- sprudla..vb.1
  sprudlande_1_N = mkN "sprudlande" ; -- sprudlande..nn.1
  sprue_1_N = mkN "sprue" utrum  ; -- sprue..nn.1
  sprund_1_N = mkN "sprund" neutrum  ; -- sprund..nn.1
  sprut_1_N = mkN "sprut" neutrum  ; -- sprut..nn.1
  spruta_1_N = mkN "spruta" ; -- spruta..nn.1
  spruta_1_V = mkV "sprutar" ; -- spruta..vb.1
  sprutande_1_N = mkN "sprutande" ; -- sprutande..nn.1
  sprutavrättning_1_N = mkN "sprutavrättning" ; -- sprutavrättning..nn.1
  sprutbyte_1_N = mkN "sprutbyte" ; -- sprutbyte..nn.1
  sprutlackera_1_V = mkV "sprutlackerar" ; -- sprutlackera..vb.1
  sprutlackerande_1_N = mkN "sprutlackerande" ; -- sprutlackerande..nn.1
  sprutlackerbar_1_A = mkA "sprutlackerbar" ; -- sprutlackerbar..av.1
  sprutlackerbarhet_1_N = mkN "sprutlackerbarhet" ; -- sprutlackerbarhet..nn.1
  sprutlackering_1_N = mkN "sprutlackering" ; -- sprutlackering..nn.1
  sprutmåla_1_V = mkV "sprutmålar" ; -- sprutmåla..vb.1
  sprutmålande_1_N = mkN "sprutmålande" ; -- sprutmålande..nn.1
  sprutnarkoman_1_N = mkN "sprutnarkoman" "sprutnarkomaner" ; -- sprutnarkoman..nn.1
  sprutning_1_N = mkN "sprutning" ; -- sprutning..nn.1
  sprutpistol_1_N = mkN "sprutpistol" "sprutpistoler" ; -- sprutpistol..nn.1
  sprutskräck_1_N = mkN "sprutskräck" ; -- sprutskräck..nn.1
  sprutspets_1_N = mkN "sprutspets" ; -- sprutspets..nn.1
  sprutt_1_N = mkN "sprutt" ; -- sprutt..nn.1
  sprututbytesprogram_1_N = mkN "sprututbytesprogram" "sprututbytesprogrammet" "sprututbytesprogram" "sprututbytesprogrammen" ; -- sprututbytesprogram..nn.1
  sprygel_1_N = mkN "sprygel" ; -- sprygel..nn.1
  spräcka_1_V = mkV "spräcker" ; -- spräcka..vb.1
  spräckande_1_N = mkN "spräckande" ; -- spräckande..nn.1
  spräcklig_1_A = mkA "spräcklig" ; -- spräcklig..av.1
  spräcklighet_1_N = mkN "spräcklighet" ; -- spräcklighet..nn.1
  spräckning_1_N = mkN "spräckning" ; -- spräckning..nn.1
  spränga_1_V = mkV "spränger" ; -- spränga..vb.1
  spränga_2_V = mkV "spränger" ; -- spränga..vb.2
  sprängande_1_N = mkN "sprängande" ; -- sprängande..nn.1
  sprängarbete_1_N = mkN "sprängarbete" ; -- sprängarbete..nn.1
  sprängarbetsplats_1_N = mkN "sprängarbetsplats" "sprängarbetsplatser" ; -- sprängarbetsplats..nn.1
  sprängattentat_1_N = mkN "sprängattentat" neutrum  ; -- sprängattentat..nn.1
  sprängdeg_1_N = mkN "sprängdeg" ; -- sprängdeg..nn.1
  sprängdåd_1_N = mkN "sprängdåd" neutrum  ; -- sprängdåd..nn.1
  sprängfull_1_A = mkA "sprängfull" ; -- sprängfull..av.1
  sprängfullhet_1_N = mkN "sprängfullhet" ; -- sprängfullhet..nn.1
  sprängfylld_1_A = mkA "sprängfylld" "sprängfyllt" ; -- sprängfylld..av.1
  sprängfylldhet_1_N = mkN "sprängfylldhet" ; -- sprängfylldhet..nn.1
  spränggas_1_N = mkN "spränggas" "spränggaser" ; -- spränggas..nn.1
  sprängkapsel_1_N = mkN "sprängkapsel" ; -- sprängkapsel..nn.1
  sprängkraft_1_N = mkN "sprängkraft" ; -- sprängkraft..nn.1
  sprängkåt_1_A = mkA "sprängkåt" ; -- sprängkåt..av.1
  sprängladdning_1_N = mkN "sprängladdning" ; -- sprängladdning..nn.1
  spränglista_1_N = mkN "spränglista" ; -- spränglista..nn.1
  spränglärd_1_A = mkA "spränglärd" "spränglärt" ; -- spränglärd..av.1
  spränglärdhet_1_N = mkN "spränglärdhet" ; -- spränglärdhet..nn.1
  sprängmedel_1_N = mkN "sprängmedel" neutrum  ; -- sprängmedel..nn.1
  sprängning_1_N = mkN "sprängning" ; -- sprängning..nn.1
  sprängningsarbete_1_N = mkN "sprängningsarbete" ; -- sprängningsarbete..nn.1
  sprängsten_1_N = mkN "sprängsten" "sprängstenen" "sprängstenar" "sprängstenarna" ; -- sprängsten..nn.1
  sprängstoff_1_N = mkN "sprängstoff" neutrum  ; -- sprängstoff..nn.1
  sprängämne_1_N = mkN "sprängämne" ; -- sprängämne..nn.1
  sprängämnesmolekyl_1_N = mkN "sprängämnesmolekyl" "sprängämnesmolekyler" ; -- sprängämnesmolekyl..nn.1
  sprängämnespatron_1_N = mkN "sprängämnespatron" "sprängämnespatroner" ; -- sprängämnespatron..nn.1
  sprätt_1_N = mkN "sprätt" ; -- sprätt..nn.1
  sprätta_1_V = mkV "sprätta" "sprätter" "sprätt" "sprätte" "sprätt" "sprätt" ; -- sprätta..vb.1
  sprätta_2_V = mkV "sprättar" ; -- sprätta..vb.2
  sprättande_1_N = mkN "sprättande" ; -- sprättande..nn.1
  sprättbåge_1_N = mkN "sprättbåge" utrum  ; -- sprättbåge..nn.1
  sprätthök_1_N = mkN "sprätthök" ; -- sprätthök..nn.1
  sprättig_1_A = mkA "sprättig" ; -- sprättig..av.1
  sprättighet_1_N = mkN "sprättighet" ; -- sprättighet..nn.1
  sprättning_1_N = mkN "sprättning" ; -- sprättning..nn.1
  språk_1_N = mkN "språk" neutrum  ; -- språk..nn.1
  språka_1_V = mkV "språkar" ; -- språka..vb.1
  språkande_1_N = mkN "språkande" ; -- språkande..nn.1
  språkanvändning_1_N = mkN "språkanvändning" ; -- språkanvändning..nn.1
  språkbank_1_N = mkN "språkbank" "språkbanker" ; -- språkbank..nn.1
  språkbarriär_1_N = mkN "språkbarriär" "språkbarriärer" ; -- språkbarriär..nn.1
  språkbaserad_1_A = mkA "språkbaserad" ; -- språkbaserad..av.1
  språkbehandling_1_N = mkN "språkbehandling" ; -- språkbehandling..nn.1
  språkbruk_1_N = mkN "språkbruk" neutrum  ; -- språkbruk..nn.1
  språkbrukare_1_N = mkN "språkbrukare" utrum  ; -- språkbrukare..nn.1
  språkbråk_1_N = mkN "språkbråk" neutrum  ; -- språkbråk..nn.1
  språkbyte_1_N = mkN "språkbyte" ; -- språkbyte..nn.1
  språkcentrum_1_N = mkN "språkcentrum" neutrum  ; -- språkcentrum..nn.1
  språkdräkt_1_N = mkN "språkdräkt" "språkdräkter" ; -- språkdräkt..nn.1
  språkexperiment_1_N = mkN "språkexperiment" neutrum  ; -- språkexperiment..nn.1
  språkfakta_1_N = mkN "språkfakta" ; -- språkfakta..nn.1
  språkfamilj_1_N = mkN "språkfamilj" "språkfamiljer" ; -- språkfamilj..nn.1
  språkfascism_1_N = mkN "språkfascism" ; -- språkfascism..nn.1
  språkfascist_1_N = mkN "språkfascist" "språkfascister" ; -- språkfascist..nn.1
  språkfascisteri_1_N = mkN "språkfascisteri" "språkfascisteriet" "språkfascisterier" "språkfascisterierna" ; -- språkfascisteri..nn.1
  språkfel_1_N = mkN "språkfel" "språkfelet" "språkfel" "språkfelen" ; -- språkfel..nn.1
  språkfilosof_1_N = mkN "språkfilosof" "språkfilosofer" ; -- språkfilosof..nn.1
  språkfilosofi_1_N = mkN "språkfilosofi" ; -- språkfilosofi..nn.1
  språkform_1_N = mkN "språkform" "språkformer" ; -- språkform..nn.1
  språkforskare_1_N = mkN "språkforskare" utrum  ; -- språkforskare..nn.1
  språkfärdighet_1_N = mkN "språkfärdighet" "språkfärdigheter" ; -- språkfärdighet..nn.1
  språkförbistring_1_N = mkN "språkförbistring" ; -- språkförbistring..nn.1
  språkgrupp_1_N = mkN "språkgrupp" "språkgrupper" ; -- språkgrupp..nn.1
  språkhistoria_1_N = mkN "språkhistoria" ; -- språkhistoria..nn.1
  språkinlärning_1_N = mkN "språkinlärning" ; -- språkinlärning..nn.1
  språkkonsult_1_N = mkN "språkkonsult" "språkkonsulter" ; -- språkkonsult..nn.1
  språkkontrollant_1_N = mkN "språkkontrollant" "språkkontrollanter" ; -- språkkontrollant..nn.1
  språkkrav_1_N = mkN "språkkrav" neutrum  ; -- språkkrav..nn.1
  språkkunnig_1_A = mkA "språkkunnig" ; -- språkkunnig..av.1
  språkkunnighet_1_N = mkN "språkkunnighet" ; -- språkkunnighet..nn.1
  språkkunskap_1_N = mkN "språkkunskap" "språkkunskaper" ; -- språkkunskap..nn.1
  språkkurs_1_N = mkN "språkkurs" "språkkurser" ; -- språkkurs..nn.1
  språkkänsla_1_N = mkN "språkkänsla" ; -- språkkänsla..nn.1
  språklaboratorium_1_N = mkN "språklaboratorium" "språklaboratoriet" "språklaboratorier" "språklaboratorierna" ; -- språklaboratorium..nn.1
  språklektion_1_N = mkN "språklektion" ; -- språklektion..nn.1
  språklig_1_A = mkA "språklig" ; -- språklig..av.1
  språklighet_1_N = mkN "språklighet" "språkligheter" ; -- språklighet..nn.1
  språkljud_1_N = mkN "språkljud" neutrum  ; -- språkljud..nn.1
  språklära_1_N = mkN "språklära" ; -- språklära..nn.1
  språklärare_1_N = mkN "språklärare" utrum  ; -- språklärare..nn.1
  språkmässig_1_A = mkA "språkmässig" ; -- språkmässig..av.1
  språkmönster_1_N = mkN "språkmönster" neutrum  ; -- språkmönster..nn.1
  språkmöte_1_N = mkN "språkmöte" ; -- språkmöte..nn.1
  språknazism_1_N = mkN "språknazism" ; -- språknazism..nn.1
  språknazist_1_N = mkN "språknazist" "språknazister" ; -- språknazist..nn.1
  språkpolis_1_N = mkN "språkpolis" "språkpoliser" ; -- språkpolis..nn.1
  språkpoliseri_1_N = mkN "språkpoliseri" "språkpoliseriet" "språkpoliserier" "språkpoliserierna" ; -- språkpoliseri..nn.1
  språkpolitik_1_N = mkN "språkpolitik" ; -- språkpolitik..nn.1
  språkpolitisk_1_A = mkA "språkpolitisk" ; -- språkpolitisk..av.1
  språkprofessor_1_N = mkN "språkprofessor" "språkprofessorer" ; -- språkprofessor..nn.1
  språkprov_1_N = mkN "språkprov" neutrum  ; -- språkprov..nn.1
  språkpsykologi_1_N = mkN "språkpsykologi" ; -- språkpsykologi..nn.1
  språkregel_1_N = mkN "språkregel" "språkregeln" "språkregler" "språkreglerna" ; -- språkregel..nn.1
  språkresa_1_N = mkN "språkresa" ; -- språkresa..nn.1
  språkresurs_1_N = mkN "språkresurs" "språkresurser" ; -- språkresurs..nn.1
  språkriktig_1_A = mkA "språkriktig" ; -- språkriktig..av.1
  språkriktighet_1_N = mkN "språkriktighet" "språkriktigheter" ; -- språkriktighet..nn.1
  språkriktighetskonflikt_1_N = mkN "språkriktighetskonflikt" "språkriktighetskonflikter" ; -- språkriktighetskonflikt..nn.1
  språkriktighetskäpphäst_1_N = mkN "språkriktighetskäpphäst" ; -- språkriktighetskäpphäst..nn.1
  språkriktighetsproblem_1_N = mkN "språkriktighetsproblem" neutrum  ; -- språkriktighetsproblem..nn.1
  språkrör_1_N = mkN "språkrör" neutrum  ; -- språkrör..nn.1
  språksam_1_A = mkA "språksam" "språksamt" "språksamma" "språksamma" "språksammare" "språksammast" "språksammaste" ; -- språksam..av.1
  språksamhet_1_N = mkN "språksamhet" ; -- språksamhet..nn.1
  språksläktskap_1_N = mkN "språksläktskap" ; -- språksläktskap..nn.1
  språksociologi_1_N = mkN "språksociologi" ; -- språksociologi..nn.1
  språkspel_1_N = mkN "språkspel" "språkspelet" "språkspel" "språkspelen" ; -- språkspel..nn.1
  språkstam_1_N = mkN "språkstam" "språkstammen" "språkstammar" "språkstammarna" ; -- språkstam..nn.1
  språkstrid_1_N = mkN "språkstrid" "språkstrider" ; -- språkstrid..nn.1
  språktecken_1_N = mkN "språktecken" "språktecknet" "språktecken" "språktecknen" ; -- språktecken..nn.1
  språkteknik_1_N = mkN "språkteknik" "språktekniker" ; -- språkteknik..nn.1
  språkteknologi_1_N = mkN "språkteknologi" "språkteknologier" ; -- språkteknologi..nn.1
  språkteori_1_N = mkN "språkteori" "språkteorier" ; -- språkteori..nn.1
  språkundervisning_1_N = mkN "språkundervisning" ; -- språkundervisning..nn.1
  språkvetare_1_N = mkN "språkvetare" utrum  ; -- språkvetare..nn.1
  språkvetenskap_1_N = mkN "språkvetenskap" "språkvetenskaper" ; -- språkvetenskap..nn.1
  språkvård_1_N = mkN "språkvård" ; -- språkvård..nn.1
  språkvårdare_1_N = mkN "språkvårdare" utrum  ; -- språkvårdare..nn.1
  språng_1_N = mkN "språng" neutrum  ; -- språng..nn.1
  språngbräda_1_N = mkN "språngbräda" ; -- språngbräda..nn.1
  språngbräde_1_N = mkN "språngbräde" ; -- språngbräde..nn.1
  språngmarsch_1_N = mkN "språngmarsch" "språngmarscher" ; -- språngmarsch..nn.1
  språngsegel_1_N = mkN "språngsegel" neutrum  ; -- språngsegel..nn.1
  språngvis_1_Adv = mkAdv "språngvis" ; -- språngvis..ab.1
  spröd_1_A = mkA "spröd" "sprött" ; -- spröd..av.1
  sprödbakad_1_A = mkA "sprödbakad" ; -- sprödbakad..av.1
  sprödhet_1_N = mkN "sprödhet" ; -- sprödhet..nn.1
  spröjs_1_N = mkN "spröjs" ; -- spröjs..nn.1
  spröjsad_1_A = mkA "spröjsad" ; -- spröjsad..av.1
  spröt_1_N = mkN "spröt" neutrum  ; -- spröt..nn.1
  spröta_1_V = mkV "sprötar" ; -- spröta..vb.1
  sprötande_1_N = mkN "sprötande" ; -- sprötande..nn.1
  spunning_1_N = mkN "spunning" ; -- spunning..nn.1
  spurt_1_N = mkN "spurt" "spurter" ; -- spurt..nn.1
  spurta_1_V = mkV "spurtar" ; -- spurta..vb.1
  spurtande_1_N = mkN "spurtande" ; -- spurtande..nn.1
  sputnik_1_N = mkN "sputnik" ; -- sputnik..nn.1
  sputum_1_N = mkN "sputum" ; -- sputum..nn.1
  spy_1_V = mkV "spyr" ; -- spy..vb.1
  spya_1_N = mkN "spya" ; -- spya..nn.1
  spyboll_1_N = mkN "spyboll" ; -- spyboll..nn.1
  spydig_1_A = mkA "spydig" ; -- spydig..av.1
  spydighet_1_N = mkN "spydighet" "spydigheter" ; -- spydighet..nn.1
  spyende_1_N = mkN "spyende" ; -- spyende..nn.1
  spyfluga_1_N = mkN "spyfluga" ; -- spyfluga..nn.1
  spyfärdig_1_A = mkA "spyfärdig" ; -- spyfärdig..av.1
  spyfärdighet_1_N = mkN "spyfärdighet" ; -- spyfärdighet..nn.1
  spygatt_1_N = mkN "spygatt" neutrum  ; -- spygatt..nn.1
  spypåse_1_N = mkN "spypåse" utrum  ; -- spypåse..nn.1
  spä_1_V = mkV "spä" "spädde" "spätt" ; -- spä..vb.1
  späck_1_N = mkN "späck" neutrum  ; -- späck..nn.1
  späcka_1_V = mkV "späckar" ; -- späcka..vb.1
  späckande_1_N = mkN "späckande" ; -- späckande..nn.1
  späckhuggare_1_N = mkN "späckhuggare" utrum  ; -- späckhuggare..nn.1
  späckkorv_1_N = mkN "späckkorv" ; -- späckkorv..nn.1
  späckning_1_N = mkN "späckning" ; -- späckning..nn.1
  späd_1_A = mkA "späd" "spätt" ; -- späd..av.1
  spädande_1_N = mkN "spädande" ; -- spädande..nn.1
  spädbarn_1_N = mkN "spädbarn" neutrum  ; -- spädbarn..nn.1
  spädbarnsdöd_1_N = mkN "spädbarnsdöd" ; -- spädbarnsdöd..nn.1
  spädbarnsdödlighet_1_N = mkN "spädbarnsdödlighet" "spädbarnsdödligheter" ; -- spädbarnsdödlighet..nn.1
  spädbarnssjukdom_1_N = mkN "spädbarnssjukdom" ; -- spädbarnssjukdom..nn.1
  spädbarnsstadium_1_N = mkN "spädbarnsstadium" "spädbarnsstadiet" "spädbarnsstadier" "spädbarnsstadierna" ; -- spädbarnsstadium..nn.1
  späddricka_1_N = mkN "späddricka" ; -- späddricka..nn.1
  späddryck_1_N = mkN "späddryck" ; -- späddryck..nn.1
  spädget_1_N = mkN "spädget" "spädgetter" ; -- spädget..nn.1
  spädgris_1_N = mkN "spädgris" ; -- spädgris..nn.1
  spädhet_1_N = mkN "spädhet" ; -- spädhet..nn.1
  spädning_1_N = mkN "spädning" ; -- spädning..nn.1
  spädvuxen_1_A = mkA "spädvuxen" ; -- spädvuxen..av.1
  späka_1_V = mkV "späker" ; -- späka..vb.1
  späkande_1_N = mkN "späkande" ; -- späkande..nn.1
  späkning_1_N = mkN "späkning" ; -- späkning..nn.1
  spänd_1_A = mkA "spänd" ; -- spänd..av.1
  spändhet_1_N = mkN "spändhet" ; -- spändhet..nn.1
  spänn_1_N = mkN "spänn" "spännen" "spänn" "spännen" ; -- spänn..nn.1
  spänna_1_V = mkV "spänna" "spände" "spänt" ; -- spänna..vb.1
  spännande_1_A = mkA "spännande" ; -- spännande..av.1
  spännande_1_N = mkN "spännande" ; -- spännande..nn.1
  spännarm_1_N = mkN "spännarm" ; -- spännarm..nn.1
  spännband_1_N = mkN "spännband" neutrum  ; -- spännband..nn.1
  spännbetong_1_N = mkN "spännbetong" ; -- spännbetong..nn.1
  spännbuckla_1_N = mkN "spännbuckla" ; -- spännbuckla..nn.1
  spänne_1_N = mkN "spänne" ; -- spänne..nn.1
  spännfjäder_1_N = mkN "spännfjäder" ; -- spännfjäder..nn.1
  spänning_1_N = mkN "spänning" ; -- spänning..nn.1
  spänning_2_N = mkN "spänning" ; -- spänning..nn.2
  spänningsdelare_1_N = mkN "spänningsdelare" utrum  ; -- spänningsdelare..nn.1
  spänningsjustering_1_N = mkN "spänningsjustering" ; -- spänningsjustering..nn.1
  spänningsmässig_1_A = mkA "spänningsmässig" ; -- spänningsmässig..av.1
  spänningsomvandlare_1_N = mkN "spänningsomvandlare" utrum  ; -- spänningsomvandlare..nn.1
  spänningsregulator_1_N = mkN "spänningsregulator" "spänningsregulatorer" ; -- spänningsregulator..nn.1
  spänningssökare_1_N = mkN "spänningssökare" utrum  ; -- spänningssökare..nn.1
  spännmuskel_1_N = mkN "spännmuskel" "spännmuskeln" "spännmuskler" "spännmusklerna" ; -- spännmuskel..nn.1
  spännram_1_N = mkN "spännram" ; -- spännram..nn.1
  spännrem_1_N = mkN "spännrem" "spännremmen" "spännremmar" "spännremmarna" ; -- spännrem..nn.1
  spännvidd_1_N = mkN "spännvidd" "spännvidder" ; -- spännvidd..nn.1
  spännvinkel_1_N = mkN "spännvinkel" ; -- spännvinkel..nn.1
  späns_1_N = mkN "späns" "spänser" ; -- späns..nn.1
  spänst_1_N = mkN "spänst" ; -- spänst..nn.1
  spänsta_1_V = mkV "spänstar" ; -- spänsta..vb.1
  spänstande_1_N = mkN "spänstande" ; -- spänstande..nn.1
  spänstig_1_A = mkA "spänstig" ; -- spänstig..av.1
  spänstighet_1_N = mkN "spänstighet" ; -- spänstighet..nn.1
  spänta_1_V = mkV "späntar" ; -- spänta..vb.1
  späntande_1_N = mkN "späntande" ; -- späntande..nn.1
  späntning_1_N = mkN "späntning" ; -- späntning..nn.1
  spärr_1_N = mkN "spärr" ; -- spärr..nn.1
  spärra_1_V = mkV "spärrar" ; -- spärra..vb.1
  spärrande_1_N = mkN "spärrande" ; -- spärrande..nn.1
  spärrballong_1_N = mkN "spärrballong" "spärrballonger" ; -- spärrballong..nn.1
  spärrbom_1_N = mkN "spärrbom" "spärrbommen" "spärrbommar" "spärrbommarna" ; -- spärrbom..nn.1
  spärrdiod_1_N = mkN "spärrdiod" "spärrdioder" ; -- spärrdiod..nn.1
  spärreld_1_N = mkN "spärreld" ; -- spärreld..nn.1
  spärrhake_1_N = mkN "spärrhake" utrum  ; -- spärrhake..nn.1
  spärrkonto_1_N = mkN "spärrkonto" "spärrkontot" "spärrkonton" "spärrkontona" ; -- spärrkonto..nn.1
  spärrlinje_1_N = mkN "spärrlinje" "spärrlinjer" ; -- spärrlinje..nn.1
  spärrlista_1_N = mkN "spärrlista" ; -- spärrlista..nn.1
  spärrning_1_N = mkN "spärrning" ; -- spärrning..nn.1
  spärrvakt_1_N = mkN "spärrvakt" "spärrvakter" ; -- spärrvakt..nn.1
  spätlese_1_N = mkN "spätlese" utrum  ; -- spätlese..nn.1
  spätta_1_N = mkN "spätta" ; -- spätta..nn.1
  spå_1_V = mkV "spår" ; -- spå..vb.1
  spådom_1_N = mkN "spådom" ; -- spådom..nn.1
  spådomskonst_1_N = mkN "spådomskonst" "spådomskonster" ; -- spådomskonst..nn.1
  spående_1_N = mkN "spående" ; -- spående..nn.1
  spågumma_1_N = mkN "spågumma" ; -- spågumma..nn.1
  spåkvinna_1_N = mkN "spåkvinna" ; -- spåkvinna..nn.1
  spåkäring_1_N = mkN "spåkäring" ; -- spåkäring..nn.1
  spåman_1_N = mkN "spåman" "spåmannen" "spåmän" "spåmännen" ; -- spåman..nn.1
  spån_1_N = mkN "spån" neutrum  ; -- spån..nn.1
  spåna_1_N = mkN "spåna" ; -- spåna..nn.1
  spåna_1_V = mkV "spånar" ; -- spåna..vb.1
  spånad_1_N = mkN "spånad" "spånader" ; -- spånad..nn.1
  spånande_1_N = mkN "spånande" ; -- spånande..nn.1
  spånfågel_1_N = mkN "spånfågel" ; -- spånfågel..nn.1
  spång_1_N = mkN "spång" ; -- spång..nn.1
  spånga_1_V = mkV "spångar" ; -- spånga..vb.1
  spångande_1_N = mkN "spångande" ; -- spångande..nn.1
  spånk_1_N = mkN "spånk" ; -- spånk..nn.1
  spånklädd_1_A = mkA "spånklädd" ; -- spånklädd..av.1
  spånkorg_1_N = mkN "spånkorg" ; -- spånkorg..nn.1
  spånplatta_1_N = mkN "spånplatta" ; -- spånplatta..nn.1
  spånskiva_1_N = mkN "spånskiva" ; -- spånskiva..nn.1
  spånsug_1_N = mkN "spånsug" ; -- spånsug..nn.1
  spånt_1_N = mkN "spånt" "spånter" ; -- spånt..nn.1
  spånta_1_V = mkV "spåntar" ; -- spånta..vb.1
  spåntak_1_N = mkN "spåntak" neutrum  ; -- spåntak..nn.1
  spåntande_1_N = mkN "spåntande" ; -- spåntande..nn.1
  spåntning_1_N = mkN "spåntning" ; -- spåntning..nn.1
  spår_1_N = mkN "spår" neutrum  ; -- spår..nn.1
  spåra_1_V = mkV "spårar" ; -- spåra..vb.1
  spårande_1_N = mkN "spårande" ; -- spårande..nn.1
  spårarbete_1_N = mkN "spårarbete" ; -- spårarbete..nn.1
  spårbunden_1_A = mkA "spårbunden" ; -- spårbunden..av.1
  spårelement_1_N = mkN "spårelement" neutrum  ; -- spårelement..nn.1
  spårförsedd_1_A = mkA "spårförsedd" ; -- spårförsedd..av.1
  spårhund_1_N = mkN "spårhund" ; -- spårhund..nn.1
  spårig_1_A = mkA "spårig" ; -- spårig..av.1
  spårkapacitet_1_N = mkN "spårkapacitet" ; -- spårkapacitet..nn.1
  spårljus_1_N = mkN "spårljus" neutrum  ; -- spårljus..nn.1
  spårlös_1_A = mkA "spårlös" ; -- spårlös..av.1
  spårlöshet_1_N = mkN "spårlöshet" ; -- spårlöshet..nn.1
  spårmejsel_1_N = mkN "spårmejsel" ; -- spårmejsel..nn.1
  spårmetall_1_N = mkN "spårmetall" ; -- spårmetall..nn.1
  spårning_1_N = mkN "spårning" ; -- spårning..nn.1
  spårningschip_1_N = mkN "spårningschip" neutrum  ; -- spårningschip..nn.1
  spårningschipp_1_N = mkN "spårningschipp" neutrum  ; -- spårningschipp..nn.1
  spårsäkring_1_N = mkN "spårsäkring" ; -- spårsäkring..nn.1
  spårvagn_1_N = mkN "spårvagn" ; -- spårvagn..nn.1
  spårvagnsspår_1_N = mkN "spårvagnsspår" neutrum  ; -- spårvagnsspår..nn.1
  spårvidd_1_N = mkN "spårvidd" "spårvidder" ; -- spårvidd..nn.1
  spårväg_1_N = mkN "spårväg" ; -- spårväg..nn.1
  spårvägschef_1_N = mkN "spårvägschef" "spårvägschefer" ; -- spårvägschef..nn.1
  spårämne_1_N = mkN "spårämne" ; -- spårämne..nn.1
  spö_1_N = mkN "spö" "spöt" "spön" "spöna" ; -- spö..nn.1
  spöa_1_V = mkV "spöar" ; -- spöa..vb.1
  spöande_1_N = mkN "spöande" ; -- spöande..nn.1
  spöka_1_V = mkV "spökar" ; -- spöka..vb.1
  spökaktig_1_A = mkA "spökaktig" ; -- spökaktig..av.1
  spökaktighet_1_N = mkN "spökaktighet" ; -- spökaktighet..nn.1
  spökande_1_N = mkN "spökande" ; -- spökande..nn.1
  spökbild_1_N = mkN "spökbild" "spökbilder" ; -- spökbild..nn.1
  spökdjur_1_N = mkN "spökdjur" neutrum  ; -- spökdjur..nn.1
  spöke_1_N = mkN "spöke" ; -- spöke..nn.1
  spökelse_1_N = mkN "spökelse" "spökelset" "spökelser" "spökelserna" ; -- spökelse..nn.1
  spökeri_1_N = mkN "spökeri" "spökeriet" "spökerier" "spökerierna" ; -- spökeri..nn.1
  spökfigur_1_N = mkN "spökfigur" "spökfigurer" ; -- spökfigur..nn.1
  spökgestalt_1_N = mkN "spökgestalt" "spökgestalter" ; -- spökgestalt..nn.1
  spökhistoria_1_N = mkN "spökhistoria" "spökhistorian" "spökhistorier" "spökhistorierna" ; -- spökhistoria..nn.1
  spöklik_1_A = mkA "spöklik" ; -- spöklik..av.1
  spöklikhet_1_N = mkN "spöklikhet" ; -- spöklikhet..nn.1
  spökpartikel_1_N = mkN "spökpartikel" ; -- spökpartikel..nn.1
  spökrädd_1_A = mkA "spökrädd" ; -- spökrädd..av.1
  spökrädsla_1_N = mkN "spökrädsla" ; -- spökrädsla..nn.1
  spökskepp_1_N = mkN "spökskepp" neutrum  ; -- spökskepp..nn.1
  spökskrivare_1_N = mkN "spökskrivare" utrum  ; -- spökskrivare..nn.1
  spökstad_1_N = mkN "spökstad" "spökstäder" ; -- spökstad..nn.1
  spöktimma_1_N = mkN "spöktimma" ; -- spöktimma..nn.1
  spöktimme_1_N = mkN "spöktimme" utrum  ; -- spöktimme..nn.1
  spöregn_1_N = mkN "spöregn" neutrum  ; -- spöregn..nn.1
  spöregna_1_V = mkV "spöregnar" ; -- spöregna..vb.1
  spöregnande_1_N = mkN "spöregnande" ; -- spöregnande..nn.1
  spörja_1_V = mkV "spörja" "sporde" "sport" ; -- spörja..vb.1
  spörjande_1_N = mkN "spörjande" ; -- spörjande..nn.1
  spörsmål_1_N = mkN "spörsmål" neutrum  ; -- spörsmål..nn.1
  spöslitning_1_N = mkN "spöslitning" ; -- spöslitning..nn.1
  spöstraff_1_N = mkN "spöstraff" neutrum  ; -- spöstraff..nn.1
  squash_1_N = mkN "squash" ; -- squash..nn.1
  squash_2_N = mkN "squash" "squasher" ; -- squash..nn.2
  squashboll_1_N = mkN "squashboll" ; -- squashboll..nn.1
  squashrack_1_N = mkN "squashrack" ; -- squashrack..nn.1
  squashracket_1_N = mkN "squashracket" ; -- squashracket..nn.1
  squaw_1_N = mkN "squaw" "squawn" "squawer" "squawerna" ; -- squaw..nn.1
  srilankes_1_N = mkN "srilankes" "srilankeser" ; -- srilankes..nn.1
  srilankesisk_1_A = mkA "srilankesisk" ; -- srilankesisk..av.1
  srilankesiska_1_N = mkN "srilankesiska" ; -- srilankesiska..nn.1
  stab_1_N = mkN "stab" "staber" ; -- stab..nn.1
  stabbe_1_N = mkN "stabbe" utrum  ; -- stabbe..nn.1
  stabbig_1_A = mkA "stabbig" ; -- stabbig..av.1
  stabbighet_1_N = mkN "stabbighet" ; -- stabbighet..nn.1
  stabbur_1_N = mkN "stabbur" ; -- stabbur..nn.1
  stabil_1_A = mkA "stabil" ; -- stabil..av.1
  stabilisator_1_N = mkN "stabilisator" "stabilisatorer" ; -- stabilisator..nn.1
  stabilisera_1_V = mkV "stabiliserar" ; -- stabilisera..vb.1
  stabiliserande_1_N = mkN "stabiliserande" ; -- stabiliserande..nn.1
  stabiliserbar_1_A = mkA "stabiliserbar" ; -- stabiliserbar..av.1
  stabiliserbarhet_1_N = mkN "stabiliserbarhet" ; -- stabiliserbarhet..nn.1
  stabilisering_1_N = mkN "stabilisering" ; -- stabilisering..nn.1
  stabiliseringsfena_1_N = mkN "stabiliseringsfena" ; -- stabiliseringsfena..nn.1
  stabiliseringsproblem_1_N = mkN "stabiliseringsproblem" neutrum  ; -- stabiliseringsproblem..nn.1
  stabilitet_1_N = mkN "stabilitet" "stabiliteter" ; -- stabilitet..nn.1
  stabilitetspakt_1_N = mkN "stabilitetspakt" "stabilitetspakter" ; -- stabilitetspakt..nn.1
  stabschef_1_N = mkN "stabschef" "stabschefer" ; -- stabschef..nn.1
  stabskarta_1_N = mkN "stabskarta" ; -- stabskarta..nn.1
  stabskompani_1_N = mkN "stabskompani" "stabskompaniet" "stabskompanier" "stabskompanierna" ; -- stabskompani..nn.1
  stabsofficer_1_N = mkN "stabsofficer" "stabsofficeren" "stabsofficerare" "stabsofficerarna" ; -- stabsofficer..nn.1
  stack_1_N = mkN "stack" ; -- stack..nn.1
  stacka_1_V = mkV "stackar" ; -- stacka..vb.1
  stackande_1_N = mkN "stackande" ; -- stackande..nn.1
  stackare_1_N = mkN "stackare" utrum  ; -- stackare..nn.1
  stackars_1_A = mkA "stackars" ; -- stackars..av.1
  stackato_1_N = mkN "stackato" "stackatot" "stackaton" "stackatona" ; -- stackato..nn.1
  stackmoln_1_N = mkN "stackmoln" neutrum  ; -- stackmoln..nn.1
  stackmyra_1_N = mkN "stackmyra" ; -- stackmyra..nn.1
  stackning_1_N = mkN "stackning" ; -- stackning..nn.1
  stad_1_N = mkN "stad" "städer" ; -- stad..nn.1
  stadd_1_A = mkA "stadd" ; -- stadd..av.1
  stadfästa_1_V = mkV "stadfästa" "stadfäster" "stadfäst" "stadfäste" "stadfäst" "stadfäst" ; -- stadfästa..vb.1
  stadfästande_1_N = mkN "stadfästande" ; -- stadfästande..nn.1
  stadfästelse_1_N = mkN "stadfästelse" "stadfästelser" ; -- stadfästelse..nn.1
  stadga_1_N = mkN "stadga" ; -- stadga..nn.1
  stadga_2_N = mkN "stadga" ; -- stadga..nn.2
  stadga_1_V = mkV "stadgar" ; -- stadga..vb.1
  stadgad_1_A = mkA "stadgad" ; -- stadgad..av.1
  stadgande_1_N = mkN "stadgande" ; -- stadgande..nn.1
  stadgemässig_1_A = mkA "stadgemässig" ; -- stadgemässig..av.1
  stadig_1_A = mkA "stadig" ; -- stadig..av.1
  stadighet_1_N = mkN "stadighet" ; -- stadighet..nn.1
  stadigvarande_1_A = mkA "stadigvarande" ; -- stadigvarande..av.1
  stadion_1_N = mkN "stadion" neutrum  ; -- stadion..nn.1
  stadion_2_N = mkN "stadium" "stadiet" "stadier" "stadierna" ; -- stadion..nn.2
  stadiontuta_1_N = mkN "stadiontuta" ; -- stadiontuta..nn.1
  stadium_1_N = mkN "stadium" "stadiet" "stadier" "stadierna" ; -- stadium..nn.1
  stadkant_1_N = mkN "stadkant" "stadkanter" ; -- stadkant..nn.1
  stadsarkitekt_1_N = mkN "stadsarkitekt" "stadsarkitekter" ; -- stadsarkitekt..nn.1
  stadsarkiv_1_N = mkN "stadsarkiv" neutrum  ; -- stadsarkiv..nn.1
  stadsbarn_1_N = mkN "stadsbarn" neutrum  ; -- stadsbarn..nn.1
  stadsbebyggelse_1_N = mkN "stadsbebyggelse" "stadsbebyggelser" ; -- stadsbebyggelse..nn.1
  stadsbesök_1_N = mkN "stadsbesök" neutrum  ; -- stadsbesök..nn.1
  stadsbibliotek_1_N = mkN "stadsbibliotek" neutrum  ; -- stadsbibliotek..nn.1
  stadsbild_1_N = mkN "stadsbild" "stadsbilder" ; -- stadsbild..nn.1
  stadsbildmässig_1_A = mkA "stadsbildmässig" ; -- stadsbildmässig..av.1
  stadsbildsmässig_1_A = mkA "stadsbildsmässig" ; -- stadsbildsmässig..av.1
  stadsbo_1_N = mkN "stadsbo" "stadsbor" ; -- stadsbo..nn.1
  stadsbud_1_N = mkN "stadsbud" neutrum  ; -- stadsbud..nn.1
  stadsbuss_1_N = mkN "stadsbuss" ; -- stadsbuss..nn.1
  stadsbyggnad_1_N = mkN "stadsbyggnad" ; -- stadsbyggnad..nn.1
  stadsbyggnadsborgarråd_1_N = mkN "stadsbyggnadsborgarråd" neutrum  ; -- stadsbyggnadsborgarråd..nn.1
  stadsbyggnadskontor_1_N = mkN "stadsbyggnadskontor" neutrum  ; -- stadsbyggnadskontor..nn.1
  stadsbyggnadsmässig_1_A = mkA "stadsbyggnadsmässig" ; -- stadsbyggnadsmässig..av.1
  stadsdel_1_N = mkN "stadsdel" "stadsdelen" "stadsdelar" "stadsdelarna" ; -- stadsdel..nn.1
  stadsdelsförvaltning_1_N = mkN "stadsdelsförvaltning" ; -- stadsdelsförvaltning..nn.1
  stadsdelsnämnd_1_N = mkN "stadsdelsnämnd" "stadsdelsnämnder" ; -- stadsdelsnämnd..nn.1
  stadsdirektör_1_N = mkN "stadsdirektör" "stadsdirektörer" ; -- stadsdirektör..nn.1
  stadsdress_1_N = mkN "stadsdress" ; -- stadsdress..nn.1
  stadsfullmäktig_1_N = mkN "stadsfullmäktig" "stadsfullmäktigen" "stadsfullmäktige" "stadsfullmäktigena" ; -- stadsfullmäktig..nn.1
  stadsfullmäktige_1_N = mkN "stadsfullmäktige" ; -- stadsfullmäktige..nn.1
  stadsgas_1_N = mkN "stadsgas" ; -- stadsgas..nn.1
  stadsgrönska_1_N = mkN "stadsgrönska" ; -- stadsgrönska..nn.1
  stadshotell_1_N = mkN "stadshotell" neutrum  ; -- stadshotell..nn.1
  stadshus_1_N = mkN "stadshus" neutrum  ; -- stadshus..nn.1
  stadsjeep_1_N = mkN "stadsjeep" ; -- stadsjeep..nn.1
  stadsjeepägare_1_N = mkN "stadsjeepägare" utrum  ; -- stadsjeepägare..nn.1
  stadskärna_1_N = mkN "stadskärna" ; -- stadskärna..nn.1
  stadsliknande_1_A = mkA "stadsliknande" ; -- stadsliknande..av.1
  stadsliv_1_N = mkN "stadsliv" neutrum  ; -- stadsliv..nn.1
  stadsljus_1_N = mkN "stadsljus" neutrum  ; -- stadsljus..nn.1
  stadsmiljö_1_N = mkN "stadsmiljö" "stadsmiljön" "stadsmiljöer" "stadsmiljöerna" ; -- stadsmiljö..nn.1
  stadsmiljömässig_1_A = mkA "stadsmiljömässig" ; -- stadsmiljömässig..av.1
  stadsmission_1_N = mkN "stadsmission" ; -- stadsmission..nn.1
  stadsmur_1_N = mkN "stadsmur" ; -- stadsmur..nn.1
  stadsmässig_1_A = mkA "stadsmässig" ; -- stadsmässig..av.1
  stadspark_1_N = mkN "stadspark" "stadsparker" ; -- stadspark..nn.1
  stadsplan_1_N = mkN "stadsplan" "stadsplaner" ; -- stadsplan..nn.1
  stadsplanekontor_1_N = mkN "stadsplanekontor" neutrum  ; -- stadsplanekontor..nn.1
  stadsplanemässig_1_A = mkA "stadsplanemässig" ; -- stadsplanemässig..av.1
  stadsplanera_1_V = mkV "stadsplanerar" ; -- stadsplanera..vb.1
  stadsplanerande_1_N = mkN "stadsplanerande" ; -- stadsplanerande..nn.1
  stadsplanerare_1_N = mkN "stadsplanerare" utrum  ; -- stadsplanerare..nn.1
  stadsplanerbar_1_A = mkA "stadsplanerbar" ; -- stadsplanerbar..av.1
  stadsplanerbarhet_1_N = mkN "stadsplanerbarhet" ; -- stadsplanerbarhet..nn.1
  stadsplanering_1_N = mkN "stadsplanering" ; -- stadsplanering..nn.1
  stadsport_1_N = mkN "stadsport" ; -- stadsport..nn.1
  stadsresa_1_N = mkN "stadsresa" ; -- stadsresa..nn.1
  stadsrum_1_N = mkN "stadsrum" "stadsrummet" "stadsrum" "stadsrummen" ; -- stadsrum..nn.1
  stadssekreterare_1_N = mkN "stadssekreterare" utrum  ; -- stadssekreterare..nn.1
  stadssilhuett_1_N = mkN "stadssilhuett" "stadssilhuetter" ; -- stadssilhuett..nn.1
  stadsskog_1_N = mkN "stadsskog" ; -- stadsskog..nn.1
  stadsstat_1_N = mkN "stadsstat" "stadsstater" ; -- stadsstat..nn.1
  stadsteater_1_N = mkN "stadsteater" ; -- stadsteater..nn.1
  stadsvandring_1_N = mkN "stadsvandring" ; -- stadsvandring..nn.1
  stadvända_1_V = mkV "stadvänder" ; -- stadvända..vb.1
  stadvändande_1_N = mkN "stadvändande" ; -- stadvändande..nn.1
  stafett_1_N = mkN "stafett" "stafetter" ; -- stafett..nn.1
  stafettläkare_1_N = mkN "stafettläkare" utrum  ; -- stafettläkare..nn.1
  stafettlöpning_1_N = mkN "stafettlöpning" ; -- stafettlöpning..nn.1
  staffage_1_N = mkN "staffage" ; -- staffage..nn.1
  staffagefigur_1_N = mkN "staffagefigur" "staffagefigurer" ; -- staffagefigur..nn.1
  staffera_1_V = mkV "stafferar" ; -- staffera..vb.1
  stafferande_1_N = mkN "stafferande" ; -- stafferande..nn.1
  stafferbar_1_A = mkA "stafferbar" ; -- stafferbar..av.1
  stafferbarhet_1_N = mkN "stafferbarhet" ; -- stafferbarhet..nn.1
  staffering_1_N = mkN "staffering" ; -- staffering..nn.1
  staffli_1_N = mkN "staffli" "stafflit" "stafflin" "stafflina" ; -- staffli..nn.1
  stafflimålning_1_N = mkN "stafflimålning" ; -- stafflimålning..nn.1
  stafylokock_1_N = mkN "stafylokock" "stafylokocker" ; -- stafylokock..nn.1
  stag_1_N = mkN "stag" neutrum  ; -- stag..nn.1
  staga_1_V = mkV "stagar" ; -- staga..vb.1
  stagande_1_N = mkN "stagande" ; -- stagande..nn.1
  stagflation_1_N = mkN "stagflation" ; -- stagflation..nn.1
  stagg_1_N = mkN "stagg" ; -- stagg..nn.1
  stagnation_1_N = mkN "stagnation" ; -- stagnation..nn.1
  stagnera_1_V = mkV "stagnerar" ; -- stagnera..vb.1
  stagnerande_1_N = mkN "stagnerande" ; -- stagnerande..nn.1
  stagnering_1_N = mkN "stagnering" ; -- stagnering..nn.1
  stagsegel_1_N = mkN "stagsegel" neutrum  ; -- stagsegel..nn.1
  stagvända_1_V = mkV "stagvänder" ; -- stagvända..vb.1
  stagvändande_1_N = mkN "stagvändande" ; -- stagvändande..nn.1
  stagvändning_1_N = mkN "stagvändning" ; -- stagvändning..nn.1
  stajla_1_V = mkV "stajlar" ; -- stajla..vb.1
  stajlande_1_N = mkN "stajlande" ; -- stajlande..nn.1
  stajling_1_N = mkN "stajling" ; -- stajling..nn.1
  staka_1_V = mkV "stakar" ; -- staka..vb.1
  stakande_1_N = mkN "stakande" ; -- stakande..nn.1
  stake_1_N = mkN "stake" utrum  ; -- stake..nn.1
  stake_2_N = mkN "stake" ; -- stake..nn.2
  staket_1_N = mkN "staket" neutrum  ; -- staket..nn.1
  staketstolpe_1_N = mkN "staketstolpe" utrum  ; -- staketstolpe..nn.1
  stalagmit_1_N = mkN "stalagmit" "stalagmiter" ; -- stalagmit..nn.1
  stalaktit_1_N = mkN "stalaktit" "stalaktiter" ; -- stalaktit..nn.1
  stalinism_1_N = mkN "stalinism" "stalinismer" ; -- stalinism..nn.1
  stalinist_1_N = mkN "stalinist" "stalinister" ; -- stalinist..nn.1
  stalinistisk_1_A = mkA "stalinistisk" ; -- stalinistisk..av.1
  stalka_1_V = mkV "stalkar" ; -- stalka..vb.1
  stalkande_1_N = mkN "stalkande" ; -- stalkande..nn.1
  stalkare_1_N = mkN "stalkare" utrum  ; -- stalkare..nn.1
  stalker_1_N = mkN "stalker" ; -- stalker..nn.1
  stalking_1_N = mkN "stalking" ; -- stalking..nn.1
  stalkning_1_N = mkN "stalkning" ; -- stalkning..nn.1
  stall_1_N = mkN "stall" neutrum  ; -- stall..nn.1
  stall_2_N = mkN "stall" neutrum  ; -- stall..nn.2
  stall_3_N = mkN "stall" ; -- stall..nn.3
  stalla_1_V = mkV "stallar" ; -- stalla..vb.1
  stallande_1_N = mkN "stallande" ; -- stallande..nn.1
  stallbacke_1_N = mkN "stallbacke" utrum  ; -- stallbacke..nn.1
  stallbroder_1_N = mkN "stallbroder" "stallbrodern" "stallbröder" "stallbröderna" ; -- stallbroder..nn.1
  stallknekt_1_N = mkN "stallknekt" ; -- stallknekt..nn.1
  stallmästare_1_N = mkN "stallmästare" utrum  ; -- stallmästare..nn.1
  stallskulle_1_N = mkN "stallskulle" utrum  ; -- stallskulle..nn.1
  stalltips_1_N = mkN "stalltips" neutrum  ; -- stalltips..nn.1
  stallykta_1_N = mkN "stallykta" ; -- stallykta..nn.1
  stam_1_N = mkN "stam" "stammen" "stammar" "stammarna" ; -- stam..nn.1
  stamaktie_1_N = mkN "stamaktie" "stamaktier" ; -- stamaktie..nn.1
  stamanställd_1_A = mkA "stamanställd" "stamanställt" ; -- stamanställd..av.1
  stambana_1_N = mkN "stambana" ; -- stambana..nn.1
  stambok_1_N = mkN "stambok" "stamböcker" ; -- stambok..nn.1
  stambord_1_N = mkN "stambord" neutrum  ; -- stambord..nn.1
  stamcell_1_N = mkN "stamcell" "stamceller" ; -- stamcell..nn.1
  stamfar_1_N = mkN "stamfader" "stamfadern" "stamfäder" "stamfäderna" ; -- stamfar..nn.1
  stamfrände_1_N = mkN "stamfrände" "stamfränder" ; -- stamfrände..nn.1
  stamgods_1_N = mkN "stamgods" neutrum  ; -- stamgods..nn.1
  stamgäst_1_N = mkN "stamgäst" "stamgäster" ; -- stamgäst..nn.1
  stamhövding_1_N = mkN "stamhövding" ; -- stamhövding..nn.1
  stamkrigare_1_N = mkN "stamkrigare" utrum  ; -- stamkrigare..nn.1
  stamkund_1_N = mkN "stamkund" "stamkunder" ; -- stamkund..nn.1
  stamlinje_1_N = mkN "stamlinje" "stamlinjer" ; -- stamlinje..nn.1
  stamlokus_1_N = mkN "stamlokus" neutrum  ; -- stamlokus..nn.1
  stamma_1_V = mkV "stammar" ; -- stamma..vb.1
  stamma_2_V = mkV "stammar" ; -- stamma..vb.2
  stammande_1_N = mkN "stammande" ; -- stammande..nn.1
  stammare_1_N = mkN "stammare" utrum  ; -- stammare..nn.1
  stammoder_1_N = mkN "stammoder" "stammodern" "stammödrar" "stammödrarna" ; -- stammoder..nn.1
  stamning_1_N = mkN "stamning" ; -- stamning..nn.1
  stamort_1_N = mkN "stamort" "stamorter" ; -- stamort..nn.1
  stamp_1_N = mkN "stamp" ; -- stamp..nn.1
  stamp_2_N = mkN "stamp" neutrum  ; -- stamp..nn.2
  stamp_3_N = mkN "stamp" neutrum  ; -- stamp..nn.3
  stampa_1_V = mkV "stampar" ; -- stampa..vb.1
  stampa_2_V = mkV "stampar" ; -- stampa..vb.2
  stampande_1_N = mkN "stampande" ; -- stampande..nn.1
  stampkvarn_1_N = mkN "stampkvarn" ; -- stampkvarn..nn.1
  stampning_1_N = mkN "stampning" ; -- stampning..nn.1
  stamsamhälle_1_N = mkN "stamsamhälle" ; -- stamsamhälle..nn.1
  stamsoldat_1_N = mkN "stamsoldat" "stamsoldater" ; -- stamsoldat..nn.1
  stamspråk_1_N = mkN "stamspråk" neutrum  ; -- stamspråk..nn.1
  stamstavelse_1_N = mkN "stamstavelse" "stamstavelser" ; -- stamstavelse..nn.1
  stamtavla_1_N = mkN "stamtavla" ; -- stamtavla..nn.1
  stamton_1_N = mkN "stamton" "stamtoner" ; -- stamton..nn.1
  stamträd_1_N = mkN "stamträd" neutrum  ; -- stamträd..nn.1
  stamvörtstyrka_1_N = mkN "stamvörtstyrka" ; -- stamvörtstyrka..nn.1
  stand_in_1_N = mkN "stand-in" "stand-iner" ; -- stand-in..nn.1
  standar_1_N = mkN "standar" neutrum  ; -- standar..nn.1
  standard_1_N = mkN "standard" "standarder" ; -- standard..nn.1
  standardavvikelse_1_N = mkN "standardavvikelse" "standardavvikelser" ; -- standardavvikelse..nn.1
  standardformulär_1_N = mkN "standardformulär" neutrum  ; -- standardformulär..nn.1
  standardhyckleri_1_N = mkN "standardhyckleri" "standardhyckleriet" "standardhycklerier" "standardhycklerierna" ; -- standardhyckleri..nn.1
  standardhöjning_1_N = mkN "standardhöjning" ; -- standardhöjning..nn.1
  standardingrediens_1_N = mkN "standardingrediens" "standardingredienser" ; -- standardingrediens..nn.1
  standardinventarium_1_N = mkN "standardinventarium" "standardinventariet" "standardinventarier" "standardinventarierna" ; -- standardinventarium..nn.1
  standardisera_1_V = mkV "standardiserar" ; -- standardisera..vb.1
  standardiserande_1_N = mkN "standardiserande" ; -- standardiserande..nn.1
  standardiserbar_1_A = mkA "standardiserbar" ; -- standardiserbar..av.1
  standardiserbarhet_1_N = mkN "standardiserbarhet" ; -- standardiserbarhet..nn.1
  standardisering_1_N = mkN "standardisering" ; -- standardisering..nn.1
  standardislam_1_N = mkN "standardislam" ; -- standardislam..nn.1
  standardklyscha_1_N = mkN "standardklyscha" ; -- standardklyscha..nn.1
  standardlösning_1_N = mkN "standardlösning" ; -- standardlösning..nn.1
  standardmässig_1_A = mkA "standardmässig" ; -- standardmässig..av.1
  standardprov_1_N = mkN "standardprov" neutrum  ; -- standardprov..nn.1
  standardspråk_1_N = mkN "standardspråk" neutrum  ; -- standardspråk..nn.1
  standardspråklig_1_A = mkA "standardspråklig" ; -- standardspråklig..av.1
  standardspråklighet_1_N = mkN "standardspråklighet" "standardspråkligheter" ; -- standardspråklighet..nn.1
  standardsvar_1_N = mkN "standardsvar" neutrum  ; -- standardsvar..nn.1
  standardverk_1_N = mkN "standardverk" neutrum  ; -- standardverk..nn.1
  standert_1_N = mkN "standert" ; -- standert..nn.1
  stank_1_N = mkN "stank" "stanker" ; -- stank..nn.1
  stanna_1_V = mkV "stannar" ; -- stanna..vb.1
  stannande_1_N = mkN "stannande" ; -- stannande..nn.1
  stannfågel_1_N = mkN "stannfågel" ; -- stannfågel..nn.1
  stanning_1_N = mkN "stanning" ; -- stanning..nn.1
  stanniol_1_N = mkN "stanniol" ; -- stanniol..nn.1
  stannplan_1_N = mkN "stannplan" neutrum  ; -- stannplan..nn.1
  stans_1_N = mkN "stans" ; -- stans..nn.1
  stans_2_N = mkN "stans" "stanser" ; -- stans..nn.2
  stansa_1_V = mkV "stansar" ; -- stansa..vb.1
  stansande_1_N = mkN "stansande" ; -- stansande..nn.1
  stansning_1_N = mkN "stansning" ; -- stansning..nn.1
  stapel_1_N = mkN "stapel" ; -- stapel..nn.1
  stapelavlöpning_1_N = mkN "stapelavlöpning" ; -- stapelavlöpning..nn.1
  stapelbädd_1_N = mkN "stapelbädd" ; -- stapelbädd..nn.1
  stapeldiagram_1_N = mkN "stapeldiagram" "stapeldiagrammet" "stapeldiagram" "stapeldiagrammen" ; -- stapeldiagram..nn.1
  stapelplats_1_N = mkN "stapelplats" "stapelplatser" ; -- stapelplats..nn.1
  stapelstad_1_N = mkN "stapelstad" "stapelstäder" ; -- stapelstad..nn.1
  stapelvara_1_N = mkN "stapelvara" ; -- stapelvara..nn.1
  stapla_1_V = mkV "staplar" ; -- stapla..vb.1
  staplande_1_N = mkN "staplande" ; -- staplande..nn.1
  stapling_1_N = mkN "stapling" ; -- stapling..nn.1
  stappla_1_V = mkV "stapplar" ; -- stappla..vb.1
  stapplande_1_N = mkN "stapplande" ; -- stapplande..nn.1
  star_1_N = mkN "star" ; -- star..nn.1
  starbåt_1_N = mkN "starbåt" ; -- starbåt..nn.1
  stare_1_N = mkN "stare" "starar" ; -- stare..nn.1
  stark_1_A = mkA "stark" ; -- stark..av.1
  starkhet_1_N = mkN "starkhet" ; -- starkhet..nn.1
  starksprit_1_N = mkN "starksprit" ; -- starksprit..nn.1
  starkström_1_N = mkN "starkström" "starkströmmen" "starkströmmar" "starkströmmarna" ; -- starkström..nn.1
  starkvara_1_N = mkN "starkvara" ; -- starkvara..nn.1
  starkvin_1_N = mkN "starkvin" "starkvinet" "starkviner" "starkvinerna" ; -- starkvin..nn.1
  starköl_1_N = mkN "starköl" neutrum  ; -- starköl..nn.1
  starr_1_N = mkN "starr" ; -- starr..nn.1
  starrbliga_1_V = mkV "starrbligar" ; -- starrbliga..vb.1
  starrbligande_1_N = mkN "starrbligande" ; -- starrbligande..nn.1
  starrblindhet_1_N = mkN "starrblindhet" ; -- starrblindhet..nn.1
  starroperation_1_N = mkN "starroperation" ; -- starroperation..nn.1
  start_1_N = mkN "start" "starter" ; -- start..nn.1
  starta_1_V = mkV "startar" ; -- starta..vb.1
  starta_2_V = mkV "startar" ; -- starta..vb.2
  startande_1_N = mkN "startande" ; -- startande..nn.1
  startavgift_1_N = mkN "startavgift" "startavgifter" ; -- startavgift..nn.1
  startbana_1_N = mkN "startbana" ; -- startbana..nn.1
  startbatteri_1_N = mkN "startbatteri" "startbatteriet" "startbatterier" "startbatterierna" ; -- startbatteri..nn.1
  startberedd_1_A = mkA "startberedd" ; -- startberedd..av.1
  startblock_1_N = mkN "startblock" neutrum  ; -- startblock..nn.1
  startenergi_1_N = mkN "startenergi" ; -- startenergi..nn.1
  starter_1_N = mkN "starter" "startern" "starter" "starterna" ; -- starter..nn.1
  startfält_1_N = mkN "startfält" neutrum  ; -- startfält..nn.1
  startfålla_1_N = mkN "startfålla" ; -- startfålla..nn.1
  startgenerator_1_N = mkN "startgenerator" "startgeneratorer" ; -- startgenerator..nn.1
  startgrop_1_N = mkN "startgrop" ; -- startgrop..nn.1
  startkabel_1_N = mkN "startkabel" ; -- startkabel..nn.1
  startkapital_1_N = mkN "startkapital" neutrum  ; -- startkapital..nn.1
  startklar_1_A = mkA "startklar" ; -- startklar..av.1
  startlinje_1_N = mkN "startlinje" "startlinjer" ; -- startlinje..nn.1
  startmotor_1_N = mkN "startmotor" "startmotorer" ; -- startmotor..nn.1
  startnyckel_1_N = mkN "startnyckel" ; -- startnyckel..nn.1
  startpall_1_N = mkN "startpall" ; -- startpall..nn.1
  startpistol_1_N = mkN "startpistol" "startpistoler" ; -- startpistol..nn.1
  startpris_1_N = mkN "startpris" neutrum  ; -- startpris..nn.1
  startproblem_1_N = mkN "startproblem" neutrum  ; -- startproblem..nn.1
  startpunkt_1_N = mkN "startpunkt" "startpunkter" ; -- startpunkt..nn.1
  startskjut_1_N = mkN "startskjut" neutrum  ; -- startskjut..nn.1
  startskott_1_N = mkN "startskott" neutrum  ; -- startskott..nn.1
  startsnabb_1_A = mkA "startsnabb" ; -- startsnabb..av.1
  startsnöre_1_N = mkN "startsnöre" ; -- startsnöre..nn.1
  startspjäll_1_N = mkN "startspjäll" neutrum  ; -- startspjäll..nn.1
  startsträcka_1_N = mkN "startsträcka" ; -- startsträcka..nn.1
  startsystem_1_N = mkN "startsystem" neutrum  ; -- startsystem..nn.1
  starttid_1_N = mkN "starttid" "starttider" ; -- starttid..nn.1
  startvev_1_N = mkN "startvev" ; -- startvev..nn.1
  stas_1_N = mkN "stas" "staser" ; -- stas..nn.1
  stass_1_N = mkN "stass" ; -- stass..nn.1
  stassa_1_V = mkV "stassar" ; -- stassa..vb.1
  stassande_1_N = mkN "stassande" ; -- stassande..nn.1
  stat_1_N = mkN "stat" "stater" ; -- stat..nn.1
  stat_2_N = mkN "stat" ; -- stat..nn.2
  statare_1_N = mkN "statare" utrum  ; -- statare..nn.1
  statera_1_V = mkV "staterar" ; -- statera..vb.1
  staterande_1_N = mkN "staterande" ; -- staterande..nn.1
  statering_1_N = mkN "statering" ; -- statering..nn.1
  statik_1_N = mkN "statik" ; -- statik..nn.1
  station_1_N = mkN "station" ; -- station..nn.1
  stationera_1_V = mkV "stationerar" ; -- stationera..vb.1
  stationerande_1_N = mkN "stationerande" ; -- stationerande..nn.1
  stationerbar_1_A = mkA "stationerbar" ; -- stationerbar..av.1
  stationerbarhet_1_N = mkN "stationerbarhet" ; -- stationerbarhet..nn.1
  stationering_1_N = mkN "stationering" ; -- stationering..nn.1
  stationsbefäl_1_N = mkN "stationsbefäl" neutrum  ; -- stationsbefäl..nn.1
  stationsbyggnad_1_N = mkN "stationsbyggnad" "stationsbyggnader" ; -- stationsbyggnad..nn.1
  stationshus_1_N = mkN "stationshus" neutrum  ; -- stationshus..nn.1
  stationsinspektor_1_N = mkN "stationsinspektor" "stationsinspektorer" ; -- stationsinspektor..nn.1
  stationssamhälle_1_N = mkN "stationssamhälle" ; -- stationssamhälle..nn.1
  stationsvagn_1_N = mkN "stationsvagn" ; -- stationsvagn..nn.1
  stationär_1_A = mkA "stationär" ; -- stationär..av.1
  statisk_1_A = mkA "statisk" ; -- statisk..av.1
  statist_1_N = mkN "statist" "statister" ; -- statist..nn.1
  statistik_1_N = mkN "statistik" "statistiker" ; -- statistik..nn.1
  statistiker_1_N = mkN "statistiker" "statistikern" "statistiker" "statistikerna" ; -- statistiker..nn.1
  statistikmässig_1_A = mkA "statistikmässig" ; -- statistikmässig..av.1
  statistisk_1_A = mkA "statistisk" ; -- statistisk..av.1
  stativ_1_A = mkA "stativ" ; -- stativ..av.1
  stativ_1_N = mkN "stativ" neutrum  ; -- stativ..nn.1
  stativ_2_N = mkN "stativ" "stativer" ; -- stativ..nn.2
  statlig_1_A = mkA "statlig" ; -- statlig..av.1
  statlighet_1_N = mkN "statlighet" ; -- statlighet..nn.1
  statministerkandidat_1_N = mkN "statministerkandidat" "statministerkandidater" ; -- statministerkandidat..nn.1
  stator_1_N = mkN "stator" "statorer" ; -- stator..nn.1
  statsangelägenhet_1_N = mkN "statsangelägenhet" "statsangelägenheter" ; -- statsangelägenhet..nn.1
  statsanslag_1_N = mkN "statsanslag" neutrum  ; -- statsanslag..nn.1
  statsanställd_1_A = mkA "statsanställd" "statsanställt" ; -- statsanställd..av.1
  statsapparat_1_N = mkN "statsapparat" "statsapparater" ; -- statsapparat..nn.1
  statsbankett_1_N = mkN "statsbankett" "statsbanketter" ; -- statsbankett..nn.1
  statsbegravning_1_N = mkN "statsbegravning" ; -- statsbegravning..nn.1
  statsbesök_1_N = mkN "statsbesök" neutrum  ; -- statsbesök..nn.1
  statsbidrag_1_N = mkN "statsbidrag" neutrum  ; -- statsbidrag..nn.1
  statsbildning_1_N = mkN "statsbildning" ; -- statsbildning..nn.1
  statsbudget_1_N = mkN "statsbudget" ; -- statsbudget..nn.1
  statsbygge_1_N = mkN "statsbygge" ; -- statsbygge..nn.1
  statsbärande_1_A = mkA "statsbärande" ; -- statsbärande..av.1
  statschef_1_N = mkN "statschef" "statschefer" ; -- statschef..nn.1
  statsdepartement_1_N = mkN "statsdepartement" neutrum  ; -- statsdepartement..nn.1
  statsepidemolog_1_N = mkN "statsepidemolog" "statsepidemologer" ; -- statsepidemolog..nn.1
  statsfinansiell_1_A = mkA "statsfinansiell" ; -- statsfinansiell..av.1
  statsfru_1_N = mkN "statsfru" ; -- statsfru..nn.1
  statsförfattning_1_N = mkN "statsförfattning" ; -- statsförfattning..nn.1
  statsförvaltning_1_N = mkN "statsförvaltning" ; -- statsförvaltning..nn.1
  statsgeolog_1_N = mkN "statsgeolog" "statsgeologer" ; -- statsgeolog..nn.1
  statshemlighet_1_N = mkN "statshemlighet" "statshemligheter" ; -- statshemlighet..nn.1
  statskalender_1_N = mkN "statskalender" ; -- statskalender..nn.1
  statskassa_1_N = mkN "statskassa" ; -- statskassa..nn.1
  statskonst_1_N = mkN "statskonst" ; -- statskonst..nn.1
  statskontor_1_N = mkN "statskontor" neutrum  ; -- statskontor..nn.1
  statskunskap_1_N = mkN "statskunskap" ; -- statskunskap..nn.1
  statskupp_1_N = mkN "statskupp" "statskupper" ; -- statskupp..nn.1
  statskvinna_1_N = mkN "statskvinna" ; -- statskvinna..nn.1
  statskvinnamässig_1_A = mkA "statskvinnamässig" ; -- statskvinnamässig..av.1
  statskvinnomässig_1_A = mkA "statskvinnomässig" ; -- statskvinnomässig..av.1
  statskyrka_1_N = mkN "statskyrka" ; -- statskyrka..nn.1
  statskyrklig_1_A = mkA "statskyrklig" ; -- statskyrklig..av.1
  statslös_1_A = mkA "statslös" ; -- statslös..av.1
  statslöshet_1_N = mkN "statslöshet" ; -- statslöshet..nn.1
  statsmakt_1_N = mkN "statsmakt" ; -- statsmakt..nn.1
  statsmakt_2_N = mkN "statsmakt" "statsmakter" ; -- statsmakt..nn.2
  statsman_1_N = mkN "statsman" "statsmannen" "statsmän" "statsmännen" ; -- statsman..nn.1
  statsmannablick_1_N = mkN "statsmannablick" ; -- statsmannablick..nn.1
  statsmannamässig_1_A = mkA "statsmannamässig" ; -- statsmannamässig..av.1
  statsminister_1_N = mkN "statsminister" ; -- statsminister..nn.1
  statsmyndighet_1_N = mkN "statsmyndighet" "statsmyndigheter" ; -- statsmyndighet..nn.1
  statsnytta_1_N = mkN "statsnytta" ; -- statsnytta..nn.1
  statsobligation_1_N = mkN "statsobligation" ; -- statsobligation..nn.1
  statspapper_1_N = mkN "statspapper" neutrum  ; -- statspapper..nn.1
  statsreligion_1_N = mkN "statsreligion" ; -- statsreligion..nn.1
  statsrevisor_1_N = mkN "statsrevisor" "statsrevisorer" ; -- statsrevisor..nn.1
  statsrätt_1_N = mkN "statsrätt" ; -- statsrätt..nn.1
  statsrättslig_1_A = mkA "statsrättslig" ; -- statsrättslig..av.1
  statsråd_1_N = mkN "statsråd" neutrum  ; -- statsråd..nn.1
  statsrådsberedning_1_N = mkN "statsrådsberedning" ; -- statsrådsberedning..nn.1
  statsrådsbil_1_N = mkN "statsrådsbil" ; -- statsrådsbil..nn.1
  statsrådslunch_1_N = mkN "statsrådslunch" "statsrådsluncher" ; -- statsrådslunch..nn.1
  statsrådsmiddag_1_N = mkN "statsrådsmiddag" ; -- statsrådsmiddag..nn.1
  statsrådstaburett_1_N = mkN "statsrådstaburett" "statsrådstaburetter" ; -- statsrådstaburett..nn.1
  statssekreterare_1_N = mkN "statssekreterare" utrum  ; -- statssekreterare..nn.1
  statsskick_1_N = mkN "statsskick" neutrum  ; -- statsskick..nn.1
  statsskuld_1_N = mkN "statsskuld" "statsskulder" ; -- statsskuld..nn.1
  statstjänsteman_1_N = mkN "statstjänsteman" "statstjänstemannen" "statstjänstemän" "statstjänstemännen" ; -- statstjänsteman..nn.1
  statsverk_1_N = mkN "statsverk" neutrum  ; -- statsverk..nn.1
  statsverksproposition_1_N = mkN "statsverksproposition" ; -- statsverksproposition..nn.1
  statsvetare_1_N = mkN "statsvetare" utrum  ; -- statsvetare..nn.1
  statsvetenskap_1_N = mkN "statsvetenskap" "statsvetenskaper" ; -- statsvetenskap..nn.1
  statsvetenskaplig_1_A = mkA "statsvetenskaplig" ; -- statsvetenskaplig..av.1
  statsvälvning_1_N = mkN "statsvälvning" ; -- statsvälvning..nn.1
  statsägd_1_A = mkA "statsägd" "statsägt" ; -- statsägd..av.1
  statsöverhuvud_1_N = mkN "statsöverhuvud" "statsöverhuvudet" "statsöverhuvud" "statsöverhuvudena" ; -- statsöverhuvud..nn.1
  statuarisk_1_A = mkA "statuarisk" ; -- statuarisk..av.1
  statuera_1_V = mkV "statuerar" ; -- statuera..vb.1
  statuera_2_V = mkV "statuerar" ; -- statuera..vb.2
  statuerande_1_N = mkN "statuerande" ; -- statuerande..nn.1
  statuerbar_1_A = mkA "statuerbar" ; -- statuerbar..av.1
  statuerbarhet_1_N = mkN "statuerbarhet" ; -- statuerbarhet..nn.1
  statuering_1_N = mkN "statuering" ; -- statuering..nn.1
  statur_1_N = mkN "statur" "staturer" ; -- statur..nn.1
  status_1_N = mkN "status" ; -- status..nn.1
  statusförändring_1_N = mkN "statusförändring" ; -- statusförändring..nn.1
  statushierarki_1_N = mkN "statushierarki" "statushierarkier" ; -- statushierarki..nn.1
  statusmässig_1_A = mkA "statusmässig" ; -- statusmässig..av.1
  statussymbol_1_N = mkN "statussymbol" "statussymboler" ; -- statussymbol..nn.1
  statusuppdatering_1_N = mkN "statusuppdatering" ; -- statusuppdatering..nn.1
  statut_1_N = mkN "statut" "statuter" ; -- statut..nn.1
  staty_1_N = mkN "staty" "statyer" ; -- staty..nn.1
  statyett_1_N = mkN "statyett" "statyetter" ; -- statyett..nn.1
  stav_1_N = mkN "stav" ; -- stav..nn.1
  stav_2_N = mkN "stav" "stäver" ; -- stav..nn.2
  stava_1_V = mkV "stavar" ; -- stava..vb.1
  stavande_1_N = mkN "stavande" ; -- stavande..nn.1
  stavbrott_1_N = mkN "stavbrott" neutrum  ; -- stavbrott..nn.1
  stavelse_1_N = mkN "stavelse" "stavelser" ; -- stavelse..nn.1
  stavelsebildande_1_A = mkA "stavelsebildande" ; -- stavelsebildande..av.1
  stavelseskrift_1_N = mkN "stavelseskrift" "stavelseskrifter" ; -- stavelseskrift..nn.1
  stavfel_1_N = mkN "stavfel" "stavfelet" "stavfel" "stavfelen" ; -- stavfel..nn.1
  stavformad_1_A = mkA "stavformad" ; -- stavformad..av.1
  stavformig_1_A = mkA "stavformig" ; -- stavformig..av.1
  stavgång_1_N = mkN "stavgång" ; -- stavgång..nn.1
  stavhopp_1_N = mkN "stavhopp" neutrum  ; -- stavhopp..nn.1
  stavkyrka_1_N = mkN "stavkyrka" ; -- stavkyrka..nn.1
  stavlampa_1_N = mkN "stavlampa" ; -- stavlampa..nn.1
  stavmixer_1_N = mkN "stavmixer" ; -- stavmixer..nn.1
  stavning_1_N = mkN "stavning" ; -- stavning..nn.1
  stavningsreform_1_N = mkN "stavningsreform" "stavningsreformer" ; -- stavningsreform..nn.1
  stavrim_1_N = mkN "stavrim" "stavrimmet" "stavrim" "stavrimmen" ; -- stavrim..nn.1
  stavsätt_1_N = mkN "stavsätt" neutrum  ; -- stavsätt..nn.1
  stearin_1_N = mkN "stearin" ; -- stearin..nn.1
  stearindoft_1_N = mkN "stearindoft" "stearindofter" ; -- stearindoft..nn.1
  stearinljus_1_N = mkN "stearinljus" neutrum  ; -- stearinljus..nn.1
  stearinsyra_1_N = mkN "stearinsyra" ; -- stearinsyra..nn.1
  steeplechase_1_N = mkN "steeplechase" "steeplechaser" ; -- steeplechase..nn.1
  steg_1_N = mkN "steg" neutrum  ; -- steg..nn.1
  stega_1_V = mkV "stegar" ; -- stega..vb.1
  stegande_1_N = mkN "stegande" ; -- stegande..nn.1
  stegbil_1_N = mkN "stegbil" ; -- stegbil..nn.1
  stegbåt_1_N = mkN "stegbåt" ; -- stegbåt..nn.1
  stege_1_N = mkN "stege" utrum  ; -- stege..nn.1
  stegel_1_N = mkN "stegel" neutrum  ; -- stegel..nn.1
  steghylla_1_N = mkN "steghylla" ; -- steghylla..nn.1
  stegla_1_V = mkV "steglar" ; -- stegla..vb.1
  steglande_1_N = mkN "steglande" ; -- steglande..nn.1
  stegling_1_N = mkN "stegling" ; -- stegling..nn.1
  steglits_1_N = mkN "steglits" "steglitser" ; -- steglits..nn.1
  steglitsa_1_N = mkN "steglitsa" ; -- steglitsa..nn.1
  steglängd_1_N = mkN "steglängd" "steglängder" ; -- steglängd..nn.1
  steglös_1_A = mkA "steglös" ; -- steglös..av.1
  steglöshet_1_N = mkN "steglöshet" ; -- steglöshet..nn.1
  stegpall_1_N = mkN "stegpall" ; -- stegpall..nn.1
  stegpinne_1_N = mkN "stegpinne" utrum  ; -- stegpinne..nn.1
  stegra_1_V = mkV "stegrar" ; -- stegra..vb.1
  stegrande_1_N = mkN "stegrande" ; -- stegrande..nn.1
  stegring_1_N = mkN "stegring" ; -- stegring..nn.1
  stegräknare_1_N = mkN "stegräknare" utrum  ; -- stegräknare..nn.1
  stegräknartävling_1_N = mkN "stegräknartävling" ; -- stegräknartävling..nn.1
  stegvis_1_Adv = mkAdv "stegvis" ; -- stegvis..ab.1
  stegvis_1_A = mkA "stegvis" ; -- stegvis..av.1
  stek_1_N = mkN "stek" ; -- stek..nn.1
  stek_2_N = mkN "stek" neutrum  ; -- stek..nn.2
  steka_1_V = mkV "steker" ; -- steka..vb.1
  stekande_1_N = mkN "stekande" ; -- stekande..nn.1
  stekare_1_N = mkN "stekare" utrum  ; -- stekare..nn.1
  stekburgare_1_N = mkN "stekburgare" utrum  ; -- stekburgare..nn.1
  stekel_1_N = mkN "stekel" ; -- stekel..nn.1
  stekfläsk_1_N = mkN "stekfläsk" neutrum  ; -- stekfläsk..nn.1
  stekhet_1_A = mkA "stekhet" ; -- stekhet..av.1
  stekhus_1_N = mkN "stekhus" neutrum  ; -- stekhus..nn.1
  stekning_1_N = mkN "stekning" ; -- stekning..nn.1
  stekpanna_1_N = mkN "stekpanna" ; -- stekpanna..nn.1
  stekskrap_1_N = mkN "stekskrap" neutrum  ; -- stekskrap..nn.1
  stekspade_1_N = mkN "stekspade" utrum  ; -- stekspade..nn.1
  stekspett_1_N = mkN "stekspett" neutrum  ; -- stekspett..nn.1
  stekyta_1_N = mkN "stekyta" ; -- stekyta..nn.1
  stel_1_A = mkA "stel" ; -- stel..av.1
  stelbent_1_A = mkA "stelbent" "stelbent" ; -- stelbent..av.1
  stelbenthet_1_N = mkN "stelbenthet" "stelbentheter" ; -- stelbenthet..nn.1
  stele_1_N = mkN "stele" utrum  ; -- stele..nn.1
  stelfrusen_1_A = mkA "stelfrusen" ; -- stelfrusen..av.1
  stelhet_1_N = mkN "stelhet" "stelheter" ; -- stelhet..nn.1
  stelkramp_1_N = mkN "stelkramp" ; -- stelkramp..nn.1
  stellar_1_A = mkA "stellar" ; -- stellar..av.1
  stellarastronomi_1_N = mkN "stellarastronomi" ; -- stellarastronomi..nn.1
  stellarisk_1_A = mkA "stellarisk" ; -- stellarisk..av.1
  stelna_1_V = mkV "stelnar" ; -- stelna..vb.1
  stelnande_1_N = mkN "stelnande" ; -- stelnande..nn.1
  stelning_1_N = mkN "stelning" ; -- stelning..nn.1
  sten_1_N = mkN "sten" "stenen" "stenar" "stenarna" ; -- sten..nn.1
  stena_1_V = mkV "stenar" ; -- stena..vb.1
  stenad_1_A = mkA "stenad" ; -- stenad..av.1
  stenande_1_N = mkN "stenande" ; -- stenande..nn.1
  stenansamling_1_N = mkN "stenansamling" ; -- stenansamling..nn.1
  stenansikte_1_N = mkN "stenansikte" ; -- stenansikte..nn.1
  stenattack_1_N = mkN "stenattack" "stenattacker" ; -- stenattack..nn.1
  stenbit_1_N = mkN "stenbit" ; -- stenbit..nn.1
  stenblick_1_N = mkN "stenblick" ; -- stenblick..nn.1
  stenblock_1_N = mkN "stenblock" neutrum  ; -- stenblock..nn.1
  stenbock_1_N = mkN "stenbock" ; -- stenbock..nn.1
  stenbotten_1_N = mkN "stenbotten" ; -- stenbotten..nn.1
  stenbrott_1_N = mkN "stenbrott" neutrum  ; -- stenbrott..nn.1
  stenbräcka_1_N = mkN "stenbräcka" ; -- stenbräcka..nn.1
  stenbumling_1_N = mkN "stenbumling" ; -- stenbumling..nn.1
  stenbunden_1_A = mkA "stenbunden" ; -- stenbunden..av.1
  stenbädd_1_N = mkN "stenbädd" ; -- stenbädd..nn.1
  stenbär_1_N = mkN "stenbär" neutrum  ; -- stenbär..nn.1
  stencil_1_N = mkN "stencil" "stenciler" ; -- stencil..nn.1
  stencilera_1_V = mkV "stencilerar" ; -- stencilera..vb.1
  stencilerande_1_N = mkN "stencilerande" ; -- stencilerande..nn.1
  stencilerbar_1_A = mkA "stencilerbar" ; -- stencilerbar..av.1
  stencilerbarhet_1_N = mkN "stencilerbarhet" ; -- stencilerbarhet..nn.1
  stencilering_1_N = mkN "stencilering" ; -- stencilering..nn.1
  stendammlunga_1_N = mkN "stendammlunga" ; -- stendammlunga..nn.1
  stendöd_1_A = mkA "stendöd" "stendött" ; -- stendöd..av.1
  stendödhet_1_N = mkN "stendödhet" ; -- stendödhet..nn.1
  stendös_1_N = mkN "stendös" ; -- stendös..nn.1
  stendöv_1_A = mkA "stendöv" ; -- stendöv..av.1
  stendövhet_1_N = mkN "stendövhet" ; -- stendövhet..nn.1
  stenfalk_1_N = mkN "stenfalk" ; -- stenfalk..nn.1
  stenflisa_1_N = mkN "stenflisa" ; -- stenflisa..nn.1
  stenfot_1_N = mkN "stenfot" ; -- stenfot..nn.1
  stenfri_1_A = mkA "stenfri" "stenfritt" ; -- stenfri..av.1
  stenfrukt_1_N = mkN "stenfrukt" "stenfrukter" ; -- stenfrukt..nn.1
  stenfästning_1_N = mkN "stenfästning" ; -- stenfästning..nn.1
  stenget_1_N = mkN "stenget" "stengetter" ; -- stenget..nn.1
  stengods_1_N = mkN "stengods" neutrum  ; -- stengods..nn.1
  stengolv_1_N = mkN "stengolv" neutrum  ; -- stengolv..nn.1
  stengrund_1_N = mkN "stengrund" "stengrunder" ; -- stengrund..nn.1
  stengrund_2_N = mkN "stengrund" neutrum  ; -- stengrund..nn.2
  stenhallon_1_N = mkN "stenhallon" neutrum  ; -- stenhallon..nn.1
  stenhuggare_1_N = mkN "stenhuggare" utrum  ; -- stenhuggare..nn.1
  stenhuggeri_1_N = mkN "stenhuggeri" "stenhuggeriet" "stenhuggerier" "stenhuggerierna" ; -- stenhuggeri..nn.1
  stenhus_1_N = mkN "stenhus" neutrum  ; -- stenhus..nn.1
  stenhäll_1_N = mkN "stenhäll" ; -- stenhäll..nn.1
  stenhård_1_A = mkA "stenhård" "stenhårt" ; -- stenhård..av.1
  stenhårdhet_1_N = mkN "stenhårdhet" ; -- stenhårdhet..nn.1
  stenig_1_A = mkA "stenig" ; -- stenig..av.1
  stening_1_N = mkN "stening" ; -- stening..nn.1
  steningsdömd_1_A = mkA "steningsdömd" "steningsdömt" ; -- steningsdömd..av.1
  stenkaka_1_N = mkN "stenkaka" ; -- stenkaka..nn.1
  stenkast_1_N = mkN "stenkast" neutrum  ; -- stenkast..nn.1
  stenkastande_1_A = mkA "stenkastande" ; -- stenkastande..av.1
  stenkastande_1_N = mkN "stenkastande" ; -- stenkastande..nn.1
  stenkastare_1_N = mkN "stenkastare" utrum  ; -- stenkastare..nn.1
  stenkastning_1_N = mkN "stenkastning" ; -- stenkastning..nn.1
  stenkista_1_N = mkN "stenkista" ; -- stenkista..nn.1
  stenknäck_1_N = mkN "stenknäck" ; -- stenknäck..nn.1
  stenkol_1_N = mkN "stenkol" neutrum  ; -- stenkol..nn.1
  stenkoll_1_N = mkN "stenkoll" ; -- stenkoll..nn.1
  stenkolsbit_1_N = mkN "stenkolsbit" ; -- stenkolsbit..nn.1
  stenkolsperiod_1_N = mkN "stenkolsperiod" ; -- stenkolsperiod..nn.1
  stenkolstjära_1_N = mkN "stenkolstjära" ; -- stenkolstjära..nn.1
  stenkross_1_N = mkN "stenkross" ; -- stenkross..nn.1
  stenkummel_1_N = mkN "stenkummel" neutrum  ; -- stenkummel..nn.1
  stenlagd_1_A = mkA "stenlagd" "stenlagt" ; -- stenlagd..av.1
  stenlunga_1_N = mkN "stenlunga" ; -- stenlunga..nn.1
  stenlägga_1_V = mkV "stenlägga" "stenla" "stenlagt" ; -- stenlägga..vb.1
  stenläggande_1_N = mkN "stenläggande" ; -- stenläggande..nn.1
  stenläggning_1_N = mkN "stenläggning" ; -- stenläggning..nn.1
  stenmur_1_N = mkN "stenmur" ; -- stenmur..nn.1
  stenograf_1_N = mkN "stenograf" "stenografer" ; -- stenograf..nn.1
  stenografera_1_V = mkV "stenograferar" ; -- stenografera..vb.1
  stenograferande_1_N = mkN "stenograferande" ; -- stenograferande..nn.1
  stenograferbar_1_A = mkA "stenograferbar" ; -- stenograferbar..av.1
  stenograferbarhet_1_N = mkN "stenograferbarhet" ; -- stenograferbarhet..nn.1
  stenografering_1_N = mkN "stenografering" ; -- stenografering..nn.1
  stenografi_1_N = mkN "stenografi" ; -- stenografi..nn.1
  stenografisk_1_A = mkA "stenografisk" ; -- stenografisk..av.1
  stenogram_1_N = mkN "stenogram" "stenogrammet" "stenogram" "stenogrammen" ; -- stenogram..nn.1
  stenos_1_N = mkN "stenos" "stenoser" ; -- stenos..nn.1
  stenotop_1_N = mkN "stenotop" "stenotoper" ; -- stenotop..nn.1
  stenparti_1_N = mkN "stenparti" "stenpartiet" "stenpartier" "stenpartierna" ; -- stenparti..nn.1
  stenplatta_1_N = mkN "stenplatta" ; -- stenplatta..nn.1
  stenrik_1_A = mkA "stenrik" ; -- stenrik..av.1
  stenrös_1_N = mkN "stenrös" neutrum  ; -- stenrös..nn.1
  stenröse_1_N = mkN "stenröse" ; -- stenröse..nn.1
  stensalt_1_N = mkN "stensalt" neutrum  ; -- stensalt..nn.1
  stensatt_1_A = mkA "stensatt" ; -- stensatt..av.1
  stenskott_1_N = mkN "stenskott" neutrum  ; -- stenskott..nn.1
  stenskottsskydd_1_N = mkN "stenskottsskydd" neutrum  ; -- stenskottsskydd..nn.1
  stenskvätta_1_N = mkN "stenskvätta" ; -- stenskvätta..nn.1
  stensopp_1_N = mkN "stensopp" ; -- stensopp..nn.1
  stenstil_1_N = mkN "stenstil" ; -- stenstil..nn.1
  stensätta_1_V = mkV "stensätta" "stensätter" "stensätt" "stensatte" "stensatt" "stensatt" ; -- stensätta..vb.1
  stensättande_1_N = mkN "stensättande" ; -- stensättande..nn.1
  stensättare_1_N = mkN "stensättare" utrum  ; -- stensättare..nn.1
  stensättning_1_N = mkN "stensättning" ; -- stensättning..nn.1
  stensöta_1_N = mkN "stensöta" ; -- stensöta..nn.1
  stentavla_1_N = mkN "stentavla" ; -- stentavla..nn.1
  stentorsröst_1_N = mkN "stentorsröst" "stentorsröster" ; -- stentorsröst..nn.1
  stentorsstämma_1_N = mkN "stentorsstämma" ; -- stentorsstämma..nn.1
  stentrappa_1_N = mkN "stentrappa" ; -- stentrappa..nn.1
  stentrist_1_A = mkA "stentrist" "stentrist" ; -- stentrist..av.1
  stentryck_1_N = mkN "stentryck" neutrum  ; -- stentryck..nn.1
  stentryckare_1_N = mkN "stentryckare" utrum  ; -- stentryckare..nn.1
  stentuff_1_A = mkA "stentuff" ; -- stentuff..av.1
  stenverktyg_1_N = mkN "stenverktyg" neutrum  ; -- stenverktyg..nn.1
  stenvägg_1_N = mkN "stenvägg" ; -- stenvägg..nn.1
  stenyxa_1_N = mkN "stenyxa" ; -- stenyxa..nn.1
  stenålder_1_N = mkN "stenålder" ; -- stenålder..nn.1
  stenåldersfynd_1_N = mkN "stenåldersfynd" neutrum  ; -- stenåldersfynd..nn.1
  stenåldersgrav_1_N = mkN "stenåldersgrav" ; -- stenåldersgrav..nn.1
  stenåldershjärna_1_N = mkN "stenåldershjärna" ; -- stenåldershjärna..nn.1
  stenåldersmässig_1_A = mkA "stenåldersmässig" ; -- stenåldersmässig..av.1
  stenåldersnivå_1_N = mkN "stenåldersnivå" "stenåldersnivåer" ; -- stenåldersnivå..nn.1
  stenåldersyxa_1_N = mkN "stenåldersyxa" ; -- stenåldersyxa..nn.1
  stenöken_1_N = mkN "stenöken" "stenökenn" "stenöknar" "stenöknarna" ; -- stenöken..nn.1
  step_1_N = mkN "step" ; -- step..nn.1
  stepp_1_N = mkN "stepp" ; -- stepp..nn.1
  steppa_1_V = mkV "steppar" ; -- steppa..vb.1
  steppande_1_N = mkN "steppande" ; -- steppande..nn.1
  steradian_1_N = mkN "steradian" "steradianer" ; -- steradian..nn.1
  sterbhus_1_N = mkN "sterbhus" neutrum  ; -- sterbhus..nn.1
  stereo_1_N = mkN "stereo" ; -- stereo..nn.1
  stereoanläggning_1_N = mkN "stereoanläggning" ; -- stereoanläggning..nn.1
  stereobild_1_N = mkN "stereobild" "stereobilder" ; -- stereobild..nn.1
  stereofoni_1_N = mkN "stereofoni" ; -- stereofoni..nn.1
  stereofonisk_1_A = mkA "stereofonisk" ; -- stereofonisk..av.1
  stereofotografera_1_V = mkV "stereofotograferar" ; -- stereofotografera..vb.1
  stereofotograferande_1_N = mkN "stereofotograferande" ; -- stereofotograferande..nn.1
  stereofotograferbar_1_A = mkA "stereofotograferbar" ; -- stereofotograferbar..av.1
  stereofotograferbarhet_1_N = mkN "stereofotograferbarhet" ; -- stereofotograferbarhet..nn.1
  stereofotografering_1_N = mkN "stereofotografering" ; -- stereofotografering..nn.1
  stereoisomeri_1_N = mkN "stereoisomeri" ; -- stereoisomeri..nn.1
  stereokemi_1_N = mkN "stereokemi" ; -- stereokemi..nn.1
  stereometri_1_N = mkN "stereometri" ; -- stereometri..nn.1
  stereometrisk_1_A = mkA "stereometrisk" ; -- stereometrisk..av.1
  stereoseende_1_N = mkN "stereoseende" ; -- stereoseende..nn.1
  stereoskop_1_N = mkN "stereoskop" neutrum  ; -- stereoskop..nn.1
  stereoskopbild_1_N = mkN "stereoskopbild" "stereoskopbilder" ; -- stereoskopbild..nn.1
  stereoskopi_1_N = mkN "stereoskopi" ; -- stereoskopi..nn.1
  stereoskopisk_1_A = mkA "stereoskopisk" ; -- stereoskopisk..av.1
  stereotyp_1_A = mkA "stereotyp" ; -- stereotyp..av.1
  stereotyp_1_N = mkN "stereotyp" "stereotyper" ; -- stereotyp..nn.1
  stereotypera_1_V = mkV "stereotyperar" ; -- stereotypera..vb.1
  stereotyperande_1_N = mkN "stereotyperande" ; -- stereotyperande..nn.1
  stereotyperbar_1_A = mkA "stereotyperbar" ; -- stereotyperbar..av.1
  stereotyperbarhet_1_N = mkN "stereotyperbarhet" ; -- stereotyperbarhet..nn.1
  stereotypering_1_N = mkN "stereotypering" ; -- stereotypering..nn.1
  stereotypi_1_N = mkN "stereotypi" "stereotypier" ; -- stereotypi..nn.1
  stereotypisk_1_A = mkA "stereotypisk" ; -- stereotypisk..av.1
  steril_1_A = mkA "steril" ; -- steril..av.1
  sterilisera_1_V = mkV "steriliserar" ; -- sterilisera..vb.1
  steriliserande_1_N = mkN "steriliserande" ; -- steriliserande..nn.1
  steriliserbar_1_A = mkA "steriliserbar" ; -- steriliserbar..av.1
  steriliserbarhet_1_N = mkN "steriliserbarhet" ; -- steriliserbarhet..nn.1
  sterilisering_1_N = mkN "sterilisering" ; -- sterilisering..nn.1
  sterilitet_1_N = mkN "sterilitet" "steriliteter" ; -- sterilitet..nn.1
  sterin_1_N = mkN "sterin" "steriner" ; -- sterin..nn.1
  sterisk_1_A = mkA "sterisk" ; -- sterisk..av.1
  sterling_1_N = mkN "sterling" ; -- sterling..nn.1
  sternalpunktion_1_N = mkN "sternalpunktion" ; -- sternalpunktion..nn.1
  sternum_1_N = mkN "sternum" ; -- sternum..nn.1
  steroid_1_N = mkN "steroid" "steroider" ; -- steroid..nn.1
  sterol_1_N = mkN "sterol" "steroler" ; -- sterol..nn.1
  stetoskop_1_N = mkN "stetoskop" neutrum  ; -- stetoskop..nn.1
  steward_1_N = mkN "steward" ; -- steward..nn.1
  stewart_1_N = mkN "stewart" ; -- stewart..nn.1
  stia_1_N = mkN "stia" ; -- stia..nn.1
  stick_1_N = mkN "stick" neutrum  ; -- stick..nn.1
  sticka_1_N = mkN "sticka" ; -- sticka..nn.1
  sticka_1_V = mkV "sticka" "stack" "stuckit" ; -- sticka..vb.1
  sticka_2_V = mkV "stickar" ; -- sticka..vb.2
  sticka_3_V = mkV "sticka" "stack" "stuckit" ; -- sticka..vb.3
  stickande_1_A = mkA "stickande" ; -- stickande..av.1
  stickande_1_N = mkN "stickande" ; -- stickande..nn.1
  stickel_1_N = mkN "stickel" ; -- stickel..nn.1
  stickelbär_1_N = mkN "stickelbär" neutrum  ; -- stickelbär..nn.1
  stickelhårig_1_A = mkA "stickelhårig" ; -- stickelhårig..av.1
  stickert_1_N = mkN "stickert" ; -- stickert..nn.1
  stickig_1_A = mkA "stickig" ; -- stickig..av.1
  stickighet_1_N = mkN "stickighet" ; -- stickighet..nn.1
  stickkontakt_1_N = mkN "stickkontakt" "stickkontakter" ; -- stickkontakt..nn.1
  stickling_1_N = mkN "stickling" ; -- stickling..nn.1
  stickmaskin_1_N = mkN "stickmaskin" "stickmaskiner" ; -- stickmaskin..nn.1
  stickning_1_N = mkN "stickning" ; -- stickning..nn.1
  stickord_1_N = mkN "stickord" neutrum  ; -- stickord..nn.1
  stickpropp_1_N = mkN "stickpropp" ; -- stickpropp..nn.1
  stickprov_1_N = mkN "stickprov" neutrum  ; -- stickprov..nn.1
  stickprovsdragning_1_N = mkN "stickprovsdragning" ; -- stickprovsdragning..nn.1
  stickprovsmässig_1_A = mkA "stickprovsmässig" ; -- stickprovsmässig..av.1
  stickprovsundersökning_1_N = mkN "stickprovsundersökning" ; -- stickprovsundersökning..nn.1
  stickreplik_1_N = mkN "stickreplik" "stickrepliker" ; -- stickreplik..nn.1
  stickspår_1_N = mkN "stickspår" neutrum  ; -- stickspår..nn.1
  sticksvärd_1_N = mkN "sticksvärd" neutrum  ; -- sticksvärd..nn.1
  sticksåg_1_N = mkN "sticksåg" ; -- sticksåg..nn.1
  stickvapen_1_N = mkN "stickvapen" "stickvapnet" "stickvapen" "stickvapnen" ; -- stickvapen..nn.1
  stift_1_N = mkN "stift" neutrum  ; -- stift..nn.1
  stift_2_N = mkN "stift" neutrum  ; -- stift..nn.2
  stifta_1_V = mkV "stiftar" ; -- stifta..vb.1
  stiftande_1_N = mkN "stiftande" ; -- stiftande..nn.1
  stiftare_1_N = mkN "stiftare" utrum  ; -- stiftare..nn.1
  stiftelse_1_N = mkN "stiftelse" "stiftelser" ; -- stiftelse..nn.1
  stiftelseurkund_1_N = mkN "stiftelseurkund" "stiftelseurkunder" ; -- stiftelseurkund..nn.1
  stiftsadjunkt_1_N = mkN "stiftsadjunkt" "stiftsadjunkter" ; -- stiftsadjunkt..nn.1
  stiftsband_1_N = mkN "stiftsband" neutrum  ; -- stiftsband..nn.1
  stiftsfröken_1_N = mkN "stiftsfröken" ; -- stiftsfröken..nn.1
  stiftsjungfru_1_N = mkN "stiftsjungfru" "stiftsjungfrun" "stiftsjungfrur" "stiftsjungfrurna" ; -- stiftsjungfru..nn.1
  stiftsnivå_1_N = mkN "stiftsnivå" ; -- stiftsnivå..nn.1
  stiftsstad_1_N = mkN "stiftsstad" "stiftsstäder" ; -- stiftsstad..nn.1
  stiftsstyrelse_1_N = mkN "stiftsstyrelse" "stiftsstyrelser" ; -- stiftsstyrelse..nn.1
  stifttand_1_N = mkN "stifttand" "stifttänder" ; -- stifttand..nn.1
  stig_1_N = mkN "stig" ; -- stig..nn.1
  stiga_1_V = mkV "stiga" "steg" "stigit" ; -- stiga..vb.1
  stigande_1_N = mkN "stigande" ; -- stigande..nn.1
  stigarcentral_1_N = mkN "stigarcentral" "stigarcentraler" ; -- stigarcentral..nn.1
  stigarledning_1_N = mkN "stigarledning" ; -- stigarledning..nn.1
  stigbygel_1_N = mkN "stigbygel" ; -- stigbygel..nn.1
  stigfinnare_1_N = mkN "stigfinnare" utrum  ; -- stigfinnare..nn.1
  stigläder_1_N = mkN "stigläder" neutrum  ; -- stigläder..nn.1
  stiglös_1_A = mkA "stiglös" ; -- stiglös..av.1
  stiglöshet_1_N = mkN "stiglöshet" ; -- stiglöshet..nn.1
  stigma_1_N = mkN "stigma" "stigmat" "stigmata" "stigmatana" ; -- stigma..nn.1
  stigman_1_N = mkN "stigman" "stigmannen" "stigmän" "stigmännen" ; -- stigman..nn.1
  stigmatisera_1_V = mkV "stigmatiserar" ; -- stigmatisera..vb.1
  stigmatiserande_1_N = mkN "stigmatiserande" ; -- stigmatiserande..nn.1
  stigmatiserbar_1_A = mkA "stigmatiserbar" ; -- stigmatiserbar..av.1
  stigmatiserbarhet_1_N = mkN "stigmatiserbarhet" ; -- stigmatiserbarhet..nn.1
  stigmatisering_1_N = mkN "stigmatisering" ; -- stigmatisering..nn.1
  stigning_1_N = mkN "stigning" ; -- stigning..nn.1
  stigort_1_N = mkN "stigort" "stigorter" ; -- stigort..nn.1
  stikisk_1_A = mkA "stikisk" ; -- stikisk..av.1
  stil_1_N = mkN "stil" ; -- stil..nn.1
  stila_1_V = mkV "stilar" ; -- stila..vb.1
  stilande_1_N = mkN "stilande" ; -- stilande..nn.1
  stilart_1_N = mkN "stilart" "stilarter" ; -- stilart..nn.1
  stilbildande_1_A = mkA "stilbildande" ; -- stilbildande..av.1
  stilbildare_1_N = mkN "stilbildare" utrum  ; -- stilbildare..nn.1
  stilblomma_1_N = mkN "stilblomma" ; -- stilblomma..nn.1
  stilbrott_1_N = mkN "stilbrott" neutrum  ; -- stilbrott..nn.1
  stilbrytning_1_N = mkN "stilbrytning" ; -- stilbrytning..nn.1
  stildrag_1_N = mkN "stildrag" neutrum  ; -- stildrag..nn.1
  stilenlig_1_A = mkA "stilenlig" ; -- stilenlig..av.1
  stilenlighet_1_N = mkN "stilenlighet" ; -- stilenlighet..nn.1
  stilett_1_N = mkN "stilett" "stiletter" ; -- stilett..nn.1
  stilettklack_1_N = mkN "stilettklack" ; -- stilettklack..nn.1
  stilettkäpp_1_N = mkN "stilettkäpp" ; -- stilettkäpp..nn.1
  stilfigur_1_N = mkN "stilfigur" "stilfigurer" ; -- stilfigur..nn.1
  stilfull_1_A = mkA "stilfull" ; -- stilfull..av.1
  stilfullhet_1_N = mkN "stilfullhet" "stilfullheter" ; -- stilfullhet..nn.1
  stilig_1_A = mkA "stilig" ; -- stilig..av.1
  stilighet_1_N = mkN "stilighet" ; -- stilighet..nn.1
  stilikon_1_N = mkN "stilikon" "stilikoner" ; -- stilikon..nn.1
  stilisera_1_V = mkV "stiliserar" ; -- stilisera..vb.1
  stiliserande_1_N = mkN "stiliserande" ; -- stiliserande..nn.1
  stiliserbar_1_A = mkA "stiliserbar" ; -- stiliserbar..av.1
  stiliserbarhet_1_N = mkN "stiliserbarhet" ; -- stiliserbarhet..nn.1
  stilisering_1_N = mkN "stilisering" ; -- stilisering..nn.1
  stilist_1_N = mkN "stilist" "stilister" ; -- stilist..nn.1
  stilistik_1_N = mkN "stilistik" ; -- stilistik..nn.1
  stilistiker_1_N = mkN "stilistiker" "stilistikern" "stilistiker" "stilistikerna" ; -- stilistiker..nn.1
  stilistisk_1_A = mkA "stilistisk" ; -- stilistisk..av.1
  stilkonsekvens_1_N = mkN "stilkonsekvens" "stilkonsekvenser" ; -- stilkonsekvens..nn.1
  stilkänsla_1_N = mkN "stilkänsla" ; -- stilkänsla..nn.1
  stilla_1_A = mkA "stilla" ; -- stilla..av.1
  stilla_1_V = mkV "stillar" ; -- stilla..vb.1
  stillande_1_N = mkN "stillande" ; -- stillande..nn.1
  stillasittande_1_A = mkA "stillasittande" ; -- stillasittande..av.1
  stillasittande_1_N = mkN "stillasittande" ; -- stillasittande..nn.1
  stillastående_1_A = mkA "stillastående" ; -- stillastående..av.1
  stillastående_1_N = mkN "stillastående" ; -- stillastående..nn.1
  stillatigande_1_A = mkA "stillatigande" ; -- stillatigande..av.1
  stillbild_1_N = mkN "stillbild" "stillbilder" ; -- stillbild..nn.1
  stilldrink_1_N = mkN "stilldrink" ; -- stilldrink..nn.1
  stilleben_1_N = mkN "stilleben" neutrum  ; -- stilleben..nn.1
  stillestånd_1_N = mkN "stillestånd" neutrum  ; -- stillestånd..nn.1
  stillfilm_1_N = mkN "stillfilm" "stillfilmer" ; -- stillfilm..nn.1
  stillhet_1_N = mkN "stillhet" "stillheter" ; -- stillhet..nn.1
  stillna_1_V = mkV "stillnar" ; -- stillna..vb.1
  stillnande_1_N = mkN "stillnande" ; -- stillnande..nn.1
  stillsam_1_A = mkA "stillsam" "stillsamt" "stillsamma" "stillsamma" "stillsammare" "stillsammast" "stillsammaste" ; -- stillsam..av.1
  stillsamhet_1_N = mkN "stillsamhet" ; -- stillsamhet..nn.1
  stillös_1_A = mkA "stillös" ; -- stillös..av.1
  stillöshet_1_N = mkN "stillöshet" "stillösheter" ; -- stillöshet..nn.1
  stilmässig_1_A = mkA "stilmässig" ; -- stilmässig..av.1
  stilmöbel_1_N = mkN "stilmöbel" "stilmöbeln" "stilmöbler" "stilmöblerna" ; -- stilmöbel..nn.1
  stilren_1_A = mkA "stilren" "stilrent" ; -- stilren..av.1
  stilrenhet_1_N = mkN "stilrenhet" ; -- stilrenhet..nn.1
  stilriktig_1_A = mkA "stilriktig" ; -- stilriktig..av.1
  stilriktning_1_N = mkN "stilriktning" ; -- stilriktning..nn.1
  stilsort_1_N = mkN "stilsort" "stilsorter" ; -- stilsort..nn.1
  stilsäker_1_A = mkA "stilsäker" ; -- stilsäker..av.1
  stiltje_1_N = mkN "stiltje" utrum  ; -- stiltje..nn.1
  stilton_1_N = mkN "stilton" ; -- stilton..nn.1
  stilval_1_N = mkN "stilval" neutrum  ; -- stilval..nn.1
  stilvidrig_1_A = mkA "stilvidrig" ; -- stilvidrig..av.1
  stilövning_1_N = mkN "stilövning" ; -- stilövning..nn.1
  stim_1_N = mkN "stim" "stimmet" "stim" "stimmen" ; -- stim..nn.1
  stimma_1_V = mkV "stimmar" ; -- stimma..vb.1
  stimmande_1_N = mkN "stimmande" ; -- stimmande..nn.1
  stimmig_1_A = mkA "stimmig" ; -- stimmig..av.1
  stimmighet_1_N = mkN "stimmighet" ; -- stimmighet..nn.1
  stimulans_1_N = mkN "stimulans" "stimulanser" ; -- stimulans..nn.1
  stimulanspaket_1_N = mkN "stimulanspaket" neutrum  ; -- stimulanspaket..nn.1
  stimulansåtgärd_1_N = mkN "stimulansåtgärd" "stimulansåtgärder" ; -- stimulansåtgärd..nn.1
  stimulantia_1_N = mkN "stimulantia" "stimulantian" "stimulantia" "stimulantiana" ; -- stimulantia..nn.1
  stimulator_1_N = mkN "stimulator" "stimulatorer" ; -- stimulator..nn.1
  stimulera_1_V = mkV "stimulerar" ; -- stimulera..vb.1
  stimulerande_1_N = mkN "stimulerande" ; -- stimulerande..nn.1
  stimulerbar_1_A = mkA "stimulerbar" ; -- stimulerbar..av.1
  stimulerbarhet_1_N = mkN "stimulerbarhet" ; -- stimulerbarhet..nn.1
  stimulering_1_N = mkN "stimulering" ; -- stimulering..nn.1
  stimuleringsåtgärd_1_N = mkN "stimuleringsåtgärd" "stimuleringsåtgärder" ; -- stimuleringsåtgärd..nn.1
  stimulus_1_N = mkN "stimulus" neutrum  ; -- stimulus..nn.1
  sting_1_N = mkN "sting" neutrum  ; -- sting..nn.1
  stingande_1_N = mkN "stingande" ; -- stingande..nn.1
  stingpinne_1_N = mkN "stingpinne" utrum  ; -- stingpinne..nn.1
  stingslig_1_A = mkA "stingslig" ; -- stingslig..av.1
  stingslighet_1_N = mkN "stingslighet" "stingsligheter" ; -- stingslighet..nn.1
  stinka_1_V = mkV "stinka" "stank" "stunkit" ; -- stinka..vb.1
  stinkande_1_A = mkA "stinkande" ; -- stinkande..av.1
  stinkande_1_N = mkN "stinkande" ; -- stinkande..nn.1
  stinkbomb_1_N = mkN "stinkbomb" "stinkbomber" ; -- stinkbomb..nn.1
  stinkdjur_1_N = mkN "stinkdjur" neutrum  ; -- stinkdjur..nn.1
  stinkfly_1_N = mkN "stinkfly" "stinkflyet" "stinkflyn" "stinkflyna" ; -- stinkfly..nn.1
  stinksvamp_1_N = mkN "stinksvamp" ; -- stinksvamp..nn.1
  stinn_1_A = mkA "stinn" "stint" ; -- stinn..av.1
  stinnhet_1_N = mkN "stinnhet" ; -- stinnhet..nn.1
  stins_1_N = mkN "stins" ; -- stins..nn.1
  stinta_1_N = mkN "stinta" ; -- stinta..nn.1
  stipel_1_N = mkN "stipel" "stipeln" "stipler" "stiplerna" ; -- stipel..nn.1
  stipendiat_1_N = mkN "stipendiat" "stipendiater" ; -- stipendiat..nn.1
  stipendiera_1_V = mkV "stipendierar" ; -- stipendiera..vb.1
  stipendierande_1_N = mkN "stipendierande" ; -- stipendierande..nn.1
  stipendierbar_1_A = mkA "stipendierbar" ; -- stipendierbar..av.1
  stipendierbarhet_1_N = mkN "stipendierbarhet" ; -- stipendierbarhet..nn.1
  stipendiering_1_N = mkN "stipendiering" ; -- stipendiering..nn.1
  stipendium_1_N = mkN "stipendium" "stipendiet" "stipendier" "stipendierna" ; -- stipendium..nn.1
  stipulation_1_N = mkN "stipulation" ; -- stipulation..nn.1
  stipulera_1_V = mkV "stipulerar" ; -- stipulera..vb.1
  stipulerande_1_N = mkN "stipulerande" ; -- stipulerande..nn.1
  stipulerbar_1_A = mkA "stipulerbar" ; -- stipulerbar..av.1
  stipulerbarhet_1_N = mkN "stipulerbarhet" ; -- stipulerbarhet..nn.1
  stipulering_1_N = mkN "stipulering" ; -- stipulering..nn.1
  stirlingmotor_1_N = mkN "stirlingmotor" "stirlingmotorer" ; -- stirlingmotor..nn.1
  stirr_1_N = mkN "stirr" ; -- stirr..nn.1
  stirra_1_V = mkV "stirrar" ; -- stirra..vb.1
  stirrande_1_N = mkN "stirrande" ; -- stirrande..nn.1
  stirrig_1_A = mkA "stirrig" ; -- stirrig..av.1
  stirrighet_1_N = mkN "stirrighet" ; -- stirrighet..nn.1
  stjäla_1_V = mkV "stjäla" "stjäl" "stjäl" "stal" "stulit" "stulen" ; -- stjäla..vb.1
  stjälande_1_N = mkN "stjälande" ; -- stjälande..nn.1
  stjälbar_1_A = mkA "stjälbar" ; -- stjälbar..av.1
  stjälk_1_N = mkN "stjälk" ; -- stjälk..nn.1
  stjälkstygn_1_N = mkN "stjälkstygn" neutrum  ; -- stjälkstygn..nn.1
  stjälpa_1_V = mkV "stjälper" ; -- stjälpa..vb.1
  stjälpa_2_V = mkV "stjälper" ; -- stjälpa..vb.2
  stjälpande_1_N = mkN "stjälpande" ; -- stjälpande..nn.1
  stjälpning_1_N = mkN "stjälpning" ; -- stjälpning..nn.1
  stjärn_1_N = mkN "stjärn" ; -- stjärn..nn.1
  stjärna_1_N = mkN "stjärna" ; -- stjärna..nn.1
  stjärnarkitekt_1_N = mkN "stjärnarkitekt" "stjärnarkitekter" ; -- stjärnarkitekt..nn.1
  stjärnassociation_1_N = mkN "stjärnassociation" ; -- stjärnassociation..nn.1
  stjärnbeströdd_1_A = mkA "stjärnbeströdd" ; -- stjärnbeströdd..av.1
  stjärnbetäckning_1_N = mkN "stjärnbetäckning" ; -- stjärnbetäckning..nn.1
  stjärnbild_1_N = mkN "stjärnbild" "stjärnbilder" ; -- stjärnbild..nn.1
  stjärnblomma_1_N = mkN "stjärnblomma" ; -- stjärnblomma..nn.1
  stjärndirigent_1_N = mkN "stjärndirigent" "stjärndirigenter" ; -- stjärndirigent..nn.1
  stjärndygn_1_N = mkN "stjärndygn" neutrum  ; -- stjärndygn..nn.1
  stjärnenatt_1_N = mkN "stjärnenatt" "stjärnenätter" ; -- stjärnenatt..nn.1
  stjärnevalv_1_N = mkN "stjärnevalv" neutrum  ; -- stjärnevalv..nn.1
  stjärnevärld_1_N = mkN "stjärnevärld" ; -- stjärnevärld..nn.1
  stjärnfall_1_N = mkN "stjärnfall" neutrum  ; -- stjärnfall..nn.1
  stjärnfallsregn_1_N = mkN "stjärnfallsregn" neutrum  ; -- stjärnfallsregn..nn.1
  stjärnfigur_1_N = mkN "stjärnfigur" "stjärnfigurer" ; -- stjärnfigur..nn.1
  stjärnformig_1_A = mkA "stjärnformig" ; -- stjärnformig..av.1
  stjärnformighet_1_N = mkN "stjärnformighet" ; -- stjärnformighet..nn.1
  stjärngosse_1_N = mkN "stjärngosse" utrum  ; -- stjärngosse..nn.1
  stjärngranne_1_N = mkN "stjärngranne" utrum  ; -- stjärngranne..nn.1
  stjärnhimmel_1_N = mkN "stjärnhimmel" ; -- stjärnhimmel..nn.1
  stjärnhop_1_N = mkN "stjärnhop" ; -- stjärnhop..nn.1
  stjärnhus_1_N = mkN "stjärnhus" neutrum  ; -- stjärnhus..nn.1
  stjärnjurist_1_N = mkN "stjärnjurist" "stjärnjurister" ; -- stjärnjurist..nn.1
  stjärnkarta_1_N = mkN "stjärnkarta" ; -- stjärnkarta..nn.1
  stjärnklar_1_A = mkA "stjärnklar" ; -- stjärnklar..av.1
  stjärnkock_1_N = mkN "stjärnkock" ; -- stjärnkock..nn.1
  stjärnkonstellation_1_N = mkN "stjärnkonstellation" ; -- stjärnkonstellation..nn.1
  stjärnkoppling_1_N = mkN "stjärnkoppling" ; -- stjärnkoppling..nn.1
  stjärnkrögare_1_N = mkN "stjärnkrögare" utrum  ; -- stjärnkrögare..nn.1
  stjärnkusk_1_N = mkN "stjärnkusk" ; -- stjärnkusk..nn.1
  stjärnkött_1_N = mkN "stjärnkött" neutrum  ; -- stjärnkött..nn.1
  stjärnlik_1_A = mkA "stjärnlik" ; -- stjärnlik..av.1
  stjärnlikhet_1_N = mkN "stjärnlikhet" ; -- stjärnlikhet..nn.1
  stjärnljus_1_A = mkA "stjärnljus" ; -- stjärnljus..av.1
  stjärnljus_1_N = mkN "stjärnljus" neutrum  ; -- stjärnljus..nn.1
  stjärnmejsel_1_N = mkN "stjärnmejsel" ; -- stjärnmejsel..nn.1
  stjärnmotor_1_N = mkN "stjärnmotor" "stjärnmotorer" ; -- stjärnmotor..nn.1
  stjärnmålvakt_1_N = mkN "stjärnmålvakt" "stjärnmålvakter" ; -- stjärnmålvakt..nn.1
  stjärnpar_1_N = mkN "stjärnpar" neutrum  ; -- stjärnpar..nn.1
  stjärnrörelse_1_N = mkN "stjärnrörelse" "stjärnrörelser" ; -- stjärnrörelse..nn.1
  stjärnskott_1_N = mkN "stjärnskott" neutrum  ; -- stjärnskott..nn.1
  stjärnskådespelare_1_N = mkN "stjärnskådespelare" utrum  ; -- stjärnskådespelare..nn.1
  stjärnskådis_1_N = mkN "stjärnskådis" ; -- stjärnskådis..nn.1
  stjärnsmäll_1_N = mkN "stjärnsmäll" ; -- stjärnsmäll..nn.1
  stjärnspäckad_1_A = mkA "stjärnspäckad" ; -- stjärnspäckad..av.1
  stjärnstatus_1_N = mkN "stjärnstatus" ; -- stjärnstatus..nn.1
  stjärnstoff_1_N = mkN "stjärnstoff" neutrum  ; -- stjärnstoff..nn.1
  stjärnsystem_1_N = mkN "stjärnsystem" neutrum  ; -- stjärnsystem..nn.1
  stjärntecken_1_N = mkN "stjärntecken" "stjärntecknet" "stjärntecken" "stjärntecknen" ; -- stjärntecken..nn.1
  stjärntid_1_N = mkN "stjärntid" ; -- stjärntid..nn.1
  stjärntriplett_1_N = mkN "stjärntriplett" "stjärntripletter" ; -- stjärntriplett..nn.1
  stjärntränare_1_N = mkN "stjärntränare" utrum  ; -- stjärntränare..nn.1
  stjärntydare_1_N = mkN "stjärntydare" utrum  ; -- stjärntydare..nn.1
  stjärnvalv_1_N = mkN "stjärnvalv" neutrum  ; -- stjärnvalv..nn.1
  stjärnögd_1_A = mkA "stjärnögd" "stjärnögt" ; -- stjärnögd..av.1
  stjärnögdhet_1_N = mkN "stjärnögdhet" ; -- stjärnögdhet..nn.1
  stjärt_1_N = mkN "stjärt" ; -- stjärt..nn.1
  stjärtand_1_N = mkN "stjärtand" "stjärtänder" ; -- stjärtand..nn.1
  stjärtdel_1_N = mkN "stjärtdel" "stjärtdelen" "stjärtdelar" "stjärtdelarna" ; -- stjärtdel..nn.1
  stjärtfena_1_N = mkN "stjärtfena" ; -- stjärtfena..nn.1
  stjärtfjäder_1_N = mkN "stjärtfjäder" ; -- stjärtfjäder..nn.1
  stjärtgosse_1_N = mkN "stjärtgosse" utrum  ; -- stjärtgosse..nn.1
  stjärtgympa_1_N = mkN "stjärtgympa" ; -- stjärtgympa..nn.1
  stjärthalva_1_N = mkN "stjärthalva" ; -- stjärthalva..nn.1
  stjärtlös_1_A = mkA "stjärtlös" ; -- stjärtlös..av.1
  stjärtmes_1_N = mkN "stjärtmes" ; -- stjärtmes..nn.1
  stjärtskulptör_1_N = mkN "stjärtskulptör" "stjärtskulptörer" ; -- stjärtskulptör..nn.1
  stjärttrakt_1_N = mkN "stjärttrakt" "stjärttrakter" ; -- stjärttrakt..nn.1
  sto_1_N = mkN "sto" "stot" "ston" "stona" ; -- sto..nn.1
  stoa_1_N = mkN "stoa" ; -- stoa..nn.1
  stock_car_1_N = mkN "stock-car" ; -- stock-car..nn.1
  stock_1_N = mkN "stock" ; -- stock..nn.1
  stocka_1_V = mkV "stockar" ; -- stocka..vb.1
  stockande_1_N = mkN "stockande" ; -- stockande..nn.1
  stockankare_1_N = mkN "stockankare" "stockankaret" "stockankaren" "stockankarna" ; -- stockankare..nn.1
  stockbåt_1_N = mkN "stockbåt" ; -- stockbåt..nn.1
  stockdum_1_A = mkA "stockdum" "stockdumt" "stockdumma" "stockdumma" "stockdummare" "stockdummast" "stockdummaste" ; -- stockdum..av.1
  stockdumhet_1_N = mkN "stockdumhet" ; -- stockdumhet..nn.1
  stockeld_1_N = mkN "stockeld" ; -- stockeld..nn.1
  stockfisk_1_N = mkN "stockfisk" ; -- stockfisk..nn.1
  stockholmare_1_N = mkN "stockholmare" utrum  ; -- stockholmare..nn.1
  stockholmsk_1_A = mkA "stockholmsk" ; -- stockholmsk..av.1
  stockholmska_1_N = mkN "stockholmska" ; -- stockholmska..nn.1
  stockholmska_2_N = mkN "stockholmska" ; -- stockholmska..nn.2
  stockholmsmässig_1_A = mkA "stockholmsmässig" ; -- stockholmsmässig..av.1
  stockkonservativ_1_A = mkA "stockkonservativ" ; -- stockkonservativ..av.1
  stockning_1_N = mkN "stockning" ; -- stockning..nn.1
  stockreaktionär_1_A = mkA "stockreaktionär" ; -- stockreaktionär..av.1
  stockros_1_N = mkN "stockros" "stockrosor" ; -- stockros..nn.1
  stockstraff_1_N = mkN "stockstraff" neutrum  ; -- stockstraff..nn.1
  stod_1_N = mkN "stod" "stoder" ; -- stod..nn.1
  stoff_1_N = mkN "stoff" neutrum  ; -- stoff..nn.1
  stoffera_1_V = mkV "stofferar" ; -- stoffera..vb.1
  stofferande_1_N = mkN "stofferande" ; -- stofferande..nn.1
  stofferbar_1_A = mkA "stofferbar" ; -- stofferbar..av.1
  stofferbarhet_1_N = mkN "stofferbarhet" ; -- stofferbarhet..nn.1
  stoffering_1_N = mkN "stoffering" ; -- stoffering..nn.1
  stofil_1_N = mkN "stofil" "stofiler" ; -- stofil..nn.1
  stoft_1_N = mkN "stoft" neutrum  ; -- stoft..nn.1
  stoftfylld_1_A = mkA "stoftfylld" "stoftfyllt" ; -- stoftfylld..av.1
  stofthydda_1_N = mkN "stofthydda" ; -- stofthydda..nn.1
  stoftkorn_1_N = mkN "stoftkorn" neutrum  ; -- stoftkorn..nn.1
  stoftmoln_1_N = mkN "stoftmoln" neutrum  ; -- stoftmoln..nn.1
  stoftmängd_1_N = mkN "stoftmängd" "stoftmängder" ; -- stoftmängd..nn.1
  stoftpartikel_1_N = mkN "stoftpartikel" ; -- stoftpartikel..nn.1
  stoftslöja_1_N = mkN "stoftslöja" ; -- stoftslöja..nn.1
  stoicism_1_N = mkN "stoicism" "stoicismer" ; -- stoicism..nn.1
  stoicistisk_1_A = mkA "stoicistisk" ; -- stoicistisk..av.1
  stoiker_1_N = mkN "stoiker" "stoikern" "stoiker" "stoikerna" ; -- stoiker..nn.1
  stoisk_1_A = mkA "stoisk" ; -- stoisk..av.1
  stoiskhet_1_N = mkN "stoiskhet" ; -- stoiskhet..nn.1
  stoj_1_N = mkN "stoj" neutrum  ; -- stoj..nn.1
  stoja_1_V = mkV "stojar" ; -- stoja..vb.1
  stojande_1_N = mkN "stojande" ; -- stojande..nn.1
  stojig_1_A = mkA "stojig" ; -- stojig..av.1
  stokastisk_1_A = mkA "stokastisk" ; -- stokastisk..av.1
  stol_1_N = mkN "stol" ; -- stol..nn.1
  stola_1_N = mkN "stola" ; -- stola..nn.1
  stolgång_1_N = mkN "stolgång" ; -- stolgång..nn.1
  stoll_1_N = mkN "stoll" ; -- stoll..nn.1
  stolla_1_N = mkN "stolla" ; -- stolla..nn.1
  stolle_1_N = mkN "stolle" utrum  ; -- stolle..nn.1
  stolleri_1_N = mkN "stolleri" "stolleriet" "stollerier" "stollerierna" ; -- stolleri..nn.1
  stollig_1_A = mkA "stollig" ; -- stollig..av.1
  stollighet_1_N = mkN "stollighet" "stolligheter" ; -- stollighet..nn.1
  stolpa_1_V = mkV "stolpar" ; -- stolpa..vb.1
  stolpande_1_N = mkN "stolpande" ; -- stolpande..nn.1
  stolpbod_1_N = mkN "stolpbod" ; -- stolpbod..nn.1
  stolpdiagram_1_N = mkN "stolpdiagram" "stolpdiagrammet" "stolpdiagram" "stolpdiagrammen" ; -- stolpdiagram..nn.1
  stolpe_1_N = mkN "stolpe" utrum  ; -- stolpe..nn.1
  stolpiller_1_N = mkN "stolpiller" neutrum  ; -- stolpiller..nn.1
  stolprad_1_N = mkN "stolprad" "stolprader" ; -- stolprad..nn.1
  stolpsko_1_N = mkN "stolpsko" "stolpskor" ; -- stolpsko..nn.1
  stolpskott_1_N = mkN "stolpskott" neutrum  ; -- stolpskott..nn.1
  stolsdyna_1_N = mkN "stolsdyna" ; -- stolsdyna..nn.1
  stolsits_1_N = mkN "stolsits" ; -- stolsits..nn.1
  stolsrad_1_N = mkN "stolsrad" "stolsrader" ; -- stolsrad..nn.1
  stolsrygg_1_N = mkN "stolsrygg" ; -- stolsrygg..nn.1
  stolt_1_A = mkA "stolt" "stolt" ; -- stolt..av.1
  stolthet_1_N = mkN "stolthet" "stoltheter" ; -- stolthet..nn.1
  stolts_1_A = mkA "stolts" ; -- stolts..av.1
  stoltsera_1_V = mkV "stoltserar" ; -- stoltsera..vb.1
  stoltserande_1_N = mkN "stoltserande" ; -- stoltserande..nn.1
  stoltsering_1_N = mkN "stoltsering" ; -- stoltsering..nn.1
  stomatit_1_N = mkN "stomatit" "stomatiter" ; -- stomatit..nn.1
  stomatolleende_1_N = mkN "stomatolleende" ; -- stomatolleende..nn.1
  stomi_1_N = mkN "stomi" "stomier" ; -- stomi..nn.1
  stomjölk_1_N = mkN "stomjölk" ; -- stomjölk..nn.1
  stomme_1_N = mkN "stomme" utrum  ; -- stomme..nn.1
  stomp_1_N = mkN "stomp" ; -- stomp..nn.1
  stop_1_N = mkN "stop" neutrum  ; -- stop..nn.1
  stopp_1_N = mkN "stopp" neutrum  ; -- stopp..nn.1
  stopp_2_N = mkN "stopp" ; -- stopp..nn.2
  stoppa_1_V = mkV "stoppar" ; -- stoppa..vb.1
  stoppande_1_A = mkA "stoppande" ; -- stoppande..av.1
  stoppande_1_N = mkN "stoppande" ; -- stoppande..nn.1
  stoppboll_1_N = mkN "stoppboll" ; -- stoppboll..nn.1
  stopper_1_N = mkN "stopper" "stoppern" "stoppers" "stoppersarna" ; -- stopper..nn.1
  stopplikt_1_N = mkN "stopplikt" ; -- stopplikt..nn.1
  stoppljus_1_N = mkN "stoppljus" neutrum  ; -- stoppljus..nn.1
  stopplykta_1_N = mkN "stopplykta" ; -- stopplykta..nn.1
  stoppning_1_N = mkN "stoppning" ; -- stoppning..nn.1
  stoppnål_1_N = mkN "stoppnål" ; -- stoppnål..nn.1
  stoppris_1_N = mkN "stoppris" neutrum  ; -- stoppris..nn.1
  stoppsignal_1_N = mkN "stoppsignal" "stoppsignaler" ; -- stoppsignal..nn.1
  stoppskylt_1_N = mkN "stoppskylt" ; -- stoppskylt..nn.1
  stoppsväng_1_N = mkN "stoppsväng" ; -- stoppsväng..nn.1
  stoppur_1_N = mkN "stoppur" neutrum  ; -- stoppur..nn.1
  stor_1_A = mkA "stor" "större" "störst" ; -- stor..av.1
  stor_1_N = mkN "stor" ; -- stor..nn.1
  storartad_1_A = mkA "storartad" ; -- storartad..av.1
  storasyrra_1_N = mkN "storasyrra" ; -- storasyrra..nn.1
  storasyskon_1_N = mkN "storasyskon" neutrum  ; -- storasyskon..nn.1
  storasyster_1_N = mkN "storasyster" ; -- storasyster..nn.1
  storasysterattityd_1_N = mkN "storasysterattityd" "storasysterattityder" ; -- storasysterattityd..nn.1
  storband_1_N = mkN "storband" neutrum  ; -- storband..nn.1
  storbandsmässig_1_A = mkA "storbandsmässig" ; -- storbandsmässig..av.1
  storbedragerska_1_N = mkN "storbedragerska" ; -- storbedragerska..nn.1
  storbildskärm_1_N = mkN "storbildskärm" ; -- storbildskärm..nn.1
  storbildsteve_1_N = mkN "storbildsteve" "storbildsteven" "storbildstevear" "storbildstevearna" ; -- storbildsteve..nn.1
  storblommig_1_A = mkA "storblommig" ; -- storblommig..av.1
  storbolag_1_N = mkN "storbolag" neutrum  ; -- storbolag..nn.1
  storbolagsägare_1_N = mkN "storbolagsägare" utrum  ; -- storbolagsägare..nn.1
  storbonde_1_N = mkN "storbonde" "storbönder" ; -- storbonde..nn.1
  storbrand_1_N = mkN "storbrand" "storbränder" ; -- storbrand..nn.1
  storbritannisk_1_A = mkA "storbritannisk" ; -- storbritannisk..av.1
  storbrorsa_1_N = mkN "storbrorsa" ; -- storbrorsa..nn.1
  storbrättad_1_A = mkA "storbrättad" ; -- storbrättad..av.1
  storbråk_1_N = mkN "storbråk" neutrum  ; -- storbråk..nn.1
  storby_1_N = mkN "storby" "storbyn" "storbyar" "storbyarna" ; -- storby..nn.1
  storbystad_1_A = mkA "storbystad" ; -- storbystad..av.1
  storbåt_1_N = mkN "storbåt" ; -- storbåt..nn.1
  storcirkel_1_N = mkN "storcirkel" ; -- storcirkel..nn.1
  storcirkelsegling_1_N = mkN "storcirkelsegling" ; -- storcirkelsegling..nn.1
  stordator_1_N = mkN "stordator" "stordatorer" ; -- stordator..nn.1
  stordia_1_N = mkN "stordia" ; -- stordia..nn.1
  stordonator_1_N = mkN "stordonator" "stordonatorer" ; -- stordonator..nn.1
  stordrift_1_N = mkN "stordrift" ; -- stordrift..nn.1
  stordriftsfördel_1_N = mkN "stordriftsfördel" "stordriftsfördelen" "stordriftsfördelar" "stordriftsfördelarna" ; -- stordriftsfördel..nn.1
  stordåd_1_N = mkN "stordåd" neutrum  ; -- stordåd..nn.1
  store_1_N = mkN "store" "storer" ; -- store..nn.1
  storebror_1_N = mkN "storebror" ; -- storebror..nn.1
  storebrorsa_1_N = mkN "storebrorsa" ; -- storebrorsa..nn.1
  storebrorssamhälle_1_N = mkN "storebrorssamhälle" ; -- storebrorssamhälle..nn.1
  storfamilj_1_N = mkN "storfamilj" "storfamiljer" ; -- storfamilj..nn.1
  storfamiljshus_1_N = mkN "storfamiljshus" neutrum  ; -- storfamiljshus..nn.1
  storfavorit_1_N = mkN "storfavorit" "storfavoriter" ; -- storfavorit..nn.1
  storfilm_1_N = mkN "storfilm" "storfilmer" ; -- storfilm..nn.1
  storfinans_1_N = mkN "storfinans" ; -- storfinans..nn.1
  storfolk_1_N = mkN "storfolk" neutrum  ; -- storfolk..nn.1
  storfrämmande_1_N = mkN "storfrämmande" ; -- storfrämmande..nn.1
  storfurste_1_N = mkN "storfurste" utrum  ; -- storfurste..nn.1
  storfurstendöme_1_N = mkN "storfurstendöme" ; -- storfurstendöme..nn.1
  storfynd_1_N = mkN "storfynd" neutrum  ; -- storfynd..nn.1
  storföretag_1_N = mkN "storföretag" neutrum  ; -- storföretag..nn.1
  storförpackning_1_N = mkN "storförpackning" ; -- storförpackning..nn.1
  storgodsägare_1_N = mkN "storgodsägare" utrum  ; -- storgodsägare..nn.1
  storgräl_1_N = mkN "storgräl" neutrum  ; -- storgräl..nn.1
  storgråta_1_V = mkV "storgråta" "storgrät" "storgråtit" ; -- storgråta..vb.1
  storgråtande_1_N = mkN "storgråtande" ; -- storgråtande..nn.1
  storhandla_1_V = mkV "storhandlar" ; -- storhandla..vb.1
  storhandlande_1_N = mkN "storhandlande" ; -- storhandlande..nn.1
  storhandling_1_N = mkN "storhandling" ; -- storhandling..nn.1
  storhertig_1_N = mkN "storhertig" ; -- storhertig..nn.1
  storhet_1_N = mkN "storhet" "storheter" ; -- storhet..nn.1
  storhetsmani_1_N = mkN "storhetsmani" ; -- storhetsmani..nn.1
  storhetstid_1_N = mkN "storhetstid" "storhetstider" ; -- storhetstid..nn.1
  storhetsvansinne_1_N = mkN "storhetsvansinne" ; -- storhetsvansinne..nn.1
  storhjärna_1_N = mkN "storhjärna" ; -- storhjärna..nn.1
  storhushåll_1_N = mkN "storhushåll" neutrum  ; -- storhushåll..nn.1
  storhuvad_1_A = mkA "storhuvad" ; -- storhuvad..av.1
  storhövdad_1_A = mkA "storhövdad" ; -- storhövdad..av.1
  storindustri_1_N = mkN "storindustri" "storindustrier" ; -- storindustri..nn.1
  stork_1_N = mkN "stork" ; -- stork..nn.1
  storklubb_1_N = mkN "storklubb" ; -- storklubb..nn.1
  storkna_1_V = mkV "storknar" ; -- storkna..vb.1
  storknande_1_N = mkN "storknande" ; -- storknande..nn.1
  storkning_1_N = mkN "storkning" ; -- storkning..nn.1
  storkommun_1_N = mkN "storkommun" "storkommuner" ; -- storkommun..nn.1
  storkonflikt_1_N = mkN "storkonflikt" "storkonflikter" ; -- storkonflikt..nn.1
  storkors_1_N = mkN "storkors" neutrum  ; -- storkors..nn.1
  storkova_1_N = mkN "storkova" ; -- storkova..nn.1
  storkrig_1_N = mkN "storkrig" neutrum  ; -- storkrig..nn.1
  storkstam_1_N = mkN "storkstam" "storkstammen" "storkstammar" "storkstammarna" ; -- storkstam..nn.1
  storkukad_1_A = mkA "storkukad" ; -- storkukad..av.1
  storkunge_1_N = mkN "storkunge" utrum  ; -- storkunge..nn.1
  storkök_1_N = mkN "storkök" neutrum  ; -- storkök..nn.1
  storköksmat_1_N = mkN "storköksmat" ; -- storköksmat..nn.1
  storlek_1_N = mkN "storlek" ; -- storlek..nn.1
  storleksmässig_1_A = mkA "storleksmässig" ; -- storleksmässig..av.1
  storleksnummer_1_N = mkN "storleksnummer" neutrum  ; -- storleksnummer..nn.1
  storleksordna_1_V = mkV "storleksordnar" ; -- storleksordna..vb.1
  storleksordnande_1_N = mkN "storleksordnande" ; -- storleksordnande..nn.1
  storleksordning_1_N = mkN "storleksordning" ; -- storleksordning..nn.1
  storliga_1_Adv = mkAdv "storliga" ; -- storliga..ab.1
  storligen_1_Adv = mkAdv "storligen" ; -- storligen..ab.1
  storljug_1_N = mkN "storljug" neutrum  ; -- storljug..nn.1
  storljuga_1_V = mkV "storljuga" "storljög" "storljugit" ; -- storljuga..vb.1
  storljugande_1_N = mkN "storljugande" ; -- storljugande..nn.1
  storljugare_1_N = mkN "storljugare" utrum  ; -- storljugare..nn.1
  storm_1_N = mkN "storm" ; -- storm..nn.1
  storma_1_V = mkV "stormar" ; -- storma..vb.1
  storma_2_V = mkV "stormar" ; -- storma..vb.2
  stormagad_1_A = mkA "stormagad" ; -- stormagad..av.1
  stormakt_1_N = mkN "stormakt" "stormakter" ; -- stormakt..nn.1
  stormaktspolitik_1_N = mkN "stormaktspolitik" ; -- stormaktspolitik..nn.1
  stormaktspolitisk_1_A = mkA "stormaktspolitisk" ; -- stormaktspolitisk..av.1
  stormaktsspel_1_N = mkN "stormaktsspel" "stormaktsspelet" "stormaktsspel" "stormaktsspelen" ; -- stormaktsspel..nn.1
  stormaktstid_1_N = mkN "stormaktstid" "stormaktstider" ; -- stormaktstid..nn.1
  stormaktsvälde_1_N = mkN "stormaktsvälde" ; -- stormaktsvälde..nn.1
  storman_1_N = mkN "storman" "stormannen" "stormän" "stormännen" ; -- storman..nn.1
  stormande_1_N = mkN "stormande" ; -- stormande..nn.1
  stormarknad_1_N = mkN "stormarknad" "stormarknader" ; -- stormarknad..nn.1
  stormarskalk_1_N = mkN "stormarskalk" ; -- stormarskalk..nn.1
  stormast_1_N = mkN "stormast" "stormaster" ; -- stormast..nn.1
  stormavdelning_1_N = mkN "stormavdelning" ; -- stormavdelning..nn.1
  stormby_1_N = mkN "stormby" "stormbyn" "stormbyar" "stormbyarna" ; -- stormby..nn.1
  stormbåt_1_N = mkN "stormbåt" ; -- stormbåt..nn.1
  stormcentrum_1_N = mkN "stormcentrum" neutrum  ; -- stormcentrum..nn.1
  stormdriven_1_A = mkA "stormdriven" ; -- stormdriven..av.1
  stormeld_1_N = mkN "stormeld" ; -- stormeld..nn.1
  stormflod_1_N = mkN "stormflod" "stormfloder" ; -- stormflod..nn.1
  stormfri_1_A = mkA "stormfri" "stormfritt" ; -- stormfri..av.1
  stormfrihet_1_N = mkN "stormfrihet" ; -- stormfrihet..nn.1
  stormfågel_1_N = mkN "stormfågel" ; -- stormfågel..nn.1
  stormförtjust_1_A = mkA "stormförtjust" "stormförtjust" ; -- stormförtjust..av.1
  stormgräl_1_N = mkN "stormgräl" neutrum  ; -- stormgräl..nn.1
  stormgräla_1_V = mkV "stormgrälar" ; -- stormgräla..vb.1
  stormhatt_1_N = mkN "stormhatt" ; -- stormhatt..nn.1
  stormhinder_1_N = mkN "stormhinder" neutrum  ; -- stormhinder..nn.1
  stormig_1_A = mkA "stormig" ; -- stormig..av.1
  stormighet_1_N = mkN "stormighet" ; -- stormighet..nn.1
  stormil_1_N = mkN "stormil" ; -- stormil..nn.1
  stormklocka_1_N = mkN "stormklocka" ; -- stormklocka..nn.1
  stormlykta_1_N = mkN "stormlykta" ; -- stormlykta..nn.1
  stormning_1_N = mkN "stormning" ; -- stormning..nn.1
  stormningsanfall_1_N = mkN "stormningsanfall" neutrum  ; -- stormningsanfall..nn.1
  stormningsförsök_1_N = mkN "stormningsförsök" neutrum  ; -- stormningsförsök..nn.1
  stormogul_1_N = mkN "stormogul" "stormoguler" ; -- stormogul..nn.1
  stormpunkt_1_N = mkN "stormpunkt" "stormpunkter" ; -- stormpunkt..nn.1
  stormrik_1_A = mkA "stormrik" ; -- stormrik..av.1
  stormrikhet_1_N = mkN "stormrikhet" ; -- stormrikhet..nn.1
  stormskälla_1_V = mkV "stormskäller" ; -- stormskälla..vb.1
  stormskällande_1_N = mkN "stormskällande" ; -- stormskällande..nn.1
  stormstyrka_1_N = mkN "stormstyrka" ; -- stormstyrka..nn.1
  stormsvala_1_N = mkN "stormsvala" ; -- stormsvala..nn.1
  stormsäker_1_A = mkA "stormsäker" ; -- stormsäker..av.1
  stormsäkerhet_1_N = mkN "stormsäkerhet" ; -- stormsäkerhet..nn.1
  stormsäkra_1_V = mkV "stormsäkrar" ; -- stormsäkra..vb.1
  stormsäkrande_1_N = mkN "stormsäkrande" ; -- stormsäkrande..nn.1
  stormtak_1_N = mkN "stormtak" neutrum  ; -- stormtak..nn.1
  stormufti_1_N = mkN "stormufti" "stormuftin" "stormuftier" "stormuftierna" ; -- stormufti..nn.1
  stormunnad_1_A = mkA "stormunnad" ; -- stormunnad..av.1
  stormvarning_1_N = mkN "stormvarning" ; -- stormvarning..nn.1
  stormvind_1_N = mkN "stormvind" ; -- stormvind..nn.1
  stormynt_1_A = mkA "stormynt" "stormynt" ; -- stormynt..av.1
  stormästare_1_N = mkN "stormästare" utrum  ; -- stormästare..nn.1
  stormöte_1_N = mkN "stormöte" ; -- stormöte..nn.1
  storoffensiv_1_N = mkN "storoffensiv" "storoffensiver" ; -- storoffensiv..nn.1
  storordig_1_A = mkA "storordig" ; -- storordig..av.1
  storordighet_1_N = mkN "storordighet" ; -- storordighet..nn.1
  storpipig_1_A = mkA "storpipig" ; -- storpipig..av.1
  storpolitisk_1_A = mkA "storpolitisk" ; -- storpolitisk..av.1
  storprata_1_V = mkV "storpratar" ; -- storprata..vb.1
  storpratande_1_N = mkN "storpratande" ; -- storpratande..nn.1
  storpratare_1_N = mkN "storpratare" utrum  ; -- storpratare..nn.1
  storproviantering_1_N = mkN "storproviantering" ; -- storproviantering..nn.1
  storpublik_1_N = mkN "storpublik" ; -- storpublik..nn.1
  storrutig_1_A = mkA "storrutig" ; -- storrutig..av.1
  storrutighet_1_N = mkN "storrutighet" ; -- storrutighet..nn.1
  storrysk_1_A = mkA "storrysk" ; -- storrysk..av.1
  storsatsa_1_V = mkV "storsatsar" ; -- storsatsa..vb.1
  storsatsande_1_N = mkN "storsatsande" ; -- storsatsande..nn.1
  storsatsning_1_N = mkN "storsatsning" ; -- storsatsning..nn.1
  storsegel_1_N = mkN "storsegel" neutrum  ; -- storsegel..nn.1
  storsegelbom_1_N = mkN "storsegelbom" "storsegelbommen" "storsegelbommar" "storsegelbommarna" ; -- storsegelbom..nn.1
  storsinnad_1_A = mkA "storsinnad" ; -- storsinnad..av.1
  storsint_1_A = mkA "storsint" "storsint" ; -- storsint..av.1
  storsinthet_1_N = mkN "storsinthet" ; -- storsinthet..nn.1
  storsjöfiske_1_N = mkN "storsjöfiske" ; -- storsjöfiske..nn.1
  storsjöodjur_1_N = mkN "storsjöodjur" neutrum  ; -- storsjöodjur..nn.1
  storskalig_1_A = mkA "storskalig" ; -- storskalig..av.1
  storskalighet_1_N = mkN "storskalighet" ; -- storskalighet..nn.1
  storskifte_1_N = mkN "storskifte" ; -- storskifte..nn.1
  storskog_1_N = mkN "storskog" ; -- storskog..nn.1
  storskojare_1_N = mkN "storskojare" utrum  ; -- storskojare..nn.1
  storskot_1_N = mkN "storskot" neutrum  ; -- storskot..nn.1
  storskotsskena_1_N = mkN "storskotsskena" ; -- storskotsskena..nn.1
  storskrake_1_N = mkN "storskrak" ; -- storskrake..nn.1
  storskratta_1_V = mkV "storskrattar" ; -- storskratta..vb.1
  storskrika_1_V = mkV "storskrika" "storskrek" "storskrikit" ; -- storskrika..vb.1
  storskrikande_1_N = mkN "storskrikande" ; -- storskrikande..nn.1
  storskrytare_1_N = mkN "storskrytare" utrum  ; -- storskrytare..nn.1
  storskrävlare_1_N = mkN "storskrävlare" utrum  ; -- storskrävlare..nn.1
  storslagen_1_A = mkA "storslagen" ; -- storslagen..av.1
  storslagenhet_1_N = mkN "storslagenhet" ; -- storslagenhet..nn.1
  storslalom_1_N = mkN "storslalom" ; -- storslalom..nn.1
  storslam_1_N = mkN "storslam" "storslammen" "storslammar" "storslammarna" ; -- storslam..nn.1
  storspov_1_N = mkN "storspov" ; -- storspov..nn.1
  storstad_1_N = mkN "storstad" "storstäder" ; -- storstad..nn.1
  storstadsbo_1_N = mkN "storstadsbo" "storstadsbor" ; -- storstadsbo..nn.1
  storstadskille_1_N = mkN "storstadskille" utrum  ; -- storstadskille..nn.1
  storstadsliv_1_N = mkN "storstadsliv" neutrum  ; -- storstadsliv..nn.1
  storstadsmässig_1_A = mkA "storstadsmässig" ; -- storstadsmässig..av.1
  storstadsområde_1_N = mkN "storstadsområde" ; -- storstadsområde..nn.1
  storstadsrankning_1_N = mkN "storstadsrankning" ; -- storstadsrankning..nn.1
  storstadsskymning_1_N = mkN "storstadsskymning" ; -- storstadsskymning..nn.1
  storstadsungdom_1_N = mkN "storstadsungdom" ; -- storstadsungdom..nn.1
  storstilad_1_A = mkA "storstilad" ; -- storstilad..av.1
  storstilt_1_A = mkA "storstilt" "storstilt" ; -- storstilt..av.1
  storstilthet_1_N = mkN "storstilthet" ; -- storstilthet..nn.1
  storstjärna_1_N = mkN "storstjärna" ; -- storstjärna..nn.1
  storstrejk_1_N = mkN "storstrejk" "storstrejker" ; -- storstrejk..nn.1
  storstuga_1_N = mkN "storstuga" ; -- storstuga..nn.1
  storstäda_1_V = mkV "storstädar" ; -- storstäda..vb.1
  storstädande_1_N = mkN "storstädande" ; -- storstädande..nn.1
  storstädning_1_N = mkN "storstädning" ; -- storstädning..nn.1
  storsvensk_1_A = mkA "storsvensk" ; -- storsvensk..av.1
  storsvensk_1_N = mkN "storsvensk" ; -- storsvensk..nn.1
  storsvindel_1_N = mkN "storsvindel" ; -- storsvindel..nn.1
  storsyrra_1_N = mkN "storsyrra" ; -- storsyrra..nn.1
  storsyskon_1_N = mkN "storsyskon" neutrum  ; -- storsyskon..nn.1
  storsäljande_1_A = mkA "storsäljande" ; -- storsäljande..av.1
  storsäljare_1_N = mkN "storsäljare" utrum  ; -- storsäljare..nn.1
  stortavla_1_N = mkN "stortavla" ; -- stortavla..nn.1
  storting_1_N = mkN "storting" neutrum  ; -- storting..nn.1
  stortjuta_1_V = mkV "stortjuta" "stortjöt" "stortjutit" ; -- stortjuta..vb.1
  stortjutande_1_N = mkN "stortjutande" ; -- stortjutande..nn.1
  stortopp_1_N = mkN "stortopp" ; -- stortopp..nn.1
  stortröja_1_N = mkN "stortröja" ; -- stortröja..nn.1
  stortå_1_N = mkN "stortå" "stortån" "stortår" "stortårna" ; -- stortå..nn.1
  stortånagel_1_N = mkN "stortånagel" ; -- stortånagel..nn.1
  storverk_1_N = mkN "storverk" neutrum  ; -- storverk..nn.1
  storvilt_1_N = mkN "storvilt" neutrum  ; -- storvilt..nn.1
  storviltjägare_1_N = mkN "storviltjägare" utrum  ; -- storviltjägare..nn.1
  storvinst_1_N = mkN "storvinst" "storvinster" ; -- storvinst..nn.1
  storvulen_1_A = mkA "storvulen" ; -- storvulen..av.1
  storvuxen_1_A = mkA "storvuxen" ; -- storvuxen..av.1
  storväst_1_N = mkN "storväst" ; -- storväst..nn.1
  storväxt_1_A = mkA "storväxt" "storväxt" ; -- storväxt..av.1
  storväxthet_1_N = mkN "storväxthet" ; -- storväxthet..nn.1
  story_1_N = mkN "story" "storyer" ; -- story..nn.1
  storymässig_1_A = mkA "storymässig" ; -- storymässig..av.1
  storända_1_N = mkN "storända" ; -- storända..nn.1
  storände_1_N = mkN "storände" utrum  ; -- storände..nn.1
  storätare_1_N = mkN "storätare" utrum  ; -- storätare..nn.1
  storögd_1_A = mkA "storögd" "storögt" ; -- storögd..av.1
  storögdhet_1_N = mkN "storögdhet" ; -- storögdhet..nn.1
  stout_1_N = mkN "stout" ; -- stout..nn.1
  strabism_1_N = mkN "strabism" "strabismer" ; -- strabism..nn.1
  stradivarius_1_N = mkN "stradivarius" ; -- stradivarius..nn.1
  straff_1_N = mkN "straff" neutrum  ; -- straff..nn.1
  straff_2_N = mkN "straff" ; -- straff..nn.2
  straffa_1_V = mkV "straffar" ; -- straffa..vb.1
  straffande_1_N = mkN "straffande" ; -- straffande..nn.1
  straffanstalt_1_N = mkN "straffanstalt" "straffanstalter" ; -- straffanstalt..nn.1
  straffarbete_1_N = mkN "straffarbete" ; -- straffarbete..nn.1
  straffbalk_1_N = mkN "straffbalk" ; -- straffbalk..nn.1
  straffbar_1_A = mkA "straffbar" ; -- straffbar..av.1
  straffbarhet_1_N = mkN "straffbarhet" ; -- straffbarhet..nn.1
  straffbataljon_1_N = mkN "straffbataljon" "straffbataljoner" ; -- straffbataljon..nn.1
  straffbelägga_1_V = mkV "straffbelägga" "straffbela" "straffbelagt" ; -- straffbelägga..vb.1
  straffbeläggande_1_N = mkN "straffbeläggande" ; -- straffbeläggande..nn.1
  straffbeskatta_1_V = mkV "straffbeskattar" ; -- straffbeskatta..vb.1
  straffbeskattande_1_N = mkN "straffbeskattande" ; -- straffbeskattande..nn.1
  straffdom_1_N = mkN "straffdom" ; -- straffdom..nn.1
  straffexercis_1_N = mkN "straffexercis" "straffexerciser" ; -- straffexercis..nn.1
  straffexpedition_1_N = mkN "straffexpedition" ; -- straffexpedition..nn.1
  straffkast_1_N = mkN "straffkast" neutrum  ; -- straffkast..nn.1
  straffkoloni_1_N = mkN "straffkoloni" "straffkolonier" ; -- straffkoloni..nn.1
  strafflag_1_N = mkN "strafflag" ; -- strafflag..nn.1
  strafflindring_1_N = mkN "strafflindring" ; -- strafflindring..nn.1
  strafflös_1_A = mkA "strafflös" ; -- strafflös..av.1
  strafflöshet_1_N = mkN "strafflöshet" ; -- strafflöshet..nn.1
  straffmyndig_1_A = mkA "straffmyndig" ; -- straffmyndig..av.1
  straffnivå_1_N = mkN "straffnivå" "straffnivåer" ; -- straffnivå..nn.1
  straffområde_1_N = mkN "straffområde" ; -- straffområde..nn.1
  straffpåföljd_1_N = mkN "straffpåföljd" "straffpåföljder" ; -- straffpåföljd..nn.1
  straffrabatt_1_N = mkN "straffrabatt" ; -- straffrabatt..nn.1
  straffredskap_1_N = mkN "straffredskap" neutrum  ; -- straffredskap..nn.1
  straffregister_1_N = mkN "straffregister" neutrum  ; -- straffregister..nn.1
  straffri_1_A = mkA "straffri" "straffritt" ; -- straffri..av.1
  straffrätt_1_N = mkN "straffrätt" ; -- straffrätt..nn.1
  straffrättslig_1_A = mkA "straffrättslig" ; -- straffrättslig..av.1
  straffsats_1_N = mkN "straffsats" "straffsatser" ; -- straffsats..nn.1
  straffskala_1_N = mkN "straffskala" ; -- straffskala..nn.1
  straffskytt_1_N = mkN "straffskytt" ; -- straffskytt..nn.1
  straffspark_1_N = mkN "straffspark" ; -- straffspark..nn.1
  strafftid_1_N = mkN "strafftid" "strafftider" ; -- strafftid..nn.1
  strafftull_1_N = mkN "strafftull" ; -- strafftull..nn.1
  straffvärde_1_N = mkN "straffvärde" ; -- straffvärde..nn.1
  straffånge_1_N = mkN "straffånge" utrum  ; -- straffånge..nn.1
  strafföreläggande_1_N = mkN "strafföreläggande" ; -- strafföreläggande..nn.1
  straight_1_A = mkA "straight" ; -- straight..av.1
  strak_1_A = mkA "strak" ; -- strak..av.1
  strakbent_1_A = mkA "strakbent" "strakbent" ; -- strakbent..av.1
  strakbenthet_1_N = mkN "strakbenthet" ; -- strakbenthet..nn.1
  strakhet_1_N = mkN "strakhet" ; -- strakhet..nn.1
  stram_1_A = mkA "stram" ; -- stram..av.1
  strama_1_V = mkV "stramar" ; -- strama..vb.1
  stramalj_1_N = mkN "stramalj" "stramaljer" ; -- stramalj..nn.1
  stramande_1_N = mkN "stramande" ; -- stramande..nn.1
  stramhet_1_N = mkN "stramhet" ; -- stramhet..nn.1
  stramning_1_N = mkN "stramning" ; -- stramning..nn.1
  strand_1_N = mkN "strand" "stränder" ; -- strand..nn.1
  stranda_1_V = mkV "strandar" ; -- stranda..vb.1
  strandande_1_N = mkN "strandande" ; -- strandande..nn.1
  strandartikel_1_N = mkN "strandartikel" ; -- strandartikel..nn.1
  strandfavorit_1_N = mkN "strandfavorit" "strandfavoriter" ; -- strandfavorit..nn.1
  strandflate_1_N = mkN "strandflate" utrum  ; -- strandflate..nn.1
  strandfynd_1_N = mkN "strandfynd" neutrum  ; -- strandfynd..nn.1
  strandhugg_1_N = mkN "strandhugg" neutrum  ; -- strandhugg..nn.1
  strandjogg_1_N = mkN "strandjogg" ; -- strandjogg..nn.1
  strandkant_1_N = mkN "strandkant" "strandkanter" ; -- strandkant..nn.1
  strandlinje_1_N = mkN "strandlinje" "strandlinjer" ; -- strandlinje..nn.1
  strandmiljö_1_N = mkN "strandmiljö" "strandmiljön" "strandmiljöer" "strandmiljöerna" ; -- strandmiljö..nn.1
  strandning_1_N = mkN "strandning" ; -- strandning..nn.1
  strandnära_1_A = mkA "strandnära" ; -- strandnära..av.1
  strandpipare_1_N = mkN "strandpipare" utrum  ; -- strandpipare..nn.1
  strandpromenad_1_N = mkN "strandpromenad" "strandpromenader" ; -- strandpromenad..nn.1
  strandrestaurang_1_N = mkN "strandrestaurang" "strandrestauranger" ; -- strandrestaurang..nn.1
  strandrätt_1_N = mkN "strandrätt" ; -- strandrätt..nn.1
  strandråg_1_N = mkN "strandråg" ; -- strandråg..nn.1
  strandsjö_1_N = mkN "strandsjö" ; -- strandsjö..nn.1
  strandskata_1_N = mkN "strandskata" ; -- strandskata..nn.1
  strandskydd_1_N = mkN "strandskydd" neutrum  ; -- strandskydd..nn.1
  strandskyddad_1_A = mkA "strandskyddad" ; -- strandskyddad..av.1
  strandsluttning_1_N = mkN "strandsluttning" ; -- strandsluttning..nn.1
  strandsmal_1_A = mkA "strandsmal" ; -- strandsmal..av.1
  strandsnäcka_1_N = mkN "strandsnäcka" ; -- strandsnäcka..nn.1
  strandstat_1_N = mkN "strandstat" "strandstater" ; -- strandstat..nn.1
  strandsätta_1_V = mkV "strandsätta" "strandsätter" "strandsätt" "strandsatte" "strandsatt" "strandsatt" ; -- strandsätta..vb.1
  strandsättande_1_N = mkN "strandsättande" ; -- strandsättande..nn.1
  strandtomt_1_N = mkN "strandtomt" "strandtomter" ; -- strandtomt..nn.1
  strandtyp_1_N = mkN "strandtyp" "strandtyper" ; -- strandtyp..nn.1
  strandvakt_1_N = mkN "strandvakt" "strandvakter" ; -- strandvakt..nn.1
  strandvall_1_N = mkN "strandvall" ; -- strandvall..nn.1
  strandväxt_1_N = mkN "strandväxt" "strandväxter" ; -- strandväxt..nn.1
  strandäng_1_N = mkN "strandäng" ; -- strandäng..nn.1
  strandört_1_N = mkN "strandört" "strandörter" ; -- strandört..nn.1
  strangulation_1_N = mkN "strangulation" ; -- strangulation..nn.1
  strangulera_1_V = mkV "strangulerar" ; -- strangulera..vb.1
  strangulerande_1_N = mkN "strangulerande" ; -- strangulerande..nn.1
  strangulerbar_1_A = mkA "strangulerbar" ; -- strangulerbar..av.1
  strangulerbarhet_1_N = mkN "strangulerbarhet" ; -- strangulerbarhet..nn.1
  strangulering_1_N = mkN "strangulering" ; -- strangulering..nn.1
  strapats_1_N = mkN "strapats" "strapatser" ; -- strapats..nn.1
  strapatsrik_1_A = mkA "strapatsrik" ; -- strapatsrik..av.1
  strass_1_N = mkN "strass" ; -- strass..nn.1
  stratagem_1_N = mkN "stratagem" neutrum  ; -- stratagem..nn.1
  strateg_1_N = mkN "strateg" "strateger" ; -- strateg..nn.1
  strategi_1_N = mkN "strategi" "strategier" ; -- strategi..nn.1
  strategibyrå_1_N = mkN "strategibyrå" "strategibyråer" ; -- strategibyrå..nn.1
  strategidokument_1_N = mkN "strategidokument" neutrum  ; -- strategidokument..nn.1
  strategisk_1_A = mkA "strategisk" ; -- strategisk..av.1
  stratifiera_1_V = mkV "stratifierar" ; -- stratifiera..vb.1
  stratifierande_1_N = mkN "stratifierande" ; -- stratifierande..nn.1
  stratifierbar_1_A = mkA "stratifierbar" ; -- stratifierbar..av.1
  stratifierbarhet_1_N = mkN "stratifierbarhet" ; -- stratifierbarhet..nn.1
  stratifiering_1_N = mkN "stratifiering" ; -- stratifiering..nn.1
  stratigrafi_1_N = mkN "stratigrafi" ; -- stratigrafi..nn.1
  stratosfär_1_N = mkN "stratosfär" ; -- stratosfär..nn.1
  stratum_1_N = mkN "stratum" "stratumet" "strata" "stratana" ; -- stratum..nn.1
  stratus_1_N = mkN "stratus" ; -- stratus..nn.1
  strax_1_Adv = mkAdv "strax" ; -- strax..ab.1
  streaka_1_V = mkV "streakar" ; -- streaka..vb.1
  streakande_1_N = mkN "streakande" ; -- streakande..nn.1
  streaking_1_N = mkN "streaking" ; -- streaking..nn.1
  streakning_1_N = mkN "streakning" ; -- streakning..nn.1
  streama_1_V = mkV "streamar" ; -- streama..vb.1
  streamande_1_N = mkN "streamande" ; -- streamande..nn.1
  streamer_1_N = mkN "streamer" "streamern" "streamers" "streamersarna" ; -- streamer..nn.1
  streaming_1_N = mkN "streaming" ; -- streaming..nn.1
  streamning_1_N = mkN "streamning" ; -- streamning..nn.1
  streber_1_N = mkN "streber" ; -- streber..nn.1
  streck_1_N = mkN "streck" neutrum  ; -- streck..nn.1
  strecka_1_V = mkV "streckar" ; -- strecka..vb.1
  streckande_1_N = mkN "streckande" ; -- streckande..nn.1
  streckgubbe_1_N = mkN "streckgubbe" utrum  ; -- streckgubbe..nn.1
  streckkod_1_N = mkN "streckkod" "streckkoder" ; -- streckkod..nn.1
  streckkodläsare_1_N = mkN "streckkodläsare" utrum  ; -- streckkodläsare..nn.1
  streckkodsläsare_1_N = mkN "streckkodsläsare" utrum  ; -- streckkodsläsare..nn.1
  streckprickad_1_A = mkA "streckprickad" ; -- streckprickad..av.1
  strega_1_N = mkN "strega" ; -- strega..nn.1
  strejk_1_N = mkN "strejk" "strejker" ; -- strejk..nn.1
  strejka_1_V = mkV "strejkar" ; -- strejka..vb.1
  strejkande_1_N = mkN "strejkande" ; -- strejkande..nn.1
  strejkare_1_N = mkN "strejkare" utrum  ; -- strejkare..nn.1
  strejkbrytare_1_N = mkN "strejkbrytare" utrum  ; -- strejkbrytare..nn.1
  strejkkassa_1_N = mkN "strejkkassa" ; -- strejkkassa..nn.1
  strejkvakt_1_N = mkN "strejkvakt" "strejkvakter" ; -- strejkvakt..nn.1
  strejkvarsel_1_N = mkN "strejkvarsel" neutrum  ; -- strejkvarsel..nn.1
  streptokock_1_N = mkN "streptokock" "streptokocker" ; -- streptokock..nn.1
  streptomycin_1_N = mkN "streptomycin" "streptomyciner" ; -- streptomycin..nn.1
  stress_1_N = mkN "stress" ; -- stress..nn.1
  stressa_1_V = mkV "stressar" ; -- stressa..vb.1
  stressad_1_A = mkA "stressad" ; -- stressad..av.1
  stressande_1_N = mkN "stressande" ; -- stressande..nn.1
  stresshormon_1_N = mkN "stresshormon" neutrum  ; -- stresshormon..nn.1
  stressig_1_A = mkA "stressig" ; -- stressig..av.1
  stressighet_1_N = mkN "stressighet" ; -- stressighet..nn.1
  stressreaktion_1_N = mkN "stressreaktion" ; -- stressreaktion..nn.1
  stressrelaterad_1_A = mkA "stressrelaterad" ; -- stressrelaterad..av.1
  stresstest_1_N = mkN "stresstest" neutrum  ; -- stresstest..nn.1
  stresstålig_1_A = mkA "stresstålig" ; -- stresstålig..av.1
  stresstålighet_1_N = mkN "stresstålighet" ; -- stresstålighet..nn.1
  stressyndrom_1_N = mkN "stressyndrom" neutrum  ; -- stressyndrom..nn.1
  streta_1_V = mkV "stretar" ; -- streta..vb.1
  stretande_1_N = mkN "stretande" ; -- stretande..nn.1
  stretcha_1_V = mkV "stretchar" ; -- stretcha..vb.1
  stretchande_1_N = mkN "stretchande" ; -- stretchande..nn.1
  stretchnylon_1_N = mkN "stretchnylon" "stretchnyloner" ; -- stretchnylon..nn.1
  stretig_1_A = mkA "stretig" ; -- stretig..av.1
  strid_1_A = mkA "strid" "stritt" ; -- strid..av.1
  strid_1_N = mkN "strid" "strider" ; -- strid..nn.1
  strida_1_V = mkV "strida" "stred" "stridit" ; -- strida..vb.1
  stridande_1_N = mkN "stridande" ; -- stridande..nn.1
  stridbar_1_A = mkA "stridbar" ; -- stridbar..av.1
  stridbarhet_1_N = mkN "stridbarhet" ; -- stridbarhet..nn.1
  stridhet_1_N = mkN "stridhet" ; -- stridhet..nn.1
  stridig_1_A = mkA "stridig" ; -- stridig..av.1
  stridighet_1_N = mkN "stridighet" "stridigheter" ; -- stridighet..nn.1
  stridis_1_N = mkN "stridis" ; -- stridis..nn.1
  stridsberedskap_1_N = mkN "stridsberedskap" ; -- stridsberedskap..nn.1
  stridsbuller_1_N = mkN "stridsbuller" neutrum  ; -- stridsbuller..nn.1
  stridsdomare_1_N = mkN "stridsdomare" utrum  ; -- stridsdomare..nn.1
  stridsduglig_1_A = mkA "stridsduglig" ; -- stridsduglig..av.1
  stridsduglighet_1_N = mkN "stridsduglighet" ; -- stridsduglighet..nn.1
  stridsflyg_1_N = mkN "stridsflyg" neutrum  ; -- stridsflyg..nn.1
  stridsflygplan_1_N = mkN "stridsflygplan" neutrum  ; -- stridsflygplan..nn.1
  stridsformera_1_V = mkV "stridsformerar" ; -- stridsformera..vb.1
  stridsformerande_1_N = mkN "stridsformerande" ; -- stridsformerande..nn.1
  stridsformerbar_1_A = mkA "stridsformerbar" ; -- stridsformerbar..av.1
  stridsformerbarhet_1_N = mkN "stridsformerbarhet" ; -- stridsformerbarhet..nn.1
  stridsformering_1_N = mkN "stridsformering" ; -- stridsformering..nn.1
  stridsfråga_1_N = mkN "stridsfråga" ; -- stridsfråga..nn.1
  stridsgas_1_N = mkN "stridsgas" "stridsgaser" ; -- stridsgas..nn.1
  stridsgruppera_1_V = mkV "stridsgrupperar" ; -- stridsgruppera..vb.1
  stridsgrupperande_1_N = mkN "stridsgrupperande" ; -- stridsgrupperande..nn.1
  stridsgrupperbar_1_A = mkA "stridsgrupperbar" ; -- stridsgrupperbar..av.1
  stridsgrupperbarhet_1_N = mkN "stridsgrupperbarhet" ; -- stridsgrupperbarhet..nn.1
  stridsgruppering_1_N = mkN "stridsgruppering" ; -- stridsgruppering..nn.1
  stridshandske_1_N = mkN "stridshandske" utrum  ; -- stridshandske..nn.1
  stridshorn_1_N = mkN "stridshorn" neutrum  ; -- stridshorn..nn.1
  stridsklubba_1_N = mkN "stridsklubba" ; -- stridsklubba..nn.1
  stridskraft_1_N = mkN "stridskraft" ; -- stridskraft..nn.1
  stridskämpe_1_N = mkN "stridskämpe" utrum  ; -- stridskämpe..nn.1
  stridslarm_1_N = mkN "stridslarm" neutrum  ; -- stridslarm..nn.1
  stridsledning_1_N = mkN "stridsledning" ; -- stridsledning..nn.1
  stridsledningscentral_1_N = mkN "stridsledningscentral" "stridsledningscentraler" ; -- stridsledningscentral..nn.1
  stridsledningsflygplan_1_N = mkN "stridsledningsflygplan" neutrum  ; -- stridsledningsflygplan..nn.1
  stridslust_1_N = mkN "stridslust" ; -- stridslust..nn.1
  stridslysten_1_A = mkA "stridslysten" ; -- stridslysten..av.1
  stridslystnad_1_N = mkN "stridslystnad" ; -- stridslystnad..nn.1
  stridsman_1_N = mkN "stridsman" "stridsmannen" "stridsmän" "stridsmännen" ; -- stridsman..nn.1
  stridsmedel_1_N = mkN "stridsmedel" neutrum  ; -- stridsmedel..nn.1
  stridsmunderad_1_A = mkA "stridsmunderad" ; -- stridsmunderad..av.1
  stridsmundering_1_N = mkN "stridsmundering" ; -- stridsmundering..nn.1
  stridsmässig_1_A = mkA "stridsmässig" ; -- stridsmässig..av.1
  stridspitt_1_N = mkN "stridspitt" ; -- stridspitt..nn.1
  stridsplats_1_N = mkN "stridsplats" "stridsplatser" ; -- stridsplats..nn.1
  stridsrop_1_N = mkN "stridsrop" neutrum  ; -- stridsrop..nn.1
  stridssele_1_N = mkN "stridssele" utrum  ; -- stridssele..nn.1
  stridsskjutning_1_N = mkN "stridsskjutning" ; -- stridsskjutning..nn.1
  stridsskrift_1_N = mkN "stridsskrift" "stridsskrifter" ; -- stridsskrift..nn.1
  stridsspets_1_N = mkN "stridsspets" ; -- stridsspets..nn.1
  stridsställning_1_N = mkN "stridsställning" ; -- stridsställning..nn.1
  stridstummel_1_N = mkN "stridstummel" neutrum  ; -- stridstummel..nn.1
  stridstupp_1_N = mkN "stridstupp" ; -- stridstupp..nn.1
  stridsuppställning_1_N = mkN "stridsuppställning" ; -- stridsuppställning..nn.1
  stridsutrustad_1_A = mkA "stridsutrustad" ; -- stridsutrustad..av.1
  stridsvagn_1_N = mkN "stridsvagn" ; -- stridsvagn..nn.1
  stridsvagnsdrivning_1_N = mkN "stridsvagnsdrivning" ; -- stridsvagnsdrivning..nn.1
  stridsvagnshinder_1_N = mkN "stridsvagnshinder" neutrum  ; -- stridsvagnshinder..nn.1
  stridsvan_1_A = mkA "stridsvan" ; -- stridsvan..av.1
  stridsvana_1_N = mkN "stridsvana" ; -- stridsvana..nn.1
  stridsvimmel_1_N = mkN "stridsvimmel" neutrum  ; -- stridsvimmel..nn.1
  stridsvärn_1_N = mkN "stridsvärn" neutrum  ; -- stridsvärn..nn.1
  stridsyxa_1_N = mkN "stridsyxa" ; -- stridsyxa..nn.1
  stridszon_1_N = mkN "stridszon" "stridszoner" ; -- stridszon..nn.1
  stridsäpple_1_N = mkN "stridsäpple" ; -- stridsäpple..nn.1
  stridsåtgärd_1_N = mkN "stridsåtgärd" "stridsåtgärder" ; -- stridsåtgärd..nn.1
  stridulation_1_N = mkN "stridulation" ; -- stridulation..nn.1
  striga_1_N = mkN "striga" ; -- striga..nn.1
  strigel_1_N = mkN "strigel" ; -- strigel..nn.1
  strigla_1_V = mkV "striglar" ; -- strigla..vb.1
  striglande_1_N = mkN "striglande" ; -- striglande..nn.1
  strike_1_N = mkN "strike" "strikeen" "strikear" "strikearna" ; -- strike..nn.1
  strikt_1_A = mkA "strikt" "strikt" ; -- strikt..av.1
  strikthet_1_N = mkN "strikthet" ; -- strikthet..nn.1
  striktion_1_N = mkN "striktion" ; -- striktion..nn.1
  stril_1_N = mkN "stril" ; -- stril..nn.1
  strila_1_V = mkV "strilar" ; -- strila..vb.1
  strilande_1_N = mkN "strilande" ; -- strilande..nn.1
  strimla_1_N = mkN "strimla" ; -- strimla..nn.1
  strimla_1_V = mkV "strimlar" ; -- strimla..vb.1
  strimlande_1_N = mkN "strimlande" ; -- strimlande..nn.1
  strimma_1_N = mkN "strimma" ; -- strimma..nn.1
  strimmad_1_A = mkA "strimmad" ; -- strimmad..av.1
  strimmig_1_A = mkA "strimmig" ; -- strimmig..av.1
  strimmighet_1_N = mkN "strimmighet" ; -- strimmighet..nn.1
  stringens_1_N = mkN "stringens" ; -- stringens..nn.1
  stringent_1_A = mkA "stringent" "stringent" ; -- stringent..av.1
  stringenthet_1_N = mkN "stringenthet" ; -- stringenthet..nn.1
  stringhylla_1_N = mkN "stringhylla" ; -- stringhylla..nn.1
  stringtrosa_1_N = mkN "stringtrosa" ; -- stringtrosa..nn.1
  strip_tease_1_N = mkN "strip-tease" utrum  ; -- strip-tease..nn.1
  stripa_1_N = mkN "stripa" ; -- stripa..nn.1
  stripa_1_V = mkV "stripar" ; -- stripa..vb.1
  stripande_1_N = mkN "stripande" ; -- stripande..nn.1
  stripig_1_A = mkA "stripig" ; -- stripig..av.1
  stripp_1_N = mkN "stripp" ; -- stripp..nn.1
  strippa_1_N = mkN "strippa" ; -- strippa..nn.1
  strippa_1_V = mkV "strippar" ; -- strippa..vb.1
  strippande_1_N = mkN "strippande" ; -- strippande..nn.1
  strippklubb_1_N = mkN "strippklubb" ; -- strippklubb..nn.1
  strippning_1_N = mkN "strippning" ; -- strippning..nn.1
  stripporgie_1_N = mkN "stripporgie" "stripporgier" ; -- stripporgie..nn.1
  strippshow_1_N = mkN "strippshow" "strippshower" ; -- strippshow..nn.1
  strippstång_1_N = mkN "strippstång" "strippstänger" ; -- strippstång..nn.1
  striptease_1_N = mkN "striptease" utrum  ; -- striptease..nn.1
  strit_1_N = mkN "strit" ; -- strit..nn.1
  stroboskop_1_N = mkN "stroboskop" neutrum  ; -- stroboskop..nn.1
  stroboskopi_1_N = mkN "stroboskopi" "stroboskopier" ; -- stroboskopi..nn.1
  strof_1_N = mkN "strof" "strofer" ; -- strof..nn.1
  strofisk_1_A = mkA "strofisk" ; -- strofisk..av.1
  strofpar_1_N = mkN "strofpar" neutrum  ; -- strofpar..nn.1
  stroke_1_N = mkN "stroke" "stroket" "stroke" "stroken" ; -- stroke..nn.1
  stroke_2_N = mkN "stroke" "stroken" "strokes" "strokesarna" ; -- stroke..nn.2
  strokebehandling_1_N = mkN "strokebehandling" ; -- strokebehandling..nn.1
  strokekris_1_N = mkN "strokekris" "strokekriser" ; -- strokekris..nn.1
  strong_1_A = mkA "strong" ; -- strong..av.1
  stronghet_1_N = mkN "stronghet" ; -- stronghet..nn.1
  strontium_1_N = mkN "strontium" neutrum  ; -- strontium..nn.1
  strontiumförening_1_N = mkN "strontiumförening" ; -- strontiumförening..nn.1
  stropp_1_N = mkN "stropp" ; -- stropp..nn.1
  stroppig_1_A = mkA "stroppig" ; -- stroppig..av.1
  stroppighet_1_N = mkN "stroppighet" ; -- stroppighet..nn.1
  strosa_1_V = mkV "strosar" ; -- strosa..vb.1
  strosande_1_N = mkN "strosande" ; -- strosande..nn.1
  stross_1_N = mkN "stross" ; -- stross..nn.1
  strudel_1_N = mkN "strudel" ; -- strudel..nn.1
  struktur_1_N = mkN "struktur" "strukturer" ; -- struktur..nn.1
  strukturalism_1_N = mkN "strukturalism" "strukturalismer" ; -- strukturalism..nn.1
  strukturalist_1_N = mkN "strukturalist" "strukturalister" ; -- strukturalist..nn.1
  strukturalistisk_1_A = mkA "strukturalistisk" ; -- strukturalistisk..av.1
  strukturarbetslöshet_1_N = mkN "strukturarbetslöshet" "strukturarbetslösheter" ; -- strukturarbetslöshet..nn.1
  strukturell_1_A = mkA "strukturell" ; -- strukturell..av.1
  strukturera_1_V = mkV "strukturerar" ; -- strukturera..vb.1
  strukturerande_1_N = mkN "strukturerande" ; -- strukturerande..nn.1
  strukturerbar_1_A = mkA "strukturerbar" ; -- strukturerbar..av.1
  strukturerbarhet_1_N = mkN "strukturerbarhet" ; -- strukturerbarhet..nn.1
  strukturering_1_N = mkN "strukturering" ; -- strukturering..nn.1
  strukturfond_1_N = mkN "strukturfond" "strukturfonder" ; -- strukturfond..nn.1
  strukturformel_1_N = mkN "strukturformel" "strukturformeln" "strukturformler" "strukturformlerna" ; -- strukturformel..nn.1
  strukturförändring_1_N = mkN "strukturförändring" ; -- strukturförändring..nn.1
  strukturmodell_1_N = mkN "strukturmodell" "strukturmodeller" ; -- strukturmodell..nn.1
  strukturomvandling_1_N = mkN "strukturomvandling" ; -- strukturomvandling..nn.1
  strukturpolitisk_1_A = mkA "strukturpolitisk" ; -- strukturpolitisk..av.1
  strukturrationalisera_1_V = mkV "strukturrationaliserar" ; -- strukturrationalisera..vb.1
  strukturrationaliserande_1_N = mkN "strukturrationaliserande" ; -- strukturrationaliserande..nn.1
  strukturrationaliserbar_1_A = mkA "strukturrationaliserbar" ; -- strukturrationaliserbar..av.1
  strukturrationaliserbarhet_1_N = mkN "strukturrationaliserbarhet" ; -- strukturrationaliserbarhet..nn.1
  strukturrationalisering_1_N = mkN "strukturrationalisering" ; -- strukturrationalisering..nn.1
  strul_1_N = mkN "strul" neutrum  ; -- strul..nn.1
  strula_1_V = mkV "strular" ; -- strula..vb.1
  strulande_1_N = mkN "strulande" ; -- strulande..nn.1
  strulig_1_A = mkA "strulig" ; -- strulig..av.1
  strulighet_1_N = mkN "strulighet" "struligheter" ; -- strulighet..nn.1
  struma_1_N = mkN "struma" ; -- struma..nn.1
  strumaartad_1_A = mkA "strumaartad" ; -- strumaartad..av.1
  strumpa_1_N = mkN "strumpa" ; -- strumpa..nn.1
  strumpbyxa_1_N = mkN "strumpbyxa" ; -- strumpbyxa..nn.1
  strumpeband_1_N = mkN "strumpeband" neutrum  ; -- strumpeband..nn.1
  strumpebandshållare_1_N = mkN "strumpebandshållare" utrum  ; -- strumpebandshållare..nn.1
  strumpebandsorden_1_N = mkN "strumpebandsorden" ; -- strumpebandsorden..nn.1
  strumpfot_1_N = mkN "strumpfot" "strumpfötter" ; -- strumpfot..nn.1
  strumphäl_1_N = mkN "strumphäl" ; -- strumphäl..nn.1
  strumphållare_1_N = mkN "strumphållare" utrum  ; -- strumphållare..nn.1
  strumpklädd_1_A = mkA "strumpklädd" ; -- strumpklädd..av.1
  strumpläst_1_N = mkN "strumpläst" ; -- strumpläst..nn.1
  strumpsticka_1_N = mkN "strumpsticka" ; -- strumpsticka..nn.1
  strumpstoppning_1_N = mkN "strumpstoppning" ; -- strumpstoppning..nn.1
  strunt_1_N = mkN "strunt" neutrum  ; -- strunt..nn.1
  strunta_1_V = mkV "struntar" ; -- strunta..vb.1
  struntande_1_N = mkN "struntande" ; -- struntande..nn.1
  struntfin_1_A = mkA "struntfin" ; -- struntfin..av.1
  struntförnäm_1_A = mkA "struntförnäm" ; -- struntförnäm..av.1
  struntförnämhet_1_N = mkN "struntförnämhet" ; -- struntförnämhet..nn.1
  struntprat_1_N = mkN "struntprat" neutrum  ; -- struntprat..nn.1
  struntsak_1_N = mkN "struntsak" "struntsaker" ; -- struntsak..nn.1
  struntsamma_1_A = mkA "struntsamma" ; -- struntsamma..av.1
  struntsumma_1_N = mkN "struntsumma" ; -- struntsumma..nn.1
  struntviktig_1_A = mkA "struntviktig" ; -- struntviktig..av.1
  struntviktighet_1_N = mkN "struntviktighet" ; -- struntviktighet..nn.1
  strupcancer_1_N = mkN "strupcancer" ; -- strupcancer..nn.1
  strupe_1_N = mkN "strupe" utrum  ; -- strupe..nn.1
  struphuvud_1_N = mkN "struphuvud" "struphuvudet" "struphuvud" "struphuvudena" ; -- struphuvud..nn.1
  strupkatarr_1_N = mkN "strupkatarr" "strupkatarrer" ; -- strupkatarr..nn.1
  strupljud_1_N = mkN "strupljud" neutrum  ; -- strupljud..nn.1
  struplock_1_N = mkN "struplock" neutrum  ; -- struplock..nn.1
  strupsångare_1_N = mkN "strupsångare" utrum  ; -- strupsångare..nn.1
  strut_1_N = mkN "strut" ; -- strut..nn.1
  strutformig_1_A = mkA "strutformig" ; -- strutformig..av.1
  strutförsedd_1_A = mkA "strutförsedd" ; -- strutförsedd..av.1
  struts_1_N = mkN "struts" ; -- struts..nn.1
  strutsfjäder_1_N = mkN "strutsfjäder" ; -- strutsfjäder..nn.1
  strutsmage_1_N = mkN "strutsmage" utrum  ; -- strutsmage..nn.1
  strutsplym_1_N = mkN "strutsplym" "strutsplymer" ; -- strutsplym..nn.1
  strutspolitik_1_N = mkN "strutspolitik" ; -- strutspolitik..nn.1
  strutsägg_1_N = mkN "strutsägg" neutrum  ; -- strutsägg..nn.1
  strutta_1_V = mkV "struttar" ; -- strutta..vb.1
  struttande_1_N = mkN "struttande" ; -- struttande..nn.1
  struttig_1_A = mkA "struttig" ; -- struttig..av.1
  struttighet_1_N = mkN "struttighet" ; -- struttighet..nn.1
  struva_1_N = mkN "struva" ; -- struva..nn.1
  stryk_1_N = mkN "stryk" neutrum  ; -- stryk..nn.1
  stryka_1_V = mkV "stryka" "strök" "strukit" ; -- stryka..vb.1
  stryka_2_V = mkV "stryka" "strök" "strukit" ; -- stryka..vb.2
  strykande_1_N = mkN "strykande" ; -- strykande..nn.1
  strykare_1_N = mkN "strykare" utrum  ; -- strykare..nn.1
  strykarkatt_1_N = mkN "strykarkatt" "strykarkatter" ; -- strykarkatt..nn.1
  strykbräda_1_N = mkN "strykbräda" ; -- strykbräda..nn.1
  strykbräde_1_N = mkN "strykbräde" ; -- strykbräde..nn.1
  strykerska_1_N = mkN "strykerska" ; -- strykerska..nn.1
  strykfri_1_A = mkA "strykfri" "strykfritt" ; -- strykfri..av.1
  strykfågel_1_N = mkN "strykfågel" ; -- strykfågel..nn.1
  strykjärn_1_N = mkN "strykjärn" neutrum  ; -- strykjärn..nn.1
  strykkappa_1_N = mkN "strykkappa" ; -- strykkappa..nn.1
  stryknin_1_N = mkN "stryknin" ; -- stryknin..nn.1
  stryknindos_1_N = mkN "stryknindos" "stryknindoser" ; -- stryknindos..nn.1
  strykning_1_N = mkN "strykning" ; -- strykning..nn.1
  strykpojke_1_N = mkN "strykpojke" utrum  ; -- strykpojke..nn.1
  strykrum_1_N = mkN "strykrum" "strykrummet" "strykrum" "strykrummen" ; -- strykrum..nn.1
  strykrädd_1_A = mkA "strykrädd" ; -- strykrädd..av.1
  strykräddhet_1_N = mkN "strykräddhet" ; -- strykräddhet..nn.1
  stryksticka_1_N = mkN "stryksticka" ; -- stryksticka..nn.1
  stryktips_1_N = mkN "stryktips" neutrum  ; -- stryktips..nn.1
  stryktvätt_1_N = mkN "stryktvätt" ; -- stryktvätt..nn.1
  stryktäck_1_A = mkA "stryktäck" ; -- stryktäck..av.1
  stryktäckhet_1_N = mkN "stryktäckhet" ; -- stryktäckhet..nn.1
  stryktålig_1_A = mkA "stryktålig" ; -- stryktålig..av.1
  stryktålighet_1_N = mkN "stryktålighet" ; -- stryktålighet..nn.1
  strypa_1_V = mkV "stryper" ; -- strypa..vb.1
  strypande_1_N = mkN "strypande" ; -- strypande..nn.1
  strypare_1_N = mkN "strypare" utrum  ; -- strypare..nn.1
  strypattack_1_N = mkN "strypattack" "strypattacker" ; -- strypattack..nn.1
  strypgrepp_1_N = mkN "strypgrepp" neutrum  ; -- strypgrepp..nn.1
  strypmärke_1_N = mkN "strypmärke" ; -- strypmärke..nn.1
  strypning_1_N = mkN "strypning" ; -- strypning..nn.1
  strypsjuka_1_N = mkN "strypsjuka" ; -- strypsjuka..nn.1
  strypsnara_1_N = mkN "strypsnara" ; -- strypsnara..nn.1
  sträck_1_N = mkN "sträck" neutrum  ; -- sträck..nn.1
  sträcka_1_N = mkN "sträcka" ; -- sträcka..nn.1
  sträcka_1_V = mkV "sträcker" ; -- sträcka..vb.1
  sträckande_1_N = mkN "sträckande" ; -- sträckande..nn.1
  sträckare_1_N = mkN "sträckare" utrum  ; -- sträckare..nn.1
  sträckarmuskel_1_N = mkN "sträckarmuskel" "sträckarmuskeln" "sträckarmuskler" "sträckarmusklerna" ; -- sträckarmuskel..nn.1
  sträckbar_1_A = mkA "sträckbar" ; -- sträckbar..av.1
  sträckbarhet_1_N = mkN "sträckbarhet" ; -- sträckbarhet..nn.1
  sträckbänk_1_N = mkN "sträckbänk" ; -- sträckbänk..nn.1
  sträckförband_1_N = mkN "sträckförband" neutrum  ; -- sträckförband..nn.1
  sträckläsa_1_V = mkV "sträckläser" ; -- sträckläsa..vb.1
  sträckläsande_1_N = mkN "sträckläsande" ; -- sträckläsande..nn.1
  sträckmuskel_1_N = mkN "sträckmuskel" "sträckmuskeln" "sträckmuskler" "sträckmusklerna" ; -- sträckmuskel..nn.1
  sträckning_1_N = mkN "sträckning" ; -- sträckning..nn.1
  sträng_1_A = mkA "sträng" ; -- sträng..av.1
  sträng_1_N = mkN "sträng" ; -- sträng..nn.1
  stränga_1_V = mkV "strängar" ; -- stränga..vb.1
  strängande_1_N = mkN "strängande" ; -- strängande..nn.1
  strängeligen_1_Adv = mkAdv "strängeligen" ; -- strängeligen..ab.1
  stränghet_1_N = mkN "stränghet" ; -- stränghet..nn.1
  stränginstrument_1_N = mkN "stränginstrument" neutrum  ; -- stränginstrument..nn.1
  sträv_1_A = mkA "sträv" ; -- sträv..av.1
  sträva_1_N = mkN "sträva" ; -- sträva..nn.1
  sträva_1_V = mkV "strävar" ; -- sträva..vb.1
  strävande_1_N = mkN "strävande" ; -- strävande..nn.1
  strävbladig_1_A = mkA "strävbladig" ; -- strävbladig..av.1
  strävbåge_1_N = mkN "strävbåge" utrum  ; -- strävbåge..nn.1
  strävhet_1_N = mkN "strävhet" ; -- strävhet..nn.1
  strävhårig_1_A = mkA "strävhårig" ; -- strävhårig..av.1
  strävhårighet_1_N = mkN "strävhårighet" ; -- strävhårighet..nn.1
  strävig_1_A = mkA "strävig" ; -- strävig..av.1
  strävpelare_1_N = mkN "strävpelare" utrum  ; -- strävpelare..nn.1
  strävsam_1_A = mkA "strävsam" "strävsamt" "strävsamma" "strävsamma" "strävsammare" "strävsammast" "strävsammaste" ; -- strävsam..av.1
  strävsamhet_1_N = mkN "strävsamhet" ; -- strävsamhet..nn.1
  strå_1_N = mkN "strå" "stråt" "strån" "stråna" ; -- strå..nn.1
  stråbassjukdom_1_N = mkN "stråbassjukdom" ; -- stråbassjukdom..nn.1
  strådöd_1_N = mkN "strådöd" ; -- strådöd..nn.1
  stråfoder_1_N = mkN "stråfoder" neutrum  ; -- stråfoder..nn.1
  stråhatt_1_N = mkN "stråhatt" ; -- stråhatt..nn.1
  stråk_1_N = mkN "stråk" neutrum  ; -- stråk..nn.1
  stråkdrag_1_N = mkN "stråkdrag" neutrum  ; -- stråkdrag..nn.1
  stråke_1_N = mkN "stråke" utrum  ; -- stråke..nn.1
  stråkinstrument_1_N = mkN "stråkinstrument" neutrum  ; -- stråkinstrument..nn.1
  stråkkvartett_1_N = mkN "stråkkvartett" "stråkkvartetter" ; -- stråkkvartett..nn.1
  stråkmusik_1_N = mkN "stråkmusik" ; -- stråkmusik..nn.1
  stråkorkester_1_N = mkN "stråkorkester" ; -- stråkorkester..nn.1
  stråla_1_V = mkV "strålar" ; -- stråla..vb.1
  strålande_1_A = mkA "strålande" ; -- strålande..av.1
  strålande_1_N = mkN "strålande" ; -- strålande..nn.1
  strålbehandla_1_V = mkV "strålbehandlar" ; -- strålbehandla..vb.1
  strålbehandlande_1_N = mkN "strålbehandlande" ; -- strålbehandlande..nn.1
  strålbehandling_1_N = mkN "strålbehandling" ; -- strålbehandling..nn.1
  strålben_1_N = mkN "strålben" neutrum  ; -- strålben..nn.1
  strålblomma_1_N = mkN "strålblomma" ; -- strålblomma..nn.1
  strålbrytning_1_N = mkN "strålbrytning" ; -- strålbrytning..nn.1
  stråldjur_1_N = mkN "stråldjur" neutrum  ; -- stråldjur..nn.1
  stråldos_1_N = mkN "stråldos" "stråldoser" ; -- stråldos..nn.1
  stråle_1_N = mkN "stråle" utrum  ; -- stråle..nn.1
  strålfenig_1_A = mkA "strålfenig" ; -- strålfenig..av.1
  strålglans_1_N = mkN "strålglans" ; -- strålglans..nn.1
  strålgloria_1_N = mkN "strålgloria" ; -- strålgloria..nn.1
  strålgångsmätare_1_N = mkN "strålgångsmätare" utrum  ; -- strålgångsmätare..nn.1
  strålkastare_1_N = mkN "strålkastare" utrum  ; -- strålkastare..nn.1
  strålkastarljus_1_N = mkN "strålkastarljus" neutrum  ; -- strålkastarljus..nn.1
  strålkastarljus_2_N = mkN "strålkastarljus" neutrum  ; -- strålkastarljus..nn.2
  strålkastarsken_1_N = mkN "strålkastarsken" neutrum  ; -- strålkastarsken..nn.1
  strålknippe_1_N = mkN "strålknippe" ; -- strålknippe..nn.1
  strålkniv_1_N = mkN "strålkniv" ; -- strålkniv..nn.1
  strålkonservera_1_V = mkV "strålkonserverar" ; -- strålkonservera..vb.1
  strålkonserverande_1_N = mkN "strålkonserverande" ; -- strålkonserverande..nn.1
  strålkonserverbar_1_A = mkA "strålkonserverbar" ; -- strålkonserverbar..av.1
  strålkonserverbarhet_1_N = mkN "strålkonserverbarhet" ; -- strålkonserverbarhet..nn.1
  strålkonservering_1_N = mkN "strålkonservering" ; -- strålkonservering..nn.1
  strålkrans_1_N = mkN "strålkrans" ; -- strålkrans..nn.1
  strålkropp_1_N = mkN "strålkropp" ; -- strålkropp..nn.1
  strålning_1_N = mkN "strålning" ; -- strålning..nn.1
  strålningsarbete_1_N = mkN "strålningsarbete" ; -- strålningsarbete..nn.1
  strålningsbiologi_1_N = mkN "strålningsbiologi" ; -- strålningsbiologi..nn.1
  strålningsbälte_1_N = mkN "strålningsbälte" ; -- strålningsbälte..nn.1
  strålningsdos_1_N = mkN "strålningsdos" "strålningsdoser" ; -- strålningsdos..nn.1
  strålningseffekt_1_N = mkN "strålningseffekt" "strålningseffekter" ; -- strålningseffekt..nn.1
  strålningsegenskap_1_N = mkN "strålningsegenskap" "strålningsegenskaper" ; -- strålningsegenskap..nn.1
  strålningsera_1_N = mkN "strålningsera" ; -- strålningsera..nn.1
  strålningsfri_1_A = mkA "strålningsfri" "strålningsfritt" ; -- strålningsfri..av.1
  strålningskemi_1_N = mkN "strålningskemi" ; -- strålningskemi..nn.1
  strålningskommitté_1_N = mkN "strålningskommitté" "strålningskommittéer" ; -- strålningskommitté..nn.1
  strålningskvantum_1_N = mkN "strålningskvantum" neutrum  ; -- strålningskvantum..nn.1
  strålningsskadad_1_A = mkA "strålningsskadad" ; -- strålningsskadad..av.1
  strålningsspektrum_1_N = mkN "strålningsspektrum" neutrum  ; -- strålningsspektrum..nn.1
  strålningssäker_1_A = mkA "strålningssäker" ; -- strålningssäker..av.1
  strålningssäkerhet_1_N = mkN "strålningssäkerhet" ; -- strålningssäkerhet..nn.1
  strålningstryck_1_N = mkN "strålningstryck" neutrum  ; -- strålningstryck..nn.1
  strålorsakad_1_A = mkA "strålorsakad" ; -- strålorsakad..av.1
  strålputa_1_N = mkN "strålputa" ; -- strålputa..nn.1
  strålrisk_1_N = mkN "strålrisk" "strålrisker" ; -- strålrisk..nn.1
  strålsjuka_1_N = mkN "strålsjuka" ; -- strålsjuka..nn.1
  strålskada_1_N = mkN "strålskada" ; -- strålskada..nn.1
  strålskydd_1_N = mkN "strålskydd" neutrum  ; -- strålskydd..nn.1
  strålskyddsarbete_1_N = mkN "strålskyddsarbete" ; -- strålskyddsarbete..nn.1
  strålskyddsinstitut_1_N = mkN "strålskyddsinstitut" neutrum  ; -- strålskyddsinstitut..nn.1
  strålskyddsmyndighet_1_N = mkN "strålskyddsmyndighet" "strålskyddsmyndigheter" ; -- strålskyddsmyndighet..nn.1
  strålsvamp_1_N = mkN "strålsvamp" ; -- strålsvamp..nn.1
  strålsvampsjuka_1_N = mkN "strålsvampsjuka" ; -- strålsvampsjuka..nn.1
  strålsäkerhetsmyndighet_1_N = mkN "strålsäkerhetsmyndighet" "strålsäkerhetsmyndigheter" ; -- strålsäkerhetsmyndighet..nn.1
  stråmatta_1_N = mkN "stråmatta" ; -- stråmatta..nn.1
  stråröta_1_N = mkN "stråröta" ; -- stråröta..nn.1
  stråsäd_1_N = mkN "stråsäd" ; -- stråsäd..nn.1
  stråt_1_N = mkN "stråt" ; -- stråt..nn.1
  stråtrövare_1_N = mkN "stråtrövare" utrum  ; -- stråtrövare..nn.1
  stråtröveri_1_N = mkN "stråtröveri" neutrum  ; -- stråtröveri..nn.1
  strö_1_N = mkN "strö" neutrum  ; -- strö..nn.1
  strö_1_V = mkV "strör" ; -- strö..vb.1
  ströare_1_N = mkN "ströare" utrum  ; -- ströare..nn.1
  ströbröd_1_N = mkN "ströbröd" neutrum  ; -- ströbröd..nn.1
  strödd_1_A = mkA "strödd" ; -- strödd..av.1
  ströende_1_N = mkN "ströende" ; -- ströende..nn.1
  ströfynd_1_N = mkN "ströfynd" neutrum  ; -- ströfynd..nn.1
  strög_1_N = mkN "strög" neutrum  ; -- strög..nn.1
  ströhalm_1_N = mkN "ströhalm" ; -- ströhalm..nn.1
  ströjobb_1_N = mkN "ströjobb" neutrum  ; -- ströjobb..nn.1
  strökund_1_N = mkN "strökund" "strökunder" ; -- strökund..nn.1
  strökurs_1_N = mkN "strökurs" "strökurser" ; -- strökurs..nn.1
  ström_1_A = mkA "ström" ; -- ström..av.1
  ström_1_N = mkN "ström" "strömmen" "strömmar" "strömmarna" ; -- ström..nn.1
  strömavbrott_1_N = mkN "strömavbrott" neutrum  ; -- strömavbrott..nn.1
  strömavtagare_1_N = mkN "strömavtagare" utrum  ; -- strömavtagare..nn.1
  strömbrytare_1_N = mkN "strömbrytare" utrum  ; -- strömbrytare..nn.1
  strömbrytarknapp_1_N = mkN "strömbrytarknapp" ; -- strömbrytarknapp..nn.1
  strömdrag_1_N = mkN "strömdrag" neutrum  ; -- strömdrag..nn.1
  strömfall_1_N = mkN "strömfall" neutrum  ; -- strömfall..nn.1
  strömfåra_1_N = mkN "strömfåra" ; -- strömfåra..nn.1
  strömförande_1_A = mkA "strömförande" ; -- strömförande..av.1
  strömförsörjning_1_N = mkN "strömförsörjning" ; -- strömförsörjning..nn.1
  strömförträngning_1_N = mkN "strömförträngning" ; -- strömförträngning..nn.1
  strömhopp_1_N = mkN "strömhopp" neutrum  ; -- strömhopp..nn.1
  strömkantring_1_N = mkN "strömkantring" ; -- strömkantring..nn.1
  strömkarl_1_N = mkN "strömkarl" ; -- strömkarl..nn.1
  strömkrets_1_N = mkN "strömkrets" ; -- strömkrets..nn.1
  strömkälla_1_N = mkN "strömkälla" ; -- strömkälla..nn.1
  strömledande_1_A = mkA "strömledande" ; -- strömledande..av.1
  strömledning_1_N = mkN "strömledning" ; -- strömledning..nn.1
  strömlinjeformad_1_A = mkA "strömlinjeformad" ; -- strömlinjeformad..av.1
  strömlös_1_A = mkA "strömlös" ; -- strömlös..av.1
  strömlöshet_1_N = mkN "strömlöshet" ; -- strömlöshet..nn.1
  strömma_1_V = mkV "strömmar" ; -- strömma..vb.1
  strömma_2_V = mkV "strömmar" ; -- strömma..vb.2
  strömmande_1_N = mkN "strömmande" ; -- strömmande..nn.1
  strömming_1_N = mkN "strömming" ; -- strömming..nn.1
  strömmingsfilé_1_N = mkN "strömmingsfilé" "strömmingsfiléer" ; -- strömmingsfilé..nn.1
  strömmingsfiske_1_N = mkN "strömmingsfiske" ; -- strömmingsfiske..nn.1
  strömmingsflundra_1_N = mkN "strömmingsflundra" ; -- strömmingsflundra..nn.1
  strömmätare_1_N = mkN "strömmätare" utrum  ; -- strömmätare..nn.1
  strömning_1_N = mkN "strömning" ; -- strömning..nn.1
  strömningsmotstånd_1_N = mkN "strömningsmotstånd" neutrum  ; -- strömningsmotstånd..nn.1
  strömoln_1_N = mkN "strömoln" neutrum  ; -- strömoln..nn.1
  strömring_1_N = mkN "strömring" ; -- strömring..nn.1
  strömstare_1_N = mkN "strömstare" "strömstarar" ; -- strömstare..nn.1
  strömstyrka_1_N = mkN "strömstyrka" ; -- strömstyrka..nn.1
  strömställare_1_N = mkN "strömställare" utrum  ; -- strömställare..nn.1
  strömuttag_1_N = mkN "strömuttag" neutrum  ; -- strömuttag..nn.1
  strömvirvel_1_N = mkN "strömvirvel" ; -- strömvirvel..nn.1
  strömvärme_1_N = mkN "strömvärme" ; -- strömvärme..nn.1
  ströppla_1_V = mkV "ströpplar" ; -- ströppla..vb.1
  ströpplande_1_N = mkN "ströpplande" ; -- ströpplande..nn.1
  strösocker_1_N = mkN "strösocker" neutrum  ; -- strösocker..nn.1
  strössel_1_N = mkN "strössel" ; -- strössel..nn.1
  ströva_1_V = mkV "strövar" ; -- ströva..vb.1
  strövande_1_N = mkN "strövande" ; -- strövande..nn.1
  strövare_1_N = mkN "strövare" utrum  ; -- strövare..nn.1
  ströveri_1_N = mkN "ströveri" neutrum  ; -- ströveri..nn.1
  strövområde_1_N = mkN "strövområde" ; -- strövområde..nn.1
  strövtåg_1_N = mkN "strövtåg" neutrum  ; -- strövtåg..nn.1
  stubb_1_N = mkN "stubb" ; -- stubb..nn.1
  stubba_1_V = mkV "stubbar" ; -- stubba..vb.1
  stubbad_1_A = mkA "stubbad" ; -- stubbad..av.1
  stubbande_1_N = mkN "stubbande" ; -- stubbande..nn.1
  stubbe_1_N = mkN "stubbe" utrum  ; -- stubbe..nn.1
  stubbig_1_A = mkA "stubbig" ; -- stubbig..av.1
  stubbighet_1_N = mkN "stubbighet" ; -- stubbighet..nn.1
  stubbkvarn_1_N = mkN "stubbkvarn" ; -- stubbkvarn..nn.1
  stubbsvans_1_N = mkN "stubbsvans" ; -- stubbsvans..nn.1
  stubbsvansig_1_A = mkA "stubbsvansig" ; -- stubbsvansig..av.1
  stubbåker_1_N = mkN "stubbåker" ; -- stubbåker..nn.1
  stubin_1_N = mkN "stubin" "stubiner" ; -- stubin..nn.1
  stuck_1_N = mkN "stuck" "stucker" ; -- stuck..nn.1
  stuckatur_1_N = mkN "stuckatur" "stuckaturer" ; -- stuckatur..nn.1
  stuckatör_1_N = mkN "stuckatör" "stuckatörer" ; -- stuckatör..nn.1
  stucken_1_A = mkA "stucken" ; -- stucken..av.1
  stuckenhet_1_N = mkN "stuckenhet" ; -- stuckenhet..nn.1
  student_1_N = mkN "student" "studenter" ; -- student..nn.1
  studentbetyg_1_N = mkN "studentbetyg" neutrum  ; -- studentbetyg..nn.1
  studentbostad_1_N = mkN "studentbostad" "studentbostäder" ; -- studentbostad..nn.1
  studentexamen_1_N = mkN "studentexamen" "studentexamen" "studentexamina" "studentexamina" ; -- studentexamen..nn.1
  studentfirande_1_N = mkN "studentfirande" ; -- studentfirande..nn.1
  studentflak_1_N = mkN "studentflak" neutrum  ; -- studentflak..nn.1
  studenthem_1_N = mkN "studenthem" "studenthemmet" "studenthem" "studenthemmen" ; -- studenthem..nn.1
  studentikos_1_A = mkA "studentikos" ; -- studentikos..av.1
  studentinflytande_1_N = mkN "studentinflytande" ; -- studentinflytande..nn.1
  studentkår_1_N = mkN "studentkår" "studentkårer" ; -- studentkår..nn.1
  studentliv_1_N = mkN "studentliv" neutrum  ; -- studentliv..nn.1
  studentmössa_1_N = mkN "studentmössa" ; -- studentmössa..nn.1
  studentnation_1_N = mkN "studentnation" ; -- studentnation..nn.1
  studentprenumeration_1_N = mkN "studentprenumeration" ; -- studentprenumeration..nn.1
  studentrevolt_1_N = mkN "studentrevolt" "studentrevolter" ; -- studentrevolt..nn.1
  studentrum_1_N = mkN "studentrum" "studentrummet" "studentrum" "studentrummen" ; -- studentrum..nn.1
  studentsång_1_N = mkN "studentsång" "studentsånger" ; -- studentsång..nn.1
  studentteater_1_N = mkN "studentteater" ; -- studentteater..nn.1
  studenttillströmning_1_N = mkN "studenttillströmning" ; -- studenttillströmning..nn.1
  studera_1_V = mkV "studerar" ; -- studera..vb.1
  studerad_1_A = mkA "studerad" ; -- studerad..av.1
  studerande_1_N = mkN "studerande" "studeranden" "studeranden" "studerandena" ; -- studerande..nn.1
  studerande_2_N = mkN "studerande" ; -- studerande..nn.2
  studerbar_1_A = mkA "studerbar" ; -- studerbar..av.1
  studerbarhet_1_N = mkN "studerbarhet" ; -- studerbarhet..nn.1
  studering_1_N = mkN "studering" ; -- studering..nn.1
  studerkammare_1_N = mkN "studerkammare" "studerkammaren" "studerkammare" "studerkamrarna" ; -- studerkammare..nn.1
  studie_1_N = mkN "studie" "studier" ; -- studie..nn.1
  studiebesök_1_N = mkN "studiebesök" neutrum  ; -- studiebesök..nn.1
  studiebidrag_1_N = mkN "studiebidrag" neutrum  ; -- studiebidrag..nn.1
  studiecirkel_1_N = mkN "studiecirkel" ; -- studiecirkel..nn.1
  studiedag_1_N = mkN "studiedag" ; -- studiedag..nn.1
  studieförberedande_1_A = mkA "studieförberedande" ; -- studieförberedande..av.1
  studieförbund_1_N = mkN "studieförbund" neutrum  ; -- studieförbund..nn.1
  studiegrupp_1_N = mkN "studiegrupp" "studiegrupper" ; -- studiegrupp..nn.1
  studiehjälp_1_N = mkN "studiehjälp" ; -- studiehjälp..nn.1
  studiekurs_1_N = mkN "studiekurs" "studiekurser" ; -- studiekurs..nn.1
  studielån_1_N = mkN "studielån" neutrum  ; -- studielån..nn.1
  studiemedel_1_N = mkN "studiemedel" neutrum  ; -- studiemedel..nn.1
  studiemotiverad_1_A = mkA "studiemotiverad" ; -- studiemotiverad..av.1
  studiemässig_1_A = mkA "studiemässig" ; -- studiemässig..av.1
  studieobjekt_1_N = mkN "studieobjekt" neutrum  ; -- studieobjekt..nn.1
  studieorientera_1_V = mkV "studieorienterar" ; -- studieorientera..vb.1
  studieorienterande_1_N = mkN "studieorienterande" ; -- studieorienterande..nn.1
  studieorienterbar_1_A = mkA "studieorienterbar" ; -- studieorienterbar..av.1
  studieorienterbarhet_1_N = mkN "studieorienterbarhet" ; -- studieorienterbarhet..nn.1
  studieorientering_1_N = mkN "studieorientering" ; -- studieorientering..nn.1
  studieovan_1_A = mkA "studieovan" ; -- studieovan..av.1
  studieovana_1_N = mkN "studieovana" ; -- studieovana..nn.1
  studiepenning_1_N = mkN "studiepenning" ; -- studiepenning..nn.1
  studieplan_1_N = mkN "studieplan" "studieplaner" ; -- studieplan..nn.1
  studieplats_1_N = mkN "studieplats" "studieplatser" ; -- studieplats..nn.1
  studierektor_1_N = mkN "studierektor" "studierektorer" ; -- studierektor..nn.1
  studieresa_1_N = mkN "studieresa" ; -- studieresa..nn.1
  studieskuld_1_N = mkN "studieskuld" "studieskulder" ; -- studieskuld..nn.1
  studiesocial_1_A = mkA "studiesocial" ; -- studiesocial..av.1
  studiestöd_1_N = mkN "studiestöd" neutrum  ; -- studiestöd..nn.1
  studietid_1_N = mkN "studietid" "studietider" ; -- studietid..nn.1
  studietradition_1_N = mkN "studietradition" ; -- studietradition..nn.1
  studieväg_1_N = mkN "studieväg" ; -- studieväg..nn.1
  studievägledare_1_N = mkN "studievägledare" utrum  ; -- studievägledare..nn.1
  studieår_1_N = mkN "studieår" neutrum  ; -- studieår..nn.1
  studio_1_N = mkN "studio" "studior" ; -- studio..nn.1
  studioalbum_1_N = mkN "studioalbum" neutrum  ; -- studioalbum..nn.1
  studioinspelning_1_N = mkN "studioinspelning" ; -- studioinspelning..nn.1
  studioman_1_N = mkN "studioman" "studiomannen" "studiomän" "studiomännen" ; -- studioman..nn.1
  studiomusiker_1_N = mkN "studiomusiker" "studiomusikern" "studiomusiker" "studiomusikerna" ; -- studiomusiker..nn.1
  studiomässig_1_A = mkA "studiomässig" ; -- studiomässig..av.1
  studiosamtal_1_N = mkN "studiosamtal" neutrum  ; -- studiosamtal..nn.1
  studiosus_1_N = mkN "studiosus" "studiosus" "studiosi" "studiosina" ; -- studiosus..nn.1
  studium_1_N = mkN "studium" "studiet" "studier" "studierna" ; -- studium..nn.1
  studs_1_N = mkN "studs" ; -- studs..nn.1
  studsa_1_V = mkV "studsar" ; -- studsa..vb.1
  studsande_1_N = mkN "studsande" ; -- studsande..nn.1
  studsare_1_N = mkN "studsare" utrum  ; -- studsare..nn.1
  studsmatta_1_N = mkN "studsmatta" ; -- studsmatta..nn.1
  studsning_1_N = mkN "studsning" ; -- studsning..nn.1
  stuff_1_N = mkN "stuff" "stuffer" ; -- stuff..nn.1
  stuga_1_N = mkN "stuga" ; -- stuga..nn.1
  stugby_1_N = mkN "stugby" "stugbyn" "stugbyar" "stugbyarna" ; -- stugby..nn.1
  stugdörr_1_N = mkN "stugdörr" ; -- stugdörr..nn.1
  stugfönster_1_N = mkN "stugfönster" neutrum  ; -- stugfönster..nn.1
  stugknut_1_N = mkN "stugknut" ; -- stugknut..nn.1
  stugköp_1_N = mkN "stugköp" neutrum  ; -- stugköp..nn.1
  stugsittare_1_N = mkN "stugsittare" utrum  ; -- stugsittare..nn.1
  stugvärme_1_N = mkN "stugvärme" utrum  ; -- stugvärme..nn.1
  stuka_1_V = mkV "stukar" ; -- stuka..vb.1
  stukande_1_N = mkN "stukande" ; -- stukande..nn.1
  stukning_1_N = mkN "stukning" ; -- stukning..nn.1
  stulta_1_N = mkN "stulta" ; -- stulta..nn.1
  stulta_1_V = mkV "stultar" ; -- stulta..vb.1
  stultande_1_N = mkN "stultande" ; -- stultande..nn.1
  stum_1_A = mkA "stum" "stumt" "stumma" "stumma" "stummare" "stummast" "stummaste" ; -- stum..av.1
  stumfilm_1_N = mkN "stumfilm" "stumfilmer" ; -- stumfilm..nn.1
  stumfilmsmässig_1_A = mkA "stumfilmsmässig" ; -- stumfilmsmässig..av.1
  stumhet_1_N = mkN "stumhet" "stumheter" ; -- stumhet..nn.1
  stump_1_N = mkN "stump" ; -- stump..nn.1
  stumpa_1_N = mkN "stumpa" ; -- stumpa..nn.1
  stund_1_N = mkN "stund" "stunder" ; -- stund..nn.1
  stunda_1_V = mkV "stundar" ; -- stunda..vb.1
  stundande_1_N = mkN "stundande" ; -- stundande..nn.1
  stundlig_1_A = mkA "stundlig" ; -- stundlig..av.1
  stundligen_1_Adv = mkAdv "stundligen" ; -- stundligen..ab.1
  stundlighet_1_N = mkN "stundlighet" ; -- stundlighet..nn.1
  stundom_1_Adv = mkAdv "stundom" ; -- stundom..ab.1
  stundtals_1_Adv = mkAdv "stundtals" ; -- stundtals..ab.1
  stundvis_1_Adv = mkAdv "stundvis" ; -- stundvis..ab.1
  stundvis_1_A = mkA "stundvis" ; -- stundvis..av.1
  stuns_1_N = mkN "stuns" ; -- stuns..nn.1
  stuntman_1_N = mkN "stuntman" "stuntmannen" "stuntmän" "stuntmännen" ; -- stuntman..nn.1
  stunttrick_1_N = mkN "stunttrick" neutrum  ; -- stunttrick..nn.1
  stup_1_N = mkN "stup" neutrum  ; -- stup..nn.1
  stupa_1_N = mkN "stupa" ; -- stupa..nn.1
  stupa_2_N = mkN "stupa" ; -- stupa..nn.2
  stupa_1_V = mkV "stupar" ; -- stupa..vb.1
  stupande_1_N = mkN "stupande" ; -- stupande..nn.1
  stupfull_1_A = mkA "stupfull" ; -- stupfull..av.1
  stupfullhet_1_N = mkN "stupfullhet" ; -- stupfullhet..nn.1
  stupid_1_A = mkA "stupid" ; -- stupid..av.1
  stupiditet_1_N = mkN "stupiditet" "stupiditeter" ; -- stupiditet..nn.1
  stupor_1_N = mkN "stupor" ; -- stupor..nn.1
  stupränna_1_N = mkN "stupränna" ; -- stupränna..nn.1
  stuprör_1_N = mkN "stuprör" neutrum  ; -- stuprör..nn.1
  stuprörsliknande_1_A = mkA "stuprörsliknande" ; -- stuprörsliknande..av.1
  stuprörsmodell_1_N = mkN "stuprörsmodell" "stuprörsmodeller" ; -- stuprörsmodell..nn.1
  stupstock_1_N = mkN "stupstock" ; -- stupstock..nn.1
  stura_1_V = mkV "sturar" ; -- stura..vb.1
  sturande_1_N = mkN "sturande" ; -- sturande..nn.1
  sturig_1_A = mkA "sturig" ; -- sturig..av.1
  stursk_1_A = mkA "stursk" ; -- stursk..av.1
  sturskhet_1_N = mkN "sturskhet" ; -- sturskhet..nn.1
  stuss_1_N = mkN "stuss" ; -- stuss..nn.1
  stut_1_N = mkN "stut" ; -- stut..nn.1
  stut_2_N = mkN "stut" ; -- stut..nn.2
  stuteri_1_N = mkN "stuteri" "stuteriet" "stuterier" "stuterierna" ; -- stuteri..nn.1
  stuv_1_N = mkN "stuv" ; -- stuv..nn.1
  stuva_1_V = mkV "stuvar" ; -- stuva..vb.1
  stuvande_1_N = mkN "stuvande" ; -- stuvande..nn.1
  stuvare_1_N = mkN "stuvare" utrum  ; -- stuvare..nn.1
  stuvbit_1_N = mkN "stuvbit" ; -- stuvbit..nn.1
  stuveri_1_N = mkN "stuveri" "stuveriet" "stuverier" "stuverierna" ; -- stuveri..nn.1
  stuveriarbetare_1_N = mkN "stuveriarbetare" utrum  ; -- stuveriarbetare..nn.1
  stuvning_1_N = mkN "stuvning" ; -- stuvning..nn.1
  stybb_1_N = mkN "stybb" ; -- stybb..nn.1
  styck_1_N = mkN "styckna" "stycket" "styckna" "styckena" ; -- styck..nn.1
  stycka_1_V = mkV "styckar" ; -- stycka..vb.1
  styckande_1_N = mkN "styckande" ; -- styckande..nn.1
  stycke_1_N = mkN "stycke" ; -- stycke..nn.1
  styckebruk_1_N = mkN "styckebruk" neutrum  ; -- styckebruk..nn.1
  styckegods_1_N = mkN "styckegods" neutrum  ; -- styckegods..nn.1
  styckevis_1_Adv = mkAdv "styckevis" ; -- styckevis..ab.1
  styckjunkare_1_N = mkN "styckjunkare" utrum  ; -- styckjunkare..nn.1
  styckmord_1_N = mkN "styckmord" neutrum  ; -- styckmord..nn.1
  styckmästare_1_N = mkN "styckmästare" utrum  ; -- styckmästare..nn.1
  styckmördare_1_N = mkN "styckmördare" utrum  ; -- styckmördare..nn.1
  styckning_1_N = mkN "styckning" ; -- styckning..nn.1
  styckningsschema_1_N = mkN "styckningsschema" "styckningsschemat" "styckningsscheman" "styckningsschemana" ; -- styckningsschema..nn.1
  styckverk_1_N = mkN "styckverk" neutrum  ; -- styckverk..nn.1
  styckvis_1_Adv = mkAdv "styckvis" ; -- styckvis..ab.1
  stygg_1_A = mkA "stygg" ; -- stygg..av.1
  styggelse_1_N = mkN "styggelse" "styggelser" ; -- styggelse..nn.1
  stygger_1_N = mkN "stygger" "styggen" "styggar" "styggarna" ; -- stygger..nn.1
  stygghet_1_N = mkN "stygghet" ; -- stygghet..nn.1
  stygging_1_N = mkN "stygging" ; -- stygging..nn.1
  stygn_1_N = mkN "stygn" neutrum  ; -- stygn..nn.1
  styla_1_V = mkV "stylar" ; -- styla..vb.1
  stylande_1_N = mkN "stylande" ; -- stylande..nn.1
  styling_1_N = mkN "styling" ; -- styling..nn.1
  stylit_1_N = mkN "stylit" "styliter" ; -- stylit..nn.1
  stylobat_1_N = mkN "stylobat" "stylobater" ; -- stylobat..nn.1
  stylta_1_N = mkN "stylta" ; -- stylta..nn.1
  stylta_1_V = mkV "styltar" ; -- stylta..vb.1
  styltad_1_A = mkA "styltad" ; -- styltad..av.1
  styltande_1_N = mkN "styltande" ; -- styltande..nn.1
  styltig_1_A = mkA "styltig" ; -- styltig..av.1
  styltrot_1_N = mkN "styltrot" "styltrötter" ; -- styltrot..nn.1
  stympa_1_V = mkV "stympar" ; -- stympa..vb.1
  stympande_1_N = mkN "stympande" ; -- stympande..nn.1
  stympare_1_N = mkN "stympare" utrum  ; -- stympare..nn.1
  stympning_1_N = mkN "stympning" ; -- stympning..nn.1
  styng_1_N = mkN "styng" neutrum  ; -- styng..nn.1
  styr_1_N = mkN "styr" ; -- styr..nn.1
  styra_1_V = mkV "styra" "styrde" "styrt" ; -- styra..vb.1
  styrande_1_N = mkN "styrande" ; -- styrande..nn.1
  styrbar_1_A = mkA "styrbar" ; -- styrbar..av.1
  styrbarhet_1_N = mkN "styrbarhet" ; -- styrbarhet..nn.1
  styrbord_1_Adv = mkAdv "styrbord" ; -- styrbord..ab.1
  styrbord_1_N = mkN "styrbord" ; -- styrbord..nn.1
  styrcentrum_1_N = mkN "styrcentrum" neutrum  ; -- styrcentrum..nn.1
  styre_1_N = mkN "styre" ; -- styre..nn.1
  styre_2_N = mkN "styre" ; -- styre..nn.2
  styrekonom_1_N = mkN "styrekonom" "styrekonomer" ; -- styrekonom..nn.1
  styrelse_1_N = mkN "styrelse" "styrelser" ; -- styrelse..nn.1
  styrelseform_1_N = mkN "styrelseform" "styrelseformer" ; -- styrelseform..nn.1
  styrelseledamot_1_N = mkN "styrelseledamot" "styrelseledamöter" ; -- styrelseledamot..nn.1
  styrelseordförande_1_N = mkN "styrelseordförande" "styrelseordföranden" "styrelseordföranden" "styrelseordförandena" ; -- styrelseordförande..nn.1
  styrelsepost_1_N = mkN "styrelsepost" "styrelseposter" ; -- styrelsepost..nn.1
  styrelserum_1_N = mkN "styrelserum" "styrelserummet" "styrelserum" "styrelserummen" ; -- styrelserum..nn.1
  styrelseuppdrag_1_N = mkN "styrelseuppdrag" neutrum  ; -- styrelseuppdrag..nn.1
  styren_1_N = mkN "styren" neutrum  ; -- styren..nn.1
  styrenplast_1_N = mkN "styrenplast" ; -- styrenplast..nn.1
  styresman_1_N = mkN "styresman" "styresmannen" "styresmän" "styresmännen" ; -- styresman..nn.1
  styrfart_1_N = mkN "styrfart" ; -- styrfart..nn.1
  styrfjäder_1_N = mkN "styrfjäder" ; -- styrfjäder..nn.1
  styrhjul_1_N = mkN "styrhjul" neutrum  ; -- styrhjul..nn.1
  styrinrättning_1_N = mkN "styrinrättning" ; -- styrinrättning..nn.1
  styrka_1_N = mkN "styrka" ; -- styrka..nn.1
  styrka_1_V = mkV "styrker" ; -- styrka..vb.1
  styrkande_1_N = mkN "styrkande" ; -- styrkande..nn.1
  styrkebesked_1_N = mkN "styrkebesked" neutrum  ; -- styrkebesked..nn.1
  styrkeförhållande_1_N = mkN "styrkeförhållande" ; -- styrkeförhållande..nn.1
  styrkegrad_1_N = mkN "styrkegrad" "styrkegrader" ; -- styrkegrad..nn.1
  styrkeledare_1_N = mkN "styrkeledare" utrum  ; -- styrkeledare..nn.1
  styrkemedel_1_N = mkN "styrkemedel" neutrum  ; -- styrkemedel..nn.1
  styrkemedel_2_N = mkN "styrkemedel" neutrum  ; -- styrkemedel..nn.2
  styrkepass_1_N = mkN "styrkepass" neutrum  ; -- styrkepass..nn.1
  styrkeprov_1_N = mkN "styrkeprov" neutrum  ; -- styrkeprov..nn.1
  styrketräna_1_V = mkV "styrketränar" ; -- styrketräna..vb.1
  styrketränande_1_N = mkN "styrketränande" ; -- styrketränande..nn.1
  styrketräning_1_N = mkN "styrketräning" ; -- styrketräning..nn.1
  styrketår_1_N = mkN "styrketår" ; -- styrketår..nn.1
  styrlastighet_1_N = mkN "styrlastighet" "styrlastigheter" ; -- styrlastighet..nn.1
  styrlina_1_N = mkN "styrlina" ; -- styrlina..nn.1
  styrman_1_N = mkN "styrman" "styrmannen" "styrmän" "styrmännen" ; -- styrman..nn.1
  styrmedel_1_N = mkN "styrmedel" neutrum  ; -- styrmedel..nn.1
  styrning_1_N = mkN "styrning" ; -- styrning..nn.1
  styrol_1_N = mkN "styrol" ; -- styrol..nn.1
  styrpinne_1_N = mkN "styrpinne" utrum  ; -- styrpinne..nn.1
  styrprogram_1_N = mkN "styrprogram" "styrprogrammet" "styrprogram" "styrprogrammen" ; -- styrprogram..nn.1
  styrränta_1_N = mkN "styrränta" ; -- styrränta..nn.1
  styrsel_1_N = mkN "styrsel" ; -- styrsel..nn.1
  styrsellös_1_A = mkA "styrsellös" ; -- styrsellös..av.1
  styrsignal_1_N = mkN "styrsignal" "styrsignaler" ; -- styrsignal..nn.1
  styrstav_1_N = mkN "styrstav" ; -- styrstav..nn.1
  styrstång_1_N = mkN "styrstång" "styrstänger" ; -- styrstång..nn.1
  styrsystem_1_N = mkN "styrsystem" neutrum  ; -- styrsystem..nn.1
  styrtecken_1_N = mkN "styrtecken" "styrtecknet" "styrtecken" "styrtecknen" ; -- styrtecken..nn.1
  styrväxel_1_N = mkN "styrväxel" ; -- styrväxel..nn.1
  styv_1_A = mkA "styv" ; -- styv..av.1
  styva_1_V = mkV "styvar" ; -- styva..vb.1
  styvande_1_N = mkN "styvande" ; -- styvande..nn.1
  styvbarn_1_N = mkN "styvbarn" neutrum  ; -- styvbarn..nn.1
  styvdotter_1_N = mkN "styvdotter" "styvdottern" "styvdöttrar" "styvdöttrarna" ; -- styvdotter..nn.1
  styver_1_N = mkN "styver" "styvern" "styver" "styverna" ; -- styver..nn.1
  styvfar_1_N = mkN "styvfader" "styvfadern" "styvfäder" "styvfäderna" ; -- styvfar..nn.1
  styvförälder_1_N = mkN "styvförälder" ; -- styvförälder..nn.1
  styvhet_1_N = mkN "styvhet" "styvheter" ; -- styvhet..nn.1
  styvmamma_1_N = mkN "styvmamma" ; -- styvmamma..nn.1
  styvmoderlig_1_A = mkA "styvmoderlig" ; -- styvmoderlig..av.1
  styvmoderlighet_1_N = mkN "styvmoderlighet" ; -- styvmoderlighet..nn.1
  styvmor_1_N = mkN "styvmor" "styvmodern" "styvmödrar" "styvmödrarna" ; -- styvmor..nn.1
  styvmorsviol_1_N = mkN "styvmorsviol" "styvmorsvioler" ; -- styvmorsviol..nn.1
  styvna_1_V = mkV "styvnar" ; -- styvna..vb.1
  styvnackad_1_A = mkA "styvnackad" ; -- styvnackad..av.1
  styvnad_1_N = mkN "styvnad" "styvnader" ; -- styvnad..nn.1
  styvnande_1_N = mkN "styvnande" ; -- styvnande..nn.1
  styvning_1_N = mkN "styvning" ; -- styvning..nn.1
  styvpappa_1_N = mkN "styvpappa" ; -- styvpappa..nn.1
  styvsint_1_A = mkA "styvsint" "styvsint" ; -- styvsint..av.1
  styvsinthet_1_N = mkN "styvsinthet" ; -- styvsinthet..nn.1
  styvson_1_N = mkN "styvson" "styvsöner" ; -- styvson..nn.1
  styvsyskon_1_N = mkN "styvsyskon" neutrum  ; -- styvsyskon..nn.1
  styvsyster_1_N = mkN "styvsyster" ; -- styvsyster..nn.1
  styvt_1_Adv = mkAdv "styvt" ; -- styvt..ab.1
  stäcka_1_V = mkV "stäcker" ; -- stäcka..vb.1
  stäckande_1_N = mkN "stäckande" ; -- stäckande..nn.1
  stäckning_1_N = mkN "stäckning" ; -- stäckning..nn.1
  städ_1_N = mkN "städ" neutrum  ; -- städ..nn.1
  städa_1_V = mkV "städar" ; -- städa..vb.1
  städad_1_A = mkA "städad" ; -- städad..av.1
  städambition_1_N = mkN "städambition" ; -- städambition..nn.1
  städande_1_N = mkN "städande" ; -- städande..nn.1
  städare_1_N = mkN "städare" utrum  ; -- städare..nn.1
  städbolag_1_N = mkN "städbolag" neutrum  ; -- städbolag..nn.1
  städdag_1_N = mkN "städdag" ; -- städdag..nn.1
  städerska_1_N = mkN "städerska" ; -- städerska..nn.1
  städfru_1_N = mkN "städfru" ; -- städfru..nn.1
  städfynd_1_N = mkN "städfynd" neutrum  ; -- städfynd..nn.1
  städgräl_1_N = mkN "städgräl" neutrum  ; -- städgräl..nn.1
  städgumma_1_N = mkN "städgumma" ; -- städgumma..nn.1
  städhjälp_1_N = mkN "städhjälp" ; -- städhjälp..nn.1
  städja_1_V = mkV "städja" "städer" "städ" "stadde" "statt" "stadd" ; -- städja..vb.1
  städjande_1_N = mkN "städjande" ; -- städjande..nn.1
  städning_1_N = mkN "städning" ; -- städning..nn.1
  städredskap_1_N = mkN "städredskap" neutrum  ; -- städredskap..nn.1
  städsegrön_1_A = mkA "städsegrön" ; -- städsegrön..av.1
  städsel_1_N = mkN "städsel" neutrum  ; -- städsel..nn.1
  städskåp_1_N = mkN "städskåp" neutrum  ; -- städskåp..nn.1
  städsla_1_V = mkV "städslar" ; -- städsla..vb.1
  städslande_1_N = mkN "städslande" ; -- städslande..nn.1
  städsling_1_N = mkN "städsling" ; -- städsling..nn.1
  städvagn_1_N = mkN "städvagn" ; -- städvagn..nn.1
  ställ_1_N = mkN "ställ" neutrum  ; -- ställ..nn.1
  ställa_1_V = mkV "ställer" ; -- ställa..vb.1
  ställande_1_N = mkN "ställande" ; -- ställande..nn.1
  ställbar_1_A = mkA "ställbar" ; -- ställbar..av.1
  ställd_1_A = mkA "ställd" "ställt" ; -- ställd..av.1
  ställe_1_N = mkN "ställe" ; -- ställe..nn.1
  ställföreträdande_1_A = mkA "ställföreträdande" ; -- ställföreträdande..av.1
  ställföreträdare_1_N = mkN "ställföreträdare" utrum  ; -- ställföreträdare..nn.1
  ställighet_1_N = mkN "ställighet" "ställigheter" ; -- ställighet..nn.1
  ställmutter_1_N = mkN "ställmutter" ; -- ställmutter..nn.1
  ställning_1_N = mkN "ställning" ; -- ställning..nn.1
  ställningskrig_1_N = mkN "ställningskrig" neutrum  ; -- ställningskrig..nn.1
  ställningssteg_1_N = mkN "ställningssteg" neutrum  ; -- ställningssteg..nn.1
  ställningstagande_1_N = mkN "ställningstagande" ; -- ställningstagande..nn.1
  ställskruv_1_N = mkN "ställskruv" ; -- ställskruv..nn.1
  ställverk_1_N = mkN "ställverk" neutrum  ; -- ställverk..nn.1
  ställvis_1_Adv = mkAdv "ställvis" ; -- ställvis..ab.1
  ställvis_1_A = mkA "ställvis" ; -- ställvis..av.1
  stämband_1_N = mkN "stämband" neutrum  ; -- stämband..nn.1
  stämgaffel_1_N = mkN "stämgaffel" ; -- stämgaffel..nn.1
  stämjärn_1_N = mkN "stämjärn" neutrum  ; -- stämjärn..nn.1
  stämklang_1_N = mkN "stämklang" "stämklanger" ; -- stämklang..nn.1
  stämläpp_1_N = mkN "stämläpp" ; -- stämläpp..nn.1
  stämma_1_N = mkN "stämma" ; -- stämma..nn.1
  stämma_1_V = mkV "stämmer" ; -- stämma..vb.1
  stämmande_1_N = mkN "stämmande" ; -- stämmande..nn.1
  stämmobeslut_1_N = mkN "stämmobeslut" neutrum  ; -- stämmobeslut..nn.1
  stämning_1_N = mkN "stämning" ; -- stämning..nn.1
  stämningsbild_1_N = mkN "stämningsbild" "stämningsbilder" ; -- stämningsbild..nn.1
  stämningsfull_1_A = mkA "stämningsfull" ; -- stämningsfull..av.1
  stämningsfullhet_1_N = mkN "stämningsfullhet" ; -- stämningsfullhet..nn.1
  stämningshöjare_1_N = mkN "stämningshöjare" utrum  ; -- stämningshöjare..nn.1
  stämningsläge_1_N = mkN "stämningsläge" ; -- stämningsläge..nn.1
  stämningspoesi_1_N = mkN "stämningspoesi" ; -- stämningspoesi..nn.1
  stämningsskapande_1_A = mkA "stämningsskapande" ; -- stämningsskapande..av.1
  stämningsspridande_1_A = mkA "stämningsspridande" ; -- stämningsspridande..av.1
  stämningstyngd_1_A = mkA "stämningstyngd" "stämningstyngt" ; -- stämningstyngd..av.1
  stämpel_1_N = mkN "stämpel" ; -- stämpel..nn.1
  stämpel_2_N = mkN "stämpel" ; -- stämpel..nn.2
  stämpelavgift_1_N = mkN "stämpelavgift" "stämpelavgifter" ; -- stämpelavgift..nn.1
  stämpeldyna_1_N = mkN "stämpeldyna" ; -- stämpeldyna..nn.1
  stämpelklocka_1_N = mkN "stämpelklocka" ; -- stämpelklocka..nn.1
  stämpelur_1_N = mkN "stämpelur" neutrum  ; -- stämpelur..nn.1
  stämpla_1_V = mkV "stämplar" ; -- stämpla..vb.1
  stämplande_1_N = mkN "stämplande" ; -- stämplande..nn.1
  stämpling_1_N = mkN "stämpling" ; -- stämpling..nn.1
  ständchen_1_N = mkN "ständchen" "ständchenen" "ständchen" "ständchenen" ; -- ständchen..nn.1
  ständig_1_A = mkA "ständig" ; -- ständig..av.1
  ständighet_1_N = mkN "ständighet" ; -- ständighet..nn.1
  stänga_1_V = mkV "stänger" ; -- stänga..vb.1
  stängande_1_N = mkN "stängande" ; -- stängande..nn.1
  stängd_1_A = mkA "stängd" "stängt" ; -- stängd..av.1
  stängdags_1_N = mkN "stängdags" ; -- stängdags..nn.1
  stänge_1_N = mkN "stänge" ; -- stänge..nn.1
  stängel_1_N = mkN "stängel" ; -- stängel..nn.1
  stängning_1_N = mkN "stängning" ; -- stängning..nn.1
  stängningsdags_1_N = mkN "stängningsdags" ; -- stängningsdags..nn.1
  stängsel_1_N = mkN "stängsel" neutrum  ; -- stängsel..nn.1
  stängsla_1_V = mkV "stängslar" ; -- stängsla..vb.1
  stängslande_1_N = mkN "stängslande" ; -- stängslande..nn.1
  stänk_1_N = mkN "stänk" neutrum  ; -- stänk..nn.1
  stänka_1_V = mkV "stänker" ; -- stänka..vb.1
  stänkande_1_N = mkN "stänkande" ; -- stänkande..nn.1
  stänkskydd_1_N = mkN "stänkskydd" neutrum  ; -- stänkskydd..nn.1
  stänkskärm_1_N = mkN "stänkskärm" ; -- stänkskärm..nn.1
  stäpp_1_N = mkN "stäpp" "stäpper" ; -- stäpp..nn.1
  stäppantilop_1_N = mkN "stäppantilop" "stäppantiloper" ; -- stäppantilop..nn.1
  stäppnomad_1_N = mkN "stäppnomad" "stäppnomader" ; -- stäppnomad..nn.1
  stärbhus_1_N = mkN "stärbhus" neutrum  ; -- stärbhus..nn.1
  stärka_1_V = mkV "stärker" ; -- stärka..vb.1
  stärkande_1_A = mkA "stärkande" ; -- stärkande..av.1
  stärkande_1_N = mkN "stärkande" ; -- stärkande..nn.1
  stärkelse_1_N = mkN "stärkelse" "stärkelser" ; -- stärkelse..nn.1
  stärkelsehaltig_1_A = mkA "stärkelsehaltig" ; -- stärkelsehaltig..av.1
  stärkelseklister_1_N = mkN "stärkelseklister" neutrum  ; -- stärkelseklister..nn.1
  stärkelserik_1_A = mkA "stärkelserik" ; -- stärkelserik..av.1
  stärkelserikhet_1_N = mkN "stärkelserikhet" ; -- stärkelserikhet..nn.1
  stätta_1_N = mkN "stätta" ; -- stätta..nn.1
  stäv_1_N = mkN "stäv" ; -- stäv..nn.1
  stäv_2_N = mkN "stäv" neutrum  ; -- stäv..nn.2
  stäva_1_N = mkN "stäva" ; -- stäva..nn.1
  stäva_1_V = mkV "stävar" ; -- stäva..vb.1
  stävande_1_N = mkN "stävande" ; -- stävande..nn.1
  stävja_1_V = mkV "stävjar" ; -- stävja..vb.1
  stävjande_1_N = mkN "stävjande" ; -- stävjande..nn.1
  stävknä_1_N = mkN "stävknä" "stävknät" "stävknän" "stävknäna" ; -- stävknä..nn.1
  stävkraft_1_N = mkN "stävkraft" ; -- stävkraft..nn.1
  stå_1_V = mkV "stå" "stod" "stått" ; -- stå..vb.1
  ståbas_1_N = mkN "ståbas" ; -- ståbas..nn.1
  stående_1_A = mkA "stående" ; -- stående..av.1
  stående_1_N = mkN "stående" ; -- stående..nn.1
  ståfela_1_N = mkN "ståfela" ; -- ståfela..nn.1
  ståfräs_1_N = mkN "ståfräs" ; -- ståfräs..nn.1
  ståhej_1_N = mkN "ståhej" neutrum  ; -- ståhej..nn.1
  ståhjuling_1_N = mkN "ståhjuling" ; -- ståhjuling..nn.1
  stål_1_N = mkN "stål" neutrum  ; -- stål..nn.1
  stålartad_1_A = mkA "stålartad" ; -- stålartad..av.1
  stålbad_1_N = mkN "stålbad" neutrum  ; -- stålbad..nn.1
  stålbadspolitik_1_N = mkN "stålbadspolitik" ; -- stålbadspolitik..nn.1
  stålblå_1_A = mkA "stålblå" "stålblått" ; -- stålblå..av.1
  stålborste_1_N = mkN "stålborste" utrum  ; -- stålborste..nn.1
  stålbågad_1_A = mkA "stålbågad" ; -- stålbågad..av.1
  stålfjäder_1_N = mkN "stålfjäder" ; -- stålfjäder..nn.1
  stålframställning_1_N = mkN "stålframställning" ; -- stålframställning..nn.1
  stålgrå_1_A = mkA "stålgrå" "stålgrått" ; -- stålgrå..av.1
  stålhättad_1_A = mkA "stålhättad" ; -- stålhättad..av.1
  stålhård_1_A = mkA "stålhård" "stålhårt" ; -- stålhård..av.1
  stålhårdhet_1_N = mkN "stålhårdhet" ; -- stålhårdhet..nn.1
  stålkonstruktion_1_N = mkN "stålkonstruktion" ; -- stålkonstruktion..nn.1
  stålkula_1_N = mkN "stålkula" ; -- stålkula..nn.1
  stållegering_1_N = mkN "stållegering" ; -- stållegering..nn.1
  stålman_1_N = mkN "stålman" "stålmannen" "stålmän" "stålmännen" ; -- stålman..nn.1
  stålpenna_1_N = mkN "stålpenna" ; -- stålpenna..nn.1
  stålpipa_1_N = mkN "stålpipa" ; -- stålpipa..nn.1
  stålplåt_1_N = mkN "stålplåt" ; -- stålplåt..nn.1
  stålram_1_N = mkN "stålram" ; -- stålram..nn.1
  stålring_1_N = mkN "stålring" ; -- stålring..nn.1
  stålrundkula_1_N = mkN "stålrundkula" ; -- stålrundkula..nn.1
  stålrör_1_N = mkN "stålrör" neutrum  ; -- stålrör..nn.1
  stålrörsstol_1_N = mkN "stålrörsstol" ; -- stålrörsstol..nn.1
  stålsatt_1_A = mkA "stålsatt" ; -- stålsatt..av.1
  stålskelett_1_N = mkN "stålskelett" neutrum  ; -- stålskelett..nn.1
  stålskena_1_N = mkN "stålskena" ; -- stålskena..nn.1
  stålsköld_1_N = mkN "stålsköld" ; -- stålsköld..nn.1
  stålspik_1_N = mkN "stålspik" ; -- stålspik..nn.1
  stålstick_1_N = mkN "stålstick" neutrum  ; -- stålstick..nn.1
  stålstomme_1_N = mkN "stålstomme" utrum  ; -- stålstomme..nn.1
  stålsättande_1_N = mkN "stålsättande" ; -- stålsättande..nn.1
  stålsättning_1_N = mkN "stålsättning" ; -- stålsättning..nn.1
  ståltingest_1_N = mkN "ståltingest" ; -- ståltingest..nn.1
  ståltryck_1_N = mkN "ståltryck" neutrum  ; -- ståltryck..nn.1
  ståltråd_1_N = mkN "ståltråd" ; -- ståltråd..nn.1
  stålull_1_N = mkN "stålull" ; -- stålull..nn.1
  stålvajer_1_N = mkN "stålvajer" ; -- stålvajer..nn.1
  stålverk_1_N = mkN "stålverk" neutrum  ; -- stålverk..nn.1
  stålvit_1_A = mkA "stålvit" ; -- stålvit..av.1
  stålwire_1_N = mkN "stålwire" utrum  ; -- stålwire..nn.1
  ståmoppe_1_N = mkN "ståmoppe" utrum  ; -- ståmoppe..nn.1
  stånd_1_N = mkN "stånd" neutrum  ; -- stånd..nn.1
  stånd_2_N = mkN "stånd" neutrum  ; -- stånd..nn.2
  stånda_1_V = mkV "ståndar" ; -- stånda..vb.1
  ståndaktig_1_A = mkA "ståndaktig" ; -- ståndaktig..av.1
  ståndaktighet_1_N = mkN "ståndaktighet" ; -- ståndaktighet..nn.1
  ståndande_1_N = mkN "ståndande" ; -- ståndande..nn.1
  ståndare_1_N = mkN "ståndare" utrum  ; -- ståndare..nn.1
  ståndkrage_1_N = mkN "ståndkrage" utrum  ; -- ståndkrage..nn.1
  ståndkrok_1_N = mkN "ståndkrok" ; -- ståndkrok..nn.1
  ståndman_1_N = mkN "ståndman" ; -- ståndman..nn.1
  ståndmässig_1_A = mkA "ståndmässig" ; -- ståndmässig..av.1
  ståndmässighet_1_N = mkN "ståndmässighet" ; -- ståndmässighet..nn.1
  ståndort_1_N = mkN "ståndort" "ståndorter" ; -- ståndort..nn.1
  ståndpunkt_1_N = mkN "ståndpunkt" "ståndpunkter" ; -- ståndpunkt..nn.1
  ståndrätt_1_N = mkN "ståndrätt" "ståndrätter" ; -- ståndrätt..nn.1
  ståndscirkulation_1_N = mkN "ståndscirkulation" ; -- ståndscirkulation..nn.1
  ståndsmässig_1_A = mkA "ståndsmässig" ; -- ståndsmässig..av.1
  ståndsmässighet_1_N = mkN "ståndsmässighet" ; -- ståndsmässighet..nn.1
  ståndsperson_1_N = mkN "ståndsperson" "ståndspersoner" ; -- ståndsperson..nn.1
  ståndsprivilegium_1_N = mkN "ståndsprivilegium" "ståndsprivilegiet" "ståndsprivilegier" "ståndsprivilegierna" ; -- ståndsprivilegium..nn.1
  ståndsskillnad_1_N = mkN "ståndsskillnad" "ståndsskillnader" ; -- ståndsskillnad..nn.1
  stång_1_N = mkN "stång" "stänger" ; -- stång..nn.1
  stånga_1_V = mkV "stångar" ; -- stånga..vb.1
  stångande_1_N = mkN "stångande" ; -- stångande..nn.1
  stånggång_1_N = mkN "stånggång" ; -- stånggång..nn.1
  stånghammare_1_N = mkN "stånghammare" "stånghammaren" "stånghammare" "stånghamrarna" ; -- stånghammare..nn.1
  stångjärn_1_N = mkN "stångjärn" neutrum  ; -- stångjärn..nn.1
  stångjärnshammare_1_N = mkN "stångjärnshammare" "stångjärnshammaren" "stångjärnshammare" "stångjärnshamrarna" ; -- stångjärnshammare..nn.1
  stångkorv_1_N = mkN "stångkorv" ; -- stångkorv..nn.1
  stångning_1_N = mkN "stångning" ; -- stångning..nn.1
  stångpiska_1_N = mkN "stångpiska" ; -- stångpiska..nn.1
  stångryttare_1_N = mkN "stångryttare" utrum  ; -- stångryttare..nn.1
  stångstörtning_1_N = mkN "stångstörtning" ; -- stångstörtning..nn.1
  stånk_1_N = mkN "stånk" neutrum  ; -- stånk..nn.1
  stånka_1_N = mkN "stånka" ; -- stånka..nn.1
  stånka_1_V = mkV "stånkar" ; -- stånka..vb.1
  stånkande_1_N = mkN "stånkande" ; -- stånkande..nn.1
  stånkning_1_N = mkN "stånkning" ; -- stånkning..nn.1
  ståplats_1_N = mkN "ståplats" "ståplatser" ; -- ståplats..nn.1
  ståpäls_1_N = mkN "ståpäls" ; -- ståpäls..nn.1
  ståt_1_N = mkN "ståt" ; -- ståt..nn.1
  ståta_1_V = mkV "ståtar" ; -- ståta..vb.1
  ståtande_1_N = mkN "ståtande" ; -- ståtande..nn.1
  ståthållare_1_N = mkN "ståthållare" utrum  ; -- ståthållare..nn.1
  ståthållarskap_1_N = mkN "ståthållarskap" ; -- ståthållarskap..nn.1
  ståtlig_1_A = mkA "ståtlig" ; -- ståtlig..av.1
  ståtlighet_1_N = mkN "ståtlighet" ; -- ståtlighet..nn.1
  ståuppare_1_N = mkN "ståuppare" utrum  ; -- ståuppare..nn.1
  ståuppföreställning_1_N = mkN "ståuppföreställning" ; -- ståuppföreställning..nn.1
  ståuppkomiker_1_N = mkN "ståuppkomiker" "ståuppkomikern" "ståuppkomiker" "ståuppkomikerna" ; -- ståuppkomiker..nn.1
  stöd_1_N = mkN "stöd" neutrum  ; -- stöd..nn.1
  stödberättigad_1_A = mkA "stödberättigad" ; -- stödberättigad..av.1
  stödboende_1_N = mkN "stödboende" ; -- stödboende..nn.1
  stöddig_1_A = mkA "stöddig" ; -- stöddig..av.1
  stöddighet_1_N = mkN "stöddighet" ; -- stöddighet..nn.1
  stödfestival_1_N = mkN "stödfestival" "stödfestivaler" ; -- stödfestival..nn.1
  stödgala_1_N = mkN "stödgala" ; -- stödgala..nn.1
  stödgrupp_1_N = mkN "stödgrupp" "stödgrupper" ; -- stödgrupp..nn.1
  stödhjul_1_N = mkN "stödhjul" neutrum  ; -- stödhjul..nn.1
  stödinsats_1_N = mkN "stödinsats" "stödinsatser" ; -- stödinsats..nn.1
  stödja_1_V = mkV "stödja" "stödjer" "stöd" "stödde" "stött" "stödd" ; -- stödja..vb.1
  stödjande_1_N = mkN "stödjande" ; -- stödjande..nn.1
  stödjecell_1_N = mkN "stödjecell" "stödjeceller" ; -- stödjecell..nn.1
  stödjepelare_1_N = mkN "stödjepelare" utrum  ; -- stödjepelare..nn.1
  stödjepunkt_1_N = mkN "stödjepunkt" "stödjepunkter" ; -- stödjepunkt..nn.1
  stödjevävnad_1_N = mkN "stödjevävnad" "stödjevävnader" ; -- stödjevävnad..nn.1
  stödjordbruk_1_N = mkN "stödjordbruk" neutrum  ; -- stödjordbruk..nn.1
  stödköp_1_N = mkN "stödköp" neutrum  ; -- stödköp..nn.1
  stödköpa_1_V = mkV "stödköper" ; -- stödköpa..vb.1
  stödköpande_1_N = mkN "stödköpande" ; -- stödköpande..nn.1
  stödområde_1_N = mkN "stödområde" ; -- stödområde..nn.1
  stödpapper_1_N = mkN "stödpapper" neutrum  ; -- stödpapper..nn.1
  stödrösta_1_V = mkV "stödröstar" ; -- stödrösta..vb.1
  stödröstande_1_N = mkN "stödröstande" ; -- stödröstande..nn.1
  stödröstning_1_N = mkN "stödröstning" ; -- stödröstning..nn.1
  stödsamtal_1_N = mkN "stödsamtal" neutrum  ; -- stödsamtal..nn.1
  stödteam_1_N = mkN "stödteam" neutrum  ; -- stödteam..nn.1
  stödundervisning_1_N = mkN "stödundervisning" ; -- stödundervisning..nn.1
  stödutfodra_1_V = mkV "stödutfodrar" ; -- stödutfodra..vb.1
  stödutfodrande_1_N = mkN "stödutfodrande" ; -- stödutfodrande..nn.1
  stödutfodrning_1_N = mkN "stödutfodrning" ; -- stödutfodrning..nn.1
  stödvagga_1_N = mkN "stödvagga" ; -- stödvagga..nn.1
  stödåtgärd_1_N = mkN "stödåtgärd" "stödåtgärder" ; -- stödåtgärd..nn.1
  stök_1_N = mkN "stök" neutrum  ; -- stök..nn.1
  stöka_1_V = mkV "stökar" ; -- stöka..vb.1
  stökande_1_N = mkN "stökande" ; -- stökande..nn.1
  stökig_1_A = mkA "stökig" ; -- stökig..av.1
  stökighet_1_N = mkN "stökighet" "stökigheter" ; -- stökighet..nn.1
  stökiometri_1_N = mkN "stökiometri" ; -- stökiometri..nn.1
  stöl_1_N = mkN "stöl" "stölen" "stöl" "stölen" ; -- stöl..nn.1
  stöld_1_N = mkN "stöld" "stölder" ; -- stöld..nn.1
  stöldbegärlig_1_A = mkA "stöldbegärlig" ; -- stöldbegärlig..av.1
  stöldförsäkring_1_N = mkN "stöldförsäkring" ; -- stöldförsäkring..nn.1
  stöldgods_1_N = mkN "stöldgods" neutrum  ; -- stöldgods..nn.1
  stöldkupp_1_N = mkN "stöldkupp" "stöldkupper" ; -- stöldkupp..nn.1
  stöldliga_1_N = mkN "stöldliga" ; -- stöldliga..nn.1
  stöldräd_1_N = mkN "stöldräd" "stöldräder" ; -- stöldräd..nn.1
  stöldsäker_1_A = mkA "stöldsäker" ; -- stöldsäker..av.1
  stöldsäkerhet_1_N = mkN "stöldsäkerhet" ; -- stöldsäkerhet..nn.1
  stöldturné_1_N = mkN "stöldturné" "stöldturnéer" ; -- stöldturné..nn.1
  stöldutsatt_1_A = mkA "stöldutsatt" ; -- stöldutsatt..av.1
  stön_1_N = mkN "stön" neutrum  ; -- stön..nn.1
  stöna_1_V = mkV "stönar" ; -- stöna..vb.1
  stönande_1_N = mkN "stönande" ; -- stönande..nn.1
  stöpa_1_V = mkV "stöper" ; -- stöpa..vb.1
  stöpande_1_N = mkN "stöpande" ; -- stöpande..nn.1
  stöpis_1_N = mkN "stöpis" ; -- stöpis..nn.1
  stöppla_1_V = mkV "stöpplar" ; -- stöppla..vb.1
  stöpplande_1_N = mkN "stöpplande" ; -- stöpplande..nn.1
  stöpplare_1_N = mkN "stöpplare" utrum  ; -- stöpplare..nn.1
  stöpslev_1_N = mkN "stöpslev" ; -- stöpslev..nn.1
  stör_1_N = mkN "stör" ; -- stör..nn.1
  störa_1_V = mkV "störa" "störde" "stört" ; -- störa..vb.1
  störa_2_V = mkV "störar" ; -- störa..vb.2
  störande_1_N = mkN "störande" ; -- störande..nn.1
  störatom_1_N = mkN "störatom" "störatomer" ; -- störatom..nn.1
  störböna_1_N = mkN "störböna" ; -- störböna..nn.1
  störig_1_A = mkA "störig" ; -- störig..av.1
  störighet_1_N = mkN "störighet" ; -- störighet..nn.1
  störning_1_N = mkN "störning" ; -- störning..nn.1
  störningsmoment_1_N = mkN "störningsmoment" neutrum  ; -- störningsmoment..nn.1
  störskydd_1_N = mkN "störskydd" neutrum  ; -- störskydd..nn.1
  störta_1_V = mkV "störtar" ; -- störta..vb.1
  störta_2_V = mkV "störtar" ; -- störta..vb.2
  störtande_1_N = mkN "störtande" ; -- störtande..nn.1
  störtblöda_1_V = mkV "störtblöda" "störtblödde" "störtblött" ; -- störtblöda..vb.1
  störtflod_1_N = mkN "störtflod" "störtfloder" ; -- störtflod..nn.1
  störtförbannad_1_A = mkA "störtförbannad" ; -- störtförbannad..av.1
  störthjälm_1_N = mkN "störthjälm" ; -- störthjälm..nn.1
  störtkruka_1_N = mkN "störtkruka" ; -- störtkruka..nn.1
  störtkär_1_A = mkA "störtkär" ; -- störtkär..av.1
  störtlopp_1_N = mkN "störtlopp" neutrum  ; -- störtlopp..nn.1
  störtning_1_N = mkN "störtning" ; -- störtning..nn.1
  störtregn_1_N = mkN "störtregn" neutrum  ; -- störtregn..nn.1
  störtregna_1_V = mkV "störtregnar" ; -- störtregna..vb.1
  störtsjö_1_N = mkN "störtsjö" ; -- störtsjö..nn.1
  störtskur_1_N = mkN "störtskur" ; -- störtskur..nn.1
  stöt_1_N = mkN "stöt" ; -- stöt..nn.1
  stöta_1_V = mkV "stöter" ; -- stöta..vb.1
  stötande_1_N = mkN "stötande" ; -- stötande..nn.1
  stötdämpande_1_A = mkA "stötdämpande" ; -- stötdämpande..av.1
  stötdämpare_1_N = mkN "stötdämpare" utrum  ; -- stötdämpare..nn.1
  stötesten_1_N = mkN "stötesten" "stötestenen" "stötestenar" "stötestenarna" ; -- stötesten..nn.1
  stötfångare_1_N = mkN "stötfångare" utrum  ; -- stötfångare..nn.1
  stötig_1_A = mkA "stötig" ; -- stötig..av.1
  stötsida_1_N = mkN "stötsida" ; -- stötsida..nn.1
  stötskydd_1_N = mkN "stötskydd" neutrum  ; -- stötskydd..nn.1
  stött_1_A = mkA "stött" ; -- stött..av.1
  stötta_1_N = mkN "stötta" ; -- stötta..nn.1
  stötta_1_V = mkV "stöttar" ; -- stötta..vb.1
  stöttande_1_N = mkN "stöttande" ; -- stöttande..nn.1
  stöttepelare_1_N = mkN "stöttepelare" utrum  ; -- stöttepelare..nn.1
  stötthet_1_N = mkN "stötthet" ; -- stötthet..nn.1
  stöttålig_1_A = mkA "stöttålig" ; -- stöttålig..av.1
  stöttålighet_1_N = mkN "stöttålighet" ; -- stöttålighet..nn.1
  stötvapen_1_N = mkN "stötvapen" "stötvapnet" "stötvapen" "stötvapnen" ; -- stötvapen..nn.1
  stötvis_1_Adv = mkAdv "stötvis" ; -- stötvis..ab.1
  stötvis_1_A = mkA "stötvis" ; -- stötvis..av.1
  stötvåg_1_N = mkN "stötvåg" "stötvågor" ; -- stötvåg..nn.1
  stöv_1_N = mkN "stöv" neutrum  ; -- stöv..nn.1
  stövare_1_N = mkN "stövare" utrum  ; -- stövare..nn.1
  stövel_1_N = mkN "stövel" ; -- stövel..nn.1
  stövelklack_1_N = mkN "stövelklack" ; -- stövelklack..nn.1
  stövelknekt_1_N = mkN "stövelknekt" ; -- stövelknekt..nn.1
  stövelskaft_1_N = mkN "stövelskaft" neutrum  ; -- stövelskaft..nn.1
  stövelspets_1_N = mkN "stövelspets" ; -- stövelspets..nn.1
  stöveltramp_1_N = mkN "stöveltramp" neutrum  ; -- stöveltramp..nn.1
  stövla_1_V = mkV "stövlar" ; -- stövla..vb.1
  stövlande_1_N = mkN "stövlande" ; -- stövlande..nn.1
  stövlett_1_N = mkN "stövlett" "stövletter" ; -- stövlett..nn.1
  subalpin_1_A = mkA "subalpin" ; -- subalpin..av.1
  subaltern_1_N = mkN "subaltern" "subalterner" ; -- subaltern..nn.1
  subantarktisk_1_A = mkA "subantarktisk" ; -- subantarktisk..av.1
  subarktisk_1_A = mkA "subarktisk" ; -- subarktisk..av.1
  subba_1_N = mkN "subba" ; -- subba..nn.1
  subbig_1_A = mkA "subbig" ; -- subbig..av.1
  subbighet_1_N = mkN "subbighet" ; -- subbighet..nn.1
  subdominant_1_N = mkN "subdominant" "subdominanter" ; -- subdominant..nn.1
  subjekt_1_N = mkN "subjekt" neutrum  ; -- subjekt..nn.1
  subjektiv_1_A = mkA "subjektiv" ; -- subjektiv..av.1
  subjektivism_1_N = mkN "subjektivism" "subjektivismer" ; -- subjektivism..nn.1
  subjektivistisk_1_A = mkA "subjektivistisk" ; -- subjektivistisk..av.1
  subjektivitet_1_N = mkN "subjektivitet" "subjektiviteter" ; -- subjektivitet..nn.1
  subjunktion_1_N = mkN "subjunktion" ; -- subjunktion..nn.1
  subkontinent_1_N = mkN "subkontinent" "subkontinenter" ; -- subkontinent..nn.1
  subkultur_1_N = mkN "subkultur" "subkulturer" ; -- subkultur..nn.1
  subkutan_1_A = mkA "subkutan" ; -- subkutan..av.1
  sublim_1_A = mkA "sublim" ; -- sublim..av.1
  sublimat_1_N = mkN "sublimat" ; -- sublimat..nn.1
  sublimation_1_N = mkN "sublimation" ; -- sublimation..nn.1
  sublimera_1_V = mkV "sublimerar" ; -- sublimera..vb.1
  sublimerande_1_N = mkN "sublimerande" ; -- sublimerande..nn.1
  sublimerbar_1_A = mkA "sublimerbar" ; -- sublimerbar..av.1
  sublimerbarhet_1_N = mkN "sublimerbarhet" ; -- sublimerbarhet..nn.1
  sublimering_1_N = mkN "sublimering" ; -- sublimering..nn.1
  sublimering_2_N = mkN "sublimering" ; -- sublimering..nn.2
  sublimhet_1_N = mkN "sublimhet" ; -- sublimhet..nn.1
  subliminal_1_A = mkA "subliminal" ; -- subliminal..av.1
  sublimitet_1_N = mkN "sublimitet" "sublimiteter" ; -- sublimitet..nn.1
  submarin_1_A = mkA "submarin" ; -- submarin..av.1
  suboptimal_1_A = mkA "suboptimal" ; -- suboptimal..av.1
  suboptimera_1_V = mkV "suboptimerar" ; -- suboptimera..vb.1
  suboptimerande_1_N = mkN "suboptimerande" ; -- suboptimerande..nn.1
  suboptimering_1_N = mkN "suboptimering" ; -- suboptimering..nn.1
  subordination_1_N = mkN "subordination" ; -- subordination..nn.1
  subordinationsbrott_1_N = mkN "subordinationsbrott" neutrum  ; -- subordinationsbrott..nn.1
  subordinera_1_V = mkV "subordinerar" ; -- subordinera..vb.1
  subordinerande_1_N = mkN "subordinerande" ; -- subordinerande..nn.1
  subordinerbar_1_A = mkA "subordinerbar" ; -- subordinerbar..av.1
  subordinerbarhet_1_N = mkN "subordinerbarhet" ; -- subordinerbarhet..nn.1
  subordinering_1_N = mkN "subordinering" ; -- subordinering..nn.1
  subrett_1_N = mkN "subrett" "subretter" ; -- subrett..nn.1
  subsidiera_1_V = mkV "subsidierar" ; -- subsidiera..vb.1
  subsidierande_1_N = mkN "subsidierande" ; -- subsidierande..nn.1
  subsidierbar_1_A = mkA "subsidierbar" ; -- subsidierbar..av.1
  subsidierbarhet_1_N = mkN "subsidierbarhet" ; -- subsidierbarhet..nn.1
  subsidiering_1_N = mkN "subsidiering" ; -- subsidiering..nn.1
  subsidiär_1_A = mkA "subsidiär" ; -- subsidiär..av.1
  subsistens_1_N = mkN "subsistens" ; -- subsistens..nn.1
  subskribent_1_N = mkN "subskribent" "subskribenter" ; -- subskribent..nn.1
  subskribera_1_V = mkV "subskriberar" ; -- subskribera..vb.1
  subskriberande_1_N = mkN "subskriberande" ; -- subskriberande..nn.1
  subskriberbar_1_A = mkA "subskriberbar" ; -- subskriberbar..av.1
  subskriberbarhet_1_N = mkN "subskriberbarhet" ; -- subskriberbarhet..nn.1
  subskribering_1_N = mkN "subskribering" ; -- subskribering..nn.1
  subskription_1_N = mkN "subskription" ; -- subskription..nn.1
  substans_1_N = mkN "substans" "substanser" ; -- substans..nn.1
  substantialitet_1_N = mkN "substantialitet" "substantialiteter" ; -- substantialitet..nn.1
  substantiell_1_A = mkA "substantiell" ; -- substantiell..av.1
  substantiv_1_N = mkN "substantiv" neutrum  ; -- substantiv..nn.1
  substantivera_1_V = mkV "substantiverar" ; -- substantivera..vb.1
  substantiverande_1_N = mkN "substantiverande" ; -- substantiverande..nn.1
  substantiverbar_1_A = mkA "substantiverbar" ; -- substantiverbar..av.1
  substantiverbarhet_1_N = mkN "substantiverbarhet" ; -- substantiverbarhet..nn.1
  substantivering_1_N = mkN "substantivering" ; -- substantivering..nn.1
  substantivfras_1_N = mkN "substantivfras" "substantivfraser" ; -- substantivfras..nn.1
  substantivisk_1_A = mkA "substantivisk" ; -- substantivisk..av.1
  substantivsjuka_1_N = mkN "substantivsjuka" ; -- substantivsjuka..nn.1
  substantivändelse_1_N = mkN "substantivändelse" "substantivändelser" ; -- substantivändelse..nn.1
  substituera_1_V = mkV "substituerar" ; -- substituera..vb.1
  substituerande_1_N = mkN "substituerande" ; -- substituerande..nn.1
  substituerbar_1_A = mkA "substituerbar" ; -- substituerbar..av.1
  substituerbarhet_1_N = mkN "substituerbarhet" ; -- substituerbarhet..nn.1
  substituering_1_N = mkN "substituering" ; -- substituering..nn.1
  substitut_1_N = mkN "substitut" neutrum  ; -- substitut..nn.1
  substitution_1_N = mkN "substitution" ; -- substitution..nn.1
  substitutionskryptografi_1_N = mkN "substitutionskryptografi" ; -- substitutionskryptografi..nn.1
  substrat_1_N = mkN "substrat" neutrum  ; -- substrat..nn.1
  subsumera_1_V = mkV "subsumerar" ; -- subsumera..vb.1
  subsumerande_1_N = mkN "subsumerande" ; -- subsumerande..nn.1
  subsumerbar_1_A = mkA "subsumerbar" ; -- subsumerbar..av.1
  subsumerbarhet_1_N = mkN "subsumerbarhet" ; -- subsumerbarhet..nn.1
  subsumering_1_N = mkN "subsumering" ; -- subsumering..nn.1
  subtil_1_A = mkA "subtil" ; -- subtil..av.1
  subtilitet_1_N = mkN "subtilitet" "subtiliteter" ; -- subtilitet..nn.1
  subtrahend_1_N = mkN "subtrahend" "subtrahender" ; -- subtrahend..nn.1
  subtrahera_1_V = mkV "subtraherar" ; -- subtrahera..vb.1
  subtraherande_1_N = mkN "subtraherande" ; -- subtraherande..nn.1
  subtraherbar_1_A = mkA "subtraherbar" ; -- subtraherbar..av.1
  subtraherbarhet_1_N = mkN "subtraherbarhet" ; -- subtraherbarhet..nn.1
  subtrahering_1_N = mkN "subtrahering" ; -- subtrahering..nn.1
  subtraktion_1_N = mkN "subtraktion" ; -- subtraktion..nn.1
  subtropisk_1_A = mkA "subtropisk" ; -- subtropisk..av.1
  subvention_1_N = mkN "subvention" ; -- subvention..nn.1
  subventionera_1_V = mkV "subventionerar" ; -- subventionera..vb.1
  subventionerande_1_N = mkN "subventionerande" ; -- subventionerande..nn.1
  subventionerbar_1_A = mkA "subventionerbar" ; -- subventionerbar..av.1
  subventionerbarhet_1_N = mkN "subventionerbarhet" ; -- subventionerbarhet..nn.1
  subventionering_1_N = mkN "subventionering" ; -- subventionering..nn.1
  subversiv_1_A = mkA "subversiv" ; -- subversiv..av.1
  succedera_1_V = mkV "succederar" ; -- succedera..vb.1
  succederande_1_N = mkN "succederande" ; -- succederande..nn.1
  succederbar_1_A = mkA "succederbar" ; -- succederbar..av.1
  succederbarhet_1_N = mkN "succederbarhet" ; -- succederbarhet..nn.1
  succedering_1_N = mkN "succedering" ; -- succedering..nn.1
  succession_1_N = mkN "succession" ; -- succession..nn.1
  successionsordning_1_N = mkN "successionsordning" ; -- successionsordning..nn.1
  successiv_1_A = mkA "successiv" ; -- successiv..av.1
  succeés_1_N = mkN "succeés" "succeéser" ; -- succeés..nn.1
  succé_1_N = mkN "succé" "succéer" ; -- succé..nn.1
  succéartad_1_A = mkA "succéartad" ; -- succéartad..av.1
  succéthriller_1_N = mkN "succéthriller" ; -- succéthriller..nn.1
  suck_1_N = mkN "suck" ; -- suck..nn.1
  sucka_1_V = mkV "suckar" ; -- sucka..vb.1
  suckande_1_N = mkN "suckande" ; -- suckande..nn.1
  suckat_1_N = mkN "suckat" ; -- suckat..nn.1
  suckljud_1_N = mkN "suckljud" neutrum  ; -- suckljud..nn.1
  suckulent_1_A = mkA "suckulent" "suckulent" ; -- suckulent..av.1
  suckulent_1_N = mkN "suckulent" "suckulenter" ; -- suckulent..nn.1
  sudanes_1_N = mkN "sudanes" "sudaneser" ; -- sudanes..nn.1
  sudanesisk_1_A = mkA "sudanesisk" ; -- sudanesisk..av.1
  sudanesiska_1_N = mkN "sudanesiska" ; -- sudanesiska..nn.1
  sudband_1_N = mkN "sudband" neutrum  ; -- sudband..nn.1
  sudd_1_N = mkN "sudd" ; -- sudd..nn.1
  sudd_2_N = mkN "sudd" neutrum  ; -- sudd..nn.2
  sudd_3_N = mkN "sudd" ; -- sudd..nn.3
  sudda_1_V = mkV "suddar" ; -- sudda..vb.1
  suddande_1_N = mkN "suddande" ; -- suddande..nn.1
  sudderi_1_N = mkN "sudderi" neutrum  ; -- sudderi..nn.1
  suddgummi_1_N = mkN "suddgummi" "suddgummit" "suddgummin" "suddgummina" ; -- suddgummi..nn.1
  suddig_1_A = mkA "suddig" ; -- suddig..av.1
  suddighet_1_N = mkN "suddighet" "suddigheter" ; -- suddighet..nn.1
  sudoku_1_N = mkN "sudoku" "sudokut" "sudoku" "sudokun" ; -- sudoku..nn.1
  suffigera_1_V = mkV "suffigerar" ; -- suffigera..vb.1
  suffigerande_1_N = mkN "suffigerande" ; -- suffigerande..nn.1
  suffigerbar_1_A = mkA "suffigerbar" ; -- suffigerbar..av.1
  suffigerbarhet_1_N = mkN "suffigerbarhet" ; -- suffigerbarhet..nn.1
  suffigering_1_N = mkN "suffigering" ; -- suffigering..nn.1
  suffisans_1_N = mkN "suffisans" ; -- suffisans..nn.1
  suffix_1_N = mkN "suffix" neutrum  ; -- suffix..nn.1
  sufflera_1_V = mkV "sufflerar" ; -- sufflera..vb.1
  sufflerande_1_N = mkN "sufflerande" ; -- sufflerande..nn.1
  sufflerbar_1_A = mkA "sufflerbar" ; -- sufflerbar..av.1
  sufflerbarhet_1_N = mkN "sufflerbarhet" ; -- sufflerbarhet..nn.1
  sufflering_1_N = mkN "sufflering" ; -- sufflering..nn.1
  sufflett_1_N = mkN "sufflett" "suffletter" ; -- sufflett..nn.1
  sufflé_1_N = mkN "sufflé" "suffléer" ; -- sufflé..nn.1
  sufflör_1_N = mkN "sufflör" "sufflörer" ; -- sufflör..nn.1
  sufflörlucka_1_N = mkN "sufflörlucka" ; -- sufflörlucka..nn.1
  sufflös_1_N = mkN "sufflös" "sufflöser" ; -- sufflös..nn.1
  suffragett_1_N = mkN "suffragett" "suffragetter" ; -- suffragett..nn.1
  sug_1_N = mkN "sug" ; -- sug..nn.1
  sug_2_N = mkN "sug" neutrum  ; -- sug..nn.2
  suga_1_V = mkV "suga" "sög" "sugit" ; -- suga..vb.1
  suga_2_V = mkV "suga" "sög" "sugit" ; -- suga..vb.2
  sugande_1_A = mkA "sugande" ; -- sugande..av.1
  sugande_1_N = mkN "sugande" ; -- sugande..nn.1
  sugen_1_A = mkA "sugen" ; -- sugen..av.1
  sugfas_1_N = mkN "sugfas" "sugfaser" ; -- sugfas..nn.1
  sugga_1_N = mkN "sugga" ; -- sugga..nn.1
  suggerera_1_V = mkV "suggererar" ; -- suggerera..vb.1
  suggererande_1_N = mkN "suggererande" ; -- suggererande..nn.1
  suggererbar_1_A = mkA "suggererbar" ; -- suggererbar..av.1
  suggererbarhet_1_N = mkN "suggererbarhet" ; -- suggererbarhet..nn.1
  suggerering_1_N = mkN "suggerering" ; -- suggerering..nn.1
  suggestibel_1_A = mkA "suggestibel" ; -- suggestibel..av.1
  suggestion_1_N = mkN "suggestion" ; -- suggestion..nn.1
  suggestionskonst_1_N = mkN "suggestionskonst" ; -- suggestionskonst..nn.1
  suggestiv_1_A = mkA "suggestiv" ; -- suggestiv..av.1
  sughöjd_1_N = mkN "sughöjd" ; -- sughöjd..nn.1
  sugkopp_1_N = mkN "sugkopp" ; -- sugkopp..nn.1
  sugning_1_N = mkN "sugning" ; -- sugning..nn.1
  sugrör_1_N = mkN "sugrör" neutrum  ; -- sugrör..nn.1
  suicidal_1_A = mkA "suicidal" ; -- suicidal..av.1
  suicidpreventiv_1_A = mkA "suicidpreventiv" ; -- suicidpreventiv..av.1
  suicidrisk_1_N = mkN "suicidrisk" "suicidrisker" ; -- suicidrisk..nn.1
  sujett_1_N = mkN "sujett" "sujetter" ; -- sujett..nn.1
  sukta_1_V = mkV "suktar" ; -- sukta..vb.1
  suktande_1_N = mkN "suktande" ; -- suktande..nn.1
  sula_1_N = mkN "sula" ; -- sula..nn.1
  sula_1_V = mkV "sular" ; -- sula..vb.1
  sulande_1_N = mkN "sulande" ; -- sulande..nn.1
  sulfa_1_N = mkN "sulfa" ; -- sulfa..nn.1
  sulfat_1_N = mkN "sulfat" neutrum  ; -- sulfat..nn.1
  sulfatfabrik_1_N = mkN "sulfatfabrik" "sulfatfabriker" ; -- sulfatfabrik..nn.1
  sulfatmassa_1_N = mkN "sulfatmassa" ; -- sulfatmassa..nn.1
  sulfid_1_N = mkN "sulfid" "sulfider" ; -- sulfid..nn.1
  sulfit_1_N = mkN "sulfit" neutrum  ; -- sulfit..nn.1
  sulfitfabrik_1_N = mkN "sulfitfabrik" "sulfitfabriker" ; -- sulfitfabrik..nn.1
  sulky_1_N = mkN "sulky" "sulkyer" ; -- sulky..nn.1
  sultan_1_N = mkN "sultan" "sultaner" ; -- sultan..nn.1
  sultanat_1_N = mkN "sultanat" neutrum  ; -- sultanat..nn.1
  sultanrussin_1_N = mkN "sultanrussin" neutrum  ; -- sultanrussin..nn.1
  sumer_1_N = mkN "sumer" "sumerer" ; -- sumer..nn.1
  sumerer_1_N = mkN "sumerer" "sumerern" "sumerer" "sumererna" ; -- sumerer..nn.1
  sumerisk_1_A = mkA "sumerisk" ; -- sumerisk..av.1
  summa_1_N = mkN "summa" ; -- summa..nn.1
  summa_1_V = mkV "summar" ; -- summa..vb.1
  summande_1_N = mkN "summande" ; -- summande..nn.1
  summarisk_1_A = mkA "summarisk" ; -- summarisk..av.1
  summer_1_N = mkN "summer" "summern" "sumrar" "sumrarna" ; -- summer..nn.1
  summera_1_V = mkV "summerar" ; -- summera..vb.1
  summerande_1_N = mkN "summerande" ; -- summerande..nn.1
  summerbar_1_A = mkA "summerbar" ; -- summerbar..av.1
  summerbarhet_1_N = mkN "summerbarhet" ; -- summerbarhet..nn.1
  summering_1_N = mkN "summering" ; -- summering..nn.1
  summerton_1_N = mkN "summerton" "summertoner" ; -- summerton..nn.1
  sumo_1_N = mkN "sumo" ; -- sumo..nn.1
  sumo_2_N = mkN "sumo" "sumot" "sumon" "sumona" ; -- sumo..nn.2
  sump_1_N = mkN "sump" ; -- sump..nn.1
  sump_2_N = mkN "sump" ; -- sump..nn.2
  sumpa_1_V = mkV "sumpar" ; -- sumpa..vb.1
  sumpande_1_N = mkN "sumpande" ; -- sumpande..nn.1
  sumpbäver_1_N = mkN "sumpbäver" ; -- sumpbäver..nn.1
  sumpgas_1_N = mkN "sumpgas" ; -- sumpgas..nn.1
  sumpgasbrand_1_N = mkN "sumpgasbrand" "sumpgasbränder" ; -- sumpgasbrand..nn.1
  sumphöna_1_N = mkN "sumphöna" ; -- sumphöna..nn.1
  sumpig_1_A = mkA "sumpig" ; -- sumpig..av.1
  sumpighet_1_N = mkN "sumpighet" ; -- sumpighet..nn.1
  sumpmark_1_N = mkN "sumpmark" "sumpmarker" ; -- sumpmark..nn.1
  sumpområde_1_N = mkN "sumpområde" ; -- sumpområde..nn.1
  sumprunkare_1_N = mkN "sumprunkare" utrum  ; -- sumprunkare..nn.1
  sumpskog_1_N = mkN "sumpskog" ; -- sumpskog..nn.1
  sund_1_A = mkA "sund" ; -- sund..av.1
  sund_1_N = mkN "sund" neutrum  ; -- sund..nn.1
  sundae_1_N = mkN "sundae" "sundaer" ; -- sundae..nn.1
  sundhet_1_N = mkN "sundhet" ; -- sundhet..nn.1
  sundhetstecken_1_N = mkN "sundhetstecken" "sundhetstecknet" "sundhetstecken" "sundhetstecknen" ; -- sundhetstecken..nn.1
  sundsvallsbo_1_N = mkN "sundsvallsbo" "sundsvallsbor" ; -- sundsvallsbo..nn.1
  sunk_1_N = mkN "sunk" neutrum  ; -- sunk..nn.1
  sunkig_1_A = mkA "sunkig" ; -- sunkig..av.1
  sunkighet_1_N = mkN "sunkighet" "sunkigheter" ; -- sunkighet..nn.1
  sunna_1_N = mkN "sunna" ; -- sunna..nn.1
  sunnanvind_1_N = mkN "sunnanvind" ; -- sunnanvind..nn.1
  sunni_1_N = mkN "sunni" ; -- sunni..nn.1
  sunniarabisk_1_A = mkA "sunniarabisk" ; -- sunniarabisk..av.1
  sunnimuslim_1_N = mkN "sunnimuslim" "sunnimuslimer" ; -- sunnimuslim..nn.1
  sunnimuslimsk_1_A = mkA "sunnimuslimsk" ; -- sunnimuslimsk..av.1
  sunnit_1_N = mkN "sunnit" "sunniter" ; -- sunnit..nn.1
  sunnitisk_1_A = mkA "sunnitisk" ; -- sunnitisk..av.1
  suntält_1_N = mkN "suntält" neutrum  ; -- suntält..nn.1
  sup_1_N = mkN "sup" ; -- sup..nn.1
  supa_1_V = mkV "supa" "söp" "supit" ; -- supa..vb.1
  supande_1_N = mkN "supande" ; -- supande..nn.1
  supare_1_N = mkN "supare" utrum  ; -- supare..nn.1
  supbroder_1_N = mkN "supbroder" "supbrodern" "supbröder" "supbröderna" ; -- supbroder..nn.1
  super_1_A = mkA "super" ; -- super..av.1
  supera_1_V = mkV "superar" ; -- supera..vb.1
  superande_1_N = mkN "superande" ; -- superande..nn.1
  superb_1_A = mkA "superb" ; -- superb..av.1
  superbhet_1_N = mkN "superbhet" ; -- superbhet..nn.1
  superbil_1_N = mkN "superbil" ; -- superbil..nn.1
  superdator_1_N = mkN "superdator" "superdatorer" ; -- superdator..nn.1
  superdiva_1_N = mkN "superdiva" ; -- superdiva..nn.1
  superegoism_1_N = mkN "superegoism" "superegoismer" ; -- superegoism..nn.1
  superelastisk_1_A = mkA "superelastisk" ; -- superelastisk..av.1
  superellips_1_N = mkN "superellips" "superellipser" ; -- superellips..nn.1
  superfin_1_A = mkA "superfin" ; -- superfin..av.1
  superflopp_1_N = mkN "superflopp" ; -- superflopp..nn.1
  superfosfat_1_N = mkN "superfosfat" neutrum  ; -- superfosfat..nn.1
  superförening_1_N = mkN "superförening" ; -- superförening..nn.1
  supergalaxhop_1_N = mkN "supergalaxhop" ; -- supergalaxhop..nn.1
  superglad_1_A = mkA "superglad" "superglatt" ; -- superglad..av.1
  supergod_1_A = mkA "supergod" "supergott" ; -- supergod..av.1
  superhop_1_N = mkN "superhop" ; -- superhop..nn.1
  superhopslinga_1_N = mkN "superhopslinga" ; -- superhopslinga..nn.1
  superi_1_N = mkN "superi" neutrum  ; -- superi..nn.1
  supering_1_N = mkN "supering" ; -- supering..nn.1
  superintendent_1_N = mkN "superintendent" "superintendenter" ; -- superintendent..nn.1
  superjet_1_N = mkN "superjet" ; -- superjet..nn.1
  superkarg_1_N = mkN "superkarg" ; -- superkarg..nn.1
  superkul_1_A = mkA "superkul" ; -- superkul..av.1
  superlativ_1_A = mkA "superlativ" ; -- superlativ..av.1
  superlativ_1_N = mkN "superlativ" "superlativer" ; -- superlativ..nn.1
  superlen_1_A = mkA "superlen" "superlent" ; -- superlen..av.1
  superliga_1_N = mkN "superliga" ; -- superliga..nn.1
  superlätt_1_A = mkA "superlätt" ; -- superlätt..av.1
  superlåg_1_A = mkA "superlåg" ; -- superlåg..av.1
  supermakt_1_N = mkN "supermakt" "supermakter" ; -- supermakt..nn.1
  supermaktsstatus_1_N = mkN "supermaktsstatus" ; -- supermaktsstatus..nn.1
  supermarket_1_N = mkN "supermarket" ; -- supermarket..nn.1
  supermassiv_1_A = mkA "supermassiv" ; -- supermassiv..av.1
  supermatch_1_N = mkN "supermatch" "supermatcher" ; -- supermatch..nn.1
  supermodell_1_N = mkN "supermodell" "supermodeller" ; -- supermodell..nn.1
  supermåne_1_N = mkN "supermåne" utrum  ; -- supermåne..nn.1
  supernova_1_N = mkN "supernova" ; -- supernova..nn.1
  supernovaexplosion_1_N = mkN "supernovaexplosion" ; -- supernovaexplosion..nn.1
  supernovautbrott_1_N = mkN "supernovautbrott" neutrum  ; -- supernovautbrott..nn.1
  supernöjd_1_A = mkA "supernöjd" "supernöjt" ; -- supernöjd..av.1
  superpamp_1_N = mkN "superpamp" ; -- superpamp..nn.1
  superposition_1_N = mkN "superposition" ; -- superposition..nn.1
  supersmaskig_1_A = mkA "supersmaskig" ; -- supersmaskig..av.1
  supersmaskighet_1_N = mkN "supersmaskighet" ; -- supersmaskighet..nn.1
  supersnabb_1_A = mkA "supersnabb" ; -- supersnabb..av.1
  supersnabbhet_1_N = mkN "supersnabbhet" ; -- supersnabbhet..nn.1
  supersnut_1_N = mkN "supersnut" ; -- supersnut..nn.1
  supersonisk_1_A = mkA "supersonisk" ; -- supersonisk..av.1
  superspeed_1_N = mkN "superspeed" ; -- superspeed..nn.1
  superstark_1_A = mkA "superstark" ; -- superstark..av.1
  superstarkhet_1_N = mkN "superstarkhet" ; -- superstarkhet..nn.1
  superstjärna_1_N = mkN "superstjärna" ; -- superstjärna..nn.1
  superstressad_1_A = mkA "superstressad" ; -- superstressad..av.1
  supersugen_1_A = mkA "supersugen" ; -- supersugen..av.1
  supertaggad_1_A = mkA "supertaggad" ; -- supertaggad..av.1
  supertanker_1_N = mkN "supertanker" ; -- supertanker..nn.1
  supertrött_1_A = mkA "supertrött" ; -- supertrött..av.1
  supertungvikt_1_N = mkN "supertungvikt" ; -- supertungvikt..nn.1
  superviktig_1_A = mkA "superviktig" ; -- superviktig..av.1
  superviktighet_1_N = mkN "superviktighet" ; -- superviktighet..nn.1
  supervinst_1_N = mkN "supervinst" "supervinster" ; -- supervinst..nn.1
  supervirus_1_N = mkN "supervirus" neutrum  ; -- supervirus..nn.1
  supervärme_1_N = mkN "supervärme" utrum  ; -- supervärme..nn.1
  supervätska_1_N = mkN "supervätska" ; -- supervätska..nn.1
  supig_1_A = mkA "supig" ; -- supig..av.1
  supinum_1_N = mkN "supinum" "supinumet" "supiner" "supinerna" ; -- supinum..nn.1
  supkalas_1_N = mkN "supkalas" neutrum  ; -- supkalas..nn.1
  supkamrat_1_N = mkN "supkamrat" "supkamrater" ; -- supkamrat..nn.1
  suppleant_1_N = mkN "suppleant" "suppleanter" ; -- suppleant..nn.1
  supplement_1_N = mkN "supplement" neutrum  ; -- supplement..nn.1
  supplementvinkel_1_N = mkN "supplementvinkel" ; -- supplementvinkel..nn.1
  supplementär_1_A = mkA "supplementär" ; -- supplementär..av.1
  supplera_1_V = mkV "supplerar" ; -- supplera..vb.1
  supplerande_1_N = mkN "supplerande" ; -- supplerande..nn.1
  supplerbar_1_A = mkA "supplerbar" ; -- supplerbar..av.1
  supplerbarhet_1_N = mkN "supplerbarhet" ; -- supplerbarhet..nn.1
  supplering_1_N = mkN "supplering" ; -- supplering..nn.1
  supplik_1_N = mkN "supplik" "suppliker" ; -- supplik..nn.1
  supplikant_1_N = mkN "supplikant" "supplikanter" ; -- supplikant..nn.1
  supponera_1_V = mkV "supponerar" ; -- supponera..vb.1
  supponerande_1_N = mkN "supponerande" ; -- supponerande..nn.1
  supponerbar_1_A = mkA "supponerbar" ; -- supponerbar..av.1
  supponerbarhet_1_N = mkN "supponerbarhet" ; -- supponerbarhet..nn.1
  supponering_1_N = mkN "supponering" ; -- supponering..nn.1
  support_1_N = mkN "support" ; -- support..nn.1
  supporter_1_N = mkN "supporter" ; -- supporter..nn.1
  supporterbråk_1_N = mkN "supporterbråk" neutrum  ; -- supporterbråk..nn.1
  supporterklubb_1_N = mkN "supporterklubb" ; -- supporterklubb..nn.1
  supposition_1_N = mkN "supposition" ; -- supposition..nn.1
  suppositorium_1_N = mkN "suppositorium" "suppositoriet" "suppositorier" "suppositorierna" ; -- suppositorium..nn.1
  suppurera_1_V = mkV "suppurerar" ; -- suppurera..vb.1
  suppurerande_1_N = mkN "suppurerande" ; -- suppurerande..nn.1
  suppurering_1_N = mkN "suppurering" ; -- suppurering..nn.1
  supradental_1_A = mkA "supradental" ; -- supradental..av.1
  supradental_1_N = mkN "supradental" "supradentaler" ; -- supradental..nn.1
  supraledande_1_A = mkA "supraledande" ; -- supraledande..av.1
  supraledare_1_N = mkN "supraledare" utrum  ; -- supraledare..nn.1
  supraledning_1_N = mkN "supraledning" ; -- supraledning..nn.1
  supramarin_1_A = mkA "supramarin" ; -- supramarin..av.1
  supranaturalism_1_N = mkN "supranaturalism" "supranaturalismer" ; -- supranaturalism..nn.1
  supranaturalistisk_1_A = mkA "supranaturalistisk" ; -- supranaturalistisk..av.1
  supremati_1_N = mkN "supremati" ; -- supremati..nn.1
  suprematism_1_N = mkN "suprematism" "suprematismer" ; -- suprematism..nn.1
  suprematistisk_1_A = mkA "suprematistisk" ; -- suprematistisk..av.1
  suput_1_N = mkN "suput" ; -- suput..nn.1
  supvisa_1_N = mkN "supvisa" ; -- supvisa..nn.1
  supé_1_N = mkN "supé" "supéer" ; -- supé..nn.1
  sur_1_A = mkA "sur" ; -- sur..av.1
  sura_1_N = mkN "sura" ; -- sura..nn.1
  sura_1_V = mkV "surar" ; -- sura..vb.1
  surande_1_N = mkN "surande" ; -- surande..nn.1
  surapel_1_N = mkN "surapel" ; -- surapel..nn.1
  surbrunn_1_N = mkN "surbrunn" ; -- surbrunn..nn.1
  surdeg_1_N = mkN "surdeg" ; -- surdeg..nn.1
  surdegsbröd_1_N = mkN "surdegsbröd" neutrum  ; -- surdegsbröd..nn.1
  surf_1_N = mkN "surf" ; -- surf..nn.1
  surfa_1_V = mkV "surfar" ; -- surfa..vb.1
  surfande_1_N = mkN "surfande" ; -- surfande..nn.1
  surfare_1_N = mkN "surfare" utrum  ; -- surfare..nn.1
  surfbar_1_A = mkA "surfbar" ; -- surfbar..av.1
  surfbarhet_1_N = mkN "surfbarhet" ; -- surfbarhet..nn.1
  surfbräda_1_N = mkN "surfbräda" ; -- surfbräda..nn.1
  surfbräde_1_N = mkN "surfbräde" ; -- surfbräde..nn.1
  surfing_1_N = mkN "surfing" ; -- surfing..nn.1
  surfingbräda_1_N = mkN "surfingbräda" ; -- surfingbräda..nn.1
  surfingbräde_1_N = mkN "surfingbräde" ; -- surfingbräde..nn.1
  surfning_1_N = mkN "surfning" ; -- surfning..nn.1
  surfoder_1_N = mkN "surfoder" neutrum  ; -- surfoder..nn.1
  surfplatta_1_N = mkN "surfplatta" ; -- surfplatta..nn.1
  surfproffs_1_N = mkN "surfproffs" neutrum  ; -- surfproffs..nn.1
  surhet_1_N = mkN "surhet" "surheter" ; -- surhet..nn.1
  surhet_2_N = mkN "surhet" ; -- surhet..nn.2
  surhetsgrad_1_N = mkN "surhetsgrad" "surhetsgrader" ; -- surhetsgrad..nn.1
  surikat_1_N = mkN "surikat" "surikater" ; -- surikat..nn.1
  surinames_1_N = mkN "surinames" "surinameser" ; -- surinames..nn.1
  surinamesisk_1_A = mkA "surinamesisk" ; -- surinamesisk..av.1
  surinamesiska_1_N = mkN "surinamesiska" ; -- surinamesiska..nn.1
  surkart_1_N = mkN "surkart" ; -- surkart..nn.1
  surkål_1_N = mkN "surkål" ; -- surkål..nn.1
  surkörsbär_1_N = mkN "surkörsbär" neutrum  ; -- surkörsbär..nn.1
  surmagad_1_A = mkA "surmagad" ; -- surmagad..av.1
  surmjölk_1_N = mkN "surmjölk" ; -- surmjölk..nn.1
  surmulen_1_A = mkA "surmulen" ; -- surmulen..av.1
  surmulenhet_1_N = mkN "surmulenhet" ; -- surmulenhet..nn.1
  surna_1_V = mkV "surnar" ; -- surna..vb.1
  surnande_1_N = mkN "surnande" ; -- surnande..nn.1
  surpris_1_N = mkN "surpris" "surpriser" ; -- surpris..nn.1
  surpuppa_1_N = mkN "surpuppa" ; -- surpuppa..nn.1
  surr_1_N = mkN "surr" neutrum  ; -- surr..nn.1
  surra_1_V = mkV "surrar" ; -- surra..vb.1
  surra_2_V = mkV "surrar" ; -- surra..vb.2
  surrande_1_N = mkN "surrande" ; -- surrande..nn.1
  surrealism_1_N = mkN "surrealism" "surrealismer" ; -- surrealism..nn.1
  surrealistisk_1_A = mkA "surrealistisk" ; -- surrealistisk..av.1
  surrogat_1_N = mkN "surrogat" neutrum  ; -- surrogat..nn.1
  surrogatmamma_1_N = mkN "surrogatmamma" ; -- surrogatmamma..nn.1
  surrogatmoder_1_N = mkN "surrogatmoder" "surrogatmodern" "surrogatmödrar" "surrogatmödrarna" ; -- surrogatmoder..nn.1
  surrogatmödraskap_1_N = mkN "surrogatmödraskap" ; -- surrogatmödraskap..nn.1
  surstek_1_N = mkN "surstek" ; -- surstek..nn.1
  surströmming_1_N = mkN "surströmming" ; -- surströmming..nn.1
  sursöt_1_A = mkA "sursöt" ; -- sursöt..av.1
  surögd_1_A = mkA "surögd" "surögt" ; -- surögd..av.1
  surögdhet_1_N = mkN "surögdhet" ; -- surögdhet..nn.1
  sus_1_N = mkN "sus" neutrum  ; -- sus..nn.1
  susa_1_V = mkV "susar" ; -- susa..vb.1
  susande_1_N = mkN "susande" ; -- susande..nn.1
  susning_1_N = mkN "susning" ; -- susning..nn.1
  suspekt_1_A = mkA "suspekt" "suspekt" ; -- suspekt..av.1
  suspekthet_1_N = mkN "suspekthet" ; -- suspekthet..nn.1
  suspendera_1_V = mkV "suspenderar" ; -- suspendera..vb.1
  suspenderande_1_N = mkN "suspenderande" ; -- suspenderande..nn.1
  suspenderbar_1_A = mkA "suspenderbar" ; -- suspenderbar..av.1
  suspenderbarhet_1_N = mkN "suspenderbarhet" ; -- suspenderbarhet..nn.1
  suspendering_1_N = mkN "suspendering" ; -- suspendering..nn.1
  suspension_1_N = mkN "suspension" ; -- suspension..nn.1
  suspensiv_1_A = mkA "suspensiv" ; -- suspensiv..av.1
  suspensoar_1_N = mkN "suspensoar" "suspensoarer" ; -- suspensoar..nn.1
  sussa_1_V = mkV "sussar" ; -- sussa..vb.1
  sussande_1_N = mkN "sussande" ; -- sussande..nn.1
  sutan_1_N = mkN "sutan" "sutaner" ; -- sutan..nn.1
  sutare_1_N = mkN "sutare" utrum  ; -- sutare..nn.1
  sutenör_1_N = mkN "sutenör" "sutenörer" ; -- sutenör..nn.1
  suterräng_1_N = mkN "suterräng" "suterränger" ; -- suterräng..nn.1
  suterrängbyggnad_1_N = mkN "suterrängbyggnad" "suterrängbyggnader" ; -- suterrängbyggnad..nn.1
  suterränghus_1_N = mkN "suterränghus" neutrum  ; -- suterränghus..nn.1
  suterrängplan_1_N = mkN "suterrängplan" neutrum  ; -- suterrängplan..nn.1
  suterrängvåning_1_N = mkN "suterrängvåning" ; -- suterrängvåning..nn.1
  sutur_1_N = mkN "sutur" "suturer" ; -- sutur..nn.1
  suvenir_1_N = mkN "suvenir" "suvenirer" ; -- suvenir..nn.1
  suverän_1_A = mkA "suverän" ; -- suverän..av.1
  suverän_1_N = mkN "suverän" "suveräner" ; -- suverän..nn.1
  suveränitet_1_N = mkN "suveränitet" "suveräniteter" ; -- suveränitet..nn.1
  svabb_1_N = mkN "svabb" ; -- svabb..nn.1
  svabba_1_V = mkV "svabbar" ; -- svabba..vb.1
  svabbande_1_N = mkN "svabbande" ; -- svabbande..nn.1
  svacka_1_N = mkN "svacka" ; -- svacka..nn.1
  svacka_1_V = mkV "svackar" ; -- svacka..vb.1
  svackande_1_N = mkN "svackande" ; -- svackande..nn.1
  svackig_1_A = mkA "svackig" ; -- svackig..av.1
  svackighet_1_N = mkN "svackighet" ; -- svackighet..nn.1
  svackning_1_N = mkN "svackning" ; -- svackning..nn.1
  svada_1_N = mkN "svada" ; -- svada..nn.1
  svag_1_A = mkA "svag" ; -- svag..av.1
  svagartikulerad_1_A = mkA "svagartikulerad" ; -- svagartikulerad..av.1
  svagdricka_1_N = mkN "svagdricka" ; -- svagdricka..nn.1
  svaghet_1_N = mkN "svaghet" "svagheter" ; -- svaghet..nn.1
  svaghetstecken_1_N = mkN "svaghetstecken" "svaghetstecknet" "svaghetstecken" "svaghetstecknen" ; -- svaghetstecken..nn.1
  svaglysande_1_A = mkA "svaglysande" ; -- svaglysande..av.1
  svagpresterande_1_A = mkA "svagpresterande" ; -- svagpresterande..av.1
  svagsint_1_A = mkA "svagsint" "svagsint" ; -- svagsint..av.1
  svagsinthet_1_N = mkN "svagsinthet" ; -- svagsinthet..nn.1
  svagström_1_N = mkN "svagström" "svagströmmen" "svagströmmar" "svagströmmarna" ; -- svagström..nn.1
  svagsynt_1_A = mkA "svagsynt" "svagsynt" ; -- svagsynt..av.1
  svagsynthet_1_N = mkN "svagsynthet" ; -- svagsynthet..nn.1
  svagtonig_1_A = mkA "svagtonig" ; -- svagtonig..av.1
  svagtonighet_1_N = mkN "svagtonighet" ; -- svagtonighet..nn.1
  svaj_1_N = mkN "svaj" neutrum  ; -- svaj..nn.1
  svaja_1_V = mkV "svajar" ; -- svaja..vb.1
  svajande_1_N = mkN "svajande" ; -- svajande..nn.1
  svajig_1_A = mkA "svajig" ; -- svajig..av.1
  svajmast_1_N = mkN "svajmast" "svajmaster" ; -- svajmast..nn.1
  svajning_1_N = mkN "svajning" ; -- svajning..nn.1
  sval_1_A = mkA "sval" ; -- sval..av.1
  sval_1_N = mkN "sval" ; -- sval..nn.1
  svala_1_N = mkN "svala" ; -- svala..nn.1
  svale_1_N = mkN "svale" utrum  ; -- svale..nn.1
  svalg_1_N = mkN "svalg" neutrum  ; -- svalg..nn.1
  svalgmandel_1_N = mkN "svalgmandel" ; -- svalgmandel..nn.1
  svalgång_1_N = mkN "svalgång" ; -- svalgång..nn.1
  svalhet_1_N = mkN "svalhet" ; -- svalhet..nn.1
  svalka_1_N = mkN "svalka" ; -- svalka..nn.1
  svalka_1_V = mkV "svalkar" ; -- svalka..vb.1
  svalkande_1_N = mkN "svalkande" ; -- svalkande..nn.1
  svall_1_N = mkN "svall" neutrum  ; -- svall..nn.1
  svalla_1_V = mkV "svallar" ; -- svalla..vb.1
  svallande_1_N = mkN "svallande" ; -- svallande..nn.1
  svalliknande_1_A = mkA "svalliknande" ; -- svalliknande..av.1
  svallis_1_N = mkN "svallis" ; -- svallis..nn.1
  svallning_1_N = mkN "svallning" ; -- svallning..nn.1
  svallvåg_1_N = mkN "svallvåg" "svallvågor" ; -- svallvåg..nn.1
  svalna_1_V = mkV "svalnar" ; -- svalna..vb.1
  svalnande_1_N = mkN "svalnande" ; -- svalnande..nn.1
  svalstjärt_1_N = mkN "svalstjärt" ; -- svalstjärt..nn.1
  svalstjärtutsprång_1_N = mkN "svalstjärtutsprång" neutrum  ; -- svalstjärtutsprång..nn.1
  svalört_1_N = mkN "svalört" ; -- svalört..nn.1
  svamla_1_V = mkV "svamlar" ; -- svamla..vb.1
  svamlande_1_N = mkN "svamlande" ; -- svamlande..nn.1
  svamlig_1_A = mkA "svamlig" ; -- svamlig..av.1
  svamlighet_1_N = mkN "svamlighet" "svamligheter" ; -- svamlighet..nn.1
  svammel_1_N = mkN "svammel" neutrum  ; -- svammel..nn.1
  svamp_1_N = mkN "svamp" ; -- svamp..nn.1
  svampaktig_1_A = mkA "svampaktig" ; -- svampaktig..av.1
  svampdjur_1_N = mkN "svampdjur" neutrum  ; -- svampdjur..nn.1
  svampfräs_1_N = mkN "svampfräs" neutrum  ; -- svampfräs..nn.1
  svampig_1_A = mkA "svampig" ; -- svampig..av.1
  svampighet_1_N = mkN "svampighet" ; -- svampighet..nn.1
  svampinfektion_1_N = mkN "svampinfektion" ; -- svampinfektion..nn.1
  svampliknande_1_A = mkA "svampliknande" ; -- svampliknande..av.1
  svampmoln_1_N = mkN "svampmoln" neutrum  ; -- svampmoln..nn.1
  svampparasit_1_N = mkN "svampparasit" "svampparasiter" ; -- svampparasit..nn.1
  svampplockare_1_N = mkN "svampplockare" utrum  ; -- svampplockare..nn.1
  svampsjukdom_1_N = mkN "svampsjukdom" ; -- svampsjukdom..nn.1
  svampskog_1_N = mkN "svampskog" ; -- svampskog..nn.1
  svampstuvning_1_N = mkN "svampstuvning" ; -- svampstuvning..nn.1
  svamptråd_1_N = mkN "svamptråd" ; -- svamptråd..nn.1
  svampväxt_1_N = mkN "svampväxt" "svampväxter" ; -- svampväxt..nn.1
  svan_1_N = mkN "svan" ; -- svan..nn.1
  svanesång_1_N = mkN "svanesång" ; -- svanesång..nn.1
  svanhals_1_N = mkN "svanhals" ; -- svanhals..nn.1
  svanhopp_1_N = mkN "svanhopp" neutrum  ; -- svanhopp..nn.1
  svank_1_N = mkN "svank" ; -- svank..nn.1
  svanka_1_V = mkV "svankar" ; -- svanka..vb.1
  svankande_1_N = mkN "svankande" ; -- svankande..nn.1
  svankig_1_A = mkA "svankig" ; -- svankig..av.1
  svankighet_1_N = mkN "svankighet" ; -- svankighet..nn.1
  svankrygg_1_N = mkN "svankrygg" ; -- svankrygg..nn.1
  svankryggig_1_A = mkA "svankryggig" ; -- svankryggig..av.1
  svankryggighet_1_N = mkN "svankryggighet" ; -- svankryggighet..nn.1
  svans_1_N = mkN "svans" ; -- svans..nn.1
  svansa_1_V = mkV "svansar" ; -- svansa..vb.1
  svansande_1_N = mkN "svansande" ; -- svansande..nn.1
  svansföring_1_N = mkN "svansföring" ; -- svansföring..nn.1
  svanskota_1_N = mkN "svanskota" ; -- svanskota..nn.1
  svansmotor_1_N = mkN "svansmotor" "svansmotorer" ; -- svansmotor..nn.1
  svanstipp_1_N = mkN "svanstipp" ; -- svanstipp..nn.1
  svansviftare_1_N = mkN "svansviftare" utrum  ; -- svansviftare..nn.1
  svansviftning_1_N = mkN "svansviftning" ; -- svansviftning..nn.1
  svanvit_1_A = mkA "svanvit" ; -- svanvit..av.1
  svanödla_1_N = mkN "svanödla" ; -- svanödla..nn.1
  svar_1_N = mkN "svar" neutrum  ; -- svar..nn.1
  svara_1_V = mkV "svarar" ; -- svara..vb.1
  svarande_1_N = mkN "svarande" "svaranden" "svaranden" "svarandena" ; -- svarande..nn.1
  svarande_2_N = mkN "svarande" ; -- svarande..nn.2
  svarandepart_1_N = mkN "svarandepart" "svarandeparter" ; -- svarandepart..nn.1
  svarandesida_1_N = mkN "svarandesida" ; -- svarandesida..nn.1
  svaromål_1_N = mkN "svaromål" neutrum  ; -- svaromål..nn.1
  svarskupong_1_N = mkN "svarskupong" "svarskuponger" ; -- svarskupong..nn.1
  svarslös_1_A = mkA "svarslös" ; -- svarslös..av.1
  svarslöshet_1_N = mkN "svarslöshet" ; -- svarslöshet..nn.1
  svart_1_A = mkA "svart" "svart" ; -- svart..av.1
  svartabörshaj_1_N = mkN "svartabörshaj" ; -- svartabörshaj..nn.1
  svartaktig_1_A = mkA "svartaktig" ; -- svartaktig..av.1
  svartalf_1_N = mkN "svartalf" "svartalfer" ; -- svartalf..nn.1
  svartblå_1_A = mkA "svartblå" "svartblått" ; -- svartblå..av.1
  svartbroder_1_N = mkN "svartbroder" "svartbrodern" "svartbröder" "svartbröderna" ; -- svartbroder..nn.1
  svartbrun_1_A = mkA "svartbrun" ; -- svartbrun..av.1
  svartbygge_1_N = mkN "svartbygge" ; -- svartbygge..nn.1
  svartfot_1_N = mkN "svartfot" "svartfötter" ; -- svartfot..nn.1
  svartglänsande_1_A = mkA "svartglänsande" ; -- svartglänsande..av.1
  svarthakedopping_1_N = mkN "svarthakedopping" ; -- svarthakedopping..nn.1
  svarthätta_1_N = mkN "svarthätta" ; -- svarthätta..nn.1
  svarthårig_1_A = mkA "svarthårig" ; -- svarthårig..av.1
  svarting_1_N = mkN "svarting" ; -- svarting..nn.1
  svartjobb_1_N = mkN "svartjobb" neutrum  ; -- svartjobb..nn.1
  svartjobbare_1_N = mkN "svartjobbare" utrum  ; -- svartjobbare..nn.1
  svartklädd_1_A = mkA "svartklädd" ; -- svartklädd..av.1
  svartkonst_1_N = mkN "svartkonst" "svartkonster" ; -- svartkonst..nn.1
  svartkonstbok_1_N = mkN "svartkonstbok" "svartkonstböcker" ; -- svartkonstbok..nn.1
  svartkonstnär_1_N = mkN "svartkonstnär" "svartkonstnärer" ; -- svartkonstnär..nn.1
  svartkrut_1_N = mkN "svartkrut" neutrum  ; -- svartkrut..nn.1
  svartlackerad_1_A = mkA "svartlackerad" ; -- svartlackerad..av.1
  svartlista_1_V = mkV "svartlistar" ; -- svartlista..vb.1
  svartlistande_1_N = mkN "svartlistande" ; -- svartlistande..nn.1
  svartlistning_1_N = mkN "svartlistning" ; -- svartlistning..nn.1
  svartlistningsgräns_1_N = mkN "svartlistningsgräns" "svartlistningsgränser" ; -- svartlistningsgräns..nn.1
  svartmalm_1_N = mkN "svartmalm" ; -- svartmalm..nn.1
  svartmunnad_1_A = mkA "svartmunnad" ; -- svartmunnad..av.1
  svartmuskig_1_A = mkA "svartmuskig" ; -- svartmuskig..av.1
  svartmuskighet_1_N = mkN "svartmuskighet" ; -- svartmuskighet..nn.1
  svartmyra_1_N = mkN "svartmyra" ; -- svartmyra..nn.1
  svartmåla_1_V = mkV "svartmålar" ; -- svartmåla..vb.1
  svartmålad_1_A = mkA "svartmålad" ; -- svartmålad..av.1
  svartmålande_1_N = mkN "svartmålande" ; -- svartmålande..nn.1
  svartmålning_1_N = mkN "svartmålning" ; -- svartmålning..nn.1
  svartmålningskampanj_1_N = mkN "svartmålningskampanj" "svartmålningskampanjer" ; -- svartmålningskampanj..nn.1
  svartna_1_V = mkV "svartnar" ; -- svartna..vb.1
  svartnad_1_N = mkN "svartnad" "svartnader" ; -- svartnad..nn.1
  svartnaglad_1_A = mkA "svartnaglad" ; -- svartnaglad..av.1
  svartnande_1_N = mkN "svartnande" ; -- svartnande..nn.1
  svartoxiderad_1_A = mkA "svartoxiderad" ; -- svartoxiderad..av.1
  svartrock_1_N = mkN "svartrock" ; -- svartrock..nn.1
  svartrock_2_N = mkN "svartrock" ; -- svartrock..nn.2
  svartrost_1_N = mkN "svartrost" ; -- svartrost..nn.1
  svartrot_1_N = mkN "svartrot" ; -- svartrot..nn.1
  svartsjuk_1_A = mkA "svartsjuk" ; -- svartsjuk..av.1
  svartsjuka_1_N = mkN "svartsjuka" ; -- svartsjuka..nn.1
  svartsjukebråk_1_N = mkN "svartsjukebråk" neutrum  ; -- svartsjukebråk..nn.1
  svartsjukedrama_1_N = mkN "svartsjukedrama" "svartsjukedramat" "svartsjukedramer" "svartsjukedramerna" ; -- svartsjukedrama..nn.1
  svartsjukhet_1_N = mkN "svartsjukhet" ; -- svartsjukhet..nn.1
  svartskalle_1_N = mkN "svartskalle" utrum  ; -- svartskalle..nn.1
  svartskimrande_1_A = mkA "svartskimrande" ; -- svartskimrande..av.1
  svartskjorta_1_N = mkN "svartskjorta" ; -- svartskjorta..nn.1
  svartsnäppa_1_N = mkN "svartsnäppa" ; -- svartsnäppa..nn.1
  svartsoppa_1_N = mkN "svartsoppa" ; -- svartsoppa..nn.1
  svartsprit_1_N = mkN "svartsprit" ; -- svartsprit..nn.1
  svartsyn_1_N = mkN "svartsyn" ; -- svartsyn..nn.1
  svartsynt_1_A = mkA "svartsynt" "svartsynt" ; -- svartsynt..av.1
  svartsynthet_1_N = mkN "svartsynthet" "svartsyntheter" ; -- svartsynthet..nn.1
  svartvit_1_A = mkA "svartvit" ; -- svartvit..av.1
  svarv_1_N = mkN "svarv" ; -- svarv..nn.1
  svarva_1_V = mkV "svarvar" ; -- svarva..vb.1
  svarvande_1_N = mkN "svarvande" ; -- svarvande..nn.1
  svarvare_1_N = mkN "svarvare" utrum  ; -- svarvare..nn.1
  svarvchuck_1_N = mkN "svarvchuck" ; -- svarvchuck..nn.1
  svarvning_1_N = mkN "svarvning" ; -- svarvning..nn.1
  svarvstol_1_N = mkN "svarvstol" ; -- svarvstol..nn.1
  svarvstål_1_N = mkN "svarvstål" neutrum  ; -- svarvstål..nn.1
  svassa_1_V = mkV "svassar" ; -- svassa..vb.1
  svassande_1_N = mkN "svassande" ; -- svassande..nn.1
  svastika_1_N = mkN "svastika" ; -- svastika..nn.1
  svavel_1_N = mkN "svavel" neutrum  ; -- svavel..nn.1
  svavelbakterie_1_N = mkN "svavelbakterie" "svavelbakterier" ; -- svavelbakterie..nn.1
  svavelbindning_1_N = mkN "svavelbindning" ; -- svavelbindning..nn.1
  svavelblomma_1_N = mkN "svavelblomma" ; -- svavelblomma..nn.1
  svaveldioxid_1_N = mkN "svaveldioxid" ; -- svaveldioxid..nn.1
  svaveldirektiv_1_N = mkN "svaveldirektiv" neutrum  ; -- svaveldirektiv..nn.1
  svavelförening_1_N = mkN "svavelförening" ; -- svavelförening..nn.1
  svavelgul_1_A = mkA "svavelgul" ; -- svavelgul..av.1
  svavelhalt_1_N = mkN "svavelhalt" "svavelhalter" ; -- svavelhalt..nn.1
  svavelkis_1_N = mkN "svavelkis" ; -- svavelkis..nn.1
  svavelomsättning_1_N = mkN "svavelomsättning" ; -- svavelomsättning..nn.1
  svavelosande_1_A = mkA "svavelosande" ; -- svavelosande..av.1
  svavelpredikant_1_N = mkN "svavelpredikant" "svavelpredikanter" ; -- svavelpredikant..nn.1
  svavelpulver_1_N = mkN "svavelpulver" neutrum  ; -- svavelpulver..nn.1
  svavelrök_1_N = mkN "svavelrök" ; -- svavelrök..nn.1
  svavelsticka_1_N = mkN "svavelsticka" ; -- svavelsticka..nn.1
  svavelsyra_1_N = mkN "svavelsyra" ; -- svavelsyra..nn.1
  svavelsyrlighet_1_N = mkN "svavelsyrlighet" "svavelsyrligheter" ; -- svavelsyrlighet..nn.1
  svavelutsläpp_1_N = mkN "svavelutsläpp" neutrum  ; -- svavelutsläpp..nn.1
  svavelväte_1_N = mkN "svavelväte" ; -- svavelväte..nn.1
  svavelväteproducerande_1_A = mkA "svavelväteproducerande" ; -- svavelväteproducerande..av.1
  svavla_1_V = mkV "svavlar" ; -- svavla..vb.1
  svavlande_1_N = mkN "svavlande" ; -- svavlande..nn.1
  svavling_1_N = mkN "svavling" ; -- svavling..nn.1
  sveamål_1_N = mkN "sveamål" neutrum  ; -- sveamål..nn.1
  svecia_1_N = mkN "svecia" ; -- svecia..nn.1
  svecism_1_N = mkN "svecism" "svecismer" ; -- svecism..nn.1
  sved_1_N = mkN "sved" "sveder" ; -- sved..nn.1
  sveda_1_N = mkN "sveda" ; -- sveda..nn.1
  sveda_1_V = mkV "sveda" "svedde" "svett" ; -- sveda..vb.1
  svedande_1_N = mkN "svedande" ; -- svedande..nn.1
  svedenborgare_1_N = mkN "svedenborgare" utrum  ; -- svedenborgare..nn.1
  svedenborgian_1_N = mkN "svedenborgian" "svedenborgianer" ; -- svedenborgian..nn.1
  svedenborgianism_1_N = mkN "svedenborgianism" ; -- svedenborgianism..nn.1
  svedenborgiansk_1_A = mkA "svedenborgiansk" ; -- svedenborgiansk..av.1
  svedja_1_N = mkN "svedja" ; -- svedja..nn.1
  svedja_1_V = mkV "svedjar" ; -- svedja..vb.1
  svedjande_1_N = mkN "svedjande" ; -- svedjande..nn.1
  svedjebruk_1_N = mkN "svedjebruk" neutrum  ; -- svedjebruk..nn.1
  svedjeland_1_N = mkN "svedjeland" neutrum  ; -- svedjeland..nn.1
  svek_1_N = mkN "svek" neutrum  ; -- svek..nn.1
  svekdebatt_1_N = mkN "svekdebatt" "svekdebatter" ; -- svekdebatt..nn.1
  svekfri_1_A = mkA "svekfri" "svekfritt" ; -- svekfri..av.1
  svekfrihet_1_N = mkN "svekfrihet" ; -- svekfrihet..nn.1
  svekfull_1_A = mkA "svekfull" ; -- svekfull..av.1
  svekfullhet_1_N = mkN "svekfullhet" "svekfullheter" ; -- svekfullhet..nn.1
  sveklig_1_A = mkA "sveklig" ; -- sveklig..av.1
  sveklighet_1_N = mkN "sveklighet" ; -- sveklighet..nn.1
  sveklös_1_A = mkA "sveklös" ; -- sveklös..av.1
  sveklöshet_1_N = mkN "sveklöshet" ; -- sveklöshet..nn.1
  svekoman_1_N = mkN "svekoman" "svekomaner" ; -- svekoman..nn.1
  sven_1_N = mkN "sven" "svennen" "svenner" "svennerna" ; -- sven..nn.1
  svendom_1_N = mkN "svendom" ; -- svendom..nn.1
  svengelska_1_N = mkN "svengelska" ; -- svengelska..nn.1
  svenne_1_N = mkN "svenne" utrum  ; -- svenne..nn.1
  svennebanan_1_N = mkN "svennebanan" "svennebananer" ; -- svennebanan..nn.1
  svennelur_1_N = mkN "svennelur" ; -- svennelur..nn.1
  svensexa_1_N = mkN "svensexa" ; -- svensexa..nn.1
  svensk_engelsk_1_A = mkA "svensk-engelsk" ; -- svensk-engelsk..av.1
  svensk_rysk_1_A = mkA "svensk-rysk" ; -- svensk-rysk..av.1
  svensk_tysk_1_A = mkA "svensk-tysk" ; -- svensk-tysk..av.1
  svensk_1_A = mkA "svensk" ; -- svensk..av.1
  svensk_1_N = mkN "svensk" ; -- svensk..nn.1
  svenska_1_N = mkN "svenska" ; -- svenska..nn.1
  svenska_2_N = mkN "svenska" ; -- svenska..nn.2
  svenskakurs_1_N = mkN "svenskakurs" "svenskakurser" ; -- svenskakurs..nn.1
  svenskalektion_1_N = mkN "svenskalektion" ; -- svenskalektion..nn.1
  svenskalärare_1_N = mkN "svenskalärare" utrum  ; -- svenskalärare..nn.1
  svenskamerikan_1_N = mkN "svenskamerikan" "svenskamerikaner" ; -- svenskamerikan..nn.1
  svenskbygd_1_N = mkN "svenskbygd" "svenskbygder" ; -- svenskbygd..nn.1
  svenskfödd_1_A = mkA "svenskfödd" ; -- svenskfödd..av.1
  svenskförnekare_1_N = mkN "svenskförnekare" utrum  ; -- svenskförnekare..nn.1
  svenskhat_1_N = mkN "svenskhat" neutrum  ; -- svenskhat..nn.1
  svenskhet_1_N = mkN "svenskhet" "svenskheter" ; -- svenskhet..nn.1
  svenskhetsivrare_1_N = mkN "svenskhetsivrare" utrum  ; -- svenskhetsivrare..nn.1
  svenskhetsvurm_1_N = mkN "svenskhetsvurm" ; -- svenskhetsvurm..nn.1
  svenskklingande_1_A = mkA "svenskklingande" ; -- svenskklingande..av.1
  svenskkurs_1_N = mkN "svenskkurs" "svenskkurser" ; -- svenskkurs..nn.1
  svenskledd_1_A = mkA "svenskledd" ; -- svenskledd..av.1
  svensklektion_1_N = mkN "svensklektion" ; -- svensklektion..nn.1
  svensklärare_1_N = mkN "svensklärare" utrum  ; -- svensklärare..nn.1
  svenskmannaanda_1_N = mkN "svenskmannaanda" ; -- svenskmannaanda..nn.1
  svenskproducerad_1_A = mkA "svenskproducerad" ; -- svenskproducerad..av.1
  svenskregistrerad_1_A = mkA "svenskregistrerad" ; -- svenskregistrerad..av.1
  svenskspråkig_1_A = mkA "svenskspråkig" ; -- svenskspråkig..av.1
  svenskspråkighet_1_N = mkN "svenskspråkighet" ; -- svenskspråkighet..nn.1
  svenskstödd_1_A = mkA "svenskstödd" ; -- svenskstödd..av.1
  svensktalande_1_A = mkA "svensktalande" ; -- svensktalande..av.1
  svensktillverkad_1_A = mkA "svensktillverkad" ; -- svensktillverkad..av.1
  svensktoppsmusik_1_N = mkN "svensktoppsmusik" ; -- svensktoppsmusik..nn.1
  svenskull_1_N = mkN "svenskull" ; -- svenskull..nn.1
  svenskundervisning_1_N = mkN "svenskundervisning" ; -- svenskundervisning..nn.1
  svenskägd_1_A = mkA "svenskägd" "svenskägt" ; -- svenskägd..av.1
  svenskättad_1_A = mkA "svenskättad" ; -- svenskättad..av.1
  svensson_1_N = mkN "svensson" "svenssöner" ; -- svensson..nn.1
  svep_1_N = mkN "svep" neutrum  ; -- svep..nn.1
  svepa_1_V = mkV "sveper" ; -- svepa..vb.1
  svepande_1_A = mkA "svepande" ; -- svepande..av.1
  svepande_1_N = mkN "svepande" ; -- svepande..nn.1
  svepe_1_N = mkN "svepe" ; -- svepe..nn.1
  svephammare_1_N = mkN "svephammare" "svephammaren" "svephammare" "svephamrarna" ; -- svephammare..nn.1
  svepning_1_N = mkN "svepning" ; -- svepning..nn.1
  svepskäl_1_N = mkN "svepskäl" neutrum  ; -- svepskäl..nn.1
  sverigedemokrat_1_N = mkN "sverigedemokrat" "sverigedemokrater" ; -- sverigedemokrat..nn.1
  sverigefinne_1_N = mkN "sverigefinne" utrum  ; -- sverigefinne..nn.1
  svets_1_N = mkN "svets" ; -- svets..nn.1
  svetsa_1_V = mkV "svetsar" ; -- svetsa..vb.1
  svetsande_1_N = mkN "svetsande" ; -- svetsande..nn.1
  svetsare_1_N = mkN "svetsare" utrum  ; -- svetsare..nn.1
  svetselektrod_1_N = mkN "svetselektrod" "svetselektroder" ; -- svetselektrod..nn.1
  svetsloppa_1_N = mkN "svetsloppa" ; -- svetsloppa..nn.1
  svetsning_1_N = mkN "svetsning" ; -- svetsning..nn.1
  svetsslang_1_N = mkN "svetsslang" ; -- svetsslang..nn.1
  svetsstång_1_N = mkN "svetsstång" "svetsstänger" ; -- svetsstång..nn.1
  svetstråd_1_N = mkN "svetstråd" ; -- svetstråd..nn.1
  svett_1_A = mkA "svett" ; -- svett..av.1
  svett_1_N = mkN "svett" ; -- svett..nn.1
  svetta_1_V = mkV "svettar" ; -- svetta..vb.1
  svettande_1_N = mkN "svettande" ; -- svettande..nn.1
  svettband_1_N = mkN "svettband" neutrum  ; -- svettband..nn.1
  svettdoftande_1_A = mkA "svettdoftande" ; -- svettdoftande..av.1
  svettdrivande_1_A = mkA "svettdrivande" ; -- svettdrivande..av.1
  svettdroppe_1_N = mkN "svettdroppe" utrum  ; -- svettdroppe..nn.1
  svettdrypande_1_A = mkA "svettdrypande" ; -- svettdrypande..av.1
  svettfläck_1_N = mkN "svettfläck" ; -- svettfläck..nn.1
  svettfuktig_1_A = mkA "svettfuktig" ; -- svettfuktig..av.1
  svetthet_1_N = mkN "svetthet" ; -- svetthet..nn.1
  svettig_1_A = mkA "svettig" ; -- svettig..av.1
  svettighet_1_N = mkN "svettighet" ; -- svettighet..nn.1
  svettkörtel_1_N = mkN "svettkörtel" ; -- svettkörtel..nn.1
  svettning_1_N = mkN "svettning" ; -- svettning..nn.1
  svettpärla_1_N = mkN "svettpärla" ; -- svettpärla..nn.1
  svettrem_1_N = mkN "svettrem" "svettremmen" "svettremmar" "svettremmarna" ; -- svettrem..nn.1
  svettros_1_N = mkN "svettros" "svettrosor" ; -- svettros..nn.1
  svibel_1_N = mkN "svibel" ; -- svibel..nn.1
  svick_1_N = mkN "svick" ; -- svick..nn.1
  svicka_1_N = mkN "svicka" ; -- svicka..nn.1
  svid_1_N = mkN "svid" ; -- svid..nn.1
  svida_1_V = mkV "svida" "sved" "svidit" ; -- svida..vb.1
  svidande_1_N = mkN "svidande" ; -- svidande..nn.1
  svidknott_1_N = mkN "svidknott" neutrum  ; -- svidknott..nn.1
  svika_1_V = mkV "svika" "svek" "svikit" ; -- svika..vb.1
  svikande_1_N = mkN "svikande" ; -- svikande..nn.1
  svikare_1_N = mkN "svikare" utrum  ; -- svikare..nn.1
  sviken_1_A = mkA "sviken" ; -- sviken..av.1
  sviklig_1_A = mkA "sviklig" ; -- sviklig..av.1
  sviklighet_1_N = mkN "sviklighet" ; -- sviklighet..nn.1
  svikt_1_N = mkN "svikt" ; -- svikt..nn.1
  svikta_1_V = mkV "sviktar" ; -- svikta..vb.1
  sviktande_1_N = mkN "sviktande" ; -- sviktande..nn.1
  svikthopp_1_N = mkN "svikthopp" neutrum  ; -- svikthopp..nn.1
  svimanfall_1_N = mkN "svimanfall" neutrum  ; -- svimanfall..nn.1
  svimattack_1_N = mkN "svimattack" "svimattacker" ; -- svimattack..nn.1
  svimfärdig_1_A = mkA "svimfärdig" ; -- svimfärdig..av.1
  svimfärdighet_1_N = mkN "svimfärdighet" ; -- svimfärdighet..nn.1
  svimma_1_V = mkV "svimmar" ; -- svimma..vb.1
  svimmande_1_N = mkN "svimmande" ; -- svimmande..nn.1
  svimning_1_N = mkN "svimning" ; -- svimning..nn.1
  svimningsanfall_1_N = mkN "svimningsanfall" neutrum  ; -- svimningsanfall..nn.1
  svimningsattack_1_N = mkN "svimningsattack" "svimningsattacker" ; -- svimningsattack..nn.1
  svin_1_N = mkN "svin" neutrum  ; -- svin..nn.1
  svinaktig_1_A = mkA "svinaktig" ; -- svinaktig..av.1
  svinaktighet_1_N = mkN "svinaktighet" "svinaktigheter" ; -- svinaktighet..nn.1
  svinbesättning_1_N = mkN "svinbesättning" ; -- svinbesättning..nn.1
  svinblod_1_N = mkN "svinblod" neutrum  ; -- svinblod..nn.1
  svinborst_1_N = mkN "svinborst" neutrum  ; -- svinborst..nn.1
  svinbra_1_Adv = mkAdv "svinbra" ; -- svinbra..ab.1
  svinbra_1_A = mkA "svinbra" ; -- svinbra..av.1
  svindel_1_N = mkN "svindel" ; -- svindel..nn.1
  svindelperspektiv_1_N = mkN "svindelperspektiv" neutrum  ; -- svindelperspektiv..nn.1
  svindla_1_V = mkV "svindlar" ; -- svindla..vb.1
  svindla_2_V = mkV "svindlar" ; -- svindla..vb.2
  svindlande_1_A = mkA "svindlande" ; -- svindlande..av.1
  svindlande_1_N = mkN "svindlande" ; -- svindlande..nn.1
  svindlare_1_N = mkN "svindlare" utrum  ; -- svindlare..nn.1
  svindleri_1_N = mkN "svindleri" "svindleriet" "svindlerier" "svindlerierna" ; -- svindleri..nn.1
  svindlerihärva_1_N = mkN "svindlerihärva" ; -- svindlerihärva..nn.1
  svindleriåtal_1_N = mkN "svindleriåtal" neutrum  ; -- svindleriåtal..nn.1
  svindyr_1_A = mkA "svindyr" ; -- svindyr..av.1
  svindyrhet_1_N = mkN "svindyrhet" ; -- svindyrhet..nn.1
  svineri_1_N = mkN "svineri" "svineriet" "svinerier" "svinerierna" ; -- svineri..nn.1
  svinfett_1_N = mkN "svinfett" "svinfettet" "svinfetter" "svinfetterna" ; -- svinfett..nn.1
  sving_1_N = mkN "sving" neutrum  ; -- sving..nn.1
  sving_2_N = mkN "sving" ; -- sving..nn.2
  svinga_1_V = mkV "svingar" ; -- svinga..vb.1
  svinga_2_V = mkV "svingar" ; -- svinga..vb.2
  svingande_1_N = mkN "svingande" ; -- svingande..nn.1
  svingel_1_N = mkN "svingel" ; -- svingel..nn.1
  svinhugg_1_N = mkN "svinhugg" neutrum  ; -- svinhugg..nn.1
  svinhus_1_N = mkN "svinhus" neutrum  ; -- svinhus..nn.1
  svinig_1_A = mkA "svinig" ; -- svinig..av.1
  svinighet_1_N = mkN "svinighet" "svinigheter" ; -- svinighet..nn.1
  svininfluensa_1_N = mkN "svininfluensa" ; -- svininfluensa..nn.1
  svinkall_1_A = mkA "svinkall" ; -- svinkall..av.1
  svinkallhet_1_N = mkN "svinkallhet" ; -- svinkallhet..nn.1
  svinkoppa_1_N = mkN "svinkoppa" ; -- svinkoppa..nn.1
  svinkött_1_N = mkN "svinkött" neutrum  ; -- svinkött..nn.1
  svinliknande_1_A = mkA "svinliknande" ; -- svinliknande..av.1
  svinläder_1_N = mkN "svinläder" neutrum  ; -- svinläder..nn.1
  svinmålla_1_N = mkN "svinmålla" ; -- svinmålla..nn.1
  svinn_1_N = mkN "svinn" neutrum  ; -- svinn..nn.1
  svinna_1_V = mkV "svinna" "svann" "svunnit" ; -- svinna..vb.1
  svinnande_1_N = mkN "svinnande" ; -- svinnande..nn.1
  svinotta_1_N = mkN "svinotta" ; -- svinotta..nn.1
  svinpäls_1_N = mkN "svinpäls" ; -- svinpäls..nn.1
  svinrygg_1_N = mkN "svinrygg" ; -- svinrygg..nn.1
  svinskötsel_1_N = mkN "svinskötsel" ; -- svinskötsel..nn.1
  svinstall_1_N = mkN "svinstall" neutrum  ; -- svinstall..nn.1
  svinstia_1_N = mkN "svinstia" ; -- svinstia..nn.1
  svintur_1_N = mkN "svintur" ; -- svintur..nn.1
  svinuppfödning_1_N = mkN "svinuppfödning" ; -- svinuppfödning..nn.1
  svir_1_N = mkN "svir" neutrum  ; -- svir..nn.1
  svira_1_V = mkV "svirar" ; -- svira..vb.1
  svirande_1_N = mkN "svirande" ; -- svirande..nn.1
  svirare_1_N = mkN "svirare" utrum  ; -- svirare..nn.1
  svirra_1_V = mkV "svirrar" ; -- svirra..vb.1
  svirrande_1_N = mkN "svirrande" ; -- svirrande..nn.1
  svirvel_1_N = mkN "svirvel" ; -- svirvel..nn.1
  svisch_1_N = mkN "svisch" neutrum  ; -- svisch..nn.1
  svischa_1_V = mkV "svischar" ; -- svischa..vb.1
  svischande_1_N = mkN "svischande" ; -- svischande..nn.1
  sviskon_1_N = mkN "sviskon" neutrum  ; -- sviskon..nn.1
  svit_1_N = mkN "svit" "sviter" ; -- svit..nn.1
  svivel_1_N = mkN "svivel" ; -- svivel..nn.1
  svordom_1_N = mkN "svordom" ; -- svordom..nn.1
  svullen_1_A = mkA "svullen" ; -- svullen..av.1
  svullna_1_V = mkV "svullnar" ; -- svullna..vb.1
  svullnad_1_N = mkN "svullnad" "svullnader" ; -- svullnad..nn.1
  svullnande_1_N = mkN "svullnande" ; -- svullnande..nn.1
  svulst_1_N = mkN "svulst" "svulster" ; -- svulst..nn.1
  svulstig_1_A = mkA "svulstig" ; -- svulstig..av.1
  svulstighet_1_N = mkN "svulstighet" "svulstigheter" ; -- svulstighet..nn.1
  svulten_1_A = mkA "svulten" ; -- svulten..av.1
  svunnenhet_1_N = mkN "svunnenhet" ; -- svunnenhet..nn.1
  svuren_1_A = mkA "svuren" ; -- svuren..av.1
  svägerska_1_N = mkN "svägerska" ; -- svägerska..nn.1
  svälja_1_V = mkV "svälja" "svalde" "svalt" ; -- svälja..vb.1
  sväljande_1_N = mkN "sväljande" ; -- sväljande..nn.1
  svälla_1_V = mkV "sväller" ; -- svälla..vb.1
  svällande_1_N = mkN "svällande" ; -- svällande..nn.1
  svällning_1_N = mkN "svällning" ; -- svällning..nn.1
  svält_1_N = mkN "svält" ; -- svält..nn.1
  svälta_1_V = mkV "svälta" "svalt" "svultit" ; -- svälta..vb.1
  svälta_2_V = mkV "svälta" "svälter" "svält" "svälte" "svultit" "svält" ; -- svälta..vb.2
  svältande_1_N = mkN "svältande" ; -- svältande..nn.1
  svältdrabbad_1_A = mkA "svältdrabbad" ; -- svältdrabbad..av.1
  svältdöd_1_N = mkN "svältdöd" ; -- svältdöd..nn.1
  svältföda_1_N = mkN "svältföda" ; -- svältföda..nn.1
  svältfödd_1_A = mkA "svältfödd" ; -- svältfödd..av.1
  svältföddhet_1_N = mkN "svältföddhet" ; -- svältföddhet..nn.1
  svältgräns_1_N = mkN "svältgräns" ; -- svältgräns..nn.1
  svältkatastrof_1_N = mkN "svältkatastrof" "svältkatastrofer" ; -- svältkatastrof..nn.1
  svältkonstnär_1_N = mkN "svältkonstnär" "svältkonstnärer" ; -- svältkonstnär..nn.1
  svältkost_1_N = mkN "svältkost" ; -- svältkost..nn.1
  svältlön_1_N = mkN "svältlön" "svältlöner" ; -- svältlön..nn.1
  svältmässig_1_A = mkA "svältmässig" ; -- svältmässig..av.1
  svältoffer_1_N = mkN "svältoffer" neutrum  ; -- svältoffer..nn.1
  sväng_1_N = mkN "sväng" ; -- sväng..nn.1
  svänga_1_V = mkV "svänger" ; -- svänga..vb.1
  svänga_2_V = mkV "svänger" ; -- svänga..vb.2
  svängande_1_N = mkN "svängande" ; -- svängande..nn.1
  svängarm_1_N = mkN "svängarm" ; -- svängarm..nn.1
  svängbar_1_A = mkA "svängbar" ; -- svängbar..av.1
  svängbarhet_1_N = mkN "svängbarhet" ; -- svängbarhet..nn.1
  svängbro_1_N = mkN "svängbro" ; -- svängbro..nn.1
  svängd_1_A = mkA "svängd" "svängt" ; -- svängd..av.1
  svängdhet_1_N = mkN "svängdhet" ; -- svängdhet..nn.1
  svängdörr_1_N = mkN "svängdörr" ; -- svängdörr..nn.1
  svängel_1_N = mkN "svängel" ; -- svängel..nn.1
  svänghjul_1_N = mkN "svänghjul" neutrum  ; -- svänghjul..nn.1
  svänghjulsmagnet_1_N = mkN "svänghjulsmagnet" "svänghjulsmagneter" ; -- svänghjulsmagnet..nn.1
  svängig_1_A = mkA "svängig" ; -- svängig..av.1
  svängighet_1_N = mkN "svängighet" ; -- svängighet..nn.1
  svängning_1_N = mkN "svängning" ; -- svängning..nn.1
  svängningskrets_1_N = mkN "svängningskrets" ; -- svängningskrets..nn.1
  svängningsproblem_1_N = mkN "svängningsproblem" neutrum  ; -- svängningsproblem..nn.1
  svängningstal_1_N = mkN "svängningstal" neutrum  ; -- svängningstal..nn.1
  svängom_1_N = mkN "svängom" ; -- svängom..nn.1
  svära_1_V = mkV "svärja" "svärjer" "svär" "svor" "svurit" "svuren" ; -- svära..vb.1
  svärande_1_N = mkN "svärande" ; -- svärande..nn.1
  svärbror_1_N = mkN "svärbror" "svärbröder" ; -- svärbror..nn.1
  svärd_1_N = mkN "svärd" neutrum  ; -- svärd..nn.1
  svärdbärare_1_N = mkN "svärdbärare" utrum  ; -- svärdbärare..nn.1
  svärdfejare_1_N = mkN "svärdfejare" utrum  ; -- svärdfejare..nn.1
  svärdfisk_1_N = mkN "svärdfisk" ; -- svärdfisk..nn.1
  svärdfäste_1_N = mkN "svärdfäste" ; -- svärdfäste..nn.1
  svärdlik_1_A = mkA "svärdlik" ; -- svärdlik..av.1
  svärdlikhet_1_N = mkN "svärdlikhet" ; -- svärdlikhet..nn.1
  svärdliknande_1_A = mkA "svärdliknande" ; -- svärdliknande..av.1
  svärdlängd_1_N = mkN "svärdlängd" ; -- svärdlängd..nn.1
  svärdotter_1_N = mkN "svärdotter" "svärdottern" "svärdöttrar" "svärdöttrarna" ; -- svärdotter..nn.1
  svärdsdans_1_N = mkN "svärdsdans" "svärdsdanser" ; -- svärdsdans..nn.1
  svärdsfejare_1_N = mkN "svärdsfejare" utrum  ; -- svärdsfejare..nn.1
  svärdsklinga_1_N = mkN "svärdsklinga" ; -- svärdsklinga..nn.1
  svärdskydd_1_N = mkN "svärdskydd" neutrum  ; -- svärdskydd..nn.1
  svärdslilja_1_N = mkN "svärdslilja" ; -- svärdslilja..nn.1
  svärdslinje_1_N = mkN "svärdslinje" "svärdslinjer" ; -- svärdslinje..nn.1
  svärdslukare_1_N = mkN "svärdslukare" utrum  ; -- svärdslukare..nn.1
  svärdslös_1_A = mkA "svärdslös" ; -- svärdslös..av.1
  svärdslöshet_1_N = mkN "svärdslöshet" ; -- svärdslöshet..nn.1
  svärdssida_1_N = mkN "svärdssida" ; -- svärdssida..nn.1
  svärdsslukare_1_N = mkN "svärdsslukare" utrum  ; -- svärdsslukare..nn.1
  svärfar_1_N = mkN "svärfader" "svärfadern" "svärfäder" "svärfäderna" ; -- svärfar..nn.1
  svärförälder_1_N = mkN "svärförälder" ; -- svärförälder..nn.1
  svärm_1_N = mkN "svärm" ; -- svärm..nn.1
  svärma_1_V = mkV "svärmar" ; -- svärma..vb.1
  svärmande_1_N = mkN "svärmande" ; -- svärmande..nn.1
  svärmare_1_N = mkN "svärmare" utrum  ; -- svärmare..nn.1
  svärmeri_1_N = mkN "svärmeri" "svärmeriet" "svärmerier" "svärmerierna" ; -- svärmeri..nn.1
  svärmisk_1_A = mkA "svärmisk" ; -- svärmisk..av.1
  svärmor_1_N = mkN "svärmor" "svärmodern" "svärmödrar" "svärmödrarna" ; -- svärmor..nn.1
  svärmorsdröm_1_N = mkN "svärmorsdröm" "svärmorsdrömmen" "svärmorsdrömmar" "svärmorsdrömmarna" ; -- svärmorsdröm..nn.1
  svärmorshistoria_1_N = mkN "svärmorshistoria" "svärmorshistorian" "svärmorshistorier" "svärmorshistorierna" ; -- svärmorshistoria..nn.1
  svärmorsrabatt_1_N = mkN "svärmorsrabatt" "svärmorsrabatter" ; -- svärmorsrabatt..nn.1
  svärord_1_N = mkN "svärord" neutrum  ; -- svärord..nn.1
  svärson_1_N = mkN "svärson" "svärsöner" ; -- svärson..nn.1
  svärsyster_1_N = mkN "svärsyster" ; -- svärsyster..nn.1
  svärta_1_N = mkN "svärta" ; -- svärta..nn.1
  svärta_1_V = mkV "svärtar" ; -- svärta..vb.1
  svärtande_1_N = mkN "svärtande" ; -- svärtande..nn.1
  sväva_1_V = mkV "svävar" ; -- sväva..vb.1
  svävande_1_A = mkA "svävande" ; -- svävande..av.1
  svävande_1_N = mkN "svävande" ; -- svävande..nn.1
  svävarbana_1_N = mkN "svävarbana" ; -- svävarbana..nn.1
  svävare_1_N = mkN "svävare" utrum  ; -- svävare..nn.1
  svävarklippare_1_N = mkN "svävarklippare" utrum  ; -- svävarklippare..nn.1
  svävartåg_1_N = mkN "svävartåg" neutrum  ; -- svävartåg..nn.1
  svävfarkost_1_N = mkN "svävfarkost" "svävfarkoster" ; -- svävfarkost..nn.1
  svävning_1_N = mkN "svävning" ; -- svävning..nn.1
  svåger_1_N = mkN "svåger" ; -- svåger..nn.1
  svågerlag_1_N = mkN "svågerlag" neutrum  ; -- svågerlag..nn.1
  svågerpolitik_1_N = mkN "svågerpolitik" ; -- svågerpolitik..nn.1
  svågerskap_1_N = mkN "svågerskap" neutrum  ; -- svågerskap..nn.1
  svål_1_N = mkN "svål" ; -- svål..nn.1
  svångrem_1_N = mkN "svångrem" "svångremmen" "svångremmar" "svångremmarna" ; -- svångrem..nn.1
  svångremspolitik_1_N = mkN "svångremspolitik" ; -- svångremspolitik..nn.1
  svår_1_A = mkA "svår" ; -- svår..av.1
  svårartad_1_A = mkA "svårartad" ; -- svårartad..av.1
  svåravvislig_1_A = mkA "svåravvislig" ; -- svåravvislig..av.1
  svåravvislighet_1_N = mkN "svåravvislighet" ; -- svåravvislighet..nn.1
  svårbedd_1_A = mkA "svårbedd" ; -- svårbedd..av.1
  svårbedömd_1_A = mkA "svårbedömd" "svårbedömt" ; -- svårbedömd..av.1
  svårbedömdhet_1_N = mkN "svårbedömdhet" ; -- svårbedömdhet..nn.1
  svårbegriplig_1_A = mkA "svårbegriplig" ; -- svårbegriplig..av.1
  svårbegriplighet_1_N = mkN "svårbegriplighet" "svårbegripligheter" ; -- svårbegriplighet..nn.1
  svårbehandlad_1_A = mkA "svårbehandlad" ; -- svårbehandlad..av.1
  svårbemästrad_1_A = mkA "svårbemästrad" ; -- svårbemästrad..av.1
  svårbotad_1_A = mkA "svårbotad" ; -- svårbotad..av.1
  svårdefinierbar_1_A = mkA "svårdefinierbar" ; -- svårdefinierbar..av.1
  svårdefinierbarhet_1_N = mkN "svårdefinierbarhet" ; -- svårdefinierbarhet..nn.1
  svårdiagnosticerad_1_A = mkA "svårdiagnosticerad" ; -- svårdiagnosticerad..av.1
  svårfattlig_1_A = mkA "svårfattlig" ; -- svårfattlig..av.1
  svårfattlighet_1_N = mkN "svårfattlighet" "svårfattligheter" ; -- svårfattlighet..nn.1
  svårflirtad_1_A = mkA "svårflirtad" ; -- svårflirtad..av.1
  svårflörtad_1_A = mkA "svårflörtad" ; -- svårflörtad..av.1
  svårforcerad_1_A = mkA "svårforcerad" ; -- svårforcerad..av.1
  svårformulerad_1_A = mkA "svårformulerad" ; -- svårformulerad..av.1
  svårframkomlig_1_A = mkA "svårframkomlig" ; -- svårframkomlig..av.1
  svårframkomlighet_1_N = mkN "svårframkomlighet" ; -- svårframkomlighet..nn.1
  svårfunnen_1_A = mkA "svårfunnen" "svårfunnet" "svårfunna" "svårfunna" "svårfunnare" "svårfunnast" "svårfunnaste" ; -- svårfunnen..av.1
  svårfångad_1_A = mkA "svårfångad" ; -- svårfångad..av.1
  svårförenlig_1_A = mkA "svårförenlig" ; -- svårförenlig..av.1
  svårförenlighet_1_N = mkN "svårförenlighet" ; -- svårförenlighet..nn.1
  svårförklarlig_1_A = mkA "svårförklarlig" ; -- svårförklarlig..av.1
  svårförklarlighet_1_N = mkN "svårförklarlighet" "svårförklarligheter" ; -- svårförklarlighet..nn.1
  svårförståelig_1_A = mkA "svårförståelig" ; -- svårförståelig..av.1
  svårförståelighet_1_N = mkN "svårförståelighet" "svårförståeligheter" ; -- svårförståelighet..nn.1
  svårförsvarad_1_A = mkA "svårförsvarad" ; -- svårförsvarad..av.1
  svårgenomtränglig_1_A = mkA "svårgenomtränglig" ; -- svårgenomtränglig..av.1
  svårgenomtränglighet_1_N = mkN "svårgenomtränglighet" ; -- svårgenomtränglighet..nn.1
  svårgripbar_1_A = mkA "svårgripbar" ; -- svårgripbar..av.1
  svårhanterlig_1_A = mkA "svårhanterlig" ; -- svårhanterlig..av.1
  svårhanterlighet_1_N = mkN "svårhanterlighet" ; -- svårhanterlighet..nn.1
  svårhet_1_N = mkN "svårhet" ; -- svårhet..nn.1
  svårighet_1_N = mkN "svårighet" "svårigheter" ; -- svårighet..nn.1
  svårighetsgrad_1_N = mkN "svårighetsgrad" "svårighetsgrader" ; -- svårighetsgrad..nn.1
  svårintaglig_1_A = mkA "svårintaglig" ; -- svårintaglig..av.1
  svårintaglighet_1_N = mkN "svårintaglighet" ; -- svårintaglighet..nn.1
  svårkörd_1_A = mkA "svårkörd" "svårkört" ; -- svårkörd..av.1
  svårkördhet_1_N = mkN "svårkördhet" ; -- svårkördhet..nn.1
  svårligen_1_Adv = mkAdv "svårligen" ; -- svårligen..ab.1
  svårläst_1_A = mkA "svårläst" "svårläst" ; -- svårläst..av.1
  svårlästhet_1_N = mkN "svårlästhet" ; -- svårlästhet..nn.1
  svårlöst_1_A = mkA "svårlöst" "svårlöst" ; -- svårlöst..av.1
  svårlösthet_1_N = mkN "svårlösthet" ; -- svårlösthet..nn.1
  svårmod_1_N = mkN "svårmod" neutrum  ; -- svårmod..nn.1
  svårmodig_1_A = mkA "svårmodig" ; -- svårmodig..av.1
  svårmodighet_1_N = mkN "svårmodighet" ; -- svårmodighet..nn.1
  svårobserverad_1_A = mkA "svårobserverad" ; -- svårobserverad..av.1
  svårpratad_1_A = mkA "svårpratad" ; -- svårpratad..av.1
  svårpåvisbar_1_A = mkA "svårpåvisbar" ; -- svårpåvisbar..av.1
  svårpåvisbarhet_1_N = mkN "svårpåvisbarhet" ; -- svårpåvisbarhet..nn.1
  svårsjungen_1_A = mkA "svårsjungen" ; -- svårsjungen..av.1
  svårsjungenhet_1_N = mkN "svårsjungenhet" "svårsjungenheter" ; -- svårsjungenhet..nn.1
  svårslagen_1_A = mkA "svårslagen" ; -- svårslagen..av.1
  svårsläckt_1_A = mkA "svårsläckt" "svårsläckt" ; -- svårsläckt..av.1
  svårsmält_1_A = mkA "svårsmält" "svårsmält" ; -- svårsmält..av.1
  svårsmälthet_1_N = mkN "svårsmälthet" ; -- svårsmälthet..nn.1
  svårspelad_1_A = mkA "svårspelad" ; -- svårspelad..av.1
  svårstartad_1_A = mkA "svårstartad" ; -- svårstartad..av.1
  svårstoppad_1_A = mkA "svårstoppad" ; -- svårstoppad..av.1
  svårsåld_1_A = mkA "svårsåld" "svårsålt" ; -- svårsåld..av.1
  svårsåldhet_1_N = mkN "svårsåldhet" ; -- svårsåldhet..nn.1
  svårtagbar_1_A = mkA "svårtagbar" ; -- svårtagbar..av.1
  svårtillgänglig_1_A = mkA "svårtillgänglig" ; -- svårtillgänglig..av.1
  svårtillgänglighet_1_N = mkN "svårtillgänglighet" ; -- svårtillgänglighet..nn.1
  svårtippad_1_A = mkA "svårtippad" ; -- svårtippad..av.1
  svårtolkad_1_A = mkA "svårtolkad" ; -- svårtolkad..av.1
  svårtydd_1_A = mkA "svårtydd" ; -- svårtydd..av.1
  svårupptäckt_1_A = mkA "svårupptäckt" "svårupptäckt" ; -- svårupptäckt..av.1
  svårutrotad_1_A = mkA "svårutrotad" ; -- svårutrotad..av.1
  svåruttalad_1_A = mkA "svåruttalad" ; -- svåruttalad..av.1
  svåråtkomlig_1_A = mkA "svåråtkomlig" ; -- svåråtkomlig..av.1
  svåråtkomlighet_1_N = mkN "svåråtkomlighet" ; -- svåråtkomlighet..nn.1
  svåröverblickbar_1_A = mkA "svåröverblickbar" ; -- svåröverblickbar..av.1
  svåröverblickbarhet_1_N = mkN "svåröverblickbarhet" ; -- svåröverblickbarhet..nn.1
  svåröversatt_1_A = mkA "svåröversatt" ; -- svåröversatt..av.1
  svåröverskådlig_1_A = mkA "svåröverskådlig" ; -- svåröverskådlig..av.1
  svåröverskådlighet_1_N = mkN "svåröverskådlighet" ; -- svåröverskådlighet..nn.1
  svårövertalad_1_A = mkA "svårövertalad" ; -- svårövertalad..av.1
  svåröverträffad_1_A = mkA "svåröverträffad" ; -- svåröverträffad..av.1
  swahili_1_N = mkN "swahili" ; -- swahili..nn.1
  swastika_1_N = mkN "swastika" ; -- swastika..nn.1
  swaziländare_1_N = mkN "swaziländare" utrum  ; -- swaziländare..nn.1
  swaziländsk_1_A = mkA "swaziländsk" ; -- swaziländsk..av.1
  swaziländska_1_N = mkN "swaziländska" ; -- swaziländska..nn.1
  sweater_1_N = mkN "sweater" ; -- sweater..nn.1
  sweatshirt_1_N = mkN "sweatshirt" "sweatshirten" "sweatshirts" "sweatshirtsarna" ; -- sweatshirt..nn.1
  swedenborgare_1_N = mkN "swedenborgare" utrum  ; -- swedenborgare..nn.1
  swedenborgian_1_N = mkN "swedenborgian" "swedenborgianer" ; -- swedenborgian..nn.1
  swedenborgianism_1_N = mkN "swedenborgianism" ; -- swedenborgianism..nn.1
  swedenborgiansk_1_A = mkA "swedenborgiansk" ; -- swedenborgiansk..av.1
  sweepstake_1_N = mkN "sweepstake" ; -- sweepstake..nn.1
  sweet_1_A = mkA "sweet" ; -- sweet..av.1
  swimmingpool_1_N = mkN "swimmingpool" "swimmingpooler" ; -- swimmingpool..nn.1
  swing_1_N = mkN "swing" ; -- swing..nn.1
  swing_2_N = mkN "swing" ; -- swing..nn.2
  swinga_1_V = mkV "swingar" ; -- swinga..vb.1
  swingande_1_N = mkN "swingande" ; -- swingande..nn.1
  swingball_1_N = mkN "swingball" ; -- swingball..nn.1
  swingkung_1_N = mkN "swingkung" ; -- swingkung..nn.1
  swingmusik_1_N = mkN "swingmusik" ; -- swingmusik..nn.1
  swingpjatt_1_N = mkN "swingpjatt" ; -- swingpjatt..nn.1
  sy_1_V = mkV "syr" ; -- sy..vb.1
  syattiralj_1_N = mkN "syattiralj" "syattiraljer" ; -- syattiralj..nn.1
  sybarit_1_N = mkN "sybarit" "sybariter" ; -- sybarit..nn.1
  sybaritisk_1_A = mkA "sybaritisk" ; -- sybaritisk..av.1
  sybehör_1_N = mkN "sybehör" neutrum  ; -- sybehör..nn.1
  sybåge_1_N = mkN "sybåge" utrum  ; -- sybåge..nn.1
  syd_1_N = mkN "syd" ; -- syd..nn.1
  sydafrikan_1_N = mkN "sydafrikan" "sydafrikaner" ; -- sydafrikan..nn.1
  sydafrikansk_1_A = mkA "sydafrikansk" ; -- sydafrikansk..av.1
  sydafrikanska_1_N = mkN "sydafrikanska" ; -- sydafrikanska..nn.1
  sydamerikan_1_N = mkN "sydamerikan" "sydamerikaner" ; -- sydamerikan..nn.1
  sydamerikanare_1_N = mkN "sydamerikanare" utrum  ; -- sydamerikanare..nn.1
  sydamerikansk_1_A = mkA "sydamerikansk" ; -- sydamerikansk..av.1
  sydeuropeisk_1_A = mkA "sydeuropeisk" ; -- sydeuropeisk..av.1
  sydfransk_1_A = mkA "sydfransk" ; -- sydfransk..av.1
  sydfrukt_1_N = mkN "sydfrukt" "sydfrukter" ; -- sydfrukt..nn.1
  sydgående_1_A = mkA "sydgående" ; -- sydgående..av.1
  sydindisk_1_A = mkA "sydindisk" ; -- sydindisk..av.1
  sydjemenit_1_N = mkN "sydjemenit" "sydjemeniter" ; -- sydjemenit..nn.1
  sydkinesisk_1_A = mkA "sydkinesisk" ; -- sydkinesisk..av.1
  sydkorean_1_N = mkN "sydkorean" "sydkoreaner" ; -- sydkorean..nn.1
  sydkoreansk_1_A = mkA "sydkoreansk" ; -- sydkoreansk..av.1
  sydkoreanska_1_N = mkN "sydkoreanska" ; -- sydkoreanska..nn.1
  sydkust_1_N = mkN "sydkust" "sydkuster" ; -- sydkust..nn.1
  sydlig_1_A = mkA "sydlig" ; -- sydlig..av.1
  sydländsk_1_A = mkA "sydländsk" ; -- sydländsk..av.1
  sydlänning_1_N = mkN "sydlänning" ; -- sydlänning..nn.1
  sydnorsk_1_A = mkA "sydnorsk" ; -- sydnorsk..av.1
  sydossetisk_1_A = mkA "sydossetisk" ; -- sydossetisk..av.1
  sydost_1_N = mkN "sydost" ; -- sydost..nn.1
  sydostasiatisk_1_A = mkA "sydostasiatisk" ; -- sydostasiatisk..av.1
  sydostlig_1_A = mkA "sydostlig" ; -- sydostlig..av.1
  sydpol_1_N = mkN "sydpol" "sydpoler" ; -- sydpol..nn.1
  sydsamisk_1_A = mkA "sydsamisk" ; -- sydsamisk..av.1
  sydsamiska_1_N = mkN "sydsamiska" ; -- sydsamiska..nn.1
  sydsida_1_N = mkN "sydsida" ; -- sydsida..nn.1
  sydslav_1_N = mkN "sydslav" "sydslaver" ; -- sydslav..nn.1
  sydslavisk_1_A = mkA "sydslavisk" ; -- sydslavisk..av.1
  sydspansk_1_A = mkA "sydspansk" ; -- sydspansk..av.1
  sydstat_1_N = mkN "sydstat" "sydstater" ; -- sydstat..nn.1
  sydsvensk_1_A = mkA "sydsvensk" ; -- sydsvensk..av.1
  sydtysk_1_A = mkA "sydtysk" ; -- sydtysk..av.1
  sydvart_1_Adv = mkAdv "sydvart" ; -- sydvart..ab.1
  sydvietnamesisk_1_A = mkA "sydvietnamesisk" ; -- sydvietnamesisk..av.1
  sydväst_1_N = mkN "sydväst" ; -- sydväst..nn.1
  sydväst_2_N = mkN "sydväst" ; -- sydväst..nn.2
  sydvästlig_1_A = mkA "sydvästlig" ; -- sydvästlig..av.1
  sydvästra_1_A = mkA "sydvästra" ; -- sydvästra..av.1
  sydyemenit_1_N = mkN "sydyemenit" "sydyemeniter" ; -- sydyemenit..nn.1
  sydöst_1_N = mkN "sydöst" ; -- sydöst..nn.1
  sydösteuropé_1_N = mkN "sydösteuropé" "sydösteuropéer" ; -- sydösteuropé..nn.1
  sydöstlig_1_A = mkA "sydöstlig" ; -- sydöstlig..av.1
  sydöstra_1_A = mkA "sydöstra" ; -- sydöstra..av.1
  syende_1_N = mkN "syende" ; -- syende..nn.1
  syffe_1_N = mkN "syffe" utrum  ; -- syffe..nn.1
  syffisans_1_N = mkN "syffisans" ; -- syffisans..nn.1
  syfilis_1_N = mkN "syfilis" ; -- syfilis..nn.1
  syfilitisk_1_A = mkA "syfilitisk" ; -- syfilitisk..av.1
  syfta_1_V = mkV "syftar" ; -- syfta..vb.1
  syftande_1_A = mkA "syftande" ; -- syftande..av.1
  syftande_1_N = mkN "syftande" ; -- syftande..nn.1
  syfte_1_N = mkN "syfte" ; -- syfte..nn.1
  syftlinje_1_N = mkN "syftlinje" "syftlinjer" ; -- syftlinje..nn.1
  syftning_1_N = mkN "syftning" ; -- syftning..nn.1
  syftpunkt_1_N = mkN "syftpunkt" "syftpunkter" ; -- syftpunkt..nn.1
  syförening_1_N = mkN "syförening" ; -- syförening..nn.1
  syföreningstant_1_N = mkN "syföreningstant" "syföreningstanter" ; -- syföreningstant..nn.1
  syjunta_1_N = mkN "syjunta" ; -- syjunta..nn.1
  sykofant_1_N = mkN "sykofant" "sykofanter" ; -- sykofant..nn.1
  sykomor_1_N = mkN "sykomor" "sykomoren" "sykomorer" "sykomorerna" ; -- sykomor..nn.1
  syl_1_N = mkN "syl" ; -- syl..nn.1
  sylf_1_N = mkN "sylf" "sylfer" ; -- sylf..nn.1
  sylfid_1_N = mkN "sylfid" "sylfider" ; -- sylfid..nn.1
  sylfidisk_1_A = mkA "sylfidisk" ; -- sylfidisk..av.1
  sylfidiskhet_1_N = mkN "sylfidiskhet" ; -- sylfidiskhet..nn.1
  syll_1_N = mkN "syll" ; -- syll..nn.1
  syllabisk_1_A = mkA "syllabisk" ; -- syllabisk..av.1
  syllogism_1_N = mkN "syllogism" "syllogismer" ; -- syllogism..nn.1
  syllogistisk_1_A = mkA "syllogistisk" ; -- syllogistisk..av.1
  sylt_1_N = mkN "sylt" "sylter" ; -- sylt..nn.1
  sylta_1_N = mkN "sylta" ; -- sylta..nn.1
  sylta_1_V = mkV "syltar" ; -- sylta..vb.1
  syltande_1_N = mkN "syltande" ; -- syltande..nn.1
  syltberedning_1_N = mkN "syltberedning" ; -- syltberedning..nn.1
  syltburk_1_N = mkN "syltburk" ; -- syltburk..nn.1
  syltgurka_1_N = mkN "syltgurka" ; -- syltgurka..nn.1
  syltkaka_1_N = mkN "syltkaka" ; -- syltkaka..nn.1
  syltlök_1_N = mkN "syltlök" ; -- syltlök..nn.1
  syltpäron_1_N = mkN "syltpäron" neutrum  ; -- syltpäron..nn.1
  sylvass_1_A = mkA "sylvass" ; -- sylvass..av.1
  sylvesterbal_1_N = mkN "sylvesterbal" "sylvesterbaler" ; -- sylvesterbal..nn.1
  symaskin_1_N = mkN "symaskin" "symaskiner" ; -- symaskin..nn.1
  symaskinsolja_1_N = mkN "symaskinsolja" ; -- symaskinsolja..nn.1
  symbiont_1_N = mkN "symbiont" "symbionter" ; -- symbiont..nn.1
  symbios_1_N = mkN "symbios" ; -- symbios..nn.1
  symbiotisk_1_A = mkA "symbiotisk" ; -- symbiotisk..av.1
  symbol_1_N = mkN "symbol" "symboler" ; -- symbol..nn.1
  symbolhandling_1_N = mkN "symbolhandling" ; -- symbolhandling..nn.1
  symbolik_1_N = mkN "symbolik" ; -- symbolik..nn.1
  symbolisera_1_V = mkV "symboliserar" ; -- symbolisera..vb.1
  symboliserande_1_N = mkN "symboliserande" ; -- symboliserande..nn.1
  symboliserbar_1_A = mkA "symboliserbar" ; -- symboliserbar..av.1
  symboliserbarhet_1_N = mkN "symboliserbarhet" ; -- symboliserbarhet..nn.1
  symbolisering_1_N = mkN "symbolisering" ; -- symbolisering..nn.1
  symbolisk_1_A = mkA "symbolisk" ; -- symbolisk..av.1
  symbolism_1_N = mkN "symbolism" "symbolismer" ; -- symbolism..nn.1
  symbolist_1_N = mkN "symbolist" "symbolister" ; -- symbolist..nn.1
  symbolistisk_1_A = mkA "symbolistisk" ; -- symbolistisk..av.1
  symbolmässig_1_A = mkA "symbolmässig" ; -- symbolmässig..av.1
  symbolsekvens_1_N = mkN "symbolsekvens" "symbolsekvenser" ; -- symbolsekvens..nn.1
  symbolskatt_1_N = mkN "symbolskatt" "symbolskatter" ; -- symbolskatt..nn.1
  symboltolkning_1_N = mkN "symboltolkning" ; -- symboltolkning..nn.1
  symbolvärde_1_N = mkN "symbolvärde" ; -- symbolvärde..nn.1
  symfoni_1_N = mkN "symfoni" "symfonier" ; -- symfoni..nn.1
  symfoniker_1_N = mkN "symfoniker" "symfonikern" "symfoniker" "symfonikerna" ; -- symfoniker..nn.1
  symfoniorkester_1_N = mkN "symfoniorkester" ; -- symfoniorkester..nn.1
  symfonisk_1_A = mkA "symfonisk" ; -- symfonisk..av.1
  symfys_1_N = mkN "symfys" "symfyser" ; -- symfys..nn.1
  symmetri_1_N = mkN "symmetri" "symmetrier" ; -- symmetri..nn.1
  symmetriaxel_1_N = mkN "symmetriaxel" ; -- symmetriaxel..nn.1
  symmetrilinje_1_N = mkN "symmetrilinje" "symmetrilinjer" ; -- symmetrilinje..nn.1
  symmetriplan_1_N = mkN "symmetriplan" neutrum  ; -- symmetriplan..nn.1
  symmetrisk_1_A = mkA "symmetrisk" ; -- symmetrisk..av.1
  sympatetisk_1_A = mkA "sympatetisk" ; -- sympatetisk..av.1
  sympati_1_N = mkN "sympati" "sympatier" ; -- sympati..nn.1
  sympatisera_1_V = mkV "sympatiserar" ; -- sympatisera..vb.1
  sympatiserande_1_N = mkN "sympatiserande" ; -- sympatiserande..nn.1
  sympatisering_1_N = mkN "sympatisering" ; -- sympatisering..nn.1
  sympatisk_1_A = mkA "sympatisk" ; -- sympatisk..av.1
  sympatistrejk_1_N = mkN "sympatistrejk" "sympatistrejker" ; -- sympatistrejk..nn.1
  sympatistrejka_1_V = mkV "sympatistrejkar" ; -- sympatistrejka..vb.1
  sympatistrejkande_1_N = mkN "sympatistrejkande" ; -- sympatistrejkande..nn.1
  sympatistrejkning_1_N = mkN "sympatistrejkning" ; -- sympatistrejkning..nn.1
  sympatisör_1_N = mkN "sympatisör" "sympatisörer" ; -- sympatisör..nn.1
  symposium_1_N = mkN "symposium" "symposiet" "symposier" "symposierna" ; -- symposium..nn.1
  symptom_1_N = mkN "symptom" neutrum  ; -- symptom..nn.1
  symptomatisk_1_A = mkA "symptomatisk" ; -- symptomatisk..av.1
  symptomfri_1_A = mkA "symptomfri" "symptomfritt" ; -- symptomfri..av.1
  symptomfrihet_1_N = mkN "symptomfrihet" ; -- symptomfrihet..nn.1
  symptomlindrande_1_A = mkA "symptomlindrande" ; -- symptomlindrande..av.1
  symtom_1_N = mkN "symtom" neutrum  ; -- symtom..nn.1
  symtomatisk_1_A = mkA "symtomatisk" ; -- symtomatisk..av.1
  symtomfri_1_A = mkA "symtomfri" "symtomfritt" ; -- symtomfri..av.1
  symtomfrihet_1_N = mkN "symtomfrihet" ; -- symtomfrihet..nn.1
  symtomlindrande_1_A = mkA "symtomlindrande" ; -- symtomlindrande..av.1
  syn_1_N = mkN "syn" "syner" ; -- syn..nn.1
  syn_2_N = mkN "syn" ; -- syn..nn.2
  syna_1_V = mkV "synar" ; -- syna..vb.1
  synagoga_1_N = mkN "synagoga" ; -- synagoga..nn.1
  synande_1_N = mkN "synande" ; -- synande..nn.1
  synapomorfi_1_N = mkN "synapomorfi" "synapomorfier" ; -- synapomorfi..nn.1
  synaps_1_N = mkN "synaps" "synapser" ; -- synaps..nn.1
  synapsbassäng_1_N = mkN "synapsbassäng" "synapsbassänger" ; -- synapsbassäng..nn.1
  synare_1_N = mkN "synare" utrum  ; -- synare..nn.1
  synbar_1_A = mkA "synbar" ; -- synbar..av.1
  synbarhet_1_N = mkN "synbarhet" ; -- synbarhet..nn.1
  synbarlig_1_A = mkA "synbarlig" ; -- synbarlig..av.1
  synbarligen_1_Adv = mkAdv "synbarligen" ; -- synbarligen..ab.1
  synbarlighet_1_N = mkN "synbarlighet" ; -- synbarlighet..nn.1
  synbild_1_N = mkN "synbild" "synbilder" ; -- synbild..nn.1
  syncell_1_N = mkN "syncell" "synceller" ; -- syncell..nn.1
  synd_1_Adv = mkAdv "synd" ; -- synd..ab.1
  synd_1_A = mkA "synd" ; -- synd..av.1
  synd_1_N = mkN "synd" "synder" ; -- synd..nn.1
  synda_1_V = mkV "syndar" ; -- synda..vb.1
  syndabekännelse_1_N = mkN "syndabekännelse" "syndabekännelser" ; -- syndabekännelse..nn.1
  syndabock_1_N = mkN "syndabock" ; -- syndabock..nn.1
  syndabockstänkande_1_N = mkN "syndabockstänkande" ; -- syndabockstänkande..nn.1
  syndabörda_1_N = mkN "syndabörda" ; -- syndabörda..nn.1
  syndafall_1_N = mkN "syndafall" neutrum  ; -- syndafall..nn.1
  syndaflod_1_N = mkN "syndaflod" "syndafloder" ; -- syndaflod..nn.1
  syndaförlåtelse_1_N = mkN "syndaförlåtelse" utrum  ; -- syndaförlåtelse..nn.1
  syndande_1_N = mkN "syndande" ; -- syndande..nn.1
  syndapeng_1_N = mkN "syndapeng" ; -- syndapeng..nn.1
  syndapenning_1_N = mkN "syndapenning" ; -- syndapenning..nn.1
  syndare_1_N = mkN "syndare" utrum  ; -- syndare..nn.1
  syndaregister_1_N = mkN "syndaregister" neutrum  ; -- syndaregister..nn.1
  syndastraff_1_N = mkN "syndastraff" neutrum  ; -- syndastraff..nn.1
  syndbelastad_1_A = mkA "syndbelastad" ; -- syndbelastad..av.1
  synderska_1_N = mkN "synderska" ; -- synderska..nn.1
  syndetikon_1_N = mkN "syndetikon" neutrum  ; -- syndetikon..nn.1
  syndfri_1_A = mkA "syndfri" "syndfritt" ; -- syndfri..av.1
  syndfrihet_1_N = mkN "syndfrihet" "syndfriheter" ; -- syndfrihet..nn.1
  syndfull_1_A = mkA "syndfull" ; -- syndfull..av.1
  syndfullhet_1_N = mkN "syndfullhet" ; -- syndfullhet..nn.1
  syndig_1_A = mkA "syndig" ; -- syndig..av.1
  syndighet_1_N = mkN "syndighet" ; -- syndighet..nn.1
  syndikalism_1_N = mkN "syndikalism" "syndikalismer" ; -- syndikalism..nn.1
  syndikalist_1_N = mkN "syndikalist" "syndikalister" ; -- syndikalist..nn.1
  syndikalistisk_1_A = mkA "syndikalistisk" ; -- syndikalistisk..av.1
  syndikat_1_N = mkN "syndikat" neutrum  ; -- syndikat..nn.1
  syndrom_1_N = mkN "syndrom" neutrum  ; -- syndrom..nn.1
  synekdoke_1_N = mkN "synekdoke" utrum  ; -- synekdoke..nn.1
  syneman_1_N = mkN "syneman" "synemannen" "synemän" "synemännen" ; -- syneman..nn.1
  synergi_1_N = mkN "synergi" "synergier" ; -- synergi..nn.1
  synergism_1_N = mkN "synergism" "synergismer" ; -- synergism..nn.1
  synergistisk_1_A = mkA "synergistisk" ; -- synergistisk..av.1
  synestesi_1_N = mkN "synestesi" "synestesier" ; -- synestesi..nn.1
  synfel_1_N = mkN "synfel" "synfelet" "synfel" "synfelen" ; -- synfel..nn.1
  synfält_1_N = mkN "synfält" neutrum  ; -- synfält..nn.1
  synförmåga_1_N = mkN "synförmåga" ; -- synförmåga..nn.1
  synförnimmelse_1_N = mkN "synförnimmelse" "synförnimmelser" ; -- synförnimmelse..nn.1
  synhåll_1_N = mkN "synhåll" ; -- synhåll..nn.1
  synintryck_1_N = mkN "synintryck" neutrum  ; -- synintryck..nn.1
  synk_1_N = mkN "synk" ; -- synk..nn.1
  synka_1_V = mkV "synkar" ; -- synka..vb.1
  synkande_1_N = mkN "synkande" ; -- synkande..nn.1
  synklinal_1_N = mkN "synklinal" "synklinaler" ; -- synklinal..nn.1
  synkning_1_N = mkN "synkning" ; -- synkning..nn.1
  synkop_1_N = mkN "synkop" "synkoper" ; -- synkop..nn.1
  synkope_1_N = mkN "synkope" utrum  ; -- synkope..nn.1
  synkopera_1_V = mkV "synkoperar" ; -- synkopera..vb.1
  synkoperad_1_A = mkA "synkoperad" ; -- synkoperad..av.1
  synkoperande_1_N = mkN "synkoperande" ; -- synkoperande..nn.1
  synkoperbar_1_A = mkA "synkoperbar" ; -- synkoperbar..av.1
  synkoperbarhet_1_N = mkN "synkoperbarhet" ; -- synkoperbarhet..nn.1
  synkopering_1_N = mkN "synkopering" ; -- synkopering..nn.1
  synkopisk_1_A = mkA "synkopisk" ; -- synkopisk..av.1
  synkpuls_1_N = mkN "synkpuls" "synkpulser" ; -- synkpuls..nn.1
  synkretism_1_N = mkN "synkretism" "synkretismer" ; -- synkretism..nn.1
  synkretistisk_1_A = mkA "synkretistisk" ; -- synkretistisk..av.1
  synkrets_1_N = mkN "synkrets" ; -- synkrets..nn.1
  synkron_1_A = mkA "synkron" ; -- synkron..av.1
  synkronisera_1_V = mkV "synkroniserar" ; -- synkronisera..vb.1
  synkroniserande_1_N = mkN "synkroniserande" ; -- synkroniserande..nn.1
  synkroniserbar_1_A = mkA "synkroniserbar" ; -- synkroniserbar..av.1
  synkroniserbarhet_1_N = mkN "synkroniserbarhet" ; -- synkroniserbarhet..nn.1
  synkronisering_1_N = mkN "synkronisering" ; -- synkronisering..nn.1
  synkronisk_1_A = mkA "synkronisk" ; -- synkronisk..av.1
  synkronism_1_N = mkN "synkronism" "synkronismer" ; -- synkronism..nn.1
  synkrotron_1_N = mkN "synkrotron" "synkrotroner" ; -- synkrotron..nn.1
  synkrotronljusring_1_N = mkN "synkrotronljusring" ; -- synkrotronljusring..nn.1
  synlig_1_A = mkA "synlig" ; -- synlig..av.1
  synliggöra_1_V = mkV "synliggöra" "synliggjorde" "synliggjort" ; -- synliggöra..vb.1
  synliggörande_1_N = mkN "synliggörande" ; -- synliggörande..nn.1
  synlighet_1_N = mkN "synlighet" "synligheter" ; -- synlighet..nn.1
  synnedsättning_1_N = mkN "synnedsättning" ; -- synnedsättning..nn.1
  synnerlig_1_A = mkA "synnerlig" ; -- synnerlig..av.1
  synnerligen_1_Adv = mkAdv "synnerligen" ; -- synnerligen..ab.1
  synnerv_1_N = mkN "synnerv" "synnerver" ; -- synnerv..nn.1
  synod_1_N = mkN "synod" "synoder" ; -- synod..nn.1
  synodal_1_A = mkA "synodal" ; -- synodal..av.1
  synodisk_1_A = mkA "synodisk" ; -- synodisk..av.1
  synonym_1_A = mkA "synonym" ; -- synonym..av.1
  synonym_1_N = mkN "synonym" "synonymer" ; -- synonym..nn.1
  synonymi_1_N = mkN "synonymi" "synonymier" ; -- synonymi..nn.1
  synonymlexikon_1_N = mkN "synonymlexikon" neutrum  ; -- synonymlexikon..nn.1
  synonymmängd_1_N = mkN "synonymmängd" "synonymmängder" ; -- synonymmängd..nn.1
  synonymordbok_1_N = mkN "synonymordbok" "synonymordböcker" ; -- synonymordbok..nn.1
  synonympar_1_N = mkN "synonympar" neutrum  ; -- synonympar..nn.1
  synops_1_N = mkN "synops" "synopser" ; -- synops..nn.1
  synopsis_1_N = mkN "synopsis" ; -- synopsis..nn.1
  synoptiker_1_N = mkN "synoptiker" "synoptikern" "synoptiker" "synoptikerna" ; -- synoptiker..nn.1
  synoptisk_1_A = mkA "synoptisk" ; -- synoptisk..av.1
  synorgan_1_N = mkN "synorgan" neutrum  ; -- synorgan..nn.1
  synpunkt_1_N = mkN "synpunkt" "synpunkter" ; -- synpunkt..nn.1
  synrand_1_N = mkN "synrand" ; -- synrand..nn.1
  synset_1_N = mkN "synset" neutrum  ; -- synset..nn.1
  synsinne_1_N = mkN "synsinne" ; -- synsinne..nn.1
  synsjukdom_1_N = mkN "synsjukdom" ; -- synsjukdom..nn.1
  synsk_1_A = mkA "synsk" ; -- synsk..av.1
  synskadad_1_A = mkA "synskadad" ; -- synskadad..av.1
  synskhet_1_N = mkN "synskhet" ; -- synskhet..nn.1
  synsätt_1_N = mkN "synsätt" neutrum  ; -- synsätt..nn.1
  synt_1_N = mkN "synt" ; -- synt..nn.1
  syntagm_1_N = mkN "syntagm" neutrum  ; -- syntagm..nn.1
  syntaktisk_1_A = mkA "syntaktisk" ; -- syntaktisk..av.1
  syntax_1_N = mkN "syntax" "syntaxer" ; -- syntax..nn.1
  syntaxanalys_1_N = mkN "syntaxanalys" "syntaxanalyser" ; -- syntaxanalys..nn.1
  syntaxträd_1_N = mkN "syntaxträd" neutrum  ; -- syntaxträd..nn.1
  syntband_1_N = mkN "syntband" neutrum  ; -- syntband..nn.1
  syntes_1_N = mkN "syntes" "synteser" ; -- syntes..nn.1
  syntet_1_N = mkN "syntet" "synteter" ; -- syntet..nn.1
  syntetfiber_1_N = mkN "syntetfiber" "syntetfibern" "syntetfibrer" "syntetfibrerna" ; -- syntetfiber..nn.1
  syntetisera_1_V = mkV "syntetiserar" ; -- syntetisera..vb.1
  syntetiserande_1_N = mkN "syntetiserande" ; -- syntetiserande..nn.1
  syntetiserbar_1_A = mkA "syntetiserbar" ; -- syntetiserbar..av.1
  syntetiserbarhet_1_N = mkN "syntetiserbarhet" ; -- syntetiserbarhet..nn.1
  syntetisering_1_N = mkN "syntetisering" ; -- syntetisering..nn.1
  syntetisk_1_A = mkA "syntetisk" ; -- syntetisk..av.1
  syntetklädsel_1_N = mkN "syntetklädsel" ; -- syntetklädsel..nn.1
  syntetmaterial_1_N = mkN "syntetmaterial" neutrum  ; -- syntetmaterial..nn.1
  synthesizer_1_N = mkN "synthesizer" ; -- synthesizer..nn.1
  syntmusik_1_N = mkN "syntmusik" ; -- syntmusik..nn.1
  syntolka_1_V = mkV "syntolkar" ; -- syntolka..vb.1
  syntolkande_1_N = mkN "syntolkande" ; -- syntolkande..nn.1
  syntolkning_1_N = mkN "syntolkning" ; -- syntolkning..nn.1
  synvidd_1_N = mkN "synvidd" ; -- synvidd..nn.1
  synvilla_1_N = mkN "synvilla" ; -- synvilla..nn.1
  synvinkel_1_N = mkN "synvinkel" ; -- synvinkel..nn.1
  synål_1_N = mkN "synål" ; -- synål..nn.1
  syo_1_N = mkN "syo" "syor" ; -- syo..nn.1
  syokonsulent_1_N = mkN "syokonsulent" "syokonsulenter" ; -- syokonsulent..nn.1
  syperb_1_A = mkA "syperb" ; -- syperb..av.1
  syperbhet_1_N = mkN "syperbhet" ; -- syperbhet..nn.1
  syra_basbalans_1_N = mkN "syra-basbalans" ; -- syra-basbalans..nn.1
  syra_basbalans_2_N = mkN "syra/basbalans" ; -- syra-basbalans..nn.2
  syra_1_N = mkN "syra" ; -- syra..nn.1
  syra_1_V = mkV "syrar" ; -- syra..vb.1
  syraattack_1_N = mkN "syraattack" "syraattacker" ; -- syraattack..nn.1
  syracistern_1_N = mkN "syracistern" "syracisterner" ; -- syracistern..nn.1
  syrad_1_A = mkA "syrad" ; -- syrad..av.1
  syrafast_1_A = mkA "syrafast" "syrafast" ; -- syrafast..av.1
  syrafasthet_1_N = mkN "syrafasthet" ; -- syrafasthet..nn.1
  syrak_1_A = mkA "syrak" ; -- syrak..av.1
  syraläckage_1_N = mkN "syraläckage" "syraläckaget" "syraläckage" "syraläckagen" ; -- syraläckage..nn.1
  syrande_1_N = mkN "syrande" ; -- syrande..nn.1
  syraprovare_1_N = mkN "syraprovare" utrum  ; -- syraprovare..nn.1
  syre_1_N = mkN "syre" ; -- syre..nn.1
  syreatom_1_N = mkN "syreatom" "syreatomer" ; -- syreatom..nn.1
  syrebrist_1_N = mkN "syrebrist" ; -- syrebrist..nn.1
  syrefattig_1_A = mkA "syrefattig" ; -- syrefattig..av.1
  syrefattighet_1_N = mkN "syrefattighet" ; -- syrefattighet..nn.1
  syrefordrande_1_A = mkA "syrefordrande" ; -- syrefordrande..av.1
  syrefri_1_A = mkA "syrefri" "syrefritt" ; -- syrefri..av.1
  syrefält_1_N = mkN "syrefält" neutrum  ; -- syrefält..nn.1
  syreförbrukande_1_A = mkA "syreförbrukande" ; -- syreförbrukande..av.1
  syreisotop_1_N = mkN "syreisotop" "syreisotoper" ; -- syreisotop..nn.1
  syremolekyl_1_N = mkN "syremolekyl" "syremolekyler" ; -- syremolekyl..nn.1
  syren_1_N = mkN "syren" "syrener" ; -- syren..nn.1
  syrenberså_1_N = mkN "syrenberså" "syrenbersåer" ; -- syrenberså..nn.1
  syrenbuskage_1_N = mkN "syrenbuskage" "syrenbuskaget" "syrenbuskage" "syrenbuskagen" ; -- syrenbuskage..nn.1
  syrenhäck_1_N = mkN "syrenhäck" ; -- syrenhäck..nn.1
  syrenkvist_1_N = mkN "syrenkvist" ; -- syrenkvist..nn.1
  syreproducerande_1_A = mkA "syreproducerande" ; -- syreproducerande..av.1
  syrerik_1_A = mkA "syrerik" ; -- syrerik..av.1
  syrerikhet_1_N = mkN "syrerikhet" ; -- syrerikhet..nn.1
  syresättning_1_N = mkN "syresättning" ; -- syresättning..nn.1
  syretransport_1_N = mkN "syretransport" "syretransporter" ; -- syretransport..nn.1
  syreupptagande_1_A = mkA "syreupptagande" ; -- syreupptagande..av.1
  syreupptagning_1_N = mkN "syreupptagning" ; -- syreupptagning..nn.1
  syreupptagningsförmåga_1_N = mkN "syreupptagningsförmåga" ; -- syreupptagningsförmåga..nn.1
  syrgas_1_N = mkN "syrgas" ; -- syrgas..nn.1
  syrgasmask_1_N = mkN "syrgasmask" "syrgasmasker" ; -- syrgasmask..nn.1
  syrgasmolekyl_1_N = mkN "syrgasmolekyl" "syrgasmolekyler" ; -- syrgasmolekyl..nn.1
  syrgastub_1_N = mkN "syrgastub" "syrgastuber" ; -- syrgastub..nn.1
  syrier_1_N = mkN "syrier" "syriern" "syrier" "syrierna" ; -- syrier..nn.1
  syrinx_1_N = mkN "syrinx" ; -- syrinx..nn.1
  syrisk_1_A = mkA "syrisk" ; -- syrisk..av.1
  syriska_1_N = mkN "syriska" ; -- syriska..nn.1
  syriska_2_N = mkN "syriska" ; -- syriska..nn.2
  syrlig_1_A = mkA "syrlig" ; -- syrlig..av.1
  syrlighet_1_N = mkN "syrlighet" ; -- syrlighet..nn.1
  syrlighet_2_N = mkN "syrlighet" "syrligheter" ; -- syrlighet..nn.2
  syrra_1_N = mkN "syrra" ; -- syrra..nn.1
  syrsa_1_N = mkN "syrsa" ; -- syrsa..nn.1
  syrsätta_1_V = mkV "syrsätta" "syrsätter" "syrsätt" "syrsatte" "syrsatt" "syrsatt" ; -- syrsätta..vb.1
  syrsättande_1_N = mkN "syrsättande" ; -- syrsättande..nn.1
  syrtut_1_N = mkN "syrtut" "syrtuter" ; -- syrtut..nn.1
  sysilke_1_N = mkN "sysilke" ; -- sysilke..nn.1
  syskon_1_N = mkN "syskon" neutrum  ; -- syskon..nn.1
  syskonbarn_1_N = mkN "syskonbarn" neutrum  ; -- syskonbarn..nn.1
  syskonbråk_1_N = mkN "syskonbråk" neutrum  ; -- syskonbråk..nn.1
  syskonbädd_1_N = mkN "syskonbädd" ; -- syskonbädd..nn.1
  syskondrag_1_N = mkN "syskondrag" neutrum  ; -- syskondrag..nn.1
  syskongrupp_1_N = mkN "syskongrupp" "syskongrupper" ; -- syskongrupp..nn.1
  syskonkärlek_1_N = mkN "syskonkärlek" ; -- syskonkärlek..nn.1
  syskonlig_1_A = mkA "syskonlig" ; -- syskonlig..av.1
  syskonskap_1_N = mkN "syskonskap" neutrum  ; -- syskonskap..nn.1
  syskonskara_1_N = mkN "syskonskara" ; -- syskonskara..nn.1
  syskontycke_1_N = mkN "syskontycke" ; -- syskontycke..nn.1
  syskonäktenskap_1_N = mkN "syskonäktenskap" neutrum  ; -- syskonäktenskap..nn.1
  sysselsatt_1_A = mkA "sysselsatt" ; -- sysselsatt..av.1
  sysselsätta_1_V = mkV "sysselsätta" "sysselsätter" "sysselsätt" "sysselsatte" "sysselsatt" "sysselsatt" ; -- sysselsätta..vb.1
  sysselsättande_1_N = mkN "sysselsättande" ; -- sysselsättande..nn.1
  sysselsättning_1_N = mkN "sysselsättning" ; -- sysselsättning..nn.1
  sysselsättningsfrämjande_1_A = mkA "sysselsättningsfrämjande" ; -- sysselsättningsfrämjande..av.1
  sysselsättningsgrad_1_N = mkN "sysselsättningsgrad" "sysselsättningsgrader" ; -- sysselsättningsgrad..nn.1
  sysselsättningsmässig_1_A = mkA "sysselsättningsmässig" ; -- sysselsättningsmässig..av.1
  sysselsättningspolitik_1_N = mkN "sysselsättningspolitik" ; -- sysselsättningspolitik..nn.1
  sysselsättningspolitisk_1_A = mkA "sysselsättningspolitisk" ; -- sysselsättningspolitisk..av.1
  sysselsättningsskapande_1_A = mkA "sysselsättningsskapande" ; -- sysselsättningsskapande..av.1
  syssla_1_N = mkN "syssla" ; -- syssla..nn.1
  syssla_2_N = mkN "syssla" ; -- syssla..nn.2
  syssla_1_V = mkV "sysslar" ; -- syssla..vb.1
  sysslande_1_N = mkN "sysslande" ; -- sysslande..nn.1
  syssling_1_N = mkN "syssling" ; -- syssling..nn.1
  sysslolös_1_A = mkA "sysslolös" ; -- sysslolös..av.1
  sysslolöshet_1_N = mkN "sysslolöshet" ; -- sysslolöshet..nn.1
  syssloman_1_N = mkN "syssloman" "sysslomannen" "sysslomän" "sysslomännen" ; -- syssloman..nn.1
  system_1_N = mkN "system" neutrum  ; -- system..nn.1
  systemanalys_1_N = mkN "systemanalys" ; -- systemanalys..nn.1
  systematik_1_N = mkN "systematik" ; -- systematik..nn.1
  systematisera_1_V = mkV "systematiserar" ; -- systematisera..vb.1
  systematiserande_1_N = mkN "systematiserande" ; -- systematiserande..nn.1
  systematiserbar_1_A = mkA "systematiserbar" ; -- systematiserbar..av.1
  systematiserbarhet_1_N = mkN "systematiserbarhet" ; -- systematiserbarhet..nn.1
  systematisering_1_N = mkN "systematisering" ; -- systematisering..nn.1
  systematisk_1_A = mkA "systematisk" ; -- systematisk..av.1
  systembolag_1_N = mkN "systembolag" neutrum  ; -- systembolag..nn.1
  systemera_1_V = mkV "systemerar" ; -- systemera..vb.1
  systemerande_1_N = mkN "systemerande" ; -- systemerande..nn.1
  systemerare_1_N = mkN "systemerare" utrum  ; -- systemerare..nn.1
  systemering_1_N = mkN "systemering" ; -- systemering..nn.1
  systemkamera_1_N = mkN "systemkamera" ; -- systemkamera..nn.1
  systemkritik_1_N = mkN "systemkritik" ; -- systemkritik..nn.1
  systemkritisk_1_A = mkA "systemkritisk" ; -- systemkritisk..av.1
  systemkö_1_N = mkN "systemkö" "systemkön" "systemköer" "systemköerna" ; -- systemkö..nn.1
  systemman_1_N = mkN "systemman" "systemmannen" "systemmän" "systemmännen" ; -- systemman..nn.1
  systemmässig_1_A = mkA "systemmässig" ; -- systemmässig..av.1
  systemskifte_1_N = mkN "systemskifte" ; -- systemskifte..nn.1
  systemutvecklare_1_N = mkN "systemutvecklare" utrum  ; -- systemutvecklare..nn.1
  syster_1_N = mkN "syster" ; -- syster..nn.1
  systerbarn_1_N = mkN "systerbarn" neutrum  ; -- systerbarn..nn.1
  systerdotter_1_N = mkN "systerdotter" "systerdottern" "systerdöttrar" "systerdöttrarna" ; -- systerdotter..nn.1
  systerfartyg_1_N = mkN "systerfartyg" neutrum  ; -- systerfartyg..nn.1
  systerlig_1_A = mkA "systerlig" ; -- systerlig..av.1
  systerskap_1_N = mkN "systerskap" neutrum  ; -- systerskap..nn.1
  systerson_1_N = mkN "systerson" "systersöner" ; -- systerson..nn.1
  systerspråk_1_N = mkN "systerspråk" neutrum  ; -- systerspråk..nn.1
  systole_1_N = mkN "systole" utrum  ; -- systole..nn.1
  systolisk_1_A = mkA "systolisk" ; -- systolisk..av.1
  sytråd_1_N = mkN "sytråd" ; -- sytråd..nn.1
  säck_1_N = mkN "säck" ; -- säck..nn.1
  säcka_1_V = mkV "säckar" ; -- säcka..vb.1
  säckande_1_N = mkN "säckande" ; -- säckande..nn.1
  säckformig_1_A = mkA "säckformig" ; -- säckformig..av.1
  säckig_1_A = mkA "säckig" ; -- säckig..av.1
  säckighet_1_N = mkN "säckighet" ; -- säckighet..nn.1
  säckkärra_1_N = mkN "säckkärra" ; -- säckkärra..nn.1
  säckliknande_1_A = mkA "säckliknande" ; -- säckliknande..av.1
  säcklöpning_1_N = mkN "säcklöpning" ; -- säcklöpning..nn.1
  säckpipa_1_N = mkN "säckpipa" ; -- säckpipa..nn.1
  säcksvamp_1_N = mkN "säcksvamp" ; -- säcksvamp..nn.1
  säckvis_1_Adv = mkAdv "säckvis" ; -- säckvis..ab.1
  säckväv_1_N = mkN "säckväv" ; -- säckväv..nn.1
  säd_1_N = mkN "säd" ; -- säd..nn.1
  säde_1_N = mkN "säde" ; -- säde..nn.1
  sädesax_1_N = mkN "sädesax" neutrum  ; -- sädesax..nn.1
  sädesblåsa_1_N = mkN "sädesblåsa" ; -- sädesblåsa..nn.1
  sädesbruk_1_N = mkN "sädesbruk" neutrum  ; -- sädesbruk..nn.1
  sädescell_1_N = mkN "sädescell" "sädesceller" ; -- sädescell..nn.1
  sädeskärna_1_N = mkN "sädeskärna" ; -- sädeskärna..nn.1
  sädeskärve_1_N = mkN "sädeskärve" utrum  ; -- sädeskärve..nn.1
  sädesledare_1_N = mkN "sädesledare" utrum  ; -- sädesledare..nn.1
  sädesskyl_1_N = mkN "sädesskyl" ; -- sädesskyl..nn.1
  sädesslag_1_N = mkN "sädesslag" neutrum  ; -- sädesslag..nn.1
  sädestork_1_N = mkN "sädestork" ; -- sädestork..nn.1
  sädesuttömning_1_N = mkN "sädesuttömning" ; -- sädesuttömning..nn.1
  sädesvätska_1_N = mkN "sädesvätska" ; -- sädesvätska..nn.1
  sädesärla_1_N = mkN "sädesärla" ; -- sädesärla..nn.1
  sädgås_1_N = mkN "sädgås" "sädgåsen" "sädgäss" "sädgässen" ; -- sädgås..nn.1
  säga_1_V = mkV "säja" "sa" "sagt" ; -- säga..vb.1
  sägande_1_N = mkN "sägande" ; -- sägande..nn.1
  sägen_1_N = mkN "sägen" "sägenn" "sägner" "sägnerna" ; -- sägen..nn.1
  sägenomspunnen_1_A = mkA "sägenomspunnen" "sägenomspunnet" "sägenomspunna" "sägenomspunna" "sägenomspunnare" "sägenomspunnast" "sägenomspunnaste" ; -- sägenomspunnen..av.1
  sägenomsusad_1_A = mkA "sägenomsusad" ; -- sägenomsusad..av.1
  säker_1_A = mkA "säker" ; -- säker..av.1
  säkerhet_1_N = mkN "säkerhet" "säkerheter" ; -- säkerhet..nn.1
  säkerhetsanordning_1_N = mkN "säkerhetsanordning" ; -- säkerhetsanordning..nn.1
  säkerhetsansvarig_1_A = mkA "säkerhetsansvarig" ; -- säkerhetsansvarig..av.1
  säkerhetsarbete_1_N = mkN "säkerhetsarbete" ; -- säkerhetsarbete..nn.1
  säkerhetsarrangemang_1_N = mkN "säkerhetsarrangemang" neutrum  ; -- säkerhetsarrangemang..nn.1
  säkerhetsaspekt_1_N = mkN "säkerhetsaspekt" "säkerhetsaspekter" ; -- säkerhetsaspekt..nn.1
  säkerhetsavstånd_1_N = mkN "säkerhetsavstånd" neutrum  ; -- säkerhetsavstånd..nn.1
  säkerhetsbalans_1_N = mkN "säkerhetsbalans" ; -- säkerhetsbalans..nn.1
  säkerhetsbestämmelse_1_N = mkN "säkerhetsbestämmelse" "säkerhetsbestämmelser" ; -- säkerhetsbestämmelse..nn.1
  säkerhetsbrigad_1_N = mkN "säkerhetsbrigad" "säkerhetsbrigader" ; -- säkerhetsbrigad..nn.1
  säkerhetsbroms_1_N = mkN "säkerhetsbroms" ; -- säkerhetsbroms..nn.1
  säkerhetsbrytare_1_N = mkN "säkerhetsbrytare" utrum  ; -- säkerhetsbrytare..nn.1
  säkerhetsbälte_1_N = mkN "säkerhetsbälte" ; -- säkerhetsbälte..nn.1
  säkerhetschef_1_N = mkN "säkerhetschef" "säkerhetschefer" ; -- säkerhetschef..nn.1
  säkerhetsfilosofi_1_N = mkN "säkerhetsfilosofi" "säkerhetsfilosofier" ; -- säkerhetsfilosofi..nn.1
  säkerhetsfrämjande_1_A = mkA "säkerhetsfrämjande" ; -- säkerhetsfrämjande..av.1
  säkerhetsföreskrift_1_N = mkN "säkerhetsföreskrift" "säkerhetsföreskrifter" ; -- säkerhetsföreskrift..nn.1
  säkerhetsglas_1_N = mkN "säkerhetsglas" neutrum  ; -- säkerhetsglas..nn.1
  säkerhetsgrepp_1_N = mkN "säkerhetsgrepp" neutrum  ; -- säkerhetsgrepp..nn.1
  säkerhetshöjande_1_A = mkA "säkerhetshöjande" ; -- säkerhetshöjande..av.1
  säkerhetskedja_1_N = mkN "säkerhetskedja" ; -- säkerhetskedja..nn.1
  säkerhetskontroll_1_N = mkN "säkerhetskontroll" "säkerhetskontroller" ; -- säkerhetskontroll..nn.1
  säkerhetskopia_1_N = mkN "säkerhetskopia" ; -- säkerhetskopia..nn.1
  säkerhetskopiera_1_V = mkV "säkerhetskopierar" ; -- säkerhetskopiera..vb.1
  säkerhetskopierande_1_N = mkN "säkerhetskopierande" ; -- säkerhetskopierande..nn.1
  säkerhetskopiering_1_N = mkN "säkerhetskopiering" ; -- säkerhetskopiering..nn.1
  säkerhetskrok_1_N = mkN "säkerhetskrok" ; -- säkerhetskrok..nn.1
  säkerhetslampa_1_N = mkN "säkerhetslampa" ; -- säkerhetslampa..nn.1
  säkerhetslina_1_N = mkN "säkerhetslina" ; -- säkerhetslina..nn.1
  säkerhetsläge_1_N = mkN "säkerhetsläge" ; -- säkerhetsläge..nn.1
  säkerhetsman_1_N = mkN "säkerhetsman" "säkerhetsmannen" "säkerhetsmän" "säkerhetsmännen" ; -- säkerhetsman..nn.1
  säkerhetsmassa_1_N = mkN "säkerhetsmassa" ; -- säkerhetsmassa..nn.1
  säkerhetsmässig_1_A = mkA "säkerhetsmässig" ; -- säkerhetsmässig..av.1
  säkerhetsnål_1_N = mkN "säkerhetsnål" ; -- säkerhetsnål..nn.1
  säkerhetspersonal_1_N = mkN "säkerhetspersonal" ; -- säkerhetspersonal..nn.1
  säkerhetspolis_1_N = mkN "säkerhetspolis" ; -- säkerhetspolis..nn.1
  säkerhetspolis_2_N = mkN "säkerhetspolis" "säkerhetspoliser" ; -- säkerhetspolis..nn.2
  säkerhetspolitik_1_N = mkN "säkerhetspolitik" ; -- säkerhetspolitik..nn.1
  säkerhetspolitisk_1_A = mkA "säkerhetspolitisk" ; -- säkerhetspolitisk..av.1
  säkerhetsproblem_1_N = mkN "säkerhetsproblem" neutrum  ; -- säkerhetsproblem..nn.1
  säkerhetspådrag_1_N = mkN "säkerhetspådrag" neutrum  ; -- säkerhetspådrag..nn.1
  säkerhetsrelä_1_N = mkN "säkerhetsrelä" "säkerhetsreläet" "säkerhetsreläer" "säkerhetsreläerna" ; -- säkerhetsrelä..nn.1
  säkerhetsrisk_1_N = mkN "säkerhetsrisk" "säkerhetsrisker" ; -- säkerhetsrisk..nn.1
  säkerhetsråd_1_N = mkN "säkerhetsråd" neutrum  ; -- säkerhetsråd..nn.1
  säkerhetsrådgivare_1_N = mkN "säkerhetsrådgivare" utrum  ; -- säkerhetsrådgivare..nn.1
  säkerhetssal_1_N = mkN "säkerhetssal" ; -- säkerhetssal..nn.1
  säkerhetssele_1_N = mkN "säkerhetssele" ; -- säkerhetssele..nn.1
  säkerhetsskäl_1_N = mkN "säkerhetsskäl" neutrum  ; -- säkerhetsskäl..nn.1
  säkerhetssprint_1_N = mkN "säkerhetssprint" ; -- säkerhetssprint..nn.1
  säkerhetsstyrka_1_N = mkN "säkerhetsstyrka" ; -- säkerhetsstyrka..nn.1
  säkerhetssystem_1_N = mkN "säkerhetssystem" neutrum  ; -- säkerhetssystem..nn.1
  säkerhetstjänst_1_N = mkN "säkerhetstjänst" "säkerhetstjänster" ; -- säkerhetstjänst..nn.1
  säkerhetständsticka_1_N = mkN "säkerhetständsticka" ; -- säkerhetständsticka..nn.1
  säkerhetstänk_1_N = mkN "säkerhetstänk" neutrum  ; -- säkerhetstänk..nn.1
  säkerhetsvakt_1_N = mkN "säkerhetsvakt" "säkerhetsvakter" ; -- säkerhetsvakt..nn.1
  säkerhetsventil_1_N = mkN "säkerhetsventil" "säkerhetsventiler" ; -- säkerhetsventil..nn.1
  säkerhetszon_1_N = mkN "säkerhetszon" "säkerhetszoner" ; -- säkerhetszon..nn.1
  säkerhetsåtgärd_1_N = mkN "säkerhetsåtgärd" "säkerhetsåtgärder" ; -- säkerhetsåtgärd..nn.1
  säkerligen_1_Adv = mkAdv "säkerligen" ; -- säkerligen..ab.1
  säkerställa_1_V = mkV "säkerställer" ; -- säkerställa..vb.1
  säkerställande_1_N = mkN "säkerställande" ; -- säkerställande..nn.1
  säkra_1_V = mkV "säkrar" ; -- säkra..vb.1
  säkrande_1_N = mkN "säkrande" ; -- säkrande..nn.1
  säkring_1_N = mkN "säkring" ; -- säkring..nn.1
  säkringshållare_1_N = mkN "säkringshållare" utrum  ; -- säkringshållare..nn.1
  säl_1_N = mkN "säl" ; -- säl..nn.1
  säldjur_1_N = mkN "säldjur" neutrum  ; -- säldjur..nn.1
  sälg_1_N = mkN "sälg" ; -- sälg..nn.1
  sälgbuske_1_N = mkN "sälgbuske" utrum  ; -- sälgbuske..nn.1
  sälghänge_1_N = mkN "sälghänge" ; -- sälghänge..nn.1
  sälja_1_V = mkV "sälja" "sålde" "sålt" ; -- sälja..vb.1
  säljakt_1_N = mkN "säljakt" ; -- säljakt..nn.1
  säljande_1_N = mkN "säljande" ; -- säljande..nn.1
  säljare_1_N = mkN "säljare" utrum  ; -- säljare..nn.1
  säljbar_1_A = mkA "säljbar" ; -- säljbar..av.1
  säljbarhet_1_N = mkN "säljbarhet" ; -- säljbarhet..nn.1
  säljstopp_1_N = mkN "säljstopp" neutrum  ; -- säljstopp..nn.1
  sälkut_1_N = mkN "sälkut" ; -- sälkut..nn.1
  säll_1_A = mkA "säll" ; -- säll..av.1
  sälle_1_N = mkN "sälle" utrum  ; -- sälle..nn.1
  sällhet_1_N = mkN "sällhet" "sällheter" ; -- sällhet..nn.1
  sällsam_1_A = mkA "sällsam" "sällsamt" "sällsamma" "sällsamma" "sällsammare" "sällsammast" "sällsammaste" ; -- sällsam..av.1
  sällsamhet_1_N = mkN "sällsamhet" "sällsamheter" ; -- sällsamhet..nn.1
  sällskap_1_N = mkN "sällskap" neutrum  ; -- sällskap..nn.1
  sällskapa_1_V = mkV "sällskapar" ; -- sällskapa..vb.1
  sällskapande_1_N = mkN "sällskapande" ; -- sällskapande..nn.1
  sällskaplig_1_A = mkA "sällskaplig" ; -- sällskaplig..av.1
  sällskaplighet_1_N = mkN "sällskaplighet" ; -- sällskaplighet..nn.1
  sällskapsbroder_1_N = mkN "sällskapsbroder" "sällskapsbrodern" "sällskapsbröder" "sällskapsbröderna" ; -- sällskapsbroder..nn.1
  sällskapsdam_1_N = mkN "sällskapsdam" "sällskapsdamer" ; -- sällskapsdam..nn.1
  sällskapsdans_1_N = mkN "sällskapsdans" "sällskapsdanser" ; -- sällskapsdans..nn.1
  sällskapsdjur_1_N = mkN "sällskapsdjur" neutrum  ; -- sällskapsdjur..nn.1
  sällskapsgråt_1_N = mkN "sällskapsgråt" ; -- sällskapsgråt..nn.1
  sällskapsgråta_1_V = mkV "sällskapsgråta" "sällskapsgrät" "sällskapsgråtit" ; -- sällskapsgråta..vb.1
  sällskapsgråtande_1_N = mkN "sällskapsgråtande" ; -- sällskapsgråtande..nn.1
  sällskapskrets_1_N = mkN "sällskapskrets" ; -- sällskapskrets..nn.1
  sällskapsliv_1_N = mkN "sällskapsliv" neutrum  ; -- sällskapsliv..nn.1
  sällskapsmänniska_1_N = mkN "sällskapsmänniska" ; -- sällskapsmänniska..nn.1
  sällskapsnöje_1_N = mkN "sällskapsnöje" ; -- sällskapsnöje..nn.1
  sällskapsresa_1_N = mkN "sällskapsresa" ; -- sällskapsresa..nn.1
  sällskapsrum_1_N = mkN "sällskapsrum" "sällskapsrummet" "sällskapsrum" "sällskapsrummen" ; -- sällskapsrum..nn.1
  sällskapssjuk_1_A = mkA "sällskapssjuk" ; -- sällskapssjuk..av.1
  sällskapssjukhet_1_N = mkN "sällskapssjukhet" ; -- sällskapssjukhet..nn.1
  sällskapsspel_1_N = mkN "sällskapsspel" "sällskapsspelet" "sällskapsspel" "sällskapsspelen" ; -- sällskapsspel..nn.1
  sällskapsäta_1_V = mkV "sällskapsäta" "sällskapsåt" "sällskapsätit" ; -- sällskapsäta..vb.1
  sällspord_1_A = mkA "sällspord" "sällsport" ; -- sällspord..av.1
  sällspordhet_1_N = mkN "sällspordhet" ; -- sällspordhet..nn.1
  sällsynt_1_A = mkA "sällsynt" "sällsynt" ; -- sällsynt..av.1
  sällsynthet_1_N = mkN "sällsynthet" "sällsyntheter" ; -- sällsynthet..nn.1
  sällträ_1_N = mkN "sällträ" "sällträt" "sällträn" "sällträna" ; -- sällträ..nn.1
  sälskinn_1_N = mkN "sälskinn" neutrum  ; -- sälskinn..nn.1
  sälskytte_1_N = mkN "sälskytte" ; -- sälskytte..nn.1
  sälta_1_N = mkN "sälta" ; -- sälta..nn.1
  sälunge_1_N = mkN "sälunge" utrum  ; -- sälunge..nn.1
  sämja_1_N = mkN "sämja" ; -- sämja..nn.1
  sämska_1_V = mkV "sämskar" ; -- sämska..vb.1
  sämskande_1_N = mkN "sämskande" ; -- sämskande..nn.1
  sämskgarva_1_V = mkV "sämskgarvar" ; -- sämskgarva..vb.1
  sämskgarvande_1_N = mkN "sämskgarvande" ; -- sämskgarvande..nn.1
  sämskskinn_1_N = mkN "sämskskinn" neutrum  ; -- sämskskinn..nn.1
  sämskskinnsbyxa_1_N = mkN "sämskskinnsbyxa" ; -- sämskskinnsbyxa..nn.1
  sämskskinnshandske_1_N = mkN "sämskskinnshandske" utrum  ; -- sämskskinnshandske..nn.1
  sända_1_V = mkV "sänder" ; -- sända..vb.1
  sändande_1_N = mkN "sändande" ; -- sändande..nn.1
  sändare_1_N = mkN "sändare" utrum  ; -- sändare..nn.1
  sändebud_1_N = mkN "sändebud" neutrum  ; -- sändebud..nn.1
  sändning_1_N = mkN "sändning" ; -- sändning..nn.1
  sändningsrättighet_1_N = mkN "sändningsrättighet" "sändningsrättigheter" ; -- sändningsrättighet..nn.1
  sändningstid_1_N = mkN "sändningstid" "sändningstider" ; -- sändningstid..nn.1
  sändningsuppehåll_1_N = mkN "sändningsuppehåll" neutrum  ; -- sändningsuppehåll..nn.1
  säng_1_N = mkN "säng" ; -- säng..nn.1
  sängbord_1_N = mkN "sängbord" neutrum  ; -- sängbord..nn.1
  sängdags_1_N = mkN "sängdags" ; -- sängdags..nn.1
  sängfot_1_N = mkN "sängfot" "sängfötter" ; -- sängfot..nn.1
  sängförhänge_1_N = mkN "sängförhänge" ; -- sängförhänge..nn.1
  sängfösare_1_N = mkN "sängfösare" utrum  ; -- sängfösare..nn.1
  sänggavel_1_N = mkN "sänggavel" ; -- sänggavel..nn.1
  sänggrind_1_N = mkN "sänggrind" ; -- sänggrind..nn.1
  sänghalm_1_N = mkN "sänghalm" ; -- sänghalm..nn.1
  sänghimmel_1_N = mkN "sänghimmel" ; -- sänghimmel..nn.1
  sängkammare_1_N = mkN "sängkammare" "sängkammaren" "sängkammare" "sängkamrarna" ; -- sängkammare..nn.1
  sängkammarfars_1_N = mkN "sängkammarfars" "sängkammarfarser" ; -- sängkammarfars..nn.1
  sängkammarregemente_1_N = mkN "sängkammarregemente" ; -- sängkammarregemente..nn.1
  sängkamrat_1_N = mkN "sängkamrat" "sängkamrater" ; -- sängkamrat..nn.1
  sängkant_1_N = mkN "sängkant" "sängkanter" ; -- sängkant..nn.1
  sänglampa_1_N = mkN "sänglampa" ; -- sänglampa..nn.1
  sängliggande_1_A = mkA "sängliggande" ; -- sängliggande..av.1
  sänglinne_1_N = mkN "sänglinne" ; -- sänglinne..nn.1
  sängläge_1_N = mkN "sängläge" ; -- sängläge..nn.1
  sängröka_1_V = mkV "sängröker" ; -- sängröka..vb.1
  sängrökande_1_N = mkN "sängrökande" ; -- sängrökande..nn.1
  sängrökare_1_N = mkN "sängrökare" utrum  ; -- sängrökare..nn.1
  sängvärmare_1_N = mkN "sängvärmare" utrum  ; -- sängvärmare..nn.1
  sängvärme_1_N = mkN "sängvärme" utrum  ; -- sängvärme..nn.1
  sängvätare_1_N = mkN "sängvätare" utrum  ; -- sängvätare..nn.1
  sänka_1_N = mkN "sänka" ; -- sänka..nn.1
  sänka_1_V = mkV "sänker" ; -- sänka..vb.1
  sänkande_1_N = mkN "sänkande" ; -- sänkande..nn.1
  sänkbar_1_A = mkA "sänkbar" ; -- sänkbar..av.1
  sänke_1_N = mkN "sänke" ; -- sänke..nn.1
  sänkhåv_1_N = mkN "sänkhåv" ; -- sänkhåv..nn.1
  sänkning_1_N = mkN "sänkning" ; -- sänkning..nn.1
  sänkningsreaktion_1_N = mkN "sänkningsreaktion" ; -- sänkningsreaktion..nn.1
  sänkningstecken_1_N = mkN "sänkningstecken" "sänkningstecknet" "sänkningstecken" "sänkningstecknen" ; -- sänkningstecken..nn.1
  sänkvåg_1_N = mkN "sänkvåg" ; -- sänkvåg..nn.1
  sär_1_A = mkA "sär" ; -- sär..av.1
  sära_1_V = mkV "särar" ; -- sära..vb.1
  särande_1_N = mkN "särande" ; -- särande..nn.1
  särart_1_N = mkN "särart" ; -- särart..nn.1
  särartstänkande_1_N = mkN "särartstänkande" ; -- särartstänkande..nn.1
  särbehandla_1_V = mkV "särbehandlar" ; -- särbehandla..vb.1
  särbehandlande_1_N = mkN "särbehandlande" ; -- särbehandlande..nn.1
  särbehandling_1_N = mkN "särbehandling" ; -- särbehandling..nn.1
  särbeskatta_1_V = mkV "särbeskattar" ; -- särbeskatta..vb.1
  särbeskattande_1_N = mkN "särbeskattande" ; -- särbeskattande..nn.1
  särbeskattning_1_N = mkN "särbeskattning" ; -- särbeskattning..nn.1
  särbo_1_N = mkN "särbo" "särbor" ; -- särbo..nn.1
  särdeles_1_Adv = mkAdv "särdeles" ; -- särdeles..ab.1
  särdrag_1_N = mkN "särdrag" neutrum  ; -- särdrag..nn.1
  säregen_1_A = mkA "säregen" ; -- säregen..av.1
  säregenhet_1_N = mkN "säregenhet" "säregenheter" ; -- säregenhet..nn.1
  särfall_1_N = mkN "särfall" neutrum  ; -- särfall..nn.1
  särfråga_1_N = mkN "särfråga" ; -- särfråga..nn.1
  särintresse_1_N = mkN "särintresse" ; -- särintresse..nn.1
  särk_1_N = mkN "särk" ; -- särk..nn.1
  särklass_1_N = mkN "särklass" ; -- särklass..nn.1
  särklass_2_N = mkN "särklass" "särklasser" ; -- särklass..nn.2
  särklassig_1_A = mkA "särklassig" ; -- särklassig..av.1
  särklassighet_1_N = mkN "särklassighet" ; -- särklassighet..nn.1
  särkullbarn_1_N = mkN "särkullbarn" neutrum  ; -- särkullbarn..nn.1
  särkullsbarn_1_N = mkN "särkullsbarn" neutrum  ; -- särkullsbarn..nn.1
  särkvark_1_N = mkN "särkvark" ; -- särkvark..nn.1
  särlevande_1_A = mkA "särlevande" ; -- särlevande..av.1
  särlevandeutredning_1_N = mkN "särlevandeutredning" ; -- särlevandeutredning..nn.1
  särling_1_N = mkN "särling" ; -- särling..nn.1
  särmärke_1_N = mkN "särmärke" ; -- särmärke..nn.1
  särprägel_1_N = mkN "särprägel" ; -- särprägel..nn.1
  särpräglad_1_A = mkA "särpräglad" ; -- särpräglad..av.1
  särskild_1_A = mkA "särskild" "särskilt" ; -- särskild..av.1
  särskildhet_1_N = mkN "särskildhet" ; -- särskildhet..nn.1
  särskilja_1_V = mkV "särskilja" "särskilde" "särskilt" ; -- särskilja..vb.1
  särskiljande_1_N = mkN "särskiljande" ; -- särskiljande..nn.1
  särskola_1_N = mkN "särskola" ; -- särskola..nn.1
  särskriva_1_V = mkV "särskriva" "särskrev" "särskrivit" ; -- särskriva..vb.1
  särskrivande_1_N = mkN "särskrivande" ; -- särskrivande..nn.1
  särskrivning_1_N = mkN "särskrivning" ; -- särskrivning..nn.1
  särskrivningsmotståndare_1_N = mkN "särskrivningsmotståndare" utrum  ; -- särskrivningsmotståndare..nn.1
  särställning_1_N = mkN "särställning" ; -- särställning..nn.1
  särtryck_1_N = mkN "särtryck" neutrum  ; -- särtryck..nn.1
  säsong_1_N = mkN "säsong" "säsonger" ; -- säsong..nn.1
  säsongmässig_1_A = mkA "säsongmässig" ; -- säsongmässig..av.1
  säsongsinfluensa_1_N = mkN "säsongsinfluensa" ; -- säsongsinfluensa..nn.1
  säsongsmässig_1_A = mkA "säsongsmässig" ; -- säsongsmässig..av.1
  säsongsupptakt_1_N = mkN "säsongsupptakt" "säsongsupptakter" ; -- säsongsupptakt..nn.1
  säsongsvis_1_Adv = mkAdv "säsongsvis" ; -- säsongsvis..ab.1
  säte_1_N = mkN "säte" ; -- säte..nn.1
  säter_1_N = mkN "säter" ; -- säter..nn.1
  säteri_1_N = mkN "säteri" "säteriet" "säterier" "säterierna" ; -- säteri..nn.1
  säteritak_1_N = mkN "säteritak" neutrum  ; -- säteritak..nn.1
  säterjänta_1_N = mkN "säterjänta" ; -- säterjänta..nn.1
  sätesbjudning_1_N = mkN "sätesbjudning" ; -- sätesbjudning..nn.1
  sätesgård_1_N = mkN "sätesgård" ; -- sätesgård..nn.1
  sätt_1_N = mkN "sätt" neutrum  ; -- sätt..nn.1
  sätta_1_V = mkV "sätta" "sätter" "sätt" "satte" "satt" "satt" ; -- sätta..vb.1
  sättande_1_N = mkN "sättande" ; -- sättande..nn.1
  sättare_1_N = mkN "sättare" utrum  ; -- sättare..nn.1
  sätteri_1_N = mkN "sätteri" "sätteriet" "sätterier" "sätterierna" ; -- sätteri..nn.1
  sätthake_1_N = mkN "sätthake" utrum  ; -- sätthake..nn.1
  sättmaskin_1_N = mkN "sättmaskin" "sättmaskiner" ; -- sättmaskin..nn.1
  sättning_1_N = mkN "sättning" ; -- sättning..nn.1
  sättnät_1_N = mkN "sättnät" neutrum  ; -- sättnät..nn.1
  sättpotatis_1_N = mkN "sättpotatis" ; -- sättpotatis..nn.1
  sättsadverbial_1_N = mkN "sättsadverbial" neutrum  ; -- sättsadverbial..nn.1
  sättskepp_1_N = mkN "sättskepp" neutrum  ; -- sättskepp..nn.1
  sättsord_1_N = mkN "sättsord" neutrum  ; -- sättsord..nn.1
  säv_1_N = mkN "säv" ; -- säv..nn.1
  sävlig_1_A = mkA "sävlig" ; -- sävlig..av.1
  sävlighet_1_N = mkN "sävlighet" ; -- sävlighet..nn.1
  sävsparv_1_N = mkN "sävsparv" ; -- sävsparv..nn.1
  sävsångare_1_N = mkN "sävsångare" utrum  ; -- sävsångare..nn.1
  så_1_Adv = mkAdv "så" ; -- så..ab.1
  så_1_N = mkN "så" ; -- så..nn.1
  så_1_V = mkV "sår" ; -- så..vb.1
  sådd_1_N = mkN "sådd" "sådder" ; -- sådd..nn.1
  sådig_1_A = mkA "sådig" ; -- sådig..av.1
  sådär_1_Adv = mkAdv "sådär" ; -- sådär..ab.1
  sådär_1_A = mkA "sådär" ; -- sådär..av.1
  sående_1_N = mkN "sående" ; -- sående..nn.1
  såg_1_N = mkN "såg" ; -- såg..nn.1
  såga_1_V = mkV "sågar" ; -- såga..vb.1
  såga_2_V = mkV "sågar" ; -- såga..vb.2
  sågande_1_N = mkN "sågande" ; -- sågande..nn.1
  sågblad_1_N = mkN "sågblad" neutrum  ; -- sågblad..nn.1
  sågbock_1_N = mkN "sågbock" ; -- sågbock..nn.1
  sågfisk_1_N = mkN "sågfisk" ; -- sågfisk..nn.1
  sågkedja_1_N = mkN "sågkedja" ; -- sågkedja..nn.1
  sågkedjefil_1_N = mkN "sågkedjefil" ; -- sågkedjefil..nn.1
  sågklinga_1_N = mkN "sågklinga" ; -- sågklinga..nn.1
  sågkvarn_1_N = mkN "sågkvarn" ; -- sågkvarn..nn.1
  sågning_1_N = mkN "sågning" ; -- sågning..nn.1
  sågspån_1_N = mkN "sågspån" neutrum  ; -- sågspån..nn.1
  sågtak_1_N = mkN "sågtak" neutrum  ; -- sågtak..nn.1
  sågtand_1_N = mkN "sågtand" "sågtänder" ; -- sågtand..nn.1
  sågtandad_1_A = mkA "sågtandad" ; -- sågtandad..av.1
  sågverk_1_N = mkN "sågverk" neutrum  ; -- sågverk..nn.1
  sågverksarbetare_1_N = mkN "sågverksarbetare" utrum  ; -- sågverksarbetare..nn.1
  sågverksindustri_1_N = mkN "sågverksindustri" "sågverksindustrier" ; -- sågverksindustri..nn.1
  sågverksjobbare_1_N = mkN "sågverksjobbare" utrum  ; -- sågverksjobbare..nn.1
  såhär_1_Adv = mkAdv "såhär" ; -- såhär..ab.1
  såklart_1_Adv = mkAdv "såklart" ; -- såklart..ab.1
  såld_1_A = mkA "såld" "sålt" ; -- såld..av.1
  således_1_Adv = mkAdv "således" ; -- således..ab.1
  såll_1_N = mkN "såll" neutrum  ; -- såll..nn.1
  sålla_1_V = mkV "sållar" ; -- sålla..vb.1
  sållande_1_N = mkN "sållande" ; -- sållande..nn.1
  sållning_1_N = mkN "sållning" ; -- sållning..nn.1
  sållningsprocedur_1_N = mkN "sållningsprocedur" ; -- sållningsprocedur..nn.1
  sålunda_1_Adv = mkAdv "sålunda" ; -- sålunda..ab.1
  såmaskin_1_N = mkN "såmaskin" "såmaskiner" ; -- såmaskin..nn.1
  sång_1_N = mkN "sång" "sånger" ; -- sång..nn.1
  sång_2_N = mkN "sång" ; -- sång..nn.2
  sånganförare_1_N = mkN "sånganförare" utrum  ; -- sånganförare..nn.1
  sångare_1_N = mkN "sångare" utrum  ; -- sångare..nn.1
  sångarfågel_1_N = mkN "sångarfågel" ; -- sångarfågel..nn.1
  sångbar_1_A = mkA "sångbar" ; -- sångbar..av.1
  sångbarhet_1_N = mkN "sångbarhet" ; -- sångbarhet..nn.1
  sångerska_1_N = mkN "sångerska" ; -- sångerska..nn.1
  sångfågel_1_N = mkN "sångfågel" ; -- sångfågel..nn.1
  sånggudinna_1_N = mkN "sånggudinna" ; -- sånggudinna..nn.1
  sånglek_1_N = mkN "sånglek" ; -- sånglek..nn.1
  sånglig_1_A = mkA "sånglig" ; -- sånglig..av.1
  sånglighet_1_N = mkN "sånglighet" ; -- sånglighet..nn.1
  sånglärka_1_N = mkN "sånglärka" ; -- sånglärka..nn.1
  sångmässig_1_A = mkA "sångmässig" ; -- sångmässig..av.1
  sångmö_1_N = mkN "sångmö" "sångmön" "sångmör" "sångmörna" ; -- sångmö..nn.1
  sångprov_1_N = mkN "sångprov" neutrum  ; -- sångprov..nn.1
  sångröst_1_N = mkN "sångröst" ; -- sångröst..nn.1
  sångscen_1_N = mkN "sångscen" "sångscener" ; -- sångscen..nn.1
  sångspel_1_N = mkN "sångspel" "sångspelet" "sångspel" "sångspelen" ; -- sångspel..nn.1
  sångsvan_1_N = mkN "sångsvan" ; -- sångsvan..nn.1
  sångsätt_1_N = mkN "sångsätt" neutrum  ; -- sångsätt..nn.1
  sångteknik_1_N = mkN "sångteknik" "sångtekniker" ; -- sångteknik..nn.1
  sångtema_1_N = mkN "sångtema" "sångtemat" "sångtemata" "sångtematana" ; -- sångtema..nn.1
  sångtext_1_N = mkN "sångtext" "sångtexter" ; -- sångtext..nn.1
  sångtävling_1_N = mkN "sångtävling" ; -- sångtävling..nn.1
  sångövning_1_N = mkN "sångövning" ; -- sångövning..nn.1
  såning_1_N = mkN "såning" ; -- såning..nn.1
  såningsman_1_N = mkN "såningsman" "såningsmannen" "såningsmän" "såningsmännen" ; -- såningsman..nn.1
  sånär_1_Adv = mkAdv "sånär" ; -- sånär..ab.1
  såpa_1_N = mkN "såpa" ; -- såpa..nn.1
  såpa_2_N = mkN "såpa" ; -- såpa..nn.2
  såpa_1_V = mkV "såpar" ; -- såpa..vb.1
  såpande_1_N = mkN "såpande" ; -- såpande..nn.1
  såpaskådis_1_N = mkN "såpaskådis" ; -- såpaskådis..nn.1
  såpass_1_Adv = mkAdv "såpass" ; -- såpass..ab.1
  såpbubbla_1_N = mkN "såpbubbla" ; -- såpbubbla..nn.1
  såphal_1_A = mkA "såphal" ; -- såphal..av.1
  såpopera_1_N = mkN "såpopera" ; -- såpopera..nn.1
  såpvatten_1_N = mkN "såpvatten" "såpvattnet" "såpvatten" "såpvattnen" ; -- såpvatten..nn.1
  sår_1_N = mkN "sår" neutrum  ; -- sår..nn.1
  såra_1_V = mkV "sårar" ; -- såra..vb.1
  sårande_1_A = mkA "sårande" ; -- sårande..av.1
  sårande_1_N = mkN "sårande" ; -- sårande..nn.1
  sårbar_1_A = mkA "sårbar" ; -- sårbar..av.1
  sårbarhet_1_N = mkN "sårbarhet" "sårbarheter" ; -- sårbarhet..nn.1
  sårig_1_A = mkA "sårig" ; -- sårig..av.1
  sårighet_1_N = mkN "sårighet" "sårigheter" ; -- sårighet..nn.1
  sårinfektion_1_N = mkN "sårinfektion" ; -- sårinfektion..nn.1
  sårmarkör_1_N = mkN "sårmarkör" "sårmarkörer" ; -- sårmarkör..nn.1
  sårnad_1_N = mkN "sårnad" "sårnader" ; -- sårnad..nn.1
  sårskada_1_N = mkN "sårskada" ; -- sårskada..nn.1
  sårskorpa_1_N = mkN "sårskorpa" ; -- sårskorpa..nn.1
  sås_1_N = mkN "sås" "såser" ; -- sås..nn.1
  såsa_1_V = mkV "såsar" ; -- såsa..vb.1
  såsande_1_N = mkN "såsande" ; -- såsande..nn.1
  såsig_1_A = mkA "såsig" ; -- såsig..av.1
  såsighet_1_N = mkN "såsighet" ; -- såsighet..nn.1
  såskanna_1_N = mkN "såskanna" ; -- såskanna..nn.1
  såskopp_1_N = mkN "såskopp" ; -- såskopp..nn.1
  såt_1_A = mkA "såt" ; -- såt..av.1
  såt_1_N = mkN "såt" ; -- såt..nn.1
  såta_1_V = mkV "såtar" ; -- såta..vb.1
  såtande_1_N = mkN "såtande" ; -- såtande..nn.1
  såte_1_N = mkN "såte" utrum  ; -- såte..nn.1
  såtera_1_V = mkV "såterar" ; -- såtera..vb.1
  såterande_1_N = mkN "såterande" ; -- såterande..nn.1
  såterbar_1_A = mkA "såterbar" ; -- såterbar..av.1
  såterbarhet_1_N = mkN "såterbarhet" ; -- såterbarhet..nn.1
  såtering_1_N = mkN "såtering" ; -- såtering..nn.1
  såtillvida_1_Adv = mkAdv "såtillvida" ; -- såtillvida..ab.1
  såté_1_N = mkN "såté" "såtéer" ; -- såté..nn.1
  såvera_1_V = mkV "såverar" ; -- såvera..vb.1
  såverande_1_N = mkN "såverande" ; -- såverande..nn.1
  såverbar_1_A = mkA "såverbar" ; -- såverbar..av.1
  såverbarhet_1_N = mkN "såverbarhet" ; -- såverbarhet..nn.1
  såvering_1_N = mkN "såvering" ; -- såvering..nn.1
  såvitt_1_Adv = mkAdv "såvitt" ; -- såvitt..ab.1
  söckendag_1_N = mkN "söckendag" ; -- söckendag..nn.1
  söder_1_Adv = mkAdv "söder" ; -- söder..ab.1
  söder_1_N = mkN "söder" ; -- söder..nn.1
  södergående_1_A = mkA "södergående" ; -- södergående..av.1
  södergök_1_N = mkN "södergök" ; -- södergök..nn.1
  söderhipster_1_N = mkN "söderhipster" ; -- söderhipster..nn.1
  söderifrån_1_Adv = mkAdv "söderifrån" ; -- söderifrån..ab.1
  söderkis_1_N = mkN "söderkis" ; -- söderkis..nn.1
  södermalmsbo_1_N = mkN "södermalmsbo" "södermalmsbor" ; -- södermalmsbo..nn.1
  södermanländsk_1_A = mkA "södermanländsk" ; -- södermanländsk..av.1
  södermanländska_1_N = mkN "södermanländska" ; -- södermanländska..nn.1
  södermanländska_2_N = mkN "södermanländska" ; -- södermanländska..nn.2
  södermanlänning_1_N = mkN "södermanlänning" ; -- södermanlänning..nn.1
  södersida_1_N = mkN "södersida" ; -- södersida..nn.1
  södersol_1_N = mkN "södersol" ; -- södersol..nn.1
  söderut_1_Adv = mkAdv "söderut" ; -- söderut..ab.1
  söderöver_1_Adv = mkAdv "söderöver" ; -- söderöver..ab.1
  södra_1_A = mkA "södra" ; -- södra..av.1
  sök_1_N = mkN "sök" neutrum  ; -- sök..nn.1
  söka_1_V = mkV "söker" ; -- söka..vb.1
  sökaktivitet_1_N = mkN "sökaktivitet" "sökaktiviteter" ; -- sökaktivitet..nn.1
  sökande_1_N = mkN "sökande" "sökanden" "sökanden" "sökandena" ; -- sökande..nn.1
  sökande_2_N = mkN "sökande" ; -- sökande..nn.2
  sökare_1_N = mkN "sökare" utrum  ; -- sökare..nn.1
  sökarljus_1_N = mkN "sökarljus" neutrum  ; -- sökarljus..nn.1
  sökbar_1_A = mkA "sökbar" ; -- sökbar..av.1
  sökbarhet_1_N = mkN "sökbarhet" ; -- sökbarhet..nn.1
  sökgränssnitt_1_N = mkN "sökgränssnitt" neutrum  ; -- sökgränssnitt..nn.1
  sökinsats_1_N = mkN "sökinsats" "sökinsatser" ; -- sökinsats..nn.1
  sökljus_1_N = mkN "sökljus" neutrum  ; -- sökljus..nn.1
  sökmotor_1_N = mkN "sökmotor" "sökmotorer" ; -- sökmotor..nn.1
  sökning_1_N = mkN "sökning" ; -- sökning..nn.1
  sökområde_1_N = mkN "sökområde" ; -- sökområde..nn.1
  sökpådrag_1_N = mkN "sökpådrag" neutrum  ; -- sökpådrag..nn.1
  sökt_1_A = mkA "sökt" "sökt" ; -- sökt..av.1
  sökthet_1_N = mkN "sökthet" ; -- sökthet..nn.1
  söktjänst_1_N = mkN "söktjänst" "söktjänster" ; -- söktjänst..nn.1
  söktryck_1_N = mkN "söktryck" neutrum  ; -- söktryck..nn.1
  söl_1_N = mkN "söl" neutrum  ; -- söl..nn.1
  söla_1_V = mkV "sölar" ; -- söla..vb.1
  sölande_1_N = mkN "sölande" ; -- sölande..nn.1
  sölare_1_N = mkN "sölare" utrum  ; -- sölare..nn.1
  sölig_1_A = mkA "sölig" ; -- sölig..av.1
  sölighet_1_N = mkN "sölighet" ; -- sölighet..nn.1
  sölja_1_N = mkN "sölja" ; -- sölja..nn.1
  sölkorv_1_N = mkN "sölkorv" ; -- sölkorv..nn.1
  söm_1_N = mkN "söm" "sömmen" "sömmar" "sömmarna" ; -- söm..nn.1
  söm_2_N = mkN "söm" "sömmen" "söm" "sömmen" ; -- söm..nn.2
  sömma_1_V = mkV "sömmar" ; -- sömma..vb.1
  sömmande_1_N = mkN "sömmande" ; -- sömmande..nn.1
  sömmare_1_N = mkN "sömmare" utrum  ; -- sömmare..nn.1
  sömmerska_1_N = mkN "sömmerska" ; -- sömmerska..nn.1
  sömmersketips_1_N = mkN "sömmersketips" neutrum  ; -- sömmersketips..nn.1
  sömn_1_N = mkN "sömn" ; -- sömn..nn.1
  sömnad_1_N = mkN "sömnad" "sömnader" ; -- sömnad..nn.1
  sömnaktig_1_A = mkA "sömnaktig" ; -- sömnaktig..av.1
  sömnaktighet_1_N = mkN "sömnaktighet" ; -- sömnaktighet..nn.1
  sömnapne_1_N = mkN "sömnapne" "sömnapneer" ; -- sömnapne..nn.1
  sömnapné_1_N = mkN "sömnapné" "sömnapnéer" ; -- sömnapné..nn.1
  sömnbrist_1_N = mkN "sömnbrist" ; -- sömnbrist..nn.1
  sömndrucken_1_A = mkA "sömndrucken" ; -- sömndrucken..av.1
  sömndryck_1_N = mkN "sömndryck" "sömndrycker" ; -- sömndryck..nn.1
  sömnforskare_1_N = mkN "sömnforskare" utrum  ; -- sömnforskare..nn.1
  sömnforskning_1_N = mkN "sömnforskning" ; -- sömnforskning..nn.1
  sömnforskningsinstitut_1_N = mkN "sömnforskningsinstitut" neutrum  ; -- sömnforskningsinstitut..nn.1
  sömngivande_1_A = mkA "sömngivande" ; -- sömngivande..av.1
  sömngångaraktig_1_A = mkA "sömngångaraktig" ; -- sömngångaraktig..av.1
  sömngångaraktighet_1_N = mkN "sömngångaraktighet" ; -- sömngångaraktighet..nn.1
  sömngångare_1_N = mkN "sömngångare" utrum  ; -- sömngångare..nn.1
  sömngångerska_1_N = mkN "sömngångerska" ; -- sömngångerska..nn.1
  sömnig_1_A = mkA "sömnig" ; -- sömnig..av.1
  sömnighet_1_N = mkN "sömnighet" ; -- sömnighet..nn.1
  sömnlös_1_A = mkA "sömnlös" ; -- sömnlös..av.1
  sömnlöshet_1_N = mkN "sömnlöshet" ; -- sömnlöshet..nn.1
  sömnmedel_1_N = mkN "sömnmedel" neutrum  ; -- sömnmedel..nn.1
  sömnproblem_1_N = mkN "sömnproblem" neutrum  ; -- sömnproblem..nn.1
  sömnsjuk_1_A = mkA "sömnsjuk" ; -- sömnsjuk..av.1
  sömnsjuka_1_N = mkN "sömnsjuka" ; -- sömnsjuka..nn.1
  sömnstörning_1_N = mkN "sömnstörning" ; -- sömnstörning..nn.1
  sömnsvårighet_1_N = mkN "sömnsvårighet" "sömnsvårigheter" ; -- sömnsvårighet..nn.1
  sömntablett_1_N = mkN "sömntablett" "sömntabletter" ; -- sömntablett..nn.1
  sömntung_1_A = mkA "sömntung" ; -- sömntung..av.1
  sömntunghet_1_N = mkN "sömntunghet" ; -- sömntunghet..nn.1
  sömntuta_1_N = mkN "sömntuta" ; -- sömntuta..nn.1
  sömsmån_1_N = mkN "sömsmån" "sömsmåner" ; -- sömsmån..nn.1
  söndag_1_N = mkN "söndag" ; -- söndag..nn.1
  söndageftermiddag_1_N = mkN "söndageftermiddag" ; -- söndageftermiddag..nn.1
  söndagkväll_1_N = mkN "söndagkväll" ; -- söndagkväll..nn.1
  söndaglig_1_A = mkA "söndaglig" ; -- söndaglig..av.1
  söndagmorgon_1_N = mkN "söndagmorgon" "söndagmorgonen" "söndagmornar" "söndagmornarna" ; -- söndagmorgon..nn.1
  söndagsbarn_1_N = mkN "söndagsbarn" neutrum  ; -- söndagsbarn..nn.1
  söndagsbilaga_1_N = mkN "söndagsbilaga" ; -- söndagsbilaga..nn.1
  söndagsbokstav_1_N = mkN "söndagsbokstav" "söndagsbokstäver" ; -- söndagsbokstav..nn.1
  söndagseftermiddag_1_N = mkN "söndagseftermiddag" ; -- söndagseftermiddag..nn.1
  söndagsjägare_1_N = mkN "söndagsjägare" utrum  ; -- söndagsjägare..nn.1
  söndagskväll_1_N = mkN "söndagskväll" ; -- söndagskväll..nn.1
  söndagsköra_1_V = mkV "söndagsköra" "söndagskörde" "söndagskört" ; -- söndagsköra..vb.1
  söndagskörande_1_N = mkN "söndagskörande" ; -- söndagskörande..nn.1
  söndagskörning_1_N = mkN "söndagskörning" ; -- söndagskörning..nn.1
  söndagsmorgon_1_N = mkN "söndagsmorgon" "söndagsmorgonen" "söndagsmornar" "söndagsmornarna" ; -- söndagsmorgon..nn.1
  söndagspappa_1_N = mkN "söndagspappa" ; -- söndagspappa..nn.1
  söndagsseglare_1_N = mkN "söndagsseglare" utrum  ; -- söndagsseglare..nn.1
  söndagsskola_1_N = mkN "söndagsskola" ; -- söndagsskola..nn.1
  söndagsskolefröken_1_N = mkN "söndagsskolefröken" ; -- söndagsskolefröken..nn.1
  sönderbristning_1_N = mkN "sönderbristning" ; -- sönderbristning..nn.1
  sönderbrytning_1_N = mkN "sönderbrytning" ; -- sönderbrytning..nn.1
  sönderbränd_1_A = mkA "sönderbränd" ; -- sönderbränd..av.1
  sönderbrändhet_1_N = mkN "sönderbrändhet" ; -- sönderbrändhet..nn.1
  sönderdela_1_V = mkV "sönderdelar" ; -- sönderdela..vb.1
  sönderdelande_1_N = mkN "sönderdelande" ; -- sönderdelande..nn.1
  sönderdelning_1_N = mkN "sönderdelning" ; -- sönderdelning..nn.1
  sönderfall_1_N = mkN "sönderfall" neutrum  ; -- sönderfall..nn.1
  sönderfalla_1_V = mkV "sönderfalla" "sönderföll" "sönderfallit" ; -- sönderfalla..vb.1
  sönderfallande_1_N = mkN "sönderfallande" ; -- sönderfallande..nn.1
  sönderhacka_1_V = mkV "sönderhackar" ; -- sönderhacka..vb.1
  sönderhackande_1_N = mkN "sönderhackande" ; -- sönderhackande..nn.1
  sönderkörd_1_A = mkA "sönderkörd" "sönderkört" ; -- sönderkörd..av.1
  sönderplockad_1_A = mkA "sönderplockad" ; -- sönderplockad..av.1
  sönderriva_1_V = mkV "sönderriva" "sönderrev" "sönderrivit" ; -- sönderriva..vb.1
  sönderrivande_1_N = mkN "sönderrivande" ; -- sönderrivande..nn.1
  sönderrostad_1_A = mkA "sönderrostad" ; -- sönderrostad..av.1
  sönderskjuten_1_A = mkA "sönderskjuten" ; -- sönderskjuten..av.1
  sönderslagning_1_N = mkN "sönderslagning" ; -- sönderslagning..nn.1
  sönderslita_1_V = mkV "sönderslita" "sönderslet" "sönderslitit" ; -- sönderslita..vb.1
  sönderslitande_1_N = mkN "sönderslitande" ; -- sönderslitande..nn.1
  sönderslitning_1_N = mkN "sönderslitning" ; -- sönderslitning..nn.1
  söndersolad_1_A = mkA "söndersolad" ; -- söndersolad..av.1
  sönderspekulerad_1_A = mkA "sönderspekulerad" ; -- sönderspekulerad..av.1
  söndersplittring_1_N = mkN "söndersplittring" ; -- söndersplittring..nn.1
  sönderspränga_1_V = mkV "sönderspränger" ; -- sönderspränga..vb.1
  söndersprängande_1_N = mkN "söndersprängande" ; -- söndersprängande..nn.1
  söndersprängning_1_N = mkN "söndersprängning" ; -- söndersprängning..nn.1
  sönderstressad_1_A = mkA "sönderstressad" ; -- sönderstressad..av.1
  söndersutten_1_A = mkA "söndersutten" ; -- söndersutten..av.1
  söndertrasad_1_A = mkA "söndertrasad" ; -- söndertrasad..av.1
  söndertrasning_1_N = mkN "söndertrasning" ; -- söndertrasning..nn.1
  söndervittrad_1_A = mkA "söndervittrad" ; -- söndervittrad..av.1
  söndervärkt_1_A = mkA "söndervärkt" "söndervärkt" ; -- söndervärkt..av.1
  sönderälskad_1_A = mkA "sönderälskad" ; -- sönderälskad..av.1
  sönderältad_1_A = mkA "sönderältad" ; -- sönderältad..av.1
  söndra_1_V = mkV "söndrar" ; -- söndra..vb.1
  söndrande_1_N = mkN "söndrande" ; -- söndrande..nn.1
  söndrig_1_A = mkA "söndrig" ; -- söndrig..av.1
  söndrighet_1_N = mkN "söndrighet" ; -- söndrighet..nn.1
  söndring_1_N = mkN "söndring" ; -- söndring..nn.1
  sörgårdsidyll_1_N = mkN "sörgårdsidyll" "sörgårdsidyller" ; -- sörgårdsidyll..nn.1
  sörja_1_N = mkN "sörja" ; -- sörja..nn.1
  sörja_1_V = mkV "sörja" "sörjde" "sörjt" ; -- sörja..vb.1
  sörjande_1_N = mkN "sörjande" ; -- sörjande..nn.1
  sörländsk_1_A = mkA "sörländsk" ; -- sörländsk..av.1
  sörlänning_1_N = mkN "sörlänning" ; -- sörlänning..nn.1
  sörmländsk_1_A = mkA "sörmländsk" ; -- sörmländsk..av.1
  sörmländska_1_N = mkN "sörmländska" ; -- sörmländska..nn.1
  sörmländska_2_N = mkN "sörmländska" ; -- sörmländska..nn.2
  sörmlänning_1_N = mkN "sörmlänning" ; -- sörmlänning..nn.1
  sörpa_1_N = mkN "sörpa" ; -- sörpa..nn.1
  sörpla_1_V = mkV "sörplar" ; -- sörpla..vb.1
  sörplande_1_N = mkN "sörplande" ; -- sörplande..nn.1
  söt_1_A = mkA "söt" ; -- söt..av.1
  söta_1_V = mkV "sötar" ; -- söta..vb.1
  sötaktig_1_A = mkA "sötaktig" ; -- sötaktig..av.1
  sötaktighet_1_N = mkN "sötaktighet" ; -- sötaktighet..nn.1
  sötande_1_N = mkN "sötande" ; -- sötande..nn.1
  söthet_1_N = mkN "söthet" ; -- söthet..nn.1
  sötma_1_N = mkN "sötma" ; -- sötma..nn.1
  sötmandel_1_N = mkN "sötmandel" ; -- sötmandel..nn.1
  sötmjölk_1_N = mkN "sötmjölk" ; -- sötmjölk..nn.1
  sötningsmedel_1_N = mkN "sötningsmedel" neutrum  ; -- sötningsmedel..nn.1
  sötnos_1_N = mkN "sötnos" ; -- sötnos..nn.1
  sötpotatis_1_N = mkN "sötpotatis" ; -- sötpotatis..nn.1
  sötsak_1_N = mkN "sötsak" "sötsaker" ; -- sötsak..nn.1
  sötsliskig_1_A = mkA "sötsliskig" ; -- sötsliskig..av.1
  sötsliskighet_1_N = mkN "sötsliskighet" ; -- sötsliskighet..nn.1
  sötsug_1_N = mkN "sötsug" neutrum  ; -- sötsug..nn.1
  sötsur_1_A = mkA "sötsur" ; -- sötsur..av.1
  sötsurhet_1_N = mkN "sötsurhet" ; -- sötsurhet..nn.1
  sötvatten_1_N = mkN "sötvatten" "sötvattnet" "sötvatten" "sötvattnen" ; -- sötvatten..nn.1
  sötvattensforskare_1_N = mkN "sötvattensforskare" utrum  ; -- sötvattensforskare..nn.1
  sötvattensnäcka_1_N = mkN "sötvattensnäcka" ; -- sötvattensnäcka..nn.1
  söva_1_V = mkV "söver" ; -- söva..vb.1
  sövande_1_A = mkA "sövande" ; -- sövande..av.1
  sövande_1_N = mkN "sövande" ; -- sövande..nn.1
  sövning_1_N = mkN "sövning" ; -- sövning..nn.1
  t_bane_plankare_1_N = mkN "t-bane-plankare" utrum  ; -- t-bane-plankare..nn.1
  t_shirt_1_N = mkN "t-shirt" ; -- t-shirt..nn.1
  t_tröja_1_N = mkN "t-tröja" ; -- t-tröja..nn.1
  ta_1_V = mkV "taga" "tog" "tagit" ; -- ta..vb.1
  tabasco_1_N = mkN "tabasco" ; -- tabasco..nn.1
  tabbe_1_N = mkN "tabbe" utrum  ; -- tabbe..nn.1
  tabell_1_N = mkN "tabell" "tabeller" ; -- tabell..nn.1
  tabellarisk_1_A = mkA "tabellarisk" ; -- tabellarisk..av.1
  tabellera_1_V = mkV "tabellerar" ; -- tabellera..vb.1
  tabellerande_1_N = mkN "tabellerande" ; -- tabellerande..nn.1
  tabellerbar_1_A = mkA "tabellerbar" ; -- tabellerbar..av.1
  tabellerbarhet_1_N = mkN "tabellerbarhet" ; -- tabellerbarhet..nn.1
  tabellering_1_N = mkN "tabellering" ; -- tabellering..nn.1
  tabellhuvud_1_N = mkN "tabellhuvud" "tabellhuvudet" "tabellhuvud" "tabellhuvudena" ; -- tabellhuvud..nn.1
  tabellskatt_1_N = mkN "tabellskatt" "tabellskatter" ; -- tabellskatt..nn.1
  tabelras_1_N = mkN "tabelras" ; -- tabelras..nn.1
  tabernakel_1_N = mkN "tabernakel" neutrum  ; -- tabernakel..nn.1
  tablett_1_N = mkN "tablett" "tabletter" ; -- tablett..nn.1
  tablettform_1_N = mkN "tablettform" ; -- tablettform..nn.1
  tabloid_1_N = mkN "tabloid" "tabloider" ; -- tabloid..nn.1
  tablå_1_N = mkN "tablå" "tablåer" ; -- tablå..nn.1
  tablåmässig_1_A = mkA "tablåmässig" ; -- tablåmässig..av.1
  tabu_1_A = mkA "tabu" ; -- tabu..av.1
  tabu_1_N = mkN "tabu" "tabut" "tabun" "tabuna" ; -- tabu..nn.1
  tabubelagd_1_A = mkA "tabubelagd" "tabubelagt" ; -- tabubelagd..av.1
  tabubelägga_1_V = mkV "tabubelägga" "tabubela" "tabubelagt" ; -- tabubelägga..vb.1
  tabubeläggande_1_N = mkN "tabubeläggande" ; -- tabubeläggande..nn.1
  tabubeläggning_1_N = mkN "tabubeläggning" ; -- tabubeläggning..nn.1
  tabuera_1_V = mkV "tabuerar" ; -- tabuera..vb.1
  tabuerande_1_N = mkN "tabuerande" ; -- tabuerande..nn.1
  tabuerbar_1_A = mkA "tabuerbar" ; -- tabuerbar..av.1
  tabuerbarhet_1_N = mkN "tabuerbarhet" ; -- tabuerbarhet..nn.1
  tabuering_1_N = mkN "tabuering" ; -- tabuering..nn.1
  tabugräns_1_N = mkN "tabugräns" "tabugränser" ; -- tabugräns..nn.1
  tabulator_1_N = mkN "tabulator" "tabulatorer" ; -- tabulator..nn.1
  tabulatur_1_N = mkN "tabulatur" "tabulaturer" ; -- tabulatur..nn.1
  tabulera_1_V = mkV "tabulerar" ; -- tabulera..vb.1
  tabulerande_1_N = mkN "tabulerande" ; -- tabulerande..nn.1
  tabulering_1_N = mkN "tabulering" ; -- tabulering..nn.1
  tabuord_1_N = mkN "tabuord" neutrum  ; -- tabuord..nn.1
  taburett_1_N = mkN "taburett" "taburetter" ; -- taburett..nn.1
  tack_1_N = mkN "tack" neutrum  ; -- tack..nn.1
  tacka_1_N = mkN "tacka" ; -- tacka..nn.1
  tacka_1_V = mkV "tackar" ; -- tacka..vb.1
  tackande_1_N = mkN "tackande" ; -- tackande..nn.1
  tackel_1_N = mkN "tackel" neutrum  ; -- tackel..nn.1
  tackjärn_1_N = mkN "tackjärn" neutrum  ; -- tackjärn..nn.1
  tackjärnsblandare_1_N = mkN "tackjärnsblandare" utrum  ; -- tackjärnsblandare..nn.1
  tackkort_1_N = mkN "tackkort" neutrum  ; -- tackkort..nn.1
  tackla_1_V = mkV "tacklar" ; -- tackla..vb.1
  tacklage_1_N = mkN "tacklage" ; -- tacklage..nn.1
  tacklande_1_N = mkN "tacklande" ; -- tacklande..nn.1
  tackling_1_N = mkN "tackling" ; -- tackling..nn.1
  tacknämlig_1_A = mkA "tacknämlig" ; -- tacknämlig..av.1
  tacknämlighet_1_N = mkN "tacknämlighet" ; -- tacknämlighet..nn.1
  tackoffer_1_N = mkN "tackoffer" neutrum  ; -- tackoffer..nn.1
  tacksam_1_A = mkA "tacksam" "tacksamt" "tacksamma" "tacksamma" "tacksammare" "tacksammast" "tacksammaste" ; -- tacksam..av.1
  tacksamhet_1_N = mkN "tacksamhet" "tacksamheter" ; -- tacksamhet..nn.1
  tacksamhetsbetygelse_1_N = mkN "tacksamhetsbetygelse" "tacksamhetsbetygelser" ; -- tacksamhetsbetygelse..nn.1
  tacksamhetsgärd_1_N = mkN "tacksamhetsgärd" "tacksamhetsgärder" ; -- tacksamhetsgärd..nn.1
  tacksamhetsskuld_1_N = mkN "tacksamhetsskuld" ; -- tacksamhetsskuld..nn.1
  tacksägelse_1_N = mkN "tacksägelse" "tacksägelser" ; -- tacksägelse..nn.1
  tacksägelsedag_1_N = mkN "tacksägelsedag" ; -- tacksägelsedag..nn.1
  tacksägelsefest_1_N = mkN "tacksägelsefest" "tacksägelsefester" ; -- tacksägelsefest..nn.1
  tacksägelsegudstjänst_1_N = mkN "tacksägelsegudstjänst" "tacksägelsegudstjänster" ; -- tacksägelsegudstjänst..nn.1
  tacktal_1_N = mkN "tacktal" neutrum  ; -- tacktal..nn.1
  taco_1_N = mkN "taco" "tacon" "tacos" "tacosarna" ; -- taco..nn.1
  tacorecept_1_N = mkN "tacorecept" neutrum  ; -- tacorecept..nn.1
  tadel_1_N = mkN "tadel" neutrum  ; -- tadel..nn.1
  tadelfri_1_A = mkA "tadelfri" "tadelfritt" ; -- tadelfri..av.1
  tadla_1_V = mkV "tadlar" ; -- tadla..vb.1
  tadlande_1_N = mkN "tadlande" ; -- tadlande..nn.1
  tadzjik_1_N = mkN "tadzjik" "tadzjiker" ; -- tadzjik..nn.1
  tadzjikisk_1_A = mkA "tadzjikisk" ; -- tadzjikisk..av.1
  tadzjikiska_1_N = mkN "tadzjikiska" ; -- tadzjikiska..nn.1
  tadzjikiska_2_N = mkN "tadzjikiska" ; -- tadzjikiska..nn.2
  tafatt_1_A = mkA "tafatt" ; -- tafatt..av.1
  tafatt_1_N = mkN "tafatt" ; -- tafatt..nn.1
  tafatthet_1_N = mkN "tafatthet" ; -- tafatthet..nn.1
  taffel_1_N = mkN "taffel" ; -- taffel..nn.1
  taffelberg_1_N = mkN "taffelberg" neutrum  ; -- taffelberg..nn.1
  taffelland_1_N = mkN "taffelland" neutrum  ; -- taffelland..nn.1
  taffelmusik_1_N = mkN "taffelmusik" ; -- taffelmusik..nn.1
  taffeltäckare_1_N = mkN "taffeltäckare" utrum  ; -- taffeltäckare..nn.1
  taffelvåg_1_N = mkN "taffelvåg" ; -- taffelvåg..nn.1
  taffla_1_V = mkV "tafflar" ; -- taffla..vb.1
  tafflande_1_N = mkN "tafflande" ; -- tafflande..nn.1
  tafflig_1_A = mkA "tafflig" ; -- tafflig..av.1
  tafflighet_1_N = mkN "tafflighet" "taffligheter" ; -- tafflighet..nn.1
  tafs_1_N = mkN "tafs" ; -- tafs..nn.1
  tafsa_1_V = mkV "tafsar" ; -- tafsa..vb.1
  tafsande_1_N = mkN "tafsande" ; -- tafsande..nn.1
  tafsare_1_N = mkN "tafsare" utrum  ; -- tafsare..nn.1
  tafsig_1_A = mkA "tafsig" ; -- tafsig..av.1
  tafsighet_1_N = mkN "tafsighet" ; -- tafsighet..nn.1
  taft_1_N = mkN "taft" ; -- taft..nn.1
  taftbindning_1_N = mkN "taftbindning" ; -- taftbindning..nn.1
  tag_1_N = mkN "tag" neutrum  ; -- tag..nn.1
  tag_2_N = mkN "tag" neutrum  ; -- tag..nn.2
  tagande_1_N = mkN "tagande" ; -- tagande..nn.1
  tagel_1_N = mkN "tagel" neutrum  ; -- tagel..nn.1
  tagelmadrass_1_N = mkN "tagelmadrass" "tagelmadrasser" ; -- tagelmadrass..nn.1
  tagelmask_1_N = mkN "tagelmask" ; -- tagelmask..nn.1
  tagelskjorta_1_N = mkN "tagelskjorta" ; -- tagelskjorta..nn.1
  tagen_1_A = mkA "tagen" ; -- tagen..av.1
  tagetes_1_N = mkN "tagetes" ; -- tagetes..nn.1
  tagg_1_N = mkN "tagg" ; -- tagg..nn.1
  tagga_1_V = mkV "taggar" ; -- tagga..vb.1
  taggad_1_A = mkA "taggad" ; -- taggad..av.1
  taggande_1_N = mkN "taggande" ; -- taggande..nn.1
  taggare_1_N = mkN "taggare" utrum  ; -- taggare..nn.1
  taggbräken_1_N = mkN "taggbräken" ; -- taggbräken..nn.1
  taggfenig_1_A = mkA "taggfenig" ; -- taggfenig..av.1
  taggfenighet_1_N = mkN "taggfenighet" ; -- taggfenighet..nn.1
  taggfening_1_N = mkN "taggfening" ; -- taggfening..nn.1
  taggförsedd_1_A = mkA "taggförsedd" ; -- taggförsedd..av.1
  tagghuding_1_N = mkN "tagghuding" ; -- tagghuding..nn.1
  taggig_1_A = mkA "taggig" ; -- taggig..av.1
  taggighet_1_N = mkN "taggighet" ; -- taggighet..nn.1
  taggpar_1_N = mkN "taggpar" neutrum  ; -- taggpar..nn.1
  taggstråle_1_N = mkN "taggstråle" utrum  ; -- taggstråle..nn.1
  taggsvamp_1_N = mkN "taggsvamp" ; -- taggsvamp..nn.1
  taggtråd_1_N = mkN "taggtråd" ; -- taggtråd..nn.1
  taggtrådsbefäst_1_A = mkA "taggtrådsbefäst" "taggtrådsbefäst" ; -- taggtrådsbefäst..av.1
  taggtrådshinder_1_N = mkN "taggtrådshinder" neutrum  ; -- taggtrådshinder..nn.1
  taggtrådsrulle_1_N = mkN "taggtrådsrulle" utrum  ; -- taggtrådsrulle..nn.1
  taggtrådsstängsel_1_N = mkN "taggtrådsstängsel" neutrum  ; -- taggtrådsstängsel..nn.1
  tagla_1_V = mkV "taglar" ; -- tagla..vb.1
  taglande_1_N = mkN "taglande" ; -- taglande..nn.1
  taglingsgarn_1_N = mkN "taglingsgarn" neutrum  ; -- taglingsgarn..nn.1
  tagning_1_N = mkN "tagning" ; -- tagning..nn.1
  taiga_1_N = mkN "taiga" ; -- taiga..nn.1
  taiwanes_1_N = mkN "taiwanes" "taiwaneser" ; -- taiwanes..nn.1
  taiwanesisk_1_A = mkA "taiwanesisk" ; -- taiwanesisk..av.1
  taiwanesiska_1_N = mkN "taiwanesiska" ; -- taiwanesiska..nn.1
  taiwanesiska_2_N = mkN "taiwanesiska" ; -- taiwanesiska..nn.2
  taja_1_V = mkV "tajar" ; -- taja..vb.1
  tajande_1_N = mkN "tajande" ; -- tajande..nn.1
  tajga_1_N = mkN "tajga" ; -- tajga..nn.1
  tajm_1_N = mkN "tajm" ; -- tajm..nn.1
  tajma_1_V = mkV "tajmar" ; -- tajma..vb.1
  tajmande_1_N = mkN "tajmande" ; -- tajmande..nn.1
  tajming_1_N = mkN "tajming" ; -- tajming..nn.1
  tajning_1_N = mkN "tajning" ; -- tajning..nn.1
  tajt_1_A = mkA "tajt" "tajt" ; -- tajt..av.1
  tajthet_1_N = mkN "tajthet" ; -- tajthet..nn.1
  tak_1_N = mkN "tak" neutrum  ; -- tak..nn.1
  takaltan_1_N = mkN "takaltan" "takaltaner" ; -- takaltan..nn.1
  takbelysning_1_N = mkN "takbelysning" ; -- takbelysning..nn.1
  takbeläggning_1_N = mkN "takbeläggning" ; -- takbeläggning..nn.1
  takbjälke_1_N = mkN "takbjälke" utrum  ; -- takbjälke..nn.1
  takbox_1_N = mkN "takbox" ; -- takbox..nn.1
  takbrand_1_N = mkN "takbrand" "takbränder" ; -- takbrand..nn.1
  takbrunn_1_N = mkN "takbrunn" ; -- takbrunn..nn.1
  takdropp_1_N = mkN "takdropp" neutrum  ; -- takdropp..nn.1
  take_away_1_N = mkN "take-away" "take-awayen" "take-aways" "take-awayerna" ; -- take-away..nn.1
  takeaway_1_N = mkN "takeaway" "takeawayen" "takeaways" "takeawayerna" ; -- takeaway..nn.1
  takfall_1_N = mkN "takfall" neutrum  ; -- takfall..nn.1
  takfest_1_N = mkN "takfest" "takfester" ; -- takfest..nn.1
  takfläkt_1_N = mkN "takfläkt" ; -- takfläkt..nn.1
  takfot_1_N = mkN "takfot" ; -- takfot..nn.1
  takfris_1_N = mkN "takfris" "takfriser" ; -- takfris..nn.1
  takfönster_1_N = mkN "takfönster" neutrum  ; -- takfönster..nn.1
  takgesims_1_N = mkN "takgesims" "takgesimser" ; -- takgesims..nn.1
  takgräs_1_N = mkN "takgräs" neutrum  ; -- takgräs..nn.1
  takhalm_1_N = mkN "takhalm" ; -- takhalm..nn.1
  takhimmel_1_N = mkN "takhimmel" ; -- takhimmel..nn.1
  takhuv_1_N = mkN "takhuv" ; -- takhuv..nn.1
  takhöjd_1_N = mkN "takhöjd" "takhöjder" ; -- takhöjd..nn.1
  takistoskop_1_N = mkN "takistoskop" neutrum  ; -- takistoskop..nn.1
  takistoskopi_1_N = mkN "takistoskopi" "takistoskopier" ; -- takistoskopi..nn.1
  takkam_1_N = mkN "takkam" "takkammen" "takkammar" "takkammarna" ; -- takkam..nn.1
  takklättrare_1_N = mkN "takklättrare" utrum  ; -- takklättrare..nn.1
  takkonstruktion_1_N = mkN "takkonstruktion" ; -- takkonstruktion..nn.1
  takkrona_1_N = mkN "takkrona" ; -- takkrona..nn.1
  taklag_1_N = mkN "taklag" neutrum  ; -- taklag..nn.1
  taklagsfest_1_N = mkN "taklagsfest" "taklagsfester" ; -- taklagsfest..nn.1
  taklagsöl_1_N = mkN "taklagsöl" neutrum  ; -- taklagsöl..nn.1
  taklampa_1_N = mkN "taklampa" ; -- taklampa..nn.1
  taklist_1_N = mkN "taklist" "taklister" ; -- taklist..nn.1
  takläggare_1_N = mkN "takläggare" utrum  ; -- takläggare..nn.1
  takläkt_1_N = mkN "takläkt" "takläkter" ; -- takläkt..nn.1
  taklök_1_N = mkN "taklök" ; -- taklök..nn.1
  taklös_1_A = mkA "taklös" ; -- taklös..av.1
  taknock_1_N = mkN "taknock" ; -- taknock..nn.1
  takometer_1_N = mkN "takometer" ; -- takometer..nn.1
  takpanna_1_N = mkN "takpanna" ; -- takpanna..nn.1
  takpapp_1_N = mkN "takpapp" ; -- takpapp..nn.1
  takplatta_1_N = mkN "takplatta" ; -- takplatta..nn.1
  takras_1_N = mkN "takras" neutrum  ; -- takras..nn.1
  takregel_1_N = mkN "takregel" ; -- takregel..nn.1
  takresning_1_N = mkN "takresning" ; -- takresning..nn.1
  takrygg_1_N = mkN "takrygg" ; -- takrygg..nn.1
  takryttare_1_N = mkN "takryttare" utrum  ; -- takryttare..nn.1
  takräck_1_N = mkN "takräck" neutrum  ; -- takräck..nn.1
  takräcke_1_N = mkN "takräcke" ; -- takräcke..nn.1
  takränna_1_N = mkN "takränna" ; -- takränna..nn.1
  takröst_1_N = mkN "takröst" neutrum  ; -- takröst..nn.1
  takröste_1_N = mkN "takröste" ; -- takröste..nn.1
  taksektion_1_N = mkN "taksektion" ; -- taksektion..nn.1
  taksilhuett_1_N = mkN "taksilhuett" "taksilhuetter" ; -- taksilhuett..nn.1
  takskottare_1_N = mkN "takskottare" utrum  ; -- takskottare..nn.1
  takskägg_1_N = mkN "takskägg" neutrum  ; -- takskägg..nn.1
  taksparre_1_N = mkN "taksparre" utrum  ; -- taksparre..nn.1
  taksprång_1_N = mkN "taksprång" neutrum  ; -- taksprång..nn.1
  takspån_1_N = mkN "takspån" neutrum  ; -- takspån..nn.1
  takstol_1_N = mkN "takstol" ; -- takstol..nn.1
  takt_1_N = mkN "takt" "takter" ; -- takt..nn.1
  takt_2_N = mkN "takt" ; -- takt..nn.2
  taktart_1_N = mkN "taktart" "taktarter" ; -- taktart..nn.1
  taktbeteckning_1_N = mkN "taktbeteckning" ; -- taktbeteckning..nn.1
  taktdel_1_N = mkN "taktdel" "taktdelen" "taktdelar" "taktdelarna" ; -- taktdel..nn.1
  taktegel_1_N = mkN "taktegel" neutrum  ; -- taktegel..nn.1
  taktera_1_V = mkV "takterar" ; -- taktera..vb.1
  takterande_1_N = mkN "takterande" ; -- takterande..nn.1
  taktering_1_N = mkN "taktering" ; -- taktering..nn.1
  taktfast_1_A = mkA "taktfast" "taktfast" ; -- taktfast..av.1
  taktfasthet_1_N = mkN "taktfasthet" ; -- taktfasthet..nn.1
  taktfull_1_A = mkA "taktfull" ; -- taktfull..av.1
  taktfullhet_1_N = mkN "taktfullhet" ; -- taktfullhet..nn.1
  taktik_1_N = mkN "taktik" "taktiker" ; -- taktik..nn.1
  taktiker_1_N = mkN "taktiker" "taktikern" "taktiker" "taktikerna" ; -- taktiker..nn.1
  taktikrösta_1_V = mkV "taktikröstar" ; -- taktikrösta..vb.1
  taktikröstande_1_N = mkN "taktikröstande" ; -- taktikröstande..nn.1
  taktikröstning_1_N = mkN "taktikröstning" ; -- taktikröstning..nn.1
  taktil_1_A = mkA "taktil" ; -- taktil..av.1
  taktisk_1_A = mkA "taktisk" ; -- taktisk..av.1
  taktisk_2_A = mkA "taktisk" ; -- taktisk..av.2
  taktkänsla_1_N = mkN "taktkänsla" ; -- taktkänsla..nn.1
  taktlös_1_A = mkA "taktlös" ; -- taktlös..av.1
  taktlöshet_1_N = mkN "taktlöshet" "taktlösheter" ; -- taktlöshet..nn.1
  taktmässig_1_A = mkA "taktmässig" ; -- taktmässig..av.1
  taktorv_1_N = mkN "taktorv" ; -- taktorv..nn.1
  taktpinne_1_N = mkN "taktpinne" utrum  ; -- taktpinne..nn.1
  taktslag_1_N = mkN "taktslag" neutrum  ; -- taktslag..nn.1
  taktstreck_1_N = mkN "taktstreck" neutrum  ; -- taktstreck..nn.1
  taktsäker_1_A = mkA "taktsäker" ; -- taktsäker..av.1
  taktäckare_1_N = mkN "taktäckare" utrum  ; -- taktäckare..nn.1
  taktäckning_1_N = mkN "taktäckning" ; -- taktäckning..nn.1
  takvass_1_N = mkN "takvass" ; -- takvass..nn.1
  takvåning_1_N = mkN "takvåning" ; -- takvåning..nn.1
  takykardi_1_N = mkN "takykardi" "takykardier" ; -- takykardi..nn.1
  takymeter_1_N = mkN "takymeter" ; -- takymeter..nn.1
  takås_1_N = mkN "takås" ; -- takås..nn.1
  tal_1_N = mkN "tal" neutrum  ; -- tal..nn.1
  tal_2_N = mkN "tal" neutrum  ; -- tal..nn.2
  tala_1_V = mkV "talar" ; -- tala..vb.1
  talakt_1_N = mkN "talakt" "talakter" ; -- talakt..nn.1
  talande_1_A = mkA "talande" ; -- talande..av.1
  talande_1_N = mkN "talande" ; -- talande..nn.1
  talang_1_N = mkN "talang" "talanger" ; -- talang..nn.1
  talangfull_1_A = mkA "talangfull" ; -- talangfull..av.1
  talangfullhet_1_N = mkN "talangfullhet" ; -- talangfullhet..nn.1
  talangjakt_1_N = mkN "talangjakt" "talangjakter" ; -- talangjakt..nn.1
  talanglös_1_A = mkA "talanglös" ; -- talanglös..av.1
  talanglöshet_1_N = mkN "talanglöshet" ; -- talanglöshet..nn.1
  talangprogram_1_N = mkN "talangprogram" "talangprogrammet" "talangprogram" "talangprogrammen" ; -- talangprogram..nn.1
  talangscout_1_N = mkN "talangscout" "talangscouter" ; -- talangscout..nn.1
  talapparat_1_N = mkN "talapparat" "talapparater" ; -- talapparat..nn.1
  talar_1_N = mkN "talar" "talarer" ; -- talar..nn.1
  talare_1_N = mkN "talare" utrum  ; -- talare..nn.1
  talarkonst_1_N = mkN "talarkonst" ; -- talarkonst..nn.1
  talarlista_1_N = mkN "talarlista" ; -- talarlista..nn.1
  talarstol_1_N = mkN "talarstol" ; -- talarstol..nn.1
  talbok_1_N = mkN "talbok" "talböcker" ; -- talbok..nn.1
  talcentrum_1_N = mkN "talcentrum" neutrum  ; -- talcentrum..nn.1
  talegåva_1_N = mkN "talegåva" ; -- talegåva..nn.1
  talekonst_1_N = mkN "talekonst" ; -- talekonst..nn.1
  talent_1_N = mkN "talent" "talenter" ; -- talent..nn.1
  talerätt_1_N = mkN "talerätt" ; -- talerätt..nn.1
  taleskvinna_1_N = mkN "taleskvinna" ; -- taleskvinna..nn.1
  talesman_1_N = mkN "talesman" "talesmannen" "talesmän" "talesmännen" ; -- talesman..nn.1
  talesperson_1_N = mkN "talesperson" "talespersoner" ; -- talesperson..nn.1
  talesätt_1_N = mkN "talesätt" neutrum  ; -- talesätt..nn.1
  talfel_1_N = mkN "talfel" "talfelet" "talfel" "talfelen" ; -- talfel..nn.1
  talföljd_1_N = mkN "talföljd" "talföljder" ; -- talföljd..nn.1
  talför_1_A = mkA "talför" ; -- talför..av.1
  talförhet_1_N = mkN "talförhet" ; -- talförhet..nn.1
  talförhållande_1_N = mkN "talförhållande" ; -- talförhållande..nn.1
  talförmåga_1_N = mkN "talförmåga" ; -- talförmåga..nn.1
  talg_1_N = mkN "talg" ; -- talg..nn.1
  talga_1_V = mkV "talgar" ; -- talga..vb.1
  talgande_1_N = mkN "talgande" ; -- talgande..nn.1
  talgdank_1_N = mkN "talgdank" ; -- talgdank..nn.1
  talgig_1_A = mkA "talgig" ; -- talgig..av.1
  talgighet_1_N = mkN "talgighet" ; -- talgighet..nn.1
  talgkörtel_1_N = mkN "talgkörtel" ; -- talgkörtel..nn.1
  talgljus_1_N = mkN "talgljus" neutrum  ; -- talgljus..nn.1
  talgoxe_1_N = mkN "talgoxe" utrum  ; -- talgoxe..nn.1
  talgögd_1_A = mkA "talgögd" "talgögt" ; -- talgögd..av.1
  talgögdhet_1_N = mkN "talgögdhet" ; -- talgögdhet..nn.1
  taliban_1_N = mkN "taliban" "talibaner" ; -- taliban..nn.1
  talibanrebell_1_N = mkN "talibanrebell" "talibanrebeller" ; -- talibanrebell..nn.1
  talibansk_1_A = mkA "talibansk" ; -- talibansk..av.1
  talisman_1_N = mkN "talisman" "talismaner" ; -- talisman..nn.1
  talja_1_N = mkN "talja" ; -- talja..nn.1
  talk_1_N = mkN "talk" ; -- talk..nn.1
  talka_1_V = mkV "talkar" ; -- talka..vb.1
  talkande_1_N = mkN "talkande" ; -- talkande..nn.1
  talkig_1_A = mkA "talkig" ; -- talkig..av.1
  talkighet_1_N = mkN "talkighet" ; -- talkighet..nn.1
  talklinik_1_N = mkN "talklinik" "talkliniker" ; -- talklinik..nn.1
  talkshow_1_N = mkN "talkshow" "talkshower" ; -- talkshow..nn.1
  talkshowprogram_1_N = mkN "talkshowprogram" "talkshowprogrammet" "talkshowprogram" "talkshowprogrammen" ; -- talkshowprogram..nn.1
  talkskiffer_1_N = mkN "talkskiffer" ; -- talkskiffer..nn.1
  talkör_1_N = mkN "talkör" "talkörer" ; -- talkör..nn.1
  tall_1_N = mkN "tall" ; -- tall..nn.1
  talla_1_V = mkV "tallar" ; -- talla..vb.1
  tallande_1_N = mkN "tallande" ; -- tallande..nn.1
  tallbark_1_N = mkN "tallbark" ; -- tallbark..nn.1
  tallbarr_1_N = mkN "tallbarr" neutrum  ; -- tallbarr..nn.1
  tallbarrsolja_1_N = mkN "tallbarrsolja" ; -- tallbarrsolja..nn.1
  tallbit_1_N = mkN "tallbit" ; -- tallbit..nn.1
  tallbock_1_N = mkN "tallbock" ; -- tallbock..nn.1
  talldunge_1_N = mkN "talldunge" utrum  ; -- talldunge..nn.1
  tallgren_1_N = mkN "tallgren" "tallgrenen" "tallgrenar" "tallgrenarna" ; -- tallgren..nn.1
  tallinje_1_N = mkN "tallinje" "tallinjer" ; -- tallinje..nn.1
  tallium_1_N = mkN "tallium" neutrum  ; -- tallium..nn.1
  tallkottkörtel_1_N = mkN "tallkottkörtel" ; -- tallkottkörtel..nn.1
  tallkottskörtel_1_N = mkN "tallkottskörtel" ; -- tallkottskörtel..nn.1
  tallmätare_1_N = mkN "tallmätare" utrum  ; -- tallmätare..nn.1
  tallolja_1_N = mkN "tallolja" ; -- tallolja..nn.1
  tallplanta_1_N = mkN "tallplanta" ; -- tallplanta..nn.1
  tallrik_1_A = mkA "tallrik" ; -- tallrik..av.1
  tallrik_1_N = mkN "tallrik" ; -- tallrik..nn.1
  tallrikhet_1_N = mkN "tallrikhet" ; -- tallrikhet..nn.1
  tallriksformad_1_A = mkA "tallriksformad" ; -- tallriksformad..av.1
  tallriksharv_1_N = mkN "tallriksharv" ; -- tallriksharv..nn.1
  tallrikshjul_1_N = mkN "tallrikshjul" neutrum  ; -- tallrikshjul..nn.1
  tallriksis_1_N = mkN "tallriksis" ; -- tallriksis..nn.1
  tallriksliknande_1_A = mkA "tallriksliknande" ; -- tallriksliknande..av.1
  tallriksslickare_1_N = mkN "tallriksslickare" utrum  ; -- tallriksslickare..nn.1
  tallriksventil_1_N = mkN "tallriksventil" "tallriksventiler" ; -- tallriksventil..nn.1
  tallskog_1_N = mkN "tallskog" ; -- tallskog..nn.1
  tallsort_1_N = mkN "tallsort" "tallsorter" ; -- tallsort..nn.1
  tallspinnare_1_N = mkN "tallspinnare" utrum  ; -- tallspinnare..nn.1
  tallstam_1_N = mkN "tallstam" "tallstammen" "tallstammar" "tallstammarna" ; -- tallstam..nn.1
  tallstekel_1_N = mkN "tallstekel" ; -- tallstekel..nn.1
  tallstrunt_1_N = mkN "tallstrunt" ; -- tallstrunt..nn.1
  tallticka_1_N = mkN "tallticka" ; -- tallticka..nn.1
  talltita_1_N = mkN "talltita" ; -- talltita..nn.1
  tallört_1_N = mkN "tallört" "tallörter" ; -- tallört..nn.1
  tallös_1_A = mkA "tallös" ; -- tallös..av.1
  tallöshet_1_N = mkN "tallöshet" ; -- tallöshet..nn.1
  talman_1_N = mkN "talman" "talmannen" "talmän" "talmännen" ; -- talman..nn.1
  talmansklubba_1_N = mkN "talmansklubba" ; -- talmansklubba..nn.1
  talmanskonferens_1_N = mkN "talmanskonferens" "talmanskonferenser" ; -- talmanskonferens..nn.1
  talmystik_1_N = mkN "talmystik" ; -- talmystik..nn.1
  talong_1_N = mkN "talong" "talonger" ; -- talong..nn.1
  talorgan_1_N = mkN "talorgan" neutrum  ; -- talorgan..nn.1
  talpedagog_1_N = mkN "talpedagog" "talpedagoger" ; -- talpedagog..nn.1
  talpjäs_1_N = mkN "talpjäs" "talpjäser" ; -- talpjäs..nn.1
  talregistreringsapparat_1_N = mkN "talregistreringsapparat" "talregistreringsapparater" ; -- talregistreringsapparat..nn.1
  talrik_1_A = mkA "talrik" ; -- talrik..av.1
  talrikhet_1_N = mkN "talrikhet" ; -- talrikhet..nn.1
  talroll_1_N = mkN "talroll" "talroller" ; -- talroll..nn.1
  talrubbning_1_N = mkN "talrubbning" ; -- talrubbning..nn.1
  talrör_1_N = mkN "talrör" neutrum  ; -- talrör..nn.1
  talscen_1_N = mkN "talscen" "talscener" ; -- talscen..nn.1
  talshow_1_N = mkN "talshow" "talshower" ; -- talshow..nn.1
  talsituation_1_N = mkN "talsituation" ; -- talsituation..nn.1
  talskrivare_1_N = mkN "talskrivare" utrum  ; -- talskrivare..nn.1
  talspråk_1_N = mkN "talspråk" neutrum  ; -- talspråk..nn.1
  talspråklig_1_A = mkA "talspråklig" ; -- talspråklig..av.1
  talspråklighet_1_N = mkN "talspråklighet" "talspråkligheter" ; -- talspråklighet..nn.1
  talspråksmässig_1_A = mkA "talspråksmässig" ; -- talspråksmässig..av.1
  talsvar_1_N = mkN "talsvar" neutrum  ; -- talsvar..nn.1
  talsvarssystem_1_N = mkN "talsvarssystem" neutrum  ; -- talsvarssystem..nn.1
  talsvarstjänst_1_N = mkN "talsvarstjänst" "talsvarstjänster" ; -- talsvarstjänst..nn.1
  talsvarsystem_1_N = mkN "talsvarsystem" neutrum  ; -- talsvarsystem..nn.1
  talsvårighet_1_N = mkN "talsvårighet" "talsvårigheter" ; -- talsvårighet..nn.1
  talsymbolik_1_N = mkN "talsymbolik" ; -- talsymbolik..nn.1
  talsyntes_1_N = mkN "talsyntes" ; -- talsyntes..nn.1
  talsystem_1_N = mkN "talsystem" neutrum  ; -- talsystem..nn.1
  talteknik_1_N = mkN "talteknik" ; -- talteknik..nn.1
  talteknologi_1_N = mkN "talteknologi" "talteknologier" ; -- talteknologi..nn.1
  talteori_1_N = mkN "talteori" ; -- talteori..nn.1
  taltrast_1_N = mkN "taltrast" ; -- taltrast..nn.1
  taltratt_1_N = mkN "taltratt" ; -- taltratt..nn.1
  talträngd_1_A = mkA "talträngd" "talträngt" ; -- talträngd..av.1
  talträngdhet_1_N = mkN "talträngdhet" ; -- talträngdhet..nn.1
  talvård_1_N = mkN "talvård" ; -- talvård..nn.1
  tam_1_A = mkA "tam" ; -- tam..av.1
  tamarind_1_N = mkN "tamarind" "tamarinder" ; -- tamarind..nn.1
  tamarisk_1_N = mkN "tamarisk" "tamarisker" ; -- tamarisk..nn.1
  tambur_1_N = mkN "tambur" "tamburer" ; -- tambur..nn.1
  tamburin_1_N = mkN "tamburin" "tamburiner" ; -- tamburin..nn.1
  tamburmajor_1_N = mkN "tamburmajor" "tamburmajorer" ; -- tamburmajor..nn.1
  tambursöm_1_N = mkN "tambursöm" "tambursömmen" "tambursömmar" "tambursömmarna" ; -- tambursöm..nn.1
  tamburtapet_1_N = mkN "tamburtapet" "tamburtapeter" ; -- tamburtapet..nn.1
  tamburvaktmästare_1_N = mkN "tamburvaktmästare" utrum  ; -- tamburvaktmästare..nn.1
  tamduva_1_N = mkN "tamduva" ; -- tamduva..nn.1
  tamfågel_1_N = mkN "tamfågel" ; -- tamfågel..nn.1
  tamhet_1_N = mkN "tamhet" ; -- tamhet..nn.1
  tamiflu_1_N = mkN "tamiflu" neutrum  ; -- tamiflu..nn.1
  tamil_1_N = mkN "tamil" "tamiler" ; -- tamil..nn.1
  tamil_2_N = mkN "tamil" ; -- tamil..nn.2
  tamilsk_1_A = mkA "tamilsk" ; -- tamilsk..av.1
  tamkatt_1_N = mkN "tamkatt" "tamkatter" ; -- tamkatt..nn.1
  tamp_1_N = mkN "tamp" ; -- tamp..nn.1
  tamponera_1_V = mkV "tamponerar" ; -- tamponera..vb.1
  tamponerande_1_N = mkN "tamponerande" ; -- tamponerande..nn.1
  tamponerbar_1_A = mkA "tamponerbar" ; -- tamponerbar..av.1
  tamponerbarhet_1_N = mkN "tamponerbarhet" ; -- tamponerbarhet..nn.1
  tamponering_1_N = mkN "tamponering" ; -- tamponering..nn.1
  tampong_1_N = mkN "tampong" "tamponger" ; -- tampong..nn.1
  tampongsjuka_1_N = mkN "tampongsjuka" ; -- tampongsjuka..nn.1
  tamren_1_N = mkN "tamren" "tamrenen" "tamrenar" "tamrenarna" ; -- tamren..nn.1
  tamsvin_1_N = mkN "tamsvin" neutrum  ; -- tamsvin..nn.1
  tamtam_1_N = mkN "tamtam" ; -- tamtam..nn.1
  tamul_1_N = mkN "tamul" "tamuler" ; -- tamul..nn.1
  tana_1_N = mkN "tana" ; -- tana..nn.1
  tand_1_N = mkN "tand" "tänder" ; -- tand..nn.1
  tanda_1_V = mkV "tandar" ; -- tanda..vb.1
  tandad_1_A = mkA "tandad" ; -- tandad..av.1
  tandagnisslan_1_N = mkN "tandagnisslan" ; -- tandagnisslan..nn.1
  tandande_1_N = mkN "tandande" ; -- tandande..nn.1
  tandben_1_N = mkN "tandben" neutrum  ; -- tandben..nn.1
  tandblekning_1_N = mkN "tandblekning" ; -- tandblekning..nn.1
  tandborr_1_N = mkN "tandborr" ; -- tandborr..nn.1
  tandborrmaskin_1_N = mkN "tandborrmaskin" "tandborrmaskiner" ; -- tandborrmaskin..nn.1
  tandborste_1_N = mkN "tandborste" utrum  ; -- tandborste..nn.1
  tandborstglas_1_N = mkN "tandborstglas" neutrum  ; -- tandborstglas..nn.1
  tandborstmugg_1_N = mkN "tandborstmugg" ; -- tandborstmugg..nn.1
  tandborstning_1_N = mkN "tandborstning" ; -- tandborstning..nn.1
  tandbrygga_1_N = mkN "tandbrygga" ; -- tandbrygga..nn.1
  tandböld_1_N = mkN "tandböld" "tandbölder" ; -- tandböld..nn.1
  tandem_1_N = mkN "tandem" neutrum  ; -- tandem..nn.1
  tandemcykel_1_N = mkN "tandemcykel" ; -- tandemcykel..nn.1
  tandemmaskin_1_N = mkN "tandemmaskin" "tandemmaskiner" ; -- tandemmaskin..nn.1
  tandemridning_1_N = mkN "tandemridning" ; -- tandemridning..nn.1
  tandemspermie_1_N = mkN "tandemspermie" "tandemspermier" ; -- tandemspermie..nn.1
  tandfistel_1_N = mkN "tandfistel" ; -- tandfistel..nn.1
  tandformel_1_N = mkN "tandformel" "tandformeln" "tandformler" "tandformlerna" ; -- tandformel..nn.1
  tandfyllning_1_N = mkN "tandfyllning" ; -- tandfyllning..nn.1
  tandfällning_1_N = mkN "tandfällning" ; -- tandfällning..nn.1
  tandgarnityr_1_N = mkN "tandgarnityr" neutrum  ; -- tandgarnityr..nn.1
  tandgenombrott_1_N = mkN "tandgenombrott" neutrum  ; -- tandgenombrott..nn.1
  tandgnisslande_1_N = mkN "tandgnisslande" ; -- tandgnisslande..nn.1
  tandguld_1_N = mkN "tandguld" neutrum  ; -- tandguld..nn.1
  tandgård_1_N = mkN "tandgård" ; -- tandgård..nn.1
  tandhals_1_N = mkN "tandhals" ; -- tandhals..nn.1
  tandhjul_1_N = mkN "tandhjul" neutrum  ; -- tandhjul..nn.1
  tandhygienist_1_N = mkN "tandhygienist" "tandhygienister" ; -- tandhygienist..nn.1
  tandhyvel_1_N = mkN "tandhyvel" ; -- tandhyvel..nn.1
  tandhävel_1_N = mkN "tandhävel" ; -- tandhävel..nn.1
  tandhåla_1_N = mkN "tandhåla" ; -- tandhåla..nn.1
  tandimplantat_1_N = mkN "tandimplantat" neutrum  ; -- tandimplantat..nn.1
  tandkitt_1_N = mkN "tandkitt" neutrum  ; -- tandkitt..nn.1
  tandkonstruktion_1_N = mkN "tandkonstruktion" ; -- tandkonstruktion..nn.1
  tandkort_1_N = mkN "tandkort" neutrum  ; -- tandkort..nn.1
  tandkrona_1_N = mkN "tandkrona" ; -- tandkrona..nn.1
  tandkräm_1_N = mkN "tandkräm" "tandkrämer" ; -- tandkräm..nn.1
  tandkött_1_N = mkN "tandkött" neutrum  ; -- tandkött..nn.1
  tandlagning_1_N = mkN "tandlagning" ; -- tandlagning..nn.1
  tandlik_1_A = mkA "tandlik" ; -- tandlik..av.1
  tandlikhet_1_N = mkN "tandlikhet" ; -- tandlikhet..nn.1
  tandlist_1_N = mkN "tandlist" "tandlister" ; -- tandlist..nn.1
  tandlossning_1_N = mkN "tandlossning" ; -- tandlossning..nn.1
  tandläkarbesök_1_N = mkN "tandläkarbesök" neutrum  ; -- tandläkarbesök..nn.1
  tandläkare_1_N = mkN "tandläkare" utrum  ; -- tandläkare..nn.1
  tandläkarpraktik_1_N = mkN "tandläkarpraktik" "tandläkarpraktiker" ; -- tandläkarpraktik..nn.1
  tandläkarskylt_1_N = mkN "tandläkarskylt" ; -- tandläkarskylt..nn.1
  tandläkarstol_1_N = mkN "tandläkarstol" ; -- tandläkarstol..nn.1
  tandläkartid_1_N = mkN "tandläkartid" "tandläkartider" ; -- tandläkartid..nn.1
  tandläkarundersökning_1_N = mkN "tandläkarundersökning" ; -- tandläkarundersökning..nn.1
  tandlös_1_A = mkA "tandlös" ; -- tandlös..av.1
  tandlöshet_1_N = mkN "tandlöshet" ; -- tandlöshet..nn.1
  tandlöshet_2_N = mkN "tandlöshet" "tandlösheter" ; -- tandlöshet..nn.2
  tandning_1_N = mkN "tandning" ; -- tandning..nn.1
  tandpasta_1_N = mkN "tandpasta" ; -- tandpasta..nn.1
  tandpetare_1_N = mkN "tandpetare" utrum  ; -- tandpetare..nn.1
  tandprotes_1_N = mkN "tandprotes" "tandproteser" ; -- tandprotes..nn.1
  tandpulpa_1_N = mkN "tandpulpa" ; -- tandpulpa..nn.1
  tandrad_1_N = mkN "tandrad" "tandrader" ; -- tandrad..nn.1
  tandreglering_1_N = mkN "tandreglering" ; -- tandreglering..nn.1
  tandrot_1_N = mkN "tandrot" "tandrötter" ; -- tandrot..nn.1
  tandröta_1_N = mkN "tandröta" ; -- tandröta..nn.1
  tandskydd_1_N = mkN "tandskydd" neutrum  ; -- tandskydd..nn.1
  tandsköterska_1_N = mkN "tandsköterska" ; -- tandsköterska..nn.1
  tandsnitt_1_N = mkN "tandsnitt" neutrum  ; -- tandsnitt..nn.1
  tandsprickning_1_N = mkN "tandsprickning" ; -- tandsprickning..nn.1
  tandstatus_1_N = mkN "tandstatus" ; -- tandstatus..nn.1
  tandsticka_1_N = mkN "tandsticka" ; -- tandsticka..nn.1
  tandställning_1_N = mkN "tandställning" ; -- tandställning..nn.1
  tandtekniker_1_N = mkN "tandtekniker" "tandteknikern" "tandtekniker" "tandteknikerna" ; -- tandtekniker..nn.1
  tandtråd_1_N = mkN "tandtråd" ; -- tandtråd..nn.1
  tandtråda_1_V = mkV "tandtrådar" ; -- tandtråda..vb.1
  tandtrådande_1_N = mkN "tandtrådande" ; -- tandtrådande..nn.1
  tandtrådning_1_N = mkN "tandtrådning" ; -- tandtrådning..nn.1
  tanduppsättning_1_N = mkN "tanduppsättning" ; -- tanduppsättning..nn.1
  tandutdragning_1_N = mkN "tandutdragning" ; -- tandutdragning..nn.1
  tandutskott_1_N = mkN "tandutskott" neutrum  ; -- tandutskott..nn.1
  tandval_1_N = mkN "tandval" ; -- tandval..nn.1
  tandvall_1_N = mkN "tandvall" ; -- tandvall..nn.1
  tandvänlig_1_A = mkA "tandvänlig" ; -- tandvänlig..av.1
  tandvänlighet_1_N = mkN "tandvänlighet" ; -- tandvänlighet..nn.1
  tandvärk_1_N = mkN "tandvärk" ; -- tandvärk..nn.1
  tandvård_1_N = mkN "tandvård" ; -- tandvård..nn.1
  tandvårdsbidrag_1_N = mkN "tandvårdsbidrag" neutrum  ; -- tandvårdsbidrag..nn.1
  tandvårdsförsäkring_1_N = mkN "tandvårdsförsäkring" ; -- tandvårdsförsäkring..nn.1
  tandvårdsstöd_1_N = mkN "tandvårdsstöd" neutrum  ; -- tandvårdsstöd..nn.1
  tandyta_1_N = mkN "tandyta" ; -- tandyta..nn.1
  tandömsning_1_N = mkN "tandömsning" ; -- tandömsning..nn.1
  tangakalsong_1_N = mkN "tangakalsong" "tangakalsonger" ; -- tangakalsong..nn.1
  tangens_1_N = mkN "tangens" ; -- tangens..nn.1
  tangent_1_N = mkN "tangent" "tangenter" ; -- tangent..nn.1
  tangentbord_1_N = mkN "tangentbord" neutrum  ; -- tangentbord..nn.1
  tangenten_1_N = mkN "tangenten" ; -- tangenten..nn.1
  tangentinstrument_1_N = mkN "tangentinstrument" neutrum  ; -- tangentinstrument..nn.1
  tangentplan_1_N = mkN "tangentplan" neutrum  ; -- tangentplan..nn.1
  tangera_1_V = mkV "tangerar" ; -- tangera..vb.1
  tangerande_1_N = mkN "tangerande" ; -- tangerande..nn.1
  tangerbar_1_A = mkA "tangerbar" ; -- tangerbar..av.1
  tangerbarhet_1_N = mkN "tangerbarhet" ; -- tangerbarhet..nn.1
  tangerin_1_N = mkN "tangerin" "tangeriner" ; -- tangerin..nn.1
  tangering_1_N = mkN "tangering" ; -- tangering..nn.1
  tangeringspunkt_1_N = mkN "tangeringspunkt" "tangeringspunkter" ; -- tangeringspunkt..nn.1
  tango_1_N = mkN "tango" "tangon" "tangosar" "tangosarna" ; -- tango..nn.1
  tangodansare_1_N = mkN "tangodansare" utrum  ; -- tangodansare..nn.1
  tangokavaljer_1_N = mkN "tangokavaljer" "tangokavaljerer" ; -- tangokavaljer..nn.1
  tangorabatt_1_N = mkN "tangorabatt" "tangorabatter" ; -- tangorabatt..nn.1
  tanig_1_A = mkA "tanig" ; -- tanig..av.1
  tank_1_N = mkN "tank" ; -- tank..nn.1
  tank_2_N = mkN "tank" ; -- tank..nn.2
  tanka_1_V = mkV "tankar" ; -- tanka..vb.1
  tankande_1_N = mkN "tankande" ; -- tankande..nn.1
  tankbil_1_N = mkN "tankbil" ; -- tankbil..nn.1
  tanke_1_N = mkN "tanke" utrum  ; -- tanke..nn.1
  tankeakt_1_N = mkN "tankeakt" "tankeakter" ; -- tankeakt..nn.1
  tankearbete_1_N = mkN "tankearbete" ; -- tankearbete..nn.1
  tankebana_1_N = mkN "tankebana" ; -- tankebana..nn.1
  tankebollning_1_N = mkN "tankebollning" ; -- tankebollning..nn.1
  tankebyggnad_1_N = mkN "tankebyggnad" "tankebyggnader" ; -- tankebyggnad..nn.1
  tankediger_1_A = mkA "tankediger" ; -- tankediger..av.1
  tankedigerhet_1_N = mkN "tankedigerhet" ; -- tankedigerhet..nn.1
  tankedikt_1_N = mkN "tankedikt" "tankedikter" ; -- tankedikt..nn.1
  tankedjup_1_N = mkN "tankedjup" neutrum  ; -- tankedjup..nn.1
  tankeexperiment_1_N = mkN "tankeexperiment" neutrum  ; -- tankeexperiment..nn.1
  tankefattig_1_A = mkA "tankefattig" ; -- tankefattig..av.1
  tankefattigdom_1_N = mkN "tankefattigdom" ; -- tankefattigdom..nn.1
  tankefel_1_N = mkN "tankefel" "tankefelet" "tankefel" "tankefelen" ; -- tankefel..nn.1
  tankefigur_1_N = mkN "tankefigur" "tankefigurer" ; -- tankefigur..nn.1
  tankeflykt_1_N = mkN "tankeflykt" ; -- tankeflykt..nn.1
  tankeform_1_N = mkN "tankeform" "tankeformer" ; -- tankeform..nn.1
  tankefoster_1_N = mkN "tankefoster" neutrum  ; -- tankefoster..nn.1
  tankefrihet_1_N = mkN "tankefrihet" "tankefriheter" ; -- tankefrihet..nn.1
  tankefrö_1_N = mkN "tankefrö" "tankefröet" "tankefrön" "tankefröna" ; -- tankefrö..nn.1
  tankegods_1_N = mkN "tankegods" neutrum  ; -- tankegods..nn.1
  tankegång_1_N = mkN "tankegång" ; -- tankegång..nn.1
  tankeherravälde_1_N = mkN "tankeherravälde" ; -- tankeherravälde..nn.1
  tankeinnehåll_1_N = mkN "tankeinnehåll" neutrum  ; -- tankeinnehåll..nn.1
  tankekedja_1_N = mkN "tankekedja" ; -- tankekedja..nn.1
  tankekraft_1_N = mkN "tankekraft" "tankekrafter" ; -- tankekraft..nn.1
  tankelag_1_N = mkN "tankelag" ; -- tankelag..nn.1
  tankeled_1_N = mkN "tankeled" neutrum  ; -- tankeled..nn.1
  tankelek_1_N = mkN "tankelek" ; -- tankelek..nn.1
  tankeliv_1_N = mkN "tankeliv" neutrum  ; -- tankeliv..nn.1
  tankelyrik_1_N = mkN "tankelyrik" ; -- tankelyrik..nn.1
  tankeläsare_1_N = mkN "tankeläsare" utrum  ; -- tankeläsare..nn.1
  tankeläsning_1_N = mkN "tankeläsning" ; -- tankeläsning..nn.1
  tankemetod_1_N = mkN "tankemetod" "tankemetoder" ; -- tankemetod..nn.1
  tankemässig_1_A = mkA "tankemässig" ; -- tankemässig..av.1
  tankemässighet_1_N = mkN "tankemässighet" ; -- tankemässighet..nn.1
  tankemöda_1_N = mkN "tankemöda" ; -- tankemöda..nn.1
  tankemönster_1_N = mkN "tankemönster" neutrum  ; -- tankemönster..nn.1
  tankenöt_1_N = mkN "tankenöt" "tankenötter" ; -- tankenöt..nn.1
  tankeprocess_1_N = mkN "tankeprocess" "tankeprocesser" ; -- tankeprocess..nn.1
  tanker_1_N = mkN "tanker" ; -- tanker..nn.1
  tankereda_1_N = mkN "tankereda" ; -- tankereda..nn.1
  tankerik_1_A = mkA "tankerik" ; -- tankerik..av.1
  tankerikedom_1_N = mkN "tankerikedom" ; -- tankerikedom..nn.1
  tankeskärpa_1_N = mkN "tankeskärpa" ; -- tankeskärpa..nn.1
  tankesmedja_1_N = mkN "tankesmedja" ; -- tankesmedja..nn.1
  tankespår_1_N = mkN "tankespår" neutrum  ; -- tankespår..nn.1
  tankeställare_1_N = mkN "tankeställare" utrum  ; -- tankeställare..nn.1
  tankesystem_1_N = mkN "tankesystem" neutrum  ; -- tankesystem..nn.1
  tanketom_1_A = mkA "tanketom" "tanketomt" "tanketomma" "tanketomma" "tanketommare" "tanketommast" "tanketommaste" ; -- tanketom..av.1
  tanketomhet_1_N = mkN "tanketomhet" "tanketomheter" ; -- tanketomhet..nn.1
  tanketradition_1_N = mkN "tanketradition" ; -- tanketradition..nn.1
  tanketråd_1_N = mkN "tanketråd" ; -- tanketråd..nn.1
  tankeutbyte_1_N = mkN "tankeutbyte" ; -- tankeutbyte..nn.1
  tankeverksamhet_1_N = mkN "tankeverksamhet" ; -- tankeverksamhet..nn.1
  tankevilla_1_N = mkN "tankevilla" ; -- tankevilla..nn.1
  tankevurpa_1_N = mkN "tankevurpa" ; -- tankevurpa..nn.1
  tankeväckande_1_A = mkA "tankeväckande" ; -- tankeväckande..av.1
  tankevärld_1_N = mkN "tankevärld" ; -- tankevärld..nn.1
  tankeöverföring_1_N = mkN "tankeöverföring" ; -- tankeöverföring..nn.1
  tankeövning_1_N = mkN "tankeövning" ; -- tankeövning..nn.1
  tankfartyg_1_N = mkN "tankfartyg" neutrum  ; -- tankfartyg..nn.1
  tankfull_1_A = mkA "tankfull" ; -- tankfull..av.1
  tankfullhet_1_N = mkN "tankfullhet" ; -- tankfullhet..nn.1
  tankgevär_1_N = mkN "tankgevär" neutrum  ; -- tankgevär..nn.1
  tankkapacitet_1_N = mkN "tankkapacitet" "tankkapaciteter" ; -- tankkapacitet..nn.1
  tanklös_1_A = mkA "tanklös" ; -- tanklös..av.1
  tanklöshet_1_N = mkN "tanklöshet" "tanklösheter" ; -- tanklöshet..nn.1
  tankning_1_N = mkN "tankning" ; -- tankning..nn.1
  tankomat_1_N = mkN "tankomat" "tankomater" ; -- tankomat..nn.1
  tanks_1_N = mkN "tanks" ; -- tanks..nn.1
  tankspridd_1_A = mkA "tankspridd" ; -- tankspridd..av.1
  tankspriddhet_1_N = mkN "tankspriddhet" ; -- tankspriddhet..nn.1
  tankstreck_1_N = mkN "tankstreck" neutrum  ; -- tankstreck..nn.1
  tankställe_1_N = mkN "tankställe" ; -- tankställe..nn.1
  tankvagn_1_N = mkN "tankvagn" ; -- tankvagn..nn.1
  tankvolym_1_N = mkN "tankvolym" "tankvolymer" ; -- tankvolym..nn.1
  tannin_1_N = mkN "tannin" ; -- tannin..nn.1
  tant_1_N = mkN "tant" "tanter" ; -- tant..nn.1
  tantaktig_1_A = mkA "tantaktig" ; -- tantaktig..av.1
  tantaktighet_1_N = mkN "tantaktighet" ; -- tantaktighet..nn.1
  tantal_1_N = mkN "tantal" ; -- tantal..nn.1
  tantalikval_1_N = mkN "tantalikval" neutrum  ; -- tantalikval..nn.1
  tantalit_1_N = mkN "tantalit" ; -- tantalit..nn.1
  tantiem_1_N = mkN "tantiem" neutrum  ; -- tantiem..nn.1
  tantig_1_A = mkA "tantig" ; -- tantig..av.1
  tantighet_1_N = mkN "tantighet" ; -- tantighet..nn.1
  tantslem_1_N = mkN "tantslem" "tantslemmet" "tantslem" "tantslemmen" ; -- tantslem..nn.1
  tantsnusk_1_N = mkN "tantsnusk" neutrum  ; -- tantsnusk..nn.1
  tanzanier_1_N = mkN "tanzanier" "tanzaniern" "tanzanier" "tanzanierna" ; -- tanzanier..nn.1
  tanzanisk_1_A = mkA "tanzanisk" ; -- tanzanisk..av.1
  tanzaniska_1_N = mkN "tanzaniska" ; -- tanzaniska..nn.1
  taoism_1_N = mkN "taoism" "taoismer" ; -- taoism..nn.1
  taoist_1_N = mkN "taoist" "taoister" ; -- taoist..nn.1
  taoistisk_1_A = mkA "taoistisk" ; -- taoistisk..av.1
  tapas_1_N = mkN "tapas" ; -- tapas..nn.1
  tape_1_N = mkN "tape" utrum  ; -- tape..nn.1
  tapet_1_N = mkN "tapet" "tapeter" ; -- tapet..nn.1
  tapetborste_1_N = mkN "tapetborste" utrum  ; -- tapetborste..nn.1
  tapetbård_1_N = mkN "tapetbård" "tapetbårder" ; -- tapetbård..nn.1
  tapetdörr_1_N = mkN "tapetdörr" ; -- tapetdörr..nn.1
  tapetsera_1_V = mkV "tapetserar" ; -- tapetsera..vb.1
  tapetserande_1_N = mkN "tapetserande" ; -- tapetserande..nn.1
  tapetserare_1_N = mkN "tapetserare" utrum  ; -- tapetserare..nn.1
  tapetserarstift_1_N = mkN "tapetserarstift" neutrum  ; -- tapetserarstift..nn.1
  tapetserbar_1_A = mkA "tapetserbar" ; -- tapetserbar..av.1
  tapetserbarhet_1_N = mkN "tapetserbarhet" ; -- tapetserbarhet..nn.1
  tapetsering_1_N = mkN "tapetsering" ; -- tapetsering..nn.1
  tapetvåd_1_N = mkN "tapetvåd" "tapetvåder" ; -- tapetvåd..nn.1
  tapioka_1_N = mkN "tapioka" ; -- tapioka..nn.1
  tapir_1_N = mkN "tapir" "tapirer" ; -- tapir..nn.1
  tapisseri_1_N = mkN "tapisseri" "tapisseriet" "tapisserier" "tapisserierna" ; -- tapisseri..nn.1
  tapisseriaffär_1_N = mkN "tapisseriaffär" "tapisseriaffärer" ; -- tapisseriaffär..nn.1
  tapisserinål_1_N = mkN "tapisserinål" ; -- tapisserinål..nn.1
  tapp_1_N = mkN "tapp" ; -- tapp..nn.1
  tapp_2_N = mkN "tapp" neutrum  ; -- tapp..nn.2
  tappa_1_V = mkV "tappar" ; -- tappa..vb.1
  tappande_1_N = mkN "tappande" ; -- tappande..nn.1
  tappborr_1_N = mkN "tappborr" ; -- tappborr..nn.1
  tapper_1_A = mkA "tapper" ; -- tapper..av.1
  tapperhet_1_N = mkN "tapperhet" "tapperheter" ; -- tapperhet..nn.1
  tapperhetsmedalj_1_N = mkN "tapperhetsmedalj" "tapperhetsmedaljer" ; -- tapperhetsmedalj..nn.1
  tapphål_1_N = mkN "tapphål" neutrum  ; -- tapphål..nn.1
  tappkran_1_N = mkN "tappkran" ; -- tappkran..nn.1
  tapplager_1_N = mkN "tapplager" neutrum  ; -- tapplager..nn.1
  tappning_1_N = mkN "tappning" ; -- tappning..nn.1
  tappningsrör_1_N = mkN "tappningsrör" neutrum  ; -- tappningsrör..nn.1
  tappstation_1_N = mkN "tappstation" ; -- tappstation..nn.1
  tappt_1_N = mkN "tappt" "tappter" ; -- tappt..nn.1
  tapto_1_N = mkN "tapto" "taptot" "tapton" "taptona" ; -- tapto..nn.1
  tara_1_N = mkN "tara" ; -- tara..nn.1
  tarantel_1_N = mkN "tarantel" ; -- tarantel..nn.1
  tarantella_1_N = mkN "tarantella" ; -- tarantella..nn.1
  tarera_1_V = mkV "tarerar" ; -- tarera..vb.1
  tarerande_1_N = mkN "tarerande" ; -- tarerande..nn.1
  tarerbar_1_A = mkA "tarerbar" ; -- tarerbar..av.1
  tarerbarhet_1_N = mkN "tarerbarhet" ; -- tarerbarhet..nn.1
  tarering_1_N = mkN "tarering" ; -- tarering..nn.1
  targabåge_1_N = mkN "targabåge" utrum  ; -- targabåge..nn.1
  tariff_1_N = mkN "tariff" "tariffer" ; -- tariff..nn.1
  tariffera_1_V = mkV "tarifferar" ; -- tariffera..vb.1
  tarifferande_1_N = mkN "tarifferande" ; -- tarifferande..nn.1
  tarifferbar_1_A = mkA "tarifferbar" ; -- tarifferbar..av.1
  tarifferbarhet_1_N = mkN "tarifferbarhet" ; -- tarifferbarhet..nn.1
  tariffering_1_N = mkN "tariffering" ; -- tariffering..nn.1
  tarlatan_1_N = mkN "tarlatan" ; -- tarlatan..nn.1
  tarm_1_N = mkN "tarm" ; -- tarm..nn.1
  tarmbakterie_1_N = mkN "tarmbakterie" "tarmbakterier" ; -- tarmbakterie..nn.1
  tarmben_1_N = mkN "tarmben" neutrum  ; -- tarmben..nn.1
  tarmfistel_1_N = mkN "tarmfistel" ; -- tarmfistel..nn.1
  tarmflora_1_N = mkN "tarmflora" ; -- tarmflora..nn.1
  tarmförträngning_1_N = mkN "tarmförträngning" ; -- tarmförträngning..nn.1
  tarmgas_1_N = mkN "tarmgas" "tarmgaser" ; -- tarmgas..nn.1
  tarmkanal_1_N = mkN "tarmkanal" "tarmkanaler" ; -- tarmkanal..nn.1
  tarmkatarr_1_N = mkN "tarmkatarr" "tarmkatarrer" ; -- tarmkatarr..nn.1
  tarmkäx_1_N = mkN "tarmkäx" neutrum  ; -- tarmkäx..nn.1
  tarmludd_1_N = mkN "tarmludd" ; -- tarmludd..nn.1
  tarmrörelse_1_N = mkN "tarmrörelse" "tarmrörelser" ; -- tarmrörelse..nn.1
  tarmsaft_1_N = mkN "tarmsaft" "tarmsafter" ; -- tarmsaft..nn.1
  tarmsköljning_1_N = mkN "tarmsköljning" ; -- tarmsköljning..nn.1
  tarmsystem_1_N = mkN "tarmsystem" neutrum  ; -- tarmsystem..nn.1
  tarmvred_1_N = mkN "tarmvred" neutrum  ; -- tarmvred..nn.1
  taro_1_N = mkN "taro" ; -- taro..nn.1
  tarok_1_N = mkN "tarok" ; -- tarok..nn.1
  tars_1_N = mkN "tars" "tarser" ; -- tars..nn.1
  tarsalben_1_N = mkN "tarsalben" neutrum  ; -- tarsalben..nn.1
  tartan_1_N = mkN "tartan" ; -- tartan..nn.1
  tartar_1_N = mkN "tartar" ; -- tartar..nn.1
  tartar_2_N = mkN "tartar" "tartarer" ; -- tartar..nn.2
  tartarbiff_1_N = mkN "tartarbiff" ; -- tartarbiff..nn.1
  tartarisk_1_A = mkA "tartarisk" ; -- tartarisk..av.1
  tartariska_1_N = mkN "tartariska" ; -- tartariska..nn.1
  tartariska_2_N = mkN "tartariska" ; -- tartariska..nn.2
  tartarsmörgås_1_N = mkN "tartarsmörgås" ; -- tartarsmörgås..nn.1
  tartarsås_1_N = mkN "tartarsås" ; -- tartarsås..nn.1
  tartelett_1_N = mkN "tartelett" "tarteletter" ; -- tartelett..nn.1
  tartrat_1_N = mkN "tartrat" "tartrater" ; -- tartrat..nn.1
  tarv_1_N = mkN "tarv" neutrum  ; -- tarv..nn.1
  tarva_1_V = mkV "tarvar" ; -- tarva..vb.1
  tarvande_1_N = mkN "tarvande" ; -- tarvande..nn.1
  tarvlig_1_A = mkA "tarvlig" ; -- tarvlig..av.1
  tarvlighet_1_N = mkN "tarvlighet" "tarvligheter" ; -- tarvlighet..nn.1
  task_1_N = mkN "task" ; -- task..nn.1
  taska_1_N = mkN "taska" ; -- taska..nn.1
  taskig_1_A = mkA "taskig" ; -- taskig..av.1
  taskighet_1_N = mkN "taskighet" "taskigheter" ; -- taskighet..nn.1
  taskmört_1_N = mkN "taskmört" ; -- taskmört..nn.1
  taskspelare_1_N = mkN "taskspelare" utrum  ; -- taskspelare..nn.1
  taskspeleri_1_N = mkN "taskspeleri" "taskspeleriet" "taskspelerier" "taskspelerierna" ; -- taskspeleri..nn.1
  tass_1_N = mkN "tass" ; -- tass..nn.1
  tassa_1_V = mkV "tassar" ; -- tassa..vb.1
  tassande_1_N = mkN "tassande" ; -- tassande..nn.1
  tassel_1_N = mkN "tassel" neutrum  ; -- tassel..nn.1
  tassemark_1_N = mkN "tassemark" "tassemarker" ; -- tassemark..nn.1
  tassfot_1_N = mkN "tassfot" "tassfötter" ; -- tassfot..nn.1
  tassla_1_V = mkV "tasslar" ; -- tassla..vb.1
  tasslande_1_N = mkN "tasslande" ; -- tasslande..nn.1
  tassliknande_1_A = mkA "tassliknande" ; -- tassliknande..av.1
  tatar_1_N = mkN "tatar" "tatarer" ; -- tatar..nn.1
  tatarisk_1_A = mkA "tatarisk" ; -- tatarisk..av.1
  tatariska_1_N = mkN "tatariska" ; -- tatariska..nn.1
  tatariska_2_N = mkN "tatariska" ; -- tatariska..nn.2
  tattare_1_N = mkN "tattare" utrum  ; -- tattare..nn.1
  tatuera_1_V = mkV "tatuerar" ; -- tatuera..vb.1
  tatuerande_1_N = mkN "tatuerande" ; -- tatuerande..nn.1
  tatuerare_1_N = mkN "tatuerare" utrum  ; -- tatuerare..nn.1
  tatuerbar_1_A = mkA "tatuerbar" ; -- tatuerbar..av.1
  tatuerbarhet_1_N = mkN "tatuerbarhet" ; -- tatuerbarhet..nn.1
  tatuering_1_N = mkN "tatuering" ; -- tatuering..nn.1
  tau_1_N = mkN "tau" neutrum  ; -- tau..nn.1
  tauon_1_N = mkN "tauon" "tauoner" ; -- tauon..nn.1
  tauonneutrino_1_N = mkN "tauonneutrino" "tauonneutrinor" ; -- tauonneutrino..nn.1
  tautologi_1_N = mkN "tautologi" "tautologier" ; -- tautologi..nn.1
  tautologisk_1_A = mkA "tautologisk" ; -- tautologisk..av.1
  tautomeri_1_N = mkN "tautomeri" ; -- tautomeri..nn.1
  tavelgalleri_1_N = mkN "tavelgalleri" "tavelgalleriet" "tavelgallerier" "tavelgallerierna" ; -- tavelgalleri..nn.1
  tavelsudd_1_N = mkN "tavelsudd" ; -- tavelsudd..nn.1
  taverna_1_N = mkN "taverna" ; -- taverna..nn.1
  tavla_1_N = mkN "tavla" ; -- tavla..nn.1
  tax_free_1_A = mkA "tax-free" ; -- tax-free..av.1
  tax_free_1_N = mkN "tax-free" ; -- tax-free..nn.1
  tax_1_N = mkN "tax" ; -- tax..nn.1
  taxa_1_N = mkN "taxa" ; -- taxa..nn.1
  taxa_1_V = mkV "taxar" ; -- taxa..vb.1
  taxameter_1_N = mkN "taxameter" ; -- taxameter..nn.1
  taxande_1_N = mkN "taxande" ; -- taxande..nn.1
  taxeområde_1_N = mkN "taxeområde" ; -- taxeområde..nn.1
  taxera_1_V = mkV "taxerar" ; -- taxera..vb.1
  taxerande_1_N = mkN "taxerande" ; -- taxerande..nn.1
  taxerbar_1_A = mkA "taxerbar" ; -- taxerbar..av.1
  taxerbarhet_1_N = mkN "taxerbarhet" ; -- taxerbarhet..nn.1
  taxering_1_N = mkN "taxering" ; -- taxering..nn.1
  taxeringsassistent_1_N = mkN "taxeringsassistent" "taxeringsassistenter" ; -- taxeringsassistent..nn.1
  taxeringsbeslut_1_N = mkN "taxeringsbeslut" neutrum  ; -- taxeringsbeslut..nn.1
  taxeringsbevis_1_N = mkN "taxeringsbevis" neutrum  ; -- taxeringsbevis..nn.1
  taxeringsenhet_1_N = mkN "taxeringsenhet" "taxeringsenheter" ; -- taxeringsenhet..nn.1
  taxeringsintendent_1_N = mkN "taxeringsintendent" "taxeringsintendenter" ; -- taxeringsintendent..nn.1
  taxeringskalender_1_N = mkN "taxeringskalender" ; -- taxeringskalender..nn.1
  taxeringslängd_1_N = mkN "taxeringslängd" "taxeringslängder" ; -- taxeringslängd..nn.1
  taxeringsman_1_N = mkN "taxeringsman" "taxeringsmannen" "taxeringsmän" "taxeringsmännen" ; -- taxeringsman..nn.1
  taxeringsmyndighet_1_N = mkN "taxeringsmyndighet" "taxeringsmyndigheter" ; -- taxeringsmyndighet..nn.1
  taxeringsmässig_1_A = mkA "taxeringsmässig" ; -- taxeringsmässig..av.1
  taxeringsnämnd_1_N = mkN "taxeringsnämnd" "taxeringsnämnder" ; -- taxeringsnämnd..nn.1
  taxeringsvärde_1_N = mkN "taxeringsvärde" ; -- taxeringsvärde..nn.1
  taxeringsår_1_N = mkN "taxeringsår" neutrum  ; -- taxeringsår..nn.1
  taxi_1_N = mkN "taxi" "taxin" "taxi" "taxina" ; -- taxi..nn.1
  taxibil_1_N = mkN "taxibil" ; -- taxibil..nn.1
  taxibuss_1_N = mkN "taxibuss" ; -- taxibuss..nn.1
  taxichaufför_1_N = mkN "taxichaufför" "taxichaufförer" ; -- taxichaufför..nn.1
  taxifönster_1_N = mkN "taxifönster" neutrum  ; -- taxifönster..nn.1
  taxikund_1_N = mkN "taxikund" "taxikunder" ; -- taxikund..nn.1
  taxiresa_1_N = mkN "taxiresa" ; -- taxiresa..nn.1
  taxis_1_N = mkN "taxis" ; -- taxis..nn.1
  taxistation_1_N = mkN "taxistation" ; -- taxistation..nn.1
  taxonomi_1_N = mkN "taxonomi" "taxonomier" ; -- taxonomi..nn.1
  taxonomisk_1_A = mkA "taxonomisk" ; -- taxonomisk..av.1
  taxvalp_1_N = mkN "taxvalp" ; -- taxvalp..nn.1
  tazett_1_N = mkN "tazett" "tazetter" ; -- tazett..nn.1
  tchadier_1_N = mkN "tchadier" "tchadiern" "tchadier" "tchadierna" ; -- tchadier..nn.1
  tchadisk_1_A = mkA "tchadisk" ; -- tchadisk..av.1
  tchadiska_1_N = mkN "tchadiska" ; -- tchadiska..nn.1
  te_1_N = mkN "te" "teet" "teer" "teerna" ; -- te..nn.1
  te_2_N = mkN "te" "te" ; -- te..nn.2
  teach_in_1_N = mkN "teach-in" "teach-in" "teach-in" "teach-ina" ; -- teach-in..nn.1
  teak_1_N = mkN "teak" ; -- teak..nn.1
  teakträd_1_N = mkN "teakträd" neutrum  ; -- teakträd..nn.1
  team_1_N = mkN "team" neutrum  ; -- team..nn.1
  teamwork_1_N = mkN "teamwork" "teamworker" ; -- teamwork..nn.1
  teater_1_N = mkN "teater" ; -- teater..nn.1
  teateranmälan_1_N = mkN "teateranmälan" "teateranmälan" "teateranmälningar" "teateranmälningarna" ; -- teateranmälan..nn.1
  teaterapa_1_N = mkN "teaterapa" ; -- teaterapa..nn.1
  teaterbesök_1_N = mkN "teaterbesök" neutrum  ; -- teaterbesök..nn.1
  teaterbesökare_1_N = mkN "teaterbesökare" utrum  ; -- teaterbesökare..nn.1
  teaterbiljett_1_N = mkN "teaterbiljett" "teaterbiljetter" ; -- teaterbiljett..nn.1
  teaterbransch_1_N = mkN "teaterbransch" ; -- teaterbransch..nn.1
  teaterchef_1_N = mkN "teaterchef" "teaterchefer" ; -- teaterchef..nn.1
  teaterdebatt_1_N = mkN "teaterdebatt" "teaterdebatter" ; -- teaterdebatt..nn.1
  teaterdekoration_1_N = mkN "teaterdekoration" ; -- teaterdekoration..nn.1
  teaterdirektör_1_N = mkN "teaterdirektör" "teaterdirektörer" ; -- teaterdirektör..nn.1
  teaterdistrikt_1_N = mkN "teaterdistrikt" neutrum  ; -- teaterdistrikt..nn.1
  teatereffekt_1_N = mkN "teatereffekt" "teatereffekter" ; -- teatereffekt..nn.1
  teaterfigur_1_N = mkN "teaterfigur" "teaterfigurer" ; -- teaterfigur..nn.1
  teaterfoajé_1_N = mkN "teaterfoajé" "teaterfoajéer" ; -- teaterfoajé..nn.1
  teaterföreställning_1_N = mkN "teaterföreställning" ; -- teaterföreställning..nn.1
  teatergrupp_1_N = mkN "teatergrupp" "teatergrupper" ; -- teatergrupp..nn.1
  teaterhabitué_1_N = mkN "teaterhabitué" "teaterhabituéer" ; -- teaterhabitué..nn.1
  teaterhjälte_1_N = mkN "teaterhjälte" utrum  ; -- teaterhjälte..nn.1
  teaterintresserad_1_A = mkA "teaterintresserad" ; -- teaterintresserad..av.1
  teaterkikare_1_N = mkN "teaterkikare" utrum  ; -- teaterkikare..nn.1
  teaterkonst_1_N = mkN "teaterkonst" ; -- teaterkonst..nn.1
  teaterkritik_1_N = mkN "teaterkritik" ; -- teaterkritik..nn.1
  teaterliv_1_N = mkN "teaterliv" neutrum  ; -- teaterliv..nn.1
  teaterloge_1_N = mkN "teaterloge" "teaterloger" ; -- teaterloge..nn.1
  teatermaskineri_1_N = mkN "teatermaskineri" "teatermaskineriet" "teatermaskinerier" "teatermaskinerierna" ; -- teatermaskineri..nn.1
  teatermaskinist_1_N = mkN "teatermaskinist" "teatermaskinister" ; -- teatermaskinist..nn.1
  teatermässig_1_A = mkA "teatermässig" ; -- teatermässig..av.1
  teaterpjäs_1_N = mkN "teaterpjäs" "teaterpjäser" ; -- teaterpjäs..nn.1
  teaterpublik_1_N = mkN "teaterpublik" ; -- teaterpublik..nn.1
  teaterroll_1_N = mkN "teaterroll" "teaterroller" ; -- teaterroll..nn.1
  teaterscen_1_N = mkN "teaterscen" "teaterscener" ; -- teaterscen..nn.1
  teaterstycke_1_N = mkN "teaterstycke" ; -- teaterstycke..nn.1
  teatersällskap_1_N = mkN "teatersällskap" neutrum  ; -- teatersällskap..nn.1
  teatervana_1_N = mkN "teatervana" ; -- teatervana..nn.1
  teaterviskning_1_N = mkN "teaterviskning" ; -- teaterviskning..nn.1
  teatral_1_A = mkA "teatral" ; -- teatral..av.1
  teatralisk_1_A = mkA "teatralisk" ; -- teatralisk..av.1
  teatralitet_1_N = mkN "teatralitet" "teatraliteter" ; -- teatralitet..nn.1
  tebjudning_1_N = mkN "tebjudning" ; -- tebjudning..nn.1
  teblad_1_N = mkN "teblad" neutrum  ; -- teblad..nn.1
  teblask_1_N = mkN "teblask" neutrum  ; -- teblask..nn.1
  teburk_1_N = mkN "teburk" ; -- teburk..nn.1
  tebuske_1_N = mkN "tebuske" utrum  ; -- tebuske..nn.1
  teceremoni_1_N = mkN "teceremoni" "teceremonier" ; -- teceremoni..nn.1
  techno_1_N = mkN "techno" ; -- techno..nn.1
  tecken_1_N = mkN "tecken" "tecknet" "tecken" "tecknen" ; -- tecken..nn.1
  teckenalfabet_1_N = mkN "teckenalfabet" neutrum  ; -- teckenalfabet..nn.1
  teckenförklaring_1_N = mkN "teckenförklaring" ; -- teckenförklaring..nn.1
  teckengivning_1_N = mkN "teckengivning" ; -- teckengivning..nn.1
  teckenruta_1_N = mkN "teckenruta" ; -- teckenruta..nn.1
  teckenskådare_1_N = mkN "teckenskådare" utrum  ; -- teckenskådare..nn.1
  teckenspråk_1_N = mkN "teckenspråk" neutrum  ; -- teckenspråk..nn.1
  teckensystem_1_N = mkN "teckensystem" neutrum  ; -- teckensystem..nn.1
  teckentolkning_1_N = mkN "teckentolkning" ; -- teckentolkning..nn.1
  teckentydare_1_N = mkN "teckentydare" utrum  ; -- teckentydare..nn.1
  teckna_1_V = mkV "tecknar" ; -- teckna..vb.1
  tecknad_1_A = mkA "tecknad" ; -- tecknad..av.1
  tecknande_1_N = mkN "tecknande" ; -- tecknande..nn.1
  tecknare_1_N = mkN "tecknare" utrum  ; -- tecknare..nn.1
  teckning_1_N = mkN "teckning" ; -- teckning..nn.1
  teckningsbevis_1_N = mkN "teckningsbevis" neutrum  ; -- teckningsbevis..nn.1
  teckningslista_1_N = mkN "teckningslista" ; -- teckningslista..nn.1
  teckningsrätt_1_N = mkN "teckningsrätt" ; -- teckningsrätt..nn.1
  tedags_1_N = mkN "tedags" ; -- tedags..nn.1
  teddybjörn_1_N = mkN "teddybjörn" ; -- teddybjörn..nn.1
  tedeum_1_N = mkN "tedeum" neutrum  ; -- tedeum..nn.1
  tedrickande_1_N = mkN "tedrickande" ; -- tedrickande..nn.1
  tedrickning_1_N = mkN "tedrickning" ; -- tedrickning..nn.1
  tefat_1_N = mkN "tefat" neutrum  ; -- tefat..nn.1
  teflon_1_N = mkN "teflon" neutrum  ; -- teflon..nn.1
  teflonhjärna_1_N = mkN "teflonhjärna" ; -- teflonhjärna..nn.1
  tefra_1_N = mkN "tefra" ; -- tefra..nn.1
  tefralager_1_N = mkN "tefralager" neutrum  ; -- tefralager..nn.1
  tefrokronologi_1_N = mkN "tefrokronologi" ; -- tefrokronologi..nn.1
  teg_1_N = mkN "teg" ; -- teg..nn.1
  tegel_1_N = mkN "tegel" neutrum  ; -- tegel..nn.1
  tegelbruk_1_N = mkN "tegelbruk" neutrum  ; -- tegelbruk..nn.1
  tegelbruksarbetare_1_N = mkN "tegelbruksarbetare" utrum  ; -- tegelbruksarbetare..nn.1
  tegelbyggnad_1_N = mkN "tegelbyggnad" "tegelbyggnader" ; -- tegelbyggnad..nn.1
  tegelfärg_1_N = mkN "tegelfärg" ; -- tegelfärg..nn.1
  tegelfärgad_1_A = mkA "tegelfärgad" ; -- tegelfärgad..av.1
  tegellera_1_N = mkN "tegellera" ; -- tegellera..nn.1
  tegelliknande_1_A = mkA "tegelliknande" ; -- tegelliknande..av.1
  tegelmur_1_N = mkN "tegelmur" ; -- tegelmur..nn.1
  tegelmurad_1_A = mkA "tegelmurad" ; -- tegelmurad..av.1
  tegelmästare_1_N = mkN "tegelmästare" utrum  ; -- tegelmästare..nn.1
  tegelpanna_1_N = mkN "tegelpanna" ; -- tegelpanna..nn.1
  tegelplatta_1_N = mkN "tegelplatta" ; -- tegelplatta..nn.1
  tegelröd_1_A = mkA "tegelröd" "tegelrött" ; -- tegelröd..av.1
  tegelsilhuett_1_N = mkN "tegelsilhuett" "tegelsilhuetter" ; -- tegelsilhuett..nn.1
  tegelskorsten_1_N = mkN "tegelskorsten" "tegelskorstenen" "tegelskorstenar" "tegelskorstenarna" ; -- tegelskorsten..nn.1
  tegelskärva_1_N = mkN "tegelskärva" ; -- tegelskärva..nn.1
  tegelslagare_1_N = mkN "tegelslagare" utrum  ; -- tegelslagare..nn.1
  tegelsten_1_N = mkN "tegelsten" "tegelstenen" "tegelstenar" "tegelstenarna" ; -- tegelsten..nn.1
  tegelstensroman_1_N = mkN "tegelstensroman" "tegelstensromaner" ; -- tegelstensroman..nn.1
  tegelugn_1_N = mkN "tegelugn" ; -- tegelugn..nn.1
  tegelvägg_1_N = mkN "tegelvägg" ; -- tegelvägg..nn.1
  tegfåra_1_N = mkN "tegfåra" ; -- tegfåra..nn.1
  teglas_1_N = mkN "teglas" neutrum  ; -- teglas..nn.1
  tegplöjning_1_N = mkN "tegplöjning" ; -- tegplöjning..nn.1
  tegskifte_1_N = mkN "tegskifte" ; -- tegskifte..nn.1
  tehus_1_N = mkN "tehus" neutrum  ; -- tehus..nn.1
  tehuv_1_N = mkN "tehuv" ; -- tehuv..nn.1
  tehuva_1_N = mkN "tehuva" ; -- tehuva..nn.1
  tein_1_N = mkN "tein" "teiner" ; -- tein..nn.1
  teint_1_N = mkN "teint" ; -- teint..nn.1
  teism_1_N = mkN "teism" "teismer" ; -- teism..nn.1
  teist_1_N = mkN "teist" "teister" ; -- teist..nn.1
  teistisk_1_A = mkA "teistisk" ; -- teistisk..av.1
  tejp_1_N = mkN "tejp" ; -- tejp..nn.1
  tejpa_1_V = mkV "tejpar" ; -- tejpa..vb.1
  tejpande_1_N = mkN "tejpande" ; -- tejpande..nn.1
  tejprulle_1_N = mkN "tejprulle" utrum  ; -- tejprulle..nn.1
  tejst_1_N = mkN "tejst" ; -- tejst..nn.1
  teka_1_V = mkV "tekar" ; -- teka..vb.1
  tekaka_1_N = mkN "tekaka" ; -- tekaka..nn.1
  tekande_1_N = mkN "tekande" ; -- tekande..nn.1
  tekanna_1_N = mkN "tekanna" ; -- tekanna..nn.1
  teknetium_1_N = mkN "teknetium" neutrum  ; -- teknetium..nn.1
  teknifiera_1_V = mkV "teknifierar" ; -- teknifiera..vb.1
  teknifierande_1_N = mkN "teknifierande" ; -- teknifierande..nn.1
  teknifierbar_1_A = mkA "teknifierbar" ; -- teknifierbar..av.1
  teknifierbarhet_1_N = mkN "teknifierbarhet" ; -- teknifierbarhet..nn.1
  teknifiering_1_N = mkN "teknifiering" ; -- teknifiering..nn.1
  teknik_1_N = mkN "teknik" "tekniker" ; -- teknik..nn.1
  teknikalitet_1_N = mkN "teknikalitet" "teknikaliteter" ; -- teknikalitet..nn.1
  teknikanpassad_1_A = mkA "teknikanpassad" ; -- teknikanpassad..av.1
  teknikbransch_1_N = mkN "teknikbransch" "teknikbranscher" ; -- teknikbransch..nn.1
  tekniker_1_N = mkN "tekniker" "teknikern" "tekniker" "teknikerna" ; -- tekniker..nn.1
  teknikjournalist_1_N = mkN "teknikjournalist" "teknikjournalister" ; -- teknikjournalist..nn.1
  teknikkunnande_1_N = mkN "teknikkunnande" ; -- teknikkunnande..nn.1
  teknikrådgivare_1_N = mkN "teknikrådgivare" utrum  ; -- teknikrådgivare..nn.1
  teknikutveckling_1_N = mkN "teknikutveckling" ; -- teknikutveckling..nn.1
  tekniköverföring_1_N = mkN "tekniköverföring" ; -- tekniköverföring..nn.1
  tekning_1_N = mkN "tekning" ; -- tekning..nn.1
  teknisk_1_A = mkA "teknisk" ; -- teknisk..av.1
  teknisk_2_A = mkA "teknisk" ; -- teknisk..av.2
  teknokrat_1_N = mkN "teknokrat" "teknokrater" ; -- teknokrat..nn.1
  teknokrati_1_N = mkN "teknokrati" "teknokratier" ; -- teknokrati..nn.1
  teknokratisk_1_A = mkA "teknokratisk" ; -- teknokratisk..av.1
  teknolog_1_N = mkN "teknolog" "teknologer" ; -- teknolog..nn.1
  teknologi_1_N = mkN "teknologi" "teknologier" ; -- teknologi..nn.1
  teknologie_1_A = mkA "teknologie" ; -- teknologie..av.1
  teknologisk_1_A = mkA "teknologisk" ; -- teknologisk..av.1
  tekoindustri_1_N = mkN "tekoindustri" "tekoindustrier" ; -- tekoindustri..nn.1
  tekokare_1_N = mkN "tekokare" utrum  ; -- tekokare..nn.1
  tekopp_1_N = mkN "tekopp" ; -- tekopp..nn.1
  tektonik_1_N = mkN "tektonik" ; -- tektonik..nn.1
  tektonisk_1_A = mkA "tektonisk" ; -- tektonisk..av.1
  teleavgift_1_N = mkN "teleavgift" "teleavgifter" ; -- teleavgift..nn.1
  teledata_1_N = mkN "teledata" "teledatat" "teledata" "teledatana" ; -- teledata..nn.1
  telefaksimil_1_N = mkN "telefaksimil" neutrum  ; -- telefaksimil..nn.1
  telefax_1_N = mkN "telefax" neutrum  ; -- telefax..nn.1
  telefon_1_N = mkN "telefon" "telefoner" ; -- telefon..nn.1
  telefonabonnent_1_N = mkN "telefonabonnent" "telefonabonnenter" ; -- telefonabonnent..nn.1
  telefonanrop_1_N = mkN "telefonanrop" neutrum  ; -- telefonanrop..nn.1
  telefonanslutning_1_N = mkN "telefonanslutning" ; -- telefonanslutning..nn.1
  telefonapparat_1_N = mkN "telefonapparat" "telefonapparater" ; -- telefonapparat..nn.1
  telefonautomat_1_N = mkN "telefonautomat" "telefonautomater" ; -- telefonautomat..nn.1
  telefonavlyssning_1_N = mkN "telefonavlyssning" ; -- telefonavlyssning..nn.1
  telefonbolag_1_N = mkN "telefonbolag" neutrum  ; -- telefonbolag..nn.1
  telefonera_1_V = mkV "telefonerar" ; -- telefonera..vb.1
  telefonerande_1_N = mkN "telefonerande" ; -- telefonerande..nn.1
  telefonerbar_1_A = mkA "telefonerbar" ; -- telefonerbar..av.1
  telefonerbarhet_1_N = mkN "telefonerbarhet" ; -- telefonerbarhet..nn.1
  telefonering_1_N = mkN "telefonering" ; -- telefonering..nn.1
  telefonfröken_1_N = mkN "telefonfröken" ; -- telefonfröken..nn.1
  telefonförbindelse_1_N = mkN "telefonförbindelse" "telefonförbindelser" ; -- telefonförbindelse..nn.1
  telefonförsäljare_1_N = mkN "telefonförsäljare" utrum  ; -- telefonförsäljare..nn.1
  telefonhytt_1_N = mkN "telefonhytt" "telefonhytter" ; -- telefonhytt..nn.1
  telefoni_1_N = mkN "telefoni" ; -- telefoni..nn.1
  telefonist_1_N = mkN "telefonist" "telefonister" ; -- telefonist..nn.1
  telefonjack_1_N = mkN "telefonjack" ; -- telefonjack..nn.1
  telefonjour_1_N = mkN "telefonjour" ; -- telefonjour..nn.1
  telefonkatalog_1_N = mkN "telefonkatalog" "telefonkataloger" ; -- telefonkatalog..nn.1
  telefonkiosk_1_N = mkN "telefonkiosk" "telefonkiosker" ; -- telefonkiosk..nn.1
  telefonkonferens_1_N = mkN "telefonkonferens" "telefonkonferenser" ; -- telefonkonferens..nn.1
  telefonkontakt_1_N = mkN "telefonkontakt" "telefonkontakter" ; -- telefonkontakt..nn.1
  telefonkort_1_N = mkN "telefonkort" neutrum  ; -- telefonkort..nn.1
  telefonkö_1_N = mkN "telefonkö" "telefonkön" "telefonköer" "telefonköerna" ; -- telefonkö..nn.1
  telefonledes_1_Adv = mkAdv "telefonledes" ; -- telefonledes..ab.1
  telefonledning_1_N = mkN "telefonledning" ; -- telefonledning..nn.1
  telefonlinje_1_N = mkN "telefonlinje" "telefonlinjer" ; -- telefonlinje..nn.1
  telefonlur_1_N = mkN "telefonlur" ; -- telefonlur..nn.1
  telefonnummer_1_N = mkN "telefonnummer" neutrum  ; -- telefonnummer..nn.1
  telefonnät_1_N = mkN "telefonnät" neutrum  ; -- telefonnät..nn.1
  telefonoperatör_1_N = mkN "telefonoperatör" "telefonoperatörer" ; -- telefonoperatör..nn.1
  telefonpåringning_1_N = mkN "telefonpåringning" ; -- telefonpåringning..nn.1
  telefonsamtal_1_N = mkN "telefonsamtal" neutrum  ; -- telefonsamtal..nn.1
  telefonsignal_1_N = mkN "telefonsignal" "telefonsignaler" ; -- telefonsignal..nn.1
  telefonsladd_1_N = mkN "telefonsladd" ; -- telefonsladd..nn.1
  telefonsluss_1_N = mkN "telefonsluss" ; -- telefonsluss..nn.1
  telefonstation_1_N = mkN "telefonstation" ; -- telefonstation..nn.1
  telefonstolpe_1_N = mkN "telefonstolpe" utrum  ; -- telefonstolpe..nn.1
  telefonsvar_1_N = mkN "telefonsvar" neutrum  ; -- telefonsvar..nn.1
  telefonsvarare_1_N = mkN "telefonsvarare" utrum  ; -- telefonsvarare..nn.1
  telefonsvararmeddelande_1_N = mkN "telefonsvararmeddelande" ; -- telefonsvararmeddelande..nn.1
  telefonsvararprogram_1_N = mkN "telefonsvararprogram" "telefonsvararprogrammet" "telefonsvararprogram" "telefonsvararprogrammen" ; -- telefonsvararprogram..nn.1
  telefontråd_1_N = mkN "telefontråd" ; -- telefontråd..nn.1
  telefonvakt_1_N = mkN "telefonvakt" "telefonvakter" ; -- telefonvakt..nn.1
  telefonväckning_1_N = mkN "telefonväckning" ; -- telefonväckning..nn.1
  telefonväktare_1_N = mkN "telefonväktare" utrum  ; -- telefonväktare..nn.1
  telefonväxel_1_N = mkN "telefonväxel" ; -- telefonväxel..nn.1
  telefonör_1_N = mkN "telefonör" "telefonörer" ; -- telefonör..nn.1
  telefoto_1_N = mkN "telefoto" "telefotot" "telefoton" "telefotona" ; -- telefoto..nn.1
  teleförbindelse_1_N = mkN "teleförbindelse" "teleförbindelser" ; -- teleförbindelse..nn.1
  telegraf_1_N = mkN "telegraf" "telegrafer" ; -- telegraf..nn.1
  telegrafera_1_V = mkV "telegraferar" ; -- telegrafera..vb.1
  telegraferande_1_N = mkN "telegraferande" ; -- telegraferande..nn.1
  telegraferbar_1_A = mkA "telegraferbar" ; -- telegraferbar..av.1
  telegraferbarhet_1_N = mkN "telegraferbarhet" ; -- telegraferbarhet..nn.1
  telegrafering_1_N = mkN "telegrafering" ; -- telegrafering..nn.1
  telegrafi_1_N = mkN "telegrafi" ; -- telegrafi..nn.1
  telegrafisk_1_A = mkA "telegrafisk" ; -- telegrafisk..av.1
  telegrafist_1_N = mkN "telegrafist" "telegrafister" ; -- telegrafist..nn.1
  telegrafnyckel_1_N = mkN "telegrafnyckel" ; -- telegrafnyckel..nn.1
  telegrafremsa_1_N = mkN "telegrafremsa" ; -- telegrafremsa..nn.1
  telegrafstation_1_N = mkN "telegrafstation" ; -- telegrafstation..nn.1
  telegrafutrustning_1_N = mkN "telegrafutrustning" ; -- telegrafutrustning..nn.1
  telegram_1_N = mkN "telegram" "telegrammet" "telegram" "telegrammen" ; -- telegram..nn.1
  telegramadress_1_N = mkN "telegramadress" "telegramadresser" ; -- telegramadress..nn.1
  telegrambud_1_N = mkN "telegrambud" neutrum  ; -- telegrambud..nn.1
  telegrambyrå_1_N = mkN "telegrambyrå" "telegrambyråer" ; -- telegrambyrå..nn.1
  telegramspråk_1_N = mkN "telegramspråk" neutrum  ; -- telegramspråk..nn.1
  telegramstil_1_N = mkN "telegramstil" ; -- telegramstil..nn.1
  telekinesi_1_N = mkN "telekinesi" ; -- telekinesi..nn.1
  telekommunikation_1_N = mkN "telekommunikation" ; -- telekommunikation..nn.1
  telematik_1_N = mkN "telematik" ; -- telematik..nn.1
  telemeter_1_N = mkN "telemeter" ; -- telemeter..nn.1
  telenät_1_N = mkN "telenät" neutrum  ; -- telenät..nn.1
  teleobjektiv_1_N = mkN "teleobjektiv" neutrum  ; -- teleobjektiv..nn.1
  teleologi_1_N = mkN "teleologi" ; -- teleologi..nn.1
  teleologisk_1_A = mkA "teleologisk" ; -- teleologisk..av.1
  telepati_1_N = mkN "telepati" "telepatier" ; -- telepati..nn.1
  telepatisk_1_A = mkA "telepatisk" ; -- telepatisk..av.1
  teleprinter_1_N = mkN "teleprinter" ; -- teleprinter..nn.1
  telesatellit_1_N = mkN "telesatellit" "telesatelliter" ; -- telesatellit..nn.1
  teleschack_1_N = mkN "teleschack" neutrum  ; -- teleschack..nn.1
  teleskop_1_N = mkN "teleskop" neutrum  ; -- teleskop..nn.1
  teleskopfunktion_1_N = mkN "teleskopfunktion" ; -- teleskopfunktion..nn.1
  teleskopi_1_N = mkN "teleskopi" ; -- teleskopi..nn.1
  teleskopisk_1_A = mkA "teleskopisk" ; -- teleskopisk..av.1
  teleskopliknande_1_A = mkA "teleskopliknande" ; -- teleskopliknande..av.1
  teleskopord_1_N = mkN "teleskopord" neutrum  ; -- teleskopord..nn.1
  teleskoprör_1_N = mkN "teleskoprör" neutrum  ; -- teleskoprör..nn.1
  teleskopspegel_1_N = mkN "teleskopspegel" ; -- teleskopspegel..nn.1
  teleskopöga_1_N = mkN "teleskopöga" "teleskopögat" "teleskopögon" "teleskopögonen" ; -- teleskopöga..nn.1
  telestation_1_N = mkN "telestation" ; -- telestation..nn.1
  teleteknisk_1_A = mkA "teleteknisk" ; -- teleteknisk..av.1
  teletex_1_N = mkN "teletex" ; -- teletex..nn.1
  televerk_1_N = mkN "televerk" neutrum  ; -- televerk..nn.1
  televisera_1_V = mkV "televiserar" ; -- televisera..vb.1
  televiserande_1_N = mkN "televiserande" ; -- televiserande..nn.1
  televiserbar_1_A = mkA "televiserbar" ; -- televiserbar..av.1
  televiserbarhet_1_N = mkN "televiserbarhet" ; -- televiserbarhet..nn.1
  televisering_1_N = mkN "televisering" ; -- televisering..nn.1
  television_1_N = mkN "television" ; -- television..nn.1
  televisionskamera_1_N = mkN "televisionskamera" ; -- televisionskamera..nn.1
  telex_1_N = mkN "telex" ; -- telex..nn.1
  telex_2_N = mkN "telex" neutrum  ; -- telex..nn.2
  telfer_1_N = mkN "telfer" ; -- telfer..nn.1
  telialand_1_N = mkN "telialand" neutrum  ; -- telialand..nn.1
  tellur_1_N = mkN "tellur" ; -- tellur..nn.1
  tellurisk_1_A = mkA "tellurisk" ; -- tellurisk..av.1
  tellurium_1_N = mkN "tellurium" "telluriet" "tellurier" "tellurierna" ; -- tellurium..nn.1
  teln_1_N = mkN "teln" ; -- teln..nn.1
  telning_1_N = mkN "telning" ; -- telning..nn.1
  tema_1_N = mkN "tema" "temat" "temata" "tematana" ; -- tema..nn.1
  temadag_1_N = mkN "temadag" ; -- temadag..nn.1
  temanummer_1_N = mkN "temanummer" neutrum  ; -- temanummer..nn.1
  tematik_1_N = mkN "tematik" ; -- tematik..nn.1
  tematisk_1_A = mkA "tematisk" ; -- tematisk..av.1
  temp_1_N = mkN "temp" ; -- temp..nn.1
  tempa_1_V = mkV "tempar" ; -- tempa..vb.1
  tempande_1_N = mkN "tempande" ; -- tempande..nn.1
  tempel_1_N = mkN "tempel" neutrum  ; -- tempel..nn.1
  tempelgård_1_N = mkN "tempelgård" ; -- tempelgård..nn.1
  tempelherre_1_N = mkN "tempelherre" utrum  ; -- tempelherre..nn.1
  tempelherreorden_1_N = mkN "tempelherreorden" ; -- tempelherreorden..nn.1
  tempelriddare_1_N = mkN "tempelriddare" utrum  ; -- tempelriddare..nn.1
  tempelskändare_1_N = mkN "tempelskändare" utrum  ; -- tempelskändare..nn.1
  tempeltorn_1_N = mkN "tempeltorn" neutrum  ; -- tempeltorn..nn.1
  tempera_1_N = mkN "tempera" ; -- tempera..nn.1
  tempera_1_V = mkV "temperar" ; -- tempera..vb.1
  temperafärg_1_N = mkN "temperafärg" "temperafärger" ; -- temperafärg..nn.1
  temperament_1_N = mkN "temperament" neutrum  ; -- temperament..nn.1
  temperamentfull_1_A = mkA "temperamentfull" ; -- temperamentfull..av.1
  temperamentsfri_1_A = mkA "temperamentsfri" "temperamentsfritt" ; -- temperamentsfri..av.1
  temperamentsfull_1_A = mkA "temperamentsfull" ; -- temperamentsfull..av.1
  temperamentsfullhet_1_N = mkN "temperamentsfullhet" ; -- temperamentsfullhet..nn.1
  temperamentsmänniska_1_N = mkN "temperamentsmänniska" ; -- temperamentsmänniska..nn.1
  temperamentsutbrott_1_N = mkN "temperamentsutbrott" neutrum  ; -- temperamentsutbrott..nn.1
  temperamålning_1_N = mkN "temperamålning" ; -- temperamålning..nn.1
  temperamålning_2_N = mkN "temperamålning" ; -- temperamålning..nn.2
  temperande_1_N = mkN "temperande" ; -- temperande..nn.1
  temperatur_1_N = mkN "temperatur" "temperaturer" ; -- temperatur..nn.1
  temperaturbeständig_1_A = mkA "temperaturbeständig" ; -- temperaturbeständig..av.1
  temperaturbeständighet_1_N = mkN "temperaturbeständighet" ; -- temperaturbeständighet..nn.1
  temperaturfördelning_1_N = mkN "temperaturfördelning" ; -- temperaturfördelning..nn.1
  temperaturförhållande_1_N = mkN "temperaturförhållande" ; -- temperaturförhållande..nn.1
  temperaturförändring_1_N = mkN "temperaturförändring" ; -- temperaturförändring..nn.1
  temperaturgivare_1_N = mkN "temperaturgivare" utrum  ; -- temperaturgivare..nn.1
  temperaturhöjning_1_N = mkN "temperaturhöjning" ; -- temperaturhöjning..nn.1
  temperaturkänslig_1_A = mkA "temperaturkänslig" ; -- temperaturkänslig..av.1
  temperaturkänslighet_1_N = mkN "temperaturkänslighet" ; -- temperaturkänslighet..nn.1
  temperaturområde_1_N = mkN "temperaturområde" ; -- temperaturområde..nn.1
  temperaturregulator_1_N = mkN "temperaturregulator" "temperaturregulatorer" ; -- temperaturregulator..nn.1
  temperaturskala_1_N = mkN "temperaturskala" ; -- temperaturskala..nn.1
  temperaturskillnad_1_N = mkN "temperaturskillnad" "temperaturskillnader" ; -- temperaturskillnad..nn.1
  temperaturspann_1_N = mkN "temperaturspann" neutrum  ; -- temperaturspann..nn.1
  temperaturstrålning_1_N = mkN "temperaturstrålning" ; -- temperaturstrålning..nn.1
  temperatursvängning_1_N = mkN "temperatursvängning" ; -- temperatursvängning..nn.1
  temperatursänkning_1_N = mkN "temperatursänkning" ; -- temperatursänkning..nn.1
  temperaturutveckling_1_N = mkN "temperaturutveckling" ; -- temperaturutveckling..nn.1
  temperaturväxling_1_N = mkN "temperaturväxling" ; -- temperaturväxling..nn.1
  temperbar_1_A = mkA "temperbar" ; -- temperbar..av.1
  temperbarhet_1_N = mkN "temperbarhet" ; -- temperbarhet..nn.1
  temperera_1_V = mkV "tempererar" ; -- temperera..vb.1
  tempererad_1_A = mkA "tempererad" ; -- tempererad..av.1
  tempererande_1_N = mkN "tempererande" ; -- tempererande..nn.1
  tempererbar_1_A = mkA "tempererbar" ; -- tempererbar..av.1
  tempererbarhet_1_N = mkN "tempererbarhet" ; -- tempererbarhet..nn.1
  temperering_1_N = mkN "temperering" ; -- temperering..nn.1
  temperering_2_N = mkN "temperering" ; -- temperering..nn.2
  tempering_1_N = mkN "tempering" ; -- tempering..nn.1
  tempo_1_N = mkN "tempo" "tempot" "tempi" "tempona" ; -- tempo..nn.1
  tempoarbetare_1_N = mkN "tempoarbetare" utrum  ; -- tempoarbetare..nn.1
  tempoarbete_1_N = mkN "tempoarbete" ; -- tempoarbete..nn.1
  tempobeteckning_1_N = mkN "tempobeteckning" ; -- tempobeteckning..nn.1
  tempolopp_1_N = mkN "tempolopp" neutrum  ; -- tempolopp..nn.1
  tempomässig_1_A = mkA "tempomässig" ; -- tempomässig..av.1
  temporal_1_A = mkA "temporal" ; -- temporal..av.1
  temporär_1_A = mkA "temporär" ; -- temporär..av.1
  tempus_1_N = mkN "tempus" neutrum  ; -- tempus..nn.1
  tempusväxling_1_N = mkN "tempusväxling" ; -- tempusväxling..nn.1
  ten_1_N = mkN "ten" "tenen" "tenar" "tenarna" ; -- ten..nn.1
  tendens_1_N = mkN "tendens" "tendenser" ; -- tendens..nn.1
  tendenslös_1_A = mkA "tendenslös" ; -- tendenslös..av.1
  tendentiös_1_A = mkA "tendentiös" ; -- tendentiös..av.1
  tender_1_N = mkN "tender" ; -- tender..nn.1
  tendera_1_V = mkV "tenderar" ; -- tendera..vb.1
  tenderande_1_N = mkN "tenderande" ; -- tenderande..nn.1
  tenn_1_N = mkN "tenn" neutrum  ; -- tenn..nn.1
  tennbricka_1_N = mkN "tennbricka" ; -- tennbricka..nn.1
  tennfolie_1_N = mkN "tennfolie" "tennfolier" ; -- tennfolie..nn.1
  tennis_1_N = mkN "tennis" ; -- tennis..nn.1
  tennisarm_1_N = mkN "tennisarm" ; -- tennisarm..nn.1
  tennisbana_1_N = mkN "tennisbana" ; -- tennisbana..nn.1
  tennisboll_1_N = mkN "tennisboll" ; -- tennisboll..nn.1
  tennisframgång_1_N = mkN "tennisframgång" ; -- tennisframgång..nn.1
  tennisjournalist_1_N = mkN "tennisjournalist" "tennisjournalister" ; -- tennisjournalist..nn.1
  tennisläger_1_N = mkN "tennisläger" neutrum  ; -- tennisläger..nn.1
  tennisplan_1_N = mkN "tennisplan" "tennisplaner" ; -- tennisplan..nn.1
  tennisrack_1_N = mkN "tennisrack" ; -- tennisrack..nn.1
  tennisracket_1_N = mkN "tennisracket" ; -- tennisracket..nn.1
  tennissko_1_N = mkN "tennissko" "tennisskor" ; -- tennissko..nn.1
  tennisspelare_1_N = mkN "tennisspelare" utrum  ; -- tennisspelare..nn.1
  tennisvecka_1_N = mkN "tennisvecka" ; -- tennisvecka..nn.1
  tennlod_1_N = mkN "tennlod" neutrum  ; -- tennlod..nn.1
  tennpest_1_N = mkN "tennpest" ; -- tennpest..nn.1
  tennsoldat_1_N = mkN "tennsoldat" "tennsoldater" ; -- tennsoldat..nn.1
  tenor_1_N = mkN "tenor" "tenoren" "tenorer" "tenorerna" ; -- tenor..nn.1
  tenorbaryton_1_N = mkN "tenorbaryton" "tenorbarytoner" ; -- tenorbaryton..nn.1
  tenorsaxofon_1_N = mkN "tenorsaxofon" "tenorsaxofoner" ; -- tenorsaxofon..nn.1
  tenorstämma_1_N = mkN "tenorstämma" ; -- tenorstämma..nn.1
  tenorsångare_1_N = mkN "tenorsångare" utrum  ; -- tenorsångare..nn.1
  tensid_1_N = mkN "tensid" "tensider" ; -- tensid..nn.1
  tension_1_N = mkN "tension" ; -- tension..nn.1
  tenta_1_N = mkN "tenta" ; -- tenta..nn.1
  tenta_1_V = mkV "tentar" ; -- tenta..vb.1
  tentakel_1_N = mkN "tentakel" "tentakeln" "tentakler" "tentaklerna" ; -- tentakel..nn.1
  tentakelerotik_1_N = mkN "tentakelerotik" ; -- tentakelerotik..nn.1
  tentakelpornografi_1_N = mkN "tentakelpornografi" ; -- tentakelpornografi..nn.1
  tentakelporr_1_N = mkN "tentakelporr" ; -- tentakelporr..nn.1
  tentamen_1_N = mkN "tentamen" "tentamen" "tentamina" "tentamina" ; -- tentamen..nn.1
  tentamensbok_1_N = mkN "tentamensbok" "tentamensböcker" ; -- tentamensbok..nn.1
  tentamensläsa_1_V = mkV "tentamensläser" ; -- tentamensläsa..vb.1
  tentamensläsande_1_N = mkN "tentamensläsande" ; -- tentamensläsande..nn.1
  tentamensnervositet_1_N = mkN "tentamensnervositet" "tentamensnervositeter" ; -- tentamensnervositet..nn.1
  tentand_1_N = mkN "tentand" "tentander" ; -- tentand..nn.1
  tentande_1_N = mkN "tentande" ; -- tentande..nn.1
  tentativ_1_A = mkA "tentativ" ; -- tentativ..av.1
  tentator_1_N = mkN "tentator" "tentatorer" ; -- tentator..nn.1
  tentera_1_V = mkV "tenterar" ; -- tentera..vb.1
  tenterande_1_N = mkN "tenterande" ; -- tenterande..nn.1
  tenterbar_1_A = mkA "tenterbar" ; -- tenterbar..av.1
  tenterbarhet_1_N = mkN "tenterbarhet" ; -- tenterbarhet..nn.1
  tentering_1_N = mkN "tentering" ; -- tentering..nn.1
  teobromin_1_N = mkN "teobromin" "teobrominer" ; -- teobromin..nn.1
  teocentrisk_1_A = mkA "teocentrisk" ; -- teocentrisk..av.1
  teodicéproblem_1_N = mkN "teodicéproblem" neutrum  ; -- teodicéproblem..nn.1
  teodolit_1_N = mkN "teodolit" "teodoliter" ; -- teodolit..nn.1
  teofyllin_1_N = mkN "teofyllin" "teofylliner" ; -- teofyllin..nn.1
  teogoni_1_N = mkN "teogoni" "teogonier" ; -- teogoni..nn.1
  teokrati_1_N = mkN "teokrati" "teokratier" ; -- teokrati..nn.1
  teokratisk_1_A = mkA "teokratisk" ; -- teokratisk..av.1
  teolog_1_N = mkN "teolog" "teologer" ; -- teolog..nn.1
  teologi_1_N = mkN "teologi" ; -- teologi..nn.1
  teologie_1_A = mkA "teologie" ; -- teologie..av.1
  teologisk_1_A = mkA "teologisk" ; -- teologisk..av.1
  teorb_1_N = mkN "teorb" "teorber" ; -- teorb..nn.1
  teorem_1_N = mkN "teorem" neutrum  ; -- teorem..nn.1
  teoretiker_1_N = mkN "teoretiker" "teoretikern" "teoretiker" "teoretikerna" ; -- teoretiker..nn.1
  teoretisera_1_V = mkV "teoretiserar" ; -- teoretisera..vb.1
  teoretiserande_1_N = mkN "teoretiserande" ; -- teoretiserande..nn.1
  teoretisering_1_N = mkN "teoretisering" ; -- teoretisering..nn.1
  teoretisk_1_A = mkA "teoretisk" ; -- teoretisk..av.1
  teori_1_N = mkN "teori" "teorier" ; -- teori..nn.1
  teoribildning_1_N = mkN "teoribildning" ; -- teoribildning..nn.1
  teosof_1_N = mkN "teosof" "teosofer" ; -- teosof..nn.1
  teosofi_1_N = mkN "teosofi" ; -- teosofi..nn.1
  teosofisk_1_A = mkA "teosofisk" ; -- teosofisk..av.1
  tepåse_1_N = mkN "tepåse" utrum  ; -- tepåse..nn.1
  tequila_1_N = mkN "tequila" ; -- tequila..nn.1
  terabyte_1_N = mkN "terabyte" "terabyten" "terabyte" "terabytena" ; -- terabyte..nn.1
  teraelektronvolt_1_N = mkN "teraelektronvolt" "teraelektronvolten" "teraelektronvolt" "teraelektronvolten" ; -- teraelektronvolt..nn.1
  terapeut_1_N = mkN "terapeut" "terapeuter" ; -- terapeut..nn.1
  terapeutisk_1_A = mkA "terapeutisk" ; -- terapeutisk..av.1
  terapi_1_N = mkN "terapi" "terapier" ; -- terapi..nn.1
  terapisession_1_N = mkN "terapisession" ; -- terapisession..nn.1
  terapisoffa_1_N = mkN "terapisoffa" ; -- terapisoffa..nn.1
  terass_1_N = mkN "terass" "terasser" ; -- terass..nn.1
  terasstvätt_1_N = mkN "terasstvätt" ; -- terasstvätt..nn.1
  terawatt_1_N = mkN "terawatt" "terawatten" "terawatt" "terawatten" ; -- terawatt..nn.1
  terbium_1_N = mkN "terbium" neutrum  ; -- terbium..nn.1
  terebint_1_N = mkN "terebint" "terebinter" ; -- terebint..nn.1
  term_1_N = mkN "term" "termer" ; -- term..nn.1
  termik_1_N = mkN "termik" ; -- termik..nn.1
  termin_1_N = mkN "termin" "terminer" ; -- termin..nn.1
  terminal_1_A = mkA "terminal" ; -- terminal..av.1
  terminal_1_N = mkN "terminal" "terminaler" ; -- terminal..nn.1
  terminalrum_1_N = mkN "terminalrum" "terminalrummet" "terminalrum" "terminalrummen" ; -- terminalrum..nn.1
  terminalvård_1_N = mkN "terminalvård" ; -- terminalvård..nn.1
  terminlig_1_A = mkA "terminlig" ; -- terminlig..av.1
  terminolog_1_N = mkN "terminolog" "terminologer" ; -- terminolog..nn.1
  terminologi_1_N = mkN "terminologi" "terminologier" ; -- terminologi..nn.1
  terminologifråga_1_N = mkN "terminologifråga" ; -- terminologifråga..nn.1
  terminologisk_1_A = mkA "terminologisk" ; -- terminologisk..av.1
  terminsaffär_1_N = mkN "terminsaffär" "terminsaffärer" ; -- terminsaffär..nn.1
  terminsavgift_1_N = mkN "terminsavgift" "terminsavgifter" ; -- terminsavgift..nn.1
  terminsvis_1_Adv = mkAdv "terminsvis" ; -- terminsvis..ab.1
  terminsvis_1_A = mkA "terminsvis" ; -- terminsvis..av.1
  termisk_1_A = mkA "termisk" ; -- termisk..av.1
  termistor_1_N = mkN "termistor" "termistorer" ; -- termistor..nn.1
  termit_1_N = mkN "termit" "termiter" ; -- termit..nn.1
  termit_2_N = mkN "termit" ; -- termit..nn.2
  termitbeständig_1_A = mkA "termitbeständig" ; -- termitbeständig..av.1
  termobyxa_1_N = mkN "termobyxa" ; -- termobyxa..nn.1
  termodynamik_1_N = mkN "termodynamik" ; -- termodynamik..nn.1
  termodynamisk_1_A = mkA "termodynamisk" ; -- termodynamisk..av.1
  termoelektricitet_1_N = mkN "termoelektricitet" "termoelektriciteter" ; -- termoelektricitet..nn.1
  termoelement_1_N = mkN "termoelement" neutrum  ; -- termoelement..nn.1
  termofil_1_A = mkA "termofil" ; -- termofil..av.1
  termografi_1_N = mkN "termografi" ; -- termografi..nn.1
  termokappa_1_N = mkN "termokappa" ; -- termokappa..nn.1
  termokemi_1_N = mkN "termokemi" ; -- termokemi..nn.1
  termometer_1_N = mkN "termometer" ; -- termometer..nn.1
  termonukleär_1_A = mkA "termonukleär" ; -- termonukleär..av.1
  termoplast_1_N = mkN "termoplast" "termoplaster" ; -- termoplast..nn.1
  termoregulator_1_N = mkN "termoregulator" "termoregulatorer" ; -- termoregulator..nn.1
  termos_1_N = mkN "termos" ; -- termos..nn.1
  termostapel_1_N = mkN "termostapel" ; -- termostapel..nn.1
  termostat_1_N = mkN "termostat" "termostater" ; -- termostat..nn.1
  tern_1_N = mkN "tern" "terner" ; -- tern..nn.1
  teros_1_N = mkN "teros" "terosor" ; -- teros..nn.1
  terpen_1_N = mkN "terpen" "terpener" ; -- terpen..nn.1
  terpentin_1_N = mkN "terpentin" ; -- terpentin..nn.1
  terrakotta_1_N = mkN "terrakotta" ; -- terrakotta..nn.1
  terrakottasoldat_1_N = mkN "terrakottasoldat" "terrakottasoldater" ; -- terrakottasoldat..nn.1
  terrarium_1_N = mkN "terrarium" "terrariet" "terrarier" "terrarierna" ; -- terrarium..nn.1
  terrass_1_N = mkN "terrass" "terrasser" ; -- terrass..nn.1
  terrassera_1_V = mkV "terrasserar" ; -- terrassera..vb.1
  terrasserande_1_N = mkN "terrasserande" ; -- terrasserande..nn.1
  terrasserbar_1_A = mkA "terrasserbar" ; -- terrasserbar..av.1
  terrasserbarhet_1_N = mkN "terrasserbarhet" ; -- terrasserbarhet..nn.1
  terrassering_1_N = mkN "terrassering" ; -- terrassering..nn.1
  terrassformig_1_A = mkA "terrassformig" ; -- terrassformig..av.1
  terrassland_1_N = mkN "terrassland" neutrum  ; -- terrassland..nn.1
  terrassvärmare_1_N = mkN "terrassvärmare" utrum  ; -- terrassvärmare..nn.1
  terrester_1_A = mkA "terrester" ; -- terrester..av.1
  terrier_1_N = mkN "terrier" "terriern" "terrier" "terrierna" ; -- terrier..nn.1
  terrigen_1_A = mkA "terrigen" "terrigent" ; -- terrigen..av.1
  terrin_1_N = mkN "terrin" "terriner" ; -- terrin..nn.1
  territ_1_N = mkN "territ" ; -- territ..nn.1
  territorialgräns_1_N = mkN "territorialgräns" "territorialgränser" ; -- territorialgräns..nn.1
  territorialvatten_1_N = mkN "territorialvatten" "territorialvattnet" "territorialvatten" "territorialvattnen" ; -- territorialvatten..nn.1
  territoriell_1_A = mkA "territoriell" ; -- territoriell..av.1
  territorium_1_N = mkN "territorium" "territoriet" "territorier" "territorierna" ; -- territorium..nn.1
  terrorattack_1_N = mkN "terrorattack" "terrorattacker" ; -- terrorattack..nn.1
  terrorbalans_1_N = mkN "terrorbalans" ; -- terrorbalans..nn.1
  terrorberedskap_1_N = mkN "terrorberedskap" ; -- terrorberedskap..nn.1
  terrorbombning_1_N = mkN "terrorbombning" ; -- terrorbombning..nn.1
  terrordåd_1_N = mkN "terrordåd" neutrum  ; -- terrordåd..nn.1
  terrorhot_1_N = mkN "terrorhot" neutrum  ; -- terrorhot..nn.1
  terrorhotbedömning_1_N = mkN "terrorhotbedömning" ; -- terrorhotbedömning..nn.1
  terrorisera_1_V = mkV "terroriserar" ; -- terrorisera..vb.1
  terroriserande_1_N = mkN "terroriserande" ; -- terroriserande..nn.1
  terroriserbar_1_A = mkA "terroriserbar" ; -- terroriserbar..av.1
  terroriserbarhet_1_N = mkN "terroriserbarhet" ; -- terroriserbarhet..nn.1
  terrorisering_1_N = mkN "terrorisering" ; -- terrorisering..nn.1
  terrorism_1_N = mkN "terrorism" "terrorismer" ; -- terrorism..nn.1
  terrorist_1_N = mkN "terrorist" "terrorister" ; -- terrorist..nn.1
  terroristattack_1_N = mkN "terroristattack" "terroristattacker" ; -- terroristattack..nn.1
  terroristgrupp_1_N = mkN "terroristgrupp" "terroristgrupper" ; -- terroristgrupp..nn.1
  terroristisk_1_A = mkA "terroristisk" ; -- terroristisk..av.1
  terroristlagstiftning_1_N = mkN "terroristlagstiftning" ; -- terroristlagstiftning..nn.1
  terroristledare_1_N = mkN "terroristledare" utrum  ; -- terroristledare..nn.1
  terroristmisstänkt_1_A = mkA "terroristmisstänkt" "terroristmisstänkt" ; -- terroristmisstänkt..av.1
  terroristspårning_1_N = mkN "terroristspårning" ; -- terroristspårning..nn.1
  terrormisstänkt_1_A = mkA "terrormisstänkt" "terrormisstänkt" ; -- terrormisstänkt..av.1
  terrornätverk_1_N = mkN "terrornätverk" neutrum  ; -- terrornätverk..nn.1
  terrorplan_1_N = mkN "terrorplan" "terrorplaner" ; -- terrorplan..nn.1
  terrorvarning_1_N = mkN "terrorvarning" ; -- terrorvarning..nn.1
  terräng_1_N = mkN "terräng" "terränger" ; -- terräng..nn.1
  terrängbana_1_N = mkN "terrängbana" ; -- terrängbana..nn.1
  terrängbil_1_N = mkN "terrängbil" ; -- terrängbil..nn.1
  terrängförlust_1_N = mkN "terrängförlust" "terrängförluster" ; -- terrängförlust..nn.1
  terränggående_1_A = mkA "terränggående" ; -- terränggående..av.1
  terrängkörning_1_N = mkN "terrängkörning" ; -- terrängkörning..nn.1
  terränglöpning_1_N = mkN "terränglöpning" ; -- terränglöpning..nn.1
  terrängnamn_1_N = mkN "terrängnamn" neutrum  ; -- terrängnamn..nn.1
  terrängscooter_1_N = mkN "terrängscooter" ; -- terrängscooter..nn.1
  terrängskoter_1_N = mkN "terrängskoter" ; -- terrängskoter..nn.1
  terrängvinkel_1_N = mkN "terrängvinkel" ; -- terrängvinkel..nn.1
  terrängvinst_1_N = mkN "terrängvinst" "terrängvinster" ; -- terrängvinst..nn.1
  ters_1_N = mkN "ters" "terser" ; -- ters..nn.1
  tersett_1_N = mkN "tersett" "tersetter" ; -- tersett..nn.1
  tertiär_1_A = mkA "tertiär" ; -- tertiär..av.1
  tertiär_1_N = mkN "tertiär" ; -- tertiär..nn.1
  tertiärperiod_1_N = mkN "tertiärperiod" ; -- tertiärperiod..nn.1
  tertiärsystem_1_N = mkN "tertiärsystem" neutrum  ; -- tertiärsystem..nn.1
  tertiärtid_1_N = mkN "tertiärtid" ; -- tertiärtid..nn.1
  terylen_1_N = mkN "terylen" neutrum  ; -- terylen..nn.1
  terzett_1_N = mkN "terzett" "terzetter" ; -- terzett..nn.1
  terzin_1_N = mkN "terzin" "terziner" ; -- terzin..nn.1
  tes_1_N = mkN "tes" "teser" ; -- tes..nn.1
  tesalong_1_N = mkN "tesalong" "tesalonger" ; -- tesalong..nn.1
  tesaurera_1_V = mkV "tesaurerar" ; -- tesaurera..vb.1
  tesaurerande_1_N = mkN "tesaurerande" ; -- tesaurerande..nn.1
  tesaurerbar_1_A = mkA "tesaurerbar" ; -- tesaurerbar..av.1
  tesaurerbarhet_1_N = mkN "tesaurerbarhet" ; -- tesaurerbarhet..nn.1
  tesaurering_1_N = mkN "tesaurering" ; -- tesaurering..nn.1
  tesaurus_1_N = mkN "tesaurus" ; -- tesaurus..nn.1
  tesked_1_N = mkN "tesked" ; -- tesked..nn.1
  tesla_1_N = mkN "tesla" "teslan" "tesla" "teslana" ; -- tesla..nn.1
  teslaström_1_N = mkN "teslaström" "teslaströmmen" "teslaströmmar" "teslaströmmarna" ; -- teslaström..nn.1
  tespiskärra_1_N = mkN "tespiskärra" ; -- tespiskärra..nn.1
  tesserakt_1_N = mkN "tesserakt" "tesserakter" ; -- tesserakt..nn.1
  test_1_N = mkN "test" neutrum  ; -- test..nn.1
  test_2_N = mkN "test" ; -- test..nn.2
  testa_1_V = mkV "testar" ; -- testa..vb.1
  testabel_1_A = mkA "testabel" ; -- testabel..av.1
  testamentarisk_1_A = mkA "testamentarisk" ; -- testamentarisk..av.1
  testamente_1_N = mkN "testamente" ; -- testamente..nn.1
  testamentera_1_V = mkV "testamenterar" ; -- testamentera..vb.1
  testamenterande_1_N = mkN "testamenterande" ; -- testamenterande..nn.1
  testamenterbar_1_A = mkA "testamenterbar" ; -- testamenterbar..av.1
  testamenterbarhet_1_N = mkN "testamenterbarhet" ; -- testamenterbarhet..nn.1
  testamentering_1_N = mkN "testamentering" ; -- testamentering..nn.1
  testamentsexekutor_1_N = mkN "testamentsexekutor" "testamentsexekutorer" ; -- testamentsexekutor..nn.1
  testande_1_N = mkN "testande" ; -- testande..nn.1
  testator_1_N = mkN "testator" "testatorer" ; -- testator..nn.1
  testbatteri_1_N = mkN "testbatteri" "testbatteriet" "testbatterier" "testbatterierna" ; -- testbatteri..nn.1
  testbild_1_N = mkN "testbild" "testbilder" ; -- testbild..nn.1
  testcykel_1_N = mkN "testcykel" ; -- testcykel..nn.1
  testflyga_1_V = mkV "testflyga" "testflög" "testflugit" ; -- testflyga..vb.1
  testflygande_1_N = mkN "testflygande" ; -- testflygande..nn.1
  testflygning_1_N = mkN "testflygning" ; -- testflygning..nn.1
  testig_1_A = mkA "testig" ; -- testig..av.1
  testighet_1_N = mkN "testighet" ; -- testighet..nn.1
  testikel_1_N = mkN "testikel" ; -- testikel..nn.1
  testikelcancer_1_N = mkN "testikelcancer" ; -- testikelcancer..nn.1
  testimonium_1_N = mkN "testimonium" "testimoniet" "testimonier" "testimonierna" ; -- testimonium..nn.1
  testköra_1_V = mkV "testköra" "testkörde" "testkört" ; -- testköra..vb.1
  testosteron_1_N = mkN "testosteron" neutrum  ; -- testosteron..nn.1
  testosteronpumpad_1_A = mkA "testosteronpumpad" ; -- testosteronpumpad..av.1
  testpilot_1_N = mkN "testpilot" "testpiloter" ; -- testpilot..nn.1
  testreaktor_1_N = mkN "testreaktor" "testreaktorer" ; -- testreaktor..nn.1
  testuggare_1_N = mkN "testuggare" utrum  ; -- testuggare..nn.1
  testvärde_1_N = mkN "testvärde" ; -- testvärde..nn.1
  tetani_1_N = mkN "tetani" ; -- tetani..nn.1
  tetanus_1_N = mkN "tetanus" ; -- tetanus..nn.1
  tetig_1_A = mkA "tetig" ; -- tetig..av.1
  tetra_1_N = mkN "tetra" ; -- tetra..nn.1
  tetraeder_1_N = mkN "tetraeder" ; -- tetraeder..nn.1
  tetraetylbly_1_N = mkN "tetraetylbly" neutrum  ; -- tetraetylbly..nn.1
  tetragon_1_N = mkN "tetragon" "tetragoner" ; -- tetragon..nn.1
  tetragonal_1_A = mkA "tetragonal" ; -- tetragonal..av.1
  tetraklorid_1_N = mkN "tetraklorid" "tetraklorider" ; -- tetraklorid..nn.1
  tetrakord_1_N = mkN "tetrakord" neutrum  ; -- tetrakord..nn.1
  tetralogi_1_N = mkN "tetralogi" "tetralogier" ; -- tetralogi..nn.1
  tetrapack_1_N = mkN "tetrapack" neutrum  ; -- tetrapack..nn.1
  tetrapak_1_N = mkN "tetrapak" neutrum  ; -- tetrapak..nn.1
  tetraploid_1_A = mkA "tetraploid" ; -- tetraploid..av.1
  tetrapod_1_N = mkN "tetrapod" "tetrapoder" ; -- tetrapod..nn.1
  tetrark_1_N = mkN "tetrark" "tetrarker" ; -- tetrark..nn.1
  teuton_1_N = mkN "teuton" "teutoner" ; -- teuton..nn.1
  teutonisk_1_A = mkA "teutonisk" ; -- teutonisk..av.1
  teutoniskhet_1_N = mkN "teutoniskhet" ; -- teutoniskhet..nn.1
  tevagn_1_N = mkN "tevagn" ; -- tevagn..nn.1
  teve_evangelist_1_N = mkN "teve-evangelist" "teve-evangelister" ; -- teve-evangelist..nn.1
  teve_1_N = mkN "teve" ; -- teve..nn.1
  teve_2_N = mkN "teve" "teven" "tevear" "tevearna" ; -- teve..nn.2
  teveabonnemang_1_N = mkN "teveabonnemang" neutrum  ; -- teveabonnemang..nn.1
  teveaktuell_1_A = mkA "teveaktuell" ; -- teveaktuell..av.1
  teveantenn_1_N = mkN "teveantenn" "teveantenner" ; -- teveantenn..nn.1
  teveapparat_1_N = mkN "teveapparat" "teveapparater" ; -- teveapparat..nn.1
  tevebild_1_N = mkN "tevebild" "tevebilder" ; -- tevebild..nn.1
  tevechef_1_N = mkN "tevechef" "tevechefer" ; -- tevechef..nn.1
  teveevangelist_1_N = mkN "teveevangelist" "teveevangelister" ; -- teveevangelist..nn.1
  teveintervju_1_N = mkN "teveintervju" "teveintervjun" "teveintervjuer" "teveintervjuerna" ; -- teveintervju..nn.1
  tevekamera_1_N = mkN "tevekamera" ; -- tevekamera..nn.1
  tevekanal_1_N = mkN "tevekanal" "tevekanaler" ; -- tevekanal..nn.1
  tevekonferens_1_N = mkN "tevekonferens" "tevekonferenser" ; -- tevekonferens..nn.1
  tevemast_1_N = mkN "tevemast" "tevemaster" ; -- tevemast..nn.1
  tevemeteorolog_1_N = mkN "tevemeteorolog" "tevemeteorologer" ; -- tevemeteorolog..nn.1
  tevemottagare_1_N = mkN "tevemottagare" utrum  ; -- tevemottagare..nn.1
  tevenyhet_1_N = mkN "tevenyhet" "tevenyheter" ; -- tevenyhet..nn.1
  tevepredikant_1_N = mkN "tevepredikant" "tevepredikanter" ; -- tevepredikant..nn.1
  teveproducent_1_N = mkN "teveproducent" "teveproducenter" ; -- teveproducent..nn.1
  teveprofil_1_N = mkN "teveprofil" "teveprofiler" ; -- teveprofil..nn.1
  teveprogram_1_N = mkN "teveprogram" "teveprogrammet" "teveprogram" "teveprogrammen" ; -- teveprogram..nn.1
  tevereklam_1_N = mkN "tevereklam" ; -- tevereklam..nn.1
  tevereparatör_1_N = mkN "tevereparatör" "tevereparatörer" ; -- tevereparatör..nn.1
  teveronika_1_N = mkN "teveronika" ; -- teveronika..nn.1
  teveruta_1_N = mkN "teveruta" ; -- teveruta..nn.1
  teveserie_1_N = mkN "teveserie" "teveserier" ; -- teveserie..nn.1
  tevesignal_1_N = mkN "tevesignal" "tevesignaler" ; -- tevesignal..nn.1
  teveskärm_1_N = mkN "teveskärm" ; -- teveskärm..nn.1
  tevesoffa_1_N = mkN "tevesoffa" ; -- tevesoffa..nn.1
  tevestudio_1_N = mkN "tevestudio" "tevestudior" ; -- tevestudio..nn.1
  tevesändare_1_N = mkN "tevesändare" utrum  ; -- tevesändare..nn.1
  tevesändning_1_N = mkN "tevesändning" ; -- tevesändning..nn.1
  tevesåpa_1_N = mkN "tevesåpa" ; -- tevesåpa..nn.1
  tevetittande_1_N = mkN "tevetittande" ; -- tevetittande..nn.1
  tevetittare_1_N = mkN "tevetittare" utrum  ; -- tevetittare..nn.1
  teveövervakning_1_N = mkN "teveövervakning" ; -- teveövervakning..nn.1
  text_1_N = mkN "text" "texter" ; -- text..nn.1
  texta_1_V = mkV "textar" ; -- texta..vb.1
  textande_1_N = mkN "textande" ; -- textande..nn.1
  textarkiv_1_N = mkN "textarkiv" neutrum  ; -- textarkiv..nn.1
  textavsnitt_1_N = mkN "textavsnitt" neutrum  ; -- textavsnitt..nn.1
  textbearbetning_1_N = mkN "textbearbetning" ; -- textbearbetning..nn.1
  textbehandling_1_N = mkN "textbehandling" ; -- textbehandling..nn.1
  textbok_1_N = mkN "textbok" "textböcker" ; -- textbok..nn.1
  textfält_1_N = mkN "textfält" neutrum  ; -- textfält..nn.1
  textförlust_1_N = mkN "textförlust" "textförluster" ; -- textförlust..nn.1
  textil_1_A = mkA "textil" ; -- textil..av.1
  textil_1_N = mkN "textil" "textiler" ; -- textil..nn.1
  textilarbetare_1_N = mkN "textilarbetare" utrum  ; -- textilarbetare..nn.1
  textilfabrik_1_N = mkN "textilfabrik" "textilfabriker" ; -- textilfabrik..nn.1
  textilfiber_1_N = mkN "textilfiber" "textilfibern" "textilfibrer" "textilfibrerna" ; -- textilfiber..nn.1
  textilindustri_1_N = mkN "textilindustri" "textilindustrier" ; -- textilindustri..nn.1
  textilkonst_1_N = mkN "textilkonst" ; -- textilkonst..nn.1
  textilkonstnär_1_N = mkN "textilkonstnär" "textilkonstnärer" ; -- textilkonstnär..nn.1
  textilkurs_1_N = mkN "textilkurs" "textilkurser" ; -- textilkurs..nn.1
  textillärare_1_N = mkN "textillärare" utrum  ; -- textillärare..nn.1
  textilslöjd_1_N = mkN "textilslöjd" ; -- textilslöjd..nn.1
  textilspill_1_N = mkN "textilspill" neutrum  ; -- textilspill..nn.1
  textilätande_1_A = mkA "textilätande" ; -- textilätande..av.1
  textkorpus_1_N = mkN "textkorpus" ; -- textkorpus..nn.1
  textkritik_1_N = mkN "textkritik" ; -- textkritik..nn.1
  textkritisk_1_A = mkA "textkritisk" ; -- textkritisk..av.1
  textmässig_1_A = mkA "textmässig" ; -- textmässig..av.1
  textning_1_N = mkN "textning" ; -- textning..nn.1
  textparti_1_N = mkN "textparti" "textpartiet" "textpartier" "textpartierna" ; -- textparti..nn.1
  textrad_1_N = mkN "textrad" "textrader" ; -- textrad..nn.1
  textreklam_1_N = mkN "textreklam" ; -- textreklam..nn.1
  textskärm_1_N = mkN "textskärm" ; -- textskärm..nn.1
  textstorlek_1_N = mkN "textstorlek" ; -- textstorlek..nn.1
  textstycke_1_N = mkN "textstycke" ; -- textstycke..nn.1
  textställe_1_N = mkN "textställe" ; -- textställe..nn.1
  textstöld_1_N = mkN "textstöld" "textstölder" ; -- textstöld..nn.1
  texttolkning_1_N = mkN "texttolkning" ; -- texttolkning..nn.1
  texttrogen_1_A = mkA "texttrogen" ; -- texttrogen..av.1
  textur_1_N = mkN "textur" "texturer" ; -- textur..nn.1
  textyta_1_N = mkN "textyta" ; -- textyta..nn.1
  teälskande_1_A = mkA "teälskande" ; -- teälskande..av.1
  teärenpris_1_N = mkN "teärenpris" ; -- teärenpris..nn.1
  thai_1_N = mkN "thai" ; -- thai..nn.1
  thaiboxning_1_N = mkN "thaiboxning" ; -- thaiboxning..nn.1
  thailändare_1_N = mkN "thailändare" utrum  ; -- thailändare..nn.1
  thailändsk_1_A = mkA "thailändsk" ; -- thailändsk..av.1
  thailändska_1_N = mkN "thailändska" ; -- thailändska..nn.1
  thaimat_1_N = mkN "thaimat" ; -- thaimat..nn.1
  thairestaurang_1_N = mkN "thairestaurang" "thairestauranger" ; -- thairestaurang..nn.1
  thaisiden_1_N = mkN "thaisiden" neutrum  ; -- thaisiden..nn.1
  thaispråk_1_N = mkN "thaispråk" neutrum  ; -- thaispråk..nn.1
  thalamus_1_N = mkN "thalamus" ; -- thalamus..nn.1
  the_1_N = mkN "the" "theet" "theer" "theerna" ; -- the..nn.1
  the_2_N = mkN "the" "the" ; -- the..nn.2
  theta_1_N = mkN "theta" "thetat" "thetan" "thetana" ; -- theta..nn.1
  thinner_1_N = mkN "thinner" ; -- thinner..nn.1
  thomasfosfat_1_N = mkN "thomasfosfat" neutrum  ; -- thomasfosfat..nn.1
  thorax_1_N = mkN "thorax" ; -- thorax..nn.1
  thriller_1_N = mkN "thriller" ; -- thriller..nn.1
  thrillerfilm_1_N = mkN "thrillerfilm" "thrillerfilmer" ; -- thrillerfilm..nn.1
  thymus_1_N = mkN "thymus" ; -- thymus..nn.1
  thyroxin_1_N = mkN "thyroxin" "thyroxiner" ; -- thyroxin..nn.1
  thäta_1_N = mkN "thäta" "thätat" "thätan" "thätana" ; -- thäta..nn.1
  tia_1_N = mkN "tia" ; -- tia..nn.1
  tiamin_1_N = mkN "tiamin" "tiaminer" ; -- tiamin..nn.1
  tiara_1_N = mkN "tiara" ; -- tiara..nn.1
  tibast_1_N = mkN "tibast" ; -- tibast..nn.1
  tibetan_1_N = mkN "tibetan" "tibetaner" ; -- tibetan..nn.1
  tibetanare_1_N = mkN "tibetanare" utrum  ; -- tibetanare..nn.1
  tibetansk_1_A = mkA "tibetansk" ; -- tibetansk..av.1
  tibetanska_1_N = mkN "tibetanska" ; -- tibetanska..nn.1
  tibetanska_2_N = mkN "tibetanska" ; -- tibetanska..nn.2
  tic_1_N = mkN "tic" "ticen" "tics" "ticsarna" ; -- tic..nn.1
  tick_tack_1_N = mkN "tick-tack" neutrum  ; -- tick-tack..nn.1
  tick_1_N = mkN "tick" neutrum  ; -- tick..nn.1
  ticka_1_N = mkN "ticka" ; -- ticka..nn.1
  ticka_1_V = mkV "tickar" ; -- ticka..vb.1
  tickande_1_N = mkN "tickande" ; -- tickande..nn.1
  tid_1_N = mkN "tid" "tider" ; -- tid..nn.1
  tidebok_1_N = mkN "tidebok" "tideböcker" ; -- tidebok..nn.1
  tidegärd_1_N = mkN "tidegärd" "tidegärder" ; -- tidegärd..nn.1
  tidelag_1_N = mkN "tidelag" neutrum  ; -- tidelag..nn.1
  tidelagsförbud_1_N = mkN "tidelagsförbud" neutrum  ; -- tidelagsförbud..nn.1
  tidernas_1_A = mkA "tidernas" ; -- tidernas..av.1
  tideräkning_1_N = mkN "tideräkning" ; -- tideräkning..nn.1
  tidevarv_1_N = mkN "tidevarv" neutrum  ; -- tidevarv..nn.1
  tidfästa_1_V = mkV "tidfästa" "tidfäster" "tidfäst" "tidfäste" "tidfäst" "tidfäst" ; -- tidfästa..vb.1
  tidfästande_1_N = mkN "tidfästande" ; -- tidfästande..nn.1
  tidig_1_A = mkA "tidig" ; -- tidig..av.1
  tidigare_1_Adv = mkAdv "tidigare" ; -- tidigare..ab.1
  tidigarelägga_1_V = mkV "tidigarelägga" "tidigarela" "tidigarelagt" ; -- tidigarelägga..vb.1
  tidigareläggande_1_N = mkN "tidigareläggande" ; -- tidigareläggande..nn.1
  tidigareläggning_1_N = mkN "tidigareläggning" ; -- tidigareläggning..nn.1
  tidigast_1_Adv = mkAdv "tidigast" ; -- tidigast..ab.1
  tidighet_1_N = mkN "tidighet" ; -- tidighet..nn.1
  tidigmedeltida_1_A = mkA "tidigmedeltida" ; -- tidigmedeltida..av.1
  tidigmodern_1_A = mkA "tidigmodern" ; -- tidigmodern..av.1
  tidigneolitisk_1_A = mkA "tidigneolitisk" ; -- tidigneolitisk..av.1
  tidjord_1_N = mkN "tidjord" ; -- tidjord..nn.1
  tidjordsfenomen_1_N = mkN "tidjordsfenomen" neutrum  ; -- tidjordsfenomen..nn.1
  tidjordsforskning_1_N = mkN "tidjordsforskning" ; -- tidjordsforskning..nn.1
  tidjordskraft_1_N = mkN "tidjordskraft" "tidjordskrafter" ; -- tidjordskraft..nn.1
  tidkontrollur_1_N = mkN "tidkontrollur" neutrum  ; -- tidkontrollur..nn.1
  tidkort_1_N = mkN "tidkort" neutrum  ; -- tidkort..nn.1
  tidlig_1_A = mkA "tidlig" ; -- tidlig..av.1
  tidlighet_1_N = mkN "tidlighet" ; -- tidlighet..nn.1
  tidlån_1_N = mkN "tidlån" neutrum  ; -- tidlån..nn.1
  tidlön_1_N = mkN "tidlön" "tidlöner" ; -- tidlön..nn.1
  tidlös_1_A = mkA "tidlös" ; -- tidlös..av.1
  tidlösa_1_N = mkN "tidlösa" ; -- tidlösa..nn.1
  tidlöshet_1_N = mkN "tidlöshet" "tidlösheter" ; -- tidlöshet..nn.1
  tidmätning_1_N = mkN "tidmätning" ; -- tidmätning..nn.1
  tidmåne_1_N = mkN "tidmåne" utrum  ; -- tidmåne..nn.1
  tidning_1_N = mkN "tidning" ; -- tidning..nn.1
  tidningsanka_1_N = mkN "tidningsanka" ; -- tidningsanka..nn.1
  tidningsartikel_1_N = mkN "tidningsartikel" ; -- tidningsartikel..nn.1
  tidningsbilaga_1_N = mkN "tidningsbilaga" ; -- tidningsbilaga..nn.1
  tidningsblunder_1_N = mkN "tidningsblunder" ; -- tidningsblunder..nn.1
  tidningsbransch_1_N = mkN "tidningsbransch" ; -- tidningsbransch..nn.1
  tidningsbud_1_N = mkN "tidningsbud" neutrum  ; -- tidningsbud..nn.1
  tidningsbunt_1_N = mkN "tidningsbunt" ; -- tidningsbunt..nn.1
  tidningsdrottning_1_N = mkN "tidningsdrottning" ; -- tidningsdrottning..nn.1
  tidningsdöd_1_N = mkN "tidningsdöd" ; -- tidningsdöd..nn.1
  tidningsföretag_1_N = mkN "tidningsföretag" neutrum  ; -- tidningsföretag..nn.1
  tidningskant_1_N = mkN "tidningskant" "tidningskanter" ; -- tidningskant..nn.1
  tidningskiosk_1_N = mkN "tidningskiosk" "tidningskiosker" ; -- tidningskiosk..nn.1
  tidningskrig_1_N = mkN "tidningskrig" neutrum  ; -- tidningskrig..nn.1
  tidningskung_1_N = mkN "tidningskung" ; -- tidningskung..nn.1
  tidningskäbbel_1_N = mkN "tidningskäbbel" neutrum  ; -- tidningskäbbel..nn.1
  tidningsledare_1_N = mkN "tidningsledare" utrum  ; -- tidningsledare..nn.1
  tidningsläsande_1_A = mkA "tidningsläsande" ; -- tidningsläsande..av.1
  tidningsläsande_1_N = mkN "tidningsläsande" ; -- tidningsläsande..nn.1
  tidningsläsare_1_N = mkN "tidningsläsare" utrum  ; -- tidningsläsare..nn.1
  tidningsman_1_N = mkN "tidningsman" "tidningsmannen" "tidningsmän" "tidningsmännen" ; -- tidningsman..nn.1
  tidningsnotis_1_N = mkN "tidningsnotis" "tidningsnotiser" ; -- tidningsnotis..nn.1
  tidningspacke_1_N = mkN "tidningspacke" utrum  ; -- tidningspacke..nn.1
  tidningspapper_1_N = mkN "tidningspapper" neutrum  ; -- tidningspapper..nn.1
  tidningspolemik_1_N = mkN "tidningspolemik" ; -- tidningspolemik..nn.1
  tidningsredaktion_1_N = mkN "tidningsredaktion" ; -- tidningsredaktion..nn.1
  tidningsreferat_1_N = mkN "tidningsreferat" neutrum  ; -- tidningsreferat..nn.1
  tidningssida_1_N = mkN "tidningssida" ; -- tidningssida..nn.1
  tidningsspalt_1_N = mkN "tidningsspalt" "tidningsspalter" ; -- tidningsspalt..nn.1
  tidningsställ_1_N = mkN "tidningsställ" neutrum  ; -- tidningsställ..nn.1
  tidningstext_1_N = mkN "tidningstext" "tidningstexter" ; -- tidningstext..nn.1
  tidningsuppgift_1_N = mkN "tidningsuppgift" "tidningsuppgifter" ; -- tidningsuppgift..nn.1
  tidningsupplaga_1_N = mkN "tidningsupplaga" ; -- tidningsupplaga..nn.1
  tidningsutbärning_1_N = mkN "tidningsutbärning" ; -- tidningsutbärning..nn.1
  tidningsutgivning_1_N = mkN "tidningsutgivning" ; -- tidningsutgivning..nn.1
  tidpunkt_1_N = mkN "tidpunkt" "tidpunkter" ; -- tidpunkt..nn.1
  tidrymd_1_N = mkN "tidrymd" "tidrymder" ; -- tidrymd..nn.1
  tidrör_1_N = mkN "tidrör" neutrum  ; -- tidrör..nn.1
  tidsadverb_1_N = mkN "tidsadverb" neutrum  ; -- tidsadverb..nn.1
  tidsadverbial_1_N = mkN "tidsadverbial" neutrum  ; -- tidsadverbial..nn.1
  tidsanda_1_N = mkN "tidsanda" ; -- tidsanda..nn.1
  tidsangivelse_1_N = mkN "tidsangivelse" "tidsangivelser" ; -- tidsangivelse..nn.1
  tidsanvändning_1_N = mkN "tidsanvändning" ; -- tidsanvändning..nn.1
  tidsanvändningsundersökning_1_N = mkN "tidsanvändningsundersökning" ; -- tidsanvändningsundersökning..nn.1
  tidsaspekt_1_N = mkN "tidsaspekt" "tidsaspekter" ; -- tidsaspekt..nn.1
  tidsasymmetrisk_1_A = mkA "tidsasymmetrisk" ; -- tidsasymmetrisk..av.1
  tidsaxel_1_N = mkN "tidsaxel" ; -- tidsaxel..nn.1
  tidsbefraktning_1_N = mkN "tidsbefraktning" ; -- tidsbefraktning..nn.1
  tidsbegrepp_1_N = mkN "tidsbegrepp" neutrum  ; -- tidsbegrepp..nn.1
  tidsbegränsa_1_V = mkV "tidsbegränsar" ; -- tidsbegränsa..vb.1
  tidsbegränsad_1_A = mkA "tidsbegränsad" ; -- tidsbegränsad..av.1
  tidsbegränsande_1_N = mkN "tidsbegränsande" ; -- tidsbegränsande..nn.1
  tidsberäkna_1_V = mkV "tidsberäknar" ; -- tidsberäkna..vb.1
  tidsberäknande_1_N = mkN "tidsberäknande" ; -- tidsberäknande..nn.1
  tidsberäkning_1_N = mkN "tidsberäkning" ; -- tidsberäkning..nn.1
  tidsbesparande_1_A = mkA "tidsbesparande" ; -- tidsbesparande..av.1
  tidsbesparing_1_N = mkN "tidsbesparing" ; -- tidsbesparing..nn.1
  tidsbeställning_1_N = mkN "tidsbeställning" ; -- tidsbeställning..nn.1
  tidsbestämma_1_V = mkV "tidsbestämmer" ; -- tidsbestämma..vb.1
  tidsbestämmande_1_N = mkN "tidsbestämmande" ; -- tidsbestämmande..nn.1
  tidsbestämning_1_N = mkN "tidsbestämning" ; -- tidsbestämning..nn.1
  tidsbild_1_N = mkN "tidsbild" "tidsbilder" ; -- tidsbild..nn.1
  tidsbrist_1_N = mkN "tidsbrist" ; -- tidsbrist..nn.1
  tidsbunden_1_A = mkA "tidsbunden" ; -- tidsbunden..av.1
  tidsdelning_1_N = mkN "tidsdelning" ; -- tidsdelning..nn.1
  tidsdokument_1_N = mkN "tidsdokument" neutrum  ; -- tidsdokument..nn.1
  tidsekvation_1_N = mkN "tidsekvation" ; -- tidsekvation..nn.1
  tidsenhet_1_N = mkN "tidsenhet" "tidsenheter" ; -- tidsenhet..nn.1
  tidsenlig_1_A = mkA "tidsenlig" ; -- tidsenlig..av.1
  tidsenlighet_1_N = mkN "tidsenlighet" ; -- tidsenlighet..nn.1
  tidsepok_1_N = mkN "tidsepok" "tidsepoker" ; -- tidsepok..nn.1
  tidsfaktor_1_N = mkN "tidsfaktor" "tidsfaktorer" ; -- tidsfaktor..nn.1
  tidsfrist_1_N = mkN "tidsfrist" "tidsfrister" ; -- tidsfrist..nn.1
  tidsfråga_1_N = mkN "tidsfråga" ; -- tidsfråga..nn.1
  tidsföljd_1_N = mkN "tidsföljd" "tidsföljder" ; -- tidsföljd..nn.1
  tidsfördriv_1_N = mkN "tidsfördriv" neutrum  ; -- tidsfördriv..nn.1
  tidsförhållande_1_N = mkN "tidsförhållande" ; -- tidsförhållande..nn.1
  tidsförlopp_1_N = mkN "tidsförlopp" neutrum  ; -- tidsförlopp..nn.1
  tidsförlust_1_N = mkN "tidsförlust" "tidsförluster" ; -- tidsförlust..nn.1
  tidsförskjutning_1_N = mkN "tidsförskjutning" ; -- tidsförskjutning..nn.1
  tidsgräns_1_N = mkN "tidsgräns" "tidsgränser" ; -- tidsgräns..nn.1
  tidsindelning_1_N = mkN "tidsindelning" ; -- tidsindelning..nn.1
  tidsinställa_1_V = mkV "tidsinställer" ; -- tidsinställa..vb.1
  tidsinställande_1_N = mkN "tidsinställande" ; -- tidsinställande..nn.1
  tidsinställd_1_A = mkA "tidsinställd" "tidsinställt" ; -- tidsinställd..av.1
  tidsinställning_1_N = mkN "tidsinställning" ; -- tidsinställning..nn.1
  tidsintervall_1_N = mkN "tidsintervall" neutrum  ; -- tidsintervall..nn.1
  tidskapsel_1_N = mkN "tidskapsel" ; -- tidskapsel..nn.1
  tidskifte_1_N = mkN "tidskifte" ; -- tidskifte..nn.1
  tidskrift_1_N = mkN "tidskrift" "tidskrifter" ; -- tidskrift..nn.1
  tidskriftsartikel_1_N = mkN "tidskriftsartikel" ; -- tidskriftsartikel..nn.1
  tidskriftsillustration_1_N = mkN "tidskriftsillustration" ; -- tidskriftsillustration..nn.1
  tidskriftsindex_1_N = mkN "tidskriftsindex" neutrum  ; -- tidskriftsindex..nn.1
  tidskriftsnummer_1_N = mkN "tidskriftsnummer" neutrum  ; -- tidskriftsnummer..nn.1
  tidskrävande_1_A = mkA "tidskrävande" ; -- tidskrävande..av.1
  tidslig_1_A = mkA "tidslig" ; -- tidslig..av.1
  tidslighet_1_N = mkN "tidslighet" ; -- tidslighet..nn.1
  tidsmarginal_1_N = mkN "tidsmarginal" "tidsmarginaler" ; -- tidsmarginal..nn.1
  tidsmaskin_1_N = mkN "tidsmaskin" "tidsmaskiner" ; -- tidsmaskin..nn.1
  tidsmedvetande_1_N = mkN "tidsmedvetande" ; -- tidsmedvetande..nn.1
  tidsmedveten_1_A = mkA "tidsmedveten" ; -- tidsmedveten..av.1
  tidsmässig_1_A = mkA "tidsmässig" ; -- tidsmässig..av.1
  tidsmässighet_1_N = mkN "tidsmässighet" "tidsmässigheter" ; -- tidsmässighet..nn.1
  tidsmått_1_N = mkN "tidsmått" neutrum  ; -- tidsmått..nn.1
  tidsnöd_1_N = mkN "tidsnöd" ; -- tidsnöd..nn.1
  tidsomställning_1_N = mkN "tidsomställning" ; -- tidsomställning..nn.1
  tidsperiod_1_N = mkN "tidsperiod" "tidsperioder" ; -- tidsperiod..nn.1
  tidsperspektiv_1_N = mkN "tidsperspektiv" neutrum  ; -- tidsperspektiv..nn.1
  tidspil_1_N = mkN "tidspil" ; -- tidspil..nn.1
  tidsplan_1_N = mkN "tidsplan" "tidsplaner" ; -- tidsplan..nn.1
  tidsplan_2_N = mkN "tidsplan" neutrum  ; -- tidsplan..nn.2
  tidspress_1_N = mkN "tidspress" ; -- tidspress..nn.1
  tidsriktning_1_N = mkN "tidsriktning" ; -- tidsriktning..nn.1
  tidsriktning_2_N = mkN "tidsriktning" ; -- tidsriktning..nn.2
  tidsrymd_1_N = mkN "tidsrymd" "tidsrymder" ; -- tidsrymd..nn.1
  tidsschema_1_N = mkN "tidsschema" "tidsschemat" "tidsscheman" "tidsschemana" ; -- tidsschema..nn.1
  tidssignal_1_N = mkN "tidssignal" "tidssignaler" ; -- tidssignal..nn.1
  tidsskala_1_N = mkN "tidsskala" ; -- tidsskala..nn.1
  tidsskede_1_N = mkN "tidsskede" ; -- tidsskede..nn.1
  tidsskildring_1_N = mkN "tidsskildring" ; -- tidsskildring..nn.1
  tidsskillnad_1_N = mkN "tidsskillnad" "tidsskillnader" ; -- tidsskillnad..nn.1
  tidsspillande_1_A = mkA "tidsspillande" ; -- tidsspillande..av.1
  tidsströmning_1_N = mkN "tidsströmning" ; -- tidsströmning..nn.1
  tidsstudieman_1_N = mkN "tidsstudieman" "tidsstudiemannen" "tidsstudiemän" "tidsstudiemännen" ; -- tidsstudieman..nn.1
  tidssymmetrisk_1_A = mkA "tidssymmetrisk" ; -- tidssymmetrisk..av.1
  tidstjuv_1_N = mkN "tidstjuv" ; -- tidstjuv..nn.1
  tidstrogen_1_A = mkA "tidstrogen" ; -- tidstrogen..av.1
  tidströmställare_1_N = mkN "tidströmställare" utrum  ; -- tidströmställare..nn.1
  tidstypisk_1_A = mkA "tidstypisk" ; -- tidstypisk..av.1
  tidsuppfattning_1_N = mkN "tidsuppfattning" ; -- tidsuppfattning..nn.1
  tidsutdräkt_1_N = mkN "tidsutdräkt" ; -- tidsutdräkt..nn.1
  tidsvinst_1_N = mkN "tidsvinst" "tidsvinster" ; -- tidsvinst..nn.1
  tidszon_1_N = mkN "tidszon" "tidszoner" ; -- tidszon..nn.1
  tidsålder_1_N = mkN "tidsålder" ; -- tidsålder..nn.1
  tidsåtgång_1_N = mkN "tidsåtgång" ; -- tidsåtgång..nn.1
  tidsödande_1_A = mkA "tidsödande" ; -- tidsödande..av.1
  tidsöverdrag_1_N = mkN "tidsöverdrag" neutrum  ; -- tidsöverdrag..nn.1
  tidtabell_1_N = mkN "tidtabell" "tidtabeller" ; -- tidtabell..nn.1
  tidtabellsmässig_1_A = mkA "tidtabellsmässig" ; -- tidtabellsmässig..av.1
  tidtagare_1_N = mkN "tidtagare" utrum  ; -- tidtagare..nn.1
  tidtagarur_1_N = mkN "tidtagarur" neutrum  ; -- tidtagarur..nn.1
  tidtagning_1_N = mkN "tidtagning" ; -- tidtagning..nn.1
  tidtals_1_Adv = mkAdv "tidtals" ; -- tidtals..ab.1
  tidur_1_N = mkN "tidur" neutrum  ; -- tidur..nn.1
  tidvatten_1_N = mkN "tidvatten" "tidvattnet" "tidvatten" "tidvattnen" ; -- tidvatten..nn.1
  tidvattenhöjd_1_N = mkN "tidvattenhöjd" "tidvattenhöjder" ; -- tidvattenhöjd..nn.1
  tidvattenkraft_1_N = mkN "tidvattenkraft" "tidvattenkrafter" ; -- tidvattenkraft..nn.1
  tidvattenkraftverk_1_N = mkN "tidvattenkraftverk" neutrum  ; -- tidvattenkraftverk..nn.1
  tidvattenström_1_N = mkN "tidvattenström" "tidvattenströmmen" "tidvattenströmmar" "tidvattenströmmarna" ; -- tidvattenström..nn.1
  tidvattenvåg_1_N = mkN "tidvattenvåg" "tidvattenvågor" ; -- tidvattenvåg..nn.1
  tidvis_1_Adv = mkAdv "tidvis" ; -- tidvis..ab.1
  tie_break_1_N = mkN "tie-break" neutrum  ; -- tie-break..nn.1
  tiga_1_V = mkV "tiga" "teg" "tigit" ; -- tiga..vb.1
  tigande_1_N = mkN "tigande" ; -- tigande..nn.1
  tigare_1_N = mkN "tigare" utrum  ; -- tigare..nn.1
  tiger_1_N = mkN "tiger" ; -- tiger..nn.1
  tigerbalsam_1_N = mkN "tigerbalsam" "tigerbalsamer" ; -- tigerbalsam..nn.1
  tigerekonomi_1_N = mkN "tigerekonomi" "tigerekonomier" ; -- tigerekonomi..nn.1
  tigerhaj_1_N = mkN "tigerhaj" ; -- tigerhaj..nn.1
  tigerkaka_1_N = mkN "tigerkaka" ; -- tigerkaka..nn.1
  tigerkatt_1_N = mkN "tigerkatt" "tigerkatter" ; -- tigerkatt..nn.1
  tigerlilja_1_N = mkN "tigerlilja" ; -- tigerlilja..nn.1
  tigermönstrad_1_A = mkA "tigermönstrad" ; -- tigermönstrad..av.1
  tigerorm_1_N = mkN "tigerorm" ; -- tigerorm..nn.1
  tigerrandig_1_A = mkA "tigerrandig" ; -- tigerrandig..av.1
  tigerrandighet_1_N = mkN "tigerrandighet" ; -- tigerrandighet..nn.1
  tigerskinn_1_N = mkN "tigerskinn" neutrum  ; -- tigerskinn..nn.1
  tigersprång_1_N = mkN "tigersprång" neutrum  ; -- tigersprång..nn.1
  tigerstrimmig_1_A = mkA "tigerstrimmig" ; -- tigerstrimmig..av.1
  tigerstrimmighet_1_N = mkN "tigerstrimmighet" ; -- tigerstrimmighet..nn.1
  tigersåg_1_N = mkN "tigersåg" ; -- tigersåg..nn.1
  tigga_1_V = mkV "tigger" ; -- tigga..vb.1
  tiggande_1_N = mkN "tiggande" ; -- tiggande..nn.1
  tiggarbrev_1_N = mkN "tiggarbrev" neutrum  ; -- tiggarbrev..nn.1
  tiggare_1_N = mkN "tiggare" utrum  ; -- tiggare..nn.1
  tiggarliga_1_N = mkN "tiggarliga" ; -- tiggarliga..nn.1
  tiggarmunk_1_N = mkN "tiggarmunk" ; -- tiggarmunk..nn.1
  tiggarorden_1_N = mkN "tiggarorden" ; -- tiggarorden..nn.1
  tiggarpack_1_N = mkN "tiggarpack" neutrum  ; -- tiggarpack..nn.1
  tiggarpåse_1_N = mkN "tiggarpåse" utrum  ; -- tiggarpåse..nn.1
  tiggarstav_1_N = mkN "tiggarstav" ; -- tiggarstav..nn.1
  tiggeri_1_N = mkN "tiggeri" "tiggeriet" "tiggerier" "tiggerierna" ; -- tiggeri..nn.1
  tight_1_A = mkA "tight" "tight" ; -- tight..av.1
  tighthet_1_N = mkN "tighthet" ; -- tighthet..nn.1
  tigrerad_1_A = mkA "tigrerad" ; -- tigrerad..av.1
  tik_1_N = mkN "tik" ; -- tik..nn.1
  tilja_1_N = mkN "tilja" ; -- tilja..nn.1
  tillaga_1_V = mkV "tillagar" ; -- tillaga..vb.1
  tillagande_1_N = mkN "tillagande" ; -- tillagande..nn.1
  tillagning_1_N = mkN "tillagning" ; -- tillagning..nn.1
  tillbakabildning_1_N = mkN "tillbakabildning" ; -- tillbakabildning..nn.1
  tillbakablick_1_N = mkN "tillbakablick" ; -- tillbakablick..nn.1
  tillbakablickande_1_A = mkA "tillbakablickande" ; -- tillbakablickande..av.1
  tillbakadragande_1_N = mkN "tillbakadragande" ; -- tillbakadragande..nn.1
  tillbakadragen_1_A = mkA "tillbakadragen" ; -- tillbakadragen..av.1
  tillbakadragenhet_1_N = mkN "tillbakadragenhet" ; -- tillbakadragenhet..nn.1
  tillbakadrivning_1_N = mkN "tillbakadrivning" ; -- tillbakadrivning..nn.1
  tillbakagående_1_A = mkA "tillbakagående" ; -- tillbakagående..av.1
  tillbakagång_1_N = mkN "tillbakagång" ; -- tillbakagång..nn.1
  tillbakahållen_1_A = mkA "tillbakahållen" ; -- tillbakahållen..av.1
  tillbakalutad_1_A = mkA "tillbakalutad" ; -- tillbakalutad..av.1
  tillbakasatt_1_A = mkA "tillbakasatt" ; -- tillbakasatt..av.1
  tillbakaslagen_1_A = mkA "tillbakaslagen" ; -- tillbakaslagen..av.1
  tillbakasyftande_1_A = mkA "tillbakasyftande" ; -- tillbakasyftande..av.1
  tillbakasättning_1_N = mkN "tillbakasättning" ; -- tillbakasättning..nn.1
  tillbakaträdande_1_N = mkN "tillbakaträdande" ; -- tillbakaträdande..nn.1
  tillbakavinkad_1_A = mkA "tillbakavinkad" ; -- tillbakavinkad..av.1
  tillbakavisa_1_V = mkV "tillbakavisar" ; -- tillbakavisa..vb.1
  tillbakavisande_1_N = mkN "tillbakavisande" ; -- tillbakavisande..nn.1
  tillbakavisning_1_N = mkN "tillbakavisning" ; -- tillbakavisning..nn.1
  tillbaks_1_Adv = mkAdv "tillbaks" ; -- tillbaks..ab.1
  tillbe_1_V = mkV "tillbeda" "tillbad" "tillbett" ; -- tillbe..vb.1
  tillbedjande_1_N = mkN "tillbedjande" ; -- tillbedjande..nn.1
  tillbedjare_1_N = mkN "tillbedjare" utrum  ; -- tillbedjare..nn.1
  tillbehör_1_N = mkN "tillbehör" neutrum  ; -- tillbehör..nn.1
  tillblanda_1_V = mkV "tillblandar" ; -- tillblanda..vb.1
  tillblandande_1_N = mkN "tillblandande" ; -- tillblandande..nn.1
  tillblandning_1_N = mkN "tillblandning" ; -- tillblandning..nn.1
  tillblivelse_1_N = mkN "tillblivelse" utrum  ; -- tillblivelse..nn.1
  tillbomning_1_N = mkN "tillbomning" ; -- tillbomning..nn.1
  tillbringa_1_V = mkV "tillbringar" ; -- tillbringa..vb.1
  tillbringande_1_N = mkN "tillbringande" ; -- tillbringande..nn.1
  tillbringare_1_N = mkN "tillbringare" utrum  ; -- tillbringare..nn.1
  tillbucklad_1_A = mkA "tillbucklad" ; -- tillbucklad..av.1
  tillbud_1_N = mkN "tillbud" neutrum  ; -- tillbud..nn.1
  tillbuds_1_Adv = mkAdv "tillbuds" ; -- tillbuds..ab.1
  tillbyggd_1_A = mkA "tillbyggd" "tillbyggt" ; -- tillbyggd..av.1
  tillbyggnad_1_N = mkN "tillbyggnad" "tillbyggnader" ; -- tillbyggnad..nn.1
  tillbörlig_1_A = mkA "tillbörlig" ; -- tillbörlig..av.1
  tillbörligen_1_Adv = mkAdv "tillbörligen" ; -- tillbörligen..ab.1
  tillbörlighet_1_N = mkN "tillbörlighet" ; -- tillbörlighet..nn.1
  tilldela_1_V = mkV "tilldelar" ; -- tilldela..vb.1
  tilldelande_1_N = mkN "tilldelande" ; -- tilldelande..nn.1
  tilldelning_1_N = mkN "tilldelning" ; -- tilldelning..nn.1
  tilldragande_1_A = mkA "tilldragande" ; -- tilldragande..av.1
  tilldragelse_1_N = mkN "tilldragelse" "tilldragelser" ; -- tilldragelse..nn.1
  tilldöma_1_V = mkV "tilldömer" ; -- tilldöma..vb.1
  tilldömande_1_N = mkN "tilldömande" ; -- tilldömande..nn.1
  tillerkänna_1_V = mkV "tillerkänna" "tillerkände" "tillerkänt" ; -- tillerkänna..vb.1
  tillerkännande_1_N = mkN "tillerkännande" ; -- tillerkännande..nn.1
  tillfalla_1_V = mkV "tillfalla" "tillföll" "tillfallit" ; -- tillfalla..vb.1
  tillfallande_1_N = mkN "tillfallande" ; -- tillfallande..nn.1
  tillfart_1_N = mkN "tillfart" "tillfarter" ; -- tillfart..nn.1
  tillfartsväg_1_N = mkN "tillfartsväg" ; -- tillfartsväg..nn.1
  tillflykt_1_N = mkN "tillflykt" ; -- tillflykt..nn.1
  tillflyktsort_1_N = mkN "tillflyktsort" "tillflyktsorter" ; -- tillflyktsort..nn.1
  tillflöde_1_N = mkN "tillflöde" ; -- tillflöde..nn.1
  tillfoga_1_V = mkV "tillfogar" ; -- tillfoga..vb.1
  tillfogande_1_N = mkN "tillfogande" ; -- tillfogande..nn.1
  tillfogning_1_N = mkN "tillfogning" ; -- tillfogning..nn.1
  tillfreds_1_A = mkA "tillfreds" ; -- tillfreds..av.1
  tillfredsställa_1_V = mkV "tillfredsställer" ; -- tillfredsställa..vb.1
  tillfredsställande_1_A = mkA "tillfredsställande" ; -- tillfredsställande..av.1
  tillfredsställande_1_N = mkN "tillfredsställande" ; -- tillfredsställande..nn.1
  tillfredsställd_1_A = mkA "tillfredsställd" "tillfredsställt" ; -- tillfredsställd..av.1
  tillfredsställelse_1_N = mkN "tillfredsställelse" utrum  ; -- tillfredsställelse..nn.1
  tillfriskna_1_V = mkV "tillfrisknar" ; -- tillfriskna..vb.1
  tillfrisknande_1_N = mkN "tillfrisknande" ; -- tillfrisknande..nn.1
  tillfriskning_1_N = mkN "tillfriskning" ; -- tillfriskning..nn.1
  tillfriskningsprogram_1_N = mkN "tillfriskningsprogram" "tillfriskningsprogrammet" "tillfriskningsprogram" "tillfriskningsprogrammen" ; -- tillfriskningsprogram..nn.1
  tillfrusen_1_A = mkA "tillfrusen" ; -- tillfrusen..av.1
  tillfrysa_1_V = mkV "tillfryser" ; -- tillfrysa..vb.1
  tillfrysande_1_N = mkN "tillfrysande" ; -- tillfrysande..nn.1
  tillfrysning_1_N = mkN "tillfrysning" ; -- tillfrysning..nn.1
  tillfråga_1_V = mkV "tillfrågar" ; -- tillfråga..vb.1
  tillfrågande_1_N = mkN "tillfrågande" ; -- tillfrågande..nn.1
  tillfullo_1_Adv = mkAdv "tillfullo" ; -- tillfullo..ab.1
  tillfyllest_1_Adv = mkAdv "tillfyllest" ; -- tillfyllest..ab.1
  tillfälle_1_N = mkN "tillfälle" ; -- tillfälle..nn.1
  tillfälleslitteratur_1_N = mkN "tillfälleslitteratur" ; -- tillfälleslitteratur..nn.1
  tillfällig_1_A = mkA "tillfällig" ; -- tillfällig..av.1
  tillfällighet_1_N = mkN "tillfällighet" "tillfälligheter" ; -- tillfällighet..nn.1
  tillfällighetsarbete_1_N = mkN "tillfällighetsarbete" ; -- tillfällighetsarbete..nn.1
  tillfällighetsdikt_1_N = mkN "tillfällighetsdikt" "tillfällighetsdikter" ; -- tillfällighetsdikt..nn.1
  tillfällighetsförbrytare_1_N = mkN "tillfällighetsförbrytare" utrum  ; -- tillfällighetsförbrytare..nn.1
  tillfällighetsvers_1_N = mkN "tillfällighetsvers" ; -- tillfällighetsvers..nn.1
  tillfälligtvis_1_Adv = mkAdv "tillfälligtvis" ; -- tillfälligtvis..ab.1
  tillfångata_1_V = mkV "tillfångataga" "tillfångatog" "tillfångatagit" ; -- tillfångata..vb.1
  tillfångatagande_1_N = mkN "tillfångatagande" ; -- tillfångatagande..nn.1
  tillfångatagning_1_N = mkN "tillfångatagning" ; -- tillfångatagning..nn.1
  tillföra_1_V = mkV "tillföra" "tillförde" "tillfört" ; -- tillföra..vb.1
  tillförande_1_N = mkN "tillförande" ; -- tillförande..nn.1
  tillförlitlig_1_A = mkA "tillförlitlig" ; -- tillförlitlig..av.1
  tillförlitlighet_1_N = mkN "tillförlitlighet" "tillförlitligheter" ; -- tillförlitlighet..nn.1
  tillförlitlighetstävling_1_N = mkN "tillförlitlighetstävling" ; -- tillförlitlighetstävling..nn.1
  tillförordna_1_V = mkV "tillförordnar" ; -- tillförordna..vb.1
  tillförordnad_1_A = mkA "tillförordnad" ; -- tillförordnad..av.1
  tillförsel_1_N = mkN "tillförsel" ; -- tillförsel..nn.1
  tillförsikt_1_N = mkN "tillförsikt" ; -- tillförsikt..nn.1
  tillförsäkra_1_V = mkV "tillförsäkrar" ; -- tillförsäkra..vb.1
  tillförsäkrande_1_N = mkN "tillförsäkrande" ; -- tillförsäkrande..nn.1
  tillge_1_V = mkV "tillgiva" "tillgav" "tillgivit" ; -- tillge..vb.1
  tillgift_1_N = mkN "tillgift" ; -- tillgift..nn.1
  tillgivande_1_N = mkN "tillgivande" ; -- tillgivande..nn.1
  tillgiven_1_A = mkA "tillgiven" ; -- tillgiven..av.1
  tillgivenhet_1_N = mkN "tillgivenhet" "tillgivenheter" ; -- tillgivenhet..nn.1
  tillgjord_1_A = mkA "tillgjord" "tillgjort" ; -- tillgjord..av.1
  tillgjordhet_1_N = mkN "tillgjordhet" "tillgjordheter" ; -- tillgjordhet..nn.1
  tillgodohavande_1_N = mkN "tillgodohavande" ; -- tillgodohavande..nn.1
  tillgodokvitto_1_N = mkN "tillgodokvitto" "tillgodokvittot" "tillgodokvitton" "tillgodokvittona" ; -- tillgodokvitto..nn.1
  tillgodoräkna_1_V = mkV "tillgodoräknar" ; -- tillgodoräkna..vb.1
  tillgodoräknande_1_N = mkN "tillgodoräknande" ; -- tillgodoräknande..nn.1
  tillgodose_1_V = mkV "tillgodose" "tillgodosåg" "tillgodosett" ; -- tillgodose..vb.1
  tillgodoseende_1_N = mkN "tillgodoseende" ; -- tillgodoseende..nn.1
  tillgodoskriva_1_V = mkV "tillgodoskriva" "tillgodoskrev" "tillgodoskrivit" ; -- tillgodoskriva..vb.1
  tillgodoskrivande_1_N = mkN "tillgodoskrivande" ; -- tillgodoskrivande..nn.1
  tillgodoskrivning_1_N = mkN "tillgodoskrivning" ; -- tillgodoskrivning..nn.1
  tillgrepp_1_N = mkN "tillgrepp" neutrum  ; -- tillgrepp..nn.1
  tillgripa_1_V = mkV "tillgripa" "tillgrep" "tillgripit" ; -- tillgripa..vb.1
  tillgripande_1_N = mkN "tillgripande" ; -- tillgripande..nn.1
  tillgänglig_1_A = mkA "tillgänglig" ; -- tillgänglig..av.1
  tillgängliggöra_1_V = mkV "tillgängliggöra" "tillgängliggjorde" "tillgängliggjort" ; -- tillgängliggöra..vb.1
  tillgängliggörande_1_N = mkN "tillgängliggörande" ; -- tillgängliggörande..nn.1
  tillgängliggörning_1_N = mkN "tillgängliggörning" ; -- tillgängliggörning..nn.1
  tillgänglighet_1_N = mkN "tillgänglighet" ; -- tillgänglighet..nn.1
  tillgå_1_V = mkV "tillgå" "tillgick" "tillgått" ; -- tillgå..vb.1
  tillgående_1_N = mkN "tillgående" ; -- tillgående..nn.1
  tillgång_1_N = mkN "tillgång" ; -- tillgång..nn.1
  tillhandahålla_1_V = mkV "tillhandahålla" "tillhandahöll" "tillhandahållit" ; -- tillhandahålla..vb.1
  tillhandahållande_1_N = mkN "tillhandahållande" ; -- tillhandahållande..nn.1
  tillhands_1_A = mkA "tillhands" ; -- tillhands..av.1
  tillhuggning_1_N = mkN "tillhuggning" ; -- tillhuggning..nn.1
  tillhyfsning_1_N = mkN "tillhyfsning" ; -- tillhyfsning..nn.1
  tillhygge_1_N = mkN "tillhygge" ; -- tillhygge..nn.1
  tillhåll_1_N = mkN "tillhåll" neutrum  ; -- tillhåll..nn.1
  tillhålla_1_V = mkV "tillhålla" "tillhöll" "tillhållit" ; -- tillhålla..vb.1
  tillhållande_1_N = mkN "tillhållande" ; -- tillhållande..nn.1
  tillhållarfjäder_1_N = mkN "tillhållarfjäder" ; -- tillhållarfjäder..nn.1
  tillhöra_1_V = mkV "tillhöra" "tillhörde" "tillhört" ; -- tillhöra..vb.1
  tillhörande_1_A = mkA "tillhörande" ; -- tillhörande..av.1
  tillhörande_1_N = mkN "tillhörande" ; -- tillhörande..nn.1
  tillhörig_1_A = mkA "tillhörig" ; -- tillhörig..av.1
  tillhörighet_1_N = mkN "tillhörighet" "tillhörigheter" ; -- tillhörighet..nn.1
  tillika_1_Adv = mkAdv "tillika" ; -- tillika..ab.1
  tillintetgjord_1_A = mkA "tillintetgjord" "tillintetgjort" ; -- tillintetgjord..av.1
  tillintetgöra_1_V = mkV "tillintetgöra" "tillintetgjorde" "tillintetgjort" ; -- tillintetgöra..vb.1
  tillintetgörande_1_A = mkA "tillintetgörande" ; -- tillintetgörande..av.1
  tillintetgörande_1_N = mkN "tillintetgörande" ; -- tillintetgörande..nn.1
  tillintetgörelse_1_N = mkN "tillintetgörelse" utrum  ; -- tillintetgörelse..nn.1
  tillit_1_N = mkN "tillit" ; -- tillit..nn.1
  tillitsfull_1_A = mkA "tillitsfull" ; -- tillitsfull..av.1
  tillitsfullhet_1_N = mkN "tillitsfullhet" ; -- tillitsfullhet..nn.1
  tilljämning_1_N = mkN "tilljämning" ; -- tilljämning..nn.1
  tillkalla_1_V = mkV "tillkallar" ; -- tillkalla..vb.1
  tillkallande_1_N = mkN "tillkallande" ; -- tillkallande..nn.1
  tillklippt_1_A = mkA "tillklippt" "tillklippt" ; -- tillklippt..av.1
  tillklistring_1_N = mkN "tillklistring" ; -- tillklistring..nn.1
  tillknipning_1_N = mkN "tillknipning" ; -- tillknipning..nn.1
  tillknycklad_1_A = mkA "tillknycklad" ; -- tillknycklad..av.1
  tillknyckling_1_N = mkN "tillknyckling" ; -- tillknyckling..nn.1
  tillknäppning_1_N = mkN "tillknäppning" ; -- tillknäppning..nn.1
  tillknäppt_1_A = mkA "tillknäppt" "tillknäppt" ; -- tillknäppt..av.1
  tillknäppthet_1_N = mkN "tillknäppthet" ; -- tillknäppthet..nn.1
  tillkomma_1_V = mkV "tillkomma" "tillkom" "tillkommit" ; -- tillkomma..vb.1
  tillkommande_1_A = mkA "tillkommande" ; -- tillkommande..av.1
  tillkommande_1_N = mkN "tillkommande" ; -- tillkommande..nn.1
  tillkomst_1_N = mkN "tillkomst" ; -- tillkomst..nn.1
  tillkomstsätt_1_N = mkN "tillkomstsätt" neutrum  ; -- tillkomstsätt..nn.1
  tillkoppla_1_V = mkV "tillkopplar" ; -- tillkoppla..vb.1
  tillkopplande_1_N = mkN "tillkopplande" ; -- tillkopplande..nn.1
  tillkorkad_1_A = mkA "tillkorkad" ; -- tillkorkad..av.1
  tillkortakommande_1_N = mkN "tillkortakommande" ; -- tillkortakommande..nn.1
  tillkrånglad_1_A = mkA "tillkrånglad" ; -- tillkrånglad..av.1
  tillkrångling_1_N = mkN "tillkrångling" ; -- tillkrångling..nn.1
  tillkämpad_1_A = mkA "tillkämpad" ; -- tillkämpad..av.1
  tillkännage_1_V = mkV "tillkännagiva" "tillkännagav" "tillkännagivit" ; -- tillkännage..vb.1
  tillkännagivande_1_N = mkN "tillkännagivande" ; -- tillkännagivande..nn.1
  tillmakning_1_N = mkN "tillmakning" ; -- tillmakning..nn.1
  tillmods_1_Adv = mkAdv "tillmods" ; -- tillmods..ab.1
  tillmurning_1_N = mkN "tillmurning" ; -- tillmurning..nn.1
  tillmäle_1_N = mkN "tillmäle" ; -- tillmäle..nn.1
  tillmäta_1_V = mkV "tillmäter" ; -- tillmäta..vb.1
  tillmätande_1_N = mkN "tillmätande" ; -- tillmätande..nn.1
  tillmötes_1_Adv = mkAdv "tillmötes" ; -- tillmötes..ab.1
  tillmötesgå_1_V = mkV "tillmötesgå" "tillmötesgick" "tillmötesgått" ; -- tillmötesgå..vb.1
  tillmötesgående_1_A = mkA "tillmötesgående" ; -- tillmötesgående..av.1
  tillmötesgående_1_N = mkN "tillmötesgående" ; -- tillmötesgående..nn.1
  tillnamn_1_N = mkN "tillnamn" neutrum  ; -- tillnamn..nn.1
  tillnyktring_1_N = mkN "tillnyktring" ; -- tillnyktring..nn.1
  tillnärmelsevis_1_Adv = mkAdv "tillnärmelsevis" ; -- tillnärmelsevis..ab.1
  tillopp_1_N = mkN "tillopp" neutrum  ; -- tillopp..nn.1
  tillpackning_1_N = mkN "tillpackning" ; -- tillpackning..nn.1
  tillpass_1_Adv = mkAdv "tillpass" ; -- tillpass..ab.1
  tillpassa_1_V = mkV "tillpassar" ; -- tillpassa..vb.1
  tillpassande_1_N = mkN "tillpassande" ; -- tillpassande..nn.1
  tillpassning_1_N = mkN "tillpassning" ; -- tillpassning..nn.1
  tillpimpning_1_N = mkN "tillpimpning" ; -- tillpimpning..nn.1
  tillplatta_1_V = mkV "tillplattar" ; -- tillplatta..vb.1
  tillplattad_1_A = mkA "tillplattad" ; -- tillplattad..av.1
  tillplattande_1_N = mkN "tillplattande" ; -- tillplattande..nn.1
  tillplattning_1_N = mkN "tillplattning" ; -- tillplattning..nn.1
  tillproppad_1_A = mkA "tillproppad" ; -- tillproppad..av.1
  tillra_1_V = mkV "tillrar" ; -- tillra..vb.1
  tillrande_1_N = mkN "tillrande" ; -- tillrande..nn.1
  tillreda_1_V = mkV "tillreda" "tillredde" "tillrett" ; -- tillreda..vb.1
  tillredande_1_N = mkN "tillredande" ; -- tillredande..nn.1
  tillreds_1_Adv = mkAdv "tillreds" ; -- tillreds..ab.1
  tillregling_1_N = mkN "tillregling" ; -- tillregling..nn.1
  tillresande_1_A = mkA "tillresande" ; -- tillresande..av.1
  tillrest_1_A = mkA "tillrest" "tillrest" ; -- tillrest..av.1
  tillriktning_1_N = mkN "tillriktning" ; -- tillriktning..nn.1
  tillrinning_1_N = mkN "tillrinning" ; -- tillrinning..nn.1
  tillrop_1_N = mkN "tillrop" neutrum  ; -- tillrop..nn.1
  tillrufsad_1_A = mkA "tillrufsad" ; -- tillrufsad..av.1
  tillrundning_1_N = mkN "tillrundning" ; -- tillrundning..nn.1
  tillryggalägga_1_V = mkV "tillryggalägga" "tillryggala" "tillryggalagt" ; -- tillryggalägga..vb.1
  tillryggaläggande_1_N = mkN "tillryggaläggande" ; -- tillryggaläggande..nn.1
  tillrynkad_1_A = mkA "tillrynkad" ; -- tillrynkad..av.1
  tillräcklig_1_A = mkA "tillräcklig" ; -- tillräcklig..av.1
  tillräcklighet_1_N = mkN "tillräcklighet" ; -- tillräcklighet..nn.1
  tillräkna_1_V = mkV "tillräknar" ; -- tillräkna..vb.1
  tillräknande_1_N = mkN "tillräknande" ; -- tillräknande..nn.1
  tillräknelig_1_A = mkA "tillräknelig" ; -- tillräknelig..av.1
  tillräknelighet_1_N = mkN "tillräknelighet" ; -- tillräknelighet..nn.1
  tillrätta_1_Adv = mkAdv "tillrätta" ; -- tillrätta..ab.1
  tillrättalägga_1_V = mkV "tillrättalägga" "tillrättala" "tillrättalagt" ; -- tillrättalägga..vb.1
  tillrättaläggande_1_N = mkN "tillrättaläggande" ; -- tillrättaläggande..nn.1
  tillrättavisa_1_V = mkV "tillrättavisar" ; -- tillrättavisa..vb.1
  tillrättavisande_1_N = mkN "tillrättavisande" ; -- tillrättavisande..nn.1
  tillrättavisning_1_N = mkN "tillrättavisning" ; -- tillrättavisning..nn.1
  tillråda_1_V = mkV "tillråda" "tillrådde" "tillrått" ; -- tillråda..vb.1
  tillrådande_1_N = mkN "tillrådande" ; -- tillrådande..nn.1
  tillrådlig_1_A = mkA "tillrådlig" ; -- tillrådlig..av.1
  tillrådlighet_1_N = mkN "tillrådlighet" ; -- tillrådlighet..nn.1
  tillsamman_1_Adv = mkAdv "tillsamman" ; -- tillsamman..ab.1
  tillsammans_1_Adv = mkAdv "tillsammans" ; -- tillsammans..ab.1
  tillsammantagen_1_A = mkA "tillsammantagen" ; -- tillsammantagen..av.1
  tillsats_1_N = mkN "tillsats" "tillsatser" ; -- tillsats..nn.1
  tillsatslins_1_N = mkN "tillsatslins" "tillsatslinser" ; -- tillsatslins..nn.1
  tillsatsämne_1_N = mkN "tillsatsämne" ; -- tillsatsämne..nn.1
  tillsatt_1_A = mkA "tillsatt" ; -- tillsatt..av.1
  tillse_1_V = mkV "tillse" "tillsåg" "tillsett" ; -- tillse..vb.1
  tillseende_1_N = mkN "tillseende" ; -- tillseende..nn.1
  tillskapa_1_V = mkV "tillskapar" ; -- tillskapa..vb.1
  tillskapande_1_N = mkN "tillskapande" ; -- tillskapande..nn.1
  tillskapning_1_N = mkN "tillskapning" ; -- tillskapning..nn.1
  tillskjuta_1_V = mkV "tillskjuta" "tillsköt" "tillskjutit" ; -- tillskjuta..vb.1
  tillskjutande_1_N = mkN "tillskjutande" ; -- tillskjutande..nn.1
  tillskjutning_1_N = mkN "tillskjutning" ; -- tillskjutning..nn.1
  tillskott_1_N = mkN "tillskott" neutrum  ; -- tillskott..nn.1
  tillskriva_1_V = mkV "tillskriva" "tillskrev" "tillskrivit" ; -- tillskriva..vb.1
  tillskrivande_1_N = mkN "tillskrivande" ; -- tillskrivande..nn.1
  tillskruvning_1_N = mkN "tillskruvning" ; -- tillskruvning..nn.1
  tillskrynklad_1_A = mkA "tillskrynklad" ; -- tillskrynklad..av.1
  tillskrynkling_1_N = mkN "tillskrynkling" ; -- tillskrynkling..nn.1
  tillskynda_1_V = mkV "tillskyndar" ; -- tillskynda..vb.1
  tillskyndande_1_N = mkN "tillskyndande" ; -- tillskyndande..nn.1
  tillskyndare_1_N = mkN "tillskyndare" utrum  ; -- tillskyndare..nn.1
  tillskära_1_V = mkV "tillskära" "tillskar" "tillskurit" ; -- tillskära..vb.1
  tillskärande_1_N = mkN "tillskärande" ; -- tillskärande..nn.1
  tillskärare_1_N = mkN "tillskärare" utrum  ; -- tillskärare..nn.1
  tillskärarkniv_1_N = mkN "tillskärarkniv" ; -- tillskärarkniv..nn.1
  tillskärning_1_N = mkN "tillskärning" ; -- tillskärning..nn.1
  tillslag_1_N = mkN "tillslag" neutrum  ; -- tillslag..nn.1
  tillslagen_1_A = mkA "tillslagen" ; -- tillslagen..av.1
  tillslagning_1_N = mkN "tillslagning" ; -- tillslagning..nn.1
  tillslagningsteknik_1_N = mkN "tillslagningsteknik" "tillslagningstekniker" ; -- tillslagningsteknik..nn.1
  tillslut_1_Adv = mkAdv "tillslut" ; -- tillslut..ab.1
  tillsluta_1_V = mkV "tillsluta" "tillslöt" "tillslutit" ; -- tillsluta..vb.1
  tillslutande_1_N = mkN "tillslutande" ; -- tillslutande..nn.1
  tillslutare_1_N = mkN "tillslutare" utrum  ; -- tillslutare..nn.1
  tillslutning_1_N = mkN "tillslutning" ; -- tillslutning..nn.1
  tillsläppning_1_N = mkN "tillsläppning" ; -- tillsläppning..nn.1
  tillslätning_1_N = mkN "tillslätning" ; -- tillslätning..nn.1
  tillspetsa_1_V = mkV "tillspetsar" ; -- tillspetsa..vb.1
  tillspetsad_1_A = mkA "tillspetsad" ; -- tillspetsad..av.1
  tillspetsande_1_N = mkN "tillspetsande" ; -- tillspetsande..nn.1
  tillspetsning_1_N = mkN "tillspetsning" ; -- tillspetsning..nn.1
  tillspikning_1_N = mkN "tillspikning" ; -- tillspikning..nn.1
  tillspilloge_1_V = mkV "tillspillogiva" "tillspillogav" "tillspillogivit" ; -- tillspilloge..vb.1
  tillspillogivande_1_N = mkN "tillspillogivande" ; -- tillspillogivande..nn.1
  tillspillogiven_1_A = mkA "tillspillogiven" ; -- tillspillogiven..av.1
  tillspillogivning_1_N = mkN "tillspillogivning" ; -- tillspillogivning..nn.1
  tillstoppning_1_N = mkN "tillstoppning" ; -- tillstoppning..nn.1
  tillströmma_1_V = mkV "tillströmmar" ; -- tillströmma..vb.1
  tillströmmande_1_N = mkN "tillströmmande" ; -- tillströmmande..nn.1
  tillströmning_1_N = mkN "tillströmning" ; -- tillströmning..nn.1
  tillstukad_1_A = mkA "tillstukad" ; -- tillstukad..av.1
  tillstunda_1_V = mkV "tillstundar" ; -- tillstunda..vb.1
  tillstundande_1_N = mkN "tillstundande" ; -- tillstundande..nn.1
  tillstymmelse_1_N = mkN "tillstymmelse" "tillstymmelser" ; -- tillstymmelse..nn.1
  tillstyrka_1_V = mkV "tillstyrker" ; -- tillstyrka..vb.1
  tillstyrkande_1_N = mkN "tillstyrkande" ; -- tillstyrkande..nn.1
  tillstädes_1_Adv = mkAdv "tillstädes" ; -- tillstädes..ab.1
  tillstädesvarande_1_A = mkA "tillstädesvarande" ; -- tillstädesvarande..av.1
  tillstädja_1_V = mkV "tillstädja" "tillstäder" "tillstäd" "tillstadde" "tillstatt" "tillstadd" ; -- tillstädja..vb.1
  tillstädjande_1_N = mkN "tillstädjande" ; -- tillstädjande..nn.1
  tillställa_1_V = mkV "tillställer" ; -- tillställa..vb.1
  tillställande_1_N = mkN "tillställande" ; -- tillställande..nn.1
  tillställare_1_N = mkN "tillställare" utrum  ; -- tillställare..nn.1
  tillställning_1_N = mkN "tillställning" ; -- tillställning..nn.1
  tillständig_1_A = mkA "tillständig" ; -- tillständig..av.1
  tillständighet_1_N = mkN "tillständighet" ; -- tillständighet..nn.1
  tillstängning_1_N = mkN "tillstängning" ; -- tillstängning..nn.1
  tillstå_1_V = mkV "tillstå" "tillstod" "tillstått" ; -- tillstå..vb.1
  tillstående_1_N = mkN "tillstående" ; -- tillstående..nn.1
  tillstånd_1_N = mkN "tillstånd" neutrum  ; -- tillstånd..nn.1
  tillståndsbevis_1_N = mkN "tillståndsbevis" neutrum  ; -- tillståndsbevis..nn.1
  tillståndsgivande_1_A = mkA "tillståndsgivande" ; -- tillståndsgivande..av.1
  tillstöta_1_V = mkV "tillstöter" ; -- tillstöta..vb.1
  tillstötande_1_N = mkN "tillstötande" ; -- tillstötande..nn.1
  tillsvarvning_1_N = mkN "tillsvarvning" ; -- tillsvarvning..nn.1
  tillsvidareförordnande_1_N = mkN "tillsvidareförordnande" ; -- tillsvidareförordnande..nn.1
  tillsyn_1_N = mkN "tillsyn" ; -- tillsyn..nn.1
  tillsynes_1_Adv = mkAdv "tillsynes" ; -- tillsynes..ab.1
  tillsyningsman_1_N = mkN "tillsyningsman" "tillsyningsmannen" "tillsyningsmän" "tillsyningsmännen" ; -- tillsyningsman..nn.1
  tillsynsansvar_1_N = mkN "tillsynsansvar" neutrum  ; -- tillsynsansvar..nn.1
  tillsynslärare_1_N = mkN "tillsynslärare" utrum  ; -- tillsynslärare..nn.1
  tillsynsman_1_N = mkN "tillsynsman" "tillsynsmannen" "tillsynsmän" "tillsynsmännen" ; -- tillsynsman..nn.1
  tillsynsmyndighet_1_N = mkN "tillsynsmyndighet" "tillsynsmyndigheter" ; -- tillsynsmyndighet..nn.1
  tillsäga_1_V = mkV "tillsäga" "tillsade" "tillsagt" ; -- tillsäga..vb.1
  tillsägande_1_N = mkN "tillsägande" ; -- tillsägande..nn.1
  tillsägelse_1_N = mkN "tillsägelse" "tillsägelser" ; -- tillsägelse..nn.1
  tillsägning_1_N = mkN "tillsägning" ; -- tillsägning..nn.1
  tillsända_1_V = mkV "tillsänder" ; -- tillsända..vb.1
  tillsändande_1_N = mkN "tillsändande" ; -- tillsändande..nn.1
  tillsändning_1_N = mkN "tillsändning" ; -- tillsändning..nn.1
  tillsätta_1_V = mkV "tillsätta" "tillsätter" "tillsätt" "tillsatte" "tillsatt" "tillsatt" ; -- tillsätta..vb.1
  tillsättande_1_N = mkN "tillsättande" ; -- tillsättande..nn.1
  tillsättning_1_N = mkN "tillsättning" ; -- tillsättning..nn.1
  tillsättningsärende_1_N = mkN "tillsättningsärende" ; -- tillsättningsärende..nn.1
  tillta_1_V = mkV "tilltaga" "tilltog" "tilltagit" ; -- tillta..vb.1
  tilltag_1_N = mkN "tilltag" neutrum  ; -- tilltag..nn.1
  tilltagande_1_A = mkA "tilltagande" ; -- tilltagande..av.1
  tilltagande_1_N = mkN "tilltagande" ; -- tilltagande..nn.1
  tilltagen_1_A = mkA "tilltagen" ; -- tilltagen..av.1
  tilltagsen_1_A = mkA "tilltagsen" ; -- tilltagsen..av.1
  tilltagsenhet_1_N = mkN "tilltagsenhet" ; -- tilltagsenhet..nn.1
  tilltal_1_N = mkN "tilltal" neutrum  ; -- tilltal..nn.1
  tilltala_1_V = mkV "tilltalar" ; -- tilltala..vb.1
  tilltalande_1_A = mkA "tilltalande" ; -- tilltalande..av.1
  tilltalande_1_N = mkN "tilltalande" ; -- tilltalande..nn.1
  tilltalsform_1_N = mkN "tilltalsform" "tilltalsformer" ; -- tilltalsform..nn.1
  tilltalsnamn_1_N = mkN "tilltalsnamn" neutrum  ; -- tilltalsnamn..nn.1
  tilltalsord_1_N = mkN "tilltalsord" neutrum  ; -- tilltalsord..nn.1
  tilltrampning_1_N = mkN "tilltrampning" ; -- tilltrampning..nn.1
  tilltrasslad_1_A = mkA "tilltrasslad" ; -- tilltrasslad..av.1
  tilltrassling_1_N = mkN "tilltrassling" ; -- tilltrassling..nn.1
  tilltro_1_N = mkN "tilltro" ; -- tilltro..nn.1
  tilltro_1_V = mkV "tilltror" ; -- tilltro..vb.1
  tilltroende_1_N = mkN "tilltroende" ; -- tilltroende..nn.1
  tilltryckning_1_N = mkN "tilltryckning" ; -- tilltryckning..nn.1
  tillträda_1_V = mkV "tillträda" "tillträdde" "tillträtt" ; -- tillträda..vb.1
  tillträdande_1_N = mkN "tillträdande" ; -- tillträdande..nn.1
  tillträdare_1_N = mkN "tillträdare" utrum  ; -- tillträdare..nn.1
  tillträde_1_N = mkN "tillträde" ; -- tillträde..nn.1
  tilltufsad_1_A = mkA "tilltufsad" ; -- tilltufsad..av.1
  tilltufsning_1_N = mkN "tilltufsning" ; -- tilltufsning..nn.1
  tilltugg_1_N = mkN "tilltugg" neutrum  ; -- tilltugg..nn.1
  tilltvålning_1_N = mkN "tilltvålning" ; -- tilltvålning..nn.1
  tilltyga_1_V = mkV "tilltygar" ; -- tilltyga..vb.1
  tilltygande_1_N = mkN "tilltygande" ; -- tilltygande..nn.1
  tilltäckning_1_N = mkN "tilltäckning" ; -- tilltäckning..nn.1
  tilltänkt_1_A = mkA "tilltänkt" "tilltänkt" ; -- tilltänkt..av.1
  tilltänkthet_1_N = mkN "tilltänkthet" ; -- tilltänkthet..nn.1
  tilltäppa_1_V = mkV "tilltäpper" ; -- tilltäppa..vb.1
  tilltäppande_1_N = mkN "tilltäppande" ; -- tilltäppande..nn.1
  tilltäppning_1_N = mkN "tilltäppning" ; -- tilltäppning..nn.1
  tilltäppt_1_A = mkA "tilltäppt" "tilltäppt" ; -- tilltäppt..av.1
  tilluft_1_N = mkN "tilluft" ; -- tilluft..nn.1
  tillval_1_N = mkN "tillval" neutrum  ; -- tillval..nn.1
  tillvalsämne_1_N = mkN "tillvalsämne" ; -- tillvalsämne..nn.1
  tillvand_1_A = mkA "tillvand" ; -- tillvand..av.1
  tillvandhet_1_N = mkN "tillvandhet" ; -- tillvandhet..nn.1
  tillvarata_1_V = mkV "tillvarataga" "tillvaratog" "tillvaratagit" ; -- tillvarata..vb.1
  tillvaratagande_1_N = mkN "tillvaratagande" ; -- tillvaratagande..nn.1
  tillvaro_1_N = mkN "tillvaro" ; -- tillvaro..nn.1
  tillverka_1_V = mkV "tillverkar" ; -- tillverka..vb.1
  tillverkande_1_N = mkN "tillverkande" ; -- tillverkande..nn.1
  tillverkare_1_N = mkN "tillverkare" utrum  ; -- tillverkare..nn.1
  tillverkning_1_N = mkN "tillverkning" ; -- tillverkning..nn.1
  tillverkningsindustri_1_N = mkN "tillverkningsindustri" "tillverkningsindustrier" ; -- tillverkningsindustri..nn.1
  tillverkningskostnad_1_N = mkN "tillverkningskostnad" "tillverkningskostnader" ; -- tillverkningskostnad..nn.1
  tillverkningsprocess_1_N = mkN "tillverkningsprocess" "tillverkningsprocesser" ; -- tillverkningsprocess..nn.1
  tillverkningsserie_1_N = mkN "tillverkningsserie" "tillverkningsserier" ; -- tillverkningsserie..nn.1
  tillverkningsutrustning_1_N = mkN "tillverkningsutrustning" ; -- tillverkningsutrustning..nn.1
  tillverkningsår_1_N = mkN "tillverkningsår" neutrum  ; -- tillverkningsår..nn.1
  tillvita_1_V = mkV "tillvitar" ; -- tillvita..vb.1
  tillvitande_1_N = mkN "tillvitande" ; -- tillvitande..nn.1
  tillvitelse_1_N = mkN "tillvitelse" "tillvitelser" ; -- tillvitelse..nn.1
  tillvägabringa_1_V = mkV "tillvägabringar" ; -- tillvägabringa..vb.1
  tillvägabringande_1_N = mkN "tillvägabringande" ; -- tillvägabringande..nn.1
  tillvägagångssätt_1_N = mkN "tillvägagångssätt" neutrum  ; -- tillvägagångssätt..nn.1
  tillvägning_1_N = mkN "tillvägning" ; -- tillvägning..nn.1
  tillvänja_1_V = mkV "tillvänja" "tillvande" "tillvant" ; -- tillvänja..vb.1
  tillvänjande_1_N = mkN "tillvänjande" ; -- tillvänjande..nn.1
  tillvänjning_1_N = mkN "tillvänjning" ; -- tillvänjning..nn.1
  tillväxa_1_V = mkV "tillväxa" "tillväxer" "tillväxa" "tillväxte" "tillväxt" "tillvuxen" ; -- tillväxa..vb.1
  tillväxande_1_N = mkN "tillväxande" ; -- tillväxande..nn.1
  tillväxt_1_N = mkN "tillväxt" ; -- tillväxt..nn.1
  tillväxtbefrämjande_1_A = mkA "tillväxtbefrämjande" ; -- tillväxtbefrämjande..av.1
  tillväxtfanatiker_1_N = mkN "tillväxtfanatiker" "tillväxtfanatikern" "tillväxtfanatiker" "tillväxtfanatikerna" ; -- tillväxtfanatiker..nn.1
  tillväxtfrämjande_1_A = mkA "tillväxtfrämjande" ; -- tillväxtfrämjande..av.1
  tillväxtfråga_1_N = mkN "tillväxtfråga" ; -- tillväxtfråga..nn.1
  tillväxtförmåga_1_N = mkN "tillväxtförmåga" ; -- tillväxtförmåga..nn.1
  tillväxthastighet_1_N = mkN "tillväxthastighet" "tillväxthastigheter" ; -- tillväxthastighet..nn.1
  tillväxthormon_1_N = mkN "tillväxthormon" neutrum  ; -- tillväxthormon..nn.1
  tillväxtkontinent_1_N = mkN "tillväxtkontinent" "tillväxtkontinenter" ; -- tillväxtkontinent..nn.1
  tillväxtkritik_1_N = mkN "tillväxtkritik" ; -- tillväxtkritik..nn.1
  tillväxtkurva_1_N = mkN "tillväxtkurva" ; -- tillväxtkurva..nn.1
  tillväxtland_1_N = mkN "tillväxtland" "tillväxtlandet" "tillväxtländer" "tillväxtländerna" ; -- tillväxtland..nn.1
  tillväxtmodell_1_N = mkN "tillväxtmodell" "tillväxtmodeller" ; -- tillväxtmodell..nn.1
  tillväxtorienterad_1_A = mkA "tillväxtorienterad" ; -- tillväxtorienterad..av.1
  tillväxtpakt_1_N = mkN "tillväxtpakt" "tillväxtpakter" ; -- tillväxtpakt..nn.1
  tillväxtperiod_1_N = mkN "tillväxtperiod" "tillväxtperioder" ; -- tillväxtperiod..nn.1
  tillväxtpolitik_1_N = mkN "tillväxtpolitik" ; -- tillväxtpolitik..nn.1
  tillväxtpolitisk_1_A = mkA "tillväxtpolitisk" ; -- tillväxtpolitisk..av.1
  tillväxtprognos_1_N = mkN "tillväxtprognos" "tillväxtprognoser" ; -- tillväxtprognos..nn.1
  tillväxtstark_1_A = mkA "tillväxtstark" ; -- tillväxtstark..av.1
  tillväxtstyrka_1_N = mkN "tillväxtstyrka" ; -- tillväxtstyrka..nn.1
  tillväxttakt_1_N = mkN "tillväxttakt" ; -- tillväxttakt..nn.1
  tillväxtutsikt_1_N = mkN "tillväxtutsikt" "tillväxtutsikter" ; -- tillväxtutsikt..nn.1
  tillväxtämne_1_N = mkN "tillväxtämne" ; -- tillväxtämne..nn.1
  tillyxa_1_V = mkV "tillyxar" ; -- tillyxa..vb.1
  tillyxad_1_A = mkA "tillyxad" ; -- tillyxad..av.1
  tillyxande_1_N = mkN "tillyxande" ; -- tillyxande..nn.1
  tillyxning_1_N = mkN "tillyxning" ; -- tillyxning..nn.1
  tillägg_1_N = mkN "tillägg" neutrum  ; -- tillägg..nn.1
  tillägga_1_V = mkV "tillägga" "tilla" "tillagt" ; -- tillägga..vb.1
  tilläggande_1_N = mkN "tilläggande" ; -- tilläggande..nn.1
  tilläggsbelopp_1_N = mkN "tilläggsbelopp" neutrum  ; -- tilläggsbelopp..nn.1
  tilläggskostnad_1_N = mkN "tilläggskostnad" "tilläggskostnader" ; -- tilläggskostnad..nn.1
  tilläggsmandat_1_N = mkN "tilläggsmandat" neutrum  ; -- tilläggsmandat..nn.1
  tilläggspension_1_N = mkN "tilläggspension" ; -- tilläggspension..nn.1
  tilläggsplats_1_N = mkN "tilläggsplats" "tilläggsplatser" ; -- tilläggsplats..nn.1
  tilläggsstat_1_N = mkN "tilläggsstat" ; -- tilläggsstat..nn.1
  tillägna_1_V = mkV "tillägnar" ; -- tillägna..vb.1
  tillägnande_1_N = mkN "tillägnande" ; -- tillägnande..nn.1
  tillägnelse_1_N = mkN "tillägnelse" utrum  ; -- tillägnelse..nn.1
  tillämna_1_V = mkV "tillämnar" ; -- tillämna..vb.1
  tillämnande_1_N = mkN "tillämnande" ; -- tillämnande..nn.1
  tillämpa_1_V = mkV "tillämpar" ; -- tillämpa..vb.1
  tillämpad_1_A = mkA "tillämpad" ; -- tillämpad..av.1
  tillämpande_1_N = mkN "tillämpande" ; -- tillämpande..nn.1
  tillämpbar_1_A = mkA "tillämpbar" ; -- tillämpbar..av.1
  tillämplig_1_A = mkA "tillämplig" ; -- tillämplig..av.1
  tillämplighet_1_N = mkN "tillämplighet" ; -- tillämplighet..nn.1
  tillämpning_1_N = mkN "tillämpning" ; -- tillämpning..nn.1
  tillämpningsföreskrift_1_N = mkN "tillämpningsföreskrift" "tillämpningsföreskrifter" ; -- tillämpningsföreskrift..nn.1
  tillämpningsområde_1_N = mkN "tillämpningsområde" ; -- tillämpningsområde..nn.1
  tilländalupen_1_A = mkA "tilländalupen" ; -- tilländalupen..av.1
  tilläventyrs_1_Adv = mkAdv "tilläventyrs" ; -- tilläventyrs..ab.1
  tillåta_1_V = mkV "tillåta" "tillät" "tillåtit" ; -- tillåta..vb.1
  tillåtande_1_N = mkN "tillåtande" ; -- tillåtande..nn.1
  tillåtelse_1_N = mkN "tillåtelse" utrum  ; -- tillåtelse..nn.1
  tillåten_1_A = mkA "tillåten" ; -- tillåten..av.1
  tillåtlig_1_A = mkA "tillåtlig" ; -- tillåtlig..av.1
  tillåtlighet_1_N = mkN "tillåtlighet" ; -- tillåtlighet..nn.1
  tillökning_1_N = mkN "tillökning" ; -- tillökning..nn.1
  tillönska_1_V = mkV "tillönskar" ; -- tillönska..vb.1
  tillönskande_1_N = mkN "tillönskande" ; -- tillönskande..nn.1
  tillönskning_1_N = mkN "tillönskning" ; -- tillönskning..nn.1
  tilt_1_N = mkN "tilt" ; -- tilt..nn.1
  tilt_2_N = mkN "tilt" ; -- tilt..nn.2
  tilta_1_N = mkN "tilta" ; -- tilta..nn.1
  tilta_1_V = mkV "tiltar" ; -- tilta..vb.1
  tiltande_1_N = mkN "tiltande" ; -- tiltande..nn.1
  tima_1_V = mkV "timar" ; -- tima..vb.1
  timande_1_N = mkN "timande" ; -- timande..nn.1
  timanställd_1_A = mkA "timanställd" "timanställt" ; -- timanställd..av.1
  timarvode_1_N = mkN "timarvode" ; -- timarvode..nn.1
  timaxel_1_N = mkN "timaxel" ; -- timaxel..nn.1
  timbal_1_N = mkN "timbal" "timbaler" ; -- timbal..nn.1
  timbre_1_N = mkN "timbre" utrum  ; -- timbre..nn.1
  timcirkel_1_N = mkN "timcirkel" ; -- timcirkel..nn.1
  timer_1_N = mkN "timer" ; -- timer..nn.1
  timglas_1_N = mkN "timglas" neutrum  ; -- timglas..nn.1
  timid_1_A = mkA "timid" ; -- timid..av.1
  timidhet_1_N = mkN "timidhet" "timidheter" ; -- timidhet..nn.1
  timiditet_1_N = mkN "timiditet" "timiditeter" ; -- timiditet..nn.1
  timing_1_N = mkN "timing" ; -- timing..nn.1
  timjan_1_N = mkN "timjan" ; -- timjan..nn.1
  timjandoftande_1_A = mkA "timjandoftande" ; -- timjandoftande..av.1
  timlig_1_A = mkA "timlig" ; -- timlig..av.1
  timlighet_1_N = mkN "timlighet" "timligheter" ; -- timlighet..nn.1
  timlärare_1_N = mkN "timlärare" utrum  ; -- timlärare..nn.1
  timlön_1_N = mkN "timlön" "timlöner" ; -- timlön..nn.1
  timma_1_N = mkN "timma" ; -- timma..nn.1
  timme_1_N = mkN "timme" utrum  ; -- timme..nn.1
  timmer_1_N = mkN "timmer" neutrum  ; -- timmer..nn.1
  timmeravlägg_1_N = mkN "timmeravlägg" neutrum  ; -- timmeravlägg..nn.1
  timmeravverkning_1_N = mkN "timmeravverkning" ; -- timmeravverkning..nn.1
  timmerblädning_1_N = mkN "timmerblädning" ; -- timmerblädning..nn.1
  timmerbröt_1_N = mkN "timmerbröt" ; -- timmerbröt..nn.1
  timmerdoning_1_N = mkN "timmerdoning" ; -- timmerdoning..nn.1
  timmerflotte_1_N = mkN "timmerflotte" utrum  ; -- timmerflotte..nn.1
  timmerflottning_1_N = mkN "timmerflottning" ; -- timmerflottning..nn.1
  timmerhus_1_N = mkN "timmerhus" neutrum  ; -- timmerhus..nn.1
  timmerkoja_1_N = mkN "timmerkoja" ; -- timmerkoja..nn.1
  timmerläns_1_N = mkN "timmerläns" ; -- timmerläns..nn.1
  timmerlänsa_1_N = mkN "timmerlänsa" ; -- timmerlänsa..nn.1
  timmermagasin_1_N = mkN "timmermagasin" neutrum  ; -- timmermagasin..nn.1
  timmerman_1_N = mkN "timmerman" "timmermannen" "timmermän" "timmermännen" ; -- timmerman..nn.1
  timmersax_1_N = mkN "timmersax" ; -- timmersax..nn.1
  timmersläp_1_N = mkN "timmersläp" neutrum  ; -- timmersläp..nn.1
  timmerstek_1_N = mkN "timmerstek" neutrum  ; -- timmerstek..nn.1
  timmerstock_1_N = mkN "timmerstock" ; -- timmerstock..nn.1
  timmersvans_1_N = mkN "timmersvans" ; -- timmersvans..nn.1
  timotej_1_N = mkN "timotej" ; -- timotej..nn.1
  timpenning_1_N = mkN "timpenning" ; -- timpenning..nn.1
  timra_1_V = mkV "timrar" ; -- timra..vb.1
  timrande_1_N = mkN "timrande" ; -- timrande..nn.1
  timslag_1_N = mkN "timslag" neutrum  ; -- timslag..nn.1
  timslång_1_A = mkA "timslång" ; -- timslång..av.1
  timtals_1_Adv = mkAdv "timtals" ; -- timtals..ab.1
  timvis_1_Adv = mkAdv "timvis" ; -- timvis..ab.1
  timvis_1_A = mkA "timvis" ; -- timvis..av.1
  timvisare_1_N = mkN "timvisare" utrum  ; -- timvisare..nn.1
  tina_1_N = mkN "tina" ; -- tina..nn.1
  tina_1_V = mkV "tinar" ; -- tina..vb.1
  tina_2_V = mkV "tinar" ; -- tina..vb.2
  tinande_1_N = mkN "tinande" ; -- tinande..nn.1
  tindra_1_V = mkV "tindrar" ; -- tindra..vb.1
  tindrande_1_N = mkN "tindrande" ; -- tindrande..nn.1
  ting_1_N = mkN "ting" neutrum  ; -- ting..nn.1
  ting_2_N = mkN "ting" neutrum  ; -- ting..nn.2
  tinga_1_V = mkV "tingar" ; -- tinga..vb.1
  tingande_1_N = mkN "tingande" ; -- tingande..nn.1
  tingeltangel_1_N = mkN "tingeltangel" neutrum  ; -- tingeltangel..nn.1
  tingest_1_N = mkN "tingest" ; -- tingest..nn.1
  tingord_1_N = mkN "tingord" neutrum  ; -- tingord..nn.1
  tingsfrid_1_N = mkN "tingsfrid" ; -- tingsfrid..nn.1
  tingshus_1_N = mkN "tingshus" neutrum  ; -- tingshus..nn.1
  tingslag_1_N = mkN "tingslag" neutrum  ; -- tingslag..nn.1
  tingsmeritering_1_N = mkN "tingsmeritering" ; -- tingsmeritering..nn.1
  tingsrätt_1_N = mkN "tingsrätt" "tingsrätter" ; -- tingsrätt..nn.1
  tingsrättspersonal_1_N = mkN "tingsrättspersonal" ; -- tingsrättspersonal..nn.1
  tingssal_1_N = mkN "tingssal" ; -- tingssal..nn.1
  tinktur_1_N = mkN "tinktur" "tinkturer" ; -- tinktur..nn.1
  tinne_1_N = mkN "tinne" utrum  ; -- tinne..nn.1
  tinner_1_N = mkN "tinner" ; -- tinner..nn.1
  tinning_1_N = mkN "tinning" ; -- tinning..nn.1
  tinningben_1_N = mkN "tinningben" neutrum  ; -- tinningben..nn.1
  tinninglob_1_N = mkN "tinninglob" "tinninglober" ; -- tinninglob..nn.1
  tiodubbel_1_A = mkA "tiodubbel" ; -- tiodubbel..av.1
  tiodubbla_1_V = mkV "tiodubblar" ; -- tiodubbla..vb.1
  tiodubblande_1_N = mkN "tiodubblande" ; -- tiodubblande..nn.1
  tiofaldig_1_A = mkA "tiofaldig" ; -- tiofaldig..av.1
  tiofaldiga_1_V = mkV "tiofaldigar" ; -- tiofaldiga..vb.1
  tiofaldigande_1_N = mkN "tiofaldigande" ; -- tiofaldigande..nn.1
  tiofoting_1_N = mkN "tiofoting" ; -- tiofoting..nn.1
  tiogradig_1_A = mkA "tiogradig" ; -- tiogradig..av.1
  tiohundratal_1_N = mkN "tiohundratal" neutrum  ; -- tiohundratal..nn.1
  tiokamp_1_N = mkN "tiokamp" "tiokamper" ; -- tiokamp..nn.1
  tiokrona_1_N = mkN "tiokrona" ; -- tiokrona..nn.1
  tiokronorsmynt_1_N = mkN "tiokronorsmynt" neutrum  ; -- tiokronorsmynt..nn.1
  tiokronorssedel_1_N = mkN "tiokronorssedel" ; -- tiokronorssedel..nn.1
  tiomila_1_A = mkA "tiomila" ; -- tiomila..av.1
  tiominutersrast_1_N = mkN "tiominutersrast" "tiominutersraster" ; -- tiominutersrast..nn.1
  tionde_1_A = mkA "tionde" ; -- tionde..av.1
  tionde_1_N = mkN "tionde" ; -- tionde..nn.1
  tiondedel_1_N = mkN "tiondedel" "tiondedelen" "tiondedelar" "tiondedelarna" ; -- tiondedel..nn.1
  tiondel_1_N = mkN "tiondel" "tiondelen" "tiondelar" "tiondelarna" ; -- tiondel..nn.1
  tioprocentig_1_A = mkA "tioprocentig" ; -- tioprocentig..av.1
  tiosyra_1_N = mkN "tiosyra" ; -- tiosyra..nn.1
  tiotal_1_N = mkN "tiotal" neutrum  ; -- tiotal..nn.1
  tiotalism_1_N = mkN "tiotalism" "tiotalismer" ; -- tiotalism..nn.1
  tiotalist_1_N = mkN "tiotalist" "tiotalister" ; -- tiotalist..nn.1
  tiotusende_1_A = mkA "tiotusende" ; -- tiotusende..av.1
  tiotusental_1_N = mkN "tiotusental" neutrum  ; -- tiotusental..nn.1
  tioårig_1_A = mkA "tioårig" ; -- tioårig..av.1
  tioåring_1_N = mkN "tioåring" ; -- tioåring..nn.1
  tioårsperiod_1_N = mkN "tioårsperiod" "tioårsperioder" ; -- tioårsperiod..nn.1
  tioöring_1_N = mkN "tioöring" ; -- tioöring..nn.1
  tipp_1_N = mkN "tipp" ; -- tipp..nn.1
  tippa_1_V = mkV "tippar" ; -- tippa..vb.1
  tippa_2_V = mkV "tippar" ; -- tippa..vb.2
  tippande_1_N = mkN "tippande" ; -- tippande..nn.1
  tippare_1_N = mkN "tippare" utrum  ; -- tippare..nn.1
  tippflak_1_N = mkN "tippflak" neutrum  ; -- tippflak..nn.1
  tippskydd_1_N = mkN "tippskydd" neutrum  ; -- tippskydd..nn.1
  tipptopp_1_A = mkA "tipptopp" ; -- tipptopp..av.1
  tippvagn_1_N = mkN "tippvagn" ; -- tippvagn..nn.1
  tips_1_N = mkN "tips" neutrum  ; -- tips..nn.1
  tipsa_1_V = mkV "tipsar" ; -- tipsa..vb.1
  tipsande_1_N = mkN "tipsande" ; -- tipsande..nn.1
  tipskupong_1_N = mkN "tipskupong" "tipskuponger" ; -- tipskupong..nn.1
  tipspromenad_1_N = mkN "tipspromenad" "tipspromenader" ; -- tipspromenad..nn.1
  tipsrad_1_N = mkN "tipsrad" "tipsrader" ; -- tipsrad..nn.1
  tipsrunda_1_N = mkN "tipsrunda" ; -- tipsrunda..nn.1
  tipstjänst_1_N = mkN "tipstjänst" ; -- tipstjänst..nn.1
  tipstävling_1_N = mkN "tipstävling" ; -- tipstävling..nn.1
  tiptop_1_A = mkA "tiptop" ; -- tiptop..av.1
  tir_1_N = mkN "tir" ; -- tir..nn.1
  tira_1_V = mkV "tirar" ; -- tira..vb.1
  tirad_1_N = mkN "tirad" "tirader" ; -- tirad..nn.1
  tirande_1_N = mkN "tirande" ; -- tirande..nn.1
  tischa_1_N = mkN "tischa" ; -- tischa..nn.1
  tisdag_1_N = mkN "tisdag" ; -- tisdag..nn.1
  tisdageftermiddag_1_N = mkN "tisdageftermiddag" ; -- tisdageftermiddag..nn.1
  tisdagkväll_1_N = mkN "tisdagkväll" ; -- tisdagkväll..nn.1
  tisdagmorgon_1_N = mkN "tisdagmorgon" "tisdagmorgonen" "tisdagmornar" "tisdagmornarna" ; -- tisdagmorgon..nn.1
  tisdagseftermiddag_1_N = mkN "tisdagseftermiddag" ; -- tisdagseftermiddag..nn.1
  tisdagskväll_1_N = mkN "tisdagskväll" ; -- tisdagskväll..nn.1
  tisdagsmorgon_1_N = mkN "tisdagsmorgon" "tisdagsmorgonen" "tisdagsmornar" "tisdagsmornarna" ; -- tisdagsmorgon..nn.1
  tisdagssoppa_1_N = mkN "tisdagssoppa" ; -- tisdagssoppa..nn.1
  tisha_1_N = mkN "tisha" ; -- tisha..nn.1
  tissel_1_N = mkN "tissel" neutrum  ; -- tissel..nn.1
  tissla_1_V = mkV "tisslar" ; -- tissla..vb.1
  tisslande_1_N = mkN "tisslande" ; -- tisslande..nn.1
  tisslare_1_N = mkN "tisslare" utrum  ; -- tisslare..nn.1
  tistel_1_N = mkN "tistel" ; -- tistel..nn.1
  tistelborre_1_N = mkN "tistelborre" utrum  ; -- tistelborre..nn.1
  tistelstång_1_N = mkN "tistelstång" "tistelstänger" ; -- tistelstång..nn.1
  tistron_1_N = mkN "tistron" neutrum  ; -- tistron..nn.1
  tita_1_N = mkN "tita" ; -- tita..nn.1
  titan_1_N = mkN "titan" "titaner" ; -- titan..nn.1
  titan_2_N = mkN "titan" ; -- titan..nn.2
  titanisk_1_A = mkA "titanisk" ; -- titanisk..av.1
  titanskruv_1_N = mkN "titanskruv" ; -- titanskruv..nn.1
  titanvitt_1_N = mkN "titanvitt" ; -- titanvitt..nn.1
  titel_1_N = mkN "titel" ; -- titel..nn.1
  titelblad_1_N = mkN "titelblad" neutrum  ; -- titelblad..nn.1
  titelbortläggning_1_N = mkN "titelbortläggning" ; -- titelbortläggning..nn.1
  titeldikt_1_N = mkN "titeldikt" "titeldikter" ; -- titeldikt..nn.1
  titelförsvarare_1_N = mkN "titelförsvarare" utrum  ; -- titelförsvarare..nn.1
  titelmatch_1_N = mkN "titelmatch" "titelmatcher" ; -- titelmatch..nn.1
  titelnovell_1_N = mkN "titelnovell" "titelnoveller" ; -- titelnovell..nn.1
  titelroll_1_N = mkN "titelroll" "titelroller" ; -- titelroll..nn.1
  titelsida_1_N = mkN "titelsida" ; -- titelsida..nn.1
  titelsjuk_1_A = mkA "titelsjuk" ; -- titelsjuk..av.1
  titelsjuka_1_N = mkN "titelsjuka" ; -- titelsjuka..nn.1
  titelsjukhet_1_N = mkN "titelsjukhet" ; -- titelsjukhet..nn.1
  titrera_1_V = mkV "titrerar" ; -- titrera..vb.1
  titrerande_1_N = mkN "titrerande" ; -- titrerande..nn.1
  titrerbar_1_A = mkA "titrerbar" ; -- titrerbar..av.1
  titrerbarhet_1_N = mkN "titrerbarhet" ; -- titrerbarhet..nn.1
  titrering_1_N = mkN "titrering" ; -- titrering..nn.1
  titt_1_N = mkN "titt" ; -- titt..nn.1
  titta_1_V = mkV "tittar" ; -- titta..vb.1
  tittande_1_N = mkN "tittande" ; -- tittande..nn.1
  tittare_1_N = mkN "tittare" utrum  ; -- tittare..nn.1
  tittarflopp_1_N = mkN "tittarflopp" ; -- tittarflopp..nn.1
  tittarframgång_1_N = mkN "tittarframgång" ; -- tittarframgång..nn.1
  tittarmässig_1_A = mkA "tittarmässig" ; -- tittarmässig..av.1
  tittarsiffra_1_N = mkN "tittarsiffra" ; -- tittarsiffra..nn.1
  tittarstorm_1_N = mkN "tittarstorm" ; -- tittarstorm..nn.1
  tittarsuccé_1_N = mkN "tittarsuccé" "tittarsuccéer" ; -- tittarsuccé..nn.1
  tittartävling_1_N = mkN "tittartävling" ; -- tittartävling..nn.1
  tittglugg_1_N = mkN "tittglugg" ; -- tittglugg..nn.1
  titthål_1_N = mkN "titthål" neutrum  ; -- titthål..nn.1
  titthålskirurgi_1_N = mkN "titthålskirurgi" ; -- titthålskirurgi..nn.1
  titthålsoperation_1_N = mkN "titthålsoperation" ; -- titthålsoperation..nn.1
  tittskåp_1_N = mkN "tittskåp" neutrum  ; -- tittskåp..nn.1
  tittsomtätt_1_Adv = mkAdv "tittsomtätt" ; -- tittsomtätt..ab.1
  tittut_1_N = mkN "tittut" ; -- tittut..nn.1
  titulatur_1_N = mkN "titulatur" "titulaturer" ; -- titulatur..nn.1
  titulera_1_V = mkV "titulerar" ; -- titulera..vb.1
  titulerande_1_N = mkN "titulerande" ; -- titulerande..nn.1
  titulerbar_1_A = mkA "titulerbar" ; -- titulerbar..av.1
  titulerbarhet_1_N = mkN "titulerbarhet" ; -- titulerbarhet..nn.1
  titulering_1_N = mkN "titulering" ; -- titulering..nn.1
  titulärkonsul_1_N = mkN "titulärkonsul" "titulärkonsuln" "titulärkonsuler" "titulärkonsulerna" ; -- titulärkonsul..nn.1
  tivoli_1_N = mkN "tivoli" "tivolit" "tivolin" "tivolina" ; -- tivoli..nn.1
  tixotrop_1_A = mkA "tixotrop" ; -- tixotrop..av.1
  tjack_1_N = mkN "tjack" neutrum  ; -- tjack..nn.1
  tjacka_1_V = mkV "tjackar" ; -- tjacka..vb.1
  tjackande_1_N = mkN "tjackande" ; -- tjackande..nn.1
  tjackpundare_1_N = mkN "tjackpundare" utrum  ; -- tjackpundare..nn.1
  tjafs_1_N = mkN "tjafs" neutrum  ; -- tjafs..nn.1
  tjafsa_1_V = mkV "tjafsar" ; -- tjafsa..vb.1
  tjafsande_1_N = mkN "tjafsande" ; -- tjafsande..nn.1
  tjafsig_1_A = mkA "tjafsig" ; -- tjafsig..av.1
  tjafsighet_1_N = mkN "tjafsighet" ; -- tjafsighet..nn.1
  tjalk_1_N = mkN "tjalk" ; -- tjalk..nn.1
  tjall_1_N = mkN "tjall" neutrum  ; -- tjall..nn.1
  tjalla_1_V = mkV "tjallar" ; -- tjalla..vb.1
  tjallande_1_N = mkN "tjallande" ; -- tjallande..nn.1
  tjallare_1_N = mkN "tjallare" utrum  ; -- tjallare..nn.1
  tjat_1_N = mkN "tjat" neutrum  ; -- tjat..nn.1
  tjata_1_V = mkV "tjatar" ; -- tjata..vb.1
  tjatande_1_N = mkN "tjatande" ; -- tjatande..nn.1
  tjatig_1_A = mkA "tjatig" ; -- tjatig..av.1
  tjatter_1_N = mkN "tjatter" neutrum  ; -- tjatter..nn.1
  tjattra_1_V = mkV "tjattrar" ; -- tjattra..vb.1
  tjattrande_1_N = mkN "tjattrande" ; -- tjattrande..nn.1
  tjeck_1_N = mkN "tjeck" "tjecker" ; -- tjeck..nn.1
  tjeckisk_1_A = mkA "tjeckisk" ; -- tjeckisk..av.1
  tjeckiska_1_N = mkN "tjeckiska" ; -- tjeckiska..nn.1
  tjeckiska_2_N = mkN "tjeckiska" ; -- tjeckiska..nn.2
  tjeckoslovak_1_N = mkN "tjeckoslovak" "tjeckoslovaker" ; -- tjeckoslovak..nn.1
  tjeckoslovakisk_1_A = mkA "tjeckoslovakisk" ; -- tjeckoslovakisk..av.1
  tjeckoslovakiska_1_N = mkN "tjeckoslovakiska" ; -- tjeckoslovakiska..nn.1
  tjej_1_N = mkN "tjej" "tjejer" ; -- tjej..nn.1
  tjejbacill_1_N = mkN "tjejbacill" "tjejbaciller" ; -- tjejbacill..nn.1
  tjejig_1_A = mkA "tjejig" ; -- tjejig..av.1
  tjejkompis_1_N = mkN "tjejkompis" ; -- tjejkompis..nn.1
  tjejmagnet_1_N = mkN "tjejmagnet" "tjejmagneter" ; -- tjejmagnet..nn.1
  tjejslakt_1_N = mkN "tjejslakt" "tjejslakter" ; -- tjejslakt..nn.1
  tjeka_1_N = mkN "tjeka" ; -- tjeka..nn.1
  tjerkess_1_N = mkN "tjerkess" "tjerkesser" ; -- tjerkess..nn.1
  tjerkessiska_1_N = mkN "tjerkessiska" ; -- tjerkessiska..nn.1
  tjerkessiska_2_N = mkN "tjerkessiska" ; -- tjerkessiska..nn.2
  tjetjen_1_N = mkN "tjetjen" "tjetjener" ; -- tjetjen..nn.1
  tjetjensk_1_A = mkA "tjetjensk" ; -- tjetjensk..av.1
  tjetjenska_1_N = mkN "tjetjenska" ; -- tjetjenska..nn.1
  tjetjenska_2_N = mkN "tjetjenska" ; -- tjetjenska..nn.2
  tjilla_1_V = mkV "tjillar" ; -- tjilla..vb.1
  tjillande_1_N = mkN "tjillande" ; -- tjillande..nn.1
  tjimma_1_V = mkV "tjimmar" ; -- tjimma..vb.1
  tjimmande_1_N = mkN "tjimmande" ; -- tjimmande..nn.1
  tjinga_1_V = mkV "tjingar" ; -- tjinga..vb.1
  tjingande_1_N = mkN "tjingande" ; -- tjingande..nn.1
  tjirre_1_N = mkN "tjirre" utrum  ; -- tjirre..nn.1
  tjo_1_N = mkN "tjo" neutrum  ; -- tjo..nn.1
  tjoa_1_V = mkV "tjoar" ; -- tjoa..vb.1
  tjoande_1_N = mkN "tjoande" ; -- tjoande..nn.1
  tjock_1_A = mkA "tjock" ; -- tjock..av.1
  tjocka_1_N = mkN "tjocka" ; -- tjocka..nn.1
  tjockbottnad_1_A = mkA "tjockbottnad" ; -- tjockbottnad..av.1
  tjockflytande_1_A = mkA "tjockflytande" ; -- tjockflytande..av.1
  tjockhet_1_N = mkN "tjockhet" ; -- tjockhet..nn.1
  tjockhudad_1_A = mkA "tjockhudad" ; -- tjockhudad..av.1
  tjockhuding_1_N = mkN "tjockhuding" ; -- tjockhuding..nn.1
  tjockis_1_N = mkN "tjockis" ; -- tjockis..nn.1
  tjocklek_1_N = mkN "tjocklek" ; -- tjocklek..nn.1
  tjockmagad_1_A = mkA "tjockmagad" ; -- tjockmagad..av.1
  tjockmjölk_1_N = mkN "tjockmjölk" ; -- tjockmjölk..nn.1
  tjockna_1_V = mkV "tjocknar" ; -- tjockna..vb.1
  tjocknande_1_N = mkN "tjocknande" ; -- tjocknande..nn.1
  tjockolja_1_N = mkN "tjockolja" ; -- tjockolja..nn.1
  tjockskalle_1_N = mkN "tjockskalle" utrum  ; -- tjockskalle..nn.1
  tjockskallig_1_A = mkA "tjockskallig" ; -- tjockskallig..av.1
  tjockskallighet_1_N = mkN "tjockskallighet" "tjockskalligheter" ; -- tjockskallighet..nn.1
  tjocktarm_1_N = mkN "tjocktarm" ; -- tjocktarm..nn.1
  tjocktarmstumör_1_N = mkN "tjocktarmstumör" "tjocktarmstumörer" ; -- tjocktarmstumör..nn.1
  tjocktröja_1_N = mkN "tjocktröja" ; -- tjocktröja..nn.1
  tjog_1_N = mkN "tjog" neutrum  ; -- tjog..nn.1
  tjogvis_1_Adv = mkAdv "tjogvis" ; -- tjogvis..ab.1
  tjomme_1_N = mkN "tjomme" utrum  ; -- tjomme..nn.1
  tjonga_1_V = mkV "tjongar" ; -- tjonga..vb.1
  tjongande_1_N = mkN "tjongande" ; -- tjongande..nn.1
  tjongare_1_N = mkN "tjongare" utrum  ; -- tjongare..nn.1
  tjorre_1_N = mkN "tjorre" utrum  ; -- tjorre..nn.1
  tjorva_1_V = mkV "tjorvar" ; -- tjorva..vb.1
  tjorvande_1_N = mkN "tjorvande" ; -- tjorvande..nn.1
  tjotaheiti_1_N = mkN "tjotaheiti" ; -- tjotaheiti..nn.1
  tjotahejti_1_N = mkN "tjotahejti" ; -- tjotahejti..nn.1
  tjottablängare_1_N = mkN "tjottablängare" utrum  ; -- tjottablängare..nn.1
  tjottaheiti_1_N = mkN "tjottaheiti" ; -- tjottaheiti..nn.1
  tjottahejti_1_N = mkN "tjottahejti" ; -- tjottahejti..nn.1
  tjuder_1_N = mkN "tjuder" neutrum  ; -- tjuder..nn.1
  tjudra_1_V = mkV "tjudrar" ; -- tjudra..vb.1
  tjudrande_1_N = mkN "tjudrande" ; -- tjudrande..nn.1
  tjuga_1_N = mkN "tjuga" ; -- tjuga..nn.1
  tjugoett_1_N = mkN "tjugoett" ; -- tjugoett..nn.1
  tjugoettårig_1_A = mkA "tjugoettårig" ; -- tjugoettårig..av.1
  tjugoettåring_1_N = mkN "tjugoettåring" ; -- tjugoettåring..nn.1
  tjugofaldig_1_A = mkA "tjugofaldig" ; -- tjugofaldig..av.1
  tjugofaldiga_1_V = mkV "tjugofaldigar" ; -- tjugofaldiga..vb.1
  tjugofaldigande_1_N = mkN "tjugofaldigande" ; -- tjugofaldigande..nn.1
  tjugofemte_1_A = mkA "tjugofemte" ; -- tjugofemte..av.1
  tjugofemårig_1_A = mkA "tjugofemårig" ; -- tjugofemårig..av.1
  tjugofemåring_1_N = mkN "tjugofemåring" ; -- tjugofemåring..nn.1
  tjugofemöring_1_N = mkN "tjugofemöring" ; -- tjugofemöring..nn.1
  tjugofjärde_1_A = mkA "tjugofjärde" ; -- tjugofjärde..av.1
  tjugofyraårig_1_A = mkA "tjugofyraårig" ; -- tjugofyraårig..av.1
  tjugofyraåring_1_N = mkN "tjugofyraåring" ; -- tjugofyraåring..nn.1
  tjugohundratal_1_N = mkN "tjugohundratal" neutrum  ; -- tjugohundratal..nn.1
  tjugokilossäck_1_N = mkN "tjugokilossäck" ; -- tjugokilossäck..nn.1
  tjugondag_1_N = mkN "tjugondag" ; -- tjugondag..nn.1
  tjugonde_1_A = mkA "tjugonde" ; -- tjugonde..av.1
  tjugondedag_1_N = mkN "tjugondedag" ; -- tjugondedag..nn.1
  tjugondedel_1_N = mkN "tjugondedel" "tjugondedelen" "tjugondedelar" "tjugondedelarna" ; -- tjugondedel..nn.1
  tjugondel_1_N = mkN "tjugondel" "tjugondelen" "tjugondelar" "tjugondelarna" ; -- tjugondel..nn.1
  tjugonionde_1_A = mkA "tjugonionde" ; -- tjugonionde..av.1
  tjugoplanig_1_A = mkA "tjugoplanig" ; -- tjugoplanig..av.1
  tjugosjunde_1_A = mkA "tjugosjunde" ; -- tjugosjunde..av.1
  tjugosjätte_1_A = mkA "tjugosjätte" ; -- tjugosjätte..av.1
  tjugotal_1_N = mkN "tjugotal" neutrum  ; -- tjugotal..nn.1
  tjugotredje_1_A = mkA "tjugotredje" ; -- tjugotredje..av.1
  tjugotreårig_1_A = mkA "tjugotreårig" ; -- tjugotreårig..av.1
  tjugotreåring_1_N = mkN "tjugotreåring" ; -- tjugotreåring..nn.1
  tjugotvåårig_1_A = mkA "tjugotvåårig" ; -- tjugotvåårig..av.1
  tjugotvååring_1_N = mkN "tjugotvååring" ; -- tjugotvååring..nn.1
  tjugoårig_1_A = mkA "tjugoårig" ; -- tjugoårig..av.1
  tjugoåring_1_N = mkN "tjugoåring" ; -- tjugoåring..nn.1
  tjugoåttaårsålder_1_N = mkN "tjugoåttaårsålder" ; -- tjugoåttaårsålder..nn.1
  tjugoåttonde_1_A = mkA "tjugoåttonde" ; -- tjugoåttonde..av.1
  tjugufemte_1_A = mkA "tjugufemte" ; -- tjugufemte..av.1
  tjugufemårig_1_A = mkA "tjugufemårig" ; -- tjugufemårig..av.1
  tjugufemåring_1_N = mkN "tjugufemåring" ; -- tjugufemåring..nn.1
  tjugufemöring_1_N = mkN "tjugufemöring" ; -- tjugufemöring..nn.1
  tjugufjärde_1_A = mkA "tjugufjärde" ; -- tjugufjärde..av.1
  tjugufyraårig_1_A = mkA "tjugufyraårig" ; -- tjugufyraårig..av.1
  tjugufyraåring_1_N = mkN "tjugufyraåring" ; -- tjugufyraåring..nn.1
  tjugunionde_1_A = mkA "tjugunionde" ; -- tjugunionde..av.1
  tjugusjunde_1_A = mkA "tjugusjunde" ; -- tjugusjunde..av.1
  tjugusjätte_1_A = mkA "tjugusjätte" ; -- tjugusjätte..av.1
  tjugutal_1_N = mkN "tjugutal" neutrum  ; -- tjugutal..nn.1
  tjugutredje_1_A = mkA "tjugutredje" ; -- tjugutredje..av.1
  tjugutreårig_1_A = mkA "tjugutreårig" ; -- tjugutreårig..av.1
  tjugutreåring_1_N = mkN "tjugutreåring" ; -- tjugutreåring..nn.1
  tjugutvåårig_1_A = mkA "tjugutvåårig" ; -- tjugutvåårig..av.1
  tjugutvååring_1_N = mkN "tjugutvååring" ; -- tjugutvååring..nn.1
  tjuguårig_1_A = mkA "tjuguårig" ; -- tjuguårig..av.1
  tjuguåring_1_N = mkN "tjuguåring" ; -- tjuguåring..nn.1
  tjuguåttaårsålder_1_N = mkN "tjuguåttaårsålder" ; -- tjuguåttaårsålder..nn.1
  tjuguåttonde_1_A = mkA "tjuguåttonde" ; -- tjuguåttonde..av.1
  tjur_1_N = mkN "tjur" ; -- tjur..nn.1
  tjura_1_V = mkV "tjurar" ; -- tjura..vb.1
  tjurande_1_N = mkN "tjurande" ; -- tjurande..nn.1
  tjurfäktare_1_N = mkN "tjurfäktare" utrum  ; -- tjurfäktare..nn.1
  tjurfäktning_1_N = mkN "tjurfäktning" ; -- tjurfäktning..nn.1
  tjurfäktningsförsvar_1_N = mkN "tjurfäktningsförsvar" neutrum  ; -- tjurfäktningsförsvar..nn.1
  tjurfäktningsmotståndare_1_N = mkN "tjurfäktningsmotståndare" utrum  ; -- tjurfäktningsmotståndare..nn.1
  tjurfäktningssäsong_1_N = mkN "tjurfäktningssäsong" "tjurfäktningssäsonger" ; -- tjurfäktningssäsong..nn.1
  tjurhuvud_1_N = mkN "tjurhuvud" "tjurhuvudet" "tjurhuvud" "tjurhuvudena" ; -- tjurhuvud..nn.1
  tjurig_1_A = mkA "tjurig" ; -- tjurig..av.1
  tjurighet_1_N = mkN "tjurighet" ; -- tjurighet..nn.1
  tjurnacke_1_N = mkN "tjurnacke" utrum  ; -- tjurnacke..nn.1
  tjurrusning_1_N = mkN "tjurrusning" ; -- tjurrusning..nn.1
  tjurskalle_1_N = mkN "tjurskalle" utrum  ; -- tjurskalle..nn.1
  tjurskallig_1_A = mkA "tjurskallig" ; -- tjurskallig..av.1
  tjurskallighet_1_N = mkN "tjurskallighet" "tjurskalligheter" ; -- tjurskallighet..nn.1
  tjurved_1_N = mkN "tjurved" ; -- tjurved..nn.1
  tjusa_1_V = mkV "tjusar" ; -- tjusa..vb.1
  tjusande_1_N = mkN "tjusande" ; -- tjusande..nn.1
  tjusare_1_N = mkN "tjusare" utrum  ; -- tjusare..nn.1
  tjusarlock_1_N = mkN "tjusarlock" ; -- tjusarlock..nn.1
  tjusig_1_A = mkA "tjusig" ; -- tjusig..av.1
  tjuskraft_1_N = mkN "tjuskraft" ; -- tjuskraft..nn.1
  tjusning_1_N = mkN "tjusning" ; -- tjusning..nn.1
  tjusningsförmåga_1_N = mkN "tjusningsförmåga" ; -- tjusningsförmåga..nn.1
  tjusningskraft_1_N = mkN "tjusningskraft" "tjusningskrafter" ; -- tjusningskraft..nn.1
  tjut_1_N = mkN "tjut" neutrum  ; -- tjut..nn.1
  tjuta_1_V = mkV "tjuta" "tjöt" "tjutit" ; -- tjuta..vb.1
  tjutande_1_N = mkN "tjutande" ; -- tjutande..nn.1
  tjutning_1_N = mkN "tjutning" ; -- tjutning..nn.1
  tjuv_1_N = mkN "tjuv" ; -- tjuv..nn.1
  tjuva_1_V = mkV "tjuvar" ; -- tjuva..vb.1
  tjuvaktig_1_A = mkA "tjuvaktig" ; -- tjuvaktig..av.1
  tjuvaktighet_1_N = mkN "tjuvaktighet" ; -- tjuvaktighet..nn.1
  tjuvalarm_1_N = mkN "tjuvalarm" neutrum  ; -- tjuvalarm..nn.1
  tjuvande_1_N = mkN "tjuvande" ; -- tjuvande..nn.1
  tjuvbagge_1_N = mkN "tjuvbagge" utrum  ; -- tjuvbagge..nn.1
  tjuveri_1_N = mkN "tjuveri" "tjuveriet" "tjuverier" "tjuverierna" ; -- tjuveri..nn.1
  tjuvfiska_1_V = mkV "tjuvfiskar" ; -- tjuvfiska..vb.1
  tjuvfiskande_1_N = mkN "tjuvfiskande" ; -- tjuvfiskande..nn.1
  tjuvfiskare_1_N = mkN "tjuvfiskare" utrum  ; -- tjuvfiskare..nn.1
  tjuvfiske_1_N = mkN "tjuvfiske" ; -- tjuvfiske..nn.1
  tjuvfiskning_1_N = mkN "tjuvfiskning" ; -- tjuvfiskning..nn.1
  tjuvgods_1_N = mkN "tjuvgods" neutrum  ; -- tjuvgods..nn.1
  tjuvgömma_1_N = mkN "tjuvgömma" ; -- tjuvgömma..nn.1
  tjuvgömmare_1_N = mkN "tjuvgömmare" utrum  ; -- tjuvgömmare..nn.1
  tjuvhugga_1_V = mkV "tjuvhugga" "tjuvhögg" "tjuvhuggit" ; -- tjuvhugga..vb.1
  tjuvhuggande_1_N = mkN "tjuvhuggande" ; -- tjuvhuggande..nn.1
  tjuvhuggning_1_N = mkN "tjuvhuggning" ; -- tjuvhuggning..nn.1
  tjuvhålla_1_V = mkV "tjuvhålla" "tjuvhöll" "tjuvhållit" ; -- tjuvhålla..vb.1
  tjuvhållande_1_N = mkN "tjuvhållande" ; -- tjuvhållande..nn.1
  tjuvjaga_1_V = mkV "tjuvjagar" ; -- tjuvjaga..vb.1
  tjuvjagande_1_N = mkN "tjuvjagande" ; -- tjuvjagande..nn.1
  tjuvjakt_1_N = mkN "tjuvjakt" ; -- tjuvjakt..nn.1
  tjuvjägare_1_N = mkN "tjuvjägare" utrum  ; -- tjuvjägare..nn.1
  tjuvkika_1_V = mkV "tjuvkikar" ; -- tjuvkika..vb.1
  tjuvkikande_1_N = mkN "tjuvkikande" ; -- tjuvkikande..nn.1
  tjuvkikning_1_N = mkN "tjuvkikning" ; -- tjuvkikning..nn.1
  tjuvknep_1_N = mkN "tjuvknep" neutrum  ; -- tjuvknep..nn.1
  tjuvkoppla_1_V = mkV "tjuvkopplar" ; -- tjuvkoppla..vb.1
  tjuvkopplande_1_N = mkN "tjuvkopplande" ; -- tjuvkopplande..nn.1
  tjuvlarm_1_N = mkN "tjuvlarm" neutrum  ; -- tjuvlarm..nn.1
  tjuvliga_1_N = mkN "tjuvliga" ; -- tjuvliga..nn.1
  tjuvlyssna_1_V = mkV "tjuvlyssnar" ; -- tjuvlyssna..vb.1
  tjuvlyssnande_1_N = mkN "tjuvlyssnande" ; -- tjuvlyssnande..nn.1
  tjuvlyssning_1_N = mkN "tjuvlyssning" ; -- tjuvlyssning..nn.1
  tjuvläsa_1_V = mkV "tjuvläser" ; -- tjuvläsa..vb.1
  tjuvläsande_1_N = mkN "tjuvläsande" ; -- tjuvläsande..nn.1
  tjuvläsning_1_N = mkN "tjuvläsning" ; -- tjuvläsning..nn.1
  tjuvmjölka_1_V = mkV "tjuvmjölkar" ; -- tjuvmjölka..vb.1
  tjuvmjölkande_1_N = mkN "tjuvmjölkande" ; -- tjuvmjölkande..nn.1
  tjuvnad_1_N = mkN "tjuvnad" "tjuvnader" ; -- tjuvnad..nn.1
  tjuvnyp_1_N = mkN "tjuvnyp" neutrum  ; -- tjuvnyp..nn.1
  tjuvpack_1_N = mkN "tjuvpack" neutrum  ; -- tjuvpack..nn.1
  tjuvpojkaktig_1_A = mkA "tjuvpojkaktig" ; -- tjuvpojkaktig..av.1
  tjuvpojke_1_N = mkN "tjuvpojke" utrum  ; -- tjuvpojke..nn.1
  tjuvpojksglimt_1_N = mkN "tjuvpojksglimt" ; -- tjuvpojksglimt..nn.1
  tjuvpojkstreck_1_N = mkN "tjuvpojkstreck" neutrum  ; -- tjuvpojkstreck..nn.1
  tjuvröka_1_V = mkV "tjuvröker" ; -- tjuvröka..vb.1
  tjuvrökande_1_N = mkN "tjuvrökande" ; -- tjuvrökande..nn.1
  tjuvrökning_1_N = mkN "tjuvrökning" ; -- tjuvrökning..nn.1
  tjuvsamhälle_1_N = mkN "tjuvsamhälle" ; -- tjuvsamhälle..nn.1
  tjuvsena_1_N = mkN "tjuvsena" ; -- tjuvsena..nn.1
  tjuvskytt_1_N = mkN "tjuvskytt" ; -- tjuvskytt..nn.1
  tjuvskytte_1_N = mkN "tjuvskytte" ; -- tjuvskytte..nn.1
  tjuvspråk_1_N = mkN "tjuvspråk" neutrum  ; -- tjuvspråk..nn.1
  tjuvstart_1_N = mkN "tjuvstart" "tjuvstarter" ; -- tjuvstart..nn.1
  tjuvstarta_1_V = mkV "tjuvstartar" ; -- tjuvstarta..vb.1
  tjuvstartande_1_N = mkN "tjuvstartande" ; -- tjuvstartande..nn.1
  tjuvstreck_1_N = mkN "tjuvstreck" neutrum  ; -- tjuvstreck..nn.1
  tjuvstryker_1_N = mkN "tjuvstryker" ; -- tjuvstryker..nn.1
  tjuvtankning_1_N = mkN "tjuvtankning" ; -- tjuvtankning..nn.1
  tjuvtitt_1_N = mkN "tjuvtitt" ; -- tjuvtitt..nn.1
  tjuvtitta_1_V = mkV "tjuvtittar" ; -- tjuvtitta..vb.1
  tjuvtittande_1_N = mkN "tjuvtittande" ; -- tjuvtittande..nn.1
  tjuvtittning_1_N = mkN "tjuvtittning" ; -- tjuvtittning..nn.1
  tjuvtjock_1_A = mkA "tjuvtjock" ; -- tjuvtjock..av.1
  tjuvtjockhet_1_N = mkN "tjuvtjockhet" ; -- tjuvtjockhet..nn.1
  tjuvtryck_1_N = mkN "tjuvtryck" neutrum  ; -- tjuvtryck..nn.1
  tjuvträna_1_V = mkV "tjuvtränar" ; -- tjuvträna..vb.1
  tjuvtränande_1_N = mkN "tjuvtränande" ; -- tjuvtränande..nn.1
  tjyv_1_N = mkN "tjyv" ; -- tjyv..nn.1
  tjyva_1_V = mkV "tjyvar" ; -- tjyva..vb.1
  tjyvaktig_1_A = mkA "tjyvaktig" ; -- tjyvaktig..av.1
  tjyvaktighet_1_N = mkN "tjyvaktighet" ; -- tjyvaktighet..nn.1
  tjyvande_1_N = mkN "tjyvande" ; -- tjyvande..nn.1
  tjyveri_1_N = mkN "tjyveri" "tjyveriet" "tjyverier" "tjyverierna" ; -- tjyveri..nn.1
  tjyvfiska_1_V = mkV "tjyvfiskar" ; -- tjyvfiska..vb.1
  tjyvfiskande_1_N = mkN "tjyvfiskande" ; -- tjyvfiskande..nn.1
  tjyvfiskare_1_N = mkN "tjyvfiskare" utrum  ; -- tjyvfiskare..nn.1
  tjyvfiske_1_N = mkN "tjyvfiske" ; -- tjyvfiske..nn.1
  tjyvhålla_1_V = mkV "tjyvhålla" "tjyvhöll" "tjyvhållit" ; -- tjyvhålla..vb.1
  tjyvhållande_1_N = mkN "tjyvhållande" ; -- tjyvhållande..nn.1
  tjyvjaga_1_V = mkV "tjyvjagar" ; -- tjyvjaga..vb.1
  tjyvjagande_1_N = mkN "tjyvjagande" ; -- tjyvjagande..nn.1
  tjyvjakt_1_N = mkN "tjyvjakt" ; -- tjyvjakt..nn.1
  tjyvjägare_1_N = mkN "tjyvjägare" utrum  ; -- tjyvjägare..nn.1
  tjyvkika_1_V = mkV "tjyvkikar" ; -- tjyvkika..vb.1
  tjyvkikande_1_N = mkN "tjyvkikande" ; -- tjyvkikande..nn.1
  tjyvkikning_1_N = mkN "tjyvkikning" ; -- tjyvkikning..nn.1
  tjyvknep_1_N = mkN "tjyvknep" neutrum  ; -- tjyvknep..nn.1
  tjyvkoppla_1_V = mkV "tjyvkopplar" ; -- tjyvkoppla..vb.1
  tjyvkopplande_1_N = mkN "tjyvkopplande" ; -- tjyvkopplande..nn.1
  tjyvlyssna_1_V = mkV "tjyvlyssnar" ; -- tjyvlyssna..vb.1
  tjyvlyssnande_1_N = mkN "tjyvlyssnande" ; -- tjyvlyssnande..nn.1
  tjyvlyssning_1_N = mkN "tjyvlyssning" ; -- tjyvlyssning..nn.1
  tjyvmjölka_1_V = mkV "tjyvmjölkar" ; -- tjyvmjölka..vb.1
  tjyvmjölkande_1_N = mkN "tjyvmjölkande" ; -- tjyvmjölkande..nn.1
  tjyvnyp_1_N = mkN "tjyvnyp" neutrum  ; -- tjyvnyp..nn.1
  tjyvröka_1_V = mkV "tjyvröker" ; -- tjyvröka..vb.1
  tjyvrökande_1_N = mkN "tjyvrökande" ; -- tjyvrökande..nn.1
  tjyvrökning_1_N = mkN "tjyvrökning" ; -- tjyvrökning..nn.1
  tjyvsamhälle_1_N = mkN "tjyvsamhälle" ; -- tjyvsamhälle..nn.1
  tjyvstart_1_N = mkN "tjyvstart" "tjyvstarter" ; -- tjyvstart..nn.1
  tjyvstarta_1_V = mkV "tjyvstartar" ; -- tjyvstarta..vb.1
  tjyvstartande_1_N = mkN "tjyvstartande" ; -- tjyvstartande..nn.1
  tjyvtankning_1_N = mkN "tjyvtankning" ; -- tjyvtankning..nn.1
  tjyvtitt_1_N = mkN "tjyvtitt" ; -- tjyvtitt..nn.1
  tjyvtitta_1_V = mkV "tjyvtittar" ; -- tjyvtitta..vb.1
  tjyvtittande_1_N = mkN "tjyvtittande" ; -- tjyvtittande..nn.1
  tjyvtittning_1_N = mkN "tjyvtittning" ; -- tjyvtittning..nn.1
  tjyvtjock_1_A = mkA "tjyvtjock" ; -- tjyvtjock..av.1
  tjyvtjockhet_1_N = mkN "tjyvtjockhet" ; -- tjyvtjockhet..nn.1
  tjäder_1_N = mkN "tjäder" ; -- tjäder..nn.1
  tjäderhöna_1_N = mkN "tjäderhöna" ; -- tjäderhöna..nn.1
  tjädertupp_1_N = mkN "tjädertupp" ; -- tjädertupp..nn.1
  tjäla_1_V = mkV "tjälar" ; -- tjäla..vb.1
  tjälande_1_N = mkN "tjälande" ; -- tjälande..nn.1
  tjäle_1_N = mkN "tjäle" utrum  ; -- tjäle..nn.1
  tjälfri_1_A = mkA "tjälfri" "tjälfritt" ; -- tjälfri..av.1
  tjälfrusen_1_A = mkA "tjälfrusen" ; -- tjälfrusen..av.1
  tjälknöl_1_N = mkN "tjälknöl" ; -- tjälknöl..nn.1
  tjäll_1_N = mkN "tjäll" neutrum  ; -- tjäll..nn.1
  tjällossning_1_N = mkN "tjällossning" ; -- tjällossning..nn.1
  tjälskott_1_N = mkN "tjälskott" neutrum  ; -- tjälskott..nn.1
  tjäna_1_V = mkV "tjänar" ; -- tjäna..vb.1
  tjänande_1_N = mkN "tjänande" ; -- tjänande..nn.1
  tjänare_1_N = mkN "tjänare" utrum  ; -- tjänare..nn.1
  tjänarinna_1_N = mkN "tjänarinna" ; -- tjänarinna..nn.1
  tjänis_1_A = mkA "tjänis" ; -- tjänis..av.1
  tjänlig_1_A = mkA "tjänlig" ; -- tjänlig..av.1
  tjänlighet_1_N = mkN "tjänlighet" ; -- tjänlighet..nn.1
  tjänst_1_N = mkN "tjänst" "tjänster" ; -- tjänst..nn.1
  tjänst_2_N = mkN "tjänst" "tjänster" ; -- tjänst..nn.2
  tjänstaktig_1_A = mkA "tjänstaktig" ; -- tjänstaktig..av.1
  tjänstaktighet_1_N = mkN "tjänstaktighet" ; -- tjänstaktighet..nn.1
  tjänstbar_1_A = mkA "tjänstbar" ; -- tjänstbar..av.1
  tjänstbarhet_1_N = mkN "tjänstbarhet" ; -- tjänstbarhet..nn.1
  tjänstduglig_1_A = mkA "tjänstduglig" ; -- tjänstduglig..av.1
  tjänstduglighet_1_N = mkN "tjänstduglighet" ; -- tjänstduglighet..nn.1
  tjänsteande_1_N = mkN "tjänsteande" utrum  ; -- tjänsteande..nn.1
  tjänsteavtal_1_N = mkN "tjänsteavtal" neutrum  ; -- tjänsteavtal..nn.1
  tjänstebil_1_N = mkN "tjänstebil" ; -- tjänstebil..nn.1
  tjänstebostad_1_N = mkN "tjänstebostad" "tjänstebostäder" ; -- tjänstebostad..nn.1
  tjänstebrev_1_N = mkN "tjänstebrev" neutrum  ; -- tjänstebrev..nn.1
  tjänstebrevsrätt_1_N = mkN "tjänstebrevsrätt" "tjänstebrevsrätter" ; -- tjänstebrevsrätt..nn.1
  tjänstefel_1_N = mkN "tjänstefel" "tjänstefelet" "tjänstefel" "tjänstefelen" ; -- tjänstefel..nn.1
  tjänsteflicka_1_N = mkN "tjänsteflicka" ; -- tjänsteflicka..nn.1
  tjänstefolk_1_N = mkN "tjänstefolk" neutrum  ; -- tjänstefolk..nn.1
  tjänsteförrättande_1_A = mkA "tjänsteförrättande" ; -- tjänsteförrättande..av.1
  tjänsteförrättare_1_N = mkN "tjänsteförrättare" utrum  ; -- tjänsteförrättare..nn.1
  tjänsteförrättning_1_N = mkN "tjänsteförrättning" ; -- tjänsteförrättning..nn.1
  tjänsteförseelse_1_N = mkN "tjänsteförseelse" "tjänsteförseelser" ; -- tjänsteförseelse..nn.1
  tjänsteförsändelse_1_N = mkN "tjänsteförsändelse" "tjänsteförsändelser" ; -- tjänsteförsändelse..nn.1
  tjänstegrad_1_N = mkN "tjänstegrad" "tjänstegrader" ; -- tjänstegrad..nn.1
  tjänstehjon_1_N = mkN "tjänstehjon" neutrum  ; -- tjänstehjon..nn.1
  tjänstekvinna_1_N = mkN "tjänstekvinna" ; -- tjänstekvinna..nn.1
  tjänsteman_1_N = mkN "tjänsteman" "tjänstemannen" "tjänstemän" "tjänstemännen" ; -- tjänsteman..nn.1
  tjänstemannamässig_1_A = mkA "tjänstemannamässig" ; -- tjänstemannamässig..av.1
  tjänstemannaorganisation_1_N = mkN "tjänstemannaorganisation" ; -- tjänstemannaorganisation..nn.1
  tjänstenit_1_N = mkN "tjänstenit" neutrum  ; -- tjänstenit..nn.1
  tjänstepension_1_N = mkN "tjänstepension" ; -- tjänstepension..nn.1
  tjänstepiga_1_N = mkN "tjänstepiga" ; -- tjänstepiga..nn.1
  tjänsteplikt_1_N = mkN "tjänsteplikt" ; -- tjänsteplikt..nn.1
  tjänsteresa_1_N = mkN "tjänsteresa" ; -- tjänsteresa..nn.1
  tjänsterum_1_N = mkN "tjänsterum" "tjänsterummet" "tjänsterum" "tjänsterummen" ; -- tjänsterum..nn.1
  tjänstesektor_1_N = mkN "tjänstesektor" "tjänstesektorer" ; -- tjänstesektor..nn.1
  tjänsteställning_1_N = mkN "tjänsteställning" ; -- tjänsteställning..nn.1
  tjänstetid_1_N = mkN "tjänstetid" "tjänstetider" ; -- tjänstetid..nn.1
  tjänstevapen_1_N = mkN "tjänstevapen" "tjänstevapnet" "tjänstevapen" "tjänstevapnen" ; -- tjänstevapen..nn.1
  tjänstevikt_1_N = mkN "tjänstevikt" ; -- tjänstevikt..nn.1
  tjänsteärende_1_N = mkN "tjänsteärende" ; -- tjänsteärende..nn.1
  tjänsteår_1_N = mkN "tjänsteår" neutrum  ; -- tjänsteår..nn.1
  tjänstfri_1_A = mkA "tjänstfri" "tjänstfritt" ; -- tjänstfri..av.1
  tjänstfrihet_1_N = mkN "tjänstfrihet" ; -- tjänstfrihet..nn.1
  tjänstgöra_1_V = mkV "tjänstgöra" "tjänstgjorde" "tjänstgjort" ; -- tjänstgöra..vb.1
  tjänstgörande_1_N = mkN "tjänstgörande" ; -- tjänstgörande..nn.1
  tjänstgöring_1_N = mkN "tjänstgöring" ; -- tjänstgöring..nn.1
  tjänstgöringsnummer_1_N = mkN "tjänstgöringsnummer" neutrum  ; -- tjänstgöringsnummer..nn.1
  tjänstledig_1_A = mkA "tjänstledig" ; -- tjänstledig..av.1
  tjänstledighet_1_N = mkN "tjänstledighet" "tjänstledigheter" ; -- tjänstledighet..nn.1
  tjänstvillig_1_A = mkA "tjänstvillig" ; -- tjänstvillig..av.1
  tjänstvillighet_1_N = mkN "tjänstvillighet" ; -- tjänstvillighet..nn.1
  tjära_1_N = mkN "tjära" ; -- tjära..nn.1
  tjära_1_V = mkV "tjärar" ; -- tjära..vb.1
  tjärande_1_N = mkN "tjärande" ; -- tjärande..nn.1
  tjärblomster_1_N = mkN "tjärblomster" neutrum  ; -- tjärblomster..nn.1
  tjärbloss_1_N = mkN "tjärbloss" neutrum  ; -- tjärbloss..nn.1
  tjärdal_1_N = mkN "tjärdal" ; -- tjärdal..nn.1
  tjärdrev_1_N = mkN "tjärdrev" neutrum  ; -- tjärdrev..nn.1
  tjärframställning_1_N = mkN "tjärframställning" ; -- tjärframställning..nn.1
  tjärig_1_A = mkA "tjärig" ; -- tjärig..av.1
  tjärimpregnering_1_N = mkN "tjärimpregnering" ; -- tjärimpregnering..nn.1
  tjärinnehållande_1_A = mkA "tjärinnehållande" ; -- tjärinnehållande..av.1
  tjärn_1_N = mkN "tjärn" ; -- tjärn..nn.1
  tjärpapp_1_N = mkN "tjärpapp" ; -- tjärpapp..nn.1
  tjärved_1_N = mkN "tjärved" ; -- tjärved..nn.1
  toa_1_N = mkN "toa" ; -- toa..nn.1
  toabesök_1_N = mkN "toabesök" neutrum  ; -- toabesök..nn.1
  toakö_1_N = mkN "toakö" "toakön" "toaköer" "toaköerna" ; -- toakö..nn.1
  toalett_1_N = mkN "toalett" "toaletter" ; -- toalett..nn.1
  toalettartikel_1_N = mkN "toalettartikel" ; -- toalettartikel..nn.1
  toalettbesök_1_N = mkN "toalettbesök" neutrum  ; -- toalettbesök..nn.1
  toalettbord_1_N = mkN "toalettbord" neutrum  ; -- toalettbord..nn.1
  toalettkö_1_N = mkN "toalettkö" "toalettkön" "toalettköer" "toalettköerna" ; -- toalettkö..nn.1
  toalettlock_1_N = mkN "toalettlock" neutrum  ; -- toalettlock..nn.1
  toalettpapper_1_N = mkN "toalettpapper" neutrum  ; -- toalettpapper..nn.1
  toalettring_1_N = mkN "toalettring" ; -- toalettring..nn.1
  toalettrulle_1_N = mkN "toalettrulle" utrum  ; -- toalettrulle..nn.1
  toalettsits_1_N = mkN "toalettsits" ; -- toalettsits..nn.1
  toalettskåp_1_N = mkN "toalettskåp" neutrum  ; -- toalettskåp..nn.1
  toalettstol_1_N = mkN "toalettstol" ; -- toalettstol..nn.1
  toalettvål_1_N = mkN "toalettvål" ; -- toalettvål..nn.1
  toapapper_1_N = mkN "toapapper" neutrum  ; -- toapapper..nn.1
  toarulle_1_N = mkN "toarulle" utrum  ; -- toarulle..nn.1
  toasits_1_N = mkN "toasits" ; -- toasits..nn.1
  toast_1_N = mkN "toast" ; -- toast..nn.1
  toastmaster_1_N = mkN "toastmaster" ; -- toastmaster..nn.1
  toastol_1_N = mkN "toastol" ; -- toastol..nn.1
  tobak_1_N = mkN "tobak" ; -- tobak..nn.1
  tobakist_1_N = mkN "tobakist" "tobakister" ; -- tobakist..nn.1
  tobaksaffär_1_N = mkN "tobaksaffär" "tobaksaffärer" ; -- tobaksaffär..nn.1
  tobaksblad_1_N = mkN "tobaksblad" neutrum  ; -- tobaksblad..nn.1
  tobaksbruk_1_N = mkN "tobaksbruk" neutrum  ; -- tobaksbruk..nn.1
  tobaksbutik_1_N = mkN "tobaksbutik" "tobaksbutiker" ; -- tobaksbutik..nn.1
  tobaksflarn_1_N = mkN "tobaksflarn" neutrum  ; -- tobaksflarn..nn.1
  tobakshandlare_1_N = mkN "tobakshandlare" utrum  ; -- tobakshandlare..nn.1
  tobaksimportör_1_N = mkN "tobaksimportör" "tobaksimportörer" ; -- tobaksimportör..nn.1
  tobakskiosk_1_N = mkN "tobakskiosk" "tobakskiosker" ; -- tobakskiosk..nn.1
  tobaksmonopol_1_N = mkN "tobaksmonopol" neutrum  ; -- tobaksmonopol..nn.1
  tobaksodling_1_N = mkN "tobaksodling" ; -- tobaksodling..nn.1
  tobakspipa_1_N = mkN "tobakspipa" ; -- tobakspipa..nn.1
  tobaksplanta_1_N = mkN "tobaksplanta" ; -- tobaksplanta..nn.1
  tobaksstrimla_1_N = mkN "tobaksstrimla" ; -- tobaksstrimla..nn.1
  tobaksvara_1_N = mkN "tobaksvara" ; -- tobaksvara..nn.1
  tobis_1_N = mkN "tobis" ; -- tobis..nn.1
  tobisgrissla_1_N = mkN "tobisgrissla" ; -- tobisgrissla..nn.1
  tobiskung_1_N = mkN "tobiskung" ; -- tobiskung..nn.1
  tobleronepolitik_1_N = mkN "tobleronepolitik" ; -- tobleronepolitik..nn.1
  toccata_1_N = mkN "toccata" ; -- toccata..nn.1
  tocka_1_V = mkV "tockar" ; -- tocka..vb.1
  tockande_1_N = mkN "tockande" ; -- tockande..nn.1
  tocken_1_A = mkA "tocken" ; -- tocken..av.1
  toddy_1_N = mkN "toddy" "toddyn" "toddar" "toddarna" ; -- toddy..nn.1
  toffel_1_N = mkN "toffla" ; -- toffel..nn.1
  toffelblomma_1_N = mkN "toffelblomma" ; -- toffelblomma..nn.1
  toffeldjur_1_N = mkN "toffeldjur" neutrum  ; -- toffeldjur..nn.1
  toffelhjälte_1_N = mkN "toffelhjälte" utrum  ; -- toffelhjälte..nn.1
  toffla_1_V = mkV "tofflar" ; -- toffla..vb.1
  tofflande_1_N = mkN "tofflande" ; -- tofflande..nn.1
  tofs_1_N = mkN "tofs" ; -- tofs..nn.1
  tofsig_1_A = mkA "tofsig" ; -- tofsig..av.1
  tofsighet_1_N = mkN "tofsighet" ; -- tofsighet..nn.1
  tofslärka_1_N = mkN "tofslärka" ; -- tofslärka..nn.1
  tofsmes_1_N = mkN "tofsmes" ; -- tofsmes..nn.1
  tofsskivling_1_N = mkN "tofsskivling" ; -- tofsskivling..nn.1
  tofsvipa_1_N = mkN "tofsvipa" ; -- tofsvipa..nn.1
  tofsöra_1_N = mkN "tofsöra" "tofsörat" "tofsöron" "tofsöronen" ; -- tofsöra..nn.1
  toft_1_N = mkN "toft" "tofter" ; -- toft..nn.1
  toftvägare_1_N = mkN "toftvägare" utrum  ; -- toftvägare..nn.1
  tofu_1_N = mkN "tofu" ; -- tofu..nn.1
  toga_1_N = mkN "toga" ; -- toga..nn.1
  togaklädd_1_A = mkA "togaklädd" ; -- togaklädd..av.1
  togoles_1_N = mkN "togoles" "togoleser" ; -- togoles..nn.1
  togolesisk_1_A = mkA "togolesisk" ; -- togolesisk..av.1
  togolesiska_1_N = mkN "togolesiska" ; -- togolesiska..nn.1
  togolesiskflaggad_1_A = mkA "togolesiskflaggad" ; -- togolesiskflaggad..av.1
  tok_1_N = mkN "tok" ; -- tok..nn.1
  toka_1_N = mkN "toka" ; -- toka..nn.1
  tokajer_1_N = mkN "tokajer" ; -- tokajer..nn.1
  tokenskap_1_N = mkN "tokenskap" "tokenskaper" ; -- tokenskap..nn.1
  toker_1_N = mkN "toker" ; -- toker..nn.1
  tokeri_1_N = mkN "tokeri" "tokeriet" "tokerier" "tokerierna" ; -- tokeri..nn.1
  tokfeminist_1_N = mkN "tokfeminist" "tokfeminister" ; -- tokfeminist..nn.1
  tokig_1_A = mkA "tokig" ; -- tokig..av.1
  tokighet_1_N = mkN "tokighet" "tokigheter" ; -- tokighet..nn.1
  tokmorsa_1_N = mkN "tokmorsa" ; -- tokmorsa..nn.1
  tokprat_1_N = mkN "tokprat" neutrum  ; -- tokprat..nn.1
  tokrolig_1_A = mkA "tokrolig" ; -- tokrolig..av.1
  tokrolighet_1_N = mkN "tokrolighet" "tokroligheter" ; -- tokrolighet..nn.1
  tokskalle_1_N = mkN "tokskalle" utrum  ; -- tokskalle..nn.1
  tokstolle_1_N = mkN "tokstolle" utrum  ; -- tokstolle..nn.1
  tokstollig_1_A = mkA "tokstollig" ; -- tokstollig..av.1
  tokvänster_1_N = mkN "tokvänster" ; -- tokvänster..nn.1
  toledansk_1_A = mkA "toledansk" ; -- toledansk..av.1
  tolerabel_1_A = mkA "tolerabel" ; -- tolerabel..av.1
  tolerans_1_N = mkN "tolerans" ; -- tolerans..nn.1
  tolerans_2_N = mkN "tolerans" "toleranser" ; -- tolerans..nn.2
  tolerant_1_A = mkA "tolerant" "tolerant" ; -- tolerant..av.1
  tolerera_1_V = mkV "tolererar" ; -- tolerera..vb.1
  tolererande_1_N = mkN "tolererande" ; -- tolererande..nn.1
  tolererbar_1_A = mkA "tolererbar" ; -- tolererbar..av.1
  tolererbarhet_1_N = mkN "tolererbarhet" ; -- tolererbarhet..nn.1
  tolerering_1_N = mkN "tolerering" ; -- tolerering..nn.1
  tolft_1_N = mkN "tolft" "tolfter" ; -- tolft..nn.1
  tolfte_1_A = mkA "tolfte" ; -- tolfte..av.1
  tolftedel_1_N = mkN "tolftedel" "tolftedelen" "tolftedelar" "tolftedelarna" ; -- tolftedel..nn.1
  tolk_1_N = mkN "tolk" ; -- tolk..nn.1
  tolka_1_V = mkV "tolkar" ; -- tolka..vb.1
  tolkande_1_N = mkN "tolkande" ; -- tolkande..nn.1
  tolkare_1_N = mkN "tolkare" utrum  ; -- tolkare..nn.1
  tolklina_1_N = mkN "tolklina" ; -- tolklina..nn.1
  tolkning_1_N = mkN "tolkning" ; -- tolkning..nn.1
  tolkningsfråga_1_N = mkN "tolkningsfråga" ; -- tolkningsfråga..nn.1
  tolkningsföreträde_1_N = mkN "tolkningsföreträde" ; -- tolkningsföreträde..nn.1
  tolkningsmetod_1_N = mkN "tolkningsmetod" "tolkningsmetoder" ; -- tolkningsmetod..nn.1
  tolkningsmässig_1_A = mkA "tolkningsmässig" ; -- tolkningsmässig..av.1
  tolkningsmöjlighet_1_N = mkN "tolkningsmöjlighet" "tolkningsmöjligheter" ; -- tolkningsmöjlighet..nn.1
  tolta_1_N = mkN "tolta" ; -- tolta..nn.1
  toluen_1_N = mkN "toluen" neutrum  ; -- toluen..nn.1
  tolva_1_N = mkN "tolva" ; -- tolva..nn.1
  tolvfaldig_1_A = mkA "tolvfaldig" ; -- tolvfaldig..av.1
  tolvfaldiga_1_V = mkV "tolvfaldigar" ; -- tolvfaldiga..vb.1
  tolvfaldigande_1_N = mkN "tolvfaldigande" ; -- tolvfaldigande..nn.1
  tolvfaldighet_1_N = mkN "tolvfaldighet" ; -- tolvfaldighet..nn.1
  tolvfingertarm_1_N = mkN "tolvfingertarm" ; -- tolvfingertarm..nn.1
  tolvhundratal_1_N = mkN "tolvhundratal" neutrum  ; -- tolvhundratal..nn.1
  tolvhundratalsmunk_1_N = mkN "tolvhundratalsmunk" ; -- tolvhundratalsmunk..nn.1
  tolvkanthylsa_1_N = mkN "tolvkanthylsa" ; -- tolvkanthylsa..nn.1
  tolvkantshylsa_1_N = mkN "tolvkantshylsa" ; -- tolvkantshylsa..nn.1
  tolvman_1_N = mkN "tolvman" "tolvmannen" "tolvmän" "tolvmännen" ; -- tolvman..nn.1
  tolvmilsgräns_1_N = mkN "tolvmilsgräns" "tolvmilsgränser" ; -- tolvmilsgräns..nn.1
  tolvmånadersperiod_1_N = mkN "tolvmånadersperiod" "tolvmånadersperioder" ; -- tolvmånadersperiod..nn.1
  tolvskilling_1_N = mkN "tolvskilling" ; -- tolvskilling..nn.1
  tolvslag_1_N = mkN "tolvslag" neutrum  ; -- tolvslag..nn.1
  tolvtaggare_1_N = mkN "tolvtaggare" utrum  ; -- tolvtaggare..nn.1
  tolvtonsmusik_1_N = mkN "tolvtonsmusik" ; -- tolvtonsmusik..nn.1
  tolvvoltsbatteri_1_N = mkN "tolvvoltsbatteri" "tolvvoltsbatteriet" "tolvvoltsbatterier" "tolvvoltsbatterierna" ; -- tolvvoltsbatteri..nn.1
  tolvårig_1_A = mkA "tolvårig" ; -- tolvårig..av.1
  tolvåring_1_N = mkN "tolvåring" ; -- tolvåring..nn.1
  tolvårsålder_1_N = mkN "tolvårsålder" ; -- tolvårsålder..nn.1
  tom_1_A = mkA "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ; -- tom..av.1
  tom_1_N = mkN "tom" "tomer" ; -- tom..nn.1
  tomahawk_1_N = mkN "tomahawk" "tomahawker" ; -- tomahawk..nn.1
  tomahåk_1_N = mkN "tomahåk" "tomahåker" ; -- tomahåk..nn.1
  tomat_1_N = mkN "tomat" "tomater" ; -- tomat..nn.1
  tomatodling_1_N = mkN "tomatodling" ; -- tomatodling..nn.1
  tomatsås_1_N = mkN "tomatsås" ; -- tomatsås..nn.1
  tombak_1_N = mkN "tombak" ; -- tombak..nn.1
  tombola_1_N = mkN "tombola" ; -- tombola..nn.1
  tombutelj_1_N = mkN "tombutelj" "tombuteljer" ; -- tombutelj..nn.1
  tomflaska_1_N = mkN "tomflaska" ; -- tomflaska..nn.1
  tomglas_1_N = mkN "tomglas" neutrum  ; -- tomglas..nn.1
  tomgång_1_N = mkN "tomgång" ; -- tomgång..nn.1
  tomgångsförbrukning_1_N = mkN "tomgångsförbrukning" ; -- tomgångsförbrukning..nn.1
  tomgångskörning_1_N = mkN "tomgångskörning" ; -- tomgångskörning..nn.1
  tomhet_1_N = mkN "tomhet" "tomheter" ; -- tomhet..nn.1
  tomhetskänsla_1_N = mkN "tomhetskänsla" ; -- tomhetskänsla..nn.1
  tomhänt_1_A = mkA "tomhänt" "tomhänt" ; -- tomhänt..av.1
  tomhänthet_1_N = mkN "tomhänthet" ; -- tomhänthet..nn.1
  tomkartong_1_N = mkN "tomkartong" "tomkartonger" ; -- tomkartong..nn.1
  tomlåda_1_N = mkN "tomlåda" ; -- tomlåda..nn.1
  tomografi_1_N = mkN "tomografi" "tomografier" ; -- tomografi..nn.1
  tomrum_1_N = mkN "tomrum" "tomrummet" "tomrum" "tomrummen" ; -- tomrum..nn.1
  tomt_1_N = mkN "tomt" "tomter" ; -- tomt..nn.1
  tomta_1_V = mkV "tomtar" ; -- tomta..vb.1
  tomtande_1_N = mkN "tomtande" ; -- tomtande..nn.1
  tomte_1_N = mkN "tomte" utrum  ; -- tomte..nn.1
  tomtebisse_1_N = mkN "tomtebisse" utrum  ; -- tomtebisse..nn.1
  tomtebloss_1_N = mkN "tomtebloss" neutrum  ; -- tomtebloss..nn.1
  tomtebolycka_1_N = mkN "tomtebolycka" ; -- tomtebolycka..nn.1
  tomtedräkt_1_N = mkN "tomtedräkt" "tomtedräkter" ; -- tomtedräkt..nn.1
  tomtefar_1_N = mkN "tomtefar" ; -- tomtefar..nn.1
  tomtegubbe_1_N = mkN "tomtegubbe" utrum  ; -- tomtegubbe..nn.1
  tomteluva_1_N = mkN "tomteluva" ; -- tomteluva..nn.1
  tomtemask_1_N = mkN "tomtemask" "tomtemasker" ; -- tomtemask..nn.1
  tomtenisse_1_N = mkN "tomtenisse" utrum  ; -- tomtenisse..nn.1
  tomteskrockande_1_N = mkN "tomteskrockande" ; -- tomteskrockande..nn.1
  tomteverkstad_1_N = mkN "tomteverkstad" "tomteverkstäder" ; -- tomteverkstad..nn.1
  tomtgräns_1_N = mkN "tomtgräns" "tomtgränser" ; -- tomtgräns..nn.1
  tomtjobbare_1_N = mkN "tomtjobbare" utrum  ; -- tomtjobbare..nn.1
  tomtjobberi_1_N = mkN "tomtjobberi" neutrum  ; -- tomtjobberi..nn.1
  tomtmark_1_N = mkN "tomtmark" "tomtmarker" ; -- tomtmark..nn.1
  tomtning_1_N = mkN "tomtning" ; -- tomtning..nn.1
  tomträtt_1_N = mkN "tomträtt" ; -- tomträtt..nn.1
  tomträttsavgäld_1_N = mkN "tomträttsavgäld" "tomträttsavgälder" ; -- tomträttsavgäld..nn.1
  tomtyta_1_N = mkN "tomtyta" ; -- tomtyta..nn.1
  tomögd_1_A = mkA "tomögd" "tomögt" ; -- tomögd..av.1
  ton_1_N = mkN "ton" "toner" ; -- ton..nn.1
  ton_2_N = mkN "ton" "tonnet" "ton" "tonnen" ; -- ton..nn.2
  tona_1_V = mkV "tonar" ; -- tona..vb.1
  tonal_1_A = mkA "tonal" ; -- tonal..av.1
  tonalitet_1_N = mkN "tonalitet" "tonaliteter" ; -- tonalitet..nn.1
  tonande_1_A = mkA "tonande" ; -- tonande..av.1
  tonande_1_N = mkN "tonande" ; -- tonande..nn.1
  tonarm_1_N = mkN "tonarm" ; -- tonarm..nn.1
  tonart_1_N = mkN "tonart" "tonarter" ; -- tonart..nn.1
  tonband_1_N = mkN "tonband" neutrum  ; -- tonband..nn.1
  tonbildning_1_N = mkN "tonbildning" ; -- tonbildning..nn.1
  tondöv_1_A = mkA "tondöv" ; -- tondöv..av.1
  tondövhet_1_N = mkN "tondövhet" ; -- tondövhet..nn.1
  tonem_1_N = mkN "tonem" neutrum  ; -- tonem..nn.1
  tonetsning_1_N = mkN "tonetsning" ; -- tonetsning..nn.1
  tonett_1_N = mkN "tonett" "tonetter" ; -- tonett..nn.1
  tonfall_1_N = mkN "tonfall" neutrum  ; -- tonfall..nn.1
  tonfisk_1_N = mkN "tonfisk" ; -- tonfisk..nn.1
  tonföljd_1_N = mkN "tonföljd" "tonföljder" ; -- tonföljd..nn.1
  tongan_1_N = mkN "tongan" "tonganer" ; -- tongan..nn.1
  tongansk_1_A = mkA "tongansk" ; -- tongansk..av.1
  tonganska_1_N = mkN "tonganska" ; -- tonganska..nn.1
  tonganska_2_N = mkN "tonganska" ; -- tonganska..nn.2
  tongivande_1_A = mkA "tongivande" ; -- tongivande..av.1
  tongång_1_N = mkN "tongång" ; -- tongång..nn.1
  tonhöjd_1_N = mkN "tonhöjd" "tonhöjder" ; -- tonhöjd..nn.1
  tonic_1_N = mkN "tonic" ; -- tonic..nn.1
  tonika_1_N = mkN "tonika" ; -- tonika..nn.1
  tonikum_1_N = mkN "tonikum" neutrum  ; -- tonikum..nn.1
  toning_1_N = mkN "toning" ; -- toning..nn.1
  tonisk_1_A = mkA "tonisk" ; -- tonisk..av.1
  tonkilometer_1_N = mkN "tonkilometer" "tonkilometern" "tonkilometer" "tonkilometerna" ; -- tonkilometer..nn.1
  tonkonst_1_N = mkN "tonkonst" ; -- tonkonst..nn.1
  tonkonstnär_1_N = mkN "tonkonstnär" "tonkonstnärer" ; -- tonkonstnär..nn.1
  tonläge_1_N = mkN "tonläge" ; -- tonläge..nn.1
  tonlös_1_A = mkA "tonlös" ; -- tonlös..av.1
  tonlöshet_1_N = mkN "tonlöshet" ; -- tonlöshet..nn.1
  tonmålning_1_N = mkN "tonmålning" ; -- tonmålning..nn.1
  tonnage_1_N = mkN "tonnage" ; -- tonnage..nn.1
  tonomfång_1_N = mkN "tonomfång" neutrum  ; -- tonomfång..nn.1
  tonområde_1_N = mkN "tonområde" ; -- tonområde..nn.1
  tonsill_1_N = mkN "tonsill" "tonsiller" ; -- tonsill..nn.1
  tonskala_1_N = mkN "tonskala" ; -- tonskala..nn.1
  tonskapelse_1_N = mkN "tonskapelse" "tonskapelser" ; -- tonskapelse..nn.1
  tonspråk_1_N = mkN "tonspråk" neutrum  ; -- tonspråk..nn.1
  tonsteg_1_N = mkN "tonsteg" neutrum  ; -- tonsteg..nn.1
  tonstyrka_1_N = mkN "tonstyrka" ; -- tonstyrka..nn.1
  tonsur_1_N = mkN "tonsur" "tonsurer" ; -- tonsur..nn.1
  tonsystem_1_N = mkN "tonsystem" neutrum  ; -- tonsystem..nn.1
  tonsäker_1_A = mkA "tonsäker" ; -- tonsäker..av.1
  tonsäkerhet_1_N = mkN "tonsäkerhet" ; -- tonsäkerhet..nn.1
  tonsätta_1_V = mkV "tonsätta" "tonsätter" "tonsätt" "tonsatte" "tonsatt" "tonsatt" ; -- tonsätta..vb.1
  tonsättande_1_N = mkN "tonsättande" ; -- tonsättande..nn.1
  tonsättare_1_N = mkN "tonsättare" utrum  ; -- tonsättare..nn.1
  tonsättning_1_N = mkN "tonsättning" ; -- tonsättning..nn.1
  tonträffning_1_N = mkN "tonträffning" ; -- tonträffning..nn.1
  tonus_1_N = mkN "tonus" ; -- tonus..nn.1
  tonval_1_N = mkN "tonval" neutrum  ; -- tonval..nn.1
  tonvikt_1_N = mkN "tonvikt" ; -- tonvikt..nn.1
  tonvis_1_Adv = mkAdv "tonvis" ; -- tonvis..ab.1
  tonårig_1_A = mkA "tonårig" ; -- tonårig..av.1
  tonåring_1_N = mkN "tonåring" ; -- tonåring..nn.1
  tonårsabort_1_N = mkN "tonårsabort" "tonårsaborter" ; -- tonårsabort..nn.1
  tonårsdotter_1_N = mkN "tonårsdotter" "tonårsdottern" "tonårsdöttrar" "tonårsdöttrarna" ; -- tonårsdotter..nn.1
  tonårsflicka_1_N = mkN "tonårsflicka" ; -- tonårsflicka..nn.1
  tonårsförövare_1_N = mkN "tonårsförövare" utrum  ; -- tonårsförövare..nn.1
  tonårsgäng_1_N = mkN "tonårsgäng" neutrum  ; -- tonårsgäng..nn.1
  tonårsidentitet_1_N = mkN "tonårsidentitet" "tonårsidentiteter" ; -- tonårsidentitet..nn.1
  tonårsidol_1_N = mkN "tonårsidol" "tonårsidoler" ; -- tonårsidol..nn.1
  tonårsperiod_1_N = mkN "tonårsperiod" "tonårsperioder" ; -- tonårsperiod..nn.1
  tonårspojke_1_N = mkN "tonårspojke" utrum  ; -- tonårspojke..nn.1
  tonårsson_1_N = mkN "tonårsson" "tonårssöner" ; -- tonårsson..nn.1
  topas_1_N = mkN "topas" "topaser" ; -- topas..nn.1
  topasgul_1_A = mkA "topasgul" ; -- topasgul..av.1
  topless_1_A = mkA "topless" ; -- topless..av.1
  topograf_1_N = mkN "topograf" "topografer" ; -- topograf..nn.1
  topografi_1_N = mkN "topografi" ; -- topografi..nn.1
  topografisk_1_A = mkA "topografisk" ; -- topografisk..av.1
  topologi_1_N = mkN "topologi" "topologier" ; -- topologi..nn.1
  topologisk_1_A = mkA "topologisk" ; -- topologisk..av.1
  topp_1_N = mkN "topp" ; -- topp..nn.1
  toppa_1_V = mkV "toppar" ; -- toppa..vb.1
  toppande_1_N = mkN "toppande" ; -- toppande..nn.1
  toppbefattning_1_N = mkN "toppbefattning" ; -- toppbefattning..nn.1
  toppbegåvning_1_N = mkN "toppbegåvning" ; -- toppbegåvning..nn.1
  toppbetyg_1_N = mkN "toppbetyg" neutrum  ; -- toppbetyg..nn.1
  toppbrand_1_N = mkN "toppbrand" ; -- toppbrand..nn.1
  toppdomän_1_N = mkN "toppdomän" "toppdomäner" ; -- toppdomän..nn.1
  toppduo_1_N = mkN "toppduo" "toppduor" ; -- toppduo..nn.1
  toppeld_1_N = mkN "toppeld" ; -- toppeld..nn.1
  toppen_1_A = mkA "toppen" ; -- toppen..av.1
  toppenbra_1_A = mkA "toppenbra" ; -- toppenbra..av.1
  toppenergi_1_N = mkN "toppenergi" "toppenergier" ; -- toppenergi..nn.1
  toppfart_1_N = mkN "toppfart" ; -- toppfart..nn.1
  toppform_1_N = mkN "toppform" ; -- toppform..nn.1
  toppformig_1_A = mkA "toppformig" ; -- toppformig..av.1
  toppformighet_1_N = mkN "toppformighet" ; -- toppformighet..nn.1
  toppförstärkning_1_N = mkN "toppförstärkning" ; -- toppförstärkning..nn.1
  topphemlig_1_A = mkA "topphemlig" ; -- topphemlig..av.1
  topphugga_1_V = mkV "topphugga" "topphögg" "topphuggit" ; -- topphugga..vb.1
  topphuggande_1_N = mkN "topphuggande" ; -- topphuggande..nn.1
  topphuggning_1_N = mkN "topphuggning" ; -- topphuggning..nn.1
  topphäst_1_N = mkN "topphäst" ; -- topphäst..nn.1
  toppig_1_A = mkA "toppig" ; -- toppig..av.1
  toppighet_1_N = mkN "toppighet" ; -- toppighet..nn.1
  topping_1_N = mkN "topping" ; -- topping..nn.1
  toppjobb_1_N = mkN "toppjobb" neutrum  ; -- toppjobb..nn.1
  toppklass_1_N = mkN "toppklass" ; -- toppklass..nn.1
  toppknopp_1_N = mkN "toppknopp" ; -- toppknopp..nn.1
  toppkonferens_1_N = mkN "toppkonferens" "toppkonferenser" ; -- toppkonferens..nn.1
  toppkraft_1_N = mkN "toppkraft" "toppkrafter" ; -- toppkraft..nn.1
  toppkvark_1_N = mkN "toppkvark" ; -- toppkvark..nn.1
  topplag_1_N = mkN "topplag" neutrum  ; -- topplag..nn.1
  topplanterna_1_N = mkN "topplanterna" ; -- topplanterna..nn.1
  topplista_1_N = mkN "topplista" ; -- topplista..nn.1
  topplock_1_N = mkN "topplock" neutrum  ; -- topplock..nn.1
  toppluva_1_N = mkN "toppluva" ; -- toppluva..nn.1
  topplänta_1_N = mkN "topplänta" ; -- topplänta..nn.1
  topplärka_1_N = mkN "topplärka" ; -- topplärka..nn.1
  topplån_1_N = mkN "topplån" neutrum  ; -- topplån..nn.1
  topplösa_1_N = mkN "topplösa" ; -- topplösa..nn.1
  toppman_1_N = mkN "toppman" "toppmannen" "toppmän" "toppmännen" ; -- toppman..nn.1
  toppmast_1_N = mkN "toppmast" "toppmaster" ; -- toppmast..nn.1
  toppmatad_1_A = mkA "toppmatad" ; -- toppmatad..av.1
  toppmodell_1_N = mkN "toppmodell" "toppmodeller" ; -- toppmodell..nn.1
  toppmodern_1_A = mkA "toppmodern" ; -- toppmodern..av.1
  toppmurkla_1_N = mkN "toppmurkla" ; -- toppmurkla..nn.1
  toppmöte_1_N = mkN "toppmöte" ; -- toppmöte..nn.1
  toppning_1_N = mkN "toppning" ; -- toppning..nn.1
  toppnivå_1_N = mkN "toppnivå" "toppnivåer" ; -- toppnivå..nn.1
  toppolitiker_1_N = mkN "toppolitiker" "toppolitikern" "toppolitiker" "toppolitikerna" ; -- toppolitiker..nn.1
  topposition_1_N = mkN "topposition" ; -- topposition..nn.1
  toppost_1_N = mkN "toppost" "topposter" ; -- toppost..nn.1
  topprida_1_V = mkV "topprida" "toppred" "toppridit" ; -- topprida..vb.1
  toppridande_1_N = mkN "toppridande" ; -- toppridande..nn.1
  toppridning_1_N = mkN "toppridning" ; -- toppridning..nn.1
  toppröta_1_N = mkN "toppröta" ; -- toppröta..nn.1
  toppsegel_1_N = mkN "toppsegel" neutrum  ; -- toppsegel..nn.1
  toppskikt_1_N = mkN "toppskikt" neutrum  ; -- toppskikt..nn.1
  toppskott_1_N = mkN "toppskott" neutrum  ; -- toppskott..nn.1
  toppstrid_1_N = mkN "toppstrid" "toppstrider" ; -- toppstrid..nn.1
  toppstyrd_1_A = mkA "toppstyrd" "toppstyrt" ; -- toppstyrd..av.1
  toppstyrdhet_1_N = mkN "toppstyrdhet" ; -- toppstyrdhet..nn.1
  toppända_1_N = mkN "toppända" ; -- toppända..nn.1
  toppände_1_N = mkN "toppände" utrum  ; -- toppände..nn.1
  tops_1_N = mkN "tops" ; -- tops..nn.1
  topsa_1_V = mkV "topsar" ; -- topsa..vb.1
  topsande_1_N = mkN "topsande" ; -- topsande..nn.1
  topsning_1_N = mkN "topsning" ; -- topsning..nn.1
  topspin_1_N = mkN "topspin" ; -- topspin..nn.1
  toque_1_N = mkN "toque" "toquer" ; -- toque..nn.1
  torde_1_V = mkV "torde" ; -- torde..vb.1
  tordera_1_V = mkV "torderar" ; -- tordera..vb.1
  torderande_1_N = mkN "torderande" ; -- torderande..nn.1
  torderbar_1_A = mkA "torderbar" ; -- torderbar..av.1
  torderbarhet_1_N = mkN "torderbarhet" ; -- torderbarhet..nn.1
  tordering_1_N = mkN "tordering" ; -- tordering..nn.1
  tordmule_1_N = mkN "tordmule" utrum  ; -- tordmule..nn.1
  tordyvel_1_N = mkN "tordyvel" ; -- tordyvel..nn.1
  tordön_1_N = mkN "tordön" neutrum  ; -- tordön..nn.1
  tordönsröst_1_N = mkN "tordönsröst" "tordönsröster" ; -- tordönsröst..nn.1
  tordönsstämma_1_N = mkN "tordönsstämma" ; -- tordönsstämma..nn.1
  toreador_1_N = mkN "toreador" "toreadoren" "toreadorer" "toreadorerna" ; -- toreador..nn.1
  toreadorbyxa_1_N = mkN "toreadorbyxa" ; -- toreadorbyxa..nn.1
  torero_1_N = mkN "torero" "toreron" "toreroer" "toreroerna" ; -- torero..nn.1
  torftig_1_A = mkA "torftig" ; -- torftig..av.1
  torftighet_1_N = mkN "torftighet" "torftigheter" ; -- torftighet..nn.1
  torg_1_N = mkN "torg" neutrum  ; -- torg..nn.1
  torgdag_1_N = mkN "torgdag" ; -- torgdag..nn.1
  torgföra_1_V = mkV "torgföra" "torgförde" "torgfört" ; -- torgföra..vb.1
  torgförande_1_N = mkN "torgförande" ; -- torgförande..nn.1
  torggumma_1_N = mkN "torggumma" ; -- torggumma..nn.1
  torghandel_1_N = mkN "torghandel" ; -- torghandel..nn.1
  torgmarknad_1_N = mkN "torgmarknad" "torgmarknader" ; -- torgmarknad..nn.1
  torgskräck_1_N = mkN "torgskräck" ; -- torgskräck..nn.1
  torgstånd_1_N = mkN "torgstånd" neutrum  ; -- torgstånd..nn.1
  torgvimmel_1_N = mkN "torgvimmel" neutrum  ; -- torgvimmel..nn.1
  torium_1_N = mkN "torium" neutrum  ; -- torium..nn.1
  tork_1_N = mkN "tork" ; -- tork..nn.1
  torka_1_N = mkN "torka" ; -- torka..nn.1
  torka_1_V = mkV "torkar" ; -- torka..vb.1
  torkande_1_N = mkN "torkande" ; -- torkande..nn.1
  torkarblad_1_N = mkN "torkarblad" neutrum  ; -- torkarblad..nn.1
  torkblock_1_N = mkN "torkblock" neutrum  ; -- torkblock..nn.1
  torkcentrifug_1_N = mkN "torkcentrifug" "torkcentrifuger" ; -- torkcentrifug..nn.1
  torkduk_1_N = mkN "torkduk" ; -- torkduk..nn.1
  torkeri_1_N = mkN "torkeri" "torkeriet" "torkerier" "torkerierna" ; -- torkeri..nn.1
  torkfläck_1_N = mkN "torkfläck" ; -- torkfläck..nn.1
  torkhandduk_1_N = mkN "torkhandduk" ; -- torkhandduk..nn.1
  torkhuv_1_N = mkN "torkhuv" ; -- torkhuv..nn.1
  torkkatastrof_1_N = mkN "torkkatastrof" "torkkatastrofer" ; -- torkkatastrof..nn.1
  torklina_1_N = mkN "torklina" ; -- torklina..nn.1
  torklåda_1_N = mkN "torklåda" ; -- torklåda..nn.1
  torkning_1_N = mkN "torkning" ; -- torkning..nn.1
  torkpapper_1_N = mkN "torkpapper" neutrum  ; -- torkpapper..nn.1
  torkperiod_1_N = mkN "torkperiod" "torkperioder" ; -- torkperiod..nn.1
  torkrum_1_N = mkN "torkrum" "torkrummet" "torkrum" "torkrummen" ; -- torkrum..nn.1
  torkskåp_1_N = mkN "torkskåp" neutrum  ; -- torkskåp..nn.1
  torkstreck_1_N = mkN "torkstreck" neutrum  ; -- torkstreck..nn.1
  torkställ_1_N = mkN "torkställ" neutrum  ; -- torkställ..nn.1
  torktumla_1_V = mkV "torktumlar" ; -- torktumla..vb.1
  torktumlande_1_N = mkN "torktumlande" ; -- torktumlande..nn.1
  torktumlare_1_N = mkN "torktumlare" utrum  ; -- torktumlare..nn.1
  torktumlarfilter_1_N = mkN "torktumlarfilter" neutrum  ; -- torktumlarfilter..nn.1
  torktumlarludd_1_N = mkN "torktumlarludd" ; -- torktumlarludd..nn.1
  torkugn_1_N = mkN "torkugn" ; -- torkugn..nn.1
  torkämne_1_N = mkN "torkämne" ; -- torkämne..nn.1
  torkår_1_N = mkN "torkår" neutrum  ; -- torkår..nn.1
  torn_1_N = mkN "torn" neutrum  ; -- torn..nn.1
  torn_2_N = mkN "torn" ; -- torn..nn.2
  torna_1_V = mkV "tornar" ; -- torna..vb.1
  tornado_1_N = mkN "tornado" "tornador" ; -- tornado..nn.1
  tornadovarning_1_N = mkN "tornadovarning" ; -- tornadovarning..nn.1
  tornande_1_N = mkN "tornande" ; -- tornande..nn.1
  tornavslutning_1_N = mkN "tornavslutning" ; -- tornavslutning..nn.1
  tornedalsfinska_1_N = mkN "tornedalsfinska" ; -- tornedalsfinska..nn.1
  tornera_1_V = mkV "tornerar" ; -- tornera..vb.1
  tornerande_1_N = mkN "tornerande" ; -- tornerande..nn.1
  tornering_1_N = mkN "tornering" ; -- tornering..nn.1
  tornerspel_1_N = mkN "tornerspel" "tornerspelet" "tornerspel" "tornerspelen" ; -- tornerspel..nn.1
  tornfalk_1_N = mkN "tornfalk" ; -- tornfalk..nn.1
  tornfönster_1_N = mkN "tornfönster" neutrum  ; -- tornfönster..nn.1
  tornister_1_N = mkN "tornister" ; -- tornister..nn.1
  tornseglare_1_N = mkN "tornseglare" utrum  ; -- tornseglare..nn.1
  tornsnäcka_1_N = mkN "tornsnäcka" ; -- tornsnäcka..nn.1
  tornspets_1_N = mkN "tornspets" ; -- tornspets..nn.1
  tornspira_1_N = mkN "tornspira" ; -- tornspira..nn.1
  tornsvala_1_N = mkN "tornsvala" ; -- tornsvala..nn.1
  tornuggla_1_N = mkN "tornuggla" ; -- tornuggla..nn.1
  tornur_1_N = mkN "tornur" neutrum  ; -- tornur..nn.1
  tornväktare_1_N = mkN "tornväktare" utrum  ; -- tornväktare..nn.1
  torp_1_N = mkN "torp" neutrum  ; -- torp..nn.1
  torpare_1_N = mkN "torpare" utrum  ; -- torpare..nn.1
  torped_1_N = mkN "torped" "torpeder" ; -- torped..nn.1
  torpedattack_1_N = mkN "torpedattack" "torpedattacker" ; -- torpedattack..nn.1
  torpedbåt_1_N = mkN "torpedbåt" ; -- torpedbåt..nn.1
  torpedera_1_V = mkV "torpederar" ; -- torpedera..vb.1
  torpederande_1_N = mkN "torpederande" ; -- torpederande..nn.1
  torpederbar_1_A = mkA "torpederbar" ; -- torpederbar..av.1
  torpederbarhet_1_N = mkN "torpederbarhet" ; -- torpederbarhet..nn.1
  torpedering_1_N = mkN "torpedering" ; -- torpedering..nn.1
  torpedkula_1_N = mkN "torpedkula" ; -- torpedkula..nn.1
  torpedtub_1_N = mkN "torpedtub" "torpedtuber" ; -- torpedtub..nn.1
  torpedövning_1_N = mkN "torpedövning" ; -- torpedövning..nn.1
  torpruin_1_N = mkN "torpruin" "torpruiner" ; -- torpruin..nn.1
  torpstuga_1_N = mkN "torpstuga" ; -- torpstuga..nn.1
  torpägare_1_N = mkN "torpägare" utrum  ; -- torpägare..nn.1
  torr_1_A = mkA "torr" ; -- torr..av.1
  torraka_1_N = mkN "torraka" ; -- torraka..nn.1
  torrbatteri_1_N = mkN "torrbatteri" "torrbatteriet" "torrbatterier" "torrbatterierna" ; -- torrbatteri..nn.1
  torrboll_1_N = mkN "torrboll" ; -- torrboll..nn.1
  torrdass_1_N = mkN "torrdass" neutrum  ; -- torrdass..nn.1
  torrdestillation_1_N = mkN "torrdestillation" ; -- torrdestillation..nn.1
  torrdestillera_1_V = mkV "torrdestillerar" ; -- torrdestillera..vb.1
  torrdestillerande_1_N = mkN "torrdestillerande" ; -- torrdestillerande..nn.1
  torrdestillerbar_1_A = mkA "torrdestillerbar" ; -- torrdestillerbar..av.1
  torrdestillerbarhet_1_N = mkN "torrdestillerbarhet" ; -- torrdestillerbarhet..nn.1
  torrdestillering_1_N = mkN "torrdestillering" ; -- torrdestillering..nn.1
  torrdis_1_N = mkN "torrdis" neutrum  ; -- torrdis..nn.1
  torrdocka_1_N = mkN "torrdocka" ; -- torrdocka..nn.1
  torrelement_1_N = mkN "torrelement" neutrum  ; -- torrelement..nn.1
  torrfisk_1_N = mkN "torrfisk" ; -- torrfisk..nn.1
  torrfluga_1_N = mkN "torrfluga" ; -- torrfluga..nn.1
  torrfoder_1_N = mkN "torrfoder" neutrum  ; -- torrfoder..nn.1
  torrfodra_1_V = mkV "torrfodrar" ; -- torrfodra..vb.1
  torrfodrande_1_N = mkN "torrfodrande" ; -- torrfodrande..nn.1
  torrfodring_1_N = mkN "torrfodring" ; -- torrfodring..nn.1
  torrfotad_1_A = mkA "torrfotad" ; -- torrfotad..av.1
  torrhet_1_N = mkN "torrhet" ; -- torrhet..nn.1
  torrhosta_1_N = mkN "torrhosta" ; -- torrhosta..nn.1
  torrhosta_1_V = mkV "torrhostar" ; -- torrhosta..vb.1
  torrhostande_1_N = mkN "torrhostande" ; -- torrhostande..nn.1
  torris_1_N = mkN "torris" ; -- torris..nn.1
  torris_2_N = mkN "torris" ; -- torris..nn.2
  torrjäst_1_N = mkN "torrjäst" ; -- torrjäst..nn.1
  torrklosett_1_N = mkN "torrklosett" "torrklosetter" ; -- torrklosett..nn.1
  torrkoka_1_V = mkV "torrkoker" ; -- torrkoka..vb.1
  torrkokande_1_N = mkN "torrkokande" ; -- torrkokande..nn.1
  torrladdad_1_A = mkA "torrladdad" ; -- torrladdad..av.1
  torrlägga_1_V = mkV "torrlägga" "torrla" "torrlagt" ; -- torrlägga..vb.1
  torrläggande_1_N = mkN "torrläggande" ; -- torrläggande..nn.1
  torrläggning_1_N = mkN "torrläggning" ; -- torrläggning..nn.1
  torrmjölk_1_N = mkN "torrmjölk" ; -- torrmjölk..nn.1
  torrnål_1_N = mkN "torrnål" ; -- torrnål..nn.1
  torrnålsgravyr_1_N = mkN "torrnålsgravyr" ; -- torrnålsgravyr..nn.1
  torrolig_1_A = mkA "torrolig" ; -- torrolig..av.1
  torrolighet_1_N = mkN "torrolighet" "torroligheter" ; -- torrolighet..nn.1
  torrperiod_1_N = mkN "torrperiod" "torrperioder" ; -- torrperiod..nn.1
  torrschampo_1_N = mkN "torrschampo" "torrschampot" "torrschampon" "torrschampona" ; -- torrschampo..nn.1
  torrschamponera_1_V = mkV "torrschamponerar" ; -- torrschamponera..vb.1
  torrschamponerande_1_N = mkN "torrschamponerande" ; -- torrschamponerande..nn.1
  torrschamponerbar_1_A = mkA "torrschamponerbar" ; -- torrschamponerbar..av.1
  torrschamponerbarhet_1_N = mkN "torrschamponerbarhet" ; -- torrschamponerbarhet..nn.1
  torrschamponering_1_N = mkN "torrschamponering" ; -- torrschamponering..nn.1
  torrskaffning_1_N = mkN "torrskaffning" ; -- torrskaffning..nn.1
  torrskodd_1_A = mkA "torrskodd" ; -- torrskodd..av.1
  torrskoddhet_1_N = mkN "torrskoddhet" ; -- torrskoddhet..nn.1
  torrslipa_1_V = mkV "torrslipar" ; -- torrslipa..vb.1
  torrslipande_1_N = mkN "torrslipande" ; -- torrslipande..nn.1
  torrspricka_1_N = mkN "torrspricka" ; -- torrspricka..nn.1
  torrsprit_1_N = mkN "torrsprit" ; -- torrsprit..nn.1
  torrsubstans_1_N = mkN "torrsubstans" ; -- torrsubstans..nn.1
  torrtid_1_N = mkN "torrtid" "torrtider" ; -- torrtid..nn.1
  torrved_1_N = mkN "torrved" ; -- torrved..nn.1
  torrvedssticka_1_N = mkN "torrvedssticka" ; -- torrvedssticka..nn.1
  torrväder_1_N = mkN "torrväder" neutrum  ; -- torrväder..nn.1
  torrämne_1_N = mkN "torrämne" ; -- torrämne..nn.1
  torrögd_1_A = mkA "torrögd" "torrögt" ; -- torrögd..av.1
  torrögdhet_1_N = mkN "torrögdhet" ; -- torrögdhet..nn.1
  torröka_1_V = mkV "torröker" ; -- torröka..vb.1
  torrökande_1_N = mkN "torrökande" ; -- torrökande..nn.1
  torröta_1_N = mkN "torröta" ; -- torröta..nn.1
  torsdag_1_N = mkN "torsdag" ; -- torsdag..nn.1
  torsdageftermiddag_1_N = mkN "torsdageftermiddag" ; -- torsdageftermiddag..nn.1
  torsdagkväll_1_N = mkN "torsdagkväll" ; -- torsdagkväll..nn.1
  torsdagmorgon_1_N = mkN "torsdagmorgon" "torsdagmorgonen" "torsdagmornar" "torsdagmornarna" ; -- torsdagmorgon..nn.1
  torsdagseftermiddag_1_N = mkN "torsdagseftermiddag" ; -- torsdagseftermiddag..nn.1
  torsdagskväll_1_N = mkN "torsdagskväll" ; -- torsdagskväll..nn.1
  torsdagsmorgon_1_N = mkN "torsdagsmorgon" "torsdagsmorgonen" "torsdagsmornar" "torsdagsmornarna" ; -- torsdagsmorgon..nn.1
  torsdagsnummer_1_N = mkN "torsdagsnummer" neutrum  ; -- torsdagsnummer..nn.1
  torsdagstidning_1_N = mkN "torsdagstidning" ; -- torsdagstidning..nn.1
  torsion_1_N = mkN "torsion" ; -- torsion..nn.1
  torsionsfjädring_1_N = mkN "torsionsfjädring" ; -- torsionsfjädring..nn.1
  torsk_1_N = mkN "torsk" ; -- torsk..nn.1
  torsk_2_N = mkN "torsk" ; -- torsk..nn.2
  torska_1_V = mkV "torskar" ; -- torska..vb.1
  torskande_1_N = mkN "torskande" ; -- torskande..nn.1
  torskfisk_1_N = mkN "torskfisk" ; -- torskfisk..nn.1
  torskfiske_1_N = mkN "torskfiske" ; -- torskfiske..nn.1
  torskkvot_1_N = mkN "torskkvot" "torskkvoter" ; -- torskkvot..nn.1
  torskleverolja_1_N = mkN "torskleverolja" ; -- torskleverolja..nn.1
  torsklevertran_1_N = mkN "torsklevertran" neutrum  ; -- torsklevertran..nn.1
  torsköga_1_N = mkN "torsköga" "torskögat" "torskögon" "torskögonen" ; -- torsköga..nn.1
  torso_1_N = mkN "torso" "torsor" ; -- torso..nn.1
  torta_1_N = mkN "torta" ; -- torta..nn.1
  tortera_1_V = mkV "torterar" ; -- tortera..vb.1
  torterande_1_N = mkN "torterande" ; -- torterande..nn.1
  torterbar_1_A = mkA "torterbar" ; -- torterbar..av.1
  torterbarhet_1_N = mkN "torterbarhet" ; -- torterbarhet..nn.1
  tortering_1_N = mkN "tortering" ; -- tortering..nn.1
  tortilla_1_N = mkN "tortilla" ; -- tortilla..nn.1
  tortyr_1_N = mkN "tortyr" "tortyrer" ; -- tortyr..nn.1
  tortyranklagelse_1_N = mkN "tortyranklagelse" "tortyranklagelser" ; -- tortyranklagelse..nn.1
  tortyrbänk_1_N = mkN "tortyrbänk" ; -- tortyrbänk..nn.1
  tortyrfängelse_1_N = mkN "tortyrfängelse" "tortyrfängelset" "tortyrfängelser" "tortyrfängelserna" ; -- tortyrfängelse..nn.1
  tortyrkammare_1_N = mkN "tortyrkammare" "tortyrkammaren" "tortyrkammare" "tortyrkamrarna" ; -- tortyrkammare..nn.1
  tortyrmisstänkt_1_A = mkA "tortyrmisstänkt" "tortyrmisstänkt" ; -- tortyrmisstänkt..av.1
  tortyrredskap_1_N = mkN "tortyrredskap" neutrum  ; -- tortyrredskap..nn.1
  torv_1_N = mkN "torv" ; -- torv..nn.1
  torva_1_N = mkN "torva" ; -- torva..nn.1
  torva_1_V = mkV "torvar" ; -- torva..vb.1
  torvaktig_1_A = mkA "torvaktig" ; -- torvaktig..av.1
  torvaktighet_1_N = mkN "torvaktighet" ; -- torvaktighet..nn.1
  torvande_1_N = mkN "torvande" ; -- torvande..nn.1
  torvbrikett_1_N = mkN "torvbrikett" "torvbriketter" ; -- torvbrikett..nn.1
  torvbrikettfabrik_1_N = mkN "torvbrikettfabrik" "torvbrikettfabriker" ; -- torvbrikettfabrik..nn.1
  torvdike_1_N = mkN "torvdike" ; -- torvdike..nn.1
  torvgrav_1_N = mkN "torvgrav" ; -- torvgrav..nn.1
  torvjord_1_N = mkN "torvjord" ; -- torvjord..nn.1
  torvmosse_1_N = mkN "torvmosse" utrum  ; -- torvmosse..nn.1
  torvmossfynd_1_N = mkN "torvmossfynd" neutrum  ; -- torvmossfynd..nn.1
  torvmull_1_N = mkN "torvmull" ; -- torvmull..nn.1
  torvmullsklosett_1_N = mkN "torvmullsklosett" "torvmullsklosetter" ; -- torvmullsklosett..nn.1
  torvmyr_1_N = mkN "torvmyr" ; -- torvmyr..nn.1
  torvspade_1_N = mkN "torvspade" utrum  ; -- torvspade..nn.1
  torvströ_1_N = mkN "torvströ" neutrum  ; -- torvströ..nn.1
  torvtak_1_N = mkN "torvtak" neutrum  ; -- torvtak..nn.1
  torvtäcka_1_V = mkV "torvtäcker" ; -- torvtäcka..vb.1
  torvtäckande_1_N = mkN "torvtäckande" ; -- torvtäckande..nn.1
  torvtäkt_1_N = mkN "torvtäkt" "torvtäkter" ; -- torvtäkt..nn.1
  torvutvinning_1_N = mkN "torvutvinning" ; -- torvutvinning..nn.1
  tory_1_N = mkN "tory" "toryn" "tories" "toriesarna" ; -- tory..nn.1
  tosa_1_N = mkN "tosa" ; -- tosa..nn.1
  tosig_1_A = mkA "tosig" ; -- tosig..av.1
  tosighet_1_N = mkN "tosighet" "tosigheter" ; -- tosighet..nn.1
  tosing_1_N = mkN "tosing" ; -- tosing..nn.1
  tosk_1_N = mkN "tosk" "tosker" ; -- tosk..nn.1
  toskansk_1_A = mkA "toskansk" ; -- toskansk..av.1
  tossa_1_N = mkN "tossa" ; -- tossa..nn.1
  tossig_1_A = mkA "tossig" ; -- tossig..av.1
  tossighet_1_N = mkN "tossighet" "tossigheter" ; -- tossighet..nn.1
  total_1_A = mkA "total" ; -- total..av.1
  totalbelopp_1_N = mkN "totalbelopp" neutrum  ; -- totalbelopp..nn.1
  totalbild_1_N = mkN "totalbild" "totalbilder" ; -- totalbild..nn.1
  totalfinansiera_1_V = mkV "totalfinansierar" ; -- totalfinansiera..vb.1
  totalfinansierande_1_N = mkN "totalfinansierande" ; -- totalfinansierande..nn.1
  totalfinansierbar_1_A = mkA "totalfinansierbar" ; -- totalfinansierbar..av.1
  totalfinansierbarhet_1_N = mkN "totalfinansierbarhet" ; -- totalfinansierbarhet..nn.1
  totalfinansiering_1_N = mkN "totalfinansiering" ; -- totalfinansiering..nn.1
  totalfokus_1_N = mkN "totalfokus" ; -- totalfokus..nn.1
  totalfotboll_1_N = mkN "totalfotboll" ; -- totalfotboll..nn.1
  totalförbjuda_1_V = mkV "totalförbjuda" "totalförbjöd" "totalförbjudit" ; -- totalförbjuda..vb.1
  totalförbjudande_1_N = mkN "totalförbjudande" ; -- totalförbjudande..nn.1
  totalförbud_1_N = mkN "totalförbud" neutrum  ; -- totalförbud..nn.1
  totalförlama_1_V = mkV "totalförlamar" ; -- totalförlama..vb.1
  totalförlamande_1_N = mkN "totalförlamande" ; -- totalförlamande..nn.1
  totalförmörkelse_1_N = mkN "totalförmörkelse" "totalförmörkelser" ; -- totalförmörkelse..nn.1
  totalförstöra_1_V = mkV "totalförstöra" "totalförstörde" "totalförstört" ; -- totalförstöra..vb.1
  totalförstörande_1_N = mkN "totalförstörande" ; -- totalförstörande..nn.1
  totalförsvar_1_N = mkN "totalförsvar" neutrum  ; -- totalförsvar..nn.1
  totalhaverera_1_V = mkV "totalhavererar" ; -- totalhaverera..vb.1
  totalhavererande_1_N = mkN "totalhavererande" ; -- totalhavererande..nn.1
  totalhaverering_1_N = mkN "totalhaverering" ; -- totalhaverering..nn.1
  totalhaveri_1_N = mkN "totalhaveri" "totalhaveriet" "totalhaverier" "totalhaverierna" ; -- totalhaveri..nn.1
  totalintryck_1_N = mkN "totalintryck" neutrum  ; -- totalintryck..nn.1
  totalisator_1_N = mkN "totalisator" "totalisatorer" ; -- totalisator..nn.1
  totalitarism_1_N = mkN "totalitarism" "totalitarismer" ; -- totalitarism..nn.1
  totalitaristisk_1_A = mkA "totalitaristisk" ; -- totalitaristisk..av.1
  totalitet_1_N = mkN "totalitet" "totaliteter" ; -- totalitet..nn.1
  totalitetsbetydelse_1_N = mkN "totalitetsbetydelse" utrum  ; -- totalitetsbetydelse..nn.1
  totalitär_1_A = mkA "totalitär" ; -- totalitär..av.1
  totalkaos_1_N = mkN "totalkaos" neutrum  ; -- totalkaos..nn.1
  totalkvadda_1_V = mkV "totalkvaddar" ; -- totalkvadda..vb.1
  totalkvaddande_1_N = mkN "totalkvaddande" ; -- totalkvaddande..nn.1
  totalkvaddning_1_N = mkN "totalkvaddning" ; -- totalkvaddning..nn.1
  totalreflexion_1_N = mkN "totalreflexion" ; -- totalreflexion..nn.1
  totalsabba_1_V = mkV "totalsabbar" ; -- totalsabba..vb.1
  totalsabbande_1_N = mkN "totalsabbande" ; -- totalsabbande..nn.1
  totalsabbning_1_N = mkN "totalsabbning" ; -- totalsabbning..nn.1
  totalskugga_1_N = mkN "totalskugga" ; -- totalskugga..nn.1
  totalundersökning_1_N = mkN "totalundersökning" ; -- totalundersökning..nn.1
  totalvikt_1_N = mkN "totalvikt" "totalvikter" ; -- totalvikt..nn.1
  totalvägra_1_V = mkV "totalvägrar" ; -- totalvägra..vb.1
  totalvägrande_1_N = mkN "totalvägrande" ; -- totalvägrande..nn.1
  totalvärde_1_N = mkN "totalvärde" ; -- totalvärde..nn.1
  totalyta_1_N = mkN "totalyta" ; -- totalyta..nn.1
  totem_1_N = mkN "totem" ; -- totem..nn.1
  totemism_1_N = mkN "totemism" "totemismer" ; -- totemism..nn.1
  totemistisk_1_A = mkA "totemistisk" ; -- totemistisk..av.1
  totempelare_1_N = mkN "totempelare" utrum  ; -- totempelare..nn.1
  totempåle_1_N = mkN "totempåle" utrum  ; -- totempåle..nn.1
  toto_1_N = mkN "toto" ; -- toto..nn.1
  totospel_1_N = mkN "totospel" "totospelet" "totospel" "totospelen" ; -- totospel..nn.1
  tott_1_N = mkN "tott" ; -- tott..nn.1
  toucha_1_V = mkV "touchar" ; -- toucha..vb.1
  touchande_1_N = mkN "touchande" ; -- touchande..nn.1
  touche_1_N = mkN "touche" "toucher" ; -- touche..nn.1
  touchera_1_V = mkV "toucherar" ; -- touchera..vb.1
  toucherande_1_N = mkN "toucherande" ; -- toucherande..nn.1
  toucherbar_1_A = mkA "toucherbar" ; -- toucherbar..av.1
  toucherbarhet_1_N = mkN "toucherbarhet" ; -- toucherbarhet..nn.1
  touchering_1_N = mkN "touchering" ; -- touchering..nn.1
  touchmetod_1_N = mkN "touchmetod" ; -- touchmetod..nn.1
  toujours_1_A = mkA "toujours" ; -- toujours..av.1
  toupera_1_V = mkV "touperar" ; -- toupera..vb.1
  touperande_1_N = mkN "touperande" ; -- touperande..nn.1
  touperbar_1_A = mkA "touperbar" ; -- touperbar..av.1
  touperbarhet_1_N = mkN "touperbarhet" ; -- touperbarhet..nn.1
  toupering_1_N = mkN "toupering" ; -- toupering..nn.1
  toupé_1_N = mkN "toupé" "toupéer" ; -- toupé..nn.1
  tour_1_N = mkN "tour" "tourer" ; -- tour..nn.1
  tournedos_1_N = mkN "tournedos" "tournedoser" ; -- tournedos..nn.1
  tova_1_N = mkN "tova" ; -- tova..nn.1
  tova_1_V = mkV "tovar" ; -- tova..vb.1
  tovande_1_N = mkN "tovande" ; -- tovande..nn.1
  tovig_1_A = mkA "tovig" ; -- tovig..av.1
  tovighet_1_N = mkN "tovighet" ; -- tovighet..nn.1
  toxafen_1_N = mkN "toxafen" "toxafenet" "toxafener" "toxafenerna" ; -- toxafen..nn.1
  toxicitet_1_N = mkN "toxicitet" "toxiciteter" ; -- toxicitet..nn.1
  toxikolog_1_N = mkN "toxikolog" "toxikologer" ; -- toxikolog..nn.1
  toxikologi_1_N = mkN "toxikologi" ; -- toxikologi..nn.1
  toxikologisk_1_A = mkA "toxikologisk" ; -- toxikologisk..av.1
  toxikomani_1_N = mkN "toxikomani" ; -- toxikomani..nn.1
  toxin_1_N = mkN "toxin" ; -- toxin..nn.1
  toxisk_1_A = mkA "toxisk" ; -- toxisk..av.1
  tracka_1_V = mkV "trackar" ; -- tracka..vb.1
  trackande_1_N = mkN "trackande" ; -- trackande..nn.1
  trad_1_N = mkN "trad" "trader" ; -- trad..nn.1
  tradera_1_V = mkV "traderar" ; -- tradera..vb.1
  traderande_1_N = mkN "traderande" ; -- traderande..nn.1
  traderbar_1_A = mkA "traderbar" ; -- traderbar..av.1
  traderbarhet_1_N = mkN "traderbarhet" ; -- traderbarhet..nn.1
  tradering_1_N = mkN "tradering" ; -- tradering..nn.1
  tradig_1_A = mkA "tradig" ; -- tradig..av.1
  tradition_1_N = mkN "tradition" ; -- tradition..nn.1
  traditionalism_1_N = mkN "traditionalism" "traditionalismer" ; -- traditionalism..nn.1
  traditionalist_1_N = mkN "traditionalist" "traditionalister" ; -- traditionalist..nn.1
  traditionalistisk_1_A = mkA "traditionalistisk" ; -- traditionalistisk..av.1
  traditionell_1_A = mkA "traditionell" ; -- traditionell..av.1
  traditionsbrott_1_N = mkN "traditionsbrott" neutrum  ; -- traditionsbrott..nn.1
  traditionsbunden_1_A = mkA "traditionsbunden" ; -- traditionsbunden..av.1
  traditionsbärare_1_N = mkN "traditionsbärare" utrum  ; -- traditionsbärare..nn.1
  traditionsenlig_1_A = mkA "traditionsenlig" ; -- traditionsenlig..av.1
  traditionsenlighet_1_N = mkN "traditionsenlighet" ; -- traditionsenlighet..nn.1
  traditionsrik_1_A = mkA "traditionsrik" ; -- traditionsrik..av.1
  traditionstyngd_1_A = mkA "traditionstyngd" "traditionstyngt" ; -- traditionstyngd..av.1
  tradjazz_1_N = mkN "tradjazz" ; -- tradjazz..nn.1
  trafficking_1_N = mkN "trafficking" ; -- trafficking..nn.1
  traffickinganklagelse_1_N = mkN "traffickinganklagelse" "traffickinganklagelser" ; -- traffickinganklagelse..nn.1
  traffickingoffer_1_N = mkN "traffickingoffer" neutrum  ; -- traffickingoffer..nn.1
  trafik_1_N = mkN "trafik" ; -- trafik..nn.1
  trafikabel_1_A = mkA "trafikabel" ; -- trafikabel..av.1
  trafikansvarig_1_A = mkA "trafikansvarig" ; -- trafikansvarig..av.1
  trafikant_1_N = mkN "trafikant" "trafikanter" ; -- trafikant..nn.1
  trafikavspärrning_1_N = mkN "trafikavspärrning" ; -- trafikavspärrning..nn.1
  trafikbrus_1_N = mkN "trafikbrus" neutrum  ; -- trafikbrus..nn.1
  trafikbråk_1_N = mkN "trafikbråk" neutrum  ; -- trafikbråk..nn.1
  trafikbuller_1_N = mkN "trafikbuller" neutrum  ; -- trafikbuller..nn.1
  trafikdelare_1_N = mkN "trafikdelare" utrum  ; -- trafikdelare..nn.1
  trafikdöd_1_N = mkN "trafikdöd" ; -- trafikdöd..nn.1
  trafikdödad_1_A = mkA "trafikdödad" ; -- trafikdödad..av.1
  trafikera_1_V = mkV "trafikerar" ; -- trafikera..vb.1
  trafikerande_1_N = mkN "trafikerande" ; -- trafikerande..nn.1
  trafikerbar_1_A = mkA "trafikerbar" ; -- trafikerbar..av.1
  trafikerbarhet_1_N = mkN "trafikerbarhet" ; -- trafikerbarhet..nn.1
  trafikering_1_N = mkN "trafikering" ; -- trafikering..nn.1
  trafikexpert_1_N = mkN "trafikexpert" "trafikexperter" ; -- trafikexpert..nn.1
  trafikfarlig_1_A = mkA "trafikfarlig" ; -- trafikfarlig..av.1
  trafikfarlighet_1_N = mkN "trafikfarlighet" ; -- trafikfarlighet..nn.1
  trafikflyg_1_N = mkN "trafikflyg" neutrum  ; -- trafikflyg..nn.1
  trafikflygare_1_N = mkN "trafikflygare" utrum  ; -- trafikflygare..nn.1
  trafikflygplan_1_N = mkN "trafikflygplan" neutrum  ; -- trafikflygplan..nn.1
  trafikfyr_1_N = mkN "trafikfyr" ; -- trafikfyr..nn.1
  trafikförseelse_1_N = mkN "trafikförseelse" "trafikförseelser" ; -- trafikförseelse..nn.1
  trafikförsäkring_1_N = mkN "trafikförsäkring" ; -- trafikförsäkring..nn.1
  trafikinfarkt_1_N = mkN "trafikinfarkt" "trafikinfarkter" ; -- trafikinfarkt..nn.1
  trafikkaos_1_N = mkN "trafikkaos" neutrum  ; -- trafikkaos..nn.1
  trafikkontor_1_N = mkN "trafikkontor" neutrum  ; -- trafikkontor..nn.1
  trafikkontroll_1_N = mkN "trafikkontroll" "trafikkontroller" ; -- trafikkontroll..nn.1
  trafikkort_1_N = mkN "trafikkort" neutrum  ; -- trafikkort..nn.1
  trafikled_1_N = mkN "trafikled" "trafikleder" ; -- trafikled..nn.1
  trafikleda_1_V = mkV "trafikleda" "trafikledde" "trafiklett" ; -- trafikleda..vb.1
  trafikledande_1_N = mkN "trafikledande" ; -- trafikledande..nn.1
  trafikledare_1_N = mkN "trafikledare" utrum  ; -- trafikledare..nn.1
  trafikledning_1_N = mkN "trafikledning" ; -- trafikledning..nn.1
  trafikljus_1_N = mkN "trafikljus" neutrum  ; -- trafikljus..nn.1
  trafikläge_1_N = mkN "trafikläge" ; -- trafikläge..nn.1
  trafikmärke_1_N = mkN "trafikmärke" ; -- trafikmärke..nn.1
  trafikmässig_1_A = mkA "trafikmässig" ; -- trafikmässig..av.1
  trafiknämnd_1_N = mkN "trafiknämnd" "trafiknämnder" ; -- trafiknämnd..nn.1
  trafikolycka_1_N = mkN "trafikolycka" ; -- trafikolycka..nn.1
  trafikpilot_1_N = mkN "trafikpilot" "trafikpiloter" ; -- trafikpilot..nn.1
  trafikplats_1_N = mkN "trafikplats" "trafikplatser" ; -- trafikplats..nn.1
  trafikpolitik_1_N = mkN "trafikpolitik" ; -- trafikpolitik..nn.1
  trafikpolitisk_1_A = mkA "trafikpolitisk" ; -- trafikpolitisk..av.1
  trafikpulsåder_1_N = mkN "trafikpulsåder" ; -- trafikpulsåder..nn.1
  trafikregel_1_N = mkN "trafikregel" "trafikregeln" "trafikregler" "trafikreglerna" ; -- trafikregel..nn.1
  trafikreglera_1_V = mkV "trafikreglerar" ; -- trafikreglera..vb.1
  trafikreglerande_1_N = mkN "trafikreglerande" ; -- trafikreglerande..nn.1
  trafikreglerbar_1_A = mkA "trafikreglerbar" ; -- trafikreglerbar..av.1
  trafikreglerbarhet_1_N = mkN "trafikreglerbarhet" ; -- trafikreglerbarhet..nn.1
  trafikreglering_1_N = mkN "trafikreglering" ; -- trafikreglering..nn.1
  trafikråd_1_N = mkN "trafikråd" neutrum  ; -- trafikråd..nn.1
  trafikseparerad_1_A = mkA "trafikseparerad" ; -- trafikseparerad..av.1
  trafiksignal_1_N = mkN "trafiksignal" "trafiksignaler" ; -- trafiksignal..nn.1
  trafiksituation_1_N = mkN "trafiksituation" ; -- trafiksituation..nn.1
  trafikskada_1_N = mkN "trafikskada" ; -- trafikskada..nn.1
  trafikskadad_1_A = mkA "trafikskadad" ; -- trafikskadad..av.1
  trafikstockning_1_N = mkN "trafikstockning" ; -- trafikstockning..nn.1
  trafikström_1_N = mkN "trafikström" "trafikströmmen" "trafikströmmar" "trafikströmmarna" ; -- trafikström..nn.1
  trafiksäker_1_A = mkA "trafiksäker" ; -- trafiksäker..av.1
  trafiksäkerhet_1_N = mkN "trafiksäkerhet" "trafiksäkerheter" ; -- trafiksäkerhet..nn.1
  trafiksäkerhetschef_1_N = mkN "trafiksäkerhetschef" "trafiksäkerhetschefer" ; -- trafiksäkerhetschef..nn.1
  trafiksäkerhetsmässig_1_A = mkA "trafiksäkerhetsmässig" ; -- trafiksäkerhetsmässig..av.1
  trafiksäkerhetsverk_1_N = mkN "trafiksäkerhetsverk" neutrum  ; -- trafiksäkerhetsverk..nn.1
  trafiktillstånd_1_N = mkN "trafiktillstånd" neutrum  ; -- trafiktillstånd..nn.1
  trafikvakt_1_N = mkN "trafikvakt" "trafikvakter" ; -- trafikvakt..nn.1
  trafikvarning_1_N = mkN "trafikvarning" ; -- trafikvarning..nn.1
  tragedi_1_N = mkN "tragedi" "tragedier" ; -- tragedi..nn.1
  tragedienn_1_N = mkN "tragedienn" "tragedienner" ; -- tragedienn..nn.1
  tragediförfattare_1_N = mkN "tragediförfattare" utrum  ; -- tragediförfattare..nn.1
  traggel_1_N = mkN "traggel" neutrum  ; -- traggel..nn.1
  traggla_1_V = mkV "tragglar" ; -- traggla..vb.1
  tragglande_1_N = mkN "tragglande" ; -- tragglande..nn.1
  tragglig_1_A = mkA "tragglig" ; -- tragglig..av.1
  tragglighet_1_N = mkN "tragglighet" ; -- tragglighet..nn.1
  tragik_1_N = mkN "tragik" ; -- tragik..nn.1
  tragiker_1_N = mkN "tragiker" "tragikern" "tragiker" "tragikerna" ; -- tragiker..nn.1
  tragikomedi_1_N = mkN "tragikomedi" "tragikomedier" ; -- tragikomedi..nn.1
  tragikomisk_1_A = mkA "tragikomisk" ; -- tragikomisk..av.1
  tragisk_1_A = mkA "tragisk" ; -- tragisk..av.1
  tragisk_2_A = mkA "tragisk" ; -- tragisk..av.2
  tragöd_1_N = mkN "tragöd" "tragöder" ; -- tragöd..nn.1
  trailer_1_N = mkN "trailer" ; -- trailer..nn.1
  trainee_1_N = mkN "trainee" "traineen" "trainees" "traineesarna" ; -- trainee..nn.1
  traj_1_N = mkN "traj" neutrum  ; -- traj..nn.1
  traja_1_V = mkV "trajar" ; -- traja..vb.1
  trajande_1_N = mkN "trajande" ; -- trajande..nn.1
  trakassera_1_V = mkV "trakasserar" ; -- trakassera..vb.1
  trakasserande_1_N = mkN "trakasserande" ; -- trakasserande..nn.1
  trakasserbar_1_A = mkA "trakasserbar" ; -- trakasserbar..av.1
  trakasserbarhet_1_N = mkN "trakasserbarhet" ; -- trakasserbarhet..nn.1
  trakasseri_1_N = mkN "trakasseri" "trakasseriet" "trakasserier" "trakasserierna" ; -- trakasseri..nn.1
  trakassering_1_N = mkN "trakassering" ; -- trakassering..nn.1
  trakom_1_N = mkN "trakom" neutrum  ; -- trakom..nn.1
  trakt_1_N = mkN "trakt" "trakter" ; -- trakt..nn.1
  trakta_1_V = mkV "traktar" ; -- trakta..vb.1
  traktamente_1_N = mkN "traktamente" ; -- traktamente..nn.1
  traktan_1_N = mkN "traktan" ; -- traktan..nn.1
  traktande_1_N = mkN "traktande" ; -- traktande..nn.1
  traktat_1_N = mkN "traktat" "traktater" ; -- traktat..nn.1
  traktblädning_1_N = mkN "traktblädning" ; -- traktblädning..nn.1
  traktera_1_V = mkV "trakterar" ; -- traktera..vb.1
  trakterad_1_A = mkA "trakterad" ; -- trakterad..av.1
  trakterande_1_N = mkN "trakterande" ; -- trakterande..nn.1
  trakterbar_1_A = mkA "trakterbar" ; -- trakterbar..av.1
  trakterbarhet_1_N = mkN "trakterbarhet" ; -- trakterbarhet..nn.1
  traktering_1_N = mkN "traktering" ; -- traktering..nn.1
  trakthugga_1_V = mkV "trakthugga" "trakthögg" "trakthuggit" ; -- trakthugga..vb.1
  trakthuggande_1_N = mkN "trakthuggande" ; -- trakthuggande..nn.1
  traktor_1_N = mkN "traktor" "traktorer" ; -- traktor..nn.1
  traktordäck_1_N = mkN "traktordäck" neutrum  ; -- traktordäck..nn.1
  traktorkärra_1_N = mkN "traktorkärra" ; -- traktorkärra..nn.1
  traktorsläpvagn_1_N = mkN "traktorsläpvagn" ; -- traktorsläpvagn..nn.1
  traktorspår_1_N = mkN "traktorspår" neutrum  ; -- traktorspår..nn.1
  traktur_1_N = mkN "traktur" "trakturer" ; -- traktur..nn.1
  traktör_1_N = mkN "traktör" "traktörer" ; -- traktör..nn.1
  traktörpanna_1_N = mkN "traktörpanna" ; -- traktörpanna..nn.1
  trakyt_1_N = mkN "trakyt" "trakyter" ; -- trakyt..nn.1
  traké_1_N = mkN "traké" "trakéer" ; -- traké..nn.1
  trakégäl_1_N = mkN "trakégäl" ; -- trakégäl..nn.1
  trall_1_N = mkN "trall" ; -- trall..nn.1
  trall_2_N = mkN "trall" ; -- trall..nn.2
  tralla_1_N = mkN "tralla" ; -- tralla..nn.1
  tralla_1_V = mkV "trallar" ; -- tralla..vb.1
  trallande_1_N = mkN "trallande" ; -- trallande..nn.1
  trallvagn_1_N = mkN "trallvagn" ; -- trallvagn..nn.1
  trallvänlig_1_A = mkA "trallvänlig" ; -- trallvänlig..av.1
  tramp_1_N = mkN "tramp" neutrum  ; -- tramp..nn.1
  trampa_1_N = mkN "trampa" ; -- trampa..nn.1
  trampa_1_V = mkV "trampar" ; -- trampa..vb.1
  trampa_2_V = mkV "trampar" ; -- trampa..vb.2
  trampande_1_N = mkN "trampande" ; -- trampande..nn.1
  trampbil_1_N = mkN "trampbil" ; -- trampbil..nn.1
  trampbåt_1_N = mkN "trampbåt" ; -- trampbåt..nn.1
  trampcykel_1_N = mkN "trampcykel" ; -- trampcykel..nn.1
  trampdyna_1_N = mkN "trampdyna" ; -- trampdyna..nn.1
  trampfart_1_N = mkN "trampfart" ; -- trampfart..nn.1
  trampfartyg_1_N = mkN "trampfartyg" neutrum  ; -- trampfartyg..nn.1
  trampgräs_1_N = mkN "trampgräs" neutrum  ; -- trampgräs..nn.1
  tramphjul_1_N = mkN "tramphjul" neutrum  ; -- tramphjul..nn.1
  trampkvarn_1_N = mkN "trampkvarn" ; -- trampkvarn..nn.1
  trampmina_1_N = mkN "trampmina" ; -- trampmina..nn.1
  trampning_1_N = mkN "trampning" ; -- trampning..nn.1
  trampolin_1_N = mkN "trampolin" "trampoliner" ; -- trampolin..nn.1
  tramprörelse_1_N = mkN "tramprörelse" "tramprörelser" ; -- tramprörelse..nn.1
  trampsax_1_N = mkN "trampsax" ; -- trampsax..nn.1
  trampört_1_N = mkN "trampört" "trampörter" ; -- trampört..nn.1
  trams_1_N = mkN "trams" neutrum  ; -- trams..nn.1
  tramsa_1_V = mkV "tramsar" ; -- tramsa..vb.1
  tramsande_1_N = mkN "tramsande" ; -- tramsande..nn.1
  tramsig_1_A = mkA "tramsig" ; -- tramsig..av.1
  tramsighet_1_N = mkN "tramsighet" "tramsigheter" ; -- tramsighet..nn.1
  tran_1_N = mkN "tran" ; -- tran..nn.1
  trana_1_N = mkN "trana" ; -- trana..nn.1
  tranben_1_N = mkN "tranben" neutrum  ; -- tranben..nn.1
  tranbär_1_N = mkN "tranbär" neutrum  ; -- tranbär..nn.1
  tranbärssaft_1_N = mkN "tranbärssaft" "tranbärssafter" ; -- tranbärssaft..nn.1
  trance_1_N = mkN "trance" utrum  ; -- trance..nn.1
  tranch_1_N = mkN "tranch" "trancher" ; -- tranch..nn.1
  tranchera_1_V = mkV "trancherar" ; -- tranchera..vb.1
  trancherande_1_N = mkN "trancherande" ; -- trancherande..nn.1
  trancherbar_1_A = mkA "trancherbar" ; -- trancherbar..av.1
  trancherbarhet_1_N = mkN "trancherbarhet" ; -- trancherbarhet..nn.1
  trandans_1_N = mkN "trandans" ; -- trandans..nn.1
  tranedans_1_N = mkN "tranedans" ; -- tranedans..nn.1
  trankil_1_A = mkA "trankil" ; -- trankil..av.1
  trankilitet_1_N = mkN "trankilitet" "trankiliteter" ; -- trankilitet..nn.1
  tranlampa_1_N = mkN "tranlampa" ; -- tranlampa..nn.1
  trans_1_N = mkN "trans" ; -- trans..nn.1
  transa_1_N = mkN "transa" ; -- transa..nn.1
  transaktion_1_N = mkN "transaktion" ; -- transaktion..nn.1
  transaktionsanalys_1_N = mkN "transaktionsanalys" "transaktionsanalyser" ; -- transaktionsanalys..nn.1
  transalpin_1_A = mkA "transalpin" ; -- transalpin..av.1
  transalpinsk_1_A = mkA "transalpinsk" ; -- transalpinsk..av.1
  transatlantisk_1_A = mkA "transatlantisk" ; -- transatlantisk..av.1
  transcendens_1_N = mkN "transcendens" ; -- transcendens..nn.1
  transcendent_1_A = mkA "transcendent" "transcendent" ; -- transcendent..av.1
  transcendental_1_A = mkA "transcendental" ; -- transcendental..av.1
  transcendentalfilosofi_1_N = mkN "transcendentalfilosofi" ; -- transcendentalfilosofi..nn.1
  transcendenthet_1_N = mkN "transcendenthet" ; -- transcendenthet..nn.1
  transduktor_1_N = mkN "transduktor" "transduktorer" ; -- transduktor..nn.1
  transfer_1_N = mkN "transfer" ; -- transfer..nn.1
  transferera_1_V = mkV "transfererar" ; -- transferera..vb.1
  transfererande_1_N = mkN "transfererande" ; -- transfererande..nn.1
  transfererbar_1_A = mkA "transfererbar" ; -- transfererbar..av.1
  transfererbarhet_1_N = mkN "transfererbarhet" ; -- transfererbarhet..nn.1
  transferering_1_N = mkN "transferering" ; -- transferering..nn.1
  transfett_1_N = mkN "transfett" "transfettet" "transfetter" "transfetterna" ; -- transfett..nn.1
  transfiguration_1_N = mkN "transfiguration" ; -- transfiguration..nn.1
  transform_1_N = mkN "transform" "transformer" ; -- transform..nn.1
  transformation_1_N = mkN "transformation" ; -- transformation..nn.1
  transformationsgrammatik_1_N = mkN "transformationsgrammatik" "transformationsgrammatiker" ; -- transformationsgrammatik..nn.1
  transformator_1_N = mkN "transformator" "transformatorer" ; -- transformator..nn.1
  transformatorbrand_1_N = mkN "transformatorbrand" "transformatorbränder" ; -- transformatorbrand..nn.1
  transformatorkiosk_1_N = mkN "transformatorkiosk" "transformatorkiosker" ; -- transformatorkiosk..nn.1
  transformatorstation_1_N = mkN "transformatorstation" ; -- transformatorstation..nn.1
  transformera_1_V = mkV "transformerar" ; -- transformera..vb.1
  transformerande_1_N = mkN "transformerande" ; -- transformerande..nn.1
  transformerbar_1_A = mkA "transformerbar" ; -- transformerbar..av.1
  transformerbarhet_1_N = mkN "transformerbarhet" ; -- transformerbarhet..nn.1
  transformering_1_N = mkN "transformering" ; -- transformering..nn.1
  transfusion_1_N = mkN "transfusion" ; -- transfusion..nn.1
  transgen_1_A = mkA "transgen" "transgent" ; -- transgen..av.1
  transgression_1_N = mkN "transgression" ; -- transgression..nn.1
  transhora_1_N = mkN "transhora" ; -- transhora..nn.1
  transistor_1_N = mkN "transistor" "transistorer" ; -- transistor..nn.1
  transistorradio_1_N = mkN "transistorradio" ; -- transistorradio..nn.1
  transitera_1_V = mkV "transiterar" ; -- transitera..vb.1
  transiterande_1_N = mkN "transiterande" ; -- transiterande..nn.1
  transiterbar_1_A = mkA "transiterbar" ; -- transiterbar..av.1
  transiterbarhet_1_N = mkN "transiterbarhet" ; -- transiterbarhet..nn.1
  transitering_1_N = mkN "transitering" ; -- transitering..nn.1
  transithall_1_N = mkN "transithall" ; -- transithall..nn.1
  transitiv_1_A = mkA "transitiv" ; -- transitiv..av.1
  transitivitet_1_N = mkN "transitivitet" ; -- transitivitet..nn.1
  transitlast_1_N = mkN "transitlast" "transitlaster" ; -- transitlast..nn.1
  transitohamn_1_N = mkN "transitohamn" ; -- transitohamn..nn.1
  transitorisk_1_A = mkA "transitorisk" ; -- transitorisk..av.1
  transitresa_1_N = mkN "transitresa" ; -- transitresa..nn.1
  transkaukasisk_1_A = mkA "transkaukasisk" ; -- transkaukasisk..av.1
  transkontinental_1_A = mkA "transkontinental" ; -- transkontinental..av.1
  transkribera_1_V = mkV "transkriberar" ; -- transkribera..vb.1
  transkriberande_1_N = mkN "transkriberande" ; -- transkriberande..nn.1
  transkriberbar_1_A = mkA "transkriberbar" ; -- transkriberbar..av.1
  transkriberbarhet_1_N = mkN "transkriberbarhet" ; -- transkriberbarhet..nn.1
  transkribering_1_N = mkN "transkribering" ; -- transkribering..nn.1
  transkription_1_N = mkN "transkription" ; -- transkription..nn.1
  translativ_1_N = mkN "translativ" "translativer" ; -- translativ..nn.1
  translator_1_N = mkN "translator" "translatorer" ; -- translator..nn.1
  translitteration_1_N = mkN "translitteration" ; -- translitteration..nn.1
  translitterera_1_V = mkV "translittererar" ; -- translitterera..vb.1
  translittererande_1_N = mkN "translittererande" ; -- translittererande..nn.1
  translittererbar_1_A = mkA "translittererbar" ; -- translittererbar..av.1
  translittererbarhet_1_N = mkN "translittererbarhet" ; -- translittererbarhet..nn.1
  translitterering_1_N = mkN "translitterering" ; -- translitterering..nn.1
  transmission_1_N = mkN "transmission" ; -- transmission..nn.1
  transmitter_1_N = mkN "transmitter" ; -- transmitter..nn.1
  transmittera_1_V = mkV "transmitterar" ; -- transmittera..vb.1
  transmitterande_1_N = mkN "transmitterande" ; -- transmitterande..nn.1
  transmitterbar_1_A = mkA "transmitterbar" ; -- transmitterbar..av.1
  transmitterbarhet_1_N = mkN "transmitterbarhet" ; -- transmitterbarhet..nn.1
  transmittering_1_N = mkN "transmittering" ; -- transmittering..nn.1
  transmutation_1_N = mkN "transmutation" ; -- transmutation..nn.1
  transmutera_1_V = mkV "transmuterar" ; -- transmutera..vb.1
  transmuterande_1_N = mkN "transmuterande" ; -- transmuterande..nn.1
  transmuterbar_1_A = mkA "transmuterbar" ; -- transmuterbar..av.1
  transmuterbarhet_1_N = mkN "transmuterbarhet" ; -- transmuterbarhet..nn.1
  transmutering_1_N = mkN "transmutering" ; -- transmutering..nn.1
  transnationalitet_1_N = mkN "transnationalitet" ; -- transnationalitet..nn.1
  transnationell_1_A = mkA "transnationell" ; -- transnationell..av.1
  transocean_1_A = mkA "transocean" ; -- transocean..av.1
  transoceanisk_1_A = mkA "transoceanisk" ; -- transoceanisk..av.1
  transoceansk_1_A = mkA "transoceansk" ; -- transoceansk..av.1
  transparang_1_N = mkN "transparang" "transparanger" ; -- transparang..nn.1
  transparens_1_N = mkN "transparens" ; -- transparens..nn.1
  transparent_1_A = mkA "transparent" "transparent" ; -- transparent..av.1
  transparenthet_1_N = mkN "transparenthet" ; -- transparenthet..nn.1
  transperson_1_N = mkN "transperson" "transpersoner" ; -- transperson..nn.1
  transpiration_1_N = mkN "transpiration" ; -- transpiration..nn.1
  transpirera_1_V = mkV "transpirerar" ; -- transpirera..vb.1
  transpirerande_1_N = mkN "transpirerande" ; -- transpirerande..nn.1
  transpirering_1_N = mkN "transpirering" ; -- transpirering..nn.1
  transplantat_1_N = mkN "transplantat" neutrum  ; -- transplantat..nn.1
  transplantation_1_N = mkN "transplantation" ; -- transplantation..nn.1
  transplantera_1_V = mkV "transplanterar" ; -- transplantera..vb.1
  transplanterande_1_N = mkN "transplanterande" ; -- transplanterande..nn.1
  transplanterbar_1_A = mkA "transplanterbar" ; -- transplanterbar..av.1
  transplanterbarhet_1_N = mkN "transplanterbarhet" ; -- transplanterbarhet..nn.1
  transplantering_1_N = mkN "transplantering" ; -- transplantering..nn.1
  transponder_1_N = mkN "transponder" ; -- transponder..nn.1
  transponera_1_V = mkV "transponerar" ; -- transponera..vb.1
  transponerande_1_N = mkN "transponerande" ; -- transponerande..nn.1
  transponerbar_1_A = mkA "transponerbar" ; -- transponerbar..av.1
  transponerbarhet_1_N = mkN "transponerbarhet" ; -- transponerbarhet..nn.1
  transponering_1_N = mkN "transponering" ; -- transponering..nn.1
  transport_1_N = mkN "transport" "transporter" ; -- transport..nn.1
  transportabel_1_A = mkA "transportabel" ; -- transportabel..av.1
  transportanordning_1_N = mkN "transportanordning" ; -- transportanordning..nn.1
  transportarbetare_1_N = mkN "transportarbetare" utrum  ; -- transportarbetare..nn.1
  transportavtal_1_N = mkN "transportavtal" neutrum  ; -- transportavtal..nn.1
  transportbana_1_N = mkN "transportbana" ; -- transportbana..nn.1
  transportband_1_N = mkN "transportband" neutrum  ; -- transportband..nn.1
  transportberoende_1_A = mkA "transportberoende" ; -- transportberoende..av.1
  transportberoende_1_N = mkN "transportberoende" ; -- transportberoende..nn.1
  transportera_1_V = mkV "transporterar" ; -- transportera..vb.1
  transporterande_1_N = mkN "transporterande" ; -- transporterande..nn.1
  transporterbar_1_A = mkA "transporterbar" ; -- transporterbar..av.1
  transporterbarhet_1_N = mkN "transporterbarhet" ; -- transporterbarhet..nn.1
  transportering_1_N = mkN "transportering" ; -- transportering..nn.1
  transportförbud_1_N = mkN "transportförbud" neutrum  ; -- transportförbud..nn.1
  transportföretag_1_N = mkN "transportföretag" neutrum  ; -- transportföretag..nn.1
  transporthjul_1_N = mkN "transporthjul" neutrum  ; -- transporthjul..nn.1
  transportkostnad_1_N = mkN "transportkostnad" "transportkostnader" ; -- transportkostnad..nn.1
  transportkärra_1_N = mkN "transportkärra" ; -- transportkärra..nn.1
  transportläge_1_N = mkN "transportläge" ; -- transportläge..nn.1
  transportmedel_1_N = mkN "transportmedel" neutrum  ; -- transportmedel..nn.1
  transportmekanism_1_N = mkN "transportmekanism" "transportmekanismer" ; -- transportmekanism..nn.1
  transportmässig_1_A = mkA "transportmässig" ; -- transportmässig..av.1
  transportnät_1_N = mkN "transportnät" neutrum  ; -- transportnät..nn.1
  transportpolitik_1_N = mkN "transportpolitik" ; -- transportpolitik..nn.1
  transportpolitisk_1_A = mkA "transportpolitisk" ; -- transportpolitisk..av.1
  transportprocess_1_N = mkN "transportprocess" "transportprocesser" ; -- transportprocess..nn.1
  transportsträcka_1_N = mkN "transportsträcka" ; -- transportsträcka..nn.1
  transportsystem_1_N = mkN "transportsystem" neutrum  ; -- transportsystem..nn.1
  transportsäkerhet_1_N = mkN "transportsäkerhet" "transportsäkerheter" ; -- transportsäkerhet..nn.1
  transporttåg_1_N = mkN "transporttåg" neutrum  ; -- transporttåg..nn.1
  transportvagn_1_N = mkN "transportvagn" ; -- transportvagn..nn.1
  transportväsen_1_N = mkN "transportväsen" neutrum  ; -- transportväsen..nn.1
  transportör_1_N = mkN "transportör" "transportörer" ; -- transportör..nn.1
  transposition_1_N = mkN "transposition" ; -- transposition..nn.1
  transsexualitet_1_N = mkN "transsexualitet" ; -- transsexualitet..nn.1
  transsexuell_1_A = mkA "transsexuell" ; -- transsexuell..av.1
  transsibirisk_1_A = mkA "transsibirisk" ; -- transsibirisk..av.1
  transsubstantiation_1_N = mkN "transsubstantiation" ; -- transsubstantiation..nn.1
  transsubstantiationslära_1_N = mkN "transsubstantiationslära" ; -- transsubstantiationslära..nn.1
  transsylvansk_1_A = mkA "transsylvansk" ; -- transsylvansk..av.1
  transsylvanskhet_1_N = mkN "transsylvanskhet" ; -- transsylvanskhet..nn.1
  transubstantiation_1_N = mkN "transubstantiation" ; -- transubstantiation..nn.1
  transubstantiationslära_1_N = mkN "transubstantiationslära" ; -- transubstantiationslära..nn.1
  transumera_1_V = mkV "transumerar" ; -- transumera..vb.1
  transumerande_1_N = mkN "transumerande" ; -- transumerande..nn.1
  transumerbar_1_A = mkA "transumerbar" ; -- transumerbar..av.1
  transumerbarhet_1_N = mkN "transumerbarhet" ; -- transumerbarhet..nn.1
  transumering_1_N = mkN "transumering" ; -- transumering..nn.1
  transumt_1_N = mkN "transumt" neutrum  ; -- transumt..nn.1
  transuran_1_N = mkN "transuran" "transuraner" ; -- transuran..nn.1
  transversal_1_A = mkA "transversal" ; -- transversal..av.1
  transversal_1_N = mkN "transversal" "transversaler" ; -- transversal..nn.1
  transversalaxel_1_N = mkN "transversalaxel" ; -- transversalaxel..nn.1
  transversell_1_A = mkA "transversell" ; -- transversell..av.1
  transvestism_1_N = mkN "transvestism" "transvestismer" ; -- transvestism..nn.1
  transvestit_1_N = mkN "transvestit" "transvestiter" ; -- transvestit..nn.1
  transvestitism_1_N = mkN "transvestitism" "transvestitismer" ; -- transvestitism..nn.1
  trapets_1_N = mkN "trapets" "trapetser" ; -- trapets..nn.1
  trapets_2_N = mkN "trapets" "trapetser" ; -- trapets..nn.2
  trapetskonstnär_1_N = mkN "trapetskonstnär" "trapetskonstnärer" ; -- trapetskonstnär..nn.1
  trapetsoid_1_N = mkN "trapetsoid" "trapetsoider" ; -- trapetsoid..nn.1
  trapp_1_N = mkN "trapp" ; -- trapp..nn.1
  trapp_2_N = mkN "trapp" ; -- trapp..nn.2
  trappa_1_N = mkN "trappa" ; -- trappa..nn.1
  trappavsats_1_N = mkN "trappavsats" "trappavsatser" ; -- trappavsats..nn.1
  trapper_1_N = mkN "trapper" "trappern" "trapper" "trapperna" ; -- trapper..nn.1
  trappfunktion_1_N = mkN "trappfunktion" ; -- trappfunktion..nn.1
  trappgavel_1_N = mkN "trappgavel" ; -- trappgavel..nn.1
  trappgrind_1_N = mkN "trappgrind" ; -- trappgrind..nn.1
  trappgång_1_N = mkN "trappgång" ; -- trappgång..nn.1
  trapphall_1_N = mkN "trapphall" ; -- trapphall..nn.1
  trapphus_1_N = mkN "trapphus" neutrum  ; -- trapphus..nn.1
  trappist_1_N = mkN "trappist" "trappister" ; -- trappist..nn.1
  trappistkloster_1_N = mkN "trappistkloster" neutrum  ; -- trappistkloster..nn.1
  trappistmunk_1_N = mkN "trappistmunk" ; -- trappistmunk..nn.1
  trappistnunna_1_N = mkN "trappistnunna" ; -- trappistnunna..nn.1
  trappistorden_1_N = mkN "trappistorden" ; -- trappistorden..nn.1
  trappistöl_1_N = mkN "trappistöl" neutrum  ; -- trappistöl..nn.1
  trappklok_1_A = mkA "trappklok" ; -- trappklok..av.1
  trappkärra_1_N = mkN "trappkärra" ; -- trappkärra..nn.1
  trappliknande_1_A = mkA "trappliknande" ; -- trappliknande..av.1
  trappräcke_1_N = mkN "trappräcke" ; -- trappräcke..nn.1
  trappskiva_1_N = mkN "trappskiva" ; -- trappskiva..nn.1
  trappsmyg_1_N = mkN "trappsmyg" ; -- trappsmyg..nn.1
  trappsteg_1_N = mkN "trappsteg" neutrum  ; -- trappsteg..nn.1
  trappstege_1_N = mkN "trappstege" utrum  ; -- trappstege..nn.1
  trappstegsformad_1_A = mkA "trappstegsformad" ; -- trappstegsformad..av.1
  trappstegsvis_1_Adv = mkAdv "trappstegsvis" ; -- trappstegsvis..ab.1
  trappstädning_1_N = mkN "trappstädning" ; -- trappstädning..nn.1
  trapptorn_1_N = mkN "trapptorn" neutrum  ; -- trapptorn..nn.1
  trappuppgång_1_N = mkN "trappuppgång" ; -- trappuppgång..nn.1
  trasa_1_N = mkN "trasa" ; -- trasa..nn.1
  trasa_1_V = mkV "trasar" ; -- trasa..vb.1
  trasande_1_N = mkN "trasande" ; -- trasande..nn.1
  trasdocka_1_N = mkN "trasdocka" ; -- trasdocka..nn.1
  traselegans_1_N = mkN "traselegans" ; -- traselegans..nn.1
  traselegant_1_A = mkA "traselegant" "traselegant" ; -- traselegant..av.1
  trasgrann_1_A = mkA "trasgrann" "trasgrant" ; -- trasgrann..av.1
  trasha_1_V = mkV "trashar" ; -- trasha..vb.1
  trashande_1_N = mkN "trashande" ; -- trashande..nn.1
  trashank_1_N = mkN "trashank" ; -- trashank..nn.1
  trasig_1_A = mkA "trasig" ; -- trasig..av.1
  trasighet_1_N = mkN "trasighet" ; -- trasighet..nn.1
  traska_1_V = mkV "traskar" ; -- traska..vb.1
  traskande_1_N = mkN "traskande" ; -- traskande..nn.1
  trasmaja_1_N = mkN "trasmaja" ; -- trasmaja..nn.1
  trasmatta_1_N = mkN "trasmatta" ; -- trasmatta..nn.1
  trasproletariat_1_N = mkN "trasproletariat" neutrum  ; -- trasproletariat..nn.1
  trassat_1_N = mkN "trassat" "trassater" ; -- trassat..nn.1
  trassel_1_N = mkN "trassel" neutrum  ; -- trassel..nn.1
  trasselsudd_1_N = mkN "trasselsudd" ; -- trasselsudd..nn.1
  trassent_1_N = mkN "trassent" "trassenter" ; -- trassent..nn.1
  trassera_1_V = mkV "trasserar" ; -- trassera..vb.1
  trasserande_1_N = mkN "trasserande" ; -- trasserande..nn.1
  trasserbar_1_A = mkA "trasserbar" ; -- trasserbar..av.1
  trasserbarhet_1_N = mkN "trasserbarhet" ; -- trasserbarhet..nn.1
  trassering_1_N = mkN "trassering" ; -- trassering..nn.1
  trassla_1_V = mkV "trasslar" ; -- trassla..vb.1
  trasslande_1_N = mkN "trasslande" ; -- trasslande..nn.1
  trasslig_1_A = mkA "trasslig" ; -- trasslig..av.1
  trasslighet_1_N = mkN "trasslighet" "trassligheter" ; -- trasslighet..nn.1
  trast_1_N = mkN "trast" ; -- trast..nn.1
  trastfågel_1_N = mkN "trastfågel" ; -- trastfågel..nn.1
  trasunge_1_N = mkN "trasunge" utrum  ; -- trasunge..nn.1
  tratt_1_N = mkN "tratt" ; -- tratt..nn.1
  tratta_1_N = mkN "tratta" ; -- tratta..nn.1
  tratta_1_V = mkV "trattar" ; -- tratta..vb.1
  trattande_1_N = mkN "trattande" ; -- trattande..nn.1
  trattformig_1_A = mkA "trattformig" ; -- trattformig..av.1
  trattformighet_1_N = mkN "trattformighet" ; -- trattformighet..nn.1
  trattkantarell_1_N = mkN "trattkantarell" "trattkantareller" ; -- trattkantarell..nn.1
  trattliknande_1_A = mkA "trattliknande" ; -- trattliknande..av.1
  trattprick_1_N = mkN "trattprick" ; -- trattprick..nn.1
  trattskivling_1_N = mkN "trattskivling" ; -- trattskivling..nn.1
  trauma_1_N = mkN "trauma" "traumat" "traumer" "traumerna" ; -- trauma..nn.1
  traumatisera_1_V = mkV "traumatiserar" ; -- traumatisera..vb.1
  traumatiserande_1_N = mkN "traumatiserande" ; -- traumatiserande..nn.1
  traumatiserbar_1_A = mkA "traumatiserbar" ; -- traumatiserbar..av.1
  traumatiserbarhet_1_N = mkN "traumatiserbarhet" ; -- traumatiserbarhet..nn.1
  traumatisering_1_N = mkN "traumatisering" ; -- traumatisering..nn.1
  traumatisk_1_A = mkA "traumatisk" ; -- traumatisk..av.1
  trav_1_N = mkN "trav" ; -- trav..nn.1
  trav_2_N = mkN "trav" ; -- trav..nn.2
  trava_1_V = mkV "travar" ; -- trava..vb.1
  travande_1_N = mkN "travande" ; -- travande..nn.1
  travare_1_N = mkN "travare" utrum  ; -- travare..nn.1
  travbana_1_N = mkN "travbana" ; -- travbana..nn.1
  trave_1_N = mkN "trave" utrum  ; -- trave..nn.1
  travers_1_N = mkN "travers" "traverser" ; -- travers..nn.1
  travestera_1_V = mkV "travesterar" ; -- travestera..vb.1
  travesterande_1_N = mkN "travesterande" ; -- travesterande..nn.1
  travesterbar_1_A = mkA "travesterbar" ; -- travesterbar..av.1
  travesterbarhet_1_N = mkN "travesterbarhet" ; -- travesterbarhet..nn.1
  travestering_1_N = mkN "travestering" ; -- travestering..nn.1
  travesti_1_N = mkN "travesti" "travestier" ; -- travesti..nn.1
  travhäst_1_N = mkN "travhäst" ; -- travhäst..nn.1
  travsport_1_N = mkN "travsport" ; -- travsport..nn.1
  travsulky_1_N = mkN "travsulky" "travsulkyer" ; -- travsulky..nn.1
  travtips_1_N = mkN "travtips" neutrum  ; -- travtips..nn.1
  travtävling_1_N = mkN "travtävling" ; -- travtävling..nn.1
  trea_1_N = mkN "trea" ; -- trea..nn.1
  treaktare_1_N = mkN "treaktare" utrum  ; -- treaktare..nn.1
  trebent_1_A = mkA "trebent" "trebent" ; -- trebent..av.1
  trebenthet_1_N = mkN "trebenthet" ; -- trebenthet..nn.1
  trebetygskurs_1_N = mkN "trebetygskurs" "trebetygskurser" ; -- trebetygskurs..nn.1
  trecylindrig_1_A = mkA "trecylindrig" ; -- trecylindrig..av.1
  tredagarsfeber_1_N = mkN "tredagarsfeber" ; -- tredagarsfeber..nn.1
  tredagarskonferens_1_N = mkN "tredagarskonferens" "tredagarskonferenser" ; -- tredagarskonferens..nn.1
  tredagarspass_1_N = mkN "tredagarspass" neutrum  ; -- tredagarspass..nn.1
  tredelad_1_A = mkA "tredelad" ; -- tredelad..av.1
  tredelning_1_N = mkN "tredelning" ; -- tredelning..nn.1
  tredimensionell_1_A = mkA "tredimensionell" ; -- tredimensionell..av.1
  tredje_1_A = mkA "tredje" ; -- tredje..av.1
  tredjedag_1_N = mkN "tredjedag" ; -- tredjedag..nn.1
  tredjedagsfrossa_1_N = mkN "tredjedagsfrossa" ; -- tredjedagsfrossa..nn.1
  tredjedel_1_N = mkN "tredjedel" "tredjedelen" "tredjedelar" "tredjedelarna" ; -- tredjedel..nn.1
  tredjegenerationsemigrant_1_N = mkN "tredjegenerationsemigrant" "tredjegenerationsemigranter" ; -- tredjegenerationsemigrant..nn.1
  tredjegradsekvation_1_N = mkN "tredjegradsekvation" ; -- tredjegradsekvation..nn.1
  tredjegångstillsättning_1_N = mkN "tredjegångstillsättning" ; -- tredjegångstillsättning..nn.1
  tredjeopponent_1_N = mkN "tredjeopponent" "tredjeopponenter" ; -- tredjeopponent..nn.1
  tredjeplats_1_N = mkN "tredjeplats" "tredjeplatser" ; -- tredjeplats..nn.1
  tredsk_1_A = mkA "tredsk" ; -- tredsk..av.1
  tredska_1_N = mkN "tredska" ; -- tredska..nn.1
  tredskhet_1_N = mkN "tredskhet" ; -- tredskhet..nn.1
  tredskodom_1_N = mkN "tredskodom" ; -- tredskodom..nn.1
  tredubbel_1_A = mkA "tredubbel" ; -- tredubbel..av.1
  tredubbla_1_V = mkV "tredubblar" ; -- tredubbla..vb.1
  tredubblande_1_N = mkN "tredubblande" ; -- tredubblande..nn.1
  tredubbling_1_N = mkN "tredubbling" ; -- tredubbling..nn.1
  tredäckad_1_A = mkA "tredäckad" ; -- tredäckad..av.1
  tredäckare_1_N = mkN "tredäckare" utrum  ; -- tredäckare..nn.1
  treenig_1_A = mkA "treenig" ; -- treenig..av.1
  treenighet_1_N = mkN "treenighet" "treenigheter" ; -- treenighet..nn.1
  treenighetsmystik_1_N = mkN "treenighetsmystik" ; -- treenighetsmystik..nn.1
  trefald_1_N = mkN "trefald" "trefalder" ; -- trefald..nn.1
  trefaldig_1_A = mkA "trefaldig" ; -- trefaldig..av.1
  trefaldiga_1_V = mkV "trefaldigar" ; -- trefaldiga..vb.1
  trefaldigande_1_N = mkN "trefaldigande" ; -- trefaldigande..nn.1
  trefaldighet_1_N = mkN "trefaldighet" "trefaldigheter" ; -- trefaldighet..nn.1
  trefaldighetssöndag_1_N = mkN "trefaldighetssöndag" ; -- trefaldighetssöndag..nn.1
  trefas_1_A = mkA "trefas" ; -- trefas..av.1
  trefasig_1_A = mkA "trefasig" ; -- trefasig..av.1
  trefasström_1_N = mkN "trefasström" "trefasströmmen" "trefasströmmar" "trefasströmmarna" ; -- trefasström..nn.1
  trefilig_1_A = mkA "trefilig" ; -- trefilig..av.1
  trefilighet_1_N = mkN "trefilighet" ; -- trefilighet..nn.1
  trefjärdedelstakt_1_N = mkN "trefjärdedelstakt" ; -- trefjärdedelstakt..nn.1
  trefot_1_N = mkN "trefot" ; -- trefot..nn.1
  trefärgstryck_1_N = mkN "trefärgstryck" neutrum  ; -- trefärgstryck..nn.1
  treglasfönster_1_N = mkN "treglasfönster" neutrum  ; -- treglasfönster..nn.1
  trehjulig_1_A = mkA "trehjulig" ; -- trehjulig..av.1
  trehjuling_1_N = mkN "trehjuling" ; -- trehjuling..nn.1
  trehundratal_1_N = mkN "trehundratal" neutrum  ; -- trehundratal..nn.1
  trehörning_1_N = mkN "trehörning" ; -- trehörning..nn.1
  trehövdad_1_A = mkA "trehövdad" ; -- trehövdad..av.1
  trekant_1_N = mkN "trekant" "trekanter" ; -- trekant..nn.1
  trekantig_1_A = mkA "trekantig" ; -- trekantig..av.1
  trekantsprofil_1_N = mkN "trekantsprofil" "trekantsprofiler" ; -- trekantsprofil..nn.1
  trekarlspolska_1_N = mkN "trekarlspolska" ; -- trekarlspolska..nn.1
  treklang_1_N = mkN "treklang" "treklanger" ; -- treklang..nn.1
  treklöver_1_N = mkN "treklöver" ; -- treklöver..nn.1
  trekvart_1_N = mkN "trekvart" ; -- trekvart..nn.1
  trekvartslång_1_A = mkA "trekvartslång" ; -- trekvartslång..av.1
  trekvartsstrumpa_1_N = mkN "trekvartsstrumpa" ; -- trekvartsstrumpa..nn.1
  treledad_1_A = mkA "treledad" ; -- treledad..av.1
  treledarsystem_1_N = mkN "treledarsystem" neutrum  ; -- treledarsystem..nn.1
  treläkarstation_1_N = mkN "treläkarstation" ; -- treläkarstation..nn.1
  trema_1_N = mkN "trema" "tremat" "treman" "tremana" ; -- trema..nn.1
  tremastad_1_A = mkA "tremastad" ; -- tremastad..av.1
  tremastare_1_N = mkN "tremastare" utrum  ; -- tremastare..nn.1
  trematecken_1_N = mkN "trematecken" "trematecknet" "trematecken" "trematecknen" ; -- trematecken..nn.1
  tremiljarderssatsning_1_N = mkN "tremiljarderssatsning" ; -- tremiljarderssatsning..nn.1
  tremilsgräns_1_N = mkN "tremilsgräns" "tremilsgränser" ; -- tremilsgräns..nn.1
  tremolo_1_N = mkN "tremolo" "tremolot" "tremolon" "tremolona" ; -- tremolo..nn.1
  tremulant_1_N = mkN "tremulant" "tremulanter" ; -- tremulant..nn.1
  tremulera_1_V = mkV "tremulerar" ; -- tremulera..vb.1
  tremulerande_1_N = mkN "tremulerande" ; -- tremulerande..nn.1
  tremulering_1_N = mkN "tremulering" ; -- tremulering..nn.1
  tremänning_1_N = mkN "tremänning" ; -- tremänning..nn.1
  tremånadersperiod_1_N = mkN "tremånadersperiod" "tremånadersperioder" ; -- tremånadersperiod..nn.1
  trench_1_N = mkN "trench" ; -- trench..nn.1
  trenchcoat_1_N = mkN "trenchcoat" ; -- trenchcoat..nn.1
  trenchcoatklädd_1_A = mkA "trenchcoatklädd" ; -- trenchcoatklädd..av.1
  trend_1_N = mkN "trend" "trender" ; -- trend..nn.1
  trendanalys_1_N = mkN "trendanalys" "trendanalyser" ; -- trendanalys..nn.1
  trendanalysföretag_1_N = mkN "trendanalysföretag" neutrum  ; -- trendanalysföretag..nn.1
  trendbrott_1_N = mkN "trendbrott" neutrum  ; -- trendbrott..nn.1
  trendig_1_A = mkA "trendig" ; -- trendig..av.1
  trendighet_1_N = mkN "trendighet" "trendigheter" ; -- trendighet..nn.1
  trendkänslig_1_A = mkA "trendkänslig" ; -- trendkänslig..av.1
  trendkänslighet_1_N = mkN "trendkänslighet" ; -- trendkänslighet..nn.1
  trendmässig_1_A = mkA "trendmässig" ; -- trendmässig..av.1
  trendnisse_1_N = mkN "trendnisse" utrum  ; -- trendnisse..nn.1
  trendriktig_1_A = mkA "trendriktig" ; -- trendriktig..av.1
  trendriktighet_1_N = mkN "trendriktighet" ; -- trendriktighet..nn.1
  trendsättare_1_N = mkN "trendsättare" utrum  ; -- trendsättare..nn.1
  trepan_1_N = mkN "trepan" "trepaner" ; -- trepan..nn.1
  trepanation_1_N = mkN "trepanation" ; -- trepanation..nn.1
  trepanera_1_V = mkV "trepanerar" ; -- trepanera..vb.1
  trepanerande_1_N = mkN "trepanerande" ; -- trepanerande..nn.1
  trepanerbar_1_A = mkA "trepanerbar" ; -- trepanerbar..av.1
  trepanerbarhet_1_N = mkN "trepanerbarhet" ; -- trepanerbarhet..nn.1
  trepanering_1_N = mkN "trepanering" ; -- trepanering..nn.1
  trepartiregering_1_N = mkN "trepartiregering" ; -- trepartiregering..nn.1
  trepass_1_N = mkN "trepass" neutrum  ; -- trepass..nn.1
  trepunktsbälte_1_N = mkN "trepunktsbälte" ; -- trepunktsbälte..nn.1
  treradig_1_A = mkA "treradig" ; -- treradig..av.1
  trerading_1_N = mkN "trerading" ; -- trerading..nn.1
  trerummare_1_N = mkN "trerummare" utrum  ; -- trerummare..nn.1
  trerumslägenhet_1_N = mkN "trerumslägenhet" "trerumslägenheter" ; -- trerumslägenhet..nn.1
  trerätters_1_N = mkN "trerätters" ; -- trerätters..nn.1
  trerättersmeny_1_N = mkN "trerättersmeny" "trerättersmenyer" ; -- trerättersmeny..nn.1
  trerättersmiddag_1_N = mkN "trerättersmiddag" ; -- trerättersmiddag..nn.1
  tresidig_1_A = mkA "tresidig" ; -- tresidig..av.1
  tresiffrig_1_A = mkA "tresiffrig" ; -- tresiffrig..av.1
  tresitsig_1_A = mkA "tresitsig" ; -- tresitsig..av.1
  treskeppig_1_A = mkA "treskeppig" ; -- treskeppig..av.1
  treskift_1_N = mkN "treskift" neutrum  ; -- treskift..nn.1
  treskifte_1_N = mkN "treskifte" ; -- treskifte..nn.1
  treskiftesbruk_1_N = mkN "treskiftesbruk" neutrum  ; -- treskiftesbruk..nn.1
  tresnibb_1_N = mkN "tresnibb" ; -- tresnibb..nn.1
  trespann_1_N = mkN "trespann" neutrum  ; -- trespann..nn.1
  trespänd_1_A = mkA "trespänd" ; -- trespänd..av.1
  trestavig_1_A = mkA "trestavig" ; -- trestavig..av.1
  trestavighet_1_N = mkN "trestavighet" ; -- trestavighet..nn.1
  tresteg_1_N = mkN "tresteg" neutrum  ; -- tresteg..nn.1
  trestegshopp_1_N = mkN "trestegshopp" neutrum  ; -- trestegshopp..nn.1
  trestegsraket_1_N = mkN "trestegsraket" "trestegsraketer" ; -- trestegsraket..nn.1
  trestjärnig_1_A = mkA "trestjärnig" ; -- trestjärnig..av.1
  trestruken_1_A = mkA "trestruken" ; -- trestruken..av.1
  trestämmig_1_A = mkA "trestämmig" ; -- trestämmig..av.1
  tretakt_1_N = mkN "tretakt" ; -- tretakt..nn.1
  tretal_1_N = mkN "tretal" neutrum  ; -- tretal..nn.1
  tretand_1_N = mkN "tretand" ; -- tretand..nn.1
  trettifemte_1_A = mkA "trettifemte" ; -- trettifemte..av.1
  trettifemårsålder_1_N = mkN "trettifemårsålder" ; -- trettifemårsålder..nn.1
  trettiodagarsperiod_1_N = mkN "trettiodagarsperiod" "trettiodagarsperioder" ; -- trettiodagarsperiod..nn.1
  trettiofemte_1_A = mkA "trettiofemte" ; -- trettiofemte..av.1
  trettiofemårsålder_1_N = mkN "trettiofemårsålder" ; -- trettiofemårsålder..nn.1
  trettionde_1_A = mkA "trettionde" ; -- trettionde..av.1
  trettiondel_1_N = mkN "trettiondel" "trettiondelen" "trettiondelar" "trettiondelarna" ; -- trettiondel..nn.1
  trettiotal_1_N = mkN "trettiotal" neutrum  ; -- trettiotal..nn.1
  trettioårig_1_A = mkA "trettioårig" ; -- trettioårig..av.1
  trettioåttonde_1_A = mkA "trettioåttonde" ; -- trettioåttonde..av.1
  trettital_1_N = mkN "trettital" neutrum  ; -- trettital..nn.1
  trettiårig_1_A = mkA "trettiårig" ; -- trettiårig..av.1
  trettiåttonde_1_A = mkA "trettiåttonde" ; -- trettiåttonde..av.1
  trettondag_1_N = mkN "trettondag" ; -- trettondag..nn.1
  trettondagsafton_1_N = mkN "trettondagsafton" "trettondagsaftonen" "trettondagsaftnar" "trettondagsaftnarna" ; -- trettondagsafton..nn.1
  trettonde_1_A = mkA "trettonde" ; -- trettonde..av.1
  trettondedag_1_N = mkN "trettondedag" ; -- trettondedag..nn.1
  trettondedagsafton_1_N = mkN "trettondedagsafton" "trettondedagsaftonen" "trettondedagsaftnar" "trettondedagsaftnarna" ; -- trettondedagsafton..nn.1
  trettondel_1_N = mkN "trettondel" "trettondelen" "trettondelar" "trettondelarna" ; -- trettondel..nn.1
  trettonhundratal_1_N = mkN "trettonhundratal" neutrum  ; -- trettonhundratal..nn.1
  trettonårig_1_A = mkA "trettonårig" ; -- trettonårig..av.1
  trettonåring_1_N = mkN "trettonåring" ; -- trettonåring..nn.1
  tretumsspik_1_N = mkN "tretumsspik" ; -- tretumsspik..nn.1
  tretungad_1_A = mkA "tretungad" ; -- tretungad..av.1
  tretåig_1_A = mkA "tretåig" ; -- tretåig..av.1
  tretår_1_N = mkN "tretår" ; -- tretår..nn.1
  treudd_1_N = mkN "treudd" ; -- treudd..nn.1
  treva_1_V = mkV "trevar" ; -- treva..vb.1
  trevande_1_A = mkA "trevande" ; -- trevande..av.1
  trevande_1_N = mkN "trevande" ; -- trevande..nn.1
  trevare_1_N = mkN "trevare" utrum  ; -- trevare..nn.1
  treven_1_A = mkA "treven" ; -- treven..av.1
  trevinklig_1_A = mkA "trevinklig" ; -- trevinklig..av.1
  trevinklighet_1_N = mkN "trevinklighet" ; -- trevinklighet..nn.1
  trevlig_1_A = mkA "trevlig" ; -- trevlig..av.1
  trevlighet_1_N = mkN "trevlighet" "trevligheter" ; -- trevlighet..nn.1
  trevnad_1_N = mkN "trevnad" "trevnader" ; -- trevnad..nn.1
  trevnadskänsla_1_N = mkN "trevnadskänsla" ; -- trevnadskänsla..nn.1
  trevägskran_1_N = mkN "trevägskran" ; -- trevägskran..nn.1
  trevåningshus_1_N = mkN "trevåningshus" neutrum  ; -- trevåningshus..nn.1
  treårig_1_A = mkA "treårig" ; -- treårig..av.1
  treåring_1_N = mkN "treåring" ; -- treåring..nn.1
  triad_1_N = mkN "triad" "triader" ; -- triad..nn.1
  triage_1_N = mkN "triage" "triagen" "triage" "triagen" ; -- triage..nn.1
  trial_and_error_1_N = mkN "trial-and-error" ; -- trial-and-error..nn.1
  trial_1_N = mkN "trial" ; -- trial..nn.1
  triangel_1_N = mkN "triangel" ; -- triangel..nn.1
  triangelbyte_1_N = mkN "triangelbyte" ; -- triangelbyte..nn.1
  triangeldrama_1_N = mkN "triangeldrama" "triangeldramat" "triangeldramer" "triangeldramerna" ; -- triangeldrama..nn.1
  triangelformad_1_A = mkA "triangelformad" ; -- triangelformad..av.1
  triangelkoppling_1_N = mkN "triangelkoppling" ; -- triangelkoppling..nn.1
  triangelmatch_1_N = mkN "triangelmatch" "triangelmatcher" ; -- triangelmatch..nn.1
  triangelmätning_1_N = mkN "triangelmätning" ; -- triangelmätning..nn.1
  triangelpunkt_1_N = mkN "triangelpunkt" "triangelpunkter" ; -- triangelpunkt..nn.1
  triangelreflex_1_N = mkN "triangelreflex" "triangelreflexer" ; -- triangelreflex..nn.1
  triangelsida_1_N = mkN "triangelsida" ; -- triangelsida..nn.1
  triangulera_1_V = mkV "triangulerar" ; -- triangulera..vb.1
  triangulerande_1_N = mkN "triangulerande" ; -- triangulerande..nn.1
  triangulerbar_1_A = mkA "triangulerbar" ; -- triangulerbar..av.1
  triangulerbarhet_1_N = mkN "triangulerbarhet" ; -- triangulerbarhet..nn.1
  triangulering_1_N = mkN "triangulering" ; -- triangulering..nn.1
  triangulär_1_A = mkA "triangulär" ; -- triangulär..av.1
  trias_1_N = mkN "trias" ; -- trias..nn.1
  tribad_1_N = mkN "tribad" "tribader" ; -- tribad..nn.1
  tribadisk_1_A = mkA "tribadisk" ; -- tribadisk..av.1
  tribadism_1_N = mkN "tribadism" "tribadismer" ; -- tribadism..nn.1
  tribalism_1_N = mkN "tribalism" "tribalismer" ; -- tribalism..nn.1
  tribalistisk_1_A = mkA "tribalistisk" ; -- tribalistisk..av.1
  tribun_1_N = mkN "tribun" "tribuner" ; -- tribun..nn.1
  tribunal_1_N = mkN "tribunal" "tribunaler" ; -- tribunal..nn.1
  tribunat_1_N = mkN "tribunat" neutrum  ; -- tribunat..nn.1
  tribut_1_N = mkN "tribut" "tributer" ; -- tribut..nn.1
  tricepsmuskel_1_N = mkN "tricepsmuskel" "tricepsmuskeln" "tricepsmuskler" "tricepsmusklerna" ; -- tricepsmuskel..nn.1
  trick_1_N = mkN "trick" neutrum  ; -- trick..nn.1
  trick_2_N = mkN "trick" ; -- trick..nn.2
  trickfilm_1_N = mkN "trickfilm" "trickfilmer" ; -- trickfilm..nn.1
  trickfilma_1_V = mkV "trickfilmar" ; -- trickfilma..vb.1
  trickfilmande_1_N = mkN "trickfilmande" ; -- trickfilmande..nn.1
  trickfilmning_1_N = mkN "trickfilmning" ; -- trickfilmning..nn.1
  tricks_1_N = mkN "tricks" neutrum  ; -- tricks..nn.1
  tricksa_1_V = mkV "tricksar" ; -- tricksa..vb.1
  tricksande_1_N = mkN "tricksande" ; -- tricksande..nn.1
  triennal_1_N = mkN "triennal" "triennaler" ; -- triennal..nn.1
  triera_1_V = mkV "trierar" ; -- triera..vb.1
  trierande_1_N = mkN "trierande" ; -- trierande..nn.1
  trierbar_1_A = mkA "trierbar" ; -- trierbar..av.1
  trierbarhet_1_N = mkN "trierbarhet" ; -- trierbarhet..nn.1
  triering_1_N = mkN "triering" ; -- triering..nn.1
  trift_1_N = mkN "trift" ; -- trift..nn.1
  triftong_1_N = mkN "triftong" "triftonger" ; -- triftong..nn.1
  triftongisk_1_A = mkA "triftongisk" ; -- triftongisk..av.1
  trigga_1_V = mkV "triggar" ; -- trigga..vb.1
  triggande_1_N = mkN "triggande" ; -- triggande..nn.1
  triggning_1_N = mkN "triggning" ; -- triggning..nn.1
  triglyf_1_N = mkN "triglyf" "triglyfer" ; -- triglyf..nn.1
  trigonometri_1_N = mkN "trigonometri" ; -- trigonometri..nn.1
  trigonometrisk_1_A = mkA "trigonometrisk" ; -- trigonometrisk..av.1
  trigram_1_N = mkN "trigram" "trigrammet" "trigram" "trigrammen" ; -- trigram..nn.1
  trikin_1_N = mkN "trikin" "trikiner" ; -- trikin..nn.1
  trikinos_1_N = mkN "trikinos" ; -- trikinos..nn.1
  trikinös_1_A = mkA "trikinös" ; -- trikinös..av.1
  trikloretylen_1_N = mkN "trikloretylen" neutrum  ; -- trikloretylen..nn.1
  trikolor_1_N = mkN "trikolor" "trikoloren" "trikolorer" "trikolorerna" ; -- trikolor..nn.1
  trikotage_1_N = mkN "trikotage" ; -- trikotage..nn.1
  trikå_1_N = mkN "trikå" "trikåer" ; -- trikå..nn.1
  trikåvara_1_N = mkN "trikåvara" ; -- trikåvara..nn.1
  trilateral_1_A = mkA "trilateral" ; -- trilateral..av.1
  triljon_1_N = mkN "triljon" "triljoner" ; -- triljon..nn.1
  triljondel_1_N = mkN "triljondel" "triljondelen" "triljondelar" "triljondelarna" ; -- triljondel..nn.1
  triljonte_1_A = mkA "triljonte" ; -- triljonte..av.1
  trilla_1_N = mkN "trilla" ; -- trilla..nn.1
  trilla_1_V = mkV "trillar" ; -- trilla..vb.1
  trillande_1_N = mkN "trillande" ; -- trillande..nn.1
  trilling_1_N = mkN "trilling" ; -- trilling..nn.1
  trillingfödsel_1_N = mkN "trillingfödsel" ; -- trillingfödsel..nn.1
  trillingkristall_1_N = mkN "trillingkristall" "trillingkristaller" ; -- trillingkristall..nn.1
  trillingnerv_1_N = mkN "trillingnerv" "trillingnerver" ; -- trillingnerv..nn.1
  trillion_1_N = mkN "trillion" ; -- trillion..nn.1
  trillionte_1_A = mkA "trillionte" ; -- trillionte..av.1
  trilobit_1_N = mkN "trilobit" "trilobiter" ; -- trilobit..nn.1
  trilogi_1_N = mkN "trilogi" "trilogier" ; -- trilogi..nn.1
  trilsk_1_A = mkA "trilsk" ; -- trilsk..av.1
  trilska_1_N = mkN "trilska" ; -- trilska..nn.1
  trilskande_1_A = mkA "trilskande" ; -- trilskande..av.1
  trilsken_1_A = mkA "trilsken" ; -- trilsken..av.1
  trilskhet_1_N = mkN "trilskhet" ; -- trilskhet..nn.1
  trimeter_1_N = mkN "trimeter" ; -- trimeter..nn.1
  trimhuvud_1_N = mkN "trimhuvud" "trimhuvudet" "trimhuvud" "trimhuvudena" ; -- trimhuvud..nn.1
  trimma_1_V = mkV "trimmar" ; -- trimma..vb.1
  trimmande_1_N = mkN "trimmande" ; -- trimmande..nn.1
  trimmer_1_N = mkN "trimmer" "trimmern" "trimrar" "trimrarna" ; -- trimmer..nn.1
  trimmerspole_1_N = mkN "trimmerspole" utrum  ; -- trimmerspole..nn.1
  trimmertråd_1_N = mkN "trimmertråd" ; -- trimmertråd..nn.1
  trimning_1_N = mkN "trimning" ; -- trimning..nn.1
  trimningsfunktion_1_N = mkN "trimningsfunktion" ; -- trimningsfunktion..nn.1
  trimtank_1_N = mkN "trimtank" ; -- trimtank..nn.1
  trind_1_A = mkA "trind" ; -- trind..av.1
  trindbladig_1_A = mkA "trindbladig" ; -- trindbladig..av.1
  trindhet_1_N = mkN "trindhet" ; -- trindhet..nn.1
  trindmask_1_N = mkN "trindmask" ; -- trindmask..nn.1
  trindsnö_1_N = mkN "trindsnö" ; -- trindsnö..nn.1
  trindsäd_1_N = mkN "trindsäd" ; -- trindsäd..nn.1
  trindyxa_1_N = mkN "trindyxa" ; -- trindyxa..nn.1
  trinidadier_1_N = mkN "trinidadier" "trinidadiern" "trinidadier" "trinidadierna" ; -- trinidadier..nn.1
  trinidadisk_1_A = mkA "trinidadisk" ; -- trinidadisk..av.1
  trinidadiska_1_N = mkN "trinidadiska" ; -- trinidadiska..nn.1
  trio_1_N = mkN "trio" "trior" ; -- trio..nn.1
  triod_1_N = mkN "triod" "trioder" ; -- triod..nn.1
  triol_1_N = mkN "triol" "trioler" ; -- triol..nn.1
  triologi_1_N = mkN "triologi" "triologier" ; -- triologi..nn.1
  trioxipurin_1_N = mkN "trioxipurin" "trioxipuriner" ; -- trioxipurin..nn.1
  triplett_1_N = mkN "triplett" "tripletter" ; -- triplett..nn.1
  triploid_1_A = mkA "triploid" ; -- triploid..av.1
  tripod_1_N = mkN "tripod" "tripoder" ; -- tripod..nn.1
  tripp_1_N = mkN "tripp" ; -- tripp..nn.1
  tripp_2_N = mkN "tripp" neutrum  ; -- tripp..nn.2
  trippa_1_V = mkV "trippar" ; -- trippa..vb.1
  trippande_1_N = mkN "trippande" ; -- trippande..nn.1
  trippel_1_A = mkA "trippel" ; -- trippel..av.1
  trippel_1_N = mkN "trippel" ; -- trippel..nn.1
  trippel_2_N = mkN "trippel" ; -- trippel..nn.2
  trippel_3_N = mkN "trippel" "trippeln" "trippler" "tripplerna" ; -- trippel..nn.3
  trippelallians_1_N = mkN "trippelallians" "trippelallianser" ; -- trippelallians..nn.1
  trippelfödsel_1_N = mkN "trippelfödsel" ; -- trippelfödsel..nn.1
  trippelkrock_1_N = mkN "trippelkrock" ; -- trippelkrock..nn.1
  trippelpunkt_1_N = mkN "trippelpunkt" "trippelpunkter" ; -- trippelpunkt..nn.1
  trippelseger_1_N = mkN "trippelseger" ; -- trippelseger..nn.1
  trippelstjärna_1_N = mkN "trippelstjärna" ; -- trippelstjärna..nn.1
  trippelvaccin_1_N = mkN "trippelvaccin" ; -- trippelvaccin..nn.1
  trippla_1_V = mkV "tripplar" ; -- trippla..vb.1
  tripplande_1_N = mkN "tripplande" ; -- tripplande..nn.1
  tripplare_1_N = mkN "tripplare" utrum  ; -- tripplare..nn.1
  trippmätare_1_N = mkN "trippmätare" utrum  ; -- trippmätare..nn.1
  trips_1_N = mkN "trips" ; -- trips..nn.1
  triptyk_1_N = mkN "triptyk" "triptyker" ; -- triptyk..nn.1
  trirem_1_N = mkN "trirem" "triremer" ; -- trirem..nn.1
  triskaidekafobi_1_N = mkN "triskaidekafobi" ; -- triskaidekafobi..nn.1
  triss_1_N = mkN "triss" ; -- triss..nn.1
  trissa_1_N = mkN "trissa" ; -- trissa..nn.1
  trisslott_1_N = mkN "trisslott" "trisslotter" ; -- trisslott..nn.1
  trist_1_A = mkA "trist" "trist" ; -- trist..av.1
  tristess_1_N = mkN "tristess" ; -- tristess..nn.1
  tristhet_1_N = mkN "tristhet" ; -- tristhet..nn.1
  tritium_1_N = mkN "tritium" neutrum  ; -- tritium..nn.1
  triton_1_N = mkN "triton" "tritoner" ; -- triton..nn.1
  triumf_1_N = mkN "triumf" "triumfer" ; -- triumf..nn.1
  triumfator_1_N = mkN "triumfator" "triumfatorer" ; -- triumfator..nn.1
  triumfatorisk_1_A = mkA "triumfatorisk" ; -- triumfatorisk..av.1
  triumfbåge_1_N = mkN "triumfbåge" utrum  ; -- triumfbåge..nn.1
  triumfera_1_V = mkV "triumferar" ; -- triumfera..vb.1
  triumferande_1_N = mkN "triumferande" ; -- triumferande..nn.1
  triumfering_1_N = mkN "triumfering" ; -- triumfering..nn.1
  triumftåg_1_N = mkN "triumftåg" neutrum  ; -- triumftåg..nn.1
  triumfvagn_1_N = mkN "triumfvagn" ; -- triumfvagn..nn.1
  triumvir_1_N = mkN "triumvir" "triumvirer" ; -- triumvir..nn.1
  triumvirat_1_N = mkN "triumvirat" neutrum  ; -- triumvirat..nn.1
  trivial_1_A = mkA "trivial" ; -- trivial..av.1
  trivialisera_1_V = mkV "trivialiserar" ; -- trivialisera..vb.1
  trivialiserande_1_N = mkN "trivialiserande" ; -- trivialiserande..nn.1
  trivialiserbar_1_A = mkA "trivialiserbar" ; -- trivialiserbar..av.1
  trivialiserbarhet_1_N = mkN "trivialiserbarhet" ; -- trivialiserbarhet..nn.1
  trivialisering_1_N = mkN "trivialisering" ; -- trivialisering..nn.1
  trivialitet_1_N = mkN "trivialitet" "trivialiteter" ; -- trivialitet..nn.1
  trivialnamn_1_N = mkN "trivialnamn" neutrum  ; -- trivialnamn..nn.1
  trivialskola_1_N = mkN "trivialskola" ; -- trivialskola..nn.1
  trivsam_1_A = mkA "trivsam" "trivsamt" "trivsamma" "trivsamma" "trivsammare" "trivsammast" "trivsammaste" ; -- trivsam..av.1
  trivsamhet_1_N = mkN "trivsamhet" "trivsamheter" ; -- trivsamhet..nn.1
  trivsel_1_N = mkN "trivsel" ; -- trivsel..nn.1
  trivselfaktor_1_N = mkN "trivselfaktor" "trivselfaktorer" ; -- trivselfaktor..nn.1
  trivselregel_1_N = mkN "trivselregel" "trivselregeln" "trivselregler" "trivselreglerna" ; -- trivselregel..nn.1
  trivselvikt_1_N = mkN "trivselvikt" "trivselvikter" ; -- trivselvikt..nn.1
  trivselåtgärd_1_N = mkN "trivselåtgärd" "trivselåtgärder" ; -- trivselåtgärd..nn.1
  trix_1_N = mkN "trix" neutrum  ; -- trix..nn.1
  trixa_1_V = mkV "trixar" ; -- trixa..vb.1
  trixande_1_N = mkN "trixande" ; -- trixande..nn.1
  trixig_1_A = mkA "trixig" ; -- trixig..av.1
  trixighet_1_N = mkN "trixighet" "trixigheter" ; -- trixighet..nn.1
  trixighet_2_N = mkN "trixighet" ; -- trixighet..nn.2
  triör_1_N = mkN "triör" "triörer" ; -- triör..nn.1
  tro_1_N = mkN "tro" ; -- tro..nn.1
  tro_1_V = mkV "tror" ; -- tro..vb.1
  troende_1_A = mkA "troende" ; -- troende..av.1
  troende_1_N = mkN "troende" ; -- troende..nn.1
  trofast_1_A = mkA "trofast" "trofast" ; -- trofast..av.1
  trofasthet_1_N = mkN "trofasthet" "trofastheter" ; -- trofasthet..nn.1
  trofé_1_N = mkN "trofé" "troféer" ; -- trofé..nn.1
  troféprydd_1_A = mkA "troféprydd" ; -- troféprydd..av.1
  trogen_1_A = mkA "trogen" ; -- trogen..av.1
  trogenhet_1_N = mkN "trogenhet" "trogenheter" ; -- trogenhet..nn.1
  troglodyt_1_N = mkN "troglodyt" "troglodyter" ; -- troglodyt..nn.1
  trohet_1_N = mkN "trohet" "troheter" ; -- trohet..nn.1
  trohetsbrott_1_N = mkN "trohetsbrott" neutrum  ; -- trohetsbrott..nn.1
  trohetsed_1_N = mkN "trohetsed" "trohetseder" ; -- trohetsed..nn.1
  trohetslöfte_1_N = mkN "trohetslöfte" ; -- trohetslöfte..nn.1
  trohjärtad_1_A = mkA "trohjärtad" ; -- trohjärtad..av.1
  trohjärtenhet_1_N = mkN "trohjärtenhet" "trohjärtenheter" ; -- trohjärtenhet..nn.1
  trojan_1_N = mkN "trojan" "trojaner" ; -- trojan..nn.1
  trojansk_1_A = mkA "trojansk" ; -- trojansk..av.1
  trojeborg_1_N = mkN "trojeborg" ; -- trojeborg..nn.1
  trojka_1_N = mkN "trojka" ; -- trojka..nn.1
  trokaisk_1_A = mkA "trokaisk" ; -- trokaisk..av.1
  trokeisk_1_A = mkA "trokeisk" ; -- trokeisk..av.1
  troké_1_N = mkN "troké" "trokéer" ; -- troké..nn.1
  trokéisk_1_A = mkA "trokéisk" ; -- trokéisk..av.1
  trolig_1_A = mkA "trolig" ; -- trolig..av.1
  troligen_1_Adv = mkAdv "troligen" ; -- troligen..ab.1
  trolighet_1_N = mkN "trolighet" ; -- trolighet..nn.1
  troligtvis_1_Adv = mkAdv "troligtvis" ; -- troligtvis..ab.1
  troll_1_N = mkN "troll" neutrum  ; -- troll..nn.1
  trolla_1_V = mkV "trollar" ; -- trolla..vb.1
  trollande_1_N = mkN "trollande" ; -- trollande..nn.1
  trollbarn_1_N = mkN "trollbarn" neutrum  ; -- trollbarn..nn.1
  trollbinda_1_V = mkV "trollbinda" "trollband" "trollbundit" ; -- trollbinda..vb.1
  trollbindande_1_N = mkN "trollbindande" ; -- trollbindande..nn.1
  trollbär_1_N = mkN "trollbär" neutrum  ; -- trollbär..nn.1
  trollcirkel_1_N = mkN "trollcirkel" ; -- trollcirkel..nn.1
  trolldeg_1_N = mkN "trolldeg" ; -- trolldeg..nn.1
  trolldom_1_N = mkN "trolldom" ; -- trolldom..nn.1
  trolldomsrit_1_N = mkN "trolldomsrit" "trolldomsriter" ; -- trolldomsrit..nn.1
  trolldryck_1_N = mkN "trolldryck" "trolldrycker" ; -- trolldryck..nn.1
  trolleri_1_N = mkN "trolleri" "trolleriet" "trollerier" "trollerierna" ; -- trolleri..nn.1
  trollerikonst_1_N = mkN "trollerikonst" "trollerikonster" ; -- trollerikonst..nn.1
  trollerikonstnär_1_N = mkN "trollerikonstnär" "trollerikonstnärer" ; -- trollerikonstnär..nn.1
  trolleritrick_1_N = mkN "trolleritrick" neutrum  ; -- trolleritrick..nn.1
  trolleybuss_1_N = mkN "trolleybuss" ; -- trolleybuss..nn.1
  trollformel_1_N = mkN "trollformel" "trollformeln" "trollformler" "trollformlerna" ; -- trollformel..nn.1
  trollgubbe_1_N = mkN "trollgubbe" utrum  ; -- trollgubbe..nn.1
  trollhare_1_N = mkN "trollhare" "trollharar" ; -- trollhare..nn.1
  trollhoppa_1_N = mkN "trollhoppa" ; -- trollhoppa..nn.1
  trollkarl_1_N = mkN "trollkarl" ; -- trollkarl..nn.1
  trollkonst_1_N = mkN "trollkonst" "trollkonster" ; -- trollkonst..nn.1
  trollkonstnär_1_N = mkN "trollkonstnär" "trollkonstnärer" ; -- trollkonstnär..nn.1
  trollkraft_1_N = mkN "trollkraft" ; -- trollkraft..nn.1
  trollkrets_1_N = mkN "trollkrets" ; -- trollkrets..nn.1
  trollkunnig_1_A = mkA "trollkunnig" ; -- trollkunnig..av.1
  trollkunnighet_1_N = mkN "trollkunnighet" ; -- trollkunnighet..nn.1
  trollkvinna_1_N = mkN "trollkvinna" ; -- trollkvinna..nn.1
  trollkäring_1_N = mkN "trollkäring" ; -- trollkäring..nn.1
  trollkärring_1_N = mkN "trollkärring" ; -- trollkärring..nn.1
  trollmakt_1_N = mkN "trollmakt" ; -- trollmakt..nn.1
  trollmedel_1_N = mkN "trollmedel" neutrum  ; -- trollmedel..nn.1
  trollmos_1_N = mkN "trollmos" neutrum  ; -- trollmos..nn.1
  trollpacka_1_N = mkN "trollpacka" ; -- trollpacka..nn.1
  trollruna_1_N = mkN "trollruna" ; -- trollruna..nn.1
  trollskott_1_N = mkN "trollskott" neutrum  ; -- trollskott..nn.1
  trollslag_1_N = mkN "trollslag" neutrum  ; -- trollslag..nn.1
  trollslända_1_N = mkN "trollslända" ; -- trollslända..nn.1
  trollspö_1_N = mkN "trollspö" "trollspöt" "trollspön" "trollspöna" ; -- trollspö..nn.1
  trollstav_1_N = mkN "trollstav" ; -- trollstav..nn.1
  trollsång_1_N = mkN "trollsång" "trollsånger" ; -- trollsång..nn.1
  trolltrumma_1_N = mkN "trolltrumma" ; -- trolltrumma..nn.1
  trolltyg_1_N = mkN "trolltyg" neutrum  ; -- trolltyg..nn.1
  trollunge_1_N = mkN "trollunge" utrum  ; -- trollunge..nn.1
  trolova_1_V = mkV "trolovar" ; -- trolova..vb.1
  trolovad_1_A = mkA "trolovad" ; -- trolovad..av.1
  trolovande_1_N = mkN "trolovande" ; -- trolovande..nn.1
  trolovning_1_N = mkN "trolovning" ; -- trolovning..nn.1
  trolovningsbarn_1_N = mkN "trolovningsbarn" neutrum  ; -- trolovningsbarn..nn.1
  trolovningslöfte_1_N = mkN "trolovningslöfte" ; -- trolovningslöfte..nn.1
  trolovningsring_1_N = mkN "trolovningsring" ; -- trolovningsring..nn.1
  trolsk_1_A = mkA "trolsk" ; -- trolsk..av.1
  trolskhet_1_N = mkN "trolskhet" ; -- trolskhet..nn.1
  trolös_1_A = mkA "trolös" ; -- trolös..av.1
  trolöshet_1_N = mkN "trolöshet" "trolösheter" ; -- trolöshet..nn.1
  troman_1_N = mkN "troman" "tromannen" "tromän" "tromännen" ; -- troman..nn.1
  tromb_1_N = mkN "tromb" "tromber" ; -- tromb..nn.1
  trombin_1_N = mkN "trombin" "trombiner" ; -- trombin..nn.1
  trombocyt_1_N = mkN "trombocyt" "trombocyter" ; -- trombocyt..nn.1
  trombon_1_N = mkN "trombon" "tromboner" ; -- trombon..nn.1
  trombonist_1_N = mkN "trombonist" "trombonister" ; -- trombonist..nn.1
  trombos_1_N = mkN "trombos" "tromboser" ; -- trombos..nn.1
  tromla_1_N = mkN "tromla" ; -- tromla..nn.1
  tron_1_N = mkN "tron" "troner" ; -- tron..nn.1
  trona_1_V = mkV "tronar" ; -- trona..vb.1
  tronande_1_N = mkN "tronande" ; -- tronande..nn.1
  tronarvinge_1_N = mkN "tronarvinge" utrum  ; -- tronarvinge..nn.1
  tronavsägelse_1_N = mkN "tronavsägelse" "tronavsägelser" ; -- tronavsägelse..nn.1
  tronbestigning_1_N = mkN "tronbestigning" ; -- tronbestigning..nn.1
  tronföljare_1_N = mkN "tronföljare" utrum  ; -- tronföljare..nn.1
  tronföljd_1_N = mkN "tronföljd" "tronföljder" ; -- tronföljd..nn.1
  tronföljdskrig_1_N = mkN "tronföljdskrig" neutrum  ; -- tronföljdskrig..nn.1
  tronföljdsordning_1_N = mkN "tronföljdsordning" ; -- tronföljdsordning..nn.1
  tronföljerska_1_N = mkN "tronföljerska" ; -- tronföljerska..nn.1
  tronhimmel_1_N = mkN "tronhimmel" ; -- tronhimmel..nn.1
  troninnehav_1_N = mkN "troninnehav" neutrum  ; -- troninnehav..nn.1
  tronkrävare_1_N = mkN "tronkrävare" utrum  ; -- tronkrävare..nn.1
  tronpretendent_1_N = mkN "tronpretendent" "tronpretendenter" ; -- tronpretendent..nn.1
  tronsal_1_N = mkN "tronsal" ; -- tronsal..nn.1
  tronskifte_1_N = mkN "tronskifte" ; -- tronskifte..nn.1
  trontal_1_N = mkN "trontal" neutrum  ; -- trontal..nn.1
  trontillträde_1_N = mkN "trontillträde" ; -- trontillträde..nn.1
  trop_1_N = mkN "trop" "troper" ; -- trop..nn.1
  tropik_1_N = mkN "tropik" "tropiker" ; -- tropik..nn.1
  tropikfågel_1_N = mkN "tropikfågel" ; -- tropikfågel..nn.1
  tropikhjälm_1_N = mkN "tropikhjälm" ; -- tropikhjälm..nn.1
  tropisk_1_A = mkA "tropisk" ; -- tropisk..av.1
  tropism_1_N = mkN "tropism" "tropismer" ; -- tropism..nn.1
  tropistisk_1_A = mkA "tropistisk" ; -- tropistisk..av.1
  troposfär_1_N = mkN "troposfär" "troposfärer" ; -- troposfär..nn.1
  tropp_1_N = mkN "tropp" ; -- tropp..nn.1
  troppa_1_V = mkV "troppar" ; -- troppa..vb.1
  troppande_1_N = mkN "troppande" ; -- troppande..nn.1
  troppchef_1_N = mkN "troppchef" "troppchefer" ; -- troppchef..nn.1
  trosa_1_N = mkN "trosa" ; -- trosa..nn.1
  trosartikel_1_N = mkN "trosartikel" ; -- trosartikel..nn.1
  trosbekännare_1_N = mkN "trosbekännare" utrum  ; -- trosbekännare..nn.1
  trosbekännelse_1_N = mkN "trosbekännelse" "trosbekännelser" ; -- trosbekännelse..nn.1
  trosbroder_1_N = mkN "trosbroder" "trosbrodern" "trosbröder" "trosbröderna" ; -- trosbroder..nn.1
  trosfast_1_A = mkA "trosfast" "trosfast" ; -- trosfast..av.1
  trosfasthet_1_N = mkN "trosfasthet" ; -- trosfasthet..nn.1
  trosfrid_1_N = mkN "trosfrid" ; -- trosfrid..nn.1
  trosfrihet_1_N = mkN "trosfrihet" "trosfriheter" ; -- trosfrihet..nn.1
  trosfrände_1_N = mkN "trosfrände" "trosfränder" ; -- trosfrände..nn.1
  trosföreställning_1_N = mkN "trosföreställning" ; -- trosföreställning..nn.1
  trosförvant_1_N = mkN "trosförvant" "trosförvanter" ; -- trosförvant..nn.1
  trosgemenskap_1_N = mkN "trosgemenskap" "trosgemenskaper" ; -- trosgemenskap..nn.1
  trosglöd_1_N = mkN "trosglöd" ; -- trosglöd..nn.1
  trosgördel_1_N = mkN "trosgördel" ; -- trosgördel..nn.1
  trosinriktning_1_N = mkN "trosinriktning" ; -- trosinriktning..nn.1
  trosivrare_1_N = mkN "trosivrare" utrum  ; -- trosivrare..nn.1
  troskyldig_1_A = mkA "troskyldig" ; -- troskyldig..av.1
  troskyldighet_1_N = mkN "troskyldighet" ; -- troskyldighet..nn.1
  trosletare_1_N = mkN "trosletare" utrum  ; -- trosletare..nn.1
  troslära_1_N = mkN "troslära" ; -- troslära..nn.1
  trosmässig_1_A = mkA "trosmässig" ; -- trosmässig..av.1
  trosnit_1_N = mkN "trosnit" neutrum  ; -- trosnit..nn.1
  trosrörelse_1_N = mkN "trosrörelse" "trosrörelser" ; -- trosrörelse..nn.1
  tross_1_N = mkN "tross" ; -- tross..nn.1
  trossak_1_N = mkN "trossak" "trossaker" ; -- trossak..nn.1
  trossamfund_1_N = mkN "trossamfund" neutrum  ; -- trossamfund..nn.1
  trossats_1_N = mkN "trossats" "trossatser" ; -- trossats..nn.1
  trossbotten_1_N = mkN "trossbotten" ; -- trossbotten..nn.1
  trossdäck_1_N = mkN "trossdäck" neutrum  ; -- trossdäck..nn.1
  trossfyllning_1_N = mkN "trossfyllning" ; -- trossfyllning..nn.1
  trosshäst_1_N = mkN "trosshäst" ; -- trosshäst..nn.1
  trosskvinna_1_N = mkN "trosskvinna" ; -- trosskvinna..nn.1
  trosskydd_1_N = mkN "trosskydd" neutrum  ; -- trosskydd..nn.1
  trosslagen_1_A = mkA "trosslagen" ; -- trosslagen..av.1
  trossning_1_N = mkN "trossning" ; -- trossning..nn.1
  trostillhörighet_1_N = mkN "trostillhörighet" "trostillhörigheter" ; -- trostillhörighet..nn.1
  trostolerans_1_N = mkN "trostolerans" ; -- trostolerans..nn.1
  trosuppfattning_1_N = mkN "trosuppfattning" ; -- trosuppfattning..nn.1
  trosviss_1_A = mkA "trosviss" ; -- trosviss..av.1
  trosvisshet_1_N = mkN "trosvisshet" ; -- trosvisshet..nn.1
  trosvittne_1_N = mkN "trosvittne" ; -- trosvittne..nn.1
  trotjänare_1_N = mkN "trotjänare" utrum  ; -- trotjänare..nn.1
  trots_1_N = mkN "trots" neutrum  ; -- trots..nn.1
  trotsa_1_V = mkV "trotsar" ; -- trotsa..vb.1
  trotsande_1_N = mkN "trotsande" ; -- trotsande..nn.1
  trotsig_1_A = mkA "trotsig" ; -- trotsig..av.1
  trotsighet_1_N = mkN "trotsighet" ; -- trotsighet..nn.1
  trotskism_1_N = mkN "trotskism" "trotskismer" ; -- trotskism..nn.1
  trotskist_1_N = mkN "trotskist" "trotskister" ; -- trotskist..nn.1
  trotskistisk_1_A = mkA "trotskistisk" ; -- trotskistisk..av.1
  trotsålder_1_N = mkN "trotsålder" ; -- trotsålder..nn.1
  trottoar_1_N = mkN "trottoar" "trottoarer" ; -- trottoar..nn.1
  trottoarbonde_1_N = mkN "trottoarbonde" "trottoarbönder" ; -- trottoarbonde..nn.1
  trottoarhyfs_1_N = mkN "trottoarhyfs" ; -- trottoarhyfs..nn.1
  trottoarkant_1_N = mkN "trottoarkant" "trottoarkanter" ; -- trottoarkant..nn.1
  trottoarservering_1_N = mkN "trottoarservering" ; -- trottoarservering..nn.1
  trottoarsten_1_N = mkN "trottoarsten" "trottoarstenen" "trottoarstenar" "trottoarstenarna" ; -- trottoarsten..nn.1
  trotyl_1_N = mkN "trotyl" ; -- trotyl..nn.1
  trovärd_1_A = mkA "trovärd" "trovärt" ; -- trovärd..av.1
  trovärdhet_1_N = mkN "trovärdhet" ; -- trovärdhet..nn.1
  trovärdig_1_A = mkA "trovärdig" ; -- trovärdig..av.1
  trovärdighet_1_N = mkN "trovärdighet" ; -- trovärdighet..nn.1
  trubadur_1_N = mkN "trubadur" "trubadurer" ; -- trubadur..nn.1
  trubadurdiktning_1_N = mkN "trubadurdiktning" ; -- trubadurdiktning..nn.1
  trubbel_1_N = mkN "trubbel" neutrum  ; -- trubbel..nn.1
  trubbig_1_A = mkA "trubbig" ; -- trubbig..av.1
  trubbighet_1_N = mkN "trubbighet" ; -- trubbighet..nn.1
  trubbnos_1_N = mkN "trubbnos" ; -- trubbnos..nn.1
  trubbnosig_1_A = mkA "trubbnosig" ; -- trubbnosig..av.1
  trubbnosighet_1_N = mkN "trubbnosighet" ; -- trubbnosighet..nn.1
  trubbnäsa_1_N = mkN "trubbnäsa" ; -- trubbnäsa..nn.1
  trubbnäsig_1_A = mkA "trubbnäsig" ; -- trubbnäsig..av.1
  trubbnäst_1_A = mkA "trubbnäst" "trubbnäst" ; -- trubbnäst..av.1
  trubbnästhet_1_N = mkN "trubbnästhet" ; -- trubbnästhet..nn.1
  trubbvinklig_1_A = mkA "trubbvinklig" ; -- trubbvinklig..av.1
  trubbvinklighet_1_N = mkN "trubbvinklighet" ; -- trubbvinklighet..nn.1
  truck_1_N = mkN "truck" ; -- truck..nn.1
  trudelutt_1_N = mkN "trudelutt" "trudelutter" ; -- trudelutt..nn.1
  trug_1_N = mkN "trug" neutrum  ; -- trug..nn.1
  truga_1_N = mkN "truga" ; -- truga..nn.1
  truga_1_V = mkV "trugar" ; -- truga..vb.1
  trugande_1_N = mkN "trugande" ; -- trugande..nn.1
  trugning_1_N = mkN "trugning" ; -- trugning..nn.1
  truism_1_N = mkN "truism" "truismer" ; -- truism..nn.1
  truistisk_1_A = mkA "truistisk" ; -- truistisk..av.1
  trula_1_V = mkV "trular" ; -- trula..vb.1
  trulande_1_N = mkN "trulande" ; -- trulande..nn.1
  trulig_1_A = mkA "trulig" ; -- trulig..av.1
  trulighet_1_N = mkN "trulighet" ; -- trulighet..nn.1
  truls_1_N = mkN "truls" ; -- truls..nn.1
  trulsig_1_A = mkA "trulsig" ; -- trulsig..av.1
  trulsighet_1_N = mkN "trulsighet" ; -- trulsighet..nn.1
  trumbroms_1_N = mkN "trumbroms" ; -- trumbroms..nn.1
  trumeld_1_N = mkN "trumeld" ; -- trumeld..nn.1
  trumf_1_N = mkN "trumf" ; -- trumf..nn.1
  trumfa_1_V = mkV "trumfar" ; -- trumfa..vb.1
  trumfande_1_N = mkN "trumfande" ; -- trumfande..nn.1
  trumfess_1_N = mkN "trumfess" neutrum  ; -- trumfess..nn.1
  trumfkort_1_N = mkN "trumfkort" neutrum  ; -- trumfkort..nn.1
  trumfmatt_1_A = mkA "trumfmatt" ; -- trumfmatt..av.1
  trumfäss_1_N = mkN "trumfäss" neutrum  ; -- trumfäss..nn.1
  trumhinna_1_N = mkN "trumhinna" ; -- trumhinna..nn.1
  trumhåla_1_N = mkN "trumhåla" ; -- trumhåla..nn.1
  trumla_1_V = mkV "trumlar" ; -- trumla..vb.1
  trumlande_1_N = mkN "trumlande" ; -- trumlande..nn.1
  trumma_1_N = mkN "trumma" ; -- trumma..nn.1
  trumma_1_V = mkV "trummar" ; -- trumma..vb.1
  trummande_1_N = mkN "trummande" ; -- trummande..nn.1
  trumminne_1_N = mkN "trumminne" ; -- trumminne..nn.1
  trummis_1_N = mkN "trummis" ; -- trummis..nn.1
  trumning_1_N = mkN "trumning" ; -- trumning..nn.1
  trumpen_1_A = mkA "trumpen" ; -- trumpen..av.1
  trumpenhet_1_N = mkN "trumpenhet" ; -- trumpenhet..nn.1
  trumpet_1_N = mkN "trumpet" "trumpeter" ; -- trumpet..nn.1
  trumpeta_1_V = mkV "trumpetar" ; -- trumpeta..vb.1
  trumpetande_1_N = mkN "trumpetande" ; -- trumpetande..nn.1
  trumpetare_1_N = mkN "trumpetare" utrum  ; -- trumpetare..nn.1
  trumpetblomma_1_N = mkN "trumpetblomma" ; -- trumpetblomma..nn.1
  trumpetkonsert_1_N = mkN "trumpetkonsert" "trumpetkonserter" ; -- trumpetkonsert..nn.1
  trumpetsignal_1_N = mkN "trumpetsignal" "trumpetsignaler" ; -- trumpetsignal..nn.1
  trumpetsolo_1_N = mkN "trumpetsolo" "trumpetsolot" "trumpetsoli" "trumpetsolona" ; -- trumpetsolo..nn.1
  trumpetstöt_1_N = mkN "trumpetstöt" ; -- trumpetstöt..nn.1
  trumpinne_1_N = mkN "trumpinne" utrum  ; -- trumpinne..nn.1
  trumrytm_1_N = mkN "trumrytm" "trumrytmer" ; -- trumrytm..nn.1
  trumset_1_N = mkN "trumset" neutrum  ; -- trumset..nn.1
  trumsjuka_1_N = mkN "trumsjuka" ; -- trumsjuka..nn.1
  trumskinn_1_N = mkN "trumskinn" neutrum  ; -- trumskinn..nn.1
  trumslag_1_N = mkN "trumslag" neutrum  ; -- trumslag..nn.1
  trumslagare_1_N = mkN "trumslagare" utrum  ; -- trumslagare..nn.1
  trumstock_1_N = mkN "trumstock" ; -- trumstock..nn.1
  trumvirvel_1_N = mkN "trumvirvel" ; -- trumvirvel..nn.1
  trunk_1_N = mkN "trunk" ; -- trunk..nn.1
  trunkmaskin_1_N = mkN "trunkmaskin" "trunkmaskiner" ; -- trunkmaskin..nn.1
  trupp_1_N = mkN "trupp" "trupper" ; -- trupp..nn.1
  truppförband_1_N = mkN "truppförband" neutrum  ; -- truppförband..nn.1
  truppförflyttning_1_N = mkN "truppförflyttning" ; -- truppförflyttning..nn.1
  truppföring_1_N = mkN "truppföring" ; -- truppföring..nn.1
  truppförstärkning_1_N = mkN "truppförstärkning" ; -- truppförstärkning..nn.1
  truppnärvaro_1_N = mkN "truppnärvaro" ; -- truppnärvaro..nn.1
  trupprörelse_1_N = mkN "trupprörelse" "trupprörelser" ; -- trupprörelse..nn.1
  truppslag_1_N = mkN "truppslag" neutrum  ; -- truppslag..nn.1
  truppstyrka_1_N = mkN "truppstyrka" ; -- truppstyrka..nn.1
  trupptillbakadragande_1_N = mkN "trupptillbakadragande" ; -- trupptillbakadragande..nn.1
  trupptjänst_1_N = mkN "trupptjänst" ; -- trupptjänst..nn.1
  trupptransport_1_N = mkN "trupptransport" "trupptransporter" ; -- trupptransport..nn.1
  trupptransportfartyg_1_N = mkN "trupptransportfartyg" neutrum  ; -- trupptransportfartyg..nn.1
  trupptransporttåg_1_N = mkN "trupptransporttåg" neutrum  ; -- trupptransporttåg..nn.1
  trust_1_N = mkN "trust" "truster" ; -- trust..nn.1
  trut_1_N = mkN "trut" ; -- trut..nn.1
  truta_1_V = mkV "trutar" ; -- truta..vb.1
  trutande_1_N = mkN "trutande" ; -- trutande..nn.1
  trutkoloni_1_N = mkN "trutkoloni" "trutkolonier" ; -- trutkoloni..nn.1
  trutägg_1_N = mkN "trutägg" neutrum  ; -- trutägg..nn.1
  tryck_1_N = mkN "tryck" neutrum  ; -- tryck..nn.1
  tryck_2_N = mkN "tryck" neutrum  ; -- tryck..nn.2
  trycka_1_V = mkV "trycker" ; -- trycka..vb.1
  tryckaccent_1_N = mkN "tryckaccent" "tryckaccenter" ; -- tryckaccent..nn.1
  tryckalster_1_N = mkN "tryckalster" neutrum  ; -- tryckalster..nn.1
  tryckande_1_A = mkA "tryckande" ; -- tryckande..av.1
  tryckande_1_N = mkN "tryckande" ; -- tryckande..nn.1
  tryckare_1_N = mkN "tryckare" utrum  ; -- tryckare..nn.1
  tryckbar_1_A = mkA "tryckbar" ; -- tryckbar..av.1
  tryckbarhet_1_N = mkN "tryckbarhet" ; -- tryckbarhet..nn.1
  tryckbehållare_1_N = mkN "tryckbehållare" utrum  ; -- tryckbehållare..nn.1
  tryckbokstav_1_N = mkN "tryckbokstav" "tryckbokstäver" ; -- tryckbokstav..nn.1
  tryckbrännare_1_N = mkN "tryckbrännare" utrum  ; -- tryckbrännare..nn.1
  tryckdräkt_1_N = mkN "tryckdräkt" "tryckdräkter" ; -- tryckdräkt..nn.1
  trycke_1_N = mkN "trycke" ; -- trycke..nn.1
  tryckeri_1_N = mkN "tryckeri" "tryckeriet" "tryckerier" "tryckerierna" ; -- tryckeri..nn.1
  tryckfel_1_N = mkN "tryckfel" "tryckfelet" "tryckfel" "tryckfelen" ; -- tryckfel..nn.1
  tryckfelsnisse_1_N = mkN "tryckfelsnisse" utrum  ; -- tryckfelsnisse..nn.1
  tryckform_1_N = mkN "tryckform" ; -- tryckform..nn.1
  tryckfrihet_1_N = mkN "tryckfrihet" "tryckfriheter" ; -- tryckfrihet..nn.1
  tryckfärg_1_N = mkN "tryckfärg" "tryckfärger" ; -- tryckfärg..nn.1
  tryckförband_1_N = mkN "tryckförband" neutrum  ; -- tryckförband..nn.1
  tryckimpregnera_1_V = mkV "tryckimpregnerar" ; -- tryckimpregnera..vb.1
  tryckimpregnerande_1_N = mkN "tryckimpregnerande" ; -- tryckimpregnerande..nn.1
  tryckimpregnerbar_1_A = mkA "tryckimpregnerbar" ; -- tryckimpregnerbar..av.1
  tryckimpregnerbarhet_1_N = mkN "tryckimpregnerbarhet" ; -- tryckimpregnerbarhet..nn.1
  tryckimpregnering_1_N = mkN "tryckimpregnering" ; -- tryckimpregnering..nn.1
  tryckkabin_1_N = mkN "tryckkabin" "tryckkabiner" ; -- tryckkabin..nn.1
  tryckkammare_1_N = mkN "tryckkammare" "tryckkammaren" "tryckkammare" "tryckkamrarna" ; -- tryckkammare..nn.1
  tryckknapp_1_N = mkN "tryckknapp" ; -- tryckknapp..nn.1
  tryckkokare_1_N = mkN "tryckkokare" utrum  ; -- tryckkokare..nn.1
  tryckkontakt_1_N = mkN "tryckkontakt" "tryckkontakter" ; -- tryckkontakt..nn.1
  tryckkänslig_1_A = mkA "tryckkänslig" ; -- tryckkänslig..av.1
  tryckkänslighet_1_N = mkN "tryckkänslighet" ; -- tryckkänslighet..nn.1
  tryckkärl_1_N = mkN "tryckkärl" neutrum  ; -- tryckkärl..nn.1
  tryckluft_1_N = mkN "tryckluft" ; -- tryckluft..nn.1
  tryckluftsapparat_1_N = mkN "tryckluftsapparat" "tryckluftsapparater" ; -- tryckluftsapparat..nn.1
  tryckluftsavläsning_1_N = mkN "tryckluftsavläsning" ; -- tryckluftsavläsning..nn.1
  tryckluftsdriven_1_A = mkA "tryckluftsdriven" ; -- tryckluftsdriven..av.1
  tryckluftsslang_1_N = mkN "tryckluftsslang" ; -- tryckluftsslang..nn.1
  tryckmetod_1_N = mkN "tryckmetod" "tryckmetoder" ; -- tryckmetod..nn.1
  tryckning_1_N = mkN "tryckning" ; -- tryckning..nn.1
  tryckord_1_N = mkN "tryckord" neutrum  ; -- tryckord..nn.1
  tryckort_1_N = mkN "tryckort" "tryckorter" ; -- tryckort..nn.1
  tryckplåt_1_N = mkN "tryckplåt" ; -- tryckplåt..nn.1
  tryckpress_1_N = mkN "tryckpress" ; -- tryckpress..nn.1
  tryckpunkt_1_N = mkN "tryckpunkt" "tryckpunkter" ; -- tryckpunkt..nn.1
  tryckreducering_1_N = mkN "tryckreducering" ; -- tryckreducering..nn.1
  trycksak_1_N = mkN "trycksak" "trycksaker" ; -- trycksak..nn.1
  trycksats_1_N = mkN "trycksats" "trycksatser" ; -- trycksats..nn.1
  tryckskydd_1_N = mkN "tryckskydd" neutrum  ; -- tryckskydd..nn.1
  trycksmörjning_1_N = mkN "trycksmörjning" ; -- trycksmörjning..nn.1
  tryckspruta_1_N = mkN "tryckspruta" ; -- tryckspruta..nn.1
  tryckstark_1_A = mkA "tryckstark" ; -- tryckstark..av.1
  tryckstarkhet_1_N = mkN "tryckstarkhet" ; -- tryckstarkhet..nn.1
  tryckstil_1_N = mkN "tryckstil" ; -- tryckstil..nn.1
  tryckstyrka_1_N = mkN "tryckstyrka" ; -- tryckstyrka..nn.1
  trycksvag_1_A = mkA "trycksvag" ; -- trycksvag..av.1
  trycksvaghet_1_N = mkN "trycksvaghet" ; -- trycksvaghet..nn.1
  trycksvärta_1_N = mkN "trycksvärta" ; -- trycksvärta..nn.1
  trycksäker_1_A = mkA "trycksäker" ; -- trycksäker..av.1
  trycksäkerhet_1_N = mkN "trycksäkerhet" ; -- trycksäkerhet..nn.1
  tryckt_1_A = mkA "tryckt" "tryckt" ; -- tryckt..av.1
  tryckthet_1_N = mkN "tryckthet" ; -- tryckthet..nn.1
  tryckträ_1_N = mkN "tryckträ" neutrum  ; -- tryckträ..nn.1
  trycktyp_1_N = mkN "trycktyp" "trycktyper" ; -- trycktyp..nn.1
  tryckvattenreaktor_1_N = mkN "tryckvattenreaktor" "tryckvattenreaktorer" ; -- tryckvattenreaktor..nn.1
  tryckvattensreaktor_1_N = mkN "tryckvattensreaktor" "tryckvattensreaktorer" ; -- tryckvattensreaktor..nn.1
  tryckvåg_1_N = mkN "tryckvåg" "tryckvågor" ; -- tryckvåg..nn.1
  tryckyta_1_N = mkN "tryckyta" ; -- tryckyta..nn.1
  tryckår_1_N = mkN "tryckår" neutrum  ; -- tryckår..nn.1
  tryckökning_1_N = mkN "tryckökning" ; -- tryckökning..nn.1
  tryffel_1_N = mkN "tryffel" ; -- tryffel..nn.1
  tryffel_2_N = mkN "tryffel" ; -- tryffel..nn.2
  tryffelhund_1_N = mkN "tryffelhund" ; -- tryffelhund..nn.1
  tryffelsvamp_1_N = mkN "tryffelsvamp" ; -- tryffelsvamp..nn.1
  tryffera_1_V = mkV "tryfferar" ; -- tryffera..vb.1
  tryfferande_1_N = mkN "tryfferande" ; -- tryfferande..nn.1
  tryfferbar_1_A = mkA "tryfferbar" ; -- tryfferbar..av.1
  tryfferbarhet_1_N = mkN "tryfferbarhet" ; -- tryfferbarhet..nn.1
  tryffering_1_N = mkN "tryffering" ; -- tryffering..nn.1
  tryga_1_N = mkN "tryga" ; -- tryga..nn.1
  trygg_1_A = mkA "trygg" ; -- trygg..av.1
  trygga_1_V = mkV "tryggar" ; -- trygga..vb.1
  tryggande_1_N = mkN "tryggande" ; -- tryggande..nn.1
  trygghet_1_N = mkN "trygghet" "tryggheter" ; -- trygghet..nn.1
  trygghet_2_N = mkN "trygghet" ; -- trygghet..nn.2
  trygghetsboende_1_N = mkN "trygghetsboende" ; -- trygghetsboende..nn.1
  trygghetsförsäkring_1_N = mkN "trygghetsförsäkring" ; -- trygghetsförsäkring..nn.1
  trygghetskänsla_1_N = mkN "trygghetskänsla" ; -- trygghetskänsla..nn.1
  trygghetsnarkoman_1_N = mkN "trygghetsnarkoman" "trygghetsnarkomaner" ; -- trygghetsnarkoman..nn.1
  trygghetsnarkomani_1_N = mkN "trygghetsnarkomani" ; -- trygghetsnarkomani..nn.1
  trygghetsskapande_1_A = mkA "trygghetsskapande" ; -- trygghetsskapande..av.1
  trygghetsskapande_1_N = mkN "trygghetsskapande" ; -- trygghetsskapande..nn.1
  trymå_1_N = mkN "trymå" "trymåer" ; -- trymå..nn.1
  tryna_1_V = mkV "trynar" ; -- tryna..vb.1
  trynande_1_N = mkN "trynande" ; -- trynande..nn.1
  tryne_1_N = mkN "tryne" ; -- tryne..nn.1
  trypsin_1_N = mkN "trypsin" "trypsiner" ; -- trypsin..nn.1
  tryta_1_V = mkV "tryta" "tröt" "trutit" ; -- tryta..vb.1
  trytande_1_N = mkN "trytande" ; -- trytande..nn.1
  trä_1_N = mkN "trä" "träet" "träer" "träerna" ; -- trä..nn.1
  trä_2_N = mkN "trä" "trät" "trän" "träna" ; -- trä..nn.2
  trä_1_V = mkV "trä" "trädde" "trätt" ; -- trä..vb.1
  träa_1_V = mkV "träar" ; -- träa..vb.1
  träaktig_1_A = mkA "träaktig" ; -- träaktig..av.1
  träaktighet_1_N = mkN "träaktighet" ; -- träaktighet..nn.1
  träande_1_N = mkN "träande" ; -- träande..nn.1
  träavfall_1_N = mkN "träavfall" neutrum  ; -- träavfall..nn.1
  träbeläggning_1_N = mkN "träbeläggning" ; -- träbeläggning..nn.1
  träben_1_N = mkN "träben" neutrum  ; -- träben..nn.1
  träbit_1_N = mkN "träbit" ; -- träbit..nn.1
  träblåsare_1_N = mkN "träblåsare" utrum  ; -- träblåsare..nn.1
  träblåsinstrument_1_N = mkN "träblåsinstrument" neutrum  ; -- träblåsinstrument..nn.1
  träbock_1_N = mkN "träbock" ; -- träbock..nn.1
  träcell_1_N = mkN "träcell" "träceller" ; -- träcell..nn.1
  träcellulosa_1_N = mkN "träcellulosa" ; -- träcellulosa..nn.1
  träck_1_N = mkN "träck" ; -- träck..nn.1
  träcka_1_V = mkV "träcker" ; -- träcka..vb.1
  träckande_1_N = mkN "träckande" ; -- träckande..nn.1
  träckning_1_N = mkN "träckning" ; -- träckning..nn.1
  träd_1_N = mkN "träd" neutrum  ; -- träd..nn.1
  träda_1_N = mkN "träda" ; -- träda..nn.1
  träda_1_V = mkV "träda" "trädde" "trätt" ; -- träda..vb.1
  träda_2_V = mkV "träda" "trädde" "trätt" ; -- träda..vb.2
  trädande_1_N = mkN "trädande" ; -- trädande..nn.1
  trädavverkning_1_N = mkN "trädavverkning" ; -- trädavverkning..nn.1
  trädbank_1_N = mkN "trädbank" "trädbanker" ; -- trädbank..nn.1
  träddiagram_1_N = mkN "träddiagram" "träddiagrammet" "träddiagram" "träddiagrammen" ; -- träddiagram..nn.1
  träddunge_1_N = mkN "träddunge" utrum  ; -- träddunge..nn.1
  träde_1_N = mkN "träde" ; -- träde..nn.1
  trädestillation_1_N = mkN "trädestillation" ; -- trädestillation..nn.1
  trädflora_1_N = mkN "trädflora" ; -- trädflora..nn.1
  trädfällning_1_N = mkN "trädfällning" ; -- trädfällning..nn.1
  trädgren_1_N = mkN "trädgren" "trädgrenen" "trädgrenar" "trädgrenarna" ; -- trädgren..nn.1
  trädgräns_1_N = mkN "trädgräns" "trädgränser" ; -- trädgräns..nn.1
  trädgård_1_N = mkN "trädgård" ; -- trädgård..nn.1
  trädgårdsamatör_1_N = mkN "trädgårdsamatör" "trädgårdsamatörer" ; -- trädgårdsamatör..nn.1
  trädgårdsanläggning_1_N = mkN "trädgårdsanläggning" ; -- trädgårdsanläggning..nn.1
  trädgårdsarkitekt_1_N = mkN "trädgårdsarkitekt" "trädgårdsarkitekter" ; -- trädgårdsarkitekt..nn.1
  trädgårdsbelysning_1_N = mkN "trädgårdsbelysning" ; -- trädgårdsbelysning..nn.1
  trädgårdsblomma_1_N = mkN "trädgårdsblomma" ; -- trädgårdsblomma..nn.1
  trädgårdsbuske_1_N = mkN "trädgårdsbuske" utrum  ; -- trädgårdsbuske..nn.1
  trädgårdsböna_1_N = mkN "trädgårdsböna" ; -- trädgårdsböna..nn.1
  trädgårdsdamm_1_N = mkN "trädgårdsdamm" ; -- trädgårdsdamm..nn.1
  trädgårdsexpert_1_N = mkN "trädgårdsexpert" "trädgårdsexperter" ; -- trädgårdsexpert..nn.1
  trädgårdsgång_1_N = mkN "trädgårdsgång" ; -- trädgårdsgång..nn.1
  trädgårdskonst_1_N = mkN "trädgårdskonst" ; -- trädgårdskonst..nn.1
  trädgårdskratta_1_N = mkN "trädgårdskratta" ; -- trädgårdskratta..nn.1
  trädgårdsland_1_N = mkN "trädgårdsland" neutrum  ; -- trädgårdsland..nn.1
  trädgårdsmästare_1_N = mkN "trädgårdsmästare" utrum  ; -- trädgårdsmästare..nn.1
  trädgårdsmästarfru_1_N = mkN "trädgårdsmästarfru" ; -- trädgårdsmästarfru..nn.1
  trädgårdsmöbel_1_N = mkN "trädgårdsmöbel" "trädgårdsmöbeln" "trädgårdsmöbler" "trädgårdsmöblerna" ; -- trädgårdsmöbel..nn.1
  trädgårdsnejlika_1_N = mkN "trädgårdsnejlika" ; -- trädgårdsnejlika..nn.1
  trädgårdsodlare_1_N = mkN "trädgårdsodlare" utrum  ; -- trädgårdsodlare..nn.1
  trädgårdsodling_1_N = mkN "trädgårdsodling" ; -- trädgårdsodling..nn.1
  trädgårdspiga_1_N = mkN "trädgårdspiga" ; -- trädgårdspiga..nn.1
  trädgårdsprydnad_1_N = mkN "trädgårdsprydnad" "trädgårdsprydnader" ; -- trädgårdsprydnad..nn.1
  trädgårdsredskap_1_N = mkN "trädgårdsredskap" neutrum  ; -- trädgårdsredskap..nn.1
  trädgårdssax_1_N = mkN "trädgårdssax" ; -- trädgårdssax..nn.1
  trädgårdsskötsel_1_N = mkN "trädgårdsskötsel" ; -- trädgårdsskötsel..nn.1
  trädgårdsslang_1_N = mkN "trädgårdsslang" ; -- trädgårdsslang..nn.1
  trädgårdssnäcka_1_N = mkN "trädgårdssnäcka" ; -- trädgårdssnäcka..nn.1
  trädgårdsspade_1_N = mkN "trädgårdsspade" utrum  ; -- trädgårdsspade..nn.1
  trädgårdsstädare_1_N = mkN "trädgårdsstädare" utrum  ; -- trädgårdsstädare..nn.1
  trädgårdssångare_1_N = mkN "trädgårdssångare" utrum  ; -- trädgårdssångare..nn.1
  trädgårdstraktor_1_N = mkN "trädgårdstraktor" "trädgårdstraktorer" ; -- trädgårdstraktor..nn.1
  trädgårdstäppa_1_N = mkN "trädgårdstäppa" ; -- trädgårdstäppa..nn.1
  trädgårdsärt_1_N = mkN "trädgårdsärt" "trädgårdsärter" ; -- trädgårdsärt..nn.1
  trädkoja_1_N = mkN "trädkoja" ; -- trädkoja..nn.1
  trädkramare_1_N = mkN "trädkramare" utrum  ; -- trädkramare..nn.1
  trädkrona_1_N = mkN "trädkrona" ; -- trädkrona..nn.1
  trädkrypare_1_N = mkN "trädkrypare" utrum  ; -- trädkrypare..nn.1
  trädliknande_1_A = mkA "trädliknande" ; -- trädliknande..av.1
  trädlärka_1_N = mkN "trädlärka" ; -- trädlärka..nn.1
  trädlös_1_A = mkA "trädlös" ; -- trädlös..av.1
  trädmogen_1_A = mkA "trädmogen" ; -- trädmogen..av.1
  trädning_1_N = mkN "trädning" ; -- trädning..nn.1
  trädnål_1_N = mkN "trädnål" ; -- trädnål..nn.1
  trädocka_1_N = mkN "trädocka" ; -- trädocka..nn.1
  trädpiplärka_1_N = mkN "trädpiplärka" ; -- trädpiplärka..nn.1
  trädplantering_1_N = mkN "trädplantering" ; -- trädplantering..nn.1
  trädplanteringsdag_1_N = mkN "trädplanteringsdag" ; -- trädplanteringsdag..nn.1
  trädrot_1_N = mkN "trädrot" "trädrötter" ; -- trädrot..nn.1
  trädslag_1_N = mkN "trädslag" neutrum  ; -- trädslag..nn.1
  trädstam_1_N = mkN "trädstam" "trädstammen" "trädstammar" "trädstammarna" ; -- trädstam..nn.1
  trädstruktur_1_N = mkN "trädstruktur" "trädstrukturer" ; -- trädstruktur..nn.1
  trädstygn_1_N = mkN "trädstygn" neutrum  ; -- trädstygn..nn.1
  trädsvamp_1_N = mkN "trädsvamp" ; -- trädsvamp..nn.1
  trädtopp_1_N = mkN "trädtopp" ; -- trädtopp..nn.1
  trädvård_1_N = mkN "trädvård" ; -- trädvård..nn.1
  träfartyg_1_N = mkN "träfartyg" neutrum  ; -- träfartyg..nn.1
  träff_1_N = mkN "träff" ; -- träff..nn.1
  träffa_1_V = mkV "träffar" ; -- träffa..vb.1
  träffad_1_A = mkA "träffad" ; -- träffad..av.1
  träffande_1_A = mkA "träffande" ; -- träffande..av.1
  träffande_1_N = mkN "träffande" ; -- träffande..nn.1
  träffbild_1_N = mkN "träffbild" "träffbilder" ; -- träffbild..nn.1
  träffning_1_N = mkN "träffning" ; -- träffning..nn.1
  träffpunkt_1_N = mkN "träffpunkt" "träffpunkter" ; -- träffpunkt..nn.1
  träffsäker_1_A = mkA "träffsäker" ; -- träffsäker..av.1
  träffsäkerhet_1_N = mkN "träffsäkerhet" "träffsäkerheter" ; -- träffsäkerhet..nn.1
  träfiber_1_N = mkN "träfiber" "träfibern" "träfibrer" "träfibrerna" ; -- träfiber..nn.1
  träfibermassa_1_N = mkN "träfibermassa" ; -- träfibermassa..nn.1
  träfiberplatta_1_N = mkN "träfiberplatta" ; -- träfiberplatta..nn.1
  träfiberskiva_1_N = mkN "träfiberskiva" ; -- träfiberskiva..nn.1
  träfil_1_N = mkN "träfil" ; -- träfil..nn.1
  träflis_1_N = mkN "träflis" ; -- träflis..nn.1
  träflisa_1_N = mkN "träflisa" ; -- träflisa..nn.1
  träform_1_N = mkN "träform" ; -- träform..nn.1
  träfrack_1_N = mkN "träfrack" ; -- träfrack..nn.1
  träfri_1_A = mkA "träfri" "träfritt" ; -- träfri..av.1
  träfräs_1_N = mkN "träfräs" ; -- träfräs..nn.1
  träförsockring_1_N = mkN "träförsockring" ; -- träförsockring..nn.1
  träförädling_1_N = mkN "träförädling" ; -- träförädling..nn.1
  trägen_1_A = mkA "trägen" ; -- trägen..av.1
  trägenhet_1_N = mkN "trägenhet" ; -- trägenhet..nn.1
  trägolv_1_N = mkN "trägolv" neutrum  ; -- trägolv..nn.1
  trägravyr_1_N = mkN "trägravyr" "trägravyrer" ; -- trägravyr..nn.1
  trähus_1_N = mkN "trähus" neutrum  ; -- trähus..nn.1
  trähäst_1_N = mkN "trähäst" ; -- trähäst..nn.1
  träig_1_A = mkA "träig" ; -- träig..av.1
  träighet_1_N = mkN "träighet" ; -- träighet..nn.1
  träindustri_1_N = mkN "träindustri" "träindustrier" ; -- träindustri..nn.1
  träjon_1_N = mkN "träjon" neutrum  ; -- träjon..nn.1
  träkarl_1_N = mkN "träkarl" ; -- träkarl..nn.1
  träkarlsbridge_1_N = mkN "träkarlsbridge" utrum  ; -- träkarlsbridge..nn.1
  träklamp_1_N = mkN "träklamp" ; -- träklamp..nn.1
  träkloss_1_N = mkN "träkloss" ; -- träkloss..nn.1
  träkol_1_N = mkN "träkol" neutrum  ; -- träkol..nn.1
  träkonstruktion_1_N = mkN "träkonstruktion" ; -- träkonstruktion..nn.1
  träkors_1_N = mkN "träkors" neutrum  ; -- träkors..nn.1
  träkåk_1_N = mkN "träkåk" ; -- träkåk..nn.1
  träl_1_N = mkN "träl" ; -- träl..nn.1
  träla_1_V = mkV "trälar" ; -- träla..vb.1
  trälaktig_1_A = mkA "trälaktig" ; -- trälaktig..av.1
  trälande_1_N = mkN "trälande" ; -- trälande..nn.1
  trälarbete_1_N = mkN "trälarbete" ; -- trälarbete..nn.1
  trälbinda_1_V = mkV "trälbinda" "trälband" "trälbundit" ; -- trälbinda..vb.1
  trälbindande_1_N = mkN "trälbindande" ; -- trälbindande..nn.1
  träldom_1_N = mkN "träldom" ; -- träldom..nn.1
  trälig_1_A = mkA "trälig" ; -- trälig..av.1
  trälighet_1_N = mkN "trälighet" ; -- trälighet..nn.1
  trämask_1_N = mkN "trämask" ; -- trämask..nn.1
  trämassa_1_N = mkN "trämassa" ; -- trämassa..nn.1
  trämortel_1_N = mkN "trämortel" ; -- trämortel..nn.1
  träna_1_V = mkV "tränar" ; -- träna..vb.1
  tränande_1_N = mkN "tränande" ; -- tränande..nn.1
  tränare_1_N = mkN "tränare" utrum  ; -- tränare..nn.1
  träng_1_N = mkN "träng" ; -- träng..nn.1
  tränga_1_V = mkV "tränger" ; -- tränga..vb.1
  trängande_1_A = mkA "trängande" ; -- trängande..av.1
  trängande_1_N = mkN "trängande" ; -- trängande..nn.1
  trängd_1_A = mkA "trängd" "trängt" ; -- trängd..av.1
  trängdhet_1_N = mkN "trängdhet" ; -- trängdhet..nn.1
  trängning_1_N = mkN "trängning" ; -- trängning..nn.1
  trängsel_1_N = mkN "trängsel" ; -- trängsel..nn.1
  trängselavgift_1_N = mkN "trängselavgift" "trängselavgifter" ; -- trängselavgift..nn.1
  trängselskatt_1_N = mkN "trängselskatt" "trängselskatter" ; -- trängselskatt..nn.1
  trängta_1_V = mkV "trängtar" ; -- trängta..vb.1
  trängtande_1_N = mkN "trängtande" ; -- trängtande..nn.1
  trängtrupp_1_N = mkN "trängtrupp" "trängtrupper" ; -- trängtrupp..nn.1
  träning_1_N = mkN "träning" ; -- träning..nn.1
  träningsbyxa_1_N = mkN "träningsbyxa" ; -- träningsbyxa..nn.1
  träningsdataspel_1_N = mkN "träningsdataspel" "träningsdataspelet" "träningsdataspel" "träningsdataspelen" ; -- träningsdataspel..nn.1
  träningsdräkt_1_N = mkN "träningsdräkt" "träningsdräkter" ; -- träningsdräkt..nn.1
  träningsexpert_1_N = mkN "träningsexpert" "träningsexperter" ; -- träningsexpert..nn.1
  träningsglädje_1_N = mkN "träningsglädje" utrum  ; -- träningsglädje..nn.1
  träningsläger_1_N = mkN "träningsläger" neutrum  ; -- träningsläger..nn.1
  träningsmatch_1_N = mkN "träningsmatch" "träningsmatcher" ; -- träningsmatch..nn.1
  träningsmässig_1_A = mkA "träningsmässig" ; -- träningsmässig..av.1
  träningsnarkoman_1_N = mkN "träningsnarkoman" "träningsnarkomaner" ; -- träningsnarkoman..nn.1
  träningsoverall_1_N = mkN "träningsoverall" "träningsoveraller" ; -- träningsoverall..nn.1
  träningspass_1_N = mkN "träningspass" neutrum  ; -- träningspass..nn.1
  träningsskola_1_N = mkN "träningsskola" ; -- träningsskola..nn.1
  träningsupplägg_1_N = mkN "träningsupplägg" neutrum  ; -- träningsupplägg..nn.1
  träningsutrustning_1_N = mkN "träningsutrustning" ; -- träningsutrustning..nn.1
  träningsvärk_1_N = mkN "träningsvärk" ; -- träningsvärk..nn.1
  tränjon_1_N = mkN "tränjon" neutrum  ; -- tränjon..nn.1
  träns_1_N = mkN "träns" ; -- träns..nn.1
  tränsa_1_V = mkV "tränsar" ; -- tränsa..vb.1
  tränsande_1_N = mkN "tränsande" ; -- tränsande..nn.1
  träpinne_1_N = mkN "träpinne" utrum  ; -- träpinne..nn.1
  träplanka_1_N = mkN "träplanka" ; -- träplanka..nn.1
  träplatta_1_N = mkN "träplatta" ; -- träplatta..nn.1
  träplugg_1_N = mkN "träplugg" ; -- träplugg..nn.1
  träport_1_N = mkN "träport" ; -- träport..nn.1
  träprodukt_1_N = mkN "träprodukt" "träprodukter" ; -- träprodukt..nn.1
  träram_1_N = mkN "träram" ; -- träram..nn.1
  träribba_1_N = mkN "träribba" ; -- träribba..nn.1
  träsk_1_N = mkN "träsk" neutrum  ; -- träsk..nn.1
  träsk_2_N = mkN "träsk" neutrum  ; -- träsk..nn.2
  träskalle_1_N = mkN "träskalle" utrum  ; -- träskalle..nn.1
  träskallig_1_A = mkA "träskallig" ; -- träskallig..av.1
  träskallighet_1_N = mkN "träskallighet" ; -- träskallighet..nn.1
  träsked_1_N = mkN "träsked" ; -- träsked..nn.1
  träskfeber_1_N = mkN "träskfeber" ; -- träskfeber..nn.1
  träskfolk_1_N = mkN "träskfolk" neutrum  ; -- träskfolk..nn.1
  träskiva_1_N = mkN "träskiva" ; -- träskiva..nn.1
  träskland_1_N = mkN "träskland" neutrum  ; -- träskland..nn.1
  träsko_1_N = mkN "träsko" "träskor" ; -- träsko..nn.1
  träskodans_1_N = mkN "träskodans" "träskodanser" ; -- träskodans..nn.1
  träskosteg_1_N = mkN "träskosteg" neutrum  ; -- träskosteg..nn.1
  träskostövel_1_N = mkN "träskostövel" ; -- träskostövel..nn.1
  träskrinda_1_N = mkN "träskrinda" ; -- träskrinda..nn.1
  träskruv_1_N = mkN "träskruv" ; -- träskruv..nn.1
  träskydd_1_N = mkN "träskydd" neutrum  ; -- träskydd..nn.1
  träskyddsmedel_1_N = mkN "träskyddsmedel" neutrum  ; -- träskyddsmedel..nn.1
  träskål_1_N = mkN "träskål" ; -- träskål..nn.1
  träslag_1_N = mkN "träslag" neutrum  ; -- träslag..nn.1
  träslev_1_N = mkN "träslev" ; -- träslev..nn.1
  träslip_1_N = mkN "träslip" ; -- träslip..nn.1
  träslott_1_N = mkN "träslott" neutrum  ; -- träslott..nn.1
  träslup_1_N = mkN "träslup" ; -- träslup..nn.1
  träslöjd_1_N = mkN "träslöjd" ; -- träslöjd..nn.1
  träsmak_1_N = mkN "träsmak" ; -- träsmak..nn.1
  träsnidare_1_N = mkN "träsnidare" utrum  ; -- träsnidare..nn.1
  träsnideri_1_N = mkN "träsnideri" "träsnideriet" "träsniderier" "träsniderierna" ; -- träsnideri..nn.1
  träsnipa_1_N = mkN "träsnipa" ; -- träsnipa..nn.1
  träsnitt_1_N = mkN "träsnitt" neutrum  ; -- träsnitt..nn.1
  träsnittsillustration_1_N = mkN "träsnittsillustration" ; -- träsnittsillustration..nn.1
  träsnittsstock_1_N = mkN "träsnittsstock" ; -- träsnittsstock..nn.1
  träsocker_1_N = mkN "träsocker" neutrum  ; -- träsocker..nn.1
  träspillra_1_N = mkN "träspillra" ; -- träspillra..nn.1
  träsprit_1_N = mkN "träsprit" ; -- träsprit..nn.1
  träspån_1_N = mkN "träspån" neutrum  ; -- träspån..nn.1
  trästav_1_N = mkN "trästav" ; -- trästav..nn.1
  trästick_1_N = mkN "trästick" neutrum  ; -- trästick..nn.1
  trästift_1_N = mkN "trästift" neutrum  ; -- trästift..nn.1
  trästycke_1_N = mkN "trästycke" ; -- trästycke..nn.1
  träsvarv_1_N = mkN "träsvarv" ; -- träsvarv..nn.1
  träsvärd_1_N = mkN "träsvärd" neutrum  ; -- träsvärd..nn.1
  träta_1_N = mkN "träta" ; -- träta..nn.1
  träta_1_V = mkV "träter" ; -- träta..vb.1
  trätande_1_N = mkN "trätande" ; -- trätande..nn.1
  träteknisk_1_A = mkA "träteknisk" ; -- träteknisk..av.1
  trätgirig_1_A = mkA "trätgirig" ; -- trätgirig..av.1
  trätgirighet_1_N = mkN "trätgirighet" ; -- trätgirighet..nn.1
  trätjära_1_N = mkN "trätjära" ; -- trätjära..nn.1
  trätlysten_1_A = mkA "trätlysten" ; -- trätlysten..av.1
  trätlystnad_1_N = mkN "trätlystnad" ; -- trätlystnad..nn.1
  trätobroder_1_N = mkN "trätobroder" "trätobrodern" "trätobröder" "trätobröderna" ; -- trätobroder..nn.1
  trätoffel_1_N = mkN "trätoffla" ; -- trätoffel..nn.1
  trätugg_1_N = mkN "trätugg" neutrum  ; -- trätugg..nn.1
  träull_1_N = mkN "träull" ; -- träull..nn.1
  trävara_1_N = mkN "trävara" ; -- trävara..nn.1
  trävaruhandel_1_N = mkN "trävaruhandel" ; -- trävaruhandel..nn.1
  trävilla_1_N = mkN "trävilla" ; -- trävilla..nn.1
  trävirke_1_N = mkN "trävirke" ; -- trävirke..nn.1
  trävit_1_A = mkA "trävit" ; -- trävit..av.1
  träyta_1_N = mkN "träyta" ; -- träyta..nn.1
  trå_1_V = mkV "trår" ; -- trå..vb.1
  tråckelstygn_1_N = mkN "tråckelstygn" neutrum  ; -- tråckelstygn..nn.1
  tråckeltråd_1_N = mkN "tråckeltråd" ; -- tråckeltråd..nn.1
  tråckla_1_V = mkV "tråcklar" ; -- tråckla..vb.1
  tråcklande_1_N = mkN "tråcklande" ; -- tråcklande..nn.1
  tråckling_1_N = mkN "tråckling" ; -- tråckling..nn.1
  tråd_1_N = mkN "tråd" ; -- tråd..nn.1
  trådbindning_1_N = mkN "trådbindning" ; -- trådbindning..nn.1
  trådbuss_1_N = mkN "trådbuss" ; -- trådbuss..nn.1
  tråddiameter_1_N = mkN "tråddiameter" ; -- tråddiameter..nn.1
  tråddragning_1_N = mkN "tråddragning" ; -- tråddragning..nn.1
  trådduk_1_N = mkN "trådduk" ; -- trådduk..nn.1
  trådformig_1_A = mkA "trådformig" ; -- trådformig..av.1
  trådformighet_1_N = mkN "trådformighet" ; -- trådformighet..nn.1
  trådglas_1_N = mkN "trådglas" neutrum  ; -- trådglas..nn.1
  trådig_1_A = mkA "trådig" ; -- trådig..av.1
  trådknapp_1_N = mkN "trådknapp" ; -- trådknapp..nn.1
  trådkors_1_N = mkN "trådkors" neutrum  ; -- trådkors..nn.1
  trådlik_1_A = mkA "trådlik" ; -- trådlik..av.1
  trådliknande_1_A = mkA "trådliknande" ; -- trådliknande..av.1
  trådlös_1_A = mkA "trådlös" ; -- trådlös..av.1
  trådlöshet_1_N = mkN "trådlöshet" ; -- trådlöshet..nn.1
  trådmask_1_N = mkN "trådmask" ; -- trådmask..nn.1
  trådmatning_1_N = mkN "trådmatning" ; -- trådmatning..nn.1
  trådmina_1_N = mkN "trådmina" ; -- trådmina..nn.1
  trådradio_1_N = mkN "trådradio" ; -- trådradio..nn.1
  trådrot_1_N = mkN "trådrot" "trådrötter" ; -- trådrot..nn.1
  trådrulle_1_N = mkN "trådrulle" utrum  ; -- trådrulle..nn.1
  trådrät_1_A = mkA "trådrät" ; -- trådrät..av.1
  trådsax_1_N = mkN "trådsax" ; -- trådsax..nn.1
  trådskivling_1_N = mkN "trådskivling" ; -- trådskivling..nn.1
  trådsliten_1_A = mkA "trådsliten" ; -- trådsliten..av.1
  trådsmal_1_A = mkA "trådsmal" ; -- trådsmal..av.1
  trådspik_1_N = mkN "trådspik" ; -- trådspik..nn.1
  trådämne_1_N = mkN "trådämne" ; -- trådämne..nn.1
  trående_1_N = mkN "trående" ; -- trående..nn.1
  tråg_1_N = mkN "tråg" neutrum  ; -- tråg..nn.1
  trågdal_1_N = mkN "trågdal" ; -- trågdal..nn.1
  trågformig_1_A = mkA "trågformig" ; -- trågformig..av.1
  tråk_1_N = mkN "tråk" neutrum  ; -- tråk..nn.1
  tråk_2_N = mkN "tråk" ; -- tråk..nn.2
  tråka_1_V = mkV "tråkar" ; -- tråka..vb.1
  tråkande_1_N = mkN "tråkande" ; -- tråkande..nn.1
  tråkfotboll_1_N = mkN "tråkfotboll" ; -- tråkfotboll..nn.1
  tråkig_1_A = mkA "tråkig" ; -- tråkig..av.1
  tråkighet_1_N = mkN "tråkighet" "tråkigheter" ; -- tråkighet..nn.1
  tråkmåns_1_N = mkN "tråkmåns" ; -- tråkmåns..nn.1
  tråkning_1_N = mkN "tråkning" ; -- tråkning..nn.1
  trål_1_N = mkN "trål" ; -- trål..nn.1
  tråla_1_V = mkV "trålar" ; -- tråla..vb.1
  trålande_1_N = mkN "trålande" ; -- trålande..nn.1
  trålare_1_N = mkN "trålare" utrum  ; -- trålare..nn.1
  trålfiske_1_N = mkN "trålfiske" ; -- trålfiske..nn.1
  tråna_1_V = mkV "trånar" ; -- tråna..vb.1
  trånad_1_N = mkN "trånad" "trånader" ; -- trånad..nn.1
  trånadsfull_1_A = mkA "trånadsfull" ; -- trånadsfull..av.1
  trånande_1_N = mkN "trånande" ; -- trånande..nn.1
  trång_1_A = mkA "trång" ; -- trång..av.1
  trångbodd_1_A = mkA "trångbodd" ; -- trångbodd..av.1
  trångboddhet_1_N = mkN "trångboddhet" ; -- trångboddhet..nn.1
  trångbröstad_1_A = mkA "trångbröstad" ; -- trångbröstad..av.1
  trånghet_1_N = mkN "trånghet" ; -- trånghet..nn.1
  trångmål_1_N = mkN "trångmål" neutrum  ; -- trångmål..nn.1
  trångsint_1_A = mkA "trångsint" "trångsint" ; -- trångsint..av.1
  trångsinthet_1_N = mkN "trångsinthet" ; -- trångsinthet..nn.1
  trångsyn_1_N = mkN "trångsyn" ; -- trångsyn..nn.1
  trångsynt_1_A = mkA "trångsynt" "trångsynt" ; -- trångsynt..av.1
  trångsynthet_1_N = mkN "trångsynthet" ; -- trångsynthet..nn.1
  trånsjuk_1_A = mkA "trånsjuk" ; -- trånsjuk..av.1
  trånsjuka_1_N = mkN "trånsjuka" ; -- trånsjuka..nn.1
  trånsjukhet_1_N = mkN "trånsjukhet" ; -- trånsjukhet..nn.1
  trög_1_A = mkA "trög" ; -- trög..av.1
  trögbedd_1_A = mkA "trögbedd" ; -- trögbedd..av.1
  trögbeddhet_1_N = mkN "trögbeddhet" ; -- trögbeddhet..nn.1
  trögdjur_1_N = mkN "trögdjur" neutrum  ; -- trögdjur..nn.1
  trögfattad_1_A = mkA "trögfattad" ; -- trögfattad..av.1
  trögflytande_1_A = mkA "trögflytande" ; -- trögflytande..av.1
  tröghet_1_N = mkN "tröghet" ; -- tröghet..nn.1
  tröghet_2_N = mkN "tröghet" "trögheter" ; -- tröghet..nn.2
  tröghetskraft_1_N = mkN "tröghetskraft" ; -- tröghetskraft..nn.1
  tröghetslag_1_N = mkN "tröghetslag" ; -- tröghetslag..nn.1
  tröghetsnavigera_1_V = mkV "tröghetsnavigerar" ; -- tröghetsnavigera..vb.1
  tröghetsnavigerande_1_N = mkN "tröghetsnavigerande" ; -- tröghetsnavigerande..nn.1
  tröghetsnavigerbar_1_A = mkA "tröghetsnavigerbar" ; -- tröghetsnavigerbar..av.1
  tröghetsnavigerbarhet_1_N = mkN "tröghetsnavigerbarhet" ; -- tröghetsnavigerbarhet..nn.1
  tröghetsnavigering_1_N = mkN "tröghetsnavigering" ; -- tröghetsnavigering..nn.1
  trögkörd_1_A = mkA "trögkörd" "trögkört" ; -- trögkörd..av.1
  trögkördhet_1_N = mkN "trögkördhet" ; -- trögkördhet..nn.1
  trögläst_1_A = mkA "trögläst" "trögläst" ; -- trögläst..av.1
  tröglästhet_1_N = mkN "tröglästhet" ; -- tröglästhet..nn.1
  trögrörlig_1_A = mkA "trögrörlig" ; -- trögrörlig..av.1
  trögrörlighet_1_N = mkN "trögrörlighet" ; -- trögrörlighet..nn.1
  trögtänkt_1_A = mkA "trögtänkt" "trögtänkt" ; -- trögtänkt..av.1
  trögtänkthet_1_N = mkN "trögtänkthet" ; -- trögtänkthet..nn.1
  tröja_1_N = mkN "tröja" ; -- tröja..nn.1
  tröjfabrik_1_N = mkN "tröjfabrik" "tröjfabriker" ; -- tröjfabrik..nn.1
  tröjficka_1_N = mkN "tröjficka" ; -- tröjficka..nn.1
  tröska_1_N = mkN "tröska" ; -- tröska..nn.1
  tröska_1_V = mkV "tröskar" ; -- tröska..vb.1
  tröskande_1_N = mkN "tröskande" ; -- tröskande..nn.1
  tröskel_1_N = mkN "tröskel" ; -- tröskel..nn.1
  tröskeleffekt_1_N = mkN "tröskeleffekt" "tröskeleffekter" ; -- tröskeleffekt..nn.1
  tröskellåda_1_N = mkN "tröskellåda" ; -- tröskellåda..nn.1
  tröskelvärde_1_N = mkN "tröskelvärde" ; -- tröskelvärde..nn.1
  trösklada_1_N = mkN "trösklada" ; -- trösklada..nn.1
  tröskverk_1_N = mkN "tröskverk" neutrum  ; -- tröskverk..nn.1
  tröst_1_N = mkN "tröst" ; -- tröst..nn.1
  tröst_2_N = mkN "tröst" ; -- tröst..nn.2
  trösta_1_V = mkV "tröstar" ; -- trösta..vb.1
  tröstande_1_N = mkN "tröstande" ; -- tröstande..nn.1
  tröstare_1_N = mkN "tröstare" utrum  ; -- tröstare..nn.1
  tröstefull_1_A = mkA "tröstefull" ; -- tröstefull..av.1
  tröstegrund_1_N = mkN "tröstegrund" "tröstegrunder" ; -- tröstegrund..nn.1
  tröstelig_1_A = mkA "tröstelig" ; -- tröstelig..av.1
  trösteord_1_N = mkN "trösteord" neutrum  ; -- trösteord..nn.1
  trösterik_1_A = mkA "trösterik" ; -- trösterik..av.1
  trösterikhet_1_N = mkN "trösterikhet" ; -- trösterikhet..nn.1
  trösteskrift_1_N = mkN "trösteskrift" "trösteskrifter" ; -- trösteskrift..nn.1
  tröstlig_1_A = mkA "tröstlig" ; -- tröstlig..av.1
  tröstlös_1_A = mkA "tröstlös" ; -- tröstlös..av.1
  tröstlöshet_1_N = mkN "tröstlöshet" ; -- tröstlöshet..nn.1
  tröstmål_1_N = mkN "tröstmål" neutrum  ; -- tröstmål..nn.1
  tröstnapp_1_N = mkN "tröstnapp" ; -- tröstnapp..nn.1
  tröstpris_1_N = mkN "tröstpris" neutrum  ; -- tröstpris..nn.1
  tröstrik_1_A = mkA "tröstrik" ; -- tröstrik..av.1
  tröstrikhet_1_N = mkN "tröstrikhet" ; -- tröstrikhet..nn.1
  tröstäta_1_V = mkV "tröstäta" "tröståt" "tröstätit" ; -- tröstäta..vb.1
  tröstätande_1_N = mkN "tröstätande" ; -- tröstätande..nn.1
  tröstätning_1_N = mkN "tröstätning" ; -- tröstätning..nn.1
  trött_1_A = mkA "trött" ; -- trött..av.1
  trötta_1_V = mkV "tröttar" ; -- trötta..vb.1
  tröttande_1_N = mkN "tröttande" ; -- tröttande..nn.1
  trötthet_1_N = mkN "trötthet" ; -- trötthet..nn.1
  trötthetskänsla_1_N = mkN "trötthetskänsla" ; -- trötthetskänsla..nn.1
  trötthetstecken_1_N = mkN "trötthetstecken" "trötthetstecknet" "trötthetstecken" "trötthetstecknen" ; -- trötthetstecken..nn.1
  tröttkörd_1_A = mkA "tröttkörd" "tröttkört" ; -- tröttkörd..av.1
  tröttkördhet_1_N = mkN "tröttkördhet" ; -- tröttkördhet..nn.1
  tröttna_1_V = mkV "tröttnar" ; -- tröttna..vb.1
  tröttnande_1_N = mkN "tröttnande" ; -- tröttnande..nn.1
  tröttsam_1_A = mkA "tröttsam" "tröttsamt" "tröttsamma" "tröttsamma" "tröttsammare" "tröttsammast" "tröttsammaste" ; -- tröttsam..av.1
  tröttsamhet_1_N = mkN "tröttsamhet" ; -- tröttsamhet..nn.1
  tsar_1_N = mkN "tsar" "tsarer" ; -- tsar..nn.1
  tsardotter_1_N = mkN "tsardotter" "tsardottern" "tsardöttrar" "tsardöttrarna" ; -- tsardotter..nn.1
  tsarfamilj_1_N = mkN "tsarfamilj" "tsarfamiljer" ; -- tsarfamilj..nn.1
  tsaritsa_1_N = mkN "tsaritsa" ; -- tsaritsa..nn.1
  tsarregim_1_N = mkN "tsarregim" "tsarregimer" ; -- tsarregim..nn.1
  tsetsefluga_1_N = mkN "tsetsefluga" ; -- tsetsefluga..nn.1
  tsunami_1_N = mkN "tsunami" "tsunamin" "tsunamis" "tsunamisarna" ; -- tsunami..nn.1
  tsunamikatastrof_1_N = mkN "tsunamikatastrof" "tsunamikatastrofer" ; -- tsunamikatastrof..nn.1
  tsunamivarning_1_N = mkN "tsunamivarning" ; -- tsunamivarning..nn.1
  tsunamivarningssystem_1_N = mkN "tsunamivarningssystem" neutrum  ; -- tsunamivarningssystem..nn.1
  tuareg_1_N = mkN "tuareg" "tuareger" ; -- tuareg..nn.1
  tub_1_N = mkN "tub" "tuber" ; -- tub..nn.1
  tuba_1_N = mkN "tuba" ; -- tuba..nn.1
  tubba_1_V = mkV "tubbar" ; -- tubba..vb.1
  tubbande_1_N = mkN "tubbande" ; -- tubbande..nn.1
  tubbning_1_N = mkN "tubbning" ; -- tubbning..nn.1
  tuberkel_1_N = mkN "tuberkel" "tuberkeln" "tuberkler" "tuberklerna" ; -- tuberkel..nn.1
  tuberkelbakterie_1_N = mkN "tuberkelbakterie" "tuberkelbakterier" ; -- tuberkelbakterie..nn.1
  tuberkulin_1_N = mkN "tuberkulin" "tuberkuliner" ; -- tuberkulin..nn.1
  tuberkulos_1_N = mkN "tuberkulos" ; -- tuberkulos..nn.1
  tuberkulös_1_A = mkA "tuberkulös" ; -- tuberkulös..av.1
  tubkanon_1_N = mkN "tubkanon" "tubkanoner" ; -- tubkanon..nn.1
  tubkikare_1_N = mkN "tubkikare" utrum  ; -- tubkikare..nn.1
  tubrör_1_N = mkN "tubrör" neutrum  ; -- tubrör..nn.1
  tudela_1_V = mkV "tudelar" ; -- tudela..vb.1
  tudelande_1_N = mkN "tudelande" ; -- tudelande..nn.1
  tudelning_1_N = mkN "tudelning" ; -- tudelning..nn.1
  tuff_1_A = mkA "tuff" ; -- tuff..av.1
  tuff_1_N = mkN "tuff" "tuffer" ; -- tuff..nn.1
  tuffa_1_V = mkV "tuffar" ; -- tuffa..vb.1
  tuffande_1_N = mkN "tuffande" ; -- tuffande..nn.1
  tuffhet_1_N = mkN "tuffhet" ; -- tuffhet..nn.1
  tuffing_1_N = mkN "tuffing" ; -- tuffing..nn.1
  tufsa_1_V = mkV "tufsar" ; -- tufsa..vb.1
  tufsande_1_N = mkN "tufsande" ; -- tufsande..nn.1
  tufsig_1_A = mkA "tufsig" ; -- tufsig..av.1
  tufsighet_1_N = mkN "tufsighet" ; -- tufsighet..nn.1
  tuftad_1_A = mkA "tuftad" ; -- tuftad..av.1
  tuftmatta_1_N = mkN "tuftmatta" ; -- tuftmatta..nn.1
  tugg_1_N = mkN "tugg" neutrum  ; -- tugg..nn.1
  tugga_1_N = mkN "tugga" ; -- tugga..nn.1
  tugga_1_V = mkV "tuggar" ; -- tugga..vb.1
  tuggande_1_N = mkN "tuggande" ; -- tuggande..nn.1
  tuggbuss_1_N = mkN "tuggbuss" ; -- tuggbuss..nn.1
  tuggmuskel_1_N = mkN "tuggmuskel" "tuggmuskeln" "tuggmuskler" "tuggmusklerna" ; -- tuggmuskel..nn.1
  tuggtobak_1_N = mkN "tuggtobak" ; -- tuggtobak..nn.1
  tuggummi_1_N = mkN "tuggummi" "tuggummit" "tuggummin" "tuggummina" ; -- tuggummi..nn.1
  tuggummibit_1_N = mkN "tuggummibit" ; -- tuggummibit..nn.1
  tuggummipaket_1_N = mkN "tuggummipaket" neutrum  ; -- tuggummipaket..nn.1
  tuggyta_1_N = mkN "tuggyta" ; -- tuggyta..nn.1
  tuja_1_N = mkN "tuja" ; -- tuja..nn.1
  tukan_1_N = mkN "tukan" "tukaner" ; -- tukan..nn.1
  tukt_1_N = mkN "tukt" ; -- tukt..nn.1
  tukta_1_V = mkV "tuktar" ; -- tukta..vb.1
  tuktande_1_N = mkN "tuktande" ; -- tuktande..nn.1
  tukthus_1_N = mkN "tukthus" neutrum  ; -- tukthus..nn.1
  tuktig_1_A = mkA "tuktig" ; -- tuktig..av.1
  tuktighet_1_N = mkN "tuktighet" ; -- tuktighet..nn.1
  tuktlös_1_A = mkA "tuktlös" ; -- tuktlös..av.1
  tuktomästare_1_N = mkN "tuktomästare" utrum  ; -- tuktomästare..nn.1
  tularemi_1_N = mkN "tularemi" ; -- tularemi..nn.1
  tulipanaros_1_N = mkN "tulipanaros" ; -- tulipanaros..nn.1
  tulium_1_N = mkN "tulium" neutrum  ; -- tulium..nn.1
  tulkört_1_N = mkN "tulkört" "tulkörter" ; -- tulkört..nn.1
  tull_1_N = mkN "tull" ; -- tull..nn.1
  tulla_1_V = mkV "tullar" ; -- tulla..vb.1
  tullag_1_N = mkN "tullag" ; -- tullag..nn.1
  tullande_1_N = mkN "tullande" ; -- tullande..nn.1
  tullare_1_N = mkN "tullare" utrum  ; -- tullare..nn.1
  tullavgift_1_N = mkN "tullavgift" "tullavgifter" ; -- tullavgift..nn.1
  tullbesiktiga_1_V = mkV "tullbesiktigar" ; -- tullbesiktiga..vb.1
  tullbesiktigande_1_N = mkN "tullbesiktigande" ; -- tullbesiktigande..nn.1
  tullbesiktning_1_N = mkN "tullbesiktning" ; -- tullbesiktning..nn.1
  tulldeklaration_1_N = mkN "tulldeklaration" ; -- tulldeklaration..nn.1
  tullfri_1_A = mkA "tullfri" "tullfritt" ; -- tullfri..av.1
  tullfrihet_1_N = mkN "tullfrihet" ; -- tullfrihet..nn.1
  tullförvaltare_1_N = mkN "tullförvaltare" utrum  ; -- tullförvaltare..nn.1
  tullkammare_1_N = mkN "tullkammare" "tullkammaren" "tullkammare" "tullkamrarna" ; -- tullkammare..nn.1
  tullkontor_1_N = mkN "tullkontor" neutrum  ; -- tullkontor..nn.1
  tullkontroll_1_N = mkN "tullkontroll" "tullkontroller" ; -- tullkontroll..nn.1
  tullmur_1_N = mkN "tullmur" ; -- tullmur..nn.1
  tullmässig_1_A = mkA "tullmässig" ; -- tullmässig..av.1
  tullnär_1_N = mkN "tullnär" "tullnärer" ; -- tullnär..nn.1
  tullpass_1_N = mkN "tullpass" neutrum  ; -- tullpass..nn.1
  tullpliktig_1_A = mkA "tullpliktig" ; -- tullpliktig..av.1
  tullpliktighet_1_N = mkN "tullpliktighet" ; -- tullpliktighet..nn.1
  tullpolitik_1_N = mkN "tullpolitik" ; -- tullpolitik..nn.1
  tullregister_1_N = mkN "tullregister" neutrum  ; -- tullregister..nn.1
  tullskydd_1_N = mkN "tullskydd" neutrum  ; -- tullskydd..nn.1
  tullsnok_1_N = mkN "tullsnok" ; -- tullsnok..nn.1
  tullstadga_1_N = mkN "tullstadga" ; -- tullstadga..nn.1
  tullstation_1_N = mkN "tullstation" ; -- tullstation..nn.1
  tulltjänsteman_1_N = mkN "tulltjänsteman" "tulltjänstemannen" "tulltjänstemän" "tulltjänstemännen" ; -- tulltjänsteman..nn.1
  tullunion_1_N = mkN "tullunion" ; -- tullunion..nn.1
  tullverk_1_N = mkN "tullverk" neutrum  ; -- tullverk..nn.1
  tullvisitation_1_N = mkN "tullvisitation" ; -- tullvisitation..nn.1
  tullväsen_1_N = mkN "tullväsen" neutrum  ; -- tullväsen..nn.1
  tulpan_1_N = mkN "tulpan" "tulpaner" ; -- tulpan..nn.1
  tulpanlök_1_N = mkN "tulpanlök" ; -- tulpanlök..nn.1
  tulpanträd_1_N = mkN "tulpanträd" neutrum  ; -- tulpanträd..nn.1
  tulpanäng_1_N = mkN "tulpanäng" ; -- tulpanäng..nn.1
  tulta_1_N = mkN "tulta" ; -- tulta..nn.1
  tulta_1_V = mkV "tultar" ; -- tulta..vb.1
  tultande_1_N = mkN "tultande" ; -- tultande..nn.1
  tum_1_N = mkN "tum" "tummen" "tum" "tummen" ; -- tum..nn.1
  tumgrepp_1_N = mkN "tumgrepp" neutrum  ; -- tumgrepp..nn.1
  tumla_1_V = mkV "tumlar" ; -- tumla..vb.1
  tumlande_1_N = mkN "tumlande" ; -- tumlande..nn.1
  tumlare_1_N = mkN "tumlare" utrum  ; -- tumlare..nn.1
  tumma_1_V = mkV "tummar" ; -- tumma..vb.1
  tumma_2_V = mkV "tummar" ; -- tumma..vb.2
  tummande_1_N = mkN "tummande" ; -- tummande..nn.1
  tumme_1_N = mkN "tumme" utrum  ; -- tumme..nn.1
  tummel_1_N = mkN "tummel" neutrum  ; -- tummel..nn.1
  tummeliten_1_N = mkN "tummeliten" ; -- tummeliten..nn.1
  tummelplats_1_N = mkN "tummelplats" "tummelplatser" ; -- tummelplats..nn.1
  tummetott_1_N = mkN "tummetott" ; -- tummetott..nn.1
  tummis_1_A = mkA "tummis" ; -- tummis..av.1
  tumnagel_1_N = mkN "tumnagel" ; -- tumnagel..nn.1
  tumning_1_N = mkN "tumning" ; -- tumning..nn.1
  tumregel_1_N = mkN "tumregel" "tumregeln" "tumregler" "tumreglerna" ; -- tumregel..nn.1
  tumrullning_1_N = mkN "tumrullning" ; -- tumrullning..nn.1
  tumsbredd_1_N = mkN "tumsbredd" "tumsbredder" ; -- tumsbredd..nn.1
  tumskala_1_N = mkN "tumskala" ; -- tumskala..nn.1
  tumskruv_1_N = mkN "tumskruv" ; -- tumskruv..nn.1
  tumstjock_1_A = mkA "tumstjock" ; -- tumstjock..av.1
  tumstock_1_N = mkN "tumstock" ; -- tumstock..nn.1
  tumsugare_1_N = mkN "tumsugare" utrum  ; -- tumsugare..nn.1
  tumult_1_N = mkN "tumult" neutrum  ; -- tumult..nn.1
  tumultartad_1_A = mkA "tumultartad" ; -- tumultartad..av.1
  tumultuarisk_1_A = mkA "tumultuarisk" ; -- tumultuarisk..av.1
  tumvante_1_N = mkN "tumvante" utrum  ; -- tumvante..nn.1
  tumveck_1_N = mkN "tumveck" neutrum  ; -- tumveck..nn.1
  tumör_1_N = mkN "tumör" "tumörer" ; -- tumör..nn.1
  tun_1_N = mkN "tun" neutrum  ; -- tun..nn.1
  tundra_1_N = mkN "tundra" ; -- tundra..nn.1
  tuner_1_N = mkN "tuner" "tunern" "tuners" "tunersen" ; -- tuner..nn.1
  tung_1_A = mkA "tung" "tyngre" "tyngst" ; -- tung..av.1
  tunga_1_N = mkN "tunga" ; -- tunga..nn.1
  tunga_2_N = mkN "tunga" ; -- tunga..nn.2
  tungarbetad_1_A = mkA "tungarbetad" ; -- tungarbetad..av.1
  tungband_1_N = mkN "tungband" neutrum  ; -- tungband..nn.1
  tungben_1_N = mkN "tungben" neutrum  ; -- tungben..nn.1
  tungel_1_N = mkN "tungel" neutrum  ; -- tungel..nn.1
  tungfotad_1_A = mkA "tungfotad" ; -- tungfotad..av.1
  tunggumpad_1_A = mkA "tunggumpad" ; -- tunggumpad..av.1
  tunghäfta_1_N = mkN "tunghäfta" ; -- tunghäfta..nn.1
  tungkörd_1_A = mkA "tungkörd" "tungkört" ; -- tungkörd..av.1
  tungkördhet_1_N = mkN "tungkördhet" ; -- tungkördhet..nn.1
  tungljud_1_N = mkN "tungljud" neutrum  ; -- tungljud..nn.1
  tungläst_1_A = mkA "tungläst" "tungläst" ; -- tungläst..av.1
  tunglästhet_1_N = mkN "tunglästhet" ; -- tunglästhet..nn.1
  tungmask_1_N = mkN "tungmask" ; -- tungmask..nn.1
  tungmetall_1_N = mkN "tungmetall" "tungmetaller" ; -- tungmetall..nn.1
  tungomål_1_N = mkN "tungomål" neutrum  ; -- tungomål..nn.1
  tungomålstalande_1_A = mkA "tungomålstalande" ; -- tungomålstalande..av.1
  tungomålstalande_1_N = mkN "tungomålstalande" ; -- tungomålstalande..nn.1
  tungomålstalare_1_N = mkN "tungomålstalare" utrum  ; -- tungomålstalare..nn.1
  tungrodd_1_A = mkA "tungrodd" ; -- tungrodd..av.1
  tungroddhet_1_N = mkN "tungroddhet" ; -- tungroddhet..nn.1
  tungrot_1_N = mkN "tungrot" ; -- tungrot..nn.1
  tungrots_r_1_N = mkN "tungrots-r" neutrum  ; -- tungrots-r..nn.1
  tungrygg_1_N = mkN "tungrygg" ; -- tungrygg..nn.1
  tungsam_1_A = mkA "tungsam" "tungsamt" "tungsamma" "tungsamma" "tungsammare" "tungsammast" "tungsammaste" ; -- tungsam..av.1
  tungsamhet_1_N = mkN "tungsamhet" ; -- tungsamhet..nn.1
  tungsida_1_N = mkN "tungsida" ; -- tungsida..nn.1
  tungsinne_1_N = mkN "tungsinne" ; -- tungsinne..nn.1
  tungsint_1_A = mkA "tungsint" "tungsint" ; -- tungsint..av.1
  tungsinthet_1_N = mkN "tungsinthet" "tungsintheter" ; -- tungsinthet..nn.1
  tungsmycke_1_N = mkN "tungsmycke" ; -- tungsmycke..nn.1
  tungspat_1_N = mkN "tungspat" ; -- tungspat..nn.1
  tungspene_1_N = mkN "tungspene" utrum  ; -- tungspene..nn.1
  tungspets_r_1_N = mkN "tungspets-r" neutrum  ; -- tungspets-r..nn.1
  tungspets_1_N = mkN "tungspets" ; -- tungspets..nn.1
  tungsövd_1_A = mkA "tungsövd" "tungsövt" ; -- tungsövd..av.1
  tungsövdhet_1_N = mkN "tungsövdhet" ; -- tungsövdhet..nn.1
  tungus_1_N = mkN "tungus" "tunguser" ; -- tungus..nn.1
  tungusisk_1_A = mkA "tungusisk" ; -- tungusisk..av.1
  tungvattenreaktor_1_N = mkN "tungvattenreaktor" "tungvattenreaktorer" ; -- tungvattenreaktor..nn.1
  tungvikt_1_N = mkN "tungvikt" ; -- tungvikt..nn.1
  tungviktare_1_N = mkN "tungviktare" utrum  ; -- tungviktare..nn.1
  tungvrickande_1_A = mkA "tungvrickande" ; -- tungvrickande..av.1
  tungvrickare_1_N = mkN "tungvrickare" utrum  ; -- tungvrickare..nn.1
  tungört_1_N = mkN "tungört" "tungörter" ; -- tungört..nn.1
  tunik_1_N = mkN "tunik" "tuniker" ; -- tunik..nn.1
  tunika_1_N = mkN "tunika" ; -- tunika..nn.1
  tunisier_1_N = mkN "tunisier" "tunisiern" "tunisier" "tunisierna" ; -- tunisier..nn.1
  tunisisk_1_A = mkA "tunisisk" ; -- tunisisk..av.1
  tunisiska_1_N = mkN "tunisiska" ; -- tunisiska..nn.1
  tunn_1_A = mkA "tunn" "tunt" ; -- tunn..av.1
  tunna_1_N = mkN "tunna" ; -- tunna..nn.1
  tunna_1_V = mkV "tunnar" ; -- tunna..vb.1
  tunnande_1_N = mkN "tunnande" ; -- tunnande..nn.1
  tunnband_1_N = mkN "tunnband" neutrum  ; -- tunnband..nn.1
  tunnbindare_1_N = mkN "tunnbindare" utrum  ; -- tunnbindare..nn.1
  tunnbinderi_1_N = mkN "tunnbinderi" "tunnbinderiet" "tunnbinderier" "tunnbinderierna" ; -- tunnbinderi..nn.1
  tunnbladig_1_A = mkA "tunnbladig" ; -- tunnbladig..av.1
  tunnbröd_1_N = mkN "tunnbröd" neutrum  ; -- tunnbröd..nn.1
  tunnebanenät_1_N = mkN "tunnebanenät" neutrum  ; -- tunnebanenät..nn.1
  tunnel_1_N = mkN "tunnel" ; -- tunnel..nn.1
  tunnelbana_1_N = mkN "tunnelbana" ; -- tunnelbana..nn.1
  tunnelbanebombning_1_N = mkN "tunnelbanebombning" ; -- tunnelbanebombning..nn.1
  tunnelbanebygge_1_N = mkN "tunnelbanebygge" ; -- tunnelbanebygge..nn.1
  tunnelbanefärd_1_N = mkN "tunnelbanefärd" "tunnelbanefärder" ; -- tunnelbanefärd..nn.1
  tunnelbanekiosk_1_N = mkN "tunnelbanekiosk" "tunnelbanekiosker" ; -- tunnelbanekiosk..nn.1
  tunnelbaneresenär_1_N = mkN "tunnelbaneresenär" "tunnelbaneresenärer" ; -- tunnelbaneresenär..nn.1
  tunnelbanestation_1_N = mkN "tunnelbanestation" ; -- tunnelbanestation..nn.1
  tunneldiod_1_N = mkN "tunneldiod" "tunneldioder" ; -- tunneldiod..nn.1
  tunneleffekt_1_N = mkN "tunneleffekt" "tunneleffekter" ; -- tunneleffekt..nn.1
  tunnelgenombrott_1_N = mkN "tunnelgenombrott" neutrum  ; -- tunnelgenombrott..nn.1
  tunnelliknande_1_A = mkA "tunnelliknande" ; -- tunnelliknande..av.1
  tunnelseende_1_N = mkN "tunnelseende" ; -- tunnelseende..nn.1
  tunnelugn_1_N = mkN "tunnelugn" ; -- tunnelugn..nn.1
  tunnhet_1_N = mkN "tunnhet" ; -- tunnhet..nn.1
  tunnhudad_1_A = mkA "tunnhudad" ; -- tunnhudad..av.1
  tunnhårig_1_A = mkA "tunnhårig" ; -- tunnhårig..av.1
  tunnhårighet_1_N = mkN "tunnhårighet" ; -- tunnhårighet..nn.1
  tunnklädd_1_A = mkA "tunnklädd" ; -- tunnklädd..av.1
  tunnkläddhet_1_N = mkN "tunnkläddhet" ; -- tunnkläddhet..nn.1
  tunnland_1_N = mkN "tunnland" neutrum  ; -- tunnland..nn.1
  tunnpannkaka_1_N = mkN "tunnpannkaka" ; -- tunnpannkaka..nn.1
  tunnplåt_1_N = mkN "tunnplåt" ; -- tunnplåt..nn.1
  tunnsliten_1_A = mkA "tunnsliten" ; -- tunnsliten..av.1
  tunnstav_1_N = mkN "tunnstav" ; -- tunnstav..nn.1
  tunnsådd_1_A = mkA "tunnsådd" ; -- tunnsådd..av.1
  tunnsåddhet_1_N = mkN "tunnsåddhet" ; -- tunnsåddhet..nn.1
  tunntarm_1_N = mkN "tunntarm" ; -- tunntarm..nn.1
  tunnvalv_1_N = mkN "tunnvalv" neutrum  ; -- tunnvalv..nn.1
  tunnvis_1_Adv = mkAdv "tunnvis" ; -- tunnvis..ab.1
  tupera_1_V = mkV "tuperar" ; -- tupera..vb.1
  tuperande_1_N = mkN "tuperande" ; -- tuperande..nn.1
  tuperbar_1_A = mkA "tuperbar" ; -- tuperbar..av.1
  tuperbarhet_1_N = mkN "tuperbarhet" ; -- tuperbarhet..nn.1
  tupering_1_N = mkN "tupering" ; -- tupering..nn.1
  tupp_1_N = mkN "tupp" ; -- tupp..nn.1
  tuppfjät_1_N = mkN "tuppfjät" neutrum  ; -- tuppfjät..nn.1
  tuppfäktning_1_N = mkN "tuppfäktning" ; -- tuppfäktning..nn.1
  tuppjuck_1_N = mkN "tuppjuck" neutrum  ; -- tuppjuck..nn.1
  tuppkam_1_N = mkN "tuppkam" "tuppkammen" "tuppkammar" "tuppkammarna" ; -- tuppkam..nn.1
  tuppkyckling_1_N = mkN "tuppkyckling" ; -- tuppkyckling..nn.1
  tupplur_1_N = mkN "tupplur" ; -- tupplur..nn.1
  tupé_1_N = mkN "tupé" "tupéer" ; -- tupé..nn.1
  tur_1_N = mkN "tur" "turer" ; -- tur..nn.1
  tur_2_N = mkN "tur" ; -- tur..nn.2
  turban_1_N = mkN "turban" "turbaner" ; -- turban..nn.1
  turbanklädd_1_A = mkA "turbanklädd" ; -- turbanklädd..av.1
  turbin_1_N = mkN "turbin" "turbiner" ; -- turbin..nn.1
  turbinlager_1_N = mkN "turbinlager" neutrum  ; -- turbinlager..nn.1
  turbinmotor_1_N = mkN "turbinmotor" "turbinmotorer" ; -- turbinmotor..nn.1
  turbojetmotor_1_N = mkN "turbojetmotor" "turbojetmotorer" ; -- turbojetmotor..nn.1
  turbojetplan_1_N = mkN "turbojetplan" neutrum  ; -- turbojetplan..nn.1
  turbometod_1_N = mkN "turbometod" "turbometoder" ; -- turbometod..nn.1
  turbomotor_1_N = mkN "turbomotor" "turbomotorer" ; -- turbomotor..nn.1
  turbopropmotor_1_N = mkN "turbopropmotor" "turbopropmotorer" ; -- turbopropmotor..nn.1
  turbulens_1_N = mkN "turbulens" ; -- turbulens..nn.1
  turbulent_1_A = mkA "turbulent" "turbulent" ; -- turbulent..av.1
  turf_1_N = mkN "turf" ; -- turf..nn.1
  turism_1_N = mkN "turism" "turismer" ; -- turism..nn.1
  turismkritiker_1_N = mkN "turismkritiker" "turismkritikern" "turismkritiker" "turismkritikerna" ; -- turismkritiker..nn.1
  turismnäring_1_N = mkN "turismnäring" ; -- turismnäring..nn.1
  turist_1_N = mkN "turist" "turister" ; -- turist..nn.1
  turista_1_V = mkV "turistar" ; -- turista..vb.1
  turistande_1_N = mkN "turistande" ; -- turistande..nn.1
  turistattraktion_1_N = mkN "turistattraktion" ; -- turistattraktion..nn.1
  turistbroschyr_1_N = mkN "turistbroschyr" "turistbroschyrer" ; -- turistbroschyr..nn.1
  turistbuss_1_N = mkN "turistbuss" ; -- turistbuss..nn.1
  turistbyrå_1_N = mkN "turistbyrå" "turistbyråer" ; -- turistbyrå..nn.1
  turistförening_1_N = mkN "turistförening" ; -- turistförening..nn.1
  turisthandbok_1_N = mkN "turisthandbok" "turisthandböcker" ; -- turisthandbok..nn.1
  turistinformation_1_N = mkN "turistinformation" ; -- turistinformation..nn.1
  turistisk_1_A = mkA "turistisk" ; -- turistisk..av.1
  turistklass_1_N = mkN "turistklass" "turistklasser" ; -- turistklass..nn.1
  turistland_1_N = mkN "turistland" "turistlandet" "turistländer" "turistländerna" ; -- turistland..nn.1
  turistmässig_1_A = mkA "turistmässig" ; -- turistmässig..av.1
  turistmål_1_N = mkN "turistmål" neutrum  ; -- turistmål..nn.1
  turistnäring_1_N = mkN "turistnäring" ; -- turistnäring..nn.1
  turistort_1_N = mkN "turistort" "turistorter" ; -- turistort..nn.1
  turiststation_1_N = mkN "turiststation" ; -- turiststation..nn.1
  turistström_1_N = mkN "turistström" "turistströmmen" "turistströmmar" "turistströmmarna" ; -- turistström..nn.1
  turiststuga_1_N = mkN "turiststuga" ; -- turiststuga..nn.1
  turistsäng_1_N = mkN "turistsäng" ; -- turistsäng..nn.1
  turisttät_1_A = mkA "turisttät" ; -- turisttät..av.1
  turisttäthet_1_N = mkN "turisttäthet" ; -- turisttäthet..nn.1
  turistvaluta_1_N = mkN "turistvaluta" ; -- turistvaluta..nn.1
  turistö_1_N = mkN "turistö" ; -- turistö..nn.1
  turk_1_N = mkN "turk" ; -- turk..nn.1
  turkcypriot_1_N = mkN "turkcypriot" "turkcyprioter" ; -- turkcypriot..nn.1
  turkcypriotisk_1_A = mkA "turkcypriotisk" ; -- turkcypriotisk..av.1
  turkfolk_1_N = mkN "turkfolk" neutrum  ; -- turkfolk..nn.1
  turkisk_1_A = mkA "turkisk" ; -- turkisk..av.1
  turkiska_1_N = mkN "turkiska" ; -- turkiska..nn.1
  turkiska_2_N = mkN "turkiska" ; -- turkiska..nn.2
  turkmen_1_N = mkN "turkmen" "turkmener" ; -- turkmen..nn.1
  turkmenska_1_N = mkN "turkmenska" ; -- turkmenska..nn.1
  turkmenska_2_N = mkN "turkmenska" ; -- turkmenska..nn.2
  turkos_1_A = mkA "turkos" ; -- turkos..av.1
  turkos_1_N = mkN "turkos" "turkoser" ; -- turkos..nn.1
  turkosblå_1_A = mkA "turkosblå" "turkosblått" ; -- turkosblå..av.1
  turkosfärgad_1_A = mkA "turkosfärgad" ; -- turkosfärgad..av.1
  turksadel_1_N = mkN "turksadel" ; -- turksadel..nn.1
  turlig_1_A = mkA "turlig" ; -- turlig..av.1
  turlighet_1_N = mkN "turlighet" ; -- turlighet..nn.1
  turlista_1_N = mkN "turlista" ; -- turlista..nn.1
  turmalin_1_N = mkN "turmalin" "turmaliner" ; -- turmalin..nn.1
  turnera_1_V = mkV "turnerar" ; -- turnera..vb.1
  turnera_2_V = mkV "turnerar" ; -- turnera..vb.2
  turnerande_1_N = mkN "turnerande" ; -- turnerande..nn.1
  turnerbar_1_A = mkA "turnerbar" ; -- turnerbar..av.1
  turnerbarhet_1_N = mkN "turnerbarhet" ; -- turnerbarhet..nn.1
  turnering_1_N = mkN "turnering" ; -- turnering..nn.1
  turnyr_1_N = mkN "turnyr" "turnyrer" ; -- turnyr..nn.1
  turné_1_N = mkN "turné" "turnéer" ; -- turné..nn.1
  turnébuss_1_N = mkN "turnébuss" ; -- turnébuss..nn.1
  turochreturbiljett_1_N = mkN "turochreturbiljett" "turochreturbiljetter" ; -- turochreturbiljett..nn.1
  turordning_1_N = mkN "turordning" ; -- turordning..nn.1
  turordningsregel_1_N = mkN "turordningsregel" "turordningsregeln" "turordningsregler" "turordningsreglerna" ; -- turordningsregel..nn.1
  turs_1_N = mkN "turs" ; -- turs..nn.1
  tursam_1_A = mkA "tursam" "tursamt" "tursamma" "tursamma" "tursammare" "tursammast" "tursammaste" ; -- tursam..av.1
  tursamhet_1_N = mkN "tursamhet" ; -- tursamhet..nn.1
  turturduva_1_N = mkN "turturduva" ; -- turturduva..nn.1
  turtäthet_1_N = mkN "turtäthet" "turtätheter" ; -- turtäthet..nn.1
  turvis_1_Adv = mkAdv "turvis" ; -- turvis..ab.1
  turvis_1_A = mkA "turvis" ; -- turvis..av.1
  tusch_1_N = mkN "tusch" ; -- tusch..nn.1
  tuscha_1_V = mkV "tuschar" ; -- tuscha..vb.1
  tuschande_1_N = mkN "tuschande" ; -- tuschande..nn.1
  tuschera_1_V = mkV "tuscherar" ; -- tuschera..vb.1
  tuscherande_1_N = mkN "tuscherande" ; -- tuscherande..nn.1
  tuscherbar_1_A = mkA "tuscherbar" ; -- tuscherbar..av.1
  tuscherbarhet_1_N = mkN "tuscherbarhet" ; -- tuscherbarhet..nn.1
  tuschering_1_N = mkN "tuschering" ; -- tuschering..nn.1
  tuschpenna_1_N = mkN "tuschpenna" ; -- tuschpenna..nn.1
  tuschritning_1_N = mkN "tuschritning" ; -- tuschritning..nn.1
  tuschteckning_1_N = mkN "tuschteckning" ; -- tuschteckning..nn.1
  tusenbladstårta_1_N = mkN "tusenbladstårta" ; -- tusenbladstårta..nn.1
  tusende_1_A = mkA "tusende" ; -- tusende..av.1
  tusende_1_N = mkN "tusende" ; -- tusende..nn.1
  tusendedel_1_N = mkN "tusendedel" "tusendedelen" "tusendedelar" "tusendedelarna" ; -- tusendedel..nn.1
  tusendel_1_N = mkN "tusendel" "tusendelen" "tusendelar" "tusendelarna" ; -- tusendel..nn.1
  tusenfaldig_1_A = mkA "tusenfaldig" ; -- tusenfaldig..av.1
  tusenfalt_1_Adv = mkAdv "tusenfalt" ; -- tusenfalt..ab.1
  tusenfoting_1_N = mkN "tusenfoting" ; -- tusenfoting..nn.1
  tusenhövdad_1_A = mkA "tusenhövdad" ; -- tusenhövdad..av.1
  tusenkonstnär_1_N = mkN "tusenkonstnär" "tusenkonstnärer" ; -- tusenkonstnär..nn.1
  tusenkronorssedel_1_N = mkN "tusenkronorssedel" ; -- tusenkronorssedel..nn.1
  tusenlapp_1_N = mkN "tusenlapp" ; -- tusenlapp..nn.1
  tusensköna_1_N = mkN "tusensköna" ; -- tusensköna..nn.1
  tusental_1_N = mkN "tusental" neutrum  ; -- tusental..nn.1
  tusenåra_1_A = mkA "tusenåra" ; -- tusenåra..av.1
  tusenårig_1_A = mkA "tusenårig" ; -- tusenårig..av.1
  tusenårsrike_1_N = mkN "tusenårsrike" ; -- tusenårsrike..nn.1
  tusing_1_N = mkN "tusing" ; -- tusing..nn.1
  tuskaft_1_N = mkN "tuskaft" ; -- tuskaft..nn.1
  tuss_1_N = mkN "tuss" ; -- tuss..nn.1
  tussa_1_V = mkV "tussar" ; -- tussa..vb.1
  tussande_1_N = mkN "tussande" ; -- tussande..nn.1
  tussilago_1_N = mkN "tussilago" "tussilagor" ; -- tussilago..nn.1
  tussning_1_N = mkN "tussning" ; -- tussning..nn.1
  tut_1_N = mkN "tut" ; -- tut..nn.1
  tut_2_N = mkN "tut" neutrum  ; -- tut..nn.2
  tuta_1_N = mkN "tuta" ; -- tuta..nn.1
  tuta_1_V = mkV "tutar" ; -- tuta..vb.1
  tuta_2_V = mkV "tutar" ; -- tuta..vb.2
  tutande_1_N = mkN "tutande" ; -- tutande..nn.1
  tuting_1_N = mkN "tuting" ; -- tuting..nn.1
  tutt_1_N = mkN "tutt" ; -- tutt..nn.1
  tutta_1_N = mkN "tutta" ; -- tutta..nn.1
  tutte_1_N = mkN "tutte" utrum  ; -- tutte..nn.1
  tutti_1_N = mkN "tutti" "tuttit" "tuttin" "tuttina" ; -- tutti..nn.1
  tuva_1_N = mkN "tuva" ; -- tuva..nn.1
  tuvad_1_A = mkA "tuvad" ; -- tuvad..av.1
  tuvaluan_1_N = mkN "tuvaluan" "tuvaluaner" ; -- tuvaluan..nn.1
  tuvaluansk_1_A = mkA "tuvaluansk" ; -- tuvaluansk..av.1
  tuvaluanska_1_N = mkN "tuvaluanska" ; -- tuvaluanska..nn.1
  tuvaluanska_2_N = mkN "tuvaluanska" ; -- tuvaluanska..nn.2
  tuvig_1_A = mkA "tuvig" ; -- tuvig..av.1
  tuvstarr_1_N = mkN "tuvstarr" ; -- tuvstarr..nn.1
  tuvsäv_1_N = mkN "tuvsäv" ; -- tuvsäv..nn.1
  tuvtåtel_1_N = mkN "tuvtåtel" ; -- tuvtåtel..nn.1
  tv_evangelist_1_N = mkN "tv-evangelist" "tv-evangelister" ; -- tv-evangelist..nn.1
  tv_kamera_1_N = mkN "tv-kamera" ; -- tv-kamera..nn.1
  tv_kanal_1_N = mkN "tv-kanal" "tv-kanaler" ; -- tv-kanal..nn.1
  tv_kock_1_N = mkN "tv-kock" ; -- tv-kock..nn.1
  tv_konferens_1_N = mkN "tv-konferens" "tv-konferenser" ; -- tv-konferens..nn.1
  tv_leverantör_1_N = mkN "tv-leverantör" "tv-leverantörer" ; -- tv-leverantör..nn.1
  tv_meteorolog_1_N = mkN "tv-meteorolog" "tv-meteorologer" ; -- tv-meteorolog..nn.1
  tv_mottagare_1_N = mkN "tv-mottagare" utrum  ; -- tv-mottagare..nn.1
  tv_nyhet_1_N = mkN "tv-nyhet" "tv-nyheter" ; -- tv-nyhet..nn.1
  tv_predikant_1_N = mkN "tv-predikant" "tv-predikanter" ; -- tv-predikant..nn.1
  tv_producent_1_N = mkN "tv-producent" "tv-producenter" ; -- tv-producent..nn.1
  tv_program_1_N = mkN "tv-program" "tv-programmet" "tv-program" "tv-programmen" ; -- tv-program..nn.1
  tv_reklam_1_N = mkN "tv-reklam" ; -- tv-reklam..nn.1
  tv_reparatör_1_N = mkN "tv-reparatör" "tv-reparatörer" ; -- tv-reparatör..nn.1
  tv_ruta_1_N = mkN "tv-ruta" ; -- tv-ruta..nn.1
  tv_serie_1_N = mkN "tv-serie" "tv-serier" ; -- tv-serie..nn.1
  tv_skärm_1_N = mkN "tv-skärm" ; -- tv-skärm..nn.1
  tv_studio_1_N = mkN "tv-studio" "tv-studior" ; -- tv-studio..nn.1
  tv_sändare_1_N = mkN "tv-sändare" utrum  ; -- tv-sändare..nn.1
  tv_sändning_1_N = mkN "tv-sändning" ; -- tv-sändning..nn.1
  tv_tablå_1_N = mkN "tv-tablå" "tv-tablåer" ; -- tv-tablå..nn.1
  tv_tittande_1_N = mkN "tv-tittande" ; -- tv-tittande..nn.1
  tv_tittare_1_N = mkN "tv-tittare" utrum  ; -- tv-tittare..nn.1
  tvaga_1_N = mkN "tvaga" ; -- tvaga..nn.1
  tvaga_1_V = mkV "tvagar" ; -- tvaga..vb.1
  tvagande_1_N = mkN "tvagande" ; -- tvagande..nn.1
  tvagning_1_N = mkN "tvagning" ; -- tvagning..nn.1
  tvedräkt_1_N = mkN "tvedräkt" ; -- tvedräkt..nn.1
  tveeggad_1_A = mkA "tveeggad" ; -- tveeggad..av.1
  tvegifte_1_N = mkN "tvegifte" ; -- tvegifte..nn.1
  tvehågsen_1_A = mkA "tvehågsen" ; -- tvehågsen..av.1
  tvehågsenhet_1_N = mkN "tvehågsenhet" ; -- tvehågsenhet..nn.1
  tvehövdad_1_A = mkA "tvehövdad" ; -- tvehövdad..av.1
  tveka_1_V = mkV "tvekar" ; -- tveka..vb.1
  tvekamp_1_N = mkN "tvekamp" "tvekamper" ; -- tvekamp..nn.1
  tvekande_1_N = mkN "tvekande" ; -- tvekande..nn.1
  tveklös_1_A = mkA "tveklös" ; -- tveklös..av.1
  tveklöshet_1_N = mkN "tveklöshet" ; -- tveklöshet..nn.1
  tveksam_1_A = mkA "tveksam" "tveksamt" "tveksamma" "tveksamma" "tveksammare" "tveksammast" "tveksammaste" ; -- tveksam..av.1
  tveksamhet_1_N = mkN "tveksamhet" "tveksamheter" ; -- tveksamhet..nn.1
  tvekönad_1_A = mkA "tvekönad" ; -- tvekönad..av.1
  tvesalu_1_N = mkN "tvesalu" ; -- tvesalu..nn.1
  tvestjärt_1_N = mkN "tvestjärt" ; -- tvestjärt..nn.1
  tvetungad_1_A = mkA "tvetungad" ; -- tvetungad..av.1
  tvetydig_1_A = mkA "tvetydig" ; -- tvetydig..av.1
  tvetydighet_1_N = mkN "tvetydighet" "tvetydigheter" ; -- tvetydighet..nn.1
  tvilling_1_N = mkN "tvilling" ; -- tvilling..nn.1
  tvillingbror_1_N = mkN "tvillingbror" "tvillingbröder" ; -- tvillingbror..nn.1
  tvillingflicka_1_N = mkN "tvillingflicka" ; -- tvillingflicka..nn.1
  tvillingfödsel_1_N = mkN "tvillingfödsel" ; -- tvillingfödsel..nn.1
  tvillingkristall_1_N = mkN "tvillingkristall" "tvillingkristaller" ; -- tvillingkristall..nn.1
  tvillingkärna_1_N = mkN "tvillingkärna" ; -- tvillingkärna..nn.1
  tvillinglik_1_A = mkA "tvillinglik" ; -- tvillinglik..av.1
  tvillinglikhet_1_N = mkN "tvillinglikhet" ; -- tvillinglikhet..nn.1
  tvillingmaskin_1_N = mkN "tvillingmaskin" "tvillingmaskiner" ; -- tvillingmaskin..nn.1
  tvillingpar_1_N = mkN "tvillingpar" neutrum  ; -- tvillingpar..nn.1
  tvillingstjärna_1_N = mkN "tvillingstjärna" ; -- tvillingstjärna..nn.1
  tvillingsyskon_1_N = mkN "tvillingsyskon" neutrum  ; -- tvillingsyskon..nn.1
  tvillingsyster_1_N = mkN "tvillingsyster" ; -- tvillingsyster..nn.1
  tvillingtorn_1_N = mkN "tvillingtorn" neutrum  ; -- tvillingtorn..nn.1
  tvillingvagn_1_N = mkN "tvillingvagn" ; -- tvillingvagn..nn.1
  tvills_1_N = mkN "tvills" ; -- tvills..nn.1
  tvina_1_V = mkV "tvinar" ; -- tvina..vb.1
  tvinande_1_N = mkN "tvinande" ; -- tvinande..nn.1
  tving_1_N = mkN "tving" ; -- tving..nn.1
  tvinga_1_V = mkV "tvingar" ; -- tvinga..vb.1
  tvingande_1_A = mkA "tvingande" ; -- tvingande..av.1
  tvingande_1_N = mkN "tvingande" ; -- tvingande..nn.1
  tvinna_1_V = mkV "tvinnar" ; -- tvinna..vb.1
  tvinnande_1_N = mkN "tvinnande" ; -- tvinnande..nn.1
  tvinsjuk_1_A = mkA "tvinsjuk" ; -- tvinsjuk..av.1
  tvinsot_1_N = mkN "tvinsot" ; -- tvinsot..nn.1
  tvist_1_N = mkN "tvist" "tvister" ; -- tvist..nn.1
  tvista_1_V = mkV "tvistar" ; -- tvista..vb.1
  tvistande_1_N = mkN "tvistande" ; -- tvistande..nn.1
  tvistefråga_1_N = mkN "tvistefråga" ; -- tvistefråga..nn.1
  tvistefrö_1_N = mkN "tvistefrö" "tvistefröet" "tvistefrön" "tvistefröna" ; -- tvistefrö..nn.1
  tvistemål_1_N = mkN "tvistemål" neutrum  ; -- tvistemål..nn.1
  tvisteämne_1_N = mkN "tvisteämne" ; -- tvisteämne..nn.1
  tvisteäpple_1_N = mkN "tvisteäpple" ; -- tvisteäpple..nn.1
  tvistig_1_A = mkA "tvistig" ; -- tvistig..av.1
  tvistighet_1_N = mkN "tvistighet" "tvistigheter" ; -- tvistighet..nn.1
  tvistlig_1_A = mkA "tvistlig" ; -- tvistlig..av.1
  tvistsöm_1_N = mkN "tvistsöm" "tvistsömmen" "tvistsömmar" "tvistsömmarna" ; -- tvistsöm..nn.1
  tvittra_1_V = mkV "tvittrar" ; -- tvittra..vb.1
  tvittrande_1_N = mkN "tvittrande" ; -- tvittrande..nn.1
  tvittrare_1_N = mkN "tvittrare" utrum  ; -- tvittrare..nn.1
  tvittring_1_N = mkN "tvittring" ; -- tvittring..nn.1
  tvivel_1_N = mkN "tvivel" neutrum  ; -- tvivel..nn.1
  tvivelaktig_1_A = mkA "tvivelaktig" ; -- tvivelaktig..av.1
  tvivelaktighet_1_N = mkN "tvivelaktighet" ; -- tvivelaktighet..nn.1
  tvivelsam_1_A = mkA "tvivelsam" "tvivelsamt" "tvivelsamma" "tvivelsamma" "tvivelsammare" "tvivelsammast" "tvivelsammaste" ; -- tvivelsam..av.1
  tvivelsamhet_1_N = mkN "tvivelsamhet" ; -- tvivelsamhet..nn.1
  tvivelshållning_1_N = mkN "tvivelshållning" ; -- tvivelshållning..nn.1
  tvivelsjuk_1_A = mkA "tvivelsjuk" ; -- tvivelsjuk..av.1
  tvivelsjukhet_1_N = mkN "tvivelsjukhet" ; -- tvivelsjukhet..nn.1
  tvivelsmål_1_N = mkN "tvivelsmål" neutrum  ; -- tvivelsmål..nn.1
  tvivelsutan_1_Adv = mkAdv "tvivelsutan" ; -- tvivelsutan..ab.1
  tvivla_1_V = mkV "tvivlar" ; -- tvivla..vb.1
  tvivlande_1_N = mkN "tvivlande" ; -- tvivlande..nn.1
  tvivlare_1_N = mkN "tvivlare" utrum  ; -- tvivlare..nn.1
  tvungen_1_A = mkA "tvungen" ; -- tvungen..av.1
  tvär_1_A = mkA "tvär" ; -- tvär..av.1
  tvära_1_V = mkV "tvärar" ; -- tvära..vb.1
  tvärande_1_N = mkN "tvärande" ; -- tvärande..nn.1
  tvärarg_1_A = mkA "tvärarg" ; -- tvärarg..av.1
  tvärarghet_1_N = mkN "tvärarghet" ; -- tvärarghet..nn.1
  tväraxel_1_N = mkN "tväraxel" ; -- tväraxel..nn.1
  tvärbalk_1_N = mkN "tvärbalk" ; -- tvärbalk..nn.1
  tvärbjälke_1_N = mkN "tvärbjälke" utrum  ; -- tvärbjälke..nn.1
  tvärbrant_1_A = mkA "tvärbrant" "tvärbrant" ; -- tvärbrant..av.1
  tvärbrant_1_N = mkN "tvärbrant" "tvärbranter" ; -- tvärbrant..nn.1
  tvärbranthet_1_N = mkN "tvärbranthet" ; -- tvärbranthet..nn.1
  tvärbromsa_1_V = mkV "tvärbromsar" ; -- tvärbromsa..vb.1
  tvärbromsande_1_N = mkN "tvärbromsande" ; -- tvärbromsande..nn.1
  tvärdjup_1_A = mkA "tvärdjup" ; -- tvärdjup..av.1
  tvärdrag_1_N = mkN "tvärdrag" neutrum  ; -- tvärdrag..nn.1
  tvärfacklig_1_A = mkA "tvärfacklig" ; -- tvärfacklig..av.1
  tvärfacklighet_1_N = mkN "tvärfacklighet" ; -- tvärfacklighet..nn.1
  tvärfakultär_1_A = mkA "tvärfakultär" ; -- tvärfakultär..av.1
  tvärficka_1_N = mkN "tvärficka" ; -- tvärficka..nn.1
  tvärflöjt_1_N = mkN "tvärflöjt" "tvärflöjter" ; -- tvärflöjt..nn.1
  tvärförbannad_1_A = mkA "tvärförbannad" ; -- tvärförbannad..av.1
  tvärförbindelse_1_N = mkN "tvärförbindelse" "tvärförbindelser" ; -- tvärförbindelse..nn.1
  tvärgata_1_N = mkN "tvärgata" ; -- tvärgata..nn.1
  tvärgående_1_A = mkA "tvärgående" ; -- tvärgående..av.1
  tvärhand_1_N = mkN "tvärhand" ; -- tvärhand..nn.1
  tvärhet_1_N = mkN "tvärhet" ; -- tvärhet..nn.1
  tvärhuggen_1_A = mkA "tvärhuggen" ; -- tvärhuggen..av.1
  tvärilsken_1_A = mkA "tvärilsken" ; -- tvärilsken..av.1
  tvärkulturell_1_A = mkA "tvärkulturell" ; -- tvärkulturell..av.1
  tvärlinje_1_N = mkN "tvärlinje" "tvärlinjer" ; -- tvärlinje..nn.1
  tvärmätt_1_A = mkA "tvärmätt" ; -- tvärmätt..av.1
  tvärmätthet_1_N = mkN "tvärmätthet" ; -- tvärmätthet..nn.1
  tvärnit_1_N = mkN "tvärnit" ; -- tvärnit..nn.1
  tvärnita_1_V = mkV "tvärnitar" ; -- tvärnita..vb.1
  tvärnitande_1_N = mkN "tvärnitande" ; -- tvärnitande..nn.1
  tvärpolitisk_1_A = mkA "tvärpolitisk" ; -- tvärpolitisk..av.1
  tvärrandig_1_A = mkA "tvärrandig" ; -- tvärrandig..av.1
  tvärrandighet_1_N = mkN "tvärrandighet" ; -- tvärrandighet..nn.1
  tvärs_1_Adv = mkAdv "tvärs" ; -- tvärs..ab.1
  tvärsa_1_V = mkV "tvärsar" ; -- tvärsa..vb.1
  tvärsande_1_N = mkN "tvärsande" ; -- tvärsande..nn.1
  tvärsemot_1_Adv = mkAdv "tvärsemot" ; -- tvärsemot..ab.1
  tvärsigenom_1_Adv = mkAdv "tvärsigenom" ; -- tvärsigenom..ab.1
  tvärskepp_1_N = mkN "tvärskepp" neutrum  ; -- tvärskepp..nn.1
  tvärskuren_1_A = mkA "tvärskuren" ; -- tvärskuren..av.1
  tvärslockna_1_V = mkV "tvärslocknar" ; -- tvärslockna..vb.1
  tvärslocknande_1_N = mkN "tvärslocknande" ; -- tvärslocknande..nn.1
  tvärslockning_1_N = mkN "tvärslockning" ; -- tvärslockning..nn.1
  tvärslå_1_N = mkN "tvärslå" ; -- tvärslå..nn.1
  tvärsnitt_1_N = mkN "tvärsnitt" neutrum  ; -- tvärsnitt..nn.1
  tvärsom_1_Adv = mkAdv "tvärsom" ; -- tvärsom..ab.1
  tvärspagat_1_N = mkN "tvärspagat" ; -- tvärspagat..nn.1
  tvärstanna_1_V = mkV "tvärstannar" ; -- tvärstanna..vb.1
  tvärstannande_1_N = mkN "tvärstannande" ; -- tvärstannande..nn.1
  tvärstopp_1_N = mkN "tvärstopp" neutrum  ; -- tvärstopp..nn.1
  tvärstreck_1_N = mkN "tvärstreck" neutrum  ; -- tvärstreck..nn.1
  tvärstup_1_N = mkN "tvärstup" neutrum  ; -- tvärstup..nn.1
  tvärsvart_1_A = mkA "tvärsvart" "tvärsvart" ; -- tvärsvart..av.1
  tvärsäker_1_A = mkA "tvärsäker" ; -- tvärsäker..av.1
  tvärsäkerhet_1_N = mkN "tvärsäkerhet" ; -- tvärsäkerhet..nn.1
  tvärsöver_1_Adv = mkAdv "tvärsöver" ; -- tvärsöver..ab.1
  tvärtemot_1_Adv = mkAdv "tvärtemot" ; -- tvärtemot..ab.1
  tvärträ_1_N = mkN "tvärträ" "tvärträt" "tvärträn" "tvärträna" ; -- tvärträ..nn.1
  tvärträ_2_N = mkN "tvärträ" "tvärträet" "tvärträer" "tvärträerna" ; -- tvärträ..nn.2
  tvärtystna_1_V = mkV "tvärtystnar" ; -- tvärtystna..vb.1
  tvärtystnande_1_N = mkN "tvärtystnande" ; -- tvärtystnande..nn.1
  tvärvetenskap_1_N = mkN "tvärvetenskap" "tvärvetenskaper" ; -- tvärvetenskap..nn.1
  tvärvetenskaplig_1_A = mkA "tvärvetenskaplig" ; -- tvärvetenskaplig..av.1
  tvärvetenskaplighet_1_N = mkN "tvärvetenskaplighet" ; -- tvärvetenskaplighet..nn.1
  tvärvigg_1_N = mkN "tvärvigg" ; -- tvärvigg..nn.1
  tvärvända_1_V = mkV "tvärvänder" ; -- tvärvända..vb.1
  tvärvändande_1_N = mkN "tvärvändande" ; -- tvärvändande..nn.1
  tvärvändning_1_N = mkN "tvärvändning" ; -- tvärvändning..nn.1
  tvätt_1_N = mkN "tvätt" ; -- tvätt..nn.1
  tvätta_1_V = mkV "tvättar" ; -- tvätta..vb.1
  tvättande_1_N = mkN "tvättande" ; -- tvättande..nn.1
  tvättautomat_1_N = mkN "tvättautomat" "tvättautomater" ; -- tvättautomat..nn.1
  tvättbar_1_A = mkA "tvättbar" ; -- tvättbar..av.1
  tvättbar_1_N = mkN "tvättbar" "tvättbarer" ; -- tvättbar..nn.1
  tvättbarhet_1_N = mkN "tvättbarhet" ; -- tvättbarhet..nn.1
  tvättbjörn_1_N = mkN "tvättbjörn" ; -- tvättbjörn..nn.1
  tvättbräda_1_N = mkN "tvättbräda" ; -- tvättbräda..nn.1
  tvättbräde_1_N = mkN "tvättbräde" ; -- tvättbräde..nn.1
  tvätteri_1_N = mkN "tvätteri" "tvätteriet" "tvätterier" "tvätterierna" ; -- tvätteri..nn.1
  tvätterska_1_N = mkN "tvätterska" ; -- tvätterska..nn.1
  tvättfat_1_N = mkN "tvättfat" neutrum  ; -- tvättfat..nn.1
  tvätthall_1_N = mkN "tvätthall" ; -- tvätthall..nn.1
  tvättinrättning_1_N = mkN "tvättinrättning" ; -- tvättinrättning..nn.1
  tvättklämma_1_N = mkN "tvättklämma" ; -- tvättklämma..nn.1
  tvättkorg_1_N = mkN "tvättkorg" ; -- tvättkorg..nn.1
  tvättlapp_1_N = mkN "tvättlapp" ; -- tvättlapp..nn.1
  tvättlina_1_N = mkN "tvättlina" ; -- tvättlina..nn.1
  tvättmaskin_1_N = mkN "tvättmaskin" "tvättmaskiner" ; -- tvättmaskin..nn.1
  tvättmedel_1_N = mkN "tvättmedel" neutrum  ; -- tvättmedel..nn.1
  tvättomat_1_N = mkN "tvättomat" "tvättomater" ; -- tvättomat..nn.1
  tvättpelare_1_N = mkN "tvättpelare" utrum  ; -- tvättpelare..nn.1
  tvättpulver_1_N = mkN "tvättpulver" neutrum  ; -- tvättpulver..nn.1
  tvättresultat_1_N = mkN "tvättresultat" neutrum  ; -- tvättresultat..nn.1
  tvättstuga_1_N = mkN "tvättstuga" ; -- tvättstuga..nn.1
  tvättstugebråk_1_N = mkN "tvättstugebråk" neutrum  ; -- tvättstugebråk..nn.1
  tvättställ_1_N = mkN "tvättställ" neutrum  ; -- tvättställ..nn.1
  tvättsvamp_1_N = mkN "tvättsvamp" ; -- tvättsvamp..nn.1
  tvättvatten_1_N = mkN "tvättvatten" "tvättvattnet" "tvättvatten" "tvättvattnen" ; -- tvättvatten..nn.1
  tvättäkta_1_A = mkA "tvättäkta" ; -- tvättäkta..av.1
  två_1_V = mkV "tvår" ; -- två..vb.1
  tvåa_1_N = mkN "tvåa" ; -- tvåa..nn.1
  tvåbarnspappa_1_N = mkN "tvåbarnspappa" ; -- tvåbarnspappa..nn.1
  tvåbent_1_A = mkA "tvåbent" "tvåbent" ; -- tvåbent..av.1
  tvåblad_1_N = mkN "tvåblad" neutrum  ; -- tvåblad..nn.1
  tvåbyggare_1_N = mkN "tvåbyggare" utrum  ; -- tvåbyggare..nn.1
  tvåcylindrig_1_A = mkA "tvåcylindrig" ; -- tvåcylindrig..av.1
  tvådagarstripp_1_N = mkN "tvådagarstripp" ; -- tvådagarstripp..nn.1
  tvådelad_1_A = mkA "tvådelad" ; -- tvådelad..av.1
  tvådimensionell_1_A = mkA "tvådimensionell" ; -- tvådimensionell..av.1
  tvående_1_N = mkN "tvående" ; -- tvående..nn.1
  tvåendel_1_N = mkN "tvåendel" "tvåendelen" "tvåendelar" "tvåendelarna" ; -- tvåendel..nn.1
  tvåfaldig_1_A = mkA "tvåfaldig" ; -- tvåfaldig..av.1
  tvåfamiljshus_1_N = mkN "tvåfamiljshus" neutrum  ; -- tvåfamiljshus..nn.1
  tvåfilig_1_A = mkA "tvåfilig" ; -- tvåfilig..av.1
  tvåfjärdedelstakt_1_N = mkN "tvåfjärdedelstakt" ; -- tvåfjärdedelstakt..nn.1
  tvåformig_1_A = mkA "tvåformig" ; -- tvåformig..av.1
  tvåformighet_1_N = mkN "tvåformighet" ; -- tvåformighet..nn.1
  tvåfrontskrig_1_N = mkN "tvåfrontskrig" neutrum  ; -- tvåfrontskrig..nn.1
  tvåfärgad_1_A = mkA "tvåfärgad" ; -- tvåfärgad..av.1
  tvåhjulig_1_A = mkA "tvåhjulig" ; -- tvåhjulig..av.1
  tvåhjulighet_1_N = mkN "tvåhjulighet" ; -- tvåhjulighet..nn.1
  tvåhjuling_1_N = mkN "tvåhjuling" ; -- tvåhjuling..nn.1
  tvåhjärtbladig_1_A = mkA "tvåhjärtbladig" ; -- tvåhjärtbladig..av.1
  tvåhundrade_1_A = mkA "tvåhundrade" ; -- tvåhundrade..av.1
  tvåhundratal_1_N = mkN "tvåhundratal" neutrum  ; -- tvåhundratal..nn.1
  tvåhändig_1_A = mkA "tvåhändig" ; -- tvåhändig..av.1
  tvåhänt_1_A = mkA "tvåhänt" "tvåhänt" ; -- tvåhänt..av.1
  tvåhänthet_1_N = mkN "tvåhänthet" ; -- tvåhänthet..nn.1
  tvåkammarlykta_1_N = mkN "tvåkammarlykta" ; -- tvåkammarlykta..nn.1
  tvåkammarsystem_1_N = mkN "tvåkammarsystem" neutrum  ; -- tvåkammarsystem..nn.1
  tvåkomponents_1_N = mkN "tvåkomponents" ; -- tvåkomponents..nn.1
  tvåkrona_1_N = mkN "tvåkrona" ; -- tvåkrona..nn.1
  tvåkönad_1_A = mkA "tvåkönad" ; -- tvåkönad..av.1
  tvål_1_N = mkN "tvål" ; -- tvål..nn.1
  tvålask_1_N = mkN "tvålask" ; -- tvålask..nn.1
  tvåledarsystem_1_N = mkN "tvåledarsystem" neutrum  ; -- tvåledarsystem..nn.1
  tvålfager_1_A = mkA "tvålfager" ; -- tvålfager..av.1
  tvålfagerhet_1_N = mkN "tvålfagerhet" ; -- tvålfagerhet..nn.1
  tvålflinga_1_N = mkN "tvålflinga" ; -- tvålflinga..nn.1
  tvålig_1_A = mkA "tvålig" ; -- tvålig..av.1
  tvålighet_1_N = mkN "tvålighet" ; -- tvålighet..nn.1
  tvålkopp_1_N = mkN "tvålkopp" ; -- tvålkopp..nn.1
  tvållödder_1_N = mkN "tvållödder" neutrum  ; -- tvållödder..nn.1
  tvålopera_1_N = mkN "tvålopera" ; -- tvålopera..nn.1
  tvåloperamässig_1_A = mkA "tvåloperamässig" ; -- tvåloperamässig..av.1
  tvåläppig_1_A = mkA "tvåläppig" ; -- tvåläppig..av.1
  tvåmannatält_1_N = mkN "tvåmannatält" neutrum  ; -- tvåmannatält..nn.1
  tvåmans_1_A = mkA "tvåmans" ; -- tvåmans..av.1
  tvåmanstält_1_N = mkN "tvåmanstält" neutrum  ; -- tvåmanstält..nn.1
  tvåmastad_1_A = mkA "tvåmastad" ; -- tvåmastad..av.1
  tvåmastare_1_N = mkN "tvåmastare" utrum  ; -- tvåmastare..nn.1
  tvåmotorig_1_A = mkA "tvåmotorig" ; -- tvåmotorig..av.1
  tvåmänning_1_N = mkN "tvåmänning" ; -- tvåmänning..nn.1
  tvång_1_N = mkN "tvång" neutrum  ; -- tvång..nn.1
  tvångfri_1_A = mkA "tvångfri" "tvångfritt" ; -- tvångfri..av.1
  tvångfrihet_1_N = mkN "tvångfrihet" ; -- tvångfrihet..nn.1
  tvångsansluta_1_V = mkV "tvångsansluta" "tvångsanslöt" "tvångsanslutit" ; -- tvångsansluta..vb.1
  tvångsanslutande_1_N = mkN "tvångsanslutande" ; -- tvångsanslutande..nn.1
  tvångsanslutning_1_N = mkN "tvångsanslutning" ; -- tvångsanslutning..nn.1
  tvångsarbete_1_N = mkN "tvångsarbete" ; -- tvångsarbete..nn.1
  tvångsavvisa_1_V = mkV "tvångsavvisar" ; -- tvångsavvisa..vb.1
  tvångsavvisande_1_N = mkN "tvångsavvisande" ; -- tvångsavvisande..nn.1
  tvångsavvisning_1_N = mkN "tvångsavvisning" ; -- tvångsavvisning..nn.1
  tvångsbälta_1_V = mkV "tvångsbältar" ; -- tvångsbälta..vb.1
  tvångsbältande_1_N = mkN "tvångsbältande" ; -- tvångsbältande..nn.1
  tvångsbälte_1_N = mkN "tvångsbälte" ; -- tvångsbälte..nn.1
  tvångsbältning_1_N = mkN "tvångsbältning" ; -- tvångsbältning..nn.1
  tvångsflytt_1_N = mkN "tvångsflytt" ; -- tvångsflytt..nn.1
  tvångsföreställning_1_N = mkN "tvångsföreställning" ; -- tvångsföreställning..nn.1
  tvångsförflytta_1_V = mkV "tvångsförflyttar" ; -- tvångsförflytta..vb.1
  tvångsförflyttad_1_A = mkA "tvångsförflyttad" ; -- tvångsförflyttad..av.1
  tvångsförflyttande_1_N = mkN "tvångsförflyttande" ; -- tvångsförflyttande..nn.1
  tvångsförflyttning_1_N = mkN "tvångsförflyttning" ; -- tvångsförflyttning..nn.1
  tvångsförsäljning_1_N = mkN "tvångsförsäljning" ; -- tvångsförsäljning..nn.1
  tvångsgift_1_A = mkA "tvångsgift" "tvångsgift" ; -- tvångsgift..av.1
  tvångsgifte_1_N = mkN "tvångsgifte" ; -- tvångsgifte..nn.1
  tvångshandling_1_N = mkN "tvångshandling" ; -- tvångshandling..nn.1
  tvångsinlösa_1_V = mkV "tvångsinlöser" ; -- tvångsinlösa..vb.1
  tvångsinlösande_1_N = mkN "tvångsinlösande" ; -- tvångsinlösande..nn.1
  tvångsinlösen_1_N = mkN "tvångsinlösen" ; -- tvångsinlösen..nn.1
  tvångsintagen_1_A = mkA "tvångsintagen" ; -- tvångsintagen..av.1
  tvångsintagning_1_N = mkN "tvångsintagning" ; -- tvångsintagning..nn.1
  tvångskommendera_1_V = mkV "tvångskommenderar" ; -- tvångskommendera..vb.1
  tvångskommenderande_1_N = mkN "tvångskommenderande" ; -- tvångskommenderande..nn.1
  tvångskommenderbar_1_A = mkA "tvångskommenderbar" ; -- tvångskommenderbar..av.1
  tvångskommenderbarhet_1_N = mkN "tvångskommenderbarhet" ; -- tvångskommenderbarhet..nn.1
  tvångskommendering_1_N = mkN "tvångskommendering" ; -- tvångskommendering..nn.1
  tvångslag_1_N = mkN "tvångslag" ; -- tvångslag..nn.1
  tvångsläge_1_N = mkN "tvångsläge" ; -- tvångsläge..nn.1
  tvångsmedel_1_N = mkN "tvångsmedel" neutrum  ; -- tvångsmedel..nn.1
  tvångsmässig_1_A = mkA "tvångsmässig" ; -- tvångsmässig..av.1
  tvångsmässighet_1_N = mkN "tvångsmässighet" "tvångsmässigheter" ; -- tvångsmässighet..nn.1
  tvångsneuros_1_N = mkN "tvångsneuros" "tvångsneuroser" ; -- tvångsneuros..nn.1
  tvångsomhänderta_1_V = mkV "tvångsomhändertaga" "tvångsomhändertog" "tvångsomhändertagit" ; -- tvångsomhänderta..vb.1
  tvångsomhändertagande_1_N = mkN "tvångsomhändertagande" ; -- tvångsomhändertagande..nn.1
  tvångsomhändertagning_1_N = mkN "tvångsomhändertagning" ; -- tvångsomhändertagning..nn.1
  tvångsrekrytera_1_V = mkV "tvångsrekryterar" ; -- tvångsrekrytera..vb.1
  tvångsrekryterande_1_N = mkN "tvångsrekryterande" ; -- tvångsrekryterande..nn.1
  tvångsrekryterbar_1_A = mkA "tvångsrekryterbar" ; -- tvångsrekryterbar..av.1
  tvångsrekryterbarhet_1_N = mkN "tvångsrekryterbarhet" ; -- tvångsrekryterbarhet..nn.1
  tvångsrekrytering_1_N = mkN "tvångsrekrytering" ; -- tvångsrekrytering..nn.1
  tvångssituation_1_N = mkN "tvångssituation" ; -- tvångssituation..nn.1
  tvångssparande_1_N = mkN "tvångssparande" ; -- tvångssparande..nn.1
  tvångssyndrom_1_N = mkN "tvångssyndrom" neutrum  ; -- tvångssyndrom..nn.1
  tvångstanke_1_N = mkN "tvångstanke" utrum  ; -- tvångstanke..nn.1
  tvångstatuera_1_V = mkV "tvångstatuerar" ; -- tvångstatuera..vb.1
  tvångstatuerande_1_N = mkN "tvångstatuerande" ; -- tvångstatuerande..nn.1
  tvångstatuerbar_1_A = mkA "tvångstatuerbar" ; -- tvångstatuerbar..av.1
  tvångstatuerbarhet_1_N = mkN "tvångstatuerbarhet" ; -- tvångstatuerbarhet..nn.1
  tvångströja_1_N = mkN "tvångströja" ; -- tvångströja..nn.1
  tvångsvis_1_Adv = mkAdv "tvångsvis" ; -- tvångsvis..ab.1
  tvångsvärvad_1_A = mkA "tvångsvärvad" ; -- tvångsvärvad..av.1
  tvångsvård_1_N = mkN "tvångsvård" ; -- tvångsvård..nn.1
  tvångsvårda_1_V = mkV "tvångsvårdar" ; -- tvångsvårda..vb.1
  tvångsvårdande_1_N = mkN "tvångsvårdande" ; -- tvångsvårdande..nn.1
  tvångsvårdning_1_N = mkN "tvångsvårdning" ; -- tvångsvårdning..nn.1
  tvångsåtgärd_1_N = mkN "tvångsåtgärd" "tvångsåtgärder" ; -- tvångsåtgärd..nn.1
  tvåondel_1_N = mkN "tvåondel" "tvåondelen" "tvåondelar" "tvåondelarna" ; -- tvåondel..nn.1
  tvåpartsförhållande_1_N = mkN "tvåpartsförhållande" ; -- tvåpartsförhållande..nn.1
  tvåradig_1_A = mkA "tvåradig" ; -- tvåradig..av.1
  tvårading_1_N = mkN "tvårading" ; -- tvårading..nn.1
  tvårummare_1_N = mkN "tvårummare" utrum  ; -- tvårummare..nn.1
  tvårumslägenhet_1_N = mkN "tvårumslägenhet" "tvårumslägenheter" ; -- tvårumslägenhet..nn.1
  tvåsamhet_1_N = mkN "tvåsamhet" "tvåsamheter" ; -- tvåsamhet..nn.1
  tvåsidig_1_A = mkA "tvåsidig" ; -- tvåsidig..av.1
  tvåsiffrig_1_A = mkA "tvåsiffrig" ; -- tvåsiffrig..av.1
  tvåsitsig_1_A = mkA "tvåsitsig" ; -- tvåsitsig..av.1
  tvåsitssoffa_1_N = mkN "tvåsitssoffa" ; -- tvåsitssoffa..nn.1
  tvåskaft_1_N = mkN "tvåskaft" ; -- tvåskaft..nn.1
  tvåskaftsbindning_1_N = mkN "tvåskaftsbindning" ; -- tvåskaftsbindning..nn.1
  tvåskift_1_N = mkN "tvåskift" neutrum  ; -- tvåskift..nn.1
  tvåspann_1_N = mkN "tvåspann" neutrum  ; -- tvåspann..nn.1
  tvåspråkig_1_A = mkA "tvåspråkig" ; -- tvåspråkig..av.1
  tvåspråkighet_1_N = mkN "tvåspråkighet" ; -- tvåspråkighet..nn.1
  tvåspänd_1_A = mkA "tvåspänd" ; -- tvåspänd..av.1
  tvåstavig_1_A = mkA "tvåstavig" ; -- tvåstavig..av.1
  tvåstavighet_1_N = mkN "tvåstavighet" ; -- tvåstavighet..nn.1
  tvåstavighetsaccent_1_N = mkN "tvåstavighetsaccent" "tvåstavighetsaccenter" ; -- tvåstavighetsaccent..nn.1
  tvåstegsavtryckare_1_N = mkN "tvåstegsavtryckare" utrum  ; -- tvåstegsavtryckare..nn.1
  tvåstjärnig_1_A = mkA "tvåstjärnig" ; -- tvåstjärnig..av.1
  tvåstruken_1_A = mkA "tvåstruken" ; -- tvåstruken..av.1
  tvåstämmig_1_A = mkA "tvåstämmig" ; -- tvåstämmig..av.1
  tvåtakt_1_N = mkN "tvåtakt" "tvåtakter" ; -- tvåtakt..nn.1
  tvåtaktare_1_N = mkN "tvåtaktare" utrum  ; -- tvåtaktare..nn.1
  tvåtaktsmotor_1_N = mkN "tvåtaktsmotor" "tvåtaktsmotorer" ; -- tvåtaktsmotor..nn.1
  tvåtaktsolja_1_N = mkN "tvåtaktsolja" ; -- tvåtaktsolja..nn.1
  tvåtal_1_N = mkN "tvåtal" neutrum  ; -- tvåtal..nn.1
  tvåtimmarsskift_1_N = mkN "tvåtimmarsskift" neutrum  ; -- tvåtimmarsskift..nn.1
  tvåtumfyra_1_N = mkN "tvåtumfyra" ; -- tvåtumfyra..nn.1
  tvåtumsspik_1_N = mkN "tvåtumsspik" ; -- tvåtumsspik..nn.1
  tvåtungad_1_A = mkA "tvåtungad" ; -- tvåtungad..av.1
  tvåtusental_1_N = mkN "tvåtusental" neutrum  ; -- tvåtusental..nn.1
  tvåvinge_1_N = mkN "tvåvinge" utrum  ; -- tvåvinge..nn.1
  tvåvåningsbuss_1_N = mkN "tvåvåningsbuss" ; -- tvåvåningsbuss..nn.1
  tvåäggstvilling_1_N = mkN "tvåäggstvilling" ; -- tvåäggstvilling..nn.1
  tvåårig_1_A = mkA "tvåårig" ; -- tvåårig..av.1
  tvååring_1_N = mkN "tvååring" ; -- tvååring..nn.1
  tvåöring_1_N = mkN "tvåöring" ; -- tvåöring..nn.1
  tweed_1_N = mkN "tweed" ; -- tweed..nn.1
  tweedkavaj_1_N = mkN "tweedkavaj" "tweedkavajer" ; -- tweedkavaj..nn.1
  tweet_1_N = mkN "tweet" ; -- tweet..nn.1
  tweeta_1_V = mkV "tweetar" ; -- tweeta..vb.1
  tweetande_1_N = mkN "tweetande" ; -- tweetande..nn.1
  tweetning_1_N = mkN "tweetning" ; -- tweetning..nn.1
  tweets_1_N = mkN "tweets" neutrum  ; -- tweets..nn.1
  twill_1_N = mkN "twill" ; -- twill..nn.1
  twist_1_N = mkN "twist" ; -- twist..nn.1
  twista_1_V = mkV "twistar" ; -- twista..vb.1
  twistande_1_N = mkN "twistande" ; -- twistande..nn.1
  twittra_1_V = mkV "twittrar" ; -- twittra..vb.1
  twittrande_1_N = mkN "twittrande" ; -- twittrande..nn.1
  twittrare_1_N = mkN "twittrare" utrum  ; -- twittrare..nn.1
  twittring_1_N = mkN "twittring" ; -- twittring..nn.1
  two_step_1_N = mkN "two-step" ; -- two-step..nn.1
  twostep_1_N = mkN "twostep" ; -- twostep..nn.1
  tya_1_V = mkV "tyar" ; -- tya..vb.1
  tyande_1_N = mkN "tyande" ; -- tyande..nn.1
  tycka_1_V = mkV "tycker" ; -- tycka..vb.1
  tyckande_1_N = mkN "tyckande" ; -- tyckande..nn.1
  tyckare_1_N = mkN "tyckare" utrum  ; -- tyckare..nn.1
  tycke_1_N = mkN "tycke" ; -- tycke..nn.1
  tyckmycken_1_A = mkA "tyckmycken" ; -- tyckmycken..av.1
  tyckmyckenhet_1_N = mkN "tyckmyckenhet" ; -- tyckmyckenhet..nn.1
  tyda_1_N = mkN "tyda" ; -- tyda..nn.1
  tyda_1_V = mkV "tyda" "tydde" "tytt" ; -- tyda..vb.1
  tydande_1_N = mkN "tydande" ; -- tydande..nn.1
  tydbar_1_A = mkA "tydbar" ; -- tydbar..av.1
  tydbarhet_1_N = mkN "tydbarhet" ; -- tydbarhet..nn.1
  tydlig_1_A = mkA "tydlig" ; -- tydlig..av.1
  tydligen_1_Adv = mkAdv "tydligen" ; -- tydligen..ab.1
  tydliggöra_1_V = mkV "tydliggöra" "tydliggjorde" "tydliggjort" ; -- tydliggöra..vb.1
  tydliggörande_1_N = mkN "tydliggörande" ; -- tydliggörande..nn.1
  tydlighet_1_N = mkN "tydlighet" ; -- tydlighet..nn.1
  tydlighet_2_N = mkN "tydlighet" "tydligheter" ; -- tydlighet..nn.2
  tydlighetskommatering_1_N = mkN "tydlighetskommatering" ; -- tydlighetskommatering..nn.1
  tydligtvis_1_Adv = mkAdv "tydligtvis" ; -- tydligtvis..ab.1
  tydning_1_N = mkN "tydning" ; -- tydning..nn.1
  tyfoidbakterie_1_N = mkN "tyfoidbakterie" "tyfoidbakterier" ; -- tyfoidbakterie..nn.1
  tyfoidepidemi_1_N = mkN "tyfoidepidemi" "tyfoidepidemier" ; -- tyfoidepidemi..nn.1
  tyfoidfeber_1_N = mkN "tyfoidfeber" ; -- tyfoidfeber..nn.1
  tyfon_1_N = mkN "tyfon" "tyfoner" ; -- tyfon..nn.1
  tyfus_1_N = mkN "tyfus" ; -- tyfus..nn.1
  tyg_1_N = mkN "tyg" neutrum  ; -- tyg..nn.1
  tygband_1_N = mkN "tygband" neutrum  ; -- tygband..nn.1
  tygbanderoll_1_N = mkN "tygbanderoll" "tygbanderoller" ; -- tygbanderoll..nn.1
  tygboll_1_N = mkN "tygboll" ; -- tygboll..nn.1
  tygbom_1_N = mkN "tygbom" "tygbommen" "tygbommar" "tygbommarna" ; -- tygbom..nn.1
  tygbredd_1_N = mkN "tygbredd" "tygbredder" ; -- tygbredd..nn.1
  tygbunt_1_N = mkN "tygbunt" ; -- tygbunt..nn.1
  tygel_1_N = mkN "tygel" ; -- tygel..nn.1
  tygellös_1_A = mkA "tygellös" ; -- tygellös..av.1
  tygellöshet_1_N = mkN "tygellöshet" ; -- tygellöshet..nn.1
  tyghus_1_N = mkN "tyghus" neutrum  ; -- tyghus..nn.1
  tygkant_1_N = mkN "tygkant" "tygkanter" ; -- tygkant..nn.1
  tygla_1_V = mkV "tyglar" ; -- tygla..vb.1
  tyglande_1_N = mkN "tyglande" ; -- tyglande..nn.1
  tyglapp_1_N = mkN "tyglapp" ; -- tyglapp..nn.1
  tygprov_1_N = mkN "tygprov" neutrum  ; -- tygprov..nn.1
  tygremsa_1_N = mkN "tygremsa" ; -- tygremsa..nn.1
  tygrest_1_N = mkN "tygrest" "tygrester" ; -- tygrest..nn.1
  tygrulle_1_N = mkN "tygrulle" utrum  ; -- tygrulle..nn.1
  tygsjok_1_N = mkN "tygsjok" neutrum  ; -- tygsjok..nn.1
  tygsko_1_N = mkN "tygsko" "tygskor" ; -- tygsko..nn.1
  tygstycke_1_N = mkN "tygstycke" ; -- tygstycke..nn.1
  tygtjänst_1_N = mkN "tygtjänst" ; -- tygtjänst..nn.1
  tygtrasa_1_N = mkN "tygtrasa" ; -- tygtrasa..nn.1
  tygtryck_1_N = mkN "tygtryck" neutrum  ; -- tygtryck..nn.1
  tygöverdrag_1_N = mkN "tygöverdrag" neutrum  ; -- tygöverdrag..nn.1
  tyken_1_A = mkA "tyken" ; -- tyken..av.1
  tykenhet_1_N = mkN "tykenhet" "tykenheter" ; -- tykenhet..nn.1
  tykobrahedag_1_N = mkN "tykobrahedag" ; -- tykobrahedag..nn.1
  tyll_1_N = mkN "tyll" ; -- tyll..nn.1
  tyllgardin_1_N = mkN "tyllgardin" "tyllgardiner" ; -- tyllgardin..nn.1
  tyllschal_1_N = mkN "tyllschal" ; -- tyllschal..nn.1
  tyllsjal_1_N = mkN "tyllsjal" ; -- tyllsjal..nn.1
  tympanon_1_N = mkN "tympanon" "tympanoner" ; -- tympanon..nn.1
  tymus_1_N = mkN "tymus" ; -- tymus..nn.1
  tyna_1_V = mkV "tynar" ; -- tyna..vb.1
  tynande_1_N = mkN "tynande" ; -- tynande..nn.1
  tynga_1_V = mkV "tynger" ; -- tynga..vb.1
  tyngande_1_N = mkN "tyngande" ; -- tyngande..nn.1
  tyngd_1_N = mkN "tyngd" "tyngder" ; -- tyngd..nn.1
  tyngdacceleration_1_N = mkN "tyngdacceleration" ; -- tyngdacceleration..nn.1
  tyngdkraft_1_N = mkN "tyngdkraft" ; -- tyngdkraft..nn.1
  tyngdkraftsstörning_1_N = mkN "tyngdkraftsstörning" ; -- tyngdkraftsstörning..nn.1
  tyngdlag_1_N = mkN "tyngdlag" ; -- tyngdlag..nn.1
  tyngdlyftare_1_N = mkN "tyngdlyftare" utrum  ; -- tyngdlyftare..nn.1
  tyngdlyftning_1_N = mkN "tyngdlyftning" ; -- tyngdlyftning..nn.1
  tyngdlös_1_A = mkA "tyngdlös" ; -- tyngdlös..av.1
  tyngdlöshet_1_N = mkN "tyngdlöshet" "tyngdlösheter" ; -- tyngdlöshet..nn.1
  tyngdlöshetssimulator_1_N = mkN "tyngdlöshetssimulator" "tyngdlöshetssimulatorer" ; -- tyngdlöshetssimulator..nn.1
  tyngdpunkt_1_N = mkN "tyngdpunkt" "tyngdpunkter" ; -- tyngdpunkt..nn.1
  typ_1_Adv = mkAdv "typ" ; -- typ..ab.1
  typ_1_N = mkN "typ" "typer" ; -- typ..nn.1
  typbesiktning_1_N = mkN "typbesiktning" ; -- typbesiktning..nn.1
  typbildande_1_A = mkA "typbildande" ; -- typbildande..av.1
  typexempel_1_N = mkN "typexempel" neutrum  ; -- typexempel..nn.1
  typfall_1_N = mkN "typfall" neutrum  ; -- typfall..nn.1
  typifiera_1_V = mkV "typifierar" ; -- typifiera..vb.1
  typifierande_1_N = mkN "typifierande" ; -- typifierande..nn.1
  typifierbar_1_A = mkA "typifierbar" ; -- typifierbar..av.1
  typifierbarhet_1_N = mkN "typifierbarhet" ; -- typifierbarhet..nn.1
  typifiering_1_N = mkN "typifiering" ; -- typifiering..nn.1
  typisera_1_V = mkV "typiserar" ; -- typisera..vb.1
  typiserande_1_N = mkN "typiserande" ; -- typiserande..nn.1
  typiserbar_1_A = mkA "typiserbar" ; -- typiserbar..av.1
  typiserbarhet_1_N = mkN "typiserbarhet" ; -- typiserbarhet..nn.1
  typisering_1_N = mkN "typisering" ; -- typisering..nn.1
  typisk_1_A = mkA "typisk" ; -- typisk..av.1
  typiskhet_1_N = mkN "typiskhet" ; -- typiskhet..nn.1
  typnummer_1_N = mkN "typnummer" neutrum  ; -- typnummer..nn.1
  typograf_1_N = mkN "typograf" "typografer" ; -- typograf..nn.1
  typografi_1_N = mkN "typografi" "typografier" ; -- typografi..nn.1
  typografisk_1_A = mkA "typografisk" ; -- typografisk..av.1
  typologi_1_N = mkN "typologi" "typologier" ; -- typologi..nn.1
  typologisk_1_A = mkA "typologisk" ; -- typologisk..av.1
  typsnitt_1_N = mkN "typsnitt" neutrum  ; -- typsnitt..nn.1
  typvärde_1_N = mkN "typvärde" ; -- typvärde..nn.1
  tyrann_1_N = mkN "tyrann" "tyranner" ; -- tyrann..nn.1
  tyranni_1_N = mkN "tyranni" neutrum  ; -- tyranni..nn.1
  tyrannisera_1_V = mkV "tyranniserar" ; -- tyrannisera..vb.1
  tyranniserande_1_N = mkN "tyranniserande" ; -- tyranniserande..nn.1
  tyranniserbar_1_A = mkA "tyranniserbar" ; -- tyranniserbar..av.1
  tyranniserbarhet_1_N = mkN "tyranniserbarhet" ; -- tyranniserbarhet..nn.1
  tyrannisering_1_N = mkN "tyrannisering" ; -- tyrannisering..nn.1
  tyrannisk_1_A = mkA "tyrannisk" ; -- tyrannisk..av.1
  tyre_1_N = mkN "tyre" ; -- tyre..nn.1
  tyristor_1_N = mkN "tyristor" "tyristorer" ; -- tyristor..nn.1
  tyrolare_1_N = mkN "tyrolare" utrum  ; -- tyrolare..nn.1
  tyrolerhatt_1_N = mkN "tyrolerhatt" ; -- tyrolerhatt..nn.1
  tyrolsk_1_A = mkA "tyrolsk" ; -- tyrolsk..av.1
  tyrolska_1_N = mkN "tyrolska" ; -- tyrolska..nn.1
  tysk_romersk_1_A = mkA "tysk-romersk" ; -- tysk-romersk..av.1
  tysk_schweizisk_1_A = mkA "tysk-schweizisk" ; -- tysk-schweizisk..av.1
  tysk_svensk_1_A = mkA "tysk-svensk" ; -- tysk-svensk..av.1
  tysk_1_A = mkA "tysk" ; -- tysk..av.1
  tysk_1_N = mkN "tysk" ; -- tysk..nn.1
  tyska_1_N = mkN "tyska" ; -- tyska..nn.1
  tyska_2_N = mkN "tyska" ; -- tyska..nn.2
  tyskakurs_1_N = mkN "tyskakurs" "tyskakurser" ; -- tyskakurs..nn.1
  tyskalektion_1_N = mkN "tyskalektion" ; -- tyskalektion..nn.1
  tyskalärare_1_N = mkN "tyskalärare" utrum  ; -- tyskalärare..nn.1
  tyskfödd_1_A = mkA "tyskfödd" ; -- tyskfödd..av.1
  tyskhare_1_N = mkN "tyskhare" "tyskharar" ; -- tyskhare..nn.1
  tyskhat_1_N = mkN "tyskhat" neutrum  ; -- tyskhat..nn.1
  tyskhet_1_N = mkN "tyskhet" ; -- tyskhet..nn.1
  tyskkurs_1_N = mkN "tyskkurs" "tyskkurser" ; -- tyskkurs..nn.1
  tysklektion_1_N = mkN "tysklektion" ; -- tysklektion..nn.1
  tysklärare_1_N = mkN "tysklärare" utrum  ; -- tysklärare..nn.1
  tyskspråkig_1_A = mkA "tyskspråkig" ; -- tyskspråkig..av.1
  tyskspråkighet_1_N = mkN "tyskspråkighet" ; -- tyskspråkighet..nn.1
  tysktalande_1_A = mkA "tysktalande" ; -- tysktalande..av.1
  tyskundervisning_1_N = mkN "tyskundervisning" ; -- tyskundervisning..nn.1
  tyst_1_A = mkA "tyst" "tyst" ; -- tyst..av.1
  tysta_1_V = mkV "tystar" ; -- tysta..vb.1
  tystande_1_N = mkN "tystande" ; -- tystande..nn.1
  tystgående_1_A = mkA "tystgående" ; -- tystgående..av.1
  tysthet_1_N = mkN "tysthet" "tystheter" ; -- tysthet..nn.1
  tysthetslöfte_1_N = mkN "tysthetslöfte" ; -- tysthetslöfte..nn.1
  tystlåten_1_A = mkA "tystlåten" ; -- tystlåten..av.1
  tystlåtenhet_1_N = mkN "tystlåtenhet" ; -- tystlåtenhet..nn.1
  tystna_1_V = mkV "tystnar" ; -- tystna..vb.1
  tystnad_1_N = mkN "tystnad" "tystnader" ; -- tystnad..nn.1
  tystnadsed_1_N = mkN "tystnadsed" ; -- tystnadsed..nn.1
  tystnadsplikt_1_N = mkN "tystnadsplikt" ; -- tystnadsplikt..nn.1
  tystnande_1_N = mkN "tystnande" ; -- tystnande..nn.1
  tyvärr_1_Adv = mkAdv "tyvärr" ; -- tyvärr..ab.1
  täck_1_A = mkA "täck" ; -- täck..av.1
  täcka_1_V = mkV "täcker" ; -- täcka..vb.1
  täckadress_1_N = mkN "täckadress" "täckadresser" ; -- täckadress..nn.1
  täckande_1_N = mkN "täckande" ; -- täckande..nn.1
  täckblad_1_N = mkN "täckblad" neutrum  ; -- täckblad..nn.1
  täckdika_1_V = mkV "täckdikar" ; -- täckdika..vb.1
  täckdikande_1_N = mkN "täckdikande" ; -- täckdikande..nn.1
  täckdike_1_N = mkN "täckdike" ; -- täckdike..nn.1
  täckdikning_1_N = mkN "täckdikning" ; -- täckdikning..nn.1
  täcke_1_N = mkN "täcke" ; -- täcke..nn.1
  täckelig_1_A = mkA "täckelig" ; -- täckelig..av.1
  täckelighet_1_N = mkN "täckelighet" ; -- täckelighet..nn.1
  täckelse_1_N = mkN "täckelse" "täckelset" "täckelser" "täckelserna" ; -- täckelse..nn.1
  täckfärg_1_N = mkN "täckfärg" "täckfärger" ; -- täckfärg..nn.1
  täckförband_1_N = mkN "täckförband" neutrum  ; -- täckförband..nn.1
  täckglas_1_N = mkN "täckglas" neutrum  ; -- täckglas..nn.1
  täckhet_1_N = mkN "täckhet" ; -- täckhet..nn.1
  täckhår_1_N = mkN "täckhår" neutrum  ; -- täckhår..nn.1
  täckjacka_1_N = mkN "täckjacka" ; -- täckjacka..nn.1
  täckmantel_1_N = mkN "täckmantel" ; -- täckmantel..nn.1
  täckmatta_1_N = mkN "täckmatta" ; -- täckmatta..nn.1
  täcknamn_1_N = mkN "täcknamn" neutrum  ; -- täcknamn..nn.1
  täckning_1_N = mkN "täckning" ; -- täckning..nn.1
  täckningsgrad_1_N = mkN "täckningsgrad" "täckningsgrader" ; -- täckningsgrad..nn.1
  täckningsköp_1_N = mkN "täckningsköp" neutrum  ; -- täckningsköp..nn.1
  täckord_1_N = mkN "täckord" neutrum  ; -- täckord..nn.1
  täckorganisation_1_N = mkN "täckorganisation" ; -- täckorganisation..nn.1
  täckt_1_A = mkA "täckt" "täckt" ; -- täckt..av.1
  täckvinge_1_N = mkN "täckvinge" utrum  ; -- täckvinge..nn.1
  täkt_1_N = mkN "täkt" "täkter" ; -- täkt..nn.1
  tälja_1_V = mkV "tälja" "täljde" "täljt" ; -- tälja..vb.1
  tälja_2_V = mkV "tälja" "täljer" "tälj" "talde" "talt" "täljd" ; -- tälja..vb.2
  täljande_1_N = mkN "täljande" ; -- täljande..nn.1
  täljare_1_N = mkN "täljare" utrum  ; -- täljare..nn.1
  täljkniv_1_N = mkN "täljkniv" ; -- täljkniv..nn.1
  täljstenskamin_1_N = mkN "täljstenskamin" "täljstenskaminer" ; -- täljstenskamin..nn.1
  tält_1_N = mkN "tält" neutrum  ; -- tält..nn.1
  tälta_1_V = mkV "tältar" ; -- tälta..vb.1
  tältande_1_N = mkN "tältande" ; -- tältande..nn.1
  tältare_1_N = mkN "tältare" utrum  ; -- tältare..nn.1
  tältduk_1_N = mkN "tältduk" ; -- tältduk..nn.1
  tältmöte_1_N = mkN "tältmöte" ; -- tältmöte..nn.1
  tältpinne_1_N = mkN "tältpinne" utrum  ; -- tältpinne..nn.1
  tältstol_1_N = mkN "tältstol" ; -- tältstol..nn.1
  tältsäng_1_N = mkN "tältsäng" ; -- tältsäng..nn.1
  tälttak_1_N = mkN "tälttak" neutrum  ; -- tälttak..nn.1
  tämja_1_V = mkV "tämja" "tämjer" "tämj" "tämjde" "tämt" "tämjd" ; -- tämja..vb.1
  tämjande_1_N = mkN "tämjande" ; -- tämjande..nn.1
  tämjbar_1_A = mkA "tämjbar" ; -- tämjbar..av.1
  tämjbarhet_1_N = mkN "tämjbarhet" ; -- tämjbarhet..nn.1
  tämjning_1_N = mkN "tämjning" ; -- tämjning..nn.1
  tämlig_1_A = mkA "tämlig" ; -- tämlig..av.1
  tämligen_1_Adv = mkAdv "tämligen" ; -- tämligen..ab.1
  tända_1_V = mkV "tänder" ; -- tända..vb.1
  tändande_1_N = mkN "tändande" ; -- tändande..nn.1
  tändare_1_N = mkN "tändare" utrum  ; -- tändare..nn.1
  tändaruttag_1_N = mkN "tändaruttag" neutrum  ; -- tändaruttag..nn.1
  tändhatt_1_N = mkN "tändhatt" ; -- tändhatt..nn.1
  tändkulemotor_1_N = mkN "tändkulemotor" "tändkulemotorer" ; -- tändkulemotor..nn.1
  tändmedel_1_N = mkN "tändmedel" neutrum  ; -- tändmedel..nn.1
  tändning_1_N = mkN "tändning" ; -- tändning..nn.1
  tändningslås_1_N = mkN "tändningslås" neutrum  ; -- tändningslås..nn.1
  tändningsnyckel_1_N = mkN "tändningsnyckel" ; -- tändningsnyckel..nn.1
  tändpatron_1_N = mkN "tändpatron" "tändpatroner" ; -- tändpatron..nn.1
  tändrör_1_N = mkN "tändrör" neutrum  ; -- tändrör..nn.1
  tändsats_1_N = mkN "tändsats" "tändsatser" ; -- tändsats..nn.1
  tändspole_1_N = mkN "tändspole" utrum  ; -- tändspole..nn.1
  tändsticka_1_N = mkN "tändsticka" ; -- tändsticka..nn.1
  tändsticksask_1_N = mkN "tändsticksask" ; -- tändsticksask..nn.1
  tändsticksfabrik_1_N = mkN "tändsticksfabrik" "tändsticksfabriker" ; -- tändsticksfabrik..nn.1
  tändsticksmönster_1_N = mkN "tändsticksmönster" neutrum  ; -- tändsticksmönster..nn.1
  tändsticksproblem_1_N = mkN "tändsticksproblem" neutrum  ; -- tändsticksproblem..nn.1
  tändstift_1_N = mkN "tändstift" neutrum  ; -- tändstift..nn.1
  tändstiftshylsa_1_N = mkN "tändstiftshylsa" ; -- tändstiftshylsa..nn.1
  tändvätska_1_N = mkN "tändvätska" ; -- tändvätska..nn.1
  tändämne_1_N = mkN "tändämne" ; -- tändämne..nn.1
  tänja_1_V = mkV "tänja" "tänjde" "tänjt" ; -- tänja..vb.1
  tänjande_1_N = mkN "tänjande" ; -- tänjande..nn.1
  tänjbar_1_A = mkA "tänjbar" ; -- tänjbar..av.1
  tänjbarhet_1_N = mkN "tänjbarhet" ; -- tänjbarhet..nn.1
  tänjning_1_N = mkN "tänjning" ; -- tänjning..nn.1
  tänk_1_N = mkN "tänk" neutrum  ; -- tänk..nn.1
  tänka_1_V = mkV "tänker" ; -- tänka..vb.1
  tänkande_1_N = mkN "tänkande" ; -- tänkande..nn.1
  tänkare_1_N = mkN "tänkare" utrum  ; -- tänkare..nn.1
  tänkarpanna_1_N = mkN "tänkarpanna" ; -- tänkarpanna..nn.1
  tänkarpose_1_N = mkN "tänkarpose" "tänkarposer" ; -- tänkarpose..nn.1
  tänkbar_1_A = mkA "tänkbar" ; -- tänkbar..av.1
  tänkbarhet_1_N = mkN "tänkbarhet" "tänkbarheter" ; -- tänkbarhet..nn.1
  tänkebok_1_N = mkN "tänkebok" "tänkeböcker" ; -- tänkebok..nn.1
  tänkespråk_1_N = mkN "tänkespråk" neutrum  ; -- tänkespråk..nn.1
  tänkesätt_1_N = mkN "tänkesätt" neutrum  ; -- tänkesätt..nn.1
  tänkvärd_1_A = mkA "tänkvärd" "tänkvärt" ; -- tänkvärd..av.1
  tänkvärdhet_1_N = mkN "tänkvärdhet" "tänkvärdheter" ; -- tänkvärdhet..nn.1
  tännlika_1_N = mkN "tännlika" ; -- tännlika..nn.1
  täppa_1_N = mkN "täppa" ; -- täppa..nn.1
  täppt_1_A = mkA "täppt" "täppt" ; -- täppt..av.1
  tära_1_V = mkV "tära" "tärde" "tärt" ; -- tära..vb.1
  tärande_1_A = mkA "tärande" ; -- tärande..av.1
  tärande_1_N = mkN "tärande" ; -- tärande..nn.1
  tärd_1_A = mkA "tärd" "tärt" ; -- tärd..av.1
  tärdhet_1_N = mkN "tärdhet" ; -- tärdhet..nn.1
  tärna_1_N = mkN "tärna" ; -- tärna..nn.1
  tärna_1_V = mkV "tärnar" ; -- tärna..vb.1
  tärnande_1_N = mkN "tärnande" ; -- tärnande..nn.1
  tärnbukett_1_N = mkN "tärnbukett" "tärnbuketter" ; -- tärnbukett..nn.1
  tärning_1_N = mkN "tärning" ; -- tärning..nn.1
  tärningsbägare_1_N = mkN "tärningsbägare" utrum  ; -- tärningsbägare..nn.1
  tärningskast_1_N = mkN "tärningskast" neutrum  ; -- tärningskast..nn.1
  tärningsspel_1_N = mkN "tärningsspel" "tärningsspelet" "tärningsspel" "tärningsspelen" ; -- tärningsspel..nn.1
  tärningsspelare_1_N = mkN "tärningsspelare" utrum  ; -- tärningsspelare..nn.1
  tät_1_A = mkA "tät" ; -- tät..av.1
  tät_1_N = mkN "tät" "täter" ; -- tät..nn.1
  täta_1_V = mkV "tätar" ; -- täta..vb.1
  tätande_1_N = mkN "tätande" ; -- tätande..nn.1
  tätatät_1_N = mkN "tätatät" "tätatäter" ; -- tätatät..nn.1
  tätbebyggd_1_A = mkA "tätbebyggd" "tätbebyggt" ; -- tätbebyggd..av.1
  tätbebyggdhet_1_N = mkN "tätbebyggdhet" ; -- tätbebyggdhet..nn.1
  tätbefolkad_1_A = mkA "tätbefolkad" ; -- tätbefolkad..av.1
  täte_1_N = mkN "täte" utrum  ; -- täte..nn.1
  täthet_1_N = mkN "täthet" ; -- täthet..nn.1
  täthetstopp_1_N = mkN "täthetstopp" ; -- täthetstopp..nn.1
  täthetsvariation_1_N = mkN "täthetsvariation" ; -- täthetsvariation..nn.1
  tätmjölk_1_N = mkN "tätmjölk" ; -- tätmjölk..nn.1
  tätna_1_V = mkV "tätnar" ; -- tätna..vb.1
  tätnande_1_N = mkN "tätnande" ; -- tätnande..nn.1
  tätning_1_N = mkN "tätning" ; -- tätning..nn.1
  tätningslist_1_N = mkN "tätningslist" "tätningslister" ; -- tätningslist..nn.1
  tätningsmassa_1_N = mkN "tätningsmassa" ; -- tätningsmassa..nn.1
  tätort_1_N = mkN "tätort" "tätorter" ; -- tätort..nn.1
  tätortsbo_1_N = mkN "tätortsbo" "tätortsbor" ; -- tätortsbo..nn.1
  tätortsnära_1_A = mkA "tätortsnära" ; -- tätortsnära..av.1
  tätortstrafik_1_N = mkN "tätortstrafik" ; -- tätortstrafik..nn.1
  tätplacerad_1_A = mkA "tätplacerad" ; -- tätplacerad..av.1
  tätplacering_1_N = mkN "tätplacering" ; -- tätplacering..nn.1
  tätplats_1_N = mkN "tätplats" "tätplatser" ; -- tätplats..nn.1
  tätposition_1_N = mkN "tätposition" ; -- tätposition..nn.1
  tätslutande_1_A = mkA "tätslutande" ; -- tätslutande..av.1
  tätt_1_Adv = mkAdv "tätt" ; -- tätt..ab.1
  tättbebyggd_1_A = mkA "tättbebyggd" "tättbebyggt" ; -- tättbebyggd..av.1
  tättbebyggdhet_1_N = mkN "tättbebyggdhet" ; -- tättbebyggdhet..nn.1
  tättbefolkad_1_A = mkA "tättbefolkad" ; -- tättbefolkad..av.1
  tätting_1_N = mkN "tätting" ; -- tätting..nn.1
  tättingfågel_1_N = mkN "tättingfågel" ; -- tättingfågel..nn.1
  tättklippt_1_A = mkA "tättklippt" "tättklippt" ; -- tättklippt..av.1
  tättklippthet_1_N = mkN "tättklippthet" ; -- tättklippthet..nn.1
  tättsittande_1_A = mkA "tättsittande" ; -- tättsittande..av.1
  tättskriven_1_A = mkA "tättskriven" ; -- tättskriven..av.1
  tättslutande_1_A = mkA "tättslutande" ; -- tättslutande..av.1
  tätört_1_N = mkN "tätört" ; -- tätört..nn.1
  tävla_1_V = mkV "tävlar" ; -- tävla..vb.1
  tävlande_1_N = mkN "tävlande" ; -- tävlande..nn.1
  tävling_1_N = mkN "tävling" ; -- tävling..nn.1
  tävlingsansvarig_1_A = mkA "tävlingsansvarig" ; -- tävlingsansvarig..av.1
  tävlingsbana_1_N = mkN "tävlingsbana" ; -- tävlingsbana..nn.1
  tävlingsbil_1_N = mkN "tävlingsbil" ; -- tävlingsbil..nn.1
  tävlingscyklist_1_N = mkN "tävlingscyklist" "tävlingscyklister" ; -- tävlingscyklist..nn.1
  tävlingshumör_1_N = mkN "tävlingshumör" neutrum  ; -- tävlingshumör..nn.1
  tävlingsinriktad_1_A = mkA "tävlingsinriktad" ; -- tävlingsinriktad..av.1
  tävlingsinstinkt_1_N = mkN "tävlingsinstinkt" "tävlingsinstinkter" ; -- tävlingsinstinkt..nn.1
  tävlingsjury_1_N = mkN "tävlingsjury" "tävlingsjuryer" ; -- tävlingsjury..nn.1
  tävlingskamp_1_N = mkN "tävlingskamp" "tävlingskamper" ; -- tävlingskamp..nn.1
  tävlingsklass_1_N = mkN "tävlingsklass" "tävlingsklasser" ; -- tävlingsklass..nn.1
  tävlingsledare_1_N = mkN "tävlingsledare" utrum  ; -- tävlingsledare..nn.1
  tävlingsledning_1_N = mkN "tävlingsledning" ; -- tävlingsledning..nn.1
  tävlingslek_1_N = mkN "tävlingslek" ; -- tävlingslek..nn.1
  tävlingsmänniska_1_N = mkN "tävlingsmänniska" ; -- tävlingsmänniska..nn.1
  tävlingsmässig_1_A = mkA "tävlingsmässig" ; -- tävlingsmässig..av.1
  tävlingspris_1_N = mkN "tävlingspris" neutrum  ; -- tävlingspris..nn.1
  tävlingssegla_1_V = mkV "tävlingsseglar" ; -- tävlingssegla..vb.1
  tävlingsseglande_1_N = mkN "tävlingsseglande" ; -- tävlingsseglande..nn.1
  tävlingssegling_1_N = mkN "tävlingssegling" ; -- tävlingssegling..nn.1
  tävlingsskjuta_1_V = mkV "tävlingsskjuta" "tävlingssköt" "tävlingsskjutit" ; -- tävlingsskjuta..vb.1
  tävlingsskjutande_1_N = mkN "tävlingsskjutande" ; -- tävlingsskjutande..nn.1
  tävlingsskjutning_1_N = mkN "tävlingsskjutning" ; -- tävlingsskjutning..nn.1
  tävlingsskytte_1_N = mkN "tävlingsskytte" ; -- tävlingsskytte..nn.1
  tå_1_N = mkN "tå" "tån" "tår" "tårna" ; -- tå..nn.1
  tåa_1_V = mkV "tåar" ; -- tåa..vb.1
  tåande_1_N = mkN "tåande" ; -- tåande..nn.1
  tåfjutt_1_N = mkN "tåfjutt" ; -- tåfjutt..nn.1
  tåfjuttare_1_N = mkN "tåfjuttare" utrum  ; -- tåfjuttare..nn.1
  tåg_1_N = mkN "tåg" neutrum  ; -- tåg..nn.1
  tåga_1_N = mkN "tåga" ; -- tåga..nn.1
  tåga_1_V = mkV "tågar" ; -- tåga..vb.1
  tågande_1_N = mkN "tågande" ; -- tågande..nn.1
  tågankomst_1_N = mkN "tågankomst" "tågankomster" ; -- tågankomst..nn.1
  tågavgång_1_N = mkN "tågavgång" ; -- tågavgång..nn.1
  tågbana_1_N = mkN "tågbana" ; -- tågbana..nn.1
  tågbiljett_1_N = mkN "tågbiljett" "tågbiljetter" ; -- tågbiljett..nn.1
  tågbolag_1_N = mkN "tågbolag" neutrum  ; -- tågbolag..nn.1
  tågklarerare_1_N = mkN "tågklarerare" utrum  ; -- tågklarerare..nn.1
  tågkrasch_1_N = mkN "tågkrasch" "tågkrascher" ; -- tågkrasch..nn.1
  tågkrock_1_N = mkN "tågkrock" ; -- tågkrock..nn.1
  tågkupé_1_N = mkN "tågkupé" "tågkupéer" ; -- tågkupé..nn.1
  tåglinje_1_N = mkN "tåglinje" "tåglinjer" ; -- tåglinje..nn.1
  tågluffa_1_V = mkV "tågluffar" ; -- tågluffa..vb.1
  tågluffande_1_N = mkN "tågluffande" ; -- tågluffande..nn.1
  tåglägenhet_1_N = mkN "tåglägenhet" "tåglägenheter" ; -- tåglägenhet..nn.1
  tågordning_1_N = mkN "tågordning" ; -- tågordning..nn.1
  tågpassagerare_1_N = mkN "tågpassagerare" utrum  ; -- tågpassagerare..nn.1
  tågpendla_1_V = mkV "tågpendlar" ; -- tågpendla..vb.1
  tågresa_1_N = mkN "tågresa" ; -- tågresa..nn.1
  tågrån_1_N = mkN "tågrån" neutrum  ; -- tågrån..nn.1
  tågrånare_1_N = mkN "tågrånare" utrum  ; -- tågrånare..nn.1
  tågstation_1_N = mkN "tågstation" ; -- tågstation..nn.1
  tågstopp_1_N = mkN "tågstopp" neutrum  ; -- tågstopp..nn.1
  tågsträcka_1_N = mkN "tågsträcka" ; -- tågsträcka..nn.1
  tågsätt_1_N = mkN "tågsätt" neutrum  ; -- tågsätt..nn.1
  tågtid_1_N = mkN "tågtid" "tågtider" ; -- tågtid..nn.1
  tågtidtabell_1_N = mkN "tågtidtabell" "tågtidtabeller" ; -- tågtidtabell..nn.1
  tågtrafik_1_N = mkN "tågtrafik" ; -- tågtrafik..nn.1
  tågtransport_1_N = mkN "tågtransport" "tågtransporter" ; -- tågtransport..nn.1
  tågtur_1_N = mkN "tågtur" "tågturer" ; -- tågtur..nn.1
  tågurspårning_1_N = mkN "tågurspårning" ; -- tågurspårning..nn.1
  tågvirke_1_N = mkN "tågvirke" ; -- tågvirke..nn.1
  tågvärd_1_N = mkN "tågvärd" ; -- tågvärd..nn.1
  tågvärdinna_1_N = mkN "tågvärdinna" ; -- tågvärdinna..nn.1
  tågända_1_N = mkN "tågända" ; -- tågända..nn.1
  tågände_1_N = mkN "tågände" utrum  ; -- tågände..nn.1
  tågångare_1_N = mkN "tågångare" utrum  ; -- tågångare..nn.1
  tåhätta_1_N = mkN "tåhätta" ; -- tåhätta..nn.1
  tåhävning_1_N = mkN "tåhävning" ; -- tåhävning..nn.1
  tåjärn_1_N = mkN "tåjärn" neutrum  ; -- tåjärn..nn.1
  tåla_1_V = mkV "tåla" "tål" "tål" "tålde" "tålt" "tåld" ; -- tåla..vb.1
  tålamod_1_N = mkN "tålamod" neutrum  ; -- tålamod..nn.1
  tålamodskrävande_1_A = mkA "tålamodskrävande" ; -- tålamodskrävande..av.1
  tålamodsprövande_1_A = mkA "tålamodsprövande" ; -- tålamodsprövande..av.1
  tålande_1_N = mkN "tålande" ; -- tålande..nn.1
  tålig_1_A = mkA "tålig" ; -- tålig..av.1
  tålighet_1_N = mkN "tålighet" ; -- tålighet..nn.1
  tålmodig_1_A = mkA "tålmodig" ; -- tålmodig..av.1
  tålmodighet_1_N = mkN "tålmodighet" ; -- tålmodighet..nn.1
  tånagel_1_N = mkN "tånagel" ; -- tånagel..nn.1
  tång_1_N = mkN "tång" "tänger" ; -- tång..nn.1
  tång_2_N = mkN "tång" ; -- tång..nn.2
  tånga_1_V = mkV "tångar" ; -- tånga..vb.1
  tångande_1_N = mkN "tångande" ; -- tångande..nn.1
  tångbad_1_N = mkN "tångbad" neutrum  ; -- tångbad..nn.1
  tånge_1_N = mkN "tånge" utrum  ; -- tånge..nn.1
  tånglake_1_N = mkN "tånglake" utrum  ; -- tånglake..nn.1
  tångning_1_N = mkN "tångning" ; -- tångning..nn.1
  tångräka_1_N = mkN "tångräka" ; -- tångräka..nn.1
  tår_1_N = mkN "tår" ; -- tår..nn.1
  tårad_1_A = mkA "tårad" ; -- tårad..av.1
  tårben_1_N = mkN "tårben" neutrum  ; -- tårben..nn.1
  tårdrypande_1_A = mkA "tårdrypande" ; -- tårdrypande..av.1
  tårdränkt_1_A = mkA "tårdränkt" "tårdränkt" ; -- tårdränkt..av.1
  tårdränkthet_1_N = mkN "tårdränkthet" ; -- tårdränkthet..nn.1
  tåredal_1_N = mkN "tåredal" ; -- tåredal..nn.1
  tåreflöde_1_N = mkN "tåreflöde" ; -- tåreflöde..nn.1
  tårfull_1_A = mkA "tårfull" ; -- tårfull..av.1
  tårgas_1_N = mkN "tårgas" ; -- tårgas..nn.1
  tårgasdimma_1_N = mkN "tårgasdimma" ; -- tårgasdimma..nn.1
  tårgaspatron_1_N = mkN "tårgaspatron" "tårgaspatroner" ; -- tårgaspatron..nn.1
  tårkanal_1_N = mkN "tårkanal" "tårkanaler" ; -- tårkanal..nn.1
  tårkörtel_1_N = mkN "tårkörtel" ; -- tårkörtel..nn.1
  tårlös_1_A = mkA "tårlös" ; -- tårlös..av.1
  tårpil_1_N = mkN "tårpil" ; -- tårpil..nn.1
  tårsäck_1_N = mkN "tårsäck" ; -- tårsäck..nn.1
  tårta_1_N = mkN "tårta" ; -- tårta..nn.1
  tårta_1_V = mkV "tårtar" ; -- tårta..vb.1
  tårtande_1_N = mkN "tårtande" ; -- tårtande..nn.1
  tårtbotten_1_N = mkN "tårtbotten" ; -- tårtbotten..nn.1
  tårtkalas_1_N = mkN "tårtkalas" neutrum  ; -- tårtkalas..nn.1
  tårtkastning_1_N = mkN "tårtkastning" ; -- tårtkastning..nn.1
  tårtning_1_N = mkN "tårtning" ; -- tårtning..nn.1
  tårtologi_1_N = mkN "tårtologi" "tårtologier" ; -- tårtologi..nn.1
  tårtspade_1_N = mkN "tårtspade" utrum  ; -- tårtspade..nn.1
  tårtspadeprincip_1_N = mkN "tårtspadeprincip" ; -- tårtspadeprincip..nn.1
  tårögd_1_A = mkA "tårögd" "tårögt" ; -- tårögd..av.1
  tårögdhet_1_N = mkN "tårögdhet" ; -- tårögdhet..nn.1
  tåspets_1_N = mkN "tåspets" ; -- tåspets..nn.1
  tåspetsdans_1_N = mkN "tåspetsdans" ; -- tåspetsdans..nn.1
  tåt_1_N = mkN "tåt" ; -- tåt..nn.1
  tête_à_tête_1_N = mkN "tête-à-tête" "tête-à-têter" ; -- tête-à-tête..nn.1
  tö_1_N = mkN "tö" ; -- tö..nn.1
  töa_1_V = mkV "töar" ; -- töa..vb.1
  töande_1_N = mkN "töande" ; -- töande..nn.1
  töcken_1_N = mkN "töcken" "töcknet" "töcken" "töcknen" ; -- töcken..nn.1
  töckenhöljd_1_A = mkA "töckenhöljd" "töckenhöljt" ; -- töckenhöljd..av.1
  töcknig_1_A = mkA "töcknig" ; -- töcknig..av.1
  töcknighet_1_N = mkN "töcknighet" ; -- töcknighet..nn.1
  töig_1_A = mkA "töig" ; -- töig..av.1
  töja_1_V = mkV "töja" "töjde" "töjt" ; -- töja..vb.1
  töjande_1_N = mkN "töjande" ; -- töjande..nn.1
  töjbar_1_A = mkA "töjbar" ; -- töjbar..av.1
  töjbarhet_1_N = mkN "töjbarhet" "töjbarheter" ; -- töjbarhet..nn.1
  töjning_1_N = mkN "töjning" ; -- töjning..nn.1
  töjningsmätare_1_N = mkN "töjningsmätare" utrum  ; -- töjningsmätare..nn.1
  tölp_1_N = mkN "tölp" ; -- tölp..nn.1
  tölpaktig_1_A = mkA "tölpaktig" ; -- tölpaktig..av.1
  tölpaktighet_1_N = mkN "tölpaktighet" ; -- tölpaktighet..nn.1
  tölpig_1_A = mkA "tölpig" ; -- tölpig..av.1
  tölpighet_1_N = mkN "tölpighet" ; -- tölpighet..nn.1
  tölt_1_N = mkN "tölt" ; -- tölt..nn.1
  tölta_1_V = mkV "töltar" ; -- tölta..vb.1
  töltande_1_N = mkN "töltande" ; -- töltande..nn.1
  töm_1_N = mkN "töm" "tömmen" "tömmar" "tömmarna" ; -- töm..nn.1
  tömma_1_V = mkV "tömmer" ; -- tömma..vb.1
  tömmande_1_N = mkN "tömmande" ; -- tömmande..nn.1
  tömning_1_N = mkN "tömning" ; -- tömning..nn.1
  tömningshål_1_N = mkN "tömningshål" neutrum  ; -- tömningshål..nn.1
  tömring_1_N = mkN "tömring" ; -- tömring..nn.1
  tönt_1_N = mkN "tönt" ; -- tönt..nn.1
  tönta_1_V = mkV "töntar" ; -- tönta..vb.1
  töntande_1_N = mkN "töntande" ; -- töntande..nn.1
  töntig_1_A = mkA "töntig" ; -- töntig..av.1
  töntighet_1_N = mkN "töntighet" "töntigheter" ; -- töntighet..nn.1
  töre_1_N = mkN "töre" ; -- töre..nn.1
  törel_1_N = mkN "törel" ; -- törel..nn.1
  törn_1_N = mkN "törn" ; -- törn..nn.1
  törna_1_V = mkV "törnar" ; -- törna..vb.1
  törnande_1_N = mkN "törnande" ; -- törnande..nn.1
  törnbeströdd_1_A = mkA "törnbeströdd" ; -- törnbeströdd..av.1
  törnbuske_1_N = mkN "törnbuske" utrum  ; -- törnbuske..nn.1
  törne_1_N = mkN "törne" ; -- törne..nn.1
  törnekrans_1_N = mkN "törnekrans" ; -- törnekrans..nn.1
  törnekrona_1_N = mkN "törnekrona" ; -- törnekrona..nn.1
  törnekrönt_1_A = mkA "törnekrönt" "törnekrönt" ; -- törnekrönt..av.1
  törnestig_1_N = mkN "törnestig" ; -- törnestig..nn.1
  törnig_1_A = mkA "törnig" ; -- törnig..av.1
  törnighet_1_N = mkN "törnighet" ; -- törnighet..nn.1
  törnros_1_N = mkN "törnros" "törnrosor" ; -- törnros..nn.1
  törnrosasnår_1_N = mkN "törnrosasnår" neutrum  ; -- törnrosasnår..nn.1
  törnrosasömn_1_N = mkN "törnrosasömn" ; -- törnrosasömn..nn.1
  törnskata_1_N = mkN "törnskata" ; -- törnskata..nn.1
  törnsångare_1_N = mkN "törnsångare" utrum  ; -- törnsångare..nn.1
  törntagg_1_N = mkN "törntagg" ; -- törntagg..nn.1
  törst_1_N = mkN "törst" ; -- törst..nn.1
  törsta_1_V = mkV "törstar" ; -- törsta..vb.1
  törstande_1_N = mkN "törstande" ; -- törstande..nn.1
  törstig_1_A = mkA "törstig" ; -- törstig..av.1
  törstighet_1_N = mkN "törstighet" ; -- törstighet..nn.1
  törstsläckande_1_A = mkA "törstsläckande" ; -- törstsläckande..av.1
  tös_1_N = mkN "tös" "töser" ; -- tös..nn.1
  töva_1_V = mkV "tövar" ; -- töva..vb.1
  tövande_1_N = mkN "tövande" ; -- tövande..nn.1
  töväder_1_N = mkN "töväder" neutrum  ; -- töväder..nn.1
  u_båt_1_N = mkN "u-båt" ; -- u-båt..nn.1
  u_formad_1_A = mkA "u-formad" ; -- u-formad..av.1
  u_formig_1_A = mkA "u-formig" ; -- u-formig..av.1
  u_hjälp_1_N = mkN "u-hjälp" ; -- u-hjälp..nn.1
  u_land_1_N = mkN "u-land" "u-landet" "u-länder" "u-länderna" ; -- u-land..nn.1
  u_sväng_1_N = mkN "u-sväng" ; -- u-sväng..nn.1
  ubikvist_1_N = mkN "ubikvist" "ubikvister" ; -- ubikvist..nn.1
  ubikvitet_1_N = mkN "ubikvitet" "ubikviteter" ; -- ubikvitet..nn.1
  ubåt_1_N = mkN "ubåt" ; -- ubåt..nn.1
  ubåtsfälla_1_N = mkN "ubåtsfälla" ; -- ubåtsfälla..nn.1
  ubåtsförstörare_1_N = mkN "ubåtsförstörare" utrum  ; -- ubåtsförstörare..nn.1
  ubåtsjagare_1_N = mkN "ubåtsjagare" utrum  ; -- ubåtsjagare..nn.1
  ubåtsjakt_1_N = mkN "ubåtsjakt" "ubåtsjakter" ; -- ubåtsjakt..nn.1
  ubåtsjaktfartyg_1_N = mkN "ubåtsjaktfartyg" neutrum  ; -- ubåtsjaktfartyg..nn.1
  ubåtsklocka_1_N = mkN "ubåtsklocka" ; -- ubåtsklocka..nn.1
  ubåtsnät_1_N = mkN "ubåtsnät" neutrum  ; -- ubåtsnät..nn.1
  udd_1_N = mkN "udd" ; -- udd..nn.1
  udda_1_A = mkA "udda" ; -- udda..av.1
  uddabyxa_1_N = mkN "uddabyxa" ; -- uddabyxa..nn.1
  uddamål_1_N = mkN "uddamål" neutrum  ; -- uddamål..nn.1
  uddanummer_1_N = mkN "uddanummer" neutrum  ; -- uddanummer..nn.1
  uddaplagg_1_N = mkN "uddaplagg" neutrum  ; -- uddaplagg..nn.1
  uddatalsmetod_1_N = mkN "uddatalsmetod" "uddatalsmetoder" ; -- uddatalsmetod..nn.1
  uddatåig_1_A = mkA "uddatåig" ; -- uddatåig..av.1
  uddblad_1_N = mkN "uddblad" neutrum  ; -- uddblad..nn.1
  udde_1_N = mkN "udde" utrum  ; -- udde..nn.1
  uddig_1_A = mkA "uddig" ; -- uddig..av.1
  uddighet_1_N = mkN "uddighet" ; -- uddighet..nn.1
  uddjärn_1_N = mkN "uddjärn" neutrum  ; -- uddjärn..nn.1
  uddljud_1_N = mkN "uddljud" neutrum  ; -- uddljud..nn.1
  uddlös_1_A = mkA "uddlös" ; -- uddlös..av.1
  uddlöshet_1_N = mkN "uddlöshet" ; -- uddlöshet..nn.1
  uddrim_1_N = mkN "uddrim" "uddrimmet" "uddrim" "uddrimmen" ; -- uddrim..nn.1
  ufo_1_N = mkN "ufo" "ufot" "ufon" "ufona" ; -- ufo..nn.1
  ufohackare_1_N = mkN "ufohackare" utrum  ; -- ufohackare..nn.1
  ugandier_1_N = mkN "ugandier" "ugandiern" "ugandier" "ugandierna" ; -- ugandier..nn.1
  ugandisk_1_A = mkA "ugandisk" ; -- ugandisk..av.1
  ugandiska_1_N = mkN "ugandiska" ; -- ugandiska..nn.1
  uggla_1_N = mkN "uggla" ; -- uggla..nn.1
  uggla_1_V = mkV "ugglar" ; -- uggla..vb.1
  ugglande_1_N = mkN "ugglande" ; -- ugglande..nn.1
  uggleboll_1_N = mkN "uggleboll" ; -- uggleboll..nn.1
  uggleklo_1_N = mkN "uggleklo" "uggleklor" ; -- uggleklo..nn.1
  uggleliknande_1_A = mkA "uggleliknande" ; -- uggleliknande..av.1
  uggleved_1_N = mkN "uggleved" ; -- uggleved..nn.1
  ugn_1_N = mkN "ugn" ; -- ugn..nn.1
  ugnsbaka_1_V = mkV "ugnsbakar" ; -- ugnsbaka..vb.1
  ugnsbakande_1_N = mkN "ugnsbakande" ; -- ugnsbakande..nn.1
  ugnseldfast_1_A = mkA "ugnseldfast" "ugnseldfast" ; -- ugnseldfast..av.1
  ugnseldfasthet_1_N = mkN "ugnseldfasthet" ; -- ugnseldfasthet..nn.1
  ugnsfast_1_A = mkA "ugnsfast" "ugnsfast" ; -- ugnsfast..av.1
  ugnsfisk_1_N = mkN "ugnsfisk" ; -- ugnsfisk..nn.1
  ugnsgrädda_1_V = mkV "ugnsgräddar" ; -- ugnsgrädda..vb.1
  ugnsgräddande_1_N = mkN "ugnsgräddande" ; -- ugnsgräddande..nn.1
  ugnshäll_1_N = mkN "ugnshäll" ; -- ugnshäll..nn.1
  ugnsinfodring_1_N = mkN "ugnsinfodring" ; -- ugnsinfodring..nn.1
  ugnskappa_1_N = mkN "ugnskappa" ; -- ugnskappa..nn.1
  ugnskoka_1_V = mkV "ugnskoker" ; -- ugnskoka..vb.1
  ugnskokande_1_N = mkN "ugnskokande" ; -- ugnskokande..nn.1
  ugnskol_1_N = mkN "ugnskol" neutrum  ; -- ugnskol..nn.1
  ugnskolning_1_N = mkN "ugnskolning" ; -- ugnskolning..nn.1
  ugnskåpa_1_N = mkN "ugnskåpa" ; -- ugnskåpa..nn.1
  ugnslagad_1_A = mkA "ugnslagad" ; -- ugnslagad..av.1
  ugnslucka_1_N = mkN "ugnslucka" ; -- ugnslucka..nn.1
  ugnsomelett_1_N = mkN "ugnsomelett" "ugnsomeletter" ; -- ugnsomelett..nn.1
  ugnspannkaka_1_N = mkN "ugnspannkaka" ; -- ugnspannkaka..nn.1
  ugnsplåt_1_N = mkN "ugnsplåt" ; -- ugnsplåt..nn.1
  ugnsrostad_1_A = mkA "ugnsrostad" ; -- ugnsrostad..av.1
  ugnsspade_1_N = mkN "ugnsspade" utrum  ; -- ugnsspade..nn.1
  ugnssteka_1_V = mkV "ugnssteker" ; -- ugnssteka..vb.1
  ugnsstekande_1_N = mkN "ugnsstekande" ; -- ugnsstekande..nn.1
  ugnssvärta_1_N = mkN "ugnssvärta" ; -- ugnssvärta..nn.1
  ugnssäker_1_A = mkA "ugnssäker" ; -- ugnssäker..av.1
  ugnstegel_1_N = mkN "ugnstegel" neutrum  ; -- ugnstegel..nn.1
  ugnstillagad_1_A = mkA "ugnstillagad" ; -- ugnstillagad..av.1
  ugnstjära_1_N = mkN "ugnstjära" ; -- ugnstjära..nn.1
  ugnstorka_1_V = mkV "ugnstorkar" ; -- ugnstorka..vb.1
  ugnstorkande_1_N = mkN "ugnstorkande" ; -- ugnstorkande..nn.1
  ugnsvarm_1_A = mkA "ugnsvarm" ; -- ugnsvarm..av.1
  ugnsvärme_1_N = mkN "ugnsvärme" utrum  ; -- ugnsvärme..nn.1
  ukas_1_N = mkN "ukas" "ukaser" ; -- ukas..nn.1
  ukrainare_1_N = mkN "ukrainare" utrum  ; -- ukrainare..nn.1
  ukrainsk_1_A = mkA "ukrainsk" ; -- ukrainsk..av.1
  ukrainska_1_N = mkN "ukrainska" ; -- ukrainska..nn.1
  ukrainska_2_N = mkN "ukrainska" ; -- ukrainska..nn.2
  ukulele_1_N = mkN "ukulele" "ukuleler" ; -- ukulele..nn.1
  ulan_1_N = mkN "ulan" "ulaner" ; -- ulan..nn.1
  ulcerös_1_A = mkA "ulcerös" ; -- ulcerös..av.1
  ulk_1_N = mkN "ulk" ; -- ulk..nn.1
  ulka_1_V = mkV "ulkar" ; -- ulka..vb.1
  ulkande_1_N = mkN "ulkande" ; -- ulkande..nn.1
  ull_1_N = mkN "ull" ; -- ull..nn.1
  ullapa_1_N = mkN "ullapa" ; -- ullapa..nn.1
  ullbeklädnad_1_N = mkN "ullbeklädnad" "ullbeklädnader" ; -- ullbeklädnad..nn.1
  ullfett_1_N = mkN "ullfett" neutrum  ; -- ullfett..nn.1
  ullgarn_1_N = mkN "ullgarn" neutrum  ; -- ullgarn..nn.1
  ullhandskrabba_1_N = mkN "ullhandskrabba" ; -- ullhandskrabba..nn.1
  ullhår_1_N = mkN "ullhår" neutrum  ; -- ullhår..nn.1
  ullhårig_1_A = mkA "ullhårig" ; -- ullhårig..av.1
  ullhårighet_1_N = mkN "ullhårighet" ; -- ullhårighet..nn.1
  ullig_1_A = mkA "ullig" ; -- ullig..av.1
  ullighet_1_N = mkN "ullighet" ; -- ullighet..nn.1
  ulliknande_1_A = mkA "ulliknande" ; -- ulliknande..av.1
  ullolja_1_N = mkN "ullolja" ; -- ullolja..nn.1
  ullsax_1_N = mkN "ullsax" ; -- ullsax..nn.1
  ullsida_1_N = mkN "ullsida" ; -- ullsida..nn.1
  ullstrumpa_1_N = mkN "ullstrumpa" ; -- ullstrumpa..nn.1
  ullsvett_1_N = mkN "ullsvett" ; -- ullsvett..nn.1
  ulltork_1_N = mkN "ulltork" ; -- ulltork..nn.1
  ulltott_1_N = mkN "ulltott" ; -- ulltott..nn.1
  ulltäcke_1_N = mkN "ulltäcke" ; -- ulltäcke..nn.1
  ullus_1_N = mkN "ullus" "ullusen" "ullöss" "ullössen" ; -- ullus..nn.1
  ullört_1_N = mkN "ullört" "ullörter" ; -- ullört..nn.1
  ulma_1_V = mkV "ulmar" ; -- ulma..vb.1
  ulmande_1_N = mkN "ulmande" ; -- ulmande..nn.1
  ulster_1_N = mkN "ulster" ; -- ulster..nn.1
  ultima_1_N = mkN "ultima" ; -- ultima..nn.1
  ultimabetoning_1_N = mkN "ultimabetoning" ; -- ultimabetoning..nn.1
  ultimat_1_A = mkA "ultimat" "ultimat" ; -- ultimat..av.1
  ultimativ_1_A = mkA "ultimativ" ; -- ultimativ..av.1
  ultimatum_1_N = mkN "ultimatum" neutrum  ; -- ultimatum..nn.1
  ultimoaffär_1_N = mkN "ultimoaffär" "ultimoaffärer" ; -- ultimoaffär..nn.1
  ultra_1_N = mkN "ultra" "ultran" "ultras" "ultrasarna" ; -- ultra..nn.1
  ultracentrifug_1_N = mkN "ultracentrifug" "ultracentrifuger" ; -- ultracentrifug..nn.1
  ultrahöger_1_N = mkN "ultrahöger" ; -- ultrahöger..nn.1
  ultrakonservativ_1_A = mkA "ultrakonservativ" ; -- ultrakonservativ..av.1
  ultrakortvåg_1_N = mkN "ultrakortvåg" "ultrakortvågor" ; -- ultrakortvåg..nn.1
  ultraliberal_1_A = mkA "ultraliberal" ; -- ultraliberal..av.1
  ultraliberal_1_N = mkN "ultraliberal" "ultraliberaler" ; -- ultraliberal..nn.1
  ultraljud_1_N = mkN "ultraljud" neutrum  ; -- ultraljud..nn.1
  ultraljudsbild_1_N = mkN "ultraljudsbild" "ultraljudsbilder" ; -- ultraljudsbild..nn.1
  ultralätt_1_A = mkA "ultralätt" ; -- ultralätt..av.1
  ultramarin_1_A = mkA "ultramarin" ; -- ultramarin..av.1
  ultramontan_1_A = mkA "ultramontan" ; -- ultramontan..av.1
  ultramontanism_1_N = mkN "ultramontanism" "ultramontanismer" ; -- ultramontanism..nn.1
  ultranationalist_1_N = mkN "ultranationalist" "ultranationalister" ; -- ultranationalist..nn.1
  ultranationalistisk_1_A = mkA "ultranationalistisk" ; -- ultranationalistisk..av.1
  ultraortodox_1_A = mkA "ultraortodox" ; -- ultraortodox..av.1
  ultrarapid_1_A = mkA "ultrarapid" ; -- ultrarapid..av.1
  ultrarapidfilm_1_N = mkN "ultrarapidfilm" "ultrarapidfilmer" ; -- ultrarapidfilm..nn.1
  ultrarapidfotografera_1_V = mkV "ultrarapidfotograferar" ; -- ultrarapidfotografera..vb.1
  ultrarapidfotograferande_1_N = mkN "ultrarapidfotograferande" ; -- ultrarapidfotograferande..nn.1
  ultrarapidfotograferbar_1_A = mkA "ultrarapidfotograferbar" ; -- ultrarapidfotograferbar..av.1
  ultrarapidfotograferbarhet_1_N = mkN "ultrarapidfotograferbarhet" ; -- ultrarapidfotograferbarhet..nn.1
  ultrarapidfotografering_1_N = mkN "ultrarapidfotografering" ; -- ultrarapidfotografering..nn.1
  ultraröd_1_A = mkA "ultraröd" "ultrarött" ; -- ultraröd..av.1
  ultrasnabb_1_A = mkA "ultrasnabb" ; -- ultrasnabb..av.1
  ultrasnabbhet_1_N = mkN "ultrasnabbhet" ; -- ultrasnabbhet..nn.1
  ultrasofistikerad_1_A = mkA "ultrasofistikerad" ; -- ultrasofistikerad..av.1
  ultraviolett_1_A = mkA "ultraviolett" ; -- ultraviolett..av.1
  ulv_1_N = mkN "ulv" ; -- ulv..nn.1
  umbellat_1_N = mkN "umbellat" "umbellater" ; -- umbellat..nn.1
  umbra_1_N = mkN "umbra" ; -- umbra..nn.1
  umbära_1_V = mkV "umbära" "umbar" "umburit" ; -- umbära..vb.1
  umbärande_1_N = mkN "umbärande" ; -- umbärande..nn.1
  umbärlig_1_A = mkA "umbärlig" ; -- umbärlig..av.1
  umbärlighet_1_N = mkN "umbärlighet" "umbärligheter" ; -- umbärlighet..nn.1
  umeåbo_1_N = mkN "umeåbo" "umeåbor" ; -- umeåbo..nn.1
  umgälla_1_V = mkV "umgäller" ; -- umgälla..vb.1
  umgällande_1_N = mkN "umgällande" ; -- umgällande..nn.1
  umgänge_1_N = mkN "umgänge" ; -- umgänge..nn.1
  umgängelse_1_N = mkN "umgängelse" "umgängelser" ; -- umgängelse..nn.1
  umgängesform_1_N = mkN "umgängesform" "umgängesformer" ; -- umgängesform..nn.1
  umgängeskonst_1_N = mkN "umgängeskonst" ; -- umgängeskonst..nn.1
  umgängeskrets_1_N = mkN "umgängeskrets" ; -- umgängeskrets..nn.1
  umgängesliv_1_N = mkN "umgängesliv" neutrum  ; -- umgängesliv..nn.1
  umgängesnorm_1_N = mkN "umgängesnorm" "umgängesnormer" ; -- umgängesnorm..nn.1
  umgängesrätt_1_N = mkN "umgängesrätt" ; -- umgängesrätt..nn.1
  umgängeston_1_N = mkN "umgängeston" ; -- umgängeston..nn.1
  umgängesvett_1_N = mkN "umgängesvett" neutrum  ; -- umgängesvett..nn.1
  uncial_1_N = mkN "uncial" "uncialer" ; -- uncial..nn.1
  undanböjning_1_N = mkN "undanböjning" ; -- undanböjning..nn.1
  undandräkt_1_N = mkN "undandräkt" ; -- undandräkt..nn.1
  undanflykt_1_N = mkN "undanflykt" "undanflykter" ; -- undanflykt..nn.1
  undangjord_1_A = mkA "undangjord" "undangjort" ; -- undangjord..av.1
  undanglidande_1_A = mkA "undanglidande" ; -- undanglidande..av.1
  undangömd_1_A = mkA "undangömd" "undangömt" ; -- undangömd..av.1
  undangömdhet_1_N = mkN "undangömdhet" ; -- undangömdhet..nn.1
  undangömma_1_V = mkV "undangömmer" ; -- undangömma..vb.1
  undangömmande_1_N = mkN "undangömmande" ; -- undangömmande..nn.1
  undanhålla_1_V = mkV "undanhålla" "undanhöll" "undanhållit" ; -- undanhålla..vb.1
  undanhållande_1_N = mkN "undanhållande" ; -- undanhållande..nn.1
  undanlagd_1_A = mkA "undanlagd" "undanlagt" ; -- undanlagd..av.1
  undanläggning_1_N = mkN "undanläggning" ; -- undanläggning..nn.1
  undanmanöver_1_N = mkN "undanmanöver" ; -- undanmanöver..nn.1
  undanpetning_1_N = mkN "undanpetning" ; -- undanpetning..nn.1
  undanröja_1_V = mkV "undanröja" "undanröjde" "undanröjt" ; -- undanröja..vb.1
  undanröjande_1_N = mkN "undanröjande" ; -- undanröjande..nn.1
  undanröjning_1_N = mkN "undanröjning" ; -- undanröjning..nn.1
  undanskaffa_1_V = mkV "undanskaffar" ; -- undanskaffa..vb.1
  undanskaffande_1_N = mkN "undanskaffande" ; -- undanskaffande..nn.1
  undanskifta_1_V = mkV "undanskiftar" ; -- undanskifta..vb.1
  undanskiftande_1_N = mkN "undanskiftande" ; -- undanskiftande..nn.1
  undanskjuten_1_A = mkA "undanskjuten" ; -- undanskjuten..av.1
  undanskuffa_1_V = mkV "undanskuffar" ; -- undanskuffa..vb.1
  undanskuffande_1_N = mkN "undanskuffande" ; -- undanskuffande..nn.1
  undanskuffning_1_N = mkN "undanskuffning" ; -- undanskuffning..nn.1
  undanskymd_1_A = mkA "undanskymd" "undanskymt" ; -- undanskymd..av.1
  undanskymdhet_1_N = mkN "undanskymdhet" ; -- undanskymdhet..nn.1
  undanskymma_1_V = mkV "undanskymmer" ; -- undanskymma..vb.1
  undanskymmande_1_N = mkN "undanskymmande" ; -- undanskymmande..nn.1
  undansnilla_1_V = mkV "undansnillar" ; -- undansnilla..vb.1
  undansnillande_1_N = mkN "undansnillande" ; -- undansnillande..nn.1
  undansnillning_1_N = mkN "undansnillning" ; -- undansnillning..nn.1
  undansticka_1_V = mkV "undansticka" "undanstack" "undanstuckit" ; -- undansticka..vb.1
  undanstickande_1_N = mkN "undanstickande" ; -- undanstickande..nn.1
  undanstoppad_1_A = mkA "undanstoppad" ; -- undanstoppad..av.1
  undanställd_1_A = mkA "undanställd" "undanställt" ; -- undanställd..av.1
  undanstökad_1_A = mkA "undanstökad" ; -- undanstökad..av.1
  undanstökning_1_N = mkN "undanstökning" ; -- undanstökning..nn.1
  undanta_1_V = mkV "undantaga" "undantog" "undantagit" ; -- undanta..vb.1
  undantag_1_N = mkN "undantag" neutrum  ; -- undantag..nn.1
  undantagande_1_N = mkN "undantagande" ; -- undantagande..nn.1
  undantagsbestämmelse_1_N = mkN "undantagsbestämmelse" "undantagsbestämmelser" ; -- undantagsbestämmelse..nn.1
  undantagsfall_1_N = mkN "undantagsfall" neutrum  ; -- undantagsfall..nn.1
  undantagsfri_1_A = mkA "undantagsfri" "undantagsfritt" ; -- undantagsfri..av.1
  undantagslag_1_N = mkN "undantagslag" ; -- undantagslag..nn.1
  undantagslös_1_A = mkA "undantagslös" ; -- undantagslös..av.1
  undantagslöshet_1_N = mkN "undantagslöshet" ; -- undantagslöshet..nn.1
  undantagsmänniska_1_N = mkN "undantagsmänniska" ; -- undantagsmänniska..nn.1
  undantagsmässig_1_A = mkA "undantagsmässig" ; -- undantagsmässig..av.1
  undantagsrätt_1_N = mkN "undantagsrätt" "undantagsrätter" ; -- undantagsrätt..nn.1
  undantagsställning_1_N = mkN "undantagsställning" ; -- undantagsställning..nn.1
  undantagstillstånd_1_N = mkN "undantagstillstånd" neutrum  ; -- undantagstillstånd..nn.1
  undantagstillvaro_1_N = mkN "undantagstillvaro" ; -- undantagstillvaro..nn.1
  undantagställning_1_N = mkN "undantagställning" ; -- undantagställning..nn.1
  undantagsvis_1_Adv = mkAdv "undantagsvis" ; -- undantagsvis..ab.1
  undantränga_1_V = mkV "undantränger" ; -- undantränga..vb.1
  undanträngande_1_N = mkN "undanträngande" ; -- undanträngande..nn.1
  undanträngning_1_N = mkN "undanträngning" ; -- undanträngning..nn.1
  undanvindsvändning_1_N = mkN "undanvindsvändning" ; -- undanvindsvändning..nn.1
  under_1_N = mkN "under" neutrum  ; -- under..nn.1
  underanvända_1_V = mkV "underanvänder" ; -- underanvända..vb.1
  underanvändande_1_N = mkN "underanvändande" ; -- underanvändande..nn.1
  underanvändning_1_N = mkN "underanvändning" ; -- underanvändning..nn.1
  underarbete_1_N = mkN "underarbete" ; -- underarbete..nn.1
  underarm_1_N = mkN "underarm" ; -- underarm..nn.1
  underarmskrycka_1_N = mkN "underarmskrycka" ; -- underarmskrycka..nn.1
  underarmsmuskulatur_1_N = mkN "underarmsmuskulatur" ; -- underarmsmuskulatur..nn.1
  underart_1_N = mkN "underart" "underarter" ; -- underart..nn.1
  underavdelning_1_N = mkN "underavdelning" ; -- underavdelning..nn.1
  underbalans_1_N = mkN "underbalans" ; -- underbalans..nn.1
  underbalansera_1_V = mkV "underbalanserar" ; -- underbalansera..vb.1
  underbalanserande_1_N = mkN "underbalanserande" ; -- underbalanserande..nn.1
  underbalanserbar_1_A = mkA "underbalanserbar" ; -- underbalanserbar..av.1
  underbalanserbarhet_1_N = mkN "underbalanserbarhet" ; -- underbalanserbarhet..nn.1
  underbalansering_1_N = mkN "underbalansering" ; -- underbalansering..nn.1
  underbar_1_A = mkA "underbar" ; -- underbar..av.1
  underbarhet_1_N = mkN "underbarhet" ; -- underbarhet..nn.1
  underbarn_1_N = mkN "underbarn" neutrum  ; -- underbarn..nn.1
  underbefolkad_1_A = mkA "underbefolkad" ; -- underbefolkad..av.1
  underbefolkning_1_N = mkN "underbefolkning" ; -- underbefolkning..nn.1
  underbefäl_1_N = mkN "underbefäl" neutrum  ; -- underbefäl..nn.1
  underbefälhavare_1_N = mkN "underbefälhavare" utrum  ; -- underbefälhavare..nn.1
  underbefälsutbildning_1_N = mkN "underbefälsutbildning" ; -- underbefälsutbildning..nn.1
  underbegrepp_1_N = mkN "underbegrepp" neutrum  ; -- underbegrepp..nn.1
  underbeläggning_1_N = mkN "underbeläggning" ; -- underbeläggning..nn.1
  underbemannad_1_A = mkA "underbemannad" ; -- underbemannad..av.1
  underbemanning_1_N = mkN "underbemanning" ; -- underbemanning..nn.1
  underben_1_N = mkN "underben" neutrum  ; -- underben..nn.1
  underbestånd_1_N = mkN "underbestånd" neutrum  ; -- underbestånd..nn.1
  underbetala_1_V = mkV "underbetalar" ; -- underbetala..vb.1
  underbetalande_1_N = mkN "underbetalande" ; -- underbetalande..nn.1
  underbetalning_1_N = mkN "underbetalning" ; -- underbetalning..nn.1
  underbett_1_N = mkN "underbett" neutrum  ; -- underbett..nn.1
  underbetyg_1_N = mkN "underbetyg" neutrum  ; -- underbetyg..nn.1
  underbinda_1_V = mkV "underbinda" "underband" "underbundit" ; -- underbinda..vb.1
  underbindande_1_N = mkN "underbindande" ; -- underbindande..nn.1
  underbjuda_1_V = mkV "underbjuda" "underbjöd" "underbjudit" ; -- underbjuda..vb.1
  underbjudande_1_N = mkN "underbjudande" ; -- underbjudande..nn.1
  underbjudning_1_N = mkN "underbjudning" ; -- underbjudning..nn.1
  underblomma_1_N = mkN "underblomma" ; -- underblomma..nn.1
  underblåsa_1_V = mkV "underblåser" ; -- underblåsa..vb.1
  underblåsande_1_N = mkN "underblåsande" ; -- underblåsande..nn.1
  underbud_1_N = mkN "underbud" neutrum  ; -- underbud..nn.1
  underbygga_1_V = mkV "underbygger" ; -- underbygga..vb.1
  underbyggande_1_N = mkN "underbyggande" ; -- underbyggande..nn.1
  underbyggnad_1_N = mkN "underbyggnad" "underbyggnader" ; -- underbyggnad..nn.1
  underbyxa_1_N = mkN "underbyxa" ; -- underbyxa..nn.1
  underbädd_1_N = mkN "underbädd" ; -- underbädd..nn.1
  underdel_1_N = mkN "underdel" "underdelen" "underdelar" "underdelarna" ; -- underdel..nn.1
  underdimensionera_1_V = mkV "underdimensionerar" ; -- underdimensionera..vb.1
  underdimensionerande_1_N = mkN "underdimensionerande" ; -- underdimensionerande..nn.1
  underdimensionerbar_1_A = mkA "underdimensionerbar" ; -- underdimensionerbar..av.1
  underdimensionerbarhet_1_N = mkN "underdimensionerbarhet" ; -- underdimensionerbarhet..nn.1
  underdimensionering_1_N = mkN "underdimensionering" ; -- underdimensionering..nn.1
  underdjur_1_N = mkN "underdjur" neutrum  ; -- underdjur..nn.1
  underdog_1_N = mkN "underdog" ; -- underdog..nn.1
  underdogg_1_N = mkN "underdogg" ; -- underdogg..nn.1
  underdomstol_1_N = mkN "underdomstol" ; -- underdomstol..nn.1
  underdrift_1_N = mkN "underdrift" "underdrifter" ; -- underdrift..nn.1
  underdriva_1_V = mkV "underdriva" "underdrev" "underdrivit" ; -- underdriva..vb.1
  underdrivande_1_N = mkN "underdrivande" ; -- underdrivande..nn.1
  underdäck_1_N = mkN "underdäck" neutrum  ; -- underdäck..nn.1
  underdånig_1_A = mkA "underdånig" ; -- underdånig..av.1
  underdånighet_1_N = mkN "underdånighet" "underdånigheter" ; -- underdånighet..nn.1
  underdånigst_1_Adv = mkAdv "underdånigst" ; -- underdånigst..ab.1
  underemission_1_N = mkN "underemission" ; -- underemission..nn.1
  underexponera_1_V = mkV "underexponerar" ; -- underexponera..vb.1
  underexponerande_1_N = mkN "underexponerande" ; -- underexponerande..nn.1
  underexponerbar_1_A = mkA "underexponerbar" ; -- underexponerbar..av.1
  underexponerbarhet_1_N = mkN "underexponerbarhet" ; -- underexponerbarhet..nn.1
  underexponering_1_N = mkN "underexponering" ; -- underexponering..nn.1
  underfall_1_N = mkN "underfall" neutrum  ; -- underfall..nn.1
  underfamilj_1_N = mkN "underfamilj" "underfamiljer" ; -- underfamilj..nn.1
  underfart_1_N = mkN "underfart" "underfarter" ; -- underfart..nn.1
  underfinansierad_1_A = mkA "underfinansierad" ; -- underfinansierad..av.1
  underfull_1_A = mkA "underfull" ; -- underfull..av.1
  underfullhet_1_N = mkN "underfullhet" ; -- underfullhet..nn.1
  underfundig_1_A = mkA "underfundig" ; -- underfundig..av.1
  underfundighet_1_N = mkN "underfundighet" "underfundigheter" ; -- underfundighet..nn.1
  underförstå_1_V = mkV "underförstå" "underförstod" "underförstådd" ; -- underförstå..vb.1
  underförstådd_1_A = mkA "underförstådd" ; -- underförstådd..av.1
  underförståddhet_1_N = mkN "underförståddhet" ; -- underförståddhet..nn.1
  underförstående_1_N = mkN "underförstående" ; -- underförstående..nn.1
  underförsäkra_1_V = mkV "underförsäkrar" ; -- underförsäkra..vb.1
  underförsäkrande_1_N = mkN "underförsäkrande" ; -- underförsäkrande..nn.1
  underförsörjd_1_A = mkA "underförsörjd" "underförsörjt" ; -- underförsörjd..av.1
  undergardin_1_N = mkN "undergardin" "undergardiner" ; -- undergardin..nn.1
  undergiven_1_A = mkA "undergiven" ; -- undergiven..av.1
  undergivenhet_1_N = mkN "undergivenhet" ; -- undergivenhet..nn.1
  undergroundmusik_1_N = mkN "undergroundmusik" ; -- undergroundmusik..nn.1
  undergrund_1_N = mkN "undergrund" "undergrunder" ; -- undergrund..nn.1
  undergräva_1_V = mkV "undergräver" ; -- undergräva..vb.1
  undergrävande_1_N = mkN "undergrävande" ; -- undergrävande..nn.1
  undergrävning_1_N = mkN "undergrävning" ; -- undergrävning..nn.1
  undergå_1_V = mkV "undergå" "undergår" "undergå" "undergick" "undergått" "undergången" ; -- undergå..vb.1
  undergående_1_N = mkN "undergående" ; -- undergående..nn.1
  undergång_1_N = mkN "undergång" ; -- undergång..nn.1
  undergångsfixerad_1_A = mkA "undergångsfixerad" ; -- undergångsfixerad..av.1
  undergångshot_1_N = mkN "undergångshot" neutrum  ; -- undergångshot..nn.1
  undergångsmärkt_1_A = mkA "undergångsmärkt" "undergångsmärkt" ; -- undergångsmärkt..av.1
  undergångsprofetia_1_N = mkN "undergångsprofetia" ; -- undergångsprofetia..nn.1
  undergångsromantik_1_N = mkN "undergångsromantik" ; -- undergångsromantik..nn.1
  undergångsscenario_1_N = mkN "undergångsscenario" "undergångsscenariot" "undergångsscenarier" "undergångsscenarierna" ; -- undergångsscenario..nn.1
  undergångsspekulant_1_N = mkN "undergångsspekulant" "undergångsspekulanter" ; -- undergångsspekulant..nn.1
  undergångsstämning_1_N = mkN "undergångsstämning" ; -- undergångsstämning..nn.1
  undergångstecken_1_N = mkN "undergångstecken" "undergångstecknet" "undergångstecken" "undergångstecknen" ; -- undergångstecken..nn.1
  undergångsvision_1_N = mkN "undergångsvision" ; -- undergångsvision..nn.1
  undergörande_1_A = mkA "undergörande" ; -- undergörande..av.1
  undergörare_1_N = mkN "undergörare" utrum  ; -- undergörare..nn.1
  underhaltig_1_A = mkA "underhaltig" ; -- underhaltig..av.1
  underhaltighet_1_N = mkN "underhaltighet" ; -- underhaltighet..nn.1
  underhand_1_Adv = mkAdv "underhand" ; -- underhand..ab.1
  underhandla_1_V = mkV "underhandlar" ; -- underhandla..vb.1
  underhandlande_1_N = mkN "underhandlande" ; -- underhandlande..nn.1
  underhandlare_1_N = mkN "underhandlare" utrum  ; -- underhandlare..nn.1
  underhandling_1_N = mkN "underhandling" ; -- underhandling..nn.1
  underhandsackord_1_N = mkN "underhandsackord" neutrum  ; -- underhandsackord..nn.1
  underhandsbesked_1_N = mkN "underhandsbesked" neutrum  ; -- underhandsbesked..nn.1
  underhandskontakt_1_N = mkN "underhandskontakt" "underhandskontakter" ; -- underhandskontakt..nn.1
  underhavande_1_N = mkN "underhavande" "underhavanden" "underhavanden" "underhavandena" ; -- underhavande..nn.1
  underhud_1_N = mkN "underhud" ; -- underhud..nn.1
  underhuggare_1_N = mkN "underhuggare" utrum  ; -- underhuggare..nn.1
  underhus_1_N = mkN "underhus" neutrum  ; -- underhus..nn.1
  underhypotek_1_N = mkN "underhypotek" neutrum  ; -- underhypotek..nn.1
  underhärdig_1_A = mkA "underhärdig" ; -- underhärdig..av.1
  underhåll_1_N = mkN "underhåll" neutrum  ; -- underhåll..nn.1
  underhålla_1_V = mkV "underhålla" "underhöll" "underhållit" ; -- underhålla..vb.1
  underhållande_1_A = mkA "underhållande" ; -- underhållande..av.1
  underhållande_1_N = mkN "underhållande" ; -- underhållande..nn.1
  underhållare_1_N = mkN "underhållare" utrum  ; -- underhållare..nn.1
  underhållning_1_N = mkN "underhållning" ; -- underhållning..nn.1
  underhållningsbransch_1_N = mkN "underhållningsbransch" ; -- underhållningsbransch..nn.1
  underhållningsmässig_1_A = mkA "underhållningsmässig" ; -- underhållningsmässig..av.1
  underhållningsorkester_1_N = mkN "underhållningsorkester" ; -- underhållningsorkester..nn.1
  underhållningsprogram_1_N = mkN "underhållningsprogram" "underhållningsprogrammet" "underhållningsprogram" "underhållningsprogrammen" ; -- underhållningsprogram..nn.1
  underhållningsvåld_1_N = mkN "underhållningsvåld" neutrum  ; -- underhållningsvåld..nn.1
  underhållsarbete_1_N = mkN "underhållsarbete" ; -- underhållsarbete..nn.1
  underhållsbidrag_1_N = mkN "underhållsbidrag" neutrum  ; -- underhållsbidrag..nn.1
  underhållsfri_1_A = mkA "underhållsfri" "underhållsfritt" ; -- underhållsfri..av.1
  underhållsförband_1_N = mkN "underhållsförband" neutrum  ; -- underhållsförband..nn.1
  underhållskolonn_1_N = mkN "underhållskolonn" "underhållskolonner" ; -- underhållskolonn..nn.1
  underhållskostnad_1_N = mkN "underhållskostnad" "underhållskostnader" ; -- underhållskostnad..nn.1
  underhållsproblem_1_N = mkN "underhållsproblem" neutrum  ; -- underhållsproblem..nn.1
  underhållsprogram_1_N = mkN "underhållsprogram" "underhållsprogrammet" "underhållsprogram" "underhållsprogrammen" ; -- underhållsprogram..nn.1
  underhållsrutin_1_N = mkN "underhållsrutin" "underhållsrutiner" ; -- underhållsrutin..nn.1
  underhållsskyldig_1_A = mkA "underhållsskyldig" ; -- underhållsskyldig..av.1
  underhållstjänst_1_N = mkN "underhållstjänst" "underhållstjänster" ; -- underhållstjänst..nn.1
  underhållstrupp_1_N = mkN "underhållstrupp" "underhållstrupper" ; -- underhållstrupp..nn.1
  underifrånperspektiv_1_N = mkN "underifrånperspektiv" neutrum  ; -- underifrånperspektiv..nn.1
  underinformerad_1_A = mkA "underinformerad" ; -- underinformerad..av.1
  underingenjör_1_N = mkN "underingenjör" "underingenjörer" ; -- underingenjör..nn.1
  underinstans_1_N = mkN "underinstans" "underinstanser" ; -- underinstans..nn.1
  underjordisk_1_A = mkA "underjordisk" ; -- underjordisk..av.1
  underjordsarbete_1_N = mkN "underjordsarbete" ; -- underjordsarbete..nn.1
  underjordsprov_1_N = mkN "underjordsprov" neutrum  ; -- underjordsprov..nn.1
  underjäsning_1_N = mkN "underjäsning" ; -- underjäsning..nn.1
  underjäst_1_N = mkN "underjäst" ; -- underjäst..nn.1
  underkant_1_N = mkN "underkant" "underkanter" ; -- underkant..nn.1
  underkasta_1_V = mkV "underkastar" ; -- underkasta..vb.1
  underkastande_1_N = mkN "underkastande" ; -- underkastande..nn.1
  underkastelse_1_N = mkN "underkastelse" utrum  ; -- underkastelse..nn.1
  underkjol_1_N = mkN "underkjol" ; -- underkjol..nn.1
  underklass_1_N = mkN "underklass" ; -- underklass..nn.1
  underklassare_1_N = mkN "underklassare" utrum  ; -- underklassare..nn.1
  underklassig_1_A = mkA "underklassig" ; -- underklassig..av.1
  underklassighet_1_N = mkN "underklassighet" ; -- underklassighet..nn.1
  underklänning_1_N = mkN "underklänning" ; -- underklänning..nn.1
  underkropp_1_N = mkN "underkropp" ; -- underkropp..nn.1
  underkunnig_1_A = mkA "underkunnig" ; -- underkunnig..av.1
  underkur_1_N = mkN "underkur" "underkurer" ; -- underkur..nn.1
  underkurs_1_N = mkN "underkurs" "underkurser" ; -- underkurs..nn.1
  underkuva_1_V = mkV "underkuvar" ; -- underkuva..vb.1
  underkuvande_1_N = mkN "underkuvande" ; -- underkuvande..nn.1
  underkuvning_1_N = mkN "underkuvning" ; -- underkuvning..nn.1
  underkvista_1_V = mkV "underkvistar" ; -- underkvista..vb.1
  underkvistande_1_N = mkN "underkvistande" ; -- underkvistande..nn.1
  underkyla_1_V = mkV "underkyler" ; -- underkyla..vb.1
  underkylande_1_N = mkN "underkylande" ; -- underkylande..nn.1
  underkyld_1_A = mkA "underkyld" "underkylt" ; -- underkyld..av.1
  underkäke_1_N = mkN "underkäke" utrum  ; -- underkäke..nn.1
  underkänd_1_A = mkA "underkänd" ; -- underkänd..av.1
  underkänna_1_V = mkV "underkänna" "underkände" "underkänt" ; -- underkänna..vb.1
  underkännande_1_N = mkN "underkännande" ; -- underkännande..nn.1
  underlag_1_N = mkN "underlag" neutrum  ; -- underlag..nn.1
  underlagskarta_1_N = mkN "underlagskarta" ; -- underlagskarta..nn.1
  underlakan_1_N = mkN "underlakan" neutrum  ; -- underlakan..nn.1
  underland_1_N = mkN "underland" neutrum  ; -- underland..nn.1
  underlappa_1_V = mkV "underlappar" ; -- underlappa..vb.1
  underlappande_1_N = mkN "underlappande" ; -- underlappande..nn.1
  underledare_1_N = mkN "underledare" utrum  ; -- underledare..nn.1
  underleverantör_1_N = mkN "underleverantör" "underleverantörer" ; -- underleverantör..nn.1
  underlig_1_A = mkA "underlig" ; -- underlig..av.1
  underliggande_1_A = mkA "underliggande" ; -- underliggande..av.1
  underlighet_1_N = mkN "underlighet" "underligheter" ; -- underlighet..nn.1
  underliv_1_N = mkN "underliv" neutrum  ; -- underliv..nn.1
  underljudsfart_1_N = mkN "underljudsfart" "underljudsfarter" ; -- underljudsfart..nn.1
  underljudshastighet_1_N = mkN "underljudshastighet" "underljudshastigheter" ; -- underljudshastighet..nn.1
  underlydande_1_A = mkA "underlydande" ; -- underlydande..av.1
  underläder_1_N = mkN "underläder" neutrum  ; -- underläder..nn.1
  underläge_1_N = mkN "underläge" ; -- underläge..nn.1
  underlägg_1_N = mkN "underlägg" neutrum  ; -- underlägg..nn.1
  underlägsen_1_A = mkA "underlägsen" ; -- underlägsen..av.1
  underlägsenhet_1_N = mkN "underlägsenhet" "underlägsenheter" ; -- underlägsenhet..nn.1
  underläkare_1_N = mkN "underläkare" utrum  ; -- underläkare..nn.1
  underläpp_1_N = mkN "underläpp" ; -- underläpp..nn.1
  underlätta_1_V = mkV "underlättar" ; -- underlätta..vb.1
  underlättande_1_N = mkN "underlättande" ; -- underlättande..nn.1
  underlättning_1_N = mkN "underlättning" ; -- underlättning..nn.1
  underlåta_1_V = mkV "underlåta" "underlät" "underlåtit" ; -- underlåta..vb.1
  underlåtande_1_N = mkN "underlåtande" ; -- underlåtande..nn.1
  underlåtelse_1_N = mkN "underlåtelse" "underlåtelser" ; -- underlåtelse..nn.1
  underlåtenhet_1_N = mkN "underlåtenhet" "underlåtenheter" ; -- underlåtenhet..nn.1
  underlåtenhetssynd_1_N = mkN "underlåtenhetssynd" "underlåtenhetssynder" ; -- underlåtenhetssynd..nn.1
  underlöjtnant_1_N = mkN "underlöjtnant" "underlöjtnanter" ; -- underlöjtnant..nn.1
  undermast_1_N = mkN "undermast" "undermaster" ; -- undermast..nn.1
  undermedicin_1_N = mkN "undermedicin" "undermediciner" ; -- undermedicin..nn.1
  undermedicinering_1_N = mkN "undermedicinering" ; -- undermedicinering..nn.1
  undermedvetande_1_N = mkN "undermedvetande" ; -- undermedvetande..nn.1
  undermedveten_1_A = mkA "undermedveten" ; -- undermedveten..av.1
  undermedvetenhet_1_N = mkN "undermedvetenhet" ; -- undermedvetenhet..nn.1
  undermening_1_N = mkN "undermening" ; -- undermening..nn.1
  underminera_1_V = mkV "underminerar" ; -- underminera..vb.1
  underminerande_1_N = mkN "underminerande" ; -- underminerande..nn.1
  underminerbar_1_A = mkA "underminerbar" ; -- underminerbar..av.1
  underminerbarhet_1_N = mkN "underminerbarhet" ; -- underminerbarhet..nn.1
  underminering_1_N = mkN "underminering" ; -- underminering..nn.1
  undermänsklig_1_A = mkA "undermänsklig" ; -- undermänsklig..av.1
  undermänsklighet_1_N = mkN "undermänsklighet" ; -- undermänsklighet..nn.1
  undermål_1_N = mkN "undermål" neutrum  ; -- undermål..nn.1
  undermålig_1_A = mkA "undermålig" ; -- undermålig..av.1
  undermålighet_1_N = mkN "undermålighet" "undermåligheter" ; -- undermålighet..nn.1
  undermålning_1_N = mkN "undermålning" ; -- undermålning..nn.1
  undernärd_1_A = mkA "undernärd" "undernärt" ; -- undernärd..av.1
  undernärdhet_1_N = mkN "undernärdhet" ; -- undernärdhet..nn.1
  undernäring_1_N = mkN "undernäring" ; -- undernäring..nn.1
  underofficer_1_N = mkN "underofficer" "underofficeren" "underofficerare" "underofficerarna" ; -- underofficer..nn.1
  underordna_1_V = mkV "underordnar" ; -- underordna..vb.1
  underordnad_1_A = mkA "underordnad" ; -- underordnad..av.1
  underordnande_1_A = mkA "underordnande" ; -- underordnande..av.1
  underordnande_1_N = mkN "underordnande" ; -- underordnande..nn.1
  underordning_1_N = mkN "underordning" ; -- underordning..nn.1
  underpant_1_N = mkN "underpant" "underpanter" ; -- underpant..nn.1
  underplagg_1_N = mkN "underplagg" neutrum  ; -- underplagg..nn.1
  underpris_1_N = mkN "underpris" neutrum  ; -- underpris..nn.1
  underproducera_1_V = mkV "underproducerar" ; -- underproducera..vb.1
  underproducerande_1_N = mkN "underproducerande" ; -- underproducerande..nn.1
  underproduktion_1_N = mkN "underproduktion" ; -- underproduktion..nn.1
  underrapportering_1_N = mkN "underrapportering" ; -- underrapportering..nn.1
  underrede_1_N = mkN "underrede" ; -- underrede..nn.1
  underredsbehandla_1_V = mkV "underredsbehandlar" ; -- underredsbehandla..vb.1
  underredsbehandlande_1_N = mkN "underredsbehandlande" ; -- underredsbehandlande..nn.1
  underredsbehandling_1_N = mkN "underredsbehandling" ; -- underredsbehandling..nn.1
  underrepresenterad_1_A = mkA "underrepresenterad" ; -- underrepresenterad..av.1
  underrubrik_1_N = mkN "underrubrik" "underrubriker" ; -- underrubrik..nn.1
  underrätt_1_N = mkN "underrätt" "underrätter" ; -- underrätt..nn.1
  underrätta_1_V = mkV "underrättar" ; -- underrätta..vb.1
  underrättande_1_N = mkN "underrättande" ; -- underrättande..nn.1
  underrättelse_1_N = mkN "underrättelse" "underrättelser" ; -- underrättelse..nn.1
  underrättelseinhämtning_1_N = mkN "underrättelseinhämtning" ; -- underrättelseinhämtning..nn.1
  underrättelseläckage_1_N = mkN "underrättelseläckage" "underrättelseläckaget" "underrättelseläckage" "underrättelseläckagen" ; -- underrättelseläckage..nn.1
  underrättelsemyndighet_1_N = mkN "underrättelsemyndighet" "underrättelsemyndigheter" ; -- underrättelsemyndighet..nn.1
  underrättelseofficer_1_N = mkN "underrättelseofficer" "underrättelseofficeren" "underrättelseofficerare" "underrättelseofficerarna" ; -- underrättelseofficer..nn.1
  underrättelseorgan_1_N = mkN "underrättelseorgan" neutrum  ; -- underrättelseorgan..nn.1
  underrättelsesamarbete_1_N = mkN "underrättelsesamarbete" ; -- underrättelsesamarbete..nn.1
  underrättelsetjänst_1_N = mkN "underrättelsetjänst" ; -- underrättelsetjänst..nn.1
  underrättelseverksamhet_1_N = mkN "underrättelseverksamhet" "underrättelseverksamheter" ; -- underrättelseverksamhet..nn.1
  underrå_1_N = mkN "underrå" "underrån" "underrår" "underrårna" ; -- underrå..nn.1
  undersam_1_A = mkA "undersam" "undersamt" "undersamma" "undersamma" "undersammare" "undersammast" "undersammaste" ; -- undersam..av.1
  undersamhet_1_N = mkN "undersamhet" ; -- undersamhet..nn.1
  undersats_1_N = mkN "undersats" "undersatser" ; -- undersats..nn.1
  undersegel_1_N = mkN "undersegel" neutrum  ; -- undersegel..nn.1
  undersida_1_N = mkN "undersida" ; -- undersida..nn.1
  underskatta_1_V = mkV "underskattar" ; -- underskatta..vb.1
  underskattande_1_N = mkN "underskattande" ; -- underskattande..nn.1
  underskattning_1_N = mkN "underskattning" ; -- underskattning..nn.1
  underskog_1_N = mkN "underskog" ; -- underskog..nn.1
  underskott_1_N = mkN "underskott" neutrum  ; -- underskott..nn.1
  underskottsavdrag_1_N = mkN "underskottsavdrag" neutrum  ; -- underskottsavdrag..nn.1
  underskrida_1_V = mkV "underskrida" "underskred" "underskridit" ; -- underskrida..vb.1
  underskridande_1_N = mkN "underskridande" ; -- underskridande..nn.1
  underskrift_1_N = mkN "underskrift" "underskrifter" ; -- underskrift..nn.1
  underskriva_1_V = mkV "underskriva" "underskrev" "underskrivit" ; -- underskriva..vb.1
  underskrivande_1_N = mkN "underskrivande" ; -- underskrivande..nn.1
  underskriven_1_A = mkA "underskriven" ; -- underskriven..av.1
  underskrivning_1_N = mkN "underskrivning" ; -- underskrivning..nn.1
  underskruv_1_N = mkN "underskruv" ; -- underskruv..nn.1
  underskruva_1_V = mkV "underskruvar" ; -- underskruva..vb.1
  underskruvande_1_N = mkN "underskruvande" ; -- underskruvande..nn.1
  underskåp_1_N = mkN "underskåp" neutrum  ; -- underskåp..nn.1
  underskön_1_A = mkA "underskön" ; -- underskön..av.1
  underskönhet_1_N = mkN "underskönhet" ; -- underskönhet..nn.1
  undersköterska_1_N = mkN "undersköterska" ; -- undersköterska..nn.1
  underslag_1_N = mkN "underslag" neutrum  ; -- underslag..nn.1
  underslev_1_N = mkN "underslev" neutrum  ; -- underslev..nn.1
  undersläkte_1_N = mkN "undersläkte" ; -- undersläkte..nn.1
  underslå_1_V = mkV "underslå" "underslog" "underslagit" ; -- underslå..vb.1
  underslående_1_N = mkN "underslående" ; -- underslående..nn.1
  underspännare_1_N = mkN "underspännare" utrum  ; -- underspännare..nn.1
  underst_1_Adv = mkAdv "underst" ; -- underst..ab.1
  understag_1_N = mkN "understag" neutrum  ; -- understag..nn.1
  understatement_1_N = mkN "understatement" neutrum  ; -- understatement..nn.1
  understicka_1_V = mkV "understicka" "understack" "understuckit" ; -- understicka..vb.1
  understickande_1_N = mkN "understickande" ; -- understickande..nn.1
  understiga_1_V = mkV "understiga" "understeg" "understigit" ; -- understiga..vb.1
  understigande_1_N = mkN "understigande" ; -- understigande..nn.1
  understimulerad_1_A = mkA "understimulerad" ; -- understimulerad..av.1
  understrecka_1_V = mkV "understreckar" ; -- understrecka..vb.1
  understreckande_1_N = mkN "understreckande" ; -- understreckande..nn.1
  understreckare_1_N = mkN "understreckare" utrum  ; -- understreckare..nn.1
  understryka_1_V = mkV "understryka" "underströk" "understrukit" ; -- understryka..vb.1
  understrykande_1_N = mkN "understrykande" ; -- understrykande..nn.1
  understrykning_1_N = mkN "understrykning" ; -- understrykning..nn.1
  underström_1_N = mkN "underström" "underströmmen" "underströmmar" "underströmmarna" ; -- underström..nn.1
  understucken_1_A = mkA "understucken" ; -- understucken..av.1
  understyrd_1_A = mkA "understyrd" "understyrt" ; -- understyrd..av.1
  understyrdhet_1_N = mkN "understyrdhet" ; -- understyrdhet..nn.1
  underställa_1_V = mkV "underställer" ; -- underställa..vb.1
  underställande_1_N = mkN "underställande" ; -- underställande..nn.1
  underställning_1_N = mkN "underställning" ; -- underställning..nn.1
  understämma_1_N = mkN "understämma" ; -- understämma..nn.1
  understående_1_A = mkA "understående" ; -- understående..av.1
  understöd_1_N = mkN "understöd" neutrum  ; -- understöd..nn.1
  understödd_1_A = mkA "understödd" ; -- understödd..av.1
  understödja_1_V = mkV "understödja" "understödjer" "understöd" "understödde" "understött" "understödd" ; -- understödja..vb.1
  understödjande_1_N = mkN "understödjande" ; -- understödjande..nn.1
  understödsförening_1_N = mkN "understödsförening" ; -- understödsförening..nn.1
  understödskassa_1_N = mkN "understödskassa" ; -- understödskassa..nn.1
  understödsnämnd_1_N = mkN "understödsnämnd" "understödsnämnder" ; -- understödsnämnd..nn.1
  understödsrytteri_1_N = mkN "understödsrytteri" neutrum  ; -- understödsrytteri..nn.1
  understödstagaranda_1_N = mkN "understödstagaranda" ; -- understödstagaranda..nn.1
  understödstagare_1_N = mkN "understödstagare" utrum  ; -- understödstagare..nn.1
  understöt_1_N = mkN "understöt" ; -- understöt..nn.1
  undersysselsatt_1_A = mkA "undersysselsatt" ; -- undersysselsatt..av.1
  undersysselsättning_1_N = mkN "undersysselsättning" ; -- undersysselsättning..nn.1
  undersälja_1_V = mkV "undersälja" "undersålde" "undersålt" ; -- undersälja..vb.1
  undersäljande_1_N = mkN "undersäljande" ; -- undersäljande..nn.1
  undersäljning_1_N = mkN "undersäljning" ; -- undersäljning..nn.1
  undersätsig_1_A = mkA "undersätsig" ; -- undersätsig..av.1
  undersätsighet_1_N = mkN "undersätsighet" ; -- undersätsighet..nn.1
  undersåte_1_N = mkN "undersåte" utrum  ; -- undersåte..nn.1
  undersåtlig_1_A = mkA "undersåtlig" ; -- undersåtlig..av.1
  undersåtlighet_1_N = mkN "undersåtlighet" ; -- undersåtlighet..nn.1
  undersöka_1_V = mkV "undersöker" ; -- undersöka..vb.1
  undersökande_1_N = mkN "undersökande" ; -- undersökande..nn.1
  undersökare_1_N = mkN "undersökare" utrum  ; -- undersökare..nn.1
  undersökning_1_N = mkN "undersökning" ; -- undersökning..nn.1
  undersökningsdomare_1_N = mkN "undersökningsdomare" utrum  ; -- undersökningsdomare..nn.1
  undersökningsfånge_1_N = mkN "undersökningsfånge" utrum  ; -- undersökningsfånge..nn.1
  undersökningsmetod_1_N = mkN "undersökningsmetod" "undersökningsmetoder" ; -- undersökningsmetod..nn.1
  undersökningsmetod_2_N = mkN "undersökningsmetod" ; -- undersökningsmetod..nn.2
  undersökningsplikt_1_N = mkN "undersökningsplikt" ; -- undersökningsplikt..nn.1
  undersökningsrum_1_N = mkN "undersökningsrum" "undersökningsrummet" "undersökningsrum" "undersökningsrummen" ; -- undersökningsrum..nn.1
  undertak_1_N = mkN "undertak" neutrum  ; -- undertak..nn.1
  undertalig_1_A = mkA "undertalig" ; -- undertalig..av.1
  undertalighet_1_N = mkN "undertalighet" ; -- undertalighet..nn.1
  undertaxera_1_V = mkV "undertaxerar" ; -- undertaxera..vb.1
  undertaxerande_1_N = mkN "undertaxerande" ; -- undertaxerande..nn.1
  undertaxerbar_1_A = mkA "undertaxerbar" ; -- undertaxerbar..av.1
  undertaxerbarhet_1_N = mkN "undertaxerbarhet" ; -- undertaxerbarhet..nn.1
  undertaxering_1_N = mkN "undertaxering" ; -- undertaxering..nn.1
  underteckna_1_V = mkV "undertecknar" ; -- underteckna..vb.1
  undertecknad_1_A = mkA "undertecknad" ; -- undertecknad..av.1
  undertecknande_1_N = mkN "undertecknande" ; -- undertecknande..nn.1
  undertecknare_1_N = mkN "undertecknare" utrum  ; -- undertecknare..nn.1
  underterm_1_N = mkN "underterm" "undertermer" ; -- underterm..nn.1
  undertill_1_Adv = mkAdv "undertill" ; -- undertill..ab.1
  undertitel_1_N = mkN "undertitel" ; -- undertitel..nn.1
  underton_1_N = mkN "underton" "undertoner" ; -- underton..nn.1
  undertryck_1_N = mkN "undertryck" neutrum  ; -- undertryck..nn.1
  undertrycka_1_V = mkV "undertrycker" ; -- undertrycka..vb.1
  undertryckande_1_N = mkN "undertryckande" ; -- undertryckande..nn.1
  undertråd_1_N = mkN "undertråd" ; -- undertråd..nn.1
  undertröja_1_N = mkN "undertröja" ; -- undertröja..nn.1
  underutvecklad_1_A = mkA "underutvecklad" ; -- underutvecklad..av.1
  underutveckling_1_N = mkN "underutveckling" ; -- underutveckling..nn.1
  undervattensarkeologi_1_N = mkN "undervattensarkeologi" ; -- undervattensarkeologi..nn.1
  undervattensbåt_1_N = mkN "undervattensbåt" ; -- undervattensbåt..nn.1
  undervattensbölja_1_N = mkN "undervattensbölja" ; -- undervattensbölja..nn.1
  undervattensfarkost_1_N = mkN "undervattensfarkost" "undervattensfarkoster" ; -- undervattensfarkost..nn.1
  undervattensförbindelse_1_N = mkN "undervattensförbindelse" "undervattensförbindelser" ; -- undervattensförbindelse..nn.1
  undervattensgång_1_N = mkN "undervattensgång" ; -- undervattensgång..nn.1
  undervattenskamera_1_N = mkN "undervattenskamera" ; -- undervattenskamera..nn.1
  undervattenskropp_1_N = mkN "undervattenskropp" ; -- undervattenskropp..nn.1
  undervattensläge_1_N = mkN "undervattensläge" ; -- undervattensläge..nn.1
  undervattenströskel_1_N = mkN "undervattenströskel" ; -- undervattenströskel..nn.1
  undervegetation_1_N = mkN "undervegetation" ; -- undervegetation..nn.1
  underverk_1_N = mkN "underverk" neutrum  ; -- underverk..nn.1
  undervikt_1_N = mkN "undervikt" ; -- undervikt..nn.1
  underviktig_1_A = mkA "underviktig" ; -- underviktig..av.1
  underviktighet_1_N = mkN "underviktighet" ; -- underviktighet..nn.1
  undervisa_1_V = mkV "undervisar" ; -- undervisa..vb.1
  undervisande_1_N = mkN "undervisande" ; -- undervisande..nn.1
  undervisare_1_N = mkN "undervisare" utrum  ; -- undervisare..nn.1
  undervisning_1_N = mkN "undervisning" ; -- undervisning..nn.1
  undervisningsanstalt_1_N = mkN "undervisningsanstalt" "undervisningsanstalter" ; -- undervisningsanstalt..nn.1
  undervisningsbruk_1_N = mkN "undervisningsbruk" neutrum  ; -- undervisningsbruk..nn.1
  undervisningsmaterial_1_N = mkN "undervisningsmaterial" neutrum  ; -- undervisningsmaterial..nn.1
  undervisningsmetodik_1_N = mkN "undervisningsmetodik" ; -- undervisningsmetodik..nn.1
  undervisningspaket_1_N = mkN "undervisningspaket" neutrum  ; -- undervisningspaket..nn.1
  undervisningsråd_1_N = mkN "undervisningsråd" neutrum  ; -- undervisningsråd..nn.1
  undervisningssjukhus_1_N = mkN "undervisningssjukhus" neutrum  ; -- undervisningssjukhus..nn.1
  undervisningsskicklighet_1_N = mkN "undervisningsskicklighet" "undervisningsskickligheter" ; -- undervisningsskicklighet..nn.1
  undervisningsskyldighet_1_N = mkN "undervisningsskyldighet" "undervisningsskyldigheter" ; -- undervisningsskyldighet..nn.1
  undervisningsspråk_1_N = mkN "undervisningsspråk" neutrum  ; -- undervisningsspråk..nn.1
  undervisningsteknologi_1_N = mkN "undervisningsteknologi" "undervisningsteknologier" ; -- undervisningsteknologi..nn.1
  undervisningstimma_1_N = mkN "undervisningstimma" ; -- undervisningstimma..nn.1
  undervisningstimme_1_N = mkN "undervisningstimme" utrum  ; -- undervisningstimme..nn.1
  undervisningsämne_1_N = mkN "undervisningsämne" ; -- undervisningsämne..nn.1
  undervärdera_1_V = mkV "undervärderar" ; -- undervärdera..vb.1
  undervärderande_1_N = mkN "undervärderande" ; -- undervärderande..nn.1
  undervärderbar_1_A = mkA "undervärderbar" ; -- undervärderbar..av.1
  undervärderbarhet_1_N = mkN "undervärderbarhet" ; -- undervärderbarhet..nn.1
  undervärdering_1_N = mkN "undervärdering" ; -- undervärdering..nn.1
  undervärme_1_N = mkN "undervärme" utrum  ; -- undervärme..nn.1
  undervåning_1_N = mkN "undervåning" ; -- undervåning..nn.1
  underårig_1_A = mkA "underårig" ; -- underårig..av.1
  underårighet_1_N = mkN "underårighet" ; -- underårighet..nn.1
  undfalla_1_V = mkV "undfalla" "undföll" "undfallit" ; -- undfalla..vb.1
  undfallande_1_A = mkA "undfallande" ; -- undfallande..av.1
  undfallande_1_N = mkN "undfallande" ; -- undfallande..nn.1
  undfallen_1_A = mkA "undfallen" ; -- undfallen..av.1
  undfallenhet_1_N = mkN "undfallenhet" "undfallenheter" ; -- undfallenhet..nn.1
  undfallenhetspolitik_1_N = mkN "undfallenhetspolitik" ; -- undfallenhetspolitik..nn.1
  undfly_1_V = mkV "undflyr" ; -- undfly..vb.1
  undflyende_1_N = mkN "undflyende" ; -- undflyende..nn.1
  undflykt_1_N = mkN "undflykt" "undflykter" ; -- undflykt..nn.1
  undfägna_1_V = mkV "undfägnar" ; -- undfägna..vb.1
  undfägnad_1_N = mkN "undfägnad" "undfägnader" ; -- undfägnad..nn.1
  undfägnande_1_N = mkN "undfägnande" ; -- undfägnande..nn.1
  undfå_1_V = mkV "undfå" "undfick" "undfått" ; -- undfå..vb.1
  undfående_1_N = mkN "undfående" ; -- undfående..nn.1
  undgänglig_1_A = mkA "undgänglig" ; -- undgänglig..av.1
  undgå_1_V = mkV "undgå" "undgick" "undgått" ; -- undgå..vb.1
  undgående_1_N = mkN "undgående" ; -- undgående..nn.1
  undin_1_N = mkN "undin" "undiner" ; -- undin..nn.1
  undkomma_1_V = mkV "undkomma" "undkom" "undkommit" ; -- undkomma..vb.1
  undkommande_1_N = mkN "undkommande" ; -- undkommande..nn.1
  undra_1_V = mkV "undrar" ; -- undra..vb.1
  undran_1_N = mkN "undran" "undran" "undringar" "undringarna" ; -- undran..nn.1
  undrande_1_A = mkA "undrande" ; -- undrande..av.1
  undrande_1_N = mkN "undrande" ; -- undrande..nn.1
  undransvärd_1_A = mkA "undransvärd" "undransvärt" ; -- undransvärd..av.1
  undransvärdhet_1_N = mkN "undransvärdhet" ; -- undransvärdhet..nn.1
  undring_1_N = mkN "undring" ; -- undring..nn.1
  undseende_1_N = mkN "undseende" ; -- undseende..nn.1
  undskylla_1_V = mkV "undskyller" ; -- undskylla..vb.1
  undskyllande_1_N = mkN "undskyllande" ; -- undskyllande..nn.1
  undskyllning_1_N = mkN "undskyllning" ; -- undskyllning..nn.1
  undslippa_1_V = mkV "undslippa" "undslapp" "undsluppit" ; -- undslippa..vb.1
  undslippande_1_N = mkN "undslippande" ; -- undslippande..nn.1
  undsätta_1_V = mkV "undsätta" "undsätter" "undsätt" "undsatte" "undsatt" "undsatt" ; -- undsätta..vb.1
  undsättande_1_N = mkN "undsättande" ; -- undsättande..nn.1
  undsättning_1_N = mkN "undsättning" ; -- undsättning..nn.1
  undsättningsfond_1_N = mkN "undsättningsfond" "undsättningsfonder" ; -- undsättningsfond..nn.1
  undsättningsförsök_1_N = mkN "undsättningsförsök" neutrum  ; -- undsättningsförsök..nn.1
  undsättningshär_1_N = mkN "undsättningshär" ; -- undsättningshär..nn.1
  undsättningsstyrka_1_N = mkN "undsättningsstyrka" ; -- undsättningsstyrka..nn.1
  undulantfeber_1_N = mkN "undulantfeber" ; -- undulantfeber..nn.1
  undulat_1_N = mkN "undulat" "undulater" ; -- undulat..nn.1
  undulation_1_N = mkN "undulation" ; -- undulation..nn.1
  undulatorisk_1_A = mkA "undulatorisk" ; -- undulatorisk..av.1
  undulera_1_V = mkV "undulerar" ; -- undulera..vb.1
  undulerande_1_N = mkN "undulerande" ; -- undulerande..nn.1
  undulering_1_N = mkN "undulering" ; -- undulering..nn.1
  undvara_1_V = mkV "undvarar" ; -- undvara..vb.1
  undvarande_1_N = mkN "undvarande" ; -- undvarande..nn.1
  undvika_1_V = mkV "undvika" "undvek" "undvikit" ; -- undvika..vb.1
  undvikande_1_A = mkA "undvikande" ; -- undvikande..av.1
  undvikande_1_N = mkN "undvikande" ; -- undvikande..nn.1
  ung_1_A = mkA "ung" "yngre" "yngst" ; -- ung..av.1
  ungdjur_1_N = mkN "ungdjur" neutrum  ; -- ungdjur..nn.1
  ungdom_1_N = mkN "ungdom" ; -- ungdom..nn.1
  ungdomlig_1_A = mkA "ungdomlig" ; -- ungdomlig..av.1
  ungdomlighet_1_N = mkN "ungdomlighet" ; -- ungdomlighet..nn.1
  ungdomsanstalt_1_N = mkN "ungdomsanstalt" "ungdomsanstalter" ; -- ungdomsanstalt..nn.1
  ungdomsarbete_1_N = mkN "ungdomsarbete" ; -- ungdomsarbete..nn.1
  ungdomsarbetslöshet_1_N = mkN "ungdomsarbetslöshet" "ungdomsarbetslösheter" ; -- ungdomsarbetslöshet..nn.1
  ungdomsbok_1_N = mkN "ungdomsbok" "ungdomsböcker" ; -- ungdomsbok..nn.1
  ungdomsbrottslighet_1_N = mkN "ungdomsbrottslighet" "ungdomsbrottsligheter" ; -- ungdomsbrottslighet..nn.1
  ungdomsbrottsling_1_N = mkN "ungdomsbrottsling" ; -- ungdomsbrottsling..nn.1
  ungdomsfilm_1_N = mkN "ungdomsfilm" "ungdomsfilmer" ; -- ungdomsfilm..nn.1
  ungdomsflamma_1_N = mkN "ungdomsflamma" ; -- ungdomsflamma..nn.1
  ungdomsfråga_1_N = mkN "ungdomsfråga" ; -- ungdomsfråga..nn.1
  ungdomsfylleri_1_N = mkN "ungdomsfylleri" "ungdomsfylleriet" "ungdomsfyllerier" "ungdomsfyllerierna" ; -- ungdomsfylleri..nn.1
  ungdomsfängelse_1_N = mkN "ungdomsfängelse" "ungdomsfängelset" "ungdomsfängelser" "ungdomsfängelserna" ; -- ungdomsfängelse..nn.1
  ungdomsförbund_1_N = mkN "ungdomsförbund" neutrum  ; -- ungdomsförbund..nn.1
  ungdomsförmedling_1_N = mkN "ungdomsförmedling" ; -- ungdomsförmedling..nn.1
  ungdomsgrupp_1_N = mkN "ungdomsgrupp" "ungdomsgrupper" ; -- ungdomsgrupp..nn.1
  ungdomsgård_1_N = mkN "ungdomsgård" ; -- ungdomsgård..nn.1
  ungdomshem_1_N = mkN "ungdomshem" "ungdomshemmet" "ungdomshem" "ungdomshemmen" ; -- ungdomshem..nn.1
  ungdomskonsulent_1_N = mkN "ungdomskonsulent" "ungdomskonsulenter" ; -- ungdomskonsulent..nn.1
  ungdomskriminalitet_1_N = mkN "ungdomskriminalitet" "ungdomskriminaliteter" ; -- ungdomskriminalitet..nn.1
  ungdomskultur_1_N = mkN "ungdomskultur" "ungdomskulturer" ; -- ungdomskultur..nn.1
  ungdomskälla_1_N = mkN "ungdomskälla" ; -- ungdomskälla..nn.1
  ungdomskärlek_1_N = mkN "ungdomskärlek" ; -- ungdomskärlek..nn.1
  ungdomsledare_1_N = mkN "ungdomsledare" utrum  ; -- ungdomsledare..nn.1
  ungdomsorganisation_1_N = mkN "ungdomsorganisation" ; -- ungdomsorganisation..nn.1
  ungdomspolis_1_N = mkN "ungdomspolis" ; -- ungdomspolis..nn.1
  ungdomspolitik_1_N = mkN "ungdomspolitik" ; -- ungdomspolitik..nn.1
  ungdomspolitisk_1_A = mkA "ungdomspolitisk" ; -- ungdomspolitisk..av.1
  ungdomspraktik_1_N = mkN "ungdomspraktik" "ungdomspraktiker" ; -- ungdomspraktik..nn.1
  ungdomspraktikant_1_N = mkN "ungdomspraktikant" "ungdomspraktikanter" ; -- ungdomspraktikant..nn.1
  ungdomspsykiatrisk_1_A = mkA "ungdomspsykiatrisk" ; -- ungdomspsykiatrisk..av.1
  ungdomsråd_1_N = mkN "ungdomsråd" neutrum  ; -- ungdomsråd..nn.1
  ungdomsrådgivning_1_N = mkN "ungdomsrådgivning" ; -- ungdomsrådgivning..nn.1
  ungdomsrådgivningsnätverk_1_N = mkN "ungdomsrådgivningsnätverk" neutrum  ; -- ungdomsrådgivningsnätverk..nn.1
  ungdomsrörelse_1_N = mkN "ungdomsrörelse" "ungdomsrörelser" ; -- ungdomsrörelse..nn.1
  ungdomsskola_1_N = mkN "ungdomsskola" ; -- ungdomsskola..nn.1
  ungdomssvärmeri_1_N = mkN "ungdomssvärmeri" "ungdomssvärmeriet" "ungdomssvärmerier" "ungdomssvärmerierna" ; -- ungdomssvärmeri..nn.1
  ungdomssynd_1_N = mkN "ungdomssynd" "ungdomssynder" ; -- ungdomssynd..nn.1
  ungdomstid_1_N = mkN "ungdomstid" "ungdomstider" ; -- ungdomstid..nn.1
  ungdomsverk_1_N = mkN "ungdomsverk" neutrum  ; -- ungdomsverk..nn.1
  ungdomsverksamhet_1_N = mkN "ungdomsverksamhet" "ungdomsverksamheter" ; -- ungdomsverksamhet..nn.1
  ungdomsväljare_1_N = mkN "ungdomsväljare" utrum  ; -- ungdomsväljare..nn.1
  ungdomsvän_1_N = mkN "ungdomsvän" "ungdomsvännen" "ungdomsvänner" "ungdomsvännerna" ; -- ungdomsvän..nn.1
  ungdomsvård_1_N = mkN "ungdomsvård" ; -- ungdomsvård..nn.1
  ungdomsvårdsskola_1_N = mkN "ungdomsvårdsskola" ; -- ungdomsvårdsskola..nn.1
  ungdomsyra_1_N = mkN "ungdomsyra" ; -- ungdomsyra..nn.1
  ungdomsår_1_N = mkN "ungdomsår" neutrum  ; -- ungdomsår..nn.1
  unge_1_N = mkN "unge" utrum  ; -- unge..nn.1
  ungefärlig_1_A = mkA "ungefärlig" ; -- ungefärlig..av.1
  ungefärligen_1_Adv = mkAdv "ungefärligen" ; -- ungefärligen..ab.1
  ungefärlighet_1_N = mkN "ungefärlighet" ; -- ungefärlighet..nn.1
  ungersk_1_A = mkA "ungersk" ; -- ungersk..av.1
  ungerska_1_N = mkN "ungerska" ; -- ungerska..nn.1
  ungerska_2_N = mkN "ungerska" ; -- ungerska..nn.2
  ungersven_1_N = mkN "ungersven" "ungersvennen" "ungersvenner" "ungersvennerna" ; -- ungersven..nn.1
  ungflicksaktig_1_A = mkA "ungflicksaktig" ; -- ungflicksaktig..av.1
  ungflicksaktighet_1_N = mkN "ungflicksaktighet" ; -- ungflicksaktighet..nn.1
  ungflicksfnissighet_1_N = mkN "ungflicksfnissighet" ; -- ungflicksfnissighet..nn.1
  ungherre_1_N = mkN "ungherre" utrum  ; -- ungherre..nn.1
  unghäst_1_N = mkN "unghäst" ; -- unghäst..nn.1
  ungkarl_1_N = mkN "ungkarl" ; -- ungkarl..nn.1
  ungkarlsflicka_1_N = mkN "ungkarlsflicka" ; -- ungkarlsflicka..nn.1
  ungkarlshotell_1_N = mkN "ungkarlshotell" neutrum  ; -- ungkarlshotell..nn.1
  ungkarlsliv_1_N = mkN "ungkarlsliv" neutrum  ; -- ungkarlsliv..nn.1
  ungkarlslya_1_N = mkN "ungkarlslya" ; -- ungkarlslya..nn.1
  ungkarlsvana_1_N = mkN "ungkarlsvana" ; -- ungkarlsvana..nn.1
  ungkommunist_1_N = mkN "ungkommunist" "ungkommunister" ; -- ungkommunist..nn.1
  ungkyrklig_1_A = mkA "ungkyrklig" ; -- ungkyrklig..av.1
  ungkyrklighet_1_N = mkN "ungkyrklighet" ; -- ungkyrklighet..nn.1
  ungkyrkorörelse_1_N = mkN "ungkyrkorörelse" utrum  ; -- ungkyrkorörelse..nn.1
  unglotta_1_N = mkN "unglotta" ; -- unglotta..nn.1
  ungmor_1_N = mkN "ungmor" "ungmodern" "ungmödrar" "ungmödrarna" ; -- ungmor..nn.1
  ungmö_1_N = mkN "ungmö" "ungmön" "ungmör" "ungmörna" ; -- ungmö..nn.1
  ungnöt_1_N = mkN "ungnöt" neutrum  ; -- ungnöt..nn.1
  ungrare_1_N = mkN "ungrare" utrum  ; -- ungrare..nn.1
  ungrenässans_1_N = mkN "ungrenässans" ; -- ungrenässans..nn.1
  ungskog_1_N = mkN "ungskog" ; -- ungskog..nn.1
  ungsocialism_1_N = mkN "ungsocialism" "ungsocialismer" ; -- ungsocialism..nn.1
  ungsocialistisk_1_A = mkA "ungsocialistisk" ; -- ungsocialistisk..av.1
  ungstadium_1_N = mkN "ungstadium" "ungstadiet" "ungstadier" "ungstadierna" ; -- ungstadium..nn.1
  ungsugga_1_N = mkN "ungsugga" ; -- ungsugga..nn.1
  ungsvensk_1_A = mkA "ungsvensk" ; -- ungsvensk..av.1
  ungsvensk_1_N = mkN "ungsvensk" ; -- ungsvensk..nn.1
  ungtall_1_N = mkN "ungtall" ; -- ungtall..nn.1
  ungtupp_1_N = mkN "ungtupp" ; -- ungtupp..nn.1
  ungturk_1_N = mkN "ungturk" ; -- ungturk..nn.1
  unifiera_1_V = mkV "unifierar" ; -- unifiera..vb.1
  unifierande_1_N = mkN "unifierande" ; -- unifierande..nn.1
  unifierbar_1_A = mkA "unifierbar" ; -- unifierbar..av.1
  unifierbarhet_1_N = mkN "unifierbarhet" ; -- unifierbarhet..nn.1
  unifiering_1_N = mkN "unifiering" ; -- unifiering..nn.1
  uniform_1_A = mkA "uniform" ; -- uniform..av.1
  uniform_1_N = mkN "uniform" "uniformer" ; -- uniform..nn.1
  uniformera_1_V = mkV "uniformerar" ; -- uniformera..vb.1
  uniformerad_1_A = mkA "uniformerad" ; -- uniformerad..av.1
  uniformerande_1_N = mkN "uniformerande" ; -- uniformerande..nn.1
  uniformerbar_1_A = mkA "uniformerbar" ; -- uniformerbar..av.1
  uniformerbarhet_1_N = mkN "uniformerbarhet" ; -- uniformerbarhet..nn.1
  uniformering_1_N = mkN "uniformering" ; -- uniformering..nn.1
  uniformhet_1_N = mkN "uniformhet" ; -- uniformhet..nn.1
  uniformitet_1_N = mkN "uniformitet" "uniformiteter" ; -- uniformitet..nn.1
  uniformsbeteckning_1_N = mkN "uniformsbeteckning" ; -- uniformsbeteckning..nn.1
  uniformsbyxa_1_N = mkN "uniformsbyxa" ; -- uniformsbyxa..nn.1
  uniformshatt_1_N = mkN "uniformshatt" ; -- uniformshatt..nn.1
  uniformsjacka_1_N = mkN "uniformsjacka" ; -- uniformsjacka..nn.1
  uniformsklädd_1_A = mkA "uniformsklädd" ; -- uniformsklädd..av.1
  uniformsknapp_1_N = mkN "uniformsknapp" ; -- uniformsknapp..nn.1
  uniformsliknande_1_A = mkA "uniformsliknande" ; -- uniformsliknande..av.1
  uniformsmössa_1_N = mkN "uniformsmössa" ; -- uniformsmössa..nn.1
  uniformsplikt_1_N = mkN "uniformsplikt" ; -- uniformsplikt..nn.1
  uniformsrock_1_N = mkN "uniformsrock" ; -- uniformsrock..nn.1
  uniformsslips_1_N = mkN "uniformsslips" ; -- uniformsslips..nn.1
  uniformssnöre_1_N = mkN "uniformssnöre" ; -- uniformssnöre..nn.1
  uniformstecken_1_N = mkN "uniformstecken" "uniformstecknet" "uniformstecken" "uniformstecknen" ; -- uniformstecken..nn.1
  unigram_1_N = mkN "unigram" "unigrammet" "unigram" "unigrammen" ; -- unigram..nn.1
  unik_1_A = mkA "unik" ; -- unik..av.1
  unika_1_N = mkN "unika" ; -- unika..nn.1
  unikabox_1_N = mkN "unikabox" ; -- unikabox..nn.1
  unikat_1_N = mkN "unikat" neutrum  ; -- unikat..nn.1
  unikum_1_N = mkN "unikum" neutrum  ; -- unikum..nn.1
  unilateral_1_A = mkA "unilateral" ; -- unilateral..av.1
  union_1_N = mkN "union" ; -- union..nn.1
  unionell_1_A = mkA "unionell" ; -- unionell..av.1
  unionsbrott_1_N = mkN "unionsbrott" neutrum  ; -- unionsbrott..nn.1
  unionsupplösning_1_N = mkN "unionsupplösning" ; -- unionsupplösning..nn.1
  unisex_1_A = mkA "unisex" ; -- unisex..av.1
  unisexoverall_1_N = mkN "unisexoverall" "unisexoveraller" ; -- unisexoverall..nn.1
  unison_1_A = mkA "unison" ; -- unison..av.1
  unitariansk_1_A = mkA "unitariansk" ; -- unitariansk..av.1
  unitarie_1_N = mkN "unitarie" "unitarier" ; -- unitarie..nn.1
  unitarisk_1_A = mkA "unitarisk" ; -- unitarisk..av.1
  unitarism_1_N = mkN "unitarism" "unitarismer" ; -- unitarism..nn.1
  unitarist_1_N = mkN "unitarist" "unitarister" ; -- unitarist..nn.1
  unitaristisk_1_A = mkA "unitaristisk" ; -- unitaristisk..av.1
  universalarvinge_1_N = mkN "universalarvinge" utrum  ; -- universalarvinge..nn.1
  universalbegrepp_1_N = mkN "universalbegrepp" neutrum  ; -- universalbegrepp..nn.1
  universalbegåvning_1_N = mkN "universalbegåvning" ; -- universalbegåvning..nn.1
  universalborr_1_N = mkN "universalborr" ; -- universalborr..nn.1
  universalgeni_1_N = mkN "universalgeni" "universalgeniet" "universalgenier" "universalgenierna" ; -- universalgeni..nn.1
  universalism_1_N = mkN "universalism" "universalismer" ; -- universalism..nn.1
  universalist_1_N = mkN "universalist" "universalister" ; -- universalist..nn.1
  universalistisk_1_A = mkA "universalistisk" ; -- universalistisk..av.1
  universalitet_1_N = mkN "universalitet" "universaliteter" ; -- universalitet..nn.1
  universalkarta_1_N = mkN "universalkarta" ; -- universalkarta..nn.1
  universalkniv_1_N = mkN "universalkniv" ; -- universalkniv..nn.1
  universalknut_1_N = mkN "universalknut" ; -- universalknut..nn.1
  universallösning_1_N = mkN "universallösning" ; -- universallösning..nn.1
  universalmedel_1_N = mkN "universalmedel" neutrum  ; -- universalmedel..nn.1
  universalsilikon_1_N = mkN "universalsilikon" "universalsilikoner" ; -- universalsilikon..nn.1
  universalsnille_1_N = mkN "universalsnille" ; -- universalsnille..nn.1
  universalspråk_1_N = mkN "universalspråk" neutrum  ; -- universalspråk..nn.1
  universaltid_1_N = mkN "universaltid" ; -- universaltid..nn.1
  universell_1_A = mkA "universell" ; -- universell..av.1
  universitet_1_N = mkN "universitet" neutrum  ; -- universitet..nn.1
  universitetsadjunkt_1_N = mkN "universitetsadjunkt" "universitetsadjunkter" ; -- universitetsadjunkt..nn.1
  universitetsbibliotek_1_N = mkN "universitetsbibliotek" neutrum  ; -- universitetsbibliotek..nn.1
  universitetsbokhandel_1_N = mkN "universitetsbokhandel" ; -- universitetsbokhandel..nn.1
  universitetsfilial_1_N = mkN "universitetsfilial" "universitetsfilialer" ; -- universitetsfilial..nn.1
  universitetsinstitution_1_N = mkN "universitetsinstitution" ; -- universitetsinstitution..nn.1
  universitetskansler_1_N = mkN "universitetskansler" ; -- universitetskansler..nn.1
  universitetslektor_1_N = mkN "universitetslektor" "universitetslektorer" ; -- universitetslektor..nn.1
  universitetsmatrikel_1_N = mkN "universitetsmatrikel" ; -- universitetsmatrikel..nn.1
  universitetsrektor_1_N = mkN "universitetsrektor" "universitetsrektorer" ; -- universitetsrektor..nn.1
  universitetssjukhus_1_N = mkN "universitetssjukhus" neutrum  ; -- universitetssjukhus..nn.1
  universitetsstad_1_N = mkN "universitetsstad" "universitetsstäder" ; -- universitetsstad..nn.1
  universitetsstuderande_1_N = mkN "universitetsstuderande" "universitetsstuderanden" "universitetsstuderanden" "universitetsstuderandena" ; -- universitetsstuderande..nn.1
  universitetsutbildning_1_N = mkN "universitetsutbildning" ; -- universitetsutbildning..nn.1
  universitetsämne_1_N = mkN "universitetsämne" ; -- universitetsämne..nn.1
  universum_1_N = mkN "universum" neutrum  ; -- universum..nn.1
  unken_1_A = mkA "unken" ; -- unken..av.1
  unkenhet_1_N = mkN "unkenhet" ; -- unkenhet..nn.1
  unkna_1_V = mkV "unknar" ; -- unkna..vb.1
  unknande_1_N = mkN "unknande" ; -- unknande..nn.1
  unna_1_V = mkV "unnar" ; -- unna..vb.1
  unnande_1_N = mkN "unnande" ; -- unnande..nn.1
  uno_1_N = mkN "uno" ; -- uno..nn.1
  uns_1_N = mkN "uns" neutrum  ; -- uns..nn.1
  up_to_date_1_A = mkA "up-to-date" ; -- up-to-date..av.1
  uppamma_1_V = mkV "uppammar" ; -- uppamma..vb.1
  uppammande_1_N = mkN "uppammande" ; -- uppammande..nn.1
  upparbeta_1_V = mkV "upparbetar" ; -- upparbeta..vb.1
  upparbetande_1_N = mkN "upparbetande" ; -- upparbetande..nn.1
  upparbetning_1_N = mkN "upparbetning" ; -- upparbetning..nn.1
  uppassa_1_V = mkV "uppassar" ; -- uppassa..vb.1
  uppassande_1_N = mkN "uppassande" ; -- uppassande..nn.1
  uppassare_1_N = mkN "uppassare" utrum  ; -- uppassare..nn.1
  uppassning_1_N = mkN "uppassning" ; -- uppassning..nn.1
  uppassningsställe_1_N = mkN "uppassningsställe" ; -- uppassningsställe..nn.1
  uppbackare_1_N = mkN "uppbackare" utrum  ; -- uppbackare..nn.1
  uppbackning_1_N = mkN "uppbackning" ; -- uppbackning..nn.1
  uppbindning_1_N = mkN "uppbindning" ; -- uppbindning..nn.1
  uppbjuda_1_V = mkV "uppbjuda" "uppbjöd" "uppbjudit" ; -- uppbjuda..vb.1
  uppbjudande_1_N = mkN "uppbjudande" ; -- uppbjudande..nn.1
  uppbjudning_1_N = mkN "uppbjudning" ; -- uppbjudning..nn.1
  uppblanda_1_V = mkV "uppblandar" ; -- uppblanda..vb.1
  uppblandad_1_A = mkA "uppblandad" ; -- uppblandad..av.1
  uppblandande_1_N = mkN "uppblandande" ; -- uppblandande..nn.1
  uppblandning_1_N = mkN "uppblandning" ; -- uppblandning..nn.1
  uppblomstring_1_N = mkN "uppblomstring" ; -- uppblomstring..nn.1
  uppblossande_1_A = mkA "uppblossande" ; -- uppblossande..av.1
  uppblåsbar_1_A = mkA "uppblåsbar" ; -- uppblåsbar..av.1
  uppblåsning_1_N = mkN "uppblåsning" ; -- uppblåsning..nn.1
  uppblåsningsfas_1_N = mkN "uppblåsningsfas" "uppblåsningsfaser" ; -- uppblåsningsfas..nn.1
  uppblåst_1_A = mkA "uppblåst" "uppblåst" ; -- uppblåst..av.1
  uppblåsthet_1_N = mkN "uppblåsthet" ; -- uppblåsthet..nn.1
  uppblött_1_A = mkA "uppblött" ; -- uppblött..av.1
  uppbokad_1_A = mkA "uppbokad" ; -- uppbokad..av.1
  uppbragt_1_A = mkA "uppbragt" "uppbragt" ; -- uppbragt..av.1
  uppbragthet_1_N = mkN "uppbragthet" ; -- uppbragthet..nn.1
  uppbringa_1_V = mkV "uppbringar" ; -- uppbringa..vb.1
  uppbringande_1_N = mkN "uppbringande" ; -- uppbringande..nn.1
  uppbringning_1_N = mkN "uppbringning" ; -- uppbringning..nn.1
  uppbrott_1_N = mkN "uppbrott" neutrum  ; -- uppbrott..nn.1
  uppbrottsorder_1_N = mkN "uppbrottsorder" ; -- uppbrottsorder..nn.1
  uppbrottssignal_1_N = mkN "uppbrottssignal" "uppbrottssignaler" ; -- uppbrottssignal..nn.1
  uppbrottsstämning_1_N = mkN "uppbrottsstämning" ; -- uppbrottsstämning..nn.1
  uppbrusande_1_N = mkN "uppbrusande" ; -- uppbrusande..nn.1
  uppbrusning_1_N = mkN "uppbrusning" ; -- uppbrusning..nn.1
  uppbud_1_N = mkN "uppbud" neutrum  ; -- uppbud..nn.1
  uppbunden_1_A = mkA "uppbunden" ; -- uppbunden..av.1
  uppburen_1_A = mkA "uppburen" ; -- uppburen..av.1
  uppbygga_1_V = mkV "uppbygger" ; -- uppbygga..vb.1
  uppbyggande_1_N = mkN "uppbyggande" ; -- uppbyggande..nn.1
  uppbyggelse_1_N = mkN "uppbyggelse" utrum  ; -- uppbyggelse..nn.1
  uppbyggelselitteratur_1_N = mkN "uppbyggelselitteratur" ; -- uppbyggelselitteratur..nn.1
  uppbyggelsemöte_1_N = mkN "uppbyggelsemöte" ; -- uppbyggelsemöte..nn.1
  uppbygglig_1_A = mkA "uppbygglig" ; -- uppbygglig..av.1
  uppbygglighet_1_N = mkN "uppbygglighet" ; -- uppbygglighet..nn.1
  uppbygglighetsanspråk_1_N = mkN "uppbygglighetsanspråk" neutrum  ; -- uppbygglighetsanspråk..nn.1
  uppbyggnad_1_N = mkN "uppbyggnad" "uppbyggnader" ; -- uppbyggnad..nn.1
  uppbyggnadsskede_1_N = mkN "uppbyggnadsskede" ; -- uppbyggnadsskede..nn.1
  uppbäddning_1_N = mkN "uppbäddning" ; -- uppbäddning..nn.1
  uppbära_1_V = mkV "uppbära" "uppbar" "uppburit" ; -- uppbära..vb.1
  uppbärande_1_N = mkN "uppbärande" ; -- uppbärande..nn.1
  uppbåd_1_N = mkN "uppbåd" neutrum  ; -- uppbåd..nn.1
  uppbåda_1_V = mkV "uppbådar" ; -- uppbåda..vb.1
  uppbådande_1_N = mkN "uppbådande" ; -- uppbådande..nn.1
  uppbörd_1_N = mkN "uppbörd" "uppbörder" ; -- uppbörd..nn.1
  uppbördsbok_1_N = mkN "uppbördsbok" "uppbördsböcker" ; -- uppbördsbok..nn.1
  uppbördsdag_1_N = mkN "uppbördsdag" ; -- uppbördsdag..nn.1
  uppbördslängd_1_N = mkN "uppbördslängd" "uppbördslängder" ; -- uppbördslängd..nn.1
  uppbördsman_1_N = mkN "uppbördsman" "uppbördsmannen" "uppbördsmän" "uppbördsmännen" ; -- uppbördsman..nn.1
  uppbördstermin_1_N = mkN "uppbördstermin" "uppbördsterminer" ; -- uppbördstermin..nn.1
  uppbördsverk_1_N = mkN "uppbördsverk" neutrum  ; -- uppbördsverk..nn.1
  uppbördsår_1_N = mkN "uppbördsår" neutrum  ; -- uppbördsår..nn.1
  uppdaga_1_V = mkV "uppdagar" ; -- uppdaga..vb.1
  uppdagande_1_N = mkN "uppdagande" ; -- uppdagande..nn.1
  uppdatera_1_V = mkV "uppdaterar" ; -- uppdatera..vb.1
  uppdaterande_1_N = mkN "uppdaterande" ; -- uppdaterande..nn.1
  uppdaterbar_1_A = mkA "uppdaterbar" ; -- uppdaterbar..av.1
  uppdaterbarhet_1_N = mkN "uppdaterbarhet" ; -- uppdaterbarhet..nn.1
  uppdatering_1_N = mkN "uppdatering" ; -- uppdatering..nn.1
  uppdela_1_V = mkV "uppdelar" ; -- uppdela..vb.1
  uppdelande_1_N = mkN "uppdelande" ; -- uppdelande..nn.1
  uppdelning_1_N = mkN "uppdelning" ; -- uppdelning..nn.1
  uppdiktad_1_A = mkA "uppdiktad" ; -- uppdiktad..av.1
  uppdra_1_V = mkV "uppdraga" "uppdrog" "uppdragit" ; -- uppdra..vb.1
  uppdrag_1_N = mkN "uppdrag" neutrum  ; -- uppdrag..nn.1
  uppdragande_1_N = mkN "uppdragande" ; -- uppdragande..nn.1
  uppdragsarkeologi_1_N = mkN "uppdragsarkeologi" ; -- uppdragsarkeologi..nn.1
  uppdragsarkeologisk_1_A = mkA "uppdragsarkeologisk" ; -- uppdragsarkeologisk..av.1
  uppdragsforskning_1_N = mkN "uppdragsforskning" ; -- uppdragsforskning..nn.1
  uppdragsgivare_1_N = mkN "uppdragsgivare" utrum  ; -- uppdragsgivare..nn.1
  uppdragsmördare_1_N = mkN "uppdragsmördare" utrum  ; -- uppdragsmördare..nn.1
  uppdragsskribent_1_N = mkN "uppdragsskribent" "uppdragsskribenter" ; -- uppdragsskribent..nn.1
  uppdragsspecifikation_1_N = mkN "uppdragsspecifikation" ; -- uppdragsspecifikation..nn.1
  uppdragstagare_1_N = mkN "uppdragstagare" utrum  ; -- uppdragstagare..nn.1
  uppdriva_1_V = mkV "uppdriva" "uppdrev" "uppdrivit" ; -- uppdriva..vb.1
  uppdrivande_1_N = mkN "uppdrivande" ; -- uppdrivande..nn.1
  uppdriven_1_A = mkA "uppdriven" ; -- uppdriven..av.1
  uppdrivning_1_N = mkN "uppdrivning" ; -- uppdrivning..nn.1
  uppdukning_1_N = mkN "uppdukning" ; -- uppdukning..nn.1
  uppdykande_1_A = mkA "uppdykande" ; -- uppdykande..av.1
  uppdykande_1_N = mkN "uppdykande" ; -- uppdykande..nn.1
  uppdyrkning_1_N = mkN "uppdyrkning" ; -- uppdyrkning..nn.1
  uppegga_1_V = mkV "uppeggar" ; -- uppegga..vb.1
  uppeggande_1_N = mkN "uppeggande" ; -- uppeggande..nn.1
  uppehälle_1_N = mkN "uppehälle" ; -- uppehälle..nn.1
  uppehåll_1_N = mkN "uppehåll" neutrum  ; -- uppehåll..nn.1
  uppehålla_1_V = mkV "uppehålla" "uppehöll" "uppehållit" ; -- uppehålla..vb.1
  uppehållande_1_N = mkN "uppehållande" ; -- uppehållande..nn.1
  uppehållsort_1_N = mkN "uppehållsort" "uppehållsorter" ; -- uppehållsort..nn.1
  uppehållstillstånd_1_N = mkN "uppehållstillstånd" neutrum  ; -- uppehållstillstånd..nn.1
  uppehållsväder_1_N = mkN "uppehållsväder" neutrum  ; -- uppehållsväder..nn.1
  uppeldad_1_A = mkA "uppeldad" ; -- uppeldad..av.1
  uppemot_1_Adv = mkAdv "uppemot" ; -- uppemot..ab.1
  uppenbar_1_A = mkA "uppenbar" ; -- uppenbar..av.1
  uppenbara_1_V = mkV "uppenbarar" ; -- uppenbara..vb.1
  uppenbarande_1_N = mkN "uppenbarande" ; -- uppenbarande..nn.1
  uppenbarelse_1_N = mkN "uppenbarelse" "uppenbarelser" ; -- uppenbarelse..nn.1
  uppenbarelsebok_1_N = mkN "uppenbarelsebok" "uppenbarelseböcker" ; -- uppenbarelsebok..nn.1
  uppenbarelsereligion_1_N = mkN "uppenbarelsereligion" ; -- uppenbarelsereligion..nn.1
  uppenbarelsetro_1_N = mkN "uppenbarelsetro" ; -- uppenbarelsetro..nn.1
  uppenbarhet_1_N = mkN "uppenbarhet" ; -- uppenbarhet..nn.1
  uppenbarligen_1_Adv = mkAdv "uppenbarligen" ; -- uppenbarligen..ab.1
  uppepå_1_Adv = mkAdv "uppepå" ; -- uppepå..ab.1
  uppercut_1_N = mkN "uppercut" "uppercuten" "uppercuts" "uppercutsarna" ; -- uppercut..nn.1
  uppesittare_1_N = mkN "uppesittare" utrum  ; -- uppesittare..nn.1
  uppesittarkväll_1_N = mkN "uppesittarkväll" ; -- uppesittarkväll..nn.1
  uppfart_1_N = mkN "uppfart" "uppfarter" ; -- uppfart..nn.1
  uppfartsramp_1_N = mkN "uppfartsramp" "uppfartsramper" ; -- uppfartsramp..nn.1
  uppfartsväg_1_N = mkN "uppfartsväg" ; -- uppfartsväg..nn.1
  uppfatta_1_V = mkV "uppfattar" ; -- uppfatta..vb.1
  uppfattande_1_N = mkN "uppfattande" ; -- uppfattande..nn.1
  uppfattning_1_N = mkN "uppfattning" ; -- uppfattning..nn.1
  uppfattning_2_N = mkN "uppfattning" ; -- uppfattning..nn.2
  uppfattningsförmåga_1_N = mkN "uppfattningsförmåga" ; -- uppfattningsförmåga..nn.1
  uppfinna_1_V = mkV "uppfinna" "uppfann" "uppfunnit" ; -- uppfinna..vb.1
  uppfinnande_1_N = mkN "uppfinnande" ; -- uppfinnande..nn.1
  uppfinnare_1_N = mkN "uppfinnare" utrum  ; -- uppfinnare..nn.1
  uppfinning_1_N = mkN "uppfinning" ; -- uppfinning..nn.1
  uppfinningsförmåga_1_N = mkN "uppfinningsförmåga" ; -- uppfinningsförmåga..nn.1
  uppfinningsrik_1_A = mkA "uppfinningsrik" ; -- uppfinningsrik..av.1
  uppfinningsrikhet_1_N = mkN "uppfinningsrikhet" ; -- uppfinningsrikhet..nn.1
  uppflammande_1_A = mkA "uppflammande" ; -- uppflammande..av.1
  uppflog_1_N = mkN "uppflog" neutrum  ; -- uppflog..nn.1
  uppflugen_1_A = mkA "uppflugen" ; -- uppflugen..av.1
  uppflåg_1_N = mkN "uppflåg" neutrum  ; -- uppflåg..nn.1
  uppfodra_1_V = mkV "uppfodrar" ; -- uppfodra..vb.1
  uppfordra_1_V = mkV "uppfordrar" ; -- uppfordra..vb.1
  uppfordrande_1_N = mkN "uppfordrande" ; -- uppfordrande..nn.1
  uppfordring_1_N = mkN "uppfordring" ; -- uppfordring..nn.1
  uppforsling_1_N = mkN "uppforsling" ; -- uppforsling..nn.1
  uppfostra_1_V = mkV "uppfostrar" ; -- uppfostra..vb.1
  uppfostrande_1_N = mkN "uppfostrande" ; -- uppfostrande..nn.1
  uppfostrare_1_N = mkN "uppfostrare" utrum  ; -- uppfostrare..nn.1
  uppfostring_1_N = mkN "uppfostring" ; -- uppfostring..nn.1
  uppfostringsanstalt_1_N = mkN "uppfostringsanstalt" "uppfostringsanstalter" ; -- uppfostringsanstalt..nn.1
  uppfostringshem_1_N = mkN "uppfostringshem" "uppfostringshemmet" "uppfostringshem" "uppfostringshemmen" ; -- uppfostringshem..nn.1
  uppfriska_1_V = mkV "uppfriskar" ; -- uppfriska..vb.1
  uppfriskande_1_A = mkA "uppfriskande" ; -- uppfriskande..av.1
  uppfriskande_1_N = mkN "uppfriskande" ; -- uppfriskande..nn.1
  uppfriskning_1_N = mkN "uppfriskning" ; -- uppfriskning..nn.1
  uppfylla_1_V = mkV "uppfyller" ; -- uppfylla..vb.1
  uppfyllande_1_N = mkN "uppfyllande" ; -- uppfyllande..nn.1
  uppfyllelse_1_N = mkN "uppfyllelse" utrum  ; -- uppfyllelse..nn.1
  uppfällbar_1_A = mkA "uppfällbar" ; -- uppfällbar..av.1
  uppfällbarhet_1_N = mkN "uppfällbarhet" ; -- uppfällbarhet..nn.1
  uppfälld_1_A = mkA "uppfälld" "uppfällt" ; -- uppfälld..av.1
  uppfånga_1_V = mkV "uppfångar" ; -- uppfånga..vb.1
  uppfångande_1_N = mkN "uppfångande" ; -- uppfångande..nn.1
  uppföda_1_V = mkV "uppföda" "uppfödde" "uppfött" ; -- uppföda..vb.1
  uppfödande_1_N = mkN "uppfödande" ; -- uppfödande..nn.1
  uppfödare_1_N = mkN "uppfödare" utrum  ; -- uppfödare..nn.1
  uppfödning_1_N = mkN "uppfödning" ; -- uppfödning..nn.1
  uppföljande_1_A = mkA "uppföljande" ; -- uppföljande..av.1
  uppföljare_1_N = mkN "uppföljare" utrum  ; -- uppföljare..nn.1
  uppföljning_1_N = mkN "uppföljning" ; -- uppföljning..nn.1
  uppföra_1_V = mkV "uppföra" "uppförde" "uppfört" ; -- uppföra..vb.1
  uppförande_1_N = mkN "uppförande" ; -- uppförande..nn.1
  uppförandekodex_1_N = mkN "uppförandekodex" ; -- uppförandekodex..nn.1
  uppförsbacke_1_N = mkN "uppförsbacke" utrum  ; -- uppförsbacke..nn.1
  uppförstora_1_V = mkV "uppförstorar" ; -- uppförstora..vb.1
  uppförstorande_1_N = mkN "uppförstorande" ; -- uppförstorande..nn.1
  uppförsväg_1_N = mkN "uppförsväg" ; -- uppförsväg..nn.1
  uppge_1_V = mkV "uppgiva" "uppgav" "uppgivit" ; -- uppge..vb.1
  uppgift_1_N = mkN "uppgift" "uppgifter" ; -- uppgift..nn.1
  uppgiftslämnare_1_N = mkN "uppgiftslämnare" utrum  ; -- uppgiftslämnare..nn.1
  uppgivande_1_N = mkN "uppgivande" ; -- uppgivande..nn.1
  uppgivelse_1_N = mkN "uppgivelse" utrum  ; -- uppgivelse..nn.1
  uppgiven_1_A = mkA "uppgiven" ; -- uppgiven..av.1
  uppgivenhet_1_N = mkN "uppgivenhet" "uppgivenheter" ; -- uppgivenhet..nn.1
  uppgjord_1_A = mkA "uppgjord" "uppgjort" ; -- uppgjord..av.1
  uppgradera_1_V = mkV "uppgraderar" ; -- uppgradera..vb.1
  uppgraderande_1_N = mkN "uppgraderande" ; -- uppgraderande..nn.1
  uppgraderbar_1_A = mkA "uppgraderbar" ; -- uppgraderbar..av.1
  uppgraderbarhet_1_N = mkN "uppgraderbarhet" ; -- uppgraderbarhet..nn.1
  uppgradering_1_N = mkN "uppgradering" ; -- uppgradering..nn.1
  uppgrundning_1_N = mkN "uppgrundning" ; -- uppgrundning..nn.1
  uppgrävning_1_N = mkN "uppgrävning" ; -- uppgrävning..nn.1
  uppgummad_1_A = mkA "uppgummad" ; -- uppgummad..av.1
  uppgäld_1_N = mkN "uppgäld" "uppgälder" ; -- uppgäld..nn.1
  uppgå_1_V = mkV "uppgå" "uppgår" "uppgå" "uppgick" "uppgått" "uppgången" ; -- uppgå..vb.1
  uppgående_1_N = mkN "uppgående" ; -- uppgående..nn.1
  uppgång_1_N = mkN "uppgång" ; -- uppgång..nn.1
  uppgångstid_1_N = mkN "uppgångstid" "uppgångstider" ; -- uppgångstid..nn.1
  uppgörelse_1_N = mkN "uppgörelse" "uppgörelser" ; -- uppgörelse..nn.1
  upphalare_1_N = mkN "upphalare" utrum  ; -- upphalare..nn.1
  upphalningsbädd_1_N = mkN "upphalningsbädd" ; -- upphalningsbädd..nn.1
  upphandla_1_V = mkV "upphandlar" ; -- upphandla..vb.1
  upphandlande_1_N = mkN "upphandlande" ; -- upphandlande..nn.1
  upphandlare_1_N = mkN "upphandlare" utrum  ; -- upphandlare..nn.1
  upphandling_1_N = mkN "upphandling" ; -- upphandling..nn.1
  upphaussa_1_V = mkV "upphaussar" ; -- upphaussa..vb.1
  upphaussande_1_N = mkN "upphaussande" ; -- upphaussande..nn.1
  upphetsa_1_V = mkV "upphetsar" ; -- upphetsa..vb.1
  upphetsad_1_A = mkA "upphetsad" ; -- upphetsad..av.1
  upphetsande_1_N = mkN "upphetsande" ; -- upphetsande..nn.1
  upphetsning_1_N = mkN "upphetsning" ; -- upphetsning..nn.1
  upphetta_1_V = mkV "upphettar" ; -- upphetta..vb.1
  upphettande_1_N = mkN "upphettande" ; -- upphettande..nn.1
  upphettning_1_N = mkN "upphettning" ; -- upphettning..nn.1
  upphinnelig_1_A = mkA "upphinnelig" ; -- upphinnelig..av.1
  upphinnelighet_1_N = mkN "upphinnelighet" ; -- upphinnelighet..nn.1
  upphitta_1_V = mkV "upphittar" ; -- upphitta..vb.1
  upphittande_1_N = mkN "upphittande" ; -- upphittande..nn.1
  upphittare_1_N = mkN "upphittare" utrum  ; -- upphittare..nn.1
  upphopp_1_N = mkN "upphopp" neutrum  ; -- upphopp..nn.1
  upphostning_1_N = mkN "upphostning" ; -- upphostning..nn.1
  upphottande_1_N = mkN "upphottande" ; -- upphottande..nn.1
  upphottning_1_N = mkN "upphottning" ; -- upphottning..nn.1
  upphov_1_N = mkN "upphov" neutrum  ; -- upphov..nn.1
  upphovsman_1_N = mkN "upphovsman" "upphovsmannen" "upphovsmän" "upphovsmännen" ; -- upphovsman..nn.1
  upphovsmannarätt_1_N = mkN "upphovsmannarätt" ; -- upphovsmannarätt..nn.1
  upphovsrätt_1_N = mkN "upphovsrätt" ; -- upphovsrätt..nn.1
  upphovsrättsbrott_1_N = mkN "upphovsrättsbrott" neutrum  ; -- upphovsrättsbrott..nn.1
  upphovsrättsinnehavare_1_N = mkN "upphovsrättsinnehavare" utrum  ; -- upphovsrättsinnehavare..nn.1
  upphovsrättsjidder_1_N = mkN "upphovsrättsjidder" neutrum  ; -- upphovsrättsjidder..nn.1
  upphovsrättslig_1_A = mkA "upphovsrättslig" ; -- upphovsrättslig..av.1
  upphovsrättsskyddad_1_A = mkA "upphovsrättsskyddad" ; -- upphovsrättsskyddad..av.1
  upphällning_1_N = mkN "upphällning" ; -- upphällning..nn.1
  upphämta_1_N = mkN "upphämta" ; -- upphämta..nn.1
  upphämta_1_V = mkV "upphämtar" ; -- upphämta..vb.1
  upphämtande_1_N = mkN "upphämtande" ; -- upphämtande..nn.1
  upphämtning_1_N = mkN "upphämtning" ; -- upphämtning..nn.1
  upphängning_1_N = mkN "upphängning" ; -- upphängning..nn.1
  upphängningskrok_1_N = mkN "upphängningskrok" ; -- upphängningskrok..nn.1
  upphängningsögla_1_N = mkN "upphängningsögla" ; -- upphängningsögla..nn.1
  upphäva_1_V = mkV "upphäver" ; -- upphäva..vb.1
  upphäva_2_V = mkV "upphäver" ; -- upphäva..vb.2
  upphävande_1_N = mkN "upphävande" ; -- upphävande..nn.1
  upphöja_1_V = mkV "upphöja" "upphöjde" "upphöjt" ; -- upphöja..vb.1
  upphöjande_1_N = mkN "upphöjande" ; -- upphöjande..nn.1
  upphöjd_1_A = mkA "upphöjd" "upphöjt" ; -- upphöjd..av.1
  upphöjdhet_1_N = mkN "upphöjdhet" "upphöjdheter" ; -- upphöjdhet..nn.1
  upphöjelse_1_N = mkN "upphöjelse" "upphöjelser" ; -- upphöjelse..nn.1
  upphöjning_1_N = mkN "upphöjning" ; -- upphöjning..nn.1
  upphöra_1_V = mkV "upphöra" "upphörde" "upphört" ; -- upphöra..vb.1
  upphörande_1_N = mkN "upphörande" ; -- upphörande..nn.1
  uppifrån_1_Adv = mkAdv "uppifrån" ; -- uppifrån..ab.1
  uppiggande_1_A = mkA "uppiggande" ; -- uppiggande..av.1
  uppiggande_1_N = mkN "uppiggande" ; -- uppiggande..nn.1
  uppimpning_1_N = mkN "uppimpning" ; -- uppimpning..nn.1
  uppiskad_1_A = mkA "uppiskad" ; -- uppiskad..av.1
  uppjagad_1_A = mkA "uppjagad" ; -- uppjagad..av.1
  uppjazza_1_V = mkV "uppjazzar" ; -- uppjazza..vb.1
  uppjazzande_1_N = mkN "uppjazzande" ; -- uppjazzande..nn.1
  uppjustera_1_V = mkV "uppjusterar" ; -- uppjustera..vb.1
  uppjusterande_1_N = mkN "uppjusterande" ; -- uppjusterande..nn.1
  uppjusterbar_1_A = mkA "uppjusterbar" ; -- uppjusterbar..av.1
  uppjusterbarhet_1_N = mkN "uppjusterbarhet" ; -- uppjusterbarhet..nn.1
  uppjustering_1_N = mkN "uppjustering" ; -- uppjustering..nn.1
  uppkalla_1_V = mkV "uppkallar" ; -- uppkalla..vb.1
  uppkallande_1_N = mkN "uppkallande" ; -- uppkallande..nn.1
  uppkammad_1_A = mkA "uppkammad" ; -- uppkammad..av.1
  uppkast_1_N = mkN "uppkast" neutrum  ; -- uppkast..nn.1
  uppkastning_1_N = mkN "uppkastning" ; -- uppkastning..nn.1
  uppkavling_1_N = mkN "uppkavling" ; -- uppkavling..nn.1
  uppklara_1_V = mkV "uppklarar" ; -- uppklara..vb.1
  uppklarande_1_N = mkN "uppklarande" ; -- uppklarande..nn.1
  uppklarning_1_N = mkN "uppklarning" ; -- uppklarning..nn.1
  uppklarningsprocent_1_N = mkN "uppklarningsprocent" "uppklarningsprocenten" "uppklarningsprocent" "uppklarningsprocenten" ; -- uppklarningsprocent..nn.1
  uppklippt_1_A = mkA "uppklippt" "uppklippt" ; -- uppklippt..av.1
  uppklädd_1_A = mkA "uppklädd" ; -- uppklädd..av.1
  uppkläddhet_1_N = mkN "uppkläddhet" ; -- uppkläddhet..nn.1
  uppknuten_1_A = mkA "uppknuten" ; -- uppknuten..av.1
  uppknäppt_1_A = mkA "uppknäppt" "uppknäppt" ; -- uppknäppt..av.1
  uppknäppthet_1_N = mkN "uppknäppthet" ; -- uppknäppthet..nn.1
  uppkok_1_N = mkN "uppkok" neutrum  ; -- uppkok..nn.1
  uppkolning_1_N = mkN "uppkolning" ; -- uppkolning..nn.1
  uppkomling_1_N = mkN "uppkomling" ; -- uppkomling..nn.1
  uppkomlingsbloggare_1_N = mkN "uppkomlingsbloggare" utrum  ; -- uppkomlingsbloggare..nn.1
  uppkomma_1_V = mkV "uppkomma" "uppkom" "uppkommit" ; -- uppkomma..vb.1
  uppkommande_1_N = mkN "uppkommande" ; -- uppkommande..nn.1
  uppkomst_1_N = mkN "uppkomst" ; -- uppkomst..nn.1
  uppkoppling_1_N = mkN "uppkoppling" ; -- uppkoppling..nn.1
  uppkrupen_1_A = mkA "uppkrupen" ; -- uppkrupen..av.1
  uppkvark_1_N = mkN "uppkvark" ; -- uppkvark..nn.1
  uppkvista_1_V = mkV "uppkvistar" ; -- uppkvista..vb.1
  uppkvistande_1_N = mkN "uppkvistande" ; -- uppkvistande..nn.1
  uppkäftig_1_A = mkA "uppkäftig" ; -- uppkäftig..av.1
  uppkäftighet_1_N = mkN "uppkäftighet" "uppkäftigheter" ; -- uppkäftighet..nn.1
  uppköp_1_N = mkN "uppköp" neutrum  ; -- uppköp..nn.1
  uppköpare_1_N = mkN "uppköpare" utrum  ; -- uppköpare..nn.1
  uppkörd_1_A = mkA "uppkörd" "uppkört" ; -- uppkörd..av.1
  uppkördhet_1_N = mkN "uppkördhet" ; -- uppkördhet..nn.1
  uppkörning_1_N = mkN "uppkörning" ; -- uppkörning..nn.1
  uppkörningsramp_1_N = mkN "uppkörningsramp" "uppkörningsramper" ; -- uppkörningsramp..nn.1
  uppkörsväg_1_N = mkN "uppkörsväg" ; -- uppkörsväg..nn.1
  uppladdad_1_A = mkA "uppladdad" ; -- uppladdad..av.1
  uppladdning_1_N = mkN "uppladdning" ; -- uppladdning..nn.1
  uppladdningsbar_1_A = mkA "uppladdningsbar" ; -- uppladdningsbar..av.1
  upplag_1_N = mkN "upplag" neutrum  ; -- upplag..nn.1
  upplaga_1_N = mkN "upplaga" ; -- upplaga..nn.1
  upplagd_1_A = mkA "upplagd" "upplagt" ; -- upplagd..av.1
  upplagemässig_1_A = mkA "upplagemässig" ; -- upplagemässig..av.1
  upplagesiffra_1_N = mkN "upplagesiffra" ; -- upplagesiffra..nn.1
  upplagespiral_1_N = mkN "upplagespiral" ; -- upplagespiral..nn.1
  upplagra_1_V = mkV "upplagrar" ; -- upplagra..vb.1
  upplagrande_1_N = mkN "upplagrande" ; -- upplagrande..nn.1
  upplagringsplats_1_N = mkN "upplagringsplats" "upplagringsplatser" ; -- upplagringsplats..nn.1
  upplagscell_1_N = mkN "upplagscell" "upplagsceller" ; -- upplagscell..nn.1
  upplagsnäring_1_N = mkN "upplagsnäring" ; -- upplagsnäring..nn.1
  upplagsplats_1_N = mkN "upplagsplats" "upplagsplatser" ; -- upplagsplats..nn.1
  uppland_1_N = mkN "uppland" neutrum  ; -- uppland..nn.1
  upplandad_1_A = mkA "upplandad" ; -- upplandad..av.1
  upplandskyrka_1_N = mkN "upplandskyrka" ; -- upplandskyrka..nn.1
  upplappa_1_V = mkV "upplappar" ; -- upplappa..vb.1
  upplappande_1_N = mkN "upplappande" ; -- upplappande..nn.1
  upplega_1_N = mkN "upplega" ; -- upplega..nn.1
  uppletning_1_N = mkN "uppletning" ; -- uppletning..nn.1
  uppleva_1_V = mkV "upplever" ; -- uppleva..vb.1
  upplevande_1_N = mkN "upplevande" ; -- upplevande..nn.1
  upplevelse_1_N = mkN "upplevelse" "upplevelser" ; -- upplevelse..nn.1
  upplevelseläsning_1_N = mkN "upplevelseläsning" ; -- upplevelseläsning..nn.1
  upplevelsemaximering_1_N = mkN "upplevelsemaximering" ; -- upplevelsemaximering..nn.1
  upplevelsemässig_1_A = mkA "upplevelsemässig" ; -- upplevelsemässig..av.1
  upplevelsevandring_1_N = mkN "upplevelsevandring" ; -- upplevelsevandring..nn.1
  upplindning_1_N = mkN "upplindning" ; -- upplindning..nn.1
  uppliva_1_V = mkV "upplivar" ; -- uppliva..vb.1
  upplivande_1_N = mkN "upplivande" ; -- upplivande..nn.1
  upplivning_1_N = mkN "upplivning" ; -- upplivning..nn.1
  upplivningsförsök_1_N = mkN "upplivningsförsök" neutrum  ; -- upplivningsförsök..nn.1
  upplopp_1_N = mkN "upplopp" neutrum  ; -- upplopp..nn.1
  uppluckrad_1_A = mkA "uppluckrad" ; -- uppluckrad..av.1
  uppluckring_1_N = mkN "uppluckring" ; -- uppluckring..nn.1
  upplupen_1_A = mkA "upplupen" ; -- upplupen..av.1
  upplyft_1_A = mkA "upplyft" "upplyft" ; -- upplyft..av.1
  upplyftande_1_A = mkA "upplyftande" ; -- upplyftande..av.1
  upplysa_1_V = mkV "upplyser" ; -- upplysa..vb.1
  upplysande_1_N = mkN "upplysande" ; -- upplysande..nn.1
  upplysning_1_N = mkN "upplysning" ; -- upplysning..nn.1
  upplysningsfilosof_1_N = mkN "upplysningsfilosof" "upplysningsfilosofer" ; -- upplysningsfilosof..nn.1
  upplysningsfilosofi_1_N = mkN "upplysningsfilosofi" "upplysningsfilosofier" ; -- upplysningsfilosofi..nn.1
  upplysningsidé_1_N = mkN "upplysningsidé" "upplysningsidéer" ; -- upplysningsidé..nn.1
  upplysningstid_1_N = mkN "upplysningstid" ; -- upplysningstid..nn.1
  upplysningstidevarv_1_N = mkN "upplysningstidevarv" neutrum  ; -- upplysningstidevarv..nn.1
  upplysningstänkande_1_N = mkN "upplysningstänkande" ; -- upplysningstänkande..nn.1
  upplysningsvis_1_Adv = mkAdv "upplysningsvis" ; -- upplysningsvis..ab.1
  upplyst_1_A = mkA "upplyst" "upplyst" ; -- upplyst..av.1
  upplysthet_1_N = mkN "upplysthet" ; -- upplysthet..nn.1
  upplägg_1_N = mkN "upplägg" neutrum  ; -- upplägg..nn.1
  upplägga_1_V = mkV "upplägga" "uppla" "upplagt" ; -- upplägga..vb.1
  uppläggande_1_N = mkN "uppläggande" ; -- uppläggande..nn.1
  uppläggning_1_N = mkN "uppläggning" ; -- uppläggning..nn.1
  uppländsk_1_A = mkA "uppländsk" ; -- uppländsk..av.1
  uppländska_1_N = mkN "uppländska" ; -- uppländska..nn.1
  uppländska_2_N = mkN "uppländska" ; -- uppländska..nn.2
  upplänning_1_N = mkN "upplänning" ; -- upplänning..nn.1
  upplärd_1_A = mkA "upplärd" "upplärt" ; -- upplärd..av.1
  uppläsa_1_V = mkV "uppläser" ; -- uppläsa..vb.1
  uppläsande_1_N = mkN "uppläsande" ; -- uppläsande..nn.1
  uppläsare_1_N = mkN "uppläsare" utrum  ; -- uppläsare..nn.1
  uppläsning_1_N = mkN "uppläsning" ; -- uppläsning..nn.1
  uppläxning_1_N = mkN "uppläxning" ; -- uppläxning..nn.1
  upplåning_1_N = mkN "upplåning" ; -- upplåning..nn.1
  upplåta_1_V = mkV "upplåta" "upplät" "upplåtit" ; -- upplåta..vb.1
  upplåtande_1_N = mkN "upplåtande" ; -- upplåtande..nn.1
  upplåtelse_1_N = mkN "upplåtelse" "upplåtelser" ; -- upplåtelse..nn.1
  upplöjd_1_A = mkA "upplöjd" "upplöjt" ; -- upplöjd..av.1
  upplösa_1_V = mkV "upplöser" ; -- upplösa..vb.1
  upplösande_1_N = mkN "upplösande" ; -- upplösande..nn.1
  upplöslig_1_A = mkA "upplöslig" ; -- upplöslig..av.1
  upplösning_1_N = mkN "upplösning" ; -- upplösning..nn.1
  upplösningsförmåga_1_N = mkN "upplösningsförmåga" ; -- upplösningsförmåga..nn.1
  upplösningsmedel_1_N = mkN "upplösningsmedel" neutrum  ; -- upplösningsmedel..nn.1
  upplösningsprocess_1_N = mkN "upplösningsprocess" "upplösningsprocesser" ; -- upplösningsprocess..nn.1
  upplöst_1_A = mkA "upplöst" "upplöst" ; -- upplöst..av.1
  uppmana_1_V = mkV "uppmanar" ; -- uppmana..vb.1
  uppmanande_1_N = mkN "uppmanande" ; -- uppmanande..nn.1
  uppmaning_1_N = mkN "uppmaning" ; -- uppmaning..nn.1
  uppmaningssats_1_N = mkN "uppmaningssats" "uppmaningssatser" ; -- uppmaningssats..nn.1
  uppmarsch_1_N = mkN "uppmarsch" "uppmarscher" ; -- uppmarsch..nn.1
  uppmarschområde_1_N = mkN "uppmarschområde" ; -- uppmarschområde..nn.1
  uppmjuka_1_V = mkV "uppmjukar" ; -- uppmjuka..vb.1
  uppmjukande_1_N = mkN "uppmjukande" ; -- uppmjukande..nn.1
  uppmjukning_1_N = mkN "uppmjukning" ; -- uppmjukning..nn.1
  uppmjukningspolitik_1_N = mkN "uppmjukningspolitik" ; -- uppmjukningspolitik..nn.1
  uppmuddra_1_V = mkV "uppmuddrar" ; -- uppmuddra..vb.1
  uppmuddrande_1_N = mkN "uppmuddrande" ; -- uppmuddrande..nn.1
  uppmuntra_1_V = mkV "uppmuntrar" ; -- uppmuntra..vb.1
  uppmuntran_1_N = mkN "uppmuntran" "uppmuntran" "uppmuntringar" "uppmuntringarna" ; -- uppmuntran..nn.1
  uppmuntrande_1_N = mkN "uppmuntrande" ; -- uppmuntrande..nn.1
  uppmuntring_1_N = mkN "uppmuntring" ; -- uppmuntring..nn.1
  uppmärksam_1_A = mkA "uppmärksam" "uppmärksamt" "uppmärksamma" "uppmärksamma" "uppmärksammare" "uppmärksammast" "uppmärksammaste" ; -- uppmärksam..av.1
  uppmärksamhet_1_N = mkN "uppmärksamhet" "uppmärksamheter" ; -- uppmärksamhet..nn.1
  uppmärksamhetsfält_1_N = mkN "uppmärksamhetsfält" neutrum  ; -- uppmärksamhetsfält..nn.1
  uppmärksamhetsförmåga_1_N = mkN "uppmärksamhetsförmåga" ; -- uppmärksamhetsförmåga..nn.1
  uppmärksamhetskåt_1_A = mkA "uppmärksamhetskåt" ; -- uppmärksamhetskåt..av.1
  uppmärksamhetspåkallare_1_N = mkN "uppmärksamhetspåkallare" utrum  ; -- uppmärksamhetspåkallare..nn.1
  uppmärksamhetsspann_1_N = mkN "uppmärksamhetsspann" neutrum  ; -- uppmärksamhetsspann..nn.1
  uppmärksamhetsvärde_1_N = mkN "uppmärksamhetsvärde" ; -- uppmärksamhetsvärde..nn.1
  uppmärksamma_1_V = mkV "uppmärksammar" ; -- uppmärksamma..vb.1
  uppmärksammad_1_A = mkA "uppmärksammad" ; -- uppmärksammad..av.1
  uppmärksammande_1_N = mkN "uppmärksammande" ; -- uppmärksammande..nn.1
  uppmäta_1_V = mkV "uppmäter" ; -- uppmäta..vb.1
  uppmätande_1_N = mkN "uppmätande" ; -- uppmätande..nn.1
  uppmätning_1_N = mkN "uppmätning" ; -- uppmätning..nn.1
  uppmålad_1_A = mkA "uppmålad" ; -- uppmålad..av.1
  uppnosig_1_A = mkA "uppnosig" ; -- uppnosig..av.1
  uppnosighet_1_N = mkN "uppnosighet" ; -- uppnosighet..nn.1
  uppnystande_1_N = mkN "uppnystande" ; -- uppnystande..nn.1
  uppnäsa_1_N = mkN "uppnäsa" ; -- uppnäsa..nn.1
  uppnäst_1_A = mkA "uppnäst" "uppnäst" ; -- uppnäst..av.1
  uppnästhet_1_N = mkN "uppnästhet" ; -- uppnästhet..nn.1
  uppnå_1_V = mkV "uppnår" ; -- uppnå..vb.1
  uppnåelig_1_A = mkA "uppnåelig" ; -- uppnåelig..av.1
  uppnåelighet_1_N = mkN "uppnåelighet" ; -- uppnåelighet..nn.1
  uppnående_1_N = mkN "uppnående" ; -- uppnående..nn.1
  uppnåla_1_V = mkV "uppnålar" ; -- uppnåla..vb.1
  uppnålande_1_N = mkN "uppnålande" ; -- uppnålande..nn.1
  uppochnedvänd_1_A = mkA "uppochnedvänd" ; -- uppochnedvänd..av.1
  uppochnedvändhet_1_N = mkN "uppochnedvändhet" ; -- uppochnedvändhet..nn.1
  uppochnervänd_1_A = mkA "uppochnervänd" ; -- uppochnervänd..av.1
  uppochnervändhet_1_N = mkN "uppochnervändhet" ; -- uppochnervändhet..nn.1
  uppodla_1_V = mkV "uppodlar" ; -- uppodla..vb.1
  uppodlande_1_N = mkN "uppodlande" ; -- uppodlande..nn.1
  uppoffra_1_V = mkV "uppoffrar" ; -- uppoffra..vb.1
  uppoffrande_1_A = mkA "uppoffrande" ; -- uppoffrande..av.1
  uppoffrande_1_N = mkN "uppoffrande" ; -- uppoffrande..nn.1
  uppoffring_1_N = mkN "uppoffring" ; -- uppoffring..nn.1
  upprabbling_1_N = mkN "upprabbling" ; -- upprabbling..nn.1
  upprada_1_V = mkV "uppradar" ; -- upprada..vb.1
  uppradande_1_N = mkN "uppradande" ; -- uppradande..nn.1
  uppreklamera_1_V = mkV "uppreklamerar" ; -- uppreklamera..vb.1
  uppreklamerande_1_N = mkN "uppreklamerande" ; -- uppreklamerande..nn.1
  uppreklamerbar_1_A = mkA "uppreklamerbar" ; -- uppreklamerbar..av.1
  uppreklamerbarhet_1_N = mkN "uppreklamerbarhet" ; -- uppreklamerbarhet..nn.1
  uppreklamering_1_N = mkN "uppreklamering" ; -- uppreklamering..nn.1
  upprensa_1_V = mkV "upprensar" ; -- upprensa..vb.1
  upprensande_1_N = mkN "upprensande" ; -- upprensande..nn.1
  upprensning_1_N = mkN "upprensning" ; -- upprensning..nn.1
  upprepa_1_V = mkV "upprepar" ; -- upprepa..vb.1
  upprepad_1_A = mkA "upprepad" ; -- upprepad..av.1
  upprepande_1_N = mkN "upprepande" ; -- upprepande..nn.1
  upprepning_1_N = mkN "upprepning" ; -- upprepning..nn.1
  upprepningsmönster_1_N = mkN "upprepningsmönster" neutrum  ; -- upprepningsmönster..nn.1
  uppresa_1_V = mkV "uppreser" ; -- uppresa..vb.1
  uppresande_1_N = mkN "uppresande" ; -- uppresande..nn.1
  uppresning_1_N = mkN "uppresning" ; -- uppresning..nn.1
  uppretad_1_A = mkA "uppretad" ; -- uppretad..av.1
  uppretning_1_N = mkN "uppretning" ; -- uppretning..nn.1
  uppriktig_1_A = mkA "uppriktig" ; -- uppriktig..av.1
  uppriktighet_1_N = mkN "uppriktighet" "uppriktigheter" ; -- uppriktighet..nn.1
  uppringd_1_A = mkA "uppringd" "uppringt" ; -- uppringd..av.1
  uppringning_1_N = mkN "uppringning" ; -- uppringning..nn.1
  upprinnelse_1_N = mkN "upprinnelse" "upprinnelser" ; -- upprinnelse..nn.1
  upprinning_1_N = mkN "upprinning" ; -- upprinning..nn.1
  uppritning_1_N = mkN "uppritning" ; -- uppritning..nn.1
  uppriva_1_V = mkV "uppriva" "upprev" "upprivit" ; -- uppriva..vb.1
  upprivande_1_A = mkA "upprivande" ; -- upprivande..av.1
  upprivande_1_N = mkN "upprivande" ; -- upprivande..nn.1
  uppriven_1_A = mkA "uppriven" ; -- uppriven..av.1
  upprivning_1_N = mkN "upprivning" ; -- upprivning..nn.1
  upprop_1_N = mkN "upprop" neutrum  ; -- upprop..nn.1
  uppropslista_1_N = mkN "uppropslista" ; -- uppropslista..nn.1
  uppror_1_N = mkN "uppror" neutrum  ; -- uppror..nn.1
  upprorisk_1_A = mkA "upprorisk" ; -- upprorisk..av.1
  upprorsanda_1_N = mkN "upprorsanda" ; -- upprorsanda..nn.1
  upprorsfana_1_N = mkN "upprorsfana" ; -- upprorsfana..nn.1
  upprorsförsök_1_N = mkN "upprorsförsök" neutrum  ; -- upprorsförsök..nn.1
  upprorshärd_1_N = mkN "upprorshärd" ; -- upprorshärd..nn.1
  upprorsmakare_1_N = mkN "upprorsmakare" utrum  ; -- upprorsmakare..nn.1
  upprorsman_1_N = mkN "upprorsman" "upprorsmannen" "upprorsmän" "upprorsmännen" ; -- upprorsman..nn.1
  upprorsstiftare_1_N = mkN "upprorsstiftare" utrum  ; -- upprorsstiftare..nn.1
  upprullande_1_N = mkN "upprullande" ; -- upprullande..nn.1
  upprullning_1_N = mkN "upprullning" ; -- upprullning..nn.1
  upprusta_1_V = mkV "upprustar" ; -- upprusta..vb.1
  upprustande_1_N = mkN "upprustande" ; -- upprustande..nn.1
  upprustning_1_N = mkN "upprustning" ; -- upprustning..nn.1
  upprutten_1_A = mkA "upprutten" ; -- upprutten..av.1
  uppryckande_1_A = mkA "uppryckande" ; -- uppryckande..av.1
  uppryckning_1_N = mkN "uppryckning" ; -- uppryckning..nn.1
  upprymd_1_A = mkA "upprymd" "upprymt" ; -- upprymd..av.1
  upprymdhet_1_N = mkN "upprymdhet" ; -- upprymdhet..nn.1
  upprymma_1_V = mkV "upprymmer" ; -- upprymma..vb.1
  upprymmande_1_N = mkN "upprymmande" ; -- upprymmande..nn.1
  upprymmare_1_N = mkN "upprymmare" utrum  ; -- upprymmare..nn.1
  upprymningsstål_1_N = mkN "upprymningsstål" neutrum  ; -- upprymningsstål..nn.1
  uppräkna_1_V = mkV "uppräknar" ; -- uppräkna..vb.1
  uppräknande_1_N = mkN "uppräknande" ; -- uppräknande..nn.1
  uppräkning_1_N = mkN "uppräkning" ; -- uppräkning..nn.1
  uppränna_1_V = mkV "uppränna" "upprände" "uppränt" ; -- uppränna..vb.1
  upprännande_1_N = mkN "upprännande" ; -- upprännande..nn.1
  uppränning_1_N = mkN "uppränning" ; -- uppränning..nn.1
  upprätt_1_A = mkA "upprätt" ; -- upprätt..av.1
  upprätta_1_V = mkV "upprättar" ; -- upprätta..vb.1
  upprättad_1_A = mkA "upprättad" ; -- upprättad..av.1
  upprättande_1_N = mkN "upprättande" ; -- upprättande..nn.1
  upprättare_1_N = mkN "upprättare" utrum  ; -- upprättare..nn.1
  upprättelse_1_N = mkN "upprättelse" "upprättelser" ; -- upprättelse..nn.1
  upprätthålla_1_V = mkV "upprätthålla" "upprätthöll" "upprätthållit" ; -- upprätthålla..vb.1
  upprätthållande_1_N = mkN "upprätthållande" ; -- upprätthållande..nn.1
  upprätthållare_1_N = mkN "upprätthållare" utrum  ; -- upprätthållare..nn.1
  upprättstående_1_A = mkA "upprättstående" ; -- upprättstående..av.1
  uppröjning_1_N = mkN "uppröjning" ; -- uppröjning..nn.1
  uppröra_1_V = mkV "uppröra" "upprörde" "upprört" ; -- uppröra..vb.1
  upprörande_1_A = mkA "upprörande" ; -- upprörande..av.1
  upprörande_1_N = mkN "upprörande" ; -- upprörande..nn.1
  upprörd_1_A = mkA "upprörd" "upprört" ; -- upprörd..av.1
  upprördhet_1_N = mkN "upprördhet" ; -- upprördhet..nn.1
  uppsagd_1_A = mkA "uppsagd" "uppsagt" ; -- uppsagd..av.1
  uppsalabo_1_N = mkN "uppsalabo" "uppsalabor" ; -- uppsalabo..nn.1
  uppsamla_1_V = mkV "uppsamlar" ; -- uppsamla..vb.1
  uppsamlande_1_N = mkN "uppsamlande" ; -- uppsamlande..nn.1
  uppsamlare_1_N = mkN "uppsamlare" utrum  ; -- uppsamlare..nn.1
  uppsamling_1_N = mkN "uppsamling" ; -- uppsamling..nn.1
  uppsamlingsborste_1_N = mkN "uppsamlingsborste" utrum  ; -- uppsamlingsborste..nn.1
  uppsamlingskasse_1_N = mkN "uppsamlingskasse" utrum  ; -- uppsamlingskasse..nn.1
  uppsamlingsläger_1_N = mkN "uppsamlingsläger" neutrum  ; -- uppsamlingsläger..nn.1
  uppsamlingssäck_1_N = mkN "uppsamlingssäck" ; -- uppsamlingssäck..nn.1
  uppsats_1_N = mkN "uppsats" "uppsatser" ; -- uppsats..nn.1
  uppsatslag_1_N = mkN "uppsatslag" neutrum  ; -- uppsatslag..nn.1
  uppsatstitel_1_N = mkN "uppsatstitel" ; -- uppsatstitel..nn.1
  uppsatsämne_1_N = mkN "uppsatsämne" ; -- uppsatsämne..nn.1
  uppsatt_1_A = mkA "uppsatt" ; -- uppsatt..av.1
  uppseende_1_N = mkN "uppseende" ; -- uppseende..nn.1
  uppseendeväckande_1_A = mkA "uppseendeväckande" ; -- uppseendeväckande..av.1
  uppsikt_1_N = mkN "uppsikt" ; -- uppsikt..nn.1
  uppsittare_1_N = mkN "uppsittare" utrum  ; -- uppsittare..nn.1
  uppsittarkväll_1_N = mkN "uppsittarkväll" ; -- uppsittarkväll..nn.1
  uppsittning_1_N = mkN "uppsittning" ; -- uppsittning..nn.1
  uppsjungning_1_N = mkN "uppsjungning" ; -- uppsjungning..nn.1
  uppsjö_1_N = mkN "uppsjö" ; -- uppsjö..nn.1
  uppskakad_1_A = mkA "uppskakad" ; -- uppskakad..av.1
  uppskakande_1_A = mkA "uppskakande" ; -- uppskakande..av.1
  uppskalning_1_N = mkN "uppskalning" ; -- uppskalning..nn.1
  uppskalningsmöjlighet_1_N = mkN "uppskalningsmöjlighet" "uppskalningsmöjligheter" ; -- uppskalningsmöjlighet..nn.1
  uppskatta_1_V = mkV "uppskattar" ; -- uppskatta..vb.1
  uppskattande_1_N = mkN "uppskattande" ; -- uppskattande..nn.1
  uppskattning_1_N = mkN "uppskattning" ; -- uppskattning..nn.1
  uppskattningsvis_1_Adv = mkAdv "uppskattningsvis" ; -- uppskattningsvis..ab.1
  uppskjut_1_N = mkN "uppskjut" neutrum  ; -- uppskjut..nn.1
  uppskjuta_1_V = mkV "uppskjuta" "uppsköt" "uppskjutit" ; -- uppskjuta..vb.1
  uppskjutande_1_N = mkN "uppskjutande" ; -- uppskjutande..nn.1
  uppskjutning_1_N = mkN "uppskjutning" ; -- uppskjutning..nn.1
  uppskojad_1_A = mkA "uppskojad" ; -- uppskojad..av.1
  uppskov_1_N = mkN "uppskov" neutrum  ; -- uppskov..nn.1
  uppskovsränta_1_N = mkN "uppskovsränta" ; -- uppskovsränta..nn.1
  uppskrivning_1_N = mkN "uppskrivning" ; -- uppskrivning..nn.1
  uppskruvad_1_A = mkA "uppskruvad" ; -- uppskruvad..av.1
  uppskrämd_1_A = mkA "uppskrämd" "uppskrämt" ; -- uppskrämd..av.1
  uppskrämdhet_1_N = mkN "uppskrämdhet" ; -- uppskrämdhet..nn.1
  uppskrämning_1_N = mkN "uppskrämning" ; -- uppskrämning..nn.1
  uppskärare_1_N = mkN "uppskärare" utrum  ; -- uppskärare..nn.1
  uppskärrad_1_A = mkA "uppskärrad" ; -- uppskärrad..av.1
  uppskörtad_1_A = mkA "uppskörtad" ; -- uppskörtad..av.1
  uppslag_1_N = mkN "uppslag" neutrum  ; -- uppslag..nn.1
  uppslagen_1_A = mkA "uppslagen" ; -- uppslagen..av.1
  uppslagning_1_N = mkN "uppslagning" ; -- uppslagning..nn.1
  uppslagning_2_N = mkN "uppslagning" ; -- uppslagning..nn.2
  uppslagsbok_1_N = mkN "uppslagsbok" "uppslagsböcker" ; -- uppslagsbok..nn.1
  uppslagsform_1_N = mkN "uppslagsform" "uppslagsformer" ; -- uppslagsform..nn.1
  uppslagsord_1_N = mkN "uppslagsord" neutrum  ; -- uppslagsord..nn.1
  uppslagsrik_1_A = mkA "uppslagsrik" ; -- uppslagsrik..av.1
  uppslagsrikhet_1_N = mkN "uppslagsrikhet" ; -- uppslagsrikhet..nn.1
  uppslagssikte_1_N = mkN "uppslagssikte" ; -- uppslagssikte..nn.1
  uppslagsverk_1_N = mkN "uppslagsverk" neutrum  ; -- uppslagsverk..nn.1
  uppslagsända_1_N = mkN "uppslagsända" ; -- uppslagsända..nn.1
  uppslagsände_1_N = mkN "uppslagsände" utrum  ; -- uppslagsände..nn.1
  uppslaktad_1_A = mkA "uppslaktad" ; -- uppslaktad..av.1
  uppslamma_1_V = mkV "uppslammar" ; -- uppslamma..vb.1
  uppslammad_1_A = mkA "uppslammad" ; -- uppslammad..av.1
  uppslammande_1_N = mkN "uppslammande" ; -- uppslammande..nn.1
  uppslitande_1_A = mkA "uppslitande" ; -- uppslitande..av.1
  uppslitsad_1_A = mkA "uppslitsad" ; -- uppslitsad..av.1
  uppsluka_1_V = mkV "uppslukar" ; -- uppsluka..vb.1
  uppslukande_1_N = mkN "uppslukande" ; -- uppslukande..nn.1
  uppslukning_1_N = mkN "uppslukning" ; -- uppslukning..nn.1
  uppsluppen_1_A = mkA "uppsluppen" ; -- uppsluppen..av.1
  uppsluppenhet_1_N = mkN "uppsluppenhet" ; -- uppsluppenhet..nn.1
  uppslutning_1_N = mkN "uppslutning" ; -- uppslutning..nn.1
  uppsnabba_1_V = mkV "uppsnabbar" ; -- uppsnabba..vb.1
  uppsnabbande_1_N = mkN "uppsnabbande" ; -- uppsnabbande..nn.1
  uppsnappa_1_V = mkV "uppsnappar" ; -- uppsnappa..vb.1
  uppsnappande_1_N = mkN "uppsnappande" ; -- uppsnappande..nn.1
  uppspaltning_1_N = mkN "uppspaltning" ; -- uppspaltning..nn.1
  uppspel_1_N = mkN "uppspel" "uppspelet" "uppspel" "uppspelen" ; -- uppspel..nn.1
  uppspelning_1_N = mkN "uppspelning" ; -- uppspelning..nn.1
  uppspelt_1_A = mkA "uppspelt" "uppspelt" ; -- uppspelt..av.1
  uppspelthet_1_N = mkN "uppspelthet" ; -- uppspelthet..nn.1
  uppspetad_1_A = mkA "uppspetad" ; -- uppspetad..av.1
  uppspikning_1_N = mkN "uppspikning" ; -- uppspikning..nn.1
  uppspjälka_1_V = mkV "uppspjälkar" ; -- uppspjälka..vb.1
  uppspjälkande_1_N = mkN "uppspjälkande" ; -- uppspjälkande..nn.1
  uppsplittring_1_N = mkN "uppsplittring" ; -- uppsplittring..nn.1
  uppspricka_1_V = mkV "uppspricka" "uppsprack" "uppspruckit" ; -- uppspricka..vb.1
  uppsprickande_1_N = mkN "uppsprickande" ; -- uppsprickande..nn.1
  uppsprång_1_N = mkN "uppsprång" neutrum  ; -- uppsprång..nn.1
  uppspädning_1_N = mkN "uppspädning" ; -- uppspädning..nn.1
  uppspänning_1_N = mkN "uppspänning" ; -- uppspänning..nn.1
  uppspärrad_1_A = mkA "uppspärrad" ; -- uppspärrad..av.1
  uppspärrning_1_N = mkN "uppspärrning" ; -- uppspärrning..nn.1
  uppspåra_1_V = mkV "uppspårar" ; -- uppspåra..vb.1
  uppspårande_1_N = mkN "uppspårande" ; -- uppspårande..nn.1
  uppstad_1_N = mkN "uppstad" "uppstäder" ; -- uppstad..nn.1
  uppstaplad_1_A = mkA "uppstaplad" ; -- uppstaplad..av.1
  uppstart_1_N = mkN "uppstart" "uppstarter" ; -- uppstart..nn.1
  uppstartsproblem_1_N = mkN "uppstartsproblem" neutrum  ; -- uppstartsproblem..nn.1
  uppstickarbank_1_N = mkN "uppstickarbank" "uppstickarbanker" ; -- uppstickarbank..nn.1
  uppstickarbolag_1_N = mkN "uppstickarbolag" neutrum  ; -- uppstickarbolag..nn.1
  uppstickare_1_N = mkN "uppstickare" utrum  ; -- uppstickare..nn.1
  uppstiga_1_V = mkV "uppstiga" "uppsteg" "uppstigit" ; -- uppstiga..vb.1
  uppstigande_1_N = mkN "uppstigande" ; -- uppstigande..nn.1
  uppstigning_1_N = mkN "uppstigning" ; -- uppstigning..nn.1
  uppstoppad_1_A = mkA "uppstoppad" ; -- uppstoppad..av.1
  uppstoppning_1_N = mkN "uppstoppning" ; -- uppstoppning..nn.1
  uppstrama_1_V = mkV "uppstramar" ; -- uppstrama..vb.1
  uppstramande_1_N = mkN "uppstramande" ; -- uppstramande..nn.1
  uppstramning_1_N = mkN "uppstramning" ; -- uppstramning..nn.1
  uppstressad_1_A = mkA "uppstressad" ; -- uppstressad..av.1
  uppsträckning_1_N = mkN "uppsträckning" ; -- uppsträckning..nn.1
  uppsträckt_1_A = mkA "uppsträckt" "uppsträckt" ; -- uppsträckt..av.1
  uppsträckthet_1_N = mkN "uppsträckthet" ; -- uppsträckthet..nn.1
  uppstråk_1_N = mkN "uppstråk" neutrum  ; -- uppstråk..nn.1
  uppström_1_N = mkN "uppström" "uppströmmen" "uppströmmar" "uppströmmarna" ; -- uppström..nn.1
  uppstudsig_1_A = mkA "uppstudsig" ; -- uppstudsig..av.1
  uppstudsighet_1_N = mkN "uppstudsighet" ; -- uppstudsighet..nn.1
  uppstyltad_1_A = mkA "uppstyltad" ; -- uppstyltad..av.1
  uppställa_1_V = mkV "uppställer" ; -- uppställa..vb.1
  uppställande_1_N = mkN "uppställande" ; -- uppställande..nn.1
  uppställning_1_N = mkN "uppställning" ; -- uppställning..nn.1
  uppställningsplats_1_N = mkN "uppställningsplats" "uppställningsplatser" ; -- uppställningsplats..nn.1
  uppställningssignal_1_N = mkN "uppställningssignal" "uppställningssignaler" ; -- uppställningssignal..nn.1
  uppställningsspår_1_N = mkN "uppställningsspår" neutrum  ; -- uppställningsspår..nn.1
  uppstämma_1_V = mkV "uppstämmer" ; -- uppstämma..vb.1
  uppstämmande_1_N = mkN "uppstämmande" ; -- uppstämmande..nn.1
  uppstå_1_V = mkV "uppstå" "uppstår" "uppstå" "uppstod" "uppstått" "uppstånden" ; -- uppstå..vb.1
  uppstående_1_A = mkA "uppstående" ; -- uppstående..av.1
  uppstående_1_N = mkN "uppstående" ; -- uppstående..nn.1
  uppståndelse_1_N = mkN "uppståndelse" utrum  ; -- uppståndelse..nn.1
  uppstånden_1_A = mkA "uppstånden" ; -- uppstånden..av.1
  uppstötning_1_N = mkN "uppstötning" ; -- uppstötning..nn.1
  uppsuga_1_V = mkV "uppsuga" "uppsög" "uppsugit" ; -- uppsuga..vb.1
  uppsugande_1_N = mkN "uppsugande" ; -- uppsugande..nn.1
  uppsugning_1_N = mkN "uppsugning" ; -- uppsugning..nn.1
  uppsugningsförmåga_1_N = mkN "uppsugningsförmåga" ; -- uppsugningsförmåga..nn.1
  uppsummera_1_V = mkV "uppsummerar" ; -- uppsummera..vb.1
  uppsummerande_1_N = mkN "uppsummerande" ; -- uppsummerande..nn.1
  uppsummerbar_1_A = mkA "uppsummerbar" ; -- uppsummerbar..av.1
  uppsummerbarhet_1_N = mkN "uppsummerbarhet" ; -- uppsummerbarhet..nn.1
  uppsummering_1_N = mkN "uppsummering" ; -- uppsummering..nn.1
  uppsutten_1_A = mkA "uppsutten" ; -- uppsutten..av.1
  uppsvallning_1_N = mkN "uppsvallning" ; -- uppsvallning..nn.1
  uppsvensk_1_A = mkA "uppsvensk" ; -- uppsvensk..av.1
  uppsvenska_1_N = mkN "uppsvenska" ; -- uppsvenska..nn.1
  uppsving_1_N = mkN "uppsving" neutrum  ; -- uppsving..nn.1
  uppsvullen_1_A = mkA "uppsvullen" ; -- uppsvullen..av.1
  uppsvälld_1_A = mkA "uppsvälld" "uppsvällt" ; -- uppsvälld..av.1
  uppsvälldhet_1_N = mkN "uppsvälldhet" ; -- uppsvälldhet..nn.1
  uppsvällning_1_N = mkN "uppsvällning" ; -- uppsvällning..nn.1
  uppsyn_1_N = mkN "uppsyn" "uppsyner" ; -- uppsyn..nn.1
  uppsyningsman_1_N = mkN "uppsyningsman" "uppsyningsmannen" "uppsyningsmän" "uppsyningsmännen" ; -- uppsyningsman..nn.1
  uppsägbar_1_A = mkA "uppsägbar" ; -- uppsägbar..av.1
  uppsägbarhet_1_N = mkN "uppsägbarhet" ; -- uppsägbarhet..nn.1
  uppsägelse_1_N = mkN "uppsägelse" "uppsägelser" ; -- uppsägelse..nn.1
  uppsägning_1_N = mkN "uppsägning" ; -- uppsägning..nn.1
  uppsägningslån_1_N = mkN "uppsägningslån" neutrum  ; -- uppsägningslån..nn.1
  uppsägningsräkning_1_N = mkN "uppsägningsräkning" ; -- uppsägningsräkning..nn.1
  uppsägningstermin_1_N = mkN "uppsägningstermin" "uppsägningsterminer" ; -- uppsägningstermin..nn.1
  uppsägningstid_1_N = mkN "uppsägningstid" "uppsägningstider" ; -- uppsägningstid..nn.1
  uppsändning_1_N = mkN "uppsändning" ; -- uppsändning..nn.1
  uppsätta_1_V = mkV "uppsätta" "uppsätter" "uppsätt" "uppsatte" "uppsatt" "uppsatt" ; -- uppsätta..vb.1
  uppsättande_1_N = mkN "uppsättande" ; -- uppsättande..nn.1
  uppsättare_1_N = mkN "uppsättare" utrum  ; -- uppsättare..nn.1
  uppsättning_1_N = mkN "uppsättning" ; -- uppsättning..nn.1
  uppsättningsinstrument_1_N = mkN "uppsättningsinstrument" neutrum  ; -- uppsättningsinstrument..nn.1
  uppsättningsmål_1_N = mkN "uppsättningsmål" neutrum  ; -- uppsättningsmål..nn.1
  uppsåt_1_N = mkN "uppsåt" neutrum  ; -- uppsåt..nn.1
  uppsåtlig_1_A = mkA "uppsåtlig" ; -- uppsåtlig..av.1
  uppsåtligen_1_Adv = mkAdv "uppsåtligen" ; -- uppsåtligen..ab.1
  uppsåtlighet_1_N = mkN "uppsåtlighet" ; -- uppsåtlighet..nn.1
  uppsåtsbrott_1_N = mkN "uppsåtsbrott" neutrum  ; -- uppsåtsbrott..nn.1
  uppsöka_1_V = mkV "uppsöker" ; -- uppsöka..vb.1
  uppsökande_1_A = mkA "uppsökande" ; -- uppsökande..av.1
  uppsökande_1_N = mkN "uppsökande" ; -- uppsökande..nn.1
  uppsökning_1_N = mkN "uppsökning" ; -- uppsökning..nn.1
  uppta_1_V = mkV "upptaga" "upptog" "upptagit" ; -- uppta..vb.1
  upptag_1_N = mkN "upptag" neutrum  ; -- upptag..nn.1
  upptagande_1_N = mkN "upptagande" ; -- upptagande..nn.1
  upptagen_1_A = mkA "upptagen" ; -- upptagen..av.1
  upptagen_2_A = mkA "upptagen" ; -- upptagen..av.2
  upptagenhet_1_N = mkN "upptagenhet" "upptagenheter" ; -- upptagenhet..nn.1
  upptagning_1_N = mkN "upptagning" ; -- upptagning..nn.1
  upptagningsceremoni_1_N = mkN "upptagningsceremoni" "upptagningsceremonier" ; -- upptagningsceremoni..nn.1
  upptagningshem_1_N = mkN "upptagningshem" "upptagningshemmet" "upptagningshem" "upptagningshemmen" ; -- upptagningshem..nn.1
  upptagningsområde_1_N = mkN "upptagningsområde" ; -- upptagningsområde..nn.1
  upptakt_1_N = mkN "upptakt" "upptakter" ; -- upptakt..nn.1
  upptaxera_1_V = mkV "upptaxerar" ; -- upptaxera..vb.1
  upptaxerande_1_N = mkN "upptaxerande" ; -- upptaxerande..nn.1
  upptaxerbar_1_A = mkA "upptaxerbar" ; -- upptaxerbar..av.1
  upptaxerbarhet_1_N = mkN "upptaxerbarhet" ; -- upptaxerbarhet..nn.1
  upptaxering_1_N = mkN "upptaxering" ; -- upptaxering..nn.1
  uppteckna_1_V = mkV "upptecknar" ; -- uppteckna..vb.1
  upptecknande_1_N = mkN "upptecknande" ; -- upptecknande..nn.1
  upptecknare_1_N = mkN "upptecknare" utrum  ; -- upptecknare..nn.1
  uppteckning_1_N = mkN "uppteckning" ; -- uppteckning..nn.1
  upptill_1_Adv = mkAdv "upptill" ; -- upptill..ab.1
  upptining_1_N = mkN "upptining" ; -- upptining..nn.1
  upptorkning_1_N = mkN "upptorkning" ; -- upptorkning..nn.1
  upptorna_1_V = mkV "upptornar" ; -- upptorna..vb.1
  upptornande_1_N = mkN "upptornande" ; -- upptornande..nn.1
  upptrampa_1_V = mkV "upptrampar" ; -- upptrampa..vb.1
  upptrampad_1_A = mkA "upptrampad" ; -- upptrampad..av.1
  upptrampande_1_N = mkN "upptrampande" ; -- upptrampande..nn.1
  upptrampning_1_N = mkN "upptrampning" ; -- upptrampning..nn.1
  upptrappa_1_V = mkV "upptrappar" ; -- upptrappa..vb.1
  upptrappande_1_N = mkN "upptrappande" ; -- upptrappande..nn.1
  upptrappning_1_N = mkN "upptrappning" ; -- upptrappning..nn.1
  upptrissa_1_V = mkV "upptrissar" ; -- upptrissa..vb.1
  upptrissande_1_N = mkN "upptrissande" ; -- upptrissande..nn.1
  upptryck_1_N = mkN "upptryck" neutrum  ; -- upptryck..nn.1
  upptryckning_1_N = mkN "upptryckning" ; -- upptryckning..nn.1
  uppträda_1_V = mkV "uppträda" "uppträdde" "uppträtt" ; -- uppträda..vb.1
  uppträdande_1_N = mkN "uppträdande" ; -- uppträdande..nn.1
  uppträde_1_N = mkN "uppträde" ; -- uppträde..nn.1
  uppträdning_1_N = mkN "uppträdning" ; -- uppträdning..nn.1
  upptuktelse_1_N = mkN "upptuktelse" "upptuktelser" ; -- upptuktelse..nn.1
  upptäcka_1_V = mkV "upptäcker" ; -- upptäcka..vb.1
  upptäckande_1_N = mkN "upptäckande" ; -- upptäckande..nn.1
  upptäckare_1_N = mkN "upptäckare" utrum  ; -- upptäckare..nn.1
  upptäckarglädje_1_N = mkN "upptäckarglädje" utrum  ; -- upptäckarglädje..nn.1
  upptäckt_1_N = mkN "upptäckt" "upptäckter" ; -- upptäckt..nn.1
  upptäcktsfärd_1_N = mkN "upptäcktsfärd" "upptäcktsfärder" ; -- upptäcktsfärd..nn.1
  upptäcktsresa_1_N = mkN "upptäcktsresa" ; -- upptäcktsresa..nn.1
  upptäcktsresande_1_N = mkN "upptäcktsresande" "upptäcktsresanden" "upptäcktsresanden" "upptäcktsresandena" ; -- upptäcktsresande..nn.1
  upptänd_1_A = mkA "upptänd" ; -- upptänd..av.1
  upptända_1_V = mkV "upptänder" ; -- upptända..vb.1
  upptändande_1_N = mkN "upptändande" ; -- upptändande..nn.1
  upptändhet_1_N = mkN "upptändhet" ; -- upptändhet..nn.1
  upptänklig_1_A = mkA "upptänklig" ; -- upptänklig..av.1
  upptåg_1_N = mkN "upptåg" neutrum  ; -- upptåg..nn.1
  upptågsmakare_1_N = mkN "upptågsmakare" utrum  ; -- upptågsmakare..nn.1
  uppvaknande_1_N = mkN "uppvaknande" ; -- uppvaknande..nn.1
  uppvakningsögonblick_1_N = mkN "uppvakningsögonblick" neutrum  ; -- uppvakningsögonblick..nn.1
  uppvakta_1_V = mkV "uppvaktar" ; -- uppvakta..vb.1
  uppvaktande_1_N = mkN "uppvaktande" ; -- uppvaktande..nn.1
  uppvaktning_1_N = mkN "uppvaktning" ; -- uppvaktning..nn.1
  uppvigla_1_V = mkV "uppviglar" ; -- uppvigla..vb.1
  uppviglande_1_N = mkN "uppviglande" ; -- uppviglande..nn.1
  uppviglare_1_N = mkN "uppviglare" utrum  ; -- uppviglare..nn.1
  uppvigling_1_N = mkN "uppvigling" ; -- uppvigling..nn.1
  uppvikt_1_A = mkA "uppvikt" "uppvikt" ; -- uppvikt..av.1
  uppvilad_1_A = mkA "uppvilad" ; -- uppvilad..av.1
  uppvind_1_N = mkN "uppvind" ; -- uppvind..nn.1
  uppvisa_1_V = mkV "uppvisar" ; -- uppvisa..vb.1
  uppvisande_1_N = mkN "uppvisande" ; -- uppvisande..nn.1
  uppvisning_1_N = mkN "uppvisning" ; -- uppvisning..nn.1
  uppvuxen_1_A = mkA "uppvuxen" ; -- uppvuxen..av.1
  uppväcka_1_V = mkV "uppväcker" ; -- uppväcka..vb.1
  uppväckande_1_N = mkN "uppväckande" ; -- uppväckande..nn.1
  uppväckelse_1_N = mkN "uppväckelse" "uppväckelser" ; -- uppväckelse..nn.1
  uppväg_1_N = mkN "uppväg" ; -- uppväg..nn.1
  uppväga_1_V = mkV "uppväger" ; -- uppväga..vb.1
  uppvägande_1_N = mkN "uppvägande" ; -- uppvägande..nn.1
  uppvägning_1_N = mkN "uppvägning" ; -- uppvägning..nn.1
  uppvärdera_1_V = mkV "uppvärderar" ; -- uppvärdera..vb.1
  uppvärderande_1_N = mkN "uppvärderande" ; -- uppvärderande..nn.1
  uppvärderbar_1_A = mkA "uppvärderbar" ; -- uppvärderbar..av.1
  uppvärderbarhet_1_N = mkN "uppvärderbarhet" ; -- uppvärderbarhet..nn.1
  uppvärdering_1_N = mkN "uppvärdering" ; -- uppvärdering..nn.1
  uppvärma_1_V = mkV "uppvärmer" ; -- uppvärma..vb.1
  uppvärmande_1_N = mkN "uppvärmande" ; -- uppvärmande..nn.1
  uppvärmning_1_N = mkN "uppvärmning" ; -- uppvärmning..nn.1
  uppvärmningsband_1_N = mkN "uppvärmningsband" neutrum  ; -- uppvärmningsband..nn.1
  uppvärmningspotential_1_N = mkN "uppvärmningspotential" "uppvärmningspotentialer" ; -- uppvärmningspotential..nn.1
  uppväxa_1_V = mkV "uppväxa" "uppväxer" "uppväxa" "uppväxte" "uppväxt" "uppvuxen" ; -- uppväxa..vb.1
  uppväxande_1_N = mkN "uppväxande" ; -- uppväxande..nn.1
  uppväxt_1_N = mkN "uppväxt" ; -- uppväxt..nn.1
  uppväxtmiljö_1_N = mkN "uppväxtmiljö" "uppväxtmiljön" "uppväxtmiljöer" "uppväxtmiljöerna" ; -- uppväxtmiljö..nn.1
  uppäta_1_V = mkV "uppäta" "uppåt" "uppätit" ; -- uppäta..vb.1
  uppätande_1_N = mkN "uppätande" ; -- uppätande..nn.1
  uppåkt_1_A = mkA "uppåkt" "uppåkt" ; -- uppåkt..av.1
  uppånedvänd_1_A = mkA "uppånedvänd" ; -- uppånedvänd..av.1
  uppånedvändhet_1_N = mkN "uppånedvändhet" ; -- uppånedvändhet..nn.1
  uppånervänd_1_A = mkA "uppånervänd" ; -- uppånervänd..av.1
  uppånervändhet_1_N = mkN "uppånervändhet" ; -- uppånervändhet..nn.1
  uppåt_1_A = mkA "uppåt" ; -- uppåt..av.1
  uppåtböjd_1_A = mkA "uppåtböjd" "uppåtböjt" ; -- uppåtböjd..av.1
  uppåtgående_1_A = mkA "uppåtgående" ; -- uppåtgående..av.1
  uppåtgående_1_N = mkN "uppåtgående" ; -- uppåtgående..nn.1
  uppåtkammad_1_A = mkA "uppåtkammad" ; -- uppåtkammad..av.1
  uppåtriktad_1_A = mkA "uppåtriktad" ; -- uppåtriktad..av.1
  uppåtstigande_1_A = mkA "uppåtstigande" ; -- uppåtstigande..av.1
  uppåtsträvande_1_A = mkA "uppåtsträvande" ; -- uppåtsträvande..av.1
  uppåtsträvare_1_N = mkN "uppåtsträvare" utrum  ; -- uppåtsträvare..nn.1
  uppöva_1_V = mkV "uppövar" ; -- uppöva..vb.1
  uppövande_1_N = mkN "uppövande" ; -- uppövande..nn.1
  uppövning_1_N = mkN "uppövning" ; -- uppövning..nn.1
  ur_ur_kroppen_upplevelse_1_N = mkN "ur-ur-kroppen-upplevelse" "ur-ur-kroppen-upplevelser" ; -- ur-ur-kroppen-upplevelse..nn.1
  ur_ur_kroppenupplevelse_1_N = mkN "ur-ur-kroppenupplevelse" "ur-ur-kroppenupplevelser" ; -- ur-ur-kroppenupplevelse..nn.1
  ur_1_N = mkN "ur" neutrum  ; -- ur..nn.1
  ur_2_N = mkN "ur" ; -- ur..nn.2
  ur_3_N = mkN "ur" ; -- ur..nn.3
  uraktlåta_1_V = mkV "uraktlåta" "uraktlät" "uraktlåtit" ; -- uraktlåta..vb.1
  uraktlåtande_1_N = mkN "uraktlåtande" ; -- uraktlåtande..nn.1
  uraktlåtenhet_1_N = mkN "uraktlåtenhet" "uraktlåtenheter" ; -- uraktlåtenhet..nn.1
  uralisk_1_A = mkA "uralisk" ; -- uralisk..av.1
  uralsk_1_A = mkA "uralsk" ; -- uralsk..av.1
  uralstring_1_N = mkN "uralstring" ; -- uralstring..nn.1
  uran_1_N = mkN "uran" ; -- uran..nn.1
  uranbly_1_N = mkN "uranbly" neutrum  ; -- uranbly..nn.1
  uranbrytning_1_N = mkN "uranbrytning" ; -- uranbrytning..nn.1
  uranglas_1_N = mkN "uranglas" neutrum  ; -- uranglas..nn.1
  urankuts_1_N = mkN "urankuts" ; -- urankuts..nn.1
  uranstapel_1_N = mkN "uranstapel" ; -- uranstapel..nn.1
  uranutvinning_1_N = mkN "uranutvinning" ; -- uranutvinning..nn.1
  urarta_1_V = mkV "urartar" ; -- urarta..vb.1
  urartande_1_N = mkN "urartande" ; -- urartande..nn.1
  urartning_1_N = mkN "urartning" ; -- urartning..nn.1
  urarva_1_A = mkA "urarva" ; -- urarva..av.1
  urarvabo_1_N = mkN "urarvabo" "urarvaboet" "urarvabon" "urarvabona" ; -- urarvabo..nn.1
  urarvakonkurs_1_N = mkN "urarvakonkurs" "urarvakonkurser" ; -- urarvakonkurs..nn.1
  urban_1_A = mkA "urban" ; -- urban..av.1
  urbanisera_1_V = mkV "urbaniserar" ; -- urbanisera..vb.1
  urbaniserande_1_N = mkN "urbaniserande" ; -- urbaniserande..nn.1
  urbaniserbar_1_A = mkA "urbaniserbar" ; -- urbaniserbar..av.1
  urbaniserbarhet_1_N = mkN "urbaniserbarhet" ; -- urbaniserbarhet..nn.1
  urbanisering_1_N = mkN "urbanisering" ; -- urbanisering..nn.1
  urbanism_1_N = mkN "urbanism" "urbanismer" ; -- urbanism..nn.1
  urbanistisk_1_A = mkA "urbanistisk" ; -- urbanistisk..av.1
  urbanitet_1_N = mkN "urbanitet" "urbaniteter" ; -- urbanitet..nn.1
  urbefolkning_1_N = mkN "urbefolkning" ; -- urbefolkning..nn.1
  urbenad_1_A = mkA "urbenad" ; -- urbenad..av.1
  urberg_1_N = mkN "urberg" neutrum  ; -- urberg..nn.1
  urbergsplatå_1_N = mkN "urbergsplatå" "urbergsplatåer" ; -- urbergsplatå..nn.1
  urbergsterräng_1_N = mkN "urbergsterräng" "urbergsterränger" ; -- urbergsterräng..nn.1
  urbild_1_N = mkN "urbild" "urbilder" ; -- urbild..nn.1
  urblekt_1_A = mkA "urblekt" "urblekt" ; -- urblekt..av.1
  urblåst_1_A = mkA "urblåst" "urblåst" ; -- urblåst..av.1
  urbränning_1_N = mkN "urbränning" ; -- urbränning..nn.1
  urcell_1_N = mkN "urcell" "urceller" ; -- urcell..nn.1
  urdjur_1_N = mkN "urdjur" neutrum  ; -- urdjur..nn.1
  urdjurscell_1_N = mkN "urdjurscell" "urdjursceller" ; -- urdjurscell..nn.1
  urdu_1_N = mkN "urdu" ; -- urdu..nn.1
  urdyr_1_A = mkA "urdyr" ; -- urdyr..av.1
  urdålig_1_A = mkA "urdålig" ; -- urdålig..av.1
  urdålighet_1_N = mkN "urdålighet" "urdåligheter" ; -- urdålighet..nn.1
  urea_1_N = mkN "urea" ; -- urea..nn.1
  ureas_1_N = mkN "ureas" "ureaser" ; -- ureas..nn.1
  uremi_1_N = mkN "uremi" ; -- uremi..nn.1
  uretan_1_N = mkN "uretan" ; -- uretan..nn.1
  uretanplast_1_N = mkN "uretanplast" "uretanplaster" ; -- uretanplast..nn.1
  urexplosion_1_N = mkN "urexplosion" ; -- urexplosion..nn.1
  urfader_1_N = mkN "urfader" "urfadern" "urfäder" "urfäderna" ; -- urfader..nn.1
  urfinska_1_N = mkN "urfinska" ; -- urfinska..nn.1
  urfjäll_1_N = mkN "urfjäll" neutrum  ; -- urfjäll..nn.1
  urfjällsjord_1_N = mkN "urfjällsjord" ; -- urfjällsjord..nn.1
  urfolk_1_N = mkN "urfolk" neutrum  ; -- urfolk..nn.1
  urfolklig_1_A = mkA "urfolklig" ; -- urfolklig..av.1
  urform_1_N = mkN "urform" "urformer" ; -- urform..nn.1
  urformation_1_N = mkN "urformation" ; -- urformation..nn.1
  urfälld_1_A = mkA "urfälld" "urfällt" ; -- urfälld..av.1
  urfågel_1_N = mkN "urfågel" ; -- urfågel..nn.1
  urfånig_1_A = mkA "urfånig" ; -- urfånig..av.1
  urfånighet_1_N = mkN "urfånighet" ; -- urfånighet..nn.1
  urförälder_1_N = mkN "urförälder" ; -- urförälder..nn.1
  urgammal_1_A = mkA "urgammal" "urgammalt" "urgamla" "uräldre" "uräldst" ; -- urgammal..av.1
  urgera_1_V = mkV "urgerar" ; -- urgera..vb.1
  urgerande_1_N = mkN "urgerande" ; -- urgerande..nn.1
  urgering_1_N = mkN "urgering" ; -- urgering..nn.1
  urgermansk_1_A = mkA "urgermansk" ; -- urgermansk..av.1
  urgermanska_1_N = mkN "urgermanska" ; -- urgermanska..nn.1
  urgrävning_1_N = mkN "urgrävning" ; -- urgrävning..nn.1
  urgröpning_1_N = mkN "urgröpning" ; -- urgröpning..nn.1
  urgröpt_1_A = mkA "urgröpt" "urgröpt" ; -- urgröpt..av.1
  urhem_1_N = mkN "urhem" "urhemmet" "urhem" "urhemmen" ; -- urhem..nn.1
  urholka_1_V = mkV "urholkar" ; -- urholka..vb.1
  urholkande_1_N = mkN "urholkande" ; -- urholkande..nn.1
  urholkning_1_N = mkN "urholkning" ; -- urholkning..nn.1
  urholkning_2_N = mkN "urholkning" ; -- urholkning..nn.2
  uribag_1_N = mkN "uribag" ; -- uribag..nn.1
  uridiot_1_N = mkN "uridiot" "uridioter" ; -- uridiot..nn.1
  uridom_1_N = mkN "uridom" "uridomer" ; -- uridom..nn.1
  uriebrev_1_N = mkN "uriebrev" neutrum  ; -- uriebrev..nn.1
  urin_1_N = mkN "urin" ; -- urin..nn.1
  urinavsöndring_1_N = mkN "urinavsöndring" ; -- urinavsöndring..nn.1
  urinblåsa_1_N = mkN "urinblåsa" ; -- urinblåsa..nn.1
  urinbrunn_1_N = mkN "urinbrunn" ; -- urinbrunn..nn.1
  urinbyggare_1_N = mkN "urinbyggare" utrum  ; -- urinbyggare..nn.1
  urindoeuropeisk_1_A = mkA "urindoeuropeisk" ; -- urindoeuropeisk..av.1
  urindrivande_1_A = mkA "urindrivande" ; -- urindrivande..av.1
  urinera_1_V = mkV "urinerar" ; -- urinera..vb.1
  urinerande_1_N = mkN "urinerande" ; -- urinerande..nn.1
  urinering_1_N = mkN "urinering" ; -- urinering..nn.1
  urinfläckad_1_A = mkA "urinfläckad" ; -- urinfläckad..av.1
  urinförgiftning_1_N = mkN "urinförgiftning" ; -- urinförgiftning..nn.1
  urinkur_1_N = mkN "urinkur" ; -- urinkur..nn.1
  urinledare_1_N = mkN "urinledare" utrum  ; -- urinledare..nn.1
  urinnevånare_1_N = mkN "urinnevånare" utrum  ; -- urinnevånare..nn.1
  urinoar_1_N = mkN "urinoar" "urinoarer" ; -- urinoar..nn.1
  urinorgan_1_N = mkN "urinorgan" neutrum  ; -- urinorgan..nn.1
  urinprov_1_N = mkN "urinprov" neutrum  ; -- urinprov..nn.1
  urinrör_1_N = mkN "urinrör" neutrum  ; -- urinrör..nn.1
  urinstinkt_1_N = mkN "urinstinkt" "urinstinkter" ; -- urinstinkt..nn.1
  urinstockning_1_N = mkN "urinstockning" ; -- urinstockning..nn.1
  urinstämma_1_N = mkN "urinstämma" ; -- urinstämma..nn.1
  urinsyra_1_N = mkN "urinsyra" ; -- urinsyra..nn.1
  urinträngning_1_N = mkN "urinträngning" ; -- urinträngning..nn.1
  urinväg_1_N = mkN "urinväg" ; -- urinväg..nn.1
  urinvägsinfektion_1_N = mkN "urinvägsinfektion" ; -- urinvägsinfektion..nn.1
  urinvånare_1_N = mkN "urinvånare" utrum  ; -- urinvånare..nn.1
  urinämne_1_N = mkN "urinämne" ; -- urinämne..nn.1
  urkalka_1_V = mkV "urkalkar" ; -- urkalka..vb.1
  urkalkande_1_N = mkN "urkalkande" ; -- urkalkande..nn.1
  urkalksten_1_N = mkN "urkalksten" "urkalkstenen" "urkalkstenar" "urkalkstenarna" ; -- urkalksten..nn.1
  urklipp_1_N = mkN "urklipp" neutrum  ; -- urklipp..nn.1
  urkokt_1_A = mkA "urkokt" "urkokt" ; -- urkokt..av.1
  urkopplad_1_A = mkA "urkopplad" ; -- urkopplad..av.1
  urkramad_1_A = mkA "urkramad" ; -- urkramad..av.1
  urkramning_1_N = mkN "urkramning" ; -- urkramning..nn.1
  urkristendom_1_N = mkN "urkristendom" ; -- urkristendom..nn.1
  urkund_1_N = mkN "urkund" "urkunder" ; -- urkund..nn.1
  urkundlig_1_A = mkA "urkundlig" ; -- urkundlig..av.1
  urkundlighet_1_N = mkN "urkundlighet" ; -- urkundlighet..nn.1
  urkundsforskning_1_N = mkN "urkundsforskning" ; -- urkundsforskning..nn.1
  urkundsförfalskning_1_N = mkN "urkundsförfalskning" ; -- urkundsförfalskning..nn.1
  urkärnare_1_N = mkN "urkärnare" utrum  ; -- urkärnare..nn.1
  urladdare_1_N = mkN "urladdare" utrum  ; -- urladdare..nn.1
  urladdning_1_N = mkN "urladdning" ; -- urladdning..nn.1
  urladdningsrör_1_N = mkN "urladdningsrör" neutrum  ; -- urladdningsrör..nn.1
  urlaka_1_V = mkV "urlakar" ; -- urlaka..vb.1
  urlakad_1_A = mkA "urlakad" ; -- urlakad..av.1
  urlakande_1_N = mkN "urlakande" ; -- urlakande..nn.1
  urlakning_1_N = mkN "urlakning" ; -- urlakning..nn.1
  urlastning_1_N = mkN "urlastning" ; -- urlastning..nn.1
  urledvrickning_1_N = mkN "urledvrickning" ; -- urledvrickning..nn.1
  urledvridning_1_N = mkN "urledvridning" ; -- urledvridning..nn.1
  urmakare_1_N = mkN "urmakare" utrum  ; -- urmakare..nn.1
  urmakeri_1_N = mkN "urmakeri" "urmakeriet" "urmakerier" "urmakerierna" ; -- urmakeri..nn.1
  urminnes_1_A = mkA "urminnes" ; -- urminnes..av.1
  urminneshävd_1_N = mkN "urminneshävd" "urminneshävder" ; -- urminneshävd..nn.1
  urmoder_1_N = mkN "urmoder" "urmodern" "urmödrar" "urmödrarna" ; -- urmoder..nn.1
  urmodig_1_A = mkA "urmodig" ; -- urmodig..av.1
  urmodighet_1_N = mkN "urmodighet" ; -- urmodighet..nn.1
  urmänniska_1_N = mkN "urmänniska" ; -- urmänniska..nn.1
  urna_1_N = mkN "urna" ; -- urna..nn.1
  urnebrandgrop_1_N = mkN "urnebrandgrop" ; -- urnebrandgrop..nn.1
  urnegrav_1_N = mkN "urnegrav" ; -- urnegrav..nn.1
  urnformad_1_A = mkA "urnformad" ; -- urnformad..av.1
  urngrav_1_N = mkN "urngrav" ; -- urngrav..nn.1
  urnkulle_1_N = mkN "urnkulle" utrum  ; -- urnkulle..nn.1
  urnordisk_1_A = mkA "urnordisk" ; -- urnordisk..av.1
  urnordiska_1_N = mkN "urnordiska" ; -- urnordiska..nn.1
  urnsättning_1_N = mkN "urnsättning" ; -- urnsättning..nn.1
  urnupen_1_A = mkA "urnupen" ; -- urnupen..av.1
  urnyckel_1_N = mkN "urnyckel" ; -- urnyckel..nn.1
  urocean_1_N = mkN "urocean" "uroceaner" ; -- urocean..nn.1
  urogenitalapparat_1_N = mkN "urogenitalapparat" "urogenitalapparater" ; -- urogenitalapparat..nn.1
  urogenitalorgan_1_N = mkN "urogenitalorgan" neutrum  ; -- urogenitalorgan..nn.1
  urogenitalöppning_1_N = mkN "urogenitalöppning" ; -- urogenitalöppning..nn.1
  urografi_1_N = mkN "urografi" ; -- urografi..nn.1
  urolog_1_N = mkN "urolog" "urologer" ; -- urolog..nn.1
  urologi_1_N = mkN "urologi" ; -- urologi..nn.1
  urologisk_1_A = mkA "urologisk" ; -- urologisk..av.1
  urormbunke_1_N = mkN "urormbunke" utrum  ; -- urormbunke..nn.1
  uroxe_1_N = mkN "uroxe" utrum  ; -- uroxe..nn.1
  urpackning_1_N = mkN "urpackning" ; -- urpackning..nn.1
  urplock_1_N = mkN "urplock" neutrum  ; -- urplock..nn.1
  urplockning_1_N = mkN "urplockning" ; -- urplockning..nn.1
  urpremiär_1_N = mkN "urpremiär" "urpremiärer" ; -- urpremiär..nn.1
  urringad_1_A = mkA "urringad" ; -- urringad..av.1
  urringning_1_N = mkN "urringning" ; -- urringning..nn.1
  ursaka_1_V = mkV "ursakar" ; -- ursaka..vb.1
  ursakande_1_N = mkN "ursakande" ; -- ursakande..nn.1
  ursame_1_N = mkN "ursame" "ursamer" ; -- ursame..nn.1
  ursinne_1_N = mkN "ursinne" ; -- ursinne..nn.1
  ursinnig_1_A = mkA "ursinnig" ; -- ursinnig..av.1
  ursinnighet_1_N = mkN "ursinnighet" ; -- ursinnighet..nn.1
  ursinningslös_1_A = mkA "ursinningslös" ; -- ursinningslös..av.1
  urskilja_1_V = mkV "urskilja" "urskilde" "urskilt" ; -- urskilja..vb.1
  urskiljande_1_N = mkN "urskiljande" ; -- urskiljande..nn.1
  urskiljbar_1_A = mkA "urskiljbar" ; -- urskiljbar..av.1
  urskiljbarhet_1_N = mkN "urskiljbarhet" ; -- urskiljbarhet..nn.1
  urskiljning_1_N = mkN "urskiljning" ; -- urskiljning..nn.1
  urskiljningsförmåga_1_N = mkN "urskiljningsförmåga" ; -- urskiljningsförmåga..nn.1
  urskiljningslös_1_A = mkA "urskiljningslös" ; -- urskiljningslös..av.1
  urskiljningslöshet_1_N = mkN "urskiljningslöshet" ; -- urskiljningslöshet..nn.1
  urskillning_1_N = mkN "urskillning" ; -- urskillning..nn.1
  urskillningsförmåga_1_N = mkN "urskillningsförmåga" ; -- urskillningsförmåga..nn.1
  urskillningslös_1_A = mkA "urskillningslös" ; -- urskillningslös..av.1
  urskillningslöshet_1_N = mkN "urskillningslöshet" ; -- urskillningslöshet..nn.1
  urskog_1_N = mkN "urskog" ; -- urskog..nn.1
  urskri_1_N = mkN "urskri" "urskriet" "urskrin" "urskrina" ; -- urskri..nn.1
  urskulda_1_V = mkV "urskuldar" ; -- urskulda..vb.1
  urskuldande_1_N = mkN "urskuldande" ; -- urskuldande..nn.1
  urskålad_1_A = mkA "urskålad" ; -- urskålad..av.1
  ursköljning_1_N = mkN "ursköljning" ; -- ursköljning..nn.1
  urskönja_1_V = mkV "urskönja" "urskönjde" "urskönjt" ; -- urskönja..vb.1
  urskönjande_1_N = mkN "urskönjande" ; -- urskönjande..nn.1
  ursmäll_1_N = mkN "ursmäll" ; -- ursmäll..nn.1
  ursmällsteori_1_N = mkN "ursmällsteori" "ursmällsteorier" ; -- ursmällsteori..nn.1
  ursnygg_1_A = mkA "ursnygg" ; -- ursnygg..av.1
  ursnygghet_1_N = mkN "ursnygghet" ; -- ursnygghet..nn.1
  ursoppa_1_N = mkN "ursoppa" ; -- ursoppa..nn.1
  ursprung_1_N = mkN "ursprung" neutrum  ; -- ursprung..nn.1
  ursprunglig_1_A = mkA "ursprunglig" ; -- ursprunglig..av.1
  ursprungligen_1_Adv = mkAdv "ursprungligen" ; -- ursprungligen..ab.1
  ursprunglighet_1_N = mkN "ursprunglighet" ; -- ursprunglighet..nn.1
  ursprungsart_1_N = mkN "ursprungsart" "ursprungsarter" ; -- ursprungsart..nn.1
  ursprungsattest_1_N = mkN "ursprungsattest" "ursprungsattester" ; -- ursprungsattest..nn.1
  ursprungsbefolkning_1_N = mkN "ursprungsbefolkning" ; -- ursprungsbefolkning..nn.1
  ursprungsbeteckning_1_N = mkN "ursprungsbeteckning" ; -- ursprungsbeteckning..nn.1
  ursprungsbevis_1_N = mkN "ursprungsbevis" neutrum  ; -- ursprungsbevis..nn.1
  ursprungscell_1_N = mkN "ursprungscell" "ursprungsceller" ; -- ursprungscell..nn.1
  ursprungscertifikat_1_N = mkN "ursprungscertifikat" neutrum  ; -- ursprungscertifikat..nn.1
  ursprungsdokumentation_1_N = mkN "ursprungsdokumentation" ; -- ursprungsdokumentation..nn.1
  ursprungsland_1_N = mkN "ursprungsland" "ursprungslandet" "ursprungsländer" "ursprungsländerna" ; -- ursprungsland..nn.1
  ursprungsläge_1_N = mkN "ursprungsläge" ; -- ursprungsläge..nn.1
  ursprungsmärka_1_V = mkV "ursprungsmärker" ; -- ursprungsmärka..vb.1
  ursprungsmärkande_1_N = mkN "ursprungsmärkande" ; -- ursprungsmärkande..nn.1
  ursprungsort_1_N = mkN "ursprungsort" "ursprungsorter" ; -- ursprungsort..nn.1
  urspråk_1_N = mkN "urspråk" neutrum  ; -- urspråk..nn.1
  urspråklig_1_A = mkA "urspråklig" ; -- urspråklig..av.1
  urspårad_1_A = mkA "urspårad" ; -- urspårad..av.1
  urspårning_1_N = mkN "urspårning" ; -- urspårning..nn.1
  urstark_1_A = mkA "urstark" ; -- urstark..av.1
  urstigning_1_N = mkN "urstigning" ; -- urstigning..nn.1
  urstjälpning_1_N = mkN "urstjälpning" ; -- urstjälpning..nn.1
  urstyv_1_A = mkA "urstyv" ; -- urstyv..av.1
  urstyvhet_1_N = mkN "urstyvhet" ; -- urstyvhet..nn.1
  ursupen_1_A = mkA "ursupen" ; -- ursupen..av.1
  ursvensk_1_A = mkA "ursvensk" ; -- ursvensk..av.1
  ursvensk_1_N = mkN "ursvensk" ; -- ursvensk..nn.1
  ursäkt_1_N = mkN "ursäkt" "ursäkter" ; -- ursäkt..nn.1
  ursäkta_1_V = mkV "ursäktar" ; -- ursäkta..vb.1
  ursäktande_1_N = mkN "ursäktande" ; -- ursäktande..nn.1
  ursäktlig_1_A = mkA "ursäktlig" ; -- ursäktlig..av.1
  ursäktlighet_1_N = mkN "ursäktlighet" ; -- ursäktlighet..nn.1
  ursågning_1_N = mkN "ursågning" ; -- ursågning..nn.1
  urtag_1_N = mkN "urtag" neutrum  ; -- urtag..nn.1
  urtagbar_1_A = mkA "urtagbar" ; -- urtagbar..av.1
  urtagbarhet_1_N = mkN "urtagbarhet" ; -- urtagbarhet..nn.1
  urtagen_1_A = mkA "urtagen" ; -- urtagen..av.1
  urtappning_1_N = mkN "urtappning" ; -- urtappning..nn.1
  urtavla_1_N = mkN "urtavla" ; -- urtavla..nn.1
  urtext_1_N = mkN "urtext" "urtexter" ; -- urtext..nn.1
  urticaria_1_N = mkN "urticaria" ; -- urticaria..nn.1
  urtid_1_N = mkN "urtid" ; -- urtid..nn.1
  urtida_1_A = mkA "urtida" ; -- urtida..av.1
  urtillstånd_1_N = mkN "urtillstånd" neutrum  ; -- urtillstånd..nn.1
  urtima_1_A = mkA "urtima" ; -- urtima..av.1
  urtjusig_1_A = mkA "urtjusig" ; -- urtjusig..av.1
  urtjusighet_1_N = mkN "urtjusighet" ; -- urtjusighet..nn.1
  urtjuva_1_A = mkA "urtjuva" ; -- urtjuva..av.1
  urtrist_1_A = mkA "urtrist" "urtrist" ; -- urtrist..av.1
  urtvättad_1_A = mkA "urtvättad" ; -- urtvättad..av.1
  urtyp_1_N = mkN "urtyp" "urtyper" ; -- urtyp..nn.1
  uruguayansk_1_A = mkA "uruguayansk" ; -- uruguayansk..av.1
  uruguayanska_1_N = mkN "uruguayanska" ; -- uruguayanska..nn.1
  uruguayare_1_N = mkN "uruguayare" utrum  ; -- uruguayare..nn.1
  uruguaysk_1_A = mkA "uruguaysk" ; -- uruguaysk..av.1
  uruppföra_1_V = mkV "uruppföra" "uruppförde" "uruppfört" ; -- uruppföra..vb.1
  uruppförande_1_N = mkN "uruppförande" ; -- uruppförande..nn.1
  urusel_1_A = mkA "urusel" ; -- urusel..av.1
  urval_1_N = mkN "urval" neutrum  ; -- urval..nn.1
  urvalsinstrument_1_N = mkN "urvalsinstrument" neutrum  ; -- urvalsinstrument..nn.1
  urvalsprocess_1_N = mkN "urvalsprocess" "urvalsprocesser" ; -- urvalsprocess..nn.1
  urvalsundersökning_1_N = mkN "urvalsundersökning" ; -- urvalsundersökning..nn.1
  urvattnad_1_A = mkA "urvattnad" ; -- urvattnad..av.1
  urvattning_1_N = mkN "urvattning" ; -- urvattning..nn.1
  urverk_1_N = mkN "urverk" neutrum  ; -- urverk..nn.1
  urvuxen_1_A = mkA "urvuxen" ; -- urvuxen..av.1
  urväxt_1_A = mkA "urväxt" "urväxt" ; -- urväxt..av.1
  urämne_1_N = mkN "urämne" ; -- urämne..nn.1
  uråldrig_1_A = mkA "uråldrig" ; -- uråldrig..av.1
  uråldrighet_1_N = mkN "uråldrighet" ; -- uråldrighet..nn.1
  usans_1_N = mkN "usans" "usanser" ; -- usans..nn.1
  usb_minne_1_N = mkN "usb-minne" ; -- usb-minne..nn.1
  usb_sladd_1_N = mkN "usb-sladd" ; -- usb-sladd..nn.1
  uschlig_1_A = mkA "uschlig" ; -- uschlig..av.1
  uschlighet_1_N = mkN "uschlighet" "uschligheter" ; -- uschlighet..nn.1
  usel_1_A = mkA "usel" "uselt" "usla" "usla" "uslare" "uslast" "uslaste" ; -- usel..av.1
  uselhet_1_N = mkN "uselhet" "uselheter" ; -- uselhet..nn.1
  uslig_1_A = mkA "uslig" ; -- uslig..av.1
  uslighet_1_N = mkN "uslighet" "usligheter" ; -- uslighet..nn.1
  usling_1_N = mkN "usling" ; -- usling..nn.1
  usuell_1_A = mkA "usuell" ; -- usuell..av.1
  usurpation_1_N = mkN "usurpation" ; -- usurpation..nn.1
  usurpator_1_N = mkN "usurpator" "usurpatorer" ; -- usurpator..nn.1
  usurpera_1_V = mkV "usurperar" ; -- usurpera..vb.1
  usurperande_1_N = mkN "usurperande" ; -- usurperande..nn.1
  usurperbar_1_A = mkA "usurperbar" ; -- usurperbar..av.1
  usurperbarhet_1_N = mkN "usurperbarhet" ; -- usurperbarhet..nn.1
  usurpering_1_N = mkN "usurpering" ; -- usurpering..nn.1
  utackordera_1_V = mkV "utackorderar" ; -- utackordera..vb.1
  utackorderande_1_N = mkN "utackorderande" ; -- utackorderande..nn.1
  utackorderbar_1_A = mkA "utackorderbar" ; -- utackorderbar..av.1
  utackorderbarhet_1_N = mkN "utackorderbarhet" ; -- utackorderbarhet..nn.1
  utackordering_1_N = mkN "utackordering" ; -- utackordering..nn.1
  utagerad_1_A = mkA "utagerad" ; -- utagerad..av.1
  utagerande_1_A = mkA "utagerande" ; -- utagerande..av.1
  utagering_1_N = mkN "utagering" ; -- utagering..nn.1
  utandning_1_N = mkN "utandning" ; -- utandning..nn.1
  utandningsluft_1_N = mkN "utandningsluft" ; -- utandningsluft..nn.1
  utandningsprov_1_N = mkN "utandningsprov" neutrum  ; -- utandningsprov..nn.1
  utanförskap_1_N = mkN "utanförskap" neutrum  ; -- utanförskap..nn.1
  utanförskapskänsla_1_N = mkN "utanförskapskänsla" ; -- utanförskapskänsla..nn.1
  utanförskapsmarkör_1_N = mkN "utanförskapsmarkör" "utanförskapsmarkörer" ; -- utanförskapsmarkör..nn.1
  utanförstående_1_A = mkA "utanförstående" ; -- utanförstående..av.1
  utanläxa_1_N = mkN "utanläxa" ; -- utanläxa..nn.1
  utannonsera_1_V = mkV "utannonserar" ; -- utannonsera..vb.1
  utannonserande_1_N = mkN "utannonserande" ; -- utannonserande..nn.1
  utannonserbar_1_A = mkA "utannonserbar" ; -- utannonserbar..av.1
  utannonserbarhet_1_N = mkN "utannonserbarhet" ; -- utannonserbarhet..nn.1
  utannonsering_1_N = mkN "utannonsering" ; -- utannonsering..nn.1
  utanordna_1_V = mkV "utanordnar" ; -- utanordna..vb.1
  utanordnande_1_N = mkN "utanordnande" ; -- utanordnande..nn.1
  utanordning_1_N = mkN "utanordning" ; -- utanordning..nn.1
  utanpåliggande_1_A = mkA "utanpåliggande" ; -- utanpåliggande..av.1
  utanpåskjorta_1_N = mkN "utanpåskjorta" ; -- utanpåskjorta..nn.1
  utanpåskrift_1_N = mkN "utanpåskrift" "utanpåskrifter" ; -- utanpåskrift..nn.1
  utanskrift_1_N = mkN "utanskrift" "utanskrifter" ; -- utanskrift..nn.1
  utantillmässig_1_A = mkA "utantillmässig" ; -- utantillmässig..av.1
  utantilläxa_1_N = mkN "utantilläxa" ; -- utantilläxa..nn.1
  utanverk_1_N = mkN "utanverk" neutrum  ; -- utanverk..nn.1
  utarbeta_1_V = mkV "utarbetar" ; -- utarbeta..vb.1
  utarbetad_1_A = mkA "utarbetad" ; -- utarbetad..av.1
  utarbetande_1_N = mkN "utarbetande" ; -- utarbetande..nn.1
  utarbetning_1_N = mkN "utarbetning" ; -- utarbetning..nn.1
  utarma_1_V = mkV "utarmar" ; -- utarma..vb.1
  utarmad_1_A = mkA "utarmad" ; -- utarmad..av.1
  utarmande_1_N = mkN "utarmande" ; -- utarmande..nn.1
  utarrendera_1_V = mkV "utarrenderar" ; -- utarrendera..vb.1
  utarrenderande_1_N = mkN "utarrenderande" ; -- utarrenderande..nn.1
  utarrenderbar_1_A = mkA "utarrenderbar" ; -- utarrenderbar..av.1
  utarrenderbarhet_1_N = mkN "utarrenderbarhet" ; -- utarrenderbarhet..nn.1
  utarrendering_1_N = mkN "utarrendering" ; -- utarrendering..nn.1
  utav_1_Adv = mkAdv "utav" ; -- utav..ab.1
  utbalansera_1_V = mkV "utbalanserar" ; -- utbalansera..vb.1
  utbalanserande_1_N = mkN "utbalanserande" ; -- utbalanserande..nn.1
  utbalanserbar_1_A = mkA "utbalanserbar" ; -- utbalanserbar..av.1
  utbalanserbarhet_1_N = mkN "utbalanserbarhet" ; -- utbalanserbarhet..nn.1
  utbalansering_1_N = mkN "utbalansering" ; -- utbalansering..nn.1
  utbasunera_1_V = mkV "utbasunerar" ; -- utbasunera..vb.1
  utbasunerande_1_N = mkN "utbasunerande" ; -- utbasunerande..nn.1
  utbasunerbar_1_A = mkA "utbasunerbar" ; -- utbasunerbar..av.1
  utbasunerbarhet_1_N = mkN "utbasunerbarhet" ; -- utbasunerbarhet..nn.1
  utbasunering_1_N = mkN "utbasunering" ; -- utbasunering..nn.1
  utbasuning_1_N = mkN "utbasuning" ; -- utbasuning..nn.1
  utbekomma_1_V = mkV "utbekomma" "utbekom" "utbekommit" ; -- utbekomma..vb.1
  utbekommande_1_N = mkN "utbekommande" ; -- utbekommande..nn.1
  utbetala_1_V = mkV "utbetalar" ; -- utbetala..vb.1
  utbetalande_1_N = mkN "utbetalande" ; -- utbetalande..nn.1
  utbetalning_1_N = mkN "utbetalning" ; -- utbetalning..nn.1
  utbetalningskort_1_N = mkN "utbetalningskort" neutrum  ; -- utbetalningskort..nn.1
  utbetalningsorder_1_N = mkN "utbetalningsorder" ; -- utbetalningsorder..nn.1
  utbilda_1_V = mkV "utbildar" ; -- utbilda..vb.1
  utbildande_1_N = mkN "utbildande" ; -- utbildande..nn.1
  utbildning_1_N = mkN "utbildning" ; -- utbildning..nn.1
  utbildningsansvarig_1_A = mkA "utbildningsansvarig" ; -- utbildningsansvarig..av.1
  utbildningsbidrag_1_N = mkN "utbildningsbidrag" neutrum  ; -- utbildningsbidrag..nn.1
  utbildningsdepartement_1_N = mkN "utbildningsdepartement" neutrum  ; -- utbildningsdepartement..nn.1
  utbildningsexplosion_1_N = mkN "utbildningsexplosion" ; -- utbildningsexplosion..nn.1
  utbildningsförvaltning_1_N = mkN "utbildningsförvaltning" ; -- utbildningsförvaltning..nn.1
  utbildningsgap_1_N = mkN "utbildningsgap" neutrum  ; -- utbildningsgap..nn.1
  utbildningsklyfta_1_N = mkN "utbildningsklyfta" ; -- utbildningsklyfta..nn.1
  utbildningslinje_1_N = mkN "utbildningslinje" "utbildningslinjer" ; -- utbildningslinje..nn.1
  utbildningsminister_1_N = mkN "utbildningsminister" ; -- utbildningsminister..nn.1
  utbildningsmässig_1_A = mkA "utbildningsmässig" ; -- utbildningsmässig..av.1
  utbildningsnivå_1_N = mkN "utbildningsnivå" "utbildningsnivåer" ; -- utbildningsnivå..nn.1
  utbildningsplats_1_N = mkN "utbildningsplats" "utbildningsplatser" ; -- utbildningsplats..nn.1
  utbildningspolitik_1_N = mkN "utbildningspolitik" ; -- utbildningspolitik..nn.1
  utbildningspolitisk_1_A = mkA "utbildningspolitisk" ; -- utbildningspolitisk..av.1
  utbildningsprogram_1_N = mkN "utbildningsprogram" "utbildningsprogrammet" "utbildningsprogram" "utbildningsprogrammen" ; -- utbildningsprogram..nn.1
  utbildningssystem_1_N = mkN "utbildningssystem" neutrum  ; -- utbildningssystem..nn.1
  utbildningstid_1_N = mkN "utbildningstid" "utbildningstider" ; -- utbildningstid..nn.1
  utbildningsväg_1_N = mkN "utbildningsväg" ; -- utbildningsväg..nn.1
  utbjuda_1_V = mkV "utbjuda" "utbjöd" "utbjudit" ; -- utbjuda..vb.1
  utbjudande_1_N = mkN "utbjudande" ; -- utbjudande..nn.1
  utblandning_1_N = mkN "utblandning" ; -- utblandning..nn.1
  utblick_1_N = mkN "utblick" ; -- utblick..nn.1
  utblommad_1_A = mkA "utblommad" ; -- utblommad..av.1
  utblomning_1_N = mkN "utblomning" ; -- utblomning..nn.1
  utblotta_1_V = mkV "utblottar" ; -- utblotta..vb.1
  utblottad_1_A = mkA "utblottad" ; -- utblottad..av.1
  utblåsning_1_N = mkN "utblåsning" ; -- utblåsning..nn.1
  utbo_1_N = mkN "utbo" "utbor" ; -- utbo..nn.1
  utbomba_1_V = mkV "utbombar" ; -- utbomba..vb.1
  utbombande_1_N = mkN "utbombande" ; -- utbombande..nn.1
  utbordare_1_N = mkN "utbordare" utrum  ; -- utbordare..nn.1
  utbre_1_V = mkV "utbre" "utbredde" "utbrett" ; -- utbre..vb.1
  utbredande_1_N = mkN "utbredande" ; -- utbredande..nn.1
  utbredd_1_A = mkA "utbredd" ; -- utbredd..av.1
  utbreddhet_1_N = mkN "utbreddhet" ; -- utbreddhet..nn.1
  utbredning_1_N = mkN "utbredning" ; -- utbredning..nn.1
  utbredningscentrum_1_N = mkN "utbredningscentrum" neutrum  ; -- utbredningscentrum..nn.1
  utbredningsområde_1_N = mkN "utbredningsområde" ; -- utbredningsområde..nn.1
  utbreende_1_N = mkN "utbreende" ; -- utbreende..nn.1
  utbringa_1_V = mkV "utbringar" ; -- utbringa..vb.1
  utbringande_1_N = mkN "utbringande" ; -- utbringande..nn.1
  utbrista_1_V = mkV "utbrista" "utbrast" "utbrustit" ; -- utbrista..vb.1
  utbristande_1_N = mkN "utbristande" ; -- utbristande..nn.1
  utbrodera_1_V = mkV "utbroderar" ; -- utbrodera..vb.1
  utbroderande_1_N = mkN "utbroderande" ; -- utbroderande..nn.1
  utbroderbar_1_A = mkA "utbroderbar" ; -- utbroderbar..av.1
  utbroderbarhet_1_N = mkN "utbroderbarhet" ; -- utbroderbarhet..nn.1
  utbrodering_1_N = mkN "utbrodering" ; -- utbrodering..nn.1
  utbrott_1_N = mkN "utbrott" neutrum  ; -- utbrott..nn.1
  utbrunnen_1_A = mkA "utbrunnen" "utbrunnet" "utbrunna" "utbrunna" "utbrunnare" "utbrunnast" "utbrunnaste" ; -- utbrunnen..av.1
  utbryta_1_V = mkV "utbryta" "utbröt" "utbrutit" ; -- utbryta..vb.1
  utbrytande_1_N = mkN "utbrytande" ; -- utbrytande..nn.1
  utbrytare_1_N = mkN "utbrytare" utrum  ; -- utbrytare..nn.1
  utbrytarkung_1_N = mkN "utbrytarkung" ; -- utbrytarkung..nn.1
  utbrytarregion_1_N = mkN "utbrytarregion" ; -- utbrytarregion..nn.1
  utbrytarrepublik_1_N = mkN "utbrytarrepublik" "utbrytarrepubliker" ; -- utbrytarrepublik..nn.1
  utbrytarstat_1_N = mkN "utbrytarstat" "utbrytarstater" ; -- utbrytarstat..nn.1
  utbrytning_1_N = mkN "utbrytning" ; -- utbrytning..nn.1
  utbränd_1_A = mkA "utbränd" ; -- utbränd..av.1
  utbrändhet_1_N = mkN "utbrändhet" ; -- utbrändhet..nn.1
  utbua_1_V = mkV "utbuar" ; -- utbua..vb.1
  utbuad_1_A = mkA "utbuad" ; -- utbuad..av.1
  utbuande_1_N = mkN "utbuande" ; -- utbuande..nn.1
  utbud_1_N = mkN "utbud" neutrum  ; -- utbud..nn.1
  utbudspolitik_1_N = mkN "utbudspolitik" ; -- utbudspolitik..nn.1
  utbuktad_1_A = mkA "utbuktad" ; -- utbuktad..av.1
  utbuktande_1_A = mkA "utbuktande" ; -- utbuktande..av.1
  utbuktning_1_N = mkN "utbuktning" ; -- utbuktning..nn.1
  utbygga_1_V = mkV "utbygger" ; -- utbygga..vb.1
  utbyggande_1_N = mkN "utbyggande" ; -- utbyggande..nn.1
  utbyggbar_1_A = mkA "utbyggbar" ; -- utbyggbar..av.1
  utbyggbarhet_1_N = mkN "utbyggbarhet" ; -- utbyggbarhet..nn.1
  utbyggd_1_A = mkA "utbyggd" "utbyggt" ; -- utbyggd..av.1
  utbygge_1_N = mkN "utbygge" ; -- utbygge..nn.1
  utbyggnad_1_N = mkN "utbyggnad" "utbyggnader" ; -- utbyggnad..nn.1
  utbyta_1_V = mkV "utbyter" ; -- utbyta..vb.1
  utbytande_1_N = mkN "utbytande" ; -- utbytande..nn.1
  utbytbar_1_A = mkA "utbytbar" ; -- utbytbar..av.1
  utbytbarhet_1_N = mkN "utbytbarhet" "utbytbarheter" ; -- utbytbarhet..nn.1
  utbyte_1_N = mkN "utbyte" ; -- utbyte..nn.1
  utbytesbil_1_N = mkN "utbytesbil" ; -- utbytesbil..nn.1
  utbytlig_1_A = mkA "utbytlig" ; -- utbytlig..av.1
  utbytlighet_1_N = mkN "utbytlighet" ; -- utbytlighet..nn.1
  utbäring_1_N = mkN "utbäring" ; -- utbäring..nn.1
  utbärning_1_N = mkN "utbärning" ; -- utbärning..nn.1
  utböjning_1_N = mkN "utböjning" ; -- utböjning..nn.1
  utböling_1_N = mkN "utböling" ; -- utböling..nn.1
  utbörding_1_N = mkN "utbörding" ; -- utbörding..nn.1
  utcheckning_1_N = mkN "utcheckning" ; -- utcheckning..nn.1
  utdebitera_1_V = mkV "utdebiterar" ; -- utdebitera..vb.1
  utdebiterande_1_N = mkN "utdebiterande" ; -- utdebiterande..nn.1
  utdebiterbar_1_A = mkA "utdebiterbar" ; -- utdebiterbar..av.1
  utdebiterbarhet_1_N = mkN "utdebiterbarhet" ; -- utdebiterbarhet..nn.1
  utdebitering_1_N = mkN "utdebitering" ; -- utdebitering..nn.1
  utdela_1_V = mkV "utdelar" ; -- utdela..vb.1
  utdelande_1_N = mkN "utdelande" ; -- utdelande..nn.1
  utdelning_1_N = mkN "utdelning" ; -- utdelning..nn.1
  utdika_1_V = mkV "utdikar" ; -- utdika..vb.1
  utdikande_1_N = mkN "utdikande" ; -- utdikande..nn.1
  utdikning_1_N = mkN "utdikning" ; -- utdikning..nn.1
  utdockning_1_N = mkN "utdockning" ; -- utdockning..nn.1
  utdra_1_V = mkV "utdraga" "utdrog" "utdragit" ; -- utdra..vb.1
  utdrag_1_N = mkN "utdrag" neutrum  ; -- utdrag..nn.1
  utdragande_1_N = mkN "utdragande" ; -- utdragande..nn.1
  utdragare_1_N = mkN "utdragare" utrum  ; -- utdragare..nn.1
  utdragbar_1_A = mkA "utdragbar" ; -- utdragbar..av.1
  utdragbarhet_1_N = mkN "utdragbarhet" ; -- utdragbarhet..nn.1
  utdragen_1_A = mkA "utdragen" ; -- utdragen..av.1
  utdragning_1_N = mkN "utdragning" ; -- utdragning..nn.1
  utdragslåda_1_N = mkN "utdragslåda" ; -- utdragslåda..nn.1
  utdragssoffa_1_N = mkN "utdragssoffa" ; -- utdragssoffa..nn.1
  utdragssäng_1_N = mkN "utdragssäng" ; -- utdragssäng..nn.1
  utdragssöm_1_N = mkN "utdragssöm" "utdragssömmen" "utdragssömmar" "utdragssömmarna" ; -- utdragssöm..nn.1
  utdriva_1_V = mkV "utdriva" "utdrev" "utdrivit" ; -- utdriva..vb.1
  utdrivande_1_N = mkN "utdrivande" ; -- utdrivande..nn.1
  utdrivning_1_N = mkN "utdrivning" ; -- utdrivning..nn.1
  utdrucken_1_A = mkA "utdrucken" ; -- utdrucken..av.1
  utdunsta_1_V = mkV "utdunstar" ; -- utdunsta..vb.1
  utdunstande_1_N = mkN "utdunstande" ; -- utdunstande..nn.1
  utdunstning_1_N = mkN "utdunstning" ; -- utdunstning..nn.1
  utdunstningskärl_1_N = mkN "utdunstningskärl" neutrum  ; -- utdunstningskärl..nn.1
  utdöd_1_A = mkA "utdöd" "utdött" ; -- utdöd..av.1
  utdödhet_1_N = mkN "utdödhet" ; -- utdödhet..nn.1
  utdöende_1_N = mkN "utdöende" ; -- utdöende..nn.1
  utdöma_1_V = mkV "utdömer" ; -- utdöma..vb.1
  utdömande_1_N = mkN "utdömande" ; -- utdömande..nn.1
  utdömning_1_N = mkN "utdömning" ; -- utdömning..nn.1
  ute_1_A = mkA "ute" ; -- ute..av.1
  utearbete_1_N = mkN "utearbete" ; -- utearbete..nn.1
  utebli_1_V = mkV "utebliva" "uteblev" "uteblivit" ; -- utebli..vb.1
  utebliende_1_N = mkN "utebliende" ; -- utebliende..nn.1
  uteblivande_1_N = mkN "uteblivande" ; -- uteblivande..nn.1
  utebruk_1_N = mkN "utebruk" neutrum  ; -- utebruk..nn.1
  utedass_1_N = mkN "utedass" neutrum  ; -- utedass..nn.1
  uteffekt_1_N = mkN "uteffekt" ; -- uteffekt..nn.1
  utefår_1_N = mkN "utefår" neutrum  ; -- utefår..nn.1
  uteförsvar_1_N = mkN "uteförsvar" neutrum  ; -- uteförsvar..nn.1
  utegrill_1_N = mkN "utegrill" ; -- utegrill..nn.1
  utegångsfår_1_N = mkN "utegångsfår" neutrum  ; -- utegångsfår..nn.1
  utegångsförbud_1_N = mkN "utegångsförbud" neutrum  ; -- utegångsförbud..nn.1
  utekväll_1_N = mkN "utekväll" ; -- utekväll..nn.1
  utelag_1_N = mkN "utelag" neutrum  ; -- utelag..nn.1
  uteliggande_1_A = mkA "uteliggande" ; -- uteliggande..av.1
  uteliggare_1_N = mkN "uteliggare" utrum  ; -- uteliggare..nn.1
  uteliv_1_N = mkN "uteliv" neutrum  ; -- uteliv..nn.1
  utelämna_1_V = mkV "utelämnar" ; -- utelämna..vb.1
  utelämnande_1_N = mkN "utelämnande" ; -- utelämnande..nn.1
  utelämning_1_N = mkN "utelämning" ; -- utelämning..nn.1
  utelämningstecken_1_N = mkN "utelämningstecken" "utelämningstecknet" "utelämningstecken" "utelämningstecknen" ; -- utelämningstecken..nn.1
  utelåsa_1_V = mkV "utelåser" ; -- utelåsa..vb.1
  utelåsande_1_N = mkN "utelåsande" ; -- utelåsande..nn.1
  utelöpande_1_A = mkA "utelöpande" ; -- utelöpande..av.1
  utemiljö_1_N = mkN "utemiljö" "utemiljön" "utemiljöer" "utemiljöerna" ; -- utemiljö..nn.1
  utemöbel_1_N = mkN "utemöbel" "utemöbeln" "utemöbler" "utemöblerna" ; -- utemöbel..nn.1
  uteplats_1_N = mkN "uteplats" "uteplatser" ; -- uteplats..nn.1
  uterum_1_N = mkN "uterum" "uterummet" "uterum" "uterummen" ; -- uterum..nn.1
  uteservering_1_N = mkN "uteservering" ; -- uteservering..nn.1
  utesluta_1_V = mkV "utesluta" "uteslöt" "uteslutit" ; -- utesluta..vb.1
  uteslutande_1_N = mkN "uteslutande" ; -- uteslutande..nn.1
  uteslutning_1_N = mkN "uteslutning" ; -- uteslutning..nn.1
  uteslutningsmetod_1_N = mkN "uteslutningsmetod" ; -- uteslutningsmetod..nn.1
  utespelare_1_N = mkN "utespelare" utrum  ; -- utespelare..nn.1
  utestänga_1_V = mkV "utestänger" ; -- utestänga..vb.1
  utestängande_1_N = mkN "utestängande" ; -- utestängande..nn.1
  utestängning_1_N = mkN "utestängning" ; -- utestängning..nn.1
  utestående_1_A = mkA "utestående" ; -- utestående..av.1
  utetermometer_1_N = mkN "utetermometer" ; -- utetermometer..nn.1
  utevaro_1_N = mkN "utevaro" ; -- utevaro..nn.1
  utexaminera_1_V = mkV "utexaminerar" ; -- utexaminera..vb.1
  utexaminerande_1_N = mkN "utexaminerande" ; -- utexaminerande..nn.1
  utexaminerbar_1_A = mkA "utexaminerbar" ; -- utexaminerbar..av.1
  utexaminerbarhet_1_N = mkN "utexaminerbarhet" ; -- utexaminerbarhet..nn.1
  utexaminering_1_N = mkN "utexaminering" ; -- utexaminering..nn.1
  utexperimentera_1_V = mkV "utexperimenterar" ; -- utexperimentera..vb.1
  utexperimenterande_1_N = mkN "utexperimenterande" ; -- utexperimenterande..nn.1
  utexperimenterbar_1_A = mkA "utexperimenterbar" ; -- utexperimenterbar..av.1
  utexperimenterbarhet_1_N = mkN "utexperimenterbarhet" ; -- utexperimenterbarhet..nn.1
  utexperimentering_1_N = mkN "utexperimentering" ; -- utexperimentering..nn.1
  uteätare_1_N = mkN "uteätare" utrum  ; -- uteätare..nn.1
  utfall_1_N = mkN "utfall" neutrum  ; -- utfall..nn.1
  utfalla_1_V = mkV "utfalla" "utföll" "utfallit" ; -- utfalla..vb.1
  utfallande_1_N = mkN "utfallande" ; -- utfallande..nn.1
  utfallsdike_1_N = mkN "utfallsdike" ; -- utfallsdike..nn.1
  utfallsport_1_N = mkN "utfallsport" ; -- utfallsport..nn.1
  utfallsprov_1_N = mkN "utfallsprov" neutrum  ; -- utfallsprov..nn.1
  utfallsrum_1_N = mkN "utfallsrum" "utfallsrummet" "utfallsrum" "utfallsrummen" ; -- utfallsrum..nn.1
  utfallsrymd_1_N = mkN "utfallsrymd" "utfallsrymder" ; -- utfallsrymd..nn.1
  utfart_1_N = mkN "utfart" "utfarter" ; -- utfart..nn.1
  utfartsväg_1_N = mkN "utfartsväg" ; -- utfartsväg..nn.1
  utfattig_1_A = mkA "utfattig" ; -- utfattig..av.1
  utfattighet_1_N = mkN "utfattighet" ; -- utfattighet..nn.1
  utfestad_1_A = mkA "utfestad" ; -- utfestad..av.1
  utfiska_1_V = mkV "utfiskar" ; -- utfiska..vb.1
  utfiskande_1_N = mkN "utfiskande" ; -- utfiskande..nn.1
  utfiskning_1_N = mkN "utfiskning" ; -- utfiskning..nn.1
  utflagga_1_V = mkV "utflaggar" ; -- utflagga..vb.1
  utflaggande_1_N = mkN "utflaggande" ; -- utflaggande..nn.1
  utflaggning_1_N = mkN "utflaggning" ; -- utflaggning..nn.1
  utflugen_1_A = mkA "utflugen" ; -- utflugen..av.1
  utflykt_1_N = mkN "utflykt" "utflykter" ; -- utflykt..nn.1
  utflyktsmål_1_N = mkN "utflyktsmål" neutrum  ; -- utflyktsmål..nn.1
  utflyttning_1_N = mkN "utflyttning" ; -- utflyttning..nn.1
  utflyttningslän_1_N = mkN "utflyttningslän" neutrum  ; -- utflyttningslän..nn.1
  utflyttningslängd_1_N = mkN "utflyttningslängd" "utflyttningslängder" ; -- utflyttningslängd..nn.1
  utfläkartrend_1_N = mkN "utfläkartrend" "utfläkartrender" ; -- utfläkartrend..nn.1
  utfläkning_1_N = mkN "utfläkning" ; -- utfläkning..nn.1
  utflöde_1_N = mkN "utflöde" ; -- utflöde..nn.1
  utfodra_1_V = mkV "utfodrar" ; -- utfodra..vb.1
  utfodrande_1_N = mkN "utfodrande" ; -- utfodrande..nn.1
  utfodring_1_N = mkN "utfodring" ; -- utfodring..nn.1
  utfodringsjournal_1_N = mkN "utfodringsjournal" "utfodringsjournaler" ; -- utfodringsjournal..nn.1
  utfodringsstat_1_N = mkN "utfodringsstat" "utfodringsstater" ; -- utfodringsstat..nn.1
  utfordra_1_V = mkV "utfordrar" ; -- utfordra..vb.1
  utfordrande_1_N = mkN "utfordrande" ; -- utfordrande..nn.1
  utforma_1_V = mkV "utformar" ; -- utforma..vb.1
  utformande_1_N = mkN "utformande" ; -- utformande..nn.1
  utformning_1_N = mkN "utformning" ; -- utformning..nn.1
  utforska_1_V = mkV "utforskar" ; -- utforska..vb.1
  utforskande_1_N = mkN "utforskande" ; -- utforskande..nn.1
  utforskare_1_N = mkN "utforskare" utrum  ; -- utforskare..nn.1
  utforskning_1_N = mkN "utforskning" ; -- utforskning..nn.1
  utfrakta_1_V = mkV "utfraktar" ; -- utfrakta..vb.1
  utfraktande_1_N = mkN "utfraktande" ; -- utfraktande..nn.1
  utfrusen_1_A = mkA "utfrusen" ; -- utfrusen..av.1
  utfrysning_1_N = mkN "utfrysning" ; -- utfrysning..nn.1
  utfryst_1_A = mkA "utfryst" "utfryst" ; -- utfryst..av.1
  utfrysthet_1_N = mkN "utfrysthet" ; -- utfrysthet..nn.1
  utfråga_1_V = mkV "utfrågar" ; -- utfråga..vb.1
  utfrågande_1_N = mkN "utfrågande" ; -- utfrågande..nn.1
  utfrågning_1_N = mkN "utfrågning" ; -- utfrågning..nn.1
  utfundering_1_N = mkN "utfundering" ; -- utfundering..nn.1
  utfylla_1_V = mkV "utfyller" ; -- utfylla..vb.1
  utfyllande_1_N = mkN "utfyllande" ; -- utfyllande..nn.1
  utfyllnad_1_N = mkN "utfyllnad" "utfyllnader" ; -- utfyllnad..nn.1
  utfyllning_1_N = mkN "utfyllning" ; -- utfyllning..nn.1
  utfälla_1_V = mkV "utfäller" ; -- utfälla..vb.1
  utfällande_1_N = mkN "utfällande" ; -- utfällande..nn.1
  utfällbar_1_A = mkA "utfällbar" ; -- utfällbar..av.1
  utfällbarhet_1_N = mkN "utfällbarhet" ; -- utfällbarhet..nn.1
  utfällning_1_N = mkN "utfällning" ; -- utfällning..nn.1
  utfärd_1_N = mkN "utfärd" "utfärder" ; -- utfärd..nn.1
  utfärda_1_V = mkV "utfärdar" ; -- utfärda..vb.1
  utfärdande_1_N = mkN "utfärdande" ; -- utfärdande..nn.1
  utfästa_1_V = mkV "utfästa" "utfäster" "utfäst" "utfäste" "utfäst" "utfäst" ; -- utfästa..vb.1
  utfästande_1_N = mkN "utfästande" ; -- utfästande..nn.1
  utfästelse_1_N = mkN "utfästelse" "utfästelser" ; -- utfästelse..nn.1
  utfå_1_V = mkV "utfå" "utfick" "utfått" ; -- utfå..vb.1
  utfående_1_N = mkN "utfående" ; -- utfående..nn.1
  utföra_1_V = mkV "utföra" "utförde" "utfört" ; -- utföra..vb.1
  utförande_1_N = mkN "utförande" ; -- utförande..nn.1
  utförare_1_N = mkN "utförare" utrum  ; -- utförare..nn.1
  utförbar_1_A = mkA "utförbar" ; -- utförbar..av.1
  utförbarhet_1_N = mkN "utförbarhet" ; -- utförbarhet..nn.1
  utföring_1_N = mkN "utföring" ; -- utföring..nn.1
  utförlig_1_A = mkA "utförlig" ; -- utförlig..av.1
  utförlighet_1_N = mkN "utförlighet" ; -- utförlighet..nn.1
  utförsbacke_1_N = mkN "utförsbacke" utrum  ; -- utförsbacke..nn.1
  utförsel_1_N = mkN "utförsel" ; -- utförsel..nn.1
  utförsgåva_1_N = mkN "utförsgåva" ; -- utförsgåva..nn.1
  utförslöpa_1_N = mkN "utförslöpa" ; -- utförslöpa..nn.1
  utförsäkra_1_V = mkV "utförsäkrar" ; -- utförsäkra..vb.1
  utförsäkrande_1_N = mkN "utförsäkrande" ; -- utförsäkrande..nn.1
  utförsäkring_1_N = mkN "utförsäkring" ; -- utförsäkring..nn.1
  utförsälja_1_V = mkV "utförsälja" "utförsålde" "utförsålt" ; -- utförsälja..vb.1
  utförsäljande_1_N = mkN "utförsäljande" ; -- utförsäljande..nn.1
  utförsäljning_1_N = mkN "utförsäljning" ; -- utförsäljning..nn.1
  utförsåkare_1_N = mkN "utförsåkare" utrum  ; -- utförsåkare..nn.1
  utförsåkning_1_N = mkN "utförsåkning" ; -- utförsåkning..nn.1
  utfösning_1_N = mkN "utfösning" ; -- utfösning..nn.1
  utgallring_1_N = mkN "utgallring" ; -- utgallring..nn.1
  utge_1_V = mkV "utgiva" "utgav" "utgivit" ; -- utge..vb.1
  utgeende_1_N = mkN "utgeende" ; -- utgeende..nn.1
  utgift_1_N = mkN "utgift" "utgifter" ; -- utgift..nn.1
  utgiftsbudget_1_N = mkN "utgiftsbudget" ; -- utgiftsbudget..nn.1
  utgiftsdisciplin_1_N = mkN "utgiftsdisciplin" ; -- utgiftsdisciplin..nn.1
  utgiftspost_1_N = mkN "utgiftspost" "utgiftsposter" ; -- utgiftspost..nn.1
  utgiftssida_1_N = mkN "utgiftssida" ; -- utgiftssida..nn.1
  utgiftsskatt_1_N = mkN "utgiftsskatt" "utgiftsskatter" ; -- utgiftsskatt..nn.1
  utgiftsverifikation_1_N = mkN "utgiftsverifikation" ; -- utgiftsverifikation..nn.1
  utgivande_1_N = mkN "utgivande" ; -- utgivande..nn.1
  utgivare_1_N = mkN "utgivare" utrum  ; -- utgivare..nn.1
  utgivning_1_N = mkN "utgivning" ; -- utgivning..nn.1
  utgivningsbevis_1_N = mkN "utgivningsbevis" neutrum  ; -- utgivningsbevis..nn.1
  utgjuta_1_V = mkV "utgjuta" "utgöt" "utgjutit" ; -- utgjuta..vb.1
  utgjutande_1_N = mkN "utgjutande" ; -- utgjutande..nn.1
  utgjutelse_1_N = mkN "utgjutelse" "utgjutelser" ; -- utgjutelse..nn.1
  utgjutning_1_N = mkN "utgjutning" ; -- utgjutning..nn.1
  utglesa_1_V = mkV "utglesar" ; -- utglesa..vb.1
  utglesande_1_N = mkN "utglesande" ; -- utglesande..nn.1
  utglesning_1_N = mkN "utglesning" ; -- utglesning..nn.1
  utgrening_1_N = mkN "utgrening" ; -- utgrening..nn.1
  utgrunda_1_V = mkV "utgrundar" ; -- utgrunda..vb.1
  utgrundande_1_N = mkN "utgrundande" ; -- utgrundande..nn.1
  utgräva_1_V = mkV "utgräver" ; -- utgräva..vb.1
  utgrävande_1_N = mkN "utgrävande" ; -- utgrävande..nn.1
  utgrävare_1_N = mkN "utgrävare" utrum  ; -- utgrävare..nn.1
  utgrävning_1_N = mkN "utgrävning" ; -- utgrävning..nn.1
  utgrävningsplats_1_N = mkN "utgrävningsplats" "utgrävningsplatser" ; -- utgrävningsplats..nn.1
  utgrävningsresultat_1_N = mkN "utgrävningsresultat" neutrum  ; -- utgrävningsresultat..nn.1
  utgå_1_V = mkV "utgå" "utgår" "utgå" "utgick" "utgått" "utgången" ; -- utgå..vb.1
  utgående_1_A = mkA "utgående" ; -- utgående..av.1
  utgående_1_N = mkN "utgående" ; -- utgående..nn.1
  utgång_1_N = mkN "utgång" ; -- utgång..nn.1
  utgången_1_A = mkA "utgången" ; -- utgången..av.1
  utgångsdatum_1_N = mkN "utgångsdatum" neutrum  ; -- utgångsdatum..nn.1
  utgångsförutsättning_1_N = mkN "utgångsförutsättning" ; -- utgångsförutsättning..nn.1
  utgångshastighet_1_N = mkN "utgångshastighet" "utgångshastigheter" ; -- utgångshastighet..nn.1
  utgångsläge_1_N = mkN "utgångsläge" ; -- utgångsläge..nn.1
  utgångsmarsch_1_N = mkN "utgångsmarsch" "utgångsmarscher" ; -- utgångsmarsch..nn.1
  utgångsmaterial_1_N = mkN "utgångsmaterial" neutrum  ; -- utgångsmaterial..nn.1
  utgångsposition_1_N = mkN "utgångsposition" ; -- utgångsposition..nn.1
  utgångspunkt_1_N = mkN "utgångspunkt" "utgångspunkter" ; -- utgångspunkt..nn.1
  utgångsrad_1_N = mkN "utgångsrad" "utgångsrader" ; -- utgångsrad..nn.1
  utgångsställning_1_N = mkN "utgångsställning" ; -- utgångsställning..nn.1
  utgård_1_N = mkN "utgård" ; -- utgård..nn.1
  utgåva_1_N = mkN "utgåva" ; -- utgåva..nn.1
  utgödsling_1_N = mkN "utgödsling" ; -- utgödsling..nn.1
  utgöra_1_V = mkV "utgöra" "utgjorde" "utgjort" ; -- utgöra..vb.1
  utgörande_1_N = mkN "utgörande" ; -- utgörande..nn.1
  uthalare_1_N = mkN "uthalare" utrum  ; -- uthalare..nn.1
  uthamn_1_N = mkN "uthamn" ; -- uthamn..nn.1
  uthamra_1_V = mkV "uthamrar" ; -- uthamra..vb.1
  uthamrande_1_N = mkN "uthamrande" ; -- uthamrande..nn.1
  uthopp_1_N = mkN "uthopp" neutrum  ; -- uthopp..nn.1
  uthuggning_1_N = mkN "uthuggning" ; -- uthuggning..nn.1
  uthungrad_1_A = mkA "uthungrad" ; -- uthungrad..av.1
  uthungring_1_N = mkN "uthungring" ; -- uthungring..nn.1
  uthus_1_N = mkN "uthus" neutrum  ; -- uthus..nn.1
  uthusnyckel_1_N = mkN "uthusnyckel" ; -- uthusnyckel..nn.1
  uthusvägg_1_N = mkN "uthusvägg" ; -- uthusvägg..nn.1
  uthyra_1_V = mkV "uthyra" "uthyrde" "uthyrt" ; -- uthyra..vb.1
  uthyrande_1_N = mkN "uthyrande" ; -- uthyrande..nn.1
  uthyrning_1_N = mkN "uthyrning" ; -- uthyrning..nn.1
  uthyrningsrum_1_N = mkN "uthyrningsrum" "uthyrningsrummet" "uthyrningsrum" "uthyrningsrummen" ; -- uthyrningsrum..nn.1
  uthällning_1_N = mkN "uthällning" ; -- uthällning..nn.1
  uthärda_1_V = mkV "uthärdar" ; -- uthärda..vb.1
  uthärdande_1_N = mkN "uthärdande" ; -- uthärdande..nn.1
  uthärdlig_1_A = mkA "uthärdlig" ; -- uthärdlig..av.1
  uthärdlighet_1_N = mkN "uthärdlighet" ; -- uthärdlighet..nn.1
  uthållig_1_A = mkA "uthållig" ; -- uthållig..av.1
  uthållighet_1_N = mkN "uthållighet" "uthålligheter" ; -- uthållighet..nn.1
  uthållighetslöpning_1_N = mkN "uthållighetslöpning" ; -- uthållighetslöpning..nn.1
  uthållighetstävling_1_N = mkN "uthållighetstävling" ; -- uthållighetstävling..nn.1
  uthållning_1_N = mkN "uthållning" ; -- uthållning..nn.1
  utifrån_1_Adv = mkAdv "utifrån" ; -- utifrån..ab.1
  utifrånperspektiv_1_N = mkN "utifrånperspektiv" neutrum  ; -- utifrånperspektiv..nn.1
  utilism_1_N = mkN "utilism" "utilismer" ; -- utilism..nn.1
  utilist_1_N = mkN "utilist" "utilister" ; -- utilist..nn.1
  utilistisk_1_A = mkA "utilistisk" ; -- utilistisk..av.1
  utilitarism_1_N = mkN "utilitarism" "utilitarismer" ; -- utilitarism..nn.1
  utilitarist_1_N = mkN "utilitarist" "utilitarister" ; -- utilitarist..nn.1
  utilitaristisk_1_A = mkA "utilitaristisk" ; -- utilitaristisk..av.1
  utjord_1_N = mkN "utjord" ; -- utjord..nn.1
  utjämna_1_V = mkV "utjämnar" ; -- utjämna..vb.1
  utjämnande_1_N = mkN "utjämnande" ; -- utjämnande..nn.1
  utjämning_1_N = mkN "utjämning" ; -- utjämning..nn.1
  utjämningsmandat_1_N = mkN "utjämningsmandat" neutrum  ; -- utjämningsmandat..nn.1
  utkamma_1_V = mkV "utkammar" ; -- utkamma..vb.1
  utkammande_1_N = mkN "utkammande" ; -- utkammande..nn.1
  utkant_1_N = mkN "utkant" "utkanter" ; -- utkant..nn.1
  utkast_1_N = mkN "utkast" neutrum  ; -- utkast..nn.1
  utkasta_1_V = mkV "utkastar" ; -- utkasta..vb.1
  utkastande_1_N = mkN "utkastande" ; -- utkastande..nn.1
  utkastare_1_N = mkN "utkastare" utrum  ; -- utkastare..nn.1
  utkastning_1_N = mkN "utkastning" ; -- utkastning..nn.1
  utkavling_1_N = mkN "utkavling" ; -- utkavling..nn.1
  utkik_1_N = mkN "utkik" ; -- utkik..nn.1
  utkiksplats_1_N = mkN "utkiksplats" "utkiksplatser" ; -- utkiksplats..nn.1
  utkikspost_1_N = mkN "utkikspost" "utkiksposter" ; -- utkikspost..nn.1
  utkikspunkt_1_N = mkN "utkikspunkt" "utkikspunkter" ; -- utkikspunkt..nn.1
  utkikstorn_1_N = mkN "utkikstorn" neutrum  ; -- utkikstorn..nn.1
  utklara_1_V = mkV "utklarar" ; -- utklara..vb.1
  utklarande_1_N = mkN "utklarande" ; -- utklarande..nn.1
  utklarera_1_V = mkV "utklarerar" ; -- utklarera..vb.1
  utklarerande_1_N = mkN "utklarerande" ; -- utklarerande..nn.1
  utklarerbar_1_A = mkA "utklarerbar" ; -- utklarerbar..av.1
  utklarerbarhet_1_N = mkN "utklarerbarhet" ; -- utklarerbarhet..nn.1
  utklarering_1_N = mkN "utklarering" ; -- utklarering..nn.1
  utklassa_1_V = mkV "utklassar" ; -- utklassa..vb.1
  utklassande_1_N = mkN "utklassande" ; -- utklassande..nn.1
  utklassning_1_N = mkN "utklassning" ; -- utklassning..nn.1
  utklipp_1_N = mkN "utklipp" neutrum  ; -- utklipp..nn.1
  utklyva_1_V = mkV "utklyva" "utklöv" "utkluvit" ; -- utklyva..vb.1
  utklyvande_1_N = mkN "utklyvande" ; -- utklyvande..nn.1
  utkläckning_1_N = mkN "utkläckning" ; -- utkläckning..nn.1
  utklädd_1_A = mkA "utklädd" ; -- utklädd..av.1
  utklädning_1_N = mkN "utklädning" ; -- utklädning..nn.1
  utklädsel_1_N = mkN "utklädsel" ; -- utklädsel..nn.1
  utklängning_1_N = mkN "utklängning" ; -- utklängning..nn.1
  utknuffning_1_N = mkN "utknuffning" ; -- utknuffning..nn.1
  utkomma_1_V = mkV "utkomma" "utkom" "utkommit" ; -- utkomma..vb.1
  utkommande_1_N = mkN "utkommande" ; -- utkommande..nn.1
  utkommendera_1_V = mkV "utkommenderar" ; -- utkommendera..vb.1
  utkommenderande_1_N = mkN "utkommenderande" ; -- utkommenderande..nn.1
  utkommenderbar_1_A = mkA "utkommenderbar" ; -- utkommenderbar..av.1
  utkommenderbarhet_1_N = mkN "utkommenderbarhet" ; -- utkommenderbarhet..nn.1
  utkommendering_1_N = mkN "utkommendering" ; -- utkommendering..nn.1
  utkomst_1_N = mkN "utkomst" ; -- utkomst..nn.1
  utkonkurrera_1_V = mkV "utkonkurrerar" ; -- utkonkurrera..vb.1
  utkonkurrerande_1_N = mkN "utkonkurrerande" ; -- utkonkurrerande..nn.1
  utkonkurrerbar_1_A = mkA "utkonkurrerbar" ; -- utkonkurrerbar..av.1
  utkonkurrerbarhet_1_N = mkN "utkonkurrerbarhet" ; -- utkonkurrerbarhet..nn.1
  utkonkurrering_1_N = mkN "utkonkurrering" ; -- utkonkurrering..nn.1
  utkora_1_V = mkV "utkorar" ; -- utkora..vb.1
  utkorad_1_A = mkA "utkorad" ; -- utkorad..av.1
  utkorande_1_N = mkN "utkorande" ; -- utkorande..nn.1
  utkorelse_1_N = mkN "utkorelse" "utkorelser" ; -- utkorelse..nn.1
  utkragning_1_N = mkN "utkragning" ; -- utkragning..nn.1
  utkramning_1_N = mkN "utkramning" ; -- utkramning..nn.1
  utkristallisera_1_V = mkV "utkristalliserar" ; -- utkristallisera..vb.1
  utkristalliserande_1_N = mkN "utkristalliserande" ; -- utkristalliserande..nn.1
  utkristalliserbar_1_A = mkA "utkristalliserbar" ; -- utkristalliserbar..av.1
  utkristalliserbarhet_1_N = mkN "utkristalliserbarhet" ; -- utkristalliserbarhet..nn.1
  utkristallisering_1_N = mkN "utkristallisering" ; -- utkristallisering..nn.1
  utkräva_1_V = mkV "utkräver" ; -- utkräva..vb.1
  utkrävande_1_N = mkN "utkrävande" ; -- utkrävande..nn.1
  utkrävning_1_N = mkN "utkrävning" ; -- utkrävning..nn.1
  utkvittera_1_V = mkV "utkvitterar" ; -- utkvittera..vb.1
  utkvitterande_1_N = mkN "utkvitterande" ; -- utkvitterande..nn.1
  utkvitterbar_1_A = mkA "utkvitterbar" ; -- utkvitterbar..av.1
  utkvitterbarhet_1_N = mkN "utkvitterbarhet" ; -- utkvitterbarhet..nn.1
  utkvittering_1_N = mkN "utkvittering" ; -- utkvittering..nn.1
  utkvittning_1_N = mkN "utkvittning" ; -- utkvittning..nn.1
  utkyla_1_V = mkV "utkyler" ; -- utkyla..vb.1
  utkylande_1_N = mkN "utkylande" ; -- utkylande..nn.1
  utkyld_1_A = mkA "utkyld" "utkylt" ; -- utkyld..av.1
  utkyldhet_1_N = mkN "utkyldhet" ; -- utkyldhet..nn.1
  utkylning_1_N = mkN "utkylning" ; -- utkylning..nn.1
  utkämpa_1_V = mkV "utkämpar" ; -- utkämpa..vb.1
  utkämpande_1_N = mkN "utkämpande" ; -- utkämpande..nn.1
  utkörare_1_N = mkN "utkörare" utrum  ; -- utkörare..nn.1
  utkörd_1_A = mkA "utkörd" "utkört" ; -- utkörd..av.1
  utkördhet_1_N = mkN "utkördhet" ; -- utkördhet..nn.1
  utkörning_1_N = mkN "utkörning" ; -- utkörning..nn.1
  utland_1_N = mkN "utland" neutrum  ; -- utland..nn.1
  utlandsberoende_1_A = mkA "utlandsberoende" ; -- utlandsberoende..av.1
  utlandsberoende_1_N = mkN "utlandsberoende" ; -- utlandsberoende..nn.1
  utlandsfödd_1_A = mkA "utlandsfödd" ; -- utlandsfödd..av.1
  utlandsförsäljning_1_N = mkN "utlandsförsäljning" ; -- utlandsförsäljning..nn.1
  utlandskorrespondent_1_N = mkN "utlandskorrespondent" "utlandskorrespondenter" ; -- utlandskorrespondent..nn.1
  utlandslektor_1_N = mkN "utlandslektor" "utlandslektorer" ; -- utlandslektor..nn.1
  utlandsresa_1_N = mkN "utlandsresa" ; -- utlandsresa..nn.1
  utlandssamtal_1_N = mkN "utlandssamtal" neutrum  ; -- utlandssamtal..nn.1
  utlandssoldat_1_N = mkN "utlandssoldat" "utlandssoldater" ; -- utlandssoldat..nn.1
  utlandssvensk_1_N = mkN "utlandssvensk" ; -- utlandssvensk..nn.1
  utlandssvenska_1_N = mkN "utlandssvenska" ; -- utlandssvenska..nn.1
  utlandstjänst_1_N = mkN "utlandstjänst" ; -- utlandstjänst..nn.1
  utlandsuppdrag_1_N = mkN "utlandsuppdrag" neutrum  ; -- utlandsuppdrag..nn.1
  utlasande_1_N = mkN "utlasande" ; -- utlasande..nn.1
  utlasning_1_N = mkN "utlasning" ; -- utlasning..nn.1
  utled_1_A = mkA "utled" "utlett" ; -- utled..av.1
  utledhet_1_N = mkN "utledhet" ; -- utledhet..nn.1
  utledsen_1_A = mkA "utledsen" ; -- utledsen..av.1
  utlevad_1_A = mkA "utlevad" ; -- utlevad..av.1
  utlevande_1_A = mkA "utlevande" ; -- utlevande..av.1
  utlevelse_1_N = mkN "utlevelse" utrum  ; -- utlevelse..nn.1
  utliggare_1_N = mkN "utliggare" utrum  ; -- utliggare..nn.1
  utljud_1_N = mkN "utljud" neutrum  ; -- utljud..nn.1
  utloggning_1_N = mkN "utloggning" ; -- utloggning..nn.1
  utlokalisera_1_V = mkV "utlokaliserar" ; -- utlokalisera..vb.1
  utlokaliserande_1_N = mkN "utlokaliserande" ; -- utlokaliserande..nn.1
  utlokaliserbar_1_A = mkA "utlokaliserbar" ; -- utlokaliserbar..av.1
  utlokaliserbarhet_1_N = mkN "utlokaliserbarhet" ; -- utlokaliserbarhet..nn.1
  utlokalisering_1_N = mkN "utlokalisering" ; -- utlokalisering..nn.1
  utlopp_1_N = mkN "utlopp" neutrum  ; -- utlopp..nn.1
  utlotta_1_V = mkV "utlottar" ; -- utlotta..vb.1
  utlottande_1_N = mkN "utlottande" ; -- utlottande..nn.1
  utlottning_1_N = mkN "utlottning" ; -- utlottning..nn.1
  utlova_1_V = mkV "utlovar" ; -- utlova..vb.1
  utlovande_1_N = mkN "utlovande" ; -- utlovande..nn.1
  utlupen_1_A = mkA "utlupen" ; -- utlupen..av.1
  utlysa_1_V = mkV "utlyser" ; -- utlysa..vb.1
  utlysande_1_N = mkN "utlysande" ; -- utlysande..nn.1
  utlysning_1_N = mkN "utlysning" ; -- utlysning..nn.1
  utlägg_1_N = mkN "utlägg" neutrum  ; -- utlägg..nn.1
  utlägga_1_V = mkV "utlägga" "utla" "utlagt" ; -- utlägga..vb.1
  utläggande_1_N = mkN "utläggande" ; -- utläggande..nn.1
  utläggare_1_N = mkN "utläggare" utrum  ; -- utläggare..nn.1
  utläggning_1_N = mkN "utläggning" ; -- utläggning..nn.1
  utlämna_1_V = mkV "utlämnar" ; -- utlämna..vb.1
  utlämnande_1_N = mkN "utlämnande" ; -- utlämnande..nn.1
  utlämning_1_N = mkN "utlämning" ; -- utlämning..nn.1
  utlämningsförfarande_1_N = mkN "utlämningsförfarande" ; -- utlämningsförfarande..nn.1
  utländsk_1_A = mkA "utländsk" ; -- utländsk..av.1
  utländska_1_N = mkN "utländska" ; -- utländska..nn.1
  utländska_2_N = mkN "utländska" ; -- utländska..nn.2
  utlänning_1_N = mkN "utlänning" ; -- utlänning..nn.1
  utlänningslag_1_N = mkN "utlänningslag" ; -- utlänningslag..nn.1
  utlärd_1_A = mkA "utlärd" "utlärt" ; -- utlärd..av.1
  utläsa_1_V = mkV "utläser" ; -- utläsa..vb.1
  utläsande_1_N = mkN "utläsande" ; -- utläsande..nn.1
  utläsbar_1_A = mkA "utläsbar" ; -- utläsbar..av.1
  utläsbarhet_1_N = mkN "utläsbarhet" ; -- utläsbarhet..nn.1
  utlåna_1_V = mkV "utlånar" ; -- utlåna..vb.1
  utlånande_1_N = mkN "utlånande" ; -- utlånande..nn.1
  utlånare_1_N = mkN "utlånare" utrum  ; -- utlånare..nn.1
  utlåning_1_N = mkN "utlåning" ; -- utlåning..nn.1
  utlåtande_1_N = mkN "utlåtande" ; -- utlåtande..nn.1
  utlåtelse_1_N = mkN "utlåtelse" "utlåtelser" ; -- utlåtelse..nn.1
  utlöpa_1_V = mkV "utlöpa" "utlöper" "utlöp" "utlöpte" "utlöpt" "utlupen" ; -- utlöpa..vb.1
  utlöpande_1_N = mkN "utlöpande" ; -- utlöpande..nn.1
  utlöpare_1_N = mkN "utlöpare" utrum  ; -- utlöpare..nn.1
  utlösa_1_V = mkV "utlöser" ; -- utlösa..vb.1
  utlösande_1_N = mkN "utlösande" ; -- utlösande..nn.1
  utlösare_1_N = mkN "utlösare" utrum  ; -- utlösare..nn.1
  utlösning_1_N = mkN "utlösning" ; -- utlösning..nn.1
  utmana_1_V = mkV "utmanar" ; -- utmana..vb.1
  utmanande_1_A = mkA "utmanande" ; -- utmanande..av.1
  utmanande_1_N = mkN "utmanande" ; -- utmanande..nn.1
  utmanare_1_N = mkN "utmanare" utrum  ; -- utmanare..nn.1
  utmaning_1_N = mkN "utmaning" ; -- utmaning..nn.1
  utmanövrera_1_V = mkV "utmanövrerar" ; -- utmanövrera..vb.1
  utmanövrerande_1_N = mkN "utmanövrerande" ; -- utmanövrerande..nn.1
  utmanövrerbar_1_A = mkA "utmanövrerbar" ; -- utmanövrerbar..av.1
  utmanövrerbarhet_1_N = mkN "utmanövrerbarhet" ; -- utmanövrerbarhet..nn.1
  utmanövrering_1_N = mkN "utmanövrering" ; -- utmanövrering..nn.1
  utmark_1_N = mkN "utmark" "utmarker" ; -- utmark..nn.1
  utmarsch_1_N = mkN "utmarsch" "utmarscher" ; -- utmarsch..nn.1
  utmatning_1_N = mkN "utmatning" ; -- utmatning..nn.1
  utmatta_1_V = mkV "utmattar" ; -- utmatta..vb.1
  utmattad_1_A = mkA "utmattad" ; -- utmattad..av.1
  utmattande_1_N = mkN "utmattande" ; -- utmattande..nn.1
  utmattning_1_N = mkN "utmattning" ; -- utmattning..nn.1
  utmattningsbrott_1_N = mkN "utmattningsbrott" neutrum  ; -- utmattningsbrott..nn.1
  utmattningsdepression_1_N = mkN "utmattningsdepression" ; -- utmattningsdepression..nn.1
  utmattningslång_1_A = mkA "utmattningslång" ; -- utmattningslång..av.1
  utmattningsskada_1_N = mkN "utmattningsskada" ; -- utmattningsskada..nn.1
  utmattningssyndrom_1_N = mkN "utmattningssyndrom" neutrum  ; -- utmattningssyndrom..nn.1
  utmejsla_1_V = mkV "utmejslar" ; -- utmejsla..vb.1
  utmejslande_1_N = mkN "utmejslande" ; -- utmejslande..nn.1
  utminutera_1_V = mkV "utminuterar" ; -- utminutera..vb.1
  utminuterande_1_N = mkN "utminuterande" ; -- utminuterande..nn.1
  utminuterbar_1_A = mkA "utminuterbar" ; -- utminuterbar..av.1
  utminuterbarhet_1_N = mkN "utminuterbarhet" ; -- utminuterbarhet..nn.1
  utminutering_1_N = mkN "utminutering" ; -- utminutering..nn.1
  utmotning_1_N = mkN "utmotning" ; -- utmotning..nn.1
  utmynna_1_V = mkV "utmynnar" ; -- utmynna..vb.1
  utmynnande_1_N = mkN "utmynnande" ; -- utmynnande..nn.1
  utmärgla_1_V = mkV "utmärglar" ; -- utmärgla..vb.1
  utmärglad_1_A = mkA "utmärglad" ; -- utmärglad..av.1
  utmärglande_1_N = mkN "utmärglande" ; -- utmärglande..nn.1
  utmärgling_1_N = mkN "utmärgling" ; -- utmärgling..nn.1
  utmärka_1_V = mkV "utmärker" ; -- utmärka..vb.1
  utmärkande_1_A = mkA "utmärkande" ; -- utmärkande..av.1
  utmärkande_1_N = mkN "utmärkande" ; -- utmärkande..nn.1
  utmärkelse_1_N = mkN "utmärkelse" "utmärkelser" ; -- utmärkelse..nn.1
  utmärkning_1_N = mkN "utmärkning" ; -- utmärkning..nn.1
  utmärkt_1_A = mkA "utmärkt" "utmärkt" ; -- utmärkt..av.1
  utmärkthet_1_N = mkN "utmärkthet" ; -- utmärkthet..nn.1
  utmäta_1_V = mkV "utmäter" ; -- utmäta..vb.1
  utmätande_1_N = mkN "utmätande" ; -- utmätande..nn.1
  utmätning_1_N = mkN "utmätning" ; -- utmätning..nn.1
  utmål_1_N = mkN "utmål" neutrum  ; -- utmål..nn.1
  utmåla_1_V = mkV "utmålar" ; -- utmåla..vb.1
  utmålande_1_N = mkN "utmålande" ; -- utmålande..nn.1
  utmålning_1_N = mkN "utmålning" ; -- utmålning..nn.1
  utmönstra_1_V = mkV "utmönstrar" ; -- utmönstra..vb.1
  utmönstrande_1_N = mkN "utmönstrande" ; -- utmönstrande..nn.1
  utmönstring_1_N = mkN "utmönstring" ; -- utmönstring..nn.1
  utnyttja_1_V = mkV "utnyttjar" ; -- utnyttja..vb.1
  utnyttjande_1_N = mkN "utnyttjande" ; -- utnyttjande..nn.1
  utnyttjare_1_N = mkN "utnyttjare" utrum  ; -- utnyttjare..nn.1
  utnämna_1_V = mkV "utnämner" ; -- utnämna..vb.1
  utnämnande_1_N = mkN "utnämnande" ; -- utnämnande..nn.1
  utnämning_1_N = mkN "utnämning" ; -- utnämning..nn.1
  utnötning_1_N = mkN "utnötning" ; -- utnötning..nn.1
  utnött_1_A = mkA "utnött" ; -- utnött..av.1
  utnötthet_1_N = mkN "utnötthet" ; -- utnötthet..nn.1
  utochinvändning_1_N = mkN "utochinvändning" ; -- utochinvändning..nn.1
  utombordare_1_N = mkN "utombordare" utrum  ; -- utombordare..nn.1
  utombordsmotor_1_N = mkN "utombordsmotor" "utombordsmotorer" ; -- utombordsmotor..nn.1
  utomeuropeisk_1_A = mkA "utomeuropeisk" ; -- utomeuropeisk..av.1
  utomhusarbete_1_N = mkN "utomhusarbete" ; -- utomhusarbete..nn.1
  utomhusbad_1_N = mkN "utomhusbad" neutrum  ; -- utomhusbad..nn.1
  utomhusbar_1_N = mkN "utomhusbar" "utomhusbarer" ; -- utomhusbar..nn.1
  utomhusbelysning_1_N = mkN "utomhusbelysning" ; -- utomhusbelysning..nn.1
  utomhusbruk_1_N = mkN "utomhusbruk" neutrum  ; -- utomhusbruk..nn.1
  utomhuskonsert_1_N = mkN "utomhuskonsert" "utomhuskonserter" ; -- utomhuskonsert..nn.1
  utomhuslampa_1_N = mkN "utomhuslampa" ; -- utomhuslampa..nn.1
  utomhuslöpning_1_N = mkN "utomhuslöpning" ; -- utomhuslöpning..nn.1
  utomhusvistelse_1_N = mkN "utomhusvistelse" "utomhusvistelser" ; -- utomhusvistelse..nn.1
  utomjording_1_N = mkN "utomjording" ; -- utomjording..nn.1
  utomjordisk_1_A = mkA "utomjordisk" ; -- utomjordisk..av.1
  utomkroppslig_1_A = mkA "utomkroppslig" ; -- utomkroppslig..av.1
  utomkroppslighet_1_N = mkN "utomkroppslighet" ; -- utomkroppslighet..nn.1
  utomkvedshavandeskap_1_N = mkN "utomkvedshavandeskap" neutrum  ; -- utomkvedshavandeskap..nn.1
  utommänsklig_1_A = mkA "utommänsklig" ; -- utommänsklig..av.1
  utommänsklighet_1_N = mkN "utommänsklighet" ; -- utommänsklighet..nn.1
  utomnordisk_1_A = mkA "utomnordisk" ; -- utomnordisk..av.1
  utomordentlig_1_A = mkA "utomordentlig" ; -- utomordentlig..av.1
  utomordentlighet_1_N = mkN "utomordentlighet" ; -- utomordentlighet..nn.1
  utomparlamentarisk_1_A = mkA "utomparlamentarisk" ; -- utomparlamentarisk..av.1
  utomrättslig_1_A = mkA "utomrättslig" ; -- utomrättslig..av.1
  utomstående_1_A = mkA "utomstående" ; -- utomstående..av.1
  utomäktenskaplig_1_A = mkA "utomäktenskaplig" ; -- utomäktenskaplig..av.1
  utomäktenskaplighet_1_N = mkN "utomäktenskaplighet" ; -- utomäktenskaplighet..nn.1
  utopi_1_N = mkN "utopi" "utopier" ; -- utopi..nn.1
  utopisk_1_A = mkA "utopisk" ; -- utopisk..av.1
  utopist_1_N = mkN "utopist" "utopister" ; -- utopist..nn.1
  utpeka_1_V = mkV "utpekar" ; -- utpeka..vb.1
  utpekande_1_N = mkN "utpekande" ; -- utpekande..nn.1
  utpekning_1_N = mkN "utpekning" ; -- utpekning..nn.1
  utpinad_1_A = mkA "utpinad" ; -- utpinad..av.1
  utplacera_1_V = mkV "utplacerar" ; -- utplacera..vb.1
  utplacerande_1_N = mkN "utplacerande" ; -- utplacerande..nn.1
  utplacerbar_1_A = mkA "utplacerbar" ; -- utplacerbar..av.1
  utplacerbarhet_1_N = mkN "utplacerbarhet" ; -- utplacerbarhet..nn.1
  utplacering_1_N = mkN "utplacering" ; -- utplacering..nn.1
  utplattande_1_N = mkN "utplattande" ; -- utplattande..nn.1
  utplattning_1_N = mkN "utplattning" ; -- utplattning..nn.1
  utplockning_1_N = mkN "utplockning" ; -- utplockning..nn.1
  utplundra_1_V = mkV "utplundrar" ; -- utplundra..vb.1
  utplundrande_1_N = mkN "utplundrande" ; -- utplundrande..nn.1
  utplåna_1_V = mkV "utplånar" ; -- utplåna..vb.1
  utplånande_1_N = mkN "utplånande" ; -- utplånande..nn.1
  utplåning_1_N = mkN "utplåning" ; -- utplåning..nn.1
  utportionering_1_N = mkN "utportionering" ; -- utportionering..nn.1
  utpost_1_N = mkN "utpost" "utposter" ; -- utpost..nn.1
  utpostera_1_V = mkV "utposterar" ; -- utpostera..vb.1
  utposterad_1_A = mkA "utposterad" ; -- utposterad..av.1
  utposterande_1_N = mkN "utposterande" ; -- utposterande..nn.1
  utposterbar_1_A = mkA "utposterbar" ; -- utposterbar..av.1
  utposterbarhet_1_N = mkN "utposterbarhet" ; -- utposterbarhet..nn.1
  utpressa_1_V = mkV "utpressar" ; -- utpressa..vb.1
  utpressande_1_N = mkN "utpressande" ; -- utpressande..nn.1
  utpressare_1_N = mkN "utpressare" utrum  ; -- utpressare..nn.1
  utpressning_1_N = mkN "utpressning" ; -- utpressning..nn.1
  utpressningsmedel_1_N = mkN "utpressningsmedel" neutrum  ; -- utpressningsmedel..nn.1
  utpressningsrättegång_1_N = mkN "utpressningsrättegång" ; -- utpressningsrättegång..nn.1
  utpressningssituation_1_N = mkN "utpressningssituation" ; -- utpressningssituation..nn.1
  utpressningssyfte_1_N = mkN "utpressningssyfte" ; -- utpressningssyfte..nn.1
  utpricka_1_V = mkV "utprickar" ; -- utpricka..vb.1
  utprickande_1_N = mkN "utprickande" ; -- utprickande..nn.1
  utprickning_1_N = mkN "utprickning" ; -- utprickning..nn.1
  utprova_1_V = mkV "utprovar" ; -- utprova..vb.1
  utprovande_1_N = mkN "utprovande" ; -- utprovande..nn.1
  utpräglad_1_A = mkA "utpräglad" ; -- utpräglad..av.1
  utpröva_1_V = mkV "utprövar" ; -- utpröva..vb.1
  utprövande_1_N = mkN "utprövande" ; -- utprövande..nn.1
  utpumpad_1_A = mkA "utpumpad" ; -- utpumpad..av.1
  utpyntad_1_A = mkA "utpyntad" ; -- utpyntad..av.1
  utradera_1_V = mkV "utraderar" ; -- utradera..vb.1
  utraderande_1_N = mkN "utraderande" ; -- utraderande..nn.1
  utraderbar_1_A = mkA "utraderbar" ; -- utraderbar..av.1
  utraderbarhet_1_N = mkN "utraderbarhet" ; -- utraderbarhet..nn.1
  utradering_1_N = mkN "utradering" ; -- utradering..nn.1
  utrangera_1_V = mkV "utrangerar" ; -- utrangera..vb.1
  utrangerande_1_N = mkN "utrangerande" ; -- utrangerande..nn.1
  utrangerbar_1_A = mkA "utrangerbar" ; -- utrangerbar..av.1
  utrangerbarhet_1_N = mkN "utrangerbarhet" ; -- utrangerbarhet..nn.1
  utrangering_1_N = mkN "utrangering" ; -- utrangering..nn.1
  utreda_1_V = mkV "utreda" "utredde" "utrett" ; -- utreda..vb.1
  utredande_1_N = mkN "utredande" ; -- utredande..nn.1
  utredare_1_N = mkN "utredare" utrum  ; -- utredare..nn.1
  utredbar_1_A = mkA "utredbar" ; -- utredbar..av.1
  utredbarhet_1_N = mkN "utredbarhet" ; -- utredbarhet..nn.1
  utredning_1_N = mkN "utredning" ; -- utredning..nn.1
  utredningsarbete_1_N = mkN "utredningsarbete" ; -- utredningsarbete..nn.1
  utredningsläge_1_N = mkN "utredningsläge" ; -- utredningsläge..nn.1
  utredningsman_1_N = mkN "utredningsman" "utredningsmannen" "utredningsmän" "utredningsmännen" ; -- utredningsman..nn.1
  utredningsmaterial_1_N = mkN "utredningsmaterial" neutrum  ; -- utredningsmaterial..nn.1
  utredningsmässig_1_A = mkA "utredningsmässig" ; -- utredningsmässig..av.1
  utredningsteknisk_1_A = mkA "utredningsteknisk" ; -- utredningsteknisk..av.1
  utrensa_1_V = mkV "utrensar" ; -- utrensa..vb.1
  utrensande_1_N = mkN "utrensande" ; -- utrensande..nn.1
  utrensning_1_N = mkN "utrensning" ; -- utrensning..nn.1
  utrensningsaktion_1_N = mkN "utrensningsaktion" ; -- utrensningsaktion..nn.1
  utrerad_1_A = mkA "utrerad" ; -- utrerad..av.1
  utresa_1_N = mkN "utresa" ; -- utresa..nn.1
  utreseförbud_1_N = mkN "utreseförbud" neutrum  ; -- utreseförbud..nn.1
  utresetillstånd_1_N = mkN "utresetillstånd" neutrum  ; -- utresetillstånd..nn.1
  utriggad_1_A = mkA "utriggad" ; -- utriggad..av.1
  utriggare_1_N = mkN "utriggare" utrum  ; -- utriggare..nn.1
  utrikes_1_A = mkA "utrikes" ; -- utrikes..av.1
  utrikesavgång_1_N = mkN "utrikesavgång" ; -- utrikesavgång..nn.1
  utrikesdebatt_1_N = mkN "utrikesdebatt" "utrikesdebatter" ; -- utrikesdebatt..nn.1
  utrikesdeklaration_1_N = mkN "utrikesdeklaration" ; -- utrikesdeklaration..nn.1
  utrikesdepartement_1_N = mkN "utrikesdepartement" neutrum  ; -- utrikesdepartement..nn.1
  utrikesflyg_1_N = mkN "utrikesflyg" neutrum  ; -- utrikesflyg..nn.1
  utrikesflyg_2_N = mkN "utrikesflyg" neutrum  ; -- utrikesflyg..nn.2
  utrikesfråga_1_N = mkN "utrikesfråga" ; -- utrikesfråga..nn.1
  utrikeshandel_1_N = mkN "utrikeshandel" ; -- utrikeshandel..nn.1
  utrikeshandelsminister_1_N = mkN "utrikeshandelsminister" ; -- utrikeshandelsminister..nn.1
  utrikeskorrespondent_1_N = mkN "utrikeskorrespondent" "utrikeskorrespondenter" ; -- utrikeskorrespondent..nn.1
  utrikesminister_1_N = mkN "utrikesminister" ; -- utrikesminister..nn.1
  utrikesministerium_1_N = mkN "utrikesministerium" "utrikesministeriet" "utrikesministerier" "utrikesministerierna" ; -- utrikesministerium..nn.1
  utrikespassagerare_1_N = mkN "utrikespassagerare" utrum  ; -- utrikespassagerare..nn.1
  utrikespolitik_1_N = mkN "utrikespolitik" ; -- utrikespolitik..nn.1
  utrikespolitisk_1_A = mkA "utrikespolitisk" ; -- utrikespolitisk..av.1
  utrikestrafik_1_N = mkN "utrikestrafik" ; -- utrikestrafik..nn.1
  utrikisk_1_A = mkA "utrikisk" ; -- utrikisk..av.1
  utrikiska_1_N = mkN "utrikiska" ; -- utrikiska..nn.1
  utringande_1_N = mkN "utringande" ; -- utringande..nn.1
  utringning_1_N = mkN "utringning" ; -- utringning..nn.1
  utrivning_1_N = mkN "utrivning" ; -- utrivning..nn.1
  utrop_1_N = mkN "utrop" neutrum  ; -- utrop..nn.1
  utropa_1_V = mkV "utropar" ; -- utropa..vb.1
  utropande_1_N = mkN "utropande" ; -- utropande..nn.1
  utropare_1_N = mkN "utropare" utrum  ; -- utropare..nn.1
  utropsord_1_N = mkN "utropsord" neutrum  ; -- utropsord..nn.1
  utropssats_1_N = mkN "utropssats" "utropssatser" ; -- utropssats..nn.1
  utropstecken_1_N = mkN "utropstecken" "utropstecknet" "utropstecken" "utropstecknen" ; -- utropstecken..nn.1
  utrota_1_V = mkV "utrotar" ; -- utrota..vb.1
  utrotande_1_N = mkN "utrotande" ; -- utrotande..nn.1
  utrotning_1_N = mkN "utrotning" ; -- utrotning..nn.1
  utrotningshotad_1_A = mkA "utrotningshotad" ; -- utrotningshotad..av.1
  utrotningsläger_1_N = mkN "utrotningsläger" neutrum  ; -- utrotningsläger..nn.1
  utrullad_1_A = mkA "utrullad" ; -- utrullad..av.1
  utrullande_1_N = mkN "utrullande" ; -- utrullande..nn.1
  utrullning_1_N = mkN "utrullning" ; -- utrullning..nn.1
  utrum_1_N = mkN "utrum" neutrum  ; -- utrum..nn.1
  utrusta_1_V = mkV "utrustar" ; -- utrusta..vb.1
  utrustande_1_N = mkN "utrustande" ; -- utrustande..nn.1
  utrustning_1_N = mkN "utrustning" ; -- utrustning..nn.1
  utryckning_1_N = mkN "utryckning" ; -- utryckning..nn.1
  utryckningsfordon_1_N = mkN "utryckningsfordon" neutrum  ; -- utryckningsfordon..nn.1
  utrymma_1_V = mkV "utrymmer" ; -- utrymma..vb.1
  utrymmande_1_N = mkN "utrymmande" ; -- utrymmande..nn.1
  utrymme_1_N = mkN "utrymme" ; -- utrymme..nn.1
  utrymmesbrist_1_N = mkN "utrymmesbrist" ; -- utrymmesbrist..nn.1
  utrymmeskrävande_1_A = mkA "utrymmeskrävande" ; -- utrymmeskrävande..av.1
  utrymmesmässig_1_A = mkA "utrymmesmässig" ; -- utrymmesmässig..av.1
  utrymmesskäl_1_N = mkN "utrymmesskäl" neutrum  ; -- utrymmesskäl..nn.1
  utrymmesstandard_1_N = mkN "utrymmesstandard" "utrymmesstandarder" ; -- utrymmesstandard..nn.1
  utrymning_1_N = mkN "utrymning" ; -- utrymning..nn.1
  uträknad_1_A = mkA "uträknad" ; -- uträknad..av.1
  uträkning_1_N = mkN "uträkning" ; -- uträkning..nn.1
  uträtning_1_N = mkN "uträtning" ; -- uträtning..nn.1
  uträtta_1_V = mkV "uträttar" ; -- uträtta..vb.1
  uträttande_1_N = mkN "uträttande" ; -- uträttande..nn.1
  uträttning_1_N = mkN "uträttning" ; -- uträttning..nn.1
  utröna_1_V = mkV "utröna" "utröner" "utrön" "utrönte" "utrönt" "utrönt" ; -- utröna..vb.1
  utrönande_1_N = mkN "utrönande" ; -- utrönande..nn.1
  utsaga_1_N = mkN "utsaga" ; -- utsaga..nn.1
  utsagd_1_A = mkA "utsagd" "utsagt" ; -- utsagd..av.1
  utsago_1_N = mkN "utsago" ; -- utsago..nn.1
  utsatt_1_A = mkA "utsatt" ; -- utsatt..av.1
  utsatthet_1_N = mkN "utsatthet" ; -- utsatthet..nn.1
  utschasad_1_A = mkA "utschasad" ; -- utschasad..av.1
  utse_1_V = mkV "utse" "utsåg" "utsett" ; -- utse..vb.1
  utseende_1_N = mkN "utseende" ; -- utseende..nn.1
  utseendefixerad_1_A = mkA "utseendefixerad" ; -- utseendefixerad..av.1
  utseendefixering_1_N = mkN "utseendefixering" ; -- utseendefixering..nn.1
  utseendeideal_1_N = mkN "utseendeideal" neutrum  ; -- utseendeideal..nn.1
  utseendekomplex_1_N = mkN "utseendekomplex" neutrum  ; -- utseendekomplex..nn.1
  utseendemässig_1_A = mkA "utseendemässig" ; -- utseendemässig..av.1
  utsegling_1_N = mkN "utsegling" ; -- utsegling..nn.1
  utsida_1_N = mkN "utsida" ; -- utsida..nn.1
  utsikt_1_N = mkN "utsikt" "utsikter" ; -- utsikt..nn.1
  utsiktslös_1_A = mkA "utsiktslös" ; -- utsiktslös..av.1
  utsiktslöshet_1_N = mkN "utsiktslöshet" ; -- utsiktslöshet..nn.1
  utsiktspunkt_1_N = mkN "utsiktspunkt" "utsiktspunkter" ; -- utsiktspunkt..nn.1
  utsiktstorn_1_N = mkN "utsiktstorn" neutrum  ; -- utsiktstorn..nn.1
  utsining_1_N = mkN "utsining" ; -- utsining..nn.1
  utsira_1_V = mkV "utsirar" ; -- utsira..vb.1
  utsirande_1_N = mkN "utsirande" ; -- utsirande..nn.1
  utsirning_1_N = mkN "utsirning" ; -- utsirning..nn.1
  utsjasad_1_A = mkA "utsjasad" ; -- utsjasad..av.1
  utsjöfiske_1_N = mkN "utsjöfiske" ; -- utsjöfiske..nn.1
  utskeppa_1_V = mkV "utskeppar" ; -- utskeppa..vb.1
  utskeppande_1_N = mkN "utskeppande" ; -- utskeppande..nn.1
  utskeppning_1_N = mkN "utskeppning" ; -- utskeppning..nn.1
  utskick_1_N = mkN "utskick" neutrum  ; -- utskick..nn.1
  utskiftning_1_N = mkN "utskiftning" ; -- utskiftning..nn.1
  utskilja_1_V = mkV "utskilja" "utskilde" "utskilt" ; -- utskilja..vb.1
  utskiljande_1_N = mkN "utskiljande" ; -- utskiljande..nn.1
  utskjutande_1_A = mkA "utskjutande" ; -- utskjutande..av.1
  utskott_1_N = mkN "utskott" neutrum  ; -- utskott..nn.1
  utskottsbetänkande_1_N = mkN "utskottsbetänkande" ; -- utskottsbetänkande..nn.1
  utskottsmajoritet_1_N = mkN "utskottsmajoritet" "utskottsmajoriteter" ; -- utskottsmajoritet..nn.1
  utskottsordförande_1_N = mkN "utskottsordförande" "utskottsordföranden" "utskottsordföranden" "utskottsordförandena" ; -- utskottsordförande..nn.1
  utskottsvara_1_N = mkN "utskottsvara" ; -- utskottsvara..nn.1
  utskottsvirke_1_N = mkN "utskottsvirke" ; -- utskottsvirke..nn.1
  utskov_1_N = mkN "utskov" neutrum  ; -- utskov..nn.1
  utskrapning_1_N = mkN "utskrapning" ; -- utskrapning..nn.1
  utskrift_1_N = mkN "utskrift" "utskrifter" ; -- utskrift..nn.1
  utskriva_1_V = mkV "utskriva" "utskrev" "utskrivit" ; -- utskriva..vb.1
  utskrivande_1_N = mkN "utskrivande" ; -- utskrivande..nn.1
  utskrivning_1_N = mkN "utskrivning" ; -- utskrivning..nn.1
  utskrivningsprövning_1_N = mkN "utskrivningsprövning" ; -- utskrivningsprövning..nn.1
  utskuffning_1_N = mkN "utskuffning" ; -- utskuffning..nn.1
  utskuren_1_A = mkA "utskuren" ; -- utskuren..av.1
  utskyld_1_N = mkN "utskyld" "utskylder" ; -- utskyld..nn.1
  utskälld_1_A = mkA "utskälld" "utskällt" ; -- utskälld..av.1
  utskällning_1_N = mkN "utskällning" ; -- utskällning..nn.1
  utskämd_1_A = mkA "utskämd" "utskämt" ; -- utskämd..av.1
  utskämdhet_1_N = mkN "utskämdhet" ; -- utskämdhet..nn.1
  utskänka_1_V = mkV "utskänker" ; -- utskänka..vb.1
  utskänkande_1_N = mkN "utskänkande" ; -- utskänkande..nn.1
  utskänkning_1_N = mkN "utskänkning" ; -- utskänkning..nn.1
  utskänkningstillstånd_1_N = mkN "utskänkningstillstånd" neutrum  ; -- utskänkningstillstånd..nn.1
  utskärande_1_N = mkN "utskärande" ; -- utskärande..nn.1
  utskärgård_1_N = mkN "utskärgård" ; -- utskärgård..nn.1
  utskärning_1_N = mkN "utskärning" ; -- utskärning..nn.1
  utskåpning_1_N = mkN "utskåpning" ; -- utskåpning..nn.1
  utslag_1_N = mkN "utslag" neutrum  ; -- utslag..nn.1
  utslagen_1_A = mkA "utslagen" ; -- utslagen..av.1
  utslagning_1_N = mkN "utslagning" ; -- utslagning..nn.1
  utslagningsmekanism_1_N = mkN "utslagningsmekanism" "utslagningsmekanismer" ; -- utslagningsmekanism..nn.1
  utslagsfråga_1_N = mkN "utslagsfråga" ; -- utslagsfråga..nn.1
  utslagsgivande_1_A = mkA "utslagsgivande" ; -- utslagsgivande..av.1
  utslagsplats_1_N = mkN "utslagsplats" "utslagsplatser" ; -- utslagsplats..nn.1
  utslagsröst_1_N = mkN "utslagsröst" "utslagsröster" ; -- utslagsröst..nn.1
  utslagstävling_1_N = mkN "utslagstävling" ; -- utslagstävling..nn.1
  utsliten_1_A = mkA "utsliten" ; -- utsliten..av.1
  utslockna_1_V = mkV "utslocknar" ; -- utslockna..vb.1
  utslocknad_1_A = mkA "utslocknad" ; -- utslocknad..av.1
  utslocknande_1_N = mkN "utslocknande" ; -- utslocknande..nn.1
  utslunga_1_V = mkV "utslungar" ; -- utslunga..vb.1
  utslungande_1_N = mkN "utslungande" ; -- utslungande..nn.1
  utslungning_1_N = mkN "utslungning" ; -- utslungning..nn.1
  utslussa_1_V = mkV "utslussar" ; -- utslussa..vb.1
  utslussande_1_N = mkN "utslussande" ; -- utslussande..nn.1
  utslussning_1_N = mkN "utslussning" ; -- utslussning..nn.1
  utslutning_1_N = mkN "utslutning" ; -- utslutning..nn.1
  utsläcka_1_V = mkV "utsläcker" ; -- utsläcka..vb.1
  utsläckande_1_N = mkN "utsläckande" ; -- utsläckande..nn.1
  utsläckning_1_N = mkN "utsläckning" ; -- utsläckning..nn.1
  utsläpad_1_A = mkA "utsläpad" ; -- utsläpad..av.1
  utsläpning_1_N = mkN "utsläpning" ; -- utsläpning..nn.1
  utsläpp_1_N = mkN "utsläpp" neutrum  ; -- utsläpp..nn.1
  utsläppsgräns_1_N = mkN "utsläppsgräns" "utsläppsgränser" ; -- utsläppsgräns..nn.1
  utsläppsintensiv_1_A = mkA "utsläppsintensiv" ; -- utsläppsintensiv..av.1
  utsläppskälla_1_N = mkN "utsläppskälla" ; -- utsläppskälla..nn.1
  utsläppsland_1_N = mkN "utsläppsland" "utsläppslandet" "utsläppsländer" "utsläppsländerna" ; -- utsläppsland..nn.1
  utsläppsminskande_1_A = mkA "utsläppsminskande" ; -- utsläppsminskande..av.1
  utsläppsminskning_1_N = mkN "utsläppsminskning" ; -- utsläppsminskning..nn.1
  utsläppsnation_1_N = mkN "utsläppsnation" ; -- utsläppsnation..nn.1
  utsläppsrätt_1_N = mkN "utsläppsrätt" "utsläppsrätter" ; -- utsläppsrätt..nn.1
  utsläta_1_V = mkV "utslätar" ; -- utsläta..vb.1
  utslätande_1_N = mkN "utslätande" ; -- utslätande..nn.1
  utslätning_1_N = mkN "utslätning" ; -- utslätning..nn.1
  utslående_1_N = mkN "utslående" ; -- utslående..nn.1
  utsmycka_1_V = mkV "utsmyckar" ; -- utsmycka..vb.1
  utsmyckad_1_A = mkA "utsmyckad" ; -- utsmyckad..av.1
  utsmyckande_1_N = mkN "utsmyckande" ; -- utsmyckande..nn.1
  utsmyckning_1_N = mkN "utsmyckning" ; -- utsmyckning..nn.1
  utsnitt_1_N = mkN "utsnitt" neutrum  ; -- utsnitt..nn.1
  utsocknes_1_A = mkA "utsocknes" ; -- utsocknes..av.1
  utsortera_1_V = mkV "utsorterar" ; -- utsortera..vb.1
  utsortering_1_N = mkN "utsortering" ; -- utsortering..nn.1
  utsot_1_N = mkN "utsot" ; -- utsot..nn.1
  utspana_1_V = mkV "utspanar" ; -- utspana..vb.1
  utspanande_1_N = mkN "utspanande" ; -- utspanande..nn.1
  utspaning_1_N = mkN "utspaning" ; -- utspaning..nn.1
  utspark_1_N = mkN "utspark" ; -- utspark..nn.1
  utsparkad_1_A = mkA "utsparkad" ; -- utsparkad..av.1
  utsparkning_1_N = mkN "utsparkning" ; -- utsparkning..nn.1
  utspekulerad_1_A = mkA "utspekulerad" ; -- utspekulerad..av.1
  utspel_1_N = mkN "utspel" "utspelet" "utspel" "utspelen" ; -- utspel..nn.1
  utspelad_1_A = mkA "utspelad" ; -- utspelad..av.1
  utspelsfyrverkeri_1_N = mkN "utspelsfyrverkeri" "utspelsfyrverkeriet" "utspelsfyrverkerier" "utspelsfyrverkerierna" ; -- utspelsfyrverkeri..nn.1
  utspisa_1_V = mkV "utspisar" ; -- utspisa..vb.1
  utspisande_1_N = mkN "utspisande" ; -- utspisande..nn.1
  utspisning_1_N = mkN "utspisning" ; -- utspisning..nn.1
  utspisningsställe_1_N = mkN "utspisningsställe" ; -- utspisningsställe..nn.1
  utsprickning_1_N = mkN "utsprickning" ; -- utsprickning..nn.1
  utsprida_1_V = mkV "utsprida" "utsprider" "utsprid" "utspridde" "utspridit" "utspridd" ; -- utsprida..vb.1
  utspridande_1_N = mkN "utspridande" ; -- utspridande..nn.1
  utspridd_1_A = mkA "utspridd" ; -- utspridd..av.1
  utspriddhet_1_N = mkN "utspriddhet" ; -- utspriddhet..nn.1
  utspridning_1_N = mkN "utspridning" ; -- utspridning..nn.1
  utspringande_1_A = mkA "utspringande" ; -- utspringande..av.1
  utsprungen_1_A = mkA "utsprungen" ; -- utsprungen..av.1
  utsprång_1_N = mkN "utsprång" neutrum  ; -- utsprång..nn.1
  utspy_1_V = mkV "utspyr" ; -- utspy..vb.1
  utspyende_1_N = mkN "utspyende" ; -- utspyende..nn.1
  utspädd_1_A = mkA "utspädd" ; -- utspädd..av.1
  utspäddhet_1_N = mkN "utspäddhet" ; -- utspäddhet..nn.1
  utspädning_1_N = mkN "utspädning" ; -- utspädning..nn.1
  utspänd_1_A = mkA "utspänd" ; -- utspänd..av.1
  utspändhet_1_N = mkN "utspändhet" ; -- utspändhet..nn.1
  utspänning_1_N = mkN "utspänning" ; -- utspänning..nn.1
  utspärra_1_V = mkV "utspärrar" ; -- utspärra..vb.1
  utspärrande_1_N = mkN "utspärrande" ; -- utspärrande..nn.1
  utspärrning_1_N = mkN "utspärrning" ; -- utspärrning..nn.1
  utspökad_1_A = mkA "utspökad" ; -- utspökad..av.1
  utspökning_1_N = mkN "utspökning" ; -- utspökning..nn.1
  utstaka_1_V = mkV "utstakar" ; -- utstaka..vb.1
  utstakande_1_N = mkN "utstakande" ; -- utstakande..nn.1
  utstakning_1_N = mkN "utstakning" ; -- utstakning..nn.1
  utstoffera_1_V = mkV "utstofferar" ; -- utstoffera..vb.1
  utstofferad_1_A = mkA "utstofferad" ; -- utstofferad..av.1
  utstofferande_1_N = mkN "utstofferande" ; -- utstofferande..nn.1
  utstofferbar_1_A = mkA "utstofferbar" ; -- utstofferbar..av.1
  utstofferbarhet_1_N = mkN "utstofferbarhet" ; -- utstofferbarhet..nn.1
  utstoffering_1_N = mkN "utstoffering" ; -- utstoffering..nn.1
  utsträcka_1_V = mkV "utsträcker" ; -- utsträcka..vb.1
  utsträckande_1_N = mkN "utsträckande" ; -- utsträckande..nn.1
  utsträckning_1_N = mkN "utsträckning" ; -- utsträckning..nn.1
  utstråla_1_V = mkV "utstrålar" ; -- utstråla..vb.1
  utstrålande_1_N = mkN "utstrålande" ; -- utstrålande..nn.1
  utstrålning_1_N = mkN "utstrålning" ; -- utstrålning..nn.1
  utströende_1_N = mkN "utströende" ; -- utströende..nn.1
  utstuderad_1_A = mkA "utstuderad" ; -- utstuderad..av.1
  utstyrd_1_A = mkA "utstyrd" "utstyrt" ; -- utstyrd..av.1
  utstyrsel_1_N = mkN "utstyrsel" ; -- utstyrsel..nn.1
  utställa_1_V = mkV "utställer" ; -- utställa..vb.1
  utställande_1_N = mkN "utställande" ; -- utställande..nn.1
  utställare_1_N = mkN "utställare" utrum  ; -- utställare..nn.1
  utställd_1_A = mkA "utställd" "utställt" ; -- utställd..av.1
  utställelse_1_N = mkN "utställelse" "utställelser" ; -- utställelse..nn.1
  utställning_1_N = mkN "utställning" ; -- utställning..nn.1
  utställningsobjekt_1_N = mkN "utställningsobjekt" neutrum  ; -- utställningsobjekt..nn.1
  utstämpling_1_N = mkN "utstämpling" ; -- utstämpling..nn.1
  utstå_1_V = mkV "utstå" "utstår" "utstå" "utstod" "utstått" "utstånden" ; -- utstå..vb.1
  utstående_1_A = mkA "utstående" ; -- utstående..av.1
  utstående_1_N = mkN "utstående" ; -- utstående..nn.1
  utstånden_1_A = mkA "utstånden" ; -- utstånden..av.1
  utstöta_1_V = mkV "utstöter" ; -- utstöta..vb.1
  utstötande_1_N = mkN "utstötande" ; -- utstötande..nn.1
  utstötning_1_N = mkN "utstötning" ; -- utstötning..nn.1
  utstött_1_A = mkA "utstött" ; -- utstött..av.1
  utstötthet_1_N = mkN "utstötthet" ; -- utstötthet..nn.1
  utsuddad_1_A = mkA "utsuddad" ; -- utsuddad..av.1
  utsuddning_1_N = mkN "utsuddning" ; -- utsuddning..nn.1
  utsuga_1_V = mkV "utsuga" "utsög" "utsugit" ; -- utsuga..vb.1
  utsugande_1_N = mkN "utsugande" ; -- utsugande..nn.1
  utsugare_1_N = mkN "utsugare" utrum  ; -- utsugare..nn.1
  utsugarekonomi_1_N = mkN "utsugarekonomi" "utsugarekonomier" ; -- utsugarekonomi..nn.1
  utsugen_1_A = mkA "utsugen" ; -- utsugen..av.1
  utsugeri_1_N = mkN "utsugeri" neutrum  ; -- utsugeri..nn.1
  utsugning_1_N = mkN "utsugning" ; -- utsugning..nn.1
  utsvulten_1_A = mkA "utsvulten" ; -- utsvulten..av.1
  utsvällande_1_N = mkN "utsvällande" ; -- utsvällande..nn.1
  utsvällning_1_N = mkN "utsvällning" ; -- utsvällning..nn.1
  utsvältning_1_N = mkN "utsvältning" ; -- utsvältning..nn.1
  utsvängd_1_A = mkA "utsvängd" "utsvängt" ; -- utsvängd..av.1
  utsvängdhet_1_N = mkN "utsvängdhet" ; -- utsvängdhet..nn.1
  utsvävande_1_A = mkA "utsvävande" ; -- utsvävande..av.1
  utsvävning_1_N = mkN "utsvävning" ; -- utsvävning..nn.1
  utsyna_1_V = mkV "utsynar" ; -- utsyna..vb.1
  utsynande_1_N = mkN "utsynande" ; -- utsynande..nn.1
  utsyning_1_N = mkN "utsyning" ; -- utsyning..nn.1
  utsäde_1_N = mkN "utsäde" ; -- utsäde..nn.1
  utsäga_1_V = mkV "utsäga" "utsade" "utsagt" ; -- utsäga..vb.1
  utsägande_1_N = mkN "utsägande" ; -- utsägande..nn.1
  utsägbar_1_A = mkA "utsägbar" ; -- utsägbar..av.1
  utsägbarhet_1_N = mkN "utsägbarhet" ; -- utsägbarhet..nn.1
  utsägning_1_N = mkN "utsägning" ; -- utsägning..nn.1
  utsända_1_V = mkV "utsänder" ; -- utsända..vb.1
  utsändande_1_N = mkN "utsändande" ; -- utsändande..nn.1
  utsändning_1_N = mkN "utsändning" ; -- utsändning..nn.1
  utsätta_1_V = mkV "utsätta" "utsätter" "utsätt" "utsatte" "utsatt" "utsatt" ; -- utsätta..vb.1
  utsättande_1_N = mkN "utsättande" ; -- utsättande..nn.1
  utsågning_1_N = mkN "utsågning" ; -- utsågning..nn.1
  utsåld_1_A = mkA "utsåld" "utsålt" ; -- utsåld..av.1
  utsöka_1_V = mkV "utsöker" ; -- utsöka..vb.1
  utsökande_1_N = mkN "utsökande" ; -- utsökande..nn.1
  utsökning_1_N = mkN "utsökning" ; -- utsökning..nn.1
  utsökt_1_A = mkA "utsökt" "utsökt" ; -- utsökt..av.1
  utsökthet_1_N = mkN "utsökthet" "utsöktheter" ; -- utsökthet..nn.1
  utsöndra_1_V = mkV "utsöndrar" ; -- utsöndra..vb.1
  utsöndrande_1_N = mkN "utsöndrande" ; -- utsöndrande..nn.1
  utsöndring_1_N = mkN "utsöndring" ; -- utsöndring..nn.1
  utsöndringsorgan_1_N = mkN "utsöndringsorgan" neutrum  ; -- utsöndringsorgan..nn.1
  utsövd_1_A = mkA "utsövd" "utsövt" ; -- utsövd..av.1
  utsövdhet_1_N = mkN "utsövdhet" ; -- utsövdhet..nn.1
  uttag_1_N = mkN "uttag" neutrum  ; -- uttag..nn.1
  uttagbar_1_A = mkA "uttagbar" ; -- uttagbar..av.1
  uttagning_1_N = mkN "uttagning" ; -- uttagning..nn.1
  uttagsbeskattning_1_N = mkN "uttagsbeskattning" ; -- uttagsbeskattning..nn.1
  uttal_1_N = mkN "uttal" neutrum  ; -- uttal..nn.1
  uttala_1_V = mkV "uttalar" ; -- uttala..vb.1
  uttalad_1_A = mkA "uttalad" ; -- uttalad..av.1
  uttalande_1_N = mkN "uttalande" ; -- uttalande..nn.1
  uttalsbeteckning_1_N = mkN "uttalsbeteckning" ; -- uttalsbeteckning..nn.1
  uttalsenlig_1_A = mkA "uttalsenlig" ; -- uttalsenlig..av.1
  uttalsenlighet_1_N = mkN "uttalsenlighet" ; -- uttalsenlighet..nn.1
  uttalsfel_1_N = mkN "uttalsfel" "uttalsfelet" "uttalsfel" "uttalsfelen" ; -- uttalsfel..nn.1
  uttalstecken_1_N = mkN "uttalstecken" "uttalstecknet" "uttalstecken" "uttalstecknen" ; -- uttalstecken..nn.1
  uttaxera_1_V = mkV "uttaxerar" ; -- uttaxera..vb.1
  uttaxerande_1_N = mkN "uttaxerande" ; -- uttaxerande..nn.1
  uttaxerbar_1_A = mkA "uttaxerbar" ; -- uttaxerbar..av.1
  uttaxerbarhet_1_N = mkN "uttaxerbarhet" ; -- uttaxerbarhet..nn.1
  uttaxering_1_N = mkN "uttaxering" ; -- uttaxering..nn.1
  utter_1_N = mkN "utter" ; -- utter..nn.1
  uttittad_1_A = mkA "uttittad" ; -- uttittad..av.1
  uttjatad_1_A = mkA "uttjatad" ; -- uttjatad..av.1
  uttjänad_1_A = mkA "uttjänad" ; -- uttjänad..av.1
  uttjänt_1_A = mkA "uttjänt" "uttjänt" ; -- uttjänt..av.1
  uttjänthet_1_N = mkN "uttjänthet" ; -- uttjänthet..nn.1
  uttolka_1_V = mkV "uttolkar" ; -- uttolka..vb.1
  uttolkande_1_N = mkN "uttolkande" ; -- uttolkande..nn.1
  uttolkare_1_N = mkN "uttolkare" utrum  ; -- uttolkare..nn.1
  uttolkning_1_N = mkN "uttolkning" ; -- uttolkning..nn.1
  uttorkande_1_N = mkN "uttorkande" ; -- uttorkande..nn.1
  uttorkning_1_N = mkN "uttorkning" ; -- uttorkning..nn.1
  uttrampning_1_N = mkN "uttrampning" ; -- uttrampning..nn.1
  uttryck_1_N = mkN "uttryck" neutrum  ; -- uttryck..nn.1
  uttrycka_1_V = mkV "uttrycker" ; -- uttrycka..vb.1
  uttryckande_1_N = mkN "uttryckande" ; -- uttryckande..nn.1
  uttryckbar_1_A = mkA "uttryckbar" ; -- uttryckbar..av.1
  uttryckbarhet_1_N = mkN "uttryckbarhet" ; -- uttryckbarhet..nn.1
  uttrycklig_1_A = mkA "uttrycklig" ; -- uttrycklig..av.1
  uttryckligen_1_Adv = mkAdv "uttryckligen" ; -- uttryckligen..ab.1
  uttrycklighet_1_N = mkN "uttrycklighet" ; -- uttrycklighet..nn.1
  uttrycksform_1_N = mkN "uttrycksform" "uttrycksformer" ; -- uttrycksform..nn.1
  uttrycksfull_1_A = mkA "uttrycksfull" ; -- uttrycksfull..av.1
  uttrycksfullhet_1_N = mkN "uttrycksfullhet" ; -- uttrycksfullhet..nn.1
  uttryckslös_1_A = mkA "uttryckslös" ; -- uttryckslös..av.1
  uttryckslöshet_1_N = mkN "uttryckslöshet" ; -- uttryckslöshet..nn.1
  uttrycksmedel_1_N = mkN "uttrycksmedel" neutrum  ; -- uttrycksmedel..nn.1
  uttrycksmässig_1_A = mkA "uttrycksmässig" ; -- uttrycksmässig..av.1
  uttryckssätt_1_N = mkN "uttryckssätt" neutrum  ; -- uttryckssätt..nn.1
  utträda_1_V = mkV "utträda" "utträdde" "utträtt" ; -- utträda..vb.1
  utträdande_1_N = mkN "utträdande" ; -- utträdande..nn.1
  utträde_1_N = mkN "utträde" ; -- utträde..nn.1
  utträngning_1_N = mkN "utträngning" ; -- utträngning..nn.1
  uttråkad_1_A = mkA "uttråkad" ; -- uttråkad..av.1
  uttråkning_1_N = mkN "uttråkning" ; -- uttråkning..nn.1
  uttrötta_1_V = mkV "uttröttar" ; -- uttrötta..vb.1
  uttröttad_1_A = mkA "uttröttad" ; -- uttröttad..av.1
  uttröttande_1_N = mkN "uttröttande" ; -- uttröttande..nn.1
  uttröttning_1_N = mkN "uttröttning" ; -- uttröttning..nn.1
  uttunna_1_V = mkV "uttunnar" ; -- uttunna..vb.1
  uttunnad_1_A = mkA "uttunnad" ; -- uttunnad..av.1
  uttunnande_1_N = mkN "uttunnande" ; -- uttunnande..nn.1
  uttyda_1_V = mkV "uttyda" "uttydde" "uttytt" ; -- uttyda..vb.1
  uttydande_1_N = mkN "uttydande" ; -- uttydande..nn.1
  uttydare_1_N = mkN "uttydare" utrum  ; -- uttydare..nn.1
  uttydning_1_N = mkN "uttydning" ; -- uttydning..nn.1
  uttänja_1_V = mkV "uttänja" "uttänjde" "uttänjt" ; -- uttänja..vb.1
  uttänjande_1_N = mkN "uttänjande" ; -- uttänjande..nn.1
  uttänjbar_1_A = mkA "uttänjbar" ; -- uttänjbar..av.1
  uttänjbarhet_1_N = mkN "uttänjbarhet" ; -- uttänjbarhet..nn.1
  uttänjd_1_A = mkA "uttänjd" "uttänjt" ; -- uttänjd..av.1
  uttänjning_1_N = mkN "uttänjning" ; -- uttänjning..nn.1
  uttänkt_1_A = mkA "uttänkt" "uttänkt" ; -- uttänkt..av.1
  uttänkthet_1_N = mkN "uttänkthet" ; -- uttänkthet..nn.1
  uttåg_1_N = mkN "uttåg" neutrum  ; -- uttåg..nn.1
  uttöjd_1_A = mkA "uttöjd" "uttöjt" ; -- uttöjd..av.1
  uttöjning_1_N = mkN "uttöjning" ; -- uttöjning..nn.1
  uttömma_1_V = mkV "uttömmer" ; -- uttömma..vb.1
  uttömmande_1_A = mkA "uttömmande" ; -- uttömmande..av.1
  uttömmande_1_N = mkN "uttömmande" ; -- uttömmande..nn.1
  uttömning_1_N = mkN "uttömning" ; -- uttömning..nn.1
  utvakad_1_A = mkA "utvakad" ; -- utvakad..av.1
  utvald_1_A = mkA "utvald" "utvalt" ; -- utvald..av.1
  utvaldhet_1_N = mkN "utvaldhet" ; -- utvaldhet..nn.1
  utvandra_1_V = mkV "utvandrar" ; -- utvandra..vb.1
  utvandrande_1_N = mkN "utvandrande" ; -- utvandrande..nn.1
  utvandrare_1_N = mkN "utvandrare" utrum  ; -- utvandrare..nn.1
  utvandring_1_N = mkN "utvandring" ; -- utvandring..nn.1
  utveckla_1_V = mkV "utvecklar" ; -- utveckla..vb.1
  utvecklad_1_A = mkA "utvecklad" ; -- utvecklad..av.1
  utvecklande_1_N = mkN "utvecklande" ; -- utvecklande..nn.1
  utvecklare_1_N = mkN "utvecklare" utrum  ; -- utvecklare..nn.1
  utveckling_1_N = mkN "utveckling" ; -- utveckling..nn.1
  utvecklingsarbete_1_N = mkN "utvecklingsarbete" ; -- utvecklingsarbete..nn.1
  utvecklingsbar_1_A = mkA "utvecklingsbar" ; -- utvecklingsbar..av.1
  utvecklingsfond_1_N = mkN "utvecklingsfond" "utvecklingsfonder" ; -- utvecklingsfond..nn.1
  utvecklingsgrad_1_N = mkN "utvecklingsgrad" "utvecklingsgrader" ; -- utvecklingsgrad..nn.1
  utvecklingsgren_1_N = mkN "utvecklingsgren" "utvecklingsgrenen" "utvecklingsgrenar" "utvecklingsgrenarna" ; -- utvecklingsgren..nn.1
  utvecklingsgång_1_N = mkN "utvecklingsgång" ; -- utvecklingsgång..nn.1
  utvecklingshistoria_1_N = mkN "utvecklingshistoria" ; -- utvecklingshistoria..nn.1
  utvecklingshämmad_1_A = mkA "utvecklingshämmad" ; -- utvecklingshämmad..av.1
  utvecklingsland_1_N = mkN "utvecklingsland" "utvecklingslandet" "utvecklingsländer" "utvecklingsländerna" ; -- utvecklingsland..nn.1
  utvecklingslinje_1_N = mkN "utvecklingslinje" "utvecklingslinjer" ; -- utvecklingslinje..nn.1
  utvecklingslära_1_N = mkN "utvecklingslära" ; -- utvecklingslära..nn.1
  utvecklingsmässig_1_A = mkA "utvecklingsmässig" ; -- utvecklingsmässig..av.1
  utvecklingsmässighet_1_N = mkN "utvecklingsmässighet" ; -- utvecklingsmässighet..nn.1
  utvecklingsmöjlighet_1_N = mkN "utvecklingsmöjlighet" "utvecklingsmöjligheter" ; -- utvecklingsmöjlighet..nn.1
  utvecklingsoptimism_1_N = mkN "utvecklingsoptimism" "utvecklingsoptimismer" ; -- utvecklingsoptimism..nn.1
  utvecklingspessimism_1_N = mkN "utvecklingspessimism" "utvecklingspessimismer" ; -- utvecklingspessimism..nn.1
  utvecklingsplan_1_N = mkN "utvecklingsplan" neutrum  ; -- utvecklingsplan..nn.1
  utvecklingspolitik_1_N = mkN "utvecklingspolitik" ; -- utvecklingspolitik..nn.1
  utvecklingspolitisk_1_A = mkA "utvecklingspolitisk" ; -- utvecklingspolitisk..av.1
  utvecklingsprocess_1_N = mkN "utvecklingsprocess" "utvecklingsprocesser" ; -- utvecklingsprocess..nn.1
  utvecklingsprojekt_1_N = mkN "utvecklingsprojekt" neutrum  ; -- utvecklingsprojekt..nn.1
  utvecklingsrubbning_1_N = mkN "utvecklingsrubbning" ; -- utvecklingsrubbning..nn.1
  utvecklingssamarbete_1_N = mkN "utvecklingssamarbete" ; -- utvecklingssamarbete..nn.1
  utvecklingssamtal_1_N = mkN "utvecklingssamtal" neutrum  ; -- utvecklingssamtal..nn.1
  utvecklingsserie_1_N = mkN "utvecklingsserie" "utvecklingsserier" ; -- utvecklingsserie..nn.1
  utvecklingsskede_1_N = mkN "utvecklingsskede" ; -- utvecklingsskede..nn.1
  utvecklingssprång_1_N = mkN "utvecklingssprång" neutrum  ; -- utvecklingssprång..nn.1
  utvecklingsstadium_1_N = mkN "utvecklingsstadium" "utvecklingsstadiet" "utvecklingsstadier" "utvecklingsstadierna" ; -- utvecklingsstadium..nn.1
  utvecklingsstöd_1_N = mkN "utvecklingsstöd" neutrum  ; -- utvecklingsstöd..nn.1
  utvecklingsstörd_1_A = mkA "utvecklingsstörd" "utvecklingsstört" ; -- utvecklingsstörd..av.1
  utvecklingsstörning_1_N = mkN "utvecklingsstörning" ; -- utvecklingsstörning..nn.1
  utvecklingstrappa_1_N = mkN "utvecklingstrappa" ; -- utvecklingstrappa..nn.1
  utvecklingsträd_1_N = mkN "utvecklingsträd" neutrum  ; -- utvecklingsträd..nn.1
  utvecklingsväg_1_N = mkN "utvecklingsväg" ; -- utvecklingsväg..nn.1
  utverka_1_V = mkV "utverkar" ; -- utverka..vb.1
  utverkande_1_N = mkN "utverkande" ; -- utverkande..nn.1
  utvidga_1_V = mkV "utvidgar" ; -- utvidga..vb.1
  utvidgande_1_N = mkN "utvidgande" ; -- utvidgande..nn.1
  utvidgbar_1_A = mkA "utvidgbar" ; -- utvidgbar..av.1
  utvidgning_1_N = mkN "utvidgning" ; -- utvidgning..nn.1
  utvidgningsbar_1_A = mkA "utvidgningsbar" ; -- utvidgningsbar..av.1
  utvidgningspolitik_1_N = mkN "utvidgningspolitik" ; -- utvidgningspolitik..nn.1
  utvik_1_N = mkN "utvik" neutrum  ; -- utvik..nn.1
  utvikning_1_N = mkN "utvikning" ; -- utvikning..nn.1
  utvikningsbild_1_N = mkN "utvikningsbild" "utvikningsbilder" ; -- utvikningsbild..nn.1
  utvikningsbrud_1_N = mkN "utvikningsbrud" ; -- utvikningsbrud..nn.1
  utvikningspojke_1_N = mkN "utvikningspojke" utrum  ; -- utvikningspojke..nn.1
  utviksblad_1_N = mkN "utviksblad" neutrum  ; -- utviksblad..nn.1
  utviksbrud_1_N = mkN "utviksbrud" ; -- utviksbrud..nn.1
  utvilad_1_A = mkA "utvilad" ; -- utvilad..av.1
  utvinna_1_V = mkV "utvinna" "utvann" "utvunnit" ; -- utvinna..vb.1
  utvinnande_1_N = mkN "utvinnande" ; -- utvinnande..nn.1
  utvinnelsegrad_1_N = mkN "utvinnelsegrad" "utvinnelsegrader" ; -- utvinnelsegrad..nn.1
  utvinning_1_N = mkN "utvinning" ; -- utvinning..nn.1
  utvisa_1_V = mkV "utvisar" ; -- utvisa..vb.1
  utvisande_1_N = mkN "utvisande" ; -- utvisande..nn.1
  utvisning_1_N = mkN "utvisning" ; -- utvisning..nn.1
  utvisningsbås_1_N = mkN "utvisningsbås" neutrum  ; -- utvisningsbås..nn.1
  utvisningshotad_1_A = mkA "utvisningshotad" ; -- utvisningshotad..av.1
  utvisslad_1_A = mkA "utvisslad" ; -- utvisslad..av.1
  utvissling_1_N = mkN "utvissling" ; -- utvissling..nn.1
  utvotering_1_N = mkN "utvotering" ; -- utvotering..nn.1
  utvräkning_1_N = mkN "utvräkning" ; -- utvräkning..nn.1
  utväg_1_N = mkN "utväg" ; -- utväg..nn.1
  utvälja_1_V = mkV "utvälja" "utvalde" "utvalt" ; -- utvälja..vb.1
  utväljande_1_N = mkN "utväljande" ; -- utväljande..nn.1
  utvändig_1_A = mkA "utvändig" ; -- utvändig..av.1
  utvändighet_1_N = mkN "utvändighet" ; -- utvändighet..nn.1
  utvärdera_1_V = mkV "utvärderar" ; -- utvärdera..vb.1
  utvärderande_1_N = mkN "utvärderande" ; -- utvärderande..nn.1
  utvärderbar_1_A = mkA "utvärderbar" ; -- utvärderbar..av.1
  utvärderbarhet_1_N = mkN "utvärderbarhet" ; -- utvärderbarhet..nn.1
  utvärdering_1_N = mkN "utvärdering" ; -- utvärdering..nn.1
  utvärderingsenhet_1_N = mkN "utvärderingsenhet" "utvärderingsenheter" ; -- utvärderingsenhet..nn.1
  utvärdshus_1_N = mkN "utvärdshus" neutrum  ; -- utvärdshus..nn.1
  utvärtes_1_A = mkA "utvärtes" ; -- utvärtes..av.1
  utväxla_1_V = mkV "utväxlar" ; -- utväxla..vb.1
  utväxlande_1_N = mkN "utväxlande" ; -- utväxlande..nn.1
  utväxling_1_N = mkN "utväxling" ; -- utväxling..nn.1
  utväxt_1_N = mkN "utväxt" "utväxter" ; -- utväxt..nn.1
  utäga_1_N = mkN "utäga" ; -- utäga..nn.1
  utåinvändning_1_N = mkN "utåinvändning" ; -- utåinvändning..nn.1
  utåtbuktande_1_A = mkA "utåtbuktande" ; -- utåtbuktande..av.1
  utåtböjd_1_A = mkA "utåtböjd" "utåtböjt" ; -- utåtböjd..av.1
  utåtriktad_1_A = mkA "utåtriktad" ; -- utåtriktad..av.1
  utåtvänd_1_A = mkA "utåtvänd" ; -- utåtvänd..av.1
  utåtvändhet_1_N = mkN "utåtvändhet" ; -- utåtvändhet..nn.1
  utöka_1_V = mkV "utökar" ; -- utöka..vb.1
  utökande_1_N = mkN "utökande" ; -- utökande..nn.1
  utökning_1_N = mkN "utökning" ; -- utökning..nn.1
  utöva_1_V = mkV "utövar" ; -- utöva..vb.1
  utövande_1_N = mkN "utövande" ; -- utövande..nn.1
  utövare_1_N = mkN "utövare" utrum  ; -- utövare..nn.1
  utövning_1_N = mkN "utövning" ; -- utövning..nn.1
  uv_1_N = mkN "uv" ; -- uv..nn.1
  uvertyr_1_N = mkN "uvertyr" "uvertyrer" ; -- uvertyr..nn.1
  uvular_1_A = mkA "uvular" ; -- uvular..av.1
  uvular_1_N = mkN "uvular" "uvularer" ; -- uvular..nn.1
  uzbek_1_N = mkN "uzbek" "uzbeker" ; -- uzbek..nn.1
  uzbekisk_1_A = mkA "uzbekisk" ; -- uzbekisk..av.1
  uzbekiska_1_N = mkN "uzbekiska" ; -- uzbekiska..nn.1
  uzbekiska_2_N = mkN "uzbekiska" ; -- uzbekiska..nn.2
  vab_dag_1_N = mkN "vab-dag" ; -- vab-dag..nn.1
  vab_1_N = mkN "vab" ; -- vab..nn.1
  vabb_dag_1_N = mkN "vabb-dag" ; -- vabb-dag..nn.1
  vabb_1_N = mkN "vabb" ; -- vabb..nn.1
  vabba_1_V = mkV "vabbar" ; -- vabba..vb.1
  vabbande_1_N = mkN "vabbande" ; -- vabbande..nn.1
  vabbare_1_N = mkN "vabbare" utrum  ; -- vabbare..nn.1
  vabbdag_1_N = mkN "vabbdag" ; -- vabbdag..nn.1
  vabdag_1_N = mkN "vabdag" ; -- vabdag..nn.1
  vaccin_1_N = mkN "vaccin" neutrum  ; -- vaccin..nn.1
  vaccination_1_N = mkN "vaccination" ; -- vaccination..nn.1
  vaccinationskö_1_N = mkN "vaccinationskö" "vaccinationskön" "vaccinationsköer" "vaccinationsköerna" ; -- vaccinationskö..nn.1
  vaccinationstvång_1_N = mkN "vaccinationstvång" neutrum  ; -- vaccinationstvång..nn.1
  vaccinatör_1_N = mkN "vaccinatör" "vaccinatörer" ; -- vaccinatör..nn.1
  vaccinbrist_1_N = mkN "vaccinbrist" ; -- vaccinbrist..nn.1
  vaccinera_1_V = mkV "vaccinerar" ; -- vaccinera..vb.1
  vaccinerande_1_N = mkN "vaccinerande" ; -- vaccinerande..nn.1
  vaccinerbar_1_A = mkA "vaccinerbar" ; -- vaccinerbar..av.1
  vaccinerbarhet_1_N = mkN "vaccinerbarhet" ; -- vaccinerbarhet..nn.1
  vaccinering_1_N = mkN "vaccinering" ; -- vaccinering..nn.1
  vaccineringshysteri_1_N = mkN "vaccineringshysteri" ; -- vaccineringshysteri..nn.1
  vaccineringsturbulens_1_N = mkN "vaccineringsturbulens" ; -- vaccineringsturbulens..nn.1
  vacker_1_A = mkA "vacker" ; -- vacker..av.1
  vackerhet_1_N = mkN "vackerhet" ; -- vackerhet..nn.1
  vackla_1_V = mkV "vacklar" ; -- vackla..vb.1
  vacklande_1_N = mkN "vacklande" ; -- vacklande..nn.1
  vacuum_1_N = mkN "vacuum" neutrum  ; -- vacuum..nn.1
  vacuumbroms_1_N = mkN "vacuumbroms" ; -- vacuumbroms..nn.1
  vacuumförpackning_1_N = mkN "vacuumförpackning" ; -- vacuumförpackning..nn.1
  vacuumkammare_1_N = mkN "vacuumkammare" "vacuumkammaren" "vacuumkammare" "vacuumkamrarna" ; -- vacuumkammare..nn.1
  vacuumklocka_1_N = mkN "vacuumklocka" ; -- vacuumklocka..nn.1
  vacuumlampa_1_N = mkN "vacuumlampa" ; -- vacuumlampa..nn.1
  vacuummateria_1_N = mkN "vacuummateria" "vacuummaterian" "vacuummaterier" "vacuummaterierna" ; -- vacuummateria..nn.1
  vacuummeter_1_N = mkN "vacuummeter" ; -- vacuummeter..nn.1
  vacuumpump_1_N = mkN "vacuumpump" ; -- vacuumpump..nn.1
  vacuumregulator_1_N = mkN "vacuumregulator" "vacuumregulatorer" ; -- vacuumregulator..nn.1
  vacuumsug_1_N = mkN "vacuumsug" ; -- vacuumsug..nn.1
  vacuumtoalett_1_N = mkN "vacuumtoalett" "vacuumtoaletter" ; -- vacuumtoalett..nn.1
  vacuumtorkning_1_N = mkN "vacuumtorkning" ; -- vacuumtorkning..nn.1
  vad_1_Adv = mkAdv "vad" ; -- vad..ab.1
  vad_1_N = mkN "vad" neutrum  ; -- vad..nn.1
  vad_2_N = mkN "vad" "vador" ; -- vad..nn.2
  vad_3_N = mkN "vad" ; -- vad..nn.3
  vada_1_V = mkV "vadar" ; -- vada..vb.1
  vadande_1_N = mkN "vadande" ; -- vadande..nn.1
  vadarbyxa_1_N = mkN "vadarbyxa" ; -- vadarbyxa..nn.1
  vadare_1_N = mkN "vadare" utrum  ; -- vadare..nn.1
  vadarfågel_1_N = mkN "vadarfågel" ; -- vadarfågel..nn.1
  vadbar_1_A = mkA "vadbar" ; -- vadbar..av.1
  vadbarhet_1_N = mkN "vadbarhet" ; -- vadbarhet..nn.1
  vadben_1_N = mkN "vadben" neutrum  ; -- vadben..nn.1
  vadd_1_N = mkN "vadd" ; -- vadd..nn.1
  vaddera_1_V = mkV "vadderar" ; -- vaddera..vb.1
  vadderande_1_N = mkN "vadderande" ; -- vadderande..nn.1
  vadderbar_1_A = mkA "vadderbar" ; -- vadderbar..av.1
  vadderbarhet_1_N = mkN "vadderbarhet" ; -- vadderbarhet..nn.1
  vaddering_1_N = mkN "vaddering" ; -- vaddering..nn.1
  vaddå_1_Adv = mkAdv "vaddå" ; -- vaddå..ab.1
  vadeinlaga_1_N = mkN "vadeinlaga" ; -- vadeinlaga..nn.1
  vademecum_1_N = mkN "vademecum" ; -- vademecum..nn.1
  vadfalls_1_Adv = mkAdv "vadfalls" ; -- vadfalls..ab.1
  vadfot_1_N = mkN "vadfot" "vadfötter" ; -- vadfot..nn.1
  vadhållare_1_N = mkN "vadhållare" utrum  ; -- vadhållare..nn.1
  vadhållning_1_N = mkN "vadhållning" ; -- vadhållning..nn.1
  vadhållningslag_1_N = mkN "vadhållningslag" ; -- vadhållningslag..nn.1
  vadlång_1_A = mkA "vadlång" ; -- vadlång..av.1
  vadmal_1_N = mkN "vadmal" ; -- vadmal..nn.1
  vadning_1_N = mkN "vadning" ; -- vadning..nn.1
  vados_1_A = mkA "vados" ; -- vados..av.1
  vadslagning_1_N = mkN "vadslagning" ; -- vadslagning..nn.1
  vadslagningsbyrå_1_N = mkN "vadslagningsbyrå" "vadslagningsbyråer" ; -- vadslagningsbyrå..nn.1
  vadställe_1_N = mkN "vadställe" ; -- vadställe..nn.1
  vadå_1_Adv = mkAdv "vadå" ; -- vadå..ab.1
  vafalls_1_Adv = mkAdv "vafalls" ; -- vafalls..ab.1
  vag_1_A = mkA "vag" ; -- vag..av.1
  vagabond_1_N = mkN "vagabond" "vagabonder" ; -- vagabond..nn.1
  vagabondera_1_V = mkV "vagabonderar" ; -- vagabondera..vb.1
  vagabonderande_1_N = mkN "vagabonderande" ; -- vagabonderande..nn.1
  vagabondering_1_N = mkN "vagabondering" ; -- vagabondering..nn.1
  vagabondliv_1_N = mkN "vagabondliv" neutrum  ; -- vagabondliv..nn.1
  vagabondnatur_1_N = mkN "vagabondnatur" "vagabondnaturer" ; -- vagabondnatur..nn.1
  vagant_1_N = mkN "vagant" "vaganter" ; -- vagant..nn.1
  vagel_1_N = mkN "vagel" ; -- vagel..nn.1
  vagga_1_N = mkN "vagga" ; -- vagga..nn.1
  vagga_1_V = mkV "vaggar" ; -- vagga..vb.1
  vaggande_1_N = mkN "vaggande" ; -- vaggande..nn.1
  vaggsång_1_N = mkN "vaggsång" "vaggsånger" ; -- vaggsång..nn.1
  vaggtryck_1_N = mkN "vaggtryck" neutrum  ; -- vaggtryck..nn.1
  vaggvisa_1_N = mkN "vaggvisa" ; -- vaggvisa..nn.1
  vaghet_1_N = mkN "vaghet" ; -- vaghet..nn.1
  vagina_1_N = mkN "vagina" ; -- vagina..nn.1
  vaginal_1_A = mkA "vaginal" ; -- vaginal..av.1
  vaginism_1_N = mkN "vaginism" "vaginismer" ; -- vaginism..nn.1
  vagn_1_N = mkN "vagn" ; -- vagn..nn.1
  vagnbjörn_1_N = mkN "vagnbjörn" ; -- vagnbjörn..nn.1
  vagnborg_1_N = mkN "vagnborg" ; -- vagnborg..nn.1
  vagnhall_1_N = mkN "vagnhall" ; -- vagnhall..nn.1
  vagnläge_1_N = mkN "vagnläge" ; -- vagnläge..nn.1
  vagnpark_1_N = mkN "vagnpark" "vagnparker" ; -- vagnpark..nn.1
  vagnsdörr_1_N = mkN "vagnsdörr" ; -- vagnsdörr..nn.1
  vagnshäck_1_N = mkN "vagnshäck" ; -- vagnshäck..nn.1
  vagnshäst_1_N = mkN "vagnshäst" ; -- vagnshäst..nn.1
  vagnskadeförsäkring_1_N = mkN "vagnskadeförsäkring" ; -- vagnskadeförsäkring..nn.1
  vagnskorg_1_N = mkN "vagnskorg" ; -- vagnskorg..nn.1
  vagnslast_1_N = mkN "vagnslast" "vagnslaster" ; -- vagnslast..nn.1
  vagnslider_1_N = mkN "vagnslider" neutrum  ; -- vagnslider..nn.1
  vagnsport_1_N = mkN "vagnsport" ; -- vagnsport..nn.1
  vagnstock_1_N = mkN "vagnstock" ; -- vagnstock..nn.1
  vagnsätt_1_N = mkN "vagnsätt" neutrum  ; -- vagnsätt..nn.1
  vagong_1_N = mkN "vagong" "vagonger" ; -- vagong..nn.1
  vaj_1_N = mkN "vaj" ; -- vaj..nn.1
  vaja_1_N = mkN "vaja" ; -- vaja..nn.1
  vaja_1_V = mkV "vajar" ; -- vaja..vb.1
  vajande_1_N = mkN "vajande" ; -- vajande..nn.1
  vajer_1_N = mkN "vajer" ; -- vajer..nn.1
  vajerväg_1_N = mkN "vajerväg" ; -- vajerväg..nn.1
  vajsing_1_N = mkN "vajsing" ; -- vajsing..nn.1
  vak_1_N = mkN "vak" ; -- vak..nn.1
  vak_2_N = mkN "vak" neutrum  ; -- vak..nn.2
  vaka_1_N = mkN "vaka" ; -- vaka..nn.1
  vaka_1_V = mkV "vakar" ; -- vaka..vb.1
  vakande_1_N = mkN "vakande" ; -- vakande..nn.1
  vakans_1_N = mkN "vakans" "vakanser" ; -- vakans..nn.1
  vakansförordnande_1_N = mkN "vakansförordnande" ; -- vakansförordnande..nn.1
  vakanssätta_1_V = mkV "vakanssätta" "vakanssätter" "vakanssätt" "vakanssatte" "vakanssatt" "vakanssatt" ; -- vakanssätta..vb.1
  vakanssättande_1_N = mkN "vakanssättande" ; -- vakanssättande..nn.1
  vakansvikarie_1_N = mkN "vakansvikarie" "vakansvikarier" ; -- vakansvikarie..nn.1
  vakant_1_A = mkA "vakant" "vakant" ; -- vakant..av.1
  vakantsätta_1_V = mkV "vakantsätta" "vakantsätter" "vakantsätt" "vakantsatte" "vakantsatt" "vakantsatt" ; -- vakantsätta..vb.1
  vakantsättande_1_N = mkN "vakantsättande" ; -- vakantsättande..nn.1
  vakare_1_N = mkN "vakare" utrum  ; -- vakare..nn.1
  vaken_1_A = mkA "vaken" ; -- vaken..av.1
  vakenhet_1_N = mkN "vakenhet" ; -- vakenhet..nn.1
  vakfågel_1_N = mkN "vakfågel" ; -- vakfågel..nn.1
  vakna_1_V = mkV "vaknar" ; -- vakna..vb.1
  vaknande_1_N = mkN "vaknande" ; -- vaknande..nn.1
  vaknatt_1_N = mkN "vaknatt" "vaknätter" ; -- vaknatt..nn.1
  vaksam_1_A = mkA "vaksam" "vaksamt" "vaksamma" "vaksamma" "vaksammare" "vaksammast" "vaksammaste" ; -- vaksam..av.1
  vaksamhet_1_N = mkN "vaksamhet" ; -- vaksamhet..nn.1
  vaksin_1_N = mkN "vaksin" neutrum  ; -- vaksin..nn.1
  vaksination_1_N = mkN "vaksination" ; -- vaksination..nn.1
  vaksinatör_1_N = mkN "vaksinatör" "vaksinatörer" ; -- vaksinatör..nn.1
  vaksinera_1_V = mkV "vaksinerar" ; -- vaksinera..vb.1
  vaksinerande_1_N = mkN "vaksinerande" ; -- vaksinerande..nn.1
  vaksinerbar_1_A = mkA "vaksinerbar" ; -- vaksinerbar..av.1
  vaksinerbarhet_1_N = mkN "vaksinerbarhet" ; -- vaksinerbarhet..nn.1
  vaksinering_1_N = mkN "vaksinering" ; -- vaksinering..nn.1
  vakt_1_N = mkN "vakt" "vakter" ; -- vakt..nn.1
  vakta_1_V = mkV "vaktar" ; -- vakta..vb.1
  vaktande_1_N = mkN "vaktande" ; -- vaktande..nn.1
  vaktare_1_N = mkN "vaktare" utrum  ; -- vaktare..nn.1
  vaktarrest_1_N = mkN "vaktarrest" "vaktarrester" ; -- vaktarrest..nn.1
  vaktavlösning_1_N = mkN "vaktavlösning" ; -- vaktavlösning..nn.1
  vaktbricka_1_N = mkN "vaktbricka" ; -- vaktbricka..nn.1
  vaktel_1_N = mkN "vaktel" ; -- vaktel..nn.1
  vakteld_1_N = mkN "vakteld" ; -- vakteld..nn.1
  vakthavande_1_A = mkA "vakthavande" ; -- vakthavande..av.1
  vakthavande_1_N = mkN "vakthavande" "vakthavanden" "vakthavanden" "vakthavandena" ; -- vakthavande..nn.1
  vakthund_1_N = mkN "vakthund" ; -- vakthund..nn.1
  vakthållning_1_N = mkN "vakthållning" ; -- vakthållning..nn.1
  vaktkur_1_N = mkN "vaktkur" ; -- vaktkur..nn.1
  vaktman_1_N = mkN "vaktman" "vaktmannen" "vaktmän" "vaktmännen" ; -- vaktman..nn.1
  vaktmästare_1_N = mkN "vaktmästare" utrum  ; -- vaktmästare..nn.1
  vaktmästeri_1_N = mkN "vaktmästeri" "vaktmästeriet" "vaktmästerier" "vaktmästerierna" ; -- vaktmästeri..nn.1
  vaktparad_1_N = mkN "vaktparad" "vaktparader" ; -- vaktparad..nn.1
  vaktpost_1_N = mkN "vaktpost" "vaktposter" ; -- vaktpost..nn.1
  vaktstyrka_1_N = mkN "vaktstyrka" ; -- vaktstyrka..nn.1
  vakttorn_1_N = mkN "vakttorn" neutrum  ; -- vakttorn..nn.1
  vaktuniform_1_N = mkN "vaktuniform" "vaktuniformer" ; -- vaktuniform..nn.1
  vakuum_1_N = mkN "vakuum" neutrum  ; -- vakuum..nn.1
  vakuumbroms_1_N = mkN "vakuumbroms" ; -- vakuumbroms..nn.1
  vakuumförpackning_1_N = mkN "vakuumförpackning" ; -- vakuumförpackning..nn.1
  vakuumkammare_1_N = mkN "vakuumkammare" "vakuumkammaren" "vakuumkammare" "vakuumkamrarna" ; -- vakuumkammare..nn.1
  vakuumklocka_1_N = mkN "vakuumklocka" ; -- vakuumklocka..nn.1
  vakuumlampa_1_N = mkN "vakuumlampa" ; -- vakuumlampa..nn.1
  vakuummateria_1_N = mkN "vakuummateria" "vakuummaterian" "vakuummaterier" "vakuummaterierna" ; -- vakuummateria..nn.1
  vakuummeter_1_N = mkN "vakuummeter" ; -- vakuummeter..nn.1
  vakuumpump_1_N = mkN "vakuumpump" ; -- vakuumpump..nn.1
  vakuumregulator_1_N = mkN "vakuumregulator" "vakuumregulatorer" ; -- vakuumregulator..nn.1
  vakuumsug_1_N = mkN "vakuumsug" ; -- vakuumsug..nn.1
  vakuumtoalett_1_N = mkN "vakuumtoalett" "vakuumtoaletter" ; -- vakuumtoalett..nn.1
  vakuumtorkning_1_N = mkN "vakuumtorkning" ; -- vakuumtorkning..nn.1
  val_1_N = mkN "val" neutrum  ; -- val..nn.1
  val_2_N = mkN "val" ; -- val..nn.2
  vala_1_N = mkN "vala" ; -- vala..nn.1
  valack_1_N = mkN "valack" "valacker" ; -- valack..nn.1
  valacka_1_V = mkV "valackar" ; -- valacka..vb.1
  valackande_1_N = mkN "valackande" ; -- valackande..nn.1
  valaffisch_1_N = mkN "valaffisch" "valaffischer" ; -- valaffisch..nn.1
  valapparat_1_N = mkN "valapparat" "valapparater" ; -- valapparat..nn.1
  valarbetare_1_N = mkN "valarbetare" utrum  ; -- valarbetare..nn.1
  valbar_1_A = mkA "valbar" ; -- valbar..av.1
  valbarhet_1_N = mkN "valbarhet" ; -- valbarhet..nn.1
  valbarometer_1_N = mkN "valbarometer" ; -- valbarometer..nn.1
  valberedning_1_N = mkN "valberedning" ; -- valberedning..nn.1
  valbestånd_1_N = mkN "valbestånd" neutrum  ; -- valbestånd..nn.1
  valbiskop_1_N = mkN "valbiskop" ; -- valbiskop..nn.1
  valbod_1_N = mkN "valbod" ; -- valbod..nn.1
  valborg_1_N = mkN "valborg" ; -- valborg..nn.1
  valborgsmäss_1_N = mkN "valborgsmäss" ; -- valborgsmäss..nn.1
  valborgsmässoafton_1_N = mkN "valborgsmässoafton" "valborgsmässoaftonen" "valborgsmässoaftnar" "valborgsmässoaftnarna" ; -- valborgsmässoafton..nn.1
  valborgsmässofirande_1_N = mkN "valborgsmässofirande" ; -- valborgsmässofirande..nn.1
  valboskap_1_N = mkN "valboskap" ; -- valboskap..nn.1
  valbyrå_1_N = mkN "valbyrå" "valbyråer" ; -- valbyrå..nn.1
  valdag_1_N = mkN "valdag" ; -- valdag..nn.1
  valdebatt_1_N = mkN "valdebatt" "valdebatter" ; -- valdebatt..nn.1
  valdeltagande_1_N = mkN "valdeltagande" ; -- valdeltagande..nn.1
  valdeltagare_1_N = mkN "valdeltagare" utrum  ; -- valdeltagare..nn.1
  valdistrikt_1_N = mkN "valdistrikt" neutrum  ; -- valdistrikt..nn.1
  valdäck_1_N = mkN "valdäck" neutrum  ; -- valdäck..nn.1
  valen_1_A = mkA "valen" ; -- valen..av.1
  valens_1_N = mkN "valens" "valenser" ; -- valens..nn.1
  valenselektron_1_N = mkN "valenselektron" "valenselektroner" ; -- valenselektron..nn.1
  valenstal_1_N = mkN "valenstal" neutrum  ; -- valenstal..nn.1
  valeriana_1_N = mkN "valeriana" ; -- valeriana..nn.1
  valfiasko_1_N = mkN "valfiasko" "valfiaskot" "valfiaskon" "valfiaskona" ; -- valfiasko..nn.1
  valfiffel_1_N = mkN "valfiffel" neutrum  ; -- valfiffel..nn.1
  valfisk_1_N = mkN "valfisk" ; -- valfisk..nn.1
  valfläsk_1_N = mkN "valfläsk" neutrum  ; -- valfläsk..nn.1
  valforskare_1_N = mkN "valforskare" utrum  ; -- valforskare..nn.1
  valforskning_1_N = mkN "valforskning" ; -- valforskning..nn.1
  valfri_1_A = mkA "valfri" "valfritt" ; -- valfri..av.1
  valfrihet_1_N = mkN "valfrihet" "valfriheter" ; -- valfrihet..nn.1
  valfrändskap_1_N = mkN "valfrändskap" "valfrändskaper" ; -- valfrändskap..nn.1
  valfråga_1_N = mkN "valfråga" ; -- valfråga..nn.1
  valfurste_1_N = mkN "valfurste" utrum  ; -- valfurste..nn.1
  valfusk_1_N = mkN "valfusk" neutrum  ; -- valfusk..nn.1
  valfuska_1_V = mkV "valfuskar" ; -- valfuska..vb.1
  valfuskande_1_N = mkN "valfuskande" ; -- valfuskande..nn.1
  valfångare_1_N = mkN "valfångare" utrum  ; -- valfångare..nn.1
  valfångst_1_N = mkN "valfångst" ; -- valfångst..nn.1
  valförlust_1_N = mkN "valförlust" "valförluster" ; -- valförlust..nn.1
  valförrättare_1_N = mkN "valförrättare" utrum  ; -- valförrättare..nn.1
  valförvantskap_1_N = mkN "valförvantskap" ; -- valförvantskap..nn.1
  valgranskning_1_N = mkN "valgranskning" ; -- valgranskning..nn.1
  valgranskningsskommission_1_N = mkN "valgranskningsskommission" ; -- valgranskningsskommission..nn.1
  valhemlighet_1_N = mkN "valhemlighet" "valhemligheter" ; -- valhemlighet..nn.1
  valhänt_1_A = mkA "valhänt" "valhänt" ; -- valhänt..av.1
  valhänthet_1_N = mkN "valhänthet" "valhäntheter" ; -- valhänthet..nn.1
  valid_1_A = mkA "valid" ; -- valid..av.1
  validitet_1_N = mkN "validitet" "validiteter" ; -- validitet..nn.1
  valium_1_N = mkN "valium" neutrum  ; -- valium..nn.1
  valk_1_N = mkN "valk" ; -- valk..nn.1
  valka_1_V = mkV "valkar" ; -- valka..vb.1
  valkampanj_1_N = mkN "valkampanj" "valkampanjer" ; -- valkampanj..nn.1
  valkande_1_N = mkN "valkande" ; -- valkande..nn.1
  valkaos_1_N = mkN "valkaos" neutrum  ; -- valkaos..nn.1
  valkare_1_N = mkN "valkare" utrum  ; -- valkare..nn.1
  valkarstång_1_N = mkN "valkarstång" "valkarstänger" ; -- valkarstång..nn.1
  valkeri_1_N = mkN "valkeri" "valkeriet" "valkerier" "valkerierna" ; -- valkeri..nn.1
  valkgarva_1_V = mkV "valkgarvar" ; -- valkgarva..vb.1
  valkgarvande_1_N = mkN "valkgarvande" ; -- valkgarvande..nn.1
  valkig_1_A = mkA "valkig" ; -- valkig..av.1
  valkighet_1_N = mkN "valkighet" ; -- valkighet..nn.1
  valklagomål_1_N = mkN "valklagomål" neutrum  ; -- valklagomål..nn.1
  valkning_1_N = mkN "valkning" ; -- valkning..nn.1
  valkokeri_1_N = mkN "valkokeri" "valkokeriet" "valkokerier" "valkokerierna" ; -- valkokeri..nn.1
  valkommission_1_N = mkN "valkommission" ; -- valkommission..nn.1
  valkonung_1_N = mkN "valkonung" ; -- valkonung..nn.1
  valkorporation_1_N = mkN "valkorporation" ; -- valkorporation..nn.1
  valkrets_1_N = mkN "valkrets" ; -- valkrets..nn.1
  valkuvert_1_N = mkN "valkuvert" neutrum  ; -- valkuvert..nn.1
  valkyria_1_N = mkN "valkyria" ; -- valkyria..nn.1
  valkyrja_1_N = mkN "valkyrja" ; -- valkyrja..nn.1
  vall_1_N = mkN "vall" ; -- vall..nn.1
  valla_1_N = mkN "valla" ; -- valla..nn.1
  valla_1_V = mkV "vallar" ; -- valla..vb.1
  vallande_1_N = mkN "vallande" ; -- vallande..nn.1
  vallare_1_N = mkN "vallare" utrum  ; -- vallare..nn.1
  vallbonde_1_N = mkN "vallbonde" "vallbönder" ; -- vallbonde..nn.1
  vallfart_1_N = mkN "vallfart" "vallfarter" ; -- vallfart..nn.1
  vallfartsort_1_N = mkN "vallfartsort" "vallfartsorter" ; -- vallfartsort..nn.1
  vallflicka_1_N = mkN "vallflicka" ; -- vallflicka..nn.1
  vallfärd_1_N = mkN "vallfärd" "vallfärder" ; -- vallfärd..nn.1
  vallfärda_1_V = mkV "vallfärdar" ; -- vallfärda..vb.1
  vallfärdande_1_N = mkN "vallfärdande" ; -- vallfärdande..nn.1
  vallgosse_1_N = mkN "vallgosse" utrum  ; -- vallgosse..nn.1
  vallgrav_1_N = mkN "vallgrav" ; -- vallgrav..nn.1
  vallhorn_1_N = mkN "vallhorn" neutrum  ; -- vallhorn..nn.1
  vallhund_1_N = mkN "vallhund" ; -- vallhund..nn.1
  vallhö_1_N = mkN "vallhö" neutrum  ; -- vallhö..nn.1
  vallista_1_N = mkN "vallista" ; -- vallista..nn.1
  vallkrasse_1_N = mkN "vallkrasse" utrum  ; -- vallkrasse..nn.1
  vallkulla_1_N = mkN "vallkulla" ; -- vallkulla..nn.1
  vallmo_1_N = mkN "vallmo" "vallmor" ; -- vallmo..nn.1
  vallmoblomma_1_N = mkN "vallmoblomma" ; -- vallmoblomma..nn.1
  vallmofrö_1_N = mkN "vallmofrö" "vallmofröet" "vallmofrön" "vallmofröna" ; -- vallmofrö..nn.1
  vallmoodling_1_N = mkN "vallmoodling" ; -- vallmoodling..nn.1
  vallmote_1_N = mkN "vallmote" ; -- vallmote..nn.1
  vallmoväxt_1_N = mkN "vallmoväxt" "vallmoväxter" ; -- vallmoväxt..nn.1
  vallningstabell_1_N = mkN "vallningstabell" "vallningstabeller" ; -- vallningstabell..nn.1
  vallokal_1_N = mkN "vallokal" "vallokaler" ; -- vallokal..nn.1
  vallokalsundersökning_1_N = mkN "vallokalsundersökning" ; -- vallokalsundersökning..nn.1
  vallokomotiv_1_N = mkN "vallokomotiv" neutrum  ; -- vallokomotiv..nn.1
  vallon_1_N = mkN "vallon" "valloner" ; -- vallon..nn.1
  vallonsk_1_A = mkA "vallonsk" ; -- vallonsk..av.1
  vallonsmide_1_N = mkN "vallonsmide" ; -- vallonsmide..nn.1
  vallpojke_1_N = mkN "vallpojke" utrum  ; -- vallpojke..nn.1
  vallvisa_1_N = mkN "vallvisa" ; -- vallvisa..nn.1
  vallväxt_1_N = mkN "vallväxt" "vallväxter" ; -- vallväxt..nn.1
  vallängd_1_N = mkN "vallängd" "vallängder" ; -- vallängd..nn.1
  vallåt_1_N = mkN "vallåt" ; -- vallåt..nn.1
  vallöfte_1_N = mkN "vallöfte" ; -- vallöfte..nn.1
  valmad_1_A = mkA "valmad" ; -- valmad..av.1
  valmagnet_1_N = mkN "valmagnet" "valmagneter" ; -- valmagnet..nn.1
  valman_1_N = mkN "valman" "valmannen" "valmän" "valmännen" ; -- valman..nn.1
  valmanifest_1_N = mkN "valmanifest" neutrum  ; -- valmanifest..nn.1
  valmanskår_1_N = mkN "valmanskår" "valmanskårer" ; -- valmanskår..nn.1
  valmar_1_N = mkN "valmar" ; -- valmar..nn.1
  valmaskineri_1_N = mkN "valmaskineri" "valmaskineriet" "valmaskinerier" "valmaskinerierna" ; -- valmaskineri..nn.1
  valmatematik_1_N = mkN "valmatematik" ; -- valmatematik..nn.1
  valmonarki_1_N = mkN "valmonarki" "valmonarkier" ; -- valmonarki..nn.1
  valmtak_1_N = mkN "valmtak" neutrum  ; -- valmtak..nn.1
  valmöjlighet_1_N = mkN "valmöjlighet" "valmöjligheter" ; -- valmöjlighet..nn.1
  valmöte_1_N = mkN "valmöte" ; -- valmöte..nn.1
  valna_1_V = mkV "valnar" ; -- valna..vb.1
  valnande_1_N = mkN "valnande" ; -- valnande..nn.1
  valnederlag_1_N = mkN "valnederlag" neutrum  ; -- valnederlag..nn.1
  valnöt_1_N = mkN "valnöt" "valnötter" ; -- valnöt..nn.1
  valnötsbetsad_1_A = mkA "valnötsbetsad" ; -- valnötsbetsad..av.1
  valnötsgrå_1_A = mkA "valnötsgrå" "valnötsgrått" ; -- valnötsgrå..av.1
  valnötsliknande_1_A = mkA "valnötsliknande" ; -- valnötsliknande..av.1
  valnötsträ_1_N = mkN "valnötsträ" neutrum  ; -- valnötsträ..nn.1
  valnötsträd_1_N = mkN "valnötsträd" neutrum  ; -- valnötsträd..nn.1
  valnötstårta_1_N = mkN "valnötstårta" ; -- valnötstårta..nn.1
  valobservatör_1_N = mkN "valobservatör" "valobservatörer" ; -- valobservatör..nn.1
  valomgång_1_N = mkN "valomgång" ; -- valomgång..nn.1
  valorisation_1_N = mkN "valorisation" ; -- valorisation..nn.1
  valp_1_N = mkN "valp" ; -- valp..nn.1
  valpa_1_V = mkV "valpar" ; -- valpa..vb.1
  valpaktig_1_A = mkA "valpaktig" ; -- valpaktig..av.1
  valpaktighet_1_N = mkN "valpaktighet" ; -- valpaktighet..nn.1
  valpande_1_N = mkN "valpande" ; -- valpande..nn.1
  valparoll_1_N = mkN "valparoll" "valparoller" ; -- valparoll..nn.1
  valpig_1_A = mkA "valpig" ; -- valpig..av.1
  valpighet_1_N = mkN "valpighet" ; -- valpighet..nn.1
  valplats_1_N = mkN "valplats" "valplatser" ; -- valplats..nn.1
  valpning_1_N = mkN "valpning" ; -- valpning..nn.1
  valpropaganda_1_N = mkN "valpropaganda" ; -- valpropaganda..nn.1
  valpsjuka_1_N = mkN "valpsjuka" ; -- valpsjuka..nn.1
  valrav_1_N = mkN "valrav" ; -- valrav..nn.1
  valresultat_1_N = mkN "valresultat" neutrum  ; -- valresultat..nn.1
  valrike_1_N = mkN "valrike" ; -- valrike..nn.1
  valross_1_N = mkN "valross" ; -- valross..nn.1
  valrossmustasch_1_N = mkN "valrossmustasch" "valrossmustascher" ; -- valrossmustasch..nn.1
  valrätt_1_N = mkN "valrätt" ; -- valrätt..nn.1
  valrörelse_1_N = mkN "valrörelse" "valrörelser" ; -- valrörelse..nn.1
  vals_1_N = mkN "vals" ; -- vals..nn.1
  vals_2_N = mkN "vals" "valser" ; -- vals..nn.2
  valsa_1_V = mkV "valsar" ; -- valsa..vb.1
  valsande_1_N = mkN "valsande" ; -- valsande..nn.1
  valsedel_1_N = mkN "valsedel" ; -- valsedel..nn.1
  valseger_1_N = mkN "valseger" ; -- valseger..nn.1
  valsituation_1_N = mkN "valsituation" ; -- valsituation..nn.1
  valsjärn_1_N = mkN "valsjärn" neutrum  ; -- valsjärn..nn.1
  valskolk_1_N = mkN "valskolk" neutrum  ; -- valskolk..nn.1
  valskärm_1_N = mkN "valskärm" ; -- valskärm..nn.1
  valslogan_1_N = mkN "valslogan" "valsloganen" "valslogans" "valslogansen" ; -- valslogan..nn.1
  valsmelodi_1_N = mkN "valsmelodi" "valsmelodier" ; -- valsmelodi..nn.1
  valspråk_1_N = mkN "valspråk" neutrum  ; -- valspråk..nn.1
  valspurt_1_N = mkN "valspurt" "valspurter" ; -- valspurt..nn.1
  valssteg_1_N = mkN "valssteg" neutrum  ; -- valssteg..nn.1
  valstakt_1_N = mkN "valstakt" "valstakter" ; -- valstakt..nn.1
  valstrateg_1_N = mkN "valstrateg" "valstrateger" ; -- valstrateg..nn.1
  valstrategi_1_N = mkN "valstrategi" "valstrategier" ; -- valstrategi..nn.1
  valstuga_1_N = mkN "valstuga" ; -- valstuga..nn.1
  valstugeaffär_1_N = mkN "valstugeaffär" "valstugeaffärer" ; -- valstugeaffär..nn.1
  valstugeaktivist_1_N = mkN "valstugeaktivist" "valstugeaktivister" ; -- valstugeaktivist..nn.1
  valstugeavslöjande_1_N = mkN "valstugeavslöjande" ; -- valstugeavslöjande..nn.1
  valsverk_1_N = mkN "valsverk" neutrum  ; -- valsverk..nn.1
  valsätt_1_N = mkN "valsätt" neutrum  ; -- valsätt..nn.1
  valsång_1_N = mkN "valsång" "valsånger" ; -- valsång..nn.1
  valsör_1_N = mkN "valsör" "valsörer" ; -- valsör..nn.1
  valteknisk_1_A = mkA "valteknisk" ; -- valteknisk..av.1
  valthorn_1_N = mkN "valthorn" neutrum  ; -- valthorn..nn.1
  valtran_1_N = mkN "valtran" ; -- valtran..nn.1
  valupptakt_1_N = mkN "valupptakt" "valupptakter" ; -- valupptakt..nn.1
  valurna_1_N = mkN "valurna" ; -- valurna..nn.1
  valuta_1_N = mkN "valuta" ; -- valuta..nn.1
  valutaaffär_1_N = mkN "valutaaffär" "valutaaffärer" ; -- valutaaffär..nn.1
  valutabrott_1_N = mkN "valutabrott" neutrum  ; -- valutabrott..nn.1
  valutafond_1_N = mkN "valutafond" "valutafonder" ; -- valutafond..nn.1
  valutahandel_1_N = mkN "valutahandel" ; -- valutahandel..nn.1
  valutaklausul_1_N = mkN "valutaklausul" "valutaklausuler" ; -- valutaklausul..nn.1
  valutakurs_1_N = mkN "valutakurs" "valutakurser" ; -- valutakurs..nn.1
  valutamässig_1_A = mkA "valutamässig" ; -- valutamässig..av.1
  valutaoro_1_N = mkN "valutaoro" ; -- valutaoro..nn.1
  valutapolitik_1_N = mkN "valutapolitik" ; -- valutapolitik..nn.1
  valutapolitisk_1_A = mkA "valutapolitisk" ; -- valutapolitisk..av.1
  valutareglering_1_N = mkN "valutareglering" ; -- valutareglering..nn.1
  valutareserv_1_N = mkN "valutareserv" "valutareserver" ; -- valutareserv..nn.1
  valutasamarbete_1_N = mkN "valutasamarbete" ; -- valutasamarbete..nn.1
  valutasvin_1_N = mkN "valutasvin" neutrum  ; -- valutasvin..nn.1
  valutaunion_1_N = mkN "valutaunion" ; -- valutaunion..nn.1
  valutera_1_V = mkV "valuterar" ; -- valutera..vb.1
  valuterande_1_N = mkN "valuterande" ; -- valuterande..nn.1
  valuterbar_1_A = mkA "valuterbar" ; -- valuterbar..av.1
  valuterbarhet_1_N = mkN "valuterbarhet" ; -- valuterbarhet..nn.1
  valutering_1_N = mkN "valutering" ; -- valutering..nn.1
  valutgång_1_N = mkN "valutgång" ; -- valutgång..nn.1
  valv_1_N = mkN "valv" neutrum  ; -- valv..nn.1
  valvbåge_1_N = mkN "valvbåge" utrum  ; -- valvbåge..nn.1
  valvel_1_N = mkN "valvel" "valveln" "valvler" "valvlerna" ; -- valvel..nn.1
  valvera_1_V = mkV "valverar" ; -- valvera..vb.1
  valverande_1_N = mkN "valverande" ; -- valverande..nn.1
  valverbar_1_A = mkA "valverbar" ; -- valverbar..av.1
  valverbarhet_1_N = mkN "valverbarhet" ; -- valverbarhet..nn.1
  valvering_1_N = mkN "valvering" ; -- valvering..nn.1
  valvgång_1_N = mkN "valvgång" ; -- valvgång..nn.1
  valvind_1_N = mkN "valvind" ; -- valvind..nn.1
  valvinnare_1_N = mkN "valvinnare" utrum  ; -- valvinnare..nn.1
  valvinst_1_N = mkN "valvinst" "valvinster" ; -- valvinst..nn.1
  valvport_1_N = mkN "valvport" ; -- valvport..nn.1
  valvslagning_1_N = mkN "valvslagning" ; -- valvslagning..nn.1
  valvstupstående_1_N = mkN "valvstupstående" ; -- valvstupstående..nn.1
  valår_1_N = mkN "valår" ; -- valår..nn.1
  valör_1_N = mkN "valör" "valörer" ; -- valör..nn.1
  valörmåleri_1_N = mkN "valörmåleri" neutrum  ; -- valörmåleri..nn.1
  valörtryck_1_N = mkN "valörtryck" neutrum  ; -- valörtryck..nn.1
  valöverklagande_1_N = mkN "valöverklagande" ; -- valöverklagande..nn.1
  vamp_1_N = mkN "vamp" ; -- vamp..nn.1
  vampa_1_V = mkV "vampar" ; -- vampa..vb.1
  vampande_1_N = mkN "vampande" ; -- vampande..nn.1
  vampig_1_A = mkA "vampig" ; -- vampig..av.1
  vampighet_1_N = mkN "vampighet" ; -- vampighet..nn.1
  vampyr_1_N = mkN "vampyr" "vampyrer" ; -- vampyr..nn.1
  vampyrroman_1_N = mkN "vampyrroman" "vampyrromaner" ; -- vampyrroman..nn.1
  van_1_A = mkA "van" ; -- van..av.1
  van_1_N = mkN "van" "vaner" ; -- van..nn.1
  van_2_N = mkN "van" ; -- van..nn.2
  vana_1_N = mkN "vana" ; -- vana..nn.1
  vanadin_1_N = mkN "vanadin" ; -- vanadin..nn.1
  vanadinbrytning_1_N = mkN "vanadinbrytning" ; -- vanadinbrytning..nn.1
  vanadinskaft_1_N = mkN "vanadinskaft" neutrum  ; -- vanadinskaft..nn.1
  vanadinstål_1_N = mkN "vanadinstål" neutrum  ; -- vanadinstål..nn.1
  vanart_1_N = mkN "vanart" "vanarter" ; -- vanart..nn.1
  vanartad_1_A = mkA "vanartad" ; -- vanartad..av.1
  vanartig_1_A = mkA "vanartig" ; -- vanartig..av.1
  vanartighet_1_N = mkN "vanartighet" ; -- vanartighet..nn.1
  vandal_1_N = mkN "vandal" "vandaler" ; -- vandal..nn.1
  vandalisera_1_V = mkV "vandaliserar" ; -- vandalisera..vb.1
  vandaliserande_1_N = mkN "vandaliserande" ; -- vandaliserande..nn.1
  vandaliserbar_1_A = mkA "vandaliserbar" ; -- vandaliserbar..av.1
  vandaliserbarhet_1_N = mkN "vandaliserbarhet" ; -- vandaliserbarhet..nn.1
  vandalisering_1_N = mkN "vandalisering" ; -- vandalisering..nn.1
  vandalisk_1_A = mkA "vandalisk" ; -- vandalisk..av.1
  vandalism_1_N = mkN "vandalism" "vandalismer" ; -- vandalism..nn.1
  vandel_1_N = mkN "vandel" ; -- vandel..nn.1
  vandra_1_V = mkV "vandrar" ; -- vandra..vb.1
  vandrande_1_N = mkN "vandrande" ; -- vandrande..nn.1
  vandrarcell_1_N = mkN "vandrarcell" "vandrarceller" ; -- vandrarcell..nn.1
  vandrare_1_N = mkN "vandrare" utrum  ; -- vandrare..nn.1
  vandrarfolk_1_N = mkN "vandrarfolk" neutrum  ; -- vandrarfolk..nn.1
  vandrarhem_1_N = mkN "vandrarhem" "vandrarhemmet" "vandrarhem" "vandrarhemmen" ; -- vandrarhem..nn.1
  vandrarkänga_1_N = mkN "vandrarkänga" ; -- vandrarkänga..nn.1
  vandring_1_N = mkN "vandring" ; -- vandring..nn.1
  vandringsalbatross_1_N = mkN "vandringsalbatross" ; -- vandringsalbatross..nn.1
  vandringscell_1_N = mkN "vandringscell" "vandringsceller" ; -- vandringscell..nn.1
  vandringsfisk_1_N = mkN "vandringsfisk" ; -- vandringsfisk..nn.1
  vandringsfolk_1_N = mkN "vandringsfolk" neutrum  ; -- vandringsfolk..nn.1
  vandringsled_1_N = mkN "vandringsled" "vandringsleder" ; -- vandringsled..nn.1
  vandringslust_1_N = mkN "vandringslust" ; -- vandringslust..nn.1
  vandringsman_1_N = mkN "vandringsman" "vandringsmannen" "vandringsmän" "vandringsmännen" ; -- vandringsman..nn.1
  vandringspokal_1_N = mkN "vandringspokal" "vandringspokaler" ; -- vandringspokal..nn.1
  vandringspris_1_N = mkN "vandringspris" neutrum  ; -- vandringspris..nn.1
  vandringsstav_1_N = mkN "vandringsstav" ; -- vandringsstav..nn.1
  vandringsutställning_1_N = mkN "vandringsutställning" ; -- vandringsutställning..nn.1
  vandringsvågrör_1_N = mkN "vandringsvågrör" neutrum  ; -- vandringsvågrör..nn.1
  vandringsår_1_N = mkN "vandringsår" neutrum  ; -- vandringsår..nn.1
  vanebildande_1_A = mkA "vanebildande" ; -- vanebildande..av.1
  vanebildning_1_N = mkN "vanebildning" ; -- vanebildning..nn.1
  vanedjur_1_N = mkN "vanedjur" neutrum  ; -- vanedjur..nn.1
  vanedrinkare_1_N = mkN "vanedrinkare" utrum  ; -- vanedrinkare..nn.1
  vaneförbrytare_1_N = mkN "vaneförbrytare" utrum  ; -- vaneförbrytare..nn.1
  vanekristen_1_A = mkA "vanekristen" ; -- vanekristen..av.1
  vanemänniska_1_N = mkN "vanemänniska" ; -- vanemänniska..nn.1
  vanemässig_1_A = mkA "vanemässig" ; -- vanemässig..av.1
  vanemässighet_1_N = mkN "vanemässighet" ; -- vanemässighet..nn.1
  vanesak_1_N = mkN "vanesak" "vanesaker" ; -- vanesak..nn.1
  vanetänkande_1_N = mkN "vanetänkande" ; -- vanetänkande..nn.1
  vaneätare_1_N = mkN "vaneätare" utrum  ; -- vaneätare..nn.1
  vanfrejd_1_N = mkN "vanfrejd" ; -- vanfrejd..nn.1
  vanför_1_A = mkA "vanför" ; -- vanför..av.1
  vanföreställning_1_N = mkN "vanföreställning" ; -- vanföreställning..nn.1
  vanförhet_1_N = mkN "vanförhet" "vanförheter" ; -- vanförhet..nn.1
  vanheder_1_N = mkN "vanheder" ; -- vanheder..nn.1
  vanhederlig_1_A = mkA "vanhederlig" ; -- vanhederlig..av.1
  vanhederlighet_1_N = mkN "vanhederlighet" ; -- vanhederlighet..nn.1
  vanhedra_1_V = mkV "vanhedrar" ; -- vanhedra..vb.1
  vanhedrande_1_N = mkN "vanhedrande" ; -- vanhedrande..nn.1
  vanhelga_1_V = mkV "vanhelgar" ; -- vanhelga..vb.1
  vanhelgande_1_N = mkN "vanhelgande" ; -- vanhelgande..nn.1
  vanhelgd_1_N = mkN "vanhelgd" ; -- vanhelgd..nn.1
  vanhet_1_N = mkN "vanhet" ; -- vanhet..nn.1
  vanhävd_1_N = mkN "vanhävd" ; -- vanhävd..nn.1
  vanilj_1_N = mkN "vanilj" ; -- vanilj..nn.1
  vaniljgiffel_1_N = mkN "vaniljgiffel" ; -- vaniljgiffel..nn.1
  vaniljsocker_1_N = mkN "vaniljsocker" neutrum  ; -- vaniljsocker..nn.1
  vaniljsås_1_N = mkN "vaniljsås" "vaniljsåser" ; -- vaniljsås..nn.1
  vaniljvisp_1_N = mkN "vaniljvisp" ; -- vaniljvisp..nn.1
  vanillin_1_N = mkN "vanillin" "vanilliner" ; -- vanillin..nn.1
  vank_1_N = mkN "vank" ; -- vank..nn.1
  vanka_1_V = mkV "vankar" ; -- vanka..vb.1
  vankande_1_N = mkN "vankande" ; -- vankande..nn.1
  vankant_1_N = mkN "vankant" "vankanter" ; -- vankant..nn.1
  vankelmod_1_N = mkN "vankelmod" neutrum  ; -- vankelmod..nn.1
  vankelmodig_1_A = mkA "vankelmodig" ; -- vankelmodig..av.1
  vankelmodighet_1_N = mkN "vankelmodighet" ; -- vankelmodighet..nn.1
  vanlig_1_A = mkA "vanlig" ; -- vanlig..av.1
  vanligen_1_Adv = mkAdv "vanligen" ; -- vanligen..ab.1
  vanlighet_1_N = mkN "vanlighet" "vanligheter" ; -- vanlighet..nn.1
  vanligtvis_1_Adv = mkAdv "vanligtvis" ; -- vanligtvis..ab.1
  vanlottad_1_A = mkA "vanlottad" ; -- vanlottad..av.1
  vanmakt_1_N = mkN "vanmakt" ; -- vanmakt..nn.1
  vanmäktig_1_A = mkA "vanmäktig" ; -- vanmäktig..av.1
  vanmäktighet_1_N = mkN "vanmäktighet" ; -- vanmäktighet..nn.1
  vanna_1_N = mkN "vanna" ; -- vanna..nn.1
  vanna_1_V = mkV "vannar" ; -- vanna..vb.1
  vannande_1_N = mkN "vannande" ; -- vannande..nn.1
  vanpryda_1_V = mkV "vanpryda" "vanprydde" "vanprytt" ; -- vanpryda..vb.1
  vanprydande_1_N = mkN "vanprydande" ; -- vanprydande..nn.1
  vanprydnad_1_N = mkN "vanprydnad" "vanprydnader" ; -- vanprydnad..nn.1
  vanryktad_1_A = mkA "vanryktad" ; -- vanryktad..av.1
  vanrykte_1_N = mkN "vanrykte" ; -- vanrykte..nn.1
  vansinne_1_N = mkN "vansinne" ; -- vansinne..nn.1
  vansinnesdåd_1_N = mkN "vansinnesdåd" neutrum  ; -- vansinnesdåd..nn.1
  vansinneskörning_1_N = mkN "vansinneskörning" ; -- vansinneskörning..nn.1
  vansinnig_1_A = mkA "vansinnig" ; -- vansinnig..av.1
  vansinnighet_1_N = mkN "vansinnighet" "vansinnigheter" ; -- vansinnighet..nn.1
  vansinnigt_1_Adv = mkAdv "vansinnigt" ; -- vansinnigt..ab.1
  vanskapad_1_A = mkA "vanskapad" ; -- vanskapad..av.1
  vanskaplig_1_A = mkA "vanskaplig" ; -- vanskaplig..av.1
  vanskaplighet_1_N = mkN "vanskaplighet" ; -- vanskaplighet..nn.1
  vanskapnad_1_N = mkN "vanskapnad" "vanskapnader" ; -- vanskapnad..nn.1
  vanskapt_1_A = mkA "vanskapt" "vanskapt" ; -- vanskapt..av.1
  vanskapthet_1_N = mkN "vanskapthet" "vanskaptheter" ; -- vanskapthet..nn.1
  vansklig_1_A = mkA "vansklig" ; -- vansklig..av.1
  vansklighet_1_N = mkN "vansklighet" "vanskligheter" ; -- vansklighet..nn.1
  vansköta_1_V = mkV "vansköter" ; -- vansköta..vb.1
  vanskötande_1_N = mkN "vanskötande" ; -- vanskötande..nn.1
  vanskötsel_1_N = mkN "vanskötsel" ; -- vanskötsel..nn.1
  vanskött_1_A = mkA "vanskött" ; -- vanskött..av.1
  vanstark_1_A = mkA "vanstark" ; -- vanstark..av.1
  vanstarkhet_1_N = mkN "vanstarkhet" ; -- vanstarkhet..nn.1
  vanstyra_1_V = mkV "vanstyra" "vanstyrde" "vanstyrt" ; -- vanstyra..vb.1
  vanstyrande_1_N = mkN "vanstyrande" ; -- vanstyrande..nn.1
  vanstyre_1_N = mkN "vanstyre" ; -- vanstyre..nn.1
  vanställa_1_V = mkV "vanställer" ; -- vanställa..vb.1
  vanställande_1_N = mkN "vanställande" ; -- vanställande..nn.1
  vanställning_1_N = mkN "vanställning" ; -- vanställning..nn.1
  vant_1_N = mkN "vant" neutrum  ; -- vant..nn.1
  vante_1_N = mkN "vante" utrum  ; -- vante..nn.1
  vantolka_1_V = mkV "vantolkar" ; -- vantolka..vb.1
  vantolkande_1_N = mkN "vantolkande" ; -- vantolkande..nn.1
  vantolkning_1_N = mkN "vantolkning" ; -- vantolkning..nn.1
  vantrivsel_1_N = mkN "vantrivsel" ; -- vantrivsel..nn.1
  vantro_1_N = mkN "vantro" ; -- vantro..nn.1
  vantrogen_1_A = mkA "vantrogen" ; -- vantrogen..av.1
  vantrogenhet_1_N = mkN "vantrogenhet" ; -- vantrogenhet..nn.1
  vantskruv_1_N = mkN "vantskruv" ; -- vantskruv..nn.1
  vantspridare_1_N = mkN "vantspridare" utrum  ; -- vantspridare..nn.1
  vanuatisk_1_A = mkA "vanuatisk" ; -- vanuatisk..av.1
  vanuatiska_1_N = mkN "vanuatiska" ; -- vanuatiska..nn.1
  vanuatiska_2_N = mkN "vanuatiska" ; -- vanuatiska..nn.2
  vanuatuer_1_N = mkN "vanuatuer" "vanuatuern" "vanuatuer" "vanuatuerna" ; -- vanuatuer..nn.1
  vanvett_1_N = mkN "vanvett" neutrum  ; -- vanvett..nn.1
  vanvettig_1_A = mkA "vanvettig" ; -- vanvettig..av.1
  vanvettighet_1_N = mkN "vanvettighet" "vanvettigheter" ; -- vanvettighet..nn.1
  vanvetting_1_N = mkN "vanvetting" ; -- vanvetting..nn.1
  vanvård_1_N = mkN "vanvård" ; -- vanvård..nn.1
  vanvårda_1_V = mkV "vanvårdar" ; -- vanvårda..vb.1
  vanvårdande_1_N = mkN "vanvårdande" ; -- vanvårdande..nn.1
  vanvårdnad_1_N = mkN "vanvårdnad" ; -- vanvårdnad..nn.1
  vanvörda_1_V = mkV "vanvördar" ; -- vanvörda..vb.1
  vanvördande_1_N = mkN "vanvördande" ; -- vanvördande..nn.1
  vanvördig_1_A = mkA "vanvördig" ; -- vanvördig..av.1
  vanvördighet_1_N = mkN "vanvördighet" ; -- vanvördighet..nn.1
  vanvördnad_1_N = mkN "vanvördnad" "vanvördnader" ; -- vanvördnad..nn.1
  vanära_1_N = mkN "vanära" ; -- vanära..nn.1
  vanära_1_V = mkV "vanärar" ; -- vanära..vb.1
  vanärande_1_A = mkA "vanärande" ; -- vanärande..av.1
  vanärande_1_N = mkN "vanärande" ; -- vanärande..nn.1
  vapen_1_N = mkN "vapen" "vapnet" "vapen" "vapnen" ; -- vapen..nn.1
  vapenarsenal_1_N = mkN "vapenarsenal" "vapenarsenaler" ; -- vapenarsenal..nn.1
  vapenbok_1_N = mkN "vapenbok" "vapenböcker" ; -- vapenbok..nn.1
  vapenbrak_1_N = mkN "vapenbrak" neutrum  ; -- vapenbrak..nn.1
  vapenbroder_1_N = mkN "vapenbroder" "vapenbrodern" "vapenbröder" "vapenbröderna" ; -- vapenbroder..nn.1
  vapendans_1_N = mkN "vapendans" "vapendanser" ; -- vapendans..nn.1
  vapendragare_1_N = mkN "vapendragare" utrum  ; -- vapendragare..nn.1
  vapenembargo_1_N = mkN "vapenembargo" ; -- vapenembargo..nn.1
  vapenexport_1_N = mkN "vapenexport" ; -- vapenexport..nn.1
  vapenfabrik_1_N = mkN "vapenfabrik" "vapenfabriker" ; -- vapenfabrik..nn.1
  vapenfetischist_1_N = mkN "vapenfetischist" "vapenfetischister" ; -- vapenfetischist..nn.1
  vapenfett_1_N = mkN "vapenfett" neutrum  ; -- vapenfett..nn.1
  vapenfri_1_A = mkA "vapenfri" "vapenfritt" ; -- vapenfri..av.1
  vapenfynd_1_N = mkN "vapenfynd" neutrum  ; -- vapenfynd..nn.1
  vapenför_1_A = mkA "vapenför" ; -- vapenför..av.1
  vapenförhet_1_N = mkN "vapenförhet" ; -- vapenförhet..nn.1
  vapengren_1_N = mkN "vapengren" "vapengrenen" "vapengrenar" "vapengrenarna" ; -- vapengren..nn.1
  vapenhot_1_N = mkN "vapenhot" neutrum  ; -- vapenhot..nn.1
  vapenhus_1_N = mkN "vapenhus" neutrum  ; -- vapenhus..nn.1
  vapenlager_1_N = mkN "vapenlager" neutrum  ; -- vapenlager..nn.1
  vapenlarm_1_N = mkN "vapenlarm" neutrum  ; -- vapenlarm..nn.1
  vapenlek_1_N = mkN "vapenlek" ; -- vapenlek..nn.1
  vapenlös_1_A = mkA "vapenlös" ; -- vapenlös..av.1
  vapenlöshet_1_N = mkN "vapenlöshet" ; -- vapenlöshet..nn.1
  vapenmakt_1_N = mkN "vapenmakt" ; -- vapenmakt..nn.1
  vapenmässig_1_A = mkA "vapenmässig" ; -- vapenmässig..av.1
  vapenregistrering_1_N = mkN "vapenregistrering" ; -- vapenregistrering..nn.1
  vapenrock_1_N = mkN "vapenrock" ; -- vapenrock..nn.1
  vapenskifte_1_N = mkN "vapenskifte" ; -- vapenskifte..nn.1
  vapenskrammel_1_N = mkN "vapenskrammel" neutrum  ; -- vapenskrammel..nn.1
  vapensköld_1_N = mkN "vapensköld" ; -- vapensköld..nn.1
  vapenslag_1_N = mkN "vapenslag" neutrum  ; -- vapenslag..nn.1
  vapensmed_1_N = mkN "vapensmed" "vapensmeder" ; -- vapensmed..nn.1
  vapensmedja_1_N = mkN "vapensmedja" ; -- vapensmedja..nn.1
  vapensmide_1_N = mkN "vapensmide" ; -- vapensmide..nn.1
  vapensmugglande_1_A = mkA "vapensmugglande" ; -- vapensmugglande..av.1
  vapenstillestånd_1_N = mkN "vapenstillestånd" neutrum  ; -- vapenstillestånd..nn.1
  vapenstilleståndsavtal_1_N = mkN "vapenstilleståndsavtal" neutrum  ; -- vapenstilleståndsavtal..nn.1
  vapensystem_1_N = mkN "vapensystem" neutrum  ; -- vapensystem..nn.1
  vapentillverkare_1_N = mkN "vapentillverkare" utrum  ; -- vapentillverkare..nn.1
  vapentillverkning_1_N = mkN "vapentillverkning" ; -- vapentillverkning..nn.1
  vapentjänst_1_N = mkN "vapentjänst" ; -- vapentjänst..nn.1
  vapenträning_1_N = mkN "vapenträning" ; -- vapenträning..nn.1
  vapentyp_1_N = mkN "vapentyp" "vapentyper" ; -- vapentyp..nn.1
  vapenunderhåll_1_N = mkN "vapenunderhåll" neutrum  ; -- vapenunderhåll..nn.1
  vapenvila_1_N = mkN "vapenvila" ; -- vapenvila..nn.1
  vapenvägra_1_V = mkV "vapenvägrar" ; -- vapenvägra..vb.1
  vapenvägrande_1_N = mkN "vapenvägrande" ; -- vapenvägrande..nn.1
  vapenvägrare_1_N = mkN "vapenvägrare" utrum  ; -- vapenvägrare..nn.1
  vapenvård_1_N = mkN "vapenvård" ; -- vapenvård..nn.1
  vapör_1_N = mkN "vapör" "vapörer" ; -- vapör..nn.1
  var_1_Adv = mkAdv "var" ; -- var..ab.1
  var_1_A = mkA "var" ; -- var..av.1
  var_1_N = mkN "var" neutrum  ; -- var..nn.1
  vara_1_N = mkN "vara" ; -- vara..nn.1
  vara_2_V = mkV "varar" ; -- vara..vb.2
  varaktig_1_A = mkA "varaktig" ; -- varaktig..av.1
  varaktighet_1_N = mkN "varaktighet" "varaktigheter" ; -- varaktighet..nn.1
  varan_1_N = mkN "varan" "varaner" ; -- varan..nn.1
  varande_1_N = mkN "varande" ; -- varande..nn.1
  varav_1_Adv = mkAdv "varav" ; -- varav..ab.1
  varbildning_1_N = mkN "varbildning" ; -- varbildning..nn.1
  varblåsa_1_N = mkN "varblåsa" ; -- varblåsa..nn.1
  varbygel_1_N = mkN "varbygel" ; -- varbygel..nn.1
  varböld_1_N = mkN "varböld" "varbölder" ; -- varböld..nn.1
  varda_1_V = mkV "varda" "varder" "varda" "varde" "vart" "vorden" ; -- varda..vb.1
  vardag_1_N = mkN "vardag" ; -- vardag..nn.1
  vardaglig_1_A = mkA "vardaglig" ; -- vardaglig..av.1
  vardaglighet_1_N = mkN "vardaglighet" "vardagligheter" ; -- vardaglighet..nn.1
  vardagsangelägenhet_1_N = mkN "vardagsangelägenhet" "vardagsangelägenheter" ; -- vardagsangelägenhet..nn.1
  vardagsbalans_1_N = mkN "vardagsbalans" ; -- vardagsbalans..nn.1
  vardagsbruk_1_N = mkN "vardagsbruk" neutrum  ; -- vardagsbruk..nn.1
  vardagsfest_1_N = mkN "vardagsfest" "vardagsfester" ; -- vardagsfest..nn.1
  vardagsfestutstyrsel_1_N = mkN "vardagsfestutstyrsel" ; -- vardagsfestutstyrsel..nn.1
  vardagsfras_1_N = mkN "vardagsfras" "vardagsfraser" ; -- vardagsfras..nn.1
  vardagsförståelse_1_N = mkN "vardagsförståelse" utrum  ; -- vardagsförståelse..nn.1
  vardagsklädd_1_A = mkA "vardagsklädd" ; -- vardagsklädd..av.1
  vardagskriminalitet_1_N = mkN "vardagskriminalitet" ; -- vardagskriminalitet..nn.1
  vardagsliv_1_N = mkN "vardagsliv" neutrum  ; -- vardagsliv..nn.1
  vardagslunk_1_N = mkN "vardagslunk" ; -- vardagslunk..nn.1
  vardagslyx_1_N = mkN "vardagslyx" ; -- vardagslyx..nn.1
  vardagsmat_1_N = mkN "vardagsmat" ; -- vardagsmat..nn.1
  vardagsmatiné_1_N = mkN "vardagsmatiné" "vardagsmatinéer" ; -- vardagsmatiné..nn.1
  vardagsmiddag_1_N = mkN "vardagsmiddag" ; -- vardagsmiddag..nn.1
  vardagsmänniska_1_N = mkN "vardagsmänniska" ; -- vardagsmänniska..nn.1
  vardagsmässig_1_A = mkA "vardagsmässig" ; -- vardagsmässig..av.1
  vardagsnära_1_Adv = mkAdv "vardagsnära" ; -- vardagsnära..ab.1
  vardagsprosa_1_N = mkN "vardagsprosa" ; -- vardagsprosa..nn.1
  vardagspussel_1_N = mkN "vardagspussel" neutrum  ; -- vardagspussel..nn.1
  vardagsrasism_1_N = mkN "vardagsrasism" ; -- vardagsrasism..nn.1
  vardagsrekvisita_1_N = mkN "vardagsrekvisita" ; -- vardagsrekvisita..nn.1
  vardagsritual_1_N = mkN "vardagsritual" neutrum  ; -- vardagsritual..nn.1
  vardagsrum_1_N = mkN "vardagsrum" "vardagsrummet" "vardagsrum" "vardagsrummen" ; -- vardagsrum..nn.1
  vardagsrumsmöbel_1_N = mkN "vardagsrumsmöbel" "vardagsrumsmöbeln" "vardagsrumsmöbler" "vardagsrumsmöblerna" ; -- vardagsrumsmöbel..nn.1
  vardagsrätt_1_N = mkN "vardagsrätt" "vardagsrätter" ; -- vardagsrätt..nn.1
  vardagsspråk_1_N = mkN "vardagsspråk" neutrum  ; -- vardagsspråk..nn.1
  vardagstrevlig_1_A = mkA "vardagstrevlig" ; -- vardagstrevlig..av.1
  vardagstänkande_1_N = mkN "vardagstänkande" ; -- vardagstänkande..nn.1
  vardagsupplevelse_1_N = mkN "vardagsupplevelse" "vardagsupplevelser" ; -- vardagsupplevelse..nn.1
  vardande_1_N = mkN "vardande" ; -- vardande..nn.1
  varde_1_N = mkN "varde" utrum  ; -- varde..nn.1
  varefter_1_Adv = mkAdv "varefter" ; -- varefter..ab.1
  varelse_1_N = mkN "varelse" "varelser" ; -- varelse..nn.1
  vareviga_1_A = mkA "vareviga" "varteviga" ; -- vareviga..av.1
  varevigaste_1_A = mkA "varevigaste" "vartevigaste" ; -- varevigaste..av.1
  varfågel_1_N = mkN "varfågel" ; -- varfågel..nn.1
  varför_1_Adv = mkAdv "varför" ; -- varför..ab.1
  varföre_1_Adv = mkAdv "varföre" ; -- varföre..ab.1
  varg_1_N = mkN "varg" ; -- varg..nn.1
  varga_1_V = mkV "vargar" ; -- varga..vb.1
  vargande_1_N = mkN "vargande" ; -- vargande..nn.1
  vargavinter_1_N = mkN "vargavinter" ; -- vargavinter..nn.1
  vargering_1_N = mkN "vargering" ; -- vargering..nn.1
  vargflock_1_N = mkN "vargflock" ; -- vargflock..nn.1
  vargflocksjakt_1_N = mkN "vargflocksjakt" ; -- vargflocksjakt..nn.1
  varggrop_1_N = mkN "varggrop" ; -- varggrop..nn.1
  varghagel_1_N = mkN "varghagel" neutrum  ; -- varghagel..nn.1
  varghatare_1_N = mkN "varghatare" utrum  ; -- varghatare..nn.1
  varghona_1_N = mkN "varghona" ; -- varghona..nn.1
  varginna_1_N = mkN "varginna" ; -- varginna..nn.1
  vargkramare_1_N = mkN "vargkramare" utrum  ; -- vargkramare..nn.1
  vargtimma_1_N = mkN "vargtimma" ; -- vargtimma..nn.1
  vargtimme_1_N = mkN "vargtimme" utrum  ; -- vargtimme..nn.1
  vargtät_1_A = mkA "vargtät" ; -- vargtät..av.1
  vargtäthet_1_N = mkN "vargtäthet" ; -- vargtäthet..nn.1
  vargunge_1_N = mkN "vargunge" utrum  ; -- vargunge..nn.1
  vargurin_1_N = mkN "vargurin" ; -- vargurin..nn.1
  varhärd_1_N = mkN "varhärd" ; -- varhärd..nn.1
  vari_1_Adv = mkAdv "vari" ; -- vari..ab.1
  varia_1_N = mkN "varia" "varian" "varia" "variana" ; -- varia..nn.1
  variabel_1_A = mkA "variabel" ; -- variabel..av.1
  variabel_1_N = mkN "variabel" "variabeln" "variabler" "variablerna" ; -- variabel..nn.1
  variabilitet_1_N = mkN "variabilitet" "variabiliteter" ; -- variabilitet..nn.1
  varians_1_N = mkN "varians" "varianser" ; -- varians..nn.1
  variansanalys_1_N = mkN "variansanalys" ; -- variansanalys..nn.1
  variant_1_N = mkN "variant" "varianter" ; -- variant..nn.1
  variation_1_N = mkN "variation" ; -- variation..nn.1
  variationsbredd_1_N = mkN "variationsbredd" "variationsbredder" ; -- variationsbredd..nn.1
  variationsinstrument_1_N = mkN "variationsinstrument" neutrum  ; -- variationsinstrument..nn.1
  variationskalkyl_1_N = mkN "variationskalkyl" ; -- variationskalkyl..nn.1
  variationskoefficient_1_N = mkN "variationskoefficient" "variationskoefficienter" ; -- variationskoefficient..nn.1
  variationsrik_1_A = mkA "variationsrik" ; -- variationsrik..av.1
  variationsvidd_1_N = mkN "variationsvidd" "variationsvidder" ; -- variationsvidd..nn.1
  variator_1_N = mkN "variator" "variatorer" ; -- variator..nn.1
  varibland_1_Adv = mkAdv "varibland" ; -- varibland..ab.1
  variera_1_V = mkV "varierar" ; -- variera..vb.1
  varierad_1_A = mkA "varierad" ; -- varierad..av.1
  varierande_1_N = mkN "varierande" ; -- varierande..nn.1
  varierbar_1_A = mkA "varierbar" ; -- varierbar..av.1
  varierbarhet_1_N = mkN "varierbarhet" ; -- varierbarhet..nn.1
  variering_1_N = mkN "variering" ; -- variering..nn.1
  varietet_1_N = mkN "varietet" "varieteter" ; -- varietet..nn.1
  varieté_1_N = mkN "varieté" "varietéer" ; -- varieté..nn.1
  varietéartist_1_N = mkN "varietéartist" "varietéartister" ; -- varietéartist..nn.1
  varietésångerska_1_N = mkN "varietésångerska" ; -- varietésångerska..nn.1
  varifrån_1_Adv = mkAdv "varifrån" ; -- varifrån..ab.1
  varig_1_A = mkA "varig" ; -- varig..av.1
  varigenom_1_Adv = mkAdv "varigenom" ; -- varigenom..ab.1
  variometer_1_N = mkN "variometer" ; -- variometer..nn.1
  varjag_1_N = mkN "varjag" "varjager" ; -- varjag..nn.1
  varjehanda_1_A = mkA "varjehanda" ; -- varjehanda..av.1
  varjämte_1_Adv = mkAdv "varjämte" ; -- varjämte..ab.1
  varken_1_Adv = mkAdv "varken" ; -- varken..ab.1
  varkunnsam_1_A = mkA "varkunnsam" "varkunnsamt" "varkunnsamma" "varkunnsamma" "varkunnsammare" "varkunnsammast" "varkunnsammaste" ; -- varkunnsam..av.1
  varkunnsamhet_1_N = mkN "varkunnsamhet" ; -- varkunnsamhet..nn.1
  varlig_1_A = mkA "varlig" ; -- varlig..av.1
  varliga_1_Adv = mkAdv "varliga" ; -- varliga..ab.1
  varligen_1_Adv = mkAdv "varligen" ; -- varligen..ab.1
  varlighet_1_N = mkN "varlighet" ; -- varlighet..nn.1
  varm_1_A = mkA "varm" ; -- varm..av.1
  varmbad_1_N = mkN "varmbad" neutrum  ; -- varmbad..nn.1
  varmblod_1_N = mkN "varmblod" neutrum  ; -- varmblod..nn.1
  varmblodig_1_A = mkA "varmblodig" ; -- varmblodig..av.1
  varmblodighet_1_N = mkN "varmblodighet" ; -- varmblodighet..nn.1
  varmbona_1_V = mkV "varmbonar" ; -- varmbona..vb.1
  varmbonande_1_N = mkN "varmbonande" ; -- varmbonande..nn.1
  varmbräckt_1_A = mkA "varmbräckt" "varmbräckt" ; -- varmbräckt..av.1
  varmfront_1_N = mkN "varmfront" "varmfronter" ; -- varmfront..nn.1
  varmförtennad_1_A = mkA "varmförtennad" ; -- varmförtennad..av.1
  varmgarage_1_N = mkN "varmgarage" "varmgaraget" "varmgarage" "varmgaragen" ; -- varmgarage..nn.1
  varmgång_1_N = mkN "varmgång" ; -- varmgång..nn.1
  varmhet_1_N = mkN "varmhet" ; -- varmhet..nn.1
  varmhjärtad_1_A = mkA "varmhjärtad" ; -- varmhjärtad..av.1
  varmhållning_1_N = mkN "varmhållning" ; -- varmhållning..nn.1
  varmköra_1_V = mkV "varmköra" "varmkörde" "varmkört" ; -- varmköra..vb.1
  varmkörande_1_N = mkN "varmkörande" ; -- varmkörande..nn.1
  varmluft_1_N = mkN "varmluft" ; -- varmluft..nn.1
  varmluftpistol_1_N = mkN "varmluftpistol" "varmluftpistoler" ; -- varmluftpistol..nn.1
  varmluftsfläkt_1_N = mkN "varmluftsfläkt" ; -- varmluftsfläkt..nn.1
  varmluftsridå_1_N = mkN "varmluftsridå" "varmluftsridåer" ; -- varmluftsridå..nn.1
  varmluftssystem_1_N = mkN "varmluftssystem" neutrum  ; -- varmluftssystem..nn.1
  varmrätt_1_N = mkN "varmrätt" "varmrätter" ; -- varmrätt..nn.1
  varmröka_1_V = mkV "varmröker" ; -- varmröka..vb.1
  varmvatten_1_N = mkN "varmvatten" "varmvattnet" "varmvatten" "varmvattnen" ; -- varmvatten..nn.1
  varmvattenberedare_1_N = mkN "varmvattenberedare" utrum  ; -- varmvattenberedare..nn.1
  varmvattensberedare_1_N = mkN "varmvattensberedare" utrum  ; -- varmvattensberedare..nn.1
  varmvattenssystem_1_N = mkN "varmvattenssystem" neutrum  ; -- varmvattenssystem..nn.1
  varmvattensystem_1_N = mkN "varmvattensystem" neutrum  ; -- varmvattensystem..nn.1
  varna_1_V = mkV "varnar" ; -- varna..vb.1
  varnagel_1_N = mkN "varnagel" ; -- varnagel..nn.1
  varnande_1_N = mkN "varnande" ; -- varnande..nn.1
  varning_1_N = mkN "varning" ; -- varning..nn.1
  varningsblinker_1_N = mkN "varningsblinker" ; -- varningsblinker..nn.1
  varningsflagga_1_N = mkN "varningsflagga" ; -- varningsflagga..nn.1
  varningsklocka_1_N = mkN "varningsklocka" ; -- varningsklocka..nn.1
  varningslampa_1_N = mkN "varningslampa" ; -- varningslampa..nn.1
  varningsljus_1_N = mkN "varningsljus" neutrum  ; -- varningsljus..nn.1
  varningsmärke_1_N = mkN "varningsmärke" ; -- varningsmärke..nn.1
  varningsrop_1_N = mkN "varningsrop" neutrum  ; -- varningsrop..nn.1
  varningssignal_1_N = mkN "varningssignal" "varningssignaler" ; -- varningssignal..nn.1
  varningsskott_1_N = mkN "varningsskott" neutrum  ; -- varningsskott..nn.1
  varningstecken_1_N = mkN "varningstecken" "varningstecknet" "varningstecken" "varningstecknen" ; -- varningstecken..nn.1
  varningstriangel_1_N = mkN "varningstriangel" ; -- varningstriangel..nn.1
  varp_1_N = mkN "varp" ; -- varp..nn.1
  varp_2_N = mkN "varp" neutrum  ; -- varp..nn.2
  varpa_1_N = mkN "varpa" ; -- varpa..nn.1
  varpa_2_N = mkN "varpa" ; -- varpa..nn.2
  varpa_1_V = mkV "varpar" ; -- varpa..vb.1
  varpande_1_N = mkN "varpande" ; -- varpande..nn.1
  varpbom_1_N = mkN "varpbom" "varpbommen" "varpbommar" "varpbommarna" ; -- varpbom..nn.1
  varpning_1_N = mkN "varpning" ; -- varpning..nn.1
  varpsticka_1_N = mkN "varpsticka" ; -- varpsticka..nn.1
  varptrikå_1_N = mkN "varptrikå" ; -- varptrikå..nn.1
  varptråd_1_N = mkN "varptråd" ; -- varptråd..nn.1
  varpå_1_Adv = mkAdv "varpå" ; -- varpå..ab.1
  varsam_1_A = mkA "varsam" "varsamt" "varsamma" "varsamma" "varsammare" "varsammast" "varsammaste" ; -- varsam..av.1
  varsamhet_1_N = mkN "varsamhet" ; -- varsamhet..nn.1
  varse_1_A = mkA "varse" ; -- varse..av.1
  varsebli_1_V = mkV "varsebliva" "varseblev" "varseblivit" ; -- varsebli..vb.1
  varseblivande_1_N = mkN "varseblivande" ; -- varseblivande..nn.1
  varseblivning_1_N = mkN "varseblivning" ; -- varseblivning..nn.1
  varseblivningsfenomen_1_N = mkN "varseblivningsfenomen" neutrum  ; -- varseblivningsfenomen..nn.1
  varsel_1_N = mkN "varsel" neutrum  ; -- varsel..nn.1
  varseloverall_1_N = mkN "varseloverall" "varseloveraller" ; -- varseloverall..nn.1
  varsko_1_V = mkV "varskor" ; -- varsko..vb.1
  varskoende_1_N = mkN "varskoende" ; -- varskoende..nn.1
  varsla_1_V = mkV "varslar" ; -- varsla..vb.1
  varslande_1_N = mkN "varslande" ; -- varslande..nn.1
  varsna_1_V = mkV "varsnar" ; -- varsna..vb.1
  varsnande_1_N = mkN "varsnande" ; -- varsnande..nn.1
  vart_1_Adv = mkAdv "vart" ; -- vart..ab.1
  vartefter_1_Adv = mkAdv "vartefter" ; -- vartefter..ab.1
  varthelst_1_Adv = mkAdv "varthelst" ; -- varthelst..ab.1
  varthän_1_Adv = mkAdv "varthän" ; -- varthän..ab.1
  vartill_1_Adv = mkAdv "vartill" ; -- vartill..ab.1
  vartsomhelst_1_Adv = mkAdv "vartsomhelst" ; -- vartsomhelst..ab.1
  vartåt_1_Adv = mkAdv "vartåt" ; -- vartåt..ab.1
  varubelåning_1_N = mkN "varubelåning" ; -- varubelåning..nn.1
  varubeteckning_1_N = mkN "varubeteckning" ; -- varubeteckning..nn.1
  varubil_1_N = mkN "varubil" ; -- varubil..nn.1
  varubud_1_N = mkN "varubud" neutrum  ; -- varubud..nn.1
  varubuss_1_N = mkN "varubuss" ; -- varubuss..nn.1
  varudeklaration_1_N = mkN "varudeklaration" ; -- varudeklaration..nn.1
  varudeklarationsnämnd_1_N = mkN "varudeklarationsnämnd" ; -- varudeklarationsnämnd..nn.1
  varudeklarera_1_V = mkV "varudeklarerar" ; -- varudeklarera..vb.1
  varudeklarerande_1_N = mkN "varudeklarerande" ; -- varudeklarerande..nn.1
  varudeklarerbar_1_A = mkA "varudeklarerbar" ; -- varudeklarerbar..av.1
  varudeklarerbarhet_1_N = mkN "varudeklarerbarhet" ; -- varudeklarerbarhet..nn.1
  varudeklarering_1_N = mkN "varudeklarering" ; -- varudeklarering..nn.1
  varufakta_1_N = mkN "varufakta" "varufaktat" "varufakta" "varufaktana" ; -- varufakta..nn.1
  varuhavare_1_N = mkN "varuhavare" utrum  ; -- varuhavare..nn.1
  varuhus_1_N = mkN "varuhus" neutrum  ; -- varuhus..nn.1
  varuhylla_1_N = mkN "varuhylla" ; -- varuhylla..nn.1
  varuintag_1_N = mkN "varuintag" neutrum  ; -- varuintag..nn.1
  varukasse_1_N = mkN "varukasse" utrum  ; -- varukasse..nn.1
  varukännedom_1_N = mkN "varukännedom" ; -- varukännedom..nn.1
  varulv_1_N = mkN "varulv" ; -- varulv..nn.1
  varulån_1_N = mkN "varulån" neutrum  ; -- varulån..nn.1
  varumängd_1_N = mkN "varumängd" "varumängder" ; -- varumängd..nn.1
  varumärke_1_N = mkN "varumärke" ; -- varumärke..nn.1
  varumärkeshaveri_1_N = mkN "varumärkeshaveri" "varumärkeshaveriet" "varumärkeshaverier" "varumärkeshaverierna" ; -- varumärkeshaveri..nn.1
  varumärkessamhälle_1_N = mkN "varumärkessamhälle" ; -- varumärkessamhälle..nn.1
  varunder_1_Adv = mkAdv "varunder" ; -- varunder..ab.1
  varuparti_1_N = mkN "varuparti" "varupartiet" "varupartier" "varupartierna" ; -- varuparti..nn.1
  varupris_1_N = mkN "varupris" neutrum  ; -- varupris..nn.1
  varuprov_1_N = mkN "varuprov" neutrum  ; -- varuprov..nn.1
  varuskatt_1_N = mkN "varuskatt" "varuskatter" ; -- varuskatt..nn.1
  varuti_1_Adv = mkAdv "varuti" ; -- varuti..ab.1
  varutinnan_1_Adv = mkAdv "varutinnan" ; -- varutinnan..ab.1
  varutransport_1_N = mkN "varutransport" "varutransporter" ; -- varutransport..nn.1
  varutransportbil_1_N = mkN "varutransportbil" ; -- varutransportbil..nn.1
  varuvagn_1_N = mkN "varuvagn" ; -- varuvagn..nn.1
  varuöverflöd_1_N = mkN "varuöverflöd" neutrum  ; -- varuöverflöd..nn.1
  varv_1_N = mkN "varv" neutrum  ; -- varv..nn.1
  varv_2_N = mkN "varv" neutrum  ; -- varv..nn.2
  varva_1_V = mkV "varvar" ; -- varva..vb.1
  varvande_1_N = mkN "varvande" ; -- varvande..nn.1
  varvid_1_Adv = mkAdv "varvid" ; -- varvid..ab.1
  varvidlag_1_Adv = mkAdv "varvidlag" ; -- varvidlag..ab.1
  varvig_1_A = mkA "varvig" ; -- varvig..av.1
  varvighet_1_N = mkN "varvighet" ; -- varvighet..nn.1
  varvmätare_1_N = mkN "varvmätare" utrum  ; -- varvmätare..nn.1
  varvräknare_1_N = mkN "varvräknare" utrum  ; -- varvräknare..nn.1
  varvsarbetare_1_N = mkN "varvsarbetare" utrum  ; -- varvsarbetare..nn.1
  varvsfluga_1_N = mkN "varvsfluga" ; -- varvsfluga..nn.1
  varvsindustri_1_N = mkN "varvsindustri" "varvsindustrier" ; -- varvsindustri..nn.1
  varvtal_1_N = mkN "varvtal" neutrum  ; -- varvtal..nn.1
  varöver_1_Adv = mkAdv "varöver" ; -- varöver..ab.1
  vas_1_N = mkN "vas" "vaser" ; -- vas..nn.1
  vasall_1_N = mkN "vasall" "vasaller" ; -- vasall..nn.1
  vasallstat_1_N = mkN "vasallstat" "vasallstater" ; -- vasallstat..nn.1
  vasaorden_1_N = mkN "vasaorden" ; -- vasaorden..nn.1
  vase_1_N = mkN "vase" utrum  ; -- vase..nn.1
  vasektomi_1_N = mkN "vasektomi" "vasektomier" ; -- vasektomi..nn.1
  vaselin_1_N = mkN "vaselin" ; -- vaselin..nn.1
  vask_1_N = mkN "vask" ; -- vask..nn.1
  vask_2_N = mkN "vask" neutrum  ; -- vask..nn.2
  vaska_1_V = mkV "vaskar" ; -- vaska..vb.1
  vaskande_1_N = mkN "vaskande" ; -- vaskande..nn.1
  vasker_1_N = mkN "vasker" ; -- vasker..nn.1
  vaskmalm_1_N = mkN "vaskmalm" ; -- vaskmalm..nn.1
  vaskning_1_N = mkN "vaskning" ; -- vaskning..nn.1
  vaskulär_1_A = mkA "vaskulär" ; -- vaskulär..av.1
  vasografi_1_N = mkN "vasografi" ; -- vasografi..nn.1
  vasomotorisk_1_A = mkA "vasomotorisk" ; -- vasomotorisk..av.1
  vass_1_A = mkA "vass" ; -- vass..av.1
  vass_1_N = mkN "vass" ; -- vass..nn.1
  vassbuk_1_N = mkN "vassbuk" ; -- vassbuk..nn.1
  vassgöra_1_V = mkV "vassgöra" "vassgjorde" "vassgjort" ; -- vassgöra..vb.1
  vassgörande_1_N = mkN "vassgörande" ; -- vassgörande..nn.1
  vasshet_1_N = mkN "vasshet" ; -- vasshet..nn.1
  vassla_1_N = mkN "vassla" ; -- vassla..nn.1
  vassle_1_N = mkN "vassle" utrum  ; -- vassle..nn.1
  vasslig_1_A = mkA "vasslig" ; -- vasslig..av.1
  vasslighet_1_N = mkN "vasslighet" ; -- vasslighet..nn.1
  vassnäst_1_A = mkA "vassnäst" "vassnäst" ; -- vassnäst..av.1
  vassrugge_1_N = mkN "vassrugge" utrum  ; -- vassrugge..nn.1
  vassrör_1_N = mkN "vassrör" neutrum  ; -- vassrör..nn.1
  vaterbom_1_N = mkN "vaterbom" "vaterbommen" "vaterbommar" "vaterbommarna" ; -- vaterbom..nn.1
  vaterbord_1_N = mkN "vaterbord" neutrum  ; -- vaterbord..nn.1
  vaterstag_1_N = mkN "vaterstag" neutrum  ; -- vaterstag..nn.1
  vatikansk_1_A = mkA "vatikansk" ; -- vatikansk..av.1
  vattblå_1_A = mkA "vattblå" "vattblått" ; -- vattblå..av.1
  vatten_1_N = mkN "vatten" "vattnet" "vatten" "vattnen" ; -- vatten..nn.1
  vattenaloe_1_N = mkN "vattenaloe" utrum  ; -- vattenaloe..nn.1
  vattenavläsning_1_N = mkN "vattenavläsning" ; -- vattenavläsning..nn.1
  vattenavrinning_1_N = mkN "vattenavrinning" ; -- vattenavrinning..nn.1
  vattenavstötande_1_A = mkA "vattenavstötande" ; -- vattenavstötande..av.1
  vattenavvisande_1_A = mkA "vattenavvisande" ; -- vattenavvisande..av.1
  vattenbad_1_N = mkN "vattenbad" neutrum  ; -- vattenbad..nn.1
  vattenbaserad_1_A = mkA "vattenbaserad" ; -- vattenbaserad..av.1
  vattenbehållare_1_N = mkN "vattenbehållare" utrum  ; -- vattenbehållare..nn.1
  vattenbi_1_N = mkN "vattenbi" "vattenbiet" "vattenbin" "vattenbina" ; -- vattenbi..nn.1
  vattenblask_1_N = mkN "vattenblask" neutrum  ; -- vattenblask..nn.1
  vattenblomning_1_N = mkN "vattenblomning" ; -- vattenblomning..nn.1
  vattenblå_1_A = mkA "vattenblå" "vattenblått" ; -- vattenblå..av.1
  vattenblåsa_1_N = mkN "vattenblåsa" ; -- vattenblåsa..nn.1
  vattenbomba_1_V = mkV "vattenbombar" ; -- vattenbomba..vb.1
  vattenbombande_1_N = mkN "vattenbombande" ; -- vattenbombande..nn.1
  vattenbombning_1_N = mkN "vattenbombning" ; -- vattenbombning..nn.1
  vattenbrist_1_N = mkN "vattenbrist" "vattenbrister" ; -- vattenbrist..nn.1
  vattenbruk_1_N = mkN "vattenbruk" neutrum  ; -- vattenbruk..nn.1
  vattenbryn_1_N = mkN "vattenbryn" neutrum  ; -- vattenbryn..nn.1
  vattenburen_1_A = mkA "vattenburen" ; -- vattenburen..av.1
  vattenbyggnad_1_N = mkN "vattenbyggnad" "vattenbyggnader" ; -- vattenbyggnad..nn.1
  vattenbyggnadskonst_1_N = mkN "vattenbyggnadskonst" ; -- vattenbyggnadskonst..nn.1
  vattencykel_1_N = mkN "vattencykel" ; -- vattencykel..nn.1
  vattendelare_1_N = mkN "vattendelare" utrum  ; -- vattendelare..nn.1
  vattendjup_1_N = mkN "vattendjup" neutrum  ; -- vattendjup..nn.1
  vattendjur_1_N = mkN "vattendjur" neutrum  ; -- vattendjur..nn.1
  vattendomstol_1_N = mkN "vattendomstol" ; -- vattendomstol..nn.1
  vattendrag_1_N = mkN "vattendrag" neutrum  ; -- vattendrag..nn.1
  vattendrivande_1_A = mkA "vattendrivande" ; -- vattendrivande..av.1
  vattendriven_1_A = mkA "vattendriven" ; -- vattendriven..av.1
  vattendroppe_1_N = mkN "vattendroppe" utrum  ; -- vattendroppe..nn.1
  vattendränka_1_V = mkV "vattendränker" ; -- vattendränka..vb.1
  vattendränkande_1_N = mkN "vattendränkande" ; -- vattendränkande..nn.1
  vattendränkning_1_N = mkN "vattendränkning" ; -- vattendränkning..nn.1
  vattenfall_1_N = mkN "vattenfall" neutrum  ; -- vattenfall..nn.1
  vattenfas_1_N = mkN "vattenfas" "vattenfaser" ; -- vattenfas..nn.1
  vattenfast_1_A = mkA "vattenfast" "vattenfast" ; -- vattenfast..av.1
  vattenfasthet_1_N = mkN "vattenfasthet" ; -- vattenfasthet..nn.1
  vattenflaska_1_N = mkN "vattenflaska" ; -- vattenflaska..nn.1
  vattenflöde_1_N = mkN "vattenflöde" ; -- vattenflöde..nn.1
  vattenfri_1_A = mkA "vattenfri" "vattenfritt" ; -- vattenfri..av.1
  vattenfylld_1_A = mkA "vattenfylld" "vattenfyllt" ; -- vattenfylld..av.1
  vattenfärg_1_N = mkN "vattenfärg" "vattenfärger" ; -- vattenfärg..nn.1
  vattenfågel_1_N = mkN "vattenfågel" ; -- vattenfågel..nn.1
  vattenförbrukning_1_N = mkN "vattenförbrukning" ; -- vattenförbrukning..nn.1
  vattenförorening_1_N = mkN "vattenförorening" ; -- vattenförorening..nn.1
  vattenförsörjning_1_N = mkN "vattenförsörjning" ; -- vattenförsörjning..nn.1
  vattengel_1_N = mkN "vattengel" "vattengelet" "vattengeler" "vattengelerna" ; -- vattengel..nn.1
  vattenglas_1_N = mkN "vattenglas" neutrum  ; -- vattenglas..nn.1
  vattenglas_2_N = mkN "vattenglas" neutrum  ; -- vattenglas..nn.2
  vattenhalt_1_N = mkN "vattenhalt" "vattenhalter" ; -- vattenhalt..nn.1
  vattenhjul_1_N = mkN "vattenhjul" neutrum  ; -- vattenhjul..nn.1
  vattenhyacint_1_N = mkN "vattenhyacint" "vattenhyacinter" ; -- vattenhyacint..nn.1
  vattenhål_1_N = mkN "vattenhål" neutrum  ; -- vattenhål..nn.1
  vattenhölje_1_N = mkN "vattenhölje" ; -- vattenhölje..nn.1
  vattenkamma_1_V = mkV "vattenkammar" ; -- vattenkamma..vb.1
  vattenkammande_1_N = mkN "vattenkammande" ; -- vattenkammande..nn.1
  vattenkanna_1_N = mkN "vattenkanna" ; -- vattenkanna..nn.1
  vattenkanon_1_N = mkN "vattenkanon" "vattenkanoner" ; -- vattenkanon..nn.1
  vattenkastare_1_N = mkN "vattenkastare" utrum  ; -- vattenkastare..nn.1
  vattenkastning_1_N = mkN "vattenkastning" ; -- vattenkastning..nn.1
  vattenklosett_1_N = mkN "vattenklosett" "vattenklosetter" ; -- vattenklosett..nn.1
  vattenklöver_1_N = mkN "vattenklöver" ; -- vattenklöver..nn.1
  vattenkokare_1_N = mkN "vattenkokare" utrum  ; -- vattenkokare..nn.1
  vattenkonst_1_N = mkN "vattenkonst" "vattenkonster" ; -- vattenkonst..nn.1
  vattenkoppling_1_N = mkN "vattenkoppling" ; -- vattenkoppling..nn.1
  vattenkraft_1_N = mkN "vattenkraft" ; -- vattenkraft..nn.1
  vattenkraftutbyggnad_1_N = mkN "vattenkraftutbyggnad" ; -- vattenkraftutbyggnad..nn.1
  vattenkraftverk_1_N = mkN "vattenkraftverk" neutrum  ; -- vattenkraftverk..nn.1
  vattenkran_1_N = mkN "vattenkran" ; -- vattenkran..nn.1
  vattenkrasse_1_N = mkN "vattenkrasse" utrum  ; -- vattenkrasse..nn.1
  vattenkrus_1_N = mkN "vattenkrus" neutrum  ; -- vattenkrus..nn.1
  vattenkultur_1_N = mkN "vattenkultur" "vattenkulturer" ; -- vattenkultur..nn.1
  vattenkvarn_1_N = mkN "vattenkvarn" ; -- vattenkvarn..nn.1
  vattenkyld_1_A = mkA "vattenkyld" "vattenkylt" ; -- vattenkyld..av.1
  vattenkälla_1_N = mkN "vattenkälla" ; -- vattenkälla..nn.1
  vattenkänslig_1_A = mkA "vattenkänslig" ; -- vattenkänslig..av.1
  vattenkänslighet_1_N = mkN "vattenkänslighet" ; -- vattenkänslighet..nn.1
  vattenled_1_N = mkN "vattenled" "vattenleder" ; -- vattenled..nn.1
  vattenledning_1_N = mkN "vattenledning" ; -- vattenledning..nn.1
  vattenledningsvatten_1_N = mkN "vattenledningsvatten" "vattenledningsvattnet" "vattenledningsvatten" "vattenledningsvattnen" ; -- vattenledningsvatten..nn.1
  vattenlevande_1_A = mkA "vattenlevande" ; -- vattenlevande..av.1
  vattenlinje_1_N = mkN "vattenlinje" "vattenlinjer" ; -- vattenlinje..nn.1
  vattenlist_1_N = mkN "vattenlist" "vattenlister" ; -- vattenlist..nn.1
  vattenliv_1_N = mkN "vattenliv" neutrum  ; -- vattenliv..nn.1
  vattenloppa_1_N = mkN "vattenloppa" ; -- vattenloppa..nn.1
  vattenläcka_1_N = mkN "vattenläcka" ; -- vattenläcka..nn.1
  vattenlås_1_N = mkN "vattenlås" neutrum  ; -- vattenlås..nn.1
  vattenlöpare_1_N = mkN "vattenlöpare" utrum  ; -- vattenlöpare..nn.1
  vattenlöslig_1_A = mkA "vattenlöslig" ; -- vattenlöslig..av.1
  vattenlöslighet_1_N = mkN "vattenlöslighet" "vattenlösligheter" ; -- vattenlöslighet..nn.1
  vattenlösning_1_N = mkN "vattenlösning" ; -- vattenlösning..nn.1
  vattenmagasin_1_N = mkN "vattenmagasin" neutrum  ; -- vattenmagasin..nn.1
  vattenmassa_1_N = mkN "vattenmassa" ; -- vattenmassa..nn.1
  vattenmelon_1_N = mkN "vattenmelon" "vattenmeloner" ; -- vattenmelon..nn.1
  vattenmotstånd_1_N = mkN "vattenmotstånd" neutrum  ; -- vattenmotstånd..nn.1
  vattenmärke_1_N = mkN "vattenmärke" ; -- vattenmärke..nn.1
  vattennivå_1_N = mkN "vattennivå" "vattennivåer" ; -- vattennivå..nn.1
  vattennymf_1_N = mkN "vattennymf" "vattennymfer" ; -- vattennymf..nn.1
  vattenomfluten_1_A = mkA "vattenomfluten" ; -- vattenomfluten..av.1
  vattenorganism_1_N = mkN "vattenorganism" "vattenorganismer" ; -- vattenorganism..nn.1
  vattenpass_1_N = mkN "vattenpass" neutrum  ; -- vattenpass..nn.1
  vattenpelare_1_N = mkN "vattenpelare" utrum  ; -- vattenpelare..nn.1
  vattenpest_1_N = mkN "vattenpest" ; -- vattenpest..nn.1
  vattenpipa_1_N = mkN "vattenpipa" ; -- vattenpipa..nn.1
  vattenpistol_1_N = mkN "vattenpistol" "vattenpistoler" ; -- vattenpistol..nn.1
  vattenplaning_1_N = mkN "vattenplaning" ; -- vattenplaning..nn.1
  vattenpolo_1_N = mkN "vattenpolo" ; -- vattenpolo..nn.1
  vattenpost_1_N = mkN "vattenpost" "vattenposter" ; -- vattenpost..nn.1
  vattenpostventil_1_N = mkN "vattenpostventil" "vattenpostventiler" ; -- vattenpostventil..nn.1
  vattenprov_1_N = mkN "vattenprov" neutrum  ; -- vattenprov..nn.1
  vattenpump_1_N = mkN "vattenpump" ; -- vattenpump..nn.1
  vattenpuss_1_N = mkN "vattenpuss" ; -- vattenpuss..nn.1
  vattenpöl_1_N = mkN "vattenpöl" ; -- vattenpöl..nn.1
  vattenrall_1_N = mkN "vattenrall" ; -- vattenrall..nn.1
  vattenrallare_1_N = mkN "vattenrallare" utrum  ; -- vattenrallare..nn.1
  vattenreglering_1_N = mkN "vattenreglering" ; -- vattenreglering..nn.1
  vattenrening_1_N = mkN "vattenrening" ; -- vattenrening..nn.1
  vattenreningsverk_1_N = mkN "vattenreningsverk" neutrum  ; -- vattenreningsverk..nn.1
  vattenreservoar_1_N = mkN "vattenreservoar" "vattenreservoarer" ; -- vattenreservoar..nn.1
  vattenring_1_N = mkN "vattenring" ; -- vattenring..nn.1
  vattenrutschbana_1_N = mkN "vattenrutschbana" ; -- vattenrutschbana..nn.1
  vattenränna_1_N = mkN "vattenränna" ; -- vattenränna..nn.1
  vattenrätt_1_N = mkN "vattenrätt" ; -- vattenrätt..nn.1
  vattensalamander_1_N = mkN "vattensalamander" ; -- vattensalamander..nn.1
  vattensamling_1_N = mkN "vattensamling" ; -- vattensamling..nn.1
  vattensjuk_1_A = mkA "vattensjuk" ; -- vattensjuk..av.1
  vattensjukhet_1_N = mkN "vattensjukhet" ; -- vattensjukhet..nn.1
  vattenskada_1_N = mkN "vattenskada" ; -- vattenskada..nn.1
  vattenskadad_1_A = mkA "vattenskadad" ; -- vattenskadad..av.1
  vattenskalle_1_N = mkN "vattenskalle" utrum  ; -- vattenskalle..nn.1
  vattenskida_1_N = mkN "vattenskida" ; -- vattenskida..nn.1
  vattenskinnbagge_1_N = mkN "vattenskinnbagge" utrum  ; -- vattenskinnbagge..nn.1
  vattenskott_1_N = mkN "vattenskott" neutrum  ; -- vattenskott..nn.1
  vattenslang_1_N = mkN "vattenslang" ; -- vattenslang..nn.1
  vattensork_1_N = mkN "vattensork" ; -- vattensork..nn.1
  vattenspegel_1_N = mkN "vattenspegel" ; -- vattenspegel..nn.1
  vattenspindel_1_N = mkN "vattenspindel" ; -- vattenspindel..nn.1
  vattenspridare_1_N = mkN "vattenspridare" utrum  ; -- vattenspridare..nn.1
  vattenspruta_1_N = mkN "vattenspruta" ; -- vattenspruta..nn.1
  vattenstråle_1_N = mkN "vattenstråle" utrum  ; -- vattenstråle..nn.1
  vattenström_1_N = mkN "vattenström" "vattenströmmen" "vattenströmmar" "vattenströmmarna" ; -- vattenström..nn.1
  vattenstämpel_1_N = mkN "vattenstämpel" ; -- vattenstämpel..nn.1
  vattenstänk_1_N = mkN "vattenstänk" neutrum  ; -- vattenstänk..nn.1
  vattenstånd_1_N = mkN "vattenstånd" neutrum  ; -- vattenstånd..nn.1
  vattenståndsrör_1_N = mkN "vattenståndsrör" neutrum  ; -- vattenståndsrör..nn.1
  vattenståndsvisare_1_N = mkN "vattenståndsvisare" utrum  ; -- vattenståndsvisare..nn.1
  vattensvin_1_N = mkN "vattensvin" neutrum  ; -- vattensvin..nn.1
  vattensäck_1_N = mkN "vattensäck" ; -- vattensäck..nn.1
  vattensäng_1_N = mkN "vattensäng" ; -- vattensäng..nn.1
  vattentemperatur_1_N = mkN "vattentemperatur" "vattentemperaturer" ; -- vattentemperatur..nn.1
  vattentorn_1_N = mkN "vattentorn" neutrum  ; -- vattentorn..nn.1
  vattentortyr_1_N = mkN "vattentortyr" "vattentortyrer" ; -- vattentortyr..nn.1
  vattentrampning_1_N = mkN "vattentrampning" ; -- vattentrampning..nn.1
  vattentransport_1_N = mkN "vattentransport" "vattentransporter" ; -- vattentransport..nn.1
  vattentröskel_1_N = mkN "vattentröskel" ; -- vattentröskel..nn.1
  vattentunna_1_N = mkN "vattentunna" ; -- vattentunna..nn.1
  vattenturbin_1_N = mkN "vattenturbin" "vattenturbiner" ; -- vattenturbin..nn.1
  vattentäkt_1_N = mkN "vattentäkt" "vattentäkter" ; -- vattentäkt..nn.1
  vattentät_1_A = mkA "vattentät" ; -- vattentät..av.1
  vattentäthet_1_N = mkN "vattentäthet" ; -- vattentäthet..nn.1
  vattentålig_1_A = mkA "vattentålig" ; -- vattentålig..av.1
  vattentålighet_1_N = mkN "vattentålighet" ; -- vattentålighet..nn.1
  vattenur_1_N = mkN "vattenur" neutrum  ; -- vattenur..nn.1
  vattenverk_1_N = mkN "vattenverk" neutrum  ; -- vattenverk..nn.1
  vattenvirvel_1_N = mkN "vattenvirvel" ; -- vattenvirvel..nn.1
  vattenväg_1_N = mkN "vattenväg" ; -- vattenväg..nn.1
  vattenvärde_1_N = mkN "vattenvärde" ; -- vattenvärde..nn.1
  vattenvärmare_1_N = mkN "vattenvärmare" utrum  ; -- vattenvärmare..nn.1
  vattenvärmesystem_1_N = mkN "vattenvärmesystem" neutrum  ; -- vattenvärmesystem..nn.1
  vattenväsen_1_N = mkN "vattenväsen" neutrum  ; -- vattenväsen..nn.1
  vattenväxt_1_N = mkN "vattenväxt" "vattenväxter" ; -- vattenväxt..nn.1
  vattenvård_1_N = mkN "vattenvård" ; -- vattenvård..nn.1
  vattenyta_1_N = mkN "vattenyta" ; -- vattenyta..nn.1
  vattenånga_1_N = mkN "vattenånga" ; -- vattenånga..nn.1
  vattenödla_1_N = mkN "vattenödla" ; -- vattenödla..nn.1
  vattenösning_1_N = mkN "vattenösning" ; -- vattenösning..nn.1
  vattgröt_1_N = mkN "vattgröt" ; -- vattgröt..nn.1
  vattna_1_V = mkV "vattnar" ; -- vattna..vb.1
  vattnande_1_N = mkN "vattnande" ; -- vattnande..nn.1
  vattnare_1_N = mkN "vattnare" utrum  ; -- vattnare..nn.1
  vattnig_1_A = mkA "vattnig" ; -- vattnig..av.1
  vattnighet_1_N = mkN "vattnighet" ; -- vattnighet..nn.1
  vattning_1_N = mkN "vattning" ; -- vattning..nn.1
  vattningsförbud_1_N = mkN "vattningsförbud" neutrum  ; -- vattningsförbud..nn.1
  vattra_1_V = mkV "vattrar" ; -- vattra..vb.1
  vattrad_1_A = mkA "vattrad" ; -- vattrad..av.1
  vattrande_1_N = mkN "vattrande" ; -- vattrande..nn.1
  vattrig_1_A = mkA "vattrig" ; -- vattrig..av.1
  vattrighet_1_N = mkN "vattrighet" ; -- vattrighet..nn.1
  vattring_1_N = mkN "vattring" ; -- vattring..nn.1
  vattsot_1_N = mkN "vattsot" ; -- vattsot..nn.1
  vattuman_1_N = mkN "vattuman" "vattumannen" "vattumän" "vattumännen" ; -- vattuman..nn.1
  vattupass_1_N = mkN "vattupass" neutrum  ; -- vattupass..nn.1
  vattuskräck_1_N = mkN "vattuskräck" ; -- vattuskräck..nn.1
  vattusot_1_N = mkN "vattusot" ; -- vattusot..nn.1
  vattvälling_1_N = mkN "vattvälling" ; -- vattvälling..nn.1
  vaudeville_1_N = mkN "vaudeville" "vaudeviller" ; -- vaudeville..nn.1
  vax_1_N = mkN "vax" "vaxet" "vaxer" "vaxerna" ; -- vax..nn.1
  vaxa_1_V = mkV "vaxar" ; -- vaxa..vb.1
  vaxande_1_N = mkN "vaxande" ; -- vaxande..nn.1
  vaxapplikator_1_N = mkN "vaxapplikator" "vaxapplikatorer" ; -- vaxapplikator..nn.1
  vaxartad_1_A = mkA "vaxartad" ; -- vaxartad..av.1
  vaxavtryck_1_N = mkN "vaxavtryck" neutrum  ; -- vaxavtryck..nn.1
  vaxblek_1_A = mkA "vaxblek" ; -- vaxblek..av.1
  vaxblekhet_1_N = mkN "vaxblekhet" ; -- vaxblekhet..nn.1
  vaxblomma_1_N = mkN "vaxblomma" ; -- vaxblomma..nn.1
  vaxböna_1_N = mkN "vaxböna" ; -- vaxböna..nn.1
  vaxdocka_1_N = mkN "vaxdocka" ; -- vaxdocka..nn.1
  vaxduk_1_N = mkN "vaxduk" ; -- vaxduk..nn.1
  vaxfigur_1_N = mkN "vaxfigur" "vaxfigurer" ; -- vaxfigur..nn.1
  vaxgul_1_A = mkA "vaxgul" ; -- vaxgul..av.1
  vaxkabinett_1_N = mkN "vaxkabinett" neutrum  ; -- vaxkabinett..nn.1
  vaxkaka_1_N = mkN "vaxkaka" ; -- vaxkaka..nn.1
  vaxliknande_1_A = mkA "vaxliknande" ; -- vaxliknande..av.1
  vaxljus_1_N = mkN "vaxljus" neutrum  ; -- vaxljus..nn.1
  vaxmodell_1_N = mkN "vaxmodell" "vaxmodeller" ; -- vaxmodell..nn.1
  vaxning_1_N = mkN "vaxning" ; -- vaxning..nn.1
  vaxpapper_1_N = mkN "vaxpapper" neutrum  ; -- vaxpapper..nn.1
  vaxpropp_1_N = mkN "vaxpropp" ; -- vaxpropp..nn.1
  vaxschampo_1_N = mkN "vaxschampo" "vaxschampot" "vaxschampon" "vaxschampona" ; -- vaxschampo..nn.1
  vaxsigill_1_N = mkN "vaxsigill" neutrum  ; -- vaxsigill..nn.1
  vaxskivling_1_N = mkN "vaxskivling" ; -- vaxskivling..nn.1
  vaxstapel_1_N = mkN "vaxstapel" ; -- vaxstapel..nn.1
  vaxtavla_1_N = mkN "vaxtavla" ; -- vaxtavla..nn.1
  ve_1_N = mkN "ve" ; -- ve..nn.1
  veck_1_N = mkN "veck" neutrum  ; -- veck..nn.1
  vecka_1_N = mkN "vecka" ; -- vecka..nn.1
  vecka_1_V = mkV "veckar" ; -- vecka..vb.1
  veckande_1_N = mkN "veckande" ; -- veckande..nn.1
  veckberg_1_N = mkN "veckberg" neutrum  ; -- veckberg..nn.1
  veckig_1_A = mkA "veckig" ; -- veckig..av.1
  veckighet_1_N = mkN "veckighet" ; -- veckighet..nn.1
  veckla_1_V = mkV "vecklar" ; -- veckla..vb.1
  vecklande_1_N = mkN "vecklande" ; -- vecklande..nn.1
  vecklare_1_N = mkN "vecklare" utrum  ; -- vecklare..nn.1
  veckning_1_N = mkN "veckning" ; -- veckning..nn.1
  veckoavdelning_1_N = mkN "veckoavdelning" ; -- veckoavdelning..nn.1
  veckobilaga_1_N = mkN "veckobilaga" ; -- veckobilaga..nn.1
  veckobiljett_1_N = mkN "veckobiljett" "veckobiljetter" ; -- veckobiljett..nn.1
  veckodag_1_N = mkN "veckodag" ; -- veckodag..nn.1
  veckohandla_1_V = mkV "veckohandlar" ; -- veckohandla..vb.1
  veckohandlande_1_N = mkN "veckohandlande" ; -- veckohandlande..nn.1
  veckohandling_1_N = mkN "veckohandling" ; -- veckohandling..nn.1
  veckohelg_1_N = mkN "veckohelg" "veckohelger" ; -- veckohelg..nn.1
  veckolång_1_A = mkA "veckolång" ; -- veckolång..av.1
  veckomagasin_1_N = mkN "veckomagasin" neutrum  ; -- veckomagasin..nn.1
  veckony_1_A = mkA "veckony" "veckonytt" ; -- veckony..av.1
  veckopendla_1_V = mkV "veckopendlar" ; -- veckopendla..vb.1
  veckopendlande_1_N = mkN "veckopendlande" ; -- veckopendlande..nn.1
  veckopendling_1_N = mkN "veckopendling" ; -- veckopendling..nn.1
  veckopeng_1_N = mkN "veckopeng" ; -- veckopeng..nn.1
  veckopress_1_N = mkN "veckopress" ; -- veckopress..nn.1
  veckoslut_1_N = mkN "veckoslut" neutrum  ; -- veckoslut..nn.1
  veckoslutstrafik_1_N = mkN "veckoslutstrafik" ; -- veckoslutstrafik..nn.1
  veckotablett_1_N = mkN "veckotablett" "veckotabletter" ; -- veckotablett..nn.1
  veckotidning_1_N = mkN "veckotidning" ; -- veckotidning..nn.1
  veckotidningsnovell_1_N = mkN "veckotidningsnovell" "veckotidningsnoveller" ; -- veckotidningsnovell..nn.1
  veckotimma_1_N = mkN "veckotimma" ; -- veckotimma..nn.1
  veckotimme_1_N = mkN "veckotimme" utrum  ; -- veckotimme..nn.1
  veckovill_1_A = mkA "veckovill" ; -- veckovill..av.1
  veckovillhet_1_N = mkN "veckovillhet" ; -- veckovillhet..nn.1
  veckovis_1_Adv = mkAdv "veckovis" ; -- veckovis..ab.1
  veckovis_1_A = mkA "veckovis" ; -- veckovis..av.1
  veckoända_1_N = mkN "veckoända" ; -- veckoända..nn.1
  veckoände_1_N = mkN "veckoände" utrum  ; -- veckoände..nn.1
  veckända_1_N = mkN "veckända" ; -- veckända..nn.1
  veckände_1_N = mkN "veckände" utrum  ; -- veckände..nn.1
  ved_1_N = mkN "ved" ; -- ved..nn.1
  vedartad_1_A = mkA "vedartad" ; -- vedartad..av.1
  vedbacke_1_N = mkN "vedbacke" utrum  ; -- vedbacke..nn.1
  vedbod_1_N = mkN "vedbod" ; -- vedbod..nn.1
  vedborre_1_N = mkN "vedborre" utrum  ; -- vedborre..nn.1
  vedbrand_1_N = mkN "vedbrand" "vedbränder" ; -- vedbrand..nn.1
  vedbärare_1_N = mkN "vedbärare" utrum  ; -- vedbärare..nn.1
  vedeldad_1_A = mkA "vedeldad" ; -- vedeldad..av.1
  vederbörande_1_A = mkA "vederbörande" ; -- vederbörande..av.1
  vederbörande_1_N = mkN "vederbörande" ; -- vederbörande..nn.1
  vederbörlig_1_A = mkA "vederbörlig" ; -- vederbörlig..av.1
  vederbörligen_1_Adv = mkAdv "vederbörligen" ; -- vederbörligen..ab.1
  vederdeloman_1_N = mkN "vederdeloman" "vederdelomannen" "vederdelomän" "vederdelomännen" ; -- vederdeloman..nn.1
  vederdöpare_1_N = mkN "vederdöpare" utrum  ; -- vederdöpare..nn.1
  vederfående_1_N = mkN "vederfående" ; -- vederfående..nn.1
  vedergälla_1_V = mkV "vedergäller" ; -- vedergälla..vb.1
  vedergällande_1_N = mkN "vedergällande" ; -- vedergällande..nn.1
  vedergällning_1_N = mkN "vedergällning" ; -- vedergällning..nn.1
  vedergällningsförmåga_1_N = mkN "vedergällningsförmåga" ; -- vedergällningsförmåga..nn.1
  vedergällningslära_1_N = mkN "vedergällningslära" ; -- vedergällningslära..nn.1
  vederhäftig_1_A = mkA "vederhäftig" ; -- vederhäftig..av.1
  vederhäftighet_1_N = mkN "vederhäftighet" ; -- vederhäftighet..nn.1
  vederkvicka_1_V = mkV "vederkvicker" ; -- vederkvicka..vb.1
  vederkvickande_1_N = mkN "vederkvickande" ; -- vederkvickande..nn.1
  vederkvickelse_1_N = mkN "vederkvickelse" "vederkvickelser" ; -- vederkvickelse..nn.1
  vederlag_1_N = mkN "vederlag" neutrum  ; -- vederlag..nn.1
  vederlagsgods_1_N = mkN "vederlagsgods" neutrum  ; -- vederlagsgods..nn.1
  vederlike_1_N = mkN "vederlike" utrum  ; -- vederlike..nn.1
  vederlägga_1_V = mkV "vederlägga" "vederla" "vederlagt" ; -- vederlägga..vb.1
  vederläggande_1_N = mkN "vederläggande" ; -- vederläggande..nn.1
  vederläggning_1_N = mkN "vederläggning" ; -- vederläggning..nn.1
  vedermäle_1_N = mkN "vedermäle" ; -- vedermäle..nn.1
  vedermöda_1_N = mkN "vedermöda" ; -- vedermöda..nn.1
  vedernamn_1_N = mkN "vedernamn" neutrum  ; -- vedernamn..nn.1
  vederpart_1_N = mkN "vederpart" "vederparter" ; -- vederpart..nn.1
  vedersakare_1_N = mkN "vedersakare" utrum  ; -- vedersakare..nn.1
  vederstygglig_1_A = mkA "vederstygglig" ; -- vederstygglig..av.1
  vederstygglighet_1_N = mkN "vederstygglighet" "vederstyggligheter" ; -- vederstygglighet..nn.1
  vedertagen_1_A = mkA "vedertagen" ; -- vedertagen..av.1
  vedervilja_1_N = mkN "vedervilja" ; -- vedervilja..nn.1
  vedervärdig_1_A = mkA "vedervärdig" ; -- vedervärdig..av.1
  vedervärdighet_1_N = mkN "vedervärdighet" "vedervärdigheter" ; -- vedervärdighet..nn.1
  vedervåga_1_V = mkV "vedervågar" ; -- vedervåga..vb.1
  vedervågande_1_N = mkN "vedervågande" ; -- vedervågande..nn.1
  vedettbåt_1_N = mkN "vedettbåt" ; -- vedettbåt..nn.1
  vedfång_1_N = mkN "vedfång" neutrum  ; -- vedfång..nn.1
  vedhuggare_1_N = mkN "vedhuggare" utrum  ; -- vedhuggare..nn.1
  vedhuggning_1_N = mkN "vedhuggning" ; -- vedhuggning..nn.1
  vedhög_1_N = mkN "vedhög" ; -- vedhög..nn.1
  vedisk_1_A = mkA "vedisk" ; -- vedisk..av.1
  vedkap_1_N = mkN "vedkap" ; -- vedkap..nn.1
  vedkapning_1_N = mkN "vedkapning" ; -- vedkapning..nn.1
  vedkapsåg_1_N = mkN "vedkapsåg" ; -- vedkapsåg..nn.1
  vedkast_1_N = mkN "vedkast" "vedkaster" ; -- vedkast..nn.1
  vedklyv_1_N = mkN "vedklyv" ; -- vedklyv..nn.1
  vedlår_1_N = mkN "vedlår" ; -- vedlår..nn.1
  vedmått_1_N = mkN "vedmått" neutrum  ; -- vedmått..nn.1
  vedpinne_1_N = mkN "vedpinne" utrum  ; -- vedpinne..nn.1
  vedspis_1_N = mkN "vedspis" ; -- vedspis..nn.1
  vedstam_1_N = mkN "vedstam" "vedstammen" "vedstammar" "vedstammarna" ; -- vedstam..nn.1
  vedsåg_1_N = mkN "vedsåg" ; -- vedsåg..nn.1
  vedtrave_1_N = mkN "vedtrave" utrum  ; -- vedtrave..nn.1
  vedträ_1_N = mkN "vedträ" "vedträt" "vedträn" "vedträna" ; -- vedträ..nn.1
  vedämne_1_N = mkN "vedämne" ; -- vedämne..nn.1
  vegamössa_1_N = mkN "vegamössa" ; -- vegamössa..nn.1
  vegan_1_A = mkA "vegan" ; -- vegan..av.1
  vegan_1_N = mkN "vegan" "veganer" ; -- vegan..nn.1
  veganism_1_N = mkN "veganism" "veganismer" ; -- veganism..nn.1
  vegetabilisk_1_A = mkA "vegetabilisk" ; -- vegetabilisk..av.1
  vegetarian_1_N = mkN "vegetarian" "vegetarianer" ; -- vegetarian..nn.1
  vegetarianism_1_N = mkN "vegetarianism" "vegetarianismer" ; -- vegetarianism..nn.1
  vegetariansk_1_A = mkA "vegetariansk" ; -- vegetariansk..av.1
  vegetarisk_1_A = mkA "vegetarisk" ; -- vegetarisk..av.1
  vegetarism_1_N = mkN "vegetarism" "vegetarismer" ; -- vegetarism..nn.1
  vegetation_1_N = mkN "vegetation" ; -- vegetation..nn.1
  vegetationsbälte_1_N = mkN "vegetationsbälte" ; -- vegetationsbälte..nn.1
  vegetationsknopp_1_N = mkN "vegetationsknopp" ; -- vegetationsknopp..nn.1
  vegetationslös_1_A = mkA "vegetationslös" ; -- vegetationslös..av.1
  vegetationsperiod_1_N = mkN "vegetationsperiod" "vegetationsperioder" ; -- vegetationsperiod..nn.1
  vegetationszon_1_N = mkN "vegetationszon" "vegetationszoner" ; -- vegetationszon..nn.1
  vegetativ_1_A = mkA "vegetativ" ; -- vegetativ..av.1
  vegetera_1_V = mkV "vegeterar" ; -- vegetera..vb.1
  vegeterande_1_N = mkN "vegeterande" ; -- vegeterande..nn.1
  vegetering_1_N = mkN "vegetering" ; -- vegetering..nn.1
  vehikel_1_N = mkN "vehikel" ; -- vehikel..nn.1
  vejde_1_N = mkN "vejde" utrum  ; -- vejde..nn.1
  vek_1_A = mkA "vek" ; -- vek..av.1
  veke_1_N = mkN "veke" utrum  ; -- veke..nn.1
  vekhet_1_N = mkN "vekhet" ; -- vekhet..nn.1
  vekhjärtad_1_A = mkA "vekhjärtad" ; -- vekhjärtad..av.1
  veklaga_1_V = mkV "veklagar" ; -- veklaga..vb.1
  veklagande_1_N = mkN "veklagande" ; -- veklagande..nn.1
  veklig_1_A = mkA "veklig" ; -- veklig..av.1
  veklighet_1_N = mkN "veklighet" "vekligheter" ; -- veklighet..nn.1
  vekling_1_N = mkN "vekling" ; -- vekling..nn.1
  vekna_1_V = mkV "veknar" ; -- vekna..vb.1
  veknande_1_N = mkN "veknande" ; -- veknande..nn.1
  vektor_1_N = mkN "vektor" "vektorer" ; -- vektor..nn.1
  vela_1_N = mkN "vela" ; -- vela..nn.1
  vela_1_V = mkV "velar" ; -- vela..vb.1
  velande_1_N = mkN "velande" ; -- velande..nn.1
  velar_1_A = mkA "velar" ; -- velar..av.1
  velar_1_N = mkN "velar" "velarer" ; -- velar..nn.1
  vele_1_N = mkN "vele" utrum  ; -- vele..nn.1
  velig_1_A = mkA "velig" ; -- velig..av.1
  velighet_1_N = mkN "velighet" "veligheter" ; -- velighet..nn.1
  veling_1_N = mkN "veling" ; -- veling..nn.1
  velociped_1_N = mkN "velociped" "velocipeder" ; -- velociped..nn.1
  velodrom_1_N = mkN "velodrom" "velodromer" ; -- velodrom..nn.1
  velour_1_N = mkN "velour" ; -- velour..nn.1
  velourbyxa_1_N = mkN "velourbyxa" ; -- velourbyxa..nn.1
  velourisera_1_V = mkV "velouriserar" ; -- velourisera..vb.1
  velouriserande_1_N = mkN "velouriserande" ; -- velouriserande..nn.1
  velouriserbar_1_A = mkA "velouriserbar" ; -- velouriserbar..av.1
  velouriserbarhet_1_N = mkN "velouriserbarhet" ; -- velouriserbarhet..nn.1
  velourisering_1_N = mkN "velourisering" ; -- velourisering..nn.1
  velourpappa_1_N = mkN "velourpappa" ; -- velourpappa..nn.1
  velum_1_N = mkN "velum" neutrum  ; -- velum..nn.1
  velvetin_1_N = mkN "velvetin" ; -- velvetin..nn.1
  veläng_1_N = mkN "veläng" ; -- veläng..nn.1
  vemod_1_N = mkN "vemod" neutrum  ; -- vemod..nn.1
  vemodig_1_A = mkA "vemodig" ; -- vemodig..av.1
  vemodighet_1_N = mkN "vemodighet" ; -- vemodighet..nn.1
  vemodsfull_1_A = mkA "vemodsfull" ; -- vemodsfull..av.1
  ven_1_N = mkN "ven" "vener" ; -- ven..nn.1
  vend_1_N = mkN "vend" "vender" ; -- vend..nn.1
  vender_1_N = mkN "vender" "vendern" "vender" "venderna" ; -- vender..nn.1
  vendetta_1_N = mkN "vendetta" ; -- vendetta..nn.1
  vendisk_1_A = mkA "vendisk" ; -- vendisk..av.1
  venerabel_1_A = mkA "venerabel" ; -- venerabel..av.1
  veneration_1_N = mkN "veneration" ; -- veneration..nn.1
  venereolog_1_N = mkN "venereolog" "venereologer" ; -- venereolog..nn.1
  venereologi_1_N = mkN "venereologi" ; -- venereologi..nn.1
  venereologisk_1_A = mkA "venereologisk" ; -- venereologisk..av.1
  venerisk_1_A = mkA "venerisk" ; -- venerisk..av.1
  venetian_1_N = mkN "venetian" "venetianer" ; -- venetian..nn.1
  venetianare_1_N = mkN "venetianare" utrum  ; -- venetianare..nn.1
  venetiansk_1_A = mkA "venetiansk" ; -- venetiansk..av.1
  venezolan_1_N = mkN "venezolan" "venezolaner" ; -- venezolan..nn.1
  venezolansk_1_A = mkA "venezolansk" ; -- venezolansk..av.1
  venezuelan_1_N = mkN "venezuelan" "venezuelaner" ; -- venezuelan..nn.1
  venezuelansk_1_A = mkA "venezuelansk" ; -- venezuelansk..av.1
  venia_1_N = mkN "venia" ; -- venia..nn.1
  ventil_1_N = mkN "ventil" "ventiler" ; -- ventil..nn.1
  ventilation_1_N = mkN "ventilation" ; -- ventilation..nn.1
  ventilationsfläkt_1_N = mkN "ventilationsfläkt" ; -- ventilationsfläkt..nn.1
  ventilationssystem_1_N = mkN "ventilationssystem" neutrum  ; -- ventilationssystem..nn.1
  ventilator_1_N = mkN "ventilator" "ventilatorer" ; -- ventilator..nn.1
  ventilbasun_1_N = mkN "ventilbasun" "ventilbasuner" ; -- ventilbasun..nn.1
  ventilera_1_V = mkV "ventilerar" ; -- ventilera..vb.1
  ventilerande_1_N = mkN "ventilerande" ; -- ventilerande..nn.1
  ventilerbar_1_A = mkA "ventilerbar" ; -- ventilerbar..av.1
  ventilerbarhet_1_N = mkN "ventilerbarhet" ; -- ventilerbarhet..nn.1
  ventilering_1_N = mkN "ventilering" ; -- ventilering..nn.1
  ventileringshål_1_N = mkN "ventileringshål" neutrum  ; -- ventileringshål..nn.1
  ventilfjäder_1_N = mkN "ventilfjäder" ; -- ventilfjäder..nn.1
  ventilgummi_1_N = mkN "ventilgummi" "ventilgummit" "ventilgummin" "ventilgummina" ; -- ventilgummi..nn.1
  ventilhatt_1_N = mkN "ventilhatt" ; -- ventilhatt..nn.1
  ventilhus_1_N = mkN "ventilhus" neutrum  ; -- ventilhus..nn.1
  ventilruta_1_N = mkN "ventilruta" ; -- ventilruta..nn.1
  ventilsnöre_1_N = mkN "ventilsnöre" ; -- ventilsnöre..nn.1
  ventrikel_1_N = mkN "ventrikel" ; -- ventrikel..nn.1
  venusberg_1_N = mkN "venusberg" neutrum  ; -- venusberg..nn.1
  venushår_1_N = mkN "venushår" neutrum  ; -- venushår..nn.1
  venös_1_A = mkA "venös" ; -- venös..av.1
  vepa_1_N = mkN "vepa" ; -- vepa..nn.1
  veranda_1_N = mkN "veranda" ; -- veranda..nn.1
  verandadörr_1_N = mkN "verandadörr" ; -- verandadörr..nn.1
  verandaräcke_1_N = mkN "verandaräcke" ; -- verandaräcke..nn.1
  verandatrappa_1_N = mkN "verandatrappa" ; -- verandatrappa..nn.1
  verb_1_N = mkN "verb" neutrum  ; -- verb..nn.1
  verbal_1_A = mkA "verbal" ; -- verbal..av.1
  verbalabstrakt_1_N = mkN "verbalabstrakt" neutrum  ; -- verbalabstrakt..nn.1
  verbalfaktor_1_N = mkN "verbalfaktor" "verbalfaktorer" ; -- verbalfaktor..nn.1
  verbalinspiration_1_N = mkN "verbalinspiration" ; -- verbalinspiration..nn.1
  verbalisera_1_V = mkV "verbaliserar" ; -- verbalisera..vb.1
  verbaliserande_1_N = mkN "verbaliserande" ; -- verbaliserande..nn.1
  verbaliserbar_1_A = mkA "verbaliserbar" ; -- verbaliserbar..av.1
  verbaliserbarhet_1_N = mkN "verbaliserbarhet" ; -- verbaliserbarhet..nn.1
  verbalisering_1_N = mkN "verbalisering" ; -- verbalisering..nn.1
  verbalism_1_N = mkN "verbalism" "verbalismer" ; -- verbalism..nn.1
  verbalitet_1_N = mkN "verbalitet" "verbaliteter" ; -- verbalitet..nn.1
  verbalnot_1_N = mkN "verbalnot" "verbalnoter" ; -- verbalnot..nn.1
  verbalstam_1_N = mkN "verbalstam" "verbalstammen" "verbalstammar" "verbalstammarna" ; -- verbalstam..nn.1
  verbalsubstantiv_1_N = mkN "verbalsubstantiv" neutrum  ; -- verbalsubstantiv..nn.1
  verbena_1_N = mkN "verbena" ; -- verbena..nn.1
  verbform_1_N = mkN "verbform" "verbformer" ; -- verbform..nn.1
  verbfras_1_N = mkN "verbfras" "verbfraser" ; -- verbfras..nn.1
  verbhandling_1_N = mkN "verbhandling" ; -- verbhandling..nn.1
  verbsammansättning_1_N = mkN "verbsammansättning" ; -- verbsammansättning..nn.1
  verbstam_1_N = mkN "verbstam" "verbstammen" "verbstammar" "verbstammarna" ; -- verbstam..nn.1
  verbändelse_1_N = mkN "verbändelse" "verbändelser" ; -- verbändelse..nn.1
  verifiera_1_V = mkV "verifierar" ; -- verifiera..vb.1
  verifierande_1_N = mkN "verifierande" ; -- verifierande..nn.1
  verifierbar_1_A = mkA "verifierbar" ; -- verifierbar..av.1
  verifierbarhet_1_N = mkN "verifierbarhet" ; -- verifierbarhet..nn.1
  verifiering_1_N = mkN "verifiering" ; -- verifiering..nn.1
  verifieringsprocess_1_N = mkN "verifieringsprocess" "verifieringsprocesser" ; -- verifieringsprocess..nn.1
  verifikat_1_N = mkN "verifikat" neutrum  ; -- verifikat..nn.1
  verifikation_1_N = mkN "verifikation" ; -- verifikation..nn.1
  verism_1_N = mkN "verism" "verismer" ; -- verism..nn.1
  veristisk_1_A = mkA "veristisk" ; -- veristisk..av.1
  veritabel_1_A = mkA "veritabel" ; -- veritabel..av.1
  verk_1_N = mkN "verk" neutrum  ; -- verk..nn.1
  verka_1_V = mkV "verkar" ; -- verka..vb.1
  verkande_1_N = mkN "verkande" ; -- verkande..nn.1
  verkanseld_1_N = mkN "verkanseld" ; -- verkanseld..nn.1
  verkbly_1_N = mkN "verkbly" neutrum  ; -- verkbly..nn.1
  verkbord_1_N = mkN "verkbord" neutrum  ; -- verkbord..nn.1
  verkhelig_1_A = mkA "verkhelig" ; -- verkhelig..av.1
  verkhelighet_1_N = mkN "verkhelighet" ; -- verkhelighet..nn.1
  verkjärn_1_N = mkN "verkjärn" neutrum  ; -- verkjärn..nn.1
  verklig_1_A = mkA "verklig" ; -- verklig..av.1
  verkligen_1_Adv = mkAdv "verkligen" ; -- verkligen..ab.1
  verkliggöra_1_V = mkV "verkliggöra" "verkliggjorde" "verkliggjort" ; -- verkliggöra..vb.1
  verkliggörande_1_N = mkN "verkliggörande" ; -- verkliggörande..nn.1
  verklighet_1_N = mkN "verklighet" "verkligheter" ; -- verklighet..nn.1
  verklighetsbakgrund_1_N = mkN "verklighetsbakgrund" "verklighetsbakgrunder" ; -- verklighetsbakgrund..nn.1
  verklighetsbaserad_1_A = mkA "verklighetsbaserad" ; -- verklighetsbaserad..av.1
  verklighetsbeskrivning_1_N = mkN "verklighetsbeskrivning" ; -- verklighetsbeskrivning..nn.1
  verklighetsbetonad_1_A = mkA "verklighetsbetonad" ; -- verklighetsbetonad..av.1
  verklighetsbild_1_N = mkN "verklighetsbild" "verklighetsbilder" ; -- verklighetsbild..nn.1
  verklighetschock_1_N = mkN "verklighetschock" "verklighetschocker" ; -- verklighetschock..nn.1
  verklighetsflykt_1_N = mkN "verklighetsflykt" ; -- verklighetsflykt..nn.1
  verklighetsfrämmande_1_A = mkA "verklighetsfrämmande" ; -- verklighetsfrämmande..av.1
  verklighetsfrånvänd_1_A = mkA "verklighetsfrånvänd" ; -- verklighetsfrånvänd..av.1
  verklighetsförankra_1_V = mkV "verklighetsförankrar" ; -- verklighetsförankra..vb.1
  verklighetsförankrande_1_N = mkN "verklighetsförankrande" ; -- verklighetsförankrande..nn.1
  verklighetsnära_1_A = mkA "verklighetsnära" ; -- verklighetsnära..av.1
  verklighetstrogen_1_A = mkA "verklighetstrogen" ; -- verklighetstrogen..av.1
  verklighetsuppfattning_1_N = mkN "verklighetsuppfattning" ; -- verklighetsuppfattning..nn.1
  verkmästare_1_N = mkN "verkmästare" utrum  ; -- verkmästare..nn.1
  verkning_1_N = mkN "verkning" ; -- verkning..nn.1
  verkningseld_1_N = mkN "verkningseld" ; -- verkningseld..nn.1
  verkningsfull_1_A = mkA "verkningsfull" ; -- verkningsfull..av.1
  verkningsfullhet_1_N = mkN "verkningsfullhet" ; -- verkningsfullhet..nn.1
  verkningsgrad_1_N = mkN "verkningsgrad" "verkningsgrader" ; -- verkningsgrad..nn.1
  verkningskrets_1_N = mkN "verkningskrets" ; -- verkningskrets..nn.1
  verkningslös_1_A = mkA "verkningslös" ; -- verkningslös..av.1
  verkningslöshet_1_N = mkN "verkningslöshet" ; -- verkningslöshet..nn.1
  verksam_1_A = mkA "verksam" "verksamt" "verksamma" "verksamma" "verksammare" "verksammast" "verksammaste" ; -- verksam..av.1
  verksamhet_1_N = mkN "verksamhet" "verksamheter" ; -- verksamhet..nn.1
  verksamhetsbegär_1_N = mkN "verksamhetsbegär" neutrum  ; -- verksamhetsbegär..nn.1
  verksamhetsbehov_1_N = mkN "verksamhetsbehov" neutrum  ; -- verksamhetsbehov..nn.1
  verksamhetsberättelse_1_N = mkN "verksamhetsberättelse" "verksamhetsberättelser" ; -- verksamhetsberättelse..nn.1
  verksamhetsfält_1_N = mkN "verksamhetsfält" neutrum  ; -- verksamhetsfält..nn.1
  verksamhetskrets_1_N = mkN "verksamhetskrets" ; -- verksamhetskrets..nn.1
  verksamhetsmässig_1_A = mkA "verksamhetsmässig" ; -- verksamhetsmässig..av.1
  verksamhetsområde_1_N = mkN "verksamhetsområde" ; -- verksamhetsområde..nn.1
  verksamhetsstyrning_1_N = mkN "verksamhetsstyrning" ; -- verksamhetsstyrning..nn.1
  verksamhetsvarig_1_A = mkA "verksamhetsvarig" ; -- verksamhetsvarig..av.1
  verksamhetsår_1_N = mkN "verksamhetsår" neutrum  ; -- verksamhetsår..nn.1
  verkshöjd_1_N = mkN "verkshöjd" "verkshöjder" ; -- verkshöjd..nn.1
  verkskydd_1_N = mkN "verkskydd" neutrum  ; -- verkskydd..nn.1
  verksläkare_1_N = mkN "verksläkare" utrum  ; -- verksläkare..nn.1
  verkstad_1_N = mkN "verkstad" "verkstäder" ; -- verkstad..nn.1
  verkstadsarbetare_1_N = mkN "verkstadsarbetare" utrum  ; -- verkstadsarbetare..nn.1
  verkstadsarbete_1_N = mkN "verkstadsarbete" ; -- verkstadsarbete..nn.1
  verkstadsbasar_1_N = mkN "verkstadsbasar" "verkstadsbasarer" ; -- verkstadsbasar..nn.1
  verkstadsförening_1_N = mkN "verkstadsförening" ; -- verkstadsförening..nn.1
  verkstadshus_1_N = mkN "verkstadshus" neutrum  ; -- verkstadshus..nn.1
  verkstadsindustri_1_N = mkN "verkstadsindustri" "verkstadsindustrier" ; -- verkstadsindustri..nn.1
  verkstadsklubb_1_N = mkN "verkstadsklubb" ; -- verkstadsklubb..nn.1
  verkstadskran_1_N = mkN "verkstadskran" ; -- verkstadskran..nn.1
  verkställa_1_V = mkV "verkställer" ; -- verkställa..vb.1
  verkställande_1_A = mkA "verkställande" ; -- verkställande..av.1
  verkställande_1_N = mkN "verkställande" ; -- verkställande..nn.1
  verkställare_1_N = mkN "verkställare" utrum  ; -- verkställare..nn.1
  verkställighet_1_N = mkN "verkställighet" "verkställigheter" ; -- verkställighet..nn.1
  verksynd_1_N = mkN "verksynd" "verksynder" ; -- verksynd..nn.1
  verktum_1_N = mkN "verktum" "verktummen" "verktum" "verktummen" ; -- verktum..nn.1
  verktyg_1_N = mkN "verktyg" neutrum  ; -- verktyg..nn.1
  verktygsbälte_1_N = mkN "verktygsbälte" ; -- verktygsbälte..nn.1
  verktygskrok_1_N = mkN "verktygskrok" ; -- verktygskrok..nn.1
  verktygslåda_1_N = mkN "verktygslåda" ; -- verktygslåda..nn.1
  verktygsmaskin_1_N = mkN "verktygsmaskin" "verktygsmaskiner" ; -- verktygsmaskin..nn.1
  verktygssats_1_N = mkN "verktygssats" "verktygssatser" ; -- verktygssats..nn.1
  verktygsstål_1_N = mkN "verktygsstål" neutrum  ; -- verktygsstål..nn.1
  verktygsväska_1_N = mkN "verktygsväska" ; -- verktygsväska..nn.1
  vermouth_1_N = mkN "vermouth" ; -- vermouth..nn.1
  vermut_1_N = mkN "vermut" ; -- vermut..nn.1
  vernalisering_1_N = mkN "vernalisering" ; -- vernalisering..nn.1
  vernissage_1_N = mkN "vernissage" "vernissager" ; -- vernissage..nn.1
  vernissagebesökare_1_N = mkN "vernissagebesökare" utrum  ; -- vernissagebesökare..nn.1
  vernissagefest_1_N = mkN "vernissagefest" "vernissagefester" ; -- vernissagefest..nn.1
  verop_1_N = mkN "verop" neutrum  ; -- verop..nn.1
  vers_1_N = mkN "vers" ; -- vers..nn.1
  versal_1_N = mkN "versal" "versaler" ; -- versal..nn.1
  versatil_1_A = mkA "versatil" ; -- versatil..av.1
  versberättelse_1_N = mkN "versberättelse" "versberättelser" ; -- versberättelse..nn.1
  versbindning_1_N = mkN "versbindning" ; -- versbindning..nn.1
  verserad_1_A = mkA "verserad" ; -- verserad..av.1
  versfot_1_N = mkN "versfot" "versfötter" ; -- versfot..nn.1
  versifiera_1_V = mkV "versifierar" ; -- versifiera..vb.1
  versifierande_1_N = mkN "versifierande" ; -- versifierande..nn.1
  versifierbar_1_A = mkA "versifierbar" ; -- versifierbar..av.1
  versifierbarhet_1_N = mkN "versifierbarhet" ; -- versifierbarhet..nn.1
  versifiering_1_N = mkN "versifiering" ; -- versifiering..nn.1
  versifikation_1_N = mkN "versifikation" ; -- versifikation..nn.1
  versifikatör_1_N = mkN "versifikatör" "versifikatörer" ; -- versifikatör..nn.1
  version_1_N = mkN "version" ; -- version..nn.1
  verslära_1_N = mkN "verslära" ; -- verslära..nn.1
  versmakare_1_N = mkN "versmakare" utrum  ; -- versmakare..nn.1
  versmått_1_N = mkN "versmått" neutrum  ; -- versmått..nn.1
  versrad_1_N = mkN "versrad" "versrader" ; -- versrad..nn.1
  verst_1_N = mkN "verst" "versten" "verst" "versten" ; -- verst..nn.1
  verstakt_1_N = mkN "verstakt" "verstakter" ; -- verstakt..nn.1
  vertebrat_1_N = mkN "vertebrat" "vertebrater" ; -- vertebrat..nn.1
  vertebrerad_1_A = mkA "vertebrerad" ; -- vertebrerad..av.1
  vertikal_1_A = mkA "vertikal" ; -- vertikal..av.1
  vertikal_1_N = mkN "vertikal" "vertikaler" ; -- vertikal..nn.1
  vertikalaxlad_1_A = mkA "vertikalaxlad" ; -- vertikalaxlad..av.1
  vertikalcirkel_1_N = mkN "vertikalcirkel" ; -- vertikalcirkel..nn.1
  vertikallinje_1_N = mkN "vertikallinje" "vertikallinjer" ; -- vertikallinje..nn.1
  vertikalläge_1_N = mkN "vertikalläge" ; -- vertikalläge..nn.1
  vertikalplan_1_N = mkN "vertikalplan" neutrum  ; -- vertikalplan..nn.1
  vertikalprojektion_1_N = mkN "vertikalprojektion" ; -- vertikalprojektion..nn.1
  vertikalskärare_1_N = mkN "vertikalskärare" utrum  ; -- vertikalskärare..nn.1
  vertikalström_1_N = mkN "vertikalström" "vertikalströmmen" "vertikalströmmar" "vertikalströmmarna" ; -- vertikalström..nn.1
  vertikalvinkel_1_N = mkN "vertikalvinkel" ; -- vertikalvinkel..nn.1
  vertolhelikopter_1_N = mkN "vertolhelikopter" ; -- vertolhelikopter..nn.1
  verv_1_N = mkN "verv" ; -- verv..nn.1
  vesir_1_N = mkN "vesir" "vesirer" ; -- vesir..nn.1
  vespa_1_N = mkN "vespa" ; -- vespa..nn.1
  vesper_1_N = mkN "vesper" ; -- vesper..nn.1
  vessla_1_N = mkN "vessla" ; -- vessla..nn.1
  vesslelik_1_A = mkA "vesslelik" ; -- vesslelik..av.1
  vestal_1_N = mkN "vestal" "vestaler" ; -- vestal..nn.1
  vestalisk_1_A = mkA "vestalisk" ; -- vestalisk..av.1
  vestibul_1_N = mkN "vestibul" "vestibuler" ; -- vestibul..nn.1
  vestibulit_1_N = mkN "vestibulit" "vestibuliter" ; -- vestibulit..nn.1
  vesäll_1_A = mkA "vesäll" ; -- vesäll..av.1
  vetande_1_A = mkA "vetande" ; -- vetande..av.1
  vetande_1_N = mkN "vetande" ; -- vetande..nn.1
  vetbar_1_A = mkA "vetbar" ; -- vetbar..av.1
  vetbarhet_1_N = mkN "vetbarhet" ; -- vetbarhet..nn.1
  vete_1_N = mkN "vete" ; -- vete..nn.1
  vetebröd_1_N = mkN "vetebröd" neutrum  ; -- vetebröd..nn.1
  vetebrödslängd_1_N = mkN "vetebrödslängd" "vetebrödslängder" ; -- vetebrödslängd..nn.1
  vetebulla_1_N = mkN "vetebulla" ; -- vetebulla..nn.1
  vetebulle_1_N = mkN "vetebulle" utrum  ; -- vetebulle..nn.1
  vetefläta_1_N = mkN "vetefläta" ; -- vetefläta..nn.1
  vetegrodd_1_N = mkN "vetegrodd" ; -- vetegrodd..nn.1
  vetekaka_1_N = mkN "vetekaka" ; -- vetekaka..nn.1
  vetekli_1_N = mkN "vetekli" neutrum  ; -- vetekli..nn.1
  vetekorn_1_N = mkN "vetekorn" neutrum  ; -- vetekorn..nn.1
  vetekrans_1_N = mkN "vetekrans" ; -- vetekrans..nn.1
  vetelängd_1_N = mkN "vetelängd" "vetelängder" ; -- vetelängd..nn.1
  vetemjöl_1_N = mkN "vetemjöl" neutrum  ; -- vetemjöl..nn.1
  vetemjölsklister_1_N = mkN "vetemjölsklister" neutrum  ; -- vetemjölsklister..nn.1
  vetenskap_1_N = mkN "vetenskap" "vetenskaper" ; -- vetenskap..nn.1
  vetenskapa_1_V = mkV "vetenskapar" ; -- vetenskapa..vb.1
  vetenskapande_1_N = mkN "vetenskapande" ; -- vetenskapande..nn.1
  vetenskapare_1_N = mkN "vetenskapare" utrum  ; -- vetenskapare..nn.1
  vetenskaplig_1_A = mkA "vetenskaplig" ; -- vetenskaplig..av.1
  vetenskaplighet_1_N = mkN "vetenskaplighet" ; -- vetenskaplighet..nn.1
  vetenskapsakademi_1_N = mkN "vetenskapsakademi" "vetenskapsakademier" ; -- vetenskapsakademi..nn.1
  vetenskapshistoria_1_N = mkN "vetenskapshistoria" ; -- vetenskapshistoria..nn.1
  vetenskapsjournalistik_1_N = mkN "vetenskapsjournalistik" ; -- vetenskapsjournalistik..nn.1
  vetenskapsman_1_N = mkN "vetenskapsman" "vetenskapsmannen" "vetenskapsmän" "vetenskapsmännen" ; -- vetenskapsman..nn.1
  vetenskapsteori_1_N = mkN "vetenskapsteori" ; -- vetenskapsteori..nn.1
  veteran_1_N = mkN "veteran" "veteraner" ; -- veteran..nn.1
  veteranbil_1_N = mkN "veteranbil" ; -- veteranbil..nn.1
  veteranpolitik_1_N = mkN "veteranpolitik" ; -- veteranpolitik..nn.1
  veterantraktor_1_N = mkN "veterantraktor" "veterantraktorer" ; -- veterantraktor..nn.1
  veterinär_1_N = mkN "veterinär" "veterinärer" ; -- veterinär..nn.1
  veterinärbesiktning_1_N = mkN "veterinärbesiktning" ; -- veterinärbesiktning..nn.1
  veterinärkontroll_1_N = mkN "veterinärkontroll" "veterinärkontroller" ; -- veterinärkontroll..nn.1
  veterinärmedicin_1_N = mkN "veterinärmedicin" ; -- veterinärmedicin..nn.1
  veterligen_1_Adv = mkAdv "veterligen" ; -- veterligen..ab.1
  veteskiva_1_N = mkN "veteskiva" ; -- veteskiva..nn.1
  vetesort_1_N = mkN "vetesort" "vetesorter" ; -- vetesort..nn.1
  vetgirig_1_A = mkA "vetgirig" ; -- vetgirig..av.1
  vetgirighet_1_N = mkN "vetgirighet" ; -- vetgirighet..nn.1
  veto_1_N = mkN "veto" "vetot" "veton" "vetona" ; -- veto..nn.1
  vetorätt_1_N = mkN "vetorätt" ; -- vetorätt..nn.1
  vetskap_1_N = mkN "vetskap" ; -- vetskap..nn.1
  vett_1_N = mkN "vett" neutrum  ; -- vett..nn.1
  vetta_1_V = mkV "vetta" "vette" "vettat" ; -- vetta..vb.1
  vettande_1_N = mkN "vettande" ; -- vettande..nn.1
  vette_1_N = mkN "vette" utrum  ; -- vette..nn.1
  vettig_1_A = mkA "vettig" ; -- vettig..av.1
  vettighet_1_N = mkN "vettighet" "vettigheter" ; -- vettighet..nn.1
  vettlös_1_A = mkA "vettlös" ; -- vettlös..av.1
  vettlöshet_1_N = mkN "vettlöshet" "vettlösheter" ; -- vettlöshet..nn.1
  vettskrämd_1_A = mkA "vettskrämd" "vettskrämt" ; -- vettskrämd..av.1
  vettskrämdhet_1_N = mkN "vettskrämdhet" ; -- vettskrämdhet..nn.1
  vettvillig_1_A = mkA "vettvillig" ; -- vettvillig..av.1
  vettvillighet_1_N = mkN "vettvillighet" "vettvilligheter" ; -- vettvillighet..nn.1
  vettvilling_1_N = mkN "vettvilling" ; -- vettvilling..nn.1
  vev_1_N = mkN "vev" ; -- vev..nn.1
  veva_1_V = mkV "vevar" ; -- veva..vb.1
  vevande_1_N = mkN "vevande" ; -- vevande..nn.1
  vevarm_1_N = mkN "vevarm" ; -- vevarm..nn.1
  vevaxel_1_N = mkN "vevaxel" ; -- vevaxel..nn.1
  vevgrammofon_1_N = mkN "vevgrammofon" "vevgrammofoner" ; -- vevgrammofon..nn.1
  vevhus_1_N = mkN "vevhus" neutrum  ; -- vevhus..nn.1
  vevla_1_V = mkV "vevlar" ; -- vevla..vb.1
  vevlande_1_N = mkN "vevlande" ; -- vevlande..nn.1
  vevling_1_N = mkN "vevling" ; -- vevling..nn.1
  vevstake_1_N = mkN "vevstake" utrum  ; -- vevstake..nn.1
  vevstång_1_N = mkN "vevstång" "vevstänger" ; -- vevstång..nn.1
  vevtapp_1_N = mkN "vevtapp" ; -- vevtapp..nn.1
  vi_1_Adv = mkAdv "vi" ; -- vi..ab.1
  vi_1_N = mkN "vi" neutrum  ; -- vi..nn.1
  viadukt_1_N = mkN "viadukt" "viadukter" ; -- viadukt..nn.1
  viagra_1_N = mkN "viagra" ; -- viagra..nn.1
  vial_1_N = mkN "vial" "vialer" ; -- vial..nn.1
  vibb_1_N = mkN "vibb" ; -- vibb..nn.1
  vibba_1_V = mkV "vibbar" ; -- vibba..vb.1
  vibbande_1_N = mkN "vibbande" ; -- vibbande..nn.1
  vibbning_1_N = mkN "vibbning" ; -- vibbning..nn.1
  vibrafon_1_N = mkN "vibrafon" "vibrafoner" ; -- vibrafon..nn.1
  vibrant_1_N = mkN "vibrant" "vibranter" ; -- vibrant..nn.1
  vibration_1_N = mkN "vibration" ; -- vibration..nn.1
  vibrationsdämpande_1_A = mkA "vibrationsdämpande" ; -- vibrationsdämpande..av.1
  vibrationsfri_1_A = mkA "vibrationsfri" "vibrationsfritt" ; -- vibrationsfri..av.1
  vibrato_1_N = mkN "vibrato" "vibratot" "vibraton" "vibratona" ; -- vibrato..nn.1
  vibrator_1_N = mkN "vibrator" "vibratorer" ; -- vibrator..nn.1
  vibrera_1_V = mkV "vibrerar" ; -- vibrera..vb.1
  vibrerande_1_N = mkN "vibrerande" ; -- vibrerande..nn.1
  vibrering_1_N = mkN "vibrering" ; -- vibrering..nn.1
  vibrion_1_N = mkN "vibrion" ; -- vibrion..nn.1
  viby_i_1_N = mkN "viby-i" neutrum  ; -- viby-i..nn.1
  vice_1_A = mkA "vice" ; -- vice..av.1
  viceamiral_1_N = mkN "viceamiral" "viceamiraler" ; -- viceamiral..nn.1
  viceguvernör_1_N = mkN "viceguvernör" "viceguvernörer" ; -- viceguvernör..nn.1
  vicekonung_1_N = mkN "vicekonung" ; -- vicekonung..nn.1
  vicekorpral_1_N = mkN "vicekorpral" "vicekorpraler" ; -- vicekorpral..nn.1
  vicekung_1_N = mkN "vicekung" ; -- vicekung..nn.1
  vicepresident_1_N = mkN "vicepresident" "vicepresidenter" ; -- vicepresident..nn.1
  vicepresidentkandidat_1_N = mkN "vicepresidentkandidat" "vicepresidentkandidater" ; -- vicepresidentkandidat..nn.1
  vicevärd_1_N = mkN "vicevärd" ; -- vicevärd..nn.1
  vichyvatten_1_N = mkN "vichyvatten" "vichyvattnet" "vichyvatten" "vichyvattnen" ; -- vichyvatten..nn.1
  vick_1_N = mkN "vick" neutrum  ; -- vick..nn.1
  vicka_1_V = mkV "vickar" ; -- vicka..vb.1
  vicka_2_V = mkV "vickar" ; -- vicka..vb.2
  vickande_1_N = mkN "vickande" ; -- vickande..nn.1
  vickel_1_N = mkN "vickel" ; -- vickel..nn.1
  vicker_1_N = mkN "vicker" ; -- vicker..nn.1
  vickig_1_A = mkA "vickig" ; -- vickig..av.1
  vickighet_1_N = mkN "vickighet" ; -- vickighet..nn.1
  vickning_1_N = mkN "vickning" ; -- vickning..nn.1
  victoriakors_1_N = mkN "victoriakors" neutrum  ; -- victoriakors..nn.1
  victoriakorsvinnare_1_N = mkN "victoriakorsvinnare" utrum  ; -- victoriakorsvinnare..nn.1
  victorianism_1_N = mkN "victorianism" "victorianismer" ; -- victorianism..nn.1
  victoriansk_1_A = mkA "victoriansk" ; -- victoriansk..av.1
  vid_1_A = mkA "vid" "vitt" ; -- vid..av.1
  vida_1_Adv = mkAdv "vida" ; -- vida..ab.1
  vidare_1_Adv = mkAdv "vidare-" ; -- vidare..ab.1
  vidare_1_A = mkA "vidare" ; -- vidare..av.1
  vidarebefordra_1_V = mkV "vidarebefordrar" ; -- vidarebefordra..vb.1
  vidarebefordrande_1_N = mkN "vidarebefordrande" ; -- vidarebefordrande..nn.1
  vidarerapportera_1_V = mkV "vidarerapporterar" ; -- vidarerapportera..vb.1
  vidarerapporterande_1_N = mkN "vidarerapporterande" ; -- vidarerapporterande..nn.1
  vidareutbilda_1_V = mkV "vidareutbildar" ; -- vidareutbilda..vb.1
  vidareutbildande_1_N = mkN "vidareutbildande" ; -- vidareutbildande..nn.1
  vidareutbildning_1_N = mkN "vidareutbildning" ; -- vidareutbildning..nn.1
  vidareutveckla_1_V = mkV "vidareutvecklar" ; -- vidareutveckla..vb.1
  vidareutvecklande_1_N = mkN "vidareutvecklande" ; -- vidareutvecklande..nn.1
  vidareutveckling_1_N = mkN "vidareutveckling" ; -- vidareutveckling..nn.1
  vidbränd_1_A = mkA "vidbränd" ; -- vidbränd..av.1
  vidbrändhet_1_N = mkN "vidbrändhet" ; -- vidbrändhet..nn.1
  vidbränna_1_V = mkV "vidbränna" "vidbrände" "vidbränt" ; -- vidbränna..vb.1
  vidbrännande_1_N = mkN "vidbrännande" ; -- vidbrännande..nn.1
  vidbränning_1_N = mkN "vidbränning" ; -- vidbränning..nn.1
  vidbrättad_1_A = mkA "vidbrättad" ; -- vidbrättad..av.1
  vidd_1_N = mkN "vidd" ; -- vidd..nn.1
  vidd_2_N = mkN "vidd" "vidder" ; -- vidd..nn.2
  vide_1_N = mkN "vide" ; -- vide..nn.1
  videbuske_1_N = mkN "videbuske" utrum  ; -- videbuske..nn.1
  video_1_N = mkN "video" "videor" ; -- video..nn.1
  videoaffär_1_N = mkN "videoaffär" "videoaffärer" ; -- videoaffär..nn.1
  videoband_1_N = mkN "videoband" neutrum  ; -- videoband..nn.1
  videobandspelare_1_N = mkN "videobandspelare" utrum  ; -- videobandspelare..nn.1
  videoblogg_1_N = mkN "videoblogg" ; -- videoblogg..nn.1
  videobutik_1_N = mkN "videobutik" "videobutiker" ; -- videobutik..nn.1
  videofilm_1_N = mkN "videofilm" "videofilmer" ; -- videofilm..nn.1
  videoinspelning_1_N = mkN "videoinspelning" ; -- videoinspelning..nn.1
  videoklipp_1_N = mkN "videoklipp" neutrum  ; -- videoklipp..nn.1
  videosignal_1_N = mkN "videosignal" "videosignaler" ; -- videosignal..nn.1
  videoutrustning_1_N = mkN "videoutrustning" ; -- videoutrustning..nn.1
  viderboende_1_N = mkN "viderboende" "viderboenden" "viderboende" "viderboendena" ; -- viderboende..nn.1
  videregion_1_N = mkN "videregion" ; -- videregion..nn.1
  vidertryck_1_N = mkN "vidertryck" neutrum  ; -- vidertryck..nn.1
  videsparv_1_N = mkN "videsparv" ; -- videsparv..nn.1
  videört_1_N = mkN "videört" ; -- videört..nn.1
  vidfilm_1_N = mkN "vidfilm" "vidfilmer" ; -- vidfilm..nn.1
  vidfoga_1_V = mkV "vidfogar" ; -- vidfoga..vb.1
  vidfogande_1_N = mkN "vidfogande" ; -- vidfogande..nn.1
  vidfogning_1_N = mkN "vidfogning" ; -- vidfogning..nn.1
  vidfästning_1_N = mkN "vidfästning" ; -- vidfästning..nn.1
  vidga_1_V = mkV "vidgar" ; -- vidga..vb.1
  vidgande_1_N = mkN "vidgande" ; -- vidgande..nn.1
  vidgning_1_N = mkN "vidgning" ; -- vidgning..nn.1
  vidgå_1_V = mkV "vidgå" "vidgick" "vidgått" ; -- vidgå..vb.1
  vidgående_1_N = mkN "vidgående" ; -- vidgående..nn.1
  vidhet_1_N = mkN "vidhet" ; -- vidhet..nn.1
  vidhäfta_1_V = mkV "vidhäftar" ; -- vidhäfta..vb.1
  vidhäftande_1_N = mkN "vidhäftande" ; -- vidhäftande..nn.1
  vidhäftning_1_N = mkN "vidhäftning" ; -- vidhäftning..nn.1
  vidhänga_1_V = mkV "vidhänger" ; -- vidhänga..vb.1
  vidhängande_1_N = mkN "vidhängande" ; -- vidhängande..nn.1
  vidhängning_1_N = mkN "vidhängning" ; -- vidhängning..nn.1
  vidhålla_1_V = mkV "vidhålla" "vidhöll" "vidhållit" ; -- vidhålla..vb.1
  vidhållande_1_N = mkN "vidhållande" ; -- vidhållande..nn.1
  vidimation_1_N = mkN "vidimation" ; -- vidimation..nn.1
  vidimera_1_V = mkV "vidimerar" ; -- vidimera..vb.1
  vidimerande_1_N = mkN "vidimerande" ; -- vidimerande..nn.1
  vidimerbar_1_A = mkA "vidimerbar" ; -- vidimerbar..av.1
  vidimerbarhet_1_N = mkN "vidimerbarhet" ; -- vidimerbarhet..nn.1
  vidimering_1_N = mkN "vidimering" ; -- vidimering..nn.1
  vidja_1_N = mkN "vidja" ; -- vidja..nn.1
  vidkomma_1_V = mkV "vidkomma" "vidkom" "vidkommit" ; -- vidkomma..vb.1
  vidkommande_1_N = mkN "vidkommande" ; -- vidkommande..nn.1
  vidlyftig_1_A = mkA "vidlyftig" ; -- vidlyftig..av.1
  vidlyftighet_1_N = mkN "vidlyftighet" "vidlyftigheter" ; -- vidlyftighet..nn.1
  vidlåda_1_V = mkV "vidlåda" "vidlådde" "vidlått" ; -- vidlåda..vb.1
  vidlådande_1_N = mkN "vidlådande" ; -- vidlådande..nn.1
  vidmakthålla_1_V = mkV "vidmakthålla" "vidmakthöll" "vidmakthållit" ; -- vidmakthålla..vb.1
  vidmakthållande_1_N = mkN "vidmakthållande" ; -- vidmakthållande..nn.1
  vidpass_1_Adv = mkAdv "vidpass" ; -- vidpass..ab.1
  vidrig_1_A = mkA "vidrig" ; -- vidrig..av.1
  vidrighet_1_N = mkN "vidrighet" "vidrigheter" ; -- vidrighet..nn.1
  vidräkning_1_N = mkN "vidräkning" ; -- vidräkning..nn.1
  vidröra_1_V = mkV "vidröra" "vidrörde" "vidrört" ; -- vidröra..vb.1
  vidrörande_1_N = mkN "vidrörande" ; -- vidrörande..nn.1
  vidskepelse_1_N = mkN "vidskepelse" "vidskepelser" ; -- vidskepelse..nn.1
  vidskeplig_1_A = mkA "vidskeplig" ; -- vidskeplig..av.1
  vidskeplighet_1_N = mkN "vidskeplighet" "vidskepligheter" ; -- vidskeplighet..nn.1
  vidsträckt_1_A = mkA "vidsträckt" "vidsträckt" ; -- vidsträckt..av.1
  vidsträckthet_1_N = mkN "vidsträckthet" ; -- vidsträckthet..nn.1
  vidstående_1_A = mkA "vidstående" ; -- vidstående..av.1
  vidsyn_1_N = mkN "vidsyn" ; -- vidsyn..nn.1
  vidsynt_1_A = mkA "vidsynt" "vidsynt" ; -- vidsynt..av.1
  vidsynthet_1_N = mkN "vidsynthet" "vidsyntheter" ; -- vidsynthet..nn.1
  vidta_1_V = mkV "vidtaga" "vidtog" "vidtagit" ; -- vidta..vb.1
  vidtagande_1_N = mkN "vidtagande" ; -- vidtagande..nn.1
  vidtala_1_V = mkV "vidtalar" ; -- vidtala..vb.1
  vidtalande_1_N = mkN "vidtalande" ; -- vidtalande..nn.1
  vidunder_1_N = mkN "vidunder" neutrum  ; -- vidunder..nn.1
  vidunderlig_1_A = mkA "vidunderlig" ; -- vidunderlig..av.1
  vidunderlighet_1_N = mkN "vidunderlighet" "vidunderligheter" ; -- vidunderlighet..nn.1
  vidvinkelobjektiv_1_N = mkN "vidvinkelobjektiv" neutrum  ; -- vidvinkelobjektiv..nn.1
  vidöppen_1_A = mkA "vidöppen" ; -- vidöppen..av.1
  vielle_1_N = mkN "vielle" "vieller" ; -- vielle..nn.1
  vietnames_1_N = mkN "vietnames" "vietnameser" ; -- vietnames..nn.1
  vietnamesisk_1_A = mkA "vietnamesisk" ; -- vietnamesisk..av.1
  vietnamesiska_1_N = mkN "vietnamesiska" ; -- vietnamesiska..nn.1
  vietnamesiska_2_N = mkN "vietnamesiska" ; -- vietnamesiska..nn.2
  vifta_1_V = mkV "viftar" ; -- vifta..vb.1
  viftande_1_N = mkN "viftande" ; -- viftande..nn.1
  viftning_1_N = mkN "viftning" ; -- viftning..nn.1
  vig_1_A = mkA "vig" ; -- vig..av.1
  viga_1_V = mkV "viger" ; -- viga..vb.1
  vigande_1_N = mkN "vigande" ; -- vigande..nn.1
  vigg_1_N = mkN "vigg" ; -- vigg..nn.1
  vigga_1_V = mkV "viggar" ; -- vigga..vb.1
  viggande_1_N = mkN "viggande" ; -- viggande..nn.1
  vigge_1_N = mkN "vigg" ; -- vigge..nn.1
  viggning_1_N = mkN "viggning" ; -- viggning..nn.1
  vighet_1_N = mkN "vighet" ; -- vighet..nn.1
  vigilans_1_N = mkN "vigilans" ; -- vigilans..nn.1
  vigilera_1_V = mkV "vigilerar" ; -- vigilera..vb.1
  vigilerande_1_N = mkN "vigilerande" ; -- vigilerande..nn.1
  vigilering_1_N = mkN "vigilering" ; -- vigilering..nn.1
  vigilia_1_N = mkN "vigilia" ; -- vigilia..nn.1
  vigkvast_1_N = mkN "vigkvast" ; -- vigkvast..nn.1
  vigning_1_N = mkN "vigning" ; -- vigning..nn.1
  vigningslöfte_1_N = mkN "vigningslöfte" ; -- vigningslöfte..nn.1
  vigsel_1_N = mkN "vigsel" ; -- vigsel..nn.1
  vigselakt_1_N = mkN "vigselakt" "vigselakter" ; -- vigselakt..nn.1
  vigselannons_1_N = mkN "vigselannons" "vigselannonser" ; -- vigselannons..nn.1
  vigselbevis_1_N = mkN "vigselbevis" neutrum  ; -- vigselbevis..nn.1
  vigselformulär_1_N = mkN "vigselformulär" neutrum  ; -- vigselformulär..nn.1
  vigselring_1_N = mkN "vigselring" ; -- vigselring..nn.1
  vigselritual_1_N = mkN "vigselritual" neutrum  ; -- vigselritual..nn.1
  vigselrum_1_N = mkN "vigselrum" "vigselrummet" "vigselrum" "vigselrummen" ; -- vigselrum..nn.1
  vigselrätt_1_N = mkN "vigselrätt" ; -- vigselrätt..nn.1
  vigvam_1_N = mkN "vigvam" "vigvamer" ; -- vigvam..nn.1
  vigör_1_N = mkN "vigör" ; -- vigör..nn.1
  vik_1_N = mkN "vik" ; -- vik..nn.1
  vika_1_V = mkV "vika" "viker" "vik" "vek" "vikt" "viken" ; -- vika..vb.1
  vikande_1_N = mkN "vikande" ; -- vikande..nn.1
  vikare_1_N = mkN "vikare" utrum  ; -- vikare..nn.1
  vikariat_1_N = mkN "vikariat" neutrum  ; -- vikariat..nn.1
  vikarie_1_N = mkN "vikarie" "vikarier" ; -- vikarie..nn.1
  vikariera_1_V = mkV "vikarierar" ; -- vikariera..vb.1
  vikarierande_1_A = mkA "vikarierande" ; -- vikarierande..av.1
  vikarierande_1_N = mkN "vikarierande" ; -- vikarierande..nn.1
  vikariering_1_N = mkN "vikariering" ; -- vikariering..nn.1
  vikariestopp_1_N = mkN "vikariestopp" neutrum  ; -- vikariestopp..nn.1
  vikdörr_1_N = mkN "vikdörr" ; -- vikdörr..nn.1
  viking_1_N = mkN "viking" ; -- viking..nn.1
  vikingagrav_1_N = mkN "vikingagrav" ; -- vikingagrav..nn.1
  vikingahövding_1_N = mkN "vikingahövding" ; -- vikingahövding..nn.1
  vikingaskepp_1_N = mkN "vikingaskepp" neutrum  ; -- vikingaskepp..nn.1
  vikingatid_1_N = mkN "vikingatid" ; -- vikingatid..nn.1
  vikingatida_1_A = mkA "vikingatida" ; -- vikingatida..av.1
  vikingatåg_1_N = mkN "vikingatåg" neutrum  ; -- vikingatåg..nn.1
  vikning_1_N = mkN "vikning" ; -- vikning..nn.1
  vikon_1_N = mkN "vikon" neutrum  ; -- vikon..nn.1
  vikskärm_1_N = mkN "vikskärm" ; -- vikskärm..nn.1
  vikt_1_N = mkN "vikt" "vikter" ; -- vikt..nn.1
  vikta_1_V = mkV "viktar" ; -- vikta..vb.1
  viktande_1_N = mkN "viktande" ; -- viktande..nn.1
  viktenhet_1_N = mkN "viktenhet" "viktenheter" ; -- viktenhet..nn.1
  viktförlust_1_N = mkN "viktförlust" "viktförluster" ; -- viktförlust..nn.1
  viktig_1_A = mkA "viktig" ; -- viktig..av.1
  viktighet_1_N = mkN "viktighet" "viktigheter" ; -- viktighet..nn.1
  viktighetsmakare_1_N = mkN "viktighetsmakare" utrum  ; -- viktighetsmakare..nn.1
  viktigpetter_1_N = mkN "viktigpetter" ; -- viktigpetter..nn.1
  viktjusterare_1_N = mkN "viktjusterare" utrum  ; -- viktjusterare..nn.1
  viktkastning_1_N = mkN "viktkastning" ; -- viktkastning..nn.1
  viktklass_1_N = mkN "viktklass" "viktklasser" ; -- viktklass..nn.1
  viktklubb_1_N = mkN "viktklubb" ; -- viktklubb..nn.1
  viktlös_1_A = mkA "viktlös" ; -- viktlös..av.1
  viktlöshet_1_N = mkN "viktlöshet" ; -- viktlöshet..nn.1
  viktminskning_1_N = mkN "viktminskning" ; -- viktminskning..nn.1
  viktminskningsprogram_1_N = mkN "viktminskningsprogram" "viktminskningsprogrammet" "viktminskningsprogram" "viktminskningsprogrammen" ; -- viktminskningsprogram..nn.1
  viktmässig_1_A = mkA "viktmässig" ; -- viktmässig..av.1
  viktnedgång_1_N = mkN "viktnedgång" ; -- viktnedgång..nn.1
  viktnedgångsåtgärd_1_N = mkN "viktnedgångsåtgärd" "viktnedgångsåtgärder" ; -- viktnedgångsåtgärd..nn.1
  viktning_1_N = mkN "viktning" ; -- viktning..nn.1
  viktoria_1_N = mkN "viktoria" ; -- viktoria..nn.1
  viktorianism_1_N = mkN "viktorianism" "viktorianismer" ; -- viktorianism..nn.1
  viktoriansk_1_A = mkA "viktoriansk" ; -- viktoriansk..av.1
  viktprocent_1_N = mkN "viktprocent" "viktprocenten" "viktprocent" "viktprocenten" ; -- viktprocent..nn.1
  viktskillnad_1_N = mkN "viktskillnad" "viktskillnader" ; -- viktskillnad..nn.1
  viktslag_1_N = mkN "viktslag" neutrum  ; -- viktslag..nn.1
  viktsystem_1_N = mkN "viktsystem" neutrum  ; -- viktsystem..nn.1
  viktualiehandel_1_N = mkN "viktualiehandel" ; -- viktualiehandel..nn.1
  viktualievikt_1_N = mkN "viktualievikt" ; -- viktualievikt..nn.1
  viktökning_1_N = mkN "viktökning" ; -- viktökning..nn.1
  vikunja_1_N = mkN "vikunja" ; -- vikunja..nn.1
  vikunjaull_1_N = mkN "vikunjaull" ; -- vikunjaull..nn.1
  vila_1_N = mkN "vila" ; -- vila..nn.1
  vila_1_V = mkV "vilar" ; -- vila..vb.1
  vilande_1_N = mkN "vilande" ; -- vilande..nn.1
  vild_1_A = mkA "vild" "vilt" ; -- vild..av.1
  vildand_1_N = mkN "vildand" "vildänder" ; -- vildand..nn.1
  vildapel_1_N = mkN "vildapel" ; -- vildapel..nn.1
  vildavel_1_N = mkN "vildavel" ; -- vildavel..nn.1
  vildbana_1_N = mkN "vildbana" ; -- vildbana..nn.1
  vildbasare_1_N = mkN "vildbasare" utrum  ; -- vildbasare..nn.1
  vilddjur_1_N = mkN "vilddjur" neutrum  ; -- vilddjur..nn.1
  vilde_1_N = mkN "vilde" utrum  ; -- vilde..nn.1
  vildfågel_1_N = mkN "vildfågel" ; -- vildfågel..nn.1
  vildgräs_1_N = mkN "vildgräs" neutrum  ; -- vildgräs..nn.1
  vildgås_1_N = mkN "vildgås" "vildgåsen" "vildgäss" "vildgässen" ; -- vildgås..nn.1
  vildhavre_1_N = mkN "vildhavre" utrum  ; -- vildhavre..nn.1
  vildhet_1_N = mkN "vildhet" ; -- vildhet..nn.1
  vildhjärna_1_N = mkN "vildhjärna" ; -- vildhjärna..nn.1
  vildhonung_1_N = mkN "vildhonung" ; -- vildhonung..nn.1
  vildhäckande_1_A = mkA "vildhäckande" ; -- vildhäckande..av.1
  vilding_1_N = mkN "vilding" ; -- vilding..nn.1
  vildkanin_1_N = mkN "vildkanin" "vildkaniner" ; -- vildkanin..nn.1
  vildkaprifol_1_N = mkN "vildkaprifol" "vildkaprifoler" ; -- vildkaprifol..nn.1
  vildkatt_1_N = mkN "vildkatt" "vildkatter" ; -- vildkatt..nn.1
  vildkatta_1_N = mkN "vildkatta" ; -- vildkatta..nn.1
  vildman_1_N = mkN "vildman" "vildmannen" "vildmän" "vildmännen" ; -- vildman..nn.1
  vildmark_1_N = mkN "vildmark" "vildmarker" ; -- vildmark..nn.1
  vildmarksbrand_1_N = mkN "vildmarksbrand" "vildmarksbränder" ; -- vildmarksbrand..nn.1
  vildmarksmänniska_1_N = mkN "vildmarksmänniska" ; -- vildmarksmänniska..nn.1
  vildnad_1_N = mkN "vildnad" "vildnader" ; -- vildnad..nn.1
  vildpersilja_1_N = mkN "vildpersilja" ; -- vildpersilja..nn.1
  vildren_1_N = mkN "vildren" "vildrenen" "vildrenar" "vildrenarna" ; -- vildren..nn.1
  vildrensjakt_1_N = mkN "vildrensjakt" "vildrensjakter" ; -- vildrensjakt..nn.1
  vildsint_1_A = mkA "vildsint" "vildsint" ; -- vildsint..av.1
  vildsinthet_1_N = mkN "vildsinthet" ; -- vildsinthet..nn.1
  vildskott_1_N = mkN "vildskott" neutrum  ; -- vildskott..nn.1
  vildstam_1_N = mkN "vildstam" "vildstammen" "vildstammar" "vildstammarna" ; -- vildstam..nn.1
  vildsvin_1_N = mkN "vildsvin" neutrum  ; -- vildsvin..nn.1
  vildsvinsflock_1_N = mkN "vildsvinsflock" ; -- vildsvinsflock..nn.1
  vildsvinsjakt_1_N = mkN "vildsvinsjakt" ; -- vildsvinsjakt..nn.1
  vildsvinsolycka_1_N = mkN "vildsvinsolycka" ; -- vildsvinsolycka..nn.1
  vildvin_1_N = mkN "vildvin" neutrum  ; -- vildvin..nn.1
  vildvuxen_1_A = mkA "vildvuxen" ; -- vildvuxen..av.1
  vildväxande_1_A = mkA "vildväxande" ; -- vildväxande..av.1
  vildåsna_1_N = mkN "vildåsna" ; -- vildåsna..nn.1
  vilfåtölj_1_N = mkN "vilfåtölj" "vilfåtöljer" ; -- vilfåtölj..nn.1
  vilja_1_N = mkN "vilja" ; -- vilja..nn.1
  viljande_1_N = mkN "viljande" ; -- viljande..nn.1
  viljeakt_1_N = mkN "viljeakt" "viljeakter" ; -- viljeakt..nn.1
  viljeansats_1_N = mkN "viljeansats" "viljeansatser" ; -- viljeansats..nn.1
  viljeansträngning_1_N = mkN "viljeansträngning" ; -- viljeansträngning..nn.1
  viljeförklaring_1_N = mkN "viljeförklaring" ; -- viljeförklaring..nn.1
  viljeförlamning_1_N = mkN "viljeförlamning" ; -- viljeförlamning..nn.1
  viljehandling_1_N = mkN "viljehandling" ; -- viljehandling..nn.1
  viljeinriktning_1_N = mkN "viljeinriktning" ; -- viljeinriktning..nn.1
  viljekraft_1_N = mkN "viljekraft" ; -- viljekraft..nn.1
  viljekraftig_1_A = mkA "viljekraftig" ; -- viljekraftig..av.1
  viljelös_1_A = mkA "viljelös" ; -- viljelös..av.1
  viljelöshet_1_N = mkN "viljelöshet" ; -- viljelöshet..nn.1
  viljemänniska_1_N = mkN "viljemänniska" ; -- viljemänniska..nn.1
  viljemässig_1_A = mkA "viljemässig" ; -- viljemässig..av.1
  viljemässighet_1_N = mkN "viljemässighet" ; -- viljemässighet..nn.1
  viljeriktning_1_N = mkN "viljeriktning" ; -- viljeriktning..nn.1
  viljestark_1_A = mkA "viljestark" ; -- viljestark..av.1
  viljestarkhet_1_N = mkN "viljestarkhet" ; -- viljestarkhet..nn.1
  viljestyrka_1_N = mkN "viljestyrka" ; -- viljestyrka..nn.1
  viljesvag_1_A = mkA "viljesvag" ; -- viljesvag..av.1
  viljesvaghet_1_N = mkN "viljesvaghet" ; -- viljesvaghet..nn.1
  viljeyttring_1_N = mkN "viljeyttring" ; -- viljeyttring..nn.1
  villa_1_N = mkN "villa" ; -- villa..nn.1
  villa_2_N = mkN "villa" ; -- villa..nn.2
  villabrand_1_N = mkN "villabrand" "villabränder" ; -- villabrand..nn.1
  villabyggande_1_N = mkN "villabyggande" ; -- villabyggande..nn.1
  villabyggnadsraseri_1_N = mkN "villabyggnadsraseri" neutrum  ; -- villabyggnadsraseri..nn.1
  villakvarter_1_N = mkN "villakvarter" "villakvarteret" "villakvarter" "villakvarteren" ; -- villakvarter..nn.1
  villande_1_A = mkA "villande" ; -- villande..av.1
  villanell_1_N = mkN "villanell" "villaneller" ; -- villanell..nn.1
  villaområde_1_N = mkN "villaområde" ; -- villaområde..nn.1
  villapris_1_N = mkN "villapris" neutrum  ; -- villapris..nn.1
  villaservitut_1_N = mkN "villaservitut" neutrum  ; -- villaservitut..nn.1
  villastad_1_N = mkN "villastad" "villastäder" ; -- villastad..nn.1
  villatomt_1_N = mkN "villatomt" "villatomter" ; -- villatomt..nn.1
  villaägare_1_N = mkN "villaägare" utrum  ; -- villaägare..nn.1
  villebråd_1_N = mkN "villebråd" neutrum  ; -- villebråd..nn.1
  villervalla_1_N = mkN "villervalla" ; -- villervalla..nn.1
  villfara_1_V = mkV "villfara" "villfor" "villfarit" ; -- villfara..vb.1
  villfarande_1_N = mkN "villfarande" ; -- villfarande..nn.1
  villfarelse_1_N = mkN "villfarelse" "villfarelser" ; -- villfarelse..nn.1
  villfarig_1_A = mkA "villfarig" ; -- villfarig..av.1
  villig_1_A = mkA "villig" ; -- villig..av.1
  villighet_1_N = mkN "villighet" ; -- villighet..nn.1
  villkor_1_N = mkN "villkor" neutrum  ; -- villkor..nn.1
  villkora_1_V = mkV "villkorar" ; -- villkora..vb.1
  villkorande_1_N = mkN "villkorande" ; -- villkorande..nn.1
  villkorlig_1_A = mkA "villkorlig" ; -- villkorlig..av.1
  villkorlighet_1_N = mkN "villkorlighet" ; -- villkorlighet..nn.1
  villkorsbisats_1_N = mkN "villkorsbisats" "villkorsbisatser" ; -- villkorsbisats..nn.1
  villkorskonjunktion_1_N = mkN "villkorskonjunktion" ; -- villkorskonjunktion..nn.1
  villkorslös_1_A = mkA "villkorslös" ; -- villkorslös..av.1
  villkorslöshet_1_N = mkN "villkorslöshet" ; -- villkorslöshet..nn.1
  villkorssats_1_N = mkN "villkorssats" "villkorssatser" ; -- villkorssats..nn.1
  villolära_1_N = mkN "villolära" ; -- villolära..nn.1
  villospår_1_N = mkN "villospår" neutrum  ; -- villospår..nn.1
  villoväg_1_N = mkN "villoväg" ; -- villoväg..nn.1
  villrådig_1_A = mkA "villrådig" ; -- villrådig..av.1
  villrådighet_1_N = mkN "villrådighet" ; -- villrådighet..nn.1
  villsam_1_A = mkA "villsam" "villsamt" "villsamma" "villsamma" "villsammare" "villsammast" "villsammaste" ; -- villsam..av.1
  villsamhet_1_N = mkN "villsamhet" ; -- villsamhet..nn.1
  vilobädd_1_N = mkN "vilobädd" ; -- vilobädd..nn.1
  vilodag_1_N = mkN "vilodag" ; -- vilodag..nn.1
  vilohem_1_N = mkN "vilohem" "vilohemmet" "vilohem" "vilohemmen" ; -- vilohem..nn.1
  vilohemsvistelse_1_N = mkN "vilohemsvistelse" "vilohemsvistelser" ; -- vilohemsvistelse..nn.1
  viloläge_1_N = mkN "viloläge" ; -- viloläge..nn.1
  viloläger_1_N = mkN "viloläger" neutrum  ; -- viloläger..nn.1
  vilomassa_1_N = mkN "vilomassa" ; -- vilomassa..nn.1
  vilopaus_1_N = mkN "vilopaus" "vilopauser" ; -- vilopaus..nn.1
  viloplats_1_N = mkN "viloplats" "viloplatser" ; -- viloplats..nn.1
  vilopuls_1_N = mkN "vilopuls" ; -- vilopuls..nn.1
  vilopunkt_1_N = mkN "vilopunkt" "vilopunkter" ; -- vilopunkt..nn.1
  vilorum_1_N = mkN "vilorum" "vilorummet" "vilorum" "vilorummen" ; -- vilorum..nn.1
  vilostad_1_N = mkN "vilostad" ; -- vilostad..nn.1
  vilostadium_1_N = mkN "vilostadium" "vilostadiet" "vilostadier" "vilostadierna" ; -- vilostadium..nn.1
  vilrum_1_N = mkN "vilrum" "vilrummet" "vilrum" "vilrummen" ; -- vilrum..nn.1
  vilsam_1_A = mkA "vilsam" "vilsamt" "vilsamma" "vilsamma" "vilsammare" "vilsammast" "vilsammaste" ; -- vilsam..av.1
  vilsamhet_1_N = mkN "vilsamhet" ; -- vilsamhet..nn.1
  vilseföra_1_V = mkV "vilseföra" "vilseförde" "vilsefört" ; -- vilseföra..vb.1
  vilseförande_1_N = mkN "vilseförande" ; -- vilseförande..nn.1
  vilsegången_1_A = mkA "vilsegången" ; -- vilsegången..av.1
  vilsekommen_1_A = mkA "vilsekommen" "vilsekommet" "vilsekomna" "vilsekomna" "vilsekomnare" "vilsekomnast" "vilsekomnaste" ; -- vilsekommen..av.1
  vilseleda_1_V = mkV "vilseleda" "vilseledde" "vilselett" ; -- vilseleda..vb.1
  vilseledande_1_A = mkA "vilseledande" ; -- vilseledande..av.1
  vilseledande_1_N = mkN "vilseledande" ; -- vilseledande..nn.1
  vilseledning_1_N = mkN "vilseledning" ; -- vilseledning..nn.1
  vilsen_1_A = mkA "vilsen" ; -- vilsen..av.1
  vilstol_1_N = mkN "vilstol" ; -- vilstol..nn.1
  vilt_1_N = mkN "vilt" neutrum  ; -- vilt..nn.1
  viltbana_1_N = mkN "viltbana" ; -- viltbana..nn.1
  viltdjur_1_N = mkN "viltdjur" neutrum  ; -- viltdjur..nn.1
  vilthandlare_1_N = mkN "vilthandlare" utrum  ; -- vilthandlare..nn.1
  viltmålskytte_1_N = mkN "viltmålskytte" ; -- viltmålskytte..nn.1
  viltplantering_1_N = mkN "viltplantering" ; -- viltplantering..nn.1
  viltsmak_1_N = mkN "viltsmak" ; -- viltsmak..nn.1
  viltspegel_1_N = mkN "viltspegel" ; -- viltspegel..nn.1
  viltstråk_1_N = mkN "viltstråk" neutrum  ; -- viltstråk..nn.1
  viltstängsel_1_N = mkN "viltstängsel" neutrum  ; -- viltstängsel..nn.1
  viltvård_1_N = mkN "viltvård" ; -- viltvård..nn.1
  viltvårdare_1_N = mkN "viltvårdare" utrum  ; -- viltvårdare..nn.1
  vimba_1_N = mkN "vimba" ; -- vimba..nn.1
  vimla_1_V = mkV "vimlar" ; -- vimla..vb.1
  vimlande_1_N = mkN "vimlande" ; -- vimlande..nn.1
  vimma_1_N = mkN "vimma" ; -- vimma..nn.1
  vimmel_1_N = mkN "vimmel" neutrum  ; -- vimmel..nn.1
  vimmelkantig_1_A = mkA "vimmelkantig" ; -- vimmelkantig..av.1
  vimmelkantighet_1_N = mkN "vimmelkantighet" ; -- vimmelkantighet..nn.1
  vimpel_1_N = mkN "vimpel" ; -- vimpel..nn.1
  vimpelprydd_1_A = mkA "vimpelprydd" ; -- vimpelprydd..av.1
  vimperg_1_N = mkN "vimperg" "vimperger" ; -- vimperg..nn.1
  vimplad_1_A = mkA "vimplad" ; -- vimplad..av.1
  vimsa_1_V = mkV "vimsar" ; -- vimsa..vb.1
  vimsande_1_N = mkN "vimsande" ; -- vimsande..nn.1
  vimsig_1_A = mkA "vimsig" ; -- vimsig..av.1
  vimsighet_1_N = mkN "vimsighet" ; -- vimsighet..nn.1
  vin_1_N = mkN "vin" "vinet" "viner" "vinerna" ; -- vin..nn.1
  vin_2_N = mkN "vin" neutrum  ; -- vin..nn.2
  vin_3_N = mkN "vin" neutrum  ; -- vin..nn.3
  vina_1_N = mkN "vina" ; -- vina..nn.1
  vina_1_V = mkV "vina" "ven" "vinit" ; -- vina..vb.1
  vina_2_V = mkV "vinar" ; -- vina..vb.2
  vinalkoholist_1_N = mkN "vinalkoholist" "vinalkoholister" ; -- vinalkoholist..nn.1
  vinande_1_N = mkN "vinande" ; -- vinande..nn.1
  vinare_1_N = mkN "vinare" utrum  ; -- vinare..nn.1
  vinberg_1_N = mkN "vinberg" neutrum  ; -- vinberg..nn.1
  vinbergssnäcka_1_N = mkN "vinbergssnäcka" ; -- vinbergssnäcka..nn.1
  vinblad_1_N = mkN "vinblad" neutrum  ; -- vinblad..nn.1
  vinbladsdolma_1_N = mkN "vinbladsdolma" "vinbladsdolman" "vinbladsdolmar" "vinbladsdolmarna" ; -- vinbladsdolma..nn.1
  vinbonde_1_N = mkN "vinbonde" "vinbönder" ; -- vinbonde..nn.1
  vinbransch_1_N = mkN "vinbransch" ; -- vinbransch..nn.1
  vinbär_1_N = mkN "vinbär" neutrum  ; -- vinbär..nn.1
  vinbärsbuske_1_N = mkN "vinbärsbuske" utrum  ; -- vinbärsbuske..nn.1
  vinbärssaft_1_N = mkN "vinbärssaft" "vinbärssafter" ; -- vinbärssaft..nn.1
  vinbål_1_N = mkN "vinbål" ; -- vinbål..nn.1
  vind_1_A = mkA "vind" ; -- vind..av.1
  vind_1_N = mkN "vind" ; -- vind..nn.1
  vind_2_N = mkN "vind" ; -- vind..nn.2
  vinda_1_N = mkN "vinda" ; -- vinda..nn.1
  vinda_1_V = mkV "vindar" ; -- vinda..vb.1
  vindande_1_N = mkN "vindande" ; -- vindande..nn.1
  vindblomma_1_N = mkN "vindblomma" ; -- vindblomma..nn.1
  vindbro_1_N = mkN "vindbro" ; -- vindbro..nn.1
  vindbrygga_1_N = mkN "vindbrygga" ; -- vindbrygga..nn.1
  vindby_1_N = mkN "vindby" "vindbyn" "vindbyar" "vindbyarna" ; -- vindby..nn.1
  vindbälte_1_N = mkN "vindbälte" ; -- vindbälte..nn.1
  vindböjtel_1_N = mkN "vindböjtel" ; -- vindböjtel..nn.1
  vinddrag_1_N = mkN "vinddrag" neutrum  ; -- vinddrag..nn.1
  vinddriven_1_A = mkA "vinddriven" ; -- vinddriven..av.1
  vinddriven_2_A = mkA "vinddriven" ; -- vinddriven..av.2
  vindel_1_N = mkN "vindel" ; -- vindel..nn.1
  vindeltrappa_1_N = mkN "vindeltrappa" ; -- vindeltrappa..nn.1
  vindfläkt_1_N = mkN "vindfläkt" ; -- vindfläkt..nn.1
  vindflöjel_1_N = mkN "vindflöjel" ; -- vindflöjel..nn.1
  vindfälle_1_N = mkN "vindfälle" ; -- vindfälle..nn.1
  vindfång_1_N = mkN "vindfång" neutrum  ; -- vindfång..nn.1
  vindförhållande_1_N = mkN "vindförhållande" ; -- vindförhållande..nn.1
  vindhastighet_1_N = mkN "vindhastighet" "vindhastigheter" ; -- vindhastighet..nn.1
  vindhet_1_N = mkN "vindhet" ; -- vindhet..nn.1
  vindicera_1_V = mkV "vindicerar" ; -- vindicera..vb.1
  vindicerande_1_N = mkN "vindicerande" ; -- vindicerande..nn.1
  vindicerbar_1_A = mkA "vindicerbar" ; -- vindicerbar..av.1
  vindicerbarhet_1_N = mkN "vindicerbarhet" ; -- vindicerbarhet..nn.1
  vindicering_1_N = mkN "vindicering" ; -- vindicering..nn.1
  vindikation_1_N = mkN "vindikation" ; -- vindikation..nn.1
  vindil_1_N = mkN "vindil" ; -- vindil..nn.1
  vindindustri_1_N = mkN "vindindustri" "vindindustrier" ; -- vindindustri..nn.1
  vindindustrilobby_1_N = mkN "vindindustrilobby" "vindindustrilobbyer" ; -- vindindustrilobby..nn.1
  vindjacka_1_N = mkN "vindjacka" ; -- vindjacka..nn.1
  vindkantring_1_N = mkN "vindkantring" ; -- vindkantring..nn.1
  vindkast_1_N = mkN "vindkast" neutrum  ; -- vindkast..nn.1
  vindkraft_1_N = mkN "vindkraft" ; -- vindkraft..nn.1
  vindkraftsbolag_1_N = mkN "vindkraftsbolag" neutrum  ; -- vindkraftsbolag..nn.1
  vindkraftsbygge_1_N = mkN "vindkraftsbygge" ; -- vindkraftsbygge..nn.1
  vindkraftutbyggnad_1_N = mkN "vindkraftutbyggnad" ; -- vindkraftutbyggnad..nn.1
  vindkraftverk_1_N = mkN "vindkraftverk" neutrum  ; -- vindkraftverk..nn.1
  vindkåre_1_N = mkN "vindkåre" utrum  ; -- vindkåre..nn.1
  vindla_1_V = mkV "vindlar" ; -- vindla..vb.1
  vindlande_1_N = mkN "vindlande" ; -- vindlande..nn.1
  vindling_1_N = mkN "vindling" ; -- vindling..nn.1
  vindmätare_1_N = mkN "vindmätare" utrum  ; -- vindmätare..nn.1
  vindmätning_1_N = mkN "vindmätning" ; -- vindmätning..nn.1
  vindmätningsinstrument_1_N = mkN "vindmätningsinstrument" neutrum  ; -- vindmätningsinstrument..nn.1
  vindning_1_N = mkN "vindning" ; -- vindning..nn.1
  vindpinad_1_A = mkA "vindpinad" ; -- vindpinad..av.1
  vindpollinera_1_V = mkV "vindpollinerar" ; -- vindpollinera..vb.1
  vindpollinerande_1_N = mkN "vindpollinerande" ; -- vindpollinerande..nn.1
  vindpollinerbar_1_A = mkA "vindpollinerbar" ; -- vindpollinerbar..av.1
  vindpollinerbarhet_1_N = mkN "vindpollinerbarhet" ; -- vindpollinerbarhet..nn.1
  vindpollinering_1_N = mkN "vindpollinering" ; -- vindpollinering..nn.1
  vindpust_1_N = mkN "vindpust" ; -- vindpust..nn.1
  vindriktning_1_N = mkN "vindriktning" ; -- vindriktning..nn.1
  vindros_1_N = mkN "vindros" "vindrosor" ; -- vindros..nn.1
  vindrufs_1_N = mkN "vindrufs" neutrum  ; -- vindrufs..nn.1
  vindruta_1_N = mkN "vindruta" ; -- vindruta..nn.1
  vindruteskydd_1_N = mkN "vindruteskydd" neutrum  ; -- vindruteskydd..nn.1
  vindrutespolare_1_N = mkN "vindrutespolare" utrum  ; -- vindrutespolare..nn.1
  vindrutetorkare_1_N = mkN "vindrutetorkare" utrum  ; -- vindrutetorkare..nn.1
  vindruva_1_N = mkN "vindruva" ; -- vindruva..nn.1
  vindsbrand_1_N = mkN "vindsbrand" "vindsbränder" ; -- vindsbrand..nn.1
  vindsida_1_N = mkN "vindsida" ; -- vindsida..nn.1
  vindskala_1_N = mkN "vindskala" ; -- vindskala..nn.1
  vindskammare_1_N = mkN "vindskammare" "vindskammaren" "vindskammare" "vindskamrarna" ; -- vindskammare..nn.1
  vindskida_1_N = mkN "vindskida" ; -- vindskida..nn.1
  vindskifte_1_N = mkN "vindskifte" ; -- vindskifte..nn.1
  vindskiva_1_N = mkN "vindskiva" ; -- vindskiva..nn.1
  vindskontor_1_N = mkN "vindskontor" neutrum  ; -- vindskontor..nn.1
  vindskupa_1_N = mkN "vindskupa" ; -- vindskupa..nn.1
  vindskydd_1_N = mkN "vindskydd" neutrum  ; -- vindskydd..nn.1
  vindskyddad_1_A = mkA "vindskyddad" ; -- vindskyddad..av.1
  vindskärm_1_N = mkN "vindskärm" ; -- vindskärm..nn.1
  vindsopad_1_A = mkA "vindsopad" ; -- vindsopad..av.1
  vindspel_1_N = mkN "vindspel" "vindspelet" "vindspel" "vindspelen" ; -- vindspel..nn.1
  vindstilla_1_A = mkA "vindstilla" ; -- vindstilla..av.1
  vindstilla_1_N = mkN "vindstilla" ; -- vindstilla..nn.1
  vindstrappa_1_N = mkN "vindstrappa" ; -- vindstrappa..nn.1
  vindstråk_1_N = mkN "vindstråk" neutrum  ; -- vindstråk..nn.1
  vindstyrka_1_N = mkN "vindstyrka" ; -- vindstyrka..nn.1
  vindstöt_1_N = mkN "vindstöt" ; -- vindstöt..nn.1
  vindsurfa_1_V = mkV "vindsurfar" ; -- vindsurfa..vb.1
  vindsurfande_1_N = mkN "vindsurfande" ; -- vindsurfande..nn.1
  vindsus_1_N = mkN "vindsus" neutrum  ; -- vindsus..nn.1
  vindsutrymme_1_N = mkN "vindsutrymme" ; -- vindsutrymme..nn.1
  vindtunnel_1_N = mkN "vindtunnel" ; -- vindtunnel..nn.1
  vindtyg_1_N = mkN "vindtyg" neutrum  ; -- vindtyg..nn.1
  vindtygsjacka_1_N = mkN "vindtygsjacka" ; -- vindtygsjacka..nn.1
  vindtät_1_A = mkA "vindtät" ; -- vindtät..av.1
  vindvridning_1_N = mkN "vindvridning" ; -- vindvridning..nn.1
  vindägg_1_N = mkN "vindägg" neutrum  ; -- vindägg..nn.1
  vindändring_1_N = mkN "vindändring" ; -- vindändring..nn.1
  vindöga_1_N = mkN "vindöga" "vindögat" "vindögon" "vindögonen" ; -- vindöga..nn.1
  vindögd_1_A = mkA "vindögd" "vindögt" ; -- vindögd..av.1
  vindögdhet_1_N = mkN "vindögdhet" ; -- vindögdhet..nn.1
  vineri_1_N = mkN "vineri" "vineriet" "vinerier" "vinerierna" ; -- vineri..nn.1
  vinfest_1_N = mkN "vinfest" "vinfester" ; -- vinfest..nn.1
  vinflaska_1_N = mkN "vinflaska" ; -- vinflaska..nn.1
  vinfärgad_1_A = mkA "vinfärgad" ; -- vinfärgad..av.1
  ving_1_N = mkN "ving" ; -- ving..nn.1
  vingad_1_A = mkA "vingad" ; -- vingad..av.1
  vingbredd_1_N = mkN "vingbredd" "vingbredder" ; -- vingbredd..nn.1
  vingbrus_1_N = mkN "vingbrus" neutrum  ; -- vingbrus..nn.1
  vingbruten_1_A = mkA "vingbruten" ; -- vingbruten..av.1
  vinge_1_N = mkN "vinge" utrum  ; -- vinge..nn.1
  vingel_1_N = mkN "vingel" neutrum  ; -- vingel..nn.1
  vingelpelle_1_N = mkN "vingelpelle" utrum  ; -- vingelpelle..nn.1
  vingfrukt_1_N = mkN "vingfrukt" "vingfrukter" ; -- vingfrukt..nn.1
  vingglidning_1_N = mkN "vingglidning" ; -- vingglidning..nn.1
  vingklaff_1_N = mkN "vingklaff" ; -- vingklaff..nn.1
  vingklippa_1_V = mkV "vingklipper" ; -- vingklippa..vb.1
  vingklippande_1_N = mkN "vingklippande" ; -- vingklippande..nn.1
  vingklippning_1_N = mkN "vingklippning" ; -- vingklippning..nn.1
  vingla_1_V = mkV "vinglar" ; -- vingla..vb.1
  vinglande_1_N = mkN "vinglande" ; -- vinglande..nn.1
  vinglare_1_N = mkN "vinglare" utrum  ; -- vinglare..nn.1
  vinglas_1_N = mkN "vinglas" neutrum  ; -- vinglas..nn.1
  vingleri_1_N = mkN "vingleri" neutrum  ; -- vingleri..nn.1
  vinglig_1_A = mkA "vinglig" ; -- vinglig..av.1
  vinglighet_1_N = mkN "vinglighet" ; -- vinglighet..nn.1
  vinglös_1_A = mkA "vinglös" ; -- vinglös..av.1
  vinglöshet_1_N = mkN "vinglöshet" ; -- vinglöshet..nn.1
  vingman_1_N = mkN "vingman" "vingmannen" "vingmän" "vingmännen" ; -- vingman..nn.1
  vingmutter_1_N = mkN "vingmutter" ; -- vingmutter..nn.1
  vingpenna_1_N = mkN "vingpenna" ; -- vingpenna..nn.1
  vingplog_1_N = mkN "vingplog" ; -- vingplog..nn.1
  vingskjuta_1_V = mkV "vingskjuta" "vingsköt" "vingskjutit" ; -- vingskjuta..vb.1
  vingskjutande_1_N = mkN "vingskjutande" ; -- vingskjutande..nn.1
  vingskjuten_1_A = mkA "vingskjuten" ; -- vingskjuten..av.1
  vingskjutning_1_N = mkN "vingskjutning" ; -- vingskjutning..nn.1
  vingslag_1_N = mkN "vingslag" neutrum  ; -- vingslag..nn.1
  vingspann_1_N = mkN "vingspann" neutrum  ; -- vingspann..nn.1
  vingspegel_1_N = mkN "vingspegel" ; -- vingspegel..nn.1
  vingspets_1_N = mkN "vingspets" ; -- vingspets..nn.1
  vingteckning_1_N = mkN "vingteckning" ; -- vingteckning..nn.1
  vingtäckare_1_N = mkN "vingtäckare" utrum  ; -- vingtäckare..nn.1
  vingud_1_N = mkN "vingud" ; -- vingud..nn.1
  vingummi_1_N = mkN "vingummi" "vingummit" "vingummin" "vingummina" ; -- vingummi..nn.1
  vingård_1_N = mkN "vingård" ; -- vingård..nn.1
  vingårdsarbetare_1_N = mkN "vingårdsarbetare" utrum  ; -- vingårdsarbetare..nn.1
  vingårdsman_1_N = mkN "vingårdsman" "vingårdsmannen" "vingårdsmän" "vingårdsmännen" ; -- vingårdsman..nn.1
  vingöra_1_N = mkN "vingöra" "vingörat" "vingöron" "vingöronen" ; -- vingöra..nn.1
  vinjett_1_N = mkN "vinjett" "vinjetter" ; -- vinjett..nn.1
  vinjäst_1_N = mkN "vinjäst" ; -- vinjäst..nn.1
  vink_1_N = mkN "vink" ; -- vink..nn.1
  vinka_1_V = mkV "vinkar" ; -- vinka..vb.1
  vinkande_1_N = mkN "vinkande" ; -- vinkande..nn.1
  vinkaraff_1_N = mkN "vinkaraff" "vinkaraffer" ; -- vinkaraff..nn.1
  vinkel_1_N = mkN "vinkel" ; -- vinkel..nn.1
  vinkelacceleration_1_N = mkN "vinkelacceleration" ; -- vinkelacceleration..nn.1
  vinkelarm_1_N = mkN "vinkelarm" ; -- vinkelarm..nn.1
  vinkelavstånd_1_N = mkN "vinkelavstånd" neutrum  ; -- vinkelavstånd..nn.1
  vinkelben_1_N = mkN "vinkelben" neutrum  ; -- vinkelben..nn.1
  vinkelbeslag_1_N = mkN "vinkelbeslag" neutrum  ; -- vinkelbeslag..nn.1
  vinkelborr_1_N = mkN "vinkelborr" ; -- vinkelborr..nn.1
  vinkelformad_1_A = mkA "vinkelformad" ; -- vinkelformad..av.1
  vinkelhake_1_N = mkN "vinkelhake" utrum  ; -- vinkelhake..nn.1
  vinkelhastighet_1_N = mkN "vinkelhastighet" "vinkelhastigheter" ; -- vinkelhastighet..nn.1
  vinkelhus_1_N = mkN "vinkelhus" neutrum  ; -- vinkelhus..nn.1
  vinkeljärn_1_N = mkN "vinkeljärn" neutrum  ; -- vinkeljärn..nn.1
  vinkelknä_1_N = mkN "vinkelknä" "vinkelknät" "vinkelknän" "vinkelknäna" ; -- vinkelknä..nn.1
  vinkellinjal_1_N = mkN "vinkellinjal" "vinkellinjaler" ; -- vinkellinjal..nn.1
  vinkelmätare_1_N = mkN "vinkelmätare" utrum  ; -- vinkelmätare..nn.1
  vinkelmått_1_N = mkN "vinkelmått" neutrum  ; -- vinkelmått..nn.1
  vinkelpredikant_1_N = mkN "vinkelpredikant" "vinkelpredikanter" ; -- vinkelpredikant..nn.1
  vinkelroller_1_N = mkN "vinkelroller" ; -- vinkelroller..nn.1
  vinkelrät_1_A = mkA "vinkelrät" ; -- vinkelrät..av.1
  vinkelskillnad_1_N = mkN "vinkelskillnad" "vinkelskillnader" ; -- vinkelskillnad..nn.1
  vinkelslip_1_N = mkN "vinkelslip" ; -- vinkelslip..nn.1
  vinkelspets_1_N = mkN "vinkelspets" ; -- vinkelspets..nn.1
  vinkelsumma_1_N = mkN "vinkelsumma" ; -- vinkelsumma..nn.1
  vinkla_1_V = mkV "vinklar" ; -- vinkla..vb.1
  vinklande_1_N = mkN "vinklande" ; -- vinklande..nn.1
  vinkling_1_N = mkN "vinkling" ; -- vinkling..nn.1
  vinkning_1_N = mkN "vinkning" ; -- vinkning..nn.1
  vinkonsumtion_1_N = mkN "vinkonsumtion" ; -- vinkonsumtion..nn.1
  vinkork_1_N = mkN "vinkork" ; -- vinkork..nn.1
  vinkännare_1_N = mkN "vinkännare" utrum  ; -- vinkännare..nn.1
  vinland_1_N = mkN "vinland" "vinlandet" "vinländer" "vinländerna" ; -- vinland..nn.1
  vinlista_1_N = mkN "vinlista" ; -- vinlista..nn.1
  vinlus_1_N = mkN "vinlus" "vinlusen" "vinlöss" "vinlössen" ; -- vinlus..nn.1
  vinlöv_1_N = mkN "vinlöv" neutrum  ; -- vinlöv..nn.1
  vinmakare_1_N = mkN "vinmakare" utrum  ; -- vinmakare..nn.1
  vinmärke_1_N = mkN "vinmärke" ; -- vinmärke..nn.1
  vinna_1_V = mkV "vinna" "vann" "vunnit" ; -- vinna..vb.1
  vinnande_1_A = mkA "vinnande" ; -- vinnande..av.1
  vinnande_1_N = mkN "vinnande" ; -- vinnande..nn.1
  vinnare_1_N = mkN "vinnare" utrum  ; -- vinnare..nn.1
  vinnarhål_1_N = mkN "vinnarhål" neutrum  ; -- vinnarhål..nn.1
  vinnarinstinkt_1_N = mkN "vinnarinstinkt" "vinnarinstinkter" ; -- vinnarinstinkt..nn.1
  vinnarpotential_1_N = mkN "vinnarpotential" "vinnarpotentialer" ; -- vinnarpotential..nn.1
  vinnarskalle_1_N = mkN "vinnarskalle" utrum  ; -- vinnarskalle..nn.1
  vinning_1_N = mkN "vinning" ; -- vinning..nn.1
  vinningslysten_1_A = mkA "vinningslysten" ; -- vinningslysten..av.1
  vinningslystnad_1_N = mkN "vinningslystnad" "vinningslystnader" ; -- vinningslystnad..nn.1
  vinodlare_1_N = mkN "vinodlare" utrum  ; -- vinodlare..nn.1
  vinodling_1_N = mkN "vinodling" ; -- vinodling..nn.1
  vinodlingskunnig_1_A = mkA "vinodlingskunnig" ; -- vinodlingskunnig..av.1
  vinorganisation_1_N = mkN "vinorganisation" ; -- vinorganisation..nn.1
  vinproducent_1_N = mkN "vinproducent" "vinproducenter" ; -- vinproducent..nn.1
  vinproduktion_1_N = mkN "vinproduktion" ; -- vinproduktion..nn.1
  vinprovning_1_N = mkN "vinprovning" ; -- vinprovning..nn.1
  vinranka_1_N = mkN "vinranka" ; -- vinranka..nn.1
  vinruta_1_N = mkN "vinruta" ; -- vinruta..nn.1
  vinrättighet_1_N = mkN "vinrättighet" "vinrättigheter" ; -- vinrättighet..nn.1
  vinröd_1_A = mkA "vinröd" "vinrött" ; -- vinröd..av.1
  vinsch_1_N = mkN "vinsch" ; -- vinsch..nn.1
  vinscha_1_V = mkV "vinschar" ; -- vinscha..vb.1
  vinschande_1_N = mkN "vinschande" ; -- vinschande..nn.1
  vinservering_1_N = mkN "vinservering" ; -- vinservering..nn.1
  vinskänk_1_N = mkN "vinskänk" ; -- vinskänk..nn.1
  vinskörd_1_N = mkN "vinskörd" ; -- vinskörd..nn.1
  vinsort_1_N = mkN "vinsort" "vinsorter" ; -- vinsort..nn.1
  vinst_1_N = mkN "vinst" "vinster" ; -- vinst..nn.1
  vinstandel_1_N = mkN "vinstandel" "vinstandelen" "vinstandelar" "vinstandelarna" ; -- vinstandel..nn.1
  vinstbegär_1_N = mkN "vinstbegär" neutrum  ; -- vinstbegär..nn.1
  vinstbringande_1_A = mkA "vinstbringande" ; -- vinstbringande..av.1
  vinstchans_1_N = mkN "vinstchans" "vinstchanser" ; -- vinstchans..nn.1
  vinstdela_1_V = mkV "vinstdelar" ; -- vinstdela..vb.1
  vinstdelande_1_N = mkN "vinstdelande" ; -- vinstdelande..nn.1
  vinstdelning_1_N = mkN "vinstdelning" ; -- vinstdelning..nn.1
  vinstdelningsskatt_1_N = mkN "vinstdelningsskatt" "vinstdelningsskatter" ; -- vinstdelningsskatt..nn.1
  vinstdrivande_1_A = mkA "vinstdrivande" ; -- vinstdrivande..av.1
  vinstdriven_1_A = mkA "vinstdriven" ; -- vinstdriven..av.1
  vinstgivande_1_A = mkA "vinstgivande" ; -- vinstgivande..av.1
  vinstintresse_1_N = mkN "vinstintresse" ; -- vinstintresse..nn.1
  vinstkalkyl_1_N = mkN "vinstkalkyl" "vinstkalkyler" ; -- vinstkalkyl..nn.1
  vinstlista_1_N = mkN "vinstlista" ; -- vinstlista..nn.1
  vinstlott_1_N = mkN "vinstlott" "vinstlotter" ; -- vinstlott..nn.1
  vinstmarginal_1_N = mkN "vinstmarginal" "vinstmarginaler" ; -- vinstmarginal..nn.1
  vinstmaskin_1_N = mkN "vinstmaskin" "vinstmaskiner" ; -- vinstmaskin..nn.1
  vinstmaximera_1_V = mkV "vinstmaximerar" ; -- vinstmaximera..vb.1
  vinstmaximerande_1_N = mkN "vinstmaximerande" ; -- vinstmaximerande..nn.1
  vinstmaximerbar_1_A = mkA "vinstmaximerbar" ; -- vinstmaximerbar..av.1
  vinstmaximerbarhet_1_N = mkN "vinstmaximerbarhet" ; -- vinstmaximerbarhet..nn.1
  vinstminskning_1_N = mkN "vinstminskning" ; -- vinstminskning..nn.1
  vinstnummer_1_N = mkN "vinstnummer" neutrum  ; -- vinstnummer..nn.1
  vinstock_1_N = mkN "vinstock" ; -- vinstock..nn.1
  vinstplan_1_N = mkN "vinstplan" "vinstplaner" ; -- vinstplan..nn.1
  vinstras_1_N = mkN "vinstras" neutrum  ; -- vinstras..nn.1
  vinstrik_1_A = mkA "vinstrik" ; -- vinstrik..av.1
  vinstsyfte_1_N = mkN "vinstsyfte" ; -- vinstsyfte..nn.1
  vinstuga_1_N = mkN "vinstuga" ; -- vinstuga..nn.1
  vinstutdelning_1_N = mkN "vinstutdelning" ; -- vinstutdelning..nn.1
  vinstvarna_1_V = mkV "vinstvarnar" ; -- vinstvarna..vb.1
  vinstvarnande_1_N = mkN "vinstvarnande" ; -- vinstvarnande..nn.1
  vinstvarning_1_N = mkN "vinstvarning" ; -- vinstvarning..nn.1
  vinsyra_1_N = mkN "vinsyra" ; -- vinsyra..nn.1
  vintagevin_1_N = mkN "vintagevin" "vintagevinet" "vintageviner" "vintagevinerna" ; -- vintagevin..nn.1
  vinter_1_N = mkN "vinter" ; -- vinter..nn.1
  vinteraktig_1_A = mkA "vinteraktig" ; -- vinteraktig..av.1
  vinterbad_1_N = mkN "vinterbad" neutrum  ; -- vinterbad..nn.1
  vinterbada_1_V = mkV "vinterbadar" ; -- vinterbada..vb.1
  vinterbadande_1_N = mkN "vinterbadande" ; -- vinterbadande..nn.1
  vinterbadare_1_N = mkN "vinterbadare" utrum  ; -- vinterbadare..nn.1
  vinterblå_1_A = mkA "vinterblå" "vinterblått" ; -- vinterblå..av.1
  vinterbona_1_V = mkV "vinterbonar" ; -- vinterbona..vb.1
  vinterbonande_1_N = mkN "vinterbonande" ; -- vinterbonande..nn.1
  vinterbostad_1_N = mkN "vinterbostad" "vinterbostäder" ; -- vinterbostad..nn.1
  vintercykla_1_V = mkV "vintercyklar" ; -- vintercykla..vb.1
  vintercyklande_1_N = mkN "vintercyklande" ; -- vintercyklande..nn.1
  vintercykling_1_N = mkN "vintercykling" ; -- vintercykling..nn.1
  vinterdag_1_N = mkN "vinterdag" ; -- vinterdag..nn.1
  vinterdräkt_1_N = mkN "vinterdräkt" "vinterdräkter" ; -- vinterdräkt..nn.1
  vinterdvala_1_N = mkN "vinterdvala" ; -- vinterdvala..nn.1
  vinterdäck_1_N = mkN "vinterdäck" neutrum  ; -- vinterdäck..nn.1
  vintereftermiddag_1_N = mkN "vintereftermiddag" ; -- vintereftermiddag..nn.1
  vinterfarkost_1_N = mkN "vinterfarkost" "vinterfarkoster" ; -- vinterfarkost..nn.1
  vinterfiskare_1_N = mkN "vinterfiskare" utrum  ; -- vinterfiskare..nn.1
  vinterfiske_1_N = mkN "vinterfiske" ; -- vinterfiske..nn.1
  vinterfoder_1_N = mkN "vinterfoder" neutrum  ; -- vinterfoder..nn.1
  vinterfrukt_1_N = mkN "vinterfrukt" "vinterfrukter" ; -- vinterfrukt..nn.1
  vinterförråd_1_N = mkN "vinterförråd" neutrum  ; -- vinterförråd..nn.1
  vintergata_1_N = mkN "vintergata" ; -- vintergata..nn.1
  vintergrön_1_A = mkA "vintergrön" ; -- vintergrön..av.1
  vintergröna_1_N = mkN "vintergröna" ; -- vintergröna..nn.1
  vintergrönt_1_N = mkN "vintergrönt" ; -- vintergrönt..nn.1
  vintergäck_1_N = mkN "vintergäck" ; -- vintergäck..nn.1
  vinterhalvår_1_N = mkN "vinterhalvår" neutrum  ; -- vinterhalvår..nn.1
  vinterhamn_1_N = mkN "vinterhamn" ; -- vinterhamn..nn.1
  vinterhimmel_1_N = mkN "vinterhimmel" ; -- vinterhimmel..nn.1
  vinterhämpling_1_N = mkN "vinterhämpling" ; -- vinterhämpling..nn.1
  vinterhärdig_1_A = mkA "vinterhärdig" ; -- vinterhärdig..av.1
  vinterhärdighet_1_N = mkN "vinterhärdighet" ; -- vinterhärdighet..nn.1
  vinteridrott_1_N = mkN "vinteridrott" "vinteridrotter" ; -- vinteridrott..nn.1
  vinteridrottare_1_N = mkN "vinteridrottare" utrum  ; -- vinteridrottare..nn.1
  vinterkampanj_1_N = mkN "vinterkampanj" "vinterkampanjer" ; -- vinterkampanj..nn.1
  vinterklädd_1_A = mkA "vinterklädd" ; -- vinterklädd..av.1
  vinterkrig_1_N = mkN "vinterkrig" neutrum  ; -- vinterkrig..nn.1
  vinterkräk_1_N = mkN "vinterkräk" ; -- vinterkräk..nn.1
  vinterkräksjuka_1_N = mkN "vinterkräksjuka" ; -- vinterkräksjuka..nn.1
  vinterkvarter_1_N = mkN "vinterkvarter" "vinterkvarteret" "vinterkvarter" "vinterkvarteren" ; -- vinterkvarter..nn.1
  vinterkväll_1_N = mkN "vinterkväll" ; -- vinterkväll..nn.1
  vinterkyla_1_N = mkN "vinterkyla" ; -- vinterkyla..nn.1
  vinterköld_1_N = mkN "vinterköld" ; -- vinterköld..nn.1
  vinterlandskap_1_N = mkN "vinterlandskap" neutrum  ; -- vinterlandskap..nn.1
  vinterlek_1_N = mkN "vinterlek" ; -- vinterlek..nn.1
  vinterleksak_1_N = mkN "vinterleksak" "vinterleksaker" ; -- vinterleksak..nn.1
  vinterlig_1_A = mkA "vinterlig" ; -- vinterlig..av.1
  vinterliggare_1_N = mkN "vinterliggare" utrum  ; -- vinterliggare..nn.1
  vinterlighet_1_N = mkN "vinterlighet" ; -- vinterlighet..nn.1
  vinterlov_1_N = mkN "vinterlov" neutrum  ; -- vinterlov..nn.1
  vintermys_1_N = mkN "vintermys" neutrum  ; -- vintermys..nn.1
  vintermånad_1_N = mkN "vintermånad" "vintermånader" ; -- vintermånad..nn.1
  vintermörker_1_N = mkN "vintermörker" neutrum  ; -- vintermörker..nn.1
  vinternatt_1_N = mkN "vinternatt" "vinternätter" ; -- vinternatt..nn.1
  vinterny_1_N = mkN "vinterny" ; -- vinterny..nn.1
  vinterpäron_1_N = mkN "vinterpäron" neutrum  ; -- vinterpäron..nn.1
  vinterskinn_1_N = mkN "vinterskinn" neutrum  ; -- vinterskinn..nn.1
  vintersol_1_N = mkN "vintersol" ; -- vintersol..nn.1
  vintersolstånd_1_N = mkN "vintersolstånd" neutrum  ; -- vintersolstånd..nn.1
  vinterspel_1_N = mkN "vinterspel" "vinterspelet" "vinterspel" "vinterspelen" ; -- vinterspel..nn.1
  vintersport_1_N = mkN "vintersport" "vintersporter" ; -- vintersport..nn.1
  vinterspårvagn_1_N = mkN "vinterspårvagn" ; -- vinterspårvagn..nn.1
  vinterstjärna_1_N = mkN "vinterstjärna" ; -- vinterstjärna..nn.1
  vinterstånd_1_N = mkN "vinterstånd" neutrum  ; -- vinterstånd..nn.1
  vinterstövel_1_N = mkN "vinterstövel" ; -- vinterstövel..nn.1
  vintersäd_1_N = mkN "vintersäd" ; -- vintersäd..nn.1
  vintersömn_1_N = mkN "vintersömn" ; -- vintersömn..nn.1
  vintertid_1_Adv = mkAdv "vintertid" ; -- vintertid..ab.1
  vintertid_1_N = mkN "vintertid" ; -- vintertid..nn.1
  vinterträdgård_1_N = mkN "vinterträdgård" ; -- vinterträdgård..nn.1
  vintertrötthet_1_N = mkN "vintertrötthet" "vintertröttheter" ; -- vintertrötthet..nn.1
  vintervila_1_N = mkN "vintervila" ; -- vintervila..nn.1
  vinterväder_1_N = mkN "vinterväder" neutrum  ; -- vinterväder..nn.1
  vinterväg_1_N = mkN "vinterväg" ; -- vinterväg..nn.1
  vinterväghålla_1_V = mkV "vinterväghålla" "vinterväghöll" "vinterväghållit" ; -- vinterväghålla..vb.1
  vinterväglag_1_N = mkN "vinterväglag" neutrum  ; -- vinterväglag..nn.1
  vinteräpple_1_N = mkN "vinteräpple" ; -- vinteräpple..nn.1
  vinthund_1_N = mkN "vinthund" ; -- vinthund..nn.1
  vintillverkning_1_N = mkN "vintillverkning" ; -- vintillverkning..nn.1
  vintrig_1_A = mkA "vintrig" ; -- vintrig..av.1
  vintrighet_1_N = mkN "vintrighet" ; -- vintrighet..nn.1
  vinyl_1_N = mkN "vinyl" ; -- vinyl..nn.1
  vinyl_2_N = mkN "vinyl" "vinyler" ; -- vinyl..nn.2
  vinylglans_1_N = mkN "vinylglans" ; -- vinylglans..nn.1
  vinylklorid_1_N = mkN "vinylklorid" ; -- vinylklorid..nn.1
  vinäger_1_N = mkN "vinäger" ; -- vinäger..nn.1
  vinägrett_1_N = mkN "vinägrett" ; -- vinägrett..nn.1
  vinättika_1_N = mkN "vinättika" ; -- vinättika..nn.1
  vinår_1_N = mkN "vinår" neutrum  ; -- vinår..nn.1
  viol_1_N = mkN "viol" "violer" ; -- viol..nn.1
  viola_1_N = mkN "viola" ; -- viola..nn.1
  violblå_1_A = mkA "violblå" "violblått" ; -- violblå..av.1
  violdoft_1_N = mkN "violdoft" ; -- violdoft..nn.1
  violett_1_A = mkA "violett" ; -- violett..av.1
  violin_1_N = mkN "violin" "violiner" ; -- violin..nn.1
  violinist_1_N = mkN "violinist" "violinister" ; -- violinist..nn.1
  violinklav_1_N = mkN "violinklav" "violinklaver" ; -- violinklav..nn.1
  violoncell_1_N = mkN "violoncell" "violonceller" ; -- violoncell..nn.1
  violoncellist_1_N = mkN "violoncellist" "violoncellister" ; -- violoncellist..nn.1
  vip_1_N = mkN "vip" ; -- vip..nn.1
  vipa_1_N = mkN "vipa" ; -- vipa..nn.1
  vipp_1_N = mkN "vipp" ; -- vipp..nn.1
  vippa_1_N = mkN "vippa" ; -- vippa..nn.1
  vippa_1_V = mkV "vippar" ; -- vippa..vb.1
  vippa_2_V = mkV "vippar" ; -- vippa..vb.2
  vippande_1_N = mkN "vippande" ; -- vippande..nn.1
  vipparm_1_N = mkN "vipparm" ; -- vipparm..nn.1
  vippbräda_1_N = mkN "vippbräda" ; -- vippbräda..nn.1
  vippbräde_1_N = mkN "vippbräde" ; -- vippbräde..nn.1
  vippig_1_A = mkA "vippig" ; -- vippig..av.1
  vippighet_1_N = mkN "vippighet" ; -- vippighet..nn.1
  vippkoppling_1_N = mkN "vippkoppling" ; -- vippkoppling..nn.1
  vippstjärt_1_N = mkN "vippstjärt" ; -- vippstjärt..nn.1
  viprum_1_N = mkN "viprum" "viprummet" "viprum" "viprummen" ; -- viprum..nn.1
  vira_1_N = mkN "vira" ; -- vira..nn.1
  vira_2_N = mkN "vira" ; -- vira..nn.2
  vira_1_V = mkV "virar" ; -- vira..vb.1
  virak_1_N = mkN "virak" ; -- virak..nn.1
  viral_1_A = mkA "viral" ; -- viral..av.1
  virande_1_N = mkN "virande" ; -- virande..nn.1
  virginiahjort_1_N = mkN "virginiahjort" ; -- virginiahjort..nn.1
  viril_1_A = mkA "viril" ; -- viril..av.1
  virilism_1_N = mkN "virilism" ; -- virilism..nn.1
  virilitet_1_N = mkN "virilitet" "viriliteter" ; -- virilitet..nn.1
  virka_1_V = mkV "virkar" ; -- virka..vb.1
  virkande_1_N = mkN "virkande" ; -- virkande..nn.1
  virke_1_N = mkN "virke" ; -- virke..nn.1
  virkesfångst_1_N = mkN "virkesfångst" ; -- virkesfångst..nn.1
  virkeskvalitet_1_N = mkN "virkeskvalitet" "virkeskvaliteter" ; -- virkeskvalitet..nn.1
  virkesmätning_1_N = mkN "virkesmätning" ; -- virkesmätning..nn.1
  virkesupplag_1_N = mkN "virkesupplag" neutrum  ; -- virkesupplag..nn.1
  virkgarn_1_N = mkN "virkgarn" neutrum  ; -- virkgarn..nn.1
  virkkrok_1_N = mkN "virkkrok" ; -- virkkrok..nn.1
  virkning_1_N = mkN "virkning" ; -- virkning..nn.1
  virknål_1_N = mkN "virknål" ; -- virknål..nn.1
  virolog_1_N = mkN "virolog" "virologer" ; -- virolog..nn.1
  virologi_1_N = mkN "virologi" ; -- virologi..nn.1
  virra_1_V = mkV "virrar" ; -- virra..vb.1
  virrande_1_N = mkN "virrande" ; -- virrande..nn.1
  virre_1_N = mkN "virre" utrum  ; -- virre..nn.1
  virrhjärna_1_N = mkN "virrhjärna" ; -- virrhjärna..nn.1
  virrig_1_A = mkA "virrig" ; -- virrig..av.1
  virrighet_1_N = mkN "virrighet" "virrigheter" ; -- virrighet..nn.1
  virrpanna_1_N = mkN "virrpanna" ; -- virrpanna..nn.1
  virrvarr_1_N = mkN "virrvarr" neutrum  ; -- virrvarr..nn.1
  virtuell_1_A = mkA "virtuell" ; -- virtuell..av.1
  virtuos_1_A = mkA "virtuos" ; -- virtuos..av.1
  virtuos_1_N = mkN "virtuos" "virtuoser" ; -- virtuos..nn.1
  virtuositet_1_N = mkN "virtuositet" "virtuositeter" ; -- virtuositet..nn.1
  virtuosmässig_1_A = mkA "virtuosmässig" ; -- virtuosmässig..av.1
  virtuosmässighet_1_N = mkN "virtuosmässighet" ; -- virtuosmässighet..nn.1
  virtuosnummer_1_N = mkN "virtuosnummer" neutrum  ; -- virtuosnummer..nn.1
  virulens_1_N = mkN "virulens" ; -- virulens..nn.1
  virulent_1_A = mkA "virulent" "virulent" ; -- virulent..av.1
  virus_1_N = mkN "virus" neutrum  ; -- virus..nn.1
  virusepidemi_1_N = mkN "virusepidemi" "virusepidemier" ; -- virusepidemi..nn.1
  virusinfektion_1_N = mkN "virusinfektion" ; -- virusinfektion..nn.1
  virusrisk_1_N = mkN "virusrisk" "virusrisker" ; -- virusrisk..nn.1
  virussjukdom_1_N = mkN "virussjukdom" ; -- virussjukdom..nn.1
  virvel_1_N = mkN "virvel" ; -- virvel..nn.1
  virvelrörelse_1_N = mkN "virvelrörelse" "virvelrörelser" ; -- virvelrörelse..nn.1
  virvelstorm_1_N = mkN "virvelstorm" ; -- virvelstorm..nn.1
  virvelström_1_N = mkN "virvelström" "virvelströmmen" "virvelströmmar" "virvelströmmarna" ; -- virvelström..nn.1
  virvelvind_1_N = mkN "virvelvind" ; -- virvelvind..nn.1
  virvla_1_V = mkV "virvlar" ; -- virvla..vb.1
  virvlande_1_N = mkN "virvlande" ; -- virvlande..nn.1
  vis_1_A = mkA "vis" ; -- vis..av.1
  vis_1_N = mkN "vis" neutrum  ; -- vis..nn.1
  visa_1_N = mkN "visa" ; -- visa..nn.1
  visa_1_V = mkV "visar" ; -- visa..vb.1
  visafton_1_N = mkN "visafton" "visaftonen" "visaftnar" "visaftnarna" ; -- visafton..nn.1
  visakort_1_N = mkN "visakort" neutrum  ; -- visakort..nn.1
  visande_1_N = mkN "visande" ; -- visande..nn.1
  visare_1_N = mkN "visare" utrum  ; -- visare..nn.1
  visarkiv_1_N = mkN "visarkiv" neutrum  ; -- visarkiv..nn.1
  visbok_1_N = mkN "visbok" "visböcker" ; -- visbok..nn.1
  vischa_1_N = mkN "vischa" ; -- vischa..nn.1
  viscount_1_N = mkN "viscount" "viscounter" ; -- viscount..nn.1
  visdom_1_N = mkN "visdom" ; -- visdom..nn.1
  visdomskälla_1_N = mkN "visdomskälla" ; -- visdomskälla..nn.1
  visdomsord_1_N = mkN "visdomsord" neutrum  ; -- visdomsord..nn.1
  visdomsregel_1_N = mkN "visdomsregel" "visdomsregeln" "visdomsregler" "visdomsreglerna" ; -- visdomsregel..nn.1
  visdomstand_1_N = mkN "visdomstand" "visdomständer" ; -- visdomstand..nn.1
  vise_1_N = mkN "vise" utrum  ; -- vise..nn.1
  visefall_1_N = mkN "visefall" neutrum  ; -- visefall..nn.1
  visent_1_N = mkN "visent" "visenter" ; -- visent..nn.1
  visera_1_V = mkV "viserar" ; -- visera..vb.1
  viserande_1_N = mkN "viserande" ; -- viserande..nn.1
  viserbar_1_A = mkA "viserbar" ; -- viserbar..av.1
  viserbarhet_1_N = mkN "viserbarhet" ; -- viserbarhet..nn.1
  visering_1_N = mkN "visering" ; -- visering..nn.1
  viseringskort_1_N = mkN "viseringskort" neutrum  ; -- viseringskort..nn.1
  vishet_1_N = mkN "vishet" "visheter" ; -- vishet..nn.1
  vishetsgudinna_1_N = mkN "vishetsgudinna" ; -- vishetsgudinna..nn.1
  vishetslära_1_N = mkN "vishetslära" ; -- vishetslära..nn.1
  visibel_1_A = mkA "visibel" ; -- visibel..av.1
  visigot_1_N = mkN "visigot" "visigoter" ; -- visigot..nn.1
  visigotisk_1_A = mkA "visigotisk" ; -- visigotisk..av.1
  vision_1_N = mkN "vision" ; -- vision..nn.1
  visionslös_1_A = mkA "visionslös" ; -- visionslös..av.1
  visionslöshet_1_N = mkN "visionslöshet" ; -- visionslöshet..nn.1
  visionär_1_A = mkA "visionär" ; -- visionär..av.1
  visionär_1_N = mkN "visionär" "visionärer" ; -- visionär..nn.1
  visir_1_N = mkN "visir" neutrum  ; -- visir..nn.1
  visir_2_N = mkN "visir" "visirer" ; -- visir..nn.2
  visirlinje_1_N = mkN "visirlinje" utrum  ; -- visirlinje..nn.1
  visirskiva_1_N = mkN "visirskiva" ; -- visirskiva..nn.1
  visit_1_N = mkN "visit" "visiter" ; -- visit..nn.1
  visitation_1_N = mkN "visitation" ; -- visitation..nn.1
  visitator_1_N = mkN "visitator" "visitatorer" ; -- visitator..nn.1
  visitera_1_V = mkV "visiterar" ; -- visitera..vb.1
  visiterande_1_N = mkN "visiterande" ; -- visiterande..nn.1
  visiterbar_1_A = mkA "visiterbar" ; -- visiterbar..av.1
  visiterbarhet_1_N = mkN "visiterbarhet" ; -- visiterbarhet..nn.1
  visitering_1_N = mkN "visitering" ; -- visitering..nn.1
  visitkort_1_N = mkN "visitkort" neutrum  ; -- visitkort..nn.1
  viska_1_N = mkN "viska" ; -- viska..nn.1
  viska_1_V = mkV "viskar" ; -- viska..vb.1
  viskande_1_N = mkN "viskande" ; -- viskande..nn.1
  viskare_1_N = mkN "viskare" utrum  ; -- viskare..nn.1
  viskning_1_N = mkN "viskning" ; -- viskning..nn.1
  viskos_1_N = mkN "viskos" ; -- viskos..nn.1
  viskositet_1_N = mkN "viskositet" "viskositeter" ; -- viskositet..nn.1
  viskös_1_A = mkA "viskös" ; -- viskös..av.1
  vislig_1_A = mkA "vislig" ; -- vislig..av.1
  visligen_1_Adv = mkAdv "visligen" ; -- visligen..ab.1
  vislighet_1_N = mkN "vislighet" ; -- vislighet..nn.1
  visman_1_N = mkN "visman" "vismannen" "vismän" "vismännen" ; -- visman..nn.1
  vismut_1_N = mkN "vismut" ; -- vismut..nn.1
  visning_1_N = mkN "visning" ; -- visning..nn.1
  visningssal_1_N = mkN "visningssal" ; -- visningssal..nn.1
  visp_1_N = mkN "visp" ; -- visp..nn.1
  visp_2_N = mkN "visp" ; -- visp..nn.2
  vispa_1_V = mkV "vispar" ; -- vispa..vb.1
  vispande_1_N = mkN "vispande" ; -- vispande..nn.1
  visper_1_N = mkN "visper" ; -- visper..nn.1
  vispgrädde_1_N = mkN "vispgrädde" utrum  ; -- vispgrädde..nn.1
  vispig_1_A = mkA "vispig" ; -- vispig..av.1
  vispighet_1_N = mkN "vispighet" ; -- vispighet..nn.1
  viss_1_A = mkA "viss" ; -- viss..av.1
  visselblåsare_1_N = mkN "visselblåsare" utrum  ; -- visselblåsare..nn.1
  visselpipa_1_N = mkN "visselpipa" ; -- visselpipa..nn.1
  visselpipsmånglare_1_N = mkN "visselpipsmånglare" utrum  ; -- visselpipsmånglare..nn.1
  vissen_1_A = mkA "vissen" ; -- vissen..av.1
  visserligen_1_Adv = mkAdv "visserligen" ; -- visserligen..ab.1
  visshet_1_N = mkN "visshet" "vissheter" ; -- visshet..nn.1
  vissla_1_N = mkN "vissla" ; -- vissla..nn.1
  vissla_1_V = mkV "visslar" ; -- vissla..vb.1
  vissla_2_V = mkV "visslar" ; -- vissla..vb.2
  visslande_1_N = mkN "visslande" ; -- visslande..nn.1
  visslare_1_N = mkN "visslare" utrum  ; -- visslare..nn.1
  vissling_1_N = mkN "vissling" ; -- vissling..nn.1
  vissna_1_V = mkV "vissnar" ; -- vissna..vb.1
  vissnande_1_N = mkN "vissnande" ; -- vissnande..nn.1
  vissnesjuka_1_N = mkN "vissnesjuka" ; -- vissnesjuka..nn.1
  visst_1_Adv = mkAdv "visst" ; -- visst..ab.1
  visstidsanställd_1_A = mkA "visstidsanställd" "visstidsanställt" ; -- visstidsanställd..av.1
  visstidsanställning_1_N = mkN "visstidsanställning" ; -- visstidsanställning..nn.1
  visstidsförordnande_1_N = mkN "visstidsförordnande" ; -- visstidsförordnande..nn.1
  vissång_1_N = mkN "vissång" ; -- vissång..nn.1
  vissångare_1_N = mkN "vissångare" utrum  ; -- vissångare..nn.1
  vistande_1_N = mkN "vistande" ; -- vistande..nn.1
  viste_1_N = mkN "viste" ; -- viste..nn.1
  vistelse_1_N = mkN "vistelse" "vistelser" ; -- vistelse..nn.1
  vistelseort_1_N = mkN "vistelseort" "vistelseorter" ; -- vistelseort..nn.1
  visthus_1_N = mkN "visthus" neutrum  ; -- visthus..nn.1
  visthusbod_1_N = mkN "visthusbod" ; -- visthusbod..nn.1
  visualisera_1_V = mkV "visualiserar" ; -- visualisera..vb.1
  visualiserande_1_N = mkN "visualiserande" ; -- visualiserande..nn.1
  visualiserbar_1_A = mkA "visualiserbar" ; -- visualiserbar..av.1
  visualiserbarhet_1_N = mkN "visualiserbarhet" ; -- visualiserbarhet..nn.1
  visualisering_1_N = mkN "visualisering" ; -- visualisering..nn.1
  visuell_1_A = mkA "visuell" ; -- visuell..av.1
  visum_1_N = mkN "visum" neutrum  ; -- visum..nn.1
  visumbrott_1_N = mkN "visumbrott" neutrum  ; -- visumbrott..nn.1
  visumregel_1_N = mkN "visumregel" "visumregeln" "visumregler" "visumreglerna" ; -- visumregel..nn.1
  vit_1_A = mkA "vit" ; -- vit..av.1
  vita_1_N = mkN "vita" ; -- vita..nn.1
  vitaktig_1_A = mkA "vitaktig" ; -- vitaktig..av.1
  vitaktighet_1_N = mkN "vitaktighet" ; -- vitaktighet..nn.1
  vital_1_A = mkA "vital" ; -- vital..av.1
  vitalbehov_1_N = mkN "vitalbehov" neutrum  ; -- vitalbehov..nn.1
  vitalf_1_N = mkN "vitalf" "vitalfer" ; -- vitalf..nn.1
  vitalfärgning_1_N = mkN "vitalfärgning" ; -- vitalfärgning..nn.1
  vitalförnimmelse_1_N = mkN "vitalförnimmelse" "vitalförnimmelser" ; -- vitalförnimmelse..nn.1
  vitalisera_1_V = mkV "vitaliserar" ; -- vitalisera..vb.1
  vitaliserande_1_N = mkN "vitaliserande" ; -- vitaliserande..nn.1
  vitaliserbar_1_A = mkA "vitaliserbar" ; -- vitaliserbar..av.1
  vitaliserbarhet_1_N = mkN "vitaliserbarhet" ; -- vitaliserbarhet..nn.1
  vitalisering_1_N = mkN "vitalisering" ; -- vitalisering..nn.1
  vitalism_1_N = mkN "vitalism" "vitalismer" ; -- vitalism..nn.1
  vitalistisk_1_A = mkA "vitalistisk" ; -- vitalistisk..av.1
  vitalitet_1_N = mkN "vitalitet" "vitaliteter" ; -- vitalitet..nn.1
  vitalkapacitet_1_N = mkN "vitalkapacitet" "vitalkapaciteter" ; -- vitalkapacitet..nn.1
  vitalkraft_1_N = mkN "vitalkraft" ; -- vitalkraft..nn.1
  vitalv_1_N = mkN "vitalv" "vitalver" ; -- vitalv..nn.1
  vitamin_1_N = mkN "vitamin" "vitaminer" ; -- vitamin..nn.1
  vitaminberikad_1_A = mkA "vitaminberikad" ; -- vitaminberikad..av.1
  vitaminburk_1_N = mkN "vitaminburk" ; -- vitaminburk..nn.1
  vitaminera_1_V = mkV "vitaminerar" ; -- vitaminera..vb.1
  vitaminerande_1_N = mkN "vitaminerande" ; -- vitaminerande..nn.1
  vitaminerbar_1_A = mkA "vitaminerbar" ; -- vitaminerbar..av.1
  vitaminerbarhet_1_N = mkN "vitaminerbarhet" ; -- vitaminerbarhet..nn.1
  vitaminering_1_N = mkN "vitaminering" ; -- vitaminering..nn.1
  vitamininjektion_1_N = mkN "vitamininjektion" ; -- vitamininjektion..nn.1
  vitaminisera_1_V = mkV "vitaminiserar" ; -- vitaminisera..vb.1
  vitaminiserande_1_N = mkN "vitaminiserande" ; -- vitaminiserande..nn.1
  vitaminiserbar_1_A = mkA "vitaminiserbar" ; -- vitaminiserbar..av.1
  vitaminiserbarhet_1_N = mkN "vitaminiserbarhet" ; -- vitaminiserbarhet..nn.1
  vitaminisering_1_N = mkN "vitaminisering" ; -- vitaminisering..nn.1
  vitaminpiller_1_N = mkN "vitaminpiller" neutrum  ; -- vitaminpiller..nn.1
  vitaminrik_1_A = mkA "vitaminrik" ; -- vitaminrik..av.1
  vitaminrikhet_1_N = mkN "vitaminrikhet" ; -- vitaminrikhet..nn.1
  vitaxighet_1_N = mkN "vitaxighet" ; -- vitaxighet..nn.1
  vitbeta_1_N = mkN "vitbeta" ; -- vitbeta..nn.1
  vitbleck_1_N = mkN "vitbleck" neutrum  ; -- vitbleck..nn.1
  vitblå_1_A = mkA "vitblå" "vitblått" ; -- vitblå..av.1
  vitbok_1_N = mkN "vitbok" "vitböcker" ; -- vitbok..nn.1
  vitbroderi_1_N = mkN "vitbroderi" "vitbroderiet" "vitbroderier" "vitbroderierna" ; -- vitbroderi..nn.1
  vite_1_N = mkN "vite" ; -- vite..nn.1
  vitesförbud_1_N = mkN "vitesförbud" neutrum  ; -- vitesförbud..nn.1
  vitesföreläggande_1_N = mkN "vitesföreläggande" ; -- vitesföreläggande..nn.1
  vitfisk_1_N = mkN "vitfisk" ; -- vitfisk..nn.1
  vitglänsande_1_A = mkA "vitglänsande" ; -- vitglänsande..av.1
  vitglödande_1_A = mkA "vitglödande" ; -- vitglödande..av.1
  vitglödga_1_V = mkV "vitglödgar" ; -- vitglödga..vb.1
  vitglödgande_1_N = mkN "vitglödgande" ; -- vitglödgande..nn.1
  vitglödgning_1_N = mkN "vitglödgning" ; -- vitglödgning..nn.1
  vitgrå_1_A = mkA "vitgrå" "vitgrått" ; -- vitgrå..av.1
  vitgrön_1_A = mkA "vitgrön" ; -- vitgrön..av.1
  vithet_1_N = mkN "vithet" "vitheter" ; -- vithet..nn.1
  vithyllt_1_A = mkA "vithyllt" "vithyllt" ; -- vithyllt..av.1
  vithyllthet_1_N = mkN "vithyllthet" ; -- vithyllthet..nn.1
  vithårig_1_A = mkA "vithårig" ; -- vithårig..av.1
  vithårighet_1_N = mkN "vithårighet" ; -- vithårighet..nn.1
  vitiligo_1_N = mkN "vitiligo" ; -- vitiligo..nn.1
  vitkalka_1_V = mkV "vitkalkar" ; -- vitkalka..vb.1
  vitkalkande_1_N = mkN "vitkalkande" ; -- vitkalkande..nn.1
  vitkindad_1_A = mkA "vitkindad" ; -- vitkindad..av.1
  vitklädd_1_A = mkA "vitklädd" ; -- vitklädd..av.1
  vitklöver_1_N = mkN "vitklöver" ; -- vitklöver..nn.1
  vitkål_1_N = mkN "vitkål" ; -- vitkål..nn.1
  vitlackera_1_V = mkV "vitlackerar" ; -- vitlackera..vb.1
  vitlackerande_1_N = mkN "vitlackerande" ; -- vitlackerande..nn.1
  vitlackering_1_N = mkN "vitlackering" ; -- vitlackering..nn.1
  vitlimma_1_V = mkV "vitlimmar" ; -- vitlimma..vb.1
  vitlimmande_1_N = mkN "vitlimmande" ; -- vitlimmande..nn.1
  vitlimning_1_N = mkN "vitlimning" ; -- vitlimning..nn.1
  vitling_1_N = mkN "vitling" ; -- vitling..nn.1
  vitlinglyra_1_N = mkN "vitlinglyra" ; -- vitlinglyra..nn.1
  vitlök_1_N = mkN "vitlök" ; -- vitlök..nn.1
  vitlöksklyfta_1_N = mkN "vitlöksklyfta" ; -- vitlöksklyfta..nn.1
  vitlökskorv_1_N = mkN "vitlökskorv" ; -- vitlökskorv..nn.1
  vitmaktideologi_1_N = mkN "vitmaktideologi" "vitmaktideologier" ; -- vitmaktideologi..nn.1
  vitmena_1_V = mkV "vitmenar" ; -- vitmena..vb.1
  vitmenande_1_N = mkN "vitmenande" ; -- vitmenande..nn.1
  vitmening_1_N = mkN "vitmening" ; -- vitmening..nn.1
  vitmetall_1_N = mkN "vitmetall" "vitmetaller" ; -- vitmetall..nn.1
  vitmossa_1_N = mkN "vitmossa" ; -- vitmossa..nn.1
  vitmässing_1_N = mkN "vitmässing" ; -- vitmässing..nn.1
  vitmålad_1_A = mkA "vitmålad" ; -- vitmålad..av.1
  vitmåra_1_N = mkN "vitmåra" ; -- vitmåra..nn.1
  vitmögelost_1_N = mkN "vitmögelost" ; -- vitmögelost..nn.1
  vitna_1_V = mkV "vitnar" ; -- vitna..vb.1
  vitnad_1_N = mkN "vitnad" "vitnader" ; -- vitnad..nn.1
  vitnande_1_N = mkN "vitnande" ; -- vitnande..nn.1
  vitnos_1_N = mkN "vitnos" ; -- vitnos..nn.1
  vitnosad_1_A = mkA "vitnosad" ; -- vitnosad..av.1
  vitnosdelfin_1_N = mkN "vitnosdelfin" "vitnosdelfiner" ; -- vitnosdelfin..nn.1
  vitplister_1_N = mkN "vitplister" ; -- vitplister..nn.1
  vitputsad_1_A = mkA "vitputsad" ; -- vitputsad..av.1
  vitra_1_V = mkV "vitrar" ; -- vitra..vb.1
  vitrande_1_N = mkN "vitrande" ; -- vitrande..nn.1
  vitrin_1_N = mkN "vitrin" "vitriner" ; -- vitrin..nn.1
  vitrinskåp_1_N = mkN "vitrinskåp" neutrum  ; -- vitrinskåp..nn.1
  vitriol_1_N = mkN "vitriol" ; -- vitriol..nn.1
  vitriololja_1_N = mkN "vitriololja" ; -- vitriololja..nn.1
  vitrock_1_N = mkN "vitrock" ; -- vitrock..nn.1
  vitrockeffekt_1_N = mkN "vitrockeffekt" "vitrockeffekter" ; -- vitrockeffekt..nn.1
  vitrockseffekt_1_N = mkN "vitrockseffekt" "vitrockseffekter" ; -- vitrockseffekt..nn.1
  vitryggig_1_A = mkA "vitryggig" ; -- vitryggig..av.1
  vitrysk_1_A = mkA "vitrysk" ; -- vitrysk..av.1
  vitryska_1_N = mkN "vitryska" ; -- vitryska..nn.1
  vitryska_2_N = mkN "vitryska" ; -- vitryska..nn.2
  vitryss_1_N = mkN "vitryss" ; -- vitryss..nn.1
  viträv_1_N = mkN "viträv" ; -- viträv..nn.1
  vits_1_N = mkN "vits" ; -- vits..nn.1
  vitsa_1_V = mkV "vitsar" ; -- vitsa..vb.1
  vitsande_1_N = mkN "vitsande" ; -- vitsande..nn.1
  vitsare_1_N = mkN "vitsare" utrum  ; -- vitsare..nn.1
  vitsig_1_A = mkA "vitsig" ; -- vitsig..av.1
  vitsighet_1_N = mkN "vitsighet" "vitsigheter" ; -- vitsighet..nn.1
  vitsippa_1_N = mkN "vitsippa" ; -- vitsippa..nn.1
  vitsippsbacke_1_N = mkN "vitsippsbacke" utrum  ; -- vitsippsbacke..nn.1
  vitskäggig_1_A = mkA "vitskäggig" ; -- vitskäggig..av.1
  vitskäggighet_1_N = mkN "vitskäggighet" ; -- vitskäggighet..nn.1
  vitslammad_1_A = mkA "vitslammad" ; -- vitslammad..av.1
  vitsord_1_N = mkN "vitsord" neutrum  ; -- vitsord..nn.1
  vitsorda_1_V = mkV "vitsordar" ; -- vitsorda..vb.1
  vitsordande_1_N = mkN "vitsordande" ; -- vitsordande..nn.1
  vitsvanshjort_1_N = mkN "vitsvanshjort" ; -- vitsvanshjort..nn.1
  vitta_1_V = mkV "vittar" ; -- vitta..vb.1
  vittande_1_N = mkN "vittande" ; -- vittande..nn.1
  vittbekant_1_A = mkA "vittbekant" "vittbekant" ; -- vittbekant..av.1
  vittberest_1_A = mkA "vittberest" "vittberest" ; -- vittberest..av.1
  vittberesthet_1_N = mkN "vittberesthet" ; -- vittberesthet..nn.1
  vittberömd_1_A = mkA "vittberömd" "vittberömt" ; -- vittberömd..av.1
  vittberömdhet_1_N = mkN "vittberömdhet" ; -- vittberömdhet..nn.1
  vitter_1_A = mkA "vitter" ; -- vitter..av.1
  vitterfolk_1_N = mkN "vitterfolk" neutrum  ; -- vitterfolk..nn.1
  vitterhet_1_N = mkN "vitterhet" "vitterheter" ; -- vitterhet..nn.1
  vitterlek_1_N = mkN "vitterlek" ; -- vitterlek..nn.1
  vittfamnande_1_A = mkA "vittfamnande" ; -- vittfamnande..av.1
  vittflygande_1_A = mkA "vittflygande" ; -- vittflygande..av.1
  vittförgrenad_1_A = mkA "vittförgrenad" ; -- vittförgrenad..av.1
  vittgående_1_A = mkA "vittgående" ; -- vittgående..av.1
  vittja_1_V = mkV "vittjar" ; -- vittja..vb.1
  vittjande_1_N = mkN "vittjande" ; -- vittjande..nn.1
  vittling_1_N = mkN "vittling" ; -- vittling..nn.1
  vittlinglyra_1_N = mkN "vittlinglyra" ; -- vittlinglyra..nn.1
  vittna_1_V = mkV "vittnar" ; -- vittna..vb.1
  vittnande_1_N = mkN "vittnande" ; -- vittnande..nn.1
  vittne_1_N = mkN "vittne" ; -- vittne..nn.1
  vittnesberättelse_1_N = mkN "vittnesberättelse" "vittnesberättelser" ; -- vittnesberättelse..nn.1
  vittnesbås_1_N = mkN "vittnesbås" neutrum  ; -- vittnesbås..nn.1
  vittnesbörd_1_N = mkN "vittnesbörd" neutrum  ; -- vittnesbörd..nn.1
  vittnesed_1_N = mkN "vittnesed" "vittneseder" ; -- vittnesed..nn.1
  vittnesförhör_1_N = mkN "vittnesförhör" neutrum  ; -- vittnesförhör..nn.1
  vittnesgill_1_A = mkA "vittnesgill" ; -- vittnesgill..av.1
  vittnesgillhet_1_N = mkN "vittnesgillhet" ; -- vittnesgillhet..nn.1
  vittneskonfrontation_1_N = mkN "vittneskonfrontation" ; -- vittneskonfrontation..nn.1
  vittnesmål_1_N = mkN "vittnesmål" neutrum  ; -- vittnesmål..nn.1
  vittnespsykologi_1_N = mkN "vittnespsykologi" ; -- vittnespsykologi..nn.1
  vittnesskrank_1_N = mkN "vittnesskrank" neutrum  ; -- vittnesskrank..nn.1
  vittnesuppgift_1_N = mkN "vittnesuppgift" "vittnesuppgifter" ; -- vittnesuppgift..nn.1
  vittnesutsaga_1_N = mkN "vittnesutsaga" ; -- vittnesutsaga..nn.1
  vittomfattande_1_A = mkA "vittomfattande" ; -- vittomfattande..av.1
  vittra_1_N = mkN "vittra" ; -- vittra..nn.1
  vittra_1_V = mkV "vittrar" ; -- vittra..vb.1
  vittrande_1_N = mkN "vittrande" ; -- vittrande..nn.1
  vittring_1_N = mkN "vittring" ; -- vittring..nn.1
  vittvin_1_N = mkN "vittvin" "vittvinet" "vittviner" "vittvinerna" ; -- vittvin..nn.1
  vittvätt_1_N = mkN "vittvätt" ; -- vittvätt..nn.1
  vitval_1_N = mkN "vitval" ; -- vitval..nn.1
  vitvara_1_N = mkN "vitvara" ; -- vitvara..nn.1
  vitved_1_N = mkN "vitved" ; -- vitved..nn.1
  vitvin_1_N = mkN "vitvin" "vitvinet" "vitviner" "vitvinerna" ; -- vitvin..nn.1
  viv_1_N = mkN "viv" neutrum  ; -- viv..nn.1
  viva_1_N = mkN "viva" ; -- viva..nn.1
  vivacitet_1_N = mkN "vivacitet" "vivaciteter" ; -- vivacitet..nn.1
  vivel_1_N = mkN "vivel" ; -- vivel..nn.1
  vivianit_1_N = mkN "vivianit" ; -- vivianit..nn.1
  vivipar_1_A = mkA "vivipar" ; -- vivipar..av.1
  vivisektion_1_N = mkN "vivisektion" ; -- vivisektion..nn.1
  vivisektör_1_N = mkN "vivisektör" "vivisektörer" ; -- vivisektör..nn.1
  vivör_1_N = mkN "vivör" "vivörer" ; -- vivör..nn.1
  vlogg_1_N = mkN "vlogg" ; -- vlogg..nn.1
  voall_1_N = mkN "voall" "voaller" ; -- voall..nn.1
  vobba_1_V = mkV "vobbar" ; -- vobba..vb.1
  vobbande_1_N = mkN "vobbande" ; -- vobbande..nn.1
  vobbare_1_N = mkN "vobbare" utrum  ; -- vobbare..nn.1
  vobbler_1_N = mkN "vobbler" "vobblern" "vobblers" "vobblersen" ; -- vobbler..nn.1
  vodka_1_N = mkN "vodka" ; -- vodka..nn.1
  vodkaglas_1_N = mkN "vodkaglas" neutrum  ; -- vodkaglas..nn.1
  voffla_1_N = mkN "voffla" ; -- voffla..nn.1
  voidkoefficient_1_N = mkN "voidkoefficient" "voidkoefficienter" ; -- voidkoefficient..nn.1
  voile_1_N = mkN "voile" utrum  ; -- voile..nn.1
  vojlock_1_N = mkN "vojlock" ; -- vojlock..nn.1
  vokabel_1_N = mkN "vokabel" "vokabeln" "vokabler" "vokablerna" ; -- vokabel..nn.1
  vokabelsamling_1_N = mkN "vokabelsamling" ; -- vokabelsamling..nn.1
  vokabulär_1_N = mkN "vokabulär" "vokabulärer" ; -- vokabulär..nn.1
  vokal_1_A = mkA "vokal" ; -- vokal..av.1
  vokal_1_N = mkN "vokal" "vokaler" ; -- vokal..nn.1
  vokalbalans_1_N = mkN "vokalbalans" ; -- vokalbalans..nn.1
  vokalförändring_1_N = mkN "vokalförändring" ; -- vokalförändring..nn.1
  vokalharmoni_1_N = mkN "vokalharmoni" "vokalharmonier" ; -- vokalharmoni..nn.1
  vokalis_1_N = mkN "vokalis" "vokaliser" ; -- vokalis..nn.1
  vokalisation_1_N = mkN "vokalisation" ; -- vokalisation..nn.1
  vokalisera_1_V = mkV "vokaliserar" ; -- vokalisera..vb.1
  vokaliserande_1_N = mkN "vokaliserande" ; -- vokaliserande..nn.1
  vokaliserbar_1_A = mkA "vokaliserbar" ; -- vokaliserbar..av.1
  vokaliserbarhet_1_N = mkN "vokaliserbarhet" ; -- vokaliserbarhet..nn.1
  vokalisering_1_N = mkN "vokalisering" ; -- vokalisering..nn.1
  vokalisk_1_A = mkA "vokalisk" ; -- vokalisk..av.1
  vokalism_1_N = mkN "vokalism" "vokalismer" ; -- vokalism..nn.1
  vokalissa_1_N = mkN "vokalissa" ; -- vokalissa..nn.1
  vokalist_1_N = mkN "vokalist" "vokalister" ; -- vokalist..nn.1
  vokalkvalitet_1_N = mkN "vokalkvalitet" "vokalkvaliteter" ; -- vokalkvalitet..nn.1
  vokalkvantitet_1_N = mkN "vokalkvantitet" "vokalkvantiteter" ; -- vokalkvantitet..nn.1
  vokallängd_1_N = mkN "vokallängd" "vokallängder" ; -- vokallängd..nn.1
  vokalmummel_1_N = mkN "vokalmummel" neutrum  ; -- vokalmummel..nn.1
  vokalmusik_1_N = mkN "vokalmusik" ; -- vokalmusik..nn.1
  vokalmöte_1_N = mkN "vokalmöte" ; -- vokalmöte..nn.1
  vokalrim_1_N = mkN "vokalrim" "vokalrimmet" "vokalrim" "vokalrimmen" ; -- vokalrim..nn.1
  vokalväxling_1_N = mkN "vokalväxling" ; -- vokalväxling..nn.1
  vokativ_1_N = mkN "vokativ" "vokativer" ; -- vokativ..nn.1
  volang_1_N = mkN "volang" "volanger" ; -- volang..nn.1
  volapük_1_N = mkN "volapük" ; -- volapük..nn.1
  volauvent_1_N = mkN "volauvent" "volauventer" ; -- volauvent..nn.1
  volfram_1_N = mkN "volfram" ; -- volfram..nn.1
  volframnål_1_N = mkN "volframnål" ; -- volframnål..nn.1
  voljär_1_N = mkN "voljär" "voljärer" ; -- voljär..nn.1
  volleyboll_1_N = mkN "volleyboll" ; -- volleyboll..nn.1
  volleyboll_2_N = mkN "volleyboll" ; -- volleyboll..nn.2
  volm_1_N = mkN "volm" ; -- volm..nn.1
  volma_1_V = mkV "volmar" ; -- volma..vb.1
  volmande_1_N = mkN "volmande" ; -- volmande..nn.1
  volmning_1_N = mkN "volmning" ; -- volmning..nn.1
  volontera_1_V = mkV "volonterar" ; -- volontera..vb.1
  volonterande_1_N = mkN "volonterande" ; -- volonterande..nn.1
  volontering_1_N = mkN "volontering" ; -- volontering..nn.1
  volontär_1_A = mkA "volontär" ; -- volontär..av.1
  volontär_1_N = mkN "volontär" "volontärer" ; -- volontär..nn.1
  volontära_1_V = mkV "volontärar" ; -- volontära..vb.1
  volontärande_1_N = mkN "volontärande" ; -- volontärande..nn.1
  volontäring_1_N = mkN "volontäring" ; -- volontäring..nn.1
  volt_1_N = mkN "volt" "volten" "volt" "volten" ; -- volt..nn.1
  volt_2_N = mkN "volt" "volter" ; -- volt..nn.2
  volta_1_N = mkN "volta" ; -- volta..nn.1
  volta_1_V = mkV "voltar" ; -- volta..vb.1
  voltan_1_N = mkN "voltan" "voltaner" ; -- voltan..nn.1
  voltande_1_N = mkN "voltande" ; -- voltande..nn.1
  voltige_1_N = mkN "voltige" "voltiger" ; -- voltige..nn.1
  voltigera_1_V = mkV "voltigerar" ; -- voltigera..vb.1
  voltigerande_1_N = mkN "voltigerande" ; -- voltigerande..nn.1
  voltigering_1_N = mkN "voltigering" ; -- voltigering..nn.1
  voltigör_1_N = mkN "voltigör" "voltigörer" ; -- voltigör..nn.1
  voltmeter_1_N = mkN "voltmeter" ; -- voltmeter..nn.1
  voltmätare_1_N = mkN "voltmätare" utrum  ; -- voltmätare..nn.1
  volttal_1_N = mkN "volttal" neutrum  ; -- volttal..nn.1
  voluminös_1_A = mkA "voluminös" ; -- voluminös..av.1
  voluntarism_1_N = mkN "voluntarism" "voluntarismer" ; -- voluntarism..nn.1
  voluntaristisk_1_A = mkA "voluntaristisk" ; -- voluntaristisk..av.1
  volut_1_N = mkN "volut" "voluter" ; -- volut..nn.1
  volvo_1_N = mkN "volvo" ; -- volvo..nn.1
  volym_1_N = mkN "volym" "volymer" ; -- volym..nn.1
  volymenhet_1_N = mkN "volymenhet" "volymenheter" ; -- volymenhet..nn.1
  volymmässig_1_A = mkA "volymmässig" ; -- volymmässig..av.1
  volymprocent_1_N = mkN "volymprocent" "volymprocenten" "volymprocent" "volymprocenten" ; -- volymprocent..nn.1
  volymsenhet_1_N = mkN "volymsenhet" "volymsenheter" ; -- volymsenhet..nn.1
  volymvikt_1_N = mkN "volymvikt" ; -- volymvikt..nn.1
  vom_1_N = mkN "vom" "vommen" "vommar" "vommarna" ; -- vom..nn.1
  vomb_1_N = mkN "vomb" ; -- vomb..nn.1
  vombat_1_N = mkN "vombat" "vombater" ; -- vombat..nn.1
  vomera_1_V = mkV "vomerar" ; -- vomera..vb.1
  vomerande_1_N = mkN "vomerande" ; -- vomerande..nn.1
  vomering_1_N = mkN "vomering" ; -- vomering..nn.1
  vomitiv_1_N = mkN "vomitiv" neutrum  ; -- vomitiv..nn.1
  voodoo_1_N = mkN "voodoo" ; -- voodoo..nn.1
  vorstehhund_1_N = mkN "vorstehhund" ; -- vorstehhund..nn.1
  votera_1_V = mkV "voterar" ; -- votera..vb.1
  voterande_1_N = mkN "voterande" ; -- voterande..nn.1
  votering_1_N = mkN "votering" ; -- votering..nn.1
  voteringsskylt_1_N = mkN "voteringsskylt" ; -- voteringsskylt..nn.1
  votivgåva_1_N = mkN "votivgåva" ; -- votivgåva..nn.1
  votivljus_1_N = mkN "votivljus" neutrum  ; -- votivljus..nn.1
  votivskepp_1_N = mkN "votivskepp" neutrum  ; -- votivskepp..nn.1
  votum_1_N = mkN "votum" neutrum  ; -- votum..nn.1
  voucher_1_N = mkN "voucher" "vouchern" "vouchers" "vouchersen" ; -- voucher..nn.1
  vov_1_N = mkN "vov" neutrum  ; -- vov..nn.1
  vovve_1_N = mkN "vovve" utrum  ; -- vovve..nn.1
  voyeur_1_N = mkN "voyeur" "voyeurer" ; -- voyeur..nn.1
  voyeuristisk_1_A = mkA "voyeuristisk" ; -- voyeuristisk..av.1
  voyeuristiskhet_1_N = mkN "voyeuristiskhet" ; -- voyeuristiskhet..nn.1
  vrak_1_N = mkN "vrak" neutrum  ; -- vrak..nn.1
  vraka_1_V = mkV "vrakar" ; -- vraka..vb.1
  vrakande_1_N = mkN "vrakande" ; -- vrakande..nn.1
  vrakeka_1_N = mkN "vrakeka" ; -- vrakeka..nn.1
  vrakfynd_1_N = mkN "vrakfynd" neutrum  ; -- vrakfynd..nn.1
  vrakgods_1_N = mkN "vrakgods" neutrum  ; -- vrakgods..nn.1
  vrakjärn_1_N = mkN "vrakjärn" neutrum  ; -- vrakjärn..nn.1
  vraklax_1_N = mkN "vraklax" ; -- vraklax..nn.1
  vrakletare_1_N = mkN "vrakletare" utrum  ; -- vrakletare..nn.1
  vrakning_1_N = mkN "vrakning" ; -- vrakning..nn.1
  vrakplundrare_1_N = mkN "vrakplundrare" utrum  ; -- vrakplundrare..nn.1
  vrakplundring_1_N = mkN "vrakplundring" ; -- vrakplundring..nn.1
  vrakpris_1_N = mkN "vrakpris" neutrum  ; -- vrakpris..nn.1
  vrakrest_1_N = mkN "vrakrest" "vrakrester" ; -- vrakrest..nn.1
  vrakspillra_1_N = mkN "vrakspillra" ; -- vrakspillra..nn.1
  vrakvirke_1_N = mkN "vrakvirke" ; -- vrakvirke..nn.1
  vred_1_A = mkA "vred" ; -- vred..av.1
  vred_1_N = mkN "vred" neutrum  ; -- vred..nn.1
  vrede_1_N = mkN "vrede" utrum  ; -- vrede..nn.1
  vredesmod_1_N = mkN "vredesmod" neutrum  ; -- vredesmod..nn.1
  vredesutbrott_1_N = mkN "vredesutbrott" neutrum  ; -- vredesutbrott..nn.1
  vredgad_1_A = mkA "vredgad" ; -- vredgad..av.1
  vredhet_1_N = mkN "vredhet" ; -- vredhet..nn.1
  vrensk_1_A = mkA "vrensk" ; -- vrensk..av.1
  vrenskhet_1_N = mkN "vrenskhet" ; -- vrenskhet..nn.1
  vresig_1_A = mkA "vresig" ; -- vresig..av.1
  vresighet_1_N = mkN "vresighet" "vresigheter" ; -- vresighet..nn.1
  vrestall_1_N = mkN "vrestall" ; -- vrestall..nn.1
  vresved_1_N = mkN "vresved" ; -- vresved..nn.1
  vret_1_N = mkN "vret" ; -- vret..nn.1
  vricka_1_V = mkV "vrickar" ; -- vricka..vb.1
  vrickad_1_A = mkA "vrickad" ; -- vrickad..av.1
  vrickande_1_N = mkN "vrickande" ; -- vrickande..nn.1
  vrickning_1_N = mkN "vrickning" ; -- vrickning..nn.1
  vrida_1_V = mkV "vrida" "vred" "vridit" ; -- vrida..vb.1
  vridande_1_N = mkN "vridande" ; -- vridande..nn.1
  vridbar_1_A = mkA "vridbar" ; -- vridbar..av.1
  vridbarhet_1_N = mkN "vridbarhet" ; -- vridbarhet..nn.1
  vriden_1_A = mkA "vriden" ; -- vriden..av.1
  vridenhet_1_N = mkN "vridenhet" ; -- vridenhet..nn.1
  vridjärnsinstrument_1_N = mkN "vridjärnsinstrument" neutrum  ; -- vridjärnsinstrument..nn.1
  vridled_1_N = mkN "vridled" "vridleder" ; -- vridled..nn.1
  vridmoment_1_N = mkN "vridmoment" neutrum  ; -- vridmoment..nn.1
  vridning_1_N = mkN "vridning" ; -- vridning..nn.1
  vridningsaxel_1_N = mkN "vridningsaxel" ; -- vridningsaxel..nn.1
  vridscen_1_N = mkN "vridscen" "vridscener" ; -- vridscen..nn.1
  vridspoleinstrument_1_N = mkN "vridspoleinstrument" neutrum  ; -- vridspoleinstrument..nn.1
  vril_1_N = mkN "vril" ; -- vril..nn.1
  vrist_1_N = mkN "vrist" "vrister" ; -- vrist..nn.1
  vristben_1_N = mkN "vristben" neutrum  ; -- vristben..nn.1
  vristlänk_1_N = mkN "vristlänk" ; -- vristlänk..nn.1
  vräka_1_V = mkV "vräker" ; -- vräka..vb.1
  vräkande_1_N = mkN "vräkande" ; -- vräkande..nn.1
  vräkare_1_N = mkN "vräkare" utrum  ; -- vräkare..nn.1
  vräkig_1_A = mkA "vräkig" ; -- vräkig..av.1
  vräkighet_1_N = mkN "vräkighet" "vräkigheter" ; -- vräkighet..nn.1
  vräkning_1_N = mkN "vräkning" ; -- vräkning..nn.1
  vränga_1_V = mkV "vränger" ; -- vränga..vb.1
  vrängande_1_N = mkN "vrängande" ; -- vrängande..nn.1
  vrängning_1_N = mkN "vrängning" ; -- vrängning..nn.1
  vrå_1_N = mkN "vrå" "vrån" "vrår" "vrårna" ; -- vrå..nn.1
  vråk_1_N = mkN "vråk" ; -- vråk..nn.1
  vrål_1_N = mkN "vrål" neutrum  ; -- vrål..nn.1
  vråla_1_V = mkV "vrålar" ; -- vråla..vb.1
  vrålande_1_N = mkN "vrålande" ; -- vrålande..nn.1
  vrålapa_1_N = mkN "vrålapa" ; -- vrålapa..nn.1
  vrålflott_1_A = mkA "vrålflott" ; -- vrålflott..av.1
  vrålflotthet_1_N = mkN "vrålflotthet" ; -- vrålflotthet..nn.1
  vrålplugga_1_V = mkV "vrålpluggar" ; -- vrålplugga..vb.1
  vrålpluggande_1_N = mkN "vrålpluggande" ; -- vrålpluggande..nn.1
  vrålåk_1_N = mkN "vrålåk" neutrum  ; -- vrålåk..nn.1
  vrång_1_A = mkA "vrång" ; -- vrång..av.1
  vrångbild_1_N = mkN "vrångbild" "vrångbilder" ; -- vrångbild..nn.1
  vrångföreställning_1_N = mkN "vrångföreställning" ; -- vrångföreställning..nn.1
  vrånghet_1_N = mkN "vrånghet" "vrångheter" ; -- vrånghet..nn.1
  vrångvis_1_A = mkA "vrångvis" ; -- vrångvis..av.1
  vrångvishet_1_N = mkN "vrångvishet" ; -- vrångvishet..nn.1
  vrövel_1_N = mkN "vrövel" neutrum  ; -- vrövel..nn.1
  vrövla_1_V = mkV "vrövlar" ; -- vrövla..vb.1
  vrövlande_1_N = mkN "vrövlande" ; -- vrövlande..nn.1
  vula_1_V = mkV "vular" ; -- vula..vb.1
  vulande_1_N = mkN "vulande" ; -- vulande..nn.1
  vulgarisera_1_V = mkV "vulgariserar" ; -- vulgarisera..vb.1
  vulgariserande_1_N = mkN "vulgariserande" ; -- vulgariserande..nn.1
  vulgariserbar_1_A = mkA "vulgariserbar" ; -- vulgariserbar..av.1
  vulgariserbarhet_1_N = mkN "vulgariserbarhet" ; -- vulgariserbarhet..nn.1
  vulgarisering_1_N = mkN "vulgarisering" ; -- vulgarisering..nn.1
  vulgaritet_1_N = mkN "vulgaritet" "vulgariteter" ; -- vulgaritet..nn.1
  vulgo_1_A = mkA "vulgo" ; -- vulgo..av.1
  vulgonäste_1_N = mkN "vulgonäste" ; -- vulgonäste..nn.1
  vulgär_1_A = mkA "vulgär" ; -- vulgär..av.1
  vulgärlatin_1_N = mkN "vulgärlatin" neutrum  ; -- vulgärlatin..nn.1
  vulka_1_V = mkV "vulkar" ; -- vulka..vb.1
  vulkan_1_N = mkN "vulkan" "vulkaner" ; -- vulkan..nn.1
  vulkanaska_1_N = mkN "vulkanaska" ; -- vulkanaska..nn.1
  vulkande_1_N = mkN "vulkande" ; -- vulkande..nn.1
  vulkanisator_1_N = mkN "vulkanisator" "vulkanisatorer" ; -- vulkanisator..nn.1
  vulkanisera_1_V = mkV "vulkaniserar" ; -- vulkanisera..vb.1
  vulkaniserande_1_N = mkN "vulkaniserande" ; -- vulkaniserande..nn.1
  vulkaniserbar_1_A = mkA "vulkaniserbar" ; -- vulkaniserbar..av.1
  vulkaniserbarhet_1_N = mkN "vulkaniserbarhet" ; -- vulkaniserbarhet..nn.1
  vulkanisering_1_N = mkN "vulkanisering" ; -- vulkanisering..nn.1
  vulkanisk_1_A = mkA "vulkanisk" ; -- vulkanisk..av.1
  vulkanism_1_N = mkN "vulkanism" "vulkanismer" ; -- vulkanism..nn.1
  vulkanit_1_N = mkN "vulkanit" "vulkaniter" ; -- vulkanit..nn.1
  vulkankrater_1_N = mkN "vulkankrater" ; -- vulkankrater..nn.1
  vulkankägla_1_N = mkN "vulkankägla" ; -- vulkankägla..nn.1
  vulkanutbrott_1_N = mkN "vulkanutbrott" neutrum  ; -- vulkanutbrott..nn.1
  vulkanvarning_1_N = mkN "vulkanvarning" ; -- vulkanvarning..nn.1
  vulkanö_1_N = mkN "vulkanö" ; -- vulkanö..nn.1
  vulkapparat_1_N = mkN "vulkapparat" "vulkapparater" ; -- vulkapparat..nn.1
  vulst_1_N = mkN "vulst" "vulster" ; -- vulst..nn.1
  vulstig_1_A = mkA "vulstig" ; -- vulstig..av.1
  vulstighet_1_N = mkN "vulstighet" ; -- vulstighet..nn.1
  vulva_1_N = mkN "vulva" ; -- vulva..nn.1
  vurm_1_N = mkN "vurm" "vurmer" ; -- vurm..nn.1
  vurma_1_V = mkV "vurmar" ; -- vurma..vb.1
  vurmande_1_N = mkN "vurmande" ; -- vurmande..nn.1
  vurmeri_1_N = mkN "vurmeri" neutrum  ; -- vurmeri..nn.1
  vurpa_1_N = mkN "vurpa" ; -- vurpa..nn.1
  vurpa_1_V = mkV "vurpar" ; -- vurpa..vb.1
  vurpande_1_N = mkN "vurpande" ; -- vurpande..nn.1
  vurst_1_N = mkN "vurst" ; -- vurst..nn.1
  vuvuzela_1_N = mkN "vuvuzela" ; -- vuvuzela..nn.1
  vuvuzelatutande_1_A = mkA "vuvuzelatutande" ; -- vuvuzelatutande..av.1
  vuvuzelatutande_1_N = mkN "vuvuzelatutande" ; -- vuvuzelatutande..nn.1
  vuxen_1_A = mkA "vuxen" ; -- vuxen..av.1
  vuxendos_1_N = mkN "vuxendos" "vuxendoser" ; -- vuxendos..nn.1
  vuxenliv_1_N = mkN "vuxenliv" neutrum  ; -- vuxenliv..nn.1
  vuxenmobbning_1_N = mkN "vuxenmobbning" ; -- vuxenmobbning..nn.1
  vuxenstuderande_1_N = mkN "vuxenstuderande" "vuxenstuderanden" "vuxenstuderanden" "vuxenstuderandena" ; -- vuxenstuderande..nn.1
  vuxenstudiestöd_1_N = mkN "vuxenstudiestöd" neutrum  ; -- vuxenstudiestöd..nn.1
  vuxenutbildning_1_N = mkN "vuxenutbildning" ; -- vuxenutbildning..nn.1
  vuxenvärld_1_N = mkN "vuxenvärld" ; -- vuxenvärld..nn.1
  vy_1_N = mkN "vy" "vyer" ; -- vy..nn.1
  vykort_1_N = mkN "vykort" neutrum  ; -- vykort..nn.1
  vykortstext_1_N = mkN "vykortstext" "vykortstexter" ; -- vykortstext..nn.1
  vykortsvy_1_N = mkN "vykortsvy" "vykortsvyer" ; -- vykortsvy..nn.1
  vyssa_1_V = mkV "vyssar" ; -- vyssa..vb.1
  vyssande_1_N = mkN "vyssande" ; -- vyssande..nn.1
  vyssja_1_V = mkV "vyssjar" ; -- vyssja..vb.1
  vyssjande_1_N = mkN "vyssjande" ; -- vyssjande..nn.1
  väbel_1_N = mkN "väbel" ; -- väbel..nn.1
  väck_1_A = mkA "väck" ; -- väck..av.1
  väcka_1_N = mkN "väcka" ; -- väcka..nn.1
  väcka_1_V = mkV "väcker" ; -- väcka..vb.1
  väckande_1_N = mkN "väckande" ; -- väckande..nn.1
  väckare_1_N = mkN "väckare" utrum  ; -- väckare..nn.1
  väckarklocka_1_N = mkN "väckarklocka" ; -- väckarklocka..nn.1
  väckelse_1_N = mkN "väckelse" "väckelser" ; -- väckelse..nn.1
  väckelseman_1_N = mkN "väckelseman" "väckelsemannen" "väckelsemän" "väckelsemännen" ; -- väckelseman..nn.1
  väckelsemöte_1_N = mkN "väckelsemöte" ; -- väckelsemöte..nn.1
  väckelsepredikant_1_N = mkN "väckelsepredikant" "väckelsepredikanter" ; -- väckelsepredikant..nn.1
  väckelserörelse_1_N = mkN "väckelserörelse" "väckelserörelser" ; -- väckelserörelse..nn.1
  väckning_1_N = mkN "väckning" ; -- väckning..nn.1
  vädd_1_N = mkN "vädd" ; -- vädd..nn.1
  väder_1_N = mkN "väder" neutrum  ; -- väder..nn.1
  väderbeständig_1_A = mkA "väderbeständig" ; -- väderbeständig..av.1
  väderbeständighet_1_N = mkN "väderbeständighet" ; -- väderbeständighet..nn.1
  väderbesvärjare_1_N = mkN "väderbesvärjare" utrum  ; -- väderbesvärjare..nn.1
  väderbiten_1_A = mkA "väderbiten" ; -- väderbiten..av.1
  väderförhållande_1_N = mkN "väderförhållande" ; -- väderförhållande..nn.1
  vädergalla_1_N = mkN "vädergalla" ; -- vädergalla..nn.1
  väderil_1_N = mkN "väderil" ; -- väderil..nn.1
  väderkaos_1_N = mkN "väderkaos" neutrum  ; -- väderkaos..nn.1
  väderkarta_1_N = mkN "väderkarta" ; -- väderkarta..nn.1
  väderkorn_1_N = mkN "väderkorn" neutrum  ; -- väderkorn..nn.1
  väderkvarn_1_N = mkN "väderkvarn" ; -- väderkvarn..nn.1
  väderlek_1_N = mkN "väderlek" ; -- väderlek..nn.1
  väderleksmässig_1_A = mkA "väderleksmässig" ; -- väderleksmässig..av.1
  väderleksprognos_1_N = mkN "väderleksprognos" "väderleksprognoser" ; -- väderleksprognos..nn.1
  väderleksrapport_1_N = mkN "väderleksrapport" "väderleksrapporter" ; -- väderleksrapport..nn.1
  väderlekstjänst_1_N = mkN "väderlekstjänst" ; -- väderlekstjänst..nn.1
  väderläge_1_N = mkN "väderläge" ; -- väderläge..nn.1
  väderlåda_1_N = mkN "väderlåda" ; -- väderlåda..nn.1
  vädermanipulation_1_N = mkN "vädermanipulation" ; -- vädermanipulation..nn.1
  vädermässig_1_A = mkA "vädermässig" ; -- vädermässig..av.1
  vädermätning_1_N = mkN "vädermätning" ; -- vädermätning..nn.1
  väderobservation_1_N = mkN "väderobservation" ; -- väderobservation..nn.1
  väderomslag_1_N = mkN "väderomslag" neutrum  ; -- väderomslag..nn.1
  väderpresentatör_1_N = mkN "väderpresentatör" "väderpresentatörer" ; -- väderpresentatör..nn.1
  väderprognos_1_N = mkN "väderprognos" "väderprognoser" ; -- väderprognos..nn.1
  väderrapport_1_N = mkN "väderrapport" "väderrapporter" ; -- väderrapport..nn.1
  vädersatellit_1_N = mkN "vädersatellit" "vädersatelliter" ; -- vädersatellit..nn.1
  vädersegel_1_N = mkN "vädersegel" neutrum  ; -- vädersegel..nn.1
  väderskepp_1_N = mkN "väderskepp" neutrum  ; -- väderskepp..nn.1
  väderskifte_1_N = mkN "väderskifte" ; -- väderskifte..nn.1
  vädersol_1_N = mkN "vädersol" ; -- vädersol..nn.1
  väderspänd_1_A = mkA "väderspänd" ; -- väderspänd..av.1
  väderspändhet_1_N = mkN "väderspändhet" ; -- väderspändhet..nn.1
  väderspänning_1_N = mkN "väderspänning" ; -- väderspänning..nn.1
  väderstinn_1_A = mkA "väderstinn" "väderstint" ; -- väderstinn..av.1
  väderstinnhet_1_N = mkN "väderstinnhet" ; -- väderstinnhet..nn.1
  väderstreck_1_N = mkN "väderstreck" neutrum  ; -- väderstreck..nn.1
  vädertillstånd_1_N = mkN "vädertillstånd" neutrum  ; -- vädertillstånd..nn.1
  vädertjänst_1_N = mkN "vädertjänst" ; -- vädertjänst..nn.1
  väderväxling_1_N = mkN "väderväxling" ; -- väderväxling..nn.1
  vädja_1_V = mkV "vädjar" ; -- vädja..vb.1
  vädjande_1_N = mkN "vädjande" ; -- vädjande..nn.1
  vädjobana_1_N = mkN "vädjobana" ; -- vädjobana..nn.1
  vädra_1_V = mkV "vädrar" ; -- vädra..vb.1
  vädrande_1_N = mkN "vädrande" ; -- vädrande..nn.1
  vädur_1_N = mkN "vädur" ; -- vädur..nn.1
  väft_1_N = mkN "väft" ; -- väft..nn.1
  väg_1_N = mkN "väg" ; -- väg..nn.1
  väga_1_V = mkV "väger" ; -- väga..vb.1
  väga_2_V = mkV "vägar" ; -- väga..vb.2
  väga_3_V = mkV "väger" ; -- väga..vb.3
  vägande_1_N = mkN "vägande" ; -- vägande..nn.1
  vägarbete_1_N = mkN "vägarbete" ; -- vägarbete..nn.1
  vägare_1_N = mkN "vägare" utrum  ; -- vägare..nn.1
  vägbana_1_N = mkN "vägbana" ; -- vägbana..nn.1
  vägbeläggning_1_N = mkN "vägbeläggning" ; -- vägbeläggning..nn.1
  vägbom_1_N = mkN "vägbom" "vägbommen" "vägbommar" "vägbommarna" ; -- vägbom..nn.1
  vägbomb_1_N = mkN "vägbomb" "vägbomber" ; -- vägbomb..nn.1
  vägbro_1_N = mkN "vägbro" ; -- vägbro..nn.1
  vägbrytare_1_N = mkN "vägbrytare" utrum  ; -- vägbrytare..nn.1
  vägbula_1_N = mkN "vägbula" ; -- vägbula..nn.1
  vägbuller_1_N = mkN "vägbuller" neutrum  ; -- vägbuller..nn.1
  vägbygge_1_N = mkN "vägbygge" ; -- vägbygge..nn.1
  vägdike_1_N = mkN "vägdike" ; -- vägdike..nn.1
  vägdöd_1_N = mkN "vägdöd" ; -- vägdöd..nn.1
  vägegenskap_1_N = mkN "vägegenskap" "vägegenskaper" ; -- vägegenskap..nn.1
  vägfarande_1_N = mkN "vägfarande" "vägfaranden" "vägfaranden" "vägfarandena" ; -- vägfarande..nn.1
  vägfärja_1_N = mkN "vägfärja" ; -- vägfärja..nn.1
  vägförbindelse_1_N = mkN "vägförbindelse" "vägförbindelser" ; -- vägförbindelse..nn.1
  vägförening_1_N = mkN "vägförening" ; -- vägförening..nn.1
  vägförvaltning_1_N = mkN "vägförvaltning" ; -- vägförvaltning..nn.1
  vägg_1_N = mkN "vägg" ; -- vägg..nn.1
  väggarm_1_N = mkN "väggarm" ; -- väggarm..nn.1
  väggband_1_N = mkN "väggband" neutrum  ; -- väggband..nn.1
  väggbonad_1_N = mkN "väggbonad" "väggbonader" ; -- väggbonad..nn.1
  väggdekoration_1_N = mkN "väggdekoration" ; -- väggdekoration..nn.1
  väggfast_1_A = mkA "väggfast" "väggfast" ; -- väggfast..av.1
  väggfält_1_N = mkN "väggfält" neutrum  ; -- väggfält..nn.1
  väggfäste_1_N = mkN "väggfäste" ; -- väggfäste..nn.1
  vägghylla_1_N = mkN "vägghylla" ; -- vägghylla..nn.1
  väggklocka_1_N = mkN "väggklocka" ; -- väggklocka..nn.1
  väggkonstruktion_1_N = mkN "väggkonstruktion" ; -- väggkonstruktion..nn.1
  vägglus_1_N = mkN "vägglus" "vägglusen" "vägglöss" "vägglössen" ; -- vägglus..nn.1
  väggmadam_1_N = mkN "väggmadam" "väggmadammen" "väggmadammer" "väggmadammerna" ; -- väggmadam..nn.1
  väggmontera_1_V = mkV "väggmonterar" ; -- väggmontera..vb.1
  väggmonterande_1_N = mkN "väggmonterande" ; -- väggmonterande..nn.1
  väggmonterbar_1_A = mkA "väggmonterbar" ; -- väggmonterbar..av.1
  väggmonterbarhet_1_N = mkN "väggmonterbarhet" ; -- väggmonterbarhet..nn.1
  väggmossa_1_N = mkN "väggmossa" ; -- väggmossa..nn.1
  väggmålning_1_N = mkN "väggmålning" ; -- väggmålning..nn.1
  väggpelare_1_N = mkN "väggpelare" utrum  ; -- väggpelare..nn.1
  väggplatta_1_N = mkN "väggplatta" ; -- väggplatta..nn.1
  väggregel_1_N = mkN "väggregel" ; -- väggregel..nn.1
  väggrepp_1_N = mkN "väggrepp" neutrum  ; -- väggrepp..nn.1
  väggspackel_1_N = mkN "väggspackel" neutrum  ; -- väggspackel..nn.1
  väggtelefon_1_N = mkN "väggtelefon" "väggtelefoner" ; -- väggtelefon..nn.1
  väggtidning_1_N = mkN "väggtidning" ; -- väggtidning..nn.1
  väggur_1_N = mkN "väggur" neutrum  ; -- väggur..nn.1
  vägguttag_1_N = mkN "vägguttag" neutrum  ; -- vägguttag..nn.1
  väggyta_1_N = mkN "väggyta" ; -- väggyta..nn.1
  väghyvel_1_N = mkN "väghyvel" ; -- väghyvel..nn.1
  väghållning_1_N = mkN "väghållning" ; -- väghållning..nn.1
  väginvestering_1_N = mkN "väginvestering" ; -- väginvestering..nn.1
  vägkant_1_N = mkN "vägkant" "vägkanter" ; -- vägkant..nn.1
  vägkors_1_N = mkN "vägkors" neutrum  ; -- vägkors..nn.1
  vägkorsning_1_N = mkN "vägkorsning" ; -- vägkorsning..nn.1
  vägkost_1_N = mkN "vägkost" ; -- vägkost..nn.1
  vägkrog_1_N = mkN "vägkrog" ; -- vägkrog..nn.1
  vägkurva_1_N = mkN "vägkurva" ; -- vägkurva..nn.1
  väglag_1_N = mkN "väglag" neutrum  ; -- väglag..nn.1
  väglag_2_N = mkN "väglag" ; -- väglag..nn.2
  vägleda_1_V = mkV "vägleda" "vägledde" "väglett" ; -- vägleda..vb.1
  vägledande_1_A = mkA "vägledande" ; -- vägledande..av.1
  vägledande_1_N = mkN "vägledande" ; -- vägledande..nn.1
  vägledare_1_N = mkN "vägledare" utrum  ; -- vägledare..nn.1
  vägledning_1_N = mkN "vägledning" ; -- vägledning..nn.1
  väglus_1_N = mkN "väglus" "väglusen" "väglöss" "väglössen" ; -- väglus..nn.1
  väglängd_1_N = mkN "väglängd" "väglängder" ; -- väglängd..nn.1
  väglös_1_A = mkA "väglös" ; -- väglös..av.1
  vägmaskin_1_N = mkN "vägmaskin" "vägmaskiner" ; -- vägmaskin..nn.1
  vägmärke_1_N = mkN "vägmärke" ; -- vägmärke..nn.1
  vägmätare_1_N = mkN "vägmätare" utrum  ; -- vägmätare..nn.1
  vägning_1_N = mkN "vägning" ; -- vägning..nn.1
  vägnät_1_N = mkN "vägnät" neutrum  ; -- vägnät..nn.1
  vägpirat_1_N = mkN "vägpirat" "vägpirater" ; -- vägpirat..nn.1
  vägport_1_N = mkN "vägport" ; -- vägport..nn.1
  vägra_1_V = mkV "vägrar" ; -- vägra..vb.1
  vägrande_1_N = mkN "vägrande" ; -- vägrande..nn.1
  vägrare_1_N = mkN "vägrare" utrum  ; -- vägrare..nn.1
  vägren_1_N = mkN "vägren" "vägrenen" "vägrenar" "vägrenarna" ; -- vägren..nn.1
  vägräcke_1_N = mkN "vägräcke" ; -- vägräcke..nn.1
  vägröjare_1_N = mkN "vägröjare" utrum  ; -- vägröjare..nn.1
  vägröjning_1_N = mkN "vägröjning" ; -- vägröjning..nn.1
  vägsalt_1_N = mkN "vägsalt" neutrum  ; -- vägsalt..nn.1
  vägskrapa_1_N = mkN "vägskrapa" ; -- vägskrapa..nn.1
  vägskylt_1_N = mkN "vägskylt" ; -- vägskylt..nn.1
  vägskäl_1_N = mkN "vägskäl" neutrum  ; -- vägskäl..nn.1
  vägslitage_1_N = mkN "vägslitage" ; -- vägslitage..nn.1
  vägsmuts_1_N = mkN "vägsmuts" neutrum  ; -- vägsmuts..nn.1
  vägspärr_1_N = mkN "vägspärr" ; -- vägspärr..nn.1
  vägstolpe_1_N = mkN "vägstolpe" utrum  ; -- vägstolpe..nn.1
  vägsträcka_1_N = mkN "vägsträcka" ; -- vägsträcka..nn.1
  vägtistel_1_N = mkN "vägtistel" ; -- vägtistel..nn.1
  vägtorn_1_N = mkN "vägtorn" ; -- vägtorn..nn.1
  vägtrafik_1_N = mkN "vägtrafik" ; -- vägtrafik..nn.1
  vägtrumma_1_N = mkN "vägtrumma" ; -- vägtrumma..nn.1
  vägtull_1_N = mkN "vägtull" ; -- vägtull..nn.1
  vägtunnel_1_N = mkN "vägtunnel" ; -- vägtunnel..nn.1
  vägval_1_N = mkN "vägval" neutrum  ; -- vägval..nn.1
  vägverk_1_N = mkN "vägverk" neutrum  ; -- vägverk..nn.1
  vägvill_1_A = mkA "vägvill" ; -- vägvill..av.1
  vägvillhet_1_N = mkN "vägvillhet" ; -- vägvillhet..nn.1
  vägvinnande_1_A = mkA "vägvinnande" ; -- vägvinnande..av.1
  vägvisare_1_N = mkN "vägvisare" utrum  ; -- vägvisare..nn.1
  vägvårda_1_N = mkN "vägvårda" ; -- vägvårda..nn.1
  vägövergång_1_N = mkN "vägövergång" ; -- vägövergång..nn.1
  väja_1_V = mkV "väja" "väjde" "väjt" ; -- väja..vb.1
  väjande_1_N = mkN "väjande" ; -- väjande..nn.1
  väjning_1_N = mkN "väjning" ; -- väjning..nn.1
  väkt_1_N = mkN "väkt" "väkter" ; -- väkt..nn.1
  väktare_1_N = mkN "väktare" utrum  ; -- väktare..nn.1
  väl_1_N = mkN "väl" ; -- väl..nn.1
  väl_2_1_Adv = mkAdv "väl" ; -- väl_2..ab.1
  välaktad_1_A = mkA "välaktad" ; -- välaktad..av.1
  välanpassad_1_A = mkA "välanpassad" ; -- välanpassad..av.1
  välansad_1_A = mkA "välansad" ; -- välansad..av.1
  välartad_1_A = mkA "välartad" ; -- välartad..av.1
  välartikulerad_1_A = mkA "välartikulerad" ; -- välartikulerad..av.1
  välavlönad_1_A = mkA "välavlönad" ; -- välavlönad..av.1
  välavvägd_1_A = mkA "välavvägd" "välavvägt" ; -- välavvägd..av.1
  välavvägdhet_1_N = mkN "välavvägdhet" ; -- välavvägdhet..nn.1
  välbalanserad_1_A = mkA "välbalanserad" ; -- välbalanserad..av.1
  välbefinnande_1_N = mkN "välbefinnande" ; -- välbefinnande..nn.1
  välbefogad_1_A = mkA "välbefogad" ; -- välbefogad..av.1
  välbegriplig_1_A = mkA "välbegriplig" ; -- välbegriplig..av.1
  välbegriplighet_1_N = mkN "välbegriplighet" ; -- välbegriplighet..nn.1
  välbehag_1_N = mkN "välbehag" neutrum  ; -- välbehag..nn.1
  välbehaglig_1_A = mkA "välbehaglig" ; -- välbehaglig..av.1
  välbehållen_1_A = mkA "välbehållen" ; -- välbehållen..av.1
  välbehövlig_1_A = mkA "välbehövlig" ; -- välbehövlig..av.1
  välbehövlighet_1_N = mkN "välbehövlighet" ; -- välbehövlighet..nn.1
  välbekant_1_A = mkA "välbekant" "välbekant" ; -- välbekant..av.1
  välbelägen_1_A = mkA "välbelägen" ; -- välbelägen..av.1
  välbemedlad_1_A = mkA "välbemedlad" ; -- välbemedlad..av.1
  välbeprövad_1_A = mkA "välbeprövad" ; -- välbeprövad..av.1
  välberäknad_1_A = mkA "välberäknad" ; -- välberäknad..av.1
  välbesatt_1_A = mkA "välbesatt" ; -- välbesatt..av.1
  välbeställd_1_A = mkA "välbeställd" "välbeställt" ; -- välbeställd..av.1
  välbeställdhet_1_N = mkN "välbeställdhet" ; -- välbeställdhet..nn.1
  välbesökt_1_A = mkA "välbesökt" "välbesökt" ; -- välbesökt..av.1
  välbesökthet_1_N = mkN "välbesökthet" ; -- välbesökthet..nn.1
  välbetald_1_A = mkA "välbetald" "välbetalt" ; -- välbetald..av.1
  välbetaldhet_1_N = mkN "välbetaldhet" ; -- välbetaldhet..nn.1
  välbetänkt_1_A = mkA "välbetänkt" "välbetänkt" ; -- välbetänkt..av.1
  välbetänkthet_1_N = mkN "välbetänkthet" ; -- välbetänkthet..nn.1
  välbevakad_1_A = mkA "välbevakad" ; -- välbevakad..av.1
  välbevarad_1_A = mkA "välbevarad" ; -- välbevarad..av.1
  välbeväpnad_1_A = mkA "välbeväpnad" ; -- välbeväpnad..av.1
  välbildad_1_A = mkA "välbildad" ; -- välbildad..av.1
  välboren_1_A = mkA "välboren" ; -- välboren..av.1
  välborstad_1_A = mkA "välborstad" ; -- välborstad..av.1
  välbyggd_1_A = mkA "välbyggd" "välbyggt" ; -- välbyggd..av.1
  välbärgad_1_A = mkA "välbärgad" ; -- välbärgad..av.1
  väld_1_N = mkN "väld" ; -- väld..nn.1
  väldans_1_Adv = mkAdv "väldans" ; -- väldans..ab.1
  väldaterad_1_A = mkA "väldaterad" ; -- väldaterad..av.1
  välde_1_N = mkN "välde" ; -- välde..nn.1
  väldefinierad_1_A = mkA "väldefinierad" ; -- väldefinierad..av.1
  väldeliga_1_Adv = mkAdv "väldeliga" ; -- väldeliga..ab.1
  väldeligen_1_Adv = mkAdv "väldeligen" ; -- väldeligen..ab.1
  väldig_1_A = mkA "väldig" ; -- väldig..av.1
  väldighet_1_N = mkN "väldighet" "väldigheter" ; -- väldighet..nn.1
  väldoftande_1_A = mkA "väldoftande" ; -- väldoftande..av.1
  väldokumenterad_1_A = mkA "väldokumenterad" ; -- väldokumenterad..av.1
  väldränerad_1_A = mkA "väldränerad" ; -- väldränerad..av.1
  väletablerad_1_A = mkA "väletablerad" ; -- väletablerad..av.1
  välformad_1_A = mkA "välformad" ; -- välformad..av.1
  välformulerad_1_A = mkA "välformulerad" ; -- välformulerad..av.1
  välfriserad_1_A = mkA "välfriserad" ; -- välfriserad..av.1
  välfungerande_1_A = mkA "välfungerande" ; -- välfungerande..av.1
  välfunnen_1_A = mkA "välfunnen" "välfunnet" "välfunna" "välfunna" "välfunnare" "välfunnast" "välfunnaste" ; -- välfunnen..av.1
  välfylld_1_A = mkA "välfylld" "välfyllt" ; -- välfylld..av.1
  välfägna_1_V = mkV "välfägnar" ; -- välfägna..vb.1
  välfägnad_1_N = mkN "välfägnad" "välfägnader" ; -- välfägnad..nn.1
  välfägnande_1_N = mkN "välfägnande" ; -- välfägnande..nn.1
  välfärd_1_N = mkN "välfärd" ; -- välfärd..nn.1
  välfärdsbygge_1_N = mkN "välfärdsbygge" ; -- välfärdsbygge..nn.1
  välfärdsideologi_1_N = mkN "välfärdsideologi" "välfärdsideologier" ; -- välfärdsideologi..nn.1
  välfärdskris_1_N = mkN "välfärdskris" "välfärdskriser" ; -- välfärdskris..nn.1
  välfärdslöfte_1_N = mkN "välfärdslöfte" ; -- välfärdslöfte..nn.1
  välfärdspolitik_1_N = mkN "välfärdspolitik" ; -- välfärdspolitik..nn.1
  välfärdspolitisk_1_A = mkA "välfärdspolitisk" ; -- välfärdspolitisk..av.1
  välfärdssamhälle_1_N = mkN "välfärdssamhälle" ; -- välfärdssamhälle..nn.1
  välfärdssjukdom_1_N = mkN "välfärdssjukdom" ; -- välfärdssjukdom..nn.1
  välfärdsstat_1_N = mkN "välfärdsstat" "välfärdsstater" ; -- välfärdsstat..nn.1
  välfärdssystem_1_N = mkN "välfärdssystem" neutrum  ; -- välfärdssystem..nn.1
  välfärdstjänst_1_N = mkN "välfärdstjänst" "välfärdstjänster" ; -- välfärdstjänst..nn.1
  välfödd_1_A = mkA "välfödd" ; -- välfödd..av.1
  välförankrad_1_A = mkA "välförankrad" ; -- välförankrad..av.1
  välförenlig_1_A = mkA "välförenlig" ; -- välförenlig..av.1
  välförenlighet_1_N = mkN "välförenlighet" ; -- välförenlighet..nn.1
  välförhållande_1_N = mkN "välförhållande" ; -- välförhållande..nn.1
  välförklarlig_1_A = mkA "välförklarlig" ; -- välförklarlig..av.1
  välförklarlighet_1_N = mkN "välförklarlighet" ; -- välförklarlighet..nn.1
  välförrättad_1_A = mkA "välförrättad" ; -- välförrättad..av.1
  välförsedd_1_A = mkA "välförsedd" ; -- välförsedd..av.1
  välförstådd_1_A = mkA "välförstådd" ; -- välförstådd..av.1
  välförståelig_1_A = mkA "välförståelig" ; -- välförståelig..av.1
  välförståelighet_1_N = mkN "välförståelighet" ; -- välförståelighet..nn.1
  välförståndig_1_A = mkA "välförståndig" ; -- välförståndig..av.1
  välförståndighet_1_N = mkN "välförståndighet" ; -- välförståndighet..nn.1
  välförtjänt_1_A = mkA "välförtjänt" "välförtjänt" ; -- välförtjänt..av.1
  välförtjänthet_1_N = mkN "välförtjänthet" ; -- välförtjänthet..nn.1
  välgjord_1_A = mkA "välgjord" "välgjort" ; -- välgjord..av.1
  välgrundad_1_A = mkA "välgrundad" ; -- välgrundad..av.1
  välgärning_1_N = mkN "välgärning" ; -- välgärning..nn.1
  välgång_1_N = mkN "välgång" ; -- välgång..nn.1
  välgångsskål_1_N = mkN "välgångsskål" ; -- välgångsskål..nn.1
  välgångsönskning_1_N = mkN "välgångsönskning" ; -- välgångsönskning..nn.1
  välgödd_1_A = mkA "välgödd" ; -- välgödd..av.1
  välgörande_1_A = mkA "välgörande" ; -- välgörande..av.1
  välgörare_1_N = mkN "välgörare" utrum  ; -- välgörare..nn.1
  välgörenhet_1_N = mkN "välgörenhet" "välgörenheter" ; -- välgörenhet..nn.1
  välgörenhetsauktion_1_N = mkN "välgörenhetsauktion" ; -- välgörenhetsauktion..nn.1
  välgörenhetsbal_1_N = mkN "välgörenhetsbal" "välgörenhetsbaler" ; -- välgörenhetsbal..nn.1
  välgörenhetsbasar_1_N = mkN "välgörenhetsbasar" "välgörenhetsbasarer" ; -- välgörenhetsbasar..nn.1
  välgörenhetsorganisation_1_N = mkN "välgörenhetsorganisation" ; -- välgörenhetsorganisation..nn.1
  välhängd_1_A = mkA "välhängd" "välhängt" ; -- välhängd..av.1
  välhållen_1_A = mkA "välhållen" ; -- välhållen..av.1
  välinformerad_1_A = mkA "välinformerad" ; -- välinformerad..av.1
  välisolerad_1_A = mkA "välisolerad" ; -- välisolerad..av.1
  välja_1_V = mkV "välja" "valde" "valt" ; -- välja..vb.1
  väljande_1_N = mkN "väljande" ; -- väljande..nn.1
  väljarandel_1_N = mkN "väljarandel" "väljarandelen" "väljarandelar" "väljarandelarna" ; -- väljarandel..nn.1
  väljarbarometer_1_N = mkN "väljarbarometer" ; -- väljarbarometer..nn.1
  väljare_1_N = mkN "väljare" utrum  ; -- väljare..nn.1
  väljarflykt_1_N = mkN "väljarflykt" ; -- väljarflykt..nn.1
  väljarkår_1_N = mkN "väljarkår" "väljarkårer" ; -- väljarkår..nn.1
  väljarrevolt_1_N = mkN "väljarrevolt" "väljarrevolter" ; -- väljarrevolt..nn.1
  väljarskara_1_N = mkN "väljarskara" ; -- väljarskara..nn.1
  väljarstöd_1_N = mkN "väljarstöd" neutrum  ; -- väljarstöd..nn.1
  väljarundersökning_1_N = mkN "väljarundersökning" ; -- väljarundersökning..nn.1
  välkammad_1_A = mkA "välkammad" ; -- välkammad..av.1
  välklang_1_N = mkN "välklang" ; -- välklang..nn.1
  välklingande_1_A = mkA "välklingande" ; -- välklingande..av.1
  välklädd_1_A = mkA "välklädd" ; -- välklädd..av.1
  välkläddhet_1_N = mkN "välkläddhet" ; -- välkläddhet..nn.1
  välkomma_1_N = mkN "välkomma" ; -- välkomma..nn.1
  välkommen_1_A = mkA "välkommen" "välkommet" "välkomna" "välkomna" "välkomnare" "välkomnast" "välkomnaste" ; -- välkommen..av.1
  välkomna_1_V = mkV "välkomnar" ; -- välkomna..vb.1
  välkomnande_1_N = mkN "välkomnande" ; -- välkomnande..nn.1
  välkomst_1_N = mkN "välkomst" ; -- välkomst..nn.1
  välkomstbägare_1_N = mkN "välkomstbägare" utrum  ; -- välkomstbägare..nn.1
  välkomstfest_1_N = mkN "välkomstfest" "välkomstfester" ; -- välkomstfest..nn.1
  välkomstfrukost_1_N = mkN "välkomstfrukost" ; -- välkomstfrukost..nn.1
  välkomsthälsning_1_N = mkN "välkomsthälsning" ; -- välkomsthälsning..nn.1
  välkomstmiddag_1_N = mkN "välkomstmiddag" ; -- välkomstmiddag..nn.1
  välkomstskål_1_N = mkN "välkomstskål" ; -- välkomstskål..nn.1
  välkomsttal_1_N = mkN "välkomsttal" neutrum  ; -- välkomsttal..nn.1
  välkryddad_1_A = mkA "välkryddad" ; -- välkryddad..av.1
  välkänd_1_A = mkA "välkänd" ; -- välkänd..av.1
  välkändhet_1_N = mkN "välkändhet" ; -- välkändhet..nn.1
  väll_1_N = mkN "väll" ; -- väll..nn.1
  välla_1_V = mkV "väller" ; -- välla..vb.1
  vällagad_1_A = mkA "vällagad" ; -- vällagad..av.1
  vällagrad_1_A = mkA "vällagrad" ; -- vällagrad..av.1
  vällande_1_N = mkN "vällande" ; -- vällande..nn.1
  vällevnad_1_N = mkN "vällevnad" "vällevnader" ; -- vällevnad..nn.1
  välling_1_N = mkN "välling" ; -- välling..nn.1
  vällingklocka_1_N = mkN "vällingklocka" ; -- vällingklocka..nn.1
  vällingliknande_1_A = mkA "vällingliknande" ; -- vällingliknande..av.1
  välljud_1_N = mkN "välljud" neutrum  ; -- välljud..nn.1
  välljudande_1_A = mkA "välljudande" ; -- välljudande..av.1
  välljärn_1_N = mkN "välljärn" neutrum  ; -- välljärn..nn.1
  vällning_1_N = mkN "vällning" ; -- vällning..nn.1
  vällovlig_1_A = mkA "vällovlig" ; -- vällovlig..av.1
  vällovlighet_1_N = mkN "vällovlighet" ; -- vällovlighet..nn.1
  vällstål_1_N = mkN "vällstål" neutrum  ; -- vällstål..nn.1
  vällsvetsning_1_N = mkN "vällsvetsning" ; -- vällsvetsning..nn.1
  vällukt_1_N = mkN "vällukt" ; -- vällukt..nn.1
  välluktande_1_A = mkA "välluktande" ; -- välluktande..av.1
  vällust_1_N = mkN "vällust" ; -- vällust..nn.1
  vällustig_1_A = mkA "vällustig" ; -- vällustig..av.1
  vällustighet_1_N = mkN "vällustighet" ; -- vällustighet..nn.1
  vällusting_1_N = mkN "vällusting" ; -- vällusting..nn.1
  vällyckad_1_A = mkA "vällyckad" ; -- vällyckad..av.1
  välmatad_1_A = mkA "välmatad" ; -- välmatad..av.1
  välmenande_1_A = mkA "välmenande" ; -- välmenande..av.1
  välmening_1_N = mkN "välmening" ; -- välmening..nn.1
  välment_1_A = mkA "välment" "välment" ; -- välment..av.1
  välmenthet_1_N = mkN "välmenthet" ; -- välmenthet..nn.1
  välmeriterad_1_A = mkA "välmeriterad" ; -- välmeriterad..av.1
  välmotiverad_1_A = mkA "välmotiverad" ; -- välmotiverad..av.1
  välmående_1_A = mkA "välmående" ; -- välmående..av.1
  välmåga_1_N = mkN "välmåga" ; -- välmåga..nn.1
  välnärd_1_A = mkA "välnärd" "välnärt" ; -- välnärd..av.1
  välnärdhet_1_N = mkN "välnärdhet" ; -- välnärdhet..nn.1
  väloljad_1_A = mkA "väloljad" ; -- väloljad..av.1
  välondulerad_1_A = mkA "välondulerad" ; -- välondulerad..av.1
  välordnad_1_A = mkA "välordnad" ; -- välordnad..av.1
  välorganiserad_1_A = mkA "välorganiserad" ; -- välorganiserad..av.1
  välplacerad_1_A = mkA "välplacerad" ; -- välplacerad..av.1
  välplanerad_1_A = mkA "välplanerad" ; -- välplanerad..av.1
  välplägad_1_A = mkA "välplägad" ; -- välplägad..av.1
  välplöjd_1_A = mkA "välplöjd" "välplöjt" ; -- välplöjd..av.1
  välpolerad_1_A = mkA "välpolerad" ; -- välpolerad..av.1
  välpressad_1_A = mkA "välpressad" ; -- välpressad..av.1
  välproportionerad_1_A = mkA "välproportionerad" ; -- välproportionerad..av.1
  välputsad_1_A = mkA "välputsad" ; -- välputsad..av.1
  välregisserad_1_A = mkA "välregisserad" ; -- välregisserad..av.1
  välrenommerad_1_A = mkA "välrenommerad" ; -- välrenommerad..av.1
  välriktad_1_A = mkA "välriktad" ; -- välriktad..av.1
  välrustad_1_A = mkA "välrustad" ; -- välrustad..av.1
  välsedd_1_A = mkA "välsedd" ; -- välsedd..av.1
  välsigna_1_V = mkV "välsignar" ; -- välsigna..vb.1
  välsignad_1_A = mkA "välsignad" ; -- välsignad..av.1
  välsignande_1_N = mkN "välsignande" ; -- välsignande..nn.1
  välsigne_1_V = mkV "välsigne" ; -- välsigne..vb.1
  välsignelse_1_N = mkN "välsignelse" "välsignelser" ; -- välsignelse..nn.1
  välsignelsebringande_1_A = mkA "välsignelsebringande" ; -- välsignelsebringande..av.1
  välsinnad_1_A = mkA "välsinnad" ; -- välsinnad..av.1
  välsittande_1_A = mkA "välsittande" ; -- välsittande..av.1
  välsituerad_1_A = mkA "välsituerad" ; -- välsituerad..av.1
  välsjungande_1_A = mkA "välsjungande" ; -- välsjungande..av.1
  välsk_1_A = mkA "välsk" ; -- välsk..av.1
  välskapad_1_A = mkA "välskapad" ; -- välskapad..av.1
  välskapt_1_A = mkA "välskapt" "välskapt" ; -- välskapt..av.1
  välskapthet_1_N = mkN "välskapthet" ; -- välskapthet..nn.1
  välskhet_1_N = mkN "välskhet" ; -- välskhet..nn.1
  välskjutande_1_A = mkA "välskjutande" ; -- välskjutande..av.1
  välskriven_1_A = mkA "välskriven" ; -- välskriven..av.1
  välskrivning_1_N = mkN "välskrivning" ; -- välskrivning..nn.1
  välskrivningsfröken_1_N = mkN "välskrivningsfröken" ; -- välskrivningsfröken..nn.1
  välskräddad_1_A = mkA "välskräddad" ; -- välskräddad..av.1
  välskuren_1_A = mkA "välskuren" ; -- välskuren..av.1
  välskött_1_A = mkA "välskött" ; -- välskött..av.1
  välskötthet_1_N = mkN "välskötthet" ; -- välskötthet..nn.1
  välsmakande_1_A = mkA "välsmakande" ; -- välsmakande..av.1
  välsmord_1_A = mkA "välsmord" "välsmort" ; -- välsmord..av.1
  välsmordhet_1_N = mkN "välsmordhet" ; -- välsmordhet..nn.1
  välsorterad_1_A = mkA "välsorterad" ; -- välsorterad..av.1
  välspelad_1_A = mkA "välspelad" ; -- välspelad..av.1
  välspelande_1_A = mkA "välspelande" ; -- välspelande..av.1
  välspäckad_1_A = mkA "välspäckad" ; -- välspäckad..av.1
  välstekt_1_A = mkA "välstekt" "välstekt" ; -- välstekt..av.1
  välstrukturerad_1_A = mkA "välstrukturerad" ; -- välstrukturerad..av.1
  välstädad_1_A = mkA "välstädad" ; -- välstädad..av.1
  välställd_1_A = mkA "välställd" "välställt" ; -- välställd..av.1
  välställdhet_1_N = mkN "välställdhet" ; -- välställdhet..nn.1
  välstånd_1_N = mkN "välstånd" neutrum  ; -- välstånd..nn.1
  välståndssjukdom_1_N = mkN "välståndssjukdom" ; -- välståndssjukdom..nn.1
  välsvarvad_1_A = mkA "välsvarvad" ; -- välsvarvad..av.1
  välsydd_1_A = mkA "välsydd" ; -- välsydd..av.1
  vält_1_N = mkN "vält" ; -- vält..nn.1
  välta_1_N = mkN "välta" ; -- välta..nn.1
  välta_1_V = mkV "välta" "välter" "vält" "välte" "vält" "vält" ; -- välta..vb.1
  välta_2_V = mkV "vältar" ; -- välta..vb.2
  vältagen_1_A = mkA "vältagen" ; -- vältagen..av.1
  vältalare_1_N = mkN "vältalare" utrum  ; -- vältalare..nn.1
  vältalig_1_A = mkA "vältalig" ; -- vältalig..av.1
  vältalighet_1_N = mkN "vältalighet" "vältaligheter" ; -- vältalighet..nn.1
  vältande_1_N = mkN "vältande" ; -- vältande..nn.1
  vältra_1_V = mkV "vältrar" ; -- vältra..vb.1
  vältrande_1_N = mkN "vältrande" ; -- vältrande..nn.1
  vältrimmad_1_A = mkA "vältrimmad" ; -- vältrimmad..av.1
  vältränad_1_A = mkA "vältränad" ; -- vältränad..av.1
  vältuktad_1_A = mkA "vältuktad" ; -- vältuktad..av.1
  välturnerad_1_A = mkA "välturnerad" ; -- välturnerad..av.1
  välunderrättad_1_A = mkA "välunderrättad" ; -- välunderrättad..av.1
  väluniformerad_1_A = mkA "väluniformerad" ; -- väluniformerad..av.1
  väluppfostrad_1_A = mkA "väluppfostrad" ; -- väluppfostrad..av.1
  välutbildad_1_A = mkA "välutbildad" ; -- välutbildad..av.1
  välutrustad_1_A = mkA "välutrustad" ; -- välutrustad..av.1
  välutvecklad_1_A = mkA "välutvecklad" ; -- välutvecklad..av.1
  välva_1_V = mkV "välver" ; -- välva..vb.1
  välvande_1_N = mkN "välvande" ; -- välvande..nn.1
  välvd_1_A = mkA "välvd" "välvt" ; -- välvd..av.1
  välvdhet_1_N = mkN "välvdhet" ; -- välvdhet..nn.1
  välventilerad_1_A = mkA "välventilerad" ; -- välventilerad..av.1
  välvilja_1_N = mkN "välvilja" ; -- välvilja..nn.1
  välvillig_1_A = mkA "välvillig" ; -- välvillig..av.1
  välvillighet_1_N = mkN "välvillighet" "välvilligheter" ; -- välvillighet..nn.1
  välvis_1_A = mkA "välvis" ; -- välvis..av.1
  välvishet_1_N = mkN "välvishet" ; -- välvishet..nn.1
  välvning_1_N = mkN "välvning" ; -- välvning..nn.1
  välvuxen_1_A = mkA "välvuxen" ; -- välvuxen..av.1
  välväxt_1_A = mkA "välväxt" "välväxt" ; -- välväxt..av.1
  välväxthet_1_N = mkN "välväxthet" ; -- välväxthet..nn.1
  välvårdad_1_A = mkA "välvårdad" ; -- välvårdad..av.1
  välältad_1_A = mkA "välältad" ; -- välältad..av.1
  välönskning_1_N = mkN "välönskning" ; -- välönskning..nn.1
  vämja_1_V = mkV "vämja" "vämjde" "vämjt" ; -- vämja..vb.1
  vämjande_1_N = mkN "vämjande" ; -- vämjande..nn.1
  vämjelig_1_A = mkA "vämjelig" ; -- vämjelig..av.1
  vämjelighet_1_N = mkN "vämjelighet" "vämjeligheter" ; -- vämjelighet..nn.1
  vämjelse_1_N = mkN "vämjelse" utrum  ; -- vämjelse..nn.1
  vän_1_A = mkA "vän" ; -- vän..av.1
  vän_1_N = mkN "vän" "vännen" "vänner" "vännerna" ; -- vän..nn.1
  vända_1_N = mkN "vända" ; -- vända..nn.1
  vända_1_V = mkV "vänder" ; -- vända..vb.1
  vända_2_V = mkV "vänder" ; -- vända..vb.2
  vändande_1_N = mkN "vändande" ; -- vändande..nn.1
  vändbar_1_A = mkA "vändbar" ; -- vändbar..av.1
  vändbarhet_1_N = mkN "vändbarhet" ; -- vändbarhet..nn.1
  vändelrot_1_N = mkN "vändelrot" "vändelrötter" ; -- vändelrot..nn.1
  vändkors_1_N = mkN "vändkors" neutrum  ; -- vändkors..nn.1
  vändkrets_1_N = mkN "vändkrets" ; -- vändkrets..nn.1
  vändning_1_N = mkN "vändning" ; -- vändning..nn.1
  vändplats_1_N = mkN "vändplats" "vändplatser" ; -- vändplats..nn.1
  vändpunkt_1_N = mkN "vändpunkt" "vändpunkter" ; -- vändpunkt..nn.1
  vändradie_1_N = mkN "vändradie" "vändradier" ; -- vändradie..nn.1
  vändrostning_1_N = mkN "vändrostning" ; -- vändrostning..nn.1
  vändskiva_1_N = mkN "vändskiva" ; -- vändskiva..nn.1
  vändsteka_1_V = mkV "vändsteker" ; -- vändsteka..vb.1
  vändsydd_1_A = mkA "vändsydd" ; -- vändsydd..av.1
  vänfast_1_A = mkA "vänfast" "vänfast" ; -- vänfast..av.1
  vänfasthet_1_N = mkN "vänfasthet" ; -- vänfasthet..nn.1
  vängåva_1_N = mkN "vängåva" ; -- vängåva..nn.1
  vänhet_1_N = mkN "vänhet" ; -- vänhet..nn.1
  väninna_1_N = mkN "väninna" ; -- väninna..nn.1
  vänja_1_V = mkV "vänja" "vande" "vant" ; -- vänja..vb.1
  vänjande_1_N = mkN "vänjande" ; -- vänjande..nn.1
  vänkrets_1_N = mkN "vänkrets" ; -- vänkrets..nn.1
  vänkär_1_A = mkA "vänkär" ; -- vänkär..av.1
  vänlig_1_A = mkA "vänlig" ; -- vänlig..av.1
  vänligen_1_Adv = mkAdv "vänligen" ; -- vänligen..ab.1
  vänlighet_1_N = mkN "vänlighet" "vänligheter" ; -- vänlighet..nn.1
  vänlighet_2_N = mkN "vänlighet" ; -- vänlighet..nn.2
  vänort_1_N = mkN "vänort" "vänorter" ; -- vänort..nn.1
  vänpris_1_N = mkN "vänpris" neutrum  ; -- vänpris..nn.1
  vänskap_1_N = mkN "vänskap" ; -- vänskap..nn.1
  vänskaplig_1_A = mkA "vänskaplig" ; -- vänskaplig..av.1
  vänskapligen_1_Adv = mkAdv "vänskapligen" ; -- vänskapligen..ab.1
  vänskaplighet_1_N = mkN "vänskaplighet" "vänskapligheter" ; -- vänskaplighet..nn.1
  vänskapsband_1_N = mkN "vänskapsband" neutrum  ; -- vänskapsband..nn.1
  vänskapsfull_1_A = mkA "vänskapsfull" ; -- vänskapsfull..av.1
  vänskapsförbindelse_1_N = mkN "vänskapsförbindelse" "vänskapsförbindelser" ; -- vänskapsförbindelse..nn.1
  vänskapskram_1_N = mkN "vänskapskram" ; -- vänskapskram..nn.1
  vänskapsmatch_1_N = mkN "vänskapsmatch" "vänskapsmatcher" ; -- vänskapsmatch..nn.1
  vänskapspris_1_N = mkN "vänskapspris" neutrum  ; -- vänskapspris..nn.1
  vänslande_1_N = mkN "vänslande" ; -- vänslande..nn.1
  vänster_1_N = mkN "vänster" ; -- vänster..nn.1
  vänster_2_N = mkN "vänster" ; -- vänster..nn.2
  vänsteranhängare_1_N = mkN "vänsteranhängare" utrum  ; -- vänsteranhängare..nn.1
  vänsterarm_1_N = mkN "vänsterarm" ; -- vänsterarm..nn.1
  vänsterben_1_N = mkN "vänsterben" neutrum  ; -- vänsterben..nn.1
  vänsterextrem_1_A = mkA "vänsterextrem" ; -- vänsterextrem..av.1
  vänsterextremism_1_N = mkN "vänsterextremism" ; -- vänsterextremism..nn.1
  vänsterextremistisk_1_A = mkA "vänsterextremistisk" ; -- vänsterextremistisk..av.1
  vänsterflygel_1_N = mkN "vänsterflygel" ; -- vänsterflygel..nn.1
  vänsterfot_1_N = mkN "vänsterfot" "vänsterfötter" ; -- vänsterfot..nn.1
  vänsterfäste_1_N = mkN "vänsterfäste" ; -- vänsterfäste..nn.1
  vänstergir_1_N = mkN "vänstergir" ; -- vänstergir..nn.1
  vänstergängad_1_A = mkA "vänstergängad" ; -- vänstergängad..av.1
  vänsterhand_1_N = mkN "vänsterhand" "vänsterhänder" ; -- vänsterhand..nn.1
  vänsterhandsspelare_1_N = mkN "vänsterhandsspelare" utrum  ; -- vänsterhandsspelare..nn.1
  vänsterhänt_1_A = mkA "vänsterhänt" "vänsterhänt" ; -- vänsterhänt..av.1
  vänsterhänthet_1_N = mkN "vänsterhänthet" ; -- vänsterhänthet..nn.1
  vänsterinriktad_1_A = mkA "vänsterinriktad" ; -- vänsterinriktad..av.1
  vänsterintellektuell_1_A = mkA "vänsterintellektuell" ; -- vänsterintellektuell..av.1
  vänsterkant_1_N = mkN "vänsterkant" "vänsterkanter" ; -- vänsterkant..nn.1
  vänsterknapp_1_N = mkN "vänsterknapp" ; -- vänsterknapp..nn.1
  vänsterknix_1_N = mkN "vänsterknix" ; -- vänsterknix..nn.1
  vänsterknäck_1_N = mkN "vänsterknäck" neutrum  ; -- vänsterknäck..nn.1
  vänsterknäcka_1_V = mkV "vänsterknäcker" ; -- vänsterknäcka..vb.1
  vänsterknäckande_1_N = mkN "vänsterknäckande" ; -- vänsterknäckande..nn.1
  vänsterkoalition_1_N = mkN "vänsterkoalition" ; -- vänsterkoalition..nn.1
  vänsterkryss_1_N = mkN "vänsterkryss" neutrum  ; -- vänsterkryss..nn.1
  vänsterkrönikör_1_N = mkN "vänsterkrönikör" "vänsterkrönikörer" ; -- vänsterkrönikör..nn.1
  vänsterkurva_1_N = mkN "vänsterkurva" ; -- vänsterkurva..nn.1
  vänsterliberal_1_A = mkA "vänsterliberal" ; -- vänsterliberal..av.1
  vänsterliberal_1_N = mkN "vänsterliberal" "vänsterliberaler" ; -- vänsterliberal..nn.1
  vänsterman_1_N = mkN "vänsterman" "vänstermannen" "vänstermän" "vänstermännen" ; -- vänsterman..nn.1
  vänstermyt_1_N = mkN "vänstermyt" "vänstermyter" ; -- vänstermyt..nn.1
  vänsteropposition_1_N = mkN "vänsteropposition" ; -- vänsteropposition..nn.1
  vänsteroppositionell_1_A = mkA "vänsteroppositionell" ; -- vänsteroppositionell..av.1
  vänsterparti_1_N = mkN "vänsterparti" "vänsterpartiet" "vänsterpartier" "vänsterpartierna" ; -- vänsterparti..nn.1
  vänsterpartist_1_N = mkN "vänsterpartist" "vänsterpartister" ; -- vänsterpartist..nn.1
  vänsterpolitik_1_N = mkN "vänsterpolitik" ; -- vänsterpolitik..nn.1
  vänsterpolitiker_1_N = mkN "vänsterpolitiker" "vänsterpolitikern" "vänsterpolitiker" "vänsterpolitikerna" ; -- vänsterpolitiker..nn.1
  vänsterpolitisk_1_A = mkA "vänsterpolitisk" ; -- vänsterpolitisk..av.1
  vänsterprassel_1_N = mkN "vänsterprassel" neutrum  ; -- vänsterprassel..nn.1
  vänsterprassla_1_V = mkV "vänsterprasslar" ; -- vänsterprassla..vb.1
  vänsterprasslande_1_N = mkN "vänsterprasslande" ; -- vänsterprasslande..nn.1
  vänsterprofessor_1_N = mkN "vänsterprofessor" "vänsterprofessorer" ; -- vänsterprofessor..nn.1
  vänsterradikal_1_A = mkA "vänsterradikal" ; -- vänsterradikal..av.1
  vänsterradikal_1_N = mkN "vänsterradikal" "vänsterradikaler" ; -- vänsterradikal..nn.1
  vänsterrebell_1_N = mkN "vänsterrebell" "vänsterrebeller" ; -- vänsterrebell..nn.1
  vänsterregering_1_N = mkN "vänsterregering" ; -- vänsterregering..nn.1
  vänstersida_1_N = mkN "vänstersida" ; -- vänstersida..nn.1
  vänstersinnad_1_A = mkA "vänstersinnad" ; -- vänstersinnad..av.1
  vänstersocialism_1_N = mkN "vänstersocialism" "vänstersocialismer" ; -- vänstersocialism..nn.1
  vänstersocialist_1_N = mkN "vänstersocialist" "vänstersocialister" ; -- vänstersocialist..nn.1
  vänstersocialistisk_1_A = mkA "vänstersocialistisk" ; -- vänstersocialistisk..av.1
  vänstersväng_1_N = mkN "vänstersväng" ; -- vänstersväng..nn.1
  vänstersympatiserande_1_A = mkA "vänstersympatiserande" ; -- vänstersympatiserande..av.1
  vänstersympatisör_1_N = mkN "vänstersympatisör" "vänstersympatisörer" ; -- vänstersympatisör..nn.1
  vänstertidning_1_N = mkN "vänstertidning" ; -- vänstertidning..nn.1
  vänstervriden_1_A = mkA "vänstervriden" ; -- vänstervriden..av.1
  vänstervridning_1_N = mkN "vänstervridning" ; -- vänstervridning..nn.1
  vänsteråra_1_N = mkN "vänsteråra" ; -- vänsteråra..nn.1
  vänsteråsikt_1_N = mkN "vänsteråsikt" "vänsteråsikter" ; -- vänsteråsikt..nn.1
  vänsteröga_1_N = mkN "vänsteröga" "vänsterögat" "vänsterögon" "vänsterögonen" ; -- vänsteröga..nn.1
  vänsteröra_1_N = mkN "vänsteröra" "vänsterörat" "vänsteröron" "vänsteröronen" ; -- vänsteröra..nn.1
  vänstra_1_V = mkV "vänstrar" ; -- vänstra..vb.1
  vänstrande_1_N = mkN "vänstrande" ; -- vänstrande..nn.1
  vänsäll_1_A = mkA "vänsäll" ; -- vänsäll..av.1
  vänsällhet_1_N = mkN "vänsällhet" ; -- vänsällhet..nn.1
  vänta_1_V = mkV "väntar" ; -- vänta..vb.1
  väntande_1_N = mkN "väntande" ; -- väntande..nn.1
  väntelista_1_N = mkN "väntelista" ; -- väntelista..nn.1
  väntetid_1_N = mkN "väntetid" "väntetider" ; -- väntetid..nn.1
  väntevärde_1_N = mkN "väntevärde" ; -- väntevärde..nn.1
  vänthall_1_N = mkN "vänthall" ; -- vänthall..nn.1
  väntjänst_1_N = mkN "väntjänst" "väntjänster" ; -- väntjänst..nn.1
  väntrum_1_N = mkN "väntrum" "väntrummet" "väntrum" "väntrummen" ; -- väntrum..nn.1
  väntsal_1_N = mkN "väntsal" ; -- väntsal..nn.1
  väpna_1_V = mkV "väpnar" ; -- väpna..vb.1
  väpnad_1_A = mkA "väpnad" ; -- väpnad..av.1
  väpnande_1_N = mkN "väpnande" ; -- väpnande..nn.1
  väpnare_1_N = mkN "väpnare" utrum  ; -- väpnare..nn.1
  väppling_1_N = mkN "väppling" ; -- väppling..nn.1
  värd_1_A = mkA "värd" "värt" ; -- värd..av.1
  värd_1_N = mkN "värd" ; -- värd..nn.1
  värddjur_1_N = mkN "värddjur" neutrum  ; -- värddjur..nn.1
  värde_1_N = mkN "värde" ; -- värde..nn.1
  värdeanalys_1_N = mkN "värdeanalys" "värdeanalyser" ; -- värdeanalys..nn.1
  värdebeständig_1_A = mkA "värdebeständig" ; -- värdebeständig..av.1
  värdebeständighet_1_N = mkN "värdebeständighet" ; -- värdebeständighet..nn.1
  värdebrev_1_N = mkN "värdebrev" neutrum  ; -- värdebrev..nn.1
  värdefall_1_N = mkN "värdefall" neutrum  ; -- värdefall..nn.1
  värdefast_1_A = mkA "värdefast" "värdefast" ; -- värdefast..av.1
  värdefasthet_1_N = mkN "värdefasthet" ; -- värdefasthet..nn.1
  värdefilosofi_1_N = mkN "värdefilosofi" ; -- värdefilosofi..nn.1
  värdefull_1_A = mkA "värdefull" ; -- värdefull..av.1
  värdefullhet_1_N = mkN "värdefullhet" "värdefullheter" ; -- värdefullhet..nn.1
  värdeföremål_1_N = mkN "värdeföremål" neutrum  ; -- värdeföremål..nn.1
  värdeförlust_1_N = mkN "värdeförlust" "värdeförluster" ; -- värdeförlust..nn.1
  värdeförsändelse_1_N = mkN "värdeförsändelse" "värdeförsändelser" ; -- värdeförsändelse..nn.1
  värdegemenskap_1_N = mkN "värdegemenskap" ; -- värdegemenskap..nn.1
  värdegrund_1_N = mkN "värdegrund" "värdegrunder" ; -- värdegrund..nn.1
  värdegrundsfråga_1_N = mkN "värdegrundsfråga" ; -- värdegrundsfråga..nn.1
  värdehandling_1_N = mkN "värdehandling" ; -- värdehandling..nn.1
  värdehierarki_1_N = mkN "värdehierarki" "värdehierarkier" ; -- värdehierarki..nn.1
  värdekonservativ_1_A = mkA "värdekonservativ" ; -- värdekonservativ..av.1
  värdeladdad_1_A = mkA "värdeladdad" ; -- värdeladdad..av.1
  värdelära_1_N = mkN "värdelära" ; -- värdelära..nn.1
  värdelös_1_A = mkA "värdelös" ; -- värdelös..av.1
  värdelöshet_1_N = mkN "värdelöshet" ; -- värdelöshet..nn.1
  värdeminskning_1_N = mkN "värdeminskning" ; -- värdeminskning..nn.1
  värdemängd_1_N = mkN "värdemängd" "värdemängder" ; -- värdemängd..nn.1
  värdemässig_1_A = mkA "värdemässig" ; -- värdemässig..av.1
  värdemässighet_1_N = mkN "värdemässighet" ; -- värdemässighet..nn.1
  värdemätare_1_N = mkN "värdemätare" utrum  ; -- värdemätare..nn.1
  värdenihilism_1_N = mkN "värdenihilism" "värdenihilismer" ; -- värdenihilism..nn.1
  värdenihilistisk_1_A = mkA "värdenihilistisk" ; -- värdenihilistisk..av.1
  värdeomdöme_1_N = mkN "värdeomdöme" ; -- värdeomdöme..nn.1
  värdeord_1_N = mkN "värdeord" neutrum  ; -- värdeord..nn.1
  värdepapper_1_N = mkN "värdepapper" neutrum  ; -- värdepapper..nn.1
  värdepappersfond_1_N = mkN "värdepappersfond" "värdepappersfonder" ; -- värdepappersfond..nn.1
  värdepappershandel_1_N = mkN "värdepappershandel" ; -- värdepappershandel..nn.1
  värdepappersmarknad_1_N = mkN "värdepappersmarknad" "värdepappersmarknader" ; -- värdepappersmarknad..nn.1
  värdepost_1_N = mkN "värdepost" ; -- värdepost..nn.1
  värdera_1_V = mkV "värderar" ; -- värdera..vb.1
  värderande_1_N = mkN "värderande" ; -- värderande..nn.1
  värderare_1_N = mkN "värderare" utrum  ; -- värderare..nn.1
  värderbar_1_A = mkA "värderbar" ; -- värderbar..av.1
  värderbarhet_1_N = mkN "värderbarhet" ; -- värderbarhet..nn.1
  värdering_1_N = mkN "värdering" ; -- värdering..nn.1
  värderingsfri_1_A = mkA "värderingsfri" "värderingsfritt" ; -- värderingsfri..av.1
  värderingsinstrument_1_N = mkN "värderingsinstrument" neutrum  ; -- värderingsinstrument..nn.1
  värderingsman_1_N = mkN "värderingsman" "värderingsmannen" "värderingsmän" "värderingsmännen" ; -- värderingsman..nn.1
  värderingsmässig_1_A = mkA "värderingsmässig" ; -- värderingsmässig..av.1
  värderingsnorm_1_N = mkN "värderingsnorm" "värderingsnormer" ; -- värderingsnorm..nn.1
  värderingsskifte_1_N = mkN "värderingsskifte" ; -- värderingsskifte..nn.1
  värderån_1_N = mkN "värderån" neutrum  ; -- värderån..nn.1
  värdesak_1_N = mkN "värdesak" "värdesaker" ; -- värdesak..nn.1
  värdeskala_1_N = mkN "värdeskala" ; -- värdeskala..nn.1
  värdeskapande_1_A = mkA "värdeskapande" ; -- värdeskapande..av.1
  värdestegring_1_N = mkN "värdestegring" ; -- värdestegring..nn.1
  värdestruktur_1_N = mkN "värdestruktur" "värdestrukturer" ; -- värdestruktur..nn.1
  värdesäker_1_A = mkA "värdesäker" ; -- värdesäker..av.1
  värdesäkerhet_1_N = mkN "värdesäkerhet" ; -- värdesäkerhet..nn.1
  värdesäkra_1_V = mkV "värdesäkrar" ; -- värdesäkra..vb.1
  värdesäkrande_1_N = mkN "värdesäkrande" ; -- värdesäkrande..nn.1
  värdesätta_1_V = mkV "värdesätta" "värdesätter" "värdesätt" "värdesatte" "värdesatt" "värdesatt" ; -- värdesätta..vb.1
  värdesättande_1_N = mkN "värdesättande" ; -- värdesättande..nn.1
  värdesättning_1_N = mkN "värdesättning" ; -- värdesättning..nn.1
  värdetabell_1_N = mkN "värdetabell" "värdetabeller" ; -- värdetabell..nn.1
  värdeteori_1_N = mkN "värdeteori" ; -- värdeteori..nn.1
  värdetransport_1_N = mkN "värdetransport" "värdetransporter" ; -- värdetransport..nn.1
  värdetransportföretag_1_N = mkN "värdetransportföretag" neutrum  ; -- värdetransportföretag..nn.1
  värdeökning_1_N = mkN "värdeökning" ; -- värdeökning..nn.1
  värdfamilj_1_N = mkN "värdfamilj" "värdfamiljer" ; -- värdfamilj..nn.1
  värdfolk_1_N = mkN "värdfolk" neutrum  ; -- värdfolk..nn.1
  värdhet_1_N = mkN "värdhet" ; -- värdhet..nn.1
  värdig_1_A = mkA "värdig" ; -- värdig..av.1
  värdighet_1_N = mkN "värdighet" "värdigheter" ; -- värdighet..nn.1
  värdighetstecken_1_N = mkN "värdighetstecken" "värdighetstecknet" "värdighetstecken" "värdighetstecknen" ; -- värdighetstecken..nn.1
  värdinna_1_N = mkN "värdinna" ; -- värdinna..nn.1
  värdmolekyl_1_N = mkN "värdmolekyl" "värdmolekyler" ; -- värdmolekyl..nn.1
  värdpar_1_N = mkN "värdpar" neutrum  ; -- värdpar..nn.1
  värdshus_1_N = mkN "värdshus" neutrum  ; -- värdshus..nn.1
  värdshusrörelse_1_N = mkN "värdshusrörelse" "värdshusrörelser" ; -- värdshusrörelse..nn.1
  värdshusvärd_1_N = mkN "värdshusvärd" ; -- värdshusvärd..nn.1
  värdskap_1_N = mkN "värdskap" neutrum  ; -- värdskap..nn.1
  värdväxling_1_N = mkN "värdväxling" ; -- värdväxling..nn.1
  värdväxt_1_N = mkN "värdväxt" "värdväxter" ; -- värdväxt..nn.1
  väring_1_N = mkN "väring" ; -- väring..nn.1
  värja_1_N = mkN "värja" ; -- värja..nn.1
  värja_1_V = mkV "värja" "värjde" "värjt" ; -- värja..vb.1
  värjande_1_N = mkN "värjande" ; -- värjande..nn.1
  värjemålsed_1_N = mkN "värjemålsed" "värjemålseder" ; -- värjemålsed..nn.1
  värjningsskada_1_N = mkN "värjningsskada" ; -- värjningsskada..nn.1
  värjo_1_N = mkN "värjo" ; -- värjo..nn.1
  värjstöt_1_N = mkN "värjstöt" ; -- värjstöt..nn.1
  värk_1_N = mkN "värk" ; -- värk..nn.1
  värka_1_V = mkV "värker" ; -- värka..vb.1
  värkande_1_N = mkN "värkande" ; -- värkande..nn.1
  värkbruten_1_A = mkA "värkbruten" ; -- värkbruten..av.1
  värktablett_1_N = mkN "värktablett" "värktabletter" ; -- värktablett..nn.1
  värld_1_N = mkN "värld" ; -- värld..nn.1
  världens_1_A = mkA "världens" ; -- världens..av.1
  världsallt_1_N = mkN "världsallt" neutrum  ; -- världsallt..nn.1
  världsartist_1_N = mkN "världsartist" "världsartister" ; -- världsartist..nn.1
  världsarv_1_N = mkN "världsarv" neutrum  ; -- världsarv..nn.1
  världsarvslista_1_N = mkN "världsarvslista" ; -- världsarvslista..nn.1
  världsatlas_1_N = mkN "världsatlas" "världsatlaser" ; -- världsatlas..nn.1
  världsaxel_1_N = mkN "världsaxel" ; -- världsaxel..nn.1
  världsbank_1_N = mkN "världsbank" ; -- världsbank..nn.1
  världsbekant_1_A = mkA "världsbekant" "världsbekant" ; -- världsbekant..av.1
  världsberömd_1_A = mkA "världsberömd" "världsberömt" ; -- världsberömd..av.1
  världsberömdhet_1_N = mkN "världsberömdhet" "världsberömdheter" ; -- världsberömdhet..nn.1
  världsberömmelse_1_N = mkN "världsberömmelse" utrum  ; -- världsberömmelse..nn.1
  världsbild_1_N = mkN "världsbild" "världsbilder" ; -- världsbild..nn.1
  världsborgare_1_N = mkN "världsborgare" utrum  ; -- världsborgare..nn.1
  världsbrand_1_N = mkN "världsbrand" "världsbränder" ; -- världsbrand..nn.1
  världsbäst_1_A = mkA "världsbäst" "världsbäst" ; -- världsbäst..av.1
  världscup_1_N = mkN "världscup" "världscuper" ; -- världscup..nn.1
  världsdam_1_N = mkN "världsdam" "världsdamer" ; -- världsdam..nn.1
  världsdel_1_N = mkN "världsdel" "världsdelen" "världsdelar" "världsdelarna" ; -- världsdel..nn.1
  världsekonomi_1_N = mkN "världsekonomi" "världsekonomier" ; -- världsekonomi..nn.1
  världsekonomisk_1_A = mkA "världsekonomisk" ; -- världsekonomisk..av.1
  världselit_1_N = mkN "världselit" "världseliter" ; -- världselit..nn.1
  världselva_1_N = mkN "världselva" ; -- världselva..nn.1
  världserfaren_1_A = mkA "världserfaren" ; -- världserfaren..av.1
  världserfarenhet_1_N = mkN "världserfarenhet" ; -- världserfarenhet..nn.1
  världserövrare_1_N = mkN "världserövrare" utrum  ; -- världserövrare..nn.1
  världsetta_1_N = mkN "världsetta" ; -- världsetta..nn.1
  världsfederalism_1_N = mkN "världsfederalism" "världsfederalismer" ; -- världsfederalism..nn.1
  världsfientlig_1_A = mkA "världsfientlig" ; -- världsfientlig..av.1
  världsfientlighet_1_N = mkN "världsfientlighet" ; -- världsfientlighet..nn.1
  världsformat_1_N = mkN "världsformat" ; -- världsformat..nn.1
  världsfred_1_N = mkN "världsfred" ; -- världsfred..nn.1
  världsfrämmande_1_A = mkA "världsfrämmande" ; -- världsfrämmande..av.1
  världsfrånvarande_1_A = mkA "världsfrånvarande" ; -- världsfrånvarande..av.1
  världsfrånvänd_1_A = mkA "världsfrånvänd" ; -- världsfrånvänd..av.1
  världsfrånvändhet_1_N = mkN "världsfrånvändhet" ; -- världsfrånvändhet..nn.1
  världsförakt_1_N = mkN "världsförakt" neutrum  ; -- världsförakt..nn.1
  världsföraktande_1_A = mkA "världsföraktande" ; -- världsföraktande..av.1
  världsförbättrare_1_N = mkN "världsförbättrare" utrum  ; -- världsförbättrare..nn.1
  världsförsakelse_1_N = mkN "världsförsakelse" "världsförsakelser" ; -- världsförsakelse..nn.1
  världsförsäljning_1_N = mkN "världsförsäljning" ; -- världsförsäljning..nn.1
  världsgenomsnitt_1_N = mkN "världsgenomsnitt" neutrum  ; -- världsgenomsnitt..nn.1
  världsgåta_1_N = mkN "världsgåta" ; -- världsgåta..nn.1
  världshandel_1_N = mkN "världshandel" ; -- världshandel..nn.1
  världshandelsorganisation_1_N = mkN "världshandelsorganisation" ; -- världshandelsorganisation..nn.1
  världshav_1_N = mkN "världshav" neutrum  ; -- världshav..nn.1
  världsherravälde_1_N = mkN "världsherravälde" ; -- världsherravälde..nn.1
  världshistoria_1_N = mkN "världshistoria" ; -- världshistoria..nn.1
  världshistorisk_1_A = mkA "världshistorisk" ; -- världshistorisk..av.1
  världshändelse_1_N = mkN "världshändelse" "världshändelser" ; -- världshändelse..nn.1
  världskapitalism_1_N = mkN "världskapitalism" "världskapitalismer" ; -- världskapitalism..nn.1
  världskarta_1_N = mkN "världskarta" ; -- världskarta..nn.1
  världskedjebrev_1_N = mkN "världskedjebrev" neutrum  ; -- världskedjebrev..nn.1
  världsklass_1_N = mkN "världsklass" ; -- världsklass..nn.1
  världsklok_1_A = mkA "världsklok" ; -- världsklok..av.1
  världsklokhet_1_N = mkN "världsklokhet" ; -- världsklokhet..nn.1
  världskrig_1_N = mkN "världskrig" neutrum  ; -- världskrig..nn.1
  världskänd_1_A = mkA "världskänd" ; -- världskänd..av.1
  världskändhet_1_N = mkN "världskändhet" ; -- världskändhet..nn.1
  världskännedom_1_N = mkN "världskännedom" ; -- världskännedom..nn.1
  världsledande_1_A = mkA "världsledande" ; -- världsledande..av.1
  världslig_1_A = mkA "världslig" ; -- världslig..av.1
  världslighet_1_N = mkN "världslighet" "världsligheter" ; -- världslighet..nn.1
  världslitteratur_1_N = mkN "världslitteratur" ; -- världslitteratur..nn.1
  världsmakt_1_N = mkN "världsmakt" "världsmakter" ; -- världsmakt..nn.1
  världsman_1_N = mkN "världsman" "världsmannen" "världsmän" "världsmännen" ; -- världsman..nn.1
  världsmannamässig_1_A = mkA "världsmannamässig" ; -- världsmannamässig..av.1
  världsmarknad_1_N = mkN "världsmarknad" "världsmarknader" ; -- världsmarknad..nn.1
  världsmedborgare_1_N = mkN "världsmedborgare" utrum  ; -- världsmedborgare..nn.1
  världsmedborgarrörelse_1_N = mkN "världsmedborgarrörelse" "världsmedborgarrörelser" ; -- världsmedborgarrörelse..nn.1
  världsmedvetande_1_N = mkN "världsmedvetande" ; -- världsmedvetande..nn.1
  världsmästare_1_N = mkN "världsmästare" utrum  ; -- världsmästare..nn.1
  världsmästarinna_1_N = mkN "världsmästarinna" ; -- världsmästarinna..nn.1
  världsmästerskap_1_N = mkN "världsmästerskap" neutrum  ; -- världsmästerskap..nn.1
  världsnamn_1_N = mkN "världsnamn" neutrum  ; -- världsnamn..nn.1
  världsnaturfond_1_N = mkN "världsnaturfond" ; -- världsnaturfond..nn.1
  världsomfattande_1_A = mkA "världsomfattande" ; -- världsomfattande..av.1
  världsomsegling_1_N = mkN "världsomsegling" ; -- världsomsegling..nn.1
  världsomspännande_1_A = mkA "världsomspännande" ; -- världsomspännande..av.1
  världsomstörtande_1_A = mkA "världsomstörtande" ; -- världsomstörtande..av.1
  världsomvälvande_1_A = mkA "världsomvälvande" ; -- världsomvälvande..av.1
  världsordning_1_N = mkN "världsordning" ; -- världsordning..nn.1
  världsorganisation_1_N = mkN "världsorganisation" ; -- världsorganisation..nn.1
  världspolitik_1_N = mkN "världspolitik" ; -- världspolitik..nn.1
  världspolitisk_1_A = mkA "världspolitisk" ; -- världspolitisk..av.1
  världspremiär_1_N = mkN "världspremiär" "världspremiärer" ; -- världspremiär..nn.1
  världspress_1_N = mkN "världspress" ; -- världspress..nn.1
  världsranking_1_N = mkN "världsranking" ; -- världsranking..nn.1
  världsrekord_1_N = mkN "världsrekord" neutrum  ; -- världsrekord..nn.1
  världsreligion_1_N = mkN "världsreligion" ; -- världsreligion..nn.1
  världsrevolution_1_N = mkN "världsrevolution" ; -- världsrevolution..nn.1
  världsrykte_1_N = mkN "världsrykte" ; -- världsrykte..nn.1
  världsrymd_1_N = mkN "världsrymd" "världsrymder" ; -- världsrymd..nn.1
  världssamfund_1_N = mkN "världssamfund" neutrum  ; -- världssamfund..nn.1
  världssamvete_1_N = mkN "världssamvete" ; -- världssamvete..nn.1
  världsscoop_1_N = mkN "världsscoop" neutrum  ; -- världsscoop..nn.1
  världssensation_1_N = mkN "världssensation" ; -- världssensation..nn.1
  världssjäl_1_N = mkN "världssjäl" ; -- världssjäl..nn.1
  världssmärta_1_N = mkN "världssmärta" ; -- världssmärta..nn.1
  världsspråk_1_N = mkN "världsspråk" neutrum  ; -- världsspråk..nn.1
  världsstad_1_N = mkN "världsstad" "världsstäder" ; -- världsstad..nn.1
  världssuccé_1_N = mkN "världssuccé" "världssuccéer" ; -- världssuccé..nn.1
  världstid_1_N = mkN "världstid" "världstider" ; -- världstid..nn.1
  världstrea_1_N = mkN "världstrea" ; -- världstrea..nn.1
  världsturné_1_N = mkN "världsturné" "världsturnéer" ; -- världsturné..nn.1
  världsuppfattning_1_N = mkN "världsuppfattning" ; -- världsuppfattning..nn.1
  världsutställning_1_N = mkN "världsutställning" ; -- världsutställning..nn.1
  världsvan_1_A = mkA "världsvan" ; -- världsvan..av.1
  världsvana_1_N = mkN "världsvana" ; -- världsvana..nn.1
  världsvis_1_A = mkA "världsvis" ; -- världsvis..av.1
  världsvishet_1_N = mkN "världsvishet" ; -- världsvishet..nn.1
  världsålder_1_N = mkN "världsålder" ; -- världsålder..nn.1
  världsåsikt_1_N = mkN "världsåsikt" "världsåsikter" ; -- världsåsikt..nn.1
  världsåskådning_1_N = mkN "världsåskådning" ; -- världsåskådning..nn.1
  värma_1_N = mkN "värma" ; -- värma..nn.1
  värma_1_V = mkV "värmer" ; -- värma..vb.1
  värmande_1_N = mkN "värmande" ; -- värmande..nn.1
  värme_1_N = mkN "värme" utrum  ; -- värme..nn.1
  värme_2_N = mkN "värme" ; -- värme..nn.2
  värmeanläggning_1_N = mkN "värmeanläggning" ; -- värmeanläggning..nn.1
  värmeapparat_1_N = mkN "värmeapparat" "värmeapparater" ; -- värmeapparat..nn.1
  värmebehandla_1_V = mkV "värmebehandlar" ; -- värmebehandla..vb.1
  värmebehandlande_1_N = mkN "värmebehandlande" ; -- värmebehandlande..nn.1
  värmebehandling_1_N = mkN "värmebehandling" ; -- värmebehandling..nn.1
  värmebehov_1_N = mkN "värmebehov" neutrum  ; -- värmebehov..nn.1
  värmebeständig_1_A = mkA "värmebeständig" ; -- värmebeständig..av.1
  värmebeständighet_1_N = mkN "värmebeständighet" ; -- värmebeständighet..nn.1
  värmebild_1_N = mkN "värmebild" "värmebilder" ; -- värmebild..nn.1
  värmebildskamera_1_N = mkN "värmebildskamera" ; -- värmebildskamera..nn.1
  värmeblemma_1_N = mkN "värmeblemma" ; -- värmeblemma..nn.1
  värmebölja_1_N = mkN "värmebölja" ; -- värmebölja..nn.1
  värmecentral_1_N = mkN "värmecentral" "värmecentraler" ; -- värmecentral..nn.1
  värmedis_1_N = mkN "värmedis" neutrum  ; -- värmedis..nn.1
  värmedyna_1_N = mkN "värmedyna" ; -- värmedyna..nn.1
  värmedämpning_1_N = mkN "värmedämpning" ; -- värmedämpning..nn.1
  värmedöd_1_N = mkN "värmedöd" ; -- värmedöd..nn.1
  värmeeffekt_1_N = mkN "värmeeffekt" ; -- värmeeffekt..nn.1
  värmeekonomi_1_N = mkN "värmeekonomi" "värmeekonomier" ; -- värmeekonomi..nn.1
  värmeekvivalent_1_N = mkN "värmeekvivalent" ; -- värmeekvivalent..nn.1
  värmeelement_1_N = mkN "värmeelement" neutrum  ; -- värmeelement..nn.1
  värmeenergi_1_N = mkN "värmeenergi" ; -- värmeenergi..nn.1
  värmeenhet_1_N = mkN "värmeenhet" "värmeenheter" ; -- värmeenhet..nn.1
  värmeexpansion_1_N = mkN "värmeexpansion" ; -- värmeexpansion..nn.1
  värmeflaska_1_N = mkN "värmeflaska" ; -- värmeflaska..nn.1
  värmeflöde_1_N = mkN "värmeflöde" ; -- värmeflöde..nn.1
  värmefotografera_1_V = mkV "värmefotograferar" ; -- värmefotografera..vb.1
  värmefotograferande_1_N = mkN "värmefotograferande" ; -- värmefotograferande..nn.1
  värmefotograferbar_1_A = mkA "värmefotograferbar" ; -- värmefotograferbar..av.1
  värmefotograferbarhet_1_N = mkN "värmefotograferbarhet" ; -- värmefotograferbarhet..nn.1
  värmefotografering_1_N = mkN "värmefotografering" ; -- värmefotografering..nn.1
  värmeförlust_1_N = mkN "värmeförlust" "värmeförluster" ; -- värmeförlust..nn.1
  värmegenomgång_1_N = mkN "värmegenomgång" ; -- värmegenomgång..nn.1
  värmegenomgångstal_1_N = mkN "värmegenomgångstal" neutrum  ; -- värmegenomgångstal..nn.1
  värmegrad_1_N = mkN "värmegrad" "värmegrader" ; -- värmegrad..nn.1
  värmeisolator_1_N = mkN "värmeisolator" "värmeisolatorer" ; -- värmeisolator..nn.1
  värmeisolera_1_V = mkV "värmeisolerar" ; -- värmeisolera..vb.1
  värmeisolerande_1_A = mkA "värmeisolerande" ; -- värmeisolerande..av.1
  värmeisolerande_1_N = mkN "värmeisolerande" ; -- värmeisolerande..nn.1
  värmeisolerbar_1_A = mkA "värmeisolerbar" ; -- värmeisolerbar..av.1
  värmeisolerbarhet_1_N = mkN "värmeisolerbarhet" ; -- värmeisolerbarhet..nn.1
  värmeisolering_1_N = mkN "värmeisolering" ; -- värmeisolering..nn.1
  värmekamera_1_N = mkN "värmekamera" ; -- värmekamera..nn.1
  värmekapacitet_1_N = mkN "värmekapacitet" "värmekapaciteter" ; -- värmekapacitet..nn.1
  värmekapacitivitet_1_N = mkN "värmekapacitivitet" "värmekapacitiviteter" ; -- värmekapacitivitet..nn.1
  värmekonduktivitet_1_N = mkN "värmekonduktivitet" "värmekonduktiviteter" ; -- värmekonduktivitet..nn.1
  värmekostnad_1_N = mkN "värmekostnad" "värmekostnader" ; -- värmekostnad..nn.1
  värmekraftverk_1_N = mkN "värmekraftverk" neutrum  ; -- värmekraftverk..nn.1
  värmekrus_1_N = mkN "värmekrus" neutrum  ; -- värmekrus..nn.1
  värmekälla_1_N = mkN "värmekälla" ; -- värmekälla..nn.1
  värmelampa_1_N = mkN "värmelampa" ; -- värmelampa..nn.1
  värmeledande_1_A = mkA "värmeledande" ; -- värmeledande..av.1
  värmeledare_1_N = mkN "värmeledare" utrum  ; -- värmeledare..nn.1
  värmeledning_1_N = mkN "värmeledning" ; -- värmeledning..nn.1
  värmeledningspanna_1_N = mkN "värmeledningspanna" ; -- värmeledningspanna..nn.1
  värmeledningssystem_1_N = mkN "värmeledningssystem" neutrum  ; -- värmeledningssystem..nn.1
  värmeljus_1_N = mkN "värmeljus" neutrum  ; -- värmeljus..nn.1
  värmelära_1_N = mkN "värmelära" ; -- värmelära..nn.1
  värmemotor_1_N = mkN "värmemotor" "värmemotorer" ; -- värmemotor..nn.1
  värmemängd_1_N = mkN "värmemängd" "värmemängder" ; -- värmemängd..nn.1
  värmemätare_1_N = mkN "värmemätare" utrum  ; -- värmemätare..nn.1
  värmemått_1_N = mkN "värmemått" neutrum  ; -- värmemått..nn.1
  värmepanna_1_N = mkN "värmepanna" ; -- värmepanna..nn.1
  värmeplatta_1_N = mkN "värmeplatta" ; -- värmeplatta..nn.1
  värmepump_1_N = mkN "värmepump" ; -- värmepump..nn.1
  värmepumpsinstallation_1_N = mkN "värmepumpsinstallation" ; -- värmepumpsinstallation..nn.1
  värmeradiator_1_N = mkN "värmeradiator" "värmeradiatorer" ; -- värmeradiator..nn.1
  värmerörelse_1_N = mkN "värmerörelse" utrum  ; -- värmerörelse..nn.1
  värmeskyddande_1_A = mkA "värmeskyddande" ; -- värmeskyddande..av.1
  värmeskåp_1_N = mkN "värmeskåp" neutrum  ; -- värmeskåp..nn.1
  värmesköld_1_N = mkN "värmesköld" ; -- värmesköld..nn.1
  värmeslag_1_N = mkN "värmeslag" neutrum  ; -- värmeslag..nn.1
  värmeslinga_1_N = mkN "värmeslinga" ; -- värmeslinga..nn.1
  värmespridning_1_N = mkN "värmespridning" ; -- värmespridning..nn.1
  värmesterilisera_1_V = mkV "värmesteriliserar" ; -- värmesterilisera..vb.1
  värmesteriliserande_1_N = mkN "värmesteriliserande" ; -- värmesteriliserande..nn.1
  värmesteriliserbar_1_A = mkA "värmesteriliserbar" ; -- värmesteriliserbar..av.1
  värmesteriliserbarhet_1_N = mkN "värmesteriliserbarhet" ; -- värmesteriliserbarhet..nn.1
  värmesterilisering_1_N = mkN "värmesterilisering" ; -- värmesterilisering..nn.1
  värmestrålning_1_N = mkN "värmestrålning" ; -- värmestrålning..nn.1
  värmestuga_1_N = mkN "värmestuga" ; -- värmestuga..nn.1
  värmeterapi_1_N = mkN "värmeterapi" ; -- värmeterapi..nn.1
  värmetillförsel_1_N = mkN "värmetillförsel" ; -- värmetillförsel..nn.1
  värmetillägg_1_N = mkN "värmetillägg" neutrum  ; -- värmetillägg..nn.1
  värmetålig_1_A = mkA "värmetålig" ; -- värmetålig..av.1
  värmetålighet_1_N = mkN "värmetålighet" ; -- värmetålighet..nn.1
  värmeutbyte_1_N = mkN "värmeutbyte" ; -- värmeutbyte..nn.1
  värmeutstrålning_1_N = mkN "värmeutstrålning" ; -- värmeutstrålning..nn.1
  värmeutveckling_1_N = mkN "värmeutveckling" ; -- värmeutveckling..nn.1
  värmeutvidgning_1_N = mkN "värmeutvidgning" ; -- värmeutvidgning..nn.1
  värmeverk_1_N = mkN "värmeverk" neutrum  ; -- värmeverk..nn.1
  värmevärde_1_N = mkN "värmevärde" ; -- värmevärde..nn.1
  värmeväxlare_1_N = mkN "värmeväxlare" utrum  ; -- värmeväxlare..nn.1
  värmeälskande_1_A = mkA "värmeälskande" ; -- värmeälskande..av.1
  värmeåskväder_1_N = mkN "värmeåskväder" neutrum  ; -- värmeåskväder..nn.1
  värmländsk_1_A = mkA "värmländsk" ; -- värmländsk..av.1
  värmländska_1_N = mkN "värmländska" ; -- värmländska..nn.1
  värmländska_2_N = mkN "värmländska" ; -- värmländska..nn.2
  värmlänning_1_N = mkN "värmlänning" ; -- värmlänning..nn.1
  värmning_1_N = mkN "värmning" ; -- värmning..nn.1
  värmningsfunktion_1_N = mkN "värmningsfunktion" ; -- värmningsfunktion..nn.1
  värn_1_N = mkN "värn" neutrum  ; -- värn..nn.1
  värna_1_V = mkV "värnar" ; -- värna..vb.1
  värnande_1_N = mkN "värnande" ; -- värnande..nn.1
  värnfågel_1_N = mkN "värnfågel" ; -- värnfågel..nn.1
  värnkraft_1_N = mkN "värnkraft" ; -- värnkraft..nn.1
  värnlös_1_A = mkA "värnlös" ; -- värnlös..av.1
  värnlöshet_1_N = mkN "värnlöshet" ; -- värnlöshet..nn.1
  värnplikt_1_N = mkN "värnplikt" ; -- värnplikt..nn.1
  värnpliktig_1_A = mkA "värnpliktig" ; -- värnpliktig..av.1
  värnpliktsarmé_1_N = mkN "värnpliktsarmé" "värnpliktsarméer" ; -- värnpliktsarmé..nn.1
  värnpliktsmyndighet_1_N = mkN "värnpliktsmyndighet" "värnpliktsmyndigheter" ; -- värnpliktsmyndighet..nn.1
  värnpliktsriksdag_1_N = mkN "värnpliktsriksdag" ; -- värnpliktsriksdag..nn.1
  värnpliktstid_1_N = mkN "värnpliktstid" ; -- värnpliktstid..nn.1
  värnpliktstjänstgöring_1_N = mkN "värnpliktstjänstgöring" ; -- värnpliktstjänstgöring..nn.1
  värnpliktsvägrare_1_N = mkN "värnpliktsvägrare" utrum  ; -- värnpliktsvägrare..nn.1
  värpa_1_V = mkV "värper" ; -- värpa..vb.1
  värpande_1_N = mkN "värpande" ; -- värpande..nn.1
  värpsjuk_1_A = mkA "värpsjuk" ; -- värpsjuk..av.1
  värpsjuka_1_N = mkN "värpsjuka" ; -- värpsjuka..nn.1
  värpsjukhet_1_N = mkN "värpsjukhet" ; -- värpsjukhet..nn.1
  värsta_1_A = mkA "värsta" ; -- värsta..av.1
  värsting_1_N = mkN "värsting" ; -- värsting..nn.1
  värv_1_N = mkN "värv" neutrum  ; -- värv..nn.1
  värva_1_V = mkV "värvar" ; -- värva..vb.1
  värvande_1_N = mkN "värvande" ; -- värvande..nn.1
  värvning_1_N = mkN "värvning" ; -- värvning..nn.1
  värvningskampanj_1_N = mkN "värvningskampanj" "värvningskampanjer" ; -- värvningskampanj..nn.1
  väsa_1_V = mkV "väser" ; -- väsa..vb.1
  väsande_1_N = mkN "väsande" ; -- väsande..nn.1
  väsen_1_N = mkN "väsen" ; -- väsen..nn.1
  väsen_2_N = mkN "väsen" neutrum  ; -- väsen..nn.2
  väsende_1_N = mkN "väsende" ; -- väsende..nn.1
  väsensskild_1_A = mkA "väsensskild" "väsensskilt" ; -- väsensskild..av.1
  väsentlig_1_A = mkA "väsentlig" ; -- väsentlig..av.1
  väsentligen_1_Adv = mkAdv "väsentligen" ; -- väsentligen..ab.1
  väsentlighet_1_N = mkN "väsentlighet" "väsentligheter" ; -- väsentlighet..nn.1
  väska_1_N = mkN "väska" ; -- väska..nn.1
  väskryckare_1_N = mkN "väskryckare" utrum  ; -- väskryckare..nn.1
  väsljud_1_N = mkN "väsljud" neutrum  ; -- väsljud..nn.1
  väsning_1_N = mkN "väsning" ; -- väsning..nn.1
  vässa_1_V = mkV "vässar" ; -- vässa..vb.1
  vässande_1_N = mkN "vässande" ; -- vässande..nn.1
  vässning_1_N = mkN "vässning" ; -- vässning..nn.1
  väst_1_N = mkN "väst" ; -- väst..nn.1
  väst_2_N = mkN "väst" ; -- väst..nn.2
  västafrikansk_1_A = mkA "västafrikansk" ; -- västafrikansk..av.1
  västanfläkt_1_N = mkN "västanfläkt" ; -- västanfläkt..nn.1
  västanvind_1_N = mkN "västanvind" ; -- västanvind..nn.1
  västblock_1_N = mkN "västblock" neutrum  ; -- västblock..nn.1
  väster_1_Adv = mkAdv "väster" ; -- väster..ab.1
  väster_1_N = mkN "väster" ; -- väster..nn.1
  västerbottning_1_N = mkN "västerbottning" ; -- västerbottning..nn.1
  västerbottnisk_1_A = mkA "västerbottnisk" ; -- västerbottnisk..av.1
  västergök_1_N = mkN "västergök" ; -- västergök..nn.1
  västerhav_1_N = mkN "västerhav" neutrum  ; -- västerhav..nn.1
  västerland_1_N = mkN "västerland" neutrum  ; -- västerland..nn.1
  västerländsk_1_A = mkA "västerländsk" ; -- västerländsk..av.1
  västerlänning_1_N = mkN "västerlänning" ; -- västerlänning..nn.1
  västersol_1_N = mkN "västersol" ; -- västersol..nn.1
  västerut_1_Adv = mkAdv "västerut" ; -- västerut..ab.1
  västeråsgurka_1_N = mkN "västeråsgurka" ; -- västeråsgurka..nn.1
  västeuropeisk_1_A = mkA "västeuropeisk" ; -- västeuropeisk..av.1
  västficksformat_1_N = mkN "västficksformat" neutrum  ; -- västficksformat..nn.1
  västfront_1_N = mkN "västfront" "västfronter" ; -- västfront..nn.1
  västgot_1_N = mkN "västgot" "västgoter" ; -- västgot..nn.1
  västgotisk_1_A = mkA "västgotisk" ; -- västgotisk..av.1
  västgotiska_1_N = mkN "västgotiska" ; -- västgotiska..nn.1
  västgötaklimax_1_N = mkN "västgötaklimax" ; -- västgötaklimax..nn.1
  västgötaspets_1_N = mkN "västgötaspets" ; -- västgötaspets..nn.1
  västgöte_1_N = mkN "västgöte" utrum  ; -- västgöte..nn.1
  västgötsk_1_A = mkA "västgötsk" ; -- västgötsk..av.1
  västgötska_1_N = mkN "västgötska" ; -- västgötska..nn.1
  västgötska_2_N = mkN "västgötska" ; -- västgötska..nn.2
  västindiefarare_1_N = mkN "västindiefarare" utrum  ; -- västindiefarare..nn.1
  västindisk_1_A = mkA "västindisk" ; -- västindisk..av.1
  västklänning_1_N = mkN "västklänning" ; -- västklänning..nn.1
  västkritisk_1_A = mkA "västkritisk" ; -- västkritisk..av.1
  västkust_1_N = mkN "västkust" "västkuster" ; -- västkust..nn.1
  västkustaccent_1_N = mkN "västkustaccent" "västkustaccenter" ; -- västkustaccent..nn.1
  västkustsallad_1_N = mkN "västkustsallad" "västkustsallader" ; -- västkustsallad..nn.1
  västlig_1_A = mkA "västlig" ; -- västlig..av.1
  västmakt_1_N = mkN "västmakt" "västmakter" ; -- västmakt..nn.1
  västmanländsk_1_A = mkA "västmanländsk" ; -- västmanländsk..av.1
  västmanländska_1_N = mkN "västmanländska" ; -- västmanländska..nn.1
  västmanländska_2_N = mkN "västmanländska" ; -- västmanländska..nn.2
  västmanlänning_1_N = mkN "västmanlänning" ; -- västmanlänning..nn.1
  västnordisk_1_A = mkA "västnordisk" ; -- västnordisk..av.1
  västnorsk_1_A = mkA "västnorsk" ; -- västnorsk..av.1
  västpå_1_Adv = mkAdv "västpå" ; -- västpå..ab.1
  västra_1_A = mkA "västra" ; -- västra..av.1
  västsaharisk_1_A = mkA "västsaharisk" ; -- västsaharisk..av.1
  västsamoan_1_N = mkN "västsamoan" "västsamoaner" ; -- västsamoan..nn.1
  västslavisk_1_A = mkA "västslavisk" ; -- västslavisk..av.1
  västsvensk_1_A = mkA "västsvensk" ; -- västsvensk..av.1
  västtysk_1_A = mkA "västtysk" ; -- västtysk..av.1
  västtysk_1_N = mkN "västtysk" ; -- västtysk..nn.1
  västvart_1_Adv = mkAdv "västvart" ; -- västvart..ab.1
  västvind_1_N = mkN "västvind" ; -- västvind..nn.1
  västvinddrift_1_N = mkN "västvinddrift" ; -- västvinddrift..nn.1
  västvänlig_1_A = mkA "västvänlig" ; -- västvänlig..av.1
  västvärld_1_N = mkN "västvärld" ; -- västvärld..nn.1
  västöver_1_Adv = mkAdv "västöver" ; -- västöver..ab.1
  väta_1_N = mkN "väta" ; -- väta..nn.1
  väta_1_V = mkV "väter" ; -- väta..vb.1
  vätande_1_N = mkN "vätande" ; -- vätande..nn.1
  väte_1_N = mkN "väte" ; -- väte..nn.1
  väteatom_1_N = mkN "väteatom" "väteatomer" ; -- väteatom..nn.1
  vätebomb_1_N = mkN "vätebomb" "vätebomber" ; -- vätebomb..nn.1
  vätegenerator_1_N = mkN "vätegenerator" "vätegeneratorer" ; -- vätegenerator..nn.1
  vätejon_1_N = mkN "vätejon" "vätejoner" ; -- vätejon..nn.1
  vätejonkoncentration_1_N = mkN "vätejonkoncentration" ; -- vätejonkoncentration..nn.1
  vätekarbonat_1_N = mkN "vätekarbonat" "vätekarbonater" ; -- vätekarbonat..nn.1
  vätekarbonatjon_1_N = mkN "vätekarbonatjon" "vätekarbonatjoner" ; -- vätekarbonatjon..nn.1
  vätekraft_1_N = mkN "vätekraft" ; -- vätekraft..nn.1
  vätekärna_1_N = mkN "vätekärna" ; -- vätekärna..nn.1
  väteperoxid_1_N = mkN "väteperoxid" ; -- väteperoxid..nn.1
  vätesulfid_1_N = mkN "vätesulfid" ; -- vätesulfid..nn.1
  vätesuperoxid_1_N = mkN "vätesuperoxid" ; -- vätesuperoxid..nn.1
  vätevapen_1_N = mkN "vätevapen" "vätevapnet" "vätevapen" "vätevapnen" ; -- vätevapen..nn.1
  vätgas_1_N = mkN "vätgas" ; -- vätgas..nn.1
  vätgasballong_1_N = mkN "vätgasballong" "vätgasballonger" ; -- vätgasballong..nn.1
  vätgasbil_1_N = mkN "vätgasbil" ; -- vätgasbil..nn.1
  vätgasdrift_1_N = mkN "vätgasdrift" ; -- vätgasdrift..nn.1
  vätgasdriven_1_A = mkA "vätgasdriven" ; -- vätgasdriven..av.1
  vätgashybrid_1_N = mkN "vätgashybrid" "vätgashybrider" ; -- vätgashybrid..nn.1
  vätgasmolekyl_1_N = mkN "vätgasmolekyl" "vätgasmolekyler" ; -- vätgasmolekyl..nn.1
  vätgasrik_1_A = mkA "vätgasrik" ; -- vätgasrik..av.1
  vätgasrikhet_1_N = mkN "vätgasrikhet" ; -- vätgasrikhet..nn.1
  vätmedel_1_N = mkN "vätmedel" neutrum  ; -- vätmedel..nn.1
  vätning_1_N = mkN "vätning" ; -- vätning..nn.1
  vätska_1_N = mkN "vätska" ; -- vätska..nn.1
  vätska_1_V = mkV "vätskar" ; -- vätska..vb.1
  vätskande_1_N = mkN "vätskande" ; -- vätskande..nn.1
  vätskeansamling_1_N = mkN "vätskeansamling" ; -- vätskeansamling..nn.1
  vätskebalans_1_N = mkN "vätskebalans" ; -- vätskebalans..nn.1
  vätskebrist_1_N = mkN "vätskebrist" ; -- vätskebrist..nn.1
  vätskedrivande_1_A = mkA "vätskedrivande" ; -- vätskedrivande..av.1
  vätskeersättning_1_N = mkN "vätskeersättning" ; -- vätskeersättning..nn.1
  vätskefjädring_1_N = mkN "vätskefjädring" ; -- vätskefjädring..nn.1
  vätskeform_1_N = mkN "vätskeform" ; -- vätskeform..nn.1
  vätskefylld_1_A = mkA "vätskefylld" "vätskefyllt" ; -- vätskefylld..av.1
  vätskeförlust_1_N = mkN "vätskeförlust" "vätskeförluster" ; -- vätskeförlust..nn.1
  vätskeintag_1_N = mkN "vätskeintag" neutrum  ; -- vätskeintag..nn.1
  vätskekontroll_1_N = mkN "vätskekontroll" "vätskekontroller" ; -- vätskekontroll..nn.1
  vätskekultur_1_N = mkN "vätskekultur" ; -- vätskekultur..nn.1
  vätskenivå_1_N = mkN "vätskenivå" "vätskenivåer" ; -- vätskenivå..nn.1
  vätsketermometer_1_N = mkN "vätsketermometer" ; -- vätsketermometer..nn.1
  vätsketillförsel_1_N = mkN "vätsketillförsel" ; -- vätsketillförsel..nn.1
  vätskig_1_A = mkA "vätskig" ; -- vätskig..av.1
  vätskighet_1_N = mkN "vätskighet" ; -- vätskighet..nn.1
  vätte_1_N = mkN "vätte" utrum  ; -- vätte..nn.1
  vätteljus_1_N = mkN "vätteljus" neutrum  ; -- vätteljus..nn.1
  vätteros_1_N = mkN "vätteros" "vätterosor" ; -- vätteros..nn.1
  vätterröding_1_N = mkN "vätterröding" ; -- vätterröding..nn.1
  väv_1_N = mkN "väv" ; -- väv..nn.1
  väva_1_V = mkV "väver" ; -- väva..vb.1
  vävande_1_N = mkN "vävande" ; -- vävande..nn.1
  vävare_1_N = mkN "vävare" utrum  ; -- vävare..nn.1
  vävarfink_1_N = mkN "vävarfink" ; -- vävarfink..nn.1
  vävarfågel_1_N = mkN "vävarfågel" ; -- vävarfågel..nn.1
  vävarstare_1_N = mkN "vävarstare" "vävarstarar" ; -- vävarstare..nn.1
  vävbindning_1_N = mkN "vävbindning" ; -- vävbindning..nn.1
  vävburen_1_A = mkA "vävburen" ; -- vävburen..av.1
  väveri_1_N = mkN "väveri" "väveriet" "väverier" "väverierna" ; -- väveri..nn.1
  väverska_1_N = mkN "väverska" ; -- väverska..nn.1
  vävkam_1_N = mkN "vävkam" "vävkammen" "vävkammar" "vävkammarna" ; -- vävkam..nn.1
  vävknut_1_N = mkN "vävknut" ; -- vävknut..nn.1
  vävkäpp_1_N = mkN "vävkäpp" ; -- vävkäpp..nn.1
  vävlärare_1_N = mkN "vävlärare" utrum  ; -- vävlärare..nn.1
  vävnad_1_N = mkN "vävnad" "vävnader" ; -- vävnad..nn.1
  vävnadsodling_1_N = mkN "vävnadsodling" ; -- vävnadsodling..nn.1
  vävnadsprov_1_N = mkN "vävnadsprov" neutrum  ; -- vävnadsprov..nn.1
  vävnadssjukdom_1_N = mkN "vävnadssjukdom" ; -- vävnadssjukdom..nn.1
  vävnadsvätska_1_N = mkN "vävnadsvätska" ; -- vävnadsvätska..nn.1
  vävning_1_N = mkN "vävning" ; -- vävning..nn.1
  vävningslärare_1_N = mkN "vävningslärare" utrum  ; -- vävningslärare..nn.1
  vävningsmönster_1_N = mkN "vävningsmönster" neutrum  ; -- vävningsmönster..nn.1
  vävplast_1_N = mkN "vävplast" "vävplaster" ; -- vävplast..nn.1
  vävskaft_1_N = mkN "vävskaft" neutrum  ; -- vävskaft..nn.1
  vävsked_1_N = mkN "vävsked" ; -- vävsked..nn.1
  vävskyttel_1_N = mkN "vävskyttel" ; -- vävskyttel..nn.1
  vävskäl_1_N = mkN "vävskäl" neutrum  ; -- vävskäl..nn.1
  vävsolv_1_N = mkN "vävsolv" ; -- vävsolv..nn.1
  vävspännare_1_N = mkN "vävspännare" utrum  ; -- vävspännare..nn.1
  vävstol_1_N = mkN "vävstol" ; -- vävstol..nn.1
  vävtyngd_1_N = mkN "vävtyngd" "vävtyngder" ; -- vävtyngd..nn.1
  växa_1_V = mkV "växa" "växer" "växa" "växte" "växt" "vuxen" ; -- växa..vb.1
  växande_1_N = mkN "växande" ; -- växande..nn.1
  växel_1_N = mkN "växel" ; -- växel..nn.1
  växelaccept_1_N = mkN "växelaccept" "växelaccepter" ; -- växelaccept..nn.1
  växelaffär_1_N = mkN "växelaffär" "växelaffärer" ; -- växelaffär..nn.1
  växelbord_1_N = mkN "växelbord" neutrum  ; -- växelbord..nn.1
  växelbruk_1_N = mkN "växelbruk" neutrum  ; -- växelbruk..nn.1
  växeldiskont_1_N = mkN "växeldiskont" "växeldiskonter" ; -- växeldiskont..nn.1
  växeldiskonto_1_N = mkN "växeldiskonto" "växeldiskontot" "växeldiskonton" "växeldiskontona" ; -- växeldiskonto..nn.1
  växelfordran_1_N = mkN "växelfordran" "växelfordran" "växelfordringar" "växelfordringarna" ; -- växelfordran..nn.1
  växelförregling_1_N = mkN "växelförregling" ; -- växelförregling..nn.1
  växelgivare_1_N = mkN "växelgivare" utrum  ; -- växelgivare..nn.1
  växelgäldenär_1_N = mkN "växelgäldenär" "växelgäldenärer" ; -- växelgäldenär..nn.1
  växelkassa_1_N = mkN "växelkassa" ; -- växelkassa..nn.1
  växelkontor_1_N = mkN "växelkontor" neutrum  ; -- växelkontor..nn.1
  växelkredit_1_N = mkN "växelkredit" "växelkrediter" ; -- växelkredit..nn.1
  växelkurs_1_N = mkN "växelkurs" "växelkurser" ; -- växelkurs..nn.1
  växellok_1_N = mkN "växellok" neutrum  ; -- växellok..nn.1
  växelläsning_1_N = mkN "växelläsning" ; -- växelläsning..nn.1
  växellåda_1_N = mkN "växellåda" ; -- växellåda..nn.1
  växellådslyft_1_N = mkN "växellådslyft" ; -- växellådslyft..nn.1
  växelmynt_1_N = mkN "växelmynt" neutrum  ; -- växelmynt..nn.1
  växelomsättning_1_N = mkN "växelomsättning" ; -- växelomsättning..nn.1
  växelryttare_1_N = mkN "växelryttare" utrum  ; -- växelryttare..nn.1
  växelrytteri_1_N = mkN "växelrytteri" neutrum  ; -- växelrytteri..nn.1
  växelspak_1_N = mkN "växelspak" ; -- växelspak..nn.1
  växelspaksknopp_1_N = mkN "växelspaksknopp" ; -- växelspaksknopp..nn.1
  växelspel_1_N = mkN "växelspel" "växelspelet" "växelspel" "växelspelen" ; -- växelspel..nn.1
  växelspänning_1_N = mkN "växelspänning" ; -- växelspänning..nn.1
  växelspår_1_N = mkN "växelspår" neutrum  ; -- växelspår..nn.1
  växelström_1_N = mkN "växelström" "växelströmmen" "växelströmmar" "växelströmmarna" ; -- växelström..nn.1
  växelställ_1_N = mkN "växelställ" neutrum  ; -- växelställ..nn.1
  växelställverk_1_N = mkN "växelställverk" neutrum  ; -- växelställverk..nn.1
  växelsång_1_N = mkN "växelsång" "växelsånger" ; -- växelsång..nn.1
  växeltrassat_1_N = mkN "växeltrassat" "växeltrassater" ; -- växeltrassat..nn.1
  växeltrassent_1_N = mkN "växeltrassent" "växeltrassenter" ; -- växeltrassent..nn.1
  växeltunga_1_N = mkN "växeltunga" ; -- växeltunga..nn.1
  växelundervisning_1_N = mkN "växelundervisning" ; -- växelundervisning..nn.1
  växelutställare_1_N = mkN "växelutställare" utrum  ; -- växelutställare..nn.1
  växelvarm_1_A = mkA "växelvarm" ; -- växelvarm..av.1
  växelverka_1_V = mkV "växelverkar" ; -- växelverka..vb.1
  växelverkande_1_N = mkN "växelverkande" ; -- växelverkande..nn.1
  växelvis_1_Adv = mkAdv "växelvis" ; -- växelvis..ab.1
  växkraft_1_N = mkN "växkraft" ; -- växkraft..nn.1
  växla_1_V = mkV "växlar" ; -- växla..vb.1
  växlande_1_A = mkA "växlande" ; -- växlande..av.1
  växlande_1_N = mkN "växlande" ; -- växlande..nn.1
  växlare_1_N = mkN "växlare" utrum  ; -- växlare..nn.1
  växling_1_N = mkN "växling" ; -- växling..nn.1
  växlingslok_1_N = mkN "växlingslok" neutrum  ; -- växlingslok..nn.1
  växlingsrik_1_A = mkA "växlingsrik" ; -- växlingsrik..av.1
  växlingsrikhet_1_N = mkN "växlingsrikhet" ; -- växlingsrikhet..nn.1
  växt_1_N = mkN "växt" "växter" ; -- växt..nn.1
  växtanatomi_1_N = mkN "växtanatomi" ; -- växtanatomi..nn.1
  växtart_1_N = mkN "växtart" "växtarter" ; -- växtart..nn.1
  växtbas_1_N = mkN "växtbas" "växtbaser" ; -- växtbas..nn.1
  växtbiologi_1_N = mkN "växtbiologi" ; -- växtbiologi..nn.1
  växtcell_1_N = mkN "växtcell" "växtceller" ; -- växtcell..nn.1
  växtdel_1_N = mkN "växtdel" "växtdelen" "växtdelar" "växtdelarna" ; -- växtdel..nn.1
  växtfamilj_1_N = mkN "växtfamilj" "växtfamiljer" ; -- växtfamilj..nn.1
  växtfett_1_N = mkN "växtfett" "växtfettet" "växtfetter" "växtfetterna" ; -- växtfett..nn.1
  växtfiber_1_N = mkN "växtfiber" "växtfibern" "växtfibrer" "växtfibrerna" ; -- växtfiber..nn.1
  växtfysiologi_1_N = mkN "växtfysiologi" ; -- växtfysiologi..nn.1
  växtfärg_1_N = mkN "växtfärg" "växtfärger" ; -- växtfärg..nn.1
  växtfärgning_1_N = mkN "växtfärgning" ; -- växtfärgning..nn.1
  växtföljd_1_N = mkN "växtföljd" "växtföljder" ; -- växtföljd..nn.1
  växtförädling_1_N = mkN "växtförädling" ; -- växtförädling..nn.1
  växtgeografi_1_N = mkN "växtgeografi" ; -- växtgeografi..nn.1
  växtgift_1_N = mkN "växtgift" "växtgiftet" "växtgifter" "växtgifterna" ; -- växtgift..nn.1
  växtgräns_1_N = mkN "växtgräns" "växtgränser" ; -- växtgräns..nn.1
  växthormon_1_N = mkN "växthormon" neutrum  ; -- växthormon..nn.1
  växthus_1_N = mkN "växthus" neutrum  ; -- växthus..nn.1
  växthuseffekt_1_N = mkN "växthuseffekt" ; -- växthuseffekt..nn.1
  växthusgas_1_N = mkN "växthusgas" "växthusgaser" ; -- växthusgas..nn.1
  växthusodling_1_N = mkN "växthusodling" ; -- växthusodling..nn.1
  växthustak_1_N = mkN "växthustak" neutrum  ; -- växthustak..nn.1
  växthämmande_1_A = mkA "växthämmande" ; -- växthämmande..av.1
  växtkraft_1_N = mkN "växtkraft" ; -- växtkraft..nn.1
  växtkraftig_1_A = mkA "växtkraftig" ; -- växtkraftig..av.1
  växtkraftighet_1_N = mkN "växtkraftighet" ; -- växtkraftighet..nn.1
  växtlig_1_A = mkA "växtlig" ; -- växtlig..av.1
  växtlighet_1_N = mkN "växtlighet" "växtligheter" ; -- växtlighet..nn.1
  växtlim_1_N = mkN "växtlim" "växtlimmet" "växtlimmer" "växtlimmerna" ; -- växtlim..nn.1
  växtliv_1_N = mkN "växtliv" neutrum  ; -- växtliv..nn.1
  växtlokal_1_N = mkN "växtlokal" "växtlokaler" ; -- växtlokal..nn.1
  växtmargarin_1_N = mkN "växtmargarin" "växtmargariner" ; -- växtmargarin..nn.1
  växtnäring_1_N = mkN "växtnäring" ; -- växtnäring..nn.1
  växtperiod_1_N = mkN "växtperiod" "växtperioder" ; -- växtperiod..nn.1
  växtplankton_1_N = mkN "växtplankton" neutrum  ; -- växtplankton..nn.1
  växtplats_1_N = mkN "växtplats" "växtplatser" ; -- växtplats..nn.1
  växtpress_1_N = mkN "växtpress" ; -- växtpress..nn.1
  växtrike_1_N = mkN "växtrike" ; -- växtrike..nn.1
  växtrörelse_1_N = mkN "växtrörelse" utrum  ; -- växtrörelse..nn.1
  växtsaft_1_N = mkN "växtsaft" "växtsafter" ; -- växtsaft..nn.1
  växtsamhälle_1_N = mkN "växtsamhälle" ; -- växtsamhälle..nn.1
  växtsamlare_1_N = mkN "växtsamlare" utrum  ; -- växtsamlare..nn.1
  växtsilke_1_N = mkN "växtsilke" ; -- växtsilke..nn.1
  växtsjukdom_1_N = mkN "växtsjukdom" ; -- växtsjukdom..nn.1
  växtskott_1_N = mkN "växtskott" neutrum  ; -- växtskott..nn.1
  växtskydd_1_N = mkN "växtskydd" neutrum  ; -- växtskydd..nn.1
  växtskyddsmedel_1_N = mkN "växtskyddsmedel" neutrum  ; -- växtskyddsmedel..nn.1
  växtsläkte_1_N = mkN "växtsläkte" ; -- växtsläkte..nn.1
  växtstam_1_N = mkN "växtstam" "växtstammen" "växtstammar" "växtstammarna" ; -- växtstam..nn.1
  växtstekel_1_N = mkN "växtstekel" ; -- växtstekel..nn.1
  växtsäsong_1_N = mkN "växtsäsong" "växtsäsonger" ; -- växtsäsong..nn.1
  växttråd_1_N = mkN "växttråd" ; -- växttråd..nn.1
  växtvärk_1_N = mkN "växtvärk" ; -- växtvärk..nn.1
  växtvärld_1_N = mkN "växtvärld" ; -- växtvärld..nn.1
  växtvävnad_1_N = mkN "växtvävnad" "växtvävnader" ; -- växtvävnad..nn.1
  växtämne_1_N = mkN "växtämne" ; -- växtämne..nn.1
  växtätande_1_A = mkA "växtätande" ; -- växtätande..av.1
  växtätare_1_N = mkN "växtätare" utrum  ; -- växtätare..nn.1
  växvärk_1_N = mkN "växvärk" ; -- växvärk..nn.1
  våd_1_N = mkN "våd" "våder" ; -- våd..nn.1
  våda_1_N = mkN "våda" ; -- våda..nn.1
  vådaskjuta_1_V = mkV "vådaskjutar" ; -- vådaskjuta..vb.1
  vådaskjutande_1_N = mkN "vådaskjutande" ; -- vådaskjutande..nn.1
  vådaskjutning_1_N = mkN "vådaskjutning" ; -- vådaskjutning..nn.1
  vådaskott_1_N = mkN "vådaskott" neutrum  ; -- vådaskott..nn.1
  vådeld_1_N = mkN "vådeld" ; -- vådeld..nn.1
  vådevill_1_N = mkN "vådevill" "vådeviller" ; -- vådevill..nn.1
  vådlig_1_A = mkA "vådlig" ; -- vådlig..av.1
  vådligen_1_Adv = mkAdv "vådligen" ; -- vådligen..ab.1
  vådlighet_1_N = mkN "vådlighet" ; -- vådlighet..nn.1
  våffelbindning_1_N = mkN "våffelbindning" ; -- våffelbindning..nn.1
  våffeldag_1_N = mkN "våffeldag" ; -- våffeldag..nn.1
  våffeljärn_1_N = mkN "våffeljärn" neutrum  ; -- våffeljärn..nn.1
  våffelmönstrad_1_A = mkA "våffelmönstrad" ; -- våffelmönstrad..av.1
  våffla_1_N = mkN "våffla" ; -- våffla..nn.1
  våg_1_N = mkN "våg" "vågor" ; -- våg..nn.1
  våg_2_N = mkN "våg" ; -- våg..nn.2
  våga_1_V = mkV "vågar" ; -- våga..vb.1
  vågad_1_A = mkA "vågad" ; -- vågad..av.1
  vågande_1_N = mkN "vågande" ; -- vågande..nn.1
  vågbalans_1_N = mkN "vågbalans" "vågbalanser" ; -- vågbalans..nn.1
  vågberg_1_N = mkN "vågberg" neutrum  ; -- vågberg..nn.1
  vågbrytare_1_N = mkN "vågbrytare" utrum  ; -- vågbrytare..nn.1
  vågdal_1_N = mkN "vågdal" ; -- vågdal..nn.1
  vågform_1_N = mkN "vågform" "vågformer" ; -- vågform..nn.1
  vågformad_1_A = mkA "vågformad" ; -- vågformad..av.1
  vågformig_1_A = mkA "vågformig" ; -- vågformig..av.1
  vågformighet_1_N = mkN "vågformighet" ; -- vågformighet..nn.1
  vågfront_1_N = mkN "vågfront" "vågfronter" ; -- vågfront..nn.1
  vågföra_1_V = mkV "vågföra" "vågförde" "vågfört" ; -- vågföra..vb.1
  vågförande_1_N = mkN "vågförande" ; -- vågförande..nn.1
  våghals_1_N = mkN "våghals" ; -- våghals..nn.1
  våghalsig_1_A = mkA "våghalsig" ; -- våghalsig..av.1
  våghalsighet_1_N = mkN "våghalsighet" "våghalsigheter" ; -- våghalsighet..nn.1
  våghål_1_N = mkN "våghål" neutrum  ; -- våghål..nn.1
  våghöjd_1_N = mkN "våghöjd" "våghöjder" ; -- våghöjd..nn.1
  vågig_1_A = mkA "vågig" ; -- vågig..av.1
  vågighet_1_N = mkN "vågighet" ; -- vågighet..nn.1
  vågkam_1_N = mkN "vågkam" "vågkammen" "vågkammar" "vågkammarna" ; -- vågkam..nn.1
  vågkraft_1_N = mkN "vågkraft" ; -- vågkraft..nn.1
  våglinje_1_N = mkN "våglinje" "våglinjer" ; -- våglinje..nn.1
  våglängd_1_N = mkN "våglängd" "våglängder" ; -- våglängd..nn.1
  vågmekanik_1_N = mkN "vågmekanik" ; -- vågmekanik..nn.1
  vågmär_1_N = mkN "vågmär" "vågmärer" ; -- vågmär..nn.1
  vågmästare_1_N = mkN "vågmästare" utrum  ; -- vågmästare..nn.1
  vågmästarpolitik_1_N = mkN "vågmästarpolitik" ; -- vågmästarpolitik..nn.1
  vågmästarroll_1_N = mkN "vågmästarroll" "vågmästarroller" ; -- vågmästarroll..nn.1
  vågmästeri_1_N = mkN "vågmästeri" neutrum  ; -- vågmästeri..nn.1
  vågnatur_1_N = mkN "vågnatur" "vågnaturer" ; -- vågnatur..nn.1
  vågpapp_1_N = mkN "vågpapp" ; -- vågpapp..nn.1
  vågplan_1_N = mkN "vågplan" neutrum  ; -- vågplan..nn.1
  vågrät_1_A = mkA "vågrät" ; -- vågrät..av.1
  vågräthet_1_N = mkN "vågräthet" ; -- vågräthet..nn.1
  vågrörelse_1_N = mkN "vågrörelse" "vågrörelser" ; -- vågrörelse..nn.1
  vågsam_1_A = mkA "vågsam" "vågsamt" "vågsamma" "vågsamma" "vågsammare" "vågsammast" "vågsammaste" ; -- vågsam..av.1
  vågsamhet_1_N = mkN "vågsamhet" ; -- vågsamhet..nn.1
  vågskål_1_N = mkN "vågskål" ; -- vågskål..nn.1
  vågspel_1_N = mkN "vågspel" "vågspelet" "vågspel" "vågspelen" ; -- vågspel..nn.1
  vågstycke_1_N = mkN "vågstycke" ; -- vågstycke..nn.1
  vågsvall_1_N = mkN "vågsvall" neutrum  ; -- vågsvall..nn.1
  vågtopp_1_N = mkN "vågtopp" ; -- vågtopp..nn.1
  våld_1_N = mkN "våld" neutrum  ; -- våld..nn.1
  våldföra_1_V = mkV "våldföra" "våldförde" "våldfört" ; -- våldföra..vb.1
  våldförande_1_N = mkN "våldförande" ; -- våldförande..nn.1
  våldgästa_1_V = mkV "våldgästar" ; -- våldgästa..vb.1
  våldgästande_1_N = mkN "våldgästande" ; -- våldgästande..nn.1
  våldgästning_1_N = mkN "våldgästning" ; -- våldgästning..nn.1
  våldsam_1_A = mkA "våldsam" "våldsamt" "våldsamma" "våldsamma" "våldsammare" "våldsammast" "våldsammaste" ; -- våldsam..av.1
  våldsamhet_1_N = mkN "våldsamhet" "våldsamheter" ; -- våldsamhet..nn.1
  våldsbejakande_1_A = mkA "våldsbejakande" ; -- våldsbejakande..av.1
  våldsbejakande_1_N = mkN "våldsbejakande" ; -- våldsbejakande..nn.1
  våldsbenägen_1_A = mkA "våldsbenägen" ; -- våldsbenägen..av.1
  våldsbenägenhet_1_N = mkN "våldsbenägenhet" "våldsbenägenheter" ; -- våldsbenägenhet..nn.1
  våldsbrott_1_N = mkN "våldsbrott" neutrum  ; -- våldsbrott..nn.1
  våldsbrottsling_1_N = mkN "våldsbrottsling" ; -- våldsbrottsling..nn.1
  våldsdrabbad_1_A = mkA "våldsdrabbad" ; -- våldsdrabbad..av.1
  våldsdåd_1_N = mkN "våldsdåd" neutrum  ; -- våldsdåd..nn.1
  våldsförhärligande_1_N = mkN "våldsförhärligande" ; -- våldsförhärligande..nn.1
  våldsgärning_1_N = mkN "våldsgärning" ; -- våldsgärning..nn.1
  våldshandling_1_N = mkN "våldshandling" ; -- våldshandling..nn.1
  våldsincident_1_N = mkN "våldsincident" "våldsincidenter" ; -- våldsincident..nn.1
  våldsman_1_N = mkN "våldsman" "våldsmannen" "våldsmän" "våldsmännen" ; -- våldsman..nn.1
  våldsmentalitet_1_N = mkN "våldsmentalitet" "våldsmentaliteter" ; -- våldsmentalitet..nn.1
  våldspiral_1_N = mkN "våldspiral" "våldspiraler" ; -- våldspiral..nn.1
  våldsplågad_1_A = mkA "våldsplågad" ; -- våldsplågad..av.1
  våldspornografi_1_N = mkN "våldspornografi" ; -- våldspornografi..nn.1
  våldsporr_1_N = mkN "våldsporr" ; -- våldsporr..nn.1
  våldsrotel_1_N = mkN "våldsrotel" ; -- våldsrotel..nn.1
  våldsscen_1_N = mkN "våldsscen" "våldsscener" ; -- våldsscen..nn.1
  våldsskildring_1_N = mkN "våldsskildring" ; -- våldsskildring..nn.1
  våldstendens_1_N = mkN "våldstendens" "våldstendenser" ; -- våldstendens..nn.1
  våldsutsatt_1_A = mkA "våldsutsatt" ; -- våldsutsatt..av.1
  våldsutsatthet_1_N = mkN "våldsutsatthet" ; -- våldsutsatthet..nn.1
  våldsverkare_1_N = mkN "våldsverkare" utrum  ; -- våldsverkare..nn.1
  våldsvåg_1_N = mkN "våldsvåg" "våldsvågor" ; -- våldsvåg..nn.1
  våldta_1_V = mkV "våldtaga" "våldtog" "våldtagit" ; -- våldta..vb.1
  våldtagande_1_N = mkN "våldtagande" ; -- våldtagande..nn.1
  våldtagning_1_N = mkN "våldtagning" ; -- våldtagning..nn.1
  våldtäkt_1_N = mkN "våldtäkt" "våldtäkter" ; -- våldtäkt..nn.1
  våldtäktsbenägenhet_1_N = mkN "våldtäktsbenägenhet" "våldtäktsbenägenheter" ; -- våldtäktsbenägenhet..nn.1
  våldtäktsdömd_1_A = mkA "våldtäktsdömd" "våldtäktsdömt" ; -- våldtäktsdömd..av.1
  våldtäktsförsök_1_N = mkN "våldtäktsförsök" neutrum  ; -- våldtäktsförsök..nn.1
  våldtäktsman_1_N = mkN "våldtäktsman" "våldtäktsmannen" "våldtäktsmän" "våldtäktsmännen" ; -- våldtäktsman..nn.1
  våldtäktsmisstänkt_1_A = mkA "våldtäktsmisstänkt" "våldtäktsmisstänkt" ; -- våldtäktsmisstänkt..av.1
  våle_1_N = mkN "våle" utrum  ; -- våle..nn.1
  vålla_1_V = mkV "vållar" ; -- vålla..vb.1
  vållande_1_N = mkN "vållande" ; -- vållande..nn.1
  vålm_1_N = mkN "vålm" ; -- vålm..nn.1
  vålma_1_V = mkV "vålmar" ; -- vålma..vb.1
  vålmande_1_N = mkN "vålmande" ; -- vålmande..nn.1
  vålmning_1_N = mkN "vålmning" ; -- vålmning..nn.1
  vålnad_1_N = mkN "vålnad" "vålnader" ; -- vålnad..nn.1
  våm_1_N = mkN "våm" "våmmen" "våmmar" "våmmarna" ; -- våm..nn.1
  vån_1_N = mkN "vån" ; -- vån..nn.1
  vånda_1_N = mkN "vånda" ; -- vånda..nn.1
  vång_1_N = mkN "vång" ; -- vång..nn.1
  våning_1_N = mkN "våning" ; -- våning..nn.1
  våningsplan_1_N = mkN "våningsplan" neutrum  ; -- våningsplan..nn.1
  våningssäng_1_N = mkN "våningssäng" ; -- våningssäng..nn.1
  vånna_1_V = mkV "vånnar" ; -- vånna..vb.1
  vånnande_1_N = mkN "vånnande" ; -- vånnande..nn.1
  våp_1_N = mkN "våp" neutrum  ; -- våp..nn.1
  våpig_1_A = mkA "våpig" ; -- våpig..av.1
  våpighet_1_N = mkN "våpighet" ; -- våpighet..nn.1
  vår_1_N = mkN "vår" ; -- vår..nn.1
  våra_1_V = mkV "vårar" ; -- våra..vb.1
  våradonis_1_N = mkN "våradonis" ; -- våradonis..nn.1
  vårande_1_N = mkN "vårande" ; -- vårande..nn.1
  vårbete_1_N = mkN "vårbete" ; -- vårbete..nn.1
  vårblomma_1_N = mkN "vårblomma" ; -- vårblomma..nn.1
  vårbrodd_1_N = mkN "vårbrodd" ; -- vårbrodd..nn.1
  vårbruk_1_N = mkN "vårbruk" neutrum  ; -- vårbruk..nn.1
  vårbrytning_1_N = mkN "vårbrytning" ; -- vårbrytning..nn.1
  vårbudget_1_N = mkN "vårbudget" ; -- vårbudget..nn.1
  vårbäck_1_N = mkN "vårbäck" ; -- vårbäck..nn.1
  vård_1_N = mkN "vård" ; -- vård..nn.1
  vård_2_N = mkN "vård" "vårder" ; -- vård..nn.2
  vård_3_N = mkN "vård" ; -- vård..nn.3
  vårda_1_V = mkV "vårdar" ; -- vårda..vb.1
  vårdad_1_A = mkA "vårdad" ; -- vårdad..av.1
  vårdag_1_N = mkN "vårdag" ; -- vårdag..nn.1
  vårdagjämning_1_N = mkN "vårdagjämning" ; -- vårdagjämning..nn.1
  vårdagjämningspunkt_1_N = mkN "vårdagjämningspunkt" ; -- vårdagjämningspunkt..nn.1
  vårdande_1_N = mkN "vårdande" ; -- vårdande..nn.1
  vårdanstalt_1_N = mkN "vårdanstalt" "vårdanstalter" ; -- vårdanstalt..nn.1
  vårdanställd_1_A = mkA "vårdanställd" "vårdanställt" ; -- vårdanställd..av.1
  vårdare_1_N = mkN "vårdare" utrum  ; -- vårdare..nn.1
  vårdarinna_1_N = mkN "vårdarinna" ; -- vårdarinna..nn.1
  vårdavdelning_1_N = mkN "vårdavdelning" ; -- vårdavdelning..nn.1
  vårdbehov_1_N = mkN "vårdbehov" neutrum  ; -- vårdbehov..nn.1
  vårdbehövande_1_A = mkA "vårdbehövande" ; -- vårdbehövande..av.1
  vårdberoende_1_A = mkA "vårdberoende" ; -- vårdberoende..av.1
  vårdberoende_1_N = mkN "vårdberoende" ; -- vårdberoende..nn.1
  vårdbidrag_1_N = mkN "vårdbidrag" neutrum  ; -- vårdbidrag..nn.1
  vårdcentral_1_N = mkN "vårdcentral" "vårdcentraler" ; -- vårdcentral..nn.1
  vårdepression_1_N = mkN "vårdepression" ; -- vårdepression..nn.1
  vårdfall_1_N = mkN "vårdfall" neutrum  ; -- vårdfall..nn.1
  vårdföretag_1_N = mkN "vårdföretag" neutrum  ; -- vårdföretag..nn.1
  vårdgaranti_1_N = mkN "vårdgaranti" "vårdgarantier" ; -- vårdgaranti..nn.1
  vårdgivare_1_N = mkN "vårdgivare" utrum  ; -- vårdgivare..nn.1
  vårdhem_1_N = mkN "vårdhem" "vårdhemmet" "vårdhem" "vårdhemmen" ; -- vårdhem..nn.1
  vårdinsats_1_N = mkN "vårdinsats" "vårdinsatser" ; -- vårdinsats..nn.1
  vårdintyg_1_N = mkN "vårdintyg" neutrum  ; -- vårdintyg..nn.1
  vårdintygsmässig_1_A = mkA "vårdintygsmässig" ; -- vårdintygsmässig..av.1
  vårdkase_1_N = mkN "vårdkas" ; -- vårdkase..nn.1
  vårdklinik_1_N = mkN "vårdklinik" "vårdkliniker" ; -- vårdklinik..nn.1
  vårdkrävande_1_A = mkA "vårdkrävande" ; -- vårdkrävande..av.1
  vårdlinje_1_N = mkN "vårdlinje" "vårdlinjer" ; -- vårdlinje..nn.1
  vårdmässig_1_A = mkA "vårdmässig" ; -- vårdmässig..av.1
  vårdnad_1_N = mkN "vårdnad" "vårdnader" ; -- vårdnad..nn.1
  vårdnadsbidrag_1_N = mkN "vårdnadsbidrag" neutrum  ; -- vårdnadsbidrag..nn.1
  vårdnadsfylla_1_N = mkN "vårdnadsfylla" ; -- vårdnadsfylla..nn.1
  vårdnadshavare_1_N = mkN "vårdnadshavare" utrum  ; -- vårdnadshavare..nn.1
  vårdpaket_1_N = mkN "vårdpaket" neutrum  ; -- vårdpaket..nn.1
  vårdpersonal_1_N = mkN "vårdpersonal" "vårdpersonaler" ; -- vårdpersonal..nn.1
  vårdplats_1_N = mkN "vårdplats" "vårdplatser" ; -- vårdplats..nn.1
  vårdplatsgaranti_1_N = mkN "vårdplatsgaranti" "vårdplatsgarantier" ; -- vårdplatsgaranti..nn.1
  vårdsam_1_A = mkA "vårdsam" "vårdsamt" "vårdsamma" "vårdsamma" "vårdsammare" "vårdsammast" "vårdsammaste" ; -- vårdsam..av.1
  vårdsamhet_1_N = mkN "vårdsamhet" ; -- vårdsamhet..nn.1
  vårdskada_1_N = mkN "vårdskada" ; -- vårdskada..nn.1
  vårdskadad_1_A = mkA "vårdskadad" ; -- vårdskadad..av.1
  vårdslös_1_A = mkA "vårdslös" ; -- vårdslös..av.1
  vårdslösa_1_V = mkV "vårdslösar" ; -- vårdslösa..vb.1
  vårdslösande_1_N = mkN "vårdslösande" ; -- vårdslösande..nn.1
  vårdslöshet_1_N = mkN "vårdslöshet" "vårdslösheter" ; -- vårdslöshet..nn.1
  vårdsökande_1_N = mkN "vårdsökande" "vårdsökanden" "vårdsökanden" "vårdsökandena" ; -- vårdsökande..nn.1
  vårdtagare_1_N = mkN "vårdtagare" utrum  ; -- vårdtagare..nn.1
  vårdtecken_1_N = mkN "vårdtecken" "vårdtecknet" "vårdtecken" "vårdtecknen" ; -- vårdtecken..nn.1
  vårdträd_1_N = mkN "vårdträd" neutrum  ; -- vårdträd..nn.1
  vårdval_1_N = mkN "vårdval" neutrum  ; -- vårdval..nn.1
  vårdyrke_1_N = mkN "vårdyrke" ; -- vårdyrke..nn.1
  vårfin_1_A = mkA "vårfin" ; -- vårfin..av.1
  vårflod_1_N = mkN "vårflod" ; -- vårflod..nn.1
  vårflor_1_N = mkN "vårflor" neutrum  ; -- vårflor..nn.1
  vårfrisk_1_A = mkA "vårfrisk" ; -- vårfrisk..av.1
  vårfrost_1_N = mkN "vårfrost" ; -- vårfrost..nn.1
  vårfrudag_1_N = mkN "vårfrudag" ; -- vårfrudag..nn.1
  vårfräsch_1_A = mkA "vårfräsch" ; -- vårfräsch..av.1
  vårgrön_1_A = mkA "vårgrön" ; -- vårgrön..av.1
  vårkant_1_N = mkN "vårkant" ; -- vårkant..nn.1
  vårkänsla_1_N = mkN "vårkänsla" ; -- vårkänsla..nn.1
  vårlig_1_A = mkA "vårlig" ; -- vårlig..av.1
  vårluft_1_N = mkN "vårluft" ; -- vårluft..nn.1
  vårlök_1_N = mkN "vårlök" ; -- vårlök..nn.1
  vårmoln_1_N = mkN "vårmoln" neutrum  ; -- vårmoln..nn.1
  vårmånad_1_N = mkN "vårmånad" "vårmånader" ; -- vårmånad..nn.1
  vårriksdag_1_N = mkN "vårriksdag" ; -- vårriksdag..nn.1
  vårsol_1_N = mkN "vårsol" ; -- vårsol..nn.1
  vårsoppa_1_N = mkN "vårsoppa" ; -- vårsoppa..nn.1
  vårstäda_1_V = mkV "vårstädar" ; -- vårstäda..vb.1
  vårstädande_1_N = mkN "vårstädande" ; -- vårstädande..nn.1
  vårstädning_1_N = mkN "vårstädning" ; -- vårstädning..nn.1
  vårsäd_1_N = mkN "vårsäd" ; -- vårsäd..nn.1
  vårta_1_N = mkN "vårta" ; -- vårta..nn.1
  vårtbitare_1_N = mkN "vårtbitare" utrum  ; -- vårtbitare..nn.1
  vårtbjörk_1_N = mkN "vårtbjörk" ; -- vårtbjörk..nn.1
  vårtecken_1_N = mkN "vårtecken" "vårtecknet" "vårtecken" "vårtecknen" ; -- vårtecken..nn.1
  vårtermin_1_N = mkN "vårtermin" "vårterminer" ; -- vårtermin..nn.1
  vårtgård_1_N = mkN "vårtgård" ; -- vårtgård..nn.1
  vårtig_1_A = mkA "vårtig" ; -- vårtig..av.1
  vårtighet_1_N = mkN "vårtighet" ; -- vårtighet..nn.1
  vårtkaktus_1_N = mkN "vårtkaktus" ; -- vårtkaktus..nn.1
  vårtmedel_1_N = mkN "vårtmedel" neutrum  ; -- vårtmedel..nn.1
  vårtrött_1_A = mkA "vårtrött" ; -- vårtrött..av.1
  vårtrötthet_1_N = mkN "vårtrötthet" "vårtröttheter" ; -- vårtrötthet..nn.1
  vårtsvets_1_N = mkN "vårtsvets" ; -- vårtsvets..nn.1
  vårtsvin_1_N = mkN "vårtsvin" neutrum  ; -- vårtsvin..nn.1
  vårvete_1_N = mkN "vårvete" ; -- vårvete..nn.1
  vårvial_1_N = mkN "vårvial" "vårvialer" ; -- vårvial..nn.1
  vårvinter_1_N = mkN "vårvinter" ; -- vårvinter..nn.1
  vårvintervecka_1_N = mkN "vårvintervecka" ; -- vårvintervecka..nn.1
  vårvisa_1_N = mkN "vårvisa" ; -- vårvisa..nn.1
  vårväder_1_N = mkN "vårväder" neutrum  ; -- vårväder..nn.1
  vårväxt_1_N = mkN "vårväxt" "vårväxter" ; -- vårväxt..nn.1
  våröversvämning_1_N = mkN "våröversvämning" ; -- våröversvämning..nn.1
  våt_1_A = mkA "våt" ; -- våt..av.1
  våtarve_1_N = mkN "våtarv" ; -- våtarve..nn.1
  våtblank_1_A = mkA "våtblank" ; -- våtblank..av.1
  våtelement_1_N = mkN "våtelement" neutrum  ; -- våtelement..nn.1
  våthet_1_N = mkN "våthet" ; -- våthet..nn.1
  våtkola_1_V = mkV "våtkolar" ; -- våtkola..vb.1
  våtkolande_1_N = mkN "våtkolande" ; -- våtkolande..nn.1
  våtmark_1_N = mkN "våtmark" "våtmarker" ; -- våtmark..nn.1
  våtmassa_1_N = mkN "våtmassa" ; -- våtmassa..nn.1
  våtpressa_1_V = mkV "våtpressar" ; -- våtpressa..vb.1
  våtpressande_1_N = mkN "våtpressande" ; -- våtpressande..nn.1
  våtrum_1_N = mkN "våtrum" "våtrummet" "våtrum" "våtrummen" ; -- våtrum..nn.1
  våtrumssilikon_1_N = mkN "våtrumssilikon" neutrum  ; -- våtrumssilikon..nn.1
  våtservett_1_N = mkN "våtservett" "våtservetter" ; -- våtservett..nn.1
  våtskrapa_1_N = mkN "våtskrapa" ; -- våtskrapa..nn.1
  våtstark_1_A = mkA "våtstark" ; -- våtstark..av.1
  våtstarkhet_1_N = mkN "våtstarkhet" ; -- våtstarkhet..nn.1
  våtstrimmig_1_A = mkA "våtstrimmig" ; -- våtstrimmig..av.1
  våtsugning_1_N = mkN "våtsugning" ; -- våtsugning..nn.1
  våtutrymme_1_N = mkN "våtutrymme" ; -- våtutrymme..nn.1
  våtvara_1_N = mkN "våtvara" ; -- våtvara..nn.1
  våtvarm_1_A = mkA "våtvarm" ; -- våtvarm..av.1
  våtvarmhet_1_N = mkN "våtvarmhet" ; -- våtvarmhet..nn.1
  våtvärmande_1_A = mkA "våtvärmande" ; -- våtvärmande..av.1
  völva_1_N = mkN "völva" ; -- völva..nn.1
  vörda_1_V = mkV "vördar" ; -- vörda..vb.1
  vördande_1_N = mkN "vördande" ; -- vördande..nn.1
  vördig_1_A = mkA "vördig" ; -- vördig..av.1
  vördighet_1_N = mkN "vördighet" ; -- vördighet..nn.1
  vördnad_1_N = mkN "vördnad" "vördnader" ; -- vördnad..nn.1
  vördnadsbetygelse_1_N = mkN "vördnadsbetygelse" "vördnadsbetygelser" ; -- vördnadsbetygelse..nn.1
  vördnadsbjudande_1_A = mkA "vördnadsbjudande" ; -- vördnadsbjudande..av.1
  vördnadsfull_1_A = mkA "vördnadsfull" ; -- vördnadsfull..av.1
  vördnadsfullhet_1_N = mkN "vördnadsfullhet" ; -- vördnadsfullhet..nn.1
  vördnadsvärd_1_A = mkA "vördnadsvärd" "vördnadsvärt" ; -- vördnadsvärd..av.1
  vördnadsvärdhet_1_N = mkN "vördnadsvärdhet" ; -- vördnadsvärdhet..nn.1
  vördsam_1_A = mkA "vördsam" "vördsamt" "vördsamma" "vördsamma" "vördsammare" "vördsammast" "vördsammaste" ; -- vördsam..av.1
  vördsamhet_1_N = mkN "vördsamhet" ; -- vördsamhet..nn.1
  vördsamligen_1_Adv = mkAdv "vördsamligen" ; -- vördsamligen..ab.1
  vört_1_N = mkN "vört" ; -- vört..nn.1
  vörtbröd_1_N = mkN "vörtbröd" neutrum  ; -- vörtbröd..nn.1
  vörtlimpa_1_N = mkN "vörtlimpa" ; -- vörtlimpa..nn.1
  vörtstyrka_1_N = mkN "vörtstyrka" ; -- vörtstyrka..nn.1
  wafer_1_N = mkN "wafer" "wafern" "wafers" "wafersarna" ; -- wafer..nn.1
  wagon_1_N = mkN "wagon" "wagoner" ; -- wagon..nn.1
  wajang_1_N = mkN "wajang" ; -- wajang..nn.1
  waldorfpedagogik_1_N = mkN "waldorfpedagogik" ; -- waldorfpedagogik..nn.1
  walesare_1_N = mkN "walesare" utrum  ; -- walesare..nn.1
  walesisk_1_A = mkA "walesisk" ; -- walesisk..av.1
  walesiska_1_N = mkN "walesiska" ; -- walesiska..nn.1
  walesiska_2_N = mkN "walesiska" ; -- walesiska..nn.2
  walkie_talkie_1_N = mkN "walkie-talkie" "walkie-talkien" "walkie-talkies" "walkie-talkiesarna" ; -- walkie-talkie..nn.1
  walkover_1_N = mkN "walkover" ; -- walkover..nn.1
  wallraffa_1_V = mkV "wallraffar" ; -- wallraffa..vb.1
  wallraffande_1_N = mkN "wallraffande" ; -- wallraffande..nn.1
  wallrafferi_1_N = mkN "wallrafferi" "wallrafferiet" "wallrafferier" "wallrafferierna" ; -- wallrafferi..nn.1
  wallraffning_1_N = mkN "wallraffning" ; -- wallraffning..nn.1
  wankelmotor_1_N = mkN "wankelmotor" "wankelmotorer" ; -- wankelmotor..nn.1
  waterloo_1_N = mkN "waterloo" ; -- waterloo..nn.1
  watt_1_N = mkN "watt" "watten" "watt" "watten" ; -- watt..nn.1
  wattsekund_1_N = mkN "wattsekund" "wattsekunder" ; -- wattsekund..nn.1
  watusi_1_N = mkN "watusi" "watusin" "watusi" "watusina" ; -- watusi..nn.1
  watussi_1_N = mkN "watussi" "watussin" "watussi" "watussina" ; -- watussi..nn.1
  web_1_N = mkN "web" ; -- web..nn.1
  webanonymitet_1_N = mkN "webanonymitet" "webanonymiteter" ; -- webanonymitet..nn.1
  webb_1_N = mkN "webb" ; -- webb..nn.1
  webbaserad_1_A = mkA "webbaserad" ; -- webbaserad..av.1
  webbdomän_1_N = mkN "webbdomän" "webbdomäner" ; -- webbdomän..nn.1
  webbkamera_1_N = mkN "webbkamera" ; -- webbkamera..nn.1
  webblänk_1_N = mkN "webblänk" ; -- webblänk..nn.1
  webbläsare_1_N = mkN "webbläsare" utrum  ; -- webbläsare..nn.1
  webbplats_1_N = mkN "webbplats" "webbplatser" ; -- webbplats..nn.1
  webbsida_1_N = mkN "webbsida" ; -- webbsida..nn.1
  webbsupport_1_N = mkN "webbsupport" ; -- webbsupport..nn.1
  webbtelevision_1_N = mkN "webbtelevision" ; -- webbtelevision..nn.1
  webbtest_1_N = mkN "webbtest" neutrum  ; -- webbtest..nn.1
  webbteve_1_N = mkN "webbteve" ; -- webbteve..nn.1
  webbtjänst_1_N = mkN "webbtjänst" "webbtjänster" ; -- webbtjänst..nn.1
  weekend_1_N = mkN "weekend" "weekenden" "weekends" "weekendsarna" ; -- weekend..nn.1
  wellness_1_N = mkN "wellness" ; -- wellness..nn.1
  wellnessavdelning_1_N = mkN "wellnessavdelning" ; -- wellnessavdelning..nn.1
  wellpapp_1_N = mkN "wellpapp" ; -- wellpapp..nn.1
  weltervikt_1_N = mkN "weltervikt" ; -- weltervikt..nn.1
  weltschmerz_1_N = mkN "weltschmerz" ; -- weltschmerz..nn.1
  wenlock_1_N = mkN "wenlock" ; -- wenlock..nn.1
  western_1_N = mkN "western" "western" "westerns" "westerna" ; -- western..nn.1
  westernfilm_1_N = mkN "westernfilm" "westernfilmer" ; -- westernfilm..nn.1
  whig_1_N = mkN "whig" "whigen" "whigs" "whigsarna" ; -- whig..nn.1
  whippet_1_N = mkN "whippet" ; -- whippet..nn.1
  whiskybutelj_1_N = mkN "whiskybutelj" "whiskybuteljer" ; -- whiskybutelj..nn.1
  whiskyexport_1_N = mkN "whiskyexport" ; -- whiskyexport..nn.1
  whiskypinne_1_N = mkN "whiskypinne" utrum  ; -- whiskypinne..nn.1
  whiskyprovning_1_N = mkN "whiskyprovning" ; -- whiskyprovning..nn.1
  whiskysort_1_N = mkN "whiskysort" "whiskysorter" ; -- whiskysort..nn.1
  whiskysprucken_1_A = mkA "whiskysprucken" ; -- whiskysprucken..av.1
  whist_1_N = mkN "whist" ; -- whist..nn.1
  wienerbröd_1_N = mkN "wienerbröd" neutrum  ; -- wienerbröd..nn.1
  wienerkorv_1_N = mkN "wienerkorv" ; -- wienerkorv..nn.1
  wienerschnitzel_1_N = mkN "wienerschnitzel" ; -- wienerschnitzel..nn.1
  wienervals_1_N = mkN "wienervals" "wienervalser" ; -- wienervals..nn.1
  wienklassicism_1_N = mkN "wienklassicism" "wienklassicismer" ; -- wienklassicism..nn.1
  wienklassicistisk_1_A = mkA "wienklassicistisk" ; -- wienklassicistisk..av.1
  wigwam_1_N = mkN "wigwam" "wigwamer" ; -- wigwam..nn.1
  wiki_1_N = mkN "wiki" "wikin" "wikis" "wikisarna" ; -- wiki..nn.1
  wiltonmatta_1_N = mkN "wiltonmatta" ; -- wiltonmatta..nn.1
  wire_1_N = mkN "wire" utrum  ; -- wire..nn.1
  wobbler_1_N = mkN "wobbler" "wobblern" "wobblers" "wobblersen" ; -- wobbler..nn.1
  wok_1_N = mkN "wok" ; -- wok..nn.1
  woka_1_V = mkV "wokar" ; -- woka..vb.1
  wokande_1_N = mkN "wokande" ; -- wokande..nn.1
  wokning_1_N = mkN "wokning" ; -- wokning..nn.1
  wokpanna_1_N = mkN "wokpanna" ; -- wokpanna..nn.1
  wolfram_1_N = mkN "wolfram" ; -- wolfram..nn.1
  worcestersås_1_N = mkN "worcestersås" "worcestersåser" ; -- worcestersås..nn.1
  workshop_1_N = mkN "workshop" ; -- workshop..nn.1
  x_a_1_V = mkV "x-ar" ; -- x-a..vb.1
  x_ande_1_N = mkN "x-ande" ; -- x-ande..nn.1
  x_axel_1_N = mkN "x-axel" ; -- x-axel..nn.1
  x_formad_1_A = mkA "x-formad" ; -- x-formad..av.1
  x_formig_1_A = mkA "x-formig" ; -- x-formig..av.1
  x_koordinat_1_N = mkN "x-koordinat" "x-koordinater" ; -- x-koordinat..nn.1
  x_kromosom_1_N = mkN "x-kromosom" "x-kromosomer" ; -- x-kromosom..nn.1
  xa_1_V = mkV "x:ar" ; -- xa..vb.1
  xande_1_N = mkN "x:ande" ; -- xande..nn.1
  xantippa_1_N = mkN "xantippa" ; -- xantippa..nn.1
  xantofyll_1_N = mkN "xantofyll" neutrum  ; -- xantofyll..nn.1
  xenofobi_1_N = mkN "xenofobi" ; -- xenofobi..nn.1
  xenon_1_N = mkN "xenon" neutrum  ; -- xenon..nn.1
  xerografi_1_N = mkN "xerografi" ; -- xerografi..nn.1
  xerotin_1_N = mkN "xerotin" ; -- xerotin..nn.1
  xformad_1_A = mkA "xformad" ; -- xformad..av.1
  xformig_1_A = mkA "xformig" ; -- xformig..av.1
  xi_1_N = mkN "xi" neutrum  ; -- xi..nn.1
  xylofon_1_N = mkN "xylofon" "xylofoner" ; -- xylofon..nn.1
  xylograf_1_N = mkN "xylograf" "xylografer" ; -- xylograf..nn.1
  xylografi_1_N = mkN "xylografi" "xylografier" ; -- xylografi..nn.1
  xylografisk_1_A = mkA "xylografisk" ; -- xylografisk..av.1
  y_axel_1_N = mkN "y-axel" ; -- y-axel..nn.1
  y_koordinat_1_N = mkN "y-koordinat" "y-koordinater" ; -- y-koordinat..nn.1
  y_kromosom_1_N = mkN "y-kromosom" "y-kromosomer" ; -- y-kromosom..nn.1
  yacht_1_N = mkN "yacht" "yachter" ; -- yacht..nn.1
  yakuza_1_N = mkN "yakuza" ; -- yakuza..nn.1
  yalelås_1_N = mkN "yalelås" neutrum  ; -- yalelås..nn.1
  yankee_1_N = mkN "yankee" "yankeer" ; -- yankee..nn.1
  yankeejib_1_N = mkN "yankeejib" "yankeejibben" "yankeejibbar" "yankeejibbarna" ; -- yankeejib..nn.1
  yard_1_N = mkN "yard" "yarden" "yards" "yardsen" ; -- yard..nn.1
  yatzy_1_N = mkN "yatzy" ; -- yatzy..nn.1
  yawl_1_N = mkN "yawl" "yawler" ; -- yawl..nn.1
  yen_1_N = mkN "yen" "yenen" "yen" "yenen" ; -- yen..nn.1
  yl_1_N = mkN "yl" neutrum  ; -- yl..nn.1
  yla_1_V = mkV "ylar" ; -- yla..vb.1
  ylande_1_N = mkN "ylande" ; -- ylande..nn.1
  ylle_1_N = mkN "ylle" ; -- ylle..nn.1
  yllelump_1_N = mkN "yllelump" "yllelumpor" ; -- yllelump..nn.1
  yllen_1_A = mkA "yllen" ; -- yllen..av.1
  yllestrumpa_1_N = mkN "yllestrumpa" ; -- yllestrumpa..nn.1
  ylletyg_1_N = mkN "ylletyg" neutrum  ; -- ylletyg..nn.1
  yllevävnad_1_N = mkN "yllevävnad" "yllevävnader" ; -- yllevävnad..nn.1
  ymnig_1_A = mkA "ymnig" ; -- ymnig..av.1
  ymnighet_1_N = mkN "ymnighet" ; -- ymnighet..nn.1
  ymnighetshorn_1_N = mkN "ymnighetshorn" neutrum  ; -- ymnighetshorn..nn.1
  ymp_1_N = mkN "ymp" ; -- ymp..nn.1
  ympa_1_V = mkV "ympar" ; -- ympa..vb.1
  ympande_1_N = mkN "ympande" ; -- ympande..nn.1
  ympkniv_1_N = mkN "ympkniv" ; -- ympkniv..nn.1
  ympkvist_1_N = mkN "ympkvist" ; -- ympkvist..nn.1
  ympning_1_N = mkN "ympning" ; -- ympning..nn.1
  ympningsplikt_1_N = mkN "ympningsplikt" ; -- ympningsplikt..nn.1
  ympsnitt_1_N = mkN "ympsnitt" neutrum  ; -- ympsnitt..nn.1
  ympstam_1_N = mkN "ympstam" "ympstammen" "ympstammar" "ympstammarna" ; -- ympstam..nn.1
  ympsår_1_N = mkN "ympsår" neutrum  ; -- ympsår..nn.1
  ymptvång_1_N = mkN "ymptvång" neutrum  ; -- ymptvång..nn.1
  ympvax_1_N = mkN "ympvax" neutrum  ; -- ympvax..nn.1
  yngel_1_N = mkN "yngel" neutrum  ; -- yngel..nn.1
  yngelcell_1_N = mkN "yngelcell" "yngelceller" ; -- yngelcell..nn.1
  yngeldamm_1_N = mkN "yngeldamm" ; -- yngeldamm..nn.1
  yngelkaka_1_N = mkN "yngelkaka" ; -- yngelkaka..nn.1
  yngelröta_1_N = mkN "yngelröta" ; -- yngelröta..nn.1
  yngelstadium_1_N = mkN "yngelstadium" "yngelstadiet" "yngelstadier" "yngelstadierna" ; -- yngelstadium..nn.1
  yngeltråg_1_N = mkN "yngeltråg" neutrum  ; -- yngeltråg..nn.1
  yngla_1_V = mkV "ynglar" ; -- yngla..vb.1
  ynglande_1_N = mkN "ynglande" ; -- ynglande..nn.1
  yngling_1_N = mkN "yngling" ; -- yngling..nn.1
  ynglingalynne_1_N = mkN "ynglingalynne" ; -- ynglingalynne..nn.1
  ynglingasinne_1_N = mkN "ynglingasinne" ; -- ynglingasinne..nn.1
  ynk_1_N = mkN "ynk" ; -- ynk..nn.1
  ynka_1_A = mkA "ynka" ; -- ynka..av.1
  ynka_1_V = mkV "ynkar" ; -- ynka..vb.1
  ynkande_1_N = mkN "ynkande" ; -- ynkande..nn.1
  ynkansvärd_1_A = mkA "ynkansvärd" "ynkansvärt" ; -- ynkansvärd..av.1
  ynkansvärdhet_1_N = mkN "ynkansvärdhet" ; -- ynkansvärdhet..nn.1
  ynkedom_1_N = mkN "ynkedom" ; -- ynkedom..nn.1
  ynklig_1_A = mkA "ynklig" ; -- ynklig..av.1
  ynklighet_1_N = mkN "ynklighet" ; -- ynklighet..nn.1
  ynkrygg_1_N = mkN "ynkrygg" ; -- ynkrygg..nn.1
  ynnest_1_N = mkN "ynnest" ; -- ynnest..nn.1
  ynnestbetygelse_1_N = mkN "ynnestbetygelse" "ynnestbetygelser" ; -- ynnestbetygelse..nn.1
  ynnestbevis_1_N = mkN "ynnestbevis" neutrum  ; -- ynnestbevis..nn.1
  ynnestfull_1_A = mkA "ynnestfull" ; -- ynnestfull..av.1
  ynnestprov_1_N = mkN "ynnestprov" neutrum  ; -- ynnestprov..nn.1
  yoga_1_N = mkN "yoga" ; -- yoga..nn.1
  yoga_1_V = mkV "yogar" ; -- yoga..vb.1
  yogainstitut_1_N = mkN "yogainstitut" neutrum  ; -- yogainstitut..nn.1
  yogande_1_N = mkN "yogande" ; -- yogande..nn.1
  yogapass_1_N = mkN "yogapass" neutrum  ; -- yogapass..nn.1
  yogautövare_1_N = mkN "yogautövare" utrum  ; -- yogautövare..nn.1
  yoghurt_1_N = mkN "yoghurt" ; -- yoghurt..nn.1
  yogi_1_N = mkN "yogi" "yogin" "yogier" "yogierna" ; -- yogi..nn.1
  yoloa_1_V = mkV "yoloar" ; -- yoloa..vb.1
  yppa_1_V = mkV "yppar" ; -- yppa..vb.1
  yppande_1_N = mkN "yppande" ; -- yppande..nn.1
  yppandeförbud_1_N = mkN "yppandeförbud" neutrum  ; -- yppandeförbud..nn.1
  ypperlig_1_A = mkA "ypperlig" ; -- ypperlig..av.1
  ypperlighet_1_N = mkN "ypperlighet" "ypperligheter" ; -- ypperlighet..nn.1
  yppig_1_A = mkA "yppig" ; -- yppig..av.1
  yppighet_1_N = mkN "yppighet" ; -- yppighet..nn.1
  ypsilon_1_N = mkN "ypsilon" neutrum  ; -- ypsilon..nn.1
  yr_1_A = mkA "yr" ; -- yr..av.1
  yra_1_N = mkN "yra" ; -- yra..nn.1
  yra_1_V = mkV "yrar" ; -- yra..vb.1
  yra_2_V = mkV "yra" "yrde" "yrt" ; -- yra..vb.2
  yrande_1_N = mkN "yrande" ; -- yrande..nn.1
  yrhet_1_N = mkN "yrhet" ; -- yrhet..nn.1
  yrhätta_1_N = mkN "yrhätta" ; -- yrhätta..nn.1
  yrka_1_V = mkV "yrkar" ; -- yrka..vb.1
  yrkande_1_N = mkN "yrkande" ; -- yrkande..nn.1
  yrke_1_N = mkN "yrke" ; -- yrke..nn.1
  yrkesaktiv_1_A = mkA "yrkesaktiv" ; -- yrkesaktiv..av.1
  yrkesarbeta_1_V = mkV "yrkesarbetar" ; -- yrkesarbeta..vb.1
  yrkesarbetande_1_A = mkA "yrkesarbetande" ; -- yrkesarbetande..av.1
  yrkesarbetande_1_N = mkN "yrkesarbetande" ; -- yrkesarbetande..nn.1
  yrkesarbetare_1_N = mkN "yrkesarbetare" utrum  ; -- yrkesarbetare..nn.1
  yrkesarbete_1_N = mkN "yrkesarbete" ; -- yrkesarbete..nn.1
  yrkesarmé_1_N = mkN "yrkesarmé" "yrkesarméer" ; -- yrkesarmé..nn.1
  yrkesdröm_1_N = mkN "yrkesdröm" "yrkesdrömmen" "yrkesdrömmar" "yrkesdrömmarna" ; -- yrkesdröm..nn.1
  yrkesetik_1_N = mkN "yrkesetik" "yrkesetiker" ; -- yrkesetik..nn.1
  yrkesetisk_1_A = mkA "yrkesetisk" ; -- yrkesetisk..av.1
  yrkesfiskare_1_N = mkN "yrkesfiskare" utrum  ; -- yrkesfiskare..nn.1
  yrkesfiske_1_N = mkN "yrkesfiske" ; -- yrkesfiske..nn.1
  yrkesfysiker_1_N = mkN "yrkesfysiker" "yrkesfysikern" "yrkesfysiker" "yrkesfysikerna" ; -- yrkesfysiker..nn.1
  yrkesfärdighet_1_N = mkN "yrkesfärdighet" ; -- yrkesfärdighet..nn.1
  yrkesförberedande_1_A = mkA "yrkesförberedande" ; -- yrkesförberedande..av.1
  yrkesförbud_1_N = mkN "yrkesförbud" neutrum  ; -- yrkesförbud..nn.1
  yrkesgrupp_1_N = mkN "yrkesgrupp" "yrkesgrupper" ; -- yrkesgrupp..nn.1
  yrkesheder_1_N = mkN "yrkesheder" ; -- yrkesheder..nn.1
  yrkeshemlighet_1_N = mkN "yrkeshemlighet" "yrkeshemligheter" ; -- yrkeshemlighet..nn.1
  yrkesinriktad_1_A = mkA "yrkesinriktad" ; -- yrkesinriktad..av.1
  yrkesinspektion_1_N = mkN "yrkesinspektion" ; -- yrkesinspektion..nn.1
  yrkeskategori_1_N = mkN "yrkeskategori" "yrkeskategorier" ; -- yrkeskategori..nn.1
  yrkeskodex_1_N = mkN "yrkeskodex" ; -- yrkeskodex..nn.1
  yrkeskollega_1_N = mkN "yrkeskollega" ; -- yrkeskollega..nn.1
  yrkeskriminell_1_A = mkA "yrkeskriminell" ; -- yrkeskriminell..av.1
  yrkeskunnig_1_A = mkA "yrkeskunnig" ; -- yrkeskunnig..av.1
  yrkeskunnighet_1_N = mkN "yrkeskunnighet" ; -- yrkeskunnighet..nn.1
  yrkeskvinna_1_N = mkN "yrkeskvinna" ; -- yrkeskvinna..nn.1
  yrkeskår_1_N = mkN "yrkeskår" "yrkeskårer" ; -- yrkeskår..nn.1
  yrkesliv_1_N = mkN "yrkesliv" neutrum  ; -- yrkesliv..nn.1
  yrkeslärare_1_N = mkN "yrkeslärare" utrum  ; -- yrkeslärare..nn.1
  yrkesman_1_N = mkN "yrkesman" "yrkesmannen" "yrkesmän" "yrkesmännen" ; -- yrkesman..nn.1
  yrkesmässig_1_A = mkA "yrkesmässig" ; -- yrkesmässig..av.1
  yrkesmässighet_1_N = mkN "yrkesmässighet" ; -- yrkesmässighet..nn.1
  yrkesorientering_1_N = mkN "yrkesorientering" ; -- yrkesorientering..nn.1
  yrkespolitiker_1_N = mkN "yrkespolitiker" "yrkespolitikern" "yrkespolitiker" "yrkespolitikerna" ; -- yrkespolitiker..nn.1
  yrkespraktik_1_N = mkN "yrkespraktik" "yrkespraktiker" ; -- yrkespraktik..nn.1
  yrkesregister_1_N = mkN "yrkesregister" neutrum  ; -- yrkesregister..nn.1
  yrkessjukdom_1_N = mkN "yrkessjukdom" ; -- yrkessjukdom..nn.1
  yrkesskada_1_N = mkN "yrkesskada" ; -- yrkesskada..nn.1
  yrkesskicklig_1_A = mkA "yrkesskicklig" ; -- yrkesskicklig..av.1
  yrkesskicklighet_1_N = mkN "yrkesskicklighet" ; -- yrkesskicklighet..nn.1
  yrkesskola_1_N = mkN "yrkesskola" ; -- yrkesskola..nn.1
  yrkesspråk_1_N = mkN "yrkesspråk" neutrum  ; -- yrkesspråk..nn.1
  yrkestiggare_1_N = mkN "yrkestiggare" utrum  ; -- yrkestiggare..nn.1
  yrkestiggeri_1_N = mkN "yrkestiggeri" neutrum  ; -- yrkestiggeri..nn.1
  yrkestitel_1_N = mkN "yrkestitel" ; -- yrkestitel..nn.1
  yrkestjuv_1_N = mkN "yrkestjuv" ; -- yrkestjuv..nn.1
  yrkestrafik_1_N = mkN "yrkestrafik" ; -- yrkestrafik..nn.1
  yrkesutbildad_1_A = mkA "yrkesutbildad" ; -- yrkesutbildad..av.1
  yrkesutbildning_1_N = mkN "yrkesutbildning" ; -- yrkesutbildning..nn.1
  yrkesval_1_N = mkN "yrkesval" neutrum  ; -- yrkesval..nn.1
  yrkesverksam_1_A = mkA "yrkesverksam" "yrkesverksamt" "yrkesverksamma" "yrkesverksamma" "yrkesverksammare" "yrkesverksammast" "yrkesverksammaste" ; -- yrkesverksam..av.1
  yrkesverksamhet_1_N = mkN "yrkesverksamhet" ; -- yrkesverksamhet..nn.1
  yrkesvägledare_1_N = mkN "yrkesvägledare" utrum  ; -- yrkesvägledare..nn.1
  yrkesvägledning_1_N = mkN "yrkesvägledning" ; -- yrkesvägledning..nn.1
  yrsand_1_N = mkN "yrsand" ; -- yrsand..nn.1
  yrsel_1_N = mkN "yrsel" ; -- yrsel..nn.1
  yrsnö_1_N = mkN "yrsnö" ; -- yrsnö..nn.1
  yrvaken_1_A = mkA "yrvaken" ; -- yrvaken..av.1
  yrvakenhet_1_N = mkN "yrvakenhet" ; -- yrvakenhet..nn.1
  yrväder_1_N = mkN "yrväder" neutrum  ; -- yrväder..nn.1
  ysta_1_V = mkV "ystar" ; -- ysta..vb.1
  ystande_1_N = mkN "ystande" ; -- ystande..nn.1
  yste_1_N = mkN "yste" ; -- yste..nn.1
  yster_1_A = mkA "yster" ; -- yster..av.1
  ysterhet_1_N = mkN "ysterhet" ; -- ysterhet..nn.1
  yta_1_N = mkN "yta" ; -- yta..nn.1
  ytaktiv_1_A = mkA "ytaktiv" ; -- ytaktiv..av.1
  ytavvägning_1_N = mkN "ytavvägning" ; -- ytavvägning..nn.1
  ytbehandla_1_V = mkV "ytbehandlar" ; -- ytbehandla..vb.1
  ytbehandlande_1_N = mkN "ytbehandlande" ; -- ytbehandlande..nn.1
  ytbergart_1_N = mkN "ytbergart" "ytbergarter" ; -- ytbergart..nn.1
  yteffekt_1_N = mkN "yteffekt" "yteffekter" ; -- yteffekt..nn.1
  yteld_1_N = mkN "yteld" ; -- yteld..nn.1
  ytenhet_1_N = mkN "ytenhet" "ytenheter" ; -- ytenhet..nn.1
  ytfartyg_1_N = mkN "ytfartyg" neutrum  ; -- ytfartyg..nn.1
  ytform_1_N = mkN "ytform" "ytformer" ; -- ytform..nn.1
  ytlager_1_N = mkN "ytlager" neutrum  ; -- ytlager..nn.1
  ytledes_1_Adv = mkAdv "ytledes" ; -- ytledes..ab.1
  ytlig_1_A = mkA "ytlig" ; -- ytlig..av.1
  ytlighet_1_N = mkN "ytlighet" "ytligheter" ; -- ytlighet..nn.1
  ytmorän_1_N = mkN "ytmorän" "ytmoräner" ; -- ytmorän..nn.1
  ytmässig_1_A = mkA "ytmässig" ; -- ytmässig..av.1
  ytmått_1_N = mkN "ytmått" neutrum  ; -- ytmått..nn.1
  ytskikt_1_N = mkN "ytskikt" neutrum  ; -- ytskikt..nn.1
  ytspänning_1_N = mkN "ytspänning" ; -- ytspänning..nn.1
  ytstruktur_1_N = mkN "ytstruktur" "ytstrukturer" ; -- ytstruktur..nn.1
  ytter_1_N = mkN "ytter" ; -- ytter..nn.1
  ytterbana_1_N = mkN "ytterbana" ; -- ytterbana..nn.1
  ytterbium_1_N = mkN "ytterbium" neutrum  ; -- ytterbium..nn.1
  ytterdel_1_N = mkN "ytterdel" "ytterdelen" "ytterdelar" "ytterdelarna" ; -- ytterdel..nn.1
  ytterdörr_1_N = mkN "ytterdörr" ; -- ytterdörr..nn.1
  ytterdörrhandtag_1_N = mkN "ytterdörrhandtag" neutrum  ; -- ytterdörrhandtag..nn.1
  ytterfack_1_N = mkN "ytterfack" neutrum  ; -- ytterfack..nn.1
  ytterfarstu_1_N = mkN "ytterfarstu" "ytterfarstun" "ytterfarstur" "ytterfarsturna" ; -- ytterfarstu..nn.1
  ytterficka_1_N = mkN "ytterficka" ; -- ytterficka..nn.1
  ytterfoder_1_N = mkN "ytterfoder" neutrum  ; -- ytterfoder..nn.1
  ytterhud_1_N = mkN "ytterhud" ; -- ytterhud..nn.1
  ytterhölje_1_N = mkN "ytterhölje" ; -- ytterhölje..nn.1
  ytterkant_1_N = mkN "ytterkant" "ytterkanter" ; -- ytterkant..nn.1
  ytterkurva_1_N = mkN "ytterkurva" ; -- ytterkurva..nn.1
  ytterlig_1_A = mkA "ytterlig" ; -- ytterlig..av.1
  ytterligare_1_A = mkA "ytterligare" ; -- ytterligare..av.1
  ytterlighet_1_N = mkN "ytterlighet" "ytterligheter" ; -- ytterlighet..nn.1
  ytterlighetsparti_1_N = mkN "ytterlighetsparti" "ytterlighetspartiet" "ytterlighetspartier" "ytterlighetspartierna" ; -- ytterlighetsparti..nn.1
  ytterlighetsriktning_1_N = mkN "ytterlighetsriktning" ; -- ytterlighetsriktning..nn.1
  ytterlighetsåtgärd_1_N = mkN "ytterlighetsåtgärd" "ytterlighetsåtgärder" ; -- ytterlighetsåtgärd..nn.1
  yttermarginal_1_N = mkN "yttermarginal" "yttermarginaler" ; -- yttermarginal..nn.1
  ytterområde_1_N = mkN "ytterområde" ; -- ytterområde..nn.1
  ytterplagg_1_N = mkN "ytterplagg" neutrum  ; -- ytterplagg..nn.1
  ytterrock_1_N = mkN "ytterrock" ; -- ytterrock..nn.1
  yttersida_1_N = mkN "yttersida" ; -- yttersida..nn.1
  ytterskär_1_N = mkN "ytterskär" neutrum  ; -- ytterskär..nn.1
  ytterspår_1_N = mkN "ytterspår" neutrum  ; -- ytterspår..nn.1
  ytterst_1_Adv = mkAdv "ytterst" ; -- ytterst..ab.1
  yttersula_1_N = mkN "yttersula" ; -- yttersula..nn.1
  yttertak_1_N = mkN "yttertak" neutrum  ; -- yttertak..nn.1
  yttervinkel_1_N = mkN "yttervinkel" ; -- yttervinkel..nn.1
  yttervägg_1_N = mkN "yttervägg" ; -- yttervägg..nn.1
  yttervärld_1_N = mkN "yttervärld" ; -- yttervärld..nn.1
  ytteröra_1_N = mkN "ytteröra" "ytterörat" "ytteröron" "ytteröronen" ; -- ytteröra..nn.1
  yttra_1_V = mkV "yttrar" ; -- yttra..vb.1
  yttrande_1_N = mkN "yttrande" ; -- yttrande..nn.1
  yttrandefrihet_1_N = mkN "yttrandefrihet" "yttrandefriheter" ; -- yttrandefrihet..nn.1
  yttrandefrihetsfråga_1_N = mkN "yttrandefrihetsfråga" ; -- yttrandefrihetsfråga..nn.1
  yttrandefrihetslag_1_N = mkN "yttrandefrihetslag" ; -- yttrandefrihetslag..nn.1
  yttranderätt_1_N = mkN "yttranderätt" ; -- yttranderätt..nn.1
  yttre_1_N = mkN "yttre" ; -- yttre..nn.1
  yttring_1_N = mkN "yttring" ; -- yttring..nn.1
  yttrium_1_N = mkN "yttrium" neutrum  ; -- yttrium..nn.1
  yttriumoxid_1_N = mkN "yttriumoxid" "yttriumoxider" ; -- yttriumoxid..nn.1
  yttryck_1_N = mkN "yttryck" neutrum  ; -- yttryck..nn.1
  ytvatten_1_N = mkN "ytvatten" "ytvattnet" "ytvatten" "ytvattnen" ; -- ytvatten..nn.1
  ytvattenskikt_1_N = mkN "ytvattenskikt" neutrum  ; -- ytvattenskikt..nn.1
  ytved_1_N = mkN "ytved" ; -- ytved..nn.1
  ytvidd_1_N = mkN "ytvidd" "ytvidder" ; -- ytvidd..nn.1
  yverboren_1_A = mkA "yverboren" ; -- yverboren..av.1
  yvig_1_A = mkA "yvig" ; -- yvig..av.1
  yvighet_1_N = mkN "yvighet" ; -- yvighet..nn.1
  yvighet_2_N = mkN "yvighet" "yvigheter" ; -- yvighet..nn.2
  yxa_1_N = mkN "yxa" ; -- yxa..nn.1
  yxblad_1_N = mkN "yxblad" neutrum  ; -- yxblad..nn.1
  yxhammare_1_N = mkN "yxhammare" "yxhammaren" "yxhammare" "yxhamrarna" ; -- yxhammare..nn.1
  yxhugg_1_N = mkN "yxhugg" neutrum  ; -- yxhugg..nn.1
  yxhuvud_1_N = mkN "yxhuvud" "yxhuvudet" "yxhuvud" "yxhuvudena" ; -- yxhuvud..nn.1
  yxig_1_A = mkA "yxig" ; -- yxig..av.1
  yxlägg_1_N = mkN "yxlägg" ; -- yxlägg..nn.1
  yxman_1_N = mkN "yxman" "yxmannen" "yxmän" "yxmännen" ; -- yxman..nn.1
  yxmord_1_N = mkN "yxmord" neutrum  ; -- yxmord..nn.1
  yxne_1_N = mkN "yxne" ; -- yxne..nn.1
  yxskaft_1_N = mkN "yxskaft" neutrum  ; -- yxskaft..nn.1
  yxämne_1_N = mkN "yxämne" ; -- yxämne..nn.1
  zairier_1_N = mkN "zairier" "zairiern" "zairier" "zairierna" ; -- zairier..nn.1
  zairisk_1_A = mkA "zairisk" ; -- zairisk..av.1
  zambier_1_N = mkN "zambier" "zambiern" "zambier" "zambierna" ; -- zambier..nn.1
  zambisk_1_A = mkA "zambisk" ; -- zambisk..av.1
  zappa_1_V = mkV "zappar" ; -- zappa..vb.1
  zappande_1_N = mkN "zappande" ; -- zappande..nn.1
  zappning_1_N = mkN "zappning" ; -- zappning..nn.1
  zebra_1_N = mkN "zebra" ; -- zebra..nn.1
  zefyr_1_N = mkN "zefyr" "zefyrer" ; -- zefyr..nn.1
  zelot_1_N = mkN "zelot" "zeloter" ; -- zelot..nn.1
  zendavesta_1_N = mkN "zendavesta" ; -- zendavesta..nn.1
  zenit_1_N = mkN "zenit" ; -- zenit..nn.1
  zenitdistans_1_N = mkN "zenitdistans" "zenitdistanser" ; -- zenitdistans..nn.1
  zeolit_1_N = mkN "zeolit" ; -- zeolit..nn.1
  zeppelinare_1_N = mkN "zeppelinare" utrum  ; -- zeppelinare..nn.1
  zeppelinarhangar_1_N = mkN "zeppelinarhangar" "zeppelinarhangarn" "zeppelinarhangarer" "zeppelinarhangarerna" ; -- zeppelinarhangar..nn.1
  zeppelinarpilot_1_N = mkN "zeppelinarpilot" "zeppelinarpiloter" ; -- zeppelinarpilot..nn.1
  zeta_1_N = mkN "zeta" "zetat" "zetan" "zetana" ; -- zeta..nn.1
  zeugma_1_N = mkN "zeugma" "zeugmat" "zeugman" "zeugmana" ; -- zeugma..nn.1
  zigenare_1_N = mkN "zigenare" utrum  ; -- zigenare..nn.1
  zigenarflicka_1_N = mkN "zigenarflicka" ; -- zigenarflicka..nn.1
  zigenarhövding_1_N = mkN "zigenarhövding" ; -- zigenarhövding..nn.1
  zigenarkapell_1_N = mkN "zigenarkapell" neutrum  ; -- zigenarkapell..nn.1
  zigenarkaravan_1_N = mkN "zigenarkaravan" "zigenarkaravaner" ; -- zigenarkaravan..nn.1
  zigenarliv_1_N = mkN "zigenarliv" neutrum  ; -- zigenarliv..nn.1
  zigenarmusik_1_N = mkN "zigenarmusik" ; -- zigenarmusik..nn.1
  zigenarspråk_1_N = mkN "zigenarspråk" neutrum  ; -- zigenarspråk..nn.1
  zigensk_1_A = mkA "zigensk" ; -- zigensk..av.1
  zigenska_1_N = mkN "zigenska" ; -- zigenska..nn.1
  ziggurat_1_N = mkN "ziggurat" neutrum  ; -- ziggurat..nn.1
  zikkurat_1_N = mkN "zikkurat" neutrum  ; -- zikkurat..nn.1
  zimbabwier_1_N = mkN "zimbabwier" "zimbabwiern" "zimbabwier" "zimbabwierna" ; -- zimbabwier..nn.1
  zimbabwisk_1_A = mkA "zimbabwisk" ; -- zimbabwisk..av.1
  zink_1_N = mkN "zink" ; -- zink..nn.1
  zinkblände_1_N = mkN "zinkblände" ; -- zinkblände..nn.1
  zinkfeber_1_N = mkN "zinkfeber" ; -- zinkfeber..nn.1
  zinkgult_1_N = mkN "zinkgult" ; -- zinkgult..nn.1
  zinkmalm_1_N = mkN "zinkmalm" "zinkmalmer" ; -- zinkmalm..nn.1
  zinksalva_1_N = mkN "zinksalva" ; -- zinksalva..nn.1
  zinkspat_1_N = mkN "zinkspat" ; -- zinkspat..nn.1
  zinkvitt_1_N = mkN "zinkvitt" ; -- zinkvitt..nn.1
  zinkånga_1_N = mkN "zinkånga" ; -- zinkånga..nn.1
  zinnia_1_N = mkN "zinnia" ; -- zinnia..nn.1
  ziqqurat_1_N = mkN "ziqqurat" neutrum  ; -- ziqqurat..nn.1
  zirkon_1_N = mkN "zirkon" "zirkoner" ; -- zirkon..nn.1
  zirkonium_1_N = mkN "zirkonium" neutrum  ; -- zirkonium..nn.1
  zirkoniumoxid_1_N = mkN "zirkoniumoxid" "zirkoniumoxider" ; -- zirkoniumoxid..nn.1
  zloty_1_N = mkN "zloty" "zlotyn" "zloty" "zlotyna" ; -- zloty..nn.1
  zodiak_1_N = mkN "zodiak" ; -- zodiak..nn.1
  zodiakalljus_1_N = mkN "zodiakalljus" neutrum  ; -- zodiakalljus..nn.1
  zombie_1_N = mkN "zombie" "zombier" ; -- zombie..nn.1
  zon_1_N = mkN "zon" "zoner" ; -- zon..nn.1
  zonrör_1_N = mkN "zonrör" neutrum  ; -- zonrör..nn.1
  zontariff_1_N = mkN "zontariff" "zontariffer" ; -- zontariff..nn.1
  zontaxa_1_N = mkN "zontaxa" ; -- zontaxa..nn.1
  zonterapi_1_N = mkN "zonterapi" ; -- zonterapi..nn.1
  zontid_1_N = mkN "zontid" ; -- zontid..nn.1
  zoo_1_N = mkN "zoo" "zoot" "zoon" "zoona" ; -- zoo..nn.1
  zoofysiologi_1_N = mkN "zoofysiologi" ; -- zoofysiologi..nn.1
  zoolog_1_N = mkN "zoolog" "zoologer" ; -- zoolog..nn.1
  zoologi_1_N = mkN "zoologi" ; -- zoologi..nn.1
  zoologisk_1_A = mkA "zoologisk" ; -- zoologisk..av.1
  zoom_1_N = mkN "zoom" ; -- zoom..nn.1
  zooma_1_V = mkV "zoomar" ; -- zooma..vb.1
  zoomande_1_N = mkN "zoomande" ; -- zoomande..nn.1
  zoomobjektiv_1_N = mkN "zoomobjektiv" neutrum  ; -- zoomobjektiv..nn.1
  zootomi_1_N = mkN "zootomi" ; -- zootomi..nn.1
  zoroastrisk_1_A = mkA "zoroastrisk" ; -- zoroastrisk..av.1
  zoroastrism_1_N = mkN "zoroastrism" ; -- zoroastrism..nn.1
  zucchini_1_N = mkN "zucchini" "zucchinin" "zucchinis" "zucchinisen" ; -- zucchini..nn.1
  zulu_1_N = mkN "zulu" "zulun" "zuluer" "zuluerna" ; -- zulu..nn.1
  zygot_1_N = mkN "zygot" "zygoter" ; -- zygot..nn.1
  zäta_1_N = mkN "zäta" "zätat" "zätan" "zätana" ; -- zäta..nn.1
  Östermalmstant_1_N = mkN "Östermalmstant" "Östermalmstanter" ; -- Östermalmstant..nn.1
  Östersjösamarbete_1_N = mkN "Östersjösamarbete" ; -- Östersjösamarbete..nn.1
  äckel_1_N = mkN "äckel" neutrum  ; -- äckel..nn.1
  äckelklump_1_N = mkN "äckelklump" ; -- äckelklump..nn.1
  äckelkänsla_1_N = mkN "äckelkänsla" ; -- äckelkänsla..nn.1
  äckla_1_V = mkV "äcklar" ; -- äckla..vb.1
  äcklande_1_N = mkN "äcklande" ; -- äcklande..nn.1
  äcklig_1_A = mkA "äcklig" ; -- äcklig..av.1
  äcklighet_1_N = mkN "äcklighet" "äckligheter" ; -- äcklighet..nn.1
  äcklo_1_N = mkN "äcklo" "äcklot" "äcklon" "äcklona" ; -- äcklo..nn.1
  ädel_1_A = mkA "ädel" "ädelt" "ädla" "ädla" "ädlare" "ädlast" "ädlaste" ; -- ädel..av.1
  ädelfasan_1_N = mkN "ädelfasan" "ädelfasaner" ; -- ädelfasan..nn.1
  ädelfisk_1_N = mkN "ädelfisk" ; -- ädelfisk..nn.1
  ädelgas_1_N = mkN "ädelgas" "ädelgaser" ; -- ädelgas..nn.1
  ädelgran_1_N = mkN "ädelgran" ; -- ädelgran..nn.1
  ädelhet_1_N = mkN "ädelhet" ; -- ädelhet..nn.1
  ädelkorall_1_N = mkN "ädelkorall" ; -- ädelkorall..nn.1
  ädellövträd_1_N = mkN "ädellövträd" neutrum  ; -- ädellövträd..nn.1
  ädelmetall_1_N = mkN "ädelmetall" "ädelmetaller" ; -- ädelmetall..nn.1
  ädelmod_1_N = mkN "ädelmod" neutrum  ; -- ädelmod..nn.1
  ädelmodig_1_A = mkA "ädelmodig" ; -- ädelmodig..av.1
  ädelmodighet_1_N = mkN "ädelmodighet" ; -- ädelmodighet..nn.1
  ädelost_1_N = mkN "ädelost" ; -- ädelost..nn.1
  ädelpekoral_1_N = mkN "ädelpekoral" neutrum  ; -- ädelpekoral..nn.1
  ädelsinnad_1_A = mkA "ädelsinnad" ; -- ädelsinnad..av.1
  ädelsint_1_A = mkA "ädelsint" "ädelsint" ; -- ädelsint..av.1
  ädelskånska_1_N = mkN "ädelskånska" ; -- ädelskånska..nn.1
  ädelsmed_1_N = mkN "ädelsmed" "ädelsmeder" ; -- ädelsmed..nn.1
  ädelsten_1_N = mkN "ädelsten" "ädelstenen" "ädelstenar" "ädelstenarna" ; -- ädelsten..nn.1
  ädelträ_1_N = mkN "ädelträ" neutrum  ; -- ädelträ..nn.1
  ädelärg_1_N = mkN "ädelärg" ; -- ädelärg..nn.1
  ädling_1_N = mkN "ädling" ; -- ädling..nn.1
  äfsing_1_N = mkN "äfsing" ; -- äfsing..nn.1
  äga_1_N = mkN "äga" ; -- äga..nn.1
  äga_1_V = mkV "äger" ; -- äga..vb.1
  äga_2_V = mkV "äger" ; -- äga..vb.2
  ägande_1_N = mkN "ägande" ; -- ägande..nn.1
  ägandebehov_1_N = mkN "ägandebehov" neutrum  ; -- ägandebehov..nn.1
  ägandeförhållande_1_N = mkN "ägandeförhållande" ; -- ägandeförhållande..nn.1
  äganderätt_1_N = mkN "äganderätt" ; -- äganderätt..nn.1
  ägarandel_1_N = mkN "ägarandel" "ägarandelen" "ägarandelar" "ägarandelarna" ; -- ägarandel..nn.1
  ägarbevis_1_N = mkN "ägarbevis" neutrum  ; -- ägarbevis..nn.1
  ägardemokrati_1_N = mkN "ägardemokrati" ; -- ägardemokrati..nn.1
  ägardirektiv_1_N = mkN "ägardirektiv" neutrum  ; -- ägardirektiv..nn.1
  ägare_1_N = mkN "ägare" utrum  ; -- ägare..nn.1
  ägarform_1_N = mkN "ägarform" "ägarformer" ; -- ägarform..nn.1
  ägarkrav_1_N = mkN "ägarkrav" neutrum  ; -- ägarkrav..nn.1
  ägarmässig_1_A = mkA "ägarmässig" ; -- ägarmässig..av.1
  ägg_1_N = mkN "ägg" neutrum  ; -- ägg..nn.1
  äggblåsa_1_N = mkN "äggblåsa" ; -- äggblåsa..nn.1
  äggcell_1_N = mkN "äggcell" "äggceller" ; -- äggcell..nn.1
  äggformad_1_A = mkA "äggformad" ; -- äggformad..av.1
  äggformig_1_A = mkA "äggformig" ; -- äggformig..av.1
  äggfärg_1_N = mkN "äggfärg" ; -- äggfärg..nn.1
  äggfärgad_1_A = mkA "äggfärgad" ; -- äggfärgad..av.1
  ägghinna_1_N = mkN "ägghinna" ; -- ägghinna..nn.1
  ägghöna_1_N = mkN "ägghöna" ; -- ägghöna..nn.1
  äggkaka_1_N = mkN "äggkaka" ; -- äggkaka..nn.1
  äggkastare_1_N = mkN "äggkastare" utrum  ; -- äggkastare..nn.1
  äggkastning_1_N = mkN "äggkastning" ; -- äggkastning..nn.1
  äggklocka_1_N = mkN "äggklocka" ; -- äggklocka..nn.1
  äggkläckningsmaskin_1_N = mkN "äggkläckningsmaskin" "äggkläckningsmaskiner" ; -- äggkläckningsmaskin..nn.1
  äggkokare_1_N = mkN "äggkokare" utrum  ; -- äggkokare..nn.1
  äggkokning_1_N = mkN "äggkokning" ; -- äggkokning..nn.1
  äggkopp_1_N = mkN "äggkopp" ; -- äggkopp..nn.1
  äggkorn_1_N = mkN "äggkorn" neutrum  ; -- äggkorn..nn.1
  äggledare_1_N = mkN "äggledare" utrum  ; -- äggledare..nn.1
  äggledartratt_1_N = mkN "äggledartratt" ; -- äggledartratt..nn.1
  äggliknande_1_A = mkA "äggliknande" ; -- äggliknande..av.1
  ägglossning_1_N = mkN "ägglossning" ; -- ägglossning..nn.1
  äggläggning_1_N = mkN "äggläggning" ; -- äggläggning..nn.1
  äggläggningsrör_1_N = mkN "äggläggningsrör" neutrum  ; -- äggläggningsrör..nn.1
  ägglåda_1_N = mkN "ägglåda" ; -- ägglåda..nn.1
  äggost_1_N = mkN "äggost" ; -- äggost..nn.1
  äggplanta_1_N = mkN "äggplanta" ; -- äggplanta..nn.1
  äggprickare_1_N = mkN "äggprickare" utrum  ; -- äggprickare..nn.1
  äggpulver_1_N = mkN "äggpulver" neutrum  ; -- äggpulver..nn.1
  äggrund_1_A = mkA "äggrund" ; -- äggrund..av.1
  äggröra_1_N = mkN "äggröra" ; -- äggröra..nn.1
  äggsjuk_1_A = mkA "äggsjuk" ; -- äggsjuk..av.1
  äggsjukhet_1_N = mkN "äggsjukhet" ; -- äggsjukhet..nn.1
  äggskal_1_N = mkN "äggskal" neutrum  ; -- äggskal..nn.1
  äggskalsfärgad_1_A = mkA "äggskalsfärgad" ; -- äggskalsfärgad..av.1
  äggsked_1_N = mkN "äggsked" ; -- äggsked..nn.1
  äggsnodd_1_N = mkN "äggsnodd" ; -- äggsnodd..nn.1
  äggstanning_1_N = mkN "äggstanning" ; -- äggstanning..nn.1
  äggstav_1_N = mkN "äggstav" ; -- äggstav..nn.1
  äggstock_1_N = mkN "äggstock" ; -- äggstock..nn.1
  äggstockscancer_1_N = mkN "äggstockscancer" ; -- äggstockscancer..nn.1
  äggstocksinflammation_1_N = mkN "äggstocksinflammation" ; -- äggstocksinflammation..nn.1
  äggsvamp_1_N = mkN "äggsvamp" ; -- äggsvamp..nn.1
  äggsäck_1_N = mkN "äggsäck" ; -- äggsäck..nn.1
  äggtoddy_1_N = mkN "äggtoddy" "äggtoddyn" "äggtoddar" "äggtoddarna" ; -- äggtoddy..nn.1
  äggtransport_1_N = mkN "äggtransport" "äggtransporter" ; -- äggtransport..nn.1
  äggula_1_N = mkN "äggula" ; -- äggula..nn.1
  äggvita_1_N = mkN "äggvita" ; -- äggvita..nn.1
  äggvitebehov_1_N = mkN "äggvitebehov" neutrum  ; -- äggvitebehov..nn.1
  äggvitegiva_1_N = mkN "äggvitegiva" ; -- äggvitegiva..nn.1
  äggviteprov_1_N = mkN "äggviteprov" neutrum  ; -- äggviteprov..nn.1
  äggviteämne_1_N = mkN "äggviteämne" ; -- äggviteämne..nn.1
  äggvärmare_1_N = mkN "äggvärmare" utrum  ; -- äggvärmare..nn.1
  ägig_1_A = mkA "ägig" ; -- ägig..av.1
  ägiljett_1_N = mkN "ägiljett" "ägiljetter" ; -- ägiljett..nn.1
  ägna_1_V = mkV "ägnar" ; -- ägna..vb.1
  ägnad_1_A = mkA "ägnad" ; -- ägnad..av.1
  ägnande_1_N = mkN "ägnande" ; -- ägnande..nn.1
  ägodel_1_N = mkN "ägodel" "ägodelen" "ägodelar" "ägodelarna" ; -- ägodel..nn.1
  ägodelning_1_N = mkN "ägodelning" ; -- ägodelning..nn.1
  ägofred_1_N = mkN "ägofred" ; -- ägofred..nn.1
  ägogradering_1_N = mkN "ägogradering" ; -- ägogradering..nn.1
  ägoskifte_1_N = mkN "ägoskifte" ; -- ägoskifte..nn.1
  ägotecken_1_N = mkN "ägotecken" "ägotecknet" "ägotecken" "ägotecknen" ; -- ägotecken..nn.1
  ägrett_1_N = mkN "ägrett" "ägretter" ; -- ägrett..nn.1
  ägretthäger_1_N = mkN "ägretthäger" ; -- ägretthäger..nn.1
  äkta_1_A = mkA "äkta" ; -- äkta..av.1
  äkta_1_V = mkV "äktar" ; -- äkta..vb.1
  äktamakekuvert_1_N = mkN "äktamakekuvert" neutrum  ; -- äktamakekuvert..nn.1
  äktande_1_N = mkN "äktande" ; -- äktande..nn.1
  äktenskap_1_N = mkN "äktenskap" neutrum  ; -- äktenskap..nn.1
  äktenskaplig_1_A = mkA "äktenskaplig" ; -- äktenskaplig..av.1
  äktenskaplighet_1_N = mkN "äktenskaplighet" ; -- äktenskaplighet..nn.1
  äktenskapsallians_1_N = mkN "äktenskapsallians" "äktenskapsallianser" ; -- äktenskapsallians..nn.1
  äktenskapsannons_1_N = mkN "äktenskapsannons" "äktenskapsannonser" ; -- äktenskapsannons..nn.1
  äktenskapsbetyg_1_N = mkN "äktenskapsbetyg" neutrum  ; -- äktenskapsbetyg..nn.1
  äktenskapsbrott_1_N = mkN "äktenskapsbrott" neutrum  ; -- äktenskapsbrott..nn.1
  äktenskapsbrytare_1_N = mkN "äktenskapsbrytare" utrum  ; -- äktenskapsbrytare..nn.1
  äktenskapsbyrå_1_N = mkN "äktenskapsbyrå" "äktenskapsbyråer" ; -- äktenskapsbyrå..nn.1
  äktenskapscertifikat_1_N = mkN "äktenskapscertifikat" neutrum  ; -- äktenskapscertifikat..nn.1
  äktenskapsförmedling_1_N = mkN "äktenskapsförmedling" ; -- äktenskapsförmedling..nn.1
  äktenskapsförmedlingskatalog_1_N = mkN "äktenskapsförmedlingskatalog" "äktenskapsförmedlingskataloger" ; -- äktenskapsförmedlingskatalog..nn.1
  äktenskapsförord_1_N = mkN "äktenskapsförord" neutrum  ; -- äktenskapsförord..nn.1
  äktenskapshinder_1_N = mkN "äktenskapshinder" neutrum  ; -- äktenskapshinder..nn.1
  äktenskapskandidat_1_N = mkN "äktenskapskandidat" "äktenskapskandidater" ; -- äktenskapskandidat..nn.1
  äktenskapslöfte_1_N = mkN "äktenskapslöfte" ; -- äktenskapslöfte..nn.1
  äktenskapsmarknad_1_N = mkN "äktenskapsmarknad" "äktenskapsmarknader" ; -- äktenskapsmarknad..nn.1
  äktenskapsmäklare_1_N = mkN "äktenskapsmäklare" utrum  ; -- äktenskapsmäklare..nn.1
  äktenskapsskillnad_1_N = mkN "äktenskapsskillnad" "äktenskapsskillnader" ; -- äktenskapsskillnad..nn.1
  äktenskapstycke_1_N = mkN "äktenskapstycke" ; -- äktenskapstycke..nn.1
  äktenskapsålder_1_N = mkN "äktenskapsålder" ; -- äktenskapsålder..nn.1
  äkthet_1_N = mkN "äkthet" "äktheter" ; -- äkthet..nn.1
  äktsvensk_1_A = mkA "äktsvensk" ; -- äktsvensk..av.1
  äktsvensk_1_N = mkN "äktsvensk" ; -- äktsvensk..nn.1
  äldreboende_1_N = mkN "äldreboende" ; -- äldreboende..nn.1
  äldrehat_1_N = mkN "äldrehat" neutrum  ; -- äldrehat..nn.1
  äldreminister_1_N = mkN "äldreminister" ; -- äldreminister..nn.1
  äldreomsorg_1_N = mkN "äldreomsorg" ; -- äldreomsorg..nn.1
  äldresatsning_1_N = mkN "äldresatsning" ; -- äldresatsning..nn.1
  äldrevård_1_N = mkN "äldrevård" ; -- äldrevård..nn.1
  älg_1_N = mkN "älg" ; -- älg..nn.1
  älga_1_V = mkV "älgar" ; -- älga..vb.1
  älgande_1_N = mkN "älgande" ; -- älgande..nn.1
  älgbesök_1_N = mkN "älgbesök" neutrum  ; -- älgbesök..nn.1
  älgfigur_1_N = mkN "älgfigur" "älgfigurer" ; -- älgfigur..nn.1
  älggräs_1_N = mkN "älggräs" neutrum  ; -- älggräs..nn.1
  älghud_1_N = mkN "älghud" ; -- älghud..nn.1
  älgjakt_1_N = mkN "älgjakt" "älgjakter" ; -- älgjakt..nn.1
  älgjägare_1_N = mkN "älgjägare" utrum  ; -- älgjägare..nn.1
  älgkalv_1_N = mkN "älgkalv" ; -- älgkalv..nn.1
  älgkliv_1_N = mkN "älgkliv" neutrum  ; -- älgkliv..nn.1
  älgko_1_N = mkN "älgko" "älgkor" ; -- älgko..nn.1
  älgkött_1_N = mkN "älgkött" neutrum  ; -- älgkött..nn.1
  älgskav_1_N = mkN "älgskav" ; -- älgskav..nn.1
  älgskog_1_N = mkN "älgskog" ; -- älgskog..nn.1
  älgstek_1_N = mkN "älgstek" ; -- älgstek..nn.1
  älgstudsare_1_N = mkN "älgstudsare" utrum  ; -- älgstudsare..nn.1
  älgvarning_1_N = mkN "älgvarning" ; -- älgvarning..nn.1
  älling_1_N = mkN "älling" ; -- älling..nn.1
  älska_1_V = mkV "älskar" ; -- älska..vb.1
  älska_2_V = mkV "älskar" ; -- älska..vb.2
  älskad_1_A = mkA "älskad" ; -- älskad..av.1
  älskande_1_N = mkN "älskande" ; -- älskande..nn.1
  älskare_1_N = mkN "älskare" utrum  ; -- älskare..nn.1
  älskarinna_1_N = mkN "älskarinna" ; -- älskarinna..nn.1
  älsklig_1_A = mkA "älsklig" ; -- älsklig..av.1
  älsklighet_1_N = mkN "älsklighet" "älskligheter" ; -- älsklighet..nn.1
  älskling_1_N = mkN "älskling" ; -- älskling..nn.1
  älsklingsblomma_1_N = mkN "älsklingsblomma" ; -- älsklingsblomma..nn.1
  älsklingsdryck_1_N = mkN "älsklingsdryck" "älsklingsdrycker" ; -- älsklingsdryck..nn.1
  älsklingsidé_1_N = mkN "älsklingsidé" "älsklingsidéer" ; -- älsklingsidé..nn.1
  älsklingsmelodi_1_N = mkN "älsklingsmelodi" "älsklingsmelodier" ; -- älsklingsmelodi..nn.1
  älsklingsnalle_1_N = mkN "älsklingsnalle" utrum  ; -- älsklingsnalle..nn.1
  älsklingsost_1_N = mkN "älsklingsost" ; -- älsklingsost..nn.1
  älsklingsprojekt_1_N = mkN "älsklingsprojekt" neutrum  ; -- älsklingsprojekt..nn.1
  älsklingsrätt_1_N = mkN "älsklingsrätt" "älsklingsrätter" ; -- älsklingsrätt..nn.1
  älskog_1_N = mkN "älskog" ; -- älskog..nn.1
  älskogsgnabb_1_N = mkN "älskogsgnabb" neutrum  ; -- älskogsgnabb..nn.1
  älskogskrank_1_A = mkA "älskogskrank" ; -- älskogskrank..av.1
  älskogskrankhet_1_N = mkN "älskogskrankhet" ; -- älskogskrankhet..nn.1
  älskvärd_1_A = mkA "älskvärd" "älskvärt" ; -- älskvärd..av.1
  älskvärdhet_1_N = mkN "älskvärdhet" "älskvärdheter" ; -- älskvärdhet..nn.1
  älta_1_N = mkN "älta" ; -- älta..nn.1
  älta_1_V = mkV "ältar" ; -- älta..vb.1
  ältande_1_N = mkN "ältande" ; -- ältande..nn.1
  ältgräs_1_N = mkN "ältgräs" neutrum  ; -- ältgräs..nn.1
  älv_1_N = mkN "älv" ; -- älv..nn.1
  älva_1_N = mkN "älva" ; -- älva..nn.1
  älvbrink_1_N = mkN "älvbrink" ; -- älvbrink..nn.1
  älvbädd_1_N = mkN "älvbädd" ; -- älvbädd..nn.1
  älvdaling_1_N = mkN "älvdaling" ; -- älvdaling..nn.1
  älvdans_1_N = mkN "älvdans" "älvdanser" ; -- älvdans..nn.1
  älvdrottning_1_N = mkN "älvdrottning" ; -- älvdrottning..nn.1
  älvfåra_1_N = mkN "älvfåra" ; -- älvfåra..nn.1
  älvkonung_1_N = mkN "älvkonung" ; -- älvkonung..nn.1
  älvkung_1_N = mkN "älvkung" ; -- älvkung..nn.1
  älvkvarn_1_N = mkN "älvkvarn" ; -- älvkvarn..nn.1
  älvmynning_1_N = mkN "älvmynning" ; -- älvmynning..nn.1
  älvstrand_1_N = mkN "älvstrand" "älvstränder" ; -- älvstrand..nn.1
  älvvatten_1_N = mkN "älvvatten" "älvvattnet" "älvvatten" "älvvattnen" ; -- älvvatten..nn.1
  älväxing_1_N = mkN "älväxing" ; -- älväxing..nn.1
  ämabel_1_A = mkA "ämabel" ; -- ämabel..av.1
  ämbar_1_N = mkN "ämbar" neutrum  ; -- ämbar..nn.1
  ämbete_1_N = mkN "ämbete" ; -- ämbete..nn.1
  ämbetsadel_1_N = mkN "ämbetsadel" ; -- ämbetsadel..nn.1
  ämbetsansvar_1_N = mkN "ämbetsansvar" neutrum  ; -- ämbetsansvar..nn.1
  ämbetsbroder_1_N = mkN "ämbetsbroder" "ämbetsbrodern" "ämbetsbröder" "ämbetsbröderna" ; -- ämbetsbroder..nn.1
  ämbetsbrott_1_N = mkN "ämbetsbrott" neutrum  ; -- ämbetsbrott..nn.1
  ämbetsdräkt_1_N = mkN "ämbetsdräkt" "ämbetsdräkter" ; -- ämbetsdräkt..nn.1
  ämbetsed_1_N = mkN "ämbetsed" "ämbetseder" ; -- ämbetsed..nn.1
  ämbetsexamen_1_N = mkN "ämbetsexamen" "ämbetsexamen" "ämbetsexamina" "ämbetsexamina" ; -- ämbetsexamen..nn.1
  ämbetslokal_1_N = mkN "ämbetslokal" "ämbetslokaler" ; -- ämbetslokal..nn.1
  ämbetsman_1_N = mkN "ämbetsman" "ämbetsmannen" "ämbetsmän" "ämbetsmännen" ; -- ämbetsman..nn.1
  ämbetsmannaadel_1_N = mkN "ämbetsmannaadel" ; -- ämbetsmannaadel..nn.1
  ämbetsmannaansvar_1_N = mkN "ämbetsmannaansvar" neutrum  ; -- ämbetsmannaansvar..nn.1
  ämbetsmannaideal_1_N = mkN "ämbetsmannaideal" neutrum  ; -- ämbetsmannaideal..nn.1
  ämbetsmannajag_1_N = mkN "ämbetsmannajag" neutrum  ; -- ämbetsmannajag..nn.1
  ämbetsmannamässig_1_A = mkA "ämbetsmannamässig" ; -- ämbetsmannamässig..av.1
  ämbetsmannaregering_1_N = mkN "ämbetsmannaregering" ; -- ämbetsmannaregering..nn.1
  ämbetsmässig_1_A = mkA "ämbetsmässig" ; -- ämbetsmässig..av.1
  ämbetsperiod_1_N = mkN "ämbetsperiod" "ämbetsperioder" ; -- ämbetsperiod..nn.1
  ämbetsplikt_1_N = mkN "ämbetsplikt" "ämbetsplikter" ; -- ämbetsplikt..nn.1
  ämbetsrum_1_N = mkN "ämbetsrum" "ämbetsrummet" "ämbetsrum" "ämbetsrummen" ; -- ämbetsrum..nn.1
  ämbetsskrud_1_N = mkN "ämbetsskrud" ; -- ämbetsskrud..nn.1
  ämbetsställning_1_N = mkN "ämbetsställning" ; -- ämbetsställning..nn.1
  ämbetstitel_1_N = mkN "ämbetstitel" ; -- ämbetstitel..nn.1
  ämbetsverk_1_N = mkN "ämbetsverk" neutrum  ; -- ämbetsverk..nn.1
  ämbetsåliggande_1_N = mkN "ämbetsåliggande" ; -- ämbetsåliggande..nn.1
  ämna_1_V = mkV "ämnar" ; -- ämna..vb.1
  ämnande_1_N = mkN "ämnande" ; -- ämnande..nn.1
  ämne_1_N = mkN "ämne" ; -- ämne..nn.1
  ämnesblock_1_N = mkN "ämnesblock" neutrum  ; -- ämnesblock..nn.1
  ämnesföreträdare_1_N = mkN "ämnesföreträdare" utrum  ; -- ämnesföreträdare..nn.1
  ämnesgrupp_1_N = mkN "ämnesgrupp" "ämnesgrupper" ; -- ämnesgrupp..nn.1
  ämnesinnehåll_1_N = mkN "ämnesinnehåll" neutrum  ; -- ämnesinnehåll..nn.1
  ämnesintegration_1_N = mkN "ämnesintegration" ; -- ämnesintegration..nn.1
  ämnesintegrera_1_V = mkV "ämnesintegrerar" ; -- ämnesintegrera..vb.1
  ämnesintegrerande_1_N = mkN "ämnesintegrerande" ; -- ämnesintegrerande..nn.1
  ämnesintegrerbar_1_A = mkA "ämnesintegrerbar" ; -- ämnesintegrerbar..av.1
  ämnesintegrerbarhet_1_N = mkN "ämnesintegrerbarhet" ; -- ämnesintegrerbarhet..nn.1
  ämnesintegrering_1_N = mkN "ämnesintegrering" ; -- ämnesintegrering..nn.1
  ämnesjärn_1_N = mkN "ämnesjärn" neutrum  ; -- ämnesjärn..nn.1
  ämneskombination_1_N = mkN "ämneskombination" ; -- ämneskombination..nn.1
  ämneskonferens_1_N = mkN "ämneskonferens" "ämneskonferenser" ; -- ämneskonferens..nn.1
  ämneslärare_1_N = mkN "ämneslärare" utrum  ; -- ämneslärare..nn.1
  ämnesmetodik_1_N = mkN "ämnesmetodik" ; -- ämnesmetodik..nn.1
  ämnesmässig_1_A = mkA "ämnesmässig" ; -- ämnesmässig..av.1
  ämnesnamn_1_N = mkN "ämnesnamn" neutrum  ; -- ämnesnamn..nn.1
  ämnesområde_1_N = mkN "ämnesområde" ; -- ämnesområde..nn.1
  ämnesomsättning_1_N = mkN "ämnesomsättning" ; -- ämnesomsättning..nn.1
  ämnesomsättningsrubbning_1_N = mkN "ämnesomsättningsrubbning" ; -- ämnesomsättningsrubbning..nn.1
  ämnessfär_1_N = mkN "ämnessfär" "ämnessfärer" ; -- ämnessfär..nn.1
  ämnesvis_1_Adv = mkAdv "ämnesvis" ; -- ämnesvis..ab.1
  ämnesvis_1_A = mkA "ämnesvis" ; -- ämnesvis..av.1
  ämnesöverskridande_1_A = mkA "ämnesöverskridande" ; -- ämnesöverskridande..av.1
  än_1_Adv = mkAdv "än" ; -- än..ab.1
  ända_1_Adv = mkAdv "ända" ; -- ända..ab.1
  ända_1_N = mkN "ända" ; -- ända..nn.1
  ända_2_N = mkN "ända" ; -- ända..nn.2
  ända_1_V = mkV "ändar" ; -- ända..vb.1
  ända_2_V = mkV "ändar" ; -- ända..vb.2
  ändalykt_1_N = mkN "ändalykt" ; -- ändalykt..nn.1
  ändamål_1_N = mkN "ändamål" neutrum  ; -- ändamål..nn.1
  ändamålsenlig_1_A = mkA "ändamålsenlig" ; -- ändamålsenlig..av.1
  ändamålsenlighet_1_N = mkN "ändamålsenlighet" "ändamålsenligheter" ; -- ändamålsenlighet..nn.1
  ändamålsenlighetsavvägande_1_N = mkN "ändamålsenlighetsavvägande" ; -- ändamålsenlighetsavvägande..nn.1
  ändamålslös_1_A = mkA "ändamålslös" ; -- ändamålslös..av.1
  ändamålslöshet_1_N = mkN "ändamålslöshet" ; -- ändamålslöshet..nn.1
  ändande_1_N = mkN "ändande" ; -- ändande..nn.1
  ände_1_N = mkN "ände" utrum  ; -- ände..nn.1
  ändelse_1_N = mkN "ändelse" "ändelser" ; -- ändelse..nn.1
  ändlig_1_A = mkA "ändlig" ; -- ändlig..av.1
  ändlighet_1_N = mkN "ändlighet" ; -- ändlighet..nn.1
  ändlös_1_A = mkA "ändlös" ; -- ändlös..av.1
  ändlöshet_1_N = mkN "ändlöshet" ; -- ändlöshet..nn.1
  ändmorän_1_N = mkN "ändmorän" "ändmoräner" ; -- ändmorän..nn.1
  ändpunkt_1_N = mkN "ändpunkt" "ändpunkter" ; -- ändpunkt..nn.1
  ändra_1_V = mkV "ändrar" ; -- ändra..vb.1
  ändrande_1_N = mkN "ändrande" ; -- ändrande..nn.1
  ändrim_1_N = mkN "ändrim" "ändrimmet" "ändrim" "ändrimmen" ; -- ändrim..nn.1
  ändring_1_N = mkN "ändring" ; -- ändring..nn.1
  ändringsförslag_1_N = mkN "ändringsförslag" neutrum  ; -- ändringsförslag..nn.1
  ändstation_1_N = mkN "ändstation" ; -- ändstation..nn.1
  ändtarm_1_N = mkN "ändtarm" ; -- ändtarm..nn.1
  ändtarmsundersökning_1_N = mkN "ändtarmsundersökning" ; -- ändtarmsundersökning..nn.1
  ändträ_1_N = mkN "ändträ" neutrum  ; -- ändträ..nn.1
  ändvända_1_V = mkV "ändvänder" ; -- ändvända..vb.1
  ändvändande_1_N = mkN "ändvändande" ; -- ändvändande..nn.1
  ändvändning_1_N = mkN "ändvändning" ; -- ändvändning..nn.1
  ändyta_1_N = mkN "ändyta" ; -- ändyta..nn.1
  ändå_1_Adv = mkAdv "ändå" ; -- ändå..ab.1
  äng_ljud_1_N = mkN "äng-ljud" neutrum  ; -- äng-ljud..nn.1
  äng_1_N = mkN "äng" ; -- äng..nn.1
  ängd_1_N = mkN "ängd" "ängder" ; -- ängd..nn.1
  ängel_1_N = mkN "ängel" ; -- ängel..nn.1
  änger_1_N = mkN "änger" ; -- änger..nn.1
  änglabild_1_N = mkN "änglabild" "änglabilder" ; -- änglabild..nn.1
  änglafigur_1_N = mkN "änglafigur" "änglafigurer" ; -- änglafigur..nn.1
  änglakör_1_N = mkN "änglakör" "änglakörer" ; -- änglakör..nn.1
  änglalik_1_A = mkA "änglalik" ; -- änglalik..av.1
  änglalikhet_1_N = mkN "änglalikhet" ; -- änglalikhet..nn.1
  änglamakerska_1_N = mkN "änglamakerska" ; -- änglamakerska..nn.1
  änglamat_1_N = mkN "änglamat" ; -- änglamat..nn.1
  änglaröst_1_N = mkN "änglaröst" "änglaröster" ; -- änglaröst..nn.1
  änglaskara_1_N = mkN "änglaskara" ; -- änglaskara..nn.1
  änglaspel_1_N = mkN "änglaspel" "änglaspelet" "änglaspel" "änglaspelen" ; -- änglaspel..nn.1
  änglavakt_1_N = mkN "änglavakt" ; -- änglavakt..nn.1
  ängsblomma_1_N = mkN "ängsblomma" ; -- ängsblomma..nn.1
  ängsboll_1_N = mkN "ängsboll" ; -- ängsboll..nn.1
  ängsgröe_1_N = mkN "ängsgröe" utrum  ; -- ängsgröe..nn.1
  ängshök_1_N = mkN "ängshök" ; -- ängshök..nn.1
  ängsknarr_1_N = mkN "ängsknarr" ; -- ängsknarr..nn.1
  ängsla_1_V = mkV "ängslar" ; -- ängsla..vb.1
  ängslande_1_N = mkN "ängslande" ; -- ängslande..nn.1
  ängslig_1_A = mkA "ängslig" ; -- ängslig..av.1
  ängslighet_1_N = mkN "ängslighet" ; -- ängslighet..nn.1
  ängsmark_1_N = mkN "ängsmark" "ängsmarker" ; -- ängsmark..nn.1
  ängspiplärka_1_N = mkN "ängspiplärka" ; -- ängspiplärka..nn.1
  ängsruta_1_N = mkN "ängsruta" ; -- ängsruta..nn.1
  ängsskära_1_N = mkN "ängsskära" ; -- ängsskära..nn.1
  ängssyra_1_N = mkN "ängssyra" ; -- ängssyra..nn.1
  ängsull_1_N = mkN "ängsull" ; -- ängsull..nn.1
  ängsvial_1_N = mkN "ängsvial" "ängsvialer" ; -- ängsvial..nn.1
  änka_1_N = mkN "änka" ; -- änka..nn.1
  änkedok_1_N = mkN "änkedok" neutrum  ; -- änkedok..nn.1
  änkedrottning_1_N = mkN "änkedrottning" ; -- änkedrottning..nn.1
  änkefru_1_N = mkN "änkefru" ; -- änkefru..nn.1
  änkeman_1_N = mkN "änkeman" "änkemannen" "änkemän" "änkemännen" ; -- änkeman..nn.1
  änkenåd_1_N = mkN "änkenåd" "änkenåder" ; -- änkenåd..nn.1
  änkepension_1_N = mkN "änkepension" ; -- änkepension..nn.1
  änkesorg_1_N = mkN "änkesorg" ; -- änkesorg..nn.1
  änkestöt_1_N = mkN "änkestöt" ; -- änkestöt..nn.1
  änkesäte_1_N = mkN "änkesäte" ; -- änkesäte..nn.1
  änkeår_1_N = mkN "änkeår" neutrum  ; -- änkeår..nn.1
  änkling_1_N = mkN "änkling" ; -- änkling..nn.1
  änmer_1_Adv = mkAdv "änmer" ; -- änmer..ab.1
  änmera_1_Adv = mkAdv "änmera" ; -- änmera..ab.1
  änna_1_Adv = mkAdv "änna" ; -- änna..ab.1
  änne_1_N = mkN "änne" ; -- änne..nn.1
  ännu_1_Adv = mkAdv "ännu" ; -- ännu..ab.1
  ännusålänge_1_Adv = mkAdv "ännusålänge" ; -- ännusålänge..ab.1
  änsålänge_1_Adv = mkAdv "änsålänge" ; -- änsålänge..ab.1
  änterbila_1_N = mkN "änterbila" ; -- änterbila..nn.1
  änterhake_1_N = mkN "änterhake" utrum  ; -- änterhake..nn.1
  änterpik_1_N = mkN "änterpik" ; -- änterpik..nn.1
  äntligen_1_Adv = mkAdv "äntligen" ; -- äntligen..ab.1
  äntra_1_V = mkV "äntrar" ; -- äntra..vb.1
  äntrande_1_N = mkN "äntrande" ; -- äntrande..nn.1
  äntring_1_N = mkN "äntring" ; -- äntring..nn.1
  äntringsstrid_1_N = mkN "äntringsstrid" "äntringsstrider" ; -- äntringsstrid..nn.1
  äppelkaka_1_N = mkN "äppelkaka" ; -- äppelkaka..nn.1
  äppelkart_1_N = mkN "äppelkart" ; -- äppelkart..nn.1
  äppelkindad_1_A = mkA "äppelkindad" ; -- äppelkindad..av.1
  äppelliknande_1_A = mkA "äppelliknande" ; -- äppelliknande..av.1
  äppelmos_1_N = mkN "äppelmos" ; -- äppelmos..nn.1
  äppelpaj_1_N = mkN "äppelpaj" "äppelpajer" ; -- äppelpaj..nn.1
  äppelpräktig_1_A = mkA "äppelpräktig" ; -- äppelpräktig..av.1
  äppelpräktighet_1_N = mkN "äppelpräktighet" ; -- äppelpräktighet..nn.1
  äppelskorv_1_N = mkN "äppelskorv" ; -- äppelskorv..nn.1
  äppelskrott_1_N = mkN "äppelskrott" ; -- äppelskrott..nn.1
  äppelskrutt_1_N = mkN "äppelskrutt" ; -- äppelskrutt..nn.1
  äppelskörd_1_N = mkN "äppelskörd" ; -- äppelskörd..nn.1
  äppelsort_1_N = mkN "äppelsort" "äppelsorter" ; -- äppelsort..nn.1
  äppelsyra_1_N = mkN "äppelsyra" ; -- äppelsyra..nn.1
  äppelträd_1_N = mkN "äppelträd" neutrum  ; -- äppelträd..nn.1
  äppelvecklare_1_N = mkN "äppelvecklare" utrum  ; -- äppelvecklare..nn.1
  äpple_1_N = mkN "äpple" ; -- äpple..nn.1
  äpplekaka_1_N = mkN "äpplekaka" ; -- äpplekaka..nn.1
  äpplekart_1_N = mkN "äpplekart" ; -- äpplekart..nn.1
  äppleliknande_1_A = mkA "äppleliknande" ; -- äppleliknande..av.1
  äpplemos_1_N = mkN "äpplemos" ; -- äpplemos..nn.1
  äppleskorv_1_N = mkN "äppleskorv" ; -- äppleskorv..nn.1
  äppleskrott_1_N = mkN "äppleskrott" ; -- äppleskrott..nn.1
  äpplesyra_1_N = mkN "äpplesyra" ; -- äpplesyra..nn.1
  äppleträd_1_N = mkN "äppleträd" neutrum  ; -- äppleträd..nn.1
  ära_1_N = mkN "ära" ; -- ära..nn.1
  ära_1_V = mkV "ärar" ; -- ära..vb.1
  ärad_1_A = mkA "ärad" "ärat" ; -- ärad..av.1
  ärande_1_N = mkN "ärande" ; -- ärande..nn.1
  ärbar_1_A = mkA "ärbar" ; -- ärbar..av.1
  ärbarhet_1_N = mkN "ärbarhet" ; -- ärbarhet..nn.1
  ärebetygelse_1_N = mkN "ärebetygelse" "ärebetygelser" ; -- ärebetygelse..nn.1
  äredikt_1_N = mkN "äredikt" "äredikter" ; -- äredikt..nn.1
  äreförgäten_1_A = mkA "äreförgäten" ; -- äreförgäten..av.1
  äreförgätenhet_1_N = mkN "äreförgätenhet" ; -- äreförgätenhet..nn.1
  äregirig_1_A = mkA "äregirig" ; -- äregirig..av.1
  äregirighet_1_N = mkN "äregirighet" ; -- äregirighet..nn.1
  ärekränka_1_V = mkV "ärekränker" ; -- ärekränka..vb.1
  ärekränkande_1_N = mkN "ärekränkande" ; -- ärekränkande..nn.1
  ärekränkning_1_N = mkN "ärekränkning" ; -- ärekränkning..nn.1
  ärekrönt_1_A = mkA "ärekrönt" "ärekrönt" ; -- ärekrönt..av.1
  ärelysten_1_A = mkA "ärelysten" ; -- ärelysten..av.1
  ärelystnad_1_N = mkN "ärelystnad" "ärelystnader" ; -- ärelystnad..nn.1
  ärelös_1_A = mkA "ärelös" ; -- ärelös..av.1
  ärelöshet_1_N = mkN "ärelöshet" ; -- ärelöshet..nn.1
  äreminne_1_N = mkN "äreminne" ; -- äreminne..nn.1
  ärende_1_N = mkN "ärende" ; -- ärende..nn.1
  ärendehandläggning_1_N = mkN "ärendehandläggning" ; -- ärendehandläggning..nn.1
  ärenpris_1_N = mkN "ärenpris" ; -- ärenpris..nn.1
  äreport_1_N = mkN "äreport" ; -- äreport..nn.1
  ärerädda_1_V = mkV "äreräddar" ; -- ärerädda..vb.1
  äreräddande_1_N = mkN "äreräddande" ; -- äreräddande..nn.1
  äreräddning_1_N = mkN "äreräddning" ; -- äreräddning..nn.1
  ärerörig_1_A = mkA "ärerörig" ; -- ärerörig..av.1
  ärerörighet_1_N = mkN "ärerörighet" "ärerörigheter" ; -- ärerörighet..nn.1
  äresak_1_N = mkN "äresak" "äresaker" ; -- äresak..nn.1
  äretecken_1_N = mkN "äretecken" "äretecknet" "äretecken" "äretecknen" ; -- äretecken..nn.1
  äretitel_1_N = mkN "äretitel" ; -- äretitel..nn.1
  ärevarv_1_N = mkN "ärevarv" neutrum  ; -- ärevarv..nn.1
  ärevördig_1_A = mkA "ärevördig" ; -- ärevördig..av.1
  ärevördighet_1_N = mkN "ärevördighet" ; -- ärevördighet..nn.1
  ärftlig_1_A = mkA "ärftlig" ; -- ärftlig..av.1
  ärftlighet_1_N = mkN "ärftlighet" "ärftligheter" ; -- ärftlighet..nn.1
  ärftlighetsforskare_1_N = mkN "ärftlighetsforskare" utrum  ; -- ärftlighetsforskare..nn.1
  ärftlighetsforskning_1_N = mkN "ärftlighetsforskning" ; -- ärftlighetsforskning..nn.1
  ärftlighetslag_1_N = mkN "ärftlighetslag" ; -- ärftlighetslag..nn.1
  ärftlighetslära_1_N = mkN "ärftlighetslära" ; -- ärftlighetslära..nn.1
  ärg_1_N = mkN "ärg" ; -- ärg..nn.1
  ärga_1_V = mkV "ärgar" ; -- ärga..vb.1
  ärgande_1_N = mkN "ärgande" ; -- ärgande..nn.1
  ärggrön_1_A = mkA "ärggrön" ; -- ärggrön..av.1
  ärgig_1_A = mkA "ärgig" ; -- ärgig..av.1
  ärgighet_1_N = mkN "ärgighet" ; -- ärgighet..nn.1
  äril_1_N = mkN "äril" ; -- äril..nn.1
  äring_1_N = mkN "äring" ; -- äring..nn.1
  ärja_1_V = mkV "ärjar" ; -- ärja..vb.1
  ärjande_1_N = mkN "ärjande" ; -- ärjande..nn.1
  ärjkrok_1_N = mkN "ärjkrok" ; -- ärjkrok..nn.1
  ärkebiskop_1_N = mkN "ärkebiskop" ; -- ärkebiskop..nn.1
  ärkebiskoplig_1_A = mkA "ärkebiskoplig" ; -- ärkebiskoplig..av.1
  ärkebov_1_N = mkN "ärkebov" ; -- ärkebov..nn.1
  ärkefiende_1_N = mkN "ärkefiende" "ärkefiender" ; -- ärkefiende..nn.1
  ärkehertig_1_N = mkN "ärkehertig" ; -- ärkehertig..nn.1
  ärkekonservativ_1_A = mkA "ärkekonservativ" ; -- ärkekonservativ..av.1
  ärkekretin_1_N = mkN "ärkekretin" "ärkekretiner" ; -- ärkekretin..nn.1
  ärkenöt_1_N = mkN "ärkenöt" neutrum  ; -- ärkenöt..nn.1
  ärkepucko_1_N = mkN "ärkepucko" "ärkepuckot" "ärkepuckon" "ärkepuckona" ; -- ärkepucko..nn.1
  ärkereaktionär_1_N = mkN "ärkereaktionär" "ärkereaktionärer" ; -- ärkereaktionär..nn.1
  ärkerival_1_N = mkN "ärkerival" "ärkerivaler" ; -- ärkerival..nn.1
  ärkeskurk_1_N = mkN "ärkeskurk" ; -- ärkeskurk..nn.1
  ärkestift_1_N = mkN "ärkestift" neutrum  ; -- ärkestift..nn.1
  ärkesvin_1_N = mkN "ärkesvin" neutrum  ; -- ärkesvin..nn.1
  ärkeängel_1_N = mkN "ärkeängel" ; -- ärkeängel..nn.1
  ärla_1_N = mkN "ärla" ; -- ärla..nn.1
  ärlig_1_A = mkA "ärlig" ; -- ärlig..av.1
  ärligen_1_Adv = mkAdv "ärligen" ; -- ärligen..ab.1
  ärlighet_1_N = mkN "ärlighet" "ärligheter" ; -- ärlighet..nn.1
  ärm_1_N = mkN "ärm" ; -- ärm..nn.1
  ärmbräda_1_N = mkN "ärmbräda" ; -- ärmbräda..nn.1
  ärmbräde_1_N = mkN "ärmbräde" ; -- ärmbräde..nn.1
  ärmhål_1_N = mkN "ärmhål" neutrum  ; -- ärmhål..nn.1
  ärmhållare_1_N = mkN "ärmhållare" utrum  ; -- ärmhållare..nn.1
  ärmlinning_1_N = mkN "ärmlinning" ; -- ärmlinning..nn.1
  ärmlös_1_A = mkA "ärmlös" ; -- ärmlös..av.1
  ärmlöshet_1_N = mkN "ärmlöshet" ; -- ärmlöshet..nn.1
  ärmvidd_1_N = mkN "ärmvidd" "ärmvidder" ; -- ärmvidd..nn.1
  ärna_1_V = mkV "ärnar" ; -- ärna..vb.1
  ärnande_1_N = mkN "ärnande" ; -- ärnande..nn.1
  ärofull_1_A = mkA "ärofull" ; -- ärofull..av.1
  ärofullhet_1_N = mkN "ärofullhet" ; -- ärofullhet..nn.1
  ärofylld_1_A = mkA "ärofylld" "ärofyllt" ; -- ärofylld..av.1
  ärofylldhet_1_N = mkN "ärofylldhet" ; -- ärofylldhet..nn.1
  ärorik_1_A = mkA "ärorik" ; -- ärorik..av.1
  ärorikhet_1_N = mkN "ärorikhet" ; -- ärorikhet..nn.1
  ärr_1_N = mkN "ärr" neutrum  ; -- ärr..nn.1
  ärrad_1_A = mkA "ärrad" ; -- ärrad..av.1
  ärrbildning_1_N = mkN "ärrbildning" ; -- ärrbildning..nn.1
  ärrig_1_A = mkA "ärrig" ; -- ärrig..av.1
  ärrighet_1_N = mkN "ärrighet" ; -- ärrighet..nn.1
  ärrtatuering_1_N = mkN "ärrtatuering" ; -- ärrtatuering..nn.1
  ärrvävnad_1_N = mkN "ärrvävnad" "ärrvävnader" ; -- ärrvävnad..nn.1
  ärt_1_N = mkN "ärt" "ärter" ; -- ärt..nn.1
  ärta_1_N = mkN "ärta" ; -- ärta..nn.1
  ärtbalja_1_N = mkN "ärtbalja" ; -- ärtbalja..nn.1
  ärtgrön_1_A = mkA "ärtgrön" ; -- ärtgrön..av.1
  ärtgul_1_A = mkA "ärtgul" ; -- ärtgul..av.1
  ärthjärna_1_N = mkN "ärthjärna" ; -- ärthjärna..nn.1
  ärtig_1_A = mkA "ärtig" ; -- ärtig..av.1
  ärtighet_1_N = mkN "ärtighet" ; -- ärtighet..nn.1
  ärtpuré_1_N = mkN "ärtpuré" "ärtpuréer" ; -- ärtpuré..nn.1
  ärtreva_1_N = mkN "ärtreva" ; -- ärtreva..nn.1
  ärtskida_1_N = mkN "ärtskida" ; -- ärtskida..nn.1
  ärtskocka_1_N = mkN "ärtskocka" ; -- ärtskocka..nn.1
  ärtsoppa_1_N = mkN "ärtsoppa" ; -- ärtsoppa..nn.1
  ärtvecklare_1_N = mkN "ärtvecklare" utrum  ; -- ärtvecklare..nn.1
  ärtväxt_1_N = mkN "ärtväxt" "ärtväxter" ; -- ärtväxt..nn.1
  ärva_1_V = mkV "ärver" ; -- ärva..vb.1
  ärvande_1_N = mkN "ärvande" ; -- ärvande..nn.1
  ärvdabalk_1_N = mkN "ärvdabalk" ; -- ärvdabalk..nn.1
  äska_1_V = mkV "äskar" ; -- äska..vb.1
  äskande_1_N = mkN "äskande" ; -- äskande..nn.1
  äsping_1_N = mkN "äsping" ; -- äsping..nn.1
  äss_1_N = mkN "äss" neutrum  ; -- äss..nn.1
  ässja_1_N = mkN "ässja" ; -- ässja..nn.1
  äta_1_V = mkV "äta" "åt" "ätit" ; -- äta..vb.1
  ätande_1_N = mkN "ätande" ; -- ätande..nn.1
  ätbar_1_A = mkA "ätbar" ; -- ätbar..av.1
  ätbarhet_1_N = mkN "ätbarhet" ; -- ätbarhet..nn.1
  ätlig_1_A = mkA "ätlig" ; -- ätlig..av.1
  ätlighet_1_N = mkN "ätlighet" "ätligheter" ; -- ätlighet..nn.1
  ätning_1_N = mkN "ätning" ; -- ätning..nn.1
  ätpinne_1_N = mkN "ätpinne" utrum  ; -- ätpinne..nn.1
  ätstörning_1_N = mkN "ätstörning" ; -- ätstörning..nn.1
  ätstörningsproblematik_1_N = mkN "ätstörningsproblematik" "ätstörningsproblematiker" ; -- ätstörningsproblematik..nn.1
  ätt_1_N = mkN "ätt" "ätter" ; -- ätt..nn.1
  ättartal_1_N = mkN "ättartal" neutrum  ; -- ättartal..nn.1
  ättartavla_1_N = mkN "ättartavla" ; -- ättartavla..nn.1
  ättefader_1_N = mkN "ättefader" "ättefadern" "ättefäder" "ättefäderna" ; -- ättefader..nn.1
  ätteled_1_N = mkN "ätteled" neutrum  ; -- ätteled..nn.1
  ättelägg_1_N = mkN "ättelägg" ; -- ättelägg..nn.1
  ättestupa_1_N = mkN "ättestupa" ; -- ättestupa..nn.1
  ättetal_1_N = mkN "ättetal" neutrum  ; -- ättetal..nn.1
  ättetavla_1_N = mkN "ättetavla" ; -- ättetavla..nn.1
  ättika_1_N = mkN "ättika" ; -- ättika..nn.1
  ättiksgurka_1_N = mkN "ättiksgurka" ; -- ättiksgurka..nn.1
  ättiksinläggning_1_N = mkN "ättiksinläggning" ; -- ättiksinläggning..nn.1
  ättiksprit_1_N = mkN "ättiksprit" ; -- ättiksprit..nn.1
  ättikssur_1_A = mkA "ättikssur" ; -- ättikssur..av.1
  ättiksur_1_A = mkA "ättiksur" ; -- ättiksur..av.1
  ättiksyra_1_N = mkN "ättiksyra" ; -- ättiksyra..nn.1
  ättled_1_N = mkN "ättled" neutrum  ; -- ättled..nn.1
  ättling_1_N = mkN "ättling" ; -- ättling..nn.1
  ättlängd_1_N = mkN "ättlängd" "ättlängder" ; -- ättlängd..nn.1
  ättnummer_1_N = mkN "ättnummer" neutrum  ; -- ättnummer..nn.1
  även_1_Adv = mkAdv "även" ; -- även..ab.1
  ävenledes_1_Adv = mkAdv "ävenledes" ; -- ävenledes..ab.1
  äventyr_1_N = mkN "äventyr" neutrum  ; -- äventyr..nn.1
  äventyra_1_V = mkV "äventyrar" ; -- äventyra..vb.1
  äventyrande_1_N = mkN "äventyrande" ; -- äventyrande..nn.1
  äventyrare_1_N = mkN "äventyrare" utrum  ; -- äventyrare..nn.1
  äventyrlig_1_A = mkA "äventyrlig" ; -- äventyrlig..av.1
  äventyrlighet_1_N = mkN "äventyrlighet" "äventyrligheter" ; -- äventyrlighet..nn.1
  äventyrsbad_1_N = mkN "äventyrsbad" neutrum  ; -- äventyrsbad..nn.1
  äventyrsbok_1_N = mkN "äventyrsbok" "äventyrsböcker" ; -- äventyrsbok..nn.1
  äventyrsfilm_1_N = mkN "äventyrsfilm" "äventyrsfilmer" ; -- äventyrsfilm..nn.1
  äventyrslusta_1_N = mkN "äventyrslusta" ; -- äventyrslusta..nn.1
  äventyrslysten_1_A = mkA "äventyrslysten" ; -- äventyrslysten..av.1
  äventyrsroman_1_N = mkN "äventyrsroman" "äventyrsromaner" ; -- äventyrsroman..nn.1
  ävja_1_N = mkN "ävja" ; -- ävja..nn.1
  äxing_1_N = mkN "äxing" ; -- äxing..nn.1
  å_2_N = mkN "å" ; -- å..nn.2
  åberopa_1_V = mkV "åberopar" ; -- åberopa..vb.1
  åberopande_1_N = mkN "åberopande" ; -- åberopande..nn.1
  åbo_1_N = mkN "åbo" "åbor" ; -- åbo..nn.1
  åborätt_1_N = mkN "åborätt" ; -- åborätt..nn.1
  åbrodd_1_N = mkN "åbrodd" ; -- åbrodd..nn.1
  åbäke_1_N = mkN "åbäke" ; -- åbäke..nn.1
  åbäkig_1_A = mkA "åbäkig" ; -- åbäkig..av.1
  åbäkighet_1_N = mkN "åbäkighet" ; -- åbäkighet..nn.1
  åbäklig_1_A = mkA "åbäklig" ; -- åbäklig..av.1
  åbäklighet_1_N = mkN "åbäklighet" ; -- åbäklighet..nn.1
  åda_1_N = mkN "åda" ; -- åda..nn.1
  ådagalägga_1_V = mkV "ådagalägga" "ådagala" "ådagalagt" ; -- ådagalägga..vb.1
  ådagaläggande_1_N = mkN "ådagaläggande" ; -- ådagaläggande..nn.1
  ådal_1_N = mkN "ådal" ; -- ådal..nn.1
  åder_1_N = mkN "ådra" ; -- åder..nn.1
  åderbrock_1_N = mkN "åderbrock" neutrum  ; -- åderbrock..nn.1
  åderbråck_1_N = mkN "åderbråck" neutrum  ; -- åderbråck..nn.1
  åderförkalkad_1_A = mkA "åderförkalkad" ; -- åderförkalkad..av.1
  åderförkalkning_1_N = mkN "åderförkalkning" ; -- åderförkalkning..nn.1
  åderhinna_1_N = mkN "åderhinna" ; -- åderhinna..nn.1
  åderlåta_1_V = mkV "åderlåta" "åderlät" "åderlåtit" ; -- åderlåta..vb.1
  åderlåtande_1_N = mkN "åderlåtande" ; -- åderlåtande..nn.1
  åderlåtning_1_N = mkN "åderlåtning" ; -- åderlåtning..nn.1
  ådra_1_N = mkN "ådra" ; -- ådra..nn.1
  ådra_1_V = mkV "ådraga" "ådrog" "ådragit" ; -- ådra..vb.1
  ådra_2_V = mkV "ådrar" ; -- ådra..vb.2
  ådragande_1_N = mkN "ådragande" ; -- ådragande..nn.1
  ådrande_1_N = mkN "ådrande" ; -- ådrande..nn.1
  ådrig_1_A = mkA "ådrig" ; -- ådrig..av.1
  ådrighet_1_N = mkN "ådrighet" ; -- ådrighet..nn.1
  ådring_1_N = mkN "ådring" ; -- ådring..nn.1
  ådöma_1_V = mkV "ådömer" ; -- ådöma..vb.1
  ådömande_1_N = mkN "ådömande" ; -- ådömande..nn.1
  ågren_1_N = mkN "ågren" ; -- ågren..nn.1
  åhåga_1_N = mkN "åhåga" ; -- åhåga..nn.1
  åhöra_1_V = mkV "åhöra" "åhörde" "åhört" ; -- åhöra..vb.1
  åhörande_1_N = mkN "åhörande" ; -- åhörande..nn.1
  åhörardag_1_N = mkN "åhörardag" ; -- åhörardag..nn.1
  åhörare_1_N = mkN "åhörare" utrum  ; -- åhörare..nn.1
  åhörarplats_1_N = mkN "åhörarplats" "åhörarplatser" ; -- åhörarplats..nn.1
  åk_1_N = mkN "åk" neutrum  ; -- åk..nn.1
  åka_1_V = mkV "åker" ; -- åka..vb.1
  åkalla_1_V = mkV "åkallar" ; -- åkalla..vb.1
  åkallande_1_N = mkN "åkallande" ; -- åkallande..nn.1
  åkande_1_N = mkN "åkande" ; -- åkande..nn.1
  åkarbrasa_1_N = mkN "åkarbrasa" ; -- åkarbrasa..nn.1
  åkare_1_N = mkN "åkare" utrum  ; -- åkare..nn.1
  åkarhäst_1_N = mkN "åkarhäst" ; -- åkarhäst..nn.1
  åkarkamp_1_N = mkN "åkarkamp" ; -- åkarkamp..nn.1
  åkattraktion_1_N = mkN "åkattraktion" ; -- åkattraktion..nn.1
  åkdon_1_N = mkN "åkdon" neutrum  ; -- åkdon..nn.1
  åker_1_N = mkN "åker" ; -- åker..nn.1
  åkerbinda_1_N = mkN "åkerbinda" ; -- åkerbinda..nn.1
  åkerbit_1_N = mkN "åkerbit" ; -- åkerbit..nn.1
  åkerbruk_1_N = mkN "åkerbruk" neutrum  ; -- åkerbruk..nn.1
  åkerbrukare_1_N = mkN "åkerbrukare" utrum  ; -- åkerbrukare..nn.1
  åkerbär_1_N = mkN "åkerbär" neutrum  ; -- åkerbär..nn.1
  åkerfräken_1_N = mkN "åkerfräken" "åkerfräkenn" "åkerfräknar" "åkerfräknarna" ; -- åkerfräken..nn.1
  åkerfält_1_N = mkN "åkerfält" neutrum  ; -- åkerfält..nn.1
  åkergärde_1_N = mkN "åkergärde" ; -- åkergärde..nn.1
  åkerhöna_1_N = mkN "åkerhöna" ; -- åkerhöna..nn.1
  åkeri_1_N = mkN "åkeri" "åkeriet" "åkerier" "åkerierna" ; -- åkeri..nn.1
  åkerjord_1_N = mkN "åkerjord" ; -- åkerjord..nn.1
  åkerlapp_1_N = mkN "åkerlapp" ; -- åkerlapp..nn.1
  åkermark_1_N = mkN "åkermark" "åkermarker" ; -- åkermark..nn.1
  åkerogräs_1_N = mkN "åkerogräs" neutrum  ; -- åkerogräs..nn.1
  åkerren_1_N = mkN "åkerren" "åkerrenen" "åkerrenar" "åkerrenarna" ; -- åkerren..nn.1
  åkersenap_1_N = mkN "åkersenap" ; -- åkersenap..nn.1
  åkersork_1_N = mkN "åkersork" ; -- åkersork..nn.1
  åkerspergel_1_N = mkN "åkerspergel" ; -- åkerspergel..nn.1
  åkerspöke_1_N = mkN "åkerspöke" ; -- åkerspöke..nn.1
  åkerstig_1_N = mkN "åkerstig" ; -- åkerstig..nn.1
  åkerstubb_1_N = mkN "åkerstubb" ; -- åkerstubb..nn.1
  åkerteg_1_N = mkN "åkerteg" ; -- åkerteg..nn.1
  åkertistel_1_N = mkN "åkertistel" ; -- åkertistel..nn.1
  åkertäppa_1_N = mkN "åkertäppa" ; -- åkertäppa..nn.1
  åkervall_1_N = mkN "åkervall" ; -- åkervall..nn.1
  åkervinda_1_N = mkN "åkervinda" ; -- åkervinda..nn.1
  åkerväxt_1_N = mkN "åkerväxt" "åkerväxter" ; -- åkerväxt..nn.1
  åkerärt_1_N = mkN "åkerärt" "åkerärter" ; -- åkerärt..nn.1
  åkgräsklippare_1_N = mkN "åkgräsklippare" utrum  ; -- åkgräsklippare..nn.1
  åklaga_1_V = mkV "åklagar" ; -- åklaga..vb.1
  åklagande_1_N = mkN "åklagande" ; -- åklagande..nn.1
  åklagarbeslut_1_N = mkN "åklagarbeslut" neutrum  ; -- åklagarbeslut..nn.1
  åklagare_1_N = mkN "åklagare" utrum  ; -- åklagare..nn.1
  åklagarmyndighet_1_N = mkN "åklagarmyndighet" "åklagarmyndigheter" ; -- åklagarmyndighet..nn.1
  åklapp_1_N = mkN "åklapp" ; -- åklapp..nn.1
  åkmässig_1_A = mkA "åkmässig" ; -- åkmässig..av.1
  åkning_1_N = mkN "åkning" ; -- åkning..nn.1
  åkomma_1_N = mkN "åkomma" ; -- åkomma..nn.1
  åkpåse_1_N = mkN "åkpåse" utrum  ; -- åkpåse..nn.1
  åkrök_1_N = mkN "åkrök" ; -- åkrök..nn.1
  åksjuk_1_A = mkA "åksjuk" ; -- åksjuk..av.1
  åksjuka_1_N = mkN "åksjuka" ; -- åksjuka..nn.1
  åksjukhet_1_N = mkN "åksjukhet" ; -- åksjukhet..nn.1
  åktur_1_N = mkN "åktur" "åkturer" ; -- åktur..nn.1
  ål_1_N = mkN "ål" ; -- ål..nn.1
  åla_1_V = mkV "ålar" ; -- åla..vb.1
  ålagille_1_N = mkN "ålagille" ; -- ålagille..nn.1
  ålamörker_1_N = mkN "ålamörker" neutrum  ; -- ålamörker..nn.1
  ålande_1_N = mkN "ålande" ; -- ålande..nn.1
  ålandsrot_1_N = mkN "ålandsrot" "ålandsrötter" ; -- ålandsrot..nn.1
  ålbestånd_1_N = mkN "ålbestånd" neutrum  ; -- ålbestånd..nn.1
  ålder_1_N = mkN "ålder" ; -- ålder..nn.1
  ålderdom_1_N = mkN "ålderdom" ; -- ålderdom..nn.1
  ålderdomlig_1_A = mkA "ålderdomlig" ; -- ålderdomlig..av.1
  ålderdomlighet_1_N = mkN "ålderdomlighet" "ålderdomligheter" ; -- ålderdomlighet..nn.1
  ålderdomsförsäkring_1_N = mkN "ålderdomsförsäkring" ; -- ålderdomsförsäkring..nn.1
  ålderdomshem_1_N = mkN "ålderdomshem" "ålderdomshemmet" "ålderdomshem" "ålderdomshemmen" ; -- ålderdomshem..nn.1
  ålderdomskrämpa_1_N = mkN "ålderdomskrämpa" ; -- ålderdomskrämpa..nn.1
  ålderdomspension_1_N = mkN "ålderdomspension" ; -- ålderdomspension..nn.1
  ålderdomssvag_1_A = mkA "ålderdomssvag" ; -- ålderdomssvag..av.1
  ålderdomssvaghet_1_N = mkN "ålderdomssvaghet" "ålderdomssvagheter" ; -- ålderdomssvaghet..nn.1
  ålderman_1_N = mkN "ålderman" "åldermannen" "åldermän" "åldermännen" ; -- ålderman..nn.1
  åldersbestämma_1_V = mkV "åldersbestämmer" ; -- åldersbestämma..vb.1
  åldersbestämmande_1_N = mkN "åldersbestämmande" ; -- åldersbestämmande..nn.1
  åldersbestämning_1_N = mkN "åldersbestämning" ; -- åldersbestämning..nn.1
  åldersbetyg_1_N = mkN "åldersbetyg" neutrum  ; -- åldersbetyg..nn.1
  åldersblandad_1_A = mkA "åldersblandad" ; -- åldersblandad..av.1
  åldersdiskriminera_1_V = mkV "åldersdiskriminerar" ; -- åldersdiskriminera..vb.1
  åldersdiskriminerande_1_N = mkN "åldersdiskriminerande" ; -- åldersdiskriminerande..nn.1
  åldersdiskriminering_1_N = mkN "åldersdiskriminering" ; -- åldersdiskriminering..nn.1
  åldersfixerad_1_A = mkA "åldersfixerad" ; -- åldersfixerad..av.1
  åldersfixering_1_N = mkN "åldersfixering" ; -- åldersfixering..nn.1
  åldersforskning_1_N = mkN "åldersforskning" ; -- åldersforskning..nn.1
  åldersfördelning_1_N = mkN "åldersfördelning" ; -- åldersfördelning..nn.1
  åldersförändrad_1_A = mkA "åldersförändrad" ; -- åldersförändrad..av.1
  åldersförändring_1_N = mkN "åldersförändring" ; -- åldersförändring..nn.1
  åldersgrupp_1_N = mkN "åldersgrupp" "åldersgrupper" ; -- åldersgrupp..nn.1
  åldersgräns_1_N = mkN "åldersgräns" "åldersgränser" ; -- åldersgräns..nn.1
  åldersklass_1_N = mkN "åldersklass" "åldersklasser" ; -- åldersklass..nn.1
  ålderskrämpa_1_N = mkN "ålderskrämpa" ; -- ålderskrämpa..nn.1
  ålderslångsynthet_1_N = mkN "ålderslångsynthet" "ålderslångsyntheter" ; -- ålderslångsynthet..nn.1
  åldersmässig_1_A = mkA "åldersmässig" ; -- åldersmässig..av.1
  ålderspension_1_N = mkN "ålderspension" ; -- ålderspension..nn.1
  ålderspensionär_1_N = mkN "ålderspensionär" "ålderspensionärer" ; -- ålderspensionär..nn.1
  ålderspresident_1_N = mkN "ålderspresident" "ålderspresidenter" ; -- ålderspresident..nn.1
  ålderssjukdom_1_N = mkN "ålderssjukdom" ; -- ålderssjukdom..nn.1
  åldersskillnad_1_N = mkN "åldersskillnad" "åldersskillnader" ; -- åldersskillnad..nn.1
  åldersskäl_1_N = mkN "åldersskäl" neutrum  ; -- åldersskäl..nn.1
  åldersspärr_1_N = mkN "åldersspärr" ; -- åldersspärr..nn.1
  åldersstadium_1_N = mkN "åldersstadium" "åldersstadiet" "åldersstadier" "åldersstadierna" ; -- åldersstadium..nn.1
  åldersstreck_1_N = mkN "åldersstreck" neutrum  ; -- åldersstreck..nn.1
  åldersstruktur_1_N = mkN "åldersstruktur" "åldersstrukturer" ; -- åldersstruktur..nn.1
  ålderssvag_1_A = mkA "ålderssvag" ; -- ålderssvag..av.1
  ålderssvaghet_1_N = mkN "ålderssvaghet" ; -- ålderssvaghet..nn.1
  ålderstecken_1_N = mkN "ålderstecken" "ålderstecknet" "ålderstecken" "ålderstecknen" ; -- ålderstecken..nn.1
  ålderstigen_1_A = mkA "ålderstigen" ; -- ålderstigen..av.1
  ålderstillägg_1_N = mkN "ålderstillägg" neutrum  ; -- ålderstillägg..nn.1
  ålderstyngd_1_A = mkA "ålderstyngd" "ålderstyngt" ; -- ålderstyngd..av.1
  ålderstyngdhet_1_N = mkN "ålderstyngdhet" ; -- ålderstyngdhet..nn.1
  åldfru_1_N = mkN "åldfru" ; -- åldfru..nn.1
  åldrad_1_A = mkA "åldrad" ; -- åldrad..av.1
  åldrande_1_N = mkN "åldrande" ; -- åldrande..nn.1
  åldrig_1_A = mkA "åldrig" ; -- åldrig..av.1
  åldrighet_1_N = mkN "åldrighet" ; -- åldrighet..nn.1
  åldring_1_N = mkN "åldring" ; -- åldring..nn.1
  åldringsvård_1_N = mkN "åldringsvård" ; -- åldringsvård..nn.1
  ålfiskare_1_N = mkN "ålfiskare" utrum  ; -- ålfiskare..nn.1
  ålfiske_1_N = mkN "ålfiske" ; -- ålfiske..nn.1
  ålhomma_1_N = mkN "ålhomma" ; -- ålhomma..nn.1
  åligga_1_V = mkV "åligga" "ålåg" "ålegat" ; -- åligga..vb.1
  åliggande_1_N = mkN "åliggande" ; -- åliggande..nn.1
  ålkista_1_N = mkN "ålkista" ; -- ålkista..nn.1
  ålkusa_1_N = mkN "ålkusa" ; -- ålkusa..nn.1
  ålla_1_N = mkN "ålla" ; -- ålla..nn.1
  ålla_1_V = mkV "ållar" ; -- ålla..vb.1
  ållande_1_N = mkN "ållande" ; -- ållande..nn.1
  ållning_1_N = mkN "ållning" ; -- ållning..nn.1
  ålmörker_1_N = mkN "ålmörker" neutrum  ; -- ålmörker..nn.1
  ålning_1_N = mkN "ålning" ; -- ålning..nn.1
  ålskinn_1_N = mkN "ålskinn" neutrum  ; -- ålskinn..nn.1
  ålspets_1_N = mkN "ålspets" ; -- ålspets..nn.1
  ålyngel_1_N = mkN "ålyngel" neutrum  ; -- ålyngel..nn.1
  ålägga_1_V = mkV "ålägga" "åla" "ålagt" ; -- ålägga..vb.1
  åläggande_1_N = mkN "åläggande" ; -- åläggande..nn.1
  åländsk_1_A = mkA "åländsk" ; -- åländsk..av.1
  åländska_1_N = mkN "åländska" ; -- åländska..nn.1
  åländska_2_N = mkN "åländska" ; -- åländska..nn.2
  ålänning_1_N = mkN "ålänning" ; -- ålänning..nn.1
  åm_1_N = mkN "åm" ; -- åm..nn.1
  åmig_1_A = mkA "åmig" ; -- åmig..av.1
  åminnelse_1_N = mkN "åminnelse" utrum  ; -- åminnelse..nn.1
  åminnelsedag_1_N = mkN "åminnelsedag" ; -- åminnelsedag..nn.1
  åmning_1_N = mkN "åmning" ; -- åmning..nn.1
  åmynning_1_N = mkN "åmynning" ; -- åmynning..nn.1
  ånga_1_N = mkN "ånga" ; -- ånga..nn.1
  ånga_1_V = mkV "ångar" ; -- ånga..vb.1
  ångackumulator_1_N = mkN "ångackumulator" "ångackumulatorer" ; -- ångackumulator..nn.1
  ångande_1_N = mkN "ångande" ; -- ångande..nn.1
  ånganläggning_1_N = mkN "ånganläggning" ; -- ånganläggning..nn.1
  ångare_1_N = mkN "ångare" utrum  ; -- ångare..nn.1
  ångbageri_1_N = mkN "ångbageri" "ångbageriet" "ångbagerier" "ångbagerierna" ; -- ångbageri..nn.1
  ångbildning_1_N = mkN "ångbildning" ; -- ångbildning..nn.1
  ångbildningsvärme_1_N = mkN "ångbildningsvärme" utrum  ; -- ångbildningsvärme..nn.1
  ångbläster_1_N = mkN "ångbläster" ; -- ångbläster..nn.1
  ångbåt_1_N = mkN "ångbåt" ; -- ångbåt..nn.1
  ångbåtsbrygga_1_N = mkN "ångbåtsbrygga" ; -- ångbåtsbrygga..nn.1
  ångbåtsränna_1_N = mkN "ångbåtsränna" ; -- ångbåtsränna..nn.1
  ångbåtsvissla_1_N = mkN "ångbåtsvissla" ; -- ångbåtsvissla..nn.1
  ångcentral_1_N = mkN "ångcentral" "ångcentraler" ; -- ångcentral..nn.1
  ångdrift_1_N = mkN "ångdrift" ; -- ångdrift..nn.1
  ångdriven_1_A = mkA "ångdriven" ; -- ångdriven..av.1
  ånger_1_N = mkN "ånger" ; -- ånger..nn.1
  ångerfrist_1_N = mkN "ångerfrist" ; -- ångerfrist..nn.1
  ångerfull_1_A = mkA "ångerfull" ; -- ångerfull..av.1
  ångerfullhet_1_N = mkN "ångerfullhet" ; -- ångerfullhet..nn.1
  ångerköpt_1_A = mkA "ångerköpt" "ångerköpt" ; -- ångerköpt..av.1
  ångerköpthet_1_N = mkN "ångerköpthet" ; -- ångerköpthet..nn.1
  ångermanländsk_1_A = mkA "ångermanländsk" ; -- ångermanländsk..av.1
  ångermanlänning_1_N = mkN "ångermanlänning" ; -- ångermanlänning..nn.1
  ångerrätt_1_N = mkN "ångerrätt" ; -- ångerrätt..nn.1
  ångervecka_1_N = mkN "ångervecka" ; -- ångervecka..nn.1
  ångest_1_N = mkN "ångest" ; -- ångest..nn.1
  ångestanfall_1_N = mkN "ångestanfall" neutrum  ; -- ångestanfall..nn.1
  ångestattack_1_N = mkN "ångestattack" "ångestattacker" ; -- ångestattack..nn.1
  ångestdämpande_1_A = mkA "ångestdämpande" ; -- ångestdämpande..av.1
  ångestframkallande_1_A = mkA "ångestframkallande" ; -- ångestframkallande..av.1
  ångestfull_1_A = mkA "ångestfull" ; -- ångestfull..av.1
  ångestfullhet_1_N = mkN "ångestfullhet" ; -- ångestfullhet..nn.1
  ångestfylld_1_A = mkA "ångestfylld" "ångestfyllt" ; -- ångestfylld..av.1
  ångestfylldhet_1_N = mkN "ångestfylldhet" ; -- ångestfylldhet..nn.1
  ångestförlösande_1_A = mkA "ångestförlösande" ; -- ångestförlösande..av.1
  ångestkänsla_1_N = mkN "ångestkänsla" ; -- ångestkänsla..nn.1
  ångestladdad_1_A = mkA "ångestladdad" ; -- ångestladdad..av.1
  ångestneuros_1_N = mkN "ångestneuros" "ångestneuroser" ; -- ångestneuros..nn.1
  ångestriden_1_A = mkA "ångestriden" ; -- ångestriden..av.1
  ångestrop_1_N = mkN "ångestrop" neutrum  ; -- ångestrop..nn.1
  ångestskapande_1_A = mkA "ångestskapande" ; -- ångestskapande..av.1
  ångestskri_1_N = mkN "ångestskri" "ångestskriet" "ångestskrin" "ångestskrina" ; -- ångestskri..nn.1
  ångestsvett_1_N = mkN "ångestsvett" ; -- ångestsvett..nn.1
  ångestsymptom_1_N = mkN "ångestsymptom" neutrum  ; -- ångestsymptom..nn.1
  ångestsymtom_1_N = mkN "ångestsymtom" neutrum  ; -- ångestsymtom..nn.1
  ångfartyg_1_N = mkN "ångfartyg" neutrum  ; -- ångfartyg..nn.1
  ångfylld_1_A = mkA "ångfylld" "ångfyllt" ; -- ångfylld..av.1
  ångförvälla_1_V = mkV "ångförväller" ; -- ångförvälla..vb.1
  ångförvällande_1_N = mkN "ångförvällande" ; -- ångförvällande..nn.1
  ånggenerator_1_N = mkN "ånggenerator" "ånggeneratorer" ; -- ånggenerator..nn.1
  ånggrävare_1_N = mkN "ånggrävare" utrum  ; -- ånggrävare..nn.1
  ångkoka_1_V = mkV "ångkoker" ; -- ångkoka..vb.1
  ångkokande_1_N = mkN "ångkokande" ; -- ångkokande..nn.1
  ångkokare_1_N = mkN "ångkokare" utrum  ; -- ångkokare..nn.1
  ångkol_1_N = mkN "ångkol" neutrum  ; -- ångkol..nn.1
  ångkraft_1_N = mkN "ångkraft" ; -- ångkraft..nn.1
  ångkraftverk_1_N = mkN "ångkraftverk" neutrum  ; -- ångkraftverk..nn.1
  ångkök_1_N = mkN "ångkök" neutrum  ; -- ångkök..nn.1
  ånglok_1_N = mkN "ånglok" neutrum  ; -- ånglok..nn.1
  ånglokomotiv_1_N = mkN "ånglokomotiv" neutrum  ; -- ånglokomotiv..nn.1
  ångmaskin_1_N = mkN "ångmaskin" "ångmaskiner" ; -- ångmaskin..nn.1
  ångning_1_N = mkN "ångning" ; -- ångning..nn.1
  ångpanna_1_N = mkN "ångpanna" ; -- ångpanna..nn.1
  ångra_1_V = mkV "ångrar" ; -- ångra..vb.1
  ångradio_1_N = mkN "ångradio" ; -- ångradio..nn.1
  ångrande_1_N = mkN "ångrande" ; -- ångrande..nn.1
  ångslup_1_N = mkN "ångslup" ; -- ångslup..nn.1
  ångstrykjärn_1_N = mkN "ångstrykjärn" neutrum  ; -- ångstrykjärn..nn.1
  ångström_1_N = mkN "ångström" "ångströmen" "ångström" "ångströmen" ; -- ångström..nn.1
  ångtryck_1_N = mkN "ångtryck" neutrum  ; -- ångtryck..nn.1
  ångturbin_1_N = mkN "ångturbin" "ångturbiner" ; -- ångturbin..nn.1
  ångvinsch_1_N = mkN "ångvinsch" ; -- ångvinsch..nn.1
  ångvissla_1_N = mkN "ångvissla" ; -- ångvissla..nn.1
  ångvält_1_N = mkN "ångvält" ; -- ångvält..nn.1
  ånyo_1_Adv = mkAdv "ånyo" ; -- ånyo..ab.1
  åpen_1_A = mkA "åpen" "åpet" ; -- åpen..av.1
  år_1_N = mkN "år" neutrum  ; -- år..nn.1
  åra_1_N = mkN "åra" ; -- åra..nn.1
  årblad_1_N = mkN "årblad" neutrum  ; -- årblad..nn.1
  årbräckt_1_A = mkA "årbräckt" "årbräckt" ; -- årbräckt..av.1
  årbräckthet_1_N = mkN "årbräckthet" ; -- årbräckthet..nn.1
  årder_1_N = mkN "årder" neutrum  ; -- årder..nn.1
  åretruntboende_1_N = mkN "åretruntboende" "åretruntboenden" "åretruntboenden" "åretruntboendena" ; -- åretruntboende..nn.1
  åretruntbostad_1_N = mkN "åretruntbostad" "åretruntbostäder" ; -- åretruntbostad..nn.1
  åretruntgående_1_A = mkA "åretruntgående" ; -- åretruntgående..av.1
  åretruntolja_1_N = mkN "åretruntolja" ; -- åretruntolja..nn.1
  årfot_1_N = mkN "årfot" "årfötter" ; -- årfot..nn.1
  årgång_1_N = mkN "årgång" ; -- årgång..nn.1
  årgångsvin_1_N = mkN "årgångsvin" "årgångsvinet" "årgångsviner" "årgångsvinerna" ; -- årgångsvin..nn.1
  århundrade_1_N = mkN "århundrade" ; -- århundrade..nn.1
  åring_1_N = mkN "åring" ; -- åring..nn.1
  årklyka_1_N = mkN "årklyka" ; -- årklyka..nn.1
  årlig_1_A = mkA "årlig" ; -- årlig..av.1
  årligen_1_Adv = mkAdv "årligen" ; -- årligen..ab.1
  årlom_1_N = mkN "årlom" "årlommen" "årlommar" "årlommarna" ; -- årlom..nn.1
  årmiljon_1_N = mkN "årmiljon" "årmiljoner" ; -- årmiljon..nn.1
  årpinne_1_N = mkN "årpinne" utrum  ; -- årpinne..nn.1
  årsanställd_1_A = mkA "årsanställd" "årsanställt" ; -- årsanställd..av.1
  årsavgift_1_N = mkN "årsavgift" "årsavgifter" ; -- årsavgift..nn.1
  årsbarn_1_N = mkN "årsbarn" neutrum  ; -- årsbarn..nn.1
  årsberättelse_1_N = mkN "årsberättelse" "årsberättelser" ; -- årsberättelse..nn.1
  årsbok_1_N = mkN "årsbok" "årsböcker" ; -- årsbok..nn.1
  årsbokstav_1_N = mkN "årsbokstav" "årsbokstäver" ; -- årsbokstav..nn.1
  årsbästa_1_A = mkA "årsbästa" ; -- årsbästa..av.1
  årscykel_1_N = mkN "årscykel" ; -- årscykel..nn.1
  årsdag_1_N = mkN "årsdag" ; -- årsdag..nn.1
  årsdos_1_N = mkN "årsdos" "årsdoser" ; -- årsdos..nn.1
  årsförbrukning_1_N = mkN "årsförbrukning" ; -- årsförbrukning..nn.1
  årsgång_1_N = mkN "årsgång" ; -- årsgång..nn.1
  årsinkomst_1_N = mkN "årsinkomst" "årsinkomster" ; -- årsinkomst..nn.1
  årsklass_1_N = mkN "årsklass" "årsklasser" ; -- årsklass..nn.1
  årskort_1_N = mkN "årskort" neutrum  ; -- årskort..nn.1
  årskull_1_N = mkN "årskull" ; -- årskull..nn.1
  årskurs_1_N = mkN "årskurs" "årskurser" ; -- årskurs..nn.1
  årskursintegrering_1_N = mkN "årskursintegrering" ; -- årskursintegrering..nn.1
  årslång_1_A = mkA "årslång" ; -- årslång..av.1
  årsmedeltemperatur_1_N = mkN "årsmedeltemperatur" "årsmedeltemperaturer" ; -- årsmedeltemperatur..nn.1
  årsmodell_1_N = mkN "årsmodell" "årsmodeller" ; -- årsmodell..nn.1
  årsmorän_1_N = mkN "årsmorän" ; -- årsmorän..nn.1
  årsmöte_1_N = mkN "årsmöte" ; -- årsmöte..nn.1
  årsrapport_1_N = mkN "årsrapport" "årsrapporter" ; -- årsrapport..nn.1
  årsredovisning_1_N = mkN "årsredovisning" ; -- årsredovisning..nn.1
  årsring_1_N = mkN "årsring" ; -- årsring..nn.1
  årsskifte_1_N = mkN "årsskifte" ; -- årsskifte..nn.1
  årsstämma_1_N = mkN "årsstämma" ; -- årsstämma..nn.1
  årstid_1_N = mkN "årstid" "årstider" ; -- årstid..nn.1
  årstidsvind_1_N = mkN "årstidsvind" ; -- årstidsvind..nn.1
  årstidsväxling_1_N = mkN "årstidsväxling" ; -- årstidsväxling..nn.1
  årstryck_1_N = mkN "årstryck" neutrum  ; -- årstryck..nn.1
  årsvis_1_Adv = mkAdv "årsvis" ; -- årsvis..ab.1
  årsvis_1_A = mkA "årsvis" ; -- årsvis..av.1
  årsväxt_1_N = mkN "årsväxt" ; -- årsväxt..nn.1
  årta_1_N = mkN "årta" ; -- årta..nn.1
  årtag_1_N = mkN "årtag" neutrum  ; -- årtag..nn.1
  årtal_1_N = mkN "årtal" neutrum  ; -- årtal..nn.1
  årtalsexercis_1_N = mkN "årtalsexercis" "årtalsexerciser" ; -- årtalsexercis..nn.1
  årtionde_1_N = mkN "årtionde" ; -- årtionde..nn.1
  årtull_1_N = mkN "årtull" ; -- årtull..nn.1
  årtusende_1_N = mkN "årtusende" ; -- årtusende..nn.1
  ås_1_N = mkN "ås" ; -- ås..nn.1
  åsamka_1_V = mkV "åsamkar" ; -- åsamka..vb.1
  åsamkande_1_N = mkN "åsamkande" ; -- åsamkande..nn.1
  åse_1_V = mkV "åse" "åsåg" "åsett" ; -- åse..vb.1
  åseende_1_N = mkN "åseende" ; -- åseende..nn.1
  åsgrop_1_N = mkN "åsgrop" ; -- åsgrop..nn.1
  åsidosätta_1_V = mkV "åsidosätta" "åsidosätter" "åsidosätt" "åsidosatte" "åsidosatt" "åsidosatt" ; -- åsidosätta..vb.1
  åsidosättande_1_N = mkN "åsidosättande" ; -- åsidosättande..nn.1
  åsikt_1_N = mkN "åsikt" "åsikter" ; -- åsikt..nn.1
  åsiktsbildning_1_N = mkN "åsiktsbildning" ; -- åsiktsbildning..nn.1
  åsiktsdiktatur_1_N = mkN "åsiktsdiktatur" "åsiktsdiktaturer" ; -- åsiktsdiktatur..nn.1
  åsiktsfrihet_1_N = mkN "åsiktsfrihet" "åsiktsfriheter" ; -- åsiktsfrihet..nn.1
  åsiktsfrände_1_N = mkN "åsiktsfrände" "åsiktsfränder" ; -- åsiktsfrände..nn.1
  åsiktsförföljelse_1_N = mkN "åsiktsförföljelse" "åsiktsförföljelser" ; -- åsiktsförföljelse..nn.1
  åsiktsförtryck_1_N = mkN "åsiktsförtryck" neutrum  ; -- åsiktsförtryck..nn.1
  åsiktsgemenskap_1_N = mkN "åsiktsgemenskap" ; -- åsiktsgemenskap..nn.1
  åsiktsklimat_1_N = mkN "åsiktsklimat" neutrum  ; -- åsiktsklimat..nn.1
  åsiktsmässig_1_A = mkA "åsiktsmässig" ; -- åsiktsmässig..av.1
  åsiktsmässighet_1_N = mkN "åsiktsmässighet" ; -- åsiktsmässighet..nn.1
  åsiktspluralism_1_N = mkN "åsiktspluralism" "åsiktspluralismer" ; -- åsiktspluralism..nn.1
  åsiktsregistrera_1_V = mkV "åsiktsregistrerar" ; -- åsiktsregistrera..vb.1
  åsiktsregistrerande_1_N = mkN "åsiktsregistrerande" ; -- åsiktsregistrerande..nn.1
  åsiktsregistrerbar_1_A = mkA "åsiktsregistrerbar" ; -- åsiktsregistrerbar..av.1
  åsiktsregistrerbarhet_1_N = mkN "åsiktsregistrerbarhet" ; -- åsiktsregistrerbarhet..nn.1
  åsiktsregistrering_1_N = mkN "åsiktsregistrering" ; -- åsiktsregistrering..nn.1
  åsiktsriktning_1_N = mkN "åsiktsriktning" ; -- åsiktsriktning..nn.1
  åsiktsskillnad_1_N = mkN "åsiktsskillnad" "åsiktsskillnader" ; -- åsiktsskillnad..nn.1
  åsiktsutbyte_1_N = mkN "åsiktsutbyte" ; -- åsiktsutbyte..nn.1
  åsiktsyttring_1_N = mkN "åsiktsyttring" ; -- åsiktsyttring..nn.1
  åska_1_N = mkN "åska" ; -- åska..nn.1
  åska_1_V = mkV "åskar" ; -- åska..vb.1
  åskande_1_N = mkN "åskande" ; -- åskande..nn.1
  åskby_1_N = mkN "åskby" "åskbyn" "åskbyar" "åskbyarna" ; -- åskby..nn.1
  åskdiger_1_A = mkA "åskdiger" ; -- åskdiger..av.1
  åskdunder_1_N = mkN "åskdunder" neutrum  ; -- åskdunder..nn.1
  åskfront_1_N = mkN "åskfront" "åskfronter" ; -- åskfront..nn.1
  åskknall_1_N = mkN "åskknall" ; -- åskknall..nn.1
  åskledare_1_N = mkN "åskledare" utrum  ; -- åskledare..nn.1
  åsklik_1_A = mkA "åsklik" ; -- åsklik..av.1
  åsklikhet_1_N = mkN "åsklikhet" ; -- åsklikhet..nn.1
  åskmoln_1_N = mkN "åskmoln" neutrum  ; -- åskmoln..nn.1
  åskmuller_1_N = mkN "åskmuller" neutrum  ; -- åskmuller..nn.1
  åsknedslag_1_N = mkN "åsknedslag" neutrum  ; -- åsknedslag..nn.1
  åskregn_1_N = mkN "åskregn" neutrum  ; -- åskregn..nn.1
  åskrädd_1_A = mkA "åskrädd" ; -- åskrädd..av.1
  åskskräll_1_N = mkN "åskskräll" ; -- åskskräll..nn.1
  åskskur_1_N = mkN "åskskur" ; -- åskskur..nn.1
  åskslag_1_N = mkN "åskslag" neutrum  ; -- åskslag..nn.1
  åskvigg_1_N = mkN "åskvigg" ; -- åskvigg..nn.1
  åskväder_1_N = mkN "åskväder" neutrum  ; -- åskväder..nn.1
  åskåda_1_V = mkV "åskådar" ; -- åskåda..vb.1
  åskådande_1_N = mkN "åskådande" ; -- åskådande..nn.1
  åskådare_1_N = mkN "åskådare" utrum  ; -- åskådare..nn.1
  åskådarhop_1_N = mkN "åskådarhop" ; -- åskådarhop..nn.1
  åskådarläktare_1_N = mkN "åskådarläktare" utrum  ; -- åskådarläktare..nn.1
  åskådarmassa_1_N = mkN "åskådarmassa" ; -- åskådarmassa..nn.1
  åskådlig_1_A = mkA "åskådlig" ; -- åskådlig..av.1
  åskådliggöra_1_V = mkV "åskådliggöra" "åskådliggjorde" "åskådliggjort" ; -- åskådliggöra..vb.1
  åskådliggörande_1_N = mkN "åskådliggörande" ; -- åskådliggörande..nn.1
  åskådlighet_1_N = mkN "åskådlighet" "åskådligheter" ; -- åskådlighet..nn.1
  åskådning_1_N = mkN "åskådning" ; -- åskådning..nn.1
  åskådningsmaterial_1_N = mkN "åskådningsmaterial" neutrum  ; -- åskådningsmaterial..nn.1
  åskådningsmässig_1_A = mkA "åskådningsmässig" ; -- åskådningsmässig..av.1
  åskådningssätt_1_N = mkN "åskådningssätt" neutrum  ; -- åskådningssätt..nn.1
  åskådningsundervisning_1_N = mkN "åskådningsundervisning" ; -- åskådningsundervisning..nn.1
  åsna_1_N = mkN "åsna" ; -- åsna..nn.1
  åsneaktig_1_A = mkA "åsneaktig" ; -- åsneaktig..av.1
  åsnebrygga_1_N = mkN "åsnebrygga" ; -- åsnebrygga..nn.1
  åsnedrivare_1_N = mkN "åsnedrivare" utrum  ; -- åsnedrivare..nn.1
  åsnemjölk_1_N = mkN "åsnemjölk" ; -- åsnemjölk..nn.1
  åsneskri_1_N = mkN "åsneskri" "åsneskriet" "åsneskrin" "åsneskrina" ; -- åsneskri..nn.1
  åsnespark_1_N = mkN "åsnespark" ; -- åsnespark..nn.1
  åsnesto_1_N = mkN "åsnesto" "åsnestot" "åsneston" "åsnestona" ; -- åsnesto..nn.1
  åsneöra_1_N = mkN "åsneöra" "åsneörat" "åsneöron" "åsneöronen" ; -- åsneöra..nn.1
  åsstång_1_N = mkN "åsstång" "åsstänger" ; -- åsstång..nn.1
  åstadkomma_1_V = mkV "åstadkomma" "åstadkom" "åstadkommit" ; -- åstadkomma..vb.1
  åstadkommande_1_N = mkN "åstadkommande" ; -- åstadkommande..nn.1
  åstunda_1_V = mkV "åstundar" ; -- åstunda..vb.1
  åstundande_1_N = mkN "åstundande" ; -- åstundande..nn.1
  åsyfta_1_V = mkV "åsyftar" ; -- åsyfta..vb.1
  åsyftande_1_N = mkN "åsyftande" ; -- åsyftande..nn.1
  åsyn_1_N = mkN "åsyn" ; -- åsyn..nn.1
  åsätta_1_V = mkV "åsätta" "åsätter" "åsätt" "åsatte" "åsatt" "åsatt" ; -- åsätta..vb.1
  åsättande_1_N = mkN "åsättande" ; -- åsättande..nn.1
  åt_1_N = mkN "åt" neutrum  ; -- åt..nn.1
  åtagande_1_N = mkN "åtagande" ; -- åtagande..nn.1
  åtal_1_N = mkN "åtal" neutrum  ; -- åtal..nn.1
  åtala_1_V = mkV "åtalar" ; -- åtala..vb.1
  åtalad_1_A = mkA "åtalad" ; -- åtalad..av.1
  åtalande_1_N = mkN "åtalande" ; -- åtalande..nn.1
  åtalbar_1_A = mkA "åtalbar" ; -- åtalbar..av.1
  åtalbarhet_1_N = mkN "åtalbarhet" ; -- åtalbarhet..nn.1
  åtalsanmälning_1_N = mkN "åtalsanmälning" ; -- åtalsanmälning..nn.1
  åtalsbeslut_1_N = mkN "åtalsbeslut" neutrum  ; -- åtalsbeslut..nn.1
  åtalseftergift_1_N = mkN "åtalseftergift" ; -- åtalseftergift..nn.1
  åtalsimmunitet_1_N = mkN "åtalsimmunitet" "åtalsimmuniteter" ; -- åtalsimmunitet..nn.1
  åtalspunkt_1_N = mkN "åtalspunkt" "åtalspunkter" ; -- åtalspunkt..nn.1
  åtalsrätt_1_N = mkN "åtalsrätt" ; -- åtalsrätt..nn.1
  åtalsunderlåtelse_1_N = mkN "åtalsunderlåtelse" "åtalsunderlåtelser" ; -- åtalsunderlåtelse..nn.1
  åtbörd_1_N = mkN "åtbörd" "åtbörder" ; -- åtbörd..nn.1
  åtdragen_1_A = mkA "åtdragen" ; -- åtdragen..av.1
  åtdragning_1_N = mkN "åtdragning" ; -- åtdragning..nn.1
  åtel_1_N = mkN "åtel" ; -- åtel..nn.1
  åteljakt_1_N = mkN "åteljakt" ; -- åteljakt..nn.1
  återanlända_1_V = mkV "återanländer" ; -- återanlända..vb.1
  återanländande_1_N = mkN "återanländande" ; -- återanländande..nn.1
  återanpassa_1_V = mkV "återanpassar" ; -- återanpassa..vb.1
  återanpassande_1_N = mkN "återanpassande" ; -- återanpassande..nn.1
  återanpassning_1_N = mkN "återanpassning" ; -- återanpassning..nn.1
  återanskaffa_1_V = mkV "återanskaffar" ; -- återanskaffa..vb.1
  återanskaffande_1_N = mkN "återanskaffande" ; -- återanskaffande..nn.1
  återanskaffningsvärde_1_N = mkN "återanskaffningsvärde" ; -- återanskaffningsvärde..nn.1
  återanvända_1_V = mkV "återanvänder" ; -- återanvända..vb.1
  återanvändande_1_N = mkN "återanvändande" ; -- återanvändande..nn.1
  återanvändning_1_N = mkN "återanvändning" ; -- återanvändning..nn.1
  återberätta_1_V = mkV "återberättar" ; -- återberätta..vb.1
  återberättande_1_N = mkN "återberättande" ; -- återberättande..nn.1
  återbesätta_1_V = mkV "återbesätta" "återbesätter" "återbesätt" "återbesatte" "återbesatt" "återbesatt" ; -- återbesätta..vb.1
  återbesättande_1_N = mkN "återbesättande" ; -- återbesättande..nn.1
  återbesättning_1_N = mkN "återbesättning" ; -- återbesättning..nn.1
  återbesök_1_N = mkN "återbesök" neutrum  ; -- återbesök..nn.1
  återbesöka_1_V = mkV "återbesöker" ; -- återbesöka..vb.1
  återbesökande_1_N = mkN "återbesökande" ; -- återbesökande..nn.1
  återbetala_1_V = mkV "återbetalar" ; -- återbetala..vb.1
  återbetalande_1_N = mkN "återbetalande" ; -- återbetalande..nn.1
  återbetalning_1_N = mkN "återbetalning" ; -- återbetalning..nn.1
  återbetalningsrätt_1_N = mkN "återbetalningsrätt" ; -- återbetalningsrätt..nn.1
  återbetalningsskyldig_1_A = mkA "återbetalningsskyldig" ; -- återbetalningsskyldig..av.1
  återbetalningsskyldighet_1_N = mkN "återbetalningsskyldighet" "återbetalningsskyldigheter" ; -- återbetalningsskyldighet..nn.1
  återbetalningstakt_1_N = mkN "återbetalningstakt" ; -- återbetalningstakt..nn.1
  återbilda_1_V = mkV "återbildar" ; -- återbilda..vb.1
  återbildande_1_N = mkN "återbildande" ; -- återbildande..nn.1
  återblick_1_N = mkN "återblick" ; -- återblick..nn.1
  återbruk_1_N = mkN "återbruk" neutrum  ; -- återbruk..nn.1
  återbud_1_N = mkN "återbud" neutrum  ; -- återbud..nn.1
  återbäring_1_N = mkN "återbäring" ; -- återbäring..nn.1
  återbörda_1_V = mkV "återbördar" ; -- återbörda..vb.1
  återbördande_1_N = mkN "återbördande" ; -- återbördande..nn.1
  återerövra_1_V = mkV "återerövrar" ; -- återerövra..vb.1
  återerövrande_1_N = mkN "återerövrande" ; -- återerövrande..nn.1
  återerövring_1_N = mkN "återerövring" ; -- återerövring..nn.1
  återexport_1_N = mkN "återexport" ; -- återexport..nn.1
  återexportera_1_V = mkV "återexporterar" ; -- återexportera..vb.1
  återexporterande_1_N = mkN "återexporterande" ; -- återexporterande..nn.1
  återfall_1_N = mkN "återfall" neutrum  ; -- återfall..nn.1
  återfalla_1_V = mkV "återfalla" "återföll" "återfallit" ; -- återfalla..vb.1
  återfallande_1_N = mkN "återfallande" ; -- återfallande..nn.1
  återfallsfeber_1_N = mkN "återfallsfeber" ; -- återfallsfeber..nn.1
  återfallsförbrytare_1_N = mkN "återfallsförbrytare" utrum  ; -- återfallsförbrytare..nn.1
  återfinna_1_V = mkV "återfinna" "återfann" "återfunnit" ; -- återfinna..vb.1
  återfinnande_1_N = mkN "återfinnande" ; -- återfinnande..nn.1
  återflytta_1_V = mkV "återflyttar" ; -- återflytta..vb.1
  återflyttande_1_N = mkN "återflyttande" ; -- återflyttande..nn.1
  återflyttning_1_N = mkN "återflyttning" ; -- återflyttning..nn.1
  återfuktad_1_A = mkA "återfuktad" ; -- återfuktad..av.1
  återfuktande_1_A = mkA "återfuktande" ; -- återfuktande..av.1
  återfärd_1_N = mkN "återfärd" "återfärder" ; -- återfärd..nn.1
  återfå_1_V = mkV "återfå" "återfick" "återfått" ; -- återfå..vb.1
  återfående_1_N = mkN "återfående" ; -- återfående..nn.1
  återfödelse_1_N = mkN "återfödelse" utrum  ; -- återfödelse..nn.1
  återföderska_1_N = mkN "återföderska" ; -- återföderska..nn.1
  återföra_1_V = mkV "återföra" "återförde" "återfört" ; -- återföra..vb.1
  återförande_1_N = mkN "återförande" ; -- återförande..nn.1
  återförena_1_V = mkV "återförenar" ; -- återförena..vb.1
  återförenande_1_N = mkN "återförenande" ; -- återförenande..nn.1
  återförening_1_N = mkN "återförening" ; -- återförening..nn.1
  återföreningsprocess_1_N = mkN "återföreningsprocess" "återföreningsprocesser" ; -- återföreningsprocess..nn.1
  återföreningstanke_1_N = mkN "återföreningstanke" utrum  ; -- återföreningstanke..nn.1
  återföring_1_N = mkN "återföring" ; -- återföring..nn.1
  återförsluta_1_V = mkV "återförsluta" "återförslöt" "återförslutit" ; -- återförsluta..vb.1
  återförslutande_1_N = mkN "återförslutande" ; -- återförslutande..nn.1
  återförslutningsbar_1_A = mkA "återförslutningsbar" ; -- återförslutningsbar..av.1
  återförsäkra_1_V = mkV "återförsäkrar" ; -- återförsäkra..vb.1
  återförsäkrande_1_N = mkN "återförsäkrande" ; -- återförsäkrande..nn.1
  återförsäkring_1_N = mkN "återförsäkring" ; -- återförsäkring..nn.1
  återförsälja_1_V = mkV "återförsälja" "återförsålde" "återförsålt" ; -- återförsälja..vb.1
  återförsäljande_1_N = mkN "återförsäljande" ; -- återförsäljande..nn.1
  återförsäljare_1_N = mkN "återförsäljare" utrum  ; -- återförsäljare..nn.1
  återförsäljning_1_N = mkN "återförsäljning" ; -- återförsäljning..nn.1
  återförvisa_1_V = mkV "återförvisar" ; -- återförvisa..vb.1
  återförvisande_1_N = mkN "återförvisande" ; -- återförvisande..nn.1
  återförvisning_1_N = mkN "återförvisning" ; -- återförvisning..nn.1
  återge_1_V = mkV "återgiva" "återgav" "återgivit" ; -- återge..vb.1
  återgivande_1_N = mkN "återgivande" ; -- återgivande..nn.1
  återgivning_1_N = mkN "återgivning" ; -- återgivning..nn.1
  återglans_1_N = mkN "återglans" ; -- återglans..nn.1
  återgälda_1_V = mkV "återgäldar" ; -- återgälda..vb.1
  återgäldande_1_N = mkN "återgäldande" ; -- återgäldande..nn.1
  återgå_1_V = mkV "återgå" "återgår" "återgå" "återgick" "återgått" "återgången" ; -- återgå..vb.1
  återgående_1_N = mkN "återgående" ; -- återgående..nn.1
  återgång_1_N = mkN "återgång" ; -- återgång..nn.1
  återgångstull_1_N = mkN "återgångstull" ; -- återgångstull..nn.1
  återhämta_1_V = mkV "återhämtar" ; -- återhämta..vb.1
  återhämtande_1_N = mkN "återhämtande" ; -- återhämtande..nn.1
  återhämtning_1_N = mkN "återhämtning" ; -- återhämtning..nn.1
  återhämtningsfas_1_N = mkN "återhämtningsfas" "återhämtningsfaser" ; -- återhämtningsfas..nn.1
  återhålla_1_V = mkV "återhålla" "återhöll" "återhållit" ; -- återhålla..vb.1
  återhållande_1_N = mkN "återhållande" ; -- återhållande..nn.1
  återhållsam_1_A = mkA "återhållsam" "återhållsamt" "återhållsamma" "återhållsamma" "återhållsammare" "återhållsammast" "återhållsammaste" ; -- återhållsam..av.1
  återhållsamhet_1_N = mkN "återhållsamhet" "återhållsamheter" ; -- återhållsamhet..nn.1
  återigen_1_Adv = mkAdv "återigen" ; -- återigen..ab.1
  återinföra_1_V = mkV "återinföra" "återinförde" "återinfört" ; -- återinföra..vb.1
  återinförande_1_N = mkN "återinförande" ; -- återinförande..nn.1
  återinplantera_1_V = mkV "återinplanterar" ; -- återinplantera..vb.1
  återinplanterande_1_N = mkN "återinplanterande" ; -- återinplanterande..nn.1
  återinplanterbar_1_A = mkA "återinplanterbar" ; -- återinplanterbar..av.1
  återinplanterbarhet_1_N = mkN "återinplanterbarhet" ; -- återinplanterbarhet..nn.1
  återinplantering_1_N = mkN "återinplantering" ; -- återinplantering..nn.1
  återinstallera_1_V = mkV "återinstallerar" ; -- återinstallera..vb.1
  återinstallerande_1_N = mkN "återinstallerande" ; -- återinstallerande..nn.1
  återinstallerbar_1_A = mkA "återinstallerbar" ; -- återinstallerbar..av.1
  återinstallerbarhet_1_N = mkN "återinstallerbarhet" ; -- återinstallerbarhet..nn.1
  återinsätta_1_V = mkV "återinsätta" "återinsätter" "återinsätt" "återinsatte" "återinsatt" "återinsatt" ; -- återinsätta..vb.1
  återinsättande_1_N = mkN "återinsättande" ; -- återinsättande..nn.1
  återinsättning_1_N = mkN "återinsättning" ; -- återinsättning..nn.1
  återinträda_1_V = mkV "återinträda" "återinträdde" "återinträtt" ; -- återinträda..vb.1
  återinträdande_1_N = mkN "återinträdande" ; -- återinträdande..nn.1
  återinträde_1_N = mkN "återinträde" ; -- återinträde..nn.1
  återinträdning_1_N = mkN "återinträdning" ; -- återinträdning..nn.1
  återinvestera_1_V = mkV "återinvesterar" ; -- återinvestera..vb.1
  återinvesterande_1_N = mkN "återinvesterande" ; -- återinvesterande..nn.1
  återinvestering_1_N = mkN "återinvestering" ; -- återinvestering..nn.1
  återinviga_1_V = mkV "återinviger" ; -- återinviga..vb.1
  återinvigande_1_N = mkN "återinvigande" ; -- återinvigande..nn.1
  återinvigning_1_N = mkN "återinvigning" ; -- återinvigning..nn.1
  återkalla_1_V = mkV "återkallar" ; -- återkalla..vb.1
  återkallande_1_N = mkN "återkallande" ; -- återkallande..nn.1
  återkallelse_1_N = mkN "återkallelse" "återkallelser" ; -- återkallelse..nn.1
  återkasta_1_V = mkV "återkastar" ; -- återkasta..vb.1
  återkastande_1_N = mkN "återkastande" ; -- återkastande..nn.1
  återkastning_1_N = mkN "återkastning" ; -- återkastning..nn.1
  återklang_1_N = mkN "återklang" ; -- återklang..nn.1
  återklinga_1_V = mkV "återklingar" ; -- återklinga..vb.1
  återklingande_1_N = mkN "återklingande" ; -- återklingande..nn.1
  återknyta_1_V = mkV "återknyta" "återknöt" "återknutit" ; -- återknyta..vb.1
  återknytande_1_N = mkN "återknytande" ; -- återknytande..nn.1
  återknytning_1_N = mkN "återknytning" ; -- återknytning..nn.1
  återkomma_1_V = mkV "återkomma" "återkom" "återkommit" ; -- återkomma..vb.1
  återkommande_1_A = mkA "återkommande" ; -- återkommande..av.1
  återkommande_1_N = mkN "återkommande" ; -- återkommande..nn.1
  återkomst_1_N = mkN "återkomst" ; -- återkomst..nn.1
  återkoppla_1_V = mkV "återkopplar" ; -- återkoppla..vb.1
  återkopplande_1_N = mkN "återkopplande" ; -- återkopplande..nn.1
  återkoppling_1_N = mkN "återkoppling" ; -- återkoppling..nn.1
  återkrav_1_N = mkN "återkrav" neutrum  ; -- återkrav..nn.1
  återkräva_1_V = mkV "återkräver" ; -- återkräva..vb.1
  återköp_1_N = mkN "återköp" neutrum  ; -- återköp..nn.1
  återköpa_1_V = mkV "återköper" ; -- återköpa..vb.1
  återköpande_1_N = mkN "återköpande" ; -- återköpande..nn.1
  återköpning_1_N = mkN "återköpning" ; -- återköpning..nn.1
  återköpsrätt_1_N = mkN "återköpsrätt" ; -- återköpsrätt..nn.1
  återlämna_1_V = mkV "återlämnar" ; -- återlämna..vb.1
  återlämnande_1_N = mkN "återlämnande" ; -- återlämnande..nn.1
  återlämning_1_N = mkN "återlämning" ; -- återlämning..nn.1
  återlösa_1_V = mkV "återlöser" ; -- återlösa..vb.1
  återlösande_1_N = mkN "återlösande" ; -- återlösande..nn.1
  återlösare_1_N = mkN "återlösare" utrum  ; -- återlösare..nn.1
  återlösning_1_N = mkN "återlösning" ; -- återlösning..nn.1
  återmarsch_1_N = mkN "återmarsch" "återmarscher" ; -- återmarsch..nn.1
  återplantera_1_V = mkV "återplanterar" ; -- återplantera..vb.1
  återplantering_1_N = mkN "återplantering" ; -- återplantering..nn.1
  återrapportera_1_V = mkV "återrapporterar" ; -- återrapportera..vb.1
  återrapporterande_1_N = mkN "återrapporterande" ; -- återrapporterande..nn.1
  återrapporterbar_1_A = mkA "återrapporterbar" ; -- återrapporterbar..av.1
  återrapporterbarhet_1_N = mkN "återrapporterbarhet" ; -- återrapporterbarhet..nn.1
  återrapportering_1_N = mkN "återrapportering" ; -- återrapportering..nn.1
  återremiss_1_N = mkN "återremiss" "återremisser" ; -- återremiss..nn.1
  återremittera_1_V = mkV "återremitterar" ; -- återremittera..vb.1
  återremitterande_1_N = mkN "återremitterande" ; -- återremitterande..nn.1
  återremitterbar_1_A = mkA "återremitterbar" ; -- återremitterbar..av.1
  återremitterbarhet_1_N = mkN "återremitterbarhet" ; -- återremitterbarhet..nn.1
  återremittering_1_N = mkN "återremittering" ; -- återremittering..nn.1
  återresa_1_N = mkN "återresa" ; -- återresa..nn.1
  återrop_1_N = mkN "återrop" neutrum  ; -- återrop..nn.1
  återropa_1_V = mkV "återropar" ; -- återropa..vb.1
  återropande_1_N = mkN "återropande" ; -- återropande..nn.1
  återsamla_1_V = mkV "återsamlar" ; -- återsamla..vb.1
  återsamlande_1_N = mkN "återsamlande" ; -- återsamlande..nn.1
  återsamling_1_N = mkN "återsamling" ; -- återsamling..nn.1
  återse_1_V = mkV "återse" "återsåg" "återsett" ; -- återse..vb.1
  återseende_1_N = mkN "återseende" ; -- återseende..nn.1
  återskall_1_N = mkN "återskall" neutrum  ; -- återskall..nn.1
  återskalla_1_V = mkV "återskallar" ; -- återskalla..vb.1
  återskallande_1_N = mkN "återskallande" ; -- återskallande..nn.1
  återskapa_1_V = mkV "återskapar" ; -- återskapa..vb.1
  återsken_1_N = mkN "återsken" neutrum  ; -- återsken..nn.1
  återspegla_1_V = mkV "återspeglar" ; -- återspegla..vb.1
  återspeglande_1_N = mkN "återspeglande" ; -- återspeglande..nn.1
  återspegling_1_N = mkN "återspegling" ; -- återspegling..nn.1
  återstod_1_N = mkN "återstod" "återstoder" ; -- återstod..nn.1
  återstudsa_1_V = mkV "återstudsar" ; -- återstudsa..vb.1
  återstudsande_1_N = mkN "återstudsande" ; -- återstudsande..nn.1
  återstudsning_1_N = mkN "återstudsning" ; -- återstudsning..nn.1
  återställa_1_V = mkV "återställer" ; -- återställa..vb.1
  återställande_1_N = mkN "återställande" ; -- återställande..nn.1
  återställare_1_N = mkN "återställare" utrum  ; -- återställare..nn.1
  återställelse_1_N = mkN "återställelse" utrum  ; -- återställelse..nn.1
  återställningstecken_1_N = mkN "återställningstecken" "återställningstecknet" "återställningstecken" "återställningstecknen" ; -- återställningstecken..nn.1
  återstå_1_V = mkV "återstå" "återstod" "återstått" ; -- återstå..vb.1
  återstående_1_N = mkN "återstående" ; -- återstående..nn.1
  återsälja_1_V = mkV "återsälja" "återsålde" "återsålt" ; -- återsälja..vb.1
  återsäljande_1_N = mkN "återsäljande" ; -- återsäljande..nn.1
  återsäljare_1_N = mkN "återsäljare" utrum  ; -- återsäljare..nn.1
  återsända_1_V = mkV "återsänder" ; -- återsända..vb.1
  återsändande_1_N = mkN "återsändande" ; -- återsändande..nn.1
  återsändning_1_N = mkN "återsändning" ; -- återsändning..nn.1
  återta_1_V = mkV "återtaga" "återtog" "återtagit" ; -- återta..vb.1
  återtagande_1_N = mkN "återtagande" ; -- återtagande..nn.1
  återtagning_1_N = mkN "återtagning" ; -- återtagning..nn.1
  återtjänst_1_N = mkN "återtjänst" "återtjänster" ; -- återtjänst..nn.1
  återtåg_1_N = mkN "återtåg" neutrum  ; -- återtåg..nn.1
  återtåga_1_V = mkV "återtågar" ; -- återtåga..vb.1
  återtågande_1_N = mkN "återtågande" ; -- återtågande..nn.1
  återuppbygga_1_V = mkV "återuppbygger" ; -- återuppbygga..vb.1
  återuppbyggande_1_N = mkN "återuppbyggande" ; -- återuppbyggande..nn.1
  återuppbyggnad_1_N = mkN "återuppbyggnad" ; -- återuppbyggnad..nn.1
  återuppbyggnadsarbete_1_N = mkN "återuppbyggnadsarbete" ; -- återuppbyggnadsarbete..nn.1
  återuppbyggnadsprocess_1_N = mkN "återuppbyggnadsprocess" "återuppbyggnadsprocesser" ; -- återuppbyggnadsprocess..nn.1
  återuppföra_1_V = mkV "återuppföra" "återuppförde" "återuppfört" ; -- återuppföra..vb.1
  återuppförande_1_N = mkN "återuppförande" ; -- återuppförande..nn.1
  återuppförning_1_N = mkN "återuppförning" ; -- återuppförning..nn.1
  återuppleva_1_V = mkV "återupplever" ; -- återuppleva..vb.1
  återupplevande_1_N = mkN "återupplevande" ; -- återupplevande..nn.1
  återupplevelse_1_N = mkN "återupplevelse" utrum  ; -- återupplevelse..nn.1
  återuppliva_1_V = mkV "återupplivar" ; -- återuppliva..vb.1
  återupplivande_1_N = mkN "återupplivande" ; -- återupplivande..nn.1
  återupplivning_1_N = mkN "återupplivning" ; -- återupplivning..nn.1
  återupplivningsförsök_1_N = mkN "återupplivningsförsök" neutrum  ; -- återupplivningsförsök..nn.1
  återupprepa_1_V = mkV "återupprepar" ; -- återupprepa..vb.1
  återupprepande_1_N = mkN "återupprepande" ; -- återupprepande..nn.1
  återupprepning_1_N = mkN "återupprepning" ; -- återupprepning..nn.1
  återupprätta_1_V = mkV "återupprättar" ; -- återupprätta..vb.1
  återupprättande_1_N = mkN "återupprättande" ; -- återupprättande..nn.1
  återupprättelse_1_N = mkN "återupprättelse" "återupprättelser" ; -- återupprättelse..nn.1
  återuppstå_1_V = mkV "återuppstå" "återuppstår" "återuppstå" "återuppstod" "återuppstått" "återuppstånden" ; -- återuppstå..vb.1
  återuppstående_1_N = mkN "återuppstående" ; -- återuppstående..nn.1
  återuppståndelse_1_N = mkN "återuppståndelse" "återuppståndelser" ; -- återuppståndelse..nn.1
  återuppta_1_V = mkV "återupptaga" "återupptog" "återupptagit" ; -- återuppta..vb.1
  återupptagande_1_N = mkN "återupptagande" ; -- återupptagande..nn.1
  återupptagning_1_N = mkN "återupptagning" ; -- återupptagning..nn.1
  återupptäcka_1_V = mkV "återupptäcker" ; -- återupptäcka..vb.1
  återupptäckande_1_N = mkN "återupptäckande" ; -- återupptäckande..nn.1
  återupptäckning_1_N = mkN "återupptäckning" ; -- återupptäckning..nn.1
  återuppväcka_1_V = mkV "återuppväcker" ; -- återuppväcka..vb.1
  återuppväckande_1_N = mkN "återuppväckande" ; -- återuppväckande..nn.1
  återuppväckelse_1_N = mkN "återuppväckelse" "återuppväckelser" ; -- återuppväckelse..nn.1
  återutstråla_1_V = mkV "återutstrålar" ; -- återutstråla..vb.1
  återutstrålande_1_N = mkN "återutstrålande" ; -- återutstrålande..nn.1
  återutsända_1_V = mkV "återutsänder" ; -- återutsända..vb.1
  återutsändande_1_N = mkN "återutsändande" ; -- återutsändande..nn.1
  återval_1_N = mkN "återval" neutrum  ; -- återval..nn.1
  återvandring_1_N = mkN "återvandring" ; -- återvandring..nn.1
  återverka_1_V = mkV "återverkar" ; -- återverka..vb.1
  återverkande_1_N = mkN "återverkande" ; -- återverkande..nn.1
  återverkning_1_N = mkN "återverkning" ; -- återverkning..nn.1
  återvinna_1_V = mkV "återvinna" "återvann" "återvunnit" ; -- återvinna..vb.1
  återvinnande_1_N = mkN "återvinnande" ; -- återvinnande..nn.1
  återvinning_1_N = mkN "återvinning" ; -- återvinning..nn.1
  återvinningsbar_1_A = mkA "återvinningsbar" ; -- återvinningsbar..av.1
  återvinningscentral_1_N = mkN "återvinningscentral" "återvinningscentraler" ; -- återvinningscentral..nn.1
  återvinningsstation_1_N = mkN "återvinningsstation" ; -- återvinningsstation..nn.1
  återväg_1_N = mkN "återväg" ; -- återväg..nn.1
  återvälja_1_V = mkV "återvälja" "återvalde" "återvalt" ; -- återvälja..vb.1
  återväljande_1_N = mkN "återväljande" ; -- återväljande..nn.1
  återvända_1_V = mkV "återvänder" ; -- återvända..vb.1
  återvändande_1_N = mkN "återvändande" ; -- återvändande..nn.1
  återvändo_1_N = mkN "återvändo" ; -- återvändo..nn.1
  återvändsgata_1_N = mkN "återvändsgata" ; -- återvändsgata..nn.1
  återvändsgränd_1_N = mkN "återvändsgränd" "återvändsgränder" ; -- återvändsgränd..nn.1
  återväxa_1_V = mkV "återväxer" ; -- återväxa..vb.1
  återväxande_1_N = mkN "återväxande" ; -- återväxande..nn.1
  återväxt_1_N = mkN "återväxt" ; -- återväxt..nn.1
  åtfölja_1_V = mkV "åtfölja" "åtföljde" "åtföljt" ; -- åtfölja..vb.1
  åtföljande_1_N = mkN "åtföljande" ; -- åtföljande..nn.1
  åtgärd_1_N = mkN "åtgärd" "åtgärder" ; -- åtgärd..nn.1
  åtgärda_1_V = mkV "åtgärdar" ; -- åtgärda..vb.1
  åtgärdande_1_N = mkN "åtgärdande" ; -- åtgärdande..nn.1
  åtgärdspaket_1_N = mkN "åtgärdspaket" neutrum  ; -- åtgärdspaket..nn.1
  åtgärdsprogram_1_N = mkN "åtgärdsprogram" "åtgärdsprogrammet" "åtgärdsprogram" "åtgärdsprogrammen" ; -- åtgärdsprogram..nn.1
  åtgå_1_V = mkV "åtgå" "åtgår" "åtgå" "åtgick" "åtgått" "åtgången" ; -- åtgå..vb.1
  åtgående_1_N = mkN "åtgående" ; -- åtgående..nn.1
  åtgång_1_N = mkN "åtgång" ; -- åtgång..nn.1
  åtgången_1_A = mkA "åtgången" ; -- åtgången..av.1
  åtgörande_1_N = mkN "åtgörande" ; -- åtgörande..nn.1
  åthuta_1_V = mkV "åthutar" ; -- åthuta..vb.1
  åthutande_1_N = mkN "åthutande" ; -- åthutande..nn.1
  åthutning_1_N = mkN "åthutning" ; -- åthutning..nn.1
  åtkomlig_1_A = mkA "åtkomlig" ; -- åtkomlig..av.1
  åtkomlighet_1_N = mkN "åtkomlighet" ; -- åtkomlighet..nn.1
  åtkomst_1_N = mkN "åtkomst" ; -- åtkomst..nn.1
  åtlyda_1_V = mkV "åtlyda" "åtlöd" "åtlytt" ; -- åtlyda..vb.1
  åtlydande_1_N = mkN "åtlydande" ; -- åtlydande..nn.1
  åtlydnad_1_N = mkN "åtlydnad" "åtlydnader" ; -- åtlydnad..nn.1
  åtlöje_1_N = mkN "åtlöje" ; -- åtlöje..nn.1
  åtminstonde_1_Adv = mkAdv "åtminstonde" ; -- åtminstonde..ab.1
  åtminstone_1_Adv = mkAdv "åtminstone" ; -- åtminstone..ab.1
  åtnjuta_1_V = mkV "åtnjuta" "åtnjöt" "åtnjutit" ; -- åtnjuta..vb.1
  åtnjutande_1_N = mkN "åtnjutande" ; -- åtnjutande..nn.1
  åtra_1_V = mkV "åtrar" ; -- åtra..vb.1
  åtrande_1_N = mkN "åtrande" ; -- åtrande..nn.1
  åtrå_1_N = mkN "åtrå" ; -- åtrå..nn.1
  åtrå_1_V = mkV "åtrår" ; -- åtrå..vb.1
  åtrående_1_N = mkN "åtrående" ; -- åtrående..nn.1
  åtråvärd_1_A = mkA "åtråvärd" "åtråvärt" ; -- åtråvärd..av.1
  åtråvärdhet_1_N = mkN "åtråvärdhet" ; -- åtråvärdhet..nn.1
  åtsida_1_N = mkN "åtsida" ; -- åtsida..nn.1
  åtsittande_1_A = mkA "åtsittande" ; -- åtsittande..av.1
  åtskilja_1_V = mkV "åtskilja" "åtskilde" "åtskilt" ; -- åtskilja..vb.1
  åtskiljande_1_N = mkN "åtskiljande" ; -- åtskiljande..nn.1
  åtskillnad_1_N = mkN "åtskillnad" "åtskillnader" ; -- åtskillnad..nn.1
  åtskillnadslös_1_A = mkA "åtskillnadslös" ; -- åtskillnadslös..av.1
  åtskillnadslöshet_1_N = mkN "åtskillnadslöshet" ; -- åtskillnadslöshet..nn.1
  åtsmitande_1_A = mkA "åtsmitande" ; -- åtsmitande..av.1
  åtsnörning_1_N = mkN "åtsnörning" ; -- åtsnörning..nn.1
  åtstrama_1_V = mkV "åtstramar" ; -- åtstrama..vb.1
  åtstramande_1_N = mkN "åtstramande" ; -- åtstramande..nn.1
  åtstramning_1_N = mkN "åtstramning" ; -- åtstramning..nn.1
  åtstramningsbehov_1_N = mkN "åtstramningsbehov" neutrum  ; -- åtstramningsbehov..nn.1
  åtstramningsbudget_1_N = mkN "åtstramningsbudget" ; -- åtstramningsbudget..nn.1
  åtstramningspaket_1_N = mkN "åtstramningspaket" neutrum  ; -- åtstramningspaket..nn.1
  åtstramningsprogram_1_N = mkN "åtstramningsprogram" "åtstramningsprogrammet" "åtstramningsprogram" "åtstramningsprogrammen" ; -- åtstramningsprogram..nn.1
  åtstramningsåtgärd_1_N = mkN "åtstramningsåtgärd" "åtstramningsåtgärder" ; -- åtstramningsåtgärd..nn.1
  åtta_1_N = mkN "åtta" ; -- åtta..nn.1
  åttadubbel_1_A = mkA "åttadubben" ; -- åttadubbel..av.1
  åttafaldig_1_A = mkA "åttafaldig" ; -- åttafaldig..av.1
  åttahörnig_1_A = mkA "åttahörnig" ; -- åttahörnig..av.1
  åttahörning_1_N = mkN "åttahörning" ; -- åttahörning..nn.1
  åttakantig_1_A = mkA "åttakantig" ; -- åttakantig..av.1
  åttakantighet_1_N = mkN "åttakantighet" ; -- åttakantighet..nn.1
  åttatimmarsdag_1_N = mkN "åttatimmarsdag" ; -- åttatimmarsdag..nn.1
  åttatumsspik_1_N = mkN "åttatumsspik" ; -- åttatumsspik..nn.1
  åttatusentonnare_1_N = mkN "åttatusentonnare" utrum  ; -- åttatusentonnare..nn.1
  åttaårig_1_A = mkA "åttaårig" ; -- åttaårig..av.1
  åttaåring_1_N = mkN "åttaåring" ; -- åttaåring..nn.1
  åttaårscykel_1_N = mkN "åttaårscykel" ; -- åttaårscykel..nn.1
  åttionde_1_A = mkA "åttionde" ; -- åttionde..av.1
  åttiondel_1_N = mkN "åttiondel" "åttiondelen" "åttiondelar" "åttiondelarna" ; -- åttiondel..nn.1
  åttioprocentig_1_A = mkA "åttioprocentig" ; -- åttioprocentig..av.1
  åttiotal_1_N = mkN "åttiotal" neutrum  ; -- åttiotal..nn.1
  åttiotalism_1_N = mkN "åttiotalism" "åttiotalismer" ; -- åttiotalism..nn.1
  åttiotalist_1_N = mkN "åttiotalist" "åttiotalister" ; -- åttiotalist..nn.1
  åttiotalistisk_1_A = mkA "åttiotalistisk" ; -- åttiotalistisk..av.1
  åttiprocentig_1_A = mkA "åttiprocentig" ; -- åttiprocentig..av.1
  åttital_1_N = mkN "åttital" neutrum  ; -- åttital..nn.1
  åttitalism_1_N = mkN "åttitalism" "åttitalismer" ; -- åttitalism..nn.1
  åttitalist_1_N = mkN "åttitalist" "åttitalister" ; -- åttitalist..nn.1
  åttkant_1_N = mkN "åttkant" "åttkanter" ; -- åttkant..nn.1
  åttkantig_1_A = mkA "åttkantig" ; -- åttkantig..av.1
  åttkantighet_1_N = mkN "åttkantighet" ; -- åttkantighet..nn.1
  åttling_1_N = mkN "åttling" ; -- åttling..nn.1
  åttlingmamma_1_N = mkN "åttlingmamma" ; -- åttlingmamma..nn.1
  åttonde_1_A = mkA "åttonde" ; -- åttonde..av.1
  åttondedel_1_N = mkN "åttondedel" "åttondedelen" "åttondedelar" "åttondedelarna" ; -- åttondedel..nn.1
  åttondel_1_N = mkN "åttondel" "åttondelen" "åttondelar" "åttondelarna" ; -- åttondel..nn.1
  åttondelsfinal_1_N = mkN "åttondelsfinal" "åttondelsfinaler" ; -- åttondelsfinal..nn.1
  åvatten_1_N = mkN "åvatten" "åvattnet" "åvatten" "åvattnen" ; -- åvatten..nn.1
  åvila_1_V = mkV "åvilar" ; -- åvila..vb.1
  åvilande_1_N = mkN "åvilande" ; -- åvilande..nn.1
  åvägabringa_1_V = mkV "åvägabringar" ; -- åvägabringa..vb.1
  åvägabringande_1_N = mkN "åvägabringande" ; -- åvägabringande..nn.1
  élan_1_N = mkN "élan" ; -- élan..nn.1
  ö_2_N = mkN "ö" ; -- ö..nn.2
  öbo_1_N = mkN "öbo" "öbor" ; -- öbo..nn.1
  öda_1_V = mkV "öda" "ödde" "ött" ; -- öda..vb.1
  ödande_1_N = mkN "ödande" ; -- ödande..nn.1
  öde_1_A = mkA "öde" ; -- öde..av.1
  öde_1_N = mkN "öde" ; -- öde..nn.1
  ödebygdsväg_1_N = mkN "ödebygdsväg" ; -- ödebygdsväg..nn.1
  ödegård_1_N = mkN "ödegård" ; -- ödegård..nn.1
  ödekyrka_1_N = mkN "ödekyrka" ; -- ödekyrka..nn.1
  ödelägga_1_V = mkV "ödelägga" "ödela" "ödelagt" ; -- ödelägga..vb.1
  ödeläggande_1_N = mkN "ödeläggande" ; -- ödeläggande..nn.1
  ödeläggare_1_N = mkN "ödeläggare" utrum  ; -- ödeläggare..nn.1
  ödeläggelse_1_N = mkN "ödeläggelse" "ödeläggelser" ; -- ödeläggelse..nn.1
  ödem_1_N = mkN "ödem" neutrum  ; -- ödem..nn.1
  ödemark_1_N = mkN "ödemark" "ödemarker" ; -- ödemark..nn.1
  ödemarksområde_1_N = mkN "ödemarksområde" ; -- ödemarksområde..nn.1
  ödematös_1_A = mkA "ödematös" ; -- ödematös..av.1
  ödesbestämd_1_A = mkA "ödesbestämd" "ödesbestämt" ; -- ödesbestämd..av.1
  ödesbestämdhet_1_N = mkN "ödesbestämdhet" ; -- ödesbestämdhet..nn.1
  ödesdag_1_N = mkN "ödesdag" ; -- ödesdag..nn.1
  ödesdiger_1_A = mkA "ödesdiger" ; -- ödesdiger..av.1
  ödesdigerhet_1_N = mkN "ödesdigerhet" ; -- ödesdigerhet..nn.1
  ödesdrama_1_N = mkN "ödesdrama" "ödesdramat" "ödesdramer" "ödesdramerna" ; -- ödesdrama..nn.1
  ödesfråga_1_N = mkN "ödesfråga" ; -- ödesfråga..nn.1
  ödesgemenskap_1_N = mkN "ödesgemenskap" ; -- ödesgemenskap..nn.1
  ödesgudinna_1_N = mkN "ödesgudinna" ; -- ödesgudinna..nn.1
  ödesmättad_1_A = mkA "ödesmättad" ; -- ödesmättad..av.1
  ödesmål_1_N = mkN "ödesmål" ; -- ödesmål..nn.1
  ödesstund_1_N = mkN "ödesstund" "ödesstunder" ; -- ödesstund..nn.1
  ödestro_1_N = mkN "ödestro" ; -- ödestro..nn.1
  ödestuga_1_N = mkN "ödestuga" ; -- ödestuga..nn.1
  ödesval_1_N = mkN "ödesval" neutrum  ; -- ödesval..nn.1
  ödesår_1_N = mkN "ödesår" neutrum  ; -- ödesår..nn.1
  ödla_1_N = mkN "ödla" ; -- ödla..nn.1
  ödlearvsmassa_1_N = mkN "ödlearvsmassa" ; -- ödlearvsmassa..nn.1
  ödmjuk_1_A = mkA "ödmjuk" ; -- ödmjuk..av.1
  ödmjuka_1_V = mkV "ödmjukar" ; -- ödmjuka..vb.1
  ödmjukande_1_N = mkN "ödmjukande" ; -- ödmjukande..nn.1
  ödmjukhet_1_N = mkN "ödmjukhet" "ödmjukheter" ; -- ödmjukhet..nn.1
  ödsla_1_V = mkV "ödslar" ; -- ödsla..vb.1
  ödslande_1_N = mkN "ödslande" ; -- ödslande..nn.1
  ödslig_1_A = mkA "ödslig" ; -- ödslig..av.1
  ödslighet_1_N = mkN "ödslighet" "ödsligheter" ; -- ödslighet..nn.1
  öga_1_N = mkN "öga" "ögat" "ögon" "ögonen" ; -- öga..nn.1
  ögla_1_N = mkN "ögla" ; -- ögla..nn.1
  ögna_1_V = mkV "ögnar" ; -- ögna..vb.1
  ögnande_1_N = mkN "ögnande" ; -- ögnande..nn.1
  ögonbindel_1_N = mkN "ögonbindel" ; -- ögonbindel..nn.1
  ögonblick_1_N = mkN "ögonblick" neutrum  ; -- ögonblick..nn.1
  ögonblicklig_1_A = mkA "ögonblicklig" ; -- ögonblicklig..av.1
  ögonblickligen_1_Adv = mkAdv "ögonblickligen" ; -- ögonblickligen..ab.1
  ögonblicklighet_1_N = mkN "ögonblicklighet" ; -- ögonblicklighet..nn.1
  ögonblicksbild_1_N = mkN "ögonblicksbild" "ögonblicksbilder" ; -- ögonblicksbild..nn.1
  ögonbotten_1_N = mkN "ögonbotten" ; -- ögonbotten..nn.1
  ögonbryn_1_N = mkN "ögonbryn" neutrum  ; -- ögonbryn..nn.1
  ögonbrynshöjning_1_N = mkN "ögonbrynshöjning" ; -- ögonbrynshöjning..nn.1
  ögondiagnostik_1_N = mkN "ögondiagnostik" ; -- ögondiagnostik..nn.1
  ögondropp_1_N = mkN "ögondropp" neutrum  ; -- ögondropp..nn.1
  ögonflirt_1_N = mkN "ögonflirt" "ögonflirter" ; -- ögonflirt..nn.1
  ögonflirta_1_V = mkV "ögonflirtar" ; -- ögonflirta..vb.1
  ögonflirtande_1_N = mkN "ögonflirtande" ; -- ögonflirtande..nn.1
  ögonflört_1_N = mkN "ögonflört" "ögonflörter" ; -- ögonflört..nn.1
  ögonflörta_1_V = mkV "ögonflörtar" ; -- ögonflörta..vb.1
  ögonflörtande_1_N = mkN "ögonflörtande" ; -- ögonflörtande..nn.1
  ögonfrans_1_N = mkN "ögonfrans" ; -- ögonfrans..nn.1
  ögonfröjd_1_N = mkN "ögonfröjd" "ögonfröjder" ; -- ögonfröjd..nn.1
  ögonfägnad_1_N = mkN "ögonfägnad" "ögonfägnader" ; -- ögonfägnad..nn.1
  ögonfärg_1_N = mkN "ögonfärg" "ögonfärger" ; -- ögonfärg..nn.1
  ögonglob_1_N = mkN "ögonglob" "ögonglober" ; -- ögonglob..nn.1
  ögonhinna_1_N = mkN "ögonhinna" ; -- ögonhinna..nn.1
  ögonhåla_1_N = mkN "ögonhåla" ; -- ögonhåla..nn.1
  ögonhår_1_N = mkN "ögonhår" neutrum  ; -- ögonhår..nn.1
  ögoninflammation_1_N = mkN "ögoninflammation" ; -- ögoninflammation..nn.1
  ögonkamera_1_N = mkN "ögonkamera" ; -- ögonkamera..nn.1
  ögonkast_1_N = mkN "ögonkast" neutrum  ; -- ögonkast..nn.1
  ögonkontakt_1_N = mkN "ögonkontakt" "ögonkontakter" ; -- ögonkontakt..nn.1
  ögonlock_1_N = mkN "ögonlock" neutrum  ; -- ögonlock..nn.1
  ögonläkare_1_N = mkN "ögonläkare" utrum  ; -- ögonläkare..nn.1
  ögonmuskel_1_N = mkN "ögonmuskel" "ögonmuskeln" "ögonmuskler" "ögonmusklerna" ; -- ögonmuskel..nn.1
  ögonmärke_1_N = mkN "ögonmärke" ; -- ögonmärke..nn.1
  ögonmått_1_N = mkN "ögonmått" neutrum  ; -- ögonmått..nn.1
  ögonoperation_1_N = mkN "ögonoperation" ; -- ögonoperation..nn.1
  ögonpar_1_N = mkN "ögonpar" neutrum  ; -- ögonpar..nn.1
  ögonprotes_1_N = mkN "ögonprotes" "ögonproteser" ; -- ögonprotes..nn.1
  ögonrullning_1_N = mkN "ögonrullning" ; -- ögonrullning..nn.1
  ögonrörelse_1_N = mkN "ögonrörelse" "ögonrörelser" ; -- ögonrörelse..nn.1
  ögonrörelsemönster_1_N = mkN "ögonrörelsemönster" neutrum  ; -- ögonrörelsemönster..nn.1
  ögonsikte_1_N = mkN "ögonsikte" ; -- ögonsikte..nn.1
  ögonsjukdom_1_N = mkN "ögonsjukdom" ; -- ögonsjukdom..nn.1
  ögonskenlig_1_A = mkA "ögonskenlig" ; -- ögonskenlig..av.1
  ögonskenligen_1_Adv = mkAdv "ögonskenligen" ; -- ögonskenligen..ab.1
  ögonskenlighet_1_N = mkN "ögonskenlighet" ; -- ögonskenlighet..nn.1
  ögonskugga_1_N = mkN "ögonskugga" ; -- ögonskugga..nn.1
  ögonspegel_1_N = mkN "ögonspegel" ; -- ögonspegel..nn.1
  ögonsten_1_N = mkN "ögonsten" "ögonstenen" "ögonstenar" "ögonstenarna" ; -- ögonsten..nn.1
  ögontagg_1_N = mkN "ögontagg" ; -- ögontagg..nn.1
  ögontand_1_N = mkN "ögontand" "ögontänder" ; -- ögontand..nn.1
  ögontjänare_1_N = mkN "ögontjänare" utrum  ; -- ögontjänare..nn.1
  ögontröst_1_N = mkN "ögontröst" ; -- ögontröst..nn.1
  ögontrötthet_1_N = mkN "ögontrötthet" ; -- ögontrötthet..nn.1
  ögonvidd_1_N = mkN "ögonvidd" "ögonvidder" ; -- ögonvidd..nn.1
  ögonvinkel_1_N = mkN "ögonvinkel" ; -- ögonvinkel..nn.1
  ögonvita_1_N = mkN "ögonvita" ; -- ögonvita..nn.1
  ögonvittne_1_N = mkN "ögonvittne" ; -- ögonvittne..nn.1
  ögonvittnesskildring_1_N = mkN "ögonvittnesskildring" ; -- ögonvittnesskildring..nn.1
  ögonvrå_1_N = mkN "ögonvrå" "ögonvrån" "ögonvrår" "ögonvrårna" ; -- ögonvrå..nn.1
  ögonöppnare_1_N = mkN "ögonöppnare" utrum  ; -- ögonöppnare..nn.1
  ögrupp_1_N = mkN "ögrupp" "ögrupper" ; -- ögrupp..nn.1
  ök_1_N = mkN "ök" neutrum  ; -- ök..nn.1
  öka_1_V = mkV "ökar" ; -- öka..vb.1
  öka_2_V = mkV "ökar" ; -- öka..vb.2
  ökande_1_N = mkN "ökande" ; -- ökande..nn.1
  öken_1_A = mkA "öken" ; -- öken..av.1
  öken_1_N = mkN "öken" ; -- öken..nn.1
  ökendamm_1_N = mkN "ökendamm" neutrum  ; -- ökendamm..nn.1
  ökendjur_1_N = mkN "ökendjur" neutrum  ; -- ökendjur..nn.1
  ökenhetta_1_N = mkN "ökenhetta" ; -- ökenhetta..nn.1
  ökenklimat_1_N = mkN "ökenklimat" neutrum  ; -- ökenklimat..nn.1
  ökenlandskap_1_N = mkN "ökenlandskap" neutrum  ; -- ökenlandskap..nn.1
  ökenrally_1_N = mkN "ökenrally" "ökenrallyt" "ökenrallyn" "ökenrallyna" ; -- ökenrally..nn.1
  ökenrand_1_N = mkN "ökenrand" "ökenränder" ; -- ökenrand..nn.1
  ökenråtta_1_N = mkN "ökenråtta" ; -- ökenråtta..nn.1
  ökensand_1_N = mkN "ökensand" ; -- ökensand..nn.1
  ökenstjärna_1_N = mkN "ökenstjärna" ; -- ökenstjärna..nn.1
  ökenvandring_1_N = mkN "ökenvandring" ; -- ökenvandring..nn.1
  ökenvidd_1_N = mkN "ökenvidd" "ökenvidder" ; -- ökenvidd..nn.1
  ökenvind_1_N = mkN "ökenvind" ; -- ökenvind..nn.1
  ökenväxt_1_N = mkN "ökenväxt" "ökenväxter" ; -- ökenväxt..nn.1
  öknamn_1_N = mkN "öknamn" neutrum  ; -- öknamn..nn.1
  ökning_1_N = mkN "ökning" ; -- ökning..nn.1
  ökningstakt_1_N = mkN "ökningstakt" ; -- ökningstakt..nn.1
  ökstock_1_N = mkN "ökstock" ; -- ökstock..nn.1
  ökänd_1_A = mkA "ökänd" ; -- ökänd..av.1
  ökändhet_1_N = mkN "ökändhet" ; -- ökändhet..nn.1
  öl_1_N = mkN "öl" neutrum  ; -- öl..nn.1
  öl_2_N = mkN "öl" neutrum  ; -- öl..nn.2
  öla_1_V = mkV "ölar" ; -- öla..vb.1
  ölande_1_N = mkN "ölande" ; -- ölande..nn.1
  ölandsgård_1_N = mkN "ölandsgård" ; -- ölandsgård..nn.1
  ölandshäst_1_N = mkN "ölandshäst" ; -- ölandshäst..nn.1
  ölandstok_1_N = mkN "ölandstok" ; -- ölandstok..nn.1
  ölandsvända_1_N = mkN "ölandsvända" ; -- ölandsvända..nn.1
  ölback_1_N = mkN "ölback" ; -- ölback..nn.1
  ölbryggeri_1_N = mkN "ölbryggeri" "ölbryggeriet" "ölbryggerier" "ölbryggerierna" ; -- ölbryggeri..nn.1
  ölburk_1_N = mkN "ölburk" ; -- ölburk..nn.1
  öldrickande_1_A = mkA "öldrickande" ; -- öldrickande..av.1
  öldrickande_1_N = mkN "öldrickande" ; -- öldrickande..nn.1
  öldrickning_1_N = mkN "öldrickning" ; -- öldrickning..nn.1
  ölflaska_1_N = mkN "ölflaska" ; -- ölflaska..nn.1
  ölglas_1_N = mkN "ölglas" neutrum  ; -- ölglas..nn.1
  ölgubbe_1_N = mkN "ölgubbe" utrum  ; -- ölgubbe..nn.1
  ölhall_1_N = mkN "ölhall" ; -- ölhall..nn.1
  öljett_1_N = mkN "öljett" "öljetter" ; -- öljett..nn.1
  ölkafé_1_N = mkN "ölkafé" "ölkaféet" "ölkaféer" "ölkaféerna" ; -- ölkafé..nn.1
  ölmage_1_N = mkN "ölmage" utrum  ; -- ölmage..nn.1
  ölost_1_N = mkN "ölost" ; -- ölost..nn.1
  ölrättighet_1_N = mkN "ölrättighet" "ölrättigheter" ; -- ölrättighet..nn.1
  ölservering_1_N = mkN "ölservering" ; -- ölservering..nn.1
  ölsinne_1_N = mkN "ölsinne" ; -- ölsinne..nn.1
  ölstuga_1_N = mkN "ölstuga" ; -- ölstuga..nn.1
  ölsupa_1_N = mkN "ölsupa" ; -- ölsupa..nn.1
  ölsörplare_1_N = mkN "ölsörplare" utrum  ; -- ölsörplare..nn.1
  öltillverkning_1_N = mkN "öltillverkning" ; -- öltillverkning..nn.1
  öluff_1_N = mkN "öluff" ; -- öluff..nn.1
  ölunderlägg_1_N = mkN "ölunderlägg" neutrum  ; -- ölunderlägg..nn.1
  ölutkörare_1_N = mkN "ölutkörare" utrum  ; -- ölutkörare..nn.1
  öländsk_1_A = mkA "öländsk" ; -- öländsk..av.1
  öländska_1_N = mkN "öländska" ; -- öländska..nn.1
  öländska_2_N = mkN "öländska" ; -- öländska..nn.2
  ölänning_1_N = mkN "ölänning" ; -- ölänning..nn.1
  ölöppnare_1_N = mkN "ölöppnare" utrum  ; -- ölöppnare..nn.1
  öm_1_A = mkA "öm" "ömt" "ömma" "ömma" "ömmare" "ömmast" "ömmaste" ; -- öm..av.1
  ömfotad_1_A = mkA "ömfotad" ; -- ömfotad..av.1
  ömhet_1_N = mkN "ömhet" "ömheter" ; -- ömhet..nn.1
  ömhet_2_N = mkN "ömhet" ; -- ömhet..nn.2
  ömhetsbetygelse_1_N = mkN "ömhetsbetygelse" "ömhetsbetygelseen" "ömhetsbetygelseer" "ömhetsbetygelseerna" ; -- ömhetsbetygelse..nn.1
  ömhetstörst_1_N = mkN "ömhetstörst" ; -- ömhetstörst..nn.1
  ömhjärtad_1_A = mkA "ömhjärtad" ; -- ömhjärtad..av.1
  ömhudad_1_A = mkA "ömhudad" ; -- ömhudad..av.1
  ömka_1_V = mkV "ömkar" ; -- ömka..vb.1
  ömkande_1_N = mkN "ömkande" ; -- ömkande..nn.1
  ömkansvärd_1_A = mkA "ömkansvärd" "ömkansvärt" ; -- ömkansvärd..av.1
  ömkansvärdhet_1_N = mkN "ömkansvärdhet" ; -- ömkansvärdhet..nn.1
  ömklig_1_A = mkA "ömklig" ; -- ömklig..av.1
  ömkligen_1_Adv = mkAdv "ömkligen" ; -- ömkligen..ab.1
  ömklighet_1_N = mkN "ömklighet" "ömkligheter" ; -- ömklighet..nn.1
  ömkyla_1_N = mkN "ömkyla" ; -- ömkyla..nn.1
  ömma_1_V = mkV "ömmar" ; -- ömma..vb.1
  ömmande_1_A = mkA "ömmande" ; -- ömmande..av.1
  ömmande_1_N = mkN "ömmande" ; -- ömmande..nn.1
  ömsa_1_V = mkV "ömsar" ; -- ömsa..vb.1
  ömsande_1_N = mkN "ömsande" ; -- ömsande..nn.1
  ömsesidig_1_A = mkA "ömsesidig" ; -- ömsesidig..av.1
  ömsesidighet_1_N = mkN "ömsesidighet" ; -- ömsesidighet..nn.1
  ömsevis_1_Adv = mkAdv "ömsevis" ; -- ömsevis..ab.1
  ömsint_1_A = mkA "ömsint" "ömsint" ; -- ömsint..av.1
  ömsinthet_1_N = mkN "ömsinthet" ; -- ömsinthet..nn.1
  ömskinnad_1_A = mkA "ömskinnad" ; -- ömskinnad..av.1
  ömsning_1_N = mkN "ömsning" ; -- ömsning..nn.1
  ömsom_1_Adv = mkAdv "ömsom" ; -- ömsom..ab.1
  ömtålig_1_A = mkA "ömtålig" ; -- ömtålig..av.1
  ömtålighet_1_N = mkN "ömtålighet" "ömtåligheter" ; -- ömtålighet..nn.1
  önska_1_V = mkV "önskar" ; -- önska..vb.1
  önskande_1_N = mkN "önskande" ; -- önskande..nn.1
  önskebarn_1_N = mkN "önskebarn" neutrum  ; -- önskebarn..nn.1
  önskedröm_1_N = mkN "önskedröm" "önskedrömmen" "önskedrömmar" "önskedrömmarna" ; -- önskedröm..nn.1
  önskelista_1_N = mkN "önskelista" ; -- önskelista..nn.1
  önskemål_1_N = mkN "önskemål" neutrum  ; -- önskemål..nn.1
  önskering_1_N = mkN "önskering" ; -- önskering..nn.1
  önskeroll_1_N = mkN "önskeroll" "önskeroller" ; -- önskeroll..nn.1
  önskesats_1_N = mkN "önskesats" "önskesatser" ; -- önskesats..nn.1
  önsketänkande_1_N = mkN "önsketänkande" ; -- önsketänkande..nn.1
  önskeuppfyllelse_1_N = mkN "önskeuppfyllelse" utrum  ; -- önskeuppfyllelse..nn.1
  önsklig_1_A = mkA "önsklig" ; -- önsklig..av.1
  önsklighet_1_N = mkN "önsklighet" ; -- önsklighet..nn.1
  önskning_1_N = mkN "önskning" ; -- önskning..nn.1
  önskvärd_1_A = mkA "önskvärd" "önskvärt" ; -- önskvärd..av.1
  önskvärdhet_1_N = mkN "önskvärdhet" ; -- önskvärdhet..nn.1
  öppen_1_A = mkA "öppen" ; -- öppen..av.1
  öppenhet_1_N = mkN "öppenhet" "öppenheter" ; -- öppenhet..nn.1
  öppenhjärtig_1_A = mkA "öppenhjärtig" ; -- öppenhjärtig..av.1
  öppenhjärtighet_1_N = mkN "öppenhjärtighet" ; -- öppenhjärtighet..nn.1
  öppenhjärtlig_1_A = mkA "öppenhjärtlig" ; -- öppenhjärtlig..av.1
  öppenhjärtlighet_1_N = mkN "öppenhjärtlighet" ; -- öppenhjärtlighet..nn.1
  öppenvård_1_N = mkN "öppenvård" ; -- öppenvård..nn.1
  öppethållande_1_N = mkN "öppethållande" ; -- öppethållande..nn.1
  öppettid_1_N = mkN "öppettid" "öppettider" ; -- öppettid..nn.1
  öppna_1_V = mkV "öppnar" ; -- öppna..vb.1
  öppnaknapp_1_N = mkN "öppnaknapp" ; -- öppnaknapp..nn.1
  öppnande_1_N = mkN "öppnande" ; -- öppnande..nn.1
  öppnare_1_N = mkN "öppnare" utrum  ; -- öppnare..nn.1
  öppning_1_N = mkN "öppning" ; -- öppning..nn.1
  öppningsbar_1_A = mkA "öppningsbar" ; -- öppningsbar..av.1
  öppningsbud_1_N = mkN "öppningsbud" neutrum  ; -- öppningsbud..nn.1
  öppningsceremoni_1_N = mkN "öppningsceremoni" "öppningsceremonier" ; -- öppningsceremoni..nn.1
  öppningsdags_1_N = mkN "öppningsdags" ; -- öppningsdags..nn.1
  öppningsdrag_1_N = mkN "öppningsdrag" neutrum  ; -- öppningsdrag..nn.1
  öppningsskede_1_N = mkN "öppningsskede" ; -- öppningsskede..nn.1
  ör_1_N = mkN "ör" ; -- ör..nn.1
  öra_1_N = mkN "öra" "örat" "öron" "öronen" ; -- öra..nn.1
  öra_2_N = mkN "öra" ; -- öra..nn.2
  örclips_1_N = mkN "örclips" neutrum  ; -- örclips..nn.1
  öre_1_N = mkN "öre" ; -- öre..nn.1
  öresvin_1_N = mkN "öresvin" neutrum  ; -- öresvin..nn.1
  örfil_1_N = mkN "örfil" ; -- örfil..nn.1
  örfila_1_V = mkV "örfilar" ; -- örfila..vb.1
  örfilande_1_N = mkN "örfilande" ; -- örfilande..nn.1
  örfilsdom_1_N = mkN "örfilsdom" ; -- örfilsdom..nn.1
  örflik_1_N = mkN "örflik" ; -- örflik..nn.1
  örhänge_1_N = mkN "örhänge" ; -- örhänge..nn.1
  örike_1_N = mkN "örike" ; -- örike..nn.1
  öring_1_N = mkN "öring" ; -- öring..nn.1
  örla_1_V = mkV "örlar" ; -- örla..vb.1
  örlande_1_N = mkN "örlande" ; -- örlande..nn.1
  örlig_1_N = mkN "örlig" ; -- örlig..nn.1
  örlog_1_N = mkN "örlog" ; -- örlog..nn.1
  örlogsbas_1_N = mkN "örlogsbas" "örlogsbaser" ; -- örlogsbas..nn.1
  örlogsfartyg_1_N = mkN "örlogsfartyg" neutrum  ; -- örlogsfartyg..nn.1
  örlogsflagg_1_N = mkN "örlogsflagg" ; -- örlogsflagg..nn.1
  örlogsflagga_1_N = mkN "örlogsflagga" ; -- örlogsflagga..nn.1
  örlogsman_1_N = mkN "örlogsman" "örlogsmannen" "örlogsmän" "örlogsmännen" ; -- örlogsman..nn.1
  örlogsmatros_1_N = mkN "örlogsmatros" "örlogsmatroser" ; -- örlogsmatros..nn.1
  örlogsvarv_1_N = mkN "örlogsvarv" neutrum  ; -- örlogsvarv..nn.1
  örmage_1_N = mkN "örmage" utrum  ; -- örmage..nn.1
  örn_1_N = mkN "örn" ; -- örn..nn.1
  örnblick_1_N = mkN "örnblick" ; -- örnblick..nn.1
  örnbräken_1_N = mkN "örnbräken" ; -- örnbräken..nn.1
  örnbräkne_1_N = mkN "örnbräkne" utrum  ; -- örnbräkne..nn.1
  örngott_1_N = mkN "örngott" neutrum  ; -- örngott..nn.1
  örngottsband_1_N = mkN "örngottsband" neutrum  ; -- örngottsband..nn.1
  örngottsbandskrusare_1_N = mkN "örngottsbandskrusare" utrum  ; -- örngottsbandskrusare..nn.1
  örnklo_1_N = mkN "örnklo" "örnklor" ; -- örnklo..nn.1
  örnkoll_1_N = mkN "örnkoll" ; -- örnkoll..nn.1
  örnnäsa_1_N = mkN "örnnäsa" ; -- örnnäsa..nn.1
  öronbarn_1_N = mkN "öronbarn" neutrum  ; -- öronbarn..nn.1
  öronbedövande_1_A = mkA "öronbedövande" ; -- öronbedövande..av.1
  örongång_1_N = mkN "örongång" ; -- örongång..nn.1
  öroninflammation_1_N = mkN "öroninflammation" ; -- öroninflammation..nn.1
  öronlappsfåtölj_1_N = mkN "öronlappsfåtölj" "öronlappsfåtöljer" ; -- öronlappsfåtölj..nn.1
  öronläkare_1_N = mkN "öronläkare" utrum  ; -- öronläkare..nn.1
  öronlös_1_A = mkA "öronlös" ; -- öronlös..av.1
  öronmussla_1_N = mkN "öronmussla" ; -- öronmussla..nn.1
  öronmärka_1_V = mkV "öronmärker" ; -- öronmärka..vb.1
  öronmärkande_1_N = mkN "öronmärkande" ; -- öronmärkande..nn.1
  öronoperation_1_N = mkN "öronoperation" ; -- öronoperation..nn.1
  öronpropp_1_N = mkN "öronpropp" ; -- öronpropp..nn.1
  öronsjukdom_1_N = mkN "öronsjukdom" ; -- öronsjukdom..nn.1
  öronsnibb_1_N = mkN "öronsnibb" ; -- öronsnibb..nn.1
  öronsnäcka_1_N = mkN "öronsnäcka" ; -- öronsnäcka..nn.1
  öronsusning_1_N = mkN "öronsusning" ; -- öronsusning..nn.1
  örontasslare_1_N = mkN "örontasslare" utrum  ; -- örontasslare..nn.1
  örontrumpet_1_N = mkN "örontrumpet" "örontrumpeter" ; -- örontrumpet..nn.1
  öronvax_1_N = mkN "öronvax" neutrum  ; -- öronvax..nn.1
  örråg_1_N = mkN "örråg" ; -- örråg..nn.1
  örsnibb_1_N = mkN "örsnibb" ; -- örsnibb..nn.1
  örsprång_1_N = mkN "örsprång" neutrum  ; -- örsprång..nn.1
  ört_1_N = mkN "ört" "örter" ; -- ört..nn.1
  örtagård_1_N = mkN "örtagård" ; -- örtagård..nn.1
  örtagårdsmästare_1_N = mkN "örtagårdsmästare" utrum  ; -- örtagårdsmästare..nn.1
  örtesäng_1_N = mkN "örtesäng" ; -- örtesäng..nn.1
  örtkrydda_1_N = mkN "örtkrydda" ; -- örtkrydda..nn.1
  örtsäng_1_N = mkN "örtsäng" ; -- örtsäng..nn.1
  örtte_1_N = mkN "örtte" ; -- örtte..nn.1
  örtug_1_N = mkN "örtug" ; -- örtug..nn.1
  ös_1_N = mkN "ös" neutrum  ; -- ös..nn.1
  ösa_1_V = mkV "öser" ; -- ösa..vb.1
  ösande_1_N = mkN "ösande" ; -- ösande..nn.1
  öskar_1_N = mkN "öskar" neutrum  ; -- öskar..nn.1
  ösning_1_N = mkN "ösning" ; -- ösning..nn.1
  ösregn_1_N = mkN "ösregn" neutrum  ; -- ösregn..nn.1
  ösregna_1_V = mkV "ösregnar" ; -- ösregna..vb.1
  ösregnande_1_N = mkN "ösregnande" ; -- ösregnande..nn.1
  öst_västlig_1_A = mkA "öst-västlig" ; -- öst-västlig..av.1
  öst_1_N = mkN "öst" ; -- öst..nn.1
  östafrikansk_1_A = mkA "östafrikansk" ; -- östafrikansk..av.1
  östanvind_1_N = mkN "östanvind" ; -- östanvind..nn.1
  östasiat_1_N = mkN "östasiat" "östasiater" ; -- östasiat..nn.1
  östasiatisk_1_A = mkA "östasiatisk" ; -- östasiatisk..av.1
  östat_1_N = mkN "östat" "östater" ; -- östat..nn.1
  östblock_1_N = mkN "östblock" neutrum  ; -- östblock..nn.1
  öster_1_Adv = mkAdv "öster" ; -- öster..ab.1
  öster_1_N = mkN "öster" ; -- öster..nn.1
  österbottning_1_N = mkN "österbottning" ; -- österbottning..nn.1
  österbottnisk_1_A = mkA "österbottnisk" ; -- österbottnisk..av.1
  östergök_1_N = mkN "östergök" ; -- östergök..nn.1
  österifrån_1_Adv = mkAdv "österifrån" ; -- österifrån..ab.1
  österland_1_N = mkN "österland" neutrum  ; -- österland..nn.1
  österländsk_1_A = mkA "österländsk" ; -- österländsk..av.1
  österlänning_1_N = mkN "österlänning" ; -- österlänning..nn.1
  österrikare_1_N = mkN "österrikare" utrum  ; -- österrikare..nn.1
  österrikisk_1_A = mkA "österrikisk" ; -- österrikisk..av.1
  östersjöfisk_1_N = mkN "östersjöfisk" ; -- östersjöfisk..nn.1
  östersjöfiske_1_N = mkN "östersjöfiske" ; -- östersjöfiske..nn.1
  österut_1_Adv = mkAdv "österut" ; -- österut..ab.1
  östeuropeisk_1_A = mkA "östeuropeisk" ; -- östeuropeisk..av.1
  östfront_1_N = mkN "östfront" "östfronter" ; -- östfront..nn.1
  östgot_1_N = mkN "östgot" "östgoter" ; -- östgot..nn.1
  östgotisk_1_A = mkA "östgotisk" ; -- östgotisk..av.1
  östgotiska_1_N = mkN "östgotiska" ; -- östgotiska..nn.1
  östgöte_1_N = mkN "östgöte" utrum  ; -- östgöte..nn.1
  östgötsk_1_A = mkA "östgötsk" ; -- östgötsk..av.1
  östgötska_1_N = mkN "östgötska" ; -- östgötska..nn.1
  östgötska_2_N = mkN "östgötska" ; -- östgötska..nn.2
  östkant_1_N = mkN "östkant" "östkanter" ; -- östkant..nn.1
  östkust_1_N = mkN "östkust" "östkuster" ; -- östkust..nn.1
  östkustmiljö_1_N = mkN "östkustmiljö" "östkustmiljön" "östkustmiljöer" "östkustmiljöerna" ; -- östkustmiljö..nn.1
  östkyrka_1_N = mkN "östkyrka" ; -- östkyrka..nn.1
  östlig_1_A = mkA "östlig" ; -- östlig..av.1
  östnordisk_1_A = mkA "östnordisk" ; -- östnordisk..av.1
  östpå_1_Adv = mkAdv "östpå" ; -- östpå..ab.1
  östra_1_A = mkA "östra" ; -- östra..av.1
  östrogen_1_N = mkN "östrogen" "östrogenet" "östrogener" "östrogenerna" ; -- östrogen..nn.1
  östron_1_N = mkN "östron" neutrum  ; -- östron..nn.1
  östrus_1_N = mkN "östrus" ; -- östrus..nn.1
  öststat_1_N = mkN "öststat" "öststater" ; -- öststat..nn.1
  öststatsförtryck_1_N = mkN "öststatsförtryck" neutrum  ; -- öststatsförtryck..nn.1
  öststatsledare_1_N = mkN "öststatsledare" utrum  ; -- öststatsledare..nn.1
  östtysk_1_A = mkA "östtysk" ; -- östtysk..av.1
  östtysk_1_N = mkN "östtysk" ; -- östtysk..nn.1
  östvart_1_Adv = mkAdv "östvart" ; -- östvart..ab.1
  östöver_1_Adv = mkAdv "östöver" ; -- östöver..ab.1
  öva_1_V = mkV "övar" ; -- öva..vb.1
  övande_1_N = mkN "övande" ; -- övande..nn.1
  över_1_A = mkA "över" ; -- över..av.1
  överaktiv_1_A = mkA "överaktiv" ; -- överaktiv..av.1
  överaktivitet_1_N = mkN "överaktivitet" ; -- överaktivitet..nn.1
  överallt_1_Adv = mkAdv "överallt" ; -- överallt..ab.1
  överalltifrån_1_Adv = mkAdv "överalltifrån" ; -- överalltifrån..ab.1
  överambitiös_1_A = mkA "överambitiös" ; -- överambitiös..av.1
  överanstränga_1_V = mkV "överanstränger" ; -- överanstränga..vb.1
  överansträngande_1_N = mkN "överansträngande" ; -- överansträngande..nn.1
  överansträngning_1_N = mkN "överansträngning" ; -- överansträngning..nn.1
  överantvarda_1_V = mkV "överantvardar" ; -- överantvarda..vb.1
  överantvardande_1_N = mkN "överantvardande" ; -- överantvardande..nn.1
  överanvända_1_V = mkV "överanvänder" ; -- överanvända..vb.1
  överanvändande_1_N = mkN "överanvändande" ; -- överanvändande..nn.1
  överanvändning_1_N = mkN "överanvändning" ; -- överanvändning..nn.1
  överarbeta_1_V = mkV "överarbetar" ; -- överarbeta..vb.1
  överarbetande_1_N = mkN "överarbetande" ; -- överarbetande..nn.1
  överarbete_1_N = mkN "överarbete" ; -- överarbete..nn.1
  överarbetning_1_N = mkN "överarbetning" ; -- överarbetning..nn.1
  överarm_1_N = mkN "överarm" ; -- överarm..nn.1
  överarmsmuskel_1_N = mkN "överarmsmuskel" "överarmsmuskeln" "överarmsmuskler" "överarmsmusklerna" ; -- överarmsmuskel..nn.1
  överbalanserad_1_A = mkA "överbalanserad" ; -- överbalanserad..av.1
  överbefolka_1_V = mkV "överbefolkar" ; -- överbefolka..vb.1
  överbefolkad_1_A = mkA "överbefolkad" ; -- överbefolkad..av.1
  överbefolkande_1_N = mkN "överbefolkande" ; -- överbefolkande..nn.1
  överbefolkning_1_N = mkN "överbefolkning" ; -- överbefolkning..nn.1
  överbefäl_1_N = mkN "överbefäl" neutrum  ; -- överbefäl..nn.1
  överbefälhavare_1_N = mkN "överbefälhavare" utrum  ; -- överbefälhavare..nn.1
  överbegrepp_1_N = mkN "överbegrepp" neutrum  ; -- överbegrepp..nn.1
  överbegåvad_1_A = mkA "överbegåvad" ; -- överbegåvad..av.1
  överbehandling_1_N = mkN "överbehandling" ; -- överbehandling..nn.1
  överbelasta_1_V = mkV "överbelastar" ; -- överbelasta..vb.1
  överbelastad_1_A = mkA "överbelastad" ; -- överbelastad..av.1
  överbelastande_1_N = mkN "överbelastande" ; -- överbelastande..nn.1
  överbelastning_1_N = mkN "överbelastning" ; -- överbelastning..nn.1
  överbelägga_1_V = mkV "överbelägga" "överbela" "överbelagt" ; -- överbelägga..vb.1
  överbeläggande_1_N = mkN "överbeläggande" ; -- överbeläggande..nn.1
  överbeläggning_1_N = mkN "överbeläggning" ; -- överbeläggning..nn.1
  överbelåna_1_V = mkV "överbelånar" ; -- överbelåna..vb.1
  överbelånande_1_N = mkN "överbelånande" ; -- överbelånande..nn.1
  överbelåning_1_N = mkN "överbelåning" ; -- överbelåning..nn.1
  överbeskydda_1_V = mkV "överbeskyddar" ; -- överbeskydda..vb.1
  överbeskyddande_1_N = mkN "överbeskyddande" ; -- överbeskyddande..nn.1
  överbetala_1_V = mkV "överbetalar" ; -- överbetala..vb.1
  överbetalande_1_N = mkN "överbetalande" ; -- överbetalande..nn.1
  överbetalning_1_N = mkN "överbetalning" ; -- överbetalning..nn.1
  överbetona_1_V = mkV "överbetonar" ; -- överbetona..vb.1
  överbetonande_1_N = mkN "överbetonande" ; -- överbetonande..nn.1
  överbetoning_1_N = mkN "överbetoning" ; -- överbetoning..nn.1
  överbett_1_N = mkN "överbett" neutrum  ; -- överbett..nn.1
  överbetyg_1_N = mkN "överbetyg" neutrum  ; -- överbetyg..nn.1
  överbevisa_1_V = mkV "överbevisar" ; -- överbevisa..vb.1
  överbevisande_1_N = mkN "överbevisande" ; -- överbevisande..nn.1
  överbevisning_1_N = mkN "överbevisning" ; -- överbevisning..nn.1
  överbjuda_1_V = mkV "överbjuda" "överbjöd" "överbjudit" ; -- överbjuda..vb.1
  överbjudande_1_N = mkN "överbjudande" ; -- överbjudande..nn.1
  överbjudning_1_N = mkN "överbjudning" ; -- överbjudning..nn.1
  överblick_1_N = mkN "överblick" ; -- överblick..nn.1
  överblicka_1_V = mkV "överblickar" ; -- överblicka..vb.1
  överblickande_1_N = mkN "överblickande" ; -- överblickande..nn.1
  överblickbar_1_A = mkA "överblickbar" ; -- överblickbar..av.1
  överblickbarhet_1_N = mkN "överblickbarhet" ; -- överblickbarhet..nn.1
  överbliven_1_A = mkA "överbliven" ; -- överbliven..av.1
  överboka_1_V = mkV "överbokar" ; -- överboka..vb.1
  överbokande_1_N = mkN "överbokande" ; -- överbokande..nn.1
  överbringa_1_V = mkV "överbringar" ; -- överbringa..vb.1
  överbringande_1_N = mkN "överbringande" ; -- överbringande..nn.1
  överbringare_1_N = mkN "överbringare" utrum  ; -- överbringare..nn.1
  överbruk_1_N = mkN "överbruk" neutrum  ; -- överbruk..nn.1
  överbrygga_1_V = mkV "överbryggar" ; -- överbrygga..vb.1
  överbryggande_1_N = mkN "överbryggande" ; -- överbryggande..nn.1
  överbud_1_N = mkN "överbud" neutrum  ; -- överbud..nn.1
  överbudspolitik_1_N = mkN "överbudspolitik" ; -- överbudspolitik..nn.1
  överbyggd_1_A = mkA "överbyggd" "överbyggt" ; -- överbyggd..av.1
  överbyggnad_1_N = mkN "överbyggnad" "överbyggnader" ; -- överbyggnad..nn.1
  överbädd_1_N = mkN "överbädd" ; -- överbädd..nn.1
  överdebitera_1_V = mkV "överdebiterar" ; -- överdebitera..vb.1
  överdebiterande_1_N = mkN "överdebiterande" ; -- överdebiterande..nn.1
  överdebitering_1_N = mkN "överdebitering" ; -- överdebitering..nn.1
  överdel_1_N = mkN "överdel" "överdelen" "överdelar" "överdelarna" ; -- överdel..nn.1
  överdiagnostik_1_N = mkN "överdiagnostik" ; -- överdiagnostik..nn.1
  överdimensionera_1_V = mkV "överdimensionerar" ; -- överdimensionera..vb.1
  överdimensionerande_1_N = mkN "överdimensionerande" ; -- överdimensionerande..nn.1
  överdimensionerbar_1_A = mkA "överdimensionerbar" ; -- överdimensionerbar..av.1
  överdimensionerbarhet_1_N = mkN "överdimensionerbarhet" ; -- överdimensionerbarhet..nn.1
  överdimensionering_1_N = mkN "överdimensionering" ; -- överdimensionering..nn.1
  överdirektör_1_N = mkN "överdirektör" "överdirektörer" ; -- överdirektör..nn.1
  överdjävul_1_N = mkN "överdjävul" "överdjävulen" "överdjävlar" "överdjävlarna" ; -- överdjävul..nn.1
  överdomare_1_N = mkN "överdomare" utrum  ; -- överdomare..nn.1
  överdomstol_1_N = mkN "överdomstol" ; -- överdomstol..nn.1
  överdos_1_N = mkN "överdos" "överdoser" ; -- överdos..nn.1
  överdosera_1_V = mkV "överdoserar" ; -- överdosera..vb.1
  överdoserande_1_N = mkN "överdoserande" ; -- överdoserande..nn.1
  överdoserbar_1_A = mkA "överdoserbar" ; -- överdoserbar..av.1
  överdoserbarhet_1_N = mkN "överdoserbarhet" ; -- överdoserbarhet..nn.1
  överdosering_1_N = mkN "överdosering" ; -- överdosering..nn.1
  överdra_1_V = mkV "överdraga" "överdrog" "överdragit" ; -- överdra..vb.1
  överdrag_1_N = mkN "överdrag" neutrum  ; -- överdrag..nn.1
  överdragande_1_N = mkN "överdragande" ; -- överdragande..nn.1
  överdragsdräkt_1_N = mkN "överdragsdräkt" "överdragsdräkter" ; -- överdragsdräkt..nn.1
  överdrift_1_N = mkN "överdrift" "överdrifter" ; -- överdrift..nn.1
  överdriva_1_V = mkV "överdriva" "överdrev" "överdrivit" ; -- överdriva..vb.1
  överdrivande_1_N = mkN "överdrivande" ; -- överdrivande..nn.1
  överdriven_1_A = mkA "överdriven" ; -- överdriven..av.1
  överdäck_1_N = mkN "överdäck" neutrum  ; -- överdäck..nn.1
  överdängare_1_N = mkN "överdängare" utrum  ; -- överdängare..nn.1
  överdåd_1_N = mkN "överdåd" neutrum  ; -- överdåd..nn.1
  överdådig_1_A = mkA "överdådig" ; -- överdådig..av.1
  överdådighet_1_N = mkN "överdådighet" ; -- överdådighet..nn.1
  överdödlighet_1_N = mkN "överdödlighet" "överdödligheter" ; -- överdödlighet..nn.1
  överens_1_A = mkA "överens" ; -- överens..av.1
  överensfyr_1_N = mkN "överensfyr" ; -- överensfyr..nn.1
  överenskomma_1_V = mkV "överenskomma" "överenskom" "överenskommit" ; -- överenskomma..vb.1
  överenskommande_1_N = mkN "överenskommande" ; -- överenskommande..nn.1
  överenskommelse_1_N = mkN "överenskommelse" "överenskommelser" ; -- överenskommelse..nn.1
  överensstämma_1_V = mkV "överensstämmer" ; -- överensstämma..vb.1
  överensstämmande_1_N = mkN "överensstämmande" ; -- överensstämmande..nn.1
  överensstämmelse_1_N = mkN "överensstämmelse" "överensstämmelser" ; -- överensstämmelse..nn.1
  överexponera_1_V = mkV "överexponerar" ; -- överexponera..vb.1
  överexponerande_1_N = mkN "överexponerande" ; -- överexponerande..nn.1
  överexponerbar_1_A = mkA "överexponerbar" ; -- överexponerbar..av.1
  överexponerbarhet_1_N = mkN "överexponerbarhet" ; -- överexponerbarhet..nn.1
  överexponering_1_N = mkN "överexponering" ; -- överexponering..nn.1
  överfall_1_N = mkN "överfall" neutrum  ; -- överfall..nn.1
  överfalla_1_V = mkV "överfalla" "överföll" "överfallit" ; -- överfalla..vb.1
  överfallande_1_N = mkN "överfallande" ; -- överfallande..nn.1
  överfallsvåldtäkt_1_N = mkN "överfallsvåldtäkt" "överfallsvåldtäkter" ; -- överfallsvåldtäkt..nn.1
  överfallsvåldtäktsman_1_N = mkN "överfallsvåldtäktsman" "överfallsvåldtäktsmannen" "överfallsvåldtäktsmän" "överfallsvåldtäktsmännen" ; -- överfallsvåldtäktsman..nn.1
  överfarbar_1_A = mkA "överfarbar" ; -- överfarbar..av.1
  överfarbarhet_1_N = mkN "överfarbarhet" ; -- överfarbarhet..nn.1
  överfart_1_N = mkN "överfart" "överfarter" ; -- överfart..nn.1
  överfartsort_1_N = mkN "överfartsort" "överfartsorter" ; -- överfartsort..nn.1
  överfiske_1_N = mkN "överfiske" ; -- överfiske..nn.1
  överfiskning_1_N = mkN "överfiskning" ; -- överfiskning..nn.1
  överflyga_1_V = mkV "överflyga" "överflög" "överflugit" ; -- överflyga..vb.1
  överflygla_1_V = mkV "överflyglar" ; -- överflygla..vb.1
  överflyglande_1_N = mkN "överflyglande" ; -- överflyglande..nn.1
  överflygling_1_N = mkN "överflygling" ; -- överflygling..nn.1
  överflygning_1_N = mkN "överflygning" ; -- överflygning..nn.1
  överflytta_1_V = mkV "överflyttar" ; -- överflytta..vb.1
  överflyttande_1_N = mkN "överflyttande" ; -- överflyttande..nn.1
  överflyttbar_1_A = mkA "överflyttbar" ; -- överflyttbar..av.1
  överflyttbarhet_1_N = mkN "överflyttbarhet" ; -- överflyttbarhet..nn.1
  överflyttning_1_N = mkN "överflyttning" ; -- överflyttning..nn.1
  överflöd_1_N = mkN "överflöd" neutrum  ; -- överflöd..nn.1
  överflöda_1_V = mkV "överflödar" ; -- överflöda..vb.1
  överflödande_1_N = mkN "överflödande" ; -- överflödande..nn.1
  överflödig_1_A = mkA "överflödig" ; -- överflödig..av.1
  överflödighet_1_N = mkN "överflödighet" ; -- överflödighet..nn.1
  överflödsartikel_1_N = mkN "överflödsartikel" ; -- överflödsartikel..nn.1
  överflödssamhälle_1_N = mkN "överflödssamhälle" ; -- överflödssamhälle..nn.1
  överflödsvara_1_N = mkN "överflödsvara" ; -- överflödsvara..nn.1
  överfralla_1_N = mkN "överfralla" ; -- överfralla..nn.1
  överfull_1_A = mkA "överfull" ; -- överfull..av.1
  överfullhet_1_N = mkN "överfullhet" ; -- överfullhet..nn.1
  överfurir_1_N = mkN "överfurir" "överfurirer" ; -- överfurir..nn.1
  överfylld_1_A = mkA "överfylld" "överfyllt" ; -- överfylld..av.1
  överfylldhet_1_N = mkN "överfylldhet" ; -- överfylldhet..nn.1
  överfärd_1_N = mkN "överfärd" "överfärder" ; -- överfärd..nn.1
  överfångsglas_1_N = mkN "överfångsglas" neutrum  ; -- överfångsglas..nn.1
  överföra_1_V = mkV "överföra" "överförde" "överfört" ; -- överföra..vb.1
  överförande_1_N = mkN "överförande" ; -- överförande..nn.1
  överförbar_1_A = mkA "överförbar" ; -- överförbar..av.1
  överförd_1_A = mkA "överförd" "överfört" ; -- överförd..av.1
  överförfinad_1_A = mkA "överförfinad" ; -- överförfinad..av.1
  överförfining_1_N = mkN "överförfining" ; -- överförfining..nn.1
  överförfriskad_1_A = mkA "överförfriskad" ; -- överförfriskad..av.1
  överföring_1_N = mkN "överföring" ; -- överföring..nn.1
  överföringsbild_1_N = mkN "överföringsbild" "överföringsbilder" ; -- överföringsbild..nn.1
  överföringskapacitet_1_N = mkN "överföringskapacitet" "överföringskapaciteter" ; -- överföringskapacitet..nn.1
  överföringskarakteristik_1_N = mkN "överföringskarakteristik" "överföringskarakteristiker" ; -- överföringskarakteristik..nn.1
  överföringskaraktäristik_1_N = mkN "överföringskaraktäristik" "överföringskaraktäristiker" ; -- överföringskaraktäristik..nn.1
  överförmyndare_1_N = mkN "överförmyndare" utrum  ; -- överförmyndare..nn.1
  överförtjust_1_A = mkA "överförtjust" "överförtjust" ; -- överförtjust..av.1
  överförtjusthet_1_N = mkN "överförtjusthet" ; -- överförtjusthet..nn.1
  överge_1_V = mkV "övergiva" "övergav" "övergivit" ; -- överge..vb.1
  övergivande_1_N = mkN "övergivande" ; -- övergivande..nn.1
  övergiven_1_A = mkA "övergiven" ; -- övergiven..av.1
  övergivenhet_1_N = mkN "övergivenhet" ; -- övergivenhet..nn.1
  överglänsa_1_V = mkV "överglänser" ; -- överglänsa..vb.1
  överglänsande_1_N = mkN "överglänsande" ; -- överglänsande..nn.1
  övergrepp_1_N = mkN "övergrepp" neutrum  ; -- övergrepp..nn.1
  övergreppsmisstänkt_1_A = mkA "övergreppsmisstänkt" "övergreppsmisstänkt" ; -- övergreppsmisstänkt..av.1
  övergripande_1_A = mkA "övergripande" ; -- övergripande..av.1
  övergullig_1_A = mkA "övergullig" ; -- övergullig..av.1
  övergå_1_V = mkV "övergå" "övergick" "övergått" ; -- övergå..vb.1
  övergående_1_A = mkA "övergående" ; -- övergående..av.1
  övergående_1_N = mkN "övergående" ; -- övergående..nn.1
  övergång_1_N = mkN "övergång" ; -- övergång..nn.1
  övergångsform_1_N = mkN "övergångsform" "övergångsformer" ; -- övergångsform..nn.1
  övergångsmetall_1_N = mkN "övergångsmetall" "övergångsmetaller" ; -- övergångsmetall..nn.1
  övergångsmiljö_1_N = mkN "övergångsmiljö" "övergångsmiljön" "övergångsmiljöer" "övergångsmiljöerna" ; -- övergångsmiljö..nn.1
  övergångsperiod_1_N = mkN "övergångsperiod" "övergångsperioder" ; -- övergångsperiod..nn.1
  övergångsproblem_1_N = mkN "övergångsproblem" neutrum  ; -- övergångsproblem..nn.1
  övergångsregering_1_N = mkN "övergångsregering" ; -- övergångsregering..nn.1
  övergångsskede_1_N = mkN "övergångsskede" ; -- övergångsskede..nn.1
  övergångsstadium_1_N = mkN "övergångsstadium" "övergångsstadiet" "övergångsstadier" "övergångsstadierna" ; -- övergångsstadium..nn.1
  övergångsstat_1_N = mkN "övergångsstat" ; -- övergångsstat..nn.1
  övergångsstil_1_N = mkN "övergångsstil" ; -- övergångsstil..nn.1
  övergångsställe_1_N = mkN "övergångsställe" ; -- övergångsställe..nn.1
  övergångsteknologi_1_N = mkN "övergångsteknologi" "övergångsteknologier" ; -- övergångsteknologi..nn.1
  övergångstid_1_N = mkN "övergångstid" "övergångstider" ; -- övergångstid..nn.1
  övergångstillstånd_1_N = mkN "övergångstillstånd" neutrum  ; -- övergångstillstånd..nn.1
  övergångsverb_1_N = mkN "övergångsverb" neutrum  ; -- övergångsverb..nn.1
  övergångsvis_1_Adv = mkAdv "övergångsvis" ; -- övergångsvis..ab.1
  övergångsvis_1_A = mkA "övergångsvis" ; -- övergångsvis..av.1
  övergångsålder_1_N = mkN "övergångsålder" ; -- övergångsålder..nn.1
  övergöda_1_V = mkV "övergöda" "övergödde" "övergött" ; -- övergöda..vb.1
  övergödande_1_N = mkN "övergödande" ; -- övergödande..nn.1
  övergödning_1_N = mkN "övergödning" ; -- övergödning..nn.1
  överhalning_1_N = mkN "överhalning" ; -- överhalning..nn.1
  överhand_1_N = mkN "överhand" ; -- överhand..nn.1
  överhandsfräs_1_N = mkN "överhandsfräs" ; -- överhandsfräs..nn.1
  överhandsknop_1_N = mkN "överhandsknop" ; -- överhandsknop..nn.1
  överhet_1_N = mkN "överhet" "överheter" ; -- överhet..nn.1
  överhetlig_1_A = mkA "överhetlig" ; -- överhetlig..av.1
  överhetlighet_1_N = mkN "överhetlighet" ; -- överhetlighet..nn.1
  överhetsfjäsk_1_N = mkN "överhetsfjäsk" neutrum  ; -- överhetsfjäsk..nn.1
  överhetsperson_1_N = mkN "överhetsperson" "överhetspersoner" ; -- överhetsperson..nn.1
  överhetta_1_V = mkV "överhettar" ; -- överhetta..vb.1
  överhettande_1_N = mkN "överhettande" ; -- överhettande..nn.1
  överhettning_1_N = mkN "överhettning" ; -- överhettning..nn.1
  överhettningsskydd_1_N = mkN "överhettningsskydd" neutrum  ; -- överhettningsskydd..nn.1
  överhopa_1_V = mkV "överhopar" ; -- överhopa..vb.1
  överhopad_1_A = mkA "överhopad" ; -- överhopad..av.1
  överhopande_1_N = mkN "överhopande" ; -- överhopande..nn.1
  överhopning_1_N = mkN "överhopning" ; -- överhopning..nn.1
  överhoppa_1_V = mkV "överhoppar" ; -- överhoppa..vb.1
  överhoppande_1_N = mkN "överhoppande" ; -- överhoppande..nn.1
  överhoppning_1_N = mkN "överhoppning" ; -- överhoppning..nn.1
  överhud_1_N = mkN "överhud" ; -- överhud..nn.1
  överhus_1_N = mkN "överhus" neutrum  ; -- överhus..nn.1
  överhuvud_1_Adv = mkAdv "överhuvud" ; -- överhuvud..ab.1
  överhuvud_1_N = mkN "överhuvud" "överhuvudet" "överhuvud" "överhuvudena" ; -- överhuvud..nn.1
  överhuvudtaget_1_Adv = mkAdv "överhuvudtaget" ; -- överhuvudtaget..ab.1
  överhäng_1_N = mkN "överhäng" neutrum  ; -- överhäng..nn.1
  överhängande_1_A = mkA "överhängande" ; -- överhängande..av.1
  överhärdig_1_A = mkA "överhärdig" ; -- överhärdig..av.1
  överhärdighet_1_N = mkN "överhärdighet" ; -- överhärdighet..nn.1
  överhöghet_1_N = mkN "överhöghet" "överhögheter" ; -- överhöghet..nn.1
  överhölja_1_V = mkV "överhölja" "överhöljde" "överhöljt" ; -- överhölja..vb.1
  överhöljande_1_N = mkN "överhöljande" ; -- överhöljande..nn.1
  överhöljning_1_N = mkN "överhöljning" ; -- överhöljning..nn.1
  överhövan_1_Adv = mkAdv "överhövan" ; -- överhövan..ab.1
  överilad_1_A = mkA "överilad" ; -- överilad..av.1
  överilning_1_N = mkN "överilning" ; -- överilning..nn.1
  överingenjör_1_N = mkN "överingenjör" "överingenjörer" ; -- överingenjör..nn.1
  överinlärning_1_N = mkN "överinlärning" ; -- överinlärning..nn.1
  överinseende_1_N = mkN "överinseende" ; -- överinseende..nn.1
  överinstans_1_N = mkN "överinstans" "överinstanser" ; -- överinstans..nn.1
  överintecknad_1_A = mkA "överintecknad" ; -- överintecknad..av.1
  överintendent_1_N = mkN "överintendent" "överintendenter" ; -- överintendent..nn.1
  överjag_1_N = mkN "överjag" neutrum  ; -- överjag..nn.1
  överjordisk_1_A = mkA "överjordisk" ; -- överjordisk..av.1
  överjordiskhet_1_N = mkN "överjordiskhet" ; -- överjordiskhet..nn.1
  överjäsning_1_N = mkN "överjäsning" ; -- överjäsning..nn.1
  överkamning_1_N = mkN "överkamning" ; -- överkamning..nn.1
  överkapacitet_1_N = mkN "överkapacitet" ; -- överkapacitet..nn.1
  överkast_1_N = mkN "överkast" neutrum  ; -- överkast..nn.1
  överklaga_1_V = mkV "överklagar" ; -- överklaga..vb.1
  överklagande_1_N = mkN "överklagande" ; -- överklagande..nn.1
  överklagandeprocess_1_N = mkN "överklagandeprocess" "överklagandeprocesser" ; -- överklagandeprocess..nn.1
  överklass_1_N = mkN "överklass" "överklasser" ; -- överklass..nn.1
  överklassaccent_1_N = mkN "överklassaccent" "överklassaccenter" ; -- överklassaccent..nn.1
  överklassare_1_N = mkN "överklassare" utrum  ; -- överklassare..nn.1
  överklassfestprisse_1_N = mkN "överklassfestprisse" utrum  ; -- överklassfestprisse..nn.1
  överklassflicka_1_N = mkN "överklassflicka" ; -- överklassflicka..nn.1
  överklassig_1_A = mkA "överklassig" ; -- överklassig..av.1
  överklassighet_1_N = mkN "överklassighet" ; -- överklassighet..nn.1
  överklassmiljö_1_N = mkN "överklassmiljö" "överklassmiljön" "överklassmiljöer" "överklassmiljöerna" ; -- överklassmiljö..nn.1
  överklassmänniska_1_N = mkN "överklassmänniska" ; -- överklassmänniska..nn.1
  överklassprägel_1_N = mkN "överklassprägel" ; -- överklassprägel..nn.1
  överklasstant_1_N = mkN "överklasstant" "överklasstanter" ; -- överklasstant..nn.1
  överklivning_1_N = mkN "överklivning" ; -- överklivning..nn.1
  överkoka_1_V = mkV "överkoker" ; -- överkoka..vb.1
  överkomlig_1_A = mkA "överkomlig" ; -- överkomlig..av.1
  överkomlighet_1_N = mkN "överkomlighet" ; -- överkomlighet..nn.1
  överkommando_1_N = mkN "överkommando" "överkommandot" "överkommandon" "överkommandona" ; -- överkommando..nn.1
  överkompensera_1_V = mkV "överkompenserar" ; -- överkompensera..vb.1
  överkompenserande_1_N = mkN "överkompenserande" ; -- överkompenserande..nn.1
  överkompenserbar_1_A = mkA "överkompenserbar" ; -- överkompenserbar..av.1
  överkompenserbarhet_1_N = mkN "överkompenserbarhet" ; -- överkompenserbarhet..nn.1
  överkompensering_1_N = mkN "överkompensering" ; -- överkompensering..nn.1
  överkonsumtion_1_N = mkN "överkonsumtion" ; -- överkonsumtion..nn.1
  överkorsning_1_N = mkN "överkorsning" ; -- överkorsning..nn.1
  överkragning_1_N = mkN "överkragning" ; -- överkragning..nn.1
  överkropp_1_N = mkN "överkropp" ; -- överkropp..nn.1
  överkucku_1_N = mkN "överkucku" ; -- överkucku..nn.1
  överkurs_1_N = mkN "överkurs" "överkurser" ; -- överkurs..nn.1
  överkvalificerad_1_A = mkA "överkvalificerad" ; -- överkvalificerad..av.1
  överkäke_1_N = mkN "överkäke" utrum  ; -- överkäke..nn.1
  överkäksben_1_N = mkN "överkäksben" neutrum  ; -- överkäksben..nn.1
  överkänslig_1_A = mkA "överkänslig" ; -- överkänslig..av.1
  överkänslighet_1_N = mkN "överkänslighet" "överkänsligheter" ; -- överkänslighet..nn.1
  överkörd_1_A = mkA "överkörd" "överkört" ; -- överkörd..av.1
  överlackerbar_1_A = mkA "överlackerbar" ; -- överlackerbar..av.1
  överlackerbarhet_1_N = mkN "överlackerbarhet" ; -- överlackerbarhet..nn.1
  överlackeringsbar_1_A = mkA "överlackeringsbar" ; -- överlackeringsbar..av.1
  överlackeringsbarhet_1_N = mkN "överlackeringsbarhet" ; -- överlackeringsbarhet..nn.1
  överladdning_1_N = mkN "överladdning" ; -- överladdning..nn.1
  överladdningsskydd_1_N = mkN "överladdningsskydd" neutrum  ; -- överladdningsskydd..nn.1
  överlagd_1_A = mkA "överlagd" "överlagt" ; -- överlagd..av.1
  överlagdhet_1_N = mkN "överlagdhet" ; -- överlagdhet..nn.1
  överlagra_1_V = mkV "överlagrar" ; -- överlagra..vb.1
  överlagrande_1_N = mkN "överlagrande" ; -- överlagrande..nn.1
  överlakan_1_N = mkN "överlakan" neutrum  ; -- överlakan..nn.1
  överlapp_1_N = mkN "överlapp" ; -- överlapp..nn.1
  överlappa_1_V = mkV "överlappar" ; -- överlappa..vb.1
  överlappande_1_N = mkN "överlappande" ; -- överlappande..nn.1
  överlappning_1_N = mkN "överlappning" ; -- överlappning..nn.1
  överlast_1_N = mkN "överlast" "överlaster" ; -- överlast..nn.1
  överlasta_1_V = mkV "överlastar" ; -- överlasta..vb.1
  överlastad_1_A = mkA "överlastad" ; -- överlastad..av.1
  överlastning_1_N = mkN "överlastning" ; -- överlastning..nn.1
  överleva_1_N = mkN "överleva" ; -- överleva..nn.1
  överleva_1_V = mkV "överlever" ; -- överleva..vb.1
  överlevande_1_A = mkA "överlevande" ; -- överlevande..av.1
  överlevande_1_N = mkN "överlevande" ; -- överlevande..nn.1
  överlevnad_1_N = mkN "överlevnad" "överlevnader" ; -- överlevnad..nn.1
  överlevnadschans_1_N = mkN "överlevnadschans" "överlevnadschanser" ; -- överlevnadschans..nn.1
  överlevnadsdrift_1_N = mkN "överlevnadsdrift" ; -- överlevnadsdrift..nn.1
  överlevnadsfaktor_1_N = mkN "överlevnadsfaktor" "överlevnadsfaktorer" ; -- överlevnadsfaktor..nn.1
  överlevnadsficka_1_N = mkN "överlevnadsficka" ; -- överlevnadsficka..nn.1
  överlevnadsfunktion_1_N = mkN "överlevnadsfunktion" ; -- överlevnadsfunktion..nn.1
  överlevnadsförmåga_1_N = mkN "överlevnadsförmåga" ; -- överlevnadsförmåga..nn.1
  överlevnadsinstinkt_1_N = mkN "överlevnadsinstinkt" "överlevnadsinstinkter" ; -- överlevnadsinstinkt..nn.1
  överlevnadskurs_1_N = mkN "överlevnadskurs" "överlevnadskurser" ; -- överlevnadskurs..nn.1
  överlevnadsskäl_1_N = mkN "överlevnadsskäl" neutrum  ; -- överlevnadsskäl..nn.1
  överlevnadsvärde_1_N = mkN "överlevnadsvärde" ; -- överlevnadsvärde..nn.1
  överlevnadsångest_1_N = mkN "överlevnadsångest" ; -- överlevnadsångest..nn.1
  överliggande_1_A = mkA "överliggande" ; -- överliggande..av.1
  överliggare_1_N = mkN "överliggare" utrum  ; -- överliggare..nn.1
  överlista_1_V = mkV "överlistar" ; -- överlista..vb.1
  överlistande_1_N = mkN "överlistande" ; -- överlistande..nn.1
  överliv_1_N = mkN "överliv" neutrum  ; -- överliv..nn.1
  överljudsfart_1_N = mkN "överljudsfart" "överljudsfarter" ; -- överljudsfart..nn.1
  överljudsplan_1_N = mkN "överljudsplan" neutrum  ; -- överljudsplan..nn.1
  överloppsenergi_1_N = mkN "överloppsenergi" ; -- överloppsenergi..nn.1
  överloppsgärning_1_N = mkN "överloppsgärning" ; -- överloppsgärning..nn.1
  överlupen_1_A = mkA "överlupen" ; -- överlupen..av.1
  överlutande_1_A = mkA "överlutande" ; -- överlutande..av.1
  överlycklig_1_A = mkA "överlycklig" ; -- överlycklig..av.1
  överlycklighet_1_N = mkN "överlycklighet" ; -- överlycklighet..nn.1
  överläge_1_N = mkN "överläge" ; -- överläge..nn.1
  överlägga_1_V = mkV "överlägga" "överla" "överlagt" ; -- överlägga..vb.1
  överläggande_1_N = mkN "överläggande" ; -- överläggande..nn.1
  överläggning_1_N = mkN "överläggning" ; -- överläggning..nn.1
  överlägsen_1_A = mkA "överlägsen" ; -- överlägsen..av.1
  överlägsenhet_1_N = mkN "överlägsenhet" "överlägsenheter" ; -- överlägsenhet..nn.1
  överläkare_1_N = mkN "överläkare" utrum  ; -- överläkare..nn.1
  överlämna_1_V = mkV "överlämnar" ; -- överlämna..vb.1
  överlämnande_1_N = mkN "överlämnande" ; -- överlämnande..nn.1
  överlämnare_1_N = mkN "överlämnare" utrum  ; -- överlämnare..nn.1
  överlämning_1_N = mkN "överlämning" ; -- överlämning..nn.1
  överläpp_1_N = mkN "överläpp" ; -- överläpp..nn.1
  överlärare_1_N = mkN "överlärare" utrum  ; -- överlärare..nn.1
  överlåta_1_V = mkV "överlåta" "överlät" "överlåtit" ; -- överlåta..vb.1
  överlåtande_1_N = mkN "överlåtande" ; -- överlåtande..nn.1
  överlåtare_1_N = mkN "överlåtare" utrum  ; -- överlåtare..nn.1
  överlåtbar_1_A = mkA "överlåtbar" ; -- överlåtbar..av.1
  överlåtelse_1_N = mkN "överlåtelse" "överlåtelser" ; -- överlåtelse..nn.1
  överlöpare_1_N = mkN "överlöpare" utrum  ; -- överlöpare..nn.1
  övermaga_1_A = mkA "övermaga" ; -- övermaga..av.1
  övermakt_1_N = mkN "övermakt" ; -- övermakt..nn.1
  överman_1_N = mkN "överman" "övermannen" "övermän" "övermännen" ; -- överman..nn.1
  övermanna_1_V = mkV "övermannar" ; -- övermanna..vb.1
  övermannande_1_N = mkN "övermannande" ; -- övermannande..nn.1
  övermod_1_N = mkN "övermod" neutrum  ; -- övermod..nn.1
  övermodig_1_A = mkA "övermodig" ; -- övermodig..av.1
  övermodighet_1_N = mkN "övermodighet" ; -- övermodighet..nn.1
  övermogen_1_A = mkA "övermogen" ; -- övermogen..av.1
  övermognad_1_N = mkN "övermognad" ; -- övermognad..nn.1
  övermäktig_1_A = mkA "övermäktig" ; -- övermäktig..av.1
  övermäktighet_1_N = mkN "övermäktighet" ; -- övermäktighet..nn.1
  övermänniska_1_N = mkN "övermänniska" ; -- övermänniska..nn.1
  övermänsklig_1_A = mkA "övermänsklig" ; -- övermänsklig..av.1
  övermänsklighet_1_N = mkN "övermänsklighet" ; -- övermänsklighet..nn.1
  övermätt_1_A = mkA "övermätt" ; -- övermätt..av.1
  övermätta_1_V = mkV "övermättar" ; -- övermätta..vb.1
  övermättande_1_N = mkN "övermättande" ; -- övermättande..nn.1
  övermätthet_1_N = mkN "övermätthet" ; -- övermätthet..nn.1
  övermättnad_1_N = mkN "övermättnad" ; -- övermättnad..nn.1
  övermättning_1_N = mkN "övermättning" ; -- övermättning..nn.1
  övermålningsbar_1_A = mkA "övermålningsbar" ; -- övermålningsbar..av.1
  övermålningsbarhet_1_N = mkN "övermålningsbarhet" ; -- övermålningsbarhet..nn.1
  övermått_1_N = mkN "övermått" neutrum  ; -- övermått..nn.1
  övermåttan_1_Adv = mkAdv "övermåttan" ; -- övermåttan..ab.1
  övernationell_1_A = mkA "övernationell" ; -- övernationell..av.1
  övernatta_1_V = mkV "övernattar" ; -- övernatta..vb.1
  övernattande_1_N = mkN "övernattande" ; -- övernattande..nn.1
  övernattning_1_N = mkN "övernattning" ; -- övernattning..nn.1
  övernattningslägenhet_1_N = mkN "övernattningslägenhet" "övernattningslägenheter" ; -- övernattningslägenhet..nn.1
  övernattningsmöjlighet_1_N = mkN "övernattningsmöjlighet" "övernattningsmöjligheter" ; -- övernattningsmöjlighet..nn.1
  övernattningsrum_1_N = mkN "övernattningsrum" "övernattningsrummet" "övernattningsrum" "övernattningsrummen" ; -- övernattningsrum..nn.1
  övernattningsstuga_1_N = mkN "övernattningsstuga" ; -- övernattningsstuga..nn.1
  övernaturlig_1_A = mkA "övernaturlig" ; -- övernaturlig..av.1
  övernaturlighet_1_N = mkN "övernaturlighet" "övernaturligheter" ; -- övernaturlighet..nn.1
  övernit_1_N = mkN "övernit" ; -- övernit..nn.1
  övernitisk_1_A = mkA "övernitisk" ; -- övernitisk..av.1
  överoptimistisk_1_A = mkA "överoptimistisk" ; -- överoptimistisk..av.1
  överord_1_N = mkN "överord" neutrum  ; -- överord..nn.1
  överordna_1_V = mkV "överordnar" ; -- överordna..vb.1
  överordnad_1_A = mkA "överordnad" ; -- överordnad..av.1
  överordnande_1_N = mkN "överordnande" ; -- överordnande..nn.1
  överplagg_1_N = mkN "överplagg" neutrum  ; -- överplagg..nn.1
  överpris_1_N = mkN "överpris" neutrum  ; -- överpris..nn.1
  överproduktion_1_N = mkN "överproduktion" ; -- överproduktion..nn.1
  överpröva_1_V = mkV "överprövar" ; -- överpröva..vb.1
  överprövande_1_N = mkN "överprövande" ; -- överprövande..nn.1
  överraska_1_V = mkV "överraskar" ; -- överraska..vb.1
  överraskad_1_A = mkA "överraskad" ; -- överraskad..av.1
  överraskande_1_A = mkA "överraskande" ; -- överraskande..av.1
  överraskande_1_N = mkN "överraskande" ; -- överraskande..nn.1
  överraskning_1_N = mkN "överraskning" ; -- överraskning..nn.1
  överraskningsanfall_1_N = mkN "överraskningsanfall" neutrum  ; -- överraskningsanfall..nn.1
  överraskningsleksak_1_N = mkN "överraskningsleksak" "överraskningsleksaker" ; -- överraskningsleksak..nn.1
  överraskningsmoment_1_N = mkN "överraskningsmoment" neutrum  ; -- överraskningsmoment..nn.1
  överreagera_1_V = mkV "överreagerar" ; -- överreagera..vb.1
  överreagerande_1_N = mkN "överreagerande" ; -- överreagerande..nn.1
  överreagering_1_N = mkN "överreagering" ; -- överreagering..nn.1
  överrede_1_N = mkN "överrede" ; -- överrede..nn.1
  överreklamerad_1_A = mkA "överreklamerad" ; -- överreklamerad..av.1
  överrenovera_1_V = mkV "överrenoverar" ; -- överrenovera..vb.1
  överrepresenterad_1_A = mkA "överrepresenterad" ; -- överrepresenterad..av.1
  överresa_1_N = mkN "överresa" ; -- överresa..nn.1
  överriggad_1_A = mkA "överriggad" ; -- överriggad..av.1
  överrik_1_A = mkA "överrik" ; -- överrik..av.1
  överrock_1_N = mkN "överrock" ; -- överrock..nn.1
  överrumpla_1_V = mkV "överrumplar" ; -- överrumpla..vb.1
  överrumplande_1_N = mkN "överrumplande" ; -- överrumplande..nn.1
  överrumpling_1_N = mkN "överrumpling" ; -- överrumpling..nn.1
  överräcka_1_V = mkV "överräcker" ; -- överräcka..vb.1
  överräckande_1_N = mkN "överräckande" ; -- överräckande..nn.1
  överräckning_1_N = mkN "överräckning" ; -- överräckning..nn.1
  överrätt_1_N = mkN "överrätt" "överrätter" ; -- överrätt..nn.1
  överrösta_1_V = mkV "överröstar" ; -- överrösta..vb.1
  överröstande_1_N = mkN "överröstande" ; -- överröstande..nn.1
  överröstning_1_N = mkN "överröstning" ; -- överröstning..nn.1
  överse_1_V = mkV "överse" "översåg" "översett" ; -- överse..vb.1
  överseende_1_A = mkA "överseende" ; -- överseende..av.1
  överseende_1_N = mkN "överseende" ; -- överseende..nn.1
  översegling_1_N = mkN "översegling" ; -- översegling..nn.1
  översida_1_N = mkN "översida" ; -- översida..nn.1
  översiggiven_1_A = mkA "översiggiven" ; -- översiggiven..av.1
  översikt_1_N = mkN "översikt" "översikter" ; -- översikt..nn.1
  översiktlig_1_A = mkA "översiktlig" ; -- översiktlig..av.1
  översiktlighet_1_N = mkN "översiktlighet" ; -- översiktlighet..nn.1
  översiktsbild_1_N = mkN "översiktsbild" "översiktsbilder" ; -- översiktsbild..nn.1
  översiktsplan_1_N = mkN "översiktsplan" "översiktsplaner" ; -- översiktsplan..nn.1
  översiktsverk_1_N = mkN "översiktsverk" neutrum  ; -- översiktsverk..nn.1
  översinnlig_1_A = mkA "översinnlig" ; -- översinnlig..av.1
  översinnlighet_1_N = mkN "översinnlighet" ; -- översinnlighet..nn.1
  översittare_1_N = mkN "översittare" utrum  ; -- översittare..nn.1
  översittarfason_1_N = mkN "översittarfason" "översittarfasoner" ; -- översittarfason..nn.1
  översittarton_1_N = mkN "översittarton" "översittartonnet" "översittarton" "översittartonnen" ; -- översittarton..nn.1
  översitteri_1_N = mkN "översitteri" "översitterit" "översitterier" "översitterierna" ; -- översitteri..nn.1
  överskatta_1_V = mkV "överskattar" ; -- överskatta..vb.1
  överskattande_1_N = mkN "överskattande" ; -- överskattande..nn.1
  överskattning_1_N = mkN "överskattning" ; -- överskattning..nn.1
  överskeppningsbåt_1_N = mkN "överskeppningsbåt" ; -- överskeppningsbåt..nn.1
  överskickning_1_N = mkN "överskickning" ; -- överskickning..nn.1
  överskjutande_1_A = mkA "överskjutande" ; -- överskjutande..av.1
  överskjutning_1_N = mkN "överskjutning" ; -- överskjutning..nn.1
  överskott_1_N = mkN "överskott" neutrum  ; -- överskott..nn.1
  överskottsånga_1_N = mkN "överskottsånga" ; -- överskottsånga..nn.1
  överskrida_1_V = mkV "överskrida" "överskred" "överskridit" ; -- överskrida..vb.1
  överskridande_1_N = mkN "överskridande" ; -- överskridande..nn.1
  överskrift_1_N = mkN "överskrift" "överskrifter" ; -- överskrift..nn.1
  överskruv_1_N = mkN "överskruv" ; -- överskruv..nn.1
  överskruva_1_V = mkV "överskruvar" ; -- överskruva..vb.1
  överskruvande_1_N = mkN "överskruvande" ; -- överskruvande..nn.1
  överskugga_1_V = mkV "överskuggar" ; -- överskugga..vb.1
  överskuggande_1_N = mkN "överskuggande" ; -- överskuggande..nn.1
  överskuggning_1_N = mkN "överskuggning" ; -- överskuggning..nn.1
  överskyfflad_1_A = mkA "överskyfflad" ; -- överskyfflad..av.1
  överskygga_1_V = mkV "överskyggar" ; -- överskygga..vb.1
  överskyggande_1_N = mkN "överskyggande" ; -- överskyggande..nn.1
  överskyla_1_V = mkV "överskyler" ; -- överskyla..vb.1
  överskylande_1_N = mkN "överskylande" ; -- överskylande..nn.1
  överskylning_1_N = mkN "överskylning" ; -- överskylning..nn.1
  överskåda_1_V = mkV "överskådar" ; -- överskåda..vb.1
  överskådande_1_N = mkN "överskådande" ; -- överskådande..nn.1
  överskådlig_1_A = mkA "överskådlig" ; -- överskådlig..av.1
  överskådlighet_1_N = mkN "överskådlighet" ; -- överskådlighet..nn.1
  överskåp_1_N = mkN "överskåp" neutrum  ; -- överskåp..nn.1
  överskölja_1_V = mkV "överskölja" "översköljde" "översköljt" ; -- överskölja..vb.1
  översköljande_1_N = mkN "översköljande" ; -- översköljande..nn.1
  översköljning_1_N = mkN "översköljning" ; -- översköljning..nn.1
  översköljningssäker_1_A = mkA "översköljningssäker" ; -- översköljningssäker..av.1
  översköljningssäkerhet_1_N = mkN "översköljningssäkerhet" ; -- översköljningssäkerhet..nn.1
  översköterska_1_N = mkN "översköterska" ; -- översköterska..nn.1
  överslag_1_N = mkN "överslag" neutrum  ; -- överslag..nn.1
  överslagsberäkning_1_N = mkN "överslagsberäkning" ; -- överslagsberäkning..nn.1
  överslagsmässig_1_A = mkA "överslagsmässig" ; -- överslagsmässig..av.1
  överslätande_1_A = mkA "överslätande" ; -- överslätande..av.1
  översnöad_1_A = mkA "översnöad" ; -- översnöad..av.1
  överspel_1_N = mkN "överspel" "överspelet" "överspel" "överspelen" ; -- överspel..nn.1
  överspelad_1_A = mkA "överspelad" ; -- överspelad..av.1
  överspolning_1_N = mkN "överspolning" ; -- överspolning..nn.1
  överspridning_1_N = mkN "överspridning" ; -- överspridning..nn.1
  överspridningseffekt_1_N = mkN "överspridningseffekt" "överspridningseffekter" ; -- överspridningseffekt..nn.1
  översprutning_1_N = mkN "översprutning" ; -- översprutning..nn.1
  överspänd_1_A = mkA "överspänd" ; -- överspänd..av.1
  överspändhet_1_N = mkN "överspändhet" "överspändheter" ; -- överspändhet..nn.1
  överspänning_1_N = mkN "överspänning" ; -- överspänning..nn.1
  överst_1_Adv = mkAdv "överst" ; -- överst..ab.1
  överstatlig_1_A = mkA "överstatlig" ; -- överstatlig..av.1
  överste_1_N = mkN "överste" utrum  ; -- överste..nn.1
  överstegra_1_V = mkV "överstegrar" ; -- överstegra..vb.1
  överstegrande_1_N = mkN "överstegrande" ; -- överstegrande..nn.1
  överstelöjtnant_1_N = mkN "överstelöjtnant" "överstelöjtnanter" ; -- överstelöjtnant..nn.1
  överstepräst_1_N = mkN "överstepräst" "överstepräster" ; -- överstepräst..nn.1
  överstiga_1_V = mkV "överstiga" "översteg" "överstigit" ; -- överstiga..vb.1
  överstigande_1_N = mkN "överstigande" ; -- överstigande..nn.1
  överstiglig_1_A = mkA "överstiglig" ; -- överstiglig..av.1
  överstiglighet_1_N = mkN "överstiglighet" ; -- överstiglighet..nn.1
  överstigning_1_N = mkN "överstigning" ; -- överstigning..nn.1
  överstrykning_1_N = mkN "överstrykning" ; -- överstrykning..nn.1
  överstrykningspenna_1_N = mkN "överstrykningspenna" ; -- överstrykningspenna..nn.1
  överströdd_1_A = mkA "överströdd" ; -- överströdd..av.1
  överströmning_1_N = mkN "överströmning" ; -- överströmning..nn.1
  överströmsskydd_1_N = mkN "överströmsskydd" neutrum  ; -- överströmsskydd..nn.1
  överstycke_1_N = mkN "överstycke" ; -- överstycke..nn.1
  överstyr_1_A = mkA "överstyr" ; -- överstyr..av.1
  överstyrd_1_A = mkA "överstyrd" "överstyrt" ; -- överstyrd..av.1
  överstyrdhet_1_N = mkN "överstyrdhet" ; -- överstyrdhet..nn.1
  överstämma_1_N = mkN "överstämma" ; -- överstämma..nn.1
  överstånden_1_A = mkA "överstånden" ; -- överstånden..av.1
  överståthållare_1_N = mkN "överståthållare" utrum  ; -- överståthållare..nn.1
  överståthållarämbete_1_N = mkN "överståthållarämbete" ; -- överståthållarämbete..nn.1
  överstökad_1_A = mkA "överstökad" ; -- överstökad..av.1
  översvallande_1_A = mkA "översvallande" ; -- översvallande..av.1
  översvinnelig_1_A = mkA "översvinnelig" ; -- översvinnelig..av.1
  översvinnelighet_1_N = mkN "översvinnelighet" ; -- översvinnelighet..nn.1
  översvinnlig_1_A = mkA "översvinnlig" ; -- översvinnlig..av.1
  översvinnlighet_1_N = mkN "översvinnlighet" ; -- översvinnlighet..nn.1
  översvämma_1_V = mkV "översvämmar" ; -- översvämma..vb.1
  översvämmande_1_N = mkN "översvämmande" ; -- översvämmande..nn.1
  översvämning_1_N = mkN "översvämning" ; -- översvämning..nn.1
  översvämningsrisk_1_N = mkN "översvämningsrisk" "översvämningsrisker" ; -- översvämningsrisk..nn.1
  översyn_1_N = mkN "översyn" "översyner" ; -- översyn..nn.1
  översynt_1_A = mkA "översynt" "översynt" ; -- översynt..av.1
  översynthet_1_N = mkN "översynthet" ; -- översynthet..nn.1
  översända_1_V = mkV "översänder" ; -- översända..vb.1
  översändande_1_N = mkN "översändande" ; -- översändande..nn.1
  översändning_1_N = mkN "översändning" ; -- översändning..nn.1
  översätta_1_V = mkV "översätta" "översätter" "översätt" "översatte" "översatt" "översatt" ; -- översätta..vb.1
  översättande_1_N = mkN "översättande" ; -- översättande..nn.1
  översättare_1_N = mkN "översättare" utrum  ; -- översättare..nn.1
  översättbar_1_A = mkA "översättbar" ; -- översättbar..av.1
  översättbarhet_1_N = mkN "översättbarhet" "översättbarheter" ; -- översättbarhet..nn.1
  översättlig_1_A = mkA "översättlig" ; -- översättlig..av.1
  översättlighet_1_N = mkN "översättlighet" "översättligheter" ; -- översättlighet..nn.1
  översättning_1_N = mkN "översättning" ; -- översättning..nn.1
  översättningskvalitet_1_N = mkN "översättningskvalitet" ; -- översättningskvalitet..nn.1
  översättningslån_1_N = mkN "översättningslån" neutrum  ; -- översättningslån..nn.1
  översättningsmaskin_1_N = mkN "översättningsmaskin" "översättningsmaskiner" ; -- översättningsmaskin..nn.1
  översättningsprov_1_N = mkN "översättningsprov" neutrum  ; -- översättningsprov..nn.1
  översållad_1_A = mkA "översållad" ; -- översållad..av.1
  översåte_1_N = mkN "översåte" utrum  ; -- översåte..nn.1
  överta_1_V = mkV "övertaga" "övertog" "övertagit" ; -- överta..vb.1
  övertag_1_N = mkN "övertag" neutrum  ; -- övertag..nn.1
  övertagande_1_N = mkN "övertagande" ; -- övertagande..nn.1
  övertala_1_V = mkV "övertalar" ; -- övertala..vb.1
  övertalande_1_N = mkN "övertalande" ; -- övertalande..nn.1
  övertalig_1_A = mkA "övertalig" ; -- övertalig..av.1
  övertalighet_1_N = mkN "övertalighet" ; -- övertalighet..nn.1
  övertalning_1_N = mkN "övertalning" ; -- övertalning..nn.1
  övertalningsförmåga_1_N = mkN "övertalningsförmåga" ; -- övertalningsförmåga..nn.1
  övertalningsförsök_1_N = mkN "övertalningsförsök" neutrum  ; -- övertalningsförsök..nn.1
  överteckna_1_V = mkV "övertecknar" ; -- överteckna..vb.1
  övertecknande_1_N = mkN "övertecknande" ; -- övertecknande..nn.1
  överteckning_1_N = mkN "överteckning" ; -- överteckning..nn.1
  övertid_1_N = mkN "övertid" ; -- övertid..nn.1
  övertidsarbete_1_N = mkN "övertidsarbete" ; -- övertidsarbete..nn.1
  övertidsberg_1_N = mkN "övertidsberg" neutrum  ; -- övertidsberg..nn.1
  övertolka_1_V = mkV "övertolkar" ; -- övertolka..vb.1
  övertolkad_1_A = mkA "övertolkad" ; -- övertolkad..av.1
  övertolkande_1_N = mkN "övertolkande" ; -- övertolkande..nn.1
  övertolkning_1_N = mkN "övertolkning" ; -- övertolkning..nn.1
  överton_1_N = mkN "överton" "övertoner" ; -- överton..nn.1
  övertramp_1_N = mkN "övertramp" neutrum  ; -- övertramp..nn.1
  övertrassera_1_V = mkV "övertrasserar" ; -- övertrassera..vb.1
  övertrasserande_1_N = mkN "övertrasserande" ; -- övertrasserande..nn.1
  övertrasserbar_1_A = mkA "övertrasserbar" ; -- övertrasserbar..av.1
  övertrasserbarhet_1_N = mkN "övertrasserbarhet" ; -- övertrasserbarhet..nn.1
  övertrassering_1_N = mkN "övertrassering" ; -- övertrassering..nn.1
  övertro_1_N = mkN "övertro" ; -- övertro..nn.1
  övertrumfa_1_V = mkV "övertrumfar" ; -- övertrumfa..vb.1
  övertrumfande_1_N = mkN "övertrumfande" ; -- övertrumfande..nn.1
  övertryck_1_N = mkN "övertryck" neutrum  ; -- övertryck..nn.1
  överträda_1_V = mkV "överträda" "överträdde" "överträtt" ; -- överträda..vb.1
  överträdande_1_N = mkN "överträdande" ; -- överträdande..nn.1
  överträdare_1_N = mkN "överträdare" utrum  ; -- överträdare..nn.1
  överträdelse_1_N = mkN "överträdelse" "överträdelser" ; -- överträdelse..nn.1
  överträffa_1_V = mkV "överträffar" ; -- överträffa..vb.1
  överträffande_1_N = mkN "överträffande" ; -- överträffande..nn.1
  övertrött_1_A = mkA "övertrött" ; -- övertrött..av.1
  övertydlig_1_A = mkA "övertydlig" ; -- övertydlig..av.1
  övertydlighet_1_N = mkN "övertydlighet" "övertydligheter" ; -- övertydlighet..nn.1
  övertyga_1_V = mkV "övertygar" ; -- övertyga..vb.1
  övertygad_1_A = mkA "övertygad" ; -- övertygad..av.1
  övertygande_1_A = mkA "övertygande" ; -- övertygande..av.1
  övertygande_1_N = mkN "övertygande" ; -- övertygande..nn.1
  övertygelse_1_N = mkN "övertygelse" "övertygelser" ; -- övertygelse..nn.1
  övertäcka_1_V = mkV "övertäcker" ; -- övertäcka..vb.1
  övertäckning_1_N = mkN "övertäckning" ; -- övertäckning..nn.1
  övertänd_1_A = mkA "övertänd" ; -- övertänd..av.1
  övertänkt_1_A = mkA "övertänkt" "övertänkt" ; -- övertänkt..av.1
  övertänkthet_1_N = mkN "övertänkthet" ; -- övertänkthet..nn.1
  överutnyttja_1_V = mkV "överutnyttjar" ; -- överutnyttja..vb.1
  överutnyttjande_1_N = mkN "överutnyttjande" ; -- överutnyttjande..nn.1
  övervaka_1_V = mkV "övervakar" ; -- övervaka..vb.1
  övervakande_1_N = mkN "övervakande" ; -- övervakande..nn.1
  övervakare_1_N = mkN "övervakare" utrum  ; -- övervakare..nn.1
  övervakning_1_N = mkN "övervakning" ; -- övervakning..nn.1
  övervakningsbild_1_N = mkN "övervakningsbild" "övervakningsbilder" ; -- övervakningsbild..nn.1
  övervakningsfilm_1_N = mkN "övervakningsfilm" "övervakningsfilmer" ; -- övervakningsfilm..nn.1
  övervakningskamera_1_N = mkN "övervakningskamera" ; -- övervakningskamera..nn.1
  övervakningssamhälle_1_N = mkN "övervakningssamhälle" ; -- övervakningssamhälle..nn.1
  övervakningsutrustning_1_N = mkN "övervakningsutrustning" ; -- övervakningsutrustning..nn.1
  övervallning_1_N = mkN "övervallning" ; -- övervallning..nn.1
  övervara_1_V = mkV "övervarar" ; -- övervara..vb.1
  övervarande_1_N = mkN "övervarande" ; -- övervarande..nn.1
  övervattensfartyg_1_N = mkN "övervattensfartyg" neutrum  ; -- övervattensfartyg..nn.1
  övervattensläge_1_N = mkN "övervattensläge" ; -- övervattensläge..nn.1
  övervikt_1_N = mkN "övervikt" ; -- övervikt..nn.1
  överviktig_1_A = mkA "överviktig" ; -- överviktig..av.1
  överviktighet_1_N = mkN "överviktighet" ; -- överviktighet..nn.1
  övervinna_1_V = mkV "övervinna" "övervann" "övervunnit" ; -- övervinna..vb.1
  övervinnande_1_N = mkN "övervinnande" ; -- övervinnande..nn.1
  övervinnelig_1_A = mkA "övervinnelig" ; -- övervinnelig..av.1
  övervintra_1_V = mkV "övervintrar" ; -- övervintra..vb.1
  övervintrande_1_N = mkN "övervintrande" ; -- övervintrande..nn.1
  övervuxen_1_A = mkA "övervuxen" ; -- övervuxen..av.1
  överväga_1_V = mkV "överväger" ; -- överväga..vb.1
  överväga_2_V = mkV "överväger" ; -- överväga..vb.2
  övervägande_1_A = mkA "övervägande" ; -- övervägande..av.1
  övervägande_1_N = mkN "övervägande" ; -- övervägande..nn.1
  övervägning_1_N = mkN "övervägning" ; -- övervägning..nn.1
  övervälde_1_N = mkN "övervälde" ; -- övervälde..nn.1
  överväldiga_1_V = mkV "överväldigar" ; -- överväldiga..vb.1
  överväldigande_1_A = mkA "överväldigande" ; -- överväldigande..av.1
  överväldigande_1_N = mkN "överväldigande" ; -- överväldigande..nn.1
  övervältra_1_V = mkV "övervältrar" ; -- övervältra..vb.1
  övervältrande_1_N = mkN "övervältrande" ; -- övervältrande..nn.1
  övervärdera_1_V = mkV "övervärderar" ; -- övervärdera..vb.1
  övervärderande_1_N = mkN "övervärderande" ; -- övervärderande..nn.1
  övervärderbar_1_A = mkA "övervärderbar" ; -- övervärderbar..av.1
  övervärderbarhet_1_N = mkN "övervärderbarhet" ; -- övervärderbarhet..nn.1
  övervärdering_1_N = mkN "övervärdering" ; -- övervärdering..nn.1
  övervärme_1_N = mkN "övervärme" utrum  ; -- övervärme..nn.1
  överväxel_1_N = mkN "överväxel" ; -- överväxel..nn.1
  överväxt_1_N = mkN "överväxt" ; -- överväxt..nn.1
  övervåld_1_N = mkN "övervåld" neutrum  ; -- övervåld..nn.1
  övervåning_1_N = mkN "övervåning" ; -- övervåning..nn.1
  överända_1_Adv = mkAdv "överända" ; -- överända..ab.1
  överåklagare_1_N = mkN "överåklagare" utrum  ; -- överåklagare..nn.1
  överårig_1_A = mkA "överårig" ; -- överårig..av.1
  överårighet_1_N = mkN "överårighet" ; -- överårighet..nn.1
  överösa_1_V = mkV "överöser" ; -- överösa..vb.1
  överösande_1_N = mkN "överösande" ; -- överösande..nn.1
  överösning_1_N = mkN "överösning" ; -- överösning..nn.1
  övlig_1_A = mkA "övlig" ; -- övlig..av.1
  övlighet_1_N = mkN "övlighet" ; -- övlighet..nn.1
  övning_1_N = mkN "övning" ; -- övning..nn.1
  övningsköra_1_V = mkV "övningsköra" "övningskörde" "övningskört" ; -- övningsköra..vb.1
  övningslärare_1_N = mkN "övningslärare" utrum  ; -- övningslärare..nn.1
  övningsrymning_1_N = mkN "övningsrymning" ; -- övningsrymning..nn.1
  övningsskjuta_1_V = mkV "övningsskjuta" "övningssköt" "övningsskjutit" ; -- övningsskjuta..vb.1
  övningsskjutande_1_N = mkN "övningsskjutande" ; -- övningsskjutande..nn.1
  övningsskjutning_1_N = mkN "övningsskjutning" ; -- övningsskjutning..nn.1
  övningsskytte_1_N = mkN "övningsskytte" ; -- övningsskytte..nn.1
  övningsämne_1_N = mkN "övningsämne" ; -- övningsämne..nn.1
  övärld_1_N = mkN "övärld" ; -- övärld..nn.1
}
